diff -pruN 8.0.1-5/.clang-format 8.2.0~beta1-1~exp1/.clang-format
--- 8.0.1-5/.clang-format	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.clang-format	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,7 @@
+---
+Language:        Cpp
+BasedOnStyle:    LLVM
+SortIncludes:    false
+Standard:        Cpp11
+TabWidth:        2
+UseTab:          Never
diff -pruN 8.0.1-5/.flake8 8.2.0~beta1-1~exp1/.flake8
--- 8.0.1-5/.flake8	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.flake8	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,19 @@
+[flake8]
+max_line_length = 88
+ignore =
+    C408 # Unnecessary dict/list/tuple call - rewrite as a literal
+    E203 # whitespace before ':' - doesn't work well with black
+    E225 # missing whitespace around operator - let black worry about that
+    E262 # inline comment should start with '# '
+    E265 # block comment should start with '# '
+    E266 # too many leading '#' for block comment
+    E302 # expected 2 blank lines, found 1
+    E402 # module level import not at top of file
+    E501 # line too long - let black handle that
+    E711 # comparison to None should be
+    E712 # comparison to False/True should be
+    E741 # ambiguous variable name
+    F405 # may be undefined, or defined from star imports
+    W291 # trailing
+    W503 # line break occurred before a binary operator - let black worry about that
+    W504 # line break occurred adter a binary operator - let black worry about that
diff -pruN 8.0.1-5/.git-blame-ignore-revs 8.2.0~beta1-1~exp1/.git-blame-ignore-revs
--- 8.0.1-5/.git-blame-ignore-revs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.git-blame-ignore-revs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1 @@
+d3c6274e83eab857f122aacad925cf276e99212f
diff -pruN 8.0.1-5/.github/dependabot.yml 8.2.0~beta1-1~exp1/.github/dependabot.yml
--- 8.0.1-5/.github/dependabot.yml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/dependabot.yml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,6 @@
+version: 2
+updates:
+  - package-ecosystem: "github-actions"
+    directory: "/"
+    schedule:
+      interval: "weekly"
diff -pruN 8.0.1-5/.github/workflows/build-mapscript-php.yml 8.2.0~beta1-1~exp1/.github/workflows/build-mapscript-php.yml
--- 8.0.1-5/.github/workflows/build-mapscript-php.yml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/build-mapscript-php.yml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,50 @@
+name: Build and test PHP MapScript
+
+on:
+  push:
+    branches:
+      - 'main'
+    except:
+      - /^(cherry-pick-)?backport-\d+-to-/
+
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
+jobs:
+  build:
+    runs-on: ubuntu-20.04
+    strategy:
+      matrix:
+        php-version: [8.1, 8.2]
+    env:
+      IGNORE_COMPARISON_RESULT_ON_CI: 'true'
+
+    steps:
+      - name: Checkout code
+        uses: actions/checkout@v4
+
+      - name: Set up Python
+        uses: actions/setup-python@v5
+        with:
+          python-version: 3.8
+
+      - name: Setup PHP
+        run: |
+          # for pre-installed software see 
+          # https://github.com/actions/runner-images/blob/main/images/ubuntu/Ubuntu2004-Readme.md
+          # both swig and php are included, so removed these
+          sudo apt-get -qq remove "php*-cli" "php*-dev"
+          sudo apt-get -qq remove "swig*"
+          sudo add-apt-repository ppa:ondrej/php -y
+          sudo apt-get -qq update
+          sudo apt-get -qq install php${{ matrix.php-version }}-cli php${{ matrix.php-version }}-dev
+
+      - name: Install dependencies
+        run: ./ci/setup.sh
+
+      - name: Build
+        run: ./ci/build.sh
diff -pruN 8.0.1-5/.github/workflows/build-mapscript-python.yml 8.2.0~beta1-1~exp1/.github/workflows/build-mapscript-python.yml
--- 8.0.1-5/.github/workflows/build-mapscript-python.yml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/build-mapscript-python.yml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,39 @@
+name: Build and test Python MapScript
+
+on:
+  push:
+    branches:
+      - '*'
+    except:
+      - /^(cherry-pick-)?backport-\d+-to-/
+
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
+jobs:
+  build:
+    runs-on: ubuntu-20.04
+    strategy:
+      matrix:
+        python-version: [3.8, 3.9, "3.10", 3.11, 3.12]
+    env:
+      MAPSCRIPT_PYTHON_ONLY: 'true'
+
+    steps:
+      - name: Checkout code
+        uses: actions/checkout@v4
+
+      - name: Set up Python
+        uses: actions/setup-python@v5
+        with:
+          python-version: ${{ matrix.python-version }}
+
+      - name: Install dependencies
+        run: ./ci/setup.sh
+
+      - name: Build
+        run: ./ci/build.sh
diff -pruN 8.0.1-5/.github/workflows/build.yml 8.2.0~beta1-1~exp1/.github/workflows/build.yml
--- 8.0.1-5/.github/workflows/build.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/build.yml	2024-06-06 20:07:58.000000000 +0000
@@ -2,13 +2,46 @@ name: Build
 
 on: [push, pull_request]
 
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
 jobs:
   build:
     runs-on: ubuntu-20.04
 
+    strategy:
+      fail-fast: false
+      matrix:
+        include:
+          - name: Regular, with coverage
+            WITH_ASAN: "false"
+            WITH_COVERAGE: "true"
+
+          - name: Address_sanitizer
+            WITH_ASAN: "true"
+            WITH_COVERAGE: "false"
+
+    name: ${{ matrix.name }}
+
     steps:
       - name: Checkout repository contents
-        uses: actions/checkout@v2
+        uses: actions/checkout@v4
 
       - name: Build
-        run: docker run -e WORK_DIR="$PWD" -v $PWD:$PWD ubuntu:20.04 $PWD/.github/workflows/start.sh
+        run: |
+            docker run \
+            -e WORK_DIR="$PWD" \
+            -e WITH_ASAN="${{ matrix.WITH_ASAN }}" \
+            -e WITH_COVERAGE="${{ matrix.WITH_COVERAGE }}" \
+            -v $PWD:$PWD ubuntu:20.04 $PWD/.github/workflows/start.sh
+
+      - name: Coveralls
+        uses: coverallsapp/github-action@v2
+        if: ${{ matrix.WITH_COVERAGE == 'true' }}
+        with:
+          format: lcov
+          file: mapserver.info
diff -pruN 8.0.1-5/.github/workflows/check-crlf.yml 8.2.0~beta1-1~exp1/.github/workflows/check-crlf.yml
--- 8.0.1-5/.github/workflows/check-crlf.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/check-crlf.yml	2024-06-06 20:07:58.000000000 +0000
@@ -5,6 +5,13 @@ name: Check CRLF
 
 on: [push, pull_request]
 
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
 jobs:
   Check-CRLF:
     name: verify that only LF linefeeds are used
@@ -12,9 +19,9 @@ jobs:
 
     steps:
       - name: Checkout repository contents
-        uses: actions/checkout@v1
+        uses: actions/checkout@v4
 
       - name: Use action to check for CRLF endings
         uses: erclu/check-crlf@v1.2.0
         with: # ignore directories containing *.pdf and *.tab
-          exclude: msautotest/misc/data/ /msautotest/renderers/expected/
\ No newline at end of file
+          exclude: msautotest/misc/data/ /msautotest/renderers/expected/
diff -pruN 8.0.1-5/.github/workflows/cifuzz.yml 8.2.0~beta1-1~exp1/.github/workflows/cifuzz.yml
--- 8.0.1-5/.github/workflows/cifuzz.yml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/cifuzz.yml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,32 @@
+name: CIFuzz
+on: [pull_request]
+
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
+jobs:
+  Fuzzing:
+    runs-on: ubuntu-latest
+    steps:
+    - name: Build Fuzzers
+      id: build
+      uses: google/oss-fuzz/infra/cifuzz/actions/build_fuzzers@master
+      with:
+        oss-fuzz-project-name: 'mapserver'
+        dry-run: false
+    - name: Run Fuzzers
+      uses: google/oss-fuzz/infra/cifuzz/actions/run_fuzzers@master
+      with:
+        oss-fuzz-project-name: 'mapserver'
+        fuzz-seconds: 600
+        dry-run: false
+    - name: Upload Crash
+      uses: actions/upload-artifact@v4
+      if: failure() && steps.build.outcome == 'success'
+      with:
+        name: artifacts
+        path: ./out/artifacts
diff -pruN 8.0.1-5/.github/workflows/code_checks.yml 8.2.0~beta1-1~exp1/.github/workflows/code_checks.yml
--- 8.0.1-5/.github/workflows/code_checks.yml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/code_checks.yml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,19 @@
+name: Code Checks
+
+on: [push, pull_request]
+
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
+jobs:
+
+  linting:
+    runs-on: ubuntu-latest
+    steps:
+      - uses: actions/checkout@v4
+      - uses: actions/setup-python@v5
+      - uses: pre-commit/action@v3.0.1
diff -pruN 8.0.1-5/.github/workflows/codeql.yml 8.2.0~beta1-1~exp1/.github/workflows/codeql.yml
--- 8.0.1-5/.github/workflows/codeql.yml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/codeql.yml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,113 @@
+name: "CodeQL"
+
+on:
+  push:
+  pull_request:
+
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
+jobs:
+  analyze:
+    name: Analyze
+    # Runner size impacts CodeQL analysis time. To learn more, please see:
+    #   - https://gh.io/recommended-hardware-resources-for-running-codeql
+    #   - https://gh.io/supported-runners-and-hardware-resources
+    #   - https://gh.io/using-larger-runners
+    # Consider using larger runners for possible analysis time improvements.
+    runs-on: ${{ (matrix.language == 'swift' && 'macos-latest') || 'ubuntu-latest' }}
+    timeout-minutes: ${{ (matrix.language == 'swift' && 120) || 360 }}
+    permissions:
+      actions: read
+      contents: read
+      security-events: write
+
+    strategy:
+      fail-fast: false
+      matrix:
+        language: [ 'c-cpp' ]
+        # CodeQL supports [ 'c-cpp', 'csharp', 'go', 'java-kotlin', 'javascript-typescript', 'python', 'ruby', 'swift' ]
+        # Use only 'java-kotlin' to analyze code written in Java, Kotlin or both
+        # Use only 'javascript-typescript' to analyze code written in JavaScript, TypeScript or both
+        # Learn more about CodeQL language support at https://aka.ms/codeql-docs/language-support
+
+    steps:
+    - name: Checkout repository
+      uses: actions/checkout@v4
+
+    # Initializes the CodeQL tools for scanning.
+    - name: Initialize CodeQL
+      uses: github/codeql-action/init@v3
+      with:
+        languages: ${{ matrix.language }}
+        # If you wish to specify custom queries, you can do so here or in a config file.
+        # By default, queries listed here will override any specified in a config file.
+        # Prefix the list here with "+" to use these queries and those in the config file.
+
+        # For more details on CodeQL's query packs, refer to: https://docs.github.com/en/code-security/code-scanning/automatically-scanning-your-code-for-vulnerabilities-and-errors/configuring-code-scanning#using-queries-in-ql-packs
+        # queries: security-extended,security-and-quality
+        config: |
+          query-filters:
+            - exclude:
+                id: cpp/non-https-url
+    - name: Install dependencies
+      run: |
+          sudo apt update
+          sudo apt-get install -y ccache cmake g++
+          sudo apt-get install -y --allow-unauthenticated build-essential protobuf-c-compiler libprotobuf-c-dev bison flex libfribidi-dev \
+            librsvg2-dev colordiff libpq-dev libpng-dev libjpeg-dev libgif-dev libgeos-dev libfreetype6-dev libfcgi-dev libcurl4-gnutls-dev \
+            libcairo2-dev libgdal-dev libproj-dev libxml2-dev libexempi-dev libharfbuzz-dev
+    # cache the .ccache directory
+    # key it on the runner os, build type, deps, and arch
+    # It's especially important to include arch in the key because we
+    # may get runtime errors with -mavx2 from objects built on a
+    # different architecture.
+    - name: Restore build cache
+      if: matrix.language == 'c-cpp'
+      id: restore-cache
+      uses: actions/cache/restore@v4
+      with:
+        path: ${{ github.workspace }}/.ccache
+        key: ${{ matrix.id }}-${{ steps.get-arch.outputs.arch }}-${{ github.ref_name }}-${{ github.run_id }}
+        restore-keys: |
+          ${{ matrix.id }}-${{ steps.get-arch.outputs.arch }}-${{ github.ref_name }}
+          ${{ matrix.id }}-${{ steps.get-arch.outputs.arch }}
+    - name: Configure ccache
+      if: matrix.language == 'c-cpp'
+      run: |
+          echo CCACHE_BASEDIR=${{ github.workspace }} >> ${GITHUB_ENV}
+          echo CCACHE_DIR=${{ github.workspace }}/.ccache >> ${GITHUB_ENV}
+          echo CCACHE_MAXSIZE=250M >> ${GITHUB_ENV}
+          ccache -z
+    - name: Build
+      if: matrix.language == 'c-cpp'
+      run: |
+          mkdir build
+          cd build
+          export CC="ccache gcc"
+          export CXX="ccache g++"
+          cmake .. -DCMAKE_BUILD_TYPE=RelWithDebInfo \
+                          -DWITH_CLIENT_WMS=1 \
+                          -DWITH_CLIENT_WFS=1 -DWITH_KML=1 -DWITH_SOS=1 \
+                          -DWITH_THREAD_SAFETY=1 -DWITH_FRIBIDI=1 -DWITH_FCGI=1 -DWITH_EXEMPI=1 \
+                          -DWITH_RSVG=1 -DWITH_CURL=1 -DWITH_HARFBUZZ=1 -DWITH_MSSQL2008=ON
+          make -j$(nproc)
+    - name: Summarize ccache
+      if: matrix.language == 'c-cpp'
+      run: |
+        ccache -s
+    - name: Save build cache
+      if: matrix.language == 'c-cpp'
+      uses: actions/cache/save@v4
+      with:
+        path: ${{ github.workspace }}/.ccache
+        key: ${{ steps.restore-cache.outputs.cache-primary-key }}
+
+    - name: Perform CodeQL Analysis
+      uses: github/codeql-action/analyze@v3
+      with:
+        category: "/language:${{matrix.language}}"
diff -pruN 8.0.1-5/.github/workflows/coverity-scan.yml 8.2.0~beta1-1~exp1/.github/workflows/coverity-scan.yml
--- 8.0.1-5/.github/workflows/coverity-scan.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/coverity-scan.yml	2024-06-06 20:07:58.000000000 +0000
@@ -9,26 +9,36 @@ on:
   # Allows you to run this workflow manually from the Actions tab
   workflow_dispatch:
 
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
 # A workflow run is made up of one or more jobs that can run sequentially or in parallel
 jobs:
   build:
     runs-on: ubuntu-20.04
     if: github.repository == 'MapServer/MapServer'
     steps:
-      - uses: actions/checkout@v2
+      - uses: actions/checkout@v4
 
       - name: Install Libraries
         run: |
-          sudo add-apt-repository -y ppa:ubuntugis/ubuntugis-unstable
+          # This currently fails as of https://lists.osgeo.org/pipermail/ubuntu/2023-October/002046.html
+          # sudo add-apt-repository -y ppa:ubuntugis/ubuntugis-unstable
+          sudo apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 6B827C12C2D425E227EDCA75089EBE08314DF160
+          sudo add-apt-repository -y http://ppa.launchpad.net/ubuntugis/ubuntugis-unstable/ubuntu/
           sudo apt-get update
           sudo apt-get install --allow-unauthenticated protobuf-c-compiler libprotobuf-c-dev bison flex libfribidi-dev cmake librsvg2-dev colordiff libpq-dev libpng-dev libjpeg-dev libgif-dev libgeos-dev libfreetype6-dev libfcgi-dev libcurl4-gnutls-dev libcairo2-dev libgdal-dev libproj-dev libxml2-dev libexempi-dev lcov lftp postgis libharfbuzz-dev gdal-bin ccache curl postgresql-server-dev-12 postgresql-12-postgis-3 postgresql-12-postgis-3-scripts swig
       - name: Build MapServer
         run: |
           mkdir build
-          touch maplexer.l
-          touch mapparser.y
-          flex --nounistd -Pmsyy -i -omaplexer.c maplexer.l
-          yacc -d -omapparser.c mapparser.y
+          touch src/maplexer.l
+          touch src/mapparser.y
+          flex --nounistd -Pmsyy -i -osrc/maplexer.c src/maplexer.l
+          yacc -d -osrc/mapparser.c src/mapparser.y
           cd build
           cmake -G "Unix Makefiles" \
             -DWITH_CLIENT_WMS=1 -DWITH_CLIENT_WFS=1 -DWITH_SOS=1 \
diff -pruN 8.0.1-5/.github/workflows/cppcheck.yml 8.2.0~beta1-1~exp1/.github/workflows/cppcheck.yml
--- 8.0.1-5/.github/workflows/cppcheck.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/cppcheck.yml	2024-06-06 20:07:58.000000000 +0000
@@ -2,6 +2,13 @@ name: cppcheck
 
 on: [push, pull_request]
 
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
 jobs:
 
   cppcheck_2004:
@@ -9,7 +16,7 @@ jobs:
     if: "!contains(github.event.head_commit.message, '[ci skip]') && !contains(github.event.head_commit.message, '[skip ci]')"
     steps:
       - name: Checkout
-        uses: actions/checkout@v2
+        uses: actions/checkout@v4
 
       - name: Install Requirements
         run: |
diff -pruN 8.0.1-5/.github/workflows/irc_notify.yml 8.2.0~beta1-1~exp1/.github/workflows/irc_notify.yml
--- 8.0.1-5/.github/workflows/irc_notify.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/irc_notify.yml	2024-06-06 20:07:58.000000000 +0000
@@ -10,13 +10,20 @@ on:
     branches:
       - main
 
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
 jobs:
   irc_notify:
     runs-on: ubuntu-latest
     #if: github.repository == 'MapServer/MapServer'
     steps:
       - name: irc push
-        uses: rectalogic/notify-irc@v1
+        uses: rectalogic/notify-irc@v2
         if: github.event_name == 'push'
         with:
           channel: "#mapserver"
@@ -26,7 +33,7 @@ jobs:
             ${{ github.actor }} pushed ${{ github.event.ref }} ${{ github.event.compare }}
             ${{ join(github.event.commits.*.message) }}
       - name: irc pull request
-        uses: rectalogic/notify-irc@v1
+        uses: rectalogic/notify-irc@v2
         if: github.event_name == 'pull_request'
         with:
           channel: "#mapserver"
@@ -34,8 +41,9 @@ jobs:
           nickname: mapserver-github-notifier
           message: |
             ${{ github.actor }} opened PR ${{ github.event.pull_request.html_url }}
+            ${{ github.event.pull_request.title }}
       - name: irc tag created
-        uses: rectalogic/notify-irc@v1
+        uses: rectalogic/notify-irc@v2
         if: github.event_name == 'create' && github.event.ref_type == 'tag'
         with:
           channel: "#mapserver"
diff -pruN 8.0.1-5/.github/workflows/start.sh 8.2.0~beta1-1~exp1/.github/workflows/start.sh
--- 8.0.1-5/.github/workflows/start.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.github/workflows/start.sh	2024-06-06 20:07:58.000000000 +0000
@@ -4,8 +4,6 @@ set -e
 
 apt-get update -y
 
-export BUILD_NAME=PHP_8.1_WITH_PROJ8
-#export PYTHON_VERSION=3.6
 export PYTHON_VERSION=system
 
 LANG=en_US.UTF-8
@@ -29,20 +27,18 @@ curl -L https://github.com/pyenv/pyenv-i
 export PATH="/root/.pyenv/bin:$PATH"
 eval "$(pyenv init -)"
 eval "$(pyenv virtualenv-init -)"
+# ensure python points to python3
 ln -s /usr/bin/python3 /usr/bin/python
-#ln -s /usr/bin/pip3 /usr/bin/pip
 
 export CRYPTOGRAPHY_DONT_BUILD_RUST=1 # to avoid issue when building Cryptography python module
-pip install --upgrade pip
 
-# Install recent cmake
-wget -O - https://apt.kitware.com/keys/kitware-archive-latest.asc 2>/dev/null | gpg --dearmor - | sudo tee /etc/apt/trusted.gpg.d/kitware.gpg >/dev/null
-sudo apt-add-repository 'deb https://apt.kitware.com/ubuntu/ focal main'
+# set the global Python version
+pyenv global $PYTHON_VERSION
 
 cd "$WORK_DIR"
 
-ci/travis/before_install.sh
-ci/travis/script.sh
+ci/setup.sh
+ci/build.sh
 
 # Validate openapi document
 pip install jsonschema
diff -pruN 8.0.1-5/.pre-commit-config.yaml 8.2.0~beta1-1~exp1/.pre-commit-config.yaml
--- 8.0.1-5/.pre-commit-config.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/.pre-commit-config.yaml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,32 @@
+repos:
+    -   repo: https://github.com/psf/black
+        rev: 22.3.0
+        hooks:
+        -   id: black
+    -   repo: https://github.com/timothycrosley/isort
+        rev: 5.12.0
+        hooks:
+        -   id: isort
+            args: ["--profile", "black"]
+    -   repo: https://github.com/pycqa/flake8
+        rev: 3.9.2
+        hooks:
+        -   id: flake8
+    -   repo: https://github.com/pre-commit/mirrors-clang-format
+        rev: 'v15.0.7'
+        hooks:
+        -   id: clang-format
+            exclude_types: [c#, java, javascript, json, proto]
+            exclude: >
+              (?x)^(
+                build |
+                src/renderers/agg/ |
+                src/flatgeobuf/ |
+                src/opengl/ |
+                src/third-party/ |
+                src/maplexer.c |
+                src/mapparser.c |
+                src/mapparser.h |
+                src/dejavu-sans-condensed.h |
+                src/uthash.h
+              )
diff -pruN 8.0.1-5/CMakeLists.txt 8.2.0~beta1-1~exp1/CMakeLists.txt
--- 8.0.1-5/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0...3.23)
+cmake_minimum_required(VERSION 3.0...3.29)
 
 project (MapServer)
 
@@ -16,9 +16,9 @@ include(CheckIncludeFile)
 include(CheckCSourceCompiles)
 
 set (MapServer_VERSION_MAJOR 8)
-set (MapServer_VERSION_MINOR 0)
-set (MapServer_VERSION_REVISION 1)
-set (MapServer_VERSION_SUFFIX "")
+set (MapServer_VERSION_MINOR 2)
+set (MapServer_VERSION_REVISION 0)
+set (MapServer_VERSION_SUFFIX "-beta1")
 
 # Set C++ version
 # Make CMAKE_CXX_STANDARD available as cache option overridable by user
@@ -121,6 +121,10 @@ check_function_exists("strlcpy"  HAVE_ST
 check_function_exists("strlen"  HAVE_STRLEN)
 check_function_exists("strncasecmp"  HAVE_STRNCASECMP)
 
+IF((HAVE_STRLCAT OR HAVE_STRLCPY) AND CMAKE_SYSTEM_NAME MATCHES "Linux")
+    add_definitions(-D_DEFAULT_SOURCE)
+ENDIF()
+
 check_symbol_exists(vsnprintf stdio.h HAVE_VSNPRINTF)
 IF(NOT HAVE_VSNPRINTF)
     check_function_exists("vsnprintf"  HAVE_VSNPRINTF)
@@ -187,8 +191,13 @@ option(WITH_APACHE_MODULE "include (expe
 option(WITH_GENERIC_NINT "generic rounding" OFF)
 option(WITH_PYMAPSCRIPT_ANNOTATIONS "Add annotations to Python mapscript output" OFF)
 
-option(FUZZER "Build fuzzers using libFuzzer" OFF)
+option(FUZZER "Build fuzzers using libFuzzer (requires Clang, will disable executable - mapserv, etc. - generation)" OFF)
 mark_as_advanced(FUZZER)
+option(BUILD_FUZZER_REPRODUCER "Build fuzzer reproducer programs" ON)
+
+if(FUZZER AND BUILD_FUZZER_REPRODUCER)
+    message(FATAL_ERROR "FUZZER and BUILD_FUZZER_REPRODUCER options are mutually exclusive")
+endif()
 
 #TODO: USE_OGL? , USE_SDE, USE_CLUSTER_EXTERNAL USE_CLUSTER_PLUGIN, USE_MSSQL2008, USE_MSSQL2008_PLUGIN
 # SIGNORE_MISSING_DATA, CGI_CL_DEBUG_ARGS, EXTRA DEBUG FLAGS?,
@@ -234,8 +243,10 @@ if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
   set(CMAKE_INSTALL_LIBDIR "${_LIBDIR_DEFAULT}" CACHE PATH "object code libraries (${_LIBDIR_DEFAULT})")
 endif()
 
-SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
-SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+if(NOT DEFINED CMAKE_INSTALL_RPATH)
+  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+endif()
 SET(CMAKE_MACOSX_RPATH ON)
 
 if(LINK_STATIC_LIBMAPSERVER)
@@ -248,36 +259,36 @@ else(LINK_STATIC_LIBMAPSERVER)
 endif(LINK_STATIC_LIBMAPSERVER)
 
 set(agg_SOURCES
-renderers/agg/src/agg_arc.cpp
-renderers/agg/src/agg_vcgen_dash.cpp
-renderers/agg/src/agg_vcgen_contour.cpp
-renderers/agg/src/agg_curves.cpp
-renderers/agg/src/agg_embedded_raster_fonts.cpp
-renderers/agg/src/agg_trans_affine.cpp
-renderers/agg/src/agg_vcgen_stroke.cpp
-renderers/agg/src/agg_font_freetype.cpp
-renderers/agg/src/agg_line_aa_basics.cpp
-renderers/agg/src/clipper.cpp
+src/renderers/agg/src/agg_arc.cpp
+src/renderers/agg/src/agg_vcgen_dash.cpp
+src/renderers/agg/src/agg_vcgen_contour.cpp
+src/renderers/agg/src/agg_curves.cpp
+src/renderers/agg/src/agg_embedded_raster_fonts.cpp
+src/renderers/agg/src/agg_trans_affine.cpp
+src/renderers/agg/src/agg_vcgen_stroke.cpp
+src/renderers/agg/src/agg_font_freetype.cpp
+src/renderers/agg/src/agg_line_aa_basics.cpp
+src/renderers/agg/src/clipper.cpp
 )
-include_directories(renderers/agg/include)
+include_directories(src/renderers/agg/include)
 
 set(v8_SOURCES
-  mapscript/v8/v8_object_wrap.hpp  
-  mapscript/v8/point.cpp
-  mapscript/v8/line.cpp
-  mapscript/v8/shape.cpp  
-  mapscript/v8/v8_mapscript.cpp
-  mapv8.cpp
+  src/mapscript/v8/v8_object_wrap.hpp  
+  src/mapscript/v8/point.cpp
+  src/mapscript/v8/line.cpp
+  src/mapscript/v8/shape.cpp  
+  src/mapscript/v8/v8_mapscript.cpp
+  src/mapv8.cpp
 )
-include_directories(mapscript/v8/)
+include_directories(src/mapscript/v8/)
 
 # point to FlatGeobuf files
 set(flatgeobuf_SOURCES
-flatgeobuf/flatgeobuf_c.cpp
-flatgeobuf/geometryreader.cpp
-flatgeobuf/packedrtree.cpp
+src/flatgeobuf/flatgeobuf_c.cpp
+src/flatgeobuf/geometryreader.cpp
+src/flatgeobuf/packedrtree.cpp
 )
-include_directories(flatgeobuf/include)
+include_directories(src/flatgeobuf/include)
 
 #add_definitions(-DHASH_DEBUG=1)
 if(WIN32)
@@ -288,49 +299,55 @@ if(WIN32)
   set(REGEX_MALLOC 1)
   set(USE_GENERIC_MS_NINT 1)
   set(HAVE_STRING_H 0)
-  # Suppress warnings for regex.c
-  set_source_files_properties(${REGEX_SOURCES} PROPERTIES COMPILE_FLAGS /w)
+  if(MSVC)
+    # Suppress warnings for regex.c
+    set_source_files_properties(${REGEX_SOURCES} PROPERTIES COMPILE_FLAGS /w)
+  endif(MSVC)
+  if(MINGW)
+    # mingw provides stdlib.h
+    add_definitions(-DSTDC_HEADERS=1)
+  endif(MINGW)
 else(WIN32)
   set(REGEX_SOURCES "")
 endif(WIN32)
 
-set(mapserver_SOURCES fontcache.c 
-cgiutil.c mapgeos.c maporaclespatial.c mapsearch.c mapwms.cpp classobject.c
-mapgml.c mapoutput.c mapwmslayer.c layerobject.c mapgraticule.c mapows.c mapogcapi.cpp
-mapservutil.c mapxbase.c maphash.c mapowscommon.c mapshape.c mapxml.c mapbits.c
-maphttp.c mapparser.c mapstring.cpp mapxmp.c mapcairo.c mapimageio.c
-mappluginlayer.c mapsymbol.c mapchart.c mapimagemap.c mappool.c maptclutf.c
-mapcluster.c mapio.c mappostgis.cpp maptemplate.c mapcontext.c mapjoin.c
-mappostgresql.c mapthread.c mapcopy.c maplabel.c mapprimitive.c maptile.c
-mapcpl.c maplayer.c mapproject.c maptime.c mapcrypto.c maplegend.c hittest.c
-maptree.c mapdebug.c maplexer.c mapquantization.c mapunion.cpp
-mapdraw.c maplibxml2.c mapquery.c maputil.c strptime.c mapdrawgdal.c
-mapraster.c mapuvraster.c mapdummyrenderer.c mapobject.c maprasterquery.c
-mapwcs.cpp maperror.c mapogcfilter.cpp mapregex.c mapwcs11.cpp mapfile.c
-mapogcfiltercommon.cpp maprendering.c mapwcs20.cpp mapogcsld.c mapmetadata.c
-mapresample.c mapwfs.cpp mapgdal.cpp mapogcsos.c mapscale.c mapwfs11.cpp mapwfs20.c
-mapgeomtransform.c mapogroutput.cpp mapwfslayer.c mapagg.cpp mapkml.cpp
-mapgeomutil.cpp mapkmlrenderer.cpp fontcache.c textlayout.c maputfgrid.cpp
-mapogr.cpp mapcontour.c mapsmoothing.c mapv8.cpp ${REGEX_SOURCES} kerneldensity.c
-idw.c interpolation.c mapflatgeobuf.c mapcompositingfilter.c mapmvt.c mapiconv.c
-mapgraph.cpp mapserv-config.cpp)
+set(mapserver_SOURCES src/fontcache.c 
+src/cgiutil.c src/mapgeos.c src/maporaclespatial.c src/mapsearch.c src/mapwms.cpp src/classobject.c
+src/mapgml.c src/mapoutput.c src/mapwmslayer.c src/layerobject.c src/mapgraticule.c src/mapows.c src/mapogcapi.cpp
+src/mapservutil.c src/mapxbase.c src/maphash.c src/mapowscommon.c src/mapshape.c src/mapxml.c src/mapbits.c
+src/maphttp.c src/mapparser.c src/mapstring.cpp src/mapxmp.c src/mapcairo.c src/mapimageio.c
+src/mappluginlayer.c src/mapsymbol.c src/mapchart.c src/mapimagemap.c src/mappool.c src/maptclutf.c
+src/mapcluster.c src/mapio.c src/mappostgis.cpp src/maptemplate.c src/mapcontext.c src/mapjoin.c
+src/mappostgresql.c src/mapthread.c src/mapcopy.c src/maplabel.c src/mapprimitive.c src/maptile.c
+src/mapcpl.c src/maplayer.c src/mapproject.c src/maptime.c src/mapcrypto.c src/maplegend.c src/hittest.c
+src/maptree.c src/mapdebug.c src/maplexer.c src/mapquantization.c src/mapunion.cpp
+src/mapdraw.c src/maplibxml2.c src/mapquery.c src/maputil.c src/strptime.c src/mapdrawgdal.c
+src/mapraster.c src/mapuvraster.c src/mapdummyrenderer.c src/mapobject.c src/maprasterquery.c
+src/mapwcs.cpp src/maperror.c src/mapogcfilter.cpp src/mapregex.c src/mapwcs11.cpp src/mapfile.c
+src/mapogcfiltercommon.cpp src/maprendering.c src/mapwcs20.cpp src/mapogcsld.cpp src/mapmetadata.c
+src/mapresample.c src/mapwfs.cpp src/mapgdal.cpp src/mapogcsos.c src/mapscale.c src/mapwfs11.cpp src/mapwfs20.c
+src/mapgeomtransform.c src/mapogroutput.cpp src/mapwfslayer.c src/mapagg.cpp src/mapkml.cpp
+src/mapgeomutil.cpp src/mapkmlrenderer.cpp src/fontcache.c src/textlayout.c src/maputfgrid.cpp
+src/mapogr.cpp src/mapcontour.c src/mapsmoothing.c src/mapv8.cpp ${REGEX_SOURCES} src/kerneldensity.c
+src/idw.c src/interpolation.c src/mapflatgeobuf.c src/mapcompositingfilter.c src/mapmvt.c src/mapiconv.c
+src/mapgraph.cpp src/mapserv-config.cpp)
 
 set(mapserver_HEADERS
-cgiutil.h dejavu-sans-condensed.h dxfcolor.h fontcache.h hittest.h mapagg.h
-mapaxisorder.h mapcopy.h mapentities.h maperror.h mapfile.h mapgml.h maphash.h
-maphttp.h mapio.h mapkmlrenderer.h maplibxml2.h mapogcfilter.h mapogcsld.h
-mapoglcontext.h mapoglrenderer.h mapowscommon.h mapows.h mapparser.h mapogcapi.h
-mappostgis.h mapprimitive.h mapproject.h mapraster.h mapregex.h mapresample.h
-mapserver-api.h mapserver.h mapserv.h mapshape.h mapsymbol.h maptemplate.h
-mapthread.h maptile.h maptime.h maptree.h maputfgrid.h mapwcs.h uthash.h mapiconv.h
-mapflatgeobuf.h mapgraph.h mapserv-config.h)
+src/cgiutil.h src/dejavu-sans-condensed.h src/dxfcolor.h src/fontcache.h src/hittest.h src/mapagg.h
+src/mapaxisorder.h src/mapcopy.h src/mapentities.h src/maperror.h src/mapfile.h src/mapgml.h src/maphash.h
+src/maphttp.h src/mapio.h src/mapkmlrenderer.h src/maplibxml2.h src/mapogcfilter.h src/mapogcsld.h
+src/mapoglcontext.h src/mapoglrenderer.h src/mapowscommon.h src/mapows.h src/mapparser.h src/mapogcapi.h
+src/mappostgis.h src/mapprimitive.h src/mapproject.h src/mapraster.h src/mapregex.h src/mapresample.h
+src/mapserver-api.h src/mapserver.h src/apps/mapserv.h src/mapshape.h src/mapsymbol.h src/maptemplate.h
+src/mapthread.h src/maptile.h src/maptime.h src/maptree.h src/maputfgrid.h src/mapwcs.h src/uthash.h src/mapiconv.h
+src/mapflatgeobuf.h src/mapgraph.h src/mapserv-config.h)
 
 if(WIN32)
 	configure_file(
-	  ${CMAKE_CURRENT_SOURCE_DIR}/version.rc.in
-	  ${CMAKE_CURRENT_BINARY_DIR}/version.rc
+	  ${CMAKE_CURRENT_SOURCE_DIR}/src/version.rc.in
+	  ${CMAKE_CURRENT_BINARY_DIR}/src/version.rc
 	  @ONLY)
-	set(mapserver_SOURCES ${mapserver_SOURCES} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
+	set(mapserver_SOURCES ${mapserver_SOURCES} ${CMAKE_CURRENT_BINARY_DIR}/src/version.rc)
 endif(WIN32)
 
 if(WITH_PROTOBUFC)
@@ -344,7 +361,7 @@ if(WITH_PROTOBUFC)
     # Create custom command for protoc-c
     ADD_CUSTOM_COMMAND(
        COMMAND ${PROTOBUFC_COMPILER}
-       ARGS --c_out=${PROJECT_BINARY_DIR}/renderers/mvt --proto_path=${PROJECT_SOURCE_DIR}/renderers/mvt ${PROJECT_SOURCE_DIR}/renderers/mvt/vector_tile.proto
+       ARGS --c_out=${PROJECT_BINARY_DIR}/renderers/mvt --proto_path=${PROJECT_SOURCE_DIR}/src/renderers/mvt ${PROJECT_SOURCE_DIR}/src/renderers/mvt/vector_tile.proto
        OUTPUT ${PROJECT_BINARY_DIR}/renderers/mvt/vector_tile.pb-c.c ${PROJECT_BINARY_DIR}/renderers/mvt/vector_tile.pb-c.h
     )
 
@@ -379,29 +396,30 @@ endif(BUILD_STATIC)
 #the SOVERSION to be incremented. Similar rules hold of course for
 #non-opaque data-structures.
 
-add_executable(mapserv mapserv.c)
+if( NOT FUZZER )
+add_executable(mapserv src/apps/mapserv.c)
 target_link_libraries(mapserv ${MAPSERVER_LIBMAPSERVER})
-add_executable(map2img map2img.c)
+add_executable(map2img src/apps/map2img.c)
 target_link_libraries(map2img ${MAPSERVER_LIBMAPSERVER})
-add_executable(shptree shptree.c)
+add_executable(shptree src/apps/shptree.c)
 target_link_libraries(shptree ${MAPSERVER_LIBMAPSERVER})
-add_executable(coshp coshp.c)
+add_executable(coshp src/apps/coshp.c)
 target_link_libraries(coshp ${MAPSERVER_LIBMAPSERVER})
-add_executable(shptreevis shptreevis.c)
+add_executable(shptreevis src/apps/shptreevis.c)
 target_link_libraries(shptreevis ${MAPSERVER_LIBMAPSERVER})
-add_executable(sortshp sortshp.c)
+add_executable(sortshp src/apps/sortshp.c)
 target_link_libraries(sortshp ${MAPSERVER_LIBMAPSERVER})
-add_executable(legend legend.c)
+add_executable(legend src/apps/legend.c)
 target_link_libraries(legend ${MAPSERVER_LIBMAPSERVER})
-add_executable(scalebar scalebar.c)
+add_executable(scalebar src/apps/scalebar.c)
 target_link_libraries(scalebar ${MAPSERVER_LIBMAPSERVER})
-add_executable(msencrypt msencrypt.c)
+add_executable(msencrypt src/apps/msencrypt.c)
 target_link_libraries(msencrypt ${MAPSERVER_LIBMAPSERVER})
-add_executable(tile4ms tile4ms.c)
+add_executable(tile4ms src/apps/tile4ms.c)
 target_link_libraries(tile4ms ${MAPSERVER_LIBMAPSERVER})
-add_executable(shptreetst shptreetst.c)
+add_executable(shptreetst src/apps/shptreetst.c)
 target_link_libraries(shptreetst ${MAPSERVER_LIBMAPSERVER})
-
+endif()
 
 if (CMAKE_BUILD_TYPE STREQUAL "Debug") 
   set(USE_EXTENDED_DEBUG 1)
@@ -568,7 +586,7 @@ if(ORACLE_FOUND AND WITH_ORACLESPATIAL)
 endif(ORACLE_FOUND AND WITH_ORACLESPATIAL)
 
 if(ORACLE_FOUND AND WITH_ORACLE_PLUGIN)
-    add_library(msplugin_oracle MODULE maporaclespatial.c)
+    add_library(msplugin_oracle MODULE src/maporaclespatial.c)
     target_link_libraries(msplugin_oracle ${ORACLE_LIBRARY} ${MAPSERVER_LIBMAPSERVER})
     set_target_properties(msplugin_oracle PROPERTIES COMPILE_FLAGS -DUSE_ORACLE_PLUGIN)
 	set (USE_ORACLE_PLUGIN 1)
@@ -577,7 +595,7 @@ endif(ORACLE_FOUND AND WITH_ORACLE_PLUGI
 if(WITH_MSSQL2008)
   find_package(ODBC)
   if(ODBC_FOUND)
-	add_library(msplugin_mssql2008 MODULE mapmssql2008.c)
+	add_library(msplugin_mssql2008 MODULE src/mapmssql2008.c)
 	target_link_libraries(msplugin_mssql2008 ${ODBC_LIBRARY} ${MAPSERVER_LIBMAPSERVER})
     set_target_properties(msplugin_mssql2008 PROPERTIES COMPILE_FLAGS "-DUSE_MSSQL2008_PLUGIN -DUSE_MSSQL2008")
     list(APPEND ALL_INCLUDE_DIRS ${ODBC_INCLUDE_DIR})
@@ -591,7 +609,9 @@ if(WITH_FCGI)
   find_package(FCGI)
   if(FCGI_FOUND)
     include_directories(${FCGI_INCLUDE_DIR})
-    target_link_libraries(mapserv ${FCGI_LIBRARY})
+    if( NOT FUZZER )
+        target_link_libraries(mapserv ${FCGI_LIBRARY})
+    endif()
     list(APPEND ALL_INCLUDE_DIRS ${FCGI_INCLUDE_DIR})
     set (USE_FASTCGI 1)
   else(FCGI_FOUND)
@@ -822,7 +842,7 @@ if(WITH_EXEMPI)
 endif(WITH_EXEMPI)
 
 if(WITH_PYTHON)
-   add_subdirectory("mapscript/python")
+   add_subdirectory("src/mapscript/python")
    set(USE_PYTHON_MAPSCRIPT 1)
 endif(WITH_PYTHON)
 
@@ -843,38 +863,38 @@ if(WITH_V8)
 ENDIF(WITH_V8)
 
 if(WITH_PHPNG)
-   add_subdirectory("mapscript/phpng")
+   add_subdirectory("src/mapscript/phpng")
    set(USE_PHPNG_MAPSCRIPT 1)
 endif(WITH_PHPNG)
 
 if(WITH_APACHE_MODULE)
-   add_subdirectory("apache")
+   add_subdirectory("src/apache")
    set(USE_APACHE_MODULE 1)
 endif(WITH_APACHE_MODULE)
 
 if(WITH_PERL)
-   add_subdirectory("mapscript/perl")
+   add_subdirectory("src/mapscript/perl")
    set(USE_PERL_MAPSCRIPT 1)
 endif(WITH_PERL)
 
 if(WITH_RUBY)
-   add_subdirectory("mapscript/ruby")
+   add_subdirectory("src/mapscript/ruby")
    set(USE_RUBY_MAPSCRIPT 1)
 endif(WITH_RUBY)
 
 if(WITH_JAVA)
-   add_subdirectory("mapscript/java")
+   add_subdirectory("src/mapscript/java")
    set(USE_JAVA_MAPSCRIPT 1)
 endif(WITH_JAVA)
 
 if(WITH_CSHARP)
-   add_subdirectory("mapscript/csharp")
+   add_subdirectory("src/mapscript/csharp")
    set(USE_CSHARP_MAPSCRIPT 1)
 endif(WITH_CSHARP)
 
-if(FUZZER)
-  add_subdirectory("fuzzers")
-endif(FUZZER)
+if(FUZZER OR BUILD_FUZZER_REPRODUCER)
+add_subdirectory("fuzzers")
+endif()
 
 if(UNIX)
 ms_link_libraries( ${CMAKE_DL_LIBS} m )
@@ -889,12 +909,12 @@ if (WIN32)
 endif (WIN32)
 
 configure_file (
-  "${PROJECT_SOURCE_DIR}/mapserver-config.h.in"
+  "${PROJECT_SOURCE_DIR}/src/mapserver-config.h.in"
   "${PROJECT_BINARY_DIR}/mapserver-config.h"
   )
 
 configure_file (
-  "${PROJECT_SOURCE_DIR}/mapserver-version.h.in"
+  "${PROJECT_SOURCE_DIR}/src/mapserver-version.h.in"
   "${PROJECT_BINARY_DIR}/mapserver-version.h"
   )
 
@@ -939,7 +959,6 @@ status_optional_component("GIF" "${USE_G
 status_optional_component("MYSQL" "${USE_MYSQL}" "${MYSQL_LIBRARY}")
 status_optional_component("FRIBIDI" "${USE_FRIBIDI}" "${FRIBIDI_LIBRARY}")
 status_optional_component("HARFBUZZ" "${USE_HARFBUZZ}" "${HARFBUZZ_LIBRARY}")
-status_optional_component("GIF" "${USE_GIF}" "${GIF_LIBRARY}")
 status_optional_component("CAIRO" "${USE_CAIRO}" "${CAIRO_LIBRARY}")
 status_optional_component("SVGCAIRO" "${USE_SVG_CAIRO}" "${SVGCAIRO_LIBRARY}")
 status_optional_component("RSVG" "${USE_RSVG}" "${RSVG_LIBRARY}")
@@ -1010,10 +1029,11 @@ if(USE_MSSQL2008)
    INSTALL(TARGETS msplugin_mssql2008 DESTINATION ${INSTALL_LIB_DIR})
 endif(USE_MSSQL2008)
 
-
-INSTALL(TARGETS coshp sortshp shptree shptreevis msencrypt legend scalebar tile4ms shptreetst map2img mapserv
-        RUNTIME DESTINATION ${INSTALL_BIN_DIR} COMPONENT bin
-)
+if(NOT FUZZER)
+    INSTALL(TARGETS coshp sortshp shptree shptreevis msencrypt legend scalebar tile4ms shptreetst map2img mapserv
+            RUNTIME DESTINATION ${INSTALL_BIN_DIR} COMPONENT bin
+    )
+endif()
 
 if(BUILD_STATIC)
    INSTALL(TARGETS mapserver_static
@@ -1047,14 +1067,14 @@ if(BUILD_DYNAMIC)
 
    # ... for the build tree
    set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}" "${PROJECT_BINARY_DIR}")
-   configure_file(mapserver-config.cmake.in "${PROJECT_BINARY_DIR}/mapserver-config.cmake" @ONLY)
+   configure_file(src/mapserver-config.cmake.in "${PROJECT_BINARY_DIR}/mapserver-config.cmake" @ONLY)
 
    # ... for the install tree
    set(CONF_INCLUDE_DIRS "\${MAPSERVER_CMAKE_DIR}/${REL_INCLUDE_DIR}")
-   configure_file(mapserver-config.cmake.in "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mapserver-config.cmake" @ONLY)
+   configure_file(src/mapserver-config.cmake.in "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mapserver-config.cmake" @ONLY)
 
    # ... for both
-   configure_file(mapserver-config-version.cmake.in "${PROJECT_BINARY_DIR}/mapserver-config-version.cmake" @ONLY)
+   configure_file(src/mapserver-config-version.cmake.in "${PROJECT_BINARY_DIR}/mapserver-config-version.cmake" @ONLY)
 
    # Install the mapserver-config.cmake and mapserver-config-version.cmake
    install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mapserver-config.cmake"
@@ -1089,6 +1109,7 @@ mark_as_advanced(
   MAPSERVER_DATA_SUBDIR
   MAPSERVER_CONFIG_FILE
 )
+add_definitions(-DMAPSERVER_BUILD)
 add_definitions(-DMAPSERVER_CONFIG_FILE="${MAPSERVER_CONFIG_FILE}")
 
 install(
@@ -1107,5 +1128,14 @@ install(
 
 install(
   FILES ${PROJECT_SOURCE_DIR}/etc/mapserver-sample.conf
-  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/
+  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/
 )
+
+option(BUILD_TESTING "Build unit test" ON)
+if(BUILD_DYNAMIC AND BUILD_TESTING)
+    enable_testing()
+    add_executable(unit_test tests/unit/test.cpp)
+    target_include_directories(unit_test PRIVATE src)
+    target_link_libraries(unit_test PRIVATE mapserver)
+    add_test(NAME unit_test COMMAND unit_test)
+endif()
diff -pruN 8.0.1-5/HISTORY.md 8.2.0~beta1-1~exp1/HISTORY.md
--- 8.0.1-5/HISTORY.md	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/HISTORY.md	2024-06-06 20:07:58.000000000 +0000
@@ -13,6 +13,33 @@ https://mapserver.org/development/change
 
 The online Migration Guide can be found at https://mapserver.org/MIGRATION_GUIDE.html
 
+8.2.0-beta1 release (2024-06-06)
+--------------------------------
+
+- restructure repo to move source code into /src (#6837)
+
+- remove sym2img.c from codebase (#6593)
+
+- handle templates + includes (#6113)
+
+- handle empty query response (#6907)
+
+- remove support for GDAL < 3 (#6901)
+
+- remove support for PROJ < 6 (#6900)
+
+- OGC API Features: implement Part 2 - CRS (#6893)
+
+- allow custom projections to be requested via WMS (#6795)
+
+- allow mapfiles to be accessed via URL Keys (#6862)
+
+- allow expressions in LABEL PRIORITY (#6884)
+
+- reference SLD files in Mapfiles (#7034)
+
+see detailed changelog for other fixes
+
 8.0.1 release (2023-04-17)
 --------------------------
 
diff -pruN 8.0.1-5/LICENSE.md 8.2.0~beta1-1~exp1/LICENSE.md
--- 8.0.1-5/LICENSE.md	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/LICENSE.md	2024-06-06 20:07:58.000000000 +0000
@@ -4,7 +4,7 @@ MapServer Licensing
 MapServer General
 -----------------
 
-Copyright (c) 2008-2023 Open Source Geospatial Foundation.  
+Copyright (c) 2008-2024 Open Source Geospatial Foundation.  
 Copyright (c) 1996-2008 Regents of the University of Minnesota.
 
 Permission is hereby granted, free of charge, to any person obtaining a copy 
diff -pruN 8.0.1-5/Makefile 8.2.0~beta1-1~exp1/Makefile
--- 8.0.1-5/Makefile	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/Makefile	2024-06-06 20:07:58.000000000 +0000
@@ -1,12 +1,17 @@
 AUTOTEST_OPTS?=--strict_mode
-PHP_MAPSCRIPT?=build/mapscript/phpng/php_mapscriptng.so
-PYTHON_MAPSCRIPT_PATH=build/mapscript/python
-JAVA_MAPSCRIPT_PATH=build/mapscript/java
-CSHARP_MAPSCRIPT_PATH=build/mapscript/csharp
-PERL_MAPSCRIPT_PATH=build/mapscript/perl
+PHP_MAPSCRIPT?=build/src/mapscript/phpng/php_mapscriptng.so
+PYTHON_MAPSCRIPT_PATH=build/src/mapscript/python
+JAVA_MAPSCRIPT_PATH=build/src/mapscript/java
+CSHARP_MAPSCRIPT_PATH=build/src/mapscript/csharp
+PERL_MAPSCRIPT_PATH=build/src/mapscript/perl
 BUILDPATH=../../build
 FLEX=flex
 YACC=yacc
+CMAKEFLAGS_MAPSCRIPT_PYTHON=-DWITH_CLIENT_WMS=1 \
+			  -DWITH_CLIENT_WFS=1 -DWITH_KML=1 -DWITH_SOS=1 \
+			  -DWITH_PYTHON=1-DWITH_THREAD_SAFETY=1 -DWITH_FRIBIDI=1 -DWITH_FCGI=1 -DWITH_EXEMPI=1 \
+			  -DCMAKE_BUILD_TYPE=Release -DWITH_RSVG=1 -DWITH_CURL=1 -DWITH_HARFBUZZ=1 ${EXTRA_CMAKEFLAGS} -DLIBMAPSERVER_EXTRA_FLAGS="${LIBMAPSERVER_EXTRA_FLAGS}" -DCMAKE_INSTALL_PREFIX=/tmp/install-mapserver
+
 CMAKEFLAGS_NOCOVERAGE=-DWITH_CLIENT_WMS=1 \
 			  -DWITH_CLIENT_WFS=1 -DWITH_KML=1 -DWITH_SOS=1 -DWITH_CSHARP=1 -DWITH_PHPNG=1 -DWITH_PERL=1 \
 			  -DWITH_PYTHON=1 -DWITH_JAVA=1 -DWITH_THREAD_SAFETY=1 -DWITH_FRIBIDI=1 -DWITH_FCGI=1 -DWITH_EXEMPI=1 \
@@ -19,12 +24,16 @@ all: cmakebuild
 
 cmakebuild: lexer parser
 	if test ! -s build/Makefile; then  mkdir -p build ; cd build ; cmake .. $(CMAKEFLAGS); fi
-	cd build && $(MAKE) $(MFLAGS)
+	cd build && $(MAKE) $(MFLAGS) && ctest -V
 
 cmakebuild_nocoverage: lexer parser
 	if test ! -s build_nocoverage/Makefile; then  mkdir -p build_nocoverage ; cd build_nocoverage ; cmake .. $(CMAKEFLAGS_NOCOVERAGE); fi
 	cd build_nocoverage && $(MAKE) $(MFLAGS) && $(MAKE) $(MFLAGS) install
 
+cmakebuild_mapscript_python: lexer parser
+	if test ! -s build/Makefile; then  mkdir -p build ; cd build ; cmake .. $(CMAKEFLAGS_MAPSCRIPT_PYTHON); fi
+	cd build && $(MAKE) $(MFLAGS)
+    
 warning:
 	$(error "This Makefile is used to run the \"test\" target")
 
@@ -65,38 +74,38 @@ phpng-build:
 	cd build && cmake --build . --config Release
 
 java-testcase:
-	test -d "$(JAVA_MAPSCRIPT_PATH)" && (export JAVA_MAPSCRIPT_SO="../../$(JAVA_MAPSCRIPT_PATH)" && cd mapscript/java && ./run_test.sh)
+	test -d "$(JAVA_MAPSCRIPT_PATH)" && (export JAVA_MAPSCRIPT_SO="../../../$(JAVA_MAPSCRIPT_PATH)" && cd src/mapscript/java && ./run_test.sh)
 
 csharp-testcase:
-	test -d "$(CSHARP_MAPSCRIPT_PATH)" && (export CSHARP_MAPSCRIPT_SO="../../$(CSHARP_MAPSCRIPT_PATH)" && cd mapscript/csharp && ./run_test.sh)
+	test -d "$(CSHARP_MAPSCRIPT_PATH)" && (export CSHARP_MAPSCRIPT_SO="../../../$(CSHARP_MAPSCRIPT_PATH)" && cd src/mapscript/csharp && ./run_test.sh)
 
 perl-testcase:
 	cd "$(PERL_MAPSCRIPT_PATH)" \
 	&& export PERL5LIB=`pwd` \
 	&& prove tests \
-	&& perl examples/RFC24.pl ../../../tests/test.map \
-	&& perl examples/shp_in_shp.pl --infile1 ../../../tests/line.shp --infile1_shpid 0 --infile2 ../../../tests/polygon.shp --infile2_shpid 0 \
-	&& perl examples/dump.pl --file ../../../tests/line.shp \
-	&& perl examples/thin.pl --input ../../../tests/polygon --output examples/junk --tolerance=5
+	&& perl examples/RFC24.pl ../../../../tests/test.map \
+	&& perl examples/shp_in_shp.pl --infile1 ../../../../tests/line.shp --infile1_shpid 0 --infile2 ../../../../tests/polygon.shp --infile2_shpid 0 \
+	&& perl examples/dump.pl --file ../../../../tests/line.shp \
+	&& perl examples/thin.pl --input ../../../../tests/polygon --output examples/junk --tolerance=5
 
 
 
 test:  cmakebuild
 	@$(MAKE) $(MFLAGS)	api-testcase config-testcase wxs-testcase renderers-testcase misc-testcase gdal-testcase query-testcase sld-testcase mspython-testcase
-	@./print-test-results.sh
+	@./scripts/print-test-results.sh
 	@$(MAKE) $(MFLAGS)	php-testcase
 	@$(MAKE) $(MFLAGS)	csharp-testcase
 	@$(MAKE) $(MFLAGS)	perl-testcase
 
 asan_compatible_tests:  cmakebuild
 	@$(MAKE) $(MFLAGS)	api-testcase config-testcase wxs-testcase renderers-testcase misc-testcase gdal-testcase query-testcase sld-testcase
-	@./print-test-results.sh
+	@./scripts/print-test-results.sh
 
 lexer: maplexer.c
 parser: mapparser.c
 
-maplexer.c: maplexer.l
-	$(FLEX) --nounistd -Pmsyy -i -o$(CURDIR)/maplexer.c maplexer.l
+maplexer.c: src/maplexer.l
+	$(FLEX) --nounistd -Pmsyy -i -o$(CURDIR)/src/maplexer.c src/maplexer.l
 
-mapparser.c: mapparser.y
-	$(YACC) -d -o$(CURDIR)/mapparser.c mapparser.y
+mapparser.c: src/mapparser.y
+	$(YACC) -d -o$(CURDIR)/src/mapparser.c src/mapparser.y
diff -pruN 8.0.1-5/README.md 8.2.0~beta1-1~exp1/README.md
--- 8.0.1-5/README.md	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/README.md	2024-06-06 20:07:58.000000000 +0000
@@ -1,7 +1,7 @@
 MapServer
 =========
 
-[![Build Status](https://travis-ci.com/MapServer/MapServer.svg?branch=main)](https://travis-ci.com/MapServer/MapServer)
+[![Build Status](https://github.com/mapserver/mapserver/actions/workflows/build.yml/badge.svg)](https://github.com/mapserver/mapserver/actions?query=workflow%3A%22build%22+branch%3Amain)
 [![Appveyor Build Status](https://ci.appveyor.com/api/projects/status/vw1n07095a8bg23u?svg=true)](https://ci.appveyor.com/project/mapserver/mapserver)
 [![Coveralls Status](https://coveralls.io/repos/github/MapServer/MapServer/badge.svg?branch=main)](https://coveralls.io/github/MapServer/MapServer?branch=main)
 [![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.5842012.svg)](https://doi.org/10.5281/zenodo.5842012)
diff -pruN 8.0.1-5/Vagrantfile 8.2.0~beta1-1~exp1/Vagrantfile
--- 8.0.1-5/Vagrantfile	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/Vagrantfile	2024-06-06 20:07:58.000000000 +0000
@@ -40,6 +40,7 @@ Vagrant.configure(VAGRANTFILE_API_VERSIO
   config.vm.provision "shell", path: "scripts/vagrant/virtualbox-fix.sh"
   config.vm.provision "shell", path: "scripts/vagrant/packages.sh"
   config.vm.provision "shell", path: "scripts/vagrant/postgis.sh"
+  config.vm.provision "shell", path: "scripts/vagrant/msautotest.sh"  
   config.vm.provision "shell", path: "scripts/vagrant/mapserver.sh"
 
   config.vm.provision "shell", inline: $set_environment_variables, run: "always"
diff -pruN 8.0.1-5/apache/CMakeLists.txt 8.2.0~beta1-1~exp1/apache/CMakeLists.txt
--- 8.0.1-5/apache/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/apache/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-add_library(mod_mapserver MODULE mod_mapserver.c)
-target_link_libraries(mod_mapserver ${MAPSERVER_LIBMAPSERVER})
-set_target_properties(mod_mapserver PROPERTIES PREFIX "")
-
-IF(APPLE)
-  if(HTTPD_EXECUTABLE)
-    if(XCODE)
-       SET(CMAKE_C_LINK_FLAGS 
-          "${CMAKE_C_LINK_FLAGS} -bundle_loader ${HTTPD_EXECUTABLE}")
-    else(XCODE)
-       SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS 
-          "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -bundle_loader ${HTTPD_EXECUTABLE}")
-    endif(XCODE)
-  else(HTTPD_EXECUTABLE)
-    if(XCODE)
-       SET(CMAKE_C_LINK_FLAGS 
-          "${CMAKE_C_LINK_FLAGS} -undefined dynamic_lookup")
-    else(XCODE)
-       SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS 
-          "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -Wl,-undefined,dynamic_lookup")
-    endif(XCODE)
-  endif(HTTPD_EXECUTABLE)
-ENDIF(APPLE)
-
-find_package(APACHE)
-if(APACHE_FOUND)
-   include_directories(${APACHE_INCLUDE_DIR})
-else(APACHE_FOUND)
-   report_mandatory_not_found(APACHE)
-endif(APACHE_FOUND)
-
-find_package(APR)
-if(APR_FOUND)
-   include_directories(${APR_INCLUDE_DIR})
-   target_link_libraries(mod_mapserver ${APR_LIBRARY})
-   if(DEFINED APR_CPPFLAGS)
-     add_definitions("${APR_CPPFLAGS}")
-   endif(DEFINED APR_CPPFLAGS)
-else(APR_FOUND)
-   report_mandatory_not_found(APR)
-endif(APR_FOUND)
-
-if(APACHE_MODULE_DIR)
-  INSTALL(TARGETS mod_mapserver DESTINATION ${APACHE_MODULE_DIR})
-endif(APACHE_MODULE_DIR)
diff -pruN 8.0.1-5/apache/mod_mapserver.c 8.2.0~beta1-1~exp1/apache/mod_mapserver.c
--- 8.0.1-5/apache/mod_mapserver.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/apache/mod_mapserver.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,458 +0,0 @@
-/*
- *  mod_mapserver.c -- Apache sample wms module
- */
-
-#include "httpd.h"
-#include "http_config.h"
-#include "http_protocol.h"
-#include "http_log.h"
-#include "ap_config.h"
-#include "apr.h"
-#include "apr_strings.h"
-#include "apr_tables.h"
-#include "apr_file_info.h"
-
-#include "../mapserver.h"  /* for mapObj */
-#include "../cgiutil.h"
-#include "../mapserv.h"
-
-module AP_MODULE_DECLARE_DATA mapserver_module;
-
-typedef struct {
-  apr_pool_t *config_pool;
-  apr_time_t mtime;
-  char   *mapfile_name;
-  char   *uri;
-  mapObj *map;
-} mapserver_dir_config;
-
-/* These are the IO redirection hooks. They are mostly copied over from
- * mapio.c. Note that cbData contains Apache's request_rec!
- */
-static int
-msIO_apacheWrite (void *cbData, void *data, int byteCount)
-{
-  /* simply use the block writing function which is very similiar to fwrite */
-  return ap_rwrite (data, byteCount, (request_rec*) cbData);
-}
-
-static int
-msIO_apacheError (void *cbData, void *data, int byteCount)
-{
-  /* error reporting is done through the log file... */
-  ap_log_error (APLOG_MARK, APLOG_ERR, 0, NULL, "%s", (char*) data);
-  return strlen ((char*) data);
-}
-
-int
-msIO_installApacheRedirect (request_rec *r)
-{
-  msIOContext stdout_ctx, stderr_ctx;
-
-  stdout_ctx.label         = "apache";
-  stdout_ctx.write_channel = MS_TRUE;
-  stdout_ctx.readWriteFunc = msIO_apacheWrite;
-  stdout_ctx.cbData        = (void*) r;
-
-  stderr_ctx.label         = "apache";
-  stderr_ctx.write_channel = MS_TRUE;
-  stderr_ctx.readWriteFunc = msIO_apacheError;
-  stderr_ctx.cbData        = (void*) r;
-
-  msIO_installHandlers (NULL, &stdout_ctx, &stderr_ctx);
-
-  return MS_TRUE;
-}
-
-/* The maximum number of arguments we support. The number is taken from
- * cgiutil.h I think. It is only used for easier param decoding.
- */
-#define WMS_MAX_ARGS 100
-
-/* This is our simple query decoding function. Should be improved but for now
- * it works...
- */
-static int
-mapserver_decode_args (apr_pool_t *p, char *args,
-                       char ***ParamNames, char ***ParamValues)
-{
-  char **argv = NULL;
-  int    i;
-  int    n;
-  int    argc = 0;
-  char  *sep;
-
-  /* alloc the name/value pointer list */
-  argv = (char**) apr_pcalloc (p, (WMS_MAX_ARGS + 1) * 2 * sizeof (char*));
-  *ParamNames  = argv;
-  *ParamValues = argv + WMS_MAX_ARGS + 1;
-  /* No arguments? Then we're done */
-  if (!args) return 0;
-
-  argv [0] = args;
-
-  /* separate the arguments */
-  for (i = 1, n = 0; args [n] && (i < WMS_MAX_ARGS); n++)
-    if (args [n] == '&') {
-      argv [i++] = args + n + 1;
-      args [n  ] = '\0';
-    }
-
-  /* eleminate empty args */
-  for (n = 0, i = 0; argv [i]; i++)
-    if (*(argv [i]) != '\0')
-      argv [n++] = argv [i];
-    else
-      argv [i  ] = NULL;
-
-  /* argument count is the number of non-zero arguments! */
-  argc = n;
-
-  /* split the name/value pairs */
-  for (i = 0; argv [i]; i++) {
-    sep = strchr (argv [i], '=');
-    if (!sep) continue;
-    *sep = '\0';
-    argv [i + WMS_MAX_ARGS + 1] = (char*) apr_pstrdup (p, sep + 1);
-
-    if (ap_unescape_url (argv [i + WMS_MAX_ARGS + 1]) == HTTP_BAD_REQUEST) {
-      ap_log_error (APLOG_MARK, APLOG_ERR, 0, NULL,
-                    "%s: malformed URI, couldn't unescape parm %s",
-                    __func__, argv [i]);
-
-      argv [i + WMS_MAX_ARGS + 1] = NULL;
-    } else {
-      plustospace (argv [i + WMS_MAX_ARGS + 1]);
-    }
-  }
-  return argc;
-}
-
-static char*
-mapserver_read_post_data (request_rec *r)
-{
-  int   size;
-  long  blen, rsize, rpos = 0;
-  char *buffer = NULL;
-  char  buf [512];
-
-  if (ap_setup_client_block (r, REQUEST_CHUNKED_ERROR) != OK)
-    return NULL;
-
-  if (!ap_should_client_block (r))
-    return NULL;
-
-  buffer = (char*) apr_palloc (r->pool, r->remaining + 1);
-
-  if (!buffer)
-    return NULL;
-
-  size = r->remaining;
-  buffer [size] = '\0';
-
-  while ((blen = ap_get_client_block (r, buf, sizeof (buf))) > 0) {
-    if (rpos + blen > size) {
-      rsize = blen - rpos;
-    } else {
-      rsize = blen;
-    }
-    memcpy ((char*) buffer + rpos, buf, rsize);
-    rpos += rsize;
-  }
-
-  return buffer;
-}
-
-/*
-** Extract Map File name from params and load it.
-** Returns map object or NULL on error.
-*/
-static mapObj*
-msModuleLoadMap(mapservObj *mapserv, mapserver_dir_config *conf)
-{
-  int i;
-  /* OK, here's the magic: we take the mapObj from our stored config.
-   * We will use a copy of it created by msCopyMap since MapServer
-   * modifies the object at several places during request processing
-   */
-  mapObj *map = msNewMapObj ();
-  if(!map) return NULL;
-  msCopyMap (map, conf->map);
-
-
-  /* check for any %variable% substitutions here, also do any map_ changes, we do this here so WMS/WFS  */
-  /* services can take advantage of these "vendor specific" extensions */
-  for(i=0; i<mapserv->request->NumParams; i++) {
-    /*
-    ** a few CGI variables should be skipped altogether
-    **
-    ** qstring: there is separate per layer validation for attribute queries and the substitution checks
-    **          below conflict with that so we avoid it here
-    */
-    if(strncasecmp(mapserv->request->ParamNames[i],"qstring",7) == 0) continue;
-
-    if(strncasecmp(mapserv->request->ParamNames[i],"map_",4) == 0 || strncasecmp(mapserv->request->ParamNames[i],"map.",4) == 0) { /* check to see if there are any additions to the mapfile */
-      if(msUpdateMapFromURL(map, mapserv->request->ParamNames[i], mapserv->request->ParamValues[i]) != MS_SUCCESS) {
-        msFreeMap(map);
-        return NULL;
-      }
-      continue;
-    }
-  }
-
-  msApplySubstitutions(map, mapserv->request->ParamNames, mapserv->request->ParamValues, mapserv->request->NumParams);
-  msApplyDefaultSubstitutions(map);
-
-  /* check to see if a ogc map context is passed as argument. if there */
-  /* is one load it */
-
-  for(i=0; i<mapserv->request->NumParams; i++) {
-    if(strcasecmp(mapserv->request->ParamNames[i],"context") == 0) {
-      if(mapserv->request->ParamValues[i] && strlen(mapserv->request->ParamValues[i]) > 0) {
-        if(strncasecmp(mapserv->request->ParamValues[i],"http",4) == 0) {
-          if(msGetConfigOption(map, "CGI_CONTEXT_URL"))
-            msLoadMapContextURL(map, mapserv->request->ParamValues[i], MS_FALSE);
-        } else
-          msLoadMapContext(map, mapserv->request->ParamValues[i], MS_FALSE);
-      }
-    }
-  }
-  /*
-   * RFC-42 HTTP Cookie Forwarding
-   * Here we set the http_cookie_data metadata to handle the
-   * HTTP Cookie Forwarding. The content of this metadata is the cookie
-   * content. In the future, this metadata will probably be replaced
-   * by an object that is part of the mapObject that would contain
-   * information on the application status (such as cookie).
-   */
-  if( mapserv->request->httpcookiedata != NULL ) {
-    msInsertHashTable( &(map->web.metadata), "http_cookie_data",
-                       mapserv->request->httpcookiedata );
-  }
-
-  return map;
-}
-
-/***
- * The main request handler.
- **/
-static int
-mapserver_handler (request_rec *r)
-{
-  /* aquire the apropriate configuration for this directory */
-  mapserver_dir_config *conf;
-  conf = (mapserver_dir_config*) ap_get_module_config (r->per_dir_config,
-         &mapserver_module);
-
-  /* decline the request if there's no map configured */
-  if (!conf || !conf->map)
-    return DECLINED;
-
-  apr_finfo_t mapstat;
-  if (apr_stat (&mapstat, conf->mapfile_name, APR_FINFO_MTIME, r->pool) == APR_SUCCESS) {
-    if (apr_time_sec (mapstat.mtime) > apr_time_sec (conf->mtime)) {
-      mapObj *newmap = msLoadMap (conf->mapfile_name, NULL);
-      if (newmap) {
-        msFreeMap (conf->map);
-        conf->map   = newmap;
-        conf->mtime = mapstat.mtime;
-      } else {
-        ap_log_error (APLOG_MARK, APLOG_WARNING, 0, NULL,
-                      "unable to reload map file %s", conf->mapfile_name);
-      }
-    }
-  } else {
-    ap_log_error (APLOG_MARK, APLOG_WARNING, 0, NULL,
-                  "%s: unable to stat file %s", __func__, conf->mapfile_name);
-  }
-
-  /* make a copy of the URI so we can modify it safely */
-  char *uri          = apr_pstrdup (r->pool, r->uri);
-  int   len          = strlen (uri);
-  int   conf_uri_len = strlen (conf->uri);
-
-  /* If the URI points to a subdirectory we want to decline.
-   */
-  if (len > conf_uri_len)
-    return DECLINED;
-
-  int    argc          = 0;
-  char **ParamNames    = NULL;
-  char **ParamValues   = NULL;
-  char  *post_data     = NULL;
-  int    szMethod      = -1;
-  char  *szContentType = NULL;
-  mapservObj *mapserv = NULL;
-
-  /* Try decoding the query string */
-  if (r->method_number == M_GET) {
-    argc = mapserver_decode_args (r->pool, (char*) apr_pstrdup (r->pool, r->args),
-                                  &ParamNames, &ParamValues);
-    szMethod = MS_GET_REQUEST;
-  } else if (r->method_number == M_POST) {
-    szContentType = (char*) apr_table_get (r->headers_in, "Content-Type");
-    post_data = mapserver_read_post_data (r);
-    szMethod  = MS_POST_REQUEST;
-    if (strcmp (szContentType, "application/x-www-form-urlencoded") == 0) {
-      argc = mapserver_decode_args (r->pool, (char*) apr_pstrdup (r->pool, r->args),
-                                    &ParamNames, &ParamValues);
-    }
-  } else
-    return HTTP_METHOD_NOT_ALLOWED;
-
-  if (!argc && !post_data)
-    return HTTP_BAD_REQUEST;
-
-  /* Now we install the IO redirection.
-  */
-  if (msIO_installApacheRedirect (r) != MS_TRUE)
-    ap_log_error (APLOG_MARK, APLOG_ERR, 0, NULL,
-                  "%s: could not install apache redirect", __func__);
-
-
-  mapserv = msAllocMapServObj();
-  mapserv->request->NumParams   = argc;
-  mapserv->request->ParamNames  = ParamNames;
-  mapserv->request->ParamValues = ParamValues;
-  mapserv->request->type        = (enum MS_REQUEST_TYPE) szMethod;
-  mapserv->request->postrequest = post_data;
-  mapserv->request->contenttype = szContentType;
-
-  //mapserv->map = msModuleLoadMap(mapserv,conf);
-  mapserv->map = conf->map;
-  if(!mapserv->map) {
-    msCGIWriteError(mapserv);
-    goto end_request;
-  }
-
-  if(msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
-    msCGIWriteError(mapserv);
-    goto end_request;
-  }
-
-
-end_request:
-  if(mapserv) {
-    mapserv->request->ParamNames  = NULL;
-    mapserv->request->ParamValues = NULL;
-    mapserv->request->postrequest = NULL;
-    mapserv->request->contenttype = NULL;
-    mapserv->map = NULL;
-    msFreeMapServObj(mapserv);
-  }
-  msResetErrorList();
-
-
-  /* Check if status was set inside MapServer functions. If it was, we
-   * return it's value instead of simply OK. This is to support redirects
-   * from maptemplate.c
-   */
-  if (r->status == HTTP_MOVED_TEMPORARILY)
-    return r->status;
-
-  return OK;
-}
-
-/* This function will be called on startup to allow us to register our
- * handler. We don't do anything else yet...
- */
-static void
-mapserver_register_hooks (apr_pool_t *p)
-{
-  ap_hook_handler (mapserver_handler, NULL, NULL, APR_HOOK_MIDDLE);
-}
-
-/* That's the second part of the overall magic. This function will be called
- * when the configuration reaches the "WMS_Map" parameter. It will be passed
- * in as argument and should contain the full path and name of the map file.
- * We try to load it and store the resulting mapObj in the config of the
- * current directory. If we fail we throw a message...
- */
-static const char*
-mapserver_set_map (cmd_parms *cmd, void *config, const char *arg)
-{
-  mapserver_dir_config *conf = (mapserver_dir_config*) config;
-  /* if the mapObj already exists the WMS_Map was given more than once -
-   * may be the user forgot to comment something out...
-   */
-  if (conf->map) {
-    msWriteError (stderr);
-    return (char*) apr_psprintf (cmd->temp_pool,
-                                 "An MAP-file has already been registered for "
-                                 "this URI - not accepting '%s'.", arg );
-  }
-  /* Simply try loading the argument as map file. */
-  conf->mapfile_name = apr_pstrdup(cmd->pool, arg);
-  conf->map = msLoadMap ((char*) arg, NULL);
-
-  /* Ooops - we failed. We report it and fail. So beware: Always do a
-   * configcheck before really restarting your web server!
-   */
-
-  if (!conf->map) {
-    msWriteError (stderr);
-    return (char*) apr_psprintf (cmd->temp_pool,
-                                 "The given MAP-file '%s' could not be loaded",
-                                 arg);
-  }
-
-  apr_finfo_t status;
-  if (apr_stat (&status, conf->mapfile_name, APR_FINFO_MTIME, cmd->pool) != APR_SUCCESS) {
-    ap_log_error (APLOG_MARK, APLOG_WARNING, 0, NULL,
-                  "%s: unable to stat file %s", __func__, conf->mapfile_name);
-  }
-  conf->mtime = status.mtime;
-  return NULL;
-}
-
-/* This function creates the (default) directory configuration. Well, we have
- * no defaults to set so we simply alloc the memory...
- */
-static void*
-mapserver_create_dir_config (apr_pool_t *p, char *dir)
-{
-  mapserver_dir_config *newconf;
-  newconf = (mapserver_dir_config*) apr_pcalloc (p, sizeof (mapserver_dir_config));
-  newconf->config_pool = p;
-  newconf->uri = apr_pstrdup (p, dir);
-  newconf->map = NULL;
-  newconf->mapfile_name = NULL;
-  newconf->mtime = apr_time_from_sec (0);
-
-  if (dir) {
-    int len = strlen (dir);
-    if (len > 1 && dir [len - 1] == '/' )
-      newconf->uri [len - 1] = '\0';
-  }
-  return newconf;
-}
-
-/* This structure defines our single config option which takes exactly one
- * argument.
- */
-static const command_rec mapserver_options[] = {
-  AP_INIT_TAKE1(
-    "Mapfile",
-    mapserver_set_map,
-    NULL,
-    ACCESS_CONF,
-    "WMS_Map <Path to map file>"
-  ),
-  {NULL}
-};
-
-/* The following structure declares everything Apache needs to treat us as
- * a module. Merging would mean inheriting from the parent directory but that
- * doesn't make much sense here since we would only inherit the map file...
- */
-/* Dispatch list for API hooks */
-module AP_MODULE_DECLARE_DATA mapserver_module = {
-  STANDARD20_MODULE_STUFF,
-  mapserver_create_dir_config,  /* create per-dir    config structures */
-  NULL,     /* merge  per-dir    config structures */
-  NULL,     /* create per-server config structures */
-  NULL,     /* merge  per-server config structures */
-  mapserver_options,    /* table of config file commands       */
-  mapserver_register_hooks    /* register hooks                      */
-};
-
diff -pruN 8.0.1-5/cgiutil.c 8.2.0~beta1-1~exp1/cgiutil.c
--- 8.0.1-5/cgiutil.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/cgiutil.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,494 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  cgiRequestObj and CGI parameter parsing.
- * Author:   Steve Lime and the MapServer team.
- *
- * Notes: Portions derived from NCSA HTTPd Server's example CGI programs (util.c).
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <ctype.h>
-#include "mapserver.h"
-#include "cgiutil.h"
-
-#include "cpl_conv.h"
-
-#define LF 10
-#define CR 13
-
-int readPostBody( cgiRequestObj *request, char **data )
-{
-  size_t data_max, data_len;
-  int chunk_size;
-
-  (void)request;
-
-  msIO_needBinaryStdin();
-
-  /* -------------------------------------------------------------------- */
-  /*      If the length is provided, read in one gulp.                    */
-  /* -------------------------------------------------------------------- */
-  if( getenv("CONTENT_LENGTH") != NULL ) {
-    data_max = (size_t) atoi(getenv("CONTENT_LENGTH"));
-    /* Test for suspicious CONTENT_LENGTH (negative value or SIZE_MAX) */
-    if( data_max >= SIZE_MAX ) {
-      // msIO_setHeader("Content-Type","text/html");
-      // msIO_sendHeaders();
-      // msIO_printf("Suspicious Content-Length.\n");
-      msSetError(MS_WEBERR, "Suspicious Content-Length.", "readPostBody()");
-      return MS_FAILURE;
-    }
-    *data = (char *) malloc(data_max+1);
-    if( *data == NULL ) {
-      // msIO_setHeader("Content-Type","text/html");
-      // msIO_sendHeaders();
-      // msIO_printf("malloc() failed, Content-Length: %u unreasonably large?\n", (unsigned int)data_max );
-      msSetError(MS_WEBERR, "malloc() failed, Content-Length: %u unreasonably large?", "readPostBody()", (unsigned int)data_max);
-      return MS_FAILURE;
-    }
-
-    if( (int) msIO_fread(*data, 1, data_max, stdin) < (int) data_max ) {
-      // msIO_setHeader("Content-Type","text/html");
-      // msIO_sendHeaders();
-      // msIO_printf("POST body is short\n");
-      msSetError(MS_WEBERR, "POST body is short.", "readPostBody()");
-      return MS_FAILURE;
-    }
-
-    (*data)[data_max] = '\0';
-    return MS_SUCCESS;
-  }
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise read in chunks to the end.                            */
-  /* -------------------------------------------------------------------- */
-#define DATA_ALLOC_SIZE 10000
-
-  data_max = DATA_ALLOC_SIZE;
-  data_len = 0;
-  *data = (char *) msSmallMalloc(data_max+1);
-  (*data)[data_max] = '\0';
-
-  while( (chunk_size = msIO_fread( *data + data_len, 1, data_max-data_len, stdin )) > 0 ) {
-    data_len += chunk_size;
-
-    if( data_len == data_max ) {
-      /* Realloc buffer, making sure we check for possible size_t overflow */
-      if ( data_max > SIZE_MAX - (DATA_ALLOC_SIZE+1) ) {
-        // msIO_setHeader("Content-Type","text/html");
-        // msIO_sendHeaders();
-        // msIO_printf("Possible size_t overflow, cannot reallocate input buffer, POST body too large?\n" );
-	msSetError(MS_WEBERR, "Possible size_t overflow, cannot reallocate input buffer, POST body too large?", "readPostBody()");
-        return MS_FAILURE;
-      }
-
-      data_max = data_max + DATA_ALLOC_SIZE;
-      *data = (char *) msSmallRealloc(*data, data_max+1);
-    }
-  }
-
-  (*data)[data_len] = '\0';
-  return MS_SUCCESS;
-}
-
-static char* msGetEnv(const char *name, void* thread_context)
-{
-  (void)thread_context;
-  return getenv(name);
-}
-
-int loadParams(cgiRequestObj *request,
-               char* (*getenv2)(const char*, void* thread_context),
-               char *raw_post_data,
-               ms_uint32 raw_post_data_length,
-               void* thread_context)
-{
-  register int x,m=0;
-  char *s, *queryString = NULL, *httpCookie = NULL;
-  int debuglevel;
-  int maxParams = MS_DEFAULT_CGI_PARAMS;
-
-  if (getenv2==NULL)
-    getenv2 = &msGetEnv;
-
-  if(getenv2("REQUEST_METHOD", thread_context)==NULL) {
-    msIO_printf("This script can only be used to decode form results and \n");
-    msIO_printf("should be initiated as a CGI process via a httpd server.\n");
-    msIO_printf("For other options please try using the --help switch.\n");
-    return -1;
-  }
-
-  debuglevel = (int)msGetGlobalDebugLevel();
-
-  if(strcmp(getenv2("REQUEST_METHOD", thread_context),"POST") == 0 && CPLGetConfigOption("MS_NO_POST", NULL) == NULL) { /* we've got a post from a form */
-    char *post_data;
-    int data_len;
-    request->type = MS_POST_REQUEST;
-
-    if (request->contenttype == NULL){
-        s = getenv2("CONTENT_TYPE", thread_context);
-        if (s != NULL){
-          request->contenttype = msStrdup(s);
-        }
-        else {
-            /* we've to set default Content-Type which is
-             * application/octet-stream according to
-             * W3 RFC 2626 section 7.2.1 */
-            request->contenttype = msStrdup("application/octet-stream");
-        }
-    }
-
-    if (raw_post_data) {
-      post_data = msStrdup(raw_post_data);
-      data_len = raw_post_data_length;
-    } else {
-      if(MS_SUCCESS != readPostBody( request, &post_data ))
-        return -1;
-      data_len = strlen(post_data);
-    }
-
-    /* if the content_type is application/x-www-form-urlencoded,
-       we have to parse it like the QUERY_STRING variable */
-    if(strncmp(request->contenttype, "application/x-www-form-urlencoded", strlen("application/x-www-form-urlencoded")) == 0) {
-      while( data_len > 0 && isspace(post_data[data_len-1]) )
-        post_data[--data_len] = '\0';
-
-      while( post_data[0] ) {
-        if(m >= maxParams) {
-          maxParams *= 2;
-          request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-          request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
-        }
-        request->ParamValues[m] = makeword(post_data,'&');
-        plustospace(request->ParamValues[m]);
-        unescape_url(request->ParamValues[m]);
-        request->ParamNames[m] = makeword(request->ParamValues[m],'=');
-        m++;
-      }
-      free( post_data );
-    } else
-      request->postrequest = post_data;
-
-    /* check the QUERY_STRING even in the post request since it can contain
-       information. Eg a wfs request with  */
-    s = getenv2("QUERY_STRING", thread_context);
-    if(s) {
-      if (debuglevel >= MS_DEBUGLEVEL_DEBUG)
-        msDebug("loadParams() QUERY_STRING: %s\n", s);
-
-      queryString = msStrdup(s);
-      for(x=0; queryString[0] != '\0'; x++) {
-        if(m >= maxParams) {
-          maxParams *= 2;
-          request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-          request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
-        }
-        request->ParamValues[m] = makeword(queryString,'&');
-        plustospace(request->ParamValues[m]);
-        unescape_url(request->ParamValues[m]);
-        request->ParamNames[m] = makeword(request->ParamValues[m],'=');
-        m++;
-      }
-    }
-  } else {
-    if(strcmp(getenv2("REQUEST_METHOD", thread_context),"GET") == 0) { /* we've got a get request */
-      request->type = MS_GET_REQUEST;
-
-      s = getenv2("QUERY_STRING", thread_context);
-      if(s == NULL) {
-        // msIO_setHeader("Content-Type","text/html");
-        // msIO_sendHeaders();
-        // msIO_printf("No query information to decode. QUERY_STRING not set.\n");
-	msSetError(MS_WEBERR, "No query information to decode. QUERY_STRING not set.", "loadParams()");
-        return -1;
-      }
-
-      if (debuglevel >= MS_DEBUGLEVEL_DEBUG)
-        msDebug("loadParams() QUERY_STRING: %s\n", s);
-
-      if(strlen(s)==0) {
-        // msIO_setHeader("Content-Type","text/html");
-        // msIO_sendHeaders();
-        // msIO_printf("No query information to decode. QUERY_STRING is set, but empty.\n");
-	msSetError(MS_WEBERR, "No query information to decode. QUERY_STRING is set, but empty.", "loadParams()");
-        return -1;
-      }
-
-      /* don't modify the string returned by getenv2 */
-      queryString = msStrdup(s);
-      for(x=0; queryString[0] != '\0'; x++) {
-        if(m >= maxParams) {
-          maxParams *= 2;
-          request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-          request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
-        }
-        request->ParamValues[m] = makeword(queryString,'&');
-        plustospace(request->ParamValues[m]);
-        unescape_url(request->ParamValues[m]);
-        request->ParamNames[m] = makeword(request->ParamValues[m],'=');
-        m++;
-      }
-    } else {
-      // msIO_setHeader("Content-Type","text/html");
-      // msIO_sendHeaders();
-      // msIO_printf("This script should be referenced with a METHOD of GET or METHOD of POST.\n");
-      msSetError(MS_WEBERR, "This script should be referenced with a METHOD of GET or METHOD of POST.", "loadParams()");
-      return -1;
-    }
-  }
-
-  /* check for any available cookies */
-  s = getenv2("HTTP_COOKIE", thread_context);
-  if(s != NULL) {
-    httpCookie = msStrdup(s);
-    request->httpcookiedata = msStrdup(s);
-    for(x=0; httpCookie[0] != '\0'; x++) {
-      if(m >= maxParams) {
-        maxParams *= 2;
-        request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-        request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
-      }
-      request->ParamValues[m] = makeword(httpCookie,';');
-      plustospace(request->ParamValues[m]);
-      unescape_url(request->ParamValues[m]);
-      request->ParamNames[m] = makeword_skip(request->ParamValues[m],'=',' ');
-      m++;
-    }
-  }
-
-  if (queryString)
-    free(queryString);
-  if (httpCookie)
-    free(httpCookie);
-
-  return(m);
-}
-
-void getword(char *word, char *line, char stop)
-{
-  int x = 0,y;
-
-  for(x=0; ((line[x]) && (line[x] != stop)); x++)
-    word[x] = line[x];
-
-  word[x] = '\0';
-  if(line[x]) ++x;
-  y=0;
-
-  while((line[y++] = line[x++]));
-}
-
-char *makeword_skip(char *line, char stop, char skip)
-{
-  int x = 0,y,offset=0;
-  char *word = (char *) msSmallMalloc(sizeof(char) * (strlen(line) + 1));
-
-  for(x=0; ((line[x]) && (line[x] == skip)); x++);
-  offset = x;
-
-  for(x=offset; ((line[x]) && (line[x] != stop)); x++)
-    word[x-offset] = line[x];
-
-  word[x-offset] = '\0';
-  if(line[x]) ++x;
-  y=0;
-
-  while((line[y++] = line[x++]));
-  return word;
-}
-
-char *makeword(char *line, char stop)
-{
-  int x = 0,y;
-  char *word = (char *) msSmallMalloc(sizeof(char) * (strlen(line) + 1));
-
-  for(x=0; ((line[x]) && (line[x] != stop)); x++)
-    word[x] = line[x];
-
-  word[x] = '\0';
-  if(line[x]) ++x;
-  y=0;
-
-  while((line[y++] = line[x++]));
-  return word;
-}
-
-char *fmakeword(FILE *f, char stop, int *cl)
-{
-  int wsize;
-  char *word;
-  int ll;
-
-  wsize = 102400;
-  ll=0;
-  word = (char *) msSmallMalloc(sizeof(char) * (wsize + 1));
-
-  while(1) {
-    word[ll] = (char)fgetc(f);
-    if(ll==wsize) {
-      word[ll+1] = '\0';
-      wsize+=102400;
-      word = (char *)msSmallRealloc(word,sizeof(char)*(wsize+1));
-    }
-    --(*cl);
-    if((word[ll] == stop) || (feof(f)) || (!(*cl))) {
-      if(word[ll] != stop) ll++;
-      word[ll] = '\0';
-      word = (char *) msSmallRealloc(word, ll+1);
-      return word;
-    }
-    ++ll;
-  }
-}
-
-char x2c(char *what)
-{
-  register char digit;
-
-  digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
-  digit *= 16;
-  digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
-  return(digit);
-}
-
-void unescape_url(char *url)
-{
-  register int x,y;
-
-  for(x=0,y=0; url[y]; ++x,++y) {
-    if((url[x] = url[y]) == '%') {
-      url[x] = x2c(&url[y+1]);
-      y+=2;
-    }
-  }
-  url[x] = '\0';
-}
-
-void plustospace(char *str)
-{
-  register int x;
-
-  for(x=0; str[x]; x++) if(str[x] == '+') str[x] = ' ';
-}
-
-int rind(char *s, char c)
-{
-  register int x;
-  for(x=strlen(s) - 1; x != -1; x--)
-    if(s[x] == c) return x;
-  return -1;
-}
-
-void send_fd(FILE *f, FILE *fd)
-{
-  int c;
-
-  while (1) {
-    c = fgetc(f);
-    if(c == EOF)
-      return;
-    fputc((char)c,fd);
-  }
-}
-
-int ind(char *s, char c)
-{
-  register int x;
-
-  for(x=0; s[x]; x++)
-    if(s[x] == c) return x;
-
-  return -1;
-}
-
-/*
-** patched version according to CERT advisory...
-*/
-void escape_shell_cmd(char *cmd)
-{
-  register int x,y,l;
-
-  l=strlen(cmd);
-  for(x=0; cmd[x]; x++) {
-    if(ind("&;`'\"|*?~<>^()[]{}$\\\n",cmd[x]) != -1) {
-      for(y=l+1; y>x; y--)
-        cmd[y] = cmd[y-1];
-      l++; /* length has been increased */
-      cmd[x] = '\\';
-      x++; /* skip the character */
-    }
-  }
-}
-
-/*
-** Allocate a new request holder structure
-*/
-cgiRequestObj *msAllocCgiObj()
-{
-  cgiRequestObj *request = (cgiRequestObj *)malloc(sizeof(cgiRequestObj));
-
-  if(!request)
-    return NULL;
-
-  request->ParamNames = (char **) msSmallMalloc(MS_DEFAULT_CGI_PARAMS*sizeof(char*));
-  request->ParamValues = (char **) msSmallMalloc(MS_DEFAULT_CGI_PARAMS*sizeof(char*));
-  request->NumParams = 0;
-  request->type = MS_GET_REQUEST;
-  request->contenttype = NULL;
-  request->postrequest = NULL;
-  request->httpcookiedata = NULL;
-
-  request->path_info = NULL;
-  request->api_path = NULL;
-  request->api_path_length = 0;
-
-  return request;
-}
-
-void msFreeCgiObj(cgiRequestObj *request)
-{
-  msFreeCharArray(request->ParamNames, request->NumParams);
-  msFreeCharArray(request->ParamValues, request->NumParams);
-  request->ParamNames = NULL;
-  request->ParamValues = NULL;
-  request->NumParams = 0;
-  request->type = -1;
-  msFree(request->contenttype);
-  msFree(request->postrequest);
-  msFree(request->httpcookiedata);
-  request->contenttype = NULL;
-  request->postrequest = NULL;
-  request->httpcookiedata = NULL;
-
-  if(request->api_path) {
-    msFreeCharArray(request->api_path, request->api_path_length);
-    request->api_path = NULL;
-    request->api_path_length = 0;
-  }
-
-  msFree(request);
-}
diff -pruN 8.0.1-5/cgiutil.h 8.2.0~beta1-1~exp1/cgiutil.h
--- 8.0.1-5/cgiutil.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/cgiutil.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,108 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  cgiRequestObj and CGI parsing utility related declarations.
- * Author:   Steve Lime and the MapServer team.
- *
- * Notes: Portions derived from NCSA HTTPd Server's example CGI programs (util.c).
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef CGIUTIL_H
-#define CGIUTIL_H
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
-#else
-#define  MS_DLL_EXPORT
-#endif
-
-/*
-** Misc. defines
-*/
-#define MS_DEFAULT_CGI_PARAMS 100
-
-enum MS_REQUEST_TYPE {MS_GET_REQUEST, MS_POST_REQUEST};
-
-/**
-Class for programming OWS services
-*/
-typedef struct {
-#ifndef SWIG
-  char **ParamNames;
-  char **ParamValues;
-#endif
-
-#ifdef SWIG
-  %immutable;
-#endif
-  int NumParams; ///< The number of querystring parameters
-#ifdef SWIG
-  %mutable;
-#endif
-
-  enum MS_REQUEST_TYPE type; ///< A :ref:`request type constant<mapfile-constants-requesttype>`
-  char *contenttype; ///< The content type of the request
-  char *postrequest; ///< Any POST data request
-  char *httpcookiedata; ///< Any cookie data associated with the request
-
-#ifndef SWIG
-  const char *path_info;
-  int api_path_length;
-  char **api_path;
-#endif
-} cgiRequestObj;
-
-
-/*
-** Function prototypes
-*/
-#ifndef SWIG
-MS_DLL_EXPORT int loadParams(cgiRequestObj *request, char* (*getenv2)(const char*, void* thread_context),
-                             char *raw_post_data, ms_uint32 raw_post_data_length, void* thread_context);
-MS_DLL_EXPORT void getword(char *, char *, char);
-MS_DLL_EXPORT char *makeword_skip(char *, char, char);
-MS_DLL_EXPORT char *makeword(char *, char);
-MS_DLL_EXPORT char *fmakeword(FILE *, char, int *);
-MS_DLL_EXPORT char x2c(char *);
-MS_DLL_EXPORT void unescape_url(char *);
-MS_DLL_EXPORT void plustospace(char *);
-MS_DLL_EXPORT int rind(char *, char);
-MS_DLL_EXPORT void send_fd(FILE *, FILE *);
-MS_DLL_EXPORT int ind(char *, char);
-MS_DLL_EXPORT void escape_shell_cmd(char *);
-
-MS_DLL_EXPORT cgiRequestObj *msAllocCgiObj(void);
-MS_DLL_EXPORT void msFreeCgiObj(cgiRequestObj *request);
-#endif /*SWIG*/
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* CGIUTIL_H */
diff -pruN 8.0.1-5/ci/build.sh 8.2.0~beta1-1~exp1/ci/build.sh
--- 8.0.1-5/ci/build.sh	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/ci/build.sh	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,68 @@
+#!/bin/sh
+set -eu
+
+export CC="ccache gcc"
+export CXX="ccache g++"
+
+if [ "${MAPSCRIPT_PYTHON_ONLY:-}" = "true" ]; then
+    # only build MapServer with the Python MapScript
+    make cmakebuild_mapscript_python MFLAGS="-j$(nproc)" CMAKE_C_FLAGS="-O2" CMAKE_CXX_FLAGS="-O2" LIBMAPSERVER_EXTRA_FLAGS="-Wall -Werror -Wextra"
+    # build the wheel and run the Python MapScript test suite
+    make mspython-wheel
+    exit
+fi
+
+# Turn CMake warnings as errors
+EXTRA_CMAKEFLAGS="-Werror=dev"
+
+if [ "${WITH_ASAN:-}" = "true" ]; then
+    # -DNDEBUG to avoid issues with cairo cleanup
+    make cmakebuild MFLAGS="-j$(nproc)" CMAKE_C_FLAGS="-g -fsanitize=address -DNDEBUG" CMAKE_CXX_FLAGS="-g -fsanitize=address -DNDEBUG" \
+    EXTRA_CMAKEFLAGS="${EXTRA_CMAKEFLAGS} -DCMAKE_BUILD_TYPE=None -DCMAKE_EXE_LINKER_FLAGS=-fsanitize=address"
+else
+    make cmakebuild MFLAGS="-j$(nproc)" CMAKE_C_FLAGS="-O2" CMAKE_CXX_FLAGS="-O2" LIBMAPSERVER_EXTRA_FLAGS="-Wall -Werror -Wextra"
+    make mspython-wheel
+    make phpng-build
+fi
+
+# msautotests setup
+
+# setup postgresql
+sudo sed -i  's/md5/trust/' /etc/postgresql/12/main/pg_hba.conf
+sudo sed -i  's/peer/trust/' /etc/postgresql/12/main/pg_hba.conf
+sudo service postgresql restart 12
+
+cd msautotest
+./create_postgis_test_data.sh
+# copy custom projection to the PROJ_DATA folder
+sudo cp ./wxs/data/epsg2 /usr/share/proj/
+
+# lint Python msautotests
+python -m pyflakes .
+
+# run the Python server for the tests
+python -m http.server &> /dev/null &
+
+# get phpunit
+echo "PHP version"
+php -v
+cd php && curl -LO https://phar.phpunit.de/phpunit-10.phar
+echo "phpunit version"
+php phpunit-10.phar --version
+echo "PHP includes"
+php-config --includes
+
+cd ../../
+
+if [ "${WITH_ASAN:-}" = "true" ]; then
+    export AUTOTEST_OPTS="--strict_mode --run_under_asan"
+    # Only run tests that only involve mapserv/map2img binaries. mspython, etc would require LD_PREOLOAD'ing the asan shared object
+    make -j4 asan_compatible_tests
+else
+    make -j4 test
+fi
+
+if [ "${WITH_COVERAGE:-}" = "true" ]; then
+    lcov --directory . --capture --output-file mapserver.info 2>/dev/null
+    lcov --remove mapserver.info '/usr/*' --output-file mapserver.info
+fi
diff -pruN 8.0.1-5/ci/setup.sh 8.2.0~beta1-1~exp1/ci/setup.sh
--- 8.0.1-5/ci/setup.sh	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/ci/setup.sh	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,60 @@
+#!/bin/sh
+set -eu
+
+# check if postgresql and postgis are installed and remove them
+dpkg -l | grep postgresql || /bin/true
+dpkg -l | grep postgis || /bin/true
+sudo apt-get remove --purge postgresql* libpq-dev libpq5 cmake || /bin/true
+
+# This currently fails as of https://lists.osgeo.org/pipermail/ubuntu/2023-October/002046.html
+# sudo add-apt-repository -y ppa:ubuntugis/ubuntugis-unstable
+sudo apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 6B827C12C2D425E227EDCA75089EBE08314DF160
+sudo add-apt-repository -y http://ppa.launchpad.net/ubuntugis/ubuntugis-unstable/ubuntu/
+sudo apt-get update
+sudo apt-get install -y --allow-unauthenticated build-essential protobuf-c-compiler libprotobuf-c-dev bison flex libfribidi-dev \
+            librsvg2-dev colordiff libpq-dev libpng-dev libjpeg-dev libgif-dev libgeos-dev libfreetype6-dev libfcgi-dev libcurl4-gnutls-dev \
+            libcairo2-dev libgdal-dev libproj-dev libxml2-dev libexempi-dev lcov lftp postgis libharfbuzz-dev gdal-bin proj-bin ccache curl \
+            postgresql-server-dev-12 postgresql-12-postgis-3 postgresql-12-postgis-3-scripts g++ ca-certificates
+
+sudo apt-get install -y --allow-unauthenticated libmono-system-drawing4.0-cil mono-mcs
+sudo apt-get install -y --allow-unauthenticated libperl-dev
+sudo apt-get install -y --allow-unauthenticated openjdk-8-jdk
+sudo apt-get install -y --allow-unauthenticated libonig5
+
+#install recent cmake
+wget -O - https://apt.kitware.com/keys/kitware-archive-latest.asc 2>/dev/null | gpg --dearmor - | sudo tee /etc/apt/trusted.gpg.d/kitware.gpg >/dev/null
+sudo apt-add-repository 'deb https://apt.kitware.com/ubuntu/ focal main'
+sudo apt-get install -y --allow-unauthenticated cmake
+
+echo "cmake version"
+cmake --version
+
+# upgrade to recent SWIG
+git clone https://github.com/swig/swig.git swig-git-master
+cd swig-git-master
+wget https://github.com/PhilipHazel/pcre2/releases/download/pcre2-10.39/pcre2-10.39.tar.gz
+./Tools/pcre-build.sh
+./autogen.sh
+./configure --prefix=/usr
+make
+sudo make install
+sudo ldconfig
+
+#check SWIG version
+echo "SWIG version"
+swig -version
+
+cd ..
+touch src/maplexer.l
+touch src/mapparser.y
+
+# report Python locations
+which python
+which pip
+
+# install Python dependencies (required for msautotests)
+pip install --upgrade pip
+# pip install cryptography==3.4.6 # avoid requiring rust compiler for the cryptography dependency
+pip install pyflakes
+pip install -r msautotest/requirements.txt
+
diff -pruN 8.0.1-5/ci/travis/after_success.sh 8.2.0~beta1-1~exp1/ci/travis/after_success.sh
--- 8.0.1-5/ci/travis/after_success.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/ci/travis/after_success.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-#!/bin/sh
-set -eu
-
-if [ "$BUILD_NAME" != "PHP_8.1_WITH_ASAN" ]; then
-    # Only run coverage when it is safe to do so (not on pull requests), and only on master branch
-    echo "$TRAVIS_SECURE_ENV_VARS"
-    echo "$TRAVIS_BRANCH"
-    sh -c 'if test "$TRAVIS_SECURE_ENV_VARS" = "true" -a "$TRAVIS_BRANCH" = "master"; then echo "run coverage"; ./run_code_coverage_upload.sh; fi'
-    ln -s ../../../mapparser.y build/CMakeFiles/mapserver.dir/
-    ln -s ../../../maplexer.l build/CMakeFiles/mapserver.dir/
-    coveralls --exclude renderers --exclude mapscript --exclude apache --exclude build/mapscript/mapscriptJAVA_wrap.c --exclude build/mapscript/mapscriptPYTHON_wrap.c --exclude map2img.c --exclude legend.c --exclude scalebar.c --exclude msencrypt.c --exclude sortshp.c --exclude shptreevis.c --exclude shptree.c --exclude testexpr.c --exclude sym2img.c --exclude testcopy.c --exclude shptreetst.c --exclude tile4ms.c --extension .c --extension .cpp
-fi
diff -pruN 8.0.1-5/ci/travis/before_install.sh 8.2.0~beta1-1~exp1/ci/travis/before_install.sh
--- 8.0.1-5/ci/travis/before_install.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/ci/travis/before_install.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,96 +0,0 @@
-#!/bin/sh
-set -eu
-
-# Remove pre-installed things in Travis image
-if ls /etc/apt/sources.list.d/pgdg* 2>/dev/null >/dev/null; then sudo mv /etc/apt/sources.list.d/pgdg* /tmp; fi
-dpkg -l | grep postgresql || /bin/true
-dpkg -l | grep postgis || /bin/true
-sudo apt-get remove --purge postgresql* libpq-dev libpq5 cmake || /bin/true
-
-sudo add-apt-repository -y ppa:ubuntugis/ubuntugis-unstable
-sudo apt-get update
-sudo apt-get install -y --allow-unauthenticated build-essential protobuf-c-compiler libprotobuf-c-dev bison flex libfribidi-dev librsvg2-dev colordiff libpq-dev libpng-dev libjpeg-dev libgif-dev libgeos-dev libfreetype6-dev libfcgi-dev libcurl4-gnutls-dev libcairo2-dev libgdal-dev libproj-dev libxml2-dev libexempi-dev lcov lftp postgis libharfbuzz-dev gdal-bin proj-bin ccache curl postgresql-server-dev-12 postgresql-12-postgis-3 postgresql-12-postgis-3-scripts g++ ca-certificates
-# following are already installed on Travis CI
-#sudo apt-get install --allow-unauthenticated php-dev python-dev python3-dev
-sudo apt-get install -y --allow-unauthenticated libmono-system-drawing4.0-cil mono-mcs
-sudo apt-get install -y --allow-unauthenticated libperl-dev
-sudo apt-get install -y --allow-unauthenticated openjdk-8-jdk
-sudo apt-get install -y --allow-unauthenticated libonig5
-
-#install recent cmake on GH build action
-if [ -z ${TRAVIS+x} ]; then
-    sudo apt-get install -y --allow-unauthenticated cmake
-    #sudo apt-get install -y --allow-unauthenticated php-xdebug
-    export MSBUILD_ENV="NOT_TRAVIS"
-else
-    # install recent CMake on Travis
-    DEPS_DIR="${TRAVIS_BUILD_DIR}/deps"
-    mkdir ${DEPS_DIR} && cd ${DEPS_DIR}
-    wget --no-check-certificate https://github.com/Kitware/CMake/releases/download/v3.26.3/cmake-3.26.3-linux-x86_64.tar.gz
-    tar -xvf cmake-3.26.3-linux-x86_64.tar.gz > /dev/null
-    mv cmake-3.26.3-linux-x86_64 cmake-install
-    export PATH=${DEPS_DIR}/cmake-install:${DEPS_DIR}/cmake-install/bin:${PATH}
-    cd ${TRAVIS_BUILD_DIR}
-    export MSBUILD_ENV="TRAVIS"
-    # check CMake version installed
-    cmake --version
-fi
-
-#upgrade to recent SWIG
-git clone https://github.com/swig/swig.git swig-git-master
-cd swig-git-master
-wget https://github.com/PhilipHazel/pcre2/releases/download/pcre2-10.39/pcre2-10.39.tar.gz
-./Tools/pcre-build.sh
-./autogen.sh
-./configure --prefix=/usr
-make
-sudo make install
-sudo ldconfig
-cd ../
-#check SWIG version
-swig -version
-
-eval "$(pyenv init --path)"
-eval "$(pyenv init -)"
-
-# list installed and available Python/PHP versions
-pyenv versions
-# echo $(pyenv root)
-# phpenv versions
-
-# set the global Python version
-pyenv global $PYTHON_VERSION
-
-# check we are using the correct versions
-pyenv which pip
-pyenv which python
-
-pip install --upgrade pip
-pip install cryptography==3.4.6 # avoid requiring rust compiler for the cryptography dependency
-pip install cpp-coveralls pyflakes lxml
-pip install -r msautotest/requirements.txt
-
-export CC="ccache gcc"
-export CXX="ccache g++"
-
-sudo sed -i  's/md5/trust/' /etc/postgresql/12/main/pg_hba.conf
-sudo sed -i  's/peer/trust/' /etc/postgresql/12/main/pg_hba.conf
-sudo service postgresql restart 12
-
-cd msautotest
-#upgrade to recent PHPUnit
-cd php && curl -LO https://phar.phpunit.de/phpunit-10.phar
-cd ..
-python -m pyflakes .
-./create_postgis_test_data.sh
-
-if [ $PYTHON_VERSION = "2.7" ]; then
-    python -m SimpleHTTPServer &> /dev/null &
-else
-    # py3
-    python -m http.server &> /dev/null &
-fi
-
-cd ..
-touch maplexer.l
-touch mapparser.y
diff -pruN 8.0.1-5/ci/travis/script.sh 8.2.0~beta1-1~exp1/ci/travis/script.sh
--- 8.0.1-5/ci/travis/script.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/ci/travis/script.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,51 +0,0 @@
-#!/bin/sh
-set -eu
-
-eval "$(pyenv init --path)"
-eval "$(pyenv init -)"
-
-#if [ "$BUILD_NAME" = "PHP_7.2_WITH_ASAN" ]; then
-#    export CC="ccache clang"
-#    export CXX="ccache clang++"
-#else
-    export CC="ccache gcc"
-    export CXX="ccache g++"
-#fi
-
-#make sure to use recent CMake, and the pyenv Python instance
-export PYTHONPREFIX="$(dirname $(realpath $(pyenv which python)))/.."
-if [ -z ${TRAVIS+x} ]; then
-    #not travis
-    export PATH=${PYTHONPREFIX}/bin:${PATH}
-else
-    #travis
-    export PATH=${TRAVIS_BUILD_DIR}/deps/cmake-install:${TRAVIS_BUILD_DIR}/deps/cmake-install/bin:${PYTHONPREFIX}/bin:${PATH}  
-fi
-cmake --version
-
-# check we are using the correct versions
-pyenv which pip
-pyenv which python
-#pyenv which python-config
-# check for phpunit & xdebug
-php msautotest/php/phpunit-10.phar --version
-php -v
-
-if [ "$BUILD_NAME" = "PHP_8.1_WITH_ASAN" ]; then
-    # -DNDEBUG to avoid issues with cairo cleanup
-    make cmakebuild MFLAGS="-j2" CMAKE_C_FLAGS="-g -fsanitize=address -DNDEBUG" CMAKE_CXX_FLAGS="-g -fsanitize=address -DNDEBUG" EXTRA_CMAKEFLAGS="-DCMAKE_BUILD_TYPE=None -DCMAKE_EXE_LINKER_FLAGS=-fsanitize=address"
-    export AUTOTEST_OPTS="--strict --run_under_asan"
-    # Only run tests that only involve mapserv/map2img binaries. mspython, etc would require LD_PREOLOAD'ing the asan shared object
-    make -j4 asan_compatible_tests
-elif [ "$BUILD_NAME" = "PHP_8.1_WITH_PROJ8" ]; then
-    #runs through GitHub action
-    make cmakebuild MFLAGS="-j2" CMAKE_C_FLAGS="-O2" CMAKE_CXX_FLAGS="-O2" LIBMAPSERVER_EXTRA_FLAGS="-Wall -Werror -Wextra"
-    make mspython-wheel
-    make phpng-build    
-    make -j4 test
-else
-    make cmakebuild MFLAGS="-j2" CMAKE_C_FLAGS="-O2" CMAKE_CXX_FLAGS="-O2" LIBMAPSERVER_EXTRA_FLAGS="-Wall -Werror -Wextra"
-    make mspython-wheel
-    make phpng-build    
-    make -j4 test
-fi
diff -pruN 8.0.1-5/classobject.c 8.2.0~beta1-1~exp1/classobject.c
--- 8.0.1-5/classobject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/classobject.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,205 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Functions for operating on a classObj that don't belong in a
- *           more specific file such as mapfile.c.
- *           Adapted from mapobject.c.
- * Author:   Sean Gillies, sgillies@frii.com
- *
- ******************************************************************************
- * Copyright (c) 2004, Sean Gillies
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-/*
-** Add a label to a classObj (order doesn't matter for labels like it does with styles)
-*/
-int msAddLabelToClass(classObj *class, labelObj *label)
-{
-  if (!label) {
-    msSetError(MS_CHILDERR, "Can't add a NULL label.", "msAddLabelToClass()");
-    return MS_FAILURE;
-  }
-  if (msGrowClassLabels(class) == NULL) return MS_FAILURE;
-
-  /* msGrowClassLabels will alloc the label, free it in this case */
-  free(class->labels[class->numlabels]);
-  class->labels[class->numlabels] = label;
-  MS_REFCNT_INCR(label);
-  class->numlabels++;
-  return MS_SUCCESS;
-}
-
-/*
-** Remove a label from a classObj.
-*/
-labelObj *msRemoveLabelFromClass(classObj *class, int nLabelIndex)
-{
-  int i;
-  labelObj *label;
-
-  if (nLabelIndex < 0 || nLabelIndex >= class->numlabels) {
-    msSetError(MS_CHILDERR, "Cannot remove label, invalid index %d", "msRemoveLabelFromClass()", nLabelIndex);
-    return NULL;
-  } else {
-    label=class->labels[nLabelIndex];
-    for (i=nLabelIndex; i<class->numlabels-1; i++) {
-      class->labels[i]=class->labels[i+1];
-    }
-    class->labels[class->numlabels-1]=NULL;
-    class->numlabels--;
-    MS_REFCNT_DECR(label);
-    return label;
-  }
-}
-
-/**
- * Move the style up inside the array of styles.
- */
-int msMoveStyleUp(classObj *class, int nStyleIndex)
-{
-  styleObj *psTmpStyle = NULL;
-  if (class && nStyleIndex < class->numstyles && nStyleIndex >0) {
-    psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
-    initStyle(psTmpStyle);
-
-    msCopyStyle(psTmpStyle, class->styles[nStyleIndex]);
-
-    msCopyStyle(class->styles[nStyleIndex],
-                class->styles[nStyleIndex-1]);
-
-    msCopyStyle(class->styles[nStyleIndex-1], psTmpStyle);
-
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveStyleUp()",
-             nStyleIndex);
-  return (MS_FAILURE);
-}
-
-
-/**
- * Move the style down inside the array of styles.
- */
-int msMoveStyleDown(classObj *class, int nStyleIndex)
-{
-  styleObj *psTmpStyle = NULL;
-
-  if (class && nStyleIndex < class->numstyles-1 && nStyleIndex >=0) {
-    psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
-    initStyle(psTmpStyle);
-
-    msCopyStyle(psTmpStyle, class->styles[nStyleIndex]);
-
-    msCopyStyle(class->styles[nStyleIndex],
-                class->styles[nStyleIndex+1]);
-
-    msCopyStyle(class->styles[nStyleIndex+1], psTmpStyle);
-
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveStyleDown()",
-             nStyleIndex);
-  return (MS_FAILURE);
-}
-
-/* Moved here from mapscript.i
- *
- * Returns the index at which the style was inserted
- *
- */
-int msInsertStyle(classObj *class, styleObj *style, int nStyleIndex)
-{
-  int i;
-
-  if (!style) {
-    msSetError(MS_CHILDERR, "Can't insert a NULL Style", "msInsertStyle()");
-    return -1;
-  }
-
-  /* Ensure there is room for a new style */
-  if (msGrowClassStyles(class) == NULL) {
-    return -1;
-  }
-  /* Catch attempt to insert past end of styles array */
-  else if (nStyleIndex >= class->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d", "insertStyle()", class->numstyles-1);
-    return -1;
-  } else if (nStyleIndex < 0) { /* Insert at the end by default */
-    class->styles[class->numstyles]=style;
-    MS_REFCNT_INCR(style);
-    class->numstyles++;
-    return class->numstyles-1;
-  } else {
-    /* Move styles existing at the specified nStyleIndex or greater */
-    /* to a higher nStyleIndex */
-    for (i=class->numstyles-1; i>=nStyleIndex; i--) {
-      class->styles[i+1] = class->styles[i];
-    }
-    class->styles[nStyleIndex]=style;
-    MS_REFCNT_INCR(style);
-    class->numstyles++;
-    return nStyleIndex;
-  }
-}
-
-styleObj *msRemoveStyle(classObj *class, int nStyleIndex)
-{
-  int i;
-  styleObj *style;
-  if (nStyleIndex < 0 || nStyleIndex >= class->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d", "removeStyle()", nStyleIndex);
-    return NULL;
-  } else {
-    style=class->styles[nStyleIndex];
-    for (i=nStyleIndex; i<class->numstyles-1; i++) {
-      class->styles[i]=class->styles[i+1];
-    }
-    class->styles[class->numstyles-1]=NULL;
-    class->numstyles--;
-    MS_REFCNT_DECR(style);
-    return style;
-  }
-}
-
-/**
- * Delete the style identified by the index and shift
- * styles that follows the deleted style.
- */
-int msDeleteStyle(classObj *class, int nStyleIndex)
-{
-  if (class && nStyleIndex < class->numstyles && nStyleIndex >=0) {
-    if (freeStyle(class->styles[nStyleIndex]) == MS_SUCCESS)
-      msFree(class->styles[nStyleIndex]);
-    for (int i=nStyleIndex; i< class->numstyles-1; i++) {
-      class->styles[i] = class->styles[i+1];
-    }
-    class->styles[class->numstyles-1] = NULL;
-    class->numstyles--;
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msDeleteStyle()",
-             nStyleIndex);
-  return (MS_FAILURE);
-}
diff -pruN 8.0.1-5/cmake/FindGDAL.cmake 8.2.0~beta1-1~exp1/cmake/FindGDAL.cmake
--- 8.0.1-5/cmake/FindGDAL.cmake	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/cmake/FindGDAL.cmake	2024-06-06 20:07:58.000000000 +0000
@@ -73,7 +73,7 @@ if(UNIX)
     )
 
     if(GDAL_CONFIG)
-        exec_program(${GDAL_CONFIG} ARGS --libs OUTPUT_VARIABLE GDAL_CONFIG_LIBS)
+        execute_process(COMMAND ${GDAL_CONFIG} --libs OUTPUT_VARIABLE GDAL_CONFIG_LIBS)
         if(GDAL_CONFIG_LIBS)
             string(REGEX MATCHALL "-l[^ ]+" _gdal_dashl ${GDAL_CONFIG_LIBS})
             string(REGEX REPLACE "-l" "" _gdal_lib "${_gdal_dashl}")
@@ -104,3 +104,15 @@ include(FindPackageHandleStandardArgs)
 FIND_PACKAGE_HANDLE_STANDARD_ARGS(GDAL DEFAULT_MSG GDAL_LIBRARY GDAL_INCLUDE_DIR)
 MARK_AS_ADVANCED(GDAL_LIBRARY GDAL_INCLUDE_DIR GDAL_CONFIG)
 
+if(GDAL_FOUND)
+     FILE(READ ${GDAL_INCLUDE_DIR}/gdal_version.h gdal_version)
+     STRING(REGEX REPLACE "^.*GDAL_VERSION_MAJOR +([0-9]+).*$" "\\1" GDAL_VERSION_MAJOR "${gdal_version}")
+     STRING(REGEX REPLACE "^.*GDAL_VERSION_MINOR +([0-9]+).*$" "\\1" GDAL_VERSION_MINOR "${gdal_version}")
+     STRING(REGEX REPLACE "^.*GDAL_VERSION_REV +([0-9]+).*$" "\\1" GDAL_VERSION_REV "${gdal_version}")
+
+     MESSAGE(STATUS "Found GDAL ${GDAL_VERSION_MAJOR}.${GDAL_VERSION_MINOR}")
+
+     IF (GDAL_VERSION_MAJOR VERSION_LESS 3)
+        MESSAGE (FATAL_ERROR "GDAL ${GDAL_VERSION_MAJOR}.${GDAL_VERSION_MINOR} is not supported. Use 3.0 or higher.")
+     ENDIF()
+endif()
diff -pruN 8.0.1-5/cmake/FindProj.cmake 8.2.0~beta1-1~exp1/cmake/FindProj.cmake
--- 8.0.1-5/cmake/FindProj.cmake	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/cmake/FindProj.cmake	2024-06-06 20:07:58.000000000 +0000
@@ -6,7 +6,7 @@
 #    PROJ_LIBRARY
 
 
-FIND_PATH(PROJ_INCLUDE_DIR NAMES proj.h proj_api.h)
+FIND_PATH(PROJ_INCLUDE_DIR NAMES proj.h)
 
 FIND_LIBRARY(PROJ_LIBRARY NAMES proj proj_i)
 
@@ -20,7 +20,6 @@ IF (PROJ_INCLUDE_DIR AND PROJ_LIBRARY)
 ENDIF (PROJ_INCLUDE_DIR AND PROJ_LIBRARY)
 
 IF (PROJ_FOUND)
-   IF (EXISTS ${PROJ_INCLUDE_DIR}/proj.h)
      FILE(READ ${PROJ_INCLUDE_DIR}/proj.h proj_version)
      STRING(REGEX REPLACE "^.*PROJ_VERSION_MAJOR +([0-9]+).*$" "\\1" PROJ_VERSION_MAJOR "${proj_version}")
      STRING(REGEX REPLACE "^.*PROJ_VERSION_MINOR +([0-9]+).*$" "\\1" PROJ_VERSION_MINOR "${proj_version}")
@@ -28,13 +27,12 @@ IF (PROJ_FOUND)
 
      MESSAGE(STATUS "Found Proj ${PROJ_VERSION_MAJOR}.${PROJ_VERSION_MINOR}")
 
+     IF (PROJ_VERSION_MAJOR EQUAL 6 AND PROJ_VERSION_MINOR EQUAL 0)
+        MESSAGE (FATAL_ERROR "PROJ 6.0 is not supported. Use 6.1.0 or higher.")
+     ENDIF()
      IF ((PROJ_VERSION_MAJOR EQUAL 6) AND (PROJ_VERSION_MINOR EQUAL 3) AND (PROJ_VERSION_PATCH EQUAL 0))
         MESSAGE (FATAL_ERROR "MapServer known to crash with PROJ 6.3.0. Use 6.3.1 or higher.")
-     ENDIF ((PROJ_VERSION_MAJOR EQUAL 6) AND (PROJ_VERSION_MINOR EQUAL 3) AND (PROJ_VERSION_PATCH EQUAL 0))
+     ENDIF()
 
      ADD_DEFINITIONS(-DPROJ_VERSION_MAJOR=${PROJ_VERSION_MAJOR})
-  ELSE()
-     MESSAGE(STATUS "Found Proj 4.x")
-     ADD_DEFINITIONS(-DPROJ_VERSION_MAJOR=4)
-  ENDIF()
 ENDIF (PROJ_FOUND)
diff -pruN 8.0.1-5/coshp.c 8.2.0~beta1-1~exp1/coshp.c
--- 8.0.1-5/coshp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/coshp.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,236 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Command line utility to sort a shapefile based on the
- *           spatial index file.
- *
- ******************************************************************************
- * Copyright (c) 2021 Paul Ramsey <pramsey@cleverelephant.ca>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <math.h>
-#include <string.h>
-
-#include "mapserver.h"
-
-
-typedef struct {
-  SHPHandle inSHP, outSHP;
-  DBFHandle inDBF, outDBF;
-  int currentOutRecord;
-  int numDbfFields;
-} writeState;
-
-static char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension     */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = (int)strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*  Open the .shp and .shx files.  Note that files pulled from      */
-  /*  a PC to Unix with upper case filenames won't work!        */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
-
-  free(pszBasename);
-  return (pszFullname);
-}
-
-
-static int writeShape(writeState *state, int shapeId)
-{
-  int j = 0;
-  int i = state->currentOutRecord;
-  char fName[20];
-  int fWidth, fnDecimals;
-  shapeObj shape;
-
-  /* Copy the DBF record over */
-  for(j=0; j<state->numDbfFields; j++) {
-
-    DBFFieldType dbfField = msDBFGetFieldInfo(state->inDBF, j, fName, &fWidth, &fnDecimals);
-
-    switch (dbfField) {
-      case FTInteger:
-        msDBFWriteIntegerAttribute(state->outDBF, i, j,
-          msDBFReadIntegerAttribute(state->inDBF, shapeId, j));
-        break;
-      case FTDouble:
-        msDBFWriteDoubleAttribute(state->outDBF, i, j,
-          msDBFReadDoubleAttribute(state->inDBF, shapeId, j));
-        break;
-      case FTString:
-        msDBFWriteStringAttribute(state->outDBF, i, j,
-          msDBFReadStringAttribute(state->inDBF, shapeId, j));
-        break;
-      default:
-        fprintf(stderr,"Unsupported data type for field: %s, exiting.\n",fName);
-        exit(0);
-    }
-  }
-
-  /* Copy the SHP record over */
-  msSHPReadShape( state->inSHP, shapeId, &shape );
-  msSHPWriteShape( state->outSHP, &shape );
-  msFreeShape( &shape );
-
-  /* Increment output row number */
-  state->currentOutRecord++;
-
-  return MS_SUCCESS;
-}
-
-
-static int writeNode(writeState *state, treeNodeObj *node)
-{
-  int i;
-  if (node->ids) {
-    for(i = 0; i < node->numshapes; i++) {
-      int curRec = state->currentOutRecord;
-      writeShape(state, node->ids[i]);
-      node->ids[i] = curRec;
-    }
-  }
-  for(i = 0; i < node->numsubnodes; i++) {
-    if (node->subnode[i])
-      writeNode(state, node->subnode[i]);
-  }
-  return MS_SUCCESS;
-}
-
-
-int main(int argc, char *argv[])
-{
-  treeObj *tree;          /* In-memory index */
-  shapefileObj shapefile; /* Input shapefile */
-  SHPHandle    outSHP;    /* Output SHP */
-  DBFHandle    outDBF;    /* Output DBF */
-  DBFFieldType dbfField;
-  writeState   state;
-  int          shpType, nShapes;
-  char         fName[20];
-  int          fWidth, fnDecimals;
-  char         buffer[1024];
-  int          numFields;
-  int          i;
-
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
-    printf("%s\n", msGetVersion());
-    exit(0);
-  }
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Check the number of arguments, return syntax if not correct               */
-  /* ------------------------------------------------------------------------------- */
-  if( argc != 3 ) {
-    fprintf(stderr,"Syntax: %s [infile] [outfile]\n", argv[0]);
-    exit(1);
-  }
-
-  msSetErrorFile("stderr", NULL);
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Open the shapefile                                                        */
-  /* ------------------------------------------------------------------------------- */
-  if(msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) < 0) {
-    fprintf(stdout, "Error opening shapefile %s.\n", argv[1]);
-    exit(0);
-  }
-
-  nShapes = shapefile.numshapes;
-  shpType = shapefile.type;
-  numFields = msDBFGetFieldCount(shapefile.hDBF);
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Index the shapefile (auto-calculate depth)                                */
-  /* ------------------------------------------------------------------------------- */
-  tree = msCreateTree(&shapefile, 0);
-  msTreeTrim(tree);
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Setup the output .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
-  outSHP = msSHPCreate(argv[2], shpType);
-  if( outSHP == NULL ) {
-    fprintf( stderr, "Failed to create file '%s'.\n", argv[2] );
-    exit( 1 );
-  }
-
-  sprintf(buffer,"%s.dbf", argv[2]);
-  outDBF = msDBFCreate(buffer);
-  if( outDBF == NULL ) {
-    fprintf( stderr, "Failed to create dbf file '%s'.\n", buffer );
-    exit( 1 );
-  }
-
-  /* Clone the fields from the input to the output definition */
-  for(i=0; i<numFields; i++) {
-    dbfField = msDBFGetFieldInfo(shapefile.hDBF, i, fName, &fWidth, &fnDecimals); /* ---- Get field info from in file ---- */
-    msDBFAddField(outDBF, fName, dbfField, fWidth, fnDecimals);
-  }
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Write the sorted .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
-
-  /* Set up writer state */
-  state.inSHP = shapefile.hSHP;
-  state.outSHP = outSHP;
-  state.inDBF = shapefile.hDBF;
-  state.outDBF = outDBF;
-  state.currentOutRecord = 0;
-  state.numDbfFields = numFields;
-
-  writeNode(&state, tree->root);
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Write the spatial index                                                   */
-  /* ------------------------------------------------------------------------------- */
-  msWriteTree(tree, AddFileSuffix(argv[2], MS_INDEX_EXTENSION), MS_NEW_LSB_ORDER);
-  msDestroyTree(tree);
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Close all files                                                           */
-  /* ------------------------------------------------------------------------------- */
-  msShapefileClose(&shapefile);
-  msSHPClose(outSHP);
-  msDBFClose(outDBF);
-
-  fprintf(stdout, "Wrote %d spatially sorted shapes into shapefile '%s'\n", nShapes, argv[2]);
-  return(0);
-}
diff -pruN 8.0.1-5/coshp.md 8.2.0~beta1-1~exp1/coshp.md
--- 8.0.1-5/coshp.md	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/coshp.md	1970-01-01 00:00:00.000000000 +0000
@@ -1,101 +0,0 @@
-# MapServer QIX File (aka ShpTree)
-
-https://support.esri.com/en/white-paper/279
-
-## Shape File Model
-
-The shape file consists of three standard components.
-
-* **shp** file contains the binary representations of the shapes (points, lines, polygons)
-* **dbf** file contains the associated attribute information for each shape, one row per shape
-* **shx** includes an ordered list of byte offsets of shapes in the **shp** file
-
-The records in each component are inter-related by their **order of appearance**. The first entry in the **shx** file is the byte offset to the first shape in the shape file, and the first record of the dbf file contains the attributes of the first shape.
-
-In addition to the standard three components, the QIX model adds a fourth component.
-
-* **qix** file contains a binary quad-tree, in which every node in the three includes a bounds, a list of child nodes, and a list of "shape ids" that are contained in that node. The "shape ids" are just the record numbers. So "shape id" **0** corresponds to the first record in the shp/dbf/shx files, and so on.
-
-## Header
-
-There is an **8 byte** header.
-
-* **byte 0, len 3** are file signature string, always "SQT"
-* **byte 3, len 1** signals the byte-order of multi-byte types
-  * [see code](https://github.com/MapServer/MapServer/blob/8af82513f8be8a380acbb5d92f9c5dec360ee5f1/maptree.h#L72-L76)
-  * 1 = LSB (little-endian)
-  * 2 = MSB (big-endian)
-  * 0 = native (the endian of the system that wrote the file (probably LSB))
-* **byte 4, len 1** is the version number
-  * 1 = current version
-* **byte 5, len 3** is reserved for future use
-* **byte 8, len 4** is an **integer** count of number of shapes in the tree
-* **byte 12, len 4** is an **integer** count of depth of the three
-
-All **integer** values may require a byte swap, if the system byte order differs from the file byte order.
-
-## Nodes
-
-Nodes contain an 
-
-* **byte 0, len 4** is an **integer** offset from the just after the numShapes of this node to the start of the next sibling node
-* **byte 4, len 8** is a the **double** minx of the node
-* **byte 12, len 8** is a the **double** miny of the node
-* **byte 20, len 8** is a the **double** maxx of the node
-* **byte 28, len 8** is a the **double** maxy of the node
-* **byte 36, len 4** is an **integer** numShapes, the count of shape ids stored in this node
-* **byte 40, len 4\*numShapes** is an **array of integer** shape ids
-* **btye 40+4\*numShapes, 40+4\*numShapes+4** is an **integer** numChildren number of child nodes under this node
-
-All **integer** and **double** values may require a byte swap, if the system byte order differs from the file byte order.
-
-Note that the **offset** is the distance in bytes from just after the numShapes entry, 40 bytes from the start of the node. Or put another way, "offset + 40" is the distance from the start of **this** node to the start of the **next sibling** node.
-
-## Arrangement of Components
-
-* The file starts with a header.
-* A node and all its descendents always form a contiguous range of the file.
-* A node has at most four children.
-* Both internal and leaf nodes may contain shape ids.
-
-```
-Header
-Node A
-Node AA
-Node AAA
-Node AAB
-Node AAC
-Node AB
-Node ABA
-Node ABB
-Node AC
-Node B
-Node BA
-Node BAA
-Node BAB
-Node BB
-Node C
-```
-
-## Searching
-
-### The Tree
-
-The spatial search will involve a "query box" and will return a list of "shape id".
-
-* Recursively search from the top node.
-* Check that the node box and the query box intersect.
-* If they do not, return.
-* If they do, then add the "shape ids" in the node to the result list.
-* Call the search function on each child node.
-
-You can use the "offset" of each child to find the location of the next child in the set.
-
-Implementation of a reader will probably want to opportunistically load portions of the whole tree into a memory structure, rather than hopping around with random reads. If "distance to next sibling" < some size, load whole subtree into memory and iterate on that.
-
-### For Features
-
-Once the tree search is complete, retrieving the features involves pulling the data from the **shp** and **dbf** files. If the shape file has been "cloud optimized", a query rectangle should involve a minimized number of range requests on the data files, since the order of records should match the order of nodes in the tree.
-
-Analyze the "shape id" list coming out of the tree search, and find contiguous or almost-contiguous ranges of ids. Lookup the [byte offsets](https://www.esri.com/content/dam/esrisites/sitecore-archive/Files/Pdfs/library/whitepapers/pdfs/shapefile.pdf#page=28) from the **shx** file, then retrieve those ranges of data from the **shp** file. The **dbf** file is based on a fixed-length record, so once the header is read, finding the byte offset of a record just involving multiplying the record length by the shape id number.
-
diff -pruN 8.0.1-5/debian/changelog 8.2.0~beta1-1~exp1/debian/changelog
--- 8.0.1-5/debian/changelog	2024-05-08 16:48:14.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/changelog	2024-06-07 05:06:59.000000000 +0000
@@ -1,3 +1,16 @@
+mapserver (8.2.0~beta1-1~exp1) experimental; urgency=medium
+
+  * New upstream beta release.
+  * Update copyright file.
+  * Drop patches applied upstream. Refresh remaining patches.
+  * Add python3-pip to build dependencies.
+  * Update paths for source tree restructuring.
+  * Add patch to fix Python MapScript installation.
+  * Update symbols for amd64.
+  * Add patch to fix spelling errors.
+
+ -- Bas Couwenberg <sebastic@debian.org>  Fri, 07 Jun 2024 07:06:59 +0200
+
 mapserver (8.0.1-5) unstable; urgency=medium
 
   * Add patch to fix FTBFS with glibc 2.38.
diff -pruN 8.0.1-5/debian/control 8.2.0~beta1-1~exp1/debian/control
--- 8.0.1-5/debian/control	2024-05-08 16:45:13.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/control	2024-06-07 05:06:59.000000000 +0000
@@ -42,6 +42,7 @@ Build-Depends: ant,
                protobuf-c-compiler,
                python3,
                python3-dev,
+               python3-pip,
                python3-setuptools,
                swig,
                xsltproc,
@@ -49,7 +50,7 @@ Build-Depends: ant,
 Build-Conflicts: libcurl3-openssl-dev
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapserver
-Vcs-Git: https://salsa.debian.org/debian-gis-team/mapserver.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/mapserver.git -b experimental
 Homepage: https://mapserver.org
 Rules-Requires-Root: no
 
diff -pruN 8.0.1-5/debian/copyright 8.2.0~beta1-1~exp1/debian/copyright
--- 8.0.1-5/debian/copyright	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/copyright	2024-06-07 05:06:59.000000000 +0000
@@ -23,47 +23,53 @@ Copyright:                    Joyent, In
                         2021, MapServer team
             2008, 2010, 2021, Paul Ramsey
                    1996-2022, Regents of the University of Minnesota.
-                   2008-2023, Open Source Geospatial Foundation.
+                   2008-2024, Open Source Geospatial Foundation.
 License: MIT
 
-Files: dejavu-sans-condensed.h
+Files: fuzzers/build.sh
+       fuzzers/configfuzzer.c
+       fuzzers/mapfuzzer.c
+Copyright: 2022, Google LLC
+License: Apache-2.0
+
+Files: src/dejavu-sans-condensed.h
 Copyright: 2003, Bitstream, Inc.
            2006, Tavmjong Bah.
 License: DejaVu
 
-Files: flatgeobuf/*
+Files: src/flatgeobuf/*
 Copyright: 2018, Björn Harrtell
 License: BSD-2-Clause
 
-Files: flatgeobuf/include/flatbuffers/*
+Files: src/flatgeobuf/include/flatbuffers/*
 Copyright: 2014-2015, 2017, 2021-2022, Google Inc.
 License: Apache-2.0
 
-Files: flatgeobuf/packedrtree.cpp
- flatgeobuf/packedrtree.h
+Files: src/flatgeobuf/packedrtree.cpp
+       src/flatgeobuf/packedrtree.h
 Copyright: 2018-2020, Björn Harrtell <bjorn at wololo dot org>
 License: MIT
 
-Files: mapbits.c
+Files: src/mapbits.c
 Copyright: 1996-2005, Regents of the University of Minnesota
 License: MIT
 Comment: Derived from code placed in the public domain by Bob Stout, for more
  information see http://c.snippets.org/snip_lister.php?fname=bitarray.c.
 
-Files: mapquantization.c
+Files: src/mapquantization.c
 Copyright: 1989, 1991, Jef Poskanzer
      1997, 2000, 2002, Greg Roelofs
             1996-2005, Regents of the University of Minnesota
 License: MIT-mapquantization
 Comment: Contains code derived from pngquant.c and libpam3.c.
 
-Files: maptclutf.c
+Files: src/maptclutf.c
 Copyright: 1997-1998, Sun Microsystems, Inc
            1996-2007, Regents of the University of Minnesota
 License: MIT-maptclutf
 Comment: Contains code derived from tclUtf.c.
 
-Files: mapstring.cpp
+Files: src/mapstring.cpp
 Copyright: 1990, 1993, The Regents of the University of California
                  1998, Todd C. Miller <Todd.Miller@courtesan.com>
             2000-2004, University of Illinois Board of Trustees
@@ -72,50 +78,50 @@ Copyright: 1990, 1993, The Regents of th
 License: MIT-mapstring
 Comment: Contains string functions from various sources.
 
-Files: strptime.c
+Files: src/strptime.c
 Copyright: 1999, Kungliga Tekniska Högskolan
 License: BSD-3-clause-KTH
 
-Files: mapparser.c
- mapparser.h
+Files: src/mapparser.c
+       src/mapparser.h
 Copyright: 1984, 1989-1990, 2000-2011, Free Software Foundation, Inc.
 License: GPL-3+ with Bison exception
 
-Files: uthash.h
+Files: src/uthash.h
 Copyright: 2003-2013, Troy D. Hanson
 License: BSD-1-clause
 
-Files: opengl/glext.h
+Files: src/opengl/glext.h
 Copyright: 1991-2004, Silicon Graphics, Inc
                 2005, NVIDIA Corporation
 License: SGI-B-1.1-with-NVIDIA
 
-Files: opengl/wglext.h
+Files: src/opengl/wglext.h
 Copyright: 1991-2004, Silicon Graphics, Inc
 License: SGI-B-1.1
 
-Files: renderers/agg/*
+Files: src/renderers/agg/*
 Copyright: 2002-2005, Maxim Shemanarev (http://www.antigrain.com)
 License: AGGPL or BSD-3-clause-AGG
 Comment: Note that AGG changed license to GPL-2+ from v2.5 onwards,
  but the embedded copy is the dual licensed v2.4.
 
-Files: renderers/agg/include/agg_curves.h
+Files: src/renderers/agg/include/agg_curves.h
 Copyright: 2002-2005, Maxim Shemanarev (http://www.antigrain.com)
                 2005, Tony Juricic (tonygeek@yahoo.com)
 License: AGGPL or BSD-3-clause-AGG
 
-Files: renderers/agg/include/agg_conv_clipper.h
- renderers/agg/include/clipper.hpp
- renderers/agg/src/clipper.cpp
+Files: src/renderers/agg/include/agg_conv_clipper.h
+       src/renderers/agg/include/clipper.hpp
+       src/renderers/agg/src/clipper.cpp
 Copyright: 2010-2011, Angus Johnson
 License: BSL-1.0
 
-Files: third-party/nlohmann/*
+Files: src/third-party/nlohmann/*
 Copyright: 2013-2022, Niels Lohmann <http://nlohmann.me>
 License: MIT
 
-Files: third-party/pantor/*
+Files: src/third-party/pantor/*
 Copyright: 2018-2021, Lars Berscheid
 License: MIT
 
diff -pruN 8.0.1-5/debian/gbp.conf 8.2.0~beta1-1~exp1/debian/gbp.conf
--- 8.0.1-5/debian/gbp.conf	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/gbp.conf	2024-06-07 05:06:59.000000000 +0000
@@ -6,7 +6,7 @@ upstream-branch = upstream
 
 # The default name for the Debian branch is "master".
 # Change it if the name is different (for instance, "debian/unstable").
-debian-branch = master
+debian-branch = experimental
 
 # git-import-orig uses the following names for the upstream tags.
 # Change the value if you are not using git-import-orig
diff -pruN 8.0.1-5/debian/libmapscript-perl.examples 8.2.0~beta1-1~exp1/debian/libmapscript-perl.examples
--- 8.0.1-5/debian/libmapscript-perl.examples	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/libmapscript-perl.examples	2024-06-07 05:06:59.000000000 +0000
@@ -1 +1 @@
-mapscript/perl/examples/*
+src/mapscript/perl/examples/*
diff -pruN 8.0.1-5/debian/libmapserver2t64.symbols 8.2.0~beta1-1~exp1/debian/libmapserver2t64.symbols
--- 8.0.1-5/debian/libmapserver2t64.symbols	2024-05-08 16:48:14.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/libmapserver2t64.symbols	2024-06-07 05:06:59.000000000 +0000
@@ -1,7 +1,6 @@
-# SymbolsHelper-Confirmed: 8.0.1 alpha amd64 arm64 armel armhf i386 ia64 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc64
+# SymbolsHelper-Confirmed: 8.2.0~beta1 amd64
 libmapserver.so.2 #PACKAGE# #MINVER#
 * Build-Depends-Package: libmapserver-dev
- BuildExpressionTree@Base 6.2.1
  CompareEllipseRegion@Base 6.2.1
  CompareRectangleRegion@Base 6.2.1
  DefineAxis@Base 6.2.1
@@ -86,7 +85,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  Pix2Georef@Base 6.2.1
  Pix2LayerGeoref@Base 6.2.1
  RebuildClusters@Base 6.2.1
- _SLDApplyRuleValues@Base 6.2.1
  _Z11agg2CleanupPv@Base 6.2.1
  (optional=templinst)_Z11parse_valueIhEvPhPPctRjb@Base 8.0.0
  (optional=templinst|arch=armel armhf i386 m68k mipsel powerpc)_Z11parse_valueIxEvPhPPctRjb@Base 8.0.0
@@ -115,8 +113,10 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  _Z17msStdStringEscapeB5cxx11PKc@Base 8.0.0
  _Z17msUnionLayerCloseP8layerObj@Base 8.0.0
  _Z18FLTGetGeosOperatorPc@Base 8.0.0
+ _Z18msSLDGetGraphicSLDP8styleObjP8layerObjii@Base 8.2.0~beta1
  _Z18msStringTrimBlanksRNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEE@Base 8.0.0
  _Z18msUnionLayerIsOpenP8layerObj@Base 8.0.0
+ _Z19_SLDApplyRuleValuesP10CPLXMLNodeP8layerObji@Base 8.2.0~beta1
  _Z19agg2RenderLineTiledP8imageObjP8shapeObjS0_@Base 6.2.1
  _Z19msWMSPrintScaleHintPKcddd@Base 8.0.0
  _Z20FLTGetTimeExpressionB5cxx11P11_FilterNodeP8layerObj@Base 8.0.0
@@ -137,6 +137,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  _Z22aggGetRasterBufferCopyP8imageObjP15rasterBufferObj@Base 6.2.1
  _Z22msLibXml2GetFirstChildP8_xmlNodePKc@Base 8.0.0
  _Z22msOGRRecursiveFileListPKc@Base 7.6.0
+ _Z22msSLDParseUomAttributeP10CPLXMLNodeP8MS_UNITS@Base 8.2.0~beta1
  _Z22msTranslateWMS2MapservPPKcS1_iPPPcS4_Pi@Base 8.0.0
  _Z22msWMSPrintAuthorityURLP8_IO_FILEPKcP12hashTableObjS2_@Base 8.0.0
  _Z22msWMSPrintNestedGroupsP6mapObjiPciiPPS1_PiS4_PKcS6_@Base 8.0.0
@@ -404,6 +405,8 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  (arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA10_cLi0EEEvRT_RKT0_@Base 8.0.0
  (arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA11_cLi0EEEvRT_RKT0_@Base 8.0.0
  (arch=amd64 arm64)_ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA21_cLi0EEEvRT_RKT0_@Base 8.0.1
+ _ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA22_cLi0EEEvRT_RKT0_@Base 8.2.0~beta1
+ _ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA24_cLi0EEEvRT_RKT0_@Base 8.2.0~beta1
  (arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA4_cLi0EEEvRT_RKT0_@Base 8.0.0
  (arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA5_cLi0EEEvRT_RKT0_@Base 8.0.0
  (arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZN11ms_nlohmann6detail20external_constructorILNS0_7value_tE3EE9constructINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES7_IhSaIhEEEEA6_cLi0EEEvRT_RKT0_@Base 8.0.0
@@ -499,6 +502,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  (optional=templinst|arch=armel armhf i386 m68k mipsel powerpc)_ZN11ms_nlohmann6detail9iter_implIKNS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEbxydSaNS_14adl_serializerES4_IhSaIhEEEEE9set_beginEv@Base 8.0.0
  (optional=templinst|arch=alpha amd64 arm64 armel armhf i386 ia64 loong64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sparc64|subst)_ZN11ms_nlohmann6detail9iter_implIKNS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEb{int64_t}{uint64_t}dSaNS_14adl_serializerES4_IhSaIhEEEEEC1EPSF_@Base 8.0.1
  (optional=templinst|arch=alpha amd64 arm64 armel armhf i386 ia64 loong64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sparc64|subst)_ZN11ms_nlohmann6detail9iter_implIKNS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEb{int64_t}{uint64_t}dSaNS_14adl_serializerES4_IhSaIhEEEEEC2EPSF_@Base 8.0.1
+ (optional=templinst)_ZN11ms_nlohmann6detail9iter_implINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES4_IhSaIhEEEEE9set_beginEv@Base 8.2.0~beta1
  (arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZN11ms_nlohmanneqERKNS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES2_IhSaIhEEEESE_@Base 8.0.0
  (arch=armel armhf i386 m68k mipsel powerpc)_ZN11ms_nlohmanneqERKNS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEbxydSaNS_14adl_serializerES2_IhSaIhEEEESE_@Base 8.0.0
  (arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZN11ms_nlohmannltERKNS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES2_IhSaIhEEEESE_@Base 8.0.0
@@ -523,8 +527,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  _ZN4inja11LiteralNodeD0Ev@Base 8.0.0
  _ZN4inja11LiteralNodeD1Ev@Base 8.0.0
  _ZN4inja11LiteralNodeD2Ev@Base 8.0.0
- (arch=amd64)_ZN4inja11ParserErrorC1ERKNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEENS_14SourceLocationE@Base 8.0.1
- (arch=amd64)_ZN4inja11ParserErrorC2ERKNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEENS_14SourceLocationE@Base 8.0.1
  _ZN4inja11ParserErrorD0Ev@Base 8.0.0
  _ZN4inja11ParserErrorD1Ev@Base 8.0.0
  _ZN4inja11ParserErrorD2Ev@Base 8.0.0
@@ -965,7 +967,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  (optional=templinst|arch=!armel !armhf !i386 !m68k !mipsel !powerpc)_ZNK11ms_nlohmann6detail9iter_implINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS_14adl_serializerES4_IhSaIhEEEEEdeEv@Base 8.0.0
  (optional=templinst|arch=armel armhf i386 m68k mipsel powerpc)_ZNK11ms_nlohmann6detail9iter_implINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEbxydSaNS_14adl_serializerES4_IhSaIhEEEEEdeEv@Base 8.0.0
  (optional=templinst|arch=mipsel)_ZNK11ms_nlohmann6detail9iter_implINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEbxydSaNS_14adl_serializerES4_IhSaIhEEEEEltERKSF_@Base 8.0.0
- (optional=templinst|arch=arm64 mipsel|subst)_ZNK11ms_nlohmann6detail9iter_implINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEb{int64_t}{uint64_t}dSaNS_14adl_serializerES4_IhSaIhEEEEEeqISF_LDnEEEbRKT_@Base 8.0.0
+ (optional=templinst|arch=amd64 arm64 mipsel|subst)_ZNK11ms_nlohmann6detail9iter_implINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEb{int64_t}{uint64_t}dSaNS_14adl_serializerES4_IhSaIhEEEEEeqISF_LDnEEEbRKT_@Base 8.0.0
  (optional=templinst|arch=alpha amd64 arm64 ia64 loong64 mips64el mipsel riscv64 sparc64|subst)_ZNK11ms_nlohmann6detail9iter_implINS_10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEb{int64_t}{uint64_t}dSaNS_14adl_serializerES4_IhSaIhEEEEEmiERKSF_@Base 8.0.0
  _ZNK4inja11LiteralNode6acceptERNS_11NodeVisitorE@Base 8.0.0
  _ZNK4inja12FunctionNode6acceptERNS_11NodeVisitorE@Base 8.0.0
@@ -1062,7 +1064,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  (optional=templinst|arch=armel riscv64)_ZNSt16_Sp_counted_baseILN9__gnu_cxx12_Lock_policyE1EE10_M_releaseEv@Base 8.0.0
  (optional=templinst|arch=!armel !riscv64)_ZNSt16_Sp_counted_baseILN9__gnu_cxx12_Lock_policyE2EE10_M_destroyEv@Base 8.0.0
  (optional=templinst|arch=!armel !riscv64)_ZNSt16_Sp_counted_baseILN9__gnu_cxx12_Lock_policyE2EE10_M_releaseEv@Base 8.0.0
- (optional=templinst|arch=arm64)_ZNSt16_Sp_counted_baseILN9__gnu_cxx12_Lock_policyE2EE15_M_add_ref_copyEv@Base 8.0.1
+ (optional=templinst|arch=amd64 arm64)_ZNSt16_Sp_counted_baseILN9__gnu_cxx12_Lock_policyE2EE15_M_add_ref_copyEv@Base 8.0.1
  (optional=templinst|arch=alpha amd64 arm64 ia64 loong64 mips64el ppc64 ppc64el s390x)_ZNSt16_Sp_counted_baseILN9__gnu_cxx12_Lock_policyE2EE24_M_release_last_use_coldEv@Base 8.0.0
  (optional=templinst|arch=alpha amd64 arm64 ia64 loong64 mips64el ppc64 ppc64el s390x sparc64)_ZNSt23_Sp_counted_ptr_inplaceIN11ms_nlohmann10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS0_14adl_serializerES3_IhSaIhEEEESaIvELN9__gnu_cxx12_Lock_policyE2EE10_M_destroyEv@Base 8.0.0
  (optional=templinst|arch=alpha amd64 arm64 ia64 loong64 mips64el ppc64 ppc64el s390x sparc64)_ZNSt23_Sp_counted_ptr_inplaceIN11ms_nlohmann10basic_jsonISt3mapSt6vectorNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEblmdSaNS0_14adl_serializerES3_IhSaIhEEEESaIvELN9__gnu_cxx12_Lock_policyE2EE10_M_disposeEv@Base 8.0.0
@@ -1252,6 +1254,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  (optional=templinst|arch=!armel !riscv64)_ZNSt23_Sp_counted_ptr_inplaceIN4inja8TextNodeESaIvELN9__gnu_cxx12_Lock_policyE2EED2Ev@Base 8.0.0
  (optional=templinst|arch=alpha amd64 arm64 armel armhf i386 ia64 loong64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sparc64|subst)_ZNSt3mapINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEN11ms_nlohmann10basic_jsonIS_St6vectorS5_b{int64_t}{uint64_t}dSaNS6_14adl_serializerES8_IhSaIhEEEESt4lessIS5_ESaISt4pairIKS5_SC_EEEixERSG_@Base 8.0.1
  (optional=templinst|arch=amd64 arm64)_ZNSt3mapINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEN4inja8TemplateESt4lessIS5_ESaISt4pairIKS5_S7_EEEixERSB_@Base 8.0.1
+ (optional=templinst)_ZNSt3mapINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEES5_St4lessIS5_ESaISt4pairIKS5_S5_EEEixEOS5_@Base 8.2.0~beta1
  (optional=templinst)_ZNSt3mapISt4pairINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEiEN4inja15FunctionStorage12FunctionDataESt4lessIS7_ESaIS0_IKS7_SA_EEEC1ESt16initializer_listISE_ERKSC_RKSF_@Base 8.0.0
  (optional=templinst)_ZNSt3mapISt4pairINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEiEN4inja15FunctionStorage12FunctionDataESt4lessIS7_ESaIS0_IKS7_SA_EEEC2ESt16initializer_listISE_ERKSC_RKSF_@Base 8.0.0
  (optional=templinst|arch=alpha amd64 arm64 armel armhf i386 ia64 loong64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sparc64)_ZNSt4pairIKS_INSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEiEN4inja15FunctionStorage12FunctionDataEEC1IS_IPKciESA_Lb1EEEOT_OT0_@Base 8.0.0
@@ -1417,6 +1420,8 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  (optional=templinst)_ZNSt8_Rb_treeINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEESt4pairIKS5_N4inja8TemplateEESt10_Select1stISA_ESt4lessIS5_ESaISA_EE24_M_get_insert_unique_posERS7_@Base 8.0.0
  (optional=templinst|arch=amd64 arm64 ia64 loong64 m68k mips64el ppc64el riscv64 sparc64)_ZNSt8_Rb_treeINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEESt4pairIKS5_N4inja8TemplateEESt10_Select1stISA_ESt4lessIS5_ESaISA_EE29_M_get_insert_hint_unique_posESt23_Rb_tree_const_iteratorISA_ERS7_@Base 8.0.0
  (optional=templinst)_ZNSt8_Rb_treeINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEESt4pairIKS5_N4inja8TemplateEESt10_Select1stISA_ESt4lessIS5_ESaISA_EE4findERS7_@Base 8.0.0
+ (optional=templinst)_ZNSt8_Rb_treeINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEESt4pairIKS5_S5_ESt10_Select1stIS8_ESt4lessIS5_ESaIS8_EE24_M_get_insert_unique_posERS7_@Base 8.2.0~beta1
+ (optional=templinst)_ZNSt8_Rb_treeINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEESt4pairIKS5_S5_ESt10_Select1stIS8_ESt4lessIS5_ESaIS8_EE29_M_get_insert_hint_unique_posESt23_Rb_tree_const_iteratorIS8_ERS7_@Base 8.2.0~beta1
  (optional=templinst)_ZNSt8_Rb_treeINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEESt4pairIKS5_St10shared_ptrIN4inja18BlockStatementNodeEEESt10_Select1stISC_ESt4lessIS5_ESaISC_EE17_M_emplace_uniqueIJRS7_RSB_EEES6_ISt17_Rb_tree_iteratorISC_EbEDpOT_@Base 8.0.0
  (optional=templinst)_ZNSt8_Rb_treeISt4pairINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEiES0_IKS7_N4inja15FunctionStorage12FunctionDataEESt10_Select1stISC_ESt4lessIS7_ESaISC_EE24_M_get_insert_unique_posERS8_@Base 8.0.0
  (optional=templinst|arch=amd64 arm64 ia64 loong64 m68k mips64el ppc64el riscv64 sparc64)_ZNSt8_Rb_treeISt4pairINSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEEiES0_IKS7_N4inja15FunctionStorage12FunctionDataEESt10_Select1stISC_ESt4lessIS7_ESaISC_EE29_M_get_insert_hint_unique_posESt23_Rb_tree_const_iteratorISC_ERS8_@Base 8.0.0
@@ -1773,7 +1778,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  escape_shell_cmd@Base 6.2.1
  fastComputeBounds@Base 6.2.1
  findChartPoint@Base 6.2.1
- findTag@Base 6.2.1
  findTagEnd@Base 6.2.1
  flatgeobuf_check_magicbytes@Base 8.0.0
  flatgeobuf_decode_feature@Base 8.0.0
@@ -1828,7 +1832,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  generateLegendTemplate@Base 6.2.1
  getCharacter@Base 6.2.1
  getDouble@Base 6.2.1
- getInlineTag@Base 6.2.1
  getInteger@Base 6.2.1
  getIntegerOrSymbol@Base 6.2.1
  getKmlRenderer@Base 6.4.0
@@ -1841,7 +1844,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  getString@Base 6.2.1
  getSymbol2@Base 6.2.1
  getSymbol@Base 6.2.1
- getTagArgs@Base 6.2.1
  getTile@Base 6.2.1
  getTruetypeTextBBoxDummy@Base 6.2.1
  get_hb_font@Base 7.0.0
@@ -2512,6 +2514,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msLayerGetPaging@Base 6.2.1
  msLayerGetProcessing@Base 6.2.1
  msLayerGetProcessingKey@Base 6.2.1
+ msLayerGetReprojectorToMap@Base 8.2.0~beta1
  msLayerGetShape@Base 6.2.1
  msLayerGetShapeCount@Base 7.2.0
  msLayerInitItemInfo@Base 6.2.1
@@ -2558,6 +2561,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msLoadMapContextURL@Base 6.2.1
  msLoadMapContextURLELements@Base 6.2.1
  msLoadMapFromString@Base 6.2.1
+ msLoadProjectionCodeString@Base 8.2.0~beta1
  msLoadProjectionString@Base 6.2.1
  msLoadProjectionStringEPSG@Base 6.2.1
  msLoadQuery@Base 6.2.1
@@ -2756,6 +2760,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msProjectCreateReprojector@Base 7.6.0
  msProjectDestroyReprojector@Base 7.6.0
  msProjectHasLonWrap@Base 7.0.7
+ msProjectIsReprojectorStillValid@Base 8.2.0~beta1
  msProjectLine@Base 6.2.1
  msProjectLineEx@Base 7.6.0
  msProjectPoint@Base 6.2.1
@@ -2805,7 +2810,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msRectToFormattedString@Base 6.2.1
  msRectToPolygon@Base 6.2.1
  msRedactCredentials@Base 8.0.1
- msRedactString@Base 8.0.1
  msRedirect@Base 6.2.1
  msReleaseLock@Base 6.2.1
  msRemoveClass@Base 6.2.1
@@ -2862,33 +2866,21 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msSHPReadShape@Base 6.2.1
  msSHPWritePoint@Base 6.2.1
  msSHPWriteShape@Base 6.2.1
+ msSLDApplyFromFile@Base 8.2.0~beta1
  msSLDApplySLD@Base 6.2.1
  msSLDApplySLDURL@Base 6.2.1
- msSLDBuildFilterEncoding@Base 6.2.1
- msSLDConvertRegexExpToOgcIsLike@Base 6.2.1
  msSLDGenerateLineSLD@Base 6.2.1
  msSLDGeneratePointSLD@Base 6.2.1
  msSLDGeneratePolygonSLD@Base 6.2.1
  msSLDGenerateSLD@Base 6.2.1
  msSLDGenerateSLDLayer@Base 6.2.1
  msSLDGenerateTextSLD@Base 6.2.1
- msSLDGetAttributeName@Base 6.2.1
- msSLDGetAttributeNameOrValue@Base 6.2.1
- msSLDGetAttributeValue@Base 6.2.1
- msSLDGetComparisonValue@Base 6.2.1
  msSLDGetFilter@Base 6.2.1
- msSLDGetGraphicSLD@Base 6.2.1
  msSLDGetGraphicSymbol@Base 6.2.1
- msSLDGetLeftExpressionOfOperator@Base 6.2.1
- msSLDGetLogicalOperator@Base 6.2.1
  msSLDGetMarkSymbol@Base 6.2.1
- msSLDGetRightExpressionOfOperator@Base 6.2.1
- msSLDNumberOfLogicalOperators@Base 6.2.1
- msSLDParseExpression@Base 6.2.1
  msSLDParseExternalGraphic@Base 6.2.1
  msSLDParseGraphicFillOrStroke@Base 6.2.1
  msSLDParseLineSymbolizer@Base 6.2.1
- msSLDParseLogicalExpression@Base 6.2.1
  msSLDParseNamedLayer@Base 6.2.1
  msSLDParseOgcExpression@Base 7.6.0
  msSLDParsePointSymbolizer@Base 6.2.1
@@ -2900,7 +2892,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msSLDParseStroke@Base 6.2.1
  msSLDParseTextParams@Base 6.2.1
  msSLDParseTextSymbolizer@Base 6.2.1
- msSLDParseUomAttribute@Base 8.0.0
  msSLDSetColorObject@Base 6.2.1
  msSOSAddDataBlockDefinition@Base 6.2.1
  msSOSAddGeometryNode@Base 6.2.1
diff -pruN 8.0.1-5/debian/mapserver-doc.docs 8.2.0~beta1-1~exp1/debian/mapserver-doc.docs
--- 8.0.1-5/debian/mapserver-doc.docs	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/mapserver-doc.docs	2024-06-07 05:06:59.000000000 +0000
@@ -2,4 +2,4 @@ README.md
 fonts
 symbols
 MIGRATION_GUIDE.md
-xmlmapfile
+src/xmlmapfile
diff -pruN 8.0.1-5/debian/patches/glibc-strlcat.patch 8.2.0~beta1-1~exp1/debian/patches/glibc-strlcat.patch
--- 8.0.1-5/debian/patches/glibc-strlcat.patch	2024-03-25 15:42:21.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/patches/glibc-strlcat.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,19 +0,0 @@
-Description: Add -D_DEFAULT_SOURCE for strlcat/strlcpy provided by glibc >= 2.38.
-Author: Bas Couwenberg <sebastic@debian.org>
-Bug-Debian: https://bugs.debian.org/1067651
-Forwarded: https://github.com/MapServer/MapServer/pull/7055
-Applied-Upstream: https://github.com/MapServer/MapServer/commit/4531150ed15354c7b6e03bb3a7df8389a0908057
-
---- a/CMakeLists.txt
-+++ b/CMakeLists.txt
-@@ -121,6 +121,10 @@ check_function_exists("strlcpy"  HAVE_ST
- check_function_exists("strlen"  HAVE_STRLEN)
- check_function_exists("strncasecmp"  HAVE_STRNCASECMP)
- 
-+IF((HAVE_STRLCAT OR HAVE_STRLCPY) AND CMAKE_SYSTEM_NAME MATCHES "Linux")
-+    add_definitions(-D_DEFAULT_SOURCE)
-+ENDIF()
-+
- check_symbol_exists(vsnprintf stdio.h HAVE_VSNPRINTF)
- IF(NOT HAVE_VSNPRINTF)
-     check_function_exists("vsnprintf"  HAVE_VSNPRINTF)
diff -pruN 8.0.1-5/debian/patches/java-hardening.patch 8.2.0~beta1-1~exp1/debian/patches/java-hardening.patch
--- 8.0.1-5/debian/patches/java-hardening.patch	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/patches/java-hardening.patch	2024-06-07 05:06:59.000000000 +0000
@@ -4,8 +4,8 @@ Author: Ezequiel Lara Gómez <ezequiel.l
 Bug-Debian: https://bugs.debian.org/740351
 Forwarded: not-needed
 
---- a/mapscript/java/CMakeLists.txt
-+++ b/mapscript/java/CMakeLists.txt
+--- a/src/mapscript/java/CMakeLists.txt
++++ b/src/mapscript/java/CMakeLists.txt
 @@ -26,6 +26,23 @@ else ()
      swig_add_module(javamapscript java ../mapscript.i)
  endif ()
diff -pruN 8.0.1-5/debian/patches/perl-mapscript-install.patch 8.2.0~beta1-1~exp1/debian/patches/perl-mapscript-install.patch
--- 8.0.1-5/debian/patches/perl-mapscript-install.patch	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/patches/perl-mapscript-install.patch	2024-06-07 05:06:59.000000000 +0000
@@ -1,10 +1,9 @@
 Description: Fix the Perl mapscript module installation directory.
 Author: Bas Couwenberg <sebastic@debian.org>
-Last-Update: 2013-09-02
 Forwarded: not-needed
 
---- a/mapscript/perl/CMakeLists.txt
-+++ b/mapscript/perl/CMakeLists.txt
+--- a/src/mapscript/perl/CMakeLists.txt
++++ b/src/mapscript/perl/CMakeLists.txt
 @@ -2,7 +2,8 @@ find_package(SWIG REQUIRED)
  include(${SWIG_USE_FILE})
  find_package(Perl REQUIRED)
@@ -13,8 +12,8 @@ Forwarded: not-needed
 +set(CUSTOM_PERL_VENDOR_ARCH_DIR ${PERL_VENDORARCH} CACHE STRING "Custom installation directory for perl binary extension")
 +
  include_directories(${PERL_INCLUDE_PATH})
- include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
- include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
+ include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
+ include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
 @@ -23,8 +24,8 @@ if(APPLE)
    set_target_properties(perlmapscript PROPERTIES SUFFIX ".bundle")
  endif(APPLE)
diff -pruN 8.0.1-5/debian/patches/python-mapscript-install.patch 8.2.0~beta1-1~exp1/debian/patches/python-mapscript-install.patch
--- 8.0.1-5/debian/patches/python-mapscript-install.patch	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/patches/python-mapscript-install.patch	2024-06-07 05:06:59.000000000 +0000
@@ -0,0 +1,16 @@
+Description: Fix Python MapScript installation.
+ ERROR: You must give at least one requirement to install (see "pip help install")
+Author: Bas Couwenberg <sebastic@debian.org>
+Forwarded: https://github.com/MapServer/MapServer/pull/7071
+
+--- a/src/mapscript/python/CMakeLists.txt
++++ b/src/mapscript/python/CMakeLists.txt
+@@ -122,7 +122,7 @@ install(
+     endif()
+ 
+     execute_process(
+-      COMMAND ${Python_EXECUTABLE} -m pip install \${PYTHON_ROOT} \${PYTHON_PREFIX}
++      COMMAND ${Python_EXECUTABLE} -m pip install \${PYTHON_ROOT} \${PYTHON_PREFIX} .
+       WORKING_DIRECTORY ${OUTPUT_FOLDER}
+     )
+   "
diff -pruN 8.0.1-5/debian/patches/series 8.2.0~beta1-1~exp1/debian/patches/series
--- 8.0.1-5/debian/patches/series	2024-03-25 10:05:45.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/patches/series	2024-06-07 05:06:59.000000000 +0000
@@ -1,4 +1,4 @@
 perl-mapscript-install.patch
 java-hardening.patch
+python-mapscript-install.patch
 spelling-errors.patch
-glibc-strlcat.patch
diff -pruN 8.0.1-5/debian/patches/spelling-errors.patch 8.2.0~beta1-1~exp1/debian/patches/spelling-errors.patch
--- 8.0.1-5/debian/patches/spelling-errors.patch	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/patches/spelling-errors.patch	2024-06-07 05:06:59.000000000 +0000
@@ -1,17 +1,16 @@
 Description: Fix spelling errors.
- * suported -> supported
+ instanciate -> instantiate
 Author: Bas Couwenberg <sebastic@debian.org>
-Forwarded: https://github.com/MapServer/MapServer/pull/6869
-Applied-Upstream: https://github.com/MapServer/MapServer/commit/4caca40c620d425a82091b5a094eb7fd2821271f
+Forwarded: https://github.com/MapServer/MapServer/pull/7072
 
---- a/mapshape.c
-+++ b/mapshape.c
-@@ -234,7 +234,7 @@ SHPHandle msSHPOpenVirtualFile( VSILFILE
-       VSIFSeekL( psSHP->fpSHP, 0, SEEK_END );
-       vsi_l_offset nSize = VSIFTellL( psSHP->fpSHP );
-       if( nSize > (vsi_l_offset)INT_MAX ) {
--          msDebug("Actual .shp size is larger than 2 GB. Not suported. Invalidating nFileSize");
-+          msDebug("Actual .shp size is larger than 2 GB. Not supported. Invalidating nFileSize");
-           psSHP->nFileSize = 0;
-       }
-       else
+--- a/src/mapogcapi.cpp
++++ b/src/mapogcapi.cpp
+@@ -1217,7 +1217,7 @@ static int processCollectionItemsRequest
+ 
+   msProjectionInheritContextFrom(&reprObjs.proj, &(map->projection));
+   if (msLoadProjectionString(&reprObjs.proj, outputCrs.c_str()) != 0) {
+-    outputError(OGCAPI_SERVER_ERROR, "Cannot instanciate output CRS.");
++    outputError(OGCAPI_SERVER_ERROR, "Cannot instantiate output CRS.");
+     return MS_SUCCESS;
+   }
+ 
diff -pruN 8.0.1-5/debian/python3-mapscript.examples 8.2.0~beta1-1~exp1/debian/python3-mapscript.examples
--- 8.0.1-5/debian/python3-mapscript.examples	2024-03-25 10:04:46.000000000 +0000
+++ 8.2.0~beta1-1~exp1/debian/python3-mapscript.examples	2024-06-07 05:06:59.000000000 +0000
@@ -1 +1 @@
-mapscript/python/examples/*
+src/mapscript/python/examples/*
diff -pruN 8.0.1-5/dejavu-sans-condensed.h 8.2.0~beta1-1~exp1/dejavu-sans-condensed.h
--- 8.0.1-5/dejavu-sans-condensed.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/dejavu-sans-condensed.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,46158 +0,0 @@
-/*
-Fonts are (c) Bitstream (see below). DejaVu changes are in public domain.
-Glyphs imported from Arev fonts are (c) Tavmjong Bah (see below)
-
-Bitstream Vera Fonts Copyright
-------------------------------
-
-Copyright (c) 2003 by Bitstream, Inc. All Rights Reserved. Bitstream Vera is
-a trademark of Bitstream, Inc.
-
-Permission is hereby granted, free of charge, to any person obtaining a copy
-of the fonts accompanying this license ("Fonts") and associated
-documentation files (the "Font Software"), to reproduce and distribute the
-Font Software, including without limitation the rights to use, copy, merge,
-publish, distribute, and/or sell copies of the Font Software, and to permit
-persons to whom the Font Software is furnished to do so, subject to the
-following conditions:
-
-The above copyright and trademark notices and this permission notice shall
-be included in all copies of one or more of the Font Software typefaces.
-
-The Font Software may be modified, altered, or added to, and in particular
-the designs of glyphs or characters in the Fonts may be modified and
-additional glyphs or characters may be added to the Fonts, only if the fonts
-are renamed to names not containing either the words "Bitstream" or the word
-"Vera".
-
-This License becomes null and void to the extent applicable to Fonts or Font
-Software that has been modified and is distributed under the "Bitstream
-Vera" names.
-
-The Font Software may be sold as part of a larger software package but no
-copy of one or more of the Font Software typefaces may be sold by itself.
-
-THE FONT SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OF MERCHANTABILITY,
-FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF COPYRIGHT, PATENT,
-TRADEMARK, OR OTHER RIGHT. IN NO EVENT SHALL BITSTREAM OR THE GNOME
-FOUNDATION BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, INCLUDING
-ANY GENERAL, SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
-WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
-THE USE OR INABILITY TO USE THE FONT SOFTWARE OR FROM OTHER DEALINGS IN THE
-FONT SOFTWARE.
-
-Except as contained in this notice, the names of Gnome, the Gnome
-Foundation, and Bitstream Inc., shall not be used in advertising or
-otherwise to promote the sale, use or other dealings in this Font Software
-without prior written authorization from the Gnome Foundation or Bitstream
-Inc., respectively. For further information, contact: fonts at gnome dot
-org.
-
-Arev Fonts Copyright
-------------------------------
-
-Copyright (c) 2006 by Tavmjong Bah. All Rights Reserved.
-
-Permission is hereby granted, free of charge, to any person obtaining
-a copy of the fonts accompanying this license ("Fonts") and
-associated documentation files (the "Font Software"), to reproduce
-and distribute the modifications to the Bitstream Vera Font Software,
-including without limitation the rights to use, copy, merge, publish,
-distribute, and/or sell copies of the Font Software, and to permit
-persons to whom the Font Software is furnished to do so, subject to
-the following conditions:
-
-The above copyright and trademark notices and this permission notice
-shall be included in all copies of one or more of the Font Software
-typefaces.
-
-The Font Software may be modified, altered, or added to, and in
-particular the designs of glyphs or characters in the Fonts may be
-modified and additional glyphs or characters may be added to the
-Fonts, only if the fonts are renamed to names not containing either
-the words "Tavmjong Bah" or the word "Arev".
-
-This License becomes null and void to the extent applicable to Fonts
-or Font Software that has been modified and is distributed under the
-"Tavmjong Bah Arev" names.
-
-The Font Software may be sold as part of a larger software package but
-no copy of one or more of the Font Software typefaces may be sold by
-itself.
-
-THE FONT SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OF
-MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
-OF COPYRIGHT, PATENT, TRADEMARK, OR OTHER RIGHT. IN NO EVENT SHALL
-TAVMJONG BAH BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-INCLUDING ANY GENERAL, SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL
-DAMAGES, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-FROM, OUT OF THE USE OR INABILITY TO USE THE FONT SOFTWARE OR FROM
-OTHER DEALINGS IN THE FONT SOFTWARE.
-
-Except as contained in this notice, the name of Tavmjong Bah shall not
-be used in advertising or otherwise to promote the sale, use or other
-dealings in this Font Software without prior written authorization
-from Tavmjong Bah. For further information, contact: tavmjong @ free
-. fr.
-*/
-#ifndef _DEJAVU_SANS_CONDENSED_H
-#define _DEJAVU_SANS_CONDENSED_H
-/* to regenerate this file, use the `xxd -i` command */
-unsigned char dejavu_sans_condensed_ttf[] = {
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x13, 0x01, 0x00, 0x00, 0x04, 0x00, 0x30,
-  0x46, 0x46, 0x54, 0x4d, 0x66, 0x09, 0x1f, 0xf9, 0x00, 0x00, 0x01, 0x3c,
-  0x00, 0x00, 0x00, 0x1c, 0x47, 0x44, 0x45, 0x46, 0xc3, 0x10, 0xc5, 0x70,
-  0x00, 0x00, 0x01, 0x58, 0x00, 0x00, 0x01, 0xc2, 0x47, 0x50, 0x4f, 0x53,
-  0xfc, 0xcc, 0xe2, 0x8c, 0x00, 0x00, 0x03, 0x1c, 0x00, 0x00, 0x70, 0xc4,
-  0x47, 0x53, 0x55, 0x42, 0x81, 0x22, 0xfe, 0xaf, 0x00, 0x00, 0x73, 0xe0,
-  0x00, 0x00, 0x0d, 0x50, 0x4f, 0x53, 0x2f, 0x32, 0x8d, 0x18, 0xe6, 0xc7,
-  0x00, 0x00, 0x81, 0x30, 0x00, 0x00, 0x00, 0x56, 0x63, 0x6d, 0x61, 0x70,
-  0x26, 0x77, 0xbd, 0xfb, 0x00, 0x00, 0x81, 0x88, 0x00, 0x00, 0x0e, 0x0e,
-  0x63, 0x76, 0x74, 0x20, 0x00, 0x69, 0x1d, 0x39, 0x00, 0x00, 0x8f, 0x98,
-  0x00, 0x00, 0x01, 0xfe, 0x66, 0x70, 0x67, 0x6d, 0x71, 0x34, 0x76, 0x6a,
-  0x00, 0x00, 0x91, 0x98, 0x00, 0x00, 0x00, 0xab, 0x67, 0x61, 0x73, 0x70,
-  0x00, 0x07, 0x00, 0x07, 0x00, 0x00, 0x92, 0x44, 0x00, 0x00, 0x00, 0x0c,
-  0x67, 0x6c, 0x79, 0x66, 0xbf, 0x93, 0x97, 0x69, 0x00, 0x00, 0x92, 0x50,
-  0x00, 0x06, 0x16, 0x80, 0x68, 0x65, 0x61, 0x64, 0x00, 0x93, 0x52, 0xd5,
-  0x00, 0x06, 0xa8, 0xd0, 0x00, 0x00, 0x00, 0x36, 0x68, 0x68, 0x65, 0x61,
-  0x0c, 0x31, 0x19, 0x73, 0x00, 0x06, 0xa9, 0x08, 0x00, 0x00, 0x00, 0x24,
-  0x68, 0x6d, 0x74, 0x78, 0xd6, 0x38, 0x75, 0x2e, 0x00, 0x06, 0xa9, 0x2c,
-  0x00, 0x00, 0x48, 0x38, 0x6b, 0x65, 0x72, 0x6e, 0x87, 0x38, 0x36, 0x5f,
-  0x00, 0x06, 0xf1, 0x64, 0x00, 0x00, 0x3f, 0xfc, 0x6c, 0x6f, 0x63, 0x61,
-  0x2b, 0x97, 0xe6, 0xcc, 0x00, 0x07, 0x31, 0x60, 0x00, 0x00, 0x48, 0x3c,
-  0x6d, 0x61, 0x78, 0x70, 0x16, 0x7b, 0x04, 0x5b, 0x00, 0x07, 0x79, 0x9c,
-  0x00, 0x00, 0x00, 0x20, 0x6e, 0x61, 0x6d, 0x65, 0xf0, 0xf9, 0x25, 0x82,
-  0x00, 0x07, 0x79, 0xbc, 0x00, 0x00, 0x3d, 0xc5, 0x70, 0x6f, 0x73, 0x74,
-  0x6b, 0x1b, 0xc9, 0x76, 0x00, 0x07, 0xb7, 0x84, 0x00, 0x00, 0xb1, 0xbd,
-  0x70, 0x72, 0x65, 0x70, 0x3b, 0x07, 0xf1, 0x00, 0x00, 0x08, 0x69, 0x44,
-  0x00, 0x00, 0x05, 0x68, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
-  0xc9, 0x89, 0x6f, 0x31, 0x00, 0x00, 0x00, 0x00, 0xce, 0x3f, 0xd8, 0x63,
-  0x00, 0x00, 0x00, 0x00, 0xce, 0x3f, 0xd8, 0x64, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x0e, 0x00, 0x00, 0x01, 0x56, 0x01, 0x5e, 0x00, 0x00, 0x00, 0x02,
-  0x00, 0x36, 0x00, 0x03, 0x02, 0xb0, 0x00, 0x01, 0x02, 0xb1, 0x02, 0xc5,
-  0x00, 0x03, 0x02, 0xc6, 0x02, 0xc6, 0x00, 0x01, 0x02, 0xc7, 0x02, 0xca,
-  0x00, 0x03, 0x02, 0xcb, 0x02, 0xcc, 0x00, 0x01, 0x02, 0xcd, 0x02, 0xd1,
-  0x00, 0x03, 0x02, 0xd2, 0x02, 0xd3, 0x00, 0x01, 0x02, 0xd4, 0x02, 0xe4,
-  0x00, 0x03, 0x02, 0xe5, 0x02, 0xe9, 0x00, 0x01, 0x02, 0xea, 0x02, 0xf3,
-  0x00, 0x03, 0x02, 0xf4, 0x02, 0xf4, 0x00, 0x01, 0x02, 0xf5, 0x02, 0xf5,
-  0x00, 0x03, 0x02, 0xf6, 0x02, 0xf6, 0x00, 0x01, 0x02, 0xf7, 0x02, 0xff,
-  0x00, 0x03, 0x03, 0x00, 0x03, 0x00, 0x00, 0x01, 0x03, 0x01, 0x03, 0x04,
-  0x00, 0x03, 0x03, 0x05, 0x03, 0x05, 0x00, 0x01, 0x03, 0x06, 0x03, 0x06,
-  0x00, 0x03, 0x03, 0x07, 0x03, 0x07, 0x00, 0x01, 0x03, 0x08, 0x03, 0x09,
-  0x00, 0x03, 0x03, 0x0a, 0x03, 0x0a, 0x00, 0x01, 0x03, 0x0b, 0x03, 0x0c,
-  0x00, 0x03, 0x03, 0x0d, 0x04, 0x16, 0x00, 0x01, 0x04, 0x17, 0x04, 0x1b,
-  0x00, 0x03, 0x04, 0x1c, 0x05, 0x49, 0x00, 0x01, 0x05, 0x4a, 0x05, 0x4f,
-  0x00, 0x03, 0x05, 0x50, 0x07, 0x70, 0x00, 0x01, 0x07, 0x71, 0x07, 0x71,
-  0x00, 0x02, 0x07, 0x72, 0x07, 0x7b, 0x00, 0x01, 0x07, 0x7c, 0x07, 0x7e,
-  0x00, 0x02, 0x07, 0x7f, 0x07, 0xd1, 0x00, 0x01, 0x07, 0xd2, 0x07, 0xd2,
-  0x00, 0x02, 0x07, 0xd3, 0x07, 0xe2, 0x00, 0x01, 0x07, 0xe3, 0x07, 0xe9,
-  0x00, 0x03, 0x07, 0xea, 0x07, 0xea, 0x00, 0x02, 0x07, 0xeb, 0x07, 0xee,
-  0x00, 0x01, 0x07, 0xef, 0x07, 0xf0, 0x00, 0x02, 0x07, 0xf1, 0x08, 0x08,
-  0x00, 0x01, 0x08, 0x09, 0x08, 0x0a, 0x00, 0x02, 0x08, 0x0b, 0x08, 0x23,
-  0x00, 0x01, 0x08, 0x24, 0x08, 0x24, 0x00, 0x02, 0x08, 0x25, 0x0f, 0x08,
-  0x00, 0x01, 0x0f, 0x09, 0x0f, 0x0f, 0x00, 0x02, 0x0f, 0x10, 0x0f, 0x10,
-  0x00, 0x01, 0x0f, 0x11, 0x0f, 0x11, 0x00, 0x03, 0x0f, 0x12, 0x0f, 0x12,
-  0x00, 0x01, 0x0f, 0x13, 0x0f, 0x13, 0x00, 0x03, 0x0f, 0x14, 0x10, 0xea,
-  0x00, 0x01, 0x10, 0xeb, 0x10, 0xf5, 0x00, 0x03, 0x10, 0xf6, 0x11, 0x49,
-  0x00, 0x01, 0x11, 0x4a, 0x11, 0x51, 0x00, 0x03, 0x11, 0x52, 0x11, 0xab,
-  0x00, 0x01, 0x11, 0xac, 0x11, 0xac, 0x00, 0x03, 0x11, 0xad, 0x12, 0x0d,
-  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x02,
-  0x00, 0x10, 0x02, 0xb1, 0x02, 0xc6, 0x00, 0x01, 0x02, 0xc7, 0x02, 0xca,
-  0x00, 0x02, 0x02, 0xcd, 0x02, 0xd7, 0x00, 0x02, 0x02, 0xd8, 0x02, 0xd8,
-  0x00, 0x03, 0x02, 0xd9, 0x02, 0xd9, 0x00, 0x04, 0x02, 0xda, 0x02, 0xe4,
-  0x00, 0x02, 0x02, 0xea, 0x02, 0xed, 0x00, 0x02, 0x02, 0xee, 0x02, 0xf5,
-  0x00, 0x01, 0x02, 0xf6, 0x02, 0xf6, 0x00, 0x02, 0x02, 0xf7, 0x02, 0xf7,
-  0x00, 0x01, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x02, 0x02, 0xfb, 0x02, 0xfd,
-  0x00, 0x01, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x02, 0x03, 0x01, 0x03, 0x02,
-  0x00, 0x01, 0x03, 0x03, 0x03, 0x03, 0x00, 0x02, 0x03, 0x04, 0x03, 0x04,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0a, 0x01, 0xd8,
-  0x02, 0x32, 0x00, 0x14, 0x44, 0x46, 0x4c, 0x54, 0x00, 0x7a, 0x61, 0x72,
-  0x61, 0x62, 0x00, 0x86, 0x61, 0x72, 0x6d, 0x6e, 0x00, 0xa8, 0x62, 0x72,
-  0x61, 0x69, 0x00, 0xb4, 0x63, 0x61, 0x6e, 0x73, 0x00, 0xc0, 0x63, 0x68,
-  0x65, 0x72, 0x00, 0xcc, 0x63, 0x79, 0x72, 0x6c, 0x00, 0xd8, 0x67, 0x65,
-  0x6f, 0x72, 0x00, 0xf4, 0x67, 0x72, 0x65, 0x6b, 0x01, 0x00, 0x68, 0x61,
-  0x6e, 0x69, 0x01, 0x10, 0x68, 0x65, 0x62, 0x72, 0x01, 0x1c, 0x6b, 0x61,
-  0x6e, 0x61, 0x01, 0x2a, 0x6c, 0x61, 0x6f, 0x20, 0x01, 0x36, 0x6c, 0x61,
-  0x74, 0x6e, 0x01, 0x42, 0x6d, 0x61, 0x74, 0x68, 0x01, 0x82, 0x6e, 0x6b,
-  0x6f, 0x20, 0x01, 0x8e, 0x6f, 0x67, 0x61, 0x6d, 0x01, 0x9c, 0x72, 0x75,
-  0x6e, 0x72, 0x01, 0xa8, 0x74, 0x66, 0x6e, 0x67, 0x01, 0xb4, 0x74, 0x68,
-  0x61, 0x69, 0x01, 0xc2, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x16, 0x00, 0x03, 0x4b, 0x55, 0x52, 0x20,
-  0x00, 0x16, 0x53, 0x4e, 0x44, 0x20, 0x00, 0x16, 0x55, 0x52, 0x44, 0x20,
-  0x00, 0x16, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x10, 0x00, 0x02, 0x4d, 0x4b, 0x44, 0x20, 0x00, 0x10,
-  0x53, 0x52, 0x42, 0x20, 0x00, 0x10, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
-  0x00, 0x00, 0x00, 0x03, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0x06, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x00, 0x02,
-  0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x34, 0x00, 0x08, 0x49, 0x53, 0x4d, 0x20, 0x00, 0x34, 0x4b, 0x53,
-  0x4d, 0x20, 0x00, 0x34, 0x4c, 0x53, 0x4d, 0x20, 0x00, 0x34, 0x4d, 0x4f,
-  0x4c, 0x20, 0x00, 0x34, 0x4e, 0x53, 0x4d, 0x20, 0x00, 0x34, 0x52, 0x4f,
-  0x4d, 0x20, 0x00, 0x34, 0x53, 0x4b, 0x53, 0x20, 0x00, 0x34, 0x53, 0x53,
-  0x4d, 0x20, 0x00, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x01,
-  0x00, 0x03, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x02, 0x00, 0x00, 0x00, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x07, 0x6b, 0x65,
-  0x72, 0x6e, 0x00, 0x2c, 0x6b, 0x65, 0x72, 0x6e, 0x00, 0x32, 0x6d, 0x61,
-  0x72, 0x6b, 0x00, 0x3a, 0x6d, 0x61, 0x72, 0x6b, 0x00, 0x40, 0x6d, 0x61,
-  0x72, 0x6b, 0x00, 0x48, 0x6d, 0x6b, 0x6d, 0x6b, 0x00, 0x4e, 0x6d, 0x6b,
-  0x6d, 0x6b, 0x00, 0x54, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x05, 0x00, 0x06, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02,
-  0x00, 0x00, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x07, 0x00, 0x10, 0x00, 0x18, 0x00, 0x22, 0x00, 0x2a,
-  0x00, 0x32, 0x00, 0x44, 0x00, 0x4c, 0x00, 0x06, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x44, 0x00, 0x06, 0x00, 0x04, 0x00, 0x02, 0x00, 0xf0, 0x03, 0xd0,
-  0x00, 0x04, 0x00, 0x01, 0x00, 0x01, 0x08, 0x86, 0x00, 0x05, 0x00, 0x00,
-  0x00, 0x01, 0x0f, 0xc0, 0x00, 0x04, 0x00, 0x04, 0x00, 0x06, 0x11, 0x72,
-  0x17, 0x1c, 0x17, 0x9c, 0x1b, 0x3a, 0x2c, 0x8e, 0x44, 0xde, 0x00, 0x02,
-  0x00, 0x00, 0x00, 0x01, 0x46, 0x1c, 0x00, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x6d, 0xca, 0x00, 0x01, 0x00, 0x58, 0x00, 0x4e, 0x00, 0x01, 0x00, 0x62,
-  0x00, 0x0c, 0x00, 0x08, 0x00, 0x12, 0x00, 0x18, 0x00, 0x1e, 0x00, 0x24,
-  0x00, 0x2a, 0x00, 0x30, 0x00, 0x36, 0x00, 0x3c, 0x00, 0x01, 0x01, 0xcc,
-  0x08, 0xfc, 0x00, 0x01, 0x01, 0xcc, 0x09, 0xc4, 0x00, 0x01, 0x01, 0xcc,
-  0x08, 0xfc, 0x00, 0x01, 0x01, 0xcc, 0x08, 0x34, 0x00, 0x01, 0x01, 0xcc,
-  0x09, 0xc4, 0x00, 0x01, 0x01, 0xcc, 0x08, 0x34, 0x00, 0x01, 0x01, 0xcc,
-  0x07, 0xd0, 0x00, 0x01, 0x01, 0xcc, 0x09, 0x60, 0x00, 0x02, 0x00, 0x01,
-  0x11, 0x4a, 0x11, 0x51, 0x00, 0x00, 0x00, 0x02, 0x00, 0x01, 0x11, 0x4a,
-  0x11, 0x51, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x22, 0x00, 0x00,
-  0x00, 0x28, 0x00, 0x00, 0x00, 0x2e, 0x00, 0x00, 0x00, 0x34, 0x00, 0x00,
-  0x00, 0x3a, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x46, 0x00, 0x00,
-  0x00, 0x4c, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0x5a, 0x01, 0x26, 0x00, 0x01, 0x01, 0x94,
-  0x00, 0x0c, 0x00, 0x23, 0x00, 0x48, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x5a,
-  0x00, 0x60, 0x00, 0x66, 0x00, 0x6c, 0x00, 0x72, 0x00, 0x78, 0x00, 0x7e,
-  0x00, 0x84, 0x00, 0x8a, 0x00, 0x90, 0x00, 0x96, 0x00, 0x9c, 0x00, 0xa2,
-  0x00, 0xa8, 0x00, 0xae, 0x00, 0xb4, 0x00, 0xba, 0x00, 0xc0, 0x00, 0xc6,
-  0x00, 0xcc, 0x00, 0xd2, 0x00, 0xd8, 0x00, 0xde, 0x00, 0xe4, 0x00, 0xea,
-  0x00, 0xf0, 0x00, 0xf6, 0x00, 0xfc, 0x01, 0x02, 0x01, 0x08, 0x01, 0x0e,
-  0x01, 0x14, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xde, 0x00, 0x01, 0xfe, 0x34,
-  0xfd, 0xde, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xda, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x89, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x89, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x89, 0x00, 0x01, 0xfe, 0x34,
-  0xfd, 0xda, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x14, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x74, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x74, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x1f, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x3b, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x18, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x38, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x38, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x38, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0xbf, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xda, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x1f, 0x00, 0x01, 0xfe, 0x35, 0xfe, 0x13, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x0b, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34,
-  0xfe, 0x13, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xda, 0x00, 0x02, 0x00, 0x08,
-  0x02, 0xc7, 0x02, 0xca, 0x00, 0x00, 0x02, 0xcd, 0x02, 0xd1, 0x00, 0x04,
-  0x02, 0xd4, 0x02, 0xe2, 0x00, 0x09, 0x02, 0xea, 0x02, 0xed, 0x00, 0x18,
-  0x02, 0xf8, 0x02, 0xfa, 0x00, 0x1c, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x1f,
-  0x03, 0x03, 0x03, 0x03, 0x00, 0x21, 0x03, 0x06, 0x03, 0x06, 0x00, 0x22,
-  0x00, 0x02, 0x00, 0x09, 0x02, 0xc7, 0x02, 0xca, 0x00, 0x00, 0x02, 0xcd,
-  0x02, 0xd1, 0x00, 0x04, 0x02, 0xd4, 0x02, 0xd7, 0x00, 0x09, 0x02, 0xda,
-  0x02, 0xe2, 0x00, 0x0d, 0x02, 0xea, 0x02, 0xed, 0x00, 0x16, 0x02, 0xf8,
-  0x02, 0xfa, 0x00, 0x1a, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x1d, 0x03, 0x03,
-  0x03, 0x03, 0x00, 0x1f, 0x03, 0x06, 0x03, 0x06, 0x00, 0x20, 0x00, 0x21,
-  0x00, 0x00, 0x00, 0x86, 0x00, 0x00, 0x00, 0x8c, 0x00, 0x00, 0x00, 0x92,
-  0x00, 0x00, 0x00, 0x98, 0x00, 0x00, 0x00, 0x9e, 0x00, 0x00, 0x00, 0xa4,
-  0x00, 0x00, 0x00, 0xaa, 0x00, 0x00, 0x00, 0xb0, 0x00, 0x00, 0x00, 0xb6,
-  0x00, 0x00, 0x00, 0xbc, 0x00, 0x00, 0x00, 0xc2, 0x00, 0x00, 0x00, 0xc8,
-  0x00, 0x00, 0x00, 0xce, 0x00, 0x00, 0x00, 0xd4, 0x00, 0x00, 0x00, 0xda,
-  0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00, 0xe6, 0x00, 0x00, 0x00, 0xec,
-  0x00, 0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0x00, 0xfe,
-  0x00, 0x00, 0x01, 0x04, 0x00, 0x00, 0x01, 0x0a, 0x00, 0x00, 0x01, 0x10,
-  0x00, 0x00, 0x01, 0x16, 0x00, 0x00, 0x01, 0x1c, 0x00, 0x00, 0x01, 0x22,
-  0x00, 0x00, 0x01, 0x28, 0x00, 0x00, 0x01, 0x2e, 0x00, 0x00, 0x01, 0x34,
-  0x00, 0x00, 0x01, 0x3a, 0x00, 0x00, 0x01, 0x40, 0x00, 0x00, 0x01, 0x46,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x35, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x42, 0x01, 0xde,
-  0x00, 0x01, 0x02, 0x8e, 0x00, 0x0c, 0x00, 0x3a, 0x00, 0x76, 0x00, 0x7c,
-  0x00, 0x82, 0x00, 0x88, 0x00, 0x8e, 0x00, 0x94, 0x00, 0x9a, 0x00, 0xa0,
-  0x00, 0xa6, 0x00, 0xac, 0x00, 0xb2, 0x00, 0xb8, 0x00, 0xbe, 0x00, 0xc4,
-  0x00, 0xca, 0x00, 0xd0, 0x00, 0xd6, 0x00, 0xdc, 0x00, 0xe2, 0x00, 0xe8,
-  0x00, 0xee, 0x00, 0xf4, 0x00, 0xfa, 0x01, 0x00, 0x01, 0x06, 0x01, 0x0c,
-  0x01, 0x12, 0x01, 0x18, 0x01, 0x1e, 0x01, 0x24, 0x01, 0x2a, 0x01, 0x30,
-  0x01, 0x36, 0x01, 0x3c, 0x01, 0x42, 0x01, 0x48, 0x01, 0x4e, 0x01, 0x54,
-  0x01, 0x5a, 0x01, 0x60, 0x01, 0x66, 0x01, 0x6c, 0x01, 0x72, 0x01, 0x78,
-  0x01, 0x7e, 0x01, 0x84, 0x01, 0x8a, 0x01, 0x90, 0x01, 0x96, 0x01, 0x9c,
-  0x01, 0xa2, 0x01, 0xa8, 0x01, 0xae, 0x01, 0xb4, 0x01, 0xba, 0x01, 0xc0,
-  0x01, 0xc6, 0x01, 0xcc, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x3d, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x44, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0xc5, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0xa8, 0x00, 0x01, 0xfe, 0x34, 0x06, 0xa8, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x56, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x44, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x93, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x3d, 0x00, 0x01,
-  0xfe, 0x34, 0x07, 0xd0, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x44, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x44, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
-  0xfe, 0x34, 0x07, 0x04, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0xda, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
-  0x00, 0x00, 0x07, 0x6e, 0x00, 0x01, 0x00, 0x00, 0x07, 0x6e, 0x00, 0x01,
-  0x00, 0x00, 0x07, 0x6e, 0x00, 0x01, 0x00, 0x00, 0x07, 0x6e, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xdb, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
-  0xfe, 0x34, 0x06, 0x1e, 0x00, 0x02, 0x00, 0x10, 0x02, 0xb1, 0x02, 0xc2,
-  0x00, 0x00, 0x02, 0xee, 0x02, 0xee, 0x00, 0x12, 0x02, 0xf0, 0x02, 0xf3,
-  0x00, 0x13, 0x02, 0xf5, 0x02, 0xf5, 0x00, 0x17, 0x02, 0xf7, 0x02, 0xf7,
-  0x00, 0x18, 0x02, 0xfb, 0x02, 0xfd, 0x00, 0x19, 0x03, 0x01, 0x03, 0x02,
-  0x00, 0x1c, 0x03, 0x04, 0x03, 0x04, 0x00, 0x1e, 0x03, 0x08, 0x03, 0x09,
-  0x00, 0x1f, 0x03, 0x0b, 0x03, 0x0c, 0x00, 0x21, 0x05, 0x4a, 0x05, 0x4f,
-  0x00, 0x23, 0x07, 0xe3, 0x07, 0xe9, 0x00, 0x29, 0x10, 0xeb, 0x10, 0xeb,
-  0x00, 0x30, 0x10, 0xed, 0x10, 0xed, 0x00, 0x31, 0x10, 0xef, 0x10, 0xf5,
-  0x00, 0x32, 0x11, 0xac, 0x11, 0xac, 0x00, 0x39, 0x00, 0x02, 0x00, 0x0c,
-  0x02, 0xb1, 0x02, 0xc2, 0x00, 0x00, 0x02, 0xee, 0x02, 0xee, 0x00, 0x12,
-  0x02, 0xf0, 0x02, 0xf3, 0x00, 0x13, 0x02, 0xf5, 0x02, 0xf5, 0x00, 0x17,
-  0x02, 0xf7, 0x02, 0xf7, 0x00, 0x18, 0x02, 0xfb, 0x02, 0xfd, 0x00, 0x19,
-  0x03, 0x01, 0x03, 0x02, 0x00, 0x1c, 0x03, 0x04, 0x03, 0x04, 0x00, 0x1e,
-  0x05, 0x4a, 0x05, 0x4f, 0x00, 0x1f, 0x07, 0xe3, 0x07, 0xe9, 0x00, 0x25,
-  0x10, 0xeb, 0x10, 0xf5, 0x00, 0x2c, 0x11, 0xac, 0x11, 0xac, 0x00, 0x37,
-  0x00, 0x38, 0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe8, 0x00, 0x00,
-  0x00, 0xee, 0x00, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x00, 0x00,
-  0x01, 0x00, 0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0c, 0x00, 0x00,
-  0x01, 0x12, 0x00, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x1e, 0x00, 0x00,
-  0x01, 0x24, 0x00, 0x00, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x30, 0x00, 0x00,
-  0x01, 0x36, 0x00, 0x00, 0x01, 0x3c, 0x00, 0x00, 0x01, 0x42, 0x00, 0x00,
-  0x01, 0x48, 0x00, 0x00, 0x01, 0x4e, 0x00, 0x00, 0x01, 0x54, 0x00, 0x00,
-  0x01, 0x5a, 0x00, 0x00, 0x01, 0x60, 0x00, 0x00, 0x01, 0x66, 0x00, 0x00,
-  0x01, 0x6c, 0x00, 0x00, 0x01, 0x72, 0x00, 0x00, 0x01, 0x78, 0x00, 0x00,
-  0x01, 0x7e, 0x00, 0x00, 0x01, 0x84, 0x00, 0x00, 0x01, 0x8a, 0x00, 0x00,
-  0x01, 0x90, 0x00, 0x00, 0x01, 0x96, 0x00, 0x00, 0x01, 0x9c, 0x00, 0x00,
-  0x01, 0xa2, 0x00, 0x00, 0x01, 0xa8, 0x00, 0x00, 0x01, 0xae, 0x00, 0x00,
-  0x01, 0xb4, 0x00, 0x00, 0x01, 0xba, 0x00, 0x00, 0x01, 0xc0, 0x00, 0x00,
-  0x01, 0xc6, 0x00, 0x00, 0x01, 0xcc, 0x00, 0x00, 0x01, 0xd2, 0x00, 0x00,
-  0x01, 0xd8, 0x00, 0x00, 0x01, 0xde, 0x00, 0x00, 0x01, 0xe4, 0x00, 0x00,
-  0x01, 0xea, 0x00, 0x00, 0x01, 0xf0, 0x00, 0x00, 0x01, 0xf6, 0x00, 0x00,
-  0x01, 0xfc, 0x00, 0x00, 0x02, 0x02, 0x00, 0x00, 0x02, 0x08, 0x00, 0x00,
-  0x02, 0x0e, 0x00, 0x00, 0x02, 0x14, 0x00, 0x00, 0x02, 0x1a, 0x00, 0x00,
-  0x02, 0x20, 0x00, 0x00, 0x02, 0x26, 0x00, 0x00, 0x02, 0x2c, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0xb0, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0xb0, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
-  0x06, 0xe6, 0x06, 0xbe, 0x00, 0x01, 0x06, 0xf0, 0x00, 0x0c, 0x00, 0xd6,
-  0x01, 0xae, 0x01, 0xb4, 0x01, 0xba, 0x01, 0xc0, 0x01, 0xc6, 0x01, 0xcc,
-  0x01, 0xd2, 0x01, 0xd8, 0x01, 0xde, 0x01, 0xe4, 0x01, 0xea, 0x01, 0xf0,
-  0x01, 0xf6, 0x01, 0xfc, 0x02, 0x02, 0x02, 0x08, 0x02, 0x0e, 0x02, 0x14,
-  0x02, 0x1a, 0x02, 0x20, 0x02, 0x26, 0x02, 0x2c, 0x02, 0x32, 0x02, 0x38,
-  0x02, 0x3e, 0x02, 0x44, 0x02, 0x4a, 0x02, 0x50, 0x02, 0x56, 0x02, 0x5c,
-  0x02, 0x62, 0x02, 0x68, 0x02, 0x6e, 0x02, 0x74, 0x02, 0x7a, 0x02, 0x80,
-  0x02, 0x86, 0x02, 0x8c, 0x02, 0x92, 0x02, 0x98, 0x02, 0x9e, 0x02, 0xa4,
-  0x02, 0xaa, 0x02, 0xb0, 0x02, 0xb6, 0x02, 0xbc, 0x02, 0xc2, 0x02, 0xc8,
-  0x02, 0xce, 0x02, 0xd4, 0x02, 0xda, 0x02, 0xe0, 0x02, 0xe6, 0x02, 0xec,
-  0x02, 0xf2, 0x02, 0xf8, 0x02, 0xfe, 0x03, 0x04, 0x03, 0x0a, 0x03, 0x10,
-  0x03, 0x16, 0x03, 0x1c, 0x03, 0x22, 0x03, 0x28, 0x03, 0x2e, 0x03, 0x34,
-  0x03, 0x3a, 0x03, 0x40, 0x03, 0x46, 0x03, 0x4c, 0x03, 0x52, 0x03, 0x58,
-  0x03, 0x5e, 0x03, 0x64, 0x03, 0x6a, 0x03, 0x70, 0x03, 0x76, 0x03, 0x7c,
-  0x03, 0x82, 0x03, 0x88, 0x03, 0x8e, 0x03, 0x94, 0x03, 0x9a, 0x03, 0xa0,
-  0x03, 0xa6, 0x03, 0xac, 0x03, 0xb2, 0x03, 0xb8, 0x03, 0xbe, 0x03, 0xc4,
-  0x03, 0xca, 0x03, 0xd0, 0x03, 0xd6, 0x03, 0xdc, 0x03, 0xe2, 0x03, 0xe8,
-  0x03, 0xee, 0x03, 0xf4, 0x03, 0xfa, 0x04, 0x00, 0x04, 0x06, 0x04, 0x0c,
-  0x04, 0x12, 0x04, 0x18, 0x04, 0x1e, 0x04, 0x24, 0x04, 0x2a, 0x04, 0x30,
-  0x04, 0x36, 0x04, 0x3c, 0x04, 0x42, 0x04, 0x48, 0x04, 0x4e, 0x04, 0x54,
-  0x04, 0x5a, 0x04, 0x60, 0x04, 0x66, 0x04, 0x6c, 0x04, 0x72, 0x04, 0x78,
-  0x04, 0x7e, 0x04, 0x84, 0x04, 0x8a, 0x04, 0x90, 0x04, 0x96, 0x04, 0x9c,
-  0x04, 0xa2, 0x04, 0xa8, 0x04, 0xae, 0x04, 0xb4, 0x04, 0xba, 0x04, 0xc0,
-  0x04, 0xc6, 0x04, 0xcc, 0x04, 0xd2, 0x04, 0xd8, 0x04, 0xde, 0x04, 0xe4,
-  0x04, 0xea, 0x04, 0xf0, 0x04, 0xf6, 0x04, 0xfc, 0x05, 0x02, 0x05, 0x08,
-  0x05, 0x0e, 0x05, 0x14, 0x05, 0x1a, 0x05, 0x20, 0x05, 0x26, 0x05, 0x2c,
-  0x05, 0x32, 0x05, 0x38, 0x05, 0x3e, 0x05, 0x44, 0x05, 0x4a, 0x05, 0x50,
-  0x05, 0x56, 0x05, 0x5c, 0x05, 0x62, 0x05, 0x68, 0x05, 0x6e, 0x05, 0x74,
-  0x05, 0x7a, 0x05, 0x80, 0x05, 0x86, 0x05, 0x8c, 0x05, 0x92, 0x05, 0x98,
-  0x05, 0x9e, 0x05, 0xa4, 0x05, 0xaa, 0x05, 0xb0, 0x05, 0xb6, 0x05, 0xbc,
-  0x05, 0xc2, 0x05, 0xc8, 0x05, 0xce, 0x05, 0xd4, 0x05, 0xda, 0x05, 0xe0,
-  0x05, 0xe6, 0x05, 0xec, 0x05, 0xf2, 0x05, 0xf8, 0x05, 0xfe, 0x06, 0x04,
-  0x06, 0x0a, 0x06, 0x10, 0x06, 0x16, 0x06, 0x1c, 0x06, 0x22, 0x06, 0x28,
-  0x06, 0x2e, 0x06, 0x34, 0x06, 0x3a, 0x06, 0x40, 0x06, 0x46, 0x06, 0x4c,
-  0x06, 0x52, 0x06, 0x58, 0x06, 0x5e, 0x06, 0x64, 0x06, 0x6a, 0x06, 0x70,
-  0x06, 0x76, 0x06, 0x7c, 0x06, 0x82, 0x06, 0x88, 0x06, 0x8e, 0x06, 0x94,
-  0x06, 0x9a, 0x06, 0xa0, 0x06, 0xa6, 0x06, 0xac, 0x00, 0x01, 0x03, 0x2a,
-  0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d, 0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d,
-  0x03, 0xe8, 0x00, 0x01, 0x02, 0x76, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2,
-  0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2, 0x03, 0xb6, 0x00, 0x01, 0x01, 0xc2,
-  0x03, 0x52, 0x00, 0x01, 0x01, 0xc2, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2,
-  0x03, 0xb6, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d,
-  0x04, 0x1a, 0x00, 0x01, 0x03, 0x2a, 0x03, 0x52, 0x00, 0x01, 0x01, 0x0d,
-  0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x03, 0x2a,
-  0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d, 0x05, 0x14, 0x00, 0x01, 0x01, 0x0d,
-  0x05, 0x14, 0x00, 0x01, 0x02, 0x49, 0x06, 0x0e, 0x00, 0x01, 0x02, 0x1c,
-  0x05, 0xaa, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xaa, 0x00, 0x01, 0x02, 0x49,
-  0x05, 0xdc, 0x00, 0x01, 0x02, 0x1c, 0x05, 0x78, 0x00, 0x01, 0x02, 0x1c,
-  0x05, 0x78, 0x00, 0x01, 0x02, 0x49, 0x05, 0xdc, 0x00, 0x01, 0x02, 0x1c,
-  0x05, 0x78, 0x00, 0x01, 0x02, 0x1c, 0x05, 0x78, 0x00, 0x01, 0x02, 0x49,
-  0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c, 0x04, 0x7e, 0x00, 0x01, 0x02, 0x1c,
-  0x04, 0x7e, 0x00, 0x01, 0x02, 0x76, 0x02, 0xee, 0x00, 0x01, 0x02, 0x76,
-  0x02, 0xee, 0x00, 0x01, 0x04, 0x42, 0x08, 0x34, 0x00, 0x01, 0x01, 0x31,
-  0x08, 0x34, 0x00, 0x01, 0x01, 0x31, 0x08, 0x34, 0x00, 0x01, 0x02, 0x76,
-  0x03, 0xb6, 0x00, 0x01, 0x01, 0x0d, 0x04, 0xb0, 0x00, 0x01, 0x01, 0x0d,
-  0x04, 0xb0, 0x00, 0x01, 0x02, 0x76, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xef,
-  0x03, 0x52, 0x00, 0x01, 0x01, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x00,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x0e,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x0e, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x0e,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x80, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x80,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x80, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x21,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x21, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x21,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x23,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xb0,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xdd,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xdd, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xdd,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x49,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa,
-  0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x63, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x63,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x63, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x7e,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x7e, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x7e,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x69, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x69,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x69, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xad,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xad, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xad,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd2, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd2,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd2, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
-  0x05, 0xf2, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf2, 0x00, 0x01, 0x02, 0x5a,
-  0x05, 0xf2, 0x00, 0x01, 0x02, 0x40, 0x05, 0xf2, 0x00, 0x01, 0x02, 0x40,
-  0x05, 0xf2, 0x00, 0x01, 0x02, 0x40, 0x05, 0xf2, 0x00, 0x01, 0x02, 0xb5,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x52,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x52, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x52,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xad, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xad,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xad, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x40,
-  0x05, 0xf2, 0x00, 0x01, 0x02, 0x40, 0x05, 0xf2, 0x00, 0x01, 0x02, 0x40,
-  0x05, 0xf2, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe5,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xe5, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe5,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x68, 0x03, 0xe8, 0x00, 0x01, 0x01, 0x68,
-  0x03, 0xe8, 0x00, 0x01, 0x01, 0x95, 0x06, 0x40, 0x00, 0x01, 0x01, 0x95,
-  0x05, 0xaa, 0x00, 0x01, 0x01, 0x95, 0x05, 0xdc, 0x00, 0x01, 0x02, 0x76,
-  0x02, 0xee, 0x00, 0x01, 0x02, 0x76, 0x02, 0xee, 0x00, 0x01, 0x02, 0x76,
-  0x02, 0xee, 0x00, 0x01, 0x02, 0x76, 0x03, 0xe8, 0x00, 0x01, 0x02, 0x76,
-  0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c, 0x03, 0x20, 0x00, 0x01, 0x02, 0xfd,
-  0x04, 0x1a, 0x00, 0x01, 0x02, 0xfd, 0x04, 0x1a, 0x00, 0x01, 0x02, 0x1c,
-  0x03, 0x20, 0x00, 0x01, 0x02, 0x49, 0x03, 0x84, 0x00, 0x01, 0x02, 0x49,
-  0x03, 0x84, 0x00, 0x01, 0x02, 0x1c, 0x03, 0x20, 0x00, 0x01, 0x02, 0xfd,
-  0x04, 0xe2, 0x00, 0x01, 0x02, 0xfd, 0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c,
-  0x03, 0x20, 0x00, 0x01, 0x01, 0xef, 0x03, 0x20, 0x00, 0x01, 0x01, 0xef,
-  0x03, 0x20, 0x00, 0x01, 0x02, 0x1c, 0x03, 0x20, 0x00, 0x01, 0x02, 0x1c,
-  0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c, 0x04, 0xe2, 0x00, 0x01, 0x02, 0x1e,
-  0x06, 0x72, 0x00, 0x01, 0x01, 0x31, 0x06, 0x72, 0x00, 0x01, 0x01, 0x31,
-  0x06, 0x72, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x01, 0xc2,
-  0x06, 0x72, 0x00, 0x01, 0x01, 0xbc, 0x05, 0x78, 0x00, 0x01, 0x02, 0x76,
-  0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2,
-  0x03, 0xb6, 0x00, 0x01, 0x02, 0x76, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2,
-  0x05, 0x46, 0x00, 0x01, 0x01, 0xd2, 0x04, 0xb0, 0x00, 0x01, 0x02, 0x76,
-  0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2,
-  0x03, 0xb6, 0x00, 0x01, 0x01, 0xc2, 0x03, 0x52, 0x00, 0x01, 0x01, 0xc2,
-  0x05, 0x46, 0x00, 0x01, 0x01, 0xd2, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xc2,
-  0x03, 0x52, 0x00, 0x01, 0x01, 0xc2, 0x06, 0x40, 0x00, 0x01, 0x01, 0xd2,
-  0x05, 0xaa, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x00, 0x6c,
-  0x05, 0x78, 0x00, 0x01, 0x00, 0x6c, 0x05, 0x78, 0x00, 0x01, 0x01, 0xc2,
-  0x05, 0x78, 0x00, 0x01, 0x00, 0xe1, 0x06, 0x0e, 0x00, 0x01, 0x00, 0xe1,
-  0x06, 0x0e, 0x00, 0x01, 0x02, 0xe6, 0x06, 0x0e, 0x00, 0x01, 0x00, 0xf7,
-  0x06, 0xa4, 0x00, 0x01, 0x00, 0xf7, 0x06, 0xa4, 0x00, 0x01, 0x02, 0x76,
-  0x05, 0xdc, 0x00, 0x01, 0x00, 0xe1, 0x06, 0x0e, 0x00, 0x01, 0x00, 0xe1,
-  0x06, 0x0e, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x00, 0xe1,
-  0x06, 0xa4, 0x00, 0x01, 0x00, 0xe1, 0x06, 0xa4, 0x00, 0x01, 0x01, 0xc2,
-  0x05, 0x78, 0x00, 0x01, 0x00, 0xe1, 0x06, 0xa4, 0x00, 0x01, 0x00, 0xe1,
-  0x06, 0xa4, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x00, 0xf7,
-  0x08, 0x66, 0x00, 0x01, 0x00, 0xf7, 0x08, 0x66, 0x00, 0x01, 0x04, 0x42,
-  0x08, 0x34, 0x00, 0x01, 0x01, 0x31, 0x08, 0x34, 0x00, 0x01, 0x01, 0x31,
-  0x08, 0x34, 0x00, 0x01, 0x04, 0x42, 0x08, 0x66, 0x00, 0x01, 0x01, 0x31,
-  0x08, 0x66, 0x00, 0x01, 0x01, 0x31, 0x08, 0x66, 0x00, 0x01, 0x02, 0x49,
-  0x05, 0x14, 0x00, 0x01, 0x01, 0x31, 0x06, 0x72, 0x00, 0x01, 0x01, 0x31,
-  0x06, 0x72, 0x00, 0x01, 0x02, 0x49, 0x02, 0xee, 0x00, 0x01, 0x01, 0x0d,
-  0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x02, 0x49,
-  0x02, 0xee, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d,
-  0x04, 0x1a, 0x00, 0x01, 0x02, 0x76, 0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d,
-  0x05, 0x14, 0x00, 0x01, 0x01, 0x0d, 0x05, 0x14, 0x00, 0x02, 0x00, 0x06,
-  0x10, 0xfc, 0x11, 0x06, 0x00, 0x00, 0x11, 0x08, 0x11, 0x19, 0x00, 0x0b,
-  0x11, 0x35, 0x11, 0x3d, 0x00, 0x1d, 0x11, 0x3f, 0x11, 0x3f, 0x00, 0x26,
-  0x11, 0x52, 0x11, 0xab, 0x00, 0x27, 0x11, 0xb9, 0x12, 0x0d, 0x00, 0x81,
-  0x00, 0x02, 0x00, 0x01, 0x11, 0x4a, 0x11, 0x51, 0x00, 0x00, 0x00, 0x08,
-  0x00, 0x00, 0x00, 0x22, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x2e,
-  0x00, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00, 0x3a, 0x00, 0x00, 0x00, 0x40,
-  0x00, 0x00, 0x00, 0x46, 0x00, 0x00, 0x00, 0x4c, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
-  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x00, 0x20,
-  0x00, 0x1a, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x0c, 0x00, 0x01, 0x00, 0x04,
-  0x00, 0x01, 0x00, 0x04, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0xa9, 0x00, 0x02, 0x00, 0x09, 0x02, 0xc7, 0x02, 0xca,
-  0x00, 0x00, 0x02, 0xcd, 0x02, 0xd1, 0x00, 0x04, 0x02, 0xd4, 0x02, 0xd7,
-  0x00, 0x09, 0x02, 0xda, 0x02, 0xe4, 0x00, 0x0d, 0x02, 0xea, 0x02, 0xed,
-  0x00, 0x18, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x1c, 0x02, 0xfe, 0x02, 0xff,
-  0x00, 0x1f, 0x03, 0x03, 0x03, 0x03, 0x00, 0x21, 0x03, 0x06, 0x03, 0x06,
-  0x00, 0x22, 0x00, 0x23, 0x00, 0x00, 0x00, 0x8e, 0x00, 0x00, 0x00, 0x94,
-  0x00, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x00, 0xa0, 0x00, 0x00, 0x00, 0xa6,
-  0x00, 0x00, 0x00, 0xac, 0x00, 0x00, 0x00, 0xb2, 0x00, 0x00, 0x00, 0xb8,
-  0x00, 0x00, 0x00, 0xbe, 0x00, 0x00, 0x00, 0xc4, 0x00, 0x00, 0x00, 0xca,
-  0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0x00, 0xd6, 0x00, 0x00, 0x00, 0xdc,
-  0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe8, 0x00, 0x00, 0x00, 0xee,
-  0x00, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x00, 0x00, 0x01, 0x00,
-  0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0c, 0x00, 0x00, 0x01, 0x12,
-  0x00, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x1e, 0x00, 0x00, 0x01, 0x24,
-  0x00, 0x00, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x30, 0x00, 0x00, 0x01, 0x36,
-  0x00, 0x00, 0x01, 0x3c, 0x00, 0x00, 0x01, 0x42, 0x00, 0x00, 0x01, 0x48,
-  0x00, 0x00, 0x01, 0x4e, 0x00, 0x00, 0x01, 0x54, 0x00, 0x00, 0x01, 0x5a,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x35, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
-  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0x05, 0x8c, 0x04, 0xb6,
-  0x00, 0x01, 0x05, 0x94, 0x00, 0x0c, 0x00, 0x95, 0x01, 0x2c, 0x01, 0x32,
-  0x01, 0x38, 0x01, 0x3e, 0x01, 0x44, 0x01, 0x4a, 0x01, 0x50, 0x01, 0x56,
-  0x01, 0x5c, 0x01, 0x62, 0x01, 0x68, 0x01, 0x6e, 0x01, 0x74, 0x01, 0x7a,
-  0x01, 0x80, 0x01, 0x86, 0x01, 0x8c, 0x01, 0x92, 0x01, 0x98, 0x01, 0x9e,
-  0x01, 0xa4, 0x01, 0xaa, 0x01, 0xb0, 0x01, 0xb6, 0x01, 0xbc, 0x01, 0xc2,
-  0x01, 0xc8, 0x01, 0xce, 0x01, 0xd4, 0x01, 0xda, 0x01, 0xe0, 0x01, 0xe6,
-  0x01, 0xec, 0x01, 0xf2, 0x01, 0xf8, 0x01, 0xfe, 0x02, 0x04, 0x02, 0x0a,
-  0x02, 0x10, 0x02, 0x16, 0x02, 0x1c, 0x02, 0x22, 0x02, 0x28, 0x02, 0x2e,
-  0x02, 0x34, 0x02, 0x3a, 0x02, 0x40, 0x02, 0x46, 0x02, 0x4c, 0x02, 0x52,
-  0x02, 0x58, 0x02, 0x5e, 0x02, 0x64, 0x02, 0x6a, 0x02, 0x70, 0x02, 0x76,
-  0x02, 0x7c, 0x02, 0x82, 0x02, 0x88, 0x02, 0x8e, 0x02, 0x94, 0x02, 0x9a,
-  0x02, 0xa0, 0x02, 0xa6, 0x02, 0xac, 0x02, 0xb2, 0x02, 0xb8, 0x02, 0xbe,
-  0x02, 0xc4, 0x02, 0xca, 0x02, 0xd0, 0x02, 0xd6, 0x02, 0xdc, 0x02, 0xe2,
-  0x02, 0xe8, 0x02, 0xee, 0x02, 0xf4, 0x02, 0xfa, 0x03, 0x00, 0x03, 0x06,
-  0x03, 0x0c, 0x03, 0x12, 0x03, 0x18, 0x03, 0x1e, 0x03, 0x24, 0x03, 0x2a,
-  0x03, 0x30, 0x03, 0x36, 0x03, 0x3c, 0x03, 0x42, 0x03, 0x48, 0x03, 0x4e,
-  0x03, 0x54, 0x03, 0x5a, 0x03, 0x60, 0x03, 0x66, 0x03, 0x6c, 0x03, 0x72,
-  0x03, 0x78, 0x03, 0x7e, 0x03, 0x84, 0x03, 0x8a, 0x03, 0x90, 0x03, 0x96,
-  0x03, 0x9c, 0x03, 0xa2, 0x03, 0xa8, 0x03, 0xae, 0x03, 0xb4, 0x03, 0xba,
-  0x03, 0xc0, 0x03, 0xc6, 0x03, 0xcc, 0x03, 0xd2, 0x03, 0xd8, 0x03, 0xde,
-  0x03, 0xe4, 0x03, 0xea, 0x03, 0xf0, 0x03, 0xf6, 0x03, 0xfc, 0x04, 0x02,
-  0x04, 0x08, 0x04, 0x0e, 0x04, 0x14, 0x04, 0x1a, 0x04, 0x20, 0x04, 0x26,
-  0x04, 0x2c, 0x04, 0x32, 0x04, 0x38, 0x04, 0x3e, 0x04, 0x44, 0x04, 0x4a,
-  0x04, 0x50, 0x04, 0x56, 0x04, 0x5c, 0x04, 0x62, 0x04, 0x68, 0x04, 0x6e,
-  0x04, 0x74, 0x04, 0x7a, 0x04, 0x80, 0x04, 0x86, 0x04, 0x8c, 0x04, 0x92,
-  0x04, 0x98, 0x04, 0x9e, 0x04, 0xa4, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
-  0x00, 0x02, 0x00, 0x23, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x44,
-  0x00, 0x5d, 0x00, 0x1a, 0x00, 0x9a, 0x00, 0x9a, 0x00, 0x34, 0x00, 0xba,
-  0x00, 0xba, 0x00, 0x35, 0x00, 0xc6, 0x00, 0xc7, 0x00, 0x36, 0x00, 0xd0,
-  0x00, 0xd1, 0x00, 0x38, 0x00, 0xf3, 0x00, 0xf3, 0x00, 0x3a, 0x01, 0x28,
-  0x01, 0x29, 0x00, 0x3b, 0x01, 0x41, 0x01, 0x41, 0x00, 0x3d, 0x01, 0x48,
-  0x01, 0x48, 0x00, 0x3e, 0x01, 0x51, 0x01, 0x52, 0x00, 0x3f, 0x01, 0x59,
-  0x01, 0x59, 0x00, 0x41, 0x01, 0x61, 0x01, 0x61, 0x00, 0x42, 0x01, 0x79,
-  0x01, 0x7b, 0x00, 0x43, 0x02, 0x12, 0x02, 0x12, 0x00, 0x46, 0x02, 0x16,
-  0x02, 0x16, 0x00, 0x47, 0x02, 0x1b, 0x02, 0x1b, 0x00, 0x48, 0x02, 0x1d,
-  0x02, 0x1d, 0x00, 0x49, 0x02, 0x2a, 0x02, 0x2a, 0x00, 0x4a, 0x02, 0x37,
-  0x02, 0x37, 0x00, 0x4b, 0x02, 0x54, 0x02, 0x54, 0x00, 0x4c, 0x05, 0x23,
-  0x05, 0x23, 0x00, 0x4d, 0x05, 0x5a, 0x05, 0x63, 0x00, 0x4e, 0x0e, 0x38,
-  0x0e, 0x3a, 0x00, 0x58, 0x0e, 0x3d, 0x0e, 0x3e, 0x00, 0x5b, 0x0e, 0x44,
-  0x0e, 0x44, 0x00, 0x5d, 0x0e, 0x48, 0x0e, 0x49, 0x00, 0x5e, 0x0e, 0x62,
-  0x0e, 0x65, 0x00, 0x60, 0x0e, 0x6b, 0x0e, 0x75, 0x00, 0x64, 0x0e, 0x78,
-  0x0e, 0x81, 0x00, 0x6f, 0x0e, 0x83, 0x0e, 0x87, 0x00, 0x79, 0x0e, 0x8c,
-  0x0e, 0x8f, 0x00, 0x7e, 0x0e, 0x96, 0x0e, 0xa2, 0x00, 0x82, 0x0e, 0xa4,
-  0x0e, 0xa8, 0x00, 0x8f, 0x11, 0x1c, 0x11, 0x1c, 0x00, 0x94, 0x00, 0x01,
-  0x00, 0x02, 0x0f, 0x11, 0x0f, 0x13, 0x00, 0x02, 0x00, 0x00, 0x00, 0x0a,
-  0x00, 0x00, 0x00, 0x10, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01,
-  0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x62, 0x00, 0x4e, 0x00, 0x01,
-  0x00, 0x6a, 0x00, 0x0c, 0x00, 0x08, 0x00, 0x12, 0x00, 0x18, 0x00, 0x1e,
-  0x00, 0x24, 0x00, 0x2a, 0x00, 0x30, 0x00, 0x36, 0x00, 0x3c, 0x00, 0x01,
-  0x02, 0x0f, 0x06, 0x14, 0x00, 0x01, 0x02, 0xa1, 0x07, 0x6d, 0x00, 0x01,
-  0x02, 0x53, 0x06, 0x14, 0x00, 0x01, 0x01, 0x02, 0x06, 0x14, 0x00, 0x01,
-  0x02, 0x34, 0x06, 0x14, 0x00, 0x01, 0x02, 0x3d, 0x06, 0x14, 0x00, 0x01,
-  0x02, 0xa1, 0x07, 0x50, 0x00, 0x01, 0x03, 0x97, 0x07, 0x89, 0x00, 0x01,
-  0x00, 0x08, 0x00, 0xc3, 0x00, 0xd0, 0x00, 0xd5, 0x00, 0xed, 0x01, 0x0f,
-  0x01, 0x2d, 0x05, 0x5a, 0x05, 0x5b, 0x00, 0x01, 0x00, 0x02, 0x02, 0xb1,
-  0x02, 0xb2, 0x00, 0x02, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x10,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0x03, 0x8c, 0x02, 0xd6, 0x00, 0x01, 0x03, 0x92, 0x00, 0x0c,
-  0x00, 0x59, 0x00, 0xb4, 0x00, 0xba, 0x00, 0xc0, 0x00, 0xc6, 0x00, 0xcc,
-  0x00, 0xd2, 0x00, 0xd8, 0x00, 0xde, 0x00, 0xe4, 0x00, 0xea, 0x00, 0xf0,
-  0x00, 0xf6, 0x00, 0xfc, 0x01, 0x02, 0x01, 0x08, 0x01, 0x0e, 0x01, 0x14,
-  0x01, 0x1a, 0x01, 0x20, 0x01, 0x26, 0x01, 0x2c, 0x01, 0x32, 0x01, 0x38,
-  0x01, 0x3e, 0x01, 0x44, 0x01, 0x4a, 0x01, 0x50, 0x01, 0x56, 0x01, 0x5c,
-  0x01, 0x62, 0x01, 0x68, 0x01, 0x6e, 0x01, 0x74, 0x01, 0x7a, 0x01, 0x80,
-  0x01, 0x86, 0x01, 0x8c, 0x01, 0x92, 0x01, 0x98, 0x01, 0x9e, 0x01, 0xa4,
-  0x01, 0xaa, 0x01, 0xb0, 0x01, 0xb6, 0x01, 0xbc, 0x01, 0xc2, 0x01, 0xc8,
-  0x01, 0xce, 0x01, 0xd4, 0x01, 0xda, 0x01, 0xe0, 0x01, 0xe6, 0x01, 0xec,
-  0x01, 0xf2, 0x01, 0xf8, 0x01, 0xfe, 0x02, 0x04, 0x02, 0x0a, 0x02, 0x10,
-  0x02, 0x16, 0x02, 0x1c, 0x02, 0x22, 0x02, 0x28, 0x02, 0x2e, 0x02, 0x34,
-  0x02, 0x3a, 0x02, 0x40, 0x02, 0x46, 0x02, 0x4c, 0x02, 0x52, 0x02, 0x58,
-  0x02, 0x5e, 0x02, 0x64, 0x02, 0x6a, 0x02, 0x70, 0x02, 0x76, 0x02, 0x7c,
-  0x02, 0x82, 0x02, 0x88, 0x02, 0x8e, 0x02, 0x94, 0x02, 0x9a, 0x02, 0xa0,
-  0x02, 0xa6, 0x02, 0xac, 0x02, 0xb2, 0x02, 0xb8, 0x02, 0xbe, 0x02, 0xc4,
-  0x00, 0x01, 0x04, 0x7f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf7, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0xf5, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x0d, 0x00, 0x00, 0x00, 0x01, 0x01, 0x0d, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5e, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00,
-  0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x28, 0x00, 0x00, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x00, 0xfa, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x01, 0xf6, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe1, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01, 0x04, 0x7f, 0xfe, 0x80,
-  0x00, 0x01, 0x03, 0x6f, 0xfe, 0x80, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x7d, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01, 0x95, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x16, 0x00, 0x00, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x05, 0xd5, 0x00, 0x00,
-  0x00, 0x01, 0x04, 0xec, 0x00, 0x00, 0x00, 0x01, 0x05, 0x96, 0x00, 0x00,
-  0x00, 0x01, 0x04, 0xbd, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe8, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x85, 0x00, 0x00, 0x00, 0x01, 0x01, 0x0d, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5e, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0xf6, 0x00, 0x00, 0x00, 0x01, 0x01, 0x69, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x3d, 0xfe, 0x52, 0x00, 0x01, 0x00, 0x59, 0x00, 0x24,
-  0x00, 0x26, 0x00, 0x27, 0x00, 0x28, 0x00, 0x2b, 0x00, 0x2c, 0x00, 0x30,
-  0x00, 0x31, 0x00, 0x32, 0x00, 0x36, 0x00, 0x38, 0x00, 0x3d, 0x00, 0x44,
-  0x00, 0x46, 0x00, 0x47, 0x00, 0x48, 0x00, 0x4b, 0x00, 0x4c, 0x00, 0x50,
-  0x00, 0x51, 0x00, 0x52, 0x00, 0x56, 0x00, 0x58, 0x00, 0x5d, 0x00, 0x8e,
-  0x00, 0x8f, 0x00, 0x90, 0x00, 0x91, 0x00, 0x9a, 0x00, 0xae, 0x00, 0xaf,
-  0x00, 0xb0, 0x00, 0xb1, 0x00, 0xba, 0x00, 0xc3, 0x00, 0xc6, 0x00, 0xc7,
-  0x00, 0xd5, 0x00, 0xea, 0x00, 0xeb, 0x00, 0xec, 0x00, 0xed, 0x00, 0xee,
-  0x00, 0xef, 0x00, 0xf2, 0x00, 0xf3, 0x01, 0x0f, 0x01, 0x2d, 0x01, 0x48,
-  0x01, 0x51, 0x01, 0x52, 0x01, 0x59, 0x01, 0x61, 0x01, 0x79, 0x01, 0x7a,
-  0x01, 0x7b, 0x01, 0x91, 0x01, 0x92, 0x01, 0xca, 0x01, 0xcb, 0x01, 0xcc,
-  0x01, 0xcd, 0x02, 0x12, 0x02, 0x16, 0x02, 0x1b, 0x02, 0x1d, 0x02, 0x2a,
-  0x02, 0x37, 0x02, 0x54, 0x05, 0x7e, 0x05, 0x7f, 0x06, 0x18, 0x06, 0x19,
-  0x0e, 0x38, 0x0e, 0x44, 0x0e, 0x6c, 0x0e, 0x6d, 0x0e, 0x6e, 0x0e, 0x6f,
-  0x0e, 0x7e, 0x0e, 0x7f, 0x0e, 0x9c, 0x0e, 0x9d, 0x0e, 0xa0, 0x0e, 0xa1,
-  0x0e, 0xa2, 0x0e, 0xa7, 0x11, 0x1c, 0x11, 0xb8, 0x00, 0x01, 0x00, 0x01,
-  0x02, 0xd8, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x01, 0xfe, 0x48,
-  0x00, 0x00, 0x00, 0x01, 0x0f, 0xba, 0x0d, 0x8e, 0x00, 0x01, 0x0f, 0xf4,
-  0x00, 0x0c, 0x01, 0xb0, 0x03, 0x62, 0x03, 0x68, 0x03, 0x6e, 0x03, 0x74,
-  0x03, 0x7a, 0x03, 0x80, 0x03, 0x86, 0x03, 0x8c, 0x03, 0x92, 0x03, 0x98,
-  0x03, 0x9e, 0x03, 0xa4, 0x03, 0xaa, 0x03, 0xb0, 0x03, 0xb6, 0x03, 0xbc,
-  0x03, 0xc2, 0x03, 0xc8, 0x03, 0xce, 0x03, 0xd4, 0x03, 0xda, 0x03, 0xe0,
-  0x03, 0xe6, 0x03, 0xec, 0x03, 0xf2, 0x03, 0xf8, 0x03, 0xfe, 0x04, 0x04,
-  0x04, 0x0a, 0x04, 0x10, 0x04, 0x16, 0x04, 0x1c, 0x04, 0x22, 0x04, 0x28,
-  0x04, 0x2e, 0x04, 0x34, 0x04, 0x3a, 0x04, 0x40, 0x04, 0x46, 0x04, 0x4c,
-  0x04, 0x52, 0x04, 0x58, 0x04, 0x5e, 0x04, 0x64, 0x04, 0x6a, 0x04, 0x70,
-  0x04, 0x76, 0x04, 0x7c, 0x04, 0x82, 0x04, 0x88, 0x04, 0x8e, 0x04, 0x94,
-  0x04, 0x9a, 0x04, 0xa0, 0x04, 0xa6, 0x04, 0xac, 0x04, 0xb2, 0x04, 0xb8,
-  0x04, 0xbe, 0x04, 0xc4, 0x04, 0xca, 0x04, 0xd0, 0x04, 0xd6, 0x04, 0xdc,
-  0x04, 0xe2, 0x04, 0xe8, 0x04, 0xee, 0x04, 0xf4, 0x04, 0xfa, 0x05, 0x00,
-  0x05, 0x06, 0x05, 0x0c, 0x05, 0x12, 0x05, 0x18, 0x05, 0x1e, 0x05, 0x24,
-  0x05, 0x2a, 0x05, 0x30, 0x05, 0x36, 0x05, 0x3c, 0x05, 0x42, 0x05, 0x48,
-  0x05, 0x4e, 0x05, 0x54, 0x05, 0x5a, 0x05, 0x60, 0x05, 0x66, 0x05, 0x6c,
-  0x05, 0x72, 0x05, 0x78, 0x05, 0x7e, 0x05, 0x84, 0x05, 0x8a, 0x05, 0x90,
-  0x05, 0x96, 0x05, 0x9c, 0x05, 0xa2, 0x05, 0xa8, 0x05, 0xae, 0x05, 0xb4,
-  0x05, 0xba, 0x05, 0xc0, 0x05, 0xc6, 0x05, 0xcc, 0x05, 0xd2, 0x05, 0xd8,
-  0x05, 0xde, 0x05, 0xe4, 0x05, 0xea, 0x05, 0xf0, 0x05, 0xf6, 0x05, 0xfc,
-  0x06, 0x02, 0x06, 0x08, 0x06, 0x0e, 0x06, 0x14, 0x06, 0x1a, 0x06, 0x20,
-  0x06, 0x26, 0x06, 0x2c, 0x06, 0x32, 0x06, 0x38, 0x06, 0x3e, 0x06, 0x44,
-  0x06, 0x4a, 0x06, 0x50, 0x06, 0x56, 0x06, 0x5c, 0x06, 0x62, 0x06, 0x68,
-  0x06, 0x6e, 0x06, 0x74, 0x06, 0x7a, 0x06, 0x80, 0x06, 0x86, 0x06, 0x8c,
-  0x06, 0x92, 0x06, 0x98, 0x06, 0x9e, 0x06, 0xa4, 0x06, 0xaa, 0x06, 0xb0,
-  0x06, 0xb6, 0x06, 0xbc, 0x06, 0xc2, 0x06, 0xc8, 0x06, 0xce, 0x06, 0xd4,
-  0x06, 0xda, 0x06, 0xe0, 0x06, 0xe6, 0x06, 0xec, 0x06, 0xf2, 0x06, 0xf8,
-  0x06, 0xfe, 0x07, 0x04, 0x07, 0x0a, 0x07, 0x10, 0x07, 0x16, 0x07, 0x1c,
-  0x07, 0x22, 0x07, 0x28, 0x07, 0x2e, 0x07, 0x34, 0x07, 0x3a, 0x07, 0x40,
-  0x07, 0x46, 0x07, 0x4c, 0x07, 0x52, 0x07, 0x58, 0x07, 0x5e, 0x07, 0x64,
-  0x07, 0x6a, 0x07, 0x70, 0x07, 0x76, 0x07, 0x7c, 0x07, 0x82, 0x07, 0x88,
-  0x07, 0x8e, 0x07, 0x94, 0x07, 0x9a, 0x07, 0xa0, 0x07, 0xa6, 0x07, 0xac,
-  0x07, 0xb2, 0x07, 0xb8, 0x07, 0xbe, 0x07, 0xc4, 0x07, 0xca, 0x07, 0xd0,
-  0x07, 0xd6, 0x07, 0xdc, 0x07, 0xe2, 0x07, 0xe8, 0x07, 0xee, 0x07, 0xf4,
-  0x07, 0xfa, 0x08, 0x00, 0x08, 0x06, 0x08, 0x0c, 0x08, 0x12, 0x08, 0x18,
-  0x08, 0x1e, 0x08, 0x24, 0x08, 0x2a, 0x08, 0x30, 0x08, 0x36, 0x08, 0x3c,
-  0x08, 0x42, 0x08, 0x48, 0x08, 0x4e, 0x08, 0x54, 0x08, 0x5a, 0x08, 0x60,
-  0x08, 0x66, 0x08, 0x6c, 0x08, 0x72, 0x08, 0x78, 0x08, 0x7e, 0x08, 0x84,
-  0x08, 0x8a, 0x08, 0x90, 0x08, 0x96, 0x08, 0x9c, 0x08, 0xa2, 0x08, 0xa8,
-  0x08, 0xae, 0x08, 0xb4, 0x08, 0xba, 0x08, 0xc0, 0x08, 0xc6, 0x08, 0xcc,
-  0x08, 0xd2, 0x08, 0xd8, 0x08, 0xde, 0x08, 0xe4, 0x08, 0xea, 0x08, 0xf0,
-  0x08, 0xf6, 0x08, 0xfc, 0x09, 0x02, 0x09, 0x08, 0x09, 0x0e, 0x09, 0x14,
-  0x09, 0x1a, 0x09, 0x20, 0x09, 0x26, 0x09, 0x2c, 0x09, 0x32, 0x09, 0x38,
-  0x09, 0x3e, 0x09, 0x44, 0x09, 0x4a, 0x09, 0x50, 0x09, 0x56, 0x09, 0x5c,
-  0x09, 0x62, 0x09, 0x68, 0x09, 0x6e, 0x09, 0x74, 0x09, 0x7a, 0x09, 0x80,
-  0x09, 0x86, 0x09, 0x8c, 0x09, 0x92, 0x09, 0x98, 0x09, 0x9e, 0x09, 0xa4,
-  0x09, 0xaa, 0x09, 0xb0, 0x09, 0xb6, 0x09, 0xbc, 0x09, 0xc2, 0x09, 0xc8,
-  0x09, 0xce, 0x09, 0xd4, 0x09, 0xda, 0x09, 0xe0, 0x09, 0xe6, 0x09, 0xec,
-  0x09, 0xf2, 0x09, 0xf8, 0x09, 0xfe, 0x0a, 0x04, 0x0a, 0x0a, 0x0a, 0x10,
-  0x0a, 0x16, 0x0a, 0x1c, 0x0a, 0x22, 0x0a, 0x28, 0x0a, 0x2e, 0x0a, 0x34,
-  0x0a, 0x3a, 0x0a, 0x40, 0x0a, 0x46, 0x0a, 0x4c, 0x0a, 0x52, 0x0a, 0x58,
-  0x0a, 0x5e, 0x0a, 0x64, 0x0a, 0x6a, 0x0a, 0x70, 0x0a, 0x76, 0x0a, 0x7c,
-  0x0a, 0x82, 0x0a, 0x88, 0x0a, 0x8e, 0x0a, 0x94, 0x0a, 0x9a, 0x0a, 0xa0,
-  0x0a, 0xa6, 0x0a, 0xac, 0x0a, 0xb2, 0x0a, 0xb8, 0x0a, 0xbe, 0x0a, 0xc4,
-  0x0a, 0xca, 0x0a, 0xd0, 0x0a, 0xd6, 0x0a, 0xdc, 0x0a, 0xe2, 0x0a, 0xe8,
-  0x0a, 0xee, 0x0a, 0xf4, 0x0a, 0xfa, 0x0b, 0x00, 0x0b, 0x06, 0x0b, 0x0c,
-  0x0b, 0x12, 0x0b, 0x18, 0x0b, 0x1e, 0x0b, 0x24, 0x0b, 0x2a, 0x0b, 0x30,
-  0x0b, 0x36, 0x0b, 0x3c, 0x0b, 0x42, 0x0b, 0x48, 0x0b, 0x4e, 0x0b, 0x54,
-  0x0b, 0x5a, 0x0b, 0x60, 0x0b, 0x66, 0x0b, 0x6c, 0x0b, 0x72, 0x0b, 0x78,
-  0x0b, 0x7e, 0x0b, 0x84, 0x0b, 0x8a, 0x0b, 0x90, 0x0b, 0x96, 0x0b, 0x9c,
-  0x0b, 0xa2, 0x0b, 0xa8, 0x0b, 0xae, 0x0b, 0xb4, 0x0b, 0xba, 0x0b, 0xc0,
-  0x0b, 0xc6, 0x0b, 0xcc, 0x0b, 0xd2, 0x0b, 0xd8, 0x0b, 0xde, 0x0b, 0xe4,
-  0x0b, 0xea, 0x0b, 0xf0, 0x0b, 0xf6, 0x0b, 0xfc, 0x0c, 0x02, 0x0c, 0x08,
-  0x0c, 0x0e, 0x0c, 0x14, 0x0c, 0x1a, 0x0c, 0x20, 0x0c, 0x26, 0x0c, 0x2c,
-  0x0c, 0x32, 0x0c, 0x38, 0x0c, 0x3e, 0x0c, 0x44, 0x0c, 0x4a, 0x0c, 0x50,
-  0x0c, 0x56, 0x0c, 0x5c, 0x0c, 0x62, 0x0c, 0x68, 0x0c, 0x6e, 0x0c, 0x74,
-  0x0c, 0x7a, 0x0c, 0x80, 0x0c, 0x86, 0x0c, 0x8c, 0x0c, 0x92, 0x0c, 0x98,
-  0x0c, 0x9e, 0x0c, 0xa4, 0x0c, 0xaa, 0x0c, 0xb0, 0x0c, 0xb6, 0x0c, 0xbc,
-  0x0c, 0xc2, 0x0c, 0xc8, 0x0c, 0xce, 0x0c, 0xd4, 0x0c, 0xda, 0x0c, 0xe0,
-  0x0c, 0xe6, 0x0c, 0xec, 0x0c, 0xf2, 0x0c, 0xf8, 0x0c, 0xfe, 0x0d, 0x04,
-  0x0d, 0x0a, 0x0d, 0x10, 0x0d, 0x16, 0x0d, 0x1c, 0x0d, 0x22, 0x0d, 0x28,
-  0x0d, 0x2e, 0x0d, 0x34, 0x0d, 0x3a, 0x0d, 0x40, 0x0d, 0x46, 0x0d, 0x4c,
-  0x0d, 0x52, 0x0d, 0x58, 0x0d, 0x5e, 0x0d, 0x64, 0x0d, 0x6a, 0x0d, 0x70,
-  0x0d, 0x76, 0x0d, 0x7c, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf7, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xa1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x03, 0x06, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xb5, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x0f, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x56, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1a, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xa9, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x51, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x03, 0x8f, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x85, 0x00, 0x00, 0x00, 0x01, 0x02, 0x33, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x77, 0x00, 0x00, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x71, 0x00, 0x00, 0x00, 0x01, 0x02, 0x60, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x28, 0x00, 0x00, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x1b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x03, 0x84, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x01, 0xee, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x25, 0x00, 0x00, 0x00, 0x01, 0x02, 0x23, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x7f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00, 0x00, 0x01,
-  0x04, 0x7f, 0xfe, 0x80, 0x00, 0x01, 0x03, 0x6f, 0xfe, 0x80, 0x00, 0x01,
-  0x02, 0xa1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x28, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x88, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x48, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x1b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x71, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x28, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7d, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x17, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x00, 0xfa, 0xfe, 0x7a, 0x00, 0x01,
-  0x02, 0x23, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0xf3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xa3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x52, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x0f, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x02, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x33, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x23, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x46, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x8d, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x4b, 0x00, 0x00, 0x00, 0x01, 0x01, 0x95, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x18, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x25, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x16, 0x00, 0x00, 0x00, 0x01, 0x02, 0x16, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x06, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x06, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x2c, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x2c, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x25, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x25, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x3d, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0xec, 0x00, 0x00, 0x00, 0x01, 0x01, 0x59, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x70, 0x00, 0x00, 0x00, 0x01, 0x01, 0xcb, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xa3, 0xfe, 0x52, 0x00, 0x01,
-  0x03, 0x84, 0x00, 0x00, 0x00, 0x01, 0x03, 0x84, 0xfe, 0x52, 0x00, 0x01,
-  0x03, 0x84, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x48, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x48, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x48, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x04, 0x18, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0xfc, 0x00, 0x00, 0x00, 0x01, 0x01, 0xfc, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xfc, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xff, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x24, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x5c, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x35, 0x00, 0x00, 0x00, 0x01, 0x02, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x15, 0x00, 0x00, 0x00, 0x01, 0x01, 0xef, 0xfe, 0x52, 0x00, 0x01,
-  0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0xbf, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0xd9, 0xfe, 0x52, 0x00, 0x01, 0x01, 0xc2, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0x26, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x01, 0xe1, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0x84, 0x00, 0x00, 0x00, 0x01, 0x02, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x84, 0x00, 0x00, 0x00, 0x01, 0x02, 0x01, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x24, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x0d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x5f, 0xff, 0xf6, 0x00, 0x01, 0x01, 0x02, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x66, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x22, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x47, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x84, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x01, 0x00, 0x00, 0x00, 0x01, 0x03, 0x97, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x97, 0xfe, 0x52, 0x00, 0x01, 0x03, 0x97, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xf3, 0xfe, 0x52, 0x00, 0x01, 0x04, 0x19, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xd0, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x3e, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb5, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe4, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x18, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xe3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x06, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x1c, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xb7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x41, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x01, 0x85, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe0, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x4e, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x29, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x01, 0xcb, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x1c, 0x00, 0x00, 0x00, 0x01, 0x02, 0x21, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xa1, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x28, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0x89, 0x00, 0x01,
-  0x02, 0x28, 0xfe, 0x89, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0xbf, 0x00, 0x01,
-  0x02, 0x28, 0xfe, 0xbf, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0x74, 0x00, 0x01,
-  0x02, 0x28, 0xfe, 0x74, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0x15, 0x00, 0x01,
-  0x02, 0x28, 0xfe, 0x15, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x03, 0x37, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xb7, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf7, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0xd5, 0x00, 0x00, 0x00, 0x01, 0x02, 0xfd, 0xfe, 0x52, 0x00, 0x01,
-  0x03, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0xda, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xa7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x94, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xda, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe2, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xd3, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xbf, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x03, 0x2a, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x3c, 0x00, 0x00, 0x00, 0x01, 0x03, 0x08, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xad, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3a, 0xfe, 0x52, 0x00, 0x01,
-  0x03, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe2, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xc4, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7f, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x33, 0x00, 0x00, 0x00, 0x01, 0x03, 0xde, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xc7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7f, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xc1, 0x00, 0x08, 0x00, 0x01, 0x02, 0x5a, 0x00, 0x07, 0x00, 0x01,
-  0x01, 0x56, 0x00, 0x00, 0x00, 0x01, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x09, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xaf, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x0e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x71, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x56, 0x00, 0x00, 0x00, 0x01, 0x02, 0x56, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x18, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb5, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x1a, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x7c, 0xff, 0xe4, 0x00, 0x01, 0x02, 0x21, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb5, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x5f, 0x00, 0x00, 0x00, 0x01, 0x01, 0xfc, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x01, 0xa5, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x51, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x77, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0xb5, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x48, 0xfe, 0x52, 0x00, 0x01,
-  0x03, 0x1e, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x5b, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x0f, 0xfe, 0x56, 0x00, 0x01, 0x01, 0xe3, 0x00, 0x00, 0x00, 0x01,
-  0x04, 0x80, 0x00, 0x00, 0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0xc5, 0x00, 0x00, 0x00, 0x01, 0x03, 0x74, 0x00, 0x00, 0x00, 0x01,
-  0x04, 0x4a, 0x00, 0x00, 0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x96, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1d, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x96, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1d, 0xff, 0xf6, 0x00, 0x01,
-  0x03, 0x96, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1d, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x69, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x39, 0x00, 0x00, 0x00, 0x01, 0x01, 0x69, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x83, 0x00, 0x00, 0x00, 0x01, 0x01, 0x83, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xe8, 0x00, 0x00, 0x00, 0x01, 0x02, 0x85, 0x00, 0x00, 0x00, 0x01,
-  0x04, 0xe3, 0x00, 0x00, 0x00, 0x01, 0x03, 0xaa, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
-  0x03, 0x4c, 0x00, 0x00, 0x00, 0x01, 0x03, 0x63, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0xab, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0xbe, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
-  0x01, 0xc4, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xa9, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x03, 0x06, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa9, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x51, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xee, 0x00, 0x00, 0x00, 0x01, 0x03, 0x0f, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0x4b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x11, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0xfc, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1a, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x04, 0x51, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xa9, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xe9, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb9, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xb9, 0x00, 0x00, 0x00, 0x01, 0x03, 0x06, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x69, 0x00, 0x00, 0x00, 0x01, 0x01, 0x68, 0xfe, 0x52, 0x00, 0x01,
-  0x02, 0xb5, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa8, 0x00, 0x00, 0x00, 0x01,
-  0x03, 0xb0, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd5, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x40, 0x00, 0x00, 0x00, 0x01, 0x02, 0x8c, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xfd, 0x00, 0x00, 0x00, 0x01, 0x02, 0x9a, 0x00, 0x00, 0x00, 0x01,
-  0x04, 0x05, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe6, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x8b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x6e, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x37, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x01, 0x02, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x62, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x01, 0x99, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0x3d, 0xfe, 0x52, 0x00, 0x02, 0x00, 0x5c, 0x00, 0x13, 0x00, 0x1c,
-  0x00, 0x00, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x0a, 0x00, 0x44, 0x00, 0x5d,
-  0x00, 0x24, 0x00, 0x8e, 0x00, 0x91, 0x00, 0x3e, 0x00, 0x9a, 0x00, 0x9a,
-  0x00, 0x42, 0x00, 0xa8, 0x00, 0xa8, 0x00, 0x43, 0x00, 0xae, 0x00, 0xb2,
-  0x00, 0x44, 0x00, 0xba, 0x00, 0xba, 0x00, 0x49, 0x00, 0xc3, 0x00, 0xc3,
-  0x00, 0x4a, 0x00, 0xc6, 0x00, 0xc7, 0x00, 0x4b, 0x00, 0xd0, 0x00, 0xd1,
-  0x00, 0x4d, 0x00, 0xd5, 0x00, 0xd5, 0x00, 0x4f, 0x00, 0xe9, 0x00, 0xef,
-  0x00, 0x50, 0x00, 0xf2, 0x00, 0xf3, 0x00, 0x57, 0x00, 0xfa, 0x00, 0xfa,
-  0x00, 0x59, 0x01, 0x0d, 0x01, 0x0d, 0x00, 0x5a, 0x01, 0x0f, 0x01, 0x0f,
-  0x00, 0x5b, 0x01, 0x28, 0x01, 0x29, 0x00, 0x5c, 0x01, 0x2d, 0x01, 0x2d,
-  0x00, 0x5e, 0x01, 0x41, 0x01, 0x41, 0x00, 0x5f, 0x01, 0x45, 0x01, 0x45,
-  0x00, 0x60, 0x01, 0x48, 0x01, 0x48, 0x00, 0x61, 0x01, 0x4e, 0x01, 0x4e,
-  0x00, 0x62, 0x01, 0x51, 0x01, 0x52, 0x00, 0x63, 0x01, 0x54, 0x01, 0x54,
-  0x00, 0x65, 0x01, 0x59, 0x01, 0x59, 0x00, 0x66, 0x01, 0x61, 0x01, 0x61,
-  0x00, 0x67, 0x01, 0x6c, 0x01, 0x6c, 0x00, 0x68, 0x01, 0x76, 0x01, 0x76,
-  0x00, 0x69, 0x01, 0x79, 0x01, 0x7b, 0x00, 0x6a, 0x01, 0x91, 0x01, 0x92,
-  0x00, 0x6d, 0x01, 0xca, 0x01, 0xcd, 0x00, 0x6f, 0x01, 0xf6, 0x01, 0xf8,
-  0x00, 0x73, 0x02, 0x05, 0x02, 0x0c, 0x00, 0x76, 0x02, 0x0e, 0x02, 0x4a,
-  0x00, 0x7e, 0x02, 0x4c, 0x02, 0x67, 0x00, 0xbb, 0x02, 0x69, 0x02, 0x6b,
-  0x00, 0xd7, 0x02, 0x6d, 0x02, 0x6d, 0x00, 0xda, 0x03, 0x46, 0x03, 0x46,
-  0x00, 0xdb, 0x03, 0x49, 0x03, 0x49, 0x00, 0xdc, 0x03, 0x4c, 0x03, 0x4c,
-  0x00, 0xdd, 0x03, 0x88, 0x03, 0x88, 0x00, 0xde, 0x03, 0x9a, 0x03, 0x9a,
-  0x00, 0xdf, 0x03, 0xea, 0x03, 0xeb, 0x00, 0xe0, 0x04, 0x06, 0x04, 0x07,
-  0x00, 0xe2, 0x04, 0x22, 0x04, 0x22, 0x00, 0xe4, 0x04, 0x33, 0x04, 0x33,
-  0x00, 0xe5, 0x04, 0x36, 0x04, 0x36, 0x00, 0xe6, 0x04, 0x7c, 0x04, 0x7d,
-  0x00, 0xe7, 0x04, 0xba, 0x04, 0xbb, 0x00, 0xe9, 0x04, 0xbd, 0x04, 0xc2,
-  0x00, 0xeb, 0x04, 0xc5, 0x04, 0xcd, 0x00, 0xf1, 0x04, 0xd1, 0x04, 0xd5,
-  0x00, 0xfa, 0x04, 0xd9, 0x04, 0xde, 0x00, 0xff, 0x05, 0x23, 0x05, 0x23,
-  0x01, 0x05, 0x05, 0x5a, 0x05, 0x63, 0x01, 0x06, 0x05, 0x7e, 0x05, 0x7f,
-  0x01, 0x10, 0x06, 0x18, 0x06, 0x19, 0x01, 0x12, 0x06, 0x4a, 0x06, 0x4b,
-  0x01, 0x14, 0x07, 0xec, 0x07, 0xec, 0x01, 0x16, 0x07, 0xf4, 0x07, 0xf7,
-  0x01, 0x17, 0x07, 0xf9, 0x07, 0xfb, 0x01, 0x1b, 0x07, 0xfe, 0x07, 0xfe,
-  0x01, 0x1e, 0x08, 0x01, 0x08, 0x06, 0x01, 0x1f, 0x08, 0x0d, 0x08, 0x0d,
-  0x01, 0x25, 0x08, 0x11, 0x08, 0x11, 0x01, 0x26, 0x08, 0x15, 0x08, 0x16,
-  0x01, 0x27, 0x08, 0x18, 0x08, 0x1a, 0x01, 0x29, 0x08, 0x1c, 0x08, 0x1c,
-  0x01, 0x2c, 0x08, 0x1e, 0x08, 0x22, 0x01, 0x2d, 0x08, 0x25, 0x08, 0x28,
-  0x01, 0x32, 0x0a, 0x1d, 0x0a, 0x1d, 0x01, 0x36, 0x0e, 0x2b, 0x0e, 0x2b,
-  0x01, 0x37, 0x0e, 0x2d, 0x0e, 0x2e, 0x01, 0x38, 0x0e, 0x30, 0x0e, 0x41,
-  0x01, 0x3a, 0x0e, 0x43, 0x0e, 0x45, 0x01, 0x4c, 0x0e, 0x48, 0x0e, 0x49,
-  0x01, 0x4f, 0x0e, 0x62, 0x0e, 0x65, 0x01, 0x51, 0x0e, 0x67, 0x0e, 0x68,
-  0x01, 0x55, 0x0e, 0x6a, 0x0e, 0x75, 0x01, 0x57, 0x0e, 0x78, 0x0e, 0x87,
-  0x01, 0x63, 0x0e, 0x8c, 0x0e, 0x8f, 0x01, 0x73, 0x0e, 0x95, 0x0e, 0xa8,
-  0x01, 0x77, 0x0f, 0x93, 0x0f, 0xa5, 0x01, 0x8b, 0x0f, 0xbd, 0x0f, 0xbd,
-  0x01, 0x9e, 0x0f, 0xbf, 0x0f, 0xbf, 0x01, 0x9f, 0x0f, 0xf4, 0x0f, 0xfd,
-  0x01, 0xa0, 0x11, 0x1c, 0x11, 0x1d, 0x01, 0xaa, 0x11, 0x34, 0x11, 0x34,
-  0x01, 0xac, 0x11, 0x3e, 0x11, 0x3e, 0x01, 0xad, 0x11, 0x48, 0x11, 0x48,
-  0x01, 0xae, 0x11, 0xb8, 0x11, 0xb8, 0x01, 0xaf, 0x00, 0x02, 0x00, 0x09,
-  0x02, 0xc7, 0x02, 0xca, 0x00, 0x00, 0x02, 0xcd, 0x02, 0xd1, 0x00, 0x04,
-  0x02, 0xd4, 0x02, 0xd7, 0x00, 0x09, 0x02, 0xda, 0x02, 0xe4, 0x00, 0x0d,
-  0x02, 0xea, 0x02, 0xed, 0x00, 0x18, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x1c,
-  0x02, 0xfe, 0x02, 0xff, 0x00, 0x1f, 0x03, 0x03, 0x03, 0x03, 0x00, 0x21,
-  0x03, 0x06, 0x03, 0x06, 0x00, 0x22, 0x00, 0x23, 0x00, 0x00, 0x00, 0x8e,
-  0x00, 0x00, 0x00, 0x94, 0x00, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x00, 0xa0,
-  0x00, 0x00, 0x00, 0xa6, 0x00, 0x00, 0x00, 0xac, 0x00, 0x00, 0x00, 0xb2,
-  0x00, 0x00, 0x00, 0xb8, 0x00, 0x00, 0x00, 0xbe, 0x00, 0x00, 0x00, 0xc4,
-  0x00, 0x00, 0x00, 0xca, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0x00, 0xd6,
-  0x00, 0x00, 0x00, 0xdc, 0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe8,
-  0x00, 0x00, 0x00, 0xee, 0x00, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xfa,
-  0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0c,
-  0x00, 0x00, 0x01, 0x12, 0x00, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x1e,
-  0x00, 0x00, 0x01, 0x24, 0x00, 0x00, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x30,
-  0x00, 0x00, 0x01, 0x36, 0x00, 0x00, 0x01, 0x3c, 0x00, 0x00, 0x01, 0x42,
-  0x00, 0x00, 0x01, 0x48, 0x00, 0x00, 0x01, 0x4e, 0x00, 0x00, 0x01, 0x54,
-  0x00, 0x00, 0x01, 0x5a, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01,
-  0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x35, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
-  0x15, 0x68, 0x12, 0xca, 0x00, 0x01, 0x15, 0xb4, 0x00, 0x0c, 0x02, 0x53,
-  0x04, 0xa8, 0x04, 0xae, 0x04, 0xb4, 0x04, 0xba, 0x04, 0xc0, 0x04, 0xc6,
-  0x04, 0xcc, 0x04, 0xd2, 0x04, 0xd8, 0x04, 0xde, 0x04, 0xe4, 0x04, 0xea,
-  0x04, 0xf0, 0x04, 0xf6, 0x04, 0xfc, 0x05, 0x02, 0x05, 0x08, 0x05, 0x0e,
-  0x05, 0x14, 0x05, 0x1a, 0x05, 0x20, 0x05, 0x26, 0x05, 0x2c, 0x05, 0x32,
-  0x05, 0x38, 0x05, 0x3e, 0x05, 0x44, 0x05, 0x4a, 0x05, 0x50, 0x05, 0x56,
-  0x05, 0x5c, 0x05, 0x62, 0x05, 0x68, 0x05, 0x6e, 0x05, 0x74, 0x05, 0x7a,
-  0x05, 0x80, 0x05, 0x88, 0x05, 0x8e, 0x05, 0x96, 0x05, 0x9c, 0x05, 0xa4,
-  0x05, 0xaa, 0x05, 0xb0, 0x05, 0xb6, 0x05, 0xbc, 0x05, 0xc2, 0x05, 0xc8,
-  0x05, 0xce, 0x05, 0xd4, 0x05, 0xda, 0x05, 0xe2, 0x05, 0xe8, 0x05, 0xee,
-  0x05, 0xf4, 0x05, 0xfa, 0x06, 0x00, 0x06, 0x08, 0x06, 0x0e, 0x06, 0x14,
-  0x06, 0x1a, 0x06, 0x20, 0x06, 0x26, 0x06, 0x2c, 0x06, 0x32, 0x06, 0x38,
-  0x06, 0x3e, 0x06, 0x46, 0x06, 0x4c, 0x06, 0x52, 0x06, 0x5a, 0x06, 0x60,
-  0x06, 0x66, 0x06, 0x6c, 0x06, 0x74, 0x06, 0x7a, 0x06, 0x80, 0x06, 0x86,
-  0x06, 0x8c, 0x06, 0x92, 0x06, 0x98, 0x06, 0x9e, 0x06, 0xa4, 0x06, 0xaa,
-  0x06, 0xb0, 0x06, 0xb6, 0x06, 0xbc, 0x06, 0xc2, 0x06, 0xc8, 0x06, 0xce,
-  0x06, 0xd4, 0x06, 0xda, 0x06, 0xe0, 0x06, 0xe6, 0x06, 0xec, 0x06, 0xf2,
-  0x06, 0xf8, 0x06, 0xfe, 0x07, 0x04, 0x07, 0x0a, 0x07, 0x10, 0x07, 0x16,
-  0x07, 0x1c, 0x07, 0x22, 0x07, 0x28, 0x07, 0x2e, 0x07, 0x34, 0x07, 0x3a,
-  0x07, 0x40, 0x07, 0x46, 0x07, 0x4c, 0x07, 0x52, 0x07, 0x58, 0x07, 0x5e,
-  0x07, 0x64, 0x07, 0x6a, 0x07, 0x70, 0x07, 0x76, 0x07, 0x7c, 0x07, 0x82,
-  0x07, 0x88, 0x07, 0x8e, 0x07, 0x94, 0x07, 0x9a, 0x07, 0xa0, 0x07, 0xa6,
-  0x07, 0xac, 0x07, 0xb2, 0x07, 0xb8, 0x07, 0xbe, 0x07, 0xc4, 0x07, 0xca,
-  0x07, 0xd0, 0x07, 0xd6, 0x07, 0xdc, 0x07, 0xe2, 0x07, 0xe8, 0x07, 0xee,
-  0x07, 0xf6, 0x07, 0xfc, 0x08, 0x02, 0x08, 0x08, 0x08, 0x0e, 0x08, 0x14,
-  0x08, 0x1a, 0x08, 0x22, 0x08, 0x28, 0x08, 0x2e, 0x08, 0x34, 0x08, 0x3a,
-  0x08, 0x40, 0x08, 0x46, 0x08, 0x4c, 0x08, 0x52, 0x08, 0x58, 0x08, 0x5e,
-  0x08, 0x64, 0x08, 0x6a, 0x08, 0x70, 0x08, 0x76, 0x08, 0x7c, 0x08, 0x82,
-  0x08, 0x88, 0x08, 0x8e, 0x08, 0x94, 0x08, 0x9a, 0x08, 0xa0, 0x08, 0xa6,
-  0x08, 0xac, 0x08, 0xb2, 0x08, 0xb8, 0x08, 0xc0, 0x08, 0xc6, 0x08, 0xcc,
-  0x08, 0xd2, 0x08, 0xd8, 0x08, 0xde, 0x08, 0xe4, 0x08, 0xea, 0x08, 0xf0,
-  0x08, 0xf6, 0x08, 0xfc, 0x09, 0x02, 0x09, 0x08, 0x09, 0x0e, 0x09, 0x14,
-  0x09, 0x1a, 0x09, 0x20, 0x09, 0x26, 0x09, 0x2c, 0x09, 0x32, 0x09, 0x38,
-  0x09, 0x3e, 0x09, 0x44, 0x09, 0x4a, 0x09, 0x50, 0x09, 0x56, 0x09, 0x5c,
-  0x09, 0x62, 0x09, 0x68, 0x09, 0x6e, 0x09, 0x74, 0x09, 0x7a, 0x09, 0x80,
-  0x09, 0x86, 0x09, 0x8c, 0x09, 0x92, 0x09, 0x98, 0x09, 0x9e, 0x09, 0xa4,
-  0x09, 0xaa, 0x09, 0xb0, 0x09, 0xb6, 0x09, 0xbc, 0x09, 0xc2, 0x09, 0xc8,
-  0x09, 0xce, 0x09, 0xd4, 0x09, 0xda, 0x09, 0xe0, 0x09, 0xe6, 0x09, 0xec,
-  0x09, 0xf2, 0x09, 0xf8, 0x09, 0xfe, 0x0a, 0x04, 0x0a, 0x0a, 0x0a, 0x12,
-  0x0a, 0x18, 0x0a, 0x1e, 0x0a, 0x24, 0x0a, 0x2a, 0x0a, 0x30, 0x0a, 0x36,
-  0x0a, 0x3c, 0x0a, 0x42, 0x0a, 0x48, 0x0a, 0x4e, 0x0a, 0x54, 0x0a, 0x5a,
-  0x0a, 0x60, 0x0a, 0x66, 0x0a, 0x6c, 0x0a, 0x72, 0x0a, 0x78, 0x0a, 0x7e,
-  0x0a, 0x84, 0x0a, 0x8a, 0x0a, 0x90, 0x0a, 0x96, 0x0a, 0x9c, 0x0a, 0xa2,
-  0x0a, 0xa8, 0x0a, 0xae, 0x0a, 0xb4, 0x0a, 0xba, 0x0a, 0xc0, 0x0a, 0xc6,
-  0x0a, 0xcc, 0x0a, 0xd2, 0x0a, 0xd8, 0x0a, 0xde, 0x0a, 0xe4, 0x0a, 0xea,
-  0x0a, 0xf0, 0x0a, 0xf6, 0x0a, 0xfc, 0x0b, 0x02, 0x0b, 0x08, 0x0b, 0x0e,
-  0x0b, 0x14, 0x0b, 0x1a, 0x0b, 0x20, 0x0b, 0x26, 0x0b, 0x2c, 0x0b, 0x32,
-  0x0b, 0x38, 0x0b, 0x3e, 0x0b, 0x44, 0x0b, 0x4a, 0x0b, 0x50, 0x0b, 0x56,
-  0x0b, 0x5c, 0x0b, 0x62, 0x0b, 0x68, 0x0b, 0x6e, 0x0b, 0x74, 0x0b, 0x7a,
-  0x0b, 0x80, 0x0b, 0x86, 0x0b, 0x8c, 0x0b, 0x92, 0x0b, 0x98, 0x0b, 0x9e,
-  0x0b, 0xa4, 0x0b, 0xaa, 0x0b, 0xb0, 0x0b, 0xb6, 0x0b, 0xbc, 0x0b, 0xc2,
-  0x0b, 0xc8, 0x0b, 0xce, 0x0b, 0xd4, 0x0b, 0xda, 0x0b, 0xe0, 0x0b, 0xe6,
-  0x0b, 0xec, 0x0b, 0xf2, 0x0b, 0xf8, 0x0b, 0xfe, 0x0c, 0x04, 0x0c, 0x0a,
-  0x0c, 0x10, 0x0c, 0x16, 0x0c, 0x1c, 0x0c, 0x22, 0x0c, 0x28, 0x0c, 0x2e,
-  0x0c, 0x34, 0x0c, 0x3a, 0x0c, 0x40, 0x0c, 0x46, 0x0c, 0x4c, 0x0c, 0x52,
-  0x0c, 0x58, 0x0c, 0x5e, 0x0c, 0x64, 0x0c, 0x6a, 0x0c, 0x70, 0x0c, 0x76,
-  0x0c, 0x7c, 0x0c, 0x82, 0x0c, 0x88, 0x0c, 0x8e, 0x0c, 0x94, 0x0c, 0x9a,
-  0x0c, 0xa0, 0x0c, 0xa6, 0x0c, 0xac, 0x0c, 0xb2, 0x0c, 0xb8, 0x0c, 0xbe,
-  0x0c, 0xc4, 0x0c, 0xca, 0x0c, 0xd0, 0x0c, 0xd6, 0x0c, 0xdc, 0x0c, 0xe2,
-  0x0c, 0xe8, 0x0c, 0xee, 0x0c, 0xf4, 0x0c, 0xfa, 0x0d, 0x00, 0x0d, 0x06,
-  0x0d, 0x0c, 0x0d, 0x12, 0x0d, 0x18, 0x0d, 0x1e, 0x0d, 0x24, 0x0d, 0x2a,
-  0x0d, 0x30, 0x0d, 0x36, 0x0d, 0x3c, 0x0d, 0x42, 0x0d, 0x48, 0x0d, 0x4e,
-  0x0d, 0x54, 0x0d, 0x5a, 0x0d, 0x60, 0x0d, 0x66, 0x0d, 0x6c, 0x0d, 0x72,
-  0x0d, 0x78, 0x0d, 0x7e, 0x0d, 0x84, 0x0d, 0x8a, 0x0d, 0x90, 0x0d, 0x96,
-  0x0d, 0x9c, 0x0d, 0xa2, 0x0d, 0xa8, 0x0d, 0xae, 0x0d, 0xb4, 0x0d, 0xba,
-  0x0d, 0xc0, 0x0d, 0xc6, 0x0d, 0xcc, 0x0d, 0xd2, 0x0d, 0xd8, 0x0d, 0xde,
-  0x0d, 0xe4, 0x0d, 0xea, 0x0d, 0xf0, 0x0d, 0xf6, 0x0d, 0xfc, 0x0e, 0x02,
-  0x0e, 0x08, 0x0e, 0x0e, 0x0e, 0x14, 0x0e, 0x1a, 0x0e, 0x20, 0x0e, 0x26,
-  0x0e, 0x2c, 0x0e, 0x32, 0x0e, 0x38, 0x0e, 0x3e, 0x0e, 0x44, 0x0e, 0x4a,
-  0x0e, 0x50, 0x0e, 0x56, 0x0e, 0x5c, 0x0e, 0x62, 0x0e, 0x68, 0x0e, 0x6e,
-  0x0e, 0x74, 0x0e, 0x7a, 0x0e, 0x80, 0x0e, 0x86, 0x0e, 0x8c, 0x0e, 0x92,
-  0x0e, 0x98, 0x0e, 0x9e, 0x0e, 0xa4, 0x0e, 0xaa, 0x0e, 0xb0, 0x0e, 0xb6,
-  0x0e, 0xbc, 0x0e, 0xc2, 0x0e, 0xc8, 0x0e, 0xce, 0x0e, 0xd4, 0x0e, 0xda,
-  0x0e, 0xe2, 0x0e, 0xe8, 0x0e, 0xee, 0x0e, 0xf4, 0x0e, 0xfa, 0x0f, 0x00,
-  0x0f, 0x06, 0x0f, 0x0c, 0x0f, 0x12, 0x0f, 0x18, 0x0f, 0x1e, 0x0f, 0x26,
-  0x0f, 0x2c, 0x0f, 0x32, 0x0f, 0x38, 0x0f, 0x3e, 0x0f, 0x44, 0x0f, 0x4a,
-  0x0f, 0x50, 0x0f, 0x56, 0x0f, 0x5c, 0x0f, 0x62, 0x0f, 0x68, 0x0f, 0x6e,
-  0x0f, 0x74, 0x0f, 0x7a, 0x0f, 0x80, 0x0f, 0x86, 0x0f, 0x8c, 0x0f, 0x92,
-  0x0f, 0x98, 0x0f, 0x9e, 0x0f, 0xa4, 0x0f, 0xaa, 0x0f, 0xb0, 0x0f, 0xb6,
-  0x0f, 0xbc, 0x0f, 0xc2, 0x0f, 0xc8, 0x0f, 0xce, 0x0f, 0xd4, 0x0f, 0xda,
-  0x0f, 0xe0, 0x0f, 0xe6, 0x0f, 0xec, 0x0f, 0xf2, 0x0f, 0xf8, 0x0f, 0xfe,
-  0x10, 0x04, 0x10, 0x0a, 0x10, 0x10, 0x10, 0x16, 0x10, 0x1c, 0x10, 0x22,
-  0x10, 0x28, 0x10, 0x2e, 0x10, 0x34, 0x10, 0x3a, 0x10, 0x40, 0x10, 0x46,
-  0x10, 0x4c, 0x10, 0x52, 0x10, 0x58, 0x10, 0x5e, 0x10, 0x64, 0x10, 0x6a,
-  0x10, 0x72, 0x10, 0x78, 0x10, 0x7e, 0x10, 0x84, 0x10, 0x8a, 0x10, 0x90,
-  0x10, 0x96, 0x10, 0x9c, 0x10, 0xa2, 0x10, 0xa8, 0x10, 0xae, 0x10, 0xb4,
-  0x10, 0xba, 0x10, 0xc0, 0x10, 0xc6, 0x10, 0xcc, 0x10, 0xd2, 0x10, 0xd8,
-  0x10, 0xde, 0x10, 0xe4, 0x10, 0xea, 0x10, 0xf2, 0x10, 0xf8, 0x10, 0xfe,
-  0x11, 0x04, 0x11, 0x0a, 0x11, 0x10, 0x11, 0x16, 0x11, 0x1c, 0x11, 0x22,
-  0x11, 0x28, 0x11, 0x2e, 0x11, 0x34, 0x11, 0x3c, 0x11, 0x42, 0x11, 0x48,
-  0x11, 0x4e, 0x11, 0x54, 0x11, 0x5a, 0x11, 0x60, 0x11, 0x66, 0x11, 0x6c,
-  0x11, 0x72, 0x11, 0x78, 0x11, 0x7e, 0x11, 0x84, 0x11, 0x8a, 0x11, 0x90,
-  0x11, 0x96, 0x11, 0x9c, 0x11, 0xa2, 0x11, 0xa8, 0x11, 0xae, 0x11, 0xb4,
-  0x11, 0xba, 0x11, 0xc0, 0x11, 0xc6, 0x11, 0xcc, 0x11, 0xd2, 0x11, 0xd8,
-  0x11, 0xde, 0x11, 0xe4, 0x11, 0xea, 0x11, 0xf0, 0x11, 0xf6, 0x11, 0xfc,
-  0x12, 0x02, 0x12, 0x08, 0x12, 0x0e, 0x12, 0x14, 0x12, 0x1a, 0x12, 0x20,
-  0x12, 0x26, 0x12, 0x2c, 0x12, 0x32, 0x12, 0x38, 0x12, 0x3e, 0x12, 0x44,
-  0x12, 0x4a, 0x12, 0x50, 0x12, 0x56, 0x12, 0x5c, 0x12, 0x62, 0x12, 0x68,
-  0x12, 0x6e, 0x12, 0x74, 0x12, 0x7a, 0x12, 0x80, 0x12, 0x86, 0x12, 0x8c,
-  0x12, 0x92, 0x12, 0x98, 0x12, 0x9e, 0x12, 0xa4, 0x12, 0xaa, 0x12, 0xb0,
-  0x12, 0xb6, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xf7, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x06, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x10, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0f,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x51, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x34,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x8f, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x85,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x33, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x77,
-  0x05, 0xf0, 0x00, 0x02, 0x02, 0x0f, 0x04, 0x7b, 0x00, 0x23, 0x00, 0x01,
-  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x60, 0x04, 0x7b, 0x00, 0x17,
-  0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x53, 0x04, 0x7b,
-  0x00, 0x12, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x2c,
-  0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x02,
-  0x06, 0x2f, 0x00, 0x01, 0x01, 0x02, 0x06, 0x2f, 0x00, 0x01, 0x00, 0xfa,
-  0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x84,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x02, 0x02, 0x34,
-  0x04, 0x7b, 0x00, 0x0c, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01,
-  0x02, 0x30, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01,
-  0x01, 0xef, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0, 0x00, 0x02,
-  0x02, 0x3d, 0x04, 0x7b, 0x00, 0x14, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x23, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x7f, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
-  0x00, 0x02, 0x02, 0x34, 0x04, 0x7b, 0x00, 0x1a, 0x00, 0x01, 0x00, 0xfa,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x0f,
-  0x04, 0x7b, 0x00, 0x23, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01,
-  0x03, 0x4c, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x2f, 0x05, 0xf0, 0x00, 0x02,
-  0x01, 0x00, 0x04, 0x7b, 0x00, 0x04, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x03, 0xab, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x1f, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xf7, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x7d, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x1b, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0x06, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x78, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0x10, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x10, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0xfb, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x41, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x79, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xef, 0x04, 0x7b,
-  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x63, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x33, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x77, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x77, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x53, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x47, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0xf3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b,
-  0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x4b, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x0f, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0x02, 0x06, 0x2f, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x33, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x46, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x8d, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x02, 0x01, 0x9f, 0x04, 0x7b, 0x00, 0x03, 0x00, 0x01, 0x02, 0x62,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x97,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x16,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x16, 0x04, 0x7b, 0x00, 0x02, 0x02, 0x0f,
-  0x04, 0x7c, 0x00, 0x08, 0x00, 0x01, 0x02, 0x06, 0x04, 0x7b, 0x00, 0x01,
-  0x02, 0x06, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x04, 0x7b, 0x00, 0x01,
-  0x01, 0x02, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x2c, 0x05, 0xf0, 0x00, 0x01,
-  0x02, 0x2c, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01,
-  0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01,
-  0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01,
-  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x01, 0x06, 0x2f, 0x00, 0x01,
-  0x00, 0xec, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x59, 0x04, 0x7b, 0x00, 0x01,
-  0x01, 0x70, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xcb, 0x05, 0xf0, 0x00, 0x01,
-  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01,
-  0x03, 0x84, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x01,
-  0x03, 0x84, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01,
-  0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x02,
-  0x02, 0x34, 0x04, 0x7b, 0x00, 0x0e, 0x00, 0x01, 0x04, 0x18, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x9e, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xfa, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xfa, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x24, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x31, 0x04, 0x7b,
-  0x00, 0x01, 0x01, 0x5b, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x01, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x15, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xef, 0x04, 0x7b,
-  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xbf, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xd9, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x21, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x26, 0x04, 0x7b,
-  0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
-  0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
-  0x00, 0x01, 0x01, 0x84, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x01, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0x84, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x01, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x24, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x0d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x5f, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x06, 0x2f,
-  0x00, 0x01, 0x02, 0x66, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x2c, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x84, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x01, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xf3, 0x05, 0xf0, 0x00, 0x01, 0x04, 0x19, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0xd0, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x0f, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3e, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
-  0x00, 0x02, 0x02, 0x0f, 0x04, 0x7c, 0x00, 0x08, 0x00, 0x01, 0x02, 0x0a,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
-  0x05, 0xf0, 0x00, 0x01, 0x00, 0xf4, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5f,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x46,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0xe0, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x0a,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x31,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x35,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x2c,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0xe4, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x65,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x60,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x07, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3e,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x3e, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5c,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x35, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x07,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02,
-  0x06, 0x2f, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x62,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0xc0, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xf4,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x51, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x10,
-  0x05, 0xf0, 0x00, 0x01, 0x04, 0x59, 0x05, 0xf0, 0x00, 0x01, 0x04, 0x00,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x56, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1b,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x03, 0xe0,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x23,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xf7,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x30,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x18, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x85,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x6d,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0xd9, 0x05, 0xf0, 0x00, 0x01, 0x03, 0xd9,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x2c,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x13,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x96,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x58,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x24, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x0a,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xaa, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x4b,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x3e, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x06,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x35,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xac, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xb7,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x5a, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x23, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x13,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5a,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x10, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x4b,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x4b, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xd2,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xcd, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0x86, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xaa,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x35, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0xef, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02,
-  0x06, 0x2f, 0x00, 0x01, 0x01, 0x02, 0x06, 0x2f, 0x00, 0x01, 0x01, 0x02,
-  0x06, 0x2f, 0x00, 0x01, 0x03, 0x94, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x8d,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0x15, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x5c, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x07,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0xc1, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0c,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xaa,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x2a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd1,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0xe0, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3a,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xda, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0xe0, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3a,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xc5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd4,
-  0x05, 0xfa, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xcf, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x52,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x62,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0xe0, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3e,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x35,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x35,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0xb1, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0e,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x34,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x10, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5f,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xb7,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x0a, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x85,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xac,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x35,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xac, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x41,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe4,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0xab, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18,
-  0x04, 0x83, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe3,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x06, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
-  0x04, 0x7b, 0x00, 0x01, 0x00, 0xfc, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xb7,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0x85, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x76,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x76, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x76,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0xab, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe0,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x4e, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x4e,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x29,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x21,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1,
-  0x04, 0x7b, 0x00, 0x01, 0x01, 0xcb, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfc,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xac,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xa1,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
-  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x37,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0xb7, 0x05, 0xf0, 0x00, 0x02, 0x02, 0xf7,
-  0x05, 0xf0, 0x00, 0x16, 0x00, 0x01, 0x03, 0xd5, 0x05, 0xf0, 0x00, 0x01,
-  0x02, 0xfd, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0f, 0x05, 0xf0, 0x00, 0x01,
-  0x01, 0x98, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xa7, 0x05, 0xf0, 0x00, 0x01,
-  0x02, 0x94, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xda, 0x05, 0xf0, 0x00, 0x01,
-  0x02, 0xe2, 0x05, 0xe2, 0x00, 0x01, 0x02, 0xd3, 0x04, 0x7b, 0x00, 0x01,
-  0x02, 0xbf, 0x05, 0xf0, 0x00, 0x02, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x0c,
-  0x00, 0x01, 0x03, 0x2a, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3c, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0x08, 0x05, 0xe2, 0x00, 0x01, 0x02, 0xad, 0x05, 0xe2,
-  0x00, 0x01, 0x02, 0x3a, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0f, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xe2, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x82, 0x04, 0x44,
-  0x00, 0x01, 0x02, 0x7f, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x33, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0xde, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xc7, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x7f, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xc1, 0x05, 0xe7,
-  0x00, 0x01, 0x02, 0x5a, 0x05, 0xe7, 0x00, 0x01, 0x01, 0x56, 0x06, 0x31,
-  0x00, 0x01, 0x02, 0xab, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x09, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0xaf, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0e, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x77, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x7c, 0x05, 0xd3,
-  0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x8f, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5f, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x65, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x34, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xa5, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x51, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x77, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0x1e, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0,
-  0x00, 0x02, 0x02, 0x0f, 0x04, 0x7b, 0x00, 0x08, 0x00, 0x01, 0x01, 0xe3,
-  0x04, 0x7b, 0x00, 0x01, 0x04, 0x80, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x6f,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0xc5, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x74,
-  0x04, 0x7b, 0x00, 0x01, 0x04, 0x4a, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x6f,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x96, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1d,
-  0x04, 0x7b, 0x00, 0x01, 0x03, 0x96, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1d,
-  0x04, 0x71, 0x00, 0x01, 0x03, 0x96, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1d,
-  0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x01,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x69,
-  0x05, 0xf0, 0x00, 0x01, 0x01, 0x39, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x83,
-  0x05, 0xf0, 0x00, 0x01, 0x02, 0xe8, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x85,
-  0x04, 0x7b, 0x00, 0x00, 0x00, 0x01, 0x04, 0xe3, 0x05, 0xf0, 0x00, 0x01,
-  0x03, 0xaa, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01,
-  0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x4c, 0x05, 0xf0, 0x00, 0x01,
-  0x03, 0x63, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01,
-  0x02, 0x30, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01,
-  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xab, 0x05, 0xf0, 0x00, 0x02,
-  0x01, 0x00, 0x04, 0x7b, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa4, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x6d, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xc4, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x06, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x2c, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0,
-  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x51, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xef, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x0f, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0x4b, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x11, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0xfc, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0x10, 0x07, 0x88, 0x00, 0x01, 0x04, 0x51, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xe9, 0x06, 0x04, 0x00, 0x01, 0x02, 0xb9, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xb9, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x06, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0x69, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x68, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa8, 0x05, 0xf0,
-  0x00, 0x01, 0x03, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd5, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x40, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x8c, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0xfd, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x9a, 0x05, 0xf0,
-  0x00, 0x01, 0x04, 0x05, 0x05, 0xf7, 0x00, 0x01, 0x02, 0xe6, 0x05, 0xf7,
-  0x00, 0x01, 0x02, 0x8b, 0x05, 0xf7, 0x00, 0x01, 0x02, 0x6e, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x1f, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x37, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
-  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0x01, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
-  0x00, 0x01, 0x02, 0x9f, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
-  0x00, 0x01, 0x01, 0x02, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
-  0x00, 0x01, 0x01, 0x02, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x99, 0x05, 0xf0,
-  0x00, 0x02, 0x03, 0x43, 0x00, 0x6a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6f,
-  0x00, 0x13, 0x00, 0x1c, 0x00, 0x00, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x0a,
-  0x00, 0x44, 0x00, 0x5d, 0x00, 0x24, 0x00, 0x9a, 0x00, 0x9a, 0x00, 0x3e,
-  0x00, 0xa8, 0x00, 0xa9, 0x00, 0x3f, 0x00, 0xb2, 0x00, 0xb2, 0x00, 0x41,
-  0x00, 0xba, 0x00, 0xba, 0x00, 0x42, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0x43,
-  0x00, 0xc6, 0x00, 0xc7, 0x00, 0x44, 0x00, 0xd1, 0x00, 0xd1, 0x00, 0x46,
-  0x00, 0xe8, 0x00, 0xe9, 0x00, 0x47, 0x00, 0xf3, 0x00, 0xf3, 0x00, 0x49,
-  0x00, 0xfa, 0x00, 0xfa, 0x00, 0x4a, 0x01, 0x0d, 0x01, 0x0d, 0x00, 0x4b,
-  0x01, 0x15, 0x01, 0x15, 0x00, 0x4c, 0x01, 0x28, 0x01, 0x29, 0x00, 0x4d,
-  0x01, 0x35, 0x01, 0x35, 0x00, 0x4f, 0x01, 0x41, 0x01, 0x42, 0x00, 0x50,
-  0x01, 0x45, 0x01, 0x45, 0x00, 0x52, 0x01, 0x48, 0x01, 0x49, 0x00, 0x53,
-  0x01, 0x4e, 0x01, 0x4e, 0x00, 0x55, 0x01, 0x50, 0x01, 0x56, 0x00, 0x56,
-  0x01, 0x58, 0x01, 0x59, 0x00, 0x5d, 0x01, 0x5b, 0x01, 0x5d, 0x00, 0x5f,
-  0x01, 0x5f, 0x01, 0x5f, 0x00, 0x62, 0x01, 0x61, 0x01, 0x61, 0x00, 0x63,
-  0x01, 0x66, 0x01, 0x66, 0x00, 0x64, 0x01, 0x69, 0x01, 0x6a, 0x00, 0x65,
-  0x01, 0x6c, 0x01, 0x70, 0x00, 0x67, 0x01, 0x74, 0x01, 0x7b, 0x00, 0x6c,
-  0x01, 0xac, 0x01, 0xac, 0x00, 0x74, 0x01, 0xf6, 0x01, 0xf9, 0x00, 0x75,
-  0x02, 0x05, 0x02, 0x0c, 0x00, 0x79, 0x02, 0x0e, 0x02, 0x4a, 0x00, 0x81,
-  0x02, 0x4c, 0x02, 0x67, 0x00, 0xbe, 0x02, 0x69, 0x02, 0x6b, 0x00, 0xda,
-  0x02, 0x6d, 0x02, 0x6d, 0x00, 0xdd, 0x03, 0x45, 0x03, 0x5d, 0x00, 0xde,
-  0x03, 0x64, 0x03, 0x65, 0x00, 0xf7, 0x03, 0x69, 0x03, 0x69, 0x00, 0xf9,
-  0x03, 0x6b, 0x03, 0x6b, 0x00, 0xfa, 0x03, 0x6d, 0x03, 0x6d, 0x00, 0xfb,
-  0x03, 0x6f, 0x03, 0x6f, 0x00, 0xfc, 0x03, 0x77, 0x03, 0x77, 0x00, 0xfd,
-  0x03, 0x84, 0x03, 0x8a, 0x00, 0xfe, 0x03, 0x8c, 0x03, 0x8c, 0x01, 0x05,
-  0x03, 0x90, 0x03, 0x90, 0x01, 0x06, 0x03, 0x98, 0x03, 0x9a, 0x01, 0x07,
-  0x03, 0x9d, 0x03, 0x9e, 0x01, 0x0a, 0x03, 0xa3, 0x03, 0xac, 0x01, 0x0c,
-  0x03, 0xae, 0x03, 0xcc, 0x01, 0x16, 0x03, 0xce, 0x03, 0xe3, 0x01, 0x35,
-  0x03, 0xe8, 0x03, 0xef, 0x01, 0x4b, 0x03, 0xf3, 0x04, 0x01, 0x01, 0x53,
-  0x04, 0x04, 0x04, 0x09, 0x01, 0x62, 0x04, 0x22, 0x04, 0x23, 0x01, 0x68,
-  0x04, 0x2a, 0x04, 0x2b, 0x01, 0x6a, 0x04, 0x2e, 0x04, 0x36, 0x01, 0x6c,
-  0x04, 0x40, 0x04, 0x40, 0x01, 0x75, 0x04, 0x4d, 0x04, 0x4d, 0x01, 0x76,
-  0x04, 0x58, 0x04, 0x58, 0x01, 0x77, 0x04, 0x5e, 0x04, 0x5e, 0x01, 0x78,
-  0x04, 0x62, 0x04, 0x62, 0x01, 0x79, 0x04, 0x7c, 0x04, 0x7d, 0x01, 0x7a,
-  0x04, 0x8b, 0x04, 0x8b, 0x01, 0x7c, 0x04, 0x92, 0x04, 0x93, 0x01, 0x7d,
-  0x04, 0xa7, 0x04, 0xa7, 0x01, 0x7f, 0x04, 0xb2, 0x04, 0xb3, 0x01, 0x80,
-  0x04, 0xb5, 0x04, 0xb5, 0x01, 0x82, 0x04, 0xb7, 0x04, 0xb7, 0x01, 0x83,
-  0x04, 0xba, 0x04, 0xc2, 0x01, 0x84, 0x04, 0xc5, 0x04, 0xce, 0x01, 0x8d,
-  0x04, 0xd1, 0x04, 0xd5, 0x01, 0x97, 0x04, 0xd8, 0x04, 0xde, 0x01, 0x9c,
-  0x04, 0xe2, 0x04, 0xe2, 0x01, 0xa3, 0x05, 0x23, 0x05, 0x23, 0x01, 0xa4,
-  0x05, 0x5c, 0x05, 0x63, 0x01, 0xa5, 0x06, 0x4a, 0x06, 0x4b, 0x01, 0xad,
-  0x07, 0xec, 0x07, 0xec, 0x01, 0xaf, 0x07, 0xf4, 0x07, 0xf7, 0x01, 0xb0,
-  0x07, 0xf9, 0x07, 0xfb, 0x01, 0xb4, 0x07, 0xfe, 0x07, 0xfe, 0x01, 0xb7,
-  0x08, 0x01, 0x08, 0x06, 0x01, 0xb8, 0x08, 0x0d, 0x08, 0x0d, 0x01, 0xbe,
-  0x08, 0x11, 0x08, 0x11, 0x01, 0xbf, 0x08, 0x15, 0x08, 0x16, 0x01, 0xc0,
-  0x08, 0x18, 0x08, 0x1a, 0x01, 0xc2, 0x08, 0x1c, 0x08, 0x1c, 0x01, 0xc5,
-  0x08, 0x1e, 0x08, 0x22, 0x01, 0xc6, 0x08, 0x25, 0x08, 0x28, 0x01, 0xcb,
-  0x0a, 0x1d, 0x0a, 0x1d, 0x01, 0xcf, 0x0e, 0x2b, 0x0e, 0x45, 0x01, 0xd0,
-  0x0e, 0x48, 0x0e, 0x49, 0x01, 0xeb, 0x0e, 0x62, 0x0e, 0x65, 0x01, 0xed,
-  0x0e, 0x67, 0x0e, 0x68, 0x01, 0xf1, 0x0e, 0x6a, 0x0e, 0x75, 0x01, 0xf3,
-  0x0e, 0x78, 0x0e, 0x87, 0x01, 0xff, 0x0e, 0x89, 0x0e, 0x89, 0x02, 0x0f,
-  0x0e, 0x8b, 0x0e, 0x8f, 0x02, 0x10, 0x0e, 0x94, 0x0e, 0xa8, 0x02, 0x15,
-  0x0f, 0x93, 0x0f, 0xa5, 0x02, 0x2a, 0x0f, 0xbd, 0x0f, 0xbd, 0x02, 0x3d,
-  0x0f, 0xbf, 0x0f, 0xbf, 0x02, 0x3e, 0x0f, 0xf4, 0x0f, 0xfd, 0x02, 0x3f,
-  0x11, 0x1b, 0x11, 0x1d, 0x02, 0x49, 0x11, 0x34, 0x11, 0x34, 0x02, 0x4c,
-  0x11, 0x3e, 0x11, 0x3e, 0x02, 0x4d, 0x11, 0x42, 0x11, 0x42, 0x02, 0x4e,
-  0x11, 0x45, 0x11, 0x46, 0x02, 0x4f, 0x11, 0x48, 0x11, 0x48, 0x02, 0x51,
-  0x11, 0xb8, 0x11, 0xb8, 0x02, 0x52, 0x00, 0x02, 0x00, 0x0c, 0x02, 0xb1,
-  0x02, 0xc5, 0x00, 0x00, 0x02, 0xee, 0x02, 0xf3, 0x00, 0x15, 0x02, 0xf5,
-  0x02, 0xf5, 0x00, 0x1b, 0x02, 0xf7, 0x02, 0xf7, 0x00, 0x1c, 0x02, 0xfb,
-  0x02, 0xfd, 0x00, 0x1d, 0x03, 0x01, 0x03, 0x02, 0x00, 0x20, 0x03, 0x04,
-  0x03, 0x04, 0x00, 0x22, 0x04, 0x17, 0x04, 0x1b, 0x00, 0x23, 0x05, 0x4a,
-  0x05, 0x4f, 0x00, 0x28, 0x07, 0xe3, 0x07, 0xe9, 0x00, 0x2e, 0x10, 0xeb,
-  0x10, 0xf5, 0x00, 0x35, 0x11, 0xac, 0x11, 0xac, 0x00, 0x40, 0x00, 0x41,
-  0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0e, 0x00, 0x00, 0x01, 0x16,
-  0x00, 0x00, 0x01, 0x1e, 0x00, 0x00, 0x01, 0x24, 0x00, 0x00, 0x01, 0x2a,
-  0x00, 0x00, 0x01, 0x30, 0x00, 0x00, 0x01, 0x36, 0x00, 0x00, 0x01, 0x3e,
-  0x00, 0x00, 0x01, 0x46, 0x00, 0x00, 0x01, 0x4c, 0x00, 0x00, 0x01, 0x52,
-  0x00, 0x00, 0x01, 0x58, 0x00, 0x00, 0x01, 0x60, 0x00, 0x00, 0x01, 0x66,
-  0x00, 0x00, 0x01, 0x6c, 0x00, 0x00, 0x01, 0x72, 0x00, 0x00, 0x01, 0x78,
-  0x00, 0x00, 0x01, 0x7e, 0x00, 0x00, 0x01, 0x84, 0x00, 0x00, 0x01, 0x8a,
-  0x00, 0x00, 0x01, 0x90, 0x00, 0x00, 0x01, 0x96, 0x00, 0x00, 0x01, 0x9c,
-  0x00, 0x00, 0x01, 0xa2, 0x00, 0x00, 0x01, 0xa8, 0x00, 0x00, 0x01, 0xae,
-  0x00, 0x00, 0x01, 0xb4, 0x00, 0x00, 0x01, 0xba, 0x00, 0x00, 0x01, 0xc0,
-  0x00, 0x00, 0x01, 0xc6, 0x00, 0x00, 0x01, 0xcc, 0x00, 0x00, 0x01, 0xd2,
-  0x00, 0x00, 0x01, 0xd8, 0x00, 0x00, 0x01, 0xde, 0x00, 0x00, 0x01, 0xe4,
-  0x00, 0x00, 0x01, 0xea, 0x00, 0x00, 0x01, 0xf0, 0x00, 0x00, 0x01, 0xf6,
-  0x00, 0x00, 0x01, 0xfc, 0x00, 0x00, 0x02, 0x02, 0x00, 0x00, 0x02, 0x08,
-  0x00, 0x00, 0x02, 0x0e, 0x00, 0x00, 0x02, 0x14, 0x00, 0x00, 0x02, 0x1a,
-  0x00, 0x00, 0x02, 0x20, 0x00, 0x00, 0x02, 0x26, 0x00, 0x00, 0x02, 0x2c,
-  0x00, 0x00, 0x02, 0x32, 0x00, 0x00, 0x02, 0x38, 0x00, 0x00, 0x02, 0x3e,
-  0x00, 0x00, 0x02, 0x46, 0x00, 0x00, 0x02, 0x4e, 0x00, 0x00, 0x02, 0x54,
-  0x00, 0x00, 0x02, 0x5a, 0x00, 0x00, 0x02, 0x60, 0x00, 0x00, 0x02, 0x66,
-  0x00, 0x00, 0x02, 0x6c, 0x00, 0x00, 0x02, 0x72, 0x00, 0x00, 0x02, 0x78,
-  0x00, 0x00, 0x02, 0x7e, 0x00, 0x00, 0x02, 0x84, 0x00, 0x00, 0x02, 0x8a,
-  0x00, 0x00, 0x02, 0x90, 0x00, 0x00, 0x02, 0x96, 0x00, 0x02, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x04, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x04,
-  0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x02, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x04, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x08,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x07, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0xb0,
-  0x03, 0x6f, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x72, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x72, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0xb0,
-  0x04, 0x72, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfd, 0xcd, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0xa6,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x6e, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x48,
-  0x04, 0x7b, 0x00, 0x01, 0xfd, 0x39, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x02, 0xfe, 0x34,
-  0x04, 0x7b, 0x00, 0x0c, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x10,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
-  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x3e, 0x00, 0xfe,
-  0x00, 0x01, 0x01, 0x44, 0x00, 0x0c, 0x00, 0x1e, 0x00, 0x3e, 0x00, 0x44,
-  0x00, 0x4a, 0x00, 0x50, 0x00, 0x56, 0x00, 0x5c, 0x00, 0x62, 0x00, 0x68,
-  0x00, 0x6e, 0x00, 0x74, 0x00, 0x7a, 0x00, 0x80, 0x00, 0x86, 0x00, 0x8c,
-  0x00, 0x92, 0x00, 0x98, 0x00, 0x9e, 0x00, 0xa4, 0x00, 0xaa, 0x00, 0xb0,
-  0x00, 0xb6, 0x00, 0xbc, 0x00, 0xc2, 0x00, 0xc8, 0x00, 0xce, 0x00, 0xd4,
-  0x00, 0xda, 0x00, 0xe0, 0x00, 0xe6, 0x00, 0xec, 0x00, 0x01, 0x04, 0x5c,
-  0x00, 0x00, 0x00, 0x01, 0x03, 0x60, 0x00, 0x00, 0x00, 0x01, 0x01, 0x35,
-  0x00, 0x00, 0x00, 0x01, 0x02, 0xd7, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3,
-  0x00, 0x00, 0x00, 0x01, 0x02, 0x59, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77,
-  0xff, 0xfe, 0x00, 0x01, 0x03, 0x54, 0x00, 0x00, 0x00, 0x01, 0x03, 0x14,
-  0x00, 0x00, 0x00, 0x01, 0x01, 0x1e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x35,
-  0x00, 0x00, 0x00, 0x01, 0x03, 0xb1, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe1,
-  0xfe, 0x56, 0x00, 0x01, 0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd7,
-  0x00, 0x00, 0x00, 0x01, 0x02, 0x35, 0x00, 0x00, 0x00, 0x01, 0x01, 0x1e,
-  0x00, 0x00, 0x00, 0x01, 0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x35,
-  0x00, 0x00, 0x00, 0x01, 0x02, 0xd7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77,
-  0x00, 0x00, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47,
-  0xfe, 0x52, 0x00, 0x01, 0x02, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01, 0x95,
-  0x00, 0x00, 0x00, 0x01, 0x01, 0x23, 0x00, 0x00, 0x00, 0x01, 0x02, 0x35,
-  0x00, 0x00, 0x00, 0x01, 0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x04, 0xb6,
-  0x00, 0x00, 0x00, 0x01, 0x01, 0x23, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1e,
-  0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x32, 0x00, 0x38, 0x00, 0x3c,
-  0x00, 0x3d, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c, 0x00, 0x52, 0x00, 0x58,
-  0x00, 0x5c, 0x00, 0x5d, 0x00, 0x9a, 0x00, 0xba, 0x00, 0xf3, 0x01, 0x48,
-  0x01, 0x59, 0x01, 0x61, 0x01, 0x79, 0x01, 0x7a, 0x01, 0x7b, 0x02, 0x12,
-  0x02, 0x16, 0x02, 0x2a, 0x02, 0x37, 0x02, 0x54, 0x0e, 0x38, 0x11, 0x1c,
-  0x00, 0x01, 0x00, 0x01, 0x02, 0xd9, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06,
-  0x00, 0x01, 0xfe, 0x29, 0x00, 0x00, 0x00, 0x02, 0x26, 0xf0, 0x00, 0x04,
-  0x00, 0x00, 0x21, 0x30, 0x23, 0x20, 0x00, 0x35, 0x00, 0x50, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4b, 0x00, 0x72,
-  0x00, 0x39, 0x00, 0x4b, 0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0xff, 0x88,
-  0xff, 0xad, 0xff, 0x9a, 0xff, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26,
-  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4b, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
-  0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61,
-  0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
-  0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75,
-  0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61, 0x00, 0x00, 0xff, 0x61, 0xff, 0x75,
-  0xff, 0xad, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x03, 0x00, 0x2f, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0xff, 0xb7, 0x00, 0x00,
-  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00,
-  0xff, 0x90, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0x90, 0xff, 0x90,
-  0xff, 0xad, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xc9, 0xff, 0x44, 0x00, 0x00,
-  0x00, 0x00, 0xfe, 0xb7, 0xff, 0x61, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7,
-  0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x44, 0xff, 0x90, 0x00, 0x00, 0xff, 0xb7, 0xff, 0x90, 0xff, 0x44,
-  0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0xb7,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xdc, 0xff, 0xb7,
-  0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00,
-  0xfe, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xd3, 0xff, 0xd3, 0xff, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xc1, 0xff, 0xb7, 0x00, 0x00,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xc1,
-  0xff, 0x90, 0x00, 0x00, 0xff, 0x29, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0xff, 0xc9, 0x00, 0x00,
-  0xff, 0xb7, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x9a,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0x7d, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x90, 0xff, 0xdc, 0xff, 0x9a, 0x00, 0x00, 0xff, 0x9a,
-  0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xc1, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x2f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xe6,
-  0xff, 0x9a, 0xff, 0x1f, 0xff, 0x44, 0x00, 0x00, 0xfe, 0xf0, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xfe, 0x61, 0xfd, 0xe6, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x39, 0xff, 0xad, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x7d,
-  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
-  0xff, 0x44, 0x00, 0x00, 0xff, 0xd3, 0xfe, 0xc1, 0x00, 0x00, 0xff, 0x7d,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0xff, 0xa4, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00,
-  0xff, 0xdc, 0xff, 0xb7, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xa4, 0xff, 0xb7, 0x00, 0x00, 0xff, 0xb7,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x26, 0x00, 0x26, 0xfe, 0xb7, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0x7d, 0x00, 0x00,
-  0xff, 0xad, 0xff, 0xb7, 0xff, 0xc1, 0xff, 0xad, 0x00, 0x00, 0xff, 0x9a,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x6b, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0x00, 0x00,
-  0xff, 0x7d, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x90, 0xff, 0x90, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x9a,
-  0xff, 0xd3, 0xff, 0xa4, 0x00, 0x00, 0xff, 0xa4, 0xff, 0xa4, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0x7d,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44, 0xff, 0x0d,
-  0xff, 0x1f, 0xff, 0x61, 0x00, 0x00, 0xff, 0x88, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xfe, 0xad, 0xfe, 0xa4, 0x00, 0x00, 0xfe, 0xa4, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xa4, 0xfe, 0xd3, 0xfe, 0xad,
-  0x00, 0x00, 0xfe, 0xc9, 0x00, 0x00, 0xfe, 0xad, 0x00, 0x00, 0xfe, 0xc1,
-  0xff, 0x44, 0xff, 0x90, 0x00, 0x00, 0xff, 0x88, 0xff, 0x11, 0xfe, 0xe0,
-  0x00, 0x00, 0xfe, 0xf4, 0xfe, 0xe7, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xa4,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xfe, 0xf8, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x88, 0xfe, 0xf8, 0xff, 0x59, 0xff, 0x7d,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc9, 0xff, 0x4e, 0xff, 0x90,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0xff, 0x61, 0x00, 0x00, 0xff, 0x61,
-  0xff, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xfe, 0xe6, 0x00, 0x00, 0xff, 0xad, 0xff, 0x15,
-  0xff, 0x88, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x7d, 0x00, 0x00, 0x00, 0x00, 0xff, 0x88, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0xff, 0x88, 0xff, 0xa4, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0xff, 0x90, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x88,
-  0x00, 0x00, 0xff, 0x88, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xfe, 0xf8, 0x00, 0x00,
-  0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x7d, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b,
-  0x00, 0x00, 0xff, 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0xff, 0xad,
-  0xff, 0xd3, 0x00, 0x00, 0xff, 0x0d, 0xfe, 0x61, 0xfe, 0xf0, 0xff, 0x61,
-  0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xe6, 0x00, 0x00,
-  0x00, 0x00, 0xfe, 0xf0, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00,
-  0x00, 0x00, 0xfe, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x15,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x1f, 0xff, 0x6b,
-  0x00, 0x00, 0xff, 0x90, 0xfe, 0xe6, 0xfe, 0xf0, 0x00, 0x00, 0xfe, 0xf0,
-  0xff, 0x15, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x90, 0xff, 0xdc, 0xfe, 0xf8, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0x6b, 0xff, 0xb7, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xb7, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x41, 0x00, 0x00, 0xff, 0x15, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xb7,
-  0x00, 0x00, 0xff, 0xb7, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0x90,
-  0xff, 0xa4, 0x00, 0x00, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x6b, 0xff, 0xb7, 0xff, 0x7d, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x44,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0xd3, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xd3, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc9, 0x00, 0x00,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3,
-  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x56, 0xfe, 0xc9, 0x00, 0x00,
-  0xff, 0xc9, 0xff, 0x61, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0xfe, 0xf0, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44, 0xff, 0x90, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1,
-  0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0xfe, 0xdc, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xfe, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0xff, 0x90,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x97, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xb7, 0xff, 0xb7, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44,
-  0x00, 0x00, 0xff, 0x4e, 0xff, 0x90, 0xff, 0x90, 0xff, 0x1f, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xd3, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00,
-  0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad,
-  0x00, 0x00, 0xff, 0x75, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0xff, 0xdc, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad,
-  0xff, 0x61, 0xff, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xf8, 0xff, 0x03,
-  0x00, 0x2f, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x39,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0xff, 0x7d,
-  0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
-  0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75, 0xff, 0xb7, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
-  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90,
-  0xfe, 0xf8, 0xff, 0x03, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
-  0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61,
-  0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x03, 0x00, 0x2f, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xad, 0xff, 0xa4,
-  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x44, 0x00, 0x00,
-  0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0x90,
-  0xff, 0xad, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xa4, 0xff, 0x90, 0xff, 0xb7, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
-  0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61,
-  0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x02, 0x00, 0x2f, 0x00, 0x00,
-  0xff, 0xd3, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00,
-  0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad,
-  0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x02,
-  0x00, 0x2f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xd3, 0xff, 0xc9, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x7d, 0xff, 0x44, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0xd3,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xd3,
-  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xc9, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x56,
-  0xfe, 0xc9, 0x00, 0x00, 0xff, 0x44, 0xff, 0x0d, 0xff, 0x1f, 0xff, 0x61,
-  0x00, 0x00, 0xff, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xad, 0xfe, 0xa4,
-  0x00, 0x00, 0xfe, 0xa4, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00,
-  0x00, 0x00, 0xfe, 0xa4, 0xfe, 0xd3, 0xfe, 0xad, 0x00, 0x00, 0xfe, 0xc9,
-  0x00, 0x00, 0xfe, 0xad, 0x00, 0x00, 0xfe, 0xc1, 0xff, 0x44, 0xff, 0x90,
-  0x00, 0x00, 0xff, 0x88, 0xfe, 0xad, 0xfe, 0xa4, 0x00, 0x00, 0xfe, 0xa4,
-  0xfe, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xa4, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xd3, 0xfe, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xd3, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x4b, 0x00, 0x72, 0x00, 0x39, 0x00, 0x4b, 0x00, 0x00, 0xff, 0x44,
-  0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0xff, 0x9a, 0xff, 0x0d, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xf8, 0xff, 0xc1, 0xff, 0xb7,
-  0xff, 0xc1, 0xff, 0xc1, 0xff, 0xb7, 0xff, 0xc1, 0xff, 0xb7, 0xff, 0xb7,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x88,
-  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0x6b,
-  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xb7,
-  0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x7d, 0xff, 0xb7,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26,
-  0xff, 0xb7, 0xff, 0x90, 0xff, 0xb7, 0xff, 0xb7, 0xff, 0xb7, 0x00, 0x2f,
-  0xff, 0x90, 0xff, 0x90, 0x00, 0x00, 0xfe, 0xe6, 0x00, 0x00, 0xfe, 0x88,
-  0xff, 0x03, 0xff, 0xb7, 0xfe, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xb7, 0xff, 0xb7, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x15, 0xff, 0x3c, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x26, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xb7,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x52, 0x00, 0x10,
-  0x00, 0x10, 0x00, 0x01, 0x00, 0x24, 0x00, 0x24, 0x00, 0x02, 0x00, 0x25,
-  0x00, 0x25, 0x00, 0x03, 0x00, 0x26, 0x00, 0x26, 0x00, 0x04, 0x00, 0x27,
-  0x00, 0x27, 0x00, 0x05, 0x00, 0x29, 0x00, 0x29, 0x00, 0x06, 0x00, 0x2a,
-  0x00, 0x2a, 0x00, 0x07, 0x00, 0x2b, 0x00, 0x2b, 0x00, 0x08, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x09, 0x00, 0x2e, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x2f,
-  0x00, 0x2f, 0x00, 0x0b, 0x00, 0x32, 0x00, 0x32, 0x00, 0x0c, 0x00, 0x33,
-  0x00, 0x33, 0x00, 0x0d, 0x00, 0x34, 0x00, 0x34, 0x00, 0x0e, 0x00, 0x35,
-  0x00, 0x35, 0x00, 0x0f, 0x00, 0x36, 0x00, 0x36, 0x00, 0x10, 0x00, 0x37,
-  0x00, 0x37, 0x00, 0x11, 0x00, 0x38, 0x00, 0x38, 0x00, 0x12, 0x00, 0x39,
-  0x00, 0x39, 0x00, 0x13, 0x00, 0x3a, 0x00, 0x3a, 0x00, 0x14, 0x00, 0x3b,
-  0x00, 0x3b, 0x00, 0x15, 0x00, 0x3c, 0x00, 0x3c, 0x00, 0x16, 0x00, 0x3d,
-  0x00, 0x3d, 0x00, 0x17, 0x00, 0x48, 0x00, 0x48, 0x00, 0x18, 0x00, 0x49,
-  0x00, 0x49, 0x00, 0x19, 0x00, 0x4e, 0x00, 0x4e, 0x00, 0x1a, 0x00, 0x51,
-  0x00, 0x51, 0x00, 0x1b, 0x00, 0x52, 0x00, 0x52, 0x00, 0x1c, 0x00, 0x55,
-  0x00, 0x55, 0x00, 0x1d, 0x00, 0x59, 0x00, 0x59, 0x00, 0x1e, 0x00, 0x5a,
-  0x00, 0x5a, 0x00, 0x1f, 0x00, 0x5b, 0x00, 0x5b, 0x00, 0x20, 0x00, 0x5c,
-  0x00, 0x5c, 0x00, 0x21, 0x00, 0x6d, 0x00, 0x6d, 0x00, 0x22, 0x00, 0x7d,
-  0x00, 0x7d, 0x00, 0x23, 0x00, 0x82, 0x00, 0x82, 0x00, 0x24, 0x00, 0x83,
-  0x00, 0x84, 0x00, 0x25, 0x00, 0x85, 0x00, 0x85, 0x00, 0x26, 0x00, 0x86,
-  0x00, 0x86, 0x00, 0x25, 0x00, 0x88, 0x00, 0x88, 0x00, 0x27, 0x00, 0x89,
-  0x00, 0x89, 0x00, 0x28, 0x00, 0x92, 0x00, 0x92, 0x00, 0x05, 0x00, 0x94,
-  0x00, 0x98, 0x00, 0x0c, 0x00, 0x9b, 0x00, 0x9e, 0x00, 0x12, 0x00, 0x9f,
-  0x00, 0x9f, 0x00, 0x16, 0x00, 0xa0, 0x00, 0xa0, 0x00, 0x29, 0x00, 0xa1,
-  0x00, 0xa1, 0x00, 0x2a, 0x00, 0xaa, 0x00, 0xad, 0x00, 0x18, 0x00, 0xb2,
-  0x00, 0xb2, 0x00, 0x2b, 0x00, 0xb3, 0x00, 0xb3, 0x00, 0x1b, 0x00, 0xb4,
-  0x00, 0xb8, 0x00, 0x1c, 0x00, 0xbf, 0x00, 0xbf, 0x00, 0x21, 0x00, 0xc1,
-  0x00, 0xc1, 0x00, 0x21, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x2c, 0x00, 0xc4,
-  0x00, 0xc4, 0x00, 0x2c, 0x00, 0xc6, 0x00, 0xc6, 0x00, 0x2d, 0x00, 0xc8,
-  0x00, 0xc8, 0x00, 0x28, 0x00, 0xce, 0x00, 0xce, 0x00, 0x28, 0x00, 0xd0,
-  0x00, 0xd0, 0x00, 0x05, 0x00, 0xd2, 0x00, 0xd2, 0x00, 0x2e, 0x00, 0xdd,
-  0x00, 0xdd, 0x00, 0x18, 0x00, 0xe0, 0x00, 0xe0, 0x00, 0x07, 0x00, 0xfb,
-  0x00, 0xfb, 0x00, 0x0b, 0x00, 0xff, 0x00, 0xff, 0x00, 0x0b, 0x01, 0x02,
-  0x01, 0x02, 0x00, 0x2f, 0x01, 0x0a, 0x01, 0x0a, 0x00, 0x1b, 0x01, 0x16,
-  0x01, 0x16, 0x00, 0x0f, 0x01, 0x17, 0x01, 0x17, 0x00, 0x1d, 0x01, 0x1a,
-  0x01, 0x1a, 0x00, 0x0f, 0x01, 0x1b, 0x01, 0x1b, 0x00, 0x30, 0x01, 0x20,
-  0x01, 0x20, 0x00, 0x10, 0x01, 0x22, 0x01, 0x22, 0x00, 0x10, 0x01, 0x26,
-  0x01, 0x26, 0x00, 0x31, 0x01, 0x30, 0x01, 0x30, 0x00, 0x12, 0x01, 0x3a,
-  0x01, 0x3a, 0x00, 0x16, 0x01, 0x3f, 0x01, 0x3f, 0x00, 0x17, 0x07, 0x45,
-  0x07, 0x45, 0x00, 0x32, 0x07, 0x51, 0x07, 0x51, 0x00, 0x33, 0x07, 0x53,
-  0x07, 0x53, 0x00, 0x34, 0x0e, 0x60, 0x0e, 0x60, 0x00, 0x11, 0x0e, 0x78,
-  0x0e, 0x78, 0x00, 0x0a, 0x0e, 0x79, 0x0e, 0x79, 0x00, 0x1a, 0x00, 0x02,
-  0x00, 0xa2, 0x00, 0x10, 0x00, 0x10, 0x00, 0x01, 0x00, 0x11, 0x00, 0x11,
-  0x00, 0x02, 0x00, 0x1d, 0x00, 0x1d, 0x00, 0x03, 0x00, 0x24, 0x00, 0x24,
-  0x00, 0x04, 0x00, 0x25, 0x00, 0x25, 0x00, 0x05, 0x00, 0x26, 0x00, 0x26,
-  0x00, 0x06, 0x00, 0x27, 0x00, 0x27, 0x00, 0x07, 0x00, 0x29, 0x00, 0x29,
-  0x00, 0x08, 0x00, 0x2a, 0x00, 0x2a, 0x00, 0x09, 0x00, 0x2b, 0x00, 0x2b,
-  0x00, 0x08, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x0a, 0x00, 0x2e, 0x00, 0x2f,
-  0x00, 0x08, 0x00, 0x32, 0x00, 0x32, 0x00, 0x0b, 0x00, 0x33, 0x00, 0x33,
-  0x00, 0x08, 0x00, 0x34, 0x00, 0x34, 0x00, 0x0c, 0x00, 0x35, 0x00, 0x35,
-  0x00, 0x08, 0x00, 0x36, 0x00, 0x36, 0x00, 0x0d, 0x00, 0x37, 0x00, 0x37,
-  0x00, 0x0e, 0x00, 0x38, 0x00, 0x38, 0x00, 0x0f, 0x00, 0x39, 0x00, 0x39,
-  0x00, 0x10, 0x00, 0x3a, 0x00, 0x3a, 0x00, 0x11, 0x00, 0x3b, 0x00, 0x3b,
-  0x00, 0x12, 0x00, 0x3c, 0x00, 0x3c, 0x00, 0x13, 0x00, 0x3d, 0x00, 0x3d,
-  0x00, 0x14, 0x00, 0x44, 0x00, 0x44, 0x00, 0x15, 0x00, 0x46, 0x00, 0x46,
-  0x00, 0x16, 0x00, 0x47, 0x00, 0x47, 0x00, 0x17, 0x00, 0x48, 0x00, 0x48,
-  0x00, 0x18, 0x00, 0x49, 0x00, 0x49, 0x00, 0x19, 0x00, 0x4a, 0x00, 0x4b,
-  0x00, 0x1a, 0x00, 0x4c, 0x00, 0x4c, 0x00, 0x1b, 0x00, 0x4f, 0x00, 0x4f,
-  0x00, 0x1c, 0x00, 0x50, 0x00, 0x50, 0x00, 0x1a, 0x00, 0x51, 0x00, 0x51,
-  0x00, 0x1d, 0x00, 0x52, 0x00, 0x52, 0x00, 0x1e, 0x00, 0x54, 0x00, 0x54,
-  0x00, 0x17, 0x00, 0x55, 0x00, 0x55, 0x00, 0x1f, 0x00, 0x56, 0x00, 0x56,
-  0x00, 0x20, 0x00, 0x57, 0x00, 0x57, 0x00, 0x21, 0x00, 0x58, 0x00, 0x58,
-  0x00, 0x22, 0x00, 0x59, 0x00, 0x59, 0x00, 0x23, 0x00, 0x5a, 0x00, 0x5a,
-  0x00, 0x24, 0x00, 0x5b, 0x00, 0x5b, 0x00, 0x25, 0x00, 0x5c, 0x00, 0x5c,
-  0x00, 0x26, 0x00, 0x6d, 0x00, 0x6d, 0x00, 0x27, 0x00, 0x7d, 0x00, 0x7d,
-  0x00, 0x28, 0x00, 0x82, 0x00, 0x86, 0x00, 0x04, 0x00, 0x88, 0x00, 0x88,
-  0x00, 0x29, 0x00, 0x89, 0x00, 0x89, 0x00, 0x2a, 0x00, 0x94, 0x00, 0x98,
-  0x00, 0x0b, 0x00, 0x9b, 0x00, 0x9e, 0x00, 0x0f, 0x00, 0x9f, 0x00, 0x9f,
-  0x00, 0x13, 0x00, 0xa0, 0x00, 0xa1, 0x00, 0x08, 0x00, 0xa2, 0x00, 0xa2,
-  0x00, 0x2b, 0x00, 0xa3, 0x00, 0xa3, 0x00, 0x15, 0x00, 0xa4, 0x00, 0xa7,
-  0x00, 0x2b, 0x00, 0xa9, 0x00, 0xa9, 0x00, 0x16, 0x00, 0xaa, 0x00, 0xaa,
-  0x00, 0x2c, 0x00, 0xab, 0x00, 0xab, 0x00, 0x18, 0x00, 0xac, 0x00, 0xad,
-  0x00, 0x2c, 0x00, 0xb2, 0x00, 0xb2, 0x00, 0x2d, 0x00, 0xb3, 0x00, 0xb3,
-  0x00, 0x1d, 0x00, 0xb4, 0x00, 0xb4, 0x00, 0x2e, 0x00, 0xb5, 0x00, 0xb5,
-  0x00, 0x1e, 0x00, 0xb6, 0x00, 0xb8, 0x00, 0x2e, 0x00, 0xbb, 0x00, 0xbb,
-  0x00, 0x2f, 0x00, 0xbc, 0x00, 0xbc, 0x00, 0x22, 0x00, 0xbd, 0x00, 0xbe,
-  0x00, 0x2f, 0x00, 0xbf, 0x00, 0xbf, 0x00, 0x26, 0x00, 0xc1, 0x00, 0xc1,
-  0x00, 0x26, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x30, 0x00, 0xc3, 0x00, 0xc3,
-  0x00, 0x31, 0x00, 0xc4, 0x00, 0xc4, 0x00, 0x30, 0x00, 0xc5, 0x00, 0xc5,
-  0x00, 0x31, 0x00, 0xc6, 0x00, 0xc6, 0x00, 0x30, 0x00, 0xc7, 0x00, 0xc7,
-  0x00, 0x31, 0x00, 0xc8, 0x00, 0xc8, 0x00, 0x06, 0x00, 0xc9, 0x00, 0xc9,
-  0x00, 0x32, 0x00, 0xca, 0x00, 0xca, 0x00, 0x33, 0x00, 0xcb, 0x00, 0xcb,
-  0x00, 0x34, 0x00, 0xcc, 0x00, 0xcc, 0x00, 0x33, 0x00, 0xcd, 0x00, 0xcd,
-  0x00, 0x35, 0x00, 0xce, 0x00, 0xce, 0x00, 0x06, 0x00, 0xcf, 0x00, 0xcf,
-  0x00, 0x32, 0x00, 0xd0, 0x00, 0xd0, 0x00, 0x07, 0x00, 0xd1, 0x00, 0xd1,
-  0x00, 0x36, 0x00, 0xd3, 0x00, 0xd3, 0x00, 0x37, 0x00, 0xd5, 0x00, 0xd5,
-  0x00, 0x38, 0x00, 0xd7, 0x00, 0xd7, 0x00, 0x38, 0x00, 0xd9, 0x00, 0xd9,
-  0x00, 0x38, 0x00, 0xdb, 0x00, 0xdb, 0x00, 0x38, 0x00, 0xdd, 0x00, 0xdd,
-  0x00, 0x18, 0x00, 0xde, 0x00, 0xde, 0x00, 0x33, 0x00, 0xe0, 0x00, 0xe0,
-  0x00, 0x39, 0x00, 0xe1, 0x00, 0xe1, 0x00, 0x1a, 0x00, 0xe2, 0x00, 0xe2,
-  0x00, 0x33, 0x00, 0xe4, 0x00, 0xe4, 0x00, 0x3a, 0x00, 0xf1, 0x00, 0xf1,
-  0x00, 0x3b, 0x00, 0xf5, 0x00, 0xf5, 0x00, 0x3b, 0x00, 0xfb, 0x00, 0xfb,
-  0x00, 0x08, 0x00, 0xff, 0x00, 0xff, 0x00, 0x08, 0x01, 0x0a, 0x01, 0x0a,
-  0x00, 0x1d, 0x01, 0x0e, 0x01, 0x0e, 0x00, 0x33, 0x01, 0x0f, 0x01, 0x0f,
-  0x00, 0x3c, 0x01, 0x10, 0x01, 0x10, 0x00, 0x33, 0x01, 0x11, 0x01, 0x11,
-  0x00, 0x3c, 0x01, 0x12, 0x01, 0x12, 0x00, 0x3d, 0x01, 0x13, 0x01, 0x13,
-  0x00, 0x3c, 0x01, 0x16, 0x01, 0x16, 0x00, 0x08, 0x01, 0x17, 0x01, 0x17,
-  0x00, 0x1f, 0x01, 0x19, 0x01, 0x19, 0x00, 0x3b, 0x01, 0x1a, 0x01, 0x1a,
-  0x00, 0x08, 0x01, 0x1b, 0x01, 0x1b, 0x00, 0x1f, 0x01, 0x1c, 0x01, 0x1c,
-  0x00, 0x0d, 0x01, 0x1e, 0x01, 0x1e, 0x00, 0x0d, 0x01, 0x20, 0x01, 0x20,
-  0x00, 0x0d, 0x01, 0x21, 0x01, 0x21, 0x00, 0x20, 0x01, 0x22, 0x01, 0x22,
-  0x00, 0x0d, 0x01, 0x23, 0x01, 0x23, 0x00, 0x20, 0x01, 0x24, 0x01, 0x24,
-  0x00, 0x3e, 0x01, 0x25, 0x01, 0x25, 0x00, 0x35, 0x01, 0x26, 0x01, 0x26,
-  0x00, 0x0e, 0x01, 0x27, 0x01, 0x27, 0x00, 0x21, 0x01, 0x28, 0x01, 0x28,
-  0x00, 0x3f, 0x01, 0x2b, 0x01, 0x2b, 0x00, 0x40, 0x01, 0x2d, 0x01, 0x2d,
-  0x00, 0x40, 0x01, 0x2f, 0x01, 0x2f, 0x00, 0x40, 0x01, 0x30, 0x01, 0x30,
-  0x00, 0x0f, 0x01, 0x31, 0x01, 0x31, 0x00, 0x22, 0x01, 0x33, 0x01, 0x33,
-  0x00, 0x40, 0x01, 0x35, 0x01, 0x35, 0x00, 0x40, 0x01, 0x36, 0x01, 0x36,
-  0x00, 0x41, 0x01, 0x37, 0x01, 0x37, 0x00, 0x42, 0x01, 0x38, 0x01, 0x38,
-  0x00, 0x43, 0x01, 0x39, 0x01, 0x39, 0x00, 0x44, 0x01, 0x3a, 0x01, 0x3a,
-  0x00, 0x13, 0x01, 0x3f, 0x01, 0x3f, 0x00, 0x14, 0x01, 0x88, 0x01, 0x88,
-  0x00, 0x34, 0x01, 0xac, 0x01, 0xac, 0x00, 0x45, 0x01, 0xad, 0x01, 0xad,
-  0x00, 0x46, 0x01, 0xae, 0x01, 0xae, 0x00, 0x45, 0x01, 0xaf, 0x01, 0xaf,
-  0x00, 0x46, 0x01, 0xda, 0x01, 0xda, 0x00, 0x0d, 0x01, 0xdc, 0x01, 0xdc,
-  0x00, 0x47, 0x01, 0xdd, 0x01, 0xdd, 0x00, 0x34, 0x01, 0xf0, 0x01, 0xf0,
-  0x00, 0x33, 0x01, 0xf1, 0x01, 0xf1, 0x00, 0x48, 0x01, 0xf3, 0x01, 0xf3,
-  0x00, 0x34, 0x01, 0xf4, 0x01, 0xf4, 0x00, 0x49, 0x01, 0xf5, 0x01, 0xf5,
-  0x00, 0x4a, 0x05, 0xd0, 0x05, 0xd0, 0x00, 0x41, 0x05, 0xd1, 0x05, 0xd1,
-  0x00, 0x4b, 0x05, 0xd2, 0x05, 0xd2, 0x00, 0x4c, 0x05, 0xd3, 0x05, 0xd3,
-  0x00, 0x42, 0x05, 0xd4, 0x05, 0xd4, 0x00, 0x41, 0x05, 0xd5, 0x05, 0xd5,
-  0x00, 0x42, 0x06, 0x42, 0x06, 0x42, 0x00, 0x43, 0x06, 0x43, 0x06, 0x43,
-  0x00, 0x44, 0x07, 0x51, 0x07, 0x51, 0x00, 0x4d, 0x07, 0x52, 0x07, 0x52,
-  0x00, 0x4e, 0x07, 0x53, 0x07, 0x53, 0x00, 0x4f, 0x0e, 0x78, 0x0e, 0x78,
-  0x00, 0x08, 0x00, 0x01, 0x00, 0x61, 0x00, 0x10, 0x00, 0x24, 0x00, 0x25,
-  0x00, 0x26, 0x00, 0x27, 0x00, 0x29, 0x00, 0x2a, 0x00, 0x2b, 0x00, 0x2d,
-  0x00, 0x2e, 0x00, 0x2f, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00, 0x35,
-  0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39, 0x00, 0x3a, 0x00, 0x3b,
-  0x00, 0x3c, 0x00, 0x3d, 0x00, 0x48, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x51,
-  0x00, 0x52, 0x00, 0x55, 0x00, 0x59, 0x00, 0x5a, 0x00, 0x5b, 0x00, 0x5c,
-  0x00, 0x6d, 0x00, 0x7d, 0x00, 0x82, 0x00, 0x83, 0x00, 0x84, 0x00, 0x85,
-  0x00, 0x86, 0x00, 0x88, 0x00, 0x89, 0x00, 0x92, 0x00, 0x94, 0x00, 0x95,
-  0x00, 0x96, 0x00, 0x97, 0x00, 0x98, 0x00, 0x9b, 0x00, 0x9c, 0x00, 0x9d,
-  0x00, 0x9e, 0x00, 0x9f, 0x00, 0xa0, 0x00, 0xa1, 0x00, 0xaa, 0x00, 0xab,
-  0x00, 0xac, 0x00, 0xad, 0x00, 0xb2, 0x00, 0xb3, 0x00, 0xb4, 0x00, 0xb5,
-  0x00, 0xb6, 0x00, 0xb7, 0x00, 0xb8, 0x00, 0xbf, 0x00, 0xc1, 0x00, 0xc2,
-  0x00, 0xc4, 0x00, 0xc6, 0x00, 0xc8, 0x00, 0xce, 0x00, 0xd0, 0x00, 0xd2,
-  0x00, 0xdd, 0x00, 0xe0, 0x00, 0xfb, 0x00, 0xff, 0x01, 0x02, 0x01, 0x0a,
-  0x01, 0x16, 0x01, 0x17, 0x01, 0x1a, 0x01, 0x1b, 0x01, 0x20, 0x01, 0x22,
-  0x01, 0x26, 0x01, 0x30, 0x01, 0x3a, 0x01, 0x3f, 0x07, 0x45, 0x07, 0x51,
-  0x07, 0x53, 0x0e, 0x60, 0x0e, 0x78, 0x0e, 0x79, 0x00, 0x02, 0x00, 0x60,
-  0x00, 0x04, 0x00, 0x00, 0x00, 0x24, 0x00, 0x58, 0x00, 0x05, 0x00, 0x02,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd8, 0x00, 0x00, 0xff, 0xb1,
-  0x00, 0x00, 0xff, 0xa3, 0x00, 0x00, 0xff, 0x9c, 0x00, 0x01, 0x0e, 0xaa,
-  0x00, 0x17, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x03, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x01, 0x0e, 0xc2, 0x00, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x04,
-  0x0e, 0xaa, 0x0e, 0xae, 0x00, 0x00, 0x0e, 0xb0, 0x0e, 0xb4, 0x00, 0x05,
-  0x0e, 0xb6, 0x0e, 0xba, 0x00, 0x0a, 0x0e, 0xbc, 0x0e, 0xc0, 0x00, 0x0f,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x0a, 0x01, 0xf0, 0x02, 0x9e, 0x00, 0x14,
-  0x44, 0x46, 0x4c, 0x54, 0x00, 0x7a, 0x61, 0x72, 0x61, 0x62, 0x00, 0x88,
-  0x61, 0x72, 0x6d, 0x6e, 0x00, 0xa6, 0x62, 0x72, 0x61, 0x69, 0x00, 0xb2,
-  0x63, 0x61, 0x6e, 0x73, 0x00, 0xbe, 0x63, 0x68, 0x65, 0x72, 0x00, 0xca,
-  0x63, 0x79, 0x72, 0x6c, 0x00, 0xd6, 0x67, 0x65, 0x6f, 0x72, 0x00, 0xf8,
-  0x67, 0x72, 0x65, 0x6b, 0x01, 0x04, 0x68, 0x61, 0x6e, 0x69, 0x01, 0x14,
-  0x68, 0x65, 0x62, 0x72, 0x01, 0x20, 0x6b, 0x61, 0x6e, 0x61, 0x01, 0x2c,
-  0x6c, 0x61, 0x6f, 0x20, 0x01, 0x38, 0x6c, 0x61, 0x74, 0x6e, 0x01, 0x44,
-  0x6d, 0x61, 0x74, 0x68, 0x01, 0x9e, 0x6e, 0x6b, 0x6f, 0x20, 0x01, 0xaa,
-  0x6f, 0x67, 0x61, 0x6d, 0x01, 0xb6, 0x72, 0x75, 0x6e, 0x72, 0x01, 0xc2,
-  0x74, 0x66, 0x6e, 0x67, 0x01, 0xce, 0x74, 0x68, 0x61, 0x69, 0x01, 0xda,
-  0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x03,
-  0x00, 0x06, 0x00, 0x16, 0x00, 0x03, 0x4b, 0x55, 0x52, 0x20, 0x00, 0x16,
-  0x53, 0x4e, 0x44, 0x20, 0x00, 0x16, 0x55, 0x52, 0x44, 0x20, 0x00, 0x16,
-  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
-  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x10, 0x00, 0x02,
-  0x4d, 0x4b, 0x44, 0x20, 0x00, 0x18, 0x53, 0x52, 0x42, 0x20, 0x00, 0x18,
-  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x05, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x02, 0x00, 0x05, 0x00, 0x0a, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x03, 0x00, 0x01, 0x00, 0x05, 0x00, 0x0c, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x04, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x34,
-  0x00, 0x08, 0x49, 0x53, 0x4d, 0x20, 0x00, 0x46, 0x4b, 0x53, 0x4d, 0x20,
-  0x00, 0x46, 0x4c, 0x53, 0x4d, 0x20, 0x00, 0x46, 0x4d, 0x4f, 0x4c, 0x20,
-  0x00, 0x34, 0x4e, 0x53, 0x4d, 0x20, 0x00, 0x46, 0x52, 0x4f, 0x4d, 0x20,
-  0x00, 0x34, 0x53, 0x4b, 0x53, 0x20, 0x00, 0x46, 0x53, 0x53, 0x4d, 0x20,
-  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x02, 0x00, 0x05,
-  0x00, 0x07, 0x00, 0x08, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x07, 0x00, 0x02, 0x00, 0x05, 0x00, 0x07, 0x00, 0x08, 0x00, 0x09,
-  0x00, 0x0b, 0x00, 0x0d, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
-  0x00, 0x01, 0x00, 0x03, 0x00, 0x0e, 0x20, 0x52, 0x51, 0x44, 0x00, 0x56,
-  0x61, 0x61, 0x6c, 0x74, 0x00, 0x5c, 0x61, 0x61, 0x6c, 0x74, 0x00, 0x62,
-  0x63, 0x63, 0x6d, 0x70, 0x00, 0x68, 0x63, 0x63, 0x6d, 0x70, 0x00, 0x6e,
-  0x63, 0x63, 0x6d, 0x70, 0x00, 0x76, 0x64, 0x6c, 0x69, 0x67, 0x00, 0x7e,
-  0x64, 0x6c, 0x69, 0x67, 0x00, 0x84, 0x68, 0x6c, 0x69, 0x67, 0x00, 0x8a,
-  0x6c, 0x69, 0x67, 0x61, 0x00, 0x90, 0x6c, 0x6f, 0x63, 0x6c, 0x00, 0x96,
-  0x6c, 0x6f, 0x63, 0x6c, 0x00, 0x9c, 0x73, 0x61, 0x6c, 0x74, 0x00, 0xa2,
-  0x73, 0x61, 0x6c, 0x74, 0x00, 0xa8, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0d,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x03, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x03, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x00, 0x01, 0x00, 0x07, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x08, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0c, 0x00, 0x16,
-  0x00, 0x2e, 0x00, 0x36, 0x00, 0x3e, 0x00, 0x46, 0x00, 0x60, 0x00, 0x68,
-  0x00, 0x70, 0x00, 0x78, 0x00, 0x80, 0x00, 0x88, 0x00, 0x90, 0x00, 0x98,
-  0x00, 0xa0, 0x00, 0xa8, 0x00, 0xb0, 0x00, 0xb8, 0x00, 0xc0, 0x00, 0xc8,
-  0x00, 0xd0, 0x00, 0xd8, 0x00, 0xe0, 0x00, 0xe8, 0x00, 0x06, 0x00, 0x09,
-  0x00, 0x01, 0x00, 0xc2, 0x00, 0x06, 0x00, 0x01, 0x00, 0x01, 0x01, 0x12,
-  0x00, 0x06, 0x00, 0x00, 0x00, 0x01, 0x01, 0x3e, 0x00, 0x06, 0x00, 0x00,
-  0x00, 0x0a, 0x04, 0xb2, 0x05, 0x0a, 0x05, 0x62, 0x05, 0xba, 0x06, 0x12,
-  0x06, 0x6a, 0x06, 0xac, 0x06, 0xf4, 0x07, 0x3c, 0x07, 0x84, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x07, 0xac, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x07, 0xb0, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x07, 0xb4, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x01, 0x07, 0xe8, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
-  0x07, 0xf8, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x08, 0x08, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x08, 0x9c, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x08, 0xba, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x08, 0xd8, 0x00, 0x03,
-  0x00, 0x00, 0x00, 0x01, 0x08, 0xee, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x09, 0x20, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x09, 0x52, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x09, 0x88, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x09, 0x90, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x09, 0x98, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x09, 0xa0, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x09, 0xa8, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x09, 0xb0, 0x00, 0x02,
-  0x00, 0x10, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x02, 0x00, 0x00,
-  0x00, 0x30, 0x00, 0x02, 0x00, 0x02, 0x07, 0x42, 0x07, 0x42, 0x00, 0x00,
-  0x11, 0x52, 0x11, 0xab, 0x00, 0x01, 0x00, 0x02, 0x00, 0x02, 0x07, 0x42,
-  0x07, 0x42, 0x00, 0x01, 0x11, 0x52, 0x11, 0xab, 0x00, 0x01, 0x00, 0x03,
-  0x00, 0x08, 0x00, 0x14, 0x00, 0x1e, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x02, 0x00, 0x12, 0x00, 0x16, 0x00, 0x1e, 0x00, 0x1e,
-  0x00, 0x03, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x02, 0x00, 0x16, 0x00, 0x8c,
-  0x00, 0x8c, 0x00, 0x8c, 0x00, 0x05, 0x00, 0x00, 0x03, 0x0c, 0x03, 0x44,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x39, 0x00, 0x4c, 0x00, 0x4d,
-  0x00, 0xf1, 0x02, 0x0b, 0x02, 0x2a, 0x02, 0x5f, 0x02, 0xb1, 0x02, 0xb2,
-  0x02, 0xb3, 0x02, 0xb4, 0x02, 0xb5, 0x02, 0xb6, 0x02, 0xb7, 0x02, 0xb8,
-  0x02, 0xb9, 0x02, 0xba, 0x02, 0xbb, 0x02, 0xbc, 0x02, 0xbd, 0x02, 0xbe,
-  0x02, 0xbf, 0x02, 0xc0, 0x02, 0xc1, 0x02, 0xc2, 0x02, 0xc3, 0x02, 0xc4,
-  0x02, 0xc5, 0x02, 0xee, 0x02, 0xef, 0x02, 0xf0, 0x02, 0xf1, 0x02, 0xf2,
-  0x02, 0xf3, 0x02, 0xf4, 0x02, 0xf5, 0x02, 0xf7, 0x02, 0xfb, 0x02, 0xfc,
-  0x02, 0xfd, 0x03, 0x01, 0x03, 0x02, 0x03, 0x04, 0x03, 0x87, 0x03, 0xea,
-  0x03, 0xec, 0x04, 0x17, 0x04, 0x18, 0x04, 0x19, 0x04, 0x1a, 0x05, 0x7d,
-  0x06, 0x1b, 0x07, 0xe3, 0x07, 0xe4, 0x07, 0xe5, 0x07, 0xe6, 0x08, 0x31,
-  0x08, 0x32, 0x00, 0x02, 0x00, 0x6a, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x03,
-  0x00, 0x45, 0x00, 0x45, 0x00, 0x03, 0x00, 0x47, 0x00, 0x47, 0x00, 0x03,
-  0x00, 0x49, 0x00, 0x49, 0x00, 0x03, 0x00, 0x4b, 0x00, 0x4b, 0x00, 0x03,
-  0x00, 0x4c, 0x00, 0x4d, 0x00, 0x01, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x03,
-  0x00, 0x57, 0x00, 0x57, 0x00, 0x03, 0x00, 0x82, 0x00, 0x98, 0x00, 0x03,
-  0x00, 0x9a, 0x00, 0xa1, 0x00, 0x03, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x03,
-  0x00, 0xc4, 0x00, 0xc4, 0x00, 0x03, 0x00, 0xc6, 0x00, 0xc6, 0x00, 0x03,
-  0x00, 0xc8, 0x00, 0xc8, 0x00, 0x03, 0x00, 0xca, 0x00, 0xca, 0x00, 0x03,
-  0x00, 0xcc, 0x00, 0xcc, 0x00, 0x03, 0x00, 0xce, 0x00, 0xce, 0x00, 0x03,
-  0x00, 0xd0, 0x00, 0xd0, 0x00, 0x03, 0x00, 0xd2, 0x00, 0xd2, 0x00, 0x03,
-  0x00, 0xd4, 0x00, 0xd4, 0x00, 0x03, 0x00, 0xd6, 0x00, 0xd6, 0x00, 0x03,
-  0x00, 0xd8, 0x00, 0xd8, 0x00, 0x03, 0x00, 0xda, 0x00, 0xda, 0x00, 0x03,
-  0x00, 0xdc, 0x00, 0xdc, 0x00, 0x03, 0x00, 0xde, 0x00, 0xde, 0x00, 0x03,
-  0x00, 0xe0, 0x00, 0xe0, 0x00, 0x03, 0x00, 0xe2, 0x00, 0xe2, 0x00, 0x03,
-  0x00, 0xe4, 0x00, 0xe4, 0x00, 0x03, 0x00, 0xe6, 0x00, 0xea, 0x00, 0x03,
-  0x00, 0xec, 0x00, 0xec, 0x00, 0x03, 0x00, 0xee, 0x00, 0xee, 0x00, 0x03,
-  0x00, 0xf0, 0x00, 0xf0, 0x00, 0x03, 0x00, 0xf1, 0x00, 0xf1, 0x00, 0x01,
-  0x00, 0xf2, 0x00, 0xf2, 0x00, 0x03, 0x00, 0xf4, 0x00, 0xf4, 0x00, 0x03,
-  0x00, 0xf6, 0x00, 0xf6, 0x00, 0x03, 0x00, 0xf8, 0x00, 0xf8, 0x00, 0x03,
-  0x00, 0xfb, 0x01, 0x05, 0x00, 0x03, 0x01, 0x07, 0x01, 0x07, 0x00, 0x03,
-  0x01, 0x09, 0x01, 0x09, 0x00, 0x03, 0x01, 0x0c, 0x01, 0x0c, 0x00, 0x03,
-  0x01, 0x0e, 0x01, 0x0e, 0x00, 0x03, 0x01, 0x10, 0x01, 0x10, 0x00, 0x03,
-  0x01, 0x12, 0x01, 0x12, 0x00, 0x03, 0x01, 0x14, 0x01, 0x14, 0x00, 0x03,
-  0x01, 0x16, 0x01, 0x16, 0x00, 0x03, 0x01, 0x18, 0x01, 0x18, 0x00, 0x03,
-  0x01, 0x1a, 0x01, 0x1a, 0x00, 0x03, 0x01, 0x1c, 0x01, 0x1c, 0x00, 0x03,
-  0x01, 0x1e, 0x01, 0x1e, 0x00, 0x03, 0x01, 0x20, 0x01, 0x20, 0x00, 0x03,
-  0x01, 0x22, 0x01, 0x22, 0x00, 0x03, 0x01, 0x24, 0x01, 0x24, 0x00, 0x03,
-  0x01, 0x26, 0x01, 0x26, 0x00, 0x03, 0x01, 0x28, 0x01, 0x28, 0x00, 0x03,
-  0x01, 0x2a, 0x01, 0x2a, 0x00, 0x03, 0x01, 0x2c, 0x01, 0x2c, 0x00, 0x03,
-  0x01, 0x2e, 0x01, 0x2e, 0x00, 0x03, 0x01, 0x30, 0x01, 0x30, 0x00, 0x03,
-  0x01, 0x32, 0x01, 0x32, 0x00, 0x03, 0x01, 0x34, 0x01, 0x34, 0x00, 0x03,
-  0x01, 0x36, 0x01, 0x36, 0x00, 0x03, 0x01, 0x38, 0x01, 0x38, 0x00, 0x03,
-  0x01, 0x3a, 0x01, 0x3b, 0x00, 0x03, 0x01, 0x3d, 0x01, 0x3d, 0x00, 0x03,
-  0x01, 0x3f, 0x01, 0x3f, 0x00, 0x03, 0x01, 0x41, 0x01, 0x41, 0x00, 0x03,
-  0x01, 0x48, 0x01, 0x48, 0x00, 0x03, 0x01, 0x52, 0x01, 0x52, 0x00, 0x03,
-  0x01, 0x54, 0x01, 0x54, 0x00, 0x03, 0x01, 0x56, 0x01, 0x56, 0x00, 0x03,
-  0x01, 0x79, 0x01, 0x7a, 0x00, 0x03, 0x01, 0x8f, 0x01, 0x8f, 0x00, 0x03,
-  0x01, 0x91, 0x01, 0x93, 0x00, 0x03, 0x01, 0x95, 0x01, 0x95, 0x00, 0x03,
-  0x01, 0xa4, 0x01, 0xa4, 0x00, 0x03, 0x01, 0xac, 0x01, 0xac, 0x00, 0x03,
-  0x01, 0xae, 0x01, 0xae, 0x00, 0x03, 0x01, 0xda, 0x01, 0xda, 0x00, 0x03,
-  0x01, 0xdc, 0x01, 0xdc, 0x00, 0x03, 0x01, 0xf0, 0x01, 0xf0, 0x00, 0x03,
-  0x01, 0xf4, 0x01, 0xf4, 0x00, 0x03, 0x02, 0x0b, 0x02, 0x0b, 0x00, 0x01,
-  0x02, 0x2a, 0x02, 0x2a, 0x00, 0x01, 0x02, 0x5f, 0x02, 0x5f, 0x00, 0x01,
-  0x02, 0xb1, 0x02, 0xc5, 0x00, 0x02, 0x02, 0xc7, 0x02, 0xca, 0x00, 0x04,
-  0x02, 0xcd, 0x02, 0xe4, 0x00, 0x04, 0x02, 0xea, 0x02, 0xed, 0x00, 0x04,
-  0x02, 0xee, 0x02, 0xf5, 0x00, 0x02, 0x02, 0xf6, 0x02, 0xf6, 0x00, 0x04,
-  0x02, 0xf7, 0x02, 0xf7, 0x00, 0x02, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x04,
-  0x02, 0xfb, 0x02, 0xfd, 0x00, 0x02, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x04,
-  0x03, 0x01, 0x03, 0x02, 0x00, 0x02, 0x03, 0x03, 0x03, 0x03, 0x00, 0x04,
-  0x03, 0x04, 0x03, 0x04, 0x00, 0x02, 0x03, 0x87, 0x03, 0x87, 0x00, 0x01,
-  0x03, 0xea, 0x03, 0xea, 0x00, 0x01, 0x03, 0xec, 0x03, 0xec, 0x00, 0x01,
-  0x04, 0x17, 0x04, 0x1a, 0x00, 0x02, 0x05, 0x7d, 0x05, 0x7d, 0x00, 0x01,
-  0x06, 0x1b, 0x06, 0x1b, 0x00, 0x01, 0x07, 0xe3, 0x07, 0xe6, 0x00, 0x02,
-  0x08, 0x31, 0x08, 0x32, 0x00, 0x01, 0x00, 0x03, 0x00, 0x08, 0x00, 0x16,
-  0x00, 0x26, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x04,
-  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x0f, 0x00, 0x03, 0x00, 0x08, 0x00, 0x16, 0x00, 0x26, 0x00, 0x01,
-  0x00, 0x03, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0e,
-  0x00, 0x02, 0x00, 0x04, 0x00, 0x03, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x0e, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x02,
-  0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24, 0x00, 0x03, 0x00, 0x00,
-  0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02,
-  0x00, 0x02, 0x02, 0xa7, 0x02, 0xa7, 0x00, 0x01, 0x02, 0xa8, 0x02, 0xab,
-  0x00, 0x02, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x10, 0x00, 0x01, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x10, 0x00, 0x02, 0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24,
-  0x00, 0x03, 0x00, 0x00, 0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01,
-  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x02, 0xa7, 0x00, 0x05, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x11,
-  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x11, 0x00, 0x02, 0x00, 0x12, 0x00, 0x1c,
-  0x00, 0x24, 0x00, 0x24, 0x00, 0x03, 0x00, 0x00, 0x00, 0x34, 0x00, 0x46,
-  0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa7, 0x00, 0x05,
-  0x00, 0x02, 0x00, 0x02, 0x00, 0x01, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x12, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02,
-  0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24, 0x00, 0x03, 0x00, 0x00,
-  0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x02, 0xa7, 0x00, 0x05, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x02, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x13, 0x00, 0x01, 0x00, 0x04,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x13, 0x00, 0x02, 0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24,
-  0x00, 0x03, 0x00, 0x00, 0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01,
-  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x02, 0xa7, 0x02, 0xaa, 0x00, 0x02,
-  0x02, 0xab, 0x02, 0xab, 0x00, 0x01, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x14,
-  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x14, 0x00, 0x02, 0x00, 0x12, 0x00, 0x18,
-  0x00, 0x18, 0x00, 0x28, 0x00, 0x03, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x01, 0x02, 0xa7, 0x00, 0x02, 0x00, 0x02, 0x02, 0xa7,
-  0x02, 0xa7, 0x00, 0x01, 0x0e, 0xaa, 0x0e, 0xad, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
-  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
-  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x03,
-  0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xa8,
-  0x00, 0x02, 0x00, 0x03, 0x02, 0xa8, 0x02, 0xa8, 0x00, 0x01, 0x0e, 0xae,
-  0x0e, 0xae, 0x00, 0x02, 0x0e, 0xb0, 0x0e, 0xb2, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
-  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
-  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x03,
-  0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xa9,
-  0x00, 0x02, 0x00, 0x03, 0x02, 0xa9, 0x02, 0xa9, 0x00, 0x01, 0x0e, 0xb3,
-  0x0e, 0xb4, 0x00, 0x02, 0x0e, 0xb6, 0x0e, 0xb7, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
-  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
-  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x03,
-  0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xaa,
-  0x00, 0x02, 0x00, 0x03, 0x02, 0xaa, 0x02, 0xaa, 0x00, 0x01, 0x0e, 0xb8,
-  0x0e, 0xba, 0x00, 0x02, 0x0e, 0xbc, 0x0e, 0xbc, 0x00, 0x02, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
-  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
-  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x28, 0x00, 0x03,
-  0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xab,
-  0x00, 0x02, 0x00, 0x02, 0x02, 0xab, 0x02, 0xab, 0x00, 0x01, 0x0e, 0xbd,
-  0x0e, 0xc0, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x04, 0x00, 0x01, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x15, 0x00, 0x01, 0x00, 0x06, 0x0b, 0x43,
-  0x00, 0x01, 0x00, 0x01, 0x03, 0xc5, 0x00, 0x01, 0x00, 0x06, 0x10, 0x0f,
-  0x00, 0x01, 0x00, 0x01, 0x01, 0x0c, 0x00, 0x01, 0x00, 0x36, 0x00, 0x01,
-  0x00, 0x08, 0x00, 0x05, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x1c, 0x00, 0x22,
-  0x00, 0x28, 0x0f, 0x0d, 0x00, 0x03, 0x00, 0x49, 0x00, 0x4f, 0x0f, 0x0c,
-  0x00, 0x03, 0x00, 0x49, 0x00, 0x4c, 0x0f, 0x0b, 0x00, 0x02, 0x00, 0x4f,
-  0x0f, 0x0a, 0x00, 0x02, 0x00, 0x4c, 0x0f, 0x09, 0x00, 0x02, 0x00, 0x49,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x49, 0x00, 0x01, 0x00, 0x12, 0x00, 0x01,
-  0x00, 0x08, 0x00, 0x01, 0x00, 0x04, 0x0f, 0x0f, 0x00, 0x02, 0x00, 0x57,
-  0x00, 0x01, 0x00, 0x01, 0x00, 0x56, 0x00, 0x01, 0x00, 0x12, 0x00, 0x01,
-  0x00, 0x08, 0x00, 0x01, 0x00, 0x04, 0x0f, 0x0e, 0x00, 0x02, 0x00, 0x57,
-  0x00, 0x01, 0x00, 0x01, 0x01, 0x41, 0x00, 0x01, 0x00, 0x88, 0x00, 0x08,
-  0x00, 0x16, 0x00, 0x28, 0x00, 0x3a, 0x00, 0x46, 0x00, 0x50, 0x00, 0x5a,
-  0x00, 0x66, 0x00, 0x72, 0x00, 0x02, 0x00, 0x06, 0x00, 0x0c, 0x07, 0x7e,
-  0x00, 0x02, 0x00, 0x22, 0x07, 0x71, 0x00, 0x02, 0x00, 0x04, 0x00, 0x02,
-  0x00, 0x06, 0x00, 0x0c, 0x07, 0x7d, 0x00, 0x02, 0x00, 0x04, 0x07, 0x7c,
-  0x00, 0x02, 0x00, 0x22, 0x00, 0x01, 0x00, 0x04, 0x08, 0x24, 0x00, 0x03,
-  0x00, 0x24, 0x00, 0x3b, 0x00, 0x01, 0x00, 0x04, 0x07, 0xd2, 0x00, 0x02,
-  0x00, 0x56, 0x00, 0x01, 0x00, 0x04, 0x08, 0x09, 0x00, 0x02, 0x00, 0x30,
-  0x00, 0x01, 0x00, 0x04, 0x08, 0x0a, 0x00, 0x03, 0x00, 0x28, 0x00, 0x2f,
-  0x00, 0x01, 0x00, 0x04, 0x07, 0xea, 0x00, 0x03, 0x00, 0x12, 0x00, 0x46,
-  0x00, 0x02, 0x00, 0x06, 0x00, 0x0e, 0x07, 0xf0, 0x00, 0x03, 0x00, 0x12,
-  0x00, 0x58, 0x07, 0xef, 0x00, 0x03, 0x00, 0x12, 0x00, 0x52, 0x00, 0x01,
-  0x00, 0x08, 0x00, 0x04, 0x00, 0x22, 0x00, 0x29, 0x00, 0x35, 0x00, 0x36,
-  0x00, 0x37, 0x00, 0x44, 0x00, 0x46, 0x00, 0x02, 0x00, 0x14, 0x00, 0x07,
-  0x03, 0x67, 0x03, 0x66, 0x03, 0x68, 0x03, 0x64, 0x03, 0x65, 0x03, 0x6a,
-  0x03, 0x69, 0x00, 0x01, 0x00, 0x07, 0x03, 0x23, 0x03, 0x39, 0x03, 0x3f,
-  0x03, 0x46, 0x03, 0x4c, 0x03, 0x54, 0x03, 0x5a, 0x00, 0x02, 0x00, 0x14,
-  0x00, 0x07, 0x03, 0x67, 0x03, 0x66, 0x03, 0x68, 0x03, 0x64, 0x03, 0x65,
-  0x03, 0x6a, 0x03, 0x69, 0x00, 0x01, 0x00, 0x07, 0x03, 0x23, 0x03, 0x39,
-  0x03, 0x3f, 0x03, 0x46, 0x03, 0x4c, 0x03, 0x54, 0x03, 0x5a, 0x00, 0x02,
-  0x00, 0x10, 0x00, 0x05, 0x11, 0x48, 0x11, 0x34, 0x02, 0x13, 0x11, 0x3e,
-  0x11, 0x1b, 0x00, 0x01, 0x00, 0x05, 0x00, 0x2c, 0x00, 0x2d, 0x00, 0x44,
-  0x00, 0x4f, 0x01, 0x0c, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x06, 0x00, 0x12,
-  0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x26, 0x00, 0x01,
-  0x11, 0x48, 0x00, 0x01, 0x11, 0x34, 0x00, 0x01, 0x02, 0x13, 0x00, 0x01,
-  0x11, 0x3e, 0x00, 0x01, 0x11, 0xb8, 0x00, 0x01, 0x11, 0x1b, 0x00, 0x01,
-  0x00, 0x06, 0x00, 0x2c, 0x00, 0x2d, 0x00, 0x44, 0x00, 0x4f, 0x00, 0x5c,
-  0x01, 0x0c, 0x00, 0x02, 0x00, 0x1e, 0x00, 0x0c, 0x10, 0xee, 0x10, 0xec,
-  0x10, 0xef, 0x10, 0xed, 0x10, 0xf2, 0x10, 0xf3, 0x10, 0xeb, 0x11, 0xac,
-  0x10, 0xf4, 0x10, 0xf0, 0x10, 0xf5, 0x10, 0xf1, 0x00, 0x01, 0x00, 0x0c,
-  0x02, 0xb1, 0x02, 0xb2, 0x02, 0xb3, 0x02, 0xb4, 0x02, 0xb7, 0x02, 0xb8,
-  0x02, 0xb9, 0x02, 0xbb, 0x02, 0xbc, 0x02, 0xbd, 0x02, 0xc0, 0x02, 0xc2,
-  0x00, 0x02, 0x00, 0x20, 0x00, 0x0d, 0x00, 0xf3, 0x01, 0xf9, 0x11, 0x42,
-  0x02, 0x21, 0x11, 0x1c, 0x11, 0x1d, 0x01, 0xf9, 0x00, 0xf3, 0x01, 0xf9,
-  0x11, 0x45, 0x11, 0x46, 0x11, 0x43, 0x11, 0x44, 0x00, 0x01, 0x00, 0x0d,
-  0x00, 0x4c, 0x00, 0x4d, 0x00, 0xf1, 0x02, 0x0b, 0x02, 0x2a, 0x02, 0x5f,
-  0x03, 0x87, 0x03, 0xea, 0x03, 0xec, 0x05, 0x7d, 0x06, 0x1b, 0x08, 0x31,
-  0x08, 0x32, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x02, 0x00, 0x02, 0x00, 0x01,
-  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x07,
-  0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x06, 0x0c, 0x0c, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab,
-  0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x11, 0x00, 0x02, 0x00, 0x01,
-  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x16,
-  0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x02,
-  0x00, 0x10, 0x00, 0x05, 0x0e, 0xc2, 0x0e, 0xc2, 0x0e, 0xc2, 0x0e, 0xc2,
-  0x0e, 0xc2, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00,
-  0x00, 0x01, 0x03, 0xa6, 0x01, 0x90, 0x00, 0x04, 0x00, 0x00, 0x05, 0x33,
-  0x05, 0x99, 0x00, 0x00, 0x01, 0x1e, 0x05, 0x33, 0x05, 0x99, 0x00, 0x00,
-  0x03, 0xd7, 0x00, 0x66, 0x02, 0x12, 0x00, 0x00, 0x02, 0x0b, 0x06, 0x06,
-  0x03, 0x08, 0x04, 0x02, 0x02, 0x04, 0xe0, 0x00, 0x02, 0xff, 0x52, 0x00,
-  0xfd, 0xff, 0x02, 0x24, 0x00, 0x21, 0x04, 0x00, 0x20, 0x00, 0x50, 0x66,
-  0x45, 0x64, 0x00, 0x40, 0x00, 0x20, 0xff, 0xff, 0x06, 0x14, 0xfe, 0x14,
-  0x01, 0x9a, 0x07, 0x6d, 0x01, 0xe3, 0x60, 0x00, 0x01, 0xff, 0xdf, 0xff,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x03,
-  0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x04, 0x8c,
-  0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x03, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x2c, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x04, 0x8c,
-  0x00, 0x04, 0x04, 0x60, 0x00, 0x00, 0x01, 0x14, 0x01, 0x00, 0x00, 0x07,
-  0x00, 0x14, 0x00, 0x00, 0x00, 0x7e, 0x02, 0xe9, 0x02, 0xee, 0x02, 0xf3,
-  0x02, 0xf7, 0x03, 0x4f, 0x03, 0x53, 0x03, 0x58, 0x03, 0x5a, 0x03, 0x62,
-  0x03, 0x77, 0x03, 0x7e, 0x03, 0x8a, 0x03, 0x8c, 0x03, 0xa1, 0x05, 0x25,
-  0x1d, 0x14, 0x1d, 0x23, 0x1d, 0x2e, 0x1d, 0x5b, 0x1d, 0x6a, 0x1d, 0x78,
-  0x1d, 0x7b, 0x1d, 0x7d, 0x1d, 0x85, 0x1d, 0xbf, 0x1d, 0xc9, 0x1e, 0xfb,
-  0x1f, 0x15, 0x1f, 0x1d, 0x1f, 0x45, 0x1f, 0x4d, 0x1f, 0x57, 0x1f, 0x59,
-  0x1f, 0x5b, 0x1f, 0x5d, 0x1f, 0x7d, 0x1f, 0xb4, 0x1f, 0xc4, 0x1f, 0xd3,
-  0x1f, 0xdb, 0x1f, 0xef, 0x1f, 0xf4, 0x1f, 0xfe, 0x20, 0x64, 0x20, 0x71,
-  0x20, 0x8e, 0x20, 0x9c, 0x20, 0xb5, 0x20, 0xba, 0x20, 0xd1, 0x20, 0xd7,
-  0x20, 0xdc, 0x20, 0xe1, 0x21, 0x09, 0x21, 0x49, 0x21, 0x4b, 0x21, 0x4e,
-  0x21, 0x85, 0x21, 0x89, 0x23, 0x11, 0x23, 0x19, 0x23, 0x21, 0x23, 0x28,
-  0x23, 0x2c, 0x23, 0x75, 0x23, 0x7a, 0x23, 0x7d, 0x23, 0x87, 0x23, 0x94,
-  0x23, 0xae, 0x23, 0xcf, 0x23, 0xe3, 0x23, 0xe5, 0x23, 0xe8, 0x24, 0x23,
-  0x24, 0x69, 0x26, 0x9c, 0x26, 0xb8, 0x26, 0xc3, 0x26, 0xe2, 0x27, 0x04,
-  0x27, 0x09, 0x27, 0x27, 0x27, 0x4b, 0x27, 0x4d, 0x27, 0x52, 0x27, 0x56,
-  0x27, 0x5e, 0x27, 0x94, 0x27, 0xaf, 0x27, 0xbe, 0x27, 0xc6, 0x27, 0xe0,
-  0x27, 0xeb, 0x28, 0xff, 0x29, 0x07, 0x29, 0x0b, 0x29, 0x41, 0x29, 0x84,
-  0x29, 0xd5, 0x29, 0xeb, 0x29, 0xfb, 0x2a, 0x02, 0x2a, 0x1c, 0x2a, 0x2f,
-  0x2a, 0x6b, 0x2a, 0xa0, 0x2a, 0xba, 0x2a, 0xfa, 0x2b, 0x1a, 0x2b, 0x24,
-  0x2b, 0x54, 0x2c, 0x77, 0x2c, 0x7f, 0xa7, 0x16, 0xa7, 0x1f, 0xa7, 0x2b,
-  0xa7, 0x41, 0xa7, 0x4b, 0xa7, 0x53, 0xa7, 0x57, 0xa7, 0x67, 0xa7, 0x83,
-  0xa7, 0x8e, 0xa7, 0x91, 0xa7, 0xaa, 0xa7, 0xff, 0xef, 0x19, 0xf0, 0x03,
-  0xf4, 0x26, 0xf4, 0x41, 0xf6, 0xc5, 0xfb, 0x06, 0xfe, 0x23, 0xff, 0xfd,
-  0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0xa0, 0x02, 0xec,
-  0x02, 0xf3, 0x02, 0xf7, 0x03, 0x00, 0x03, 0x51, 0x03, 0x57, 0x03, 0x5a,
-  0x03, 0x5c, 0x03, 0x70, 0x03, 0x7a, 0x03, 0x84, 0x03, 0x8c, 0x03, 0x8e,
-  0x03, 0xa3, 0x1d, 0x00, 0x1d, 0x16, 0x1d, 0x26, 0x1d, 0x30, 0x1d, 0x5d,
-  0x1d, 0x77, 0x1d, 0x7b, 0x1d, 0x7d, 0x1d, 0x85, 0x1d, 0x9b, 0x1d, 0xc4,
-  0x1e, 0x00, 0x1f, 0x00, 0x1f, 0x18, 0x1f, 0x20, 0x1f, 0x48, 0x1f, 0x50,
-  0x1f, 0x59, 0x1f, 0x5b, 0x1f, 0x5d, 0x1f, 0x5f, 0x1f, 0x80, 0x1f, 0xb6,
-  0x1f, 0xc6, 0x1f, 0xd6, 0x1f, 0xdd, 0x1f, 0xf2, 0x1f, 0xf6, 0x20, 0x00,
-  0x20, 0x6a, 0x20, 0x74, 0x20, 0x90, 0x20, 0xa0, 0x20, 0xb8, 0x20, 0xd0,
-  0x20, 0xd6, 0x20, 0xdb, 0x20, 0xe1, 0x21, 0x00, 0x21, 0x0b, 0x21, 0x4b,
-  0x21, 0x4e, 0x21, 0x50, 0x21, 0x89, 0x21, 0x90, 0x23, 0x18, 0x23, 0x1c,
-  0x23, 0x24, 0x23, 0x2b, 0x23, 0x73, 0x23, 0x7a, 0x23, 0x7d, 0x23, 0x87,
-  0x23, 0x94, 0x23, 0x9b, 0x23, 0xce, 0x23, 0xe3, 0x23, 0xe5, 0x23, 0xe8,
-  0x24, 0x22, 0x24, 0x60, 0x25, 0x00, 0x26, 0xa0, 0x26, 0xc0, 0x26, 0xe2,
-  0x27, 0x01, 0x27, 0x06, 0x27, 0x0c, 0x27, 0x29, 0x27, 0x4d, 0x27, 0x4f,
-  0x27, 0x56, 0x27, 0x58, 0x27, 0x61, 0x27, 0x98, 0x27, 0xb1, 0x27, 0xc5,
-  0x27, 0xe0, 0x27, 0xe6, 0x27, 0xf0, 0x29, 0x06, 0x29, 0x0a, 0x29, 0x40,
-  0x29, 0x83, 0x29, 0xce, 0x29, 0xeb, 0x29, 0xfa, 0x2a, 0x00, 0x2a, 0x0c,
-  0x2a, 0x2f, 0x2a, 0x6a, 0x2a, 0x7d, 0x2a, 0xae, 0x2a, 0xf9, 0x2b, 0x00,
-  0x2b, 0x1f, 0x2b, 0x53, 0x2c, 0x60, 0x2c, 0x79, 0xa7, 0x08, 0xa7, 0x1b,
-  0xa7, 0x22, 0xa7, 0x30, 0xa7, 0x46, 0xa7, 0x4e, 0xa7, 0x56, 0xa7, 0x64,
-  0xa7, 0x80, 0xa7, 0x89, 0xa7, 0x90, 0xa7, 0xa0, 0xa7, 0xfa, 0xef, 0x00,
-  0xf0, 0x00, 0xf4, 0x00, 0xf4, 0x28, 0xf6, 0xc5, 0xfb, 0x00, 0xfe, 0x20,
-  0xff, 0xf9, 0xff, 0xff, 0x00, 0x00, 0xff, 0xe3, 0xff, 0xc2, 0xff, 0xc0,
-  0xff, 0xbc, 0xff, 0xb9, 0xff, 0xb1, 0xff, 0xb0, 0xff, 0xad, 0xff, 0xac,
-  0xff, 0xab, 0xff, 0x9e, 0xff, 0x9c, 0xff, 0x97, 0xff, 0x96, 0xff, 0x95,
-  0xff, 0x94, 0xe7, 0xba, 0xe7, 0xb9, 0xe7, 0xb7, 0xe7, 0xb6, 0xe7, 0xb5,
-  0xe7, 0xa9, 0xe7, 0xa7, 0xe7, 0xa6, 0xe7, 0x9f, 0xe7, 0x8a, 0xe7, 0x86,
-  0xe7, 0x50, 0xe7, 0x4c, 0xe7, 0x4a, 0xe7, 0x48, 0xe7, 0x46, 0xe7, 0x44,
-  0xe7, 0x43, 0xe7, 0x42, 0xe7, 0x41, 0xe7, 0x40, 0xe7, 0x3e, 0xe7, 0x3d,
-  0xe7, 0x3c, 0xe7, 0x3a, 0xe7, 0x39, 0xe7, 0x37, 0xe7, 0x36, 0xe7, 0x35,
-  0xe7, 0x30, 0xe7, 0x2e, 0xe7, 0x2d, 0xe7, 0x2a, 0xe7, 0x28, 0xe7, 0x13,
-  0xe7, 0x0f, 0xe7, 0x0c, 0xe7, 0x08, 0xe6, 0xea, 0xe6, 0xe9, 0xe6, 0xe8,
-  0xe6, 0xe6, 0xe6, 0xe5, 0xe6, 0xe2, 0xe6, 0xdc, 0xe6, 0xd6, 0xe6, 0xd4,
-  0xe6, 0xd2, 0xe6, 0xd0, 0xe6, 0x8a, 0xe6, 0x86, 0xe6, 0x84, 0xe6, 0x7b,
-  0xe6, 0x6f, 0xe6, 0x69, 0xe6, 0x4a, 0xe6, 0x37, 0xe6, 0x36, 0xe6, 0x34,
-  0xe5, 0xfb, 0xe5, 0xbf, 0xe5, 0x29, 0xe5, 0x26, 0xe5, 0x1f, 0xe5, 0x01,
-  0xe4, 0xe3, 0xe4, 0xe2, 0xe4, 0xe0, 0xe4, 0xdf, 0xe4, 0xde, 0xe4, 0xdd,
-  0xe4, 0xda, 0xe4, 0xd9, 0xe4, 0xd7, 0xe4, 0xd4, 0xe4, 0xd3, 0xe4, 0xcd,
-  0xe4, 0xb4, 0xe4, 0xaf, 0xe4, 0xab, 0xe4, 0xa5, 0xe4, 0xa3, 0xe4, 0x6f,
-  0xe4, 0x2e, 0xe3, 0xe5, 0xe3, 0xd0, 0xe3, 0xc2, 0xe3, 0xbe, 0xe3, 0xb5,
-  0xe3, 0xa3, 0xe3, 0x69, 0xe3, 0x58, 0xe3, 0x4b, 0xe3, 0x0d, 0xe3, 0x08,
-  0xe3, 0x04, 0xe2, 0xd6, 0xe1, 0xcb, 0xe1, 0xca, 0x67, 0x42, 0x67, 0x3e,
-  0x67, 0x3c, 0x67, 0x38, 0x67, 0x34, 0x67, 0x32, 0x67, 0x30, 0x67, 0x24,
-  0x67, 0x0c, 0x67, 0x07, 0x67, 0x06, 0x66, 0xf8, 0x66, 0xa9, 0x1f, 0xa9,
-  0x1e, 0xc3, 0x1a, 0xc7, 0x1a, 0xc6, 0x18, 0x43, 0x14, 0x09, 0x10, 0xf0,
-  0x0f, 0x1b, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x07, 0x78,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x9e, 0x00, 0x00, 0x00, 0x20,
-  0x00, 0x00, 0x00, 0x7e, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xa0,
-  0x00, 0x00, 0x02, 0xe9, 0x00, 0x00, 0x00, 0x62, 0x00, 0x00, 0x02, 0xec,
-  0x00, 0x00, 0x02, 0xee, 0x00, 0x00, 0x02, 0xac, 0x00, 0x00, 0x02, 0xf3,
-  0x00, 0x00, 0x02, 0xf3, 0x00, 0x00, 0x02, 0xaf, 0x00, 0x00, 0x02, 0xf7,
-  0x00, 0x00, 0x02, 0xf7, 0x00, 0x00, 0x02, 0xb0, 0x00, 0x00, 0x03, 0x00,
-  0x00, 0x00, 0x03, 0x4f, 0x00, 0x00, 0x02, 0xb1, 0x00, 0x00, 0x03, 0x51,
-  0x00, 0x00, 0x03, 0x53, 0x00, 0x00, 0x03, 0x01, 0x00, 0x00, 0x03, 0x57,
-  0x00, 0x00, 0x03, 0x58, 0x00, 0x00, 0x03, 0x04, 0x00, 0x00, 0x03, 0x5a,
-  0x00, 0x00, 0x03, 0x5a, 0x00, 0x00, 0x03, 0x06, 0x00, 0x00, 0x03, 0x5c,
-  0x00, 0x00, 0x03, 0x62, 0x00, 0x00, 0x03, 0x07, 0x00, 0x00, 0x03, 0x70,
-  0x00, 0x00, 0x03, 0x77, 0x00, 0x00, 0x03, 0x0e, 0x00, 0x00, 0x03, 0x7a,
-  0x00, 0x00, 0x03, 0x7e, 0x00, 0x00, 0x03, 0x16, 0x00, 0x00, 0x03, 0x84,
-  0x00, 0x00, 0x03, 0x8a, 0x00, 0x00, 0x03, 0x1b, 0x00, 0x00, 0x03, 0x8c,
-  0x00, 0x00, 0x03, 0x8c, 0x00, 0x00, 0x03, 0x22, 0x00, 0x00, 0x03, 0x8e,
-  0x00, 0x00, 0x03, 0xa1, 0x00, 0x00, 0x03, 0x23, 0x00, 0x00, 0x03, 0xa3,
-  0x00, 0x00, 0x05, 0x25, 0x00, 0x00, 0x03, 0x37, 0x00, 0x00, 0x1d, 0x00,
-  0x00, 0x00, 0x1d, 0x14, 0x00, 0x00, 0x04, 0xba, 0x00, 0x00, 0x1d, 0x16,
-  0x00, 0x00, 0x1d, 0x23, 0x00, 0x00, 0x04, 0xcf, 0x00, 0x00, 0x1d, 0x26,
-  0x00, 0x00, 0x1d, 0x2e, 0x00, 0x00, 0x04, 0xdd, 0x00, 0x00, 0x1d, 0x30,
-  0x00, 0x00, 0x1d, 0x5b, 0x00, 0x00, 0x04, 0xe6, 0x00, 0x00, 0x1d, 0x5d,
-  0x00, 0x00, 0x1d, 0x6a, 0x00, 0x00, 0x05, 0x12, 0x00, 0x00, 0x1d, 0x77,
-  0x00, 0x00, 0x1d, 0x78, 0x00, 0x00, 0x05, 0x20, 0x00, 0x00, 0x1d, 0x7b,
-  0x00, 0x00, 0x1d, 0x7b, 0x00, 0x00, 0x05, 0x22, 0x00, 0x00, 0x1d, 0x7d,
-  0x00, 0x00, 0x1d, 0x7d, 0x00, 0x00, 0x05, 0x23, 0x00, 0x00, 0x1d, 0x85,
-  0x00, 0x00, 0x1d, 0x85, 0x00, 0x00, 0x05, 0x24, 0x00, 0x00, 0x1d, 0x9b,
-  0x00, 0x00, 0x1d, 0xbf, 0x00, 0x00, 0x05, 0x25, 0x00, 0x00, 0x1d, 0xc4,
-  0x00, 0x00, 0x1d, 0xc9, 0x00, 0x00, 0x05, 0x4a, 0x00, 0x00, 0x1e, 0x00,
-  0x00, 0x00, 0x1e, 0xfb, 0x00, 0x00, 0x05, 0x50, 0x00, 0x00, 0x1f, 0x00,
-  0x00, 0x00, 0x1f, 0x15, 0x00, 0x00, 0x06, 0x4c, 0x00, 0x00, 0x1f, 0x18,
-  0x00, 0x00, 0x1f, 0x1d, 0x00, 0x00, 0x06, 0x62, 0x00, 0x00, 0x1f, 0x20,
-  0x00, 0x00, 0x1f, 0x45, 0x00, 0x00, 0x06, 0x68, 0x00, 0x00, 0x1f, 0x48,
-  0x00, 0x00, 0x1f, 0x4d, 0x00, 0x00, 0x06, 0x8e, 0x00, 0x00, 0x1f, 0x50,
-  0x00, 0x00, 0x1f, 0x57, 0x00, 0x00, 0x06, 0x94, 0x00, 0x00, 0x1f, 0x59,
-  0x00, 0x00, 0x1f, 0x59, 0x00, 0x00, 0x06, 0x9c, 0x00, 0x00, 0x1f, 0x5b,
-  0x00, 0x00, 0x1f, 0x5b, 0x00, 0x00, 0x06, 0x9d, 0x00, 0x00, 0x1f, 0x5d,
-  0x00, 0x00, 0x1f, 0x5d, 0x00, 0x00, 0x06, 0x9e, 0x00, 0x00, 0x1f, 0x5f,
-  0x00, 0x00, 0x1f, 0x7d, 0x00, 0x00, 0x06, 0x9f, 0x00, 0x00, 0x1f, 0x80,
-  0x00, 0x00, 0x1f, 0xb4, 0x00, 0x00, 0x06, 0xbe, 0x00, 0x00, 0x1f, 0xb6,
-  0x00, 0x00, 0x1f, 0xc4, 0x00, 0x00, 0x06, 0xf3, 0x00, 0x00, 0x1f, 0xc6,
-  0x00, 0x00, 0x1f, 0xd3, 0x00, 0x00, 0x07, 0x02, 0x00, 0x00, 0x1f, 0xd6,
-  0x00, 0x00, 0x1f, 0xdb, 0x00, 0x00, 0x07, 0x10, 0x00, 0x00, 0x1f, 0xdd,
-  0x00, 0x00, 0x1f, 0xef, 0x00, 0x00, 0x07, 0x16, 0x00, 0x00, 0x1f, 0xf2,
-  0x00, 0x00, 0x1f, 0xf4, 0x00, 0x00, 0x07, 0x29, 0x00, 0x00, 0x1f, 0xf6,
-  0x00, 0x00, 0x1f, 0xfe, 0x00, 0x00, 0x07, 0x2c, 0x00, 0x00, 0x20, 0x00,
-  0x00, 0x00, 0x20, 0x64, 0x00, 0x00, 0x07, 0x35, 0x00, 0x00, 0x20, 0x6a,
-  0x00, 0x00, 0x20, 0x71, 0x00, 0x00, 0x07, 0x9a, 0x00, 0x00, 0x20, 0x74,
-  0x00, 0x00, 0x20, 0x8e, 0x00, 0x00, 0x07, 0xa2, 0x00, 0x00, 0x20, 0x90,
-  0x00, 0x00, 0x20, 0x9c, 0x00, 0x00, 0x07, 0xbd, 0x00, 0x00, 0x20, 0xa0,
-  0x00, 0x00, 0x20, 0xb5, 0x00, 0x00, 0x07, 0xca, 0x00, 0x00, 0x20, 0xb8,
-  0x00, 0x00, 0x20, 0xba, 0x00, 0x00, 0x07, 0xe0, 0x00, 0x00, 0x20, 0xd0,
-  0x00, 0x00, 0x20, 0xd1, 0x00, 0x00, 0x07, 0xe3, 0x00, 0x00, 0x20, 0xd6,
-  0x00, 0x00, 0x20, 0xd7, 0x00, 0x00, 0x07, 0xe5, 0x00, 0x00, 0x20, 0xdb,
-  0x00, 0x00, 0x20, 0xdc, 0x00, 0x00, 0x07, 0xe7, 0x00, 0x00, 0x20, 0xe1,
-  0x00, 0x00, 0x20, 0xe1, 0x00, 0x00, 0x07, 0xe9, 0x00, 0x00, 0x21, 0x00,
-  0x00, 0x00, 0x21, 0x09, 0x00, 0x00, 0x07, 0xea, 0x00, 0x00, 0x21, 0x0b,
-  0x00, 0x00, 0x21, 0x49, 0x00, 0x00, 0x07, 0xf4, 0x00, 0x00, 0x21, 0x4b,
-  0x00, 0x00, 0x21, 0x4b, 0x00, 0x00, 0x08, 0x33, 0x00, 0x00, 0x21, 0x4e,
-  0x00, 0x00, 0x21, 0x4e, 0x00, 0x00, 0x08, 0x34, 0x00, 0x00, 0x21, 0x50,
-  0x00, 0x00, 0x21, 0x85, 0x00, 0x00, 0x08, 0x35, 0x00, 0x00, 0x21, 0x89,
-  0x00, 0x00, 0x21, 0x89, 0x00, 0x00, 0x08, 0x6b, 0x00, 0x00, 0x21, 0x90,
-  0x00, 0x00, 0x23, 0x11, 0x00, 0x00, 0x08, 0x6c, 0x00, 0x00, 0x23, 0x18,
-  0x00, 0x00, 0x23, 0x19, 0x00, 0x00, 0x09, 0xee, 0x00, 0x00, 0x23, 0x1c,
-  0x00, 0x00, 0x23, 0x21, 0x00, 0x00, 0x09, 0xf0, 0x00, 0x00, 0x23, 0x24,
-  0x00, 0x00, 0x23, 0x28, 0x00, 0x00, 0x09, 0xf6, 0x00, 0x00, 0x23, 0x2b,
-  0x00, 0x00, 0x23, 0x2c, 0x00, 0x00, 0x09, 0xfb, 0x00, 0x00, 0x23, 0x73,
-  0x00, 0x00, 0x23, 0x75, 0x00, 0x00, 0x09, 0xfd, 0x00, 0x00, 0x23, 0x7a,
-  0x00, 0x00, 0x23, 0x7a, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x23, 0x7d,
-  0x00, 0x00, 0x23, 0x7d, 0x00, 0x00, 0x0a, 0x01, 0x00, 0x00, 0x23, 0x87,
-  0x00, 0x00, 0x23, 0x87, 0x00, 0x00, 0x0a, 0x02, 0x00, 0x00, 0x23, 0x94,
-  0x00, 0x00, 0x23, 0x94, 0x00, 0x00, 0x0a, 0x03, 0x00, 0x00, 0x23, 0x9b,
-  0x00, 0x00, 0x23, 0xae, 0x00, 0x00, 0x0a, 0x04, 0x00, 0x00, 0x23, 0xce,
-  0x00, 0x00, 0x23, 0xcf, 0x00, 0x00, 0x0a, 0x18, 0x00, 0x00, 0x23, 0xe3,
-  0x00, 0x00, 0x23, 0xe3, 0x00, 0x00, 0x0a, 0x1a, 0x00, 0x00, 0x23, 0xe5,
-  0x00, 0x00, 0x23, 0xe5, 0x00, 0x00, 0x0a, 0x1b, 0x00, 0x00, 0x23, 0xe8,
-  0x00, 0x00, 0x23, 0xe8, 0x00, 0x00, 0x0a, 0x1c, 0x00, 0x00, 0x24, 0x22,
-  0x00, 0x00, 0x24, 0x23, 0x00, 0x00, 0x0a, 0x1d, 0x00, 0x00, 0x24, 0x60,
-  0x00, 0x00, 0x24, 0x69, 0x00, 0x00, 0x0a, 0x1f, 0x00, 0x00, 0x25, 0x00,
-  0x00, 0x00, 0x26, 0x9c, 0x00, 0x00, 0x0a, 0x29, 0x00, 0x00, 0x26, 0xa0,
-  0x00, 0x00, 0x26, 0xb8, 0x00, 0x00, 0x0b, 0xc6, 0x00, 0x00, 0x26, 0xc0,
-  0x00, 0x00, 0x26, 0xc3, 0x00, 0x00, 0x0b, 0xdf, 0x00, 0x00, 0x26, 0xe2,
-  0x00, 0x00, 0x26, 0xe2, 0x00, 0x00, 0x0b, 0xe3, 0x00, 0x00, 0x27, 0x01,
-  0x00, 0x00, 0x27, 0x04, 0x00, 0x00, 0x0b, 0xe4, 0x00, 0x00, 0x27, 0x06,
-  0x00, 0x00, 0x27, 0x09, 0x00, 0x00, 0x0b, 0xe8, 0x00, 0x00, 0x27, 0x0c,
-  0x00, 0x00, 0x27, 0x27, 0x00, 0x00, 0x0b, 0xec, 0x00, 0x00, 0x27, 0x29,
-  0x00, 0x00, 0x27, 0x4b, 0x00, 0x00, 0x0c, 0x08, 0x00, 0x00, 0x27, 0x4d,
-  0x00, 0x00, 0x27, 0x4d, 0x00, 0x00, 0x0c, 0x2b, 0x00, 0x00, 0x27, 0x4f,
-  0x00, 0x00, 0x27, 0x52, 0x00, 0x00, 0x0c, 0x2c, 0x00, 0x00, 0x27, 0x56,
-  0x00, 0x00, 0x27, 0x56, 0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x27, 0x58,
-  0x00, 0x00, 0x27, 0x5e, 0x00, 0x00, 0x0c, 0x31, 0x00, 0x00, 0x27, 0x61,
-  0x00, 0x00, 0x27, 0x94, 0x00, 0x00, 0x0c, 0x38, 0x00, 0x00, 0x27, 0x98,
-  0x00, 0x00, 0x27, 0xaf, 0x00, 0x00, 0x0c, 0x6c, 0x00, 0x00, 0x27, 0xb1,
-  0x00, 0x00, 0x27, 0xbe, 0x00, 0x00, 0x0c, 0x84, 0x00, 0x00, 0x27, 0xc5,
-  0x00, 0x00, 0x27, 0xc6, 0x00, 0x00, 0x0c, 0x92, 0x00, 0x00, 0x27, 0xe0,
-  0x00, 0x00, 0x27, 0xe0, 0x00, 0x00, 0x0c, 0x94, 0x00, 0x00, 0x27, 0xe6,
-  0x00, 0x00, 0x27, 0xeb, 0x00, 0x00, 0x0c, 0x95, 0x00, 0x00, 0x27, 0xf0,
-  0x00, 0x00, 0x28, 0xff, 0x00, 0x00, 0x0c, 0x9b, 0x00, 0x00, 0x29, 0x06,
-  0x00, 0x00, 0x29, 0x07, 0x00, 0x00, 0x0d, 0xab, 0x00, 0x00, 0x29, 0x0a,
-  0x00, 0x00, 0x29, 0x0b, 0x00, 0x00, 0x0d, 0xad, 0x00, 0x00, 0x29, 0x40,
-  0x00, 0x00, 0x29, 0x41, 0x00, 0x00, 0x0d, 0xaf, 0x00, 0x00, 0x29, 0x83,
-  0x00, 0x00, 0x29, 0x84, 0x00, 0x00, 0x0d, 0xb1, 0x00, 0x00, 0x29, 0xce,
-  0x00, 0x00, 0x29, 0xd5, 0x00, 0x00, 0x0d, 0xb3, 0x00, 0x00, 0x29, 0xeb,
-  0x00, 0x00, 0x29, 0xeb, 0x00, 0x00, 0x0d, 0xbb, 0x00, 0x00, 0x29, 0xfa,
-  0x00, 0x00, 0x29, 0xfb, 0x00, 0x00, 0x0d, 0xbc, 0x00, 0x00, 0x2a, 0x00,
-  0x00, 0x00, 0x2a, 0x02, 0x00, 0x00, 0x0d, 0xbe, 0x00, 0x00, 0x2a, 0x0c,
-  0x00, 0x00, 0x2a, 0x1c, 0x00, 0x00, 0x0d, 0xc1, 0x00, 0x00, 0x2a, 0x2f,
-  0x00, 0x00, 0x2a, 0x2f, 0x00, 0x00, 0x0d, 0xd2, 0x00, 0x00, 0x2a, 0x6a,
-  0x00, 0x00, 0x2a, 0x6b, 0x00, 0x00, 0x0d, 0xd3, 0x00, 0x00, 0x2a, 0x7d,
-  0x00, 0x00, 0x2a, 0xa0, 0x00, 0x00, 0x0d, 0xd5, 0x00, 0x00, 0x2a, 0xae,
-  0x00, 0x00, 0x2a, 0xba, 0x00, 0x00, 0x0d, 0xf9, 0x00, 0x00, 0x2a, 0xf9,
-  0x00, 0x00, 0x2a, 0xfa, 0x00, 0x00, 0x0e, 0x06, 0x00, 0x00, 0x2b, 0x00,
-  0x00, 0x00, 0x2b, 0x1a, 0x00, 0x00, 0x0e, 0x08, 0x00, 0x00, 0x2b, 0x1f,
-  0x00, 0x00, 0x2b, 0x24, 0x00, 0x00, 0x0e, 0x23, 0x00, 0x00, 0x2b, 0x53,
-  0x00, 0x00, 0x2b, 0x54, 0x00, 0x00, 0x0e, 0x29, 0x00, 0x00, 0x2c, 0x60,
-  0x00, 0x00, 0x2c, 0x77, 0x00, 0x00, 0x0e, 0x2b, 0x00, 0x00, 0x2c, 0x79,
-  0x00, 0x00, 0x2c, 0x7f, 0x00, 0x00, 0x0e, 0x43, 0x00, 0x00, 0xa7, 0x08,
-  0x00, 0x00, 0xa7, 0x16, 0x00, 0x00, 0x0e, 0x4a, 0x00, 0x00, 0xa7, 0x1b,
-  0x00, 0x00, 0xa7, 0x1f, 0x00, 0x00, 0x0e, 0x59, 0x00, 0x00, 0xa7, 0x22,
-  0x00, 0x00, 0xa7, 0x2b, 0x00, 0x00, 0x0e, 0x5e, 0x00, 0x00, 0xa7, 0x30,
-  0x00, 0x00, 0xa7, 0x41, 0x00, 0x00, 0x0e, 0x68, 0x00, 0x00, 0xa7, 0x46,
-  0x00, 0x00, 0xa7, 0x4b, 0x00, 0x00, 0x0e, 0x7a, 0x00, 0x00, 0xa7, 0x4e,
-  0x00, 0x00, 0xa7, 0x53, 0x00, 0x00, 0x0e, 0x80, 0x00, 0x00, 0xa7, 0x56,
-  0x00, 0x00, 0xa7, 0x57, 0x00, 0x00, 0x0e, 0x86, 0x00, 0x00, 0xa7, 0x64,
-  0x00, 0x00, 0xa7, 0x67, 0x00, 0x00, 0x0e, 0x88, 0x00, 0x00, 0xa7, 0x80,
-  0x00, 0x00, 0xa7, 0x83, 0x00, 0x00, 0x0e, 0x8c, 0x00, 0x00, 0xa7, 0x89,
-  0x00, 0x00, 0xa7, 0x8e, 0x00, 0x00, 0x0e, 0x90, 0x00, 0x00, 0xa7, 0x90,
-  0x00, 0x00, 0xa7, 0x91, 0x00, 0x00, 0x0e, 0x96, 0x00, 0x00, 0xa7, 0xa0,
-  0x00, 0x00, 0xa7, 0xaa, 0x00, 0x00, 0x0e, 0x98, 0x00, 0x00, 0xa7, 0xfa,
-  0x00, 0x00, 0xa7, 0xff, 0x00, 0x00, 0x0e, 0xa3, 0x00, 0x00, 0xef, 0x00,
-  0x00, 0x00, 0xef, 0x19, 0x00, 0x00, 0x0e, 0xa9, 0x00, 0x00, 0xf0, 0x00,
-  0x00, 0x00, 0xf0, 0x03, 0x00, 0x00, 0x0e, 0xc3, 0x00, 0x00, 0xf4, 0x00,
-  0x00, 0x00, 0xf4, 0x26, 0x00, 0x00, 0x0e, 0xc7, 0x00, 0x00, 0xf4, 0x28,
-  0x00, 0x00, 0xf4, 0x41, 0x00, 0x00, 0x0e, 0xee, 0x00, 0x00, 0xf6, 0xc5,
-  0x00, 0x00, 0xf6, 0xc5, 0x00, 0x00, 0x0f, 0x08, 0x00, 0x00, 0xfb, 0x00,
-  0x00, 0x00, 0xfb, 0x06, 0x00, 0x00, 0x0f, 0x09, 0x00, 0x00, 0xfe, 0x20,
-  0x00, 0x00, 0xfe, 0x23, 0x00, 0x00, 0x0f, 0x10, 0x00, 0x00, 0xff, 0xf9,
-  0x00, 0x00, 0xff, 0xfd, 0x00, 0x00, 0x0f, 0x14, 0x00, 0x01, 0x03, 0x00,
-  0x00, 0x01, 0x03, 0x1e, 0x00, 0x00, 0x0f, 0x19, 0x00, 0x01, 0x03, 0x20,
-  0x00, 0x01, 0x03, 0x23, 0x00, 0x00, 0x0f, 0x38, 0x00, 0x01, 0xd3, 0x00,
-  0x00, 0x01, 0xd3, 0x56, 0x00, 0x00, 0x0f, 0x3c, 0x00, 0x01, 0xd5, 0x38,
-  0x00, 0x01, 0xd5, 0x39, 0x00, 0x00, 0x0f, 0x93, 0x00, 0x01, 0xd5, 0x3b,
-  0x00, 0x01, 0xd5, 0x3e, 0x00, 0x00, 0x0f, 0x95, 0x00, 0x01, 0xd5, 0x40,
-  0x00, 0x01, 0xd5, 0x44, 0x00, 0x00, 0x0f, 0x99, 0x00, 0x01, 0xd5, 0x46,
-  0x00, 0x01, 0xd5, 0x46, 0x00, 0x00, 0x0f, 0x9e, 0x00, 0x01, 0xd5, 0x4a,
-  0x00, 0x01, 0xd5, 0x50, 0x00, 0x00, 0x0f, 0x9f, 0x00, 0x01, 0xd5, 0x52,
-  0x00, 0x01, 0xd5, 0x6b, 0x00, 0x00, 0x0f, 0xa6, 0x00, 0x01, 0xd5, 0xa0,
-  0x00, 0x01, 0xd5, 0xd3, 0x00, 0x00, 0x0f, 0xc0, 0x00, 0x01, 0xd7, 0xd8,
-  0x00, 0x01, 0xd7, 0xeb, 0x00, 0x00, 0x0f, 0xf4, 0x00, 0x01, 0xf0, 0x30,
-  0x00, 0x01, 0xf0, 0x93, 0x00, 0x00, 0x10, 0x08, 0x00, 0x01, 0xf0, 0xa0,
-  0x00, 0x01, 0xf0, 0xae, 0x00, 0x00, 0x10, 0x6c, 0x00, 0x01, 0xf0, 0xb1,
-  0x00, 0x01, 0xf0, 0xbe, 0x00, 0x00, 0x10, 0x7b, 0x00, 0x01, 0xf0, 0xc1,
-  0x00, 0x01, 0xf0, 0xcf, 0x00, 0x00, 0x10, 0x89, 0x00, 0x01, 0xf0, 0xd1,
-  0x00, 0x01, 0xf0, 0xdf, 0x00, 0x00, 0x10, 0x98, 0x00, 0x01, 0xf4, 0x2d,
-  0x00, 0x01, 0xf4, 0x2e, 0x00, 0x00, 0x10, 0xa7, 0x00, 0x01, 0xf4, 0x31,
-  0x00, 0x01, 0xf4, 0x31, 0x00, 0x00, 0x10, 0xa9, 0x00, 0x01, 0xf4, 0x35,
-  0x00, 0x01, 0xf4, 0x35, 0x00, 0x00, 0x10, 0xaa, 0x00, 0x01, 0xf6, 0x00,
-  0x00, 0x01, 0xf6, 0x23, 0x00, 0x00, 0x10, 0xab, 0x00, 0x01, 0xf6, 0x25,
-  0x00, 0x01, 0xf6, 0x2b, 0x00, 0x00, 0x10, 0xcf, 0x00, 0x01, 0xf6, 0x2d,
-  0x00, 0x01, 0xf6, 0x40, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x06, 0x02, 0x0a,
-  0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03,
-  0x00, 0x04, 0x00, 0x05, 0x00, 0x06, 0x00, 0x07, 0x00, 0x08, 0x00, 0x09,
-  0x00, 0x0a, 0x00, 0x0b, 0x00, 0x0c, 0x00, 0x0d, 0x00, 0x0e, 0x00, 0x0f,
-  0x00, 0x10, 0x00, 0x11, 0x00, 0x12, 0x00, 0x13, 0x00, 0x14, 0x00, 0x15,
-  0x00, 0x16, 0x00, 0x17, 0x00, 0x18, 0x00, 0x19, 0x00, 0x1a, 0x00, 0x1b,
-  0x00, 0x1c, 0x00, 0x1d, 0x00, 0x1e, 0x00, 0x1f, 0x00, 0x20, 0x00, 0x21,
-  0x00, 0x22, 0x00, 0x23, 0x00, 0x24, 0x00, 0x25, 0x00, 0x26, 0x00, 0x27,
-  0x00, 0x28, 0x00, 0x29, 0x00, 0x2a, 0x00, 0x2b, 0x00, 0x2c, 0x00, 0x2d,
-  0x00, 0x2e, 0x00, 0x2f, 0x00, 0x30, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33,
-  0x00, 0x34, 0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39,
-  0x00, 0x3a, 0x00, 0x3b, 0x00, 0x3c, 0x00, 0x3d, 0x00, 0x3e, 0x00, 0x3f,
-  0x00, 0x40, 0x00, 0x41, 0x00, 0x42, 0x00, 0x43, 0x00, 0x44, 0x00, 0x45,
-  0x00, 0x46, 0x00, 0x47, 0x00, 0x48, 0x00, 0x49, 0x00, 0x4a, 0x00, 0x4b,
-  0x00, 0x4c, 0x00, 0x4d, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x50, 0x00, 0x51,
-  0x00, 0x52, 0x00, 0x53, 0x00, 0x54, 0x00, 0x55, 0x00, 0x56, 0x00, 0x57,
-  0x00, 0x58, 0x00, 0x59, 0x00, 0x5a, 0x00, 0x5b, 0x00, 0x5c, 0x00, 0x5d,
-  0x00, 0x5e, 0x00, 0x5f, 0x00, 0x60, 0x00, 0x61, 0x00, 0x00, 0x00, 0x86,
-  0x00, 0x87, 0x00, 0x89, 0x00, 0x8b, 0x00, 0x93, 0x00, 0x98, 0x00, 0x9e,
-  0x00, 0xa3, 0x00, 0xa2, 0x00, 0xa4, 0x00, 0xa6, 0x00, 0xa5, 0x00, 0xa7,
-  0x00, 0xa9, 0x00, 0xab, 0x00, 0xaa, 0x00, 0xac, 0x00, 0xad, 0x00, 0xaf,
-  0x00, 0xae, 0x00, 0xb0, 0x00, 0xb1, 0x00, 0xb3, 0x00, 0xb5, 0x00, 0xb4,
-  0x00, 0xb6, 0x00, 0xb8, 0x00, 0xb7, 0x00, 0xbc, 0x00, 0xbb, 0x00, 0xbd,
-  0x00, 0xbe, 0x07, 0x55, 0x00, 0x72, 0x00, 0x64, 0x00, 0x65, 0x00, 0x69,
-  0x07, 0x57, 0x00, 0x78, 0x00, 0xa1, 0x00, 0x70, 0x00, 0x6b, 0x08, 0x0b,
-  0x00, 0x76, 0x00, 0x6a, 0x09, 0x3c, 0x00, 0x88, 0x00, 0x9a, 0x08, 0xfa,
-  0x00, 0x73, 0x09, 0x40, 0x09, 0x41, 0x00, 0x67, 0x00, 0x77, 0x08, 0xde,
-  0x08, 0xed, 0x08, 0xeb, 0x03, 0x54, 0x09, 0x07, 0x00, 0x6c, 0x00, 0x7c,
-  0x03, 0x3d, 0x00, 0xa8, 0x00, 0xba, 0x00, 0x81, 0x00, 0x63, 0x00, 0x6e,
-  0x08, 0xf6, 0x01, 0x54, 0x09, 0x24, 0x08, 0xe2, 0x00, 0x6d, 0x00, 0x7d,
-  0x07, 0x5b, 0x00, 0x62, 0x00, 0x82, 0x00, 0x85, 0x00, 0x97, 0x01, 0x14,
-  0x01, 0x15, 0x07, 0x48, 0x07, 0x49, 0x07, 0x51, 0x07, 0x52, 0x07, 0x4d,
-  0x07, 0x4e, 0x00, 0xb9, 0x0a, 0xf3, 0x00, 0xc1, 0x01, 0x3a, 0x07, 0x79,
-  0x07, 0xd6, 0x07, 0x6e, 0x07, 0x6f, 0x0f, 0x0a, 0x0f, 0x0b, 0x07, 0x56,
-  0x00, 0x79, 0x07, 0x4f, 0x07, 0x53, 0x07, 0x65, 0x00, 0x84, 0x00, 0x8c,
-  0x00, 0x83, 0x00, 0x8d, 0x00, 0x8a, 0x00, 0x8f, 0x00, 0x90, 0x00, 0x91,
-  0x00, 0x8e, 0x00, 0x95, 0x00, 0x96, 0x00, 0x00, 0x00, 0x94, 0x00, 0x9c,
-  0x00, 0x9d, 0x00, 0x9b, 0x00, 0xf3, 0x02, 0x88, 0x02, 0x9e, 0x00, 0x71,
-  0x02, 0x9a, 0x02, 0x9b, 0x02, 0x9c, 0x00, 0x7a, 0x02, 0x9f, 0x02, 0x9d,
-  0x02, 0x89, 0x00, 0x00, 0x01, 0x35, 0x00, 0xb8, 0x00, 0xcb, 0x00, 0xcb,
-  0x00, 0xc1, 0x00, 0xaa, 0x00, 0x9c, 0x01, 0xa6, 0x00, 0xb8, 0x00, 0x66,
-  0x00, 0x00, 0x00, 0x71, 0x00, 0xcb, 0x00, 0xa0, 0x02, 0xb2, 0x00, 0x85,
-  0x00, 0x75, 0x00, 0xb8, 0x00, 0xc3, 0x01, 0xcb, 0x01, 0x89, 0x02, 0x2d,
-  0x00, 0xcb, 0x00, 0xa6, 0x00, 0xf0, 0x00, 0xd3, 0x00, 0xaa, 0x00, 0x87,
-  0x00, 0xcb, 0x03, 0xaa, 0x04, 0x00, 0x01, 0x4a, 0x00, 0x33, 0x00, 0xcb,
-  0x00, 0x00, 0x00, 0xd9, 0x05, 0x02, 0x00, 0xf4, 0x01, 0x54, 0x00, 0xb4,
-  0x00, 0x9c, 0x01, 0x39, 0x01, 0x14, 0x01, 0x39, 0x07, 0x06, 0x04, 0x00,
-  0x04, 0x4e, 0x04, 0xb4, 0x04, 0x52, 0x04, 0xb8, 0x04, 0xe7, 0x04, 0xcd,
-  0x00, 0x37, 0x04, 0x73, 0x04, 0xcd, 0x04, 0x60, 0x04, 0x73, 0x01, 0x33,
-  0x03, 0xa2, 0x05, 0x56, 0x05, 0xa6, 0x05, 0x56, 0x05, 0x39, 0x03, 0xc5,
-  0x02, 0x12, 0x00, 0xc9, 0x00, 0x1f, 0x00, 0xb8, 0x01, 0xdf, 0x00, 0x73,
-  0x00, 0xba, 0x03, 0xe9, 0x03, 0x33, 0x03, 0xbc, 0x04, 0x44, 0x04, 0x0e,
-  0x00, 0xdf, 0x03, 0xcd, 0x03, 0xaa, 0x00, 0xe5, 0x03, 0xaa, 0x04, 0x04,
-  0x00, 0x00, 0x00, 0xcb, 0x00, 0x8f, 0x00, 0xa4, 0x00, 0x7b, 0x00, 0xb8,
-  0x00, 0x14, 0x01, 0x6f, 0x00, 0x7f, 0x02, 0x7b, 0x02, 0x52, 0x00, 0x8f,
-  0x00, 0xc7, 0x05, 0xcd, 0x00, 0x9a, 0x00, 0x9a, 0x00, 0x6f, 0x00, 0xcb,
-  0x00, 0xcd, 0x01, 0x9e, 0x01, 0xd3, 0x00, 0xf0, 0x00, 0xba, 0x01, 0x83,
-  0x00, 0xd5, 0x00, 0x98, 0x03, 0x04, 0x02, 0x48, 0x00, 0x9e, 0x01, 0xd5,
-  0x00, 0xc1, 0x00, 0xcb, 0x00, 0xf6, 0x00, 0x83, 0x03, 0x54, 0x02, 0x7f,
-  0x00, 0x00, 0x03, 0x33, 0x02, 0x66, 0x00, 0xd3, 0x00, 0xc7, 0x00, 0xa4,
-  0x00, 0xcd, 0x00, 0x8f, 0x00, 0x9a, 0x00, 0x73, 0x04, 0x00, 0x05, 0xd5,
-  0x01, 0x0a, 0x00, 0xfe, 0x02, 0x2b, 0x00, 0xa4, 0x00, 0xb4, 0x00, 0x9c,
-  0x00, 0x00, 0x00, 0x62, 0x00, 0x9c, 0x00, 0x00, 0x00, 0x1d, 0x03, 0x2d,
-  0x05, 0xd5, 0x05, 0xd5, 0x05, 0xd5, 0x05, 0xf0, 0x00, 0x7f, 0x00, 0x7b,
-  0x00, 0x54, 0x00, 0xa4, 0x06, 0xb8, 0x06, 0x14, 0x07, 0x23, 0x01, 0xd3,
-  0x00, 0xb8, 0x00, 0xcb, 0x00, 0xa6, 0x01, 0xc3, 0x01, 0xec, 0x06, 0x93,
-  0x00, 0xa0, 0x00, 0xd3, 0x03, 0x5c, 0x03, 0x71, 0x03, 0xdb, 0x01, 0x85,
-  0x04, 0x23, 0x04, 0xa8, 0x04, 0x48, 0x00, 0x8f, 0x01, 0x39, 0x01, 0x14,
-  0x01, 0x39, 0x03, 0x60, 0x00, 0x8f, 0x05, 0xd5, 0x01, 0x9a, 0x06, 0x14,
-  0x07, 0x23, 0x06, 0x66, 0x01, 0x79, 0x04, 0x60, 0x04, 0x60, 0x04, 0x60,
-  0x04, 0x7b, 0x00, 0x9c, 0x00, 0x00, 0x02, 0x77, 0x04, 0x60, 0x01, 0xaa,
-  0x00, 0xe9, 0x04, 0x60, 0x07, 0x62, 0x00, 0x7b, 0x00, 0xc5, 0x00, 0x7f,
-  0x02, 0x7b, 0x00, 0x00, 0x00, 0xb4, 0x02, 0x52, 0x05, 0xcd, 0x00, 0x66,
-  0x00, 0xbc, 0x00, 0x66, 0x00, 0x77, 0x06, 0x10, 0x00, 0xcd, 0x01, 0x3b,
-  0x01, 0x85, 0x03, 0x89, 0x00, 0x8f, 0x00, 0x7b, 0x00, 0x00, 0x00, 0x1d,
-  0x00, 0xcd, 0x07, 0x4a, 0x04, 0x2f, 0x00, 0x9c, 0x00, 0x9c, 0x00, 0x00,
-  0x07, 0x7d, 0x00, 0x6f, 0x00, 0x00, 0x00, 0x6f, 0x03, 0x35, 0x00, 0x6a,
-  0x00, 0x6f, 0x00, 0x7b, 0x00, 0xae, 0x00, 0xb2, 0x00, 0x2d, 0x03, 0x96,
-  0x00, 0x8f, 0x02, 0x7b, 0x00, 0xf6, 0x00, 0x83, 0x03, 0x54, 0x06, 0x37,
-  0x05, 0xf6, 0x00, 0x8f, 0x00, 0x9c, 0x04, 0xe1, 0x02, 0x66, 0x00, 0x8f,
-  0x01, 0x8d, 0x02, 0xf6, 0x00, 0xcd, 0x03, 0x44, 0x00, 0x29, 0x00, 0x66,
-  0x04, 0xee, 0x00, 0x73, 0x00, 0x00, 0x14, 0x00, 0x00, 0x96, 0x00, 0x00,
-  0xb7, 0x07, 0x06, 0x05, 0x04, 0x03, 0x02, 0x01, 0x00, 0x2c, 0x20, 0x10,
-  0xb0, 0x02, 0x25, 0x49, 0x64, 0xb0, 0x40, 0x51, 0x58, 0x20, 0xc8, 0x59,
-  0x21, 0x2d, 0x2c, 0xb0, 0x02, 0x25, 0x49, 0x64, 0xb0, 0x40, 0x51, 0x58,
-  0x20, 0xc8, 0x59, 0x21, 0x2d, 0x2c, 0x20, 0x10, 0x07, 0x20, 0xb0, 0x00,
-  0x50, 0xb0, 0x0d, 0x79, 0x20, 0xb8, 0xff, 0xff, 0x50, 0x58, 0x04, 0x1b,
-  0x05, 0x59, 0xb0, 0x05, 0x1c, 0xb0, 0x03, 0x25, 0x08, 0xb0, 0x04, 0x25,
-  0x23, 0xe1, 0x20, 0xb0, 0x00, 0x50, 0xb0, 0x0d, 0x79, 0x20, 0xb8, 0xff,
-  0xff, 0x50, 0x58, 0x04, 0x1b, 0x05, 0x59, 0xb0, 0x05, 0x1c, 0xb0, 0x03,
-  0x25, 0x08, 0xe1, 0x2d, 0x2c, 0x4b, 0x50, 0x58, 0x20, 0xb0, 0xfd, 0x45,
-  0x44, 0x59, 0x21, 0x2d, 0x2c, 0xb0, 0x02, 0x25, 0x45, 0x60, 0x44, 0x2d,
-  0x2c, 0x4b, 0x53, 0x58, 0xb0, 0x02, 0x25, 0xb0, 0x02, 0x25, 0x45, 0x44,
-  0x59, 0x21, 0x21, 0x2d, 0x2c, 0x45, 0x44, 0x2d, 0x2c, 0xb0, 0x02, 0x25,
-  0xb0, 0x02, 0x25, 0x49, 0xb0, 0x05, 0x25, 0xb0, 0x05, 0x25, 0x49, 0x60,
-  0xb0, 0x20, 0x63, 0x68, 0x20, 0x8a, 0x10, 0x8a, 0x23, 0x3a, 0x8a, 0x10,
-  0x65, 0x3a, 0x2d, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x08, 0x00, 0x02,
-  0xff, 0xff, 0x00, 0x03, 0x00, 0x02, 0x00, 0x5b, 0xfe, 0x96, 0x03, 0xf6,
-  0x05, 0xa4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x13, 0x11, 0x21, 0x11,
-  0x25, 0x21, 0x11, 0x21, 0x5c, 0x03, 0x99, 0xfc, 0xce, 0x02, 0xcc, 0xfd,
-  0x34, 0xfe, 0x96, 0x07, 0x0e, 0xf8, 0xf2, 0x72, 0x06, 0x29, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x16, 0x00, 0x00, 0x01, 0xcd, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x09, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23, 0x11, 0x33, 0x11, 0x03,
-  0x23, 0x03, 0x01, 0x16, 0xb7, 0xb7, 0xb7, 0x12, 0x92, 0x13, 0xfe, 0xfe,
-  0x05, 0xd5, 0xfd, 0x71, 0xfe, 0x9b, 0x01, 0x65, 0x00, 0x02, 0x00, 0xb1,
-  0x03, 0xaa, 0x02, 0x9f, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x01, 0x4a, 0x99, 0x01,
-  0xed, 0x98, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0xd5, 0x02, 0x2b,
-  0x00, 0x02, 0x00, 0x8e, 0x00, 0x00, 0x05, 0x7c, 0x05, 0xbe, 0x00, 0x03,
-  0x00, 0x1f, 0x00, 0x00, 0x01, 0x21, 0x03, 0x21, 0x0b, 0x01, 0x21, 0x13,
-  0x33, 0x03, 0x21, 0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x03, 0x23, 0x13,
-  0x21, 0x03, 0x23, 0x13, 0x21, 0x35, 0x21, 0x13, 0x21, 0x35, 0x21, 0x13,
-  0x03, 0xae, 0xfe, 0xfa, 0x4b, 0x01, 0x07, 0x3d, 0x5d, 0x01, 0x06, 0x5f,
-  0x90, 0x5d, 0x01, 0x19, 0xfe, 0xc4, 0x4a, 0x01, 0x1f, 0xfe, 0xbe, 0x5d,
-  0x90, 0x5c, 0xfe, 0xf9, 0x5d, 0x91, 0x5e, 0xfe, 0xe4, 0x01, 0x3d, 0x4c,
-  0xfe, 0xde, 0x01, 0x45, 0x5c, 0x03, 0x85, 0xfe, 0xb2, 0x03, 0x87, 0xfe,
-  0x61, 0x01, 0x9f, 0xfe, 0x61, 0x9a, 0xfe, 0xb2, 0x99, 0xfe, 0x62, 0x01,
-  0x9e, 0xfe, 0x62, 0x01, 0x9e, 0x99, 0x01, 0x4e, 0x9a, 0x01, 0x9f, 0x00,
-  0x00, 0x03, 0x00, 0x99, 0xfe, 0xd3, 0x03, 0xfc, 0x06, 0x14, 0x00, 0x21,
-  0x00, 0x28, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x23, 0x03, 0x2e, 0x01, 0x27,
-  0x35, 0x1e, 0x01, 0x17, 0x11, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x35,
-  0x33, 0x15, 0x1e, 0x01, 0x17, 0x15, 0x2e, 0x01, 0x27, 0x11, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x07, 0x03, 0x11, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17,
-  0x11, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x02, 0x6f, 0x5a, 0x01, 0x5f, 0xbd,
-  0x5f, 0x5c, 0xbc, 0x64, 0xc7, 0xb5, 0xc4, 0xb8, 0x5a, 0x53, 0x9d, 0x4b,
-  0x4b, 0x9d, 0x53, 0xcc, 0xc1, 0xcd, 0xc0, 0x5a, 0x69, 0x6d, 0x65, 0xcb,
-  0x72, 0x74, 0x6f, 0xfe, 0xd3, 0x01, 0x2d, 0x02, 0x2d, 0x2d, 0xb4, 0x40,
-  0x41, 0x01, 0x01, 0xc8, 0x24, 0xac, 0x96, 0xa3, 0xbc, 0x0e, 0xeb, 0xe8,
-  0x04, 0x1f, 0x1b, 0xaf, 0x2a, 0x2e, 0x04, 0xfe, 0x55, 0x23, 0xb4, 0x9c,
-  0xa9, 0xc3, 0x0f, 0x03, 0x00, 0x01, 0x9a, 0x0d, 0x6a, 0x58, 0x56, 0x60,
-  0xd5, 0xfe, 0x4f, 0x11, 0x6e, 0x5a, 0x58, 0x68, 0x00, 0x05, 0x00, 0x65,
-  0xff, 0xe3, 0x06, 0x72, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
-  0x00, 0x27, 0x00, 0x33, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x25, 0x33, 0x01, 0x23, 0x13, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x05, 0x3c,
-  0x4e, 0x59, 0x59, 0x4e, 0x4d, 0x59, 0x59, 0x4d, 0x8e, 0xa8, 0xa9, 0x8d,
-  0x90, 0xa7, 0xa8, 0xfc, 0xee, 0x4d, 0x59, 0x58, 0x4e, 0x4f, 0x59, 0x5a,
-  0x02, 0xdf, 0x90, 0xfc, 0xb7, 0x90, 0x1c, 0x8f, 0xa9, 0xa9, 0x8f, 0x8f,
-  0xa6, 0xa7, 0x02, 0x91, 0x94, 0x84, 0x82, 0x95, 0x95, 0x82, 0x83, 0x95,
-  0x7f, 0xdc, 0xbb, 0xbb, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x02, 0x61, 0x95,
-  0x82, 0x84, 0x94, 0x94, 0x84, 0x81, 0x96, 0x7f, 0xf9, 0xf3, 0x06, 0x0d,
-  0xdb, 0xbb, 0xbd, 0xda, 0xdb, 0xbc, 0xba, 0xdc, 0x00, 0x02, 0x00, 0x74,
-  0xff, 0xe3, 0x05, 0x65, 0x05, 0xf0, 0x00, 0x09, 0x00, 0x30, 0x00, 0x00,
-  0x01, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x09, 0x01,
-  0x3e, 0x01, 0x37, 0x33, 0x06, 0x02, 0x07, 0x13, 0x23, 0x27, 0x0e, 0x01,
-  0x23, 0x22, 0x00, 0x35, 0x34, 0x36, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x36,
-  0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x16, 0x01, 0xc0, 0x52, 0x4c, 0xbf, 0x90, 0x55, 0x96, 0x41, 0xfe, 0xa2,
-  0x01, 0xc9, 0x35, 0x3c, 0x05, 0xa8, 0x0b, 0x5e, 0x53, 0xfb, 0xe3, 0x81,
-  0x5d, 0xce, 0x76, 0xd8, 0xfe, 0xec, 0x79, 0x78, 0x2b, 0x2d, 0xc8, 0xa5,
-  0x4b, 0x95, 0x4c, 0x4e, 0x8e, 0x3e, 0x5e, 0x76, 0x35, 0x03, 0x23, 0x51,
-  0xa1, 0x58, 0x92, 0xc2, 0x3f, 0x40, 0x02, 0x8f, 0xfd, 0xf8, 0x59, 0xcb,
-  0x72, 0x84, 0xfe, 0xfe, 0x7e, 0xfe, 0xe3, 0x93, 0x59, 0x57, 0x01, 0x13,
-  0xd7, 0x80, 0xe1, 0x63, 0x3f, 0x7d, 0x3c, 0xa2, 0xc5, 0x24, 0x24, 0xb6,
-  0x2f, 0x31, 0x6f, 0x58, 0x33, 0x67, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb1,
-  0x03, 0xaa, 0x01, 0x4b, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x01, 0x4a, 0x99, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0x00,
-  0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x3c, 0x06, 0x12, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x23, 0x26, 0x02,
-  0x35, 0x34, 0x12, 0x37, 0x02, 0x3c, 0x79, 0x75, 0x76, 0x78, 0x90, 0x88,
-  0x86, 0x86, 0x88, 0x06, 0x12, 0xe6, 0xfe, 0x3e, 0xe7, 0xe7, 0xfe, 0x3b,
-  0xe5, 0xeb, 0x01, 0xc6, 0xe0, 0xdf, 0x01, 0xc4, 0xec, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x93, 0xfe, 0xf2, 0x02, 0x31, 0x06, 0x12, 0x00, 0x0d,
-  0x00, 0x00, 0x13, 0x33, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x23, 0x36,
-  0x12, 0x35, 0x34, 0x02, 0x94, 0x90, 0x87, 0x86, 0x86, 0x87, 0x90, 0x77,
-  0x76, 0x76, 0x06, 0x12, 0xec, 0xfe, 0x3c, 0xdf, 0xe0, 0xfe, 0x3a, 0xeb,
-  0xe5, 0x01, 0xc5, 0xe7, 0xe7, 0x01, 0xc2, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0x02, 0x4a, 0x03, 0x63, 0x05, 0xf0, 0x00, 0x11, 0x00, 0x00, 0x01, 0x0d,
-  0x01, 0x07, 0x25, 0x11, 0x23, 0x11, 0x05, 0x27, 0x2d, 0x01, 0x37, 0x05,
-  0x11, 0x33, 0x11, 0x25, 0x03, 0x63, 0xfe, 0xbd, 0x01, 0x43, 0x35, 0xfe,
-  0xd2, 0x66, 0xfe, 0xd1, 0x34, 0x01, 0x43, 0xfe, 0xbd, 0x34, 0x01, 0x2f,
-  0x66, 0x01, 0x2e, 0x04, 0xdf, 0xc2, 0xc3, 0x62, 0xcb, 0xfe, 0x87, 0x01,
-  0x79, 0xcb, 0x62, 0xc3, 0xc2, 0x63, 0xcb, 0x01, 0x79, 0xfe, 0x87, 0xcb,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x03, 0x50, 0x01, 0xf5, 0xfe, 0x0b, 0x97, 0xfe, 0x0a, 0x01,
-  0xf6, 0x05, 0x04, 0xfd, 0xd3, 0xaa, 0xfd, 0xd3, 0x02, 0x2d, 0xaa, 0x02,
-  0x2d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8e, 0xff, 0x12, 0x01, 0x96,
-  0x00, 0xfe, 0x00, 0x05, 0x00, 0x00, 0x37, 0x33, 0x15, 0x03, 0x23, 0x13,
-  0xd8, 0xbe, 0x94, 0x74, 0x4a, 0xfe, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40, 0x02, 0x83, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x01, 0xe5, 0xfe, 0x1b, 0x02,
-  0x83, 0xa4, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc5, 0x00, 0x00, 0x01, 0x83,
-  0x00, 0xfe, 0x00, 0x03, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23, 0xc5, 0xbe,
-  0xbe, 0xfe, 0xfe, 0x00, 0x00, 0x01, 0x00, 0x00, 0xff, 0x42, 0x02, 0x6d,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x01, 0xd4,
-  0x99, 0xfe, 0x2c, 0x99, 0x05, 0xd5, 0xf9, 0x6d, 0x00, 0x02, 0x00, 0x79,
-  0xff, 0xe3, 0x04, 0x1b, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02,
-  0x27, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
-  0x02, 0x4a, 0x8c, 0x8e, 0x8e, 0x8c, 0x8d, 0x8d, 0x8d, 0x8d, 0xe2, 0xee,
-  0xee, 0xe2, 0xe2, 0xee, 0xee, 0x05, 0x50, 0xfe, 0xcd, 0xfe, 0xcc, 0xfe,
-  0xcd, 0xfe, 0xcd, 0x01, 0x33, 0x01, 0x33, 0x01, 0x34, 0x01, 0x33, 0xa0,
-  0xfe, 0x73, 0xfe, 0x86, 0xfe, 0x87, 0xfe, 0x73, 0x01, 0x8d, 0x01, 0x79,
-  0x01, 0x7a, 0x01, 0x8d, 0x00, 0x01, 0x00, 0xca, 0x00, 0x00, 0x03, 0xeb,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x00, 0x37, 0x21, 0x11, 0x05, 0x35, 0x25,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0xe5, 0x01, 0x29, 0xfe, 0xbc, 0x01, 0x42,
-  0xb6, 0x01, 0x29, 0xfc, 0xfa, 0xaa, 0x04, 0x73, 0x48, 0xb8, 0x48, 0xfa,
-  0xd5, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0xdd,
-  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x00, 0x25, 0x21, 0x15, 0x21, 0x35, 0x36,
-  0x00, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
-  0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x02, 0x01,
-  0x62, 0x02, 0x7a, 0xfc, 0xab, 0x67, 0x01, 0x66, 0x2e, 0x57, 0x45, 0x96,
-  0x79, 0x55, 0xbe, 0x6c, 0x6e, 0xbf, 0x4f, 0xd1, 0xf8, 0x3e, 0x52, 0x17,
-  0xf1, 0xaa, 0xaa, 0xaa, 0x77, 0x01, 0x91, 0x3a, 0x6d, 0x97, 0x49, 0x77,
-  0x96, 0x42, 0x43, 0xcc, 0x31, 0x32, 0xe8, 0xc2, 0x5c, 0xa5, 0x70, 0x1d,
-  0xfe, 0xeb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8c, 0xff, 0xe3, 0x04, 0x02,
-  0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x04,
-  0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x02,
-  0xec, 0x82, 0x93, 0xfe, 0xef, 0xfc, 0x55, 0xb3, 0x60, 0x4c, 0xb4, 0x62,
-  0xab, 0xb3, 0xa6, 0x95, 0x9c, 0xa3, 0x86, 0x8f, 0x93, 0x89, 0x4b, 0xaa,
-  0x67, 0x67, 0xb5, 0x50, 0xcf, 0xf2, 0x80, 0x03, 0x25, 0x1f, 0xc4, 0x90,
-  0xdd, 0xf2, 0x25, 0x25, 0xc3, 0x31, 0x32, 0x96, 0x8f, 0x84, 0x95, 0xa6,
-  0x77, 0x70, 0x73, 0x7b, 0x24, 0x26, 0xb4, 0x20, 0x20, 0xd1, 0xb2, 0x7c,
-  0xab, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x04, 0x2e,
-  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x21, 0x03,
-  0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x21, 0x35, 0x02, 0xb9,
-  0xfe, 0x35, 0x01, 0xcb, 0x30, 0xe5, 0xbf, 0xbf, 0xb5, 0xfd, 0xa1, 0x05,
-  0x25, 0xfc, 0xe3, 0x03, 0xcd, 0xfc, 0x33, 0xa8, 0xfe, 0xa0, 0x01, 0x60,
-  0xc3, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8e, 0xff, 0xe3, 0x03, 0xf4,
-  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x3e,
-  0x01, 0x33, 0x32, 0x00, 0x15, 0x14, 0x00, 0x23, 0x22, 0x26, 0x27, 0x35,
-  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0xc7, 0x02, 0xca, 0xfd, 0xdc, 0x28, 0x4f, 0x28, 0xe1, 0x01, 0x07, 0xfe,
-  0xf2, 0xf6, 0x55, 0xaf, 0x5e, 0x51, 0xad, 0x60, 0x9c, 0xb6, 0xb6, 0x9c,
-  0x49, 0x91, 0x4b, 0x05, 0xd5, 0xaa, 0xfe, 0x92, 0x0f, 0x0f, 0xfe, 0xee,
-  0xea, 0xf1, 0xfe, 0xf5, 0x20, 0x20, 0xcb, 0x31, 0x30, 0xb6, 0x9c, 0x9c,
-  0xb6, 0x24, 0x26, 0x00, 0x00, 0x02, 0x00, 0x80, 0xff, 0xe3, 0x04, 0x21,
-  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01,
-  0x23, 0x22, 0x02, 0x03, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x15, 0x14, 0x02,
-  0x23, 0x22, 0x02, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x02, 0x60, 0x7a,
-  0x8f, 0x8f, 0x7a, 0x7b, 0x8f, 0x8f, 0xee, 0x44, 0x8c, 0x44, 0xb4, 0xbe,
-  0x0d, 0x35, 0xa0, 0x60, 0xcb, 0xeb, 0xf5, 0xcc, 0xe9, 0xf6, 0x01, 0x2e,
-  0x00, 0xff, 0x44, 0x8c, 0x03, 0x3b, 0xba, 0xa2, 0xa1, 0xbb, 0xbb, 0xa1,
-  0xa2, 0xba, 0x02, 0x79, 0xb8, 0x24, 0x26, 0xfe, 0xf2, 0xfe, 0xef, 0x57,
-  0x5d, 0xfe, 0xef, 0xeb, 0xe6, 0xfe, 0xea, 0x01, 0x8d, 0x01, 0x79, 0x01,
-  0x62, 0x01, 0xa5, 0x1e, 0x00, 0x01, 0x00, 0x97, 0x00, 0x00, 0x03, 0xf8,
-  0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x23, 0x01,
-  0x21, 0x97, 0x03, 0x60, 0xfe, 0x18, 0xbd, 0x01, 0xca, 0xfd, 0x7b, 0x05,
-  0xd5, 0x56, 0xfa, 0x81, 0x05, 0x2b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x7d,
-  0xff, 0xe3, 0x04, 0x17, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x23, 0x00, 0x2f,
-  0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x25, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x13, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x02, 0x4a, 0x82, 0x94, 0x94, 0x82, 0x82, 0x95, 0x95, 0xfe,
-  0xc8, 0x75, 0x82, 0xe5, 0xc8, 0xc9, 0xe4, 0x82, 0x74, 0x83, 0x93, 0xef,
-  0xde, 0xde, 0xef, 0x94, 0x41, 0x82, 0x76, 0x75, 0x84, 0x84, 0x75, 0x76,
-  0x82, 0x02, 0xc5, 0x9a, 0x87, 0x87, 0x9a, 0x9b, 0x86, 0x87, 0x9a, 0x56,
-  0x20, 0xb2, 0x80, 0xb3, 0xd0, 0xd0, 0xb3, 0x80, 0xb2, 0x20, 0x22, 0xc6,
-  0x8f, 0xd9, 0xe8, 0xe8, 0xd9, 0x8f, 0xc6, 0x01, 0x61, 0x74, 0x82, 0x82,
-  0x74, 0x74, 0x82, 0x82, 0x00, 0x02, 0x00, 0x74, 0xff, 0xe3, 0x04, 0x14,
-  0x05, 0xf0, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00, 0x37, 0x35, 0x1e, 0x01,
-  0x33, 0x32, 0x12, 0x13, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x35, 0x34, 0x12,
-  0x33, 0x32, 0x12, 0x11, 0x10, 0x00, 0x23, 0x22, 0x26, 0x01, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0xca, 0x45, 0x8c,
-  0x44, 0xb4, 0xbe, 0x0d, 0x34, 0xa0, 0x61, 0xca, 0xeb, 0xf5, 0xcb, 0xe9,
-  0xf6, 0xfe, 0xd3, 0xff, 0x45, 0x8c, 0x01, 0x1e, 0x7b, 0x8f, 0x8f, 0x7b,
-  0x7a, 0x8f, 0x8f, 0x1f, 0xb8, 0x24, 0x26, 0x01, 0x0d, 0x01, 0x12, 0x56,
-  0x5c, 0x01, 0x0f, 0xeb, 0xe6, 0x01, 0x16, 0xfe, 0x73, 0xfe, 0x86, 0xfe,
-  0x9f, 0xfe, 0x5b, 0x1e, 0x02, 0x97, 0xba, 0xa2, 0xa1, 0xbb, 0xbb, 0xa1,
-  0xa2, 0xba, 0x00, 0x00, 0x00, 0x02, 0x00, 0xd8, 0x00, 0x00, 0x01, 0x96,
-  0x04, 0x23, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23,
-  0x11, 0x33, 0x15, 0x23, 0xd8, 0xbe, 0xbe, 0xbe, 0xbe, 0xfe, 0xfe, 0x04,
-  0x23, 0xfe, 0x00, 0x00, 0x00, 0x02, 0x00, 0x8e, 0xff, 0x12, 0x01, 0x96,
-  0x04, 0x23, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23,
-  0x11, 0x33, 0x15, 0x03, 0x23, 0x13, 0xd8, 0xbe, 0xbe, 0xbe, 0x94, 0x74,
-  0x4a, 0x04, 0x23, 0xfe, 0xfd, 0xd9, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x5e, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x06,
-  0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45, 0xfc, 0x5f,
-  0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82, 0x03, 0xf0, 0xfe, 0x91, 0xfe, 0x93,
-  0xb6, 0x01, 0xd1, 0xa6, 0x01, 0xd1, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x01, 0x60, 0x05, 0x46, 0x03, 0xa2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfb,
-  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x5e, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x06,
-  0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0xc3, 0x04, 0x82,
-  0xfb, 0x7e, 0x03, 0x9f, 0x03, 0xf0, 0xb6, 0xfe, 0x2f, 0xa6, 0xfe, 0x2f,
-  0xb6, 0x01, 0x6d, 0x00, 0x00, 0x02, 0x00, 0x84, 0x00, 0x00, 0x03, 0x52,
-  0x05, 0xf0, 0x00, 0x03, 0x00, 0x24, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23,
-  0x13, 0x23, 0x35, 0x34, 0x36, 0x3f, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x0f, 0x01, 0x0e, 0x01, 0x07, 0x0e, 0x01, 0x15, 0x01, 0x60, 0xb7,
-  0xb7, 0xb1, 0xac, 0x33, 0x51, 0x51, 0x33, 0x2e, 0x76, 0x61, 0x47, 0xa1,
-  0x58, 0x55, 0xae, 0x5c, 0xa6, 0xc9, 0x41, 0x51, 0x4f, 0x2b, 0x23, 0x07,
-  0x05, 0x06, 0xfe, 0xfe, 0x01, 0x91, 0x9a, 0x65, 0x82, 0x56, 0x59, 0x35,
-  0x5e, 0x31, 0x59, 0x6e, 0x46, 0x43, 0xbc, 0x39, 0x38, 0xc2, 0x9f, 0x4c,
-  0x89, 0x56, 0x56, 0x2f, 0x35, 0x19, 0x15, 0x3c, 0x34, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x79, 0xfe, 0x9c, 0x06, 0xb3, 0x05, 0xa2, 0x00, 0x0b,
-  0x00, 0x4c, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x27, 0x26, 0x24, 0x23, 0x22, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14,
-  0x12, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x17, 0x06, 0x04, 0x23,
-  0x22, 0x24, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x24, 0x33,
-  0x32, 0x04, 0x17, 0x1e, 0x01, 0x15, 0x10, 0x00, 0x07, 0x02, 0xae, 0x80,
-  0x6f, 0x6f, 0x7f, 0x82, 0x6e, 0x6d, 0x80, 0x01, 0xea, 0x36, 0x8b, 0x5d,
-  0x9b, 0xc1, 0xc2, 0x9a, 0x5d, 0x8c, 0x35, 0x81, 0x83, 0x95, 0x39, 0x39,
-  0x5e, 0xfe, 0xf3, 0x9e, 0x6f, 0xcc, 0x56, 0x8d, 0xa0, 0x68, 0x62, 0x5e,
-  0xf9, 0x8d, 0x74, 0xe0, 0x5e, 0x51, 0x71, 0xfe, 0xf7, 0x89, 0xa6, 0xfe,
-  0xd8, 0x73, 0x73, 0x78, 0x7a, 0x71, 0x74, 0x01, 0x31, 0xaa, 0xbe, 0x01,
-  0x47, 0x6f, 0x43, 0x47, 0xfe, 0xe2, 0xfc, 0x02, 0x19, 0x8f, 0xa3, 0xa4,
-  0x8e, 0x8c, 0xa5, 0xa4, 0xfe, 0x48, 0x4d, 0x49, 0xf9, 0xc8, 0xc8, 0xfa,
-  0x4b, 0x4c, 0x83, 0xfd, 0x20, 0x16, 0xdf, 0xb1, 0x6b, 0xbc, 0x50, 0x83,
-  0x8b, 0x41, 0x40, 0x66, 0xfe, 0xb5, 0xc1, 0x9f, 0xfe, 0xea, 0x6a, 0x68,
-  0x6d, 0x57, 0x51, 0x6f, 0x61, 0x67, 0x83, 0x7d, 0x7d, 0x01, 0x49, 0xbd,
-  0xb6, 0x01, 0x4a, 0x7d, 0x7f, 0x87, 0xae, 0xa0, 0x62, 0xe6, 0x7b, 0xfe,
-  0xf9, 0xfe, 0xd0, 0x06, 0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00, 0x01, 0x03, 0x21, 0x01,
-  0x33, 0x01, 0x23, 0x03, 0x21, 0x03, 0x23, 0x02, 0x76, 0xf7, 0x01, 0xef,
-  0xfe, 0xa1, 0xcf, 0x02, 0x00, 0xbd, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0, 0x05,
-  0x0e, 0xfd, 0x19, 0x03, 0xae, 0xfa, 0x2b, 0x01, 0x7f, 0xfe, 0x81, 0x00,
-  0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x11, 0x00, 0x20, 0x00, 0x00, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14,
-  0x06, 0x23, 0x21, 0x01, 0x6b, 0x01, 0x23, 0x93, 0x8d, 0x8d, 0x93, 0xfe,
-  0xdd, 0x01, 0x0d, 0x85, 0x83, 0x83, 0x85, 0xfe, 0x3d, 0x01, 0xd0, 0xd0,
-  0xe1, 0x73, 0x70, 0x87, 0x94, 0xf5, 0xe2, 0xfe, 0x1e, 0x02, 0xc9, 0xfd,
-  0xdd, 0x87, 0x8b, 0x8c, 0x85, 0x02, 0x66, 0xfe, 0x3e, 0x6f, 0x72, 0x71,
-  0x70, 0xa6, 0xc0, 0xb1, 0x89, 0xa2, 0x14, 0x20, 0xcb, 0x98, 0xc8, 0xda,
-  0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
-  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x32, 0x16, 0x04, 0xa3, 0x5c, 0xd0, 0x75, 0xe6, 0xf5, 0xf5,
-  0xe6, 0x75, 0xd0, 0x5c, 0x5f, 0xd6, 0x76, 0xfe, 0xce, 0xfe, 0xa2, 0x01,
-  0x5e, 0x01, 0x32, 0x78, 0xd6, 0x05, 0x62, 0xd5, 0x5f, 0x5e, 0xfe, 0xc7,
-  0xfe, 0xd8, 0xfe, 0xd9, 0xfe, 0xc7, 0x5e, 0x5f, 0xd3, 0x48, 0x48, 0x01,
-  0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f, 0x47, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x11, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x25, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x01, 0x6b, 0xdb, 0x01, 0x16, 0x01,
-  0x03, 0xfe, 0xfd, 0xfe, 0xea, 0xfe, 0x6f, 0x01, 0x75, 0x01, 0x87, 0x01,
-  0x6d, 0xfe, 0x91, 0xfe, 0x7b, 0xfe, 0x8b, 0x05, 0x2f, 0xfb, 0x77, 0x01,
-  0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17, 0xa6, 0xfe, 0x97, 0xfe, 0x80,
-  0xfe, 0x7e, 0xfe, 0x96, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0xb5, 0x03, 0x51, 0xfd, 0x65, 0x02,
-  0x80, 0xfd, 0x80, 0x02, 0xac, 0xfc, 0x9e, 0x05, 0xd5, 0xaa, 0xfe, 0x46,
-  0xaa, 0xfd, 0xe3, 0xaa, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xba,
-  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x11, 0x23, 0xb5, 0x03, 0x04, 0xfd, 0xb2, 0x02, 0x15, 0xfd,
-  0xeb, 0xb6, 0x05, 0xd5, 0xaa, 0xfe, 0x48, 0xaa, 0xfd, 0x37, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe, 0x05, 0xf0, 0x00, 0x1d,
-  0x00, 0x00, 0x25, 0x11, 0x21, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23,
-  0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36, 0x04, 0x49, 0xfe, 0xd7,
-  0x01, 0xdd, 0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01,
-  0x3b, 0x83, 0xed, 0x64, 0x65, 0xe3, 0x7d, 0xf6, 0xf8, 0xf8, 0xf6, 0x61,
-  0x97, 0xd5, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53, 0x55, 0x01, 0x99, 0x01,
-  0x6d, 0x01, 0x6e, 0x01, 0x99, 0x48, 0x46, 0xd7, 0x5f, 0x60, 0xfe, 0xce,
-  0xfe, 0xd1, 0xfe, 0xd2, 0xfe, 0xce, 0x25, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6,
-  0x02, 0x94, 0xb6, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02,
-  0x64, 0xfa, 0x2b, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x01, 0x6b, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x23, 0xb5, 0xb6, 0xb6, 0x05, 0xd5, 0xfa, 0x2b, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xa0, 0xfe, 0x66, 0x01, 0x6b, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x36, 0x35, 0xb5, 0xb6, 0xb9, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x05, 0xd5,
-  0xfa, 0x93, 0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5, 0xb6, 0x02,
-  0x5b, 0xea, 0xfd, 0x65, 0x02, 0xca, 0xef, 0xfd, 0x7b, 0xb6, 0x05, 0xd5,
-  0xfd, 0x89, 0x02, 0x77, 0xfd, 0x48, 0xfc, 0xe3, 0x02, 0xcf, 0xfd, 0x31,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x21, 0xb5, 0xb6, 0x02, 0x8e,
-  0xfc, 0xbc, 0x05, 0xd5, 0xfa, 0xd5, 0xaa, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x21,
-  0x09, 0x01, 0x21, 0x11, 0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5,
-  0x01, 0x0f, 0x01, 0x57, 0x01, 0x58, 0x01, 0x0f, 0xb1, 0xfe, 0xa5, 0xb6,
-  0xfe, 0xa5, 0xb0, 0x05, 0xd5, 0xfc, 0x08, 0x03, 0xf8, 0xfa, 0x2b, 0x05,
-  0x1f, 0xfc, 0x00, 0x04, 0x00, 0xfa, 0xe1, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33,
-  0x01, 0x11, 0x33, 0x11, 0x23, 0x01, 0x11, 0x23, 0xb5, 0xf5, 0x02, 0x54,
-  0xb0, 0xf5, 0xfd, 0xac, 0xb0, 0x05, 0xd5, 0xfb, 0x1f, 0x04, 0xe1, 0xfa,
-  0x2b, 0x04, 0xe1, 0xfb, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02,
-  0x27, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x02, 0xd6, 0xc6, 0xe9, 0xe9, 0xc6, 0xc6, 0xe8, 0xe8, 0xc6, 0x01, 0x1b,
-  0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad, 0x01, 0x53,
-  0x05, 0x4c, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48,
-  0x01, 0x1a, 0x01, 0x1b, 0x01, 0x48, 0xa4, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe,
-  0x9f, 0xfe, 0x5b, 0x01, 0xa4, 0x01, 0x62, 0x01, 0x62, 0x01, 0xa5, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23,
-  0x01, 0x6b, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xfe, 0x66, 0x01, 0x9a, 0xe2,
-  0xe7, 0xe7, 0xe2, 0xe4, 0xb6, 0x05, 0x2f, 0xfd, 0xcf, 0x92, 0x87, 0x86,
-  0x92, 0xa6, 0xe3, 0xdb, 0xdd, 0xe2, 0xfd, 0xa8, 0x00, 0x02, 0x00, 0x67,
-  0xfe, 0xf8, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x1d, 0x00, 0x00,
-  0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02,
-  0x1b, 0x01, 0x23, 0x27, 0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x02, 0x02, 0xd6, 0xc6, 0xe9, 0xe9, 0xc6,
-  0xc6, 0xe8, 0xe8, 0x39, 0xef, 0xdb, 0xc7, 0x1e, 0x1f, 0x0f, 0xfe, 0xe5,
-  0xfe, 0xad, 0x01, 0x53, 0x01, 0x1b, 0x01, 0x1b, 0x01, 0x52, 0xbc, 0x05,
-  0x4c, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48, 0x01,
-  0x1a, 0x01, 0x1b, 0x01, 0x48, 0xfa, 0xcf, 0xfe, 0xdd, 0xef, 0x02, 0x02,
-  0x01, 0xa5, 0x01, 0x61, 0x01, 0x62, 0x01, 0xa5, 0xfe, 0x5b, 0xfe, 0x9e,
-  0xfe, 0xfc, 0xfe, 0x8e, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
-  0x05, 0xd5, 0x00, 0x13, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17,
-  0x13, 0x23, 0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4, 0xac, 0x42, 0x7d, 0x6c,
-  0xc6, 0xb6, 0x01, 0x9a, 0xe7, 0xe2, 0x75, 0xfd, 0xc8, 0xe4, 0x84, 0x86,
-  0x86, 0x84, 0x02, 0xbc, 0x16, 0x90, 0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96,
-  0x62, 0xfd, 0x89, 0x05, 0xd5, 0xd6, 0xd8, 0x8d, 0xba, 0x02, 0x4f, 0xfd,
-  0xee, 0x87, 0x83, 0x83, 0x85, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x79,
-  0xff, 0xe3, 0x04, 0x2c, 0x05, 0xf0, 0x00, 0x27, 0x00, 0x00, 0x01, 0x15,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01,
-  0x15, 0x14, 0x04, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x03, 0xda, 0x67, 0xb8, 0x55, 0x95, 0xa1, 0x6b, 0x96, 0x6d,
-  0xcc, 0xc1, 0xfe, 0xfb, 0xfd, 0x60, 0xd7, 0x73, 0x6f, 0xd4, 0x67, 0x9b,
-  0xaa, 0x7a, 0x8b, 0x6e, 0xcc, 0xb5, 0xfb, 0xdc, 0x5f, 0xc4, 0x05, 0xa4,
-  0xc5, 0x37, 0x36, 0x80, 0x76, 0x63, 0x65, 0x1f, 0x19, 0x2b, 0xd9, 0xb6,
-  0xd9, 0xe0, 0x30, 0x2f, 0xd0, 0x45, 0x46, 0x88, 0x7e, 0x6e, 0x7c, 0x1f,
-  0x18, 0x2d, 0xc0, 0xab, 0xc6, 0xe4, 0x26, 0x00, 0x00, 0x01, 0xff, 0xfa,
-  0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x00, 0x03, 0x21,
-  0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x05, 0x04, 0x70, 0xfe, 0x23, 0xb6,
-  0xfe, 0x23, 0x05, 0xd5, 0xaa, 0xfa, 0xd5, 0x05, 0x2b, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11,
-  0x33, 0x11, 0x10, 0x00, 0x23, 0x22, 0x00, 0x11, 0xa0, 0xb7, 0x9d, 0xaf,
-  0xaf, 0x9c, 0xb7, 0xfe, 0xfc, 0xfe, 0xff, 0xfe, 0xfc, 0x05, 0xd5, 0xfc,
-  0x75, 0xf0, 0xd3, 0xd3, 0xf0, 0x03, 0x8b, 0xfc, 0x5c, 0xfe, 0xdc, 0xfe,
-  0xd6, 0x01, 0x2a, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x21, 0x01,
-  0x33, 0x09, 0x01, 0x33, 0x01, 0x02, 0x0f, 0xfd, 0xff, 0xbe, 0x01, 0xaa,
-  0x01, 0xab, 0xbd, 0xfe, 0x00, 0x05, 0xd5, 0xfb, 0x17, 0x04, 0xe9, 0xfa,
-  0x2b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
-  0x05, 0xd5, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x09,
-  0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0x23, 0x3d, 0xb8, 0x01, 0x1a, 0x01,
-  0x1a, 0xcc, 0x01, 0x1b, 0x01, 0x1a, 0xb8, 0xfe, 0xaf, 0xe5, 0xfe, 0xe5,
-  0xfe, 0xe1, 0xe4, 0x05, 0xd5, 0xfb, 0x12, 0x04, 0xee, 0xfb, 0x12, 0x04,
-  0xee, 0xfa, 0x2b, 0x05, 0x10, 0xfa, 0xf0, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
-  0x09, 0x01, 0x33, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x01, 0x74, 0xc3,
-  0x01, 0x4e, 0x01, 0x50, 0xc3, 0xfe, 0x50, 0x01, 0xcd, 0xc3, 0xfe, 0x86,
-  0xfe, 0x83, 0xc4, 0x01, 0xe0, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0xfd,
-  0x33, 0xfc, 0xf8, 0x02, 0x7b, 0xfd, 0x85, 0x03, 0x1d, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x00, 0x03, 0x33, 0x09, 0x01, 0x33, 0x01, 0x11, 0x23, 0x11, 0x04,
-  0xc4, 0x01, 0x74, 0x01, 0x72, 0xc4, 0xfe, 0x24, 0xb6, 0x05, 0xd5, 0xfd,
-  0x9a, 0x02, 0x66, 0xfc, 0xf2, 0xfd, 0x39, 0x02, 0xc7, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x00, 0x09,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15, 0x21, 0x35, 0x01, 0x21,
-  0x68, 0x04, 0x1f, 0xfc, 0xaf, 0x03, 0x66, 0xfb, 0xb7, 0x03, 0x51, 0xfc,
-  0xc4, 0x05, 0xd5, 0x9a, 0xfb, 0x6f, 0xaa, 0x9a, 0x04, 0x91, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c, 0x06, 0x14, 0x00, 0x07,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x9e, 0x01,
-  0x7e, 0xd8, 0xd8, 0xfe, 0x82, 0x06, 0x14, 0x8f, 0xf9, 0xfc, 0x8f, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0xff, 0x42, 0x02, 0x6d, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x01, 0x23, 0x01, 0x99, 0x01, 0xd4, 0x99, 0xfe, 0x2c,
-  0x05, 0xd5, 0xf9, 0x6d, 0x06, 0x93, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb3,
-  0xfe, 0xf2, 0x02, 0x31, 0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x33, 0x11, 0x23, 0x35, 0x02, 0x31, 0xfe, 0x82, 0xd7, 0xd7,
-  0x06, 0x14, 0xf8, 0xde, 0x8f, 0x06, 0x04, 0x8f, 0x00, 0x01, 0x00, 0xc3,
-  0x03, 0xa8, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01,
-  0x23, 0x09, 0x01, 0x23, 0x01, 0x03, 0x5c, 0x01, 0xe9, 0xb5, 0xfe, 0x74,
-  0xfe, 0x74, 0xb5, 0x01, 0xe9, 0x05, 0xd5, 0xfd, 0xd3, 0x01, 0x8b, 0xfe,
-  0x75, 0x02, 0x2d, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x1d, 0x03, 0xac,
-  0xfe, 0xac, 0x00, 0x03, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35, 0x03, 0xac,
-  0xfc, 0x42, 0xfe, 0xac, 0x8f, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99,
-  0x04, 0xf0, 0x02, 0x49, 0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x13,
-  0x23, 0x01, 0x01, 0x4a, 0xfe, 0x8a, 0xfe, 0xdb, 0x06, 0x66, 0xfe, 0x8a,
-  0x01, 0x76, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x25, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x37, 0x11, 0x23, 0x35, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x78,
-  0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0xa6, 0xa6, 0x38, 0xa9, 0x7b, 0x9b,
-  0xb6, 0xe3, 0xe2, 0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51,
-  0xdb, 0xd8, 0x02, 0x33, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x4c,
-  0xfd, 0x81, 0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b,
-  0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x1c, 0x00, 0x00,
-  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26,
-  0x27, 0x15, 0x23, 0x11, 0x33, 0x03, 0x81, 0x96, 0x83, 0x84, 0x96, 0x96,
-  0x84, 0x83, 0x96, 0xfd, 0xcd, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8,
-  0x6f, 0x9f, 0x34, 0xa7, 0xa7, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
-  0xe7, 0xe7, 0x02, 0x52, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
-  0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x06, 0x14, 0x00, 0x00, 0x01, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x15,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37,
-  0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16,
-  0x03, 0x83, 0x46, 0x8d, 0x48, 0xa2, 0xb2, 0xb2, 0xa2, 0x48, 0x8d, 0x46,
-  0x45, 0x95, 0x53, 0xe4, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x4d, 0x92, 0x04,
-  0x35, 0xac, 0x2b, 0x2b, 0xe3, 0xcd, 0xcd, 0xe3, 0x2b, 0x2b, 0xaa, 0x24,
-  0x24, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x3a, 0x23, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xeb, 0x06, 0x14, 0x00, 0x10,
-  0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01,
-  0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0xa6,
-  0xa6, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0xfe, 0x00,
-  0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x03, 0xb6, 0x02, 0x5e,
-  0xf9, 0xec, 0xa8, 0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01,
-  0x44, 0x61, 0xfe, 0x15, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x00, 0x14,
-  0x00, 0x1b, 0x00, 0x00, 0x01, 0x15, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36,
-  0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32,
-  0x12, 0x07, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x04, 0x0c, 0xfd, 0x06,
-  0x0b, 0xb9, 0xa4, 0x60, 0xb3, 0x58, 0x59, 0xbb, 0x60, 0xf2, 0xfe, 0xe7,
-  0x01, 0x0b, 0xe3, 0xcb, 0xed, 0xa6, 0x02, 0x94, 0x7a, 0x8b, 0xa7, 0x0c,
-  0x02, 0x5e, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a, 0x2c, 0x01, 0x38,
-  0x01, 0x0a, 0x01, 0x13, 0x01, 0x43, 0xfe, 0xdd, 0xc4, 0x97, 0xb4, 0xae,
-  0x9e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac,
-  0x06, 0x14, 0x00, 0x13, 0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d,
-  0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34,
-  0x36, 0x33, 0x02, 0xac, 0x9e, 0x5a, 0x45, 0x01, 0x11, 0xfe, 0xef, 0xa6,
-  0x9f, 0x9f, 0x9c, 0xaa, 0x06, 0x14, 0x99, 0x50, 0x68, 0x63, 0x8f, 0xfc,
-  0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0xab, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xfe, 0x56, 0x03, 0xeb, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x28, 0x00, 0x00,
-  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x17, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33,
-  0x32, 0x16, 0x17, 0x35, 0x33, 0x03, 0x45, 0x95, 0x86, 0x85, 0x94, 0x94,
-  0x85, 0x86, 0x95, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a,
-  0xa3, 0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe2, 0xba, 0x70, 0xa0, 0x33,
-  0xa6, 0x02, 0x3d, 0xc8, 0xdc, 0xdc, 0xc8, 0xc7, 0xdc, 0xdc, 0xeb, 0xfe,
-  0xe2, 0xfe, 0xe9, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd, 0xbf, 0x5b, 0x63,
-  0x62, 0x01, 0x3a, 0x01, 0x03, 0x01, 0x04, 0x01, 0x3a, 0x62, 0x63, 0xaa,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x11, 0x33, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x03, 0xf4,
-  0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3,
-  0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87,
-  0x06, 0x14, 0xfd, 0x9e, 0x65, 0x64, 0xef, 0x00, 0x00, 0x02, 0x00, 0xad,
-  0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x23, 0x11, 0x33, 0x15, 0x23, 0xae, 0xa5, 0xa5, 0xa5,
-  0xa5, 0x04, 0x60, 0xfb, 0xa0, 0x06, 0x14, 0xe9, 0x00, 0x02, 0xff, 0xde,
-  0xfe, 0x56, 0x01, 0x54, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
-  0x11, 0x33, 0x15, 0x23, 0xae, 0xa5, 0x92, 0xa3, 0x3f, 0x2c, 0x5e, 0x45,
-  0xa5, 0xa5, 0x04, 0x60, 0xfb, 0x8c, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x06,
-  0x28, 0xe9, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x26,
-  0x06, 0x14, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09,
-  0x01, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xa7, 0x01, 0xee, 0xd4, 0xfd, 0xe9,
-  0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa7, 0x06, 0x14, 0xfc, 0x69, 0x01, 0xe3,
-  0xfd, 0xf4, 0xfd, 0xac, 0x02, 0x23, 0xfd, 0xdd, 0x00, 0x01, 0x00, 0xad,
-  0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x23, 0xae, 0xa5, 0xa5, 0x06, 0x14, 0xf9, 0xec, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67, 0x04, 0x7b, 0x00, 0x22,
-  0x00, 0x00, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0x03, 0xbe, 0x3f, 0xac, 0x75, 0x9e, 0xab, 0xa7, 0x66, 0x6a, 0x80,
-  0x96, 0xa6, 0x67, 0x6b, 0x7f, 0x95, 0xa7, 0xa7, 0x39, 0x9e, 0x6d, 0x6e,
-  0x9a, 0x03, 0x89, 0x7c, 0x76, 0xf5, 0xe2, 0xfd, 0x5c, 0x02, 0x9e, 0xa1,
-  0x9c, 0xbe, 0xa4, 0xfd, 0x87, 0x02, 0x9e, 0xa2, 0x9b, 0xbf, 0xa3, 0xfd,
-  0x87, 0x04, 0x60, 0xae, 0x67, 0x62, 0x7c, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0xf4, 0x04, 0x7b, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
-  0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86,
-  0x9b, 0xa7, 0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3, 0x02, 0xa4, 0xfd, 0x5c,
-  0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x65,
-  0x64, 0xef, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x12, 0x11,
-  0x10, 0x02, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x02, 0x34, 0x85, 0x9b,
-  0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x85, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xf5,
-  0xf5, 0x03, 0xdf, 0xe7, 0xc9, 0xc9, 0xe7, 0xe8, 0xc8, 0xc7, 0xe9, 0x9c,
-  0xfe, 0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x39, 0x01, 0x13,
-  0x01, 0x14, 0x01, 0x38, 0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e,
-  0x04, 0x7b, 0x00, 0x10, 0x00, 0x1c, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11,
-  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
-  0x26, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x01, 0x4e, 0xa7, 0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8,
-  0x6f, 0x9f, 0x01, 0xff, 0x96, 0x83, 0x84, 0x96, 0x96, 0x84, 0x83, 0x96,
-  0xa8, 0xfd, 0xae, 0x06, 0x0a, 0xaa, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8,
-  0xfe, 0xf8, 0xfe, 0xbc, 0x61, 0x01, 0xeb, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
-  0xe7, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb,
-  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01, 0x0e, 0x01, 0x23,
-  0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11,
-  0x23, 0x01, 0x11, 0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x02,
-  0x34, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0xa6,
-  0xa6, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0xfd, 0xae,
-  0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0x64,
-  0xaa, 0xf9, 0xf6, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x02, 0xf6,
-  0x04, 0x7b, 0x00, 0x11, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
-  0x02, 0xf6, 0x1c, 0x42, 0x27, 0x8d, 0x96, 0xa7, 0xa7, 0x34, 0xa8, 0x77,
-  0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11, 0xcb, 0xbe, 0xfd, 0xb2, 0x04,
-  0x60, 0xae, 0x66, 0x63, 0x05, 0x05, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe3, 0x03, 0x67, 0x04, 0x7b, 0x00, 0x27, 0x00, 0x00, 0x01, 0x15,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x03, 0x30, 0x46, 0x97, 0x51, 0x7b, 0x7c, 0x59, 0x85, 0x38,
-  0xb1, 0x94, 0xde, 0xc2, 0x51, 0xb0, 0x61, 0x5c, 0xb2, 0x57, 0x75, 0x7e,
-  0x5b, 0x9a, 0x39, 0x9a, 0x89, 0xca, 0xb9, 0x5c, 0xa2, 0x04, 0x3f, 0xae,
-  0x28, 0x28, 0x54, 0x54, 0x40, 0x49, 0x21, 0x0e, 0x2a, 0x99, 0x89, 0x9c,
-  0xb6, 0x23, 0x23, 0xbe, 0x35, 0x35, 0x59, 0x51, 0x4b, 0x50, 0x25, 0x0f,
-  0x24, 0x95, 0x82, 0x9e, 0xac, 0x1e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31,
-  0x00, 0x00, 0x02, 0xa7, 0x05, 0x9e, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
-  0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55, 0xfe, 0xab,
-  0x43, 0x67, 0xab, 0xab, 0xbf, 0x92, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2,
-  0x8f, 0xfd, 0xa0, 0x89, 0x4e, 0x9a, 0x9f, 0xd2, 0x02, 0x60, 0x8f, 0x01,
-  0x3e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
-  0x04, 0x7b, 0x00, 0x13, 0x00, 0x14, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0x01, 0x9d, 0xa5, 0x70, 0x6f, 0x87, 0x9b, 0xa6,
-  0xa6, 0x3c, 0x9f, 0x6a, 0xad, 0xb4, 0x01, 0xa0, 0x01, 0xba, 0x02, 0xa6,
-  0xfd, 0x61, 0x9f, 0x9f, 0xbe, 0xa4, 0x02, 0x7b, 0xfb, 0xa0, 0xac, 0x66,
-  0x63, 0xf0, 0x03, 0xa8, 0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
-  0x04, 0x60, 0x00, 0x06, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01,
-  0x23, 0x37, 0xaf, 0x01, 0x3b, 0x01, 0x3b, 0xb0, 0xfe, 0x86, 0xe1, 0x04,
-  0x60, 0xfc, 0x54, 0x03, 0xac, 0xfb, 0xa0, 0x00, 0x00, 0x01, 0x00, 0x4d,
-  0x00, 0x00, 0x05, 0x97, 0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33,
-  0x1b, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x4d,
-  0xa6, 0xcf, 0xce, 0xc3, 0xcf, 0xce, 0xa6, 0xfe, 0xf8, 0xc3, 0xd9, 0xda,
-  0xc3, 0x04, 0x60, 0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96, 0x03, 0x6a, 0xfb,
-  0xa0, 0x03, 0x96, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x35,
-  0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x02,
-  0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01, 0x03, 0xf4, 0xfe,
-  0x93, 0x01, 0x7f, 0xc3, 0xfe, 0xdb, 0xfe, 0xda, 0xc3, 0x01, 0x88, 0xfe,
-  0x99, 0xc4, 0x01, 0x0b, 0x01, 0x0b, 0x04, 0x60, 0xfd, 0xdf, 0xfd, 0xc1,
-  0x01, 0xb8, 0xfe, 0x48, 0x02, 0x4a, 0x02, 0x16, 0xfe, 0x71, 0x01, 0x8f,
-  0x00, 0x01, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x0f,
-  0x00, 0x00, 0x05, 0x0e, 0x01, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x3f,
-  0x01, 0x01, 0x33, 0x09, 0x01, 0x33, 0x02, 0x51, 0x46, 0x85, 0x70, 0x84,
-  0x61, 0x44, 0x4c, 0x2e, 0x1e, 0xfe, 0x68, 0xaf, 0x01, 0x3b, 0x01, 0x3b,
-  0xb0, 0x68, 0xc8, 0x7a, 0x9a, 0x48, 0x86, 0x54, 0x04, 0x4e, 0xfc, 0x94,
-  0x03, 0x6c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79,
-  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15,
-  0x21, 0x35, 0x01, 0x21, 0x66, 0x03, 0x12, 0xfd, 0x92, 0x02, 0x6e, 0xfc,
-  0xd7, 0x02, 0x6f, 0xfd, 0xa8, 0x04, 0x60, 0xa8, 0xfc, 0xdb, 0x93, 0xa8,
-  0x03, 0x25, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe6, 0xfe, 0xb2, 0x03, 0xaf,
-  0x06, 0x14, 0x00, 0x24, 0x00, 0x00, 0x05, 0x15, 0x23, 0x22, 0x26, 0x3d,
-  0x01, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34,
-  0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x14, 0x06, 0x07,
-  0x1e, 0x01, 0x1d, 0x01, 0x14, 0x16, 0x33, 0x03, 0xae, 0x38, 0xe0, 0x98,
-  0x61, 0x80, 0x37, 0x37, 0x81, 0x60, 0x98, 0xe0, 0x38, 0x3d, 0x7f, 0x4d,
-  0x52, 0x63, 0x64, 0x51, 0x4d, 0x7f, 0xbe, 0x90, 0x94, 0xdd, 0xef, 0x97,
-  0x74, 0x8f, 0x73, 0x95, 0xf0, 0xdd, 0x93, 0x8f, 0x58, 0x8d, 0xf8, 0x9d,
-  0x8e, 0x19, 0x1b, 0x8e, 0x9c, 0xf8, 0x8d, 0x58, 0x00, 0x01, 0x00, 0xea,
-  0xfe, 0x1d, 0x01, 0x83, 0x06, 0x1d, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x01, 0x83, 0x99, 0x06, 0x1d, 0xf8, 0x00, 0x08, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xe6, 0xfe, 0xb2, 0x03, 0xaf, 0x06, 0x14, 0x00, 0x24,
-  0x00, 0x00, 0x17, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34, 0x36, 0x37, 0x2e,
-  0x01, 0x3d, 0x01, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x1d,
-  0x01, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x14,
-  0x06, 0x2b, 0x01, 0xe6, 0x3f, 0x7e, 0x4d, 0x51, 0x64, 0x64, 0x51, 0x4d,
-  0x7e, 0x3f, 0x39, 0xe0, 0x97, 0x61, 0x7f, 0x38, 0x38, 0x7f, 0x61, 0x97,
-  0xe0, 0x39, 0xbe, 0x56, 0x8f, 0xf8, 0x9c, 0x8e, 0x1b, 0x19, 0x8e, 0x9d,
-  0xf8, 0x8e, 0x57, 0x8f, 0x93, 0xdd, 0xf0, 0x95, 0x73, 0x8f, 0x74, 0x97,
-  0xef, 0xdd, 0x94, 0x00, 0x00, 0x01, 0x00, 0xc3, 0x01, 0xd3, 0x05, 0x46,
-  0x03, 0x31, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
-  0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
-  0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x0a, 0x05, 0x06, 0x0d, 0x8c,
-  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x08, 0x05, 0x07,
-  0x0d, 0x8b, 0x55, 0x4d, 0x98, 0x03, 0x31, 0xb2, 0x4f, 0x44, 0x3b, 0x04,
-  0x02, 0x03, 0x05, 0x3e, 0x4d, 0x53, 0xb2, 0x4f, 0x45, 0x3c, 0x04, 0x02,
-  0x03, 0x05, 0x3e, 0x4c, 0x00, 0x02, 0x01, 0x16, 0x00, 0x00, 0x01, 0xcd,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33,
-  0x11, 0x23, 0x11, 0x13, 0x33, 0x13, 0x01, 0xcd, 0xb7, 0xb7, 0xb7, 0x13,
-  0x92, 0x12, 0x04, 0xd7, 0xfe, 0xfa, 0x2b, 0x02, 0x8f, 0x01, 0x65, 0xfe,
-  0x9b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9a, 0xfe, 0xc7, 0x03, 0xba,
-  0x05, 0x98, 0x00, 0x06, 0x00, 0x21, 0x00, 0x00, 0x25, 0x11, 0x0e, 0x01,
-  0x15, 0x14, 0x16, 0x01, 0x15, 0x2e, 0x01, 0x27, 0x03, 0x3e, 0x01, 0x37,
-  0x15, 0x0e, 0x01, 0x07, 0x11, 0x23, 0x11, 0x26, 0x02, 0x11, 0x10, 0x12,
-  0x37, 0x11, 0x33, 0x13, 0x1e, 0x01, 0x02, 0x62, 0x84, 0x94, 0x94, 0x01,
-  0xdb, 0x43, 0x7a, 0x3d, 0x01, 0x3f, 0x7b, 0x41, 0x3a, 0x7c, 0x45, 0x5c,
-  0xd9, 0xee, 0xee, 0xd9, 0x5c, 0x01, 0x42, 0x7b, 0x83, 0x03, 0x58, 0x12,
-  0xe2, 0xb8, 0xb9, 0xe2, 0x03, 0xa1, 0xac, 0x29, 0x2a, 0x03, 0xfc, 0xa0,
-  0x05, 0x2a, 0x27, 0xaa, 0x1e, 0x23, 0x07, 0xfe, 0xe4, 0x01, 0x20, 0x14,
-  0x01, 0x33, 0x01, 0x01, 0x01, 0x02, 0x01, 0x32, 0x16, 0x01, 0x1f, 0xfe,
-  0xe1, 0x04, 0x21, 0x00, 0x00, 0x01, 0x00, 0x74, 0x00, 0x00, 0x03, 0xf2,
-  0x05, 0xf0, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x35, 0x33,
-  0x11, 0x23, 0x35, 0x33, 0x35, 0x10, 0x36, 0x33, 0x32, 0x16, 0x03, 0xe0,
-  0x45, 0x7a, 0x37, 0x85, 0x69, 0x01, 0x60, 0xfe, 0xa0, 0x01, 0xf6, 0xfc,
-  0x82, 0xd4, 0xb3, 0xb3, 0xc1, 0xd1, 0x37, 0x88, 0x05, 0xb4, 0xb6, 0x29,
-  0x29, 0x9b, 0xd4, 0xd7, 0x8f, 0xfe, 0x2f, 0xaa, 0xaa, 0x01, 0xd1, 0x8f,
-  0xee, 0x01, 0x05, 0xf3, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x54,
-  0x00, 0x52, 0x04, 0x43, 0x04, 0xb2, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x00,
-  0x01, 0x37, 0x17, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07,
-  0x27, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x07, 0x27, 0x37, 0x2e, 0x01,
-  0x35, 0x34, 0x36, 0x37, 0x27, 0x37, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x16,
-  0x13, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x03, 0x22, 0xba, 0x67, 0xba, 0x22, 0x20, 0x22, 0x24, 0xbc, 0x67, 0xba,
-  0x35, 0x68, 0x37, 0x34, 0x6c, 0x37, 0xbb, 0x65, 0xba, 0x21, 0x22, 0x22,
-  0x23, 0xbb, 0x68, 0xba, 0x32, 0x68, 0x3a, 0x36, 0x69, 0x53, 0x8c, 0x66,
-  0x65, 0x8e, 0x8d, 0x66, 0x65, 0x8d, 0x03, 0xe1, 0xd1, 0x73, 0xce, 0x3b,
-  0x77, 0x3e, 0x3f, 0x73, 0x39, 0xcf, 0x71, 0xcf, 0x28, 0x26, 0x25, 0x25,
-  0xcf, 0x73, 0xce, 0x3e, 0x76, 0x3a, 0x40, 0x74, 0x38, 0xce, 0x73, 0xcf,
-  0x27, 0x25, 0x24, 0xfe, 0x7c, 0x70, 0x9a, 0x9a, 0x70, 0x72, 0x9c, 0x9d,
-  0x00, 0x01, 0x00, 0x49, 0x00, 0x00, 0x04, 0x4a, 0x05, 0xd5, 0x00, 0x18,
-  0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x35, 0x27,
-  0x21, 0x35, 0x33, 0x01, 0x33, 0x09, 0x01, 0x33, 0x01, 0x33, 0x15, 0x21,
-  0x07, 0x15, 0x21, 0x04, 0x18, 0xfe, 0x8d, 0xb5, 0xfe, 0x8a, 0x01, 0x76,
-  0x4c, 0xfe, 0xd6, 0xed, 0xfe, 0xe3, 0xab, 0x01, 0x55, 0x01, 0x53, 0xac,
-  0xfe, 0xe2, 0xed, 0xfe, 0xd7, 0x4c, 0x01, 0x75, 0x01, 0xc7, 0xfe, 0x39,
-  0x01, 0xc7, 0x7b, 0x33, 0x9b, 0x7b, 0x02, 0x4a, 0xfd, 0x44, 0x02, 0xbc,
-  0xfd, 0xb6, 0x7b, 0x9b, 0x33, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xea,
-  0xfe, 0xa2, 0x01, 0x83, 0x05, 0x98, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x11, 0x23, 0x11, 0x13, 0x11, 0x23, 0x11, 0x01, 0x83, 0x99, 0x99,
-  0x99, 0x01, 0x98, 0xfd, 0x0a, 0x02, 0xf6, 0x04, 0x00, 0xfd, 0x0a, 0x02,
-  0xf6, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x52, 0xff, 0x3d, 0x03, 0x45,
-  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x17, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
-  0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35,
-  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x2e, 0x01, 0x35,
-  0x34, 0x36, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x01,
-  0x55, 0x39, 0x37, 0x7d, 0xe1, 0x38, 0x38, 0x81, 0xb8, 0x4b, 0x80, 0x33,
-  0x57, 0x61, 0xb9, 0x18, 0x0c, 0xbe, 0x76, 0x53, 0x54, 0x38, 0x34, 0xb8,
-  0x9c, 0x41, 0x8b, 0x4f, 0x4e, 0x85, 0x34, 0x5c, 0x66, 0xc7, 0x16, 0xc1,
-  0x73, 0x53, 0x52, 0x35, 0x35, 0xb4, 0x96, 0x41, 0x8a, 0x03, 0xa8, 0x2e,
-  0x5a, 0x2e, 0x4c, 0x85, 0x87, 0x2d, 0x5b, 0x2e, 0x4b, 0x88, 0x02, 0x93,
-  0xa4, 0x27, 0x27, 0x50, 0x47, 0x5a, 0x73, 0x0f, 0x08, 0x77, 0x9a, 0x65,
-  0x5a, 0x8c, 0x35, 0x34, 0x6d, 0x40, 0x8e, 0xa8, 0x1d, 0x1d, 0xa4, 0x27,
-  0x27, 0x54, 0x4c, 0x66, 0x7b, 0x0e, 0x78, 0x99, 0x66, 0x5b, 0x8f, 0x31,
-  0x2c, 0x70, 0x45, 0x82, 0x9f, 0x1d, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc1,
-  0x05, 0x46, 0x02, 0xd9, 0x06, 0x10, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x02, 0x21, 0xb7, 0xb7,
-  0xfe, 0xa1, 0xb6, 0xb6, 0x06, 0x10, 0xca, 0xca, 0xca, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xfe, 0x00, 0x00, 0x06, 0x35, 0x05, 0xcd, 0x00, 0x17,
-  0x00, 0x2f, 0x00, 0x49, 0x00, 0x00, 0x01, 0x32, 0x16, 0x17, 0x16, 0x12,
-  0x15, 0x14, 0x02, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26, 0x02,
-  0x35, 0x34, 0x12, 0x37, 0x3e, 0x01, 0x17, 0x22, 0x06, 0x07, 0x0e, 0x01,
-  0x15, 0x14, 0x16, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x3e, 0x01,
-  0x35, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x03, 0x9a, 0x88, 0xed,
-  0x62, 0x62, 0x61, 0x61, 0x62, 0x62, 0xed, 0x88, 0x89, 0xed, 0x62, 0x62,
-  0x61, 0x61, 0x62, 0x62, 0xed, 0x89, 0x76, 0xcc, 0x54, 0x55, 0x56, 0x56,
-  0x55, 0x54, 0xcc, 0x76, 0x76, 0xcd, 0x54, 0x54, 0x54, 0x55, 0x53, 0x54,
-  0xcd, 0x97, 0x3c, 0x75, 0x3b, 0x86, 0x97, 0x9a, 0x8c, 0x3a, 0x6d, 0x3c,
-  0x3d, 0x7b, 0x3f, 0xc2, 0xe2, 0xe2, 0xc2, 0x42, 0x7a, 0x05, 0xcd, 0x6e,
-  0x6d, 0x6d, 0xfe, 0xfa, 0x9a, 0x98, 0xfe, 0xfb, 0x6d, 0x6d, 0x6e, 0x6e,
-  0x6d, 0x6d, 0x01, 0x05, 0x98, 0x9a, 0x01, 0x06, 0x6d, 0x6d, 0x6e, 0x67,
-  0x5e, 0x5e, 0x5e, 0xe5, 0x82, 0x81, 0xe3, 0x5e, 0x5e, 0x5f, 0x5f, 0x5e,
-  0x5d, 0xe2, 0x83, 0x85, 0xe3, 0x5d, 0x5e, 0x5e, 0xf5, 0x81, 0x21, 0x20,
-  0xaf, 0x9d, 0x9f, 0xae, 0x1f, 0x22, 0x7f, 0x1d, 0x1c, 0xf4, 0xd0, 0xd1,
-  0xf2, 0x1c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67, 0x01, 0xd5, 0x02, 0xe9,
-  0x05, 0xf0, 0x00, 0x03, 0x00, 0x1e, 0x00, 0x29, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x01, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
-  0x3e, 0x01, 0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x3d, 0x01, 0x7d, 0x02, 0x6b, 0xfd, 0x95, 0x02, 0x69, 0x86,
-  0x27, 0x82, 0x53, 0x74, 0x88, 0xab, 0xaa, 0xa3, 0x69, 0x69, 0x38, 0x7a,
-  0x3e, 0x42, 0x83, 0x3e, 0xa4, 0xa1, 0xf8, 0x91, 0x71, 0x58, 0x4a, 0x5d,
-  0x75, 0x02, 0x50, 0x7b, 0x02, 0xb8, 0xfe, 0x40, 0x70, 0x3f, 0x44, 0x87,
-  0x71, 0x87, 0x8a, 0x04, 0x5b, 0x5b, 0x22, 0x22, 0x7f, 0x1c, 0x1c, 0xb0,
-  0xf0, 0x43, 0x4f, 0x40, 0x4d, 0x90, 0x72, 0x1d, 0x00, 0x02, 0x00, 0x8e,
-  0x00, 0x8d, 0x03, 0xbb, 0x04, 0x23, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
-  0x01, 0x15, 0x09, 0x01, 0x15, 0x01, 0x35, 0x13, 0x15, 0x09, 0x01, 0x15,
-  0x01, 0x35, 0x03, 0xbb, 0xfe, 0xf1, 0x01, 0x0f, 0xfe, 0x5a, 0x1f, 0xfe,
-  0xf1, 0x01, 0x0f, 0xfe, 0x5a, 0x04, 0x23, 0xbf, 0xfe, 0xf4, 0xfe, 0xf4,
-  0xbf, 0x01, 0xa2, 0x52, 0x01, 0xa2, 0xbf, 0xfe, 0xf4, 0xfe, 0xf4, 0xbf,
-  0x01, 0xa2, 0x52, 0x00, 0x00, 0x01, 0x00, 0xc3, 0x01, 0x1f, 0x05, 0x46,
-  0x03, 0x5e, 0x00, 0x05, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0xc3, 0x04, 0x82, 0x97, 0xfc, 0x15, 0x03, 0x5e, 0xfd, 0xc1, 0x01, 0x95,
-  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40, 0x02, 0x83, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x01, 0xe5, 0xfe, 0x1b, 0x02,
-  0x83, 0xa4, 0x00, 0x00, 0x00, 0x04, 0x00, 0xfe, 0x00, 0x00, 0x06, 0x35,
-  0x05, 0xcd, 0x00, 0x17, 0x00, 0x2f, 0x00, 0x38, 0x00, 0x4c, 0x00, 0x00,
-  0x01, 0x22, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x1e, 0x01,
-  0x33, 0x32, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x2e, 0x01,
-  0x27, 0x32, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x0e, 0x01,
-  0x23, 0x22, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x3e, 0x01,
-  0x13, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x1f, 0x01, 0x23, 0x27, 0x2e, 0x01,
-  0x2b, 0x01, 0x11, 0x23, 0x11, 0x03, 0x9a, 0x76, 0xcc, 0x54, 0x55, 0x56,
-  0x56, 0x55, 0x54, 0xcc, 0x76, 0x76, 0xcd, 0x54, 0x54, 0x54, 0x55, 0x53,
-  0x54, 0xcd, 0x76, 0x88, 0xed, 0x62, 0x62, 0x61, 0x61, 0x62, 0x62, 0xed,
-  0x88, 0x89, 0xed, 0x62, 0x62, 0x61, 0x61, 0x62, 0x62, 0xed, 0x70, 0x6e,
-  0x6e, 0x63, 0x4f, 0x50, 0x5b, 0x9e, 0x9d, 0x5f, 0x56, 0x15, 0x3d, 0x29,
-  0x7b, 0x9a, 0x75, 0x35, 0x41, 0x31, 0x3b, 0x8c, 0x05, 0x66, 0x5e, 0x5e,
-  0x5e, 0xe5, 0x82, 0x81, 0xe3, 0x5e, 0x5e, 0x5f, 0x5f, 0x5e, 0x5d, 0xe2,
-  0x83, 0x85, 0xe3, 0x5d, 0x5e, 0x5e, 0x67, 0x6e, 0x6d, 0x6d, 0xfe, 0xfa,
-  0x9a, 0x98, 0xfe, 0xfb, 0x6d, 0x6d, 0x6e, 0x6e, 0x6d, 0x6d, 0x01, 0x05,
-  0x98, 0x9a, 0x01, 0x06, 0x6d, 0x6d, 0x6e, 0xfe, 0x62, 0xfe, 0xec, 0x3e,
-  0x4b, 0x4c, 0x3f, 0x67, 0x77, 0x79, 0x56, 0x70, 0x11, 0x08, 0x4d, 0x49,
-  0xdf, 0xd1, 0x60, 0x33, 0xfe, 0x9c, 0x03, 0x44, 0x00, 0x01, 0x00, 0xbf,
-  0x05, 0x62, 0x02, 0xda, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0xc0, 0x02, 0x1a, 0xfd, 0xe6, 0x05, 0xf6, 0x94, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xaf, 0x03, 0x75, 0x02, 0xeb, 0x05, 0xf0, 0x00, 0x0b,
-  0x00, 0x1a, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0xcd, 0x48, 0x63, 0x63,
-  0x48, 0x48, 0x63, 0x64, 0x47, 0x39, 0x6b, 0x26, 0x2a, 0x29, 0xa6, 0x79,
-  0x79, 0xa2, 0xa5, 0x05, 0x6f, 0x6f, 0x50, 0x4f, 0x6d, 0x6d, 0x4f, 0x4f,
-  0x70, 0x81, 0x31, 0x2e, 0x2d, 0x72, 0x42, 0x84, 0xb7, 0xb4, 0x87, 0x86,
-  0xba, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
-  0x05, 0x04, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15,
-  0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x01, 0x21, 0x15, 0x21,
-  0x03, 0x50, 0x01, 0xf5, 0xfe, 0x0b, 0x97, 0xfe, 0x0a, 0x01, 0xf6, 0xfe,
-  0x0a, 0x04, 0x82, 0xfb, 0x7e, 0x05, 0x04, 0xfe, 0x7d, 0xaa, 0xfe, 0x7d,
-  0x01, 0x83, 0xaa, 0x01, 0x83, 0xfb, 0xa6, 0xaa, 0x00, 0x01, 0x00, 0x54,
-  0x02, 0x9c, 0x02, 0x6f, 0x05, 0xf0, 0x00, 0x18, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x01, 0x06, 0xf1,
-  0x01, 0x7e, 0xfd, 0xe6, 0x1e, 0x39, 0x01, 0x36, 0x5e, 0x4d, 0x2e, 0x6e,
-  0x41, 0x45, 0x78, 0x33, 0x83, 0x9c, 0xfe, 0xd7, 0x33, 0x03, 0x0e, 0x72,
-  0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23, 0x23, 0x7b, 0x1c,
-  0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00, 0x01, 0x00, 0x58,
-  0x02, 0x8d, 0x02, 0x86, 0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x01, 0x1e,
-  0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x01, 0xd8, 0x52, 0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f,
-  0x2f, 0x6b, 0x3c, 0x62, 0x6c, 0x63, 0x62, 0x4d, 0x55, 0x54, 0x57, 0x5a,
-  0x55, 0x24, 0x5c, 0x49, 0x42, 0x73, 0x32, 0x81, 0x98, 0x51, 0x04, 0x60,
-  0x12, 0x6d, 0x52, 0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46,
-  0x4a, 0x4c, 0x6c, 0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11, 0x12,
-  0x76, 0x63, 0x45, 0x60, 0x00, 0x01, 0x01, 0x4d, 0x04, 0xee, 0x02, 0xfd,
-  0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x02, 0x4a,
-  0xb3, 0xfe, 0xdb, 0x8a, 0x06, 0x66, 0xfe, 0x88, 0x00, 0x01, 0x00, 0x9c,
-  0xfe, 0x56, 0x04, 0x68, 0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x13, 0x11,
-  0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27,
-  0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x11, 0x9d, 0xa5, 0x7c, 0x7a, 0x85,
-  0x86, 0xa6, 0x1f, 0x22, 0x08, 0x1c, 0x1a, 0x25, 0x42, 0x1f, 0x3e, 0x4a,
-  0x0e, 0x2d, 0x82, 0x59, 0x5b, 0x81, 0x26, 0xfe, 0x56, 0x06, 0x0a, 0xfd,
-  0x48, 0x91, 0x94, 0xa8, 0xa8, 0x02, 0x8d, 0xfc, 0xa2, 0x3c, 0x39, 0x0b,
-  0x0c, 0x94, 0x17, 0x16, 0x4e, 0x50, 0x4f, 0x4f, 0x4e, 0x4e, 0xfd, 0xd7,
-  0x00, 0x01, 0x00, 0x8e, 0xff, 0x3b, 0x03, 0xcd, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x2e,
-  0x01, 0x35, 0x34, 0x36, 0x02, 0x3a, 0x01, 0x93, 0x7f, 0xab, 0x80, 0xc1,
-  0xd4, 0xea, 0x05, 0xd5, 0xf9, 0x66, 0x06, 0x1f, 0xf9, 0xe1, 0x03, 0x4e,
-  0x11, 0xdd, 0xb8, 0xbe, 0xe8, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc5,
-  0x02, 0x48, 0x01, 0x83, 0x03, 0x46, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
-  0x15, 0x23, 0xc5, 0xbe, 0xbe, 0x03, 0x46, 0xfe, 0x00, 0x01, 0x01, 0x05,
-  0xfe, 0x75, 0x02, 0x7b, 0x00, 0x00, 0x00, 0x13, 0x00, 0x00, 0x21, 0x1e,
-  0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x02, 0x18, 0x32, 0x30, 0x6c, 0x6a,
-  0x29, 0x4e, 0x27, 0x1e, 0x43, 0x2a, 0x35, 0x36, 0x26, 0x29, 0x3e, 0x69,
-  0x30, 0x59, 0x5b, 0x0c, 0x0c, 0x83, 0x11, 0x0f, 0x30, 0x2e, 0x1e, 0x57,
-  0x3d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b, 0x02, 0x9c, 0x02, 0x7f,
-  0x05, 0xdf, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33, 0x11, 0x07, 0x35, 0x37,
-  0x33, 0x11, 0x33, 0x15, 0x21, 0x8c, 0xb8, 0xc9, 0xcf, 0x7c, 0xb8, 0xfe,
-  0x0e, 0x03, 0x0a, 0x02, 0x63, 0x29, 0x74, 0x27, 0xfd, 0x2b, 0x6e, 0x00,
-  0x00, 0x03, 0x00, 0x56, 0x01, 0xd5, 0x03, 0x0e, 0x05, 0xf0, 0x00, 0x03,
-  0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x17, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x7d, 0x02,
-  0x6b, 0xfd, 0x95, 0x01, 0x36, 0xa1, 0xb9, 0xb9, 0xa1, 0xa1, 0xbc, 0xbc,
-  0xa1, 0x5f, 0x71, 0x72, 0x5e, 0x5e, 0x71, 0x70, 0x02, 0x50, 0x7b, 0x04,
-  0x1b, 0xdd, 0xbf, 0xbf, 0xdb, 0xdc, 0xbe, 0xbf, 0xdd, 0x73, 0xa1, 0x88,
-  0x85, 0xa0, 0xa0, 0x85, 0x89, 0xa0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
-  0x00, 0x8d, 0x03, 0xdb, 0x04, 0x23, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
-  0x13, 0x01, 0x15, 0x01, 0x35, 0x09, 0x01, 0x25, 0x01, 0x15, 0x01, 0x35,
-  0x09, 0x01, 0xae, 0x01, 0xa6, 0xfe, 0x5a, 0x01, 0x0f, 0xfe, 0xf1, 0x01,
-  0x86, 0x01, 0xa6, 0xfe, 0x5a, 0x01, 0x0f, 0xfe, 0xf1, 0x04, 0x23, 0xfe,
-  0x5e, 0x52, 0xfe, 0x5e, 0xbf, 0x01, 0x0c, 0x01, 0x0c, 0xbf, 0xfe, 0x5e,
-  0x52, 0xfe, 0x5e, 0xbf, 0x01, 0x0c, 0x01, 0x0c, 0xff, 0xff, 0x00, 0x7b,
-  0xff, 0xe3, 0x06, 0xc0, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
-  0x10, 0x27, 0x07, 0xa2, 0x04, 0x17, 0xfd, 0x64, 0x10, 0x07, 0x07, 0x79,
-  0x02, 0xe3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0x86,
-  0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x74,
-  0x04, 0x17, 0xfd, 0x64, 0x10, 0x07, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x58, 0xff, 0xe3, 0x06, 0xc0, 0x05, 0xf0, 0x10, 0x26,
-  0x00, 0x75, 0x00, 0x00, 0x10, 0x27, 0x07, 0xa2, 0x04, 0x17, 0xfd, 0x64,
-  0x10, 0x07, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x00, 0x02, 0x00, 0x80,
-  0xff, 0xe3, 0x03, 0x4e, 0x05, 0xd5, 0x00, 0x20, 0x00, 0x24, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x14, 0x06, 0x0f, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x3f, 0x01, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x35, 0x13, 0x23, 0x35,
-  0x33, 0x01, 0xc2, 0xab, 0x31, 0x52, 0x50, 0x35, 0x2e, 0x76, 0x62, 0x47,
-  0xa2, 0x56, 0x55, 0xac, 0x5d, 0xa6, 0xc9, 0x41, 0x50, 0x50, 0x2b, 0x22,
-  0x07, 0x07, 0x05, 0xb0, 0xb5, 0xb5, 0x04, 0x44, 0x9c, 0x65, 0x82, 0x57,
-  0x58, 0x35, 0x5e, 0x31, 0x59, 0x6e, 0x46, 0x43, 0xbc, 0x39, 0x38, 0xc2,
-  0x9f, 0x4c, 0x89, 0x56, 0x56, 0x2f, 0x35, 0x19, 0x15, 0x3c, 0x36, 0x01,
-  0x0e, 0xfe, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x07, 0x6b, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee,
-  0x04, 0x43, 0x01, 0x75, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x07, 0x6b, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec,
-  0x04, 0x43, 0x01, 0x75, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x07, 0x6d, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x11, 0x07, 0x10, 0xef,
-  0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x5e, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xed, 0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x4e, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x43, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x07, 0x6d, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x21, 0x00, 0x00, 0x01, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x0b, 0x01,
-  0x21, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x07, 0x01, 0x23, 0x03, 0x21, 0x03, 0x23, 0x02, 0xff, 0x50, 0x39,
-  0x3a, 0x4e, 0x4f, 0x39, 0x39, 0x50, 0x89, 0xf5, 0x01, 0xeb, 0xfe, 0x82,
-  0x37, 0x38, 0x8f, 0x68, 0x67, 0x91, 0x39, 0x36, 0x01, 0xdf, 0xbd, 0x7b,
-  0xfd, 0xa2, 0x7a, 0xc0, 0x06, 0x5a, 0x3f, 0x59, 0x57, 0x41, 0x3f, 0x58,
-  0x58, 0xfe, 0xf3, 0xfd, 0x19, 0x03, 0x4e, 0x29, 0x73, 0x49, 0x73, 0xa0,
-  0xa1, 0x72, 0x46, 0x76, 0x29, 0xfa, 0x8b, 0x01, 0x7f, 0xfe, 0x81, 0x00,
-  0x00, 0x02, 0x00, 0x07, 0x00, 0x00, 0x06, 0x8e, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x13, 0x00, 0x00, 0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x03, 0x23, 0x01, 0x17, 0x01, 0x21, 0x11,
-  0x06, 0x7c, 0xfd, 0x66, 0x02, 0x80, 0xfd, 0x80, 0x02, 0xac, 0xfc, 0x9d,
-  0xfe, 0x25, 0x90, 0xb9, 0x02, 0x33, 0x7d, 0xfe, 0xd7, 0x01, 0x9d, 0x05,
-  0xd5, 0xaa, 0xfe, 0x46, 0xaa, 0xfd, 0xe3, 0xaa, 0x01, 0x7f, 0xfe, 0x81,
-  0x05, 0xd5, 0x9e, 0xfc, 0xf0, 0x03, 0x10, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xfe, 0x75, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x26, 0x00, 0x26, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x7a, 0x01, 0x0f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xee, 0x04, 0x28, 0x01, 0x75, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xec, 0x04, 0x28, 0x01, 0x75, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xef, 0x04, 0x28, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x4e, 0x12, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x28, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x01, 0x8e,
-  0x07, 0x6b, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee,
-  0x02, 0xde, 0x01, 0x75, 0xff, 0xff, 0x00, 0x91, 0x00, 0x00, 0x01, 0xe9,
-  0x07, 0x6b, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec,
-  0x02, 0xde, 0x01, 0x75, 0xff, 0xff, 0xff, 0xfe, 0x00, 0x00, 0x02, 0x24,
-  0x07, 0x6d, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xef,
-  0x02, 0xde, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0x00, 0x00, 0x02, 0x1c, 0x07, 0x4e, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xeb, 0x02, 0xde, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x05, 0x28, 0x05, 0xd5, 0x00, 0x0c,
-  0x00, 0x19, 0x00, 0x00, 0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x29,
-  0x01, 0x11, 0x23, 0x35, 0x33, 0x13, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0xbe, 0x01, 0x76, 0x01, 0x86, 0x01,
-  0x6d, 0xfe, 0x92, 0xfe, 0x7b, 0xfe, 0x8a, 0xb5, 0xb5, 0xb7, 0x01, 0x2e,
-  0xfe, 0xd2, 0xda, 0x01, 0x16, 0x01, 0x03, 0xfe, 0xfd, 0xfe, 0xea, 0x05,
-  0xd5, 0xfe, 0x97, 0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x02, 0xbc, 0x90,
-  0x01, 0xe3, 0xfe, 0x1d, 0x90, 0xfd, 0xea, 0x01, 0x18, 0x01, 0x2e, 0x01,
-  0x2c, 0x01, 0x17, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae,
-  0x07, 0x5e, 0x12, 0x26, 0x00, 0x31, 0x00, 0x00, 0x11, 0x07, 0x10, 0xed,
-  0x04, 0x7e, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xee, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xec, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xef, 0x04, 0xa3, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x5e, 0x12, 0x26,
-  0x00, 0x32, 0x00, 0x00, 0x11, 0x07, 0x10, 0xed, 0x04, 0xa3, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x07, 0x4e, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb,
-  0x04, 0xa3, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xfc,
-  0x00, 0x3f, 0x05, 0x0d, 0x04, 0xc5, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x02,
-  0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x37, 0x09, 0x01, 0x05, 0x0c, 0xfe,
-  0x65, 0x01, 0x9b, 0x6b, 0xfe, 0x63, 0xfe, 0x63, 0x6a, 0x01, 0x9a, 0xfe,
-  0x66, 0x6a, 0x01, 0x9d, 0x01, 0x9d, 0x04, 0x4c, 0xfe, 0x35, 0xfe, 0x37,
-  0x79, 0x01, 0xcb, 0xfe, 0x35, 0x79, 0x01, 0xc9, 0x01, 0xcb, 0x79, 0xfe,
-  0x35, 0x01, 0xcb, 0x00, 0x00, 0x03, 0x00, 0x5b, 0xff, 0xba, 0x05, 0x4f,
-  0x06, 0x17, 0x00, 0x09, 0x00, 0x13, 0x00, 0x2b, 0x00, 0x00, 0x09, 0x01,
-  0x1e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x23,
-  0x22, 0x02, 0x11, 0x14, 0x16, 0x17, 0x07, 0x26, 0x02, 0x35, 0x10, 0x00,
-  0x21, 0x32, 0x16, 0x17, 0x37, 0x17, 0x07, 0x16, 0x12, 0x15, 0x10, 0x00,
-  0x21, 0x22, 0x26, 0x27, 0x07, 0x27, 0x04, 0x3d, 0xfd, 0x7b, 0x38, 0x91,
-  0x55, 0xc6, 0xe8, 0x24, 0x6c, 0x37, 0x91, 0x56, 0xc6, 0xe9, 0x23, 0x23,
-  0x78, 0x46, 0x47, 0x01, 0x53, 0x01, 0x1b, 0x75, 0xc7, 0x4e, 0x92, 0x5c,
-  0x99, 0x46, 0x48, 0xfe, 0xae, 0xfe, 0xe5, 0x73, 0xc7, 0x52, 0x92, 0x5c,
-  0x04, 0x58, 0xfc, 0xb2, 0x40, 0x43, 0x01, 0x48, 0x01, 0x1a, 0x70, 0xb8,
-  0xb8, 0x40, 0x43, 0xfe, 0xb8, 0xfe, 0xe5, 0x70, 0xbc, 0x44, 0x9e, 0x66,
-  0x01, 0x08, 0xa0, 0x01, 0x62, 0x01, 0xa5, 0x4d, 0x4b, 0xbf, 0x59, 0xc6,
-  0x67, 0xfe, 0xf6, 0x9e, 0xfe, 0x9f, 0xfe, 0x5b, 0x4b, 0x4b, 0xbf, 0x58,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6b, 0x12, 0x26,
-  0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee, 0x04, 0x70, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6b, 0x12, 0x26,
-  0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec, 0x04, 0x70, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6d, 0x12, 0x26,
-  0x00, 0x38, 0x00, 0x00, 0x11, 0x07, 0x10, 0xef, 0x04, 0x70, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x07, 0x4e, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb,
-  0x04, 0x70, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc,
-  0x00, 0x00, 0x04, 0x6a, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xec, 0x04, 0x01, 0x01, 0x75, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11,
-  0x23, 0x13, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0xb5, 0xb6,
-  0xe4, 0xe2, 0xe7, 0xe7, 0xe2, 0xe4, 0xb6, 0xb6, 0xe4, 0x7f, 0x8b, 0x8a,
-  0x80, 0x05, 0xd5, 0xfe, 0xf8, 0xe1, 0xdc, 0xdc, 0xe2, 0xfe, 0xae, 0x04,
-  0x27, 0xfd, 0xd1, 0x92, 0x86, 0x86, 0x91, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xff, 0xe3, 0x04, 0x35, 0x06, 0x14, 0x00, 0x2f, 0x00, 0x00, 0x13, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x17, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x1f, 0x01,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34,
-  0x36, 0x37, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0xa7, 0xd7,
-  0xc5, 0xbb, 0xc5, 0x03, 0x88, 0x97, 0x34, 0x3a, 0x34, 0x95, 0x56, 0xca,
-  0xbe, 0x3a, 0x7a, 0x42, 0x48, 0x7e, 0x3b, 0x68, 0x6c, 0x35, 0x5b, 0x53,
-  0x56, 0x4e, 0x96, 0x88, 0x07, 0x76, 0x66, 0x75, 0x7a, 0xa9, 0x04, 0x71,
-  0xc8, 0xdb, 0xe8, 0xe0, 0x08, 0x73, 0x60, 0x2f, 0x51, 0x2a, 0x25, 0x6a,
-  0x8e, 0x64, 0xac, 0xb7, 0x19, 0x18, 0xa4, 0x1e, 0x1d, 0x5f, 0x5b, 0x3f,
-  0x54, 0x3e, 0x37, 0x3b, 0x87, 0x5b, 0x7f, 0xac, 0x1d, 0x67, 0x70, 0x8b,
-  0x83, 0xfb, 0x93, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x00, 0x43,
-  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x00, 0x76,
-  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x88,
-  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x06, 0x37, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x9e,
-  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x06, 0x10, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a,
-  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x07, 0x06, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x9c,
-  0x4a, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xb1,
-  0x04, 0x7b, 0x00, 0x06, 0x00, 0x33, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x07, 0x03, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x1d,
-  0x01, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b,
-  0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x03, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d,
-  0x01, 0x06, 0x0a, 0x01, 0x94, 0x7b, 0x8a, 0xa7, 0x0c, 0x3d, 0x42, 0xbf,
-  0x77, 0xcb, 0xee, 0xfd, 0x06, 0x0b, 0xb8, 0xa4, 0x5e, 0xb4, 0x5a, 0x5a,
-  0xbb, 0x60, 0x96, 0xdf, 0x45, 0x42, 0xc3, 0x80, 0xaa, 0xbd, 0xe3, 0xe2,
-  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0x80, 0xc0, 0xd7,
-  0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0x02, 0x94, 0x97, 0xb4, 0xae, 0x9e,
-  0x01, 0x30, 0x5a, 0x5e, 0xfe, 0xdd, 0xfa, 0x5a, 0xbf, 0xc8, 0x35, 0x35,
-  0xae, 0x2a, 0x2c, 0x79, 0x77, 0x78, 0x78, 0xbb, 0xa8, 0xbd, 0xc0, 0x12,
-  0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0x60, 0xfe, 0x18, 0x66, 0x7b,
-  0x62, 0x73, 0xd9, 0xb4, 0x29, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x75, 0x03, 0x84, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x46, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x7a, 0x00, 0x81, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x43, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x76, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x11, 0x06, 0x02, 0x88, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x10, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x11, 0x06, 0x00, 0x6a, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xcc,
-  0x00, 0x00, 0x01, 0x7c, 0x06, 0x66, 0x10, 0x27, 0x00, 0x43, 0xff, 0x34,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x81,
-  0x00, 0x00, 0x02, 0x31, 0x06, 0x66, 0x10, 0x27, 0x00, 0x76, 0xff, 0x34,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe1,
-  0x00, 0x00, 0x02, 0x20, 0x06, 0x66, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00,
-  0x11, 0x07, 0x02, 0x88, 0xff, 0x34, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xf5, 0x00, 0x00, 0x02, 0x0c, 0x06, 0x10, 0x12, 0x26,
-  0x00, 0xf3, 0x00, 0x00, 0x11, 0x07, 0x00, 0x6a, 0xff, 0x34, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x06, 0x14, 0x00, 0x0e, 0x00, 0x28, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23,
-  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13,
-  0x16, 0x12, 0x15, 0x14, 0x00, 0x23, 0x22, 0x02, 0x11, 0x34, 0x12, 0x33,
-  0x32, 0x16, 0x17, 0x27, 0x05, 0x27, 0x37, 0x27, 0x33, 0x17, 0x25, 0x17,
-  0x05, 0x02, 0xf2, 0x2d, 0x4f, 0x25, 0x96, 0xa7, 0x9d, 0x83, 0x83, 0x9c,
-  0x30, 0x08, 0x71, 0x67, 0xff, 0x00, 0xcf, 0xd0, 0xfe, 0xf8, 0xc7, 0x10,
-  0x2f, 0x26, 0x8f, 0xfe, 0xe1, 0x1e, 0xfd, 0xa3, 0xcd, 0x72, 0x01, 0x2c,
-  0x1e, 0xfe, 0xf6, 0x03, 0x93, 0x11, 0x10, 0xd8, 0xc3, 0xbc, 0xde, 0xde,
-  0xbc, 0x7a, 0xbc, 0x01, 0x26, 0x8f, 0xfe, 0xe0, 0xad, 0xff, 0xfe, 0xc9,
-  0x01, 0x37, 0x00, 0xff, 0xfa, 0x01, 0x37, 0x05, 0x05, 0xb4, 0x6b, 0x63,
-  0x5c, 0xcc, 0x91, 0x6f, 0x61, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0xf4, 0x06, 0x37, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x9e, 0x00, 0x89, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x43, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x76, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x11, 0x06, 0x02, 0x88, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x37, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x11, 0x06, 0x02, 0x9e, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x10, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x11, 0x06, 0x00, 0x6a, 0x68, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0x00, 0x96, 0x05, 0x46, 0x04, 0x6f, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x01, 0x21,
-  0x15, 0x21, 0x02, 0x96, 0xdd, 0xdd, 0xdd, 0xdd, 0xfe, 0x2d, 0x04, 0x82,
-  0xfb, 0x7e, 0x04, 0x6f, 0xf6, 0xfe, 0x12, 0xf5, 0x02, 0x41, 0xaa, 0x00,
-  0x00, 0x03, 0x00, 0x40, 0xff, 0xa2, 0x04, 0x26, 0x04, 0xbc, 0x00, 0x09,
-  0x00, 0x13, 0x00, 0x2b, 0x00, 0x00, 0x09, 0x01, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x16, 0x17, 0x07, 0x2e, 0x01, 0x35, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17,
-  0x37, 0x17, 0x07, 0x1e, 0x01, 0x15, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27,
-  0x07, 0x27, 0x03, 0x2e, 0xfe, 0x4a, 0x25, 0x5d, 0x3a, 0x85, 0x9a, 0x12,
-  0x52, 0x26, 0x5d, 0x38, 0x88, 0x98, 0x11, 0x12, 0x70, 0x31, 0x30, 0xf5,
-  0xd9, 0x54, 0x8f, 0x3c, 0x7d, 0x56, 0x83, 0x2f, 0x31, 0xf7, 0xd8, 0x56,
-  0x91, 0x39, 0x7d, 0x56, 0x03, 0x21, 0xfd, 0xb0, 0x2a, 0x28, 0xe8, 0xc8,
-  0x4f, 0x75, 0x9a, 0x29, 0x29, 0xeb, 0xd3, 0x48, 0x6e, 0x2e, 0x97, 0x4d,
-  0xc5, 0x77, 0x01, 0x14, 0x01, 0x38, 0x33, 0x34, 0xa8, 0x4f, 0xb3, 0x4d,
-  0xc6, 0x78, 0xfe, 0xed, 0xfe, 0xc7, 0x34, 0x33, 0xa8, 0x4e, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x10, 0x06, 0x00, 0x43, 0x6f, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76, 0x6f, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x02, 0x88, 0x6f, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x10, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a, 0x6f, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x5c, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76, 0x55, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x10,
-  0x00, 0x1c, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11, 0x33, 0x11, 0x3e, 0x01,
-  0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26, 0x01, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x01, 0x4e, 0xa7,
-  0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x01, 0xff,
-  0x96, 0x83, 0x84, 0x96, 0x96, 0x84, 0x83, 0x96, 0xa8, 0xfd, 0xae, 0x07,
-  0xbe, 0xfd, 0xa2, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8, 0xfe,
-  0xbc, 0x61, 0x01, 0xeb, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x10, 0x12, 0x26,
-  0x00, 0x5c, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a, 0x55, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0xaa, 0x01, 0x3b, 0x13, 0x06, 0x00, 0x24, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x05, 0xf6, 0x10, 0x26, 0x00, 0x71, 0x43, 0x00, 0x13, 0x06, 0x00, 0x44,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x07, 0x92, 0x10, 0x27, 0x02, 0x9a, 0x00, 0xb9, 0x01, 0x4a, 0x13, 0x06,
-  0x00, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
-  0xff, 0xe3, 0x03, 0xc3, 0x06, 0x1f, 0x10, 0x26, 0x02, 0x9a, 0x47, 0xd7,
-  0x13, 0x06, 0x00, 0x44, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0xfe, 0x75, 0x05, 0x15, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x9d, 0x02, 0x9a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
-  0xfe, 0x75, 0x04, 0x0d, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x9d, 0x01, 0x92, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa4, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x26, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xec, 0x04, 0xa8, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0x84, 0x06, 0x66, 0x12, 0x26, 0x00, 0x46, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x76, 0x7b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa4, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0xc4,
-  0x01, 0x75, 0x13, 0x06, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x46, 0x00, 0x00, 0x10, 0x07, 0x02, 0x88, 0x00, 0x94, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x07, 0x50, 0x10, 0x27,
-  0x10, 0xf3, 0x04, 0xc4, 0x01, 0x75, 0x12, 0x06, 0x00, 0x26, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x06, 0x14, 0x10, 0x27,
-  0x02, 0xb8, 0x04, 0x2d, 0x00, 0x00, 0x12, 0x06, 0x00, 0x46, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x07, 0x6d, 0x12, 0x26,
-  0x00, 0x26, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x04, 0xa8, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x46, 0x00, 0x00, 0x10, 0x06, 0x02, 0x89,
-  0x7b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x1f,
-  0x07, 0x6d, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x6e, 0x01, 0x75, 0x12, 0x06,
-  0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x05, 0x46,
-  0x06, 0x14, 0x12, 0x26, 0x00, 0x47, 0x00, 0x00, 0x11, 0x07, 0x10, 0xea,
-  0x04, 0x92, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x09,
-  0x00, 0x00, 0x05, 0x28, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x92, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x76, 0x06, 0x14, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x33, 0x15,
-  0x33, 0x15, 0x23, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
-  0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0xfe, 0xdb, 0x01, 0x25, 0xa6,
-  0x8a, 0x8a, 0xa6, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f,
-  0xfe, 0x00, 0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x03, 0xb6,
-  0x01, 0x4e, 0x7d, 0x93, 0x93, 0x7d, 0xfa, 0xfc, 0xa8, 0x64, 0x61, 0x01,
-  0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0xfe, 0x15, 0xcb, 0xe7,
-  0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x33, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x71, 0x00, 0x91, 0x01, 0x3d, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x05, 0xf6, 0x10, 0x27, 0x00, 0x71, 0x00, 0x87,
-  0x00, 0x00, 0x13, 0x06, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xf2, 0x04, 0x2a, 0x01, 0x75, 0x13, 0x06, 0x00, 0x28, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
-  0x06, 0x48, 0x10, 0x27, 0x02, 0x9a, 0x00, 0x87, 0x00, 0x00, 0x13, 0x06,
-  0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x28,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x04, 0x21,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x75, 0x04, 0x19, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x9d, 0x01, 0x9e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x75, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x9d, 0x01, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x67, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xf0, 0x04, 0x2f, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x61, 0x12, 0x26,
-  0x00, 0x48, 0x00, 0x00, 0x11, 0x07, 0x02, 0x89, 0x00, 0x85, 0xff, 0xfb,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe,
-  0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0xd3, 0x01, 0x75, 0x13, 0x06,
-  0x00, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x03, 0xeb, 0x06, 0x66, 0x10, 0x26, 0x02, 0x88, 0x5e, 0x00,
-  0x13, 0x06, 0x00, 0x4a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xfe, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x2a, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf2, 0x04, 0x98, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x03, 0xeb, 0x06, 0x48, 0x12, 0x26, 0x00, 0x4a, 0x00, 0x00,
-  0x10, 0x06, 0x02, 0x9a, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xfe, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0xd3,
-  0x01, 0x75, 0x13, 0x06, 0x00, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27,
-  0x02, 0xb8, 0x03, 0xf9, 0x00, 0x00, 0x12, 0x06, 0x00, 0x4a, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xfe, 0x01, 0x04, 0xfe, 0x05, 0xf0, 0x10, 0x27,
-  0x02, 0xd7, 0x04, 0xd4, 0xff, 0xed, 0x12, 0x06, 0x00, 0x2a, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb, 0x06, 0x34, 0x10, 0x27,
-  0x02, 0xc3, 0x03, 0x7c, 0x01, 0x0c, 0x12, 0x06, 0x00, 0x4a, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xef, 0x04, 0x82, 0x01, 0x75, 0x13, 0x06, 0x00, 0x2b, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe7, 0x00, 0x00, 0x03, 0xf4,
-  0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x02, 0xc7, 0x01, 0x75, 0x13, 0x06,
-  0x00, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0xe4, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x21, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23, 0x11, 0x23,
-  0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x17, 0x15, 0x21, 0x35,
-  0x01, 0x4c, 0xb6, 0x02, 0x94, 0xb6, 0x98, 0x98, 0xb6, 0xfd, 0x6c, 0xb6,
-  0x97, 0x97, 0xb6, 0x02, 0x94, 0x05, 0xd5, 0xe0, 0xe0, 0xe0, 0xa4, 0xfb,
-  0xaf, 0x02, 0xc7, 0xfd, 0x39, 0x04, 0x51, 0xa4, 0xa4, 0xe0, 0xe0, 0x00,
-  0x00, 0x01, 0x00, 0x6c, 0x00, 0x00, 0x04, 0x29, 0x06, 0x14, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x21, 0x15, 0x21,
-  0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x04, 0x29, 0xa6, 0x6f, 0x70, 0x86,
-  0x9b, 0xa7, 0x70, 0x70, 0xa7, 0x01, 0x3d, 0xfe, 0xc3, 0x3b, 0xa2, 0x69,
-  0xad, 0xb3, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4,
-  0xfd, 0x87, 0x04, 0xf6, 0xa4, 0x7a, 0x7a, 0xa4, 0xfe, 0xbc, 0x65, 0x64,
-  0xef, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe6, 0x00, 0x00, 0x02, 0x39,
-  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x02, 0xdd, 0x01, 0x75, 0x13, 0x06,
-  0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xd7,
-  0x00, 0x00, 0x02, 0x2a, 0x06, 0x37, 0x10, 0x27, 0x02, 0x9e, 0xff, 0x34,
-  0x00, 0x00, 0x13, 0x06, 0x00, 0xf3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x02, 0x1d, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0xff, 0x43, 0x01, 0x3b, 0x13, 0x06, 0x00, 0x2c, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf3, 0x00, 0x00, 0x02, 0x0e,
-  0x05, 0xf5, 0x10, 0x27, 0x00, 0x71, 0xff, 0x34, 0xff, 0xff, 0x13, 0x06,
-  0x00, 0xf3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf6,
-  0x00, 0x00, 0x02, 0x2a, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x02, 0xdd,
-  0x01, 0x75, 0x13, 0x06, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xe6, 0x00, 0x00, 0x02, 0x1b, 0x06, 0x48, 0x10, 0x27,
-  0x02, 0x9a, 0xff, 0x34, 0x00, 0x00, 0x13, 0x06, 0x00, 0xf3, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xfe, 0x75, 0x01, 0xef,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0x9d, 0xff, 0x74, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0xfe, 0x75, 0x01, 0xd7,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0x9d, 0xff, 0x5c, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6d,
-  0x07, 0x50, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf3,
-  0x02, 0xde, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
-  0x00, 0x00, 0x01, 0x54, 0x04, 0x7b, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x23, 0x13, 0xae, 0xa5, 0xa5, 0x52, 0x04, 0x60, 0xfb,
-  0xa0, 0x04, 0x7b, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x66, 0x03, 0x8b,
-  0x05, 0xd5, 0x10, 0x27, 0x00, 0x2d, 0x02, 0x20, 0x00, 0x00, 0x11, 0x06,
-  0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0xfe, 0x56, 0x03, 0x53, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x01, 0xff,
-  0x00, 0x00, 0x11, 0x06, 0x00, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xa0, 0xfe, 0x66, 0x02, 0x23, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xef, 0x02, 0xdd, 0x01, 0x75, 0x13, 0x06, 0x00, 0x2d, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x02, 0x20,
-  0x06, 0x66, 0x10, 0x27, 0x02, 0x88, 0xff, 0x34, 0x00, 0x00, 0x13, 0x06,
-  0x01, 0xf9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x1e, 0x04, 0xe0, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x98,
-  0x00, 0x0a, 0x12, 0x06, 0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x1e, 0x04, 0x26, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x35,
-  0x00, 0x0a, 0x12, 0x06, 0x00, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x26, 0x04, 0x60, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xa7, 0x01,
-  0xee, 0xd4, 0xfd, 0xe9, 0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa7, 0x04, 0x60,
-  0xfe, 0x1b, 0x01, 0xe5, 0xfd, 0xf2, 0xfd, 0xae, 0x02, 0x21, 0xfd, 0xdf,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x07, 0x6c, 0x10, 0x27,
-  0x10, 0xec, 0x03, 0x16, 0x01, 0x76, 0x12, 0x06, 0x00, 0x2f, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x02, 0x10, 0x07, 0x6c, 0x10, 0x27,
-  0x10, 0xec, 0x03, 0x04, 0x01, 0x76, 0x13, 0x06, 0x00, 0x4f, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x1e, 0x03, 0xf9,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x25, 0x00, 0x0a, 0x12, 0x06,
-  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7a, 0xfe, 0x1e, 0x01, 0x83,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0xd7, 0x02, 0xce, 0x00, 0x0a, 0x13, 0x06,
-  0x00, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x27, 0x10, 0xea, 0x02, 0x5c,
-  0xff, 0xc3, 0x12, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0x00, 0x00, 0x02, 0xb4, 0x06, 0x14, 0x10, 0x27, 0x10, 0xea, 0x02, 0x00,
-  0x00, 0x02, 0x11, 0x06, 0x00, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x27,
-  0x00, 0x79, 0x01, 0xf9, 0x00, 0x77, 0x12, 0x06, 0x00, 0x2f, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x02, 0x44, 0x06, 0x14, 0x10, 0x27,
-  0x00, 0x79, 0x00, 0xc1, 0x00, 0x73, 0x11, 0x06, 0x00, 0x4f, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xf3, 0x00, 0x00, 0x04, 0x03,
-  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x25, 0x17, 0x01,
-  0x11, 0x21, 0x15, 0x21, 0x11, 0x07, 0x27, 0x37, 0xbe, 0xb7, 0x01, 0x19,
-  0x48, 0xfe, 0x9f, 0x02, 0x8e, 0xfc, 0xbb, 0x85, 0x46, 0xcb, 0x05, 0xd5,
-  0xfd, 0x98, 0xdb, 0x6f, 0xfe, 0xee, 0xfd, 0xe3, 0xaa, 0x02, 0x3b, 0x6a,
-  0x6e, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x02, 0x0e,
-  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x37, 0x17, 0x07,
-  0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0xb3, 0xa6, 0x70, 0x45, 0xb5, 0xa6,
-  0x6f, 0x42, 0xb1, 0x06, 0x14, 0xfd, 0xa6, 0x5a, 0x6a, 0x8d, 0xfc, 0xe3,
-  0x02, 0x9a, 0x58, 0x6a, 0x8d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xae, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x4b,
-  0x01, 0x76, 0x13, 0x06, 0x00, 0x31, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4, 0x06, 0x6d, 0x10, 0x26,
-  0x00, 0x76, 0x3c, 0x07, 0x13, 0x06, 0x00, 0x51, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x1e, 0x04, 0xae, 0x05, 0xd5, 0x10, 0x27,
-  0x02, 0xd7, 0x04, 0x80, 0x00, 0x0a, 0x12, 0x06, 0x00, 0x31, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x1e, 0x03, 0xf4, 0x04, 0x7b, 0x10, 0x27,
-  0x02, 0xd7, 0x04, 0x1c, 0x00, 0x0a, 0x12, 0x06, 0x00, 0x51, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x5f, 0x12, 0x26,
-  0x00, 0x31, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x04, 0x76, 0x01, 0x67,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89,
-  0x7f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb8, 0x00, 0x00, 0x05, 0x27,
-  0x05, 0xd5, 0x10, 0x27, 0x00, 0x51, 0x01, 0x33, 0x00, 0x00, 0x10, 0x06,
-  0x02, 0x7e, 0x18, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x97,
-  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x10, 0x21, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12, 0x19,
-  0x01, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x03,
-  0xe2, 0xfe, 0xeb, 0xa1, 0xc1, 0xb6, 0xb6, 0x46, 0x5e, 0x60, 0x89, 0xcd,
-  0xd1, 0x49, 0x49, 0xa3, 0x4e, 0x2c, 0x5c, 0x47, 0x03, 0x7f, 0x01, 0xac,
-  0xff, 0xde, 0xfc, 0xb2, 0x05, 0xd5, 0xf1, 0x86, 0x43, 0x43, 0xfe, 0xc1,
-  0xfe, 0xcc, 0xfc, 0x6f, 0xd5, 0x61, 0x60, 0x9c, 0x5a, 0xa0, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x04, 0x7b, 0x00, 0x1f,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23,
-  0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x03, 0xf4,
-  0x4a, 0x49, 0xa3, 0xe5, 0xd2, 0x5f, 0x22, 0x22, 0x70, 0x6f, 0x86, 0x9b,
-  0xa7, 0xa7, 0x3b, 0x50, 0x51, 0x6a, 0xad, 0x59, 0x5a, 0x02, 0xa4, 0xfd,
-  0x48, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x02, 0xb2, 0x9f, 0x9e,
-  0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x01, 0x0a, 0x01, 0x3b, 0x13, 0x06, 0x00, 0x32, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x05, 0xf5, 0x10, 0x26, 0x00, 0x71, 0x68, 0xff, 0x13, 0x06, 0x00, 0x52,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x04, 0xa3, 0x01, 0x75, 0x13, 0x06,
-  0x00, 0x32, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x48, 0x10, 0x26, 0x02, 0x9a, 0x68, 0x00,
-  0x13, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6b, 0x10, 0x27, 0x10, 0xf4, 0x04, 0xa3,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x27, 0x02, 0x9f, 0x00, 0x90,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x02, 0x00, 0x67,
-  0x00, 0x00, 0x07, 0x3e, 0x05, 0xd5, 0x00, 0x10, 0x00, 0x19, 0x00, 0x00,
-  0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x17, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x33, 0x07, 0x2e, 0xfd, 0x64, 0x02, 0x80, 0xfd, 0x80, 0x02, 0xac,
-  0xfc, 0x42, 0xfe, 0x7a, 0xfe, 0x6e, 0x01, 0x92, 0x01, 0x86, 0x5c, 0x74,
-  0xfe, 0xdf, 0xfe, 0xe0, 0x01, 0x20, 0x01, 0x21, 0x74, 0x05, 0xd5, 0xaa,
-  0xfe, 0x46, 0xaa, 0xfd, 0xe3, 0xaa, 0x01, 0x7c, 0x01, 0x70, 0x01, 0x6d,
-  0x01, 0x7c, 0xaa, 0xfe, 0xe1, 0xfe, 0xe0, 0xfe, 0xdf, 0xfe, 0xdf, 0x00,
-  0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x06, 0xfd, 0x04, 0x7b, 0x00, 0x06,
-  0x00, 0x27, 0x00, 0x33, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x07, 0x05, 0x15, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10,
-  0x12, 0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x25, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x06, 0x56,
-  0x02, 0x94, 0x7b, 0x8a, 0xa6, 0x0d, 0x02, 0xf4, 0xfd, 0x07, 0x0b, 0xb7,
-  0xa5, 0x5f, 0xb4, 0x59, 0x5a, 0xbc, 0x5f, 0x90, 0xda, 0x49, 0x40, 0xbc,
-  0x7e, 0xd9, 0xf5, 0xf5, 0xd9, 0x7e, 0xbe, 0x3c, 0x46, 0xd1, 0x80, 0xcc,
-  0xed, 0xfb, 0x38, 0x85, 0x9b, 0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x02, 0x94,
-  0x98, 0xb3, 0xae, 0x9e, 0x35, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a,
-  0x2c, 0x6e, 0x6d, 0x6e, 0x6d, 0x01, 0x39, 0x01, 0x13, 0x01, 0x14, 0x01,
-  0x38, 0x6f, 0x6c, 0x6b, 0x70, 0xfe, 0xdd, 0x87, 0xe7, 0xc9, 0xc9, 0xe7,
-  0xe8, 0xc8, 0xc7, 0xe9, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
-  0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x20, 0x01, 0x76, 0x12, 0x06,
-  0x00, 0x35, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x39,
-  0x06, 0x6d, 0x10, 0x26, 0x00, 0x76, 0x3b, 0x07, 0x12, 0x06, 0x00, 0x55,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x1e, 0x04, 0xcc,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x8e, 0x00, 0x0a, 0x12, 0x06,
-  0x00, 0x35, 0x00, 0x00, 0xff, 0xff, 0x00, 0x75, 0xfe, 0x1e, 0x02, 0xf6,
-  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd7, 0x02, 0xc9, 0x00, 0x0a, 0x12, 0x06,
-  0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
-  0x07, 0x5f, 0x12, 0x26, 0x00, 0x35, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0,
-  0x04, 0x0a, 0x01, 0x67, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0x05, 0x06, 0x66, 0x12, 0x26, 0x00, 0x55, 0x00, 0x00,
-  0x11, 0x06, 0x02, 0x89, 0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x20,
-  0x01, 0x76, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
-  0xff, 0xe3, 0x03, 0x67, 0x06, 0x6d, 0x10, 0x26, 0x00, 0x76, 0x3c, 0x07,
-  0x12, 0x06, 0x00, 0x56, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0x1e,
-  0x01, 0x75, 0x13, 0x06, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x06, 0x66, 0x10, 0x26,
-  0x02, 0x88, 0x21, 0x00, 0x13, 0x06, 0x00, 0x56, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x79, 0xfe, 0x75, 0x04, 0x2c, 0x05, 0xf0, 0x12, 0x26,
-  0x00, 0x36, 0x00, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x7d, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xfe, 0x75, 0x03, 0x67, 0x04, 0x7b, 0x12, 0x26,
-  0x00, 0x56, 0x00, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x15, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6d, 0x12, 0x26,
-  0x00, 0x36, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x04, 0x17, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x56, 0x00, 0x00, 0x11, 0x07, 0x02, 0xbd,
-  0x03, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
-  0xfe, 0x75, 0x04, 0x6c, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x7a, 0x48, 0x00,
-  0x12, 0x06, 0x00, 0x37, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31,
-  0xfe, 0x75, 0x02, 0xa7, 0x05, 0x9e, 0x10, 0x26, 0x00, 0x7a, 0xe4, 0x00,
-  0x12, 0x06, 0x00, 0x57, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
-  0x00, 0x00, 0x04, 0x6c, 0x07, 0x5f, 0x12, 0x26, 0x00, 0x37, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xf0, 0x04, 0x01, 0x01, 0x67, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x31, 0x00, 0x00, 0x02, 0xb2, 0x06, 0x82, 0x12, 0x26,
-  0x00, 0x57, 0x00, 0x00, 0x11, 0x07, 0x10, 0xea, 0x01, 0xfe, 0x00, 0x70,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x33,
-  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x21, 0x05, 0x04,
-  0x70, 0xfe, 0x23, 0xef, 0xef, 0xb6, 0xef, 0xef, 0xfe, 0x23, 0x05, 0xd5,
-  0xaa, 0xfd, 0xc0, 0xaa, 0xfd, 0xbf, 0x02, 0x41, 0xaa, 0x02, 0x40, 0x00,
-  0x00, 0x01, 0x00, 0x31, 0x00, 0x00, 0x02, 0xa7, 0x05, 0x9e, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15,
-  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01,
-  0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55,
-  0xfe, 0xab, 0x01, 0x55, 0xfe, 0xab, 0x21, 0x22, 0x67, 0xab, 0xab, 0xbf,
-  0x49, 0x49, 0x79, 0x79, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2, 0x8f, 0xe9,
-  0x8e, 0xe9, 0x89, 0x27, 0x27, 0x9a, 0x50, 0x4f, 0xd2, 0xe9, 0x8e, 0xe9,
-  0x8f, 0x01, 0x3e, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0x70, 0x01, 0x75, 0x13, 0x06,
-  0x00, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c,
-  0xff, 0xe3, 0x03, 0xe9, 0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x76, 0x00,
-  0x13, 0x06, 0x00, 0x58, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
-  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x31, 0x10, 0x27, 0x00, 0x71, 0x00, 0xd6,
-  0x01, 0x3b, 0x13, 0x06, 0x00, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x05, 0xf5, 0x10, 0x26,
-  0x00, 0x71, 0x76, 0xff, 0x13, 0x06, 0x00, 0x58, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xf2, 0x04, 0x70, 0x01, 0x75, 0x13, 0x06, 0x00, 0x38, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
-  0x06, 0x48, 0x10, 0x26, 0x02, 0x9a, 0x76, 0x00, 0x13, 0x06, 0x00, 0x58,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x07, 0x6f, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9c,
-  0x00, 0xd8, 0x00, 0x69, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
-  0x06, 0xca, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x02, 0x9c,
-  0x70, 0xc4, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x07, 0x6b, 0x10, 0x27, 0x10, 0xf4, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
-  0x00, 0x38, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xef,
-  0x06, 0x66, 0x10, 0x27, 0x02, 0x9f, 0x00, 0x9e, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x75, 0x04, 0xa5,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9d,
-  0x00, 0xe1, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x75, 0x04, 0x6b,
-  0x04, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9d,
-  0x01, 0xf0, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
-  0x07, 0x74, 0x10, 0x27, 0x10, 0xef, 0x05, 0x5c, 0x01, 0x7c, 0x13, 0x06,
-  0x00, 0x3a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d,
-  0x00, 0x00, 0x05, 0x97, 0x06, 0x6d, 0x10, 0x27, 0x02, 0x88, 0x01, 0x24,
-  0x00, 0x07, 0x13, 0x06, 0x00, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x07, 0x74, 0x10, 0x27,
-  0x10, 0xef, 0x04, 0x00, 0x01, 0x7c, 0x13, 0x06, 0x00, 0x3c, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x06, 0x6d, 0x10, 0x26, 0x02, 0x88, 0x55, 0x07, 0x13, 0x06, 0x00, 0x5c,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
-  0x07, 0x4e, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb,
-  0x04, 0x01, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
-  0x00, 0x00, 0x04, 0x9c, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x20,
-  0x01, 0x76, 0x12, 0x06, 0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
-  0x00, 0x00, 0x03, 0x79, 0x06, 0x6d, 0x10, 0x26, 0x00, 0x76, 0x3c, 0x07,
-  0x12, 0x06, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
-  0x00, 0x00, 0x04, 0x9c, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x45,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
-  0x00, 0x00, 0x03, 0x79, 0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xae,
-  0x00, 0x00, 0x13, 0x06, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x07, 0x6d, 0x12, 0x26,
-  0x00, 0x3d, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf0, 0x04, 0x45, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x5d, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89, 0x18, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac, 0x06, 0x14, 0x00, 0x10,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x01, 0x6f, 0xa6, 0x9f, 0x9f,
-  0x9c, 0xaa, 0x9d, 0x9e, 0x5a, 0x22, 0x23, 0x03, 0xd1, 0x8f, 0x4e, 0xbb,
-  0xab, 0x99, 0x28, 0x29, 0x67, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x1c,
-  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x0f, 0x00, 0x2c, 0x00, 0x00,
-  0x01, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x15, 0x23, 0x11,
-  0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x21, 0x15, 0x21, 0x03, 0x81, 0x4b,
-  0x4b, 0x83, 0x84, 0x4b, 0x4b, 0x4b, 0x4b, 0x84, 0x83, 0x4b, 0x4b, 0xfd,
-  0xcd, 0x34, 0x50, 0x4f, 0x6f, 0xb8, 0x72, 0x73, 0x73, 0x72, 0xb8, 0x6f,
-  0x4f, 0x50, 0x34, 0xa7, 0x8a, 0x8a, 0xa7, 0x01, 0x24, 0xfe, 0xdc, 0x02,
-  0x2f, 0xcb, 0x74, 0x73, 0x73, 0x74, 0xcb, 0xcb, 0x74, 0x73, 0x73, 0x74,
-  0x02, 0x52, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0xfe, 0xf8, 0xfe, 0xf8, 0xa2,
-  0xa2, 0x31, 0x30, 0x64, 0xa8, 0x05, 0x04, 0x7d, 0x93, 0x93, 0x7d, 0x00,
-  0x00, 0x03, 0xff, 0xa1, 0x00, 0x00, 0x04, 0xc8, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x11, 0x00, 0x29, 0x00, 0x00, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14,
-  0x06, 0x23, 0x21, 0x11, 0x22, 0x06, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x36,
-  0x01, 0xc5, 0x01, 0x23, 0x93, 0x8d, 0x8d, 0x93, 0xfe, 0xdd, 0x01, 0x0d,
-  0x85, 0x83, 0x83, 0x85, 0xfe, 0x3d, 0x01, 0xd0, 0xd0, 0xe1, 0x73, 0x70,
-  0x87, 0x94, 0xf5, 0xe2, 0xfe, 0x1e, 0x77, 0x6a, 0x8c, 0xac, 0x02, 0xc9,
-  0xfd, 0xdd, 0x87, 0x8b, 0x8c, 0x85, 0x02, 0x66, 0xfe, 0x3e, 0x6f, 0x72,
-  0x71, 0x70, 0xa6, 0xc0, 0xb1, 0x89, 0xa2, 0x14, 0x20, 0xcb, 0x98, 0xc8,
-  0xda, 0x05, 0x30, 0x5f, 0x69, 0x31, 0x46, 0xb5, 0xa3, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x06,
-  0x03, 0xa5, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0xe3, 0x04, 0x2e,
-  0x06, 0x14, 0x00, 0x16, 0x00, 0x26, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x15, 0x23, 0x11, 0x21, 0x15, 0x25, 0x01, 0x34, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x01,
-  0x4e, 0x34, 0x50, 0x4f, 0x6f, 0xb8, 0x72, 0x73, 0x73, 0x72, 0xb8, 0x6f,
-  0x4f, 0x50, 0x34, 0xa7, 0x02, 0xfa, 0xfd, 0xad, 0x02, 0x33, 0x4b, 0x4b,
-  0x83, 0x84, 0x4b, 0x4b, 0x4b, 0x4b, 0x84, 0x83, 0x4b, 0x4b, 0x03, 0xb6,
-  0x64, 0x30, 0x31, 0xa2, 0xa2, 0xfe, 0xf8, 0xfe, 0xf8, 0xa2, 0xa2, 0x31,
-  0x30, 0x64, 0xa8, 0x06, 0x14, 0xa6, 0x01, 0xfc, 0xc0, 0xcb, 0x74, 0x73,
-  0x73, 0x74, 0xcb, 0xcb, 0x74, 0x73, 0x73, 0x74, 0x00, 0x02, 0x00, 0x00,
-  0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11, 0x21, 0x32, 0x37, 0x36, 0x01,
-  0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x23, 0x01,
-  0x03, 0xae, 0x47, 0x46, 0x93, 0xfe, 0xdd, 0x01, 0x23, 0x93, 0x46, 0x47,
-  0xfd, 0xbd, 0x01, 0x2c, 0xe2, 0xf5, 0xf5, 0xe2, 0xfe, 0x1e, 0xb5, 0x01,
-  0x19, 0x01, 0xb7, 0x8b, 0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x04, 0xa8,
-  0xfd, 0x9a, 0xda, 0xde, 0xdd, 0xda, 0x04, 0x44, 0x01, 0x91, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x00, 0xff, 0xe3, 0x04, 0x2e, 0x06, 0x15, 0x00, 0x12,
-  0x00, 0x1e, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10,
-  0x02, 0x23, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x23, 0x01, 0x33, 0x01,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x01,
-  0x4e, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xa7,
-  0xa7, 0x01, 0x05, 0x49, 0x02, 0x33, 0x96, 0x83, 0x84, 0x96, 0x96, 0x84,
-  0x83, 0x96, 0x03, 0xb6, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
-  0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x04, 0x44, 0x01, 0xd1, 0xfc, 0x1a, 0xcb,
-  0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x19, 0x00, 0x00, 0x13, 0x3e,
-  0x01, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x22, 0x26, 0x27, 0x35,
-  0x1e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x06, 0x07,
-  0x68, 0x5d, 0xd5, 0x79, 0x01, 0x31, 0x01, 0x5f, 0xfe, 0xa1, 0xfe, 0xcf,
-  0x77, 0xd5, 0x5f, 0x5b, 0xd0, 0x75, 0xe7, 0xf4, 0xf4, 0xe7, 0x75, 0xd0,
-  0x5b, 0x05, 0x62, 0x47, 0x47, 0xfe, 0x61, 0xfe, 0x98, 0xfe, 0x99, 0xfe,
-  0x61, 0x48, 0x48, 0xd3, 0x5f, 0x5e, 0x01, 0x39, 0x01, 0x27, 0x01, 0x28,
-  0x01, 0x39, 0x5e, 0x5f, 0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x05, 0xb8,
-  0x07, 0x64, 0x00, 0x24, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x17, 0x16, 0x17, 0x36, 0x37,
-  0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x04, 0xa3, 0x5c, 0xd0, 0x75,
-  0xe6, 0xf5, 0xf5, 0xe6, 0x75, 0xd0, 0x5c, 0x5f, 0xd6, 0x76, 0xfe, 0xce,
-  0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x32, 0x56, 0x8c, 0x0c, 0x0b, 0x0e, 0x4b,
-  0x5c, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x05, 0x62, 0xd5, 0x5f, 0x5e, 0xfe,
-  0xc7, 0xfe, 0xd8, 0xfe, 0xd9, 0xfe, 0xc7, 0x5e, 0x5f, 0xd3, 0x48, 0x48,
-  0x01, 0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f, 0x24, 0x03, 0x04, 0xc3,
-  0x62, 0x7a, 0xaa, 0x96, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x52,
-  0x06, 0x14, 0x00, 0x22, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x17, 0x35, 0x34, 0x36, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x06, 0x03, 0x83, 0x46, 0x8d, 0x48, 0xa2, 0xb2,
-  0xb2, 0xa2, 0x48, 0x8d, 0x46, 0x45, 0x95, 0x53, 0xe4, 0xfe, 0xf4, 0x01,
-  0x0f, 0xeb, 0x40, 0x3f, 0x91, 0xa3, 0x3e, 0x2b, 0x5e, 0x45, 0x04, 0x7e,
-  0xf5, 0x2b, 0x2b, 0xe3, 0xcd, 0xcd, 0xe3, 0x2b, 0x2b, 0xaa, 0x24, 0x24,
-  0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x3a, 0x0c, 0x0f, 0xd6, 0xc0,
-  0x9c, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x09, 0x00, 0x00, 0x05, 0x28,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x92, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa1,
-  0x00, 0x00, 0x05, 0x79, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x1a, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x25, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x11, 0x22, 0x06, 0x1d, 0x01, 0x23,
-  0x35, 0x34, 0x36, 0x01, 0xc5, 0xdb, 0x01, 0x16, 0x01, 0x03, 0xfe, 0xfd,
-  0xfe, 0xea, 0xfe, 0x6f, 0x01, 0x75, 0x01, 0x87, 0x01, 0x6d, 0xfe, 0x91,
-  0xfe, 0x7b, 0xfe, 0x8b, 0x77, 0x6a, 0x8c, 0xac, 0x05, 0x2f, 0xfb, 0x77,
-  0x01, 0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17, 0xa6, 0xfe, 0x97, 0xfe,
-  0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x05, 0x30, 0x5f, 0x69, 0x31, 0x46, 0xb5,
-  0xa3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e,
-  0x05, 0xd5, 0x00, 0x07, 0x00, 0x14, 0x00, 0x00, 0x01, 0x10, 0x29, 0x01,
-  0x11, 0x21, 0x22, 0x06, 0x11, 0x21, 0x11, 0x21, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x33, 0x21, 0x11, 0x21, 0x01, 0x75, 0x01, 0x20, 0x01, 0x23, 0xfe,
-  0xdd, 0x93, 0x8d, 0x02, 0xf9, 0xfe, 0x1e, 0xe2, 0xf5, 0xf5, 0xe2, 0x01,
-  0x2c, 0xfd, 0xbd, 0x01, 0xb7, 0xfe, 0xef, 0x02, 0x23, 0x87, 0x03, 0x93,
-  0xfa, 0x2b, 0xda, 0xde, 0xdd, 0xda, 0x01, 0xc0, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0xeb, 0x06, 0x14, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x00,
-  0x13, 0x35, 0x21, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
-  0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x11, 0x01, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0xf2, 0x02, 0xf9, 0xa6, 0x34,
-  0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0xfd, 0xcc, 0x96,
-  0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x05, 0x6e, 0xa6, 0xf9, 0xec,
-  0xa8, 0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61,
-  0x64, 0x01, 0xb9, 0xfc, 0xc0, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7,
-  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x02, 0x04, 0x63, 0x00, 0x19,
-  0x00, 0x27, 0x00, 0x00, 0x25, 0x16, 0x15, 0x10, 0x21, 0x22, 0x27, 0x35,
-  0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x11, 0x10, 0x12,
-  0x33, 0x32, 0x12, 0x03, 0x14, 0x02, 0x03, 0x36, 0x26, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x3e, 0x01, 0x03, 0x14, 0x8d, 0xfe,
-  0x73, 0xc7, 0x6c, 0x5c, 0xdd, 0xde, 0xee, 0xbb, 0x69, 0x80, 0xf6, 0xd8,
-  0xd7, 0xf8, 0x01, 0x8c, 0x23, 0x01, 0x9a, 0x85, 0x85, 0x9b, 0xa9, 0x72,
-  0x39, 0x2e, 0x59, 0x63, 0x42, 0x4f, 0x8d, 0xfe, 0xf0, 0x46, 0x99, 0x46,
-  0x75, 0x5c, 0x30, 0x25, 0x70, 0x87, 0x01, 0x0f, 0x01, 0x0f, 0x01, 0x39,
-  0xfe, 0xc7, 0xfe, 0xed, 0x9c, 0xfe, 0xfc, 0x01, 0xa0, 0xcb, 0xe5, 0xe8,
-  0xc3, 0xc2, 0xc7, 0x0b, 0x06, 0x0e, 0x2a, 0xdc, 0x00, 0x01, 0x00, 0x75,
-  0x00, 0x00, 0x03, 0xd8, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x03, 0xd8,
-  0xfc, 0x9e, 0x02, 0xac, 0xfd, 0x80, 0x02, 0x80, 0xfd, 0x64, 0x05, 0xd5,
-  0xfa, 0x2b, 0xaa, 0x02, 0x1d, 0xaa, 0x01, 0xba, 0xaa, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x69, 0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x13,
-  0x00, 0x1a, 0x00, 0x00, 0x13, 0x21, 0x10, 0x02, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x37, 0x16, 0x12, 0x33, 0x32, 0x12, 0x37, 0x69, 0x04, 0x1b, 0xf8, 0xf6,
-  0x7e, 0xe2, 0x65, 0x64, 0xec, 0x84, 0x01, 0x3b, 0x01, 0x63, 0xfe, 0xae,
-  0xfe, 0xe5, 0xfe, 0xd8, 0xfe, 0xbb, 0xc6, 0x0c, 0xe5, 0xb6, 0xb6, 0xe6,
-  0x0b, 0x03, 0x0c, 0x01, 0x0c, 0x01, 0x32, 0x60, 0x5f, 0xd7, 0x46, 0x48,
-  0xfe, 0x67, 0xfe, 0x92, 0xfe, 0x9f, 0xfe, 0x5b, 0x01, 0xb7, 0xcc, 0xc3,
-  0xfe, 0xe4, 0x01, 0x1c, 0xc3, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x93,
-  0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x01, 0x2e,
-  0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23,
-  0x22, 0x06, 0x15, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x24,
-  0x35, 0x34, 0x36, 0x01, 0xa9, 0x76, 0x80, 0xf1, 0xcf, 0x50, 0xb5, 0x68,
-  0x67, 0xab, 0x4a, 0x89, 0x93, 0x8e, 0x86, 0xa4, 0x9c, 0x95, 0xa7, 0xb4,
-  0xab, 0x62, 0xb4, 0x4b, 0x5f, 0xb3, 0x55, 0xfc, 0xfe, 0xef, 0x92, 0x03,
-  0x25, 0x21, 0xab, 0x7c, 0xb2, 0xd1, 0x20, 0x20, 0xb4, 0x26, 0x24, 0x7b,
-  0x73, 0x70, 0x77, 0xa6, 0x95, 0x84, 0x8f, 0x96, 0x32, 0x31, 0xc3, 0x25,
-  0x25, 0xf2, 0xdd, 0x90, 0xc4, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xa0,
-  0xfe, 0x66, 0x03, 0xba, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x36, 0x35, 0xb5, 0x03, 0x04, 0xfd, 0xb2, 0x02, 0x15, 0xfd,
-  0xeb, 0xb9, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x05, 0xd5, 0xaa, 0xfe, 0x48,
-  0xaa, 0xfd, 0x9f, 0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0x8b, 0xfe, 0x56, 0x02, 0xac, 0x06, 0x14, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21,
-  0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x23,
-  0x35, 0x33, 0x35, 0x34, 0x36, 0x33, 0x02, 0xac, 0x9e, 0x5a, 0x45, 0x01,
-  0x11, 0xfe, 0xef, 0x9c, 0xab, 0x9c, 0x9e, 0x59, 0x46, 0x9f, 0x9f, 0x9c,
-  0xaa, 0x06, 0x14, 0x99, 0x50, 0x68, 0x63, 0x8f, 0xfb, 0xeb, 0xbb, 0xab,
-  0x99, 0x50, 0x68, 0x04, 0x2a, 0x8f, 0x4e, 0xbb, 0xab, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x05, 0xef, 0x07, 0x64, 0x00, 0x26,
-  0x00, 0x00, 0x25, 0x11, 0x21, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x34, 0x36, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11,
-  0x10, 0x12, 0x33, 0x32, 0x36, 0x04, 0x49, 0xfe, 0xd7, 0x01, 0xdd, 0x69,
-  0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01, 0x3b, 0x51, 0x93,
-  0x3e, 0xb5, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x65, 0xe3, 0x7d, 0xf6, 0xf8,
-  0xf8, 0xf6, 0x61, 0x97, 0xd5, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53, 0x55,
-  0x01, 0x99, 0x01, 0x6d, 0x01, 0x6e, 0x01, 0x99, 0x19, 0x19, 0xbc, 0xea,
-  0xaa, 0x96, 0xc2, 0xd7, 0x5f, 0x60, 0xfe, 0xce, 0xfe, 0xd1, 0xfe, 0xd2,
-  0xfe, 0xce, 0x25, 0x00, 0x00, 0x02, 0x00, 0x07, 0xfe, 0x52, 0x04, 0xeb,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x25, 0x00, 0x00, 0x01, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x13, 0x01, 0x33, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x33, 0x02, 0x79,
-  0x31, 0x27, 0x19, 0x1c, 0x2e, 0x27, 0x28, 0x2e, 0x1c, 0x19, 0x28, 0x31,
-  0x01, 0xa9, 0xc8, 0xfd, 0xf5, 0x5d, 0x3c, 0x2a, 0x44, 0x5a, 0x8b, 0x8b,
-  0x5b, 0x43, 0x29, 0x3d, 0x5d, 0xfd, 0xf4, 0xc8, 0xfe, 0xfd, 0x20, 0x14,
-  0x42, 0x39, 0x49, 0x79, 0x5c, 0x5c, 0x79, 0x49, 0x39, 0x42, 0x14, 0x20,
-  0x03, 0x7a, 0x03, 0x5e, 0xfb, 0xcf, 0xc8, 0xae, 0x77, 0x42, 0x8b, 0x41,
-  0x57, 0x57, 0x41, 0x8b, 0x42, 0x77, 0xae, 0xc8, 0x04, 0x31, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x8d, 0x06, 0x14, 0x00, 0x2a,
-  0x00, 0x00, 0x25, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x35,
-  0x16, 0x17, 0x16, 0x11, 0x14, 0x00, 0x2b, 0x01, 0x22, 0x26, 0x35, 0x11,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x11, 0x3e,
-  0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x16, 0x33, 0x04, 0xc4, 0x86,
-  0x4c, 0x4e, 0x42, 0x38, 0x6d, 0xca, 0x62, 0x64, 0xfe, 0xfd, 0xc7, 0x3f,
-  0xa9, 0x8d, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0xa1, 0x6a, 0xad,
-  0xb3, 0x44, 0x5e, 0x9c, 0x62, 0x65, 0x9b, 0xde, 0x70, 0x5f, 0x21, 0x94,
-  0x1d, 0x8f, 0x91, 0xfe, 0xec, 0xf5, 0xfe, 0xe6, 0xc8, 0xce, 0x01, 0x08,
-  0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x06, 0x14, 0xfd, 0x9e, 0x65, 0x64,
-  0xef, 0xe8, 0xfe, 0xf2, 0x93, 0x67, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x02, 0x7f, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x11, 0xb5, 0xb6,
-  0x63, 0x78, 0x39, 0x45, 0xcd, 0xb8, 0x05, 0xd5, 0xfc, 0x2d, 0xc2, 0x96,
-  0xaa, 0xf4, 0x01, 0x0e, 0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x02, 0x17,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x15, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0xac, 0xac, 0xb6, 0xac,
-  0xac, 0x05, 0xd5, 0xfd, 0x16, 0xaa, 0xfd, 0xbf, 0x02, 0x41, 0xaa, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x5f, 0x05, 0xf0, 0x00, 0x17,
-  0x00, 0x00, 0x01, 0x23, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x09, 0x01,
-  0x23, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x05, 0x5e, 0x99, 0x41, 0x23, 0x3f, 0x21, 0xfe, 0x14, 0x02,
-  0xca, 0xef, 0xfd, 0x7b, 0xb6, 0xb6, 0x02, 0x2e, 0x4c, 0x66, 0x7a, 0x4d,
-  0x4c, 0x04, 0x48, 0x79, 0x36, 0x50, 0x23, 0xfd, 0xf9, 0xfc, 0xe3, 0x02,
-  0xcf, 0xfd, 0x31, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x43, 0x4f, 0x5c, 0x5b,
-  0x6e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa6, 0x00, 0x00, 0x04, 0x26,
-  0x06, 0x14, 0x00, 0x12, 0x00, 0x00, 0x13, 0x34, 0x36, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x06, 0x15, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
-  0x23, 0xa6, 0x93, 0xa3, 0xac, 0x97, 0x5f, 0x44, 0x01, 0xee, 0xd4, 0xfd,
-  0xe9, 0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa7, 0x04, 0x7e, 0xd6, 0xc0, 0x9c,
-  0x61, 0x99, 0xfd, 0xff, 0x01, 0xe3, 0xfd, 0xf4, 0xfd, 0xac, 0x02, 0x23,
-  0xfd, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x01, 0xf3,
-  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x15, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xae, 0xa5, 0xa0, 0xa0, 0xa5, 0xa5,
-  0xa5, 0x06, 0x14, 0xfd, 0x38, 0x90, 0xfd, 0x44, 0x02, 0xbc, 0x90, 0x00,
-  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x0f,
-  0x00, 0x00, 0x33, 0x01, 0x27, 0x05, 0x27, 0x25, 0x27, 0x33, 0x17, 0x25,
-  0x17, 0x05, 0x01, 0x23, 0x09, 0x01, 0x37, 0x01, 0xba, 0x40, 0xfe, 0xf2,
-  0x1e, 0x01, 0x0b, 0x43, 0xb4, 0x2f, 0x01, 0x1a, 0x1e, 0xfe, 0xe8, 0x01,
-  0xbc, 0xb0, 0xfe, 0xe6, 0xfe, 0xa4, 0x04, 0x32, 0xbc, 0x65, 0x63, 0x63,
-  0xc5, 0x8a, 0x68, 0x61, 0x68, 0xfa, 0xd7, 0x03, 0x3c, 0xfc, 0xc4, 0x00,
-  0x00, 0x01, 0x00, 0xa0, 0xff, 0xe3, 0x06, 0x70, 0x05, 0xd5, 0x00, 0x27,
-  0x00, 0x00, 0x25, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33,
-  0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35,
-  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x03, 0x49, 0x3f, 0xac, 0x75, 0x9e,
-  0x55, 0x56, 0xb7, 0x23, 0x33, 0x6a, 0x80, 0x96, 0xb6, 0x34, 0x33, 0x6b,
-  0x6f, 0x4a, 0x4b, 0xb7, 0xb7, 0x39, 0x9e, 0x6d, 0x6e, 0x4d, 0x4c, 0xd5,
-  0x7c, 0x76, 0x7b, 0x7a, 0xe2, 0x04, 0x1b, 0xfb, 0xef, 0xba, 0x35, 0x4e,
-  0xbe, 0xa4, 0x03, 0xec, 0xfb, 0xef, 0xa2, 0x4e, 0x4d, 0x5f, 0x60, 0xa3,
-  0x03, 0xec, 0xfa, 0x29, 0xae, 0x67, 0x62, 0x3e, 0x3e, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xa0, 0xfe, 0x66, 0x04, 0xae, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11, 0x23, 0x01, 0x11, 0x10,
-  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0xb5, 0xf5, 0x02, 0x54,
-  0xb0, 0xf5, 0xfd, 0xac, 0xb8, 0xcc, 0x40, 0x38, 0x79, 0x63, 0x05, 0xd5,
-  0xfb, 0x1f, 0x04, 0xe1, 0xfa, 0x2b, 0x04, 0xe1, 0xfb, 0x87, 0xfe, 0xf2,
-  0xf4, 0xaa, 0x96, 0xc2, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x04, 0x7b, 0x10, 0x06, 0x03, 0x4b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x19,
-  0x00, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x01, 0x22, 0x02, 0x07, 0x21, 0x26, 0x02, 0x01, 0x1a, 0x01,
-  0x33, 0x32, 0x12, 0x13, 0x68, 0x01, 0x53, 0x01, 0x1b, 0x01, 0x1b, 0x01,
-  0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad, 0x02, 0x6f, 0xb6,
-  0xe6, 0x0b, 0x03, 0x4e, 0x0c, 0xe5, 0xfd, 0x9a, 0x07, 0xe2, 0xc6, 0xc6,
-  0xe0, 0x07, 0x02, 0xe9, 0x01, 0x62, 0x01, 0xa5, 0xfe, 0x5b, 0xfe, 0x9f,
-  0xfe, 0x9e, 0xfe, 0x5b, 0x01, 0xa4, 0x03, 0xc5, 0xfe, 0xe4, 0xc3, 0xc3,
-  0x01, 0x1c, 0xfd, 0x7a, 0xfe, 0xff, 0xfe, 0xc2, 0x01, 0x3d, 0x01, 0x02,
-  0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81, 0x06, 0x14, 0x10, 0x26,
-  0x00, 0x32, 0xf5, 0x00, 0x10, 0x07, 0x02, 0xcc, 0x05, 0x11, 0x01, 0x34,
-  0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58, 0x04, 0xeb, 0x10, 0x27,
-  0x02, 0xcc, 0x03, 0xe9, 0x00, 0x0b, 0x10, 0x06, 0x00, 0x52, 0x04, 0x00,
-  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x06, 0x21, 0x05, 0xf0, 0x00, 0x14,
-  0x00, 0x1f, 0x00, 0x00, 0x21, 0x11, 0x34, 0x26, 0x23, 0x11, 0x06, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x17, 0x21, 0x32, 0x16, 0x19,
-  0x01, 0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x37, 0x11, 0x26,
-  0x05, 0x6b, 0x63, 0x6e, 0xa9, 0xfe, 0xe4, 0xfe, 0xe6, 0xfe, 0xad, 0x01,
-  0x53, 0x01, 0x1b, 0x65, 0x57, 0x01, 0x0a, 0xcc, 0xb9, 0xfc, 0xb5, 0xc6,
-  0xe9, 0xe9, 0xc6, 0x9e, 0x73, 0x7c, 0x03, 0xd3, 0xc2, 0x96, 0xfb, 0x8b,
-  0xd3, 0x01, 0xa4, 0x01, 0x62, 0x01, 0x62, 0x01, 0xa5, 0x1b, 0xf4, 0xfe,
-  0xf2, 0xfc, 0x2d, 0x05, 0x4c, 0xfe, 0xb8, 0xfe, 0xe6, 0xfe, 0xe5, 0xfe,
-  0xb8, 0x67, 0x04, 0x18, 0x46, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0xd1, 0x04, 0x7b, 0x00, 0x16, 0x00, 0x21, 0x00, 0x00,
-  0x01, 0x11, 0x34, 0x27, 0x26, 0x23, 0x11, 0x06, 0x23, 0x22, 0x02, 0x11,
-  0x10, 0x12, 0x33, 0x32, 0x17, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x01,
-  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x11, 0x26, 0x04, 0x2a,
-  0x22, 0x22, 0x5e, 0x7c, 0xd8, 0xd9, 0xf5, 0xf5, 0xd9, 0x5a, 0x4a, 0xc2,
-  0xa3, 0x4a, 0x49, 0xfd, 0x64, 0x85, 0x9b, 0x9a, 0x86, 0x74, 0x3a, 0x4c,
-  0xfe, 0x56, 0x04, 0x74, 0x99, 0x31, 0x30, 0xfc, 0xbc, 0x9d, 0x01, 0x39,
-  0x01, 0x13, 0x01, 0x14, 0x01, 0x38, 0x1b, 0x60, 0x60, 0xd6, 0xfb, 0x8c,
-  0x05, 0x89, 0xe7, 0xc9, 0xc9, 0xe7, 0x3a, 0x02, 0xf0, 0x36, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xa1, 0x00, 0x00, 0x04, 0x73, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23,
-  0x11, 0x22, 0x06, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x36, 0x01, 0xc5, 0xe4,
-  0x7f, 0x8b, 0x8b, 0x7f, 0xfe, 0x66, 0x01, 0x9a, 0xe2, 0xe7, 0xe7, 0xe2,
-  0xe4, 0xb6, 0x77, 0x6a, 0x8c, 0xac, 0x05, 0x2f, 0xfd, 0xcf, 0x92, 0x87,
-  0x86, 0x92, 0xa6, 0xe3, 0xdb, 0xdd, 0xe2, 0xfd, 0xa8, 0x05, 0x30, 0x5f,
-  0x69, 0x31, 0x46, 0xb5, 0xa3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa6,
-  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00,
-  0x25, 0x11, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06,
-  0x1d, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
-  0x26, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x01, 0x4e, 0xa8, 0x93, 0xa3, 0xe5, 0xd0, 0x5f, 0x44, 0x34, 0x9f,
-  0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x01, 0xff, 0x96, 0x83, 0x84,
-  0x96, 0x96, 0x84, 0x83, 0x96, 0xa8, 0xfd, 0xae, 0x06, 0x28, 0xd6, 0xc0,
-  0x9c, 0x61, 0x99, 0xc8, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
-  0xfe, 0xbc, 0x61, 0x01, 0xeb, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7,
-  0x00, 0x02, 0x00, 0xb4, 0xfe, 0xf8, 0x04, 0xcc, 0x05, 0xd5, 0x00, 0x15,
-  0x00, 0x1d, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17, 0x13, 0x23, 0x03, 0x2e,
-  0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x03, 0x32,
-  0x3b, 0x6e, 0x38, 0xb9, 0xc4, 0xac, 0x42, 0x7d, 0x6c, 0xc6, 0xb6, 0xb6,
-  0xe4, 0xe7, 0xe2, 0x75, 0xfd, 0xc8, 0xe4, 0x7f, 0x8b, 0x8a, 0x80, 0x01,
-  0xb4, 0x16, 0x90, 0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96, 0x62, 0xfe, 0x91,
-  0x05, 0xd5, 0xfe, 0xf8, 0xd6, 0xd8, 0x8d, 0xba, 0x02, 0x4f, 0xfd, 0xd1,
-  0x92, 0x01, 0x0c, 0x91, 0x00, 0x01, 0x00, 0x66, 0xff, 0xe3, 0x04, 0x19,
-  0x05, 0xf0, 0x00, 0x21, 0x00, 0x00, 0x13, 0x36, 0x20, 0x16, 0x10, 0x06,
-  0x0f, 0x01, 0x0e, 0x01, 0x14, 0x16, 0x33, 0x32, 0x37, 0x15, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x34,
-  0x27, 0x26, 0x20, 0x07, 0xb8, 0xcd, 0x01, 0x98, 0xfb, 0xb5, 0xcc, 0x6e,
-  0x8b, 0x7a, 0xaa, 0x9b, 0xcb, 0xdf, 0xe9, 0xc1, 0xfd, 0x83, 0x82, 0xc1,
-  0xcc, 0x6d, 0x96, 0x36, 0x35, 0x50, 0x51, 0xfe, 0xc4, 0xcd, 0x05, 0xa4,
-  0x4c, 0xe4, 0xfe, 0x8f, 0xc0, 0x2d, 0x18, 0x1f, 0x7c, 0xec, 0x88, 0x8b,
-  0xd0, 0x5f, 0x70, 0x70, 0xd9, 0xb6, 0xd9, 0x2b, 0x19, 0x1f, 0x32, 0x33,
-  0xd9, 0x40, 0x40, 0x6d, 0x00, 0x01, 0x00, 0x5a, 0xff, 0xe3, 0x03, 0x5d,
-  0x04, 0x7b, 0x00, 0x27, 0x00, 0x00, 0x13, 0x3e, 0x01, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x0f, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3f,
-  0x01, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x90, 0x44,
-  0xa2, 0x5c, 0xba, 0xc9, 0x89, 0x9a, 0x39, 0x9a, 0x5b, 0x7e, 0x75, 0x57,
-  0xb3, 0x5b, 0x61, 0xaf, 0x51, 0xc3, 0xde, 0x94, 0xb1, 0x39, 0x85, 0x58,
-  0x7b, 0x7c, 0x51, 0x97, 0x46, 0x04, 0x3f, 0x1e, 0x1e, 0xac, 0x9e, 0x82,
-  0x95, 0x24, 0x0f, 0x25, 0x50, 0x4b, 0x51, 0x59, 0x35, 0x35, 0xbe, 0x23,
-  0x23, 0xb6, 0x9c, 0x89, 0x99, 0x2a, 0x0e, 0x21, 0x49, 0x40, 0x54, 0x54,
-  0x28, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
-  0x05, 0xd5, 0x10, 0x06, 0x03, 0x37, 0x00, 0x00, 0x00, 0x02, 0xff, 0x0d,
-  0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x16, 0x00, 0x1f, 0x00, 0x00,
-  0x01, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x11,
-  0x23, 0x22, 0x35, 0x34, 0x21, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x25,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x33, 0x01, 0x52, 0x45, 0x59,
-  0x9e, 0x9c, 0xaa, 0x9d, 0xab, 0xf3, 0x01, 0x11, 0xa3, 0x49, 0x30, 0x10,
-  0xac, 0xfe, 0xac, 0x08, 0x0e, 0x1e, 0x63, 0x70, 0x03, 0x02, 0x6b, 0x04,
-  0x6a, 0xfb, 0x3d, 0x68, 0x50, 0x99, 0xab, 0xbb, 0x04, 0xae, 0xd2, 0xd8,
-  0x60, 0x40, 0x6f, 0x9b, 0x9a, 0x2c, 0x18, 0x30, 0x41, 0x33, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x31, 0xfe, 0x56, 0x02, 0xa7, 0x05, 0x9e, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01,
-  0x15, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01,
-  0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55,
-  0xfe, 0xab, 0x43, 0x67, 0xab, 0x94, 0xa2, 0x3f, 0x2b, 0x60, 0x22, 0x22,
-  0xc0, 0x96, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2, 0x8f, 0xfd, 0xa0, 0x89,
-  0x4e, 0xae, 0xd6, 0xc0, 0x9c, 0x30, 0x31, 0x99, 0x14, 0x9f, 0xd2, 0x02,
-  0x60, 0x8f, 0x01, 0x3e, 0x00, 0x01, 0x00, 0x15, 0x00, 0x00, 0x04, 0x6c,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23,
-  0x11, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x36, 0x01, 0x83,
-  0x02, 0xe8, 0xfe, 0x23, 0xb6, 0x55, 0x77, 0x6a, 0x8c, 0xac, 0x05, 0xd5,
-  0xaa, 0xfa, 0xd5, 0x05, 0x2b, 0x5a, 0x69, 0x31, 0x46, 0xb5, 0xa3, 0x00,
-  0x00, 0x01, 0x00, 0x31, 0x00, 0x00, 0x02, 0xa7, 0x06, 0x14, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x15, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x01, 0x52, 0x01, 0x55, 0xfe, 0xab,
-  0x43, 0x67, 0xab, 0xab, 0xbf, 0x92, 0x79, 0x79, 0x9d, 0xaa, 0x9c, 0x9e,
-  0x59, 0x45, 0x04, 0xc3, 0x63, 0x8f, 0xfd, 0xa0, 0x89, 0x4e, 0x9a, 0x9f,
-  0xd2, 0x02, 0x60, 0x8f, 0x4e, 0xbb, 0xab, 0x99, 0x51, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xfa, 0xfe, 0x66, 0x04, 0x6c, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x26, 0x19, 0x01, 0x21, 0x05, 0x04, 0x70, 0xfe, 0x23, 0x63,
-  0x79, 0x39, 0x47, 0xcc, 0xb8, 0xfe, 0x23, 0x05, 0xd5, 0xaa, 0xfb, 0x3d,
-  0xc2, 0x96, 0xaa, 0xf4, 0x01, 0x0e, 0x04, 0xc3, 0xff, 0xff, 0x00, 0x9b,
-  0xff, 0xf7, 0x05, 0xbc, 0x06, 0x14, 0x10, 0x26, 0x00, 0x38, 0xfc, 0x14,
-  0x10, 0x07, 0x02, 0xcc, 0x05, 0x4d, 0x01, 0x34, 0xff, 0xff, 0x00, 0x9e,
-  0xff, 0xe3, 0x04, 0xdf, 0x04, 0xeb, 0x10, 0x27, 0x02, 0xcc, 0x04, 0x70,
-  0x00, 0x0b, 0x10, 0x06, 0x00, 0x58, 0x02, 0x00, 0x00, 0x01, 0x00, 0x46,
-  0xff, 0xe3, 0x05, 0x3b, 0x05, 0xca, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x21,
-  0x16, 0x12, 0x15, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x37,
-  0x21, 0x35, 0x21, 0x15, 0x06, 0x02, 0x15, 0x14, 0x12, 0x33, 0x32, 0x12,
-  0x35, 0x34, 0x02, 0x27, 0x35, 0x21, 0x05, 0x3a, 0xfe, 0xe0, 0x91, 0x80,
-  0xfe, 0xa6, 0xfe, 0xef, 0xfe, 0xed, 0xfe, 0xa8, 0x82, 0x8e, 0xfe, 0xe1,
-  0x02, 0x1c, 0xa0, 0xb3, 0xee, 0xc3, 0xc2, 0xee, 0xb2, 0xa0, 0x02, 0x1c,
-  0x05, 0x18, 0x8d, 0xfe, 0xd8, 0xc2, 0xfe, 0xcb, 0xfe, 0x77, 0x01, 0x8a,
-  0x01, 0x3e, 0xb8, 0x01, 0x2a, 0x8b, 0xb2, 0xb2, 0x61, 0xfe, 0xb4, 0xca,
-  0xef, 0xfe, 0xdd, 0x01, 0x22, 0xf0, 0xca, 0x01, 0x4c, 0x61, 0xb2, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xff, 0xe1, 0x04, 0xeb, 0x05, 0xd5, 0x00, 0x1b,
-  0x00, 0x00, 0x25, 0x32, 0x12, 0x35, 0x34, 0x27, 0x26, 0x27, 0x35, 0x17,
-  0x16, 0x12, 0x15, 0x10, 0x07, 0x06, 0x21, 0x27, 0x26, 0x27, 0x26, 0x19,
-  0x01, 0x33, 0x11, 0x14, 0x16, 0x33, 0x02, 0x7f, 0xc2, 0xee, 0x59, 0x3b,
-  0x63, 0xa2, 0x90, 0x80, 0xad, 0xac, 0xfe, 0xee, 0x45, 0xd1, 0x57, 0x5d,
-  0xb6, 0x63, 0x78, 0x8d, 0x01, 0x22, 0xf0, 0xca, 0xa6, 0x6d, 0x57, 0x44,
-  0x01, 0x8d, 0xfe, 0xd8, 0xc2, 0xfe, 0xcb, 0xc5, 0xc4, 0x02, 0x06, 0x74,
-  0x7a, 0x01, 0x0e, 0x03, 0xf0, 0xfc, 0x10, 0xc2, 0x96, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xfc, 0x00, 0x00, 0x05, 0x58, 0x05, 0xf0, 0x00, 0x17,
-  0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x07, 0x01, 0x11, 0x23, 0x11, 0x01,
-  0x33, 0x09, 0x01, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x23, 0x35,
-  0x34, 0x26, 0x04, 0x5b, 0x33, 0x13, 0x22, 0x0f, 0xfe, 0xaa, 0xb6, 0xfe,
-  0x24, 0xc4, 0x01, 0x74, 0x01, 0x2d, 0x51, 0x93, 0x7a, 0x4d, 0x4c, 0x99,
-  0x42, 0x05, 0x47, 0x0e, 0x18, 0x19, 0xfd, 0xbf, 0xfd, 0x39, 0x02, 0xc7,
-  0x03, 0x0e, 0xfd, 0x9a, 0x01, 0xf9, 0x88, 0x5c, 0x5b, 0x6e, 0x83, 0x79,
-  0x36, 0x50, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36, 0xfe, 0x56, 0x05, 0x43,
-  0x04, 0x7b, 0x00, 0x1f, 0x00, 0x00, 0x05, 0x0e, 0x01, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x36, 0x3f, 0x01, 0x01, 0x33, 0x01, 0x13, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x16, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x07, 0x02, 0x51, 0x46, 0x85, 0x70, 0x84, 0x61, 0x44, 0x4c, 0x2e,
-  0x1e, 0xfe, 0x68, 0xaf, 0x01, 0x3b, 0xfe, 0x13, 0x2b, 0x4f, 0x7a, 0x76,
-  0xa6, 0xa0, 0x49, 0x33, 0x33, 0x25, 0x12, 0x09, 0x68, 0xc8, 0x7a, 0x9a,
-  0x48, 0x86, 0x54, 0x04, 0x4e, 0xfc, 0x94, 0x02, 0xc0, 0x34, 0x33, 0x60,
-  0xbf, 0x86, 0x72, 0x72, 0x3a, 0x54, 0x2a, 0x14, 0x19, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x33, 0x15, 0x21, 0x01, 0x21, 0x15,
-  0x21, 0x35, 0x01, 0x21, 0x35, 0x21, 0x01, 0x21, 0x68, 0x04, 0x1f, 0xfe,
-  0x98, 0xfd, 0xfe, 0x9b, 0xfe, 0x7f, 0x03, 0x66, 0xfb, 0xb7, 0x01, 0x8d,
-  0xfe, 0xf3, 0x01, 0x75, 0x01, 0x5c, 0xfc, 0xc4, 0x05, 0xd5, 0x9a, 0xfe,
-  0x11, 0x90, 0xfd, 0xee, 0xaa, 0x9a, 0x02, 0x22, 0x90, 0x01, 0xdf, 0x00,
-  0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79, 0x04, 0x60, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x03, 0x33, 0x15, 0x21, 0x01, 0x21, 0x15,
-  0x21, 0x35, 0x01, 0x23, 0x35, 0x21, 0x13, 0x21, 0x66, 0x03, 0x12, 0xe2,
-  0xaf, 0xfe, 0xe2, 0xfe, 0xe3, 0x02, 0x6e, 0xfc, 0xd7, 0x01, 0x0d, 0xbe,
-  0x01, 0x2e, 0xf2, 0xfd, 0xa8, 0x04, 0x60, 0xa8, 0xfe, 0xdc, 0x90, 0xfe,
-  0x8f, 0x93, 0xa8, 0x01, 0x5c, 0x90, 0x01, 0x39, 0x00, 0x01, 0x00, 0x90,
-  0xff, 0xc1, 0x04, 0x79, 0x05, 0xd5, 0x00, 0x22, 0x00, 0x00, 0x25, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x35,
-  0x21, 0x15, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x02, 0x64, 0xad,
-  0x59, 0x5a, 0x53, 0x54, 0x94, 0x9d, 0x01, 0x5b, 0xfd, 0x49, 0x03, 0x9a,
-  0xfe, 0x8e, 0x5f, 0x73, 0x58, 0x4e, 0x49, 0x89, 0x89, 0xfc, 0x6b, 0x70,
-  0x72, 0x78, 0x5f, 0x72, 0x72, 0x6b, 0x4b, 0x4b, 0x8f, 0x86, 0x49, 0x4a,
-  0x98, 0x01, 0xea, 0xaa, 0x9a, 0xfe, 0x16, 0x38, 0x2a, 0x6d, 0x68, 0x8a,
-  0xdc, 0x7a, 0x79, 0x13, 0x12, 0x25, 0xc3, 0x31, 0x19, 0x19, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x52, 0xff, 0xc1, 0x04, 0x3c, 0x05, 0xd5, 0x00, 0x22,
-  0x00, 0x00, 0x25, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x01, 0x35,
-  0x21, 0x15, 0x21, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x02, 0x68, 0x7b, 0x71, 0x73, 0x5f, 0x79, 0x71, 0x70, 0x6c, 0xfc,
-  0x88, 0x89, 0x49, 0x4d, 0x58, 0x73, 0x60, 0xfe, 0x8e, 0x03, 0x9a, 0xfd,
-  0x49, 0x01, 0x5a, 0x9c, 0x95, 0x54, 0x52, 0x5a, 0x59, 0x6b, 0x19, 0x19,
-  0x31, 0xc3, 0x25, 0x12, 0x13, 0x79, 0x7a, 0xdc, 0x8a, 0x68, 0x6d, 0x2a,
-  0x38, 0x01, 0xea, 0x9a, 0xaa, 0xfe, 0x16, 0x98, 0x4a, 0x49, 0x86, 0x8f,
-  0x4b, 0x4b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5d, 0xfe, 0x4c, 0x03, 0xd3,
-  0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x09, 0x01, 0x35, 0x21, 0x15, 0x21,
-  0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32,
-  0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23, 0x22, 0x24, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x02, 0x1f, 0xfe, 0x8e, 0x03, 0x12, 0xfd, 0xa8, 0x01,
-  0x83, 0x9c, 0x95, 0x54, 0x53, 0x5a, 0x5a, 0xab, 0x62, 0xb4, 0x4b, 0x5f,
-  0x5a, 0x59, 0x55, 0xfc, 0xfe, 0xef, 0x48, 0x4e, 0x58, 0x73, 0x01, 0xdc,
-  0x01, 0xdc, 0xa8, 0x93, 0xfe, 0x0d, 0xa6, 0x4a, 0x4b, 0x84, 0x8f, 0x4b,
-  0x4b, 0x32, 0x31, 0xc3, 0x25, 0x13, 0x12, 0xf2, 0xdd, 0x8a, 0x68, 0x6d,
-  0x2a, 0x38, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xfe, 0x56, 0x03, 0x84,
-  0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x01, 0x32, 0x37, 0x36, 0x37, 0x15,
-  0x06, 0x07, 0x06, 0x23, 0x20, 0x11, 0x34, 0x25, 0x24, 0x35, 0x34, 0x23,
-  0x30, 0x21, 0x01, 0x21, 0x35, 0x21, 0x15, 0x01, 0x20, 0x15, 0x10, 0x05,
-  0x06, 0x15, 0x14, 0x02, 0x3f, 0x4c, 0x45, 0x47, 0x49, 0x4e, 0x48, 0x4e,
-  0x57, 0xfe, 0x50, 0x01, 0x6d, 0x01, 0x00, 0xd4, 0xfe, 0xfc, 0x01, 0xb4,
-  0xfd, 0xa8, 0x03, 0x12, 0xfe, 0xc2, 0x01, 0x4a, 0xfe, 0x5e, 0xcb, 0xfe,
-  0xee, 0x15, 0x15, 0x2c, 0xb3, 0x20, 0x0d, 0x0e, 0x01, 0x19, 0xee, 0x35,
-  0x25, 0x62, 0x7c, 0x02, 0x38, 0x93, 0xa8, 0xfe, 0x64, 0xe5, 0xfe, 0xec,
-  0x31, 0x18, 0x61, 0x8b, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0xdd,
-  0x05, 0xf0, 0x00, 0x24, 0x00, 0x00, 0x25, 0x21, 0x15, 0x21, 0x35, 0x01,
-  0x37, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x33, 0x15, 0x23, 0x07, 0x01, 0x62, 0x02, 0x7a, 0xfc,
-  0xab, 0x01, 0x1b, 0x67, 0xfe, 0xca, 0x01, 0xb1, 0x56, 0x21, 0x23, 0x4a,
-  0x4c, 0x79, 0x55, 0x5f, 0x5f, 0x6c, 0x6e, 0xbf, 0x4f, 0xd1, 0xf8, 0x1f,
-  0x1c, 0x42, 0x5e, 0xd5, 0x2b, 0xaa, 0xaa, 0xaa, 0x01, 0x40, 0x75, 0x90,
-  0x6d, 0x48, 0x4c, 0x49, 0x77, 0x4b, 0x4b, 0x21, 0x21, 0x43, 0xcc, 0x31,
-  0x32, 0xe8, 0xc2, 0x5c, 0x52, 0x49, 0x60, 0x90, 0x31, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x53, 0xff, 0xc1, 0x04, 0x7a, 0x05, 0xd5, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x10, 0x20, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x11, 0x25, 0x36, 0x17, 0x16, 0x10, 0x0f, 0x01, 0x06, 0x07,
-  0x06, 0x20, 0x24, 0x35, 0x01, 0x09, 0x02, 0xbc, 0xa7, 0x94, 0xfe, 0x2b,
-  0x03, 0x44, 0xfd, 0x72, 0x01, 0x4e, 0xe6, 0x92, 0x49, 0x35, 0x1a, 0x11,
-  0x29, 0x89, 0xfd, 0xfd, 0xfe, 0xef, 0x01, 0x90, 0xfe, 0xdb, 0x01, 0x25,
-  0x86, 0x93, 0x03, 0x2c, 0xaa, 0xfe, 0x25, 0x01, 0x01, 0xd0, 0x68, 0xfe,
-  0xe0, 0x56, 0x29, 0x1d, 0x24, 0x79, 0xf2, 0xdd, 0x00, 0x01, 0x00, 0x5d,
-  0xfe, 0x4c, 0x03, 0xd3, 0x04, 0x60, 0x00, 0x1a, 0x00, 0x00, 0x17, 0x16,
-  0x33, 0x20, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x33, 0x32, 0x1e, 0x01, 0x10, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x5e, 0x98, 0xba, 0x01, 0x6d, 0xa6, 0x95, 0xfe, 0xc3, 0x02, 0xc9,
-  0xfd, 0xdc, 0xc7, 0x5f, 0xcd, 0x95, 0x35, 0x19, 0x12, 0x28, 0x89, 0xfc,
-  0xa9, 0xbe, 0xa7, 0x63, 0x01, 0x25, 0x86, 0x93, 0x03, 0x2c, 0xaa, 0xfe,
-  0x26, 0x63, 0xd4, 0xfe, 0xe0, 0x56, 0x29, 0x1d, 0x24, 0x79, 0x4a, 0x00,
-  0x00, 0x01, 0x00, 0x4f, 0xff, 0xe3, 0x03, 0x48, 0x05, 0x9e, 0x00, 0x24,
-  0x00, 0x00, 0x01, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x13, 0x23, 0x35, 0x33, 0x11, 0x33,
-  0x11, 0x33, 0x15, 0x01, 0xea, 0x01, 0x99, 0x64, 0x62, 0x63, 0x7c, 0xf7,
-  0x4d, 0x49, 0x48, 0x45, 0x42, 0x4b, 0x47, 0x48, 0xa1, 0x59, 0x33, 0x01,
-  0x34, 0x4d, 0xad, 0x38, 0x02, 0xce, 0xce, 0xb5, 0xd0, 0x03, 0xe6, 0x7d,
-  0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d, 0x9d, 0x12, 0x11, 0x23, 0xac, 0x28,
-  0x18, 0x16, 0x72, 0x41, 0x85, 0x62, 0x4c, 0x72, 0x01, 0x0f, 0xa4, 0x01,
-  0x14, 0xfe, 0xec, 0xa4, 0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e,
-  0x04, 0x7b, 0x00, 0x0e, 0x00, 0x17, 0x00, 0x00, 0x05, 0x11, 0x23, 0x11,
-  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x10, 0x01,
-  0x00, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x01, 0x4e, 0xa7, 0xa7,
-  0x2f, 0x79, 0x49, 0xbd, 0xa6, 0x45, 0x46, 0xfd, 0x21, 0x02, 0x33, 0x33,
-  0x32, 0x6c, 0xc6, 0x9c, 0x7a, 0xfe, 0xd0, 0x06, 0x0a, 0xaa, 0x42, 0x52,
-  0x31, 0x70, 0x71, 0x99, 0xfe, 0x57, 0xfe, 0xe4, 0x01, 0x90, 0xf9, 0x85,
-  0x42, 0x41, 0xef, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x01, 0x6b,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0xb5, 0xb6,
-  0xb6, 0x05, 0xd5, 0xf8, 0x81, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x56, 0x02, 0xd7, 0x05, 0xd5, 0x10, 0x27, 0x01, 0x82, 0x01, 0x6c,
-  0x00, 0x00, 0x10, 0x06, 0x01, 0x82, 0x00, 0x00, 0x00, 0x01, 0x00, 0x12,
-  0xfe, 0x56, 0x03, 0x40, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
-  0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x01, 0x4e, 0xb6, 0x01, 0x3c, 0xfe,
-  0xc4, 0x01, 0x3c, 0xfe, 0xc4, 0xb6, 0xfe, 0xc4, 0x01, 0x3c, 0xfe, 0xc4,
-  0x01, 0x3c, 0x05, 0xd5, 0xfd, 0x97, 0xa8, 0xf0, 0xaa, 0xfd, 0x2c, 0x02,
-  0xd4, 0xaa, 0xf0, 0xa8, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6c,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x04, 0x9f, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x09, 0xbc, 0x07, 0x6d, 0x10, 0x27, 0x01, 0x3f, 0x05, 0x1f,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x08, 0xb8, 0x06, 0x66, 0x10, 0x27, 0x01, 0x40, 0x05, 0x40,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x07, 0xb6, 0x06, 0x66, 0x10, 0x27, 0x01, 0x40, 0x04, 0x3d,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x66, 0x05, 0x87, 0x05, 0xd5, 0x10, 0x27, 0x00, 0x2d, 0x04, 0x1c,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x56, 0x05, 0x48, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x03, 0xf4,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0xfe, 0x56, 0x02, 0xa4, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x01, 0x51,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x66, 0x06, 0x41, 0x05, 0xd5, 0x10, 0x27, 0x00, 0x2d, 0x04, 0xd6,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x56, 0x06, 0x0c, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x04, 0xb8,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x05, 0x48, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x03, 0xf4,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xf0, 0x04, 0x45, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89, 0x51, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfe, 0x00, 0x00, 0x02, 0x24, 0x07, 0x6d, 0x12, 0x26,
-  0x00, 0x2c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x02, 0xde, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe3, 0x00, 0x00, 0x02, 0x22,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00, 0x11, 0x07, 0x02, 0x89,
-  0xff, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf0, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x11, 0x06, 0x02, 0x89, 0x6a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
-  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xf0, 0x04, 0x77, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89, 0x6a, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x33, 0x10, 0x26,
-  0x11, 0x1e, 0x2b, 0x00, 0x12, 0x06, 0x00, 0x38, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0x6f, 0x01, 0x3b, 0x12, 0x06, 0x00, 0xbe, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x5a, 0x12, 0x26,
-  0x00, 0x38, 0x00, 0x00, 0x10, 0x06, 0x11, 0x21, 0x31, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x22, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x11, 0x21, 0xff, 0xc5, 0xfe, 0xc8,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x5a, 0x12, 0x26,
-  0x00, 0x38, 0x00, 0x00, 0x10, 0x06, 0x11, 0x26, 0x2b, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x22, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x11, 0x26, 0xff, 0xca, 0xfe, 0xc8,
-  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x60, 0x12, 0x26,
-  0x00, 0x38, 0x00, 0x00, 0x10, 0x06, 0x11, 0x22, 0x2b, 0x06, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x22, 0x12, 0x26,
-  0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x11, 0x22, 0xff, 0xc5, 0xfe, 0xc8,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x06,
-  0x02, 0x1b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x08, 0x33, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x1e,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x07, 0x31, 0x12, 0x26, 0x00, 0xa6, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71,
-  0x00, 0x4a, 0x01, 0x3b, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x08, 0x33, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x20,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x06, 0xf4, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x11, 0x20,
-  0xff, 0x9e, 0xfe, 0xc1, 0xff, 0xff, 0x00, 0x07, 0x00, 0x00, 0x06, 0x8e,
-  0x07, 0x34, 0x10, 0x27, 0x00, 0x71, 0x02, 0x8e, 0x01, 0x3e, 0x12, 0x06,
-  0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xb1,
-  0x05, 0xf2, 0x10, 0x27, 0x00, 0x71, 0x01, 0xb7, 0xff, 0xfc, 0x12, 0x06,
-  0x00, 0xa8, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x6a,
-  0x05, 0xf0, 0x00, 0x25, 0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x23, 0x15,
-  0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17,
-  0x15, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36,
-  0x37, 0x35, 0x23, 0x35, 0x33, 0x35, 0x21, 0x35, 0x04, 0xfd, 0x6d, 0x6d,
-  0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01, 0x3b, 0x83,
-  0xed, 0x64, 0x65, 0xe3, 0x7d, 0xf6, 0xf8, 0xf8, 0xf6, 0x61, 0x97, 0x3c,
-  0xe4, 0xe4, 0xfe, 0xd7, 0x03, 0x0c, 0xfe, 0xd6, 0x58, 0xff, 0x53, 0x55,
-  0x01, 0x99, 0x01, 0x6d, 0x01, 0x6e, 0x01, 0x99, 0x48, 0x46, 0xd7, 0x5f,
-  0x60, 0xfe, 0xce, 0xfe, 0xd1, 0xfe, 0xd2, 0xfe, 0xce, 0x25, 0x27, 0xb5,
-  0x58, 0x84, 0xa6, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x7b,
-  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x34, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x17, 0x14, 0x07, 0x33,
-  0x15, 0x23, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
-  0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x36, 0x3d, 0x01, 0x0e,
-  0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35,
-  0x33, 0x03, 0x45, 0x95, 0x86, 0x85, 0x94, 0x94, 0x85, 0x86, 0x95, 0xa6,
-  0x11, 0xa1, 0xb3, 0x1c, 0x34, 0x72, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e,
-  0x4a, 0xa3, 0x51, 0x13, 0x0f, 0xfd, 0xc4, 0x02, 0x57, 0x14, 0x33, 0xa0,
-  0x70, 0xba, 0xe2, 0xe2, 0xba, 0x70, 0xa0, 0x33, 0xa6, 0x02, 0x3d, 0xc8,
-  0xdc, 0xdc, 0xc8, 0xc7, 0xdc, 0xdc, 0xeb, 0x6e, 0x58, 0x46, 0x5d, 0x40,
-  0x8c, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0x5f, 0x17, 0x1c, 0x45, 0x47, 0x5e,
-  0x5b, 0x63, 0x62, 0x01, 0x3a, 0x01, 0x03, 0x01, 0x04, 0x01, 0x3a, 0x62,
-  0x63, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe,
-  0x07, 0x6d, 0x12, 0x26, 0x00, 0x2a, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0,
-  0x04, 0xc3, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x03, 0xeb, 0x06, 0x63, 0x10, 0x26, 0x02, 0x89, 0x43, 0xfd,
-  0x12, 0x06, 0x00, 0x4a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xe0, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x2b,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0xff, 0xeb,
-  0x00, 0x00, 0x04, 0x26, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x4e, 0x00, 0x00,
-  0x11, 0x07, 0x10, 0xf0, 0x02, 0xcb, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xfe, 0x75, 0x05, 0x44, 0x05, 0xf0, 0x10, 0x27,
-  0x02, 0x9d, 0x01, 0x15, 0x00, 0x00, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x26,
-  0x02, 0x9d, 0x73, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xfe, 0x75, 0x05, 0x44, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x01, 0x0a, 0x01, 0x3b, 0x12, 0x06, 0x01, 0xac, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x03, 0x05, 0xf5, 0x10, 0x26,
-  0x00, 0x71, 0x68, 0xff, 0x12, 0x06, 0x01, 0xad, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x90, 0xff, 0xc1, 0x04, 0x79, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xf0, 0x04, 0x45, 0x01, 0x75, 0x12, 0x06, 0x01, 0x79, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0xc4, 0x06, 0x66, 0x10, 0x26,
-  0x02, 0x89, 0x18, 0x00, 0x10, 0x06, 0x02, 0x54, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x02, 0x27, 0x06, 0x66, 0x10, 0x27,
-  0x02, 0x89, 0xff, 0x3b, 0x00, 0x00, 0x11, 0x06, 0x01, 0xf9, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x09, 0xbc,
-  0x05, 0xd5, 0x10, 0x27, 0x00, 0x3d, 0x05, 0x1f, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x08, 0xb8,
-  0x05, 0xd5, 0x10, 0x27, 0x00, 0x5d, 0x05, 0x40, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x07, 0xb6,
-  0x06, 0x14, 0x10, 0x27, 0x00, 0x5d, 0x04, 0x3d, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe,
-  0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x98, 0x01, 0x76, 0x12, 0x06,
-  0x00, 0x2a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb,
-  0x06, 0x63, 0x12, 0x26, 0x00, 0x4a, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76,
-  0x18, 0xfd, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xff, 0xe3, 0x07, 0x5c,
-  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
-  0x11, 0x14, 0x17, 0x16, 0x17, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11,
-  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x21, 0x11, 0x23,
-  0xb5, 0xb6, 0x02, 0x94, 0xb6, 0x38, 0x37, 0x8a, 0x85, 0x3b, 0x38, 0xb6,
-  0x5a, 0x57, 0xfd, 0xf8, 0x5d, 0x5a, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd,
-  0x9c, 0x02, 0x64, 0xfb, 0xec, 0x9f, 0x50, 0x4e, 0x01, 0x4f, 0x4b, 0xa4,
-  0x02, 0x9f, 0xfd, 0x5a, 0xdf, 0x80, 0x78, 0x78, 0x76, 0xe9, 0x01, 0x0d,
-  0xfd, 0x39, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x82,
-  0x05, 0xf0, 0x00, 0x0e, 0x00, 0x17, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11,
-  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x10, 0x01,
-  0x00, 0x11, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x01, 0x6b, 0xb6, 0xb6,
-  0x32, 0x83, 0x4e, 0xcb, 0xb3, 0x4a, 0x4c, 0xfc, 0xe9, 0x02, 0x5d, 0x36,
-  0x36, 0x75, 0xd5, 0xa7, 0x9c, 0xfd, 0xba, 0x07, 0x7f, 0xb9, 0x48, 0x57,
-  0x35, 0x78, 0x7a, 0xa4, 0xfe, 0x37, 0xfe, 0xce, 0x01, 0xae, 0x01, 0x0c,
-  0x8f, 0x47, 0x46, 0xfe, 0xff, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xae, 0x07, 0x6b, 0x10, 0x27, 0x10, 0xee, 0x04, 0x9b,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0xf4, 0x06, 0x64, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x43, 0x00, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x73, 0x12, 0x26, 0x00, 0x87, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xec, 0x05, 0xb9, 0x01, 0x7d, 0xff, 0xff, 0x00, 0x6e,
-  0xff, 0xe3, 0x04, 0x60, 0x07, 0x73, 0x12, 0x26, 0x00, 0xa7, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xec, 0x05, 0x54, 0x01, 0x7d, 0xff, 0xff, 0x00, 0x07,
-  0x00, 0x00, 0x06, 0x8e, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x05, 0xb9,
-  0x01, 0x76, 0x12, 0x06, 0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
-  0xff, 0xe3, 0x06, 0xb1, 0x06, 0x63, 0x12, 0x26, 0x00, 0xa8, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x76, 0x01, 0x41, 0xff, 0xfd, 0xff, 0xff, 0x00, 0x5b,
-  0xff, 0xba, 0x05, 0x4f, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x7e,
-  0x01, 0x76, 0x12, 0x06, 0x00, 0x9a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x40,
-  0xff, 0xa2, 0x04, 0x26, 0x06, 0x63, 0x12, 0x26, 0x00, 0xba, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x76, 0x19, 0xfd, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x70, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf5, 0x04, 0x68, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x6e,
-  0xff, 0xe3, 0x03, 0xc3, 0x06, 0x64, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x22,
-  0xff, 0xfe, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x36, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf1, 0x04, 0x43, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x6e,
-  0xff, 0xe3, 0x03, 0xc3, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x03, 0xf4,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x70, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf5, 0x04, 0x2e, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x63, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x41,
-  0xff, 0xfd, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x07, 0x36, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf1, 0x04, 0x2f, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x04, 0x32,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0xff, 0xaf,
-  0x00, 0x00, 0x02, 0x35, 0x07, 0x70, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf5, 0x03, 0x03, 0x01, 0x7a, 0xff, 0xff, 0xff, 0xc9,
-  0x00, 0x00, 0x02, 0x41, 0x06, 0x63, 0x10, 0x27, 0x02, 0xc0, 0x03, 0x0f,
-  0xff, 0xfd, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0x00, 0x00, 0x02, 0x38, 0x07, 0x36, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf1, 0x02, 0xeb, 0x01, 0x3e, 0xff, 0xff, 0xff, 0xe5,
-  0x00, 0x00, 0x02, 0x1a, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x02, 0xd4,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0x70, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf5, 0x04, 0xba, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x64, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x29,
-  0xff, 0xfe, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0x36, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf1, 0x04, 0x99, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x04, 0x22,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb3,
-  0x00, 0x00, 0x04, 0xcc, 0x07, 0x70, 0x12, 0x26, 0x00, 0x35, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf5, 0x04, 0x06, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x75,
-  0x00, 0x00, 0x02, 0xf6, 0x06, 0x63, 0x10, 0x27, 0x02, 0xc0, 0x03, 0xbb,
-  0xff, 0xfd, 0x12, 0x06, 0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xcc, 0x07, 0x36, 0x12, 0x26, 0x00, 0x35, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf1, 0x04, 0x0d, 0x01, 0x3e, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0x08, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x03, 0xc2,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
-  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x70, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf5, 0x04, 0x93, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x9c,
-  0xff, 0xe3, 0x03, 0xe9, 0x06, 0x64, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x58,
-  0xff, 0xfe, 0x12, 0x06, 0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
-  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x36, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf1, 0x04, 0x6e, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x9c,
-  0xff, 0xe3, 0x03, 0xe9, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x04, 0x34,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x14, 0x04, 0x2c, 0x05, 0xf0, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x04,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
-  0xfe, 0x14, 0x03, 0x67, 0x04, 0x7b, 0x10, 0x27, 0x02, 0xd7, 0x03, 0xc1,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x56, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
-  0xfe, 0x14, 0x04, 0x6c, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x03, 0xe4,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31,
-  0xfe, 0x14, 0x02, 0xa7, 0x05, 0x9e, 0x10, 0x27, 0x02, 0xd7, 0x03, 0x9a,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x57, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8c,
-  0xfe, 0x52, 0x04, 0x02, 0x05, 0xf0, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x04,
-  0x11, 0x14, 0x0e, 0x03, 0x07, 0x35, 0x36, 0x24, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x37, 0x3e, 0x03, 0x35, 0x34, 0x2e,
-  0x03, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x14,
-  0x0e, 0x02, 0x02, 0xec, 0x01, 0x15, 0x64, 0xa6, 0xe7, 0xfa, 0x8a, 0xb4,
-  0x01, 0x13, 0xa6, 0x53, 0x70, 0x65, 0x56, 0x67, 0x93, 0xdf, 0x36, 0x5c,
-  0x5e, 0x37, 0x20, 0x31, 0x44, 0x41, 0x22, 0xa5, 0xdb, 0xd7, 0xb9, 0x76,
-  0xb7, 0x70, 0x15, 0x34, 0x63, 0x02, 0xa2, 0x43, 0xfe, 0xdb, 0x70, 0xce,
-  0xa0, 0x88, 0x60, 0x22, 0xa0, 0x37, 0x8c, 0x99, 0x9d, 0x4f, 0x65, 0x84,
-  0x33, 0x48, 0xab, 0x6a, 0x1a, 0x41, 0x63, 0x8b, 0x52, 0x37, 0x56, 0x33,
-  0x22, 0x0c, 0xb8, 0xbe, 0xa4, 0x56, 0xb6, 0x80, 0x3c, 0x66, 0x71, 0x74,
-  0x00, 0x01, 0x00, 0x3f, 0xfe, 0x4f, 0x03, 0x5d, 0x04, 0x7b, 0x00, 0x34,
-  0x00, 0x00, 0x01, 0x1e, 0x03, 0x15, 0x14, 0x0e, 0x05, 0x07, 0x35, 0x3e,
-  0x04, 0x35, 0x34, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x37, 0x3e, 0x04,
-  0x35, 0x34, 0x2e, 0x03, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x33, 0x32,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x02, 0x63, 0x3f, 0x65, 0x38, 0x1d, 0x3b,
-  0x61, 0x89, 0x8d, 0xa1, 0x87, 0x42, 0x92, 0xdc, 0x8e, 0x5a, 0x24, 0x6b,
-  0x53, 0x36, 0x38, 0xc3, 0xc9, 0x1f, 0x3a, 0x4f, 0x38, 0x29, 0x1c, 0x2c,
-  0x3d, 0x3a, 0x20, 0x3e, 0x97, 0x84, 0xef, 0x79, 0x65, 0xa5, 0x69, 0x5d,
-  0x01, 0xcd, 0x08, 0x44, 0x5a, 0x58, 0x25, 0x4b, 0x8a, 0x6c, 0x61, 0x46,
-  0x3d, 0x27, 0x0f, 0x82, 0x2e, 0x60, 0x5b, 0x62, 0x5b, 0x33, 0x58, 0x70,
-  0x19, 0x56, 0x8b, 0x55, 0x0d, 0x20, 0x3c, 0x45, 0x66, 0x39, 0x2c, 0x46,
-  0x2a, 0x1b, 0x0a, 0x3b, 0x5a, 0x9a, 0x85, 0x47, 0x92, 0x61, 0x6e, 0x99,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xf0, 0x04, 0x84, 0x01, 0x75, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xf1, 0x00, 0x00, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xf0, 0x02, 0xd1, 0x01, 0x75, 0x13, 0x06, 0x00, 0x4b, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x97,
-  0x05, 0xf0, 0x00, 0x13, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x17, 0x32, 0x12, 0x19,
-  0x01, 0x23, 0x03, 0xe2, 0x8b, 0x8a, 0xa1, 0xc1, 0xb6, 0xb6, 0x48, 0xb9,
-  0x8c, 0xcd, 0xd1, 0xb4, 0x03, 0x7f, 0xd7, 0xd5, 0xff, 0xde, 0xfc, 0xb2,
-  0x05, 0xd5, 0xf1, 0x87, 0x86, 0x01, 0xfe, 0xc1, 0xfe, 0xcc, 0xfa, 0xd9,
-  0x00, 0x03, 0x00, 0x65, 0xff, 0x70, 0x05, 0xa4, 0x06, 0x14, 0x00, 0x07,
-  0x00, 0x28, 0x00, 0x34, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34,
-  0x27, 0x22, 0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06,
-  0x07, 0x23, 0x36, 0x37, 0x26, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x11, 0x33, 0x00,
-  0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x10, 0x27, 0x26, 0x20, 0x07, 0x04,
-  0x3d, 0x10, 0x21, 0x90, 0x2f, 0x2f, 0xb5, 0x63, 0x7a, 0xdc, 0xfe, 0xcc,
-  0x42, 0x30, 0x1e, 0x16, 0xb0, 0x1a, 0x3c, 0x2b, 0x34, 0x4f, 0x50, 0x70,
-  0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50, 0x4f, 0x34, 0xa6, 0xfd,
-  0x26, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x4c, 0x4c, 0x4b, 0xfe, 0xf9, 0x4c,
-  0x82, 0x05, 0xaf, 0x2d, 0x01, 0x20, 0xb8, 0xce, 0xfe, 0xbf, 0x0f, 0x48,
-  0x3a, 0x45, 0x93, 0x3c, 0x24, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0x02, 0x10,
-  0xa2, 0xa2, 0x31, 0x30, 0x64, 0x02, 0x5e, 0xfc, 0xe6, 0xfe, 0x6a, 0x74,
-  0x73, 0x73, 0x74, 0x01, 0x96, 0x74, 0x73, 0x73, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0xa2, 0x05, 0xf0, 0x00, 0x0c, 0x00, 0x3b, 0x00, 0x00,
-  0x01, 0x22, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35, 0x34,
-  0x26, 0x03, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x27, 0x35, 0x32, 0x17, 0x16, 0x15, 0x14, 0x06,
-  0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x20, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
-  0x02, 0x84, 0xa6, 0x60, 0x60, 0x60, 0x60, 0x01, 0x4b, 0x60, 0x61, 0xbf,
-  0xdc, 0x75, 0x99, 0x56, 0x35, 0xb8, 0x97, 0x55, 0x57, 0x45, 0x62, 0x75,
-  0xcd, 0x87, 0x7d, 0x99, 0x88, 0x9a, 0x56, 0x56, 0x8c, 0x8c, 0xfd, 0xf5,
-  0x8c, 0x8c, 0x56, 0x57, 0x9a, 0x9a, 0x3c, 0x4c, 0x75, 0x68, 0xe7, 0x02,
-  0xc5, 0x4d, 0x4d, 0xfe, 0xf2, 0x4d, 0x4d, 0x4d, 0x4e, 0x86, 0x87, 0x9a,
-  0x02, 0x27, 0x03, 0x7c, 0x4f, 0x45, 0x48, 0x2d, 0x41, 0x41, 0x88, 0x9e,
-  0x2b, 0x4d, 0x08, 0x64, 0x68, 0x61, 0xba, 0x80, 0xb2, 0x20, 0x22, 0x63,
-  0x63, 0x8f, 0xd9, 0x74, 0x74, 0x74, 0x74, 0xd9, 0x8f, 0x63, 0x63, 0x22,
-  0x1f, 0x46, 0x59, 0x58, 0x82, 0x53, 0x4a, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x00, 0x05, 0x0f, 0x00, 0x0d, 0x00, 0x34, 0x00, 0x00,
-  0x01, 0x22, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x13, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x20, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x02, 0x32, 0x81, 0x4b, 0x4a, 0x4a, 0x4b,
-  0x01, 0x03, 0x4b, 0x4b, 0x4b, 0x4a, 0xe5, 0x34, 0x2f, 0x41, 0x75, 0x84,
-  0x49, 0x49, 0x77, 0x77, 0xfe, 0x43, 0x77, 0x77, 0x93, 0x84, 0x82, 0x35,
-  0x2f, 0x39, 0x91, 0x27, 0x42, 0x41, 0x75, 0x76, 0x41, 0x43, 0x28, 0x02,
-  0xc5, 0x4d, 0x4d, 0xfe, 0xf2, 0x4d, 0x4d, 0x4d, 0x4e, 0x86, 0x87, 0x4d,
-  0x4d, 0x02, 0x4a, 0x40, 0x62, 0x99, 0x40, 0x59, 0x20, 0x22, 0x63, 0x63,
-  0x8f, 0xd9, 0x74, 0x74, 0x74, 0x74, 0xd9, 0x8f, 0xc6, 0x22, 0x23, 0x56,
-  0x4b, 0x8e, 0x59, 0x49, 0x41, 0xe8, 0x41, 0x41, 0x41, 0x41, 0x74, 0x77,
-  0x3e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x52, 0xfe, 0x56, 0x04, 0x9c,
-  0x05, 0xd5, 0x00, 0x15, 0x00, 0x00, 0x05, 0x10, 0x07, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x21, 0x35, 0x01, 0x21, 0x35,
-  0x21, 0x15, 0x01, 0x21, 0x04, 0x9c, 0x8e, 0x41, 0x67, 0xe4, 0xd1, 0x5f,
-  0x22, 0x22, 0xfc, 0x5d, 0x03, 0x51, 0xfc, 0xc4, 0x04, 0x1f, 0xfc, 0xaf,
-  0x03, 0x66, 0x14, 0xfe, 0xdf, 0x50, 0x25, 0x9c, 0x30, 0x31, 0x99, 0x14,
-  0x9a, 0x04, 0x91, 0xaa, 0x9a, 0xfb, 0x6f, 0x00, 0x00, 0x01, 0x00, 0x4f,
-  0xfe, 0x56, 0x03, 0x79, 0x04, 0x60, 0x00, 0x15, 0x00, 0x00, 0x05, 0x10,
-  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x21,
-  0x35, 0x01, 0x21, 0x35, 0x21, 0x15, 0x01, 0x21, 0x03, 0x78, 0x8e, 0x41,
-  0x66, 0xe5, 0xd2, 0x5e, 0x22, 0x23, 0xfd, 0x7c, 0x02, 0x6f, 0xfd, 0xa8,
-  0x03, 0x12, 0xfd, 0x92, 0x02, 0x6e, 0x14, 0xfe, 0xdf, 0x50, 0x25, 0x9c,
-  0x30, 0x31, 0x99, 0x14, 0xa8, 0x03, 0x25, 0x93, 0xa8, 0xfc, 0xdb, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x50, 0x10, 0x27,
-  0x10, 0xf3, 0x04, 0x43, 0x01, 0x75, 0x12, 0x06, 0x00, 0x24, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x14, 0x10, 0x27,
-  0x02, 0xb8, 0x03, 0xdc, 0x00, 0x00, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x75, 0x04, 0x17, 0x05, 0xd5, 0x12, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x00, 0x7a, 0x00, 0x92, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26,
-  0x00, 0x48, 0x00, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x6f, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x33, 0x12, 0x26,
-  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x1e, 0x58, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x31, 0x12, 0x26,
-  0x00, 0xb8, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71, 0x00, 0x68, 0x01, 0x3b,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x33, 0x12, 0x26,
-  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x25, 0x5e, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0xe9, 0x12, 0x26,
-  0x00, 0x52, 0x00, 0x00, 0x10, 0x07, 0x11, 0x25, 0xff, 0xbc, 0xfe, 0xb6,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x50, 0x10, 0x27,
-  0x10, 0xf3, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x14, 0x10, 0x27,
-  0x02, 0xb8, 0x04, 0x01, 0x00, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x33, 0x12, 0x26,
-  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x20, 0x5f, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x31, 0x12, 0x26,
-  0x01, 0xf1, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71, 0x00, 0x68, 0x01, 0x3b,
-  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0x66, 0x01, 0x3b, 0x12, 0x06, 0x00, 0x3c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x05, 0xf5, 0x10, 0x26,
-  0x00, 0x71, 0x55, 0xff, 0x12, 0x06, 0x00, 0x5c, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x7c, 0xff, 0x70, 0x03, 0x06, 0x06, 0x0e, 0x00, 0x07,
-  0x00, 0x19, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x22,
-  0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06, 0x07, 0x23,
-  0x36, 0x37, 0x26, 0x37, 0x11, 0x33, 0x01, 0xa0, 0x0f, 0x21, 0x90, 0x2e,
-  0x2f, 0xb6, 0x63, 0x7a, 0xdc, 0xfe, 0xcc, 0x42, 0x2f, 0x1f, 0x15, 0xb1,
-  0x1a, 0x3d, 0x2d, 0x01, 0xa6, 0x82, 0x05, 0xaf, 0x2d, 0x01, 0x20, 0xb8,
-  0xce, 0xfe, 0xbf, 0x0f, 0x48, 0x3a, 0x45, 0x93, 0x3c, 0x5a, 0x05, 0x30,
-  0x00, 0x02, 0x00, 0xa7, 0xff, 0x70, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x07,
-  0x00, 0x2b, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x22,
-  0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06, 0x07, 0x23,
-  0x36, 0x37, 0x26, 0x37, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11,
-  0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x04, 0x46, 0x10, 0x21, 0x90, 0x2f, 0x2f, 0xb5, 0x63, 0x7a, 0xdc, 0xfe,
-  0xcc, 0x42, 0x30, 0x1e, 0x16, 0xb0, 0x1a, 0x3c, 0x2c, 0x01, 0x70, 0x6f,
-  0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0x50, 0x51, 0x6a, 0xad, 0x59, 0x5a, 0x82,
-  0x05, 0xaf, 0x2d, 0x01, 0x20, 0xb8, 0xce, 0xfe, 0xbf, 0x0f, 0x48, 0x3a,
-  0x45, 0x93, 0x3c, 0x5a, 0x01, 0xc0, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87,
-  0x04, 0x60, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78, 0xe8, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x31, 0xff, 0x70, 0x03, 0x0b, 0x05, 0x9e, 0x00, 0x07,
-  0x00, 0x21, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x22,
-  0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06, 0x07, 0x23,
-  0x36, 0x37, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21,
-  0x15, 0x21, 0x01, 0xa4, 0x10, 0x21, 0x90, 0x2f, 0x2f, 0xb5, 0x62, 0x7b,
-  0xdb, 0xfe, 0xcd, 0x42, 0x31, 0x1d, 0x16, 0xb0, 0x1a, 0x3c, 0x2c, 0x79,
-  0x79, 0xa7, 0x01, 0x55, 0xfe, 0xab, 0x82, 0x05, 0xaf, 0x2d, 0x01, 0x20,
-  0xb8, 0xce, 0xfe, 0xbf, 0x0f, 0x48, 0x3a, 0x45, 0x93, 0x3c, 0x5a, 0x02,
-  0xf3, 0x8f, 0x01, 0x3e, 0xfe, 0xc2, 0x8f, 0x00, 0x00, 0x01, 0xff, 0xde,
-  0xfe, 0x56, 0x01, 0x54, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0xae, 0xa5,
-  0x92, 0xa3, 0x3f, 0x2c, 0x5e, 0x45, 0x04, 0x60, 0xfb, 0x8c, 0xd6, 0xc0,
-  0x9c, 0x61, 0x99, 0x00, 0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x06, 0xcb,
-  0x06, 0x14, 0x00, 0x09, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x00, 0x00, 0x10,
-  0x17, 0x16, 0x20, 0x36, 0x10, 0x26, 0x20, 0x07, 0x13, 0x32, 0x17, 0x11,
-  0x33, 0x11, 0x36, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x27, 0x15,
-  0x23, 0x35, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x00, 0x10,
-  0x27, 0x26, 0x20, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0x01, 0x11,
-  0x4a, 0x4c, 0x01, 0x07, 0x97, 0x97, 0xfe, 0xf9, 0x4c, 0xa7, 0xdc, 0x67,
-  0xa7, 0x66, 0xdc, 0xb7, 0xe6, 0xe6, 0xb7, 0xdc, 0x66, 0xa7, 0x67, 0xdc,
-  0xb7, 0x73, 0x72, 0x72, 0x73, 0x04, 0xd4, 0x4b, 0x4b, 0xfe, 0xf9, 0x4c,
-  0x4a, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x02, 0xfa, 0xfe, 0x6a, 0x74, 0x73,
-  0xe7, 0x01, 0x96, 0xe7, 0x73, 0x01, 0x0d, 0xc5, 0x02, 0x5e, 0xfd, 0xa2,
-  0xc5, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0xc5, 0xa8, 0xa8, 0xc5, 0xa2,
-  0xa2, 0x02, 0x10, 0xa2, 0xa2, 0xfc, 0xe9, 0x01, 0x96, 0x74, 0x73, 0x73,
-  0x74, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
-  0xfe, 0x56, 0x06, 0xcb, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x25, 0x00, 0x2f,
-  0x00, 0x00, 0x00, 0x10, 0x27, 0x26, 0x20, 0x07, 0x06, 0x10, 0x17, 0x16,
-  0x20, 0x37, 0x03, 0x22, 0x27, 0x11, 0x23, 0x11, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x35, 0x33, 0x15, 0x36, 0x33,
-  0x32, 0x12, 0x10, 0x02, 0x00, 0x10, 0x17, 0x16, 0x20, 0x36, 0x10, 0x26,
-  0x20, 0x07, 0x06, 0x1f, 0x4b, 0x4b, 0xfe, 0xf9, 0x4c, 0x4a, 0x4a, 0x4c,
-  0x01, 0x07, 0x4b, 0xa6, 0xdc, 0x66, 0xa7, 0x67, 0xdc, 0xb7, 0x73, 0x72,
-  0x72, 0x73, 0xb7, 0xdc, 0x67, 0xa7, 0x66, 0xdc, 0xb7, 0xe6, 0xe6, 0xfb,
-  0x2c, 0x4a, 0x4c, 0x01, 0x07, 0x97, 0x97, 0xfe, 0xf9, 0x4c, 0x01, 0x64,
-  0x01, 0x96, 0x74, 0x73, 0x73, 0x74, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0xfe,
-  0xf3, 0xc5, 0xfd, 0xae, 0x02, 0x52, 0xc5, 0xa2, 0xa2, 0x02, 0x10, 0xa2,
-  0xa2, 0xc5, 0xaa, 0xaa, 0xc5, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x03,
-  0x17, 0xfe, 0x6a, 0x74, 0x73, 0xe7, 0x01, 0x96, 0xe7, 0x73, 0x00, 0x00,
-  0x00, 0x03, 0xff, 0xfd, 0xff, 0xba, 0x04, 0xf0, 0x06, 0x17, 0x00, 0x12,
-  0x00, 0x16, 0x00, 0x19, 0x00, 0x00, 0x01, 0x33, 0x13, 0x01, 0x17, 0x09,
-  0x01, 0x23, 0x03, 0x21, 0x0f, 0x01, 0x23, 0x07, 0x27, 0x23, 0x37, 0x27,
-  0x37, 0x01, 0x03, 0x33, 0x01, 0x03, 0x21, 0x03, 0x02, 0x0f, 0xcf, 0x78,
-  0x01, 0x3e, 0x5c, 0xfe, 0x98, 0x01, 0x56, 0xbd, 0x7b, 0xfe, 0x0e, 0xb9,
-  0x2d, 0x3f, 0x35, 0x4a, 0x02, 0x01, 0x12, 0x2b, 0x02, 0x4e, 0xf7, 0x14,
-  0x01, 0x4b, 0xab, 0x01, 0x3b, 0x60, 0x05, 0xd5, 0xfe, 0xa1, 0x01, 0xa1,
-  0x59, 0xfe, 0x27, 0xfc, 0x1b, 0x01, 0x7f, 0xf1, 0x8e, 0x46, 0x46, 0x01,
-  0x11, 0x38, 0x04, 0xc4, 0xfd, 0x19, 0x01, 0xb1, 0xfe, 0x4f, 0x01, 0x1f,
-  0x00, 0x02, 0x00, 0x0a, 0xff, 0xba, 0x04, 0xfd, 0x06, 0x17, 0x00, 0x22,
-  0x00, 0x2c, 0x00, 0x00, 0x17, 0x27, 0x13, 0x26, 0x11, 0x10, 0x37, 0x36,
-  0x21, 0x32, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07, 0x15, 0x26, 0x27, 0x01,
-  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06,
-  0x23, 0x20, 0x27, 0x13, 0x01, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x11,
-  0x14, 0x67, 0x5c, 0xc6, 0x69, 0xaf, 0xaf, 0x01, 0x32, 0x78, 0x6a, 0x37,
-  0x35, 0x5a, 0x5c, 0x59, 0x29, 0x2c, 0xfd, 0x42, 0x08, 0x0a, 0x7a, 0xe6,
-  0x75, 0x69, 0x67, 0x5c, 0x5f, 0x6b, 0x6b, 0x76, 0xfe, 0xd5, 0xaf, 0x34,
-  0x02, 0x8f, 0x01, 0x69, 0x75, 0xe6, 0x7a, 0x7b, 0x46, 0x58, 0x01, 0x05,
-  0xbb, 0x01, 0x17, 0x01, 0x68, 0xcf, 0xd0, 0x24, 0x12, 0x1b, 0x78, 0x59,
-  0x76, 0xbb, 0x2b, 0x21, 0xfc, 0x66, 0x0d, 0x0c, 0x9d, 0x2f, 0x2f, 0x5f,
-  0xd3, 0x48, 0x24, 0x24, 0xc7, 0x01, 0x15, 0x03, 0x5c, 0x2f, 0x9c, 0x9d,
-  0xfe, 0xd8, 0xad, 0x00, 0x00, 0x02, 0x00, 0x08, 0xff, 0xa2, 0x03, 0xee,
-  0x04, 0xbc, 0x00, 0x22, 0x00, 0x2b, 0x00, 0x00, 0x17, 0x27, 0x37, 0x26,
-  0x35, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07,
-  0x15, 0x26, 0x27, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x15, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x13, 0x01, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x5e, 0x56, 0xaa, 0x4c, 0x88, 0x87, 0xeb, 0x4d,
-  0x49, 0x29, 0x29, 0x50, 0x55, 0x6a, 0x16, 0x16, 0xfe, 0x0b, 0x06, 0x05,
-  0x59, 0xa2, 0x48, 0x46, 0x47, 0x46, 0x45, 0x4a, 0x4b, 0x53, 0xd8, 0x85,
-  0x32, 0x01, 0xbc, 0x3f, 0x40, 0xa2, 0x59, 0x59, 0x5e, 0x4e, 0xe6, 0x8d,
-  0xcc, 0x01, 0x12, 0x9d, 0x9d, 0x11, 0x0a, 0x10, 0x6c, 0x4f, 0x8f, 0x55,
-  0x0e, 0x0b, 0xfd, 0x5e, 0x08, 0x08, 0x71, 0x15, 0x16, 0x2b, 0xaa, 0x24,
-  0x12, 0x12, 0x90, 0x01, 0x05, 0x02, 0x56, 0x11, 0x71, 0x72, 0xcd, 0x67,
-  0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x21, 0x15, 0x21,
-  0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0xac, 0xac, 0x02, 0x8e, 0xfc, 0xbc,
-  0xac, 0xac, 0x05, 0xd5, 0xfd, 0x77, 0x90, 0xfd, 0xee, 0xaa, 0x02, 0xbc,
-  0x90, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb9, 0xff, 0xba, 0x04, 0xad,
-  0x06, 0x17, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x00, 0x01, 0x15, 0x23, 0x01,
-  0x11, 0x23, 0x11, 0x01, 0x27, 0x01, 0x11, 0x21, 0x35, 0x21, 0x37, 0x17,
-  0x09, 0x01, 0x21, 0x04, 0x6b, 0x2f, 0xfe, 0x52, 0xb6, 0xfe, 0x3e, 0x5c,
-  0x02, 0x1e, 0xfe, 0x23, 0x04, 0x23, 0x32, 0x5c, 0xfd, 0xe2, 0x01, 0x0e,
-  0xfe, 0xf2, 0x05, 0x69, 0x3e, 0xfd, 0xcc, 0xfd, 0x09, 0x02, 0x07, 0xfd,
-  0xb3, 0x58, 0x02, 0xc7, 0x02, 0x52, 0xaa, 0x42, 0x59, 0xfe, 0x0b, 0x01,
-  0x62, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xfe, 0x10, 0x03, 0xb1,
-  0x04, 0x7b, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x2f, 0x01,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
-  0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x1f, 0x01, 0x16, 0x33, 0x15,
-  0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x02, 0xbc, 0x2d, 0x2e,
-  0x9a, 0x39, 0x9a, 0x44, 0x45, 0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x46, 0x97,
-  0x51, 0x7b, 0x3e, 0x3e, 0x2c, 0x2d, 0x85, 0x38, 0xb3, 0x48, 0x4a, 0x6e,
-  0x4f, 0x77, 0x90, 0x84, 0x26, 0x44, 0x23, 0x4c, 0x66, 0x40, 0x50, 0xd5,
-  0x1c, 0x20, 0x0e, 0x10, 0x57, 0x61, 0x5c, 0x59, 0x59, 0x57, 0x75, 0x3f,
-  0x3f, 0x01, 0x27, 0x4b, 0x28, 0x28, 0x25, 0x0f, 0x24, 0x4a, 0x4b, 0x82,
-  0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x2a, 0x2a, 0x54, 0x40, 0x25,
-  0x24, 0x21, 0x0e, 0x2c, 0x4b, 0x4c, 0x89, 0x9c, 0x5b, 0x40, 0x13, 0x9f,
-  0x7e, 0x24, 0x9a, 0x3d, 0x26, 0x5b, 0xf3, 0x1e, 0x10, 0x03, 0x02, 0x12,
-  0x23, 0xbe, 0x35, 0x1a, 0x1b, 0x2d, 0x2c, 0x00, 0x00, 0x01, 0x00, 0x4f,
-  0xfe, 0x10, 0x03, 0xc8, 0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x01, 0x16, 0x17, 0x13, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x27, 0x26, 0x2f, 0x01, 0x26, 0x2b, 0x01, 0x3d, 0x01, 0x01, 0x21, 0x66,
-  0x03, 0x12, 0xfd, 0x93, 0x53, 0x2c, 0xee, 0x84, 0x26, 0x44, 0x62, 0x85,
-  0x4b, 0x67, 0x40, 0x50, 0xd5, 0x37, 0x51, 0x55, 0x02, 0x6f, 0xfd, 0xa8,
-  0x04, 0x60, 0xa8, 0xfc, 0xdd, 0x10, 0x31, 0xfe, 0xf8, 0x7e, 0x24, 0x9a,
-  0x3d, 0x26, 0x5b, 0xf3, 0x3f, 0x9c, 0x0c, 0x03, 0x25, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x48, 0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x18,
-  0x00, 0x00, 0x01, 0x23, 0x11, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x2b, 0x01, 0x22, 0x06, 0x07, 0x35, 0x36, 0x3b, 0x01, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x02, 0x4f, 0x23, 0xb6, 0xd9, 0x7f, 0x8b, 0x8b, 0x7f,
-  0xe4, 0x3e, 0x9e, 0x47, 0x89, 0x9a, 0xe4, 0xdc, 0xed, 0xee, 0x02, 0x5a,
-  0xfd, 0xa6, 0x03, 0x00, 0x91, 0x87, 0x88, 0x8f, 0x2a, 0x2c, 0xb6, 0x46,
-  0xdc, 0xe1, 0xd7, 0xe7, 0x00, 0x01, 0x00, 0x48, 0x00, 0x00, 0x03, 0x34,
-  0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x11, 0x23, 0x01, 0x11, 0x5a, 0x7f, 0x8a,
-  0x44, 0x4c, 0x79, 0x42, 0x4d, 0x4e, 0x46, 0x89, 0x9a, 0xe2, 0x70, 0x77,
-  0xbf, 0xaf, 0xb5, 0x01, 0xa6, 0x91, 0x87, 0x8d, 0x41, 0x48, 0x15, 0x15,
-  0x2b, 0xb6, 0x46, 0x6e, 0x74, 0xdb, 0xd5, 0xe5, 0xfe, 0xfc, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x0c,
-  0x00, 0x15, 0x00, 0x28, 0x00, 0x00, 0x01, 0x15, 0x21, 0x15, 0x21, 0x15,
-  0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x11, 0x21, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x23, 0x35, 0x33, 0x01,
-  0x6b, 0x01, 0x38, 0xfe, 0xc8, 0x01, 0x23, 0x93, 0x8d, 0x8d, 0x93, 0xfe,
-  0xdd, 0x01, 0x0d, 0x85, 0x83, 0x83, 0x85, 0xfe, 0x3d, 0x01, 0xd0, 0xd0,
-  0xe1, 0x73, 0x70, 0x87, 0x94, 0xf5, 0xe2, 0xfe, 0x1e, 0xac, 0xac, 0x02,
-  0xc9, 0xc9, 0x90, 0xca, 0x87, 0x8b, 0x8c, 0x85, 0x02, 0x66, 0xfe, 0x3e,
-  0x6f, 0x72, 0x71, 0x70, 0xa6, 0xc0, 0xb1, 0x89, 0xa2, 0x14, 0x20, 0xcb,
-  0x98, 0xc8, 0xda, 0x01, 0x70, 0x90, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0a,
-  0xff, 0xe3, 0x05, 0x3a, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x1d, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x10,
-  0x00, 0x23, 0x22, 0x00, 0x11, 0x35, 0x23, 0x35, 0x33, 0x05, 0x21, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0xa0, 0xb7, 0x02, 0x97, 0xb7, 0x94,
-  0x94, 0xfe, 0xfc, 0xfe, 0xff, 0xfe, 0xfc, 0x95, 0x95, 0x03, 0x4e, 0xfd,
-  0x69, 0x9d, 0xaf, 0xaf, 0x9c, 0x05, 0xd5, 0xfd, 0x96, 0x02, 0x6a, 0xfd,
-  0x96, 0xa4, 0x96, 0xfe, 0xdc, 0xfe, 0xd6, 0x01, 0x2a, 0x01, 0x24, 0x96,
-  0xa4, 0xa4, 0x7d, 0xf0, 0xd3, 0xd3, 0xf0, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x03, 0x30, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xb4, 0xff, 0x42, 0x04, 0x17, 0x06, 0x93, 0x00, 0x13,
-  0x00, 0x17, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x33, 0x07, 0x33, 0x15, 0x23,
-  0x03, 0x33, 0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x07, 0x23, 0x37, 0x23,
-  0x11, 0x21, 0x01, 0x13, 0x23, 0x11, 0x1b, 0x01, 0x21, 0x11, 0x03, 0x59,
-  0x99, 0x3b, 0x4f, 0x83, 0x88, 0xf0, 0xfe, 0xdc, 0xa6, 0x01, 0xf6, 0xfd,
-  0xd5, 0x3a, 0x99, 0x3a, 0x9e, 0x02, 0x69, 0xfe, 0x6a, 0xa6, 0xc3, 0xf7,
-  0x88, 0xfe, 0x81, 0x06, 0x93, 0xbe, 0xaa, 0xfe, 0x46, 0xaa, 0xfd, 0xe3,
-  0xaa, 0xbe, 0xbe, 0x05, 0xd5, 0xfa, 0xd5, 0x02, 0x1d, 0xfd, 0xe3, 0x02,
-  0xc7, 0x01, 0xba, 0xfe, 0x46, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65,
-  0xff, 0x42, 0x04, 0x0c, 0x05, 0x1e, 0x00, 0x05, 0x00, 0x26, 0x00, 0x2d,
-  0x00, 0x31, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x03, 0x05, 0x15,
-  0x21, 0x03, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x27, 0x07, 0x23, 0x13, 0x26, 0x27, 0x26, 0x11, 0x10, 0x00, 0x33, 0x32,
-  0x17, 0x37, 0x33, 0x07, 0x16, 0x17, 0x16, 0x05, 0x13, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x1b, 0x01, 0x23, 0x16, 0x03, 0x66, 0x02, 0x4a, 0x0d, 0x0e,
-  0x64, 0x01, 0x71, 0xfe, 0x5a, 0x86, 0x43, 0x57, 0x60, 0xb3, 0x58, 0x59,
-  0xbb, 0x60, 0x6f, 0x5a, 0x47, 0x99, 0x62, 0x1e, 0x19, 0x8d, 0x01, 0x0b,
-  0xe3, 0x32, 0x2d, 0x3f, 0x99, 0x53, 0x34, 0x2a, 0x76, 0xfd, 0xf6, 0x79,
-  0x12, 0x13, 0x8b, 0xa7, 0x0c, 0x51, 0x64, 0xbb, 0x0a, 0x02, 0x94, 0x97,
-  0x5a, 0x10, 0x0d, 0xfe, 0xf2, 0x36, 0x5a, 0xfe, 0x97, 0x1c, 0x34, 0x34,
-  0xae, 0x2a, 0x2c, 0x21, 0xc2, 0x01, 0x09, 0x17, 0x1d, 0x9c, 0x01, 0x0a,
-  0x01, 0x13, 0x01, 0x43, 0x09, 0xac, 0xe0, 0x22, 0x32, 0x92, 0xc5, 0x01,
-  0x4a, 0x02, 0xae, 0x9e, 0xfe, 0x63, 0x01, 0x0e, 0xac, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xa0, 0xfe, 0x66, 0x02, 0x17, 0x05, 0xd5, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x23, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x36, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x02, 0x17,
-  0xac, 0xb9, 0xcc, 0x45, 0x38, 0x79, 0x63, 0xac, 0xac, 0xb6, 0xac, 0x02,
-  0x77, 0xfd, 0xf1, 0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x02, 0x0f, 0xa6,
-  0x02, 0xb8, 0xfd, 0x48, 0x00, 0x02, 0xff, 0xde, 0xfe, 0x56, 0x01, 0xe6,
-  0x06, 0x14, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33,
-  0x15, 0x23, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
-  0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x15, 0x23, 0xae, 0xa5, 0x93, 0x93,
-  0x92, 0xa3, 0x3f, 0x2c, 0x5e, 0x45, 0xa3, 0xa3, 0xa5, 0xa5, 0x04, 0x60,
-  0xfe, 0x08, 0xa4, 0xfe, 0x28, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x01, 0xd8,
-  0xa4, 0x03, 0xac, 0xe9, 0x00, 0x02, 0x00, 0x67, 0xfe, 0x66, 0x06, 0x05,
-  0x05, 0xf1, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00, 0x01, 0x35, 0x33, 0x11,
-  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x11, 0x35, 0x0e, 0x01,
-  0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x01, 0x10, 0x12,
-  0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x04, 0x3b, 0xb0,
-  0x63, 0x79, 0x3e, 0x45, 0xcd, 0xb8, 0x46, 0xd4, 0x95, 0xf2, 0xfe, 0xce,
-  0x01, 0x32, 0xf2, 0x95, 0xd4, 0xfd, 0x2f, 0xd3, 0xb8, 0xb8, 0xd4, 0xd4,
-  0xb8, 0xb8, 0xd3, 0x04, 0xed, 0xe8, 0xfa, 0x93, 0xc2, 0x96, 0xaa, 0xf4,
-  0x01, 0x0e, 0x7f, 0x84, 0x80, 0x01, 0xab, 0x01, 0x5c, 0x01, 0x5c, 0x01,
-  0xab, 0x80, 0xfd, 0x78, 0xfe, 0xe3, 0xfe, 0xbb, 0x01, 0x45, 0x01, 0x1d,
-  0x01, 0x1d, 0x01, 0x45, 0xfe, 0xbb, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0xba, 0x04, 0x7b, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00,
-  0x01, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
-  0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11, 0x14, 0x16, 0x3b,
-  0x01, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x04, 0xba, 0x3f, 0xa3, 0x93, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
-  0xb7, 0x70, 0x9f, 0x34, 0xa6, 0x44, 0x5f, 0x2c, 0xfc, 0x57, 0x96, 0x83,
-  0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0xfe, 0x56, 0xc0, 0xd6, 0xbc, 0x64,
-  0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0x64, 0xaa,
-  0xfb, 0x8c, 0x99, 0x61, 0x03, 0x3d, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7,
-  0xe7, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x04, 0xcc,
-  0x05, 0xd5, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17,
-  0x13, 0x23, 0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x23, 0x35,
-  0x33, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4,
-  0xac, 0x42, 0x7d, 0x6c, 0xc6, 0xb6, 0xac, 0xac, 0x01, 0x9a, 0xe7, 0xe2,
-  0x75, 0xfd, 0xc8, 0xe4, 0x84, 0x86, 0x86, 0x84, 0x02, 0xbc, 0x16, 0x90,
-  0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0x89, 0x02, 0x77, 0xa6,
-  0x02, 0xb8, 0xd6, 0xd8, 0x8d, 0xba, 0x02, 0x4f, 0xfd, 0xee, 0x87, 0x83,
-  0x83, 0x85, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0c, 0x00, 0x00, 0x02, 0xf6,
-  0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x01, 0x15, 0x23, 0x11, 0x23, 0x11,
-  0x23, 0x35, 0x33, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x1f,
-  0x01, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x01, 0xe8, 0x9a, 0xa7, 0x9a,
-  0x9a, 0xa7, 0x34, 0xa8, 0x77, 0x11, 0x2a, 0x19, 0x01, 0x1c, 0x42, 0x27,
-  0x8d, 0x96, 0x02, 0x68, 0xa4, 0xfe, 0x3c, 0x01, 0xc4, 0xa4, 0x01, 0xf8,
-  0xae, 0x66, 0x63, 0x05, 0x05, 0xbd, 0x12, 0x11, 0xce, 0xa1, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xf7, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x14, 0x00, 0x00, 0x03, 0x33, 0x17, 0x21, 0x37, 0x33, 0x07, 0x33,
-  0x15, 0x23, 0x03, 0x11, 0x23, 0x11, 0x03, 0x23, 0x35, 0x33, 0x05, 0x21,
-  0x17, 0x04, 0xc4, 0x88, 0x01, 0xd7, 0x87, 0xc4, 0x88, 0x8c, 0xf0, 0xf0,
-  0xb6, 0xf0, 0xf1, 0x8d, 0x02, 0x38, 0xfe, 0xf0, 0x88, 0x05, 0xd5, 0xe0,
-  0xe0, 0xe0, 0xa4, 0xfe, 0x76, 0xfd, 0x39, 0x02, 0xc7, 0x01, 0x8a, 0xa4,
-  0xa4, 0xe2, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09, 0xfe, 0x56, 0x04, 0x3d,
-  0x04, 0x60, 0x00, 0x18, 0x00, 0x1b, 0x00, 0x00, 0x05, 0x0e, 0x01, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x36, 0x3f, 0x01, 0x03, 0x21, 0x35, 0x33, 0x03,
-  0x33, 0x13, 0x21, 0x13, 0x33, 0x03, 0x33, 0x15, 0x21, 0x2b, 0x01, 0x13,
-  0x02, 0x51, 0x46, 0x85, 0x70, 0x84, 0x61, 0x44, 0x4c, 0x2e, 0x1e, 0xb9,
-  0xfe, 0xf4, 0xd8, 0xab, 0xaf, 0xa6, 0x01, 0x2b, 0xa5, 0xb0, 0xa7, 0xd7,
-  0xfe, 0xf5, 0xad, 0xc5, 0x62, 0x68, 0xc8, 0x7a, 0x9a, 0x48, 0x86, 0x54,
-  0x01, 0xf2, 0x8f, 0x01, 0xcd, 0xfe, 0x33, 0x01, 0xcd, 0xfe, 0x33, 0x8f,
-  0xfe, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xf0,
-  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x25, 0x00, 0x00, 0x01, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x07, 0x11, 0x33, 0x15, 0x3e,
-  0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x01, 0xe7,
-  0xc9, 0x9a, 0x74, 0x64, 0x89, 0xa7, 0xa5, 0xa5, 0x39, 0xa9, 0x7a, 0x9b,
-  0xb7, 0xe4, 0xe2, 0xe8, 0x96, 0x88, 0x57, 0xa4, 0x4b, 0x5b, 0xab, 0x51,
-  0xda, 0xd8, 0x02, 0x2b, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x4c,
-  0x02, 0x7f, 0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b,
-  0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0xeb, 0x04, 0x7b, 0x00, 0x10, 0x00, 0x1c, 0x00, 0x00,
-  0x01, 0x35, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
-  0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0xa6, 0xa6, 0x34, 0x9f, 0x70,
-  0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0xfe, 0x00, 0x96, 0x83, 0x84, 0x97,
-  0x97, 0x84, 0x83, 0x96, 0x03, 0xb6, 0xaa, 0xfb, 0xa0, 0xa8, 0x64, 0x61,
-  0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0xfe, 0x15, 0xcb,
-  0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xff, 0xe3, 0x04, 0x2d, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x1c, 0x00, 0x00,
-  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26,
-  0x27, 0x15, 0x23, 0x11, 0x33, 0x03, 0x81, 0x96, 0x83, 0x84, 0x97, 0x97,
-  0x84, 0x83, 0x96, 0xfd, 0xcc, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7,
-  0x70, 0x9f, 0x34, 0xa6, 0xa6, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
-  0xe7, 0xe7, 0x02, 0x52, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
-  0xfe, 0xbc, 0x61, 0x64, 0xaa, 0x04, 0x60, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x00,
-  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26,
-  0x27, 0x15, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06,
-  0x15, 0x03, 0x81, 0x96, 0x83, 0x84, 0x96, 0x96, 0x84, 0x83, 0x96, 0xfd,
-  0xcd, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xa7,
-  0xa1, 0x95, 0xe5, 0xd2, 0x51, 0x52, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb,
-  0xcb, 0xe7, 0xe7, 0x02, 0x52, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe,
-  0xf8, 0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x04, 0x7e, 0xc3, 0xd3, 0x9c, 0x7d,
-  0x7d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90,
-  0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x13, 0x3e, 0x01, 0x33, 0x32, 0x00,
-  0x11, 0x10, 0x00, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x72, 0x46, 0x94, 0x54,
-  0xe4, 0x01, 0x0c, 0xfe, 0xf1, 0xec, 0x4d, 0x91, 0x45, 0x46, 0x8e, 0x48,
-  0xa1, 0xb2, 0xb2, 0xa1, 0x48, 0x8e, 0x46, 0x04, 0x33, 0x24, 0x24, 0xfe,
-  0xc2, 0xfe, 0xf2, 0xfe, 0xee, 0xfe, 0xc6, 0x23, 0x23, 0xac, 0x2b, 0x2b,
-  0xe3, 0xcd, 0xcd, 0xe3, 0x2b, 0x2b, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0x73, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x27, 0x00, 0x2f, 0x00, 0x00,
-  0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x06, 0x15, 0x23, 0x34, 0x37, 0x26, 0x27, 0x26, 0x11, 0x10,
-  0x00, 0x33, 0x32, 0x16, 0x01, 0x16, 0x33, 0x32, 0x35, 0x34, 0x23, 0x22,
-  0x03, 0x83, 0x46, 0x8d, 0x48, 0xa2, 0xb2, 0x59, 0x06, 0x06, 0x23, 0x38,
-  0x42, 0x5f, 0x92, 0x43, 0x39, 0x55, 0x4b, 0x8c, 0x48, 0x41, 0x06, 0x89,
-  0x0a, 0x32, 0x2b, 0x86, 0x01, 0x0f, 0xeb, 0x4d, 0x92, 0xfe, 0xaf, 0x34,
-  0x46, 0x83, 0x77, 0x5b, 0x04, 0x35, 0xac, 0x2b, 0x2b, 0xe3, 0xcd, 0xcd,
-  0x72, 0x08, 0x06, 0x51, 0x2c, 0x33, 0x48, 0x3d, 0x59, 0x7d, 0x2f, 0x29,
-  0x11, 0x39, 0x44, 0x68, 0x51, 0x23, 0x33, 0xa1, 0x01, 0x0c, 0x01, 0x12,
-  0x01, 0x3a, 0x23, 0xfc, 0x3a, 0x13, 0x39, 0x4b, 0x00, 0x02, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0xba, 0x06, 0x14, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00,
-  0x01, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
-  0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x11, 0x33, 0x11, 0x14, 0x16, 0x3b,
-  0x01, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x04, 0xba, 0x3f, 0xa3, 0x93, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
-  0xb7, 0x70, 0x9f, 0x34, 0xa6, 0x44, 0x5f, 0x2c, 0xfc, 0x57, 0x96, 0x83,
-  0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0xfe, 0x56, 0xc0, 0xd6, 0xbc, 0x64,
-  0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0x64, 0x02,
-  0x5e, 0xf9, 0xd8, 0x99, 0x61, 0x03, 0x3d, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
-  0xe7, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x05, 0x27,
-  0x06, 0x14, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00, 0x01, 0x35, 0x34, 0x36,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x35, 0x0e, 0x01,
-  0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0x93,
-  0xa3, 0xab, 0x98, 0x5f, 0x44, 0xa6, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
-  0xb7, 0x70, 0x9f, 0xfe, 0x00, 0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83,
-  0x96, 0x03, 0xb6, 0xc8, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xfb, 0x82, 0xa8,
-  0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0xfe,
-  0x15, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x22, 0x00, 0x00,
-  0x13, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06,
-  0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x21, 0x37, 0x05, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x66,
-  0x76, 0x76, 0xcc, 0xe3, 0x85, 0x86, 0x8d, 0x8d, 0xf1, 0x60, 0xbb, 0x5a,
-  0x59, 0x5a, 0x59, 0x5f, 0xa5, 0x5c, 0x5c, 0x0b, 0xfd, 0x07, 0xa5, 0x02,
-  0x4f, 0x0d, 0x54, 0x52, 0x8b, 0x7a, 0x4a, 0x4b, 0x02, 0x5e, 0xfa, 0x92,
-  0x91, 0xa1, 0xa2, 0xfe, 0xed, 0xfe, 0xf6, 0x9c, 0x9c, 0x2c, 0x2a, 0xae,
-  0x34, 0x1a, 0x1a, 0x63, 0x64, 0xbe, 0x90, 0x01, 0x9e, 0x57, 0x57, 0x5a,
-  0x5a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
-  0x04, 0x7b, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x35, 0x21, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x00, 0x11,
-  0x10, 0x00, 0x23, 0x22, 0x02, 0x37, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37,
-  0x66, 0x02, 0xf9, 0x0b, 0xb8, 0xa5, 0x5f, 0xb3, 0x59, 0x5a, 0xbb, 0x60,
-  0xf1, 0x01, 0x1a, 0xfe, 0xf5, 0xe3, 0xcc, 0xec, 0xa5, 0x02, 0x95, 0x7a,
-  0x8b, 0xa6, 0x0d, 0x02, 0x00, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a,
-  0x2c, 0xfe, 0xc8, 0xfe, 0xf6, 0xfe, 0xed, 0xfe, 0xbd, 0x01, 0x23, 0xc4,
-  0x97, 0xb4, 0xae, 0x9e, 0x00, 0x02, 0x00, 0x6f, 0xff, 0xe3, 0x05, 0xde,
-  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x34, 0x00, 0x00, 0x25, 0x36, 0x27, 0x36,
-  0x27, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x01, 0x16, 0x15, 0x10, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x26, 0x27, 0x26, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x37,
-  0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26,
-  0x35, 0x02, 0xf9, 0x5c, 0x02, 0x01, 0x09, 0xfd, 0xd5, 0x1b, 0x1d, 0x4a,
-  0x7a, 0x97, 0x01, 0x3d, 0x1c, 0x86, 0x85, 0xe3, 0xcd, 0x75, 0x54, 0x18,
-  0x02, 0xb1, 0x11, 0x18, 0x44, 0xbd, 0x61, 0x57, 0x5a, 0x59, 0x5a, 0xbb,
-  0x60, 0xf1, 0x8d, 0x20, 0x18, 0xb7, 0xa6, 0x22, 0x22, 0x5e, 0x27, 0x39,
-  0x9d, 0x4f, 0x4a, 0xd6, 0x8a, 0xcf, 0x3e, 0x38, 0xfe, 0x9c, 0x45, 0x23,
-  0x5a, 0x02, 0x90, 0x60, 0x76, 0xfe, 0xed, 0xa2, 0xa1, 0x91, 0x67, 0x9c,
-  0x01, 0xbb, 0x27, 0x23, 0x64, 0x01, 0x01, 0x19, 0x1a, 0x34, 0xae, 0x2a,
-  0x2c, 0x9c, 0x23, 0x29, 0x75, 0x94, 0x99, 0x31, 0x30, 0x9c, 0x60, 0x5a,
-  0xc8, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
-  0x04, 0x7c, 0x12, 0x06, 0x03, 0x49, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x04, 0x7c, 0x12, 0x06, 0x03, 0xcb, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x77, 0xff, 0xe3, 0x05, 0x8d, 0x04, 0x7c, 0x00, 0x3e,
-  0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x37, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x27, 0x26, 0x35, 0x05, 0x06, 0x02, 0x7b, 0x70, 0x7c, 0xe8, 0xd6, 0x48,
-  0x4d, 0x4b, 0x51, 0x40, 0x4c, 0x4d, 0x53, 0x88, 0x4d, 0x4b, 0x46, 0x41,
-  0x7b, 0x85, 0x8b, 0x69, 0x3c, 0x3d, 0x3f, 0x3e, 0x6b, 0x40, 0x49, 0x48,
-  0x57, 0x58, 0x99, 0x45, 0xb0, 0x66, 0x55, 0x0e, 0xd4, 0xa6, 0x22, 0x22,
-  0x5f, 0x26, 0x39, 0x9d, 0x4f, 0x4a, 0xfe, 0xfd, 0x3a, 0x02, 0x5c, 0x18,
-  0x92, 0x6c, 0xad, 0xb6, 0x0e, 0x0e, 0x1c, 0xab, 0x25, 0x13, 0x12, 0x38,
-  0x38, 0x5a, 0x58, 0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e,
-  0x0d, 0x0d, 0x1d, 0xa7, 0x18, 0x18, 0x4e, 0x42, 0x6a, 0x86, 0x94, 0x99,
-  0x31, 0x30, 0x9c, 0x60, 0x5a, 0xc8, 0xa6, 0x46, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x4b, 0x04, 0x7c, 0x00, 0x1a, 0x00, 0x2f, 0x00, 0x00,
-  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x37, 0x36,
-  0x02, 0xa6, 0xe2, 0x57, 0x59, 0x59, 0x5e, 0xbd, 0x88, 0x4c, 0x4c, 0x46,
-  0x41, 0x7b, 0x86, 0x8c, 0x68, 0x3d, 0x3d, 0x3f, 0x3e, 0x5e, 0xb1, 0x65,
-  0x67, 0x36, 0x36, 0x65, 0x70, 0x7c, 0xe8, 0xd7, 0xfe, 0xe6, 0xfe, 0xf4,
-  0x87, 0x88, 0x03, 0xdc, 0x6e, 0x72, 0xcd, 0xd0, 0x6f, 0x74, 0x38, 0x38,
-  0x5a, 0x58, 0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e, 0xa0,
-  0x4e, 0x4f, 0x8d, 0x5d, 0x40, 0x41, 0x18, 0x18, 0x92, 0x6c, 0xad, 0xb6,
-  0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x9d, 0x9e, 0x00, 0x01, 0xff, 0xde,
-  0xfe, 0x56, 0x01, 0xe6, 0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x33, 0x15, 0x23, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x36, 0x35, 0x11, 0x23, 0x35, 0x33, 0xae, 0xa5, 0x93, 0x93, 0x92, 0xa3,
-  0x3f, 0x2c, 0x5e, 0x45, 0xa3, 0xa3, 0x04, 0x60, 0xfe, 0x08, 0xa4, 0xfe,
-  0x28, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x01, 0xd8, 0xa4, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x05, 0x26, 0x06, 0x14, 0x00, 0x0b,
-  0x00, 0x30, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x17, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35,
-  0x1e, 0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02,
-  0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x34, 0x36, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x06, 0x15, 0x03, 0x45, 0x95, 0x86, 0x85, 0x94, 0x94,
-  0x85, 0x86, 0x95, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a,
-  0xa3, 0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe2, 0xba, 0x70, 0xa0, 0x33,
-  0x93, 0xa3, 0xab, 0x98, 0x5f, 0x44, 0x02, 0x3d, 0xc8, 0xdc, 0xdc, 0xc8,
-  0xc7, 0xdc, 0xdc, 0xeb, 0xfe, 0xe2, 0xfe, 0xe9, 0x1d, 0x1e, 0xb3, 0x2c,
-  0x2a, 0xbd, 0xbf, 0x5b, 0x63, 0x62, 0x01, 0x3a, 0x01, 0x03, 0x01, 0x04,
-  0x01, 0x3a, 0x62, 0x63, 0xc8, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb, 0x04, 0x60, 0x00, 0x0a,
-  0x00, 0x23, 0x00, 0x00, 0x01, 0x11, 0x21, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x17, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e,
-  0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
-  0x34, 0x12, 0x33, 0x21, 0x03, 0x45, 0xfe, 0xcc, 0x79, 0x87, 0x94, 0x85,
-  0x86, 0x95, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a, 0xa3,
-  0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe2, 0xba, 0x01, 0xe9, 0x02, 0x3d,
-  0x01, 0x88, 0xcd, 0xbb, 0xc7, 0xdc, 0xdc, 0xeb, 0xfe, 0xe2, 0xfe, 0xe9,
-  0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd, 0xbf, 0x5b, 0x63, 0x62, 0x01, 0x3a,
-  0x01, 0x03, 0xf9, 0x01, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0xe1, 0x04, 0x7b, 0x00, 0x1d, 0x00, 0x00, 0x25, 0x11,
-  0x23, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00,
-  0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x03, 0x4b, 0x8b, 0x01, 0x21, 0x5b, 0xc2, 0x6e,
-  0xe4, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x5e, 0xb1, 0x54, 0x55, 0xad, 0x59,
-  0xa2, 0xb2, 0xb2, 0xa2, 0x47, 0x6f, 0x9e, 0x01, 0x11, 0x8c, 0xfd, 0xf0,
-  0x24, 0x24, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x3a, 0x37, 0x37,
-  0xaa, 0x3e, 0x3e, 0xe3, 0xcd, 0xcd, 0xe3, 0x0f, 0x00, 0x02, 0x00, 0x56,
-  0xfe, 0x52, 0x03, 0xf4, 0x04, 0x60, 0x00, 0x13, 0x00, 0x23, 0x00, 0x00,
-  0x09, 0x01, 0x33, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x33, 0x01, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x02, 0x25, 0x01, 0x22, 0xad, 0xfe, 0x88, 0x5f, 0x23, 0x35, 0x87, 0x87,
-  0x87, 0x87, 0x35, 0x23, 0x5f, 0xfe, 0x88, 0xad, 0x01, 0x22, 0x3c, 0x1c,
-  0x19, 0x19, 0x24, 0x34, 0x34, 0x24, 0x19, 0x19, 0x1c, 0x01, 0xe8, 0x02,
-  0x78, 0xfc, 0xdc, 0xb1, 0x53, 0x80, 0x63, 0x81, 0x82, 0x82, 0x81, 0x63,
-  0x80, 0x53, 0xb1, 0x03, 0x24, 0xfa, 0x8e, 0x1b, 0x18, 0x2d, 0x45, 0x49,
-  0x64, 0x63, 0x63, 0x64, 0x49, 0x45, 0x2d, 0x18, 0x1b, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x56, 0xff, 0xe3, 0x03, 0xf4, 0x04, 0x60, 0x00, 0x13,
-  0x00, 0x23, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x33,
-  0x01, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x02, 0x25, 0x01, 0x0b, 0xc4, 0xfe, 0x99, 0x41,
-  0x27, 0x3e, 0x87, 0x87, 0x87, 0x87, 0x3e, 0x27, 0x41, 0xfe, 0x99, 0xc4,
-  0x01, 0x0b, 0x3c, 0x1c, 0x19, 0x23, 0x1c, 0x32, 0x32, 0x1c, 0x23, 0x19,
-  0x1c, 0x02, 0xd1, 0x01, 0x8f, 0xfd, 0xea, 0x62, 0x4c, 0x78, 0x3e, 0x82,
-  0x81, 0x81, 0x82, 0x3e, 0x78, 0x4c, 0x62, 0x02, 0x16, 0xfc, 0x1f, 0x1b,
-  0x18, 0x2d, 0x21, 0x40, 0x32, 0x46, 0x46, 0x32, 0x40, 0x21, 0x2d, 0x18,
-  0x1b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9c, 0xfe, 0x56, 0x03, 0xe9,
-  0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x11, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x9d, 0xa5, 0x70, 0x6f, 0x87, 0x9b, 0xa6, 0xa6, 0x3c, 0x9f,
-  0x6a, 0xad, 0xb4, 0x01, 0xba, 0x02, 0xa6, 0xfd, 0x61, 0x9f, 0x9f, 0xbe,
-  0xa4, 0x02, 0x7b, 0xf9, 0xf6, 0x02, 0x56, 0x66, 0x63, 0xf0, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d,
-  0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86,
-  0x9b, 0xa7, 0x93, 0xa3, 0xe5, 0xd0, 0x5f, 0x45, 0x3b, 0xa1, 0x6a, 0xad,
-  0xb3, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd,
-  0x87, 0x04, 0x7e, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xcc, 0x65, 0x64, 0xef,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x21,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36,
-  0x35, 0x11, 0x10, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x36,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x36, 0x33, 0x32, 0x16,
-  0x03, 0xf4, 0x93, 0xa3, 0xe5, 0xd2, 0x5f, 0x44, 0xdf, 0x86, 0x9b, 0xa7,
-  0x93, 0xa3, 0xe5, 0xd0, 0x5f, 0x45, 0x76, 0xd0, 0xad, 0xb3, 0x02, 0xa4,
-  0xfd, 0x48, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x02, 0xb2, 0x01, 0x3d, 0xbe,
-  0xa4, 0xfd, 0x87, 0x04, 0x7e, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xcc, 0xc9,
-  0xef, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0c, 0x00, 0x00, 0x01, 0xe8,
-  0x06, 0x14, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33,
-  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x15, 0x23,
-  0xaf, 0xa5, 0x94, 0x94, 0xa5, 0xa2, 0xa2, 0xa5, 0xa5, 0x04, 0x60, 0xfe,
-  0x08, 0xa4, 0xfe, 0x3c, 0x01, 0xc4, 0xa4, 0x03, 0xac, 0xe9, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x30, 0x04, 0x60, 0x10, 0x06,
-  0x03, 0x4d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x68, 0x00, 0x00, 0x02, 0x44,
-  0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x23, 0x11,
-  0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x68, 0x01, 0xdc, 0x98, 0x98, 0xfe,
-  0x24, 0x9f, 0x03, 0xbc, 0xa4, 0xa4, 0xfc, 0xe8, 0xa4, 0xa4, 0x03, 0x18,
-  0x00, 0x01, 0x00, 0x43, 0x00, 0x00, 0x02, 0x96, 0x06, 0x14, 0x00, 0x23,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x11, 0x23, 0x11, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x01, 0x1d, 0xa6, 0x01, 0x02, 0x0f, 0x0c, 0x22, 0x10, 0x10,
-  0x02, 0x71, 0x02, 0x2e, 0x2e, 0x52, 0x12, 0x11, 0xa6, 0x05, 0x05, 0x0f,
-  0x0c, 0x22, 0x10, 0x10, 0x02, 0x70, 0x01, 0x2e, 0x2e, 0x52, 0x16, 0x14,
-  0x06, 0x14, 0xfc, 0xed, 0x01, 0x01, 0x09, 0x25, 0x24, 0x52, 0x87, 0x49,
-  0x4a, 0x04, 0xfd, 0x85, 0x03, 0x02, 0x04, 0x03, 0x09, 0x25, 0x24, 0x52,
-  0x87, 0x49, 0x4a, 0x06, 0x00, 0x02, 0x00, 0x45, 0x00, 0x00, 0x02, 0xff,
-  0x06, 0x14, 0x00, 0x11, 0x00, 0x18, 0x00, 0x00, 0x01, 0x33, 0x11, 0x33,
-  0x15, 0x23, 0x11, 0x23, 0x11, 0x34, 0x27, 0x23, 0x22, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x14, 0x33, 0x01, 0x78, 0xa6,
-  0xe1, 0xe1, 0xa6, 0x01, 0x37, 0xfc, 0x01, 0x01, 0xdd, 0x30, 0x25, 0x0e,
-  0x15, 0x31, 0x46, 0x01, 0x53, 0x06, 0x14, 0xfc, 0xfe, 0xa0, 0xfd, 0x8e,
-  0x02, 0x54, 0x0f, 0x0f, 0xbd, 0xf6, 0x19, 0xfa, 0x84, 0x4b, 0x39, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x02, 0x23, 0x06, 0x14, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
-  0x35, 0x11, 0x01, 0x53, 0x37, 0x6c, 0x2c, 0x3f, 0xac, 0x89, 0x06, 0x14,
-  0xf9, 0xce, 0x7c, 0x74, 0x9c, 0xcc, 0xca, 0x06, 0x28, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0xfe, 0x4c, 0x04, 0xb1, 0x06, 0x14, 0x00, 0x24,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
-  0x11, 0x21, 0x15, 0x02, 0xf0, 0x5e, 0x74, 0x59, 0x4d, 0x49, 0xfe, 0xee,
-  0xfc, 0x55, 0x59, 0x5a, 0x5f, 0x4c, 0xb4, 0x62, 0xaa, 0x5a, 0x5a, 0x53,
-  0x52, 0x96, 0x9d, 0x01, 0x83, 0xfd, 0xac, 0xa5, 0xa5, 0x03, 0x0e, 0x01,
-  0xdc, 0x38, 0x2b, 0x6c, 0x68, 0x8a, 0xdd, 0xf2, 0x12, 0x13, 0x25, 0xc3,
-  0x31, 0x32, 0x4b, 0x4b, 0x8f, 0x84, 0x4b, 0x4a, 0xa6, 0x01, 0xf3, 0xfc,
-  0x33, 0x06, 0x14, 0xfe, 0x4c, 0xa8, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xff, 0xe6, 0x06, 0x67, 0x04, 0x62, 0x00, 0x26, 0x00, 0x00, 0x25, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x03, 0x50, 0x3d, 0x58, 0x56, 0x75, 0x9e, 0xab, 0xa7, 0x66, 0x6a,
-  0x80, 0x4b, 0x4b, 0xa6, 0x67, 0x6b, 0x7f, 0x95, 0xa7, 0xa7, 0x37, 0x51,
-  0x4f, 0x6d, 0x6d, 0x4e, 0x4c, 0xd8, 0x79, 0x3d, 0x3c, 0xf6, 0xe2, 0x02,
-  0xa4, 0xfd, 0x62, 0xa2, 0x9c, 0x60, 0x5e, 0xa4, 0x02, 0x7a, 0xfd, 0x62,
-  0xa2, 0x9c, 0xc0, 0xa2, 0x02, 0x7a, 0xfb, 0x9e, 0xb0, 0x65, 0x33, 0x32,
-  0x3e, 0x3e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x06, 0x67,
-  0x04, 0x62, 0x00, 0x26, 0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
-  0x23, 0x11, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x03, 0x50, 0x3d,
-  0x58, 0x56, 0x75, 0x9e, 0xab, 0xa7, 0x66, 0x6a, 0x80, 0x4b, 0x4b, 0xa6,
-  0x67, 0x6b, 0x7f, 0x95, 0xa7, 0xa7, 0x37, 0x51, 0x4f, 0x6d, 0x6d, 0x4e,
-  0x4c, 0xd8, 0x79, 0x3d, 0x3c, 0xf6, 0xe2, 0x02, 0xa4, 0xfd, 0x62, 0xa2,
-  0x9c, 0x60, 0x5e, 0xa4, 0x02, 0x7a, 0xfd, 0x62, 0xa2, 0x9c, 0xc0, 0xa2,
-  0x02, 0x7a, 0xf9, 0xf4, 0x02, 0x5a, 0x65, 0x33, 0x32, 0x3e, 0x3e, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x06, 0x67, 0x04, 0x7b, 0x00, 0x30,
-  0x00, 0x00, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x14,
-  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x03, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x16, 0x03, 0xbe, 0x3f, 0xac, 0x75, 0x9e, 0x55, 0x56, 0x4a,
-  0x49, 0xa3, 0xe4, 0xd1, 0x5f, 0x22, 0x22, 0x01, 0x66, 0x6a, 0x80, 0x96,
-  0xa6, 0x33, 0x34, 0x6b, 0x7f, 0x4a, 0x4b, 0xa7, 0xa7, 0x39, 0x9e, 0x6d,
-  0x6e, 0x4c, 0x4e, 0x03, 0x89, 0x7c, 0x76, 0x7b, 0x7a, 0xe2, 0xfd, 0x48,
-  0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x02, 0xb2, 0xa1, 0x9c, 0xbe,
-  0xa4, 0xfd, 0x87, 0x02, 0x9e, 0xa2, 0x4e, 0x4d, 0x5f, 0x60, 0xa3, 0xfd,
-  0x87, 0x04, 0x60, 0xae, 0x67, 0x62, 0x3e, 0x3e, 0x00, 0x01, 0xff, 0xde,
-  0xfe, 0x56, 0x03, 0xfa, 0x04, 0x7b, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x14, 0x06, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x03, 0xfa, 0xa6, 0x6f, 0x70, 0x86, 0x9c, 0x92, 0xa3, 0x3f,
-  0x2c, 0x5e, 0x45, 0xa6, 0x3c, 0xa1, 0x69, 0xae, 0xb2, 0x02, 0xa4, 0xfd,
-  0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x73, 0xd6, 0xc0, 0x9c,
-  0x61, 0x99, 0x04, 0x74, 0xae, 0x65, 0x64, 0xef, 0x00, 0x01, 0x00, 0xa7,
-  0xfe, 0x56, 0x04, 0xc3, 0x04, 0x7b, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x26,
-  0x35, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
-  0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x17, 0x16, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x03, 0x98, 0x4a, 0x70, 0x6f, 0x86, 0x9b, 0xa7,
-  0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3, 0x22, 0x22, 0x5e, 0x2d, 0x3f, 0xa3,
-  0xfe, 0xb6, 0x60, 0xd6, 0x02, 0xb2, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87,
-  0x04, 0x60, 0xae, 0x65, 0x64, 0xef, 0xe8, 0xfd, 0x48, 0x99, 0x31, 0x30,
-  0x9c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa1, 0x00, 0x00, 0x03, 0xf4,
-  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
-  0x23, 0x01, 0x11, 0x23, 0xa1, 0xf5, 0x01, 0xad, 0xb1, 0xf5, 0xfe, 0x53,
-  0xb1, 0x04, 0x60, 0xfc, 0x79, 0x03, 0x87, 0xfb, 0xa0, 0x03, 0x6c, 0xfc,
-  0x94, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x04, 0x7b, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x00, 0x01, 0x22,
-  0x06, 0x07, 0x21, 0x2e, 0x01, 0x03, 0x32, 0x36, 0x35, 0x21, 0x14, 0x16,
-  0x13, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
-  0x02, 0x32, 0x84, 0x86, 0x10, 0x02, 0x35, 0x10, 0x86, 0x84, 0x87, 0x97,
-  0xfd, 0xc5, 0x97, 0x87, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xf5, 0xf5, 0x03,
-  0xdf, 0xc1, 0x7f, 0x7f, 0xc1, 0xfc, 0xa0, 0xe8, 0x94, 0x94, 0xe8, 0x03,
-  0xfc, 0xfe, 0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x39, 0x01,
-  0x13, 0x01, 0x14, 0x01, 0x38, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0x00, 0x00, 0x05, 0x87, 0x04, 0x60, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00,
-  0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x20,
-  0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x21, 0x17, 0x23, 0x22, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x05, 0x7a, 0xfe, 0x0c, 0x01, 0xe0,
-  0xfe, 0x20, 0x02, 0x01, 0xfd, 0x31, 0xfe, 0xdb, 0x96, 0x97, 0x97, 0x96,
-  0x01, 0x25, 0x26, 0x22, 0xd8, 0x6c, 0x6c, 0x6c, 0x6c, 0xd8, 0x22, 0x04,
-  0x60, 0x9a, 0xfe, 0xdd, 0x9b, 0xfe, 0x94, 0x9c, 0x8e, 0x8f, 0x01, 0x14,
-  0x01, 0x12, 0x8e, 0x8f, 0x82, 0x6c, 0x6b, 0xd8, 0xd9, 0x6c, 0x6d, 0x00,
-  0x00, 0x02, 0x00, 0x85, 0xff, 0xdc, 0x04, 0xb8, 0x04, 0x7c, 0x00, 0x13,
-  0x00, 0x24, 0x00, 0x00, 0x01, 0x15, 0x14, 0x16, 0x32, 0x37, 0x36, 0x35,
-  0x10, 0x02, 0x20, 0x02, 0x11, 0x14, 0x17, 0x16, 0x32, 0x36, 0x3d, 0x01,
-  0x05, 0x10, 0x00, 0x20, 0x00, 0x11, 0x14, 0x06, 0x07, 0x06, 0x22, 0x26,
-  0x27, 0x0e, 0x01, 0x22, 0x26, 0x02, 0xf4, 0x56, 0x61, 0x22, 0x42, 0xbc,
-  0xfe, 0x97, 0xb6, 0x42, 0x22, 0x60, 0x56, 0xfe, 0x37, 0x01, 0x22, 0x01,
-  0xec, 0x01, 0x25, 0x34, 0x2a, 0x57, 0xc2, 0x91, 0x0b, 0x10, 0x8e, 0xc0,
-  0xc2, 0x02, 0x94, 0xc4, 0xa3, 0xb5, 0x30, 0x5b, 0x9d, 0x01, 0x0f, 0x01,
-  0x31, 0xfe, 0xd0, 0xfe, 0xf0, 0x9d, 0x5b, 0x30, 0xb5, 0xa3, 0xc4, 0xc8,
-  0x01, 0x54, 0x01, 0x5c, 0xfe, 0xa4, 0xfe, 0x80, 0x6c, 0xb2, 0x36, 0x70,
-  0xa3, 0x75, 0x79, 0x9f, 0xed, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x64,
-  0xfe, 0x56, 0x04, 0x56, 0x06, 0x14, 0x12, 0x06, 0x03, 0x69, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0xff, 0xe5, 0x02, 0x4f, 0x04, 0x60, 0x00, 0x0e,
-  0x00, 0x00, 0x25, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x16, 0x33, 0x32, 0x36,
-  0x35, 0x11, 0x33, 0x11, 0x23, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32, 0x01,
-  0x36, 0x4f, 0x8d, 0x96, 0xa6, 0xa6, 0xae, 0xc9, 0x0a, 0xbd, 0x23, 0xcb,
-  0xbe, 0x02, 0x4e, 0xfb, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0xff, 0xe5, 0x02, 0x4f, 0x06, 0x0a, 0x00, 0x0e, 0x00, 0x00, 0x25, 0x06,
-  0x23, 0x22, 0x2f, 0x01, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
-  0x23, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32, 0x01, 0x36, 0x4f, 0x8f, 0x94,
-  0xa6, 0xa6, 0xae, 0xc9, 0x0a, 0xbd, 0x23, 0xce, 0xbb, 0x03, 0xf8, 0xf9,
-  0xf6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0xfe, 0x56, 0x03, 0x1e,
-  0x04, 0x60, 0x00, 0x16, 0x00, 0x00, 0x25, 0x06, 0x23, 0x22, 0x2f, 0x01,
-  0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x26, 0x35, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32, 0x01,
-  0x36, 0x4f, 0x8d, 0x96, 0xa6, 0x45, 0x5e, 0x2c, 0x3f, 0xa2, 0x93, 0xae,
-  0xc9, 0x0a, 0xbd, 0x23, 0xcb, 0xbe, 0x02, 0x4e, 0xfb, 0x8c, 0x99, 0x61,
-  0x9c, 0xc0, 0xd6, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0x58, 0x02, 0xf6,
-  0x04, 0x7b, 0x00, 0x11, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
-  0x02, 0xf6, 0x1c, 0x42, 0x27, 0x8d, 0x96, 0xa7, 0xa7, 0x34, 0xa8, 0x77,
-  0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11, 0xcb, 0xbe, 0xfc, 0x0a, 0x06,
-  0x08, 0xae, 0x66, 0x63, 0x05, 0x05, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xfe, 0x56, 0x02, 0xf6, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x15, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x26, 0x35, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
-  0x02, 0xf6, 0x1c, 0x42, 0x27, 0x8e, 0x96, 0x44, 0x5f, 0xd2, 0xe5, 0xa3,
-  0x93, 0xa7, 0x34, 0xa8, 0x77, 0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11,
-  0xcb, 0xbe, 0xfd, 0x9e, 0x99, 0x61, 0x9c, 0xc0, 0xd6, 0x04, 0x74, 0xae,
-  0x66, 0x63, 0x05, 0x05, 0x00, 0x01, 0x00, 0x76, 0x00, 0x00, 0x03, 0x25,
-  0x04, 0x7b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x21, 0x35,
-  0x33, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x01, 0xb0,
-  0x94, 0xfe, 0x33, 0x93, 0x93, 0xa3, 0xe5, 0xd2, 0x5f, 0x44, 0x02, 0xe5,
-  0xfd, 0xbf, 0xa4, 0xa4, 0x02, 0x41, 0xd6, 0xc0, 0x9c, 0x61, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x68, 0x00, 0x00, 0x03, 0x25, 0x04, 0x7b, 0x00, 0x0f,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x34, 0x26,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x02, 0x83, 0xa2, 0xfe, 0x24, 0x94,
-  0x44, 0x5f, 0xd2, 0xe5, 0xa3, 0x93, 0x02, 0xe5, 0xfd, 0xbf, 0xa4, 0xa4,
-  0x02, 0x41, 0x99, 0x61, 0x9c, 0xc0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x22, 0x04, 0x60, 0x00, 0x13, 0x00, 0x1c, 0x00, 0x00,
-  0x01, 0x1e, 0x01, 0x17, 0x13, 0x23, 0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11,
-  0x23, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x02, 0xc5, 0x2b, 0x68, 0x2d, 0x9d, 0xb0,
-  0x92, 0x42, 0x6f, 0x49, 0x98, 0xa7, 0x01, 0x5e, 0xc4, 0xc0, 0x64, 0xfe,
-  0x29, 0xb2, 0x6b, 0x73, 0x6a, 0x74, 0x02, 0x0d, 0x0a, 0x74, 0x5d, 0xfe,
-  0xce, 0x01, 0x1f, 0x80, 0x3a, 0xfe, 0x27, 0x04, 0x60, 0x9e, 0xa5, 0x69,
-  0x8c, 0x01, 0x9d, 0xfe, 0xaf, 0x56, 0x4e, 0x4d, 0x60, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x22, 0x04, 0x60, 0x00, 0x13,
-  0x00, 0x1c, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x32, 0x36, 0x37, 0x13,
-  0x33, 0x03, 0x0e, 0x01, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21,
-  0x13, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0xa7, 0xa7, 0x98,
-  0x49, 0x6f, 0x42, 0x92, 0xb0, 0x9d, 0x2d, 0x68, 0x2b, 0x60, 0x64, 0xc0,
-  0xc4, 0xfe, 0xa2, 0xa7, 0xb2, 0x74, 0x6a, 0x73, 0x6b, 0x04, 0x60, 0xfe,
-  0x27, 0x3a, 0x80, 0x01, 0x1f, 0xfe, 0xce, 0x5d, 0x74, 0x0a, 0x1b, 0x8c,
-  0x69, 0xa5, 0x9e, 0x01, 0xec, 0xfe, 0xaf, 0x60, 0x4d, 0x4e, 0x56, 0x00,
-  0x00, 0x01, 0x00, 0x63, 0xfe, 0x56, 0x03, 0x67, 0x04, 0x7b, 0x00, 0x30,
-  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x1f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x15,
-  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36,
-  0x33, 0x32, 0x16, 0x03, 0x30, 0x46, 0x97, 0x51, 0x7b, 0x7c, 0x59, 0x85,
-  0x38, 0xb1, 0x94, 0xde, 0xc2, 0x5b, 0x4f, 0x12, 0x44, 0x5e, 0xd2, 0xe4,
-  0xa3, 0x93, 0xb7, 0xae, 0x75, 0x7e, 0x5b, 0x9a, 0x39, 0x9a, 0x89, 0xca,
-  0xb9, 0x5c, 0xa2, 0x04, 0x3f, 0xae, 0x28, 0x28, 0x54, 0x54, 0x40, 0x49,
-  0x21, 0x0e, 0x2a, 0x99, 0x89, 0x9c, 0xb6, 0x11, 0x04, 0x0c, 0x99, 0x61,
-  0x9c, 0xc0, 0xd6, 0xfb, 0x6a, 0x59, 0x51, 0x4b, 0x50, 0x25, 0x0f, 0x24,
-  0x95, 0x82, 0x9e, 0xac, 0x1e, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xdc,
-  0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x13, 0x00, 0x00, 0x17, 0x11,
-  0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11, 0x14, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0xab, 0x9d, 0xaa, 0x9c, 0x9e, 0x59,
-  0x45, 0x93, 0xa3, 0x3f, 0x2c, 0x5f, 0x43, 0x14, 0x04, 0xc2, 0xbb, 0xab,
-  0x99, 0x50, 0x68, 0xfb, 0x29, 0xd6, 0xc0, 0x9c, 0x61, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xdc, 0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x20,
-  0x00, 0x00, 0x13, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06,
-  0x15, 0x11, 0x15, 0x33, 0x15, 0x23, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x36, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x23, 0x35, 0xab,
-  0x9d, 0xaa, 0x9c, 0x9e, 0x59, 0x45, 0x92, 0x92, 0x93, 0xa3, 0x3f, 0x2c,
-  0x5f, 0x43, 0xa2, 0xa2, 0x9e, 0x04, 0x60, 0x4e, 0xbb, 0xab, 0x99, 0x50,
-  0x68, 0xfd, 0xa8, 0x03, 0xa4, 0xfe, 0x28, 0xd6, 0xc0, 0x9c, 0x61, 0x99,
-  0x01, 0xd8, 0xa4, 0x01, 0x69, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31,
-  0xfe, 0x56, 0x02, 0xe3, 0x04, 0x65, 0x00, 0x13, 0x00, 0x00, 0x05, 0x11,
-  0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x16,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x01, 0x6e, 0x45, 0x59, 0x9e, 0x9c,
-  0xaa, 0x9d, 0x43, 0x5f, 0x2c, 0x3f, 0xa3, 0x93, 0x14, 0x03, 0x28, 0x68,
-  0x50, 0x99, 0xab, 0xbb, 0xfc, 0xed, 0x99, 0x61, 0x9c, 0xc0, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0x0d, 0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x16,
-  0x00, 0x1f, 0x00, 0x00, 0x21, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x23,
-  0x20, 0x35, 0x34, 0x3b, 0x01, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x06, 0x15, 0x03, 0x23, 0x22, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x01, 0x52, 0xa4, 0xac, 0x10, 0x30, 0x49, 0xa3, 0xfe, 0xef, 0xf3, 0xab,
-  0x9d, 0xaa, 0x9c, 0x9e, 0x59, 0x45, 0xb0, 0xa1, 0x6b, 0x02, 0x03, 0x70,
-  0x63, 0x1e, 0x0e, 0x9b, 0x6f, 0x40, 0x60, 0xd8, 0xd2, 0x04, 0xae, 0xbb,
-  0xab, 0x99, 0x50, 0x68, 0xfa, 0xa3, 0x33, 0x41, 0x30, 0x18, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x31, 0xfe, 0xc0, 0x02, 0xa7, 0x04, 0x5e, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x34, 0x26, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x16, 0x15, 0x11, 0x33, 0x15, 0x23, 0x11, 0x01, 0x87,
-  0xfe, 0xab, 0x01, 0x55, 0x44, 0x67, 0xaa, 0xaa, 0xbf, 0x92, 0x7a, 0x7a,
-  0xfe, 0xc0, 0x01, 0x3e, 0x8f, 0x02, 0x60, 0x89, 0x4e, 0x9a, 0x9f, 0xd2,
-  0xfd, 0xa0, 0x8f, 0xfe, 0xc2, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31,
-  0xfe, 0x56, 0x02, 0xab, 0x05, 0x9e, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
-  0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55, 0xfe, 0xab,
-  0x44, 0x5e, 0xb6, 0xc9, 0xa3, 0x93, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2,
-  0x8f, 0xfc, 0x1b, 0x99, 0x61, 0x9c, 0xc0, 0xd6, 0x03, 0xe5, 0x8f, 0x01,
-  0x3e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0xff, 0xe3, 0x04, 0x91,
-  0x04, 0x60, 0x00, 0x16, 0x00, 0x1e, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x35, 0x0e, 0x01,
-  0x23, 0x22, 0x26, 0x3d, 0x01, 0x23, 0x35, 0x05, 0x21, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x9d, 0xa5, 0x02, 0x01, 0xa6, 0xa7, 0xa7, 0xa6, 0x3c,
-  0x9f, 0x6a, 0xad, 0xb4, 0x9d, 0x03, 0x42, 0xfe, 0x00, 0x70, 0x6f, 0x81,
-  0xa0, 0x02, 0x68, 0x01, 0xf8, 0xfe, 0x08, 0x01, 0xf8, 0xfe, 0x08, 0xa4,
-  0xfe, 0x3c, 0xac, 0x66, 0x63, 0xf0, 0xe7, 0x0a, 0xa4, 0xa5, 0x02, 0x9f,
-  0x9f, 0xba, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe2, 0x04, 0x11,
-  0x04, 0x60, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x23, 0x1e, 0x01, 0x15, 0x14,
-  0x00, 0x23, 0x22, 0x00, 0x35, 0x34, 0x36, 0x37, 0x23, 0x35, 0x21, 0x15,
-  0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27,
-  0x37, 0x21, 0x04, 0x10, 0xd4, 0x57, 0x73, 0xff, 0x00, 0xca, 0xcb, 0xff,
-  0x00, 0x73, 0x57, 0xd5, 0x01, 0x8e, 0x5c, 0x7b, 0x9f, 0x81, 0x82, 0x9e,
-  0x7a, 0x5c, 0x01, 0x01, 0x88, 0x03, 0xbc, 0x48, 0xeb, 0x98, 0xeb, 0xfe,
-  0xdc, 0x01, 0x24, 0xeb, 0x98, 0xeb, 0x48, 0xa4, 0xdc, 0x42, 0xd7, 0x8b,
-  0x9f, 0xc2, 0xc2, 0x9f, 0x8b, 0xd7, 0x42, 0xdc, 0x00, 0x01, 0x00, 0xad,
-  0x00, 0x00, 0x03, 0xed, 0x04, 0x62, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x14,
-  0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14,
-  0x17, 0x16, 0x37, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x35,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x03, 0xec, 0x7f, 0x83, 0xc8, 0x3f, 0xa3,
-  0x49, 0x49, 0xa5, 0x23, 0x24, 0x5c, 0x2e, 0x82, 0x9e, 0x42, 0x42, 0x63,
-  0x5d, 0x50, 0x96, 0x2e, 0x1e, 0x02, 0x0f, 0xee, 0x8f, 0x92, 0x60, 0x60,
-  0xd6, 0x02, 0xca, 0xfd, 0x36, 0x99, 0x31, 0x32, 0x02, 0xc4, 0x9e, 0xe8,
-  0x65, 0x63, 0x1e, 0x96, 0x08, 0x30, 0x5b, 0xab, 0x73, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x06,
-  0x00, 0x00, 0x33, 0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0x37, 0x01, 0x7a,
-  0xe1, 0x01, 0x7a, 0xb0, 0xfe, 0xc5, 0xfe, 0xc5, 0x04, 0x60, 0xfb, 0xa0,
-  0x03, 0xac, 0xfc, 0x54, 0x00, 0x01, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
-  0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x21, 0x23, 0x0b, 0x01, 0x23, 0x0b,
-  0x01, 0x23, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x05, 0x96, 0xa6, 0xce, 0xcf,
-  0xc3, 0xcf, 0xce, 0xa6, 0x01, 0x08, 0xc3, 0xd9, 0xda, 0xc3, 0x03, 0x6a,
-  0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96, 0x04, 0x60, 0xfc, 0x6a, 0x03, 0x96,
-  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x11,
-  0x00, 0x00, 0x33, 0x01, 0x36, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x07, 0x06, 0x0f, 0x01, 0x01, 0x23, 0x09, 0x01, 0x37, 0x01, 0xbb, 0x47,
-  0x41, 0x43, 0x70, 0x84, 0x61, 0x45, 0x25, 0x29, 0x2b, 0x1e, 0x01, 0x98,
-  0xb0, 0xfe, 0xc4, 0xfe, 0xc6, 0x04, 0xd2, 0xc7, 0x3e, 0x3d, 0x9a, 0x24,
-  0x23, 0x87, 0x5e, 0xfb, 0xb2, 0x03, 0x6c, 0xfc, 0x94, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5b, 0x00, 0x00, 0x03, 0xfa, 0x04, 0x60, 0x00, 0x08,
-  0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01, 0x11, 0x23, 0x11, 0x5c,
-  0xc3, 0x01, 0x08, 0x01, 0x10, 0xc3, 0xfe, 0x87, 0xb7, 0x04, 0x60, 0xfe,
-  0x38, 0x01, 0xc8, 0xfd, 0x90, 0xfe, 0x10, 0x01, 0xf0, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x4f, 0xfe, 0x56, 0x04, 0x46, 0x04, 0x60, 0x00, 0x13,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15, 0x14, 0x16, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x21, 0x35, 0x01, 0x21, 0x66, 0x03,
-  0x12, 0xfd, 0x92, 0x02, 0x6e, 0x45, 0x5e, 0x2b, 0x40, 0xa2, 0x93, 0xfd,
-  0x7e, 0x02, 0x6f, 0xfd, 0xa8, 0x04, 0x60, 0xa8, 0xfc, 0xdb, 0xa7, 0x99,
-  0x61, 0x9c, 0xc0, 0xd6, 0x14, 0xa8, 0x03, 0x25, 0x00, 0x02, 0x00, 0x4f,
-  0xff, 0x91, 0x03, 0x79, 0x04, 0x60, 0x00, 0x1a, 0x00, 0x21, 0x00, 0x00,
-  0x13, 0x21, 0x15, 0x01, 0x33, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x16, 0x07, 0x06, 0x2b, 0x01, 0x06, 0x15, 0x23, 0x34, 0x37, 0x21,
-  0x35, 0x01, 0x21, 0x01, 0x33, 0x32, 0x35, 0x34, 0x07, 0x06, 0x66, 0x03,
-  0x12, 0xfd, 0x92, 0x9d, 0x1e, 0x4c, 0x3b, 0x56, 0x77, 0x34, 0x22, 0x01,
-  0x38, 0x49, 0x72, 0x5e, 0x03, 0x8a, 0x03, 0xfe, 0xba, 0x02, 0x6f, 0xfd,
-  0xa8, 0x01, 0xcc, 0x32, 0x7c, 0x3f, 0x4f, 0x04, 0x60, 0xa8, 0xfc, 0xdb,
-  0xa2, 0x47, 0x37, 0x57, 0x39, 0x57, 0x60, 0x2f, 0x3d, 0x33, 0x3c, 0x3b,
-  0x34, 0xa8, 0x03, 0x25, 0xfc, 0xc6, 0x36, 0x5d, 0x02, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0xc4, 0x04, 0x60, 0x00, 0x20,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x35, 0x21, 0x15, 0x02,
-  0x03, 0x5f, 0x73, 0x59, 0x4d, 0x49, 0xfe, 0xee, 0xfc, 0x54, 0x59, 0x5a,
-  0x60, 0x4c, 0xb4, 0x62, 0xab, 0x59, 0x5a, 0x53, 0x54, 0x94, 0x9d, 0x01,
-  0x83, 0xfd, 0xa8, 0x03, 0x13, 0x01, 0xdc, 0x38, 0x2a, 0x6d, 0x68, 0x8a,
-  0xdd, 0xf2, 0x12, 0x13, 0x25, 0xc3, 0x31, 0x32, 0x4b, 0x4b, 0x8f, 0x84,
-  0x4b, 0x4a, 0xa6, 0x01, 0xf3, 0x93, 0xa8, 0x00, 0x00, 0x02, 0x00, 0x62,
-  0xfe, 0x4c, 0x03, 0xfb, 0x04, 0x60, 0x00, 0x24, 0x00, 0x2d, 0x00, 0x00,
-  0x01, 0x20, 0x37, 0x36, 0x05, 0x16, 0x17, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x2b, 0x01, 0x35, 0x01, 0x21, 0x35, 0x21, 0x15, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x15, 0x23, 0x34, 0x27, 0x30, 0x07,
-  0x06, 0x37, 0x26, 0x23, 0x22, 0x07, 0x14, 0x33, 0x32, 0x37, 0x01, 0xb6,
-  0xfe, 0xd3, 0x02, 0x01, 0x01, 0x0d, 0xdd, 0x8e, 0x0b, 0x53, 0x54, 0x94,
-  0x9d, 0x01, 0x83, 0xfd, 0xa8, 0x03, 0x13, 0xfe, 0x8e, 0x5e, 0x74, 0x5a,
-  0x4c, 0x49, 0x23, 0x5a, 0x8a, 0x24, 0x12, 0x88, 0x08, 0x70, 0xb1, 0x76,
-  0x01, 0x8e, 0xab, 0x59, 0xfe, 0x4c, 0xbd, 0xfb, 0x05, 0x04, 0x3b, 0x2a,
-  0x31, 0x85, 0x4a, 0x4a, 0xa6, 0x01, 0xf3, 0x93, 0xa8, 0xfe, 0x24, 0x38,
-  0x2b, 0x6c, 0x67, 0x8b, 0x71, 0x55, 0x65, 0xa4, 0x52, 0x38, 0x11, 0x79,
-  0xfa, 0x2a, 0x4b, 0x2f, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f,
-  0x00, 0x00, 0x03, 0x48, 0x06, 0x12, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
-  0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x11, 0x23, 0x01, 0x32, 0x39, 0xad, 0x4d, 0x34, 0x01, 0x33, 0x59,
-  0xa1, 0x48, 0x47, 0x47, 0x46, 0x45, 0x48, 0x49, 0x4d, 0xf7, 0x7d, 0x62,
-  0x62, 0x64, 0x99, 0xb6, 0x03, 0x1e, 0x72, 0x4c, 0x62, 0x85, 0x41, 0x72,
-  0x16, 0x15, 0x2b, 0xac, 0x23, 0x11, 0x12, 0x9d, 0x7d, 0xba, 0xaa, 0x73,
-  0x77, 0x1e, 0xfd, 0x74, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48,
-  0x06, 0x12, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x33, 0x02,
-  0x64, 0xb6, 0x99, 0x65, 0x61, 0x63, 0x7c, 0xf7, 0x4d, 0x48, 0x49, 0x45,
-  0x46, 0x48, 0x46, 0x48, 0xa1, 0x59, 0x33, 0x01, 0x34, 0x4d, 0xad, 0x03,
-  0x1e, 0xfc, 0xe2, 0x02, 0x8c, 0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d, 0x9d,
-  0x12, 0x11, 0x23, 0xac, 0x2b, 0x15, 0x16, 0x72, 0x41, 0x85, 0x62, 0x4c,
-  0x72, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48,
-  0x06, 0x12, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x13, 0x33, 0x11, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x34, 0x27, 0x26, 0x23, 0x01,
-  0x32, 0x01, 0xb6, 0x99, 0x64, 0x62, 0x62, 0x7d, 0xf7, 0x4d, 0x49, 0x48,
-  0x45, 0x46, 0x47, 0x47, 0x48, 0xa1, 0x59, 0x33, 0x01, 0x34, 0x4d, 0xad,
-  0x02, 0xf4, 0x03, 0x1e, 0xfd, 0x74, 0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d,
-  0x9d, 0x12, 0x11, 0x23, 0xac, 0x2b, 0x15, 0x16, 0x72, 0x41, 0x85, 0x62,
-  0x4c, 0x72, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0x48,
-  0x06, 0x14, 0x00, 0x23, 0x00, 0x00, 0x13, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
-  0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x4f, 0x63, 0x7c, 0xf7, 0x4d, 0x48,
-  0x49, 0x45, 0x42, 0x4c, 0x46, 0x48, 0x9f, 0x5b, 0x34, 0x34, 0x5c, 0x9e,
-  0x48, 0x46, 0x48, 0x46, 0x45, 0x49, 0x48, 0x4d, 0xf7, 0x7c, 0x63, 0x04,
-  0x40, 0xba, 0x7d, 0x9d, 0x12, 0x11, 0x23, 0xac, 0x28, 0x18, 0x16, 0x72,
-  0x41, 0x85, 0xfb, 0xe0, 0x85, 0x41, 0x72, 0x16, 0x15, 0x2b, 0xac, 0x23,
-  0x11, 0x12, 0x9d, 0x7d, 0xba, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x22,
-  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x06, 0x22, 0x27, 0x26, 0x00, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20, 0x12,
-  0x11, 0x10, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x10,
-  0x00, 0x02, 0x70, 0x1e, 0x1d, 0x2b, 0x2a, 0x1e, 0x1d, 0x3b, 0x55, 0x1d,
-  0x1e, 0x01, 0x2c, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0xfe, 0x52,
-  0x01, 0x1b, 0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad,
-  0x01, 0x53, 0x02, 0xe9, 0x2e, 0x22, 0x22, 0x22, 0x22, 0x2e, 0x2f, 0x42,
-  0x21, 0x21, 0x02, 0x92, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8,
-  0x01, 0x48, 0x01, 0x1a, 0x01, 0x1b, 0x01, 0xec, 0xfe, 0x5b, 0xfe, 0x9e,
-  0xfe, 0x9f, 0xfe, 0x5b, 0x01, 0xa4, 0x02, 0xc4, 0x01, 0xa5, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xd2, 0x04, 0x60, 0x10, 0x06,
-  0x03, 0xc6, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x4b,
-  0x04, 0x7c, 0x00, 0x1a, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
-  0x20, 0x17, 0x16, 0x11, 0x10, 0x00, 0x21, 0x22, 0x26, 0x35, 0x34, 0x36,
-  0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x02, 0x0b, 0x6b, 0x3e,
-  0x3f, 0x3d, 0x3c, 0x69, 0x8b, 0x85, 0x7b, 0x41, 0x46, 0x4b, 0x4d, 0x88,
-  0xbd, 0x5d, 0x59, 0x59, 0x57, 0xef, 0x01, 0x3e, 0x88, 0x88, 0xfe, 0xf4,
-  0xfe, 0xe5, 0xd6, 0xe8, 0x7c, 0x70, 0x65, 0x36, 0x36, 0x66, 0x66, 0x03,
-  0xdc, 0x2e, 0x2e, 0x40, 0x46, 0x2d, 0x2c, 0x98, 0x33, 0x38, 0x58, 0x5a,
-  0x38, 0x38, 0x74, 0x6f, 0xd0, 0xcd, 0x72, 0x6e, 0xa0, 0x9e, 0x9d, 0xfe,
-  0xee, 0xfe, 0xf2, 0xfe, 0xc2, 0xb6, 0xad, 0x6c, 0x92, 0x18, 0x18, 0x41,
-  0x40, 0x5d, 0x8d, 0x4f, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
-  0xff, 0xe3, 0x05, 0x37, 0x06, 0x14, 0x00, 0x27, 0x00, 0x00, 0x25, 0x11,
-  0x23, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00,
-  0x33, 0x32, 0x16, 0x17, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x06, 0x15, 0x11, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x03, 0x4b, 0x8b, 0x01, 0x21, 0x5b, 0xc2, 0x6e, 0xe4, 0xfe,
-  0xf4, 0x01, 0x0f, 0xeb, 0x32, 0x5e, 0x2c, 0x93, 0xa3, 0xe5, 0xd0, 0x5f,
-  0x45, 0x55, 0xad, 0x59, 0xa2, 0xb2, 0xb2, 0xa2, 0x47, 0x6f, 0x9e, 0x01,
-  0x11, 0x8c, 0xfd, 0xf0, 0x24, 0x24, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12,
-  0x01, 0x3a, 0x0f, 0x0f, 0x21, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xfe, 0xe5,
-  0x3e, 0x3e, 0xe3, 0xcd, 0xcd, 0xe3, 0x0f, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x0e, 0x04, 0x60, 0x10, 0x06, 0x03, 0xd1, 0x00, 0x00,
-  0x00, 0x03, 0xff, 0x0d, 0xfe, 0x56, 0x01, 0xf7, 0x06, 0x14, 0x00, 0x03,
-  0x00, 0x12, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x15, 0x33,
-  0x11, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x23, 0x20, 0x35, 0x34, 0x3b,
-  0x01, 0x07, 0x23, 0x22, 0x15, 0x14, 0x33, 0x32, 0x37, 0x36, 0xae, 0xa5,
-  0xa5, 0xa5, 0xa3, 0xaa, 0x10, 0x32, 0x43, 0xa9, 0xfe, 0xef, 0xf3, 0xae,
-  0x08, 0xa5, 0x69, 0x73, 0x56, 0x26, 0x1a, 0x06, 0x14, 0xe9, 0xcb, 0xfb,
-  0xa0, 0x8b, 0x78, 0x47, 0x60, 0xdd, 0xcd, 0x8b, 0x42, 0x41, 0x30, 0x20,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x4c, 0x04, 0x26, 0x04, 0x60, 0x00, 0x0a,
-  0x00, 0x00, 0x01, 0x23, 0x11, 0x01, 0x23, 0x09, 0x01, 0x33, 0x01, 0x11,
-  0x33, 0x04, 0x26, 0xa6, 0xfe, 0x11, 0xd3, 0x02, 0x16, 0xfd, 0xd3, 0xd8,
-  0x02, 0x01, 0xa6, 0xfe, 0x4c, 0x03, 0x97, 0xfe, 0x1d, 0x02, 0x0c, 0x02,
-  0x54, 0xfd, 0xdd, 0x02, 0x23, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0x8d, 0x04, 0x60, 0x00, 0x05, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x21, 0x15, 0x21, 0xa7, 0xa6, 0x02, 0x3f, 0xfd, 0x1b, 0x04, 0x60,
-  0xfc, 0x33, 0x93, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x05, 0x60,
-  0x06, 0x12, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01, 0x0e, 0x01, 0x23,
-  0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x34, 0x36,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x01, 0x11, 0x96,
-  0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x02, 0x34, 0x34, 0x9f, 0x70,
-  0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0x93, 0xa3, 0xe4, 0xd0, 0x5e,
-  0x45, 0xa7, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0xfd,
-  0xae, 0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61,
-  0x64, 0xc6, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xf9, 0xda, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48, 0x06, 0x12, 0x00, 0x24,
-  0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x26, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11,
-  0x23, 0x35, 0x33, 0x01, 0x32, 0x39, 0xac, 0x4e, 0x34, 0x01, 0x33, 0x59,
-  0xa1, 0x48, 0x47, 0x47, 0x46, 0x45, 0x48, 0x49, 0x4d, 0xf7, 0x7d, 0x62,
-  0x62, 0x64, 0x99, 0xd0, 0xd0, 0xb6, 0xce, 0xcd, 0x03, 0x1e, 0x72, 0x4c,
-  0x62, 0x85, 0x41, 0x72, 0x16, 0x15, 0x2b, 0xac, 0x23, 0x11, 0x12, 0x9d,
-  0x7d, 0xba, 0xaa, 0x73, 0x77, 0x1e, 0xd4, 0xa4, 0xfe, 0xec, 0x01, 0x14,
-  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48,
-  0x06, 0x12, 0x00, 0x24, 0x00, 0x00, 0x13, 0x35, 0x33, 0x35, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x3b, 0x01,
-  0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0xde, 0xd0, 0x99, 0x65, 0x61,
-  0x63, 0x7c, 0xf7, 0x4d, 0x48, 0x49, 0x45, 0x47, 0x47, 0x46, 0x48, 0xa1,
-  0x59, 0x33, 0x01, 0x34, 0x4d, 0xad, 0x38, 0xce, 0xce, 0xb6, 0x01, 0x14,
-  0xa4, 0xd4, 0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d, 0x9d, 0x12, 0x11, 0x23,
-  0xac, 0x2b, 0x15, 0x16, 0x72, 0x41, 0x85, 0x62, 0x4c, 0x72, 0xfe, 0x9a,
-  0xa4, 0xfe, 0xec, 0x01, 0x14, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
-  0xff, 0xe3, 0x06, 0xfd, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x26, 0x00, 0x29,
-  0x00, 0x00, 0x00, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x10, 0x27, 0x26,
-  0x20, 0x07, 0x25, 0x11, 0x33, 0x11, 0x21, 0x15, 0x01, 0x21, 0x15, 0x21,
-  0x2b, 0x01, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x11, 0x01, 0x01, 0x11, 0x4a, 0x4c,
-  0x01, 0x07, 0x4b, 0x4c, 0x4c, 0x4b, 0xfe, 0xf9, 0x4c, 0x01, 0xea, 0xa6,
-  0x03, 0x11, 0xfd, 0x92, 0x02, 0x6e, 0xfc, 0xef, 0x18, 0x8e, 0x34, 0x4f,
-  0x50, 0x70, 0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50, 0x4f, 0xda,
-  0x02, 0x57, 0x02, 0xfa, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x74, 0x01, 0x96,
-  0x74, 0x73, 0x73, 0x48, 0x02, 0x5e, 0xfe, 0x4c, 0xa8, 0xfc, 0xdb, 0x93,
-  0xa8, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0x02, 0x10, 0xa2, 0xa2, 0x31, 0x30,
-  0x4d, 0xfc, 0xf9, 0x03, 0x07, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xfe, 0x4c, 0x07, 0x4d, 0x06, 0x14, 0x00, 0x34, 0x00, 0x40, 0x00, 0x00,
-  0x01, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x11, 0x33, 0x11, 0x21, 0x15,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x2b, 0x01, 0x35, 0x01, 0x04, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36,
-  0x10, 0x27, 0x26, 0x20, 0x07, 0x03, 0xeb, 0xa6, 0x34, 0x4f, 0x50, 0x70,
-  0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50, 0x4f, 0x34, 0xa6, 0x03,
-  0x12, 0xfe, 0x8e, 0x60, 0x73, 0x58, 0x4e, 0x48, 0xfe, 0xef, 0xfc, 0x55,
-  0x59, 0x5a, 0x5f, 0x4b, 0xb4, 0x62, 0xab, 0x5a, 0x5a, 0x53, 0x54, 0x95,
-  0x9c, 0x01, 0x83, 0xfa, 0xce, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x4c, 0x4c,
-  0x4b, 0xfe, 0xf9, 0x4c, 0x03, 0xcd, 0xfc, 0x33, 0xa8, 0x64, 0x30, 0x31,
-  0xa2, 0xa2, 0x02, 0x10, 0xa2, 0xa2, 0x31, 0x30, 0x64, 0x02, 0x5e, 0xfe,
-  0x4c, 0xa8, 0xfe, 0x24, 0x38, 0x2a, 0x6d, 0x68, 0x8a, 0xdd, 0xf2, 0x12,
-  0x13, 0x25, 0xc3, 0x31, 0x32, 0x4b, 0x4b, 0x8f, 0x84, 0x4b, 0x4a, 0xa6,
-  0x01, 0xf3, 0xd3, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x74, 0x01, 0x96, 0x74,
-  0x73, 0x73, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65, 0xff, 0x91, 0x06, 0xfc,
-  0x06, 0x14, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x33, 0x00, 0x3a, 0x00, 0x00,
-  0x00, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x10, 0x27, 0x26, 0x20, 0x07,
-  0x25, 0x11, 0x01, 0x25, 0x21, 0x15, 0x01, 0x33, 0x12, 0x33, 0x32, 0x15,
-  0x16, 0x21, 0x23, 0x06, 0x15, 0x23, 0x34, 0x37, 0x21, 0x23, 0x35, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x11, 0x33, 0x01, 0x33, 0x32, 0x35, 0x34, 0x23, 0x06, 0x01,
-  0x11, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x4c, 0x4c, 0x4b, 0xfe, 0xf9, 0x4c,
-  0x02, 0x90, 0x02, 0x56, 0xfd, 0xaa, 0x03, 0x10, 0xfd, 0x92, 0x9d, 0x36,
-  0xc5, 0xcd, 0x01, 0xfe, 0xd4, 0x25, 0x03, 0x8a, 0x03, 0xfe, 0xba, 0x8d,
-  0x34, 0x4f, 0x50, 0x70, 0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50,
-  0x4f, 0x34, 0xa6, 0x01, 0xca, 0x12, 0x9c, 0x3f, 0x4f, 0x02, 0xfa, 0xfe,
-  0x6a, 0x74, 0x73, 0x73, 0x74, 0x01, 0x96, 0x74, 0x73, 0x73, 0x5f, 0xfc,
-  0xfa, 0x03, 0x06, 0x93, 0xa8, 0xfc, 0xdb, 0x01, 0x20, 0xf6, 0xbd, 0x33,
-  0x3c, 0x3b, 0x34, 0xa8, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0x02, 0x10, 0xa2,
-  0xa2, 0x31, 0x30, 0x64, 0x02, 0x5e, 0xfa, 0x7f, 0x36, 0x5b, 0x02, 0x00,
-  0x00, 0x01, 0x00, 0x31, 0x00, 0x00, 0x05, 0xa0, 0x05, 0x9e, 0x00, 0x37,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x17, 0x16, 0x33,
-  0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35,
-  0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52,
-  0x01, 0x55, 0xfe, 0xab, 0x21, 0x22, 0x67, 0x02, 0x07, 0x75, 0x3f, 0x3f,
-  0x55, 0xa0, 0x39, 0x9a, 0x89, 0xc9, 0xba, 0x5c, 0xa2, 0x44, 0x46, 0x97,
-  0x51, 0x7c, 0x7b, 0x58, 0x85, 0x39, 0xb2, 0x93, 0x70, 0x44, 0xed, 0xfd,
-  0xfd, 0xbf, 0x49, 0x49, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2, 0x8f, 0xfd,
-  0xa0, 0x89, 0x27, 0x27, 0x2d, 0x2c, 0x34, 0x49, 0x4d, 0x2a, 0x0f, 0x24,
-  0x95, 0x82, 0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x54, 0x54, 0x40,
-  0x49, 0x21, 0x0e, 0x2c, 0x97, 0x89, 0x92, 0x65, 0x3e, 0x50, 0x4f, 0xd2,
-  0x02, 0x60, 0x8f, 0x01, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x31,
-  0xfe, 0x56, 0x04, 0x88, 0x06, 0x14, 0x00, 0x26, 0x00, 0x2f, 0x00, 0x00,
-  0x01, 0x11, 0x21, 0x30, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x07, 0x06, 0x15, 0x13, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x3d, 0x01, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23,
-  0x35, 0x33, 0x11, 0x01, 0x02, 0x11, 0x21, 0x11, 0x14, 0x17, 0x16, 0x33,
-  0x01, 0x52, 0x01, 0x52, 0x4e, 0x49, 0xb0, 0x9c, 0x9e, 0x59, 0x22, 0x24,
-  0x02, 0x49, 0x49, 0xa3, 0x3f, 0x2c, 0x5e, 0x22, 0x23, 0xab, 0xbf, 0x49,
-  0x49, 0x79, 0x79, 0x01, 0xfb, 0x02, 0xfe, 0xae, 0x21, 0x22, 0x67, 0x05,
-  0x9e, 0xfe, 0xc2, 0x4e, 0xb5, 0x5b, 0x56, 0x99, 0x28, 0x28, 0x68, 0xfb,
-  0x29, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x14, 0x50, 0x4f, 0xd2,
-  0x02, 0x60, 0x8f, 0x01, 0x3e, 0xfa, 0xfc, 0x01, 0xa2, 0x01, 0x95, 0xfd,
-  0xa0, 0x89, 0x27, 0x27, 0x00, 0x03, 0x00, 0x31, 0xff, 0x70, 0x05, 0x35,
-  0x05, 0x9e, 0x00, 0x2d, 0x00, 0x39, 0x00, 0x44, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x15, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x10, 0x1f, 0x01, 0x36, 0x33, 0x20, 0x17, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x06, 0x15, 0x07, 0x34, 0x37, 0x23, 0x22,
-  0x27, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x05, 0x26, 0x35, 0x10,
-  0x37, 0x21, 0x11, 0x14, 0x17, 0x16, 0x33, 0x01, 0x52, 0x01, 0x55, 0x86,
-  0xe5, 0x4d, 0x49, 0x48, 0x45, 0x46, 0x47, 0x47, 0x48, 0xa1, 0x59, 0x59,
-  0x59, 0x07, 0x48, 0xb9, 0x01, 0x0d, 0x01, 0x5b, 0x44, 0x8d, 0x4b, 0x42,
-  0x02, 0x8a, 0x06, 0xfa, 0xbf, 0x49, 0x49, 0x79, 0x79, 0x02, 0xe8, 0x3c,
-  0x4a, 0x56, 0x13, 0x1c, 0x01, 0x01, 0x76, 0x67, 0x24, 0x04, 0xfe, 0xf4,
-  0x73, 0x7d, 0xfe, 0xbd, 0x21, 0x22, 0x67, 0x05, 0x9e, 0xfe, 0xc2, 0x7a,
-  0x95, 0x11, 0x12, 0x23, 0xac, 0x2b, 0x16, 0x15, 0x71, 0x72, 0xfe, 0x66,
-  0x72, 0x09, 0xab, 0xf6, 0x76, 0x29, 0x1e, 0x12, 0x32, 0x4c, 0x03, 0x4f,
-  0x41, 0x50, 0x4f, 0xd2, 0x02, 0x60, 0x8f, 0x01, 0x3e, 0xfa, 0xf9, 0x18,
-  0x07, 0x0b, 0x27, 0x4b, 0x56, 0x0a, 0x09, 0x9d, 0xf8, 0x01, 0x07, 0x9b,
-  0xfd, 0xa0, 0x89, 0x27, 0x27, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a,
-  0xfe, 0x56, 0x05, 0xcb, 0x06, 0x14, 0x00, 0x35, 0x00, 0x00, 0x01, 0x11,
-  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23,
-  0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x07, 0x06, 0x1d, 0x01, 0x21, 0x3b, 0x01, 0x15, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x05, 0xca, 0x4a, 0x48, 0xa3, 0xe5, 0xd2, 0x5e,
-  0x22, 0x23, 0x70, 0x6f, 0x87, 0x9a, 0xa7, 0xfe, 0xf1, 0xa6, 0x9f, 0x9f,
-  0x4e, 0x4e, 0xaa, 0x9d, 0x9e, 0x5a, 0x23, 0x22, 0x01, 0x0f, 0x02, 0xa5,
-  0x3b, 0x50, 0x51, 0x69, 0xae, 0x59, 0x59, 0x02, 0xa4, 0xfd, 0x48, 0xd6,
-  0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x02, 0xb2, 0x9f, 0x9e, 0xbe, 0xa4,
-  0xfd, 0x87, 0x03, 0xd1, 0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0x55,
-  0x56, 0x99, 0x28, 0x28, 0x68, 0x63, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78,
-  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x04, 0xbb, 0x06, 0x14, 0x00, 0x27,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26,
-  0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01,
-  0x15, 0x14, 0x07, 0x06, 0x23, 0x21, 0xae, 0xa5, 0x01, 0xca, 0x75, 0x3f,
-  0x3f, 0x54, 0xa0, 0x3a, 0x9a, 0x89, 0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x46,
-  0x97, 0x51, 0x7b, 0x7b, 0x58, 0x85, 0x39, 0xb2, 0x92, 0x6f, 0x45, 0xec,
-  0xfd, 0x94, 0x06, 0x14, 0xfa, 0x86, 0x2d, 0x2c, 0x34, 0x49, 0x4d, 0x2a,
-  0x0f, 0x24, 0x95, 0x82, 0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x54,
-  0x54, 0x40, 0x49, 0x21, 0x0e, 0x2c, 0x97, 0x89, 0x92, 0x65, 0x3e, 0x00,
-  0x00, 0x02, 0x00, 0xad, 0x00, 0x00, 0x04, 0x65, 0x06, 0x14, 0x00, 0x0a,
-  0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x01, 0x21, 0x15,
-  0x21, 0x2b, 0x01, 0x13, 0x11, 0x01, 0xae, 0xa5, 0x03, 0x12, 0xfd, 0x91,
-  0x02, 0x6f, 0xfc, 0xee, 0x17, 0x8e, 0xa5, 0x02, 0x58, 0x06, 0x14, 0xfe,
-  0x4c, 0xa8, 0xfc, 0xdb, 0x93, 0x03, 0xcd, 0xfc, 0xf9, 0x03, 0x07, 0x00,
-  0x00, 0x02, 0x00, 0x30, 0xff, 0xe2, 0x03, 0x85, 0x05, 0x1f, 0x00, 0x0c,
-  0x00, 0x19, 0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x1b, 0x01, 0x33,
-  0x03, 0x23, 0x0b, 0x01, 0x23, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x1b, 0x01,
-  0x33, 0x03, 0x23, 0x0b, 0x01, 0x23, 0x31, 0x68, 0x83, 0x81, 0x7b, 0x83,
-  0x81, 0x69, 0xa7, 0x7a, 0x89, 0x89, 0x7b, 0xa6, 0x68, 0x83, 0x81, 0x7b,
-  0x83, 0x81, 0x69, 0xa7, 0x7a, 0x89, 0x89, 0x7b, 0x02, 0x55, 0xfe, 0x17,
-  0x01, 0xe9, 0xfe, 0x17, 0x01, 0xe9, 0xfd, 0x8d, 0x02, 0x02, 0xfd, 0xfe,
-  0x05, 0x3d, 0xfe, 0x17, 0x01, 0xe9, 0xfe, 0x17, 0x01, 0xe9, 0xfd, 0x8d,
-  0x02, 0x02, 0xfd, 0xfe, 0x00, 0x02, 0x00, 0x30, 0x00, 0xad, 0x03, 0x85,
-  0x05, 0x1f, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23,
-  0x31, 0x03, 0x54, 0x81, 0xfd, 0xad, 0x80, 0x03, 0x54, 0x81, 0xfd, 0xad,
-  0x80, 0x02, 0x55, 0xfe, 0x58, 0x01, 0x05, 0xfe, 0xfb, 0x04, 0x72, 0xfe,
-  0x58, 0x01, 0x05, 0xfe, 0xfb, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0xfe, 0x4a, 0x04, 0x1c, 0x06, 0x14, 0x00, 0x19, 0x00, 0x00, 0x25, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x11, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x16, 0x15, 0x11, 0x10, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23,
-  0x03, 0x75, 0x77, 0xcf, 0xae, 0xb2, 0x44, 0x5f, 0x2c, 0x3f, 0xa3, 0x93,
-  0xdf, 0x86, 0x9b, 0xa6, 0xa6, 0xac, 0xc9, 0xef, 0xe8, 0x02, 0xc4, 0x99,
-  0x61, 0x9c, 0xc0, 0xd6, 0xfd, 0x42, 0xfe, 0xc3, 0xbe, 0xa4, 0x02, 0x79,
-  0xf9, 0xec, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0xfe, 0x56, 0x04, 0xeb,
-  0x06, 0x14, 0x00, 0x21, 0x00, 0x00, 0x25, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x11, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x15, 0x11, 0x10,
-  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x06, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x26, 0x27, 0x03, 0x75, 0x77, 0xcf, 0xae, 0xb2, 0x44, 0x5f,
-  0x2c, 0x3f, 0xa3, 0x93, 0xdf, 0x86, 0x9b, 0xa6, 0x03, 0x48, 0x5d, 0x2d,
-  0x3f, 0xa4, 0x8e, 0x04, 0xac, 0xc9, 0xef, 0xe8, 0x02, 0xc4, 0x99, 0x61,
-  0x9c, 0xc0, 0xd6, 0xfd, 0x42, 0xfe, 0xc3, 0xbe, 0xa4, 0x02, 0x79, 0xfb,
-  0x8e, 0x94, 0x66, 0x9c, 0xb9, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x02, 0x9c, 0x02, 0x7e, 0x06, 0x03, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
-  0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x7d, 0x68, 0x46, 0x47, 0x54,
-  0x61, 0x6a, 0x6a, 0x25, 0x65, 0x43, 0x6d, 0x70, 0x04, 0x17, 0xfe, 0x85,
-  0x01, 0x77, 0x59, 0x59, 0x6b, 0x5c, 0xfe, 0x9e, 0x03, 0x67, 0xfe, 0xab,
-  0x38, 0x38, 0x86, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x7e,
-  0x06, 0x03, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x06, 0x1d, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x7d,
-  0x68, 0x46, 0x47, 0x54, 0x61, 0x6a, 0x5d, 0x67, 0x90, 0x84, 0x3b, 0x2b,
-  0x25, 0x65, 0x43, 0x6d, 0x70, 0x04, 0x17, 0xfe, 0x85, 0x01, 0x77, 0x59,
-  0x59, 0x6b, 0x5c, 0xfe, 0x9e, 0x02, 0x84, 0x78, 0x6b, 0x57, 0x36, 0x56,
-  0x72, 0x38, 0x38, 0x86, 0x00, 0x02, 0xff, 0xeb, 0x01, 0xad, 0x00, 0xd7,
-  0x06, 0x03, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x13, 0x33, 0x11, 0x14,
-  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
-  0x15, 0x23, 0x6e, 0x68, 0x2f, 0x2d, 0x67, 0x28, 0x1c, 0x3c, 0x15, 0x16,
-  0x68, 0x68, 0x05, 0x0f, 0xfd, 0x82, 0x78, 0x36, 0x36, 0x58, 0x1b, 0x1b,
-  0x56, 0x03, 0x72, 0x82, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x01, 0xdd,
-  0x05, 0x1e, 0x00, 0x11, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
-  0x01, 0xdd, 0x11, 0x2a, 0x19, 0x58, 0x5e, 0x6a, 0x6a, 0x20, 0x69, 0x4c,
-  0x0b, 0x1a, 0x10, 0x04, 0xaf, 0x0a, 0x09, 0x71, 0x6b, 0xfe, 0xb6, 0x02,
-  0x73, 0x61, 0x39, 0x37, 0x02, 0x03, 0x00, 0x00, 0x00, 0x01, 0x00, 0x40,
-  0x02, 0x8d, 0x01, 0xb4, 0x05, 0x0f, 0x00, 0x11, 0x00, 0x00, 0x13, 0x1e,
-  0x01, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01,
-  0x23, 0x22, 0x26, 0x27, 0x41, 0x11, 0x29, 0x19, 0x59, 0x5e, 0x69, 0x69,
-  0x20, 0x69, 0x4c, 0x0b, 0x1a, 0x10, 0x02, 0xfc, 0x0a, 0x09, 0x71, 0x6b,
-  0x01, 0x4a, 0xfd, 0x8d, 0x61, 0x39, 0x37, 0x02, 0x03, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x40, 0x01, 0xad, 0x02, 0x37, 0x05, 0x0f, 0x00, 0x1b,
-  0x00, 0x00, 0x13, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
-  0x15, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x02, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0x27, 0x41, 0x11, 0x29, 0x19, 0x59, 0x5e, 0x69,
-  0x2b, 0x3b, 0x1c, 0x28, 0x66, 0x5d, 0x20, 0x69, 0x4c, 0x0b, 0x1a, 0x10,
-  0x02, 0xfc, 0x0a, 0x09, 0x71, 0x6b, 0x01, 0x4a, 0xfd, 0x8d, 0x0b, 0x56,
-  0x36, 0x58, 0x6c, 0x78, 0x0b, 0x61, 0x39, 0x37, 0x02, 0x03, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x1c, 0x02, 0x9c, 0x02, 0x4e, 0x05, 0x0f, 0x00, 0x16,
-  0x00, 0x21, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x2b,
-  0x01, 0x11, 0x33, 0x11, 0x33, 0x32, 0x37, 0x36, 0x3f, 0x01, 0x33, 0x07,
-  0x06, 0x07, 0x06, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x2b, 0x01, 0x01, 0x72, 0x3c, 0x3f, 0x3c, 0x3d, 0x7c, 0xdb, 0x68, 0x61,
-  0x36, 0x22, 0x21, 0x24, 0x5c, 0x6f, 0x64, 0x1d, 0x1e, 0x1f, 0xfe, 0xf5,
-  0x71, 0x43, 0x23, 0x25, 0x25, 0x23, 0x43, 0x71, 0x03, 0xe9, 0x0f, 0x4e,
-  0x3b, 0x5b, 0x2d, 0x2d, 0x02, 0x73, 0xfe, 0xf7, 0x15, 0x14, 0x3f, 0xa1,
-  0xab, 0x35, 0x1e, 0x1e, 0xff, 0x00, 0x17, 0x18, 0x2f, 0x2e, 0x18, 0x19,
-  0x00, 0x01, 0x00, 0x30, 0x02, 0x9c, 0x03, 0x85, 0x05, 0x0f, 0x00, 0x0c,
-  0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x23,
-  0x0b, 0x01, 0x23, 0x31, 0x68, 0x83, 0x81, 0x7b, 0x83, 0x81, 0x69, 0xa7,
-  0x7a, 0x89, 0x89, 0x7b, 0x05, 0x0f, 0xfe, 0x17, 0x01, 0xe9, 0xfe, 0x17,
-  0x01, 0xe9, 0xfd, 0x8d, 0x02, 0x02, 0xfd, 0xfe, 0x00, 0x01, 0x00, 0x22,
-  0x01, 0xad, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x11, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3f, 0x01, 0x01,
-  0x33, 0x1b, 0x01, 0x33, 0x01, 0x76, 0x2d, 0x2a, 0x29, 0x46, 0x54, 0x3d,
-  0x2b, 0x18, 0x18, 0x1d, 0x13, 0xfe, 0xfe, 0x6f, 0xc7, 0xc6, 0x6e, 0x02,
-  0x62, 0x70, 0x22, 0x23, 0x57, 0x14, 0x14, 0x4b, 0x2f, 0x02, 0x69, 0xfe,
-  0x16, 0x01, 0xea, 0x00, 0xff, 0xff, 0x00, 0x90, 0x04, 0x74, 0x01, 0x76,
-  0x06, 0x66, 0x10, 0x06, 0x03, 0x12, 0x00, 0x00, 0xff, 0xff, 0x00, 0x90,
-  0x04, 0x74, 0x02, 0xc5, 0x06, 0x66, 0x10, 0x26, 0x03, 0x12, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x12, 0x01, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c,
-  0x03, 0xe9, 0x01, 0xa5, 0x05, 0xd5, 0x10, 0x06, 0x07, 0x4d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa0, 0x03, 0xfe, 0x01, 0xa8, 0x05, 0xd5, 0x10, 0x06,
-  0x07, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb0, 0x04, 0xee, 0x01, 0xb9,
-  0x06, 0xda, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15, 0x13, 0x23, 0x03, 0x35,
-  0x01, 0x6e, 0x4a, 0x74, 0x94, 0x06, 0xda, 0xac, 0xfe, 0xc0, 0x01, 0x40,
-  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x03, 0xef, 0x01, 0x60,
-  0x06, 0x14, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x35, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x35, 0x32, 0x17, 0x16, 0x14, 0x07, 0x06, 0x69, 0x3a, 0x4f,
-  0x4f, 0x3a, 0x68, 0x48, 0x47, 0x47, 0x48, 0x03, 0xef, 0x7b, 0x58, 0x40,
-  0x3f, 0x58, 0x7b, 0x50, 0x4f, 0xe6, 0x50, 0x50, 0x00, 0x01, 0x00, 0x69,
-  0x03, 0xef, 0x01, 0x60, 0x06, 0x14, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x22,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x33, 0x15, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x01, 0x60, 0x68, 0x48, 0x47, 0x47, 0x48, 0x68, 0x3a, 0x4f, 0x4f,
-  0x3a, 0x03, 0xef, 0x50, 0x50, 0xe6, 0x4f, 0x50, 0x7b, 0x58, 0x3f, 0x40,
-  0x58, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x49,
-  0x06, 0x02, 0x00, 0x1c, 0x00, 0x00, 0x13, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x11, 0x23, 0xf8,
-  0x24, 0x6c, 0x32, 0x20, 0x01, 0x1f, 0x39, 0x65, 0x2e, 0x2c, 0x2d, 0x2c,
-  0x2b, 0x2e, 0x2e, 0x30, 0x9d, 0x4e, 0x3d, 0x3d, 0x3f, 0x60, 0x74, 0x04,
-  0x5b, 0x40, 0x2a, 0x37, 0x4b, 0x24, 0x40, 0x0c, 0x0c, 0x18, 0x60, 0x14,
-  0x09, 0x0a, 0x58, 0x46, 0x68, 0x5f, 0x40, 0x43, 0x11, 0xfe, 0x93, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x49, 0x06, 0x02, 0x00, 0x1c,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x33, 0x01, 0xb9, 0x72, 0x61, 0x40,
-  0x3d, 0x3e, 0x4f, 0x9b, 0x30, 0x2e, 0x2e, 0x2b, 0x2c, 0x2d, 0x2c, 0x2d,
-  0x66, 0x38, 0x20, 0x01, 0x21, 0x31, 0x6d, 0x04, 0x5b, 0xfe, 0x41, 0x01,
-  0x6d, 0x11, 0x43, 0x40, 0x5f, 0x68, 0x46, 0x58, 0x0a, 0x09, 0x14, 0x60,
-  0x18, 0x0c, 0x0c, 0x40, 0x24, 0x4b, 0x37, 0x2a, 0x40, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xf0, 0x04, 0x32, 0x02, 0xaa, 0x06, 0xb0, 0x00, 0x06,
-  0x00, 0x00, 0x13, 0x25, 0x15, 0x0d, 0x01, 0x15, 0x25, 0xf0, 0x01, 0xb9,
-  0xfe, 0xbd, 0x01, 0x43, 0xfe, 0x47, 0x05, 0xbb, 0xf5, 0x8b, 0xb4, 0xb4,
-  0x8b, 0xf5, 0x00, 0x00, 0x00, 0x01, 0x00, 0xf0, 0x04, 0x32, 0x02, 0xaa,
-  0x06, 0xb0, 0x00, 0x06, 0x00, 0x00, 0x01, 0x05, 0x35, 0x2d, 0x01, 0x35,
-  0x05, 0x02, 0xa9, 0xfe, 0x47, 0x01, 0x43, 0xfe, 0xbd, 0x01, 0xb9, 0x05,
-  0x27, 0xf5, 0x8b, 0xb4, 0xb4, 0x8b, 0xf5, 0x00, 0x00, 0x01, 0x00, 0xad,
-  0x04, 0x7c, 0x02, 0xec, 0x06, 0x66, 0x00, 0x06, 0x00, 0x00, 0x01, 0x33,
-  0x13, 0x23, 0x0b, 0x01, 0x23, 0x01, 0x8a, 0x85, 0xdd, 0x7d, 0xa2, 0xa2,
-  0x7d, 0x06, 0x66, 0xfe, 0x16, 0x01, 0x67, 0xfe, 0x99, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0x04, 0x7c, 0x02, 0xec, 0x06, 0x66, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x01, 0x8a, 0xdc,
-  0x7d, 0xa2, 0xa2, 0x7d, 0xdd, 0x04, 0x7c, 0x01, 0xea, 0xfe, 0x99, 0x01,
-  0x67, 0xfe, 0x16, 0x00, 0x00, 0x01, 0x00, 0xad, 0x04, 0xee, 0x02, 0xec,
-  0x06, 0x66, 0x00, 0x06, 0x00, 0x00, 0x01, 0x33, 0x13, 0x23, 0x27, 0x07,
-  0x23, 0x01, 0x8a, 0x85, 0xdd, 0x7d, 0xa2, 0xa2, 0x7d, 0x06, 0x66, 0xfe,
-  0x88, 0xf5, 0xf5, 0x00, 0x00, 0x01, 0x00, 0xad, 0x04, 0xee, 0x02, 0xec,
-  0x06, 0x66, 0x00, 0x06, 0x00, 0x00, 0x01, 0x03, 0x33, 0x17, 0x37, 0x33,
-  0x03, 0x01, 0x8a, 0xdc, 0x7d, 0xa2, 0xa2, 0x7d, 0xdd, 0x04, 0xee, 0x01,
-  0x78, 0xf5, 0xf5, 0xfe, 0x88, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0,
-  0x03, 0xe7, 0x01, 0x3b, 0x06, 0x12, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x01, 0x3b, 0x7a, 0x06, 0x12, 0xfd, 0xd5, 0x02, 0x2b, 0x00,
-  0xff, 0xff, 0x00, 0xbf, 0x05, 0x62, 0x02, 0xda, 0x05, 0xf6, 0x10, 0x06,
-  0x00, 0x71, 0x00, 0x00, 0x00, 0x01, 0x01, 0x4d, 0x04, 0xee, 0x02, 0xfd,
-  0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x02, 0x4a,
-  0xb3, 0xfe, 0xdb, 0x8a, 0x06, 0x66, 0xfe, 0x88, 0x00, 0x01, 0x00, 0x99,
-  0x04, 0xf0, 0x02, 0x49, 0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x13,
-  0x23, 0x01, 0x01, 0x4a, 0xfe, 0x8a, 0xfe, 0xdb, 0x06, 0x66, 0xfe, 0x8a,
-  0x01, 0x76, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0, 0xfe, 0xd1, 0x01, 0x3b,
-  0x00, 0xfc, 0x00, 0x03, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11, 0x01, 0x3b,
-  0x7a, 0xfc, 0xfd, 0xd5, 0x02, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xbf,
-  0xfe, 0xc0, 0x02, 0xda, 0xff, 0x54, 0x10, 0x07, 0x00, 0x71, 0x00, 0x00,
-  0xf9, 0x5e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99, 0xfe, 0x1c, 0x02, 0x49,
-  0xff, 0x92, 0x00, 0x03, 0x00, 0x00, 0x05, 0x13, 0x23, 0x01, 0x01, 0x4a,
-  0xfe, 0x8a, 0xfe, 0xdb, 0x6e, 0xfe, 0x8a, 0x01, 0x76, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x4d, 0xfe, 0x1c, 0x02, 0xfd, 0xff, 0x94, 0x00, 0x03,
-  0x00, 0x00, 0x05, 0x33, 0x01, 0x23, 0x02, 0x4a, 0xb3, 0xfe, 0xdb, 0x8a,
-  0x6c, 0xfe, 0x88, 0x00, 0x00, 0x02, 0x00, 0x63, 0x00, 0x00, 0x01, 0xa6,
-  0x04, 0x23, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x01, 0x03, 0x21, 0x03,
-  0x13, 0x21, 0x01, 0x04, 0xa0, 0x01, 0x41, 0xa1, 0xa1, 0xfe, 0xbf, 0x02,
-  0xd9, 0x01, 0x4a, 0xfd, 0x27, 0xfe, 0xb6, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0x02, 0xd9, 0x01, 0xa6, 0x04, 0x23, 0x00, 0x02, 0x00, 0x00, 0x01, 0x03,
-  0x21, 0x01, 0x04, 0xa0, 0x01, 0x41, 0x02, 0xd9, 0x01, 0x4a, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x69, 0x01, 0xfe, 0x01, 0x60, 0x04, 0x23, 0x10, 0x07,
-  0x02, 0x80, 0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
-  0x01, 0xfe, 0x01, 0x60, 0x04, 0x23, 0x10, 0x07, 0x02, 0x81, 0x00, 0x00,
-  0xfe, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x01, 0xd4, 0x02, 0x98,
-  0x03, 0x96, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35, 0x33, 0x11,
-  0x33, 0x11, 0x02, 0x97, 0xfe, 0x6b, 0x87, 0x87, 0x02, 0x6a, 0x96, 0x96,
-  0x01, 0x2c, 0xfe, 0xd4, 0x00, 0x01, 0x01, 0x02, 0x01, 0xd4, 0x02, 0x98,
-  0x03, 0x96, 0x00, 0x07, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x23, 0x11,
-  0x23, 0x11, 0x01, 0x02, 0x01, 0x95, 0x87, 0x87, 0x03, 0x00, 0x96, 0x96,
-  0xfe, 0xd4, 0x01, 0x2c, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xff, 0x02, 0x75,
-  0x03, 0x55, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x33, 0x15,
-  0x23, 0x15, 0x23, 0x35, 0x23, 0x35, 0x01, 0x24, 0x87, 0xc9, 0xc9, 0x87,
-  0xca, 0x02, 0x75, 0xe0, 0xe0, 0x96, 0xe0, 0xe0, 0x96, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x01, 0xef, 0x02, 0x75, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x01, 0xef, 0xfe, 0x6b, 0x01, 0x95,
-  0x01, 0xdf, 0x96, 0x00, 0x00, 0x01, 0x00, 0xb3, 0x05, 0x29, 0x02, 0xe7,
-  0x06, 0x48, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x37, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x26, 0xb3, 0x6a, 0x0a, 0x57,
-  0x4f, 0x4d, 0x57, 0x0b, 0x6a, 0x08, 0x8f, 0x82, 0x83, 0x8e, 0x06, 0x48,
-  0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x00, 0x00, 0x01, 0x01, 0x71,
-  0x05, 0x44, 0x02, 0x29, 0x06, 0x10, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33,
-  0x15, 0x23, 0x01, 0x71, 0xb8, 0xb8, 0x06, 0x10, 0xcc, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xd6, 0x04, 0xe1, 0x02, 0xc4, 0x07, 0x06, 0x00, 0x0b,
-  0x00, 0x17, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x02, 0x56, 0x50, 0x39, 0x3b, 0x4e, 0x4e, 0x3b,
-  0x39, 0x50, 0x6d, 0x8f, 0x67, 0x68, 0x8f, 0x8f, 0x68, 0x67, 0x8f, 0x05,
-  0xf4, 0x3f, 0x58, 0x57, 0x40, 0x41, 0x57, 0x58, 0x40, 0x73, 0xa0, 0xa0,
-  0x73, 0x73, 0x9f, 0x9f, 0x00, 0x01, 0x01, 0x2a, 0xfe, 0x75, 0x02, 0x7b,
-  0x00, 0x00, 0x00, 0x13, 0x00, 0x00, 0x21, 0x33, 0x0e, 0x01, 0x15, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x01, 0x8c, 0x6b, 0x28, 0x27, 0x31, 0x31, 0x1d, 0x38, 0x1b,
-  0x22, 0x3d, 0x1b, 0x6e, 0x67, 0x2f, 0x3d, 0x58, 0x1f, 0x2e, 0x2e, 0x0f,
-  0x0f, 0x85, 0x0a, 0x0a, 0x57, 0x5d, 0x30, 0x69, 0x00, 0x01, 0x00, 0xa3,
-  0x05, 0x1d, 0x02, 0xf6, 0x06, 0x37, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x27,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x33, 0x32, 0x16,
-  0x1f, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x33, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x01, 0xc9, 0x33, 0x14, 0x1e, 0x0b, 0x23, 0x20, 0x02, 0x70,
-  0x02, 0x5b, 0x52, 0x23, 0x39, 0x21, 0x34, 0x14, 0x1d, 0x0c, 0x22, 0x21,
-  0x01, 0x71, 0x02, 0x5c, 0x52, 0x22, 0x3a, 0x05, 0x5a, 0x37, 0x14, 0x13,
-  0x49, 0x52, 0x87, 0x93, 0x1c, 0x21, 0x37, 0x14, 0x13, 0x49, 0x52, 0x87,
-  0x93, 0x1c, 0x00, 0x00, 0x00, 0x02, 0x00, 0xd8, 0x04, 0xee, 0x03, 0x50,
-  0x06, 0x66, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x03, 0x23,
-  0x03, 0x33, 0x03, 0x23, 0x02, 0xb0, 0xa0, 0xdf, 0x7a, 0x74, 0x99, 0xc9,
-  0x7b, 0x06, 0x66, 0xfe, 0x88, 0x01, 0x78, 0xfe, 0x88, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xff, 0x01, 0xde, 0x02, 0x69, 0x04, 0x08, 0x00, 0x0f,
-  0x00, 0x00, 0x03, 0x37, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x07, 0x01, 0xfa, 0xa6, 0x22, 0x22, 0x5f,
-  0x26, 0x39, 0x9e, 0x4e, 0x4a, 0xf9, 0x03, 0x64, 0xa4, 0x94, 0x99, 0x31,
-  0x30, 0x9c, 0x60, 0x5a, 0xc8, 0xa2, 0x00, 0x00, 0x00, 0x01, 0x00, 0xd7,
-  0x04, 0xee, 0x02, 0xc2, 0x06, 0x66, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x27,
-  0x07, 0x23, 0x37, 0x27, 0x33, 0x17, 0x37, 0x33, 0x07, 0x17, 0x02, 0x20,
-  0x53, 0x54, 0xa2, 0xa3, 0xa3, 0xa2, 0x54, 0x53, 0xa2, 0xa4, 0xa4, 0x04,
-  0xee, 0x61, 0x61, 0xbb, 0xbd, 0x60, 0x60, 0xbd, 0xbb, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x69, 0x01, 0xab, 0x02, 0xb1, 0x05, 0x0f, 0x00, 0x0d,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x16, 0x15, 0x14, 0x23, 0x22, 0x35, 0x34,
-  0x37, 0x03, 0x33, 0x17, 0x37, 0x33, 0x01, 0x06, 0x15, 0x14, 0x33, 0x32,
-  0x35, 0x34, 0x01, 0xd1, 0xa1, 0xda, 0xf1, 0xa3, 0xe1, 0x7c, 0xab, 0xa5,
-  0x7b, 0xfe, 0xdd, 0x7b, 0x7a, 0x74, 0x03, 0xdc, 0xf9, 0xb4, 0x84, 0x84,
-  0xbf, 0xf2, 0x01, 0x2f, 0xe0, 0xe0, 0xfe, 0x8a, 0xae, 0x98, 0x4d, 0x4d,
-  0x89, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6d, 0x02, 0x9c, 0x00, 0xd7,
-  0x06, 0x03, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x6e, 0x68,
-  0x68, 0x06, 0x03, 0xfc, 0x99, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x02, 0x9c, 0x02, 0x4f, 0x05, 0x2f, 0x00, 0x32, 0x00, 0x00, 0x01, 0x15,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f,
-  0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x02, 0x2c, 0x2c, 0x30, 0x2e, 0x34, 0x4e, 0x27, 0x26, 0x1b, 0x1c,
-  0x54, 0x24, 0x71, 0x2d, 0x2e, 0x46, 0x45, 0x7b, 0x33, 0x38, 0x37, 0x3d,
-  0x3a, 0x39, 0x37, 0x37, 0x4a, 0x4f, 0x1d, 0x19, 0x64, 0x24, 0x61, 0x2b,
-  0x2b, 0x40, 0x3f, 0x75, 0x39, 0x34, 0x33, 0x05, 0x0d, 0x61, 0x16, 0x0b,
-  0x0b, 0x17, 0x18, 0x2f, 0x24, 0x14, 0x15, 0x12, 0x08, 0x18, 0x2a, 0x2b,
-  0x4d, 0x57, 0x33, 0x33, 0x0a, 0x0a, 0x13, 0x6b, 0x1e, 0x0f, 0x0f, 0x32,
-  0x2d, 0x2a, 0x17, 0x14, 0x17, 0x08, 0x15, 0x29, 0x2a, 0x49, 0x58, 0x30,
-  0x31, 0x09, 0x08, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0xd1,
-  0x05, 0x0f, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x03, 0x13, 0x23, 0x27, 0x07,
-  0x23, 0x13, 0x03, 0x33, 0x17, 0x37, 0x02, 0xc5, 0xe5, 0xf1, 0x7b, 0xb9,
-  0xb8, 0x7c, 0xf7, 0xe2, 0x7b, 0xa9, 0xa8, 0x05, 0x0f, 0xfe, 0xcf, 0xfe,
-  0xbe, 0xf6, 0xf6, 0x01, 0x48, 0x01, 0x2b, 0xdf, 0xdf, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x49, 0x06, 0x02, 0x10, 0x06,
-  0x02, 0x83, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
-  0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x02, 0x53, 0xfe, 0x6e, 0x02, 0x0c, 0x04, 0xd0, 0x88, 0xfa, 0xa8, 0x00,
-  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07,
-  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x02, 0x53,
-  0xfe, 0x6e, 0x01, 0x92, 0x7a, 0x03, 0x9c, 0x88, 0x01, 0x34, 0xfa, 0xa8,
-  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07,
-  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x02, 0x53,
-  0xfe, 0x6e, 0x01, 0x92, 0x7a, 0x02, 0x68, 0x88, 0x02, 0x68, 0xfa, 0xa8,
-  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07,
-  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x02, 0x53,
-  0xfe, 0x6e, 0x01, 0x92, 0x7a, 0x01, 0x34, 0x88, 0x03, 0x9c, 0xfa, 0xa8,
-  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x05,
-  0x00, 0x00, 0x25, 0x11, 0x33, 0x11, 0x21, 0x35, 0x02, 0x53, 0x7a, 0xfd,
-  0xf4, 0x88, 0x04, 0xd0, 0xfa, 0xa8, 0x88, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0xfd, 0xec, 0x02, 0xec, 0xff, 0xd6, 0x10, 0x07, 0x02, 0x87, 0x00, 0x00,
-  0xf9, 0x70, 0x00, 0x00, 0xff, 0xff, 0x00, 0xbf, 0x04, 0xe2, 0x02, 0xda,
-  0x06, 0x76, 0x12, 0x27, 0x00, 0x71, 0x00, 0x00, 0x00, 0x80, 0x12, 0x06,
-  0x00, 0x71, 0x00, 0x80, 0xff, 0xff, 0x00, 0x9c, 0x03, 0xe9, 0x03, 0x16,
-  0x05, 0xd5, 0x12, 0x06, 0x07, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xd6,
-  0xfe, 0x14, 0x02, 0xc4, 0x00, 0x39, 0x10, 0x07, 0x02, 0x9c, 0x00, 0x00,
-  0xf9, 0x33, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa3, 0xfe, 0x76, 0x02, 0xf6,
-  0xff, 0x90, 0x00, 0x21, 0x00, 0x00, 0x01, 0x27, 0x26, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x1f,
-  0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x01, 0xc9, 0x33, 0x14, 0x0f, 0x0f, 0x0b, 0x23,
-  0x10, 0x10, 0x02, 0x70, 0x02, 0x2e, 0x2d, 0x52, 0x23, 0x39, 0x21, 0x34,
-  0x14, 0x0f, 0x0e, 0x0c, 0x22, 0x10, 0x11, 0x01, 0x71, 0x02, 0x2e, 0x2e,
-  0x52, 0x22, 0x3a, 0xfe, 0xb3, 0x37, 0x14, 0x0a, 0x09, 0x25, 0x24, 0x52,
-  0x87, 0x49, 0x4a, 0x1c, 0x21, 0x37, 0x14, 0x0a, 0x09, 0x25, 0x24, 0x52,
-  0x87, 0x49, 0x4a, 0x1c, 0x00, 0x02, 0xfc, 0xfd, 0x04, 0x7b, 0xfe, 0xad,
-  0x06, 0x66, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x01, 0x13, 0x23, 0x09,
-  0x01, 0xfd, 0xaf, 0xfe, 0x8a, 0xfe, 0xdb, 0x01, 0x35, 0x06, 0x66, 0xfe,
-  0x8a, 0x01, 0x76, 0xfe, 0x15, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0xb2,
-  0x04, 0x7b, 0xff, 0x62, 0x06, 0x66, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
-  0x01, 0x33, 0x01, 0x23, 0x17, 0xfe, 0xae, 0xb4, 0xfe, 0xda, 0x8a, 0x81,
-  0x06, 0x66, 0xfe, 0x88, 0x73, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x14,
-  0x04, 0x7b, 0xff, 0x53, 0x06, 0x66, 0x00, 0x06, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x33, 0x13, 0x23, 0x27, 0x07, 0x23, 0x05, 0xfd, 0xf1, 0x85, 0xdc,
-  0x7d, 0xa2, 0xa2, 0x7d, 0x01, 0x1f, 0x06, 0x66, 0xfe, 0x88, 0xf5, 0xf5,
-  0x73, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x08, 0x05, 0x1d, 0xff, 0x5b,
-  0x06, 0x37, 0x10, 0x07, 0x02, 0x9e, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0x29, 0x05, 0x62, 0xff, 0x44, 0x05, 0xf6, 0x10, 0x07,
-  0x00, 0x71, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0x54,
-  0x05, 0x7c, 0x00, 0x12, 0x06, 0x0b, 0x10, 0x07, 0x07, 0x73, 0xfc, 0x66,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x12, 0x05, 0x29, 0xff, 0x46,
-  0x06, 0x48, 0x10, 0x07, 0x02, 0x9a, 0xfc, 0x5f, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0xfd, 0xde, 0x04, 0x7b, 0xfe, 0x85, 0x06, 0x14, 0x00, 0x03,
-  0x00, 0x04, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x17, 0xfd, 0xdf, 0xa5,
-  0xa5, 0x54, 0x06, 0x14, 0xe9, 0xb0, 0x00, 0x00, 0x00, 0x03, 0xfd, 0x27,
-  0x04, 0x7b, 0xff, 0x3f, 0x06, 0x10, 0x00, 0x03, 0x00, 0x07, 0x00, 0x08,
-  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x05, 0xfe,
-  0x88, 0xb6, 0xb6, 0xfe, 0xa0, 0xb7, 0xb7, 0x01, 0x0b, 0x06, 0x10, 0xca,
-  0xca, 0xca, 0xcb, 0x00, 0x00, 0x01, 0xfd, 0x7e, 0x04, 0xf2, 0xff, 0x12,
-  0x06, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x36, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x15, 0x23, 0x35, 0x34, 0x36, 0x3f,
-  0x01, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0xfd, 0x7e, 0x65, 0x5e,
-  0x5e, 0x73, 0x50, 0x27, 0x20, 0x03, 0x07, 0x6b, 0x1c, 0x2d, 0x29, 0x29,
-  0x38, 0x40, 0x51, 0x5a, 0x06, 0x48, 0x33, 0x55, 0x43, 0x3d, 0x41, 0x20,
-  0x1a, 0x09, 0x10, 0x20, 0x0c, 0x28, 0x36, 0x25, 0x22, 0x22, 0x28, 0x15,
-  0x24, 0x34, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x3a, 0x04, 0xe1, 0xff, 0x28,
-  0x07, 0x06, 0x10, 0x07, 0x02, 0x9c, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0x42, 0x04, 0xee, 0xff, 0xba, 0x06, 0x66, 0x10, 0x07,
-  0x02, 0x9f, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x17,
-  0x04, 0x7b, 0xff, 0x56, 0x06, 0x66, 0x00, 0x06, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03, 0x07, 0xfd, 0xf4, 0xdc, 0x7d,
-  0xa2, 0xa2, 0x7d, 0xdd, 0x46, 0x04, 0xee, 0x01, 0x78, 0xf5, 0xf5, 0xfe,
-  0x88, 0x73, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xf6, 0x04, 0xec, 0xfe, 0x71,
-  0x06, 0xa8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0xfe, 0x70,
-  0x7a, 0x06, 0xa8, 0xfe, 0x44, 0x01, 0xbc, 0x00, 0xff, 0xff, 0xfd, 0x3e,
-  0x04, 0xec, 0xff, 0x28, 0x06, 0xa8, 0x10, 0x27, 0x02, 0xbe, 0xff, 0x48,
-  0x00, 0x00, 0x10, 0x07, 0x02, 0xbe, 0x00, 0xb8, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0xfc, 0xba, 0x04, 0xee, 0xff, 0x32, 0x06, 0x66, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x01, 0x13, 0x23, 0x03, 0x21, 0x13, 0x23, 0x03,
-  0xfd, 0x5a, 0xb9, 0x7a, 0xdf, 0x01, 0xcd, 0xab, 0x7b, 0xc9, 0x06, 0x66,
-  0xfe, 0x88, 0x01, 0x78, 0xfe, 0x88, 0x01, 0x78, 0xff, 0xff, 0xfd, 0x12,
-  0x05, 0x29, 0xff, 0x46, 0x07, 0x56, 0x10, 0x27, 0x02, 0xb8, 0x00, 0x00,
-  0x01, 0x42, 0x10, 0x07, 0x02, 0x9a, 0xfc, 0x5f, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x12, 0x05, 0x29, 0xff, 0x46, 0x06, 0x48, 0x00, 0x0c,
-  0x00, 0x00, 0x03, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e,
-  0x01, 0x20, 0x16, 0xba, 0x6a, 0x0a, 0x58, 0x4e, 0x4d, 0x57, 0x0c, 0x6a,
-  0x09, 0x8f, 0x01, 0x04, 0x8f, 0x05, 0x29, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f,
-  0x90, 0x90, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x4f, 0x03, 0xe9, 0xff, 0x57,
-  0x05, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x23, 0x13, 0x33, 0xf3, 0xbe,
-  0x94, 0x74, 0x03, 0xe9, 0x01, 0x3f, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xce,
-  0x04, 0xc2, 0xfe, 0xa8, 0x06, 0xc1, 0x00, 0x08, 0x00, 0x00, 0x01, 0x10,
-  0x23, 0x35, 0x16, 0x35, 0x23, 0x35, 0x33, 0xfe, 0xa8, 0xda, 0x65, 0x64,
-  0xd9, 0x05, 0xc3, 0xfe, 0xff, 0x7b, 0x03, 0x89, 0xfe, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0xce, 0x04, 0xc2, 0xfe, 0xa8, 0x06, 0xc1, 0x00, 0x08,
-  0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x23, 0x14, 0x37, 0x15, 0x22, 0xfd,
-  0xce, 0xd9, 0x64, 0x65, 0xda, 0x05, 0xc3, 0xfe, 0xfe, 0x89, 0x03, 0x7b,
-  0x00, 0x01, 0xff, 0x86, 0x04, 0x9a, 0x00, 0x7a, 0x06, 0x12, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x33, 0x03, 0x23, 0x3a, 0xb4, 0x6a, 0x8a, 0x06, 0x12,
-  0xfe, 0x88, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xfd, 0xfd, 0xdf, 0xfe, 0xad,
-  0xff, 0x55, 0x10, 0x07, 0x00, 0x43, 0xfc, 0x65, 0xf8, 0xef, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0xb2, 0xfd, 0xdd, 0xff, 0x62, 0xff, 0x55, 0x10, 0x07,
-  0x00, 0x76, 0xfc, 0x65, 0xf8, 0xef, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x6d,
-  0xfe, 0x14, 0xfe, 0x6a, 0xff, 0xce, 0x00, 0x07, 0x00, 0x00, 0x01, 0x23,
-  0x35, 0x33, 0x35, 0x33, 0x11, 0x23, 0xfd, 0xfd, 0x90, 0x90, 0x6c, 0x6c,
-  0xfe, 0xb5, 0x78, 0xa1, 0xfe, 0x46, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xfd,
-  0xfe, 0x14, 0xfe, 0xfa, 0xff, 0xce, 0x00, 0x07, 0x00, 0x00, 0x05, 0x33,
-  0x15, 0x33, 0x15, 0x23, 0x15, 0x23, 0xfd, 0xfd, 0x6c, 0x90, 0x90, 0x6c,
-  0x32, 0xa1, 0x78, 0xa1, 0x00, 0x01, 0xfe, 0x7f, 0x05, 0x86, 0x00, 0x39,
-  0x07, 0x70, 0x00, 0x05, 0x00, 0x00, 0x03, 0x21, 0x35, 0x21, 0x11, 0x23,
-  0x42, 0xfe, 0xc2, 0x01, 0xb9, 0x7b, 0x06, 0xe8, 0x88, 0xfe, 0x16, 0x00,
-  0x00, 0x01, 0xff, 0x0b, 0x03, 0x6b, 0x00, 0x6f, 0x04, 0xe0, 0x00, 0x13,
-  0x00, 0x00, 0x03, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x27, 0x33, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0xf5, 0x37,
-  0x4f, 0x1c, 0x2a, 0x29, 0x0e, 0x0d, 0x78, 0x09, 0x09, 0x4f, 0x53, 0x2b,
-  0x5f, 0x03, 0xd7, 0x77, 0x2d, 0x2b, 0x37, 0x36, 0x20, 0x3e, 0x1f, 0x26,
-  0x44, 0x1e, 0x7a, 0x73, 0x35, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xc0,
-  0xfe, 0x12, 0xfe, 0x81, 0xff, 0xbe, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x15, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33,
-  0xfe, 0x81, 0x51, 0x70, 0x70, 0x51, 0x24, 0x30, 0x30, 0x24, 0xfe, 0x12,
-  0x7d, 0x5a, 0x59, 0x7c, 0x78, 0x35, 0x27, 0x28, 0x35, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x56, 0xfe, 0x14, 0xff, 0x10, 0xff, 0x4d, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35, 0x33, 0xfe, 0x70,
-  0xa0, 0xfe, 0x47, 0x9f, 0x7a, 0xfe, 0x9c, 0x88, 0x88, 0xb1, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x56, 0xfe, 0x14, 0xff, 0x10, 0xff, 0x4d, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x23, 0x35, 0x21, 0x15, 0x23, 0x15, 0x23, 0xfd, 0xf6,
-  0x9f, 0x01, 0xb9, 0xa0, 0x7a, 0xfe, 0xc5, 0x88, 0x88, 0xb1, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x6d, 0xfe, 0x14, 0xfe, 0xfa, 0xff, 0xce, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23,
-  0x15, 0x23, 0xfd, 0xfd, 0x90, 0x90, 0x6c, 0x90, 0x90, 0x6c, 0xfe, 0xb5,
-  0x78, 0xa1, 0xa1, 0x78, 0xa1, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x56,
-  0xfe, 0x88, 0xff, 0x10, 0xff, 0x10, 0x00, 0x03, 0x00, 0x00, 0x01, 0x35,
-  0x21, 0x15, 0xfd, 0x57, 0x01, 0xb9, 0xfe, 0x88, 0x88, 0x88, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0xba, 0xfe, 0x56, 0xff, 0xd5, 0x00, 0x80, 0x00, 0x0d,
-  0x00, 0x00, 0x27, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x3d, 0x01, 0x2b, 0x4a, 0x49, 0xa3, 0xe4, 0xd1, 0x5f, 0x22,
-  0x22, 0x80, 0x94, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x94, 0x00,
-  0x00, 0x01, 0xfd, 0xb7, 0xfe, 0x56, 0xff, 0xd3, 0x00, 0x80, 0x00, 0x0d,
-  0x00, 0x00, 0x25, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0xfd, 0xb8, 0xa6, 0x22, 0x22, 0x5e, 0xd2, 0xe4,
-  0xa3, 0x49, 0x4a, 0x80, 0x94, 0x99, 0x31, 0x30, 0x9c, 0x60, 0x60, 0xd6,
-  0x00, 0x01, 0xfd, 0xde, 0xfe, 0x89, 0xfe, 0x85, 0xff, 0x73, 0x00, 0x03,
-  0x00, 0x00, 0x05, 0x33, 0x15, 0x23, 0xfd, 0xdf, 0xa5, 0xa5, 0x8d, 0xea,
-  0xff, 0xff, 0xfd, 0x26, 0xfe, 0x89, 0xff, 0x3d, 0xff, 0x53, 0x10, 0x07,
-  0x00, 0x6a, 0xfc, 0x65, 0xf9, 0x43, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x70,
-  0xfe, 0x12, 0xfe, 0xf2, 0xff, 0xbe, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x37, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16,
-  0xfe, 0x85, 0x31, 0x23, 0x24, 0x2f, 0x2f, 0x24, 0x23, 0x31, 0x6d, 0x70,
-  0x51, 0x51, 0x6f, 0x6f, 0x51, 0x51, 0x70, 0xfe, 0xea, 0x26, 0x36, 0x35,
-  0x27, 0x28, 0x35, 0x36, 0x26, 0x5a, 0x7d, 0x7d, 0x5a, 0x59, 0x7c, 0x7c,
-  0x00, 0x01, 0xfd, 0xac, 0xfe, 0x14, 0xfe, 0xb4, 0xff, 0x54, 0x00, 0x03,
-  0x00, 0x00, 0x05, 0x33, 0x03, 0x23, 0xfd, 0xf6, 0xbe, 0x94, 0x74, 0xac,
-  0xfe, 0xc0, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x6c, 0xfe, 0x75, 0xfe, 0xe1,
-  0x00, 0x00, 0x10, 0x07, 0x00, 0x7a, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0x91, 0xfe, 0x75, 0xfe, 0xe1, 0x00, 0x00, 0x10, 0x07,
-  0x02, 0x9d, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xf6,
-  0xfe, 0x14, 0xfe, 0x71, 0xff, 0xa0, 0x00, 0x03, 0x00, 0x00, 0x05, 0x11,
-  0x23, 0x11, 0xfe, 0x70, 0x7a, 0x60, 0xfe, 0x74, 0x01, 0x8c, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x3e, 0xfe, 0x50, 0xff, 0x2f, 0xff, 0x9a, 0x00, 0x07,
-  0x00, 0x00, 0x07, 0x11, 0x23, 0x35, 0x23, 0x15, 0x23, 0x11, 0xd2, 0x7b,
-  0xf9, 0x7c, 0x66, 0xfe, 0xb6, 0xc2, 0xc2, 0x01, 0x4a, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfc, 0xbf, 0xfe, 0x39, 0xff, 0xa3, 0xff, 0x58, 0x00, 0x14,
-  0x00, 0x00, 0x01, 0x06, 0x23, 0x22, 0x03, 0x34, 0x35, 0x33, 0x16, 0x33,
-  0x32, 0x37, 0x33, 0x16, 0x17, 0x32, 0x37, 0x33, 0x02, 0x07, 0x22, 0xfe,
-  0x31, 0x36, 0x68, 0xc4, 0x0f, 0x69, 0x0c, 0x5e, 0x5b, 0x0e, 0x6a, 0x0b,
-  0x5e, 0x5b, 0x0e, 0x6a, 0x0d, 0xc6, 0x68, 0xfe, 0x8b, 0x52, 0x01, 0x1a,
-  0x02, 0x03, 0x96, 0x96, 0x95, 0x01, 0x96, 0xfe, 0xe2, 0x01, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0x17, 0xfe, 0x14, 0xff, 0x56, 0xff, 0x8c, 0x11, 0x07,
-  0x02, 0x89, 0xfc, 0x6a, 0xf9, 0x26, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x12,
-  0xfe, 0x14, 0xff, 0x51, 0xff, 0x8c, 0x11, 0x07, 0x02, 0x88, 0xfc, 0x65,
-  0xf9, 0x26, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x12, 0xfe, 0x39, 0xff, 0x46,
-  0xff, 0x58, 0x10, 0x07, 0x02, 0x9a, 0xfc, 0x5f, 0xf9, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x12, 0xfe, 0x36, 0xff, 0x46, 0xff, 0x55, 0x00, 0x0c,
-  0x00, 0x00, 0x03, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e,
-  0x01, 0x20, 0x16, 0xba, 0x6a, 0x0a, 0x58, 0x4e, 0x4d, 0x57, 0x0c, 0x6a,
-  0x09, 0x8f, 0x01, 0x04, 0x8f, 0xfe, 0x36, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f,
-  0x90, 0x90, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x08, 0xfe, 0x39, 0xff, 0x5b,
-  0xff, 0x53, 0x10, 0x07, 0x02, 0x9e, 0xfc, 0x65, 0xf9, 0x1c, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0x29, 0xfe, 0xc0, 0xff, 0x44, 0xff, 0x54, 0x10, 0x07,
-  0x02, 0x8f, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0x54,
-  0xfe, 0x1d, 0x00, 0x12, 0xfe, 0xac, 0x10, 0x07, 0x00, 0x42, 0xfc, 0x66,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0x54, 0xfe, 0x1d, 0x00, 0x12,
-  0xff, 0xee, 0x10, 0x07, 0x07, 0x4c, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfb, 0xfe, 0x01, 0xec, 0xff, 0xb6, 0x03, 0x0c, 0x00, 0x1b,
-  0x00, 0x00, 0x03, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x4b, 0x43, 0x81, 0x47, 0x51, 0x66,
-  0x13, 0x0a, 0x46, 0x5c, 0x2e, 0x47, 0x7f, 0x42, 0x46, 0x84, 0x4a, 0x30,
-  0x5a, 0x43, 0x0a, 0x13, 0x69, 0x53, 0x3f, 0x7c, 0x03, 0x0c, 0xae, 0x3b,
-  0x37, 0x33, 0x0a, 0x04, 0x21, 0x18, 0x3b, 0x3f, 0xae, 0x3c, 0x36, 0x16,
-  0x1f, 0x05, 0x0a, 0x37, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xb8,
-  0x01, 0xc4, 0xff, 0x94, 0x02, 0x68, 0x00, 0x03, 0x00, 0x00, 0x03, 0x15,
-  0x21, 0x35, 0x6c, 0xfe, 0x25, 0x02, 0x68, 0xa4, 0xa4, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfb, 0x6e, 0x01, 0xc4, 0x00, 0x00, 0x02, 0x68, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0xfb, 0x6f, 0x04, 0x90, 0x01, 0xc4,
-  0xa4, 0xa4, 0x00, 0x00, 0x00, 0x01, 0xfb, 0xdd, 0xff, 0xa2, 0xff, 0xc3,
-  0x04, 0xbc, 0x00, 0x03, 0x00, 0x00, 0x05, 0x27, 0x01, 0x17, 0xfc, 0x34,
-  0x56, 0x03, 0x8f, 0x56, 0x5e, 0x4e, 0x04, 0xcc, 0x4f, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfa, 0xa9, 0xff, 0xba, 0xff, 0x9d, 0x06, 0x17, 0x00, 0x03,
-  0x00, 0x00, 0x05, 0x27, 0x01, 0x17, 0xfb, 0x06, 0x5c, 0x04, 0x96, 0x5c,
-  0x46, 0x58, 0x06, 0x05, 0x59, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xe7,
-  0xfe, 0x12, 0xfe, 0xa9, 0xff, 0xbe, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x35, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0xfd, 0xe8, 0x51, 0x6f, 0x6f, 0x51, 0x24, 0x2f, 0x2f, 0x24, 0x42, 0x7d,
-  0x5a, 0x59, 0x7c, 0x78, 0x35, 0x27, 0x28, 0x35, 0x00, 0x01, 0xfd, 0x3f,
-  0xfe, 0x5b, 0xff, 0x30, 0xff, 0xa5, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x15, 0x33, 0x35, 0x33, 0x11, 0xfd, 0x3f, 0x7c, 0xf9, 0x7b, 0xfe,
-  0x5b, 0x01, 0x4a, 0xc2, 0xc2, 0xfe, 0xb6, 0x00, 0x00, 0x02, 0xfd, 0x6a,
-  0xfe, 0x14, 0xff, 0x00, 0xff, 0xd6, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x05, 0x11, 0x21, 0x11, 0x01, 0x35, 0x23, 0x15, 0xff, 0x00, 0xfe, 0x6a,
-  0x01, 0x2a, 0xbe, 0x2a, 0xfe, 0x3e, 0x01, 0xc2, 0xfe, 0xb6, 0xd2, 0xd2,
-  0x00, 0x01, 0xfc, 0xbf, 0xfe, 0x39, 0xff, 0xa3, 0xff, 0x58, 0x00, 0x14,
-  0x00, 0x00, 0x05, 0x36, 0x33, 0x32, 0x13, 0x14, 0x15, 0x23, 0x26, 0x23,
-  0x22, 0x07, 0x23, 0x26, 0x27, 0x22, 0x07, 0x23, 0x12, 0x37, 0x32, 0xfe,
-  0x31, 0x36, 0x68, 0xc4, 0x0f, 0x69, 0x0c, 0x5e, 0x5b, 0x0e, 0x6a, 0x0b,
-  0x5e, 0x5b, 0x0e, 0x6a, 0x0d, 0xc6, 0x68, 0xfa, 0x52, 0xfe, 0xe6, 0x02,
-  0x03, 0x96, 0x96, 0x95, 0x01, 0x96, 0x01, 0x1e, 0x01, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x73, 0x04, 0xf3, 0xff, 0x02, 0x06, 0xad, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07,
-  0x17, 0x07, 0xfe, 0x3a, 0x70, 0x56, 0x70, 0x70, 0x56, 0x70, 0x71, 0x56,
-  0x70, 0x70, 0x56, 0x05, 0x70, 0x7d, 0x60, 0x7d, 0x7d, 0x60, 0x7d, 0x7d,
-  0x60, 0x7d, 0x7d, 0x60, 0x00, 0x01, 0xfe, 0x38, 0x04, 0xc2, 0xff, 0x37,
-  0x06, 0xd2, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36,
-  0x37, 0x15, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27,
-  0xfe, 0x70, 0x1e, 0x19, 0x84, 0x79, 0x49, 0x42, 0x08, 0x0b, 0x10, 0x32,
-  0x1d, 0x19, 0x84, 0x79, 0x49, 0x42, 0x08, 0x0b, 0x10, 0x05, 0xc7, 0x1c,
-  0x30, 0x1c, 0x50, 0x51, 0x02, 0x6e, 0x02, 0x1b, 0x1c, 0x0a, 0x0c, 0x0f,
-  0x0e, 0x2b, 0x1c, 0x30, 0x1c, 0x50, 0x51, 0x02, 0x6e, 0x02, 0x1b, 0x1c,
-  0x0a, 0x0c, 0x0f, 0x0e, 0xff, 0xff, 0xfc, 0x54, 0x04, 0x3a, 0x00, 0x12,
-  0x06, 0x0b, 0x10, 0x27, 0x07, 0x73, 0xfc, 0x66, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x73, 0xfc, 0x66, 0xfe, 0xbe, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xfd,
-  0x04, 0xf0, 0xfe, 0xad, 0x06, 0x66, 0x10, 0x07, 0x00, 0x43, 0xfc, 0x65,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0xb2, 0x04, 0xee, 0xff, 0x62,
-  0x06, 0x66, 0x10, 0x07, 0x00, 0x76, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0x08, 0x05, 0x1d, 0xff, 0x5b, 0x06, 0x37, 0x10, 0x07,
-  0x02, 0x9e, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0xce,
-  0x04, 0xc2, 0xfe, 0xa8, 0x06, 0xc1, 0x10, 0x06, 0x02, 0xc4, 0x00, 0x00,
-  0xff, 0xff, 0xfd, 0x36, 0x05, 0x46, 0xff, 0x72, 0x07, 0xd2, 0x10, 0x07,
-  0x03, 0x1c, 0xfc, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0xff,
-  0xfe, 0x56, 0xfe, 0xc5, 0xff, 0xa4, 0x10, 0x07, 0x03, 0x16, 0xfc, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x26, 0x05, 0x1d, 0xff, 0x41,
-  0x06, 0x49, 0x00, 0x07, 0x00, 0x00, 0x03, 0x23, 0x35, 0x21, 0x15, 0x23,
-  0x11, 0x21, 0xc0, 0x87, 0xfe, 0xf4, 0x87, 0x02, 0x1a, 0x05, 0x1d, 0x96,
-  0x96, 0x01, 0x2c, 0x00, 0x00, 0x02, 0xfd, 0x68, 0xfe, 0x32, 0xfe, 0xfe,
-  0xff, 0xb8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21,
-  0x35, 0x21, 0x35, 0x21, 0xfe, 0xfe, 0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b,
-  0x01, 0x95, 0xfe, 0x32, 0x78, 0x96, 0x78, 0x00, 0x00, 0x02, 0xfd, 0x5f,
-  0xfe, 0x14, 0xff, 0x07, 0xff, 0xa0, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x05, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0xfd, 0x60, 0x87, 0x87,
-  0x01, 0x20, 0x87, 0x87, 0x60, 0xfe, 0x74, 0x01, 0x8c, 0xfe, 0x74, 0x00,
-  0x00, 0x01, 0xfd, 0x68, 0xfe, 0x14, 0xfe, 0xfe, 0xff, 0xd6, 0x00, 0x05,
-  0x00, 0x00, 0x05, 0x21, 0x11, 0x23, 0x11, 0x21, 0xfd, 0x69, 0x01, 0x95,
-  0x87, 0xfe, 0xf2, 0x2a, 0xfe, 0x3e, 0x01, 0x2c, 0x00, 0x01, 0xfd, 0x0a,
-  0x04, 0xee, 0xff, 0x5d, 0x06, 0x66, 0x00, 0x27, 0x00, 0x00, 0x01, 0x37,
-  0x33, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x07, 0x23, 0x37, 0x26, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0xfe, 0x32, 0x3c, 0x62, 0x60, 0x09, 0x14, 0x0f, 0x0b, 0x23,
-  0x10, 0x10, 0x02, 0x70, 0x02, 0x2e, 0x2d, 0x52, 0x23, 0x1c, 0x1b, 0x1e,
-  0x3b, 0x63, 0x60, 0x0c, 0x12, 0x0e, 0x0c, 0x22, 0x10, 0x11, 0x01, 0x71,
-  0x02, 0x2e, 0x2e, 0x52, 0x22, 0x1d, 0x1b, 0x05, 0xff, 0x67, 0xa9, 0x09,
-  0x0e, 0x0a, 0x24, 0x25, 0x52, 0x87, 0x4a, 0x49, 0x0e, 0x0d, 0x1d, 0x67,
-  0xa8, 0x0b, 0x0d, 0x0a, 0x24, 0x25, 0x52, 0x87, 0x4a, 0x49, 0x0e, 0x0d,
-  0x00, 0x03, 0xfd, 0x0a, 0x04, 0x89, 0xff, 0x5d, 0x06, 0xcc, 0x00, 0x1d,
-  0x00, 0x21, 0x00, 0x25, 0x00, 0x00, 0x01, 0x27, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x1d, 0x01, 0x23, 0x34, 0x36, 0x33, 0x32, 0x16, 0x1f, 0x01, 0x1e,
-  0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x26,
-  0x07, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0xfe, 0x30, 0x34, 0x16,
-  0x1c, 0x0b, 0x20, 0x24, 0x71, 0x5d, 0x4d, 0x21, 0x37, 0x2b, 0x33, 0x15,
-  0x1e, 0x0e, 0x1d, 0x24, 0x70, 0x02, 0x5c, 0x4c, 0x1e, 0x36, 0xd0, 0x87,
-  0x87, 0xbd, 0x87, 0x87, 0x05, 0x68, 0x21, 0x0e, 0x0b, 0x32, 0x2d, 0x06,
-  0x65, 0x76, 0x10, 0x1b, 0x1e, 0x0d, 0x0c, 0x33, 0x29, 0x06, 0x64, 0x77,
-  0x10, 0x2e, 0x96, 0x02, 0x43, 0x96, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x0a,
-  0x04, 0xc5, 0xff, 0x5d, 0x06, 0x90, 0x10, 0x22, 0x10, 0xed, 0x00, 0xb7,
-  0x10, 0x03, 0x10, 0xed, 0x00, 0x00, 0x00, 0xa7, 0x00, 0x01, 0xfc, 0xbf,
-  0xfe, 0x28, 0xff, 0xa7, 0xff, 0xc2, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x37,
-  0x21, 0x17, 0x23, 0x27, 0x37, 0x33, 0x07, 0x21, 0x27, 0x33, 0x17, 0x07,
-  0xfe, 0x98, 0x77, 0xfe, 0x49, 0x77, 0x72, 0x9d, 0x9d, 0x72, 0x77, 0x01,
-  0xb7, 0x77, 0x71, 0x9e, 0x9e, 0xfe, 0x28, 0x9b, 0x9b, 0xcd, 0xcd, 0x9b,
-  0x9b, 0xcd, 0xcd, 0x00, 0x00, 0x01, 0xfd, 0x7a, 0xfe, 0x14, 0xfe, 0xec,
-  0xff, 0xa4, 0x00, 0x08, 0x00, 0x00, 0x01, 0x23, 0x35, 0x07, 0x35, 0x37,
-  0x17, 0x15, 0x27, 0xfe, 0x60, 0x5a, 0x8b, 0xb8, 0xb9, 0x8c, 0xfe, 0x14,
-  0xe7, 0x84, 0x7e, 0xaf, 0xaf, 0x7e, 0x84, 0x00, 0x00, 0x01, 0xfd, 0xb8,
-  0x04, 0xe1, 0xfe, 0xae, 0x07, 0x06, 0x00, 0x10, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0xfe, 0xae, 0x3a, 0x26, 0x27, 0x27, 0x26, 0x3a, 0x67,
-  0x46, 0x48, 0x48, 0x46, 0x67, 0x06, 0x8b, 0x01, 0x2a, 0x2c, 0x40, 0x41,
-  0x2b, 0x2b, 0x01, 0x7b, 0x01, 0x4f, 0x50, 0xe6, 0x50, 0x4e, 0x01, 0x00,
-  0xff, 0xff, 0xfd, 0x12, 0x04, 0x60, 0xff, 0x46, 0x06, 0xd8, 0x10, 0x27,
-  0x02, 0xc2, 0x00, 0x00, 0x00, 0x90, 0x10, 0x06, 0x02, 0xb8, 0x00, 0xe5,
-  0xff, 0xff, 0xfd, 0x73, 0xfe, 0x14, 0xff, 0x02, 0xff, 0xce, 0x10, 0x07,
-  0x02, 0xee, 0x00, 0x00, 0xf9, 0x21, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xb8,
-  0x04, 0xe1, 0xfe, 0xae, 0x07, 0x06, 0x00, 0x12, 0x00, 0x00, 0x01, 0x30,
-  0x35, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x30, 0x35, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0xfd, 0xb9, 0x66, 0x47, 0x48, 0x48, 0x47,
-  0x66, 0x39, 0x26, 0x28, 0x28, 0x26, 0x06, 0x8b, 0x7b, 0x01, 0x4e, 0x50,
-  0xe6, 0x50, 0x4f, 0x01, 0x7b, 0x01, 0x2b, 0x2b, 0x41, 0x40, 0x2c, 0x2a,
-  0xff, 0xff, 0xff, 0x43, 0x05, 0x44, 0xff, 0xfb, 0x06, 0x10, 0x10, 0x07,
-  0x02, 0x9b, 0xfd, 0xd2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xfc, 0xe8,
-  0xfe, 0x12, 0xff, 0x7e, 0xff, 0xbf, 0x00, 0x07, 0x00, 0x15, 0x00, 0x1d,
-  0x00, 0x00, 0x00, 0x16, 0x32, 0x3e, 0x01, 0x26, 0x22, 0x06, 0x37, 0x36,
-  0x32, 0x16, 0x14, 0x06, 0x22, 0x27, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32,
-  0x12, 0x36, 0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0xfd, 0x55, 0x30, 0x47,
-  0x2f, 0x02, 0x31, 0x47, 0x30, 0xde, 0x38, 0xa3, 0x70, 0x70, 0xa4, 0x37,
-  0x38, 0xa3, 0x70, 0x70, 0xa3, 0xe5, 0x31, 0x31, 0x47, 0x30, 0x30, 0xfe,
-  0xc3, 0x35, 0x35, 0x4d, 0x37, 0x35, 0x6d, 0x3f, 0x7c, 0xb3, 0x7d, 0x41,
-  0x40, 0x7d, 0xb3, 0x7c, 0xfe, 0xce, 0x36, 0x4d, 0x36, 0x35, 0x4f, 0x35,
-  0xff, 0xff, 0xfc, 0xcb, 0xfe, 0x1b, 0x03, 0x35, 0xff, 0x85, 0x10, 0x07,
-  0x07, 0x74, 0xfd, 0x1b, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xcb,
-  0x06, 0x6b, 0x03, 0x35, 0x07, 0xd5, 0x10, 0x07, 0x07, 0x74, 0xfd, 0x1b,
-  0x08, 0x50, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xcb, 0x06, 0xd7, 0x03, 0x35,
-  0x07, 0x6b, 0x00, 0x03, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0xfc, 0xcb,
-  0x06, 0x6a, 0xf9, 0x96, 0x07, 0x6b, 0x94, 0x00, 0x00, 0x01, 0xfc, 0xcb,
-  0xfe, 0xc0, 0x03, 0x35, 0xff, 0x54, 0x00, 0x03, 0x00, 0x00, 0x05, 0x21,
-  0x15, 0x21, 0xfc, 0xcb, 0x06, 0x6a, 0xf9, 0x96, 0xac, 0x94, 0x00, 0x00,
-  0x00, 0x01, 0xfd, 0x72, 0x06, 0x0d, 0x02, 0x8e, 0x07, 0x27, 0x00, 0x23,
-  0x00, 0x00, 0x03, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
-  0x23, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x04, 0x81, 0x19, 0x48, 0x27, 0x21, 0x5a, 0x30, 0x3f, 0x05,
-  0x91, 0x03, 0x66, 0x65, 0xb4, 0x52, 0x38, 0x34, 0x51, 0x81, 0x19, 0x48,
-  0x27, 0x21, 0x57, 0x33, 0x40, 0x04, 0x91, 0x03, 0x66, 0x65, 0xb4, 0x52,
-  0x38, 0x34, 0x06, 0x4a, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x30, 0x47, 0x87,
-  0x4a, 0x49, 0x0e, 0x0d, 0x22, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x2c, 0x4b,
-  0x87, 0x4a, 0x49, 0x0e, 0x0d, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xcb,
-  0x06, 0x04, 0x03, 0x35, 0x07, 0x6e, 0x10, 0x07, 0x07, 0x75, 0xfd, 0x1b,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xd1, 0xfe, 0x28, 0x03, 0x38,
-  0xff, 0xc2, 0x00, 0x08, 0x00, 0x00, 0x01, 0x35, 0x21, 0x27, 0x33, 0x17,
-  0x07, 0x23, 0x37, 0xfc, 0xd2, 0x05, 0xcd, 0x76, 0x71, 0x9e, 0x9e, 0x71,
-  0x76, 0xfe, 0xc3, 0x64, 0x9b, 0xcd, 0xcd, 0x9b, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x00, 0x05, 0xd5, 0x10, 0x06, 0x0e, 0x40, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x03, 0x6f, 0x04, 0x60, 0x10, 0x06,
-  0x0e, 0x41, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x80,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xb5, 0x04, 0xcb, 0xb6, 0xfe, 0xac,
-  0xb7, 0xfe, 0xac, 0xb6, 0x05, 0xd5, 0xfc, 0xf4, 0x02, 0x62, 0xfa, 0xd5,
-  0x05, 0x2b, 0xfd, 0x9e, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf5,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0xb5, 0x03, 0x3f, 0xa5, 0xa7, 0xa6,
-  0xa7, 0xa6, 0x05, 0xd5, 0xfc, 0xf4, 0x02, 0x62, 0xfa, 0xd5, 0x05, 0x2b,
-  0xfd, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x90, 0x04, 0x74, 0x01, 0x76,
-  0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x1b, 0x01, 0x33, 0x03, 0x90, 0x3a,
-  0xac, 0x64, 0x04, 0x74, 0x01, 0xf2, 0xfe, 0x0e, 0x00, 0x01, 0x00, 0x90,
-  0xfe, 0x56, 0x01, 0x76, 0x00, 0x48, 0x00, 0x03, 0x00, 0x00, 0x25, 0x03,
-  0x23, 0x13, 0x01, 0x76, 0x3b, 0xab, 0x63, 0x48, 0xfe, 0x0e, 0x01, 0xf2,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x10, 0x06,
-  0x03, 0xac, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
-  0x04, 0x60, 0x10, 0x06, 0x03, 0xcc, 0x00, 0x00, 0x00, 0x01, 0x01, 0x8a,
-  0xfe, 0x56, 0x02, 0x51, 0xff, 0xa4, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x23,
-  0x22, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01,
-  0x02, 0x50, 0x85, 0x17, 0x18, 0x12, 0x86, 0x09, 0x0b, 0x0d, 0x1f, 0xfe,
-  0x56, 0x21, 0x1a, 0x2e, 0xe5, 0xe5, 0x0e, 0x0c, 0x0d, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90, 0x04, 0x7b, 0x10, 0x06,
-  0x02, 0x16, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
-  0x04, 0x7b, 0x10, 0x27, 0x00, 0x79, 0x01, 0x2e, 0xff, 0x84, 0x10, 0x06,
-  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90,
-  0x04, 0x7b, 0x10, 0x27, 0x00, 0x79, 0x00, 0x80, 0xff, 0x84, 0x10, 0x06,
-  0x02, 0x16, 0x00, 0x00, 0xff, 0xff, 0x00, 0x8e, 0xff, 0x12, 0x01, 0x96,
-  0x04, 0x23, 0x12, 0x06, 0x00, 0x1e, 0x00, 0x00, 0x00, 0x01, 0x01, 0x4d,
-  0x04, 0xee, 0x02, 0xfd, 0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33,
-  0x01, 0x23, 0x02, 0x4a, 0xb3, 0xfe, 0xdb, 0x8a, 0x06, 0x66, 0xfe, 0x88,
-  0xff, 0xff, 0x00, 0xc1, 0x05, 0x46, 0x02, 0xfd, 0x07, 0xd2, 0x12, 0x26,
-  0x00, 0x6a, 0x00, 0x00, 0x11, 0x07, 0x03, 0x1b, 0x00, 0x00, 0x01, 0x6c,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0xf7, 0x00, 0x00, 0x10, 0x06,
-  0x03, 0x26, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc5, 0x02, 0x48, 0x01, 0x83,
-  0x03, 0x46, 0x12, 0x06, 0x00, 0x79, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe9,
-  0x00, 0x00, 0x04, 0xea, 0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0x9c,
-  0x00, 0x00, 0x10, 0x07, 0x03, 0x2a, 0x00, 0xd3, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xf4, 0x00, 0x00, 0x05, 0x83, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x1b, 0xfe, 0xa6, 0x00, 0x00, 0x10, 0x07, 0x03, 0x2c, 0x00, 0xcd,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3e,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0xa1, 0x00, 0x00, 0x10, 0x07,
-  0x03, 0x2e, 0x00, 0xd3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf3,
-  0xff, 0xe3, 0x05, 0x68, 0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0xa6,
-  0x00, 0x00, 0x10, 0x06, 0x03, 0x34, 0x24, 0x00, 0xff, 0xff, 0xff, 0xe4,
-  0x00, 0x00, 0x05, 0xe9, 0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0x96,
-  0x00, 0x00, 0x10, 0x07, 0x03, 0x39, 0x01, 0x7f, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xde, 0x00, 0x00, 0x05, 0x6b, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x1b, 0xfe, 0x91, 0x00, 0x00, 0x10, 0x06, 0x03, 0x3d, 0x31, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x40, 0x07, 0xd2, 0x10, 0x27,
-  0x03, 0x1c, 0xff, 0x43, 0x00, 0x00, 0x12, 0x06, 0x03, 0x4d, 0x0e, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x25, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0xb5, 0x03, 0x44, 0xfd, 0x72, 0x05, 0xd5, 0xaa,
-  0xfa, 0xd5, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x05, 0xd5, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x21, 0x05,
-  0x01, 0x33, 0x01, 0x02, 0x76, 0xfe, 0x8f, 0x02, 0xe3, 0xfc, 0x26, 0x02,
-  0x01, 0xcf, 0x02, 0x00, 0x05, 0x0e, 0xfb, 0x9a, 0xa8, 0x05, 0xd5, 0xfa,
-  0x2b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
-  0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x3d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x2b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x05, 0xf0, 0x00, 0x03, 0x00, 0x12, 0x00, 0x21, 0x00, 0x00, 0x01, 0x21,
-  0x15, 0x21, 0x01, 0x22, 0x07, 0x06, 0x11, 0x10, 0x12, 0x33, 0x32, 0x37,
-  0x36, 0x11, 0x10, 0x27, 0x26, 0x27, 0x20, 0x00, 0x11, 0x10, 0x07, 0x06,
-  0x21, 0x20, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x01, 0x98, 0x02, 0x7b,
-  0xfd, 0x85, 0x01, 0x3e, 0xc6, 0x74, 0x75, 0xe9, 0xc6, 0xc6, 0x74, 0x74,
-  0x74, 0x74, 0xc6, 0x01, 0x1b, 0x01, 0x52, 0xa9, 0xa9, 0xfe, 0xe5, 0xfe,
-  0xe5, 0xaa, 0xa9, 0xa9, 0xaa, 0x03, 0x70, 0xaa, 0x02, 0x86, 0xa4, 0xa4,
-  0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0xa4, 0xa4, 0x01, 0x1a, 0x01, 0x1b,
-  0xa4, 0xa4, 0xa4, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0x9f, 0xd2, 0xd3, 0xd2,
-  0xd2, 0x01, 0x62, 0x01, 0x62, 0xd3, 0xd2, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x01, 0x6b, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x2c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x2e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x33, 0x23, 0x01, 0x33, 0x01, 0x23,
-  0x01, 0xce, 0xc0, 0x02, 0x01, 0xcf, 0x02, 0x00, 0xbd, 0xfe, 0x55, 0x05,
-  0xd5, 0xfa, 0x2b, 0x05, 0x0e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x30, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x31, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf2,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
-  0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x01, 0x13,
-  0x02, 0x80, 0xfd, 0x80, 0x5e, 0x03, 0x3d, 0xfc, 0xc3, 0x03, 0x3d, 0xfc,
-  0xc3, 0x03, 0x71, 0xaa, 0x03, 0x0e, 0xaa, 0xfb, 0x7f, 0xaa, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06,
-  0x00, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6,
-  0x05, 0xd5, 0x12, 0x06, 0x03, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x25, 0x21, 0x15, 0x21, 0x35, 0x09, 0x01, 0x35, 0x21, 0x15,
-  0x21, 0x01, 0x01, 0x86, 0x02, 0x91, 0xfc, 0x9e, 0x01, 0xaf, 0xfe, 0x51,
-  0x03, 0x51, 0xfd, 0x80, 0x01, 0xaf, 0xaa, 0xaa, 0xaa, 0x02, 0x70, 0x02,
-  0x11, 0xaa, 0xaa, 0xfd, 0xf3, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
-  0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x37, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x3c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67, 0x00, 0x00, 0x05, 0x44,
-  0x05, 0xd5, 0x00, 0x08, 0x00, 0x11, 0x00, 0x27, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x33, 0x36, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x03, 0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36,
-  0x37, 0x35, 0x33, 0x15, 0x16, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x07,
-  0x15, 0x23, 0x02, 0x7b, 0x87, 0x58, 0x75, 0x75, 0x58, 0x87, 0xb6, 0x87,
-  0x58, 0x74, 0x74, 0x58, 0x87, 0xb6, 0xdb, 0x8e, 0xaa, 0xaa, 0x8d, 0xdc,
-  0xb6, 0xdc, 0x8d, 0xa9, 0xa9, 0x8d, 0xdc, 0xb6, 0x04, 0x8e, 0x15, 0x57,
-  0x73, 0xc6, 0xc5, 0x73, 0x57, 0x15, 0x15, 0x57, 0x73, 0xc5, 0xc6, 0x73,
-  0x57, 0x15, 0xfc, 0x10, 0x16, 0x86, 0xa0, 0x01, 0x0f, 0x01, 0x0f, 0xa1,
-  0x87, 0x16, 0x9f, 0x9f, 0x17, 0x86, 0xa1, 0xfe, 0xf1, 0xfe, 0xf2, 0xa1,
-  0x86, 0x17, 0x9d, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
-  0x00, 0x00, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x21, 0x36,
-  0x27, 0x22, 0x27, 0x26, 0x03, 0x11, 0x33, 0x11, 0x10, 0x17, 0x16, 0x17,
-  0x11, 0x33, 0x11, 0x36, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x02, 0x07,
-  0x06, 0x23, 0x06, 0x17, 0x02, 0x7b, 0x01, 0x01, 0xc0, 0xaa, 0xa5, 0x04,
-  0xbf, 0x75, 0x63, 0x7c, 0xb6, 0x7d, 0x63, 0x74, 0xc0, 0x05, 0xa5, 0xa9,
-  0xc1, 0x01, 0x01, 0x86, 0xb0, 0xd2, 0xcc, 0x01, 0x68, 0x01, 0x99, 0xfe,
-  0x67, 0xfe, 0xe6, 0xa4, 0x8c, 0x0e, 0x03, 0xf1, 0xfc, 0x0f, 0x0e, 0x8c,
-  0xa4, 0x01, 0x1a, 0x01, 0x99, 0xfe, 0x67, 0xfe, 0x98, 0xcc, 0xd2, 0x48,
-  0xee, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x46, 0x00, 0x00, 0x05, 0x3b,
-  0x05, 0xe7, 0x00, 0x26, 0x00, 0x00, 0x25, 0x15, 0x21, 0x35, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x02, 0x15, 0x14, 0x17, 0x16,
-  0x17, 0x15, 0x21, 0x35, 0x21, 0x26, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36,
-  0x21, 0x20, 0x17, 0x16, 0x11, 0x14, 0x07, 0x06, 0x07, 0x05, 0x3a, 0xfd,
-  0xe4, 0xa0, 0x59, 0x59, 0x77, 0x77, 0xc2, 0xc3, 0xee, 0x59, 0x5a, 0xa0,
-  0xfd, 0xe4, 0x01, 0x1f, 0x8e, 0x41, 0x41, 0xac, 0xac, 0x01, 0x13, 0x01,
-  0x11, 0xad, 0xad, 0x40, 0x40, 0x91, 0xb2, 0xb2, 0xb2, 0x61, 0xa6, 0xa6,
-  0xca, 0xf0, 0x91, 0x91, 0xfe, 0xdd, 0xef, 0xca, 0xa6, 0xa6, 0x61, 0xb2,
-  0xb2, 0x8b, 0x95, 0x95, 0xb8, 0x01, 0x3e, 0xc5, 0xc5, 0xc5, 0xc4, 0xfe,
-  0xcb, 0xc2, 0x94, 0x94, 0x8d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0x00, 0x00, 0x02, 0x1c, 0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x02, 0xde,
-  0x01, 0x75, 0x13, 0x06, 0x03, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x07, 0x4e, 0x10, 0x27,
-  0x10, 0xeb, 0x03, 0xff, 0x01, 0x75, 0x13, 0x06, 0x03, 0x39, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
-  0x06, 0x66, 0x12, 0x26, 0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x03, 0x1b,
-  0x63, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
-  0x06, 0x66, 0x10, 0x26, 0x03, 0x1b, 0x48, 0x00, 0x12, 0x06, 0x03, 0x49,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0x00, 0xb2, 0x00, 0x00, 0x12, 0x06,
-  0x03, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x56,
-  0x06, 0x66, 0x12, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x03, 0x1b,
-  0xff, 0x59, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
-  0x07, 0xd2, 0x12, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x03, 0x1c,
-  0x18, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
-  0x04, 0x79, 0x00, 0x0d, 0x00, 0x2a, 0x00, 0x00, 0x01, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x1b, 0x01,
-  0x33, 0x03, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11, 0x10, 0x37,
-  0x36, 0x33, 0x20, 0x02, 0xf9, 0x27, 0x29, 0xa0, 0x78, 0x37, 0x46, 0x43,
-  0x45, 0x6d, 0x79, 0x40, 0x94, 0x59, 0x94, 0xb9, 0x24, 0x08, 0x20, 0x25,
-  0x1d, 0x4f, 0x63, 0x55, 0x4b, 0x25, 0x10, 0x29, 0x54, 0x29, 0x80, 0xd3,
-  0x67, 0x69, 0x72, 0x7f, 0xb2, 0x01, 0x18, 0x02, 0x09, 0xe7, 0xed, 0x6e,
-  0x8a, 0xb6, 0xdc, 0x69, 0x6b, 0xd5, 0x01, 0xe7, 0x01, 0x25, 0xfd, 0xa1,
-  0xdb, 0x31, 0x29, 0x30, 0x9c, 0x54, 0x2a, 0x58, 0x6f, 0x57, 0x29, 0x98,
-  0x9d, 0x01, 0x13, 0x01, 0x26, 0x8a, 0x9a, 0x00, 0x00, 0x02, 0x00, 0xac,
-  0xfe, 0x56, 0x04, 0x14, 0x06, 0x21, 0x00, 0x0e, 0x00, 0x1c, 0x00, 0x00,
-  0x25, 0x11, 0x23, 0x11, 0x10, 0x21, 0x20, 0x11, 0x10, 0x07, 0x16, 0x11,
-  0x10, 0x21, 0x22, 0x03, 0x16, 0x33, 0x20, 0x11, 0x10, 0x05, 0x35, 0x20,
-  0x11, 0x34, 0x23, 0x22, 0x11, 0x01, 0x53, 0xa6, 0x01, 0x7f, 0x01, 0x87,
-  0x9b, 0xfc, 0xfe, 0x4e, 0xbf, 0x50, 0x64, 0xb1, 0x01, 0x04, 0xfe, 0x5e,
-  0x01, 0x47, 0xd3, 0xeb, 0x45, 0xfe, 0x11, 0x06, 0x03, 0x01, 0xc8, 0xfe,
-  0x7f, 0xfe, 0xee, 0x64, 0x5a, 0xfe, 0xf5, 0xfe, 0x26, 0x01, 0x4a, 0xad,
-  0x01, 0x3a, 0x01, 0x1a, 0x16, 0xaa, 0x01, 0x40, 0xdb, 0xfe, 0xc8, 0x00,
-  0x00, 0x01, 0x00, 0x1c, 0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x0e,
-  0x00, 0x00, 0x01, 0x13, 0x01, 0x33, 0x01, 0x11, 0x23, 0x11, 0x01, 0x26,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x01, 0x45, 0xdc, 0x01, 0x3b, 0xb0, 0xfe,
-  0x68, 0xa5, 0xfe, 0xf7, 0x27, 0x56, 0x2c, 0x3f, 0xb1, 0x03, 0xb0, 0xfd,
-  0x4c, 0x03, 0x64, 0xfb, 0xa0, 0xfe, 0x56, 0x01, 0xaa, 0x03, 0x44, 0x7e,
-  0x9e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
-  0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x11, 0x34, 0x37, 0x36, 0x37, 0x26, 0x35, 0x10, 0x21, 0x32,
-  0x17, 0x01, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x03, 0x88, 0x5c, 0xd7, 0xe4, 0xee,
-  0xba, 0x6a, 0x80, 0x7b, 0x7c, 0xd8, 0xd7, 0x7c, 0x7b, 0x7b, 0x30, 0x43,
-  0x8c, 0x01, 0x8d, 0xc7, 0x6c, 0xfe, 0x48, 0x3d, 0x31, 0x4e, 0x4d, 0x4d,
-  0x86, 0x85, 0x9a, 0x51, 0x58, 0x71, 0x3a, 0x05, 0x11, 0x46, 0x75, 0x5c,
-  0x30, 0x25, 0x70, 0x87, 0xfe, 0xeb, 0xfe, 0xf7, 0x9c, 0x9d, 0x9d, 0x9c,
-  0x01, 0x13, 0xcc, 0xa5, 0x40, 0x24, 0x4f, 0x8d, 0x01, 0x10, 0x46, 0xfe,
-  0x28, 0x1d, 0x49, 0x71, 0xcc, 0xcb, 0x72, 0x73, 0xe8, 0xbe, 0xc7, 0x60,
-  0x67, 0x0b, 0x06, 0x00, 0x00, 0x01, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
-  0x04, 0x7c, 0x00, 0x32, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x01, 0x64, 0x65,
-  0x36, 0x36, 0x66, 0x66, 0xb0, 0x45, 0x99, 0x58, 0x57, 0x48, 0x49, 0x40,
-  0x6b, 0x3e, 0x3f, 0x3d, 0x3c, 0x69, 0x8b, 0x85, 0x7b, 0x41, 0x46, 0x4b,
-  0x4d, 0x88, 0x53, 0x4d, 0x4c, 0x40, 0x51, 0x4b, 0x4d, 0x48, 0xd6, 0x74,
-  0x74, 0x7c, 0x02, 0x5c, 0x18, 0x41, 0x40, 0x5d, 0x8d, 0x4f, 0x4e, 0x18,
-  0x18, 0xa7, 0x1d, 0x0d, 0x0d, 0x2e, 0x2e, 0x40, 0x46, 0x2d, 0x2c, 0x98,
-  0x33, 0x38, 0x58, 0x5a, 0x38, 0x38, 0x12, 0x13, 0x25, 0xab, 0x1c, 0x0e,
-  0x0e, 0x5b, 0x5b, 0xad, 0x6c, 0x92, 0x00, 0x00, 0x00, 0x01, 0x00, 0x60,
-  0xfe, 0x52, 0x03, 0x93, 0x06, 0x14, 0x00, 0x1d, 0x00, 0x00, 0x25, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x23, 0x20, 0x03, 0x10, 0x01, 0x21, 0x35, 0x21,
-  0x15, 0x00, 0x11, 0x10, 0x02, 0x83, 0x76, 0x47, 0x4c, 0x42, 0x49, 0x92,
-  0x3e, 0x26, 0x1d, 0x1d, 0x1d, 0x33, 0xfd, 0xde, 0x01, 0x02, 0x02, 0xfe,
-  0x21, 0x03, 0x0f, 0xfd, 0x75, 0x7f, 0x01, 0x4b, 0x4f, 0x78, 0x73, 0x50,
-  0x57, 0x4b, 0x4c, 0x05, 0x2c, 0x23, 0x25, 0x35, 0x2c, 0x2a, 0x02, 0x33,
-  0x01, 0xec, 0x01, 0x59, 0xb9, 0xb9, 0xfe, 0x94, 0xfe, 0x27, 0xfe, 0x69,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x04, 0x7b, 0x00, 0x15,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0x51, 0x50,
-  0x6a, 0xad, 0x59, 0x5a, 0x02, 0xa4, 0xfb, 0xb2, 0x04, 0x48, 0x9f, 0x9e,
-  0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78,
-  0x00, 0x03, 0x00, 0x65, 0xff, 0xe9, 0x04, 0x03, 0x06, 0x24, 0x00, 0x08,
-  0x00, 0x11, 0x00, 0x21, 0x00, 0x00, 0x01, 0x21, 0x12, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x13, 0x02, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x03,
-  0x01, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x11, 0x10, 0x37, 0x36, 0x03, 0x52, 0xfd, 0xc3, 0x0e, 0x3e, 0x4d, 0x86,
-  0x87, 0x4b, 0x42, 0x08, 0x1a, 0x30, 0x4d, 0x85, 0x8a, 0x48, 0x3a, 0x11,
-  0x01, 0x1d, 0xd8, 0x7c, 0x7b, 0x7b, 0x7c, 0xd8, 0xd9, 0x7a, 0x7b, 0x7b,
-  0x7a, 0x02, 0xc6, 0xfe, 0xd5, 0x7f, 0x9c, 0x9d, 0x8a, 0x01, 0xc9, 0x01,
-  0x1c, 0x64, 0x9e, 0x9c, 0x7e, 0xfe, 0xfc, 0x02, 0xb4, 0xd4, 0xd3, 0xfe,
-  0x8a, 0xfe, 0x8b, 0xd4, 0xd5, 0xd5, 0xd4, 0x01, 0x75, 0x01, 0x76, 0xd3,
-  0xd4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x95, 0x00, 0x00, 0x02, 0x30,
-  0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x03, 0x01, 0x40, 0x1e, 0x20,
-  0x62, 0x50, 0x64, 0xa2, 0x4a, 0x4a, 0x01, 0x04, 0x60, 0xfd, 0x2b, 0x91,
-  0x2e, 0x30, 0x9c, 0x60, 0x62, 0xd4, 0x02, 0xca, 0x00, 0x01, 0x00, 0xab,
-  0x00, 0x00, 0x04, 0x12, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0xac, 0xab,
-  0x01, 0xb3, 0xc9, 0xfe, 0x73, 0x01, 0xcb, 0xca, 0xfe, 0x8b, 0x7b, 0xab,
-  0x04, 0x60, 0xfe, 0x2f, 0x01, 0xd1, 0xfe, 0x5a, 0xfd, 0x46, 0x02, 0x42,
-  0x81, 0xfe, 0x3f, 0x00, 0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
-  0x06, 0x14, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23,
-  0x01, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x17, 0x16, 0x02, 0x3b, 0x01, 0xd1,
-  0xb0, 0xfe, 0xe6, 0xfe, 0xa4, 0xaf, 0x01, 0xba, 0x43, 0x2a, 0x60, 0x57,
-  0x69, 0xcc, 0x05, 0x65, 0xfa, 0x9b, 0x03, 0x3c, 0xfc, 0xc4, 0x04, 0x32,
-  0xc6, 0x7e, 0x9e, 0x02, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c,
-  0xfe, 0x56, 0x04, 0x68, 0x04, 0x60, 0x10, 0x06, 0x00, 0x77, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x42, 0x00, 0x00, 0x03, 0xb0, 0x04, 0x60, 0x00, 0x15,
-  0x00, 0x00, 0x21, 0x01, 0x33, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36, 0x27,
-  0x26, 0x27, 0x33, 0x31, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x01, 0x76, 0xfe, 0xcd, 0xb2, 0x01, 0x04, 0x6c, 0x5a, 0x45, 0x03, 0x02,
-  0x16, 0x19, 0x60, 0xa8, 0x3e, 0x29, 0x26, 0x7a, 0xa0, 0x6e, 0x04, 0x60,
-  0xfc, 0x54, 0x7c, 0xac, 0x81, 0x70, 0x35, 0x64, 0x77, 0x83, 0x59, 0x7c,
-  0x72, 0x4e, 0xc4, 0xaf, 0xe4, 0x74, 0x00, 0x00, 0x00, 0x01, 0x00, 0x60,
-  0xfe, 0x52, 0x03, 0x9b, 0x06, 0x14, 0x00, 0x26, 0x00, 0x00, 0x25, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x23, 0x20, 0x11, 0x10, 0x25, 0x26, 0x11, 0x34,
-  0x37, 0x23, 0x35, 0x21, 0x15, 0x20, 0x11, 0x14, 0x05, 0x15, 0x24, 0x13,
-  0x12, 0x02, 0x91, 0x77, 0x47, 0x4b, 0x42, 0x49, 0x92, 0x3e, 0x26, 0x1d,
-  0x1d, 0x1c, 0x34, 0xfd, 0xcf, 0x01, 0x2c, 0xfc, 0xc6, 0xbb, 0x02, 0xc6,
-  0xfd, 0xca, 0x01, 0xdb, 0xfd, 0xff, 0x02, 0x01, 0x7f, 0x01, 0x4b, 0x4f,
-  0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c, 0x05, 0x2c, 0x23, 0x25, 0x35, 0x2c,
-  0x2a, 0x01, 0xb5, 0x01, 0x2c, 0x58, 0x24, 0x01, 0x04, 0xc5, 0x52, 0xb9,
-  0xb9, 0xfe, 0xdd, 0xbf, 0x09, 0xaa, 0x16, 0xfe, 0xbc, 0xfe, 0xf1, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x12, 0x06,
-  0x00, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0x42, 0xff, 0xd9, 0x04, 0x23,
-  0x04, 0x60, 0x00, 0x17, 0x00, 0x00, 0x13, 0x21, 0x15, 0x23, 0x11, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
-  0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x43, 0x03, 0xc5, 0x7f, 0x2d, 0x31,
-  0x0d, 0x28, 0x06, 0x1f, 0x43, 0x21, 0x6c, 0x53, 0xfe, 0x8c, 0xa9, 0x80,
-  0x04, 0x60, 0xb8, 0xfd, 0x50, 0x48, 0x3f, 0x05, 0x01, 0x85, 0x0d, 0x0c,
-  0x83, 0xb0, 0x02, 0x9c, 0xfc, 0x58, 0x03, 0xa8, 0x00, 0x02, 0x00, 0xa7,
-  0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x00,
-  0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
-  0x26, 0x27, 0x11, 0x23, 0x11, 0x34, 0x05, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0xf8, 0x37, 0x88, 0x35, 0xa4, 0xb8,
-  0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xa7, 0x02, 0xda, 0x96, 0x83, 0x84,
-  0x96, 0x96, 0x84, 0x83, 0x96, 0x03, 0x98, 0x66, 0x5a, 0x23, 0xfe, 0xbc,
-  0xfe, 0xf8, 0xfe, 0xf8, 0xfe, 0xbc, 0x61, 0x64, 0xfd, 0xae, 0x03, 0xcf,
-  0xe7, 0xdd, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x65, 0xfe, 0x52, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x24,
-  0x00, 0x00, 0x05, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x17,
-  0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x02, 0x64, 0xf2, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x4d,
-  0x92, 0x44, 0x46, 0x8d, 0x48, 0xa2, 0xb2, 0xb2, 0x9e, 0x76, 0x48, 0x4c,
-  0x43, 0x49, 0x92, 0x3e, 0x26, 0x1d, 0x1d, 0x1c, 0x1d, 0x01, 0x3e, 0x01,
-  0x0e, 0x01, 0x12, 0x01, 0x3a, 0x23, 0x23, 0xac, 0x2b, 0x2b, 0xe3, 0xcd,
-  0xcd, 0xe3, 0x4c, 0x4f, 0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c, 0x05, 0x2c,
-  0x23, 0x25, 0x35, 0x2c, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x5b, 0x04, 0x60, 0x00, 0x0d, 0x00, 0x1e, 0x00, 0x00,
-  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x27, 0x21, 0x15, 0x23, 0x16, 0x15, 0x10, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x02, 0x34, 0x89, 0x49, 0x4e,
-  0x9a, 0x86, 0x85, 0x9a, 0x4d, 0x47, 0x8b, 0x02, 0x26, 0xb9, 0x62, 0x7b,
-  0x7c, 0xd8, 0xd9, 0x7a, 0x7b, 0x7b, 0x66, 0x03, 0xce, 0x6e, 0x73, 0xbe,
-  0xc9, 0xe7, 0xe8, 0xc8, 0xb7, 0x7a, 0x6e, 0x92, 0xb8, 0x9c, 0xdd, 0xfe,
-  0xed, 0x9c, 0x9d, 0x9d, 0x9c, 0x01, 0x13, 0x01, 0x15, 0x9b, 0x81, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x03, 0xfc, 0x04, 0x60, 0x00, 0x11,
-  0x00, 0x00, 0x25, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35,
-  0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x14, 0x02, 0x9c, 0x20, 0x62,
-  0x50, 0x64, 0xa2, 0x4a, 0x4a, 0xfe, 0x86, 0x03, 0xa2, 0xfe, 0x82, 0xcc,
-  0x30, 0x9c, 0x60, 0x62, 0xd4, 0x02, 0x12, 0xb8, 0xb8, 0xfd, 0xe3, 0x91,
-  0x00, 0x01, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x04, 0x60, 0x00, 0x1c,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x36, 0x27, 0x26, 0x27, 0x33, 0x31, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x27, 0x22, 0x27, 0x26, 0x35, 0x03, 0x01, 0x30, 0x2e, 0x31, 0x60,
-  0x87, 0x5e, 0x36, 0x0d, 0x07, 0x1b, 0x19, 0x5f, 0xa7, 0x3f, 0x29, 0x25,
-  0x73, 0x8c, 0xe5, 0xa1, 0x5a, 0x59, 0x01, 0x04, 0x60, 0xfd, 0x2b, 0x87,
-  0x40, 0x45, 0xd0, 0x76, 0xbb, 0x66, 0x80, 0x77, 0x83, 0x5a, 0x7b, 0x73,
-  0x9a, 0xfd, 0xbb, 0xe4, 0x01, 0x78, 0x76, 0xc5, 0x02, 0xca, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x64, 0xfe, 0x56, 0x04, 0x56, 0x04, 0x68, 0x00, 0x0a,
-  0x00, 0x29, 0x00, 0x00, 0x01, 0x22, 0x15, 0x11, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23,
-  0x11, 0x23, 0x11, 0x22, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x37, 0x15,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x11, 0x10, 0x02, 0xea,
-  0x3a, 0x55, 0x55, 0x4d, 0x4d, 0x40, 0x30, 0x7e, 0x73, 0x7b, 0x7b, 0x75,
-  0xb6, 0xa5, 0xb4, 0x77, 0x7b, 0x7b, 0x5b, 0x95, 0x3b, 0x34, 0x4e, 0x4d,
-  0x46, 0x65, 0x03, 0xcb, 0x91, 0xfd, 0x52, 0x68, 0x5d, 0xdf, 0xd0, 0x70,
-  0x5b, 0x9d, 0x84, 0x8d, 0xfe, 0xd9, 0xfe, 0xf1, 0xa1, 0x98, 0xfe, 0x6e,
-  0x01, 0x91, 0x99, 0x9c, 0x01, 0x13, 0x01, 0x1e, 0x92, 0x6d, 0x1c, 0xa3,
-  0x17, 0x4e, 0x73, 0xbe, 0xca, 0x73, 0x67, 0x02, 0xaf, 0x01, 0x2e, 0x00,
-  0x00, 0x01, 0x00, 0x35, 0xfe, 0x55, 0x03, 0xf4, 0x04, 0x61, 0x00, 0x17,
-  0x00, 0x00, 0x05, 0x03, 0x01, 0x23, 0x01, 0x03, 0x26, 0x2b, 0x01, 0x35,
-  0x17, 0x16, 0x17, 0x13, 0x01, 0x33, 0x01, 0x13, 0x16, 0x3b, 0x01, 0x15,
-  0x27, 0x26, 0x02, 0x92, 0x85, 0xfe, 0xeb, 0xc3, 0x01, 0x87, 0xa4, 0x2c,
-  0x8b, 0x2c, 0x3f, 0xe8, 0x3a, 0x86, 0x01, 0x14, 0xc4, 0xfe, 0x79, 0xa4,
-  0x2c, 0x8b, 0x2c, 0x3f, 0xe9, 0xfa, 0x01, 0x7f, 0xfd, 0xd0, 0x03, 0x18,
-  0x01, 0xd7, 0x7e, 0x9e, 0x02, 0x07, 0xa7, 0xfe, 0x81, 0x02, 0x30, 0xfc,
-  0xe8, 0xfe, 0x29, 0x7e, 0x9e, 0x02, 0x07, 0x00, 0x00, 0x01, 0x00, 0x64,
-  0xfe, 0x56, 0x04, 0x56, 0x04, 0x60, 0x00, 0x1b, 0x00, 0x00, 0x05, 0x26,
-  0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x17, 0x11, 0x33,
-  0x11, 0x36, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x07,
-  0x11, 0x23, 0x02, 0x0b, 0xd0, 0x60, 0x76, 0xa7, 0x4d, 0x43, 0x6f, 0xa5,
-  0x76, 0x3c, 0x4c, 0xa8, 0x76, 0x6a, 0xc6, 0xa5, 0x19, 0x25, 0x61, 0x77,
-  0xf3, 0x02, 0x89, 0xfd, 0x7e, 0xb7, 0x4c, 0x42, 0x0e, 0x03, 0xd5, 0xfc,
-  0x2c, 0x0e, 0x42, 0x54, 0xaf, 0x02, 0x81, 0xfd, 0x78, 0xfc, 0x6e, 0x63,
-  0x23, 0xfe, 0x6e, 0x00, 0x00, 0x01, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
-  0x04, 0x60, 0x00, 0x1a, 0x00, 0x00, 0x05, 0x20, 0x11, 0x34, 0x13, 0x33,
-  0x02, 0x15, 0x10, 0x33, 0x32, 0x11, 0x33, 0x10, 0x33, 0x32, 0x11, 0x34,
-  0x03, 0x33, 0x12, 0x15, 0x10, 0x21, 0x22, 0x03, 0x02, 0x01, 0xef, 0xfe,
-  0x8b, 0x8b, 0xb2, 0x81, 0xc8, 0xb7, 0x99, 0xb7, 0xc7, 0x80, 0xb2, 0x8c,
-  0xfe, 0x8a, 0xf5, 0x1d, 0x25, 0x1d, 0x02, 0x52, 0xeb, 0x01, 0x40, 0xfe,
-  0xc0, 0xf0, 0xfe, 0x4f, 0x02, 0x1a, 0xfd, 0xe6, 0x01, 0xb1, 0xf0, 0x01,
-  0x40, 0xfe, 0xc0, 0xeb, 0xfd, 0xae, 0x01, 0x2b, 0xfe, 0xd5, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x3e, 0x06, 0x10, 0x12, 0x26,
-  0x03, 0x4d, 0x0e, 0x00, 0x10, 0x07, 0x00, 0x6a, 0xff, 0x43, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x10, 0x10, 0x26,
-  0x00, 0x6a, 0x1a, 0x00, 0x12, 0x06, 0x03, 0x59, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x1b, 0x70, 0x00, 0x12, 0x06, 0x03, 0x53, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x1b, 0x1f, 0x00, 0x12, 0x06, 0x03, 0x59, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x12, 0x26,
-  0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x03, 0x1b, 0x01, 0x36, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x0c,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09, 0x02, 0x23, 0x13, 0x01,
-  0x11, 0x23, 0xb5, 0xb6, 0x02, 0x5b, 0xea, 0xfd, 0x65, 0x02, 0xca, 0xfe,
-  0xb7, 0x79, 0xf5, 0xfd, 0x59, 0xb6, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x77,
-  0xfd, 0x48, 0xfc, 0xe3, 0xfe, 0x56, 0x01, 0x84, 0x02, 0xf5, 0xfd, 0x31,
-  0x00, 0x03, 0x00, 0x96, 0xff, 0xe9, 0x03, 0xdf, 0x06, 0x24, 0x00, 0x0a,
-  0x00, 0x1b, 0x00, 0x27, 0x00, 0x00, 0x01, 0x32, 0x36, 0x37, 0x36, 0x37,
-  0x34, 0x23, 0x22, 0x07, 0x06, 0x01, 0x16, 0x15, 0x14, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x02, 0x37, 0x36, 0x17, 0x1e, 0x01, 0x12, 0x06, 0x07, 0x06,
-  0x23, 0x10, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x34, 0x26, 0x01, 0x45,
-  0x48, 0xb7, 0x3d, 0x6c, 0x01, 0xb7, 0x6e, 0x53, 0x31, 0x01, 0xbd, 0xdd,
-  0x35, 0x72, 0xfe, 0x40, 0x7d, 0x64, 0x02, 0x6c, 0x79, 0xbd, 0x94, 0xc4,
-  0x02, 0x54, 0xe2, 0x50, 0xc9, 0x34, 0x48, 0x9d, 0x81, 0x4e, 0x16, 0x9b,
-  0x03, 0x70, 0x04, 0x3d, 0x6c, 0x93, 0xde, 0xba, 0x6c, 0xfe, 0xc7, 0xa7,
-  0xe9, 0x82, 0x5f, 0xd5, 0xd5, 0xa8, 0x03, 0x2c, 0xbe, 0xd5, 0x01, 0x01,
-  0xe2, 0xfe, 0xe5, 0xb6, 0x96, 0x14, 0xfe, 0xea, 0x80, 0xb0, 0x9c, 0x2d,
-  0xd1, 0x9e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe9, 0x04, 0x03,
-  0x06, 0x24, 0x00, 0x0a, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x20, 0x27, 0x26, 0x11,
-  0x34, 0x36, 0x33, 0x32, 0x12, 0x10, 0x00, 0x20, 0x02, 0x11, 0x17, 0x15,
-  0x10, 0x12, 0x20, 0x12, 0x03, 0x50, 0x2c, 0x3c, 0x86, 0x4a, 0x6c, 0x6c,
-  0x43, 0xf7, 0xfe, 0xeb, 0x76, 0xbd, 0xbb, 0x9d, 0xc4, 0xdd, 0xff, 0x00,
-  0xfe, 0x53, 0xf0, 0xa9, 0x9e, 0x01, 0x11, 0x94, 0x03, 0x70, 0xf6, 0x7e,
-  0xaa, 0x89, 0x5a, 0xaa, 0x5a, 0x37, 0xaa, 0x41, 0x69, 0x01, 0x36, 0xa0,
-  0xde, 0xfe, 0x64, 0xfc, 0xfc, 0xfe, 0x65, 0x01, 0xb6, 0x01, 0xd2, 0x01,
-  0xa0, 0xfe, 0xf3, 0xfe, 0xbd, 0x01, 0x42, 0x00, 0x00, 0x01, 0x00, 0x4e,
-  0x00, 0x00, 0x04, 0xc9, 0x05, 0xdf, 0x00, 0x20, 0x00, 0x00, 0x01, 0x06,
-  0x03, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x27, 0x02, 0x27, 0x26, 0x22,
-  0x07, 0x35, 0x36, 0x32, 0x17, 0x04, 0x13, 0x12, 0x25, 0x36, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x03, 0xd9, 0x90, 0x4a, 0x26,
-  0xb7, 0x26, 0x49, 0x90, 0x46, 0x6b, 0x24, 0x1c, 0x64, 0x4d, 0x01, 0x22,
-  0x41, 0x60, 0x01, 0x03, 0x22, 0x56, 0x25, 0x4b, 0x0f, 0x17, 0x44, 0x77,
-  0x05, 0x11, 0x48, 0xfe, 0xf3, 0x8d, 0xa5, 0xfd, 0x76, 0x02, 0x8a, 0xa5,
-  0x8d, 0x01, 0x0d, 0x48, 0x23, 0x09, 0xaa, 0x0a, 0x0d, 0x30, 0xfe, 0x72,
-  0x01, 0x7b, 0x43, 0x09, 0x20, 0x40, 0x5b, 0x29, 0x2f, 0x42, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xe4, 0x00, 0x00, 0x05, 0xf8, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x1b, 0xfe, 0x96, 0x00, 0x00, 0x10, 0x07, 0x03, 0x66, 0x01, 0x2e,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4e, 0x00, 0x00, 0x04, 0xc9,
-  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x04, 0x4b, 0x01, 0x75, 0x12, 0x06,
-  0x03, 0x66, 0x00, 0x00, 0x00, 0x03, 0x00, 0x64, 0xfe, 0x56, 0x04, 0x56,
-  0x06, 0x14, 0x00, 0x15, 0x00, 0x1e, 0x00, 0x27, 0x00, 0x00, 0x01, 0x11,
-  0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x11, 0x23, 0x11, 0x22,
-  0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x33, 0x11, 0x13, 0x32, 0x37, 0x36,
-  0x37, 0x36, 0x27, 0x26, 0x23, 0x03, 0x11, 0x22, 0x07, 0x06, 0x17, 0x16,
-  0x17, 0x16, 0x02, 0xb0, 0xb3, 0x78, 0x7b, 0x7b, 0x78, 0xb3, 0xa5, 0xb4,
-  0x77, 0x7b, 0x7b, 0x77, 0xb4, 0xa5, 0x65, 0x45, 0x4c, 0x01, 0x01, 0x4e,
-  0x45, 0x65, 0xa5, 0x66, 0x45, 0x4e, 0x01, 0x01, 0x4c, 0x45, 0x06, 0x14,
-  0xfe, 0x63, 0x99, 0x9c, 0xfe, 0xed, 0xfe, 0xed, 0x9c, 0x99, 0xfe, 0x6f,
-  0x01, 0x91, 0x99, 0x9c, 0x01, 0x13, 0x01, 0x13, 0x9c, 0x99, 0x01, 0x9d,
-  0xfa, 0x77, 0x67, 0x73, 0xca, 0xc8, 0x75, 0x67, 0xfc, 0xb8, 0x03, 0x48,
-  0x67, 0x75, 0xc8, 0xca, 0x73, 0x67, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3a,
-  0xff, 0xe3, 0x05, 0xc9, 0x04, 0x60, 0x00, 0x10, 0x00, 0x1e, 0x00, 0x00,
-  0x13, 0x35, 0x21, 0x15, 0x23, 0x16, 0x15, 0x10, 0x25, 0x26, 0x03, 0x02,
-  0x23, 0x20, 0x11, 0x34, 0x37, 0x29, 0x01, 0x06, 0x15, 0x10, 0x33, 0x32,
-  0x03, 0x33, 0x02, 0x37, 0x36, 0x11, 0x34, 0x3a, 0x05, 0x8e, 0x84, 0x46,
-  0xfe, 0x8a, 0xf4, 0x1e, 0x25, 0xee, 0xfe, 0x8b, 0x45, 0x03, 0xce, 0xfc,
-  0xe9, 0x40, 0xc8, 0xbb, 0x04, 0x99, 0x04, 0xbb, 0xc7, 0x03, 0xa8, 0xb8,
-  0xb8, 0xcf, 0xa4, 0xfd, 0xad, 0x01, 0x01, 0x01, 0x2a, 0xfe, 0xd5, 0x02,
-  0x52, 0xa4, 0xcf, 0xd1, 0xa7, 0xfe, 0x4f, 0x02, 0x1a, 0xfd, 0xe3, 0x03,
-  0x03, 0x01, 0xae, 0xa7, 0x00, 0x01, 0x00, 0x64, 0xfe, 0x5b, 0x04, 0x53,
-  0x04, 0x67, 0x00, 0x39, 0x00, 0x00, 0x05, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x07, 0x02, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x01, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32, 0x17, 0x04, 0x11,
-  0x14, 0x07, 0x37, 0x12, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x01, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x02, 0x07, 0x06, 0x22, 0x27,
-  0x35, 0x16, 0x33, 0x32, 0x03, 0x93, 0xdd, 0x1e, 0x09, 0x0c, 0xaa, 0x57,
-  0xb4, 0x31, 0x1f, 0x31, 0x01, 0x07, 0x37, 0x0c, 0x18, 0x7f, 0x34, 0x52,
-  0x3a, 0x52, 0x17, 0x19, 0x01, 0x00, 0x1a, 0xaa, 0x56, 0xb4, 0x32, 0x1f,
-  0x31, 0xfe, 0xf9, 0x37, 0x0c, 0x18, 0x7f, 0x34, 0x51, 0x22, 0xb8, 0x3f,
-  0x92, 0x54, 0x56, 0x41, 0x94, 0x0a, 0x20, 0xf0, 0x49, 0x81, 0x35, 0x6c,
-  0xfe, 0xf7, 0x7c, 0x22, 0x4f, 0x9a, 0x01, 0x09, 0x8a, 0x7a, 0x3a, 0x36,
-  0x68, 0x6c, 0xe0, 0x30, 0x04, 0x27, 0xfe, 0xc3, 0x5b, 0x4d, 0x6c, 0x01,
-  0x09, 0x7c, 0x22, 0x4f, 0x9a, 0xfe, 0xf7, 0x8a, 0x7a, 0x3a, 0x36, 0x68,
-  0x6c, 0xfd, 0xe0, 0x66, 0x24, 0x31, 0xa0, 0x31, 0x00, 0x02, 0x00, 0x67,
-  0xfe, 0x58, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x11, 0x00, 0x1f, 0x00, 0x00,
-  0x05, 0x11, 0x23, 0x11, 0x26, 0x27, 0x26, 0x10, 0x37, 0x36, 0x21, 0x20,
-  0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x02, 0x20, 0x07, 0x06, 0x11, 0x10,
-  0x17, 0x16, 0x20, 0x37, 0x36, 0x11, 0x10, 0x27, 0x03, 0x2a, 0xa6, 0xe2,
-  0x90, 0xaa, 0xaa, 0xa9, 0x01, 0x1b, 0x01, 0x1b, 0xa9, 0xa9, 0xa9, 0x8f,
-  0x6f, 0xfe, 0x74, 0x74, 0x75, 0x75, 0x74, 0x01, 0x8c, 0x74, 0x74, 0x74,
-  0x18, 0xfe, 0x70, 0x01, 0x90, 0x1a, 0xb3, 0xd2, 0x02, 0xc4, 0xd3, 0xd2,
-  0xd2, 0xd3, 0xfe, 0x9e, 0xfe, 0x9f, 0xd2, 0xb3, 0x05, 0x49, 0xa4, 0xa4,
-  0xfe, 0xe5, 0xfe, 0xe6, 0xa4, 0xa4, 0xa4, 0xa4, 0x01, 0x1a, 0x01, 0x1b,
-  0xa4, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x03,
-  0x04, 0x7b, 0x00, 0x0d, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
-  0x10, 0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x03, 0x11,
-  0x23, 0x11, 0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x33, 0x32, 0x12,
-  0x11, 0x10, 0x07, 0x06, 0x02, 0x34, 0x85, 0x4d, 0x4e, 0x4d, 0x4d, 0x86,
-  0x85, 0x9a, 0x4d, 0x4d, 0x34, 0x99, 0xab, 0x60, 0x7b, 0x7b, 0x7a, 0xd9,
-  0xd8, 0xf7, 0x7b, 0x60, 0x03, 0xdf, 0x73, 0x74, 0xfe, 0x6e, 0x74, 0x73,
-  0xe8, 0xc8, 0xc7, 0x74, 0x75, 0xfc, 0x09, 0xfe, 0x6e, 0x01, 0x92, 0x1b,
-  0x7d, 0x9c, 0x01, 0x13, 0x01, 0x14, 0x9c, 0x9c, 0xfe, 0xc8, 0xfe, 0xec,
-  0xfe, 0xed, 0x9c, 0x7b, 0x00, 0x01, 0x00, 0x7d, 0xfe, 0x52, 0x04, 0x34,
-  0x05, 0xd5, 0x00, 0x24, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x11, 0x10,
-  0x17, 0x16, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34,
-  0x35, 0x16, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x20, 0x27, 0x26,
-  0x11, 0x10, 0x37, 0x36, 0x29, 0x01, 0x15, 0x02, 0xf2, 0xf2, 0x56, 0x6f,
-  0x52, 0x62, 0xb4, 0x6e, 0x50, 0x4b, 0x42, 0x48, 0x93, 0x3e, 0x26, 0x1d,
-  0x1d, 0x1c, 0x34, 0xfe, 0xe0, 0x80, 0x86, 0xa7, 0x7c, 0x01, 0x52, 0x01,
-  0x42, 0x05, 0x2b, 0x77, 0x98, 0xfe, 0xcd, 0xfe, 0xb5, 0x7f, 0x98, 0x54,
-  0x4f, 0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c, 0x05, 0x2c, 0x23, 0x25, 0x35,
-  0x2c, 0x2a, 0xcb, 0xd6, 0x01, 0x65, 0x01, 0x4e, 0xed, 0xb1, 0xaa, 0x00,
-  0x00, 0x01, 0x00, 0x65, 0xfe, 0x52, 0x03, 0xe3, 0x04, 0x60, 0x00, 0x20,
-  0x00, 0x00, 0x05, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x21, 0x15, 0x21,
-  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x02,
-  0x2a, 0xb8, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x01, 0x82, 0xfe, 0x86, 0xa2,
-  0xb2, 0xb2, 0x64, 0x75, 0x48, 0x4c, 0x43, 0x48, 0x92, 0x3e, 0x26, 0x1c,
-  0x1c, 0x1d, 0x1d, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x1f, 0x9c,
-  0xc7, 0xce, 0xcd, 0xe3, 0x4c, 0x4f, 0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c,
-  0x05, 0x2c, 0x23, 0x25, 0x35, 0x2c, 0x2a, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0xba, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x29, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0x53, 0xfe, 0x56, 0x02, 0xf3, 0x06, 0x14, 0x00, 0x27,
-  0x00, 0x00, 0x33, 0x11, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x21, 0x15,
-  0x21, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0xd6, 0x7b, 0x56, 0x98, 0x2c, 0x2d,
-  0x2c, 0x2e, 0x20, 0x25, 0x25, 0x28, 0x6c, 0x34, 0x43, 0x01, 0x21, 0xfe,
-  0xdf, 0x7d, 0x59, 0x9b, 0x34, 0x2e, 0x2d, 0x2a, 0x2c, 0x2d, 0x2d, 0x2b,
-  0x4f, 0x39, 0x4a, 0x04, 0x82, 0xa0, 0x8e, 0x64, 0x09, 0x09, 0x12, 0xa4,
-  0x1c, 0x0e, 0x0f, 0x3e, 0x51, 0x6f, 0xfe, 0xc9, 0x8f, 0xfd, 0x3f, 0x92,
-  0xa5, 0x73, 0x0a, 0x0b, 0x16, 0xa4, 0x1f, 0x10, 0x11, 0x4b, 0x5f, 0x00,
-  0x00, 0x01, 0x00, 0xa1, 0xff, 0xfc, 0x04, 0x59, 0x05, 0xd5, 0x00, 0x17,
-  0x00, 0x00, 0x01, 0x03, 0x01, 0x03, 0x06, 0x17, 0x16, 0x37, 0x15, 0x22,
-  0x27, 0x26, 0x37, 0x13, 0x01, 0x13, 0x36, 0x27, 0x26, 0x07, 0x35, 0x32,
-  0x17, 0x16, 0x01, 0xfd, 0x63, 0x02, 0xbe, 0xd2, 0x23, 0x18, 0x3b, 0x76,
-  0xcf, 0x49, 0x55, 0x11, 0x8b, 0xfd, 0x52, 0x9b, 0x23, 0x19, 0x3b, 0x76,
-  0xcf, 0x49, 0x55, 0x04, 0x87, 0xfe, 0x5b, 0x01, 0x7e, 0xfd, 0x2c, 0x60,
-  0x2a, 0x6c, 0x23, 0xbd, 0x46, 0x52, 0xb6, 0x01, 0xda, 0xfe, 0x91, 0x02,
-  0x90, 0x60, 0x2a, 0x6c, 0x23, 0xbd, 0x46, 0x52, 0x00, 0x01, 0x00, 0xab,
-  0x00, 0x00, 0x04, 0x14, 0x06, 0x13, 0x00, 0x07, 0x00, 0x00, 0x01, 0x03,
-  0x23, 0x13, 0x21, 0x13, 0x33, 0x03, 0x04, 0x14, 0xfd, 0xa5, 0xcb, 0xfd,
-  0x6f, 0xfd, 0xa5, 0xcb, 0x03, 0x70, 0xfc, 0x90, 0x02, 0xc6, 0x03, 0x4d,
-  0xfd, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x66, 0xfe, 0x56, 0x05, 0xbd,
-  0x05, 0xf0, 0x00, 0x21, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x06, 0x07,
-  0x35, 0x36, 0x21, 0x20, 0x13, 0x12, 0x11, 0x10, 0x03, 0x23, 0x12, 0x11,
-  0x10, 0x27, 0x06, 0x07, 0x06, 0x15, 0x11, 0x23, 0x36, 0x11, 0x34, 0x3f,
-  0x01, 0x02, 0x21, 0x22, 0x02, 0x16, 0x99, 0xb9, 0x5d, 0xbb, 0x01, 0x5b,
-  0x01, 0xaa, 0xd5, 0xc1, 0xde, 0xca, 0xea, 0x4a, 0x4a, 0x55, 0x3a, 0xb8,
-  0x02, 0xa3, 0xa9, 0xbb, 0xfe, 0xc6, 0x2b, 0x05, 0x3a, 0xfd, 0x8c, 0x02,
-  0x49, 0x4b, 0x69, 0xc6, 0xcf, 0xfe, 0xce, 0xfe, 0xec, 0xfd, 0xc2, 0xfe,
-  0x58, 0xfe, 0x92, 0x01, 0x4c, 0x01, 0xca, 0x01, 0xd1, 0x7d, 0x2f, 0x4d,
-  0x34, 0xd0, 0xfd, 0xc6, 0x21, 0x02, 0x14, 0xf7, 0x8f, 0x8d, 0x01, 0x04,
-  0x00, 0x01, 0x00, 0x6b, 0xfe, 0x90, 0x04, 0x21, 0x04, 0x78, 0x00, 0x16,
-  0x00, 0x00, 0x01, 0x03, 0x23, 0x01, 0x26, 0x27, 0x01, 0x23, 0x01, 0x26,
-  0x27, 0x26, 0x23, 0x35, 0x20, 0x17, 0x16, 0x13, 0x12, 0x11, 0x23, 0x10,
-  0x27, 0x03, 0x16, 0xd7, 0xa6, 0x01, 0x40, 0x0d, 0x2d, 0xfe, 0x73, 0xa7,
-  0x01, 0xe9, 0x58, 0x2a, 0xa9, 0xbe, 0x01, 0x0f, 0xda, 0xc9, 0x9b, 0x69,
-  0x98, 0x56, 0x01, 0x34, 0xfe, 0xcc, 0x01, 0xc0, 0x23, 0x4d, 0xfd, 0xd0,
-  0x02, 0xb0, 0x7f, 0x21, 0x84, 0xa4, 0xd8, 0xc8, 0xfe, 0x50, 0xfe, 0xdf,
-  0xfe, 0x89, 0x01, 0x5e, 0xf6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
-  0xfe, 0x4b, 0x06, 0x52, 0x05, 0xd5, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x10,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x37,
-  0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11,
-  0x34, 0x13, 0x36, 0x37, 0x33, 0x06, 0x03, 0x06, 0x15, 0x10, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x11, 0x34, 0x27, 0x02, 0x27, 0x33, 0x16, 0x17, 0x12,
-  0x06, 0x51, 0x37, 0x3d, 0xc5, 0xa2, 0xf8, 0x6a, 0x7e, 0x58, 0x7c, 0x6d,
-  0xb9, 0x93, 0x5c, 0x3d, 0x5a, 0x24, 0x23, 0x5a, 0x5b, 0x83, 0xbe, 0x6d,
-  0x6e, 0x5a, 0x35, 0x53, 0xe0, 0x4b, 0x7a, 0x3c, 0x41, 0x42, 0x70, 0x67,
-  0x40, 0x40, 0xb3, 0x3f, 0x3f, 0x69, 0x78, 0x3b, 0x40, 0x3c, 0x7a, 0x4c,
-  0xe1, 0x56, 0x32, 0x5a, 0x02, 0xe0, 0xfe, 0xef, 0xcb, 0xe6, 0xa6, 0x88,
-  0x64, 0x2a, 0x17, 0x85, 0x18, 0x30, 0x51, 0x80, 0x17, 0x41, 0x5e, 0xad,
-  0xad, 0x5e, 0x5e, 0xb1, 0xb4, 0x01, 0x98, 0xc9, 0x01, 0x0e, 0x9f, 0x7f,
-  0x46, 0xfe, 0xbf, 0x9f, 0xb7, 0xfe, 0xcd, 0x6b, 0x6d, 0x69, 0x68, 0xc6,
-  0xf1, 0xf1, 0xc6, 0x68, 0x69, 0x6d, 0x77, 0x01, 0x27, 0xb7, 0x9f, 0x01,
-  0x41, 0x46, 0x82, 0x9c, 0xfe, 0xeb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x79,
-  0xfe, 0x55, 0x05, 0x8a, 0x04, 0x60, 0x00, 0x25, 0x00, 0x00, 0x21, 0x26,
-  0x03, 0x02, 0x23, 0x20, 0x11, 0x34, 0x13, 0x33, 0x02, 0x15, 0x10, 0x17,
-  0x16, 0x03, 0x33, 0x02, 0x37, 0x36, 0x11, 0x34, 0x03, 0x33, 0x12, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36,
-  0x04, 0x14, 0xf8, 0x1a, 0x20, 0xf3, 0xfe, 0x8b, 0x79, 0xc4, 0x81, 0xc8,
-  0xbc, 0x05, 0x99, 0x03, 0xba, 0xc7, 0x80, 0xc4, 0x7a, 0x33, 0x5e, 0xb2,
-  0x8a, 0xbd, 0x61, 0x64, 0x52, 0x49, 0x7d, 0xb3, 0x01, 0x01, 0x0d, 0xfe,
-  0xed, 0x02, 0x3a, 0xeb, 0x01, 0x40, 0xfe, 0xc0, 0xf0, 0xfe, 0x97, 0x01,
-  0x01, 0x01, 0xd4, 0xfe, 0x2b, 0x02, 0x02, 0x01, 0x68, 0xf0, 0x01, 0x40,
-  0xfe, 0xc0, 0xeb, 0xd1, 0x84, 0xf4, 0x9e, 0x7b, 0x49, 0x25, 0x10, 0x6c,
-  0x0b, 0x2b, 0x3f, 0x00, 0x00, 0x01, 0x00, 0x67, 0xfe, 0x56, 0x04, 0xc1,
-  0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x11, 0x14,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x23, 0x11,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11, 0x10, 0x13, 0x36, 0x25,
-  0x02, 0xa1, 0xa2, 0x56, 0x78, 0x63, 0x58, 0xb0, 0xb0, 0x58, 0x5a, 0xc3,
-  0xc3, 0x3e, 0x5d, 0x5e, 0x99, 0xe6, 0x8d, 0x91, 0xa7, 0x88, 0x01, 0x0a,
-  0x05, 0x4a, 0x12, 0x84, 0xb9, 0xfe, 0xee, 0xf9, 0xab, 0x98, 0x98, 0x99,
-  0x01, 0x0b, 0x02, 0xec, 0xf8, 0x81, 0x02, 0x90, 0x84, 0x40, 0x3f, 0xd5,
-  0xdd, 0x01, 0x47, 0x01, 0x36, 0x01, 0x08, 0xd5, 0x01, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x18, 0x04, 0x7b, 0x00, 0x1c,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37,
-  0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x02, 0x4a, 0x8b, 0x48, 0x66,
-  0x54, 0x4b, 0x01, 0x2b, 0x4b, 0x4c, 0xa6, 0xa6, 0x34, 0x4f, 0x51, 0x81,
-  0xc4, 0x78, 0x7b, 0x8e, 0x72, 0xe4, 0x03, 0xfd, 0x0e, 0x63, 0x8d, 0xd0,
-  0xbd, 0x81, 0x74, 0x73, 0x74, 0xcb, 0x02, 0x31, 0xf9, 0xf6, 0x02, 0x52,
-  0x64, 0x30, 0x31, 0xa2, 0xa8, 0xf8, 0xec, 0xc8, 0xa2, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x4b, 0x05, 0x4c, 0x05, 0xd5, 0x00, 0x25,
-  0x00, 0x00, 0x01, 0x20, 0x17, 0x16, 0x11, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
-  0x11, 0x36, 0x37, 0x36, 0x02, 0xf8, 0x01, 0x09, 0x9f, 0xab, 0x36, 0x3c,
-  0x99, 0xaf, 0xd9, 0xa7, 0x41, 0x58, 0x79, 0x70, 0xc4, 0x88, 0x7b, 0x27,
-  0x31, 0x71, 0x68, 0xb8, 0xb7, 0x68, 0x65, 0xb6, 0xb6, 0x46, 0x5e, 0x5f,
-  0x04, 0x7b, 0xb3, 0xc2, 0xfe, 0xfd, 0xcc, 0xa1, 0xb2, 0x80, 0x93, 0x45,
-  0x35, 0x0c, 0x85, 0x16, 0x32, 0x57, 0x7a, 0x6d, 0x68, 0x7f, 0xc0, 0x9d,
-  0x96, 0x86, 0x81, 0x7e, 0xde, 0xfe, 0x27, 0x05, 0xd5, 0xfd, 0x9a, 0x87,
-  0x42, 0x43, 0x00, 0x00, 0x00, 0x02, 0x00, 0x28, 0xff, 0xe3, 0x04, 0x1d,
-  0x04, 0x9a, 0x00, 0x17, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x27, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x36, 0x37,
-  0x17, 0x06, 0x02, 0xdb, 0x73, 0x7e, 0x1c, 0x32, 0x1a, 0x21, 0x1a, 0x0f,
-  0x0c, 0x0a, 0x0e, 0x16, 0x17, 0x1f, 0x1d, 0x1b, 0x17, 0x40, 0x35, 0x42,
-  0x20, 0xf0, 0x61, 0x72, 0x64, 0xee, 0x7f, 0x59, 0x44, 0x2f, 0x3b, 0x49,
-  0x4c, 0x7a, 0x56, 0x74, 0x4a, 0x39, 0x52, 0x8d, 0x47, 0x44, 0x2c, 0x19,
-  0x1c, 0x3e, 0x6a, 0x5c, 0x40, 0x24, 0x41, 0x2d, 0x3a, 0x2b, 0x25, 0x1b,
-  0x1a, 0x1c, 0x29, 0x38, 0x48, 0x5b, 0x55, 0xbd, 0x81, 0x33, 0x26, 0x7a,
-  0x31, 0x03, 0x44, 0x98, 0x16, 0x0b, 0x21, 0x1a, 0x20, 0x1b, 0x21, 0x20,
-  0x15, 0x1c, 0x11, 0x14, 0x06, 0x05, 0x19, 0x14, 0x31, 0x18, 0x32, 0xc0,
-  0xd4, 0xb0, 0x9c, 0x88, 0x2e, 0x23, 0x41, 0x93, 0x4c, 0x2e, 0x23, 0x5e,
-  0x59, 0x7f, 0x8c, 0x71, 0x19, 0x17, 0x34, 0x2b, 0x26, 0x02, 0x01, 0x0a,
-  0x07, 0x22, 0x1a, 0x48, 0x34, 0x42, 0x3b, 0x3b, 0x3d, 0x2f, 0x3f, 0x22,
-  0x2b, 0x9f, 0x56, 0x68, 0x50, 0x92, 0x00, 0x00, 0x00, 0x01, 0x00, 0x47,
-  0xfe, 0x56, 0x04, 0x8a, 0x05, 0xf6, 0x00, 0x21, 0x00, 0x00, 0x05, 0x06,
-  0x23, 0x20, 0x01, 0x00, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x02, 0x01, 0x16, 0x33, 0x20, 0x37, 0x04, 0x7b, 0xe7, 0xf7,
-  0xfe, 0xd0, 0xfe, 0xda, 0x02, 0x74, 0xa1, 0x62, 0x62, 0x59, 0x93, 0xa2,
-  0x55, 0x1f, 0x16, 0xd8, 0x28, 0x4d, 0x93, 0xfc, 0xf7, 0x91, 0x92, 0x92,
-  0xee, 0xfe, 0x48, 0x8d, 0xbf, 0x01, 0x0c, 0xd1, 0xec, 0xbe, 0x01, 0xa3,
-  0x01, 0xf1, 0xdb, 0x84, 0x9c, 0x8d, 0x65, 0x5d, 0x92, 0x36, 0x3f, 0xa1,
-  0x66, 0xc2, 0x90, 0x91, 0xf1, 0xd8, 0xb6, 0xfe, 0xf2, 0xfe, 0x85, 0xb5,
-  0xb3, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0xfe, 0x56, 0x03, 0xf9,
-  0x04, 0x7b, 0x00, 0x20, 0x00, 0x00, 0x01, 0x06, 0x23, 0x22, 0x01, 0x00,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x16,
-  0x33, 0x32, 0x37, 0x03, 0xec, 0xc4, 0xd2, 0xf7, 0xfe, 0xfb, 0x02, 0x08,
-  0x96, 0x53, 0x53, 0x4b, 0x7d, 0x8a, 0x48, 0x1b, 0x12, 0xb7, 0x21, 0x41,
-  0x7e, 0xd6, 0xd1, 0xf8, 0x7c, 0x9e, 0xfe, 0x5e, 0x82, 0x98, 0xe4, 0xb1,
-  0xfe, 0xef, 0x99, 0x01, 0x79, 0x01, 0x59, 0xc2, 0x6b, 0x7d, 0x6f, 0x53,
-  0x4b, 0x75, 0x2c, 0x32, 0x81, 0x52, 0x9c, 0xe8, 0xc2, 0xa4, 0x9c, 0xc5,
-  0xfe, 0xe0, 0xba, 0x90, 0x00, 0x02, 0x00, 0x67, 0x00, 0x00, 0x05, 0x24,
-  0x05, 0xef, 0x00, 0x02, 0x00, 0x35, 0x00, 0x00, 0x25, 0x21, 0x09, 0x03,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x1b, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x09, 0x01,
-  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x21, 0x35, 0x33, 0x32, 0x37, 0x36,
-  0x01, 0xab, 0x02, 0x2f, 0xfe, 0xec, 0xfe, 0x45, 0x01, 0x5a, 0xfe, 0xf9,
-  0x11, 0x17, 0x1f, 0x39, 0x16, 0x14, 0x3e, 0x1e, 0x1c, 0x1c, 0x1a, 0x66,
-  0x44, 0x27, 0x2b, 0xe8, 0xee, 0x2f, 0x23, 0x44, 0x66, 0x1a, 0x1b, 0x1d,
-  0x1e, 0x3d, 0x15, 0x16, 0x36, 0x22, 0x11, 0x17, 0xfe, 0xf0, 0x01, 0x4f,
-  0x05, 0x06, 0x1a, 0x3e, 0x40, 0xfb, 0x4a, 0x3f, 0x41, 0x18, 0x0a, 0xaa,
-  0x01, 0xca, 0xfe, 0x68, 0x02, 0x3d, 0x01, 0xbb, 0x1d, 0x1a, 0x22, 0x04,
-  0x0a, 0xbb, 0x0b, 0x05, 0x05, 0x43, 0x28, 0x46, 0xfe, 0x81, 0x01, 0x7f,
-  0x4b, 0x23, 0x43, 0x05, 0x05, 0x0b, 0xbb, 0x0a, 0x04, 0x22, 0x11, 0x26,
-  0xfe, 0x45, 0xfd, 0xc3, 0x09, 0x08, 0x21, 0xaa, 0xaa, 0x21, 0x0f, 0x00,
-  0x00, 0x02, 0x00, 0x30, 0x00, 0x00, 0x04, 0x51, 0x04, 0x7b, 0x00, 0x02,
-  0x00, 0x35, 0x00, 0x00, 0x25, 0x21, 0x03, 0x09, 0x01, 0x03, 0x26, 0x27,
-  0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x1b, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x15, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x01, 0x16, 0x17,
-  0x16, 0x3b, 0x01, 0x15, 0x21, 0x35, 0x33, 0x32, 0x37, 0x36, 0x01, 0x71,
-  0x01, 0x9e, 0xcd, 0xfe, 0x85, 0x01, 0x1a, 0xd7, 0x13, 0x10, 0x1a, 0x30,
-  0x13, 0x11, 0x35, 0x1a, 0x18, 0x17, 0x16, 0x76, 0x39, 0x22, 0x24, 0xb1,
-  0xb1, 0x24, 0x22, 0x39, 0x76, 0x16, 0x17, 0x18, 0x1a, 0x35, 0x11, 0x13,
-  0x30, 0x1a, 0x10, 0x13, 0xdd, 0x01, 0x0f, 0x05, 0x05, 0x16, 0x35, 0x41,
-  0xfb, 0xe1, 0x41, 0x34, 0x17, 0x05, 0x9e, 0x01, 0x38, 0xfe, 0xee, 0x01,
-  0xa4, 0x01, 0x3d, 0x1c, 0x0e, 0x19, 0x03, 0x07, 0x8d, 0x08, 0x04, 0x04,
-  0x33, 0x1e, 0x35, 0xfe, 0xfa, 0x01, 0x06, 0x35, 0x1e, 0x33, 0x04, 0x04,
-  0x08, 0x8d, 0x07, 0x03, 0x19, 0x0e, 0x1c, 0xfe, 0xb8, 0xfe, 0x67, 0x08,
-  0x05, 0x19, 0x9e, 0x9e, 0x19, 0x05, 0x00, 0x00, 0x00, 0x02, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa2, 0x06, 0x10, 0x00, 0x1d, 0x00, 0x2b, 0x00, 0x00,
-  0x01, 0x24, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x00, 0x10,
-  0x00, 0x23, 0x20, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x21, 0x32, 0x37,
-  0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x12, 0x10, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x02, 0xd9, 0xfe, 0xf4,
-  0x4f, 0x32, 0x14, 0x49, 0x4d, 0x6e, 0x75, 0xdd, 0x01, 0x13, 0xfe, 0xed,
-  0xed, 0xfe, 0xed, 0x94, 0x92, 0x7d, 0x6f, 0x01, 0x85, 0x67, 0x87, 0x90,
-  0x43, 0x54, 0x88, 0x62, 0x80, 0xb4, 0xa7, 0xa9, 0x5e, 0x5e, 0x5e, 0x5b,
-  0xac, 0xa9, 0x58, 0x05, 0x2d, 0x02, 0x73, 0x4a, 0xa0, 0x56, 0x22, 0x31,
-  0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x9c, 0x9b, 0x01, 0x50, 0x01, 0xde,
-  0xd2, 0xbb, 0x0a, 0x0a, 0x27, 0xb1, 0x24, 0x08, 0x06, 0xfc, 0x41, 0x01,
-  0x82, 0xe6, 0x73, 0x74, 0xc0, 0xbd, 0x78, 0x73, 0x73, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xec, 0x06, 0x10, 0x00, 0x1f,
-  0x00, 0x2f, 0x00, 0x00, 0x01, 0x26, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11,
-  0x10, 0x37, 0x36, 0x21, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06,
-  0x13, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x02, 0x58, 0xcc, 0x42, 0x27, 0x12, 0x25, 0x5a,
-  0x52, 0x6c, 0xb8, 0x72, 0x74, 0x74, 0x72, 0xc5, 0xe6, 0x7b, 0x7a, 0x68,
-  0x5d, 0x01, 0x2d, 0x56, 0x53, 0x4a, 0x40, 0x53, 0x3f, 0x51, 0x98, 0x4b,
-  0x4c, 0x83, 0x86, 0x4e, 0x4f, 0x4f, 0x4c, 0x88, 0x85, 0x4a, 0x4b, 0x05,
-  0x37, 0x02, 0x78, 0x4a, 0xa9, 0x46, 0x36, 0x31, 0xa2, 0xa2, 0xfd, 0xf0,
-  0xa2, 0xa2, 0x9c, 0x9b, 0x01, 0x50, 0x01, 0xde, 0xd2, 0xbb, 0x0a, 0x0a,
-  0x27, 0xa7, 0x27, 0x05, 0x06, 0xfc, 0xf8, 0xcd, 0x72, 0x73, 0x73, 0x74,
-  0xcb, 0xc7, 0x78, 0x73, 0x73, 0x74, 0x00, 0x00, 0x00, 0x01, 0x00, 0x27,
-  0xfe, 0x56, 0x04, 0x3f, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x35, 0x23, 0x11, 0x23, 0x11, 0x23, 0x15, 0x23, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x04, 0x3e, 0xb6, 0xfa, 0xb6, 0xfa, 0xb6, 0x01, 0xb0, 0xb6,
-  0x04, 0x60, 0xfe, 0xf2, 0x64, 0xfa, 0xa0, 0x05, 0x60, 0x64, 0x01, 0x0e,
-  0x01, 0x75, 0xfe, 0x8b, 0x00, 0x01, 0x00, 0x31, 0xfe, 0x55, 0x03, 0xac,
-  0x05, 0xcf, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x23, 0x35, 0x23, 0x11,
-  0x23, 0x11, 0x23, 0x15, 0x23, 0x11, 0x21, 0x11, 0x33, 0x11, 0x03, 0xac,
-  0x9c, 0xce, 0xa7, 0xce, 0x9b, 0x01, 0x69, 0xa7, 0x04, 0x5f, 0xff, 0x00,
-  0x70, 0xfa, 0x86, 0x05, 0x7a, 0x70, 0x01, 0x00, 0x01, 0x70, 0xfe, 0x90,
-  0x00, 0x01, 0x00, 0x64, 0xff, 0xf2, 0x04, 0x53, 0x04, 0x67, 0x00, 0x33,
-  0x00, 0x00, 0x01, 0x02, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x01, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32, 0x17,
-  0x04, 0x11, 0x14, 0x07, 0x37, 0x12, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14,
-  0x01, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x15, 0x06, 0x23,
-  0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x01, 0xf1, 0x57, 0xb4, 0x31, 0x1f,
-  0x31, 0x01, 0x07, 0x37, 0x0c, 0x18, 0x7f, 0x34, 0x52, 0x3a, 0x52, 0x17,
-  0x19, 0x01, 0x00, 0x1a, 0xaa, 0x56, 0xb4, 0x32, 0x1f, 0x31, 0xfe, 0xf9,
-  0x37, 0x0c, 0x18, 0x7f, 0x34, 0x51, 0x39, 0x52, 0x17, 0x19, 0xff, 0x00,
-  0x1a, 0x01, 0x99, 0xfe, 0xf7, 0x7c, 0x22, 0x4f, 0x9a, 0x01, 0x09, 0x8a,
-  0x7a, 0x3a, 0x36, 0x68, 0x6c, 0xe0, 0x30, 0x04, 0x25, 0xfe, 0xc1, 0x5b,
-  0x4d, 0x6c, 0x01, 0x09, 0x7c, 0x22, 0x4f, 0x9a, 0xfe, 0xf7, 0x8a, 0x7a,
-  0x3a, 0x36, 0x68, 0x6c, 0xe0, 0x30, 0x04, 0x25, 0x01, 0x3f, 0x5b, 0x4d,
-  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x00, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x12, 0x29,
-  0x01, 0x15, 0x21, 0x20, 0x11, 0x24, 0x10, 0x27, 0x26, 0x20, 0x07, 0x06,
-  0x10, 0x17, 0x16, 0x20, 0x37, 0xa7, 0x51, 0x31, 0x8e, 0x35, 0xa4, 0xb8,
-  0x72, 0x73, 0x73, 0x72, 0xb8, 0x6c, 0x52, 0x50, 0x34, 0x04, 0x01, 0x04,
-  0x01, 0xc2, 0xfe, 0x4c, 0xfe, 0x43, 0x02, 0xda, 0x4a, 0x4c, 0xfe, 0xf9,
-  0x4b, 0x4b, 0x4b, 0x4b, 0x01, 0x07, 0x4c, 0x02, 0x25, 0xd0, 0xa3, 0x62,
-  0x5e, 0x23, 0xa2, 0xa2, 0xfd, 0xf0, 0xa2, 0xa2, 0x31, 0x30, 0x64, 0xfe,
-  0x58, 0xaa, 0x02, 0xda, 0x34, 0x01, 0x96, 0x74, 0x73, 0x73, 0x74, 0xfe,
-  0x6a, 0x74, 0x73, 0x73, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
-  0x04, 0x7b, 0x12, 0x06, 0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde,
-  0xfe, 0x56, 0x01, 0x54, 0x06, 0x14, 0x12, 0x06, 0x00, 0x4d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06,
-  0x01, 0x61, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x76,
-  0x04, 0x7b, 0x00, 0x21, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x3f,
-  0x01, 0x15, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x03, 0x76, 0x22, 0x21, 0x59, 0x60, 0xa4, 0x5c,
-  0x56, 0x10, 0x02, 0x62, 0xfd, 0x9e, 0x10, 0x56, 0x5c, 0xa4, 0x74, 0x45,
-  0x43, 0x48, 0x5d, 0x60, 0xf2, 0x8c, 0x8d, 0x8d, 0x8c, 0xf2, 0x5b, 0x62,
-  0x24, 0x24, 0x03, 0xae, 0x0d, 0x0a, 0x1a, 0x63, 0x5c, 0xa9, 0x90, 0xa9,
-  0x5c, 0x63, 0x1a, 0x19, 0xa7, 0x12, 0x16, 0x9c, 0x9c, 0x02, 0x28, 0x9c,
-  0x9c, 0x16, 0x08, 0x0c, 0x00, 0x01, 0x00, 0xb0, 0xff, 0xe3, 0x03, 0xc1,
-  0x04, 0x7b, 0x00, 0x21, 0x00, 0x00, 0x13, 0x35, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x26, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0xb0, 0x24, 0x24, 0x62, 0x5b, 0xf2, 0x8c, 0x8d,
-  0x8d, 0x8c, 0xf2, 0x60, 0x5d, 0x48, 0x43, 0x45, 0x74, 0xa4, 0x5c, 0x56,
-  0x10, 0xfd, 0x9e, 0x02, 0x62, 0x10, 0x56, 0x5c, 0xa4, 0x60, 0x59, 0x21,
-  0x03, 0xae, 0xa3, 0x0c, 0x08, 0x16, 0x9c, 0x9c, 0xfd, 0xd8, 0x9c, 0x9c,
-  0x16, 0x12, 0xa7, 0x19, 0x1a, 0x63, 0x5c, 0xa9, 0x90, 0xa9, 0x5c, 0x63,
-  0x1a, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0xa0, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x12, 0x06, 0x00, 0xc0, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x06,
-  0x00, 0x26, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83,
-  0x05, 0xd5, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x21, 0x09, 0x01, 0x21, 0x11,
-  0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5, 0x01, 0x0f, 0x01, 0x57,
-  0x01, 0x58, 0x01, 0x0f, 0xb1, 0xfe, 0xa5, 0xb6, 0xfe, 0xa5, 0xb0, 0x05,
-  0xd5, 0xfe, 0x21, 0x01, 0xdf, 0xfa, 0x2b, 0x05, 0x1f, 0xfe, 0x19, 0x01,
-  0xe7, 0xfa, 0xe1, 0x00, 0x00, 0x01, 0x00, 0x72, 0xfe, 0x56, 0x04, 0x3b,
-  0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x11,
-  0x23, 0x11, 0x03, 0x23, 0x03, 0x11, 0x23, 0x72, 0x00, 0xff, 0xe5, 0xe6,
-  0x00, 0xff, 0xa7, 0xf8, 0x8a, 0xf9, 0xa7, 0x04, 0x60, 0xfe, 0x7b, 0x01,
-  0x85, 0xfb, 0xa0, 0x03, 0xb2, 0xfe, 0x60, 0x01, 0xa0, 0xfa, 0xa4, 0x00,
-  0x00, 0x02, 0x00, 0x4c, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x1b,
-  0x00, 0x27, 0x00, 0x00, 0x17, 0x11, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x11,
-  0x21, 0x15, 0x21, 0x15, 0x23, 0x35, 0x23, 0x35, 0x00, 0x10, 0x27, 0x26,
-  0x20, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0xa7, 0x51, 0x37, 0x88,
-  0x35, 0xa4, 0xb8, 0x72, 0x73, 0x73, 0x72, 0xb8, 0x6f, 0x4f, 0x50, 0x34,
-  0x01, 0xb4, 0xfe, 0x4c, 0xa7, 0x5b, 0x03, 0x35, 0x4a, 0x4c, 0xfe, 0xf9,
-  0x4b, 0x4b, 0x4b, 0x4b, 0x01, 0x07, 0x4c, 0x90, 0x02, 0xb5, 0xe7, 0x8c,
-  0x66, 0x5a, 0x23, 0xa2, 0xa2, 0xfd, 0xf0, 0xa2, 0xa2, 0x31, 0x30, 0x64,
-  0xfe, 0xc8, 0xaa, 0x70, 0x70, 0xaa, 0x01, 0xf4, 0x01, 0x96, 0x74, 0x73,
-  0x73, 0x74, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x06, 0x01, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x26,
-  0x03, 0x8d, 0x00, 0x00, 0x10, 0x07, 0x00, 0x79, 0x01, 0xfb, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x10, 0x27,
-  0x00, 0x79, 0x00, 0xcd, 0x00, 0x00, 0x12, 0x06, 0x03, 0x91, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x6b, 0x12, 0x26,
-  0x03, 0xa9, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee, 0x04, 0x70, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x4e, 0x12, 0x26,
-  0x03, 0xa9, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x27, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0xfe, 0x66, 0x05, 0x1b,
-  0x05, 0xd5, 0x00, 0x1b, 0x00, 0x00, 0x25, 0x10, 0x06, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11,
-  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x21, 0x32, 0x16, 0x15, 0x05, 0x1b,
-  0xb8, 0xcd, 0x44, 0x37, 0x79, 0x64, 0x70, 0x6f, 0xfe, 0xad, 0xb6, 0xfe,
-  0x7d, 0x04, 0x16, 0xfe, 0x23, 0x01, 0x78, 0xa7, 0xc8, 0x68, 0xfe, 0xf2,
-  0xf4, 0xaa, 0x96, 0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x05, 0x2b,
-  0xaa, 0xaa, 0xfe, 0x46, 0xe9, 0xee, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0xf9, 0x07, 0x6b, 0x12, 0x26, 0x03, 0xa7, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xec, 0x04, 0x36, 0x01, 0x75, 0x00, 0x01, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x18, 0x00, 0x00, 0x01, 0x15,
-  0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x17, 0x15, 0x26,
-  0x23, 0x22, 0x02, 0x07, 0x21, 0x15, 0x21, 0x16, 0x12, 0x33, 0x32, 0x04,
-  0xa3, 0xbf, 0xf0, 0xfe, 0xd2, 0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x2e, 0xf4,
-  0xbb, 0xbe, 0xe6, 0xee, 0xd6, 0x14, 0x02, 0xce, 0xfd, 0x32, 0x14, 0xd6,
-  0xee, 0xe6, 0x01, 0x46, 0xd3, 0x90, 0x01, 0x9f, 0x01, 0x68, 0x01, 0x67,
-  0x01, 0x9f, 0x8e, 0xd5, 0xbd, 0xfe, 0xe3, 0xef, 0xaa, 0xef, 0xfe, 0xe4,
-  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x05, 0xf0, 0x12, 0x06,
-  0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6b,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0x00, 0x00, 0x02, 0x1c, 0x07, 0x4e, 0x10, 0x06, 0x00, 0x91, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xa0, 0xfe, 0x66, 0x01, 0x6b, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x2d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4b, 0x00, 0x00, 0x07, 0x5e,
-  0x05, 0xd5, 0x00, 0x14, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x21, 0x15, 0x10,
-  0x02, 0x05, 0x35, 0x36, 0x12, 0x11, 0x35, 0x21, 0x11, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x21, 0x25, 0x20, 0x11, 0x34, 0x26, 0x2b, 0x01,
-  0x11, 0x03, 0xfe, 0xfe, 0x4c, 0xb4, 0xfe, 0xb6, 0xc3, 0x86, 0x03, 0x1f,
-  0xd3, 0xe2, 0xf5, 0xf5, 0xe2, 0xfe, 0x77, 0x01, 0x80, 0x01, 0x20, 0x8e,
-  0x92, 0xca, 0x05, 0x2b, 0xb8, 0xfd, 0xca, 0xfd, 0xfb, 0x38, 0xaa, 0x2f,
-  0x01, 0xa6, 0x02, 0x58, 0xfe, 0xfd, 0x9a, 0xda, 0xdd, 0xde, 0xda, 0xa6,
-  0x01, 0x11, 0x8b, 0x87, 0xfd, 0xdd, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x07, 0x05, 0x05, 0xd5, 0x00, 0x12, 0x00, 0x1b, 0x00, 0x00,
-  0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11,
-  0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x01, 0x34, 0x26, 0x2b, 0x01,
-  0x11, 0x33, 0x32, 0x36, 0x03, 0xa5, 0xfd, 0xc6, 0xb6, 0xb6, 0x02, 0x3a,
-  0xb6, 0xd3, 0xe2, 0xf4, 0xf4, 0xe2, 0x01, 0x17, 0x8e, 0x92, 0xca, 0xca,
-  0x90, 0x90, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64,
-  0xfd, 0x9a, 0xda, 0xde, 0xdd, 0xda, 0x01, 0xb7, 0x8b, 0x87, 0xfd, 0xdd,
-  0x87, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0x00, 0x00, 0x05, 0x1b,
-  0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x11, 0x23,
-  0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x15,
-  0x21, 0x11, 0x03, 0xac, 0xa7, 0xc8, 0xb5, 0x70, 0x6f, 0xfe, 0xad, 0xb6,
-  0xfe, 0x7d, 0x04, 0x16, 0xfe, 0x23, 0x03, 0x71, 0xe9, 0xee, 0xfe, 0x66,
-  0x01, 0x8a, 0x9f, 0x9e, 0xfd, 0x39, 0x05, 0x2b, 0xaa, 0xaa, 0xfe, 0x46,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xf9, 0x07, 0x6b, 0x12, 0x26,
-  0x03, 0xae, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec, 0x04, 0x70, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x6b, 0x12, 0x26,
-  0x03, 0xac, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee, 0x04, 0x68, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xf2, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x23, 0x02, 0x68, 0xfe, 0x4d, 0xb6, 0x02, 0x94, 0xb6, 0xfe, 0x4d,
-  0x9a, 0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0x2b, 0xfe, 0xbf, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x24, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e,
-  0x05, 0xd5, 0x00, 0x08, 0x00, 0x15, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23,
-  0x21, 0x11, 0x21, 0x32, 0x36, 0x13, 0x15, 0x21, 0x11, 0x21, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x03, 0xae, 0x8d, 0x93, 0xfe, 0xdd,
-  0x01, 0x23, 0x93, 0x8d, 0x62, 0xfd, 0x5b, 0x01, 0x2c, 0xe2, 0xf5, 0xed,
-  0xea, 0xfe, 0x1e, 0x01, 0xb7, 0x8b, 0x87, 0xfd, 0xdd, 0x87, 0x04, 0xa8,
-  0xa6, 0xfe, 0x40, 0xda, 0xde, 0xdd, 0xda, 0x05, 0xd5, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x25, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9,
-  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0xb5, 0x03, 0x44, 0xfd, 0x72, 0x05, 0xd5, 0xaa, 0xfa, 0xd5, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x5a, 0xfe, 0xbf, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x07,
-  0x00, 0x17, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06,
-  0x05, 0x36, 0x37, 0x12, 0x19, 0x01, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11,
-  0x21, 0x11, 0x23, 0x11, 0x01, 0xa4, 0x02, 0x52, 0xfe, 0x4c, 0x65, 0x15,
-  0xfe, 0xd3, 0x78, 0x23, 0x57, 0x03, 0x1f, 0x99, 0x99, 0xfc, 0x48, 0x99,
-  0xaa, 0x04, 0x81, 0xd4, 0xfe, 0x0d, 0xfe, 0xb5, 0x44, 0x2b, 0x3f, 0x78,
-  0x01, 0x34, 0x02, 0x26, 0x01, 0x1a, 0xfa, 0xd5, 0xfe, 0x15, 0x01, 0x41,
-  0xfe, 0xbf, 0x01, 0xeb, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00, 0x00, 0x01, 0x00, 0x24,
-  0x00, 0x00, 0x07, 0x9e, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x03, 0x11, 0x23, 0x11, 0x03,
-  0x01, 0x23, 0x09, 0x01, 0x33, 0x01, 0x03, 0x86, 0xb6, 0x02, 0x65, 0xdd,
-  0xfe, 0x15, 0x02, 0x0a, 0xbd, 0xfe, 0x44, 0xe8, 0xb6, 0xe8, 0xfe, 0x44,
-  0xbe, 0x02, 0x0a, 0xfe, 0x16, 0xdc, 0x02, 0x66, 0x05, 0xd5, 0xfd, 0x1e,
-  0x02, 0xe2, 0xfd, 0xb3, 0xfc, 0x78, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16,
-  0x01, 0xea, 0x01, 0x17, 0xfc, 0xff, 0x03, 0x88, 0x02, 0x4d, 0xfd, 0x1e,
-  0x00, 0x01, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x25, 0x05, 0xf0, 0x00, 0x28,
-  0x00, 0x00, 0x01, 0x32, 0x04, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15,
-  0x14, 0x04, 0x23, 0x22, 0x24, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x02, 0x0e, 0xde, 0x01, 0x19,
-  0x80, 0x76, 0x83, 0x92, 0xfe, 0xc1, 0xd7, 0x6d, 0xff, 0x00, 0x27, 0x89,
-  0x98, 0x70, 0xa9, 0xbb, 0xa6, 0xb0, 0xb7, 0xbe, 0xa2, 0x8e, 0x93, 0xb2,
-  0x79, 0x52, 0xb9, 0x66, 0xd4, 0x05, 0xf0, 0xd1, 0xb2, 0x7c, 0xab, 0x21,
-  0x1f, 0xc4, 0x90, 0xe6, 0xe9, 0x42, 0x1c, 0xd0, 0x59, 0x2b, 0x90, 0x95,
-  0x84, 0x95, 0xa6, 0x77, 0x70, 0x73, 0x7b, 0x18, 0x4d, 0xc5, 0x28, 0x22,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x01, 0x23, 0x11, 0x33, 0x11, 0x01,
-  0x04, 0xae, 0xb0, 0xfd, 0xac, 0xf5, 0xb0, 0x02, 0x54, 0x05, 0xd5, 0xfa,
-  0x2b, 0x04, 0xe1, 0xfb, 0x1f, 0x05, 0xd5, 0xfb, 0x1f, 0x04, 0xe1, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x6d, 0x12, 0x26,
-  0x03, 0xac, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf2, 0x04, 0x76, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xf9,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09,
-  0x01, 0x23, 0x01, 0x03, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x89, 0xea, 0xfd,
-  0xf8, 0x02, 0x23, 0xc6, 0xfe, 0x2d, 0xf5, 0xb6, 0x05, 0xd5, 0xfd, 0x1e,
-  0x02, 0xe2, 0xfd, 0xb2, 0xfc, 0x79, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16,
-  0x00, 0x01, 0x00, 0x4b, 0x00, 0x00, 0x04, 0xb5, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x12, 0x11, 0x35, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x4c, 0xc3, 0x38, 0x4e, 0x03, 0x1f,
-  0xb6, 0xfe, 0x4c, 0x5c, 0x58, 0xaa, 0x2f, 0xa4, 0x01, 0x02, 0x02, 0x58,
-  0xfe, 0xfa, 0x2b, 0x05, 0x2b, 0xb8, 0xfd, 0xca, 0xfe, 0xf8, 0xfd, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x04, 0xb5,
-  0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfa, 0x2b, 0x05, 0x2b, 0xfa, 0xd5,
-  0x05, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x06, 0x00, 0x26, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x37, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44,
-  0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x3f, 0x01, 0x01, 0x33, 0x09, 0x01, 0x33,
-  0x02, 0x4e, 0x13, 0x1d, 0x47, 0xe2, 0x45, 0x38, 0x6b, 0x2a, 0x19, 0x10,
-  0x29, 0xfe, 0x51, 0xc3, 0x01, 0x4e, 0x01, 0x4f, 0xc4, 0xb5, 0x32, 0x26,
-  0x5d, 0xaa, 0x1b, 0x11, 0x2a, 0x6a, 0x04, 0x6b, 0xfc, 0x94, 0x03, 0x6c,
-  0x00, 0x03, 0x00, 0x6c, 0x00, 0x00, 0x05, 0xc6, 0x05, 0xd5, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16,
-  0x17, 0x33, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x03, 0x24, 0x00, 0x11,
-  0x10, 0x00, 0x25, 0x35, 0x33, 0x15, 0x04, 0x00, 0x11, 0x10, 0x00, 0x05,
-  0x15, 0x23, 0x02, 0xbf, 0xc3, 0xcf, 0xcf, 0xc3, 0xb7, 0xc3, 0xcd, 0xcd,
-  0xc3, 0xb7, 0xfe, 0xe3, 0xfe, 0xcb, 0x01, 0x35, 0x01, 0x1d, 0xb7, 0x01,
-  0x1d, 0x01, 0x33, 0xfe, 0xcd, 0xfe, 0xe3, 0xb7, 0x04, 0xa2, 0x14, 0xcc,
-  0xc5, 0xc5, 0xcb, 0x14, 0x14, 0xcb, 0xc5, 0xc5, 0xcc, 0x14, 0xfc, 0x10,
-  0x17, 0x01, 0x2b, 0x01, 0x09, 0x01, 0x09, 0x01, 0x2d, 0x17, 0x8b, 0x8b,
-  0x17, 0xfe, 0xd5, 0xfe, 0xf5, 0xfe, 0xf7, 0xfe, 0xd5, 0x17, 0xb2, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x06,
-  0x00, 0x3b, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x4f,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x04, 0xb5, 0xfc, 0x00, 0xb6, 0x02,
-  0x94, 0xb6, 0x99, 0x99, 0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0xd5,
-  0xfe, 0x15, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x04, 0x3b,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x21, 0x11, 0x21, 0x22, 0x26, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x21, 0x11, 0x33, 0x11, 0x03, 0x84,
-  0xfe, 0x89, 0xa8, 0xc7, 0xb4, 0x70, 0x70, 0x01, 0x52, 0xb7, 0x02, 0x64,
-  0xe9, 0xee, 0x01, 0x9a, 0xfe, 0x76, 0x9f, 0x9e, 0x02, 0xc7, 0xfa, 0x2b,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x06, 0xff, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x25, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x04, 0x34, 0x02, 0x14, 0xb6, 0xf9, 0xb7, 0xb6, 0x02, 0x14,
-  0xb5, 0xaa, 0x05, 0x2b, 0xfa, 0x2b, 0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x07, 0x98, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x06, 0xfe, 0xf9, 0xb7, 0xb6, 0x02,
-  0x14, 0xb5, 0x02, 0x14, 0xb6, 0x99, 0x99, 0x05, 0xd5, 0xfa, 0xd5, 0x05,
-  0x2b, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0xd5, 0xfe, 0x15, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x05, 0x7c, 0x05, 0xd5, 0x00, 0x0c,
-  0x00, 0x17, 0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x01, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11,
-  0x21, 0x32, 0x37, 0x36, 0x01, 0xc3, 0xfe, 0x73, 0x02, 0x43, 0x01, 0x2c,
-  0xe2, 0xf5, 0xf5, 0xe2, 0x01, 0x17, 0x47, 0x46, 0x93, 0xfe, 0xdd, 0x01,
-  0x23, 0x91, 0x48, 0x47, 0x05, 0x2b, 0xaa, 0xfd, 0x9a, 0xda, 0xde, 0xdd,
-  0xda, 0x01, 0xb7, 0x8b, 0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0xa6, 0x05, 0xd5, 0x10, 0x26,
-  0x03, 0xc0, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x04, 0x3b, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x0a,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11, 0x21,
-  0x32, 0x37, 0x36, 0x01, 0x33, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x21, 0x03, 0xae, 0x47, 0x46, 0x93, 0xfe, 0xdd, 0x01, 0x23, 0x93,
-  0x46, 0x47, 0xfd, 0x07, 0xb6, 0x01, 0x2c, 0xe2, 0xf5, 0xf5, 0xe2, 0xfe,
-  0x1e, 0x01, 0xb7, 0x8b, 0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x04, 0xa8,
-  0xfd, 0x9a, 0xda, 0xde, 0xdd, 0xda, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe3, 0x04, 0xa0, 0x05, 0xf0, 0x00, 0x18, 0x00, 0x00, 0x13, 0x16,
-  0x33, 0x32, 0x12, 0x37, 0x21, 0x35, 0x21, 0x26, 0x02, 0x23, 0x22, 0x07,
-  0x35, 0x36, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x22, 0x27, 0x64,
-  0xbe, 0xe6, 0xee, 0xd6, 0x14, 0xfd, 0x32, 0x02, 0xce, 0x14, 0xd6, 0xee,
-  0xe6, 0xbe, 0xbb, 0xf4, 0x01, 0x2d, 0x01, 0x60, 0xfe, 0xa0, 0xfe, 0xd3,
-  0xf0, 0xbf, 0x01, 0x46, 0xbd, 0x01, 0x1c, 0xef, 0xaa, 0xef, 0x01, 0x1d,
-  0xbd, 0xd5, 0x8e, 0xfe, 0x61, 0xfe, 0x99, 0xfe, 0x98, 0xfe, 0x61, 0x90,
-  0x00, 0x02, 0x00, 0xbd, 0xff, 0xe3, 0x07, 0x5f, 0x05, 0xf0, 0x00, 0x0f,
-  0x00, 0x26, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x11, 0x10, 0x27, 0x26, 0x01, 0x12, 0x37, 0x36,
-  0x21, 0x20, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26,
-  0x03, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x04, 0xf1, 0xc6, 0x74, 0x75,
-  0x75, 0x74, 0xc6, 0xc6, 0x74, 0x74, 0x74, 0x74, 0xfc, 0xce, 0x0d, 0xa2,
-  0xa2, 0x01, 0x1b, 0x01, 0x1b, 0xa9, 0xa9, 0xa9, 0xa9, 0xfe, 0xe5, 0xfe,
-  0xe5, 0xa2, 0xa2, 0x0d, 0xfe, 0xef, 0xb6, 0xb6, 0x05, 0x4c, 0xa4, 0xa4,
-  0xfe, 0xe5, 0xfe, 0xe6, 0xa4, 0xa4, 0xa4, 0xa4, 0x01, 0x1a, 0x01, 0x1b,
-  0xa4, 0xa4, 0xfd, 0xf3, 0x01, 0x18, 0xcd, 0xcc, 0xd2, 0xd3, 0xfe, 0x9e,
-  0xfe, 0x9f, 0xd2, 0xd3, 0xcd, 0xcd, 0x01, 0x18, 0xfd, 0x6b, 0x05, 0xd5,
-  0xfd, 0x6a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x7a, 0x00, 0x00, 0x04, 0x4c,
-  0x05, 0xd5, 0x00, 0x08, 0x00, 0x16, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
-  0x21, 0x11, 0x21, 0x22, 0x06, 0x03, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36,
-  0x33, 0x21, 0x11, 0x23, 0x11, 0x23, 0x01, 0x01, 0x72, 0x86, 0x83, 0x01,
-  0x1b, 0xfe, 0xe5, 0x83, 0x86, 0xf8, 0x01, 0x70, 0x5a, 0xe7, 0xea, 0xe8,
-  0x01, 0xd1, 0xb6, 0xf3, 0xfe, 0x9d, 0x04, 0x27, 0x83, 0x87, 0x02, 0x12,
-  0x85, 0xfb, 0x56, 0x02, 0x8d, 0x1a, 0xa9, 0xd7, 0xce, 0xe0, 0xfa, 0x2b,
-  0x02, 0x77, 0xfd, 0x89, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x04, 0x7b, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64,
-  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x37, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x00,
-  0x01, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x03, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x24, 0x37, 0x36, 0x37, 0x17, 0x06, 0x0f, 0x01,
-  0x06, 0x07, 0x06, 0x0f, 0x01, 0x36, 0x17, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x02, 0x3d, 0xd8, 0xf7, 0xf7, 0xd8,
-  0xd9, 0xef, 0x06, 0x06, 0x04, 0x34, 0x52, 0x01, 0x1b, 0xee, 0x6e, 0x30,
-  0x2e, 0x2c, 0x28, 0xe1, 0x72, 0x44, 0xb3, 0x11, 0x07, 0x75, 0xbe, 0x85,
-  0x9b, 0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x04, 0x7b, 0xfe, 0xc8, 0xfe, 0xec,
-  0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x30, 0x01, 0x1c, 0xe5, 0x77, 0x29, 0xa0,
-  0x76, 0xb9, 0xa0, 0x02, 0x01, 0x11, 0x92, 0x14, 0x01, 0x11, 0x09, 0x2c,
-  0x75, 0x99, 0x38, 0x77, 0x9c, 0xe7, 0xc9, 0xc9, 0xe7, 0xe8, 0xc8, 0xc7,
-  0xe9, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xd2,
-  0x04, 0x60, 0x00, 0x08, 0x00, 0x11, 0x00, 0x20, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x11, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21, 0x01, 0x4d, 0xec, 0x71, 0x77,
-  0x77, 0x71, 0xec, 0xda, 0x5d, 0x77, 0x77, 0x5d, 0xfe, 0x80, 0x01, 0x8b,
-  0xb1, 0xbf, 0x62, 0x5f, 0x72, 0x7e, 0xcf, 0xc1, 0xfe, 0x66, 0x02, 0x04,
-  0xfe, 0x8f, 0x5f, 0x5a, 0x5a, 0x5e, 0x01, 0xc9, 0xfe, 0xca, 0x53, 0x4a,
-  0x4a, 0x4f, 0x93, 0x90, 0x85, 0x67, 0x79, 0x0f, 0x18, 0x98, 0x72, 0x96,
-  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x6f,
-  0x04, 0x60, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0xa7, 0x02, 0xc7, 0xfd, 0xe0, 0x04, 0x60, 0x93, 0xfc, 0x33, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x60, 0xfe, 0xe5, 0x04, 0x9b, 0x04, 0x60, 0x00, 0x06,
-  0x00, 0x16, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x15, 0x10, 0x07, 0x05,
-  0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21,
-  0x11, 0x23, 0x11, 0x01, 0x8f, 0x01, 0xe0, 0xfe, 0xa4, 0x6a, 0xfe, 0xf5,
-  0x52, 0x24, 0x58, 0x02, 0xaa, 0x84, 0x84, 0xfc, 0xcf, 0x85, 0x93, 0x03,
-  0x3a, 0x8c, 0xfe, 0x64, 0xdc, 0x36, 0x28, 0x55, 0xd3, 0x01, 0xa9, 0xd4,
-  0xfc, 0x33, 0xfe, 0x52, 0x01, 0x1b, 0xfe, 0xe5, 0x01, 0xae, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x06,
-  0x00, 0x48, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f, 0x00, 0x00, 0x06, 0x3e,
-  0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33, 0x11, 0x01, 0x33, 0x09,
-  0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x27, 0x01, 0x23, 0x09, 0x01,
-  0x33, 0x01, 0x02, 0xec, 0xa5, 0x01, 0xb8, 0xc0, 0xfe, 0x97, 0x01, 0x9e,
-  0xb2, 0xfe, 0xad, 0xa8, 0xa5, 0xa8, 0xfe, 0xac, 0xb1, 0x01, 0x9e, 0xfe,
-  0x96, 0xc1, 0x01, 0xb8, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e, 0xfe, 0x51,
-  0xfd, 0x4f, 0x02, 0x36, 0xc9, 0xfe, 0x93, 0x01, 0x6d, 0xc9, 0xfd, 0xca,
-  0x02, 0xb1, 0x01, 0xaf, 0xfd, 0xf2, 0x00, 0x00, 0x00, 0x01, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x04, 0x7c, 0x00, 0x28, 0x00, 0x00, 0x01, 0x1e,
-  0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x02, 0x7b, 0x70, 0x7c, 0xe8, 0xd6, 0x48, 0x98, 0x51,
-  0x40, 0x99, 0x53, 0x88, 0x98, 0x87, 0x7b, 0x85, 0x8b, 0x69, 0x79, 0x7d,
-  0x6b, 0x40, 0x91, 0x57, 0x58, 0x99, 0x45, 0xb0, 0xcc, 0x6c, 0x02, 0x5c,
-  0x18, 0x92, 0x6c, 0xad, 0xb6, 0x1c, 0x1c, 0xab, 0x25, 0x25, 0x70, 0x5a,
-  0x58, 0x6b, 0x98, 0x59, 0x46, 0x40, 0x5c, 0x1a, 0x1d, 0xa7, 0x18, 0x18,
-  0x9d, 0x8d, 0x5d, 0x81, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
-  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x01, 0x23,
-  0x11, 0x33, 0x11, 0x01, 0x04, 0x06, 0xa4, 0xfe, 0x1a, 0xd5, 0xa5, 0x01,
-  0xe5, 0x04, 0x60, 0xfb, 0xa0, 0x03, 0x83, 0xfc, 0x7d, 0x04, 0x60, 0xfc,
-  0x7f, 0x03, 0x81, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
-  0x06, 0x14, 0x12, 0x26, 0x03, 0xcc, 0x00, 0x00, 0x11, 0x07, 0x02, 0x9a,
-  0x00, 0x8a, 0xff, 0xcc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x1d, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0xa7, 0xa5,
-  0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0xb3, 0xb9, 0xfe, 0x9a, 0xb1, 0xa5,
-  0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e, 0xfe, 0x4f, 0xfd, 0x51, 0x02, 0x35,
-  0xc8, 0xfe, 0x93, 0x00, 0x00, 0x01, 0x00, 0x44, 0x00, 0x00, 0x04, 0x02,
-  0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x36, 0x11,
-  0x35, 0x21, 0x11, 0x23, 0x11, 0x21, 0x15, 0x10, 0x07, 0x06, 0x44, 0xa4,
-  0x33, 0x3d, 0x02, 0xa9, 0xa5, 0xfe, 0xa1, 0x4f, 0x54, 0x99, 0x1c, 0x7e,
-  0xb1, 0x01, 0xc5, 0xb7, 0xfb, 0xa0, 0x03, 0xcd, 0x6f, 0xfe, 0x50, 0xc2,
-  0xcf, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8,
-  0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x11,
-  0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xf3, 0x01, 0x1e, 0x01,
-  0x1f, 0xf0, 0xa6, 0xfe, 0xe9, 0xa5, 0xfe, 0xe9, 0xa7, 0x04, 0x60, 0xfd,
-  0x12, 0x02, 0xee, 0xfb, 0xa0, 0x03, 0xb0, 0xfd, 0x27, 0x02, 0xd9, 0xfc,
-  0x50, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x0e,
-  0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
-  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xa7, 0xa7, 0x02, 0x19, 0xa7, 0xa7,
-  0xfd, 0xe7, 0xa7, 0x04, 0x60, 0xfe, 0x37, 0x01, 0xc9, 0xfb, 0xa0, 0x02,
-  0x04, 0xfd, 0xfc, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x04, 0x7b, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x0e, 0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x04, 0x0e, 0xa7, 0xfd, 0xe7, 0xa7,
-  0x04, 0x60, 0xfb, 0xa0, 0x03, 0xcd, 0xfc, 0x33, 0x04, 0x60, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x12, 0x06,
-  0x00, 0x53, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
-  0x04, 0x7b, 0x12, 0x06, 0x00, 0x46, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0x00, 0x00, 0x03, 0xfc, 0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x36, 0x03, 0xc6, 0xfe, 0x6e, 0xa3,
-  0xfe, 0x6f, 0x04, 0x60, 0x93, 0xfc, 0x33, 0x03, 0xcd, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x12, 0x06,
-  0x00, 0x5c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x64, 0xfe, 0x56, 0x05, 0xc4,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x28, 0x00, 0x33, 0x00, 0x00, 0x01, 0x14,
-  0x16, 0x33, 0x32, 0x37, 0x11, 0x26, 0x23, 0x22, 0x06, 0x01, 0x11, 0x0e,
-  0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x11,
-  0x33, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
-  0x26, 0x27, 0x11, 0x01, 0x34, 0x26, 0x23, 0x22, 0x07, 0x11, 0x16, 0x33,
-  0x32, 0x36, 0x01, 0x11, 0x82, 0x6f, 0x58, 0x67, 0x67, 0x58, 0x6f, 0x82,
-  0x01, 0xb0, 0x34, 0x75, 0x4b, 0x97, 0xd1, 0xd1, 0x97, 0x4b, 0x75, 0x34,
-  0xa6, 0x33, 0x76, 0x4b, 0x96, 0xd2, 0xd2, 0x96, 0x4b, 0x76, 0x33, 0x01,
-  0xb0, 0x82, 0x6f, 0x58, 0x67, 0x67, 0x58, 0x6f, 0x82, 0x02, 0x2f, 0xeb,
-  0xc7, 0xa8, 0x02, 0x14, 0xa8, 0xc7, 0xfb, 0x3c, 0x02, 0x39, 0x5e, 0x4e,
-  0x01, 0x35, 0x01, 0x13, 0x01, 0x13, 0x01, 0x3d, 0x4c, 0x5e, 0x02, 0x04,
-  0xfd, 0xfc, 0x5e, 0x4c, 0xfe, 0xc3, 0xfe, 0xed, 0xfe, 0xed, 0xfe, 0xcb,
-  0x4e, 0x5e, 0xfd, 0xc7, 0x03, 0xd9, 0xeb, 0xc7, 0xa8, 0xfd, 0xec, 0xa8,
-  0xc7, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07,
-  0x04, 0x60, 0x12, 0x06, 0x00, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xfe, 0xe5, 0x04, 0x92, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01,
-  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x04, 0x0e,
-  0xfc, 0x99, 0xa7, 0x02, 0x19, 0xa7, 0x84, 0x84, 0x04, 0x60, 0xfc, 0x33,
-  0x03, 0xcd, 0xfc, 0x33, 0xfe, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87,
-  0x00, 0x00, 0x03, 0x9a, 0x04, 0x60, 0x00, 0x11, 0x00, 0x00, 0x21, 0x11,
-  0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33,
-  0x21, 0x11, 0x33, 0x11, 0x02, 0xf4, 0xfe, 0xcb, 0x89, 0x5c, 0x53, 0xa6,
-  0x2e, 0x30, 0x5e, 0x01, 0x0b, 0xa6, 0x01, 0xd7, 0x5f, 0x56, 0xb8, 0x01,
-  0x1c, 0xfe, 0xf5, 0x75, 0x3b, 0x3b, 0x01, 0xf6, 0xfb, 0xa0, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x05, 0xf0, 0x04, 0x60, 0x00, 0x0b,
-  0x00, 0x00, 0x25, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x03, 0x9e, 0x01, 0xab, 0xa6, 0xfa, 0xb8, 0xa7, 0x01, 0xaa,
-  0xa6, 0x93, 0x03, 0xcd, 0xfb, 0xa0, 0x04, 0x60, 0xfc, 0x33, 0x03, 0xcd,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x06, 0x74, 0x04, 0x60, 0x00, 0x0f,
-  0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x05, 0xef, 0xfa, 0xb8, 0xa7, 0x01,
-  0xaa, 0xa6, 0x01, 0xab, 0xa6, 0x85, 0x85, 0x04, 0x60, 0xfc, 0x33, 0x03,
-  0xcd, 0xfc, 0x33, 0x03, 0xcd, 0xfc, 0x33, 0xfe, 0x52, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x37, 0x00, 0x00, 0x04, 0xaa, 0x04, 0x60, 0x00, 0x0c,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21,
-  0x11, 0x21, 0x35, 0x21, 0x11, 0x17, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x03, 0x19, 0xc1, 0xcf, 0xcf, 0xc1, 0xfe, 0x65, 0xfe, 0xba,
-  0x01, 0xed, 0xed, 0xed, 0xed, 0x71, 0x76, 0x76, 0x02, 0x97, 0xa3, 0xa8,
-  0xa8, 0xa4, 0x03, 0xcd, 0x93, 0xfe, 0x37, 0x93, 0xfe, 0x8f, 0x5f, 0x5a,
-  0x5a, 0x5e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x05, 0x0c,
-  0x04, 0x7b, 0x10, 0x27, 0x00, 0xf3, 0x03, 0xb8, 0x00, 0x00, 0x10, 0x06,
-  0x03, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xd2,
-  0x04, 0x60, 0x00, 0x08, 0x00, 0x13, 0x00, 0x00, 0x01, 0x34, 0x26, 0x2b,
-  0x01, 0x11, 0x33, 0x32, 0x36, 0x01, 0x33, 0x11, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x21, 0x03, 0x21, 0x76, 0x71, 0xec, 0xec, 0x71, 0x76,
-  0xfd, 0x86, 0xa7, 0xf3, 0xc1, 0xcf, 0xcf, 0xc1, 0xfe, 0x66, 0x01, 0x4c,
-  0x5a, 0x5e, 0xfe, 0x8f, 0x5f, 0x03, 0x6e, 0xfe, 0x37, 0xa3, 0xa8, 0xa8,
-  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
-  0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x37, 0x16, 0x33, 0x32, 0x36, 0x37,
-  0x21, 0x35, 0x21, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32,
-  0x00, 0x11, 0x10, 0x00, 0x23, 0x22, 0x27, 0x66, 0x8e, 0x8d, 0x85, 0xbc,
-  0x12, 0xfe, 0x00, 0x01, 0xfa, 0x0b, 0x8f, 0xb3, 0x8a, 0x91, 0x8d, 0x95,
-  0xec, 0x01, 0x0f, 0xfe, 0xf8, 0xe7, 0xaa, 0x84, 0xd5, 0x56, 0xab, 0xda,
-  0x93, 0x69, 0xdf, 0x56, 0xac, 0x46, 0xfe, 0xc3, 0xfe, 0xf1, 0xfe, 0xf2,
-  0xfe, 0xc2, 0x48, 0x00, 0x00, 0x02, 0x00, 0xad, 0xff, 0xe3, 0x05, 0xab,
-  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x01, 0x36, 0x12, 0x33,
-  0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x27, 0x23, 0x11, 0x23,
-  0x11, 0x33, 0x11, 0x03, 0xdc, 0x85, 0x9b, 0x9a, 0x86, 0x84, 0x9b, 0x9b,
-  0xfd, 0xb3, 0x11, 0xe0, 0xd8, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xec, 0x09,
-  0xbb, 0xa5, 0xa5, 0x03, 0xdf, 0xe7, 0xc9, 0xc9, 0xe7, 0xe8, 0xc8, 0xc7,
-  0xe9, 0xfe, 0xc2, 0xbe, 0x01, 0x1c, 0xfe, 0xc8, 0xfe, 0xec, 0xfe, 0xed,
-  0xfe, 0xc7, 0x01, 0x2e, 0xf8, 0xfd, 0xf7, 0x04, 0x60, 0xfe, 0x41, 0x00,
-  0x00, 0x02, 0x00, 0x68, 0x00, 0x00, 0x03, 0xb9, 0x04, 0x60, 0x00, 0x08,
-  0x00, 0x16, 0x00, 0x00, 0x01, 0x14, 0x16, 0x3b, 0x01, 0x11, 0x23, 0x22,
-  0x06, 0x03, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x23,
-  0x11, 0x23, 0x01, 0x01, 0x54, 0x73, 0x6b, 0xe0, 0xe0, 0x6b, 0x73, 0xec,
-  0x01, 0x34, 0x68, 0x8b, 0xc2, 0xc3, 0x01, 0x8a, 0xa6, 0xce, 0xfe, 0xd7,
-  0x03, 0x1d, 0x53, 0x5e, 0x01, 0x61, 0x5c, 0xfc, 0x8f, 0x01, 0xeb, 0x1a,
-  0x89, 0x8f, 0xa2, 0xa1, 0xfb, 0xa0, 0x01, 0xd9, 0xfe, 0x27, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x6b, 0x12, 0x26,
-  0x03, 0xc9, 0x00, 0x00, 0x10, 0x06, 0x00, 0x43, 0x51, 0x05, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x10, 0x12, 0x26,
-  0x03, 0xc9, 0x00, 0x00, 0x11, 0x07, 0x00, 0x6a, 0x00, 0x87, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a, 0xfe, 0x56, 0x04, 0x1c,
-  0x06, 0x14, 0x00, 0x1f, 0x00, 0x00, 0x13, 0x23, 0x35, 0x33, 0x11, 0x33,
-  0x11, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x11, 0x14,
-  0x00, 0x07, 0x35, 0x36, 0x12, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0xc9, 0x9f, 0x9f, 0xa6, 0x01, 0xe7, 0xfe, 0x19, 0x3c, 0xa0,
-  0x6a, 0xa4, 0xc2, 0xfe, 0xcb, 0xc1, 0x6e, 0xdc, 0x6f, 0x70, 0x8a, 0x97,
-  0xa6, 0x03, 0xd1, 0x8f, 0x01, 0xb4, 0xfe, 0x4c, 0x8f, 0xfe, 0x6d, 0x65,
-  0x64, 0xe9, 0xfe, 0xea, 0xe2, 0xfe, 0x59, 0x29, 0x8c, 0x16, 0x01, 0x2e,
-  0xd2, 0xd0, 0x9f, 0xc4, 0x9e, 0xfe, 0xfb, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0x76, 0x06, 0x6d, 0x12, 0x26, 0x03, 0xc7, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x76, 0x78, 0x07, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x15, 0x26, 0x23, 0x22, 0x06, 0x07, 0x21, 0x15, 0x21, 0x1e, 0x01,
-  0x33, 0x32, 0x37, 0x15, 0x06, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x02,
-  0x60, 0x96, 0x8d, 0x91, 0x8a, 0xb4, 0x8f, 0x0a, 0x01, 0xf9, 0xfe, 0x01,
-  0x11, 0xbd, 0x85, 0x8d, 0x8e, 0x84, 0xaa, 0xe8, 0xfe, 0xf9, 0x01, 0x0f,
-  0x04, 0x7b, 0x46, 0xac, 0x56, 0xdf, 0x69, 0x93, 0xda, 0xab, 0x56, 0xaa,
-  0x48, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x0f, 0x01, 0x3d, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x04, 0x7b, 0x12, 0x06,
-  0x00, 0x56, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54,
-  0x06, 0x14, 0x12, 0x06, 0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf5,
-  0x00, 0x00, 0x02, 0x0c, 0x06, 0x10, 0x10, 0x06, 0x00, 0xb1, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x01, 0x54, 0x06, 0x14, 0x12, 0x06,
-  0x00, 0x4d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x44, 0x00, 0x00, 0x06, 0x13,
-  0x04, 0x60, 0x00, 0x16, 0x00, 0x1f, 0x00, 0x00, 0x33, 0x35, 0x36, 0x37,
-  0x36, 0x11, 0x35, 0x21, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
-  0x21, 0x11, 0x21, 0x15, 0x10, 0x07, 0x06, 0x25, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x2b, 0x01, 0x11, 0x44, 0xa4, 0x33, 0x3d, 0x02, 0x8f, 0x9a, 0xc1,
-  0xd0, 0xd0, 0xc0, 0xfe, 0xbe, 0xfe, 0xbe, 0x4f, 0x55, 0x03, 0x20, 0x71,
-  0x77, 0x77, 0x71, 0x93, 0x99, 0x1c, 0x7e, 0xb1, 0x01, 0xc5, 0xb7, 0xfe,
-  0x37, 0xa3, 0xa8, 0xa8, 0xa4, 0x03, 0xcd, 0x6f, 0xfe, 0x50, 0xc2, 0xcf,
-  0x76, 0x5f, 0x5a, 0x5a, 0x5e, 0xfe, 0x8f, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0x00, 0x00, 0x06, 0x0c, 0x04, 0x60, 0x00, 0x12, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x21,
-  0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x01, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x2b, 0x01, 0x11, 0x03, 0xe0, 0x9a, 0xc0, 0xd1, 0xd0, 0xc0, 0xfe,
-  0xbe, 0xfe, 0x15, 0xa7, 0xa7, 0x01, 0xeb, 0x01, 0x39, 0x72, 0x77, 0x77,
-  0x72, 0x92, 0x04, 0x60, 0xfe, 0x37, 0xa3, 0xa8, 0xa8, 0xa4, 0x02, 0x04,
-  0xfd, 0xfc, 0x04, 0x60, 0xfe, 0x37, 0x01, 0xc9, 0xfc, 0x33, 0x5f, 0x5a,
-  0x5a, 0x5e, 0xfe, 0x8f, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x04, 0x15,
-  0x06, 0x14, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x23, 0x35, 0x33, 0x11, 0x33,
-  0x11, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11,
-  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0xc9, 0x9f,
-  0x9f, 0xa6, 0x01, 0xe7, 0xfe, 0x19, 0x3c, 0xa1, 0x69, 0xaa, 0xb6, 0xa6,
-  0x6f, 0x70, 0x89, 0x98, 0xa6, 0x03, 0xd1, 0x8f, 0x01, 0xb4, 0xfe, 0x4c,
-  0x8f, 0xfe, 0x6d, 0x65, 0x64, 0xea, 0xed, 0xfe, 0xd0, 0x01, 0x2a, 0x9f,
-  0x9e, 0xc1, 0xa1, 0xfe, 0xfb, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x1d, 0x06, 0x6d, 0x12, 0x26, 0x03, 0xce, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x76, 0x64, 0x07, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x07, 0x06, 0x6b, 0x12, 0x26, 0x03, 0xcc, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x43, 0x54, 0x05, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36,
-  0xfe, 0x56, 0x04, 0x0c, 0x06, 0x14, 0x12, 0x26, 0x03, 0xd7, 0x00, 0x00,
-  0x10, 0x06, 0x02, 0x9a, 0x55, 0xcc, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xfe, 0xe5, 0x04, 0x0e, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01,
-  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x23, 0x02, 0x18,
-  0xfe, 0x8f, 0xa7, 0x02, 0x19, 0xa7, 0xfe, 0x8f, 0x85, 0x04, 0x60, 0xfc,
-  0x33, 0x03, 0xcd, 0xfb, 0xa0, 0xfe, 0xe5, 0x00, 0x00, 0x01, 0x00, 0x67,
-  0xff, 0xe3, 0x06, 0x52, 0x05, 0xd5, 0x00, 0x34, 0x00, 0x00, 0x05, 0x22,
-  0x27, 0x26, 0x11, 0x34, 0x13, 0x36, 0x37, 0x33, 0x06, 0x03, 0x06, 0x15,
-  0x10, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x11, 0x34, 0x27, 0x02, 0x27, 0x33,
-  0x16, 0x17, 0x12, 0x15, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x06, 0x07, 0x06, 0x02, 0x01, 0xbe, 0x6d, 0x6e, 0x5a, 0x35, 0x53, 0xe0,
-  0x4b, 0x7a, 0x3c, 0x41, 0x42, 0x70, 0x67, 0x40, 0x40, 0xb3, 0x3f, 0x3f,
-  0x69, 0x78, 0x3b, 0x40, 0x3c, 0x7a, 0x4c, 0xe1, 0x56, 0x32, 0x5a, 0x6e,
-  0x6f, 0xbc, 0x84, 0x5a, 0x5a, 0x24, 0x23, 0x5a, 0x5b, 0x1d, 0xb1, 0xb4,
-  0x01, 0x98, 0xc9, 0x01, 0x0e, 0x9f, 0x7f, 0x46, 0xfe, 0xbf, 0x9f, 0xb7,
-  0xfe, 0xcd, 0x6b, 0x6d, 0x69, 0x68, 0xc6, 0xf1, 0xf1, 0xc6, 0x68, 0x69,
-  0x6d, 0x77, 0x01, 0x27, 0xb7, 0x9f, 0x01, 0x41, 0x46, 0x82, 0x9c, 0xfe,
-  0xe7, 0xbe, 0xfe, 0x66, 0xb2, 0xb1, 0x5e, 0x5e, 0xad, 0xad, 0x5e, 0x5e,
-  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a, 0x04, 0x60, 0x10, 0x06,
-  0x03, 0x5d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x1b, 0x00, 0x00, 0x05, 0x20,
-  0x05, 0xd5, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15, 0x21, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x21, 0x35, 0x21, 0x35, 0x33,
-  0x15, 0x21, 0x15, 0x13, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11, 0x21, 0x32,
-  0x37, 0x36, 0x02, 0x1c, 0x01, 0x2d, 0xe1, 0xf5, 0xf5, 0xe1, 0xfe, 0x1d,
-  0xfe, 0xb5, 0x01, 0x4b, 0xb6, 0x01, 0x4c, 0xf8, 0x48, 0x46, 0x92, 0xfe,
-  0xdc, 0x01, 0x24, 0x92, 0x46, 0x48, 0x04, 0x51, 0xe2, 0xda, 0xde, 0xdd,
-  0xda, 0x04, 0x51, 0xa4, 0xe0, 0xe0, 0xa4, 0xfd, 0x66, 0x8b, 0x44, 0x43,
-  0xfd, 0xdd, 0x44, 0x43, 0x00, 0x02, 0x00, 0x1b, 0x00, 0x00, 0x04, 0x6a,
-  0x06, 0x14, 0x00, 0x07, 0x00, 0x19, 0x00, 0x00, 0x24, 0x34, 0x26, 0x2b,
-  0x01, 0x11, 0x33, 0x32, 0x05, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x33, 0x32, 0x16, 0x10, 0x06, 0x23, 0x03, 0xb9,
-  0x76, 0x71, 0xec, 0xec, 0x71, 0xfd, 0xfd, 0xfe, 0xdb, 0x01, 0x25, 0xa6,
-  0x01, 0x7e, 0xfe, 0x82, 0xf3, 0xc1, 0xd0, 0xd0, 0xc1, 0xf2, 0xb4, 0x5e,
-  0xfe, 0x8f, 0x93, 0x03, 0xcd, 0x93, 0x01, 0xb4, 0xfe, 0x4c, 0x93, 0xfe,
-  0xca, 0xa3, 0xfe, 0xb0, 0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xbd,
-  0xff, 0xe3, 0x06, 0x66, 0x05, 0xf0, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x33, 0x11, 0x33, 0x12, 0x37, 0x36, 0x21, 0x32, 0x17, 0x16,
-  0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x21, 0x15,
-  0x21, 0x12, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07,
-  0x06, 0x23, 0x20, 0x27, 0x26, 0x03, 0x01, 0x74, 0xb6, 0xb6, 0xbd, 0x1b,
-  0x8d, 0xaf, 0x01, 0x32, 0x78, 0x6a, 0x6c, 0x5d, 0x5c, 0x67, 0x69, 0x75,
-  0xe6, 0x7a, 0x5d, 0x17, 0x02, 0x6d, 0xfd, 0x8c, 0x07, 0x74, 0x7b, 0xe5,
-  0x75, 0x69, 0x67, 0x5c, 0x5f, 0x6b, 0x6b, 0x76, 0xfe, 0xce, 0xaf, 0xa7,
-  0x08, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c, 0x01, 0x08, 0xa7,
-  0xd0, 0x24, 0x23, 0x47, 0xd5, 0x5f, 0x2f, 0x2f, 0x9c, 0x77, 0xc6, 0xaa,
-  0xfe, 0xf3, 0x94, 0x9d, 0x2f, 0x2f, 0x5f, 0xd3, 0x48, 0x24, 0x24, 0xcf,
-  0xc6, 0x01, 0x4f, 0x00, 0x00, 0x01, 0x00, 0xad, 0xff, 0xe3, 0x04, 0xf5,
-  0x04, 0x7b, 0x00, 0x23, 0x00, 0x00, 0x01, 0x32, 0x17, 0x15, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x15, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x23, 0x11, 0x23, 0x11,
-  0x33, 0x11, 0x33, 0x36, 0x37, 0x36, 0x03, 0xd1, 0x96, 0x8d, 0x91, 0x8a,
-  0xcf, 0x53, 0x1f, 0x0b, 0x01, 0x9e, 0xfe, 0x5b, 0x0c, 0x8e, 0x4d, 0x6c,
-  0x8d, 0x8e, 0x84, 0xa9, 0xf3, 0x85, 0x6e, 0x09, 0x85, 0xa5, 0xa5, 0x89,
-  0x15, 0x6e, 0x87, 0x04, 0x7b, 0x46, 0xac, 0x56, 0xb4, 0x41, 0x57, 0x8f,
-  0xf4, 0x5e, 0x33, 0x56, 0xaa, 0x48, 0xad, 0x90, 0xe4, 0xfd, 0xfc, 0x04,
-  0x60, 0xfe, 0x33, 0xca, 0x80, 0x9e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e,
-  0x00, 0x00, 0x06, 0x46, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x00,
-  0x21, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23, 0x03, 0x23, 0x01, 0x33,
-  0x13, 0x09, 0x01, 0x06, 0x46, 0xcb, 0xfa, 0xfb, 0xb6, 0xfd, 0xfa, 0xcb,
-  0x02, 0xb5, 0xcf, 0x9f, 0xfe, 0xf9, 0xfe, 0xf9, 0x02, 0x1b, 0xfd, 0xe5,
-  0x02, 0x1b, 0xfd, 0xe5, 0x05, 0xd5, 0xfc, 0xf3, 0x02, 0x37, 0xfd, 0xc9,
-  0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x05, 0x76, 0x04, 0x60, 0x00, 0x0b,
-  0x00, 0x0e, 0x00, 0x00, 0x21, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23,
-  0x03, 0x23, 0x01, 0x33, 0x13, 0x0b, 0x01, 0x05, 0x76, 0xb0, 0xd4, 0xcc,
-  0xa6, 0xce, 0xd5, 0xaf, 0x02, 0x4c, 0xb0, 0x82, 0xda, 0xdb, 0x01, 0x95,
-  0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b, 0x04, 0x60, 0xfd, 0xb9, 0x01, 0xa1,
-  0xfe, 0x5f, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x08, 0x2c,
-  0x05, 0xd5, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00, 0x21, 0x23, 0x03, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x03, 0x23, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
-  0x11, 0x21, 0x01, 0x33, 0x13, 0x09, 0x01, 0x08, 0x2c, 0xcb, 0xfa, 0xfb,
-  0xb6, 0xfd, 0xfa, 0xcb, 0x01, 0x4b, 0xfe, 0x2c, 0xb6, 0xb6, 0x02, 0x22,
-  0x01, 0x1c, 0xcf, 0x9f, 0xfe, 0xf9, 0xfe, 0xf9, 0x02, 0x1b, 0xfd, 0xe5,
-  0x02, 0x1b, 0xfd, 0xe5, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c,
-  0x02, 0x64, 0xfc, 0xf3, 0x02, 0x37, 0xfd, 0xc9, 0x00, 0x02, 0x00, 0xad,
-  0x00, 0x00, 0x07, 0x08, 0x04, 0x60, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00,
-  0x21, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23, 0x03, 0x23, 0x01, 0x21,
-  0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x01, 0x33, 0x13, 0x0b, 0x01, 0x07,
-  0x08, 0xb0, 0xd4, 0xcc, 0xa6, 0xce, 0xd4, 0xb0, 0x01, 0x00, 0xfe, 0x93,
-  0xa5, 0xa5, 0x01, 0xb8, 0x01, 0x02, 0xaf, 0x83, 0xdb, 0xdb, 0x01, 0x95,
-  0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b, 0x01, 0xe7, 0xfe, 0x19, 0x04, 0x60,
-  0xfe, 0x17, 0x01, 0xe9, 0xfd, 0xb9, 0x01, 0xa1, 0xfe, 0x5f, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x67, 0x00, 0x00, 0x05, 0x44, 0x05, 0xd5, 0x00, 0x17,
-  0x00, 0x1a, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x11,
-  0x23, 0x10, 0x37, 0x36, 0x37, 0x01, 0x21, 0x01, 0x16, 0x17, 0x16, 0x11,
-  0x23, 0x10, 0x27, 0x26, 0x27, 0x01, 0x21, 0x03, 0x30, 0xb6, 0x84, 0x5a,
-  0x75, 0xbf, 0xaa, 0x6c, 0x99, 0xfe, 0x7c, 0x04, 0x90, 0xfe, 0x7b, 0x94,
-  0x68, 0xa9, 0xbf, 0x74, 0x56, 0xdf, 0x01, 0x1e, 0xfd, 0xc3, 0x02, 0x59,
-  0xfd, 0xa7, 0x02, 0x59, 0x1c, 0x7e, 0xa4, 0xfe, 0xe5, 0x01, 0x62, 0xd2,
-  0x86, 0x31, 0x02, 0xea, 0xfd, 0x13, 0x32, 0x82, 0xd2, 0xfe, 0x9e, 0x01,
-  0x1e, 0xa1, 0x7a, 0xca, 0x02, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x60,
-  0x00, 0x00, 0x04, 0x09, 0x04, 0x60, 0x00, 0x02, 0x00, 0x1a, 0x00, 0x00,
-  0x01, 0x21, 0x13, 0x09, 0x01, 0x16, 0x17, 0x16, 0x11, 0x23, 0x34, 0x27,
-  0x26, 0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x15, 0x23, 0x10, 0x37,
-  0x36, 0x37, 0x01, 0x02, 0xf1, 0xfe, 0x87, 0xbc, 0x01, 0xd4, 0xfe, 0xdc,
-  0x60, 0x44, 0x7b, 0xb0, 0x4d, 0x34, 0x4e, 0xa5, 0x4b, 0x32, 0x4e, 0xae,
-  0x7b, 0x43, 0x61, 0xfe, 0xdb, 0x03, 0xb6, 0xfe, 0x96, 0x02, 0x14, 0xfd,
-  0xcc, 0x26, 0x56, 0x9c, 0xfe, 0xec, 0xc7, 0x74, 0x4f, 0x1a, 0xfe, 0x5c,
-  0x01, 0xa2, 0x1a, 0x4b, 0x74, 0xc9, 0x01, 0x14, 0x9c, 0x55, 0x27, 0x02,
-  0x34, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x06, 0xfe,
-  0x05, 0xd5, 0x00, 0x1e, 0x00, 0x21, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01,
-  0x16, 0x17, 0x16, 0x11, 0x23, 0x10, 0x27, 0x26, 0x27, 0x11, 0x23, 0x11,
-  0x06, 0x07, 0x06, 0x11, 0x23, 0x10, 0x37, 0x36, 0x37, 0x21, 0x11, 0x23,
-  0x11, 0x33, 0x11, 0x05, 0x01, 0x21, 0x03, 0x8a, 0xfe, 0xc3, 0x04, 0x90,
-  0xfe, 0x7b, 0x94, 0x68, 0xa9, 0xbf, 0x74, 0x56, 0x8a, 0xb6, 0x84, 0x5a,
-  0x75, 0xc0, 0xab, 0x4c, 0x63, 0xfd, 0xf0, 0xb6, 0xb6, 0x03, 0x2a, 0x01,
-  0x1e, 0xfd, 0xc3, 0x03, 0x71, 0x02, 0x64, 0xfd, 0x13, 0x32, 0x82, 0xd2,
-  0xfe, 0x9e, 0x01, 0x1e, 0xa1, 0x7a, 0x20, 0xfd, 0xa7, 0x02, 0x59, 0x1c,
-  0x7e, 0xa4, 0xfe, 0xe5, 0x01, 0x62, 0xd2, 0x5f, 0x34, 0xfd, 0x39, 0x05,
-  0xd5, 0xfd, 0x9c, 0x6e, 0x02, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
-  0x00, 0x00, 0x05, 0x90, 0x04, 0x60, 0x00, 0x1e, 0x00, 0x21, 0x00, 0x00,
-  0x01, 0x03, 0x21, 0x01, 0x16, 0x17, 0x16, 0x11, 0x23, 0x34, 0x27, 0x26,
-  0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x15, 0x23, 0x10, 0x37, 0x36,
-  0x37, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x21, 0x13, 0x02, 0xe5,
-  0xfd, 0x03, 0xa8, 0xfe, 0xdb, 0x61, 0x43, 0x7b, 0xaf, 0x4d, 0x35, 0x4d,
-  0xa6, 0x4a, 0x33, 0x4d, 0xaf, 0x7b, 0x19, 0x1c, 0xfe, 0xb6, 0xa5, 0xa5,
-  0x03, 0x26, 0xfe, 0x87, 0xbc, 0x02, 0x77, 0x01, 0xe9, 0xfd, 0xcc, 0x26,
-  0x56, 0x9c, 0xfe, 0xec, 0xc7, 0x74, 0x4f, 0x1a, 0xfe, 0x5c, 0x01, 0xa2,
-  0x1a, 0x4b, 0x74, 0xc9, 0x01, 0x14, 0x9c, 0x1f, 0x18, 0xfe, 0x19, 0x04,
-  0x60, 0xfe, 0x17, 0x01, 0x3f, 0xfe, 0x96, 0x00, 0x00, 0x01, 0x00, 0x67,
-  0xfe, 0x56, 0x04, 0x02, 0x07, 0x7a, 0x00, 0x53, 0x00, 0x00, 0x01, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x23, 0x22, 0x15, 0x14, 0x33, 0x32, 0x37,
-  0x36, 0x17, 0x16, 0x17, 0x15, 0x26, 0x23, 0x22, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x23, 0x35, 0x32, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
-  0x21, 0x22, 0x07, 0x35, 0x36, 0x37, 0x03, 0x33, 0x13, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22, 0x0f,
-  0x01, 0x16, 0x17, 0x16, 0x15, 0x10, 0x07, 0x16, 0x17, 0x16, 0x04, 0x01,
-  0x67, 0x89, 0xb2, 0x3e, 0xa7, 0x20, 0x56, 0xc6, 0x3b, 0x73, 0x68, 0x1d,
-  0x58, 0x4c, 0x3d, 0x69, 0x35, 0xe3, 0x36, 0x70, 0x43, 0x92, 0x2f, 0x39,
-  0x69, 0x01, 0x3c, 0x5e, 0x3f, 0x3a, 0xa8, 0x4f, 0xe0, 0x10, 0x4d, 0x15,
-  0x93, 0x49, 0x6a, 0xfe, 0xe4, 0x94, 0xc8, 0x90, 0x74, 0x8f, 0x67, 0x90,
-  0x60, 0x1b, 0x0d, 0x15, 0x15, 0x1f, 0x3c, 0x17, 0x1f, 0x23, 0x09, 0x0e,
-  0x1f, 0x2d, 0x51, 0x96, 0x58, 0x67, 0xf6, 0x7f, 0x4a, 0x4c, 0x01, 0xbe,
-  0xcf, 0x67, 0x88, 0x08, 0x82, 0x72, 0x0c, 0x0b, 0x02, 0x07, 0x25, 0xa7,
-  0x27, 0x1b, 0x2c, 0x61, 0x92, 0x7a, 0x51, 0x5e, 0x58, 0x52, 0x6a, 0xbd,
-  0x37, 0x19, 0xa6, 0x02, 0x26, 0x36, 0x8d, 0xee, 0x4a, 0xb4, 0x2d, 0x0d,
-  0x01, 0x83, 0xfe, 0x83, 0xde, 0x40, 0x18, 0x27, 0x12, 0x1b, 0x0a, 0x57,
-  0x05, 0x02, 0x6f, 0xca, 0x18, 0x57, 0x64, 0xa7, 0xfe, 0xfd, 0x45, 0x1e,
-  0x5c, 0x60, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51, 0xfe, 0x74, 0x03, 0x68,
-  0x06, 0x06, 0x00, 0x4f, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x23, 0x22, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x33, 0x32,
-  0x17, 0x15, 0x26, 0x23, 0x22, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x10,
-  0x33, 0x21, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x22, 0x23, 0x35,
-  0x32, 0x17, 0x32, 0x33, 0x20, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x35, 0x36, 0x37, 0x03, 0x33, 0x13, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x15, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x04, 0x15, 0x14, 0x07, 0x16,
-  0x17, 0x16, 0x03, 0x67, 0x6a, 0x62, 0x92, 0x3d, 0x97, 0x17, 0x48, 0x58,
-  0x1e, 0x23, 0x28, 0xa0, 0x29, 0x59, 0x4f, 0x35, 0x59, 0x2c, 0xbd, 0x2d,
-  0x5e, 0x39, 0x7b, 0xb0, 0x01, 0x0e, 0x51, 0x63, 0x46, 0x36, 0x66, 0x05,
-  0xa0, 0x0a, 0x1d, 0x1d, 0x13, 0x01, 0x16, 0x54, 0x41, 0x53, 0x82, 0xa6,
-  0x71, 0x5c, 0x8f, 0x68, 0x90, 0x5f, 0x2a, 0x13, 0x27, 0x49, 0x17, 0x20,
-  0x2d, 0x0e, 0x1e, 0x2e, 0x51, 0x01, 0x11, 0xd1, 0x64, 0x40, 0x48, 0x01,
-  0x52, 0x9e, 0x5e, 0x56, 0x08, 0x81, 0x61, 0x1b, 0x09, 0x24, 0x27, 0x8b,
-  0x22, 0x17, 0x25, 0x52, 0x97, 0x01, 0x0c, 0x60, 0x59, 0x4c, 0x38, 0x2b,
-  0x08, 0x98, 0x01, 0xa0, 0x51, 0x2a, 0x21, 0x37, 0xa7, 0x1f, 0x0b, 0x01,
-  0x83, 0xfe, 0x83, 0xde, 0x63, 0x17, 0x32, 0x0a, 0x57, 0x07, 0x6f, 0xca,
-  0x2f, 0xf2, 0xc4, 0x32, 0x16, 0x40, 0x49, 0x00, 0x00, 0x01, 0x00, 0x0e,
-  0x00, 0x00, 0x06, 0x15, 0x05, 0xd5, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x01, 0x23, 0x11, 0x23, 0x11, 0x23,
-  0x01, 0x33, 0x01, 0x33, 0x11, 0x33, 0x11, 0x33, 0x13, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x06, 0x14, 0x34, 0x17, 0x1c, 0x22, 0x1a, 0x3b, 0x36,
-  0xff, 0x00, 0xe1, 0xb6, 0xe1, 0xfe, 0x86, 0xb0, 0x01, 0x3b, 0x70, 0xb6,
-  0x71, 0xd0, 0x47, 0x5d, 0x3c, 0x74, 0x2e, 0x32, 0x05, 0x14, 0x07, 0x03,
-  0x19, 0x38, 0xa1, 0xfd, 0x0a, 0xfe, 0xca, 0x01, 0x36, 0x04, 0x60, 0xfc,
-  0x54, 0x03, 0xeb, 0xfc, 0x13, 0x02, 0x72, 0xd4, 0x50, 0x33, 0x10, 0x00,
-  0x00, 0x01, 0x00, 0x2d, 0xfe, 0x56, 0x06, 0x22, 0x06, 0x1e, 0x00, 0x1c,
-  0x00, 0x00, 0x01, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x01, 0x33, 0x01, 0x33, 0x11, 0x33, 0x11, 0x33,
-  0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x06, 0x22, 0x35, 0x16, 0x1d,
-  0x21, 0x1a, 0x3c, 0x36, 0xff, 0xe1, 0xa5, 0xe1, 0xfe, 0x86, 0xaf, 0x01,
-  0x3c, 0x70, 0xa5, 0x70, 0xd1, 0x46, 0x5e, 0x3b, 0x74, 0x2e, 0x33, 0x03,
-  0xde, 0x07, 0x03, 0x19, 0x38, 0xa1, 0xfd, 0x0a, 0xfe, 0x56, 0x01, 0xaa,
-  0x04, 0x60, 0xfc, 0x54, 0x05, 0x6a, 0xfa, 0x94, 0x02, 0x72, 0xd4, 0x50,
-  0x33, 0x10, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x05, 0xf0, 0x12, 0x06, 0x01, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x12, 0x06, 0x02, 0x37, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x8a, 0x05, 0xf0, 0x00, 0x12,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x07, 0x01, 0x23, 0x01, 0x33, 0x09, 0x01, 0x12, 0x36, 0x05, 0x18, 0x39,
-  0x39, 0x3e, 0x14, 0x16, 0x42, 0x1e, 0x40, 0x4c, 0xfe, 0xa8, 0xcf, 0xfd,
-  0xff, 0xbe, 0x01, 0xaa, 0x01, 0x19, 0x67, 0x9d, 0x05, 0xf0, 0x15, 0xbb,
-  0x0a, 0x04, 0x22, 0x43, 0xdd, 0xfc, 0x14, 0x05, 0xd5, 0xfb, 0x17, 0x03,
-  0x3d, 0x01, 0x32, 0x95, 0x00, 0x01, 0x00, 0x2d, 0x00, 0x00, 0x04, 0x9c,
-  0x04, 0x7b, 0x00, 0x13, 0x00, 0x00, 0x01, 0x32, 0x17, 0x15, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x07, 0x01, 0x23, 0x01, 0x33, 0x01, 0x13, 0x36,
-  0x37, 0x36, 0x04, 0x3c, 0x2e, 0x32, 0x34, 0x11, 0x23, 0x21, 0x1a, 0x3b,
-  0x36, 0xff, 0x00, 0xe1, 0xfe, 0x86, 0xaf, 0x01, 0x3c, 0xd0, 0x48, 0x5c,
-  0x3c, 0x04, 0x7b, 0x10, 0x8d, 0x07, 0x03, 0x19, 0x37, 0xa2, 0xfd, 0x0a,
-  0x04, 0x60, 0xfc, 0x54, 0x02, 0x70, 0xd5, 0x4f, 0x33, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x8a, 0x07, 0x70, 0x10, 0x27,
-  0x10, 0xf5, 0x04, 0x67, 0x01, 0x7a, 0x12, 0x06, 0x04, 0x08, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x2d, 0x00, 0x00, 0x04, 0x9c, 0x06, 0x66, 0x10, 0x27,
-  0x02, 0xc0, 0x04, 0x48, 0x00, 0x00, 0x12, 0x06, 0x04, 0x09, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x67, 0xfe, 0x56, 0x06, 0xee, 0x05, 0xf0, 0x00, 0x11,
-  0x00, 0x1e, 0x00, 0x2c, 0x00, 0x00, 0x09, 0x01, 0x06, 0x07, 0x06, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x13, 0x01, 0x33, 0x1b, 0x01,
-  0x01, 0x10, 0x07, 0x02, 0x20, 0x03, 0x26, 0x10, 0x37, 0x12, 0x20, 0x13,
-  0x16, 0x03, 0x10, 0x27, 0x26, 0x20, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x06, 0xee, 0xfe, 0x45, 0x4a, 0x3f, 0x42, 0x70, 0x84,
-  0x61, 0x44, 0x26, 0x22, 0x32, 0x6f, 0xfe, 0xc6, 0xaf, 0xe4, 0xe3, 0xfd,
-  0x86, 0x56, 0x71, 0xfe, 0x33, 0x72, 0x56, 0x56, 0x72, 0x01, 0xcd, 0x71,
-  0x56, 0xc0, 0x19, 0x32, 0xfe, 0xbc, 0x35, 0x19, 0x1a, 0x34, 0x01, 0x44,
-  0x33, 0x18, 0x04, 0x60, 0xfb, 0x38, 0xcb, 0x3a, 0x3d, 0x9a, 0x24, 0x21,
-  0x89, 0x01, 0x37, 0x03, 0x6b, 0xfd, 0x8a, 0x02, 0x76, 0xfe, 0x8a, 0xfe,
-  0xdd, 0xd0, 0xfe, 0xec, 0x01, 0x13, 0xd1, 0x02, 0x44, 0xd1, 0x01, 0x14,
-  0xfe, 0xed, 0xd1, 0xfe, 0xde, 0x01, 0x06, 0x72, 0xea, 0xea, 0x74, 0xfe,
-  0xfb, 0xfe, 0xfc, 0x74, 0xea, 0xea, 0x72, 0x00, 0x00, 0x03, 0x00, 0x65,
-  0xfe, 0x56, 0x06, 0x4c, 0x04, 0x7b, 0x00, 0x11, 0x00, 0x1f, 0x00, 0x25,
-  0x00, 0x00, 0x09, 0x01, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x37, 0x13, 0x01, 0x33, 0x1b, 0x01, 0x00, 0x10, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x02, 0x10,
-  0x23, 0x22, 0x10, 0x33, 0x06, 0x4c, 0xfe, 0x45, 0x4a, 0x3f, 0x42, 0x70,
-  0x84, 0x61, 0x44, 0x26, 0x22, 0x32, 0x6f, 0xfe, 0xc6, 0xaf, 0xe4, 0xe3,
-  0xfd, 0xb6, 0x55, 0x67, 0xb8, 0xba, 0x68, 0x56, 0x56, 0x68, 0xba, 0xb8,
-  0x67, 0x5a, 0xc5, 0xca, 0xca, 0x04, 0x60, 0xfb, 0x38, 0xcb, 0x3a, 0x3d,
-  0x9a, 0x24, 0x21, 0x89, 0x01, 0x37, 0x03, 0x6b, 0xfd, 0x8a, 0x02, 0x76,
-  0xfe, 0xab, 0xfe, 0x48, 0xa7, 0xc9, 0xc8, 0xa6, 0x01, 0xbc, 0xa6, 0xc8,
-  0xc9, 0xfc, 0xcd, 0x03, 0x60, 0xfc, 0xa0, 0x00, 0x00, 0x02, 0x00, 0x67,
-  0xff, 0xe3, 0x06, 0x76, 0x05, 0xf0, 0x00, 0x29, 0x00, 0x52, 0x00, 0x00,
-  0x25, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x07, 0x23, 0x20, 0x27, 0x26, 0x10,
-  0x37, 0x36, 0x21, 0x33, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x33, 0x20, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x21,
-  0x23, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03,
-  0xed, 0x1b, 0xd4, 0x66, 0x74, 0x74, 0x66, 0xd4, 0x1b, 0x0a, 0x0d, 0x14,
-  0x18, 0x18, 0x37, 0x18, 0x18, 0x14, 0x0e, 0x09, 0x2a, 0xd3, 0x67, 0x75,
-  0x75, 0x67, 0xd3, 0x2a, 0x09, 0x0e, 0x14, 0x18, 0x18, 0x37, 0x18, 0x18,
-  0x14, 0x0e, 0xe4, 0x2a, 0xfe, 0xc4, 0x88, 0xaa, 0xaa, 0x88, 0x01, 0x3c,
-  0x29, 0x0a, 0x0e, 0x14, 0x18, 0x18, 0x37, 0x18, 0x1c, 0x10, 0x0e, 0x0a,
-  0x1a, 0x01, 0x3b, 0x89, 0xa9, 0xa9, 0x89, 0xfe, 0xc5, 0x1a, 0x09, 0x0f,
-  0x14, 0x18, 0x18, 0x37, 0x18, 0x1c, 0x10, 0x0e, 0xc2, 0x91, 0xa4, 0xf2,
-  0xf3, 0xa4, 0x91, 0x14, 0x0e, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x10,
-  0x12, 0x91, 0xa4, 0xf3, 0xf2, 0xa4, 0x91, 0x12, 0x10, 0x15, 0x0c, 0x0b,
-  0x0b, 0x0c, 0x15, 0x10, 0xa1, 0xaa, 0xd2, 0x02, 0x74, 0xd3, 0xaa, 0x15,
-  0x0f, 0x15, 0x0c, 0x0b, 0x0b, 0x0e, 0x13, 0x11, 0x13, 0xaa, 0xd3, 0xfe,
-  0xc6, 0xfe, 0xc7, 0xd2, 0xab, 0x13, 0x11, 0x15, 0x0c, 0x0b, 0x0b, 0x0e,
-  0x13, 0x11, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x05, 0x11,
-  0x04, 0x7b, 0x00, 0x26, 0x00, 0x50, 0x00, 0x00, 0x25, 0x33, 0x32, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x06, 0x07, 0x0e, 0x01, 0x22,
-  0x26, 0x27, 0x26, 0x27, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x3b, 0x01, 0x36, 0x37, 0x3e, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x07,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0x1a, 0x28, 0x91, 0x41, 0x4d, 0x4d,
-  0x39, 0x99, 0x28, 0x06, 0x0a, 0x10, 0x27, 0x2f, 0x28, 0x10, 0x09, 0x06,
-  0x29, 0x92, 0x40, 0x4e, 0x4d, 0x41, 0x92, 0x29, 0x06, 0x09, 0x10, 0x28,
-  0x2f, 0x13, 0x19, 0x0b, 0x09, 0xb5, 0x2a, 0xe7, 0x6c, 0x7b, 0x7b, 0x68,
-  0xeb, 0x2a, 0x06, 0x08, 0x0c, 0x18, 0x14, 0x2f, 0x13, 0x19, 0x0b, 0x09,
-  0x06, 0x29, 0xe8, 0x6c, 0x7b, 0x7b, 0x69, 0xeb, 0x29, 0x06, 0x09, 0x0b,
-  0x19, 0x13, 0x2f, 0x14, 0x18, 0x0c, 0x08, 0xa4, 0x60, 0x74, 0xb7, 0xa7,
-  0x83, 0x61, 0x0b, 0x0a, 0x11, 0x14, 0x14, 0x11, 0x0a, 0x0b, 0x5f, 0x74,
-  0xb8, 0xbc, 0x70, 0x5f, 0x0b, 0x0a, 0x11, 0x14, 0x0a, 0x0c, 0x0f, 0x0a,
-  0x93, 0x89, 0x9c, 0xee, 0xe9, 0xa2, 0x88, 0x0a, 0x0a, 0x0f, 0x0c, 0x0a,
-  0x0a, 0x0c, 0x0f, 0x0a, 0x0a, 0x88, 0x9c, 0xef, 0xe8, 0xa2, 0x89, 0x0a,
-  0x0a, 0x0f, 0x0c, 0x0a, 0x0a, 0x0c, 0x0f, 0x0a, 0x00, 0x03, 0x00, 0x6a,
-  0xff, 0xe3, 0x08, 0x15, 0x07, 0x74, 0x00, 0x34, 0x00, 0x3d, 0x00, 0x4b,
-  0x00, 0x00, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x23, 0x22, 0x0f, 0x01, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x15, 0x10, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x11, 0x34,
-  0x27, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x01, 0x10, 0x23, 0x35, 0x16,
-  0x35, 0x23, 0x35, 0x33, 0x17, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
-  0x35, 0x36, 0x37, 0x36, 0x33, 0x20, 0x08, 0x14, 0x5c, 0x68, 0xd3, 0x51,
-  0x64, 0x57, 0x56, 0x6e, 0x6c, 0x6e, 0x6f, 0xae, 0x63, 0x52, 0xd3, 0x68,
-  0x5c, 0x3c, 0x40, 0x64, 0xe0, 0x71, 0x52, 0x4c, 0xe6, 0x7c, 0x54, 0x44,
-  0x44, 0x5c, 0x8d, 0x8b, 0x5a, 0x44, 0x43, 0x53, 0x7c, 0xe7, 0x4d, 0x52,
-  0x71, 0xe1, 0x64, 0x3f, 0x3c, 0xfc, 0xa2, 0xda, 0x79, 0x78, 0xd9, 0xe4,
-  0x6a, 0x15, 0x92, 0x54, 0x52, 0x84, 0x7a, 0x7d, 0x42, 0x6c, 0x70, 0x01,
-  0x07, 0x01, 0xfe, 0xf2, 0x8b, 0x9e, 0x44, 0x40, 0x40, 0x44, 0x44, 0x80,
-  0x44, 0x9d, 0x8b, 0xf2, 0xc6, 0xe2, 0xec, 0x98, 0x6b, 0xf3, 0xe2, 0xb6,
-  0xfe, 0xba, 0x36, 0x33, 0x33, 0x36, 0x36, 0x33, 0x33, 0x36, 0x01, 0x46,
-  0xb6, 0xe2, 0xf3, 0x6b, 0x98, 0xec, 0xe2, 0x03, 0x0a, 0xfe, 0xf5, 0x67,
-  0x03, 0x9d, 0x9e, 0x11, 0x9b, 0x2f, 0x4b, 0x17, 0x86, 0x27, 0x2a, 0x43,
-  0x00, 0x03, 0x00, 0x88, 0xff, 0xe3, 0x06, 0xde, 0x06, 0x10, 0x00, 0x21,
-  0x00, 0x2a, 0x00, 0x38, 0x00, 0x00, 0x01, 0x12, 0x11, 0x10, 0x21, 0x22,
-  0x24, 0x22, 0x04, 0x23, 0x20, 0x11, 0x10, 0x13, 0x33, 0x02, 0x15, 0x10,
-  0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x33,
-  0x32, 0x11, 0x34, 0x03, 0x25, 0x10, 0x23, 0x35, 0x16, 0x35, 0x23, 0x35,
-  0x33, 0x17, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37,
-  0x36, 0x33, 0x20, 0x06, 0x62, 0x7c, 0xfe, 0x9a, 0x4c, 0xfe, 0xf3, 0xd8,
-  0xfe, 0xf2, 0x4a, 0xfe, 0x9a, 0x7c, 0xb2, 0x83, 0xbb, 0x38, 0x41, 0x6c,
-  0x13, 0x5a, 0xe3, 0x5a, 0x12, 0x6d, 0x42, 0x39, 0xbb, 0x84, 0xfe, 0x7b,
-  0xd9, 0x78, 0x77, 0xd8, 0xe4, 0x6a, 0x15, 0x91, 0x54, 0x52, 0x84, 0x7b,
-  0x7d, 0x43, 0x6b, 0x70, 0x01, 0x07, 0x03, 0xc5, 0xfe, 0xe3, 0xfe, 0xeb,
-  0xfe, 0x50, 0xe2, 0xe2, 0x01, 0xb1, 0x01, 0x14, 0x01, 0x1d, 0xfe, 0xb9,
-  0xfa, 0xfe, 0xfb, 0x38, 0x5b, 0x0c, 0x37, 0x37, 0x0c, 0x5b, 0x38, 0x01,
-  0x07, 0xf8, 0x01, 0x47, 0xa4, 0xfe, 0xf5, 0x67, 0x03, 0x9d, 0x9e, 0x11,
-  0x9b, 0x2f, 0x4b, 0x17, 0x86, 0x27, 0x2a, 0x43, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x06, 0x52, 0x07, 0x33, 0x10, 0x27, 0x11, 0xb5, 0x00, 0x59,
-  0x01, 0x53, 0x10, 0x06, 0x03, 0xf4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x05, 0xe0, 0x10, 0x26, 0x11, 0xb5, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0xf5, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
-  0xfe, 0x56, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x21, 0x23,
-  0x20, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x21, 0x32, 0x17, 0x16, 0x17,
-  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16,
-  0x33, 0x21, 0x11, 0x23, 0x03, 0x94, 0x9c, 0xfe, 0xc7, 0xa8, 0xaf, 0xaf,
-  0xaf, 0x01, 0x32, 0x78, 0x6a, 0x6c, 0x5d, 0x5c, 0x67, 0x69, 0x75, 0xe6,
-  0x7a, 0x7b, 0x7b, 0x88, 0xd8, 0x01, 0x47, 0xb5, 0xc6, 0xd0, 0x01, 0x53,
-  0x01, 0x68, 0xcf, 0xd0, 0x24, 0x23, 0x47, 0xd5, 0x5f, 0x2f, 0x2f, 0x9c,
-  0x9d, 0xfe, 0xd8, 0xfe, 0xd3, 0x82, 0x94, 0xfd, 0xb0, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x65, 0xfe, 0x56, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x1d,
-  0x00, 0x00, 0x21, 0x22, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x3b, 0x01, 0x11, 0x23, 0x11, 0x02, 0x56, 0xeb, 0x7f,
-  0x86, 0x88, 0x87, 0xeb, 0x4d, 0x49, 0x49, 0x44, 0x46, 0x47, 0x46, 0x48,
-  0xa2, 0x59, 0x59, 0x59, 0x59, 0xa2, 0xdc, 0xb5, 0x96, 0x9f, 0xfa, 0x01,
-  0x12, 0x9d, 0x9d, 0x11, 0x12, 0x23, 0xac, 0x2b, 0x16, 0x15, 0x71, 0x72,
-  0xcd, 0xb9, 0x72, 0x71, 0xfd, 0xc3, 0x01, 0xaa, 0x00, 0x01, 0x00, 0x35,
-  0xff, 0xa5, 0x03, 0x69, 0x03, 0xa7, 0x00, 0x13, 0x00, 0x00, 0x01, 0x07,
-  0x27, 0x07, 0x17, 0x07, 0x27, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37,
-  0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x03, 0x69, 0x5a, 0xc2, 0x5f, 0xc2,
-  0x5a, 0xc2, 0x70, 0x9d, 0x71, 0xc3, 0x5a, 0xc3, 0x5e, 0xc2, 0x5a, 0xc2,
-  0x5e, 0x9d, 0x5e, 0x02, 0x11, 0xae, 0x7d, 0xb5, 0x7d, 0xae, 0x7d, 0xd8,
-  0x64, 0xd8, 0x7d, 0xae, 0x7d, 0xb5, 0x7d, 0xae, 0x7d, 0xb5, 0x64, 0xb5,
-  0x00, 0x01, 0xfc, 0x44, 0x04, 0xde, 0xff, 0x55, 0x06, 0x7a, 0x00, 0x2f,
-  0x00, 0x00, 0x01, 0x21, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x21, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0xfe, 0xda, 0xfe, 0x61, 0x09, 0x0a, 0x11, 0x12, 0x17, 0x15,
-  0x33, 0x15, 0x17, 0x12, 0x11, 0x0a, 0x09, 0x09, 0x0a, 0x11, 0x12, 0x17,
-  0x15, 0x1a, 0x01, 0x9e, 0x09, 0x0a, 0x11, 0x12, 0x17, 0x15, 0x33, 0x15,
-  0x17, 0x12, 0x12, 0x09, 0x09, 0x09, 0x0a, 0x11, 0x12, 0x17, 0x15, 0x05,
-  0x67, 0x1b, 0x19, 0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x0a, 0x0b, 0x13, 0x12,
-  0x1b, 0x19, 0x1b, 0x1c, 0x19, 0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x1b, 0x19,
-  0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x0a, 0x0b, 0x13, 0x15, 0x18, 0x19, 0x1c,
-  0x1b, 0x19, 0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x00, 0x00, 0x01, 0xfd, 0x53,
-  0x05, 0x29, 0x00, 0x09, 0x06, 0x4d, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x23,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x20,
-  0x08, 0x6a, 0x15, 0x92, 0x53, 0x52, 0x84, 0x7b, 0x7d, 0x43, 0x6b, 0x70,
-  0x01, 0x07, 0x05, 0x29, 0x9b, 0x2f, 0x4b, 0x17, 0x86, 0x27, 0x2a, 0x43,
-  0x00, 0x01, 0xfd, 0xed, 0x04, 0xc2, 0xfe, 0xc8, 0x06, 0x61, 0x00, 0x08,
-  0x00, 0x00, 0x01, 0x22, 0x11, 0x35, 0x33, 0x15, 0x23, 0x14, 0x37, 0xfe,
-  0xc8, 0xda, 0xd9, 0x78, 0x79, 0x04, 0xc2, 0x01, 0x0b, 0x94, 0x9e, 0x9d,
-  0x03, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xed, 0x04, 0xc2, 0xfe, 0xc8,
-  0x06, 0x61, 0x00, 0x08, 0x00, 0x00, 0x01, 0x10, 0x23, 0x35, 0x16, 0x35,
-  0x23, 0x35, 0x33, 0xfe, 0xc8, 0xda, 0x78, 0x77, 0xd9, 0x05, 0xcd, 0xfe,
-  0xf5, 0x67, 0x03, 0x9d, 0x9e, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfa, 0x69,
-  0x04, 0xd9, 0x00, 0x09, 0x06, 0x4d, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x12,
-  0x21, 0x32, 0x05, 0x04, 0x25, 0x15, 0x24, 0x27, 0x24, 0x27, 0x26, 0x07,
-  0xfa, 0x69, 0x79, 0x01, 0x84, 0x67, 0x01, 0x25, 0x01, 0x13, 0x01, 0x03,
-  0xfe, 0x89, 0xd7, 0xfe, 0xf6, 0x5c, 0xc6, 0x89, 0x05, 0x01, 0x01, 0x4c,
-  0x7b, 0x74, 0x01, 0x86, 0x17, 0x5c, 0x71, 0x07, 0x0c, 0xcf, 0x00, 0x00,
-  0x00, 0x08, 0xf8, 0xa7, 0xfe, 0x90, 0x02, 0xf3, 0x07, 0x60, 0x00, 0x0c,
-  0x00, 0x19, 0x00, 0x26, 0x00, 0x33, 0x00, 0x40, 0x00, 0x4d, 0x00, 0x5a,
-  0x00, 0x67, 0x00, 0x00, 0x01, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07,
-  0x23, 0x3e, 0x01, 0x20, 0x16, 0x01, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x05, 0x23, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x01, 0x23, 0x2e, 0x01, 0x23,
-  0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x05, 0x23, 0x2e, 0x01,
-  0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x01, 0x23, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x05, 0x23,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x01,
-  0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16,
-  0xfe, 0xe6, 0x6a, 0x0a, 0x57, 0x4e, 0x4e, 0x56, 0x0c, 0x6a, 0x09, 0x8e,
-  0x01, 0x05, 0x8e, 0x02, 0xe6, 0x6a, 0x0a, 0x57, 0x4f, 0x4d, 0x57, 0x0b,
-  0x6a, 0x08, 0x8f, 0x01, 0x05, 0x8e, 0xfa, 0x50, 0x6a, 0x0a, 0x58, 0x4e,
-  0x4d, 0x57, 0x0c, 0x6a, 0x09, 0x8f, 0x01, 0x04, 0x8f, 0x05, 0xc2, 0x6a,
-  0x0a, 0x57, 0x4f, 0x4d, 0x57, 0x0b, 0x6a, 0x08, 0x8f, 0x01, 0x05, 0x8e,
-  0xfa, 0x50, 0x6a, 0x0a, 0x58, 0x4e, 0x4d, 0x57, 0x0c, 0x6a, 0x09, 0x8f,
-  0x01, 0x04, 0x8f, 0x06, 0xf1, 0x6a, 0x0a, 0x57, 0x4f, 0x4d, 0x56, 0x0c,
-  0x6a, 0x09, 0x8e, 0x01, 0x05, 0x8e, 0xf7, 0xf1, 0x6a, 0x0a, 0x57, 0x4e,
-  0x4e, 0x56, 0x0c, 0x6a, 0x09, 0x8e, 0x01, 0x05, 0x8e, 0x04, 0x15, 0x6a,
-  0x0a, 0x57, 0x4e, 0x4e, 0x56, 0x0c, 0x6a, 0x09, 0x8e, 0x01, 0x05, 0x8e,
-  0x06, 0x41, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0xfe, 0x51, 0x4b,
-  0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x8f, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f,
-  0x90, 0x90, 0xfa, 0x01, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x8f,
-  0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x02, 0x29, 0x4b, 0x4b, 0x4a,
-  0x4c, 0x8f, 0x90, 0x90, 0x8f, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90,
-  0xfb, 0x98, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x00, 0x00, 0x00,
-  0x00, 0x08, 0xf9, 0x1c, 0xfd, 0xc3, 0x02, 0x7c, 0x08, 0x2d, 0x00, 0x05,
-  0x00, 0x0b, 0x00, 0x11, 0x00, 0x17, 0x00, 0x1d, 0x00, 0x23, 0x00, 0x29,
-  0x00, 0x2f, 0x00, 0x00, 0x27, 0x37, 0x17, 0x13, 0x07, 0x03, 0x01, 0x07,
-  0x27, 0x03, 0x37, 0x13, 0x01, 0x27, 0x37, 0x25, 0x17, 0x05, 0x01, 0x17,
-  0x07, 0x05, 0x27, 0x25, 0x01, 0x35, 0x33, 0x05, 0x15, 0x2d, 0x01, 0x15,
-  0x23, 0x25, 0x35, 0x05, 0x01, 0x23, 0x35, 0x13, 0x33, 0x0b, 0x01, 0x33,
-  0x15, 0x03, 0x23, 0x13, 0x60, 0x87, 0x6d, 0x64, 0x53, 0x98, 0xfb, 0xeb,
-  0x87, 0x6d, 0x64, 0x53, 0x98, 0x04, 0x9c, 0x87, 0x6e, 0x01, 0x33, 0x53,
-  0xff, 0x00, 0xfa, 0xde, 0x86, 0x6d, 0xfe, 0xcb, 0x52, 0x01, 0x00, 0x05,
-  0xbd, 0x9a, 0x01, 0x20, 0xfe, 0xe0, 0xf9, 0x7c, 0x9b, 0xfe, 0xe0, 0x01,
-  0x20, 0x03, 0xef, 0xbe, 0x94, 0x74, 0x4a, 0xbe, 0xbe, 0x93, 0x75, 0x4a,
-  0x5a, 0x96, 0x79, 0xfe, 0xa9, 0x5c, 0x01, 0x1d, 0x05, 0xb5, 0x96, 0x79,
-  0x01, 0x57, 0x5c, 0xfe, 0xe3, 0xfe, 0xf1, 0x95, 0x7a, 0x6e, 0x5b, 0xa9,
-  0xfb, 0x77, 0x96, 0x79, 0x6f, 0x5c, 0xa8, 0x02, 0x18, 0xd4, 0xa4, 0x82,
-  0x52, 0xd4, 0xd4, 0xa4, 0x82, 0x52, 0x02, 0xdf, 0xac, 0x01, 0x40, 0xfe,
-  0xc0, 0xf8, 0xc2, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x56, 0x05, 0x63, 0x07, 0x6d, 0x10, 0x26, 0x11, 0xb6, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf2, 0x04, 0x76, 0x01, 0x75, 0xff, 0xff, 0x00, 0xad,
-  0xfe, 0x56, 0x04, 0xb3, 0x06, 0x14, 0x10, 0x26, 0x11, 0xb7, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x9a, 0x00, 0x90, 0xff, 0xcc, 0x00, 0x02, 0x00, 0x1d,
-  0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00,
-  0x01, 0x15, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x23,
-  0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x01, 0x34, 0x27, 0x26, 0x23,
-  0x21, 0x11, 0x21, 0x32, 0x37, 0x36, 0x01, 0x6b, 0x01, 0x2c, 0xe2, 0xf5,
-  0xf5, 0xe2, 0xfe, 0x1e, 0x97, 0x97, 0xb6, 0x97, 0x01, 0xac, 0x47, 0x46,
-  0x93, 0xfe, 0xdd, 0x01, 0x23, 0x93, 0x46, 0x47, 0x04, 0x51, 0xe2, 0xda,
-  0xde, 0xdd, 0xda, 0x04, 0x51, 0xa4, 0xe0, 0xe0, 0xa4, 0xfd, 0x66, 0x8b,
-  0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x00, 0x00, 0x00, 0x02, 0x00, 0x22,
-  0x00, 0x00, 0x03, 0xd8, 0x05, 0x9e, 0x00, 0x0a, 0x00, 0x1e, 0x00, 0x00,
-  0x01, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x33, 0x32, 0x37, 0x36, 0x01,
-  0x11, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x21, 0x11, 0x23,
-  0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0x03, 0x27, 0x37, 0x3d, 0x73,
-  0xed, 0xed, 0x74, 0x3c, 0x37, 0xfe, 0x2c, 0xf4, 0xbb, 0x6d, 0x69, 0x69,
-  0x67, 0xc1, 0xfe, 0x67, 0x8c, 0x8c, 0xa5, 0x8e, 0x01, 0x4c, 0x5e, 0x2a,
-  0x2e, 0xfe, 0x97, 0x2e, 0x2b, 0x02, 0xdf, 0xfe, 0xca, 0x55, 0x52, 0xfe,
-  0xb0, 0x52, 0x52, 0x03, 0xd1, 0x8f, 0x01, 0x3e, 0xfe, 0xc2, 0x8f, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x65, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x1c, 0x00, 0x00, 0x01, 0x17, 0x07, 0x27, 0x06, 0x2b, 0x01, 0x11,
-  0x23, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x27, 0x36, 0x37, 0x34,
-  0x26, 0x2b, 0x01, 0x11, 0x33, 0x32, 0x37, 0x27, 0x37, 0x03, 0xe6, 0x7e,
-  0x5f, 0x84, 0x71, 0xc1, 0xe4, 0xb6, 0x01, 0x9a, 0xe2, 0x73, 0x74, 0xcb,
-  0x0b, 0x01, 0x8b, 0x7f, 0xe4, 0xe4, 0x67, 0x40, 0xc2, 0x60, 0x03, 0x23,
-  0x75, 0x7e, 0x7b, 0x53, 0xfd, 0xa8, 0x05, 0xd5, 0x71, 0x72, 0xdb, 0x92,
-  0x2d, 0x2c, 0x39, 0x86, 0x92, 0xfd, 0xcf, 0x2f, 0xb4, 0x7e, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x10,
-  0x00, 0x29, 0x00, 0x00, 0x25, 0x27, 0x37, 0x17, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x20, 0x07, 0x06, 0x10, 0x17, 0x16, 0x33, 0x32, 0x1f, 0x01, 0x07,
-  0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x11, 0x23, 0x11, 0x33, 0x15,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x02, 0xd9,
-  0x7e, 0x63, 0x7c, 0x47, 0x4a, 0x4c, 0xfe, 0xf9, 0x4b, 0x4b, 0x4b, 0x4b,
-  0x84, 0x3f, 0xfe, 0x85, 0x64, 0x86, 0x4f, 0x61, 0x6f, 0x4f, 0x50, 0x34,
-  0xa7, 0xa7, 0x34, 0x50, 0x4f, 0x6f, 0xb8, 0x72, 0x73, 0x73, 0x0b, 0x98,
-  0xa7, 0x5d, 0xa5, 0x73, 0xc5, 0xcb, 0x74, 0x73, 0x74, 0x73, 0xfe, 0x6a,
-  0x74, 0x73, 0x14, 0xae, 0x5d, 0xb3, 0x2e, 0x30, 0x31, 0x64, 0xfd, 0xae,
-  0x06, 0x0a, 0xaa, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0xfd, 0xf0, 0xa2, 0x0f,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x07, 0x07, 0x00, 0x07,
-  0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0xb5, 0x02,
-  0xab, 0x99, 0xfd, 0x72, 0x05, 0xd5, 0x01, 0x32, 0xfe, 0x24, 0xfa, 0xd5,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x6f, 0x05, 0x9a, 0x00, 0x07,
-  0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0xa7, 0x02,
-  0x43, 0x84, 0xfd, 0xdf, 0x04, 0x60, 0x01, 0x3a, 0xfe, 0x33, 0xfc, 0x33,
-  0x00, 0x01, 0x00, 0x3f, 0x00, 0x00, 0x04, 0x71, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x21, 0x11, 0x23, 0x35, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x01, 0x2d, 0xed, 0xed, 0x03, 0x44, 0xfd, 0x71,
-  0x01, 0xed, 0xfe, 0x13, 0x02, 0x94, 0xaa, 0x02, 0x97, 0xaa, 0xfe, 0x13,
-  0xaa, 0xfd, 0x6c, 0x00, 0x00, 0x01, 0x00, 0x32, 0x00, 0x00, 0x03, 0xe7,
-  0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x21, 0x11, 0x23, 0x35, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x1f, 0xed, 0xed,
-  0x02, 0xc7, 0xfd, 0xdf, 0x01, 0x76, 0xfe, 0x8a, 0x01, 0xf4, 0xaa, 0x01,
-  0xc2, 0x9d, 0xfe, 0xdb, 0xaa, 0xfe, 0x0c, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0xfe, 0x66, 0x04, 0x52, 0x05, 0xd5, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11,
-  0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34,
-  0x26, 0x23, 0x01, 0x6b, 0xb6, 0x03, 0x44, 0xfd, 0x72, 0x01, 0x77, 0xa7,
-  0x66, 0x62, 0xb7, 0xce, 0x44, 0x38, 0x78, 0x33, 0x31, 0x6f, 0x70, 0x02,
-  0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xaa, 0xfe, 0x46, 0x77, 0x72, 0xee, 0xfe,
-  0xce, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b, 0xc2, 0x01, 0x22, 0x9f, 0x9e,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xa4, 0x04, 0x60, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x32,
-  0x17, 0x16, 0x15, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x11, 0x34, 0x27, 0x26, 0x23, 0x01, 0x4d, 0xa6, 0x02,
-  0xc7, 0xfd, 0xdf, 0xe1, 0xed, 0x3f, 0x4a, 0x4a, 0x49, 0xa3, 0xae, 0x9b,
-  0x63, 0x1e, 0x22, 0x22, 0x2c, 0x79, 0x01, 0xe7, 0xfe, 0x19, 0x04, 0x60,
-  0xaa, 0xfe, 0xc1, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd6, 0x60, 0x60, 0x9c,
-  0x30, 0x37, 0x93, 0x01, 0x08, 0xaa, 0x20, 0x29, 0x00, 0x01, 0x00, 0x24,
-  0xfe, 0xbf, 0x07, 0xb6, 0x05, 0xd5, 0x00, 0x17, 0x00, 0x00, 0x01, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x03,
-  0x11, 0x23, 0x11, 0x03, 0x01, 0x23, 0x09, 0x01, 0x33, 0x01, 0x03, 0x86,
-  0xb6, 0x02, 0x65, 0xdd, 0xfe, 0x15, 0x01, 0xa8, 0x7b, 0xb2, 0x24, 0xfe,
-  0x44, 0xe8, 0xb6, 0xe8, 0xfe, 0x44, 0xbe, 0x02, 0x0a, 0xfe, 0x16, 0xdc,
-  0x02, 0x66, 0x05, 0xd5, 0xfd, 0x1e, 0x02, 0xe2, 0xfd, 0xb3, 0xfd, 0x22,
-  0xfe, 0x15, 0x01, 0x41, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x01, 0xea,
-  0x01, 0x17, 0xfc, 0xff, 0x03, 0x88, 0x02, 0x4d, 0xfd, 0x1e, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x3f, 0xfe, 0xe5, 0x06, 0x50, 0x04, 0x60, 0x00, 0x17,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23,
-  0x11, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x27, 0x01, 0x23, 0x09, 0x01,
-  0x33, 0x01, 0x02, 0xec, 0xa5, 0x01, 0xb8, 0xc0, 0xfe, 0x97, 0x01, 0x42,
-  0x6e, 0xa6, 0x1e, 0xfe, 0xad, 0xa8, 0xa5, 0xa8, 0xfe, 0xac, 0xb1, 0x01,
-  0x9e, 0xfe, 0x96, 0xc1, 0x01, 0xb8, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e,
-  0xfe, 0x51, 0xfd, 0xe8, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x36, 0xc9, 0xfe,
-  0x93, 0x01, 0x6d, 0xc9, 0xfd, 0xca, 0x02, 0xb1, 0x01, 0xaf, 0xfd, 0xf2,
-  0xff, 0xff, 0x00, 0x79, 0xfe, 0x75, 0x04, 0x25, 0x05, 0xf0, 0x10, 0x26,
-  0x00, 0x7a, 0x33, 0x00, 0x12, 0x06, 0x03, 0xab, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x77, 0xfe, 0x75, 0x03, 0x68, 0x04, 0x7c, 0x10, 0x26,
-  0x00, 0x7a, 0xd3, 0x00, 0x12, 0x06, 0x03, 0xcb, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x22, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23,
-  0x11, 0x23, 0x01, 0x03, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x89, 0xea, 0xfd,
-  0xf8, 0x01, 0xbc, 0x90, 0xb1, 0x3e, 0xfe, 0x2d, 0xf5, 0xb6, 0x05, 0xd5,
-  0xfd, 0x1e, 0x02, 0xe2, 0xfd, 0xb2, 0xfd, 0x23, 0xfe, 0x15, 0x01, 0x41,
-  0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xfe, 0xe5, 0x04, 0x3b, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x07,
-  0x11, 0x23, 0xa7, 0xa5, 0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0x52, 0x80,
-  0xa6, 0x32, 0xfe, 0x9a, 0xb1, 0xa5, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e,
-  0xfe, 0x4f, 0xfd, 0xea, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x35, 0xc8, 0xfe,
-  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xf9,
-  0x05, 0xd5, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33, 0x11, 0x37, 0x11, 0x33,
-  0x15, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x11, 0x07, 0x11,
-  0x23, 0xb5, 0xb6, 0x9b, 0x5a, 0x01, 0x94, 0xea, 0xfd, 0xf8, 0x02, 0x23,
-  0xc6, 0xfe, 0x2d, 0x5a, 0x9b, 0xb6, 0x05, 0xd5, 0xfd, 0x1e, 0xb1, 0x01,
-  0x54, 0xee, 0x01, 0xcb, 0xfd, 0xb2, 0xfc, 0x79, 0x03, 0x01, 0xfe, 0x25,
-  0x01, 0x75, 0xb1, 0xfe, 0x16, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x1d, 0x04, 0x60, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x37, 0x35, 0x33, 0x15, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
-  0x23, 0x35, 0x07, 0x11, 0x23, 0xa7, 0xa5, 0x56, 0x5b, 0x01, 0x22, 0xcc,
-  0xfe, 0x7e, 0x01, 0xb3, 0xb9, 0xfe, 0x9a, 0x5b, 0x56, 0xa5, 0x04, 0x60,
-  0xfd, 0xf2, 0x61, 0xdd, 0x76, 0x01, 0x46, 0xfe, 0x4f, 0xfd, 0x51, 0x02,
-  0x35, 0xfe, 0xc5, 0xd4, 0x61, 0xfe, 0x93, 0x00, 0x00, 0x01, 0x00, 0x1d,
-  0x00, 0x00, 0x04, 0xf9, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
-  0x15, 0x33, 0x15, 0x23, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x03,
-  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0x97, 0x97, 0x02, 0x89,
-  0xea, 0xfd, 0xf8, 0x02, 0x23, 0xc6, 0xfe, 0x2d, 0xf5, 0xb6, 0x97, 0x97,
-  0x05, 0xd5, 0xe0, 0x90, 0xfe, 0x8e, 0x02, 0xe2, 0xfd, 0xb2, 0xfc, 0x79,
-  0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x04, 0x65, 0x90, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x1d, 0x06, 0x14, 0x00, 0x13,
-  0x00, 0x00, 0x13, 0x33, 0x15, 0x21, 0x15, 0x21, 0x11, 0x01, 0x33, 0x09,
-  0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xa7, 0xa5,
-  0x01, 0x40, 0xfe, 0xc0, 0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0xb3, 0xb9,
-  0xfe, 0x9a, 0xb1, 0xa5, 0x70, 0x70, 0x06, 0x14, 0x7a, 0x7d, 0xfd, 0x35,
-  0x02, 0x0e, 0xfe, 0x4f, 0xfd, 0x51, 0x02, 0x35, 0xc8, 0xfe, 0x93, 0x05,
-  0x1d, 0x7d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2d, 0x00, 0x00, 0x06, 0x07,
-  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x21, 0x11, 0x01, 0x33, 0x09,
-  0x01, 0x23, 0x01, 0x03, 0x11, 0x23, 0x11, 0x21, 0x2d, 0x02, 0x4c, 0x02,
-  0x89, 0xea, 0xfd, 0xf8, 0x02, 0x23, 0xc6, 0xfe, 0x2d, 0xf5, 0xb6, 0xfe,
-  0x6a, 0x05, 0xd5, 0xfd, 0x1e, 0x02, 0xe2, 0xfd, 0xb2, 0xfc, 0x79, 0x03,
-  0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x05, 0x2b, 0x00, 0x00, 0x01, 0x00, 0x25,
-  0x00, 0x00, 0x04, 0xf5, 0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x21,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x21,
-  0x26, 0x01, 0xff, 0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0xb3, 0xb9, 0xfe,
-  0x9a, 0xb1, 0xa5, 0xfe, 0xa6, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e, 0xfe,
-  0x4f, 0xfd, 0x51, 0x02, 0x35, 0xc8, 0xfe, 0x93, 0x03, 0xc6, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x6a, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23,
-  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x94, 0xb6, 0xb5,
-  0xb5, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfa,
-  0xd5, 0xfe, 0x15, 0x01, 0x41, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0xfe, 0xe5, 0x04, 0xba, 0x04, 0x60, 0x00, 0x0f,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23,
-  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xae, 0xa5, 0x02, 0x1b, 0xa6, 0xa6,
-  0xa6, 0xa6, 0xfd, 0xe5, 0xa5, 0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0xfc,
-  0x39, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x04, 0xfd, 0xfc, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x07, 0x44, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x94, 0x03, 0x44, 0xfd, 0x72,
-  0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xaa, 0xfa,
-  0xd5, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad,
-  0x00, 0x00, 0x06, 0x36, 0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23,
-  0xae, 0xa5, 0x02, 0x1b, 0x02, 0xc7, 0xfd, 0xdf, 0xa6, 0xfd, 0xe5, 0xa5,
-  0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0xaa, 0xfc, 0x4a, 0x02, 0x04, 0xfd,
-  0xfc, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x07, 0x9c,
-  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x21, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23,
-  0x04, 0xb5, 0xb6, 0xfd, 0x6c, 0xb6, 0x04, 0x00, 0x01, 0x77, 0xa8, 0x66,
-  0x62, 0xb8, 0xcd, 0x45, 0x38, 0x79, 0x32, 0x32, 0x70, 0x6f, 0x02, 0xc7,
-  0xfd, 0x39, 0x05, 0x2b, 0xfa, 0xd5, 0x05, 0xd5, 0xfd, 0x9c, 0x77, 0x72,
-  0xee, 0xfe, 0xce, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b, 0xc2, 0x01, 0x22,
-  0x9f, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x06, 0x6b,
-  0x04, 0x60, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x21, 0x11, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x14, 0x07,
-  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x27,
-  0x26, 0x07, 0x04, 0x14, 0xa6, 0xfd, 0xe5, 0xa5, 0x03, 0x66, 0xe1, 0xed,
-  0x3f, 0x49, 0x49, 0x49, 0xa3, 0xae, 0x9b, 0x63, 0x1e, 0x22, 0x22, 0x2c,
-  0x79, 0x01, 0xe7, 0xfe, 0x19, 0x03, 0xc6, 0xfc, 0x3a, 0x04, 0x60, 0xfe,
-  0x17, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x37,
-  0x93, 0x01, 0x08, 0xa4, 0x26, 0x2e, 0x05, 0x00, 0x00, 0x02, 0x00, 0x67,
-  0xff, 0xe3, 0x06, 0x45, 0x05, 0xf1, 0x00, 0x41, 0x00, 0x59, 0x00, 0x00,
-  0x25, 0x2e, 0x03, 0x35, 0x34, 0x3e, 0x04, 0x33, 0x32, 0x1e, 0x04, 0x15,
-  0x14, 0x0e, 0x02, 0x07, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
-  0x01, 0x23, 0x22, 0x2e, 0x02, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01,
-  0x02, 0x35, 0x34, 0x12, 0x3e, 0x01, 0x37, 0x15, 0x0e, 0x03, 0x15, 0x14,
-  0x1e, 0x02, 0x33, 0x32, 0x36, 0x37, 0x3e, 0x03, 0x35, 0x34, 0x2e, 0x04,
-  0x23, 0x22, 0x0e, 0x04, 0x15, 0x14, 0x1e, 0x02, 0x03, 0xc0, 0x33, 0x61,
-  0x4a, 0x2d, 0x11, 0x26, 0x3d, 0x57, 0x74, 0x4b, 0x46, 0x71, 0x57, 0x3f,
-  0x29, 0x13, 0x18, 0x38, 0x60, 0x49, 0x22, 0x5e, 0x35, 0x38, 0x5b, 0x2e,
-  0x2a, 0x6c, 0x37, 0x22, 0x49, 0x4c, 0x4f, 0x26, 0x3c, 0xaf, 0x6d, 0x99,
-  0xf1, 0xa9, 0x59, 0x51, 0x9b, 0xde, 0x8e, 0x68, 0x9a, 0x64, 0x33, 0x36,
-  0x6f, 0xab, 0x74, 0x4a, 0x73, 0x9f, 0x39, 0x4b, 0x2b, 0x12, 0x0a, 0x15,
-  0x20, 0x2b, 0x38, 0x22, 0x2c, 0x41, 0x2e, 0x1e, 0x10, 0x06, 0x24, 0x3b,
-  0x4c, 0xae, 0x31, 0x89, 0xaa, 0xc4, 0x6b, 0x42, 0x8a, 0x83, 0x74, 0x57,
-  0x32, 0x32, 0x54, 0x70, 0x7b, 0x7f, 0x3a, 0x53, 0xb4, 0xb2, 0xaa, 0x4a,
-  0x1a, 0x15, 0x13, 0x1a, 0xa8, 0x17, 0x12, 0x08, 0x14, 0x23, 0x1b, 0x26,
-  0x34, 0x74, 0xcf, 0x01, 0x1d, 0xa8, 0xa0, 0x01, 0x10, 0xcb, 0x7d, 0x0e,
-  0xa7, 0x16, 0x66, 0x9a, 0xcd, 0x7c, 0x7d, 0xde, 0xa7, 0x62, 0x19, 0x6d,
-  0x3a, 0x86, 0x8e, 0x91, 0x45, 0x2f, 0x66, 0x63, 0x59, 0x43, 0x28, 0x2b,
-  0x47, 0x5b, 0x60, 0x5f, 0x26, 0x62, 0xab, 0x8e, 0x6e, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0xec, 0x04, 0x7a, 0x00, 0x3f,
-  0x00, 0x50, 0x00, 0x00, 0x13, 0x34, 0x3e, 0x02, 0x37, 0x15, 0x0e, 0x03,
-  0x15, 0x14, 0x1e, 0x02, 0x33, 0x32, 0x36, 0x37, 0x2e, 0x03, 0x35, 0x34,
-  0x3e, 0x02, 0x33, 0x32, 0x1e, 0x02, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01,
-  0x33, 0x32, 0x3e, 0x02, 0x37, 0x15, 0x0e, 0x03, 0x23, 0x22, 0x26, 0x27,
-  0x0e, 0x03, 0x23, 0x22, 0x2e, 0x02, 0x05, 0x3e, 0x03, 0x35, 0x34, 0x2e,
-  0x02, 0x23, 0x22, 0x0e, 0x02, 0x15, 0x14, 0x66, 0x43, 0x81, 0xbc, 0x79,
-  0x54, 0x7c, 0x52, 0x29, 0x2d, 0x57, 0x7c, 0x4f, 0x23, 0x4e, 0x19, 0x21,
-  0x38, 0x2b, 0x18, 0x24, 0x48, 0x69, 0x45, 0x3b, 0x65, 0x48, 0x29, 0x53,
-  0x56, 0x20, 0x3d, 0x1b, 0x18, 0x29, 0x25, 0x25, 0x16, 0x0f, 0x22, 0x28,
-  0x33, 0x21, 0x31, 0x75, 0x3d, 0x1b, 0x3f, 0x41, 0x40, 0x1c, 0x7a, 0xbe,
-  0x83, 0x44, 0x03, 0x00, 0x1f, 0x28, 0x18, 0x0a, 0x14, 0x1e, 0x24, 0x10,
-  0x17, 0x28, 0x1e, 0x11, 0x02, 0x28, 0x83, 0xd8, 0x9c, 0x58, 0x03, 0x9b,
-  0x06, 0x46, 0x72, 0x98, 0x58, 0x62, 0xa0, 0x72, 0x3e, 0x0b, 0x11, 0x25,
-  0x67, 0x78, 0x82, 0x40, 0x5d, 0x9f, 0x73, 0x41, 0x39, 0x68, 0x92, 0x59,
-  0x9b, 0xf1, 0x5e, 0x13, 0x0a, 0x04, 0x0a, 0x13, 0x0f, 0x9d, 0x0a, 0x11,
-  0x0c, 0x07, 0x1c, 0x2c, 0x12, 0x1b, 0x12, 0x09, 0x54, 0x99, 0xd6, 0xb8,
-  0x26, 0x5e, 0x64, 0x63, 0x2b, 0x4b, 0x69, 0x42, 0x1f, 0x26, 0x48, 0x69,
-  0x43, 0xf7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xfe, 0x75, 0x04, 0xa4,
-  0x05, 0xf0, 0x10, 0x27, 0x00, 0x7a, 0x01, 0x0f, 0x00, 0x00, 0x12, 0x06,
-  0x03, 0xb5, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x03, 0x84,
-  0x04, 0x7b, 0x10, 0x27, 0x00, 0x7a, 0x00, 0x81, 0x00, 0x00, 0x12, 0x06,
-  0x03, 0xd5, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0xfe, 0xbf, 0x04, 0x6c,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23,
-  0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x02, 0x8e, 0xb5, 0xb5, 0xb6, 0xfe,
-  0x23, 0x04, 0x70, 0xfe, 0x23, 0xaa, 0xfe, 0x15, 0x01, 0x41, 0x05, 0x2b,
-  0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36, 0xfe, 0xe5, 0x03, 0xfc,
-  0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23,
-  0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x02, 0x6a, 0xa6, 0xa6, 0xa3, 0xfe,
-  0x6f, 0x03, 0xc6, 0xfe, 0x6e, 0x99, 0xfe, 0x4c, 0x01, 0x1b, 0x03, 0xb6,
-  0xaa, 0xaa, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x08, 0x00, 0x00, 0x25, 0x11,
-  0x23, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x02, 0x7e, 0xaf, 0xfe, 0x68,
-  0xaf, 0x01, 0x3b, 0x01, 0x3b, 0xb0, 0x12, 0xfe, 0x44, 0x01, 0xbc, 0x04,
-  0x4e, 0xfc, 0x94, 0x03, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfc,
-  0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x00, 0x10, 0x00, 0x00, 0x01, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x01, 0x33, 0x09, 0x01, 0x33,
-  0x01, 0x15, 0x33, 0x03, 0x7c, 0xee, 0xb6, 0xed, 0xed, 0xfe, 0x24, 0xc4,
-  0x01, 0x74, 0x01, 0x72, 0xc4, 0xfe, 0x24, 0xee, 0x01, 0x73, 0xfe, 0x8d,
-  0x01, 0x73, 0xaa, 0xaa, 0x03, 0x0e, 0xfd, 0x9a, 0x02, 0x66, 0xfc, 0xf2,
-  0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x04, 0x60, 0x00, 0x10, 0x00, 0x00, 0x09, 0x01, 0x15, 0x33, 0x15, 0x23,
-  0x15, 0x23, 0x35, 0x23, 0x35, 0x33, 0x35, 0x01, 0x33, 0x09, 0x01, 0x04,
-  0x0c, 0xfe, 0x72, 0xec, 0xec, 0xaf, 0xf6, 0xf6, 0xfe, 0x68, 0xaf, 0x01,
-  0x3b, 0x01, 0x3b, 0x04, 0x60, 0xfb, 0xb2, 0x58, 0xaa, 0xba, 0xba, 0xaa,
-  0x58, 0x04, 0x4e, 0xfc, 0x94, 0x03, 0x6c, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0xfe, 0xbf, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x33,
-  0x11, 0x23, 0x11, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01,
-  0x33, 0x01, 0x04, 0x50, 0x65, 0xb1, 0x12, 0xfe, 0x86, 0xfe, 0x83, 0xc4,
-  0x01, 0xe0, 0xfe, 0x5d, 0xc3, 0x01, 0x4e, 0x01, 0x50, 0xc3, 0xfe, 0x50,
-  0xaa, 0xfe, 0x15, 0x01, 0x41, 0x02, 0x7b, 0xfd, 0x85, 0x03, 0x1d, 0x02,
-  0xb8, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x33, 0x00, 0x00, 0x01, 0x00, 0x35,
-  0xfe, 0xe5, 0x04, 0x07, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x33,
-  0x11, 0x23, 0x11, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01,
-  0x33, 0x01, 0x03, 0xa1, 0x65, 0xa5, 0x1e, 0xfe, 0xdb, 0xfe, 0xda, 0xc3,
-  0x01, 0x88, 0xfe, 0x99, 0xc4, 0x01, 0x0b, 0x01, 0x0b, 0xc4, 0xfe, 0x93,
-  0x99, 0xfe, 0x4c, 0x01, 0x1b, 0x01, 0xb8, 0xfe, 0x48, 0x02, 0x4a, 0x02,
-  0x16, 0xfe, 0x71, 0x01, 0x8f, 0xfd, 0xdf, 0x00, 0x00, 0x01, 0xff, 0xfa,
-  0xfe, 0xbf, 0x06, 0x8d, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21,
-  0x15, 0x21, 0x02, 0x8d, 0x02, 0x95, 0xb6, 0xb5, 0xb5, 0xfc, 0x00, 0xfe,
-  0x23, 0x04, 0x70, 0xfe, 0x23, 0xaa, 0x05, 0x2b, 0xfa, 0xd5, 0xfe, 0x15,
-  0x01, 0x41, 0x05, 0x2b, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04,
-  0xfe, 0xe5, 0x05, 0xa2, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21,
-  0x15, 0x21, 0x02, 0x39, 0x02, 0x1e, 0xa5, 0xa6, 0xa6, 0xfc, 0x9a, 0xfe,
-  0x6e, 0x03, 0xc6, 0xfe, 0x6f, 0x99, 0x03, 0xc7, 0xfc, 0x39, 0xfe, 0x4c,
-  0x01, 0x1b, 0x03, 0xb6, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0xfe, 0xbf, 0x04, 0xf0, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x25, 0x33,
-  0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33,
-  0x11, 0x14, 0x16, 0x33, 0x21, 0x11, 0x33, 0x04, 0x3b, 0xb5, 0xb5, 0xb7,
-  0xfe, 0x89, 0xa8, 0x65, 0x62, 0xb4, 0x70, 0x70, 0x01, 0x52, 0xb7, 0xaa,
-  0xfe, 0x15, 0x01, 0x41, 0x02, 0xc7, 0x77, 0x72, 0xee, 0x01, 0x37, 0xfe,
-  0xd9, 0x9f, 0x9e, 0x02, 0x64, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87,
-  0xfe, 0xe5, 0x04, 0x40, 0x04, 0x60, 0x00, 0x15, 0x00, 0x00, 0x25, 0x33,
-  0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x33,
-  0x15, 0x14, 0x17, 0x16, 0x33, 0x21, 0x11, 0x33, 0x03, 0x9a, 0xa5, 0xa5,
-  0xa6, 0xfe, 0xcb, 0x89, 0x5c, 0x53, 0xa6, 0x2e, 0x30, 0x5e, 0x01, 0x0b,
-  0xa6, 0x99, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x09, 0x5f, 0x56, 0xb8, 0xea,
-  0xd3, 0x75, 0x3b, 0x3b, 0x01, 0xbe, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0x00, 0x00, 0x04, 0x3b, 0x05, 0xd5, 0x00, 0x18, 0x00, 0x00, 0x01, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x11,
-  0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x02,
-  0x42, 0x35, 0xa8, 0x65, 0x62, 0xb4, 0x70, 0x70, 0x10, 0x81, 0xc1, 0xb7,
-  0xb7, 0xc1, 0x81, 0x02, 0xc7, 0x77, 0x72, 0xee, 0x01, 0x37, 0xfe, 0xd9,
-  0x9f, 0x9e, 0x01, 0x39, 0xfe, 0xc7, 0x02, 0x64, 0xfa, 0x2b, 0x02, 0xc7,
-  0xfe, 0xcf, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0x9a,
-  0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x33, 0x11,
-  0x33, 0x11, 0x23, 0x11, 0x23, 0x15, 0x23, 0x35, 0x23, 0x22, 0x27, 0x26,
-  0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x01, 0xc6, 0x90, 0x9e, 0xa6,
-  0xa6, 0x9e, 0x90, 0x07, 0x89, 0x5c, 0x53, 0xa6, 0x2e, 0x27, 0x02, 0xa4,
-  0xc2, 0xc4, 0x01, 0xbe, 0xfb, 0xa0, 0x02, 0x09, 0xc4, 0xc4, 0x5f, 0x56,
-  0xb8, 0xea, 0xd3, 0x75, 0x3b, 0x30, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0x00, 0x00, 0x04, 0x3b, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11,
-  0x23, 0x11, 0x01, 0x54, 0x01, 0x78, 0xa7, 0xc8, 0xb5, 0x70, 0x6f, 0xfe,
-  0xad, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0xe9, 0xee, 0xfe, 0x66, 0x01, 0x8a,
-  0x9f, 0x9e, 0xfd, 0x39, 0x05, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x12, 0xff, 0xe3, 0x06, 0x5f, 0x05, 0xf0, 0x00, 0x22,
-  0x00, 0x2a, 0x00, 0x00, 0x01, 0x12, 0x37, 0x36, 0x21, 0x20, 0x17, 0x16,
-  0x13, 0x21, 0x10, 0x12, 0x33, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06,
-  0x23, 0x20, 0x27, 0x26, 0x03, 0x06, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15,
-  0x14, 0x17, 0x16, 0x25, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x01,
-  0x87, 0x1e, 0x87, 0xa9, 0x01, 0x1b, 0x01, 0x23, 0xa3, 0xa8, 0x01, 0xfb,
-  0xe5, 0xf6, 0xf7, 0x7d, 0xe3, 0x65, 0x64, 0x76, 0x77, 0x83, 0xfe, 0xc4,
-  0xb1, 0xa9, 0x09, 0x99, 0x6a, 0x6e, 0x99, 0x43, 0x3c, 0x01, 0x20, 0x03,
-  0x4f, 0x16, 0x58, 0x75, 0xfe, 0x74, 0x73, 0x57, 0x03, 0x6d, 0x01, 0x0a,
-  0xa7, 0xd2, 0xd2, 0xdb, 0xfe, 0x84, 0xfe, 0xf4, 0xfe, 0xce, 0x60, 0x5f,
-  0xd7, 0x46, 0x24, 0x24, 0xcd, 0xc2, 0x01, 0x55, 0x01, 0x67, 0x6b, 0xdf,
-  0x4c, 0x3e, 0xa0, 0x41, 0x39, 0x02, 0xbf, 0x7c, 0xa4, 0xa4, 0x7c, 0x00,
-  0x00, 0x02, 0x00, 0x0d, 0xff, 0xe3, 0x04, 0xdc, 0x04, 0x7b, 0x00, 0x25,
-  0x00, 0x2e, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1d,
-  0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x01, 0x36, 0x82, 0x50, 0x56, 0x8c, 0x2b, 0x33, 0x43,
-  0x17, 0x69, 0x83, 0xe6, 0xcb, 0x76, 0x77, 0xfd, 0x06, 0x0b, 0x5c, 0x5d,
-  0xa4, 0x60, 0x5a, 0x59, 0x58, 0x5d, 0x5a, 0x63, 0x5b, 0xf2, 0x8c, 0x85,
-  0x02, 0xf9, 0x02, 0x49, 0x4b, 0x7a, 0x8b, 0x54, 0x53, 0x0c, 0x02, 0x04,
-  0x52, 0x5a, 0xac, 0x46, 0x31, 0x97, 0x21, 0x26, 0xc5, 0x82, 0xa1, 0x91,
-  0x92, 0xfa, 0x5a, 0xbe, 0x64, 0x63, 0x1a, 0x1a, 0x34, 0xae, 0x2c, 0x14,
-  0x16, 0x9c, 0x94, 0x01, 0x81, 0x97, 0x5a, 0x5a, 0x57, 0x57, 0x9e, 0x00,
-  0x00, 0x02, 0x00, 0x12, 0xfe, 0x87, 0x06, 0x5f, 0x05, 0xf0, 0x00, 0x07,
-  0x00, 0x2d, 0x00, 0x00, 0x01, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06,
-  0x07, 0x12, 0x37, 0x36, 0x21, 0x20, 0x17, 0x16, 0x13, 0x21, 0x10, 0x12,
-  0x33, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23, 0x11,
-  0x26, 0x27, 0x26, 0x03, 0x06, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15, 0x14,
-  0x17, 0x16, 0x02, 0x4a, 0x03, 0x4f, 0x16, 0x58, 0x75, 0xfe, 0x74, 0x73,
-  0x57, 0xd9, 0x1e, 0x87, 0xa9, 0x01, 0x1b, 0x01, 0x23, 0xa3, 0xa8, 0x01,
-  0xfb, 0xe5, 0xf6, 0xf7, 0x7d, 0xe3, 0x65, 0x64, 0x76, 0x62, 0x6c, 0xa0,
-  0xe9, 0x90, 0xa9, 0x09, 0x99, 0x6a, 0x6e, 0x99, 0x43, 0x3c, 0x03, 0x6d,
-  0xbf, 0x7c, 0xa4, 0xa4, 0x7c, 0xbf, 0x01, 0x0a, 0xa7, 0xd2, 0xd2, 0xdb,
-  0xfe, 0x84, 0xfe, 0xf4, 0xfe, 0xce, 0x60, 0x5f, 0xd7, 0x46, 0x24, 0x1e,
-  0x05, 0xfe, 0xa3, 0x01, 0x63, 0x20, 0xa6, 0xc3, 0x01, 0x54, 0x01, 0x67,
-  0x6b, 0xdf, 0x4c, 0x3e, 0xa0, 0x41, 0x39, 0x00, 0x00, 0x02, 0x00, 0x0d,
-  0xfe, 0xb7, 0x04, 0xdc, 0x04, 0x7b, 0x00, 0x08, 0x00, 0x31, 0x00, 0x00,
-  0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x22, 0x27,
-  0x26, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23, 0x11, 0x26,
-  0x27, 0x26, 0x04, 0x36, 0x02, 0x49, 0x4b, 0x7a, 0x8b, 0x54, 0x53, 0x0c,
-  0xb2, 0x82, 0x50, 0x56, 0x8c, 0x2b, 0x33, 0x43, 0x17, 0x69, 0x83, 0xe6,
-  0xcb, 0x76, 0x77, 0xfd, 0x06, 0x0b, 0x5c, 0x5d, 0xa4, 0x60, 0x5a, 0x59,
-  0x58, 0x5d, 0x5a, 0x47, 0x42, 0x96, 0xae, 0x6f, 0x85, 0x02, 0x94, 0x97,
-  0x5a, 0x5a, 0x57, 0x57, 0x9e, 0x8f, 0x52, 0x5a, 0xac, 0x46, 0x31, 0x97,
-  0x21, 0x26, 0xc5, 0x82, 0xa1, 0x91, 0x92, 0xfa, 0x5a, 0xbe, 0x64, 0x63,
-  0x1a, 0x1a, 0x34, 0xae, 0x2c, 0x14, 0x10, 0x04, 0xfe, 0xd2, 0x01, 0x33,
-  0x1a, 0x7b, 0x94, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6b,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x24,
-  0x00, 0x00, 0x07, 0x9e, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x05, 0xb8,
-  0x01, 0x75, 0x12, 0x06, 0x03, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f,
-  0x00, 0x00, 0x06, 0x3e, 0x06, 0x48, 0x10, 0x27, 0x02, 0x9a, 0x01, 0x7e,
-  0x00, 0x00, 0x12, 0x06, 0x03, 0xca, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0xfe, 0x66, 0x04, 0xb0, 0x05, 0xd5, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11, 0x33,
-  0x11, 0x01, 0x33, 0x02, 0x65, 0x7d, 0xa7, 0x66, 0x62, 0xb7, 0xce, 0x44,
-  0x38, 0x78, 0x33, 0x31, 0x6f, 0x70, 0xfe, 0xae, 0xb6, 0xb6, 0x02, 0x5b,
-  0xea, 0x03, 0x71, 0x77, 0x72, 0xee, 0xfe, 0xce, 0xfe, 0xf2, 0xf4, 0xaa,
-  0x4b, 0x4b, 0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x05, 0xd5, 0xfd,
-  0x89, 0x02, 0x77, 0x00, 0x00, 0x01, 0x00, 0xab, 0xfe, 0x56, 0x04, 0x14,
-  0x04, 0x60, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01,
-  0x33, 0x02, 0x21, 0x12, 0xeb, 0x41, 0x4a, 0x4a, 0x49, 0xa3, 0xad, 0x9a,
-  0x63, 0x1e, 0x22, 0x22, 0x27, 0x7e, 0xea, 0xa6, 0xa6, 0x01, 0xee, 0xd4,
-  0x02, 0x77, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd6, 0x60, 0x60, 0x9c, 0x30,
-  0x37, 0x93, 0x01, 0x08, 0xa6, 0x24, 0x29, 0xfe, 0x19, 0x04, 0x60, 0xfe,
-  0x1d, 0x01, 0xe3, 0x00, 0x00, 0x01, 0x00, 0x30, 0xfe, 0x56, 0x05, 0x6a,
-  0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x15, 0x10,
-  0x03, 0x06, 0x05, 0x35, 0x36, 0x37, 0x12, 0x19, 0x01, 0x21, 0x11, 0x33,
-  0x15, 0x01, 0x23, 0x04, 0xb4, 0xb6, 0xfe, 0x4c, 0x77, 0x58, 0xfe, 0xb6,
-  0xbe, 0x3d, 0x69, 0x03, 0x1f, 0xb5, 0xfe, 0xb7, 0x79, 0x05, 0x2b, 0xd4,
-  0xfe, 0x18, 0xfe, 0xaa, 0xfd, 0x38, 0xa7, 0x2e, 0xa8, 0x01, 0x25, 0x02,
-  0x35, 0x01, 0x1a, 0xfa, 0xd5, 0xaa, 0xfe, 0x56, 0x00, 0x01, 0x00, 0x29,
-  0xfe, 0x56, 0x04, 0xa7, 0x04, 0x60, 0x00, 0x14, 0x00, 0x00, 0x25, 0x33,
-  0x15, 0x01, 0x23, 0x13, 0x23, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x05,
-  0x35, 0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x04, 0x01, 0xa6, 0xfe, 0xfb,
-  0x6f, 0xce, 0xa5, 0xfe, 0xa1, 0x6a, 0x54, 0xfe, 0xea, 0xa1, 0x36, 0x58,
-  0x02, 0xa9, 0x99, 0x99, 0xfe, 0x56, 0x01, 0xaa, 0x03, 0xc7, 0x86, 0xfe,
-  0x92, 0xfe, 0xfc, 0xcf, 0x1d, 0x99, 0x1b, 0x7f, 0xcf, 0x01, 0xa7, 0xd4,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x14,
-  0x00, 0x00, 0x25, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x03,
-  0xff, 0xfd, 0x6c, 0xb6, 0xb6, 0x02, 0x94, 0xb6, 0xb9, 0xcd, 0x44, 0x38,
-  0x78, 0x33, 0x31, 0x68, 0x02, 0x5f, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c,
-  0x02, 0x64, 0xfa, 0x93, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x04, 0x14, 0x04, 0x60, 0x00, 0x15,
-  0x00, 0x00, 0x05, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
-  0x03, 0x6e, 0xfd, 0xe5, 0xa5, 0xa5, 0x02, 0x1b, 0xa6, 0x4a, 0x49, 0xa3,
-  0xad, 0x9b, 0x62, 0x1e, 0x22, 0x14, 0x02, 0x18, 0xfd, 0xfc, 0x04, 0x60,
-  0xfe, 0x33, 0x01, 0xcd, 0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x37,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x05, 0x6a, 0x05, 0xd5, 0x00, 0x10,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0xb5, 0xb6, 0xfd, 0x6c,
-  0xb6, 0xb6, 0x02, 0x94, 0xb6, 0xb5, 0xfe, 0xb7, 0x79, 0x02, 0xc7, 0xfd,
-  0x39, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfa, 0xd5, 0xaa, 0xfe, 0x56,
-  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x04, 0xba, 0x04, 0x60, 0x00, 0x10,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0x14, 0xa6, 0xfd, 0xe5,
-  0xa5, 0xa5, 0x02, 0x1b, 0xa6, 0xa6, 0xfe, 0xfb, 0x6f, 0x02, 0x04, 0xfd,
-  0xfc, 0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0xfc, 0x39, 0x99, 0xfe, 0x56,
-  0x00, 0x01, 0x00, 0x9d, 0xfe, 0xbf, 0x04, 0x3b, 0x05, 0xd5, 0x00, 0x14,
-  0x00, 0x00, 0x25, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11,
-  0x14, 0x16, 0x33, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x03,
-  0x84, 0xfe, 0x89, 0xa8, 0x65, 0x62, 0xb4, 0x70, 0x70, 0x01, 0x52, 0xb7,
-  0xb7, 0xb5, 0xaa, 0x02, 0x1d, 0x77, 0x72, 0xee, 0x01, 0x37, 0xfe, 0xd9,
-  0x9f, 0x9e, 0x02, 0x64, 0xfa, 0x2b, 0xfe, 0xbf, 0x01, 0xeb, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x87, 0xfe, 0xe5, 0x03, 0x9a, 0x04, 0x60, 0x00, 0x15,
-  0x00, 0x00, 0x25, 0x11, 0x21, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11,
-  0x02, 0xf4, 0xfe, 0xcb, 0x89, 0x5c, 0x53, 0xa6, 0x2e, 0x30, 0x5e, 0x01,
-  0x0b, 0xa6, 0xa6, 0xa6, 0x99, 0x01, 0x70, 0x5f, 0x56, 0xb8, 0xea, 0xd3,
-  0x75, 0x3b, 0x3b, 0x01, 0xbe, 0xfb, 0xa0, 0xfe, 0xe5, 0x01, 0xb4, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x06, 0x38, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x00, 0x25, 0x33, 0x15, 0x01, 0x23, 0x01, 0x23, 0x11, 0x01, 0x23,
-  0x01, 0x11, 0x23, 0x11, 0x21, 0x09, 0x01, 0x21, 0x05, 0x82, 0xb5, 0xfe,
-  0xb7, 0x79, 0x01, 0x0d, 0xb1, 0xfe, 0xa5, 0xb6, 0xfe, 0xa5, 0xb0, 0x01,
-  0x0f, 0x01, 0x57, 0x01, 0x58, 0x01, 0x0f, 0xaa, 0xaa, 0xfe, 0x56, 0x01,
-  0xaa, 0x05, 0x1f, 0xfc, 0x00, 0x04, 0x00, 0xfa, 0xe1, 0x05, 0xd5, 0xfc,
-  0x08, 0x03, 0xf8, 0x00, 0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x05, 0x67,
-  0x04, 0x60, 0x00, 0x11, 0x00, 0x00, 0x25, 0x33, 0x15, 0x01, 0x23, 0x13,
-  0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0x11, 0x33, 0x09, 0x01, 0x33,
-  0x04, 0xc1, 0xa5, 0xfe, 0xfb, 0x6e, 0xce, 0xa0, 0xfe, 0xe9, 0xa5, 0xfe,
-  0xe9, 0xa0, 0xec, 0x01, 0x1e, 0x01, 0x1f, 0xea, 0x99, 0x99, 0xfe, 0x56,
-  0x01, 0xaa, 0x03, 0xb0, 0xfd, 0x27, 0x02, 0xd9, 0xfc, 0x50, 0x04, 0x60,
-  0xfd, 0x12, 0x02, 0xee, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54,
-  0x06, 0x14, 0x12, 0x06, 0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x92, 0x10, 0x27, 0x02, 0x9a, 0x00, 0xb9,
-  0x01, 0x4a, 0x13, 0x06, 0x03, 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x1f, 0x10, 0x26,
-  0x02, 0x9a, 0x47, 0xd7, 0x13, 0x06, 0x03, 0xc4, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x4e, 0x12, 0x26,
-  0x03, 0xa4, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x43, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x06, 0x10, 0x12, 0x26, 0x03, 0xc4, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a,
-  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x07, 0x00, 0x00, 0x06, 0x8e,
-  0x05, 0xd5, 0x12, 0x06, 0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
-  0xff, 0xe3, 0x06, 0xb1, 0x04, 0x7b, 0x12, 0x06, 0x00, 0xa8, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xf2, 0x04, 0x2a, 0x01, 0x75, 0x13, 0x06, 0x03, 0xa9, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
-  0x06, 0x48, 0x10, 0x27, 0x02, 0x9a, 0x00, 0x87, 0x00, 0x00, 0x13, 0x06,
-  0x03, 0xc9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
-  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06, 0x01, 0x51, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x06,
-  0x02, 0x1b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69, 0xff, 0xe3, 0x05, 0x44,
-  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x04, 0x9d, 0x01, 0x75, 0x12, 0x06,
-  0x04, 0x6c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
-  0x06, 0x10, 0x10, 0x26, 0x00, 0x6a, 0x4c, 0x00, 0x12, 0x06, 0x04, 0x6d,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x24, 0x00, 0x00, 0x07, 0x9e,
-  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x05, 0xaf, 0x01, 0x75, 0x12, 0x06,
-  0x03, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f, 0x00, 0x00, 0x06, 0x3e,
-  0x06, 0x10, 0x10, 0x27, 0x00, 0x6a, 0x01, 0x75, 0x00, 0x00, 0x12, 0x06,
-  0x03, 0xca, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x25,
-  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x04, 0x13, 0x01, 0x75, 0x12, 0x06,
-  0x03, 0xab, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
-  0x06, 0x10, 0x10, 0x26, 0x00, 0x6a, 0x34, 0x00, 0x12, 0x06, 0x03, 0xcb,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x90, 0xff, 0xc1, 0x04, 0x79,
-  0x05, 0xd5, 0x12, 0x06, 0x01, 0x79, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
-  0xfe, 0x4c, 0x03, 0xc4, 0x04, 0x60, 0x12, 0x06, 0x02, 0x54, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0xdc, 0x01, 0x3b, 0x12, 0x06, 0x03, 0xac, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07, 0x05, 0xf5, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0x83, 0xff, 0xff, 0x12, 0x06, 0x03, 0xcc, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x4e, 0x10, 0x27,
-  0x10, 0xeb, 0x04, 0x76, 0x01, 0x75, 0x12, 0x06, 0x03, 0xac, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07, 0x06, 0x10, 0x10, 0x27,
-  0x00, 0x6a, 0x00, 0x83, 0x00, 0x00, 0x12, 0x06, 0x03, 0xcc, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x4e, 0x12, 0x26,
-  0x03, 0xb2, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0xa3, 0x01, 0x75,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x06, 0x10, 0x12, 0x26, 0x03, 0xd2, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a,
-  0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x05, 0xf0, 0x12, 0x06, 0x01, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x12, 0x06, 0x02, 0x37, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x4e, 0x12, 0x26,
-  0x04, 0x7c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xeb, 0x04, 0xa3, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x10, 0x12, 0x26,
-  0x04, 0x7d, 0x00, 0x00, 0x10, 0x06, 0x00, 0x6a, 0x68, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x04, 0xa0, 0x07, 0x4e, 0x10, 0x27,
-  0x10, 0xeb, 0x03, 0xf6, 0x01, 0x75, 0x12, 0x06, 0x03, 0xc1, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x06, 0x10, 0x10, 0x26,
-  0x00, 0x6a, 0xe5, 0x00, 0x12, 0x06, 0x03, 0xe1, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0x67, 0x01, 0x3b, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x05, 0xf5, 0x10, 0x26,
-  0x00, 0x71, 0x55, 0xff, 0x12, 0x06, 0x03, 0xd7, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x4e, 0x10, 0x27,
-  0x10, 0xeb, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x10, 0x10, 0x26,
-  0x00, 0x6a, 0x55, 0x00, 0x12, 0x06, 0x03, 0xd7, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x6b, 0x10, 0x27,
-  0x10, 0xf4, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x66, 0x10, 0x26,
-  0x02, 0x9f, 0x55, 0x00, 0x12, 0x06, 0x03, 0xd7, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9d, 0x00, 0x00, 0x04, 0x3b, 0x07, 0x4e, 0x10, 0x27,
-  0x10, 0xeb, 0x04, 0x51, 0x01, 0x75, 0x12, 0x06, 0x03, 0xbb, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x87, 0x00, 0x00, 0x03, 0x9a, 0x06, 0x10, 0x10, 0x26,
-  0x00, 0x6a, 0x55, 0x00, 0x12, 0x06, 0x03, 0xdb, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x09,
-  0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11,
-  0xb5, 0x03, 0x44, 0xfd, 0x72, 0xb5, 0xb5, 0x05, 0xd5, 0xaa, 0xfb, 0x7f,
-  0xfe, 0x15, 0x01, 0x41, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x03, 0x6f,
-  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x33, 0x11, 0x23, 0x11, 0xa7, 0x02, 0xc7, 0xfd, 0xdf, 0xa6, 0xa6, 0x04,
-  0x60, 0xaa, 0xfc, 0xe3, 0xfe, 0x4c, 0x01, 0x1b, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0xa6, 0x07, 0x4e, 0x12, 0x26, 0x03, 0xbf, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xeb, 0x05, 0x25, 0x01, 0x75, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x05, 0x0c, 0x06, 0x10, 0x12, 0x26, 0x03, 0xdf, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x6a, 0x00, 0xee, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f,
-  0xfe, 0x56, 0x04, 0x71, 0x05, 0xd5, 0x00, 0x19, 0x00, 0x00, 0x21, 0x11,
-  0x23, 0x35, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x21, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
-  0x01, 0x2d, 0xed, 0xed, 0x03, 0x44, 0xfd, 0x71, 0x01, 0xed, 0xfe, 0x13,
-  0x01, 0x45, 0x40, 0x49, 0xac, 0xe5, 0xd2, 0x5e, 0x45, 0x02, 0x94, 0xaa,
-  0x02, 0x97, 0xaa, 0xfe, 0x13, 0xaa, 0xfd, 0xec, 0x94, 0xc8, 0x60, 0x6e,
-  0x9c, 0x61, 0xad, 0x00, 0x00, 0x01, 0x00, 0x32, 0xfe, 0x56, 0x03, 0xe7,
-  0x04, 0x60, 0x00, 0x19, 0x00, 0x00, 0x21, 0x11, 0x23, 0x35, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x14, 0x07,
-  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x01, 0x1f, 0xed, 0xed,
-  0x02, 0xc7, 0xfd, 0xdf, 0x01, 0x76, 0xfe, 0x8a, 0x01, 0x49, 0x3f, 0x4a,
-  0xad, 0xe4, 0xd2, 0x5f, 0x43, 0x01, 0xf4, 0xaa, 0x01, 0xc2, 0x9d, 0xfe,
-  0xdb, 0xaa, 0xfe, 0x8c, 0x94, 0xc8, 0x60, 0x6e, 0x9c, 0x61, 0xad, 0x00,
-  0x00, 0x01, 0x00, 0x36, 0xfe, 0x66, 0x04, 0xa6, 0x05, 0xd5, 0x00, 0x17,
-  0x00, 0x00, 0x25, 0x16, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x37, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01,
-  0x33, 0x01, 0x04, 0xa6, 0x01, 0x02, 0x0e, 0x4a, 0x5c, 0xcd, 0x45, 0x38,
-  0x7a, 0x31, 0x24, 0x0a, 0xfe, 0x88, 0xfe, 0x83, 0xc4, 0x01, 0xe0, 0xfe,
-  0x5d, 0xc3, 0x01, 0x4e, 0x01, 0x50, 0xc3, 0xfe, 0x50, 0x1a, 0x02, 0x18,
-  0xbe, 0x62, 0x7a, 0xaa, 0x4b, 0x35, 0x73, 0x02, 0x78, 0xfd, 0x85, 0x03,
-  0x1d, 0x02, 0xb8, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x33, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x35, 0xfe, 0x56, 0x03, 0xf4, 0x04, 0x60, 0x00, 0x17,
-  0x00, 0x00, 0x09, 0x02, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35,
-  0x32, 0x37, 0x3e, 0x01, 0x35, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09,
-  0x01, 0x03, 0xf4, 0xfe, 0x93, 0x01, 0x47, 0x18, 0x3c, 0x49, 0xb1, 0xad,
-  0xb0, 0x17, 0x47, 0x2f, 0xfe, 0xde, 0xfe, 0xda, 0xc3, 0x01, 0x88, 0xfe,
-  0x99, 0xc4, 0x01, 0x0b, 0x01, 0x0b, 0x04, 0x60, 0xfd, 0xdf, 0xfe, 0x17,
-  0x26, 0x39, 0xcd, 0x61, 0x73, 0x9c, 0x03, 0x0a, 0x6d, 0x98, 0x01, 0xb4,
-  0xfe, 0x48, 0x02, 0x4a, 0x02, 0x16, 0xfe, 0x71, 0x01, 0x8f, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01, 0x21, 0x15, 0x21, 0x01,
-  0x23, 0x09, 0x01, 0x23, 0x01, 0x21, 0x35, 0x21, 0x74, 0xc3, 0x01, 0x4e,
-  0x01, 0x50, 0xc3, 0xfe, 0x7a, 0x01, 0x4e, 0xfe, 0xb5, 0x01, 0xa0, 0xc3,
-  0xfe, 0x86, 0xfe, 0x83, 0xc4, 0x01, 0xa5, 0xfe, 0xb1, 0x01, 0x6e, 0x05,
-  0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x77, 0x90, 0xfd, 0x44, 0x02, 0x7b,
-  0xfd, 0x85, 0x02, 0xbc, 0x90, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x35,
-  0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01,
-  0x33, 0x09, 0x01, 0x33, 0x01, 0x33, 0x15, 0x21, 0x01, 0x23, 0x09, 0x01,
-  0x23, 0x01, 0x21, 0x35, 0x01, 0x8b, 0xfe, 0xcb, 0xc4, 0x01, 0x0b, 0x01,
-  0x0b, 0xc4, 0xfe, 0xcc, 0xf2, 0xfe, 0xfd, 0x01, 0x57, 0xc3, 0xfe, 0xdb,
-  0xfe, 0xda, 0xc3, 0x01, 0x59, 0xfe, 0xfc, 0x02, 0x94, 0x01, 0xcc, 0xfe,
-  0x71, 0x01, 0x8f, 0xfe, 0x34, 0x90, 0xfd, 0xfc, 0x01, 0xb8, 0xfe, 0x48,
-  0x02, 0x04, 0x90, 0x00, 0x00, 0x02, 0x00, 0x82, 0x00, 0x00, 0x04, 0x3c,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16,
-  0x33, 0x21, 0x11, 0x21, 0x22, 0x07, 0x06, 0x01, 0x11, 0x21, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x01, 0x42, 0x47, 0x47, 0x92, 0x01,
-  0x24, 0xfe, 0xdc, 0x92, 0x47, 0x47, 0x02, 0xfa, 0xfe, 0x1d, 0xe2, 0xf5,
-  0xf5, 0xe2, 0x01, 0x2d, 0x01, 0xb7, 0x8a, 0x43, 0x44, 0x02, 0x23, 0x43,
-  0x44, 0x03, 0x93, 0xfa, 0x2b, 0xda, 0xdd, 0xde, 0xda, 0x02, 0x66, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x03, 0x90, 0x04, 0x60, 0x00, 0x0a,
-  0x00, 0x16, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x11, 0x23,
-  0x22, 0x07, 0x06, 0x01, 0x11, 0x21, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36,
-  0x3b, 0x01, 0x11, 0x01, 0x16, 0x38, 0x3b, 0x74, 0xed, 0xed, 0x73, 0x3c,
-  0x38, 0x02, 0x7a, 0xfe, 0x66, 0xc0, 0x68, 0x68, 0x68, 0x6d, 0xbb, 0xf4,
-  0x01, 0x4c, 0x5a, 0x2b, 0x2e, 0x01, 0x69, 0x2e, 0x2a, 0x02, 0xb6, 0xfb,
-  0xa0, 0x52, 0x52, 0x01, 0x50, 0x52, 0x55, 0x01, 0xc5, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x82, 0xff, 0xe3, 0x06, 0x8a, 0x05, 0xd5, 0x00, 0x0c,
-  0x00, 0x30, 0x00, 0x00, 0x01, 0x21, 0x22, 0x07, 0x06, 0x10, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x13, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x33, 0x11, 0x14,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x03, 0x86, 0xfe, 0xdc, 0x92, 0x47, 0x47,
-  0x47, 0x56, 0x74, 0xa2, 0x43, 0x4e, 0x1e, 0x0b, 0x0d, 0x2e, 0x5f, 0x55,
-  0x63, 0xd6, 0x74, 0x7b, 0xf5, 0xe2, 0x01, 0x2d, 0xb5, 0x38, 0x2f, 0x65,
-  0x5f, 0x35, 0x38, 0xb6, 0x63, 0x5e, 0xc1, 0xc3, 0x5c, 0x2c, 0x02, 0xc9,
-  0x43, 0x44, 0xfe, 0xea, 0x50, 0x5f, 0x6d, 0x7d, 0x9f, 0xfe, 0xdd, 0x1d,
-  0x1c, 0x60, 0x36, 0x31, 0x81, 0x89, 0xca, 0xde, 0xda, 0x02, 0x66, 0xfb,
-  0xec, 0x8f, 0x5b, 0x4a, 0x4a, 0x4f, 0x9b, 0x02, 0x9f, 0xfd, 0x5a, 0xe0,
-  0x7f, 0x78, 0x78, 0x39, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x05, 0xce,
-  0x04, 0x60, 0x00, 0x0d, 0x00, 0x30, 0x00, 0x00, 0x01, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x13, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01,
-  0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
-  0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x02, 0xea, 0xed,
-  0x73, 0x3c, 0x38, 0x3b, 0x39, 0x60, 0x85, 0x53, 0x28, 0x2c, 0x3c, 0x54,
-  0x54, 0x7b, 0x9b, 0x5b, 0x5b, 0x68, 0x6d, 0xbb, 0xf4, 0xa6, 0x38, 0x36,
-  0x5f, 0x5d, 0x36, 0x38, 0xa6, 0x5a, 0x5e, 0xb9, 0xbe, 0x5a, 0x1c, 0x02,
-  0x02, 0x2e, 0x2a, 0x5e, 0x5c, 0x3a, 0x39, 0x6d, 0x34, 0x9c, 0xfe, 0xf6,
-  0x6c, 0x30, 0x31, 0x61, 0x60, 0xa6, 0xaa, 0x52, 0x55, 0x01, 0xc5, 0xfd,
-  0x61, 0x9f, 0x50, 0x4f, 0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe, 0xb8, 0xec,
-  0x73, 0x78, 0x78, 0x25, 0x00, 0x01, 0x00, 0xb4, 0xff, 0xe3, 0x06, 0x50,
-  0x05, 0xf0, 0x00, 0x37, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x03, 0x4c, 0x53, 0x53, 0x95, 0x9c, 0xa3, 0x86, 0x48, 0x47,
-  0x49, 0x4a, 0x89, 0x4b, 0xaa, 0x67, 0x67, 0x5a, 0x5b, 0x50, 0xcf, 0x79,
-  0x79, 0x40, 0x40, 0x76, 0x82, 0x4a, 0x49, 0x39, 0x2f, 0x64, 0x5f, 0x35,
-  0x39, 0xb6, 0x64, 0x5d, 0xc2, 0xc3, 0x5c, 0x2b, 0x19, 0x1e, 0x01, 0xb2,
-  0x84, 0x4a, 0x4b, 0xa6, 0x3b, 0x3c, 0x70, 0x73, 0x3d, 0x3e, 0x24, 0x26,
-  0xb4, 0x20, 0x10, 0x10, 0x68, 0x69, 0xb2, 0x7c, 0x55, 0x56, 0x21, 0x1f,
-  0x62, 0x62, 0x90, 0x80, 0x5b, 0x4a, 0x4a, 0x4f, 0x9b, 0x02, 0x9f, 0xfd,
-  0x5a, 0xe0, 0x7f, 0x78, 0x78, 0x38, 0x50, 0x61, 0x00, 0x01, 0x00, 0x99,
-  0xff, 0xe3, 0x05, 0xa6, 0x04, 0x7c, 0x00, 0x35, 0x00, 0x00, 0x01, 0x34,
-  0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x02, 0xc4, 0x46, 0x41, 0x7b, 0x85, 0x8b, 0x69,
-  0x3c, 0x3d, 0x3f, 0x3e, 0x6b, 0x40, 0x49, 0x48, 0x57, 0x58, 0x99, 0x45,
-  0xb0, 0x66, 0x66, 0x36, 0x36, 0x65, 0x75, 0x39, 0x3e, 0x38, 0x37, 0x5e,
-  0x5e, 0x36, 0x38, 0xa5, 0x5a, 0x5d, 0xba, 0xb3, 0x65, 0x58, 0x01, 0x38,
-  0x66, 0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e, 0x0d, 0x0d,
-  0x1d, 0xa7, 0x18, 0x18, 0x4e, 0x4f, 0x8d, 0x5d, 0x40, 0x41, 0x18, 0x19,
-  0x48, 0x4f, 0x48, 0x58, 0x44, 0x45, 0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe,
-  0xb8, 0xec, 0x73, 0x78, 0x75, 0x65, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0xfe, 0x56, 0x04, 0xb6, 0x05, 0xf0, 0x00, 0x29, 0x00, 0x00, 0x21, 0x23,
-  0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15,
-  0x11, 0x33, 0x11, 0x23, 0x04, 0x01, 0xb5, 0x53, 0x53, 0x95, 0x9c, 0xa3,
-  0x86, 0x48, 0x47, 0x49, 0x4a, 0x89, 0x4b, 0xaa, 0x67, 0x67, 0x5a, 0x5b,
-  0x50, 0xcf, 0x79, 0x79, 0x40, 0x40, 0x76, 0x82, 0x4a, 0x49, 0xb5, 0xb5,
-  0x01, 0xb1, 0x85, 0x4a, 0x4b, 0xa6, 0x3b, 0x3c, 0x70, 0x73, 0x3d, 0x3e,
-  0x24, 0x26, 0xb4, 0x20, 0x10, 0x10, 0x68, 0x69, 0xb2, 0x7c, 0x55, 0x56,
-  0x21, 0x1f, 0x62, 0x61, 0x92, 0xfe, 0xf9, 0xfd, 0xac, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x99, 0xfe, 0x56, 0x04, 0x10, 0x04, 0x7c, 0x00, 0x29,
-  0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x34, 0x27, 0x26,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x03, 0x67, 0xa9, 0xa6,
-  0xa6, 0x46, 0x41, 0x7b, 0x85, 0x8b, 0x69, 0x3c, 0x3d, 0x3f, 0x3e, 0x6b,
-  0x40, 0x49, 0x48, 0x57, 0x58, 0x99, 0x45, 0xb0, 0x66, 0x66, 0x36, 0x36,
-  0x65, 0x72, 0x3c, 0x3e, 0x99, 0xfd, 0xbd, 0x01, 0xaa, 0x01, 0x46, 0x58,
-  0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e, 0x0d, 0x0d, 0x1d,
-  0xa7, 0x18, 0x18, 0x4e, 0x4f, 0x8d, 0x5d, 0x40, 0x41, 0x18, 0x18, 0x49,
-  0x4b, 0x6a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x30, 0xff, 0xe3, 0x07, 0x03,
-  0x05, 0xd5, 0x00, 0x21, 0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x35, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x05, 0x35, 0x36,
-  0x37, 0x12, 0x19, 0x01, 0x04, 0xb4, 0x39, 0x2f, 0x64, 0x5f, 0x35, 0x39,
-  0xb6, 0x63, 0x5e, 0xc2, 0xc0, 0x5f, 0x63, 0xfe, 0x4c, 0x77, 0x58, 0xfe,
-  0xb6, 0xbe, 0x3d, 0x69, 0x05, 0xd5, 0xfb, 0xec, 0x8f, 0x5b, 0x4a, 0x4a,
-  0x4f, 0x9b, 0x02, 0x9f, 0xfd, 0x5a, 0xe0, 0x7f, 0x78, 0x78, 0x7d, 0xe2,
-  0x03, 0x71, 0xd4, 0xfe, 0x18, 0xfe, 0xaa, 0xfd, 0x38, 0xa7, 0x2e, 0xa8,
-  0x01, 0x25, 0x02, 0x35, 0x01, 0x1a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x29,
-  0xff, 0xe3, 0x06, 0x3d, 0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x01, 0x11,
-  0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06,
-  0x05, 0x35, 0x36, 0x37, 0x36, 0x11, 0x35, 0x04, 0x01, 0x6e, 0x5d, 0x5d,
-  0x36, 0x38, 0xa6, 0x5a, 0x5e, 0xb9, 0xb4, 0x64, 0x58, 0xfe, 0xa1, 0x6a,
-  0x54, 0xfe, 0xea, 0xa1, 0x36, 0x58, 0x04, 0x60, 0xfd, 0x04, 0x57, 0x8a,
-  0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe, 0xb8, 0xec, 0x73, 0x78, 0x75, 0x65,
-  0x7b, 0x02, 0x8f, 0x86, 0xfe, 0x92, 0xfe, 0xfc, 0xcf, 0x1d, 0x99, 0x1b,
-  0x7f, 0xcf, 0x01, 0xa7, 0xd4, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xff, 0xe3, 0x07, 0x5c, 0x05, 0xd5, 0x12, 0x06, 0x01, 0xb8, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0xff, 0xe3, 0x06, 0x50, 0x04, 0x60, 0x00, 0x1c,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
-  0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x21,
-  0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x04, 0x14, 0x6e, 0x5c, 0x5e,
-  0x36, 0x38, 0xa6, 0x5a, 0x5e, 0xba, 0xb3, 0x64, 0x59, 0xfd, 0xe5, 0xa5,
-  0xa5, 0x02, 0x1b, 0x04, 0x60, 0xfd, 0x04, 0x57, 0x8a, 0x4f, 0x52, 0x9d,
-  0x01, 0x41, 0xfe, 0xb8, 0xec, 0x73, 0x78, 0x75, 0x65, 0x7b, 0xcc, 0xfd,
-  0xfc, 0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0x00, 0x00, 0x01, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xfc, 0x05, 0xf0, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x20, 0x27, 0x26, 0x10, 0x37, 0x36, 0x21,
-  0x20, 0x17, 0x15, 0x26, 0x23, 0x20, 0x11, 0x10, 0x21, 0x32, 0x36, 0x35,
-  0x11, 0x33, 0x04, 0xfb, 0x5a, 0x28, 0x7b, 0x70, 0x88, 0xfe, 0xbf, 0xb1,
-  0xac, 0xab, 0xb2, 0x01, 0x41, 0x01, 0x0a, 0xca, 0xca, 0xfb, 0xfe, 0x12,
-  0x01, 0xee, 0xc2, 0x6f, 0xb5, 0x01, 0xba, 0xe0, 0x7f, 0x39, 0x21, 0x1e,
-  0xd2, 0xcc, 0x02, 0xd0, 0xcd, 0xd2, 0x8e, 0xd7, 0xbf, 0xfd, 0x9f, 0xfd,
-  0xa0, 0x94, 0xa4, 0x01, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0xd9, 0x04, 0x7b, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x10,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x10,
-  0x17, 0x16, 0x33, 0x32, 0x11, 0x35, 0x33, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x66, 0x83, 0x87, 0xf0, 0xbc, 0xa7, 0xab, 0xb0, 0xaa, 0x59,
-  0x51, 0x51, 0x59, 0xaa, 0xcb, 0xa6, 0xb5, 0xce, 0xea, 0x86, 0x80, 0x02,
-  0x2f, 0x01, 0x0e, 0x9d, 0xa1, 0x6e, 0xaa, 0x7c, 0x7c, 0x72, 0xfe, 0x7c,
-  0x72, 0x7c, 0x01, 0x3e, 0xbe, 0xc5, 0xec, 0xe7, 0xa6, 0x9e, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xfa, 0xff, 0xe3, 0x04, 0xdc, 0x05, 0xd5, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11,
-  0x21, 0x35, 0x21, 0x15, 0x02, 0x8e, 0x39, 0x2f, 0x64, 0x5e, 0x35, 0x39,
-  0xb6, 0x63, 0x5e, 0xc1, 0xc1, 0x5e, 0x63, 0xfe, 0x23, 0x04, 0x70, 0x05,
-  0x2b, 0xfc, 0x96, 0x8f, 0x5b, 0x4a, 0x4a, 0x4f, 0x9b, 0x02, 0x9f, 0xfd,
-  0x5a, 0xe0, 0x7f, 0x78, 0x78, 0x7d, 0xe2, 0x03, 0x71, 0xaa, 0xaa, 0x00,
-  0x00, 0x01, 0x00, 0x04, 0xff, 0xe3, 0x04, 0x77, 0x04, 0x60, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11,
-  0x21, 0x35, 0x21, 0x15, 0x02, 0x39, 0x38, 0x37, 0x5e, 0x5e, 0x36, 0x37,
-  0xa6, 0x5a, 0x5e, 0xb9, 0xb3, 0x65, 0x58, 0xfe, 0x6e, 0x03, 0xc6, 0x03,
-  0xb6, 0xfd, 0xae, 0x56, 0x46, 0x45, 0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe,
-  0xb8, 0xec, 0x73, 0x78, 0x75, 0x65, 0x7b, 0x02, 0x7e, 0xaa, 0xaa, 0x00,
-  0xff, 0xff, 0x00, 0x93, 0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x12, 0x06,
-  0x01, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
-  0x04, 0x7c, 0x12, 0x06, 0x03, 0x49, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b,
-  0xfe, 0x66, 0x04, 0xb5, 0x05, 0xd5, 0x00, 0x18, 0x00, 0x00, 0x33, 0x35,
-  0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x4c,
-  0xc7, 0x34, 0x4e, 0x03, 0x1f, 0xb8, 0xcd, 0x45, 0x39, 0x78, 0x32, 0x31,
-  0xfe, 0x4c, 0x5c, 0x58, 0xaa, 0x30, 0xa3, 0xf6, 0x02, 0x64, 0xfe, 0xfa,
-  0x93, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4c, 0xc1, 0x04, 0xc3, 0xb8, 0xfd,
-  0xca, 0xfe, 0xf8, 0xfd, 0x00, 0x01, 0x00, 0x44, 0xfe, 0x56, 0x04, 0x02,
-  0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x36, 0x11,
-  0x35, 0x21, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x11, 0x21, 0x15, 0x10, 0x07, 0x06, 0x44, 0xa8, 0x2f, 0x3d, 0x02,
-  0xa9, 0x93, 0xa2, 0x40, 0x2d, 0x57, 0x29, 0x23, 0xfe, 0xa1, 0x4f, 0x54,
-  0x99, 0x1d, 0x7d, 0xa6, 0x01, 0xd0, 0xb7, 0xfb, 0x8c, 0xd6, 0xc0, 0x9c,
-  0x30, 0x29, 0xa1, 0x03, 0xe1, 0x6f, 0xfe, 0x50, 0xc2, 0xcf, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x4b, 0x00, 0x00, 0x08, 0x33, 0x05, 0xd5, 0x00, 0x17,
-  0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x12, 0x11, 0x35, 0x21, 0x09, 0x01,
-  0x33, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x21, 0x15, 0x10,
-  0x03, 0x06, 0x4c, 0xc3, 0x38, 0x4e, 0x03, 0x20, 0x01, 0x4e, 0x01, 0x50,
-  0xc3, 0xfe, 0x50, 0x01, 0xcd, 0xc3, 0xfe, 0x86, 0xfe, 0x83, 0xc4, 0x01,
-  0xdf, 0xfe, 0xc4, 0xfd, 0xf2, 0x5c, 0x58, 0xaa, 0x2f, 0xa4, 0x01, 0x02,
-  0x02, 0x58, 0xfe, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x33, 0xfc, 0xf8, 0x02,
-  0x7b, 0xfd, 0x85, 0x03, 0x1d, 0x02, 0x0e, 0xb8, 0xfd, 0xca, 0xfe, 0xf8,
-  0xfd, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x44, 0x00, 0x00, 0x06, 0xed,
-  0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x09, 0x02, 0x23, 0x09, 0x01, 0x23,
-  0x09, 0x01, 0x21, 0x15, 0x10, 0x07, 0x06, 0x05, 0x35, 0x36, 0x37, 0x36,
-  0x11, 0x35, 0x21, 0x17, 0x09, 0x01, 0x06, 0xda, 0xfe, 0x94, 0x01, 0x7f,
-  0xc3, 0xfe, 0xda, 0xfe, 0xdb, 0xc3, 0x01, 0x87, 0xfe, 0xfc, 0xfe, 0x5e,
-  0x4f, 0x54, 0xfe, 0xea, 0xa4, 0x33, 0x3d, 0x02, 0xa9, 0x01, 0x01, 0x0a,
-  0x01, 0x0b, 0x04, 0x60, 0xfd, 0xdf, 0xfd, 0xc1, 0x01, 0xb8, 0xfe, 0x48,
-  0x02, 0x4a, 0x01, 0x83, 0x6f, 0xfe, 0x50, 0xc2, 0xcf, 0x1d, 0x99, 0x1c,
-  0x7e, 0xb1, 0x01, 0xc5, 0xb7, 0x03, 0xfe, 0x74, 0x01, 0x8f, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x06, 0x38, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x1a, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x01, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32, 0x16, 0x15,
-  0x14, 0x07, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x6b, 0xe4, 0x7f, 0x8b,
-  0x8b, 0x7f, 0x01, 0x6d, 0x73, 0xfa, 0xe4, 0xb6, 0x01, 0x9a, 0xe2, 0xe7,
-  0x05, 0x01, 0x44, 0xc3, 0xfe, 0x50, 0x01, 0xcd, 0xc3, 0x05, 0x2f, 0xfd,
-  0xcf, 0x92, 0x87, 0x86, 0x92, 0xfd, 0xb3, 0x8a, 0xfd, 0xa8, 0x05, 0xd5,
-  0xe3, 0xdb, 0x30, 0x2a, 0x02, 0x18, 0xfd, 0x33, 0xfc, 0xf8, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x05, 0xfe, 0x04, 0x7b, 0x00, 0x18,
-  0x00, 0x20, 0x00, 0x00, 0x09, 0x02, 0x23, 0x01, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x26, 0x27, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x01, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
-  0x05, 0xeb, 0xfe, 0x93, 0x01, 0x80, 0xc4, 0xfe, 0xea, 0x17, 0x53, 0x72,
-  0xb8, 0x6f, 0x9f, 0x34, 0xa7, 0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0x72, 0x4c,
-  0x1a, 0x01, 0x07, 0xfe, 0x5a, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07,
-  0x04, 0x60, 0xfd, 0xdf, 0xfd, 0xc1, 0x01, 0xa1, 0xa8, 0x74, 0xa2, 0x61,
-  0x64, 0xfd, 0xae, 0x06, 0x0a, 0xaa, 0x64, 0x61, 0xa2, 0x6b, 0x97, 0x01,
-  0x89, 0xfd, 0x04, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x7a, 0x00, 0x00, 0x06, 0xf6, 0x05, 0xd5, 0x00, 0x15,
-  0x00, 0x1d, 0x00, 0x00, 0x33, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x23, 0x01, 0x12, 0x10, 0x16, 0x33, 0x21, 0x11, 0x21, 0x22, 0x7a, 0x01,
-  0x70, 0x5a, 0xe7, 0xea, 0xe8, 0x04, 0x6b, 0xfd, 0x66, 0x02, 0x7e, 0xfd,
-  0x82, 0x02, 0xaa, 0xfc, 0x9e, 0xf1, 0xfe, 0x9d, 0x32, 0x86, 0x83, 0x01,
-  0x19, 0xfe, 0xe7, 0x83, 0x02, 0x8d, 0x1a, 0xa9, 0xd7, 0xce, 0xe0, 0xaa,
-  0xfe, 0x46, 0xaa, 0xfd, 0xe3, 0xaa, 0x02, 0x77, 0xfd, 0x89, 0x04, 0xaa,
-  0xfe, 0xfa, 0x87, 0x02, 0x12, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x68,
-  0xff, 0xe3, 0x06, 0xb8, 0x04, 0x7b, 0x00, 0x1f, 0x00, 0x26, 0x00, 0x2f,
-  0x00, 0x00, 0x01, 0x15, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x23, 0x01, 0x23, 0x01, 0x2e,
-  0x01, 0x35, 0x34, 0x36, 0x33, 0x21, 0x36, 0x33, 0x32, 0x12, 0x07, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x07, 0x25, 0x14, 0x16, 0x3b, 0x01, 0x11, 0x23,
-  0x22, 0x06, 0x06, 0xb8, 0xfd, 0x06, 0x0b, 0xb9, 0xa4, 0x60, 0xb3, 0x58,
-  0x59, 0xbb, 0x60, 0xf2, 0x8d, 0x89, 0x03, 0xce, 0xfe, 0xd7, 0xb3, 0x01,
-  0x34, 0x68, 0x8b, 0xc2, 0xc3, 0x02, 0x28, 0x4d, 0x5d, 0xcb, 0xed, 0xa6,
-  0x02, 0x94, 0x7a, 0x8b, 0xa7, 0x0c, 0xfd, 0x90, 0x73, 0x6b, 0xe0, 0xe0,
-  0x6b, 0x73, 0x02, 0x5e, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a, 0x2c,
-  0x9c, 0x98, 0xc2, 0xfe, 0x27, 0x01, 0xeb, 0x1a, 0x89, 0x8f, 0xa2, 0xa1,
-  0x1b, 0xfe, 0xdd, 0xc4, 0x97, 0xb4, 0xae, 0x9e, 0x8a, 0x53, 0x5e, 0x01,
-  0x61, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xfe, 0xf8, 0x05, 0x44,
-  0x05, 0xf0, 0x10, 0x06, 0x00, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x03, 0xeb, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x54, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
-  0x04, 0x60, 0x10, 0x06, 0x00, 0x5a, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xf9, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x01, 0x33,
-  0x17, 0x37, 0x33, 0x01, 0x17, 0x23, 0x27, 0x07, 0x01, 0x23, 0x01, 0x03,
-  0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x27, 0x02, 0x2c, 0x7a, 0x88, 0xc6,
-  0xea, 0xfe, 0xc6, 0xb4, 0x80, 0x74, 0x8e, 0x02, 0x23, 0xc6, 0xfe, 0x2d,
-  0xf5, 0xb6, 0xb6, 0x01, 0x84, 0xc5, 0x05, 0x8a, 0x97, 0xe2, 0xfe, 0x9b,
-  0xc8, 0x80, 0xa1, 0xfc, 0x79, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x05,
-  0xd5, 0xfd, 0x1e, 0x01, 0xb8, 0xdc, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x1d, 0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
-  0x17, 0x37, 0x33, 0x07, 0x17, 0x23, 0x27, 0x07, 0x01, 0x23, 0x01, 0x07,
-  0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x01, 0xfc, 0x7e, 0x3b, 0x6a, 0xcc,
-  0xcf, 0x84, 0x80, 0x44, 0x73, 0x01, 0xb3, 0xb9, 0xfe, 0x9a, 0xb1, 0xa5,
-  0xa5, 0x01, 0x2a, 0x04, 0x29, 0x40, 0x77, 0xe9, 0x93, 0x4c, 0x81, 0xfd,
-  0x51, 0x02, 0x35, 0xc8, 0xfe, 0x93, 0x04, 0x60, 0xfd, 0xf2, 0x01, 0x50,
-  0x00, 0x01, 0x00, 0x4b, 0xfe, 0x66, 0x07, 0x9b, 0x05, 0xd5, 0x00, 0x25,
-  0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x12, 0x11, 0x35, 0x21, 0x11, 0x21,
-  0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x15, 0x10, 0x03, 0x06, 0x4c, 0xc3, 0x38, 0x4e, 0x03, 0x1f, 0x01, 0x78,
-  0xa7, 0x66, 0x62, 0xb8, 0xcd, 0x44, 0x37, 0x79, 0x32, 0x32, 0x70, 0x6f,
-  0xfe, 0xad, 0xb6, 0xfe, 0x4c, 0x5c, 0x58, 0xaa, 0x2f, 0xa4, 0x01, 0x02,
-  0x02, 0x58, 0xfe, 0xfd, 0x9c, 0x77, 0x72, 0xee, 0xfe, 0xce, 0xfe, 0xf2,
-  0xf4, 0xaa, 0x4b, 0x4b, 0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x05,
-  0x2b, 0xb8, 0xfd, 0xca, 0xfe, 0xf8, 0xfd, 0x00, 0x00, 0x01, 0x00, 0x44,
-  0xfe, 0x56, 0x06, 0x58, 0x04, 0x60, 0x00, 0x27, 0x00, 0x00, 0x33, 0x35,
-  0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x11, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x15, 0x10,
-  0x07, 0x06, 0x44, 0xa4, 0x33, 0x3d, 0x02, 0xa9, 0xe1, 0xed, 0x3f, 0x4a,
-  0x4a, 0x49, 0xa3, 0xae, 0x9b, 0x63, 0x1e, 0x22, 0x22, 0x28, 0x7d, 0xea,
-  0xa5, 0xfe, 0xa1, 0x4f, 0x54, 0x99, 0x1c, 0x7e, 0xb1, 0x01, 0xc5, 0xb7,
-  0xfe, 0x17, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd5, 0x61, 0x60, 0x9c, 0x30,
-  0x37, 0x93, 0x01, 0x08, 0xa6, 0x24, 0x29, 0xfe, 0x19, 0x03, 0xcd, 0x6f,
-  0xfe, 0x50, 0xc2, 0xcf, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x07, 0x9c,
-  0x05, 0xd5, 0x00, 0x21, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
-  0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x94, 0xb6, 0x01, 0x77, 0xa8,
-  0x66, 0x62, 0xb8, 0xcd, 0x45, 0x38, 0x79, 0x32, 0x32, 0x70, 0x6f, 0xfe,
-  0xad, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfd,
-  0x9c, 0x77, 0x72, 0xee, 0xfe, 0xce, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b,
-  0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x02, 0xc7, 0xfd, 0x39, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x06, 0x65, 0x04, 0x60, 0x00, 0x23,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
-  0x36, 0x35, 0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21,
-  0x11, 0x23, 0xa7, 0xa7, 0x02, 0x19, 0xa7, 0xe1, 0xec, 0x3f, 0x4a, 0x4a,
-  0x49, 0xa2, 0xae, 0x9b, 0x63, 0x1d, 0x23, 0x23, 0x27, 0x7d, 0xea, 0xa7,
-  0xfd, 0xe7, 0xa7, 0x04, 0x60, 0xfe, 0x37, 0x01, 0xc9, 0xfe, 0x17, 0x47,
-  0x51, 0xe5, 0xfe, 0xf2, 0xd5, 0x61, 0x60, 0x9c, 0x30, 0x37, 0x93, 0x01,
-  0x08, 0xa6, 0x24, 0x29, 0xfe, 0x19, 0x02, 0x04, 0xfd, 0xfc, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x6a, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x33, 0x11,
-  0x23, 0x11, 0x03, 0xff, 0xfd, 0x6c, 0xb6, 0x04, 0x00, 0xb5, 0xb5, 0x05,
-  0x2b, 0xfa, 0xd5, 0x05, 0xd5, 0xfa, 0xd5, 0xfe, 0x15, 0x01, 0x41, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0xb4, 0x04, 0x60, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x04, 0x0e, 0xa5, 0xa5, 0xa7, 0xfd, 0xe7, 0xa7, 0x04, 0x60,
-  0xfc, 0x39, 0xfe, 0x4c, 0x01, 0x1b, 0x03, 0xcd, 0xfc, 0x33, 0x04, 0x60,
-  0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x07,
-  0x00, 0x0a, 0x00, 0x00, 0x21, 0x23, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33,
-  0x01, 0x21, 0x03, 0x04, 0x0c, 0xb0, 0x5b, 0xfe, 0x41, 0x5c, 0xaf, 0x01,
-  0x7a, 0xe1, 0xfe, 0xe3, 0x01, 0x59, 0xad, 0x01, 0x13, 0xfe, 0xed, 0x04,
-  0x60, 0xfd, 0x47, 0x02, 0x05, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09,
-  0x00, 0x00, 0x04, 0xd2, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00,
-  0x33, 0x01, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15,
-  0x21, 0x11, 0x21, 0x03, 0x01, 0x03, 0x33, 0x11, 0x0a, 0x01, 0xaa, 0x03,
-  0x12, 0xfe, 0x2a, 0x01, 0xc2, 0xfe, 0x3e, 0x01, 0xe2, 0xfd, 0x77, 0xfe,
-  0xde, 0x68, 0x01, 0x71, 0xd1, 0xea, 0x04, 0x60, 0x94, 0xfe, 0xd3, 0x94,
-  0xfe, 0x88, 0x93, 0x01, 0x13, 0xfe, 0xed, 0x03, 0xcd, 0xfd, 0xda, 0x02,
-  0x26, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xb1,
-  0x04, 0x7b, 0x00, 0x34, 0x00, 0x3d, 0x00, 0x4a, 0x00, 0x00, 0x25, 0x0e,
-  0x01, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x21, 0x2e, 0x01, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x3e,
-  0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x25, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x1d,
-  0x01, 0x03, 0xa0, 0x43, 0xbf, 0x76, 0xcc, 0x76, 0x77, 0x02, 0xf9, 0x0b,
-  0xb7, 0xa5, 0x5e, 0x5a, 0x5a, 0x5a, 0x5a, 0xbc, 0x5f, 0x96, 0x70, 0x70,
-  0x45, 0x41, 0xc3, 0x81, 0xaa, 0x5e, 0x5f, 0x73, 0x71, 0xe2, 0xe8, 0x4b,
-  0x4b, 0x88, 0x57, 0xa3, 0x4c, 0x5b, 0x56, 0x55, 0x51, 0x80, 0x5f, 0x61,
-  0xfd, 0x45, 0x01, 0x4b, 0x4a, 0x7b, 0x8a, 0x52, 0x54, 0x0d, 0x01, 0x45,
-  0xc8, 0x9b, 0x3a, 0x3a, 0x64, 0x8a, 0x52, 0x54, 0x9b, 0x5a, 0x5e, 0x91,
-  0x92, 0xfa, 0x5a, 0xbf, 0xc8, 0x1b, 0x1a, 0x35, 0xae, 0x2a, 0x2c, 0x3d,
-  0x3c, 0x77, 0x78, 0x78, 0x5d, 0x5e, 0xa8, 0xbd, 0x60, 0x60, 0x12, 0x7f,
-  0x46, 0x45, 0x2e, 0x2e, 0xaa, 0x27, 0x14, 0x13, 0x30, 0x30, 0x01, 0x87,
-  0x97, 0x5a, 0x5a, 0x57, 0x57, 0x9e, 0x60, 0x66, 0x7b, 0x62, 0x3a, 0x39,
-  0x6d, 0x6c, 0xb4, 0x29, 0x00, 0x03, 0x00, 0x37, 0x00, 0x00, 0x03, 0xd2,
-  0x04, 0x60, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x23, 0x00, 0x00, 0x25, 0x32,
-  0x35, 0x34, 0x2b, 0x01, 0x15, 0x33, 0x15, 0x23, 0x15, 0x01, 0x34, 0x2b,
-  0x01, 0x11, 0x33, 0x32, 0x37, 0x14, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06,
-  0x23, 0x21, 0x35, 0x23, 0x35, 0x33, 0x11, 0x21, 0x32, 0x16, 0x02, 0x39,
-  0xe8, 0xe8, 0xec, 0xc6, 0xc6, 0x01, 0xae, 0xd4, 0xda, 0xda, 0xd4, 0xa7,
-  0xc1, 0x72, 0x7e, 0xcf, 0xc1, 0xfe, 0x66, 0x6f, 0x6f, 0x01, 0x8b, 0xb1,
-  0xbf, 0x99, 0xb5, 0xb4, 0x66, 0xa4, 0x5f, 0x02, 0x9d, 0x91, 0xfe, 0xda,
-  0xaa, 0xd0, 0x1f, 0x18, 0x98, 0x72, 0x96, 0xa4, 0xf8, 0xa4, 0x02, 0xc4,
-  0x90, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
-  0x04, 0x7b, 0x10, 0x06, 0x00, 0x46, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0xf7, 0x04, 0x60, 0x00, 0x08, 0x00, 0x11, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x25, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x01, 0x4e, 0x7f, 0xc3, 0xb7, 0xb7,
-  0xc3, 0xfe, 0xda, 0x01, 0x18, 0x01, 0x26, 0x01, 0x11, 0xfe, 0xed, 0xfe,
-  0xdc, 0xfe, 0xe8, 0x03, 0xcd, 0xfc, 0xc7, 0xc7, 0xd6, 0xd5, 0xc7, 0x93,
-  0xfe, 0xf1, 0xfe, 0xe0, 0xfe, 0xdf, 0xfe, 0xf0, 0x00, 0x02, 0x00, 0x20,
-  0x00, 0x00, 0x03, 0xf7, 0x04, 0x60, 0x00, 0x0c, 0x00, 0x19, 0x00, 0x00,
-  0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x11, 0x23, 0x35,
-  0x33, 0x21, 0x15, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b,
-  0x01, 0x11, 0xa7, 0x01, 0x18, 0x01, 0x26, 0x01, 0x11, 0xfe, 0xed, 0xfe,
-  0xdc, 0xfe, 0xe8, 0x87, 0x87, 0x01, 0x55, 0xae, 0x7f, 0xc3, 0xb7, 0xb7,
-  0xc3, 0x7f, 0x04, 0x60, 0xfe, 0xf1, 0xfe, 0xe0, 0xfe, 0xdf, 0xfe, 0xf0,
-  0x01, 0xf5, 0xa4, 0xa4, 0xfe, 0x9f, 0xc7, 0xd6, 0xd5, 0xc7, 0xfe, 0xcc,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x31, 0x04, 0x60, 0x00, 0x0b,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0xa7, 0x02, 0x7e, 0xfe, 0x2a, 0x01, 0xc1, 0xfe, 0x3f, 0x01,
-  0xe1, 0xfd, 0x77, 0x04, 0x60, 0x94, 0xfe, 0xd3, 0x94, 0xfe, 0x88, 0x93,
-  0x00, 0x01, 0x00, 0x75, 0xff, 0xe3, 0x03, 0x65, 0x04, 0x7c, 0x00, 0x31,
-  0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x02, 0x79, 0x65, 0x36, 0x36, 0x67, 0x66, 0xb0,
-  0x45, 0x99, 0x58, 0x57, 0x48, 0x49, 0x40, 0x6b, 0x3e, 0x40, 0x3e, 0x3c,
-  0x68, 0x8c, 0x85, 0x7c, 0x40, 0x47, 0x4c, 0x4c, 0x88, 0x54, 0x4d, 0x4c,
-  0x40, 0x51, 0x4c, 0x4c, 0x48, 0xd6, 0xe8, 0x7c, 0x02, 0x03, 0x18, 0x41,
-  0x40, 0x5d, 0x8d, 0x4f, 0x4e, 0x18, 0x18, 0xa7, 0x1d, 0x0d, 0x0d, 0x2e,
-  0x2e, 0x40, 0x46, 0x2d, 0x2c, 0x98, 0x33, 0x38, 0x58, 0x5a, 0x38, 0x38,
-  0x12, 0x13, 0x25, 0xab, 0x1c, 0x0e, 0x0e, 0xb6, 0xad, 0x6c, 0x92, 0x00,
-  0x00, 0x02, 0x00, 0xad, 0xfe, 0x4c, 0x01, 0x54, 0x04, 0x60, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x11, 0x35, 0x33, 0x15,
-  0xae, 0xa5, 0xa5, 0xa5, 0x04, 0x60, 0xfb, 0xa0, 0xfe, 0x4c, 0xe9, 0xe9,
-  0x00, 0x01, 0x00, 0x00, 0xff, 0xe3, 0x02, 0x3c, 0x04, 0x60, 0x00, 0x10,
-  0x00, 0x00, 0x3d, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
-  0x33, 0x11, 0x10, 0x06, 0x23, 0x22, 0x26, 0x3d, 0x84, 0x46, 0x5d, 0x29,
-  0x27, 0x88, 0x8f, 0xa7, 0x40, 0x81, 0x3d, 0xb9, 0x3c, 0x3d, 0x4d, 0x46,
-  0xd7, 0x02, 0x79, 0xfd, 0x87, 0xfe, 0xe6, 0xea, 0x2c, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x26, 0x04, 0x60, 0x10, 0x06,
-  0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x03, 0x96,
-  0x04, 0x7b, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x37, 0x17, 0x07,
-  0x11, 0x21, 0x15, 0x21, 0x11, 0x07, 0x27, 0x37, 0xa7, 0xa7, 0x7b, 0x45,
-  0xc0, 0x02, 0x48, 0xfd, 0x11, 0x63, 0x42, 0xa5, 0x04, 0x7b, 0xfe, 0x64,
-  0x61, 0x6a, 0x97, 0xfe, 0x6b, 0xaa, 0x01, 0xbc, 0x4e, 0x6a, 0x83, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8, 0x04, 0x60, 0x10, 0x06,
-  0x03, 0xd0, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
-  0x04, 0x60, 0x10, 0x06, 0x03, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90, 0x04, 0x7b, 0x10, 0x06,
-  0x02, 0x16, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0x00, 0x2d, 0x04, 0x89,
-  0x04, 0x31, 0x00, 0x0a, 0x00, 0x16, 0x00, 0x00, 0x01, 0x34, 0x26, 0x20,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x14, 0x00, 0x23, 0x22,
-  0x00, 0x35, 0x34, 0x00, 0x33, 0x32, 0x00, 0x03, 0xfc, 0xd0, 0xfe, 0x96,
-  0xd0, 0xd1, 0xb4, 0xb3, 0xd2, 0x8c, 0xfe, 0xe7, 0xf8, 0xf8, 0xfe, 0xe7,
-  0x01, 0x19, 0xf8, 0xf8, 0x01, 0x19, 0x02, 0x2f, 0x94, 0xac, 0xab, 0x95,
-  0x93, 0xac, 0xac, 0x93, 0xf0, 0xfe, 0xee, 0x01, 0x12, 0xf0, 0xf1, 0x01,
-  0x11, 0xfe, 0xef, 0x00, 0x00, 0x01, 0x00, 0x65, 0x00, 0x74, 0x04, 0x89,
-  0x03, 0xea, 0x00, 0x18, 0x00, 0x00, 0x25, 0x23, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x20, 0x06, 0x15, 0x14, 0x16, 0x17, 0x23, 0x2e, 0x01, 0x35, 0x34,
-  0x00, 0x33, 0x32, 0x00, 0x11, 0x14, 0x06, 0x04, 0x49, 0x9b, 0x27, 0x27,
-  0xcd, 0xfe, 0x8f, 0xcc, 0x27, 0x27, 0x9a, 0x20, 0x20, 0x01, 0x1e, 0xf3,
-  0xf7, 0x01, 0x1a, 0x1f, 0x74, 0x4e, 0x9d, 0x50, 0xb3, 0xc6, 0xc6, 0xb3,
-  0x50, 0x9d, 0x4e, 0x4d, 0xa5, 0x5d, 0xfd, 0x01, 0x2a, 0xfe, 0xd3, 0xfe,
-  0xfa, 0x55, 0xa2, 0x00, 0x00, 0x03, 0x00, 0x2d, 0x00, 0x05, 0x04, 0xc6,
-  0x04, 0x59, 0x00, 0x09, 0x00, 0x13, 0x00, 0x2b, 0x00, 0x00, 0x09, 0x01,
-  0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x3e, 0x01, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x27, 0x3e, 0x01, 0x33, 0x32, 0x00,
-  0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x00,
-  0x35, 0x34, 0x36, 0x37, 0x27, 0x37, 0x03, 0x53, 0xfd, 0xec, 0x26, 0x24,
-  0xd1, 0xb4, 0x47, 0x69, 0x8b, 0x25, 0x24, 0xd3, 0xbe, 0x41, 0x63, 0x29,
-  0x88, 0x45, 0xb1, 0x6c, 0xf8, 0x01, 0x19, 0x2e, 0x2f, 0x97, 0x47, 0xa1,
-  0x45, 0xb2, 0x6c, 0xf8, 0xfe, 0xe6, 0x2f, 0x2e, 0x97, 0x46, 0x01, 0x18,
-  0x01, 0xe7, 0x29, 0x67, 0x41, 0x93, 0xac, 0x14, 0x5c, 0x2a, 0x67, 0x3e,
-  0x97, 0xa9, 0x13, 0x14, 0x7d, 0x36, 0x36, 0xfe, 0xef, 0xf1, 0x5d, 0x9f,
-  0x43, 0x8b, 0x5f, 0x92, 0x35, 0x36, 0x01, 0x12, 0xf0, 0x60, 0xa1, 0x3f,
-  0x8b, 0x60, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x06, 0xfd,
-  0x04, 0x7b, 0x00, 0x26, 0x00, 0x2f, 0x00, 0x3d, 0x00, 0x00, 0x13, 0x35,
-  0x21, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x11, 0x10,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x27,
-  0x26, 0x37, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x01, 0x32,
-  0x37, 0x36, 0x10, 0x27, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x66, 0x02, 0xf9, 0x0b, 0x5c, 0x5b, 0xa5, 0x5f, 0xb4, 0x59, 0x5a, 0xbc,
-  0x5f, 0x90, 0xda, 0x49, 0x40, 0x5d, 0x5f, 0x7e, 0xd9, 0x7a, 0x7b, 0x7b,
-  0x7a, 0xd9, 0x7e, 0x5f, 0x5f, 0x3c, 0x46, 0xd1, 0x80, 0xcc, 0x77, 0x76,
-  0xa6, 0x02, 0x4a, 0x4a, 0x7b, 0x8a, 0x52, 0x54, 0x0d, 0x01, 0xd4, 0x85,
-  0x4d, 0x4e, 0x4d, 0x4d, 0x86, 0x85, 0x9a, 0x4d, 0x4d, 0x02, 0x00, 0x5a,
-  0xbe, 0x64, 0x63, 0x34, 0x34, 0xae, 0x2a, 0x2c, 0x6e, 0x6d, 0x6e, 0x36,
-  0x37, 0x9d, 0x9c, 0xfe, 0xed, 0xfe, 0xec, 0x9c, 0x9c, 0x37, 0x38, 0x6c,
-  0x6b, 0x70, 0x91, 0x92, 0xc4, 0x98, 0x5a, 0x59, 0x57, 0x57, 0x9e, 0xfe,
-  0xb4, 0x73, 0x74, 0x01, 0x92, 0x74, 0x73, 0xe8, 0xc8, 0xc7, 0x74, 0x75,
-  0x00, 0x01, 0x00, 0x65, 0x02, 0x2f, 0x04, 0x03, 0x04, 0x7b, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x23, 0x10, 0x12,
-  0x33, 0x32, 0x12, 0x11, 0x03, 0x53, 0x9a, 0x85, 0x85, 0x9b, 0xae, 0xf5,
-  0xd9, 0xd8, 0xf7, 0x02, 0x2f, 0xc7, 0xe9, 0xe7, 0xc9, 0x01, 0x14, 0x01,
-  0x38, 0xfe, 0xc8, 0xfe, 0xec, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x02, 0x2f, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x35, 0x33, 0x10, 0x02, 0x23, 0x22, 0x02, 0x11,
-  0x01, 0x15, 0x9b, 0x84, 0x86, 0x9a, 0xaf, 0xf6, 0xd9, 0xd8, 0xf6, 0x02,
-  0x2f, 0xc7, 0xe9, 0xe7, 0xc9, 0xfe, 0xec, 0xfe, 0xc8, 0x01, 0x38, 0x01,
-  0x14, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x87, 0x00, 0x00, 0x03, 0x6b,
-  0x04, 0x60, 0x00, 0x07, 0x00, 0x11, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32,
-  0x36, 0x34, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16, 0x10, 0x06, 0x2b, 0x01,
-  0x11, 0x23, 0x01, 0x2d, 0xe7, 0x52, 0x59, 0x59, 0x52, 0xfe, 0x74, 0x01,
-  0x8c, 0xa9, 0xae, 0xae, 0xa9, 0xe7, 0xa5, 0x03, 0xc5, 0xfe, 0x98, 0x5e,
-  0xac, 0x5e, 0x9b, 0xaa, 0xfe, 0xb6, 0xaa, 0xfe, 0x3e, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x03, 0xa8, 0x04, 0x60, 0x00, 0x16,
-  0x00, 0x21, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x33,
-  0x21, 0x11, 0x23, 0x11, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x23, 0x13,
-  0x36, 0x37, 0x36, 0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x3b, 0x01, 0x01, 0x89, 0x5f, 0x65, 0x60, 0x62, 0xc3, 0x01, 0x5d, 0xa6,
-  0x99, 0x57, 0x35, 0x35, 0x39, 0x92, 0xaf, 0x9d, 0x2f, 0x2f, 0x30, 0x01,
-  0xa9, 0xb3, 0x6b, 0x38, 0x3a, 0x3a, 0x38, 0x6b, 0xb3, 0x02, 0x0d, 0x1b,
-  0x8c, 0x69, 0xa2, 0x51, 0x50, 0xfb, 0xa0, 0x01, 0xd9, 0x25, 0x24, 0x71,
-  0xfe, 0xe1, 0x01, 0x32, 0x5e, 0x36, 0x36, 0x01, 0xc9, 0x2a, 0x2a, 0x54,
-  0x53, 0x2b, 0x2b, 0x00, 0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x03, 0xa8,
-  0x04, 0x60, 0x00, 0x16, 0x00, 0x21, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
-  0x27, 0x03, 0x33, 0x13, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x11, 0x33, 0x11,
-  0x21, 0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x01, 0x89, 0x31, 0x30, 0x2f, 0x2f,
-  0x9d, 0xaf, 0x92, 0x39, 0x35, 0x35, 0x57, 0x99, 0xa6, 0xfe, 0xa3, 0xc3,
-  0x62, 0x60, 0x65, 0x01, 0xd7, 0xb3, 0x6b, 0x38, 0x3a, 0x3a, 0x38, 0x6b,
-  0x02, 0x53, 0x11, 0x36, 0x36, 0x5e, 0x01, 0x32, 0xfe, 0xe1, 0x71, 0x24,
-  0x25, 0x01, 0xd9, 0xfb, 0xa0, 0x50, 0x51, 0xa2, 0x69, 0x8c, 0xfe, 0x63,
-  0x01, 0x51, 0x2b, 0x2b, 0x53, 0x54, 0x2a, 0x2a, 0xff, 0xff, 0x00, 0x36,
-  0x00, 0x00, 0x03, 0xfc, 0x04, 0x60, 0x10, 0x06, 0x03, 0xd6, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0xff, 0xe0, 0x03, 0xac, 0x04, 0x60, 0x00, 0x0f,
-  0x00, 0x00, 0x24, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x06, 0x20,
-  0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x01, 0xb5, 0xe9, 0x67, 0xa7, 0xc4,
-  0xfe, 0x83, 0xc4, 0xa7, 0x7d, 0x8e, 0xa2, 0x02, 0xb3, 0xfd, 0x3b, 0xdb,
-  0xe0, 0xe0, 0xdb, 0x02, 0xc5, 0xfd, 0x4d, 0xa2, 0x00, 0x01, 0x00, 0x9c,
-  0x00, 0x4c, 0x04, 0xa7, 0x03, 0xf6, 0x00, 0x13, 0x00, 0x00, 0x25, 0x21,
-  0x35, 0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15,
-  0x23, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x02, 0xff, 0xfd, 0x9e, 0x02, 0x5b,
-  0x90, 0x8f, 0xab, 0x94, 0xfd, 0xc5, 0x03, 0xf0, 0x9b, 0x5c, 0x59, 0xd8,
-  0x4c, 0xb8, 0x7c, 0x7c, 0x96, 0xac, 0xb8, 0xb8, 0x42, 0xb2, 0x74, 0xc2,
-  0xc8, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x9c, 0x00, 0x4e, 0x06, 0x2c,
-  0x03, 0xf8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x35,
-  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x05, 0x21, 0x35, 0x21, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15, 0x23, 0x1e, 0x01, 0x15,
-  0x14, 0x06, 0x9d, 0xb5, 0xb5, 0xb5, 0x03, 0x32, 0xfd, 0x9d, 0x02, 0x5c,
-  0x8f, 0x90, 0xac, 0x93, 0xfd, 0xc4, 0x03, 0xf0, 0x9a, 0x5b, 0x5a, 0xd8,
-  0x02, 0x78, 0xcc, 0xcc, 0xfe, 0x7a, 0xca, 0xca, 0xa4, 0xb8, 0x7c, 0x7c,
-  0x94, 0xae, 0xb8, 0xb8, 0x44, 0xb0, 0x76, 0xc0, 0xc8, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x2a, 0xfe, 0x18, 0x04, 0x33, 0x04, 0x7b, 0x00, 0x26,
-  0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x23, 0x21, 0x35,
-  0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15, 0x23, 0x1e,
-  0x01, 0x15, 0x14, 0x07, 0x06, 0x03, 0x59, 0x6f, 0x6b, 0x6e, 0x6f, 0xcb,
-  0xfd, 0x9f, 0x02, 0x5b, 0x91, 0x8d, 0xab, 0x94, 0xfd, 0xc6, 0x02, 0x5b,
-  0x92, 0x45, 0x47, 0x57, 0x55, 0x93, 0xfd, 0xc6, 0x03, 0xf0, 0x9c, 0x5c,
-  0x59, 0x38, 0x38, 0x01, 0x0c, 0x45, 0xc0, 0x82, 0xaf, 0x5f, 0x5f, 0xb9,
-  0x72, 0x75, 0x8f, 0xa6, 0xb9, 0x39, 0x39, 0x77, 0x8d, 0x53, 0x53, 0xb9,
-  0xb9, 0x3f, 0xb0, 0x79, 0x7a, 0x56, 0x55, 0x00, 0xff, 0xff, 0x00, 0x36,
-  0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x10, 0x06, 0x00, 0x59, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97, 0x04, 0x60, 0x10, 0x06,
-  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79,
-  0x04, 0x60, 0x10, 0x06, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6c,
-  0xff, 0xe3, 0x03, 0x5b, 0x04, 0x60, 0x00, 0x17, 0x00, 0x00, 0x37, 0x16,
-  0x33, 0x32, 0x36, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x13, 0x25, 0x35, 0x21,
-  0x15, 0x03, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x20, 0x27, 0x7c, 0x91,
-  0xbe, 0x73, 0x77, 0x6f, 0x63, 0x72, 0xef, 0xfe, 0x0c, 0x02, 0xb3, 0xef,
-  0x3f, 0x88, 0x64, 0xce, 0xfe, 0xa4, 0xb5, 0xbd, 0x42, 0x64, 0xbb, 0x64,
-  0x90, 0x01, 0x3e, 0x01, 0x93, 0x93, 0xfe, 0xc2, 0x4a, 0x9f, 0x6d, 0xa0,
-  0xb6, 0x37, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa1, 0x00, 0x00, 0x03, 0x96,
-  0x04, 0x7b, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0xa1, 0x02, 0xf5, 0xfd, 0xc1, 0x04, 0x7b, 0xaa, 0xfc, 0x2f, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x10, 0x06,
-  0x02, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0x88,
-  0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x03, 0x88, 0xa4, 0xfe, 0x48, 0xa4, 0x04, 0x60, 0xfb, 0xa0,
-  0x03, 0xb7, 0xfc, 0x49, 0x04, 0x60, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87,
-  0x00, 0x00, 0x03, 0x6b, 0x04, 0x60, 0x10, 0x06, 0x04, 0xd1, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x51, 0x00, 0x00, 0x03, 0xef, 0x04, 0x60, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x36, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11,
-  0x10, 0x07, 0x06, 0x07, 0x15, 0x23, 0x35, 0x26, 0x27, 0x26, 0x19, 0x01,
-  0x33, 0x11, 0x14, 0x17, 0x16, 0x17, 0x01, 0xcd, 0xa5, 0x4d, 0x33, 0x4e,
-  0xae, 0x7a, 0x62, 0xa0, 0xa5, 0x9e, 0x62, 0x7c, 0xb0, 0x4e, 0x33, 0x4b,
-  0x04, 0x60, 0xfd, 0x31, 0x1a, 0x4d, 0x73, 0xc9, 0x01, 0x2c, 0xfe, 0xd4,
-  0xfe, 0xec, 0x9c, 0x7d, 0x19, 0xee, 0xee, 0x19, 0x7d, 0x9c, 0x01, 0x14,
-  0x01, 0x2c, 0xfe, 0xd4, 0xc7, 0x75, 0x4d, 0x1a, 0xff, 0xff, 0x00, 0x44,
-  0x00, 0x00, 0x04, 0x02, 0x04, 0x60, 0x10, 0x06, 0x03, 0xcf, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x09, 0x02, 0x9c, 0x03, 0x11, 0x05, 0xe0, 0x00, 0x02,
-  0x00, 0x0a, 0x00, 0x00, 0x01, 0x03, 0x21, 0x03, 0x33, 0x01, 0x23, 0x27,
-  0x21, 0x07, 0x23, 0x01, 0x8d, 0x9c, 0x01, 0x38, 0xdd, 0x82, 0x01, 0x43,
-  0x77, 0x4d, 0xfe, 0x82, 0x4d, 0x79, 0x05, 0x71, 0xfe, 0x60, 0x02, 0x0f,
-  0xfc, 0xbc, 0xd6, 0xd6, 0x00, 0x02, 0x00, 0x04, 0x02, 0x9c, 0x04, 0x21,
-  0x05, 0xe0, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x01, 0x15, 0x21, 0x15,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x35, 0x21, 0x07, 0x23, 0x01,
-  0x17, 0x03, 0x21, 0x11, 0x04, 0x16, 0xfe, 0x5c, 0x01, 0x93, 0xfe, 0x6d,
-  0x01, 0xaf, 0xfd, 0xde, 0xfe, 0xd5, 0x5b, 0x75, 0x01, 0x63, 0x4e, 0xbb,
-  0x01, 0x05, 0x05, 0xe0, 0x5f, 0xf8, 0x5f, 0xfe, 0xd1, 0x5f, 0xd6, 0xd6,
-  0x03, 0x44, 0x58, 0xfe, 0x49, 0x01, 0xb7, 0x00, 0x00, 0x03, 0x00, 0x72,
-  0x02, 0x9c, 0x02, 0xcb, 0x05, 0xe0, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x26,
-  0x00, 0x00, 0x13, 0x11, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x23, 0x03, 0x15, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
-  0x25, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x23, 0x21, 0xe5, 0xb7, 0x5d, 0x2c, 0x2d, 0x2d, 0x2c,
-  0x5d, 0xb7, 0xa9, 0x54, 0x29, 0x29, 0x29, 0x29, 0x54, 0xfe, 0xe4, 0x01,
-  0x25, 0x82, 0x47, 0x48, 0x25, 0x24, 0x47, 0x55, 0x5e, 0x9b, 0x8e, 0xfe,
-  0xd0, 0x04, 0x2b, 0xfe, 0xce, 0x26, 0x26, 0x4d, 0x4f, 0x25, 0x25, 0x01,
-  0x58, 0xfc, 0x1f, 0x1f, 0x40, 0x3f, 0x20, 0x1f, 0x5d, 0x36, 0x35, 0x64,
-  0x4c, 0x2e, 0x2d, 0x0b, 0x12, 0x72, 0x55, 0x70, 0x7a, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x72, 0x02, 0x9c, 0x03, 0x3a, 0x05, 0xe0, 0x00, 0x0a,
-  0x00, 0x15, 0x00, 0x00, 0x13, 0x11, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x23, 0x27, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x2b, 0x01, 0xe5, 0x8a, 0xaf, 0x52, 0x51, 0x51, 0x52, 0xaf, 0xfd, 0xeb,
-  0xf7, 0x72, 0x73, 0x73, 0x74, 0xf5, 0xeb, 0x05, 0x83, 0xfd, 0x76, 0x4e,
-  0x4f, 0xa9, 0xa8, 0x4e, 0x4e, 0x5d, 0x65, 0x65, 0xd7, 0xd8, 0x66, 0x65,
-  0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0x94, 0x05, 0xe0, 0x00, 0x0b,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x72, 0x02, 0x17, 0xfe, 0x5c, 0x01, 0x93, 0xfe, 0x6d, 0x01,
-  0xaf, 0xfd, 0xde, 0x05, 0xe0, 0x5f, 0xf8, 0x5f, 0xfe, 0xd1, 0x5f, 0x00,
-  0x00, 0x01, 0x00, 0x4a, 0x02, 0x9c, 0x02, 0x6d, 0x05, 0xe0, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x35,
-  0x21, 0x35, 0x02, 0x6c, 0xfd, 0xdf, 0x01, 0xae, 0xfe, 0x6d, 0x01, 0x93,
-  0xfe, 0x5c, 0x05, 0xe0, 0xfc, 0xbc, 0x5f, 0x01, 0x2f, 0x5f, 0xf8, 0x5f,
-  0x00, 0x01, 0x00, 0x40, 0x02, 0x8c, 0x03, 0x25, 0x05, 0xef, 0x00, 0x24,
-  0x00, 0x00, 0x01, 0x35, 0x23, 0x35, 0x21, 0x11, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x36, 0x02, 0xb3, 0xbb, 0x01, 0x2d, 0x43, 0x50, 0x4f, 0x5b,
-  0xc7, 0x70, 0x70, 0x70, 0x70, 0xc7, 0x53, 0x4a, 0x4a, 0x3f, 0x3f, 0x48,
-  0x47, 0x4e, 0x9c, 0x4e, 0x4e, 0x4e, 0x4e, 0x9c, 0x3c, 0x5f, 0x03, 0x13,
-  0xe1, 0x5d, 0xfe, 0x99, 0x2f, 0x17, 0x18, 0x72, 0x73, 0xcc, 0xcd, 0x73,
-  0x72, 0x14, 0x14, 0x27, 0x79, 0x35, 0x1b, 0x1b, 0x55, 0x56, 0xaa, 0xa9,
-  0x56, 0x55, 0x14, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf8,
-  0x05, 0xe0, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
-  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x72, 0x73, 0x01, 0x9f, 0x74, 0x74,
-  0xfe, 0x61, 0x73, 0x05, 0xe0, 0xfe, 0xa9, 0x01, 0x57, 0xfc, 0xbc, 0x01,
-  0x8e, 0xfe, 0x72, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x00, 0xe5,
-  0x05, 0xe0, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x72, 0x73,
-  0x73, 0x05, 0xe0, 0xfc, 0xbc, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xc3,
-  0x01, 0xb6, 0x00, 0xe5, 0x05, 0xe0, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x72,
-  0x73, 0x3b, 0x3a, 0x80, 0x2c, 0x24, 0x4b, 0x3f, 0x05, 0xe0, 0xfc, 0xf6,
-  0x97, 0x44, 0x45, 0x60, 0x54, 0x6c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72,
-  0x02, 0x9c, 0x03, 0x12, 0x05, 0xe0, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x72, 0x73, 0x01,
-  0x7b, 0x94, 0xfe, 0x5c, 0x01, 0xc2, 0x97, 0xfe, 0x6a, 0x73, 0x05, 0xe0,
-  0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe, 0x6d,
-  0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0x81, 0x05, 0xe0, 0x00, 0x05,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x21, 0x72, 0x73, 0x01, 0x9c,
-  0xfd, 0xf1, 0x05, 0xe0, 0xfd, 0x1b, 0x5f, 0x00, 0x00, 0x01, 0x00, 0x72,
-  0x02, 0x9c, 0x03, 0x79, 0x05, 0xe0, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33,
-  0x1b, 0x01, 0x33, 0x11, 0x23, 0x11, 0x03, 0x23, 0x03, 0x11, 0x23, 0x72,
-  0xaa, 0xd8, 0xda, 0xaa, 0x6f, 0xda, 0x73, 0xdb, 0x6f, 0x05, 0xe0, 0xfd,
-  0xc7, 0x02, 0x39, 0xfc, 0xbc, 0x02, 0xde, 0xfd, 0xc3, 0x02, 0x3d, 0xfd,
-  0x22, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf4,
-  0x05, 0xe0, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
-  0x23, 0x01, 0x11, 0x23, 0x72, 0x9a, 0x01, 0x78, 0x6f, 0x9b, 0xfe, 0x89,
-  0x6f, 0x05, 0xe0, 0xfd, 0x45, 0x02, 0xbb, 0xfc, 0xbc, 0x02, 0xbb, 0xfd,
-  0x45, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf4,
-  0x05, 0xe0, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x01, 0x23,
-  0x11, 0x33, 0x11, 0x01, 0x02, 0xf3, 0x6f, 0xfe, 0x88, 0x9a, 0x6f, 0x01,
-  0x77, 0x05, 0xe0, 0xfc, 0xbc, 0x02, 0xbb, 0xfd, 0x45, 0x03, 0x44, 0xfd,
-  0x45, 0x02, 0xbb, 0x00, 0x00, 0x02, 0x00, 0x40, 0x02, 0x8c, 0x03, 0x51,
-  0x05, 0xef, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x24, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x20, 0x27, 0x26, 0x10,
-  0x01, 0xc9, 0x7c, 0x4a, 0x49, 0x49, 0x4a, 0x7c, 0x7d, 0x49, 0x49, 0x49,
-  0x49, 0xfe, 0xd1, 0x01, 0x64, 0x6b, 0x6b, 0x6b, 0x6b, 0xfe, 0x9c, 0x6b,
-  0x6b, 0x05, 0x93, 0x5b, 0x5c, 0x9f, 0x9e, 0x5c, 0x5b, 0x5b, 0x5c, 0x9e,
-  0x9f, 0x5c, 0x5b, 0x5c, 0x76, 0x76, 0xc6, 0xc5, 0x76, 0x76, 0x75, 0x76,
-  0x01, 0x8c, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0xeb,
-  0x05, 0xef, 0x00, 0x0f, 0x00, 0x40, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x03, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x27, 0x35, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x01, 0x95, 0x67, 0x3d, 0x3d, 0x3d, 0x3d, 0x67, 0x68, 0x3e, 0x3c,
-  0x3c, 0x3c, 0x8a, 0x4a, 0x31, 0x30, 0x36, 0x22, 0x73, 0x5f, 0x36, 0x37,
-  0x2b, 0x3e, 0x4a, 0x82, 0x54, 0x50, 0x31, 0x30, 0x56, 0x61, 0x36, 0x37,
-  0x59, 0x57, 0xa6, 0xa5, 0xb0, 0x37, 0x37, 0x61, 0x61, 0x26, 0x31, 0x4a,
-  0x42, 0x92, 0x04, 0x29, 0x2b, 0x2b, 0x4c, 0x4b, 0x2c, 0x2b, 0x2b, 0x2c,
-  0x4b, 0x4c, 0x2b, 0x2b, 0x01, 0x35, 0x02, 0x23, 0x23, 0x2c, 0x26, 0x29,
-  0x19, 0x24, 0x25, 0x4c, 0x59, 0x18, 0x2b, 0x04, 0x38, 0x3a, 0x36, 0x69,
-  0x47, 0x32, 0x32, 0x12, 0x13, 0x37, 0x38, 0x50, 0x79, 0x41, 0x41, 0x82,
-  0x79, 0x50, 0x38, 0x37, 0x13, 0x12, 0x27, 0x32, 0x31, 0x49, 0x2e, 0x2a,
-  0x00, 0x02, 0x00, 0x72, 0x02, 0x9c, 0x02, 0x95, 0x05, 0xe0, 0x00, 0x09,
-  0x00, 0x15, 0x00, 0x00, 0x13, 0x11, 0x33, 0x32, 0x37, 0x36, 0x34, 0x27,
-  0x26, 0x23, 0x25, 0x21, 0x32, 0x17, 0x16, 0x14, 0x07, 0x06, 0x2b, 0x01,
-  0x11, 0x23, 0xe5, 0x90, 0x50, 0x2b, 0x2c, 0x2c, 0x2b, 0x50, 0xfe, 0xfd,
-  0x01, 0x03, 0x8e, 0x49, 0x49, 0x49, 0x49, 0x8e, 0x90, 0x73, 0x05, 0x83,
-  0xfe, 0xc6, 0x29, 0x29, 0x96, 0x29, 0x29, 0x5d, 0x3f, 0x40, 0xf6, 0x40,
-  0x3f, 0xfe, 0xb0, 0x00, 0x00, 0x02, 0x00, 0x72, 0x02, 0x9c, 0x03, 0x06,
-  0x05, 0xe0, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16,
-  0x1f, 0x01, 0x23, 0x27, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11,
-  0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x11, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x02, 0x04, 0x25, 0x22, 0x23, 0x23, 0x74,
-  0x7a, 0x6d, 0x2a, 0x27, 0x28, 0x44, 0x7c, 0x73, 0x01, 0x03, 0x91, 0x48,
-  0x47, 0x25, 0x26, 0xfe, 0x9b, 0x90, 0x52, 0x55, 0x55, 0x52, 0x04, 0x24,
-  0x0c, 0x29, 0x28, 0x47, 0xe4, 0xd6, 0x54, 0x1c, 0x1b, 0xfe, 0x9f, 0x03,
-  0x44, 0x3c, 0x3c, 0x79, 0x4f, 0x34, 0x34, 0x01, 0x4b, 0xfe, 0xd7, 0x4c,
-  0x49, 0x4a, 0x4a, 0x00, 0x00, 0x01, 0xff, 0xfc, 0x02, 0x9c, 0x02, 0xc9,
-  0x05, 0xe0, 0x00, 0x07, 0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x04, 0x02, 0xcd, 0xfe, 0xd3, 0x73, 0xfe, 0xd3, 0x05, 0xe0,
-  0x5f, 0xfd, 0x1b, 0x02, 0xe5, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64,
-  0x02, 0x8c, 0x02, 0xed, 0x05, 0xe0, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14,
-  0x07, 0x06, 0x20, 0x27, 0x26, 0x35, 0x65, 0x73, 0x63, 0x6e, 0x6f, 0x31,
-  0x31, 0x73, 0x52, 0x52, 0xfe, 0xc0, 0x52, 0x52, 0x05, 0xe0, 0xfe, 0x04,
-  0x86, 0x76, 0x3b, 0x3b, 0x86, 0x01, 0xfc, 0xfd, 0xf6, 0xa3, 0x54, 0x53,
-  0x53, 0x54, 0xa3, 0x00, 0x00, 0x01, 0x00, 0x26, 0x02, 0x9c, 0x04, 0x57,
-  0x05, 0xe0, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x1b,
-  0x01, 0x33, 0x03, 0x23, 0x0b, 0x01, 0x23, 0x27, 0x73, 0xb2, 0xb1, 0x81,
-  0xb2, 0xb2, 0x75, 0xd6, 0x90, 0xb2, 0xb5, 0x90, 0x05, 0xe0, 0xfd, 0x3d,
-  0x02, 0xc3, 0xfd, 0x3d, 0x02, 0xc3, 0xfc, 0xbc, 0x02, 0xd6, 0xfd, 0x2a,
-  0x00, 0x02, 0x00, 0x45, 0x02, 0x8c, 0x02, 0x5e, 0x05, 0x1e, 0x00, 0x0c,
-  0x00, 0x2b, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x3d, 0x01, 0x37, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x01, 0x8e, 0x7e, 0x31, 0x31, 0x4a, 0x3e, 0x57, 0x34, 0x35, 0x68, 0x68,
-  0x24, 0x35, 0x36, 0x4c, 0x63, 0x73, 0x90, 0x8f, 0x92, 0x5f, 0x56, 0x36,
-  0x34, 0x33, 0x30, 0x3a, 0x36, 0x35, 0x33, 0x8a, 0x44, 0x44, 0x03, 0xd7,
-  0x1c, 0x1d, 0x45, 0x37, 0x40, 0x3d, 0x3d, 0x64, 0x17, 0x2b, 0xfe, 0x9a,
-  0x5f, 0x39, 0x1b, 0x1b, 0x6c, 0x5b, 0x69, 0x6c, 0x0a, 0x47, 0x4e, 0x0d,
-  0x0d, 0x1a, 0x60, 0x15, 0x0b, 0x0b, 0x46, 0x47, 0x00, 0x02, 0x00, 0x45,
-  0x02, 0x8c, 0x02, 0x5e, 0x05, 0x1e, 0x00, 0x0c, 0x00, 0x2d, 0x00, 0x00,
-  0x01, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x1d,
-  0x01, 0x07, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x16,
-  0x7e, 0x31, 0x31, 0x4a, 0x3f, 0x56, 0x34, 0x35, 0x69, 0x69, 0x24, 0x35,
-  0x36, 0x4c, 0x62, 0x3a, 0x39, 0x48, 0x47, 0x8f, 0x92, 0x5f, 0x56, 0x36,
-  0x34, 0x33, 0x30, 0x3a, 0x36, 0x36, 0x32, 0x8a, 0x44, 0x45, 0x03, 0xd3,
-  0x1c, 0x1d, 0x45, 0x37, 0x40, 0x3d, 0x3c, 0x65, 0x17, 0x2b, 0x01, 0x66,
-  0x5f, 0x39, 0x1b, 0x1b, 0x36, 0x36, 0x5a, 0x6a, 0x36, 0x36, 0x0a, 0x47,
-  0x4e, 0x0d, 0x0d, 0x1a, 0x60, 0x15, 0x0c, 0x0a, 0x46, 0x47, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x78, 0x05, 0x1e, 0x00, 0x13,
-  0x00, 0x1f, 0x00, 0x00, 0x01, 0x35, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x04, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x34, 0x27, 0x26, 0x22, 0x07,
-  0x02, 0x0f, 0x69, 0x69, 0x21, 0x31, 0x33, 0x46, 0x73, 0x49, 0x48, 0x48,
-  0x49, 0x73, 0x46, 0x33, 0x31, 0xfe, 0xbe, 0x2f, 0x2f, 0xa6, 0x30, 0x2f,
-  0x2f, 0x30, 0xa6, 0x2f, 0x04, 0xb0, 0x5f, 0xfd, 0x8d, 0x5e, 0x38, 0x1b,
-  0x1b, 0x5a, 0x5b, 0x01, 0x28, 0x5b, 0x5a, 0x1b, 0x1b, 0xa1, 0xe4, 0x41,
-  0x40, 0x40, 0x41, 0xe4, 0x41, 0x40, 0x40, 0x00, 0x00, 0x03, 0x00, 0x45,
-  0x02, 0x8c, 0x04, 0x38, 0x05, 0x1e, 0x00, 0x33, 0x00, 0x3c, 0x00, 0x4a,
-  0x00, 0x00, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x21,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x2b, 0x01, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37,
-  0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x25, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x3f, 0x01, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x1d, 0x01, 0x02, 0x49, 0x2a, 0x79, 0x4b, 0x7f, 0x4b,
-  0x4c, 0x01, 0xe0, 0x06, 0x3a, 0x3a, 0x68, 0x3a, 0x72, 0x39, 0x39, 0x3b,
-  0x3b, 0x3b, 0x60, 0x46, 0x46, 0x2c, 0x29, 0x3d, 0x3d, 0x52, 0x6b, 0x77,
-  0x48, 0x47, 0x8f, 0x92, 0x2f, 0x30, 0x55, 0x37, 0x67, 0x2f, 0x38, 0x6c,
-  0x34, 0x50, 0x78, 0xfe, 0x47, 0x01, 0x2e, 0x2f, 0x4d, 0x57, 0x35, 0x34,
-  0x08, 0xcd, 0x7f, 0x30, 0x31, 0x25, 0x24, 0x3f, 0x57, 0x35, 0x34, 0x02,
-  0xf3, 0x33, 0x34, 0x51, 0x52, 0x8c, 0x32, 0x6b, 0x38, 0x38, 0x1e, 0x1d,
-  0x61, 0x18, 0x0c, 0x0c, 0x22, 0x21, 0x43, 0x43, 0x22, 0x21, 0x68, 0x5e,
-  0x6a, 0x36, 0x36, 0x0a, 0x47, 0x27, 0x27, 0x1a, 0x1a, 0x60, 0x15, 0x16,
-  0x36, 0xda, 0x54, 0x32, 0x33, 0x31, 0x31, 0x58, 0x36, 0x1c, 0x1d, 0x45,
-  0x37, 0x20, 0x20, 0x3d, 0x3c, 0x65, 0x17, 0x00, 0x00, 0x02, 0x00, 0x69,
-  0x02, 0x8c, 0x02, 0xa2, 0x06, 0x03, 0x00, 0x0b, 0x00, 0x1d, 0x00, 0x00,
-  0x00, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x14, 0x17, 0x16, 0x32, 0x37,
-  0x01, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x15, 0x23, 0x11, 0x33, 0x02, 0x35, 0x2f, 0x2f, 0xa6, 0x30,
-  0x2e, 0x2e, 0x30, 0xa6, 0x2f, 0xfe, 0xcd, 0x20, 0x65, 0x45, 0x74, 0x48,
-  0x48, 0x48, 0x48, 0x74, 0x45, 0x65, 0x20, 0x6a, 0x6a, 0x03, 0x63, 0xe4,
-  0x40, 0x41, 0x41, 0x40, 0xe4, 0x40, 0x41, 0x41, 0x01, 0x8d, 0x38, 0x36,
-  0x5a, 0x5b, 0xfe, 0xd8, 0x5b, 0x5a, 0x36, 0x38, 0x5e, 0x03, 0x67, 0x00,
-  0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x78, 0x06, 0x03, 0x00, 0x13,
-  0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x04, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x34, 0x27, 0x26, 0x22, 0x07,
-  0x02, 0x0f, 0x69, 0x69, 0x21, 0x31, 0x33, 0x46, 0x73, 0x48, 0x49, 0x49,
-  0x48, 0x73, 0x46, 0x33, 0x31, 0xfe, 0xbe, 0x2f, 0x2f, 0xa6, 0x30, 0x2f,
-  0x2f, 0x30, 0xa6, 0x2f, 0x04, 0xb0, 0x01, 0x53, 0xfc, 0x99, 0x5e, 0x38,
-  0x1b, 0x1b, 0x5a, 0x5b, 0x01, 0x28, 0x5b, 0x5a, 0x1b, 0x1b, 0xa1, 0xe4,
-  0x40, 0x41, 0x41, 0x40, 0xe4, 0x40, 0x41, 0x41, 0x00, 0x02, 0x00, 0x3f,
-  0x02, 0x8c, 0x02, 0x8d, 0x05, 0x1e, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x00,
-  0x01, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x07, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
-  0x02, 0x8c, 0xfe, 0x21, 0x07, 0x3a, 0x3a, 0x68, 0x3c, 0x39, 0x37, 0x38,
-  0x38, 0x3b, 0x3b, 0x3d, 0x98, 0x58, 0x59, 0x54, 0x54, 0x8f, 0x80, 0x4b,
-  0x4a, 0x68, 0x01, 0x2f, 0x2e, 0x4e, 0x57, 0x34, 0x35, 0x08, 0x03, 0xef,
-  0x32, 0x6a, 0x38, 0x38, 0x0f, 0x0e, 0x1d, 0x61, 0x18, 0x0c, 0x0c, 0x57,
-  0x57, 0x95, 0x9a, 0x5b, 0x5a, 0x51, 0x52, 0x6d, 0x54, 0x33, 0x32, 0x31,
-  0x30, 0x58, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x8d,
-  0x05, 0x1e, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x35, 0x21, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x37, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37,
-  0x40, 0x01, 0xe0, 0x07, 0x75, 0x67, 0x3d, 0x70, 0x38, 0x39, 0x76, 0x3c,
-  0x98, 0xb1, 0xa8, 0x8f, 0x80, 0x95, 0x68, 0x01, 0x5e, 0x4d, 0x58, 0x69,
-  0x07, 0x03, 0xbb, 0x32, 0x6b, 0x6f, 0x1d, 0x1d, 0x61, 0x18, 0x18, 0xae,
-  0x95, 0x9a, 0xb5, 0xa3, 0x6d, 0x54, 0x65, 0x62, 0x58, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x4b, 0x02, 0x8c, 0x02, 0x25, 0x05, 0x1f, 0x00, 0x32,
-  0x00, 0x00, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0xe0, 0x40, 0x22, 0x21, 0x41, 0x3f, 0x6f,
-  0x2b, 0x31, 0x30, 0x37, 0x37, 0x5b, 0x28, 0x43, 0x28, 0x28, 0x27, 0x26,
-  0x42, 0x58, 0x54, 0x4e, 0x29, 0x2c, 0x30, 0x30, 0x55, 0x35, 0x31, 0x2f,
-  0x29, 0x33, 0x30, 0x30, 0x2e, 0x87, 0x91, 0x26, 0x28, 0x03, 0xee, 0x0e,
-  0x24, 0x24, 0x34, 0x4f, 0x2c, 0x2c, 0x07, 0x07, 0x0d, 0x5e, 0x11, 0x0e,
-  0x19, 0x1a, 0x24, 0x27, 0x19, 0x19, 0x55, 0x1d, 0x1f, 0x31, 0x33, 0x1f,
-  0x20, 0x0b, 0x0a, 0x15, 0x60, 0x10, 0x07, 0x08, 0x66, 0x61, 0x3c, 0x29,
-  0x29, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x49, 0x02, 0x8c, 0x02, 0x24,
-  0x05, 0x1f, 0x00, 0x31, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x8f, 0x3f, 0x44,
-  0x41, 0x40, 0x6e, 0x2b, 0x31, 0x30, 0x38, 0x37, 0x2d, 0x2e, 0x29, 0x43,
-  0x4f, 0x26, 0x26, 0x42, 0x58, 0x54, 0x4d, 0x29, 0x2d, 0x30, 0x31, 0x55,
-  0x34, 0x31, 0x30, 0x28, 0x33, 0x5f, 0x2e, 0x86, 0x4a, 0x49, 0x27, 0x27,
-  0x03, 0xbc, 0x0d, 0x48, 0x34, 0x4f, 0x2d, 0x2b, 0x06, 0x07, 0x0e, 0x5d,
-  0x10, 0x07, 0x08, 0x34, 0x24, 0x27, 0x19, 0x19, 0x55, 0x1c, 0x20, 0x31,
-  0x32, 0x20, 0x1f, 0x0a, 0x0b, 0x14, 0x60, 0x0f, 0x10, 0x33, 0x33, 0x61,
-  0x3c, 0x29, 0x29, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x01, 0xad, 0x02, 0x78,
-  0x05, 0x1e, 0x00, 0x0d, 0x00, 0x31, 0x00, 0x00, 0x00, 0x34, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x17, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x35, 0x33, 0x02, 0x0f,
-  0x2e, 0x2f, 0x55, 0x53, 0x2f, 0x2f, 0x2f, 0x2f, 0x53, 0x55, 0x2f, 0x97,
-  0x48, 0x48, 0x95, 0x37, 0x31, 0x31, 0x2e, 0x2e, 0x2d, 0x2d, 0x2e, 0x67,
-  0x33, 0x33, 0x20, 0x32, 0x33, 0x46, 0x75, 0x47, 0x48, 0x48, 0x47, 0x75,
-  0x46, 0x33, 0x32, 0x20, 0x69, 0x03, 0x6d, 0xe0, 0x3d, 0x3e, 0x3e, 0x3d,
-  0xe0, 0x3d, 0x3e, 0x3e, 0x46, 0xa0, 0x4e, 0x4f, 0x09, 0x08, 0x10, 0x65,
-  0x19, 0x0c, 0x0b, 0x34, 0x35, 0x6b, 0x33, 0x37, 0x1c, 0x1b, 0x58, 0x58,
-  0x01, 0x22, 0x58, 0x58, 0x1b, 0x1c, 0x37, 0x5f, 0x00, 0x02, 0x00, 0x6d,
-  0x01, 0xa8, 0x00, 0xd7, 0x05, 0x0f, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x23, 0x15, 0x35, 0x33, 0x15, 0x6e, 0x68, 0x68, 0x68,
-  0x05, 0x0f, 0xfd, 0x8d, 0xf4, 0x82, 0x82, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x02, 0x9c, 0x02, 0x9d, 0x06, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x69, 0x6a, 0x01,
-  0x37, 0x85, 0xfe, 0xaf, 0x01, 0x5f, 0x88, 0xfe, 0xbe, 0x6a, 0x06, 0x03,
-  0xfd, 0xfe, 0x01, 0x0e, 0xfe, 0xdb, 0xfe, 0xb2, 0x01, 0x32, 0xfe, 0xce,
-  0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x04, 0x09, 0x05, 0x1e, 0x00, 0x22,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x3e,
-  0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x02, 0x6d, 0x68, 0x41, 0x44, 0x50, 0x5d, 0x6a, 0x6a, 0x23, 0x64,
-  0x45, 0x44, 0x61, 0x18, 0x27, 0x6d, 0x49, 0x64, 0x6b, 0x68, 0x41, 0x43,
-  0x50, 0x5f, 0x03, 0xfe, 0xfe, 0x9e, 0x01, 0x77, 0x5b, 0x57, 0x6b, 0x5c,
-  0xfe, 0x9e, 0x02, 0x73, 0x61, 0x39, 0x37, 0x45, 0x42, 0x45, 0x42, 0x89,
-  0x7e, 0xfe, 0x85, 0x01, 0x77, 0x5a, 0x58, 0x6b, 0x00, 0x01, 0x00, 0x69,
-  0x01, 0xad, 0x02, 0x7e, 0x05, 0x1e, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x11,
-  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x02, 0x7d, 0x2f, 0x2e, 0x66, 0x90, 0x84,
-  0x3c, 0x2b, 0x46, 0x47, 0x54, 0x61, 0x6a, 0x6a, 0x25, 0x32, 0x33, 0x43,
-  0x6d, 0x38, 0x38, 0x04, 0x17, 0xfe, 0x7a, 0x78, 0x36, 0x36, 0x58, 0x36,
-  0x56, 0x01, 0x82, 0x59, 0x59, 0x6b, 0x5c, 0xfe, 0x9e, 0x02, 0x73, 0x61,
-  0x38, 0x1c, 0x1c, 0x42, 0x44, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f,
-  0x02, 0x8c, 0x02, 0x88, 0x05, 0x1e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x27, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
-  0x01, 0x64, 0x54, 0x62, 0x61, 0x55, 0x53, 0x61, 0x61, 0x53, 0x87, 0x9c,
-  0x9c, 0x87, 0x89, 0x9b, 0x9b, 0x04, 0xc7, 0x81, 0x71, 0x71, 0x81, 0x82,
-  0x70, 0x6f, 0x83, 0x57, 0xae, 0x9b, 0x9a, 0xaf, 0xaf, 0x9a, 0x9b, 0xae,
-  0x00, 0x01, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x37, 0x05, 0x1e, 0x00, 0x20,
-  0x00, 0x00, 0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x40,
-  0x2b, 0x2e, 0x2e, 0x31, 0x94, 0x55, 0x55, 0x54, 0x54, 0x90, 0x34, 0x30,
-  0x2e, 0x2c, 0x2c, 0x2d, 0x2c, 0x2e, 0x65, 0x38, 0x38, 0x38, 0x38, 0x65,
-  0x2e, 0x2c, 0x2d, 0x2c, 0x04, 0xf7, 0x14, 0x0a, 0x09, 0x58, 0x58, 0x99,
-  0x97, 0x59, 0x59, 0x0a, 0x0a, 0x14, 0x5f, 0x18, 0x0c, 0x0c, 0x3f, 0x40,
-  0xe6, 0x40, 0x3f, 0x0c, 0x0c, 0x18, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f,
-  0x03, 0xd5, 0x02, 0x88, 0x05, 0x1e, 0x00, 0x10, 0x00, 0x00, 0x01, 0x34,
-  0x27, 0x26, 0x22, 0x07, 0x06, 0x15, 0x23, 0x34, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x30, 0x02, 0x18, 0x30, 0x31, 0xa7, 0x31, 0x31, 0x6e, 0x9b,
-  0x89, 0x87, 0x4f, 0x4d, 0x03, 0xd5, 0x6f, 0x42, 0x41, 0x41, 0x40, 0x71,
-  0x9b, 0xae, 0x57, 0x57, 0x9b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f,
-  0x02, 0x8c, 0x02, 0x88, 0x03, 0xd5, 0x00, 0x10, 0x00, 0x00, 0x13, 0x14,
-  0x17, 0x16, 0x32, 0x37, 0x36, 0x35, 0x33, 0x14, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x35, 0x30, 0xaf, 0x30, 0x31, 0xa7, 0x31, 0x31, 0x6e, 0x9b, 0x88,
-  0x88, 0x4e, 0x4e, 0x03, 0xd5, 0x6f, 0x42, 0x41, 0x41, 0x40, 0x71, 0x9b,
-  0xae, 0x57, 0x57, 0x9b, 0x00, 0x02, 0x00, 0x69, 0x01, 0xad, 0x02, 0xa2,
-  0x05, 0x1e, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x11, 0x23, 0x11,
-  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23,
-  0x22, 0x26, 0x24, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x14, 0x17, 0x16,
-  0x32, 0x37, 0xd3, 0x6a, 0x6a, 0x20, 0x65, 0x45, 0x74, 0x48, 0x48, 0x48,
-  0x48, 0x74, 0x45, 0x65, 0x01, 0x42, 0x2f, 0x2f, 0xa6, 0x30, 0x2e, 0x2e,
-  0x30, 0xa6, 0x2f, 0x02, 0xfa, 0xfe, 0xb3, 0x03, 0x62, 0x5f, 0x38, 0x36,
-  0x5a, 0x5b, 0xfe, 0xd8, 0x5b, 0x5a, 0x36, 0xa1, 0xe4, 0x40, 0x41, 0x41,
-  0x40, 0xe4, 0x40, 0x41, 0x41, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1f,
-  0x02, 0x9c, 0x01, 0xac, 0x05, 0xc1, 0x00, 0x14, 0x00, 0x00, 0x13, 0x15,
-  0x33, 0x15, 0x23, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
-  0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x35, 0xd4, 0xd8, 0xd8, 0x2c, 0x40,
-  0x6c, 0x6c, 0x78, 0x2e, 0x2e, 0x4c, 0x4c, 0x05, 0xc1, 0xb2, 0x50, 0xfe,
-  0xac, 0x4d, 0x2c, 0x56, 0x2d, 0x2c, 0x76, 0x01, 0x54, 0x50, 0xb2, 0x00,
-  0x00, 0x01, 0x00, 0x63, 0x02, 0x8c, 0x02, 0x77, 0x05, 0x0f, 0x00, 0x16,
-  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x63, 0x68, 0x23, 0x24, 0x46, 0x54, 0x31, 0x31, 0x69, 0x69, 0x26,
-  0x32, 0x32, 0x43, 0x6d, 0x71, 0x03, 0x94, 0x01, 0x7b, 0xfe, 0x88, 0x59,
-  0x2c, 0x2d, 0x36, 0x35, 0x5c, 0x01, 0x63, 0xfd, 0x8d, 0x60, 0x39, 0x1c,
-  0x1b, 0x86, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0x02, 0xc7, 0x02, 0xee,
-  0x04, 0xd4, 0x00, 0x16, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x32, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15, 0x23, 0x1e,
-  0x01, 0x15, 0x14, 0x07, 0x06, 0x01, 0xe3, 0xfe, 0x80, 0x01, 0x7c, 0x5b,
-  0x2d, 0x2d, 0x36, 0x36, 0x5d, 0xfe, 0x98, 0x02, 0x7b, 0x62, 0x3a, 0x38,
-  0x44, 0x44, 0x02, 0xc7, 0x67, 0x23, 0x22, 0x46, 0x53, 0x31, 0x30, 0x67,
-  0x67, 0x25, 0x64, 0x41, 0x6c, 0x38, 0x38, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x02, 0x8d, 0x04, 0x09, 0x05, 0x10, 0x00, 0x28, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x26, 0x02, 0x16, 0x27, 0x36, 0x37, 0x4a, 0x63, 0x6c, 0x6a,
-  0x20, 0x20, 0x42, 0x51, 0x30, 0x2f, 0x68, 0x20, 0x21, 0x43, 0x50, 0x2f,
-  0x30, 0x68, 0x68, 0x24, 0x32, 0x32, 0x44, 0x46, 0x61, 0x03, 0x15, 0x45,
-  0x21, 0x22, 0x8a, 0x7f, 0x01, 0x7a, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x36,
-  0x34, 0x5c, 0x01, 0x63, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x36, 0x36, 0x5a,
-  0x01, 0x63, 0xfd, 0x8d, 0x62, 0x3b, 0x1b, 0x1c, 0x46, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x22, 0x02, 0x9c, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x06,
-  0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x23, 0x22, 0x6f, 0xc7,
-  0xc6, 0x6e, 0xed, 0x8e, 0x05, 0x0f, 0xfd, 0xf2, 0x02, 0x0e, 0xfd, 0x8d,
-  0x00, 0x02, 0x00, 0x6c, 0x01, 0xad, 0x02, 0x92, 0x06, 0x0b, 0x00, 0x0e,
-  0x00, 0x1c, 0x00, 0x00, 0x13, 0x11, 0x23, 0x11, 0x10, 0x33, 0x32, 0x17,
-  0x16, 0x07, 0x16, 0x17, 0x12, 0x21, 0x26, 0x27, 0x16, 0x33, 0x32, 0x35,
-  0x34, 0x05, 0x35, 0x16, 0x35, 0x34, 0x23, 0x22, 0x15, 0xd5, 0x68, 0xf1,
-  0xf6, 0x01, 0x01, 0x63, 0x9e, 0x01, 0x01, 0xfe, 0xed, 0x77, 0x34, 0x3f,
-  0x71, 0xa3, 0xfe, 0xf8, 0xcf, 0x85, 0x95, 0x02, 0xc3, 0xfe, 0xea, 0x03,
-  0x5e, 0x01, 0x00, 0xd8, 0x99, 0x38, 0x33, 0x95, 0xfe, 0xf6, 0x01, 0xb8,
-  0x61, 0xb0, 0x9e, 0x0c, 0x5f, 0x04, 0xb7, 0x7b, 0xaf, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x12, 0x01, 0xad, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x0e,
-  0x00, 0x00, 0x1b, 0x02, 0x33, 0x01, 0x15, 0x23, 0x35, 0x03, 0x26, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0xcc, 0x8c, 0xc6, 0x6e, 0xff, 0x00, 0x68, 0xa7,
-  0x19, 0x36, 0x1c, 0x28, 0x6f, 0x04, 0xad, 0xfe, 0x7c, 0x01, 0xe6, 0xfd,
-  0x8d, 0xef, 0xef, 0x01, 0xd4, 0x47, 0x58, 0x00, 0x00, 0x02, 0x00, 0x3f,
-  0x02, 0x8c, 0x02, 0x88, 0x05, 0xef, 0x00, 0x1b, 0x00, 0x2b, 0x00, 0x00,
-  0x01, 0x26, 0x23, 0x22, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x20, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x35,
-  0x34, 0x33, 0x32, 0x17, 0x01, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x02, 0x3a, 0x3b, 0x87,
-  0x90, 0x96, 0x76, 0x42, 0x51, 0x4d, 0x4f, 0xfe, 0xf1, 0x4e, 0x4e, 0x4e,
-  0x1e, 0x2a, 0x58, 0xfa, 0x7d, 0x45, 0xfe, 0xea, 0x26, 0x1f, 0x31, 0x30,
-  0x31, 0x55, 0x53, 0x61, 0x33, 0x37, 0x48, 0x24, 0x05, 0x72, 0x28, 0x42,
-  0x34, 0x1a, 0x15, 0x3f, 0x4b, 0x9c, 0x94, 0x57, 0x58, 0x58, 0x57, 0x9a,
-  0x72, 0x5d, 0x24, 0x14, 0x2c, 0x4f, 0x98, 0x27, 0xfe, 0xf8, 0x11, 0x28,
-  0x40, 0xe4, 0x3f, 0x41, 0x82, 0x6a, 0x70, 0x36, 0x39, 0x06, 0x04, 0x00,
-  0x00, 0x02, 0x00, 0x3f, 0x01, 0xad, 0x02, 0xbc, 0x05, 0x14, 0x00, 0x0a,
-  0x00, 0x29, 0x00, 0x00, 0x01, 0x22, 0x15, 0x11, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x15, 0x23, 0x35, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x15,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x11, 0x34, 0x01, 0xd6,
-  0x25, 0x37, 0x35, 0x31, 0x32, 0x28, 0x1e, 0x4f, 0x49, 0x4d, 0x4d, 0x49,
-  0x74, 0x68, 0x71, 0x4b, 0x4d, 0x4d, 0x3a, 0x5d, 0x25, 0x21, 0x30, 0x30,
-  0x2c, 0x3f, 0x04, 0xbc, 0x51, 0xfe, 0x7f, 0x3a, 0x35, 0x7d, 0x74, 0x3f,
-  0x33, 0x58, 0x4a, 0x4f, 0xa5, 0x98, 0x5a, 0x55, 0xe2, 0xe1, 0x55, 0x58,
-  0x9a, 0xa0, 0x52, 0x3d, 0x10, 0x5c, 0x0c, 0x2c, 0x41, 0x6a, 0x71, 0x40,
-  0x3a, 0x01, 0x81, 0xa9, 0x00, 0x01, 0x00, 0x21, 0x01, 0xad, 0x02, 0x7e,
-  0x05, 0x10, 0x00, 0x17, 0x00, 0x00, 0x01, 0x27, 0x03, 0x23, 0x13, 0x03,
-  0x26, 0x2b, 0x01, 0x35, 0x17, 0x16, 0x1f, 0x01, 0x13, 0x33, 0x03, 0x13,
-  0x16, 0x3b, 0x01, 0x15, 0x27, 0x26, 0x01, 0x9f, 0x55, 0xad, 0x7c, 0xf7,
-  0x68, 0x1c, 0x57, 0x1c, 0x28, 0x93, 0x24, 0x54, 0xae, 0x7b, 0xf5, 0x66,
-  0x1c, 0x57, 0x1c, 0x27, 0x93, 0x02, 0x10, 0xd7, 0xfe, 0xc6, 0x01, 0xbc,
-  0x01, 0x07, 0x47, 0x58, 0x01, 0x04, 0x5d, 0xd7, 0x01, 0x3a, 0xfe, 0x44,
-  0xfe, 0xf8, 0x46, 0x59, 0x02, 0x04, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6d,
-  0x00, 0x00, 0x00, 0xd7, 0x03, 0x67, 0x12, 0x07, 0x07, 0xa1, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x01, 0xdd,
-  0x02, 0x82, 0x12, 0x07, 0x02, 0x75, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xff, 0xf0, 0x02, 0x77, 0x02, 0x73, 0x12, 0x07,
-  0x05, 0x0e, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x22,
-  0x00, 0x00, 0x02, 0x8d, 0x02, 0x73, 0x12, 0x07, 0x05, 0x11, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c, 0xff, 0x11, 0x02, 0x92,
-  0x03, 0x6f, 0x12, 0x07, 0x05, 0x12, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x12, 0xff, 0x11, 0x02, 0x8d, 0x02, 0x73, 0x12, 0x07,
-  0x05, 0x13, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6c,
-  0xff, 0x11, 0x02, 0xa4, 0x02, 0x82, 0x00, 0x10, 0x00, 0x1c, 0x00, 0x00,
-  0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26,
-  0x27, 0x11, 0x23, 0x11, 0x34, 0x05, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0xa0, 0x22, 0x56, 0x21, 0x68, 0x73, 0x90,
-  0x90, 0x73, 0x47, 0x63, 0x22, 0x68, 0x01, 0xcb, 0x5f, 0x52, 0x52, 0x60,
-  0x60, 0x52, 0x52, 0x5f, 0x02, 0x03, 0x39, 0x32, 0x14, 0xb5, 0xfe, 0xd8,
-  0xb6, 0x37, 0x38, 0xfe, 0xb3, 0x02, 0x22, 0x81, 0x7b, 0x71, 0x82, 0x82,
-  0x71, 0x72, 0x81, 0x81, 0xff, 0xff, 0x00, 0x3f, 0xff, 0x11, 0x02, 0xbc,
-  0x02, 0x78, 0x12, 0x07, 0x05, 0x15, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x21, 0xff, 0x11, 0x02, 0x7e, 0x02, 0x74, 0x12, 0x07,
-  0x05, 0x16, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xfe, 0x56, 0x04, 0x2d, 0x04, 0x7b, 0x00, 0x1c, 0x00, 0x28, 0x00, 0x00,
-  0x13, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x1d, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23,
-  0x22, 0x26, 0x27, 0x15, 0x23, 0x13, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0xa7, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49,
-  0x8e, 0x4a, 0xa3, 0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe3, 0xb9, 0x70,
-  0xa0, 0x33, 0xa6, 0xa6, 0x95, 0x86, 0x85, 0x94, 0x94, 0x85, 0x86, 0x95,
-  0x02, 0x46, 0x01, 0x1e, 0x01, 0x17, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd,
-  0xbf, 0x5b, 0x63, 0x62, 0xfe, 0xc6, 0xfe, 0xfd, 0xfe, 0xfc, 0xfe, 0xc6,
-  0x62, 0x63, 0xaa, 0x02, 0x23, 0xc8, 0xdc, 0xdc, 0xc8, 0xc7, 0xdc, 0xdc,
-  0xff, 0xff, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf8, 0x05, 0xe0, 0x10, 0x06,
-  0x04, 0xea, 0x00, 0x00, 0x00, 0x01, 0x00, 0x68, 0x00, 0x00, 0x02, 0x44,
-  0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x23, 0x11,
-  0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35,
-  0x33, 0x11, 0x68, 0x01, 0xdc, 0x98, 0x98, 0x98, 0x98, 0xfe, 0x24, 0x9f,
-  0x9f, 0x9f, 0x03, 0xbc, 0xa4, 0xa4, 0xfe, 0xac, 0xa4, 0xfe, 0xe0, 0xa4,
-  0xa4, 0x01, 0x20, 0xa4, 0x01, 0x54, 0x00, 0x00, 0x00, 0x03, 0x00, 0x2d,
-  0xfe, 0x56, 0x04, 0xa1, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x22, 0x00, 0x2b,
-  0x00, 0x00, 0x25, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x15,
-  0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x23, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x01, 0x21, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x01, 0x4e,
-  0xa7, 0x7a, 0x7a, 0xa7, 0x34, 0x9f, 0x6f, 0xb7, 0x73, 0x5c, 0x13, 0x77,
-  0x74, 0x0a, 0x68, 0x73, 0xb7, 0x6f, 0x9f, 0x01, 0xfe, 0xfd, 0xcf, 0x07,
-  0x43, 0x4b, 0x84, 0x83, 0x4c, 0x42, 0xfd, 0xda, 0x02, 0x29, 0x0e, 0x37,
-  0x4c, 0x83, 0x84, 0x4b, 0x38, 0xa8, 0xfd, 0xae, 0x03, 0xae, 0x90, 0x01,
-  0xcc, 0xaa, 0x64, 0x61, 0xa2, 0x82, 0xc3, 0x90, 0xea, 0x95, 0xa2, 0x61,
-  0x01, 0xc0, 0xae, 0x66, 0x74, 0x74, 0x66, 0x01, 0x3e, 0x84, 0x56, 0x74,
-  0x74, 0x56, 0x00, 0x00, 0x00, 0x01, 0x00, 0x82, 0xfe, 0x56, 0x01, 0xf8,
-  0x06, 0x14, 0x00, 0x10, 0x00, 0x00, 0x25, 0x15, 0x14, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x27, 0x37, 0x23, 0x11, 0x33, 0x11, 0x01,
-  0xf7, 0x93, 0xa2, 0x40, 0x2c, 0x5f, 0x22, 0x26, 0x03, 0x01, 0xa5, 0xa5,
-  0x9a, 0xae, 0xd6, 0xc0, 0x9c, 0x30, 0x36, 0x94, 0x14, 0x06, 0x14, 0xfa,
-  0x86, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x78,
-  0x05, 0x1e, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x00, 0x13, 0x15, 0x23, 0x11,
-  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x24, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x14,
-  0x17, 0x16, 0x32, 0x37, 0xa8, 0x68, 0x68, 0x22, 0x32, 0x32, 0x46, 0x73,
-  0x48, 0x49, 0x49, 0x48, 0x73, 0x46, 0x32, 0x32, 0x01, 0x42, 0x30, 0x2f,
-  0xa5, 0x30, 0x30, 0x30, 0x30, 0xa5, 0x2f, 0x02, 0xfa, 0x5f, 0x02, 0x73,
-  0x5e, 0x38, 0x1b, 0x1b, 0x5a, 0x5b, 0xfe, 0xd8, 0x5b, 0x5a, 0x1b, 0x1b,
-  0xa1, 0xe4, 0x41, 0x40, 0x40, 0x41, 0xe4, 0x41, 0x40, 0x40, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x37, 0x05, 0x1e, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x14,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x16, 0x02, 0x36, 0x2c, 0x2c,
-  0x2d, 0x2d, 0x66, 0x38, 0x38, 0x38, 0x38, 0x66, 0x2d, 0x2d, 0x2c, 0x2c,
-  0x2b, 0x5e, 0x35, 0x8f, 0xa9, 0xab, 0x94, 0x30, 0x2e, 0x2e, 0x04, 0xf7,
-  0x60, 0x18, 0x0c, 0x0c, 0x40, 0x3f, 0xe6, 0x3f, 0x40, 0x0c, 0x0c, 0x18,
-  0x5f, 0x14, 0x14, 0xb2, 0x97, 0x99, 0xb0, 0x09, 0x0a, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x3f, 0x02, 0x4b, 0x02, 0x37, 0x05, 0x1e, 0x00, 0x07,
-  0x00, 0x2b, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x35, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x07, 0x34, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x14, 0x17, 0x16, 0x17, 0x36, 0x33, 0x32, 0x17, 0x16, 0x23, 0x22,
-  0x01, 0x37, 0x22, 0x2b, 0x53, 0x01, 0x4a, 0x3a, 0x2f, 0x04, 0x56, 0x07,
-  0x20, 0x1c, 0x54, 0xab, 0x94, 0x2f, 0x2f, 0x2c, 0x2d, 0x2a, 0x2f, 0x2c,
-  0x2d, 0x66, 0x38, 0x38, 0x38, 0x02, 0x06, 0x2f, 0x6f, 0xa9, 0x01, 0x01,
-  0xbd, 0x2e, 0x02, 0xee, 0x0b, 0x20, 0x2a, 0x9a, 0x20, 0x26, 0x02, 0x3b,
-  0x2f, 0x13, 0x1d, 0x5a, 0x96, 0x99, 0xb0, 0x09, 0x0a, 0x14, 0x60, 0x17,
-  0x0d, 0x0c, 0x3f, 0x40, 0xe6, 0x40, 0x02, 0x05, 0x62, 0x8a, 0x69, 0x00,
-  0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x88, 0x06, 0x03, 0x00, 0x11,
-  0x00, 0x2e, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x37, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x27, 0x07, 0x27, 0x37, 0x27, 0x33, 0x17,
-  0x37, 0x17, 0x07, 0x01, 0xdb, 0x1d, 0x18, 0x19, 0x17, 0x5f, 0x34, 0x35,
-  0x63, 0x53, 0x51, 0x63, 0x0f, 0x0f, 0x05, 0x47, 0x21, 0x20, 0x51, 0x50,
-  0x82, 0x84, 0xa0, 0x9c, 0x7e, 0x0a, 0x0f, 0x0e, 0x19, 0x5a, 0xb5, 0x13,
-  0x9f, 0x67, 0x82, 0x48, 0xbc, 0x13, 0xa7, 0x04, 0x9c, 0x0a, 0x04, 0x05,
-  0x3d, 0x3c, 0x6d, 0x6a, 0x7c, 0x7c, 0x6a, 0x44, 0x35, 0x34, 0xa5, 0x50,
-  0x51, 0x50, 0x61, 0x8f, 0x57, 0x57, 0xae, 0x8f, 0x8c, 0xae, 0x02, 0x01,
-  0x03, 0x65, 0x3c, 0x38, 0x33, 0x72, 0x51, 0x3e, 0x36, 0x37, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x4b, 0x02, 0x8c, 0x02, 0x25, 0x05, 0x1f, 0x00, 0x31,
-  0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x06, 0x01, 0x90, 0x47, 0x26, 0x28, 0x49, 0x4a, 0x87,
-  0x2d, 0x30, 0x30, 0x32, 0x28, 0x30, 0x30, 0x35, 0x55, 0x31, 0x2f, 0x2c,
-  0x29, 0x4d, 0x54, 0x57, 0x42, 0x4d, 0x28, 0x27, 0x43, 0x29, 0x2e, 0x2d,
-  0x37, 0x37, 0x61, 0x2b, 0x6f, 0x40, 0x41, 0x44, 0x03, 0xee, 0x0d, 0x29,
-  0x29, 0x3c, 0x61, 0x33, 0x33, 0x08, 0x07, 0x10, 0x60, 0x15, 0x0a, 0x0b,
-  0x20, 0x1f, 0x33, 0x31, 0x1f, 0x1d, 0x55, 0x32, 0x27, 0x24, 0x1a, 0x19,
-  0x07, 0x07, 0x11, 0x5e, 0x0d, 0x0e, 0x2c, 0x2c, 0x4f, 0x34, 0x48, 0x00,
-  0x00, 0x01, 0x00, 0x1b, 0x02, 0x9c, 0x01, 0xb0, 0x06, 0x03, 0x00, 0x15,
-  0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x1d, 0x01, 0x33, 0x15,
-  0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36, 0x33,
-  0x01, 0xaf, 0x64, 0x38, 0x16, 0x16, 0xac, 0xac, 0x69, 0x63, 0x63, 0x32,
-  0x31, 0x6b, 0x06, 0x03, 0x55, 0x17, 0x16, 0x3a, 0x38, 0x50, 0xfd, 0xdd,
-  0x02, 0x23, 0x50, 0x2c, 0x69, 0x2f, 0x30, 0x00, 0x00, 0x01, 0xff, 0xeb,
-  0x01, 0xad, 0x01, 0x3a, 0x05, 0x0f, 0x00, 0x15, 0x00, 0x00, 0x13, 0x15,
-  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01,
-  0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0xd6, 0x2f, 0x2d, 0x67,
-  0x28, 0x1c, 0x3c, 0x15, 0x16, 0x67, 0x67, 0x68, 0x63, 0x02, 0x9c, 0x0b,
-  0x78, 0x36, 0x36, 0x58, 0x1b, 0x1c, 0x55, 0x0b, 0x50, 0x02, 0x23, 0xfd,
-  0xdd, 0x50, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x01, 0xad, 0x02, 0x78,
-  0x05, 0x0f, 0x00, 0x0c, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x35, 0x23, 0x22,
-  0x07, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x13, 0x11, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x33, 0x02, 0x0f, 0xb2, 0x53, 0x2f, 0x2f, 0x2f,
-  0x2f, 0x53, 0x55, 0x2f, 0x2e, 0x69, 0x48, 0x48, 0x95, 0x37, 0x31, 0x31,
-  0x2e, 0x2e, 0x2d, 0x2d, 0x2e, 0x67, 0x33, 0x33, 0x20, 0x32, 0x33, 0x46,
-  0x75, 0x47, 0x48, 0x48, 0x47, 0x75, 0x03, 0xdd, 0xeb, 0x3e, 0x3d, 0xe0,
-  0x3d, 0x3e, 0x3e, 0x3d, 0x01, 0xa2, 0xfd, 0xdb, 0xa0, 0x4e, 0x4f, 0x08,
-  0x09, 0x10, 0x65, 0x19, 0x0c, 0x0b, 0x34, 0x35, 0x6b, 0x33, 0x37, 0x1c,
-  0x1b, 0x58, 0x58, 0x91, 0x82, 0x58, 0x58, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0x01, 0xad, 0x02, 0x77, 0x05, 0x0f, 0x00, 0x16, 0x00, 0x00, 0x13, 0x11,
-  0x33, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
-  0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x63, 0x68, 0x23,
-  0x24, 0x46, 0x54, 0x31, 0x31, 0x69, 0x69, 0x26, 0x33, 0x31, 0x43, 0x6d,
-  0x71, 0x03, 0x94, 0x01, 0x7b, 0xfe, 0x88, 0x59, 0x2c, 0x2d, 0x36, 0x35,
-  0x5c, 0x01, 0x63, 0xfc, 0x9e, 0x01, 0x4f, 0x39, 0x1c, 0x1b, 0x86, 0x00,
-  0x00, 0x02, 0x00, 0x41, 0x02, 0x9c, 0x01, 0x6e, 0x06, 0x03, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x00, 0x13, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15,
-  0x23, 0x15, 0x23, 0x35, 0x11, 0x33, 0x15, 0x23, 0x42, 0x66, 0x69, 0x5c,
-  0x5c, 0x69, 0x69, 0x69, 0x03, 0x99, 0x5c, 0x01, 0x1a, 0xfe, 0xe6, 0x5c,
-  0xfd, 0xfd, 0x02, 0x6a, 0x82, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6d,
-  0x02, 0x9c, 0x01, 0x58, 0x05, 0x0f, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x11,
-  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x11, 0xd6,
-  0x15, 0x15, 0x3d, 0x1b, 0x28, 0x66, 0x5c, 0x05, 0x0f, 0xfe, 0x70, 0x55,
-  0x1c, 0x1b, 0x57, 0x6c, 0x77, 0x01, 0x90, 0x00, 0x00, 0x01, 0x00, 0x41,
-  0x02, 0x9c, 0x01, 0x6e, 0x05, 0x0f, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35,
-  0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x42, 0x01,
-  0x2b, 0x5f, 0x5f, 0xfe, 0xd5, 0x64, 0x04, 0xb3, 0x5c, 0x5c, 0xfe, 0x45,
-  0x5c, 0x5c, 0x01, 0xbb, 0x00, 0x01, 0x00, 0x41, 0x02, 0x9c, 0x01, 0x6e,
-  0x05, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x23, 0x15,
-  0x33, 0x15, 0x23, 0x15, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35, 0x23, 0x35,
-  0x33, 0x35, 0x42, 0x01, 0x2b, 0x5f, 0x5f, 0x5f, 0x5f, 0xfe, 0xd5, 0x64,
-  0x64, 0x64, 0x04, 0xb3, 0x5c, 0x5c, 0xbe, 0x5c, 0xa1, 0x5c, 0x5c, 0xa1,
-  0x5c, 0xbe, 0x00, 0x00, 0x00, 0x03, 0xff, 0x67, 0x01, 0xad, 0x01, 0x3d,
-  0x06, 0x03, 0x00, 0x03, 0x00, 0x12, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x33,
-  0x15, 0x23, 0x03, 0x22, 0x35, 0x34, 0x3b, 0x01, 0x11, 0x33, 0x11, 0x33,
-  0x15, 0x23, 0x06, 0x07, 0x06, 0x27, 0x23, 0x22, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x6e, 0x68, 0x68, 0x5b, 0xac, 0x99, 0x6e, 0x68, 0x67, 0x6d,
-  0x0a, 0x1f, 0x2d, 0x12, 0x67, 0x44, 0x02, 0x02, 0x46, 0x3c, 0x15, 0x0a,
-  0x06, 0x03, 0x82, 0xfc, 0x2c, 0x7c, 0x73, 0x02, 0x73, 0xfd, 0x8d, 0x57,
-  0x3f, 0x23, 0x35, 0x98, 0x1d, 0x24, 0x1b, 0x0d, 0x00, 0x01, 0x00, 0x6d,
-  0x01, 0xad, 0x01, 0x58, 0x06, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x11,
-  0x33, 0x11, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
-  0x35, 0x6e, 0x68, 0x15, 0x15, 0x3d, 0x1b, 0x28, 0x66, 0x5c, 0x02, 0xe4,
-  0x03, 0x1f, 0xfc, 0xe1, 0x53, 0x56, 0x1b, 0x1b, 0x58, 0x6c, 0x78, 0x00,
-  0x00, 0x01, 0x00, 0x51, 0x01, 0xad, 0x01, 0x3d, 0x06, 0x03, 0x00, 0x11,
-  0x00, 0x00, 0x01, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x27, 0x37, 0x23, 0x11, 0x33, 0x11, 0x01, 0x3d, 0x2e, 0x2f,
-  0x66, 0x28, 0x1c, 0x3b, 0x16, 0x18, 0x03, 0x02, 0x68, 0x68, 0x02, 0xf2,
-  0x61, 0x78, 0x36, 0x36, 0x58, 0x1b, 0x1e, 0x53, 0x0b, 0x03, 0x67, 0xfc,
-  0xef, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0x02, 0x9c, 0x02, 0x43,
-  0x05, 0x1e, 0x00, 0x05, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x21,
-  0x66, 0x72, 0x01, 0x6b, 0xfe, 0x23, 0x05, 0x1e, 0xfd, 0xdd, 0x5f, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0x01, 0xad, 0x04, 0x09, 0x05, 0x1e, 0x00, 0x34,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
-  0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x26, 0x37, 0x34,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x02, 0x5c, 0x27, 0x37, 0x36,
-  0x49, 0x64, 0x35, 0x36, 0x5c, 0x66, 0x91, 0x84, 0x3c, 0x2b, 0x01, 0x01,
-  0x41, 0x43, 0x50, 0x2f, 0x30, 0x68, 0x21, 0x20, 0x44, 0x50, 0x2f, 0x2e,
-  0x6a, 0x6a, 0x23, 0x32, 0x32, 0x45, 0x44, 0x31, 0x30, 0x04, 0x97, 0x45,
-  0x21, 0x21, 0x45, 0x44, 0x7e, 0xfe, 0x7a, 0x78, 0x6c, 0x58, 0x36, 0x56,
-  0x30, 0xe8, 0x3d, 0x2d, 0x5a, 0x58, 0x35, 0x36, 0x5c, 0xfe, 0x9e, 0x01,
-  0x77, 0x5b, 0x2c, 0x2b, 0x35, 0x36, 0x5c, 0xfe, 0x9e, 0x02, 0x73, 0x61,
-  0x39, 0x1c, 0x1b, 0x22, 0x23, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x01, 0xad, 0x04, 0x09, 0x05, 0x10, 0x00, 0x28, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x26, 0x02, 0x16, 0x27, 0x36, 0x37, 0x4a, 0x63, 0x6c, 0x6a,
-  0x20, 0x20, 0x42, 0x51, 0x30, 0x2f, 0x68, 0x20, 0x21, 0x43, 0x50, 0x2f,
-  0x30, 0x68, 0x68, 0x24, 0x32, 0x32, 0x44, 0x46, 0x61, 0x03, 0x15, 0x45,
-  0x22, 0x21, 0x8a, 0x7e, 0x01, 0x7b, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x35,
-  0x35, 0x5c, 0x01, 0x63, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x36, 0x35, 0x5b,
-  0x01, 0x63, 0xfc, 0x9d, 0x01, 0x51, 0x3a, 0x1b, 0x1c, 0x46, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xeb, 0x01, 0xad, 0x02, 0x82, 0x05, 0x1e, 0x00, 0x1f,
-  0x00, 0x00, 0x13, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36,
-  0x35, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
-  0x23, 0x11, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0xd6, 0x2f,
-  0x2d, 0x67, 0x28, 0x1c, 0x3c, 0x2b, 0x68, 0x26, 0x65, 0x42, 0x6e, 0x38,
-  0x39, 0x69, 0x23, 0x24, 0x46, 0x55, 0x30, 0x31, 0x02, 0x91, 0x78, 0x36,
-  0x36, 0x58, 0x36, 0x56, 0x02, 0x7e, 0x61, 0x38, 0x38, 0x42, 0x44, 0x81,
-  0xfe, 0x85, 0x01, 0x77, 0x59, 0x2c, 0x2d, 0x35, 0x36, 0x5c, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0x01, 0xad, 0x03, 0x00, 0x05, 0x1e, 0x00, 0x20,
-  0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11,
-  0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x02,
-  0x15, 0x23, 0x23, 0x47, 0x54, 0x31, 0x30, 0x6a, 0x6a, 0x25, 0x32, 0x33,
-  0x43, 0x6d, 0x38, 0x38, 0x2b, 0x3c, 0x1c, 0x28, 0x66, 0x2e, 0x2f, 0x04,
-  0x13, 0x59, 0x2c, 0x2d, 0x35, 0x36, 0x5c, 0xfe, 0x9e, 0x02, 0x73, 0x61,
-  0x38, 0x1c, 0x1c, 0x42, 0x44, 0x81, 0xfe, 0x7a, 0x56, 0x36, 0x58, 0x36,
-  0x36, 0x78, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0x02, 0x9c, 0x02, 0x7e,
-  0x05, 0x1e, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
-  0x23, 0x01, 0x11, 0x23, 0x66, 0x9a, 0x01, 0x0e, 0x6f, 0x9a, 0xfe, 0xf1,
-  0x6e, 0x05, 0x1e, 0xfe, 0x07, 0x01, 0xf9, 0xfd, 0x7e, 0x01, 0xfa, 0xfe,
-  0x06, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x88,
-  0x05, 0x1e, 0x00, 0x0f, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x16, 0x22, 0x07, 0x06, 0x07, 0x21, 0x26, 0x27, 0x17, 0x21,
-  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x01, 0x64, 0x87, 0x4f, 0x4d,
-  0x4d, 0x4f, 0x87, 0x89, 0x4d, 0x4e, 0x4e, 0x4d, 0xdc, 0xa7, 0x31, 0x2a,
-  0x06, 0x01, 0x69, 0x06, 0x2a, 0x2c, 0xfe, 0x9e, 0x0a, 0x22, 0x31, 0x55,
-  0x53, 0x31, 0x22, 0x05, 0x1e, 0x57, 0x57, 0x9b, 0x9a, 0x57, 0x58, 0x58,
-  0x57, 0x9a, 0x9b, 0x57, 0x57, 0x57, 0x40, 0x39, 0x5c, 0x5b, 0x38, 0xef,
-  0x45, 0x2d, 0x41, 0x41, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x3f,
-  0x01, 0xae, 0x02, 0x88, 0x06, 0x03, 0x00, 0x1d, 0x00, 0x26, 0x00, 0x2e,
-  0x00, 0x00, 0x01, 0x23, 0x35, 0x21, 0x15, 0x23, 0x15, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x17, 0x11, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x03, 0x11, 0x06, 0x07, 0x06, 0x14, 0x17,
-  0x16, 0x01, 0x2e, 0x88, 0x01, 0x78, 0x88, 0x65, 0x3f, 0x4d, 0x4d, 0x3f,
-  0x65, 0x88, 0xfe, 0x88, 0x88, 0x64, 0x3c, 0x4e, 0x4e, 0x3c, 0x64, 0x68,
-  0x30, 0x22, 0x30, 0x30, 0x22, 0x98, 0x2f, 0x20, 0x31, 0x30, 0x21, 0x05,
-  0xa7, 0x5c, 0x5c, 0x8c, 0x0e, 0x46, 0x57, 0x9b, 0x9a, 0x57, 0x47, 0x0e,
-  0x85, 0x5c, 0x5c, 0x86, 0x0e, 0x46, 0x57, 0x9a, 0x9b, 0x57, 0x45, 0x0f,
-  0x5b, 0xfe, 0x2a, 0x0e, 0x2c, 0x41, 0x70, 0x6f, 0x41, 0x2d, 0xfe, 0x39,
-  0x01, 0xd4, 0x0e, 0x2a, 0x41, 0xe2, 0x40, 0x2b, 0x00, 0x01, 0x00, 0x3f,
-  0x01, 0xad, 0x02, 0x25, 0x05, 0x1e, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x15,
-  0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x15,
-  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x02, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x2e,
-  0x01, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16, 0x02, 0x02, 0x2c, 0x60,
-  0x32, 0x4e, 0x26, 0x28, 0x1c, 0x1c, 0x54, 0x24, 0x6e, 0x2f, 0x2f, 0x45,
-  0x46, 0x7b, 0x33, 0x38, 0x0c, 0x2c, 0x3b, 0x84, 0x90, 0x66, 0x2e, 0x2f,
-  0x3a, 0x38, 0x38, 0x37, 0x4a, 0x4f, 0x1c, 0x1d, 0x61, 0x25, 0x60, 0x56,
-  0x3f, 0x3f, 0x75, 0x3a, 0x67, 0x04, 0xfd, 0x62, 0x17, 0x16, 0x17, 0x18,
-  0x2f, 0x24, 0x15, 0x14, 0x12, 0x08, 0x18, 0x2b, 0x2a, 0x4d, 0x57, 0x33,
-  0x33, 0x09, 0x03, 0x07, 0x56, 0x36, 0x58, 0x36, 0x36, 0x78, 0x22, 0x6a,
-  0x1d, 0x0f, 0x0f, 0x32, 0x2d, 0x2a, 0x17, 0x16, 0x15, 0x08, 0x14, 0x54,
-  0x49, 0x58, 0x30, 0x30, 0x10, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xeb,
-  0x01, 0xad, 0x01, 0x9d, 0x06, 0x03, 0x00, 0x17, 0x00, 0x00, 0x13, 0x02,
-  0x03, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15,
-  0x13, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x6e, 0x01,
-  0x01, 0x32, 0x2d, 0x6e, 0x63, 0x64, 0x38, 0x15, 0x17, 0x02, 0x2f, 0x2d,
-  0x67, 0x28, 0x1c, 0x3c, 0x2b, 0x02, 0x91, 0x01, 0x5d, 0x01, 0x4d, 0x65,
-  0x33, 0x30, 0x55, 0x17, 0x16, 0x3a, 0xfd, 0x4a, 0x78, 0x36, 0x36, 0x58,
-  0x36, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1f, 0x01, 0xad, 0x01, 0xac,
-  0x05, 0xc1, 0x00, 0x1f, 0x00, 0x00, 0x13, 0x15, 0x33, 0x15, 0x23, 0x11,
-  0x14, 0x16, 0x3b, 0x01, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x36, 0x3d, 0x01, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23, 0x35,
-  0x33, 0x35, 0xd4, 0xd8, 0xd8, 0x2c, 0x40, 0x6c, 0x2f, 0x2e, 0x67, 0x27,
-  0x1b, 0x3c, 0x2b, 0x03, 0x78, 0x2e, 0x2e, 0x4c, 0x4c, 0x05, 0xc1, 0xb2,
-  0x50, 0xfe, 0xac, 0x4d, 0x2c, 0x61, 0x78, 0x36, 0x36, 0x58, 0x36, 0x56,
-  0x0b, 0x2d, 0x2c, 0x76, 0x01, 0x54, 0x50, 0xb2, 0x00, 0x02, 0x00, 0x54,
-  0x02, 0x8c, 0x03, 0x35, 0x05, 0x0f, 0x00, 0x17, 0x00, 0x21, 0x00, 0x00,
-  0x13, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15,
-  0x23, 0x15, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x3d, 0x01,
-  0x29, 0x01, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x55, 0x63,
-  0x68, 0x01, 0x43, 0x69, 0x69, 0x69, 0x69, 0x27, 0x32, 0x32, 0x42, 0x6d,
-  0x71, 0x01, 0xaa, 0xfe, 0xbe, 0x23, 0x23, 0x46, 0x55, 0x31, 0x2c, 0x03,
-  0x99, 0x5c, 0x01, 0x1a, 0xfe, 0xe6, 0x01, 0x1a, 0xfe, 0xe6, 0x5c, 0xfd,
-  0x60, 0x39, 0x1c, 0x1b, 0x86, 0x82, 0x05, 0x02, 0x59, 0x2c, 0x2d, 0x36,
-  0x2f, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f, 0x02, 0x8b, 0x02, 0x90,
-  0x05, 0x0f, 0x00, 0x26, 0x00, 0x00, 0x13, 0x35, 0x33, 0x15, 0x06, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x27, 0x35, 0x33, 0x15, 0x23, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x20, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x40, 0xfb, 0x3e,
-  0x24, 0x25, 0x32, 0x32, 0x51, 0x52, 0x31, 0x33, 0x26, 0x28, 0x38, 0xf6,
-  0x85, 0x40, 0x20, 0x1f, 0x51, 0x50, 0xff, 0x00, 0x50, 0x51, 0x1e, 0x1e,
-  0x43, 0x04, 0xb3, 0x5c, 0x7b, 0x27, 0x3a, 0x3f, 0x4b, 0x59, 0x37, 0x36,
-  0x36, 0x37, 0x59, 0x52, 0x38, 0x3e, 0x23, 0x7b, 0x5c, 0x38, 0x3f, 0x3e,
-  0x4c, 0x83, 0x52, 0x52, 0x51, 0x52, 0x80, 0x52, 0x3c, 0x3d, 0x3a, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0x02, 0x8a, 0x02, 0x51, 0x05, 0x0f, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x01, 0x5d,
-  0x49, 0x41, 0x69, 0x3d, 0x3e, 0x78, 0x78, 0x3f, 0x3d, 0x6a, 0x40, 0x02,
-  0xe2, 0x50, 0x5a, 0x01, 0x83, 0xfe, 0x73, 0x7b, 0x3e, 0x3f, 0x3f, 0x3e,
-  0x7b, 0x01, 0x8d, 0xfe, 0x7d, 0x5a, 0x50, 0x00, 0x00, 0x01, 0x00, 0x6d,
-  0x02, 0x9c, 0x02, 0x79, 0x05, 0x0f, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x33,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x26, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3f, 0x01, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x26, 0x01, 0x43, 0xb7, 0x41, 0x1f, 0x1f, 0x50,
-  0x51, 0x80, 0x28, 0x66, 0x5c, 0x68, 0x15, 0x17, 0x3b, 0x1d, 0x51, 0x32,
-  0x31, 0x24, 0x2d, 0x35, 0x2b, 0x04, 0xc4, 0x38, 0x3f, 0x3e, 0x4c, 0x83,
-  0x52, 0x52, 0x6c, 0x77, 0x01, 0x90, 0xfe, 0x70, 0x55, 0x1c, 0x1c, 0x01,
-  0x01, 0x36, 0x37, 0x59, 0x51, 0x38, 0x43, 0x1f, 0x18, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x22, 0x02, 0x9c, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x13, 0x33, 0x02, 0x8c, 0x6e,
-  0xc6, 0xc7, 0x6f, 0xef, 0x8e, 0x02, 0x9c, 0x02, 0x0e, 0xfd, 0xf2, 0x02,
-  0x73, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31, 0x02, 0x9c, 0x02, 0x30,
-  0x05, 0x0f, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15,
-  0x21, 0x35, 0x01, 0x21, 0x40, 0x01, 0xf0, 0xfe, 0x77, 0x01, 0x89, 0xfe,
-  0x02, 0x01, 0x88, 0xfe, 0x86, 0x05, 0x0f, 0x5e, 0xfe, 0x3d, 0x52, 0x5e,
-  0x01, 0xc3, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31, 0x01, 0xad, 0x02, 0xb1,
-  0x05, 0x0f, 0x00, 0x16, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15,
-  0x23, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d,
-  0x01, 0x21, 0x35, 0x01, 0x21, 0x40, 0x01, 0xf0, 0xfe, 0x77, 0x01, 0x89,
-  0x01, 0x15, 0x15, 0x3d, 0x1a, 0x27, 0x67, 0x5c, 0xfe, 0x6c, 0x01, 0x88,
-  0xfe, 0x86, 0x05, 0x0f, 0x5e, 0xfe, 0x3d, 0x52, 0x0b, 0x56, 0x1b, 0x1b,
-  0x58, 0x6c, 0x78, 0x0b, 0x5e, 0x01, 0xc3, 0x00, 0x00, 0x02, 0x00, 0x31,
-  0x02, 0x5e, 0x02, 0x30, 0x05, 0x0f, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x06, 0x15, 0x23, 0x34, 0x37, 0x23, 0x35, 0x01, 0x21, 0x35, 0x21,
-  0x15, 0x01, 0x33, 0x36, 0x33, 0x32, 0x15, 0x14, 0x23, 0x27, 0x33, 0x32,
-  0x35, 0x34, 0x23, 0x06, 0x01, 0x56, 0x02, 0x56, 0x02, 0xce, 0x01, 0x88,
-  0xfe, 0x86, 0x01, 0xf0, 0xfe, 0x77, 0x63, 0x23, 0x7c, 0x81, 0xbd, 0x0b,
-  0x0b, 0x63, 0x28, 0x32, 0x02, 0x9c, 0x1d, 0x21, 0x21, 0x1d, 0x5e, 0x01,
-  0xc3, 0x52, 0x5e, 0xfe, 0x3d, 0xa2, 0x8a, 0x6a, 0x52, 0x1f, 0x33, 0x01,
-  0x00, 0x01, 0x00, 0x31, 0x01, 0xa8, 0x02, 0x60, 0x05, 0x0f, 0x00, 0x21,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x13, 0x21, 0x35, 0x21, 0x15,
-  0x01, 0x44, 0x3c, 0x49, 0x38, 0x31, 0x2e, 0x57, 0x56, 0x9f, 0x35, 0x39,
-  0x38, 0x3c, 0x2f, 0x72, 0x3e, 0x6c, 0x37, 0x39, 0x34, 0x34, 0x5e, 0x63,
-  0xf4, 0xfe, 0x86, 0x01, 0xef, 0x03, 0xa7, 0x20, 0x17, 0x3d, 0x3b, 0x4d,
-  0x7c, 0x43, 0x44, 0x0a, 0x0b, 0x14, 0x6d, 0x1b, 0x1c, 0x2a, 0x2a, 0x50,
-  0x4a, 0x2a, 0x29, 0x5d, 0x01, 0x18, 0x52, 0x5e, 0x00, 0x03, 0x00, 0x3f,
-  0x02, 0x8f, 0x02, 0x88, 0x06, 0x0c, 0x00, 0x08, 0x00, 0x10, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x13, 0x32, 0x17, 0x16, 0x10,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x10, 0x37, 0x36, 0x02, 0x18, 0xfe, 0x97,
-  0x05, 0x2a, 0x31, 0x55, 0x53, 0x31, 0x2a, 0x05, 0x09, 0x26, 0x31, 0xa7,
-  0x31, 0x27, 0x08, 0xb4, 0x87, 0x4f, 0x4d, 0x4d, 0x4f, 0x87, 0x89, 0x9b,
-  0x4d, 0x4e, 0x04, 0x2a, 0x80, 0x4d, 0x57, 0x58, 0x4d, 0xde, 0x6d, 0x47,
-  0x59, 0x58, 0x46, 0x6f, 0x01, 0x83, 0x76, 0x77, 0xfe, 0x5e, 0x77, 0x77,
-  0xee, 0x01, 0xa2, 0x77, 0x76, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xb8,
-  0x04, 0xee, 0xff, 0xaf, 0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x35, 0x21, 0x37, 0x33, 0xfe, 0xd2, 0xfd, 0xe6, 0x01, 0xe2, 0x97, 0x7d,
-  0x04, 0xee, 0x94, 0xe4, 0x00, 0x01, 0xfc, 0xb8, 0x04, 0xee, 0xff, 0xaf,
-  0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x03, 0x33, 0x17, 0x21, 0x15,
-  0xfd, 0x95, 0xdd, 0x7d, 0x98, 0x01, 0xe1, 0x04, 0xee, 0x01, 0x78, 0xe4,
-  0x94, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xb8, 0x04, 0xee, 0xff, 0xaf,
-  0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x13, 0x23, 0x27, 0x21, 0x35,
-  0xfe, 0xd2, 0xdc, 0x7d, 0x97, 0xfe, 0x1e, 0x06, 0x66, 0xfe, 0x88, 0xe4,
-  0x94, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xb8, 0x04, 0xee, 0xff, 0xaf,
-  0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x07, 0x23,
-  0xfd, 0x95, 0x02, 0x19, 0xfe, 0x1f, 0x98, 0x7d, 0x06, 0x66, 0x94, 0xe4,
-  0x00, 0x01, 0xfc, 0xa1, 0x04, 0xee, 0xff, 0xc5, 0x06, 0x66, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x33, 0x13, 0x23, 0x27, 0x07, 0x23, 0x03, 0x33, 0x17,
-  0xfe, 0x63, 0x85, 0xdd, 0x7d, 0xa2, 0xa2, 0x86, 0xdc, 0x7d, 0xa2, 0x06,
-  0x66, 0xfe, 0x88, 0xf5, 0xf5, 0x01, 0x78, 0xf5, 0x00, 0x01, 0xfc, 0xa1,
-  0x04, 0xee, 0xff, 0xc5, 0x06, 0x66, 0x00, 0x09, 0x00, 0x00, 0x01, 0x17,
-  0x37, 0x33, 0x03, 0x23, 0x27, 0x07, 0x23, 0x13, 0xfe, 0x04, 0xa2, 0xa2,
-  0x7d, 0xdd, 0x85, 0xa2, 0xa2, 0x7d, 0xdc, 0x06, 0x66, 0xf5, 0xf5, 0xfe,
-  0x88, 0xf5, 0xf5, 0x01, 0x78, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0xfe, 0x13, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd6, 0x04, 0x43,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
-  0xfe, 0x13, 0x03, 0xc3, 0x04, 0x7b, 0x10, 0x27, 0x02, 0xd6, 0x03, 0xe5,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x6e, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x43,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x25, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa5,
-  0xff, 0xe3, 0x04, 0x2e, 0x07, 0x52, 0x10, 0x27, 0x02, 0xb8, 0x02, 0xc7,
-  0x01, 0x3e, 0x12, 0x06, 0x00, 0x45, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x89, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x25, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x04, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x89, 0x04, 0x2e, 0x06, 0x14, 0x12, 0x26, 0x00, 0x45, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x04, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0xc0, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x25, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x8f, 0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0xc0, 0x04, 0x2e, 0x06, 0x14, 0x12, 0x26, 0x00, 0x45, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x8f, 0x00, 0x81, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xfe, 0x75, 0x04, 0xa4, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0xc4,
-  0x01, 0x76, 0x12, 0x06, 0x00, 0x89, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x75, 0x03, 0x84, 0x06, 0x66, 0x12, 0x26, 0x00, 0xa9, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x76, 0x3c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x1f, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x6e,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x03, 0xeb, 0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x05, 0x65,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x8a, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x6e,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x8a, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd4, 0x03, 0xf5,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0xc1, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xe2, 0x04, 0x6e,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0xc1, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27, 0x02, 0xe2, 0x03, 0xf5,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x77, 0x05, 0x1f, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x27, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x7a, 0x52, 0x02, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x75, 0x03, 0xeb, 0x06, 0x14, 0x12, 0x26, 0x00, 0x47, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x7a, 0xf7, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x15, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xde, 0x04, 0x6e,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x15, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27, 0x02, 0xde, 0x03, 0xf5,
-  0x00, 0x01, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x08, 0x5a, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x06, 0x11, 0x24, 0xf0, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x07, 0x5e, 0x10, 0x27, 0x11, 0x24, 0xff, 0xdd,
-  0xff, 0x04, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x17, 0x08, 0x5a, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x06, 0x11, 0x23, 0xee, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x07, 0x5e, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x10, 0x07, 0x11, 0x23, 0xff, 0xdb, 0xff, 0x04, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x4b, 0x04, 0x17, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xde, 0x04, 0x39, 0x00, 0x37, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x4b, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xde, 0x04, 0x38, 0x00, 0x37, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x76, 0x04, 0x17, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xb0, 0x00, 0xa1, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x76, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xb0, 0x00, 0x8c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x75, 0x04, 0x17, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x04, 0x2a,
-  0x01, 0x75, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x00, 0x7a,
-  0x00, 0xab, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x0c,
-  0x06, 0x48, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00, 0x10, 0x26, 0x02, 0x9a,
-  0x7a, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x44, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0xba, 0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x04,
-  0x01, 0x74, 0x12, 0x06, 0x00, 0x29, 0x00, 0x00, 0xff, 0xff, 0x00, 0x2a,
-  0x00, 0x00, 0x02, 0xac, 0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x03, 0x7d,
-  0x01, 0x75, 0x12, 0x06, 0x00, 0x49, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xfe, 0x07, 0x18, 0x12, 0x26, 0x00, 0x2a, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x8b, 0x01, 0x13, 0x01, 0x22, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x03, 0xeb, 0x05, 0xf6, 0x12, 0x26, 0x00, 0x4a, 0x00, 0x00,
-  0x10, 0x06, 0x02, 0x8b, 0x42, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xb6, 0x07, 0x4e, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x92,
-  0x01, 0x73, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa5,
-  0x00, 0x00, 0x03, 0xf4, 0x07, 0x52, 0x10, 0x27, 0x02, 0xb8, 0x02, 0xc7,
-  0x01, 0x3e, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x89, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x82,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x89, 0x03, 0xf4, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x1a,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xb6, 0x07, 0x50, 0x12, 0x26, 0x00, 0x2b, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x6a, 0x00, 0xee, 0x01, 0x40, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xf4, 0x07, 0x4e, 0x10, 0x27, 0x02, 0xb9, 0x02, 0xc7,
-  0x01, 0x3e, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0f,
-  0xfe, 0x74, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2b, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x7a, 0xff, 0x09, 0xff, 0xff, 0xff, 0xff, 0x00, 0x01,
-  0xfe, 0x74, 0x03, 0xf4, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4b, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x7a, 0xfe, 0xfc, 0xff, 0xff, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x39, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2b, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xdf, 0x04, 0x89, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x39, 0x03, 0xf4, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4b, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xdf, 0x04, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,
-  0xfe, 0x76, 0x02, 0x52, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xb0, 0xff, 0x5c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xd7,
-  0xfe, 0x76, 0x02, 0x2a, 0x06, 0x14, 0x10, 0x27, 0x02, 0xb0, 0xff, 0x34,
-  0x00, 0x00, 0x12, 0x06, 0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x02, 0x1d, 0x08, 0x5a, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x11, 0x21, 0xfe, 0x9c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf5,
-  0x00, 0x00, 0x02, 0x0c, 0x07, 0x16, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00,
-  0x10, 0x07, 0x11, 0x21, 0xfe, 0x8a, 0xfe, 0xbc, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xe0, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x65,
-  0x01, 0x76, 0x12, 0x06, 0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x26, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x03, 0x04,
-  0x01, 0x76, 0x12, 0x06, 0x00, 0x4e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x89, 0x04, 0xe0, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2e, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x04, 0x60, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x89, 0x04, 0x26, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4e, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x04, 0x1c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0xc0, 0x04, 0xe0, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2e, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x8f, 0x00, 0xf2, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0xc0, 0x04, 0x26, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4e, 0x00, 0x00,
-  0x10, 0x06, 0x02, 0x8f, 0x6a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x89, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x24,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x89, 0x01, 0x5e, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd4, 0x02, 0xd6,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0x4f, 0x0a, 0x00, 0xff, 0xff, 0x00, 0x02,
-  0xfe, 0x8a, 0x03, 0xf9, 0x07, 0x6b, 0x10, 0x27, 0x02, 0xb5, 0x02, 0xd9,
-  0x01, 0x75, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x23, 0x00, 0x01, 0x12, 0x06,
-  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfd, 0xfe, 0x89, 0x02, 0x18,
-  0x07, 0x31, 0x10, 0x27, 0x00, 0x71, 0xff, 0x3e, 0x01, 0x3b, 0x10, 0x06,
-  0x05, 0x87, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0xc0, 0x03, 0xf9,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x2f, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f,
-  0x00, 0x80, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf5, 0xfe, 0xc0, 0x02, 0x10,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0x8f, 0xff, 0x36, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x14, 0x03, 0xf9,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0x88, 0x00, 0x88, 0xf9, 0x26, 0x12, 0x06,
-  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe1, 0xfe, 0x14, 0x02, 0x20,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0x88, 0xff, 0x34, 0xf9, 0x26, 0x12, 0x06,
-  0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83,
-  0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0xe8, 0x01, 0x76, 0x12, 0x06,
-  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x50, 0x00, 0x00, 0x10, 0x07, 0x00, 0x76,
-  0x01, 0x6c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83,
-  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0xeb, 0x01, 0x74, 0x12, 0x06,
-  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x05, 0x52, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x50, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x05, 0x83,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0xe8, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x06, 0x67,
-  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd4, 0x05, 0x4f, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x50, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae,
-  0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x76, 0x01, 0x75, 0x12, 0x06,
-  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x04, 0x15, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0xae,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x7e, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x03, 0xf4,
-  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x1a, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0xc0, 0x04, 0xae,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x31, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f,
-  0x00, 0xde, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0xc0, 0x03, 0xf4,
-  0x04, 0x7b, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
-  0x7e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x14, 0x04, 0xae,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0x88, 0x00, 0xe5, 0xf9, 0x26, 0x12, 0x06,
-  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x14, 0x03, 0xf4,
-  0x04, 0x7b, 0x10, 0x27, 0x02, 0x88, 0x00, 0x86, 0xf9, 0x26, 0x12, 0x06,
-  0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x08, 0x5a, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x29,
-  0x5c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x07, 0x0c, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00, 0x10, 0x07, 0x11, 0x29,
-  0xff, 0xba, 0xfe, 0xb2, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x08, 0x56, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x27,
-  0x61, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x07, 0x0f, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00, 0x10, 0x27, 0x00, 0x6a,
-  0x00, 0x64, 0x00, 0xff, 0x10, 0x07, 0x10, 0xed, 0x04, 0x00, 0x00, 0x12,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x5a, 0x12, 0x26,
-  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x24, 0x5f, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x5e, 0x10, 0x26,
-  0x00, 0x52, 0x00, 0x00, 0x10, 0x07, 0x11, 0x24, 0xff, 0xbc, 0xff, 0x04,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x5a, 0x12, 0x26,
-  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x23, 0x5e, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x5e, 0x10, 0x27,
-  0x11, 0x23, 0xff, 0xc0, 0xff, 0x04, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19, 0x07, 0x6c, 0x10, 0x27,
-  0x10, 0xec, 0x04, 0x28, 0x01, 0x76, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0x53, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76, 0x2d, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19, 0x07, 0x4f, 0x10, 0x27,
-  0x10, 0xf3, 0x04, 0x10, 0x01, 0x74, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x10, 0x27,
-  0x02, 0xb8, 0x04, 0x2f, 0x00, 0x00, 0x12, 0x06, 0x00, 0x53, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc, 0x07, 0x4e, 0x10, 0x27,
-  0x10, 0xf3, 0x04, 0x10, 0x01, 0x73, 0x12, 0x06, 0x00, 0x35, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x02, 0xf6, 0x06, 0x14, 0x10, 0x27,
-  0x02, 0xb8, 0x03, 0xae, 0x00, 0x00, 0x12, 0x06, 0x00, 0x55, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0xcc, 0x05, 0xd5, 0x10, 0x27,
-  0x02, 0xd4, 0x04, 0x0a, 0x00, 0x00, 0x10, 0x06, 0x00, 0x35, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x02, 0xf6, 0x04, 0x7b, 0x10, 0x27,
-  0x02, 0xd4, 0x02, 0xd0, 0x00, 0x00, 0x10, 0x06, 0x00, 0x55, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0xcc, 0x07, 0x31, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0x70, 0x01, 0x3b, 0x10, 0x06, 0x05, 0xaa, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x02, 0xf6, 0x05, 0xf5, 0x10, 0x26,
-  0x00, 0x71, 0x15, 0xff, 0x10, 0x06, 0x05, 0xab, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0xc0, 0x04, 0xcc, 0x05, 0xd5, 0x12, 0x26,
-  0x00, 0x35, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f, 0x00, 0xce, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x4b, 0xfe, 0xc0, 0x02, 0xf6, 0x04, 0x7b, 0x12, 0x26,
-  0x00, 0x55, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f, 0x8c, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x07, 0x4f, 0x10, 0x27,
-  0x10, 0xf3, 0x04, 0x3f, 0x01, 0x74, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x06, 0x14, 0x10, 0x27,
-  0x02, 0xb8, 0x03, 0xbd, 0x00, 0x00, 0x12, 0x06, 0x00, 0x56, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x79, 0xfe, 0x89, 0x04, 0x2c, 0x05, 0xf0, 0x10, 0x27,
-  0x02, 0xd4, 0x04, 0x16, 0x00, 0x00, 0x10, 0x06, 0x00, 0x36, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xfe, 0x8a, 0x03, 0x67, 0x04, 0x7b, 0x10, 0x27,
-  0x02, 0xd4, 0x03, 0xbb, 0x00, 0x01, 0x12, 0x06, 0x00, 0x56, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xec, 0x04, 0x65, 0x01, 0x76, 0x10, 0x27, 0x10, 0xf3, 0x03, 0x47,
-  0x01, 0x92, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
-  0xff, 0xe3, 0x03, 0x7f, 0x06, 0x66, 0x12, 0x26, 0x00, 0x56, 0x00, 0x00,
-  0x10, 0x26, 0x02, 0x9b, 0x98, 0x56, 0x10, 0x07, 0x00, 0x76, 0x00, 0x82,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c,
-  0x08, 0x57, 0x10, 0x26, 0x11, 0x28, 0xe7, 0x00, 0x12, 0x06, 0x00, 0x36,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
-  0x07, 0xc9, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xc2, 0x01, 0xb5, 0x12, 0x06,
-  0x01, 0x23, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x89, 0x04, 0x2c,
-  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x25, 0x01, 0x74, 0x12, 0x06,
-  0x05, 0xb2, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xfe, 0x8a, 0x03, 0x67,
-  0x05, 0xde, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xbd, 0xff, 0xca, 0x12, 0x06,
-  0x05, 0xb3, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c,
-  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x00, 0x01, 0x74, 0x12, 0x06,
-  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0x00, 0x00, 0x02, 0xa7,
-  0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x02, 0xcb, 0x01, 0x75, 0x12, 0x06,
-  0x00, 0x57, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0xfe, 0x89, 0x04, 0x6c,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x03, 0xff, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0xfe, 0x89, 0x02, 0xa7,
-  0x05, 0x9e, 0x10, 0x27, 0x02, 0xd4, 0x03, 0x84, 0x00, 0x00, 0x10, 0x06,
-  0x00, 0x57, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0xfe, 0xc0, 0x04, 0x6c,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x37, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
-  0x58, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0xfe, 0xc0, 0x02, 0xd0,
-  0x05, 0x9e, 0x10, 0x26, 0x02, 0x8f, 0xf5, 0x00, 0x12, 0x06, 0x00, 0x57,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0xfe, 0x14, 0x04, 0x6c,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0x88, 0x00, 0x67, 0xf9, 0x26, 0x12, 0x06,
-  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0xfe, 0x14, 0x02, 0xd6,
-  0x05, 0x9e, 0x10, 0x27, 0x02, 0x88, 0xff, 0xea, 0xf9, 0x26, 0x12, 0x06,
-  0x00, 0x57, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x89, 0x04, 0xa5,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd5, 0x04, 0x72, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x38, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x89, 0x03, 0xe9,
-  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd5, 0x04, 0x08, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x76, 0x04, 0xa5,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xb0,
-  0x00, 0xda, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x76, 0x03, 0xe9,
-  0x04, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xb0,
-  0x00, 0x81, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x4b, 0x04, 0xa5,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xde,
-  0x04, 0x63, 0x00, 0x37, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x4b, 0x03, 0xe9,
-  0x04, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xde,
-  0x04, 0x03, 0x00, 0x37, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x08, 0x5a, 0x10, 0x26, 0x11, 0x29, 0x29, 0x00, 0x12, 0x06, 0x00, 0x38,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
-  0x07, 0xec, 0x10, 0x26, 0x01, 0x2b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x76,
-  0x00, 0x87, 0x01, 0x86, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x08, 0x34, 0x10, 0x26, 0x11, 0x1f, 0x2d, 0x00, 0x12, 0x06, 0x00, 0x38,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
-  0x06, 0xf4, 0x10, 0x27, 0x11, 0x1f, 0xff, 0xce, 0xfe, 0xc0, 0x12, 0x06,
-  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x07, 0x7d, 0x12, 0x26, 0x00, 0x39, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9e,
-  0x00, 0xd5, 0x01, 0x46, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
-  0x06, 0x37, 0x12, 0x26, 0x00, 0x59, 0x00, 0x00, 0x10, 0x06, 0x02, 0x9e,
-  0x62, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde,
-  0x05, 0xd5, 0x10, 0x26, 0x00, 0x39, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x89, 0x04, 0x0c,
-  0x04, 0x60, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x03, 0xee, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
-  0x07, 0x72, 0x10, 0x27, 0x10, 0xee, 0x05, 0x5c, 0x01, 0x7c, 0x12, 0x06,
-  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
-  0x06, 0x6b, 0x10, 0x27, 0x00, 0x43, 0x00, 0xee, 0x00, 0x05, 0x12, 0x06,
-  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
-  0x07, 0x72, 0x10, 0x27, 0x10, 0xec, 0x05, 0x5c, 0x01, 0x7c, 0x12, 0x06,
-  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
-  0x06, 0x6d, 0x10, 0x27, 0x00, 0x76, 0x01, 0x5f, 0x00, 0x07, 0x12, 0x06,
-  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
-  0x07, 0x4e, 0x10, 0x27, 0x00, 0x6a, 0x01, 0xc3, 0x01, 0x3e, 0x12, 0x06,
-  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
-  0x06, 0x10, 0x10, 0x27, 0x00, 0x6a, 0x01, 0x24, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
-  0x07, 0x4e, 0x10, 0x27, 0x10, 0xf3, 0x05, 0x5c, 0x01, 0x73, 0x12, 0x06,
-  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x04, 0xc0, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0xfe, 0x89, 0x06, 0xe3,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x3a, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x05, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0xfe, 0x89, 0x05, 0x97,
-  0x04, 0x60, 0x12, 0x26, 0x00, 0x5a, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0xc3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
-  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x4f, 0x01, 0x73, 0x12, 0x06,
-  0x00, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xf2, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x5b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
-  0x07, 0x4e, 0x12, 0x26, 0x00, 0x3b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x6a,
-  0x00, 0xb6, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07,
-  0x06, 0x10, 0x12, 0x26, 0x00, 0x5b, 0x00, 0x00, 0x10, 0x06, 0x00, 0x6a,
-  0x5c, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
-  0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06,
-  0x00, 0x3c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xf0, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c,
-  0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0x45, 0x01, 0x75, 0x12, 0x06,
-  0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79,
-  0x06, 0x66, 0x12, 0x26, 0x00, 0x5d, 0x00, 0x00, 0x10, 0x06, 0x02, 0x88,
-  0x17, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52, 0xfe, 0x89, 0x04, 0x9c,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x3d, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0x5d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0xfe, 0x89, 0x03, 0x79,
-  0x04, 0x60, 0x12, 0x26, 0x00, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x03, 0xc6, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52, 0xfe, 0xc0, 0x04, 0x9c,
-  0x05, 0xd5, 0x12, 0x26, 0x00, 0x3d, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f,
-  0x00, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0xfe, 0xc0, 0x03, 0x79,
-  0x04, 0x60, 0x12, 0x26, 0x00, 0x5d, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
-  0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0xc0, 0x03, 0xf4,
-  0x06, 0x14, 0x12, 0x26, 0x00, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
-  0x5c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x02, 0xa7,
-  0x07, 0x4e, 0x12, 0x26, 0x00, 0x57, 0x00, 0x00, 0x10, 0x07, 0x00, 0x6a,
-  0xff, 0x42, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
-  0x07, 0x06, 0x12, 0x26, 0x00, 0x5a, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9c,
-  0x01, 0x22, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x07, 0x06, 0x12, 0x26, 0x00, 0x5c, 0x00, 0x00, 0x10, 0x06, 0x02, 0x9c,
-  0x74, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x04, 0xd8,
-  0x06, 0x14, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x02, 0x80,
-  0x03, 0x77, 0x00, 0x00, 0xff, 0xff, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac,
-  0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x03, 0x7d, 0x01, 0x75, 0x12, 0x06,
-  0x01, 0x41, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x02, 0xac,
-  0x06, 0x14, 0x00, 0x18, 0x00, 0x00, 0x21, 0x23, 0x11, 0x07, 0x27, 0x37,
-  0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x11, 0x37, 0x17, 0x05, 0x01, 0x6f, 0xa6, 0x85, 0x42,
-  0xc7, 0x9f, 0x9f, 0x9c, 0xaa, 0x9d, 0x9e, 0x5a, 0x23, 0x22, 0xc1, 0x43,
-  0xfe, 0xfc, 0x02, 0x14, 0x68, 0x6a, 0x9d, 0x01, 0x1e, 0x8f, 0x4e, 0xbb,
-  0xab, 0x99, 0x28, 0x29, 0x67, 0xfe, 0x74, 0x98, 0x69, 0xcf, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac, 0x06, 0x14, 0x00, 0x17,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33,
-  0x36, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x07, 0x33,
-  0x15, 0x23, 0x01, 0x6f, 0xa6, 0x9f, 0x9f, 0x9f, 0xa1, 0x0c, 0x40, 0x4e,
-  0xaa, 0x9d, 0x9e, 0x5a, 0x23, 0x1b, 0x05, 0xe4, 0xe6, 0x03, 0x45, 0x8f,
-  0x8c, 0x8f, 0x89, 0x46, 0x56, 0x99, 0x28, 0x20, 0x44, 0x8f, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa0, 0xff, 0xe3, 0x05, 0x22, 0x05, 0xf2, 0x00, 0x37,
-  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x0e, 0x03, 0x15, 0x11, 0x23, 0x11,
-  0x34, 0x3e, 0x03, 0x33, 0x32, 0x04, 0x17, 0x22, 0x06, 0x15, 0x14, 0x1e,
-  0x05, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x2e, 0x07, 0x35, 0x34, 0x36, 0x03, 0x9c, 0x62, 0x9c,
-  0x3a, 0x5c, 0x55, 0x3a, 0x22, 0xb7, 0x34, 0x5a, 0x81, 0x95, 0x5a, 0xc3,
-  0x01, 0x11, 0x32, 0xba, 0xe8, 0x3d, 0x5f, 0x74, 0x74, 0x60, 0x3c, 0xee,
-  0xbe, 0xa2, 0xb5, 0x62, 0x9f, 0x64, 0x58, 0x88, 0x25, 0x3f, 0x52, 0x5a,
-  0x5a, 0x52, 0x3f, 0x25, 0xc9, 0x04, 0xf4, 0x5a, 0x18, 0x40, 0x68, 0xa7,
-  0x6f, 0xfc, 0x88, 0x03, 0x91, 0x83, 0xcf, 0x8b, 0x5c, 0x28, 0xc5, 0xbd,
-  0x7d, 0x5f, 0x2d, 0x43, 0x2d, 0x2d, 0x3e, 0x54, 0x8c, 0x5c, 0xa4, 0xc9,
-  0x5f, 0xd0, 0x45, 0x46, 0x76, 0x58, 0x35, 0x50, 0x33, 0x29, 0x20, 0x24,
-  0x32, 0x42, 0x67, 0x43, 0x8f, 0xbb, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x05, 0xf0, 0x10, 0x06, 0x03, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x27,
-  0x02, 0xd4, 0x04, 0x3e, 0x00, 0x00, 0x12, 0x06, 0x00, 0x24, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xfe, 0x89, 0x03, 0xc3, 0x04, 0x7b, 0x10, 0x27,
-  0x02, 0xd4, 0x03, 0xb7, 0x00, 0x00, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0xf0, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x04, 0x43, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x7b, 0x12, 0x26,
-  0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x03, 0xe5, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x3a, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2a, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x04, 0x37, 0x06, 0xc5, 0x10, 0x27,
-  0x11, 0x2a, 0xff, 0xa1, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x3a, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2b, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0xc6, 0x10, 0x26,
-  0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x11, 0x2b, 0xff, 0x9f, 0xfe, 0x8c,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x5b, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x31, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x04, 0x27, 0x06, 0xe6, 0x10, 0x27,
-  0x11, 0x31, 0xff, 0xa1, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x75, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2c, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x00, 0x10, 0x27,
-  0x11, 0x2c, 0xff, 0xa1, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde, 0x07, 0x6d, 0x12, 0x26,
-  0x00, 0x84, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x37, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xfe, 0x89, 0x03, 0xc3, 0x06, 0x66, 0x12, 0x26,
-  0x00, 0xa4, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x03, 0xb8, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x5a, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2e, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x04, 0x10, 0x27,
-  0x11, 0x2e, 0xff, 0x9c, 0xfe, 0xaa, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x5a, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2f, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x04, 0x10, 0x27,
-  0x11, 0x2f, 0xff, 0x9d, 0xfe, 0xaa, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x8b, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x30, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x35, 0x10, 0x27,
-  0x11, 0x30, 0xff, 0x9f, 0xfe, 0xaa, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x59, 0x12, 0x26,
-  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2d, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x03, 0x10, 0x26,
-  0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x11, 0x2d, 0xff, 0x9d, 0xfe, 0xaa,
-  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde, 0x07, 0x92, 0x12, 0x26,
-  0x00, 0xc4, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x46, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6e, 0xfe, 0x89, 0x03, 0xc3, 0x06, 0x1f, 0x12, 0x26,
-  0x00, 0xc5, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x03, 0xc8, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0x17, 0x05, 0xd5, 0x10, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x28, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0x89, 0x04, 0x0c, 0x04, 0x7b, 0x10, 0x26,
-  0x00, 0x48, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x17, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0xf0, 0x12, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x04, 0x28, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x7b, 0x12, 0x26,
-  0x00, 0x48, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x04, 0x18, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x5e, 0x10, 0x27,
-  0x10, 0xed, 0x04, 0x28, 0x01, 0x75, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x37, 0x10, 0x27,
-  0x02, 0x9e, 0x00, 0x88, 0x00, 0x00, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x96, 0x08, 0x3a, 0x12, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2a, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x6b, 0x06, 0xc5, 0x10, 0x27,
-  0x11, 0x2a, 0xff, 0xd5, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x08, 0x3a, 0x12, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2b, 0xf0, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0xc6, 0x10, 0x27,
-  0x11, 0x2b, 0xff, 0xd5, 0xfe, 0x8c, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x77, 0x08, 0x5b, 0x12, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x31, 0xf0, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x5c, 0x06, 0xe6, 0x10, 0x26,
-  0x00, 0x48, 0x00, 0x00, 0x10, 0x07, 0x11, 0x31, 0xff, 0xd5, 0xfe, 0x8b,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x08, 0x75, 0x12, 0x26,
-  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2c, 0xec, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x07, 0x00, 0x10, 0x27,
-  0x11, 0x2c, 0xff, 0xd6, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0x17, 0x07, 0x6d, 0x12, 0x26,
-  0x00, 0x8c, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x28, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0x89, 0x04, 0x0c, 0x06, 0x66, 0x10, 0x27,
-  0x02, 0xd4, 0x04, 0x17, 0x00, 0x00, 0x10, 0x26, 0x06, 0x09, 0x00, 0x00,
-  0x10, 0x06, 0x02, 0x88, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x51,
-  0x00, 0x00, 0x01, 0xe5, 0x07, 0xf0, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xba, 0x02, 0xd3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x3d,
-  0x00, 0x00, 0x01, 0xd1, 0x06, 0x7c, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xba, 0x02, 0xbf, 0x00, 0x01, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x89, 0x01, 0x6b, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x00, 0xab,
-  0xfe, 0x89, 0x01, 0x54, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x02, 0xcd, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xfe, 0x89, 0x05, 0x44, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x04, 0xa3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x89, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x04, 0x01, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x07, 0xf0, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xba, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x7b, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xba, 0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x08, 0x3a, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x06, 0x11, 0x2a, 0x61, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x53, 0x06, 0xc5, 0x10, 0x27, 0x11, 0x2a, 0xff, 0xbd,
-  0xfe, 0x8b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x08, 0x3a, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x06, 0x11, 0x2b, 0x5f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0xc6, 0x10, 0x27, 0x11, 0x2b, 0xff, 0xbc,
-  0xfe, 0x8c, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x08, 0x5b, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x06, 0x11, 0x31, 0x5f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x44, 0x06, 0xe6, 0x10, 0x27, 0x11, 0x31, 0xff, 0xbd,
-  0xfe, 0x8b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x05, 0x44, 0x08, 0x75, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
-  0x10, 0x06, 0x11, 0x2c, 0x5b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x07, 0x00, 0x10, 0x27, 0x11, 0x2c, 0xff, 0xbd,
-  0xfe, 0x8b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xfe, 0x89, 0x05, 0x44, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x96, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x04, 0xa3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x89, 0x04, 0x03, 0x06, 0x66, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x01,
-  0x00, 0x00, 0x10, 0x26, 0x06, 0x1d, 0x00, 0x00, 0x10, 0x06, 0x02, 0x88,
-  0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
-  0x07, 0x6b, 0x10, 0x27, 0x10, 0xec, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06,
-  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
-  0x06, 0x66, 0x10, 0x26, 0x00, 0x76, 0x68, 0x00, 0x12, 0x06, 0x01, 0x63,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
-  0x07, 0x6b, 0x10, 0x27, 0x10, 0xee, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06,
-  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
-  0x06, 0x66, 0x10, 0x26, 0x00, 0x43, 0x68, 0x00, 0x12, 0x06, 0x01, 0x63,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
-  0x07, 0xf0, 0x12, 0x26, 0x01, 0x62, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
-  0x06, 0x7b, 0x12, 0x26, 0x01, 0x63, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
-  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06,
-  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
-  0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x68, 0x00, 0x12, 0x06, 0x01, 0x63,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xfe, 0x89, 0x05, 0x81,
-  0x06, 0x14, 0x12, 0x26, 0x01, 0x62, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0xa3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xfe, 0x89, 0x04, 0x58,
-  0x04, 0xeb, 0x12, 0x26, 0x01, 0x63, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0x01, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x89, 0x04, 0xa5,
-  0x05, 0xd5, 0x10, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0x76, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x89, 0x03, 0xe9,
-  0x04, 0x7b, 0x10, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0x08, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x07, 0xf0, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x04, 0x70, 0x01, 0x75, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
-  0x06, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
-  0x07, 0x6b, 0x10, 0x27, 0x10, 0xec, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
-  0x01, 0x71, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
-  0x06, 0x66, 0x10, 0x26, 0x00, 0x76, 0x6f, 0x00, 0x12, 0x06, 0x01, 0x72,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
-  0x07, 0x6b, 0x10, 0x27, 0x10, 0xee, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
-  0x01, 0x71, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
-  0x06, 0x66, 0x10, 0x26, 0x00, 0x43, 0x6f, 0x00, 0x12, 0x06, 0x01, 0x72,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
-  0x07, 0xf0, 0x12, 0x26, 0x01, 0x71, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x04, 0x70, 0x01, 0x75, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
-  0x06, 0x7b, 0x12, 0x26, 0x01, 0x72, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
-  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
-  0x01, 0x71, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
-  0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x73, 0x00, 0x12, 0x06, 0x01, 0x72,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xfe, 0x89, 0x05, 0xbc,
-  0x06, 0x14, 0x12, 0x26, 0x01, 0x71, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0x76, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xfe, 0x89, 0x04, 0xdf,
-  0x04, 0xeb, 0x12, 0x26, 0x01, 0x72, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
-  0x04, 0x08, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
-  0x07, 0x72, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee,
-  0x04, 0x00, 0x01, 0x7c, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x06, 0x6b, 0x12, 0x26, 0x00, 0x5c, 0x00, 0x00, 0x10, 0x06, 0x00, 0x43,
-  0x1e, 0x05, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0xfe, 0x89, 0x04, 0x6a,
-  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x04, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x3c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x04, 0x60, 0x10, 0x27, 0x02, 0xd4, 0x04, 0xe8, 0x00, 0x00, 0x12, 0x06,
-  0x00, 0x5c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
-  0x07, 0xf7, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x04, 0x00, 0x01, 0x7c, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x06, 0x82, 0x12, 0x26, 0x00, 0x5c, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
-  0x03, 0xf0, 0x00, 0x07, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
-  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06,
-  0x00, 0x3c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x6b, 0x00, 0x12, 0x06, 0x00, 0x5c,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x80,
-  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x11, 0x33,
-  0x11, 0x21, 0x15, 0x21, 0xb5, 0xb6, 0xd1, 0xb5, 0x02, 0x8f, 0xfb, 0x35,
-  0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0xd5, 0xaa, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x1c, 0x00, 0x00, 0x03, 0x54, 0x06, 0x14, 0x00, 0x13,
-  0x00, 0x00, 0x13, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xae, 0xa5,
-  0xca, 0xa5, 0x91, 0x91, 0xa5, 0xca, 0xa5, 0x91, 0x91, 0x06, 0x14, 0x93,
-  0x93, 0x93, 0x7d, 0xfa, 0xfc, 0x05, 0x04, 0xfa, 0xfc, 0x05, 0x04, 0x7d,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x06, 0xfc, 0x65, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x34, 0x41, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x07, 0x07, 0x09, 0x00, 0x85, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x77, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0a, 0x77, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0x00, 0x90, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0b, 0x6a, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26,
-  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x18, 0x3d, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x26, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xff, 0x39, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x26, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xff, 0x0e, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0x42, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x26, 0x01, 0x64, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00,
-  0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x06, 0x42, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x26, 0x01, 0x64, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x05, 0x7b, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x26, 0x00, 0x9d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x05, 0xb6,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x26, 0x00, 0xd8, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x05, 0x0a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x26, 0x2c, 0x00,
-  0x10, 0x07, 0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
-  0x00, 0x00, 0x05, 0x4a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x26, 0x6c, 0x00,
-  0x10, 0x07, 0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x06, 0x61, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
-  0x10, 0x06, 0x06, 0xfc, 0x3d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x06, 0x61, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x34, 0x33, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x09, 0x1d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x16, 0x21, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x80, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x0a, 0x47, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x9d, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x17, 0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x04, 0xa9, 0x06, 0x61, 0x10, 0x27, 0x03, 0x2a, 0x00, 0x92,
-  0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x04, 0xa9, 0x06, 0x61, 0x10, 0x27,
-  0x03, 0x2a, 0x00, 0x92, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0x7f,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x02, 0x68, 0x00, 0x00, 0x10, 0x06,
-  0x07, 0x09, 0x89, 0x00, 0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x06, 0x8f,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x02, 0x78, 0x00, 0x00, 0x10, 0x06,
-  0x07, 0x16, 0x94, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x06, 0x03,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x01, 0xeb, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x0a, 0xff, 0x64, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0x00, 0x00, 0x06, 0x39, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x02, 0x21,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0x00, 0x95, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0x00, 0x92, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x73, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x65, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0a, 0x77, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0x00, 0x9d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0b, 0x00, 0x8c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x18, 0x7a, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x05, 0x52, 0x06, 0x61, 0x10, 0x27,
-  0x03, 0x2c, 0x00, 0x9d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x05, 0x4f,
-  0x06, 0x61, 0x10, 0x27, 0x03, 0x2c, 0x00, 0x9a, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0x00, 0x00, 0x07, 0x1d, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2c, 0x02, 0x68,
-  0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0x00, 0x00, 0x07, 0x23, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2c, 0x02, 0x6d,
-  0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x06, 0xb0, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2c, 0x01, 0xfb,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0xdc, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x2c, 0x02, 0x27, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x06, 0x04,
-  0x07, 0x6d, 0x10, 0x27, 0x03, 0x2c, 0x01, 0x4f, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
-  0x00, 0x00, 0x06, 0x1d, 0x07, 0x6d, 0x10, 0x27, 0x03, 0x2c, 0x01, 0x67,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x8b, 0x00, 0x00, 0x02, 0x30, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xff, 0x2c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x82, 0x00, 0x00, 0x02, 0x30, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xff, 0x24, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xb8, 0x00, 0x00, 0x02, 0x74, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x09, 0xff, 0x3d, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xc1, 0x00, 0x00, 0x02, 0x80, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x16, 0xff, 0x50, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x9b, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x62, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xd7, 0x00, 0x00, 0x02, 0xa3, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x50, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xd0, 0x00, 0x00, 0x02, 0x30, 0x07, 0x6d, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0b, 0xff, 0x2c, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xcb, 0x00, 0x00, 0x02, 0x30, 0x07, 0x6d, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x28, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x02, 0x08, 0x06, 0x61, 0x10, 0x27,
-  0x03, 0x2e, 0x00, 0x9d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x01, 0xfd,
-  0x06, 0x61, 0x10, 0x27, 0x03, 0x2e, 0x00, 0x92, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0x00, 0x00, 0x03, 0xde, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x02, 0x72,
-  0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0x00, 0x00, 0x03, 0xde, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x02, 0x72,
-  0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x03, 0x67, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x01, 0xfc,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x03, 0x9d, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x2e, 0x02, 0x32, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x02, 0xd2,
-  0x07, 0x6d, 0x10, 0x27, 0x03, 0x2e, 0x01, 0x67, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
-  0x00, 0x00, 0x02, 0xd9, 0x07, 0x6d, 0x10, 0x27, 0x03, 0x2e, 0x01, 0x6d,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x06, 0xfc, 0x6c, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x34, 0x63, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x5b, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x4c, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0a, 0x7a, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x53, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0x00, 0x82, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0xff, 0xe3, 0x05, 0x63, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x34, 0x20, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0xff, 0xe3, 0x05, 0xb4, 0x06, 0x61, 0x10, 0x26,
-  0x03, 0x34, 0x70, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0xff, 0xe3, 0x07, 0x7b, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x34, 0x02, 0x37, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00,
-  0xff, 0xff, 0x00, 0x05, 0xff, 0xe3, 0x07, 0x84, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x34, 0x02, 0x40, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0xff, 0xe3, 0x06, 0x5b, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x34, 0x01, 0x17, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0xff, 0xe3, 0x06, 0x95,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x34, 0x01, 0x52, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x61, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x06, 0xfc, 0x37, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x61, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x34, 0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x09, 0x23, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x16, 0x1e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x0a, 0x56, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x17, 0x4e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x0b, 0x32, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x18, 0x16, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x05, 0xa9, 0x06, 0x61, 0x10, 0x27, 0x03, 0x39, 0x01, 0x3f,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x07, 0x33, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x39, 0x02, 0xc9, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x07, 0x4e, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x39, 0x02, 0xe4, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x06, 0x7b,
-  0x07, 0x6d, 0x10, 0x27, 0x03, 0x39, 0x02, 0x11, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfc, 0x01, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x34, 0x01, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x09, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x16, 0x01, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x0a, 0x01, 0x7a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x17, 0x01, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x0b, 0x01, 0x40, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x18, 0x01, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x05, 0x81, 0x06, 0x61, 0x10, 0x26, 0x03, 0x3d, 0x46, 0x00,
-  0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x05, 0xcd, 0x06, 0x61, 0x10, 0x27, 0x03, 0x3d, 0x00, 0x92,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x07, 0x92, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x3d, 0x02, 0x57, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00,
-  0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x07, 0x9d, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x3d, 0x02, 0x62, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
-  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x06, 0x8a, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x3d, 0x01, 0x4f, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0xba,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x3d, 0x01, 0x7f, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0x00, 0x00, 0x06, 0x5d, 0x07, 0x6d, 0x10, 0x27, 0x03, 0x3d, 0x01, 0x22,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x06, 0x95, 0x07, 0x6d, 0x10, 0x27,
-  0x03, 0x3d, 0x01, 0x5a, 0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x60,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
-  0x06, 0x66, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x28,
-  0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
-  0x06, 0x66, 0x10, 0x06, 0x03, 0x40, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x28, 0x4c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
-  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x06, 0x03, 0x41, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0x00, 0xb2, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x06,
-  0x03, 0x42, 0x00, 0x00, 0xff, 0xff, 0xff, 0x98, 0x00, 0x00, 0x02, 0x30,
-  0x06, 0x66, 0x10, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28,
-  0xff, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x56,
-  0x06, 0x66, 0x10, 0x06, 0x03, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26, 0x03, 0x53, 0x00, 0x00,
-  0x10, 0x06, 0x07, 0x28, 0x6f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x06, 0x03, 0x60, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26,
-  0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x07, 0x28, 0x2b, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x06,
-  0x03, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
-  0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28,
-  0x01, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
-  0x06, 0x66, 0x10, 0x06, 0x03, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26, 0x06, 0x4c, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26, 0x06, 0x4d, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x4e, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x4f, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x50, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x51, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x52, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x53, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0xfe, 0x56, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26, 0x06, 0x54, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0xfe, 0x56, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26, 0x06, 0x55, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0xfe, 0x56, 0x06, 0x42, 0x06, 0x66, 0x10, 0x26, 0x06, 0x56, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x0c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0xfe, 0x56, 0x06, 0x42, 0x06, 0x66, 0x10, 0x26, 0x06, 0x57, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x0c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x05, 0x7b, 0x06, 0x66, 0x10, 0x26, 0x06, 0x58, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x01, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0xfe, 0x56, 0x05, 0xb6, 0x06, 0x66, 0x10, 0x26, 0x06, 0x59, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x01, 0x7f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x05, 0x0a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x5a, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x00, 0xd4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
-  0xfe, 0x56, 0x05, 0x4a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x5b, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x01, 0x13, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26, 0x06, 0x68, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26, 0x06, 0x69, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6a, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6b, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6c, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6d, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x6e, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x6f, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x05, 0x52, 0x06, 0x61, 0x10, 0x26, 0x06, 0x70, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x01, 0x75, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x05, 0x4f, 0x06, 0x61, 0x10, 0x26, 0x06, 0x71, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x01, 0x72, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0xfe, 0x56, 0x07, 0x1d, 0x06, 0x66, 0x10, 0x26, 0x06, 0x72, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x03, 0x40, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0xfe, 0x56, 0x07, 0x23, 0x06, 0x66, 0x10, 0x26, 0x06, 0x73, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x03, 0x45, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x06, 0xb0, 0x06, 0x66, 0x10, 0x26, 0x06, 0x74, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0xd3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0xfe, 0x56, 0x06, 0xdc, 0x06, 0x66, 0x10, 0x26, 0x06, 0x75, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x06, 0x04, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x76, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
-  0xfe, 0x56, 0x06, 0x1d, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x77, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x3f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa0, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa1, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa2, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa3, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa4, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa5, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xa6, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xfe, 0x56, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xa7, 0x00, 0x00,
-  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x05, 0x81, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa8, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x01, 0x39, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x05, 0xcd, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa9, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x01, 0x85, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0xfe, 0x56, 0x07, 0x92, 0x06, 0x66, 0x10, 0x26, 0x06, 0xaa, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x03, 0x4a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
-  0xfe, 0x56, 0x07, 0x9d, 0x06, 0x66, 0x10, 0x26, 0x06, 0xab, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x03, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x06, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xac, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x42, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
-  0xfe, 0x56, 0x06, 0xba, 0x06, 0x66, 0x10, 0x26, 0x06, 0xad, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x72, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
-  0xfe, 0x56, 0x06, 0x5d, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xae, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x15, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
-  0xfe, 0x56, 0x06, 0x95, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xaf, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x02, 0x4e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe7, 0x04, 0x67, 0x06, 0x48, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
-  0x10, 0x06, 0x02, 0x9a, 0x6e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe7, 0x04, 0x67, 0x05, 0xf6, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
-  0x10, 0x06, 0x00, 0x71, 0x6d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0xb0, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x04, 0x79, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x03, 0x40, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe7, 0x04, 0x67, 0x06, 0x37, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
-  0x10, 0x06, 0x06, 0xfd, 0x63, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x67, 0x06, 0x37, 0x10, 0x26, 0x06, 0xf3, 0x00, 0x00,
-  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x26, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf2, 0x04, 0x41, 0x01, 0x75, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x07, 0x31, 0x10, 0x26, 0x03, 0x26, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x71, 0x00, 0xaa, 0x01, 0x3b, 0xff, 0xff, 0xff, 0xfc,
-  0x00, 0x00, 0x05, 0x19, 0x06, 0x66, 0x10, 0x26, 0x03, 0x26, 0x3b, 0x00,
-  0x10, 0x07, 0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x06, 0x66, 0x10, 0x06, 0x03, 0x1d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x56, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x26,
-  0x03, 0x26, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfb, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x5f, 0x04, 0xc2, 0x02, 0x39, 0x06, 0x61, 0x10, 0x06,
-  0x06, 0xfc, 0x00, 0x00, 0xff, 0xff, 0x01, 0x8a, 0xfe, 0x56, 0x02, 0x51,
-  0xff, 0xa4, 0x10, 0x06, 0x03, 0x16, 0x00, 0x00, 0x00, 0x01, 0x01, 0x5f,
-  0x04, 0xc2, 0x02, 0x39, 0x06, 0x61, 0x00, 0x08, 0x00, 0x00, 0x01, 0x10,
-  0x23, 0x35, 0x16, 0x35, 0x23, 0x35, 0x33, 0x02, 0x39, 0xda, 0x79, 0x78,
-  0xd9, 0x05, 0xcd, 0xfe, 0xf5, 0x67, 0x03, 0x9d, 0x9e, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa3, 0x05, 0x1d, 0x02, 0xf6, 0x06, 0x37, 0x10, 0x06,
-  0x02, 0x9e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa3, 0x05, 0x46, 0x02, 0xf6,
-  0x07, 0x6d, 0x10, 0x27, 0x10, 0xed, 0x03, 0x9a, 0x01, 0x84, 0x12, 0x06,
-  0x00, 0x6a, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x06, 0x66, 0x10, 0x26, 0x06, 0xb4, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x04, 0x7b, 0x10, 0x26, 0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x06, 0x66, 0x10, 0x26, 0x03, 0x42, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x06, 0x37, 0x10, 0x26, 0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfd,
-  0x00, 0x82, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x06, 0x37, 0x10, 0x26, 0x07, 0x02, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x05, 0x56,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x01, 0x3f, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe9,
-  0x00, 0x00, 0x04, 0xea, 0x06, 0x66, 0x10, 0x06, 0x03, 0x1f, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x05, 0xff, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x2c, 0x01, 0x49, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0xff, 0x63,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf4, 0x00, 0x00, 0x05, 0x83,
-  0x06, 0x66, 0x10, 0x06, 0x03, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0xfe, 0x56, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x26, 0x03, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x00, 0xe6, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b,
-  0x04, 0xc2, 0x03, 0x37, 0x06, 0x66, 0x10, 0x27, 0x06, 0xfc, 0xff, 0x1c,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0x00, 0xee, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa2, 0x04, 0xc2, 0x03, 0x39, 0x06, 0x66, 0x10, 0x27,
-  0x06, 0xfc, 0xff, 0x43, 0x00, 0x00, 0x10, 0x06, 0x07, 0x33, 0x3b, 0x00,
-  0xff, 0xff, 0x00, 0xa3, 0x04, 0xc2, 0x02, 0xf6, 0x07, 0x6d, 0x10, 0x27,
-  0x10, 0xed, 0x03, 0x9a, 0x01, 0x84, 0x10, 0x06, 0x06, 0xfc, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xed, 0x00, 0x00, 0x02, 0x30, 0x06, 0x48, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9a, 0xff, 0x3a, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xe5, 0x00, 0x00, 0x02, 0x30, 0x05, 0xf6, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71, 0xff, 0x26, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xdc, 0x00, 0x00, 0x02, 0x30, 0x07, 0xd2, 0x10, 0x26,
-  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x26, 0xff, 0x43, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x40, 0x07, 0xd2, 0x10, 0x06,
-  0x03, 0x25, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe6, 0x00, 0x00, 0x02, 0x39,
-  0x06, 0x37, 0x10, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfd,
-  0xff, 0x43, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe8, 0x00, 0x00, 0x02, 0x3b,
-  0x07, 0x6d, 0x10, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfe,
-  0xff, 0x45, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf6, 0x00, 0x00, 0x02, 0x2a,
-  0x07, 0x6d, 0x10, 0x26, 0x03, 0x2e, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf2,
-  0x02, 0xdd, 0x01, 0x75, 0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x02, 0x1d,
-  0x07, 0x31, 0x10, 0x26, 0x03, 0x2e, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71,
-  0xff, 0x43, 0x01, 0x3b, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x02, 0xb7,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x01, 0x4c, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0x3e, 0x06, 0x66, 0x10, 0x06, 0x03, 0x21, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x71, 0x04, 0xc2, 0x03, 0x31, 0x06, 0x66, 0x10, 0x27,
-  0x07, 0x34, 0xff, 0x12, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0x00, 0xe8,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0x04, 0xc2, 0x03, 0x53,
-  0x06, 0x66, 0x10, 0x27, 0x07, 0x34, 0xff, 0x27, 0x00, 0x00, 0x10, 0x06,
-  0x07, 0x33, 0x56, 0x00, 0xff, 0xff, 0x00, 0xa3, 0x04, 0xc2, 0x02, 0xf6,
-  0x07, 0x6d, 0x10, 0x27, 0x10, 0xed, 0x03, 0x9a, 0x01, 0x84, 0x10, 0x06,
-  0x07, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
-  0x06, 0x48, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x02, 0x9a,
-  0x23, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
-  0x05, 0xf6, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x00, 0x71,
-  0x20, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
-  0x07, 0xd2, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x07, 0x26,
-  0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
-  0x07, 0xd2, 0x10, 0x06, 0x03, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x61, 0x10, 0x26, 0x03, 0x55, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfc, 0x00, 0xa8, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x61, 0x10, 0x26, 0x03, 0x55, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x34, 0x00, 0x9f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x37, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x06, 0xfd, 0x23, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
-  0xff, 0xe3, 0x03, 0xc0, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
-  0x10, 0x06, 0x06, 0xfe, 0x17, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc,
-  0x00, 0x00, 0x04, 0x6a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x39, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf2, 0x04, 0x04, 0x01, 0x75, 0xff, 0xff, 0xff, 0xfc,
-  0x00, 0x00, 0x04, 0x6a, 0x07, 0x31, 0x10, 0x26, 0x03, 0x39, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x71, 0x00, 0x74, 0x01, 0x3b, 0xff, 0xff, 0xff, 0xfc,
-  0x00, 0x00, 0x06, 0x1a, 0x06, 0x66, 0x10, 0x27, 0x03, 0x39, 0x01, 0xb0,
-  0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xe4, 0x00, 0x00, 0x05, 0xe9, 0x06, 0x66, 0x10, 0x06,
-  0x03, 0x23, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x04, 0xb0,
-  0x06, 0x61, 0x10, 0x27, 0x03, 0x36, 0x00, 0x97, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x05, 0x46, 0x02, 0xd9, 0x07, 0xd2, 0x12, 0x26, 0x00, 0x6a, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x28, 0x00, 0x00, 0x01, 0x6c, 0xff, 0xff, 0x00, 0xc1,
-  0x05, 0x46, 0x02, 0xfd, 0x07, 0xd2, 0x10, 0x06, 0x03, 0x1c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x04, 0xf0, 0x02, 0x49, 0x06, 0x66, 0x10, 0x06,
-  0x00, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
-  0x06, 0x66, 0x10, 0x26, 0x06, 0xbc, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
-  0x04, 0x60, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
-  0x06, 0x66, 0x10, 0x26, 0x03, 0x62, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
-  0x06, 0x37, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfd,
-  0x01, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
-  0x06, 0x37, 0x10, 0x26, 0x07, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
-  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xe3, 0x06, 0x5f,
-  0x06, 0x66, 0x10, 0x27, 0x03, 0x34, 0x01, 0x1c, 0x00, 0x00, 0x10, 0x07,
-  0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf3,
-  0xff, 0xe3, 0x05, 0x68, 0x06, 0x66, 0x10, 0x06, 0x03, 0x22, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x06, 0x5e, 0x06, 0x66, 0x10, 0x27,
-  0x03, 0x3d, 0x01, 0x24, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0xff, 0x63,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde, 0x00, 0x00, 0x05, 0x6b,
-  0x06, 0x66, 0x10, 0x06, 0x03, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0x46,
-  0xfe, 0x56, 0x05, 0x3b, 0x05, 0xe7, 0x10, 0x26, 0x03, 0x3d, 0x00, 0x00,
-  0x10, 0x07, 0x06, 0xfb, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x01, 0x4d,
-  0x04, 0xee, 0x02, 0xfd, 0x06, 0x66, 0x10, 0x06, 0x00, 0x76, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x5f, 0x04, 0xc2, 0x02, 0x39, 0x06, 0x61, 0x00, 0x08,
-  0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x23, 0x14, 0x37, 0x15, 0x22, 0x01,
-  0x5f, 0xd9, 0x78, 0x79, 0xda, 0x05, 0xcd, 0x94, 0x9e, 0x9d, 0x03, 0x67,
-  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40, 0x02, 0x83, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x01, 0xe5, 0xfe, 0x1b, 0x02,
-  0x83, 0xa4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40,
-  0x02, 0x83, 0x12, 0x06, 0x07, 0x45, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0x01, 0xe9, 0x04, 0x3b, 0x02, 0x79, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x5a, 0x03, 0xe1, 0xfc, 0x1f, 0x02, 0x79, 0x90, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x01, 0xe9, 0x03, 0x40, 0x02, 0x79, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x02, 0xe6, 0xfd, 0x1a, 0x02,
-  0x79, 0x90, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x01, 0xe9, 0x06, 0xda,
-  0x02, 0x79, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x06,
-  0x7f, 0xf9, 0x81, 0x02, 0x79, 0x90, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0x01, 0xe9, 0x07, 0x34, 0x02, 0x79, 0x00, 0x03, 0x00, 0x00, 0x11, 0x21,
-  0x15, 0x21, 0x07, 0x33, 0xf8, 0xcd, 0x02, 0x79, 0x90, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xea, 0xfe, 0x1d, 0x02, 0xac, 0x06, 0x1d, 0x10, 0x26,
-  0x00, 0x5f, 0x00, 0x00, 0x10, 0x07, 0x00, 0x5f, 0x01, 0x29, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xee, 0xfe, 0x1d, 0x03, 0xac, 0xff, 0xee, 0x10, 0x26,
-  0x00, 0x42, 0x00, 0x00, 0x10, 0x07, 0x00, 0x42, 0x00, 0x00, 0x01, 0x42,
-  0x00, 0x01, 0x00, 0x9c, 0x03, 0xe9, 0x01, 0xa5, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x23, 0x35, 0x13, 0x33, 0x03, 0x01, 0x5a, 0xbd, 0x93,
-  0x74, 0x4a, 0x03, 0xe9, 0xad, 0x01, 0x3f, 0xfe, 0xc1, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa0, 0x03, 0xfe, 0x01, 0xa8, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x00, 0x13, 0x33, 0x15, 0x03, 0x23, 0x13, 0xea, 0xbe, 0x94, 0x74,
-  0x4a, 0x05, 0xd5, 0x98, 0xfe, 0xc1, 0x01, 0x3f, 0x00, 0x01, 0x00, 0x9c,
-  0xff, 0x12, 0x01, 0xa5, 0x00, 0xfe, 0x00, 0x05, 0x00, 0x00, 0x37, 0x33,
-  0x15, 0x03, 0x23, 0x13, 0xe6, 0xbe, 0x93, 0x74, 0x49, 0xfe, 0xac, 0xfe,
-  0xc0, 0x01, 0x40, 0x00, 0x00, 0x01, 0x00, 0xa0, 0x03, 0xfe, 0x01, 0xa8,
-  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15, 0x13, 0x23, 0x03, 0x35,
-  0x01, 0x5e, 0x4a, 0x74, 0x94, 0x05, 0xd5, 0x98, 0xfe, 0xc1, 0x01, 0x3f,
-  0x98, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9c, 0x03, 0xe9, 0x03, 0x16,
-  0x05, 0xd5, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23, 0x35, 0x13,
-  0x33, 0x03, 0x05, 0x23, 0x35, 0x13, 0x33, 0x03, 0x01, 0x5a, 0xbd, 0x93,
-  0x74, 0x4a, 0x01, 0x72, 0xbe, 0x93, 0x74, 0x49, 0x03, 0xe9, 0xad, 0x01,
-  0x3f, 0xfe, 0xc1, 0xad, 0xad, 0x01, 0x3f, 0xfe, 0xc1, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x9c, 0x03, 0xe9, 0x03, 0x16, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x15, 0x03, 0x23, 0x13, 0x25, 0x33,
-  0x15, 0x03, 0x23, 0x13, 0xe6, 0xbe, 0x93, 0x74, 0x49, 0x01, 0x71, 0xbe,
-  0x93, 0x74, 0x49, 0x05, 0xd5, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0xac, 0xac,
-  0xfe, 0xc0, 0x01, 0x40, 0x00, 0x02, 0x00, 0x9c, 0xff, 0x12, 0x03, 0x16,
-  0x00, 0xfe, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33, 0x15, 0x03,
-  0x23, 0x13, 0x25, 0x33, 0x15, 0x03, 0x23, 0x13, 0x02, 0x57, 0xbe, 0x93,
-  0x74, 0x49, 0xfe, 0x8f, 0xbe, 0x93, 0x74, 0x49, 0xfe, 0xac, 0xfe, 0xc0,
-  0x01, 0x40, 0xac, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0x00, 0x02, 0x00, 0x9c,
-  0x03, 0xe9, 0x03, 0x16, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00,
-  0x01, 0x15, 0x13, 0x23, 0x03, 0x35, 0x21, 0x15, 0x13, 0x23, 0x03, 0x35,
-  0x01, 0x5a, 0x4a, 0x74, 0x93, 0x02, 0x2f, 0x49, 0x74, 0x93, 0x05, 0xd5,
-  0xad, 0xfe, 0xc1, 0x01, 0x3f, 0xad, 0xad, 0xfe, 0xc1, 0x01, 0x3f, 0xad,
-  0x00, 0x01, 0x00, 0x33, 0xff, 0x3b, 0x03, 0x67, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x35, 0x21, 0x01, 0x7e, 0x9e, 0x01, 0x4a, 0xfe, 0xb6, 0x9e, 0xfe, 0xb5,
-  0x01, 0x4b, 0x05, 0xd5, 0xfe, 0x5c, 0x99, 0xfb, 0xa3, 0x04, 0x5d, 0x99,
-  0x00, 0x01, 0x00, 0x33, 0xff, 0x3b, 0x03, 0x67, 0x05, 0xd5, 0x00, 0x13,
-  0x00, 0x00, 0x25, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21,
-  0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x03, 0x66,
-  0xfe, 0xb6, 0x9e, 0xfe, 0xb5, 0x01, 0x4b, 0xfe, 0xb5, 0x01, 0x4b, 0x9e,
-  0x01, 0x4a, 0xfe, 0xb6, 0x01, 0x4a, 0xdf, 0xfe, 0x5c, 0x01, 0xa4, 0x9a,
-  0x02, 0x1f, 0x99, 0x01, 0xa4, 0xfe, 0x5c, 0x99, 0xfd, 0xe1, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x14, 0x01, 0xd1, 0x03, 0x2b, 0x04, 0x21, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x01, 0x14, 0x9c, 0x71, 0x70, 0x9a, 0x9b, 0x70, 0x71, 0x9b,
-  0x02, 0xfa, 0x7c, 0xab, 0xab, 0x7c, 0x7d, 0xac, 0xac, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x14, 0x01, 0x81, 0x03, 0x73, 0x04, 0x71, 0x00, 0x02,
-  0x00, 0x00, 0x01, 0x11, 0x01, 0x01, 0x14, 0x02, 0x5f, 0x01, 0x81, 0x02,
-  0xf0, 0xfe, 0x88, 0x00, 0x00, 0x01, 0x00, 0xd4, 0x00, 0x00, 0x01, 0x95,
-  0x00, 0xfe, 0x00, 0x03, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23, 0xd4, 0xc0,
-  0xc0, 0xfe, 0xfe, 0x00, 0x00, 0x02, 0x00, 0xd4, 0x00, 0x00, 0x03, 0xfa,
-  0x00, 0xfe, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23,
-  0x25, 0x33, 0x15, 0x23, 0x03, 0x3a, 0xc0, 0xc0, 0xfd, 0x9a, 0xc0, 0xc0,
-  0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x03, 0x00, 0xd4, 0x00, 0x00, 0x06, 0x5f,
-  0x00, 0xfe, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33,
-  0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x03, 0x3a,
-  0xbf, 0xbf, 0x02, 0x65, 0xc0, 0xc0, 0xfb, 0x35, 0xc0, 0xc0, 0xfe, 0xfe,
-  0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x01, 0x00, 0xc6, 0x02, 0x6b, 0x01, 0x84,
-  0x03, 0x69, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0xc6, 0xbe,
-  0xbe, 0x03, 0x69, 0xfe, 0x00, 0x07, 0x00, 0x65, 0xff, 0xe3, 0x09, 0x45,
-  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x27, 0x00, 0x33,
-  0x00, 0x3f, 0x00, 0x4b, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x21, 0x33, 0x01, 0x23, 0x13, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x01, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x17, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x08, 0x0f,
-  0x4f, 0x5a, 0x5a, 0x4f, 0x4c, 0x59, 0x59, 0x4c, 0x8e, 0xa7, 0xa8, 0x8d,
-  0x90, 0xa8, 0xa9, 0xfa, 0x1b, 0x8f, 0xa9, 0xa9, 0x8f, 0x8f, 0xa6, 0xa7,
-  0x03, 0xbb, 0x90, 0xfc, 0xb7, 0x90, 0x1c, 0x4d, 0x59, 0x58, 0x4e, 0x4f,
-  0x59, 0x5a, 0x03, 0x53, 0x8e, 0xa8, 0xa9, 0x8d, 0x90, 0xa7, 0xa8, 0x8f,
-  0x4e, 0x59, 0x59, 0x4e, 0x4d, 0x59, 0x59, 0x02, 0x91, 0x94, 0x84, 0x82,
-  0x95, 0x95, 0x82, 0x83, 0x95, 0x7f, 0xdc, 0xbb, 0xbb, 0xdb, 0xdb, 0xbb,
-  0xbc, 0xdb, 0x02, 0xe0, 0xdb, 0xbb, 0xbd, 0xda, 0xdb, 0xbc, 0xba, 0xdc,
-  0xf9, 0xf3, 0x05, 0x8e, 0x95, 0x82, 0x84, 0x94, 0x94, 0x84, 0x81, 0x96,
-  0xfd, 0x9f, 0xdc, 0xbb, 0xbb, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x7f, 0x94,
-  0x84, 0x82, 0x95, 0x95, 0x82, 0x83, 0x95, 0x00, 0x00, 0x09, 0x00, 0x65,
-  0xff, 0xe3, 0x0c, 0x1a, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22,
-  0x00, 0x2d, 0x00, 0x37, 0x00, 0x3b, 0x00, 0x45, 0x00, 0x50, 0x00, 0x5c,
-  0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x27, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x05, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x27, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
-  0x00, 0x20, 0x16, 0x15, 0x14, 0x06, 0x20, 0x26, 0x35, 0x34, 0x25, 0x33,
-  0x01, 0x23, 0x12, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34,
-  0x01, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x17,
-  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x0a,
-  0xe4, 0x4e, 0x5a, 0x5a, 0x4e, 0x4d, 0x59, 0x59, 0x4d, 0x8e, 0xa8, 0xa8,
-  0x8e, 0x90, 0xa7, 0xa8, 0xfd, 0xba, 0x4f, 0x5a, 0x5a, 0x4f, 0x4c, 0x59,
-  0x59, 0x4c, 0x8e, 0xa7, 0xa8, 0x8d, 0x90, 0xa8, 0xa9, 0xf9, 0x8d, 0x01,
-  0x1d, 0xa9, 0xa9, 0xfe, 0xe2, 0xa6, 0x04, 0x62, 0x90, 0xfc, 0xb7, 0x90,
-  0x6a, 0x9b, 0x59, 0x58, 0x9d, 0x59, 0x02, 0xf9, 0x8e, 0xa8, 0xa9, 0x8d,
-  0x90, 0xa7, 0xa8, 0x8f, 0x4e, 0x59, 0x59, 0x4e, 0x4d, 0x59, 0x59, 0x02,
-  0x91, 0x94, 0x84, 0x82, 0x95, 0x95, 0x82, 0x83, 0x95, 0x7f, 0xdc, 0xfe,
-  0x8a, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x7f, 0x94, 0x84, 0x82, 0x95, 0x95,
-  0x82, 0x83, 0x95, 0x7f, 0xdc, 0xfe, 0x8a, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb,
-  0x02, 0xe0, 0xdb, 0xbb, 0xbd, 0xda, 0xdb, 0xbc, 0xba, 0xdc, 0xf9, 0xf3,
-  0x05, 0x8e, 0x95, 0x82, 0x84, 0x94, 0x94, 0x84, 0x81, 0xfe, 0x35, 0xdc,
-  0xfe, 0x8a, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x7f, 0x94, 0x84, 0x82, 0x95,
-  0x95, 0x82, 0x83, 0x95, 0x00, 0x01, 0x00, 0x24, 0x04, 0x60, 0x01, 0x77,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x1b, 0x01, 0x33, 0x01, 0x24, 0x9c,
-  0xb6, 0xfe, 0xfc, 0x04, 0x60, 0x01, 0x75, 0xfe, 0x8b, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x02, 0x85, 0x05, 0xd5, 0x10, 0x26,
-  0x07, 0x67, 0x00, 0x00, 0x10, 0x07, 0x07, 0x67, 0x01, 0x0e, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x03, 0x93, 0x05, 0xd5, 0x10, 0x27,
-  0x07, 0x67, 0x01, 0x0e, 0x00, 0x00, 0x10, 0x26, 0x07, 0x67, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x67, 0x02, 0x1c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x24,
-  0x04, 0x60, 0x01, 0x77, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x23,
-  0x01, 0x33, 0x01, 0x76, 0x4e, 0xfe, 0xfc, 0xb7, 0x04, 0x60, 0x01, 0x75,
-  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x02, 0x85, 0x05, 0xd5, 0x10, 0x26,
-  0x07, 0x6a, 0x00, 0x00, 0x10, 0x07, 0x07, 0x6a, 0x01, 0x0e, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x03, 0x93, 0x05, 0xd5, 0x10, 0x26,
-  0x07, 0x6a, 0x00, 0x00, 0x10, 0x27, 0x07, 0x6a, 0x02, 0x1c, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x6a, 0x01, 0x0e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
-  0xfe, 0x1d, 0x02, 0x67, 0xff, 0xc3, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
-  0x27, 0x07, 0x23, 0x01, 0x02, 0x67, 0x85, 0xa9, 0xa9, 0x86, 0x01, 0x30,
-  0xfe, 0x1d, 0xf9, 0xf9, 0x01, 0xa6, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8e,
-  0x00, 0x8d, 0x02, 0x35, 0x04, 0x23, 0x00, 0x06, 0x00, 0x00, 0x01, 0x15,
-  0x09, 0x01, 0x15, 0x01, 0x35, 0x02, 0x34, 0xfe, 0xf1, 0x01, 0x0f, 0xfe,
-  0x5a, 0x04, 0x23, 0xbf, 0xfe, 0xf4, 0xfe, 0xf4, 0xbf, 0x01, 0xa2, 0x52,
-  0x00, 0x01, 0x00, 0xad, 0x00, 0x8d, 0x02, 0x54, 0x04, 0x23, 0x00, 0x06,
-  0x00, 0x00, 0x13, 0x01, 0x15, 0x01, 0x35, 0x09, 0x01, 0xae, 0x01, 0xa6,
-  0xfe, 0x5a, 0x01, 0x0f, 0xfe, 0xf1, 0x04, 0x23, 0xfe, 0x5e, 0x52, 0xfe,
-  0x5e, 0xbf, 0x01, 0x0c, 0x01, 0x0c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xaf,
-  0x00, 0x04, 0x05, 0x54, 0x05, 0xcc, 0x12, 0x26, 0x00, 0x99, 0x00, 0x4b,
-  0x10, 0x27, 0x00, 0x11, 0xff, 0xea, 0x02, 0x4e, 0x10, 0x27, 0x00, 0x11,
-  0x01, 0xe1, 0x00, 0x04, 0x10, 0x27, 0x00, 0x11, 0x03, 0xd0, 0x02, 0x4e,
-  0x10, 0x07, 0x00, 0x11, 0x01, 0xe1, 0x04, 0xce, 0xff, 0xff, 0x00, 0x84,
-  0x00, 0x00, 0x02, 0xfb, 0x05, 0xd5, 0x10, 0x27, 0x00, 0x04, 0xff, 0x6e,
-  0x00, 0x00, 0x10, 0x07, 0x00, 0x04, 0x01, 0x2e, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x84, 0x00, 0x00, 0x03, 0x52, 0x05, 0xf0, 0x00, 0x17,
-  0x00, 0x1b, 0x00, 0x24, 0x00, 0x00, 0x01, 0x23, 0x11, 0x06, 0x07, 0x06,
-  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x0f, 0x01,
-  0x0e, 0x01, 0x07, 0x0e, 0x01, 0x15, 0x03, 0x33, 0x15, 0x23, 0x13, 0x11,
-  0x37, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x02, 0x11, 0xac, 0x1c, 0x1d,
-  0x50, 0x58, 0x55, 0xae, 0x5c, 0xa6, 0xc9, 0x41, 0x51, 0x4f, 0x2b, 0x23,
-  0x07, 0x05, 0x06, 0xb1, 0xb7, 0xb7, 0xb1, 0x29, 0x33, 0x2e, 0x3b, 0x21,
-  0x01, 0x91, 0x03, 0xad, 0x08, 0x0d, 0x23, 0x43, 0xbc, 0x39, 0x38, 0xc2,
-  0x9f, 0x4c, 0x89, 0x56, 0x56, 0x2f, 0x35, 0x19, 0x15, 0x3c, 0x34, 0xfe,
-  0xf2, 0xfe, 0x05, 0x42, 0xfe, 0x52, 0x2d, 0x35, 0x5e, 0x31, 0x59, 0x37,
-  0x1f, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x05, 0x7c, 0x03, 0xac,
-  0x06, 0x0b, 0x10, 0x07, 0x00, 0x42, 0x00, 0x00, 0x07, 0x5f, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xaf, 0xfe, 0x1b, 0x06, 0x1a, 0xff, 0x85, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x32, 0x24, 0x37, 0x15, 0x06, 0x04, 0x23, 0x22, 0x24,
-  0x27, 0x35, 0x16, 0x04, 0x02, 0xe4, 0xd0, 0x01, 0x97, 0xcf, 0xd4, 0xfe,
-  0x67, 0xc9, 0xc9, 0xfe, 0x69, 0xd4, 0xcf, 0x01, 0x95, 0xfe, 0xb5, 0x68,
-  0x68, 0x7e, 0x76, 0x76, 0x75, 0x77, 0x7e, 0x69, 0x67, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xaf, 0x06, 0x04, 0x06, 0x1a, 0x07, 0x6e, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x32, 0x04, 0x17, 0x15, 0x26, 0x24, 0x23, 0x22, 0x04,
-  0x07, 0x35, 0x36, 0x24, 0x02, 0xe4, 0xc9, 0x01, 0x99, 0xd4, 0xcf, 0xfe,
-  0x69, 0xd0, 0xd0, 0xfe, 0x6b, 0xcf, 0xd4, 0x01, 0x97, 0x07, 0x6e, 0x76,
-  0x76, 0x7e, 0x68, 0x68, 0x67, 0x69, 0x7e, 0x77, 0x75, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xb2, 0xfe, 0x1d, 0x02, 0x0f, 0x01, 0xd5, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x33, 0x09, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x01, 0xb6,
-  0x58, 0xfe, 0xff, 0x01, 0x01, 0x58, 0xd5, 0xd5, 0x59, 0x01, 0xd5, 0xfe,
-  0x24, 0xfe, 0x24, 0x01, 0x8a, 0xfe, 0x76, 0x00, 0xff, 0xff, 0x00, 0x36,
-  0xff, 0xc5, 0x06, 0xfd, 0x06, 0x83, 0x10, 0x27, 0x00, 0x0d, 0x00, 0x00,
-  0xfd, 0x7b, 0x10, 0x27, 0x00, 0x0d, 0x03, 0x9a, 0xfd, 0x7b, 0x10, 0x07,
-  0x00, 0x0d, 0x01, 0xcd, 0x00, 0x93, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc6,
-  0x02, 0x81, 0x02, 0xe2, 0x03, 0x5f, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0xc7, 0x02, 0x1a, 0xfd, 0xe6, 0x03, 0x5f, 0xde, 0x00, 0x00,
-  0x00, 0x01, 0xfe, 0xae, 0xff, 0xe3, 0x02, 0x86, 0x05, 0xf0, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x01, 0xf5, 0x90, 0xfc, 0xb9, 0x90,
-  0x05, 0xf0, 0xf9, 0xf3, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c,
-  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x21, 0x11,
-  0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x01, 0x44, 0xd8, 0xfe, 0x82, 0x01,
-  0x7e, 0xd8, 0xd8, 0x02, 0x5e, 0xfd, 0x23, 0x8f, 0x07, 0x22, 0x8f, 0xfd,
-  0x23, 0x4a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c,
-  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35, 0x33, 0x11, 0x23, 0x35,
-  0x21, 0x11, 0x21, 0x35, 0x33, 0x11, 0x9e, 0xd8, 0xd8, 0x01, 0x7e, 0xfe,
-  0x82, 0xd8, 0x02, 0x5e, 0x4a, 0x02, 0xdd, 0x8f, 0xf8, 0xde, 0x8f, 0x02,
-  0xdd, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x42, 0x00, 0x00, 0x06, 0x62,
-  0x05, 0xf0, 0x10, 0x26, 0x00, 0x22, 0xbe, 0x00, 0x10, 0x07, 0x00, 0x22,
-  0x03, 0x10, 0x00, 0x00, 0xff, 0xff, 0x00, 0x84, 0x00, 0x00, 0x04, 0xc3,
-  0x05, 0xf0, 0x10, 0x26, 0x00, 0x22, 0x00, 0x00, 0x10, 0x07, 0x00, 0x04,
-  0x02, 0xf6, 0x00, 0x00, 0xff, 0xff, 0x00, 0x84, 0x00, 0x00, 0x04, 0xc3,
-  0x05, 0xf0, 0x10, 0x27, 0x00, 0x04, 0xff, 0x6e, 0x00, 0x00, 0x10, 0x07,
-  0x00, 0x22, 0x01, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0xff, 0x05, 0x03, 0x3b, 0x04, 0x5d, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x16,
-  0x33, 0x32, 0x37, 0x07, 0x01, 0x23, 0x13, 0x06, 0x20, 0x27, 0x5a, 0x8b,
-  0xd2, 0xe2, 0xa1, 0x07, 0xfe, 0xfd, 0x89, 0xee, 0x6a, 0xfe, 0xe3, 0xb4,
-  0x04, 0x5d, 0x10, 0x10, 0x80, 0xfb, 0x28, 0x04, 0xae, 0x0f, 0x0f, 0x00,
-  0x00, 0x01, 0x00, 0xd4, 0xff, 0x3b, 0x04, 0x14, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x11, 0x23, 0x11,
-  0x23, 0x11, 0x23, 0x11, 0x02, 0x68, 0xc1, 0xea, 0xd3, 0xc2, 0x80, 0xab,
-  0x7f, 0x05, 0xd5, 0xe8, 0xbe, 0xb8, 0xdd, 0x11, 0xfc, 0xb2, 0x06, 0x1f,
-  0xf9, 0xe1, 0x06, 0x9a, 0x00, 0x02, 0x00, 0xc2, 0x01, 0xc2, 0x02, 0xd8,
-  0x04, 0x12, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33, 0x11, 0x07,
-  0x2b, 0x01, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x02, 0x3a, 0x9d, 0x9d,
-  0x6a, 0x02, 0x71, 0x9b, 0x9c, 0x72, 0x04, 0x12, 0xfd, 0xb1, 0x01, 0xac,
-  0x7d, 0x7c, 0xab, 0x00, 0x00, 0x02, 0x00, 0xc2, 0x01, 0xc2, 0x02, 0xd8,
-  0x04, 0x12, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x27, 0x11, 0x3b,
-  0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x01, 0x60, 0x9e, 0x9e,
-  0x6a, 0x72, 0x9b, 0x9b, 0x70, 0x02, 0x01, 0xc2, 0x01, 0x02, 0x4f, 0xab,
-  0x7c, 0x7d, 0xac, 0x00, 0xff, 0xff, 0x00, 0x36, 0xff, 0xc5, 0x03, 0x63,
-  0x03, 0x6b, 0x12, 0x07, 0x00, 0x0d, 0x00, 0x00, 0xfd, 0x7b, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x00, 0xff, 0x12, 0x02, 0x09, 0x04, 0x23, 0x00, 0x03,
-  0x00, 0x09, 0x00, 0x00, 0x01, 0x15, 0x23, 0x35, 0x13, 0x15, 0x13, 0x23,
-  0x03, 0x35, 0x01, 0xbe, 0xbe, 0xbe, 0x4a, 0x74, 0x94, 0x04, 0x23, 0xfe,
-  0xfe, 0xfc, 0xdb, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0xac, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xaf, 0xfe, 0x1b, 0x06, 0x1a, 0x07, 0x6e, 0x10, 0x26,
-  0x07, 0x74, 0x00, 0x00, 0x10, 0x06, 0x07, 0x75, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0xff, 0xf2, 0x03, 0x63, 0x07, 0x6f, 0x12, 0x27,
-  0x00, 0x0d, 0x00, 0x00, 0xfd, 0xa8, 0x10, 0x07, 0x00, 0x0d, 0x00, 0x00,
-  0x01, 0x7f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x82, 0xff, 0x42, 0x02, 0xf0,
-  0x05, 0xd5, 0x10, 0x27, 0x00, 0x12, 0x00, 0x82, 0x00, 0x00, 0x10, 0x27,
-  0x00, 0x11, 0x01, 0x66, 0x00, 0x00, 0x10, 0x07, 0x00, 0x11, 0xff, 0xdd,
-  0x04, 0x48, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x01, 0xd3, 0x06, 0xda,
-  0x03, 0x31, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
-  0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
-  0x06, 0xd9, 0x8e, 0xcf, 0x83, 0x86, 0xd4, 0x0e, 0x08, 0x09, 0x14, 0xd2,
-  0x7e, 0x77, 0xc6, 0x85, 0x8e, 0xcf, 0x84, 0x9e, 0xbd, 0x0d, 0x07, 0x0b,
-  0x13, 0xd1, 0x7e, 0x75, 0xc2, 0x03, 0x31, 0xb2, 0x4f, 0x44, 0x3b, 0x04,
-  0x02, 0x02, 0x06, 0x3e, 0x4d, 0x53, 0xb2, 0x4f, 0x45, 0x3c, 0x04, 0x02,
-  0x03, 0x05, 0x3e, 0x4c, 0xff, 0xff, 0xff, 0xaf, 0xfe, 0x14, 0x06, 0x1a,
-  0xff, 0x7e, 0x10, 0x07, 0x07, 0x75, 0x00, 0x00, 0xf8, 0x10, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x18, 0x00, 0xc8, 0x04, 0xf0, 0x05, 0x0d, 0x00, 0x17,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21,
-  0x27, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x07, 0x21, 0x15, 0x21,
-  0x17, 0x07, 0x03, 0x4c, 0x90, 0xe0, 0x66, 0xe0, 0xfe, 0xc3, 0x01, 0x3d,
-  0xe0, 0x65, 0xe1, 0x90, 0xe1, 0x66, 0xe1, 0x01, 0x3e, 0xfe, 0xc2, 0xe1,
-  0x66, 0x02, 0x29, 0xfe, 0x9f, 0x01, 0x60, 0xf9, 0x72, 0xf9, 0xa0, 0xfa,
-  0x72, 0xfb, 0x01, 0x62, 0xfe, 0x9e, 0xfa, 0x71, 0xfa, 0xa0, 0xf9, 0x72,
-  0x00, 0x03, 0x00, 0xe1, 0x01, 0x32, 0x03, 0x57, 0x04, 0xb6, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35, 0x33, 0x15, 0x01, 0x35,
-  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0xe1, 0xb4, 0x01, 0x0e, 0xb4, 0xb4,
-  0xb4, 0x02, 0x90, 0xc8, 0xc8, 0xfe, 0xa2, 0xc8, 0xc8, 0x02, 0xbc, 0xc8,
-  0xc8, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x04, 0xa1,
-  0x05, 0xd5, 0x10, 0x27, 0x07, 0x67, 0x01, 0x0e, 0x00, 0x00, 0x10, 0x26,
-  0x07, 0x67, 0x00, 0x00, 0x10, 0x27, 0x07, 0x67, 0x03, 0x2a, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x67, 0x02, 0x1c, 0x00, 0x00, 0x00, 0x04, 0x01, 0x42,
-  0x01, 0x00, 0x04, 0xc7, 0x04, 0xe8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x21, 0x35, 0x33, 0x15,
-  0x01, 0x35, 0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x42, 0xb4, 0x02,
-  0x1c, 0xb4, 0xfd, 0xe4, 0xb4, 0xb4, 0xb4, 0x02, 0x90, 0xc8, 0xc8, 0xc8,
-  0xc8, 0xfe, 0x70, 0xc8, 0xc8, 0x03, 0x20, 0xc8, 0xc8, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x01, 0x42, 0x00, 0xf6, 0x04, 0xc7, 0x04, 0xde, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x01, 0x35,
-  0x33, 0x15, 0x13, 0x35, 0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x35,
-  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x02, 0xaa, 0xb4, 0xb4, 0xb4, 0xb4,
-  0xb4, 0xfc, 0x8e, 0xb4, 0xc6, 0xb4, 0x02, 0x86, 0xc8, 0xc8, 0xfe, 0x70,
-  0xc8, 0xc8, 0x03, 0x20, 0xc8, 0xc8, 0xfc, 0xf4, 0xc8, 0xc8, 0x03, 0x0c,
-  0xc8, 0xc8, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc5, 0x00, 0x00, 0x01, 0x83,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23,
-  0x11, 0x33, 0x15, 0x23, 0xc5, 0xbe, 0xbe, 0xbe, 0xbe, 0x05, 0xd5, 0xfe,
-  0xfc, 0x27, 0xfe, 0x00, 0x00, 0x04, 0x00, 0x5a, 0xfe, 0xe5, 0x05, 0x64,
-  0x06, 0xef, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
-  0x13, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x01, 0x33, 0x15, 0x23,
-  0x11, 0x33, 0x15, 0x23, 0x5a, 0xbe, 0xbe, 0x04, 0x4c, 0xbe, 0xbe, 0xfd,
-  0xda, 0xbe, 0xbe, 0xbe, 0xbe, 0x03, 0x69, 0xfe, 0xfe, 0xfe, 0x04, 0x84,
-  0xfe, 0xf9, 0xf2, 0xfe, 0x00, 0x05, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x1b,
-  0x00, 0x00, 0x25, 0x35, 0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x35,
-  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x11, 0x23, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x04, 0x12, 0xb4, 0xb4, 0xb4, 0xfc,
-  0x8e, 0xb4, 0xc6, 0xb4, 0x01, 0x56, 0x90, 0xfd, 0xa9, 0x02, 0x57, 0x90,
-  0x02, 0x58, 0xf6, 0xc8, 0xc8, 0x03, 0x20, 0xc8, 0xc8, 0xfc, 0xf4, 0xc8,
-  0xc8, 0x03, 0x0c, 0xc8, 0xc8, 0xfe, 0x84, 0xfd, 0x66, 0x02, 0x9a, 0xa0,
-  0x02, 0x9b, 0xfd, 0x65, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc5,
-  0x00, 0x50, 0x01, 0x83, 0x05, 0x3e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x11, 0x33,
-  0x15, 0x23, 0xc5, 0xbe, 0xbe, 0xbe, 0xbe, 0xbe, 0xbe, 0x05, 0x3e, 0xfe,
-  0xfd, 0x0e, 0xfe, 0x02, 0xf6, 0xfe, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc5,
-  0x00, 0x11, 0x01, 0x83, 0x05, 0x77, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23,
-  0x11, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0xc5, 0xbe, 0xbe, 0xbe,
-  0xbe, 0xbe, 0xbe, 0xbe, 0xbe, 0x02, 0x89, 0xfe, 0x03, 0xec, 0xfe, 0xfc,
-  0x96, 0xfe, 0x03, 0xf0, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4e,
-  0x02, 0x8d, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x00,
-  0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x01, 0xd4, 0xb6, 0x2d, 0x2e, 0x2e, 0x2d, 0xb6, 0x2d, 0x2e,
-  0x2e, 0x88, 0x91, 0x99, 0x99, 0x91, 0x92, 0x99, 0x99, 0x05, 0x97, 0x56,
-  0x56, 0xac, 0xad, 0x56, 0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde,
-  0xd3, 0xd4, 0xde, 0xde, 0xd4, 0xd3, 0xde, 0x00, 0x00, 0x02, 0x00, 0x6d,
-  0x02, 0x9c, 0x00, 0xd7, 0x06, 0x03, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x23, 0x11, 0x33, 0x15, 0x23, 0x6e, 0x68, 0x68, 0x68,
-  0x68, 0x05, 0x0f, 0xfd, 0x8d, 0x03, 0x67, 0x82, 0x00, 0x02, 0x00, 0x38,
-  0x02, 0x9c, 0x02, 0xa9, 0x05, 0xdf, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x00,
-  0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35,
-  0x21, 0x35, 0x01, 0xad, 0xfe, 0xea, 0x01, 0x16, 0x13, 0x95, 0x79, 0x79,
-  0x82, 0xfe, 0x8c, 0x05, 0x66, 0xfe, 0x5d, 0x02, 0x1c, 0xfd, 0xe4, 0x6d,
-  0xba, 0xba, 0x79, 0x00, 0x00, 0x01, 0x00, 0x5b, 0x02, 0x8d, 0x02, 0x8b,
-  0x05, 0xdf, 0x00, 0x20, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x80, 0x01, 0xcb, 0xfe, 0xa0, 0x19, 0x1a, 0x19, 0x1a,
-  0x90, 0x55, 0x55, 0x58, 0x56, 0x9e, 0x36, 0x72, 0x3b, 0x33, 0x38, 0x38,
-  0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f, 0x5e, 0x30, 0x05, 0xdf, 0x5f, 0xcc,
-  0x09, 0x04, 0x04, 0x4d, 0x4c, 0x83, 0x87, 0x4b, 0x4a, 0x12, 0x12, 0x71,
-  0x1b, 0x0e, 0x0d, 0x66, 0xae, 0x66, 0x14, 0x15, 0x00, 0x02, 0x00, 0x52,
-  0x02, 0x8d, 0x02, 0xa8, 0x05, 0xf0, 0x00, 0x0f, 0x00, 0x2f, 0x00, 0x00,
-  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x01, 0x88, 0x50, 0x2e, 0x2e, 0x2e, 0x2e, 0x50, 0x4e, 0x2e, 0x2e, 0x2e,
-  0x2e, 0x9a, 0x2c, 0x2d, 0x2d, 0x2c, 0x74, 0x3d, 0x3d, 0x09, 0x22, 0x33,
-  0x35, 0x3d, 0x82, 0x4c, 0x4c, 0x50, 0x4e, 0x82, 0x97, 0x9e, 0x61, 0x61,
-  0xa4, 0x2c, 0x2d, 0x2d, 0x04, 0x6d, 0x34, 0x35, 0x5b, 0x5a, 0x34, 0x35,
-  0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14, 0x0a, 0x0b,
-  0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f, 0x4f, 0x4e,
-  0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x00, 0x00, 0x01, 0x00, 0x61,
-  0x02, 0x9c, 0x02, 0x8d, 0x05, 0xdf, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x01, 0x23, 0x01, 0x21, 0x61, 0x02, 0x2b, 0xfe, 0xc7, 0x7a, 0x01,
-  0x27, 0xfe, 0x61, 0x05, 0xdf, 0x30, 0xfc, 0xed, 0x02, 0xe4, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x50, 0x02, 0x8d, 0x02, 0xa2, 0x05, 0xf0, 0x00, 0x0c,
-  0x00, 0x2a, 0x00, 0x3a, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x36, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x01, 0xcd, 0xa8, 0x2f, 0x30, 0x5f, 0x54,
-  0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01, 0x02, 0x4a,
-  0x48, 0x29, 0x2a, 0x4b, 0x51, 0x33, 0x2f, 0x4c, 0x4e, 0x8e, 0x8f, 0x4c,
-  0x4e, 0x30, 0x31, 0x28, 0x2a, 0x2a, 0x4c, 0x49, 0x2c, 0x2b, 0x2b, 0x2a,
-  0x4b, 0x4a, 0x2c, 0x2a, 0x04, 0x2a, 0x2c, 0x2b, 0x4b, 0x4c, 0x56, 0x2c,
-  0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48, 0x64, 0x74, 0x3a, 0x3a,
-  0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37, 0x50, 0x79, 0x41, 0x41,
-  0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f, 0x26, 0x25, 0x25, 0x24,
-  0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4a,
-  0x02, 0x8d, 0x02, 0x9f, 0x05, 0xf0, 0x00, 0x1f, 0x00, 0x2e, 0x00, 0x00,
-  0x13, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x82,
-  0x2d, 0x2d, 0x2d, 0x2b, 0x74, 0x3d, 0x3c, 0x09, 0x1f, 0x36, 0x33, 0x3e,
-  0x82, 0x97, 0x4e, 0x4f, 0x83, 0x96, 0x4e, 0x4f, 0x60, 0x61, 0xa4, 0x2c,
-  0x2d, 0x2d, 0xb8, 0x4f, 0x5c, 0x2e, 0x2e, 0x4f, 0x4d, 0x30, 0x2e, 0x2e,
-  0x2e, 0x02, 0xae, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b,
-  0x1a, 0x98, 0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76,
-  0x08, 0x09, 0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a,
-  0x5c, 0x34, 0x34, 0x00, 0x00, 0x01, 0x00, 0x7b, 0x02, 0x9c, 0x03, 0x52,
-  0x05, 0x6b, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x02, 0x16, 0x01, 0x3c, 0xfe, 0xc4,
-  0x5f, 0xfe, 0xc4, 0x01, 0x3c, 0x05, 0x6b, 0xfe, 0xc8, 0x5f, 0xfe, 0xc8,
-  0x01, 0x38, 0x5f, 0x01, 0x38, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b,
-  0x03, 0xd4, 0x03, 0x52, 0x04, 0x33, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x7b, 0x02, 0xd7, 0xfd, 0x29, 0x04, 0x33, 0x5f, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x7b, 0x03, 0x61, 0x03, 0x52, 0x04, 0xa5, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x7b, 0x02, 0xd7, 0xfd, 0x29, 0x02, 0xd7, 0xfd, 0x29, 0x04, 0xa5, 0x5e,
-  0x87, 0x5f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0x02, 0x05, 0x01, 0x68,
-  0x06, 0x02, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x10, 0x16, 0x17,
-  0x23, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x68, 0x4c, 0x49,
-  0x49, 0x4c, 0x5b, 0x55, 0x2a, 0x2a, 0x2a, 0x2a, 0x55, 0x06, 0x02, 0x81,
-  0xfc, 0xfe, 0xfe, 0xfe, 0x80, 0x83, 0x80, 0x7f, 0xfa, 0x7f, 0x7e, 0x84,
-  0x00, 0x01, 0x00, 0x5c, 0x02, 0x05, 0x01, 0x61, 0x06, 0x02, 0x00, 0x0f,
-  0x00, 0x00, 0x13, 0x33, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x23,
-  0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x5d, 0x5b, 0x55, 0x2a, 0x2a, 0x2a,
-  0x2a, 0x55, 0x5b, 0x4b, 0x25, 0x26, 0x26, 0x25, 0x06, 0x02, 0x84, 0x7e,
-  0x7f, 0xfa, 0x7f, 0x80, 0x83, 0x80, 0x7f, 0x7f, 0x01, 0x02, 0x7e, 0x7e,
-  0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x7e, 0x05, 0x1e, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x7d,
-  0x68, 0x46, 0x47, 0x54, 0x61, 0x6a, 0x6a, 0x25, 0x65, 0x43, 0x6d, 0x70,
-  0x04, 0x17, 0xfe, 0x85, 0x01, 0x77, 0x59, 0x59, 0x6b, 0x5c, 0xfe, 0x9e,
-  0x02, 0x73, 0x61, 0x38, 0x38, 0x86, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4e,
-  0xff, 0xf1, 0x02, 0xa3, 0x03, 0x54, 0x12, 0x07, 0x07, 0xa0, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b, 0x00, 0x00, 0x02, 0x7f,
-  0x03, 0x43, 0x12, 0x07, 0x00, 0x7b, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x54, 0x00, 0x00, 0x02, 0x6f, 0x03, 0x54, 0x12, 0x07,
-  0x00, 0x74, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x58,
-  0xff, 0xf1, 0x02, 0x86, 0x03, 0x54, 0x12, 0x07, 0x00, 0x75, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x38, 0x00, 0x00, 0x02, 0xa9,
-  0x03, 0x43, 0x12, 0x07, 0x07, 0xa2, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x5b, 0xff, 0xf1, 0x02, 0x8b, 0x03, 0x43, 0x12, 0x07,
-  0x07, 0xa3, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
-  0xff, 0xf1, 0x02, 0xa8, 0x03, 0x54, 0x12, 0x07, 0x07, 0xa4, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x61, 0x00, 0x00, 0x02, 0x8d,
-  0x03, 0x43, 0x12, 0x07, 0x07, 0xa5, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x50, 0xff, 0xf1, 0x02, 0xa2, 0x03, 0x54, 0x12, 0x07,
-  0x07, 0xa6, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4a,
-  0xff, 0xf1, 0x02, 0x9f, 0x03, 0x54, 0x12, 0x07, 0x07, 0xa7, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b, 0x00, 0x00, 0x03, 0x52,
-  0x02, 0xcf, 0x12, 0x07, 0x07, 0xa8, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x7b, 0x01, 0x38, 0x03, 0x52, 0x01, 0x97, 0x12, 0x07,
-  0x07, 0xa9, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b,
-  0x00, 0xc5, 0x03, 0x52, 0x02, 0x09, 0x12, 0x07, 0x07, 0xaa, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0x69, 0x01, 0x68,
-  0x03, 0x66, 0x12, 0x07, 0x07, 0xab, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x5c, 0xff, 0x69, 0x01, 0x61, 0x03, 0x66, 0x12, 0x07,
-  0x07, 0xac, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x45,
-  0xff, 0xf0, 0x02, 0x5e, 0x02, 0x82, 0x12, 0x07, 0x04, 0xf9, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f, 0xff, 0xf0, 0x02, 0x8d,
-  0x02, 0x82, 0x12, 0x07, 0x04, 0xff, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x3f, 0xff, 0xf0, 0x02, 0x88, 0x02, 0x82, 0x12, 0x07,
-  0x05, 0x08, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
-  0x00, 0x00, 0x02, 0xd1, 0x02, 0x73, 0x12, 0x07, 0x02, 0xa5, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f, 0xff, 0xf0, 0x02, 0x8d,
-  0x02, 0x82, 0x12, 0x07, 0x05, 0x00, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x02, 0x7e, 0x03, 0x67, 0x12, 0x07,
-  0x02, 0x72, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
-  0x00, 0x00, 0x02, 0x9d, 0x03, 0x67, 0x12, 0x07, 0x05, 0x05, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6d, 0x00, 0x00, 0x00, 0xd7,
-  0x03, 0x67, 0x12, 0x07, 0x02, 0xa3, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x04, 0x09, 0x02, 0x82, 0x12, 0x07,
-  0x05, 0x06, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
-  0x00, 0x00, 0x02, 0x7e, 0x02, 0x82, 0x12, 0x07, 0x07, 0xad, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69, 0xff, 0x11, 0x02, 0xa2,
-  0x02, 0x82, 0x12, 0x07, 0x05, 0x0c, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x02, 0x4f, 0x02, 0x93, 0x12, 0x07,
-  0x02, 0xa4, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x1f,
-  0x00, 0x00, 0x01, 0xac, 0x03, 0x25, 0x12, 0x07, 0x05, 0x0d, 0x00, 0x00,
-  0xfd, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4d, 0x00, 0x00, 0x06, 0x03,
-  0x05, 0xd6, 0x00, 0x23, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x00,
-  0x10, 0x00, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x10, 0x16, 0x33, 0x32, 0x36, 0x37, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x03, 0x7a, 0x47, 0xa0, 0x59, 0xe5,
-  0xfe, 0xf8, 0x01, 0x08, 0xe5, 0x5b, 0x9f, 0x46, 0x44, 0x9c, 0x58, 0xad,
-  0xb8, 0xb8, 0xad, 0x58, 0x9c, 0x44, 0x02, 0x7d, 0xfe, 0x0b, 0x01, 0xe1,
-  0xfe, 0x1f, 0x02, 0x01, 0xfd, 0x77, 0x01, 0xb8, 0x36, 0x36, 0x01, 0x37,
-  0x02, 0x1c, 0x01, 0x37, 0x35, 0x36, 0x9f, 0x47, 0x46, 0xea, 0xfe, 0x44,
-  0xea, 0x46, 0x47, 0x02, 0x0a, 0x80, 0xfe, 0xb5, 0x80, 0xfe, 0x6b, 0x80,
-  0x00, 0x03, 0x00, 0x67, 0xff, 0xa6, 0x04, 0x45, 0x06, 0x39, 0x00, 0x27,
-  0x00, 0x2e, 0x00, 0x34, 0x00, 0x00, 0x01, 0x16, 0x17, 0x37, 0x33, 0x07,
-  0x16, 0x17, 0x15, 0x26, 0x27, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
-  0x01, 0x23, 0x22, 0x27, 0x07, 0x23, 0x37, 0x26, 0x27, 0x07, 0x23, 0x37,
-  0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x3f, 0x01, 0x33, 0x07, 0x06,
-  0x07, 0x06, 0x11, 0x14, 0x17, 0x01, 0x26, 0x27, 0x01, 0x16, 0x17, 0x03,
-  0x11, 0x3a, 0x38, 0x1b, 0x8c, 0x2b, 0x24, 0x22, 0x35, 0x39, 0xfe, 0xe1,
-  0x10, 0x6b, 0xbe, 0x54, 0x58, 0xc2, 0x6d, 0x18, 0x18, 0x10, 0x8b, 0x16,
-  0x3a, 0x34, 0x22, 0x8b, 0x3a, 0x11, 0x0f, 0xa0, 0xa0, 0x90, 0xed, 0x13,
-  0x8d, 0xcd, 0x82, 0x4f, 0x71, 0x4a, 0x01, 0xfc, 0x38, 0x3d, 0xfe, 0xe1,
-  0x30, 0x3a, 0x05, 0xeb, 0x08, 0x13, 0x69, 0xa5, 0x16, 0x1c, 0xd5, 0x3c,
-  0x29, 0xfb, 0x97, 0x5e, 0x5f, 0xd3, 0x48, 0x48, 0x02, 0x3f, 0x57, 0x12,
-  0x1e, 0x87, 0xe6, 0x12, 0x15, 0xcf, 0x01, 0x67, 0x01, 0x68, 0xd0, 0xb9,
-  0x14, 0x4b, 0xfc, 0x1f, 0x70, 0x9d, 0xfe, 0xd8, 0xee, 0x94, 0x03, 0xcb,
-  0x13, 0x04, 0xfb, 0x95, 0x28, 0x15, 0x00, 0x00, 0x00, 0x01, 0x00, 0x56,
-  0xff, 0xe4, 0x04, 0x3b, 0x05, 0xf0, 0x00, 0x2c, 0x00, 0x00, 0x25, 0x36,
-  0x37, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10,
-  0x17, 0x16, 0x17, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x1f,
-  0x01, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x02, 0xdd, 0x57, 0x4f, 0x5f,
-  0x54, 0x57, 0xc3, 0x6d, 0xfe, 0xe9, 0xfe, 0xbe, 0x01, 0x42, 0x01, 0x17,
-  0x6e, 0xc4, 0x55, 0x54, 0xbe, 0x6b, 0xd3, 0xe0, 0x70, 0x54, 0x8a, 0x89,
-  0x2b, 0x8a, 0x63, 0x0e, 0x22, 0x15, 0x01, 0x18, 0x36, 0x20, 0x73, 0x7d,
-  0x8a, 0x07, 0x27, 0x2f, 0x5f, 0xd3, 0x48, 0x47, 0x01, 0x9e, 0x01, 0x67,
-  0x01, 0x68, 0x01, 0x9f, 0x47, 0x47, 0xd5, 0x5f, 0x5e, 0xfe, 0xc7, 0xfe,
-  0xd8, 0xfe, 0xd9, 0x9c, 0x75, 0x1e, 0x03, 0x5d, 0x9d, 0x5c, 0x59, 0x04,
-  0x05, 0xaa, 0x10, 0x0f, 0xb6, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x77,
-  0x00, 0x00, 0x04, 0x51, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x15, 0x23, 0x11,
-  0x23, 0x11, 0x23, 0x35, 0x01, 0x4c, 0x03, 0x04, 0xfd, 0xb2, 0x02, 0x15,
-  0xfd, 0xeb, 0xe1, 0xe1, 0xb6, 0xd4, 0x01, 0x7e, 0x04, 0x57, 0xaa, 0xfe,
-  0x48, 0xaa, 0xfe, 0xb5, 0x45, 0xfe, 0xc7, 0x01, 0x39, 0x45, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x74, 0x00, 0x00, 0x03, 0xf2, 0x05, 0xf0, 0x00, 0x23,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35,
-  0x33, 0x35, 0x23, 0x35, 0x33, 0x35, 0x10, 0x36, 0x33, 0x32, 0x16, 0x17,
-  0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x15,
-  0x21, 0x15, 0x01, 0xfc, 0x01, 0xf6, 0xfc, 0x82, 0xd4, 0xab, 0xab, 0xb3,
-  0xb3, 0xc1, 0xd1, 0x37, 0x88, 0x47, 0x45, 0x7a, 0x37, 0x85, 0x69, 0x01,
-  0x60, 0xfe, 0xa0, 0x01, 0x68, 0x01, 0xec, 0xfe, 0xbe, 0xaa, 0xaa, 0x01,
-  0x42, 0x8f, 0x8f, 0x8f, 0x5f, 0x01, 0x05, 0xf3, 0x1f, 0x1d, 0xb6, 0x29,
-  0x29, 0x9b, 0xd4, 0x48, 0x8f, 0x8f, 0x8f, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xff, 0x42, 0x06, 0x67, 0x05, 0x1e, 0x00, 0x2b, 0x00, 0x00, 0x05, 0x23,
-  0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11,
-  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x13, 0x33,
-  0x07, 0x36, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x02, 0x84, 0x99, 0x01, 0x49, 0x05,
-  0x2e, 0x34, 0x6b, 0x7f, 0x4a, 0x4b, 0xa7, 0xa7, 0x38, 0x50, 0x4f, 0x6d,
-  0x6e, 0x4c, 0x31, 0x21, 0x78, 0x99, 0x4f, 0x52, 0x6c, 0x9e, 0xab, 0xa7,
-  0x66, 0x6a, 0x80, 0x96, 0xa6, 0xbe, 0x03, 0x78, 0x8d, 0x47, 0x4d, 0x5f,
-  0x61, 0xa2, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x66, 0x32, 0x31, 0x3e, 0x26,
-  0x3e, 0x01, 0x45, 0xd6, 0x33, 0xf6, 0xe1, 0xfd, 0x5c, 0x02, 0x9e, 0xa1,
-  0x9c, 0xbe, 0xa4, 0xfd, 0x87, 0x01, 0x1d, 0x00, 0x00, 0x05, 0x00, 0x69,
-  0x00, 0x00, 0x04, 0xfa, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x06, 0x00, 0x22,
-  0x00, 0x26, 0x00, 0x29, 0x00, 0x00, 0x01, 0x27, 0x15, 0x13, 0x27, 0x23,
-  0x15, 0x03, 0x33, 0x13, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15,
-  0x33, 0x15, 0x23, 0x11, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35,
-  0x33, 0x35, 0x23, 0x35, 0x33, 0x05, 0x17, 0x33, 0x35, 0x03, 0x17, 0x35,
-  0x02, 0x10, 0x47, 0xa4, 0x33, 0x71, 0xb1, 0xf5, 0xbe, 0xcf, 0xb0, 0xb0,
-  0xb0, 0xb0, 0xb0, 0xf4, 0xbe, 0xcf, 0xb1, 0xaf, 0xaf, 0xaf, 0xaf, 0x01,
-  0xde, 0x32, 0x72, 0x47, 0x47, 0x03, 0xaf, 0xce, 0xce, 0xfe, 0xf2, 0x93,
-  0x93, 0x03, 0x34, 0xfd, 0xda, 0x02, 0x26, 0xfd, 0xda, 0x7b, 0x93, 0x7b,
-  0xfd, 0xda, 0x02, 0x26, 0xfd, 0xda, 0x02, 0x26, 0x7b, 0x93, 0x7b, 0x7b,
-  0x93, 0x93, 0xfe, 0xf2, 0xce, 0xce, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0xff, 0xe3, 0x08, 0xd3, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x50, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x06, 0x07,
-  0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32, 0x17, 0x16, 0x17, 0x33,
-  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x35,
-  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01,
-  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x27, 0x35, 0x23, 0x22, 0x26, 0x35, 0x11, 0x01, 0x60, 0xd7,
-  0x78, 0x82, 0x82, 0x78, 0x01, 0xad, 0x05, 0x66, 0x6e, 0xd4, 0xd7, 0xab,
-  0x01, 0x82, 0xd4, 0x6e, 0x4f, 0x15, 0x49, 0x9d, 0x01, 0x41, 0xfe, 0xbf,
-  0x3f, 0x62, 0x9a, 0x56, 0xa8, 0x52, 0x6e, 0x77, 0x56, 0x91, 0x36, 0x90,
-  0x81, 0xbe, 0xae, 0x57, 0x98, 0x41, 0x43, 0x8e, 0x4d, 0x74, 0x74, 0x54,
-  0x7d, 0x35, 0xa7, 0x8b, 0xd2, 0xb6, 0x4d, 0xa5, 0x5b, 0x9a, 0xb5, 0x89,
-  0x05, 0x2f, 0xfd, 0xcf, 0x92, 0x87, 0x86, 0x92, 0xfe, 0xcc, 0xc8, 0x6a,
-  0x71, 0xfd, 0xa8, 0x05, 0xd5, 0x71, 0x52, 0x88, 0x01, 0x3e, 0xfe, 0xc2,
-  0x8f, 0xfd, 0xa0, 0x89, 0x4e, 0x23, 0x35, 0x35, 0x59, 0x51, 0x4b, 0x50,
-  0x25, 0x0f, 0x24, 0x95, 0x82, 0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28,
-  0x54, 0x54, 0x40, 0x49, 0x21, 0x0e, 0x2a, 0x99, 0x89, 0x9c, 0xb6, 0x23,
-  0x23, 0x01, 0x9f, 0xd2, 0x02, 0x60, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0xff, 0xe3, 0x07, 0x62, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x45, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x01, 0x17, 0x23, 0x03,
-  0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x07, 0x1e, 0x01, 0x1f, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32,
-  0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f,
-  0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x6b,
-  0xe4, 0x84, 0x86, 0x86, 0x84, 0x02, 0x79, 0x04, 0xc4, 0xac, 0x42, 0x7d,
-  0x6c, 0xc6, 0xb6, 0x01, 0x9a, 0xe7, 0xe2, 0x75, 0x71, 0x3b, 0x6e, 0x38,
-  0x52, 0x58, 0x57, 0x59, 0x57, 0x75, 0x7e, 0x5b, 0x9a, 0x39, 0x9a, 0x89,
-  0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x46, 0x97, 0x51, 0x7c, 0x7b, 0x58, 0x86,
-  0x38, 0xb1, 0x94, 0xde, 0xc3, 0x51, 0x57, 0x28, 0x05, 0x2f, 0xfd, 0xee,
-  0x87, 0x01, 0x06, 0x85, 0xfa, 0xd8, 0x07, 0x01, 0x7f, 0x96, 0x62, 0xfd,
-  0x89, 0x05, 0xd5, 0xd6, 0xd8, 0x8d, 0xba, 0x24, 0x16, 0x90, 0x7e, 0xb4,
-  0x33, 0x19, 0x1b, 0x59, 0x51, 0x4b, 0x50, 0x25, 0x0f, 0x24, 0x95, 0x82,
-  0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x54, 0x54, 0x40, 0x49, 0x21,
-  0x0e, 0x2a, 0x99, 0x89, 0x9c, 0xb6, 0x12, 0x08, 0x00, 0x06, 0x00, 0x35,
-  0x00, 0x00, 0x06, 0xea, 0x05, 0xd5, 0x00, 0x1f, 0x00, 0x22, 0x00, 0x26,
-  0x00, 0x29, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x13, 0x27, 0x23, 0x35,
-  0x33, 0x27, 0x33, 0x17, 0x21, 0x37, 0x33, 0x17, 0x21, 0x37, 0x33, 0x07,
-  0x33, 0x15, 0x23, 0x07, 0x33, 0x15, 0x23, 0x03, 0x23, 0x03, 0x23, 0x03,
-  0x23, 0x03, 0x23, 0x35, 0x05, 0x1b, 0x01, 0x01, 0x17, 0x21, 0x37, 0x01,
-  0x1b, 0x02, 0x07, 0x33, 0x27, 0x21, 0x17, 0x21, 0x37, 0xa4, 0x1b, 0x54,
-  0x34, 0x2c, 0xb8, 0x2b, 0x01, 0xde, 0x2b, 0xcc, 0x2c, 0x01, 0xdd, 0x2c,
-  0xb8, 0x2c, 0x33, 0x53, 0x1a, 0x6d, 0x8e, 0xca, 0xe5, 0xc4, 0xb0, 0xc6,
-  0xe4, 0xca, 0x8f, 0x04, 0x47, 0x94, 0x94, 0xfe, 0x9d, 0x1a, 0x01, 0x69,
-  0x1a, 0xfb, 0x9d, 0x94, 0x95, 0xce, 0x1a, 0x70, 0x19, 0xfd, 0x91, 0x1a,
-  0x01, 0x69, 0x1b, 0x04, 0x0f, 0x75, 0x8f, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2,
-  0xc2, 0x8f, 0x75, 0x8f, 0xfc, 0x80, 0x03, 0x80, 0xfc, 0x80, 0x03, 0x80,
-  0x8f, 0x8f, 0xfd, 0x67, 0x02, 0x99, 0x01, 0x04, 0x75, 0x75, 0xfe, 0xfc,
-  0xfd, 0x67, 0x02, 0x99, 0x01, 0x04, 0x75, 0x75, 0x75, 0x75, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x55, 0xff, 0xe3, 0x05, 0x59, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x1b, 0x00, 0x00, 0x13, 0x25, 0x32, 0x12, 0x19, 0x01, 0x23, 0x11,
-  0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x29, 0x01, 0x22, 0x02, 0x19, 0x01,
-  0x33, 0x11, 0x14, 0x16, 0x33, 0x21, 0x03, 0x33, 0x56, 0x01, 0xd3, 0xe5,
-  0xec, 0xa6, 0x8d, 0x9e, 0xfe, 0xd2, 0xa5, 0x04, 0xff, 0xfe, 0x31, 0xe6,
-  0xec, 0xa6, 0x8d, 0x9f, 0x01, 0x31, 0x04, 0xa6, 0x05, 0xd2, 0x03, 0xfe,
-  0xd6, 0xfe, 0xdc, 0xfe, 0x91, 0x01, 0x56, 0xf0, 0xd3, 0xfa, 0xb2, 0x01,
-  0x2a, 0x01, 0x24, 0x01, 0x6f, 0xfe, 0xaa, 0xf0, 0xd3, 0x05, 0x4e, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xfe, 0xc0, 0x04, 0x76, 0x06, 0x14, 0x10, 0x26,
-  0x00, 0xd3, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f, 0x7c, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0xff, 0xe3, 0x04, 0x1b, 0x05, 0xf0, 0x00, 0x31,
-  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x21, 0x07,
-  0x21, 0x06, 0x14, 0x15, 0x1c, 0x01, 0x17, 0x21, 0x07, 0x21, 0x1e, 0x01,
-  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x03, 0x23,
-  0x37, 0x33, 0x34, 0x26, 0x35, 0x34, 0x36, 0x35, 0x23, 0x37, 0x33, 0x12,
-  0x00, 0x33, 0x32, 0x16, 0x04, 0x1a, 0x52, 0x98, 0x5c, 0x8d, 0xb6, 0x1c,
-  0x02, 0x07, 0x32, 0xfe, 0x1c, 0x02, 0x02, 0x01, 0x92, 0x33, 0xfe, 0xb0,
-  0x1c, 0xb6, 0x8d, 0x5c, 0x98, 0x52, 0x50, 0xa6, 0x57, 0xd5, 0xfe, 0xea,
-  0x24, 0xbe, 0x32, 0x7d, 0x01, 0x01, 0xaf, 0x32, 0x8c, 0x24, 0x01, 0x17,
-  0xd4, 0x59, 0xa6, 0x05, 0x62, 0xd5, 0x69, 0x5a, 0xc8, 0xbb, 0x7b, 0x18,
-  0x2e, 0x23, 0x20, 0x2e, 0x18, 0x7b, 0xbb, 0xca, 0x5a, 0x69, 0xd3, 0x48,
-  0x48, 0x01, 0x22, 0x01, 0x03, 0x7b, 0x17, 0x2f, 0x20, 0x23, 0x2f, 0x17,
-  0x7b, 0x01, 0x01, 0x01, 0x22, 0x47, 0x00, 0x00, 0x00, 0x01, 0x00, 0x24,
-  0x00, 0x00, 0x04, 0x94, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x13, 0x11,
-  0x33, 0x11, 0x01, 0x33, 0x01, 0x21, 0x15, 0x21, 0x01, 0x23, 0x01, 0x11,
-  0x23, 0x11, 0x23, 0x35, 0xac, 0xaa, 0x02, 0x36, 0xdb, 0xfd, 0xc0, 0x01,
-  0x7f, 0xfe, 0x83, 0x02, 0x6b, 0xe0, 0xfd, 0xa2, 0xaa, 0x88, 0x03, 0x54,
-  0x02, 0x81, 0xfd, 0x89, 0x02, 0x77, 0xfd, 0x7f, 0x73, 0xfd, 0x1f, 0x02,
-  0xcf, 0xfd, 0x31, 0x02, 0xe1, 0x73, 0x00, 0x00, 0x00, 0x01, 0x00, 0x12,
-  0x00, 0x00, 0x04, 0x83, 0x05, 0xd5, 0x00, 0x17, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x37, 0x17, 0x05, 0x15, 0x37, 0x17,
-  0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x25, 0x35, 0x07, 0x27, 0x01, 0xef,
-  0xfe, 0x23, 0x04, 0x71, 0xfe, 0x23, 0xce, 0x48, 0xfe, 0xea, 0xcf, 0x48,
-  0xfe, 0xe9, 0xb7, 0xd0, 0x45, 0x01, 0x15, 0xd1, 0x45, 0x03, 0x8d, 0x01,
-  0x9e, 0xaa, 0xaa, 0xfe, 0xf1, 0xa1, 0x6f, 0xd8, 0x88, 0xa2, 0x6f, 0xd9,
-  0xfd, 0xb8, 0x01, 0xba, 0xa1, 0x6e, 0xd9, 0x88, 0xa2, 0x6e, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0xbb, 0xfe, 0x39, 0x08, 0xae, 0x05, 0xf0, 0x00, 0x16,
-  0x00, 0x2d, 0x00, 0x62, 0x00, 0x77, 0x00, 0x83, 0x00, 0x00, 0x01, 0x27,
-  0x13, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x22, 0x07,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x05, 0x36, 0x37, 0x13,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x3e, 0x01, 0x37, 0x36, 0x33,
-  0x32, 0x04, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x2f,
-  0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33,
-  0x32, 0x01, 0x03, 0x06, 0x07, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x01, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x06, 0x54,
-  0xa6, 0x91, 0x1f, 0x38, 0x2c, 0x87, 0x57, 0x43, 0x6e, 0x22, 0x3a, 0x2b,
-  0x2c, 0x49, 0x52, 0x4e, 0x32, 0x37, 0x2b, 0x1b, 0xde, 0x4e, 0x2c, 0x0b,
-  0x0e, 0x09, 0x15, 0x1c, 0x38, 0x21, 0x36, 0x15, 0x12, 0x11, 0x10, 0x1a,
-  0x0b, 0x16, 0x12, 0xfa, 0x5a, 0x0b, 0x0a, 0xa2, 0x2a, 0x1d, 0x1f, 0x16,
-  0x13, 0x0f, 0x9d, 0x18, 0x5a, 0x3c, 0x6b, 0x9e, 0xb6, 0x01, 0x0f, 0x55,
-  0x4c, 0x4a, 0x19, 0x17, 0x3c, 0x20, 0x57, 0x37, 0x3e, 0x44, 0x56, 0x43,
-  0x38, 0x29, 0x2e, 0x58, 0x1d, 0x3a, 0x0d, 0x0e, 0x10, 0x13, 0x46, 0x53,
-  0x69, 0x45, 0x45, 0x77, 0x5e, 0x42, 0x01, 0xb4, 0xa0, 0x16, 0x13, 0x24,
-  0x4b, 0x2e, 0x33, 0x30, 0x61, 0x8a, 0x34, 0x27, 0x1a, 0x15, 0x1b, 0x1c,
-  0x32, 0x77, 0xfd, 0x8d, 0x24, 0x2b, 0x22, 0x0c, 0x0c, 0x15, 0x14, 0x1d,
-  0x29, 0xfe, 0x39, 0x29, 0x02, 0xd0, 0x97, 0x69, 0x52, 0x6d, 0x3a, 0x33,
-  0x58, 0x92, 0x77, 0x64, 0x67, 0x37, 0x3f, 0x20, 0x17, 0x32, 0x01, 0xf8,
-  0x6a, 0x1a, 0x37, 0x23, 0x3d, 0x35, 0x28, 0x36, 0x24, 0x20, 0x1b, 0x36,
-  0x32, 0x39, 0x54, 0x2f, 0x14, 0x0c, 0x0b, 0xb7, 0x28, 0x32, 0x03, 0x4d,
-  0x0a, 0x14, 0x16, 0x21, 0x1d, 0x3a, 0x35, 0x53, 0x7d, 0x24, 0x40, 0x7b,
-  0x6d, 0x62, 0xf5, 0x81, 0x71, 0x8c, 0x82, 0x7e, 0x45, 0x73, 0x2f, 0x34,
-  0x18, 0x1d, 0x09, 0x0a, 0x2d, 0x13, 0x26, 0x0a, 0x0a, 0x22, 0x17, 0x54,
-  0x41, 0x42, 0x60, 0x5d, 0x85, 0x03, 0x92, 0xfc, 0x9b, 0x7c, 0x40, 0x1b,
-  0x38, 0x16, 0x19, 0x86, 0x6e, 0x52, 0x80, 0x6b, 0x63, 0x64, 0x5d, 0x61,
-  0x43, 0x9c, 0xfb, 0xa0, 0x22, 0x0e, 0x0e, 0x0f, 0x18, 0x0f, 0x0e, 0x00,
-  0x00, 0x02, 0x00, 0x29, 0xff, 0xe3, 0x04, 0x1a, 0x05, 0xf0, 0x00, 0x29,
-  0x00, 0x35, 0x00, 0x00, 0x13, 0x27, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x35, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x25, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0xa6, 0x7d,
-  0x85, 0x64, 0x6f, 0x3a, 0x4f, 0x1f, 0x2b, 0x31, 0xcc, 0x48, 0x50, 0x7b,
-  0x68, 0x57, 0x4c, 0x61, 0xa3, 0x71, 0x5f, 0xe3, 0x78, 0x52, 0x42, 0x6b,
-  0x7b, 0x62, 0x66, 0x43, 0x2d, 0x30, 0x2d, 0x01, 0xf8, 0x3d, 0x18, 0x20,
-  0x2d, 0x2f, 0x1e, 0x16, 0x02, 0x04, 0x60, 0xf0, 0x4e, 0x6b, 0x42, 0xb1,
-  0xfe, 0xac, 0x58, 0x60, 0x60, 0x53, 0xb1, 0xe3, 0xab, 0xa3, 0xbf, 0xc2,
-  0x86, 0x71, 0xa2, 0x4a, 0x3c, 0x93, 0x58, 0x72, 0x7e, 0x68, 0x46, 0xd9,
-  0x6c, 0xaf, 0x56, 0x31, 0x3f, 0x3f, 0x30, 0x57, 0xa6, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x3d, 0x00, 0x00, 0x04, 0x2c, 0x05, 0xd5, 0x00, 0x1d,
-  0x00, 0x24, 0x00, 0x2b, 0x00, 0x31, 0x00, 0x00, 0x13, 0x35, 0x23, 0x35,
-  0x33, 0x11, 0x21, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x23, 0x16, 0x14,
-  0x07, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11,
-  0x23, 0x35, 0x05, 0x21, 0x15, 0x33, 0x32, 0x37, 0x36, 0x01, 0x21, 0x26,
-  0x27, 0x26, 0x2b, 0x01, 0x05, 0x21, 0x15, 0x21, 0x36, 0x34, 0x88, 0x4a,
-  0x4a, 0x01, 0x9a, 0xe2, 0x74, 0x45, 0x1c, 0x52, 0x40, 0x01, 0x01, 0x3f,
-  0x50, 0x1c, 0x46, 0x74, 0xe2, 0xe4, 0xb6, 0x4b, 0x02, 0xcd, 0xfe, 0x34,
-  0xe4, 0x7f, 0x45, 0x15, 0xfe, 0x43, 0x01, 0xcc, 0x0f, 0x15, 0x45, 0x7f,
-  0xe4, 0x01, 0xec, 0xfe, 0x14, 0x01, 0xec, 0x02, 0x03, 0xec, 0x56, 0x74,
-  0x01, 0x1f, 0x71, 0x44, 0x6a, 0x74, 0x15, 0x2c, 0x15, 0x74, 0x6b, 0x44,
-  0x71, 0xfd, 0xa8, 0x03, 0x78, 0x74, 0x74, 0x7a, 0x49, 0x16, 0x01, 0x59,
-  0x1b, 0x15, 0x49, 0xed, 0x56, 0x15, 0x2c, 0x00, 0x00, 0x02, 0x00, 0x53,
-  0xff, 0x5b, 0x04, 0x39, 0x06, 0x78, 0x00, 0x24, 0x00, 0x2d, 0x00, 0x00,
-  0x05, 0x23, 0x35, 0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x37, 0x35,
-  0x33, 0x15, 0x16, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x27, 0x11,
-  0x36, 0x37, 0x36, 0x37, 0x11, 0x23, 0x35, 0x21, 0x11, 0x06, 0x07, 0x06,
-  0x07, 0x27, 0x11, 0x06, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16, 0x02, 0xad,
-  0x7e, 0xc9, 0x7b, 0x97, 0x97, 0x7b, 0xc9, 0x7e, 0x5e, 0x57, 0x65, 0x54,
-  0x55, 0x61, 0x58, 0x60, 0x46, 0x39, 0x41, 0x33, 0x6c, 0x01, 0x05, 0x59,
-  0x6c, 0x5e, 0x69, 0x7e, 0x78, 0x47, 0x64, 0x64, 0x47, 0xa5, 0x8f, 0x1f,
-  0xa7, 0xcc, 0x01, 0x6d, 0x01, 0x6e, 0xcd, 0xa6, 0x1f, 0x8f, 0x89, 0x04,
-  0x1f, 0x24, 0x46, 0xd7, 0x5f, 0x30, 0x2c, 0x04, 0xfb, 0x3f, 0x02, 0x11,
-  0x12, 0x27, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53, 0x2a, 0x25, 0x05, 0xb2,
-  0x04, 0xa7, 0x20, 0x6c, 0x99, 0xfe, 0xd1, 0xfe, 0xd2, 0x99, 0x6c, 0x00,
-  0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x04, 0x85, 0x05, 0xd5, 0x00, 0x17,
-  0x00, 0x1b, 0x00, 0x1e, 0x00, 0x00, 0x13, 0x35, 0x21, 0x13, 0x33, 0x13,
-  0x21, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x13, 0x23, 0x03, 0x21, 0x03,
-  0x23, 0x13, 0x23, 0x35, 0x33, 0x37, 0x33, 0x07, 0x21, 0x2f, 0x01, 0x33,
-  0x03, 0x2e, 0x01, 0x12, 0xa3, 0xce, 0xa3, 0x01, 0x12, 0xeb, 0x40, 0xab,
-  0x84, 0xa2, 0xbc, 0x9a, 0xfe, 0x39, 0x99, 0xc0, 0xa3, 0x83, 0xaa, 0x42,
-  0xad, 0x3c, 0x01, 0x7f, 0x3e, 0xe1, 0xbd, 0x5e, 0x03, 0x52, 0x7b, 0x02,
-  0x08, 0xfd, 0xf8, 0x7b, 0xcf, 0x7b, 0xfd, 0xf8, 0x02, 0x08, 0xfd, 0xf8,
-  0x02, 0x08, 0x7b, 0xcf, 0xcf, 0xcf, 0x7b, 0x01, 0x41, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0xff, 0xe3, 0x05, 0x2a, 0x05, 0xf0, 0x00, 0x36,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x07, 0x33, 0x15, 0x23, 0x06, 0x0f, 0x01, 0x21,
-  0x15, 0x21, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
-  0x01, 0x23, 0x22, 0x24, 0x35, 0x34, 0x37, 0x23, 0x35, 0x01, 0x39, 0x04,
-  0x14, 0x42, 0x74, 0xfe, 0x62, 0x03, 0x37, 0x0b, 0x0b, 0x36, 0xa2, 0x94,
-  0x56, 0xb7, 0x68, 0x67, 0xc4, 0x5f, 0xdc, 0xfb, 0x16, 0x9d, 0xe9, 0x5c,
-  0xc3, 0x3c, 0x02, 0x44, 0xfc, 0xb2, 0x2d, 0xa9, 0x9c, 0x67, 0xd4, 0x6f,
-  0x73, 0xd8, 0x5f, 0xfd, 0xfe, 0xfa, 0x11, 0x98, 0x02, 0xa1, 0x07, 0x16,
-  0x4a, 0x2c, 0x7b, 0x08, 0x09, 0x2b, 0x6b, 0x76, 0x80, 0x36, 0x37, 0xc5,
-  0x26, 0x26, 0xe4, 0xc6, 0x55, 0x42, 0x7b, 0x5c, 0x2a, 0x0d, 0x7b, 0x3b,
-  0x5e, 0x7e, 0x88, 0x46, 0x45, 0xd0, 0x2f, 0x30, 0xe0, 0xd9, 0x4b, 0x3f,
-  0x7b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x94, 0xfe, 0xd3, 0x04, 0x01,
-  0x06, 0x14, 0x00, 0x1f, 0x00, 0x2a, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01,
-  0x23, 0x11, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23,
-  0x11, 0x26, 0x27, 0x26, 0x11, 0x35, 0x10, 0x37, 0x36, 0x37, 0x35, 0x33,
-  0x15, 0x16, 0x17, 0x16, 0x01, 0x03, 0x06, 0x07, 0x06, 0x07, 0x06, 0x17,
-  0x16, 0x17, 0x16, 0x04, 0x00, 0x53, 0x97, 0x5b, 0x5b, 0x97, 0x53, 0x51,
-  0x53, 0x4f, 0x52, 0x5a, 0xa6, 0x69, 0xbe, 0xbf, 0x6d, 0xa0, 0x5b, 0x54,
-  0x4f, 0x53, 0xfe, 0xb0, 0x01, 0x52, 0x3c, 0x6a, 0x0e, 0x0c, 0x0c, 0x17,
-  0x61, 0x3c, 0x04, 0xa4, 0xd5, 0x69, 0x5a, 0xfb, 0xf1, 0x5a, 0x69, 0xd3,
-  0x48, 0x24, 0x22, 0x02, 0xfe, 0xf0, 0x01, 0x15, 0x16, 0x76, 0xd6, 0x01,
-  0x39, 0x11, 0x01, 0x42, 0xcb, 0x74, 0x17, 0xe8, 0xe2, 0x02, 0x22, 0x24,
-  0xfb, 0xa4, 0x03, 0xf9, 0x16, 0x43, 0x75, 0xaa, 0xa1, 0x66, 0xb4, 0x6c,
-  0x43, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x12, 0x00, 0x00, 0x04, 0x83,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x12, 0x04, 0x71, 0xfb,
-  0x8f, 0x04, 0x71, 0xfe, 0x23, 0xb7, 0xfe, 0x23, 0x05, 0xd5, 0xaa, 0x78,
-  0xaa, 0xfb, 0xf7, 0x04, 0x09, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5f,
-  0x00, 0x00, 0x04, 0x38, 0x05, 0xd5, 0x00, 0x26, 0x00, 0x00, 0x13, 0x37,
-  0x21, 0x07, 0x21, 0x16, 0x17, 0x21, 0x07, 0x23, 0x06, 0x07, 0x06, 0x07,
-  0x16, 0x17, 0x16, 0x17, 0x13, 0x23, 0x03, 0x26, 0x27, 0x26, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x37, 0x21, 0x26, 0x27, 0x26,
-  0x23, 0x5f, 0x32, 0x03, 0xa6, 0x31, 0xfe, 0xc1, 0x47, 0x13, 0x01, 0x16,
-  0x31, 0xde, 0x05, 0x36, 0x3b, 0x70, 0x3a, 0x38, 0x34, 0x3b, 0xb8, 0xc3,
-  0xac, 0x44, 0x3d, 0x3f, 0x6c, 0xc6, 0xe5, 0x83, 0x43, 0x3d, 0x06, 0xfd,
-  0xf7, 0x32, 0x01, 0xcc, 0x10, 0x28, 0x43, 0x83, 0x05, 0x5a, 0x7b, 0x7b,
-  0x4e, 0x81, 0x7b, 0x7e, 0x55, 0x5d, 0x24, 0x16, 0x48, 0x44, 0x82, 0xfe,
-  0x68, 0x01, 0x7f, 0x97, 0x30, 0x31, 0xa6, 0x43, 0x3e, 0x72, 0x7b, 0x43,
-  0x34, 0x58, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09, 0x00, 0x05, 0x04, 0xad,
-  0x05, 0xda, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x10, 0x07, 0x06, 0x21, 0x23,
-  0x11, 0x07, 0x27, 0x25, 0x35, 0x07, 0x27, 0x25, 0x11, 0x33, 0x11, 0x37,
-  0x17, 0x05, 0x15, 0x37, 0x17, 0x05, 0x11, 0x20, 0x00, 0x11, 0x04, 0xad,
-  0xb8, 0xb7, 0xfe, 0x7b, 0x9b, 0xcf, 0x46, 0x01, 0x15, 0xd1, 0x44, 0x01,
-  0x15, 0xb6, 0xcf, 0x48, 0xfe, 0xe9, 0xd1, 0x48, 0xfe, 0xe7, 0x01, 0x16,
-  0x01, 0x02, 0x02, 0xf1, 0xfe, 0x7e, 0xb5, 0xb5, 0x02, 0x1e, 0xa1, 0x6e,
-  0xd8, 0x89, 0xa2, 0x6e, 0xd9, 0x01, 0xe4, 0xfe, 0xaa, 0xa2, 0x6f, 0xd9,
-  0x88, 0xa3, 0x6f, 0xda, 0xfd, 0xfb, 0x01, 0x18, 0x01, 0x2e, 0x00, 0x00,
-  0x00, 0x01, 0xfc, 0x76, 0x05, 0x15, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x13, 0x33, 0x07, 0x21, 0x15, 0xfc, 0x77, 0xc4, 0x71,
-  0x77, 0x02, 0x9b, 0x05, 0x15, 0x00, 0xff, 0x9b, 0x64, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xfc, 0x9d, 0x05, 0x15, 0xff, 0xf7, 0x06, 0x14, 0x00, 0x05,
-  0x00, 0x00, 0x03, 0x21, 0x35, 0x21, 0x27, 0x33, 0x09, 0xfc, 0xa6, 0x02,
-  0x9b, 0x77, 0x72, 0x05, 0x15, 0x64, 0x9b, 0x00, 0x00, 0x01, 0xfc, 0x9d,
-  0x04, 0x7a, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x08, 0x00, 0x00, 0x03, 0x21,
-  0x17, 0x23, 0x27, 0x37, 0x33, 0x07, 0x21, 0x30, 0xfd, 0x65, 0x77, 0x71,
-  0x9e, 0x9e, 0x71, 0x77, 0x02, 0x9b, 0x05, 0x15, 0x9b, 0xcd, 0xcd, 0x9b,
-  0x00, 0x01, 0xfc, 0x9d, 0x04, 0x7a, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x08,
-  0x00, 0x00, 0x01, 0x35, 0x21, 0x27, 0x33, 0x17, 0x07, 0x23, 0x37, 0xfc,
-  0x9d, 0x02, 0x9b, 0x77, 0x72, 0x9d, 0x9d, 0x72, 0x77, 0x05, 0x15, 0x64,
-  0x9b, 0xcd, 0xcd, 0x9b, 0x00, 0x04, 0xfc, 0x77, 0x04, 0x7b, 0xff, 0xee,
-  0x06, 0x10, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0c, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23,
-  0x17, 0xfc, 0x78, 0xb6, 0xb6, 0x02, 0xbf, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7,
-  0xb7, 0x5c, 0x06, 0x10, 0xca, 0xca, 0xca, 0xca, 0xca, 0xcb, 0x00, 0x00,
-  0x00, 0x05, 0xfb, 0xc8, 0x04, 0x7b, 0x00, 0x9f, 0x06, 0x10, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x10, 0x00, 0x00, 0x03, 0x33,
-  0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33,
-  0x15, 0x23, 0x05, 0x18, 0xb6, 0xb6, 0xfb, 0xe0, 0xb7, 0xb7, 0x02, 0xc0,
-  0xb6, 0xb6, 0xfe, 0xa0, 0xb7, 0xb7, 0x01, 0x0b, 0x06, 0x10, 0xca, 0xca,
-  0xca, 0xca, 0xca, 0xca, 0xca, 0xcb, 0x00, 0x00, 0x00, 0x01, 0xfc, 0x9d,
-  0x04, 0x7a, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x17,
-  0x23, 0x27, 0x37, 0x33, 0x07, 0x21, 0x27, 0x33, 0x17, 0x07, 0x23, 0x37,
-  0xfd, 0x35, 0x77, 0x71, 0x9e, 0x9e, 0x71, 0x77, 0x02, 0x03, 0x77, 0x72,
-  0x9d, 0x9d, 0x72, 0x77, 0x05, 0x15, 0x9b, 0xcd, 0xcd, 0x9b, 0x9b, 0xcd,
-  0xcd, 0x9b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x3c, 0xff, 0xcf, 0x07, 0x10,
-  0x06, 0x04, 0x00, 0x0a, 0x00, 0x24, 0x00, 0x28, 0x00, 0x42, 0x00, 0x00,
-  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x37,
-  0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
-  0x17, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0x25, 0x33, 0x01, 0x23, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x01, 0xda, 0x90, 0x64, 0x4a,
-  0x41, 0x5c, 0x72, 0xa9, 0xa9, 0x03, 0x89, 0x62, 0x7f, 0x96, 0xb9, 0xb2,
-  0x98, 0x64, 0x5d, 0x3d, 0x74, 0x59, 0x53, 0x85, 0x40, 0xaf, 0xad, 0x02,
-  0x6c, 0xc2, 0xfc, 0xa4, 0xc3, 0x05, 0x18, 0x54, 0x64, 0x33, 0x6d, 0x7b,
-  0x7b, 0x6d, 0x33, 0x64, 0x54, 0x41, 0x76, 0x41, 0xb6, 0xd4, 0xd6, 0xbc,
-  0x3c, 0x73, 0x03, 0xf6, 0x42, 0x52, 0x43, 0x49, 0x94, 0x82, 0x0a, 0x4d,
-  0xfe, 0x0d, 0x3e, 0x05, 0x4f, 0x9e, 0x81, 0x96, 0x9b, 0x06, 0x57, 0x5c,
-  0x20, 0x37, 0xb2, 0x24, 0x1e, 0xca, 0xfa, 0xf9, 0xcb, 0x03, 0x84, 0xb2,
-  0x34, 0x1e, 0x9c, 0x94, 0x93, 0x9d, 0x1f, 0x34, 0xb1, 0x22, 0x1b, 0xfa,
-  0xd1, 0xd4, 0xf9, 0x1b, 0x00, 0x04, 0x00, 0x3c, 0xff, 0xcf, 0x07, 0x32,
-  0x06, 0x04, 0x00, 0x20, 0x00, 0x2b, 0x00, 0x45, 0x00, 0x49, 0x00, 0x00,
-  0x01, 0x2e, 0x01, 0x34, 0x36, 0x04, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22,
-  0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x14, 0x06, 0x23, 0x26, 0x27,
-  0x35, 0x17, 0x16, 0x33, 0x32, 0x35, 0x34, 0x26, 0x27, 0x01, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x37, 0x11, 0x23, 0x35,
-  0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x17, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x25, 0x33,
-  0x01, 0x23, 0x05, 0xb4, 0x7a, 0x72, 0xa6, 0x01, 0x2d, 0x6e, 0x21, 0x64,
-  0x74, 0xa2, 0x35, 0x5e, 0x2b, 0x8a, 0x7b, 0xb5, 0x99, 0x9e, 0x82, 0x21,
-  0x84, 0x7d, 0xa0, 0x37, 0x6f, 0xfb, 0xfb, 0x90, 0x64, 0x4a, 0x41, 0x5c,
-  0x72, 0xa9, 0xa9, 0x03, 0x89, 0x62, 0x7f, 0x96, 0xb9, 0xb2, 0x98, 0x64,
-  0x5d, 0x3d, 0x74, 0x59, 0x53, 0x85, 0x40, 0xaf, 0xad, 0x02, 0x6c, 0xc2,
-  0xfc, 0xa4, 0xc3, 0x01, 0x7d, 0x1c, 0x7c, 0xef, 0x8e, 0x01, 0x34, 0xbc,
-  0x12, 0x39, 0x64, 0x24, 0x2c, 0x18, 0x0a, 0x21, 0x7f, 0xf3, 0x95, 0x06,
-  0x35, 0xca, 0x13, 0x4c, 0x66, 0x2c, 0x31, 0x1b, 0x02, 0x84, 0x42, 0x52,
-  0x43, 0x49, 0x94, 0x82, 0x0a, 0x4d, 0xfe, 0x0d, 0x3e, 0x05, 0x4f, 0x9e,
-  0x81, 0x96, 0x9b, 0x06, 0x57, 0x5c, 0x20, 0x37, 0xb2, 0x24, 0x1e, 0xca,
-  0xfa, 0xf9, 0xcb, 0x00, 0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4,
-  0x05, 0xf0, 0x00, 0x18, 0x00, 0x21, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01,
-  0x23, 0x22, 0x07, 0x11, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01,
-  0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x01, 0x11, 0x06,
-  0x07, 0x06, 0x11, 0x10, 0x17, 0x16, 0x04, 0xa3, 0x50, 0xd1, 0x88, 0x92,
-  0x6d, 0x6d, 0x92, 0x88, 0xd1, 0x50, 0x5f, 0xd6, 0x76, 0xfe, 0xce, 0xfe,
-  0xa2, 0x01, 0x5e, 0x01, 0x32, 0x78, 0xd6, 0xfd, 0x56, 0x1f, 0x1c, 0x8d,
-  0x8d, 0x1c, 0x05, 0x62, 0x76, 0x41, 0x5a, 0x34, 0xfb, 0x2d, 0x34, 0x5a,
-  0x42, 0x75, 0x48, 0x48, 0x01, 0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f,
-  0x47, 0xfb, 0x13, 0x04, 0x5b, 0x1b, 0x21, 0xac, 0xfe, 0xba, 0xfe, 0xbb,
-  0xac, 0x21, 0x00, 0x00, 0xff, 0xff, 0x00, 0xaf, 0xff, 0xe3, 0x07, 0x96,
-  0x05, 0xf0, 0x10, 0x26, 0x00, 0x72, 0x00, 0x00, 0x10, 0x07, 0x00, 0x26,
-  0x02, 0xf2, 0x00, 0x00, 0x00, 0x02, 0xff, 0xda, 0x00, 0x00, 0x04, 0x96,
-  0x05, 0xd5, 0x00, 0x08, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x17, 0x11, 0x35, 0x33, 0x15, 0x16, 0x17, 0x16,
-  0x17, 0x15, 0x26, 0x27, 0x26, 0x27, 0x11, 0x36, 0x37, 0x36, 0x37, 0x15,
-  0x06, 0x07, 0x06, 0x07, 0x15, 0x21, 0x15, 0x21, 0x35, 0x26, 0x27, 0x26,
-  0x11, 0x10, 0x37, 0x36, 0x01, 0x52, 0x42, 0x2e, 0x59, 0x59, 0x2e, 0x42,
-  0xb5, 0x33, 0x30, 0x49, 0x45, 0x47, 0x46, 0x31, 0x33, 0x33, 0x31, 0x46,
-  0x47, 0x46, 0x4a, 0x2e, 0x33, 0x02, 0x8f, 0xfc, 0xbc, 0x91, 0x61, 0x86,
-  0x88, 0x5f, 0x04, 0xb3, 0x1d, 0x3a, 0x72, 0xcd, 0xcd, 0x71, 0x3b, 0x1d,
-  0x03, 0xd4, 0x7a, 0x6e, 0x04, 0x0b, 0x12, 0x23, 0xac, 0x2b, 0x16, 0x0f,
-  0x04, 0xfc, 0xa4, 0x04, 0x10, 0x15, 0x2b, 0xaa, 0x24, 0x12, 0x0b, 0x04,
-  0x2a, 0xaa, 0xde, 0x20, 0x72, 0x9f, 0x01, 0x0e, 0x01, 0x12, 0x9d, 0x6e,
-  0x00, 0x04, 0x00, 0x36, 0xff, 0xcf, 0x07, 0x1b, 0x06, 0x04, 0x00, 0x19,
-  0x00, 0x1d, 0x00, 0x28, 0x00, 0x32, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x25, 0x33,
-  0x01, 0x23, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x10,
-  0x26, 0x24, 0x20, 0x16, 0x15, 0x14, 0x06, 0x20, 0x26, 0x35, 0x34, 0x02,
-  0xb9, 0x55, 0x64, 0x32, 0x6d, 0x7b, 0x7b, 0x6d, 0x32, 0x64, 0x55, 0x42,
-  0x75, 0x42, 0xb6, 0xd4, 0xd6, 0xbc, 0x3d, 0x73, 0x02, 0x94, 0xc2, 0xfc,
-  0xa4, 0xc3, 0x03, 0xfa, 0x57, 0x6a, 0x6a, 0x57, 0x56, 0x6b, 0x6b, 0xfe,
-  0xfc, 0x01, 0x5c, 0xc4, 0xc4, 0xfe, 0xa4, 0xc3, 0x05, 0x97, 0xb2, 0x34,
-  0x1e, 0x9c, 0x94, 0x93, 0x9d, 0x1f, 0x34, 0xb1, 0x22, 0x1d, 0xfc, 0xd1,
-  0xd4, 0xf9, 0x1b, 0x4b, 0xf9, 0xcb, 0x03, 0x04, 0x9e, 0x92, 0x91, 0x9f,
-  0xa0, 0x01, 0x20, 0xa0, 0x9d, 0xf8, 0xd5, 0xd4, 0xf8, 0xf8, 0xd4, 0xd5,
-  0x00, 0x03, 0x00, 0x36, 0xff, 0xcf, 0x07, 0x79, 0x06, 0x04, 0x00, 0x13,
-  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x25, 0x33, 0x01, 0x23, 0x04, 0xd3, 0xa9, 0x49,
-  0x48, 0x59, 0x69, 0xa9, 0xa9, 0x05, 0x82, 0x56, 0x8e, 0x91, 0xfd, 0xe6,
-  0x55, 0x64, 0x32, 0x6d, 0x7b, 0x7b, 0x6d, 0x32, 0x64, 0x55, 0x42, 0x75,
-  0x42, 0xb6, 0xd4, 0xd6, 0xbc, 0x3d, 0x73, 0x02, 0x94, 0xc2, 0xfc, 0xa4,
-  0xc3, 0x01, 0x4c, 0x02, 0x10, 0xfd, 0xf5, 0x72, 0x69, 0x81, 0x75, 0x01,
-  0xf0, 0xfc, 0x90, 0x44, 0x09, 0x50, 0xc1, 0x04, 0xff, 0xb2, 0x34, 0x1e,
-  0x9c, 0x94, 0x93, 0x9d, 0x1f, 0x34, 0xb1, 0x22, 0x1d, 0xfc, 0xd1, 0xd4,
-  0xf9, 0x1b, 0x4b, 0xf9, 0xcb, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x93,
-  0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x10, 0x06, 0x01, 0x52, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xfe, 0xd6, 0x04, 0xa0, 0x04, 0xe3, 0x10, 0x07,
-  0x03, 0xc1, 0x00, 0x00, 0xfe, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xaf,
-  0x00, 0x00, 0x06, 0x6f, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x72, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x29, 0x02, 0xb6, 0x00, 0x00, 0x00, 0x01, 0x00, 0x41,
-  0xff, 0xe3, 0x06, 0xcb, 0x05, 0xfb, 0x00, 0x6f, 0x00, 0x00, 0x01, 0x0f,
-  0x01, 0x11, 0x21, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x11, 0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x21, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x19, 0x01, 0x22, 0x07, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x16, 0x03, 0x5f, 0x02, 0x61, 0x01, 0xc6, 0x24, 0x33, 0x3b, 0x44,
-  0x59, 0x6f, 0x37, 0x12, 0x22, 0x19, 0x21, 0x12, 0x14, 0x1a, 0x21, 0x2b,
-  0x2e, 0x1e, 0x24, 0x17, 0x14, 0x17, 0x24, 0x17, 0x1e, 0x27, 0x14, 0x32,
-  0x1a, 0x2e, 0x33, 0x1c, 0x21, 0x31, 0x1a, 0x57, 0x61, 0x40, 0x35, 0x32,
-  0x1a, 0x19, 0x0c, 0xfe, 0x44, 0x2d, 0x30, 0x53, 0x9c, 0xa6, 0x5e, 0x3c,
-  0x2e, 0x27, 0x23, 0x30, 0x0e, 0x10, 0x0a, 0x14, 0x08, 0x23, 0x3b, 0x52,
-  0x49, 0x3f, 0x20, 0x22, 0x7b, 0x53, 0x5a, 0x23, 0x40, 0x09, 0x01, 0x08,
-  0x09, 0x11, 0x21, 0x1e, 0x15, 0x1a, 0x12, 0x09, 0x07, 0x71, 0x43, 0x67,
-  0x71, 0x85, 0x27, 0x97, 0x05, 0xea, 0x1f, 0x31, 0xfd, 0xbc, 0xd1, 0x8c,
-  0x98, 0x49, 0x67, 0x14, 0x29, 0x1d, 0x2a, 0x1a, 0x21, 0x1c, 0x26, 0x21,
-  0x28, 0x44, 0x3b, 0x77, 0xd6, 0xfe, 0xbd, 0xa5, 0x82, 0x7d, 0x2c, 0x16,
-  0x37, 0x35, 0x3b, 0x21, 0x5f, 0x27, 0x5d, 0x37, 0x3a, 0x79, 0x7d, 0xa9,
-  0x5b, 0xb4, 0xcf, 0x9e, 0xa3, 0x5c, 0xae, 0x40, 0x34, 0x3e, 0x23, 0x2c,
-  0x0f, 0x12, 0x21, 0x2c, 0x0b, 0x27, 0x51, 0x46, 0xaa, 0xa7, 0x00, 0xff,
-  0x02, 0x6a, 0x16, 0x1a, 0x28, 0x4a, 0x47, 0x1f, 0x34, 0x10, 0x24, 0x24,
-  0x2c, 0x10, 0x2a, 0x1d, 0x12, 0x29, 0x2f, 0x39, 0x84, 0x79, 0x4b, 0x23,
-  0x25, 0x06, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0xfe, 0xf9, 0x04, 0xfe,
-  0x05, 0xd9, 0x00, 0x50, 0x00, 0x00, 0x05, 0x37, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x16, 0x17, 0x16, 0x07, 0x02, 0x07, 0x26, 0x27, 0x26,
-  0x22, 0x07, 0x27, 0x36, 0x33, 0x32, 0x17, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x16, 0x17, 0x16, 0x37, 0x36,
-  0x37, 0x15, 0x0e, 0x02, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x36, 0x37, 0x32, 0x17, 0x16, 0x15, 0x10, 0x07, 0x02,
-  0x23, 0x22, 0x02, 0xd9, 0x5f, 0x24, 0x4f, 0x21, 0x1c, 0x1f, 0x19, 0x17,
-  0x10, 0x0c, 0x18, 0x19, 0x2d, 0x3f, 0x75, 0x4a, 0x9f, 0x3e, 0x2a, 0x0a,
-  0x0c, 0x16, 0xb6, 0x47, 0x2a, 0x2f, 0x30, 0x3f, 0x69, 0x14, 0xaa, 0x48,
-  0x4c, 0x52, 0x49, 0x3f, 0x52, 0x2b, 0x2b, 0x66, 0x62, 0xbe, 0x71, 0x8c,
-  0x18, 0x1f, 0x05, 0x82, 0x43, 0x42, 0x70, 0x1e, 0x35, 0x42, 0x3f, 0x67,
-  0x35, 0x1c, 0x1c, 0x63, 0x91, 0xd5, 0xda, 0x8d, 0x35, 0x55, 0xfc, 0x4b,
-  0x55, 0xcd, 0x8c, 0x51, 0x1f, 0x1f, 0x37, 0x39, 0x7d, 0x77, 0xb2, 0x96,
-  0x5e, 0x6c, 0x2e, 0x47, 0x89, 0x79, 0x72, 0x5c, 0x5b, 0x34, 0xfe, 0xfa,
-  0x4f, 0x39, 0x25, 0x23, 0x69, 0x23, 0xde, 0x5e, 0x4d, 0x58, 0x3b, 0x80,
-  0xa5, 0x79, 0x76, 0x40, 0x63, 0x8d, 0x84, 0x93, 0x7d, 0x07, 0x01, 0x1a,
-  0x02, 0x65, 0x2e, 0x49, 0x44, 0x5c, 0x1a, 0x16, 0x37, 0x49, 0x3b, 0x3e,
-  0x32, 0x56, 0xe7, 0xa7, 0x89, 0x75, 0xd3, 0xb0, 0xfe, 0xa2, 0xd3, 0xfe,
-  0xfe, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x6a,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x25, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x04, 0x59, 0xb6, 0xfc, 0x00, 0xb6,
-  0xfe, 0xf0, 0x01, 0x6a, 0x01, 0xe0, 0x01, 0x6a, 0xfe, 0x96, 0xfe, 0x20,
-  0xfe, 0x96, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x0d,
-  0x64, 0xfd, 0x88, 0x02, 0x78, 0xfa, 0x2b, 0x02, 0xdb, 0xfd, 0x25, 0x00,
-  0x00, 0x01, 0x00, 0x40, 0x00, 0x00, 0x04, 0x14, 0x06, 0x14, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x03, 0x23, 0x13, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x03, 0x23, 0x01, 0x33, 0x03, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x04, 0x03, 0x76, 0xa7, 0x76, 0x08, 0x0a, 0x60,
-  0x55, 0x86, 0xc3, 0x1d, 0x6d, 0xa5, 0x01, 0x11, 0xa5, 0x6b, 0x3f, 0xc4,
-  0x6c, 0x85, 0x93, 0x08, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9d, 0x2f, 0x48,
-  0x15, 0x54, 0x5e, 0xc8, 0xa6, 0xfd, 0x93, 0x06, 0x14, 0xfd, 0x9c, 0x5e,
-  0x6d, 0xa0, 0x91, 0x24, 0x52, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51,
-  0x00, 0x00, 0x04, 0x14, 0x06, 0x14, 0x00, 0x19, 0x00, 0x00, 0x01, 0x33,
-  0x07, 0x25, 0x17, 0x05, 0x03, 0x36, 0x33, 0x32, 0x16, 0x07, 0x03, 0x23,
-  0x13, 0x12, 0x23, 0x22, 0x06, 0x07, 0x03, 0x23, 0x13, 0x07, 0x27, 0x37,
-  0x01, 0x61, 0xa6, 0x28, 0x01, 0x65, 0x0d, 0xfe, 0x7b, 0x2f, 0x99, 0xd0,
-  0xae, 0x88, 0x29, 0x76, 0xa5, 0x75, 0x37, 0xdf, 0x86, 0xbc, 0x1d, 0x6e,
-  0xa7, 0xc9, 0xbc, 0x0d, 0xdd, 0x06, 0x14, 0xea, 0x7c, 0x61, 0x88, 0xfe,
-  0xf5, 0xc9, 0xef, 0xe8, 0xfd, 0x5c, 0x02, 0x9e, 0x01, 0x3d, 0xbe, 0xa4,
-  0xfd, 0x87, 0x04, 0x7f, 0x42, 0x63, 0x4c, 0x00, 0x00, 0x01, 0x00, 0x35,
-  0xff, 0xe1, 0x03, 0x1c, 0x05, 0xf0, 0x00, 0x39, 0x00, 0x00, 0x01, 0x0f,
-  0x01, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x35, 0x11, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x14, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x03, 0x1c, 0x1b, 0x5e,
-  0xae, 0x75, 0x80, 0x63, 0x36, 0x32, 0x0f, 0x17, 0x1f, 0x19, 0x1c, 0x07,
-  0x0a, 0x0a, 0x18, 0x12, 0x35, 0x43, 0x49, 0x38, 0x1e, 0x1c, 0x70, 0x51,
-  0x57, 0x28, 0x2f, 0x06, 0x12, 0x1c, 0x14, 0x15, 0x18, 0x14, 0x24, 0x50,
-  0x45, 0x7d, 0x86, 0xa3, 0x1e, 0x70, 0x05, 0xe3, 0x2c, 0x16, 0xfc, 0xfe,
-  0xfe, 0x86, 0xc2, 0x82, 0x3c, 0x37, 0x44, 0x39, 0x0f, 0x1b, 0x23, 0x07,
-  0x37, 0x2e, 0x1b, 0x13, 0x4d, 0x3d, 0x86, 0x84, 0xbe, 0x03, 0x11, 0x1a,
-  0x1d, 0x2e, 0x31, 0x3f, 0x1b, 0x16, 0x04, 0x40, 0x09, 0x27, 0x1f, 0x12,
-  0x16, 0x28, 0x4d, 0x7f, 0x58, 0x49, 0x28, 0x27, 0x0d, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x5f, 0xff, 0xe3, 0x04, 0xbf, 0x05, 0xf0, 0x00, 0x21,
-  0x00, 0x32, 0x00, 0x00, 0x3f, 0x01, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x23, 0x22, 0x13, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x23, 0x22, 0x07, 0x5f, 0x7e, 0x64, 0x6a, 0x33,
-  0x77, 0x81, 0x1e, 0x6d, 0x5a, 0x40, 0x38, 0x48, 0x48, 0xc0, 0x48, 0x48,
-  0x2f, 0xb5, 0xa8, 0xda, 0x30, 0x74, 0x78, 0x32, 0x55, 0x63, 0x62, 0x7f,
-  0x6f, 0x72, 0x6e, 0x73, 0x70, 0x71, 0xb4, 0x7d, 0x64, 0x81, 0xc0, 0x81,
-  0x6e, 0x73, 0x5a, 0xa5, 0x27, 0x50, 0x56, 0x89, 0x61, 0x4b, 0x7e, 0x70,
-  0x92, 0x6d, 0x64, 0xa0, 0x8c, 0x8b, 0x79, 0x6b, 0x94, 0x62, 0xbc, 0x5e,
-  0xf2, 0xde, 0x4f, 0x50, 0x05, 0x36, 0x38, 0x31, 0x2f, 0x3a, 0xaa, 0x3a,
-  0x62, 0x3a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3d, 0xff, 0xe3, 0x04, 0xe3,
-  0x05, 0xf2, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x17, 0x16, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x23, 0x35, 0x22, 0x07, 0x06, 0x07,
-  0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x13, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x17, 0x33, 0x32, 0x01, 0xac, 0xe8,
-  0x63, 0x51, 0x4a, 0x36, 0x5d, 0x4d, 0x3c, 0x08, 0x27, 0x16, 0x63, 0x6d,
-  0x6d, 0x2f, 0x5b, 0x50, 0x80, 0xeb, 0x4a, 0x3d, 0x32, 0x2f, 0x0c, 0x30,
-  0x42, 0x17, 0x2c, 0x22, 0x2b, 0x31, 0x0a, 0x05, 0x1f, 0x1e, 0x3a, 0x59,
-  0xbc, 0x66, 0x40, 0x3c, 0x0d, 0x25, 0x1c, 0x27, 0x1a, 0x0c, 0x0a, 0x06,
-  0x25, 0x2e, 0x33, 0x44, 0x29, 0x20, 0x20, 0x04, 0x03, 0x12, 0x14, 0x22,
-  0x32, 0x3b, 0x02, 0x0e, 0x38, 0x01, 0x5f, 0x6e, 0x30, 0x18, 0x19, 0x56,
-  0x42, 0x9a, 0x52, 0x1e, 0x0e, 0x84, 0x0e, 0xe4, 0x6e, 0x79, 0x23, 0x1f,
-  0x48, 0x89, 0x08, 0x42, 0x3f, 0x84, 0x18, 0xc1, 0x58, 0x21, 0x24, 0x18,
-  0x39, 0x42, 0x01, 0x7f, 0xa9, 0x84, 0x80, 0x4d, 0x77, 0x3e, 0x37, 0x6c,
-  0x1a, 0x10, 0x2e, 0x1b, 0x0b, 0x3b, 0x37, 0x25, 0x2c, 0x3b, 0x28, 0xd3,
-  0xa7, 0xbd, 0x75, 0x79, 0x2c, 0x44, 0x30, 0x03, 0x00, 0x02, 0xff, 0xe6,
-  0xff, 0xe3, 0x02, 0x8a, 0x05, 0xf0, 0x00, 0x1c, 0x00, 0x26, 0x00, 0x00,
-  0x01, 0x16, 0x33, 0x32, 0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x07, 0x23, 0x36, 0x37, 0x26, 0x35, 0x34, 0x37, 0x12, 0x37, 0x36, 0x33,
-  0x32, 0x15, 0x06, 0x07, 0x02, 0x01, 0x12, 0x13, 0x36, 0x35, 0x34, 0x23,
-  0x06, 0x03, 0x06, 0x01, 0x12, 0x24, 0x4f, 0x34, 0x43, 0x78, 0x36, 0x3f,
-  0x44, 0x3f, 0x8d, 0x38, 0x44, 0x8c, 0x61, 0x48, 0x09, 0x1c, 0x69, 0x5e,
-  0x41, 0x6e, 0x71, 0x01, 0x10, 0x41, 0xfe, 0xd9, 0xa8, 0x33, 0x1b, 0x16,
-  0x62, 0x58, 0x18, 0x01, 0x0c, 0xc8, 0x73, 0x66, 0x35, 0x39, 0x8b, 0x6e,
-  0x93, 0x89, 0x4e, 0x55, 0x98, 0x98, 0x02, 0x3b, 0x75, 0x51, 0xad, 0x4e,
-  0x5d, 0xfe, 0x83, 0xfe, 0xf7, 0x01, 0x5c, 0x01, 0x16, 0x93, 0x26, 0x45,
-  0x57, 0xfd, 0xfa, 0x91, 0x00, 0x02, 0x00, 0x1c, 0xff, 0xe3, 0x05, 0x7f,
-  0x06, 0x14, 0x00, 0x1f, 0x00, 0x27, 0x00, 0x00, 0x13, 0x33, 0x15, 0x33,
-  0x35, 0x33, 0x15, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12,
-  0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23,
-  0x11, 0x23, 0x35, 0x33, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
-  0xae, 0xa5, 0xa6, 0xa6, 0x02, 0x6d, 0xfd, 0x93, 0x35, 0x9f, 0x6f, 0xb7,
-  0xe6, 0xe6, 0xb7, 0x6f, 0x9f, 0x35, 0xa6, 0xa6, 0xa5, 0x91, 0x91, 0x04,
-  0x25, 0x97, 0xfe, 0xfa, 0x97, 0x97, 0x01, 0x06, 0x06, 0x14, 0x93, 0x93,
-  0x93, 0x7d, 0xfe, 0xb2, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc,
-  0x61, 0x64, 0xa8, 0x05, 0x04, 0xfa, 0xfc, 0x05, 0x04, 0x7d, 0xfb, 0xe3,
-  0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x00, 0x00, 0x02, 0x00, 0xb2,
-  0x00, 0x00, 0x05, 0x12, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00,
-  0x25, 0x01, 0x23, 0x09, 0x01, 0x21, 0x01, 0x11, 0x33, 0x11, 0x21, 0x01,
-  0x11, 0x23, 0x04, 0x9c, 0xfd, 0x62, 0xd6, 0x02, 0x9e, 0xfc, 0xed, 0x01,
-  0x7c, 0x02, 0x88, 0x5a, 0xfe, 0x84, 0xfd, 0x78, 0x5a, 0x64, 0x05, 0x0d,
-  0xfa, 0xf3, 0x05, 0x71, 0xfb, 0x1f, 0x04, 0xe1, 0xfa, 0x2b, 0x04, 0xe1,
-  0xfb, 0x1f, 0x00, 0x00, 0x00, 0x04, 0x00, 0x30, 0x00, 0x00, 0x06, 0xfb,
-  0x05, 0xd5, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x00,
-  0x33, 0x35, 0x32, 0x35, 0x11, 0x33, 0x01, 0x11, 0x34, 0x36, 0x33, 0x15,
-  0x22, 0x15, 0x11, 0x23, 0x01, 0x11, 0x14, 0x06, 0x01, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x35, 0x21, 0x15,
-  0x31, 0x84, 0xf5, 0x02, 0x54, 0x8d, 0xa7, 0x84, 0xf5, 0xfd, 0xac, 0x8d,
-  0x04, 0x66, 0x82, 0x5c, 0x5d, 0x81, 0x81, 0x5d, 0x5c, 0x82, 0x7e, 0x33,
-  0x2d, 0x2d, 0x33, 0x33, 0x2d, 0x2d, 0x33, 0x7e, 0x01, 0xbc, 0xaa, 0x6b,
-  0x04, 0xc0, 0xfb, 0x1f, 0x03, 0xcc, 0x80, 0x95, 0xaa, 0x6b, 0xfb, 0x40,
-  0x04, 0xe1, 0xfc, 0x34, 0x80, 0x95, 0x02, 0x6e, 0x8a, 0xbf, 0xbf, 0x8a,
-  0x8a, 0xbf, 0xbf, 0x8a, 0x4e, 0x67, 0x67, 0x4e, 0x4e, 0x67, 0x67, 0xfd,
-  0x44, 0x7b, 0x7b, 0x00, 0x00, 0x04, 0x00, 0xfe, 0x00, 0x00, 0x06, 0x35,
-  0x05, 0xca, 0x00, 0x0c, 0x00, 0x19, 0x00, 0x22, 0x00, 0x2d, 0x00, 0x00,
-  0x01, 0x16, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21,
-  0x20, 0x06, 0x23, 0x22, 0x00, 0x11, 0x12, 0x00, 0x33, 0x32, 0x00, 0x11,
-  0x10, 0x27, 0x05, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x25,
-  0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x05, 0x70,
-  0xc4, 0xfe, 0x76, 0xfe, 0xf0, 0xfe, 0xed, 0xfe, 0x7d, 0x05, 0x01, 0x88,
-  0x01, 0x13, 0x01, 0x13, 0x25, 0xee, 0xec, 0xfe, 0xac, 0x04, 0x01, 0x50,
-  0xec, 0xec, 0x01, 0x54, 0xa9, 0xfe, 0x0b, 0xa0, 0x59, 0x61, 0x61, 0x59,
-  0xfe, 0xe1, 0x01, 0x1f, 0x9f, 0xa2, 0xa2, 0x9f, 0xa0, 0x7f, 0x04, 0xf1,
-  0xdb, 0xfe, 0xce, 0xfe, 0xd0, 0xfe, 0x4c, 0x01, 0xb4, 0x01, 0x30, 0x01,
-  0x30, 0x01, 0xb6, 0x65, 0xfe, 0x85, 0xfe, 0xf9, 0xfe, 0xfb, 0xfe, 0x87,
-  0x01, 0x79, 0x01, 0x05, 0x01, 0x09, 0xbb, 0x77, 0xfe, 0xaf, 0x58, 0x51,
-  0x50, 0x58, 0x64, 0x89, 0x83, 0x85, 0x87, 0xfe, 0x98, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x63, 0xfe, 0x3b, 0x04, 0xbd, 0x03, 0xf6, 0x00, 0x30,
-  0x00, 0x3c, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x17, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x36,
-  0x37, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
-  0x01, 0x12, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x10,
-  0x37, 0x26, 0x35, 0x34, 0x37, 0x03, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x01, 0xfc, 0x7a, 0x1c, 0x52, 0x9a, 0xc5,
-  0x77, 0x76, 0x3f, 0x41, 0x8c, 0x6d, 0x9d, 0x5a, 0x45, 0x10, 0x08, 0x25,
-  0x66, 0x6e, 0x54, 0x3e, 0x23, 0x1c, 0x43, 0xaa, 0xfe, 0xc2, 0x7a, 0x3e,
-  0x50, 0x76, 0x66, 0x34, 0x39, 0xc9, 0x2a, 0xd1, 0x85, 0x74, 0x1c, 0x2b,
-  0x29, 0x3b, 0x19, 0x1d, 0x03, 0xc6, 0x82, 0xbe, 0x4d, 0x6b, 0x65, 0x94,
-  0xbd, 0x4c, 0x50, 0xab, 0xda, 0xd7, 0xa7, 0x3c, 0x2b, 0x1d, 0x28, 0x8c,
-  0x68, 0xc3, 0x7c, 0x48, 0x3d, 0xfe, 0x79, 0xfe, 0xde, 0x7c, 0x9d, 0x6e,
-  0x8e, 0x3d, 0x42, 0x86, 0x01, 0x0b, 0xfc, 0x9e, 0x7f, 0xee, 0xa4, 0xfc,
-  0xef, 0xc6, 0x7b, 0x75, 0x2e, 0x46, 0x01, 0x2f, 0x34, 0x5f, 0x4e, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x0b, 0x00, 0x16, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x21, 0x32, 0x37, 0x11, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x21, 0x01, 0x11, 0x36, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x01, 0x0e, 0xb6, 0x5a, 0x01, 0x10, 0x15, 0x15,
-  0x15, 0x15, 0xfd, 0x86, 0x02, 0x4f, 0xe1, 0xe8, 0xe8, 0xe2, 0xe4, 0xfe,
-  0x96, 0x03, 0x02, 0x36, 0x29, 0x54, 0x53, 0x28, 0x05, 0x71, 0xfa, 0xf3,
-  0x05, 0x0d, 0xfd, 0x6a, 0x02, 0x02, 0x92, 0x02, 0x64, 0xdb, 0xd3, 0xd5,
-  0xda, 0xfd, 0x88, 0x05, 0x5a, 0xfd, 0x99, 0x16, 0x29, 0x56, 0x9f, 0x9e,
-  0x56, 0x29, 0x00, 0x00, 0x00, 0x04, 0x00, 0x67, 0xfe, 0xf8, 0x05, 0x44,
-  0x05, 0xf0, 0x00, 0x11, 0x00, 0x19, 0x00, 0x21, 0x00, 0x29, 0x00, 0x00,
-  0x25, 0x13, 0x23, 0x27, 0x07, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x02, 0x25, 0x16, 0x32, 0x37, 0x11, 0x26,
-  0x22, 0x07, 0x03, 0x11, 0x06, 0x07, 0x06, 0x10, 0x17, 0x16, 0x01, 0x11,
-  0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x03, 0xd5, 0xef, 0xdb, 0xc7, 0x2e,
-  0x0f, 0x0f, 0xfe, 0xe5, 0xfe, 0xad, 0x01, 0x53, 0x01, 0x1b, 0x01, 0x1b,
-  0x01, 0x52, 0xbc, 0xfd, 0x74, 0x61, 0xf5, 0x61, 0x61, 0xf5, 0x61, 0x5f,
-  0x20, 0x1d, 0x8b, 0x8b, 0x1d, 0x02, 0x94, 0x20, 0x1c, 0x8b, 0x8b, 0x1c,
-  0x1b, 0xfe, 0xdd, 0xef, 0x03, 0x01, 0x01, 0xa5, 0x01, 0x61, 0x01, 0x62,
-  0x01, 0xa5, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0xfc, 0xfe, 0x8e, 0x0b, 0x32,
-  0x32, 0x04, 0xd7, 0x32, 0x32, 0xfb, 0x6a, 0x04, 0x54, 0x1d, 0x25, 0xb6,
-  0xfd, 0x9c, 0xb5, 0x25, 0x04, 0x35, 0xfb, 0xaf, 0x1d, 0x24, 0xb6, 0x02,
-  0x63, 0xb6, 0x24, 0x00, 0x00, 0x02, 0x00, 0x3b, 0xff, 0xee, 0x05, 0x80,
-  0x06, 0x32, 0x00, 0x0c, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x11, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x13, 0x03, 0x27,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x35, 0x11, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x1e,
-  0x01, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x21, 0x36, 0x3f, 0x01, 0x15, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x17, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x02, 0xef, 0x1b, 0x37,
-  0x81, 0x54, 0x5e, 0x4a, 0x19, 0x53, 0x50, 0x87, 0xb9, 0x4d, 0x1c, 0x2e,
-  0x2b, 0x3f, 0x8f, 0xa7, 0x63, 0x32, 0x35, 0x18, 0x16, 0x20, 0x17, 0x14,
-  0x18, 0x10, 0x13, 0x0f, 0x17, 0x3f, 0x5c, 0x4b, 0x33, 0x1e, 0x1d, 0xcf,
-  0x75, 0x36, 0x09, 0x01, 0x0f, 0x1a, 0x20, 0x30, 0x1a, 0x27, 0x5d, 0xaa,
-  0x01, 0x05, 0x1b, 0x35, 0x36, 0xa3, 0x7c, 0x76, 0x2e, 0x4f, 0x63, 0x5d,
-  0x8b, 0x51, 0x4a, 0x6f, 0x17, 0x28, 0x1a, 0x1c, 0x1f, 0x10, 0x1c, 0x20,
-  0x33, 0x38, 0x35, 0x44, 0x1d, 0x49, 0x05, 0xa1, 0xfd, 0x49, 0x07, 0x61,
-  0x67, 0xc2, 0xa3, 0x53, 0x1b, 0x14, 0x0f, 0xfb, 0x16, 0x01, 0xe6, 0x09,
-  0xc0, 0x88, 0x89, 0x44, 0xa3, 0x35, 0x40, 0x37, 0x2a, 0x1a, 0x18, 0x16,
-  0x1a, 0x1f, 0x27, 0x10, 0x1a, 0x53, 0x3a, 0x79, 0x7d, 0x9e, 0x03, 0x2a,
-  0x82, 0x37, 0x48, 0x19, 0x30, 0x09, 0x35, 0x0f, 0x23, 0x21, 0x1f, 0x18,
-  0x2c, 0x49, 0x91, 0x6c, 0xbb, 0x0d, 0x1d, 0x1c, 0x40, 0x1c, 0x1f, 0x33,
-  0x58, 0xa7, 0xbf, 0x6e, 0x68, 0x30, 0xde, 0xcd, 0x7b, 0x1f, 0x1f, 0x28,
-  0x32, 0x18, 0x72, 0x3a, 0x3d, 0x1f, 0x4f, 0x00, 0x00, 0x02, 0x00, 0x4a,
-  0xff, 0xe3, 0x05, 0xc8, 0x05, 0xf1, 0x00, 0x49, 0x00, 0x58, 0x00, 0x00,
-  0x05, 0x26, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x15, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x16, 0x17, 0x14, 0x17, 0x16,
-  0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x14, 0x17, 0x16, 0x33, 0x17, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
-  0x37, 0x17, 0x01, 0x16, 0x15, 0x11, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x04, 0x82, 0x4a, 0x14, 0x24, 0x47, 0x26,
-  0x53, 0x6c, 0x5c, 0x5d, 0x7e, 0x7f, 0x5c, 0x5c, 0x28, 0x2a, 0x39, 0x3a,
-  0x81, 0x39, 0x3a, 0x3a, 0x39, 0x52, 0x49, 0x3b, 0x39, 0x39, 0x3a, 0x4a,
-  0x31, 0x88, 0x5c, 0x5c, 0x5c, 0x5c, 0x88, 0x92, 0x5b, 0x1b, 0x0e, 0xbe,
-  0xa8, 0x65, 0x2a, 0x21, 0x71, 0x3a, 0x3c, 0x70, 0x34, 0x2c, 0x21, 0x18,
-  0x1d, 0x28, 0x82, 0x26, 0xfc, 0xfa, 0x12, 0x8b, 0x82, 0x45, 0x43, 0x43,
-  0x16, 0x1c, 0x39, 0x5c, 0x1d, 0xb7, 0x9f, 0x8c, 0x5b, 0xa6, 0x2b, 0x38,
-  0xc7, 0xce, 0x76, 0x75, 0x75, 0x76, 0xb0, 0x0c, 0x0c, 0x7a, 0x56, 0x57,
-  0x57, 0x57, 0x96, 0x02, 0x9b, 0x95, 0x58, 0x57, 0x57, 0x56, 0xca, 0x56,
-  0x57, 0x5c, 0x75, 0x76, 0x9c, 0x9d, 0x75, 0x75, 0x75, 0x23, 0x20, 0x62,
-  0x57, 0x0e, 0x31, 0xb1, 0x57, 0x7b, 0x7c, 0x5e, 0x31, 0x24, 0x68, 0x7b,
-  0x83, 0x80, 0x76, 0x43, 0x5b, 0x04, 0x53, 0x4b, 0x5c, 0xfe, 0x95, 0x47,
-  0x43, 0x68, 0x66, 0x79, 0x97, 0x20, 0x0a, 0x2f, 0x00, 0x05, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x94, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x26,
-  0x00, 0x2e, 0x00, 0x32, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x2b, 0x01,
-  0x16, 0x17, 0x13, 0x33, 0x03, 0x1e, 0x01, 0x17, 0x13, 0x21, 0x03, 0x2e,
-  0x01, 0x2b, 0x01, 0x11, 0x21, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x01, 0x11, 0x21, 0x32, 0x37, 0x11, 0x26, 0x23, 0x17, 0x11, 0x36,
-  0x37, 0x36, 0x10, 0x27, 0x26, 0x25, 0x11, 0x33, 0x11, 0x04, 0x7c, 0x45,
-  0x3d, 0x3e, 0x6c, 0x29, 0x46, 0x5b, 0x80, 0xb3, 0xed, 0x2f, 0x66, 0x38,
-  0xb8, 0xfe, 0x74, 0xab, 0x43, 0x7d, 0x6c, 0x12, 0xfe, 0x96, 0x02, 0x63,
-  0xe7, 0xe2, 0x69, 0x2c, 0xfd, 0xd3, 0x01, 0x24, 0x16, 0x15, 0x15, 0x16,
-  0x89, 0x3b, 0x26, 0x51, 0x50, 0x26, 0xfd, 0x07, 0xb6, 0x01, 0x7f, 0x97,
-  0x30, 0x31, 0x2f, 0xc9, 0xfe, 0xe5, 0x02, 0x4f, 0x19, 0x84, 0x7e, 0xfe,
-  0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0x89, 0x05, 0xd5, 0xd6, 0xd8, 0xd0,
-  0x62, 0x29, 0x02, 0xa5, 0xfd, 0x6a, 0x02, 0x02, 0x92, 0x02, 0x17, 0xfd,
-  0x99, 0x16, 0x29, 0x56, 0x01, 0x3e, 0x55, 0x29, 0x2d, 0xfa, 0xf3, 0x05,
-  0x0d, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x98, 0x00, 0x00, 0x05, 0xdd,
-  0x05, 0xd5, 0x00, 0x08, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11,
-  0x21, 0x32, 0x16, 0x15, 0x14, 0x07, 0x17, 0x37, 0x33, 0x09, 0x01, 0x23,
-  0x0b, 0x01, 0x23, 0x01, 0x01, 0x4e, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0x01,
-  0x04, 0x68, 0x9c, 0xe4, 0xb6, 0x01, 0x9a, 0xe2, 0xe8, 0x46, 0x9c, 0xab,
-  0xd1, 0xfe, 0xec, 0x01, 0x22, 0xd1, 0xbb, 0xbe, 0xd1, 0x01, 0x28, 0x05,
-  0x2f, 0xfd, 0xcf, 0x92, 0x87, 0x86, 0x92, 0xfd, 0x5f, 0x36, 0xfd, 0xa8,
-  0x05, 0xd5, 0xe3, 0xdb, 0xac, 0x6b, 0xdb, 0xea, 0xfe, 0x86, 0xfe, 0x6b,
-  0x01, 0x04, 0xfe, 0xfc, 0x01, 0x95, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xff, 0x25, 0x04, 0xcc, 0x06, 0xc7, 0x00, 0x05, 0x00, 0x24, 0x00, 0x2b,
-  0x00, 0x2e, 0x00, 0x00, 0x01, 0x11, 0x33, 0x13, 0x26, 0x23, 0x13, 0x16,
-  0x17, 0x16, 0x17, 0x13, 0x23, 0x03, 0x26, 0x27, 0x26, 0x27, 0x01, 0x27,
-  0x37, 0x23, 0x11, 0x21, 0x32, 0x17, 0x37, 0x25, 0x37, 0x05, 0x07, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x06, 0x0b, 0x01, 0x36, 0x37, 0x36, 0x35, 0x34,
-  0x01, 0x13, 0x23, 0x01, 0x6b, 0xbc, 0xb4, 0x39, 0x53, 0xe3, 0x3b, 0x37,
-  0x34, 0x3b, 0xb9, 0xc4, 0xac, 0x43, 0x3e, 0x30, 0x4d, 0xfe, 0xd0, 0x64,
-  0x3f, 0x54, 0x01, 0x9a, 0x72, 0x55, 0x0a, 0xfe, 0xdb, 0x27, 0x01, 0x8a,
-  0x32, 0x19, 0x14, 0x71, 0x75, 0x70, 0x96, 0x4b, 0x2e, 0x43, 0xfe, 0x12,
-  0x80, 0x80, 0x05, 0x2f, 0xfd, 0xee, 0x01, 0xf8, 0x1a, 0xfd, 0x8d, 0x16,
-  0x48, 0x44, 0x82, 0xfe, 0x68, 0x01, 0x7f, 0x97, 0x30, 0x26, 0x09, 0xfc,
-  0xb0, 0x2c, 0xaf, 0x05, 0xd5, 0x1a, 0x1b, 0x82, 0x6f, 0xae, 0x8c, 0x10,
-  0x13, 0x6b, 0xd8, 0x8d, 0xba, 0x01, 0xe7, 0xfe, 0x5d, 0x0f, 0x2d, 0x44,
-  0x83, 0x62, 0xfc, 0x87, 0x01, 0x67, 0x00, 0x00, 0x00, 0x02, 0x00, 0xe9,
-  0x03, 0x8b, 0x05, 0x8b, 0x05, 0xd8, 0x00, 0x27, 0x00, 0x34, 0x00, 0x00,
-  0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x37, 0x33, 0x1b, 0x01, 0x33, 0x11, 0x23, 0x11,
-  0x03, 0x23, 0x03, 0x11, 0x23, 0x02, 0x9c, 0x4d, 0x4e, 0x23, 0x3b, 0x3f,
-  0x2a, 0x3e, 0x32, 0x65, 0x5f, 0x82, 0x7e, 0x2f, 0x67, 0x40, 0x52, 0x5a,
-  0x2a, 0x3e, 0x44, 0x32, 0x39, 0x32, 0x65, 0x59, 0x7c, 0x70, 0x2e, 0x5e,
-  0xbb, 0xa6, 0x91, 0x92, 0xa5, 0x7c, 0x7e, 0x79, 0x7f, 0x7c, 0x05, 0xb7,
-  0x59, 0x22, 0x13, 0x2a, 0x2f, 0x28, 0x20, 0x0b, 0x09, 0x12, 0x56, 0x41,
-  0x4f, 0x5b, 0x13, 0x15, 0x60, 0x2a, 0x18, 0x2c, 0x32, 0x2c, 0x2a, 0x0a,
-  0x09, 0x12, 0x4d, 0x3d, 0x48, 0x5c, 0x0f, 0x05, 0xfe, 0xac, 0x01, 0x54,
-  0xfd, 0xc8, 0x01, 0x94, 0xfe, 0xd8, 0x01, 0x28, 0xfe, 0x6c, 0x00, 0x00,
-  0x00, 0x03, 0xff, 0xfc, 0x00, 0x00, 0x07, 0x5f, 0x04, 0x60, 0x00, 0x07,
-  0x00, 0x13, 0x00, 0x19, 0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x05, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x01, 0x33, 0x11, 0x21, 0x15, 0x21, 0x04, 0x03, 0x55, 0xfe,
-  0x99, 0x88, 0xfe, 0x9a, 0x02, 0x97, 0x02, 0x31, 0xfe, 0x46, 0x01, 0xa7,
-  0xfe, 0x59, 0x01, 0xc4, 0xfd, 0xc5, 0x02, 0xa4, 0x77, 0x01, 0xb0, 0xfd,
-  0xd9, 0x04, 0x60, 0x80, 0xfc, 0x20, 0x03, 0xe0, 0x60, 0x66, 0xfe, 0xf7,
-  0x66, 0xfe, 0xbb, 0x66, 0x03, 0x80, 0xfc, 0xe6, 0x66, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x09, 0x03, 0x93, 0x05, 0xa6, 0x05, 0xd5, 0x00, 0x0c,
-  0x00, 0x14, 0x00, 0x00, 0x01, 0x1b, 0x01, 0x33, 0x11, 0x23, 0x11, 0x03,
-  0x23, 0x03, 0x11, 0x23, 0x11, 0x23, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23,
-  0x35, 0x03, 0xdc, 0x9d, 0x93, 0x99, 0x65, 0xb0, 0x31, 0xb7, 0x67, 0x65,
-  0xb7, 0x67, 0xb4, 0x05, 0xd5, 0xff, 0x00, 0x01, 0x00, 0xfd, 0xbe, 0x01,
-  0xe4, 0xfe, 0xd1, 0x01, 0x2f, 0xfe, 0x1c, 0x02, 0x42, 0x5e, 0xfe, 0x1c,
-  0x01, 0xe4, 0x5e, 0x00, 0x00, 0x01, 0x00, 0x0e, 0xff, 0x22, 0x04, 0xde,
-  0x06, 0xc4, 0x00, 0x10, 0x00, 0x00, 0x01, 0x13, 0x25, 0x37, 0x05, 0x01,
-  0x13, 0x01, 0x33, 0x01, 0x23, 0x0b, 0x01, 0x27, 0x09, 0x01, 0x33, 0x01,
-  0xa8, 0xe7, 0xfe, 0xdb, 0x27, 0x01, 0x8b, 0xfe, 0xc4, 0x96, 0x01, 0xab,
-  0xbd, 0xfe, 0x00, 0xcf, 0x8e, 0xe3, 0x64, 0x01, 0x0f, 0xfe, 0xc5, 0xbe,
-  0x03, 0x4d, 0x02, 0x86, 0x82, 0x6f, 0xae, 0xfc, 0x90, 0xfe, 0x46, 0x04,
-  0xe9, 0xfa, 0x2b, 0x01, 0x9e, 0xfd, 0x84, 0x2c, 0x02, 0xf5, 0x03, 0x92,
-  0x00, 0x02, 0x00, 0x52, 0x00, 0x00, 0x05, 0x0a, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x0d, 0x00, 0x00, 0x25, 0x01, 0x23, 0x01, 0x03, 0x21, 0x15, 0x01,
-  0x21, 0x15, 0x21, 0x35, 0x01, 0x21, 0x01, 0x9a, 0x02, 0xe6, 0xd3, 0xfd,
-  0x1b, 0x60, 0x04, 0x8d, 0xfd, 0x1a, 0x02, 0xfb, 0xfb, 0x49, 0x02, 0xe5,
-  0xfd, 0x30, 0x64, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x71, 0x64, 0xfa, 0xf3,
-  0x64, 0x64, 0x05, 0x0d, 0x00, 0x01, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0xc4,
-  0x06, 0x14, 0x00, 0x1f, 0x00, 0x00, 0x17, 0x16, 0x20, 0x36, 0x35, 0x34,
-  0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x35, 0x01, 0x21, 0x35, 0x21, 0x15,
-  0x01, 0x21, 0x15, 0x01, 0x32, 0x1e, 0x01, 0x15, 0x10, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x4f, 0x99, 0x01, 0x79, 0xae, 0xa7, 0x94, 0xf5, 0x01, 0xc5,
-  0xfe, 0x3b, 0x01, 0xc5, 0xfd, 0xfd, 0x02, 0xd4, 0xfe, 0x56, 0x01, 0xaa,
-  0xfe, 0x56, 0x9a, 0xc9, 0x96, 0x7f, 0xa7, 0xe8, 0xa8, 0xbf, 0xa7, 0x63,
-  0xa3, 0xcc, 0x86, 0x93, 0xa6, 0x01, 0x65, 0x93, 0x01, 0x65, 0x93, 0xa8,
-  0xfe, 0xb0, 0xa8, 0xfe, 0xb0, 0x61, 0xd4, 0x8a, 0xfe, 0xd3, 0x66, 0x86,
-  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x46, 0x00, 0x00, 0x05, 0x3b,
-  0x05, 0xe7, 0x10, 0x06, 0x03, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x46,
-  0xff, 0xe3, 0x05, 0x3b, 0x05, 0xca, 0x10, 0x06, 0x01, 0x73, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x15, 0xfe, 0xce, 0x04, 0x20, 0x06, 0x44, 0x00, 0x55,
-  0x00, 0x00, 0x01, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x37, 0x33, 0x06, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x32, 0x36, 0x33, 0x32, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x17, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x10,
-  0x03, 0x06, 0x21, 0x22, 0x27, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x27, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x01, 0x66, 0x56, 0x70, 0x6d, 0x5f, 0x1f, 0x2c,
-  0x49, 0x16, 0x73, 0x87, 0x17, 0x53, 0x20, 0x16, 0x89, 0x1f, 0x1f, 0x1f,
-  0x20, 0x75, 0x27, 0x4c, 0x0f, 0x40, 0x0f, 0x40, 0x53, 0x16, 0x36, 0x75,
-  0x77, 0x61, 0x02, 0x40, 0x2c, 0xe2, 0x5b, 0x21, 0x9f, 0xd9, 0xfe, 0xf4,
-  0x67, 0x58, 0x01, 0x04, 0x0e, 0x16, 0x20, 0x2b, 0x3e, 0x15, 0x43, 0x4f,
-  0x49, 0x36, 0x45, 0x10, 0x0a, 0x16, 0x1b, 0x3a, 0x89, 0x69, 0x43, 0x22,
-  0x23, 0x0f, 0x12, 0x1e, 0x5d, 0x9e, 0x61, 0x54, 0x02, 0xa8, 0x8a, 0x09,
-  0x79, 0x6a, 0x8d, 0x2e, 0x23, 0x2e, 0x0b, 0x0b, 0x23, 0x19, 0x21, 0xd3,
-  0x3c, 0x23, 0x21, 0x05, 0x06, 0x16, 0x18, 0x3b, 0x47, 0xa3, 0x81, 0x84,
-  0x42, 0x03, 0x0e, 0x98, 0x77, 0x80, 0xfe, 0xeb, 0xfe, 0xfa, 0xc8, 0x18,
-  0x87, 0x1c, 0x2c, 0x10, 0x18, 0x3c, 0x24, 0x3d, 0x2c, 0x23, 0x23, 0x16,
-  0x77, 0x55, 0x19, 0x1e, 0x74, 0x4b, 0x79, 0x79, 0x98, 0x56, 0x3f, 0x40,
-  0x21, 0x6a, 0x2e, 0x00, 0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x01, 0xd6,
-  0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x21, 0x11, 0x34, 0x27, 0x26, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x01, 0x2d, 0x1f, 0x20,
-  0x62, 0x4f, 0x63, 0xa4, 0x48, 0x4a, 0x02, 0xd5, 0x91, 0x2e, 0x30, 0x9c,
-  0x60, 0x62, 0xd4, 0xfd, 0x36, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x2e, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x6d, 0x10, 0x06,
-  0x00, 0x87, 0x00, 0x00, 0x00, 0x03, 0x00, 0x52, 0x00, 0x00, 0x05, 0x49,
-  0x06, 0x2e, 0x00, 0x32, 0x00, 0x3f, 0x00, 0x52, 0x00, 0x00, 0x01, 0x17,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x29, 0x01, 0x37, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x35, 0x11, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x14,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x3f, 0x01, 0x17, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x05, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23,
-  0x11, 0x14, 0x03, 0x05, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x03, 0xff, 0x07,
-  0x98, 0x55, 0x56, 0x6d, 0xc6, 0xfe, 0xd4, 0xfd, 0xb4, 0x36, 0x86, 0x79,
-  0x33, 0x1a, 0x1c, 0xa6, 0x75, 0x45, 0x0a, 0x0b, 0x11, 0x1e, 0x27, 0x17,
-  0x0f, 0x22, 0x65, 0x90, 0xee, 0x89, 0x08, 0xb2, 0x83, 0x80, 0x2c, 0x41,
-  0x5c, 0x44, 0xfe, 0xaf, 0xb8, 0x66, 0x4a, 0x3e, 0x26, 0x5b, 0x61, 0x79,
-  0xfc, 0x01, 0x39, 0x7b, 0x61, 0x5d, 0x2c, 0x4f, 0x4e, 0x29, 0x4c, 0x45,
-  0x6a, 0x44, 0x41, 0x1c, 0x2a, 0x4f, 0x03, 0x54, 0x10, 0x61, 0x5e, 0x80,
-  0xae, 0x7d, 0xda, 0x75, 0x86, 0x3b, 0x8b, 0x84, 0xd3, 0x02, 0x83, 0x82,
-  0x49, 0x4d, 0x0b, 0x3d, 0x05, 0x2c, 0x0d, 0x33, 0x13, 0x21, 0x16, 0x23,
-  0x56, 0x86, 0x74, 0x9f, 0x27, 0x49, 0x40, 0x1c, 0x1f, 0x33, 0x48, 0x6c,
-  0x9a, 0x68, 0x4a, 0x33, 0x70, 0x52, 0x81, 0x75, 0x46, 0x2a, 0x1b, 0x18,
-  0xfd, 0xc2, 0x1d, 0xfd, 0x28, 0x02, 0x1a, 0x1d, 0x30, 0x58, 0xb9, 0x72,
-  0x56, 0x2c, 0x18, 0x18, 0x06, 0xec, 0x6e, 0xce, 0x00, 0x01, 0x00, 0x75,
-  0xff, 0xe8, 0x04, 0xb2, 0x05, 0xf0, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x17,
-  0x36, 0x25, 0x1e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x37, 0x15, 0x06, 0x07,
-  0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x1e, 0x01,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x37, 0x22, 0x07, 0x06, 0x15, 0x10, 0x17, 0x16, 0x25, 0x37, 0x15,
-  0x06, 0x07, 0x06, 0x24, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x02, 0x10, 0x40, 0x89, 0x01, 0x11, 0x0a, 0x24, 0x0a, 0x0f, 0x0e, 0x14,
-  0x5f, 0x7e, 0x5e, 0x35, 0x69, 0x25, 0x1b, 0x15, 0x0a, 0x03, 0x0d, 0x0d,
-  0x0e, 0x3f, 0x67, 0xb3, 0x17, 0x51, 0x42, 0x1f, 0x29, 0x1e, 0x11, 0x70,
-  0x42, 0x5f, 0x9f, 0xc8, 0x01, 0x46, 0xe8, 0xc2, 0x5b, 0xad, 0xfe, 0xb4,
-  0x75, 0x53, 0x2a, 0x2b, 0x55, 0xac, 0x05, 0x35, 0x23, 0x6c, 0x72, 0x1c,
-  0x77, 0x1f, 0x28, 0x0f, 0x16, 0x21, 0x2e, 0x44, 0x0e, 0x24, 0xbb, 0x0d,
-  0x22, 0x1c, 0x39, 0x42, 0x47, 0x16, 0x33, 0x32, 0x4b, 0x25, 0x8d, 0x46,
-  0x6e, 0x1f, 0x23, 0x16, 0x49, 0x23, 0x74, 0x33, 0xb9, 0x74, 0x52, 0x5d,
-  0x86, 0xda, 0xfe, 0xb9, 0xb0, 0xe1, 0x26, 0x7f, 0x39, 0x88, 0x4b, 0x28,
-  0x56, 0x82, 0x5c, 0x8f, 0x91, 0xb5, 0xd1, 0xbd, 0x93, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x70, 0xff, 0xe7, 0x05, 0xb7, 0x05, 0x2d, 0x00, 0x1a,
-  0x00, 0x29, 0x00, 0x00, 0x25, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
-  0x33, 0x06, 0x07, 0x06, 0x20, 0x24, 0x02, 0x35, 0x34, 0x12, 0x24, 0x33,
-  0x32, 0x04, 0x12, 0x15, 0x21, 0x22, 0x15, 0x35, 0x14, 0x33, 0x21, 0x32,
-  0x35, 0x11, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x01, 0x68,
-  0x3c, 0x54, 0x87, 0x01, 0x29, 0x89, 0x5f, 0x46, 0x63, 0x55, 0x80, 0xa1,
-  0xfe, 0xa1, 0xfe, 0xbf, 0xb3, 0xb5, 0x01, 0x43, 0xac, 0xaa, 0x01, 0x43,
-  0xb5, 0xfb, 0xc3, 0x11, 0x11, 0x03, 0x35, 0x12, 0x3f, 0x56, 0x88, 0x8f,
-  0x90, 0x89, 0x56, 0x3d, 0xe4, 0x4d, 0x33, 0x54, 0x54, 0x3c, 0x60, 0x78,
-  0x47, 0x5a, 0xb3, 0x01, 0x41, 0xaf, 0xb0, 0x01, 0x45, 0xae, 0xae, 0xfe,
-  0xbb, 0xb0, 0x13, 0x49, 0x13, 0x13, 0x01, 0x70, 0x50, 0x33, 0x52, 0x51,
-  0x34, 0x4f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4e, 0xff, 0xe3, 0x03, 0xf0,
-  0x04, 0x44, 0x00, 0x1c, 0x00, 0x25, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x00, 0x33, 0x20, 0x11, 0x14, 0x07,
-  0x06, 0x37, 0x36, 0x35, 0x34, 0x23, 0x22, 0x06, 0x03, 0x20, 0x01, 0x0e,
-  0x04, 0x1f, 0x35, 0x8e, 0x69, 0x33, 0x5c, 0x15, 0x7a, 0x24, 0x86, 0x5e,
-  0xfe, 0x8d, 0x64, 0x46, 0x0e, 0x2c, 0x01, 0x30, 0xd8, 0x01, 0x60, 0xb8,
-  0xbd, 0x61, 0x64, 0xcc, 0x78, 0xa8, 0x33, 0x01, 0x21, 0x01, 0x98, 0x26,
-  0x22, 0x5e, 0x3e, 0x6e, 0x23, 0x3f, 0x51, 0x7f, 0x59, 0x3e, 0x99, 0x6b,
-  0x9b, 0x44, 0x4d, 0xfd, 0x01, 0x34, 0xfe, 0xeb, 0xc7, 0x67, 0x69, 0xe0,
-  0x4d, 0x71, 0xab, 0xcc, 0xfe, 0xed, 0x00, 0x00, 0x00, 0x01, 0x00, 0x91,
-  0xff, 0xe3, 0x04, 0x13, 0x05, 0xf0, 0x00, 0x45, 0x00, 0x00, 0x01, 0x17,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x3f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x17, 0x16, 0x33, 0x15, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x03, 0xbd, 0x55, 0x1c,
-  0x0e, 0xa0, 0xe2, 0x81, 0x5e, 0x62, 0x3e, 0x55, 0x78, 0x62, 0xa1, 0x01,
-  0x61, 0x37, 0x47, 0x59, 0x6f, 0xd9, 0x7a, 0x4c, 0x2e, 0x29, 0x2d, 0x1e,
-  0x25, 0x15, 0x0c, 0x1a, 0x17, 0x21, 0x27, 0x5c, 0x57, 0x3a, 0x57, 0x48,
-  0x2a, 0x51, 0x56, 0x70, 0x9a, 0x6f, 0x6b, 0x34, 0x62, 0x57, 0x51, 0xae,
-  0x74, 0x6a, 0x38, 0x0b, 0x01, 0x49, 0x68, 0x41, 0x11, 0xac, 0x22, 0x25,
-  0x40, 0x5f, 0xa9, 0xae, 0x8a, 0x6c, 0x18, 0x15, 0x24, 0x3d, 0x50, 0x94,
-  0x8b, 0x63, 0x7a, 0x53, 0x32, 0x56, 0x4e, 0x2d, 0x32, 0x16, 0x0e, 0x21,
-  0x1c, 0x24, 0x2b, 0x1f, 0x25, 0x24, 0x2b, 0x40, 0x65, 0x97, 0x7d, 0x4e,
-  0x30, 0x17, 0x1a, 0x36, 0x1e, 0x1d, 0x39, 0x6e, 0x99, 0xa6, 0x61, 0x5b,
-  0x75, 0x3e, 0x5f, 0x00, 0x00, 0x01, 0x00, 0x4b, 0xff, 0xdf, 0x05, 0x76,
-  0x06, 0x0b, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x17, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x11, 0x21, 0x07, 0x23, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x3d,
-  0x01, 0x21, 0x37, 0x21, 0x11, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x1f, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x21, 0x32, 0x17, 0x37, 0x15, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x05, 0x56, 0x20, 0x50, 0x23, 0x34, 0x23, 0x31, 0xcb, 0x39, 0x01, 0x1d,
-  0x37, 0xe6, 0x25, 0x26, 0x46, 0xb2, 0xf1, 0x73, 0x56, 0x2e, 0x1b, 0x18,
-  0x29, 0x1c, 0x0c, 0x10, 0x14, 0x11, 0x18, 0x3c, 0x54, 0x61, 0x6f, 0x38,
-  0x1a, 0x1e, 0xfe, 0xbb, 0x23, 0x01, 0x22, 0x57, 0x38, 0xae, 0x63, 0x40,
-  0x06, 0x12, 0x16, 0x20, 0x17, 0x22, 0x20, 0x1c, 0x6c, 0x96, 0x01, 0x15,
-  0x20, 0x3c, 0x8a, 0xa9, 0x80, 0x2c, 0x13, 0x2c, 0x1d, 0x05, 0xf2, 0x13,
-  0xa3, 0x4b, 0x14, 0x3d, 0x19, 0xfd, 0xdc, 0x44, 0x63, 0x98, 0x84, 0x80,
-  0x4b, 0xca, 0x5f, 0x34, 0x42, 0x28, 0x1f, 0x1a, 0x0b, 0x14, 0x30, 0x33,
-  0x1a, 0x42, 0x7b, 0x3e, 0x63, 0x65, 0x82, 0xb9, 0x44, 0x02, 0x49, 0x18,
-  0x6e, 0x46, 0x54, 0x3d, 0x1f, 0x49, 0x2c, 0x1a, 0x1f, 0x1f, 0x1f, 0x46,
-  0xb4, 0x77, 0xa7, 0x08, 0x37, 0x4b, 0x2e, 0x16, 0x09, 0x30, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xba, 0x05, 0xd5, 0x00, 0x09,
-  0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33,
-  0x03, 0xb9, 0xfc, 0xfc, 0x02, 0x4e, 0xfd, 0xeb, 0x02, 0x15, 0xb6, 0xaa,
-  0x01, 0xb8, 0xaa, 0x02, 0xc9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x33,
-  0xff, 0xc7, 0x07, 0x6f, 0x06, 0x02, 0x00, 0x6b, 0x00, 0x00, 0x01, 0x11,
-  0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x17, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x11, 0x34, 0x02, 0x37, 0x06,
-  0x03, 0x02, 0x03, 0x07, 0x27, 0x02, 0x03, 0x26, 0x27, 0x26, 0x27, 0x11,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x36, 0x35, 0x11,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x33, 0x16, 0x13, 0x12, 0x13, 0x17, 0x12, 0x37, 0x12,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x06, 0x28,
-  0x14, 0x14, 0x27, 0x18, 0x1a, 0x2f, 0x24, 0x2a, 0x23, 0x26, 0x23, 0x3f,
-  0x56, 0x8f, 0x33, 0x32, 0x10, 0x05, 0x07, 0x05, 0x9d, 0x6d, 0x6e, 0x32,
-  0x57, 0x12, 0x35, 0x5c, 0x32, 0x35, 0x38, 0x3f, 0x2e, 0x29, 0x55, 0x48,
-  0x5a, 0x46, 0x3d, 0x26, 0x1a, 0x16, 0x1f, 0x32, 0x1a, 0x19, 0x3a, 0x27,
-  0x60, 0x1e, 0x19, 0x41, 0x5e, 0x40, 0x36, 0x37, 0x12, 0x2a, 0x0e, 0x15,
-  0x19, 0x21, 0x56, 0x6c, 0x81, 0x5f, 0x06, 0x94, 0x65, 0x65, 0x2e, 0x0a,
-  0x4b, 0x71, 0x73, 0x8d, 0x88, 0xa0, 0x3c, 0x23, 0x1a, 0x10, 0x1b, 0x28,
-  0x20, 0x07, 0x14, 0x06, 0x0a, 0x04, 0x16, 0x18, 0x1a, 0x17, 0x26, 0x05,
-  0x1d, 0xfd, 0x35, 0xdc, 0x80, 0x81, 0x2f, 0x16, 0x2c, 0x2c, 0x40, 0x21,
-  0x3b, 0x44, 0x61, 0x39, 0x37, 0x9e, 0x54, 0x02, 0x01, 0x1e, 0x01, 0x91,
-  0x1f, 0xb3, 0xfe, 0xc4, 0xfe, 0xc9, 0xfe, 0x56, 0x4d, 0x0f, 0x01, 0xe6,
-  0x01, 0x3b, 0xa9, 0x6e, 0x77, 0x46, 0xfe, 0x0f, 0xed, 0xbb, 0xb3, 0x5e,
-  0x4f, 0x3f, 0x2f, 0x2c, 0x25, 0x21, 0x18, 0x3b, 0x3e, 0x6a, 0x79, 0x74,
-  0x9f, 0x02, 0xd6, 0x58, 0x3c, 0x3b, 0x7d, 0x03, 0x66, 0x3f, 0x45, 0x27,
-  0x5f, 0x6e, 0xa5, 0xfe, 0xfa, 0xfe, 0xf4, 0xfe, 0xb1, 0x0b, 0x01, 0x48,
-  0xf4, 0x01, 0x02, 0x97, 0x98, 0x27, 0x1d, 0x1d, 0x27, 0x10, 0x23, 0x09,
-  0x16, 0x0d, 0x1d, 0x04, 0x18, 0x16, 0x2e, 0x00, 0x00, 0x02, 0x00, 0x5d,
-  0xff, 0xe7, 0x02, 0xf6, 0x03, 0x29, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x34, 0x26, 0x23, 0x22, 0x02, 0x15, 0x14, 0x16, 0x33, 0x32, 0x12,
-  0x03, 0x32, 0x16, 0x15, 0x14, 0x02, 0x23, 0x22, 0x26, 0x35, 0x34, 0x12,
-  0x02, 0x65, 0x4e, 0x47, 0x63, 0x7f, 0x4e, 0x48, 0x62, 0x7f, 0xaf, 0x89,
-  0xb7, 0xc7, 0x92, 0x89, 0xb6, 0xc6, 0x01, 0xf7, 0x74, 0x7d, 0xfe, 0xfe,
-  0xcf, 0x74, 0x7b, 0x01, 0x04, 0x01, 0xfd, 0xd8, 0xa3, 0xc6, 0xfe, 0xff,
-  0xd8, 0xa3, 0xc6, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5c,
-  0xff, 0xe3, 0x05, 0x21, 0x05, 0xf0, 0x00, 0x34, 0x00, 0x00, 0x09, 0x01,
-  0x16, 0x15, 0x14, 0x07, 0x34, 0x27, 0x01, 0x07, 0x06, 0x1f, 0x01, 0x16,
-  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x26,
-  0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x37, 0x14, 0x17, 0x01, 0x13,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x14, 0x1f, 0x01, 0x16, 0x15, 0x14, 0x07,
-  0x34, 0x2f, 0x01, 0x03, 0x64, 0x01, 0x63, 0x59, 0x81, 0x2d, 0xfd, 0x48,
-  0x8c, 0x37, 0x3b, 0x9b, 0x5a, 0x37, 0x4e, 0x3e, 0xdc, 0xb0, 0x2a, 0x58,
-  0x30, 0x7e, 0x8b, 0xd9, 0x59, 0x81, 0x2d, 0x02, 0x2e, 0xfd, 0x68, 0x59,
-  0x81, 0x2d, 0xa4, 0x59, 0x81, 0x2d, 0x11, 0x02, 0xd0, 0xfe, 0x75, 0x63,
-  0x31, 0x82, 0x4c, 0x53, 0x32, 0x03, 0x05, 0x9c, 0x3f, 0x42, 0xac, 0x64,
-  0xd6, 0x2c, 0x3e, 0x38, 0x3f, 0x5d, 0x1d, 0x2f, 0x63, 0x36, 0xbc, 0x8d,
-  0x9b, 0xf1, 0x63, 0x31, 0x82, 0x4c, 0x53, 0x32, 0xfd, 0x96, 0x01, 0x19,
-  0x74, 0x63, 0x31, 0x82, 0x4c, 0x53, 0x32, 0xb6, 0x63, 0x31, 0x82, 0x4c,
-  0x53, 0x32, 0x12, 0x00, 0x00, 0x01, 0xff, 0xfb, 0xff, 0xe3, 0x04, 0xb4,
-  0x05, 0xf1, 0x00, 0x30, 0x00, 0x00, 0x01, 0x11, 0x33, 0x16, 0x15, 0x14,
-  0x0f, 0x01, 0x0e, 0x01, 0x23, 0x21, 0x22, 0x2e, 0x01, 0x35, 0x34, 0x3f,
-  0x01, 0x3e, 0x01, 0x33, 0x21, 0x11, 0x34, 0x27, 0x2e, 0x01, 0x23, 0x21,
-  0x22, 0x2e, 0x03, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x1e, 0x02,
-  0x33, 0x21, 0x32, 0x16, 0x04, 0x45, 0x47, 0x27, 0x1b, 0x79, 0x0f, 0x12,
-  0x1f, 0xfc, 0x5b, 0x13, 0x16, 0x15, 0x1e, 0x78, 0x0f, 0x12, 0x21, 0x03,
-  0x2a, 0x12, 0x12, 0x22, 0x39, 0xfd, 0xbf, 0x35, 0x30, 0x41, 0x1a, 0x14,
-  0x04, 0x0e, 0x12, 0x17, 0x0b, 0x0a, 0x26, 0x1c, 0x19, 0x02, 0x8e, 0x50,
-  0x52, 0x04, 0xb6, 0xfc, 0x23, 0x04, 0x24, 0x14, 0x1b, 0x87, 0x12, 0x06,
-  0x02, 0x14, 0x12, 0x10, 0x22, 0x86, 0x10, 0x06, 0x03, 0x78, 0x32, 0x0d,
-  0x10, 0x06, 0x04, 0x18, 0x31, 0x5b, 0x47, 0x28, 0x20, 0x14, 0x20, 0x1e,
-  0x1f, 0x04, 0x57, 0x00, 0x00, 0x01, 0x00, 0x18, 0xff, 0xb8, 0x02, 0xee,
-  0x05, 0xf0, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x21, 0x32, 0x17, 0x16, 0x14,
-  0x0e, 0x01, 0x07, 0x1e, 0x01, 0x12, 0x10, 0x07, 0x06, 0x23, 0x22, 0x26,
-  0x2f, 0x01, 0x0e, 0x01, 0x23, 0x21, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x3e,
-  0x01, 0x33, 0x21, 0x11, 0x21, 0x22, 0x26, 0x35, 0x34, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x01, 0x32, 0x01, 0x2e, 0x62, 0x1b, 0x11, 0x0b, 0x2b,
-  0x22, 0x02, 0x02, 0x37, 0x09, 0x16, 0x28, 0x14, 0x10, 0x06, 0x0c, 0x5a,
-  0x10, 0x28, 0xfe, 0x95, 0x3f, 0x1f, 0x78, 0x0f, 0x12, 0x20, 0x01, 0x5e,
-  0xfe, 0xdb, 0x62, 0x40, 0x12, 0x29, 0x0a, 0x15, 0x2a, 0x0e, 0x05, 0x8f,
-  0x37, 0x23, 0x2a, 0x28, 0x2f, 0x0a, 0x1a, 0x82, 0xfd, 0x24, 0xfe, 0xfb,
-  0x22, 0x53, 0x1e, 0x1f, 0x61, 0x65, 0x0e, 0x28, 0x10, 0x21, 0x87, 0x10,
-  0x06, 0x03, 0xcd, 0x71, 0x7e, 0x42, 0x19, 0x1e, 0x3b, 0x06, 0x02, 0x00,
-  0x00, 0x01, 0x00, 0x4d, 0xff, 0xb8, 0x04, 0x41, 0x05, 0xf0, 0x00, 0x26,
-  0x00, 0x00, 0x01, 0x21, 0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32,
-  0x17, 0x1e, 0x02, 0x33, 0x21, 0x32, 0x1e, 0x02, 0x15, 0x14, 0x0e, 0x01,
-  0x07, 0x1e, 0x01, 0x17, 0x12, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26,
-  0x27, 0x26, 0x35, 0x03, 0xa3, 0xfd, 0x4c, 0x62, 0x40, 0x04, 0x0e, 0x12,
-  0x17, 0x0b, 0x0b, 0x25, 0x1c, 0x19, 0x02, 0xbd, 0x2f, 0x40, 0x18, 0x05,
-  0x0b, 0x2b, 0x21, 0x02, 0x01, 0x04, 0x33, 0x09, 0x15, 0x29, 0x15, 0x10,
-  0x0b, 0x0a, 0x04, 0xa6, 0x71, 0x7e, 0x28, 0x1f, 0x14, 0x1f, 0x1e, 0x20,
-  0x04, 0x1f, 0x30, 0x1a, 0x0b, 0x10, 0x28, 0x2f, 0x0a, 0x1a, 0x82, 0x26,
-  0xfd, 0x4a, 0x93, 0x73, 0x21, 0x53, 0x27, 0x44, 0x51, 0x49, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x3f, 0x00, 0x00, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x0b,
-  0x00, 0x15, 0x00, 0x00, 0x13, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x01, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23,
-  0x35, 0x21, 0xa9, 0x65, 0x49, 0x47, 0x64, 0x64, 0x47, 0x49, 0x65, 0x01,
-  0x5d, 0x88, 0xfd, 0xb1, 0x88, 0x88, 0x01, 0xc7, 0x05, 0x54, 0x51, 0x6f,
-  0x6f, 0x51, 0x4f, 0x6f, 0x6e, 0xfb, 0x75, 0x79, 0x79, 0x03, 0x35, 0x79,
-  0x00, 0x02, 0x00, 0x51, 0xff, 0xd5, 0x06, 0x97, 0x05, 0x3b, 0x00, 0x09,
-  0x00, 0x1b, 0x00, 0x00, 0x12, 0x10, 0x00, 0x33, 0x32, 0x00, 0x10, 0x00,
-  0x23, 0x22, 0x05, 0x01, 0x15, 0x07, 0x1e, 0x01, 0x15, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x04, 0xe5, 0x01, 0x27, 0xfe,
-  0xfe, 0x01, 0x28, 0xfe, 0xd8, 0xfe, 0xfe, 0x03, 0x85, 0x01, 0x06, 0xd7,
-  0x01, 0x02, 0xfe, 0x85, 0xfe, 0xc2, 0xfe, 0xc2, 0xfe, 0x85, 0x01, 0x7b,
-  0x01, 0x3e, 0xea, 0x01, 0x4e, 0x03, 0x65, 0xfe, 0x48, 0xfe, 0xfd, 0x01,
-  0x03, 0x01, 0xb8, 0x01, 0x01, 0xc2, 0x01, 0x0a, 0xf4, 0xdd, 0x21, 0x23,
-  0x10, 0xfe, 0xc5, 0xfe, 0x87, 0x01, 0x79, 0x01, 0x3b, 0x01, 0x3a, 0x01,
-  0x78, 0xd1, 0x00, 0x00, 0x00, 0x04, 0x00, 0x87, 0x00, 0x00, 0x08, 0x5e,
-  0x04, 0x60, 0x00, 0x09, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x20, 0x00, 0x00,
-  0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x01, 0x03,
-  0x21, 0x03, 0x33, 0x01, 0x23, 0x27, 0x21, 0x07, 0x23, 0x01, 0x33, 0x1b,
-  0x01, 0x33, 0x09, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x01, 0x88, 0x02, 0x43,
-  0xfe, 0x45, 0x01, 0x8f, 0xfe, 0x71, 0x88, 0x03, 0x29, 0xa3, 0x01, 0x46,
-  0xe6, 0x87, 0x01, 0x52, 0x7c, 0x51, 0xfe, 0x70, 0x51, 0x7e, 0x03, 0x74,
-  0x81, 0xdc, 0xde, 0x81, 0xfe, 0xe3, 0x01, 0x30, 0x82, 0xf9, 0xfb, 0x82,
-  0x01, 0x3d, 0x04, 0x60, 0x80, 0xfe, 0xb6, 0x7f, 0xfd, 0xe9, 0x03, 0x08,
-  0xfe, 0x43, 0x02, 0x35, 0xfc, 0x80, 0xe6, 0xe6, 0x03, 0x80, 0xfe, 0xb3,
-  0x01, 0x4d, 0xfe, 0x52, 0xfe, 0x2e, 0x01, 0x7d, 0xfe, 0x83, 0x01, 0xde,
-  0x00, 0x03, 0x00, 0x20, 0xff, 0xf0, 0x04, 0xee, 0x04, 0x60, 0x00, 0x0f,
-  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x25, 0x35, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x11, 0x23, 0x11, 0x14, 0x16, 0x17, 0x16, 0x32, 0x03, 0x16,
-  0x33, 0x32, 0x37, 0x15, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23,
-  0x11, 0x21, 0x11, 0x23, 0x22, 0x06, 0x15, 0x23, 0x34, 0x36, 0x33, 0x21,
-  0x15, 0x23, 0x11, 0x14, 0x01, 0x33, 0x11, 0x23, 0x04, 0x94, 0x7c, 0x27,
-  0x17, 0x08, 0x0d, 0x79, 0x15, 0x12, 0x33, 0xcb, 0x50, 0x07, 0x61, 0x24,
-  0x41, 0x69, 0x76, 0xe4, 0x26, 0x13, 0x96, 0xfe, 0xd3, 0x37, 0x51, 0x2d,
-  0x5a, 0x67, 0x95, 0x03, 0xa7, 0xa4, 0xfd, 0x6a, 0x79, 0x79, 0x5a, 0x34,
-  0x40, 0x27, 0x21, 0x38, 0xa2, 0x02, 0x0c, 0xfd, 0xd6, 0xa6, 0x7a, 0x19,
-  0x45, 0x01, 0x42, 0xaf, 0x0a, 0xf1, 0x10, 0xca, 0x62, 0xfd, 0x01, 0xe3,
-  0xfc, 0x04, 0x03, 0xfc, 0x4c, 0x73, 0xa8, 0x7b, 0x64, 0xfe, 0x12, 0x59,
-  0xfe, 0xaf, 0x03, 0x98, 0x00, 0x02, 0x00, 0x00, 0xfe, 0x73, 0x04, 0xd1,
-  0x04, 0x7b, 0x00, 0x08, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x16, 0x13, 0x12,
-  0x11, 0x33, 0x10, 0x03, 0x02, 0x03, 0x10, 0x03, 0x02, 0x23, 0x22, 0x07,
-  0x23, 0x34, 0x37, 0x36, 0x33, 0x20, 0x13, 0x12, 0x13, 0x33, 0x02, 0x03,
-  0x02, 0x11, 0x01, 0xa8, 0x9c, 0x4d, 0x3e, 0x75, 0x3e, 0x61, 0x2f, 0x3f,
-  0x7e, 0xb1, 0x98, 0x16, 0x5a, 0x40, 0x49, 0xdc, 0x01, 0x89, 0x7b, 0x63,
-  0x90, 0x75, 0xb7, 0x3c, 0x3f, 0x04, 0x1d, 0xc1, 0xfe, 0x5c, 0xfe, 0xa7,
-  0xfe, 0x78, 0x01, 0x9f, 0x01, 0x42, 0x01, 0xfd, 0xfa, 0xbe, 0x02, 0x1b,
-  0x01, 0x2a, 0x02, 0x57, 0x9f, 0x62, 0x4f, 0x5a, 0xfd, 0x3d, 0x01, 0x9a,
-  0x01, 0x0e, 0xfe, 0x8f, 0xfe, 0xc9, 0xfe, 0xbe, 0xfd, 0xfd, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xac, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x25, 0x15, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0x0e, 0xb6, 0x02, 0xe7, 0xfd, 0x73, 0xfe, 0x96, 0x05,
-  0x71, 0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0x8f, 0x05, 0xd5, 0x00,
-  0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x68, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x01, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x04, 0x58,
-  0xb5, 0xfc, 0x02, 0xb6, 0x03, 0xa2, 0xfe, 0x97, 0xfe, 0x21, 0xfe, 0x96,
-  0x04, 0xb2, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x0d,
-  0xfa, 0x8f, 0x05, 0x71, 0xfa, 0x8f, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x16,
-  0xfe, 0x77, 0x05, 0xb2, 0x05, 0xc1, 0x00, 0x05, 0x00, 0x11, 0x00, 0x00,
-  0x09, 0x02, 0x23, 0x09, 0x02, 0x15, 0x21, 0x09, 0x01, 0x21, 0x15, 0x21,
-  0x35, 0x09, 0x01, 0x35, 0x01, 0x7c, 0x02, 0xc1, 0xfd, 0x53, 0xea, 0x02,
-  0xad, 0xfd, 0x3f, 0x05, 0x08, 0xfc, 0x7d, 0x02, 0xad, 0xfd, 0x3f, 0x03,
-  0xae, 0xfa, 0x65, 0x02, 0xba, 0xfd, 0x62, 0xfe, 0xda, 0x03, 0x59, 0x03,
-  0x2a, 0xfc, 0xd6, 0xfc, 0xa7, 0x06, 0xe7, 0x64, 0xfc, 0xd6, 0xfc, 0xa7,
-  0x63, 0x63, 0x03, 0x53, 0x03, 0x15, 0x7f, 0x00, 0x00, 0x01, 0x00, 0x92,
-  0xff, 0xe3, 0x05, 0x29, 0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10,
-  0x02, 0x23, 0x22, 0x06, 0x01, 0x47, 0x01, 0x29, 0xfe, 0x23, 0x69, 0xfe,
-  0x90, 0x01, 0x3b, 0x01, 0x63, 0xfe, 0x9d, 0xfe, 0xc5, 0x84, 0xec, 0x64,
-  0x65, 0xe2, 0x7d, 0xf7, 0xf8, 0xf8, 0xf7, 0x60, 0x97, 0x04, 0xfe, 0xfe,
-  0x6f, 0xa6, 0x02, 0x81, 0x53, 0x55, 0xfe, 0x67, 0xfe, 0x93, 0xfe, 0x92,
-  0xfe, 0x67, 0x48, 0x46, 0xd7, 0x5f, 0x60, 0x01, 0x32, 0x01, 0x2f, 0x01,
-  0x2e, 0x01, 0x32, 0x25, 0x00, 0x01, 0x00, 0x07, 0x00, 0x00, 0x03, 0x4c,
-  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x35, 0x21,
-  0x03, 0x4b, 0xb5, 0xfd, 0x71, 0x03, 0x44, 0x05, 0x2b, 0xaa, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x06, 0x00, 0x00, 0x03, 0x4b, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x03, 0x4a, 0xfc, 0xbc,
-  0x02, 0x8f, 0x05, 0xd5, 0xfa, 0x2b, 0xaa, 0x05, 0x2b, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x00, 0x21, 0x23, 0x09, 0x01, 0x23, 0x01, 0x11, 0x33, 0x11, 0x04,
-  0x6a, 0xc4, 0xfe, 0x8c, 0xfe, 0x8e, 0xc4, 0x01, 0xdc, 0xb6, 0x02, 0x66,
-  0xfd, 0x9a, 0x03, 0x0e, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x04, 0x00, 0x4e,
-  0x00, 0x00, 0x05, 0xa9, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x13, 0x00, 0x17,
-  0x00, 0x22, 0x00, 0x00, 0x01, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x02,
-  0x00, 0x29, 0x01, 0x01, 0x05, 0x03, 0x33, 0x32, 0x37, 0x13, 0x26, 0x23,
-  0x21, 0x03, 0x33, 0x13, 0x05, 0x03, 0x36, 0x37, 0x36, 0x13, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x03, 0x23, 0x01, 0x86, 0x98, 0x68, 0x15, 0x43, 0xfe,
-  0x52, 0xfe, 0x7b, 0xfe, 0x30, 0x01, 0x05, 0x01, 0x59, 0xe2, 0x59, 0xdd,
-  0x9b, 0xcc, 0x85, 0xdd, 0xfe, 0x97, 0xe2, 0xb6, 0xe2, 0x02, 0x6a, 0xb8,
-  0x18, 0x17, 0xbb, 0x3a, 0x12, 0x5c, 0x10, 0x05, 0xd5, 0xb5, 0x7c, 0xdf,
-  0x63, 0x76, 0xfe, 0x7e, 0xfe, 0x96, 0x05, 0xd5, 0x64, 0xfa, 0xf3, 0x41,
-  0x04, 0x8b, 0x41, 0xfa, 0xf3, 0x05, 0x0d, 0x78, 0xfb, 0xe3, 0x10, 0x13,
-  0x9d, 0x01, 0x50, 0x66, 0x55, 0xc2, 0x6d, 0x13, 0x00, 0x04, 0x00, 0x51,
-  0xff, 0xe3, 0x05, 0x1c, 0x06, 0x14, 0x00, 0x0a, 0x00, 0x1f, 0x00, 0x23,
-  0x00, 0x32, 0x00, 0x00, 0x13, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x13,
-  0x06, 0x07, 0x06, 0x01, 0x21, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22, 0x02,
-  0x35, 0x34, 0x37, 0x36, 0x00, 0x33, 0x32, 0x17, 0x16, 0x17, 0x13, 0x21,
-  0x07, 0x03, 0x33, 0x13, 0x01, 0x03, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0xd0, 0x1c, 0x26, 0x1d, 0x30,
-  0x9e, 0x3c, 0x32, 0x6b, 0x03, 0x1f, 0xfe, 0xd3, 0x1e, 0x46, 0x58, 0x58,
-  0x70, 0xb7, 0x8e, 0x1f, 0x1f, 0x01, 0x1e, 0xb7, 0x70, 0x47, 0x47, 0x23,
-  0x6a, 0x01, 0x2d, 0xe5, 0xee, 0x78, 0xef, 0xfd, 0x7a, 0xab, 0x16, 0x17,
-  0x95, 0x6b, 0x6c, 0x1c, 0x1c, 0x33, 0x31, 0x95, 0x17, 0x02, 0x74, 0x9e,
-  0x4b, 0x73, 0x4f, 0x3d, 0x20, 0x03, 0x86, 0x20, 0x3d, 0x82, 0xfc, 0xed,
-  0xa8, 0x64, 0x30, 0x31, 0x01, 0x0c, 0x94, 0x50, 0xb2, 0xb2, 0x01, 0x44,
-  0x31, 0x30, 0x64, 0x02, 0x5e, 0x64, 0xfa, 0xac, 0x05, 0x54, 0xfe, 0x64,
-  0xfc, 0x36, 0x03, 0x82, 0x82, 0x9f, 0x9e, 0x4a, 0x74, 0x68, 0x69, 0x00,
-  0x00, 0x03, 0x00, 0x51, 0xff, 0xe3, 0x04, 0x1e, 0x04, 0x7b, 0x00, 0x0a,
-  0x00, 0x28, 0x00, 0x32, 0x00, 0x00, 0x13, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x17, 0x13, 0x06, 0x07, 0x06, 0x13, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x12,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x0f, 0x01, 0x21, 0x37,
-  0x21, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0xc4, 0x0b, 0x47,
-  0x13, 0x1b, 0x91, 0x22, 0x1f, 0x90, 0x97, 0x40, 0x55, 0x6d, 0x72, 0x51,
-  0x53, 0x15, 0x60, 0x61, 0x62, 0x60, 0xf2, 0x70, 0x51, 0x0d, 0x30, 0xa3,
-  0xa1, 0xe3, 0xcd, 0x5c, 0x3f, 0x0e, 0x11, 0xfd, 0xce, 0x12, 0x01, 0xcd,
-  0x0a, 0x34, 0x46, 0x98, 0x43, 0x3c, 0x02, 0x30, 0x3c, 0x37, 0x8d, 0x68,
-  0x1d, 0x16, 0x03, 0x3a, 0x15, 0x1c, 0x82, 0xfd, 0x4a, 0x15, 0x1f, 0x16,
-  0x28, 0x75, 0x2a, 0x16, 0x16, 0x9c, 0x6f, 0xa6, 0x44, 0x4d, 0x01, 0x13,
-  0xa2, 0xa1, 0x91, 0x63, 0x93, 0x46, 0x50, 0x5a, 0x64, 0x38, 0x32, 0x76,
-  0x52, 0x73, 0x11, 0x00, 0x00, 0x03, 0x00, 0x47, 0x00, 0x00, 0x02, 0x41,
-  0x06, 0x14, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33,
-  0x07, 0x23, 0x03, 0x33, 0x13, 0x23, 0x13, 0x21, 0x13, 0x21, 0x01, 0x9b,
-  0xa6, 0x29, 0xa6, 0xbf, 0x79, 0xa0, 0x79, 0x21, 0xfe, 0xd3, 0xc4, 0x01,
-  0x2d, 0x06, 0x14, 0xe9, 0xfb, 0x39, 0x03, 0x98, 0xfc, 0x04, 0x04, 0x60,
-  0x00, 0x03, 0xff, 0x2d, 0xfe, 0x56, 0x02, 0x41, 0x06, 0x14, 0x00, 0x03,
-  0x00, 0x0c, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x33, 0x07, 0x23, 0x03, 0x13,
-  0x23, 0x03, 0x06, 0x07, 0x36, 0x37, 0x36, 0x05, 0x23, 0x37, 0x33, 0x32,
-  0x37, 0x36, 0x37, 0x13, 0x21, 0x03, 0x06, 0x07, 0x06, 0x01, 0x9b, 0xa6,
-  0x29, 0xa6, 0x5c, 0xb6, 0x79, 0xbb, 0x1f, 0x30, 0x41, 0x2d, 0x43, 0xfe,
-  0xf9, 0xc6, 0x12, 0x2d, 0x5e, 0x2b, 0x2b, 0x1a, 0xd1, 0x01, 0x2d, 0xc8,
-  0x25, 0x5a, 0x5b, 0x06, 0x14, 0xe9, 0xfa, 0xbf, 0x04, 0x12, 0xfb, 0xd0,
-  0xb5, 0x54, 0x0f, 0x30, 0x48, 0xf4, 0x64, 0x30, 0x31, 0x99, 0x04, 0xac,
-  0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x35,
-  0xff, 0xe3, 0x05, 0x26, 0x05, 0xf0, 0x00, 0x26, 0x00, 0x30, 0x00, 0x00,
-  0x09, 0x01, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x12, 0x37, 0x03, 0x33, 0x17,
-  0x3e, 0x01, 0x33, 0x32, 0x00, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x03, 0x5b, 0xfe, 0x36, 0x35, 0x40, 0xa8, 0x68, 0x54, 0xfb, 0xe3,
-  0x81, 0x5d, 0xcd, 0x76, 0xd9, 0x01, 0x14, 0x79, 0x79, 0x2c, 0x2d, 0xc8,
-  0xa6, 0x4b, 0x94, 0x4c, 0x4e, 0x8e, 0x3d, 0x5f, 0x76, 0x36, 0x2e, 0x51,
-  0x4d, 0xbf, 0x90, 0x55, 0x96, 0x42, 0x02, 0x40, 0x02, 0x08, 0x59, 0xcb,
-  0x72, 0x84, 0x01, 0x02, 0x7e, 0x01, 0x1f, 0x95, 0x59, 0x57, 0xfe, 0xed,
-  0xd7, 0x80, 0xe1, 0x63, 0x3f, 0x7d, 0x3c, 0xa2, 0xc5, 0x24, 0x24, 0xb6,
-  0x2f, 0x31, 0x6f, 0x58, 0x33, 0x67, 0xce, 0x51, 0xa1, 0x58, 0x92, 0xc2,
-  0x3f, 0x40, 0x00, 0x00, 0x00, 0x01, 0x00, 0x48, 0x00, 0x00, 0x03, 0x2e,
-  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x03, 0x2e, 0xfd, 0x1b, 0x02, 0x3f, 0xfe, 0x3a,
-  0x01, 0xc6, 0x04, 0x60, 0xfb, 0xa0, 0x93, 0x01, 0x6f, 0x93, 0x01, 0xcb,
-  0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0xa4, 0x05, 0xf0, 0x10, 0x27,
-  0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0xa5, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
-  0xff, 0xe3, 0x06, 0xb6, 0x05, 0xf0, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3,
-  0x00, 0x00, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa7,
-  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x09, 0x9d,
-  0x05, 0xf0, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x26,
-  0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x7b, 0x04, 0x17, 0xfd, 0x64,
-  0x10, 0x07, 0x07, 0xa0, 0x06, 0xfa, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
-  0xff, 0xe3, 0x06, 0x9c, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
-  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x00, 0x75,
-  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x54, 0xff, 0xe3, 0x06, 0x9c,
-  0x05, 0xf0, 0x10, 0x26, 0x00, 0x74, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
-  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x00, 0x75, 0x04, 0x17, 0xfd, 0x64,
-  0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0xa2, 0x05, 0xf0, 0x10, 0x26,
-  0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0xa3, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x54,
-  0xff, 0xe3, 0x06, 0xa2, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x74, 0x00, 0x00,
-  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa3,
-  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x58, 0xff, 0xe3, 0x06, 0xa2,
-  0x05, 0xf0, 0x10, 0x26, 0x00, 0x75, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
-  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa3, 0x04, 0x17, 0xfd, 0x64,
-  0xff, 0xff, 0x00, 0x38, 0xff, 0xe3, 0x06, 0xa2, 0x05, 0xf0, 0x10, 0x26,
-  0x07, 0xa2, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0xa3, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
-  0xff, 0xe3, 0x06, 0xbf, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
-  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa4,
-  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x5b, 0xff, 0xe3, 0x06, 0xbf,
-  0x05, 0xf0, 0x10, 0x26, 0x07, 0xa3, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
-  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa4, 0x04, 0x17, 0xfd, 0x64,
-  0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0xb8, 0x05, 0xf0, 0x10, 0x26,
-  0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0xa6, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x58,
-  0xff, 0xe3, 0x06, 0xb8, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x75, 0x00, 0x00,
-  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa6,
-  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x5b, 0xff, 0xe3, 0x06, 0xb8,
-  0x05, 0xf0, 0x10, 0x26, 0x07, 0xa3, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
-  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa6, 0x04, 0x17, 0xfd, 0x64,
-  0xff, 0xff, 0x00, 0x61, 0xff, 0xe3, 0x06, 0xb8, 0x05, 0xf0, 0x10, 0x26,
-  0x07, 0xa5, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0xa6, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
-  0xff, 0xe3, 0x05, 0x69, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
-  0x10, 0x07, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x01, 0x6b, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x2c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x02, 0xd7, 0x05, 0xd5, 0x10, 0x26,
-  0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x01, 0x6c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x42, 0x05, 0xd5, 0x10, 0x26,
-  0x00, 0x2c, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c, 0x01, 0x6c, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x2c, 0x02, 0xd7, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x06, 0x96, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x2c, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x39, 0x01, 0xb8, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x39, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x05, 0xf0, 0x05, 0xd5, 0x10, 0x26,
-  0x00, 0x39, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x04, 0x84, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x07, 0x5b, 0x05, 0xd5, 0x10, 0x26,
-  0x00, 0x39, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c, 0x04, 0x84, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x2c, 0x05, 0xf0, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x08, 0xc7, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x39, 0x00, 0x00,
-  0x10, 0x27, 0x00, 0x2c, 0x04, 0x84, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c,
-  0x05, 0xf0, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x07, 0x5c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x06, 0x62, 0x05, 0xd5, 0x10, 0x26,
-  0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x00, 0x3b, 0x01, 0xac, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x06, 0x03,
-  0x05, 0xd5, 0x10, 0x26, 0x00, 0x3b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c,
-  0x04, 0x98, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x07, 0x6f,
-  0x05, 0xd5, 0x10, 0x26, 0x00, 0x3b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c,
-  0x04, 0x98, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x06, 0x04, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4,
-  0x05, 0xf0, 0x10, 0x06, 0x00, 0x26, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54,
-  0x06, 0x14, 0x10, 0x06, 0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0x00, 0x00, 0x02, 0x9f, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x4c, 0x01, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0x00, 0x00, 0x03, 0xea, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
-  0x10, 0x27, 0x00, 0x4c, 0x01, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x4c,
-  0x02, 0x96, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x05, 0xa1,
-  0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00, 0x10, 0x07, 0x00, 0x59,
-  0x01, 0x95, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
-  0x04, 0x60, 0x10, 0x06, 0x00, 0x59, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36,
-  0x00, 0x00, 0x05, 0x2b, 0x06, 0x14, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x4c, 0x03, 0xd7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36,
-  0x00, 0x00, 0x06, 0x76, 0x06, 0x14, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00,
-  0x10, 0x27, 0x00, 0x4c, 0x03, 0xd7, 0x00, 0x00, 0x10, 0x07, 0x00, 0x4c,
-  0x05, 0x22, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x07, 0xc1,
-  0x06, 0x14, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00, 0x10, 0x27, 0x00, 0x4c,
-  0x03, 0xd7, 0x00, 0x00, 0x10, 0x27, 0x00, 0x4c, 0x05, 0x22, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x4c, 0x06, 0x6d, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0x00, 0x00, 0x05, 0xa9, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x5b, 0x01, 0xa2, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35,
-  0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x10, 0x06, 0x00, 0x5b, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x05, 0x3f, 0x06, 0x14, 0x10, 0x26,
-  0x00, 0x5b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x4c, 0x03, 0xec, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x06, 0x8a, 0x06, 0x14, 0x10, 0x26,
-  0x00, 0x5b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x4c, 0x03, 0xec, 0x00, 0x00,
-  0x10, 0x07, 0x00, 0x4c, 0x05, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
-  0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x10, 0x06, 0x00, 0x4f, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x10, 0x06,
-  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xeb,
-  0x06, 0x14, 0x10, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x06, 0x67, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x50, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x6c, 0x00, 0x00, 0x08, 0x8b, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x16, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x29, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x01, 0x33, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x23, 0x03, 0x11, 0x23, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x05, 0x96, 0x01, 0x87, 0x01, 0x6d, 0xfe, 0x91, 0xfe, 0x7b,
-  0xfd, 0xcb, 0xfe, 0x7b, 0xfe, 0x91, 0x01, 0x6d, 0x01, 0x87, 0x01, 0x75,
-  0xdc, 0x01, 0x16, 0x01, 0x02, 0xfe, 0xfe, 0xfe, 0xea, 0xdc, 0xb5, 0xdc,
-  0xfe, 0xea, 0xfe, 0xfe, 0x01, 0x02, 0x01, 0x16, 0x05, 0xd5, 0xfe, 0x97,
-  0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x01, 0x6a, 0x01, 0x82, 0x01, 0x80,
-  0x01, 0x69, 0xfa, 0xd1, 0x01, 0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17,
-  0xfb, 0x77, 0x04, 0x89, 0xfe, 0xe9, 0xfe, 0xd4, 0xfe, 0xd2, 0xfe, 0xe8,
-  0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x01, 0x15, 0x33, 0x20, 0x00, 0x11,
-  0x10, 0x00, 0x21, 0x23, 0x15, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
-  0x03, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x01, 0x6b, 0xdb, 0x01, 0x16, 0x01,
-  0x03, 0xfe, 0xfd, 0xfe, 0xea, 0xdb, 0x41, 0xe6, 0xd8, 0xd9, 0xe5, 0x41,
-  0x46, 0x8f, 0x84, 0x84, 0x8f, 0xfc, 0x01, 0x75, 0x01, 0x87, 0x01, 0x6d,
-  0xfe, 0x91, 0xfe, 0x7b, 0xfe, 0x8b, 0x01, 0x59, 0xb3, 0x01, 0x18, 0x01,
-  0x2e, 0x01, 0x2c, 0x01, 0x17, 0xb2, 0xc2, 0xcf, 0xd0, 0xc3, 0x02, 0x9e,
-  0xfd, 0xe8, 0x81, 0x8c, 0x8a, 0x81, 0x01, 0xde, 0xfe, 0x97, 0xfe, 0x80,
-  0xfe, 0x7e, 0xfe, 0x96, 0x00, 0x05, 0x00, 0x6c, 0x00, 0x00, 0x08, 0x8b,
-  0x05, 0xd5, 0x00, 0x11, 0x00, 0x1a, 0x00, 0x28, 0x00, 0x31, 0x00, 0x43,
-  0x00, 0x00, 0x01, 0x15, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01,
-  0x15, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x03, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x2b, 0x01, 0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x29, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00, 0x01, 0x11, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x13, 0x35, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x33, 0x35, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x04, 0xd6,
-  0x41, 0xe7, 0xd8, 0xd9, 0xe6, 0x41, 0xdc, 0x01, 0x16, 0x01, 0x02, 0xfe,
-  0xfe, 0xfe, 0xea, 0xdc, 0x47, 0x8f, 0x84, 0x84, 0x8f, 0x47, 0xc0, 0xfd,
-  0xcb, 0xfe, 0x7b, 0xfe, 0x91, 0x01, 0x6d, 0x01, 0x87, 0x02, 0x35, 0x01,
-  0x87, 0x01, 0x6d, 0xfe, 0x91, 0xfd, 0x06, 0x47, 0x8f, 0x84, 0x84, 0x8f,
-  0x47, 0xdc, 0xfe, 0xea, 0xfe, 0xfe, 0x01, 0x02, 0x01, 0x16, 0xdc, 0x41,
-  0xe6, 0xd9, 0xd8, 0xe7, 0x05, 0x2f, 0xb2, 0xc2, 0xcf, 0xd0, 0xc3, 0xb3,
-  0x01, 0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17, 0xfc, 0xb0, 0x81, 0x8c,
-  0x8a, 0x81, 0xfc, 0x09, 0x01, 0x6a, 0x01, 0x82, 0x01, 0x80, 0x01, 0x69,
-  0xfe, 0x97, 0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x01, 0xdf, 0x02, 0x18,
-  0x81, 0x8a, 0x8c, 0x81, 0x02, 0x9e, 0xb2, 0xfe, 0xe9, 0xfe, 0xd4, 0xfe,
-  0xd2, 0xfe, 0xe8, 0xb3, 0xc3, 0xd0, 0xcf, 0xc2, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x10, 0x06, 0x01, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90, 0x04, 0x7b, 0x10, 0x06,
-  0x02, 0x16, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67, 0xfe, 0x56, 0x04, 0xa4,
-  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36, 0x37, 0x11, 0x23, 0x11, 0x06,
-  0x07, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x04,
-  0xa3, 0x5c, 0xd0, 0x75, 0xe6, 0xf5, 0xf5, 0xe6, 0x75, 0xd0, 0x5c, 0xb5,
-  0x0a, 0x0b, 0x6b, 0x76, 0xfe, 0xce, 0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x32,
-  0x78, 0xd6, 0x05, 0x62, 0xd5, 0x5f, 0x5e, 0xfe, 0xc7, 0xfe, 0xd8, 0xfe,
-  0xd9, 0xfe, 0xc7, 0x5e, 0x5f, 0xfd, 0x10, 0x01, 0xb9, 0x04, 0x04, 0x24,
-  0x01, 0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f, 0x47, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x4e, 0xff, 0xe3, 0x06, 0x9c, 0x05, 0xf0, 0x10, 0x27,
-  0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x27, 0x00, 0x75, 0x04, 0x17,
-  0xfd, 0x64, 0x10, 0x06, 0x07, 0xa0, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x13, 0x35,
-  0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c,
-  0xd2, 0x04, 0x49, 0xfb, 0xb7, 0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89,
-  0x78, 0xe9, 0xaa, 0xe9, 0x78, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x79,
-  0x00, 0x00, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x09, 0x00, 0x00, 0x01, 0x33,
-  0x01, 0x07, 0x27, 0x11, 0x23, 0x11, 0x07, 0x27, 0x02, 0xdc, 0x51, 0x01,
-  0x61, 0x6c, 0xd1, 0x99, 0xd3, 0x6c, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea,
-  0xfb, 0x3c, 0x04, 0xc4, 0xea, 0x78, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x01, 0x15,
-  0x01, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x05, 0xae, 0xfe, 0x9f,
-  0x6c, 0xd1, 0xfb, 0xb7, 0x04, 0x49, 0xd1, 0x6c, 0x02, 0xaf, 0x5a, 0xfe,
-  0x77, 0x78, 0xe9, 0xaa, 0xe9, 0x78, 0x00, 0x00, 0x00, 0x01, 0x01, 0x79,
-  0xff, 0xf9, 0x04, 0x8e, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x05, 0x23,
-  0x01, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x03, 0x2d, 0x51, 0xfe,
-  0x9d, 0x6c, 0xd3, 0x99, 0xd1, 0x6c, 0x07, 0x01, 0x8a, 0x78, 0xea, 0x04,
-  0xc4, 0xfb, 0x3c, 0xea, 0x78, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x35,
-  0x01, 0x17, 0x07, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
-  0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x03, 0x5c, 0xd1, 0x6c, 0x01,
-  0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfc, 0xa4, 0xd2, 0x6c, 0x02, 0x55, 0x5a,
-  0x01, 0x89, 0x78, 0xe9, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78,
-  0xe9, 0xe9, 0x78, 0x00, 0x00, 0x01, 0x01, 0x79, 0xff, 0xef, 0x04, 0x8e,
-  0x05, 0xdc, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11,
-  0x37, 0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x11, 0x07, 0x27, 0x02, 0xdc,
-  0x51, 0x01, 0x61, 0x6c, 0xd1, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9d,
-  0x6c, 0xd3, 0xd3, 0x6c, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea, 0xfc, 0x43,
-  0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0xea, 0x03, 0xbd, 0xea, 0x78,
-  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x37, 0x21, 0x15, 0x21, 0x01, 0x07, 0x01, 0x11, 0x23,
-  0x01, 0x03, 0x39, 0x01, 0xf4, 0xfe, 0xd7, 0x03, 0x08, 0x6c, 0xfc, 0xf8,
-  0x98, 0x04, 0x74, 0x3f, 0xa9, 0xfc, 0xa2, 0x78, 0x03, 0x5e, 0xfe, 0xb6,
-  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x17, 0x11, 0x23, 0x11, 0x01, 0x27, 0x01, 0x21, 0x35,
-  0x04, 0xd6, 0x39, 0x98, 0xfc, 0xf8, 0x6c, 0x03, 0x08, 0xfe, 0xd7, 0x04,
-  0xb3, 0x3f, 0xfd, 0xd4, 0x01, 0x4a, 0xfc, 0xa2, 0x78, 0x03, 0x5e, 0xa9,
-  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
-  0x00, 0x00, 0x25, 0x07, 0x21, 0x35, 0x21, 0x01, 0x37, 0x01, 0x11, 0x33,
-  0x05, 0x0f, 0x39, 0xfe, 0x0c, 0x01, 0x29, 0xfc, 0xf8, 0x6c, 0x03, 0x08,
-  0x98, 0x73, 0x3f, 0xa9, 0x03, 0x5e, 0x78, 0xfc, 0xa2, 0x01, 0x4a, 0x00,
-  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
-  0x00, 0x00, 0x25, 0x27, 0x11, 0x33, 0x11, 0x01, 0x17, 0x01, 0x21, 0x15,
-  0x01, 0x3c, 0x39, 0x98, 0x03, 0x08, 0x6c, 0xfc, 0xf8, 0x01, 0x29, 0x34,
-  0x3f, 0x02, 0x2c, 0xfe, 0xb6, 0x03, 0x5e, 0x78, 0xfc, 0xa2, 0xa9, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x11,
-  0x00, 0x00, 0x01, 0x03, 0x27, 0x13, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01,
-  0x17, 0x07, 0x21, 0x13, 0x17, 0x03, 0x21, 0x15, 0x03, 0xd5, 0xb4, 0x85,
-  0x88, 0xfe, 0x32, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x02,
-  0x27, 0xb4, 0x85, 0x88, 0x01, 0x71, 0x02, 0x2d, 0xfe, 0xa5, 0x55, 0x01,
-  0x06, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x5b,
-  0x55, 0xfe, 0xfa, 0xaa, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x11, 0x00, 0x00, 0x01, 0x13, 0x17, 0x03, 0x21, 0x27,
-  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x03, 0x27, 0x13, 0x21, 0x35,
-  0x02, 0x33, 0xb4, 0x86, 0x88, 0x01, 0xcd, 0xd1, 0x6c, 0x01, 0x61, 0xfe,
-  0x9f, 0x6c, 0xd1, 0xfd, 0xda, 0xb4, 0x86, 0x88, 0xfe, 0x8f, 0x02, 0xd7,
-  0x01, 0x5b, 0x55, 0xfe, 0xfa, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77,
-  0x78, 0xe9, 0xfe, 0xa5, 0x55, 0x01, 0x06, 0xaa, 0x00, 0x01, 0x00, 0x27,
-  0x00, 0xd3, 0x05, 0xf5, 0x03, 0x50, 0x00, 0x34, 0x00, 0x00, 0x01, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x11, 0x23, 0x11, 0x37,
-  0x21, 0x15, 0x05, 0x01, 0xbc, 0x1f, 0x2b, 0x24, 0x33, 0x2f, 0x28, 0x2b,
-  0x3f, 0x13, 0x1f, 0x36, 0x35, 0x46, 0x43, 0x4f, 0x52, 0x40, 0x49, 0x32,
-  0x36, 0x1f, 0x8e, 0x13, 0x1f, 0x1e, 0x2d, 0x25, 0x32, 0x30, 0x27, 0x2b,
-  0x20, 0x20, 0x13, 0x1b, 0x39, 0x2d, 0x4e, 0x40, 0x52, 0x4f, 0x43, 0x46,
-  0x35, 0x90, 0x98, 0x38, 0x01, 0xf5, 0xfe, 0xd7, 0x01, 0xf4, 0x21, 0x15,
-  0x13, 0x13, 0x15, 0x46, 0x30, 0x4f, 0x3c, 0x3a, 0x22, 0x20, 0x20, 0x25,
-  0x37, 0x3c, 0x4f, 0x41, 0x30, 0x23, 0x21, 0x17, 0x13, 0x13, 0x14, 0x24,
-  0x23, 0x30, 0x49, 0x42, 0x35, 0x27, 0x20, 0x20, 0x22, 0x3a, 0xa0, 0xfe,
-  0xb6, 0x02, 0x2c, 0x3f, 0xa9, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x13,
-  0x00, 0xd3, 0x05, 0xe1, 0x03, 0x50, 0x00, 0x34, 0x00, 0x00, 0x01, 0x37,
-  0x25, 0x35, 0x21, 0x17, 0x11, 0x23, 0x11, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x04, 0x4d, 0x90, 0xfe, 0xd7, 0x01, 0xf4, 0x39, 0x98,
-  0x90, 0x35, 0x47, 0x42, 0x4f, 0x52, 0x40, 0x4e, 0x2e, 0x38, 0x1c, 0x13,
-  0x1f, 0x21, 0x2a, 0x28, 0x2f, 0x33, 0x25, 0x2d, 0x1d, 0x20, 0x13, 0x8d,
-  0x1e, 0x36, 0x32, 0x4a, 0x40, 0x52, 0x4f, 0x42, 0x47, 0x35, 0x36, 0x1e,
-  0x13, 0x3f, 0x2b, 0x28, 0x30, 0x32, 0x25, 0x2a, 0x01, 0xf4, 0xa0, 0x01,
-  0xa9, 0x3f, 0xfd, 0xd4, 0x01, 0x4a, 0xa0, 0x3a, 0x22, 0x20, 0x20, 0x27,
-  0x35, 0x42, 0x49, 0x30, 0x23, 0x24, 0x14, 0x13, 0x13, 0x17, 0x21, 0x23,
-  0x30, 0x41, 0x4f, 0x3c, 0x37, 0x25, 0x20, 0x20, 0x22, 0x3a, 0x3c, 0x4f,
-  0x30, 0x46, 0x15, 0x13, 0x13, 0x15, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x11, 0x00, 0x00, 0x13, 0x01,
-  0x17, 0x07, 0x33, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01,
-  0x23, 0x17, 0x07, 0x01, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0xd8, 0x01, 0x3e,
-  0x6c, 0xd2, 0x02, 0x99, 0xfd, 0x67, 0xd2, 0x6c, 0xfe, 0xc2, 0xd8, 0xd2,
-  0x6c, 0xfe, 0x9e, 0x02, 0xaf, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x61, 0x78,
-  0xe9, 0xaa, 0xe9, 0x78, 0x01, 0x61, 0xe9, 0x78, 0x01, 0x89, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x90, 0x05, 0xdc, 0x00, 0x11,
-  0x00, 0x00, 0x09, 0x01, 0x07, 0x27, 0x15, 0x01, 0x07, 0x27, 0x11, 0x23,
-  0x11, 0x07, 0x27, 0x01, 0x35, 0x07, 0x27, 0x01, 0x03, 0x2d, 0x01, 0x62,
-  0x6c, 0xd2, 0x01, 0x3e, 0x6c, 0xd2, 0x99, 0xd1, 0x6c, 0x01, 0x3d, 0xd1,
-  0x6c, 0x01, 0x61, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea, 0xf0, 0xfe, 0x9e,
-  0x78, 0xea, 0xfd, 0x1c, 0x02, 0xe4, 0xea, 0x78, 0x01, 0x62, 0xf0, 0xea,
-  0x78, 0x01, 0x8a, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x23, 0x01,
-  0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x33, 0x27, 0x37, 0x01,
-  0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xd8, 0xfe, 0xc3, 0x6c, 0xd1, 0xfd,
-  0x67, 0x02, 0x99, 0xd1, 0x6c, 0x01, 0x3d, 0xd8, 0xd1, 0x6c, 0x01, 0x61,
-  0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0xfe, 0x9f, 0x78, 0xe9, 0xaa, 0xe9,
-  0x78, 0xfe, 0x9f, 0xe9, 0x78, 0xfe, 0x77, 0x00, 0x00, 0x01, 0x01, 0x7a,
-  0xff, 0xf9, 0x04, 0x90, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x05, 0x01,
-  0x37, 0x17, 0x35, 0x01, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01,
-  0x15, 0x37, 0x17, 0x01, 0x02, 0xde, 0xfe, 0x9d, 0x6c, 0xd3, 0xfe, 0xc1,
-  0x6c, 0xd3, 0x98, 0xd1, 0x6c, 0xfe, 0xc3, 0xd1, 0x6c, 0xfe, 0x9f, 0x07,
-  0x01, 0x8a, 0x78, 0xea, 0xf0, 0x01, 0x62, 0x78, 0xea, 0x02, 0xe4, 0xfd,
-  0x1c, 0xea, 0x78, 0xfe, 0x9e, 0xf0, 0xea, 0x78, 0xfe, 0x76, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0e,
-  0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21, 0x01, 0x17, 0x09, 0x01,
-  0x07, 0x01, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x02, 0x9f,
-  0x01, 0x3e, 0x6c, 0xfe, 0xe2, 0x01, 0x1e, 0x6c, 0xfe, 0xc2, 0xfd, 0x61,
-  0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x61, 0x78,
-  0xfe, 0xc2, 0xfe, 0xc2, 0x78, 0x01, 0x61, 0xe9, 0x78, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0e,
-  0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x01, 0x27, 0x09, 0x01, 0x37,
-  0x01, 0x21, 0x27, 0x37, 0x01, 0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfd,
-  0x61, 0xfe, 0xc2, 0x6c, 0x01, 0x1f, 0xfe, 0xe1, 0x6c, 0x01, 0x3e, 0x02,
-  0x9f, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0xfe,
-  0x9f, 0x78, 0x01, 0x3e, 0x01, 0x3e, 0x78, 0xfe, 0x9f, 0xe9, 0x78, 0xfe,
-  0x77, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0,
-  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x17, 0x07, 0x01, 0x35,
-  0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x23, 0x05, 0x06, 0xfc, 0x50,
-  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x03, 0xb0, 0x99, 0x99,
-  0x02, 0x2d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01,
-  0x59, 0xfc, 0xa4, 0x00, 0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x8e,
-  0x05, 0xdc, 0x00, 0x0d, 0x00, 0x00, 0x25, 0x11, 0x07, 0x27, 0x01, 0x33,
-  0x01, 0x07, 0x27, 0x11, 0x21, 0x15, 0x21, 0x35, 0x02, 0xb8, 0xd1, 0x6c,
-  0x01, 0x61, 0x51, 0x01, 0x61, 0x6c, 0xd1, 0x01, 0x37, 0xfc, 0xfa, 0xaa,
-  0x04, 0x1a, 0xea, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78, 0xea, 0xfb, 0xe6,
-  0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
-  0x11, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x04, 0xb2, 0xfc, 0x50,
-  0x99, 0x99, 0x03, 0xb0, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0x02,
-  0x2d, 0xfe, 0xa7, 0x03, 0x5c, 0xfe, 0xa7, 0xe9, 0x78, 0xfe, 0x77, 0x5a,
-  0xfe, 0x77, 0x78, 0x00, 0x00, 0x01, 0x01, 0x7a, 0xff, 0xf9, 0x04, 0x8e,
-  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x15, 0x21,
-  0x11, 0x37, 0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x02, 0xb8, 0xfe, 0xca,
-  0x03, 0x06, 0xfe, 0xc9, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9f, 0x6c,
-  0xd1, 0x05, 0x2b, 0xaa, 0xaa, 0xfb, 0xe6, 0xea, 0x78, 0xfe, 0x76, 0x01,
-  0x8a, 0x78, 0xea, 0x00, 0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x8e,
-  0x05, 0xdc, 0x00, 0x13, 0x00, 0x00, 0x01, 0x37, 0x17, 0x01, 0x21, 0x15,
-  0x21, 0x35, 0x21, 0x01, 0x37, 0x17, 0x11, 0x07, 0x27, 0x01, 0x33, 0x01,
-  0x07, 0x27, 0x03, 0x51, 0xd1, 0x6c, 0xfe, 0x9f, 0x01, 0x5b, 0xfc, 0xfa,
-  0x01, 0x5a, 0xfe, 0x9f, 0x6c, 0xd1, 0xd1, 0x6c, 0x01, 0x61, 0x51, 0x01,
-  0x61, 0x6c, 0xd1, 0x01, 0xc2, 0xea, 0x78, 0xfe, 0x76, 0xaa, 0xaa, 0x01,
-  0x8a, 0x78, 0xea, 0x03, 0x02, 0xea, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78,
-  0xea, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0x9f,
-  0x04, 0x86, 0x00, 0x25, 0x00, 0x00, 0x01, 0x35, 0x32, 0x17, 0x16, 0x17,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21, 0x17,
-  0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x20, 0x37, 0x36, 0x37, 0x3e,
-  0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x04, 0x91, 0x38, 0x2f,
-  0x2d, 0x2a, 0x27, 0x28, 0x26, 0x29, 0x23, 0x34, 0x2c, 0x1d, 0xfc, 0xa7,
-  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0xaa, 0x01, 0xa9,
-  0x14, 0x16, 0x11, 0x10, 0x12, 0x11, 0x11, 0x11, 0x16, 0x14, 0x03, 0xdc,
-  0xaa, 0x16, 0x15, 0x2d, 0x29, 0x6f, 0x3d, 0x3c, 0x6a, 0x2e, 0x28, 0x1a,
-  0x16, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x0a, 0x0a,
-  0x12, 0x11, 0x31, 0x1a, 0x1b, 0x2e, 0x14, 0x12, 0x0a, 0x0a, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x6a, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x86, 0x00, 0x29,
-  0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x21, 0x27, 0x37, 0x01, 0x15,
-  0x01, 0x27, 0x37, 0x21, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x01, 0x77, 0x18, 0x14,
-  0x15, 0x12, 0x10, 0x09, 0x09, 0x09, 0x0b, 0x0e, 0x12, 0x15, 0x14, 0x18,
-  0x03, 0x3b, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfc, 0xc5,
-  0x3a, 0x2c, 0x35, 0x23, 0x28, 0x13, 0x14, 0x14, 0x15, 0x26, 0x2b, 0x2d,
-  0x2f, 0x37, 0x03, 0xdc, 0x0a, 0x0a, 0x12, 0x11, 0x1a, 0x17, 0x1b, 0x1a,
-  0x17, 0x1c, 0x0f, 0x12, 0x0a, 0x0a, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
-  0x77, 0x78, 0xe9, 0x16, 0x1a, 0x28, 0x2e, 0x34, 0x36, 0x3c, 0x3d, 0x36,
-  0x39, 0x29, 0x2d, 0x15, 0x16, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0x9f, 0x04, 0x86, 0x00, 0x18, 0x00, 0x3e, 0x00, 0x00,
-  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x15, 0x07, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x2b, 0x01, 0x15, 0x23, 0x35, 0x21, 0x17, 0x07, 0x01, 0x35,
-  0x01, 0x17, 0x07, 0x04, 0x1c, 0x75, 0x18, 0x14, 0x16, 0x11, 0x10, 0x09,
-  0x09, 0x09, 0x09, 0x10, 0x11, 0x16, 0x14, 0x30, 0x14, 0x16, 0x11, 0x0e,
-  0x0b, 0x09, 0x98, 0x14, 0x14, 0x27, 0x2b, 0x2c, 0x2f, 0x38, 0x3b, 0x2c,
-  0x34, 0x23, 0x29, 0x12, 0x14, 0x14, 0x14, 0x27, 0x2a, 0x2d, 0x2f, 0x38,
-  0x75, 0x98, 0xfd, 0xd2, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2,
-  0x02, 0xd7, 0x0a, 0x0a, 0x12, 0x11, 0x1a, 0x17, 0x1a, 0x1b, 0x17, 0x1a,
-  0x11, 0x12, 0x0a, 0x0a, 0x0a, 0x0a, 0x12, 0x0f, 0x1c, 0x17, 0x1b, 0x82,
-  0x82, 0x3d, 0x36, 0x39, 0x29, 0x2d, 0x15, 0x16, 0x16, 0x1a, 0x28, 0x2e,
-  0x34, 0x36, 0x3d, 0x3c, 0x36, 0x39, 0x29, 0x2d, 0x15, 0x16, 0xdc, 0xdc,
-  0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x6a, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x86, 0x00, 0x18,
-  0x00, 0x3e, 0x00, 0x00, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x33, 0x29, 0x01, 0x27, 0x37, 0x01, 0x15, 0x01,
-  0x27, 0x37, 0x21, 0x15, 0x23, 0x35, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x01, 0xec, 0x09, 0x0b, 0x0e,
-  0x11, 0x16, 0x13, 0x31, 0x14, 0x15, 0x12, 0x10, 0x09, 0x09, 0x09, 0x09,
-  0x10, 0x12, 0x15, 0x14, 0x18, 0x01, 0x0d, 0x02, 0x2e, 0xd1, 0x6c, 0x01,
-  0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfd, 0xd2, 0x98, 0x75, 0x37, 0x2f, 0x2d,
-  0x2b, 0x26, 0x15, 0x14, 0x14, 0x13, 0x28, 0x23, 0x35, 0x2c, 0x3a, 0x38,
-  0x2f, 0x2d, 0x2a, 0x27, 0x15, 0x13, 0x02, 0xd7, 0x82, 0x1b, 0x17, 0x1c,
-  0x0f, 0x12, 0x0a, 0x0a, 0x0a, 0x0a, 0x12, 0x11, 0x1a, 0x17, 0x1b, 0x1a,
-  0x17, 0x1a, 0x11, 0x12, 0x0a, 0x0a, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
-  0x77, 0x78, 0xe9, 0xdc, 0xdc, 0x16, 0x15, 0x2d, 0x29, 0x39, 0x36, 0x3c,
-  0x3d, 0x36, 0x34, 0x2e, 0x28, 0x1a, 0x16, 0x16, 0x15, 0x2d, 0x29, 0x39,
-  0x36, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x58, 0x00, 0x00, 0x01, 0x23, 0x17, 0x07, 0x01, 0x35,
-  0x01, 0x17, 0x07, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x32, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x32, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x3b, 0x01, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x5f, 0x09, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x09, 0x2b,
-  0x21, 0x1f, 0x20, 0x0a, 0x15, 0x18, 0x16, 0x09, 0x09, 0x05, 0x0e, 0x1d,
-  0x1e, 0x22, 0x23, 0x28, 0x2b, 0x21, 0x23, 0x1d, 0x1d, 0x0e, 0x04, 0x09,
-  0x09, 0x16, 0x18, 0x16, 0x09, 0x23, 0x1d, 0x23, 0x28, 0x09, 0xd1, 0x6c,
-  0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0x09, 0x0c, 0x0a, 0x0c, 0x09, 0x1c,
-  0x24, 0x23, 0x51, 0x22, 0x24, 0x1c, 0x1e, 0x0e, 0x04, 0x09, 0x09, 0x0b,
-  0x0a, 0x19, 0x0a, 0x0c, 0x09, 0x08, 0x05, 0x0d, 0x1f, 0x1c, 0x24, 0x22,
-  0x51, 0x23, 0x24, 0x1c, 0x09, 0x0b, 0x0a, 0x02, 0x2d, 0xe9, 0x78, 0x01,
-  0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x12, 0x12, 0x24, 0x0a, 0x0c, 0x0c,
-  0x0a, 0x0c, 0x0d, 0x2d, 0x23, 0x25, 0x11, 0x12, 0x12, 0x14, 0x22, 0x26,
-  0x2a, 0x0d, 0x0c, 0x0a, 0x0c, 0x0c, 0x0a, 0x27, 0x0f, 0x12, 0xe9, 0x78,
-  0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x06, 0x06, 0x0a, 0x22, 0x14,
-  0x12, 0x12, 0x14, 0x22, 0x26, 0x2a, 0x0d, 0x0c, 0x0a, 0x06, 0x06, 0x06,
-  0x06, 0x0a, 0x09, 0x10, 0x2a, 0x26, 0x22, 0x14, 0x12, 0x12, 0x14, 0x22,
-  0x0a, 0x06, 0x06, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xbe, 0x05, 0xaf,
-  0x04, 0x46, 0x00, 0x17, 0x00, 0x00, 0x25, 0x27, 0x13, 0x21, 0x17, 0x07,
-  0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x13, 0x17, 0x03, 0x21, 0x27, 0x37,
-  0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x02, 0xc2, 0x90, 0x64, 0xfe, 0xc0,
-  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0x78, 0x79, 0x90,
-  0x65, 0x01, 0x40, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe,
-  0x88, 0xbe, 0x3a, 0x01, 0x35, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89,
-  0x78, 0xe9, 0x01, 0x6f, 0x3a, 0xfe, 0xcb, 0xe9, 0x78, 0xfe, 0x77, 0x5a,
-  0xfe, 0x77, 0x78, 0xe9, 0x00, 0x01, 0x01, 0x0c, 0xff, 0xfc, 0x05, 0x0e,
-  0x05, 0xd8, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x13, 0x17, 0x03, 0x01,
-  0x03, 0x37, 0x17, 0x01, 0x27, 0x01, 0x37, 0x13, 0x03, 0xa2, 0xfd, 0x6a,
-  0x8e, 0x96, 0x55, 0x02, 0x96, 0xae, 0xf2, 0x58, 0xfe, 0x67, 0x50, 0xfe,
-  0xe1, 0x7d, 0xab, 0x04, 0x08, 0xfe, 0x58, 0x03, 0x78, 0x1d, 0xfd, 0xee,
-  0x01, 0xa8, 0xfb, 0xb8, 0xbe, 0x8b, 0xfe, 0xc0, 0x10, 0x01, 0xc8, 0x62,
-  0xfe, 0xf1, 0x00, 0x00, 0x00, 0x01, 0x01, 0x37, 0x00, 0x00, 0x04, 0x89,
-  0x05, 0xf2, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x17,
-  0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x04, 0x88, 0x99, 0xfe, 0x44, 0xd2,
-  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x04, 0x91, 0xfb, 0x6f, 0x03,
-  0xe7, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x81, 0x00, 0x00, 0x04, 0xd2, 0x05, 0xf2, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
-  0x11, 0x23, 0x01, 0x81, 0x02, 0x55, 0xd2, 0x6c, 0x01, 0x62, 0xfe, 0x9e,
-  0x6c, 0xd2, 0xfe, 0x44, 0x99, 0x04, 0x91, 0xe9, 0x78, 0xfe, 0x77, 0x5a,
-  0xfe, 0x77, 0x78, 0xe9, 0xfc, 0x19, 0x00, 0x00, 0x00, 0x01, 0x01, 0x37,
-  0xff, 0xe3, 0x04, 0x89, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
-  0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x04, 0x88,
-  0xfd, 0xab, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0xbc,
-  0x99, 0x01, 0x44, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9,
-  0x03, 0xe7, 0x00, 0x00, 0x00, 0x01, 0x01, 0x81, 0xff, 0xe3, 0x04, 0xd2,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x27,
-  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x01, 0x81, 0x99, 0x01, 0xbc, 0xd2,
-  0x6c, 0x01, 0x62, 0xfe, 0x9e, 0x6c, 0xd2, 0x01, 0x44, 0x04, 0x91, 0xfc,
-  0x19, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0xad, 0xff, 0xf9, 0x05, 0x79, 0x04, 0xd4, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x37, 0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x11,
-  0x21, 0x35, 0x04, 0x3b, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9e, 0x6c,
-  0xd2, 0xfe, 0x0b, 0x04, 0xd4, 0xfc, 0x3d, 0xe9, 0x78, 0xfe, 0x77, 0x01,
-  0x89, 0x78, 0xe9, 0x03, 0x19, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0xcc, 0x04, 0xb9, 0x05, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
-  0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x04, 0xb9,
-  0xfc, 0x9d, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x02, 0xca,
-  0x99, 0x02, 0x2d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9,
-  0x02, 0x2c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x28, 0x01, 0xa0, 0x05, 0xc2,
-  0x05, 0x58, 0x00, 0x26, 0x00, 0x00, 0x01, 0x37, 0x17, 0x01, 0x23, 0x01,
-  0x37, 0x17, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x23, 0x34, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x02, 0x00, 0xd1,
-  0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9d, 0x6c, 0xd3, 0x29, 0x29, 0x53, 0x51,
-  0x63, 0x61, 0xe6, 0x62, 0x63, 0x51, 0x52, 0x29, 0x29, 0x99, 0x3b, 0x3b,
-  0x36, 0x4e, 0x42, 0xac, 0x46, 0x4a, 0x39, 0x3a, 0x1f, 0x1e, 0x02, 0xb8,
-  0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0xea, 0x32, 0x7f, 0x70, 0x6b,
-  0x5f, 0x56, 0x31, 0x2e, 0x2e, 0x31, 0x56, 0x5f, 0x6b, 0x70, 0x7f, 0x5d,
-  0xa2, 0x42, 0x3b, 0x27, 0x21, 0x21, 0x23, 0x3f, 0x40, 0x53, 0x51, 0x5d,
-  0x00, 0x01, 0x00, 0x47, 0x01, 0xa0, 0x05, 0xe0, 0x05, 0x58, 0x00, 0x26,
-  0x00, 0x00, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22,
-  0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x1d, 0x01, 0x37,
-  0x17, 0x01, 0x23, 0x01, 0x37, 0x04, 0x08, 0x1d, 0x20, 0x39, 0x3a, 0x4a,
-  0x46, 0xab, 0x43, 0x4d, 0x36, 0x3b, 0x3c, 0x99, 0x29, 0x29, 0x53, 0x51,
-  0x63, 0x61, 0xe6, 0x62, 0x63, 0x51, 0x52, 0x29, 0x29, 0xd3, 0x6c, 0xfe,
-  0x9d, 0x51, 0xfe, 0xa0, 0x6c, 0x02, 0xb8, 0x32, 0x5d, 0x51, 0x53, 0x40,
-  0x3f, 0x23, 0x21, 0x21, 0x27, 0x3b, 0x42, 0xa2, 0x5d, 0x7f, 0x70, 0x6b,
-  0x5f, 0x56, 0x31, 0x2e, 0x2e, 0x31, 0x56, 0x5f, 0x6b, 0x70, 0x7f, 0x32,
-  0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0x00, 0x00, 0x02, 0x00, 0xc7,
-  0x00, 0x34, 0x05, 0xac, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00,
-  0x13, 0x35, 0x21, 0x15, 0x05, 0x37, 0x21, 0x15, 0x21, 0x01, 0x07, 0x01,
-  0x11, 0x23, 0xc8, 0x04, 0xe4, 0xfb, 0x57, 0x39, 0x01, 0xf4, 0xfe, 0xd7,
-  0x03, 0x08, 0x6c, 0xfc, 0xf8, 0x98, 0x05, 0x72, 0x63, 0x63, 0xfe, 0x3f,
-  0xa9, 0xfc, 0xa2, 0x78, 0x03, 0x5e, 0xfe, 0xb6, 0x00, 0x02, 0x00, 0x64,
-  0xff, 0xa1, 0x05, 0xa4, 0x05, 0x63, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x00,
-  0x13, 0x35, 0x21, 0x27, 0x37, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x01,
-  0x27, 0x37, 0x01, 0x21, 0x17, 0x07, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11,
-  0x01, 0x17, 0x07, 0x21, 0x65, 0x03, 0xaa, 0xd3, 0x6c, 0x01, 0x63, 0x99,
-  0x99, 0xfe, 0x9d, 0x6c, 0xd3, 0x01, 0x95, 0xfc, 0x56, 0xd2, 0x6c, 0xfe,
-  0x9e, 0x99, 0x99, 0x01, 0x62, 0x6c, 0xd2, 0x03, 0xaa, 0x01, 0x01, 0xaa,
-  0xe8, 0x78, 0xfe, 0x78, 0x01, 0x4e, 0xfd, 0x08, 0x01, 0x50, 0xfe, 0x78,
-  0x78, 0xe8, 0x02, 0x58, 0xe8, 0x78, 0x01, 0x88, 0xfe, 0xb0, 0x02, 0xf8,
-  0xfe, 0xb2, 0x01, 0x88, 0x78, 0xe8, 0x00, 0x00, 0x00, 0x01, 0x00, 0xbd,
-  0x00, 0x7f, 0x05, 0x7d, 0x05, 0x70, 0x00, 0x36, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36,
-  0x37, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x11, 0x23, 0x11,
-  0x37, 0x21, 0x15, 0x21, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0xcf, 0x3e, 0x1c, 0x1e, 0x3b, 0x3c,
-  0x36, 0x4d, 0x43, 0xab, 0x46, 0x4a, 0x39, 0x3c, 0x3b, 0x1e, 0x1e, 0x3c,
-  0x1f, 0x99, 0x39, 0x01, 0xf5, 0xfe, 0xd7, 0x1f, 0x51, 0x2b, 0x29, 0x29,
-  0x2b, 0x51, 0x4b, 0x69, 0x5c, 0x78, 0x73, 0x61, 0x65, 0x4f, 0x51, 0x2b,
-  0x29, 0x29, 0x29, 0x53, 0x04, 0x2b, 0x42, 0x51, 0x51, 0x5d, 0x5a, 0xa2,
-  0x42, 0x3b, 0x27, 0x21, 0x21, 0x23, 0x3f, 0x42, 0xa2, 0x5a, 0x5d, 0x51,
-  0x51, 0x42, 0x23, 0xfe, 0xb6, 0x02, 0x2c, 0x40, 0xaa, 0x23, 0x5a, 0x70,
-  0x70, 0x7f, 0x7c, 0x70, 0x71, 0x59, 0x53, 0x34, 0x2e, 0x2e, 0x30, 0x57,
-  0x59, 0x71, 0x70, 0x7c, 0x7f, 0x70, 0x6b, 0x5f, 0x00, 0x01, 0x00, 0x8d,
-  0x00, 0x7f, 0x05, 0x4d, 0x05, 0x70, 0x00, 0x36, 0x00, 0x00, 0x01, 0x37,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3f,
-  0x01, 0x21, 0x35, 0x21, 0x17, 0x11, 0x23, 0x11, 0x07, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e,
-  0x01, 0x35, 0x34, 0x27, 0x26, 0x04, 0x3c, 0x6c, 0x52, 0x29, 0x29, 0x29,
-  0x2b, 0x50, 0x50, 0x64, 0x62, 0x73, 0x77, 0x5d, 0x69, 0x4b, 0x50, 0x2b,
-  0x2a, 0x2a, 0x2a, 0x51, 0x1f, 0xfe, 0xd7, 0x01, 0xf5, 0x39, 0x99, 0x1f,
-  0x3c, 0x1e, 0x1e, 0x3b, 0x3c, 0x3a, 0x49, 0x47, 0xaa, 0x43, 0x4d, 0x36,
-  0x3c, 0x3b, 0x1d, 0x1d, 0x04, 0x2b, 0x78, 0x5f, 0x6b, 0x70, 0x7f, 0x7c,
-  0x70, 0x71, 0x59, 0x57, 0x30, 0x2e, 0x2e, 0x34, 0x53, 0x59, 0x71, 0x70,
-  0x7c, 0x7f, 0x70, 0x70, 0x5a, 0x23, 0xaa, 0x40, 0xfd, 0xd4, 0x01, 0x4a,
-  0x23, 0x42, 0x51, 0x51, 0x5d, 0x5a, 0xa2, 0x42, 0x3f, 0x23, 0x21, 0x21,
-  0x27, 0x3b, 0x42, 0xa2, 0x5a, 0x5d, 0x51, 0x51, 0x00, 0x01, 0x00, 0x5a,
-  0x02, 0x2d, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x06, 0x00, 0x00, 0x13, 0x35,
-  0x01, 0x17, 0x07, 0x21, 0x15, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x04, 0x49,
-  0x02, 0x2d, 0x82, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0xa0, 0x02, 0xd7, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x17, 0x07, 0x01, 0x5a, 0x05, 0x45, 0xfb, 0xb7, 0xd2, 0x6c,
-  0xfe, 0x9e, 0x02, 0xd7, 0xaa, 0xe9, 0x78, 0x01, 0x89, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0xb7, 0x00, 0x00, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x23, 0x02, 0xb8, 0x75,
-  0x01, 0x61, 0x6c, 0xd1, 0x99, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea, 0xfb,
-  0x3c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x03, 0x51,
-  0x05, 0xdc, 0x00, 0x06, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27,
-  0x01, 0x03, 0x51, 0x99, 0xd3, 0x6c, 0x01, 0x63, 0x05, 0xdc, 0xfa, 0x24,
-  0x04, 0xc4, 0xea, 0x78, 0x01, 0x8a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x02, 0x2d, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x06, 0x00, 0x00, 0x01, 0x21,
-  0x35, 0x21, 0x27, 0x37, 0x01, 0x05, 0xae, 0xfa, 0xbb, 0x04, 0x49, 0xd1,
-  0x6c, 0x01, 0x61, 0x02, 0x2d, 0xaa, 0xe9, 0x78, 0xfe, 0x77, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x02, 0xd7, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x35, 0x05, 0xae, 0xfe,
-  0x9f, 0x6c, 0xd1, 0xfb, 0xb7, 0x02, 0xd7, 0x82, 0xfe, 0x77, 0x78, 0xe9,
-  0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb7, 0x00, 0x00, 0x04, 0x8e,
-  0x05, 0xdc, 0x00, 0x06, 0x00, 0x00, 0x21, 0x11, 0x33, 0x11, 0x37, 0x17,
-  0x01, 0x02, 0xb8, 0x99, 0xd1, 0x6c, 0xfe, 0x9f, 0x05, 0xdc, 0xfb, 0x3c,
-  0xea, 0x78, 0xfe, 0x76, 0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x03, 0x51,
-  0x05, 0xdc, 0x00, 0x06, 0x00, 0x00, 0x21, 0x23, 0x01, 0x37, 0x17, 0x11,
-  0x33, 0x03, 0x51, 0x75, 0xfe, 0x9d, 0x6c, 0xd3, 0x99, 0x01, 0x8a, 0x78,
-  0xea, 0x04, 0xc4, 0x00, 0xff, 0xff, 0x00, 0x5a, 0xff, 0xa0, 0x05, 0xaf,
-  0x05, 0x64, 0x10, 0x27, 0x08, 0x6c, 0x00, 0x00, 0xfe, 0xd4, 0x10, 0x07,
-  0x08, 0x6e, 0x00, 0x00, 0x01, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6b,
-  0xff, 0xf9, 0x05, 0x9c, 0x05, 0xdc, 0x10, 0x27, 0x08, 0x6f, 0x01, 0x0e,
-  0x00, 0x00, 0x10, 0x07, 0x08, 0x6d, 0xfe, 0xf2, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x5a, 0xff, 0xa0, 0x05, 0xaf, 0x05, 0x64, 0x10, 0x27,
-  0x08, 0x6e, 0x00, 0x00, 0xfe, 0xd4, 0x10, 0x07, 0x08, 0x6c, 0x00, 0x00,
-  0x01, 0x2c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0xff, 0xa0, 0x05, 0xa0,
-  0x05, 0x64, 0x00, 0x11, 0x00, 0x00, 0x01, 0x03, 0x35, 0x01, 0x17, 0x07,
-  0x21, 0x15, 0x21, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01, 0x35,
-  0x01, 0x40, 0xe6, 0x01, 0x62, 0x6c, 0xd2, 0x04, 0x49, 0xfb, 0xb7, 0xc2,
-  0xc2, 0x04, 0x49, 0xfb, 0xb7, 0xd2, 0x6c, 0xfe, 0x9e, 0x02, 0x82, 0x00,
-  0xff, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0xd7, 0xd7, 0xaa, 0xe9, 0x78,
-  0x01, 0x89, 0x5a, 0x00, 0x00, 0x01, 0x00, 0x6c, 0x00, 0x00, 0x05, 0x9d,
-  0x05, 0xdc, 0x00, 0x11, 0x00, 0x00, 0x01, 0x13, 0x33, 0x01, 0x07, 0x27,
-  0x11, 0x23, 0x11, 0x07, 0x27, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x33,
-  0x03, 0x04, 0xe5, 0x51, 0x01, 0x62, 0x6c, 0xd2, 0x99, 0xc1, 0xc2, 0x99,
-  0xd1, 0x6c, 0x01, 0x61, 0x51, 0x04, 0xdc, 0x01, 0x00, 0xfe, 0x76, 0x78,
-  0xea, 0xfb, 0x3c, 0x04, 0xc4, 0xd8, 0xd8, 0xfb, 0x3c, 0x04, 0xc4, 0xea,
-  0x78, 0x01, 0x8a, 0x00, 0x00, 0x01, 0x00, 0x6a, 0xff, 0xa0, 0x05, 0xb0,
-  0x05, 0x64, 0x00, 0x11, 0x00, 0x00, 0x01, 0x17, 0x15, 0x01, 0x27, 0x37,
-  0x21, 0x35, 0x21, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x15,
-  0x04, 0xca, 0xe5, 0xfe, 0x9f, 0x6c, 0xd1, 0xfb, 0xb7, 0x04, 0x49, 0xc1,
-  0xc1, 0xfb, 0xb7, 0x04, 0x49, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x82, 0xff,
-  0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xaa, 0xd7, 0xd7, 0xaa, 0xe9, 0x78, 0xfe,
-  0x77, 0x5a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6c, 0xff, 0xf9, 0x05, 0x9d,
-  0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x25, 0x03, 0x23, 0x01, 0x37, 0x17,
-  0x11, 0x33, 0x11, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x23,
-  0x03, 0x04, 0xe6, 0x51, 0xfe, 0x9f, 0x6c, 0xd1, 0x99, 0xc2, 0xc1, 0x99,
-  0xd2, 0x6c, 0xfe, 0x9e, 0x51, 0xf9, 0xff, 0x00, 0x01, 0x8a, 0x78, 0xea,
-  0x04, 0xc4, 0xfb, 0x3c, 0xd8, 0xd8, 0x04, 0xc4, 0xfb, 0x3c, 0xea, 0x78,
-  0xfe, 0x76, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5a, 0x00, 0x0e, 0x05, 0xaf,
-  0x04, 0xf6, 0x10, 0x27, 0x08, 0x9d, 0x00, 0x00, 0xff, 0x42, 0x10, 0x07,
-  0x08, 0x98, 0x00, 0x00, 0x00, 0xbe, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5a,
-  0x00, 0x0e, 0x05, 0xaf, 0x04, 0xf6, 0x10, 0x27, 0x08, 0x99, 0x00, 0x00,
-  0xff, 0x42, 0x10, 0x07, 0x08, 0x9c, 0x00, 0x00, 0x00, 0xbe, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x04,
-  0x00, 0x1a, 0x00, 0x00, 0x01, 0x21, 0x07, 0x17, 0x21, 0x25, 0x07, 0x21,
-  0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
-  0x07, 0x21, 0x37, 0x17, 0x07, 0x21, 0x15, 0x03, 0x92, 0xfd, 0xd6, 0x5e,
-  0x5e, 0x01, 0xbd, 0x01, 0x08, 0x6d, 0x01, 0xdf, 0xfd, 0xe3, 0x69, 0x75,
-  0x42, 0xfe, 0xee, 0x54, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x01,
-  0xfc, 0x69, 0x75, 0x42, 0x01, 0x33, 0x02, 0xeb, 0x69, 0x69, 0xd2, 0xd2,
-  0x78, 0xca, 0x4b, 0x7f, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78,
-  0x5d, 0xca, 0x4b, 0x7f, 0x78, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x5a,
-  0x00, 0xc1, 0x05, 0xaf, 0x04, 0x43, 0x00, 0x17, 0x00, 0x1c, 0x00, 0x21,
-  0x00, 0x00, 0x25, 0x27, 0x37, 0x23, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
-  0x07, 0x21, 0x37, 0x17, 0x07, 0x33, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27,
-  0x37, 0x21, 0x13, 0x07, 0x21, 0x37, 0x27, 0x29, 0x01, 0x07, 0x17, 0x21,
-  0x02, 0xba, 0x7f, 0x37, 0x9e, 0x54, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c,
-  0x54, 0x01, 0x32, 0x49, 0x7f, 0x38, 0x9e, 0x53, 0x6c, 0x01, 0x61, 0xfe,
-  0x9f, 0x6c, 0x53, 0xfe, 0xce, 0x6c, 0x44, 0x01, 0x76, 0x5f, 0x5f, 0xfe,
-  0x3e, 0xfe, 0x8a, 0x5e, 0x5e, 0x01, 0x32, 0xc1, 0x34, 0xac, 0x5d, 0x78,
-  0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d, 0xe0, 0x34, 0xac, 0x5d, 0x78,
-  0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x5d, 0x01, 0x4a, 0xd2, 0x69, 0x69,
-  0x69, 0x69, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x04, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x21, 0x37, 0x27,
-  0x21, 0x05, 0x37, 0x21, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21, 0x27, 0x37,
-  0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x02,
-  0x77, 0x02, 0x29, 0x5f, 0x5f, 0xfe, 0x44, 0xfe, 0xf7, 0x6d, 0xfe, 0x21,
-  0x02, 0x1d, 0x6a, 0x74, 0x41, 0x01, 0x11, 0x53, 0x6c, 0x01, 0x61, 0xfe,
-  0x9f, 0x6c, 0x53, 0xfe, 0x05, 0x69, 0x76, 0x42, 0xfe, 0xcd, 0x02, 0x19,
-  0x69, 0x69, 0xd2, 0xd2, 0x78, 0xca, 0x4b, 0x7f, 0x5d, 0x78, 0xfe, 0x77,
-  0x5a, 0xfe, 0x77, 0x78, 0x5d, 0xca, 0x4b, 0x7f, 0x78, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0e,
-  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
-  0x07, 0x21, 0x15, 0x21, 0x07, 0x01, 0x68, 0x04, 0x37, 0xfc, 0x35, 0x54,
-  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x03, 0xcb, 0xfb, 0xc9, 0x5e,
-  0x02, 0x19, 0x78, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d,
-  0x78, 0x69, 0x00, 0x00, 0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x90,
-  0x05, 0xdc, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27,
-  0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x23, 0x11, 0x27, 0x02, 0xa6, 0x6c,
-  0x53, 0x6c, 0x01, 0x61, 0x51, 0x01, 0x62, 0x6c, 0x54, 0x6c, 0x5e, 0x04,
-  0xb0, 0xfb, 0x50, 0x04, 0x38, 0x5e, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78,
-  0x5e, 0xfb, 0xc8, 0x04, 0xb0, 0x68, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x37,
-  0x27, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
-  0x35, 0x04, 0xa0, 0x5f, 0x5f, 0xfb, 0xc9, 0x03, 0xcb, 0x53, 0x6c, 0x01,
-  0x61, 0xfe, 0x9f, 0x6c, 0x53, 0xfc, 0x35, 0x02, 0x19, 0x69, 0x69, 0x78,
-  0x5d, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x5d, 0x78, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x7a, 0xff, 0xf9, 0x04, 0x90, 0x05, 0xd5, 0x00, 0x0e,
-  0x00, 0x00, 0x01, 0x17, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x23,
-  0x01, 0x37, 0x17, 0x11, 0x33, 0x02, 0xa6, 0x5f, 0x5e, 0x6c, 0x54, 0x6c,
-  0xfe, 0x9e, 0x51, 0xfe, 0x9f, 0x6c, 0x53, 0x6c, 0x01, 0x25, 0x68, 0x68,
-  0x04, 0xb0, 0xfb, 0xc8, 0x5e, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0x5e,
-  0x04, 0x38, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x05, 0x00, 0x15, 0x00, 0x00, 0x01, 0x21, 0x37, 0x27,
-  0x21, 0x07, 0x05, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21,
-  0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x01, 0x68, 0x03, 0x38, 0x5f, 0x5f,
-  0xfc, 0xc8, 0x5e, 0x03, 0x2a, 0xfd, 0xa0, 0x54, 0x6c, 0xfe, 0x9e, 0x01,
-  0x62, 0x6c, 0x54, 0x02, 0x60, 0x53, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
-  0x02, 0x19, 0x69, 0x69, 0x69, 0xe1, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01,
-  0x89, 0x78, 0x5d, 0x5d, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x00,
-  0x00, 0x02, 0x01, 0x7a, 0xff, 0xf0, 0x04, 0x8f, 0x05, 0xdc, 0x00, 0x05,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x11, 0x17, 0x37, 0x11, 0x27, 0x03, 0x11,
-  0x07, 0x27, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x37, 0x17, 0x01, 0x23,
-  0x01, 0x37, 0x02, 0xa6, 0x5e, 0x5f, 0x5f, 0xca, 0x54, 0x6c, 0x01, 0x62,
-  0x51, 0x01, 0x61, 0x6c, 0x53, 0x53, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9e,
-  0x6c, 0x04, 0xb0, 0xfc, 0x6c, 0x69, 0x69, 0x03, 0x94, 0x69, 0xfc, 0x7b,
-  0x02, 0xa4, 0x5d, 0x78, 0x01, 0x89, 0xfe, 0x77, 0x78, 0x5d, 0xfd, 0x5c,
-  0x5d, 0x78, 0xfe, 0x77, 0x01, 0x89, 0x78, 0x00, 0x00, 0x01, 0x01, 0x03,
-  0xff, 0xd1, 0x05, 0x6a, 0x04, 0xb3, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01,
-  0x07, 0x01, 0x15, 0x23, 0x11, 0x37, 0x21, 0x15, 0x23, 0x01, 0x07, 0x01,
-  0x23, 0x01, 0x9b, 0x02, 0xfb, 0x4c, 0xfd, 0x51, 0x98, 0x39, 0x01, 0xf4,
-  0x76, 0x02, 0xaf, 0x4c, 0xfd, 0x04, 0x86, 0x03, 0x76, 0xfc, 0xb0, 0x55,
-  0x02, 0xfb, 0x84, 0x02, 0x2c, 0x3f, 0xa9, 0xfd, 0x05, 0x55, 0x03, 0x50,
-  0x00, 0x01, 0x00, 0xa9, 0xff, 0xd1, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x0e,
-  0x00, 0x00, 0x01, 0x35, 0x23, 0x01, 0x27, 0x01, 0x23, 0x35, 0x21, 0x17,
-  0x11, 0x23, 0x35, 0x01, 0x27, 0x04, 0x77, 0x86, 0xfd, 0x05, 0x4d, 0x02,
-  0xaf, 0x76, 0x01, 0xf4, 0x39, 0x98, 0xfd, 0x51, 0x4c, 0x03, 0x76, 0x94,
-  0xfc, 0xb0, 0x55, 0x02, 0xfb, 0xa9, 0x3f, 0xfd, 0xd4, 0x84, 0xfd, 0x05,
-  0x55, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa9, 0x00, 0x34, 0x05, 0x10,
-  0x05, 0x16, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01, 0x37, 0x01, 0x35, 0x33,
-  0x11, 0x07, 0x21, 0x35, 0x33, 0x01, 0x37, 0x01, 0x33, 0x04, 0x77, 0xfd,
-  0x05, 0x4c, 0x02, 0xaf, 0x98, 0x39, 0xfe, 0x0c, 0x76, 0xfd, 0x51, 0x4d,
-  0x02, 0xfb, 0x86, 0x01, 0x71, 0x03, 0x50, 0x55, 0xfd, 0x05, 0x84, 0xfd,
-  0xd4, 0x3f, 0xa9, 0x02, 0xfb, 0x55, 0xfc, 0xb0, 0x00, 0x01, 0x01, 0x03,
-  0x00, 0x34, 0x05, 0x6a, 0x05, 0x16, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x15,
-  0x33, 0x01, 0x17, 0x01, 0x33, 0x15, 0x21, 0x27, 0x11, 0x33, 0x15, 0x01,
-  0x17, 0x01, 0x9b, 0x86, 0x02, 0xfc, 0x4c, 0xfd, 0x51, 0x76, 0xfe, 0x0c,
-  0x39, 0x98, 0x02, 0xaf, 0x4c, 0x01, 0x71, 0x94, 0x03, 0x50, 0x55, 0xfd,
-  0x05, 0xa9, 0x3f, 0x02, 0x2c, 0x84, 0x02, 0xfb, 0x55, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0f,
-  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x17, 0x21, 0x15, 0x21, 0x07, 0x01,
-  0x35, 0x01, 0x17, 0x21, 0x15, 0x21, 0x01, 0x40, 0x04, 0x5f, 0xfb, 0xa1,
-  0x7c, 0x03, 0xe3, 0xfc, 0x89, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x03,
-  0x77, 0xfc, 0x1d, 0x02, 0xbe, 0x78, 0x8a, 0x78, 0x78, 0x01, 0x89, 0x5a,
-  0x01, 0x89, 0x78, 0x78, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x27, 0x21,
-  0x35, 0x21, 0x37, 0x01, 0x15, 0x01, 0x27, 0x21, 0x35, 0x21, 0x04, 0xc9,
-  0xfb, 0xa0, 0x04, 0x60, 0x7c, 0xfc, 0x1c, 0x03, 0x78, 0x6c, 0x01, 0x61,
-  0xfe, 0x9f, 0x6c, 0xfc, 0x88, 0x03, 0xe4, 0x02, 0x46, 0x78, 0x8a, 0x78,
-  0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x78, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x18, 0x00, 0x00, 0x01, 0x23,
-  0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x23, 0x17, 0x07, 0x01, 0x35,
-  0x01, 0x17, 0x07, 0x33, 0x17, 0x37, 0x17, 0x37, 0x17, 0x37, 0x17, 0x05,
-  0x9f, 0x24, 0x3f, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x63, 0x59, 0xd2, 0x6c,
-  0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x7d, 0x3f, 0xa2, 0xa2, 0xa2, 0xa2,
-  0xa2, 0x63, 0x02, 0x2d, 0x46, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x6e, 0xe9,
-  0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x46, 0xb4, 0xb4, 0xb4,
-  0xb4, 0xb4, 0x6e, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x18, 0x00, 0x00, 0x13, 0x35, 0x37, 0x17, 0x37, 0x17,
-  0x37, 0x17, 0x37, 0x33, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x23,
-  0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x69, 0x63, 0xa2, 0xa2, 0xa2,
-  0xa2, 0xa2, 0x3f, 0x7d, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1,
-  0x59, 0x63, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x3f, 0x02, 0x2d, 0xaa, 0x6e,
-  0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
-  0x77, 0x78, 0xe9, 0x6e, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x21, 0x15, 0x21, 0x15,
-  0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35,
-  0x21, 0x11, 0x07, 0x27, 0x02, 0xdc, 0x51, 0x01, 0x61, 0x6c, 0xd1, 0x01,
-  0x0a, 0xfe, 0xf6, 0x01, 0x0a, 0xfe, 0xf6, 0x99, 0xfe, 0xf7, 0x01, 0x09,
-  0xfe, 0xf7, 0x01, 0x09, 0xd3, 0x6c, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea,
-  0xfe, 0x8e, 0xaa, 0xaa, 0xaa, 0xfe, 0xac, 0x01, 0x54, 0xaa, 0xaa, 0xaa,
-  0x01, 0x72, 0xea, 0x78, 0x00, 0x01, 0x01, 0x79, 0xff, 0xf9, 0x04, 0x8e,
-  0x05, 0xd5, 0x00, 0x19, 0x00, 0x00, 0x05, 0x23, 0x01, 0x37, 0x17, 0x11,
-  0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15,
-  0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x37, 0x17, 0x03, 0x2b, 0x51, 0xfe,
-  0x9f, 0x6c, 0xd1, 0xfe, 0xf6, 0x01, 0x0a, 0xfe, 0xf6, 0x01, 0x0a, 0x99,
-  0x01, 0x09, 0xfe, 0xf7, 0x01, 0x09, 0xfe, 0xf7, 0xd3, 0x6c, 0x07, 0x01,
-  0x8a, 0x78, 0xea, 0x01, 0x72, 0xaa, 0xaa, 0xaa, 0x01, 0x54, 0xfe, 0xac,
-  0xaa, 0xaa, 0xaa, 0xfe, 0x8e, 0xea, 0x78, 0x00, 0x00, 0x03, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07,
-  0x01, 0x35, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x5a, 0x01, 0x62, 0x6c,
-  0xd2, 0x01, 0x4c, 0xfe, 0xb4, 0xd2, 0x6c, 0x01, 0x7f, 0xe6, 0x99, 0xe5,
-  0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0xe9, 0x78, 0x01, 0x61,
-  0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x03, 0x01, 0x79, 0x00, 0x00, 0x04, 0x90,
-  0x05, 0xdc, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x01, 0x33,
-  0x01, 0x07, 0x27, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x33, 0x15, 0x23,
-  0x15, 0x33, 0x11, 0x23, 0x02, 0xdc, 0x51, 0x01, 0x62, 0x6c, 0xd2, 0x99,
-  0xd3, 0x6c, 0x01, 0x3f, 0x99, 0x99, 0x99, 0x99, 0x05, 0xdc, 0xfe, 0x76,
-  0x78, 0xea, 0xfe, 0x8e, 0x01, 0x72, 0xea, 0x78, 0xfe, 0x56, 0xfe, 0xaa,
-  0xff, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01,
-  0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x25, 0x33, 0x15, 0x23,
-  0x27, 0x15, 0x23, 0x35, 0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0xb4,
-  0x01, 0x4c, 0xd1, 0x6c, 0x01, 0x61, 0xfc, 0x3a, 0xe5, 0xe5, 0x99, 0xe6,
-  0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0xaa, 0xe9, 0x78, 0xfe, 0x77, 0x28,
-  0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x03, 0x01, 0x79, 0xff, 0xf9, 0x04, 0x90,
-  0x05, 0xd5, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x05, 0x01,
-  0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x03, 0x35, 0x33, 0x15,
-  0x03, 0x11, 0x33, 0x11, 0x02, 0xdc, 0xfe, 0x9d, 0x6c, 0xd3, 0x99, 0xd2,
-  0x6c, 0xfe, 0x9e, 0x75, 0x99, 0x99, 0x99, 0x07, 0x01, 0x8a, 0x78, 0xea,
-  0x01, 0x72, 0xfe, 0x8e, 0xea, 0x78, 0xfe, 0x76, 0x03, 0x34, 0xfe, 0xfe,
-  0x01, 0xa8, 0x01, 0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x60,
-  0x00, 0xcb, 0x05, 0xa0, 0x04, 0x39, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x15,
-  0x21, 0x17, 0x07, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x17, 0x07,
-  0x05, 0x9f, 0xfc, 0x56, 0xd3, 0x6c, 0xfe, 0x9d, 0x99, 0x99, 0x01, 0x63,
-  0x6c, 0xd3, 0x02, 0xd7, 0xaa, 0xea, 0x78, 0x01, 0x8a, 0xfe, 0x7e, 0x03,
-  0x5c, 0xfe, 0x80, 0x01, 0x8a, 0x78, 0xea, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x00, 0xcb, 0x05, 0xa9, 0x04, 0x39, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x21,
-  0x27, 0x37, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x01, 0x27, 0x37, 0x21,
-  0x69, 0x03, 0xaa, 0xd3, 0x6c, 0x01, 0x63, 0x99, 0x99, 0xfe, 0x9d, 0x6c,
-  0xd3, 0xfc, 0x56, 0x02, 0xd7, 0xea, 0x78, 0xfe, 0x76, 0x01, 0x80, 0xfc,
-  0xa4, 0x01, 0x82, 0xfe, 0x76, 0x78, 0xea, 0x00, 0x00, 0x02, 0x00, 0x31,
-  0x00, 0x86, 0x05, 0xa0, 0x04, 0x7e, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
-  0x01, 0x03, 0x13, 0x35, 0x21, 0x11, 0x21, 0x13, 0x09, 0x01, 0x11, 0x21,
-  0x11, 0x21, 0x01, 0xa1, 0xf0, 0xf0, 0x03, 0xa4, 0xfc, 0x5c, 0x5a, 0xfe,
-  0x37, 0x01, 0xc9, 0x03, 0xa4, 0xfc, 0x5c, 0x03, 0x8c, 0xfe, 0xf6, 0xfe,
-  0xf6, 0x83, 0x01, 0x0e, 0xfd, 0x7d, 0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef,
-  0xfe, 0x2a, 0x00, 0x00, 0x00, 0x02, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce,
-  0x06, 0x08, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x0b, 0x01, 0x33,
-  0x11, 0x33, 0x11, 0x05, 0x09, 0x01, 0x23, 0x11, 0x21, 0x11, 0x03, 0xf4,
-  0xf0, 0xef, 0x76, 0xf3, 0xfd, 0xbd, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0xfe,
-  0x59, 0x04, 0x70, 0x01, 0x0a, 0xfe, 0xf6, 0xfb, 0xf4, 0x04, 0x0c, 0x64,
-  0x01, 0xfc, 0xfe, 0x04, 0xfb, 0xf4, 0x04, 0x0c, 0x00, 0x02, 0x00, 0x40,
-  0x00, 0x86, 0x05, 0xaf, 0x04, 0x7e, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
-  0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x13, 0x01, 0x11, 0x21, 0x11, 0x21,
-  0x11, 0x01, 0x04, 0x3f, 0xfc, 0x5c, 0x03, 0xa4, 0xf0, 0xfe, 0xb6, 0xfc,
-  0x5c, 0x03, 0xa4, 0x01, 0xc9, 0x03, 0x8c, 0x83, 0xfe, 0xf2, 0x83, 0x01,
-  0x0a, 0xfe, 0x04, 0x01, 0x11, 0x01, 0xd6, 0x01, 0x11, 0xfe, 0x04, 0x00,
-  0x00, 0x02, 0x01, 0x3b, 0xff, 0xcd, 0x04, 0xce, 0x05, 0xd5, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x01, 0x23, 0x11, 0x23, 0x11, 0x23, 0x13, 0x01,
-  0x33, 0x11, 0x21, 0x11, 0x33, 0x01, 0x03, 0xf4, 0x76, 0xf3, 0x76, 0xef,
-  0xfe, 0x37, 0xf6, 0x01, 0xa7, 0xf5, 0xfe, 0x37, 0x01, 0x65, 0x04, 0x0c,
-  0xfb, 0xf4, 0xfe, 0xf6, 0x01, 0x6e, 0x04, 0x0c, 0xfb, 0xf4, 0xfe, 0x04,
-  0x00, 0x04, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23,
-  0x09, 0x01, 0x23, 0x03, 0x11, 0x33, 0x0b, 0x01, 0x33, 0x11, 0x01, 0x11,
-  0x21, 0x11, 0x05, 0x23, 0x15, 0x33, 0x03, 0xd8, 0xfe, 0x59, 0xf6, 0x01,
-  0xc9, 0x01, 0xc9, 0xf5, 0x5a, 0x76, 0xf0, 0xef, 0x76, 0x01, 0x4d, 0xfe,
-  0x59, 0x01, 0x4d, 0xf3, 0xf3, 0x02, 0x24, 0x01, 0xe8, 0x01, 0xfc, 0xfe,
-  0x04, 0xfe, 0x7c, 0x01, 0xe8, 0x01, 0x0a, 0xfe, 0xf6, 0xfe, 0x18, 0xfe,
-  0xd4, 0xfe, 0xa4, 0x01, 0x5c, 0x64, 0x94, 0x00, 0x00, 0x02, 0x01, 0x3b,
-  0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00,
-  0x29, 0x01, 0x11, 0x33, 0x11, 0x23, 0x09, 0x01, 0x23, 0x11, 0x33, 0x05,
-  0x23, 0x15, 0x21, 0x35, 0x23, 0x11, 0x33, 0x0b, 0x01, 0x33, 0x04, 0x8c,
-  0xfc, 0xf1, 0xb4, 0xf6, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0xb4, 0xfd, 0xff,
-  0xb4, 0x02, 0x5b, 0xb4, 0x76, 0xf0, 0xef, 0x76, 0x01, 0x5c, 0x02, 0xb0,
-  0x01, 0xfc, 0xfe, 0x04, 0xfd, 0x50, 0x64, 0x94, 0x94, 0x03, 0x78, 0x01,
-  0x0a, 0xfe, 0xf6, 0x00, 0x00, 0x03, 0x01, 0x20, 0x00, 0x00, 0x04, 0xe9,
-  0x06, 0x08, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x19, 0x00, 0x00, 0x25, 0x23,
-  0x15, 0x21, 0x35, 0x23, 0x11, 0x33, 0x27, 0x21, 0x07, 0x33, 0x01, 0x21,
-  0x11, 0x33, 0x11, 0x21, 0x09, 0x01, 0x21, 0x11, 0x33, 0x01, 0x33, 0x27,
-  0x02, 0x8b, 0xb4, 0x02, 0x5b, 0xb4, 0x91, 0x5a, 0xfe, 0x9f, 0x5a, 0x91,
-  0x02, 0x01, 0xfc, 0xf1, 0xb4, 0xfe, 0xef, 0x01, 0xe4, 0x01, 0xe4, 0xfe,
-  0xf0, 0xb4, 0xfe, 0x10, 0xd1, 0x69, 0xf8, 0x94, 0x94, 0x03, 0x5a, 0x64,
-  0x64, 0xfb, 0xae, 0x01, 0x5c, 0x02, 0x92, 0x02, 0x1a, 0xfd, 0xe6, 0xfd,
-  0x6e, 0x03, 0xaa, 0x74, 0x00, 0x03, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce,
-  0x06, 0x08, 0x00, 0x06, 0x00, 0x11, 0x00, 0x18, 0x00, 0x00, 0x25, 0x23,
-  0x15, 0x21, 0x11, 0x07, 0x33, 0x01, 0x21, 0x11, 0x33, 0x11, 0x23, 0x09,
-  0x01, 0x23, 0x11, 0x33, 0x01, 0x11, 0x21, 0x35, 0x23, 0x11, 0x33, 0x02,
-  0x7d, 0xa6, 0x01, 0x00, 0xc2, 0x68, 0x02, 0x0f, 0xfc, 0xf1, 0xa6, 0xe8,
-  0x01, 0xc9, 0x01, 0xc9, 0xe8, 0xa7, 0xfe, 0xa5, 0x01, 0x01, 0xa7, 0x69,
-  0xf8, 0x94, 0x04, 0xe4, 0xd8, 0xfb, 0x90, 0x01, 0x5c, 0x02, 0xb0, 0x01,
-  0xfc, 0xfe, 0x04, 0xfd, 0x50, 0x03, 0xec, 0xfb, 0x1c, 0x94, 0x03, 0x78,
-  0x00, 0x03, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x06,
-  0x00, 0x11, 0x00, 0x17, 0x00, 0x00, 0x25, 0x11, 0x33, 0x0b, 0x01, 0x33,
-  0x11, 0x05, 0x21, 0x11, 0x23, 0x13, 0x23, 0x09, 0x01, 0x23, 0x13, 0x23,
-  0x03, 0x33, 0x0b, 0x01, 0x33, 0x37, 0x03, 0x7e, 0x76, 0xf0, 0xef, 0x76,
-  0x01, 0x4d, 0xfe, 0x59, 0xf6, 0xfc, 0xfc, 0x01, 0xc9, 0x01, 0xc9, 0xfc,
-  0xfc, 0xf5, 0x61, 0x7d, 0xf0, 0xef, 0x7c, 0x73, 0x64, 0x02, 0xf4, 0x01,
-  0x0a, 0xfe, 0xf6, 0xfd, 0x0c, 0x64, 0x02, 0xf4, 0x01, 0x18, 0x01, 0xfc,
-  0xfe, 0x04, 0xfe, 0xe8, 0x01, 0x7c, 0x01, 0x0a, 0xfe, 0xf6, 0x80, 0x00,
-  0x00, 0x03, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x0a,
-  0x00, 0x19, 0x00, 0x1f, 0x00, 0x00, 0x25, 0x23, 0x15, 0x21, 0x35, 0x23,
-  0x11, 0x33, 0x0b, 0x01, 0x33, 0x01, 0x21, 0x11, 0x33, 0x11, 0x23, 0x13,
-  0x23, 0x09, 0x01, 0x23, 0x13, 0x23, 0x11, 0x33, 0x01, 0x33, 0x0b, 0x01,
-  0x33, 0x37, 0x02, 0x8b, 0xb4, 0x02, 0x5b, 0xb4, 0x76, 0xf0, 0xef, 0x76,
-  0x02, 0x01, 0xfc, 0xf1, 0xb4, 0xf6, 0xfc, 0xfc, 0x01, 0xc9, 0x01, 0xc9,
-  0xfc, 0xfc, 0xf5, 0xb4, 0xfe, 0xeb, 0x7d, 0xf0, 0xef, 0x7c, 0x73, 0xf8,
-  0x94, 0x94, 0x02, 0x60, 0x01, 0x0a, 0xfe, 0xf6, 0xfc, 0xa8, 0x01, 0x5c,
-  0x01, 0x98, 0x01, 0x18, 0x01, 0xfc, 0xfe, 0x04, 0xfe, 0xe8, 0xfe, 0x68,
-  0x03, 0x14, 0x01, 0x0a, 0xfe, 0xf6, 0x80, 0x00, 0x00, 0x02, 0x00, 0x69,
-  0x00, 0x86, 0x05, 0xd7, 0x04, 0x7e, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00,
-  0x37, 0x11, 0x21, 0x15, 0x21, 0x11, 0x09, 0x01, 0x11, 0x21, 0x15, 0x03,
-  0x35, 0x23, 0x11, 0x33, 0x35, 0x21, 0x15, 0x13, 0x03, 0x15, 0x69, 0x01,
-  0x39, 0x02, 0x6c, 0x01, 0xc9, 0xfe, 0x37, 0xfd, 0x94, 0x5a, 0x85, 0x85,
-  0x03, 0x20, 0xef, 0xef, 0xcf, 0x03, 0x66, 0xc8, 0x01, 0x11, 0xfe, 0x04,
-  0xfe, 0x04, 0x01, 0x11, 0xc8, 0x02, 0x3a, 0xc8, 0xfd, 0x62, 0xc8, 0x83,
-  0x01, 0x0a, 0x01, 0x0a, 0x83, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6d,
-  0x00, 0x00, 0x05, 0xac, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x0f, 0x00, 0x00,
-  0x01, 0x15, 0x21, 0x11, 0x23, 0x11, 0x01, 0x37, 0x21, 0x15, 0x21, 0x01,
-  0x07, 0x01, 0x11, 0x23, 0x05, 0xac, 0xfb, 0x1b, 0x59, 0x01, 0x05, 0x39,
-  0x01, 0xf4, 0xfe, 0xd7, 0x03, 0x08, 0x6c, 0xfc, 0xf8, 0x98, 0x05, 0xd5,
-  0x63, 0xfa, 0x8e, 0x05, 0xd5, 0xfe, 0x9f, 0x3f, 0xa9, 0xfc, 0xa2, 0x78,
-  0x03, 0x5e, 0xfe, 0xb6, 0x00, 0x02, 0x00, 0x6d, 0x00, 0x00, 0x05, 0xac,
-  0x05, 0xd5, 0x00, 0x05, 0x00, 0x0f, 0x00, 0x00, 0x33, 0x35, 0x21, 0x11,
-  0x33, 0x11, 0x01, 0x07, 0x21, 0x35, 0x21, 0x01, 0x37, 0x01, 0x11, 0x33,
-  0x6e, 0x04, 0xe5, 0x59, 0xfe, 0xfb, 0x39, 0xfe, 0x0c, 0x01, 0x29, 0xfc,
-  0xf8, 0x6c, 0x03, 0x08, 0x98, 0x63, 0x05, 0x72, 0xfa, 0x2b, 0x01, 0x61,
-  0x3f, 0xa9, 0x03, 0x5e, 0x78, 0xfc, 0xa2, 0x01, 0x4a, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x3b, 0xff, 0xcd, 0x04, 0xce, 0x06, 0x08, 0x00, 0x09,
-  0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x33, 0x0b, 0x01, 0x33, 0x11, 0x23,
-  0x1b, 0x01, 0x27, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23, 0x09, 0x01, 0x23,
-  0x03, 0x7e, 0x76, 0xf0, 0xef, 0x76, 0x76, 0xef, 0xf0, 0x1c, 0xf5, 0xfe,
-  0x37, 0xfe, 0x37, 0xf6, 0xf6, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0x01, 0x65,
-  0x03, 0x0b, 0x01, 0x0a, 0xfe, 0xf6, 0xfc, 0xf5, 0xfe, 0xf6, 0x01, 0x0a,
-  0x64, 0xfe, 0x04, 0x01, 0xfc, 0x02, 0x43, 0x01, 0xfc, 0xfe, 0x04, 0x00,
-  0x00, 0x03, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x29,
-  0x00, 0x35, 0x00, 0x41, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x27, 0x37, 0x01,
-  0x24, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x26, 0x27, 0x26, 0x27,
-  0x13, 0x21, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36,
-  0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0xc4, 0x05, 0x09, 0x18, 0x2d,
-  0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3d, 0x29, 0x2d, 0x18, 0x09, 0x06, 0xab,
-  0xab, 0x06, 0x09, 0x18, 0x2d, 0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3c, 0x2a,
-  0x2d, 0x18, 0x09, 0x05, 0x01, 0x3c, 0xd1, 0x6c, 0x01, 0x61, 0xfc, 0xbc,
-  0x4a, 0x1f, 0x25, 0x16, 0x17, 0x0d, 0x01, 0x47, 0x0f, 0x16, 0x1a, 0x20,
-  0x5d, 0xfe, 0xbc, 0x0d, 0x16, 0x1b, 0x20, 0x1f, 0x4a, 0x20, 0x20, 0x1a,
-  0x17, 0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0x18, 0x18, 0x40, 0x32, 0x31,
-  0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x40, 0x18, 0x18, 0xaa, 0x1a, 0x19,
-  0x40, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x40, 0x19, 0x1a,
-  0xe9, 0x78, 0xfe, 0x77, 0x9d, 0x0f, 0x12, 0x1a, 0x1c, 0x1e, 0x23, 0x17,
-  0x1c, 0x10, 0xfe, 0xf0, 0x1d, 0x1a, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c,
-  0x1a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6b, 0xff, 0xf9, 0x05, 0x9c,
-  0x05, 0xdc, 0x10, 0x27, 0x08, 0x6d, 0x01, 0x0e, 0x00, 0x00, 0x10, 0x07,
-  0x08, 0x6f, 0xfe, 0xf2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0xfe, 0x74, 0x05, 0xaf, 0x06, 0x90, 0x00, 0x19, 0x00, 0x00, 0x01, 0x07,
-  0x17, 0x15, 0x01, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x21, 0x35,
-  0x21, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x15, 0x07, 0x17,
-  0x05, 0xae, 0xe5, 0xe5, 0xfe, 0x9f, 0x6c, 0xd1, 0xfb, 0xb7, 0x04, 0x49,
-  0xc1, 0xc1, 0xfb, 0xb7, 0x04, 0x49, 0xc1, 0xc1, 0xfb, 0xb7, 0x04, 0x49,
-  0xd1, 0x6c, 0x01, 0x61, 0xe5, 0xe5, 0x02, 0x55, 0xff, 0xff, 0x5a, 0xfe,
-  0x77, 0x78, 0xe9, 0xaa, 0xd7, 0xd7, 0xaa, 0xd7, 0xd7, 0xaa, 0xe9, 0x78,
-  0xfe, 0x77, 0x5a, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0xc0, 0x05, 0xa0, 0x04, 0x44, 0x00, 0x11, 0x00, 0x00, 0x13, 0x35,
-  0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0xfb, 0x99,
-  0x01, 0xb5, 0xfe, 0x4b, 0x99, 0xfe, 0x05, 0xd2, 0x6c, 0x02, 0x55, 0x5a,
-  0x01, 0x89, 0x78, 0xe9, 0x01, 0x6d, 0xfe, 0x93, 0xaa, 0xfe, 0x93, 0x01,
-  0x6d, 0xe9, 0x78, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xc0, 0x05, 0xaf,
-  0x04, 0x44, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x11,
-  0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x27, 0x37, 0x01,
-  0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0x06, 0x99, 0xfe, 0x4a, 0x01,
-  0xb6, 0x99, 0x01, 0xfa, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x55, 0xfe, 0x77,
-  0x78, 0xe9, 0xfe, 0x93, 0x01, 0x6d, 0xaa, 0x01, 0x6d, 0xfe, 0x93, 0xe9,
-  0x78, 0xfe, 0x77, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xc0, 0x05, 0xaf,
-  0x04, 0x44, 0x00, 0x17, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x27,
-  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x11, 0x23, 0x11, 0x21, 0x17,
-  0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x02, 0xb8, 0x99, 0x01, 0x61, 0xd1,
-  0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0x9f, 0x99, 0xfe, 0x9e,
-  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x02, 0xd7, 0x01, 0x6d,
-  0xfe, 0x93, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xfe,
-  0x93, 0x01, 0x6d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0xc0, 0x05, 0xa0, 0x04, 0x44, 0x00, 0x19,
-  0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x33,
-  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23,
-  0x11, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0x7d, 0x99,
-  0x99, 0x99, 0x01, 0x01, 0xfe, 0xff, 0x99, 0x99, 0x99, 0xfe, 0x83, 0xd2,
-  0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x6d, 0xfe, 0x93,
-  0x01, 0x6d, 0xfe, 0x93, 0xaa, 0xfe, 0x93, 0x01, 0x6d, 0xfe, 0x93, 0x01,
-  0x6d, 0xe9, 0x78, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xc0, 0x05, 0xaf,
-  0x04, 0x44, 0x00, 0x19, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x11,
-  0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x33, 0x11, 0x21, 0x27, 0x37, 0x01, 0x05, 0xae, 0xfe, 0x9f,
-  0x6c, 0xd1, 0xfe, 0x84, 0x99, 0x99, 0x99, 0xfe, 0xfe, 0x01, 0x02, 0x99,
-  0x99, 0x99, 0x01, 0x7c, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x55, 0xfe, 0x77,
-  0x78, 0xe9, 0xfe, 0x93, 0x01, 0x6d, 0xfe, 0x93, 0x01, 0x6d, 0xaa, 0x01,
-  0x6d, 0xfe, 0x93, 0x01, 0x6d, 0xfe, 0x93, 0xe9, 0x78, 0xfe, 0x77, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0xc0, 0x05, 0xaf, 0x04, 0x44, 0x00, 0x1f,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x27,
-  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11,
-  0x23, 0x11, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x02, 0x59,
-  0x7e, 0x5a, 0x7e, 0x01, 0x03, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
-  0xd1, 0xfe, 0xfd, 0x7e, 0x5a, 0x7e, 0xfe, 0xfd, 0xd2, 0x6c, 0xfe, 0x9e,
-  0x01, 0x62, 0x6c, 0xd2, 0x02, 0xd7, 0x01, 0x6d, 0xfe, 0x93, 0x01, 0x6d,
-  0xfe, 0x93, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xfe,
-  0x93, 0x01, 0x6d, 0xfe, 0x93, 0x01, 0x6d, 0xe9, 0x78, 0x01, 0x89, 0x5a,
-  0x01, 0x89, 0x78, 0xe9, 0x00, 0x02, 0x00, 0x31, 0x00, 0xc4, 0x05, 0xa0,
-  0x04, 0x40, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x07, 0x05,
-  0x11, 0x09, 0x01, 0x11, 0x21, 0x15, 0x01, 0x7b, 0xe1, 0x01, 0x29, 0xfe,
-  0x6f, 0x01, 0x91, 0x03, 0xdc, 0x01, 0x88, 0x01, 0xf4, 0xfa, 0x41, 0xfe,
-  0x83, 0x01, 0xbe, 0x01, 0xbe, 0xfe, 0x83, 0x82, 0x00, 0x02, 0x00, 0x69,
-  0x00, 0xc4, 0x05, 0xd7, 0x04, 0x40, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00,
-  0x01, 0x37, 0x27, 0x03, 0x21, 0x35, 0x21, 0x11, 0x09, 0x01, 0x04, 0x8e,
-  0xe0, 0xe0, 0x48, 0xfc, 0x23, 0x03, 0xdd, 0x01, 0x91, 0xfe, 0x6f, 0x01,
-  0x88, 0xfa, 0xfa, 0xfe, 0xc5, 0x82, 0x01, 0x7d, 0xfe, 0x42, 0xfe, 0x42,
-  0x00, 0x03, 0x00, 0x31, 0x00, 0xc4, 0x05, 0xd7, 0x04, 0x40, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x37, 0x27, 0x01, 0x11, 0x07,
-  0x05, 0x21, 0x11, 0x09, 0x01, 0x11, 0x21, 0x11, 0x09, 0x01, 0x04, 0x8e,
-  0xe0, 0xe0, 0xfc, 0xed, 0xe1, 0x03, 0xac, 0xfd, 0x7d, 0xfe, 0x6f, 0x01,
-  0x91, 0x02, 0x83, 0x01, 0x91, 0xfe, 0x6f, 0x01, 0x88, 0xfa, 0xfa, 0xfe,
-  0x0c, 0x01, 0xf4, 0xfa, 0x41, 0xfe, 0x83, 0x01, 0xbe, 0x01, 0xbe, 0xfe,
-  0x83, 0x01, 0x7d, 0xfe, 0x42, 0xfe, 0x42, 0x00, 0x00, 0x02, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00,
-  0x25, 0x13, 0x21, 0x13, 0x01, 0x33, 0x13, 0x21, 0x13, 0x33, 0x01, 0x02,
-  0x76, 0xf8, 0xfe, 0x11, 0x90, 0xfd, 0xff, 0xc0, 0x7a, 0x02, 0x5e, 0x7b,
-  0xbd, 0xfe, 0x00, 0xc7, 0x02, 0xe7, 0xfc, 0x52, 0x05, 0xd5, 0xfe, 0x81,
-  0x01, 0x7f, 0xfa, 0x2b, 0x00, 0x01, 0x00, 0x79, 0xff, 0xe3, 0x03, 0xfd,
-  0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x10, 0x12, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x23, 0x26, 0x27, 0x26, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
-  0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22, 0x02,
-  0x7a, 0xee, 0xe2, 0xe2, 0x78, 0x3b, 0x1e, 0xb6, 0x10, 0x19, 0x47, 0x8d,
-  0x8c, 0x8e, 0x8e, 0x8c, 0x8d, 0x47, 0x19, 0x10, 0xb6, 0x1e, 0x3b, 0x78,
-  0xe2, 0xe2, 0xee, 0x02, 0xe9, 0x01, 0x7a, 0x01, 0x8d, 0xc6, 0x63, 0x90,
-  0x49, 0x37, 0x99, 0xfe, 0xcd, 0xfe, 0xcc, 0xfe, 0xcc, 0xfe, 0xcd, 0x99,
-  0x37, 0x49, 0x90, 0x63, 0xc5, 0x01, 0x8c, 0x00, 0x00, 0x02, 0x00, 0x55,
-  0xff, 0xe3, 0x03, 0x64, 0x05, 0x4c, 0x00, 0x20, 0x00, 0x30, 0x00, 0x00,
-  0x05, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x02, 0x07, 0x06, 0x01, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x01, 0x89, 0x7f, 0x52, 0x62, 0x56, 0x59, 0xa0, 0x69, 0x53, 0x31,
-  0x21, 0x0c, 0x1d, 0x40, 0xa9, 0x40, 0x63, 0x68, 0x5e, 0xf1, 0x67, 0x30,
-  0x17, 0x39, 0x92, 0x74, 0xfe, 0xe1, 0x28, 0x2a, 0x41, 0x3a, 0x2e, 0x40,
-  0x30, 0x28, 0x14, 0x51, 0x8a, 0x77, 0x34, 0x21, 0x1d, 0x55, 0x65, 0xb7,
-  0xbe, 0x94, 0x98, 0x49, 0x2b, 0x48, 0x51, 0x5c, 0x87, 0x4e, 0xad, 0x2c,
-  0xa8, 0x1f, 0xf6, 0x74, 0xad, 0x71, 0x83, 0xfe, 0xb8, 0x9c, 0x7a, 0x01,
-  0x53, 0x64, 0x36, 0x39, 0x2d, 0x3e, 0x65, 0x53, 0x59, 0xd7, 0xae, 0x6c,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x21, 0x35, 0x04, 0x17, 0xfc, 0x9e, 0x02, 0xac, 0xfd, 0x54, 0x02, 0xac,
-  0xfd, 0x54, 0x05, 0xd5, 0xfa, 0x2b, 0xaa, 0x01, 0xec, 0xaa, 0x01, 0xeb,
-  0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0xff, 0xa2, 0x04, 0x17,
-  0x06, 0x35, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x07, 0x23, 0x37, 0x23, 0x35, 0x33, 0x13, 0x21, 0x35, 0x21, 0x13,
-  0x21, 0x35, 0x21, 0x37, 0x33, 0x0f, 0x01, 0x03, 0x33, 0x11, 0x01, 0x03,
-  0x21, 0x11, 0x04, 0x17, 0xfd, 0x90, 0x1a, 0x99, 0x1a, 0x59, 0x89, 0x88,
-  0xfe, 0xef, 0x01, 0x40, 0x89, 0xfe, 0x37, 0x01, 0xf8, 0x1b, 0x99, 0x1b,
-  0x2f, 0x89, 0xd3, 0xfe, 0xff, 0x89, 0x01, 0x8a, 0x05, 0xd5, 0xfa, 0x2b,
-  0x5e, 0x5e, 0xaa, 0x01, 0xec, 0xaa, 0x01, 0xeb, 0xaa, 0x60, 0x60, 0xaa,
-  0xfe, 0x15, 0x01, 0xeb, 0xfd, 0x6b, 0xfe, 0x14, 0x01, 0xec, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x8b, 0xff, 0xec, 0x05, 0xbb, 0x05, 0xae, 0x00, 0x1b,
-  0x00, 0x28, 0x00, 0x36, 0x00, 0x00, 0x01, 0x37, 0x33, 0x07, 0x16, 0x17,
-  0x16, 0x10, 0x02, 0x04, 0x23, 0x22, 0x27, 0x26, 0x27, 0x07, 0x23, 0x37,
-  0x26, 0x27, 0x26, 0x10, 0x12, 0x24, 0x33, 0x32, 0x17, 0x16, 0x09, 0x01,
-  0x27, 0x26, 0x23, 0x22, 0x04, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x09,
-  0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x24, 0x37, 0x36, 0x37, 0x26, 0x27,
-  0x26, 0x04, 0x87, 0x50, 0x60, 0x73, 0x5e, 0x3e, 0x5a, 0xb4, 0xfe, 0xc3,
-  0xa6, 0xa9, 0x9e, 0x32, 0x2c, 0x71, 0x5e, 0x99, 0x39, 0x2a, 0x59, 0xb2,
-  0x01, 0x3c, 0xa9, 0xa6, 0x9f, 0x10, 0xfd, 0x1b, 0x02, 0xa9, 0x0d, 0x83,
-  0x89, 0x8b, 0xfe, 0xfa, 0x4a, 0x48, 0x01, 0x01, 0x48, 0x21, 0x03, 0x10,
-  0xfd, 0x51, 0x23, 0x29, 0x82, 0x8b, 0x89, 0x01, 0x06, 0x4a, 0x4a, 0x01,
-  0x01, 0x4a, 0x34, 0x05, 0x3b, 0x6e, 0x9d, 0x53, 0x7a, 0xb2, 0xfe, 0x80,
-  0xfe, 0x9d, 0xbe, 0x5f, 0x1e, 0x27, 0x9c, 0xd2, 0x42, 0x54, 0xb1, 0x01,
-  0x80, 0x01, 0x63, 0xbe, 0x5f, 0x0a, 0xfb, 0xe9, 0x03, 0xa5, 0x08, 0x4e,
-  0x9d, 0x93, 0x91, 0x9b, 0x9b, 0x91, 0x40, 0x03, 0x44, 0xfc, 0x52, 0x1f,
-  0x18, 0x4f, 0x9d, 0x93, 0x91, 0x9b, 0x9b, 0x91, 0x67, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xfa, 0x00, 0x00, 0x04, 0xd7, 0x05, 0xc1, 0x00, 0x02,
-  0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01, 0x33, 0x01, 0x21, 0x02,
-  0x68, 0xfe, 0x87, 0x02, 0xf1, 0xfe, 0x24, 0xc9, 0x02, 0x09, 0xfb, 0x25,
-  0x04, 0xee, 0xfb, 0xc4, 0x05, 0x0f, 0xfa, 0x3f, 0x00, 0x02, 0xff, 0xfa,
-  0x00, 0x00, 0x04, 0xd7, 0x05, 0xc1, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00,
-  0x25, 0x01, 0x21, 0x09, 0x01, 0x21, 0x01, 0x02, 0x68, 0x01, 0x78, 0xfd,
-  0x0f, 0x01, 0x15, 0xfd, 0xf7, 0x04, 0xdb, 0xfd, 0xf7, 0xd3, 0x04, 0x3c,
-  0xfa, 0xf1, 0x05, 0xc1, 0xfa, 0x3f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x02, 0x35,
-  0x34, 0x12, 0x24, 0x33, 0x21, 0x15, 0x21, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x21, 0x15, 0x01, 0x35, 0x06, 0x39, 0x43, 0x7d, 0x7c, 0x85, 0x02,
-  0x73, 0xfd, 0x8d, 0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02,
-  0x73, 0xfd, 0x8d, 0x85, 0x7c, 0x7d, 0x43, 0x3a, 0x08, 0x04, 0x76, 0x02,
-  0x73, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0x01, 0x60, 0xbb,
-  0xb9, 0x01, 0x60, 0xc8, 0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0,
-  0x00, 0x03, 0x00, 0x9d, 0xfe, 0xe5, 0x05, 0xa9, 0x06, 0xaf, 0x00, 0x1e,
-  0x00, 0x26, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21,
-  0x03, 0x21, 0x15, 0x21, 0x03, 0x16, 0x33, 0x21, 0x15, 0x21, 0x22, 0x27,
-  0x03, 0x27, 0x13, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x24, 0x3b,
-  0x01, 0x01, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x13, 0x37, 0x13, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x06, 0x15, 0x04, 0x5c, 0x87, 0x42, 0x01, 0x07,
-  0xfe, 0xc5, 0xa6, 0x01, 0xe1, 0xfd, 0xea, 0x9e, 0x20, 0x21, 0x02, 0x73,
-  0xfd, 0x8d, 0x3b, 0x38, 0x5a, 0x87, 0x56, 0x28, 0x27, 0xa0, 0xaa, 0xaa,
-  0x01, 0x40, 0xad, 0xd2, 0xfd, 0x2e, 0x3f, 0x4c, 0x74, 0x1a, 0x1a, 0x90,
-  0x36, 0xa5, 0x9e, 0x85, 0x7c, 0x70, 0x50, 0x42, 0x06, 0xaf, 0x37, 0xca,
-  0x9f, 0xfe, 0x04, 0xa0, 0xfe, 0x1d, 0x05, 0x9f, 0x0b, 0xfe, 0xee, 0x37,
-  0x01, 0x08, 0x13, 0x18, 0x63, 0x01, 0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8,
-  0xfc, 0xc5, 0x4a, 0x78, 0x91, 0x48, 0x10, 0x0d, 0x01, 0xb8, 0xa0, 0x01,
-  0xfc, 0x4e, 0x47, 0x92, 0x78, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x16, 0x00, 0x00, 0x25, 0x20,
-  0x24, 0x35, 0x34, 0x24, 0x29, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x07,
-  0x21, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x21, 0x15, 0x02, 0xda, 0xfe,
-  0xf6, 0xfe, 0xf3, 0x01, 0x0d, 0x01, 0x0a, 0x01, 0x8e, 0xfe, 0x72, 0xd1,
-  0x5e, 0x46, 0x1b, 0x03, 0x1e, 0xfc, 0xe2, 0x21, 0x40, 0x67, 0xc8, 0x01,
-  0x8e, 0x9b, 0xf6, 0xf0, 0xf0, 0xf6, 0x8e, 0x01, 0x01, 0x4f, 0x3a, 0x85,
-  0x8e, 0x91, 0x30, 0x51, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x21, 0x35, 0x21, 0x32, 0x04, 0x12, 0x15,
-  0x14, 0x02, 0x04, 0x23, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x21, 0x35, 0x05, 0x11, 0x06, 0x39, 0x43, 0x7e, 0x7b, 0x85, 0xfd,
-  0x8d, 0x02, 0x73, 0xad, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1, 0xad, 0xfd,
-  0x8d, 0x02, 0x73, 0x85, 0x7b, 0x7d, 0x44, 0x3a, 0x08, 0xfb, 0x8a, 0x03,
-  0x27, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0xfe, 0xa0, 0xbb,
-  0xb9, 0xfe, 0xa0, 0xc8, 0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0,
-  0x00, 0x03, 0x00, 0x9d, 0xfe, 0xe5, 0x05, 0xa9, 0x06, 0xaf, 0x00, 0x1e,
-  0x00, 0x26, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x27, 0x37, 0x21, 0x35, 0x21,
-  0x13, 0x21, 0x35, 0x21, 0x13, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x17,
-  0x13, 0x17, 0x03, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x04, 0x2b,
-  0x01, 0x01, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x07, 0x03, 0x33,
-  0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x01, 0xea, 0x87, 0x41, 0xfe, 0xfa,
-  0x01, 0x3a, 0xa7, 0xfe, 0x1f, 0x02, 0x15, 0x9f, 0x21, 0x20, 0xfd, 0x8d,
-  0x02, 0x73, 0x3a, 0x39, 0x5a, 0x87, 0x56, 0x27, 0x28, 0x9f, 0xab, 0xab,
-  0xfe, 0xc1, 0xad, 0xd3, 0x02, 0xd3, 0x3f, 0x4c, 0x75, 0x1a, 0x1a, 0x90,
-  0x35, 0xa6, 0x9f, 0x84, 0x7c, 0x71, 0x50, 0x42, 0xfe, 0xe5, 0x37, 0xca,
-  0x9f, 0x01, 0xfc, 0xa0, 0x01, 0xe3, 0x05, 0x9f, 0x0b, 0x01, 0x12, 0x37,
-  0xfe, 0xf8, 0x13, 0x18, 0x63, 0xfe, 0xa0, 0xbb, 0xb9, 0xfe, 0xa0, 0xc8,
-  0x03, 0x3b, 0x4a, 0x78, 0x91, 0x48, 0x10, 0x0d, 0xfe, 0x48, 0xa0, 0xfe,
-  0x04, 0x4e, 0x47, 0x92, 0x78, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x16, 0x00, 0x00, 0x01, 0x20,
-  0x04, 0x15, 0x14, 0x04, 0x29, 0x01, 0x35, 0x25, 0x32, 0x37, 0x36, 0x37,
-  0x21, 0x35, 0x05, 0x26, 0x27, 0x26, 0x07, 0x21, 0x35, 0x02, 0x51, 0x01,
-  0x0a, 0x01, 0x0d, 0xfe, 0xf3, 0xfe, 0xf6, 0xfe, 0x72, 0x01, 0x8e, 0xd1,
-  0x5e, 0x46, 0x1b, 0xfc, 0xe2, 0x03, 0x1e, 0x22, 0x3f, 0x68, 0xc7, 0xfe,
-  0x72, 0x04, 0x67, 0xf6, 0xf1, 0xef, 0xf6, 0x8e, 0x01, 0x50, 0x3a, 0x85,
-  0x8e, 0x01, 0x91, 0x31, 0x52, 0x01, 0x8e, 0x00, 0x00, 0x01, 0x01, 0x0e,
-  0x00, 0x00, 0x03, 0x87, 0x03, 0xe2, 0x00, 0x03, 0x00, 0x00, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0x0e, 0x02, 0x79, 0x03, 0xe2, 0xfc, 0x1e, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x8c, 0xfe, 0x77, 0x04, 0xe6, 0x05, 0xc1, 0x00, 0x07,
-  0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x8c, 0x04,
-  0x5a, 0xd8, 0xfd, 0x56, 0xd8, 0x05, 0xc1, 0xf8, 0xb6, 0x06, 0x7d, 0xf9,
-  0x83, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8c, 0xfe, 0x77, 0x04, 0xe6,
-  0x05, 0xc1, 0x00, 0x07, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x8c, 0xd8, 0x02, 0xaa, 0xd8, 0xfe, 0x77, 0x07, 0x4a, 0xf9,
-  0x83, 0x06, 0x7d, 0xf8, 0xb6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x16,
-  0xfe, 0x77, 0x04, 0xb6, 0x05, 0xc1, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x09, 0x01, 0x21, 0x15, 0x21, 0x35, 0x09, 0x01, 0x32, 0x04,
-  0x6c, 0xfc, 0xa1, 0x02, 0x5c, 0xfd, 0x90, 0x03, 0x8a, 0xfb, 0x61, 0x02,
-  0x8d, 0xfd, 0x8f, 0x05, 0xc1, 0xc1, 0xfd, 0x33, 0xfd, 0x04, 0xc0, 0x95,
-  0x03, 0x21, 0x02, 0xe3, 0x00, 0x01, 0x00, 0xc3, 0x02, 0x2d, 0x05, 0x46,
-  0x02, 0xd7, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0xc3, 0x04,
-  0x82, 0xfb, 0x7e, 0x02, 0xd7, 0xaa, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
-  0x21, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21,
-  0x01, 0x35, 0x21, 0x15, 0x03, 0x50, 0x97, 0xfe, 0x0a, 0x01, 0xf6, 0x97,
-  0x01, 0xf5, 0xfe, 0x0b, 0xfd, 0x73, 0x04, 0x82, 0x01, 0x83, 0xaa, 0x01,
-  0x83, 0xfe, 0x7d, 0xaa, 0x02, 0xd7, 0xaa, 0xaa, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x00, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
-  0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x19,
-  0x01, 0x33, 0x15, 0x23, 0x03, 0x50, 0x01, 0xf5, 0xfe, 0x0b, 0x97, 0xfe,
-  0x0a, 0x01, 0xf6, 0x97, 0x97, 0x04, 0xa0, 0xfe, 0x05, 0xaa, 0xfe, 0x05,
-  0x01, 0xfb, 0xaa, 0x01, 0xfb, 0x01, 0x35, 0xcc, 0xff, 0xff, 0x00, 0x00,
-  0xff, 0x42, 0x02, 0x6d, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x12, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x62, 0xff, 0x92, 0x03, 0xd0, 0x06, 0x25, 0x10, 0x07,
-  0x00, 0x3f, 0x01, 0x63, 0x00, 0x50, 0x00, 0x00, 0x00, 0x01, 0x00, 0xeb,
-  0x00, 0x00, 0x05, 0x1e, 0x05, 0x04, 0x00, 0x11, 0x00, 0x00, 0x01, 0x25,
-  0x37, 0x05, 0x11, 0x33, 0x11, 0x25, 0x17, 0x0d, 0x01, 0x07, 0x25, 0x11,
-  0x23, 0x11, 0x05, 0x27, 0x02, 0x6c, 0xfe, 0x7f, 0x4d, 0x01, 0x81, 0x97,
-  0x01, 0x81, 0x4c, 0xfe, 0x7f, 0x01, 0x81, 0x4c, 0xfe, 0x7f, 0x97, 0xfe,
-  0x7f, 0x4d, 0x02, 0x82, 0xf7, 0x93, 0xf7, 0x01, 0xef, 0xfe, 0x11, 0xf7,
-  0x93, 0xf7, 0xf7, 0x93, 0xf7, 0xfe, 0x11, 0x01, 0xef, 0xf7, 0x93, 0x00,
-  0xff, 0xff, 0x01, 0x23, 0x01, 0x47, 0x03, 0x5f, 0x03, 0xc2, 0x10, 0x07,
-  0x00, 0x72, 0x00, 0x74, 0xfd, 0xd2, 0x00, 0x00, 0xff, 0xff, 0x01, 0x35,
-  0x01, 0x59, 0x03, 0x4d, 0x03, 0xa9, 0x10, 0x06, 0x07, 0x57, 0x21, 0x88,
-  0x00, 0x01, 0x00, 0x36, 0xff, 0xd7, 0x04, 0x97, 0x06, 0x7d, 0x00, 0x0a,
-  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x01, 0x23, 0x01, 0x07, 0x27, 0x25,
-  0x13, 0x03, 0xec, 0xaa, 0x67, 0xfd, 0xe9, 0x3b, 0xfe, 0xe1, 0x71, 0x16,
-  0x00, 0xff, 0xe6, 0x06, 0x7d, 0x60, 0xf9, 0xba, 0x03, 0x73, 0x2d, 0x50,
-  0x62, 0xfd, 0x3b, 0x00, 0xff, 0xff, 0x00, 0x36, 0xff, 0xd7, 0x04, 0x97,
-  0x07, 0x76, 0x12, 0x26, 0x08, 0xf6, 0x00, 0x00, 0x10, 0x07, 0x00, 0x75,
-  0x00, 0x68, 0x01, 0x86, 0xff, 0xff, 0x00, 0x36, 0xff, 0xd7, 0x04, 0x97,
-  0x07, 0x65, 0x12, 0x26, 0x08, 0xf6, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa2,
-  0x00, 0x68, 0x01, 0x86, 0x00, 0x02, 0x00, 0xc6, 0x00, 0xe5, 0x04, 0x5f,
-  0x03, 0xe5, 0x00, 0x0b, 0x00, 0x31, 0x00, 0x00, 0x01, 0x32, 0x37, 0x02,
-  0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x05, 0x15, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x36,
-  0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x12, 0x33, 0x01, 0xda,
-  0x95, 0x59, 0x72, 0x7c, 0x5a, 0x2e, 0x30, 0x30, 0x33, 0x02, 0xda, 0x46,
-  0x41, 0x31, 0x31, 0x2e, 0x1c, 0x2c, 0x3d, 0x35, 0x41, 0x69, 0x79, 0x50,
-  0x55, 0x55, 0x4a, 0x81, 0x42, 0x30, 0x39, 0x27, 0x24, 0x24, 0x3c, 0x35,
-  0x42, 0x68, 0x44, 0x3a, 0x85, 0x68, 0x72, 0x7b, 0x01, 0x6b, 0xf0, 0x01,
-  0x06, 0x48, 0x4d, 0x66, 0x70, 0x45, 0x46, 0x02, 0x84, 0x1e, 0x1b, 0x3f,
-  0x24, 0x54, 0x78, 0x35, 0x40, 0x65, 0x6a, 0xaf, 0xa8, 0x72, 0x65, 0x1e,
-  0x21, 0x39, 0x33, 0x45, 0x78, 0x35, 0x40, 0x83, 0xf0, 0xfe, 0xfa, 0x00,
-  0x00, 0x03, 0x00, 0xc6, 0x00, 0xe5, 0x05, 0x3a, 0x03, 0xe5, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x25, 0x32, 0x37, 0x02, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0x22, 0x07, 0x12, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x03, 0x48, 0x1c, 0x2c, 0x3d, 0x35,
-  0x42, 0x68, 0x79, 0x50, 0x55, 0x55, 0x4b, 0x80, 0x42, 0x30, 0x39, 0x27,
-  0x24, 0x24, 0x3c, 0x35, 0x43, 0x67, 0x7a, 0x50, 0x54, 0x54, 0x4c, 0x80,
-  0x41, 0x31, 0x31, 0xfe, 0x64, 0x95, 0x59, 0x72, 0x7c, 0x5a, 0x2e, 0x31,
-  0x31, 0x33, 0x02, 0xa0, 0x86, 0x67, 0x71, 0x7c, 0x5a, 0x2e, 0x31, 0x31,
-  0x32, 0x01, 0x5d, 0x24, 0x54, 0x78, 0x35, 0x40, 0x65, 0x6a, 0xaf, 0xa8,
-  0x72, 0x65, 0x1e, 0x21, 0x39, 0x33, 0x45, 0x78, 0x35, 0x40, 0x65, 0x6a,
-  0xaf, 0xa8, 0x72, 0x65, 0x1e, 0x1b, 0x4d, 0xf0, 0x01, 0x06, 0x48, 0x4d,
-  0x66, 0x70, 0x45, 0x46, 0x01, 0xf4, 0xf0, 0xfe, 0xfa, 0x48, 0x4d, 0x66,
-  0x70, 0x45, 0x46, 0x00, 0x00, 0x01, 0x00, 0xfe, 0x00, 0xcb, 0x05, 0x0a,
-  0x05, 0x49, 0x00, 0x05, 0x00, 0x00, 0x25, 0x21, 0x11, 0x33, 0x11, 0x21,
-  0x05, 0x0a, 0xfb, 0xf5, 0x99, 0x03, 0x72, 0xcb, 0x04, 0x7e, 0xfc, 0x2c,
-  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x00, 0x25, 0x15, 0x21, 0x01, 0x33, 0x01, 0x05, 0xa8, 0xfa, 0xf6,
-  0x03, 0x59, 0xda, 0xfd, 0x1d, 0xca, 0xca, 0x05, 0xd5, 0xfa, 0xf5, 0x00,
-  0x00, 0x02, 0x00, 0x9d, 0xff, 0x94, 0x05, 0xa9, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x1b, 0x00, 0x00, 0x25, 0x26, 0x27, 0x26, 0x27, 0x01, 0x13, 0x01,
-  0x33, 0x01, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x16, 0x15, 0x23,
-  0x34, 0x27, 0x21, 0x01, 0x26, 0x27, 0x37, 0x16, 0x03, 0xf0, 0x23, 0x43,
-  0x3a, 0x4e, 0xfe, 0xec, 0xcc, 0x01, 0x3d, 0xda, 0xfe, 0x78, 0x65, 0x4a,
-  0x54, 0x26, 0x01, 0x36, 0xfe, 0xe8, 0x04, 0x7e, 0x05, 0xfc, 0x8d, 0x01,
-  0xd8, 0x1b, 0x1c, 0x48, 0x1a, 0xca, 0x8b, 0x86, 0x73, 0x5e, 0xfe, 0x1e,
-  0x02, 0xe3, 0x02, 0x28, 0xfd, 0x52, 0x73, 0x93, 0xa7, 0xb0, 0xca, 0x35,
-  0x37, 0x37, 0x35, 0x03, 0x36, 0x15, 0x14, 0x75, 0x13, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xd5, 0xff, 0xfa, 0x05, 0x46, 0x05, 0xd1, 0x00, 0x17,
-  0x00, 0x1d, 0x00, 0x00, 0x09, 0x01, 0x37, 0x01, 0x26, 0x27, 0x37, 0x16,
-  0x17, 0x25, 0x15, 0x05, 0x16, 0x07, 0x15, 0x06, 0x07, 0x05, 0x15, 0x25,
-  0x06, 0x07, 0x27, 0x36, 0x13, 0x09, 0x01, 0x36, 0x37, 0x36, 0x03, 0x1a,
-  0xfd, 0xbb, 0x02, 0x02, 0x4d, 0x17, 0x1a, 0x7d, 0x1a, 0x17, 0x01, 0xa5,
-  0xfe, 0xaf, 0x3f, 0x06, 0x06, 0x40, 0x01, 0x5e, 0xfe, 0x54, 0x19, 0x1b,
-  0x78, 0x1c, 0x6c, 0xfe, 0x14, 0x01, 0xe4, 0x2f, 0x04, 0x06, 0x01, 0x34,
-  0x01, 0x52, 0xc0, 0x01, 0x57, 0x21, 0x1e, 0x4c, 0x21, 0x24, 0xee, 0xd2,
-  0xbe, 0xb3, 0xc6, 0x09, 0xa1, 0x93, 0xbf, 0xd2, 0xf1, 0x26, 0x21, 0x4c,
-  0x20, 0x02, 0xe9, 0xfe, 0xe7, 0xfe, 0xf0, 0x7b, 0x81, 0x9e, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x84, 0xfe, 0x4a, 0x02, 0x15, 0x06, 0x2b, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x01, 0x85, 0x90, 0x90, 0x06, 0x2b,
-  0xf8, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5b, 0xfe, 0x4a, 0x03, 0x3f,
-  0x06, 0x2b, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x37, 0x17,
-  0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x85, 0x90, 0xe2, 0x48, 0xfe,
-  0xd6, 0x90, 0xe4, 0x45, 0x02, 0x56, 0x03, 0xd5, 0xfc, 0x9c, 0xb0, 0x6f,
-  0xe7, 0xfc, 0x29, 0x03, 0x67, 0xb1, 0x6e, 0x00, 0x00, 0x02, 0x00, 0xf4,
-  0xfe, 0x4a, 0x02, 0xa5, 0x06, 0x2b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0xf5, 0x90, 0x90, 0x01,
-  0x20, 0x90, 0x90, 0x06, 0x2b, 0xf8, 0x1f, 0x07, 0xe1, 0xf8, 0x1f, 0x00,
-  0x00, 0x01, 0x00, 0x5b, 0xfe, 0x4a, 0x03, 0x3f, 0x06, 0x2b, 0x00, 0x13,
-  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17,
-  0x07, 0x11, 0x23, 0x11, 0x07, 0x11, 0x23, 0x11, 0x07, 0x27, 0xf5, 0x90,
-  0x90, 0x90, 0x52, 0x48, 0x9a, 0x90, 0x90, 0x90, 0x54, 0x45, 0x01, 0xe6,
-  0x04, 0x45, 0xfc, 0x2b, 0x71, 0x03, 0x64, 0xfd, 0x0c, 0x40, 0x6f, 0x78,
-  0xfb, 0xba, 0x03, 0xd7, 0x70, 0xfc, 0x99, 0x02, 0xf7, 0x41, 0x6e, 0x00,
-  0x00, 0x01, 0x00, 0xed, 0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x06,
-  0x00, 0x00, 0x33, 0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0xee, 0x01, 0x44,
-  0xe2, 0x01, 0x44, 0xb0, 0xfe, 0xfb, 0xfe, 0xfa, 0x04, 0xa2, 0xfb, 0x5e,
-  0x03, 0xac, 0xfc, 0x54, 0x00, 0x01, 0x00, 0xed, 0x00, 0x00, 0x04, 0x58,
-  0x04, 0xa2, 0x00, 0x06, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01,
-  0x23, 0xee, 0xaf, 0x01, 0x06, 0x01, 0x05, 0xb0, 0xfe, 0xbc, 0xe2, 0x04,
-  0xa2, 0xfc, 0x54, 0x03, 0xac, 0xfb, 0x5e, 0x00, 0x00, 0x01, 0x00, 0xed,
-  0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x11, 0x00, 0x00, 0x13, 0x10,
-  0x12, 0x33, 0x32, 0x12, 0x19, 0x01, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x15, 0x11, 0x23, 0xee, 0xdc, 0xd9, 0xd8, 0xdd, 0x9b, 0x85, 0x95,
-  0x95, 0x86, 0x9a, 0x02, 0x50, 0x01, 0x28, 0x01, 0x2a, 0xfe, 0xd6, 0xfe,
-  0xd8, 0xfd, 0xb0, 0x02, 0x37, 0xf4, 0xd3, 0xd3, 0xf4, 0xfd, 0xc9, 0x00,
-  0x00, 0x01, 0x00, 0xed, 0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x11, 0x33, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0xee, 0x9a, 0x86, 0x95,
-  0x95, 0x85, 0x9b, 0xdd, 0xd8, 0xd9, 0xdc, 0x02, 0x52, 0x02, 0x50, 0xfd,
-  0xc9, 0xf4, 0xd3, 0xd3, 0xf4, 0x02, 0x37, 0xfd, 0xb0, 0xfe, 0xd8, 0xfe,
-  0xd6, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
-  0x06, 0x0e, 0x00, 0x15, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x32, 0x16, 0x17,
-  0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37,
-  0x16, 0x33, 0x32, 0x37, 0x01, 0xb3, 0x07, 0x92, 0x88, 0x71, 0x12, 0x85,
-  0x10, 0x33, 0x40, 0x07, 0x3a, 0x08, 0x91, 0x88, 0x72, 0x12, 0x85, 0x10,
-  0x33, 0x40, 0x07, 0x04, 0xe2, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf,
-  0xfa, 0xb0, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x69, 0xfe, 0x4d, 0x05, 0x46, 0x06, 0x0e, 0x10, 0x26,
-  0x09, 0x07, 0x00, 0x00, 0x10, 0x07, 0x09, 0x07, 0x01, 0xee, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x69, 0xfe, 0x4d, 0x07, 0x34, 0x06, 0x0e, 0x10, 0x26,
-  0x09, 0x07, 0x00, 0x00, 0x10, 0x27, 0x09, 0x07, 0x01, 0xee, 0x00, 0x00,
-  0x10, 0x07, 0x09, 0x07, 0x03, 0xdc, 0x00, 0x00, 0x00, 0x03, 0x00, 0x69,
-  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x2d, 0x00, 0x36, 0x00, 0x3f,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x07,
-  0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16,
-  0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x13, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x03, 0x13, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0xb3, 0x07, 0x4b, 0x47, 0x42,
-  0x46, 0x40, 0x31, 0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0c, 0x59, 0x3b,
-  0x63, 0x63, 0x4d, 0x68, 0x0d, 0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32,
-  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b,
-  0x69, 0x7c, 0x37, 0x28, 0x3e, 0x40, 0x21, 0x28, 0xaa, 0x14, 0x37, 0x28,
-  0x40, 0x43, 0x21, 0x04, 0xe2, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f,
-  0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0x92, 0x9c, 0x6f, 0x55, 0x13,
-  0xfe, 0xbe, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01,
-  0x31, 0x18, 0x49, 0x6f, 0x9b, 0x9c, 0x73, 0x56, 0x13, 0xfd, 0x9b, 0x10,
-  0x2f, 0x48, 0x67, 0x6a, 0x47, 0x24, 0x12, 0xfe, 0x34, 0x01, 0xd6, 0x11,
-  0x2e, 0x4a, 0x68, 0x67, 0x48, 0x24, 0x00, 0x00, 0x00, 0x04, 0x00, 0x69,
-  0xfe, 0x4d, 0x05, 0x46, 0x06, 0x0e, 0x00, 0x4d, 0x00, 0x51, 0x00, 0x5a,
-  0x00, 0x63, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x21, 0x13, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x03, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x21, 0x03,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
-  0x37, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x13, 0x21,
-  0x13, 0x21, 0x03, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01,
-  0x03, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0xb3, 0x07, 0x4b,
-  0x47, 0x42, 0x46, 0x40, 0x31, 0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0c,
-  0x01, 0x57, 0x0e, 0x07, 0x4b, 0x47, 0x42, 0x46, 0x40, 0x31, 0x12, 0x85,
-  0x0f, 0x34, 0x40, 0x07, 0x0c, 0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68, 0x0d,
-  0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32, 0x12, 0x86, 0x0f, 0x33, 0x40,
-  0x07, 0x0d, 0xfe, 0xa8, 0x0d, 0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32,
-  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b,
-  0x69, 0x7b, 0x01, 0x58, 0x16, 0xfe, 0xa8, 0xab, 0x14, 0x37, 0x28, 0x40,
-  0x43, 0x21, 0x02, 0xbf, 0x13, 0x36, 0x28, 0x3e, 0x40, 0x21, 0x04, 0xe2,
-  0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xe2, 0x01,
-  0x37, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xd6,
-  0x18, 0x4b, 0x7c, 0x92, 0x9c, 0x6f, 0x55, 0x13, 0xfe, 0xbe, 0xa7, 0x44,
-  0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x24, 0xfe, 0xc3, 0xa7,
-  0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x30, 0x19, 0x49,
-  0x6f, 0x9b, 0x9c, 0x73, 0x56, 0x13, 0xfd, 0x92, 0x01, 0xf1, 0xfe, 0x21,
-  0x01, 0xd6, 0x11, 0x2e, 0x4a, 0x68, 0x67, 0x48, 0x24, 0x01, 0xba, 0xfe,
-  0x2b, 0x10, 0x2f, 0x48, 0x67, 0x6a, 0x47, 0x24, 0x00, 0x05, 0x00, 0x69,
-  0xfe, 0x4d, 0x07, 0x34, 0x06, 0x0e, 0x00, 0x6d, 0x00, 0x71, 0x00, 0x75,
-  0x00, 0x7e, 0x00, 0x87, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x21, 0x13, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
-  0x03, 0x21, 0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x07,
-  0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16,
-  0x33, 0x32, 0x37, 0x13, 0x21, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x21, 0x03, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x13, 0x21, 0x03,
-  0x29, 0x01, 0x13, 0x21, 0x03, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x01, 0x03, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0xb3,
-  0x07, 0x4b, 0x47, 0x42, 0x46, 0x40, 0x31, 0x12, 0x85, 0x10, 0x33, 0x40,
-  0x07, 0x0c, 0x01, 0x57, 0x0e, 0x07, 0x4b, 0x47, 0x42, 0x46, 0x40, 0x31,
-  0x12, 0x85, 0x0f, 0x34, 0x40, 0x07, 0x0c, 0x01, 0x57, 0x0e, 0x07, 0x4b,
-  0x47, 0x42, 0x46, 0x40, 0x32, 0x11, 0x85, 0x0f, 0x34, 0x3f, 0x08, 0x0c,
-  0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68, 0x0d, 0x07, 0x4b, 0x47, 0x43, 0x45,
-  0x40, 0x32, 0x11, 0x85, 0x0f, 0x33, 0x40, 0x07, 0x0d, 0xfe, 0xa8, 0x0d,
-  0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32, 0x12, 0x86, 0x0f, 0x33, 0x40,
-  0x07, 0x0d, 0xfe, 0xa8, 0x0d, 0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32,
-  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b,
-  0x69, 0x03, 0xc1, 0x16, 0xfe, 0xa8, 0x15, 0xfe, 0x11, 0x01, 0x58, 0x16,
-  0xfe, 0xa8, 0xab, 0x14, 0x37, 0x28, 0x40, 0x43, 0x21, 0x04, 0xad, 0x13,
-  0x36, 0x28, 0x3e, 0x40, 0x21, 0x04, 0xe2, 0xa7, 0x44, 0x41, 0x46, 0x37,
-  0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xe2, 0x01, 0x37, 0xa7, 0x44, 0x41, 0x46,
-  0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xe2, 0x01, 0x37, 0xa7, 0x44, 0x41,
-  0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0x92,
-  0x9c, 0x6f, 0x55, 0x13, 0xfe, 0xbe, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c,
-  0x0f, 0x82, 0xaf, 0x01, 0x24, 0xfe, 0xc3, 0xa7, 0x44, 0x41, 0x46, 0x37,
-  0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x24, 0xfe, 0xc3, 0xa7, 0x44, 0x41, 0x46,
-  0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x30, 0x19, 0x49, 0x6f, 0x9b, 0x9c,
-  0x73, 0x56, 0x13, 0xfd, 0x92, 0x01, 0xf1, 0xfe, 0x0f, 0x01, 0xf1, 0xfe,
-  0x21, 0x01, 0xd6, 0x11, 0x2e, 0x4a, 0x68, 0x67, 0x48, 0x24, 0x01, 0xba,
-  0xfe, 0x2b, 0x10, 0x2f, 0x48, 0x67, 0x6a, 0x47, 0x24, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0xfe, 0x4c, 0x03, 0xc3, 0x06, 0x0f, 0x00, 0x33,
-  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x1d,
-  0x01, 0x37, 0x17, 0x07, 0x23, 0x27, 0x37, 0x17, 0x35, 0x34, 0x27, 0x26,
-  0x27, 0x03, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
-  0x37, 0x13, 0x06, 0x07, 0x06, 0x15, 0x23, 0x34, 0x37, 0x36, 0x37, 0x13,
-  0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x02, 0xd2, 0x10, 0x34, 0x3f, 0x07,
-  0x0e, 0x50, 0x38, 0x6c, 0x54, 0x41, 0xab, 0x31, 0xa9, 0x41, 0x53, 0x47,
-  0x2e, 0x28, 0x27, 0x08, 0x8f, 0x41, 0x47, 0x74, 0x12, 0x85, 0x10, 0x35,
-  0x3e, 0x07, 0x27, 0x3a, 0x2a, 0x4d, 0x5c, 0x62, 0x4e, 0x61, 0x10, 0x07,
-  0x90, 0x40, 0x48, 0x73, 0x12, 0x04, 0xf6, 0x82, 0xaf, 0xfe, 0xb3, 0x18,
-  0x3f, 0x75, 0x9c, 0x1e, 0x5d, 0x48, 0xbd, 0xbd, 0x48, 0x5d, 0x1e, 0x73,
-  0x4d, 0x33, 0x0b, 0xfc, 0x67, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf,
-  0x03, 0x88, 0x10, 0x2e, 0x56, 0x72, 0x9b, 0x6d, 0x56, 0x11, 0x01, 0x5f,
-  0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x03, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0xb4,
-  0x06, 0x0e, 0x00, 0x08, 0x00, 0x11, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x13,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x25, 0x34, 0x27, 0x03, 0x3e,
-  0x01, 0x37, 0x27, 0x37, 0x13, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17,
-  0x16, 0x15, 0x37, 0x17, 0x07, 0x06, 0x07, 0x06, 0x07, 0x03, 0x0e, 0x01,
-  0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x01,
-  0x8b, 0x14, 0x37, 0x28, 0x40, 0x43, 0x21, 0x01, 0x5a, 0x89, 0x14, 0x37,
-  0x49, 0x08, 0x79, 0x41, 0x61, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x50, 0x44,
-  0x62, 0x41, 0x41, 0x97, 0x17, 0x36, 0x4d, 0x68, 0x0d, 0x08, 0x8f, 0x89,
-  0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64,
-  0x4b, 0x69, 0x0e, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x01, 0x4a, 0x01, 0xd6,
-  0x11, 0x2e, 0x4a, 0x67, 0x68, 0x48, 0x24, 0xe6, 0x99, 0x3b, 0xfe, 0x2b,
-  0x10, 0x65, 0x13, 0x88, 0x48, 0x02, 0x5d, 0x82, 0xaf, 0xfe, 0xd6, 0x16,
-  0x4d, 0x6f, 0x7c, 0x48, 0x48, 0xa7, 0x43, 0x3f, 0x5a, 0x13, 0xfe, 0xbe,
-  0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0x01, 0x31, 0x18, 0x49, 0x6f,
-  0x9b, 0x9c, 0x73, 0x56, 0x13, 0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f, 0x00,
-  0x00, 0x03, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0xb6, 0x06, 0x0e, 0x00, 0x08,
-  0x00, 0x12, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x13, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x01, 0x2e, 0x01, 0x27, 0x03, 0x3e, 0x01, 0x37, 0x07,
-  0x27, 0x13, 0x26, 0x23, 0x22, 0x07, 0x03, 0x1e, 0x01, 0x1f, 0x01, 0x07,
-  0x27, 0x14, 0x06, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16,
-  0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x01, 0x8b, 0x14, 0x37, 0x28, 0x40,
-  0x43, 0x21, 0x01, 0x49, 0x20, 0x30, 0x28, 0x14, 0x37, 0x5f, 0x06, 0x4b,
-  0x40, 0xa0, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x59, 0x7d, 0x10, 0x94, 0x41,
-  0x44, 0xae, 0x68, 0x0d, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35,
-  0x3e, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b, 0x69, 0x0e, 0x07, 0x8f,
-  0x89, 0x73, 0x12, 0x01, 0x4a, 0x01, 0xd6, 0x11, 0x2e, 0x4a, 0x67, 0x68,
-  0x48, 0x24, 0x01, 0x36, 0x42, 0x30, 0x12, 0xfe, 0x2b, 0x10, 0x82, 0x40,
-  0x54, 0x48, 0x02, 0xef, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x9d, 0x3f, 0xa4,
-  0x48, 0x4b, 0x7c, 0xc0, 0x13, 0xfe, 0xbe, 0xa5, 0x87, 0x7a, 0x8f, 0x0f,
-  0x82, 0xaf, 0x01, 0x31, 0x18, 0x49, 0x6f, 0x9b, 0x9c, 0x73, 0x56, 0x13,
-  0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c,
-  0x00, 0xcd, 0x04, 0x28, 0x04, 0xd5, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xa8,
-  0xfe, 0x85, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xa5, 0xfe, 0x85, 0x10, 0x07,
-  0x09, 0xa1, 0x01, 0x26, 0x01, 0x8f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c,
-  0x00, 0xcd, 0x04, 0x28, 0x04, 0xd5, 0x10, 0x27, 0x09, 0xa1, 0x01, 0x26,
-  0xfe, 0x85, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xa5, 0x01, 0x8f, 0x10, 0x07,
-  0x09, 0xa1, 0xff, 0xa8, 0x01, 0x8f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x90,
-  0x00, 0xcd, 0x01, 0x4f, 0x04, 0xd6, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xcc,
-  0x01, 0x90, 0x10, 0x07, 0x09, 0xa1, 0xff, 0xcc, 0xfe, 0x85, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x6c, 0x00, 0xcd, 0x04, 0x28, 0x04, 0xd5, 0x10, 0x27,
-  0x09, 0xa1, 0x02, 0xa5, 0x01, 0x8f, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xa8,
-  0x01, 0x8f, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xa5, 0xfe, 0x85, 0x10, 0x07,
-  0x09, 0xa1, 0xff, 0xa8, 0xfe, 0x85, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3,
-  0x02, 0x2d, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xdf,
-  0x01, 0x24, 0x10, 0x06, 0x08, 0xee, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x05, 0x21,
-  0x15, 0x21, 0x04, 0x87, 0xbe, 0xbe, 0x01, 0xbe, 0xbe, 0xfc, 0x3b, 0x03,
-  0x03, 0xfc, 0xfd, 0x01, 0x9d, 0xfe, 0x03, 0xcb, 0xfe, 0x95, 0xaa, 0x00,
-  0xff, 0xff, 0x00, 0xc2, 0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
-  0x08, 0xee, 0x00, 0x00, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfd, 0xfe, 0x57,
-  0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe, 0x01, 0x24, 0x10, 0x27, 0x09, 0xa1,
-  0x03, 0xc2, 0xfe, 0x57, 0x10, 0x07, 0x09, 0xa1, 0x03, 0xc3, 0x01, 0x24,
-  0xff, 0xff, 0x00, 0xc3, 0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
-  0x09, 0x18, 0x00, 0x00, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xde, 0xfe, 0x57,
-  0x10, 0x07, 0x09, 0xa1, 0x01, 0xdf, 0x01, 0x24, 0x00, 0x01, 0x00, 0xc3,
-  0x01, 0xd3, 0x05, 0x46, 0x03, 0x32, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x33, 0x32, 0x36, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09,
-  0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63,
-  0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55, 0x4d, 0x98, 0x03, 0x32, 0xb3,
-  0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e,
-  0x45, 0x3b, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b, 0x00, 0x01, 0x00, 0xc3,
-  0x01, 0xd3, 0x05, 0x46, 0x03, 0x32, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x1e,
-  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16,
-  0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x26, 0x27, 0xc3, 0x5d, 0x98, 0x4e, 0x54, 0x8c, 0x0d, 0x05,
-  0x05, 0x0a, 0x84, 0x63, 0x58, 0xa1, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b,
-  0x0e, 0x05, 0x06, 0x09, 0x84, 0x63, 0x57, 0xa1, 0x5f, 0x03, 0x32, 0x55,
-  0x4b, 0x3d, 0x06, 0x02, 0x02, 0x05, 0x3b, 0x45, 0x4e, 0xb3, 0x54, 0x4c,
-  0x3d, 0x06, 0x02, 0x03, 0x04, 0x3b, 0x45, 0x4e, 0x00, 0x01, 0x00, 0x91,
-  0x01, 0x31, 0x05, 0x77, 0x03, 0xd4, 0x00, 0x29, 0x00, 0x00, 0x01, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x15, 0x1e, 0x01, 0x33, 0x15, 0x22, 0x2e, 0x01,
-  0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x2e, 0x01, 0x23, 0x37, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0x02, 0xe7, 0x49, 0x8f, 0x40, 0x4a, 0x5a, 0x01,
-  0x5e, 0x46, 0x5f, 0x8c, 0x53, 0x5a, 0x80, 0x63, 0x6c, 0xaf, 0x37, 0x3a,
-  0x9e, 0x41, 0x4a, 0x5a, 0x02, 0x5e, 0x46, 0x01, 0x5e, 0x8d, 0x53, 0x5a,
-  0x80, 0x63, 0x6c, 0xb1, 0x02, 0x2e, 0x74, 0x74, 0x6c, 0x48, 0x3d, 0x59,
-  0x9b, 0x4f, 0x9a, 0x48, 0x4c, 0xa2, 0x5c, 0x7d, 0x58, 0x5b, 0x8d, 0x6c,
-  0x48, 0x3d, 0x59, 0x9b, 0x4f, 0x9a, 0x48, 0x4c, 0xa2, 0x5c, 0x7d, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x57, 0x05, 0x46, 0x04, 0xad, 0x00, 0x11,
-  0x00, 0x00, 0x01, 0x02, 0x23, 0x22, 0x03, 0x02, 0x27, 0x22, 0x03, 0x23,
-  0x12, 0x33, 0x32, 0x13, 0x12, 0x17, 0x32, 0x13, 0x05, 0x45, 0x6f, 0xe2,
-  0xcf, 0x59, 0x5c, 0x5c, 0x68, 0x50, 0x99, 0x6f, 0xe2, 0xcf, 0x5a, 0x5b,
-  0x5c, 0x68, 0x50, 0x02, 0xd7, 0xfd, 0x80, 0x01, 0xd6, 0x01, 0xdc, 0x01,
-  0xfe, 0x23, 0x02, 0x80, 0xfe, 0x2a, 0xfe, 0x24, 0x01, 0x01, 0xdd, 0x00,
-  0x00, 0x01, 0x00, 0xbb, 0x00, 0x00, 0x01, 0xf8, 0x05, 0x02, 0x00, 0x1d,
-  0x00, 0x00, 0x21, 0x23, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x35, 0x34, 0x26, 0x27, 0x33, 0x1e, 0x01, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x16, 0x01, 0xf8, 0xa2, 0x46,
-  0x3d, 0x34, 0x03, 0x04, 0x02, 0x05, 0x36, 0x44, 0x4c, 0xa2, 0x46, 0x3e,
-  0x35, 0x05, 0x02, 0x02, 0x05, 0x36, 0x43, 0x68, 0xb4, 0x60, 0x6e, 0x92,
-  0x0a, 0x08, 0x06, 0x0e, 0x9c, 0x5e, 0x58, 0xac, 0x62, 0x6a, 0xb2, 0x62,
-  0x6e, 0x92, 0x0c, 0x04, 0x06, 0x10, 0x9a, 0x5e, 0x56, 0xaa, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x9d, 0x05, 0x46, 0x04, 0x6c, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x13, 0x17, 0x03, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
-  0x01, 0x23, 0x22, 0x27, 0x03, 0x27, 0x02, 0x9c, 0x5a, 0x3c, 0x50, 0x9a,
-  0x59, 0x5f, 0xa1, 0x57, 0x54, 0x6c, 0x9c, 0x8b, 0x97, 0x5b, 0x3e, 0x4d,
-  0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x56, 0x6d, 0x9a, 0x8b, 0x02, 0x53, 0x20,
-  0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x2b, 0x01, 0x7e, 0x46, 0xfe, 0x8c, 0x20,
-  0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x2c, 0xfe, 0x85, 0x46, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x01, 0x10, 0x05, 0x46, 0x03, 0xa2, 0x00, 0x1c,
-  0x00, 0x20, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15,
-  0x21, 0x05, 0x45, 0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c,
-  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x09, 0x05, 0x05,
-  0x0e, 0x8b, 0x55, 0x4d, 0x98, 0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x02,
-  0x6f, 0xb3, 0x4e, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3,
-  0x4e, 0x45, 0x3b, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b, 0x01, 0x88, 0xa8,
-  0x00, 0x02, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x03, 0xf4, 0x00, 0x1a,
-  0x00, 0x1e, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15, 0x21, 0x05, 0x45,
-  0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a,
-  0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98,
-  0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xf4, 0xb2, 0x4f, 0x45, 0x3b,
-  0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x09,
-  0x3d, 0x4b, 0xfe, 0x6b, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x62, 0x05, 0x46, 0x04, 0xd3, 0x00, 0x25, 0x00, 0x26, 0x00, 0x00,
-  0x01, 0x03, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x27, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x23, 0x35, 0x21,
-  0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f,
-  0x01, 0x13, 0x01, 0x04, 0x83, 0xb7, 0x1c, 0x21, 0x41, 0x53, 0x9d, 0x0b,
-  0x5e, 0xa1, 0x58, 0x3b, 0x48, 0x82, 0x02, 0x5c, 0xfd, 0x3e, 0xa7, 0x7b,
-  0x61, 0xff, 0x01, 0x70, 0xa6, 0x83, 0x50, 0x50, 0x9a, 0x59, 0x5f, 0xa1,
-  0x57, 0x63, 0x85, 0x2d, 0xd7, 0xfd, 0xbe, 0x04, 0x6f, 0xfe, 0xe9, 0x0b,
-  0x2d, 0x58, 0x22, 0xb2, 0x4f, 0x45, 0x16, 0xba, 0xaa, 0xfe, 0x64, 0x9a,
-  0xaa, 0xf3, 0x38, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x16, 0x01, 0x49,
-  0xfc, 0x8d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46,
-  0x04, 0xc1, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x00, 0x01, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36,
-  0x01, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x05, 0x45, 0x5e, 0xa2,
-  0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f,
-  0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0xfb, 0xdb,
-  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0xc1, 0xb2, 0x4f,
-  0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b,
-  0x06, 0x07, 0x3f, 0x4b, 0xfe, 0x6b, 0xaa, 0xcb, 0xaa, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x18, 0x05, 0x46, 0x04, 0xc1, 0x00, 0x1a,
-  0x00, 0x2e, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x23, 0x35, 0x21, 0x37, 0x21,
-  0x35, 0x21, 0x37, 0x17, 0x07, 0x33, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21,
-  0x07, 0x27, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x10, 0x05, 0x0d,
-  0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14,
-  0x8b, 0x55, 0x4d, 0x98, 0xfc, 0xab, 0xd0, 0x01, 0x6d, 0xbc, 0xfd, 0xd7,
-  0x02, 0xca, 0x7e, 0x64, 0x11, 0xe7, 0xfe, 0x77, 0xbb, 0x02, 0x44, 0xfd,
-  0x1b, 0x95, 0x64, 0x04, 0xc1, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06,
-  0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0xfc,
-  0x4c, 0xaa, 0xcb, 0xaa, 0x8a, 0x73, 0x17, 0xaa, 0xcb, 0xaa, 0xa0, 0x73,
-  0x00, 0x01, 0x00, 0xc3, 0xff, 0xf6, 0x05, 0x46, 0x05, 0x42, 0x00, 0x2e,
-  0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x27, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07,
-  0x27, 0x37, 0x23, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x37, 0x27, 0x26,
-  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x37,
-  0x17, 0x03, 0xf2, 0x09, 0x08, 0x43, 0x57, 0x42, 0x66, 0x5e, 0xa1, 0x58,
-  0x23, 0x27, 0x52, 0x01, 0xf3, 0xfd, 0xbb, 0x62, 0x02, 0xa7, 0xfd, 0x08,
-  0x5e, 0x83, 0x37, 0xe0, 0x01, 0x32, 0x62, 0xfe, 0x6c, 0x01, 0xe6, 0x6a,
-  0x2d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x59,
-  0x78, 0x84, 0x04, 0x22, 0x01, 0x25, 0x1e, 0x5d, 0xb2, 0x4f, 0x45, 0x07,
-  0xab, 0xaa, 0xcb, 0xaa, 0xc2, 0x4e, 0x74, 0xaa, 0xcb, 0xaa, 0xda, 0x14,
-  0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x25, 0xfa, 0x4e, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x01, 0x10, 0x05, 0x46, 0x03, 0xf4, 0x00, 0x1d,
-  0x00, 0x3b, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x33, 0x32, 0x36, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09,
-  0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63,
-  0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa1,
-  0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59,
-  0x5f, 0xa1, 0x57, 0x63, 0x85, 0x08, 0x05, 0x06, 0x0e, 0x8b, 0x55, 0x4d,
-  0x98, 0x02, 0x6f, 0xb3, 0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d,
-  0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x3b, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b,
-  0x01, 0xda, 0xb2, 0x4f, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c,
-  0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x04, 0x02, 0x03, 0x06, 0x3d, 0x4b, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x05, 0x05, 0x46, 0x04, 0xff, 0x00, 0x34,
-  0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x27, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x2f, 0x01, 0x03, 0x27, 0x13, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
-  0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
-  0x3e, 0x01, 0x32, 0x1f, 0x01, 0x13, 0x17, 0x03, 0xa9, 0x33, 0x27, 0x4d,
-  0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x39, 0x45, 0x42, 0x84, 0x51, 0x4d, 0x98,
-  0x5d, 0x5e, 0xa1, 0x58, 0x76, 0x70, 0x11, 0x7f, 0x94, 0x7c, 0x33, 0x27,
-  0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x3a, 0x45, 0x41, 0x83, 0x51, 0x50,
-  0x9a, 0x59, 0x5f, 0xa1, 0xae, 0x91, 0x10, 0x7f, 0x93, 0x03, 0x61, 0x0d,
-  0x4b, 0x55, 0xb2, 0x4f, 0x45, 0x14, 0xbb, 0x38, 0x4b, 0x55, 0xb3, 0x4e,
-  0x45, 0x3b, 0x09, 0xfe, 0x98, 0x40, 0x01, 0x5e, 0x0d, 0x4c, 0x54, 0xb3,
-  0x4e, 0x45, 0x14, 0xbb, 0x38, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x07,
-  0x01, 0x66, 0x40, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46,
-  0x04, 0xc9, 0x00, 0x1a, 0x00, 0x35, 0x00, 0x39, 0x00, 0x00, 0x01, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36,
-  0x13, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33,
-  0x32, 0x36, 0x01, 0x21, 0x15, 0x21, 0x05, 0x45, 0x5e, 0xa2, 0x57, 0x63,
-  0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57,
-  0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa2, 0x57,
-  0x65, 0x81, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1,
-  0x57, 0x63, 0x85, 0x0d, 0x14, 0xb2, 0x2e, 0x4d, 0x98, 0xfb, 0xdb, 0x04,
-  0x82, 0xfb, 0x7e, 0x03, 0x4c, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06,
-  0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0x01,
-  0xd2, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2,
-  0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0xfc, 0xee, 0xaa, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0x00, 0x79, 0x05, 0x46, 0x04, 0xd1, 0x00, 0x1a,
-  0x00, 0x35, 0x00, 0x50, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
-  0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
-  0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36,
-  0x05, 0x45, 0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54,
-  0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55,
-  0x4d, 0x98, 0x5d, 0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c,
-  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b,
-  0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa2, 0x57, 0x65, 0x81, 0x10, 0x05, 0x0d,
-  0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14,
-  0xb2, 0x2e, 0x4d, 0x98, 0x01, 0xd7, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02,
-  0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b,
-  0x01, 0xd2, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53,
-  0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0x01, 0xd2, 0xb2, 0x4f,
-  0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b,
-  0x06, 0x07, 0x3f, 0x4b, 0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46,
-  0x04, 0xc1, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x00, 0x13, 0x1e,
-  0x01, 0x33, 0x32, 0x3f, 0x02, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
-  0x01, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x23, 0x22, 0x26, 0x27,
-  0x01, 0x15, 0x21, 0x35, 0x01, 0x15, 0x21, 0x35, 0xc3, 0x5d, 0x98, 0x4e,
-  0x54, 0x8c, 0x13, 0x0e, 0x84, 0x63, 0x58, 0xa1, 0x5e, 0x58, 0x9b, 0x4f,
-  0x55, 0x8b, 0x0e, 0x05, 0x0f, 0x84, 0x63, 0x57, 0xa1, 0x5f, 0x04, 0x82,
-  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0xc1, 0x55, 0x4b, 0x3f, 0x07,
-  0x06, 0x3b, 0x45, 0x4e, 0xb2, 0x53, 0x4c, 0x3d, 0x06, 0x02, 0x07, 0x3b,
-  0x45, 0x4f, 0xfe, 0xc8, 0xaa, 0xaa, 0xfe, 0x8b, 0xaa, 0xaa, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc2, 0x00, 0xd7, 0x05, 0x46, 0x04, 0x2b, 0x00, 0x09,
-  0x00, 0x13, 0x00, 0x00, 0x01, 0x20, 0x25, 0x35, 0x04, 0x05, 0x20, 0x25,
-  0x15, 0x04, 0x05, 0x20, 0x05, 0x15, 0x24, 0x25, 0x04, 0x05, 0x35, 0x24,
-  0x03, 0x05, 0xfe, 0xfe, 0xfe, 0xbf, 0x01, 0x43, 0x01, 0x00, 0x01, 0x09,
-  0x01, 0x36, 0xfe, 0xc5, 0xfe, 0xfd, 0x01, 0x07, 0x01, 0x38, 0xfe, 0xc6,
-  0xfe, 0xfb, 0xfe, 0xfd, 0xfe, 0xc0, 0x01, 0x44, 0x02, 0xd3, 0xa6, 0xb2,
-  0x95, 0x11, 0xa6, 0xb2, 0x97, 0xb3, 0xa6, 0xb2, 0x97, 0x0f, 0x02, 0xa4,
-  0xb2, 0x97, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x36, 0x05, 0x46,
-  0x04, 0xce, 0x00, 0x1c, 0x00, 0x39, 0x00, 0x00, 0x25, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x21, 0x15, 0x23, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x35, 0x21, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x13, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x35, 0x33, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x15,
-  0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x03, 0x05, 0x3c, 0x29, 0x32, 0x1b,
-  0x18, 0x04, 0x01, 0x72, 0xef, 0x0d, 0x1a, 0x31, 0x4d, 0x50, 0xb9, 0x51,
-  0x4d, 0x31, 0x1b, 0x0b, 0xf0, 0x01, 0x73, 0x04, 0x18, 0x1b, 0x32, 0x29,
-  0x3d, 0x3d, 0x29, 0x32, 0x1b, 0x18, 0x04, 0xfe, 0x8d, 0xf0, 0x0b, 0x1b,
-  0x31, 0x4d, 0x51, 0xb9, 0x50, 0x4d, 0x31, 0x1a, 0x0d, 0xef, 0xfe, 0x8e,
-  0x04, 0x18, 0x1b, 0x32, 0x29, 0xd9, 0x04, 0x1e, 0x2c, 0x43, 0x45, 0x5b,
-  0xa8, 0x3c, 0x30, 0x5b, 0x32, 0x33, 0x33, 0x32, 0x5b, 0x33, 0x39, 0xa8,
-  0x5c, 0x44, 0x44, 0x2b, 0x1e, 0x03, 0x4e, 0x04, 0x1e, 0x2b, 0x44, 0x44,
-  0x5c, 0xa8, 0x39, 0x33, 0x5b, 0x32, 0x33, 0x33, 0x32, 0x5b, 0x30, 0x3c,
-  0xa8, 0x5b, 0x45, 0x43, 0x2c, 0x1e, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x01, 0x60, 0x05, 0x46, 0x04, 0xce, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00,
-  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x35, 0x33, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x15, 0x21,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x15, 0x21, 0x03, 0x05, 0x3d,
-  0x29, 0x32, 0x1b, 0x18, 0x04, 0xfe, 0x8d, 0xf0, 0x0b, 0x1b, 0x31, 0x4d,
-  0x51, 0xb9, 0x50, 0x4d, 0x31, 0x1a, 0x0d, 0xef, 0xfe, 0x8e, 0x04, 0x18,
-  0x1b, 0x32, 0x29, 0xfd, 0x82, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x2b, 0x04,
-  0x1e, 0x2b, 0x44, 0x44, 0x5c, 0xa8, 0x39, 0x33, 0x5b, 0x32, 0x33, 0x33,
-  0x32, 0x5b, 0x30, 0x3c, 0xa8, 0x5b, 0x45, 0x43, 0x2c, 0x1e, 0xfd, 0xe3,
-  0xaa, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
-  0x04, 0xff, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xe0, 0x01, 0xb9, 0x10, 0x06,
-  0x00, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0x00, 0x02, 0x05, 0x46,
-  0x04, 0xff, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xde, 0xfd, 0xba, 0x10, 0x26,
-  0x00, 0x20, 0x00, 0x00, 0x10, 0x07, 0x09, 0xa1, 0x01, 0xdf, 0x01, 0xb9,
-  0xff, 0xff, 0x00, 0xc3, 0x00, 0x05, 0x05, 0x48, 0x04, 0xff, 0x10, 0x27,
-  0x09, 0xa1, 0xff, 0xfe, 0x01, 0xb9, 0x10, 0x26, 0x00, 0x20, 0x00, 0x00,
-  0x10, 0x07, 0x09, 0xa1, 0x03, 0xc5, 0xfd, 0xbd, 0xff, 0xff, 0x00, 0xc3,
-  0x00, 0x05, 0x05, 0x47, 0x04, 0xff, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe,
-  0xfd, 0xbd, 0x10, 0x26, 0x00, 0x20, 0x02, 0x00, 0x10, 0x07, 0x09, 0xa1,
-  0x03, 0xc3, 0x01, 0xb9, 0xff, 0xff, 0x00, 0xba, 0x01, 0x36, 0x06, 0x7a,
-  0x03, 0xcf, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xf5, 0xfe, 0xee, 0x10, 0x27,
-  0x09, 0xa1, 0xff, 0xf5, 0x00, 0x89, 0x10, 0x07, 0x00, 0x20, 0x01, 0x35,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb8, 0x01, 0x36, 0x06, 0x7b,
-  0x03, 0xcc, 0x10, 0x26, 0x00, 0x20, 0xf5, 0x00, 0x10, 0x27, 0x09, 0xa1,
-  0x04, 0xf8, 0x00, 0x86, 0x10, 0x07, 0x09, 0xa1, 0x04, 0xf8, 0xfe, 0xee,
-  0x00, 0x02, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x03, 0xa2, 0x00, 0x09,
-  0x00, 0x1b, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x17, 0x33, 0x36, 0x35,
-  0x26, 0x27, 0x17, 0x21, 0x15, 0x21, 0x35, 0x21, 0x26, 0x35, 0x34, 0x37,
-  0x21, 0x35, 0x21, 0x15, 0x21, 0x16, 0x17, 0x14, 0x02, 0x9c, 0x2f, 0x2e,
-  0xda, 0x2f, 0x01, 0x2e, 0x7e, 0x01, 0x52, 0xfb, 0x7e, 0x01, 0x58, 0x16,
-  0x18, 0xfe, 0xa6, 0x04, 0x82, 0xfe, 0xaf, 0x17, 0x01, 0x02, 0xfa, 0x30,
-  0x49, 0x47, 0x30, 0x30, 0x47, 0x47, 0x32, 0xf0, 0xaa, 0xaa, 0x3f, 0x38,
-  0x3e, 0x3b, 0xa8, 0xa8, 0x1a, 0x5f, 0x38, 0x00, 0x00, 0x04, 0x00, 0xc3,
-  0x01, 0x60, 0x05, 0x46, 0x06, 0x15, 0x00, 0x03, 0x00, 0x07, 0x00, 0x11,
-  0x00, 0x20, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x34, 0x26, 0x27, 0x32,
-  0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0x45,
-  0x41, 0x5a, 0x5a, 0x83, 0x5a, 0x5b, 0x41, 0x35, 0x60, 0x24, 0x25, 0x26,
-  0x98, 0x6d, 0x6f, 0x93, 0x96, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0x44,
-  0x62, 0x46, 0x45, 0x60, 0x60, 0x8b, 0x62, 0x71, 0x2b, 0x28, 0x28, 0x64,
-  0x3a, 0x73, 0xa1, 0x9e, 0x76, 0x76, 0xa3, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0x01, 0x60, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x11,
-  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x01, 0x32,
-  0x17, 0x15, 0x26, 0x23, 0x06, 0x07, 0x35, 0x36, 0xc3, 0x04, 0x82, 0xfb,
-  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0x42, 0xe7, 0xca, 0xca, 0xe7, 0xe5,
-  0xce, 0xd2, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x03, 0xeb, 0x97, 0xb2, 0x97,
-  0x02, 0x95, 0xb2, 0x97, 0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
-  0x06, 0x7f, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x01, 0x13, 0x33, 0x13, 0x23, 0x0b,
-  0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x01, 0x07,
-  0xea, 0xa2, 0xe9, 0x8f, 0xab, 0xa5, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x02,
-  0x82, 0x02, 0x9d, 0xfd, 0x63, 0x01, 0xd9, 0xfe, 0x27, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x06, 0x7f, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x23, 0xc3, 0x04, 0x82,
-  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x01, 0x07, 0x96, 0xa5, 0xab, 0x8f,
-  0xe9, 0xa2, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x05, 0x1f, 0xfe, 0x27, 0x01,
-  0xd9, 0xfd, 0x63, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
-  0x06, 0xca, 0x00, 0x03, 0x00, 0x07, 0x00, 0x11, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x07,
-  0x13, 0x27, 0x07, 0x13, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
-  0x7e, 0xe1, 0x01, 0x0d, 0x54, 0x55, 0x01, 0x0c, 0xda, 0x55, 0xdc, 0xdb,
-  0x54, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0x4e, 0x01, 0x1c, 0xfe, 0xe4,
-  0xb0, 0xfe, 0xe4, 0xb0, 0xb0, 0x01, 0x1c, 0x00, 0x00, 0x04, 0x00, 0xc3,
-  0x01, 0x60, 0x05, 0x46, 0x06, 0xd4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0a,
-  0x00, 0x0e, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x01, 0x03, 0x21, 0x03, 0x33, 0x01, 0x21, 0xc3, 0x04, 0x82, 0xfb, 0x7e,
-  0x04, 0x82, 0xfb, 0x7e, 0x02, 0x42, 0x95, 0x01, 0x2c, 0xc8, 0x64, 0x01,
-  0x04, 0xfd, 0x94, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0xc0, 0xfe, 0x4e,
-  0x02, 0x66, 0xfd, 0x1f, 0x00, 0x07, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
-  0x06, 0x1c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x30, 0x00, 0x37,
-  0x00, 0x47, 0x00, 0x4f, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x33, 0x15, 0x23,
-  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x33, 0x03, 0x15,
-  0x21, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x07, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x15, 0x27, 0x35, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22,
-  0x26, 0x34, 0x36, 0x33, 0x32, 0x16, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34,
-  0x26, 0x22, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04,
-  0x2d, 0x38, 0x21, 0x18, 0x62, 0x62, 0x3c, 0x39, 0x39, 0x39, 0x3d, 0xd6,
-  0xfe, 0xee, 0x46, 0x3b, 0x23, 0x41, 0x1f, 0x20, 0x43, 0x23, 0x57, 0x65,
-  0x60, 0x52, 0x49, 0x55, 0x3c, 0x36, 0x2c, 0x31, 0x41, 0xb3, 0x3c, 0x3c,
-  0x12, 0x3a, 0x28, 0x41, 0x53, 0x53, 0x41, 0x28, 0x3a, 0xb9, 0x36, 0x5f,
-  0x36, 0x36, 0x5f, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0xbc, 0x37, 0x1e,
-  0x24, 0x24, 0x33, 0xfe, 0xa0, 0x01, 0x60, 0x33, 0x1c, 0x44, 0x3d, 0xfe,
-  0xaa, 0x20, 0x44, 0x48, 0x13, 0x12, 0x3e, 0x0f, 0x10, 0x70, 0x60, 0x63,
-  0x74, 0x69, 0x47, 0x36, 0x42, 0x3f, 0x39, 0x69, 0xda, 0xfd, 0xd0, 0x3d,
-  0x24, 0x23, 0x74, 0xbe, 0x75, 0x23, 0x67, 0x93, 0x53, 0x53, 0x93, 0x53,
-  0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x06, 0x14, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x2a, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0x5c,
-  0x1e, 0x54, 0x38, 0x4d, 0x52, 0x50, 0x32, 0x33, 0x3e, 0x49, 0x50, 0x32,
-  0x34, 0x3d, 0x48, 0x51, 0x51, 0x1b, 0x4d, 0x35, 0x35, 0x4a, 0x03, 0xa2,
-  0xa8, 0xf0, 0xaa, 0x04, 0x3d, 0x3d, 0x3a, 0x78, 0x6f, 0xfe, 0xb5, 0x01,
-  0x48, 0x4f, 0x4d, 0x5d, 0x51, 0xfe, 0xca, 0x01, 0x48, 0x50, 0x4c, 0x5e,
-  0x50, 0xfe, 0xca, 0x02, 0x25, 0x55, 0x32, 0x30, 0x3d, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x06, 0xda, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x2c, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x15, 0x21, 0x01, 0x33, 0x15, 0x23, 0x37, 0x23, 0x35, 0x34,
-  0x36, 0x3f, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x0f, 0x01, 0x0e,
-  0x01, 0x07, 0x0e, 0x01, 0x15, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
-  0xfb, 0x7e, 0x01, 0xfc, 0x5b, 0x5b, 0x58, 0x56, 0x1a, 0x28, 0x29, 0x19,
-  0x17, 0x3b, 0x30, 0x24, 0x50, 0x2c, 0x2a, 0x57, 0x2e, 0x53, 0x65, 0x21,
-  0x28, 0x28, 0x15, 0x12, 0x03, 0x03, 0x03, 0x03, 0xa2, 0xa8, 0xf0, 0xaa,
-  0x03, 0x01, 0x7f, 0xc8, 0x4e, 0x32, 0x41, 0x2b, 0x2c, 0x1b, 0x2f, 0x18,
-  0x2d, 0x37, 0x23, 0x21, 0x5e, 0x1c, 0x1c, 0x61, 0x4f, 0x26, 0x45, 0x2b,
-  0x2b, 0x17, 0x1b, 0x0d, 0x0a, 0x1e, 0x1a, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0x00, 0x27, 0x05, 0x46, 0x04, 0xdd, 0x00, 0x13, 0x00, 0x00, 0x13, 0x21,
-  0x13, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27,
-  0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0xc3, 0x02, 0xb7, 0xe6, 0x71, 0x9d,
-  0x01, 0x11, 0xfe, 0x74, 0xaf, 0x02, 0x3b, 0xfd, 0x47, 0xe8, 0x70, 0x9c,
-  0xfe, 0xf3, 0x01, 0x8b, 0xaf, 0xfd, 0xc6, 0x03, 0xa2, 0x01, 0x3b, 0x66,
-  0xd5, 0xa8, 0xf0, 0xaa, 0xfe, 0xc7, 0x66, 0xd3, 0xaa, 0xf0, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46, 0x04, 0x4c, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04,
-  0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0xd7, 0xaa, 0x02, 0x1f,
-  0xaa, 0xfd, 0xc0, 0xaa, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xce, 0x05, 0x46,
-  0x05, 0x34, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x37, 0x17,
-  0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21,
-  0x07, 0x27, 0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x03, 0x39,
-  0xfd, 0x8a, 0x02, 0xc9, 0x73, 0x8a, 0x49, 0x01, 0x05, 0xfe, 0xa7, 0x66,
-  0x01, 0xbf, 0xfd, 0xf0, 0x63, 0x02, 0x73, 0xfd, 0x38, 0x74, 0x8a, 0x4a,
-  0xfe, 0xfa, 0x01, 0x5b, 0x64, 0xfe, 0x41, 0x02, 0x11, 0x03, 0xa2, 0xaa,
-  0xe8, 0x54, 0x94, 0xaa, 0xcb, 0xaa, 0xcb, 0xaa, 0xea, 0x54, 0x96, 0xaa,
-  0xcb, 0xaa, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
-  0x05, 0x09, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
-  0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
-  0x11, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
-  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x94, 0xaa,
-  0x02, 0x1f, 0xaa, 0xfc, 0x4b, 0xaa, 0x02, 0x1f, 0xaa, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x06,
-  0x00, 0x0a, 0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x09, 0x01, 0x21,
-  0x15, 0x21, 0x05, 0x45, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82,
-  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xf8, 0xfe, 0xeb, 0xfe, 0xee,
-  0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0xfc, 0x02, 0xaa, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x06,
-  0x00, 0x0a, 0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x09, 0x01,
-  0x15, 0x21, 0x35, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x61, 0x01, 0x21,
-  0xfb, 0x7e, 0x03, 0xf8, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01,
-  0x12, 0xfd, 0xc7, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4,
-  0xff, 0x56, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e,
-  0x00, 0x00, 0x33, 0x21, 0x15, 0x21, 0x09, 0x02, 0x15, 0x01, 0x35, 0x09,
-  0x01, 0x21, 0x15, 0x21, 0xc4, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc,
-  0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
-  0x7e, 0xaa, 0x05, 0x15, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa,
-  0x01, 0x6f, 0xfc, 0x02, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4,
-  0xff, 0x56, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e,
-  0x00, 0x00, 0x21, 0x15, 0x21, 0x35, 0x11, 0x35, 0x01, 0x15, 0x01, 0x35,
-  0x09, 0x01, 0x15, 0x21, 0x35, 0x05, 0x46, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
-  0x7e, 0x03, 0x60, 0x01, 0x22, 0xfb, 0x7e, 0xaa, 0xaa, 0x04, 0x6b, 0xb0,
-  0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0xfd, 0xc7, 0xaa, 0xaa,
-  0x00, 0x02, 0x00, 0xc4, 0xfe, 0xb1, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x13,
-  0x00, 0x1a, 0x00, 0x00, 0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21,
-  0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
-  0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x01, 0xf0, 0xfe, 0xd4, 0x01, 0xab,
-  0x56, 0xfd, 0xff, 0x02, 0x81, 0x7b, 0x7c, 0x24, 0x01, 0x2e, 0xfe, 0x52,
-  0x56, 0x02, 0x04, 0xfd, 0x7d, 0x7c, 0x7c, 0x03, 0x7b, 0xfc, 0xa0, 0x03,
-  0x60, 0xfb, 0x7e, 0x04, 0x82, 0xaa, 0xaa, 0x73, 0xaa, 0xa4, 0x73, 0x31,
-  0xaa, 0x73, 0xaa, 0xa5, 0x74, 0x05, 0x46, 0xfe, 0xeb, 0xfe, 0xee, 0xb2,
-  0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc4,
-  0xfe, 0xb1, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x13, 0x00, 0x1a, 0x00, 0x00,
-  0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21,
-  0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x01, 0x35, 0x01, 0x15,
-  0x01, 0x35, 0x01, 0x01, 0xf0, 0xfe, 0xd4, 0x01, 0xab, 0x56, 0xfd, 0xff,
-  0x02, 0x81, 0x7b, 0x7c, 0x24, 0x01, 0x2e, 0xfe, 0x52, 0x56, 0x02, 0x04,
-  0xfd, 0x7d, 0x7c, 0x7c, 0xfe, 0xf9, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60,
-  0xaa, 0xaa, 0x73, 0xaa, 0xa4, 0x73, 0x31, 0xaa, 0x73, 0xaa, 0xa5, 0x74,
-  0x05, 0x46, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00,
-  0x00, 0x02, 0x00, 0x85, 0x00, 0x2e, 0x07, 0x04, 0x04, 0xdf, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x09,
-  0x01, 0x15, 0x01, 0x35, 0x01, 0x07, 0x04, 0xfd, 0x19, 0x02, 0xe7, 0xfc,
-  0x36, 0x03, 0xca, 0xfd, 0x4c, 0xfd, 0x18, 0x02, 0xe8, 0xfc, 0x36, 0x03,
-  0xca, 0x04, 0x11, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08, 0x9f, 0x02,
-  0x0a, 0xce, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08, 0x9f, 0x02, 0x0a,
-  0x00, 0x02, 0x00, 0x85, 0x00, 0x2e, 0x07, 0x04, 0x04, 0xdf, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x03,
-  0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x86, 0x03, 0xca, 0xfc, 0x36, 0x02,
-  0xe7, 0x33, 0x03, 0xca, 0xfc, 0x36, 0x02, 0xe7, 0x04, 0x11, 0xce, 0xfd,
-  0xf6, 0x9f, 0xfd, 0xf8, 0xc5, 0x01, 0x8e, 0x01, 0x90, 0xce, 0xfd, 0xf6,
-  0x9f, 0xfd, 0xf8, 0xc5, 0x01, 0x8e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9e,
-  0xfe, 0xf2, 0x02, 0xb9, 0x06, 0x12, 0x00, 0x19, 0x00, 0x27, 0x00, 0x00,
-  0x01, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16,
-  0x17, 0x21, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x26, 0x27, 0x13, 0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x27, 0x06, 0x07,
-  0x06, 0x10, 0x17, 0x16, 0x02, 0x3c, 0x26, 0x1f, 0x50, 0x2f, 0x43, 0x43,
-  0x2f, 0x50, 0x1f, 0x26, 0xfe, 0xe0, 0x25, 0x1f, 0x50, 0x2f, 0x43, 0x43,
-  0x2f, 0x50, 0x1f, 0x25, 0x90, 0x13, 0x0f, 0x3b, 0x3a, 0x10, 0x13, 0x14,
-  0x10, 0x3a, 0x3b, 0x0f, 0x06, 0x12, 0x47, 0x46, 0xa3, 0x9e, 0xe2, 0xdf,
-  0xe0, 0xe3, 0x9e, 0xa2, 0x47, 0x47, 0x47, 0x47, 0xa2, 0x9e, 0xe3, 0xe0,
-  0xdf, 0xe2, 0x9e, 0xa3, 0x46, 0x47, 0xfa, 0x32, 0x3b, 0x3b, 0xe2, 0x01,
-  0xce, 0xe1, 0x3b, 0x3c, 0x3c, 0x3b, 0xe1, 0xfe, 0x32, 0xe2, 0x3b, 0x00,
-  0x00, 0x01, 0x00, 0xc2, 0x00, 0x1a, 0x05, 0x46, 0x04, 0xe8, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x35, 0x36, 0x3f, 0x01, 0x26, 0x25, 0x35,
-  0x04, 0x37, 0x13, 0x17, 0x07, 0x36, 0x37, 0x15, 0x06, 0x0f, 0x01, 0x16,
-  0x05, 0x15, 0x24, 0x07, 0x03, 0x27, 0x02, 0x1b, 0xa2, 0xb5, 0xee, 0xca,
-  0x5b, 0xf0, 0xfe, 0xdc, 0x01, 0x86, 0xe6, 0xb1, 0x85, 0x79, 0xa4, 0xb5,
-  0xec, 0xcd, 0x5a, 0xf5, 0x01, 0x1f, 0xfe, 0x79, 0xe6, 0xb0, 0x86, 0x01,
-  0x5d, 0x29, 0x5d, 0xb2, 0x6f, 0x26, 0xb6, 0x0e, 0x97, 0xb2, 0xaf, 0x0a,
-  0x01, 0x62, 0x52, 0xf4, 0x29, 0x60, 0xb2, 0x71, 0x25, 0xb5, 0x0d, 0x98,
-  0xb2, 0xaf, 0x0b, 0xfe, 0x9f, 0x52, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x05, 0x05, 0x46, 0x05, 0x64, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x00,
-  0x01, 0x05, 0x15, 0x25, 0x03, 0x27, 0x13, 0x25, 0x35, 0x01, 0x13, 0x17,
-  0x07, 0x25, 0x15, 0x05, 0x07, 0x0d, 0x01, 0x03, 0x40, 0x02, 0x05, 0xfd,
-  0xbb, 0x8a, 0x7a, 0x85, 0xfe, 0x42, 0x02, 0xcc, 0x9b, 0x7b, 0x62, 0x01,
-  0x02, 0xfe, 0xa1, 0xb4, 0xfe, 0x72, 0x01, 0x1d, 0x01, 0xdf, 0xcb, 0xb6,
-  0xea, 0xfe, 0xbd, 0x40, 0x01, 0x36, 0xb4, 0xa6, 0x01, 0x20, 0x01, 0x6f,
-  0x40, 0xe6, 0x68, 0xb6, 0x8b, 0x47, 0x9d, 0x70, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0xa0, 0x05, 0x46, 0x04, 0xff, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x00,
-  0x01, 0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x05, 0x15, 0x01, 0x03, 0x27,
-  0x37, 0x05, 0x35, 0x25, 0x37, 0x2d, 0x01, 0x02, 0xc8, 0xfd, 0xfb, 0x02,
-  0x46, 0x89, 0x7a, 0x84, 0x01, 0xbd, 0xfd, 0x35, 0x9c, 0x7a, 0x62, 0xfe,
-  0xfd, 0x01, 0x5f, 0xb4, 0x01, 0x8e, 0xfe, 0xe4, 0x03, 0x25, 0xcb, 0xb6,
-  0xea, 0x01, 0x43, 0x40, 0xfe, 0xca, 0xb4, 0xa6, 0xfe, 0xe0, 0xfe, 0x91,
-  0x40, 0xe6, 0x68, 0xb6, 0x8b, 0x47, 0x9d, 0x70, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x2f, 0x05, 0x46, 0x05, 0x56, 0x00, 0x02, 0x00, 0x1a, 0x00, 0x00,
-  0x01, 0x0d, 0x01, 0x03, 0x21, 0x35, 0x21, 0x13, 0x25, 0x35, 0x25, 0x13,
-  0x17, 0x07, 0x25, 0x15, 0x05, 0x03, 0x05, 0x15, 0x25, 0x03, 0x21, 0x15,
-  0x21, 0x07, 0x27, 0x03, 0x37, 0xfe, 0xae, 0x01, 0x11, 0xdc, 0xfe, 0xa9,
-  0x01, 0x91, 0x6c, 0xfe, 0x03, 0x02, 0xb6, 0x6a, 0x94, 0x41, 0x01, 0x0f,
-  0xfe, 0xaf, 0x67, 0x01, 0xb8, 0xfe, 0x12, 0x5c, 0x02, 0x4a, 0xfd, 0x7d,
-  0x45, 0x93, 0x03, 0x4f, 0x6c, 0x55, 0xfd, 0x72, 0xaa, 0x01, 0x43, 0xa2,
-  0xaa, 0xdd, 0x01, 0x40, 0x3d, 0xc7, 0x56, 0xb0, 0x6c, 0xfe, 0xd1, 0x8c,
-  0xb2, 0x9e, 0xfe, 0xed, 0xaa, 0xd1, 0x3d, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x2f, 0x05, 0x46, 0x05, 0x56, 0x00, 0x02, 0x00, 0x1a, 0x00, 0x00,
-  0x01, 0x37, 0x27, 0x01, 0x23, 0x35, 0x21, 0x37, 0x05, 0x35, 0x25, 0x37,
-  0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x05, 0x15, 0x05, 0x03, 0x21, 0x15,
-  0x21, 0x07, 0x27, 0x03, 0x36, 0xee, 0xc0, 0xfe, 0x4d, 0xee, 0x01, 0x27,
-  0x4e, 0xfe, 0x8b, 0x01, 0xb7, 0x52, 0xfd, 0xf7, 0x02, 0x3f, 0x77, 0x94,
-  0x73, 0x01, 0xab, 0xfd, 0xaf, 0x62, 0x02, 0xb3, 0xfd, 0x14, 0x46, 0x94,
-  0x02, 0x97, 0x4c, 0x3e, 0xfc, 0xdf, 0xaa, 0xec, 0x77, 0xb2, 0x8b, 0xf5,
-  0xa7, 0xb0, 0xb7, 0x01, 0x65, 0x3d, 0xfe, 0xa8, 0x88, 0xaa, 0xbd, 0xfe,
-  0xd8, 0xaa, 0xd1, 0x3d, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x90, 0x05, 0x46,
-  0x04, 0xa8, 0x00, 0x1d, 0x00, 0x24, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33,
-  0x32, 0x36, 0x13, 0x09, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f,
-  0xa1, 0x57, 0x63, 0x84, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b,
-  0x58, 0x5e, 0xa1, 0x58, 0x63, 0x84, 0x0a, 0x04, 0x06, 0x0d, 0x8c, 0x54,
-  0x4e, 0x98, 0x5c, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xf0,
-  0xb4, 0x4e, 0x44, 0x3a, 0x04, 0x04, 0x02, 0x06, 0x3c, 0x4c, 0x54, 0xb4,
-  0x4e, 0x44, 0x3a, 0x06, 0x02, 0x02, 0x06, 0x3c, 0x4a, 0x03, 0x5e, 0xfe,
-  0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc4, 0xff, 0xb0, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x1b,
-  0x00, 0x22, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x2e,
-  0x01, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x17, 0x1e, 0x01, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x35, 0x01, 0x15,
-  0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x0b,
-  0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x63, 0x85, 0x09,
-  0x0b, 0x0d, 0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdc, 0x04, 0x82, 0xfb, 0x7e,
-  0x03, 0x61, 0x01, 0x0e, 0xb2, 0x4e, 0x46, 0x3c, 0x04, 0x04, 0x06, 0x3e,
-  0x4c, 0x54, 0xb2, 0x4e, 0x46, 0x3c, 0x04, 0x04, 0x06, 0x3e, 0x4c, 0x03,
-  0x3e, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46, 0x05, 0x50, 0x00, 0x31,
-  0x00, 0x34, 0x00, 0x00, 0x25, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
-  0x01, 0x33, 0x32, 0x17, 0x13, 0x25, 0x35, 0x25, 0x13, 0x17, 0x07, 0x25,
-  0x15, 0x05, 0x03, 0x05, 0x15, 0x25, 0x03, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x2f, 0x01, 0x07, 0x27, 0x01, 0x0d, 0x01, 0x02, 0x2d, 0x1b,
-  0x0c, 0x4f, 0x9b, 0x58, 0x5e, 0xa1, 0x58, 0x22, 0x27, 0x60, 0xfd, 0xff,
-  0x02, 0xbb, 0x69, 0x95, 0x3f, 0x01, 0x08, 0xfe, 0xb4, 0x67, 0x01, 0xb3,
-  0xfe, 0x17, 0x60, 0x06, 0x0a, 0x04, 0x06, 0x0d, 0x8c, 0x54, 0x4e, 0x98,
-  0x5d, 0x5f, 0xa1, 0x57, 0x63, 0x84, 0x09, 0x06, 0x05, 0x0e, 0x1f, 0x48,
-  0x95, 0x01, 0x51, 0xfe, 0xaa, 0x01, 0x13, 0x2d, 0x03, 0x4c, 0x54, 0xb4,
-  0x4e, 0x44, 0x07, 0x01, 0x1d, 0xa3, 0xaa, 0xde, 0x01, 0x39, 0x41, 0xbb,
-  0x54, 0xb0, 0x6a, 0xfe, 0xcd, 0x8a, 0xb2, 0x9c, 0xfe, 0xe3, 0x02, 0x06,
-  0x02, 0x02, 0x06, 0x3c, 0x4a, 0x56, 0xb4, 0x4e, 0x44, 0x3a, 0x04, 0x04,
-  0x02, 0x06, 0x0d, 0xd8, 0x3c, 0x03, 0xec, 0x6e, 0x57, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x2f, 0x05, 0x46, 0x05, 0x56, 0x00, 0x31,
-  0x00, 0x34, 0x00, 0x00, 0x01, 0x05, 0x15, 0x05, 0x07, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x27, 0x37, 0x06,
-  0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x3f, 0x01, 0x05, 0x35, 0x25,
-  0x37, 0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x37, 0x27, 0x03, 0xa1, 0x01,
-  0xa4, 0xfd, 0xb6, 0x54, 0x2b, 0x30, 0x0a, 0x04, 0x06, 0x0d, 0x8c, 0x54,
-  0x4e, 0x98, 0x5d, 0x5f, 0xa1, 0x57, 0x63, 0x84, 0x09, 0x06, 0x05, 0x0e,
-  0x41, 0x34, 0x5e, 0x94, 0x4e, 0x32, 0x32, 0x4d, 0x58, 0x5e, 0x51, 0x45,
-  0x4b, 0x36, 0xfe, 0x8a, 0x01, 0xb8, 0x55, 0xfd, 0xf3, 0x02, 0x43, 0x73,
-  0x94, 0xd1, 0xe8, 0xb9, 0x03, 0xbf, 0x86, 0xaa, 0xbb, 0xf7, 0x0d, 0x16,
-  0x04, 0x02, 0x02, 0x06, 0x3e, 0x4c, 0x54, 0xb2, 0x4e, 0x46, 0x3c, 0x04,
-  0x02, 0x02, 0x06, 0x1d, 0x0f, 0xfe, 0xf1, 0x3d, 0xdf, 0x09, 0x18, 0x26,
-  0x54, 0xb2, 0x4e, 0x23, 0x1e, 0x04, 0xa1, 0x77, 0xb2, 0x8b, 0xf4, 0xa8,
-  0xb0, 0xb8, 0x01, 0x66, 0x3d, 0xfd, 0x80, 0x4a, 0x3b, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xbb, 0xff, 0x4e, 0x05, 0x46, 0x05, 0x7d, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x09, 0x03,
-  0x15, 0x01, 0x35, 0x01, 0xc4, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x01,
-  0x19, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x02, 0x27, 0xb0,
-  0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x03, 0xbb, 0xfe, 0xeb,
-  0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x02, 0x00, 0xbb,
-  0xff, 0x4e, 0x05, 0x46, 0x05, 0x7d, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
-  0x09, 0x02, 0x15, 0x01, 0x35, 0x09, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35,
-  0x01, 0x05, 0x3d, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
-  0x87, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x02, 0x27, 0xfe, 0xeb, 0xfe,
-  0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x01, 0xf6, 0xb0, 0xfe, 0x91,
-  0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00, 0x03, 0x00, 0xbb,
-  0xfe, 0x6d, 0x05, 0x46, 0x06, 0x60, 0x00, 0x02, 0x00, 0x1e, 0x00, 0x21,
-  0x00, 0x00, 0x2d, 0x02, 0x03, 0x25, 0x35, 0x25, 0x13, 0x17, 0x03, 0x25,
-  0x15, 0x05, 0x03, 0x05, 0x15, 0x25, 0x07, 0x05, 0x15, 0x05, 0x03, 0x27,
-  0x13, 0x05, 0x35, 0x25, 0x13, 0x25, 0x35, 0x05, 0x13, 0x0d, 0x01, 0x02,
-  0xf8, 0x01, 0x2c, 0xfe, 0xfa, 0x57, 0xfd, 0xf4, 0x02, 0x7c, 0x51, 0x95,
-  0x3e, 0x01, 0x5e, 0xfe, 0x7a, 0x3a, 0x01, 0xc0, 0xfe, 0x1d, 0x1a, 0x02,
-  0x06, 0xfd, 0x8c, 0x51, 0x96, 0x3e, 0xfe, 0x9b, 0x01, 0x8d, 0x39, 0xfe,
-  0x3a, 0x01, 0xe9, 0x62, 0xfe, 0xce, 0x01, 0x0d, 0xb3, 0x5f, 0x54, 0x01,
-  0x57, 0xa7, 0xaa, 0xca, 0x01, 0x88, 0x26, 0xfe, 0xd4, 0x6f, 0xb0, 0x7d,
-  0xfe, 0xe4, 0x8e, 0xb2, 0x9a, 0x81, 0xa5, 0xaa, 0xc8, 0xfe, 0x77, 0x26,
-  0x01, 0x2d, 0x72, 0xb2, 0x7e, 0x01, 0x18, 0x91, 0xb0, 0x9b, 0x01, 0xde,
-  0x62, 0x55, 0x00, 0x00, 0x00, 0x03, 0x00, 0xbb, 0xfe, 0x6d, 0x05, 0x46,
-  0x06, 0x60, 0x00, 0x02, 0x00, 0x05, 0x00, 0x21, 0x00, 0x00, 0x01, 0x07,
-  0x17, 0x01, 0x37, 0x2f, 0x01, 0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x05,
-  0x15, 0x05, 0x07, 0x25, 0x15, 0x05, 0x07, 0x05, 0x15, 0x25, 0x03, 0x27,
-  0x13, 0x25, 0x35, 0x25, 0x37, 0x05, 0x35, 0x25, 0x02, 0x7a, 0x9d, 0x89,
-  0x01, 0x29, 0x95, 0x83, 0x94, 0xfd, 0xb7, 0x02, 0x6c, 0x58, 0x95, 0x5a,
-  0x01, 0x83, 0xfe, 0x21, 0x1e, 0x01, 0xf4, 0xfd, 0xe5, 0x28, 0x02, 0x43,
-  0xfd, 0x9b, 0x57, 0x96, 0x59, 0xfe, 0x77, 0x01, 0xe6, 0x1e, 0xfe, 0x05,
-  0x02, 0x22, 0x01, 0x44, 0x32, 0x2c, 0x02, 0xa3, 0x2f, 0x2a, 0x2f, 0xbc,
-  0xb0, 0xc5, 0x01, 0xa8, 0x26, 0xfe, 0x4f, 0x7b, 0xaa, 0x98, 0x94, 0x9f,
-  0xb0, 0xad, 0xc2, 0xb8, 0xb2, 0xc4, 0xfe, 0x5b, 0x26, 0x01, 0xae, 0x7d,
-  0xaa, 0x9a, 0x94, 0xa2, 0xb2, 0xad, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0xff, 0xb2, 0x05, 0x46, 0x05, 0x50, 0x00, 0x0a, 0x00, 0x00, 0x01, 0x00,
-  0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x05, 0x45, 0xfe,
-  0x9a, 0xfe, 0x27, 0x01, 0xd5, 0x01, 0x6a, 0xfe, 0x97, 0xfc, 0xe7, 0x03,
-  0x1b, 0x01, 0x67, 0x04, 0x61, 0xfe, 0x81, 0x61, 0x5e, 0xfe, 0x7e, 0xef,
-  0x02, 0x00, 0x7c, 0xa6, 0x7c, 0x02, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0xff, 0xb2, 0x05, 0x46, 0x05, 0x50, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x35,
-  0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0xc3, 0x01, 0x67,
-  0x03, 0x1b, 0xfc, 0xe7, 0xfe, 0x97, 0x01, 0x6a, 0x01, 0xd5, 0xfe, 0x27,
-  0x04, 0x61, 0xef, 0xfe, 0x00, 0x7c, 0xa6, 0x7c, 0xfe, 0x00, 0xef, 0x01,
-  0x82, 0x5e, 0x61, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46,
-  0x05, 0x57, 0x00, 0x05, 0x00, 0x10, 0x00, 0x00, 0x21, 0x15, 0x00, 0x25,
-  0x35, 0x04, 0x01, 0x00, 0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24,
-  0x01, 0x05, 0x45, 0xfe, 0x90, 0xfc, 0xee, 0x03, 0x01, 0x01, 0x81, 0xfe,
-  0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe, 0xa7, 0xfc, 0xd7, 0x03,
-  0x29, 0x01, 0x59, 0xd7, 0x01, 0xbe, 0x91, 0xae, 0x85, 0x02, 0xdf, 0xfe,
-  0xe5, 0x5d, 0x5d, 0xfe, 0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01,
-  0x80, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46,
-  0x05, 0x57, 0x00, 0x05, 0x00, 0x10, 0x00, 0x00, 0x33, 0x00, 0x25, 0x15,
-  0x04, 0x01, 0x11, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25,
-  0x24, 0xc3, 0x01, 0x81, 0x03, 0x01, 0xfc, 0xee, 0xfe, 0x90, 0x01, 0x59,
-  0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7, 0x01, 0x59, 0x01, 0xac, 0xfe, 0x54,
-  0x01, 0xa1, 0x85, 0xae, 0x91, 0xfe, 0x42, 0x05, 0x57, 0xd7, 0xfe, 0x80,
-  0x7c, 0xa6, 0x84, 0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x52, 0x05, 0x46, 0x05, 0x57, 0x00, 0x1d,
-  0x00, 0x28, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x00,
-  0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x05, 0x45, 0x5e,
-  0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a,
-  0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55,
-  0x4d, 0x98, 0x5d, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe,
-  0xa7, 0xfc, 0xd7, 0x03, 0x29, 0x01, 0x59, 0xb1, 0xb3, 0x4e, 0x45, 0x3b,
-  0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x3b, 0x05,
-  0x02, 0x02, 0x06, 0x3d, 0x4b, 0x04, 0x24, 0xfe, 0xe5, 0x5d, 0x5d, 0xfe,
-  0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01, 0x80, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x52, 0x05, 0x46, 0x05, 0x57, 0x00, 0x1d,
-  0x00, 0x28, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x35,
-  0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0x05, 0x45, 0x5e,
-  0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a,
-  0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55,
-  0x4d, 0x98, 0xfb, 0xdb, 0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7,
-  0x01, 0x59, 0x01, 0xac, 0xfe, 0x54, 0xb1, 0xb3, 0x4e, 0x45, 0x3b, 0x04,
-  0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x3b, 0x05, 0x02,
-  0x02, 0x06, 0x3d, 0x4b, 0x04, 0x24, 0xd7, 0xfe, 0x80, 0x7c, 0xa6, 0x84,
-  0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x83, 0x05, 0x46, 0x06, 0x1d, 0x00, 0x15, 0x00, 0x1a, 0x00, 0x00,
-  0x01, 0x26, 0x25, 0x35, 0x24, 0x25, 0x01, 0x17, 0x03, 0x36, 0x37, 0x15,
-  0x06, 0x07, 0x03, 0x04, 0x17, 0x15, 0x02, 0x25, 0x03, 0x27, 0x01, 0x06,
-  0x07, 0x16, 0x17, 0x02, 0xa3, 0xd8, 0xfe, 0xf8, 0x01, 0x96, 0x01, 0x25,
-  0x01, 0x01, 0x76, 0xa7, 0x8e, 0x69, 0xa7, 0xc1, 0x7d, 0x01, 0x06, 0xdf,
-  0xcc, 0xfe, 0xa8, 0xd3, 0x76, 0x01, 0x47, 0x88, 0x91, 0x71, 0x6a, 0x01,
-  0xb0, 0x55, 0x29, 0xa6, 0x3f, 0xa5, 0x02, 0x65, 0x4b, 0xfe, 0x74, 0x75,
-  0x95, 0xef, 0xb3, 0x75, 0xfe, 0xd4, 0x7f, 0xed, 0xef, 0x01, 0x22, 0xa6,
-  0xfe, 0x09, 0x4b, 0x03, 0x0a, 0x39, 0x1e, 0x17, 0x27, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xe5, 0x05, 0x46, 0x05, 0x7f, 0x00, 0x15,
-  0x00, 0x1a, 0x00, 0x00, 0x01, 0x16, 0x05, 0x15, 0x04, 0x05, 0x01, 0x27,
-  0x13, 0x06, 0x07, 0x35, 0x36, 0x37, 0x13, 0x24, 0x27, 0x35, 0x12, 0x05,
-  0x13, 0x17, 0x01, 0x36, 0x37, 0x26, 0x27, 0x03, 0x65, 0xd8, 0x01, 0x08,
-  0xfe, 0x6a, 0xfe, 0xdc, 0xfe, 0xfe, 0x76, 0xa7, 0x8e, 0x69, 0xa8, 0xc0,
-  0x7e, 0xfe, 0xf9, 0xdf, 0xcd, 0x01, 0x57, 0xd4, 0x75, 0xfe, 0xb9, 0x88,
-  0x91, 0x70, 0x6a, 0x03, 0x52, 0x55, 0x29, 0xa6, 0x3f, 0xa5, 0xfd, 0x9b,
-  0x4b, 0x01, 0x8c, 0x75, 0x95, 0xef, 0xb3, 0x75, 0x01, 0x2c, 0x7f, 0xed,
-  0xef, 0xfe, 0xde, 0xa6, 0x01, 0xf7, 0x4b, 0xfc, 0xf6, 0x39, 0x1e, 0x17,
-  0x27, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb7, 0x00, 0xa3, 0x05, 0x51,
-  0x04, 0x5f, 0x00, 0x13, 0x00, 0x00, 0x25, 0x21, 0x22, 0x02, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x21, 0x05, 0x51, 0xfd, 0x15, 0xb6, 0xf8, 0x7c, 0x7c, 0xb4, 0x02,
-  0xed, 0xfd, 0x13, 0x7a, 0xab, 0x54, 0x57, 0x7a, 0x02, 0xed, 0xa3, 0x01,
-  0x16, 0xc8, 0xc6, 0x8d, 0x8b, 0x96, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x00,
-  0x00, 0x01, 0x00, 0xb7, 0x00, 0xa3, 0x05, 0x51, 0x04, 0x5f, 0x00, 0x13,
-  0x00, 0x00, 0x37, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0x21, 0x35, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x02, 0x23, 0xb8, 0x02,
-  0xec, 0x7b, 0x56, 0x55, 0xab, 0x7b, 0xfd, 0x14, 0x02, 0xec, 0xb4, 0x7d,
-  0x7c, 0xf9, 0xb5, 0xa3, 0x96, 0x60, 0x5e, 0x8a, 0x88, 0xc0, 0x96, 0x8b,
-  0x8d, 0xc6, 0xc8, 0xfe, 0xea, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb7,
-  0xff, 0x3b, 0x05, 0x51, 0x05, 0xcf, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00,
-  0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x1b, 0x01,
-  0x33, 0x03, 0x21, 0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x03, 0x23, 0x13,
-  0x22, 0x02, 0x35, 0x34, 0x37, 0x36, 0x33, 0x03, 0x45, 0xe1, 0x7a, 0xab,
-  0x54, 0x57, 0x7a, 0x2b, 0xdf, 0x67, 0x99, 0x67, 0x01, 0x4a, 0xfe, 0x8d,
-  0xb6, 0x02, 0x29, 0xfd, 0xae, 0x65, 0x99, 0x65, 0xb4, 0xfa, 0x7c, 0x7c,
-  0xb4, 0x03, 0xc9, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x03, 0x26, 0x01, 0x70,
-  0xfe, 0x90, 0x96, 0xfd, 0x70, 0x96, 0xfe, 0x98, 0x01, 0x68, 0x01, 0x16,
-  0xc8, 0xc6, 0x8d, 0x8b, 0x00, 0x02, 0x00, 0xb7, 0xff, 0x33, 0x05, 0x51,
-  0x05, 0xc7, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x0b, 0x01, 0x23, 0x13, 0x21, 0x35,
-  0x21, 0x13, 0x21, 0x35, 0x21, 0x13, 0x33, 0x03, 0x32, 0x12, 0x15, 0x14,
-  0x07, 0x06, 0x23, 0x02, 0xc3, 0xe1, 0x7b, 0xab, 0x55, 0x56, 0x7b, 0x2b,
-  0xdf, 0x67, 0x99, 0x67, 0xfe, 0xb7, 0x01, 0x72, 0xb6, 0xfd, 0xd8, 0x02,
-  0x52, 0x64, 0x99, 0x64, 0xb4, 0xfa, 0x7c, 0x7d, 0xb4, 0x01, 0x39, 0xc0,
-  0x88, 0x8a, 0x5e, 0x60, 0xfc, 0xda, 0xfe, 0x90, 0x01, 0x70, 0x96, 0x02,
-  0x90, 0x96, 0x01, 0x68, 0xfe, 0x98, 0xfe, 0xea, 0xc8, 0xc6, 0x8d, 0x8b,
-  0x00, 0x02, 0x00, 0xab, 0x00, 0x00, 0x05, 0x46, 0x04, 0xe8, 0x00, 0x03,
-  0x00, 0x18, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x01, 0x21, 0x22, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x21, 0xda, 0x04, 0x6b, 0xfb, 0x95, 0x04, 0x6b,
-  0xfd, 0x14, 0xb5, 0x7c, 0x7d, 0x7d, 0x7c, 0xb4, 0x02, 0xed, 0xfd, 0x13,
-  0x7b, 0xab, 0x56, 0x56, 0x7a, 0x02, 0xed, 0x96, 0x96, 0x01, 0x2c, 0x8b,
-  0x8b, 0xc8, 0xc6, 0x8d, 0x8b, 0x96, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x5e, 0x04, 0xe8, 0x00, 0x03,
-  0x00, 0x18, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x11, 0x35, 0x21, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x23, 0xc3, 0x04, 0x6c, 0xfb, 0x94, 0x02, 0xed,
-  0x7a, 0x57, 0x55, 0xab, 0x7b, 0xfd, 0x13, 0x02, 0xed, 0xb4, 0x7c, 0x7d,
-  0x7d, 0x7c, 0xb5, 0x96, 0x96, 0x01, 0x2c, 0x96, 0x60, 0x5e, 0x8a, 0x88,
-  0xc0, 0x96, 0x8b, 0x8d, 0xc6, 0xc8, 0x8b, 0x8b, 0x00, 0x02, 0x00, 0xab,
-  0xff, 0x13, 0x05, 0x46, 0x05, 0xd7, 0x00, 0x09, 0x00, 0x27, 0x00, 0x00,
-  0x01, 0x21, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x02, 0x21, 0x15,
-  0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x23, 0x35, 0x21, 0x37,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x37, 0x17, 0x07,
-  0x21, 0x15, 0x21, 0x03, 0x6f, 0xfe, 0xe9, 0x7b, 0xab, 0x56, 0x56, 0x7a,
-  0x23, 0x8d, 0x02, 0x3d, 0xfd, 0x8b, 0x37, 0x02, 0xac, 0xfd, 0x1c, 0x58,
-  0x79, 0x45, 0xfb, 0x01, 0x32, 0x38, 0xa7, 0x75, 0x7d, 0x7d, 0x7c, 0xb4,
-  0x01, 0x4f, 0x58, 0x79, 0x44, 0x01, 0x11, 0xfe, 0xb7, 0x04, 0x52, 0xc0,
-  0x88, 0x8a, 0x5e, 0x60, 0x96, 0x96, 0x96, 0xed, 0x35, 0xb8, 0x96, 0x96,
-  0x08, 0x83, 0x8b, 0xc8, 0xc6, 0x8d, 0x8b, 0xef, 0x37, 0xb8, 0x96, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x13, 0x05, 0x5e, 0x05, 0xd7, 0x00, 0x09,
-  0x00, 0x27, 0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x2f, 0x01, 0x21, 0x35, 0x21, 0x37, 0x17, 0x07, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
-  0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x03, 0x08, 0xa8, 0x7a,
-  0x57, 0x55, 0x55, 0x3b, 0x4e, 0x89, 0xfd, 0x54, 0x02, 0xe4, 0x58, 0x79,
-  0x4c, 0x66, 0x4e, 0x7d, 0x7d, 0x7c, 0xb5, 0xde, 0x38, 0x02, 0x96, 0xfd,
-  0x32, 0x58, 0x79, 0x45, 0xfe, 0xee, 0x01, 0x49, 0x38, 0xfe, 0x7f, 0x01,
-  0xb8, 0x01, 0xc2, 0x60, 0x5e, 0x8a, 0x88, 0x60, 0x43, 0x14, 0x09, 0x96,
-  0xef, 0x37, 0xcb, 0x20, 0x58, 0x8d, 0xc6, 0xc8, 0x8b, 0x8b, 0x96, 0x96,
-  0xed, 0x35, 0xb8, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0x00, 0xab,
-  0xff, 0x6a, 0x05, 0x46, 0x04, 0xe9, 0x00, 0x0b, 0x00, 0x20, 0x00, 0x00,
-  0x29, 0x01, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
-  0x01, 0x21, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x15,
-  0x21, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x21, 0x02, 0x7d, 0xfe,
-  0x5d, 0x02, 0x08, 0x66, 0x6c, 0x28, 0x01, 0xb9, 0xfd, 0xe1, 0x65, 0x6c,
-  0x02, 0xf0, 0xfd, 0x14, 0xb5, 0x7c, 0x7d, 0x7d, 0x7c, 0xb4, 0x02, 0xed,
-  0xfd, 0x13, 0x7b, 0xab, 0x56, 0x56, 0x7a, 0x02, 0xed, 0x96, 0x96, 0x5a,
-  0x3c, 0x96, 0x96, 0x5a, 0x01, 0x69, 0x8b, 0x8b, 0xc8, 0xc6, 0x8d, 0x8b,
-  0x96, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x00, 0x00, 0x00, 0x02, 0x00, 0xab,
-  0xff, 0x6a, 0x05, 0x46, 0x04, 0xe9, 0x00, 0x0b, 0x00, 0x20, 0x00, 0x00,
-  0x29, 0x01, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
-  0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35,
-  0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x02, 0x7d, 0xfe,
-  0x5d, 0x02, 0x08, 0x66, 0x6c, 0x28, 0x01, 0xb9, 0xfd, 0xe1, 0x65, 0x6c,
-  0xfe, 0x56, 0x02, 0xed, 0x7a, 0x57, 0x55, 0xab, 0x7b, 0xfd, 0x13, 0x02,
-  0xed, 0xb4, 0x7c, 0x7d, 0x7d, 0x7c, 0xb5, 0x96, 0x96, 0x5a, 0x3c, 0x96,
-  0x96, 0x5a, 0x01, 0x69, 0x96, 0x60, 0x5e, 0x8a, 0x88, 0xc0, 0x96, 0x8b,
-  0x8d, 0xc6, 0xc8, 0x8b, 0x8b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xed,
-  0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x11, 0x00, 0x1b, 0x00, 0x00,
-  0x13, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33,
-  0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x37, 0x35, 0x37, 0x17, 0x07, 0x21,
-  0x15, 0x21, 0x17, 0x07, 0xee, 0x9a, 0x86, 0x95, 0x95, 0x85, 0x9b, 0xdd,
-  0xd8, 0xd9, 0xdc, 0xd6, 0xb0, 0x36, 0x68, 0x01, 0x3f, 0xfe, 0xc1, 0x68,
-  0x36, 0x02, 0x52, 0x02, 0x50, 0xfd, 0xc9, 0xf4, 0xd3, 0xd3, 0xf4, 0x02,
-  0x37, 0xfd, 0xb0, 0xfe, 0xd8, 0xfe, 0xd6, 0x01, 0x2a, 0xca, 0x2d, 0xc5,
-  0x3c, 0x75, 0x55, 0x74, 0x3c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xed,
-  0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x10, 0x26, 0x09, 0x06, 0x00, 0x00,
-  0x10, 0x07, 0x09, 0xa1, 0x01, 0x7e, 0xff, 0x33, 0x00, 0x02, 0x00, 0xed,
-  0x00, 0x05, 0x04, 0x58, 0x04, 0xa7, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x00,
-  0x13, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33,
-  0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x01, 0x15, 0x33, 0x15, 0x23, 0x15,
-  0x23, 0x35, 0x23, 0x35, 0x33, 0x35, 0xee, 0x9a, 0x86, 0x95, 0x95, 0x85,
-  0x9b, 0xdd, 0xd8, 0xd9, 0xdc, 0x01, 0xe2, 0x99, 0x99, 0x5b, 0x99, 0x99,
-  0x02, 0x57, 0x02, 0x50, 0xfd, 0xc9, 0xf4, 0xd3, 0xd3, 0xf4, 0x02, 0x37,
-  0xfd, 0xb0, 0xfe, 0xd8, 0xfe, 0xd6, 0x01, 0x2a, 0x01, 0xe1, 0xab, 0x64,
-  0xab, 0xab, 0x64, 0xab, 0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
-  0x04, 0x8b, 0x00, 0x07, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0xe9, 0xfb, 0x7e, 0x04,
-  0x8b, 0xaa, 0xfc, 0xc9, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0x00, 0x00, 0x05, 0x46, 0x04, 0x8b, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x05, 0x45, 0xfb, 0x7e, 0x03, 0xe9,
-  0xfc, 0x17, 0x04, 0x8b, 0xfb, 0x75, 0xaa, 0x03, 0x37, 0xaa, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x56, 0x05, 0x46, 0x05, 0x0b, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0xe9, 0xfb,
-  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x05, 0x0b, 0xaa, 0xfc, 0xc9, 0xaa, 0x80,
-  0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x56, 0x05, 0x46,
-  0x05, 0x0b, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x21, 0x35, 0x01, 0x15, 0x21, 0x35, 0x05, 0x45, 0xfb, 0x7e,
-  0x03, 0xe9, 0xfc, 0x17, 0x04, 0x82, 0xfb, 0x7e, 0x05, 0x0b, 0xfb, 0x75,
-  0xaa, 0x03, 0x37, 0xaa, 0xfa, 0xf5, 0xaa, 0xaa, 0x00, 0x01, 0x00, 0xc3,
-  0x00, 0x00, 0x04, 0xdb, 0x05, 0x02, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x04, 0xdb, 0x99, 0xfd, 0x1a, 0x99,
-  0x05, 0x02, 0xfa, 0xfe, 0x04, 0x58, 0xfb, 0xa8, 0x05, 0x02, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x04, 0xdb, 0x05, 0x02, 0x00, 0x07,
-  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0xc3, 0x99,
-  0x02, 0xe6, 0x99, 0x05, 0x02, 0xfb, 0xa8, 0x04, 0x58, 0xfa, 0xfe, 0x00,
-  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x19,
-  0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x05, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x03, 0x64,
-  0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0,
-  0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8,
-  0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6,
-  0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a, 0x58, 0x01, 0x9f, 0x01, 0x40,
-  0xfe, 0xc0, 0x99, 0xfe, 0xbf, 0x01, 0x41, 0x04, 0x8e, 0x27, 0x27, 0x4c,
-  0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c,
-  0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63,
-  0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63,
-  0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x84, 0xfe, 0x9b, 0xaa,
-  0xfe, 0x9b, 0x01, 0x65, 0xaa, 0x01, 0x65, 0x00, 0x00, 0x03, 0x00, 0xa8,
-  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x37,
-  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x77,
-  0x03, 0x1a, 0xfc, 0xe6, 0x01, 0xed, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45,
-  0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44,
-  0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c,
-  0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c,
-  0x5a, 0x58, 0x02, 0xd7, 0xaa, 0x02, 0x61, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
-  0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
-  0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77, 0x76,
-  0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x77,
-  0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa8,
-  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x19, 0x00, 0x33, 0x00, 0x3f,
-  0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x07, 0x17, 0x07, 0x27, 0x07,
-  0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x03, 0x64, 0xc0, 0x54, 0x53, 0x44,
-  0x45, 0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46,
-  0x44, 0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c,
-  0x2c, 0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c,
-  0x2c, 0x2c, 0x5a, 0x58, 0x02, 0xa2, 0xe4, 0xe3, 0x6c, 0xe3, 0xe3, 0x6d,
-  0xe4, 0xe3, 0x6c, 0xe3, 0xe3, 0x04, 0x8e, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
-  0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
-  0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77, 0x76,
-  0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x77,
-  0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0xfe, 0xbe, 0xfc, 0xfc, 0x78, 0xfc,
-  0xfd, 0x79, 0xfc, 0xfc, 0x78, 0xfc, 0xfd, 0x00, 0x00, 0x03, 0x00, 0xa8,
-  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x37,
-  0x00, 0x00, 0x09, 0x01, 0x17, 0x01, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0xb5,
-  0x02, 0x32, 0x6c, 0xfd, 0xce, 0x01, 0x43, 0xc0, 0x54, 0x53, 0x44, 0x45,
-  0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44,
-  0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c,
-  0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c,
-  0x2c, 0x5a, 0x58, 0x01, 0x86, 0x02, 0x70, 0x78, 0xfd, 0x90, 0x03, 0x80,
-  0x27, 0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27,
-  0x27, 0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd,
-  0x64, 0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64,
-  0x64, 0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00,
-  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x1d, 0x00, 0x37, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x12, 0x22,
-  0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27,
-  0x24, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x02, 0xa5, 0xbe, 0xbe, 0xbf, 0xc0, 0x54, 0x53, 0x44, 0x45,
-  0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44,
-  0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c,
-  0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c,
-  0x2c, 0x5a, 0x58, 0x03, 0x01, 0xfe, 0x02, 0x8b, 0x27, 0x27, 0x4c, 0x4d,
-  0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d,
-  0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77,
-  0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76,
-  0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00, 0x04, 0x00, 0xa8,
-  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x09, 0x00, 0x18, 0x00, 0x32,
-  0x00, 0x4c, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36,
-  0x34, 0x26, 0x27, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01,
-  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e,
-  0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x04, 0x48,
-  0x63, 0x63, 0x90, 0x63, 0x64, 0x47, 0x3a, 0x6a, 0x27, 0x29, 0x2a, 0xa7,
-  0x79, 0x79, 0xa2, 0xa5, 0xd8, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45,
-  0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46,
-  0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c,
-  0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a,
-  0x58, 0x03, 0x41, 0x6f, 0x50, 0x4f, 0x6d, 0x6d, 0x9e, 0x70, 0x81, 0x31,
-  0x2e, 0x2d, 0x72, 0x42, 0x84, 0xb7, 0xb4, 0x87, 0x86, 0xba, 0xcc, 0x27,
-  0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27,
-  0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64,
-  0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64,
-  0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x11,
-  0x00, 0x2b, 0x00, 0x45, 0x00, 0x00, 0x01, 0x0d, 0x01, 0x07, 0x25, 0x11,
-  0x23, 0x11, 0x05, 0x27, 0x2d, 0x01, 0x37, 0x05, 0x11, 0x33, 0x11, 0x25,
-  0x02, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27,
-  0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x04, 0x72, 0xfe, 0xdd, 0x01, 0x23, 0x2f, 0xfe,
-  0xef, 0x5c, 0xfe, 0xf0, 0x2f, 0x01, 0x23, 0xfe, 0xdd, 0x2f, 0x01, 0x10,
-  0x5c, 0x01, 0x11, 0xdf, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45, 0x45,
-  0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46, 0x44,
-  0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c, 0x59,
-  0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a, 0x58,
-  0x03, 0x31, 0xaf, 0xb0, 0x58, 0xb7, 0xfe, 0xad, 0x01, 0x53, 0xb7, 0x58,
-  0xb0, 0xaf, 0x59, 0xb7, 0x01, 0x53, 0xfe, 0xad, 0xb7, 0x01, 0x04, 0x27,
-  0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27,
-  0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64,
-  0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64,
-  0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x21, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x15, 0x21, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01,
-  0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0xe4, 0x02, 0x40,
-  0xfd, 0xc0, 0x02, 0x40, 0xfd, 0xc0, 0x01, 0x80, 0xc0, 0x54, 0x53, 0x44,
-  0x45, 0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46,
-  0x44, 0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c,
-  0x2c, 0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c,
-  0x2c, 0x2c, 0x5a, 0x58, 0x03, 0x6a, 0x88, 0xc0, 0x88, 0x02, 0xf4, 0x27,
-  0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27,
-  0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64,
-  0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64,
-  0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x19,
-  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x21,
-  0x15, 0x21, 0x03, 0x64, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45, 0x45,
-  0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46, 0x44,
-  0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c, 0x59,
-  0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a, 0x58,
-  0x32, 0x02, 0x41, 0xfd, 0xbf, 0x04, 0x8e, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
-  0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
-  0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77, 0x76,
-  0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x77,
-  0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0xfe, 0x17, 0xaa, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21,
-  0x11, 0x21, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x01, 0x2f, 0x03, 0xaa, 0xfb, 0xcf, 0x04, 0xb8, 0xfb, 0x48,
-  0x02, 0xa9, 0x01, 0x40, 0xfe, 0xc0, 0x99, 0xfe, 0xbf, 0x01, 0x41, 0x04,
-  0x89, 0xfb, 0xf0, 0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x04, 0x59, 0xfe, 0x9b,
-  0xaa, 0xfe, 0x9b, 0x01, 0x65, 0xaa, 0x01, 0x65, 0x00, 0x03, 0x00, 0xa8,
-  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x03, 0x11, 0x21, 0x11, 0x25, 0x21,
-  0x11, 0x21, 0x01, 0x77, 0x03, 0x1a, 0xfc, 0xe6, 0x48, 0x03, 0xaa, 0xfb,
-  0xcf, 0x04, 0xb8, 0xfb, 0x48, 0x02, 0xd7, 0xaa, 0x02, 0x5c, 0xfb, 0xf0,
-  0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa8,
-  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13,
-  0x00, 0x00, 0x09, 0x02, 0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x37, 0x09,
-  0x01, 0x25, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x04, 0xb7, 0xfe,
-  0xb9, 0x01, 0x47, 0x6d, 0xfe, 0xba, 0xfe, 0xba, 0x6c, 0x01, 0x46, 0xfe,
-  0xba, 0x6c, 0x01, 0x46, 0x01, 0x46, 0xfc, 0xe5, 0x03, 0xaa, 0xfb, 0xcf,
-  0x04, 0xb8, 0xfb, 0x48, 0x03, 0xec, 0xfe, 0x96, 0xfe, 0x96, 0x78, 0x01,
-  0x6a, 0xfe, 0x95, 0x79, 0x01, 0x6a, 0x01, 0x6a, 0x79, 0xfe, 0x95, 0x01,
-  0x6b, 0x24, 0xfb, 0xf0, 0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x01, 0x11,
-  0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x02, 0xa5, 0xbe, 0xbe, 0xfe, 0x8a,
-  0x03, 0xaa, 0xfb, 0xcf, 0x04, 0xb8, 0xfb, 0x48, 0x03, 0x01, 0xfe, 0x02,
-  0x86, 0xfb, 0xf0, 0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x00, 0x01, 0x00, 0x9d,
-  0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07, 0x00, 0x00, 0x33, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x9e, 0x72, 0x04, 0x99, 0xfb, 0x67,
-  0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
-  0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x05, 0xa9, 0x72, 0xfb, 0x67, 0x04,
-  0x99, 0x72, 0x02, 0x90, 0x7f, 0x02, 0x8b, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15,
-  0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x05, 0xa8, 0xfd, 0xb4, 0x73, 0xfd,
-  0xb5, 0x05, 0x9a, 0x7f, 0xfa, 0xe5, 0x05, 0x1b, 0x7f, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07,
-  0x00, 0x00, 0x33, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x9e, 0x02,
-  0x4b, 0x73, 0x02, 0x4c, 0x7f, 0x05, 0x1b, 0xfa, 0xe5, 0x7f, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x03, 0x23, 0x05, 0x9a, 0x00, 0x07,
-  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x9e, 0x72,
-  0x02, 0x13, 0xfd, 0xed, 0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70, 0x00,
-  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x03, 0x23, 0x05, 0x9a, 0x00, 0x0b,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x01, 0x10, 0x72, 0x72, 0x02, 0x13, 0xfd, 0xed, 0x02, 0x13,
-  0xfd, 0xed, 0x05, 0x9a, 0xfe, 0x24, 0x7f, 0xe4, 0x7f, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x0b,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x15, 0x21, 0x01, 0x10, 0x72, 0x72, 0x04, 0x99, 0xfb, 0x67, 0x04, 0x99,
-  0xfb, 0x67, 0x05, 0x9a, 0xfe, 0x24, 0x7f, 0xe4, 0x7f, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x00, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x21, 0x23, 0x11, 0x33, 0x01, 0xdd, 0x72, 0x03, 0x5a, 0xfc, 0xa6, 0xfe,
-  0xc1, 0x72, 0x72, 0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70, 0x05, 0x9a,
-  0x00, 0x03, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x03,
-  0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x01, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x23, 0x11, 0x33, 0x01, 0x10,
-  0x72, 0x72, 0x02, 0x0c, 0x73, 0x02, 0x1a, 0xfd, 0xe6, 0xfe, 0xc0, 0x72,
-  0x72, 0x05, 0x9a, 0xfa, 0x66, 0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70,
-  0x05, 0x9a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9,
-  0x05, 0x9a, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x21, 0x23, 0x11, 0x33,
-  0x01, 0x23, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x01, 0x10, 0x72, 0x72, 0x01, 0x3f, 0x72, 0x72, 0x03, 0x5a, 0xfc, 0xa6,
-  0x03, 0x5a, 0xfc, 0xa6, 0x05, 0x9a, 0xfa, 0x66, 0x05, 0x9a, 0xfe, 0x24,
-  0x7f, 0xe4, 0x7f, 0x00, 0x00, 0x01, 0x00, 0x9d, 0xff, 0xaf, 0x05, 0xa9,
-  0x05, 0xeb, 0x00, 0x0f, 0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x21, 0x01,
-  0x17, 0x01, 0x21, 0x15, 0x21, 0x01, 0x27, 0x01, 0x21, 0x11, 0x9e, 0x72,
-  0x01, 0xef, 0x01, 0x32, 0x67, 0xfe, 0xe5, 0x02, 0x2c, 0xfd, 0x9f, 0xfe,
-  0xcd, 0x68, 0x01, 0x1d, 0xfe, 0x46, 0x05, 0x9a, 0xfd, 0x75, 0x02, 0xdc,
-  0x35, 0xfd, 0x59, 0x7f, 0xfd, 0x1f, 0x36, 0x02, 0xab, 0xfd, 0x70, 0x00,
-  0x00, 0x02, 0x00, 0x9d, 0xff, 0xaf, 0x05, 0xa9, 0x05, 0xeb, 0x00, 0x13,
-  0x00, 0x17, 0x00, 0x00, 0x01, 0x17, 0x03, 0x21, 0x15, 0x21, 0x07, 0x21,
-  0x15, 0x21, 0x03, 0x27, 0x13, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21,
-  0x03, 0x37, 0x21, 0x15, 0x04, 0x31, 0x67, 0xd2, 0x01, 0xe3, 0xfd, 0xe8,
-  0x5f, 0x02, 0x77, 0xfd, 0x54, 0xe8, 0x68, 0xd2, 0xfe, 0x91, 0x72, 0x72,
-  0x02, 0x38, 0x94, 0x5f, 0xfd, 0xfd, 0x05, 0xeb, 0x35, 0xfe, 0x08, 0x7f,
-  0xe4, 0x7f, 0xfd, 0xd3, 0x36, 0x01, 0xf7, 0xfe, 0x24, 0x05, 0x9a, 0xfe,
-  0x24, 0xfe, 0x9d, 0xe4, 0xe4, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d,
-  0xff, 0xaf, 0x05, 0xa9, 0x05, 0xeb, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00,
-  0x01, 0x17, 0x01, 0x21, 0x15, 0x21, 0x01, 0x27, 0x01, 0x21, 0x11, 0x23,
-  0x11, 0x33, 0x11, 0x21, 0x01, 0x23, 0x11, 0x33, 0x04, 0xf5, 0x67, 0xfe,
-  0xe5, 0x01, 0x68, 0xfe, 0x63, 0xfe, 0xcd, 0x67, 0x01, 0x1d, 0xfe, 0xc0,
-  0x72, 0x72, 0x01, 0x75, 0xfd, 0x4c, 0x72, 0x72, 0x05, 0xeb, 0x35, 0xfd,
-  0x59, 0x7f, 0xfd, 0x1f, 0x36, 0x02, 0xab, 0xfd, 0x70, 0x05, 0x9a, 0xfd,
-  0x75, 0xfc, 0xf1, 0x05, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x9d,
-  0xff, 0xaf, 0x05, 0xa9, 0x05, 0xeb, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x21, 0x13, 0x17, 0x03, 0x21,
-  0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27, 0x13, 0x23, 0x01, 0x23,
-  0x11, 0x33, 0x01, 0x37, 0x21, 0x15, 0x02, 0x4f, 0x72, 0x72, 0x01, 0xc2,
-  0xe9, 0x67, 0xd2, 0x01, 0x1a, 0xfe, 0xb1, 0x5f, 0x01, 0xae, 0xfe, 0x1d,
-  0xe8, 0x68, 0xd2, 0xf9, 0xfe, 0xc1, 0x72, 0x72, 0x02, 0x6d, 0x5f, 0xfe,
-  0x73, 0x05, 0x9a, 0xfe, 0x24, 0x02, 0x2d, 0x35, 0xfe, 0x08, 0x7f, 0xe4,
-  0x7f, 0xfd, 0xd3, 0x36, 0x01, 0xf7, 0xfe, 0x24, 0x05, 0x9a, 0xfc, 0xc1,
-  0xe4, 0xe4, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xa7, 0x05, 0x37,
-  0x05, 0x5d, 0x00, 0x2a, 0x00, 0x00, 0x13, 0x35, 0x24, 0x25, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x27, 0x36, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x05, 0x04, 0x17, 0x16, 0x15, 0x14, 0x06, 0x23,
-  0x22, 0x27, 0x37, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
-  0x24, 0xc3, 0x01, 0x72, 0x01, 0x20, 0xb4, 0x5b, 0x37, 0x45, 0x38, 0x48,
-  0x32, 0x67, 0x51, 0x90, 0x7a, 0x9f, 0x85, 0xcd, 0xfe, 0xaf, 0x01, 0x51,
-  0xcd, 0x85, 0x9f, 0x7a, 0x90, 0x51, 0x67, 0x32, 0x48, 0x38, 0x45, 0x37,
-  0x5b, 0xb4, 0xfe, 0xe0, 0x02, 0x2e, 0xa8, 0x28, 0x59, 0x37, 0x4f, 0x30,
-  0x3c, 0x30, 0x3a, 0x3e, 0x7e, 0x6a, 0xa0, 0x79, 0x9f, 0x5b, 0x8c, 0x3c,
-  0x3c, 0x8c, 0x5b, 0x9f, 0x79, 0xa0, 0x6a, 0x7e, 0x3e, 0x3a, 0x30, 0x3c,
-  0x30, 0x4f, 0x37, 0x59, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xa7, 0x05, 0x37,
-  0x05, 0x5d, 0x00, 0x2a, 0x00, 0x00, 0x01, 0x04, 0x05, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x25, 0x24, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32,
-  0x17, 0x07, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x04,
-  0x05, 0x05, 0x37, 0xfe, 0x8e, 0xfe, 0xe0, 0xb4, 0x5b, 0x37, 0x45, 0x38,
-  0x48, 0x32, 0x67, 0x51, 0x90, 0x7a, 0x9f, 0x85, 0xcd, 0x01, 0x51, 0xfe,
-  0xaf, 0xcd, 0x85, 0x9f, 0x7a, 0x90, 0x51, 0x67, 0x32, 0x48, 0x38, 0x45,
-  0x37, 0x5b, 0xb4, 0x01, 0x20, 0x01, 0x72, 0x02, 0x2e, 0x28, 0x59, 0x37,
-  0x4f, 0x30, 0x3c, 0x30, 0x3a, 0x3e, 0x7e, 0x6a, 0xa0, 0x79, 0x9f, 0x5b,
-  0x8c, 0x3c, 0x3c, 0x8c, 0x5b, 0x9f, 0x79, 0xa0, 0x6a, 0x7e, 0x3e, 0x3a,
-  0x30, 0x3c, 0x30, 0x4f, 0x37, 0x59, 0x28, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x1e, 0x05, 0x46, 0x04, 0xe6, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00,
-  0x01, 0x11, 0x09, 0x02, 0x35, 0x01, 0x04, 0xac, 0xfc, 0xf8, 0x03, 0xa1,
-  0xfb, 0x7e, 0x04, 0x82, 0x01, 0x20, 0x02, 0xc4, 0xfe, 0x9e, 0xfd, 0x9c,
-  0x02, 0x11, 0xa6, 0x02, 0x11, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x1e, 0x05, 0x46, 0x04, 0xe6, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00,
-  0x09, 0x02, 0x03, 0x11, 0x01, 0x15, 0x01, 0x5c, 0x03, 0x08, 0xfc, 0xf8,
-  0x99, 0x04, 0x82, 0x01, 0x20, 0x01, 0x62, 0x01, 0x62, 0xfc, 0x3a, 0x04,
-  0xc8, 0xfd, 0xef, 0xa6, 0x00, 0x03, 0x00, 0xc3, 0xff, 0x9e, 0x05, 0x46,
-  0x05, 0x64, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x00, 0x17, 0x35,
-  0x21, 0x15, 0x03, 0x11, 0x09, 0x02, 0x35, 0x01, 0xc3, 0x04, 0x82, 0x99,
-  0xfc, 0xf8, 0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82, 0x62, 0xaa, 0xaa, 0x02,
-  0x00, 0x02, 0xc4, 0xfe, 0x9e, 0xfd, 0x9c, 0x02, 0x11, 0xa6, 0x02, 0x11,
-  0x00, 0x03, 0x00, 0xc3, 0xff, 0x9e, 0x05, 0x46, 0x05, 0x64, 0x00, 0x03,
-  0x00, 0x06, 0x00, 0x0a, 0x00, 0x00, 0x17, 0x35, 0x21, 0x15, 0x09, 0x02,
-  0x03, 0x11, 0x01, 0x15, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0x08, 0xfc,
-  0xf8, 0x99, 0x04, 0x82, 0x62, 0xaa, 0xaa, 0x02, 0x00, 0x01, 0x62, 0x01,
-  0x62, 0xfc, 0x3a, 0x04, 0xc8, 0xfd, 0xef, 0xa6, 0x00, 0x02, 0x00, 0x6c,
-  0x01, 0x67, 0x06, 0xc7, 0x03, 0xa2, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x00,
-  0x01, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x27, 0x26, 0x27, 0x21, 0x06,
-  0x07, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x17, 0x16, 0x17, 0x21, 0x36,
-  0x04, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x05, 0x0f, 0x4b, 0xd3,
-  0x99, 0x96, 0xda, 0x49, 0x2e, 0x11, 0xfd, 0x96, 0x12, 0x2e, 0x4c, 0xd9,
-  0x92, 0x95, 0xd4, 0x4e, 0x2f, 0x11, 0x02, 0x6a, 0x12, 0xfc, 0xc1, 0x67,
-  0x47, 0x47, 0x68, 0x47, 0x03, 0x4f, 0x53, 0xa8, 0xef, 0xa4, 0x51, 0x33,
-  0x43, 0x42, 0x33, 0x52, 0xa2, 0xf2, 0xa7, 0x55, 0x34, 0x43, 0x44, 0x0e,
-  0x50, 0x72, 0x4f, 0x4f, 0x71, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6c,
-  0x01, 0x67, 0x06, 0xc7, 0x03, 0xa2, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x00,
-  0x01, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x17, 0x16, 0x17, 0x21, 0x36,
-  0x37, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x27, 0x26, 0x27, 0x21, 0x06,
-  0x24, 0x32, 0x36, 0x34, 0x26, 0x22, 0x06, 0x14, 0x02, 0x24, 0x4b, 0xd3,
-  0x99, 0x96, 0xda, 0x49, 0x2e, 0x11, 0x02, 0x6a, 0x12, 0x2e, 0x4c, 0xd9,
-  0x92, 0x95, 0xd4, 0x4e, 0x2f, 0x11, 0xfd, 0x96, 0x12, 0x03, 0x3f, 0x67,
-  0x47, 0x47, 0x67, 0x48, 0x01, 0xba, 0x53, 0xa8, 0xef, 0xa4, 0x51, 0x33,
-  0x43, 0x42, 0x33, 0x52, 0xa2, 0xf2, 0xa7, 0x55, 0x34, 0x43, 0x44, 0x0e,
-  0x50, 0x72, 0x4f, 0x4f, 0x71, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x58,
-  0x01, 0x67, 0x05, 0xb1, 0x03, 0xa2, 0x00, 0x0d, 0x00, 0x15, 0x00, 0x00,
-  0x13, 0x37, 0x21, 0x36, 0x37, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x24, 0x26, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x58, 0x01,
-  0x03, 0x60, 0x11, 0x2c, 0x52, 0xd4, 0x94, 0x92, 0xd9, 0x4b, 0x2f, 0x11,
-  0x01, 0x71, 0x47, 0x68, 0x48, 0x48, 0x68, 0x47, 0x02, 0x2e, 0xa8, 0x44,
-  0x2f, 0x59, 0xa7, 0xf2, 0xa2, 0x52, 0x33, 0x42, 0x8e, 0x50, 0x51, 0x71,
-  0x4f, 0x4f, 0x00, 0x00, 0x00, 0x04, 0x00, 0x6c, 0xff, 0xa0, 0x05, 0x9c,
-  0x05, 0x64, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
-  0x01, 0x33, 0x11, 0x23, 0x05, 0x21, 0x15, 0x21, 0x03, 0x23, 0x11, 0x33,
-  0x25, 0x21, 0x35, 0x21, 0x02, 0xb9, 0x97, 0x97, 0x01, 0x0a, 0x01, 0xd9,
-  0xfe, 0x27, 0x73, 0x97, 0x97, 0xfe, 0xf5, 0xfe, 0x28, 0x01, 0xd8, 0x05,
-  0x64, 0xfd, 0xf3, 0x80, 0xaa, 0xfd, 0x73, 0x02, 0x0d, 0x80, 0xaa, 0x00,
-  0x00, 0x01, 0x00, 0xd6, 0x00, 0x00, 0x02, 0xea, 0x05, 0x9b, 0x00, 0x07,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x23, 0x35, 0x21, 0x15, 0x23, 0x02, 0x19,
-  0x72, 0xd1, 0x02, 0x13, 0xd0, 0x05, 0x1c, 0x7f, 0x7f, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x92, 0x05, 0xec, 0x00, 0x03,
-  0x00, 0x0a, 0x00, 0x00, 0x33, 0x35, 0x21, 0x15, 0x01, 0x33, 0x09, 0x01,
-  0x33, 0x01, 0x23, 0xb4, 0x03, 0xdd, 0xfc, 0x5c, 0xb0, 0x01, 0x06, 0x01,
-  0x05, 0xb0, 0xfe, 0xbb, 0xe1, 0xaa, 0xaa, 0x05, 0xec, 0xfc, 0x54, 0x03,
-  0xac, 0xfb, 0x5e, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x92,
-  0x05, 0xec, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
-  0x13, 0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0xb4, 0x03, 0xdd, 0xfc, 0x23,
-  0x39, 0x01, 0x45, 0xe1, 0x01, 0x45, 0xb0, 0xfe, 0xfb, 0xfe, 0xfa, 0x05,
-  0xec, 0xaa, 0xfa, 0xbe, 0x04, 0xa2, 0xfb, 0x5e, 0x03, 0xac, 0xfc, 0x54,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x92, 0x05, 0xec, 0x00, 0x03,
-  0x00, 0x0a, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x17, 0x33, 0x09, 0x01,
-  0x33, 0x01, 0x23, 0xb4, 0x03, 0xdd, 0xfc, 0x23, 0x39, 0xb0, 0x01, 0x06,
-  0x01, 0x05, 0xb0, 0xfe, 0xbb, 0xe1, 0x05, 0xec, 0xaa, 0xa0, 0xfc, 0x54,
-  0x03, 0xac, 0xfb, 0x5e, 0x00, 0x02, 0x00, 0xfe, 0x00, 0x00, 0x05, 0x0a,
-  0x04, 0x7e, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00, 0x29, 0x01, 0x11, 0x33,
-  0x11, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x17, 0x33, 0x01, 0x11, 0x21,
-  0x26, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x05, 0x0a, 0xfb, 0xf5, 0x99, 0x51,
-  0x4d, 0x95, 0xd6, 0x3f, 0x21, 0x10, 0xf9, 0xfc, 0x8e, 0x02, 0x0b, 0x0e,
-  0x18, 0x37, 0xba, 0x80, 0x39, 0x04, 0x7e, 0xfe, 0xeb, 0x12, 0x25, 0x46,
-  0xee, 0xa4, 0x56, 0x5a, 0x02, 0x44, 0xfd, 0xbc, 0x41, 0x3f, 0x8f, 0xce,
-  0x3d, 0x1b, 0x00, 0x00, 0x00, 0x02, 0x00, 0xfe, 0x00, 0x00, 0x05, 0x0a,
-  0x04, 0x7e, 0x00, 0x02, 0x00, 0x07, 0x00, 0x00, 0x09, 0x01, 0x21, 0x05,
-  0x35, 0x01, 0x33, 0x11, 0x04, 0x71, 0xfd, 0x27, 0x02, 0xd9, 0xfc, 0x8e,
-  0x03, 0x72, 0x99, 0x03, 0xd4, 0xfc, 0xd6, 0xaa, 0xaa, 0x03, 0xd4, 0xfb,
-  0x82, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0xfe, 0x77, 0x05, 0xee,
-  0x05, 0xc1, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23,
-  0x01, 0x03, 0x58, 0x02, 0x95, 0xb6, 0xfd, 0xbd, 0xfd, 0xbd, 0xb6, 0x02,
-  0x93, 0x05, 0xc1, 0xf8, 0xb6, 0x06, 0x77, 0xf9, 0x89, 0x07, 0x4a, 0x00,
-  0x00, 0x01, 0xff, 0xfa, 0xfe, 0x77, 0x05, 0xee, 0x05, 0xc1, 0x00, 0x06,
-  0x00, 0x00, 0x09, 0x01, 0x33, 0x09, 0x01, 0x33, 0x01, 0x02, 0x90, 0xfd,
-  0x6b, 0xb6, 0x02, 0x43, 0x02, 0x43, 0xb6, 0xfd, 0x6d, 0xfe, 0x77, 0x07,
-  0x4a, 0xf9, 0x89, 0x06, 0x77, 0xf8, 0xb6, 0x00, 0x00, 0x01, 0x00, 0x7e,
-  0xfe, 0x77, 0x05, 0x6a, 0x05, 0xc1, 0x00, 0x10, 0x00, 0x00, 0x01, 0x22,
-  0x04, 0x15, 0x11, 0x23, 0x11, 0x10, 0x00, 0x20, 0x00, 0x19, 0x01, 0x23,
-  0x11, 0x34, 0x24, 0x02, 0xf4, 0xc5, 0xfe, 0xea, 0x9b, 0x01, 0x90, 0x01,
-  0xcc, 0x01, 0x90, 0x9b, 0xfe, 0xec, 0x05, 0x1d, 0xe3, 0xfc, 0xfb, 0x39,
-  0x04, 0xe0, 0x01, 0x42, 0x01, 0x28, 0xfe, 0xd8, 0xfe, 0xbe, 0xfb, 0x20,
-  0x04, 0xc7, 0xfa, 0xe5, 0x00, 0x01, 0x00, 0x7e, 0xfe, 0x77, 0x05, 0x6a,
-  0x05, 0xc1, 0x00, 0x10, 0x00, 0x00, 0x05, 0x32, 0x24, 0x35, 0x11, 0x33,
-  0x11, 0x10, 0x00, 0x20, 0x00, 0x19, 0x01, 0x33, 0x11, 0x14, 0x04, 0x02,
-  0xf4, 0xc5, 0x01, 0x16, 0x9b, 0xfe, 0x70, 0xfe, 0x34, 0xfe, 0x70, 0x9b,
-  0x01, 0x14, 0xe5, 0xe3, 0xfc, 0x04, 0xc7, 0xfb, 0x20, 0xfe, 0xbe, 0xfe,
-  0xd8, 0x01, 0x28, 0x01, 0x42, 0x04, 0xe0, 0xfb, 0x39, 0xfa, 0xe5, 0x00,
-  0xff, 0xff, 0x00, 0x05, 0xfe, 0x23, 0x03, 0x8a, 0x06, 0x75, 0x12, 0x06,
-  0x0a, 0xf3, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc5, 0x02, 0x48, 0x01, 0x83,
-  0x03, 0x46, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0xc5, 0xbe,
-  0xbe, 0x03, 0x46, 0xfe, 0x00, 0x01, 0x00, 0xe0, 0x01, 0x31, 0x03, 0xa2,
-  0x04, 0x19, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x07,
-  0x13, 0x27, 0x07, 0x13, 0xe0, 0x01, 0x0d, 0x54, 0x55, 0x01, 0x0c, 0xda,
-  0x54, 0xdb, 0xdb, 0x54, 0x02, 0xfd, 0x01, 0x1c, 0xfe, 0xe4, 0xb0, 0xfe,
-  0xe4, 0xb0, 0xb0, 0x01, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0x00, 0x1e, 0x05, 0x46, 0x04, 0xe7, 0x00, 0x03, 0x00, 0x07, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x03, 0x21,
-  0x35, 0x21, 0x01, 0x37, 0x09, 0x01, 0x17, 0x01, 0x21, 0x15, 0x21, 0x01,
-  0x07, 0x09, 0x01, 0x27, 0x02, 0x96, 0xdd, 0xdd, 0xdd, 0xdd, 0x4a, 0xfe,
-  0x77, 0x01, 0x89, 0xfe, 0xb0, 0x6c, 0x01, 0x9c, 0x01, 0x9c, 0x6c, 0xfe,
-  0xb1, 0x01, 0x88, 0xfe, 0x78, 0x01, 0x4f, 0x6c, 0xfe, 0x64, 0xfe, 0x64,
-  0x6c, 0x01, 0x13, 0xf5, 0x04, 0xc9, 0xf6, 0xfe, 0x3c, 0xaa, 0x01, 0x75,
-  0x78, 0xfe, 0x36, 0x01, 0xca, 0x78, 0xfe, 0x8b, 0xaa, 0xfe, 0x8b, 0x78,
-  0x01, 0xca, 0xfe, 0x36, 0x78, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x05, 0x00, 0x08, 0x00, 0x0b,
-  0x00, 0x00, 0x17, 0x11, 0x09, 0x01, 0x11, 0x01, 0x27, 0x01, 0x11, 0x09,
-  0x01, 0x11, 0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0x8c, 0xfe, 0x4e,
-  0x02, 0xc9, 0x01, 0xb2, 0x3e, 0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50, 0xfa,
-  0x80, 0x02, 0x4e, 0x71, 0x01, 0x5e, 0xfd, 0x44, 0x01, 0x5e, 0xfe, 0xa2,
-  0x02, 0xc6, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70,
-  0x05, 0x42, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x15, 0x09, 0x01,
-  0x11, 0x09, 0x01, 0x15, 0x01, 0x21, 0x01, 0x11, 0x06, 0x70, 0xfd, 0x2a,
-  0xfd, 0x29, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0xb5, 0xfe, 0xe9, 0xfe, 0x4e,
-  0xa2, 0xe0, 0x02, 0x4e, 0xfd, 0xb2, 0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50,
-  0xdd, 0xfe, 0x1c, 0x01, 0x5e, 0xfd, 0x44, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x00,
-  0x13, 0x35, 0x09, 0x01, 0x11, 0x09, 0x01, 0x35, 0x01, 0x21, 0x01, 0x11,
-  0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0xfd, 0x29, 0x02, 0x4b, 0x01,
-  0x17, 0x01, 0xb2, 0x04, 0x62, 0xe0, 0xfd, 0xb2, 0x02, 0x4e, 0xfa, 0x80,
-  0x02, 0x50, 0xfd, 0xb0, 0xdd, 0x01, 0xe4, 0xfe, 0xa2, 0x02, 0xbc, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x07,
-  0x00, 0x00, 0x17, 0x35, 0x09, 0x01, 0x35, 0x01, 0x15, 0x01, 0xc3, 0x02,
-  0x4b, 0xfd, 0xb5, 0x05, 0xad, 0xfd, 0x2a, 0x3e, 0xe0, 0x01, 0xe1, 0x01,
-  0xe2, 0xdd, 0xfb, 0x5d, 0xdd, 0x02, 0x50, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x07, 0x00, 0x00, 0x05, 0x09,
-  0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x06, 0x70, 0xfd, 0x2a, 0xfd, 0x29,
-  0x05, 0xad, 0xfd, 0xb5, 0x02, 0x4b, 0x3e, 0x02, 0x50, 0xfd, 0xb0, 0xdd,
-  0x04, 0xa3, 0xdd, 0xfe, 0x1e, 0xfe, 0x1f, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x01, 0x60, 0x05, 0x46, 0x03, 0xf4, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x00,
-  0x13, 0x1e, 0x01, 0x33, 0x32, 0x3f, 0x02, 0x36, 0x33, 0x32, 0x16, 0x17,
-  0x15, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x01, 0x15, 0x21, 0x35, 0xc3, 0x5d, 0x98, 0x4e, 0x54, 0x8c,
-  0x13, 0x0e, 0x84, 0x63, 0x58, 0xa1, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b,
-  0x0e, 0x05, 0x0f, 0x84, 0x63, 0x57, 0xa1, 0x5f, 0x04, 0x82, 0xfb, 0x7e,
-  0x03, 0xf4, 0x55, 0x4b, 0x3d, 0x09, 0x06, 0x3b, 0x45, 0x4e, 0xb2, 0x53,
-  0x4c, 0x3d, 0x06, 0x02, 0x07, 0x3b, 0x45, 0x4f, 0xfe, 0xc8, 0xaa, 0xaa,
-  0x00, 0x01, 0x00, 0x59, 0x00, 0x00, 0x04, 0xed, 0x04, 0xa2, 0x00, 0x0a,
-  0x00, 0x00, 0x13, 0x33, 0x00, 0x13, 0x12, 0x01, 0x33, 0x00, 0x03, 0x23,
-  0x02, 0x59, 0xc2, 0x01, 0x4f, 0x39, 0x42, 0x01, 0x46, 0xc2, 0xfe, 0x65,
-  0x5b, 0xa8, 0x5b, 0x04, 0xa2, 0xfe, 0x90, 0xfe, 0x25, 0x01, 0xda, 0x01,
-  0x71, 0xfe, 0x81, 0xfc, 0xdd, 0x03, 0x23, 0x00, 0x00, 0x01, 0x00, 0x59,
-  0x00, 0x00, 0x04, 0xed, 0x04, 0xa2, 0x00, 0x0a, 0x00, 0x00, 0x33, 0x00,
-  0x13, 0x33, 0x12, 0x01, 0x23, 0x00, 0x03, 0x02, 0x01, 0x59, 0x01, 0x9b,
-  0x5b, 0xa8, 0x5b, 0x01, 0x9b, 0xc2, 0xfe, 0xba, 0x42, 0x39, 0xfe, 0xb1,
-  0x01, 0x7f, 0x03, 0x23, 0xfc, 0xdd, 0xfe, 0x81, 0x01, 0x71, 0x01, 0xda,
-  0xfe, 0x25, 0xfe, 0x90, 0x00, 0x02, 0x00, 0xab, 0xff, 0xfa, 0x05, 0x46,
-  0x05, 0x0a, 0x00, 0x13, 0x00, 0x29, 0x00, 0x00, 0x01, 0x21, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x35,
-  0x34, 0x36, 0x33, 0x21, 0x11, 0x21, 0x22, 0x27, 0x26, 0x11, 0x10, 0x37,
-  0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x21, 0x05, 0x45, 0xfd, 0xad, 0x34, 0x24, 0x24, 0x48, 0x34, 0x02,
-  0x53, 0xfd, 0xac, 0x73, 0x51, 0x50, 0xa0, 0x74, 0x02, 0x54, 0xfd, 0xad,
-  0xf4, 0xa9, 0xaa, 0xaa, 0xa7, 0xf4, 0x02, 0x55, 0xfd, 0xac, 0xb4, 0x7c,
-  0x7d, 0x7d, 0x7c, 0xb5, 0x02, 0x53, 0x03, 0x0c, 0x28, 0x29, 0x39, 0x3a,
-  0x50, 0xaa, 0x5a, 0x58, 0x82, 0x80, 0xb4, 0xfc, 0x44, 0xbd, 0xbe, 0x01,
-  0x0d, 0x01, 0x0c, 0xbf, 0xbd, 0xaa, 0x8b, 0x8d, 0xc6, 0xc8, 0x8b, 0x8b,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0xfa, 0x05, 0x5e, 0x05, 0x0a, 0x00, 0x13,
-  0x00, 0x29, 0x00, 0x00, 0x13, 0x35, 0x21, 0x32, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x21, 0x35, 0x21, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
-  0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x21,
-  0x35, 0x21, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0xc3, 0x02,
-  0x54, 0x74, 0xa0, 0x50, 0x51, 0x73, 0xfd, 0xac, 0x02, 0x53, 0x34, 0x48,
-  0x24, 0x24, 0x34, 0xfd, 0xad, 0x02, 0x53, 0xb5, 0x7c, 0x7d, 0x7d, 0x7c,
-  0xb4, 0xfd, 0xac, 0x02, 0x55, 0xf4, 0xa7, 0xaa, 0xaa, 0xa9, 0xf4, 0x03,
-  0x0c, 0xaa, 0xb4, 0x80, 0x82, 0x58, 0x5a, 0xaa, 0x50, 0x3a, 0x39, 0x29,
-  0x28, 0xfc, 0xee, 0xaa, 0x8b, 0x8b, 0xc8, 0xc6, 0x8d, 0x8b, 0xaa, 0xbd,
-  0xbf, 0xfe, 0xf4, 0xfe, 0xf3, 0xbe, 0xbd, 0x00, 0x00, 0x02, 0x00, 0xbd,
-  0x00, 0x00, 0x05, 0x4c, 0x05, 0x4e, 0x00, 0x11, 0x00, 0x24, 0x00, 0x00,
-  0x21, 0x11, 0x34, 0x26, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x16, 0x15, 0x11, 0x21, 0x11, 0x10, 0x00, 0x20, 0x17,
-  0x16, 0x19, 0x01, 0x23, 0x11, 0x34, 0x27, 0x26, 0x20, 0x07, 0x06, 0x15,
-  0x11, 0x03, 0x80, 0x48, 0x68, 0x48, 0x99, 0x51, 0x4f, 0x75, 0x73, 0xa2,
-  0xfc, 0xa4, 0x01, 0x56, 0x01, 0xe2, 0xad, 0xa9, 0x99, 0x7c, 0x7e, 0xfe,
-  0x98, 0x7c, 0x7e, 0x02, 0xc6, 0x3a, 0x50, 0x50, 0x3a, 0xfd, 0x3a, 0x02,
-  0xc8, 0x80, 0x5a, 0x58, 0xb2, 0x80, 0xfd, 0x38, 0x02, 0xc6, 0x01, 0x10,
-  0x01, 0x78, 0xbc, 0xba, 0xfe, 0xf0, 0xfd, 0x38, 0x02, 0xc8, 0xc8, 0x8a,
-  0x8a, 0x8a, 0x8a, 0xca, 0xfd, 0x3a, 0x00, 0x00, 0x00, 0x02, 0x00, 0xbd,
-  0xff, 0xe3, 0x05, 0x4c, 0x05, 0x31, 0x00, 0x11, 0x00, 0x24, 0x00, 0x00,
-  0x01, 0x11, 0x14, 0x16, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x21, 0x11, 0x10, 0x00, 0x20, 0x27,
-  0x26, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35,
-  0x11, 0x02, 0x88, 0x48, 0x68, 0x48, 0x99, 0x51, 0x4f, 0x75, 0x73, 0xa2,
-  0x03, 0x5c, 0xfe, 0xaa, 0xfe, 0x1e, 0xad, 0xa9, 0x99, 0x7c, 0x7e, 0x01,
-  0x68, 0x7c, 0x7e, 0x05, 0x31, 0xfd, 0x3a, 0x3a, 0x50, 0x50, 0x3a, 0x02,
-  0xc6, 0xfd, 0x38, 0x80, 0x5a, 0x58, 0xb2, 0x80, 0x02, 0xc8, 0xfd, 0x3a,
-  0xfe, 0xf0, 0xfe, 0x88, 0xbc, 0xba, 0x01, 0x10, 0x02, 0xc8, 0xfd, 0x38,
-  0xc8, 0x8a, 0x8a, 0x8a, 0x8a, 0xca, 0x02, 0xc6, 0x00, 0x01, 0x01, 0x56,
-  0x00, 0x00, 0x04, 0xb3, 0x05, 0xd5, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x34,
-  0x27, 0x26, 0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x15, 0x11, 0x23,
-  0x11, 0x34, 0x37, 0x36, 0x37, 0x11, 0x33, 0x11, 0x16, 0x17, 0x16, 0x15,
-  0x11, 0x23, 0x04, 0x19, 0x51, 0x34, 0x43, 0x99, 0x44, 0x34, 0x51, 0x99,
-  0x7e, 0x61, 0x83, 0x99, 0x84, 0x61, 0x7c, 0x99, 0x02, 0x9f, 0x80, 0x59,
-  0x3a, 0x14, 0xfc, 0x3a, 0x03, 0xc6, 0x13, 0x3a, 0x5a, 0x80, 0xfd, 0x61,
-  0x02, 0x9d, 0xc8, 0x8c, 0x6c, 0x17, 0x01, 0x61, 0xfe, 0x9f, 0x17, 0x6c,
-  0x8a, 0xc8, 0xfd, 0x61, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x34, 0x05, 0x46,
-  0x05, 0xd5, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x00, 0x05, 0x23, 0x11, 0x23,
-  0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x33,
-  0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
-  0x27, 0x35, 0x23, 0x15, 0x03, 0xea, 0x99, 0x99, 0x99, 0xfe, 0xa4, 0x01,
-  0x5c, 0xfe, 0xa4, 0x01, 0x5c, 0x99, 0x99, 0x99, 0x01, 0x5b, 0xfe, 0xa5,
-  0x01, 0x5b, 0xfe, 0xa5, 0x99, 0x99, 0xcc, 0x02, 0x2c, 0xfd, 0xd4, 0x02,
-  0x2c, 0xaa, 0xf0, 0xa8, 0x02, 0x33, 0xfd, 0xcd, 0x02, 0x33, 0xfd, 0xcd,
-  0xa8, 0xf0, 0xaa, 0xaa, 0xf0, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x5e, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x23, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x04, 0x2d,
-  0xbe, 0xbe, 0x01, 0x18, 0xfc, 0x5f, 0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82,
-  0x03, 0x00, 0xfe, 0x01, 0xee, 0xfe, 0x91, 0xfe, 0x93, 0xb6, 0x01, 0xd1,
-  0xa6, 0x01, 0xd1, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x5e, 0x05, 0x46,
-  0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23,
-  0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x01, 0x1d, 0xbe, 0xbe, 0x5a,
-  0x04, 0x82, 0xfb, 0x7e, 0x03, 0x9f, 0x03, 0x00, 0xfe, 0x01, 0xee, 0xb6,
-  0xfe, 0x2f, 0xa6, 0xfe, 0x2f, 0xb6, 0x01, 0x6d, 0x00, 0x03, 0x00, 0x85,
-  0x00, 0x2e, 0x09, 0xb8, 0x04, 0xdf, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x14,
-  0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x09, 0x01, 0x15,
-  0x01, 0x35, 0x01, 0x05, 0x09, 0x01, 0x15, 0x01, 0x35, 0x01, 0x09, 0xb8,
-  0xfd, 0x18, 0x02, 0xe8, 0xfc, 0x35, 0x03, 0xcb, 0xfd, 0x4c, 0xfd, 0x19,
-  0x02, 0xe7, 0xfc, 0x36, 0x03, 0xca, 0xfd, 0x4b, 0xfd, 0x19, 0x02, 0xe7,
-  0xfc, 0x36, 0x03, 0xca, 0x04, 0x11, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02,
-  0x08, 0x9f, 0x02, 0x0a, 0xce, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08,
-  0x9f, 0x02, 0x0a, 0xce, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08, 0x9f,
-  0x02, 0x0a, 0x00, 0x00, 0x00, 0x03, 0x00, 0x85, 0x00, 0x2e, 0x09, 0xb8,
-  0x04, 0xdf, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x00, 0x13, 0x35,
-  0x01, 0x15, 0x01, 0x35, 0x01, 0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01,
-  0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x85, 0x03, 0xca, 0xfc, 0x36,
-  0x02, 0xe8, 0x33, 0x03, 0xca, 0xfc, 0x36, 0x02, 0xe8, 0x35, 0x03, 0xcb,
-  0xfc, 0x35, 0x02, 0xe8, 0x04, 0x11, 0xce, 0xfd, 0xf6, 0x9f, 0xfd, 0xf8,
-  0xc5, 0x01, 0x8e, 0x01, 0x90, 0xce, 0xfd, 0xf6, 0x9f, 0xfd, 0xf8, 0xc5,
-  0x01, 0x8e, 0x01, 0x90, 0xce, 0xfd, 0xf6, 0x9f, 0xfd, 0xf8, 0xc5, 0x01,
-  0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0x2e, 0x05, 0x46,
-  0x06, 0xd4, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x00, 0x13, 0x09,
-  0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0x11, 0x09, 0x01,
-  0x15, 0x01, 0x35, 0x01, 0xc3, 0x03, 0x61, 0xfc, 0x9f, 0x04, 0x82, 0xfb,
-  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xa0, 0x03, 0x60, 0xfb,
-  0x7e, 0x04, 0x82, 0xfe, 0xde, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90,
-  0xaa, 0xfe, 0x91, 0x03, 0xfe, 0xaa, 0x03, 0x4e, 0xfe, 0xeb, 0xfe, 0xee,
-  0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0xfe, 0x2e, 0x05, 0x46, 0x06, 0xd4, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11,
-  0x00, 0x00, 0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x35, 0x21,
-  0x15, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45, 0xfb, 0x7e,
-  0x04, 0x82, 0xfc, 0x9f, 0xfe, 0xdf, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
-  0xfb, 0x7e, 0x03, 0x60, 0xfe, 0xde, 0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70,
-  0xb2, 0xfe, 0xee, 0x02, 0x39, 0xaa, 0xaa, 0x03, 0xf8, 0xb0, 0xfe, 0x91,
-  0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0x00, 0x00, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x00,
-  0x25, 0x15, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x35, 0x21, 0x15, 0x05,
-  0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xa0, 0xfe, 0xde, 0x04, 0x82, 0xb0,
-  0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x02, 0x39, 0xaa,
-  0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
-  0x04, 0xa8, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x00, 0x37, 0x09, 0x01, 0x35,
-  0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0xc3, 0x03, 0x61, 0xfc, 0x9f,
-  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xb0, 0x01,
-  0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe, 0x91, 0x03, 0xfe, 0xaa,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46, 0x05, 0x57, 0x00, 0x05,
-  0x00, 0x10, 0x00, 0x00, 0x01, 0x00, 0x05, 0x35, 0x24, 0x01, 0x11, 0x15,
-  0x00, 0x25, 0x35, 0x24, 0x01, 0x15, 0x00, 0x05, 0x04, 0x05, 0x45, 0xfe,
-  0x7f, 0xfc, 0xff, 0x03, 0x12, 0x01, 0x70, 0xfe, 0xa7, 0xfc, 0xd7, 0x03,
-  0x29, 0x01, 0x59, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x04, 0x80, 0xfe,
-  0x5f, 0x85, 0xae, 0x91, 0x01, 0xbe, 0xfa, 0xa9, 0xd7, 0x01, 0x80, 0x7c,
-  0xa6, 0x84, 0x01, 0x78, 0xd7, 0xfe, 0xe5, 0x5d, 0x5d, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46, 0x05, 0x57, 0x00, 0x05,
-  0x00, 0x10, 0x00, 0x00, 0x13, 0x35, 0x00, 0x05, 0x15, 0x24, 0x01, 0x00,
-  0x25, 0x24, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0xc3, 0x01, 0x70,
-  0x03, 0x12, 0xfc, 0xff, 0xfe, 0x7f, 0x01, 0x59, 0x01, 0xac, 0xfe, 0x54,
-  0xfe, 0xa7, 0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7, 0x04, 0x80,
-  0xd7, 0xfe, 0x42, 0x91, 0xae, 0x85, 0xfd, 0x21, 0x01, 0x1b, 0x5d, 0x5d,
-  0x01, 0x1b, 0xd7, 0xfe, 0x88, 0x84, 0xa6, 0x7c, 0xfe, 0x80, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x93, 0x05, 0x46, 0x06, 0x1d, 0x00, 0x21,
-  0x00, 0x26, 0x00, 0x00, 0x21, 0x15, 0x02, 0x25, 0x01, 0x27, 0x13, 0x26,
-  0x27, 0x35, 0x16, 0x17, 0x37, 0x26, 0x25, 0x35, 0x24, 0x25, 0x13, 0x17,
-  0x03, 0x36, 0x37, 0x15, 0x06, 0x0f, 0x01, 0x04, 0x17, 0x15, 0x26, 0x25,
-  0x07, 0x04, 0x01, 0x37, 0x06, 0x07, 0x16, 0x05, 0x45, 0xf2, 0xfe, 0x59,
-  0xff, 0x00, 0x76, 0xf4, 0xa7, 0xc0, 0xe6, 0xc4, 0x39, 0xd8, 0xfe, 0xf5,
-  0x01, 0x8a, 0x01, 0x1b, 0xde, 0x75, 0x95, 0xaa, 0x75, 0xb4, 0xcc, 0x5e,
-  0x01, 0x01, 0xdd, 0xc4, 0xfe, 0xa6, 0x39, 0x01, 0x70, 0xfe, 0x88, 0x2b,
-  0x66, 0x6b, 0x55, 0xd7, 0x01, 0x25, 0xa4, 0xfd, 0xa1, 0x4b, 0x02, 0x41,
-  0x36, 0x23, 0xae, 0x28, 0x41, 0x87, 0x46, 0x2b, 0xa6, 0x3c, 0x7a, 0x02,
-  0x0c, 0x4b, 0xfe, 0x9f, 0x64, 0x82, 0xd7, 0x94, 0x60, 0xdf, 0x67, 0xb6,
-  0xd7, 0xd6, 0x87, 0x88, 0x94, 0x01, 0xe2, 0x66, 0x23, 0x17, 0x12, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x93, 0x05, 0x46, 0x06, 0x1d, 0x00, 0x21,
-  0x00, 0x26, 0x00, 0x00, 0x13, 0x35, 0x16, 0x05, 0x13, 0x17, 0x03, 0x16,
-  0x17, 0x15, 0x04, 0x0f, 0x01, 0x24, 0x25, 0x15, 0x04, 0x05, 0x03, 0x27,
-  0x13, 0x06, 0x07, 0x35, 0x36, 0x3f, 0x01, 0x04, 0x07, 0x35, 0x36, 0x25,
-  0x37, 0x24, 0x05, 0x07, 0x36, 0x37, 0x26, 0xc3, 0xe2, 0x01, 0xa8, 0xf9,
-  0x75, 0xea, 0xac, 0xc8, 0xfe, 0xd9, 0xea, 0x50, 0x01, 0x0b, 0x01, 0x56,
-  0xfe, 0x65, 0xfe, 0xd8, 0xd6, 0x76, 0x81, 0x8b, 0x69, 0x96, 0xce, 0x5a,
-  0xfe, 0xea, 0xa8, 0xf7, 0x01, 0x22, 0x32, 0xfe, 0xc1, 0x01, 0xc4, 0x0c,
-  0x21, 0x20, 0x1b, 0x04, 0x80, 0xd7, 0xfb, 0x8c, 0x02, 0x4d, 0x4b, 0xfd,
-  0xd6, 0x2e, 0x1f, 0xa6, 0x30, 0x51, 0xbd, 0x74, 0x3b, 0xae, 0x4c, 0x9e,
-  0xfe, 0x05, 0x4b, 0x01, 0x31, 0x67, 0x7f, 0xd7, 0xa2, 0x76, 0xd5, 0x7d,
-  0xb7, 0xd7, 0xcb, 0x69, 0x77, 0x69, 0x90, 0x1b, 0x08, 0x07, 0x06, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xdf, 0x05, 0x46, 0x06, 0x23, 0x00, 0x17,
-  0x00, 0x1b, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x03, 0x21,
-  0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27, 0x37, 0x21, 0x35, 0x21,
-  0x37, 0x21, 0x11, 0x21, 0x03, 0x13, 0x21, 0x11, 0x03, 0xdf, 0x90, 0x4f,
-  0x01, 0x25, 0xfe, 0xa4, 0xc7, 0x02, 0x23, 0xfd, 0xa6, 0x2a, 0x02, 0x84,
-  0xfd, 0x46, 0x62, 0x90, 0x4f, 0xfe, 0xdb, 0x01, 0x5c, 0x29, 0xfe, 0x7b,
-  0x02, 0xba, 0xfe, 0xc7, 0xfe, 0x16, 0x06, 0x23, 0x3a, 0xf5, 0xaa, 0xfd,
-  0x98, 0xaa, 0x80, 0xaa, 0xfe, 0xd1, 0x3a, 0xf5, 0xaa, 0x80, 0x03, 0xbc,
-  0xfc, 0xee, 0x02, 0x68, 0xfd, 0x98, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xfe, 0xdf, 0x05, 0x46, 0x06, 0x23, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x17, 0x07, 0x21, 0x11, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27,
-  0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x13, 0x21, 0x35, 0x21,
-  0x17, 0x03, 0x21, 0x11, 0x03, 0xdf, 0x90, 0x4f, 0x01, 0x25, 0xfd, 0xa6,
-  0x2a, 0x02, 0x84, 0xfd, 0x46, 0x62, 0x90, 0x4f, 0xfe, 0xdb, 0x01, 0x5c,
-  0x29, 0xfe, 0x7b, 0x01, 0xbc, 0xc7, 0xfd, 0x7d, 0x02, 0xba, 0x6c, 0xc7,
-  0x01, 0x8a, 0x06, 0x23, 0x3a, 0xf5, 0xfc, 0x44, 0x80, 0xaa, 0xfe, 0xd1,
-  0x3a, 0xf5, 0xaa, 0x80, 0xaa, 0x02, 0x68, 0xaa, 0xaa, 0xfd, 0x98, 0x02,
-  0x68, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3, 0xff, 0x3f, 0x05, 0x46,
-  0x04, 0xf4, 0x00, 0x14, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35,
-  0x21, 0x37, 0x21, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0xe9, 0xfe, 0x80,
-  0x18, 0x45, 0x01, 0xad, 0xfd, 0xe7, 0x84, 0x7d, 0x46, 0xfe, 0x52, 0x02,
-  0x1a, 0x51, 0xfd, 0x95, 0x04, 0xf4, 0xaa, 0xfd, 0x98, 0xaa, 0x13, 0x6d,
-  0xaa, 0xcf, 0x62, 0x6d, 0xaa, 0x80, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0xff, 0x3f, 0x05, 0x46, 0x04, 0xf4, 0x00, 0x14, 0x00, 0x00, 0x25, 0x15,
-  0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x21, 0x17, 0x07, 0x05, 0x45, 0xfd, 0xe7, 0x84,
-  0x7d, 0x46, 0xfe, 0x52, 0x02, 0x1a, 0x51, 0xfd, 0x95, 0x03, 0xe9, 0xfc,
-  0x17, 0x04, 0x82, 0xfe, 0x80, 0x18, 0x45, 0xb8, 0xaa, 0xcf, 0x62, 0x6d,
-  0xaa, 0x80, 0xaa, 0x02, 0x68, 0xaa, 0xfc, 0x44, 0x13, 0x6d, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xe5, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x1b,
-  0x00, 0x22, 0x00, 0x00, 0x25, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
-  0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37,
-  0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27, 0x09, 0x02, 0x15, 0x01,
-  0x35, 0x01, 0x02, 0x9c, 0x59, 0x3d, 0x4f, 0x9b, 0x58, 0x5e, 0xa1, 0x58,
-  0x54, 0x6c, 0x63, 0x8b, 0x5e, 0x5b, 0x3d, 0x4e, 0x98, 0x5d, 0x5f, 0xa1,
-  0x57, 0x57, 0x6d, 0x61, 0x8c, 0x03, 0x07, 0xfc, 0xa0, 0x03, 0x60, 0xfb,
-  0x7e, 0x04, 0x82, 0x11, 0x1f, 0x4c, 0x54, 0xb4, 0x4e, 0x44, 0x2a, 0xf3,
-  0x46, 0xe9, 0x20, 0x4a, 0x56, 0xb4, 0x4e, 0x44, 0x2b, 0xf0, 0x46, 0x04,
-  0xcd, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xe5, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x1b,
-  0x00, 0x22, 0x00, 0x00, 0x25, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
-  0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37,
-  0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27, 0x01, 0x35, 0x01, 0x15,
-  0x01, 0x35, 0x01, 0x02, 0x9c, 0x59, 0x3d, 0x4f, 0x9b, 0x58, 0x5e, 0xa1,
-  0x58, 0x54, 0x6c, 0x63, 0x8b, 0x5e, 0x5b, 0x3d, 0x4e, 0x98, 0x5d, 0x5f,
-  0xa1, 0x57, 0x57, 0x6d, 0x61, 0x8c, 0xfe, 0x85, 0x04, 0x82, 0xfb, 0x7e,
-  0x03, 0x60, 0x11, 0x1f, 0x4c, 0x54, 0xb4, 0x4e, 0x44, 0x2a, 0xf3, 0x46,
-  0xe9, 0x20, 0x4a, 0x56, 0xb4, 0x4e, 0x44, 0x2b, 0xf0, 0x46, 0x04, 0xcd,
-  0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xa6, 0x05, 0x46, 0x05, 0x57, 0x00, 0x1b,
-  0x00, 0x26, 0x00, 0x00, 0x05, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
-  0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37,
-  0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27, 0x01, 0x00, 0x05, 0x04,
-  0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x02, 0x9c, 0x5a, 0x3c, 0x50,
-  0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x54, 0x6c, 0x63, 0x8c, 0x5f, 0x5b, 0x3e,
-  0x4d, 0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x56, 0x6d, 0x62, 0x8b, 0x03, 0x07,
-  0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe, 0xa7, 0xfc, 0xd7,
-  0x03, 0x29, 0x01, 0x59, 0x2e, 0x20, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x2b,
-  0xf3, 0x46, 0xe9, 0x20, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x2c, 0xf1, 0x46,
-  0x05, 0x94, 0xfe, 0xe5, 0x5d, 0x5d, 0xfe, 0xe5, 0xd7, 0x01, 0x78, 0x84,
-  0xa6, 0x7c, 0x01, 0x80, 0x00, 0x02, 0x00, 0xca, 0xfe, 0xa2, 0x05, 0x4d,
-  0x05, 0x57, 0x00, 0x1b, 0x00, 0x26, 0x00, 0x00, 0x05, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16,
-  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27,
-  0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0x02,
-  0xa3, 0x59, 0x3d, 0x4f, 0x9b, 0x59, 0x5f, 0xa1, 0x57, 0x54, 0x6d, 0x62,
-  0x8c, 0x5f, 0x5b, 0x3e, 0x4e, 0x98, 0x5c, 0x5e, 0xa1, 0x58, 0x56, 0x6d,
-  0x61, 0x8c, 0xfe, 0x85, 0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7,
-  0x01, 0x59, 0x01, 0xad, 0xfe, 0x53, 0x33, 0x20, 0x4c, 0x54, 0xb3, 0x4e,
-  0x45, 0x2b, 0xf4, 0x46, 0xea, 0x20, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x2c,
-  0xf0, 0x46, 0x05, 0x98, 0xd7, 0xfe, 0x80, 0x7c, 0xa6, 0x84, 0xfe, 0x88,
-  0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0xfe, 0xf6, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x12,
-  0x00, 0x00, 0x01, 0x17, 0x03, 0x37, 0x11, 0x25, 0x03, 0x27, 0x13, 0x25,
-  0x35, 0x01, 0x13, 0x11, 0x07, 0x03, 0x27, 0x13, 0x05, 0x04, 0x6a, 0x8e,
-  0x76, 0xc3, 0xfd, 0xf4, 0xc6, 0x8e, 0xc6, 0xfe, 0x18, 0x02, 0xf8, 0xf1,
-  0x7d, 0xbb, 0x8e, 0x82, 0xfe, 0x3c, 0x06, 0x0c, 0x40, 0xfe, 0xc1, 0x59,
-  0xfb, 0x38, 0xf0, 0xfd, 0xe8, 0x40, 0x02, 0x19, 0xe0, 0xa6, 0x01, 0x5c,
-  0xfc, 0xef, 0x02, 0xc4, 0x39, 0xfe, 0x04, 0x40, 0x01, 0x61, 0xce, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0xfe, 0xf6, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x12, 0x00, 0x00, 0x01, 0x27, 0x13, 0x07, 0x11, 0x05,
-  0x13, 0x17, 0x03, 0x05, 0x15, 0x01, 0x03, 0x11, 0x37, 0x13, 0x17, 0x03,
-  0x25, 0x01, 0x9f, 0x8e, 0x75, 0xc3, 0x02, 0x0d, 0xc5, 0x8e, 0xc6, 0x01,
-  0xe8, 0xfd, 0x09, 0xf2, 0x7d, 0xbc, 0x8e, 0x82, 0x01, 0xc3, 0xfe, 0xf6,
-  0x40, 0x01, 0x3f, 0x59, 0x04, 0xc8, 0xf0, 0x02, 0x18, 0x40, 0xfd, 0xe7,
-  0xe0, 0xa6, 0xfe, 0xa4, 0x03, 0x11, 0xfd, 0x3c, 0x39, 0x01, 0xfc, 0x40,
-  0xfe, 0x9f, 0xce, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0x7d, 0x05, 0x46,
-  0x06, 0x85, 0x00, 0x03, 0x00, 0x17, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x11,
-  0x07, 0x03, 0x01, 0x35, 0x21, 0x13, 0x25, 0x35, 0x01, 0x13, 0x17, 0x03,
-  0x37, 0x11, 0x25, 0x03, 0x21, 0x15, 0x21, 0x03, 0x27, 0x37, 0x01, 0x13,
-  0x05, 0x04, 0xac, 0x7f, 0xbb, 0xfd, 0x51, 0x01, 0x56, 0x90, 0xfe, 0x1a,
-  0x02, 0xf5, 0xae, 0x8e, 0x74, 0xc5, 0xfd, 0xf2, 0x78, 0x02, 0x86, 0xfd,
-  0x3b, 0x6a, 0x8e, 0x52, 0x01, 0x0a, 0x81, 0xfe, 0x3f, 0x01, 0x9e, 0x02,
-  0xc4, 0x3a, 0xfe, 0x05, 0xfd, 0x71, 0xaa, 0x01, 0x86, 0xdf, 0xa6, 0x01,
-  0x5b, 0x01, 0xd7, 0x40, 0xfe, 0xc5, 0x5a, 0xfb, 0x38, 0xf1, 0xfe, 0xbb,
-  0xaa, 0xfe, 0xdf, 0x40, 0xe1, 0x02, 0xd0, 0x01, 0x5f, 0xcd, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xbf, 0xfe, 0x7d, 0x05, 0x42, 0x06, 0x85, 0x00, 0x13,
-  0x00, 0x17, 0x00, 0x1a, 0x00, 0x00, 0x37, 0x11, 0x01, 0x13, 0x17, 0x03,
-  0x05, 0x15, 0x01, 0x03, 0x21, 0x15, 0x21, 0x03, 0x27, 0x37, 0x23, 0x35,
-  0x33, 0x37, 0x13, 0x25, 0x11, 0x37, 0x01, 0x03, 0x25, 0xc0, 0x02, 0x61,
-  0xd2, 0x8e, 0xd2, 0x01, 0x93, 0xfd, 0x80, 0x76, 0x02, 0xf6, 0xfc, 0xcb,
-  0x6b, 0x8e, 0x53, 0xa7, 0xe6, 0x54, 0xec, 0xfe, 0x73, 0xf4, 0x01, 0x27,
-  0x60, 0x01, 0x4c, 0x9c, 0x04, 0xc8, 0xfe, 0xe9, 0x02, 0x38, 0x40, 0xfd,
-  0xc7, 0xb9, 0xa6, 0xfe, 0xdb, 0xfe, 0xc0, 0xaa, 0xfe, 0xdf, 0x40, 0xe1,
-  0xaa, 0xe4, 0x02, 0x81, 0xb5, 0xfd, 0x3c, 0x70, 0x01, 0x5e, 0xfe, 0xfc,
-  0x98, 0x00, 0x00, 0x00, 0xff, 0xff, 0x03, 0x3a, 0xff, 0x42, 0x03, 0xf9,
-  0x05, 0xb8, 0x10, 0x27, 0x09, 0xa1, 0x02, 0x75, 0xfc, 0xfa, 0x10, 0x27,
-  0x09, 0xa1, 0x02, 0x75, 0x02, 0x72, 0x10, 0x07, 0x09, 0xa1, 0x02, 0x75,
-  0xff, 0xb6, 0x00, 0x00, 0xff, 0xff, 0x00, 0xd4, 0x01, 0xfe, 0x06, 0x5e,
-  0x02, 0xfc, 0x10, 0x26, 0x09, 0xa1, 0x0f, 0xb6, 0x10, 0x27, 0x09, 0xa1,
-  0x02, 0x75, 0xff, 0xb6, 0x10, 0x07, 0x09, 0xa1, 0x04, 0xdb, 0xff, 0xb6,
-  0xff, 0xff, 0x00, 0xd4, 0xff, 0x42, 0x06, 0x5e, 0x05, 0xb8, 0x10, 0x27,
-  0x09, 0xa1, 0x00, 0x0f, 0xfc, 0xfa, 0x10, 0x27, 0x09, 0xa1, 0x04, 0xdb,
-  0x02, 0x72, 0x10, 0x07, 0x09, 0xa1, 0x02, 0x75, 0xff, 0xb6, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xd4, 0xff, 0x42, 0x06, 0x5e, 0x05, 0xb8, 0x10, 0x27,
-  0x09, 0xa1, 0x04, 0xdb, 0xfc, 0xfa, 0x10, 0x27, 0x09, 0xa1, 0x00, 0x0f,
-  0x02, 0x72, 0x10, 0x07, 0x09, 0xa1, 0x02, 0x75, 0xff, 0xb6, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x4f, 0xff, 0xec, 0x06, 0xe4, 0x05, 0xae, 0x00, 0x21,
-  0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x24, 0x33, 0x21,
-  0x15, 0x21, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x27, 0x26,
-  0x01, 0xdf, 0xfe, 0x70, 0x01, 0x8e, 0x0d, 0x46, 0x54, 0x01, 0x41, 0xad,
-  0x02, 0x72, 0xfd, 0x8d, 0x85, 0x7c, 0x7c, 0x44, 0x3a, 0x07, 0x04, 0x75,
-  0xfb, 0x8d, 0x06, 0x39, 0x43, 0x7d, 0x7c, 0x85, 0x02, 0x73, 0xfd, 0x8e,
-  0xad, 0xfe, 0xbf, 0x54, 0x41, 0x02, 0x73, 0xa0, 0x94, 0x8f, 0xb0, 0xc8,
-  0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0, 0x4a, 0x78, 0x8b, 0x4e,
-  0x4c, 0x01, 0x9f, 0xc6, 0xb0, 0x85, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x16,
-  0x12, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x02, 0x10, 0x12, 0x24,
-  0x33, 0x21, 0x15, 0x21, 0x0e, 0x01, 0x02, 0x07, 0x21, 0x11, 0x33, 0x11,
-  0x23, 0x11, 0x01, 0x35, 0x06, 0x7b, 0xfa, 0x85, 0x02, 0x73, 0xfd, 0x8d,
-  0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02, 0x73, 0xfd, 0x8d,
-  0x85, 0xf9, 0x7d, 0x08, 0x03, 0xe6, 0x90, 0x90, 0x02, 0x73, 0x4a, 0xfe,
-  0xfd, 0x9a, 0x01, 0x9f, 0xc6, 0x01, 0x60, 0x01, 0x74, 0x01, 0x60, 0xc8,
-  0x9f, 0x01, 0x9c, 0xfe, 0xfe, 0x5d, 0x01, 0x10, 0xfd, 0x40, 0x01, 0x10,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x19,
-  0x00, 0x00, 0x25, 0x20, 0x24, 0x10, 0x24, 0x29, 0x01, 0x15, 0x21, 0x22,
-  0x07, 0x06, 0x07, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35, 0x21, 0x16, 0x17,
-  0x16, 0x33, 0x21, 0x15, 0x02, 0xda, 0xfe, 0xf6, 0xfe, 0xf3, 0x01, 0x0d,
-  0x01, 0x0a, 0x01, 0x8e, 0xfe, 0x72, 0xcf, 0x60, 0x47, 0x1a, 0x02, 0x9e,
-  0x80, 0x80, 0xfd, 0x62, 0x22, 0x3f, 0x66, 0xc9, 0x01, 0x8e, 0x9b, 0xf6,
-  0x01, 0xe0, 0xf6, 0x8e, 0x51, 0x3b, 0x84, 0xac, 0xfe, 0x1a, 0xac, 0x91,
-  0x30, 0x51, 0x8e, 0x00, 0xff, 0xff, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
-  0x07, 0x48, 0x10, 0x26, 0x08, 0xe4, 0x00, 0x00, 0x10, 0x07, 0x09, 0xa1,
-  0x01, 0xff, 0x04, 0x02, 0x00, 0x02, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
-  0x06, 0xd2, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x02, 0x35, 0x34, 0x12,
-  0x24, 0x33, 0x21, 0x15, 0x21, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21,
-  0x15, 0x11, 0x21, 0x35, 0x21, 0x01, 0x35, 0x06, 0x39, 0x43, 0x7d, 0x7c,
-  0x85, 0x02, 0x73, 0xfd, 0x8d, 0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40,
-  0xad, 0x02, 0x73, 0xfd, 0x8d, 0x85, 0x7c, 0x7d, 0x43, 0x3a, 0x08, 0x04,
-  0x76, 0xfb, 0x2e, 0x04, 0xd2, 0x02, 0x73, 0x4a, 0x78, 0x8b, 0x4e, 0x4c,
-  0x01, 0x9f, 0xc6, 0x01, 0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8, 0x9f, 0x01,
-  0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0, 0x03, 0xbf, 0xa0, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x9b, 0x04, 0x68, 0x05, 0x7d, 0x00, 0x16,
-  0x00, 0x1a, 0x00, 0x00, 0x25, 0x20, 0x24, 0x35, 0x34, 0x24, 0x29, 0x01,
-  0x15, 0x05, 0x06, 0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16, 0x17, 0x16,
-  0x33, 0x21, 0x15, 0x11, 0x21, 0x35, 0x21, 0x02, 0xda, 0xfe, 0xf6, 0xfe,
-  0xf3, 0x01, 0x0d, 0x01, 0x0a, 0x01, 0x8e, 0xfe, 0x72, 0xd1, 0x5e, 0x46,
-  0x1b, 0x03, 0x1e, 0xfc, 0xe2, 0x21, 0x40, 0x67, 0xc8, 0x01, 0x8e, 0xfc,
-  0x7e, 0x03, 0x82, 0x9b, 0xf6, 0xf0, 0xf0, 0xf6, 0x8e, 0x01, 0x01, 0x4f,
-  0x3a, 0x85, 0x8e, 0x91, 0x30, 0x51, 0x8e, 0x04, 0x56, 0x8c, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x9d, 0xfe, 0xda, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1c,
-  0x00, 0x20, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21,
-  0x15, 0x21, 0x22, 0x24, 0x02, 0x35, 0x34, 0x12, 0x24, 0x33, 0x21, 0x15,
-  0x21, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x15, 0x11, 0x21, 0x35,
-  0x21, 0x01, 0x35, 0x06, 0x39, 0x43, 0x7d, 0x7c, 0x85, 0x02, 0x73, 0xfd,
-  0x8d, 0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02, 0x73, 0xfd,
-  0x8d, 0x85, 0x7c, 0x7d, 0x43, 0x3a, 0x08, 0x04, 0x76, 0xfb, 0x2e, 0x04,
-  0xd2, 0x02, 0x73, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0x01,
-  0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8, 0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78,
-  0x5d, 0xa0, 0xfc, 0x67, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x21,
-  0x15, 0x21, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24,
-  0x02, 0x35, 0x34, 0x12, 0x24, 0x33, 0x21, 0x15, 0x21, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x01, 0x35, 0x04, 0x73, 0xfb, 0xbc,
-  0x10, 0x43, 0x7d, 0x7c, 0x85, 0x02, 0x73, 0xfd, 0x8d, 0xad, 0xfe, 0xc0,
-  0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02, 0x73, 0xfd, 0x8d, 0x85, 0x7c, 0x7d,
-  0x43, 0x0d, 0x0b, 0x04, 0x4c, 0xfb, 0x8d, 0x02, 0x73, 0xa0, 0x22, 0x8b,
-  0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0x01, 0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8,
-  0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x1b, 0x1a, 0xa0, 0x00, 0x01, 0x00, 0x4f,
-  0xff, 0xec, 0x06, 0xe4, 0x05, 0xae, 0x00, 0x21, 0x00, 0x00, 0x01, 0x21,
-  0x15, 0x21, 0x06, 0x07, 0x06, 0x04, 0x23, 0x21, 0x35, 0x21, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x27, 0x21, 0x35, 0x21, 0x32, 0x04, 0x17, 0x16, 0x05, 0x54, 0x01, 0x90,
-  0xfe, 0x72, 0x0d, 0x46, 0x54, 0xfe, 0xbf, 0xac, 0xfd, 0x8d, 0x02, 0x73,
-  0x85, 0x7c, 0x7c, 0x44, 0x3a, 0x07, 0xfb, 0x8b, 0x04, 0x74, 0x07, 0x39,
-  0x43, 0x7d, 0x7c, 0x85, 0xfd, 0x8d, 0x02, 0x73, 0xac, 0x01, 0x41, 0x54,
-  0x41, 0x03, 0x27, 0xa0, 0x94, 0x8f, 0xb0, 0xc8, 0x9f, 0x01, 0x4d, 0x4f,
-  0x8a, 0x78, 0x5d, 0xa0, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6,
-  0xb0, 0x85, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
-  0x05, 0xae, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x26, 0x02, 0x26, 0x27, 0x21,
-  0x35, 0x21, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x21, 0x35, 0x21,
-  0x3e, 0x01, 0x12, 0x37, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x05, 0x11,
-  0x06, 0x7c, 0xf9, 0x85, 0xfd, 0x8d, 0x02, 0x73, 0xad, 0x01, 0x3f, 0xab,
-  0xab, 0xfe, 0xc1, 0xad, 0xfd, 0x8d, 0x02, 0x73, 0x85, 0xf8, 0x7e, 0x08,
-  0xfc, 0x1a, 0x90, 0x90, 0x03, 0x27, 0x4a, 0x01, 0x03, 0x9a, 0x01, 0x9f,
-  0xc6, 0xfe, 0xa0, 0xfe, 0x8c, 0xfe, 0xa0, 0xc8, 0x9f, 0x01, 0x9c, 0x01,
-  0x02, 0x5d, 0xfe, 0xf0, 0x02, 0xc0, 0xfe, 0xf0, 0x00, 0x01, 0x00, 0xc3,
-  0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x19, 0x00, 0x00, 0x01, 0x20,
-  0x04, 0x10, 0x04, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x37, 0x21,
-  0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x26, 0x27, 0x26, 0x23, 0x25, 0x35,
-  0x02, 0x51, 0x01, 0x0a, 0x01, 0x0d, 0xfe, 0xf3, 0xfe, 0xf6, 0xfe, 0x72,
-  0x01, 0x8e, 0xcf, 0x60, 0x46, 0x1b, 0xfd, 0x62, 0x80, 0x80, 0x02, 0x9e,
-  0x21, 0x40, 0x67, 0xc8, 0xfe, 0x72, 0x04, 0x67, 0xf6, 0xfe, 0x20, 0xf6,
-  0x8e, 0x51, 0x3a, 0x85, 0xac, 0x01, 0xe6, 0xac, 0x91, 0x30, 0x50, 0x01,
-  0x8e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
-  0x06, 0xd2, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x21, 0x35, 0x21, 0x32, 0x04, 0x12, 0x15, 0x14, 0x02,
-  0x04, 0x23, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x21,
-  0x35, 0x01, 0x21, 0x35, 0x21, 0x05, 0x11, 0x06, 0x39, 0x43, 0x7e, 0x7b,
-  0x85, 0xfd, 0x8d, 0x02, 0x73, 0xad, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1,
-  0xad, 0xfd, 0x8d, 0x02, 0x73, 0x85, 0x7b, 0x7d, 0x44, 0x3a, 0x08, 0xfb,
-  0x8a, 0x04, 0xd1, 0xfb, 0x2f, 0x04, 0xd1, 0x03, 0x27, 0x4a, 0x78, 0x8b,
-  0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0xfe, 0xa0, 0xbb, 0xb9, 0xfe, 0xa0, 0xc8,
-  0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0, 0x03, 0x0b, 0xa0, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x9b, 0x04, 0x68, 0x05, 0x7d, 0x00, 0x16,
-  0x00, 0x1a, 0x00, 0x00, 0x01, 0x20, 0x04, 0x15, 0x14, 0x04, 0x29, 0x01,
-  0x35, 0x25, 0x32, 0x37, 0x36, 0x37, 0x21, 0x35, 0x05, 0x26, 0x27, 0x26,
-  0x07, 0x21, 0x35, 0x25, 0x21, 0x35, 0x21, 0x02, 0x51, 0x01, 0x0a, 0x01,
-  0x0d, 0xfe, 0xf3, 0xfe, 0xf6, 0xfe, 0x72, 0x01, 0x8e, 0xd1, 0x5e, 0x46,
-  0x1b, 0xfc, 0xe2, 0x03, 0x1e, 0x22, 0x3f, 0x68, 0xc7, 0xfe, 0x72, 0x03,
-  0x82, 0xfc, 0x7e, 0x03, 0x82, 0x04, 0x67, 0xf6, 0xf1, 0xef, 0xf6, 0x8e,
-  0x01, 0x50, 0x3a, 0x85, 0x8e, 0x01, 0x91, 0x31, 0x52, 0x01, 0x8e, 0x8a,
-  0x8c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x83,
-  0x05, 0xc2, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x15, 0x21,
-  0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x05, 0x82, 0xfb, 0xda, 0x04, 0x26,
-  0xfb, 0x41, 0x04, 0xbf, 0xfb, 0xda, 0x04, 0x26, 0x02, 0x82, 0xfe, 0x28,
-  0xaa, 0x05, 0xc2, 0xaa, 0xfe, 0x14, 0x00, 0x00, 0x00, 0x03, 0x00, 0x42,
-  0xff, 0xdc, 0x04, 0x15, 0x04, 0x1c, 0x00, 0x13, 0x00, 0x1b, 0x00, 0x23,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x15, 0x14, 0x00,
-  0x23, 0x22, 0x27, 0x07, 0x27, 0x37, 0x26, 0x35, 0x34, 0x00, 0x05, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x1f, 0x01, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x27, 0x02, 0x2a, 0xa8, 0x80, 0x6a, 0x59, 0x6a, 0x63, 0xfe, 0xe3,
-  0xc7, 0xa5, 0x7f, 0x6a, 0x59, 0x69, 0x64, 0x01, 0x1c, 0x01, 0x94, 0x5a,
-  0x74, 0x91, 0xd2, 0x40, 0x59, 0x59, 0x71, 0x93, 0xd2, 0x3e, 0x04, 0x17,
-  0x71, 0x76, 0x63, 0x76, 0x8d, 0xba, 0xdd, 0xfe, 0xc4, 0x6f, 0x76, 0x63,
-  0x76, 0x8d, 0xba, 0xdf, 0x01, 0x3c, 0xd5, 0x48, 0xe9, 0xa5, 0x80, 0x63,
-  0x62, 0x47, 0xe9, 0xa3, 0x80, 0x62, 0x00, 0x00, 0x00, 0x01, 0x00, 0x66,
-  0x01, 0x4c, 0x03, 0xe4, 0x03, 0x8c, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x01, 0x35, 0x05, 0x11, 0x01, 0x15, 0x02, 0x5f, 0xfe, 0x08, 0x01, 0x84,
-  0x01, 0xf8, 0x02, 0x7a, 0xfe, 0xd2, 0x01, 0x4a, 0xc2, 0xfa, 0x01, 0x2e,
-  0xfe, 0xb6, 0xc2, 0x00, 0x00, 0x02, 0x00, 0x83, 0x00, 0x00, 0x04, 0x0f,
-  0x04, 0xc4, 0x00, 0x04, 0x00, 0x09, 0x00, 0x00, 0x33, 0x11, 0x09, 0x01,
-  0x11, 0x25, 0x21, 0x11, 0x09, 0x01, 0x83, 0x01, 0xc6, 0x01, 0xc6, 0xfd,
-  0x0a, 0x02, 0x60, 0xfe, 0xd0, 0xfe, 0xd0, 0x02, 0xa0, 0x02, 0x24, 0xfd,
-  0xdc, 0xfd, 0x60, 0xaa, 0x01, 0xd5, 0x01, 0x79, 0xfe, 0x87, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x79, 0x03, 0xda, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x03, 0x27, 0x01, 0x33, 0x01, 0x07, 0x03, 0x02, 0xdc,
-  0xf7, 0x6c, 0x01, 0x63, 0x51, 0x01, 0x61, 0x6c, 0xf5, 0x04, 0xea, 0xfe,
-  0xf0, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78, 0x01, 0x10, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x04, 0x8e, 0x02, 0x02, 0x00, 0x07,
-  0x00, 0x00, 0x25, 0x33, 0x13, 0x17, 0x01, 0x23, 0x01, 0x37, 0x02, 0xdc,
-  0x51, 0xf5, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9d, 0x6c, 0xf2, 0x01, 0x10,
-  0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0x00, 0x00, 0xff, 0xff, 0x01, 0x79,
-  0x00, 0x00, 0x04, 0x8e, 0x03, 0x3f, 0x10, 0x26, 0x11, 0x49, 0x00, 0x00,
-  0x10, 0x07, 0x09, 0xdf, 0x00, 0x00, 0xfc, 0x26, 0xff, 0xff, 0x01, 0x79,
-  0x00, 0x00, 0x04, 0x8e, 0x04, 0x1b, 0x10, 0x27, 0x11, 0x49, 0x00, 0x00,
-  0x00, 0xdc, 0x10, 0x26, 0x11, 0x49, 0x00, 0xd7, 0x10, 0x07, 0x09, 0xdf,
-  0x00, 0x00, 0xfc, 0x26, 0x00, 0x01, 0x01, 0x1b, 0xff, 0xc5, 0x02, 0x69,
-  0x06, 0x4e, 0x00, 0x19, 0x00, 0x00, 0x01, 0x17, 0x06, 0x14, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x14, 0x17, 0x16, 0x14, 0x07, 0x27, 0x36, 0x34, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x34, 0x27, 0x26, 0x34, 0x01, 0x8b, 0x6e, 0x45,
-  0x45, 0x6f, 0x6f, 0x45, 0x45, 0x6f, 0x6f, 0x6e, 0x45, 0x45, 0x6f, 0x6f,
-  0x45, 0x45, 0x6f, 0x06, 0x4e, 0x76, 0x4f, 0x70, 0x50, 0x81, 0xf8, 0x81,
-  0x50, 0x6f, 0x50, 0x81, 0xf9, 0x81, 0x76, 0x4f, 0x70, 0x50, 0x81, 0xf8,
-  0x81, 0x50, 0x70, 0x50, 0x81, 0xf8, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e,
-  0xfe, 0xf2, 0x02, 0x1c, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x23, 0x11, 0x23, 0x9e, 0x01, 0x7e, 0xd8, 0xa6, 0x06, 0x14, 0x8f,
-  0xf9, 0x6d, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb3, 0xfe, 0xf2, 0x02, 0x31,
-  0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x23, 0x35,
-  0x02, 0x31, 0xa6, 0xd8, 0x06, 0x14, 0xf8, 0xde, 0x06, 0x93, 0x8f, 0x00,
-  0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c, 0x06, 0x14, 0x00, 0x05,
-  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x33, 0x15, 0x9e, 0xa6, 0xd8, 0xfe,
-  0xf2, 0x07, 0x22, 0xf9, 0x6d, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb3,
-  0xfe, 0xf2, 0x02, 0x31, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x35, 0x33, 0x11, 0x33, 0x02, 0x31, 0xfe, 0x82, 0xd8, 0xa6, 0xfe, 0xf2,
-  0x8f, 0x06, 0x93, 0x00, 0x00, 0x02, 0x02, 0xa8, 0xff, 0x62, 0x05, 0x78,
-  0x02, 0x82, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x11, 0x23,
-  0x13, 0x35, 0x21, 0x15, 0x02, 0xa8, 0x82, 0x82, 0xb4, 0x02, 0x1c, 0x01,
-  0xba, 0xfd, 0xa8, 0x02, 0x90, 0x90, 0x90, 0x00, 0x00, 0x02, 0x00, 0x5a,
-  0xff, 0x62, 0x03, 0x2a, 0x02, 0x82, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x15, 0x21, 0x35, 0x05, 0x33, 0x11, 0x23, 0x02, 0x76, 0xfd, 0xe4,
-  0x02, 0x4e, 0x82, 0x82, 0x02, 0x82, 0x90, 0x90, 0xc8, 0xfd, 0xa8, 0x00,
-  0x00, 0x02, 0x02, 0xa8, 0x01, 0xf2, 0x05, 0x78, 0x05, 0x12, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x25, 0x23, 0x11, 0x33,
-  0x03, 0x5c, 0x02, 0x1c, 0xfd, 0xb2, 0x82, 0x82, 0x01, 0xf2, 0x90, 0x90,
-  0xc8, 0x02, 0x58, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x01, 0xf2, 0x03, 0x2a,
-  0x05, 0x12, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35,
-  0x25, 0x23, 0x11, 0x33, 0x02, 0x76, 0xfd, 0xe4, 0x02, 0xd0, 0x82, 0x82,
-  0x02, 0x82, 0x90, 0x90, 0x38, 0x02, 0x58, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0x01, 0x1f, 0x05, 0x46, 0x03, 0x5e, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15,
-  0x21, 0x11, 0x23, 0x11, 0x05, 0x45, 0xfc, 0x15, 0x97, 0x03, 0x5e, 0xaa,
-  0xfe, 0x6b, 0x02, 0x3f, 0x00, 0x02, 0x00, 0x05, 0x01, 0x02, 0x03, 0xad,
-  0x05, 0x12, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x24, 0x05, 0x02,
-  0x13, 0x04, 0x25, 0x12, 0x03, 0x12, 0x03, 0x04, 0x25, 0x02, 0x13, 0x24,
-  0x7e, 0x01, 0x5a, 0x01, 0x5b, 0x7c, 0x7c, 0xfe, 0xa5, 0xfe, 0xa6, 0x7c,
-  0xf5, 0xa6, 0xa6, 0x01, 0xd4, 0x01, 0xd3, 0xa5, 0xa5, 0xfe, 0x2c, 0x01,
-  0x8a, 0x89, 0x89, 0x01, 0x80, 0x01, 0x82, 0x8a, 0x8a, 0xfe, 0x7e, 0xfd,
-  0xf8, 0x01, 0xf4, 0x02, 0x1c, 0xb1, 0xb1, 0xfe, 0x0c, 0xfd, 0xe5, 0xb1,
-  0x00, 0x06, 0x00, 0xde, 0x00, 0x01, 0x06, 0x55, 0x06, 0x13, 0x00, 0x03,
-  0x00, 0x31, 0x00, 0x3b, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x59, 0x00, 0x00,
-  0x01, 0x21, 0x11, 0x21, 0x11, 0x15, 0x14, 0x06, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x3b, 0x01, 0x11, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x32, 0x16,
-  0x1d, 0x01, 0x21, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x2b, 0x01, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x3d, 0x01, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x14, 0x16, 0x33,
-  0x13, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x01,
-  0x33, 0x32, 0x36, 0x34, 0x26, 0x22, 0x06, 0x15, 0x11, 0x15, 0x14, 0x16,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x14, 0x01, 0x0b, 0xfe, 0xf5,
-  0xa6, 0xea, 0xa6, 0xa6, 0x72, 0x99, 0x99, 0x72, 0xa6, 0xa6, 0xea, 0xa6,
-  0x01, 0x0b, 0xa6, 0x75, 0x76, 0xa5, 0xa5, 0x73, 0x99, 0x99, 0x73, 0xa5,
-  0xa5, 0x76, 0x75, 0xa6, 0xfe, 0x70, 0x58, 0x3e, 0x3d, 0x58, 0x58, 0x3e,
-  0x95, 0x95, 0x3e, 0x58, 0x58, 0x3e, 0x3d, 0x58, 0x02, 0x15, 0x96, 0x3e,
-  0x58, 0x58, 0x7c, 0x58, 0x58, 0x7c, 0x58, 0x58, 0x3e, 0x02, 0x76, 0x01,
-  0x28, 0xfe, 0x44, 0xaa, 0x80, 0xb7, 0xb8, 0x83, 0x80, 0xba, 0x01, 0x28,
-  0xba, 0x81, 0x82, 0xb8, 0xb7, 0x80, 0xaa, 0xaa, 0x80, 0xb7, 0xb8, 0x82,
-  0x81, 0xba, 0xfe, 0xd8, 0xba, 0x80, 0x83, 0xb8, 0xb7, 0x80, 0xaa, 0x02,
-  0x50, 0xa7, 0x45, 0x61, 0x61, 0x8a, 0x62, 0xfd, 0xb0, 0x62, 0x44, 0x45,
-  0x62, 0x62, 0x44, 0x02, 0xf7, 0x62, 0x8a, 0x61, 0x61, 0x45, 0xfd, 0x09,
-  0xa7, 0x44, 0x62, 0x62, 0x45, 0x44, 0x62, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0x01, 0x1f, 0x05, 0x46, 0x03, 0x5e, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x11, 0x33, 0x11, 0x21, 0x05, 0x45, 0xfb, 0x7e, 0x97, 0x03, 0xeb, 0x01,
-  0x1f, 0x02, 0x3f, 0xfe, 0x6b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e,
-  0x03, 0x67, 0x02, 0xe8, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x11, 0x23, 0x11, 0x21, 0x02, 0xe7, 0xfe, 0x39, 0x82, 0x02, 0x49, 0x05,
-  0x84, 0xfd, 0xe3, 0x02, 0xad, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x78,
-  0x03, 0x67, 0x02, 0xc2, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x13, 0x35,
-  0x21, 0x11, 0x23, 0x11, 0x79, 0x02, 0x49, 0x82, 0x05, 0x84, 0x90, 0xfd,
-  0x53, 0x02, 0x1d, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xff, 0x70, 0x02, 0xe8,
-  0x02, 0x1d, 0x00, 0x05, 0x00, 0x00, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11,
-  0x02, 0xe7, 0xfd, 0xb7, 0x82, 0x90, 0x02, 0xad, 0xfd, 0xe3, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x78, 0xff, 0x70, 0x02, 0xc2, 0x02, 0x1d, 0x00, 0x05,
-  0x00, 0x00, 0x33, 0x21, 0x11, 0x33, 0x11, 0x21, 0x79, 0x01, 0xc7, 0x82,
-  0xfd, 0xb7, 0x02, 0x1d, 0xfd, 0x53, 0x00, 0x00, 0x00, 0x01, 0x01, 0x83,
-  0xfe, 0x00, 0x03, 0x95, 0x07, 0x6c, 0x00, 0x19, 0x00, 0x00, 0x01, 0x11,
-  0x34, 0x37, 0x1a, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x03, 0x02, 0x15, 0x30, 0x11,
-  0x01, 0x84, 0x03, 0x0a, 0xab, 0xb6, 0x48, 0x5a, 0x39, 0x32, 0x27, 0x19,
-  0x15, 0x0e, 0x05, 0x08, 0x0f, 0x5d, 0x10, 0x07, 0xfe, 0x00, 0x05, 0x08,
-  0x24, 0x81, 0x02, 0x03, 0x01, 0xbc, 0x54, 0x41, 0x36, 0x3f, 0x13, 0x10,
-  0x26, 0x0f, 0x48, 0xfd, 0x95, 0xfe, 0xd3, 0x02, 0xfa, 0x98, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x25, 0xfe, 0x1a, 0x02, 0x37, 0x07, 0x89, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x11, 0x14, 0x07, 0x0a, 0x01, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x13,
-  0x12, 0x35, 0x30, 0x11, 0x02, 0x36, 0x03, 0x0a, 0xab, 0xb6, 0x48, 0x5a,
-  0x39, 0x32, 0x27, 0x19, 0x15, 0x0e, 0x05, 0x08, 0x0f, 0x5d, 0x10, 0x07,
-  0x07, 0x89, 0xfa, 0xf5, 0x24, 0x81, 0xfd, 0xfd, 0xfe, 0x44, 0x54, 0x41,
-  0x36, 0x3f, 0x13, 0x10, 0x26, 0x0f, 0x48, 0x02, 0x6b, 0x01, 0x2d, 0x02,
-  0x05, 0x6b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x8c, 0x01, 0xd0, 0x07, 0xc0,
-  0x04, 0x9a, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x09, 0x01,
-  0x27, 0x01, 0x33, 0x01, 0x07, 0x01, 0x25, 0x21, 0x35, 0x29, 0x02, 0x15,
-  0x21, 0x03, 0xfe, 0xfe, 0x55, 0x6c, 0x02, 0x17, 0x50, 0x02, 0x15, 0x6c,
-  0xfe, 0x57, 0xfe, 0xb3, 0xfd, 0x8b, 0x02, 0x75, 0x02, 0x49, 0x02, 0x76,
-  0xfd, 0x8a, 0x03, 0xa8, 0xfe, 0x28, 0x78, 0x02, 0x52, 0xfd, 0xae, 0x78,
-  0x01, 0xd8, 0x48, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x8c,
-  0x00, 0x00, 0x07, 0xc0, 0x04, 0x9a, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00,
-  0x13, 0x21, 0x01, 0x21, 0x15, 0x21, 0x01, 0x21, 0x25, 0x21, 0x15, 0x21,
-  0x8c, 0x02, 0x75, 0x02, 0x9a, 0x02, 0x25, 0xfd, 0x8b, 0xfd, 0x66, 0xfd,
-  0xdb, 0x04, 0xbe, 0x02, 0x76, 0xfd, 0x8a, 0x04, 0x9a, 0xfc, 0x10, 0xaa,
-  0x03, 0xf0, 0xaa, 0xaa, 0x00, 0x05, 0x00, 0x8c, 0x00, 0x00, 0x0a, 0x2e,
-  0x06, 0x14, 0x00, 0x04, 0x00, 0x09, 0x00, 0x0c, 0x00, 0x0f, 0x00, 0x15,
-  0x00, 0x00, 0x33, 0x11, 0x21, 0x09, 0x02, 0x11, 0x33, 0x09, 0x01, 0x29,
-  0x01, 0x09, 0x01, 0x21, 0x09, 0x03, 0x33, 0x09, 0x01, 0x8c, 0x06, 0xe5,
-  0x02, 0xbd, 0xfd, 0x43, 0xf9, 0xa1, 0x7e, 0x02, 0x38, 0xfd, 0xc8, 0x04,
-  0x6f, 0xfc, 0x4f, 0x01, 0xd9, 0xfe, 0x27, 0x03, 0xb1, 0xfe, 0x28, 0x02,
-  0x94, 0xfd, 0xc9, 0x02, 0x37, 0x7f, 0x02, 0x37, 0xfd, 0xc9, 0x06, 0x14,
-  0xfc, 0xf6, 0xfc, 0xf6, 0x05, 0x80, 0xfb, 0x14, 0x02, 0x76, 0x02, 0x76,
-  0xfd, 0xf3, 0xfd, 0x21, 0x02, 0x0d, 0x02, 0xdf, 0xfd, 0x8a, 0xfd, 0x8a,
-  0x02, 0x74, 0x02, 0x78, 0x00, 0x05, 0x00, 0x8c, 0x00, 0x00, 0x07, 0xc0,
-  0x06, 0x14, 0x00, 0x03, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x13,
-  0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x01, 0x11, 0x33, 0x09, 0x01, 0x29,
-  0x01, 0x09, 0x01, 0x21, 0x09, 0x03, 0x33, 0x11, 0x8c, 0x07, 0x34, 0xf9,
-  0x52, 0x7e, 0x02, 0x38, 0xfd, 0xc8, 0x04, 0x6f, 0xfc, 0x4f, 0x01, 0xd9,
-  0xfe, 0x27, 0x03, 0xb1, 0xfe, 0x28, 0x02, 0x94, 0xfd, 0xc9, 0x02, 0x37,
-  0x7f, 0x06, 0x14, 0xf9, 0xec, 0x05, 0x80, 0xfb, 0x14, 0x02, 0x76, 0x02,
-  0x76, 0xfd, 0xf3, 0xfd, 0x21, 0x02, 0x0d, 0x02, 0xdf, 0xfd, 0x8a, 0xfd,
-  0x8a, 0x04, 0xec, 0x00, 0x00, 0x2b, 0x00, 0x6c, 0x00, 0x00, 0x09, 0xf9,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
-  0x00, 0x47, 0x00, 0x53, 0x00, 0x5f, 0x00, 0x6b, 0x00, 0x77, 0x00, 0x83,
-  0x00, 0x8f, 0x00, 0x9b, 0x00, 0xa7, 0x00, 0xb3, 0x00, 0xbf, 0x00, 0xcb,
-  0x00, 0xd7, 0x00, 0xe3, 0x00, 0xef, 0x00, 0xfb, 0x01, 0x07, 0x01, 0x13,
-  0x01, 0x1f, 0x01, 0x2b, 0x01, 0x37, 0x01, 0x43, 0x01, 0x4f, 0x01, 0x5b,
-  0x01, 0x67, 0x01, 0x73, 0x01, 0x7f, 0x01, 0x8b, 0x01, 0x97, 0x01, 0xa3,
-  0x01, 0xaf, 0x01, 0xbb, 0x01, 0xc7, 0x01, 0xd3, 0x01, 0xe4, 0x01, 0xf0,
-  0x01, 0xfc, 0x02, 0x08, 0x00, 0x00, 0x01, 0x21, 0x32, 0x15, 0x11, 0x14,
-  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x11, 0x14, 0x33, 0x21, 0x32,
-  0x35, 0x11, 0x34, 0x23, 0x21, 0x22, 0x13, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x25, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x25, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x27, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x27, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x32, 0x15, 0x11, 0x14, 0x2b,
-  0x01, 0x22, 0x3d, 0x01, 0x34, 0x23, 0x22, 0x3d, 0x01, 0x34, 0x33, 0x13,
-  0x15, 0x14, 0x2b, 0x01, 0x22, 0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17,
-  0x15, 0x14, 0x2b, 0x01, 0x22, 0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05,
-  0x22, 0x3d, 0x01, 0x34, 0x33, 0x21, 0x32, 0x1d, 0x01, 0x14, 0x23, 0x01,
-  0x33, 0x07, 0xff, 0xc6, 0xc6, 0xf8, 0x01, 0xc7, 0x84, 0x43, 0x07, 0xff,
-  0x41, 0x41, 0xf8, 0x01, 0x43, 0xe9, 0x21, 0x42, 0x22, 0x22, 0x42, 0x21,
-  0xc9, 0x21, 0x44, 0x20, 0x20, 0x44, 0x21, 0x01, 0x29, 0x21, 0x43, 0x21,
-  0x21, 0x43, 0x21, 0xfe, 0x72, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7,
-  0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0x01, 0x8d, 0x21, 0x43, 0x21, 0x21,
-  0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43,
-  0x21, 0x21, 0x43, 0x21, 0xc7, 0x22, 0x42, 0x21, 0x21, 0x42, 0x22, 0xc7,
-  0x22, 0x42, 0x21, 0x21, 0x42, 0x22, 0x01, 0x66, 0x21, 0xe2, 0x22, 0x22,
-  0xe2, 0x21, 0xf9, 0x09, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21,
-  0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x22, 0x42, 0x21, 0x21, 0x42, 0x22,
-  0xc6, 0x22, 0x42, 0x21, 0x21, 0x42, 0x22, 0xc7, 0x22, 0x42, 0x21, 0x21,
-  0x42, 0x22, 0xc7, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0xc6, 0x21, 0x42,
-  0x22, 0x22, 0x42, 0x21, 0xc7, 0x21, 0x42, 0x22, 0x22, 0x42, 0x21, 0x20,
-  0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43,
-  0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21,
-  0x21, 0x43, 0x21, 0xc6, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21,
-  0x42, 0x22, 0x22, 0x42, 0x21, 0xc7, 0x21, 0x42, 0x22, 0x22, 0x42, 0x21,
-  0xc6, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0x21, 0x21, 0x43, 0x21, 0x21,
-  0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43,
-  0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc6,
-  0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43,
-  0x21, 0xc7, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0xc7, 0x22, 0x42, 0x22,
-  0x22, 0x42, 0x22, 0xc7, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0x01, 0x01,
-  0x21, 0x7e, 0x21, 0x21, 0x7e, 0x21, 0x21, 0x21, 0x21, 0xde, 0x26, 0x20,
-  0x21, 0x21, 0x85, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc9, 0x21, 0x44,
-  0x20, 0x20, 0x44, 0x21, 0xfa, 0x48, 0x22, 0x22, 0x03, 0x9d, 0x21, 0x21,
-  0x05, 0xd5, 0xdd, 0xfb, 0xe5, 0xdd, 0xdd, 0x04, 0x1b, 0xdd, 0xdd, 0xfb,
-  0xe5, 0x4a, 0x4a, 0x04, 0x1b, 0x4a, 0xfc, 0x1c, 0x49, 0x25, 0x25, 0x49,
-  0x26, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0xb7, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0xb7, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0xb7, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0xb4, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0xdb, 0x25, 0xfe, 0xde, 0x25, 0x25, 0x95, 0x20, 0x25, 0x49, 0x25,
-  0xfd, 0x48, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
-  0x25, 0x94, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x00, 0x05, 0x00, 0x00,
-  0x00, 0x00, 0x09, 0xa2, 0x06, 0x14, 0x00, 0x04, 0x00, 0x09, 0x00, 0x0c,
-  0x00, 0x0f, 0x00, 0x15, 0x00, 0x00, 0x29, 0x01, 0x09, 0x01, 0x21, 0x07,
-  0x23, 0x09, 0x01, 0x33, 0x09, 0x02, 0x11, 0x09, 0x01, 0x03, 0x23, 0x09,
-  0x01, 0x33, 0x01, 0x09, 0xa2, 0xf9, 0x1b, 0xfd, 0x44, 0x02, 0xbc, 0x06,
-  0xe5, 0x85, 0x7f, 0xfd, 0xc9, 0x02, 0x37, 0x7f, 0xfb, 0x12, 0x01, 0xd9,
-  0x01, 0xd8, 0xfe, 0x28, 0xfe, 0x27, 0xbb, 0x80, 0xfd, 0xc9, 0x02, 0x37,
-  0x80, 0x02, 0x37, 0x03, 0x0a, 0x03, 0x0a, 0x94, 0xfd, 0x8a, 0xfd, 0x8a,
-  0x04, 0xec, 0xfd, 0xf3, 0x02, 0x0d, 0xfb, 0x14, 0x02, 0x0d, 0xfd, 0xf3,
-  0x04, 0xec, 0xfd, 0x88, 0xfd, 0x8c, 0x02, 0x76, 0x00, 0x05, 0x00, 0x87,
-  0xff, 0x46, 0x05, 0xc3, 0x05, 0xfc, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x0f,
-  0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x13, 0x09, 0x01, 0x11, 0x09, 0x01,
-  0x03, 0x11, 0x09, 0x01, 0x11, 0x01, 0x03, 0x37, 0x01, 0x07, 0x11, 0x17,
-  0x01, 0x27, 0x01, 0x33, 0x11, 0x23, 0xee, 0x02, 0x37, 0x02, 0x37, 0xfd,
-  0xc9, 0xfd, 0xc9, 0x67, 0x02, 0x9e, 0x02, 0x9d, 0xfd, 0x63, 0x23, 0x34,
-  0x01, 0xae, 0x33, 0x33, 0xfe, 0x52, 0x34, 0xfe, 0x52, 0x67, 0x67, 0x01,
-  0x35, 0xfe, 0x95, 0x01, 0x6b, 0x02, 0xd8, 0x01, 0x6b, 0xfe, 0x95, 0xfc,
-  0xe6, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4, 0xfe, 0x53, 0x05,
-  0x41, 0x63, 0xfe, 0xec, 0x63, 0xfe, 0x5c, 0x63, 0xfe, 0xec, 0x63, 0x02,
-  0xfa, 0xfd, 0xd8, 0x00, 0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x30,
-  0x04, 0x60, 0x10, 0x06, 0x03, 0x4d, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x10, 0x06, 0x03, 0x55, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a, 0x04, 0x60, 0x10, 0x06,
-  0x03, 0x5d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
-  0x04, 0x79, 0x10, 0x06, 0x03, 0x45, 0x00, 0x00, 0x00, 0x01, 0x00, 0x17,
-  0xfe, 0x2e, 0x05, 0x5d, 0x00, 0xd0, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
-  0x11, 0x21, 0x15, 0x23, 0x11, 0x21, 0x11, 0x23, 0x35, 0x21, 0x01, 0x8c,
-  0x02, 0x5c, 0x01, 0x74, 0xdc, 0xfc, 0x74, 0xdd, 0x01, 0x75, 0xfe, 0xd8,
-  0x01, 0xf8, 0xaa, 0xfe, 0x08, 0x01, 0xf8, 0xaa, 0x00, 0x02, 0x00, 0x8c,
-  0x00, 0x00, 0x07, 0xe5, 0x05, 0xfb, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00,
-  0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x01, 0x21,
-  0x35, 0x21, 0x05, 0x35, 0x21, 0x15, 0x05, 0x4b, 0x01, 0x9d, 0xd1, 0x6c,
-  0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0xb3, 0xfd, 0x66, 0xfd, 0x8b,
-  0x02, 0x25, 0x02, 0x99, 0x02, 0x76, 0x04, 0x9a, 0xe9, 0x78, 0xfe, 0x77,
-  0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xfc, 0x10, 0xaa, 0xaa, 0xaa, 0xaa, 0x00,
-  0x00, 0x02, 0x00, 0x1f, 0x00, 0x00, 0x06, 0x2a, 0x05, 0xd0, 0x00, 0x05,
-  0x00, 0x0b, 0x00, 0x00, 0x25, 0x21, 0x09, 0x01, 0x21, 0x09, 0x03, 0x21,
-  0x09, 0x01, 0x01, 0xdd, 0x02, 0x8f, 0x01, 0x48, 0xfe, 0xb8, 0xfd, 0x71,
-  0xfe, 0xb8, 0x01, 0x0d, 0xfe, 0x7e, 0x01, 0x82, 0x03, 0x05, 0x01, 0x83,
-  0xfe, 0x7e, 0x72, 0x02, 0x76, 0x02, 0x76, 0xfd, 0x8a, 0xfd, 0x18, 0x02,
-  0xe8, 0x02, 0xe8, 0xfd, 0x18, 0xfd, 0x18, 0x00, 0x00, 0x01, 0x00, 0x9e,
-  0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x92, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23,
-  0x35, 0x10, 0x13, 0x12, 0x13, 0x33, 0x02, 0x03, 0x02, 0x11, 0x01, 0x4e,
-  0xb0, 0x90, 0xa8, 0x95, 0x90, 0xea, 0x51, 0x72, 0xfd, 0xfc, 0xea, 0x03,
-  0x97, 0x01, 0xe2, 0x02, 0x30, 0x01, 0x03, 0xfd, 0xf3, 0xfe, 0x86, 0xfd,
-  0xee, 0xfc, 0xed, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x01, 0x4e,
-  0x07, 0x89, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x9e, 0xb0,
-  0xb0, 0x07, 0x89, 0xf6, 0x73, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e,
-  0xfe, 0x14, 0x02, 0xfc, 0x07, 0x89, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x15,
-  0x10, 0x13, 0x12, 0x13, 0x23, 0x02, 0x03, 0x02, 0x11, 0x35, 0x01, 0x4e,
-  0x72, 0x84, 0xb7, 0x90, 0xbb, 0x82, 0x90, 0x07, 0x89, 0xea, 0xfc, 0xa5,
-  0xfe, 0x57, 0xfe, 0x14, 0xfe, 0x65, 0x01, 0x45, 0x01, 0xee, 0x02, 0x26,
-  0x03, 0x32, 0xea, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x02, 0xfc,
-  0x07, 0x92, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35, 0x10, 0x03, 0x02, 0x03,
-  0x33, 0x12, 0x13, 0x12, 0x11, 0x15, 0x02, 0x4c, 0x73, 0x51, 0xea, 0x90,
-  0x96, 0xa7, 0x90, 0xfd, 0xfc, 0xea, 0x03, 0x13, 0x02, 0x12, 0x01, 0x79,
-  0x02, 0x0e, 0xfe, 0xfd, 0xfd, 0xd0, 0xfe, 0x1e, 0xfc, 0x69, 0xea, 0x00,
-  0x00, 0x01, 0x02, 0x4b, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x89, 0x00, 0x04,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x30, 0x02, 0xfb, 0xaf, 0x07, 0x89,
-  0xf6, 0x73, 0x09, 0x8d, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0x14, 0x02, 0xfc,
-  0x07, 0x89, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33, 0x15, 0x10, 0x03, 0x02,
-  0x03, 0x23, 0x12, 0x13, 0x12, 0x11, 0x02, 0x4c, 0xaf, 0x90, 0x81, 0xbc,
-  0x90, 0xb7, 0x84, 0x73, 0x07, 0x89, 0xea, 0xfc, 0xcd, 0xfd, 0xdb, 0xfe,
-  0x12, 0xfe, 0xbb, 0x01, 0x9b, 0x01, 0xec, 0x01, 0xa9, 0x03, 0x5b, 0x00,
-  0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x6d, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x23, 0x11, 0x21, 0x15, 0x21, 0x01, 0x4e, 0xb0, 0x02,
-  0x5d, 0xfe, 0x53, 0xfd, 0xfc, 0x09, 0x71, 0xc3, 0x00, 0x01, 0x00, 0x9e,
-  0xfd, 0xfc, 0x01, 0x4e, 0x07, 0x89, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x23, 0x9e, 0xb0, 0xb0, 0x07, 0x89, 0xf6, 0x73, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x9e, 0xfe, 0x14, 0x02, 0xfc, 0x07, 0x89, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x4e, 0x01, 0xad,
-  0xfd, 0xa3, 0x07, 0x89, 0xf7, 0x4e, 0xc3, 0x09, 0x75, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x6d, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x02, 0x4c, 0xfe, 0x52,
-  0x02, 0x5d, 0xfd, 0xfc, 0x08, 0xae, 0xc3, 0xf6, 0x8f, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0x4b, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x7a, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x02, 0x4c, 0xaf, 0xaf, 0x07, 0x7a,
-  0xf6, 0x82, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0x14, 0x02, 0xfc,
-  0x07, 0x7a, 0x00, 0x05, 0x00, 0x00, 0x01, 0x33, 0x11, 0x21, 0x35, 0x21,
-  0x02, 0x4c, 0xaf, 0xfd, 0xa3, 0x01, 0xae, 0x07, 0x7a, 0xf6, 0x9a, 0xc3,
-  0x00, 0x01, 0x02, 0x5f, 0xfd, 0xea, 0x04, 0xd0, 0x07, 0x6d, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x23, 0x11, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x07, 0x06, 0x15, 0x03, 0x07, 0xa7, 0x63, 0x6d, 0xa8, 0xf7, 0xfd,
-  0x5b, 0x3d, 0x33, 0xfd, 0xea, 0x07, 0x75, 0xdf, 0x91, 0x9e, 0xb0, 0x66,
-  0x57, 0x99, 0x00, 0x00, 0x00, 0x01, 0x00, 0x97, 0xfd, 0xfc, 0x03, 0x07,
-  0x07, 0x86, 0x00, 0x18, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x19, 0x01,
-  0x23, 0x11, 0x10, 0x27, 0x26, 0x2f, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
-  0x19, 0x01, 0x33, 0x11, 0x10, 0x07, 0x06, 0x02, 0x52, 0x34, 0x26, 0x5b,
-  0xa7, 0x64, 0x43, 0xeb, 0x37, 0x37, 0xe9, 0x45, 0x64, 0xa7, 0x5b, 0x24,
-  0x02, 0xc1, 0x20, 0x3d, 0x93, 0xfe, 0x43, 0xfd, 0xe8, 0x02, 0x0c, 0x01,
-  0xb7, 0x5f, 0x41, 0x04, 0x01, 0xbb, 0x45, 0x63, 0x01, 0xb3, 0x02, 0x0c,
-  0xfd, 0xe8, 0xfe, 0x48, 0x98, 0x3c, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5f,
-  0xfe, 0x14, 0x04, 0xd0, 0x07, 0x86, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11,
-  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11,
-  0x03, 0x07, 0x33, 0x3d, 0x5b, 0xfd, 0xf7, 0xa6, 0x6f, 0x63, 0x07, 0x86,
-  0xf8, 0x94, 0x9a, 0x56, 0x66, 0xb0, 0x9e, 0x8f, 0xe1, 0x07, 0x64, 0x00,
-  0x00, 0x01, 0x02, 0x5f, 0xfd, 0xf4, 0x03, 0x07, 0x07, 0x8c, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x23, 0x11, 0x33, 0x03, 0x07, 0xa7, 0xa7, 0xfd, 0xf4,
-  0x09, 0x98, 0x00, 0x00, 0x00, 0x01, 0x00, 0x97, 0xfd, 0xea, 0x03, 0x07,
-  0x07, 0x6d, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x34, 0x27, 0x26, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x02, 0x60, 0x34, 0x3d,
-  0x5b, 0xfd, 0xf8, 0xa7, 0x6d, 0x64, 0xfd, 0xea, 0x07, 0x7d, 0x99, 0x57,
-  0x66, 0xb0, 0x9e, 0x91, 0xdf, 0xf8, 0x8b, 0x00, 0x00, 0x01, 0x02, 0x5f,
-  0xfd, 0xfc, 0x04, 0xd0, 0x07, 0x86, 0x00, 0x18, 0x00, 0x00, 0x01, 0x26,
-  0x27, 0x26, 0x19, 0x01, 0x33, 0x11, 0x10, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x07, 0x06, 0x07, 0x06, 0x19, 0x01, 0x23, 0x11, 0x10, 0x37, 0x36, 0x03,
-  0x14, 0x36, 0x24, 0x5a, 0xa7, 0x63, 0x45, 0xe9, 0x37, 0x37, 0xeb, 0x43,
-  0x63, 0xa7, 0x5a, 0x26, 0x02, 0xc1, 0x21, 0x3c, 0x98, 0x01, 0xb8, 0x02,
-  0x18, 0xfd, 0xf4, 0xfe, 0x4d, 0x63, 0x45, 0xbb, 0x01, 0x04, 0x41, 0x5f,
-  0xfe, 0x49, 0xfd, 0xf4, 0x02, 0x18, 0x01, 0xbd, 0x93, 0x3d, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x97, 0xfe, 0x14, 0x03, 0x07, 0x07, 0x86, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x02, 0x60, 0xa7, 0x64, 0x6f, 0xa5, 0xf8, 0xfd,
-  0x5b, 0x3d, 0x34, 0x07, 0x86, 0xf8, 0x9c, 0xe1, 0x8f, 0x9e, 0xb0, 0x66,
-  0x56, 0x9a, 0x00, 0x00, 0x00, 0x01, 0x01, 0x83, 0xfe, 0x00, 0x02, 0x37,
-  0x07, 0x89, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x01, 0x84,
-  0xb2, 0xfe, 0x00, 0x09, 0x89, 0xf6, 0x77, 0x00, 0x00, 0x02, 0x00, 0x31,
-  0x00, 0x86, 0x05, 0xa0, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x11, 0x00, 0x00,
-  0x25, 0x09, 0x01, 0x11, 0x21, 0x11, 0x21, 0x03, 0x21, 0x03, 0x35, 0x03,
-  0x13, 0x35, 0x21, 0x13, 0x23, 0x03, 0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9,
-  0x01, 0xfe, 0x01, 0xa7, 0x01, 0xfc, 0x5c, 0x5a, 0xf0, 0xf0, 0x03, 0xa4,
-  0x01, 0xf3, 0x01, 0x86, 0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0x02, 0x68,
-  0xfb, 0xc2, 0x01, 0x72, 0x83, 0xfe, 0xf6, 0xfe, 0xf6, 0x83, 0x03, 0x76,
-  0xfd, 0x98, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x27,
-  0x04, 0xc4, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x01, 0x21, 0x09, 0x01,
-  0x21, 0x11, 0x21, 0x06, 0x26, 0xfa, 0x81, 0x02, 0xbf, 0x02, 0xc0, 0xfa,
-  0x81, 0x05, 0x7f, 0x02, 0xa0, 0x02, 0x24, 0xfb, 0x3c, 0x01, 0xf8, 0x00,
-  0x00, 0x04, 0x00, 0x87, 0xff, 0x46, 0x05, 0xc3, 0x05, 0xfc, 0x00, 0x05,
-  0x00, 0x0b, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x00, 0x13, 0x09, 0x01, 0x11,
-  0x09, 0x01, 0x03, 0x11, 0x09, 0x01, 0x11, 0x01, 0x00, 0x14, 0x17, 0x16,
-  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x26, 0x27, 0x26,
-  0x22, 0x07, 0x06, 0x07, 0x02, 0x10, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x10,
-  0x0e, 0x01, 0x22, 0x26, 0xee, 0x02, 0x37, 0x02, 0x37, 0xfd, 0xc9, 0xfd,
-  0xc9, 0x67, 0x02, 0x9e, 0x02, 0x9d, 0xfd, 0x63, 0xfe, 0x96, 0x30, 0x31,
-  0x53, 0x53, 0xc5, 0x53, 0x53, 0x31, 0x30, 0x30, 0x31, 0x53, 0x53, 0xc5,
-  0x53, 0x53, 0x31, 0x97, 0x7c, 0xd7, 0xfc, 0xd6, 0x7c, 0x7c, 0xd6, 0xfc,
-  0xd7, 0x01, 0x35, 0xfe, 0x95, 0x01, 0x6b, 0x02, 0xd8, 0x01, 0x6b, 0xfe,
-  0x95, 0xfc, 0xe6, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4, 0xfe,
-  0x53, 0x03, 0xc8, 0xda, 0x5d, 0x5c, 0x36, 0x36, 0x36, 0x36, 0x5c, 0x5d,
-  0xda, 0x5d, 0x5c, 0x36, 0x36, 0x36, 0x36, 0x5c, 0xfe, 0xaa, 0x01, 0x18,
-  0xee, 0x8a, 0x8a, 0xee, 0xfe, 0xe8, 0xee, 0x8a, 0x8a, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x05, 0x00, 0x9a, 0x05, 0x85, 0x03, 0x8e, 0x10, 0x06,
-  0x0a, 0xda, 0x00, 0x00, 0x00, 0x03, 0x00, 0x50, 0xfe, 0xf7, 0x04, 0x54,
-  0x02, 0x5a, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x20, 0x00, 0x00, 0x00, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x35, 0x34, 0x2f,
-  0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
-  0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x03, 0x85, 0xb6, 0x2d, 0x2e,
-  0x2e, 0x2d, 0xb6, 0x2d, 0x2e, 0x2e, 0x88, 0x91, 0x99, 0x99, 0x91, 0x92,
-  0x99, 0x99, 0xfe, 0x81, 0xc9, 0xcf, 0x7b, 0x02, 0x01, 0x56, 0x56, 0xac,
-  0xad, 0x56, 0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4,
-  0xde, 0xde, 0xd4, 0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27,
-  0xfc, 0xbd, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8e, 0xff, 0xe3, 0x04, 0x2e,
-  0x06, 0x14, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x33,
-  0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x07,
-  0x27, 0x25, 0x35, 0x33, 0x15, 0x25, 0x17, 0x05, 0x00, 0x10, 0x26, 0x20,
-  0x06, 0x10, 0x16, 0x20, 0x01, 0x4e, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5,
-  0xb8, 0x6f, 0x9f, 0x34, 0xa7, 0xfa, 0x1e, 0x01, 0x18, 0xa7, 0x01, 0x06,
-  0x1e, 0xfe, 0xdc, 0x02, 0x33, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07,
-  0x03, 0xb6, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x64,
-  0xa8, 0x04, 0xe6, 0x5d, 0x63, 0x68, 0xc0, 0x83, 0x61, 0x61, 0x6d, 0xfc,
-  0x40, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x00, 0x01, 0x00, 0x83,
-  0xfe, 0x2e, 0x04, 0x0f, 0x00, 0xd0, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21,
-  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x01, 0x1b, 0x02, 0x5c, 0x98, 0xfc,
-  0x74, 0x98, 0xfe, 0xd8, 0x01, 0xf8, 0xfd, 0x5e, 0x02, 0xa2, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
-  0x00, 0x1b, 0x00, 0x26, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x01, 0x33,
-  0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x05, 0xec, 0xfe,
-  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
-  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
-  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x01, 0x56, 0xc3,
-  0xd5, 0xe8, 0x91, 0xc4, 0xfd, 0xd5, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41,
-  0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8,
-  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
-  0xb1, 0xfe, 0xb9, 0xfd, 0xff, 0x02, 0x7e, 0x2b, 0x98, 0x2f, 0xfc, 0xe6,
-  0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
-  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x38, 0x00, 0x00, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
-  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22,
-  0x04, 0x02, 0x01, 0x21, 0x15, 0x21, 0x35, 0x3e, 0x01, 0x37, 0x3e, 0x01,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x07, 0x0e, 0x01, 0x05, 0xec, 0xfe, 0x6c, 0xfe,
-  0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c,
-  0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01, 0x67, 0xa4,
-  0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x02, 0x13, 0x01, 0x89, 0xfd,
-  0x9f, 0x4a, 0xec, 0x1e, 0x37, 0x2b, 0x56, 0x46, 0x35, 0x77, 0x67, 0x57,
-  0x83, 0x36, 0x93, 0xb1, 0x2b, 0x38, 0x0f, 0xa0, 0x02, 0xea, 0xfe, 0xc1,
-  0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe,
-  0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01,
-  0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0xfd, 0xff, 0x8e, 0x81, 0x4d, 0xf1, 0x22,
-  0x3f, 0x55, 0x28, 0x3f, 0x4e, 0x26, 0x3a, 0xab, 0x24, 0x1f, 0x97, 0x7d,
-  0x3a, 0x69, 0x46, 0x12, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x44,
-  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
-  0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
-  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x05, 0x1e, 0x01, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x05,
-  0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c,
-  0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01,
-  0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x03,
-  0x59, 0x0c, 0x6a, 0xc2, 0xb0, 0x39, 0x7b, 0x4f, 0x52, 0x70, 0x3e, 0x69,
-  0x67, 0x60, 0x59, 0x7e, 0x83, 0x50, 0x50, 0x53, 0x52, 0x2f, 0x6d, 0x60,
-  0x55, 0x7b, 0x37, 0x91, 0xad, 0x5d, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41,
-  0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8,
-  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
-  0xb1, 0xfe, 0xb9, 0x96, 0x03, 0x81, 0x5d, 0x8d, 0x9c, 0x17, 0x1b, 0xa8,
-  0x30, 0x1c, 0x4f, 0x4c, 0x47, 0x4e, 0x8c, 0x3c, 0x3a, 0x3c, 0x3f, 0x15,
-  0x20, 0x97, 0x18, 0x14, 0x89, 0x73, 0x51, 0x72, 0x00, 0x04, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x1e,
-  0x00, 0x29, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
-  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x25, 0x03, 0x33, 0x03,
-  0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x21, 0x35, 0x05, 0xec,
-  0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab,
-  0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00,
-  0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x02, 0x78,
-  0xf2, 0xf2, 0x15, 0xb9, 0x7f, 0x7f, 0xa4, 0xfe, 0x70, 0x02, 0xea, 0xfe,
-  0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6,
-  0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3,
-  0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x4f, 0xfe, 0x82, 0x02, 0x48, 0xfd,
-  0xb8, 0x8d, 0xd3, 0xd3, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x39,
-  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
-  0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
-  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x01, 0x21, 0x15, 0x21, 0x15, 0x06,
-  0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35,
-  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01,
-  0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff,
-  0x01, 0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3,
-  0x01, 0x6f, 0x02, 0x03, 0xfe, 0x98, 0x03, 0x39, 0x1b, 0x9f, 0xba, 0xc0,
-  0xab, 0x39, 0x78, 0x4f, 0x55, 0x6c, 0x3d, 0x5d, 0x6a, 0x6a, 0x5d, 0x2d,
-  0x5b, 0x50, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f,
-  0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70,
-  0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x01,
-  0x19, 0x8e, 0xab, 0x01, 0x0a, 0xb0, 0x95, 0x98, 0xac, 0x14, 0x18, 0xac,
-  0x2f, 0x1b, 0x61, 0x55, 0x56, 0x61, 0x14, 0x25, 0x00, 0x04, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x27,
-  0x00, 0x40, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
-  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x05, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01,
-  0x23, 0x22, 0x06, 0x07, 0x06, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x12, 0x33, 0x32, 0x16, 0x05, 0xec, 0xfe,
-  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
-  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
-  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x02, 0x5d, 0x46,
-  0x53, 0x53, 0x46, 0x46, 0x53, 0x53, 0xbf, 0x4b, 0x58, 0x2a, 0x6b, 0x72,
-  0x05, 0x08, 0x73, 0x46, 0x90, 0xa8, 0xaf, 0x90, 0xa6, 0xad, 0xd2, 0xb4,
-  0x30, 0x60, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f,
-  0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70,
-  0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x9f,
-  0x62, 0x5b, 0x5a, 0x62, 0x62, 0x5a, 0x5b, 0x62, 0x01, 0x9d, 0x9c, 0x23,
-  0x16, 0x94, 0x50, 0x0b, 0x3d, 0xb1, 0x94, 0x91, 0xb3, 0xfd, 0xe7, 0xda,
-  0x01, 0x0b, 0x13, 0x00, 0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
-  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x22, 0x00, 0x00, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
-  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22,
-  0x04, 0x02, 0x01, 0x21, 0x15, 0x01, 0x23, 0x01, 0x21, 0x05, 0xec, 0xfe,
-  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
-  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
-  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x01, 0x46, 0x02,
-  0x67, 0xfe, 0xb8, 0xad, 0x01, 0x2f, 0xfe, 0x5f, 0x02, 0xea, 0xfe, 0xc1,
-  0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe,
-  0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01,
-  0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x01, 0x19, 0x4b, 0xfc, 0xa3, 0x03, 0x1a,
-  0x00, 0x05, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
-  0x00, 0x1b, 0x00, 0x27, 0x00, 0x3f, 0x00, 0x4b, 0x00, 0x00, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
-  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22,
-  0x04, 0x02, 0x05, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x25, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c,
-  0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67,
-  0x00, 0xff, 0x01, 0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe,
-  0xd9, 0xa3, 0x02, 0x6a, 0x4c, 0x55, 0x55, 0x4c, 0x4b, 0x56, 0x56, 0xfe,
-  0xe6, 0x04, 0x5f, 0xa4, 0x8e, 0x8d, 0xa4, 0x5f, 0x03, 0x0d, 0x6a, 0xaa,
-  0x9c, 0x9c, 0xab, 0x6a, 0x4f, 0x48, 0x46, 0x43, 0x4a, 0x4a, 0x43, 0x46,
-  0x48, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6,
-  0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01,
-  0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0xe6, 0x50,
-  0x49, 0x49, 0x50, 0x51, 0x48, 0x49, 0x50, 0x49, 0x01, 0x76, 0x53, 0x74,
-  0x88, 0x88, 0x74, 0x53, 0x76, 0x01, 0x03, 0x83, 0x5c, 0x8a, 0x97, 0x97,
-  0x8a, 0x5c, 0x83, 0xc1, 0x3d, 0x42, 0x42, 0x3d, 0x3e, 0x42, 0x42, 0x00,
-  0x00, 0x04, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
-  0x00, 0x1b, 0x00, 0x34, 0x00, 0x40, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02,
-  0x01, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x36, 0x06, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x02, 0x23, 0x22,
-  0x26, 0x13, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x16, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9,
-  0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00,
-  0xff, 0x01, 0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9,
-  0xa3, 0x01, 0x68, 0x4c, 0x57, 0x2a, 0x6b, 0x72, 0x05, 0x09, 0x74, 0x47,
-  0x8f, 0xa7, 0xae, 0x90, 0xa7, 0xac, 0xd2, 0xb4, 0x30, 0x60, 0xc3, 0x47,
-  0x52, 0x52, 0x47, 0x46, 0x53, 0x53, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41,
-  0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8,
-  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
-  0xb1, 0xfe, 0xb9, 0xfd, 0x8b, 0x9c, 0x24, 0x15, 0x93, 0x4f, 0x0d, 0x3c,
-  0xaf, 0x94, 0x91, 0xb4, 0xfd, 0xe8, 0xda, 0xfe, 0xf6, 0x13, 0x01, 0xb4,
-  0x62, 0x5b, 0x5b, 0x62, 0x62, 0x5b, 0x5b, 0x62, 0x00, 0x05, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x26,
-  0x00, 0x32, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x13, 0x33,
-  0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x01, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x05, 0xec, 0xfe,
-  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
-  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
-  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0xb8, 0x8e, 0x9b,
-  0xaa, 0x69, 0x8f, 0xfe, 0x6b, 0x02, 0xb7, 0x3a, 0x3e, 0x3e, 0x3a, 0x39,
-  0x3e, 0x3e, 0x39, 0x75, 0x7a, 0x7a, 0x75, 0x76, 0x7b, 0x7b, 0x02, 0xea,
-  0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6,
-  0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c,
-  0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0xfe, 0x3e, 0x02, 0x3e, 0x27,
-  0x89, 0x2a, 0xfd, 0x36, 0x80, 0x02, 0xde, 0x97, 0xa3, 0xa2, 0x97, 0x97,
-  0xa2, 0xa3, 0x97, 0x7b, 0xe4, 0xd1, 0xd0, 0xe4, 0xe4, 0xd0, 0xd1, 0xe4,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x12, 0x04, 0x7a, 0x01, 0xf0, 0xac,
-  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68,
-  0x02, 0xf2, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x04,
-  0x7a, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x00, 0x00, 0x01, 0x01, 0xe2,
-  0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x11, 0x01, 0xe2, 0x90, 0xfd, 0x96, 0x0a, 0x32, 0xf5, 0xce, 0x00,
-  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x01, 0x20, 0xfd, 0x96,
-  0x0a, 0x32, 0xf5, 0xce, 0x00, 0x03, 0xff, 0xee, 0x01, 0xf0, 0x04, 0x68,
-  0x02, 0x9c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35,
-  0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x03, 0x52,
-  0x01, 0x16, 0xfd, 0x3d, 0x01, 0x0b, 0xfd, 0x3e, 0x01, 0x15, 0x01, 0xf0,
-  0xac, 0xac, 0xac, 0xac, 0xac, 0xac, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee,
-  0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x03, 0x52, 0x01, 0x16, 0xfd, 0x3d, 0x01, 0x0b, 0xfd, 0x3e,
-  0x01, 0x15, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58, 0xfe, 0xa8,
-  0x01, 0x58, 0xfe, 0xa8, 0x00, 0x03, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73,
-  0x07, 0xc8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x01, 0xe2,
-  0x90, 0x90, 0x90, 0x90, 0x90, 0xfd, 0x96, 0x03, 0x0c, 0xfc, 0xf4, 0x03,
-  0xc0, 0x02, 0xb2, 0xfd, 0x4e, 0x03, 0x66, 0x03, 0x0c, 0xfc, 0xf4, 0x00,
-  0x00, 0x03, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11,
-  0x21, 0x11, 0x01, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x01, 0x20, 0xfe, 0xe0,
-  0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20, 0xfd, 0x96, 0x03, 0x0c, 0xfc, 0xf4,
-  0x03, 0xc0, 0x02, 0xb2, 0xfd, 0x4e, 0x03, 0x66, 0x03, 0x0c, 0xfc, 0xf4,
-  0x00, 0x04, 0xff, 0xed, 0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x35, 0x33, 0x15,
-  0x33, 0x35, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15,
-  0x13, 0xa9, 0xa2, 0xa1, 0xa2, 0xa1, 0xa2, 0xaa, 0x01, 0xf0, 0xac, 0xac,
-  0xac, 0xac, 0xac, 0xac, 0xac, 0xac, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
-  0x01, 0x9a, 0x04, 0x69, 0x02, 0xf2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x00, 0x03, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x12, 0xa9, 0xa2, 0xa1,
-  0xa2, 0xa0, 0xa2, 0xab, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58,
-  0xfe, 0xa8, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58, 0xfe, 0xa8, 0x00, 0x00,
-  0x00, 0x04, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
-  0x03, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
-  0x01, 0xe2, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x05, 0x96, 0x02,
-  0x32, 0xfd, 0xce, 0xf8, 0x00, 0x02, 0x32, 0xfd, 0xce, 0x05, 0x73, 0x01,
-  0xd9, 0xfe, 0x27, 0xfd, 0x73, 0x01, 0xd9, 0xfe, 0x27, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
-  0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11,
-  0x01, 0x9a, 0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20,
-  0xfe, 0xe0, 0x01, 0x20, 0x05, 0x96, 0x02, 0x32, 0xfd, 0xce, 0xf8, 0x00,
-  0x02, 0x32, 0xfd, 0xce, 0x05, 0x73, 0x01, 0xd9, 0xfe, 0x27, 0xfd, 0x73,
-  0x01, 0xd9, 0xfe, 0x27, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
-  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x01, 0xe2, 0x02, 0x86, 0xfe, 0x0a, 0xfd, 0x96, 0x05, 0x06, 0xac, 0xfb,
-  0xa6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
-  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x01, 0xe2, 0x02, 0x86, 0xfe, 0x0a, 0xfd, 0x96, 0x05, 0x5c, 0xfe, 0xa8,
-  0xfb, 0xfc, 0x00, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
-  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x01, 0x9a, 0x02, 0xce, 0xfe, 0x52, 0xfd, 0x96, 0x05, 0x06, 0xac, 0xfb,
-  0xa6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
-  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x01, 0x9a, 0x02, 0xce, 0xfe, 0x52, 0xfd, 0x96, 0x05, 0x5c, 0xfe, 0xa8,
-  0xfb, 0xfc, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73,
-  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x01, 0xe2, 0xfe, 0x0c, 0x02, 0x84, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xfa,
-  0xfa, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73,
-  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x01, 0xe2, 0xfe, 0x0c, 0x02, 0x84, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58,
-  0xfa, 0xa4, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
-  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x01, 0x9a, 0xfe, 0x54, 0x02, 0xcc, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xfa,
-  0xfa, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
-  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x01, 0x9a, 0xfe, 0x54, 0x02, 0xcc, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58,
-  0xfa, 0xa4, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0x01, 0xf0, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15,
-  0x01, 0xe2, 0x90, 0x01, 0xf6, 0x01, 0xf0, 0x05, 0xd8, 0xfa, 0xd4, 0xac,
-  0x00, 0x01, 0x01, 0xe2, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x01, 0xe2, 0x90, 0x01,
-  0xf6, 0x01, 0x9a, 0x06, 0x2e, 0xfb, 0x2a, 0xfe, 0xa8, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x9a, 0x01, 0xf0, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x01, 0x9a, 0x01, 0x20,
-  0x01, 0xae, 0x01, 0xf0, 0x05, 0xd8, 0xfa, 0xd4, 0xac, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x9a, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x01, 0x20,
-  0x01, 0xae, 0x01, 0x9a, 0x06, 0x2e, 0xfb, 0x2a, 0xfe, 0xa8, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x05,
-  0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x12, 0x01, 0xf4, 0x90,
-  0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa, 0x28, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x01, 0x9a, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x05, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x33, 0x11, 0x12, 0x01, 0xf4, 0x90, 0x01, 0x9a, 0x01, 0x58,
-  0x04, 0xd6, 0xf9, 0xd2, 0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0xbb,
-  0x07, 0xc8, 0x00, 0x05, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x12, 0x01, 0xac, 0x01, 0x20, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa, 0x28,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x05,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x21, 0x11, 0x12, 0x01, 0xac, 0x01,
-  0x20, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xf9, 0xd2, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2,
-  0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x0a, 0x32, 0xfa, 0xd4, 0xac,
-  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0xe2, 0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x0a,
-  0x32, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0x01, 0x9a,
-  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0x48, 0x01,
-  0x20, 0x01, 0xae, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0x05, 0xd8, 0xfa,
-  0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x01, 0x9a, 0x48, 0x90, 0x01, 0xf6, 0xfe, 0x52,
-  0xfd, 0x96, 0x05, 0x06, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00,
-  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a,
-  0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96, 0x0a, 0x32, 0xfa, 0xd4,
-  0xac, 0xfb, 0xa6, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x01, 0xe2, 0x48, 0x01, 0x20, 0x01, 0xae, 0xfe,
-  0x0a, 0xfd, 0x96, 0x04, 0x04, 0x06, 0x2e, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb,
-  0xfc, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x48, 0x90, 0x01, 0xf6, 0xfe, 0x52,
-  0xfd, 0x96, 0x05, 0x5c, 0x04, 0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc,
-  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a,
-  0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96, 0x0a, 0x32, 0xfb, 0x2a,
-  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73,
-  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x33, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0x90, 0xfd, 0x96, 0x04,
-  0x5a, 0xac, 0x05, 0x2c, 0xf5, 0xce, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4,
-  0x90, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xf5, 0xce, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11,
-  0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xac, 0x01, 0x20, 0x48, 0xfd, 0x96, 0x04,
-  0x5a, 0xac, 0x05, 0x2c, 0xfa, 0x28, 0xfb, 0xa6, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x01, 0x9a, 0xfe, 0x54,
-  0x01, 0xf4, 0x90, 0x48, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xfa,
-  0xd4, 0xfa, 0xfa, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
-  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0xfd, 0x96,
-  0x04, 0x5a, 0xac, 0x05, 0x2c, 0xf5, 0xce, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x01, 0xe2, 0xfe, 0x0c,
-  0x01, 0xac, 0x01, 0x20, 0x48, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04,
-  0xd6, 0xf9, 0xd2, 0xfb, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x01, 0x9a, 0xfe, 0x54,
-  0x01, 0xf4, 0x90, 0x48, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6,
-  0xfb, 0x2a, 0xfa, 0xa4, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
-  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0xfd, 0x96,
-  0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xf5, 0xce, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x04, 0x7a,
-  0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xac, 0xfb, 0xa6, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11,
-  0x01, 0xe2, 0xfe, 0x0c, 0x02, 0x84, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96,
-  0x04, 0x04, 0x01, 0x58, 0x56, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c,
-  0x01, 0xf4, 0x02, 0x86, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x56,
-  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x02, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x04, 0x7a, 0xfe, 0x0a, 0xfd, 0x96,
-  0x04, 0x04, 0x01, 0x58, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x04, 0x7a,
-  0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xac, 0xfb, 0xa6, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11,
-  0x01, 0x9a, 0xfe, 0x54, 0x02, 0xcc, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96,
-  0x04, 0x04, 0x01, 0x58, 0x56, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54,
-  0x01, 0xac, 0x02, 0xce, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x56,
-  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x02, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x04, 0x7a, 0xfe, 0x52, 0xfd, 0x96,
-  0x04, 0x04, 0x01, 0x58, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee,
-  0x01, 0xf0, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x03, 0x35,
-  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x01, 0xf4, 0x90, 0x01, 0xf6,
-  0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x01, 0xff, 0xee,
-  0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x12, 0x01, 0xf4, 0x90,
-  0x01, 0xf6, 0xfe, 0x0a, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfa, 0xd4,
-  0xac, 0x56, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x21, 0x35, 0x12, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfd, 0x7a,
-  0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0x56, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x12, 0x01,
-  0xf4, 0x90, 0x01, 0xf6, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a,
-  0xfe, 0xa8, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x15, 0x12, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0x01, 0xf0, 0xac,
-  0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x12, 0x01, 0xac, 0x01,
-  0x20, 0x01, 0xae, 0xfe, 0x52, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfa,
-  0xd4, 0xac, 0x56, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x21, 0x35, 0x12, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0xfd,
-  0x32, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0x56, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x12, 0x01,
-  0xac, 0x01, 0x20, 0x01, 0xae, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfb,
-  0x2a, 0xfe, 0xa8, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x02, 0x72, 0x90, 0xfe, 0x0c, 0x01,
-  0xf4, 0x90, 0x01, 0xf6, 0x01, 0xf0, 0xfb, 0xa6, 0x04, 0x5a, 0xac, 0x05,
-  0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4,
-  0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04,
-  0xd6, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0xe2,
-  0xfe, 0x0c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x04,
-  0x5a, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe,
-  0x0a, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a, 0xfe,
-  0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xac,
-  0x01, 0x20, 0x01, 0xae, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05,
-  0x2c, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a,
-  0xfe, 0x54, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe, 0x52, 0xfd, 0x96, 0x04,
-  0x5a, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x21, 0x15,
-  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae,
-  0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0xac,
-  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x23, 0x11, 0x01, 0xe2, 0xfe, 0x0c,
-  0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0x48, 0xfd, 0x96, 0x04,
-  0x04, 0x01, 0x58, 0x04, 0xd6, 0xfa, 0xd4, 0xac, 0x56, 0xfb, 0xfc, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x35, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x01, 0xe2, 0x48, 0xfe, 0x54, 0x01, 0xac, 0x01,
-  0x20, 0x01, 0xae, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x04, 0x56, 0xac, 0x05,
-  0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x21, 0x15, 0x21, 0x11,
-  0x01, 0x9a, 0xfe, 0x54, 0x01, 0xf4, 0x90, 0x48, 0x01, 0xae, 0xfe, 0x52,
-  0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a, 0x56, 0xac,
-  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35,
-  0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54,
-  0x01, 0xac, 0x48, 0x90, 0x01, 0xf6, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a,
-  0xac, 0x56, 0x04, 0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae,
-  0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a,
-  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xf4,
-  0x90, 0x01, 0xf6, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04,
-  0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a,
-  0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96,
-  0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae,
-  0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe,
-  0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac,
-  0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58,
-  0x04, 0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x02, 0xff, 0xee,
-  0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x03, 0x35, 0x21, 0x15, 0x33, 0x35, 0x21, 0x15, 0x12, 0x01, 0xf4, 0x90,
-  0x01, 0xf6, 0x01, 0xf0, 0xac, 0xac, 0xac, 0xac, 0x00, 0x02, 0xff, 0xee,
-  0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x02, 0x72, 0x01, 0xf6,
-  0xfb, 0x86, 0x01, 0xf4, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58,
-  0xfe, 0xa8, 0x00, 0x00, 0x00, 0x02, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73,
-  0x07, 0xc8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
-  0x03, 0x11, 0x33, 0x11, 0x01, 0xe2, 0x90, 0x90, 0x90, 0x02, 0xf2, 0x04,
-  0xd6, 0xfb, 0x2a, 0xfa, 0xa4, 0x04, 0x04, 0xfb, 0xfc, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11,
-  0x01, 0x9a, 0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20, 0x02, 0xf2, 0x04, 0xd6,
-  0xfb, 0x2a, 0xfa, 0xa4, 0x04, 0x04, 0xfb, 0xfc, 0x00, 0x02, 0xff, 0xee,
-  0x01, 0x44, 0x04, 0x68, 0x03, 0x48, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x03, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x12, 0x04, 0x7a, 0xfb,
-  0x86, 0x04, 0x7a, 0x02, 0x9c, 0xac, 0xac, 0xfe, 0xa8, 0xac, 0xac, 0x00,
-  0x00, 0x02, 0x01, 0x52, 0xfd, 0x96, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x01, 0x52, 0x90, 0x90, 0x90, 0xfd, 0x96, 0x0a, 0x32, 0xf5, 0xce, 0x0a,
-  0x32, 0xf5, 0xce, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
-  0x03, 0x48, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x15,
-  0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0x02, 0x86, 0xfe, 0x0a, 0x01, 0xf6,
-  0xfe, 0x0a, 0xfd, 0x96, 0x05, 0xb2, 0xac, 0xac, 0xac, 0xfc, 0x52, 0x00,
-  0x00, 0x01, 0x01, 0x52, 0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11,
-  0x01, 0x52, 0x03, 0x16, 0xfe, 0x9a, 0x90, 0x90, 0xfd, 0x96, 0x05, 0x06,
-  0xac, 0xfb, 0xa6, 0x04, 0x5a, 0xfb, 0xa6, 0x00, 0x00, 0x02, 0x01, 0x52,
-  0xfd, 0x96, 0x04, 0x68, 0x03, 0x48, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00,
-  0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x01, 0x52, 0x03, 0x16, 0xfd, 0x7a, 0x90, 0x01, 0xf6, 0xfe, 0x9a, 0xfd,
-  0x96, 0x05, 0xb2, 0xac, 0xfa, 0xfa, 0x04, 0x5a, 0xac, 0xfc, 0x52, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73, 0x03, 0x48, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11,
-  0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0xfe, 0x0c, 0x02, 0x84, 0xfd, 0x96,
-  0x03, 0xae, 0xac, 0xac, 0xac, 0xfa, 0x4e, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x03, 0x03, 0x02, 0x9c, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35,
-  0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x12, 0x03, 0x14, 0x90,
-  0x90, 0x90, 0x01, 0xf0, 0xac, 0xfa, 0xfa, 0x04, 0x5a, 0xfb, 0xa6, 0x04,
-  0x5a, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0xfd, 0x96, 0x03, 0x03,
-  0x03, 0x48, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x02, 0x72, 0xfd, 0x7c,
-  0x03, 0x14, 0xfe, 0x50, 0xfe, 0x9c, 0x01, 0xf4, 0xfd, 0x96, 0x05, 0x06,
-  0xac, 0xfa, 0x4e, 0x03, 0xae, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0x01, 0xe2,
-  0x01, 0x44, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x01, 0xe2, 0x90, 0x01,
-  0xf6, 0xfe, 0x0a, 0x01, 0xf6, 0x01, 0x44, 0x06, 0x84, 0xfb, 0x80, 0xac,
-  0xac, 0xac, 0x00, 0x00, 0x00, 0x01, 0x01, 0x52, 0x01, 0xf0, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x01, 0x52, 0x90, 0x90, 0x90, 0x01, 0x66, 0x01,
-  0xf0, 0x05, 0xd8, 0xfa, 0xd4, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x52, 0x01, 0x44, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
-  0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15, 0x01, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x02, 0x72, 0x90, 0x01, 0x66, 0xfc, 0xea, 0x90,
-  0x02, 0x86, 0x02, 0x9c, 0x05, 0x2c, 0xfb, 0x80, 0xac, 0xfe, 0xa8, 0x06,
-  0x84, 0xfa, 0x28, 0xac, 0x00, 0x01, 0xff, 0xee, 0x01, 0x44, 0x02, 0x73,
-  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35, 0x21, 0x35, 0x21, 0x35,
-  0x21, 0x11, 0x33, 0x11, 0x12, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0xf4, 0x90,
-  0x01, 0x44, 0xac, 0xac, 0xac, 0x04, 0x80, 0xf9, 0x7c, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x09,
-  0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x12, 0x01, 0x64, 0x90, 0x90, 0x90, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa,
-  0xd4, 0x05, 0x2c, 0xfa, 0x28, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0x01, 0x44, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00,
-  0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x12, 0x01, 0x64, 0x90, 0xfe, 0x0c, 0x02, 0x84, 0x90, 0x02, 0x9c, 0xac,
-  0x04, 0x80, 0xfa, 0xd4, 0xfe, 0xa8, 0xac, 0x05, 0xd8, 0xf9, 0x7c, 0x00,
-  0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15,
-  0x21, 0x11, 0x01, 0xe2, 0x90, 0x01, 0xf6, 0xfe, 0x0a, 0x01, 0xf6, 0xfe,
-  0x0a, 0xfd, 0x96, 0x0a, 0x32, 0xfb, 0x80, 0xac, 0xac, 0xac, 0xfc, 0x52,
-  0x00, 0x02, 0x01, 0x52, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x03,
-  0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x01, 0x52, 0x90, 0x90, 0x90, 0x01, 0x66, 0xfe,
-  0x9a, 0xfd, 0x96, 0x0a, 0x32, 0xf5, 0xce, 0x0a, 0x32, 0xfa, 0xd4, 0xac,
-  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x03, 0x01, 0x52, 0xfd, 0x96, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15,
-  0x21, 0x11, 0x02, 0x72, 0x90, 0x01, 0x66, 0xfc, 0xea, 0x90, 0x90, 0x01,
-  0xf6, 0xfe, 0x9a, 0x02, 0x9c, 0x05, 0x2c, 0xfb, 0x80, 0xac, 0xfa, 0xfa,
-  0x0a, 0x32, 0xf5, 0xce, 0x04, 0x5a, 0xac, 0xfc, 0x52, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11,
-  0x33, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0xf4,
-  0x90, 0xfd, 0x96, 0x03, 0xae, 0xac, 0xac, 0xac, 0x04, 0x80, 0xf5, 0xce,
-  0x00, 0x02, 0xff, 0xee, 0xfd, 0x96, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x33, 0x11, 0x01, 0x52, 0xfe, 0x9c, 0x01, 0x64, 0x90, 0x90,
-  0x90, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xf5, 0xce, 0x0a, 0x32,
-  0xf5, 0xce, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee, 0xfd, 0x96, 0x03, 0x03,
-  0x07, 0xc8, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x35,
-  0x21, 0x11, 0x33, 0x11, 0x03, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x12, 0x01, 0x64, 0x90, 0x90, 0xfe, 0x9c, 0x01, 0xf4, 0x90,
-  0x90, 0x02, 0x9c, 0xac, 0x04, 0x80, 0xfa, 0xd4, 0xfa, 0xfa, 0x03, 0xae,
-  0xac, 0xfb, 0xa6, 0x0a, 0x32, 0xf5, 0xce, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x03, 0x48, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00,
-  0x01, 0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x01, 0x35, 0x21, 0x15,
-  0x01, 0xe2, 0xfe, 0x0c, 0x04, 0x7a, 0xfe, 0x0a, 0xfd, 0x7c, 0x04, 0x7a,
-  0xfd, 0x96, 0x03, 0xae, 0xac, 0xac, 0xfc, 0x52, 0x05, 0x06, 0xac, 0xac,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x0b,
-  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11,
-  0x23, 0x11, 0x12, 0x04, 0x7a, 0xfe, 0x9a, 0x90, 0x90, 0x90, 0x01, 0xf0,
-  0xac, 0xac, 0xfb, 0xa6, 0x04, 0x5a, 0xfb, 0xa6, 0x04, 0x5a, 0x00, 0x00,
-  0x00, 0x03, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x03, 0x48, 0x00, 0x03,
-  0x00, 0x09, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x12, 0x04,
-  0x7a, 0xfc, 0xea, 0xfe, 0x9c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe, 0x9a,
-  0x02, 0x9c, 0xac, 0xac, 0xfa, 0xfa, 0x03, 0xae, 0xac, 0xfb, 0xa6, 0x04,
-  0x5a, 0xac, 0xfc, 0x52, 0x00, 0x02, 0xff, 0xee, 0x01, 0x44, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x03, 0x35, 0x21, 0x15,
-  0x01, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x04, 0x7a, 0xfb,
-  0x86, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0x01, 0x44, 0xac, 0xac, 0x01, 0x58,
-  0xac, 0x04, 0x80, 0xfb, 0x80, 0xac, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x01, 0xf0, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x03, 0x35,
-  0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x01,
-  0x64, 0x90, 0x90, 0x90, 0x01, 0x66, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa,
-  0xd4, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee,
-  0x01, 0x44, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x09, 0x00, 0x0f,
-  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x04, 0x7a, 0xfb, 0x86, 0x01,
-  0x64, 0x90, 0x90, 0x90, 0x01, 0x66, 0x01, 0x44, 0xac, 0xac, 0x01, 0x58,
-  0xac, 0x04, 0x80, 0xfa, 0xd4, 0x05, 0x2c, 0xfb, 0x80, 0xac, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2,
-  0xfe, 0x0c, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe,
-  0x0a, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x03, 0xae, 0xac, 0xac, 0xac,
-  0x04, 0x80, 0xfb, 0x80, 0xac, 0xac, 0xac, 0xfc, 0x52, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x13,
-  0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x12, 0x01,
-  0x64, 0x90, 0x90, 0x90, 0x01, 0x66, 0xfe, 0x9a, 0x90, 0x90, 0x90, 0x01,
-  0xf0, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0xfb,
-  0xa6, 0x04, 0x5a, 0xfb, 0xa6, 0x04, 0x5a, 0x00, 0x00, 0x04, 0xff, 0xee,
-  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x11,
-  0x00, 0x17, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x01, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x02, 0x72, 0x01, 0xf6, 0xfe, 0x9a, 0xfe, 0x50,
-  0xfe, 0x9c, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0x64, 0x90, 0x90, 0x90, 0x01,
-  0x66, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xfc, 0x52, 0x03, 0xae, 0xac, 0xfb,
-  0xa6, 0x05, 0x06, 0xac, 0x04, 0x80, 0xfa, 0xd4, 0x05, 0x2c, 0xfb, 0x80,
-  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
-  0x02, 0x9c, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x11, 0x34, 0x37, 0x36, 0x33,
-  0x21, 0x15, 0x21, 0x22, 0x06, 0x15, 0x11, 0x01, 0xe2, 0x49, 0x52, 0x97,
-  0x01, 0x54, 0xfe, 0xac, 0x50, 0x52, 0xfd, 0x96, 0x03, 0x60, 0xa1, 0x7f,
-  0x86, 0xac, 0x7e, 0x7c, 0xfc, 0xa0, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfd, 0x96, 0x02, 0x73, 0x02, 0x9c, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11,
-  0x34, 0x27, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11,
-  0x01, 0xe2, 0x29, 0x29, 0x50, 0xfe, 0xae, 0x01, 0x52, 0x98, 0x51, 0x49,
-  0xfd, 0x96, 0x03, 0x60, 0x7e, 0x3d, 0x3f, 0xac, 0x86, 0x78, 0xa8, 0xfc,
-  0xa0, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0x73,
-  0x07, 0xc8, 0x00, 0x0c, 0x00, 0x00, 0x03, 0x35, 0x21, 0x32, 0x36, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x12, 0x01, 0x52, 0x50, 0x52,
-  0x90, 0x49, 0x51, 0x98, 0x01, 0xf0, 0xac, 0x7e, 0x7c, 0x04, 0x32, 0xfb,
-  0xce, 0xa8, 0x78, 0x86, 0x00, 0x01, 0x01, 0xe2, 0x01, 0xf0, 0x04, 0x68,
-  0x07, 0xc8, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x21, 0x22, 0x27, 0x26, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x21, 0x04, 0x68, 0xfe, 0xac, 0x97,
-  0x52, 0x49, 0x90, 0x52, 0x50, 0x01, 0x54, 0x01, 0xf0, 0x86, 0x78, 0xa8,
-  0x04, 0x32, 0xfb, 0xce, 0x7c, 0x7e, 0x00, 0x00, 0x00, 0x01, 0xff, 0x9d,
-  0xfd, 0x96, 0x04, 0xb8, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x03, 0x01,
-  0x33, 0x01, 0x62, 0x04, 0x7a, 0xa0, 0xfb, 0x86, 0xfd, 0x96, 0x0a, 0x32,
-  0xf5, 0xce, 0x00, 0x00, 0x00, 0x01, 0xff, 0x9d, 0xfd, 0x96, 0x04, 0xb8,
-  0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x23, 0x01, 0x33, 0x04, 0xb8,
-  0xa0, 0xfb, 0x86, 0xa0, 0xfd, 0x96, 0x0a, 0x32, 0x00, 0x01, 0xff, 0x9d,
-  0xfd, 0x96, 0x04, 0xb8, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23,
-  0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01, 0x33, 0x01, 0x04, 0xb8,
-  0xa0, 0xfe, 0x12, 0xfe, 0x14, 0xa0, 0x02, 0x3d, 0xfd, 0xc3, 0xa0, 0x01,
-  0xec, 0x01, 0xee, 0xa0, 0xfd, 0xc3, 0xfd, 0x96, 0x04, 0x63, 0xfb, 0x9d,
-  0x05, 0x19, 0x05, 0x19, 0xfb, 0x9d, 0x04, 0x63, 0xfa, 0xe7, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0x3d, 0x02, 0x9c, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x12, 0x02, 0x4e, 0x01, 0xf0, 0xac,
-  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0x02, 0x46, 0x02, 0x73,
-  0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x01, 0xe2,
-  0x90, 0x02, 0x46, 0x05, 0x82, 0xfa, 0x7e, 0x00, 0x00, 0x01, 0x02, 0x3c,
-  0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03, 0x00, 0x00, 0x01, 0x35,
-  0x21, 0x15, 0x02, 0x3c, 0x02, 0x2c, 0x01, 0xf0, 0xac, 0xac, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73, 0x02, 0x46, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x01, 0xe2, 0x90, 0xfd, 0x96, 0x04,
-  0xb0, 0xfb, 0x50, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x02, 0x3d,
-  0x02, 0xf2, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x02,
-  0x4e, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x00, 0x00, 0x01, 0x01, 0x9a,
-  0x02, 0x46, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x01, 0x9a, 0x01, 0x20, 0x02, 0x46, 0x05, 0x82, 0xfa, 0x7e,
-  0x00, 0x01, 0x02, 0x3c, 0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x02, 0x3c, 0x02, 0x2c, 0x01, 0x9a,
-  0x01, 0x58, 0xfe, 0xa8, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb,
-  0x02, 0x46, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x9a,
-  0x01, 0x20, 0xfd, 0x96, 0x04, 0xb0, 0xfb, 0x50, 0x00, 0x01, 0xff, 0xee,
-  0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x03, 0x35,
-  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x12, 0x02, 0x4e, 0x02, 0x2c, 0xfd,
-  0xd4, 0x01, 0xf0, 0xac, 0x56, 0xfe, 0xa8, 0x56, 0x00, 0x01, 0x01, 0x9a,
-  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x01, 0x9a, 0x48, 0x90, 0x48, 0xfd,
-  0x96, 0x04, 0xb0, 0x05, 0x82, 0xfa, 0x7e, 0xfb, 0x50, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x07,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x12, 0x02,
-  0x4e, 0x02, 0x2c, 0xfd, 0xd4, 0x01, 0x9a, 0x01, 0x58, 0x56, 0xac, 0x56,
-  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x01, 0xe2,
-  0x48, 0x01, 0x20, 0x48, 0xfd, 0x96, 0x04, 0xb0, 0x05, 0x82, 0xfa, 0x7e,
-  0xfb, 0x50, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x02, 0x14, 0x05, 0x9c,
-  0x06, 0x28, 0x10, 0x07, 0x0a, 0xad, 0x00, 0x00, 0x04, 0x14, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0xff, 0x05, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x01,
-  0x05, 0xfe, 0xfb, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
-  0xff, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05,
-  0xae, 0xfe, 0x00, 0x01, 0xf6, 0xfe, 0x0a, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x05, 0x9c, 0x01, 0x0f, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x03, 0x0f, 0xfc, 0xf1, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x02, 0x14, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x04,
-  0x14, 0xfb, 0xec, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
-  0x03, 0x19, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05,
-  0xae, 0xfe, 0x00, 0x05, 0x19, 0xfa, 0xe7, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x05, 0x9c, 0x04, 0x1e, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x06, 0x1e, 0xf9, 0xe2, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x05, 0x23, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x07,
-  0x23, 0xf8, 0xdd, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
-  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05,
-  0xae, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x04, 0xe6, 0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x12, 0x04, 0xf8, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x04, 0x30, 0x06, 0x28, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x04, 0x42, 0xfe, 0x00, 0x08,
-  0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x03, 0x7b,
-  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x03,
-  0x8c, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x02, 0xc5, 0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x12, 0x02, 0xd6, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x02, 0x0f, 0x06, 0x28, 0x00, 0x03,
-  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x02, 0x20, 0xfe, 0x00, 0x08,
-  0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x01, 0x59,
-  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x01,
-  0x6b, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x00, 0xa3, 0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
-  0x33, 0x11, 0x12, 0xb5, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00,
-  0xff, 0xff, 0x02, 0xc4, 0xfe, 0x00, 0x05, 0x9b, 0x06, 0x28, 0x10, 0x07,
-  0x0a, 0xb5, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0xff, 0xee,
-  0xfe, 0x00, 0x04, 0xe6, 0x06, 0x28, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23,
-  0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x33, 0x11, 0x13, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11,
-  0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x13, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11,
-  0x13, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x04, 0x30, 0xb6, 0xfc,
-  0x73, 0xb5, 0xb6, 0xb6, 0xfc, 0x74, 0xb5, 0x03, 0x8d, 0xb6, 0xfc, 0x73,
-  0xb5, 0xb6, 0xb6, 0xfc, 0x74, 0xb5, 0x03, 0x8d, 0xb6, 0xfc, 0x73, 0xb5,
-  0xb6, 0xb6, 0xfc, 0x74, 0xb5, 0xfe, 0x00, 0x01, 0x05, 0xfe, 0xfb, 0x01,
-  0x05, 0xfe, 0xfb, 0x01, 0x6d, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe,
-  0xfb, 0x01, 0x6e, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x01,
-  0x6d, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x6e, 0x01,
-  0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x6d, 0x01, 0x05, 0xfe,
-  0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x00, 0x00, 0x00, 0x00, 0x20, 0xff, 0xee,
-  0xfe, 0x00, 0x05, 0x96, 0x06, 0x28, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x17,
-  0x00, 0x1f, 0x00, 0x27, 0x00, 0x2f, 0x00, 0x37, 0x00, 0x3f, 0x00, 0x47,
-  0x00, 0x4f, 0x00, 0x57, 0x00, 0x5f, 0x00, 0x67, 0x00, 0x6f, 0x00, 0x77,
-  0x00, 0x7f, 0x00, 0x87, 0x00, 0x8f, 0x00, 0x97, 0x00, 0x9f, 0x00, 0xa7,
-  0x00, 0xaf, 0x00, 0xb7, 0x00, 0xbf, 0x00, 0xc7, 0x00, 0xcf, 0x00, 0xd7,
-  0x00, 0xdf, 0x00, 0xe7, 0x00, 0xef, 0x00, 0xf7, 0x00, 0xff, 0x00, 0x00,
-  0x13, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
-  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
-  0x35, 0x37, 0x33, 0x17, 0xa3, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
-  0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x04,
-  0x04, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfc,
-  0x78, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04,
-  0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x01,
-  0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfb, 0x0e, 0x05, 0xac, 0x04,
-  0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
-  0x69, 0x04, 0xac, 0x04, 0x04, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05,
-  0x05, 0xac, 0x04, 0xfc, 0x78, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
-  0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x05,
-  0x05, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfb,
-  0x0e, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04,
-  0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x04, 0x04, 0xac, 0x04, 0x01,
-  0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfc, 0x78, 0x05, 0xac, 0x04,
-  0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
-  0x69, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05,
-  0x05, 0xac, 0x04, 0xfb, 0x0e, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
-  0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x04,
-  0x04, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfc,
-  0x78, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04,
-  0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x01,
-  0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x05, 0x28, 0x05, 0x05, 0xfb,
-  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
-  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe, 0x00, 0x05, 0x05,
-  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
-  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe, 0x00, 0x05,
-  0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05,
-  0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe, 0x00,
-  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
-  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe,
-  0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
-  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
-  0xfe, 0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05,
-  0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05,
-  0x05, 0xfe, 0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
-  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
-  0x05, 0x05, 0xfe, 0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
-  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
-  0xfb, 0x05, 0x05, 0x00, 0x00, 0x07, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
-  0x06, 0x28, 0x00, 0x19, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x25, 0x00, 0x29,
-  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x03, 0x11, 0x33, 0x11, 0x23, 0x11,
-  0x33, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x19, 0x01, 0x33, 0x11, 0x23,
-  0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23,
-  0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0x12, 0xb5, 0xb5, 0xb5,
-  0xb5, 0xb5, 0x02, 0x21, 0xb6, 0x02, 0x22, 0xb6, 0xb6, 0xfd, 0xde, 0xb5,
-  0xb5, 0xb5, 0x02, 0xd7, 0xb6, 0xb6, 0xfe, 0x94, 0xb6, 0xb6, 0xfe, 0x95,
-  0xb5, 0xb5, 0x02, 0xd7, 0xb6, 0xb6, 0xfe, 0x94, 0xb6, 0xb6, 0xfe, 0x00,
-  0x01, 0x6d, 0x01, 0x05, 0x01, 0xd6, 0x01, 0x05, 0x01, 0xd6, 0x01, 0x05,
-  0xfe, 0xfb, 0x01, 0x05, 0xf7, 0xd8, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05,
-  0xfe, 0xfb, 0x05, 0xb6, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfd, 0x8d,
-  0x01, 0x05, 0xfd, 0x8e, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfd, 0x8d,
-  0x01, 0x05, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x05, 0x23, 0x05, 0x9c,
-  0x06, 0x28, 0x10, 0x07, 0x0a, 0xaa, 0x00, 0x00, 0x07, 0x23, 0x00, 0x00,
-  0xff, 0xff, 0x04, 0xe5, 0xfe, 0x00, 0x05, 0x9b, 0x06, 0x28, 0x10, 0x07,
-  0x0a, 0xb8, 0x04, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x02, 0xc6, 0x02, 0x14, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x12, 0x02, 0xd7, 0xfe, 0x00, 0x04, 0x14, 0xfb, 0xec, 0x00,
-  0x00, 0x01, 0x02, 0xc4, 0xfe, 0x00, 0x05, 0x9c, 0x02, 0x14, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x02, 0xc4, 0x02, 0xd8, 0xfe, 0x00,
-  0x04, 0x14, 0xfb, 0xec, 0x00, 0x01, 0xff, 0xee, 0x02, 0x14, 0x02, 0xc6,
-  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x02,
-  0xd7, 0x02, 0x14, 0x04, 0x14, 0xfb, 0xec, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x11, 0x21, 0x11, 0x21, 0x05, 0x9c, 0xfa, 0x52, 0x02, 0xd7, 0x02, 0xd7,
-  0xfe, 0x00, 0x08, 0x28, 0xfb, 0xec, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x07, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x12, 0x02, 0xd7, 0x02, 0xd7, 0xfd,
-  0x28, 0x02, 0x14, 0x04, 0x14, 0xfb, 0xec, 0xfb, 0xec, 0x04, 0x14, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x05, 0x9c, 0xfd, 0x29,
-  0xfd, 0x29, 0x06, 0x28, 0xfb, 0xec, 0xfb, 0xec, 0x08, 0x28, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05,
-  0x00, 0x00, 0x03, 0x21, 0x11, 0x21, 0x11, 0x21, 0x12, 0x05, 0xae, 0xfd,
-  0x28, 0xfd, 0x2a, 0x06, 0x28, 0xf7, 0xd8, 0x04, 0x14, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0xc4, 0x02, 0x14, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x02, 0xc4, 0x02, 0xd8, 0x02, 0x14,
-  0x04, 0x14, 0xfb, 0xec, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
-  0x06, 0x28, 0x00, 0x07, 0x00, 0x00, 0x03, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x11, 0x21, 0x12, 0x02, 0xd6, 0x02, 0xd8, 0xfd, 0x29, 0xfd, 0x29, 0x02,
-  0x14, 0x04, 0x14, 0xfb, 0xec, 0xfb, 0xec, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05, 0x00, 0x00, 0x03, 0x11,
-  0x21, 0x11, 0x21, 0x11, 0x12, 0x02, 0xd6, 0x02, 0xd8, 0xfe, 0x00, 0x04,
-  0x14, 0x04, 0x14, 0xf7, 0xd8, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x00, 0x17, 0x11,
-  0x21, 0x11, 0xa7, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
-  0x01, 0x0e, 0x04, 0xb2, 0xfb, 0x4e, 0x67, 0x05, 0x7f, 0x8a, 0x05, 0x3c,
-  0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
-  0x25, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x21, 0x22, 0x15,
-  0x03, 0x11, 0x10, 0x29, 0x01, 0x20, 0x19, 0x01, 0x10, 0x29, 0x01, 0x20,
-  0x01, 0x0e, 0xcd, 0x03, 0x17, 0xce, 0xce, 0xfc, 0xe9, 0xcd, 0x67, 0x01,
-  0x34, 0x03, 0x17, 0x01, 0x34, 0xfe, 0xcc, 0xfc, 0xe9, 0xfe, 0xcc, 0x5a,
-  0xe4, 0xe4, 0x03, 0x74, 0xe4, 0xe4, 0xfc, 0x8c, 0x03, 0x74, 0x01, 0x56,
-  0xfe, 0xaa, 0xfc, 0x8c, 0xfe, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x10, 0x27, 0x0a, 0xd3, 0x00, 0xf6,
-  0x00, 0x00, 0x10, 0x06, 0x0a, 0xca, 0x00, 0x00, 0x00, 0x06, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
-  0x25, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21,
-  0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0xa7, 0x05, 0x7f, 0xfa,
-  0xe8, 0x04, 0xb2, 0xfb, 0x4e, 0x04, 0xb2, 0xfb, 0x4e, 0x04, 0xb2, 0xfb,
-  0x4e, 0x04, 0xb2, 0xfb, 0x4e, 0x04, 0xb2, 0xfb, 0x4e, 0xfc, 0x06, 0x20,
-  0xf9, 0xe0, 0x72, 0xb0, 0x72, 0xb2, 0x72, 0xb0, 0x72, 0xb2, 0x72, 0xb0,
-  0x00, 0x06, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00,
-  0x17, 0x11, 0x21, 0x11, 0x25, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23,
-  0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23,
-  0xa7, 0x05, 0x7f, 0xfe, 0xfe, 0x9e, 0x9e, 0xfe, 0xf9, 0xa0, 0xa0, 0xfe,
-  0xfb, 0x9e, 0x9e, 0xfe, 0xf9, 0xa0, 0xa0, 0xfe, 0xfb, 0x9f, 0x9f, 0xfc,
-  0x06, 0x20, 0xf9, 0xe0, 0x74, 0x05, 0x38, 0xfa, 0xc8, 0x05, 0x38, 0xfa,
-  0xc8, 0x05, 0x38, 0xfa, 0xc8, 0x05, 0x38, 0xfa, 0xc8, 0x05, 0x38, 0x00,
-  0x00, 0x1a, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
-  0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33,
-  0x00, 0x37, 0x00, 0x3b, 0x00, 0x3f, 0x00, 0x43, 0x00, 0x47, 0x00, 0x4b,
-  0x00, 0x4f, 0x00, 0x53, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
-  0x00, 0x67, 0x00, 0x00, 0x05, 0x33, 0x35, 0x23, 0x05, 0x33, 0x35, 0x23,
-  0x05, 0x33, 0x35, 0x23, 0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
-  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
-  0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
-  0x11, 0x33, 0x35, 0x23, 0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
-  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x01, 0x33, 0x35, 0x23,
-  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
-  0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
-  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x01, 0x11, 0x21, 0x11,
-  0x02, 0x11, 0xa0, 0xa0, 0x01, 0x07, 0x9e, 0x9e, 0x01, 0x05, 0xa0, 0xa0,
-  0xfc, 0xf1, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d,
-  0x01, 0x03, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0x01, 0x07,
-  0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x01, 0x05, 0xa0, 0xa0,
-  0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0x01, 0x07, 0x9c, 0x9c, 0x9c, 0x9c,
-  0x9c, 0x9c, 0x9c, 0x9c, 0x9c, 0x9c, 0xfb, 0x83, 0x05, 0x7f, 0x88, 0xae,
-  0xae, 0xae, 0xae, 0xae, 0x03, 0xdc, 0xae, 0xfe, 0x2e, 0xb2, 0xfe, 0x2c,
-  0xb0, 0xfe, 0x2c, 0xb2, 0xfe, 0x2e, 0xae, 0x03, 0xdc, 0xae, 0xfe, 0x2e,
-  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0x02, 0xb8, 0xae, 0xfe, 0x2e,
-  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0x02, 0xb8, 0xae, 0xfe, 0x2e,
-  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0x02, 0xb8, 0xae, 0xfe, 0x2e,
-  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0xfe, 0x2e, 0xae, 0xfe, 0xde,
-  0x06, 0x20, 0xf9, 0xe0, 0x00, 0x08, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
-  0x05, 0x24, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x14,
-  0x00, 0x18, 0x00, 0x1c, 0x00, 0x1f, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
-  0x01, 0x15, 0x33, 0x03, 0x15, 0x01, 0x33, 0x01, 0x15, 0x01, 0x37, 0x01,
-  0x15, 0x01, 0x37, 0x35, 0x01, 0x33, 0x01, 0x35, 0x01, 0x33, 0x01, 0x35,
-  0x01, 0x33, 0x17, 0x35, 0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0xcb, 0xcb, 0x01,
-  0x5d, 0xe2, 0xfd, 0xc1, 0x02, 0xd1, 0xe2, 0xfc, 0x4d, 0x04, 0x45, 0x6d,
-  0xfb, 0xbb, 0x92, 0x03, 0xb3, 0xfd, 0x2f, 0x91, 0x02, 0x40, 0xfe, 0xa2,
-  0x92, 0xcc, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x01, 0x54, 0xe2, 0x02, 0x7f,
-  0xfc, 0xfe, 0x7d, 0x04, 0x1c, 0xfc, 0xfc, 0xdf, 0x01, 0x05, 0x3c, 0x7f,
-  0xfb, 0x42, 0x01, 0x7f, 0x04, 0xbd, 0xfb, 0xe4, 0xfc, 0x03, 0x20, 0xfd,
-  0x81, 0xfc, 0x01, 0x83, 0xe2, 0xe2, 0x00, 0x00, 0x00, 0x08, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a,
-  0x00, 0x0e, 0x00, 0x14, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x1f, 0x00, 0x00,
-  0x17, 0x11, 0x21, 0x11, 0x25, 0x33, 0x35, 0x05, 0x33, 0x01, 0x35, 0x01,
-  0x17, 0x01, 0x35, 0x01, 0x17, 0x01, 0x35, 0x23, 0x01, 0x35, 0x01, 0x23,
-  0x01, 0x35, 0x01, 0x23, 0x01, 0x35, 0x37, 0x23, 0xa7, 0x05, 0x7f, 0xfe,
-  0xce, 0xcc, 0xfd, 0xc0, 0xe2, 0x01, 0x5e, 0xfc, 0x4d, 0xe2, 0x02, 0xd1,
-  0xfb, 0x4e, 0x6d, 0x04, 0x45, 0x6d, 0xfb, 0xbb, 0x03, 0xb3, 0xe2, 0xfd,
-  0x2f, 0x02, 0x3f, 0xe2, 0xfe, 0xa3, 0xcb, 0xcb, 0xfc, 0x06, 0x20, 0xf9,
-  0xe0, 0x72, 0xe2, 0xe2, 0x01, 0x83, 0xfc, 0xfd, 0x81, 0x01, 0x03, 0x21,
-  0xfc, 0xfb, 0xe4, 0x01, 0x04, 0xbe, 0x7f, 0xfb, 0x43, 0xa1, 0x04, 0x1c,
-  0xfc, 0xe0, 0xa1, 0x02, 0x7f, 0xfe, 0x7d, 0xa1, 0xe2, 0x00, 0x00, 0x00,
-  0x00, 0x1a, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x04,
-  0x00, 0x09, 0x00, 0x0e, 0x00, 0x12, 0x00, 0x17, 0x00, 0x1c, 0x00, 0x20,
-  0x00, 0x24, 0x00, 0x28, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x39,
-  0x00, 0x3d, 0x00, 0x41, 0x00, 0x46, 0x00, 0x4b, 0x00, 0x4f, 0x00, 0x53,
-  0x00, 0x57, 0x00, 0x5c, 0x00, 0x61, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x6f,
-  0x00, 0x73, 0x00, 0x00, 0x01, 0x17, 0x37, 0x27, 0x23, 0x11, 0x17, 0x37,
-  0x27, 0x07, 0x01, 0x17, 0x37, 0x27, 0x23, 0x03, 0x17, 0x37, 0x27, 0x03,
-  0x17, 0x37, 0x27, 0x07, 0x01, 0x17, 0x37, 0x27, 0x23, 0x03, 0x17, 0x37,
-  0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37,
-  0x35, 0x23, 0x03, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17,
-  0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x03, 0x33,
-  0x37, 0x27, 0x07, 0x01, 0x17, 0x37, 0x35, 0x27, 0x01, 0x17, 0x37, 0x27,
-  0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x33, 0x37,
-  0x27, 0x01, 0x17, 0x37, 0x35, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17,
-  0x33, 0x37, 0x27, 0x05, 0x17, 0x33, 0x35, 0x27, 0x01, 0x11, 0x21, 0x11,
-  0x01, 0x0e, 0x2d, 0x70, 0x30, 0x6d, 0x2d, 0x71, 0x71, 0x2d, 0x01, 0x2e,
-  0x71, 0x71, 0x2f, 0x84, 0xe8, 0x71, 0x70, 0x71, 0xe5, 0x2d, 0x71, 0x71,
-  0x2d, 0x02, 0xa1, 0x72, 0x71, 0x30, 0x83, 0xe9, 0x71, 0x71, 0x71, 0xfe,
-  0xd6, 0x71, 0x70, 0x71, 0xfe, 0xd6, 0x71, 0x72, 0x72, 0x03, 0x2f, 0x70,
-  0x2d, 0x6d, 0xe9, 0x6f, 0x71, 0x6f, 0xfe, 0xd4, 0x70, 0x71, 0x6f, 0xfe,
-  0xd6, 0x70, 0x70, 0x70, 0xfe, 0xd6, 0x70, 0x71, 0x6f, 0xfe, 0xd4, 0x71,
-  0x70, 0x70, 0xe6, 0x6e, 0x2f, 0x70, 0x2d, 0x04, 0x14, 0x71, 0x2d, 0x2e,
-  0xfe, 0xd6, 0x71, 0x71, 0x71, 0xfe, 0xd6, 0x72, 0x6f, 0x71, 0xfe, 0xd7,
-  0x71, 0x72, 0x72, 0xfe, 0xd5, 0x2f, 0x85, 0x2e, 0x71, 0x02, 0x75, 0x70,
-  0x2e, 0x2e, 0xfe, 0xd7, 0x71, 0x70, 0x71, 0xfe, 0xd6, 0x2f, 0x84, 0x30,
-  0x71, 0x01, 0x02, 0x2f, 0x6e, 0x2e, 0xfb, 0x15, 0x05, 0x7f, 0x04, 0x33,
-  0x31, 0x7c, 0x34, 0xfd, 0xe4, 0x32, 0x7e, 0x7e, 0x31, 0x01, 0x4f, 0x7e,
-  0x7e, 0x34, 0xfe, 0xff, 0x7e, 0x7c, 0x7e, 0xfc, 0xcc, 0x31, 0x7e, 0x7d,
-  0x31, 0x02, 0xec, 0x7e, 0x7e, 0x34, 0xfe, 0xfd, 0x7d, 0x7d, 0x7e, 0xfe,
-  0xb5, 0x7e, 0x7d, 0x7d, 0xfe, 0xb6, 0x7e, 0x7e, 0x7e, 0x01, 0xec, 0x7c,
-  0x31, 0x7f, 0xfe, 0xfd, 0x7c, 0x7e, 0x7c, 0xfe, 0xb4, 0x7d, 0x7e, 0x7c,
-  0xfe, 0xb6, 0x7c, 0x7c, 0x7c, 0xfe, 0xb5, 0x7c, 0x7e, 0x7c, 0xfe, 0xb4,
-  0x7c, 0x7d, 0x7d, 0xfe, 0x81, 0x34, 0x7c, 0x31, 0x02, 0xed, 0x7e, 0x32,
-  0x99, 0x31, 0xfe, 0xb4, 0x7e, 0x7e, 0x7e, 0xfe, 0xb5, 0x7e, 0x7c, 0x7e,
-  0xfe, 0xb5, 0x7e, 0x7e, 0x7e, 0xfe, 0xb4, 0x34, 0x34, 0x7e, 0x01, 0x1e,
-  0x7e, 0x31, 0x99, 0x31, 0xfe, 0xb5, 0x7d, 0x7c, 0x7e, 0xfe, 0xb5, 0x34,
-  0x34, 0x7e, 0x7e, 0x34, 0x7f, 0x31, 0xfe, 0xde, 0x06, 0x20, 0xf9, 0xe0,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x16, 0x04, 0x3a, 0x04, 0x12, 0x00, 0x03,
-  0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0xa7, 0x03, 0x93, 0x16, 0x03, 0xfc,
-  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x16, 0x04, 0x3a,
-  0x04, 0x12, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21,
-  0x03, 0x11, 0x21, 0x11, 0x01, 0x0e, 0x02, 0xc5, 0xfd, 0x3b, 0x67, 0x03,
-  0x93, 0x88, 0x03, 0x18, 0xfc, 0x76, 0x03, 0xfc, 0xfc, 0x04, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0x00, 0x9a, 0x06, 0x27, 0x03, 0x8e, 0x00, 0x03,
-  0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x06, 0x26, 0xfa, 0x81, 0x05, 0x7f,
-  0x9a, 0x02, 0xf4, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x9a, 0x06, 0x27,
-  0x03, 0x8e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
-  0x05, 0x21, 0x11, 0x21, 0x05, 0xc0, 0xfb, 0x4e, 0x05, 0x18, 0xfa, 0x81,
-  0x05, 0x7f, 0x01, 0x0c, 0x02, 0x10, 0xfd, 0xf0, 0x72, 0x02, 0xf4, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0xff, 0x06, 0x03, 0x4f, 0x05, 0x22, 0x00, 0x03,
-  0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0xa7, 0x02, 0xa8, 0xfa, 0x06, 0x1c,
-  0xf9, 0xe4, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x06, 0x03, 0x4f,
-  0x05, 0x22, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21,
-  0x03, 0x11, 0x21, 0x11, 0x01, 0x0e, 0x01, 0xda, 0xfe, 0x26, 0x67, 0x02,
-  0xa8, 0x88, 0x05, 0x38, 0xfa, 0x56, 0x06, 0x1c, 0xf9, 0xe4, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0x00, 0x9a, 0x05, 0x85, 0x03, 0x8e, 0x00, 0x03,
-  0x00, 0x00, 0x25, 0x21, 0x01, 0x21, 0x04, 0x22, 0xfb, 0xe3, 0x01, 0x63,
-  0x04, 0x1c, 0x9a, 0x02, 0xf4, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05,
-  0x00, 0x9a, 0x05, 0x85, 0x03, 0x8e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x13, 0x21, 0x03, 0x05, 0x21, 0x01, 0x21, 0x03, 0xf2, 0xf5, 0xfc,
-  0xb1, 0xf6, 0x03, 0x80, 0xfb, 0xe3, 0x01, 0x63, 0x04, 0x1c, 0x01, 0x0c,
-  0x02, 0x10, 0xfd, 0xf0, 0x72, 0x02, 0xf4, 0x00, 0x00, 0x01, 0x00, 0x05,
-  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x17, 0x09,
-  0x01, 0x05, 0x02, 0xbf, 0x02, 0xc0, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00,
-  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x00, 0x17, 0x21, 0x09, 0x03, 0x9f, 0x04, 0x4b, 0xfd,
-  0xda, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0x8a, 0x04, 0xca, 0xfa, 0xc4,
-  0x06, 0x20, 0xf9, 0xe0, 0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
-  0x04, 0x12, 0x00, 0x02, 0x00, 0x00, 0x37, 0x09, 0x01, 0x05, 0x01, 0xca,
-  0x01, 0xc9, 0x16, 0x03, 0xfc, 0xfc, 0x04, 0x00, 0x00, 0x02, 0x00, 0x05,
-  0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00,
-  0x37, 0x21, 0x09, 0x03, 0x9f, 0x02, 0x5f, 0xfe, 0xd1, 0xfe, 0x36, 0x01,
-  0xca, 0x01, 0xc9, 0x88, 0x02, 0xa6, 0xfc, 0xe8, 0x03, 0xfc, 0xfc, 0x04,
-  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x00, 0x17, 0x11, 0x01, 0x05, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0xfc,
-  0xf0, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x17, 0x09, 0x01, 0x03,
-  0x11, 0x01, 0x6c, 0x04, 0x4b, 0xfb, 0xb5, 0x67, 0x05, 0x7f, 0x52, 0x02,
-  0x66, 0x02, 0x66, 0xfa, 0x8a, 0x06, 0x20, 0xfc, 0xf0, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02,
-  0x00, 0x00, 0x37, 0x11, 0x01, 0x05, 0x03, 0x93, 0x16, 0x03, 0xfc, 0xfe,
-  0x02, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
-  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x37, 0x09, 0x01, 0x03,
-  0x11, 0x01, 0x6c, 0x02, 0x5f, 0xfd, 0xa1, 0x67, 0x03, 0x93, 0xc1, 0x01,
-  0x53, 0x01, 0x53, 0xfc, 0xaf, 0x03, 0xfc, 0xfe, 0x02, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85, 0x04, 0x12, 0x00, 0x02,
-  0x00, 0x00, 0x37, 0x11, 0x01, 0x05, 0x05, 0x7f, 0x16, 0x03, 0xfc, 0xfe,
-  0x02, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85,
-  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x37, 0x09, 0x01, 0x03,
-  0x11, 0x01, 0x6c, 0x04, 0x18, 0xfb, 0xe8, 0x67, 0x05, 0x7f, 0xc1, 0x01,
-  0x53, 0x01, 0x53, 0xfc, 0xaf, 0x03, 0xfc, 0xfe, 0x02, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x00, 0x13, 0x21, 0x01, 0x05, 0x05, 0x7f, 0xfd, 0x40, 0x05, 0x24,
-  0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x09, 0x01, 0x25,
-  0x21, 0x01, 0x9f, 0x02, 0x25, 0x02, 0x26, 0xfb, 0x1b, 0x05, 0x7f, 0xfd,
-  0x40, 0x04, 0xb2, 0xfb, 0x36, 0x04, 0xca, 0x72, 0xf9, 0xe0, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02,
-  0x00, 0x00, 0x13, 0x21, 0x01, 0x05, 0x03, 0x93, 0xfe, 0x37, 0x04, 0x12,
-  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
-  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x09, 0x01, 0x25,
-  0x21, 0x01, 0x9f, 0x01, 0x30, 0x01, 0x2f, 0xfd, 0x07, 0x03, 0x93, 0xfe,
-  0x37, 0x03, 0xa0, 0xfd, 0x5a, 0x02, 0xa6, 0x72, 0xfc, 0x04, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x00, 0x13, 0x01, 0x11, 0x05, 0x05, 0x7f, 0x02, 0x14, 0x03, 0x10,
-  0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x01, 0x11, 0x09,
-  0x01, 0x11, 0xd3, 0x04, 0x4b, 0xfa, 0xe7, 0x05, 0x7f, 0x02, 0x14, 0xfd,
-  0x9a, 0x04, 0xcc, 0xfd, 0x9a, 0x03, 0x10, 0xf9, 0xe0, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02,
-  0x00, 0x00, 0x13, 0x01, 0x11, 0x05, 0x03, 0x93, 0x02, 0x14, 0x01, 0xfe,
-  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
-  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x01, 0x11, 0x09,
-  0x01, 0x11, 0xd3, 0x02, 0x5e, 0xfc, 0xd4, 0x03, 0x93, 0x02, 0x14, 0xfe,
-  0xad, 0x02, 0xa6, 0xfe, 0xad, 0x01, 0xfe, 0xfc, 0x04, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85, 0x04, 0x12, 0x00, 0x02,
-  0x00, 0x00, 0x13, 0x01, 0x11, 0x05, 0x05, 0x7f, 0x02, 0x14, 0x01, 0xfe,
-  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85,
-  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x09, 0x01, 0x11, 0x09,
-  0x01, 0x11, 0x01, 0x06, 0x04, 0x18, 0xfa, 0xe7, 0x05, 0x7f, 0x02, 0x14,
-  0xfe, 0xad, 0x02, 0xa6, 0xfe, 0xad, 0x01, 0xfe, 0xfc, 0x04, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x09, 0x02, 0x05, 0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40,
-  0x02, 0x14, 0x03, 0x10, 0xfc, 0xf0, 0xfc, 0xf0, 0x00, 0x02, 0x00, 0x05,
-  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x09, 0x06, 0x8e, 0x02, 0x36, 0x02, 0x37, 0xfd, 0xc9, 0xfd, 0x41,
-  0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40, 0x02, 0x14, 0xfd, 0x88, 0x02, 0x78,
-  0x02, 0x78, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0, 0xfc, 0xf0, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x0b, 0x01, 0x1e, 0x01, 0xa6,
-  0x01, 0xa6, 0xfe, 0x5a, 0xfd, 0xca, 0x02, 0x36, 0x02, 0x37, 0xfd, 0xc9,
-  0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40, 0x02, 0x14, 0x01, 0xd7,
-  0xfe, 0x29, 0xfe, 0x29, 0x01, 0xd7, 0xfd, 0x88, 0x02, 0x78, 0x02, 0x78,
-  0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0, 0xfc, 0xf0, 0x00, 0x03, 0x00, 0x64,
-  0xfe, 0xff, 0x05, 0xe4, 0x05, 0x29, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x29,
-  0x00, 0x00, 0x24, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x00, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
-  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x00, 0x10, 0x25, 0x36, 0x33, 0x32,
-  0x17, 0x04, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x01, 0x5b, 0xe5, 0x71,
-  0x73, 0x73, 0x71, 0xe5, 0xe5, 0x71, 0x73, 0x73, 0x71, 0xfe, 0x8e, 0x01,
-  0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96, 0x96,
-  0x94, 0xfe, 0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe,
-  0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xef, 0x02, 0x4a, 0x92, 0x4a, 0x4a, 0x92,
-  0xfd, 0xb6, 0x92, 0x4a, 0x4a, 0x03, 0x36, 0xfd, 0x02, 0xc0, 0x60, 0x60,
-  0xc0, 0x02, 0xfe, 0xc0, 0x60, 0x60, 0xfb, 0xff, 0x03, 0x84, 0xe2, 0x71,
-  0x71, 0xe2, 0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x00, 0x00, 0x02, 0x00, 0x05,
-  0xfe, 0x23, 0x03, 0x8a, 0x06, 0x75, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x09, 0x07, 0x01, 0xc7, 0xfe, 0xa6, 0x01, 0x5a, 0x01, 0x5b, 0xfe, 0xa5,
-  0x01, 0xc2, 0xfe, 0x3e, 0xfe, 0x3e, 0x05, 0x81, 0xfc, 0xcf, 0xfc, 0xc7,
-  0x03, 0x39, 0x04, 0x25, 0xfb, 0xdb, 0xfb, 0xd3, 0x04, 0x2d, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4, 0x05, 0x29, 0x00, 0x0d,
-  0x00, 0x1b, 0x00, 0x00, 0x12, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
-  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x00, 0x10, 0x25, 0x36, 0x33, 0x32,
-  0x17, 0x04, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0xce, 0x01, 0x2c, 0x94,
-  0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96, 0x96, 0x94, 0xfe,
-  0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe, 0xa0, 0xb0,
-  0xb0, 0xb0, 0xaf, 0x03, 0x93, 0xfd, 0x02, 0xc0, 0x60, 0x60, 0xc0, 0x02,
-  0xfe, 0xc0, 0x60, 0x60, 0xfb, 0xff, 0x03, 0x84, 0xe2, 0x71, 0x71, 0xe2,
-  0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x66,
-  0xff, 0x01, 0x05, 0xe2, 0x05, 0x27, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d,
-  0x00, 0x27, 0x00, 0x2f, 0x00, 0x37, 0x00, 0x3f, 0x00, 0x47, 0x00, 0x00,
-  0x25, 0x16, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x27, 0x05, 0x36,
-  0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x07, 0x13, 0x26, 0x27, 0x26,
-  0x27, 0x37, 0x16, 0x17, 0x16, 0x17, 0x25, 0x06, 0x07, 0x06, 0x07, 0x27,
-  0x36, 0x37, 0x36, 0x37, 0x13, 0x16, 0x32, 0x37, 0x17, 0x06, 0x22, 0x27,
-  0x01, 0x36, 0x34, 0x27, 0x37, 0x16, 0x14, 0x07, 0x01, 0x26, 0x22, 0x07,
-  0x27, 0x36, 0x32, 0x17, 0x01, 0x06, 0x14, 0x17, 0x07, 0x26, 0x34, 0x37,
-  0x01, 0x39, 0x27, 0x35, 0x29, 0x33, 0x2c, 0x3f, 0x34, 0x43, 0x30, 0x03,
-  0x78, 0x32, 0x29, 0x2f, 0x2d, 0x5a, 0x35, 0x3e, 0x33, 0x40, 0x8c, 0x27,
-  0x35, 0x29, 0x32, 0x2b, 0x40, 0x33, 0x43, 0x30, 0xfc, 0x89, 0x33, 0x29,
-  0x35, 0x27, 0x5a, 0x2c, 0x47, 0x34, 0x3f, 0xd5, 0x44, 0x8b, 0x44, 0x23,
-  0x56, 0xad, 0x56, 0x02, 0xf6, 0x0e, 0x0e, 0x63, 0x12, 0x12, 0xfd, 0xdd,
-  0x44, 0x8b, 0x44, 0x23, 0x56, 0xad, 0x56, 0xfd, 0x0c, 0x0f, 0x0f, 0x63,
-  0x12, 0x12, 0x8f, 0x3c, 0x31, 0x26, 0x20, 0x6a, 0x28, 0x30, 0x3d, 0x4a,
-  0x75, 0x20, 0x26, 0x2c, 0x41, 0x3d, 0x4e, 0x3a, 0x30, 0x28, 0x04, 0x27,
-  0x3c, 0x31, 0x26, 0x20, 0x6a, 0x28, 0x30, 0x3d, 0x4a, 0x75, 0x20, 0x26,
-  0x31, 0x3c, 0x3e, 0x45, 0x42, 0x30, 0x28, 0xfa, 0xd4, 0x16, 0x16, 0x6e,
-  0x1b, 0x1b, 0x02, 0x5f, 0x49, 0xa0, 0x49, 0x27, 0x5b, 0xca, 0x5b, 0x03,
-  0x4a, 0x16, 0x16, 0x6e, 0x1b, 0x1b, 0xfd, 0xa1, 0x49, 0xa0, 0x49, 0x27,
-  0x5b, 0xca, 0x5b, 0x00, 0x00, 0x06, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4,
-  0x05, 0x29, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x25, 0x00, 0x2f,
-  0x00, 0x33, 0x00, 0x00, 0x36, 0x10, 0x25, 0x36, 0x33, 0x32, 0x17, 0x04,
-  0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x13, 0x11, 0x16, 0x17, 0x16, 0x17,
-  0x11, 0x06, 0x07, 0x06, 0x07, 0x06, 0x10, 0x17, 0x01, 0x11, 0x16, 0x33,
-  0x32, 0x37, 0x11, 0x26, 0x23, 0x22, 0x17, 0x11, 0x36, 0x37, 0x36, 0x37,
-  0x11, 0x26, 0x27, 0x26, 0x17, 0x11, 0x36, 0x10, 0x65, 0x01, 0x60, 0xaf,
-  0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0x0a,
-  0x14, 0x17, 0x3a, 0x3b, 0x3b, 0x3a, 0x17, 0x7b, 0x9a, 0x9a, 0x01, 0x6d,
-  0x28, 0x27, 0x28, 0x28, 0x28, 0x28, 0x27, 0xdd, 0x3b, 0x39, 0x18, 0x15,
-  0x15, 0x18, 0x39, 0xcc, 0x99, 0x52, 0x03, 0x84, 0xe2, 0x71, 0x71, 0xe2,
-  0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x04, 0xc5, 0xfb, 0xbe, 0x0f, 0x0f, 0x25,
-  0x17, 0x04, 0xf6, 0x17, 0x25, 0x0f, 0x6d, 0xb1, 0xfd, 0xdc, 0xb1, 0x04,
-  0x5b, 0xfa, 0xd0, 0x07, 0x07, 0x05, 0x30, 0x07, 0x24, 0xfb, 0x0a, 0x17,
-  0x25, 0x0f, 0x10, 0x04, 0x40, 0x10, 0x0f, 0x25, 0xa2, 0xfc, 0x7c, 0xb1,
-  0x02, 0x22, 0x00, 0x00, 0x00, 0x04, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4,
-  0x05, 0x29, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x29, 0x00, 0x37, 0x00, 0x00,
-  0x00, 0x10, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x10, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x02, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x00, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
-  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x00, 0x10, 0x25, 0x36, 0x33, 0x32,
-  0x17, 0x04, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x02, 0x56, 0x67, 0x33,
-  0x34, 0x34, 0x33, 0x67, 0x67, 0x33, 0x34, 0x34, 0x33, 0xd5, 0x9e, 0x4f,
-  0x4f, 0x4f, 0x4f, 0x9e, 0x9e, 0x4f, 0x4f, 0x4f, 0x4f, 0xfe, 0x48, 0x01,
-  0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96, 0x96,
-  0x94, 0xfe, 0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe,
-  0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0x02, 0x98, 0xfe, 0xf8, 0x42, 0x21, 0x21,
-  0x42, 0x01, 0x08, 0x42, 0x21, 0x21, 0xfe, 0x6f, 0x01, 0x96, 0x65, 0x33,
-  0x33, 0x65, 0xfe, 0x6a, 0x65, 0x33, 0x33, 0x02, 0xaf, 0xfd, 0x02, 0xc0,
-  0x60, 0x60, 0xc0, 0x02, 0xfe, 0xc0, 0x60, 0x60, 0xfb, 0xff, 0x03, 0x84,
-  0xe2, 0x71, 0x71, 0xe2, 0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x17,
-  0x00, 0x00, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x65, 0x5e, 0x5e, 0xa4, 0xa3, 0xbd, 0xbc, 0xa3, 0xa3, 0x5e,
-  0x5f, 0x5f, 0x5e, 0xa3, 0xa3, 0xbc, 0xbd, 0xa3, 0xa4, 0x5e, 0x5e, 0x02,
-  0x12, 0xd1, 0xb6, 0xb5, 0x69, 0x69, 0x69, 0x69, 0xb5, 0xb6, 0xd1, 0xd1,
-  0xb6, 0xb5, 0x69, 0x69, 0x69, 0x69, 0xb5, 0xb6, 0x00, 0x02, 0x00, 0x64,
-  0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d, 0x00, 0x15, 0x00, 0x00,
-  0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23,
-  0x22, 0x24, 0x05, 0x32, 0x37, 0x24, 0x10, 0x25, 0x26, 0x23, 0x65, 0xbc,
-  0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd,
-  0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96,
-  0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e,
-  0xfe, 0x95, 0xd2, 0xd2, 0x61, 0x60, 0xc0, 0x02, 0xfe, 0xc0, 0x60, 0x00,
-  0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d,
-  0x00, 0x15, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
-  0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x01, 0x22, 0x07, 0x04, 0x10, 0x05,
-  0x16, 0x33, 0x65, 0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd, 0xbd,
-  0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0xfe, 0xd4,
-  0x01, 0x2c, 0x94, 0x96, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2,
-  0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x04, 0xdd, 0x60, 0xc0,
-  0xfd, 0x02, 0xc0, 0x60, 0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
-  0x05, 0x20, 0x00, 0x0d, 0x00, 0x16, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24,
-  0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x01, 0x10,
-  0x25, 0x26, 0x23, 0x22, 0x07, 0x04, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd,
-  0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x04,
-  0x59, 0xfe, 0xd4, 0x94, 0x96, 0x96, 0x94, 0xfe, 0xd4, 0x01, 0x41, 0x01,
-  0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2,
-  0xd2, 0x02, 0x3e, 0x01, 0x7f, 0xc0, 0x60, 0x60, 0xc0, 0xfe, 0x81, 0x00,
-  0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d,
-  0x00, 0x16, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
-  0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x03, 0x10, 0x05, 0x16, 0x33, 0x32,
-  0x37, 0x24, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd,
-  0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x53, 0x01, 0x2c, 0x94, 0x96,
-  0x96, 0x94, 0x01, 0x2c, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2,
-  0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x02, 0x3e, 0xfe, 0x81,
-  0xc0, 0x60, 0x60, 0xc0, 0x01, 0x7f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64,
-  0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0b, 0x00, 0x18, 0x00, 0x00,
-  0x12, 0x10, 0x12, 0x24, 0x20, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24,
-  0x01, 0x22, 0x07, 0x04, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24, 0x11,
-  0x21, 0x65, 0xbc, 0x01, 0x47, 0x01, 0x79, 0x01, 0x46, 0xbd, 0xbd, 0xfe,
-  0xba, 0xfe, 0x87, 0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0xfe, 0xd4, 0x01,
-  0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfd, 0xaa, 0x01, 0x41, 0x01,
-  0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2,
-  0xd2, 0x04, 0xdd, 0x60, 0xc0, 0xfd, 0x02, 0xc0, 0x60, 0x60, 0xc0, 0x01,
-  0x7f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
-  0x05, 0x20, 0x00, 0x0b, 0x00, 0x11, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24,
-  0x20, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x01, 0x22, 0x07, 0x04,
-  0x11, 0x21, 0x65, 0xbc, 0x01, 0x47, 0x01, 0x79, 0x01, 0x46, 0xbd, 0xbd,
-  0xfe, 0xba, 0xfe, 0x87, 0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0xfe, 0xd4,
-  0x02, 0x56, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95,
-  0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x04, 0xdd, 0x60, 0xc0, 0xfe, 0x81,
-  0x00, 0x01, 0x00, 0x64, 0xfe, 0xff, 0x03, 0x24, 0x05, 0x29, 0x00, 0x07,
-  0x00, 0x00, 0x36, 0x10, 0x25, 0x36, 0x33, 0x11, 0x22, 0x27, 0x65, 0x01,
-  0x60, 0xaf, 0xb0, 0xb0, 0xaf, 0x52, 0x03, 0x84, 0xe2, 0x71, 0xf9, 0xd6,
-  0x71, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0xff, 0x03, 0x67,
-  0x05, 0x29, 0x00, 0x07, 0x00, 0x00, 0x00, 0x10, 0x05, 0x06, 0x23, 0x11,
-  0x32, 0x17, 0x03, 0x66, 0xfe, 0xa0, 0xaf, 0xb0, 0xb0, 0xaf, 0x03, 0xd6,
-  0xfc, 0x7c, 0xe2, 0x71, 0x06, 0x2a, 0x71, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xff, 0xec, 0x05, 0x0b, 0x06, 0x28, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00,
-  0x01, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01,
-  0x11, 0x21, 0x11, 0x01, 0xce, 0x9a, 0xe2, 0x9a, 0x9a, 0x6f, 0x72, 0x9b,
-  0xfe, 0xd9, 0x04, 0x64, 0x02, 0xfa, 0x7d, 0xac, 0xac, 0x7d, 0x7c, 0xab,
-  0xab, 0xfc, 0x76, 0x06, 0x3c, 0xf9, 0xc4, 0x00, 0x00, 0x03, 0x00, 0xa7,
-  0xfe, 0x00, 0x06, 0x55, 0x06, 0x28, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x1f,
-  0x00, 0x00, 0x24, 0x10, 0x25, 0x36, 0x33, 0x32, 0x17, 0x04, 0x10, 0x05,
-  0x06, 0x23, 0x22, 0x27, 0x00, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
-  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x01, 0x11, 0x21, 0x11, 0x01, 0x28,
-  0x01, 0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96,
-  0x96, 0x94, 0xfe, 0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60,
-  0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xfe, 0x88, 0x05, 0xae, 0x95, 0x02,
-  0xfe, 0xc0, 0x60, 0x60, 0xc0, 0xfd, 0x02, 0xc0, 0x60, 0x60, 0x04, 0x01,
-  0xfc, 0x7c, 0xe2, 0x71, 0x71, 0xe2, 0x03, 0x84, 0xe2, 0x71, 0x71, 0xf9,
-  0x48, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0x02, 0x14, 0x06, 0x55, 0x06, 0x28, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
-  0x13, 0x11, 0x21, 0x11, 0x23, 0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x04,
-  0x11, 0x29, 0x01, 0x10, 0x25, 0x36, 0x33, 0x32, 0x17, 0x04, 0xa7, 0x05,
-  0xae, 0x17, 0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xfe, 0xa0, 0x05, 0x15,
-  0xfb, 0x54, 0x01, 0x2c, 0x95, 0x95, 0x95, 0x95, 0x01, 0x2c, 0x02, 0x14,
-  0x04, 0x14, 0xfb, 0xec, 0x01, 0xc2, 0xe2, 0x71, 0x71, 0xe2, 0xfe, 0x3e,
-  0x01, 0x7e, 0xc1, 0x60, 0x60, 0xc1, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xfe, 0x00, 0x06, 0x55, 0x02, 0x14, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
-  0x13, 0x11, 0x33, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24, 0x11, 0x33,
-  0x11, 0x01, 0x21, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x24, 0xa7, 0x18,
-  0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0x17, 0xfa, 0xd3, 0x04,
-  0xac, 0xfe, 0xd4, 0x95, 0x95, 0x95, 0x95, 0xfe, 0xd4, 0xfe, 0x00, 0x04,
-  0x14, 0xfe, 0x3e, 0xe2, 0x71, 0x71, 0xe2, 0x01, 0xc2, 0xfb, 0xec, 0x04,
-  0x14, 0xfe, 0x82, 0xc1, 0x60, 0x60, 0xc1, 0x00, 0x00, 0x01, 0x00, 0x05,
-  0x02, 0x14, 0x02, 0xc5, 0x05, 0x29, 0x00, 0x09, 0x00, 0x00, 0x13, 0x10,
-  0x25, 0x36, 0x33, 0x15, 0x22, 0x07, 0x04, 0x11, 0x05, 0x01, 0x60, 0xb0,
-  0xaf, 0x95, 0x95, 0xfe, 0xd5, 0x02, 0x14, 0x01, 0xc2, 0xe2, 0x71, 0x76,
-  0x60, 0xc0, 0xfe, 0x81, 0x00, 0x01, 0x00, 0x05, 0x02, 0x14, 0x02, 0xc5,
-  0x05, 0x29, 0x00, 0x09, 0x00, 0x00, 0x13, 0x32, 0x17, 0x04, 0x11, 0x23,
-  0x10, 0x25, 0x26, 0x23, 0x05, 0xb0, 0xaf, 0x01, 0x60, 0x69, 0xfe, 0xd4,
-  0x94, 0x96, 0x05, 0x29, 0x71, 0xe2, 0xfe, 0x3e, 0x01, 0x7f, 0xc0, 0x60,
-  0x00, 0x01, 0x00, 0x05, 0xfe, 0xff, 0x02, 0xc5, 0x02, 0x14, 0x00, 0x09,
-  0x00, 0x00, 0x13, 0x35, 0x32, 0x37, 0x24, 0x11, 0x33, 0x10, 0x05, 0x06,
-  0x05, 0x96, 0x94, 0x01, 0x2c, 0x69, 0xfe, 0xa0, 0xaf, 0xfe, 0xff, 0x76,
-  0x60, 0xc0, 0x01, 0x7f, 0xfe, 0x3e, 0xe2, 0x71, 0x00, 0x01, 0x00, 0x05,
-  0xfe, 0xff, 0x02, 0xc5, 0x02, 0x14, 0x00, 0x09, 0x00, 0x00, 0x01, 0x22,
-  0x27, 0x24, 0x11, 0x33, 0x10, 0x05, 0x16, 0x33, 0x02, 0xc4, 0xaf, 0xb0,
-  0xfe, 0xa0, 0x6a, 0x01, 0x2b, 0x95, 0x95, 0xfe, 0xff, 0x71, 0xe2, 0x01,
-  0xc2, 0xfe, 0x81, 0xc0, 0x60, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64,
-  0x02, 0x14, 0x05, 0xe4, 0x05, 0x29, 0x00, 0x11, 0x00, 0x00, 0x13, 0x10,
-  0x25, 0x36, 0x33, 0x32, 0x17, 0x04, 0x11, 0x23, 0x10, 0x25, 0x26, 0x23,
-  0x22, 0x07, 0x04, 0x11, 0x65, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01,
-  0x60, 0x6a, 0xfe, 0xd4, 0x94, 0x96, 0x96, 0x94, 0xfe, 0xd4, 0x02, 0x14,
-  0x01, 0xc2, 0xe2, 0x71, 0x71, 0xe2, 0xfe, 0x3e, 0x01, 0x7f, 0xc0, 0x60,
-  0x60, 0xc0, 0xfe, 0x81, 0x00, 0x01, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4,
-  0x02, 0x14, 0x00, 0x12, 0x00, 0x00, 0x13, 0x30, 0x33, 0x10, 0x05, 0x16,
-  0x33, 0x32, 0x37, 0x24, 0x11, 0x33, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27,
-  0x24, 0x65, 0x69, 0x01, 0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0x6a,
-  0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xfe, 0xa0, 0x02, 0x14, 0xfe, 0x81,
-  0xc0, 0x60, 0x60, 0xc0, 0x01, 0x7f, 0xfe, 0x3e, 0xe2, 0x71, 0x71, 0xe2,
-  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x00, 0x17, 0x01, 0x11, 0x05, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0xf9,
-  0xe0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x17, 0x11, 0x01, 0x05, 0x05, 0x7f,
-  0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05,
-  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x17, 0x11,
-  0x21, 0x05, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0x00, 0x00, 0x01, 0x00, 0x05,
-  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x13, 0x21,
-  0x11, 0x05, 0x05, 0x7f, 0x05, 0x24, 0xf9, 0xe0, 0x00, 0x02, 0x01, 0x14,
-  0x01, 0xd1, 0x03, 0x2b, 0x04, 0x21, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00,
-  0x01, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x22, 0x26, 0x01, 0x49,
-  0x7d, 0xb4, 0x7c, 0x7c, 0x59, 0x5b, 0x7d, 0x35, 0x9c, 0x71, 0x70, 0x9a,
-  0x9b, 0xe1, 0x9b, 0x02, 0xfa, 0x64, 0x8a, 0x8a, 0x64, 0x63, 0x89, 0x89,
-  0x63, 0x7c, 0xab, 0xab, 0x7c, 0x7d, 0xac, 0xac, 0x00, 0x02, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfd,
-  0x40, 0x02, 0x5a, 0xfd, 0xa6, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05,
-  0x3c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
-  0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
-  0x25, 0x21, 0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0x02, 0x58, 0xfd,
-  0xa8, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05, 0x3c, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x06, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0xa7,
-  0x05, 0x7f, 0xfa, 0xe8, 0x04, 0xb2, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72,
-  0x05, 0x3c, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
-  0x05, 0x24, 0x00, 0x03, 0x00, 0x06, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
-  0x25, 0x01, 0x21, 0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0x04, 0xb2, 0xfb, 0x4e,
-  0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05, 0x3c, 0x00, 0x03, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x01, 0x21,
-  0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfd, 0x74, 0x02, 0x26, 0xfd, 0xda, 0xfd,
-  0x74, 0x02, 0x25, 0xfd, 0xdb, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05,
-  0x3c, 0xfa, 0xc4, 0x05, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x05,
-  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x07, 0x00, 0x0a, 0x00, 0x0d,
-  0x00, 0x00, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x21,
-  0x09, 0x03, 0x02, 0x3f, 0x4e, 0x70, 0x4d, 0x4d, 0x71, 0xfe, 0x13, 0x04,
-  0x4b, 0xfd, 0xda, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0x01, 0x2c, 0x7c,
-  0x56, 0x56, 0x7c, 0x56, 0xfe, 0xa0, 0x04, 0xca, 0xfa, 0xc4, 0x06, 0x20,
-  0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x05, 0x21, 0x09, 0x03,
-  0x02, 0xc4, 0x02, 0x26, 0xfd, 0xda, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0,
-  0x8a, 0x04, 0xca, 0xfa, 0xc4, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x00, 0x17, 0x21, 0x11, 0x09, 0x02, 0x9f, 0x02, 0x25,
-  0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0x8a, 0x04, 0xca, 0xfa, 0xc4, 0x06,
-  0x20, 0xf9, 0xe0, 0x00, 0x00, 0x02, 0x00, 0x64, 0xfe, 0x00, 0x07, 0xaa,
-  0x06, 0x28, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00, 0x12, 0x10, 0x01, 0x16,
-  0x20, 0x37, 0x00, 0x10, 0x01, 0x26, 0x20, 0x07, 0x00, 0x10, 0x01, 0x36,
-  0x20, 0x17, 0x00, 0x10, 0x01, 0x06, 0x20, 0x27, 0xd9, 0x01, 0x98, 0xcb,
-  0x01, 0x97, 0xcb, 0x01, 0x98, 0xfe, 0x68, 0xcb, 0xfe, 0x69, 0xcb, 0xfd,
-  0xf4, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xfe, 0x2f, 0xe9,
-  0xfe, 0x2f, 0xe9, 0x04, 0x1e, 0xfb, 0xec, 0xfe, 0xfb, 0x83, 0x83, 0x01,
-  0x05, 0x04, 0x14, 0x01, 0x05, 0x83, 0x83, 0xfa, 0x9d, 0x04, 0xa8, 0x01,
-  0x2a, 0x96, 0x96, 0xfe, 0xd6, 0xfb, 0x58, 0xfe, 0xd6, 0x96, 0x96, 0x00,
-  0x00, 0x03, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x05,
-  0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x03, 0x11, 0x21, 0x11, 0x01, 0x21, 0x11, 0x21, 0x01, 0x0e, 0x04, 0xb2,
-  0xfd, 0xda, 0xfd, 0x74, 0x67, 0x05, 0x7f, 0xfa, 0xe8, 0x02, 0x25, 0xfd,
-  0xdb, 0x8a, 0x05, 0x3c, 0xfd, 0x29, 0xfd, 0x29, 0x06, 0x20, 0xf9, 0xe0,
-  0x03, 0x49, 0x02, 0x65, 0x00, 0x03, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
-  0x05, 0x24, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21,
-  0x11, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
-  0x01, 0x0e, 0x02, 0x8c, 0x02, 0x26, 0xfb, 0x4e, 0x67, 0x05, 0x7f, 0xfa,
-  0xe8, 0x02, 0x25, 0xfd, 0xdb, 0x02, 0x4d, 0xfd, 0x29, 0x05, 0x3c, 0xfa,
-  0x52, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x02, 0x65, 0x00, 0x03, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0d,
-  0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
-  0x25, 0x21, 0x11, 0x21, 0x01, 0x0e, 0x02, 0x25, 0x02, 0x8d, 0xfb, 0x4e,
-  0x67, 0x05, 0x7f, 0xfd, 0x74, 0x02, 0x26, 0xfd, 0xda, 0x8a, 0x02, 0xd7,
-  0x02, 0x65, 0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x02, 0x65, 0x00,
-  0x00, 0x03, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x05,
-  0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x03, 0x11, 0x21, 0x11, 0x01, 0x21, 0x11, 0x21, 0x01, 0x0e, 0x04, 0xb2,
-  0xfd, 0x73, 0xfd, 0xdb, 0x67, 0x05, 0x7f, 0xfd, 0x74, 0x02, 0x26, 0xfd,
-  0xda, 0x8a, 0x02, 0x65, 0x02, 0xd7, 0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0,
-  0x03, 0x49, 0x02, 0x65, 0x00, 0x03, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
-  0x05, 0x20, 0x00, 0x0d, 0x00, 0x13, 0x00, 0x20, 0x00, 0x00, 0x12, 0x10,
-  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24,
-  0x01, 0x06, 0x07, 0x04, 0x03, 0x21, 0x05, 0x12, 0x05, 0x16, 0x33, 0x32,
-  0x37, 0x24, 0x10, 0x25, 0x26, 0x27, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd,
-  0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x01,
-  0xcf, 0x7b, 0x7b, 0xfe, 0xeb, 0x15, 0x02, 0x20, 0xfd, 0xe0, 0x15, 0x01,
-  0x15, 0x95, 0x95, 0x95, 0x95, 0x01, 0x2c, 0xfe, 0xd4, 0x7b, 0x7c, 0x01,
-  0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe,
-  0x95, 0xd2, 0xd2, 0x04, 0xda, 0x0e, 0x4f, 0xb2, 0xfe, 0xac, 0x72, 0xfe,
-  0xac, 0xb2, 0x60, 0x60, 0xc1, 0x02, 0xfc, 0xc1, 0x4f, 0x0e, 0xfd, 0x2b,
-  0x00, 0x03, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d,
-  0x00, 0x1a, 0x00, 0x20, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32,
-  0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x05, 0x36, 0x37, 0x24,
-  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x04, 0x03, 0x21, 0x05, 0x12, 0x05,
-  0x16, 0x17, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd,
-  0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x02, 0x36, 0x7c, 0x7b, 0x01,
-  0x2c, 0xfe, 0xd4, 0x95, 0x95, 0x95, 0x95, 0xfe, 0xeb, 0x15, 0x02, 0x87,
-  0xfd, 0x79, 0x15, 0x01, 0x15, 0x7b, 0x7b, 0x01, 0x41, 0x01, 0xa2, 0x01,
-  0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x5e,
-  0x0e, 0x4f, 0xc1, 0x02, 0xfc, 0xc1, 0x60, 0x60, 0xb2, 0xfe, 0xac, 0x72,
-  0xfe, 0xac, 0xb2, 0x4f, 0x0e, 0x02, 0x63, 0x00, 0x00, 0x03, 0x00, 0x64,
-  0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d, 0x00, 0x1a, 0x00, 0x20,
-  0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02,
-  0x04, 0x23, 0x22, 0x24, 0x02, 0x10, 0x05, 0x16, 0x17, 0x11, 0x21, 0x02,
-  0x25, 0x26, 0x23, 0x22, 0x07, 0x01, 0x36, 0x37, 0x24, 0x13, 0x21, 0x65,
-  0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc,
-  0xbd, 0xfe, 0xb9, 0x53, 0x01, 0x2c, 0x7b, 0x7b, 0x02, 0x88, 0x14, 0xfe,
-  0xea, 0x95, 0x95, 0x95, 0x95, 0x01, 0x5d, 0x7c, 0x7b, 0x01, 0x16, 0x14,
-  0xfd, 0xdf, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95,
-  0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x03, 0xbc, 0xfd, 0x04, 0xc1, 0x4f,
-  0x0e, 0x02, 0xd5, 0x01, 0x54, 0xb2, 0x60, 0x60, 0xfb, 0x25, 0x0e, 0x4f,
-  0xb2, 0x01, 0x54, 0x00, 0x00, 0x03, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
-  0x05, 0x20, 0x00, 0x0d, 0x00, 0x1a, 0x00, 0x20, 0x00, 0x00, 0x12, 0x10,
-  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24,
-  0x02, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24, 0x13, 0x21, 0x11, 0x06,
-  0x07, 0x01, 0x02, 0x25, 0x26, 0x27, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd,
-  0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x53,
-  0x01, 0x2c, 0x95, 0x95, 0x95, 0x95, 0x01, 0x16, 0x14, 0xfd, 0x78, 0x7b,
-  0x7b, 0x03, 0x7e, 0x14, 0xfe, 0xea, 0x7b, 0x7c, 0x01, 0x41, 0x01, 0xa2,
-  0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2,
-  0x03, 0xbc, 0xfd, 0x04, 0xc1, 0x60, 0x60, 0xb2, 0x01, 0x54, 0x02, 0xd5,
-  0x0e, 0x4f, 0xfd, 0xfa, 0x01, 0x54, 0xb2, 0x4f, 0x0e, 0xfd, 0x9d, 0x00,
-  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x00, 0x37, 0x01, 0x21, 0x03, 0x11, 0x21, 0x6c, 0x04,
-  0x18, 0xfb, 0xe8, 0x67, 0x05, 0x7f, 0x20, 0x04, 0x92, 0xfa, 0x52, 0x06,
-  0x20, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x09, 0x01, 0x11, 0x25,
-  0x21, 0x11, 0x01, 0x06, 0x04, 0x18, 0xfa, 0xe7, 0x05, 0x7f, 0x04, 0xb2,
-  0xfb, 0x6e, 0x04, 0x92, 0x72, 0xf9, 0xe0, 0x00, 0x00, 0x02, 0x00, 0x05,
-  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00,
-  0x17, 0x21, 0x01, 0x03, 0x11, 0x01, 0x6c, 0x04, 0x18, 0xfb, 0xe8, 0x67,
-  0x05, 0x7f, 0x8a, 0x04, 0x92, 0xfa, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xff, 0x79, 0x05, 0x53, 0x04, 0xaf, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
-  0x01, 0x0e, 0x03, 0xde, 0xfc, 0x22, 0x67, 0x04, 0xac, 0x15, 0x04, 0x52,
-  0xfb, 0x3c, 0x05, 0x36, 0xfa, 0xca, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xff, 0x79, 0x05, 0x53, 0x04, 0xaf, 0x00, 0x03, 0x00, 0x00, 0x17, 0x11,
-  0x21, 0x11, 0xa7, 0x04, 0xac, 0x87, 0x05, 0x36, 0xfa, 0xca, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xff, 0xdd, 0x04, 0x9f, 0x04, 0x4b, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
-  0x01, 0x0e, 0x03, 0x2a, 0xfc, 0xd6, 0x67, 0x03, 0xf8, 0x4f, 0x03, 0x8a,
-  0xfc, 0x04, 0x04, 0x6e, 0xfb, 0x92, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xff, 0xdd, 0x04, 0x9f, 0x04, 0x4b, 0x00, 0x03, 0x00, 0x00, 0x17, 0x11,
-  0x21, 0x11, 0xa7, 0x03, 0xf8, 0x23, 0x04, 0x6e, 0xfb, 0x92, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x00, 0x05, 0x21, 0x11, 0x09, 0x01, 0x11, 0x01, 0x06,
-  0x04, 0x18, 0xfa, 0xe7, 0x05, 0x7f, 0x8a, 0x04, 0x92, 0xfa, 0xfc, 0x06,
-  0x20, 0xf9, 0xe0, 0x00, 0x00, 0x09, 0x00, 0x99, 0x00, 0x00, 0x05, 0xda,
-  0x05, 0xd5, 0x00, 0x07, 0x00, 0x0c, 0x00, 0x13, 0x00, 0x22, 0x00, 0x2a,
-  0x00, 0x32, 0x00, 0x3a, 0x00, 0x41, 0x00, 0x49, 0x00, 0x00, 0x01, 0x33,
-  0x17, 0x11, 0x07, 0x23, 0x27, 0x11, 0x05, 0x17, 0x15, 0x07, 0x27, 0x25,
-  0x17, 0x07, 0x23, 0x26, 0x27, 0x35, 0x05, 0x32, 0x1f, 0x01, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01, 0x21, 0x17,
-  0x15, 0x07, 0x21, 0x27, 0x35, 0x25, 0x21, 0x17, 0x15, 0x07, 0x21, 0x27,
-  0x35, 0x03, 0x33, 0x16, 0x17, 0x15, 0x07, 0x27, 0x35, 0x25, 0x33, 0x17,
-  0x15, 0x07, 0x27, 0x35, 0x25, 0x33, 0x17, 0x11, 0x07, 0x23, 0x27, 0x11,
-  0x03, 0x1b, 0x45, 0x05, 0x05, 0x45, 0x06, 0x01, 0xff, 0x34, 0xdf, 0x37,
-  0xfd, 0x4a, 0xe3, 0x37, 0x03, 0xb4, 0x29, 0x01, 0xf8, 0xbc, 0x50, 0x0c,
-  0xac, 0x3f, 0x2a, 0x9d, 0x58, 0x20, 0xa5, 0x3c, 0xfd, 0x90, 0x01, 0x31,
-  0x06, 0x06, 0xfe, 0xcf, 0x05, 0x04, 0x03, 0x01, 0x36, 0x07, 0x07, 0xfe,
-  0xca, 0x06, 0x3f, 0x02, 0x79, 0x66, 0x37, 0xdf, 0xfd, 0xf0, 0x03, 0x35,
-  0xde, 0x37, 0x01, 0xe5, 0x45, 0x05, 0x05, 0x45, 0x06, 0x05, 0xd5, 0x06,
-  0xfe, 0xa2, 0x06, 0x06, 0x01, 0x5e, 0x9b, 0x3f, 0x03, 0xfe, 0x3f, 0xee,
-  0xfe, 0x40, 0xc7, 0x37, 0x04, 0xb5, 0xe1, 0x60, 0xbd, 0x64, 0x17, 0xa7,
-  0x3f, 0x5c, 0xb5, 0x67, 0x1b, 0xfe, 0xed, 0x06, 0x4f, 0x06, 0x06, 0x4f,
-  0x06, 0x06, 0x4f, 0x06, 0x06, 0x4f, 0xfe, 0xe8, 0x82, 0x79, 0x03, 0x3e,
-  0xfd, 0x04, 0x2a, 0x3c, 0x03, 0xfe, 0x3f, 0x04, 0x76, 0x06, 0xfe, 0xa2,
-  0x06, 0x06, 0x01, 0x5e, 0x00, 0x01, 0x00, 0x5d, 0xff, 0xfb, 0x06, 0xd5,
-  0x02, 0xe1, 0x00, 0x22, 0x00, 0x00, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x36,
-  0x33, 0x16, 0x15, 0x14, 0x07, 0x16, 0x1d, 0x01, 0x06, 0x23, 0x21, 0x35,
-  0x32, 0x37, 0x36, 0x3b, 0x01, 0x27, 0x34, 0x3f, 0x01, 0x17, 0x27, 0x34,
-  0x3f, 0x01, 0x32, 0x17, 0x36, 0x04, 0x76, 0x14, 0xc3, 0x69, 0x13, 0x23,
-  0x31, 0x7a, 0x1f, 0x5d, 0x11, 0x48, 0xf9, 0xe2, 0x33, 0x79, 0x29, 0x2f,
-  0x1d, 0x0a, 0x90, 0x23, 0x26, 0x05, 0xb8, 0x3c, 0x2b, 0x2a, 0x6c, 0x02,
-  0xe1, 0xe8, 0x56, 0x23, 0x1b, 0x6d, 0x31, 0x34, 0x17, 0x48, 0x1a, 0x65,
-  0x09, 0xae, 0x27, 0x31, 0x6c, 0x31, 0x04, 0x04, 0x0c, 0x93, 0x5a, 0x08,
-  0x2b, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x1b,
-  0x05, 0xd5, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x33, 0x17, 0x15, 0x33, 0x20,
-  0x13, 0x16, 0x1d, 0x01, 0x23, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07,
-  0x15, 0x14, 0x07, 0x27, 0x26, 0x23, 0x11, 0x14, 0x0f, 0x01, 0x22, 0x2f,
-  0x01, 0x35, 0x37, 0x33, 0x17, 0x15, 0x16, 0x3b, 0x01, 0x32, 0x3f, 0x01,
-  0x11, 0x22, 0x07, 0x06, 0x23, 0x27, 0x35, 0x37, 0x23, 0x26, 0x27, 0x23,
-  0x22, 0x0f, 0x01, 0x23, 0x35, 0x36, 0x37, 0x36, 0x21, 0x35, 0x03, 0x30,
-  0x34, 0x06, 0x02, 0x01, 0x8c, 0xfc, 0x26, 0x01, 0x14, 0x11, 0x20, 0x33,
-  0x28, 0x87, 0x64, 0x08, 0x1d, 0x88, 0x7b, 0x5f, 0x1b, 0x52, 0x21, 0x02,
-  0x05, 0x27, 0x05, 0x09, 0x38, 0x09, 0x32, 0x12, 0x05, 0xbe, 0x4d, 0x10,
-  0x0c, 0x06, 0x06, 0x04, 0x3c, 0xb1, 0x3d, 0x59, 0x1e, 0x12, 0x03, 0x34,
-  0xad, 0xd7, 0x01, 0x19, 0x05, 0xd5, 0x06, 0x7d, 0xfe, 0x1a, 0x56, 0x0d,
-  0x08, 0x0f, 0x2e, 0x18, 0x65, 0x33, 0x0f, 0x02, 0x42, 0x3d, 0xfd, 0x53,
-  0x65, 0x18, 0x02, 0x60, 0x1c, 0x1a, 0x06, 0x06, 0x0c, 0x65, 0x39, 0x2a,
-  0x02, 0xa4, 0x3d, 0x39, 0x06, 0x0c, 0x33, 0x40, 0x1b, 0x3d, 0x12, 0x02,
-  0x90, 0xda, 0xdf, 0x7d, 0x00, 0x1a, 0x00, 0x99, 0xff, 0xff, 0x05, 0xdc,
-  0x07, 0x6b, 0x00, 0x0d, 0x00, 0x15, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x43,
-  0x00, 0x60, 0x00, 0x8c, 0x00, 0xb7, 0x00, 0xe3, 0x01, 0x0e, 0x01, 0x3a,
-  0x01, 0x64, 0x01, 0x90, 0x01, 0xbb, 0x01, 0xe6, 0x02, 0x0f, 0x02, 0x3b,
-  0x02, 0x65, 0x02, 0x6d, 0x02, 0x75, 0x02, 0x7d, 0x02, 0xa9, 0x02, 0xd3,
-  0x02, 0xfd, 0x03, 0x27, 0x03, 0x53, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32,
-  0x37, 0x33, 0x06, 0x07, 0x26, 0x27, 0x33, 0x16, 0x33, 0x32, 0x37, 0x26,
-  0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x07, 0x26, 0x27, 0x36, 0x37, 0x16,
-  0x17, 0x06, 0x03, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x27, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x32,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x33, 0x06, 0x13, 0x36, 0x37, 0x32, 0x1f, 0x01, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x20, 0x24, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x37, 0x01, 0x17, 0x27,
-  0x26, 0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f,
-  0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23,
-  0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27,
-  0x26, 0x35, 0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01,
-  0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14,
-  0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06,
-  0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32,
-  0x05, 0x17, 0x27, 0x26, 0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32,
-  0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01,
-  0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34,
-  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x13, 0x17, 0x27, 0x26,
-  0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17,
-  0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35,
-  0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35,
-  0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x33, 0x32, 0x0f, 0x01, 0x37,
-  0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23,
-  0x22, 0x2f, 0x01, 0x17, 0x14, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23,
-  0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x01,
-  0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14,
-  0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x14,
-  0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27,
-  0x26, 0x35, 0x34, 0x33, 0x32, 0x05, 0x17, 0x27, 0x34, 0x33, 0x32, 0x15,
-  0x07, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15,
-  0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07,
-  0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33,
-  0x32, 0x03, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32,
-  0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01,
-  0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34,
-  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x05, 0x17, 0x27, 0x26,
-  0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17,
-  0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35,
-  0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35,
-  0x34, 0x33, 0x32, 0x1f, 0x01, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36,
-  0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x14, 0x23, 0x22, 0x2f,
-  0x01, 0x17, 0x14, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x34,
-  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x37, 0x17, 0x27, 0x34,
-  0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01,
-  0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22,
-  0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26,
-  0x35, 0x34, 0x33, 0x32, 0x37, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37,
-  0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23,
-  0x22, 0x2f, 0x01, 0x17, 0x16, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22,
-  0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x13, 0x26,
-  0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x05, 0x26, 0x27, 0x36, 0x37, 0x16,
-  0x17, 0x06, 0x17, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x01, 0x17,
-  0x27, 0x26, 0x33, 0x32, 0x15, 0x07, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14,
-  0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16,
-  0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01,
-  0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x32, 0x0f,
-  0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15,
-  0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x14, 0x22, 0x35, 0x37, 0x07, 0x06,
-  0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32,
-  0x05, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15,
-  0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17,
-  0x16, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01,
-  0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x32, 0x0f,
-  0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15,
-  0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x22, 0x35, 0x37, 0x07, 0x06,
-  0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32,
-  0x01, 0x17, 0x27, 0x26, 0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32,
-  0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01,
-  0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34,
-  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x03, 0x96, 0x07, 0x07,
-  0x3c, 0x16, 0x17, 0x05, 0x73, 0x71, 0x08, 0x15, 0x21, 0x36, 0x07, 0x6e,
-  0x26, 0x01, 0x03, 0x26, 0x23, 0x03, 0x03, 0xf9, 0x25, 0x02, 0x02, 0x27,
-  0x24, 0x03, 0x03, 0x3a, 0x22, 0x02, 0x03, 0x23, 0x21, 0x01, 0x01, 0xb6,
-  0x70, 0xde, 0x9e, 0x9c, 0xe0, 0x70, 0x5b, 0x7d, 0x02, 0x03, 0x36, 0x28,
-  0x3b, 0x71, 0x54, 0x52, 0x7d, 0x3c, 0x28, 0x32, 0x82, 0x13, 0x17, 0x85,
-  0x77, 0x2c, 0x02, 0x4a, 0x44, 0x12, 0x16, 0x64, 0x4e, 0x80, 0xff, 0xfe,
-  0x92, 0xff, 0x00, 0x80, 0x53, 0x6a, 0x12, 0x12, 0x44, 0x44, 0xfd, 0xe5,
-  0x25, 0x05, 0x01, 0x0d, 0x10, 0x02, 0x05, 0x24, 0x03, 0x04, 0x0e, 0x07,
-  0x2b, 0x2a, 0x08, 0x0e, 0x04, 0x03, 0x24, 0x05, 0x01, 0x0f, 0x0c, 0x04,
-  0x24, 0x02, 0x05, 0x0c, 0x08, 0x29, 0x2c, 0x06, 0x0d, 0x05, 0x01, 0x0a,
-  0x21, 0x05, 0x02, 0x1b, 0x02, 0x05, 0x21, 0x04, 0x03, 0x0d, 0x06, 0x28,
-  0x26, 0x06, 0x0b, 0x04, 0x03, 0x1f, 0x03, 0x01, 0x0c, 0x0c, 0x04, 0x20,
-  0x03, 0x03, 0x0c, 0x07, 0x25, 0x26, 0x07, 0x0d, 0x03, 0x03, 0x0f, 0x21,
-  0x05, 0x02, 0x0d, 0x0e, 0x01, 0x06, 0x21, 0x03, 0x05, 0x0b, 0x06, 0x27,
-  0x25, 0x07, 0x0a, 0x06, 0x02, 0x20, 0x05, 0x01, 0x0e, 0x0b, 0x04, 0x20,
-  0x03, 0x03, 0x0d, 0x08, 0x25, 0x26, 0x07, 0x0d, 0x03, 0x5c, 0x21, 0x06,
-  0x01, 0x1b, 0x02, 0x06, 0x22, 0x03, 0x04, 0x0c, 0x06, 0x27, 0x25, 0x07,
-  0x0b, 0x06, 0x01, 0x21, 0x05, 0x01, 0x0d, 0x0c, 0x05, 0x20, 0x03, 0x04,
-  0x0b, 0x07, 0x25, 0x26, 0x07, 0x0c, 0x04, 0xfc, 0x37, 0x11, 0x02, 0x01,
-  0x06, 0x07, 0x01, 0x02, 0x12, 0x01, 0x01, 0x08, 0x03, 0x16, 0x15, 0x04,
-  0x08, 0x01, 0x01, 0x11, 0x01, 0x06, 0x05, 0x02, 0x11, 0x02, 0x03, 0x05,
-  0x03, 0x15, 0x16, 0x02, 0x07, 0x01, 0x02, 0xc8, 0x12, 0x02, 0x01, 0x10,
-  0x01, 0x03, 0x13, 0x02, 0x02, 0x08, 0x04, 0x17, 0x16, 0x04, 0x07, 0x02,
-  0x02, 0x13, 0x03, 0x0e, 0x02, 0x12, 0x02, 0x02, 0x07, 0x03, 0x17, 0x17,
-  0x04, 0x08, 0x02, 0xfd, 0x0e, 0x12, 0x04, 0x06, 0x08, 0x04, 0x11, 0x03,
-  0x02, 0x07, 0x05, 0x14, 0x14, 0x04, 0x06, 0x02, 0x03, 0x11, 0x03, 0x01,
-  0x08, 0x06, 0x04, 0x12, 0x02, 0x02, 0x06, 0x03, 0x14, 0x14, 0x04, 0x07,
-  0x02, 0x53, 0x12, 0x04, 0x01, 0x0f, 0x01, 0x03, 0x11, 0x03, 0x02, 0x06,
-  0x03, 0x15, 0x14, 0x04, 0x06, 0x02, 0x03, 0x11, 0x03, 0x01, 0x07, 0x07,
-  0x03, 0x11, 0x02, 0x02, 0x07, 0x05, 0x13, 0x13, 0x05, 0x07, 0x02, 0x01,
-  0x00, 0x11, 0x02, 0x01, 0x0f, 0x01, 0x03, 0x11, 0x01, 0x03, 0x07, 0x04,
-  0x14, 0x13, 0x05, 0x07, 0x03, 0x01, 0x11, 0x03, 0x01, 0x08, 0x06, 0x02,
-  0x11, 0x02, 0x01, 0x07, 0x04, 0x14, 0x15, 0x03, 0x07, 0x01, 0x64, 0x11,
-  0x02, 0x02, 0x0f, 0x01, 0x03, 0x12, 0x01, 0x02, 0x07, 0x03, 0x15, 0x15,
-  0x03, 0x07, 0x02, 0x01, 0x11, 0x02, 0x06, 0x06, 0x02, 0x11, 0x02, 0x03,
-  0x05, 0x04, 0x13, 0x14, 0x03, 0x05, 0x03, 0xde, 0x13, 0x02, 0x06, 0x08,
-  0x01, 0x03, 0x14, 0x01, 0x04, 0x07, 0x05, 0x17, 0x16, 0x06, 0x07, 0x04,
-  0x02, 0x12, 0x02, 0x01, 0x08, 0x06, 0x02, 0x13, 0x02, 0x02, 0x07, 0x04,
-  0x16, 0x17, 0x03, 0x07, 0x02, 0x52, 0x13, 0x02, 0x01, 0x10, 0x01, 0x04,
-  0x14, 0x02, 0x02, 0x07, 0x03, 0x17, 0x16, 0x04, 0x07, 0x02, 0x02, 0x14,
-  0x03, 0x01, 0x0e, 0x02, 0x13, 0x01, 0x03, 0x07, 0x04, 0x17, 0x18, 0x03,
-  0x08, 0x02, 0x9c, 0x21, 0x02, 0x02, 0x25, 0x1f, 0x03, 0x03, 0xfe, 0xd8,
-  0x22, 0x02, 0x03, 0x23, 0x21, 0x01, 0x01, 0xe3, 0x22, 0x02, 0x02, 0x25,
-  0x1f, 0x03, 0x03, 0x01, 0x3d, 0x20, 0x05, 0x01, 0x0d, 0x0d, 0x06, 0x20,
-  0x03, 0x05, 0x0b, 0x06, 0x26, 0x25, 0x07, 0x0b, 0x05, 0x03, 0x20, 0x04,
-  0x02, 0x0d, 0x0c, 0x05, 0x20, 0x03, 0x04, 0x0d, 0x08, 0x26, 0x27, 0x07,
-  0x0d, 0x04, 0xfc, 0xb3, 0x12, 0x02, 0x01, 0x10, 0x01, 0x04, 0x13, 0x03,
-  0x02, 0x08, 0x04, 0x17, 0x16, 0x04, 0x07, 0x02, 0x03, 0x13, 0x04, 0x0e,
-  0x02, 0x12, 0x02, 0x02, 0x07, 0x03, 0x17, 0x18, 0x03, 0x08, 0x02, 0xfe,
-  0x7c, 0x14, 0x03, 0x01, 0x10, 0x01, 0x02, 0x13, 0x01, 0x02, 0x07, 0x02,
-  0x18, 0x17, 0x03, 0x07, 0x02, 0x01, 0x13, 0x01, 0x01, 0x0e, 0x03, 0x14,
-  0x01, 0x02, 0x08, 0x05, 0x16, 0x17, 0x04, 0x08, 0x02, 0x03, 0xc5, 0x14,
-  0x03, 0x01, 0x10, 0x01, 0x03, 0x13, 0x02, 0x02, 0x07, 0x02, 0x18, 0x17,
-  0x03, 0x07, 0x02, 0x02, 0x13, 0x02, 0x01, 0x0e, 0x03, 0x14, 0x01, 0x03,
-  0x07, 0x05, 0x16, 0x17, 0x04, 0x08, 0x02, 0xfc, 0xa4, 0x22, 0x05, 0x02,
-  0x0d, 0x0e, 0x02, 0x05, 0x21, 0x03, 0x05, 0x0b, 0x06, 0x27, 0x25, 0x07,
-  0x0a, 0x06, 0x02, 0x20, 0x04, 0x01, 0x0d, 0x0b, 0x04, 0x21, 0x02, 0x03,
-  0x0d, 0x07, 0x26, 0x26, 0x08, 0x0e, 0x03, 0x03, 0x89, 0x01, 0x26, 0x45,
-  0x05, 0x07, 0x43, 0x26, 0x56, 0x02, 0x2a, 0x2c, 0x03, 0x03, 0x29, 0x2d,
-  0x04, 0x02, 0x29, 0x2d, 0x03, 0x03, 0x2a, 0x2c, 0xfe, 0x12, 0x02, 0x25,
-  0x26, 0x02, 0x02, 0x25, 0x26, 0x9e, 0x66, 0x93, 0x91, 0xd0, 0xd0, 0x91,
-  0x93, 0x66, 0x55, 0x20, 0x33, 0x48, 0x68, 0x66, 0x65, 0x65, 0x66, 0x68,
-  0x48, 0x32, 0x1e, 0x01, 0xd9, 0x70, 0x18, 0x75, 0x13, 0x5e, 0xe8, 0x51,
-  0x18, 0x10, 0x1c, 0x46, 0x73, 0xa5, 0xa3, 0xe6, 0xe6, 0xa3, 0xa5, 0x73,
-  0x4b, 0x1a, 0x0f, 0x16, 0x51, 0xe8, 0x47, 0xfd, 0x68, 0x21, 0x39, 0x0f,
-  0x0f, 0x39, 0x21, 0x04, 0x11, 0x0b, 0x03, 0x15, 0x16, 0x03, 0x0c, 0x0f,
-  0x02, 0x21, 0x37, 0x10, 0x10, 0x37, 0x21, 0x02, 0x0f, 0x0c, 0x03, 0x16,
-  0x15, 0x03, 0x0b, 0x11, 0x01, 0xd1, 0x1f, 0x34, 0x0d, 0x0d, 0x34, 0x1f,
-  0x03, 0x10, 0x07, 0x05, 0x14, 0x13, 0x03, 0x09, 0x0e, 0x02, 0x1e, 0x32,
-  0x0f, 0x0f, 0x32, 0x1e, 0x02, 0x0e, 0x09, 0x03, 0x13, 0x14, 0x05, 0x07,
-  0x10, 0x4b, 0x1f, 0x34, 0x0e, 0x0e, 0x34, 0x1f, 0x03, 0x10, 0x07, 0x03,
-  0x15, 0x13, 0x04, 0x09, 0x0e, 0x02, 0x1e, 0x32, 0x0e, 0x0e, 0x32, 0x1e,
-  0x02, 0x0e, 0x09, 0x04, 0x13, 0x15, 0x03, 0x07, 0x10, 0x01, 0x1b, 0x1e,
-  0x32, 0x0e, 0x0e, 0x32, 0x1e, 0x02, 0x0e, 0x09, 0x04, 0x13, 0x14, 0x03,
-  0x09, 0x0f, 0x03, 0x1d, 0x31, 0x0e, 0x0e, 0x31, 0x1d, 0x03, 0x0f, 0x09,
-  0x03, 0x14, 0x13, 0x04, 0x09, 0x0e, 0x02, 0x9a, 0x10, 0x1c, 0x06, 0x06,
-  0x1c, 0x10, 0x01, 0x07, 0x06, 0x02, 0x09, 0x0b, 0x02, 0x04, 0x08, 0x02,
-  0x0e, 0x19, 0x07, 0x07, 0x19, 0x0e, 0x02, 0x08, 0x04, 0x02, 0x0b, 0x09,
-  0x02, 0x06, 0x07, 0xfe, 0xe3, 0x11, 0x1d, 0x0a, 0x0a, 0x1d, 0x11, 0x03,
-  0x0a, 0x05, 0x01, 0x0d, 0x0a, 0x03, 0x06, 0x07, 0x01, 0x11, 0x1e, 0x07,
-  0x07, 0x1e, 0x11, 0x01, 0x07, 0x06, 0x03, 0x0a, 0x0d, 0x01, 0x05, 0x0a,
-  0xa8, 0x10, 0x1c, 0x07, 0x07, 0x1c, 0x10, 0x02, 0x07, 0x06, 0x02, 0x09,
-  0x0b, 0x02, 0x05, 0x08, 0x02, 0x0f, 0x1a, 0x08, 0x08, 0x1a, 0x0f, 0x02,
-  0x08, 0x05, 0x02, 0x0b, 0x09, 0x02, 0x06, 0x07, 0x01, 0x18, 0x10, 0x1c,
-  0x06, 0x06, 0x1c, 0x10, 0x02, 0x08, 0x04, 0x03, 0x0a, 0x0a, 0x02, 0x05,
-  0x07, 0x01, 0x0f, 0x19, 0x08, 0x08, 0x19, 0x0f, 0x01, 0x07, 0x05, 0x02,
-  0x0a, 0x0a, 0x03, 0x04, 0x08, 0x18, 0x0f, 0x1b, 0x07, 0x07, 0x1b, 0x0f,
-  0x02, 0x08, 0x05, 0x01, 0x0a, 0x0b, 0x01, 0x06, 0x07, 0x01, 0x10, 0x1b,
-  0x08, 0x08, 0x1b, 0x10, 0x01, 0x07, 0x06, 0x01, 0x0b, 0x0a, 0x01, 0x06,
-  0x07, 0xa1, 0x0f, 0x1b, 0x07, 0x07, 0x1b, 0x0f, 0x01, 0x07, 0x04, 0x01,
-  0x0c, 0x0a, 0x01, 0x0c, 0x01, 0x0f, 0x1b, 0x07, 0x07, 0x1b, 0x0f, 0x01,
-  0x0c, 0x01, 0x0a, 0x0c, 0x01, 0x04, 0x07, 0x37, 0x12, 0x1f, 0x07, 0x07,
-  0x1f, 0x12, 0x01, 0x08, 0x05, 0x02, 0x0c, 0x0c, 0x02, 0x05, 0x08, 0x01,
-  0x12, 0x1d, 0x0a, 0x0a, 0x1d, 0x12, 0x01, 0x08, 0x05, 0x02, 0x0c, 0x0c,
-  0x02, 0x05, 0x08, 0xd9, 0x12, 0x1f, 0x07, 0x07, 0x1f, 0x12, 0x01, 0x08,
-  0x05, 0x02, 0x0b, 0x0c, 0x02, 0x05, 0x0a, 0x03, 0x10, 0x1c, 0x09, 0x09,
-  0x1c, 0x10, 0x03, 0x0a, 0x05, 0x02, 0x0c, 0x0b, 0x02, 0x06, 0x07, 0xfa,
-  0xe0, 0x02, 0x25, 0x26, 0x02, 0x02, 0x25, 0x26, 0xe2, 0x02, 0x25, 0x27,
-  0x02, 0x03, 0x25, 0x26, 0x02, 0x02, 0x25, 0x27, 0x02, 0x03, 0x25, 0x26,
-  0x01, 0x81, 0x1d, 0x32, 0x0e, 0x0e, 0x32, 0x1d, 0x03, 0x0f, 0x09, 0x03,
-  0x13, 0x14, 0x03, 0x0a, 0x0e, 0x04, 0x1b, 0x2f, 0x0f, 0x0f, 0x2f, 0x1b,
-  0x04, 0x0e, 0x0a, 0x03, 0x14, 0x13, 0x03, 0x09, 0x0f, 0x02, 0x67, 0x12,
-  0x1e, 0x08, 0x08, 0x1e, 0x12, 0x01, 0x0a, 0x04, 0x02, 0x0b, 0x0c, 0x02,
-  0x06, 0x08, 0x02, 0x11, 0x1d, 0x09, 0x09, 0x1d, 0x11, 0x02, 0x08, 0x06,
-  0x02, 0x0c, 0x0b, 0x02, 0x04, 0x0a, 0xfb, 0x12, 0x1f, 0x07, 0x07, 0x1f,
-  0x12, 0x01, 0x08, 0x05, 0x03, 0x0b, 0x0c, 0x02, 0x05, 0x09, 0x01, 0x12,
-  0x1c, 0x0a, 0x0a, 0x1c, 0x12, 0x01, 0x09, 0x05, 0x02, 0x0c, 0x0b, 0x03,
-  0x05, 0x08, 0x01, 0x82, 0x11, 0x1e, 0x08, 0x08, 0x1e, 0x11, 0x02, 0x08,
-  0x07, 0x01, 0x0b, 0x0c, 0x02, 0x05, 0x09, 0x01, 0x11, 0x1c, 0x09, 0x09,
-  0x1c, 0x11, 0x01, 0x09, 0x05, 0x02, 0x0c, 0x0b, 0x01, 0x07, 0x08, 0xfd,
-  0x7f, 0x1f, 0x34, 0x0e, 0x0e, 0x34, 0x1f, 0x03, 0x10, 0x07, 0x04, 0x14,
-  0x13, 0x03, 0x0a, 0x0e, 0x03, 0x1d, 0x32, 0x0e, 0x0e, 0x32, 0x1d, 0x03,
-  0x0e, 0x0a, 0x03, 0x13, 0x14, 0x04, 0x07, 0x10, 0x00, 0x0f, 0x00, 0x75,
-  0x00, 0x00, 0x05, 0xff, 0x07, 0x0b, 0x00, 0x17, 0x00, 0x2d, 0x00, 0x3e,
-  0x00, 0x4f, 0x00, 0x60, 0x00, 0x71, 0x00, 0x82, 0x00, 0x93, 0x00, 0xa4,
-  0x00, 0xb5, 0x00, 0xc6, 0x00, 0xd7, 0x00, 0xe8, 0x00, 0xf9, 0x01, 0x0a,
-  0x00, 0x00, 0x01, 0x16, 0x15, 0x14, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x2b,
-  0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x3f, 0x02, 0x36, 0x33, 0x32, 0x33,
-  0x16, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x33, 0x32,
-  0x3f, 0x01, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x26, 0x23, 0x22, 0x07, 0x13,
-  0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01,
-  0x35, 0x34, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x13, 0x32, 0x17,
-  0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34,
-  0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d,
-  0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x3d, 0x01, 0x34, 0x37, 0x36,
-  0x03, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f,
-  0x01, 0x35, 0x34, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37, 0x32,
-  0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35,
-  0x34, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16,
-  0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x25, 0x32, 0x17, 0x16, 0x1d, 0x01,
-  0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01,
-  0x35, 0x34, 0x37, 0x36, 0x02, 0x0a, 0x29, 0x17, 0x12, 0x2d, 0x13, 0x56,
-  0x6f, 0x14, 0x2f, 0x22, 0x2a, 0x36, 0x25, 0x0b, 0x5a, 0x7b, 0x03, 0x03,
-  0x38, 0xec, 0x47, 0x08, 0x05, 0x0c, 0x0d, 0x1b, 0x27, 0x2f, 0x41, 0x2e,
-  0x4a, 0x04, 0x1d, 0x1c, 0x2c, 0x31, 0x44, 0xdf, 0x1a, 0x0d, 0x07, 0x18,
-  0x0a, 0x0b, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0x97, 0x1a, 0x0d, 0x07, 0x18,
-  0x09, 0x0c, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0x7c, 0x19, 0x0e, 0x06, 0x17,
-  0x09, 0x0d, 0x1f, 0x0d, 0x01, 0x17, 0x0c, 0x8c, 0x19, 0x0d, 0x07, 0x18,
-  0x09, 0x0c, 0x20, 0x0c, 0x01, 0x17, 0x0c, 0x02, 0x1a, 0x0d, 0x07, 0x18,
-  0x09, 0x0d, 0x1f, 0x0d, 0x17, 0x0c, 0xab, 0x1b, 0x0d, 0x06, 0x17, 0x0a,
-  0x0c, 0x20, 0x0c, 0x01, 0x18, 0x0c, 0x01, 0x62, 0x19, 0x0e, 0x06, 0x17,
-  0x09, 0x0d, 0x1f, 0x0d, 0x01, 0x17, 0x0c, 0xaf, 0x1a, 0x0d, 0x07, 0x18,
-  0x0a, 0x0b, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0xae, 0x1a, 0x0e, 0x06, 0x17,
-  0x0a, 0x0c, 0x20, 0x0c, 0x01, 0x18, 0x0b, 0xfd, 0x9a, 0x1a, 0x0d, 0x07,
-  0x18, 0x0a, 0x0b, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0xf6, 0x1a, 0x0d, 0x06,
-  0x17, 0x09, 0x0d, 0x1f, 0x0d, 0x01, 0x18, 0x0b, 0x01, 0x05, 0x1b, 0x0d,
-  0x06, 0x17, 0x0a, 0x0c, 0x20, 0x0c, 0x01, 0x18, 0x0b, 0xea, 0x19, 0x0d,
-  0x06, 0x17, 0x09, 0x0c, 0x20, 0x0d, 0x01, 0x18, 0x0c, 0x02, 0x20, 0x37,
-  0x51, 0x3d, 0x4b, 0x47, 0x3c, 0x1a, 0x73, 0x07, 0x2d, 0x38, 0x50, 0x5a,
-  0x79, 0x39, 0x0e, 0x7a, 0x0c, 0x80, 0x5f, 0x65, 0x22, 0x22, 0x16, 0x10,
-  0x12, 0x23, 0x2f, 0x32, 0x64, 0x74, 0x1a, 0x1b, 0x30, 0x26, 0x32, 0x01,
-  0x6a, 0x1f, 0x0c, 0x0f, 0x06, 0x1f, 0x12, 0x07, 0x2c, 0x0e, 0x03, 0x1f,
-  0x14, 0x08, 0x01, 0x3a, 0x1e, 0x0c, 0x0f, 0x07, 0x1e, 0x13, 0x08, 0x2e,
-  0x0c, 0x05, 0x1e, 0x14, 0x08, 0x01, 0x34, 0x1f, 0x0c, 0x0e, 0x07, 0x1e,
-  0x14, 0x07, 0x2e, 0x0c, 0x05, 0x1e, 0x14, 0x08, 0x01, 0x3d, 0x1f, 0x0c,
-  0x0f, 0x06, 0x1f, 0x12, 0x07, 0x2c, 0x0d, 0x04, 0x1f, 0x14, 0x08, 0xfd,
-  0x02, 0x1f, 0x0c, 0x0f, 0x06, 0x1f, 0x12, 0x07, 0x2c, 0x0e, 0x03, 0x20,
-  0x13, 0x08, 0xfe, 0xfc, 0x1f, 0x0c, 0x0e, 0x06, 0x20, 0x12, 0x07, 0x2d,
-  0x0d, 0x04, 0x1f, 0x13, 0x08, 0x02, 0x07, 0x1e, 0x0c, 0x0f, 0x07, 0x1e,
-  0x13, 0x07, 0x2d, 0x0c, 0x05, 0x1e, 0x15, 0x07, 0xfa, 0x1e, 0x0c, 0x0f,
-  0x07, 0x1e, 0x13, 0x07, 0x2d, 0x0c, 0x05, 0x1e, 0x15, 0x07, 0x01, 0x04,
-  0x20, 0x0c, 0x0e, 0x06, 0x1f, 0x12, 0x08, 0x2d, 0x0d, 0x04, 0x1f, 0x13,
-  0x09, 0xfb, 0x0c, 0x1e, 0x0c, 0x0f, 0x07, 0x1e, 0x13, 0x08, 0x2e, 0x0c,
-  0x05, 0x1e, 0x14, 0x08, 0xd3, 0x1e, 0x0c, 0x0e, 0x07, 0x1e, 0x14, 0x07,
-  0x2e, 0x0c, 0x05, 0x1e, 0x14, 0x07, 0xe7, 0x1f, 0x0c, 0x0e, 0x06, 0x20,
-  0x12, 0x07, 0x2c, 0x0e, 0x03, 0x20, 0x13, 0x08, 0xca, 0x1f, 0x0c, 0x0e,
-  0x06, 0x20, 0x12, 0x07, 0x2d, 0x0d, 0x03, 0x20, 0x13, 0x08, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x77, 0xff, 0xf7, 0x05, 0xfd, 0x05, 0xc9, 0x00, 0x09,
-  0x00, 0x00, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x01, 0x13, 0x09, 0x01, 0x13,
-  0x78, 0x02, 0x1b, 0xa7, 0xa8, 0x02, 0x1b, 0xfe, 0x4c, 0xa7, 0xfe, 0x4a,
-  0xfe, 0x4b, 0xa6, 0x03, 0x90, 0x02, 0x39, 0xfd, 0xc7, 0xfe, 0x9f, 0xfd,
-  0xc8, 0x01, 0x60, 0xfe, 0xa0, 0x02, 0x38, 0x00, 0x00, 0x02, 0x00, 0x77,
-  0xff, 0xf7, 0x05, 0xfd, 0x05, 0xc9, 0x00, 0x09, 0x00, 0x13, 0x00, 0x00,
-  0x13, 0x21, 0x1b, 0x01, 0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x37, 0x03,
-  0x09, 0x01, 0x03, 0x01, 0x21, 0x0b, 0x01, 0x21, 0x78, 0x02, 0x1b, 0xa7,
-  0xa8, 0x02, 0x1b, 0xfe, 0x4c, 0xa7, 0xfe, 0x4a, 0xfe, 0x4b, 0xa6, 0x3d,
-  0x7e, 0x01, 0x50, 0x01, 0x5a, 0x89, 0x01, 0x67, 0xfe, 0x4b, 0x83, 0x80,
-  0xfe, 0x49, 0x03, 0x90, 0x02, 0x39, 0xfd, 0xc7, 0xfe, 0x9f, 0xfd, 0xc8,
-  0x01, 0x60, 0xfe, 0xa0, 0x02, 0x38, 0x15, 0xfe, 0x4e, 0x01, 0x0c, 0xfe,
-  0xe6, 0x01, 0xc2, 0x01, 0x18, 0x01, 0xb7, 0xfe, 0x49, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x99, 0x00, 0x04, 0x03, 0x87, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x00, 0x01, 0x16, 0x17, 0x14, 0x07, 0x09, 0x01, 0x37, 0x13, 0x25,
-  0x37, 0x01, 0x26, 0x35, 0x34, 0x37, 0x01, 0x36, 0x03, 0x52, 0x33, 0x02,
-  0x08, 0xfd, 0xbd, 0x01, 0xbc, 0x4e, 0x22, 0xfe, 0x65, 0xc9, 0xfe, 0x14,
-  0x11, 0x3b, 0x02, 0x51, 0x09, 0x05, 0xd5, 0x02, 0x36, 0x24, 0x0c, 0xfd,
-  0x85, 0xfd, 0xf4, 0xe6, 0xfe, 0x38, 0x27, 0x5e, 0x02, 0x34, 0x17, 0x17,
-  0x1b, 0x3f, 0x02, 0x86, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdb, 0x05, 0xd9, 0x00, 0x19, 0x00, 0x00, 0x13, 0x21,
-  0x32, 0x15, 0x14, 0x07, 0x09, 0x01, 0x37, 0x13, 0x25, 0x37, 0x01, 0x26,
-  0x35, 0x34, 0x37, 0x01, 0x21, 0x11, 0x06, 0x07, 0x26, 0x27, 0x11, 0x36,
-  0xd5, 0x04, 0xc2, 0x3a, 0x19, 0xfd, 0xfb, 0x01, 0xb6, 0x50, 0x21, 0xfe,
-  0x60, 0xd0, 0xfe, 0x24, 0x0e, 0x2f, 0x01, 0xb4, 0xfc, 0x18, 0x01, 0x41,
-  0x3f, 0x01, 0x01, 0x05, 0xd9, 0x53, 0x22, 0x1b, 0xfd, 0xc5, 0xfe, 0x1b,
-  0xd5, 0xfe, 0x3d, 0x22, 0x6c, 0x02, 0x16, 0x10, 0x2d, 0x1c, 0x32, 0x01,
-  0xdf, 0xfa, 0xfc, 0x44, 0x01, 0x01, 0x43, 0x05, 0x5b, 0x39, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd8, 0x00, 0x0d,
-  0x00, 0x19, 0x00, 0x26, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x20,
-  0x00, 0x11, 0x34, 0x02, 0x24, 0x20, 0x04, 0x02, 0x05, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x05, 0xdb, 0xfe,
-  0x76, 0xfe, 0xe8, 0xfe, 0xea, 0xfe, 0x76, 0xb5, 0x01, 0x44, 0xa7, 0xaa,
-  0x01, 0x44, 0xb4, 0xfb, 0x00, 0x01, 0x62, 0x01, 0xf8, 0x01, 0x63, 0xa2,
-  0xfe, 0xdc, 0xfe, 0xce, 0xfe, 0xdd, 0xa2, 0x03, 0x07, 0x62, 0x46, 0x45,
-  0x63, 0x2d, 0x51, 0x54, 0x52, 0x2c, 0x02, 0xec, 0xfe, 0xc9, 0xfe, 0x4b,
-  0x01, 0xb5, 0x01, 0x37, 0xc2, 0x01, 0x69, 0xc1, 0xc1, 0xfe, 0x99, 0xc4,
-  0xfe, 0xe8, 0xfe, 0x77, 0x01, 0x89, 0x01, 0x18, 0xb1, 0x01, 0x42, 0xae,
-  0xae, 0xfe, 0xbe, 0xb1, 0x4e, 0x6d, 0x6d, 0x4e, 0x31, 0x5a, 0x30, 0x30,
-  0x5a, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x70, 0x00, 0x00, 0x05, 0xf6,
-  0x05, 0xd1, 0x00, 0x0a, 0x00, 0x16, 0x00, 0x43, 0x00, 0x00, 0x00, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x25, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x25, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x24, 0x20, 0x04, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
-  0x10, 0x06, 0x23, 0x22, 0x26, 0x10, 0x37, 0x36, 0x37, 0x26, 0x35, 0x34,
-  0x00, 0x21, 0x20, 0x00, 0x15, 0x14, 0x05, 0x1f, 0x85, 0x5d, 0x5d, 0x43,
-  0x41, 0x5e, 0xfc, 0x0c, 0x41, 0x5e, 0x5e, 0x41, 0x43, 0x5d, 0x5d, 0x03,
-  0xae, 0x17, 0x14, 0x52, 0xa4, 0x75, 0x74, 0xa4, 0x51, 0x49, 0x64, 0x6d,
-  0xfe, 0xd2, 0xfe, 0x50, 0xfe, 0xd2, 0x6d, 0x71, 0x4e, 0x51, 0xa4, 0x75,
-  0x73, 0xa5, 0x52, 0x11, 0x11, 0x6e, 0x01, 0x93, 0x01, 0x21, 0x01, 0x24,
-  0x01, 0x93, 0x01, 0xe9, 0x67, 0x4a, 0x49, 0x67, 0x67, 0x49, 0x4a, 0x67,
-  0x67, 0x4a, 0x49, 0x68, 0x68, 0x49, 0x4a, 0x67, 0x55, 0x11, 0x16, 0x5c,
-  0x82, 0x81, 0xb7, 0xb7, 0x81, 0x82, 0x5c, 0x51, 0x09, 0x73, 0x99, 0xb4,
-  0xfd, 0xfd, 0xb4, 0x99, 0x72, 0x04, 0x57, 0x5c, 0xfe, 0xfc, 0xb7, 0xb7,
-  0x01, 0x04, 0x5c, 0x11, 0x0f, 0x8e, 0xb6, 0xf8, 0x01, 0x5e, 0xfe, 0xa2,
-  0xf8, 0xb1, 0x00, 0x00, 0x00, 0x03, 0x00, 0x70, 0x00, 0x00, 0x05, 0xf6,
-  0x05, 0xc9, 0x00, 0x0a, 0x00, 0x16, 0x00, 0x41, 0x00, 0x00, 0x01, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x25, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x01, 0x14, 0x00,
-  0x21, 0x20, 0x00, 0x35, 0x34, 0x37, 0x26, 0x27, 0x26, 0x10, 0x36, 0x33,
-  0x32, 0x16, 0x10, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x04, 0x20, 0x24,
-  0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x10, 0x36, 0x33, 0x32, 0x16, 0x10,
-  0x07, 0x06, 0x07, 0x16, 0x05, 0x7c, 0x5e, 0x41, 0x43, 0x5d, 0x5d, 0x85,
-  0x5d, 0xfc, 0xac, 0x5d, 0x43, 0x41, 0x5e, 0x5e, 0x41, 0x43, 0x5d, 0x03,
-  0xb9, 0xfe, 0x6d, 0xfe, 0xdc, 0xfe, 0xdf, 0xfe, 0x6d, 0x6e, 0x11, 0x11,
-  0x52, 0xa5, 0x73, 0x75, 0xa4, 0x51, 0x4e, 0x71, 0x6d, 0x01, 0x2e, 0x01,
-  0xb0, 0x01, 0x2e, 0x6d, 0x64, 0x49, 0x51, 0xa4, 0x74, 0x75, 0xa4, 0x52,
-  0x14, 0x17, 0x68, 0x04, 0x91, 0x49, 0x68, 0x68, 0x49, 0x4a, 0x67, 0x67,
-  0x4a, 0x4a, 0x67, 0x67, 0x4a, 0x49, 0x67, 0x67, 0xfe, 0x0c, 0xf7, 0xfe,
-  0xa3, 0x01, 0x5d, 0xf7, 0xb4, 0x8d, 0x0f, 0x12, 0x5b, 0x01, 0x02, 0xb6,
-  0xb6, 0xfe, 0xfe, 0x5b, 0x58, 0x03, 0x72, 0x97, 0xb4, 0xfb, 0xfb, 0xb4,
-  0x98, 0x71, 0x09, 0x51, 0x5c, 0x01, 0x02, 0xb6, 0xb6, 0xfe, 0xfe, 0x5c,
-  0x16, 0x11, 0x8b, 0x00, 0x00, 0x02, 0x00, 0x70, 0xff, 0xfd, 0x04, 0x65,
-  0x05, 0xc6, 0x00, 0x0b, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x37, 0x16, 0x17, 0x16,
-  0x10, 0x00, 0x23, 0x22, 0x00, 0x10, 0x00, 0x33, 0x32, 0x17, 0x13, 0x17,
-  0x02, 0x45, 0x80, 0xb5, 0xb5, 0x80, 0x80, 0xb5, 0xb3, 0xab, 0x11, 0x10,
-  0x89, 0xfe, 0xed, 0xc4, 0xc1, 0xfe, 0xec, 0x01, 0x11, 0xc4, 0x57, 0x4b,
-  0xf3, 0x8b, 0x03, 0x5f, 0xc8, 0x90, 0x8e, 0xc9, 0xc9, 0x8e, 0x90, 0xc8,
-  0x3b, 0x10, 0x13, 0x99, 0xfe, 0x50, 0xfe, 0xcf, 0x01, 0x31, 0x01, 0xb0,
-  0x01, 0x32, 0x1d, 0x01, 0xd3, 0x59, 0x00, 0x00, 0x00, 0x03, 0x00, 0x70,
-  0x00, 0x01, 0x06, 0xdb, 0x05, 0xc9, 0x00, 0x08, 0x00, 0x11, 0x00, 0x31,
-  0x00, 0x00, 0x01, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x26, 0x00,
-  0x22, 0x06, 0x14, 0x16, 0x33, 0x32, 0x36, 0x34, 0x01, 0x16, 0x15, 0x14,
-  0x02, 0x23, 0x22, 0x02, 0x35, 0x34, 0x12, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x37, 0x26, 0x35, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x02, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x01, 0xfb, 0x6c, 0x98, 0x98, 0xd8, 0x98, 0x97,
-  0x03, 0x54, 0xda, 0x97, 0x97, 0x6d, 0x6c, 0x98, 0xfd, 0x11, 0x23, 0xe8,
-  0xa4, 0xa3, 0xe8, 0xe6, 0xa5, 0xa6, 0x73, 0x02, 0x02, 0xc6, 0x19, 0xe5,
-  0xa5, 0xa6, 0xe6, 0xe7, 0xa5, 0xa3, 0x74, 0x0a, 0x0a, 0x02, 0xda, 0xa9,
-  0xf0, 0xa9, 0xa9, 0xf0, 0xa9, 0x02, 0x5a, 0xa9, 0xf0, 0xa9, 0xa9, 0xf0,
-  0xfd, 0xe4, 0x54, 0x64, 0xb5, 0xfe, 0xff, 0x01, 0x01, 0xb5, 0xb7, 0x01,
-  0x01, 0x80, 0x03, 0x02, 0x89, 0x49, 0x55, 0xb7, 0x01, 0x01, 0xfe, 0xff,
-  0xb7, 0xb5, 0xfe, 0xff, 0x81, 0x0b, 0x0c, 0x00, 0x00, 0x0e, 0x00, 0x7e,
-  0x00, 0x00, 0x08, 0x7a, 0x05, 0xd5, 0x00, 0x23, 0x00, 0x35, 0x00, 0x41,
-  0x00, 0x4d, 0x00, 0x59, 0x00, 0x65, 0x00, 0x72, 0x00, 0x80, 0x00, 0x8d,
-  0x00, 0x9a, 0x00, 0xa7, 0x00, 0xb5, 0x00, 0xc5, 0x00, 0xd9, 0x00, 0x00,
-  0x01, 0x33, 0x04, 0x17, 0x16, 0x15, 0x06, 0x23, 0x22, 0x27, 0x25, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x35, 0x34, 0x27, 0x21, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x05, 0x06, 0x23, 0x22, 0x27, 0x34, 0x37, 0x36,
-  0x01, 0x35, 0x33, 0x15, 0x14, 0x17, 0x16, 0x19, 0x01, 0x21, 0x11, 0x10,
-  0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x03, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x05, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x27, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x11, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x02, 0x16, 0x06, 0x07, 0x06, 0x26,
-  0x27, 0x26, 0x36, 0x37, 0x36, 0x33, 0x32, 0x01, 0x16, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x26, 0x27, 0x26, 0x36, 0x37, 0x36, 0x16, 0x01, 0x1e, 0x01,
-  0x0e, 0x01, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x3e, 0x01, 0x04, 0x1e,
-  0x01, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x24,
-  0x36, 0x16, 0x17, 0x16, 0x06, 0x07, 0x06, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x25, 0x36, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x26, 0x27,
-  0x26, 0x36, 0x01, 0x3e, 0x01, 0x17, 0x1e, 0x01, 0x07, 0x0e, 0x01, 0x23,
-  0x22, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x17,
-  0x1e, 0x01, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x2e, 0x01,
-  0x35, 0x34, 0x04, 0x78, 0x08, 0x02, 0x1f, 0xe7, 0xf4, 0x20, 0x5d, 0x06,
-  0x06, 0xfe, 0x92, 0x36, 0x0b, 0x3d, 0x1f, 0xfc, 0x0d, 0x1f, 0x3d, 0x0b,
-  0x37, 0xfe, 0x92, 0x07, 0x05, 0x5c, 0x21, 0xf5, 0xe6, 0x02, 0xf8, 0x81,
-  0xd9, 0xd0, 0xfa, 0x02, 0xd1, 0xd8, 0x82, 0x9a, 0xd4, 0x95, 0x97, 0xd3,
-  0xd2, 0x98, 0x96, 0xd3, 0x02, 0x34, 0x76, 0x55, 0x54, 0x76, 0x76, 0x54,
-  0x55, 0x76, 0x90, 0x1c, 0x16, 0x15, 0x1d, 0x1d, 0x15, 0x16, 0x1c, 0x1c,
-  0x16, 0x15, 0x1d, 0x1d, 0x15, 0x16, 0x1c, 0xbc, 0x18, 0x06, 0x11, 0x11,
-  0x29, 0x0d, 0x0c, 0x07, 0x11, 0x0d, 0x10, 0x04, 0x01, 0x72, 0x0d, 0x06,
-  0x12, 0x0d, 0x10, 0x04, 0x18, 0x0e, 0x0c, 0x07, 0x11, 0x11, 0x29, 0xfe,
-  0x3e, 0x16, 0x12, 0x0d, 0x26, 0x13, 0x14, 0x10, 0x02, 0x08, 0x25, 0x02,
-  0x1c, 0x27, 0x0f, 0x02, 0x08, 0x24, 0x14, 0x14, 0x13, 0x06, 0x08, 0xfd,
-  0xea, 0x27, 0x26, 0x07, 0x06, 0x12, 0x14, 0x15, 0x25, 0x08, 0x02, 0x02,
-  0x3f, 0x14, 0x24, 0x08, 0x02, 0x0f, 0x14, 0x13, 0x27, 0x06, 0x06, 0x13,
-  0xfe, 0x46, 0x0d, 0x29, 0x11, 0x11, 0x08, 0x0e, 0x0c, 0x19, 0x04, 0x10,
-  0x0d, 0x11, 0x05, 0x01, 0x57, 0x0e, 0x18, 0x04, 0x10, 0x0d, 0x12, 0x04,
-  0x0b, 0x0c, 0x18, 0x05, 0x10, 0x0d, 0x11, 0x04, 0x05, 0xd5, 0x11, 0x9b,
-  0xa4, 0xaa, 0x99, 0x01, 0x8c, 0x12, 0x2b, 0x13, 0x19, 0x47, 0x20, 0x17,
-  0x03, 0x03, 0x17, 0x20, 0x47, 0x18, 0x14, 0x2b, 0x12, 0x8c, 0x01, 0x99,
-  0xaa, 0xa4, 0x99, 0xfe, 0x76, 0x4b, 0x98, 0x4b, 0x39, 0x5f, 0xfe, 0xe2,
-  0xfe, 0x16, 0x01, 0xea, 0x01, 0x1e, 0x5f, 0x39, 0x4b, 0x98, 0x4b, 0xfd,
-  0xdd, 0xa7, 0xea, 0xea, 0xa7, 0xa6, 0xec, 0xec, 0xa5, 0x5d, 0x84, 0x84,
-  0x5d, 0x5f, 0x83, 0x83, 0xde, 0x16, 0x22, 0x22, 0x16, 0x18, 0x22, 0x22,
-  0xfd, 0x73, 0x18, 0x21, 0x21, 0x18, 0x17, 0x22, 0x22, 0x02, 0x57, 0x26,
-  0x2e, 0x0d, 0x0f, 0x07, 0x13, 0x14, 0x2d, 0x0f, 0x0a, 0xfd, 0xec, 0x13,
-  0x2e, 0x0f, 0x0a, 0x04, 0x14, 0x13, 0x2d, 0x0e, 0x0d, 0x06, 0x01, 0x61,
-  0x08, 0x29, 0x2c, 0x15, 0x06, 0x07, 0x22, 0x0d, 0x09, 0x09, 0x16, 0x15,
-  0xc3, 0x0e, 0x22, 0x0d, 0x08, 0x09, 0x16, 0x15, 0x08, 0x07, 0x29, 0x17,
-  0x16, 0x06, 0x0e, 0x14, 0x16, 0x18, 0x29, 0x08, 0x06, 0x15, 0x16, 0x09,
-  0x08, 0x0d, 0xec, 0x07, 0x15, 0x16, 0x09, 0x08, 0x0d, 0x21, 0x08, 0x07,
-  0x15, 0x16, 0x16, 0x29, 0xfe, 0x94, 0x12, 0x07, 0x0d, 0x0e, 0x2f, 0x11,
-  0x14, 0x04, 0x0a, 0x0f, 0x1c, 0x05, 0x11, 0x02, 0x0c, 0x13, 0x04, 0x0a,
-  0x0f, 0x1b, 0x04, 0x12, 0x10, 0x13, 0x04, 0x0c, 0x0d, 0x1c, 0x05, 0x11,
-  0x00, 0x10, 0x00, 0x82, 0x00, 0x00, 0x08, 0x7f, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x1d, 0x00, 0x25, 0x00, 0x2d, 0x00, 0x35, 0x00, 0x41, 0x00, 0x4d,
-  0x00, 0x59, 0x00, 0x64, 0x00, 0x70, 0x00, 0x7c, 0x00, 0x88, 0x00, 0x94,
-  0x00, 0xa6, 0x00, 0xca, 0x00, 0xf0, 0x00, 0x00, 0x01, 0x35, 0x23, 0x15,
-  0x06, 0x07, 0x06, 0x15, 0x11, 0x21, 0x11, 0x34, 0x27, 0x26, 0x27, 0x35,
-  0x23, 0x15, 0x07, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x16, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x02, 0x22,
-  0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x02, 0x22, 0x06, 0x14, 0x16, 0x32,
-  0x36, 0x34, 0x03, 0x0e, 0x01, 0x17, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27,
-  0x2e, 0x01, 0x01, 0x0e, 0x01, 0x17, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27,
-  0x2e, 0x01, 0x01, 0x06, 0x16, 0x17, 0x16, 0x36, 0x37, 0x36, 0x26, 0x27,
-  0x26, 0x06, 0x05, 0x06, 0x16, 0x17, 0x16, 0x3e, 0x01, 0x26, 0x27, 0x26,
-  0x06, 0x05, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27, 0x2e, 0x01, 0x07, 0x0e,
-  0x01, 0x25, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27, 0x2e, 0x01, 0x07, 0x0e,
-  0x01, 0x01, 0x16, 0x36, 0x37, 0x36, 0x26, 0x27, 0x26, 0x06, 0x07, 0x06,
-  0x16, 0x01, 0x16, 0x36, 0x37, 0x36, 0x26, 0x27, 0x26, 0x06, 0x07, 0x06,
-  0x16, 0x13, 0x35, 0x33, 0x15, 0x14, 0x17, 0x16, 0x19, 0x01, 0x21, 0x11,
-  0x10, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x25, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x05, 0x23, 0x22, 0x27, 0x36, 0x37, 0x36, 0x25,
-  0x16, 0x32, 0x37, 0x04, 0x17, 0x16, 0x17, 0x06, 0x2b, 0x01, 0x25, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x05, 0x16, 0x33, 0x32, 0x37, 0x26, 0x27, 0x24,
-  0x25, 0x27, 0x15, 0x23, 0x04, 0x05, 0x06, 0x07, 0x16, 0x33, 0x32, 0x37,
-  0x25, 0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x37, 0x03, 0x88, 0x2c,
-  0x0e, 0xb7, 0xaf, 0x05, 0x0d, 0xb0, 0xb6, 0x07, 0x33, 0xeb, 0x95, 0xce,
-  0xcf, 0x94, 0x93, 0xd0, 0xcf, 0xe6, 0xa5, 0x74, 0x74, 0xa5, 0x74, 0xa9,
-  0x29, 0x1d, 0x1d, 0x29, 0x1d, 0x1d, 0x29, 0x1d, 0x1d, 0x29, 0x1d, 0xf3,
-  0x10, 0x07, 0x0b, 0x0e, 0x28, 0x11, 0x11, 0x05, 0x0c, 0x0b, 0x29, 0x01,
-  0x37, 0x11, 0x07, 0x0c, 0x0d, 0x28, 0x11, 0x11, 0x06, 0x0c, 0x0c, 0x28,
-  0xfe, 0x2f, 0x06, 0x14, 0x13, 0x14, 0x24, 0x07, 0x06, 0x12, 0x15, 0x14,
-  0x24, 0x02, 0x0c, 0x06, 0x12, 0x14, 0x13, 0x25, 0x0c, 0x12, 0x14, 0x12,
-  0x25, 0xfd, 0xe6, 0x07, 0x24, 0x15, 0x14, 0x12, 0x06, 0x07, 0x24, 0x14,
-  0x13, 0x14, 0x02, 0x19, 0x06, 0x26, 0x12, 0x14, 0x12, 0x06, 0x06, 0x25,
-  0x13, 0x14, 0x12, 0xfe, 0x6b, 0x11, 0x29, 0x0b, 0x0e, 0x07, 0x11, 0x11,
-  0x28, 0x0e, 0x0b, 0x07, 0x01, 0x58, 0x11, 0x28, 0x0c, 0x0c, 0x06, 0x11,
-  0x11, 0x28, 0x0d, 0x0c, 0x07, 0x4d, 0x79, 0xca, 0xc2, 0xfa, 0x68, 0xc3,
-  0xca, 0x79, 0xfe, 0xcb, 0x17, 0x43, 0x1a, 0x35, 0xfe, 0xaf, 0x09, 0x6d,
-  0x3b, 0x0c, 0xdf, 0xe0, 0x02, 0x09, 0x15, 0x2b, 0x16, 0x02, 0x08, 0xe0,
-  0xdf, 0x0b, 0x3a, 0x6c, 0x09, 0xfe, 0xae, 0x35, 0x1a, 0x43, 0x17, 0x17,
-  0x23, 0x30, 0x1c, 0x1c, 0x01, 0x25, 0x0d, 0x0e, 0x42, 0x38, 0x09, 0xd4,
-  0xfe, 0xe6, 0xfe, 0x54, 0x2b, 0x31, 0xfe, 0x53, 0xfe, 0xe6, 0xd4, 0x08,
-  0x37, 0x43, 0x0d, 0x0e, 0x01, 0x25, 0x1c, 0x1c, 0x30, 0x22, 0x03, 0xc2,
-  0x40, 0x8e, 0x40, 0x31, 0x41, 0xf1, 0xfe, 0x65, 0x01, 0x9b, 0xf1, 0x41,
-  0x31, 0x40, 0x8e, 0x40, 0x48, 0xe7, 0xa3, 0xa4, 0xe6, 0xe6, 0xa4, 0xa3,
-  0xe7, 0xad, 0x81, 0xb8, 0x80, 0x80, 0xb8, 0x01, 0x14, 0x20, 0x2e, 0x20,
-  0x20, 0x2e, 0xfd, 0xb5, 0x20, 0x2e, 0x20, 0x20, 0x2e, 0x02, 0x45, 0x0d,
-  0x2d, 0x13, 0x12, 0x08, 0x0d, 0x0f, 0x2d, 0x13, 0x11, 0x07, 0xfd, 0xff,
-  0x0e, 0x2d, 0x13, 0x13, 0x07, 0x0f, 0x0d, 0x2c, 0x13, 0x13, 0x07, 0x01,
-  0x31, 0x16, 0x29, 0x07, 0x07, 0x14, 0x17, 0x16, 0x29, 0x07, 0x07, 0x16,
-  0xd5, 0x15, 0x29, 0x07, 0x07, 0x15, 0x2c, 0x28, 0x08, 0x07, 0x14, 0x39,
-  0x17, 0x14, 0x07, 0x07, 0x29, 0x15, 0x16, 0x16, 0x07, 0x08, 0x28, 0xa9,
-  0x15, 0x16, 0x07, 0x07, 0x29, 0x16, 0x15, 0x16, 0x07, 0x07, 0x29, 0xfe,
-  0x75, 0x0f, 0x07, 0x13, 0x13, 0x2d, 0x0d, 0x0e, 0x07, 0x13, 0x13, 0x2c,
-  0x01, 0xe6, 0x0d, 0x08, 0x12, 0x13, 0x2d, 0x0d, 0x0f, 0x08, 0x12, 0x13,
-  0x2d, 0x01, 0x20, 0x47, 0x9c, 0x37, 0x37, 0x57, 0xfe, 0xf5, 0xfe, 0x36,
-  0x01, 0xca, 0x01, 0x0b, 0x57, 0x37, 0x37, 0x9c, 0x47, 0xe5, 0x06, 0x12,
-  0x20, 0x44, 0x26, 0x1a, 0x26, 0x0b, 0xa5, 0xcb, 0xc7, 0x65, 0x8b, 0x11,
-  0x01, 0x01, 0x11, 0x8b, 0x65, 0xc7, 0xcb, 0xa5, 0x0b, 0x26, 0x1a, 0x26,
-  0x44, 0x20, 0x12, 0x06, 0x1c, 0x12, 0x22, 0x28, 0x3d, 0x16, 0x15, 0x14,
-  0x13, 0x88, 0x06, 0x97, 0x9d, 0x70, 0x81, 0x19, 0x01, 0x01, 0x19, 0x81,
-  0x70, 0x9d, 0x97, 0x06, 0x88, 0x13, 0x14, 0x15, 0x16, 0x3d, 0x28, 0x22,
-  0x12, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa5, 0x00, 0x00, 0x05, 0xd0,
-  0x05, 0xd5, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x17, 0x11,
-  0x07, 0x21, 0x27, 0x11, 0x17, 0x11, 0x21, 0x11, 0xab, 0x05, 0x1e, 0x07,
-  0x07, 0xfa, 0xe2, 0x05, 0x63, 0x04, 0x63, 0x05, 0xd5, 0x07, 0xfa, 0x38,
-  0x06, 0x06, 0x05, 0xc8, 0x68, 0xfb, 0x08, 0x04, 0xf8, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xa4, 0x00, 0x00, 0x05, 0xd1, 0x05, 0xd5, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x22, 0x00, 0x00, 0x13, 0x21, 0x17, 0x11, 0x07, 0x21,
-  0x27, 0x11, 0x17, 0x11, 0x21, 0x11, 0x07, 0x15, 0x06, 0x07, 0x00, 0x03,
-  0x06, 0x23, 0x06, 0x23, 0x02, 0x2b, 0x01, 0x35, 0x37, 0x32, 0x17, 0x33,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0xaa, 0x05, 0x21, 0x06, 0x06, 0xfa, 0xdf,
-  0x05, 0x64, 0x04, 0x63, 0x7a, 0x44, 0x25, 0xfe, 0xda, 0x38, 0x05, 0x0f,
-  0x69, 0x0c, 0x5b, 0xb8, 0x15, 0x92, 0x88, 0x41, 0x06, 0x2e, 0x38, 0x59,
-  0x8b, 0x57, 0x05, 0xd5, 0x06, 0xfa, 0x38, 0x07, 0x07, 0x05, 0xc8, 0x68,
-  0xfb, 0x08, 0x04, 0xf8, 0x9e, 0x06, 0x41, 0x3a, 0xfe, 0x46, 0xfe, 0xbd,
-  0x3b, 0x2f, 0x01, 0x02, 0x07, 0x49, 0x83, 0xa6, 0x74, 0xb3, 0xbb, 0x78,
-  0x00, 0x03, 0x00, 0xa4, 0x00, 0x00, 0x05, 0xd1, 0x05, 0xd5, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x1a, 0x00, 0x00, 0x13, 0x21, 0x17, 0x11, 0x07, 0x21,
-  0x27, 0x11, 0x17, 0x11, 0x21, 0x11, 0x05, 0x09, 0x01, 0x17, 0x09, 0x01,
-  0x15, 0x07, 0x01, 0x23, 0x01, 0x23, 0x27, 0x09, 0x01, 0xaa, 0x05, 0x21,
-  0x06, 0x06, 0xfa, 0xdf, 0x05, 0x64, 0x04, 0x63, 0xfc, 0x5e, 0x01, 0x72,
-  0x01, 0x6e, 0x56, 0xfe, 0x91, 0x01, 0x6f, 0x52, 0xfe, 0x8e, 0x04, 0xfe,
-  0x92, 0x04, 0x51, 0x01, 0x6e, 0xfe, 0x92, 0x05, 0xd5, 0x06, 0xfa, 0x38,
-  0x07, 0x07, 0x05, 0xc8, 0x68, 0xfb, 0x08, 0x04, 0xf8, 0x86, 0xfe, 0x69,
-  0x01, 0x97, 0x5b, 0xfe, 0x65, 0xfe, 0x66, 0x03, 0x5b, 0x01, 0x97, 0xfe,
-  0x6c, 0x5b, 0x01, 0x9a, 0x01, 0x9b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8a,
-  0x00, 0xa0, 0x03, 0x4a, 0x05, 0x40, 0x00, 0x14, 0x00, 0x00, 0x13, 0x33,
-  0x01, 0x36, 0x13, 0x32, 0x37, 0x33, 0x17, 0x09, 0x01, 0x15, 0x07, 0x01,
-  0x23, 0x01, 0x23, 0x27, 0x01, 0x00, 0x35, 0xd9, 0x04, 0x01, 0x0c, 0x0a,
-  0xfd, 0x04, 0x05, 0x04, 0x4d, 0xfe, 0xf0, 0x01, 0x10, 0x4f, 0xfe, 0xf2,
-  0x02, 0xfe, 0xf1, 0x03, 0x4e, 0x01, 0x12, 0xfe, 0xee, 0x05, 0x40, 0xfe,
-  0x0b, 0x08, 0x01, 0xde, 0x0f, 0x55, 0xfe, 0x04, 0xfe, 0x07, 0x03, 0x53,
-  0x01, 0xf7, 0xfe, 0x0b, 0x56, 0x01, 0xf9, 0x01, 0xf5, 0x07, 0x00, 0x00,
-  0x00, 0x08, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x43, 0x07, 0x76, 0x00, 0x08,
-  0x00, 0x11, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x2c, 0x00, 0x35, 0x00, 0x3e,
-  0x00, 0x7e, 0x00, 0x00, 0x01, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01,
-  0x34, 0x01, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x25, 0x33,
-  0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x17, 0x33, 0x06, 0x2b, 0x01,
-  0x26, 0x3d, 0x01, 0x34, 0x01, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01,
-  0x34, 0x05, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x17, 0x33,
-  0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x25, 0x33, 0x17, 0x15, 0x33,
-  0x20, 0x13, 0x16, 0x1d, 0x01, 0x23, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22,
-  0x07, 0x15, 0x14, 0x07, 0x27, 0x26, 0x23, 0x11, 0x14, 0x0f, 0x01, 0x22,
-  0x2f, 0x01, 0x35, 0x37, 0x33, 0x17, 0x15, 0x16, 0x3b, 0x01, 0x32, 0x3f,
-  0x01, 0x11, 0x22, 0x07, 0x06, 0x23, 0x27, 0x35, 0x37, 0x23, 0x26, 0x27,
-  0x23, 0x22, 0x0f, 0x01, 0x23, 0x35, 0x36, 0x37, 0x36, 0x21, 0x35, 0x01,
-  0xa7, 0x03, 0x1b, 0x53, 0x06, 0x34, 0x02, 0x1a, 0x02, 0x1a, 0x53, 0x06,
-  0x33, 0x01, 0xe8, 0x02, 0x1b, 0x53, 0x05, 0x34, 0xde, 0x04, 0x1b, 0x53,
-  0x05, 0x35, 0x01, 0xe8, 0x03, 0x1a, 0x54, 0x05, 0x35, 0x01, 0x09, 0x02,
-  0x19, 0x54, 0x06, 0x34, 0x52, 0x03, 0x1b, 0x53, 0x05, 0x34, 0xfd, 0xe6,
-  0x34, 0x06, 0x02, 0x01, 0x8c, 0xfc, 0x26, 0x01, 0x14, 0x11, 0x20, 0x33,
-  0x28, 0x87, 0x64, 0x08, 0x1d, 0x88, 0x7b, 0x5f, 0x1b, 0x52, 0x21, 0x02,
-  0x05, 0x27, 0x05, 0x09, 0x38, 0x09, 0x32, 0x12, 0x05, 0xbe, 0x4d, 0x10,
-  0x0c, 0x06, 0x06, 0x04, 0x3c, 0xb1, 0x3d, 0x59, 0x1e, 0x12, 0x03, 0x34,
-  0xad, 0xd7, 0x01, 0x19, 0x06, 0x01, 0xcf, 0x0a, 0x23, 0x02, 0x38, 0x01,
-  0x64, 0xcf, 0x08, 0x23, 0x03, 0x37, 0xe3, 0xcf, 0x08, 0x24, 0x03, 0x36,
-  0xb9, 0xcf, 0x08, 0x24, 0x02, 0x38, 0x01, 0x3b, 0xce, 0x07, 0x24, 0x03,
-  0x37, 0x69, 0xcf, 0x07, 0x24, 0x03, 0x37, 0xeb, 0xcf, 0x09, 0x23, 0x02,
-  0x39, 0x9a, 0x05, 0x70, 0xfe, 0x50, 0x4c, 0x0c, 0x07, 0x0d, 0x29, 0x16,
-  0x5a, 0x2e, 0x0d, 0x02, 0x3b, 0x36, 0xfd, 0x9f, 0x5a, 0x15, 0x02, 0x56,
-  0x18, 0x17, 0x06, 0x06, 0x0a, 0x5a, 0x33, 0x25, 0x02, 0x59, 0x36, 0x33,
-  0x05, 0x0b, 0x2e, 0x38, 0x19, 0x37, 0x10, 0x02, 0x80, 0xc2, 0xc6, 0x70,
-  0x00, 0x09, 0x00, 0x88, 0x00, 0x00, 0x05, 0xeb, 0x05, 0xd9, 0x00, 0x0b,
-  0x00, 0x11, 0x00, 0x1c, 0x00, 0x33, 0x00, 0x44, 0x00, 0x4d, 0x00, 0x79,
-  0x00, 0x7f, 0x00, 0x8f, 0x00, 0x00, 0x01, 0x14, 0x15, 0x14, 0x17, 0x21,
-  0x36, 0x37, 0x34, 0x23, 0x21, 0x06, 0x13, 0x16, 0x17, 0x21, 0x36, 0x3f,
-  0x01, 0x06, 0x07, 0x36, 0x37, 0x36, 0x35, 0x34, 0x35, 0x26, 0x23, 0x27,
-  0x06, 0x07, 0x33, 0x32, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x33,
-  0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x23, 0x01, 0x33,
-  0x14, 0x06, 0x07, 0x14, 0x16, 0x17, 0x23, 0x26, 0x27, 0x26, 0x27, 0x34,
-  0x35, 0x34, 0x36, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x16,
-  0x05, 0x36, 0x37, 0x32, 0x17, 0x15, 0x14, 0x05, 0x07, 0x17, 0x14, 0x07,
-  0x21, 0x26, 0x3d, 0x01, 0x37, 0x35, 0x24, 0x2f, 0x01, 0x35, 0x36, 0x33,
-  0x16, 0x17, 0x26, 0x11, 0x34, 0x33, 0x21, 0x16, 0x15, 0x33, 0x32, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x27, 0x01, 0x16, 0x17, 0x21,
-  0x36, 0x37, 0x01, 0x06, 0x07, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x35, 0x33, 0x1e, 0x01, 0x15, 0x01, 0x06, 0x0d, 0x04, 0x0e, 0x0a,
-  0x03, 0x1b, 0xfc, 0x10, 0x19, 0x38, 0x05, 0x0e, 0x03, 0x8f, 0x0c, 0x08,
-  0x41, 0x08, 0x34, 0x4e, 0x2c, 0x1a, 0x01, 0x1d, 0x33, 0x02, 0x01, 0x31,
-  0x35, 0x3e, 0x28, 0x49, 0x1d, 0x2d, 0x07, 0x34, 0x22, 0x11, 0x61, 0x31,
-  0x1a, 0x16, 0x6c, 0xfd, 0x78, 0x08, 0x58, 0x01, 0x7a, 0x04, 0x08, 0x11,
-  0x62, 0x1e, 0x08, 0x63, 0xfe, 0xf9, 0xa5, 0xaa, 0x9d, 0x9f, 0x1f, 0x53,
-  0xfc, 0x9e, 0x21, 0x02, 0xf2, 0xe4, 0x5c, 0x10, 0x06, 0xfe, 0xbc, 0x71,
-  0x02, 0x0f, 0xfe, 0x26, 0x0f, 0x03, 0xfe, 0x8e, 0x2c, 0x03, 0x03, 0x11,
-  0x4c, 0xc1, 0xb5, 0x30, 0x03, 0xf7, 0x1d, 0x31, 0x81, 0x4e, 0x1f, 0x65,
-  0x30, 0x3c, 0x06, 0x10, 0xfc, 0x8d, 0x06, 0x09, 0x03, 0xd6, 0x0a, 0x03,
-  0xfe, 0xbc, 0x05, 0x11, 0x39, 0x0a, 0x05, 0x02, 0x48, 0x33, 0x05, 0x09,
-  0x39, 0x02, 0xb4, 0x06, 0x07, 0x37, 0x48, 0x34, 0x58, 0x16, 0x04, 0xfe,
-  0xcd, 0x1a, 0x12, 0x16, 0x16, 0xc7, 0x6d, 0x86, 0x01, 0x4d, 0x37, 0x52,
-  0x06, 0x05, 0x11, 0x56, 0x1c, 0x20, 0x2f, 0x82, 0x4d, 0x28, 0x01, 0x3d,
-  0x48, 0x3a, 0x0d, 0x1f, 0x2c, 0x71, 0x4c, 0x55, 0x44, 0x03, 0x29, 0x38,
-  0x88, 0x57, 0x71, 0x6b, 0xb1, 0x92, 0x65, 0x2d, 0x50, 0x05, 0x06, 0x65,
-  0x78, 0xfa, 0xf3, 0x0d, 0x0b, 0x10, 0x97, 0x4e, 0x57, 0x18, 0x0a, 0x0a,
-  0x0a, 0x10, 0x3d, 0x24, 0x0a, 0x0f, 0x08, 0x07, 0x10, 0x06, 0x02, 0x02,
-  0x55, 0x12, 0x0d, 0x04, 0x0b, 0x09, 0x14, 0xfe, 0x01, 0x2f, 0x30, 0x02,
-  0x18, 0x63, 0x9b, 0x99, 0x29, 0x16, 0x48, 0x04, 0x01, 0x3f, 0x1a, 0x12,
-  0x13, 0x19, 0x01, 0xf5, 0x32, 0x1c, 0x40, 0x5b, 0x6e, 0x44, 0x46, 0x38,
-  0x54, 0x24, 0x2e, 0x4a, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9a,
-  0x00, 0x01, 0x05, 0xdb, 0x05, 0xd9, 0x00, 0x07, 0x00, 0x0c, 0x00, 0x00,
-  0x09, 0x01, 0x13, 0x07, 0x21, 0x27, 0x13, 0x09, 0x01, 0x03, 0x21, 0x03,
-  0x01, 0x03, 0x41, 0x02, 0x4e, 0x4b, 0x02, 0xfa, 0xc8, 0x05, 0x4f, 0x02,
-  0x55, 0xfe, 0x05, 0x44, 0x04, 0x75, 0x40, 0xfe, 0x07, 0x05, 0xd9, 0xfe,
-  0x77, 0xfb, 0xb4, 0x03, 0x06, 0x04, 0x4c, 0x01, 0x86, 0xfe, 0x35, 0xfc,
-  0x5f, 0x03, 0xa1, 0x01, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9a,
-  0x00, 0x00, 0x05, 0xdb, 0x05, 0xd0, 0x00, 0x09, 0x00, 0x00, 0x09, 0x01,
-  0x13, 0x17, 0x07, 0x21, 0x27, 0x13, 0x00, 0x37, 0x03, 0x3f, 0x02, 0x4b,
-  0x4e, 0x02, 0x02, 0xfa, 0xc8, 0x05, 0x51, 0x02, 0x3e, 0x12, 0x05, 0xd0,
-  0xfe, 0x77, 0xfb, 0xbf, 0x03, 0x03, 0x06, 0x04, 0x44, 0x01, 0x80, 0x06,
-  0x00, 0x01, 0x00, 0x8f, 0x00, 0x00, 0x05, 0xe6, 0x05, 0xd4, 0x00, 0x53,
-  0x00, 0x00, 0x01, 0x03, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16,
-  0x32, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x03, 0x25, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x03, 0x16, 0x15, 0x10, 0x07, 0x23, 0x36, 0x11, 0x34, 0x27, 0x03,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36,
-  0x35, 0x34, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x03, 0x1f, 0xc2, 0x43, 0x4f, 0x22, 0x22, 0x4f, 0x3b, 0x27,
-  0x3c, 0x34, 0x53, 0x32, 0x0c, 0x52, 0xb3, 0x01, 0x24, 0x46, 0x40, 0x34,
-  0x2f, 0x20, 0x1f, 0x3f, 0x06, 0x10, 0x61, 0x21, 0x0b, 0x0a, 0x1e, 0x33,
-  0x39, 0x1e, 0x20, 0x5f, 0x44, 0xbb, 0x08, 0x64, 0x56, 0x84, 0x07, 0xb9,
-  0x46, 0x5e, 0x20, 0x1e, 0x39, 0x32, 0x1f, 0x0b, 0x09, 0x21, 0x61, 0x11,
-  0x06, 0x3f, 0x20, 0x1f, 0x30, 0x32, 0x41, 0x46, 0x03, 0x08, 0x01, 0x34,
-  0x68, 0x6f, 0x6b, 0x40, 0x16, 0x52, 0x52, 0x72, 0x2a, 0x25, 0x7f, 0x74,
-  0xfe, 0xeb, 0x65, 0x1c, 0x11, 0x0c, 0x1b, 0x42, 0x42, 0x15, 0x15, 0x39,
-  0x27, 0x1d, 0x11, 0x37, 0x2a, 0x1f, 0x24, 0x25, 0x1b, 0x29, 0x0c, 0x22,
-  0x66, 0x01, 0x16, 0x58, 0x53, 0xfe, 0xdd, 0xe7, 0xf2, 0x01, 0x35, 0x45,
-  0x49, 0xfe, 0xea, 0x66, 0x22, 0x0c, 0x29, 0x1b, 0x25, 0x23, 0x1e, 0x2c,
-  0x37, 0x11, 0x1d, 0x27, 0x39, 0x15, 0x14, 0x43, 0x42, 0x1b, 0x0c, 0x11,
-  0x1c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x99, 0x01, 0x1e, 0x05, 0xdb,
-  0x04, 0x98, 0x00, 0x3e, 0x00, 0x45, 0x00, 0x00, 0x01, 0x16, 0x17, 0x14,
-  0x07, 0x06, 0x07, 0x16, 0x13, 0x33, 0x17, 0x07, 0x23, 0x06, 0x07, 0x22,
-  0x27, 0x34, 0x33, 0x16, 0x33, 0x32, 0x33, 0x32, 0x37, 0x26, 0x27, 0x23,
-  0x22, 0x07, 0x16, 0x15, 0x06, 0x05, 0x24, 0x03, 0x34, 0x37, 0x16, 0x17,
-  0x15, 0x07, 0x14, 0x17, 0x32, 0x37, 0x12, 0x25, 0x16, 0x1d, 0x01, 0x14,
-  0x07, 0x36, 0x37, 0x32, 0x35, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x03,
-  0x06, 0x15, 0x14, 0x17, 0x35, 0x26, 0x05, 0x16, 0x64, 0x12, 0x42, 0x9f,
-  0x12, 0xe7, 0x31, 0x18, 0x11, 0x29, 0x03, 0x0f, 0x89, 0x58, 0x16, 0x12,
-  0x0e, 0x33, 0x02, 0x01, 0x45, 0x0c, 0xec, 0x06, 0x03, 0x76, 0x3d, 0x79,
-  0x08, 0xfe, 0xd3, 0xfd, 0xd7, 0x28, 0x3b, 0x2e, 0x07, 0x0b, 0x65, 0x50,
-  0x0c, 0x30, 0x01, 0x0c, 0xb0, 0x25, 0x53, 0x5a, 0x37, 0x41, 0x46, 0x34,
-  0x22, 0x79, 0x01, 0xce, 0x1d, 0x04, 0x98, 0x05, 0x73, 0x57, 0x19, 0x24,
-  0x2c, 0x1b, 0xfe, 0xf0, 0x4a, 0x0d, 0xae, 0x09, 0x5d, 0x54, 0x2d, 0x4d,
-  0x4d, 0xf1, 0x6d, 0x40, 0x65, 0xf6, 0x10, 0x03, 0x01, 0x64, 0x3a, 0x09,
-  0x03, 0x2c, 0x17, 0x27, 0x5a, 0x0c, 0x4d, 0x01, 0xde, 0x14, 0x06, 0xa0,
-  0x08, 0x27, 0x63, 0x4d, 0x14, 0x26, 0x54, 0x29, 0x24, 0x24, 0x0d, 0x3c,
-  0xfe, 0xa5, 0x08, 0x09, 0x84, 0x49, 0x03, 0xb5, 0x00, 0x01, 0x00, 0x9a,
-  0x00, 0xe7, 0x05, 0xdb, 0x04, 0x8d, 0x00, 0x32, 0x00, 0x00, 0x25, 0x21,
-  0x22, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x33, 0x37, 0x23, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x3b, 0x01, 0x37, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x21, 0x37, 0x21, 0x22, 0x26, 0x35,
-  0x34, 0x3e, 0x01, 0x33, 0x21, 0x36, 0x37, 0x36, 0x33, 0x21, 0x32, 0x16,
-  0x15, 0x05, 0x97, 0xfd, 0x95, 0x27, 0x37, 0x19, 0x17, 0x10, 0x11, 0x31,
-  0x03, 0x7a, 0x2a, 0x17, 0x1c, 0x1a, 0x2d, 0x18, 0xa2, 0x01, 0xe8, 0x3d,
-  0x38, 0x1b, 0x16, 0x12, 0x14, 0x01, 0x30, 0x02, 0xfd, 0x4f, 0x26, 0x38,
-  0x1a, 0x2d, 0x17, 0x02, 0xdb, 0x07, 0x0f, 0x1c, 0x26, 0x01, 0x51, 0x26,
-  0x37, 0xe7, 0x3e, 0x2b, 0x1b, 0x32, 0x0d, 0x0a, 0x03, 0x0c, 0x02, 0x1a,
-  0x1e, 0x2c, 0x1b, 0x32, 0x1c, 0x0a, 0x3d, 0x2c, 0x1a, 0x32, 0x0e, 0x0b,
-  0x02, 0x0a, 0x3d, 0x2c, 0x1b, 0x33, 0x1a, 0x16, 0x11, 0x1f, 0x3e, 0x2c,
-  0x00, 0x01, 0x00, 0x9a, 0x00, 0xe7, 0x05, 0xdb, 0x04, 0x8d, 0x00, 0x32,
-  0x00, 0x00, 0x13, 0x34, 0x36, 0x33, 0x21, 0x32, 0x17, 0x16, 0x17, 0x21,
-  0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21, 0x17, 0x21, 0x16, 0x17,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x32, 0x1e, 0x01,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x23, 0x17, 0x33, 0x16, 0x17, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x23, 0x21, 0x9b, 0x38, 0x25, 0x01, 0x51, 0x27, 0x1b,
-  0x0f, 0x07, 0x02, 0xdb, 0x17, 0x2d, 0x1a, 0x37, 0x27, 0xfd, 0x50, 0x01,
-  0x01, 0x31, 0x13, 0x12, 0x17, 0x19, 0x37, 0x3d, 0xe7, 0xa2, 0x18, 0x2d,
-  0x19, 0x1b, 0x16, 0x2c, 0x79, 0x04, 0x30, 0x11, 0x10, 0x16, 0x1a, 0x37,
-  0x26, 0xfd, 0x94, 0x04, 0x23, 0x2c, 0x3e, 0x1f, 0x11, 0x16, 0x1a, 0x33,
-  0x1b, 0x2c, 0x3d, 0x0a, 0x02, 0x0b, 0x0e, 0x32, 0x1a, 0x2c, 0x3d, 0x0a,
-  0x1c, 0x32, 0x1b, 0x2c, 0x1e, 0x1a, 0x02, 0x0c, 0x03, 0x0a, 0x0d, 0x32,
-  0x1b, 0x2b, 0x3e, 0x00, 0x00, 0x02, 0x00, 0xa0, 0x00, 0xd4, 0x05, 0xd6,
-  0x04, 0x8d, 0x00, 0x22, 0x00, 0x44, 0x00, 0x00, 0x25, 0x13, 0x34, 0x26,
-  0x23, 0x21, 0x22, 0x07, 0x21, 0x30, 0x23, 0x22, 0x14, 0x33, 0x21, 0x07,
-  0x21, 0x22, 0x15, 0x14, 0x33, 0x21, 0x07, 0x23, 0x22, 0x15, 0x14, 0x3b,
-  0x01, 0x07, 0x23, 0x22, 0x15, 0x14, 0x33, 0x07, 0x26, 0x27, 0x36, 0x37,
-  0x33, 0x37, 0x23, 0x26, 0x27, 0x36, 0x37, 0x33, 0x37, 0x21, 0x22, 0x27,
-  0x36, 0x37, 0x21, 0x37, 0x21, 0x26, 0x27, 0x36, 0x33, 0x21, 0x36, 0x37,
-  0x21, 0x32, 0x16, 0x15, 0x03, 0x05, 0x6e, 0x41, 0x2b, 0x1e, 0xfe, 0xc3,
-  0x31, 0x15, 0xfd, 0x2a, 0x03, 0x48, 0x4b, 0x02, 0xb2, 0x0b, 0xfe, 0xc1,
-  0x4b, 0x4b, 0x01, 0x1b, 0x08, 0xc7, 0x4b, 0x4b, 0x9c, 0x11, 0x38, 0x4a,
-  0x4a, 0x19, 0x53, 0x01, 0x01, 0x53, 0x43, 0x03, 0x99, 0x54, 0x01, 0x01,
-  0x54, 0xcd, 0x01, 0xfe, 0xe6, 0x54, 0x01, 0x01, 0x54, 0x01, 0x44, 0x04,
-  0xfd, 0x50, 0x53, 0x01, 0x01, 0x53, 0x02, 0xdb, 0x1d, 0x3b, 0x01, 0x51,
-  0x25, 0x38, 0x43, 0xf1, 0x03, 0x15, 0x25, 0x33, 0x39, 0x92, 0x4c, 0x4b,
-  0x49, 0x4f, 0x4b, 0x48, 0x4c, 0x4b, 0x49, 0x1d, 0x01, 0x68, 0x67, 0x01,
-  0x0e, 0x01, 0x68, 0x67, 0x01, 0x13, 0x68, 0x67, 0x01, 0x0f, 0x01, 0x68,
-  0x67, 0x45, 0x02, 0x3f, 0x2d, 0xfc, 0xb3, 0x00, 0x00, 0x02, 0x00, 0x84,
-  0x00, 0x00, 0x03, 0xde, 0x05, 0xca, 0x00, 0x21, 0x00, 0x44, 0x00, 0x00,
-  0x37, 0x05, 0x32, 0x36, 0x35, 0x11, 0x34, 0x27, 0x11, 0x36, 0x23, 0x22,
-  0x15, 0x11, 0x27, 0x11, 0x34, 0x23, 0x22, 0x15, 0x11, 0x27, 0x35, 0x34,
-  0x23, 0x22, 0x1d, 0x01, 0x27, 0x35, 0x34, 0x23, 0x22, 0x15, 0x27, 0x36,
-  0x37, 0x16, 0x17, 0x15, 0x17, 0x35, 0x36, 0x37, 0x16, 0x17, 0x15, 0x17,
-  0x11, 0x34, 0x37, 0x16, 0x17, 0x11, 0x17, 0x11, 0x36, 0x37, 0x16, 0x15,
-  0x11, 0x16, 0x17, 0x11, 0x14, 0x06, 0x23, 0x25, 0x13, 0x9f, 0x02, 0xc6,
-  0x21, 0x2f, 0x35, 0x02, 0x42, 0x42, 0x44, 0x45, 0x41, 0x47, 0x43, 0x41,
-  0x45, 0x43, 0x42, 0x1a, 0x01, 0x5e, 0x5c, 0x01, 0x0d, 0x01, 0x5d, 0x5d,
-  0x01, 0x10, 0x5f, 0x5c, 0x01, 0x0e, 0x01, 0x5d, 0x5d, 0x3d, 0x02, 0x38,
-  0x28, 0xfd, 0x06, 0x01, 0x73, 0x4a, 0x31, 0x20, 0x01, 0x62, 0x36, 0x16,
-  0x03, 0x27, 0x53, 0x53, 0xfd, 0x02, 0x0d, 0x01, 0x63, 0x52, 0x52, 0xfe,
-  0xc4, 0x09, 0xdf, 0x53, 0x53, 0xae, 0x12, 0x3f, 0x53, 0x53, 0x1c, 0x5c,
-  0x01, 0x01, 0x5c, 0x4b, 0x04, 0xac, 0x5c, 0x01, 0x01, 0x5c, 0xe4, 0x03,
-  0x01, 0x3b, 0x5c, 0x01, 0x01, 0x5c, 0xfe, 0x96, 0x04, 0x02, 0xfd, 0x5d,
-  0x01, 0x01, 0x5d, 0xfc, 0xd4, 0x21, 0x41, 0xfe, 0x8a, 0x2a, 0x3e, 0x4b,
-  0x02, 0x9b, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9f, 0x00, 0xd3, 0x05, 0xd6,
-  0x04, 0x8d, 0x00, 0x21, 0x00, 0x43, 0x00, 0x00, 0x25, 0x32, 0x35, 0x34,
-  0x2b, 0x01, 0x27, 0x33, 0x32, 0x35, 0x34, 0x2b, 0x01, 0x27, 0x21, 0x32,
-  0x35, 0x34, 0x23, 0x21, 0x27, 0x21, 0x32, 0x34, 0x2b, 0x01, 0x21, 0x26,
-  0x23, 0x21, 0x22, 0x06, 0x15, 0x13, 0x07, 0x03, 0x34, 0x36, 0x33, 0x21,
-  0x16, 0x17, 0x21, 0x32, 0x17, 0x06, 0x07, 0x21, 0x17, 0x21, 0x16, 0x17,
-  0x06, 0x23, 0x21, 0x17, 0x33, 0x16, 0x17, 0x06, 0x07, 0x23, 0x17, 0x33,
-  0x16, 0x17, 0x06, 0x07, 0x03, 0x61, 0x4b, 0x4b, 0x39, 0x10, 0x9d, 0x4a,
-  0x4a, 0xc9, 0x08, 0x01, 0x1c, 0x4a, 0x4a, 0xfe, 0xc1, 0x0c, 0x02, 0xb1,
-  0x4b, 0x47, 0x04, 0xfd, 0x2a, 0x14, 0x30, 0xfe, 0xc1, 0x1d, 0x2c, 0x43,
-  0x24, 0x44, 0x38, 0x26, 0x01, 0x51, 0x3a, 0x1e, 0x02, 0xda, 0x54, 0x01,
-  0x01, 0x54, 0xfd, 0x50, 0x04, 0x01, 0x45, 0x53, 0x01, 0x01, 0x53, 0xfe,
-  0xe5, 0x03, 0xcd, 0x53, 0x01, 0x01, 0x53, 0x9b, 0x04, 0x43, 0x53, 0x01,
-  0x01, 0x53, 0xf1, 0x49, 0x4b, 0x4c, 0x48, 0x4b, 0x4f, 0x49, 0x4b, 0x4c,
-  0x92, 0x39, 0x33, 0x25, 0xfc, 0xeb, 0x1e, 0x03, 0x4e, 0x2d, 0x3f, 0x02,
-  0x45, 0x67, 0x68, 0x01, 0x0f, 0x01, 0x67, 0x68, 0x13, 0x01, 0x67, 0x68,
-  0x01, 0x0e, 0x01, 0x67, 0x69, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x84,
-  0xff, 0xf9, 0x03, 0xde, 0x05, 0xc2, 0x00, 0x21, 0x00, 0x43, 0x00, 0x00,
-  0x13, 0x14, 0x33, 0x32, 0x3d, 0x01, 0x37, 0x15, 0x14, 0x33, 0x32, 0x3d,
-  0x01, 0x37, 0x11, 0x14, 0x33, 0x32, 0x35, 0x11, 0x37, 0x11, 0x14, 0x33,
-  0x32, 0x27, 0x11, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x05, 0x27, 0x25,
-  0x32, 0x16, 0x15, 0x11, 0x06, 0x07, 0x11, 0x14, 0x07, 0x26, 0x27, 0x11,
-  0x07, 0x11, 0x06, 0x07, 0x26, 0x35, 0x11, 0x07, 0x15, 0x06, 0x07, 0x26,
-  0x27, 0x35, 0x07, 0x15, 0x06, 0x07, 0x26, 0x27, 0x9f, 0x42, 0x43, 0x45,
-  0x41, 0x43, 0x47, 0x41, 0x45, 0x44, 0x42, 0x42, 0x02, 0x35, 0x2f, 0x21,
-  0xfd, 0x3a, 0x1b, 0x02, 0xfa, 0x28, 0x38, 0x02, 0x3d, 0x5d, 0x5d, 0x01,
-  0x0e, 0x01, 0x5c, 0x5f, 0x10, 0x01, 0x5d, 0x5d, 0x01, 0x0d, 0x01, 0x5c,
-  0x5e, 0x01, 0x02, 0xb3, 0x53, 0x53, 0x3d, 0x14, 0xae, 0x53, 0x53, 0xdd,
-  0x09, 0xfe, 0xc6, 0x53, 0x53, 0x01, 0x62, 0x0d, 0xfd, 0x01, 0x53, 0x53,
-  0x03, 0x27, 0x17, 0x36, 0x01, 0x61, 0x21, 0x30, 0x4a, 0x29, 0x4b, 0x3e,
-  0x2a, 0xfe, 0x8a, 0x42, 0x20, 0xfc, 0xd4, 0x5c, 0x01, 0x01, 0x5c, 0x02,
-  0xfc, 0x04, 0xfe, 0x98, 0x5d, 0x01, 0x01, 0x5d, 0x01, 0x3a, 0x02, 0xe4,
-  0x5d, 0x01, 0x01, 0x5d, 0xab, 0x04, 0x4a, 0x5d, 0x01, 0x01, 0x5d, 0x00,
-  0x00, 0x1d, 0x00, 0x70, 0x00, 0x00, 0x06, 0x04, 0x05, 0xd8, 0x00, 0x4f,
-  0x00, 0x80, 0x00, 0x8b, 0x00, 0x95, 0x00, 0xa4, 0x00, 0xb3, 0x00, 0xba,
-  0x00, 0xc1, 0x00, 0xd6, 0x00, 0xdc, 0x00, 0xe3, 0x00, 0xe7, 0x00, 0xeb,
-  0x00, 0xef, 0x00, 0xf3, 0x00, 0xf7, 0x00, 0xfb, 0x00, 0xff, 0x01, 0x03,
-  0x01, 0x07, 0x01, 0x0b, 0x01, 0x1a, 0x01, 0x26, 0x01, 0x2a, 0x01, 0x2e,
-  0x01, 0x32, 0x01, 0x36, 0x01, 0x3a, 0x01, 0x3e, 0x00, 0x00, 0x01, 0x20,
-  0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x17, 0x15, 0x14, 0x07, 0x33, 0x36,
-  0x35, 0x36, 0x3b, 0x01, 0x32, 0x15, 0x16, 0x1d, 0x01, 0x06, 0x23, 0x27,
-  0x06, 0x07, 0x15, 0x17, 0x37, 0x16, 0x15, 0x14, 0x07, 0x14, 0x2b, 0x01,
-  0x22, 0x2f, 0x01, 0x06, 0x23, 0x22, 0x27, 0x06, 0x15, 0x06, 0x2b, 0x01,
-  0x22, 0x35, 0x26, 0x35, 0x34, 0x37, 0x17, 0x37, 0x35, 0x25, 0x07, 0x22,
-  0x27, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x1f, 0x01, 0x35, 0x27,
-  0x37, 0x26, 0x35, 0x36, 0x37, 0x36, 0x01, 0x14, 0x17, 0x33, 0x35, 0x26,
-  0x35, 0x36, 0x3b, 0x01, 0x17, 0x07, 0x17, 0x15, 0x07, 0x15, 0x14, 0x17,
-  0x16, 0x1d, 0x01, 0x17, 0x33, 0x37, 0x34, 0x37, 0x36, 0x35, 0x27, 0x37,
-  0x35, 0x27, 0x37, 0x16, 0x1d, 0x01, 0x07, 0x17, 0x36, 0x3d, 0x01, 0x34,
-  0x27, 0x26, 0x2b, 0x01, 0x20, 0x07, 0x06, 0x05, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x2b, 0x01, 0x22, 0x27, 0x34, 0x21, 0x16, 0x17, 0x06, 0x23, 0x22,
-  0x27, 0x34, 0x35, 0x34, 0x13, 0x33, 0x36, 0x33, 0x17, 0x36, 0x35, 0x26,
-  0x35, 0x26, 0x23, 0x06, 0x07, 0x06, 0x15, 0x25, 0x06, 0x23, 0x06, 0x15,
-  0x17, 0x37, 0x16, 0x17, 0x35, 0x34, 0x27, 0x26, 0x35, 0x26, 0x05, 0x17,
-  0x15, 0x07, 0x26, 0x35, 0x34, 0x37, 0x16, 0x15, 0x14, 0x07, 0x27, 0x35,
-  0x03, 0x16, 0x33, 0x36, 0x37, 0x26, 0x35, 0x34, 0x37, 0x06, 0x07, 0x06,
-  0x2b, 0x01, 0x26, 0x27, 0x26, 0x27, 0x16, 0x15, 0x14, 0x37, 0x16, 0x17,
-  0x33, 0x35, 0x26, 0x05, 0x15, 0x32, 0x3f, 0x01, 0x22, 0x07, 0x05, 0x15,
-  0x17, 0x35, 0x25, 0x15, 0x37, 0x35, 0x05, 0x15, 0x17, 0x35, 0x33, 0x15,
-  0x37, 0x27, 0x07, 0x15, 0x37, 0x27, 0x07, 0x15, 0x33, 0x35, 0x33, 0x15,
-  0x33, 0x35, 0x07, 0x15, 0x17, 0x35, 0x17, 0x15, 0x33, 0x35, 0x07, 0x15,
-  0x33, 0x35, 0x05, 0x27, 0x07, 0x15, 0x16, 0x15, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x26, 0x35, 0x06, 0x25, 0x07, 0x16, 0x15, 0x14, 0x17, 0x32,
-  0x3f, 0x01, 0x26, 0x23, 0x07, 0x25, 0x07, 0x17, 0x35, 0x07, 0x15, 0x17,
-  0x35, 0x27, 0x15, 0x17, 0x35, 0x17, 0x15, 0x37, 0x35, 0x37, 0x15, 0x37,
-  0x35, 0x37, 0x15, 0x37, 0x35, 0x03, 0x4a, 0x01, 0x12, 0x83, 0x35, 0x5b,
-  0x05, 0x16, 0x05, 0x90, 0x28, 0x20, 0x07, 0x39, 0x3f, 0x18, 0x38, 0x50,
-  0xe0, 0x37, 0xd2, 0x3f, 0x56, 0x45, 0x3a, 0x05, 0x2e, 0x3e, 0xac, 0x44,
-  0x9b, 0x9d, 0x41, 0xbc, 0x2e, 0x28, 0x0c, 0x33, 0x44, 0x50, 0x44, 0xce,
-  0xfe, 0xee, 0x61, 0x3e, 0x07, 0x40, 0x03, 0x23, 0x1e, 0x2b, 0x36, 0x78,
-  0x17, 0x0b, 0x60, 0x1f, 0xed, 0x5d, 0xfe, 0xbe, 0x3e, 0x07, 0x1c, 0x0a,
-  0x0b, 0x0c, 0x11, 0x0b, 0x1c, 0x11, 0x8a, 0x3e, 0x5b, 0x50, 0x72, 0xb1,
-  0x1d, 0x17, 0x1e, 0x0c, 0x1c, 0x17, 0x1c, 0x05, 0x40, 0xca, 0x73, 0x65,
-  0x22, 0xfe, 0xcf, 0x5e, 0x12, 0x01, 0x4c, 0x29, 0x02, 0x32, 0x51, 0x06,
-  0x46, 0x20, 0x01, 0xa0, 0xb7, 0x06, 0x22, 0x56, 0x3b, 0x3d, 0xd4, 0x05,
-  0xfc, 0x16, 0x5c, 0x1c, 0x3f, 0x06, 0x12, 0x19, 0x2f, 0xe0, 0xfc, 0x85,
-  0x0f, 0x0d, 0x2f, 0x2a, 0x55, 0x39, 0xd9, 0x5b, 0xb7, 0x16, 0x02, 0x27,
-  0x0d, 0x2e, 0x22, 0x6e, 0x3f, 0x24, 0x2d, 0xf0, 0x29, 0xc0, 0xc4, 0x26,
-  0x01, 0x1a, 0x21, 0x19, 0x44, 0x68, 0x32, 0xac, 0x0b, 0x06, 0x29, 0x14,
-  0x0e, 0x12, 0x17, 0x05, 0x08, 0x01, 0x60, 0x0e, 0x02, 0x17, 0x0c, 0x15,
-  0xfe, 0xba, 0x10, 0x01, 0x07, 0x17, 0xfe, 0xf4, 0x16, 0xb8, 0x18, 0x02,
-  0x3f, 0x14, 0x02, 0x68, 0x1d, 0x12, 0x16, 0x94, 0x16, 0x68, 0x16, 0x45,
-  0x1d, 0xfe, 0x2d, 0x67, 0x06, 0x3e, 0x05, 0x0d, 0x11, 0x3f, 0x8c, 0x1e,
-  0x11, 0xa7, 0x02, 0xc0, 0x10, 0xcc, 0x2e, 0x12, 0x0b, 0x38, 0x05, 0x1c,
-  0x56, 0xfd, 0xe0, 0x03, 0x1a, 0x16, 0x16, 0x65, 0x17, 0xb7, 0x19, 0x0d,
-  0x17, 0x12, 0x17, 0x05, 0xd8, 0xc1, 0x6c, 0x54, 0x45, 0x72, 0x66, 0x5e,
-  0x06, 0x35, 0x2e, 0x3e, 0x3d, 0x39, 0x7c, 0x35, 0x22, 0x18, 0x2d, 0x07,
-  0x6c, 0x29, 0x12, 0x64, 0x0d, 0x12, 0x2c, 0x26, 0x3e, 0x76, 0x76, 0x5d,
-  0x63, 0x63, 0x63, 0x19, 0x57, 0x70, 0x43, 0x2d, 0x2b, 0x0d, 0x0d, 0x64,
-  0x12, 0x95, 0x07, 0x38, 0x0d, 0x1b, 0x42, 0x70, 0x70, 0x3e, 0x06, 0x57,
-  0x5d, 0x6f, 0xd8, 0xe6, 0x61, 0x1d, 0xfe, 0x78, 0x76, 0x75, 0x50, 0x70,
-  0x38, 0x32, 0x13, 0x2c, 0x8e, 0x44, 0xa8, 0x0c, 0x5e, 0x1e, 0x38, 0x2c,
-  0x18, 0x0d, 0x1a, 0x5e, 0x42, 0x24, 0x4b, 0xbb, 0x9c, 0x12, 0x2b, 0x14,
-  0x0b, 0x22, 0x31, 0xae, 0x18, 0x52, 0x5b, 0x2b, 0xd2, 0x65, 0x2a, 0xf1,
-  0x3b, 0xd0, 0x0d, 0x32, 0x0b, 0x0d, 0x9b, 0x9b, 0x57, 0x0a, 0x51, 0x97,
-  0x9b, 0x03, 0x02, 0x50, 0xfe, 0x12, 0x82, 0x05, 0x08, 0x0a, 0x49, 0x26,
-  0x3f, 0x09, 0x67, 0x70, 0x13, 0xeb, 0x6f, 0x25, 0x19, 0x0b, 0x05, 0x12,
-  0x77, 0x0d, 0x5e, 0x19, 0x53, 0x41, 0x24, 0x0d, 0x07, 0x9f, 0x32, 0x0c,
-  0x39, 0x69, 0x2d, 0x35, 0x6e, 0x30, 0x08, 0x32, 0xa2, 0xfe, 0x86, 0xc7,
-  0x0e, 0xbf, 0x0a, 0x0c, 0x41, 0x69, 0x26, 0xae, 0x49, 0x16, 0x59, 0x5e,
-  0x50, 0x5d, 0x44, 0x13, 0x9b, 0x25, 0x88, 0x5c, 0x3f, 0x3f, 0x5c, 0x4f,
-  0x57, 0x43, 0x0d, 0x2c, 0x05, 0x2c, 0x05, 0x31, 0x0a, 0x2f, 0x0f, 0x32,
-  0x05, 0x31, 0x31, 0x08, 0x2f, 0x06, 0x3d, 0x02, 0x3b, 0x06, 0x37, 0x37,
-  0x37, 0x37, 0x3d, 0x33, 0x05, 0x32, 0x0e, 0x31, 0x38, 0x07, 0x31, 0x31,
-  0x7b, 0x05, 0x05, 0x13, 0x39, 0x30, 0x38, 0x68, 0x4e, 0x1d, 0x25, 0x1e,
-  0x62, 0x5c, 0x44, 0x68, 0x2c, 0x0f, 0x29, 0x68, 0x3f, 0x12, 0x05, 0xcc,
-  0x31, 0x06, 0x37, 0x49, 0x32, 0x06, 0x31, 0x21, 0x31, 0x07, 0x32, 0x18,
-  0x32, 0x06, 0x32, 0x04, 0x32, 0x05, 0x33, 0x0a, 0x32, 0x07, 0x31, 0x00,
-  0x00, 0x01, 0x00, 0x9a, 0x00, 0x00, 0x05, 0xdb, 0x05, 0xd8, 0x00, 0x26,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x01, 0x07, 0x14,
-  0x17, 0x25, 0x32, 0x17, 0x15, 0x14, 0x23, 0x05, 0x22, 0x27, 0x26, 0x3d,
-  0x01, 0x34, 0x37, 0x00, 0x37, 0x36, 0x35, 0x34, 0x27, 0x23, 0x05, 0x22,
-  0x27, 0x35, 0x34, 0x37, 0x33, 0x03, 0xd5, 0x81, 0x65, 0x2f, 0x6f, 0xfd,
-  0xae, 0x0a, 0x57, 0x03, 0x16, 0x46, 0x08, 0x5e, 0xfc, 0xf7, 0x91, 0x61,
-  0x18, 0x7d, 0x02, 0x2f, 0x12, 0x0a, 0x58, 0x0a, 0xfd, 0x09, 0x33, 0x0a,
-  0x58, 0x0d, 0x05, 0xd8, 0x8d, 0x4d, 0x4f, 0x8a, 0x62, 0xfd, 0xa0, 0x3e,
-  0x59, 0x1a, 0xd1, 0x61, 0x03, 0x59, 0xc6, 0xae, 0x35, 0x38, 0x18, 0x8a,
-  0x6c, 0x02, 0x37, 0x1b, 0x1b, 0x16, 0x50, 0x20, 0xcc, 0x50, 0x1e, 0x40,
-  0x0c, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0xd8, 0x00, 0x11, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3c, 0x00, 0x46,
-  0x00, 0x58, 0x00, 0x00, 0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x05, 0x06,
-  0x2b, 0x01, 0x20, 0x03, 0x26, 0x3d, 0x01, 0x10, 0x01, 0x36, 0x05, 0x26,
-  0x23, 0x20, 0x03, 0x06, 0x15, 0x10, 0x17, 0x16, 0x33, 0x20, 0x13, 0x36,
-  0x3d, 0x01, 0x10, 0x25, 0x26, 0x01, 0x23, 0x22, 0x27, 0x13, 0x16, 0x3b,
-  0x01, 0x32, 0x37, 0x13, 0x06, 0x01, 0x06, 0x1d, 0x01, 0x21, 0x35, 0x10,
-  0x25, 0x36, 0x37, 0x13, 0x06, 0x25, 0x16, 0x17, 0x21, 0x26, 0x27, 0x26,
-  0x27, 0x13, 0x16, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b,
-  0x01, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x34, 0x37, 0x36, 0x03, 0x2e, 0x01,
-  0x59, 0xee, 0x66, 0xfe, 0xe3, 0xae, 0xbf, 0x1d, 0xfe, 0xaa, 0xec, 0x59,
-  0x01, 0x30, 0xa7, 0x01, 0xe8, 0x96, 0x96, 0xfe, 0xf2, 0xd4, 0x71, 0xfb,
-  0xa0, 0xc9, 0x01, 0x33, 0xd2, 0x50, 0xfe, 0xce, 0x04, 0xfe, 0xf2, 0x19,
-  0x97, 0x7f, 0xbc, 0x2b, 0x32, 0x08, 0x2d, 0x29, 0xbf, 0x7f, 0xfe, 0xfd,
-  0x56, 0xfe, 0x82, 0x01, 0x02, 0x10, 0x11, 0xbd, 0x06, 0x02, 0x45, 0x56,
-  0x03, 0xfe, 0x80, 0x01, 0x1c, 0x1e, 0x27, 0xbd, 0x71, 0xfe, 0x75, 0x49,
-  0x33, 0x16, 0x3d, 0x25, 0x29, 0x07, 0x48, 0x33, 0x12, 0x41, 0x23, 0x05,
-  0xd8, 0xfe, 0x8d, 0xaf, 0xd6, 0xfe, 0xb0, 0xfd, 0x93, 0x01, 0x83, 0xae,
-  0xb2, 0x1c, 0x01, 0x53, 0x01, 0x02, 0x84, 0xac, 0x5d, 0xfe, 0xd9, 0xb1,
-  0xc2, 0xfe, 0xc4, 0xe2, 0x8a, 0x01, 0x5a, 0x96, 0xa6, 0x0f, 0x01, 0x59,
-  0xe0, 0x04, 0xfb, 0x48, 0x59, 0x01, 0x6f, 0x1f, 0x1d, 0xfe, 0x92, 0x58,
-  0x03, 0x28, 0x49, 0x5f, 0x05, 0x10, 0x01, 0x20, 0xdb, 0x0d, 0x0c, 0xfe,
-  0x92, 0x04, 0x8f, 0x91, 0xb0, 0x3b, 0x2e, 0x32, 0x19, 0x01, 0x6c, 0x4f,
-  0xfe, 0xcf, 0x50, 0x25, 0x2e, 0x47, 0x36, 0x1f, 0x52, 0x25, 0x26, 0x05,
-  0x49, 0x38, 0x1c, 0x00, 0x00, 0x06, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x1b,
-  0x05, 0xd8, 0x00, 0x0f, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x4e, 0x00, 0x6c,
-  0x00, 0x8d, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x36, 0x37,
-  0x16, 0x15, 0x14, 0x06, 0x07, 0x26, 0x35, 0x34, 0x03, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x26, 0x27, 0x36, 0x33, 0x32, 0x16, 0x17, 0x06, 0x01, 0x14,
-  0x16, 0x17, 0x06, 0x07, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x16, 0x01, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x16, 0x33,
-  0x32, 0x37, 0x17, 0x06, 0x15, 0x14, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x01,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x33, 0x16, 0x17, 0x16, 0x11, 0x15,
-  0x2e, 0x01, 0x23, 0x06, 0x07, 0x27, 0x36, 0x35, 0x34, 0x27, 0x35, 0x36,
-  0x37, 0x36, 0x35, 0x34, 0x26, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3b,
-  0x01, 0x27, 0x26, 0x27, 0x12, 0x37, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16,
-  0x1f, 0x01, 0x06, 0x15, 0x14, 0x17, 0x07, 0x26, 0x2b, 0x01, 0x22, 0x23,
-  0x22, 0x06, 0x03, 0xcc, 0x3d, 0x41, 0x01, 0x21, 0x20, 0x02, 0x6d, 0x4d,
-  0x09, 0x0c, 0x39, 0x44, 0x07, 0x52, 0x37, 0x1e, 0x13, 0x4e, 0x69, 0x06,
-  0x78, 0x42, 0x16, 0xfe, 0x57, 0x52, 0x3f, 0x03, 0x0e, 0x5e, 0x64, 0x02,
-  0x26, 0x03, 0x61, 0x62, 0x96, 0x29, 0x2d, 0x94, 0x52, 0x01, 0x37, 0x6b,
-  0x53, 0x57, 0x6f, 0x73, 0x4c, 0x48, 0x32, 0xa5, 0x34, 0x2b, 0x19, 0x3e,
-  0x1f, 0x1d, 0x1c, 0x1a, 0x3a, 0x18, 0x32, 0x38, 0x90, 0x3e, 0x48, 0xfe,
-  0xc9, 0x92, 0x53, 0x0f, 0x3e, 0x03, 0x5f, 0x6c, 0xaf, 0x0b, 0xbd, 0x65,
-  0xa5, 0x75, 0x3f, 0x01, 0x39, 0xa3, 0x4c, 0x30, 0x16, 0xfb, 0xf9, 0x04,
-  0x6d, 0x62, 0xa2, 0x10, 0x02, 0x27, 0x02, 0x0f, 0xf9, 0xa0, 0x1e, 0x22,
-  0x5b, 0xac, 0x01, 0x3c, 0x02, 0x3a, 0x65, 0x96, 0x0c, 0x03, 0x04, 0x73,
-  0xa0, 0x01, 0x91, 0x28, 0x8b, 0x41, 0x0c, 0x0c, 0x0e, 0x05, 0x13, 0x12,
-  0x5f, 0xc3, 0x25, 0x18, 0x19, 0x0e, 0x02, 0x0d, 0x23, 0x04, 0x2b, 0x16,
-  0x1c, 0x42, 0x05, 0x37, 0x21, 0xfe, 0xea, 0x4e, 0x8f, 0x20, 0x26, 0x22,
-  0x2e, 0xcb, 0x4f, 0x10, 0x0f, 0x06, 0xfd, 0xb2, 0x53, 0x06, 0x24, 0xaa,
-  0x02, 0x58, 0x45, 0x2f, 0x4b, 0x28, 0x41, 0x61, 0x5d, 0x64, 0x4c, 0x50,
-  0x2a, 0x18, 0x17, 0x27, 0x46, 0x43, 0x61, 0x59, 0x72, 0x3d, 0x05, 0xa0,
-  0x43, 0xd9, 0x34, 0x34, 0x6d, 0x6f, 0x0a, 0x43, 0x82, 0xfe, 0xff, 0x0a,
-  0x9d, 0xb6, 0x0a, 0x93, 0x28, 0x07, 0x07, 0x46, 0x19, 0x4b, 0x1f, 0x9c,
-  0x57, 0x59, 0x1a, 0x8e, 0xfc, 0x46, 0x18, 0x19, 0x95, 0xa1, 0x76, 0x02,
-  0x62, 0x89, 0x01, 0x0e, 0x70, 0x68, 0xb4, 0x27, 0x55, 0x44, 0x98, 0x27,
-  0x52, 0x1d, 0x3c, 0x09, 0x0a, 0x24, 0x88, 0x93, 0x00, 0x17, 0x00, 0x5a,
-  0xff, 0xfc, 0x04, 0x77, 0x05, 0xd1, 0x00, 0x07, 0x00, 0x1d, 0x00, 0x23,
-  0x00, 0x2b, 0x00, 0x3f, 0x00, 0x56, 0x00, 0x6d, 0x00, 0x83, 0x00, 0xa2,
-  0x00, 0xad, 0x00, 0xb2, 0x00, 0xb7, 0x00, 0xbc, 0x00, 0xc1, 0x00, 0xc9,
-  0x00, 0xd0, 0x00, 0xd5, 0x00, 0xda, 0x00, 0xdf, 0x00, 0xe5, 0x00, 0xed,
-  0x00, 0xf4, 0x01, 0x23, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x33, 0x32,
-  0x37, 0x26, 0x17, 0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x37, 0x27, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x06, 0x07, 0x26, 0x27, 0x36, 0x35, 0x34,
-  0x01, 0x06, 0x07, 0x23, 0x26, 0x37, 0x03, 0x16, 0x33, 0x32, 0x35, 0x34,
-  0x27, 0x26, 0x13, 0x15, 0x06, 0x23, 0x22, 0x27, 0x35, 0x26, 0x35, 0x36,
-  0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x04, 0x07, 0x23, 0x26, 0x27, 0x15,
-  0x27, 0x35, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x04,
-  0x15, 0x14, 0x07, 0x27, 0x36, 0x35, 0x34, 0x27, 0x34, 0x03, 0x15, 0x27,
-  0x35, 0x24, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x17, 0x06,
-  0x04, 0x17, 0x06, 0x07, 0x27, 0x36, 0x35, 0x34, 0x07, 0x26, 0x27, 0x36,
-  0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x04, 0x17, 0x06, 0x07, 0x26, 0x27,
-  0x36, 0x35, 0x34, 0x27, 0x15, 0x27, 0x13, 0x15, 0x27, 0x35, 0x24, 0x35,
-  0x36, 0x37, 0x33, 0x32, 0x17, 0x07, 0x17, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x23, 0x22, 0x15, 0x14, 0x04, 0x17, 0x06, 0x07, 0x26, 0x27, 0x36, 0x27,
-  0x36, 0x01, 0x14, 0x1e, 0x01, 0x33, 0x26, 0x34, 0x37, 0x22, 0x0e, 0x01,
-  0x05, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16,
-  0x17, 0x37, 0x26, 0x27, 0x16, 0x07, 0x37, 0x26, 0x27, 0x14, 0x15, 0x14,
-  0x07, 0x17, 0x35, 0x34, 0x27, 0x06, 0x07, 0x17, 0x36, 0x35, 0x34, 0x05,
-  0x17, 0x36, 0x37, 0x06, 0x07, 0x17, 0x36, 0x37, 0x06, 0x07, 0x17, 0x36,
-  0x37, 0x06, 0x1f, 0x01, 0x35, 0x34, 0x37, 0x06, 0x17, 0x37, 0x26, 0x35,
-  0x34, 0x35, 0x06, 0x15, 0x3f, 0x01, 0x26, 0x27, 0x14, 0x15, 0x14, 0x17,
-  0x15, 0x27, 0x35, 0x26, 0x23, 0x22, 0x07, 0x22, 0x27, 0x36, 0x25, 0x16,
-  0x17, 0x16, 0x33, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01,
-  0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x31, 0x14, 0x31,
-  0x15, 0x36, 0x37, 0x04, 0x17, 0x06, 0x23, 0x26, 0x23, 0x22, 0x03, 0x02,
-  0x04, 0x0a, 0x0b, 0x16, 0x09, 0x47, 0x06, 0x07, 0x3c, 0x31, 0x17, 0x14,
-  0x52, 0x61, 0x20, 0x37, 0x0a, 0x0c, 0xb8, 0x0b, 0x01, 0x7f, 0x3f, 0x8e,
-  0xf7, 0xfe, 0xae, 0x56, 0x1c, 0x0d, 0x01, 0x4d, 0x5d, 0x18, 0x0c, 0x09,
-  0x05, 0x1f, 0xd8, 0x0a, 0x18, 0x1e, 0x03, 0x9d, 0x04, 0x3a, 0x29, 0x28,
-  0x37, 0x01, 0x17, 0x02, 0x0e, 0x17, 0x68, 0x43, 0xfc, 0x04, 0x02, 0x73,
-  0x2f, 0x4e, 0x9d, 0x01, 0x8a, 0x65, 0x2c, 0x3e, 0x01, 0x48, 0x43, 0xfe,
-  0xb7, 0x02, 0x04, 0x66, 0x45, 0x5f, 0xba, 0x01, 0x09, 0x02, 0x37, 0x02,
-  0x04, 0x87, 0x5e, 0x93, 0xe4, 0xf2, 0x05, 0x01, 0x65, 0x41, 0x42, 0x93,
-  0x01, 0xe0, 0x02, 0x03, 0x9d, 0x1e, 0x34, 0x9e, 0xaa, 0x43, 0x43, 0x43,
-  0xfe, 0xa7, 0x0c, 0xb8, 0x08, 0x37, 0x2e, 0x62, 0x53, 0x15, 0x15, 0x33,
-  0x3b, 0x07, 0x07, 0x25, 0x02, 0x89, 0x06, 0x06, 0x9d, 0x39, 0x64, 0xed,
-  0x02, 0x0b, 0xfe, 0x9e, 0x10, 0x1d, 0x11, 0x0e, 0x0e, 0x10, 0x1e, 0x10,
-  0x01, 0x8d, 0x69, 0x27, 0x19, 0x57, 0x88, 0x68, 0x22, 0x26, 0x56, 0x71,
-  0x48, 0x0f, 0x2c, 0x37, 0x75, 0x30, 0x01, 0x37, 0x23, 0x5d, 0x13, 0x36,
-  0x37, 0x2d, 0x2f, 0x36, 0x27, 0xfd, 0x5d, 0x19, 0x28, 0x68, 0x52, 0x28,
-  0x26, 0x22, 0x68, 0x5a, 0x12, 0x2c, 0x0f, 0x48, 0x4b, 0x0e, 0x38, 0x2e,
-  0x43, 0x3a, 0x37, 0x14, 0x23, 0x5d, 0x36, 0x2f, 0x2d, 0xce, 0x43, 0x29,
-  0x40, 0x20, 0x26, 0xf0, 0x50, 0x4c, 0x01, 0x3c, 0x14, 0x50, 0x02, 0x01,
-  0x03, 0x02, 0x12, 0x14, 0x14, 0x25, 0x26, 0x25, 0x15, 0x14, 0x12, 0x03,
-  0x02, 0x4f, 0x15, 0x01, 0x3b, 0x4c, 0x50, 0xf0, 0x26, 0x21, 0x3d, 0x04,
-  0x20, 0x08, 0x04, 0x09, 0x0a, 0x14, 0x3f, 0x02, 0x18, 0x05, 0x17, 0x19,
-  0x3e, 0x02, 0x04, 0x7d, 0x3e, 0x20, 0x11, 0x09, 0x14, 0x2a, 0x30, 0xfc,
-  0x74, 0x22, 0x3c, 0x48, 0x23, 0x03, 0xa6, 0x0b, 0x08, 0x05, 0x09, 0x09,
-  0xfc, 0x2d, 0x38, 0x1a, 0x38, 0x29, 0x1e, 0x36, 0x31, 0x18, 0x0d, 0x06,
-  0x15, 0x15, 0x29, 0x36, 0x66, 0x38, 0xad, 0x5a, 0x0d, 0x5c, 0x2b, 0x48,
-  0x44, 0x20, 0x13, 0x09, 0x1a, 0x27, 0x2a, 0x3e, 0x4a, 0x2e, 0x0e, 0x0b,
-  0x11, 0x1d, 0x05, 0x05, 0x17, 0x01, 0x99, 0x8c, 0x0d, 0x89, 0x26, 0x62,
-  0x35, 0x16, 0x14, 0x07, 0x0f, 0x1d, 0x02, 0x02, 0x34, 0x43, 0x55, 0x45,
-  0x20, 0x1b, 0x27, 0x1a, 0x27, 0xa4, 0x21, 0x60, 0x39, 0x1e, 0x0c, 0x07,
-  0x21, 0x2c, 0x28, 0x4d, 0x54, 0x45, 0x15, 0x0f, 0x0b, 0x1e, 0x2a, 0x21,
-  0x1d, 0x85, 0x0c, 0x02, 0x04, 0x7f, 0x08, 0x7d, 0x15, 0x71, 0x7e, 0x04,
-  0x3d, 0x18, 0x17, 0x05, 0x18, 0x02, 0x2f, 0x2b, 0x29, 0x66, 0x5b, 0x14,
-  0x10, 0x0f, 0x1c, 0x34, 0x1f, 0x02, 0x66, 0x12, 0x20, 0x11, 0x21, 0x42,
-  0x22, 0x11, 0x20, 0x3c, 0x40, 0x30, 0x26, 0x39, 0x15, 0x63, 0x3f, 0x22,
-  0x56, 0x2b, 0x80, 0x47, 0x13, 0x6f, 0x4d, 0x93, 0x4b, 0x08, 0x7e, 0x61,
-  0x11, 0x0f, 0x84, 0x3f, 0x0b, 0x0c, 0x7d, 0x62, 0x89, 0x39, 0x19, 0x65,
-  0x5c, 0x0d, 0x50, 0x26, 0x30, 0x40, 0x11, 0x6b, 0x22, 0x3f, 0x63, 0x2a,
-  0x89, 0x13, 0x47, 0x80, 0x45, 0x89, 0x08, 0x06, 0x4a, 0x8e, 0x58, 0x8d,
-  0x0b, 0x3f, 0x84, 0x0f, 0x11, 0x65, 0x7d, 0x04, 0x19, 0x39, 0x89, 0x0d,
-  0x0d, 0x5c, 0xab, 0xce, 0x06, 0xc2, 0x34, 0x0c, 0xa5, 0x5c, 0x06, 0x36,
-  0x1e, 0x01, 0x18, 0x01, 0x02, 0x0a, 0x27, 0x16, 0x15, 0x27, 0x16, 0x16,
-  0x27, 0x15, 0x16, 0x27, 0x0a, 0x02, 0x01, 0x01, 0x16, 0x1e, 0x36, 0x06,
-  0x5c, 0xa5, 0x0d, 0x00, 0x00, 0x02, 0x00, 0x99, 0x00, 0x00, 0x04, 0xc7,
-  0x05, 0xd9, 0x00, 0x08, 0x00, 0x28, 0x00, 0x00, 0x01, 0x26, 0x27, 0x06,
-  0x07, 0x16, 0x17, 0x36, 0x35, 0x03, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17,
-  0x15, 0x14, 0x07, 0x33, 0x32, 0x37, 0x11, 0x26, 0x2b, 0x02, 0x11, 0x14,
-  0x17, 0x21, 0x36, 0x35, 0x11, 0x2b, 0x01, 0x22, 0x07, 0x11, 0x16, 0x33,
-  0x03, 0x20, 0x02, 0x6d, 0x6d, 0x01, 0x07, 0x67, 0x6f, 0xb1, 0x6b, 0x0b,
-  0x03, 0xb5, 0xb6, 0x03, 0x76, 0x93, 0xa3, 0x9c, 0x98, 0xa1, 0x05, 0x94,
-  0x59, 0xfe, 0xc9, 0x59, 0x97, 0x06, 0xa1, 0x98, 0x9d, 0xa2, 0x04, 0xde,
-  0xb1, 0x02, 0x02, 0xb1, 0x8e, 0x71, 0x58, 0x9f, 0xfe, 0xf1, 0x65, 0xb8,
-  0xf3, 0x02, 0x02, 0xf3, 0x0e, 0xb7, 0x58, 0x63, 0xfe, 0xf7, 0x36, 0xfe,
-  0x0c, 0xb5, 0xae, 0xae, 0xb5, 0x01, 0xf4, 0x36, 0x01, 0x09, 0x63, 0x00,
-  0x00, 0x03, 0x00, 0x99, 0xff, 0xfd, 0x04, 0x14, 0x05, 0xd9, 0x00, 0x03,
-  0x00, 0x20, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x15, 0x33, 0x35, 0x27, 0x35,
-  0x33, 0x15, 0x33, 0x15, 0x23, 0x15, 0x33, 0x05, 0x15, 0x21, 0x11, 0x17,
-  0x15, 0x27, 0x03, 0x23, 0x11, 0x27, 0x35, 0x17, 0x11, 0x21, 0x35, 0x21,
-  0x35, 0x23, 0x35, 0x13, 0x33, 0x11, 0x33, 0x35, 0x23, 0x35, 0x23, 0x15,
-  0x23, 0x15, 0x33, 0x01, 0xf5, 0xb6, 0xa5, 0x9a, 0x71, 0x71, 0x08, 0x01,
-  0x6c, 0xfe, 0x8c, 0x81, 0x7a, 0x01, 0xa0, 0x79, 0x79, 0xfe, 0x93, 0x01,
-  0x6d, 0x6a, 0x94, 0x40, 0xf1, 0xf1, 0x40, 0xf0, 0xf0, 0x05, 0x40, 0x3c,
-  0x3c, 0x33, 0x66, 0x66, 0xa2, 0x58, 0x01, 0xaf, 0xfd, 0xe8, 0x8b, 0x9c,
-  0x85, 0xfe, 0xee, 0x01, 0xbc, 0x86, 0x9b, 0x82, 0x01, 0x71, 0xb0, 0x58,
-  0xa2, 0xfc, 0xcf, 0x01, 0xbb, 0x47, 0x63, 0x63, 0x47, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x99, 0x00, 0x00, 0x05, 0x0c, 0x07, 0x4a, 0x00, 0x07,
-  0x00, 0x20, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23,
-  0x01, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x37,
-  0x33, 0x09, 0x01, 0x23, 0x03, 0x11, 0x23, 0x11, 0x03, 0x23, 0x09, 0x01,
-  0x33, 0x02, 0xd7, 0xbc, 0x69, 0x72, 0x72, 0x69, 0xfe, 0xb0, 0x01, 0x50,
-  0xba, 0xbf, 0xbf, 0xba, 0xbc, 0xc4, 0xc6, 0xfe, 0x90, 0x01, 0x83, 0xc5,
-  0xd7, 0x95, 0xe5, 0xc5, 0x01, 0x8b, 0xfe, 0x96, 0xc6, 0x06, 0xa7, 0xfd,
-  0xd8, 0x90, 0x01, 0x08, 0x90, 0xfc, 0x04, 0x04, 0x9f, 0xdf, 0xd8, 0xd9,
-  0xde, 0xfe, 0xcd, 0xed, 0xfe, 0x42, 0xfe, 0x28, 0x01, 0x06, 0xfe, 0xfa,
-  0x01, 0x17, 0xfe, 0xe9, 0x01, 0xe1, 0x01, 0xb5, 0x00, 0x01, 0x00, 0x99,
-  0x00, 0x00, 0x03, 0x54, 0x05, 0xd7, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x33,
-  0x17, 0x15, 0x33, 0x17, 0x15, 0x07, 0x23, 0x15, 0x21, 0x17, 0x15, 0x07,
-  0x21, 0x11, 0x07, 0x23, 0x27, 0x11, 0x21, 0x27, 0x35, 0x37, 0x21, 0x35,
-  0x23, 0x27, 0x35, 0x37, 0x33, 0x35, 0x01, 0xa8, 0x9a, 0x05, 0x95, 0x04,
-  0x04, 0x95, 0x01, 0x07, 0x05, 0x05, 0xfe, 0xf9, 0x05, 0x9a, 0x06, 0xfe,
-  0xfc, 0x05, 0x05, 0x01, 0x04, 0x92, 0x05, 0x05, 0x92, 0x05, 0xd7, 0x05,
-  0x9b, 0x06, 0x94, 0x06, 0x71, 0x06, 0x98, 0x05, 0xfc, 0x82, 0x05, 0x05,
-  0x03, 0x7e, 0x05, 0x98, 0x06, 0x71, 0x06, 0x94, 0x06, 0x9b, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x99, 0xff, 0xfd, 0x05, 0xdc, 0x05, 0xd5, 0x00, 0x2b,
-  0x00, 0x00, 0x01, 0x21, 0x17, 0x15, 0x07, 0x23, 0x11, 0x21, 0x35, 0x37,
-  0x33, 0x17, 0x11, 0x07, 0x23, 0x27, 0x35, 0x21, 0x11, 0x33, 0x17, 0x15,
-  0x07, 0x21, 0x27, 0x35, 0x37, 0x33, 0x11, 0x21, 0x15, 0x07, 0x23, 0x27,
-  0x11, 0x37, 0x33, 0x17, 0x15, 0x21, 0x11, 0x23, 0x27, 0x35, 0x02, 0x75,
-  0x01, 0x8a, 0x06, 0x06, 0x90, 0x02, 0x02, 0x06, 0x5f, 0x05, 0x05, 0x5f,
-  0x06, 0xfd, 0xfe, 0x90, 0x06, 0x06, 0xfe, 0x76, 0x05, 0x05, 0x99, 0xfd,
-  0xfd, 0x05, 0x68, 0x05, 0x05, 0x68, 0x05, 0x02, 0x03, 0x99, 0x05, 0x05,
-  0xd5, 0x06, 0x77, 0x06, 0xfd, 0xd1, 0xa1, 0x06, 0x06, 0xfe, 0x49, 0x06,
-  0x06, 0x9e, 0xfd, 0xc8, 0x06, 0x6a, 0x06, 0x06, 0x6a, 0x06, 0x02, 0x38,
-  0x9e, 0x06, 0x06, 0x01, 0xb7, 0x06, 0x06, 0xa1, 0x02, 0x2f, 0x06, 0x77,
-  0x00, 0x02, 0x00, 0xa0, 0x00, 0x00, 0x05, 0xd6, 0x05, 0xd8, 0x00, 0x1b,
-  0x00, 0x2c, 0x00, 0x00, 0x01, 0x33, 0x32, 0x17, 0x23, 0x27, 0x20, 0x03,
-  0x06, 0x15, 0x10, 0x05, 0x16, 0x33, 0x37, 0x15, 0x06, 0x07, 0x06, 0x2b,
-  0x01, 0x20, 0x03, 0x26, 0x35, 0x10, 0x25, 0x36, 0x01, 0x33, 0x32, 0x17,
-  0x33, 0x15, 0x07, 0x16, 0x15, 0x27, 0x07, 0x23, 0x35, 0x37, 0x27, 0x35,
-  0x33, 0x03, 0x40, 0x12, 0xc7, 0xbd, 0x05, 0xd7, 0xfe, 0xcb, 0xbc, 0x55,
-  0x01, 0x34, 0x7b, 0x8c, 0xe7, 0x90, 0x7c, 0x49, 0x30, 0x19, 0xfe, 0xb5,
-  0xd6, 0x77, 0x01, 0x5f, 0x9b, 0x02, 0x3f, 0x03, 0x05, 0x38, 0xbc, 0x97,
-  0x3a, 0x9f, 0x98, 0x03, 0x3c, 0x9b, 0xc0, 0x05, 0xd8, 0x92, 0x36, 0xfe,
-  0xca, 0x9e, 0xb9, 0xfe, 0x92, 0xd6, 0x47, 0x32, 0x06, 0x6b, 0x1a, 0x0b,
-  0x01, 0x3e, 0xc0, 0xe9, 0x01, 0xaa, 0xee, 0x59, 0xfe, 0x33, 0xc9, 0x03,
-  0x7e, 0xbb, 0x11, 0x7c, 0x7c, 0x03, 0xc9, 0x7e, 0x03, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd, 0x05, 0xd9, 0x00, 0x16,
-  0x00, 0x4f, 0x00, 0x62, 0x00, 0x73, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32,
-  0x37, 0x16, 0x33, 0x32, 0x37, 0x35, 0x33, 0x17, 0x15, 0x14, 0x0f, 0x01,
-  0x22, 0x27, 0x06, 0x23, 0x22, 0x27, 0x34, 0x17, 0x33, 0x16, 0x17, 0x32,
-  0x15, 0x03, 0x33, 0x24, 0x11, 0x34, 0x27, 0x35, 0x16, 0x11, 0x15, 0x10,
-  0x07, 0x06, 0x07, 0x15, 0x16, 0x3b, 0x01, 0x15, 0x06, 0x2b, 0x01, 0x22,
-  0x07, 0x27, 0x23, 0x22, 0x27, 0x35, 0x33, 0x32, 0x37, 0x35, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x10, 0x3f, 0x01, 0x15, 0x06, 0x15, 0x10, 0x05, 0x35,
-  0x03, 0x35, 0x37, 0x32, 0x27, 0x15, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x15, 0x23, 0x26, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36, 0x33, 0x34, 0x25,
-  0x16, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x07, 0x34, 0x37, 0x36,
-  0x3d, 0x01, 0x10, 0x25, 0x02, 0x9f, 0x19, 0x39, 0x2a, 0x1d, 0x22, 0x27,
-  0x3c, 0x13, 0x04, 0x02, 0x3e, 0x1b, 0x28, 0x1f, 0x1e, 0x28, 0x49, 0x0f,
-  0xa0, 0x02, 0x2d, 0x1f, 0x07, 0x09, 0x02, 0x01, 0x07, 0x63, 0xc7, 0xc9,
-  0x45, 0x2a, 0x48, 0x95, 0x17, 0x69, 0x41, 0x74, 0x14, 0x3e, 0x3d, 0x82,
-  0x32, 0x7b, 0x36, 0x6d, 0x4e, 0x50, 0x70, 0x20, 0x5a, 0xb4, 0x1d, 0x69,
-  0x01, 0x08, 0x10, 0x03, 0x1f, 0xe6, 0x55, 0x3b, 0x78, 0x83, 0x02, 0x8e,
-  0x54, 0x22, 0xf1, 0x6d, 0x20, 0x02, 0x3b, 0x77, 0x75, 0x9e, 0x95, 0x50,
-  0x1c, 0x31, 0x52, 0xfe, 0xf4, 0x05, 0xd9, 0x4b, 0x30, 0x30, 0x44, 0x07,
-  0x28, 0x05, 0x3b, 0x1b, 0x04, 0x2c, 0x2c, 0x65, 0x22, 0x87, 0x40, 0x0b,
-  0x05, 0xfc, 0x20, 0xe4, 0x01, 0x70, 0xc2, 0xcf, 0x03, 0xd7, 0xfe, 0xeb,
-  0x24, 0xfe, 0xf1, 0xdd, 0x42, 0x16, 0x05, 0x28, 0x05, 0x21, 0x63, 0x63,
-  0x1c, 0x05, 0x2a, 0x03, 0x40, 0x72, 0x4a, 0xb1, 0xb1, 0x01, 0x01, 0xe6,
-  0x1f, 0x05, 0xc0, 0xe2, 0xfe, 0xa7, 0xf5, 0x02, 0x03, 0x26, 0x16, 0xa9,
-  0x2a, 0x06, 0x45, 0x63, 0xcc, 0xef, 0xe9, 0xd6, 0x02, 0x4a, 0xe9, 0x6b,
-  0x67, 0x01, 0x0c, 0xcd, 0x46, 0x04, 0x02, 0x1e, 0x70, 0xb7, 0xd8, 0x2f,
-  0xd4, 0xb6, 0x51, 0x06, 0x07, 0x52, 0xaf, 0xbf, 0x02, 0x01, 0x6d, 0xf4,
-  0x00, 0x03, 0x00, 0x99, 0x00, 0x00, 0x04, 0x85, 0x05, 0xd9, 0x00, 0x5b,
-  0x00, 0x66, 0x00, 0x6e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x0f, 0x01, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x17, 0x23, 0x15, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x37, 0x33, 0x16, 0x11, 0x10, 0x03, 0x26, 0x23, 0x22, 0x15,
-  0x14, 0x17, 0x16, 0x15, 0x14, 0x15, 0x06, 0x23, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x15, 0x14, 0x15, 0x14, 0x17, 0x14, 0x23, 0x22, 0x35, 0x36,
-  0x3d, 0x01, 0x06, 0x15, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x34, 0x36, 0x35,
-  0x34, 0x23, 0x22, 0x07, 0x02, 0x11, 0x34, 0x37, 0x33, 0x17, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x17, 0x35, 0x23, 0x35, 0x26, 0x35, 0x34, 0x37, 0x2f,
-  0x01, 0x36, 0x03, 0x14, 0x17, 0x33, 0x36, 0x35, 0x34, 0x27, 0x06, 0x07,
-  0x06, 0x25, 0x06, 0x15, 0x14, 0x17, 0x36, 0x35, 0x34, 0x02, 0x8f, 0x3c,
-  0x49, 0x11, 0x0d, 0x72, 0x2e, 0x32, 0xb8, 0x01, 0x6c, 0x6d, 0x80, 0x79,
-  0x71, 0x13, 0x05, 0xd2, 0x86, 0x6c, 0x47, 0x32, 0x6c, 0x1b, 0x0c, 0x26,
-  0x0a, 0x08, 0x28, 0x06, 0x35, 0x54, 0x48, 0x5e, 0x64, 0x48, 0x8a, 0x07,
-  0x33, 0x05, 0x25, 0x0d, 0x87, 0x29, 0x4a, 0x68, 0x8b, 0xcd, 0x05, 0x13,
-  0x71, 0xc1, 0x38, 0x6d, 0x6b, 0xb7, 0xd6, 0x16, 0x0e, 0x4e, 0xb9, 0x79,
-  0x04, 0x3f, 0x1a, 0x50, 0x2e, 0x24, 0x01, 0x4b, 0x1f, 0x3b, 0x81, 0x05,
-  0xd9, 0x4b, 0x0f, 0x7c, 0x2e, 0x50, 0x51, 0x55, 0xc7, 0x62, 0x4b, 0x78,
-  0x81, 0x9d, 0xc6, 0xb0, 0x72, 0x13, 0xa5, 0xfe, 0xfe, 0xfe, 0xe0, 0xfe,
-  0xc9, 0xae, 0x2d, 0x1c, 0x93, 0x26, 0x2a, 0x02, 0x03, 0x3b, 0x02, 0x22,
-  0xee, 0x31, 0x96, 0x03, 0x04, 0x46, 0x71, 0x3b, 0x3c, 0x74, 0x4d, 0x92,
-  0x5d, 0xbf, 0x23, 0x3b, 0x40, 0xa4, 0x22, 0x2b, 0xad, 0x01, 0x21, 0x01,
-  0x4d, 0xe9, 0xa6, 0x13, 0x79, 0xae, 0xfb, 0xa3, 0x2f, 0x12, 0x78, 0x4b,
-  0x5c, 0xcc, 0xbe, 0x67, 0x7c, 0x12, 0x48, 0xfd, 0xff, 0x92, 0x4a, 0x69,
-  0x8b, 0x53, 0x7e, 0x19, 0x4a, 0x3f, 0xa2, 0x73, 0x63, 0x89, 0x66, 0x3d,
-  0xa8, 0x98, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdb,
-  0x05, 0xd7, 0x00, 0x32, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x17, 0x07, 0x23, 0x27, 0x06, 0x23, 0x22, 0x27, 0x15, 0x03, 0x23,
-  0x26, 0x27, 0x36, 0x01, 0x36, 0x33, 0x16, 0x33, 0x32, 0x37, 0x27, 0x07,
-  0x23, 0x26, 0x27, 0x13, 0x04, 0x15, 0x07, 0x16, 0x17, 0x35, 0x36, 0x3d,
-  0x01, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x36, 0x03, 0x84, 0xd5,
-  0xbc, 0x87, 0x70, 0xae, 0x7e, 0x02, 0xa7, 0x94, 0xc3, 0x9a, 0x80, 0xea,
-  0x03, 0xb7, 0x04, 0x17, 0x01, 0x37, 0x15, 0x07, 0x65, 0x8f, 0xac, 0x87,
-  0xc3, 0x61, 0x05, 0xa9, 0x08, 0xd2, 0x00, 0xff, 0x72, 0xcf, 0x1a, 0x3c,
-  0xe2, 0x7c, 0x6b, 0x21, 0x58, 0x6c, 0x99, 0x05, 0xd7, 0xbd, 0x9b, 0xd7,
-  0xc9, 0x8a, 0x94, 0x83, 0xaa, 0x6e, 0x58, 0x03, 0xfe, 0x31, 0x8d, 0x07,
-  0x19, 0x01, 0x98, 0x1d, 0x55, 0x68, 0xc6, 0x73, 0x74, 0x0c, 0x01, 0x02,
-  0x0e, 0x05, 0x9f, 0xaf, 0x0e, 0x02, 0x5a, 0x7c, 0x24, 0xfe, 0x65, 0x45,
-  0x37, 0x8f, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0xd8, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x21,
-  0x00, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x13, 0x14, 0x17, 0x01, 0x03, 0x06, 0x00, 0x13, 0x16, 0x17,
-  0x1b, 0x01, 0x36, 0x37, 0x09, 0x01, 0x36, 0x35, 0x34, 0x00, 0x27, 0x11,
-  0x99, 0x01, 0x8a, 0x01, 0x17, 0x01, 0x18, 0x01, 0x89, 0xfe, 0x77, 0xfe,
-  0xe8, 0xfe, 0xe9, 0xfe, 0x76, 0x89, 0x6d, 0x01, 0x7f, 0x02, 0xb0, 0xfe,
-  0xc6, 0x9c, 0x9e, 0xad, 0x01, 0x56, 0xb8, 0x9a, 0xfe, 0xae, 0x01, 0x8f,
-  0x65, 0xfe, 0xc4, 0xbd, 0x02, 0xea, 0x01, 0x37, 0x01, 0xb7, 0xfe, 0x49,
-  0xfe, 0xc9, 0xfe, 0xca, 0xfe, 0x4c, 0x01, 0xb4, 0x01, 0x36, 0xe5, 0x78,
-  0x01, 0xf5, 0x01, 0xc2, 0x04, 0xfe, 0xa3, 0xfd, 0x62, 0xb1, 0x06, 0x02,
-  0x68, 0xfd, 0x96, 0x08, 0xa4, 0x01, 0xb6, 0xfe, 0x97, 0x70, 0xf5, 0xf9,
-  0x01, 0x5d, 0x04, 0xfe, 0x42, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd8, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x28,
-  0x00, 0x34, 0x00, 0x00, 0x01, 0x15, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x05,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x05,
-  0x34, 0x26, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x25, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x3a, 0x09,
-  0xb1, 0x82, 0x84, 0xb4, 0xfe, 0x8c, 0xff, 0x00, 0xfe, 0xfb, 0xfe, 0xa2,
-  0x12, 0x16, 0x9f, 0x86, 0x81, 0xb2, 0x01, 0x9c, 0x37, 0x22, 0x26, 0x36,
-  0x36, 0x26, 0x24, 0x35, 0xfd, 0x8b, 0x35, 0x4a, 0x34, 0x34, 0x4a, 0x35,
-  0x03, 0x81, 0xfe, 0x77, 0xfe, 0xe8, 0xfe, 0xe9, 0xfe, 0x76, 0x01, 0x8a,
-  0x01, 0x17, 0x01, 0x18, 0x01, 0x89, 0x02, 0xf8, 0x1a, 0x8e, 0xc1, 0xcf,
-  0x9a, 0x01, 0x16, 0x01, 0x98, 0xfe, 0x7b, 0xfe, 0xc9, 0xac, 0xb2, 0xc0,
-  0x9e, 0x29, 0x3a, 0x3a, 0x29, 0x2a, 0x3c, 0x3c, 0x2a, 0x2a, 0x3c, 0x3c,
-  0x2a, 0x29, 0x3a, 0x3c, 0x27, 0xfe, 0xca, 0xfe, 0x4c, 0x01, 0xb4, 0x01,
-  0x36, 0x01, 0x37, 0x01, 0xb7, 0xfe, 0x49, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x07, 0x0b, 0xb3,
-  0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd,
-  0x05, 0xd4, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x01, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0c,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26,
-  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85,
-  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
-  0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb4,
-  0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26,
-  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x85,
-  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb3,
-  0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
-  0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d,
-  0x00, 0x0a, 0x00, 0x79, 0xff, 0xea, 0x05, 0xfb, 0x05, 0xe1, 0x00, 0x0c,
-  0x00, 0x40, 0x00, 0x46, 0x00, 0x4c, 0x00, 0x52, 0x00, 0x58, 0x00, 0x5e,
-  0x00, 0x64, 0x00, 0x6a, 0x00, 0x70, 0x00, 0x00, 0x00, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x36, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x05, 0x26, 0x34,
-  0x37, 0x33, 0x36, 0x37, 0x27, 0x36, 0x37, 0x17, 0x36, 0x37, 0x35, 0x36,
-  0x32, 0x17, 0x15, 0x16, 0x17, 0x37, 0x16, 0x17, 0x07, 0x16, 0x17, 0x33,
-  0x16, 0x14, 0x07, 0x23, 0x06, 0x07, 0x17, 0x06, 0x07, 0x27, 0x06, 0x07,
-  0x15, 0x06, 0x23, 0x27, 0x35, 0x26, 0x27, 0x07, 0x26, 0x27, 0x37, 0x26,
-  0x27, 0x01, 0x36, 0x37, 0x03, 0x06, 0x07, 0x05, 0x16, 0x17, 0x37, 0x26,
-  0x27, 0x01, 0x36, 0x37, 0x27, 0x06, 0x07, 0x25, 0x16, 0x17, 0x37, 0x26,
-  0x27, 0x01, 0x26, 0x27, 0x07, 0x16, 0x17, 0x25, 0x06, 0x07, 0x17, 0x36,
-  0x37, 0x05, 0x06, 0x07, 0x13, 0x36, 0x37, 0x25, 0x26, 0x27, 0x07, 0x16,
-  0x17, 0x02, 0xa8, 0x2c, 0x2a, 0x3c, 0x3c, 0x54, 0x2b, 0x2a, 0x3b, 0x3c,
-  0x2a, 0xfd, 0xbf, 0x19, 0x19, 0x65, 0x18, 0x60, 0x4c, 0x0e, 0x59, 0x4a,
-  0x6f, 0xaf, 0x23, 0x46, 0x24, 0xa4, 0x7c, 0x47, 0x5b, 0x10, 0x4d, 0x5f,
-  0x19, 0x65, 0x19, 0x19, 0x65, 0x12, 0x66, 0x4d, 0x10, 0x5b, 0x47, 0x7d,
-  0xa3, 0x24, 0x23, 0x46, 0xa3, 0x7c, 0x49, 0x57, 0x10, 0x49, 0x5d, 0x18,
-  0x01, 0xc8, 0x1e, 0x20, 0x0b, 0x80, 0x58, 0x01, 0x5a, 0x25, 0x1a, 0xa4,
-  0x5a, 0x7e, 0xfe, 0xd1, 0x07, 0x14, 0xb7, 0x44, 0x15, 0x02, 0xab, 0x16,
-  0x05, 0xf7, 0x11, 0x49, 0xfd, 0xad, 0x12, 0x09, 0xf5, 0x14, 0x44, 0x02,
-  0x6e, 0x07, 0x14, 0xb8, 0x4a, 0x0f, 0xfe, 0x9c, 0x1e, 0x21, 0x0b, 0x7e,
-  0x5a, 0xfe, 0xa5, 0x1a, 0x23, 0xa6, 0x5a, 0x7f, 0x03, 0x26, 0x84, 0x2f,
-  0x2f, 0x5e, 0x84, 0x30, 0x30, 0x30, 0xc3, 0x27, 0x4e, 0x27, 0xb7, 0x7c,
-  0x50, 0x5f, 0x10, 0x50, 0x66, 0x1e, 0x70, 0x1c, 0x1c, 0x70, 0x16, 0x6f,
-  0x51, 0x0f, 0x60, 0x51, 0x79, 0xb9, 0x27, 0x4e, 0x27, 0xb0, 0x83, 0x50,
-  0x5c, 0x0b, 0x51, 0x67, 0x1d, 0x70, 0x1c, 0x1c, 0x70, 0x17, 0x6d, 0x51,
-  0x0b, 0x5c, 0x50, 0x79, 0xba, 0x01, 0x2c, 0x13, 0x0a, 0x01, 0x0d, 0x16,
-  0x4d, 0xaa, 0x0a, 0x13, 0xc6, 0x4e, 0x15, 0xfe, 0x3e, 0x26, 0x1a, 0xab,
-  0x60, 0x82, 0x37, 0x1e, 0x22, 0x0a, 0x7f, 0x62, 0xfe, 0x4b, 0x1e, 0x2a,
-  0x11, 0x8c, 0x56, 0xf4, 0x26, 0x22, 0xac, 0x67, 0x7b, 0x89, 0x12, 0x0b,
-  0xfe, 0xf0, 0x1e, 0x4d, 0xa5, 0x09, 0x14, 0xc2, 0x4d, 0x1e, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a,
-  0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36,
-  0x20, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x07,
-  0x02, 0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08,
-  0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
-  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x20, 0x2e, 0xa4, 0x01, 0xd0,
-  0xa4, 0x2d, 0x21, 0x67, 0x1a, 0x23, 0x80, 0xfe, 0x94, 0x80, 0x23, 0x1a,
-  0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51,
-  0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
-  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd,
-  0x25, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x8d,
-  0x28, 0x2b, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3d,
-  0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x13, 0x37, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07,
-  0x06, 0x20, 0x27, 0x26, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34,
-  0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc,
-  0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
-  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
-  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x67,
-  0x1a, 0x23, 0x80, 0x01, 0x6c, 0x80, 0x23, 0x1a, 0x67, 0x21, 0x2d, 0xa4,
-  0xfe, 0x30, 0xa4, 0x2e, 0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53,
-  0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75, 0x02,
-  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
-  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
-  0xc0, 0xfe, 0x40, 0xfd, 0xaa, 0x47, 0x2b, 0x27, 0x8e, 0x8e, 0x27, 0x2c,
-  0x48, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x21,
-  0x00, 0x31, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x05, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x22, 0x06, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x25, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x27, 0x06,
-  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
-  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x49, 0x35, 0x34, 0x4b, 0x4b, 0x68,
-  0x4a, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
-  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x4e, 0x20, 0x2e, 0xa4,
-  0x01, 0xd0, 0xa4, 0x2d, 0x21, 0x67, 0x1a, 0x23, 0x80, 0xfe, 0x94, 0x80,
-  0x23, 0x1a, 0x03, 0xfd, 0x3a, 0x53, 0x52, 0x76, 0x51, 0x51, 0x3b, 0x3a,
-  0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0xfe, 0xb2, 0x01, 0x75, 0x02, 0x0f,
-  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x5b, 0x38,
-  0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x8e, 0x27, 0x2b,
-  0x00, 0x0a, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd8, 0x00, 0x07,
-  0x00, 0x0c, 0x00, 0x13, 0x00, 0x22, 0x00, 0x2a, 0x00, 0x32, 0x00, 0x3a,
-  0x00, 0x41, 0x00, 0x49, 0x00, 0x58, 0x00, 0x00, 0x01, 0x33, 0x17, 0x11,
-  0x07, 0x23, 0x27, 0x11, 0x05, 0x17, 0x15, 0x07, 0x27, 0x25, 0x17, 0x07,
-  0x23, 0x26, 0x27, 0x35, 0x05, 0x32, 0x1f, 0x01, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01, 0x21, 0x17, 0x15, 0x07,
-  0x21, 0x27, 0x35, 0x25, 0x21, 0x17, 0x15, 0x07, 0x21, 0x27, 0x35, 0x03,
-  0x33, 0x16, 0x17, 0x15, 0x07, 0x27, 0x35, 0x25, 0x33, 0x17, 0x15, 0x07,
-  0x27, 0x35, 0x25, 0x33, 0x17, 0x11, 0x07, 0x23, 0x27, 0x11, 0x03, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x27, 0x26, 0x23,
-  0x22, 0x03, 0x1b, 0x46, 0x05, 0x05, 0x46, 0x06, 0x02, 0x00, 0x34, 0xdf,
-  0x37, 0xfd, 0x48, 0xe4, 0x38, 0x03, 0xb4, 0x28, 0x01, 0xf8, 0xc2, 0x53,
-  0x0b, 0xb0, 0x41, 0x2b, 0xa3, 0x5b, 0x21, 0xaa, 0x3f, 0xfd, 0x90, 0x01,
-  0x32, 0x05, 0x05, 0xfe, 0xce, 0x05, 0x04, 0x05, 0x01, 0x37, 0x06, 0x06,
-  0xfe, 0xc9, 0x06, 0x40, 0x03, 0x79, 0x66, 0x37, 0xdf, 0xfd, 0xef, 0x03,
-  0x35, 0xdf, 0x36, 0x01, 0xe5, 0x46, 0x05, 0x05, 0x46, 0x06, 0x20, 0x75,
-  0x16, 0x3e, 0x70, 0x1d, 0x2c, 0x79, 0x08, 0x39, 0x84, 0x23, 0x05, 0xd8,
-  0x06, 0xfe, 0xa1, 0x06, 0x06, 0x01, 0x5f, 0x9c, 0x3e, 0x03, 0xff, 0x3f,
-  0xee, 0xfe, 0x40, 0xc7, 0x37, 0x04, 0xb5, 0xe2, 0x60, 0xbd, 0x64, 0x18,
-  0xa8, 0x40, 0x5c, 0xb4, 0x68, 0x1b, 0xfe, 0xed, 0x06, 0x50, 0x06, 0x06,
-  0x50, 0x06, 0x06, 0x50, 0x06, 0x06, 0x50, 0xfe, 0xe7, 0x82, 0x79, 0x03,
-  0x3f, 0xfd, 0x04, 0x2b, 0x3c, 0x03, 0xfe, 0x3e, 0x04, 0x77, 0x06, 0xfe,
-  0xa1, 0x06, 0x06, 0x01, 0x5f, 0x02, 0x56, 0x47, 0x7b, 0x3f, 0x2c, 0x72,
-  0x11, 0x43, 0x82, 0x41, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x93,
-  0x00, 0x00, 0x05, 0xdd, 0x05, 0xd7, 0x00, 0x17, 0x00, 0x2b, 0x00, 0x00,
-  0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x01, 0x06, 0x2b, 0x01, 0x22, 0x27,
-  0x35, 0x36, 0x37, 0x36, 0x11, 0x10, 0x25, 0x26, 0x27, 0x35, 0x34, 0x37,
-  0x17, 0x15, 0x04, 0x11, 0x10, 0x05, 0x07, 0x15, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x36, 0x3d, 0x01, 0x10, 0x01, 0x26, 0x23, 0x03, 0x25, 0x01, 0x63,
-  0xf5, 0x5f, 0xfe, 0x9c, 0xa1, 0x9f, 0x2c, 0x2a, 0x49, 0xf9, 0x71, 0x8b,
-  0xfe, 0xd4, 0x7b, 0x53, 0x86, 0x24, 0x01, 0x9b, 0xfe, 0xd1, 0x27, 0x05,
-  0x4e, 0x8e, 0xd2, 0x4a, 0x1a, 0xfe, 0xc7, 0x92, 0x8f, 0x05, 0xd7, 0xfe,
-  0x87, 0xad, 0xc6, 0xfe, 0x78, 0xfe, 0xff, 0x62, 0x0f, 0x06, 0x4f, 0xb1,
-  0xca, 0x01, 0x0c, 0x01, 0x90, 0xe0, 0x50, 0x10, 0x03, 0x0b, 0x0e, 0x3e,
-  0x03, 0xc5, 0xfe, 0x14, 0xfe, 0x6e, 0xe8, 0x18, 0x04, 0x53, 0x98, 0xf4,
-  0x5d, 0x5d, 0x09, 0x01, 0x3d, 0x01, 0x05, 0x66, 0x00, 0x02, 0x00, 0x99,
-  0x00, 0x00, 0x03, 0xe2, 0x05, 0xd8, 0x00, 0x17, 0x00, 0x2b, 0x00, 0x00,
-  0x21, 0x20, 0x03, 0x26, 0x35, 0x10, 0x01, 0x36, 0x3b, 0x01, 0x32, 0x17,
-  0x15, 0x06, 0x07, 0x06, 0x11, 0x10, 0x05, 0x16, 0x17, 0x15, 0x14, 0x07,
-  0x27, 0x35, 0x24, 0x11, 0x10, 0x25, 0x37, 0x35, 0x23, 0x22, 0x07, 0x06,
-  0x07, 0x06, 0x1d, 0x01, 0x10, 0x01, 0x16, 0x33, 0x03, 0x51, 0xfe, 0x9c,
-  0xf5, 0x5f, 0x01, 0x64, 0xa1, 0xa0, 0x2c, 0x29, 0x48, 0xf8, 0x71, 0x8b,
-  0x01, 0x2d, 0x7a, 0x54, 0x86, 0x24, 0xfe, 0x64, 0x01, 0x2f, 0x27, 0x05,
-  0x4e, 0x8f, 0xd0, 0x4b, 0x19, 0x01, 0x37, 0x94, 0x8e, 0x01, 0x79, 0xad,
-  0xc6, 0x01, 0x88, 0x01, 0x01, 0x63, 0x0f, 0x07, 0x4f, 0xb1, 0xcb, 0xfe,
-  0xf5, 0xfe, 0x70, 0xe1, 0x4f, 0x10, 0x04, 0x0a, 0x0e, 0x3e, 0x03, 0xc5,
-  0x01, 0xed, 0x01, 0x91, 0xe8, 0x18, 0x03, 0x53, 0x96, 0xf5, 0x5c, 0x5e,
-  0x09, 0xfe, 0xc2, 0xfe, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d,
-  0xff, 0x30, 0x03, 0xce, 0x05, 0xdb, 0x00, 0x31, 0x00, 0x3e, 0x00, 0x00,
-  0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x15, 0x37, 0x15,
-  0x07, 0x15, 0x23, 0x27, 0x23, 0x35, 0x33, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15, 0x14,
-  0x17, 0x16, 0x17, 0x33, 0x36, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x23, 0x06, 0x07, 0x06, 0x10, 0x16, 0x33, 0x32, 0x36,
-  0x10, 0x27, 0x26, 0x03, 0x12, 0x24, 0x20, 0x78, 0x77, 0x61, 0x81, 0xc3,
-  0xc6, 0x74, 0x01, 0xb5, 0xb5, 0x01, 0x85, 0x62, 0x77, 0x77, 0x21, 0x24,
-  0x24, 0x21, 0x77, 0x7f, 0x52, 0x4d, 0x69, 0x22, 0x69, 0x4c, 0x52, 0x80,
-  0x78, 0x20, 0xef, 0x22, 0x69, 0x4d, 0x52, 0xa5, 0x75, 0x72, 0xa5, 0x52,
-  0x4c, 0x04, 0x56, 0x1a, 0x24, 0x83, 0xbd, 0xbc, 0x7c, 0x64, 0x0e, 0xd1,
-  0x02, 0x64, 0x01, 0xca, 0xcb, 0x62, 0xd1, 0x0d, 0x65, 0x7c, 0xbc, 0xbd,
-  0x83, 0x24, 0x1a, 0x19, 0x25, 0x83, 0xbc, 0x08, 0x0a, 0x82, 0x5a, 0x53,
-  0x07, 0x07, 0x53, 0x5a, 0x82, 0x0a, 0x08, 0xbc, 0x83, 0x25, 0x5f, 0x06,
-  0x54, 0x59, 0xfe, 0xfc, 0xaa, 0xaa, 0x01, 0x04, 0x59, 0x54, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x9d, 0xfe, 0xff, 0x04, 0xa9, 0x05, 0xda, 0x00, 0x0b,
-  0x00, 0x23, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x01, 0x26, 0x35, 0x34, 0x00, 0x33, 0x32, 0x00,
-  0x10, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23,
-  0x35, 0x33, 0x11, 0x26, 0x02, 0xa3, 0x94, 0xcf, 0xcf, 0x94, 0x91, 0xd2,
-  0xd2, 0xfe, 0x02, 0x98, 0x01, 0x2e, 0xd7, 0xd4, 0x01, 0x31, 0x98, 0x7a,
-  0xa2, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xa3, 0x05, 0x27, 0xe4, 0xa4, 0xa3,
-  0xd8, 0xd8, 0xa3, 0xa4, 0xe4, 0xfc, 0xed, 0x9d, 0xee, 0xef, 0x01, 0x4c,
-  0xfe, 0xb4, 0xfe, 0x22, 0x9c, 0x7e, 0x12, 0xfe, 0xf8, 0x7c, 0xfe, 0xff,
-  0x01, 0x01, 0x7c, 0x01, 0x09, 0x11, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d,
-  0xff, 0xe3, 0x04, 0xa9, 0x06, 0xbe, 0x00, 0x0b, 0x00, 0x23, 0x00, 0x00,
-  0x25, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x01, 0x16, 0x15, 0x14, 0x00, 0x23, 0x22, 0x00, 0x10, 0x37, 0x36, 0x37,
-  0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x16,
-  0x02, 0xa3, 0x94, 0xcf, 0xcf, 0x94, 0x91, 0xd2, 0xd2, 0x01, 0xfe, 0x98,
-  0xfe, 0xd2, 0xd7, 0xd4, 0xfe, 0xcf, 0x98, 0x7a, 0xa2, 0xf4, 0xf4, 0xa2,
-  0xf5, 0xf5, 0xa3, 0x96, 0xe4, 0xa4, 0xa3, 0xd8, 0xd8, 0xa3, 0xa4, 0xe4,
-  0x03, 0x13, 0x9d, 0xee, 0xef, 0xfe, 0xb4, 0x01, 0x4c, 0x01, 0xde, 0x9c,
-  0x7e, 0x12, 0x01, 0x08, 0x7c, 0x01, 0x01, 0xfe, 0xff, 0x7c, 0xfe, 0xf7,
-  0x11, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x91, 0xff, 0xe3, 0x05, 0xfb,
-  0x05, 0xc3, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x22, 0x06, 0x10,
-  0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x13, 0x06, 0x23, 0x22, 0x00, 0x10,
-  0x00, 0x17, 0x16, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x07, 0x11, 0x01,
-  0x16, 0x15, 0x14, 0x02, 0x97, 0x93, 0xd0, 0xd0, 0x93, 0x91, 0xd3, 0xd3,
-  0xe2, 0x97, 0xdc, 0xd3, 0xfe, 0xce, 0x01, 0x36, 0xcf, 0xcd, 0x65, 0x01,
-  0x45, 0xfe, 0xb2, 0x7e, 0x01, 0xbd, 0x81, 0xfe, 0xbe, 0x65, 0x03, 0x96,
-  0xe4, 0xfe, 0xb8, 0xd8, 0xd8, 0x01, 0x48, 0xe4, 0xfc, 0xf1, 0xa4, 0x01,
-  0x3d, 0x01, 0xdc, 0x01, 0x55, 0x09, 0x08, 0x67, 0x01, 0x5c, 0x8e, 0xfe,
-  0x14, 0x8f, 0x01, 0x75, 0xfe, 0xa4, 0x92, 0xc1, 0xe8, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x31, 0x00, 0x00, 0x05, 0x42, 0x05, 0xd8, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x35, 0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x06, 0x1d,
-  0x01, 0x23, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x07, 0x33, 0x11,
-  0x33, 0x11, 0x23, 0x11, 0x21, 0x35, 0x02, 0xbf, 0x6e, 0x99, 0x98, 0x6f,
-  0x6d, 0x9a, 0x87, 0xe8, 0xa6, 0xa8, 0xe8, 0x62, 0xcd, 0x88, 0x88, 0xfc,
-  0x77, 0x02, 0x13, 0x01, 0xab, 0xf2, 0xab, 0xab, 0x79, 0x02, 0xb9, 0x01,
-  0x04, 0xfe, 0xfc, 0xb9, 0xa8, 0x7b, 0x03, 0xc5, 0xfa, 0x28, 0x01, 0x7c,
-  0x97, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x93, 0x00, 0x00, 0x04, 0xe0,
-  0x05, 0xd8, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33, 0x35, 0x33,
-  0x15, 0x33, 0x15, 0x23, 0x11, 0x36, 0x33, 0x32, 0x12, 0x15, 0x14, 0x06,
-  0x1d, 0x01, 0x23, 0x34, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x23, 0x01, 0xf3, 0x60, 0x60, 0x88, 0xa1, 0xa1, 0x64, 0x89, 0xa0,
-  0xd7, 0x7e, 0x87, 0x7e, 0x8b, 0x64, 0x63, 0x8b, 0x88, 0x04, 0x8d, 0x97,
-  0xb4, 0xb4, 0x97, 0xfe, 0x7d, 0x6d, 0xfe, 0xfe, 0xbb, 0x5a, 0xe5, 0x79,
-  0x02, 0x84, 0xee, 0x48, 0x7b, 0xa9, 0xaa, 0x7a, 0xfe, 0x46, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xdf, 0x00, 0x00, 0x05, 0x94, 0x05, 0xd8, 0x00, 0x0a,
-  0x00, 0x31, 0x00, 0x00, 0x00, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x27, 0x16, 0x17, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x11, 0x21, 0x11, 0x21, 0x35, 0x33, 0x11, 0x23,
-  0x35, 0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x21, 0x15, 0x23,
-  0x11, 0x33, 0x15, 0x21, 0x11, 0x21, 0x03, 0x6c, 0x65, 0x47, 0x47, 0x32,
-  0x32, 0x47, 0x34, 0x37, 0x2b, 0x44, 0x89, 0x62, 0x60, 0x8a, 0x45, 0x2a,
-  0x38, 0xfe, 0xfd, 0xfe, 0xec, 0x8c, 0x8c, 0x01, 0x14, 0x01, 0x03, 0x88,
-  0x01, 0x03, 0x01, 0x12, 0x89, 0x89, 0xfe, 0xee, 0xfe, 0xfd, 0x01, 0x8c,
-  0x4f, 0x37, 0x39, 0x4e, 0x4e, 0x39, 0x37, 0xc2, 0x12, 0x30, 0x4c, 0xd8,
-  0x99, 0x99, 0xd8, 0x4c, 0x31, 0x11, 0x01, 0x8c, 0xfe, 0x4b, 0x97, 0x02,
-  0xd3, 0x98, 0xfe, 0x4a, 0x01, 0xb6, 0xfe, 0x4a, 0x01, 0xb6, 0x98, 0xfd,
-  0x2d, 0x97, 0x01, 0xb5, 0x00, 0x01, 0x00, 0xea, 0x00, 0x00, 0x05, 0x8a,
-  0x05, 0xd8, 0x00, 0x3c, 0x00, 0x00, 0x25, 0x15, 0x23, 0x35, 0x23, 0x35,
-  0x33, 0x35, 0x26, 0x27, 0x26, 0x27, 0x35, 0x07, 0x27, 0x37, 0x33, 0x17,
-  0x15, 0x27, 0x15, 0x33, 0x15, 0x23, 0x16, 0x17, 0x16, 0x17, 0x11, 0x07,
-  0x27, 0x37, 0x33, 0x17, 0x15, 0x27, 0x11, 0x36, 0x37, 0x36, 0x3d, 0x01,
-  0x33, 0x35, 0x07, 0x27, 0x37, 0x33, 0x17, 0x15, 0x27, 0x15, 0x33, 0x15,
-  0x06, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x03, 0x7f, 0x88, 0x9f, 0x9f,
-  0x95, 0x6e, 0x87, 0x01, 0x81, 0x01, 0x82, 0x89, 0x82, 0x82, 0x02, 0x02,
-  0x01, 0x5e, 0x46, 0x5d, 0x83, 0x01, 0x84, 0x88, 0x82, 0x82, 0x5b, 0x45,
-  0x5f, 0x01, 0x81, 0x01, 0x82, 0x89, 0x82, 0x82, 0x01, 0x01, 0x87, 0x6e,
-  0x94, 0x9d, 0xbb, 0xbb, 0xbb, 0x97, 0x8b, 0x16, 0x7a, 0x96, 0xd7, 0x54,
-  0x8e, 0x8c, 0x99, 0x99, 0x8c, 0x8e, 0x54, 0x02, 0x97, 0x68, 0x4f, 0x14,
-  0x02, 0xca, 0x8d, 0x8b, 0x9a, 0x9a, 0x8b, 0x8d, 0xfd, 0x37, 0x14, 0x4e,
-  0x6a, 0x96, 0x01, 0x59, 0x8e, 0x8c, 0x99, 0x99, 0x8c, 0x8e, 0x59, 0x04,
-  0xd3, 0x96, 0x79, 0x17, 0x8b, 0x97, 0x00, 0x00, 0x00, 0x02, 0x01, 0xba,
-  0x00, 0x00, 0x04, 0xb9, 0x05, 0xd8, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00,
-  0x01, 0x21, 0x20, 0x17, 0x16, 0x15, 0x10, 0x07, 0x06, 0x23, 0x21, 0x11,
-  0x21, 0x17, 0x15, 0x07, 0x21, 0x27, 0x11, 0x17, 0x11, 0x21, 0x32, 0x37,
-  0x36, 0x37, 0x34, 0x27, 0x26, 0x23, 0x01, 0xc2, 0x01, 0x70, 0x01, 0x10,
-  0x5a, 0x1d, 0xe2, 0x35, 0x31, 0xfe, 0xcc, 0x02, 0x3b, 0x07, 0x07, 0xfd,
-  0x4a, 0x07, 0x82, 0x01, 0x26, 0x75, 0x40, 0x0f, 0x07, 0x92, 0x21, 0x49,
-  0x05, 0xd8, 0xd0, 0x4d, 0x5f, 0xfe, 0xf6, 0x5c, 0x11, 0xfd, 0xad, 0x08,
-  0x82, 0x08, 0x08, 0x05, 0xc7, 0x83, 0xfe, 0x24, 0x82, 0x1a, 0x50, 0xa4,
-  0x3c, 0x10, 0x00, 0x00, 0x00, 0x01, 0x00, 0x53, 0x00, 0x00, 0x06, 0x20,
-  0x05, 0xda, 0x00, 0x24, 0x00, 0x00, 0x21, 0x10, 0x00, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x17, 0x23, 0x26, 0x35, 0x34, 0x36, 0x33, 0x20, 0x13, 0x16,
-  0x17, 0x36, 0x37, 0x12, 0x21, 0x32, 0x16, 0x15, 0x14, 0x07, 0x23, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x00, 0x11, 0x03, 0x01, 0xfe, 0xfe, 0x98,
-  0x74, 0x1f, 0x4c, 0x79, 0x53, 0x92, 0x84, 0x01, 0x4f, 0x75, 0x08, 0x04,
-  0x04, 0x07, 0x77, 0x01, 0x4e, 0x84, 0x92, 0x54, 0x78, 0x4c, 0x1f, 0x75,
-  0x97, 0xfe, 0xff, 0x02, 0x58, 0x03, 0x05, 0xc5, 0x22, 0x80, 0x80, 0x84,
-  0xa1, 0x84, 0xbb, 0xfc, 0xfb, 0x31, 0x28, 0x28, 0x31, 0x03, 0x05, 0xbb,
-  0x84, 0xa1, 0x84, 0x80, 0x81, 0x22, 0xc4, 0xfc, 0xfb, 0xfd, 0xa8, 0x00,
-  0x00, 0x02, 0x00, 0xa4, 0x00, 0x00, 0x05, 0xd0, 0x05, 0xd8, 0x00, 0x08,
-  0x00, 0x2e, 0x00, 0x00, 0x01, 0x22, 0x06, 0x10, 0x16, 0x20, 0x36, 0x10,
-  0x26, 0x27, 0x36, 0x37, 0x3e, 0x02, 0x33, 0x15, 0x22, 0x02, 0x07, 0x06,
-  0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x00, 0x23, 0x22, 0x00, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x02, 0x23, 0x35, 0x32, 0x1e, 0x01,
-  0x17, 0x16, 0x03, 0x39, 0x84, 0xb9, 0xb9, 0x01, 0x09, 0xba, 0xb9, 0x86,
-  0x76, 0x45, 0x4d, 0x57, 0x91, 0xa7, 0x6f, 0x96, 0x76, 0x13, 0x15, 0x2a,
-  0x26, 0x84, 0xfe, 0xf6, 0xbe, 0xbb, 0xfe, 0xf6, 0x85, 0x25, 0x2b, 0x16,
-  0x13, 0x74, 0x9a, 0x6d, 0xa6, 0xa8, 0x40, 0x4d, 0x45, 0x03, 0x5c, 0xcf,
-  0xfe, 0xda, 0xce, 0xce, 0x01, 0x26, 0xcf, 0x96, 0x05, 0x3d, 0x42, 0xb4,
-  0xae, 0x6c, 0xfe, 0xc8, 0x6c, 0x13, 0x0f, 0x1e, 0x29, 0x95, 0xd2, 0xd1,
-  0xfe, 0xd9, 0x01, 0x27, 0xd1, 0xd2, 0x95, 0x2a, 0x1e, 0x0e, 0x13, 0x6c,
-  0x01, 0x38, 0x6c, 0xae, 0xb4, 0x42, 0x3d, 0x00, 0x00, 0x02, 0x00, 0xac,
-  0x00, 0x00, 0x05, 0xc6, 0x05, 0xda, 0x00, 0x13, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x26, 0x27, 0x35, 0x04, 0x20, 0x25, 0x15, 0x06, 0x07, 0x11, 0x16,
-  0x17, 0x15, 0x24, 0x20, 0x05, 0x35, 0x36, 0x3f, 0x01, 0x36, 0x33, 0x17,
-  0x11, 0x06, 0x23, 0x27, 0x01, 0xdd, 0x97, 0x99, 0x01, 0x38, 0x02, 0xac,
-  0x01, 0x35, 0x9f, 0x95, 0x95, 0x9f, 0xfe, 0xcb, 0xfd, 0x54, 0xfe, 0xc8,
-  0x99, 0x97, 0x89, 0x68, 0x6a, 0xd1, 0x68, 0x69, 0xd2, 0x04, 0xfc, 0x16,
-  0x34, 0x94, 0x5a, 0x5a, 0x97, 0x2f, 0x18, 0xfb, 0xe2, 0x17, 0x2f, 0x98,
-  0x5b, 0x5b, 0x94, 0x35, 0x15, 0x0c, 0x0d, 0x0d, 0x04, 0x07, 0x0d, 0x0d,
-  0x00, 0x04, 0x00, 0xcf, 0x00, 0x40, 0x05, 0xa5, 0x05, 0x6f, 0x00, 0x08,
-  0x00, 0x1d, 0x00, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x22, 0x06, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x34, 0x01, 0x2c, 0x01, 0x27, 0x35, 0x16, 0x04,
-  0x33, 0x32, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x10, 0x07,
-  0x0e, 0x01, 0x01, 0x32, 0x36, 0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0x01,
-  0x0c, 0x01, 0x17, 0x15, 0x26, 0x24, 0x23, 0x22, 0x17, 0x16, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x3e, 0x01, 0x04, 0xbb, 0xab,
-  0x76, 0x76, 0x56, 0x54, 0x78, 0xfe, 0x88, 0xfe, 0xe7, 0xfe, 0xb9, 0x8a,
-  0xe4, 0x01, 0x47, 0x35, 0x75, 0x07, 0x76, 0xb9, 0x84, 0x86, 0xb9, 0x5d,
-  0x42, 0xdd, 0xfd, 0xe6, 0x55, 0x78, 0x78, 0xa9, 0x79, 0x78, 0x01, 0x01,
-  0x01, 0x19, 0x01, 0x48, 0x89, 0xe3, 0xfe, 0xba, 0x34, 0x78, 0x07, 0x76,
-  0xb8, 0x85, 0x86, 0xb9, 0x5e, 0x41, 0xdd, 0x02, 0xb8, 0x84, 0xbe, 0x85,
-  0x85, 0xbe, 0xfe, 0x0c, 0x02, 0x28, 0x2b, 0x7c, 0x54, 0x16, 0x1a, 0x6c,
-  0xa7, 0x93, 0xcf, 0xcf, 0xfe, 0xda, 0x67, 0x4d, 0x4c, 0x02, 0xb6, 0x84,
-  0xbe, 0x84, 0x84, 0xbe, 0x84, 0x02, 0x78, 0x02, 0x29, 0x2b, 0x7b, 0x54,
-  0x15, 0x1a, 0x6c, 0xa6, 0x94, 0xcf, 0xcf, 0x94, 0x92, 0x67, 0x4d, 0x4d,
-  0x00, 0x02, 0x01, 0x01, 0x00, 0x00, 0x05, 0x73, 0x05, 0xd8, 0x00, 0x13,
-  0x00, 0x4d, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x2e, 0x01,
-  0x23, 0x22, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x1e, 0x01, 0x33, 0x32,
-  0x13, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x00, 0x15, 0x16, 0x17,
-  0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x00, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x32, 0x35, 0x34, 0x26, 0x02, 0x52,
-  0x44, 0x2c, 0x0c, 0x1a, 0x66, 0x23, 0x20, 0x20, 0x43, 0x2c, 0x0c, 0x1b,
-  0x64, 0x23, 0x20, 0x2b, 0xc9, 0xa2, 0x9a, 0xc4, 0xfe, 0xfc, 0x03, 0x79,
-  0x40, 0x5a, 0x3a, 0x72, 0x64, 0x59, 0x82, 0x01, 0x03, 0x94, 0x77, 0x72,
-  0x87, 0x29, 0x17, 0x21, 0x08, 0x1d, 0x2e, 0x68, 0x32, 0x33, 0x36, 0x9b,
-  0x2b, 0x14, 0x19, 0x2e, 0x69, 0x31, 0x32, 0x44, 0x43, 0x07, 0x45, 0x01,
-  0x8c, 0x1d, 0x71, 0x27, 0x23, 0x23, 0x4b, 0x32, 0x0e, 0x1e, 0x6f, 0x27,
-  0x23, 0x24, 0x4c, 0x31, 0x02, 0xf0, 0xa1, 0xc9, 0xdd, 0xb0, 0xbb, 0xfe,
-  0x0a, 0xb4, 0x7c, 0x03, 0x58, 0x48, 0x77, 0x79, 0x6f, 0xc7, 0x01, 0xe1,
-  0xc2, 0x86, 0xa5, 0x9b, 0x81, 0x3c, 0x91, 0x3e, 0x62, 0x80, 0x11, 0x57,
-  0x44, 0x73, 0x2d, 0x16, 0x4b, 0x78, 0x36, 0x38, 0x3c, 0x3c, 0x72, 0x2e,
-  0x15, 0x29, 0x0d, 0x1a, 0xb8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x62,
-  0xfe, 0x8f, 0x06, 0x12, 0x05, 0xd8, 0x00, 0x3a, 0x00, 0x44, 0x00, 0x00,
-  0x01, 0x32, 0x16, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x1d, 0x01, 0x3e,
-  0x01, 0x33, 0x32, 0x16, 0x11, 0x10, 0x01, 0x16, 0x17, 0x23, 0x26, 0x27,
-  0x06, 0x07, 0x35, 0x36, 0x37, 0x27, 0x11, 0x34, 0x35, 0x10, 0x27, 0x0e,
-  0x01, 0x07, 0x11, 0x23, 0x11, 0x10, 0x26, 0x2b, 0x02, 0x22, 0x06, 0x07,
-  0x11, 0x23, 0x11, 0x34, 0x27, 0x33, 0x16, 0x17, 0x3e, 0x01, 0x01, 0x11,
-  0x36, 0x13, 0x34, 0x26, 0x2b, 0x01, 0x22, 0x06, 0x02, 0x64, 0x39, 0x6b,
-  0x24, 0xb2, 0x44, 0x37, 0x4a, 0x2b, 0x76, 0x3d, 0x36, 0x5a, 0xfe, 0xa9,
-  0x01, 0x84, 0x97, 0x2a, 0x42, 0x97, 0x9d, 0xac, 0x6f, 0x08, 0x29, 0x34,
-  0x78, 0x39, 0x88, 0x1c, 0x1f, 0x01, 0x01, 0x25, 0xa1, 0x11, 0x86, 0x89,
-  0x80, 0x6a, 0x20, 0x15, 0xa5, 0x02, 0x7d, 0xe8, 0x16, 0x29, 0x19, 0x03,
-  0x1b, 0x81, 0x05, 0xd8, 0xc6, 0x80, 0x77, 0xcf, 0xa7, 0xdb, 0xca, 0x7d,
-  0x77, 0xe8, 0xfe, 0xef, 0xfe, 0x68, 0xfe, 0xbf, 0x5e, 0xc1, 0x29, 0xa1,
-  0x65, 0x07, 0x74, 0x1c, 0x57, 0xd9, 0x03, 0x57, 0x12, 0x11, 0x01, 0x19,
-  0x01, 0x01, 0xd9, 0xc8, 0xfc, 0x61, 0x03, 0x9a, 0x01, 0x41, 0x6a, 0xe2,
-  0xd7, 0xfc, 0x74, 0x04, 0x41, 0xbe, 0xbf, 0x4f, 0xb0, 0x5d, 0xbc, 0xfc,
-  0x92, 0xfd, 0xd0, 0xfa, 0x01, 0x52, 0xc1, 0x8b, 0xce, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x99, 0x00, 0x6b, 0x05, 0xdb, 0x05, 0x39, 0x00, 0x03,
-  0x00, 0x23, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x01, 0x21, 0x35, 0x21,
-  0x26, 0x35, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x07, 0x21, 0x15,
-  0x21, 0x35, 0x23, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x22, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x17, 0x9a, 0x05, 0x40, 0xfa, 0xc0, 0x01, 0xf5, 0xfe,
-  0x0b, 0x01, 0x3e, 0x3c, 0xe8, 0xa6, 0xa7, 0xe9, 0x3d, 0x01, 0x5d, 0xfd,
-  0xeb, 0x01, 0x10, 0x0f, 0x4e, 0x99, 0xdc, 0x99, 0x4d, 0x0e, 0x11, 0x01,
-  0x03, 0x98, 0x01, 0x8f, 0x98, 0x68, 0x83, 0xb9, 0x01, 0x03, 0xfe, 0xfd,
-  0xb9, 0x83, 0x68, 0x98, 0x98, 0x0d, 0x11, 0x55, 0x79, 0x7a, 0xaa, 0xaa,
-  0x7a, 0x79, 0x55, 0x11, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3e,
-  0xff, 0x3c, 0x06, 0x38, 0x05, 0xd8, 0x00, 0x38, 0x00, 0x00, 0x01, 0x14,
-  0x16, 0x17, 0x33, 0x35, 0x33, 0x17, 0x07, 0x27, 0x35, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x03, 0x34, 0x35, 0x10, 0x27, 0x0e, 0x01, 0x07, 0x11, 0x23,
-  0x11, 0x10, 0x26, 0x2b, 0x02, 0x22, 0x06, 0x07, 0x11, 0x23, 0x11, 0x34,
-  0x27, 0x33, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x3e, 0x01,
-  0x33, 0x32, 0x16, 0x1d, 0x01, 0x13, 0x04, 0x80, 0x5d, 0x50, 0x50, 0x03,
-  0xb7, 0xb7, 0x03, 0x50, 0xb7, 0x3d, 0x28, 0x07, 0x13, 0x29, 0x34, 0x78,
-  0x39, 0x88, 0x1c, 0x1f, 0x01, 0x01, 0x25, 0xa1, 0x11, 0x86, 0x89, 0x80,
-  0x6a, 0x20, 0x15, 0xa5, 0x3e, 0x39, 0x6b, 0x24, 0xb2, 0x44, 0x37, 0x4a,
-  0x01, 0x01, 0x0f, 0x6f, 0x7d, 0x01, 0x76, 0xad, 0xaf, 0x04, 0x76, 0x78,
-  0x4a, 0x76, 0x03, 0x16, 0x12, 0x11, 0x01, 0x19, 0x01, 0x01, 0xd9, 0xc8,
-  0xfc, 0x61, 0x03, 0x9a, 0x01, 0x41, 0x6a, 0xe2, 0xd7, 0xfc, 0x74, 0x04,
-  0x41, 0xbe, 0xbf, 0x4f, 0xb0, 0x5d, 0xbc, 0xc6, 0x80, 0x77, 0xcf, 0xa7,
-  0xdb, 0xca, 0xfd, 0x84, 0x00, 0x01, 0x00, 0x98, 0xff, 0xff, 0x05, 0xdc,
-  0x05, 0xd8, 0x00, 0x14, 0x00, 0x00, 0x01, 0x11, 0x09, 0x01, 0x07, 0x09,
-  0x01, 0x2f, 0x02, 0x09, 0x01, 0x3f, 0x02, 0x09, 0x01, 0x21, 0x35, 0x21,
-  0x11, 0x05, 0x53, 0xfd, 0x85, 0x01, 0x1d, 0x61, 0xfe, 0xe3, 0xfe, 0x82,
-  0x01, 0x5f, 0x01, 0x01, 0x7e, 0xfe, 0xe2, 0x01, 0x60, 0x01, 0x01, 0x1d,
-  0x02, 0x7a, 0xfe, 0x37, 0x02, 0xb3, 0x02, 0xd8, 0x01, 0xfc, 0xfd, 0x3f,
-  0xfe, 0xc3, 0x6c, 0x01, 0x3d, 0xfe, 0x58, 0x01, 0x6a, 0x01, 0x01, 0xa8,
-  0x01, 0x3d, 0x01, 0x6a, 0x01, 0xfe, 0xc3, 0x02, 0xc1, 0x98, 0xfd, 0x00,
-  0x00, 0x02, 0x00, 0xac, 0x00, 0x00, 0x05, 0xc6, 0x05, 0xd8, 0x00, 0x29,
-  0x00, 0x31, 0x00, 0x00, 0x01, 0x32, 0x12, 0x37, 0x36, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x0e, 0x01, 0x07, 0x23, 0x35, 0x37,
-  0x36, 0x13, 0x26, 0x02, 0x23, 0x22, 0x02, 0x15, 0x14, 0x15, 0x07, 0x34,
-  0x02, 0x27, 0x35, 0x32, 0x16, 0x13, 0x36, 0x37, 0x3e, 0x01, 0x01, 0x16,
-  0x33, 0x32, 0x37, 0x26, 0x27, 0x22, 0x02, 0xfe, 0x60, 0x49, 0x17, 0x62,
-  0xaf, 0x6d, 0x8a, 0x81, 0x80, 0x8b, 0x6e, 0x28, 0x71, 0x7c, 0x97, 0x8a,
-  0x6e, 0x5e, 0x2c, 0x3a, 0x34, 0x21, 0x8a, 0x8f, 0x7e, 0x77, 0x84, 0x91,
-  0x24, 0x29, 0x29, 0x25, 0x6e, 0x01, 0x34, 0x54, 0x75, 0x91, 0x08, 0x06,
-  0x8f, 0x89, 0x05, 0xd8, 0xfc, 0x9e, 0x04, 0xdd, 0xbe, 0x67, 0x91, 0xab,
-  0x85, 0xa0, 0xd7, 0x04, 0x76, 0x01, 0x04, 0x01, 0x78, 0x10, 0x03, 0x15,
-  0xfe, 0x2d, 0xc3, 0x0f, 0x0e, 0x02, 0xfd, 0x01, 0xf0, 0x06, 0x61, 0xde,
-  0xfe, 0xed, 0xc9, 0x58, 0x5b, 0x96, 0xfc, 0x26, 0x91, 0xc5, 0x9d, 0x13,
-  0x00, 0x02, 0x00, 0x9e, 0x01, 0x39, 0x05, 0xd6, 0x04, 0xa2, 0x00, 0x27,
-  0x00, 0x51, 0x00, 0x00, 0x13, 0x00, 0x33, 0x32, 0x17, 0x16, 0x32, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x32, 0x37, 0x36, 0x33, 0x32, 0x13, 0x07, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x23, 0x22, 0x06, 0x23, 0x27, 0x11, 0x00, 0x33, 0x32,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x33, 0x32, 0x13, 0x07, 0x26, 0x23, 0x22, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x22, 0x06,
-  0x23, 0x27, 0x9e, 0x01, 0x25, 0x67, 0x29, 0x0c, 0x15, 0x65, 0x9b, 0x32,
-  0x31, 0x15, 0x18, 0x66, 0x4e, 0x26, 0x25, 0x70, 0x62, 0x55, 0x38, 0x56,
-  0x2e, 0x36, 0x4d, 0x65, 0x16, 0x1a, 0x35, 0x31, 0x4b, 0x4e, 0x32, 0x32,
-  0x17, 0x15, 0x31, 0x31, 0xe8, 0x05, 0x30, 0x01, 0x24, 0x68, 0x28, 0x0d,
-  0x15, 0x33, 0x31, 0x4e, 0x4e, 0x63, 0x15, 0x18, 0x32, 0x34, 0x4d, 0x27,
-  0x24, 0x71, 0x62, 0x55, 0x38, 0x56, 0x2e, 0x36, 0x4e, 0x31, 0x33, 0x17,
-  0x19, 0x35, 0x31, 0x4c, 0x4d, 0x33, 0x31, 0x17, 0x15, 0x63, 0xe7, 0x05,
-  0x30, 0x01, 0x9d, 0x01, 0x0f, 0x28, 0x47, 0x8e, 0x47, 0x47, 0x47, 0x24,
-  0xfe, 0xc4, 0x33, 0xb9, 0x35, 0x4c, 0x4b, 0x4e, 0x43, 0x47, 0x48, 0x46,
-  0xd5, 0x62, 0x01, 0xd9, 0x01, 0x0d, 0x27, 0x46, 0x46, 0x48, 0x48, 0x46,
-  0x46, 0x23, 0xfe, 0xc5, 0x32, 0xb9, 0x36, 0x4d, 0x4c, 0x4e, 0x44, 0x47,
-  0x48, 0x48, 0xd5, 0x61, 0x00, 0x01, 0x01, 0x20, 0x00, 0x00, 0x05, 0x53,
-  0x05, 0xd8, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x07, 0x02, 0x03, 0x07, 0x00,
-  0x13, 0x21, 0x35, 0x21, 0x02, 0x01, 0x17, 0x12, 0x13, 0x33, 0x12, 0x13,
-  0x37, 0x00, 0x03, 0x21, 0x07, 0x21, 0x12, 0x01, 0x27, 0x02, 0x03, 0x03,
-  0xa6, 0xd9, 0x1d, 0xfa, 0x94, 0x01, 0x14, 0x18, 0xfe, 0xf6, 0x01, 0x0a,
-  0x19, 0xfe, 0xec, 0x95, 0xfa, 0x1d, 0xda, 0x1c, 0xfb, 0x95, 0xfe, 0xeb,
-  0x18, 0x01, 0x0a, 0x01, 0xfe, 0xf5, 0x1a, 0x01, 0x15, 0x96, 0xfb, 0x1c,
-  0x02, 0x99, 0x03, 0xfe, 0xae, 0xfe, 0xbf, 0x03, 0x01, 0x5f, 0x01, 0x37,
-  0xac, 0x01, 0x36, 0x01, 0x60, 0x03, 0xfe, 0xc0, 0xfe, 0xad, 0x01, 0x53,
-  0x01, 0x40, 0x03, 0xfe, 0xa0, 0xfe, 0xca, 0xac, 0xfe, 0xc9, 0xfe, 0xa1,
-  0x03, 0x01, 0x41, 0x01, 0x52, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0xc0, 0x05, 0xd8, 0x00, 0x0f, 0x00, 0x20, 0x00, 0x24,
-  0x00, 0x54, 0x00, 0x64, 0x00, 0x00, 0x01, 0x36, 0x37, 0x26, 0x27, 0x26,
-  0x22, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x21, 0x33, 0x21,
-  0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06,
-  0x07, 0x16, 0x17, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x26, 0x27, 0x2e,
-  0x01, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x35, 0x34, 0x36, 0x37,
-  0x36, 0x37, 0x35, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23,
-  0x15, 0x16, 0x17, 0x1e, 0x01, 0x1d, 0x01, 0x36, 0x33, 0x32, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x01, 0x14, 0x1e, 0x01, 0x33,
-  0x32, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x02,
-  0xfb, 0x01, 0x02, 0x20, 0x2e, 0x42, 0x8c, 0x85, 0x4b, 0x49, 0x43, 0x14,
-  0x14, 0x01, 0x35, 0x7f, 0x01, 0x34, 0x16, 0x13, 0x43, 0x49, 0x4b, 0x84,
-  0x47, 0x46, 0x42, 0x2f, 0x1f, 0x02, 0x01, 0xfe, 0x6c, 0x02, 0xa9, 0xfd,
-  0x0d, 0x26, 0x22, 0x3e, 0x61, 0x63, 0xb2, 0x5e, 0x48, 0x44, 0x20, 0x1d,
-  0x0c, 0x0e, 0x61, 0x61, 0x5f, 0x61, 0x61, 0x0e, 0x0c, 0x1c, 0x21, 0x45,
-  0x47, 0x5d, 0xb2, 0x64, 0x62, 0x3d, 0x23, 0x25, 0xfe, 0x0d, 0x17, 0x29,
-  0x14, 0x16, 0x28, 0x16, 0x16, 0x28, 0x16, 0x14, 0x29, 0x17, 0x03, 0xc7,
-  0x03, 0x03, 0x2b, 0x1c, 0x29, 0x51, 0x95, 0x50, 0x51, 0x92, 0x28, 0x0e,
-  0x08, 0x08, 0x0e, 0x28, 0x92, 0x51, 0x50, 0x95, 0x51, 0x29, 0x1c, 0x2b,
-  0x03, 0x03, 0xfd, 0xb8, 0xfe, 0xd1, 0x01, 0x2f, 0xfe, 0x81, 0x01, 0x7f,
-  0x0d, 0x16, 0x36, 0xc4, 0x6b, 0x6c, 0xc5, 0x6a, 0x1f, 0x02, 0x24, 0x3f,
-  0x12, 0x07, 0x04, 0x36, 0x46, 0x57, 0x57, 0x46, 0x36, 0x04, 0x07, 0x12,
-  0x3f, 0x24, 0x02, 0x1f, 0x6a, 0xc5, 0x6c, 0x6b, 0xc4, 0x36, 0x16, 0x0d,
-  0xfe, 0x81, 0x04, 0x7d, 0x19, 0x2b, 0x19, 0x19, 0x2b, 0x19, 0x18, 0x2d,
-  0x17, 0x17, 0x2d, 0x00, 0x00, 0x08, 0x00, 0xcb, 0x00, 0x00, 0x05, 0xa9,
-  0x05, 0xd8, 0x00, 0x48, 0x00, 0x4e, 0x00, 0x52, 0x00, 0x68, 0x00, 0x7c,
-  0x00, 0x90, 0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x26, 0x27, 0x34,
-  0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x13, 0x03, 0x22,
-  0x27, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x1b,
-  0x01, 0x26, 0x27, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06,
-  0x07, 0x1b, 0x01, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01,
-  0x15, 0x06, 0x07, 0x03, 0x13, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32,
-  0x1e, 0x01, 0x15, 0x06, 0x23, 0x03, 0x11, 0x21, 0x11, 0x01, 0x35, 0x07,
-  0x21, 0x27, 0x1d, 0x02, 0x21, 0x35, 0x01, 0x17, 0x03, 0x36, 0x37, 0x3e,
-  0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x1e,
-  0x01, 0x33, 0x32, 0x37, 0x01, 0x17, 0x03, 0x36, 0x37, 0x3e, 0x01, 0x34,
-  0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x37,
-  0x01, 0x37, 0x13, 0x16, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23,
-  0x22, 0x0e, 0x01, 0x14, 0x16, 0x17, 0x16, 0x17, 0x01, 0x33, 0x03, 0x32,
-  0x37, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x17, 0x16, 0x17, 0x01, 0x37, 0x13, 0x16, 0x33, 0x32, 0x3e,
-  0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x16,
-  0x17, 0x16, 0x17, 0x01, 0x2c, 0x56, 0x0b, 0x1b, 0x30, 0x1a, 0x19, 0x31,
-  0x19, 0x03, 0x34, 0xd7, 0x2e, 0x4b, 0x10, 0x1a, 0x30, 0x1b, 0x1a, 0x2f,
-  0x1a, 0x01, 0x2a, 0xaa, 0x27, 0x3c, 0x02, 0x1b, 0x30, 0x18, 0x1a, 0x30,
-  0x1b, 0x03, 0x3c, 0x22, 0xa6, 0x29, 0x1a, 0x31, 0x18, 0x1b, 0x31, 0x1a,
-  0x0a, 0x4e, 0x52, 0xe7, 0x27, 0x1a, 0x30, 0x19, 0x1b, 0x30, 0x1a, 0x0c,
-  0x59, 0x90, 0xfc, 0xf9, 0x02, 0xd4, 0xa3, 0xfe, 0xb9, 0xa4, 0x02, 0x8e,
-  0xfd, 0x4c, 0x45, 0xd0, 0x06, 0x07, 0x10, 0x12, 0x12, 0x1f, 0x12, 0x11,
-  0x1f, 0x13, 0x12, 0x20, 0x11, 0x06, 0x08, 0x01, 0x17, 0x7a, 0xa8, 0x05,
-  0x05, 0x0f, 0x11, 0x11, 0x20, 0x10, 0x12, 0x1f, 0x12, 0x11, 0x20, 0x12,
-  0x06, 0x07, 0x01, 0x82, 0x68, 0x56, 0x05, 0x04, 0x11, 0x21, 0x12, 0x13,
-  0x20, 0x11, 0x10, 0x20, 0x12, 0x12, 0x10, 0x07, 0x06, 0xfe, 0xbe, 0x5a,
-  0x2b, 0x11, 0x0e, 0x10, 0x13, 0x14, 0x1f, 0x11, 0x10, 0x22, 0x11, 0x11,
-  0x12, 0x0c, 0x0e, 0x01, 0x0b, 0x5e, 0x95, 0x0a, 0x0a, 0x11, 0x1f, 0x12,
-  0x12, 0x1f, 0x11, 0x12, 0x20, 0x11, 0x11, 0x10, 0x04, 0x03, 0x03, 0xfb,
-  0x02, 0x5f, 0x1c, 0x33, 0x1c, 0x1c, 0x33, 0x1c, 0x40, 0x16, 0xfe, 0x06,
-  0x02, 0xbe, 0x5d, 0x1c, 0x32, 0x1c, 0x1c, 0x32, 0x1c, 0x2d, 0x22, 0xfd,
-  0x14, 0x03, 0x34, 0x1e, 0x30, 0x1c, 0x34, 0x1a, 0x1a, 0x34, 0x1c, 0x36,
-  0x18, 0xfc, 0xca, 0x02, 0xe4, 0x2f, 0x2a, 0x1b, 0x33, 0x1c, 0x1c, 0x33,
-  0x1b, 0x55, 0x10, 0xfd, 0x4a, 0x02, 0x03, 0x22, 0x2b, 0x1c, 0x33, 0x1b,
-  0x1b, 0x33, 0x1c, 0x5e, 0xfe, 0x31, 0xfd, 0xd1, 0x02, 0x2f, 0xfe, 0xdf,
-  0xe1, 0x4b, 0x3d, 0xd3, 0x30, 0xa4, 0xa4, 0x01, 0x54, 0x2a, 0x02, 0x0e,
-  0x03, 0x04, 0x0a, 0x23, 0x13, 0x14, 0x23, 0x14, 0x14, 0x23, 0x14, 0x13,
-  0x23, 0x14, 0x01, 0xfd, 0xf8, 0x20, 0x02, 0xf9, 0x02, 0x03, 0x0a, 0x23,
-  0x26, 0x24, 0x13, 0x13, 0x24, 0x26, 0x23, 0x14, 0x01, 0xfd, 0x13, 0x1b,
-  0x02, 0xd1, 0x01, 0x14, 0x23, 0x26, 0x24, 0x13, 0x13, 0x24, 0x26, 0x23,
-  0x0a, 0x05, 0x02, 0xfd, 0x0a, 0x03, 0x42, 0x0a, 0x0a, 0x23, 0x14, 0x13,
-  0x23, 0x14, 0x14, 0x23, 0x13, 0x14, 0x23, 0x0a, 0x08, 0x02, 0xfc, 0xda,
-  0x2a, 0x01, 0xea, 0x03, 0x15, 0x22, 0x14, 0x13, 0x24, 0x13, 0x13, 0x24,
-  0x13, 0x14, 0x22, 0x0b, 0x02, 0x02, 0x00, 0x00, 0x00, 0x05, 0x01, 0x32,
-  0xff, 0xfe, 0x05, 0x41, 0x05, 0xd6, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x27,
-  0x00, 0x2d, 0x00, 0x32, 0x00, 0x00, 0x01, 0x33, 0x15, 0x33, 0x35, 0x33,
-  0x15, 0x23, 0x15, 0x07, 0x11, 0x17, 0x15, 0x33, 0x15, 0x21, 0x35, 0x33,
-  0x35, 0x37, 0x33, 0x11, 0x23, 0x27, 0x35, 0x23, 0x35, 0x33, 0x15, 0x33,
-  0x01, 0x35, 0x21, 0x15, 0x01, 0x37, 0x35, 0x21, 0x15, 0x17, 0x11, 0x07,
-  0x15, 0x21, 0x35, 0x27, 0x35, 0x11, 0x37, 0x21, 0x11, 0x02, 0xba, 0xfa,
-  0x9a, 0xf3, 0x68, 0x53, 0x53, 0x68, 0xfb, 0xf2, 0x67, 0x54, 0x01, 0x01,
-  0x54, 0x67, 0xee, 0x99, 0x02, 0x55, 0xfc, 0x56, 0x02, 0xf6, 0x4a, 0xfd,
-  0x2b, 0x49, 0x41, 0x02, 0xc5, 0x43, 0x01, 0xfd, 0xbe, 0x05, 0xd6, 0x9b,
-  0x9b, 0xa2, 0x90, 0x96, 0xfd, 0xb7, 0x95, 0x8f, 0xa3, 0xa3, 0x8f, 0x98,
-  0x02, 0x45, 0x97, 0x90, 0xa2, 0x9b, 0xfa, 0xfb, 0x37, 0x37, 0x03, 0xea,
-  0x83, 0x5f, 0x5f, 0x83, 0xfd, 0x76, 0x74, 0x80, 0x80, 0x74, 0x34, 0x02,
-  0x21, 0x02, 0xfd, 0xdd, 0x00, 0x04, 0x01, 0x8a, 0x00, 0x00, 0x04, 0xeb,
-  0x05, 0xd8, 0x00, 0x37, 0x00, 0x43, 0x00, 0x51, 0x00, 0x5e, 0x00, 0x00,
-  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x35,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x3e,
-  0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x15, 0x06, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x13, 0x21, 0x1b, 0x01, 0x35, 0x33, 0x35,
-  0x23, 0x35, 0x23, 0x15, 0x23, 0x15, 0x33, 0x15, 0x13, 0x36, 0x35, 0x34,
-  0x2e, 0x01, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x03, 0x21, 0x00, 0x14,
-  0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x02,
-  0x84, 0x1c, 0x1c, 0x08, 0x0a, 0x36, 0x21, 0x25, 0x01, 0x01, 0x25, 0x27,
-  0x46, 0x19, 0x1b, 0x17, 0x0f, 0x14, 0x28, 0x46, 0x26, 0x25, 0x46, 0x29,
-  0x13, 0x0f, 0x17, 0x19, 0x1a, 0x46, 0x27, 0x26, 0x01, 0x01, 0x26, 0x21,
-  0x34, 0x0a, 0x07, 0x1c, 0x1d, 0x02, 0x02, 0xfe, 0xfc, 0xa0, 0xf4, 0xf1,
-  0x9b, 0x9b, 0x6a, 0x9b, 0x9b, 0x92, 0x36, 0x29, 0x45, 0x4b, 0x46, 0x28,
-  0x38, 0xc7, 0x02, 0x49, 0xfe, 0x76, 0x1a, 0x30, 0x34, 0x31, 0x1a, 0x1b,
-  0x31, 0x19, 0x1a, 0x2f, 0x01, 0x94, 0x35, 0x39, 0x3c, 0x35, 0x11, 0x0e,
-  0x26, 0x3f, 0x48, 0x50, 0x04, 0x50, 0x49, 0x4b, 0x2a, 0x0e, 0x0a, 0x12,
-  0x1d, 0x27, 0x29, 0x2b, 0x4b, 0x2a, 0x2a, 0x4b, 0x2b, 0x29, 0x27, 0x1d,
-  0x13, 0x09, 0x0e, 0x2a, 0x4b, 0x49, 0x50, 0x04, 0x50, 0x48, 0x3e, 0x26,
-  0x0f, 0x11, 0x35, 0x3c, 0x3a, 0x36, 0x03, 0x04, 0xfe, 0x75, 0x01, 0x94,
-  0x01, 0x4e, 0x7c, 0x6c, 0x7c, 0x7c, 0x6c, 0x7c, 0xfe, 0xb2, 0x2d, 0x49,
-  0x2b, 0x4e, 0x29, 0x29, 0x4e, 0x2b, 0x40, 0x36, 0xfe, 0xac, 0x05, 0x19,
-  0x3a, 0x35, 0x1c, 0x1c, 0x35, 0x3a, 0x35, 0x1b, 0x1b, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x01, 0x2f, 0x00, 0x00, 0x05, 0x46, 0x05, 0xd8, 0x00, 0x29,
-  0x00, 0x35, 0x00, 0x3e, 0x00, 0x6f, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34,
-  0x26, 0x35, 0x34, 0x37, 0x16, 0x15, 0x14, 0x07, 0x00, 0x13, 0x21, 0x26,
-  0x35, 0x34, 0x00, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x07, 0x27, 0x07, 0x26,
-  0x27, 0x36, 0x35, 0x34, 0x27, 0x36, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x37,
-  0x16, 0x17, 0x03, 0x36, 0x3b, 0x01, 0x06, 0x15, 0x14, 0x2b, 0x01, 0x22,
-  0x27, 0x35, 0x03, 0x17, 0x14, 0x07, 0x23, 0x22, 0x3d, 0x01, 0x36, 0x13,
-  0x26, 0x27, 0x06, 0x15, 0x14, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16,
-  0x15, 0x14, 0x07, 0x16, 0x17, 0x37, 0x07, 0x36, 0x37, 0x36, 0x37, 0x16,
-  0x15, 0x14, 0x00, 0x15, 0x14, 0x17, 0x25, 0x02, 0x01, 0x32, 0x35, 0x23,
-  0x36, 0x35, 0x34, 0x26, 0x27, 0x06, 0x15, 0x14, 0x16, 0x15, 0x14, 0x07,
-  0x02, 0xce, 0x04, 0x14, 0x3f, 0x6e, 0x07, 0x01, 0xb9, 0x28, 0xfc, 0x97,
-  0x0c, 0x01, 0x63, 0x51, 0x32, 0x2a, 0x8e, 0x08, 0x28, 0x7d, 0x1c, 0x47,
-  0x02, 0x2b, 0x41, 0x13, 0x07, 0x1e, 0x5e, 0x30, 0x91, 0x21, 0x56, 0x06,
-  0x27, 0x3e, 0x13, 0x07, 0x04, 0x05, 0x06, 0x41, 0x09, 0x19, 0x25, 0xc2,
-  0x1f, 0x45, 0x17, 0x1a, 0x0a, 0x35, 0x27, 0x03, 0x42, 0x16, 0x5d, 0x57,
-  0x1f, 0x79, 0x1a, 0x5f, 0x49, 0x0a, 0xfe, 0xa9, 0x0a, 0x03, 0x14, 0x23,
-  0xfe, 0x43, 0x01, 0x04, 0x1c, 0x0b, 0x46, 0x1b, 0x10, 0x08, 0x04, 0xe8,
-  0x08, 0x0b, 0x15, 0x2b, 0x0e, 0x31, 0x5e, 0x68, 0x67, 0x1a, 0x1b, 0xfe,
-  0xbd, 0xfc, 0x6f, 0x38, 0x3a, 0xa0, 0x01, 0x28, 0x40, 0x06, 0x73, 0x03,
-  0x8e, 0x12, 0x16, 0x1e, 0x2e, 0x50, 0xf9, 0xc0, 0x1e, 0x1c, 0x6d, 0x7a,
-  0x20, 0x13, 0x05, 0x1b, 0x6e, 0x1b, 0x78, 0xfe, 0xeb, 0x3f, 0x2e, 0x23,
-  0x31, 0x1e, 0x0f, 0xfe, 0x70, 0x23, 0x34, 0x0f, 0x1e, 0x17, 0x31, 0x02,
-  0xa7, 0x60, 0x26, 0x3e, 0x25, 0x1b, 0x21, 0x12, 0x10, 0x0f, 0x61, 0x63,
-  0x2c, 0x2c, 0xc5, 0xc0, 0x4c, 0x18, 0x48, 0x4a, 0x0a, 0x90, 0x04, 0xad,
-  0x1e, 0x1e, 0x78, 0xfe, 0xec, 0x7d, 0x36, 0x34, 0x01, 0x03, 0x37, 0x01,
-  0x7c, 0x01, 0x0a, 0x2b, 0x0c, 0x4f, 0x4a, 0x4a, 0x29, 0x13, 0x21, 0x13,
-  0x11, 0x0f, 0x00, 0x00, 0x00, 0x04, 0x01, 0x11, 0xff, 0xff, 0x05, 0x62,
-  0x05, 0xd7, 0x00, 0x0d, 0x00, 0x1d, 0x00, 0x50, 0x00, 0x5b, 0x00, 0x00,
-  0x00, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23,
-  0x22, 0x06, 0x13, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x35, 0x34,
-  0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x01, 0x15, 0x21, 0x35, 0x07, 0x26,
-  0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36,
-  0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e,
-  0x01, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x07, 0x27, 0x26, 0x27,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x02, 0x79, 0x34, 0x5b,
-  0x31, 0x34, 0x5b, 0x32, 0x33, 0x5c, 0x32, 0x30, 0x5b, 0x56, 0x0f, 0x19,
-  0x0d, 0x0f, 0x19, 0x0e, 0x0e, 0x1a, 0x0e, 0x0c, 0x1a, 0x0f, 0x02, 0x1f,
-  0xfc, 0x43, 0x4a, 0x0a, 0x94, 0x84, 0x22, 0x24, 0x1b, 0x13, 0x26, 0x4c,
-  0x46, 0x18, 0x1a, 0x17, 0x0e, 0x14, 0x27, 0x46, 0x25, 0x24, 0x47, 0x28,
-  0x13, 0x0f, 0x17, 0x19, 0x1b, 0x43, 0x4e, 0x25, 0x14, 0x1b, 0x22, 0x22,
-  0x84, 0x96, 0x0b, 0x53, 0x03, 0x3a, 0x3e, 0xdd, 0x73, 0x74, 0xdc, 0x3d,
-  0x3a, 0x04, 0x03, 0xc1, 0x70, 0x64, 0x38, 0x38, 0x64, 0x70, 0x67, 0x36,
-  0x36, 0x01, 0x0e, 0x10, 0x1b, 0x0f, 0x0f, 0x1b, 0x10, 0x0f, 0x1c, 0x10,
-  0x10, 0x1c, 0xfa, 0xbb, 0x01, 0x01, 0x01, 0x39, 0x3a, 0xa0, 0x01, 0x25,
-  0x4e, 0x15, 0x0f, 0x1d, 0x26, 0x4b, 0x52, 0x53, 0x97, 0x2a, 0x0e, 0x0a,
-  0x13, 0x1d, 0x27, 0x54, 0x4d, 0x2a, 0x2a, 0x4d, 0x54, 0x27, 0x1d, 0x14,
-  0x09, 0x0e, 0x2a, 0x97, 0x53, 0x52, 0x4b, 0x26, 0x1d, 0x10, 0x14, 0x4e,
-  0xfe, 0xdb, 0xa0, 0x3a, 0x39, 0x84, 0x7d, 0x71, 0x79, 0x83, 0x83, 0x79,
-  0x71, 0x7d, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0x00, 0x00, 0x05, 0xc0,
-  0x05, 0xd8, 0x00, 0x0f, 0x00, 0x20, 0x00, 0x24, 0x00, 0x54, 0x00, 0x64,
-  0x00, 0x68, 0x00, 0x79, 0x00, 0x8a, 0x00, 0x00, 0x01, 0x36, 0x37, 0x26,
-  0x27, 0x26, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x21,
-  0x33, 0x21, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x16, 0x17, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x26,
-  0x27, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x35, 0x34,
-  0x36, 0x37, 0x36, 0x37, 0x35, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33,
-  0x15, 0x23, 0x15, 0x16, 0x17, 0x1e, 0x01, 0x1d, 0x01, 0x36, 0x33, 0x32,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x01, 0x14, 0x1e,
-  0x01, 0x33, 0x32, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e,
-  0x01, 0x01, 0x15, 0x21, 0x35, 0x37, 0x23, 0x26, 0x27, 0x2e, 0x01, 0x35,
-  0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x06, 0x15, 0x33, 0x34,
-  0x27, 0x36, 0x37, 0x36, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07,
-  0x06, 0x07, 0x23, 0x02, 0xfb, 0x01, 0x02, 0x20, 0x2e, 0x42, 0x8c, 0x85,
-  0x4b, 0x49, 0x43, 0x14, 0x14, 0x01, 0x35, 0x7f, 0x01, 0x34, 0x16, 0x13,
-  0x43, 0x49, 0x4b, 0x84, 0x47, 0x46, 0x42, 0x2f, 0x1f, 0x02, 0x01, 0xfe,
-  0x6c, 0x02, 0xa9, 0xfd, 0x0d, 0x26, 0x22, 0x3e, 0x61, 0x63, 0xb2, 0x5e,
-  0x48, 0x44, 0x20, 0x1d, 0x0c, 0x0e, 0x61, 0x61, 0x5f, 0x61, 0x61, 0x0e,
-  0x0c, 0x1c, 0x21, 0x45, 0x47, 0x5d, 0xb2, 0x64, 0x62, 0x3d, 0x23, 0x25,
-  0xfe, 0x0d, 0x17, 0x29, 0x14, 0x16, 0x28, 0x16, 0x16, 0x28, 0x16, 0x14,
-  0x29, 0x17, 0x01, 0x7a, 0xfd, 0xb5, 0xb9, 0xfc, 0x10, 0x0f, 0x37, 0x3c,
-  0x3e, 0x6b, 0x39, 0x38, 0x37, 0x25, 0x1a, 0x02, 0xd9, 0x02, 0x1a, 0x25,
-  0x37, 0x37, 0x3b, 0x6b, 0x3d, 0x3b, 0x37, 0x11, 0x10, 0xfb, 0x03, 0xc7,
-  0x03, 0x03, 0x2b, 0x1c, 0x29, 0x51, 0x95, 0x50, 0x51, 0x92, 0x28, 0x0e,
-  0x08, 0x08, 0x0e, 0x28, 0x92, 0x51, 0x50, 0x95, 0x51, 0x29, 0x1c, 0x2b,
-  0x03, 0x03, 0xfd, 0xb8, 0xfe, 0xd1, 0x01, 0x2f, 0xfe, 0x81, 0x01, 0x7f,
-  0x0d, 0x16, 0x36, 0xc4, 0x6b, 0x6c, 0xc5, 0x6a, 0x1f, 0x02, 0x24, 0x3f,
-  0x12, 0x07, 0x04, 0x36, 0x46, 0x57, 0x57, 0x46, 0x36, 0x04, 0x07, 0x12,
-  0x3f, 0x24, 0x02, 0x1f, 0x6a, 0xc5, 0x6c, 0x6b, 0xc4, 0x36, 0x16, 0x0d,
-  0xfe, 0x81, 0x04, 0x7d, 0x19, 0x2b, 0x19, 0x19, 0x2b, 0x19, 0x18, 0x2d,
-  0x17, 0x17, 0x2d, 0xfc, 0xb6, 0xc8, 0xc8, 0xce, 0x07, 0x0c, 0x21, 0x79,
-  0x43, 0x42, 0x7b, 0x43, 0x21, 0x17, 0x24, 0x03, 0x02, 0x02, 0x03, 0x24,
-  0x17, 0x21, 0x43, 0x7b, 0x42, 0x43, 0x79, 0x21, 0x0c, 0x07, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xcb, 0x00, 0x00, 0x05, 0xa9, 0x05, 0xd8, 0x00, 0x48,
-  0x00, 0x4c, 0x00, 0x50, 0x00, 0x00, 0x01, 0x26, 0x27, 0x34, 0x3e, 0x01,
-  0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x13, 0x03, 0x22, 0x27, 0x34,
-  0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x1b, 0x01, 0x26,
-  0x27, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x1b,
-  0x01, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06,
-  0x07, 0x03, 0x13, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01,
-  0x15, 0x06, 0x23, 0x03, 0x11, 0x21, 0x11, 0x05, 0x35, 0x21, 0x15, 0x01,
-  0x35, 0x21, 0x15, 0x01, 0x2c, 0x56, 0x0b, 0x1b, 0x30, 0x1a, 0x19, 0x31,
-  0x19, 0x03, 0x34, 0xd7, 0x2e, 0x4b, 0x10, 0x1a, 0x30, 0x1b, 0x1a, 0x2f,
-  0x1a, 0x01, 0x2a, 0xaa, 0x27, 0x3c, 0x02, 0x1b, 0x30, 0x18, 0x1a, 0x30,
-  0x1b, 0x03, 0x3c, 0x22, 0xa6, 0x29, 0x1a, 0x31, 0x18, 0x1b, 0x31, 0x1a,
-  0x0a, 0x4e, 0x52, 0xe7, 0x27, 0x1a, 0x30, 0x19, 0x1b, 0x30, 0x1a, 0x0c,
-  0x59, 0x90, 0xfc, 0xf9, 0x02, 0xd4, 0xfd, 0x72, 0x02, 0x8e, 0xfd, 0x72,
-  0x03, 0xfb, 0x02, 0x5f, 0x1c, 0x33, 0x1c, 0x1c, 0x33, 0x1c, 0x40, 0x16,
-  0xfe, 0x06, 0x02, 0xbe, 0x5d, 0x1c, 0x32, 0x1c, 0x1c, 0x32, 0x1c, 0x2d,
-  0x22, 0xfd, 0x14, 0x03, 0x34, 0x1e, 0x30, 0x1c, 0x34, 0x1a, 0x1a, 0x34,
-  0x1c, 0x36, 0x18, 0xfc, 0xca, 0x02, 0xe4, 0x2f, 0x2a, 0x1b, 0x33, 0x1c,
-  0x1c, 0x33, 0x1b, 0x55, 0x10, 0xfd, 0x4a, 0x02, 0x03, 0x22, 0x2b, 0x1c,
-  0x33, 0x1b, 0x1b, 0x33, 0x1c, 0x5e, 0xfe, 0x31, 0xfd, 0xd1, 0x02, 0x2f,
-  0xcb, 0x4e, 0x4e, 0xfe, 0xd6, 0x4f, 0x4f, 0x00, 0x00, 0x04, 0x01, 0x32,
-  0xff, 0xfe, 0x05, 0x41, 0x05, 0xd6, 0x00, 0x03, 0x00, 0x07, 0x00, 0x25,
-  0x00, 0x29, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
-  0x13, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x23, 0x15, 0x07, 0x11, 0x17,
-  0x15, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35, 0x37, 0x33, 0x11, 0x23, 0x27,
-  0x35, 0x23, 0x35, 0x33, 0x15, 0x33, 0x01, 0x35, 0x21, 0x15, 0x04, 0x5a,
-  0xfd, 0xc0, 0x02, 0x83, 0xfd, 0x3b, 0xe2, 0xfa, 0x9a, 0xf3, 0x68, 0x53,
-  0x53, 0x68, 0xfb, 0xf2, 0x67, 0x54, 0x01, 0x01, 0x54, 0x67, 0xee, 0x99,
-  0x02, 0x55, 0xfc, 0x56, 0x04, 0x84, 0x5e, 0x5e, 0xfc, 0x2f, 0x6f, 0x6f,
-  0x05, 0x23, 0x9b, 0x9b, 0xa2, 0x90, 0x96, 0xfd, 0xb7, 0x95, 0x8f, 0xa3,
-  0xa3, 0x8f, 0x98, 0x02, 0x45, 0x97, 0x90, 0xa2, 0x9b, 0xfa, 0xfb, 0x37,
-  0x37, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x8a, 0x00, 0x00, 0x04, 0xeb,
-  0x05, 0xd8, 0x00, 0x34, 0x00, 0x40, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x26, 0x27, 0x26, 0x27, 0x35, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x15, 0x06,
-  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x13, 0x21, 0x13,
-  0x26, 0x01, 0x35, 0x33, 0x35, 0x23, 0x35, 0x23, 0x15, 0x23, 0x15, 0x33,
-  0x15, 0x02, 0x68, 0x1c, 0x08, 0x0a, 0x36, 0x21, 0x25, 0x01, 0x01, 0x25,
-  0x27, 0x46, 0x19, 0x1b, 0x17, 0x0f, 0x14, 0x28, 0x46, 0x26, 0x25, 0x46,
-  0x29, 0x13, 0x0f, 0x17, 0x19, 0x1a, 0x46, 0x27, 0x26, 0x01, 0x01, 0x26,
-  0x21, 0x34, 0x0a, 0x07, 0x1c, 0x1d, 0xfa, 0xfc, 0xa0, 0xf4, 0x16, 0x01,
-  0x07, 0x9b, 0x9b, 0x6a, 0x9b, 0x9b, 0x02, 0x02, 0x3c, 0x35, 0x11, 0x0e,
-  0x26, 0x3f, 0x48, 0x50, 0x04, 0x50, 0x49, 0x4b, 0x2a, 0x0e, 0x0a, 0x12,
-  0x1d, 0x27, 0x29, 0x2b, 0x4b, 0x2a, 0x2a, 0x4b, 0x2b, 0x29, 0x27, 0x1d,
-  0x13, 0x09, 0x0e, 0x2a, 0x4b, 0x49, 0x50, 0x04, 0x50, 0x48, 0x3e, 0x26,
-  0x0f, 0x11, 0x35, 0x3c, 0x3a, 0x36, 0xfe, 0x6e, 0x01, 0x94, 0x35, 0x01,
-  0x19, 0x7c, 0x6c, 0x7c, 0x7c, 0x6c, 0x7c, 0x00, 0x00, 0x04, 0x01, 0x2a,
-  0x00, 0x00, 0x05, 0x4a, 0x05, 0xd8, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x48,
-  0x00, 0x4e, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x26, 0x35, 0x34, 0x37,
-  0x1e, 0x01, 0x15, 0x14, 0x07, 0x33, 0x14, 0x23, 0x00, 0x13, 0x21, 0x26,
-  0x35, 0x34, 0x00, 0x35, 0x34, 0x27, 0x06, 0x2b, 0x01, 0x06, 0x23, 0x22,
-  0x23, 0x37, 0x07, 0x26, 0x27, 0x36, 0x35, 0x34, 0x27, 0x36, 0x37, 0x36,
-  0x35, 0x34, 0x26, 0x35, 0x34, 0x37, 0x16, 0x17, 0x07, 0x15, 0x16, 0x3b,
-  0x01, 0x32, 0x35, 0x34, 0x37, 0x23, 0x22, 0x07, 0x03, 0x15, 0x14, 0x3b,
-  0x01, 0x36, 0x35, 0x27, 0x22, 0x01, 0x17, 0x00, 0x13, 0x33, 0x02, 0x02,
-  0xc7, 0x21, 0x1b, 0x35, 0x4c, 0x0e, 0x1f, 0x03, 0x01, 0x01, 0xe2, 0x29,
-  0xfc, 0x97, 0x0c, 0x01, 0x6c, 0x01, 0x3b, 0x69, 0x09, 0x51, 0x5d, 0x03,
-  0x03, 0x2b, 0x60, 0x67, 0x18, 0x4f, 0x02, 0x2b, 0x59, 0x03, 0x28, 0x12,
-  0x5d, 0x33, 0x99, 0x03, 0x07, 0x13, 0x3f, 0x26, 0x05, 0x57, 0x21, 0x67,
-  0x19, 0x09, 0x41, 0x07, 0x38, 0x01, 0x9c, 0x2f, 0x01, 0x51, 0x06, 0x45,
-  0x29, 0x04, 0xe6, 0x17, 0x27, 0x19, 0x39, 0x16, 0x2e, 0x1e, 0x51, 0x59,
-  0x0d, 0x2f, 0x0c, 0x01, 0xfe, 0xac, 0xfc, 0x6f, 0x38, 0x3a, 0xa0, 0x01,
-  0x1b, 0x71, 0x08, 0x07, 0xa7, 0x92, 0x68, 0x50, 0x1c, 0x53, 0xe5, 0xbe,
-  0x1b, 0x1a, 0x6d, 0x68, 0x0a, 0x09, 0x1c, 0x1a, 0x23, 0x25, 0x42, 0x1b,
-  0x7a, 0xff, 0x10, 0x1e, 0x31, 0x22, 0x30, 0x40, 0xfe, 0x29, 0x18, 0x1d,
-  0x0f, 0x35, 0x22, 0x02, 0x40, 0x59, 0xfe, 0xf3, 0xfd, 0x04, 0x03, 0x52,
-  0x00, 0x01, 0x01, 0x11, 0xff, 0xff, 0x05, 0x62, 0x05, 0xd7, 0x00, 0x2e,
-  0x00, 0x00, 0x05, 0x26, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x3e,
-  0x01, 0x33, 0x32, 0x1e, 0x01, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x1e,
-  0x01, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
-  0x07, 0x01, 0x1c, 0x0a, 0x94, 0x84, 0x22, 0x24, 0x1b, 0x13, 0x26, 0x4c,
-  0x46, 0x18, 0x1a, 0x17, 0x0e, 0x14, 0x27, 0x46, 0x25, 0x24, 0x47, 0x28,
-  0x13, 0x0f, 0x17, 0x19, 0x1b, 0x43, 0x4e, 0x25, 0x14, 0x1b, 0x22, 0x22,
-  0x84, 0x96, 0x0b, 0x01, 0x39, 0x3a, 0xa0, 0x01, 0x25, 0x4e, 0x15, 0x0f,
-  0x1d, 0x26, 0x4b, 0x52, 0x53, 0x97, 0x2a, 0x0e, 0x0a, 0x13, 0x1d, 0x27,
-  0x54, 0x4d, 0x2a, 0x2a, 0x4d, 0x54, 0x27, 0x1d, 0x14, 0x09, 0x0e, 0x2a,
-  0x97, 0x53, 0x52, 0x4b, 0x26, 0x1d, 0x10, 0x14, 0x4e, 0xfe, 0xdb, 0xa0,
-  0x3a, 0x39, 0x00, 0x00, 0x00, 0x01, 0x01, 0x22, 0x00, 0x00, 0x05, 0x51,
-  0x05, 0xd4, 0x00, 0x23, 0x00, 0x00, 0x01, 0x16, 0x13, 0x12, 0x17, 0x16,
-  0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x23, 0x15, 0x10, 0x17,
-  0x23, 0x35, 0x36, 0x11, 0x27, 0x23, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01,
-  0x35, 0x34, 0x37, 0x00, 0x3f, 0x01, 0x03, 0x3c, 0x55, 0xc2, 0xd5, 0x06,
-  0x23, 0x92, 0x30, 0x39, 0x8b, 0x55, 0x26, 0x4a, 0xc1, 0x4d, 0x03, 0x22,
-  0x2b, 0x4c, 0x72, 0xa9, 0x44, 0x08, 0xa8, 0x01, 0x1b, 0x51, 0x02, 0x05,
-  0xd4, 0xa7, 0xfe, 0xec, 0xfe, 0xea, 0x39, 0x55, 0x50, 0x28, 0xa7, 0x60,
-  0x16, 0xdd, 0x0c, 0xfe, 0xe5, 0x96, 0x06, 0x97, 0x01, 0x1d, 0x03, 0x58,
-  0x85, 0xd1, 0x49, 0x2e, 0xb7, 0xcb, 0x01, 0x82, 0xa5, 0x03, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa6, 0x00, 0x01, 0x05, 0xce, 0x05, 0xd1, 0x00, 0x18,
-  0x00, 0x32, 0x00, 0x00, 0x01, 0x32, 0x13, 0x16, 0x15, 0x32, 0x37, 0x12,
-  0x33, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x10, 0x07, 0x00, 0x07, 0x23, 0x01,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x03, 0x15, 0x14, 0x17, 0x01, 0x33, 0x01,
-  0x36, 0x3d, 0x01, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x06, 0x15, 0x23,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x01, 0xf3, 0xc4, 0x68, 0x19,
-  0x06, 0x0c, 0x64, 0xd4, 0xbc, 0x6e, 0x22, 0xc7, 0xfe, 0x6a, 0x36, 0x05,
-  0xfd, 0xdc, 0x6c, 0xb4, 0x48, 0xce, 0xbc, 0x01, 0xab, 0x03, 0x02, 0x04,
-  0x5e, 0xaa, 0x40, 0x34, 0xee, 0x4d, 0x09, 0x06, 0x40, 0x5b, 0xaa, 0x9d,
-  0x60, 0x22, 0x05, 0xd1, 0xfe, 0xed, 0x50, 0x18, 0x46, 0x01, 0x35, 0xd3,
-  0x4e, 0x50, 0x0d, 0xfe, 0xfe, 0xe7, 0xfd, 0xd9, 0x42, 0x02, 0xed, 0xb2,
-  0xb6, 0xd2, 0x7c, 0x2d, 0xfe, 0x8f, 0x10, 0xdb, 0xe4, 0xfd, 0xbc, 0x02,
-  0xbb, 0xa1, 0x97, 0x26, 0xac, 0x70, 0x1c, 0xfe, 0x41, 0x26, 0x1a, 0x4e,
-  0xd1, 0xe0, 0xb1, 0x46, 0x00, 0x02, 0x01, 0x35, 0x00, 0x00, 0x05, 0x3d,
-  0x05, 0xd4, 0x00, 0x08, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x15, 0x00,
-  0x07, 0x26, 0x01, 0x26, 0x35, 0x09, 0x04, 0x03, 0x3a, 0x02, 0x03, 0xfe,
-  0x19, 0x1c, 0x0d, 0xfe, 0x48, 0x3f, 0x02, 0x01, 0xfe, 0x35, 0x01, 0xce,
-  0x01, 0xce, 0xfe, 0x88, 0x05, 0xd4, 0xfd, 0x1a, 0x07, 0xfd, 0x3b, 0x22,
-  0x0b, 0x02, 0x80, 0x56, 0x0d, 0x02, 0x96, 0xfd, 0x67, 0xfd, 0x64, 0x02,
-  0x9c, 0x02, 0x1e, 0x00, 0x00, 0x01, 0x00, 0xcd, 0x00, 0x00, 0x05, 0xa7,
-  0x05, 0xd4, 0x00, 0x37, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x14,
-  0x0f, 0x01, 0x33, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x22, 0x03, 0x23, 0x15, 0x10, 0x17, 0x15, 0x23, 0x27, 0x36,
-  0x11, 0x35, 0x23, 0x02, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x3b, 0x01, 0x32, 0x17, 0x33, 0x35, 0x26, 0x27, 0x26, 0x3d, 0x01, 0x34,
-  0x37, 0x36, 0x03, 0x3b, 0xc1, 0x5b, 0x0b, 0x03, 0x6c, 0x36, 0x03, 0x42,
-  0x4c, 0x11, 0xd6, 0x57, 0x14, 0xbc, 0x24, 0x40, 0xda, 0x5a, 0x03, 0x4a,
-  0xbb, 0x06, 0x4d, 0x03, 0x5a, 0xdd, 0xab, 0x5c, 0x17, 0xde, 0x3b, 0x2e,
-  0x08, 0x4d, 0x47, 0x02, 0x4b, 0x1a, 0x36, 0xc1, 0x40, 0x05, 0xd4, 0xe3,
-  0x34, 0x38, 0x75, 0xa0, 0x3c, 0x1c, 0xca, 0x42, 0x3c, 0xcd, 0x68, 0x0c,
-  0x06, 0x01, 0x12, 0x09, 0xfe, 0xa9, 0x6d, 0x06, 0x06, 0x80, 0x01, 0x4d,
-  0x03, 0xfe, 0xeb, 0xc9, 0x44, 0x3a, 0xe9, 0x53, 0x0c, 0x1c, 0x03, 0x47,
-  0x45, 0x6e, 0x51, 0x0e, 0xc9, 0x68, 0x13, 0x00, 0x00, 0x03, 0x01, 0x21,
-  0x00, 0x01, 0x05, 0x53, 0x05, 0xd5, 0x00, 0x22, 0x00, 0x3c, 0x00, 0x42,
-  0x00, 0x00, 0x01, 0x16, 0x01, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x2b,
-  0x01, 0x22, 0x27, 0x23, 0x15, 0x10, 0x17, 0x23, 0x35, 0x36, 0x11, 0x23,
-  0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x35, 0x37, 0x35, 0x34, 0x37,
-  0x00, 0x37, 0x06, 0x01, 0x06, 0x15, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x32,
-  0x37, 0x33, 0x32, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x37, 0x36, 0x3d, 0x01,
-  0x34, 0x27, 0x02, 0x03, 0x33, 0x26, 0x27, 0x22, 0x07, 0x03, 0x3b, 0x71,
-  0x01, 0x59, 0x4e, 0xa3, 0x1f, 0x2b, 0x14, 0x82, 0x59, 0x25, 0x4a, 0xc1,
-  0x4d, 0x26, 0x32, 0x4c, 0x5f, 0x14, 0x90, 0x49, 0x16, 0x02, 0xba, 0x01,
-  0x05, 0x55, 0x6f, 0xfe, 0xd0, 0x49, 0x09, 0x85, 0x14, 0x25, 0x0e, 0x6b,
-  0x56, 0xa5, 0x07, 0x1b, 0x4b, 0x5d, 0x11, 0x7b, 0x3b, 0x09, 0xb7, 0xcf,
-  0x80, 0x39, 0x0c, 0x0d, 0x06, 0x0e, 0x05, 0xd5, 0xe1, 0xfe, 0x36, 0x8b,
-  0x86, 0x03, 0xd1, 0x4e, 0x10, 0xda, 0x0d, 0xfe, 0xe8, 0x9b, 0x06, 0x97,
-  0x01, 0x23, 0x65, 0x75, 0xae, 0x42, 0x3f, 0x0d, 0x03, 0xc8, 0xd4, 0x01,
-  0x67, 0x49, 0xc7, 0xfe, 0x6f, 0x82, 0x85, 0xbb, 0x35, 0x09, 0xda, 0x46,
-  0x94, 0xa7, 0x28, 0x1e, 0x1f, 0xb0, 0xcf, 0x01, 0x1f, 0xfb, 0x70, 0x17,
-  0x5a, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa3, 0x00, 0x00, 0x05, 0xd2,
-  0x05, 0xd4, 0x00, 0x17, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x33,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x01, 0x23,
-  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01, 0xf1, 0xb7, 0x68, 0x26, 0x02,
-  0x02, 0x20, 0x52, 0x62, 0x79, 0xbc, 0x72, 0x1d, 0xbc, 0xfe, 0x24, 0x05,
-  0xfe, 0x06, 0x97, 0xb3, 0x4b, 0x05, 0xd4, 0xeb, 0x5d, 0x31, 0xa2, 0x6b,
-  0x6c, 0xe0, 0x53, 0x49, 0xfa, 0xe3, 0xfd, 0x85, 0x02, 0xb1, 0xcd, 0xda,
-  0xd3, 0x7c, 0x2d, 0x00, 0x00, 0x01, 0x01, 0x35, 0x00, 0x00, 0x05, 0x3d,
-  0x05, 0xd4, 0x00, 0x08, 0x00, 0x00, 0x09, 0x01, 0x16, 0x15, 0x01, 0x26,
-  0x01, 0x34, 0x37, 0x03, 0x3a, 0x01, 0xc5, 0x3e, 0xfd, 0xfd, 0x0b, 0xfe,
-  0x07, 0x64, 0x05, 0xd4, 0xfd, 0x73, 0x55, 0x0d, 0xfd, 0x1b, 0x08, 0x02,
-  0xdd, 0x0e, 0x8a, 0x00, 0x00, 0x03, 0x00, 0xcd, 0x00, 0x00, 0x05, 0xa8,
-  0x05, 0xdc, 0x00, 0x32, 0x00, 0x60, 0x00, 0x67, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x16, 0x15, 0x14, 0x0f, 0x01, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x22, 0x03, 0x23, 0x15, 0x10, 0x17, 0x15,
-  0x23, 0x27, 0x36, 0x11, 0x35, 0x23, 0x02, 0x23, 0x22, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x26, 0x27, 0x35, 0x34, 0x37,
-  0x36, 0x03, 0x14, 0x1f, 0x01, 0x15, 0x26, 0x2b, 0x01, 0x22, 0x0f, 0x01,
-  0x14, 0x17, 0x16, 0x33, 0x32, 0x13, 0x36, 0x37, 0x33, 0x16, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x34, 0x2f, 0x01, 0x23, 0x22, 0x07,
-  0x35, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x13,
-  0x14, 0x07, 0x33, 0x35, 0x26, 0x35, 0x03, 0x3f, 0xb6, 0x5e, 0x17, 0x67,
-  0x14, 0x1c, 0x37, 0x25, 0xdf, 0x53, 0x0e, 0xbd, 0x1e, 0x42, 0xd9, 0x5c,
-  0x03, 0x4a, 0xbc, 0x05, 0x4c, 0x02, 0x5a, 0xde, 0xad, 0x5c, 0x17, 0xdf,
-  0x3c, 0x2e, 0x22, 0x37, 0x1c, 0x59, 0x1a, 0xc3, 0x40, 0xd8, 0x98, 0x0b,
-  0x61, 0x6a, 0x08, 0xdb, 0x37, 0x06, 0x7b, 0x36, 0x47, 0xbd, 0x66, 0x0f,
-  0x13, 0x07, 0x21, 0x4b, 0x51, 0x8e, 0x97, 0x4d, 0x0a, 0xe3, 0x31, 0x05,
-  0x6b, 0x60, 0x74, 0x1d, 0x17, 0xa8, 0x30, 0x25, 0xa6, 0x4b, 0xed, 0x19,
-  0x36, 0x19, 0x05, 0xdc, 0xce, 0x46, 0x39, 0x84, 0xa6, 0x17, 0x06, 0xd7,
-  0x38, 0x3a, 0xd3, 0x64, 0x0c, 0x07, 0x01, 0x14, 0x09, 0xfe, 0xa7, 0x6d,
-  0x06, 0x06, 0x80, 0x01, 0x4f, 0x04, 0xfe, 0xe8, 0xcb, 0x45, 0x3a, 0xeb,
-  0x52, 0x0c, 0x06, 0x70, 0xb1, 0x26, 0xcb, 0x69, 0x13, 0xfe, 0xb3, 0x9b,
-  0xcc, 0x0c, 0x03, 0x09, 0xd4, 0x43, 0x94, 0x5d, 0x26, 0x01, 0x27, 0x1b,
-  0x41, 0x78, 0x86, 0x85, 0xbe, 0x2e, 0x2b, 0x06, 0xde, 0x30, 0x03, 0x09,
-  0x03, 0x89, 0x6e, 0x4d, 0x2c, 0xb6, 0x57, 0x10, 0xc8, 0xfb, 0xce, 0x1c,
-  0x60, 0x03, 0x63, 0x16, 0x00, 0x04, 0x00, 0xc2, 0xff, 0xfe, 0x05, 0xb2,
-  0x05, 0xd4, 0x00, 0x10, 0x00, 0x21, 0x00, 0x31, 0x00, 0x4d, 0x00, 0x00,
-  0x01, 0x33, 0x14, 0x06, 0x07, 0x14, 0x16, 0x17, 0x23, 0x26, 0x27, 0x26,
-  0x27, 0x30, 0x35, 0x34, 0x36, 0x25, 0x33, 0x14, 0x06, 0x07, 0x14, 0x16,
-  0x13, 0x23, 0x26, 0x27, 0x26, 0x27, 0x34, 0x35, 0x34, 0x36, 0x05, 0x33,
-  0x14, 0x06, 0x07, 0x14, 0x16, 0x17, 0x23, 0x26, 0x27, 0x26, 0x27, 0x35,
-  0x34, 0x36, 0x13, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x04, 0x20, 0x24, 0x26,
-  0x35, 0x34, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x14, 0x16, 0x04, 0x20,
-  0x24, 0x36, 0x34, 0x27, 0x26, 0x27, 0x02, 0x37, 0x0c, 0x83, 0x02, 0xb8,
-  0x06, 0x0b, 0x1b, 0x92, 0x2b, 0x0e, 0x95, 0x01, 0x20, 0x0c, 0x83, 0x02,
-  0xb9, 0x05, 0x0c, 0x1a, 0x92, 0x2c, 0x0d, 0x95, 0x01, 0x37, 0x0b, 0x83,
-  0x02, 0xb9, 0x05, 0x0c, 0x19, 0x93, 0x2c, 0x0d, 0x95, 0x28, 0x97, 0xab,
-  0xa6, 0xfe, 0xd2, 0xfe, 0xb8, 0xfe, 0xd3, 0xa7, 0xaa, 0x98, 0x02, 0x76,
-  0x43, 0x4d, 0x96, 0x01, 0x10, 0x01, 0x29, 0x01, 0x10, 0x96, 0x4e, 0x44,
-  0x76, 0x05, 0x39, 0x3f, 0x9b, 0x63, 0x82, 0x79, 0xc9, 0xa6, 0x74, 0x33,
-  0x5a, 0x0e, 0x72, 0x88, 0xed, 0x60, 0xed, 0x97, 0xc5, 0xbb, 0xfe, 0xce,
-  0xfb, 0xb2, 0x4e, 0x8b, 0x08, 0x09, 0xb1, 0xd1, 0x5b, 0x4f, 0xc4, 0x7d,
-  0xa1, 0x9a, 0xfd, 0xd0, 0x91, 0x42, 0x72, 0x0e, 0x91, 0xad, 0xfe, 0x1e,
-  0x31, 0xb1, 0x61, 0x60, 0xb0, 0x62, 0x62, 0xb0, 0x60, 0x61, 0xb1, 0x31,
-  0x29, 0x45, 0x4d, 0xa8, 0x98, 0x55, 0x55, 0x98, 0xa8, 0x4d, 0x45, 0x29,
-  0x00, 0x01, 0x00, 0x9a, 0xff, 0xf6, 0x02, 0x72, 0x05, 0xd5, 0x00, 0x11,
-  0x00, 0x00, 0x01, 0x33, 0x17, 0x11, 0x14, 0x0f, 0x01, 0x23, 0x22, 0x2f,
-  0x01, 0x34, 0x3f, 0x01, 0x32, 0x17, 0x33, 0x11, 0x02, 0x2a, 0x41, 0x07,
-  0xb1, 0x2b, 0x20, 0xbe, 0x1a, 0x03, 0xbe, 0x1d, 0x5a, 0x50, 0x04, 0x05,
-  0xd5, 0x08, 0xfa, 0xfd, 0xa3, 0x2d, 0x04, 0x85, 0x1f, 0x82, 0x18, 0x05,
-  0x40, 0x04, 0xd4, 0x00, 0x00, 0x01, 0x00, 0x9a, 0xff, 0xf6, 0x03, 0xfe,
-  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x33, 0x17, 0x15, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x23, 0x27, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
-  0x11, 0x14, 0x07, 0x23, 0x22, 0x35, 0x34, 0x37, 0x33, 0x32, 0x17, 0x11,
-  0x02, 0x1c, 0x4e, 0x08, 0x18, 0x9c, 0xd8, 0x6e, 0x04, 0x1b, 0x37, 0xcd,
-  0x53, 0x16, 0xca, 0x33, 0xda, 0xbf, 0x14, 0x57, 0x50, 0x05, 0xd5, 0x07,
-  0x27, 0x36, 0x3f, 0x46, 0x8a, 0x92, 0x60, 0x20, 0x31, 0x54, 0x46, 0x47,
-  0x2a, 0x1a, 0xfb, 0xd6, 0x99, 0x2d, 0xa8, 0x83, 0x17, 0x40, 0x04, 0xd6,
-  0x00, 0x01, 0x01, 0x52, 0xff, 0x2f, 0x05, 0x22, 0x05, 0xd5, 0x00, 0x1e,
-  0x00, 0x00, 0x01, 0x05, 0x17, 0x11, 0x14, 0x07, 0x23, 0x22, 0x3d, 0x01,
-  0x34, 0x3f, 0x01, 0x32, 0x17, 0x11, 0x25, 0x11, 0x14, 0x0f, 0x01, 0x23,
-  0x22, 0x3d, 0x01, 0x34, 0x3f, 0x01, 0x32, 0x17, 0x11, 0x02, 0xb0, 0x02,
-  0x6e, 0x03, 0xad, 0x30, 0xc0, 0x9f, 0x23, 0x4e, 0x49, 0xfe, 0x13, 0x88,
-  0x3c, 0x17, 0xc3, 0x99, 0x27, 0x50, 0x48, 0x05, 0xd5, 0xca, 0x04, 0xfa,
-  0xed, 0x9b, 0x2a, 0xa4, 0x04, 0x7e, 0x16, 0x03, 0x3a, 0x04, 0x0b, 0xa9,
-  0xfb, 0xdb, 0x89, 0x38, 0x08, 0x9b, 0x07, 0x7a, 0x22, 0x04, 0x43, 0x04,
-  0xd3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa9, 0xff, 0xf6, 0x05, 0xcb,
-  0x05, 0xd5, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x17, 0x11, 0x14,
-  0x07, 0x22, 0x27, 0x34, 0x37, 0x32, 0x17, 0x33, 0x11, 0x21, 0x11, 0x06,
-  0x07, 0x23, 0x22, 0x35, 0x34, 0x37, 0x32, 0x17, 0x11, 0x17, 0x15, 0x21,
-  0x35, 0x05, 0xc7, 0x03, 0xeb, 0xd1, 0x10, 0xd1, 0x62, 0x47, 0x03, 0xfc,
-  0xfb, 0x07, 0xda, 0x04, 0xe8, 0xd5, 0x5a, 0x4f, 0x4f, 0x03, 0x05, 0x05,
-  0xd5, 0x04, 0xfb, 0x12, 0xd5, 0x15, 0xa4, 0x8a, 0x0e, 0x3b, 0x02, 0x95,
-  0xfd, 0x5a, 0xcf, 0x24, 0xb1, 0x7d, 0x10, 0x40, 0x04, 0xe1, 0xcf, 0x9c,
-  0x9c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa2, 0xff, 0xfa, 0x02, 0xd2,
-  0x05, 0xd9, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00, 0x13, 0x33, 0x17, 0x11,
-  0x33, 0x36, 0x33, 0x16, 0x13, 0x02, 0x05, 0x27, 0x11, 0x13, 0x11, 0x24,
-  0x11, 0x34, 0x35, 0x34, 0x27, 0x22, 0xa8, 0x29, 0x04, 0x03, 0x99, 0x83,
-  0xcc, 0x12, 0x1a, 0xfd, 0xee, 0x03, 0x32, 0x01, 0x79, 0x86, 0x6b, 0x05,
-  0xd9, 0x06, 0xfc, 0x3f, 0xed, 0x03, 0xfe, 0xff, 0xfe, 0x57, 0x58, 0x03,
-  0x05, 0xd6, 0xfb, 0xd4, 0xfe, 0x9d, 0x63, 0x01, 0x31, 0x0d, 0x0c, 0x94,
-  0x08, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9a, 0x00, 0x00, 0x01, 0xf8,
-  0x05, 0xd9, 0x00, 0x0d, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33, 0x17, 0x11,
-  0x25, 0x17, 0x11, 0x07, 0x23, 0x27, 0x11, 0x05, 0x23, 0x11, 0x13, 0x11,
-  0x33, 0x25, 0x11, 0x23, 0x9f, 0x25, 0x06, 0x01, 0x2c, 0x02, 0x04, 0x24,
-  0x04, 0xfe, 0xd1, 0x02, 0x2f, 0x01, 0x01, 0x01, 0x02, 0x05, 0xd9, 0x05,
-  0xfe, 0x2f, 0xa1, 0x02, 0xfb, 0x63, 0x05, 0x05, 0x01, 0xe5, 0xa0, 0x04,
-  0x8a, 0xfd, 0x99, 0xfe, 0x7d, 0x90, 0x01, 0x7f, 0x00, 0x02, 0x00, 0x9b,
-  0x00, 0x00, 0x02, 0xe2, 0x05, 0xd9, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00,
-  0x01, 0x33, 0x17, 0x11, 0x37, 0x17, 0x15, 0x06, 0x07, 0x11, 0x37, 0x15,
-  0x06, 0x07, 0x11, 0x07, 0x23, 0x27, 0x11, 0x05, 0x11, 0x07, 0x23, 0x27,
-  0x11, 0x07, 0x35, 0x34, 0x37, 0x11, 0x23, 0x07, 0x35, 0x37, 0x11, 0x37,
-  0x33, 0x17, 0x11, 0x25, 0x11, 0x01, 0x11, 0x25, 0x11, 0x02, 0x46, 0x2a,
-  0x04, 0x6b, 0x03, 0x03, 0x6b, 0x6e, 0x01, 0x6d, 0x04, 0x2a, 0x04, 0xfe,
-  0xfd, 0x05, 0x26, 0x04, 0x74, 0x74, 0x02, 0x72, 0x74, 0x04, 0x26, 0x05,
-  0x01, 0x03, 0xfe, 0xfd, 0x01, 0x03, 0x05, 0xd9, 0x05, 0xfe, 0xd0, 0x3c,
-  0x02, 0x8d, 0x07, 0x3c, 0xfe, 0x8b, 0x37, 0x87, 0x04, 0x43, 0xfe, 0xd7,
-  0x04, 0x04, 0x01, 0x11, 0x8c, 0xfe, 0xa6, 0x04, 0x04, 0x01, 0x41, 0x3c,
-  0x8e, 0x06, 0x3c, 0x01, 0x7b, 0x38, 0x8b, 0x41, 0x01, 0x1f, 0x04, 0x04,
-  0xfe, 0xfa, 0x86, 0x01, 0x4d, 0xfd, 0x96, 0xfe, 0x87, 0x8b, 0x01, 0x74,
-  0x00, 0x01, 0x00, 0x9a, 0x00, 0x00, 0x04, 0xc8, 0x05, 0xd9, 0x00, 0x48,
-  0x00, 0x00, 0x01, 0x23, 0x30, 0x23, 0x22, 0x07, 0x23, 0x22, 0x27, 0x35,
-  0x36, 0x35, 0x34, 0x27, 0x35, 0x36, 0x37, 0x33, 0x16, 0x3b, 0x01, 0x35,
-  0x34, 0x27, 0x35, 0x36, 0x37, 0x33, 0x16, 0x32, 0x37, 0x33, 0x16, 0x17,
-  0x15, 0x06, 0x1d, 0x01, 0x33, 0x32, 0x37, 0x33, 0x16, 0x17, 0x15, 0x06,
-  0x15, 0x14, 0x17, 0x15, 0x06, 0x2b, 0x01, 0x26, 0x2b, 0x02, 0x11, 0x14,
-  0x17, 0x15, 0x06, 0x07, 0x23, 0x26, 0x22, 0x07, 0x23, 0x26, 0x27, 0x35,
-  0x36, 0x35, 0x02, 0x71, 0x98, 0x03, 0xa1, 0x48, 0x33, 0x15, 0x0a, 0x59,
-  0x59, 0x02, 0x1c, 0x34, 0x4a, 0xa3, 0x97, 0x76, 0x02, 0x1b, 0x34, 0x28,
-  0x7e, 0x29, 0x34, 0x1a, 0x03, 0x76, 0x92, 0xa3, 0x4b, 0x32, 0x1e, 0x02,
-  0x59, 0x59, 0x0a, 0x16, 0x32, 0x48, 0xa1, 0x04, 0x93, 0x76, 0x03, 0x1a,
-  0x34, 0x29, 0x7e, 0x28, 0x34, 0x1b, 0x02, 0x76, 0x03, 0x11, 0x5a, 0x23,
-  0x3b, 0x31, 0x37, 0x46, 0x2d, 0x3a, 0x1d, 0x03, 0x83, 0xaf, 0xb5, 0x53,
-  0x38, 0x21, 0x02, 0x63, 0x63, 0x02, 0x21, 0x38, 0x53, 0xb5, 0xaf, 0x83,
-  0x03, 0x1d, 0x3a, 0x2d, 0x46, 0x37, 0x31, 0x3b, 0x23, 0x5a, 0xfe, 0x52,
-  0xb5, 0x53, 0x39, 0x20, 0x02, 0x63, 0x63, 0x02, 0x20, 0x39, 0x53, 0xb5,
-  0x00, 0x06, 0x00, 0x76, 0x00, 0x00, 0x05, 0x0d, 0x05, 0xd9, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x3b, 0x00, 0x47, 0x00, 0x00,
-  0x01, 0x06, 0x07, 0x16, 0x17, 0x37, 0x35, 0x05, 0x15, 0x17, 0x36, 0x37,
-  0x26, 0x27, 0x01, 0x26, 0x27, 0x06, 0x07, 0x17, 0x33, 0x03, 0x23, 0x07,
-  0x16, 0x17, 0x36, 0x37, 0x03, 0x33, 0x37, 0x16, 0x17, 0x06, 0x07, 0x27,
-  0x23, 0x11, 0x17, 0x06, 0x07, 0x26, 0x27, 0x37, 0x11, 0x23, 0x07, 0x26,
-  0x27, 0x36, 0x37, 0x17, 0x33, 0x35, 0x27, 0x36, 0x37, 0x16, 0x17, 0x0f,
-  0x01, 0x15, 0x23, 0x15, 0x33, 0x11, 0x33, 0x11, 0x33, 0x35, 0x23, 0x35,
-  0x01, 0x1c, 0x14, 0x2c, 0x2b, 0x15, 0x55, 0x02, 0xa2, 0x55, 0x14, 0x2b,
-  0x2b, 0x14, 0xfe, 0xac, 0x28, 0x2a, 0x28, 0x28, 0x3d, 0x28, 0x01, 0x28,
-  0x3c, 0x28, 0x28, 0x29, 0x29, 0x07, 0xcd, 0xbc, 0x09, 0x6d, 0x6d, 0x09,
-  0xbc, 0xcd, 0x72, 0x60, 0x5e, 0x5e, 0x5d, 0x71, 0xcd, 0xbc, 0x09, 0x6e,
-  0x6e, 0x09, 0xbc, 0xcd, 0x71, 0x5d, 0x5f, 0x5d, 0x60, 0x72, 0x63, 0x68,
-  0x68, 0x31, 0x68, 0x68, 0x03, 0xb4, 0x2d, 0x2e, 0x2c, 0x2d, 0x43, 0x2e,
-  0x01, 0x2e, 0x43, 0x2e, 0x2c, 0x2e, 0x2d, 0x01, 0x6e, 0x17, 0x2f, 0x2f,
-  0x17, 0x5f, 0xfc, 0x52, 0x5f, 0x17, 0x2f, 0x2f, 0x17, 0x02, 0xf7, 0x7e,
-  0x69, 0x6a, 0x68, 0x68, 0x7e, 0xfe, 0x4e, 0xd0, 0x0b, 0x79, 0x79, 0x0b,
-  0xd0, 0x01, 0xb2, 0x7e, 0x68, 0x69, 0x69, 0x69, 0x7e, 0xd6, 0xd1, 0x0b,
-  0x7a, 0x7a, 0x0b, 0xd1, 0x73, 0x9f, 0x2e, 0xfe, 0x80, 0x01, 0x80, 0x2e,
-  0x9f, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x9a, 0x00, 0x00, 0x05, 0xdb,
-  0x05, 0xac, 0x00, 0x14, 0x00, 0x23, 0x00, 0x2e, 0x00, 0x36, 0x00, 0x43,
-  0x00, 0x4d, 0x00, 0x68, 0x00, 0x77, 0x00, 0x8c, 0x00, 0x97, 0x00, 0xa6,
-  0x00, 0xaf, 0x00, 0x00, 0x01, 0x21, 0x32, 0x1f, 0x01, 0x37, 0x33, 0x32,
-  0x15, 0x03, 0x21, 0x27, 0x35, 0x36, 0x37, 0x35, 0x02, 0x27, 0x26, 0x3d,
-  0x01, 0x07, 0x33, 0x32, 0x17, 0x16, 0x15, 0x02, 0x07, 0x23, 0x24, 0x27,
-  0x35, 0x12, 0x37, 0x36, 0x17, 0x15, 0x13, 0x07, 0x15, 0x33, 0x37, 0x07,
-  0x26, 0x2f, 0x01, 0x01, 0x17, 0x13, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x01,
-  0x16, 0x13, 0x17, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x26, 0x03, 0x35,
-  0x17, 0x13, 0x33, 0x32, 0x3f, 0x01, 0x34, 0x2f, 0x01, 0x06, 0x25, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x07, 0x23, 0x27, 0x02, 0x0f, 0x01, 0x17, 0x07,
-  0x23, 0x26, 0x03, 0x26, 0x3d, 0x01, 0x34, 0x3f, 0x01, 0x23, 0x27, 0x35,
-  0x37, 0x17, 0x15, 0x17, 0x33, 0x15, 0x14, 0x07, 0x15, 0x16, 0x17, 0x13,
-  0x33, 0x17, 0x35, 0x27, 0x01, 0x33, 0x17, 0x15, 0x21, 0x32, 0x37, 0x33,
-  0x17, 0x15, 0x06, 0x03, 0x06, 0x2b, 0x01, 0x15, 0x07, 0x23, 0x02, 0x3d,
-  0x01, 0x27, 0x17, 0x11, 0x07, 0x21, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37,
-  0x05, 0x07, 0x17, 0x33, 0x35, 0x34, 0x3b, 0x01, 0x32, 0x3f, 0x01, 0x21,
-  0x26, 0x3d, 0x01, 0x05, 0x06, 0x07, 0x15, 0x14, 0x1f, 0x01, 0x33, 0x11,
-  0x02, 0xd7, 0x01, 0x64, 0x34, 0x1a, 0x45, 0x58, 0x08, 0x04, 0x9c, 0xfe,
-  0xc7, 0x04, 0x10, 0x4a, 0xa9, 0x0e, 0x29, 0x66, 0x15, 0x64, 0x32, 0x1b,
-  0x9e, 0x0f, 0x02, 0xfe, 0xf1, 0x04, 0x8e, 0x0f, 0x28, 0xf7, 0xb5, 0x13,
-  0xb5, 0x56, 0x19, 0x66, 0x0e, 0x12, 0xfd, 0x67, 0xd8, 0x90, 0x37, 0x46,
-  0x19, 0x4b, 0x28, 0x03, 0x3f, 0x10, 0x86, 0x04, 0x48, 0x14, 0x21, 0x83,
-  0x0b, 0xa2, 0x31, 0x8c, 0x78, 0x30, 0x21, 0x02, 0x2b, 0x56, 0xcd, 0xfd,
-  0x5e, 0x12, 0x08, 0x69, 0x2e, 0x04, 0x05, 0x5a, 0xa2, 0x0d, 0x03, 0x04,
-  0x06, 0x03, 0x14, 0x9b, 0x12, 0x4c, 0x12, 0x01, 0x5a, 0x04, 0x73, 0x10,
-  0x03, 0x68, 0x01, 0x8c, 0xb4, 0x02, 0x19, 0x56, 0x02, 0x3e, 0x04, 0x05,
-  0x01, 0x4e, 0x25, 0x21, 0x02, 0x04, 0x05, 0xb1, 0x16, 0x1f, 0xaf, 0x05,
-  0x07, 0x9b, 0x4a, 0x08, 0x05, 0xfe, 0xf4, 0x68, 0x2c, 0x05, 0x4f, 0x02,
-  0x1c, 0x55, 0x55, 0x05, 0x07, 0xd0, 0x14, 0x2a, 0x5e, 0xfe, 0x94, 0x07,
-  0xfd, 0xf2, 0x37, 0x05, 0x51, 0x1b, 0xf3, 0x05, 0xac, 0x47, 0x86, 0x38,
-  0x07, 0xfe, 0xd4, 0x05, 0x05, 0x11, 0x2a, 0x05, 0x01, 0x46, 0x14, 0x16,
-  0x04, 0x05, 0x0d, 0x80, 0x31, 0x0a, 0xfe, 0xc6, 0x11, 0xac, 0x08, 0x02,
-  0x01, 0x1a, 0x08, 0x2e, 0x17, 0x02, 0xfe, 0x9d, 0x0f, 0x03, 0xad, 0x0d,
-  0xc5, 0x0d, 0x05, 0xfe, 0xd1, 0x8a, 0x01, 0x17, 0x90, 0x66, 0xfe, 0xf5,
-  0x11, 0xfe, 0xef, 0x29, 0x14, 0x4d, 0x43, 0x12, 0x0b, 0x01, 0x3d, 0x05,
-  0x0f, 0xfe, 0xea, 0x67, 0x1a, 0x39, 0x45, 0xa2, 0x81, 0x6b, 0xd7, 0x4f,
-  0x0d, 0x05, 0x39, 0xfe, 0xcb, 0x21, 0x15, 0x28, 0x05, 0x1b, 0x01, 0x2d,
-  0x1a, 0x1f, 0x07, 0x1c, 0x83, 0x29, 0x3b, 0x05, 0x05, 0x26, 0x05, 0x0d,
-  0x02, 0x08, 0xc6, 0x0a, 0x1a, 0xfe, 0x01, 0x5d, 0x08, 0x03, 0xac, 0xfe,
-  0xd4, 0x05, 0x74, 0x21, 0x05, 0x02, 0x15, 0xfe, 0xb1, 0x1d, 0x79, 0x05,
-  0x01, 0x22, 0x0d, 0x03, 0xb3, 0x07, 0xfe, 0xa5, 0x05, 0x86, 0x26, 0x0d,
-  0x32, 0x7c, 0x0c, 0xac, 0xaa, 0x08, 0x1c, 0x62, 0xb3, 0x01, 0x14, 0x08,
-  0x1d, 0x61, 0x24, 0x0a, 0x55, 0x2b, 0x06, 0x01, 0x15, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x0a,
-  0x00, 0x23, 0x00, 0x38, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x33, 0x11, 0x07,
-  0x35, 0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x05, 0x26, 0x35, 0x34, 0x3f,
-  0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23,
-  0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03,
-  0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27,
-  0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36,
-  0x37, 0x36, 0x02, 0x8c, 0x9a, 0xa7, 0xb6, 0x72, 0x9a, 0xfe, 0x4b, 0xfe,
-  0x28, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f,
-  0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd,
-  0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a,
-  0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59,
-  0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a,
-  0x01, 0xea, 0x01, 0x9a, 0x1a, 0x61, 0x1e, 0xfe, 0x01, 0x5c, 0xb8, 0x4d,
-  0x4f, 0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13,
-  0x23, 0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97,
-  0x95, 0x46, 0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe,
-  0x5d, 0x42, 0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff,
-  0x6b, 0x23, 0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4,
-  0x41, 0x21, 0x1b, 0x00, 0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
-  0x05, 0xd9, 0x00, 0x1c, 0x00, 0x35, 0x00, 0x4a, 0x00, 0x5f, 0x00, 0x00,
-  0x01, 0x21, 0x15, 0x21, 0x35, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x07, 0x0e, 0x01, 0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x27,
-  0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23, 0x15, 0x27,
-  0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03, 0x37, 0x13,
-  0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27, 0x37, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36, 0x37, 0x36,
-  0x03, 0x07, 0x01, 0x32, 0xfe, 0x26, 0x39, 0xb9, 0x16, 0x2c, 0x21, 0x43,
-  0x36, 0x2a, 0x5d, 0x50, 0x44, 0x65, 0x2b, 0x73, 0x8a, 0x22, 0x2b, 0x0d,
-  0x7d, 0xfd, 0x56, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07,
-  0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29,
-  0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d,
-  0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3,
-  0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23,
-  0x32, 0x2a, 0x01, 0xd2, 0x5d, 0x55, 0x31, 0x9e, 0x15, 0x29, 0x38, 0x1a,
-  0x28, 0x33, 0x18, 0x26, 0x6e, 0x19, 0x14, 0x63, 0x51, 0x26, 0x44, 0x2d,
-  0x0d, 0x6d, 0xfe, 0xba, 0x4d, 0x4f, 0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe,
-  0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b,
-  0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b, 0x37, 0x11, 0x13, 0x34,
-  0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41, 0x36, 0x04, 0x9e, 0x01,
-  0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac, 0x28, 0x01, 0x09, 0x6b,
-  0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b, 0x00, 0x04, 0x00, 0x8c,
-  0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x28, 0x00, 0x41, 0x00, 0x56,
-  0x00, 0x6b, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x26, 0x35,
-  0x34, 0x3f, 0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06,
-  0x07, 0x23, 0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x03, 0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37,
-  0x03, 0x27, 0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27,
-  0x13, 0x36, 0x37, 0x36, 0x03, 0xeb, 0x09, 0x56, 0x9c, 0x8d, 0x2e, 0x61,
-  0x3f, 0x41, 0x5b, 0x2f, 0x55, 0x53, 0x4e, 0x47, 0x64, 0x68, 0x41, 0x40,
-  0x43, 0x42, 0x25, 0x56, 0x4e, 0x44, 0x62, 0x2c, 0x74, 0x8b, 0x4b, 0xfc,
-  0xc6, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f,
-  0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd,
-  0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a,
-  0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59,
-  0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a,
-  0x02, 0xbe, 0x02, 0x53, 0x3c, 0x5c, 0x65, 0x0e, 0x12, 0x6c, 0x1e, 0x12,
-  0x32, 0x33, 0x2d, 0x32, 0x5b, 0x27, 0x26, 0x27, 0x29, 0x0e, 0x14, 0x62,
-  0x0f, 0x0d, 0x59, 0x4b, 0x34, 0x4a, 0xfe, 0x18, 0x4d, 0x4f, 0x48, 0x4b,
-  0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c,
-  0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b,
-  0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41,
-  0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac,
-  0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b,
-  0x00, 0x05, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x02,
-  0x00, 0x0d, 0x00, 0x26, 0x00, 0x3b, 0x00, 0x50, 0x00, 0x00, 0x01, 0x03,
-  0x33, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x21, 0x35,
-  0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27,
-  0x26, 0x25, 0x06, 0x07, 0x23, 0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x03, 0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16,
-  0x1f, 0x01, 0x37, 0x03, 0x27, 0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x07, 0x03, 0x27, 0x13, 0x36, 0x37, 0x36, 0x03, 0x57, 0xcf, 0xcf, 0x12,
-  0x9f, 0x6d, 0x6d, 0x8d, 0xfe, 0xa8, 0xfe, 0xb5, 0x28, 0x23, 0x4b, 0x38,
-  0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d,
-  0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd,
-  0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99,
-  0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39,
-  0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a, 0x03, 0x52, 0xfe, 0xff, 0x01,
-  0x8a, 0xfe, 0x76, 0x5f, 0x8e, 0x8e, 0x60, 0xfe, 0x84, 0x4d, 0x4f, 0x48,
-  0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20,
-  0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46,
-  0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42,
-  0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23,
-  0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21,
-  0x1b, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
-  0x05, 0xd9, 0x00, 0x1d, 0x00, 0x36, 0x00, 0x4b, 0x00, 0x60, 0x00, 0x00,
-  0x01, 0x21, 0x15, 0x21, 0x15, 0x06, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x01, 0x26, 0x35, 0x34, 0x3f, 0x01,
-  0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23, 0x15,
-  0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03, 0x37,
-  0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27, 0x37,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36, 0x37,
-  0x36, 0x02, 0x75, 0x01, 0x96, 0xfe, 0xe5, 0x02, 0x2c, 0x15, 0x7d, 0x92,
-  0x96, 0x87, 0x2d, 0x5e, 0x3f, 0x45, 0x54, 0x2f, 0x4a, 0x54, 0x54, 0x4a,
-  0x23, 0x48, 0x3f, 0xfe, 0x3f, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37,
-  0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44,
-  0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16,
-  0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38,
-  0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a,
-  0xd9, 0x23, 0x32, 0x2a, 0x03, 0xd0, 0x5f, 0x70, 0x01, 0x07, 0x74, 0x63,
-  0x64, 0x72, 0x0e, 0x0f, 0x72, 0x1f, 0x12, 0x40, 0x38, 0x39, 0x40, 0x0d,
-  0x19, 0xfe, 0x53, 0x4d, 0x4f, 0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff,
-  0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61,
-  0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b, 0x37, 0x11, 0x13, 0x34, 0x48,
-  0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41, 0x36, 0x04, 0x9e, 0x01, 0x92,
-  0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe,
-  0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b, 0x00, 0x00, 0x05, 0x00, 0x8c,
-  0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x09, 0x00, 0x22, 0x00, 0x3b,
-  0x00, 0x50, 0x00, 0x65, 0x00, 0x00, 0x01, 0x22, 0x06, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07,
-  0x06, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x33, 0x32, 0x16, 0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x27,
-  0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23, 0x15, 0x27,
-  0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03, 0x37, 0x13,
-  0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27, 0x37, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36, 0x37, 0x36,
-  0x03, 0x2c, 0x32, 0x3d, 0x3d, 0x32, 0x34, 0x3b, 0x3b, 0x8a, 0x37, 0x3f,
-  0x1f, 0x4e, 0x53, 0x03, 0x06, 0x54, 0x32, 0x69, 0x7a, 0x7f, 0x69, 0x78,
-  0x7e, 0x98, 0x84, 0x22, 0x45, 0xfc, 0xfb, 0x28, 0x23, 0x4b, 0x38, 0xd4,
-  0x16, 0x37, 0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe,
-  0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3,
-  0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56,
-  0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f,
-  0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a, 0x02, 0xbc, 0x41, 0x76, 0x40, 0x40,
-  0x76, 0x41, 0x01, 0x0e, 0x66, 0x16, 0x0e, 0x60, 0x35, 0x07, 0x28, 0x73,
-  0x61, 0x5f, 0x74, 0xa5, 0x96, 0x8f, 0xae, 0x0c, 0xfc, 0xfd, 0x4d, 0x4f,
-  0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23,
-  0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95,
-  0x46, 0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d,
-  0x42, 0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b,
-  0x23, 0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41,
-  0x21, 0x1b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
-  0x05, 0xd9, 0x00, 0x06, 0x00, 0x1f, 0x00, 0x34, 0x00, 0x49, 0x00, 0x00,
-  0x01, 0x21, 0x15, 0x03, 0x23, 0x13, 0x21, 0x01, 0x26, 0x35, 0x34, 0x3f,
-  0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23,
-  0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03,
-  0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27,
-  0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36,
-  0x37, 0x36, 0x02, 0x5f, 0x01, 0xce, 0xf5, 0x84, 0xe5, 0xfe, 0xc6, 0xfe,
-  0x55, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f,
-  0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd,
-  0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a,
-  0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59,
-  0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a,
-  0x03, 0xba, 0x32, 0xfd, 0xb9, 0x02, 0x1a, 0xfd, 0x7b, 0x4d, 0x4f, 0x48,
-  0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20,
-  0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46,
-  0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42,
-  0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23,
-  0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21,
-  0x1b, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
-  0x05, 0xd9, 0x00, 0x18, 0x00, 0x2d, 0x00, 0x42, 0x00, 0x00, 0x37, 0x26,
-  0x35, 0x34, 0x3f, 0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25,
-  0x06, 0x07, 0x23, 0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x03, 0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01,
-  0x37, 0x03, 0x27, 0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03,
-  0x27, 0x13, 0x36, 0x37, 0x36, 0xb4, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16,
-  0x37, 0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d,
-  0x44, 0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34,
-  0x16, 0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c,
-  0x38, 0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8,
-  0x7a, 0xd9, 0x23, 0x32, 0x2a, 0xd6, 0x4d, 0x4f, 0x48, 0x4b, 0x92, 0x24,
-  0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c, 0x01, 0x9f,
-  0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b, 0x37, 0x11,
-  0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41, 0x36, 0x04,
-  0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac, 0x28, 0x01,
-  0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b, 0x00, 0x00,
-  0x00, 0x06, 0x00, 0x9a, 0x00, 0x00, 0x05, 0xd9, 0x05, 0xa1, 0x00, 0x10,
-  0x00, 0x1a, 0x00, 0x27, 0x00, 0x39, 0x00, 0x48, 0x00, 0x52, 0x00, 0x00,
-  0x01, 0x21, 0x32, 0x1f, 0x01, 0x37, 0x33, 0x15, 0x02, 0x07, 0x21, 0x35,
-  0x36, 0x37, 0x03, 0x26, 0x23, 0x07, 0x32, 0x1f, 0x01, 0x03, 0x26, 0x27,
-  0x12, 0x37, 0x36, 0x01, 0x12, 0x15, 0x17, 0x14, 0x07, 0x06, 0x2b, 0x01,
-  0x26, 0x03, 0x36, 0x37, 0x05, 0x12, 0x17, 0x27, 0x02, 0x0f, 0x01, 0x17,
-  0x23, 0x03, 0x27, 0x36, 0x37, 0x36, 0x35, 0x27, 0x35, 0x33, 0x01, 0x33,
-  0x15, 0x21, 0x32, 0x37, 0x33, 0x14, 0x03, 0x06, 0x2b, 0x01, 0x15, 0x23,
-  0x03, 0x27, 0x17, 0x11, 0x07, 0x21, 0x22, 0x2f, 0x01, 0x34, 0x37, 0x02,
-  0xd9, 0x01, 0x5f, 0x34, 0x1e, 0x42, 0x5a, 0x05, 0x8d, 0x0f, 0xfe, 0xcc,
-  0x57, 0x04, 0xb2, 0x1f, 0x0c, 0x5c, 0x5f, 0x26, 0x2c, 0xae, 0xf0, 0x19,
-  0x86, 0x14, 0x2c, 0x03, 0x05, 0x95, 0x02, 0x58, 0x0d, 0x24, 0x71, 0x0c,
-  0x9e, 0x16, 0xb5, 0xfc, 0xd3, 0x9a, 0x02, 0x65, 0xad, 0x03, 0x03, 0x04,
-  0x04, 0xb5, 0x07, 0x03, 0x48, 0x18, 0x5a, 0xcd, 0x02, 0x8f, 0x02, 0x01,
-  0x63, 0x1d, 0x1b, 0x03, 0xb5, 0x15, 0x1c, 0xb8, 0x04, 0x98, 0x54, 0x04,
-  0x04, 0xfe, 0xfb, 0x69, 0x2a, 0x04, 0x4b, 0x05, 0xa1, 0x54, 0x7d, 0x37,
-  0x02, 0xfe, 0xed, 0x15, 0x05, 0x35, 0x09, 0x01, 0x62, 0x1a, 0x05, 0x5c,
-  0x56, 0xfe, 0xb6, 0x9a, 0x13, 0x01, 0x04, 0x1c, 0x2f, 0xfe, 0x56, 0xfe,
-  0xea, 0x17, 0x27, 0x66, 0x3a, 0x08, 0x0f, 0x01, 0x3a, 0x17, 0x70, 0x1b,
-  0xfe, 0xe0, 0x0d, 0x3f, 0xfe, 0xb6, 0x10, 0x29, 0x1d, 0x01, 0x5c, 0x20,
-  0x1f, 0x80, 0x29, 0x0b, 0x39, 0x03, 0xfe, 0xa5, 0x73, 0x1a, 0x09, 0xfe,
-  0xa4, 0x17, 0x73, 0x01, 0x25, 0xb0, 0x06, 0xfe, 0xa9, 0x05, 0x80, 0x30,
-  0x30, 0x82, 0x00, 0x00, 0x00, 0x07, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd,
-  0x05, 0xd9, 0x00, 0x13, 0x00, 0x25, 0x00, 0x32, 0x00, 0x3c, 0x00, 0x4a,
-  0x00, 0x5c, 0x00, 0x65, 0x00, 0x00, 0x01, 0x33, 0x20, 0x13, 0x16, 0x1d,
-  0x01, 0x10, 0x05, 0x06, 0x2b, 0x01, 0x20, 0x03, 0x26, 0x3d, 0x01, 0x10,
-  0x25, 0x36, 0x17, 0x15, 0x32, 0x1f, 0x01, 0x15, 0x06, 0x07, 0x15, 0x33,
-  0x36, 0x37, 0x23, 0x07, 0x26, 0x27, 0x26, 0x23, 0x01, 0x16, 0x33, 0x36,
-  0x13, 0x26, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x05, 0x15, 0x13,
-  0x33, 0x32, 0x37, 0x34, 0x2f, 0x01, 0x22, 0x05, 0x17, 0x06, 0x07, 0x14,
-  0x1f, 0x01, 0x33, 0x34, 0x3f, 0x01, 0x33, 0x17, 0x27, 0x01, 0x07, 0x16,
-  0x17, 0x33, 0x35, 0x37, 0x33, 0x32, 0x3f, 0x01, 0x35, 0x23, 0x06, 0x23,
-  0x21, 0x27, 0x35, 0x05, 0x06, 0x1d, 0x01, 0x14, 0x1f, 0x01, 0x33, 0x11,
-  0x03, 0x2e, 0x19, 0x01, 0x63, 0xdb, 0x57, 0xfe, 0x97, 0x92, 0xa5, 0x03,
-  0xfe, 0x7b, 0xd0, 0x4b, 0x01, 0x1c, 0xab, 0x7c, 0x22, 0x2e, 0x6d, 0x19,
-  0x34, 0xfc, 0x09, 0x77, 0x03, 0x4a, 0x47, 0x11, 0x13, 0x17, 0xfd, 0xc7,
-  0xda, 0x08, 0x04, 0x86, 0x3c, 0x14, 0x1a, 0x2d, 0x56, 0x30, 0x46, 0x0b,
-  0x02, 0x40, 0x8a, 0x6a, 0x58, 0x18, 0x5b, 0x25, 0x0c, 0xfc, 0x38, 0x48,
-  0x44, 0x09, 0x7d, 0x1a, 0x02, 0x19, 0x80, 0x08, 0x44, 0x7d, 0x01, 0xc6,
-  0x79, 0x05, 0x74, 0x03, 0x06, 0x9a, 0x21, 0x37, 0x5f, 0x03, 0x13, 0x1f,
-  0xfe, 0xe4, 0x06, 0xfe, 0x20, 0x3b, 0x60, 0x17, 0xe3, 0x05, 0xd9, 0xfe,
-  0x92, 0xae, 0xcf, 0x06, 0xfe, 0x4f, 0xeb, 0x4c, 0x01, 0x86, 0xa8, 0xa3,
-  0x35, 0x01, 0x5f, 0xf1, 0x83, 0x93, 0x03, 0x6b, 0xce, 0x03, 0x16, 0x1f,
-  0x03, 0x08, 0xf0, 0x2c, 0x89, 0x16, 0x0c, 0xfe, 0xdf, 0x8b, 0x0f, 0x01,
-  0x01, 0x7e, 0x12, 0x79, 0x7d, 0x1f, 0xde, 0x03, 0xfe, 0xf4, 0x8a, 0x2f,
-  0x9d, 0x4d, 0x3c, 0x34, 0x7b, 0x31, 0x16, 0xe8, 0x3b, 0x43, 0x19, 0xf8,
-  0x2c, 0xf1, 0xfe, 0xe5, 0xfb, 0x03, 0xec, 0x5b, 0x06, 0x80, 0xb1, 0x03,
-  0x10, 0x06, 0x5f, 0x65, 0x69, 0x27, 0x0c, 0x5b, 0x29, 0x04, 0x01, 0x24,
-  0x00, 0x08, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd, 0x05, 0xd9, 0x00, 0x0f,
-  0x00, 0x20, 0x00, 0x2f, 0x00, 0x3a, 0x00, 0x42, 0x00, 0x52, 0x00, 0x60,
-  0x00, 0x6a, 0x00, 0x00, 0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x05, 0x06,
-  0x23, 0x20, 0x03, 0x26, 0x35, 0x10, 0x25, 0x36, 0x01, 0x10, 0x05, 0x16,
-  0x3b, 0x01, 0x20, 0x13, 0x36, 0x35, 0x10, 0x25, 0x26, 0x23, 0x20, 0x03,
-  0x06, 0x01, 0x21, 0x32, 0x1f, 0x01, 0x37, 0x15, 0x06, 0x07, 0x23, 0x35,
-  0x37, 0x26, 0x2f, 0x01, 0x23, 0x32, 0x1f, 0x01, 0x03, 0x23, 0x26, 0x27,
-  0x36, 0x37, 0x36, 0x01, 0x16, 0x1d, 0x01, 0x06, 0x2b, 0x01, 0x03, 0x25,
-  0x33, 0x17, 0x07, 0x23, 0x27, 0x23, 0x02, 0x07, 0x15, 0x26, 0x03, 0x27,
-  0x34, 0x37, 0x27, 0x01, 0x33, 0x15, 0x21, 0x32, 0x37, 0x15, 0x03, 0x07,
-  0x23, 0x07, 0x15, 0x23, 0x27, 0x25, 0x21, 0x17, 0x11, 0x07, 0x23, 0x22,
-  0x2f, 0x01, 0x36, 0x03, 0x3c, 0x01, 0x6e, 0xd6, 0x5c, 0xfe, 0xaa, 0x93,
-  0xbc, 0xfe, 0x87, 0xd0, 0x55, 0x01, 0x61, 0x99, 0xfe, 0x2d, 0x01, 0x3e,
-  0x8e, 0x99, 0x2b, 0x01, 0x44, 0xce, 0x53, 0xfe, 0xba, 0x90, 0xa6, 0xfe,
-  0xa2, 0xc9, 0x52, 0x02, 0x1e, 0x01, 0x1b, 0x30, 0x15, 0x34, 0x49, 0x62,
-  0x18, 0xf5, 0x46, 0x84, 0x17, 0x19, 0x45, 0x52, 0x1b, 0x28, 0x8a, 0x03,
-  0xcc, 0x10, 0x6b, 0x19, 0x28, 0x02, 0x5f, 0x7b, 0x13, 0x61, 0x5a, 0x8c,
-  0xfd, 0x29, 0xf8, 0x83, 0x03, 0x03, 0x46, 0x03, 0x95, 0x05, 0x0b, 0x8d,
-  0x02, 0x4e, 0x46, 0x02, 0xb0, 0x06, 0x01, 0x26, 0x12, 0x16, 0x9c, 0x15,
-  0x98, 0x05, 0x06, 0x79, 0xfe, 0xaf, 0x01, 0x0d, 0x06, 0x06, 0xdc, 0x49,
-  0x23, 0x06, 0x01, 0x05, 0xd9, 0xfe, 0x97, 0xb2, 0xd4, 0xfe, 0x58, 0xe9,
-  0x59, 0x01, 0x74, 0xa2, 0xdb, 0x01, 0xa9, 0xeb, 0x54, 0xfd, 0x12, 0xfe,
-  0x70, 0xd8, 0x58, 0x01, 0x59, 0xa5, 0xc5, 0x01, 0x8c, 0xe0, 0x53, 0xfe,
-  0xa6, 0x9f, 0x01, 0x6d, 0x45, 0x62, 0x2c, 0x03, 0xcc, 0x23, 0x03, 0x34,
-  0xfe, 0x27, 0x0c, 0x46, 0x56, 0xfe, 0xfe, 0x7f, 0x10, 0xd5, 0x1a, 0x20,
-  0xfe, 0xa7, 0xe2, 0x21, 0x17, 0x82, 0x01, 0x09, 0x59, 0xf4, 0x03, 0x31,
-  0xfe, 0xea, 0x15, 0x1a, 0x0b, 0x01, 0x12, 0x11, 0x1c, 0x8d, 0x31, 0xfe,
-  0xec, 0x5f, 0x14, 0x06, 0xfe, 0xdc, 0x09, 0x06, 0x55, 0xee, 0x8c, 0x05,
-  0xfe, 0xeb, 0x05, 0x67, 0x2c, 0x31, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdd, 0x05, 0xd9, 0x00, 0x07, 0x00, 0x17, 0x00, 0x1f,
-  0x00, 0x41, 0x00, 0x52, 0x00, 0x00, 0x01, 0x16, 0x17, 0x32, 0x37, 0x26,
-  0x27, 0x06, 0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x05, 0x06, 0x23, 0x20,
-  0x03, 0x26, 0x35, 0x10, 0x25, 0x36, 0x01, 0x06, 0x07, 0x16, 0x33, 0x36,
-  0x37, 0x26, 0x01, 0x15, 0x23, 0x06, 0x2b, 0x01, 0x2e, 0x01, 0x35, 0x34,
-  0x35, 0x34, 0x35, 0x34, 0x36, 0x37, 0x32, 0x17, 0x36, 0x33, 0x1e, 0x01,
-  0x15, 0x14, 0x15, 0x14, 0x15, 0x14, 0x06, 0x07, 0x23, 0x22, 0x27, 0x23,
-  0x25, 0x10, 0x05, 0x16, 0x3b, 0x01, 0x20, 0x13, 0x36, 0x35, 0x10, 0x25,
-  0x26, 0x23, 0x20, 0x03, 0x06, 0x01, 0x95, 0x02, 0xa5, 0x81, 0x57, 0x4e,
-  0x92, 0x9d, 0x01, 0xa5, 0x01, 0x6e, 0xd6, 0x5c, 0xfe, 0xaa, 0x93, 0xbc,
-  0xfe, 0x87, 0xd0, 0x55, 0x01, 0x61, 0x99, 0x01, 0xb1, 0x92, 0x4e, 0x57,
-  0x81, 0xa5, 0x02, 0x02, 0xfe, 0x5a, 0x03, 0x6a, 0xa0, 0x0d, 0x7e, 0x6d,
-  0x8c, 0x7a, 0x8d, 0x72, 0x73, 0x8e, 0x7a, 0x8c, 0x6d, 0x7e, 0x0d, 0xa0,
-  0x6b, 0x02, 0xfd, 0x83, 0x01, 0x3e, 0x8e, 0x99, 0x2b, 0x01, 0x44, 0xce,
-  0x53, 0xfe, 0xba, 0x90, 0xa6, 0xfe, 0xa2, 0xc9, 0x52, 0x02, 0xf4, 0xcd,
-  0x02, 0xcb, 0xc2, 0x04, 0x03, 0x02, 0x26, 0xfe, 0x97, 0xb2, 0xd4, 0xfe,
-  0x58, 0xe9, 0x59, 0x01, 0x74, 0xa2, 0xdb, 0x01, 0xa9, 0xeb, 0x54, 0xfd,
-  0xdd, 0x04, 0xc2, 0xcb, 0x02, 0xcd, 0xbf, 0xfe, 0xf3, 0x1c, 0xbd, 0x0f,
-  0xb9, 0x50, 0x07, 0x08, 0x04, 0x05, 0x74, 0x99, 0x01, 0xaa, 0xaa, 0x01,
-  0x99, 0x74, 0x05, 0x04, 0x08, 0x07, 0x50, 0xb9, 0x0f, 0xbd, 0x61, 0xfe,
-  0x70, 0xd8, 0x58, 0x01, 0x59, 0xa5, 0xc5, 0x01, 0x8c, 0xe0, 0x53, 0xfe,
-  0xa6, 0x9f, 0x00, 0x00, 0x00, 0x02, 0x01, 0x12, 0x00, 0x02, 0x05, 0x61,
-  0x05, 0xd9, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x32, 0x15, 0x06,
-  0x07, 0x17, 0x33, 0x32, 0x17, 0x07, 0x23, 0x17, 0x21, 0x16, 0x13, 0x37,
-  0x17, 0x06, 0x07, 0x26, 0x03, 0x21, 0x22, 0x03, 0x34, 0x01, 0x06, 0x23,
-  0x22, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x14,
-  0x1e, 0x01, 0x32, 0x36, 0x37, 0x17, 0x06, 0x02, 0x57, 0x8a, 0x01, 0x73,
-  0x16, 0xf7, 0x0b, 0x0e, 0x03, 0xf8, 0x0b, 0x01, 0x91, 0x0a, 0x7f, 0x79,
-  0x2b, 0x05, 0xf6, 0x0e, 0x87, 0xfe, 0x53, 0x0b, 0x4c, 0x01, 0xc5, 0x65,
-  0x6f, 0x70, 0xcb, 0x71, 0x3a, 0x1e, 0x2a, 0x24, 0x16, 0x02, 0x4a, 0x89,
-  0x96, 0x88, 0x25, 0x3e, 0x29, 0x05, 0xd9, 0x8e, 0xa3, 0x02, 0xe6, 0x92,
-  0x04, 0x65, 0x06, 0xfe, 0x72, 0x28, 0x8d, 0x08, 0x59, 0x18, 0x01, 0xad,
-  0x03, 0x24, 0x85, 0xfa, 0x68, 0x3f, 0x7d, 0xe1, 0x7d, 0x7c, 0x72, 0x3c,
-  0x2e, 0xd9, 0x3c, 0x43, 0x53, 0x98, 0x53, 0x53, 0x4c, 0xa9, 0x32, 0x00,
-  0x00, 0x03, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd, 0x05, 0xcd, 0x00, 0x16,
-  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11,
-  0x21, 0x02, 0xa4, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13,
-  0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xe3,
-  0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x02, 0xe9, 0x2a, 0x1c,
-  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15,
-  0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0x42, 0x05, 0xcd, 0xfa, 0x33, 0xa5,
-  0x04, 0x83, 0x00, 0x00, 0x00, 0x04, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd,
-  0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
-  0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x01, 0x8d, 0x11, 0x12, 0x1c, 0x19,
-  0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
-  0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
-  0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
-  0xfc, 0xcc, 0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x01, 0xae,
-  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c,
-  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x02, 0x9c, 0x2a, 0x1c, 0x1e,
-  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
-  0x13, 0x14, 0x1f, 0x1b, 0xfc, 0x0c, 0x05, 0xcd, 0xfa, 0x33, 0xa5, 0x04,
-  0x83, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd,
-  0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c,
-  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x01, 0x8d, 0x11, 0x12, 0x1c,
-  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
-  0x19, 0x1b, 0x13, 0x11, 0x01, 0x17, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
-  0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13,
-  0x11, 0x01, 0x17, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13,
-  0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfc, 0xcc,
-  0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x01, 0xae, 0x2a, 0x1c,
-  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15,
-  0x13, 0x13, 0x14, 0x1f, 0x1b, 0x01, 0x66, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
-  0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14,
-  0x1f, 0x1b, 0x01, 0x61, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f,
-  0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfc,
-  0x0c, 0x05, 0xcd, 0xfa, 0x33, 0xa5, 0x04, 0x83, 0x00, 0x06, 0x00, 0x87,
-  0x00, 0x00, 0x05, 0xbd, 0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x44,
-  0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
-  0x01, 0x8d, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11,
-  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11,
-  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c,
-  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xd2, 0x11, 0x12, 0x1c, 0x19,
-  0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
-  0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
-  0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
-  0xfc, 0xcc, 0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x04, 0x1f,
-  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c,
-  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0xba, 0x2a, 0x1c, 0x1e,
-  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
-  0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14,
-  0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b,
-  0x02, 0x9c, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b,
-  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfc, 0x0c, 0x05,
-  0xcd, 0xfa, 0x33, 0xa5, 0x04, 0x83, 0x00, 0x00, 0x00, 0x07, 0x00, 0x87,
-  0x00, 0x00, 0x05, 0xbd, 0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x44,
-  0x00, 0x5b, 0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11,
-  0x21, 0x01, 0x8d, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
-  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e,
-  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12,
-  0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xd2, 0x11, 0x12, 0x1c,
-  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
-  0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
-  0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13,
-  0x11, 0xfe, 0xe9, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13,
-  0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xe3,
-  0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x04, 0x1f, 0x2a, 0x1c,
-  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15,
-  0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0xba, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
-  0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14,
-  0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b,
-  0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x02, 0x9c,
-  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c,
-  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfe, 0xf5, 0x2a, 0x1c, 0x1e,
-  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
-  0x13, 0x14, 0x1f, 0x1b, 0xfd, 0x42, 0x05, 0xcd, 0xfa, 0x33, 0xa5, 0x04,
-  0x83, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd,
-  0x05, 0xcd, 0x00, 0x17, 0x00, 0x2f, 0x00, 0x46, 0x00, 0x5d, 0x00, 0x74,
-  0x00, 0x8b, 0x00, 0x8f, 0x00, 0x93, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
-  0x03, 0xba, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11,
-  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xd3,
-  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12,
-  0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19,
-  0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
-  0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
-  0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
-  0xfd, 0xd2, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11,
-  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11,
-  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c,
-  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfc, 0xcc, 0x05, 0x36, 0xfb, 0x5f,
-  0x04, 0x0c, 0xfb, 0xf4, 0x02, 0xe9, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13,
-  0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f,
-  0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b,
-  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x01, 0x93, 0x2a,
-  0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e,
-  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0x56, 0x2a, 0x1c, 0x1e, 0x15,
-  0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13,
-  0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f,
-  0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x03,
-  0x00, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a,
-  0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfb, 0xda, 0x05, 0xcd,
-  0xfa, 0x33, 0xa5, 0x04, 0x83, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x99,
-  0x00, 0x01, 0x05, 0xdc, 0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1b, 0x00, 0x29,
-  0x00, 0x00, 0x01, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x02,
-  0x10, 0x12, 0x24, 0x01, 0x14, 0x12, 0x04, 0x20, 0x24, 0x12, 0x35, 0x34,
-  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x04, 0x34, 0x3e, 0x01, 0x33, 0x32,
-  0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x03, 0x3a, 0xa9, 0x01,
-  0x42, 0xb6, 0xb1, 0xfe, 0xbf, 0xfe, 0xa3, 0xfe, 0xbe, 0xb1, 0xb5, 0x01,
-  0x41, 0xfe, 0x57, 0x9d, 0x01, 0x1c, 0x01, 0x36, 0x01, 0x1c, 0x9d, 0xa1,
-  0xfe, 0xe3, 0x96, 0x97, 0xfe, 0xe3, 0xa0, 0x03, 0x38, 0x1e, 0x36, 0x1e,
-  0x1d, 0x36, 0x1f, 0x20, 0x36, 0x1c, 0x1e, 0x35, 0x05, 0xd9, 0xc1, 0xfe,
-  0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63, 0x01, 0x86, 0x01,
-  0x68, 0xc1, 0xfd, 0x14, 0xad, 0xfe, 0xc5, 0xae, 0xae, 0x01, 0x3b, 0xad,
-  0xac, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1, 0xcd, 0x42, 0x3c, 0x21, 0x21,
-  0x3c, 0x42, 0x3d, 0x20, 0x20, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99,
-  0x00, 0x01, 0x05, 0xdc, 0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1b, 0x00, 0x29,
-  0x00, 0x36, 0x00, 0x00, 0x01, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20,
-  0x24, 0x02, 0x10, 0x12, 0x24, 0x01, 0x14, 0x12, 0x04, 0x20, 0x24, 0x12,
-  0x35, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x04, 0x34, 0x3e, 0x01,
-  0x33, 0x32, 0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x24, 0x32,
-  0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01, 0x34, 0x36, 0x03,
-  0x3a, 0xa9, 0x01, 0x42, 0xb6, 0xb1, 0xfe, 0xbf, 0xfe, 0xa3, 0xfe, 0xbe,
-  0xb1, 0xb5, 0x01, 0x41, 0xfe, 0x57, 0x9d, 0x01, 0x1c, 0x01, 0x36, 0x01,
-  0x1c, 0x9d, 0xa1, 0xfe, 0xe3, 0x96, 0x97, 0xfe, 0xe3, 0xa0, 0x03, 0x38,
-  0x1e, 0x36, 0x1e, 0x1d, 0x36, 0x1f, 0x20, 0x36, 0x1c, 0x1e, 0x35, 0xfd,
-  0x85, 0x3a, 0x36, 0x1f, 0x1f, 0x36, 0x1d, 0x1d, 0x36, 0x1f, 0x20, 0x05,
-  0xd9, 0xc1, 0xfe, 0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63,
-  0x01, 0x86, 0x01, 0x68, 0xc1, 0xfd, 0x14, 0xad, 0xfe, 0xc5, 0xae, 0xae,
-  0x01, 0x3b, 0xad, 0xac, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1, 0xcd, 0x42,
-  0x3c, 0x21, 0x21, 0x3c, 0x42, 0x3d, 0x20, 0x20, 0xdc, 0x20, 0x3d, 0x42,
-  0x3c, 0x21, 0x21, 0x3c, 0x42, 0x3d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x99,
-  0x00, 0x01, 0x05, 0xdc, 0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1a, 0x00, 0x00,
-  0x01, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x02, 0x10, 0x12,
-  0x24, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01,
-  0x14, 0x1e, 0x01, 0x03, 0x3a, 0xa9, 0x01, 0x42, 0xb6, 0xb1, 0xfe, 0xbf,
-  0xfe, 0xa3, 0xfe, 0xbe, 0xb1, 0xb5, 0x01, 0x41, 0x02, 0x01, 0x1c, 0x36,
-  0x20, 0x1f, 0x36, 0x1d, 0x1e, 0x36, 0x1e, 0x1f, 0x35, 0x05, 0xd9, 0xc1,
-  0xfe, 0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63, 0x01, 0x86,
-  0x01, 0x68, 0xc1, 0xfc, 0x96, 0x20, 0x3d, 0x42, 0x3c, 0x21, 0x21, 0x3c,
-  0x42, 0x3d, 0x20, 0x00, 0x00, 0x03, 0x00, 0x99, 0x00, 0x01, 0x05, 0xdc,
-  0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1a, 0x00, 0x27, 0x00, 0x00, 0x01, 0x32,
-  0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x02, 0x10, 0x12, 0x24, 0x01,
-  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x14, 0x1e,
-  0x01, 0x24, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01,
-  0x22, 0x06, 0x03, 0x3a, 0xa9, 0x01, 0x42, 0xb6, 0xb1, 0xfe, 0xbf, 0xfe,
-  0xa3, 0xfe, 0xbe, 0xb1, 0xb5, 0x01, 0x41, 0x02, 0x01, 0x1c, 0x36, 0x20,
-  0x1f, 0x36, 0x1d, 0x1e, 0x36, 0x1e, 0x1f, 0x35, 0xfc, 0xfb, 0x1f, 0x36,
-  0x1d, 0x1d, 0x36, 0x1f, 0x1f, 0x36, 0x3a, 0x35, 0x05, 0xd9, 0xc1, 0xfe,
-  0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63, 0x01, 0x86, 0x01,
-  0x68, 0xc1, 0xfc, 0x96, 0x20, 0x3d, 0x42, 0x3c, 0x21, 0x21, 0x3c, 0x42,
-  0x3d, 0x20, 0x9f, 0x42, 0x3c, 0x21, 0x21, 0x3c, 0x42, 0x3d, 0x20, 0x20,
-  0x00, 0x01, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x00, 0xc8, 0x00, 0x03,
-  0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x99, 0x05, 0x42, 0xfa, 0xbe, 0xc8,
-  0xc8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x00, 0xc8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21,
-  0x25, 0x21, 0x15, 0x21, 0x99, 0x02, 0x23, 0xfd, 0xdd, 0x03, 0x1f, 0x02,
-  0x23, 0xfd, 0xdd, 0xc8, 0xc8, 0xc8, 0xc8, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4d, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
-  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x85, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4d, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
-  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4e, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4e, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x00, 0x02, 0x01, 0x35,
-  0x00, 0x06, 0x05, 0x3d, 0x05, 0xd9, 0x00, 0x11, 0x00, 0x2a, 0x00, 0x00,
-  0x01, 0x36, 0x33, 0x32, 0x04, 0x33, 0x32, 0x37, 0x11, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x2f, 0x01, 0x23, 0x35, 0x33, 0x15, 0x23,
-  0x15, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x11, 0x06, 0x23,
-  0x22, 0x24, 0x23, 0x22, 0x07, 0x11, 0x23, 0x01, 0xd3, 0x2f, 0x36, 0x73,
-  0x01, 0x2d, 0xa8, 0x3f, 0x41, 0x2f, 0x30, 0x96, 0x9f, 0x7d, 0xac, 0x2d,
-  0x31, 0x12, 0x59, 0x44, 0xf3, 0x45, 0x30, 0x2e, 0xae, 0x9a, 0x98, 0x91,
-  0x47, 0x43, 0x5f, 0x5c, 0x9a, 0xfe, 0xe3, 0x74, 0x48, 0x3f, 0x56, 0x02,
-  0x9f, 0x11, 0xa3, 0x0c, 0x02, 0x62, 0x0a, 0x5f, 0x7e, 0x09, 0x02, 0x5d,
-  0x35, 0x35, 0x1a, 0x08, 0x78, 0x5c, 0x15, 0xfd, 0x0d, 0x1c, 0x9a, 0x1e,
-  0xfd, 0xc6, 0x00, 0x00, 0x00, 0x01, 0x01, 0x35, 0x00, 0x06, 0x05, 0x3d,
-  0x05, 0xd9, 0x00, 0x18, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33, 0x15, 0x23,
-  0x15, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x11, 0x06, 0x23,
-  0x22, 0x24, 0x23, 0x22, 0x07, 0x11, 0x23, 0x01, 0x7a, 0x44, 0xf3, 0x45,
-  0x30, 0x2e, 0xae, 0x9a, 0x98, 0x91, 0x47, 0x43, 0x5f, 0x5c, 0x9a, 0xfe,
-  0xe3, 0x74, 0x48, 0x3f, 0x56, 0x05, 0xa4, 0x35, 0x35, 0x1a, 0x08, 0x78,
-  0x5c, 0x15, 0xfd, 0x0d, 0x1c, 0x9a, 0x1e, 0xfd, 0xc6, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5f, 0x00, 0x01, 0x06, 0x15, 0x05, 0xda, 0x00, 0x1f,
-  0x00, 0x00, 0x09, 0x01, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x17,
-  0x07, 0x09, 0x01, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x16, 0x13, 0x09,
-  0x01, 0x17, 0x01, 0x07, 0x03, 0x27, 0x07, 0x03, 0x27, 0x01, 0x02, 0xe4,
-  0xfe, 0xd4, 0xa6, 0xb3, 0xa8, 0x2a, 0x7d, 0x26, 0xa7, 0xb1, 0xa6, 0x01,
-  0x2c, 0x01, 0x2c, 0xa6, 0xb2, 0xa6, 0x28, 0x7a, 0x28, 0x3f, 0x1f, 0xfe,
-  0xf1, 0xfe, 0xd5, 0xa0, 0x01, 0x1f, 0xa7, 0xf3, 0xa1, 0xa0, 0xf3, 0xa6,
-  0x01, 0x1e, 0x02, 0x7e, 0x01, 0x51, 0xbb, 0xc7, 0xbb, 0x2c, 0x8a, 0x2c,
-  0xba, 0xc8, 0xba, 0xfe, 0xb0, 0x01, 0x4f, 0xbb, 0xc8, 0xbb, 0x2d, 0x8a,
-  0x2c, 0x71, 0xfe, 0x74, 0x01, 0x35, 0xfe, 0xaf, 0xb3, 0xfe, 0xf0, 0xb9,
-  0x01, 0x40, 0xb4, 0xb4, 0xfe, 0xc0, 0xb9, 0x01, 0x10, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xb2, 0xff, 0xec, 0x05, 0xc2, 0x05, 0xdb, 0x00, 0x0f,
-  0x00, 0x52, 0x00, 0x00, 0x01, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01,
-  0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x13, 0x15, 0x23, 0x06,
-  0x23, 0x22, 0x27, 0x35, 0x23, 0x15, 0x23, 0x22, 0x24, 0x27, 0x26, 0x27,
-  0x07, 0x03, 0x05, 0x07, 0x30, 0x17, 0x16, 0x17, 0x16, 0x17, 0x11, 0x21,
-  0x35, 0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x33, 0x32,
-  0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x15, 0x21, 0x15, 0x21, 0x11,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x27, 0x25, 0x03, 0x27, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x02, 0xc2, 0x23, 0x41, 0x22, 0x24, 0x40, 0x24, 0x25,
-  0x40, 0x23, 0x22, 0x40, 0x24, 0xcc, 0x07, 0x22, 0x23, 0x02, 0x03, 0x06,
-  0x07, 0x98, 0xfe, 0xea, 0x4d, 0x0f, 0x0b, 0x4f, 0x1a, 0x01, 0x14, 0x4e,
-  0x06, 0x41, 0x77, 0x62, 0x6a, 0xfe, 0xae, 0x01, 0x52, 0x18, 0x16, 0x38,
-  0x3d, 0x3e, 0x70, 0x3b, 0x3b, 0x70, 0x40, 0x3f, 0x36, 0x19, 0x17, 0x01,
-  0x48, 0xfe, 0xb8, 0x5a, 0x54, 0x77, 0x43, 0x02, 0x02, 0x4e, 0x01, 0x15,
-  0x1b, 0x4e, 0x0b, 0x0f, 0x4e, 0x8b, 0x67, 0x04, 0xd6, 0x27, 0x48, 0x27,
-  0x27, 0x48, 0x27, 0x28, 0x48, 0x27, 0x27, 0x48, 0xfa, 0xf2, 0x01, 0x03,
-  0x01, 0x02, 0x02, 0x60, 0x58, 0x11, 0x10, 0x41, 0x01, 0x4b, 0x7c, 0x40,
-  0x06, 0x58, 0x31, 0x28, 0x07, 0x02, 0xd4, 0x81, 0x33, 0x08, 0x0e, 0x22,
-  0x7c, 0x88, 0x7d, 0x44, 0x44, 0x7d, 0x88, 0x7c, 0x22, 0x0e, 0x09, 0x32,
-  0x81, 0xfd, 0x2f, 0x0a, 0x22, 0x31, 0x58, 0x03, 0x03, 0x40, 0x7c, 0xfe,
-  0xb5, 0x41, 0x10, 0x11, 0x58, 0x31, 0x23, 0x00, 0x00, 0x01, 0x00, 0xf2,
-  0x00, 0x00, 0x05, 0x83, 0x05, 0xd6, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x13,
-  0x36, 0x37, 0x33, 0x06, 0x07, 0x17, 0x16, 0x17, 0x0e, 0x01, 0x07, 0x26,
-  0x2f, 0x01, 0x06, 0x07, 0x27, 0x36, 0x37, 0x0b, 0x01, 0x16, 0x17, 0x07,
-  0x26, 0x27, 0x07, 0x06, 0x07, 0x22, 0x26, 0x27, 0x36, 0x3f, 0x01, 0x26,
-  0x27, 0x33, 0x16, 0x17, 0x13, 0x01, 0x27, 0x09, 0x01, 0x07, 0x03, 0x7f,
-  0xfa, 0x43, 0x19, 0x51, 0x16, 0x54, 0x8d, 0x37, 0x02, 0x05, 0x36, 0x27,
-  0x40, 0x03, 0x8e, 0x5c, 0x52, 0x23, 0x5c, 0x3b, 0xdc, 0xd9, 0x3b, 0x5b,
-  0x22, 0x53, 0x5e, 0x8c, 0x01, 0x39, 0x24, 0x43, 0x04, 0x01, 0x39, 0x8c,
-  0x54, 0x17, 0x53, 0x18, 0x44, 0xfa, 0xfe, 0x19, 0x1d, 0x02, 0x47, 0x02,
-  0x49, 0x1d, 0x02, 0xbd, 0xfe, 0xd0, 0x3b, 0x3c, 0x75, 0x49, 0xb6, 0x03,
-  0x40, 0x2a, 0x22, 0x01, 0x04, 0x4f, 0xa8, 0x38, 0x08, 0x42, 0x11, 0x31,
-  0x01, 0x22, 0xfe, 0xde, 0x31, 0x11, 0x42, 0x08, 0x38, 0xa8, 0x48, 0x0b,
-  0x1d, 0x24, 0x4c, 0x03, 0xb6, 0x49, 0x75, 0x3c, 0x3b, 0x01, 0x30, 0x02,
-  0x84, 0x95, 0xfd, 0x3a, 0x02, 0xc6, 0x95, 0x00, 0x00, 0x05, 0x00, 0x70,
-  0xff, 0xec, 0x03, 0x73, 0x05, 0xdb, 0x00, 0x07, 0x00, 0x1a, 0x00, 0x2e,
-  0x00, 0x4f, 0x00, 0x60, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x35, 0x34,
-  0x27, 0x26, 0x13, 0x15, 0x06, 0x23, 0x22, 0x27, 0x35, 0x26, 0x35, 0x34,
-  0x37, 0x17, 0x06, 0x15, 0x14, 0x04, 0x07, 0x23, 0x26, 0x03, 0x24, 0x35,
-  0x34, 0x37, 0x15, 0x06, 0x15, 0x14, 0x04, 0x17, 0x06, 0x07, 0x35, 0x36,
-  0x35, 0x34, 0x27, 0x11, 0x27, 0x13, 0x11, 0x27, 0x11, 0x24, 0x27, 0x36,
-  0x37, 0x32, 0x33, 0x32, 0x17, 0x07, 0x17, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x23, 0x22, 0x15, 0x14, 0x04, 0x17, 0x06, 0x05, 0x35, 0x36, 0x27, 0x34,
-  0x35, 0x34, 0x25, 0x27, 0x03, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x33,
-  0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x01, 0x32, 0x19, 0x0c, 0x0a,
-  0x05, 0x20, 0xe0, 0x0b, 0x18, 0x20, 0x02, 0xa3, 0x93, 0x01, 0x3a, 0x01,
-  0x22, 0x01, 0x0e, 0x19, 0xb1, 0xfe, 0xfe, 0xf3, 0x9a, 0x01, 0xf5, 0x03,
-  0x04, 0xf8, 0xa3, 0xb1, 0x45, 0x45, 0x45, 0xfe, 0x9d, 0x04, 0x0c, 0xc0,
-  0x04, 0x02, 0x3b, 0x2f, 0x64, 0x55, 0x15, 0x18, 0x33, 0x3d, 0x08, 0x06,
-  0x28, 0x02, 0xa4, 0x05, 0x06, 0xfe, 0xba, 0xf6, 0x01, 0xff, 0x00, 0x45,
-  0x05, 0x13, 0x15, 0x15, 0x26, 0x14, 0x15, 0x25, 0x16, 0x15, 0x13, 0x04,
-  0xa4, 0x0c, 0x09, 0x06, 0x0a, 0x0b, 0xfb, 0x94, 0x42, 0x1d, 0x40, 0x30,
-  0x22, 0x40, 0x52, 0x1a, 0x2f, 0x18, 0x18, 0x2f, 0x3e, 0x77, 0x41, 0x01,
-  0xb7, 0x26, 0x6f, 0x63, 0x2f, 0x44, 0x26, 0x33, 0x2e, 0x59, 0x61, 0x51,
-  0x2f, 0x35, 0x22, 0x31, 0x27, 0x22, 0xfe, 0xb4, 0x13, 0x03, 0x01, 0xfe,
-  0x81, 0x10, 0x01, 0x75, 0x13, 0x8a, 0x90, 0x05, 0x45, 0x1e, 0x19, 0x06,
-  0x1b, 0x02, 0x36, 0x32, 0x2f, 0x75, 0x8a, 0x10, 0x3d, 0x20, 0x3d, 0x01,
-  0x02, 0x21, 0x6d, 0x07, 0x01, 0x2d, 0x0b, 0x2e, 0x18, 0x19, 0x2e, 0x18,
-  0x18, 0x2e, 0x19, 0x18, 0x2e, 0x0b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6c,
-  0xff, 0xec, 0x06, 0x07, 0x05, 0xdb, 0x00, 0x04, 0x00, 0x09, 0x00, 0x37,
-  0x00, 0x00, 0x25, 0x0b, 0x01, 0x16, 0x32, 0x25, 0x0b, 0x01, 0x16, 0x32,
-  0x01, 0x33, 0x32, 0x1d, 0x01, 0x14, 0x2b, 0x01, 0x13, 0x06, 0x07, 0x0e,
-  0x01, 0x23, 0x22, 0x2e, 0x01, 0x3d, 0x01, 0x13, 0x21, 0x13, 0x15, 0x14,
-  0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x13, 0x23, 0x26, 0x3d, 0x01,
-  0x34, 0x3b, 0x01, 0x37, 0x17, 0x33, 0x1b, 0x01, 0x33, 0x37, 0x05, 0xbc,
-  0xf8, 0xf9, 0x7d, 0xf9, 0xfd, 0x6e, 0xf8, 0xf8, 0x7c, 0xf8, 0x02, 0xbc,
-  0xc0, 0x33, 0x25, 0xaf, 0xf9, 0x02, 0x2b, 0x2b, 0x9b, 0x56, 0x54, 0x9a,
-  0x55, 0xf5, 0xfd, 0x92, 0xf6, 0x54, 0x9b, 0xa9, 0x9c, 0x2c, 0x2a, 0x01,
-  0xf7, 0xb7, 0x1d, 0x33, 0xc2, 0x2f, 0x2e, 0xe3, 0x74, 0x74, 0xe3, 0x2f,
-  0xed, 0x03, 0x3c, 0xfc, 0xc4, 0x26, 0x26, 0x03, 0x3c, 0xfc, 0xc4, 0x26,
-  0x03, 0xd1, 0x2a, 0x19, 0x28, 0xfc, 0xc7, 0x44, 0x3e, 0x3f, 0x47, 0x47,
-  0x7a, 0x42, 0x08, 0x03, 0x36, 0xfc, 0xca, 0x06, 0x43, 0x7b, 0x47, 0x47,
-  0x3f, 0x3e, 0x44, 0x03, 0x39, 0x11, 0x1c, 0x0f, 0x2f, 0x9b, 0x9b, 0x01,
-  0x43, 0xfe, 0xbd, 0x9b, 0x00, 0x02, 0x00, 0x70, 0x00, 0x00, 0x06, 0x03,
-  0x05, 0xdb, 0x00, 0x1a, 0x00, 0x26, 0x00, 0x00, 0x01, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x03, 0x27, 0x12, 0x01,
-  0x13, 0x23, 0x03, 0x21, 0x11, 0x23, 0x03, 0x21, 0x03, 0x23, 0x13, 0x02,
-  0x8a, 0xa5, 0x8f, 0x30, 0x2d, 0xb5, 0x44, 0x1f, 0x0f, 0x27, 0x71, 0x44,
-  0x3f, 0x2b, 0x8d, 0x4a, 0x1e, 0x33, 0x23, 0x2b, 0x46, 0x92, 0xb4, 0x6c,
-  0xcf, 0x04, 0x6f, 0x55, 0x72, 0x4c, 0xfe, 0xff, 0x7c, 0x01, 0xfe, 0xff,
-  0x4d, 0x73, 0x56, 0x05, 0x87, 0x54, 0x09, 0x27, 0xa6, 0x4e, 0x51, 0x39,
-  0x3b, 0x8d, 0x3a, 0x23, 0x38, 0xb3, 0x48, 0x4c, 0x22, 0x43, 0xfe, 0xdf,
-  0x44, 0x01, 0x99, 0xfd, 0x7c, 0xfd, 0xa6, 0x01, 0xd7, 0xfe, 0x29, 0x01,
-  0xd7, 0xfe, 0x29, 0x02, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x0b,
-  0x00, 0x00, 0x05, 0x68, 0x05, 0xdb, 0x00, 0x0d, 0x00, 0x35, 0x00, 0x00,
-  0x00, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23,
-  0x22, 0x06, 0x13, 0x15, 0x3b, 0x01, 0x32, 0x36, 0x37, 0x14, 0x04, 0x07,
-  0x06, 0x07, 0x23, 0x26, 0x3d, 0x01, 0x26, 0x24, 0x03, 0x1e, 0x01, 0x33,
-  0x32, 0x37, 0x33, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32,
-  0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x02, 0x9c, 0x2d, 0x52, 0x2b, 0x2d,
-  0x52, 0x2d, 0x2f, 0x51, 0x2c, 0x2a, 0x52, 0xa8, 0x05, 0x03, 0x87, 0xcb,
-  0x9b, 0xfe, 0x58, 0x23, 0x2f, 0x02, 0x26, 0x27, 0x04, 0xfe, 0x40, 0x4f,
-  0xb3, 0xd4, 0x74, 0x0c, 0x0c, 0x06, 0x3b, 0x36, 0x46, 0x4e, 0x4f, 0x8d,
-  0x96, 0x8e, 0x51, 0x4f, 0x47, 0x33, 0x04, 0xc4, 0x64, 0x59, 0x32, 0x32,
-  0x59, 0x64, 0x5b, 0x30, 0x30, 0xfe, 0x2d, 0x9c, 0xbf, 0x26, 0xe7, 0x9a,
-  0x97, 0x88, 0xf5, 0xa8, 0x9a, 0x14, 0x84, 0x8f, 0x01, 0x31, 0x02, 0xe9,
-  0x01, 0x9b, 0x07, 0x23, 0x2b, 0x9c, 0xac, 0x9e, 0x55, 0x55, 0x9e, 0xac,
-  0x9c, 0x2b, 0x20, 0x00, 0x00, 0x03, 0x00, 0xae, 0xff, 0xdd, 0x05, 0xc6,
-  0x05, 0xd0, 0x00, 0x3f, 0x00, 0x47, 0x00, 0x4f, 0x00, 0x00, 0x00, 0x32,
-  0x1f, 0x01, 0x16, 0x17, 0x37, 0x16, 0x17, 0x07, 0x16, 0x17, 0x37, 0x16,
-  0x17, 0x07, 0x16, 0x14, 0x07, 0x17, 0x06, 0x07, 0x27, 0x06, 0x07, 0x17,
-  0x06, 0x07, 0x27, 0x06, 0x0f, 0x01, 0x06, 0x22, 0x2f, 0x01, 0x26, 0x27,
-  0x07, 0x26, 0x27, 0x37, 0x26, 0x27, 0x07, 0x26, 0x27, 0x37, 0x26, 0x34,
-  0x37, 0x27, 0x36, 0x37, 0x17, 0x36, 0x37, 0x27, 0x36, 0x37, 0x17, 0x36,
-  0x3f, 0x01, 0x12, 0x20, 0x02, 0x10, 0x12, 0x20, 0x12, 0x10, 0x04, 0x14,
-  0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x03, 0x13, 0x4f, 0x26, 0x18, 0x3c,
-  0x3a, 0x71, 0x45, 0x39, 0x4b, 0x2a, 0x1e, 0x94, 0x21, 0x0f, 0x85, 0x03,
-  0x03, 0x85, 0x0f, 0x21, 0x94, 0x1e, 0x2a, 0x4b, 0x39, 0x45, 0x71, 0x3a,
-  0x3c, 0x18, 0x26, 0x4f, 0x27, 0x18, 0x3c, 0x39, 0x72, 0x44, 0x3a, 0x4c,
-  0x2b, 0x1d, 0x95, 0x21, 0x0e, 0x85, 0x04, 0x04, 0x85, 0x0e, 0x21, 0x95,
-  0x1d, 0x2b, 0x4c, 0x3a, 0x44, 0x72, 0x39, 0x3c, 0x18, 0xf2, 0xfe, 0xb8,
-  0xe8, 0xe8, 0x01, 0x48, 0xe8, 0xff, 0x00, 0x52, 0x73, 0x52, 0x52, 0x73,
-  0x05, 0xd0, 0x05, 0xbb, 0x0d, 0x1e, 0x84, 0x2d, 0x40, 0x9c, 0x32, 0x3c,
-  0x1f, 0x54, 0x5c, 0x45, 0x23, 0x44, 0x23, 0x46, 0x5b, 0x54, 0x1f, 0x3c,
-  0x33, 0x9b, 0x40, 0x2e, 0x84, 0x1d, 0x0e, 0xba, 0x06, 0x06, 0xba, 0x0e,
-  0x1d, 0x84, 0x2e, 0x40, 0x9b, 0x32, 0x3d, 0x1f, 0x54, 0x5b, 0x46, 0x23,
-  0x44, 0x23, 0x45, 0x5c, 0x54, 0x1f, 0x3c, 0x33, 0x9b, 0x40, 0x2d, 0x83,
-  0x1d, 0x0d, 0xbb, 0xfe, 0xc4, 0xfe, 0xfd, 0xfe, 0x95, 0xfe, 0xfe, 0x01,
-  0x02, 0x01, 0x6b, 0x75, 0x80, 0x5b, 0x5b, 0x80, 0x5b, 0x00, 0x00, 0x00,
-  0x00, 0x0f, 0x00, 0xeb, 0xff, 0xed, 0x05, 0x88, 0x05, 0xdd, 0x00, 0x09,
-  0x00, 0x0e, 0x00, 0x13, 0x00, 0x18, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x2c,
-  0x00, 0x31, 0x00, 0x36, 0x00, 0x3b, 0x00, 0x40, 0x00, 0x48, 0x00, 0x4f,
-  0x00, 0x5b, 0x00, 0x9f, 0x00, 0x00, 0x00, 0x14, 0x1e, 0x01, 0x33, 0x26,
-  0x34, 0x37, 0x22, 0x06, 0x05, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16, 0x17,
-  0x37, 0x26, 0x27, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16, 0x07, 0x37, 0x26,
-  0x27, 0x14, 0x15, 0x14, 0x07, 0x17, 0x35, 0x34, 0x27, 0x06, 0x07, 0x17,
-  0x36, 0x35, 0x34, 0x05, 0x17, 0x36, 0x37, 0x06, 0x07, 0x17, 0x36, 0x37,
-  0x06, 0x07, 0x17, 0x36, 0x37, 0x06, 0x1f, 0x01, 0x26, 0x37, 0x06, 0x17,
-  0x37, 0x26, 0x35, 0x34, 0x37, 0x06, 0x15, 0x3f, 0x01, 0x26, 0x27, 0x06,
-  0x15, 0x14, 0x05, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x27, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x33,
-  0x32, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x33, 0x14, 0x23, 0x15,
-  0x16, 0x17, 0x16, 0x17, 0x36, 0x37, 0x04, 0x17, 0x06, 0x23, 0x26, 0x22,
-  0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x03, 0x15, 0x06, 0x23, 0x22,
-  0x2f, 0x01, 0x03, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x26, 0x23, 0x22,
-  0x07, 0x22, 0x27, 0x36, 0x25, 0x16, 0x17, 0x36, 0x37, 0x36, 0x03, 0x01,
-  0x0f, 0x1c, 0x10, 0x0d, 0x0d, 0x0f, 0x1d, 0x01, 0xc1, 0x63, 0x26, 0x17,
-  0x52, 0x82, 0x63, 0x21, 0x23, 0x51, 0x6c, 0x45, 0x0e, 0x2b, 0x36, 0x6f,
-  0x2e, 0x01, 0x35, 0x22, 0x59, 0x13, 0x36, 0x36, 0x2b, 0x2d, 0x34, 0x24,
-  0xfc, 0xce, 0x18, 0x26, 0x62, 0x4e, 0x25, 0x23, 0x21, 0x64, 0x57, 0x12,
-  0x2c, 0x0e, 0x44, 0x48, 0x0e, 0x35, 0x01, 0x2d, 0x3f, 0x36, 0x35, 0x14,
-  0x01, 0x22, 0x59, 0x34, 0x2d, 0x2a, 0x01, 0x01, 0x00, 0x32, 0x44, 0x44,
-  0x32, 0x2f, 0x46, 0x45, 0x51, 0x02, 0x02, 0x11, 0x13, 0x13, 0x23, 0x13,
-  0x12, 0x22, 0x14, 0x13, 0x11, 0x02, 0x03, 0x01, 0x01, 0x2f, 0x25, 0x03,
-  0x02, 0x48, 0x14, 0x01, 0x2d, 0x48, 0x4d, 0xe4, 0x24, 0x3e, 0x19, 0x04,
-  0x2f, 0x24, 0x2f, 0x01, 0x0a, 0x14, 0x17, 0x07, 0x01, 0x02, 0x2e, 0x24,
-  0x2e, 0x02, 0x1c, 0x24, 0x1f, 0x24, 0xe5, 0x4c, 0x48, 0x01, 0x2c, 0x13,
-  0x4a, 0x06, 0x09, 0x24, 0x05, 0xa0, 0x22, 0x1f, 0x12, 0x20, 0x42, 0x22,
-  0x11, 0x76, 0x3e, 0x30, 0x26, 0x38, 0x14, 0x61, 0x3e, 0x21, 0x55, 0x2a,
-  0x7e, 0x45, 0x13, 0x6d, 0x4c, 0x91, 0x4b, 0x08, 0x7d, 0x60, 0x11, 0x10,
-  0x81, 0x3f, 0x0a, 0x0c, 0x7b, 0x61, 0x88, 0x37, 0x1a, 0x63, 0x5b, 0x0d,
-  0x4f, 0x26, 0x30, 0x3e, 0x10, 0x6a, 0x21, 0x3e, 0x61, 0x29, 0x86, 0x13,
-  0x45, 0x7e, 0x43, 0x88, 0x08, 0x4b, 0x91, 0x57, 0x8b, 0x0a, 0x3d, 0x7b,
-  0x14, 0x15, 0x64, 0x7b, 0x03, 0x1a, 0x37, 0x88, 0x0e, 0x0d, 0x5b, 0x2b,
-  0x4d, 0x35, 0x37, 0x4c, 0x4c, 0x37, 0x35, 0x4d, 0x2d, 0x5a, 0x01, 0x02,
-  0x0a, 0x27, 0x2a, 0x27, 0x15, 0x15, 0x27, 0x2a, 0x27, 0x0a, 0x02, 0x01,
-  0x01, 0x59, 0x09, 0x28, 0x03, 0x04, 0x80, 0x35, 0x06, 0x5b, 0xa3, 0x0c,
-  0x0c, 0x14, 0x15, 0x4a, 0x35, 0x28, 0x09, 0xfc, 0xd6, 0x5c, 0x16, 0x1c,
-  0x64, 0x03, 0x1c, 0x09, 0x28, 0x35, 0x4a, 0x12, 0x11, 0x11, 0x0c, 0xa3,
-  0x5b, 0x06, 0x34, 0x8c, 0x0a, 0x09, 0x27, 0x00, 0x00, 0x0f, 0x00, 0xea,
-  0x00, 0x00, 0x05, 0x8a, 0x05, 0xd3, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x2f,
-  0x00, 0x37, 0x00, 0x4f, 0x00, 0x5f, 0x00, 0x9f, 0x00, 0xab, 0x00, 0xb3,
-  0x00, 0xbb, 0x00, 0xcb, 0x00, 0xd3, 0x00, 0xdb, 0x00, 0xe3, 0x00, 0xef,
-  0x00, 0x00, 0x01, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x0e, 0x01, 0x23, 0x22,
-  0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x07, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x33, 0x36, 0x37, 0x26, 0x25, 0x06,
-  0x07, 0x16, 0x17, 0x32, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x27, 0x06, 0x27, 0x16, 0x15, 0x14, 0x07, 0x36, 0x37, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x13, 0x16,
-  0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x05, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x15, 0x36,
-  0x33, 0x32, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x23,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x23, 0x22, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x32, 0x33, 0x32, 0x05, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x16, 0x17, 0x36, 0x17, 0x06, 0x07, 0x16, 0x17, 0x16,
-  0x17, 0x26, 0x25, 0x06, 0x07, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x36,
-  0x37, 0x36, 0x07, 0x06, 0x07, 0x16, 0x17, 0x26, 0x35, 0x34, 0x17, 0x16,
-  0x17, 0x36, 0x37, 0x26, 0x27, 0x26, 0x17, 0x16, 0x17, 0x36, 0x37, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x26, 0x03, 0x3a, 0x11, 0x21, 0x12, 0x12, 0x21, 0x11, 0x12, 0x20,
-  0x12, 0x12, 0x20, 0xca, 0x47, 0x40, 0x73, 0x2e, 0x21, 0x07, 0x15, 0x4d,
-  0x08, 0x08, 0x59, 0x89, 0x0d, 0x01, 0xb2, 0x05, 0x0d, 0x8a, 0x59, 0x08,
-  0x07, 0x4d, 0x15, 0x07, 0x21, 0x2f, 0x72, 0x40, 0x44, 0x01, 0x01, 0x33,
-  0x2f, 0x2f, 0x62, 0x2b, 0x2c, 0x2d, 0x2d, 0x2c, 0x2b, 0x2d, 0x2a, 0x02,
-  0x02, 0x29, 0x2e, 0x2b, 0x2e, 0x2c, 0x2c, 0x2d, 0x2a, 0x03, 0x16, 0x0e,
-  0x05, 0x47, 0x3f, 0x71, 0x30, 0x22, 0x07, 0x15, 0x4d, 0x08, 0x0a, 0x5b,
-  0xfd, 0xef, 0x01, 0x1e, 0x6c, 0x38, 0x38, 0x6a, 0x1f, 0x93, 0x65, 0x03,
-  0x04, 0x68, 0x1d, 0x0b, 0x20, 0x32, 0x7b, 0x01, 0x7c, 0x32, 0x1e, 0x0b,
-  0x1c, 0x6a, 0x06, 0x63, 0x93, 0x01, 0x1f, 0x34, 0x35, 0x3a, 0x3a, 0x36,
-  0x34, 0x1f, 0x92, 0x63, 0x05, 0x6c, 0x1c, 0x0a, 0x1e, 0x30, 0x7c, 0x7a,
-  0x31, 0x1f, 0x0a, 0x1d, 0x67, 0x04, 0x02, 0x65, 0x01, 0xee, 0x18, 0x29,
-  0x2b, 0x2c, 0x2e, 0x2a, 0x29, 0x19, 0x4d, 0x4d, 0x4c, 0x53, 0x36, 0x38,
-  0x1e, 0x21, 0x1e, 0x1d, 0x04, 0xfe, 0xb9, 0x08, 0x05, 0x1e, 0x1f, 0x1f,
-  0x1f, 0x38, 0x60, 0x86, 0x5a, 0x09, 0x09, 0x4d, 0x14, 0x08, 0x22, 0x31,
-  0x70, 0x3f, 0x47, 0x05, 0x08, 0x33, 0x2e, 0x2e, 0x33, 0x01, 0x33, 0x05,
-  0x08, 0x36, 0x38, 0x20, 0x1e, 0x20, 0xc1, 0x38, 0x36, 0x08, 0x04, 0x1d,
-  0x1e, 0x21, 0x51, 0x4b, 0x4d, 0x18, 0x29, 0x2a, 0x2f, 0x2e, 0x2a, 0x29,
-  0x17, 0x4d, 0x03, 0x35, 0x13, 0x24, 0x15, 0x14, 0x23, 0x14, 0x14, 0x23,
-  0x14, 0x15, 0x24, 0x13, 0xd9, 0x35, 0x39, 0x67, 0x54, 0x3b, 0x26, 0x12,
-  0x0e, 0x27, 0x04, 0x39, 0x5a, 0x5e, 0x5e, 0x5a, 0x39, 0x04, 0x27, 0x0e,
-  0x12, 0x27, 0x3a, 0x54, 0x67, 0x39, 0xa7, 0x27, 0x28, 0x27, 0x27, 0x26,
-  0x28, 0x29, 0x49, 0x1e, 0x1c, 0x1c, 0x1a, 0x1a, 0x1c, 0x1c, 0x1e, 0x38,
-  0x3a, 0x39, 0x38, 0x1e, 0x1c, 0x1d, 0x1a, 0x1a, 0x1d, 0x1c, 0x1e, 0x38,
-  0x39, 0x3a, 0x01, 0x0c, 0x5a, 0x5f, 0x35, 0x39, 0x65, 0x55, 0x3b, 0x27,
-  0x13, 0x0e, 0x28, 0x01, 0x05, 0x09, 0x02, 0xb3, 0xc0, 0xc0, 0xb3, 0x02,
-  0x3a, 0x02, 0x38, 0x14, 0x1b, 0x2e, 0x3e, 0x65, 0x75, 0x01, 0x76, 0x63,
-  0x3e, 0x2d, 0x1b, 0x14, 0x37, 0x03, 0x3a, 0xb0, 0x62, 0x63, 0x63, 0x62,
-  0xb0, 0x3b, 0x04, 0x37, 0x14, 0x1a, 0x2d, 0x3f, 0x63, 0x77, 0x75, 0x64,
-  0x3f, 0x2f, 0x1a, 0x14, 0x38, 0x02, 0x4b, 0xa2, 0x57, 0x5a, 0x5a, 0x57,
-  0xa2, 0x20, 0x2a, 0x2a, 0x10, 0x19, 0x1d, 0x12, 0x14, 0x15, 0x14, 0x44,
-  0x40, 0x40, 0x44, 0x14, 0x15, 0x14, 0x12, 0x1d, 0x2b, 0x38, 0x05, 0x01,
-  0x28, 0x0f, 0x13, 0x27, 0x3a, 0x54, 0x65, 0x39, 0x35, 0x5e, 0x9d, 0x26,
-  0x29, 0x28, 0x26, 0x27, 0x27, 0x28, 0xd6, 0x44, 0x41, 0x19, 0x1d, 0x12,
-  0x14, 0x14, 0x3a, 0x1d, 0x19, 0x41, 0x44, 0x15, 0x14, 0x14, 0x2e, 0x2a,
-  0x21, 0x9e, 0x59, 0x5b, 0x5b, 0x59, 0x9e, 0x21, 0x00, 0x07, 0x00, 0xea,
-  0x00, 0x00, 0x05, 0x89, 0x05, 0xd6, 0x00, 0x0b, 0x00, 0x14, 0x00, 0x21,
-  0x00, 0x2d, 0x00, 0x78, 0x00, 0x86, 0x00, 0x94, 0x00, 0x00, 0x01, 0x14,
-  0x17, 0x36, 0x37, 0x26, 0x27, 0x36, 0x37, 0x26, 0x27, 0x06, 0x05, 0x34,
-  0x26, 0x15, 0x06, 0x15, 0x16, 0x17, 0x36, 0x25, 0x06, 0x15, 0x14, 0x17,
-  0x36, 0x37, 0x2e, 0x01, 0x27, 0x06, 0x15, 0x14, 0x25, 0x34, 0x27, 0x06,
-  0x07, 0x16, 0x17, 0x06, 0x07, 0x16, 0x17, 0x36, 0x03, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x36, 0x37, 0x26,
-  0x35, 0x34, 0x3f, 0x01, 0x15, 0x16, 0x15, 0x14, 0x07, 0x1e, 0x01, 0x17,
-  0x36, 0x37, 0x16, 0x17, 0x06, 0x07, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x06, 0x23, 0x26,
-  0x27, 0x06, 0x07, 0x06, 0x07, 0x23, 0x26, 0x27, 0x35, 0x26, 0x27, 0x06,
-  0x07, 0x22, 0x27, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x06,
-  0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x25, 0x32, 0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01,
-  0x34, 0x3e, 0x01, 0x03, 0x6d, 0x23, 0x31, 0x28, 0x2e, 0x08, 0x03, 0x2d,
-  0x21, 0x2a, 0x2b, 0xfe, 0xf9, 0x25, 0x28, 0x07, 0x32, 0x13, 0x01, 0xaf,
-  0x01, 0x0f, 0x37, 0x03, 0x03, 0x25, 0x01, 0x20, 0xfe, 0xf5, 0x2b, 0x26,
-  0x27, 0x2e, 0x03, 0x0d, 0x29, 0x2d, 0x2d, 0x23, 0xef, 0x32, 0x1d, 0x0c,
-  0x09, 0x1c, 0x51, 0x5b, 0x02, 0x02, 0xa4, 0x99, 0x4b, 0x28, 0x2c, 0x23,
-  0x94, 0x01, 0x94, 0x23, 0x24, 0x2a, 0x04, 0x4d, 0x97, 0xa6, 0x01, 0x02,
-  0x5c, 0x50, 0x1d, 0x05, 0x0d, 0x1a, 0x38, 0x18, 0x12, 0x33, 0x33, 0x15,
-  0x1d, 0x1f, 0x2d, 0x01, 0x0c, 0x3b, 0x2d, 0x35, 0x3f, 0x56, 0x16, 0x1d,
-  0x1d, 0x4f, 0x3c, 0x38, 0x2d, 0x3d, 0x0b, 0x01, 0x2e, 0x1e, 0x1c, 0x15,
-  0x33, 0x34, 0x12, 0x2f, 0x5e, 0xaa, 0x5d, 0x5d, 0xa9, 0x5f, 0x61, 0xab,
-  0x59, 0x5b, 0xaa, 0x01, 0x05, 0x4b, 0x8f, 0x52, 0x4f, 0x8f, 0x4e, 0x4e,
-  0x8f, 0x4f, 0x51, 0x8f, 0x02, 0x84, 0xa3, 0xa7, 0x0f, 0x23, 0x65, 0x8d,
-  0xaa, 0x6a, 0x1c, 0x0f, 0x70, 0xcd, 0x4d, 0x63, 0x01, 0x4e, 0x54, 0x76,
-  0x4a, 0x4b, 0x72, 0x1b, 0x19, 0x5a, 0x31, 0x56, 0x6c, 0x4c, 0x57, 0x02,
-  0x4d, 0x49, 0x09, 0x11, 0xa9, 0x70, 0x0d, 0x1e, 0x6a, 0xaa, 0x85, 0x6b,
-  0x25, 0x0f, 0xa7, 0x01, 0x6e, 0x41, 0x0d, 0x56, 0x02, 0x02, 0x7b, 0x77,
-  0x02, 0x06, 0x77, 0x19, 0x11, 0x5b, 0x31, 0x87, 0xf4, 0x01, 0x01, 0xf4,
-  0x87, 0x31, 0x5b, 0x0d, 0x1a, 0x03, 0x77, 0x06, 0x02, 0x77, 0x7b, 0x02,
-  0x02, 0x56, 0x0d, 0x40, 0x1e, 0x23, 0x66, 0xdc, 0x64, 0x2d, 0x23, 0x4a,
-  0x4d, 0x0c, 0x37, 0x42, 0x2f, 0x15, 0x22, 0x89, 0x89, 0x22, 0x01, 0x14,
-  0x30, 0x43, 0x37, 0x0c, 0x4e, 0x4b, 0x22, 0x2c, 0x64, 0xdc, 0x66, 0x23,
-  0x88, 0xce, 0xbd, 0x68, 0x68, 0xbd, 0xce, 0xbf, 0x67, 0x67, 0x51, 0x55,
-  0xa0, 0xae, 0x9d, 0x58, 0x58, 0x9d, 0xae, 0xa0, 0x55, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x1b, 0x05, 0xd4, 0x00, 0x07,
-  0x00, 0x0d, 0x00, 0x15, 0x00, 0x25, 0x00, 0x00, 0x01, 0x33, 0x01, 0x15,
-  0x21, 0x27, 0x23, 0x00, 0x17, 0x01, 0x15, 0x21, 0x35, 0x00, 0x07, 0x32,
-  0x15, 0x02, 0x23, 0x22, 0x03, 0x36, 0x13, 0x32, 0x1e, 0x01, 0x15, 0x14,
-  0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x03, 0x42,
-  0x07, 0x02, 0xd1, 0xfa, 0x4f, 0x07, 0x08, 0x02, 0xcc, 0x14, 0xfd, 0xab,
-  0x04, 0xb3, 0xfd, 0xbc, 0x12, 0x46, 0x2f, 0x17, 0x14, 0x31, 0x17, 0x2d,
-  0x11, 0x22, 0x13, 0x12, 0x23, 0x11, 0x12, 0x20, 0x13, 0x13, 0x20, 0x05,
-  0xd4, 0xfa, 0x35, 0x09, 0x09, 0x05, 0xaa, 0x9b, 0xfb, 0x4f, 0x11, 0x09,
-  0x04, 0x9d, 0xc2, 0x44, 0xfd, 0x9b, 0x02, 0x6e, 0x3b, 0xfd, 0x0d, 0x14,
-  0x24, 0x15, 0x14, 0x24, 0x14, 0x14, 0x24, 0x14, 0x15, 0x24, 0x14, 0x00,
-  0x00, 0x01, 0x00, 0x99, 0x00, 0x04, 0x04, 0x76, 0x05, 0xd8, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x33, 0x17, 0x15, 0x01, 0x14, 0x33, 0x04, 0x15, 0x17,
-  0x01, 0x27, 0x35, 0x00, 0x35, 0x34, 0x23, 0x24, 0x2f, 0x01, 0x04, 0x56,
-  0x0c, 0x13, 0xfd, 0xcd, 0x52, 0x01, 0x5c, 0x06, 0xfc, 0xb0, 0x0d, 0x02,
-  0x46, 0x6b, 0xfe, 0xb8, 0x0f, 0x06, 0x05, 0xd8, 0x15, 0x07, 0xfd, 0xe2,
-  0x47, 0x53, 0x0e, 0x47, 0xfd, 0x55, 0x15, 0x07, 0x02, 0x57, 0x0d, 0x47,
-  0x4a, 0x11, 0x47, 0x00, 0x00, 0x05, 0x00, 0x9d, 0xfe, 0xff, 0x06, 0x9e,
-  0x05, 0xda, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x31, 0x00, 0x3d, 0x00, 0x43,
-  0x00, 0x00, 0x01, 0x26, 0x10, 0x00, 0x33, 0x32, 0x17, 0x36, 0x33, 0x32,
-  0x00, 0x10, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11,
-  0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x26, 0x13, 0x22, 0x06,
-  0x10, 0x16, 0x33, 0x32, 0x37, 0x26, 0x10, 0x37, 0x26, 0x13, 0x06, 0x07,
-  0x11, 0x21, 0x11, 0x26, 0x37, 0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23,
-  0x22, 0x07, 0x16, 0x10, 0x05, 0x36, 0x10, 0x27, 0x06, 0x10, 0x01, 0x36,
-  0x98, 0x01, 0x2e, 0xd7, 0x8a, 0x70, 0x71, 0x8b, 0xd5, 0x01, 0x30, 0x97,
-  0x7b, 0xa2, 0xf5, 0xf5, 0xa2, 0xfe, 0xac, 0xa2, 0xf5, 0xf5, 0xa3, 0xf4,
-  0x94, 0xcf, 0xcf, 0x94, 0x39, 0x33, 0x7c, 0x7d, 0x33, 0xc1, 0x4f, 0x5b,
-  0x01, 0x54, 0x5c, 0x41, 0x33, 0x39, 0x90, 0xd3, 0xd3, 0x90, 0x3a, 0x35,
-  0x7e, 0xfe, 0xf5, 0x69, 0x69, 0x68, 0x02, 0x14, 0x9d, 0x01, 0xdd, 0x01,
-  0x4c, 0x46, 0x46, 0xfe, 0xb4, 0xfe, 0x22, 0x9c, 0x7e, 0x12, 0xfe, 0xf8,
-  0x7c, 0xfe, 0xff, 0x01, 0x01, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x09,
-  0x11, 0x03, 0x91, 0xe4, 0xfe, 0xb9, 0xd8, 0x11, 0x95, 0x01, 0xae, 0x9d,
-  0x12, 0xfc, 0x94, 0x2d, 0x0a, 0xfe, 0xf8, 0x01, 0x09, 0x0a, 0xa5, 0x10,
-  0xd8, 0x01, 0x47, 0xe4, 0x12, 0x9d, 0xfe, 0x50, 0x38, 0x6c, 0x01, 0x47,
-  0x72, 0x72, 0xfe, 0xb9, 0x00, 0x05, 0x00, 0x91, 0xfe, 0x5b, 0x07, 0x5f,
-  0x05, 0xc3, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x2c, 0x00, 0x38, 0x00, 0x3e,
-  0x00, 0x00, 0x01, 0x26, 0x20, 0x06, 0x10, 0x17, 0x16, 0x17, 0x36, 0x00,
-  0x37, 0x26, 0x01, 0x14, 0x00, 0x20, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x10, 0x00, 0x04, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x21, 0x11, 0x07,
-  0x11, 0x01, 0x16, 0x03, 0x01, 0x16, 0x17, 0x16, 0x17, 0x01, 0x23, 0x03,
-  0x06, 0x00, 0x07, 0x16, 0x17, 0x16, 0x20, 0x36, 0x10, 0x27, 0x26, 0x01,
-  0x32, 0x36, 0x35, 0x22, 0x06, 0x03, 0x92, 0x6a, 0xfe, 0xdc, 0xd0, 0x68,
-  0x2a, 0x31, 0x0f, 0x01, 0x17, 0xb8, 0x19, 0x02, 0x44, 0xfe, 0xd6, 0xfe,
-  0x51, 0x99, 0x69, 0x20, 0x79, 0x61, 0x99, 0x01, 0x36, 0x01, 0x9d, 0x64,
-  0x01, 0x45, 0xfe, 0xb2, 0x7e, 0x01, 0xbd, 0x01, 0x63, 0x80, 0xfe, 0xbe,
-  0x64, 0x86, 0xfe, 0xbe, 0x3a, 0x18, 0x66, 0x3d, 0x01, 0x45, 0xf8, 0xde,
-  0x0d, 0xfe, 0xef, 0xc8, 0x1a, 0x2f, 0x68, 0x01, 0x25, 0xd2, 0x69, 0x29,
-  0xfd, 0xcb, 0x91, 0xd3, 0x94, 0xcc, 0x03, 0x24, 0x72, 0xe4, 0xfe, 0xb8,
-  0x6c, 0x2c, 0x1a, 0xce, 0x01, 0x33, 0x07, 0x36, 0xfd, 0x90, 0xe8, 0xfe,
-  0xbd, 0x9f, 0x6c, 0x92, 0x25, 0x65, 0x9e, 0x01, 0xdc, 0x01, 0x55, 0x11,
-  0x67, 0x01, 0x5c, 0x8e, 0xfe, 0x78, 0xfe, 0x14, 0x8f, 0x01, 0x75, 0xfe,
-  0xa4, 0x92, 0x03, 0x76, 0xfe, 0xa4, 0x53, 0x63, 0x1b, 0x3f, 0x01, 0x5c,
-  0xfe, 0x37, 0xcc, 0xfe, 0xd7, 0x0b, 0x3d, 0x31, 0x6c, 0xd8, 0x01, 0x48,
-  0x72, 0x2d, 0xfe, 0xc9, 0xd8, 0xa4, 0xe0, 0x00, 0x00, 0x04, 0x00, 0x9d,
-  0xfe, 0x83, 0x07, 0xfc, 0x06, 0xd9, 0x00, 0x05, 0x00, 0x2d, 0x00, 0x39,
-  0x00, 0x45, 0x00, 0x00, 0x00, 0x02, 0x17, 0x36, 0x10, 0x27, 0x01, 0x14,
-  0x00, 0x23, 0x22, 0x27, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23,
-  0x11, 0x23, 0x35, 0x33, 0x11, 0x26, 0x27, 0x26, 0x10, 0x00, 0x33, 0x32,
-  0x17, 0x36, 0x17, 0x16, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x07, 0x11,
-  0x01, 0x16, 0x25, 0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x37, 0x26, 0x10,
-  0x37, 0x26, 0x01, 0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x22, 0x07,
-  0x16, 0x10, 0x03, 0x37, 0x01, 0x67, 0x69, 0x69, 0x03, 0x02, 0xfe, 0xd4,
-  0xdb, 0x8a, 0x72, 0x4e, 0x5a, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xa3, 0x79,
-  0x98, 0x01, 0x2e, 0xd7, 0x88, 0x6f, 0x74, 0x8a, 0xce, 0x64, 0x01, 0x46,
-  0xfe, 0xb1, 0x7e, 0x01, 0xbd, 0x80, 0xfe, 0xbe, 0x65, 0xfc, 0x04, 0x94,
-  0xcf, 0xcf, 0x94, 0x39, 0x33, 0x7b, 0x7d, 0x34, 0x01, 0x50, 0x33, 0x38,
-  0x92, 0xd3, 0xd3, 0x92, 0x3a, 0x34, 0x7e, 0x03, 0xc8, 0xfe, 0xb8, 0x6c,
-  0x6c, 0x01, 0x47, 0x72, 0xfe, 0xeb, 0xe7, 0xfe, 0xbc, 0x45, 0x2c, 0x0a,
-  0xfe, 0xf8, 0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x09, 0x11, 0x7e,
-  0x9d, 0x01, 0xdd, 0x01, 0x4c, 0x44, 0x4a, 0x06, 0x08, 0x67, 0x01, 0x5c,
-  0x8e, 0xfe, 0x14, 0x8f, 0x01, 0x75, 0xfe, 0xa4, 0x92, 0xc6, 0xe4, 0xfe,
-  0xb9, 0xd8, 0x11, 0x95, 0x01, 0xac, 0x9f, 0x12, 0xfd, 0x0d, 0x10, 0xd8,
-  0x01, 0x48, 0xe4, 0x12, 0x9d, 0xfe, 0x4f, 0x00, 0x00, 0x02, 0x00, 0x9d,
-  0xfe, 0xff, 0x06, 0x07, 0x07, 0x55, 0x00, 0x07, 0x00, 0x28, 0x00, 0x00,
-  0x00, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20, 0x36, 0x05, 0x26, 0x10, 0x00,
-  0x33, 0x32, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x07, 0x11, 0x01, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11,
-  0x23, 0x35, 0x33, 0x11, 0x26, 0x04, 0x06, 0xd2, 0xfe, 0xdb, 0xcf, 0xcf,
-  0x01, 0x25, 0xd2, 0xfd, 0x30, 0x98, 0x01, 0x2e, 0xd7, 0xad, 0x86, 0x01,
-  0x44, 0xfe, 0xb2, 0x7e, 0x01, 0xbd, 0x81, 0xfe, 0xbe, 0x64, 0x98, 0x7a,
-  0xa2, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xa3, 0x04, 0x43, 0xe4, 0xe4, 0xfe,
-  0xb9, 0xd8, 0xd8, 0xe8, 0x9d, 0x01, 0xdd, 0x01, 0x4c, 0x6e, 0x01, 0x5b,
-  0x8e, 0xfe, 0x14, 0x8f, 0x01, 0x75, 0xfe, 0xa4, 0x92, 0xc2, 0xef, 0x9c,
-  0x7e, 0x12, 0xfe, 0xf8, 0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x09,
-  0x11, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xf2, 0xff, 0xe3, 0x05, 0x3c,
-  0x06, 0xf4, 0x00, 0x2b, 0x00, 0x44, 0x00, 0x00, 0x01, 0x07, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x37, 0x27, 0x37, 0x17, 0x13, 0x07, 0x27, 0x25, 0x13, 0x07,
-  0x27, 0x03, 0x17, 0x07, 0x01, 0x16, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36,
-  0x34, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06,
-  0x14, 0x17, 0x16, 0x17, 0x16, 0x03, 0xbe, 0x3f, 0x2d, 0x1f, 0x3d, 0x1f,
-  0x22, 0x21, 0x20, 0x70, 0x58, 0x4e, 0x56, 0x51, 0x51, 0x55, 0x35, 0x3d,
-  0x1f, 0x22, 0x22, 0x21, 0x76, 0x51, 0x50, 0x53, 0x35, 0x2e, 0x3f, 0xe4,
-  0x33, 0xe5, 0x78, 0xca, 0x34, 0x01, 0x9f, 0xad, 0x7d, 0x54, 0x78, 0xe4,
-  0x34, 0xfd, 0x8c, 0x37, 0x71, 0x37, 0x36, 0x51, 0x18, 0x16, 0x16, 0x15,
-  0x2a, 0x26, 0x72, 0x6d, 0x39, 0x36, 0x50, 0x19, 0x16, 0x16, 0x15, 0x2a,
-  0x24, 0x04, 0x00, 0xaa, 0x21, 0x24, 0x48, 0x53, 0x5c, 0xb4, 0x5b, 0x56,
-  0x83, 0x2a, 0x25, 0x25, 0x27, 0x3e, 0x48, 0x53, 0x5d, 0xb3, 0x5e, 0x58,
-  0x82, 0x26, 0x25, 0x0c, 0xab, 0x69, 0x8a, 0x69, 0x01, 0x44, 0x5e, 0x8b,
-  0xbf, 0xfe, 0x32, 0x39, 0xe1, 0xfe, 0xbd, 0x69, 0x8b, 0xfc, 0xfc, 0x1a,
-  0x19, 0x19, 0x5c, 0x3d, 0x3c, 0x80, 0x3c, 0x39, 0x32, 0x2d, 0x31, 0x19,
-  0x19, 0x58, 0x3f, 0x3a, 0x84, 0x3c, 0x39, 0x31, 0x2a, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xba, 0xfe, 0xa3, 0x05, 0x57, 0x07, 0x12, 0x00, 0x3d,
-  0x00, 0x58, 0x00, 0x00, 0x01, 0x36, 0x32, 0x17, 0x13, 0x07, 0x27, 0x25,
-  0x13, 0x07, 0x27, 0x03, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x23,
-  0x35, 0x33, 0x35, 0x26, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36,
-  0x37, 0x36, 0x37, 0x27, 0x07, 0x27, 0x37, 0x27, 0x07, 0x27, 0x13, 0x05,
-  0x07, 0x27, 0x17, 0x37, 0x17, 0x07, 0x17, 0x22, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x02, 0xa3, 0x2f,
-  0x65, 0x30, 0xa1, 0xcb, 0x33, 0x01, 0x9f, 0xad, 0x7e, 0x54, 0xa1, 0x2a,
-  0x24, 0x3e, 0x40, 0x40, 0x3e, 0x3a, 0x51, 0x28, 0x36, 0xf7, 0xf7, 0x87,
-  0xf8, 0xf8, 0x33, 0x2c, 0x4d, 0x3d, 0x3e, 0x40, 0x3f, 0x3f, 0x23, 0x2c,
-  0x1c, 0xe5, 0x33, 0xe5, 0x4c, 0x54, 0x7e, 0xad, 0x01, 0xa0, 0x33, 0xcc,
-  0x4c, 0xe4, 0x35, 0xe5, 0x7c, 0x40, 0x2f, 0x38, 0x27, 0x29, 0x2c, 0x2c,
-  0x29, 0x2a, 0x35, 0x33, 0x7c, 0x30, 0x38, 0x26, 0x2a, 0x2c, 0x2c, 0x2a,
-  0x2a, 0x34, 0x34, 0x04, 0x87, 0x0c, 0x0c, 0x01, 0x9e, 0x5c, 0x8a, 0xbf,
-  0xfe, 0x32, 0x3a, 0xe2, 0xfe, 0x61, 0x1d, 0x28, 0x45, 0xab, 0x62, 0x5f,
-  0xab, 0x45, 0x40, 0x28, 0x14, 0x0a, 0xb8, 0x96, 0xf0, 0xf0, 0x96, 0xb8,
-  0x09, 0x15, 0x25, 0x43, 0x45, 0xab, 0x5f, 0x62, 0xa9, 0x47, 0x28, 0x1e,
-  0x48, 0x69, 0x8a, 0x6a, 0xcb, 0xe2, 0x3a, 0x01, 0xce, 0xbf, 0x8a, 0x5c,
-  0xcb, 0x69, 0x8a, 0x6a, 0xd3, 0x18, 0x1c, 0x2b, 0x2e, 0x77, 0x42, 0x41,
-  0x77, 0x2e, 0x2f, 0x18, 0x18, 0x18, 0x1c, 0x2b, 0x2e, 0x77, 0x41, 0x42,
-  0x77, 0x2e, 0x2f, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x59,
-  0xff, 0xe3, 0x04, 0xaf, 0x06, 0xf4, 0x00, 0x2b, 0x00, 0x46, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x15, 0x23, 0x15, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x23,
-  0x35, 0x33, 0x11, 0x07, 0x27, 0x09, 0x01, 0x07, 0x03, 0x32, 0x37, 0x36,
-  0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07,
-  0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x03,
-  0x48, 0xf7, 0xf7, 0x36, 0x28, 0x51, 0x3a, 0x3e, 0x40, 0x40, 0x3e, 0x3d,
-  0x4e, 0x4a, 0x58, 0x5c, 0x46, 0x51, 0x39, 0x3e, 0x40, 0x40, 0x3e, 0x3d,
-  0x4d, 0x2c, 0x33, 0xf8, 0xf8, 0x9b, 0x60, 0x01, 0x3e, 0x01, 0x3f, 0x60,
-  0xdf, 0x3c, 0x34, 0x34, 0x2a, 0x2a, 0x2c, 0x2c, 0x2a, 0x26, 0x38, 0x30,
-  0x7c, 0x33, 0x35, 0x2a, 0x29, 0x2c, 0x2c, 0x29, 0x27, 0x38, 0x2f, 0x05,
-  0xd5, 0xfe, 0xe7, 0x96, 0x91, 0x0a, 0x14, 0x28, 0x40, 0x45, 0xab, 0x5f,
-  0x62, 0xab, 0x45, 0x43, 0x25, 0x23, 0x23, 0x28, 0x40, 0x45, 0xab, 0x62,
-  0x5f, 0xab, 0x45, 0x43, 0x25, 0x15, 0x09, 0x91, 0x96, 0x01, 0x19, 0xad,
-  0x6b, 0x01, 0x61, 0xfe, 0x9f, 0x6a, 0xfb, 0x50, 0x18, 0x18, 0x2f, 0x2e,
-  0x77, 0x42, 0x41, 0x77, 0x2e, 0x2b, 0x1c, 0x18, 0x18, 0x18, 0x2f, 0x2e,
-  0x77, 0x41, 0x42, 0x77, 0x2e, 0x2b, 0x1c, 0x18, 0x00, 0x02, 0x00, 0x08,
-  0x01, 0x10, 0x05, 0xf8, 0x04, 0xc4, 0x00, 0x2b, 0x00, 0x46, 0x00, 0x00,
-  0x01, 0x23, 0x11, 0x23, 0x11, 0x23, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01,
-  0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x11,
-  0x33, 0x11, 0x33, 0x27, 0x37, 0x09, 0x01, 0x27, 0x25, 0x14, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27,
-  0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x04,
-  0xf5, 0xc6, 0x87, 0x4c, 0x0a, 0x12, 0x24, 0x39, 0x3e, 0x9a, 0x56, 0x58,
-  0x9a, 0x3e, 0x3c, 0x21, 0x20, 0x20, 0x24, 0x39, 0x3e, 0x9a, 0x58, 0x56,
-  0x9a, 0x3e, 0x3c, 0x21, 0x13, 0x09, 0x4c, 0x87, 0xc6, 0x9c, 0x61, 0x01,
-  0x3d, 0xfe, 0xc3, 0x60, 0xfc, 0x35, 0x16, 0x15, 0x2b, 0x29, 0x6b, 0x3b,
-  0x3b, 0x6b, 0x2a, 0x26, 0x19, 0x16, 0x16, 0x15, 0x2a, 0x2a, 0x6b, 0x3b,
-  0x3b, 0x6b, 0x29, 0x27, 0x19, 0x16, 0x02, 0x9f, 0xfe, 0xed, 0x01, 0x13,
-  0x3c, 0x2d, 0x5a, 0x40, 0x45, 0x47, 0x47, 0x45, 0x44, 0x56, 0x52, 0x62,
-  0x66, 0x4e, 0x5a, 0x40, 0x45, 0x47, 0x47, 0x45, 0x44, 0x56, 0x31, 0x38,
-  0x01, 0x13, 0xfe, 0xed, 0xac, 0x6b, 0xfe, 0x9e, 0xfe, 0x9e, 0x6a, 0xf8,
-  0x43, 0x39, 0x3a, 0x2f, 0x2e, 0x31, 0x31, 0x2e, 0x2b, 0x3e, 0x35, 0x8a,
-  0x39, 0x3a, 0x2f, 0x2e, 0x31, 0x31, 0x2e, 0x2b, 0x3e, 0x35, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x58, 0x01, 0x10, 0x04, 0xb0, 0x04, 0xc5, 0x00, 0x0b,
-  0x00, 0x17, 0x00, 0x00, 0x01, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14,
-  0x02, 0x23, 0x22, 0x02, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x01, 0x59, 0xfb, 0xb0, 0xb1, 0xfb, 0xfb, 0xb1,
-  0xb0, 0xfb, 0x89, 0xaa, 0x78, 0x78, 0xaa, 0xaa, 0x78, 0x78, 0xaa, 0x02,
-  0xeb, 0xc4, 0x01, 0x16, 0xfe, 0xea, 0xc4, 0xc5, 0xfe, 0xea, 0x01, 0x16,
-  0xc2, 0x85, 0xbd, 0xbd, 0x85, 0x86, 0xbd, 0xbd, 0x00, 0x01, 0x01, 0x58,
-  0x01, 0x10, 0x04, 0xb0, 0x04, 0xc5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x34,
-  0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x02, 0x23, 0x22, 0x02, 0x01, 0x59,
-  0xfb, 0xb0, 0xb1, 0xfb, 0xfb, 0xb1, 0xb0, 0xfb, 0x02, 0xeb, 0xc4, 0x01,
-  0x16, 0xfe, 0xea, 0xc4, 0xc5, 0xfe, 0xea, 0x01, 0x16, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0xc7, 0x01, 0x8d, 0x04, 0x41, 0x04, 0x4b, 0x00, 0x0b,
-  0x00, 0x17, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x01, 0xc7, 0xbb, 0x82, 0x83, 0xba, 0xba, 0x83,
-  0x82, 0xbb, 0x89, 0x6a, 0x4a, 0x4b, 0x69, 0x69, 0x4b, 0x4a, 0x6a, 0x02,
-  0xec, 0x92, 0xcd, 0xcd, 0x92, 0x91, 0xce, 0xce, 0x90, 0x53, 0x75, 0x75,
-  0x53, 0x53, 0x76, 0x76, 0x00, 0x04, 0x01, 0x40, 0x01, 0x8d, 0x04, 0xc8,
-  0x04, 0x4b, 0x00, 0x13, 0x00, 0x21, 0x00, 0x29, 0x00, 0x37, 0x00, 0x00,
-  0x01, 0x34, 0x36, 0x33, 0x32, 0x17, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x27, 0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33,
-  0x32, 0x33, 0x26, 0x35, 0x34, 0x37, 0x26, 0x23, 0x22, 0x06, 0x25, 0x06,
-  0x15, 0x14, 0x17, 0x36, 0x35, 0x34, 0x37, 0x16, 0x15, 0x14, 0x07, 0x32,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x01, 0x40, 0xbb, 0x82,
-  0x4a, 0x3d, 0x3d, 0x4a, 0x83, 0xba, 0xba, 0x83, 0x4a, 0x3d, 0x3d, 0x4a,
-  0x82, 0xbb, 0x89, 0x69, 0x4b, 0x06, 0x04, 0x39, 0x38, 0x04, 0x05, 0x4b,
-  0x69, 0x01, 0x3b, 0x2d, 0x2d, 0x2d, 0x51, 0x38, 0x39, 0x05, 0x05, 0x4b,
-  0x69, 0x69, 0x4b, 0x04, 0x02, 0xec, 0x92, 0xcd, 0x20, 0x20, 0xcd, 0x92,
-  0x91, 0xce, 0x21, 0x21, 0xce, 0x90, 0x53, 0x75, 0x58, 0x71, 0x70, 0x57,
-  0x01, 0x76, 0x32, 0x38, 0x4d, 0x4c, 0x38, 0x38, 0x4c, 0x4d, 0x7b, 0x57,
-  0x70, 0x71, 0x58, 0x75, 0x53, 0x53, 0x76, 0x00, 0x00, 0x05, 0x00, 0x4b,
-  0x01, 0x5a, 0x05, 0xbd, 0x04, 0x7a, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x38,
-  0x00, 0x52, 0x00, 0x6d, 0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x00, 0x22,
-  0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x2f,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x04, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35,
-  0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e,
-  0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x02, 0xc1, 0x87, 0x87,
-  0x01, 0xe7, 0x4a, 0x20, 0x25, 0x15, 0x1a, 0x1b, 0x1c, 0x19, 0x1a, 0x20,
-  0x20, 0x4a, 0x1f, 0x21, 0x1a, 0x1a, 0x1b, 0x1d, 0x18, 0x1a, 0x21, 0x44,
-  0x43, 0x34, 0x3d, 0x29, 0x2d, 0x30, 0x30, 0x2d, 0x2c, 0x3a, 0x36, 0x85,
-  0x34, 0x3c, 0x2a, 0x2d, 0x2f, 0x2f, 0x2d, 0x2c, 0x3a, 0x37, 0xfd, 0x69,
-  0x4a, 0x20, 0x25, 0x15, 0x1a, 0x1b, 0x1c, 0x19, 0x1a, 0x20, 0x20, 0x4a,
-  0x1f, 0x20, 0x1b, 0x1a, 0x1b, 0x1d, 0x18, 0x1b, 0x20, 0x44, 0x43, 0x34,
-  0x3d, 0x29, 0x2d, 0x30, 0x30, 0x2d, 0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3c,
-  0x2a, 0x2d, 0x2f, 0x2f, 0x2d, 0x2c, 0x3a, 0x37, 0x04, 0x7a, 0xfc, 0xe0,
-  0x02, 0x5a, 0x0f, 0x12, 0x1a, 0x1f, 0x46, 0x29, 0x28, 0x4a, 0x1b, 0x1c,
-  0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29, 0x4b, 0x1a, 0x1c,
-  0x10, 0xa5, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x49, 0x46, 0x7f, 0x32, 0x31,
-  0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x46, 0x49, 0x7f, 0x32, 0x31,
-  0x1b, 0x1a, 0x96, 0x0f, 0x12, 0x1a, 0x1f, 0x46, 0x29, 0x28, 0x4a, 0x1b,
-  0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29, 0x4b, 0x1a,
-  0x1c, 0x10, 0xa5, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x49, 0x46, 0x7f, 0x32,
-  0x31, 0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x46, 0x49, 0x7f, 0x32,
-  0x31, 0x1b, 0x1a, 0x00, 0x00, 0x03, 0x00, 0x09, 0x01, 0x8d, 0x06, 0x00,
-  0x04, 0x4a, 0x00, 0x37, 0x00, 0x51, 0x00, 0x6b, 0x00, 0x00, 0x01, 0x3e,
-  0x01, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e,
-  0x01, 0x27, 0x21, 0x0e, 0x01, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x24, 0x22, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x22, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37,
-  0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x03, 0x92,
-  0x06, 0x1f, 0x31, 0x2c, 0x3a, 0x36, 0x41, 0x44, 0x34, 0x3c, 0x2a, 0x2d,
-  0x2f, 0x2f, 0x2d, 0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3d, 0x29, 0x30, 0x21,
-  0x05, 0xfe, 0xe4, 0x05, 0x23, 0x2e, 0x2c, 0x39, 0x37, 0x84, 0x35, 0x3c,
-  0x29, 0x2d, 0x30, 0x30, 0x2d, 0x2c, 0x39, 0x37, 0x41, 0x44, 0x34, 0x3c,
-  0x29, 0x31, 0x20, 0x06, 0x02, 0x73, 0x4a, 0x1f, 0x21, 0x1a, 0x1a, 0x1b,
-  0x1b, 0x1a, 0x1a, 0x21, 0x1f, 0x4a, 0x20, 0x20, 0x1a, 0x1a, 0x1b, 0x1b,
-  0x1a, 0x1a, 0x20, 0xfc, 0x5e, 0x4a, 0x1f, 0x25, 0x16, 0x1a, 0x1b, 0x1c,
-  0x19, 0x1a, 0x21, 0x1f, 0x4a, 0x20, 0x20, 0x1a, 0x1a, 0x1b, 0x1d, 0x18,
-  0x1a, 0x20, 0x03, 0x35, 0x1f, 0x5b, 0x35, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
-  0x2e, 0x32, 0x7f, 0x49, 0x46, 0x7f, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
-  0x2e, 0x34, 0x60, 0x18, 0x1d, 0x5d, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
-  0x2e, 0x32, 0x7f, 0x46, 0x49, 0x7f, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
-  0x2e, 0x35, 0x5b, 0x1f, 0x7f, 0x0f, 0x10, 0x1c, 0x1f, 0x46, 0x29, 0x28,
-  0x47, 0x1e, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29,
-  0x46, 0x1f, 0x1c, 0x10, 0x0f, 0x0f, 0x12, 0x1a, 0x1f, 0x46, 0x29, 0x28,
-  0x4a, 0x1b, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29,
-  0x4b, 0x1a, 0x1c, 0x10, 0x00, 0x02, 0x00, 0xbd, 0x01, 0xe6, 0x05, 0x73,
-  0x04, 0x52, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35, 0x25, 0x07,
-  0x15, 0x17, 0x01, 0x25, 0x05, 0x11, 0x05, 0x25, 0x04, 0xec, 0xfd, 0x1e,
-  0xc6, 0xc6, 0xfe, 0xb3, 0x01, 0x4d, 0x03, 0x69, 0xfc, 0x97, 0xfe, 0xb3,
-  0x02, 0xd7, 0x8a, 0x65, 0x4d, 0xba, 0x4d, 0x01, 0x5e, 0x82, 0x78, 0xfe,
-  0x84, 0x78, 0x82, 0x00, 0x00, 0x02, 0x01, 0x85, 0x00, 0x56, 0x04, 0x83,
-  0x05, 0x96, 0x00, 0x15, 0x00, 0x29, 0x00, 0x00, 0x01, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x35, 0x37, 0x35, 0x23, 0x15, 0x17, 0x15, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x1f, 0x02, 0x23, 0x03, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x27, 0x35, 0x21, 0x15, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x03, 0x1b, 0x55, 0x6a, 0x49, 0x21, 0x46, 0x34, 0xb4, 0x34, 0x46,
-  0x20, 0x4a, 0x6a, 0x56, 0x92, 0xf8, 0x94, 0x6e, 0x57, 0x4c, 0x27, 0x4f,
-  0x02, 0x06, 0x4f, 0x28, 0x4b, 0x58, 0x6f, 0x01, 0x11, 0xb4, 0xdf, 0x34,
-  0x62, 0x5c, 0x29, 0x31, 0xa2, 0x25, 0x3d, 0x3d, 0x25, 0xa2, 0x31, 0x29,
-  0x5c, 0x62, 0x34, 0xdf, 0xb4, 0xbb, 0x01, 0x3a, 0xea, 0x60, 0xbe, 0x5c,
-  0x4b, 0x19, 0x44, 0xfa, 0xfa, 0x44, 0x19, 0x4b, 0x5c, 0xbe, 0x60, 0xea,
-  0x00, 0x02, 0x00, 0x9d, 0xfe, 0xff, 0x04, 0xa9, 0x05, 0xda, 0x00, 0x07,
-  0x00, 0x15, 0x00, 0x00, 0x00, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20, 0x36,
-  0x05, 0x26, 0x10, 0x00, 0x20, 0x00, 0x10, 0x07, 0x06, 0x07, 0x11, 0x23,
-  0x11, 0x26, 0x04, 0x06, 0xd2, 0xfe, 0xdb, 0xcf, 0xcf, 0x01, 0x25, 0xd2,
-  0xfd, 0x30, 0x98, 0x01, 0x2e, 0x01, 0xab, 0x01, 0x31, 0x98, 0x7a, 0xa2,
-  0xa2, 0xa3, 0x04, 0x43, 0xe4, 0xe4, 0xfe, 0xb9, 0xd8, 0xd8, 0xe8, 0x9d,
-  0x01, 0xdd, 0x01, 0x4c, 0xfe, 0xb4, 0xfe, 0x22, 0x9c, 0x7e, 0x12, 0xfd,
-  0x7b, 0x02, 0x86, 0x11, 0x00, 0x01, 0x01, 0x36, 0xfe, 0xff, 0x04, 0xa8,
-  0x05, 0xda, 0x00, 0x1a, 0x00, 0x00, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35,
-  0x33, 0x11, 0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x20, 0x07, 0x27, 0x36,
-  0x20, 0x00, 0x10, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x02, 0xf5, 0xa3,
-  0xf5, 0xf5, 0x24, 0x2f, 0x91, 0xd0, 0xd0, 0xfe, 0xdb, 0x71, 0x6a, 0x98,
-  0x01, 0xab, 0x01, 0x2f, 0x97, 0x7b, 0xa1, 0xf4, 0xfe, 0xff, 0x01, 0x01,
-  0x7c, 0x01, 0xb2, 0x07, 0xd8, 0x01, 0x47, 0xe4, 0x6a, 0x74, 0xa6, 0xfe,
-  0xb4, 0xfe, 0x20, 0x9a, 0x7e, 0x12, 0xfe, 0xf8, 0x7c, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x9e, 0xfe, 0xff, 0x04, 0xa8, 0x05, 0xda, 0x00, 0x13,
-  0x00, 0x17, 0x00, 0x00, 0x13, 0x09, 0x02, 0x11, 0x32, 0x33, 0x15, 0x22,
-  0x23, 0x11, 0x22, 0x23, 0x11, 0x22, 0x23, 0x35, 0x32, 0x33, 0x11, 0x37,
-  0x09, 0x02, 0x9e, 0x02, 0x05, 0x02, 0x05, 0xfe, 0x50, 0x7a, 0x7a, 0x7a,
-  0x7a, 0x51, 0x51, 0x7b, 0x7a, 0x7a, 0x7b, 0x4d, 0x01, 0x2b, 0xfe, 0xd5,
-  0xfe, 0xd5, 0x03, 0x9f, 0x02, 0x3b, 0xfd, 0xc5, 0xfd, 0xe9, 0xfe, 0xf4,
-  0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x0c, 0xa8, 0x01, 0x6f, 0x01,
-  0x4a, 0xfe, 0xb6, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0xff, 0x04, 0xa8,
-  0x05, 0xda, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x37, 0x17, 0x11, 0x33, 0x11,
-  0x37, 0x17, 0x01, 0x21, 0x15, 0x21, 0x13, 0x07, 0x27, 0x11, 0x33, 0x15,
-  0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x07, 0x27, 0x13, 0x21,
-  0x35, 0x21, 0x01, 0x00, 0x6f, 0xe4, 0xa1, 0xe3, 0x6f, 0xff, 0x00, 0x01,
-  0x62, 0xfe, 0xa4, 0xfa, 0x6e, 0xe4, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xe4,
-  0x6e, 0xfa, 0xfe, 0xa4, 0x01, 0x62, 0x04, 0xf9, 0x7a, 0xfd, 0x01, 0x64,
-  0xfe, 0x9d, 0xfc, 0x7a, 0xfe, 0xe4, 0x7c, 0xfe, 0xeb, 0x7b, 0xfd, 0xfd,
-  0xae, 0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x02, 0x52, 0xfd, 0x7b, 0x01,
-  0x15, 0x7c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6c, 0xff, 0x0f, 0x05, 0xb2,
-  0x05, 0x25, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x00, 0x01, 0x15,
-  0x21, 0x09, 0x01, 0x21, 0x35, 0x21, 0x09, 0x01, 0x03, 0x11, 0x23, 0x11,
-  0x01, 0x33, 0x17, 0x37, 0x33, 0x15, 0x23, 0x09, 0x01, 0x23, 0x05, 0xb2,
-  0xfe, 0xf1, 0xfe, 0x6c, 0xfe, 0x6c, 0xfe, 0xf1, 0x01, 0x78, 0x01, 0x2b,
-  0x01, 0x2b, 0xd9, 0x9b, 0xfe, 0x9e, 0xea, 0xc1, 0xc1, 0xea, 0x80, 0xfe,
-  0xd5, 0xfe, 0xd5, 0x80, 0x01, 0x4a, 0x7c, 0xfe, 0x41, 0x01, 0xbf, 0x7c,
-  0xfe, 0xb6, 0x01, 0x4a, 0x03, 0xdb, 0xfd, 0xa6, 0x02, 0x5a, 0xfd, 0x74,
-  0xd5, 0xd5, 0x7c, 0xfe, 0xb6, 0x01, 0x4a, 0x00, 0x00, 0x02, 0x01, 0x66,
-  0xff, 0x2c, 0x04, 0x49, 0x05, 0xaf, 0x00, 0x07, 0x00, 0x1c, 0x00, 0x00,
-  0x24, 0x14, 0x16, 0x32, 0x36, 0x34, 0x26, 0x22, 0x02, 0x26, 0x10, 0x37,
-  0x36, 0x37, 0x11, 0x33, 0x11, 0x25, 0x17, 0x0d, 0x01, 0x07, 0x25, 0x11,
-  0x16, 0x17, 0x16, 0x10, 0x06, 0x01, 0xef, 0x69, 0x96, 0x69, 0x69, 0x96,
-  0x38, 0xba, 0x5e, 0x41, 0x53, 0x9b, 0x01, 0x08, 0x4d, 0xfe, 0xbd, 0x01,
-  0x43, 0x4d, 0xfe, 0xf8, 0x50, 0x3f, 0x5e, 0xba, 0xdd, 0xa6, 0x75, 0x75,
-  0xa6, 0x76, 0xfd, 0xd9, 0xce, 0x01, 0x23, 0x67, 0x47, 0x16, 0x03, 0xce,
-  0xfe, 0xce, 0xad, 0x94, 0xd1, 0xd2, 0x94, 0xae, 0xfe, 0xd2, 0x16, 0x45,
-  0x67, 0xfe, 0xdd, 0xce, 0x00, 0x01, 0x01, 0x23, 0xfe, 0xff, 0x03, 0xe9,
-  0x05, 0xda, 0x00, 0x1e, 0x00, 0x00, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35,
-  0x33, 0x11, 0x26, 0x27, 0x26, 0x35, 0x10, 0x25, 0x36, 0x37, 0x36, 0x17,
-  0x06, 0x07, 0x06, 0x15, 0x10, 0x17, 0x16, 0x17, 0x06, 0x27, 0x15, 0x33,
-  0x15, 0x02, 0xf4, 0xa2, 0xf5, 0xf5, 0x8c, 0x5c, 0x46, 0x01, 0x0b, 0x54,
-  0x9c, 0x41, 0x35, 0xb7, 0x58, 0x68, 0xe1, 0x4e, 0x4d, 0x43, 0x63, 0xf5,
-  0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x33, 0x4c, 0x98, 0x75, 0xa1, 0x01,
-  0x2e, 0xb9, 0x3a, 0x10, 0x07, 0x17, 0x3b, 0x85, 0x9d, 0xc4, 0xfe, 0xcd,
-  0xa2, 0x38, 0x0f, 0x25, 0x13, 0xff, 0x7c, 0x00, 0x00, 0x03, 0x00, 0x4d,
-  0x00, 0x08, 0x05, 0xbb, 0x04, 0x6d, 0x00, 0x0f, 0x00, 0x1d, 0x00, 0x33,
-  0x00, 0x00, 0x13, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01,
-  0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x00, 0x20, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x1e, 0x01, 0x15,
-  0x11, 0x14, 0x06, 0x07, 0x06, 0x21, 0x20, 0x27, 0x2e, 0x01, 0x35, 0x11,
-  0x34, 0x36, 0x37, 0x36, 0x21, 0x20, 0xa7, 0x9a, 0xba, 0x02, 0x13, 0xb9,
-  0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x03, 0x41, 0xfd, 0xed,
-  0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x9a, 0x28, 0x67, 0x65,
-  0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65, 0x65,
-  0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x02, 0x1d, 0x93, 0x60, 0x56, 0x68, 0x68,
-  0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20, 0x02, 0x0b, 0x68, 0x56,
-  0x63, 0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x63, 0x56, 0x59, 0x39, 0x88,
-  0x51, 0xfe, 0xa2, 0x4e, 0x88, 0x39, 0x73, 0x73, 0x39, 0x88, 0x4e, 0x01,
-  0x5e, 0x51, 0x88, 0x39, 0x73, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x4d,
-  0x00, 0x08, 0x05, 0xbb, 0x05, 0xcb, 0x00, 0x0d, 0x00, 0x1d, 0x00, 0x2d,
-  0x00, 0x45, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x15, 0x14, 0x17, 0x16, 0x20,
-  0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x15,
-  0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x01, 0x1e, 0x01, 0x15, 0x19, 0x01, 0x14, 0x06, 0x07, 0x06,
-  0x21, 0x20, 0x27, 0x2e, 0x01, 0x35, 0x19, 0x01, 0x34, 0x36, 0x37, 0x36,
-  0x21, 0x20, 0x04, 0x0e, 0xfd, 0xed, 0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13,
-  0xb9, 0x9a, 0x9a, 0xfb, 0xe0, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x29,
-  0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x26, 0x9a, 0xba, 0x02, 0x13, 0xb9,
-  0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x04, 0x22, 0x67, 0x65,
-  0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65, 0x65,
-  0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x05, 0x67, 0x68, 0x56, 0x63, 0x60, 0x56,
-  0x68, 0x68, 0x56, 0x60, 0x63, 0x56, 0xfe, 0x7c, 0x93, 0x60, 0x56, 0x68,
-  0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20, 0xfe, 0xc1, 0x93,
-  0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20,
-  0x03, 0x5a, 0x39, 0x88, 0x51, 0xfe, 0xa2, 0xfe, 0xa2, 0x4e, 0x88, 0x39,
-  0x73, 0x73, 0x39, 0x88, 0x4e, 0x01, 0x5e, 0x01, 0x5e, 0x51, 0x88, 0x39,
-  0x73, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x4d, 0x00, 0x08, 0x05, 0xbb,
-  0x04, 0x6d, 0x00, 0x0b, 0x00, 0x21, 0x00, 0x31, 0x00, 0x3f, 0x00, 0x55,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16,
-  0x21, 0x20, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x03, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07,
-  0x06, 0x20, 0x27, 0x26, 0x00, 0x20, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x1e, 0x01, 0x15, 0x11, 0x14,
-  0x06, 0x07, 0x06, 0x21, 0x20, 0x27, 0x2e, 0x01, 0x35, 0x11, 0x34, 0x36,
-  0x37, 0x36, 0x21, 0x20, 0x04, 0xec, 0x1c, 0x32, 0xa6, 0xf4, 0xf6, 0xa3,
-  0x35, 0x1b, 0xd4, 0x01, 0x15, 0x01, 0x13, 0xfd, 0xf9, 0x01, 0xea, 0xa4,
-  0x34, 0x1c, 0x19, 0x02, 0x17, 0x1c, 0x34, 0xa6, 0xfe, 0x16, 0xa3, 0x35,
-  0x1b, 0x1b, 0x01, 0x01, 0x19, 0x1c, 0x34, 0xc4, 0x9a, 0xba, 0x02, 0x13,
-  0xb9, 0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x03, 0x41, 0xfd,
-  0xed, 0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x9a, 0x28, 0x67,
-  0x65, 0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65,
-  0x65, 0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x01, 0x64, 0x1b, 0x1c, 0x5d, 0x5d,
-  0x1e, 0x1a, 0x63, 0x02, 0xa3, 0x5d, 0x1d, 0x1c, 0x19, 0x0e, 0x0e, 0x16,
-  0x1c, 0x1d, 0x5d, 0x5d, 0x1e, 0x1b, 0x18, 0x0c, 0x0f, 0x18, 0x1c, 0x1d,
-  0xfe, 0xd5, 0x93, 0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c,
-  0x78, 0x78, 0x20, 0x02, 0x0b, 0x68, 0x56, 0x63, 0x60, 0x56, 0x68, 0x68,
-  0x56, 0x60, 0x63, 0x56, 0x59, 0x39, 0x88, 0x51, 0xfe, 0xa2, 0x4e, 0x88,
-  0x39, 0x73, 0x73, 0x39, 0x88, 0x4e, 0x01, 0x5e, 0x51, 0x88, 0x39, 0x73,
-  0x00, 0x07, 0x00, 0x4d, 0x00, 0x08, 0x05, 0xbb, 0x05, 0xcb, 0x00, 0x15,
-  0x00, 0x21, 0x00, 0x2d, 0x00, 0x3b, 0x00, 0x4b, 0x00, 0x5b, 0x00, 0x73,
-  0x00, 0x00, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16, 0x21, 0x20,
-  0x17, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16, 0x21, 0x20,
-  0x02, 0x20, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x01, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01,
-  0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x15, 0x14, 0x17, 0x16, 0x20,
-  0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x01, 0x1e,
-  0x01, 0x15, 0x19, 0x01, 0x14, 0x06, 0x07, 0x06, 0x21, 0x20, 0x27, 0x2e,
-  0x01, 0x35, 0x19, 0x01, 0x34, 0x36, 0x37, 0x36, 0x21, 0x20, 0x02, 0x10,
-  0x01, 0xea, 0xa4, 0x34, 0x1c, 0x19, 0x02, 0x17, 0x1c, 0x34, 0xa6, 0xfe,
-  0x16, 0xa3, 0x35, 0x1b, 0x1b, 0x01, 0x01, 0x19, 0x1c, 0x34, 0x03, 0x81,
-  0x1c, 0x32, 0xa6, 0xf4, 0xf6, 0xa3, 0x35, 0x1b, 0xd4, 0x01, 0x15, 0x01,
-  0x13, 0xd5, 0x1c, 0x32, 0xa6, 0xf4, 0xf6, 0xa3, 0x35, 0x1b, 0xd4, 0x01,
-  0x15, 0x01, 0x13, 0x09, 0xfd, 0xed, 0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13,
-  0xb9, 0x9a, 0x9a, 0xfb, 0xe0, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x29,
-  0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x26, 0x9a, 0xba, 0x02, 0x13, 0xb9,
-  0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x04, 0x22, 0x67, 0x65,
-  0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65, 0x65,
-  0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x05, 0x03, 0x5d, 0x1d, 0x1c, 0x19, 0x0e,
-  0x0e, 0x16, 0x1c, 0x1d, 0x5d, 0x5d, 0x1e, 0x1b, 0x18, 0x0c, 0x0f, 0x18,
-  0x1c, 0x1d, 0xfe, 0x1c, 0x1b, 0x1c, 0x5d, 0x5d, 0x1e, 0x1a, 0x63, 0xfc,
-  0x1b, 0x1c, 0x5d, 0x5d, 0x1e, 0x1a, 0x63, 0x04, 0x65, 0x68, 0x56, 0x63,
-  0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x63, 0x56, 0xfe, 0x7c, 0x93, 0x60,
-  0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20, 0xfe,
-  0xc1, 0x93, 0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78,
-  0x78, 0x20, 0x03, 0x5a, 0x39, 0x88, 0x51, 0xfe, 0xa2, 0xfe, 0xa2, 0x4e,
-  0x88, 0x39, 0x73, 0x73, 0x39, 0x88, 0x4e, 0x01, 0x5e, 0x01, 0x5e, 0x51,
-  0x88, 0x39, 0x73, 0x00, 0x00, 0x03, 0x00, 0x9d, 0xff, 0xe3, 0x04, 0xa9,
-  0x06, 0xbe, 0x00, 0x0b, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x13, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x00, 0x23, 0x22, 0x00, 0x10, 0x37, 0x36, 0x37,
-  0x0b, 0x01, 0x35, 0x09, 0x01, 0x15, 0x0b, 0x01, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x02, 0xa3, 0x3a, 0x57, 0x55,
-  0x3c, 0x3f, 0x52, 0x55, 0x15, 0xa3, 0x79, 0x98, 0xfe, 0xd2, 0xd7, 0xd4,
-  0xfe, 0xcf, 0x98, 0x7a, 0xa2, 0x01, 0xed, 0x01, 0x3f, 0x01, 0x3f, 0xee,
-  0x51, 0x94, 0xcf, 0xcf, 0x94, 0x91, 0xd2, 0xd2, 0x01, 0x7d, 0x5b, 0x44,
-  0x3e, 0x58, 0x55, 0x41, 0x42, 0x5d, 0x02, 0xbb, 0x11, 0x7e, 0x9d, 0xee,
-  0xef, 0xfe, 0xb4, 0x01, 0x4c, 0x01, 0xde, 0x9c, 0x7e, 0x12, 0x01, 0x67,
-  0xfe, 0xfa, 0xc7, 0x01, 0x5d, 0xfe, 0xa3, 0xc7, 0x01, 0x05, 0xfa, 0xf7,
-  0xe4, 0xa4, 0xa3, 0xd8, 0xd8, 0xa3, 0xa4, 0xe4, 0x00, 0x03, 0x00, 0x13,
-  0x01, 0x85, 0x05, 0xc8, 0x05, 0x14, 0x00, 0x50, 0x00, 0x6a, 0x00, 0x85,
-  0x00, 0x00, 0x01, 0x27, 0x23, 0x22, 0x27, 0x26, 0x07, 0x06, 0x14, 0x07,
-  0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x1f, 0x01, 0x16, 0x33,
-  0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x26, 0x27, 0x26, 0x27, 0x26, 0x2f,
-  0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x3e, 0x01, 0x37, 0x36,
-  0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x0e, 0x01, 0x07, 0x06,
-  0x17, 0x16, 0x1f, 0x01, 0x21, 0x32, 0x17, 0x16, 0x17, 0x21, 0x17, 0x25,
-  0x16, 0x33, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x34, 0x27, 0x26, 0x27,
-  0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x14, 0x17, 0x1e,
-  0x01, 0x01, 0x26, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x14, 0x17,
-  0x16, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x34,
-  0x27, 0x26, 0x27, 0x26, 0x03, 0x6c, 0xc1, 0x67, 0x9d, 0x19, 0x26, 0x03,
-  0x01, 0x09, 0x0b, 0x2c, 0x20, 0x19, 0x27, 0x20, 0x21, 0x20, 0x17, 0x13,
-  0x15, 0x10, 0x0b, 0x0b, 0x2c, 0x20, 0x1a, 0x26, 0x1f, 0x09, 0x50, 0x58,
-  0x51, 0x21, 0x0d, 0x13, 0x22, 0x02, 0x03, 0x06, 0x0c, 0x0b, 0x14, 0x46,
-  0x4b, 0x2d, 0x2c, 0x17, 0x19, 0x0e, 0x11, 0x0b, 0x0c, 0x2f, 0x1c, 0x20,
-  0x41, 0x40, 0x18, 0x1c, 0x0c, 0x10, 0x0b, 0x08, 0x1b, 0x03, 0x04, 0x1e,
-  0x25, 0x62, 0x4a, 0x01, 0x64, 0xd0, 0x47, 0x5b, 0x10, 0xfd, 0xa5, 0xbf,
-  0xfc, 0x72, 0x13, 0x12, 0x16, 0x0e, 0x13, 0x1a, 0x05, 0x04, 0x0b, 0x08,
-  0x0e, 0x0f, 0x28, 0x0f, 0x12, 0x12, 0x13, 0x17, 0x07, 0x05, 0x0c, 0x08,
-  0x1c, 0x01, 0x11, 0x10, 0x15, 0x19, 0x0b, 0x13, 0x1b, 0x03, 0x05, 0x0b,
-  0x09, 0x0e, 0x0d, 0x27, 0x12, 0x14, 0x10, 0x13, 0x19, 0x04, 0x06, 0x0c,
-  0x09, 0x0d, 0x0a, 0x01, 0x85, 0xcd, 0x06, 0x08, 0x0d, 0x08, 0x29, 0x17,
-  0x20, 0x2e, 0x0d, 0x0b, 0x0f, 0x0e, 0x19, 0x15, 0x24, 0x1d, 0x4a, 0x1e,
-  0x20, 0x2e, 0x0d, 0x0b, 0x03, 0x25, 0x27, 0x03, 0x05, 0x1c, 0x07, 0x08,
-  0x2e, 0x13, 0x13, 0x13, 0x44, 0x22, 0x14, 0x14, 0x18, 0x1b, 0x1e, 0x26,
-  0x42, 0x1d, 0x20, 0x31, 0x0a, 0x0b, 0x1e, 0x18, 0x1e, 0x1c, 0x24, 0x43,
-  0x1e, 0x17, 0x1d, 0x07, 0x0d, 0x16, 0x1a, 0x6d, 0x52, 0x20, 0x29, 0x4b,
-  0xcf, 0x79, 0x09, 0x05, 0x07, 0x18, 0x10, 0x11, 0x1f, 0x17, 0x12, 0x0d,
-  0x10, 0x10, 0x06, 0x06, 0x17, 0x11, 0x11, 0x20, 0x16, 0x12, 0x1c, 0x02,
-  0xb5, 0x09, 0x05, 0x07, 0x19, 0x0f, 0x11, 0x21, 0x15, 0x12, 0x0e, 0x0d,
-  0x12, 0x05, 0x07, 0x19, 0x0e, 0x12, 0x20, 0x16, 0x12, 0x0e, 0x09, 0x00,
-  0x00, 0x03, 0x00, 0x4d, 0x01, 0x21, 0x05, 0xa5, 0x04, 0xb5, 0x00, 0x15,
-  0x00, 0x64, 0x00, 0x7a, 0x00, 0x00, 0x12, 0x32, 0x36, 0x37, 0x3e, 0x01,
-  0x35, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x22, 0x06, 0x07, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x17, 0x16, 0x01, 0x05, 0x06, 0x23, 0x22, 0x27, 0x25, 0x07,
-  0x0e, 0x01, 0x15, 0x14, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x3b, 0x01, 0x32, 0x37, 0x3e, 0x02, 0x34, 0x2e, 0x01, 0x27, 0x26,
-  0x2b, 0x01, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06,
-  0x15, 0x14, 0x16, 0x1f, 0x01, 0x25, 0x36, 0x33, 0x32, 0x17, 0x24, 0x22,
-  0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x1e, 0x01, 0x32, 0x36,
-  0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0xe4, 0x29, 0x22, 0x0f,
-  0x0f, 0x0e, 0x0e, 0x0f, 0x0f, 0x22, 0x29, 0x22, 0x0f, 0x0f, 0x0f, 0x0f,
-  0x0f, 0x0f, 0x02, 0xb4, 0x02, 0x2e, 0x27, 0x62, 0x49, 0xc5, 0xfe, 0xb5,
-  0x5f, 0x87, 0x48, 0x0f, 0x19, 0x19, 0x14, 0x24, 0x1d, 0x47, 0x1d, 0x1f,
-  0x19, 0x18, 0x1b, 0x1a, 0x19, 0x14, 0x24, 0x1d, 0x09, 0x57, 0x4d, 0x5c,
-  0x18, 0x22, 0x16, 0x16, 0x22, 0x18, 0x58, 0x51, 0x30, 0x30, 0x1d, 0x24,
-  0x14, 0x19, 0x1a, 0x1b, 0x18, 0x19, 0x1f, 0x1d, 0x47, 0x1d, 0x24, 0x14,
-  0x19, 0x19, 0x0f, 0x48, 0x87, 0x5f, 0x01, 0x4b, 0xc5, 0x49, 0x62, 0x27,
-  0xfb, 0x69, 0x29, 0x22, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x22, 0x29,
-  0x22, 0x0f, 0x0f, 0x0e, 0x0e, 0x0f, 0x0f, 0x01, 0x71, 0x0e, 0x0d, 0x0e,
-  0x1f, 0x13, 0x12, 0x1f, 0x0e, 0x0d, 0x0e, 0x0e, 0x0d, 0x0e, 0x1f, 0x12,
-  0x13, 0x1f, 0x0e, 0x0d, 0x01, 0x6c, 0xfc, 0x3f, 0x57, 0x92, 0x2c, 0x3e,
-  0x0e, 0x0e, 0x08, 0x26, 0x19, 0x23, 0x3c, 0x1a, 0x15, 0x10, 0x0d, 0x0d,
-  0x0e, 0x17, 0x15, 0x41, 0x23, 0x22, 0x3c, 0x1a, 0x15, 0x10, 0x0d, 0x22,
-  0x09, 0x1a, 0x28, 0x10, 0x28, 0x1a, 0x09, 0x22, 0x0d, 0x10, 0x15, 0x1a,
-  0x3c, 0x22, 0x23, 0x41, 0x15, 0x17, 0x0e, 0x0d, 0x0d, 0x10, 0x15, 0x1a,
-  0x3c, 0x23, 0x19, 0x26, 0x08, 0x0e, 0x0e, 0x3e, 0x2c, 0x92, 0x57, 0x3f,
-  0x7e, 0x0e, 0x0d, 0x0e, 0x1f, 0x13, 0x12, 0x1f, 0x0e, 0x0d, 0x0e, 0x0e,
-  0x0d, 0x0e, 0x1f, 0x12, 0x13, 0x1f, 0x0e, 0x0d, 0x00, 0x03, 0x00, 0x13,
-  0x00, 0xc0, 0x05, 0xc8, 0x04, 0x4f, 0x00, 0x4f, 0x00, 0x6a, 0x00, 0x85,
-  0x00, 0x00, 0x01, 0x33, 0x07, 0x21, 0x06, 0x07, 0x06, 0x23, 0x21, 0x07,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x0e, 0x01, 0x22, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x27, 0x2e, 0x01,
-  0x27, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x06, 0x23, 0x22, 0x27, 0x2e, 0x01,
-  0x27, 0x26, 0x34, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x17, 0x1e,
-  0x01, 0x17, 0x16, 0x14, 0x17, 0x16, 0x37, 0x36, 0x3b, 0x01, 0x25, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x33, 0x32,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x23,
-  0x22, 0x13, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x2e, 0x01, 0x27,
-  0x26, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x1e, 0x01,
-  0x17, 0x16, 0x33, 0x32, 0x03, 0x6c, 0xc0, 0xbf, 0x02, 0x5b, 0x10, 0x5b,
-  0x47, 0xd0, 0xfe, 0x9c, 0x4a, 0x5a, 0x2d, 0x1a, 0x1e, 0x08, 0x0b, 0x10,
-  0x0c, 0x1c, 0x18, 0x40, 0x41, 0x20, 0x1c, 0x32, 0x09, 0x0b, 0x11, 0x0b,
-  0x1c, 0x17, 0x08, 0x51, 0x4b, 0x46, 0x14, 0x0b, 0x0c, 0x06, 0x03, 0x02,
-  0x1a, 0x1b, 0x08, 0x26, 0x51, 0x58, 0x2c, 0x2d, 0x1f, 0x27, 0x19, 0x20,
-  0x2c, 0x0b, 0x0b, 0x10, 0x10, 0x2f, 0x20, 0x21, 0x20, 0x27, 0x19, 0x20,
-  0x2c, 0x0b, 0x09, 0x01, 0x06, 0x23, 0x16, 0xa0, 0x67, 0xfd, 0xf3, 0x12,
-  0x0e, 0x08, 0x0e, 0x0c, 0x05, 0x07, 0x14, 0x16, 0x0f, 0x15, 0x13, 0x25,
-  0x0e, 0x0e, 0x08, 0x0c, 0x05, 0x07, 0x13, 0x18, 0x0f, 0x15, 0x12, 0xec,
-  0x13, 0x0e, 0x08, 0x0e, 0x0c, 0x06, 0x06, 0x19, 0x11, 0x10, 0x14, 0x13,
-  0x26, 0x0d, 0x0e, 0x09, 0x0b, 0x05, 0x06, 0x1b, 0x10, 0x12, 0x12, 0x0d,
-  0x04, 0x4f, 0xcf, 0x4b, 0x29, 0x20, 0x52, 0x64, 0x23, 0x14, 0x0f, 0x06,
-  0x1e, 0x17, 0x21, 0x3e, 0x26, 0x1c, 0x1e, 0x18, 0x1e, 0x0b, 0x0a, 0x33,
-  0x1e, 0x22, 0x39, 0x2a, 0x1b, 0x1e, 0x18, 0x04, 0x24, 0x22, 0x44, 0x13,
-  0x13, 0x13, 0x2e, 0x08, 0x07, 0x16, 0x0b, 0x03, 0x27, 0x14, 0x14, 0x0b,
-  0x0e, 0x2d, 0x20, 0x20, 0x44, 0x21, 0x20, 0x32, 0x0e, 0x0f, 0x0b, 0x0d,
-  0x2e, 0x20, 0x17, 0x2c, 0x05, 0x0e, 0x09, 0x06, 0x54, 0x08, 0x0e, 0x08,
-  0x18, 0x13, 0x25, 0x0f, 0x11, 0x15, 0x08, 0x06, 0x12, 0x0e, 0x0d, 0x12,
-  0x16, 0x23, 0x0e, 0x12, 0x15, 0x08, 0x05, 0xfd, 0x3a, 0x09, 0x0d, 0x08,
-  0x18, 0x13, 0x26, 0x0f, 0x10, 0x19, 0x05, 0x05, 0x12, 0x0d, 0x0e, 0x12,
-  0x13, 0x28, 0x0c, 0x11, 0x19, 0x05, 0x05, 0x00, 0x00, 0x09, 0x00, 0x41,
-  0x00, 0xf4, 0x05, 0xf0, 0x04, 0xe8, 0x00, 0x5a, 0x00, 0x78, 0x00, 0x96,
-  0x00, 0xb4, 0x00, 0xd2, 0x00, 0xfe, 0x01, 0x2d, 0x01, 0x34, 0x01, 0x48,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x26, 0x2b, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x16, 0x1f, 0x01, 0x25, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x0d, 0x01, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x25,
-  0x07, 0x06, 0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x37, 0x36, 0x02, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x12, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x12, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x05, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x37, 0x36, 0x03, 0x2d, 0x01, 0x26, 0x23, 0x22, 0x07,
-  0x05, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x07,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x25, 0x05, 0x16, 0x33, 0x32, 0x37, 0x25, 0x26,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x02, 0x0e, 0x0a, 0x07, 0x07,
-  0x0a, 0x08, 0x16, 0x49, 0x53, 0x3c, 0x29, 0x28, 0x21, 0x24, 0x1f, 0x11,
-  0x10, 0x10, 0x0e, 0x24, 0x19, 0x2a, 0x26, 0x2b, 0x29, 0x28, 0x27, 0x1e,
-  0x24, 0x0c, 0x10, 0x05, 0x2a, 0x80, 0x4f, 0x01, 0x3a, 0xcc, 0x52, 0x7b,
-  0x33, 0x07, 0x1b, 0xfe, 0x35, 0x01, 0xcb, 0x1b, 0x07, 0x36, 0x78, 0x52,
-  0xcc, 0xfe, 0xc6, 0x4f, 0x80, 0x2a, 0x05, 0x10, 0x11, 0x1f, 0x20, 0x25,
-  0x2b, 0x26, 0x2e, 0x23, 0x25, 0x1f, 0x25, 0x0c, 0x10, 0x10, 0x0e, 0x22,
-  0x19, 0x2c, 0x26, 0x2b, 0x3c, 0x4a, 0x52, 0x15, 0xfa, 0x19, 0x0a, 0x0b,
-  0x08, 0x09, 0x03, 0x03, 0x03, 0x03, 0x09, 0x08, 0x0b, 0x0a, 0x19, 0x0a,
-  0x0a, 0x09, 0x08, 0x03, 0x03, 0x03, 0x03, 0x08, 0x09, 0x0a, 0x0a, 0x19,
-  0x0a, 0x0b, 0x08, 0x09, 0x03, 0x03, 0x03, 0x03, 0x09, 0x08, 0x0b, 0x0a,
-  0x19, 0x0a, 0x0a, 0x09, 0x08, 0x03, 0x03, 0x03, 0x03, 0x08, 0x09, 0x0a,
-  0x2d, 0x2d, 0x13, 0x12, 0x10, 0x11, 0x08, 0x08, 0x08, 0x08, 0x11, 0x10,
-  0x12, 0x13, 0x2d, 0x13, 0x13, 0x10, 0x11, 0x08, 0x08, 0x08, 0x08, 0x11,
-  0x10, 0x13, 0x13, 0x2d, 0x13, 0x12, 0x10, 0x11, 0x08, 0x08, 0x08, 0x08,
-  0x11, 0x10, 0x12, 0x13, 0x2d, 0x13, 0x13, 0x10, 0x11, 0x08, 0x08, 0x08,
-  0x08, 0x11, 0x10, 0x13, 0x01, 0x5f, 0x21, 0x86, 0x23, 0x14, 0x0a, 0x0e,
-  0x0a, 0x05, 0x0c, 0x0b, 0x19, 0x12, 0x22, 0x1c, 0x42, 0x1c, 0x1d, 0x18,
-  0x16, 0x0e, 0x0b, 0x0b, 0x0c, 0x18, 0x12, 0x23, 0x1c, 0x21, 0x3c, 0x53,
-  0x5a, 0x1b, 0x10, 0x15, 0x06, 0x20, 0x19, 0xaa, 0x01, 0xbc, 0x02, 0x22,
-  0x26, 0x54, 0x47, 0xc3, 0xfe, 0xb6, 0x86, 0x10, 0x0f, 0x15, 0x12, 0x19,
-  0x5e, 0x4f, 0x3c, 0x21, 0x1c, 0x23, 0x12, 0x18, 0x0c, 0x0b, 0x0b, 0x0e,
-  0x16, 0x18, 0x1d, 0x1c, 0x42, 0x1c, 0x22, 0x12, 0x19, 0x0b, 0x0c, 0x05,
-  0x0a, 0x0e, 0x0b, 0x01, 0x6b, 0x01, 0x02, 0xc3, 0x47, 0x54, 0x26, 0xfe,
-  0x14, 0xc4, 0x04, 0x06, 0x08, 0x08, 0x14, 0x08, 0x08, 0x05, 0x05, 0x05,
-  0x05, 0x08, 0x08, 0x14, 0x08, 0x08, 0x06, 0x02, 0xd9, 0x08, 0x0d, 0x0e,
-  0x07, 0x06, 0x0a, 0x20, 0x10, 0x0d, 0x22, 0x1c, 0x29, 0x26, 0x60, 0x26,
-  0x22, 0x27, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1f, 0x24, 0x22, 0x2f, 0x27,
-  0x1d, 0x12, 0x09, 0x3c, 0x25, 0x8b, 0x5a, 0x53, 0x0d, 0x11, 0x1f, 0x0c,
-  0xcf, 0xcf, 0x0c, 0x25, 0x0d, 0x0b, 0x53, 0x5a, 0x8b, 0x25, 0x3c, 0x09,
-  0x18, 0x17, 0x2f, 0x27, 0x2a, 0x1d, 0x20, 0x0e, 0x10, 0x10, 0x11, 0x1c,
-  0x22, 0x25, 0x35, 0x22, 0x2d, 0x28, 0x24, 0x23, 0x1b, 0x13, 0x10, 0x20,
-  0x09, 0xfe, 0xd2, 0x04, 0x05, 0x08, 0x07, 0x07, 0x04, 0x08, 0x07, 0x05,
-  0x06, 0x08, 0x07, 0x05, 0x04, 0x04, 0x05, 0x08, 0x07, 0x07, 0x04, 0x07,
-  0x08, 0x05, 0x06, 0x08, 0x07, 0x05, 0x02, 0x3b, 0x04, 0x05, 0x08, 0x07,
-  0x07, 0x04, 0x07, 0x08, 0x05, 0x06, 0x08, 0x07, 0x05, 0x04, 0x04, 0x05,
-  0x08, 0x07, 0x07, 0x04, 0x08, 0x07, 0x05, 0x06, 0x08, 0x07, 0x05, 0xfd,
-  0x82, 0x07, 0x08, 0x0e, 0x10, 0x11, 0x12, 0x16, 0x15, 0x12, 0x11, 0x10,
-  0x0e, 0x08, 0x07, 0x07, 0x08, 0x0e, 0x10, 0x11, 0x12, 0x15, 0x16, 0x12,
-  0x11, 0x10, 0x0e, 0x08, 0x02, 0x38, 0x07, 0x08, 0x0e, 0x10, 0x11, 0x12,
-  0x15, 0x16, 0x12, 0x11, 0x10, 0x0e, 0x08, 0x07, 0x07, 0x08, 0x0e, 0x10,
-  0x11, 0x12, 0x16, 0x15, 0x12, 0x11, 0x10, 0x0e, 0x08, 0x5c, 0x0f, 0x3d,
-  0x07, 0x04, 0x06, 0x08, 0x0e, 0x0a, 0x18, 0x0e, 0x17, 0x21, 0x1c, 0x1b,
-  0x19, 0x13, 0x10, 0x0c, 0x0c, 0x0e, 0x16, 0x13, 0x20, 0x1c, 0x21, 0x20,
-  0x1c, 0x1b, 0x19, 0x13, 0x10, 0x0c, 0x22, 0x0a, 0x0e, 0x11, 0x08, 0x18,
-  0x11, 0xfe, 0xf2, 0xc2, 0xf7, 0x2f, 0x56, 0x92, 0x43, 0x1e, 0x1e, 0x0f,
-  0x0e, 0x0a, 0x22, 0x0c, 0x10, 0x13, 0x19, 0x1b, 0x1c, 0x20, 0x21, 0x1c,
-  0x20, 0x13, 0x16, 0x0e, 0x0c, 0x0c, 0x10, 0x13, 0x19, 0x1b, 0x1c, 0x21,
-  0x17, 0x0d, 0x19, 0x0a, 0x14, 0x02, 0x02, 0x5b, 0x75, 0x56, 0x2f, 0xe1,
-  0x2b, 0x16, 0x09, 0x09, 0x06, 0x05, 0x05, 0x06, 0x09, 0x09, 0x16, 0x09,
-  0x09, 0x06, 0x05, 0x05, 0x06, 0x09, 0x00, 0x00, 0x00, 0x03, 0x00, 0x4d,
-  0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x61, 0x00, 0x75, 0x00, 0x87,
-  0x00, 0x00, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17,
-  0x15, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06,
-  0x20, 0x27, 0x2e, 0x02, 0x35, 0x34, 0x36, 0x37, 0x26, 0x35, 0x34, 0x37,
-  0x12, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x07,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x16, 0x17,
-  0x16, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x36, 0x37, 0x36, 0x35, 0x34, 0x01, 0xde, 0x03, 0x0b, 0x13, 0x11, 0x12,
-  0x16, 0x64, 0x00, 0xff, 0x6d, 0x6c, 0x58, 0x5a, 0x57, 0x55, 0x5c, 0x56,
-  0x6e, 0x6c, 0x7c, 0x78, 0x70, 0x6b, 0x58, 0x5a, 0x58, 0x46, 0x27, 0x60,
-  0x67, 0x63, 0x6a, 0x61, 0x7f, 0x7e, 0x8c, 0x8b, 0x80, 0x78, 0x68, 0x65,
-  0x67, 0x63, 0x69, 0x63, 0x7d, 0x7f, 0xfe, 0xe6, 0x7c, 0x26, 0x3d, 0x21,
-  0x1d, 0x19, 0x03, 0x61, 0xa3, 0x98, 0x49, 0x05, 0x0f, 0x21, 0x1e, 0x08,
-  0x31, 0x26, 0x1c, 0x3d, 0x39, 0x0f, 0x10, 0x14, 0x1e, 0x30, 0x23, 0x10,
-  0x0f, 0x44, 0x15, 0x24, 0x2d, 0x17, 0x14, 0x03, 0x29, 0x05, 0x10, 0x01,
-  0x0a, 0x11, 0x18, 0x1f, 0x1d, 0x11, 0x03, 0x03, 0x18, 0x01, 0x75, 0x37,
-  0x14, 0x0f, 0x13, 0x0c, 0x1b, 0x09, 0x19, 0x09, 0x34, 0x0f, 0x1a, 0x1b,
-  0x01, 0x37, 0x06, 0x1e, 0x1b, 0x1c, 0x32, 0x12, 0x13, 0x0b, 0x33, 0x33,
-  0x31, 0x63, 0x64, 0xed, 0x88, 0x8d, 0xe8, 0x69, 0x60, 0x34, 0x33, 0x33,
-  0x31, 0x63, 0x64, 0xed, 0x8d, 0x87, 0xbc, 0x3e, 0x98, 0x6d, 0x01, 0x10,
-  0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x3b, 0x38, 0x72, 0x6f,
-  0xfe, 0xec, 0xa1, 0x98, 0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x12,
-  0x42, 0x56, 0x30, 0x2f, 0x4d, 0x1f, 0x10, 0x0f, 0xcd, 0xef, 0x01, 0x90,
-  0x08, 0x14, 0x38, 0x3a, 0x44, 0x40, 0x2a, 0x1f, 0x7c, 0x73, 0x61, 0x20,
-  0x16, 0x1b, 0x1e, 0x09, 0x2d, 0x46, 0x28, 0x1c, 0x37, 0x0c, 0x22, 0x2a,
-  0x3d, 0x38, 0x19, 0x26, 0x08, 0x15, 0x0f, 0x30, 0x21, 0x32, 0x1d, 0x1c,
-  0x01, 0x06, 0x04, 0x20, 0x16, 0x11, 0x0c, 0x31, 0x2d, 0x35, 0x24, 0x26,
-  0x0c, 0x0a, 0x12, 0x36, 0x3a, 0x42, 0x34, 0x00, 0x00, 0x06, 0x00, 0x4d,
-  0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x0d, 0x00, 0x1a, 0x00, 0x28,
-  0x00, 0x42, 0x00, 0x5c, 0x00, 0x77, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x27,
-  0x25, 0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x13, 0x26,
-  0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x13, 0x36, 0x33, 0x32, 0x17, 0x13,
-  0x05, 0x0e, 0x01, 0x07, 0x25, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35,
-  0x34, 0x26, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36,
-  0x37, 0x36, 0x37, 0x13, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14,
-  0x16, 0x17, 0x1e, 0x01, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x17, 0x16, 0x12,
-  0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26,
-  0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x36, 0x01, 0x7e, 0x38, 0x23,
-  0x05, 0x01, 0x0c, 0x07, 0x22, 0x21, 0x1d, 0x2c, 0x12, 0x07, 0xdb, 0x21,
-  0x28, 0x27, 0x5e, 0x26, 0x29, 0x20, 0x3f, 0x2e, 0x31, 0x33, 0x2d, 0x7a,
-  0x01, 0x0c, 0x02, 0x25, 0x39, 0xfe, 0xb6, 0x0d, 0x0d, 0x2c, 0x1d, 0x20,
-  0x22, 0xfd, 0x38, 0x18, 0x18, 0x14, 0x13, 0x14, 0x14, 0x13, 0x14, 0x18,
-  0x18, 0x38, 0x17, 0x18, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x18, 0x33,
-  0x78, 0x70, 0x6b, 0x58, 0x5a, 0x58, 0x59, 0x59, 0x56, 0xda, 0xf6, 0x6d,
-  0x6c, 0x58, 0x5a, 0x57, 0x55, 0x5c, 0x56, 0x6e, 0x6c, 0x7c, 0x8b, 0x80,
-  0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x63, 0x7d, 0x7f, 0xfe, 0xea, 0x80,
-  0x79, 0x67, 0x65, 0x68, 0x63, 0x6a, 0x61, 0x7f, 0x7e, 0x01, 0x77, 0x49,
-  0x5f, 0x0f, 0xfd, 0x1e, 0x22, 0x32, 0x5b, 0x24, 0x20, 0x16, 0x09, 0x01,
-  0x01, 0xa3, 0x22, 0x14, 0x13, 0x13, 0x14, 0x22, 0x01, 0x83, 0x09, 0x09,
-  0xfe, 0x0b, 0xfd, 0x07, 0x67, 0x49, 0x83, 0x04, 0x06, 0x16, 0x20, 0x24,
-  0x5b, 0x32, 0x21, 0x76, 0x0b, 0x0c, 0x15, 0x17, 0x35, 0x1f, 0x1e, 0x35,
-  0x17, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x17, 0x35, 0x1e, 0x1f, 0x35,
-  0x17, 0x15, 0x0c, 0x02, 0x15, 0x33, 0x31, 0x63, 0x64, 0xed, 0x8d, 0x85,
-  0xf1, 0x63, 0x61, 0x66, 0x33, 0x31, 0x63, 0x64, 0xed, 0x88, 0x8d, 0xe8,
-  0x69, 0x60, 0x34, 0x33, 0x64, 0x3b, 0x38, 0x72, 0x6f, 0xfe, 0xec, 0xa1,
-  0x98, 0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x38, 0x72, 0x6f, 0x01,
-  0x14, 0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x6c, 0x00, 0x2c, 0x05, 0xa1, 0x05, 0xaa, 0x00, 0x2d,
-  0x00, 0x00, 0x13, 0x35, 0x37, 0x27, 0x33, 0x17, 0x36, 0x25, 0x02, 0x03,
-  0x33, 0x17, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x17, 0x33, 0x32,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x07, 0x33, 0x15, 0x23, 0x07,
-  0x33, 0x15, 0x23, 0x07, 0x23, 0x12, 0x13, 0x24, 0x27, 0x07, 0x23, 0x37,
-  0x85, 0x21, 0x3a, 0x5a, 0x83, 0x84, 0x01, 0x01, 0x30, 0x99, 0x6e, 0x68,
-  0x85, 0x4d, 0x5a, 0x8a, 0x53, 0x88, 0xee, 0x3f, 0x2b, 0x1d, 0x1d, 0x2b,
-  0x3f, 0xee, 0x88, 0x53, 0x8a, 0x5a, 0x4d, 0x85, 0x68, 0x6e, 0x99, 0x30,
-  0xfe, 0xff, 0x84, 0x83, 0x5a, 0x3a, 0x02, 0xd7, 0x28, 0x05, 0xda, 0xc9,
-  0x0d, 0x0a, 0x01, 0x14, 0x01, 0x6a, 0x96, 0x50, 0x82, 0x50, 0xc6, 0x1a,
-  0x11, 0x2c, 0x11, 0x1a, 0xc6, 0x50, 0x82, 0x50, 0x96, 0x01, 0x60, 0x01,
-  0x1e, 0x0b, 0x0c, 0xc9, 0xda, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x76,
-  0x00, 0xdc, 0x05, 0x92, 0x04, 0xf9, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x22,
-  0x00, 0x29, 0x00, 0x2d, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x01, 0x11, 0x01,
-  0x16, 0x15, 0x14, 0x05, 0x01, 0x21, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x01, 0x11, 0x01, 0x26, 0x35, 0x34,
-  0x01, 0x11, 0x21, 0x11, 0x03, 0x91, 0x01, 0x8c, 0xfb, 0xcf, 0x01, 0x8c,
-  0x06, 0x07, 0x1a, 0x21, 0x1f, 0x4a, 0x20, 0x26, 0x14, 0x07, 0x2b, 0x01,
-  0x83, 0xfe, 0x7d, 0x02, 0xfe, 0xc3, 0xfe, 0x72, 0x04, 0x31, 0xfe, 0x72,
-  0x06, 0x06, 0x1a, 0x20, 0x20, 0x4a, 0x1f, 0x21, 0x1a, 0x06, 0x2c, 0xfe,
-  0x7e, 0x01, 0x82, 0x03, 0xfe, 0x27, 0x05, 0x1b, 0x03, 0x68, 0x01, 0x2c,
-  0xfe, 0xd4, 0x09, 0x08, 0x1c, 0x10, 0x0f, 0x0f, 0x13, 0x19, 0x09, 0xaa,
-  0xfe, 0xde, 0x02, 0x8d, 0xfe, 0xdd, 0x11, 0x12, 0x13, 0x6b, 0xfe, 0xd3,
-  0x01, 0x2d, 0x08, 0x07, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x07, 0xaa,
-  0x01, 0x22, 0xfd, 0x73, 0x01, 0x21, 0x13, 0x13, 0x12, 0xfd, 0xdf, 0x04,
-  0x1d, 0xfb, 0xe3, 0x00, 0x00, 0x04, 0x01, 0x87, 0x00, 0x00, 0x04, 0x0a,
-  0x05, 0xef, 0x00, 0x50, 0x00, 0xd0, 0x00, 0xe3, 0x00, 0xf3, 0x00, 0x00,
-  0x01, 0x34, 0x37, 0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x33, 0x17, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x1f, 0x01, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x03, 0x14, 0x15, 0x14, 0x1f, 0x01,
-  0x16, 0x15, 0x14, 0x07, 0x17, 0x16, 0x07, 0x06, 0x1d, 0x01, 0x21, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x27, 0x26, 0x01, 0x26, 0x23,
-  0x22, 0x0f, 0x01, 0x14, 0x0f, 0x01, 0x06, 0x0f, 0x01, 0x27, 0x26, 0x2f,
-  0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x1f, 0x02, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
-  0x07, 0x06, 0x07, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x26, 0x27, 0x26, 0x27, 0x26, 0x3f, 0x01, 0x36, 0x27, 0x26,
-  0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x17, 0x16,
-  0x17, 0x16, 0x1f, 0x01, 0x16, 0x15, 0x07, 0x21, 0x27, 0x34, 0x37, 0x36,
-  0x3d, 0x01, 0x27, 0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x35, 0x13,
-  0x34, 0x35, 0x34, 0x27, 0x01, 0x07, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x07,
-  0x06, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x2f, 0x01, 0x01, 0x88, 0x21, 0x15, 0x0f, 0x2f, 0x0c, 0x29, 0x01,
-  0x02, 0x04, 0x18, 0x24, 0x1b, 0x12, 0x1f, 0x15, 0x18, 0x20, 0x0f, 0x10,
-  0x2b, 0x0f, 0x43, 0x44, 0x22, 0x0d, 0x0d, 0x10, 0x06, 0x05, 0x09, 0x04,
-  0x0b, 0x05, 0x01, 0x01, 0x1c, 0x18, 0x25, 0x32, 0x1a, 0x0b, 0x01, 0x09,
-  0x01, 0x08, 0x02, 0x02, 0x03, 0x01, 0x03, 0x01, 0x14, 0x02, 0xfe, 0x15,
-  0x04, 0x09, 0x21, 0x2b, 0x18, 0x10, 0x02, 0x46, 0x03, 0x23, 0x20, 0x03,
-  0x05, 0x0a, 0x1f, 0x05, 0x13, 0x31, 0x16, 0x08, 0x27, 0x0f, 0x29, 0x44,
-  0x18, 0x12, 0x0f, 0x0d, 0x0f, 0x07, 0x07, 0x1b, 0x0b, 0x11, 0x56, 0x7a,
-  0x56, 0x54, 0x04, 0x12, 0x05, 0x03, 0x14, 0x10, 0x05, 0x03, 0x2b, 0x67,
-  0x2f, 0x06, 0x26, 0x1b, 0x11, 0x0b, 0x06, 0x05, 0x02, 0x07, 0x2c, 0x24,
-  0x0c, 0x07, 0x29, 0x2d, 0x01, 0x13, 0x0d, 0x01, 0x30, 0x15, 0x16, 0x30,
-  0x09, 0x02, 0x19, 0x70, 0x2a, 0x05, 0x07, 0x0c, 0x02, 0x06, 0x02, 0x07,
-  0x06, 0x0d, 0x1a, 0x24, 0x0c, 0x0e, 0x15, 0x10, 0x2c, 0x08, 0x03, 0x01,
-  0x09, 0x07, 0x03, 0x09, 0x53, 0x01, 0x01, 0x01, 0x80, 0x01, 0x0b, 0x0c,
-  0x02, 0x03, 0x08, 0x05, 0x0b, 0x02, 0xfe, 0x32, 0x10, 0x20, 0x34, 0x32,
-  0x0f, 0x03, 0x01, 0x10, 0x09, 0x0a, 0x03, 0x02, 0x0b, 0x04, 0x06, 0x61,
-  0x73, 0x0e, 0x02, 0x4a, 0x23, 0x0d, 0x0a, 0x0e, 0x08, 0x03, 0x0b, 0x07,
-  0x0a, 0x6c, 0x02, 0xeb, 0x37, 0x31, 0x07, 0x1f, 0x5d, 0x18, 0x17, 0x01,
-  0x01, 0x2f, 0x7e, 0x5b, 0x23, 0x3c, 0x24, 0x1c, 0x1b, 0x20, 0x05, 0x0c,
-  0x1a, 0x6f, 0xbb, 0x5f, 0x25, 0x15, 0x10, 0x40, 0x2c, 0x1f, 0x10, 0x86,
-  0x3a, 0x06, 0x0b, 0x0a, 0x06, 0x06, 0x24, 0x22, 0x1e, 0x3b, 0x1a, 0x12,
-  0x76, 0x52, 0x15, 0x12, 0xfe, 0xd4, 0x07, 0x09, 0x18, 0x1d, 0x16, 0x24,
-  0x58, 0x24, 0x2b, 0x7c, 0x19, 0x89, 0x13, 0x8d, 0x89, 0xb6, 0x12, 0x21,
-  0x35, 0x44, 0x58, 0x26, 0x50, 0x59, 0x3b, 0x02, 0xb6, 0x39, 0x44, 0x6f,
-  0x1e, 0x36, 0xc2, 0x1d, 0x06, 0x0f, 0x0b, 0x0d, 0x62, 0x27, 0x6e, 0x95,
-  0x32, 0x0f, 0x0c, 0x0b, 0x06, 0x0b, 0x1f, 0x38, 0x1a, 0x33, 0xfe, 0x65,
-  0x46, 0x5d, 0x0c, 0x08, 0x13, 0x04, 0x01, 0x14, 0x06, 0x07, 0x34, 0x54,
-  0x26, 0x03, 0x1f, 0x16, 0x0a, 0x07, 0x0c, 0x16, 0x26, 0x20, 0x12, 0x0c,
-  0x2f, 0x35, 0x30, 0x24, 0x3f, 0x2d, 0x20, 0x02, 0x31, 0x40, 0x1b, 0x11,
-  0x26, 0x11, 0x06, 0x05, 0x10, 0x09, 0x33, 0x6c, 0x0f, 0x0a, 0x17, 0x17,
-  0x4b, 0x0f, 0x0b, 0x0a, 0x05, 0x19, 0x03, 0x05, 0x0d, 0x43, 0x04, 0x22,
-  0x50, 0x31, 0x16, 0xd6, 0x09, 0x0b, 0x9f, 0xb7, 0x3a, 0x30, 0x33, 0x3c,
-  0x08, 0x44, 0x3a, 0x35, 0x58, 0x49, 0x2e, 0x29, 0x06, 0x07, 0x01, 0x44,
-  0x04, 0x07, 0x13, 0x26, 0xfe, 0x5b, 0x14, 0x2b, 0x2d, 0x31, 0x3a, 0x0d,
-  0x0c, 0x11, 0x10, 0x09, 0x09, 0x15, 0x17, 0x09, 0x05, 0x71, 0x12, 0x14,
-  0x2f, 0x41, 0x38, 0x09, 0x12, 0x0a, 0x0a, 0x12, 0x11, 0x0b, 0x06, 0x67,
-  0x00, 0x08, 0x00, 0x26, 0x00, 0xa9, 0x05, 0xc6, 0x05, 0x6c, 0x00, 0x06,
-  0x00, 0x39, 0x00, 0x4c, 0x00, 0x70, 0x00, 0x7b, 0x00, 0x7f, 0x00, 0x89,
-  0x00, 0x8d, 0x00, 0x00, 0x13, 0x16, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01,
-  0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x0f,
-  0x01, 0x13, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x07, 0x17, 0x16, 0x33, 0x32, 0x37, 0x33, 0x16, 0x15, 0x14, 0x07, 0x23,
-  0x35, 0x06, 0x25, 0x36, 0x37, 0x36, 0x37, 0x01, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x0f, 0x01, 0x16, 0x15, 0x14, 0x07, 0x36, 0x01, 0x22, 0x2f,
-  0x01, 0x07, 0x14, 0x07, 0x36, 0x37, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x07, 0x16, 0x15, 0x14, 0x07, 0x32, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x06, 0x37, 0x16, 0x15,
-  0x14, 0x07, 0x15, 0x33, 0x36, 0x35, 0x34, 0x27, 0x05, 0x36, 0x37, 0x0f,
-  0x01, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x36, 0x35, 0x34, 0x05, 0x07,
-  0x37, 0x26, 0xc2, 0x19, 0x12, 0x0d, 0x0e, 0x03, 0x18, 0x2a, 0x62, 0x2b,
-  0x1a, 0x22, 0x87, 0x43, 0x1d, 0x5a, 0x4a, 0x22, 0x50, 0xed, 0x74, 0x06,
-  0x0d, 0x3e, 0x19, 0x17, 0x54, 0x6e, 0x3a, 0x3c, 0x1f, 0x20, 0x2f, 0x38,
-  0x89, 0x29, 0x35, 0x21, 0x1b, 0x0c, 0xab, 0xb8, 0x27, 0x24, 0x31, 0x05,
-  0xcb, 0x50, 0x38, 0xdf, 0x62, 0xfd, 0x0f, 0x1e, 0x1b, 0x07, 0x05, 0x01,
-  0x2c, 0x20, 0x0f, 0x1c, 0x50, 0xd4, 0x30, 0x1f, 0x12, 0x2a, 0x27, 0x24,
-  0x03, 0x4d, 0x2f, 0x17, 0xd9, 0x68, 0x4b, 0x39, 0x4f, 0x0e, 0x21, 0x4c,
-  0x74, 0x38, 0x16, 0x1f, 0x12, 0x67, 0x43, 0x39, 0x43, 0x24, 0x57, 0x29,
-  0x2a, 0x2f, 0x7c, 0x26, 0x2d, 0x16, 0x43, 0x2d, 0x29, 0x8e, 0x2b, 0x38,
-  0xfd, 0x05, 0x4b, 0x0c, 0x92, 0x51, 0x65, 0x2b, 0x1c, 0x27, 0x15, 0xfe,
-  0xc3, 0x2c, 0x54, 0x06, 0x01, 0xf0, 0x03, 0x27, 0x1f, 0x1f, 0x20, 0x10,
-  0xfe, 0xc7, 0x0e, 0x05, 0x10, 0x08, 0x3b, 0x63, 0x73, 0x01, 0x0c, 0x12,
-  0x20, 0x1a, 0x2f, 0xe8, 0x5e, 0x22, 0x7c, 0x59, 0x2f, 0x1a, 0x0d, 0x34,
-  0xab, 0x32, 0x38, 0x19, 0x1d, 0xdb, 0x87, 0x1d, 0x1e, 0x83, 0xb4, 0xcf,
-  0x95, 0x6c, 0x25, 0xe9, 0x25, 0x6f, 0x1d, 0x0f, 0x01, 0x74, 0x1e, 0x0e,
-  0xe9, 0x35, 0x6f, 0x41, 0x3d, 0x27, 0x59, 0x24, 0x09, 0x01, 0x61, 0x10,
-  0x9d, 0x85, 0xa3, 0x54, 0x02, 0x2a, 0x0d, 0x16, 0x12, 0x10, 0x27, 0x01,
-  0x27, 0x47, 0x2b, 0x2d, 0x0d, 0x0b, 0x0c, 0x06, 0x25, 0x5f, 0x6b, 0x6a,
-  0x7e, 0x07, 0x1d, 0x72, 0x8d, 0x7d, 0x6a, 0x4c, 0x60, 0xd0, 0x86, 0x7c,
-  0xef, 0x5c, 0x67, 0xc3, 0x4b, 0x1a, 0x40, 0x2f, 0x1e, 0x14, 0x03, 0x2e,
-  0x38, 0x35, 0x96, 0x63, 0x28, 0x24, 0x00, 0x00, 0x00, 0x07, 0x00, 0xa3,
-  0x00, 0x9a, 0x05, 0x37, 0x05, 0xaf, 0x00, 0x13, 0x00, 0x19, 0x00, 0x20,
-  0x00, 0x28, 0x00, 0x32, 0x00, 0x4c, 0x00, 0x53, 0x00, 0x00, 0x01, 0x3e,
-  0x01, 0x35, 0x34, 0x2f, 0x01, 0x06, 0x23, 0x14, 0x07, 0x06, 0x23, 0x14,
-  0x07, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x3f, 0x01, 0x0f, 0x02, 0x13,
-  0x37, 0x01, 0x13, 0x25, 0x01, 0x13, 0x05, 0x01, 0x33, 0x32, 0x35, 0x34,
-  0x27, 0x01, 0x00, 0x36, 0x35, 0x34, 0x27, 0x01, 0x07, 0x01, 0x16, 0x33,
-  0x01, 0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x0e,
-  0x01, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37,
-  0x3e, 0x01, 0x17, 0x07, 0x01, 0x16, 0x33, 0x32, 0x27, 0x04, 0xa1, 0x07,
-  0x0b, 0x01, 0x36, 0x14, 0x1b, 0x31, 0x30, 0x42, 0x14, 0xd5, 0x07, 0x07,
-  0x09, 0x17, 0xfc, 0xda, 0x89, 0x0c, 0x83, 0x8a, 0x0c, 0x76, 0xef, 0x02,
-  0x3d, 0xa6, 0xfd, 0xa9, 0xfd, 0xc4, 0x0f, 0x01, 0x91, 0x01, 0xd8, 0x02,
-  0x39, 0x02, 0xfd, 0xfb, 0x01, 0x7a, 0x31, 0x06, 0xfe, 0x2f, 0x66, 0x01,
-  0xd2, 0x0f, 0x0d, 0xfd, 0xb0, 0x0c, 0x1c, 0x0e, 0x0c, 0x09, 0x0d, 0x0f,
-  0x05, 0x05, 0x11, 0x0d, 0x0c, 0x1a, 0x10, 0x0c, 0x08, 0x0d, 0x0e, 0x03,
-  0x05, 0x12, 0x28, 0x72, 0x02, 0x04, 0x0a, 0x09, 0x34, 0x01, 0x01, 0x40,
-  0x08, 0x1c, 0x0a, 0x05, 0x08, 0xee, 0x17, 0x48, 0x36, 0x37, 0x1c, 0x18,
-  0x3b, 0x02, 0x0b, 0x02, 0xf9, 0x98, 0x92, 0x0d, 0x98, 0x92, 0x01, 0x7a,
-  0x12, 0xfd, 0x83, 0xfd, 0x68, 0xb8, 0x02, 0x7c, 0x01, 0x09, 0x14, 0xfd,
-  0xf3, 0x38, 0x0a, 0x0c, 0x02, 0x3e, 0xfc, 0xb6, 0x36, 0x21, 0x0f, 0x11,
-  0x02, 0x06, 0x71, 0xfd, 0xfa, 0x06, 0x02, 0xea, 0x0d, 0x15, 0x05, 0x04,
-  0x11, 0x0d, 0x0a, 0x0e, 0x10, 0x1f, 0x0d, 0x0e, 0x14, 0x05, 0x04, 0x0e,
-  0x10, 0x0b, 0x0d, 0x10, 0x1e, 0xf4, 0x0e, 0xfd, 0xc2, 0x02, 0x42, 0x00,
-  0x00, 0x07, 0x00, 0x2f, 0x01, 0x96, 0x05, 0xe7, 0x04, 0x3e, 0x00, 0x11,
-  0x00, 0x17, 0x00, 0x1e, 0x00, 0x25, 0x00, 0x2b, 0x00, 0x3f, 0x00, 0x46,
-  0x00, 0x00, 0x00, 0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x14, 0x07, 0x16,
-  0x14, 0x07, 0x16, 0x15, 0x37, 0x36, 0x37, 0x36, 0x05, 0x35, 0x27, 0x07,
-  0x15, 0x17, 0x03, 0x37, 0x21, 0x09, 0x01, 0x21, 0x27, 0x01, 0x21, 0x36,
-  0x35, 0x34, 0x27, 0x21, 0x00, 0x34, 0x27, 0x21, 0x15, 0x21, 0x24, 0x34,
-  0x36, 0x37, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07,
-  0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x17, 0x07, 0x21, 0x36, 0x35, 0x34,
-  0x27, 0x05, 0x13, 0x07, 0x06, 0x04, 0x09, 0xbd, 0x13, 0x2e, 0x2e, 0x13,
-  0xbd, 0x09, 0x04, 0x06, 0xfc, 0x16, 0x55, 0x54, 0x54, 0x9d, 0x9d, 0x02,
-  0xfd, 0x02, 0x1c, 0xfd, 0xe4, 0xfd, 0x03, 0x9d, 0x01, 0x28, 0x02, 0x6f,
-  0x16, 0x1f, 0xfd, 0x52, 0x02, 0xf6, 0x2d, 0xfd, 0x9a, 0x02, 0x66, 0xfc,
-  0xc7, 0x06, 0x08, 0x06, 0x10, 0x12, 0x10, 0x07, 0x07, 0x06, 0x06, 0x07,
-  0x07, 0x10, 0x12, 0x10, 0x06, 0x08, 0xb2, 0x48, 0x02, 0xae, 0x1f, 0x16,
-  0x02, 0xde, 0x18, 0x15, 0x09, 0x07, 0x06, 0x7e, 0x21, 0x14, 0x38, 0x90,
-  0x38, 0x14, 0x21, 0x7e, 0x06, 0x07, 0x09, 0x4b, 0xd8, 0x70, 0x70, 0xd8,
-  0x70, 0x01, 0x68, 0xc8, 0xfe, 0xac, 0xfe, 0xac, 0xc8, 0x01, 0x2c, 0x19,
-  0x17, 0x1b, 0x19, 0xfe, 0xc4, 0x70, 0x18, 0xa0, 0x3c, 0x28, 0x23, 0x0f,
-  0x0e, 0x10, 0x10, 0x0e, 0x0f, 0x23, 0x28, 0x23, 0x0f, 0x0e, 0x10, 0x10,
-  0x0e, 0x0f, 0x69, 0x64, 0x19, 0x1b, 0x17, 0x19, 0x00, 0x07, 0x00, 0xa3,
-  0x00, 0x9a, 0x05, 0x37, 0x05, 0xaf, 0x00, 0x13, 0x00, 0x19, 0x00, 0x20,
-  0x00, 0x28, 0x00, 0x32, 0x00, 0x4c, 0x00, 0x53, 0x00, 0x00, 0x01, 0x2e,
-  0x01, 0x23, 0x22, 0x0f, 0x01, 0x16, 0x15, 0x32, 0x17, 0x16, 0x15, 0x32,
-  0x17, 0x37, 0x36, 0x35, 0x34, 0x26, 0x01, 0x27, 0x1f, 0x02, 0x27, 0x07,
-  0x27, 0x03, 0x01, 0x25, 0x03, 0x01, 0x27, 0x17, 0x01, 0x36, 0x35, 0x34,
-  0x2b, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x01, 0x17, 0x01, 0x36, 0x35,
-  0x01, 0x2e, 0x01, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x1e,
-  0x01, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27,
-  0x2e, 0x01, 0x13, 0x01, 0x36, 0x23, 0x22, 0x07, 0x01, 0x04, 0xa1, 0x08,
-  0x17, 0x09, 0x07, 0x07, 0xd5, 0x14, 0x42, 0x30, 0x31, 0x1b, 0x14, 0x36,
-  0x01, 0x0b, 0xfc, 0xcb, 0x84, 0x0c, 0x8a, 0x83, 0x0c, 0x97, 0xb2, 0x0f,
-  0x02, 0x3c, 0x02, 0x57, 0xa6, 0xfd, 0xc3, 0x10, 0x0c, 0x02, 0x05, 0x02,
-  0x39, 0x02, 0x21, 0x31, 0x1e, 0x0d, 0x0f, 0xfe, 0x2e, 0x66, 0x01, 0xd1,
-  0x06, 0xfd, 0x61, 0x0c, 0x12, 0x05, 0x03, 0x0e, 0x0d, 0x08, 0x0c, 0x10,
-  0x1a, 0x0c, 0x0d, 0x11, 0x05, 0x05, 0x0f, 0x0d, 0x09, 0x0c, 0x0e, 0x1c,
-  0x10, 0x01, 0xd8, 0x01, 0x34, 0x09, 0x0a, 0xfd, 0xfc, 0x05, 0x09, 0x09,
-  0x0b, 0x02, 0x3b, 0x18, 0x1c, 0x37, 0x36, 0x48, 0x17, 0xee, 0x08, 0x05,
-  0x0a, 0x1c, 0xfd, 0x18, 0x0d, 0x92, 0x98, 0x0d, 0x92, 0xd5, 0xc6, 0x01,
-  0x09, 0x02, 0x7c, 0xb8, 0xfd, 0x68, 0xfd, 0x83, 0xec, 0x7f, 0x02, 0x3e,
-  0x0c, 0x0a, 0x38, 0x88, 0x36, 0x06, 0xfd, 0xfa, 0x71, 0x02, 0x06, 0x11,
-  0x0f, 0xfd, 0x6d, 0x0e, 0x1e, 0x10, 0x0d, 0x0b, 0x10, 0x0e, 0x04, 0x05,
-  0x14, 0x0e, 0x0d, 0x1f, 0x10, 0x0e, 0x0a, 0x0d, 0x11, 0x04, 0x05, 0x15,
-  0x01, 0x0f, 0x02, 0x0c, 0x42, 0x02, 0xfd, 0xc2, 0x00, 0x02, 0x00, 0x4f,
-  0x01, 0x7b, 0x05, 0x73, 0x04, 0x5b, 0x00, 0x25, 0x00, 0x47, 0x00, 0x00,
-  0x12, 0x10, 0x27, 0x32, 0x33, 0x20, 0x25, 0x01, 0x15, 0x25, 0x2e, 0x01,
-  0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x14, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x25, 0x15, 0x01, 0x24, 0x21,
-  0x22, 0x23, 0x12, 0x14, 0x07, 0x32, 0x33, 0x32, 0x05, 0x25, 0x05, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x05, 0x25, 0x04, 0x23, 0x22, 0x23,
-  0x7c, 0x2d, 0x07, 0x07, 0x01, 0x07, 0x01, 0xe2, 0x02, 0x2d, 0xfd, 0xf9,
-  0x05, 0x0c, 0x11, 0x0b, 0x1b, 0x0c, 0x0d, 0x09, 0x0a, 0x0a, 0x0c, 0x08,
-  0x09, 0x0d, 0x0c, 0x1b, 0x0b, 0x11, 0x0c, 0x05, 0x02, 0x07, 0xfd, 0xd3,
-  0xfe, 0x1e, 0xfe, 0xf9, 0x07, 0x07, 0x8a, 0x15, 0x04, 0x04, 0xa0, 0x01,
-  0xda, 0x01, 0x8b, 0xfe, 0xc0, 0x14, 0x19, 0x17, 0x38, 0x17, 0x18, 0x14,
-  0x14, 0x14, 0x14, 0x14, 0x14, 0x18, 0x17, 0x38, 0x17, 0x19, 0x14, 0x01,
-  0x40, 0xfe, 0x75, 0xfe, 0x26, 0xa0, 0x04, 0x04, 0x02, 0x49, 0x01, 0x44,
-  0x60, 0x6e, 0xfe, 0xed, 0x53, 0x1c, 0x08, 0x10, 0x08, 0x06, 0x06, 0x06,
-  0x0a, 0x09, 0x1d, 0x20, 0x1f, 0x07, 0x0a, 0x06, 0x06, 0x06, 0x08, 0x10,
-  0x08, 0x1c, 0x53, 0xfe, 0xed, 0x6e, 0x01, 0x47, 0x8a, 0x59, 0x6e, 0xb9,
-  0x18, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x17, 0x35, 0x3e, 0x35, 0x17,
-  0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x18, 0xb9, 0x6e, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x7c, 0x01, 0xad, 0x05, 0x73, 0x04, 0x29, 0x00, 0x28,
-  0x00, 0x00, 0x01, 0x25, 0x15, 0x01, 0x24, 0x23, 0x22, 0x23, 0x36, 0x34,
-  0x27, 0x32, 0x33, 0x32, 0x25, 0x01, 0x15, 0x25, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x03, 0x84, 0x01, 0xef, 0xfd,
-  0xd3, 0xfe, 0x21, 0xdf, 0x06, 0x06, 0x2d, 0x2d, 0x06, 0x06, 0xdf, 0x01,
-  0xdf, 0x02, 0x2d, 0xfe, 0x11, 0x06, 0x0e, 0x0c, 0x11, 0x0f, 0x26, 0x0f,
-  0x10, 0x0d, 0x0d, 0x0e, 0x0e, 0x0d, 0x0d, 0x10, 0x0f, 0x26, 0x0f, 0x11,
-  0x0c, 0x0e, 0x02, 0xc5, 0x1c, 0x21, 0xfe, 0xed, 0x6e, 0x60, 0xe0, 0x60,
-  0x6e, 0xfe, 0xed, 0x21, 0x1d, 0x11, 0x0f, 0x0e, 0x08, 0x08, 0x08, 0x08,
-  0x0e, 0x0f, 0x23, 0x15, 0x14, 0x23, 0x0f, 0x0e, 0x08, 0x08, 0x08, 0x08,
-  0x0e, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x14, 0x00, 0xc6, 0x04, 0xcf,
-  0x05, 0x0a, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x12, 0x13, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x00, 0x01,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01,
-  0x98, 0x23, 0x12, 0x24, 0x0f, 0x0c, 0x0c, 0xfd, 0xd7, 0x38, 0x7a, 0x1c,
-  0x14, 0x1d, 0xfe, 0xa4, 0xfe, 0xd7, 0x14, 0x40, 0x41, 0x0c, 0x1f, 0x29,
-  0x2f, 0x3f, 0x27, 0x02, 0x8e, 0x40, 0x78, 0x14, 0x01, 0xc2, 0x01, 0x16,
-  0x48, 0x0c, 0x09, 0x0e, 0x29, 0xfe, 0x30, 0xfd, 0xfc, 0x24, 0x06, 0x0f,
-  0x8a, 0x99, 0x27, 0x2a, 0x27, 0x18, 0x00, 0x00, 0x00, 0x01, 0x00, 0xd5,
-  0x00, 0xb2, 0x05, 0x32, 0x05, 0x0c, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x12, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x00, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x33, 0x01, 0x98, 0x23, 0x12, 0x24, 0x0f, 0x0c,
-  0x0c, 0xfd, 0xd7, 0x5b, 0x57, 0x72, 0x17, 0x0a, 0x14, 0xfd, 0xbd, 0x6f,
-  0x26, 0x88, 0x2d, 0x32, 0x15, 0x33, 0x41, 0x3f, 0x57, 0x2b, 0x03, 0x1a,
-  0x40, 0x78, 0x14, 0x01, 0x9d, 0xaf, 0x4a, 0x08, 0x03, 0x16, 0x12, 0x1b,
-  0xfd, 0x1e, 0xde, 0x4c, 0x1a, 0x0c, 0x8d, 0xb2, 0x86, 0x31, 0x20, 0x2c,
-  0x00, 0x01, 0x00, 0xe9, 0x00, 0x94, 0x05, 0x20, 0x05, 0x41, 0x00, 0x0b,
-  0x00, 0x00, 0x09, 0x01, 0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x37, 0x09,
-  0x01, 0x17, 0x03, 0x83, 0x01, 0x9b, 0x7f, 0xfe, 0x65, 0xfe, 0x65, 0x80,
-  0x01, 0x9b, 0xfe, 0x65, 0x80, 0x01, 0x9b, 0x01, 0x9c, 0x7f, 0x02, 0xea,
-  0xfe, 0x37, 0x8d, 0x01, 0xc9, 0xfe, 0x37, 0x8d, 0x01, 0xc9, 0x01, 0xc9,
-  0x8d, 0xfe, 0x38, 0x01, 0xc9, 0x8d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
-  0x00, 0x3f, 0x05, 0x6b, 0x05, 0x96, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x0b,
-  0x04, 0x1c, 0x01, 0x4f, 0xfe, 0xe8, 0xfe, 0xb1, 0xfe, 0xb1, 0xfe, 0xe9,
-  0x01, 0x4e, 0xfe, 0xb2, 0x01, 0x17, 0x01, 0x4f, 0x01, 0x4f, 0x01, 0x18,
-  0x02, 0xea, 0xfe, 0x8c, 0xfe, 0xc9, 0x01, 0x74, 0xfe, 0x8c, 0x01, 0x37,
-  0x01, 0x74, 0x01, 0x74, 0x01, 0x37, 0xfe, 0x8c, 0x01, 0x75, 0xfe, 0xc9,
-  0x00, 0x01, 0x00, 0xd8, 0xff, 0xee, 0x05, 0x0d, 0x05, 0xdc, 0x00, 0x42,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x0f, 0x01,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x03,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x12, 0x13,
-  0x02, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x04, 0x79, 0x09,
-  0x0e, 0x10, 0x10, 0x1a, 0x0f, 0x0e, 0x17, 0x0e, 0x13, 0xbc, 0xb0, 0x49,
-  0x81, 0x0a, 0x1b, 0x1c, 0x03, 0x14, 0x17, 0x0b, 0x17, 0x12, 0x6c, 0x73,
-  0x9b, 0xc8, 0x1d, 0x44, 0x21, 0x03, 0x2e, 0x0a, 0x04, 0x19, 0xb7, 0xcd,
-  0x6d, 0x24, 0x09, 0x11, 0x11, 0x0e, 0x0e, 0x14, 0x08, 0x0c, 0x10, 0x1a,
-  0x1c, 0x09, 0x31, 0x4f, 0x80, 0xb8, 0x15, 0x05, 0xdc, 0x10, 0x10, 0x1a,
-  0x33, 0x1b, 0x11, 0x15, 0x1b, 0x17, 0xe2, 0xfe, 0xf1, 0xc6, 0xef, 0x14,
-  0x0c, 0x17, 0x19, 0x16, 0x0c, 0x14, 0x1e, 0x10, 0x12, 0x1a, 0x9a, 0xd0,
-  0xe0, 0xfe, 0x8a, 0x36, 0x2a, 0x1c, 0x3d, 0x50, 0x1f, 0x0e, 0x2a, 0x01,
-  0x3e, 0x01, 0x0a, 0x01, 0x22, 0x9d, 0x23, 0x0a, 0x0e, 0x1a, 0x1a, 0x1d,
-  0x11, 0x0c, 0x10, 0x1e, 0xa8, 0x98, 0xb8, 0xcc, 0x18, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xe2, 0x00, 0x00, 0x05, 0x6e, 0x05, 0xea, 0x00, 0x52,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x36, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x02, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x27,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x26, 0x03, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x12, 0x37,
-  0x36, 0x04, 0xcc, 0x1a, 0x18, 0x12, 0x07, 0x18, 0x09, 0x1c, 0x0d, 0x0d,
-  0x0f, 0xd9, 0xd3, 0x85, 0x85, 0x0f, 0x1a, 0x12, 0x22, 0x02, 0x0c, 0x16,
-  0x1d, 0x20, 0x1b, 0x07, 0x0d, 0x20, 0x18, 0x15, 0x18, 0x50, 0x6d, 0xcf,
-  0x4f, 0x0f, 0x13, 0x02, 0x10, 0x0f, 0x0e, 0x02, 0x12, 0x10, 0x16, 0x1a,
-  0x21, 0x1b, 0x08, 0x08, 0x10, 0x15, 0x75, 0xb1, 0x6e, 0x59, 0x14, 0x15,
-  0x0e, 0x14, 0x17, 0x2c, 0x01, 0x09, 0x15, 0x0f, 0x27, 0x0c, 0x5f, 0x87,
-  0xd0, 0xe0, 0x0b, 0x05, 0xea, 0x1e, 0x16, 0x3a, 0x01, 0x05, 0x0c, 0x0e,
-  0x0d, 0x15, 0x28, 0x10, 0xdb, 0xfe, 0xc7, 0xcc, 0xa2, 0x12, 0x18, 0x31,
-  0x1a, 0x11, 0x02, 0x11, 0x23, 0x3a, 0x18, 0x12, 0x0b, 0x1b, 0x1c, 0x5f,
-  0xbf, 0xfe, 0xfb, 0x87, 0x1a, 0x24, 0x1f, 0x0d, 0x0c, 0x1e, 0x23, 0x11,
-  0x1b, 0x2d, 0x03, 0x0d, 0x18, 0x18, 0x15, 0x1f, 0xb0, 0xd4, 0xbd, 0x01,
-  0x0b, 0x3d, 0x1c, 0x1a, 0x31, 0x20, 0x27, 0x0e, 0x19, 0x32, 0x1a, 0xc4,
-  0xba, 0x01, 0x08, 0xda, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x64,
-  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
-  0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x11, 0x21, 0x03, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21,
-  0x11, 0x33, 0x03, 0xca, 0xfe, 0x74, 0xfe, 0x81, 0x01, 0x7f, 0x01, 0x8c,
-  0x01, 0x80, 0xfe, 0xc8, 0x01, 0x92, 0xfe, 0x6e, 0xfd, 0xe4, 0xfe, 0x6f,
-  0x01, 0x91, 0x02, 0x1c, 0xb4, 0x01, 0x92, 0xfe, 0x6e, 0xb4, 0xfe, 0x6f,
-  0x01, 0x91, 0xb4, 0x03, 0xc6, 0x01, 0xab, 0xfe, 0x55, 0xfe, 0x48, 0xfe,
-  0x56, 0x01, 0xaa, 0x01, 0xb8, 0x50, 0xfd, 0xa8, 0xfe, 0x42, 0x01, 0xbe,
-  0x02, 0x58, 0x01, 0xbf, 0xfd, 0x79, 0xc8, 0xfe, 0x42, 0x01, 0xbe, 0xc8,
-  0x01, 0xbf, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x03, 0xb8, 0x01, 0xec, 0xfe, 0x14,
-  0xfe, 0x98, 0xfe, 0x15, 0x01, 0xeb, 0x01, 0x68, 0x03, 0xb2, 0xfe, 0x70,
-  0xfd, 0xde, 0x02, 0x22, 0x01, 0x90, 0x02, 0x23, 0x00, 0x02, 0x00, 0x64,
-  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
-  0x01, 0x33, 0x35, 0x23, 0x37, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x35, 0x21, 0x11, 0x33, 0x02, 0x99, 0xd6, 0xd6, 0xd7, 0x02, 0x34, 0xfd,
-  0xcc, 0xd8, 0xfd, 0xcd, 0x02, 0x33, 0xd8, 0x02, 0x73, 0xee, 0x01, 0xf0,
-  0xfd, 0x8e, 0x02, 0x72, 0xf0, 0x02, 0x73, 0x00, 0x00, 0x02, 0x00, 0x64,
-  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
-  0x01, 0x21, 0x11, 0x21, 0x25, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x11, 0x21, 0x11, 0x21, 0x02, 0x51, 0x01, 0x66, 0xfe, 0x9a, 0x01, 0x67,
-  0x01, 0xec, 0xfe, 0x14, 0xfe, 0x98, 0xfe, 0x15, 0x01, 0xeb, 0x01, 0x68,
-  0x02, 0x23, 0x01, 0x8e, 0x01, 0xfe, 0x70, 0xfd, 0xde, 0x02, 0x22, 0x01,
-  0x90, 0x02, 0x23, 0x00, 0x00, 0x01, 0x01, 0x30, 0x00, 0x00, 0x04, 0xd9,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x03, 0x70, 0x01, 0x68, 0xfe, 0x98,
-  0xd8, 0xfe, 0x98, 0x01, 0x68, 0xd8, 0x04, 0x45, 0xf0, 0xfc, 0xab, 0x03,
-  0x55, 0xf0, 0x01, 0x90, 0x00, 0x02, 0x00, 0xf1, 0x00, 0x00, 0x04, 0xe2,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x33, 0x17, 0x11,
-  0x21, 0x11, 0x21, 0x27, 0x11, 0x23, 0x27, 0x11, 0x21, 0x11, 0x21, 0x17,
-  0x07, 0x11, 0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11, 0x21, 0x35,
-  0x03, 0xd3, 0x87, 0x87, 0xfe, 0xf2, 0xfe, 0xb3, 0x87, 0x87, 0x87, 0x01,
-  0x0e, 0x01, 0x4d, 0x87, 0xb4, 0xc6, 0xfe, 0xf2, 0x01, 0x0e, 0xc6, 0x01,
-  0x0e, 0x04, 0xa9, 0x96, 0xfe, 0x8e, 0xfd, 0x5f, 0x96, 0x02, 0x0b, 0x96,
-  0x01, 0x72, 0x01, 0x2c, 0x96, 0xfa, 0x01, 0x2c, 0xfe, 0xd4, 0xdc, 0xfd,
-  0x5f, 0x02, 0xa1, 0xdc, 0x00, 0x03, 0x01, 0x1e, 0x00, 0x00, 0x04, 0xeb,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x27, 0x33,
-  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x03, 0x33,
-  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x03, 0xa6,
-  0xfe, 0xbc, 0xfc, 0xfc, 0x01, 0x44, 0xfc, 0xb4, 0xfc, 0xfc, 0xfe, 0x2c,
-  0xfc, 0xfc, 0x01, 0xd4, 0x90, 0xfc, 0xfc, 0xb4, 0xfc, 0xfc, 0xb4, 0x04,
-  0x6d, 0x01, 0x18, 0xfe, 0xe8, 0xfe, 0x84, 0xfd, 0x5f, 0x02, 0xa1, 0x01,
-  0x7c, 0x50, 0xfd, 0xe4, 0xfd, 0x5f, 0x02, 0xa1, 0x02, 0x1c, 0x01, 0x18,
-  0xfe, 0x48, 0xdc, 0xfd, 0x5f, 0x02, 0xa1, 0xdc, 0x01, 0x18, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x4b,
-  0x00, 0x00, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x07,
-  0x11, 0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x3b, 0x01, 0x35, 0x34,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x27, 0x21, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x1d, 0x01, 0x33, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x35, 0x37, 0x11, 0x27, 0x26, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x2b, 0x01,
-  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x17, 0x21, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x02, 0xc1, 0x6f, 0x5a, 0xa1, 0x42,
-  0x3b, 0x28, 0x20, 0x2d, 0x16, 0x17, 0x20, 0x26, 0x3d, 0x3e, 0xa1, 0x5e,
-  0x6f, 0x45, 0x40, 0x3c, 0x55, 0x4a, 0x19, 0x48, 0x04, 0x09, 0x31, 0x30,
-  0x4a, 0x56, 0x3c, 0x42, 0x42, 0x6e, 0x5e, 0xa1, 0x3e, 0x3d, 0x26, 0x21,
-  0x2d, 0x17, 0x16, 0x21, 0x27, 0x3c, 0x3f, 0xa4, 0x5a, 0x6e, 0x44, 0x40,
-  0x3c, 0x56, 0x4a, 0x18, 0x49, 0xfb, 0xf7, 0x30, 0x31, 0x4a, 0x55, 0x3c,
-  0x42, 0x43, 0x02, 0xa0, 0x4b, 0x49, 0x42, 0x60, 0x4f, 0x1b, 0x54, 0x04,
-  0x7c, 0x38, 0x37, 0x4f, 0x5c, 0x46, 0x47, 0x4b, 0x7a, 0x64, 0xb6, 0x47,
-  0x42, 0x2b, 0x25, 0x32, 0x19, 0x19, 0x25, 0x2b, 0x42, 0x49, 0xb4, 0x64,
-  0x7a, 0x4b, 0x47, 0x46, 0x5c, 0x4f, 0x1b, 0x54, 0xfb, 0x84, 0x38, 0x37,
-  0x4f, 0x60, 0x42, 0x48, 0x4c, 0x7b, 0x64, 0xb6, 0x47, 0x42, 0x2b, 0x25,
-  0x32, 0x19, 0x19, 0x25, 0x2b, 0x42, 0x49, 0xb4, 0x64, 0x00, 0x00, 0x00,
-  0x00, 0x08, 0x00, 0xa8, 0xff, 0xe5, 0x05, 0x61, 0x05, 0xf3, 0x00, 0x0b,
-  0x00, 0x11, 0x00, 0x14, 0x00, 0x17, 0x00, 0x1a, 0x00, 0x1d, 0x00, 0x20,
-  0x00, 0x23, 0x00, 0x00, 0x01, 0x13, 0x21, 0x03, 0x13, 0x21, 0x0b, 0x01,
-  0x21, 0x13, 0x03, 0x21, 0x17, 0x03, 0x13, 0x21, 0x13, 0x0b, 0x01, 0x07,
-  0x33, 0x1f, 0x01, 0x37, 0x03, 0x07, 0x33, 0x05, 0x23, 0x17, 0x03, 0x27,
-  0x07, 0x13, 0x37, 0x23, 0x03, 0x04, 0xca, 0x01, 0x92, 0xca, 0xca, 0xfe,
-  0x6e, 0xca, 0xc9, 0xfe, 0x6d, 0xca, 0xca, 0x01, 0x93, 0x34, 0x96, 0x96,
-  0x01, 0x2b, 0x95, 0x95, 0x96, 0x61, 0xc2, 0x9c, 0x62, 0x61, 0x61, 0x62,
-  0xc3, 0xfe, 0xa1, 0xc2, 0x61, 0xfd, 0x62, 0x61, 0x61, 0x62, 0xc3, 0x05,
-  0xf3, 0xfe, 0x7c, 0xfe, 0x7d, 0xfe, 0x7d, 0xfe, 0x7c, 0x01, 0x84, 0x01,
-  0x83, 0x01, 0x83, 0x64, 0xfe, 0xe1, 0xfe, 0xe0, 0x01, 0x20, 0x01, 0x1f,
-  0x01, 0x1f, 0xbb, 0x64, 0xbb, 0xbb, 0xfe, 0x7d, 0xbc, 0x63, 0xbc, 0x01,
-  0x1f, 0xbc, 0xbc, 0x01, 0x84, 0xbb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b,
-  0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x43, 0x00, 0x00, 0x01, 0x35,
-  0x34, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x1d, 0x01, 0x33, 0x32, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x2b, 0x01, 0x15, 0x14, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x3d, 0x01, 0x23, 0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x02, 0xd7, 0x44, 0x28, 0x31, 0x32,
-  0x6c, 0x33, 0x30, 0x27, 0x45, 0x1d, 0xa7, 0x6e, 0x3f, 0x6a, 0x5a, 0x2c,
-  0x2b, 0x2b, 0x2c, 0x5a, 0x6a, 0x3f, 0x6e, 0xa7, 0x1d, 0x45, 0x27, 0x30,
-  0x33, 0x6c, 0x32, 0x31, 0x28, 0x44, 0x1d, 0xa7, 0x6e, 0x3f, 0x6a, 0x5a,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x5a, 0x6a, 0x3f, 0x6e, 0xa7, 0x03, 0x1c, 0x20,
-  0xba, 0x7a, 0x46, 0x76, 0x64, 0x30, 0x30, 0x30, 0x30, 0x64, 0x76, 0x46,
-  0x7a, 0xba, 0x20, 0x4c, 0x2c, 0x36, 0x38, 0x78, 0x38, 0x36, 0x2c, 0x4c,
-  0x20, 0xbb, 0x79, 0x46, 0x76, 0x64, 0x30, 0x31, 0x31, 0x30, 0x64, 0x76,
-  0x46, 0x79, 0xbb, 0x20, 0x4c, 0x2c, 0x36, 0x38, 0x78, 0x38, 0x36, 0x2c,
-  0x4c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4d, 0xff, 0xe7, 0x05, 0xbb,
-  0x05, 0xf0, 0x00, 0x83, 0x00, 0x00, 0x01, 0x26, 0x27, 0x23, 0x06, 0x07,
-  0x06, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x33, 0x36, 0x37, 0x36, 0x37, 0x35, 0x26, 0x27, 0x26, 0x27, 0x2e,
-  0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x15, 0x16,
-  0x17, 0x16, 0x17, 0x33, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x06, 0x07, 0x06, 0x07,
-  0x15, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x35, 0x26, 0x02, 0xb5, 0x0e, 0x09, 0xbf, 0x02,
-  0x09, 0x12, 0x1a, 0x1d, 0x4a, 0x29, 0x29, 0x49, 0x1d, 0x1c, 0x10, 0x10,
-  0x10, 0x10, 0x1c, 0x1d, 0x49, 0x29, 0x29, 0x4a, 0x1d, 0x1e, 0x0e, 0x08,
-  0x03, 0xbf, 0x09, 0x0e, 0x0f, 0x13, 0x0e, 0x12, 0x26, 0x1b, 0x1e, 0x1e,
-  0x1e, 0x1e, 0x1d, 0x24, 0x24, 0x53, 0x24, 0x24, 0x1c, 0x1e, 0x1f, 0x1f,
-  0x1e, 0x1f, 0x21, 0x15, 0x0c, 0x13, 0x0f, 0x0f, 0x09, 0xbf, 0x02, 0x08,
-  0x0e, 0x1e, 0x1d, 0x4a, 0x29, 0x29, 0x4a, 0x1d, 0x1c, 0x10, 0x0f, 0x0f,
-  0x10, 0x1c, 0x1d, 0x4a, 0x29, 0x29, 0x4a, 0x1d, 0x1a, 0x12, 0x09, 0x01,
-  0xbf, 0x09, 0x0f, 0x0f, 0x13, 0x0c, 0x15, 0x21, 0x1f, 0x1e, 0x1f, 0x1f,
-  0x1e, 0x1c, 0x24, 0x24, 0x53, 0x24, 0x24, 0x1d, 0x1e, 0x1e, 0x1e, 0x1e,
-  0x1b, 0x26, 0x12, 0x0e, 0x13, 0x02, 0x93, 0x11, 0x15, 0x10, 0x14, 0x2a,
-  0x1e, 0x21, 0x22, 0x22, 0x21, 0x20, 0x28, 0x28, 0x5c, 0x28, 0x28, 0x20,
-  0x21, 0x22, 0x22, 0x21, 0x23, 0x25, 0x17, 0x0d, 0x15, 0x11, 0x10, 0x0a,
-  0xd5, 0x02, 0x0a, 0x14, 0x1d, 0x20, 0x52, 0x2e, 0x2d, 0x52, 0x20, 0x1f,
-  0x12, 0x11, 0x11, 0x12, 0x1f, 0x20, 0x52, 0x2d, 0x2e, 0x52, 0x20, 0x22,
-  0x0f, 0x09, 0x03, 0xd5, 0x0a, 0x10, 0x11, 0x15, 0x0d, 0x17, 0x25, 0x23,
-  0x21, 0x22, 0x22, 0x21, 0x20, 0x28, 0x28, 0x5c, 0x28, 0x28, 0x20, 0x21,
-  0x22, 0x22, 0x21, 0x1e, 0x2a, 0x14, 0x10, 0x15, 0x11, 0x10, 0x0a, 0xd4,
-  0x03, 0x09, 0x0f, 0x22, 0x20, 0x52, 0x2e, 0x2d, 0x52, 0x20, 0x1f, 0x12,
-  0x11, 0x11, 0x12, 0x1f, 0x20, 0x52, 0x2d, 0x2e, 0x52, 0x20, 0x1d, 0x14,
-  0x0a, 0x02, 0xd4, 0x0a, 0x00, 0x01, 0x00, 0x4a, 0xff, 0xe3, 0x05, 0xbe,
-  0x05, 0xf0, 0x00, 0x83, 0x00, 0x00, 0x01, 0x34, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x15, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x3e,
-  0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x2e, 0x01,
-  0x23, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35,
-  0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x22, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x02, 0xd7, 0x27, 0x21, 0x0c, 0x0f,
-  0x15, 0x09, 0x24, 0x24, 0x25, 0x23, 0x1c, 0x35, 0x29, 0x67, 0x2b, 0x30,
-  0x21, 0x22, 0x26, 0x26, 0x22, 0x09, 0x18, 0x07, 0x12, 0x25, 0x23, 0x3d,
-  0x5b, 0x1e, 0x0c, 0x0b, 0x10, 0x09, 0x23, 0x5a, 0x32, 0x34, 0x59, 0x22,
-  0x20, 0x16, 0x13, 0x13, 0x16, 0x20, 0x22, 0x59, 0x34, 0x32, 0x5a, 0x23,
-  0x09, 0x10, 0x0b, 0x0c, 0x25, 0x57, 0x3a, 0x2b, 0x1d, 0x0c, 0x0e, 0x17,
-  0x09, 0x23, 0x25, 0x26, 0x22, 0x21, 0x30, 0x2a, 0x67, 0x2a, 0x31, 0x20,
-  0x23, 0x25, 0x24, 0x24, 0x09, 0x16, 0x0f, 0x0b, 0x23, 0x25, 0x39, 0x59,
-  0x23, 0x0c, 0x0b, 0x10, 0x09, 0x22, 0x5a, 0x33, 0x34, 0x58, 0x23, 0x1d,
-  0x19, 0x13, 0x13, 0x16, 0x20, 0x23, 0x58, 0x34, 0x37, 0x56, 0x22, 0x09,
-  0x10, 0x05, 0x12, 0x24, 0x58, 0x03, 0x1c, 0x43, 0x63, 0x22, 0x0e, 0x0c,
-  0x12, 0x0a, 0x26, 0x64, 0x38, 0x3a, 0x62, 0x26, 0x20, 0x1c, 0x16, 0x16,
-  0x18, 0x24, 0x26, 0x62, 0x3a, 0x3d, 0x5f, 0x26, 0x0a, 0x12, 0x06, 0x14,
-  0x28, 0x61, 0x3f, 0x2f, 0x21, 0x0d, 0x10, 0x19, 0x0a, 0x27, 0x29, 0x2a,
-  0x26, 0x24, 0x36, 0x2f, 0x72, 0x2f, 0x36, 0x24, 0x26, 0x2a, 0x29, 0x27,
-  0x0a, 0x19, 0x10, 0x0d, 0x27, 0x29, 0x44, 0x65, 0x21, 0x0d, 0x0c, 0x12,
-  0x0a, 0x27, 0x64, 0x38, 0x3a, 0x62, 0x26, 0x24, 0x18, 0x15, 0x15, 0x18,
-  0x24, 0x26, 0x62, 0x3a, 0x38, 0x64, 0x27, 0x0a, 0x12, 0x0c, 0x0d, 0x29,
-  0x61, 0x40, 0x29, 0x27, 0x0e, 0x10, 0x18, 0x0a, 0x28, 0x28, 0x2a, 0x26,
-  0x20, 0x3a, 0x2e, 0x72, 0x30, 0x36, 0x24, 0x26, 0x2a, 0x2a, 0x26, 0x0a,
-  0x1a, 0x08, 0x14, 0x28, 0x28, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b,
-  0xff, 0xe5, 0x05, 0xbd, 0x05, 0xf2, 0x01, 0x30, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x11, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x21, 0x11, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x11, 0x21, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x21, 0x11, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x2e,
-  0x01, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x03, 0x04, 0x1b, 0x15, 0x18, 0x10, 0x12, 0x0a, 0x09,
-  0x09, 0x0a, 0x12, 0x0a, 0x12, 0x17, 0x19, 0x1b, 0x16, 0x17, 0x11, 0x12,
-  0x0a, 0x09, 0x09, 0x0a, 0x24, 0x16, 0x17, 0x1a, 0x1b, 0x15, 0x16, 0x12,
-  0x0d, 0x09, 0x01, 0x09, 0x0f, 0x0d, 0x11, 0x0a, 0x0a, 0x14, 0x11, 0x12,
-  0x17, 0x17, 0x19, 0x1a, 0x17, 0x17, 0x12, 0x11, 0x0a, 0x0a, 0x0a, 0x07,
-  0x08, 0x12, 0x16, 0x17, 0x19, 0x1d, 0x14, 0x17, 0x12, 0x11, 0x0b, 0x09,
-  0x09, 0x0b, 0x11, 0x14, 0x15, 0x17, 0x1a, 0x19, 0x17, 0x16, 0x12, 0x08,
-  0x07, 0x0a, 0x14, 0x11, 0x0f, 0x1a, 0x17, 0x1a, 0x16, 0x1a, 0x17, 0x12,
-  0x11, 0x0a, 0x0a, 0x0a, 0x0a, 0x11, 0x0d, 0x0f, 0xfe, 0xf8, 0x08, 0x0d,
-  0x0f, 0x1a, 0x15, 0x1b, 0x1a, 0x16, 0x17, 0x11, 0x12, 0x0a, 0x09, 0x09,
-  0x0a, 0x12, 0x10, 0x18, 0x15, 0x1b, 0x17, 0x19, 0x12, 0x0a, 0x11, 0x0a,
-  0x0a, 0x0a, 0x0a, 0x12, 0x10, 0x18, 0x15, 0x36, 0x15, 0x18, 0x10, 0x12,
-  0x0a, 0x0a, 0x0a, 0x0a, 0x11, 0x0a, 0x12, 0x15, 0x1a, 0x1c, 0x14, 0x18,
-  0x11, 0x12, 0x0a, 0x09, 0x09, 0x0a, 0x12, 0x11, 0x18, 0x15, 0x1b, 0x18,
-  0x2f, 0x12, 0x0c, 0x08, 0xfe, 0xf9, 0x0f, 0x0c, 0x13, 0x08, 0x0a, 0x0a,
-  0x09, 0x12, 0x14, 0x15, 0x17, 0x19, 0x1b, 0x16, 0x17, 0x12, 0x11, 0x0b,
-  0x08, 0x08, 0x08, 0x09, 0x14, 0x15, 0x17, 0x19, 0x1a, 0x17, 0x17, 0x12,
-  0x11, 0x0a, 0x09, 0x09, 0x0a, 0x11, 0x0f, 0x1a, 0x17, 0x1a, 0x19, 0x17,
-  0x17, 0x12, 0x09, 0x08, 0x08, 0x08, 0x0b, 0x11, 0x12, 0x17, 0x16, 0x1b,
-  0x19, 0x17, 0x17, 0x12, 0x12, 0x09, 0x0a, 0x0a, 0x0a, 0x11, 0x0c, 0x0f,
-  0x01, 0x07, 0x09, 0x0c, 0x12, 0x17, 0x15, 0x1a, 0x1b, 0x15, 0x18, 0x24,
-  0x09, 0x09, 0x09, 0x09, 0x12, 0x12, 0x18, 0x14, 0x1c, 0x1a, 0x15, 0x12,
-  0x0a, 0x12, 0x0a, 0x09, 0x09, 0x0a, 0x12, 0x11, 0x18, 0x14, 0x05, 0xf2,
-  0x0b, 0x0c, 0x12, 0x14, 0x1a, 0x19, 0x1d, 0x1c, 0x19, 0x1a, 0x14, 0x0a,
-  0x08, 0x0a, 0x0a, 0x0c, 0x12, 0x14, 0x1a, 0x19, 0x1d, 0x1f, 0x17, 0x19,
-  0x28, 0x0b, 0x0a, 0x0a, 0x0c, 0x13, 0x0d, 0x11, 0xfe, 0xdb, 0x0a, 0x0e,
-  0x14, 0x19, 0x17, 0x1e, 0x1d, 0x32, 0x14, 0x14, 0x0b, 0x0a, 0x0a, 0x0b,
-  0x14, 0x13, 0x1a, 0x18, 0x1e, 0x1c, 0x19, 0x14, 0x0b, 0x14, 0x0b, 0x0a,
-  0x0a, 0x0b, 0x14, 0x12, 0x1b, 0x18, 0x1d, 0x1e, 0x18, 0x1b, 0x12, 0x16,
-  0x09, 0x0a, 0x0a, 0x0b, 0x14, 0x0b, 0x14, 0x19, 0x1c, 0x1a, 0x36, 0x13,
-  0x11, 0x0d, 0x0b, 0x0b, 0x0a, 0x14, 0x14, 0x1a, 0x18, 0x1d, 0x1e, 0x17,
-  0x19, 0x14, 0x0e, 0x0a, 0xfe, 0xda, 0x12, 0x0d, 0x10, 0x0e, 0x0b, 0x0b,
-  0x0b, 0x13, 0x14, 0x1a, 0x19, 0x1c, 0x1d, 0x19, 0x1a, 0x14, 0x12, 0x0c,
-  0x0b, 0x0b, 0x08, 0x09, 0x13, 0x1a, 0x19, 0x1c, 0x1d, 0x1a, 0x19, 0x14,
-  0x13, 0x0c, 0x0a, 0x0a, 0x0c, 0x13, 0x14, 0x19, 0x1a, 0x1d, 0x1c, 0x19,
-  0x1a, 0x13, 0x09, 0x08, 0x0b, 0x0b, 0x0c, 0x12, 0x14, 0x1a, 0x19, 0x1d,
-  0x1c, 0x19, 0x1a, 0x14, 0x13, 0x0b, 0x0b, 0x16, 0x13, 0x0d, 0x12, 0x01,
-  0x25, 0x09, 0x0e, 0x17, 0x16, 0x18, 0x1e, 0x1c, 0x19, 0x1a, 0x13, 0x16,
-  0x09, 0x0a, 0x0a, 0x0b, 0x14, 0x12, 0x1b, 0x17, 0x1e, 0x1d, 0x19, 0x13,
-  0x0c, 0x16, 0x09, 0x0a, 0x0a, 0x0b, 0x14, 0x12, 0x1b, 0x17, 0x3c, 0x17,
-  0x1b, 0x13, 0x11, 0x0d, 0x0b, 0x0b, 0x0a, 0x14, 0x0b, 0x14, 0x18, 0x1d,
-  0x1e, 0x17, 0x1b, 0x12, 0x14, 0x0b, 0x0b, 0x0b, 0x0b, 0x14, 0x13, 0x1a,
-  0x18, 0x1d, 0x1e, 0x17, 0x1a, 0x13, 0x0e, 0x0a, 0x01, 0x25, 0x11, 0x0d,
-  0x13, 0x0c, 0x0a, 0x0a, 0x0b, 0x28, 0x19, 0x1a, 0x1c, 0x19, 0x1d, 0x1a,
-  0x14, 0x12, 0x0c, 0x0a, 0x0a, 0x08, 0x0a, 0x14, 0x1a, 0x19, 0x1c, 0x1d,
-  0x19, 0x1a, 0x14, 0x12, 0x0c, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4e,
-  0xff, 0xe3, 0x05, 0xbc, 0x05, 0xf5, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x32,
-  0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
-  0x33, 0x22, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x34, 0x02, 0x27, 0x26,
-  0x27, 0x26, 0x4e, 0x8c, 0x7f, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x62,
-  0x7f, 0x7e, 0x8c, 0x8c, 0x7e, 0x7f, 0x62, 0x69, 0x63, 0x67, 0x65, 0x68,
-  0x78, 0x7f, 0x02, 0xec, 0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14, 0xa1, 0x9d,
-  0xfe, 0xf0, 0x77, 0x6e, 0x3c, 0x3b, 0x3b, 0x3c, 0x6e, 0x77, 0xfe, 0xf0,
-  0x9d, 0xa1, 0x01, 0x14, 0x6f, 0x72, 0x38, 0x3b, 0x00, 0x02, 0x00, 0x4e,
-  0xff, 0xe3, 0x05, 0xbc, 0x05, 0xf5, 0x00, 0x1b, 0x00, 0x37, 0x00, 0x00,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x34, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x14, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x21, 0x32, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35,
-  0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x33, 0x22, 0x07, 0x06, 0x07, 0x06,
-  0x02, 0x15, 0x34, 0x02, 0x27, 0x26, 0x27, 0x26, 0x01, 0x41, 0x5b, 0x53,
-  0x4e, 0x43, 0x42, 0x43, 0x40, 0x45, 0x3f, 0x52, 0x52, 0x5c, 0x5c, 0x52,
-  0x52, 0x3f, 0x45, 0x40, 0x43, 0x42, 0x43, 0x4e, 0x53, 0xfe, 0xb2, 0x8c,
-  0x7f, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x62, 0x7f, 0x7e, 0x8c, 0x8c,
-  0x7e, 0x7f, 0x62, 0x69, 0x63, 0x67, 0x65, 0x68, 0x78, 0x7f, 0x02, 0xec,
-  0x26, 0x25, 0x4a, 0x48, 0xb3, 0x69, 0x66, 0xb1, 0x4d, 0x48, 0x27, 0x26,
-  0x26, 0x27, 0x48, 0x4d, 0xb1, 0x66, 0x69, 0xb3, 0x48, 0x4a, 0x25, 0x26,
-  0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14, 0xa1, 0x9d, 0xfe, 0xf0, 0x77, 0x6e,
-  0x3c, 0x3b, 0x3b, 0x3c, 0x6e, 0x77, 0xfe, 0xf0, 0x9d, 0xa1, 0x01, 0x14,
-  0x6f, 0x72, 0x38, 0x3b, 0x00, 0x02, 0x00, 0x2a, 0xff, 0xec, 0x05, 0xdf,
-  0x05, 0xf3, 0x00, 0x09, 0x00, 0x13, 0x00, 0x00, 0x13, 0x25, 0x09, 0x01,
-  0x05, 0x01, 0x13, 0x25, 0x05, 0x13, 0x01, 0x03, 0x21, 0x01, 0x03, 0x09,
-  0x01, 0x03, 0x01, 0x21, 0x2a, 0x01, 0xd9, 0x01, 0x01, 0x01, 0x02, 0x01,
-  0xd8, 0xfe, 0xc9, 0x21, 0xfe, 0x3c, 0xfe, 0x3c, 0x22, 0x01, 0xa2, 0xac,
-  0xfd, 0xd3, 0x01, 0xc2, 0xac, 0x01, 0xc3, 0x01, 0xc3, 0xac, 0x01, 0xc2,
-  0xfd, 0xd3, 0x03, 0xa5, 0x83, 0x01, 0xcb, 0xfe, 0x35, 0x83, 0xfe, 0x61,
-  0xfd, 0xe6, 0xca, 0xca, 0x02, 0x1a, 0x03, 0xec, 0xfd, 0xb3, 0xfe, 0x94,
-  0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01, 0x6c, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x4d, 0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x09,
-  0x00, 0x24, 0x00, 0x00, 0x01, 0x03, 0x21, 0x01, 0x03, 0x09, 0x01, 0x03,
-  0x01, 0x21, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02,
-  0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34,
-  0x12, 0x37, 0x36, 0x37, 0x36, 0x03, 0x04, 0x9b, 0xfe, 0x0b, 0x01, 0x95,
-  0x9b, 0x01, 0x96, 0x01, 0x96, 0x9b, 0x01, 0x95, 0xfe, 0x0b, 0x9b, 0x8b,
-  0x80, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x63, 0x7d, 0x7f, 0xfe, 0xea,
-  0x80, 0x79, 0x67, 0x65, 0x68, 0x63, 0x6a, 0x61, 0x7f, 0x7e, 0x05, 0xea,
-  0xfd, 0xee, 0xfe, 0xb8, 0xfd, 0xef, 0x01, 0x48, 0xfe, 0xb8, 0x02, 0x11,
-  0x01, 0x48, 0x02, 0x18, 0x3b, 0x38, 0x72, 0x6f, 0xfe, 0xec, 0xa1, 0x98,
-  0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14,
-  0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x00, 0x02, 0x00, 0x2b,
-  0xff, 0xed, 0x05, 0xde, 0x05, 0xf2, 0x00, 0x1d, 0x00, 0x27, 0x00, 0x00,
-  0x00, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x13, 0x21, 0x01, 0x13, 0x09,
-  0x01, 0x13, 0x01, 0x21, 0x03, 0x40, 0x78, 0x33, 0x34, 0x2b, 0x2b, 0x15,
-  0x15, 0x15, 0x15, 0x2b, 0x2b, 0x34, 0x33, 0x78, 0x34, 0x33, 0x2b, 0x2c,
-  0x14, 0x16, 0x16, 0x14, 0x2c, 0x2b, 0x33, 0x70, 0xac, 0x02, 0x2d, 0xfe,
-  0x3e, 0xac, 0xfe, 0x3d, 0xfe, 0x3d, 0xac, 0xfe, 0x3e, 0x02, 0x2d, 0x03,
-  0xe4, 0x18, 0x1a, 0x2d, 0x32, 0x38, 0x3b, 0x42, 0x41, 0x3b, 0x38, 0x32,
-  0x2d, 0x1a, 0x18, 0x18, 0x1a, 0x2d, 0x32, 0x38, 0x3b, 0x41, 0x42, 0x3b,
-  0x38, 0x32, 0x2d, 0x1a, 0x02, 0x26, 0xfd, 0xb3, 0xfe, 0x94, 0xfd, 0xb4,
-  0x01, 0x6b, 0xfe, 0x95, 0x02, 0x4c, 0x01, 0x6c, 0x00, 0x03, 0x00, 0x2a,
-  0xff, 0xec, 0x05, 0xdf, 0x05, 0xf3, 0x00, 0x09, 0x00, 0x27, 0x00, 0x31,
-  0x00, 0x00, 0x13, 0x25, 0x09, 0x01, 0x05, 0x01, 0x13, 0x25, 0x05, 0x13,
-  0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x13, 0x03, 0x21, 0x01, 0x03, 0x09,
-  0x01, 0x03, 0x01, 0x21, 0x2a, 0x01, 0xd9, 0x01, 0x01, 0x01, 0x02, 0x01,
-  0xd8, 0xfe, 0xc9, 0x21, 0xfe, 0x3c, 0xfe, 0x3c, 0x22, 0x01, 0x66, 0x78,
-  0x34, 0x33, 0x2b, 0x2c, 0x14, 0x16, 0x16, 0x14, 0x2c, 0x2b, 0x33, 0x34,
-  0x78, 0x33, 0x34, 0x2b, 0x2b, 0x15, 0x15, 0x15, 0x15, 0x2b, 0x2b, 0x34,
-  0x6f, 0xac, 0xfd, 0xd3, 0x01, 0xc2, 0xac, 0x01, 0xc3, 0x01, 0xc3, 0xac,
-  0x01, 0xc2, 0xfd, 0xd3, 0x03, 0xa5, 0x83, 0x01, 0xcb, 0xfe, 0x35, 0x83,
-  0xfe, 0x61, 0xfd, 0xe6, 0xca, 0xca, 0x02, 0x1a, 0x01, 0xde, 0x18, 0x1a,
-  0x2d, 0x32, 0x38, 0x3b, 0x42, 0x41, 0x3b, 0x38, 0x32, 0x2d, 0x1a, 0x18,
-  0x18, 0x1a, 0x2d, 0x32, 0x38, 0x3b, 0x41, 0x42, 0x3b, 0x38, 0x32, 0x2d,
-  0x1a, 0x02, 0x26, 0xfd, 0xb3, 0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6b, 0xfe,
-  0x95, 0x02, 0x4c, 0x01, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x2b,
-  0xff, 0xed, 0x05, 0xde, 0x05, 0xf2, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x13, 0x21, 0x07, 0x13, 0x27, 0x07, 0x13, 0x27, 0x21,
-  0x13, 0x03, 0x21, 0x01, 0x03, 0x09, 0x01, 0x03, 0x01, 0x21, 0x03, 0x13,
-  0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x01, 0x21, 0x03, 0x04, 0x57, 0x01,
-  0x16, 0xe1, 0x55, 0xe1, 0xe1, 0x56, 0xe1, 0x01, 0x16, 0x56, 0x80, 0xfe,
-  0x5d, 0x01, 0x52, 0x81, 0x01, 0x52, 0x01, 0x53, 0x82, 0x01, 0x52, 0xfe,
-  0x5e, 0x81, 0xac, 0x02, 0x2d, 0xfe, 0x3e, 0xac, 0xfe, 0x3d, 0xfe, 0x3d,
-  0xac, 0xfe, 0x3e, 0x02, 0x2d, 0x04, 0x49, 0xfe, 0xd9, 0xb6, 0xfe, 0xda,
-  0xb6, 0xb6, 0x01, 0x26, 0xb6, 0x01, 0xfb, 0xfe, 0x47, 0xfe, 0xef, 0xfe,
-  0x47, 0x01, 0x11, 0xfe, 0xef, 0x01, 0xb9, 0x01, 0x11, 0x02, 0x8e, 0xfd,
-  0xb3, 0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01,
-  0x6c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x2b, 0xff, 0xed, 0x05, 0xde,
-  0x05, 0xf2, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x17,
-  0x33, 0x07, 0x17, 0x27, 0x07, 0x37, 0x27, 0x33, 0x1b, 0x01, 0x21, 0x01,
-  0x13, 0x09, 0x01, 0x13, 0x01, 0x21, 0x37, 0x03, 0x21, 0x05, 0x03, 0x25,
-  0x05, 0x03, 0x25, 0x21, 0x03, 0x04, 0x22, 0x70, 0x5a, 0x22, 0x5a, 0x5a,
-  0x22, 0x5a, 0x70, 0x22, 0xac, 0x02, 0x2d, 0xfe, 0x3e, 0xac, 0xfe, 0x3d,
-  0xfe, 0x3d, 0xac, 0xfe, 0x3e, 0x02, 0x2d, 0xac, 0x67, 0xfe, 0xaf, 0x01,
-  0x11, 0x69, 0x01, 0x10, 0x01, 0x11, 0x69, 0x01, 0x10, 0xfe, 0xb0, 0x03,
-  0x49, 0x76, 0x49, 0x76, 0x49, 0x49, 0x76, 0x49, 0x03, 0x1f, 0xfd, 0xb3,
-  0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01, 0x6c,
-  0xfb, 0xfe, 0x9d, 0xdb, 0xfe, 0x9d, 0xdb, 0xdb, 0x01, 0x63, 0xdb, 0x00,
-  0x00, 0x06, 0x00, 0x2b, 0xff, 0xed, 0x05, 0xde, 0x05, 0xf2, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x18, 0x00, 0x00,
-  0x25, 0x01, 0x35, 0x25, 0x01, 0x37, 0x01, 0x03, 0x27, 0x25, 0x21, 0x07,
-  0x0b, 0x01, 0x17, 0x11, 0x13, 0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x01,
-  0x21, 0x01, 0xb1, 0x01, 0x52, 0xfd, 0xdd, 0x01, 0x52, 0xd1, 0x01, 0x55,
-  0x82, 0xd1, 0x02, 0x23, 0xfe, 0x5e, 0x81, 0x01, 0x80, 0x80, 0xac, 0x02,
-  0x2d, 0xfe, 0x3e, 0xac, 0xfe, 0x3d, 0xfe, 0x3d, 0xac, 0xfe, 0x3e, 0x02,
-  0x2d, 0x99, 0x01, 0x11, 0xf3, 0xc7, 0xfe, 0xef, 0x4b, 0xfd, 0xfb, 0x01,
-  0xb9, 0x4b, 0xc7, 0xc6, 0x02, 0x80, 0xfe, 0x47, 0xc6, 0x03, 0x53, 0xfd,
-  0xb3, 0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01,
-  0x6c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x2d, 0x00, 0x18, 0x05, 0xdf,
-  0x05, 0xb7, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x00, 0x09, 0x01, 0x13, 0x27,
-  0x25, 0x01, 0x27, 0x13, 0x01, 0x21, 0x13, 0x17, 0x13, 0x21, 0x01, 0x03,
-  0x21, 0x05, 0x03, 0x01, 0x05, 0x03, 0x01, 0x21, 0x05, 0xdf, 0xfe, 0x6b,
-  0x9b, 0x92, 0xfe, 0xd3, 0xfe, 0x93, 0x92, 0x9b, 0xfe, 0x6b, 0x01, 0xf5,
-  0x9b, 0x92, 0x8b, 0x01, 0x73, 0xfd, 0x70, 0x79, 0xfe, 0x7b, 0x01, 0x3b,
-  0x79, 0x01, 0x3c, 0x01, 0x3c, 0x79, 0x01, 0x3b, 0xfe, 0x7b, 0x03, 0x71,
-  0xfe, 0xb8, 0xfd, 0xef, 0x34, 0xf3, 0xfe, 0xd9, 0x34, 0x02, 0x11, 0x01,
-  0x48, 0x02, 0x12, 0x34, 0xfe, 0x22, 0x01, 0x68, 0xfe, 0x64, 0xff, 0xfe,
-  0x64, 0x00, 0xff, 0xff, 0x01, 0x9c, 0x00, 0xff, 0x00, 0x01, 0x00, 0x76,
-  0x00, 0x00, 0x05, 0x92, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x25, 0x13, 0x0d, 0x01, 0x03, 0x25, 0x11, 0x21, 0x11, 0x05,
-  0x03, 0x2d, 0x01, 0x13, 0x02, 0x74, 0x01, 0x20, 0x01, 0x6e, 0x90, 0xfe,
-  0x92, 0x01, 0x6e, 0x90, 0xfe, 0x92, 0xfe, 0xe0, 0xfe, 0x93, 0x90, 0x01,
-  0x6c, 0xfe, 0x94, 0x90, 0x04, 0x00, 0x01, 0xd5, 0xfe, 0x2a, 0xeb, 0xfe,
-  0xeb, 0xea, 0xeb, 0xfe, 0xeb, 0xeb, 0xfe, 0x2a, 0x01, 0xd6, 0xeb, 0x01,
-  0x15, 0xeb, 0xea, 0x01, 0x15, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x88,
-  0x00, 0x00, 0x05, 0x80, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x17, 0x00, 0x00,
-  0x01, 0x07, 0x17, 0x33, 0x37, 0x27, 0x05, 0x01, 0x37, 0x01, 0x11, 0x33,
-  0x11, 0x01, 0x17, 0x09, 0x01, 0x07, 0x01, 0x11, 0x23, 0x11, 0x01, 0x27,
-  0x02, 0x99, 0x6c, 0x6c, 0xd6, 0x6c, 0x6c, 0xfe, 0xbd, 0xfe, 0x5d, 0x6c,
-  0x01, 0xa3, 0xd8, 0x01, 0xa4, 0x6c, 0xfe, 0x5c, 0x01, 0xa4, 0x6c, 0xfe,
-  0x5c, 0xd8, 0xfe, 0x5d, 0x6c, 0x03, 0xb9, 0xce, 0xd0, 0xd0, 0xce, 0xce,
-  0x01, 0x0d, 0xd0, 0xfe, 0xf2, 0x02, 0x1b, 0xfd, 0xe5, 0x01, 0x0e, 0xd0,
-  0xfe, 0xf3, 0xfe, 0xf2, 0xd0, 0x01, 0x0d, 0xfd, 0xe6, 0x02, 0x1a, 0xfe,
-  0xf3, 0xd0, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4,
-  0x05, 0xd5, 0x00, 0x17, 0x00, 0x00, 0x09, 0x01, 0x07, 0x01, 0x11, 0x23,
-  0x11, 0x01, 0x27, 0x01, 0x21, 0x35, 0x21, 0x01, 0x37, 0x01, 0x11, 0x33,
-  0x11, 0x01, 0x17, 0x01, 0x21, 0x15, 0x03, 0x72, 0x01, 0x8d, 0x40, 0xfe,
-  0x72, 0x5a, 0xfe, 0x72, 0x3f, 0x01, 0x8d, 0xfd, 0xce, 0x02, 0x33, 0xfe,
-  0x72, 0x3f, 0x01, 0x8e, 0x5a, 0x01, 0x8e, 0x40, 0xfe, 0x71, 0x02, 0x34,
-  0x02, 0xb8, 0xfe, 0x46, 0x47, 0x01, 0xbb, 0xfd, 0x8e, 0x02, 0x71, 0xfe,
-  0x46, 0x47, 0x01, 0xba, 0x64, 0x01, 0xbb, 0x47, 0xfe, 0x46, 0x02, 0x71,
-  0xfd, 0x8f, 0x01, 0xba, 0x47, 0xfe, 0x45, 0x64, 0x00, 0x01, 0x00, 0x39,
-  0xff, 0xe3, 0x05, 0xab, 0x05, 0xf0, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x13,
-  0x09, 0x01, 0x0d, 0x01, 0x09, 0x01, 0x0b, 0x01, 0x09, 0x01, 0x2d, 0x01,
-  0x09, 0x01, 0x02, 0xf2, 0x47, 0x01, 0xa5, 0xfe, 0xc1, 0x02, 0x0c, 0xfd,
-  0xf4, 0x01, 0x3f, 0xfe, 0x5b, 0x47, 0x47, 0xfe, 0x5b, 0x01, 0x3f, 0xfd,
-  0xf5, 0x02, 0x0b, 0xfe, 0xc1, 0x01, 0xa5, 0x05, 0xf0, 0xfd, 0xb9, 0x01,
-  0x64, 0xfe, 0x2c, 0x50, 0x4f, 0xfe, 0x2c, 0x01, 0x64, 0xfd, 0xb9, 0x02,
-  0x47, 0xfe, 0x9c, 0x01, 0xd4, 0x4f, 0x50, 0x01, 0xd4, 0xfe, 0x9c, 0x00,
-  0x00, 0x09, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x02,
-  0x00, 0x05, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x11, 0x00, 0x14,
-  0x00, 0x17, 0x00, 0x27, 0x00, 0x00, 0x01, 0x05, 0x03, 0x05, 0x25, 0x05,
-  0x01, 0x03, 0x25, 0x03, 0x13, 0x03, 0x01, 0x25, 0x13, 0x25, 0x05, 0x25,
-  0x01, 0x13, 0x05, 0x13, 0x03, 0x13, 0x11, 0x13, 0x25, 0x03, 0x0d, 0x01,
-  0x13, 0x25, 0x0b, 0x01, 0x05, 0x13, 0x2d, 0x01, 0x03, 0x05, 0x04, 0x76,
-  0xfe, 0xfa, 0x6b, 0x02, 0x0a, 0xfe, 0xf8, 0xfe, 0xfe, 0x01, 0x71, 0x6f,
-  0xfe, 0xfe, 0x01, 0x6b, 0x6b, 0xfe, 0x8e, 0x01, 0x06, 0x6b, 0xfd, 0xf6,
-  0x01, 0x08, 0x01, 0x02, 0xfe, 0x8f, 0x6f, 0x01, 0x02, 0x01, 0x6b, 0x6b,
-  0x8f, 0x01, 0x5d, 0x93, 0x01, 0x60, 0xfe, 0xa0, 0x93, 0xfe, 0xa3, 0x8f,
-  0x8f, 0xfe, 0xa3, 0x94, 0xfe, 0xa0, 0x01, 0x60, 0x94, 0x01, 0x5d, 0x04,
-  0x85, 0x7b, 0xfe, 0xe0, 0x01, 0x78, 0x78, 0xfe, 0x65, 0x01, 0x23, 0x77,
-  0xfd, 0xbc, 0x01, 0x25, 0x01, 0x1f, 0xfe, 0x66, 0x7b, 0x01, 0x1f, 0x01,
-  0x77, 0x77, 0x01, 0x9c, 0xfe, 0xdd, 0x78, 0x02, 0x45, 0xfe, 0xdb, 0xfe,
-  0xe0, 0x03, 0x06, 0xfe, 0x79, 0xa4, 0xfe, 0x7c, 0xa0, 0x9f, 0xfe, 0x7c,
-  0xa4, 0xfe, 0x79, 0x01, 0x87, 0xa4, 0x01, 0x84, 0x9f, 0xa0, 0x01, 0x84,
-  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61,
-  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x13, 0x25, 0x09, 0x01, 0x25,
-  0x0b, 0x01, 0x05, 0x09, 0x01, 0x05, 0x03, 0x04, 0x65, 0x01, 0xf7, 0xfe,
-  0x6e, 0x01, 0x92, 0xfe, 0x09, 0x65, 0x65, 0xfe, 0x09, 0x01, 0x93, 0xfe,
-  0x6d, 0x01, 0xf7, 0x05, 0xf0, 0xfd, 0xbc, 0xc1, 0xfe, 0x7d, 0xfe, 0x7d,
-  0xc1, 0xfd, 0xbb, 0x02, 0x45, 0xc1, 0x01, 0x83, 0x01, 0x83, 0xc1, 0x00,
-  0x00, 0x01, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x0f,
-  0x00, 0x00, 0x01, 0x13, 0x01, 0x03, 0x0d, 0x01, 0x13, 0x01, 0x0b, 0x01,
-  0x01, 0x13, 0x2d, 0x01, 0x03, 0x01, 0x03, 0x04, 0x66, 0x01, 0x86, 0xf5,
-  0x01, 0xc2, 0xfe, 0x3e, 0xf5, 0xfe, 0x7a, 0x66, 0x66, 0xfe, 0x7a, 0xf6,
-  0xfe, 0x3e, 0x01, 0xc2, 0xf6, 0x01, 0x86, 0x05, 0xf0, 0xfe, 0x0b, 0x01,
-  0x12, 0xfe, 0x4e, 0x72, 0x71, 0xfe, 0x4e, 0x01, 0x12, 0xfe, 0x0b, 0x01,
-  0xf5, 0xfe, 0xee, 0x01, 0xb2, 0x71, 0x72, 0x01, 0xb2, 0xfe, 0xee, 0x00,
-  0x00, 0x01, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x0f,
-  0x00, 0x00, 0x01, 0x13, 0x25, 0x03, 0x0d, 0x01, 0x13, 0x25, 0x0b, 0x01,
-  0x05, 0x13, 0x2d, 0x01, 0x03, 0x05, 0x03, 0x04, 0x99, 0x01, 0x53, 0x7b,
-  0x01, 0x48, 0xfe, 0xb8, 0x7b, 0xfe, 0xad, 0x99, 0x99, 0xfe, 0xad, 0x7b,
-  0xfe, 0xb9, 0x01, 0x47, 0x7b, 0x01, 0x53, 0x05, 0xf0, 0xfe, 0x94, 0x89,
-  0xfe, 0x87, 0xab, 0xaa, 0xfe, 0x87, 0x89, 0xfe, 0x94, 0x01, 0x6c, 0x89,
-  0x01, 0x79, 0xaa, 0xab, 0x01, 0x79, 0x89, 0x00, 0x00, 0x01, 0x00, 0x4b,
-  0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x17, 0x00, 0x00, 0x01, 0x13,
-  0x37, 0x03, 0x25, 0x03, 0x0d, 0x01, 0x13, 0x25, 0x13, 0x27, 0x0b, 0x01,
-  0x07, 0x13, 0x05, 0x13, 0x2d, 0x01, 0x03, 0x05, 0x03, 0x17, 0x03, 0x04,
-  0x69, 0xf3, 0x3f, 0x01, 0x3f, 0xd7, 0x01, 0x34, 0xfe, 0xcc, 0xd7, 0xfe,
-  0xc1, 0x3f, 0xf3, 0x69, 0x68, 0xf4, 0x40, 0xfe, 0xc0, 0xd7, 0xfe, 0xcd,
-  0x01, 0x33, 0xd7, 0x01, 0x40, 0x40, 0xf4, 0x05, 0xf0, 0xfe, 0xa9, 0xef,
-  0xfe, 0x9d, 0x47, 0xfe, 0xf1, 0x73, 0x74, 0xfe, 0xf1, 0x47, 0xfe, 0x9d,
-  0xef, 0xfe, 0xa9, 0x01, 0x57, 0xef, 0x01, 0x63, 0x47, 0x01, 0x0f, 0x74,
-  0x73, 0x01, 0x0f, 0x47, 0x01, 0x63, 0xef, 0x00, 0x00, 0x01, 0x00, 0x64,
-  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x11,
-  0x33, 0x11, 0x13, 0x17, 0x03, 0x01, 0x17, 0x01, 0x25, 0x17, 0x05, 0x21,
-  0x15, 0x21, 0x05, 0x07, 0x25, 0x01, 0x07, 0x01, 0x13, 0x07, 0x03, 0x11,
-  0x23, 0x11, 0x03, 0x27, 0x13, 0x01, 0x27, 0x01, 0x05, 0x27, 0x25, 0x21,
-  0x35, 0x21, 0x25, 0x37, 0x05, 0x01, 0x37, 0x01, 0x03, 0x37, 0x02, 0xce,
-  0x6c, 0x99, 0x64, 0x99, 0x01, 0x1b, 0x4c, 0xfe, 0xe5, 0x01, 0x72, 0x2a,
-  0xfe, 0x8c, 0x01, 0x92, 0xfe, 0x72, 0x01, 0x70, 0x2a, 0xfe, 0x8e, 0x01,
-  0x1b, 0x4c, 0xfe, 0xe6, 0x98, 0x64, 0x99, 0x6c, 0x99, 0x64, 0x99, 0xfe,
-  0xe6, 0x4d, 0x01, 0x1b, 0xfe, 0x8e, 0x2a, 0x01, 0x72, 0xfe, 0x71, 0x01,
-  0x91, 0xfe, 0x8c, 0x2a, 0x01, 0x70, 0xfe, 0xe7, 0x4d, 0x01, 0x19, 0x98,
-  0x64, 0x04, 0x17, 0x01, 0xbe, 0xfe, 0x45, 0x01, 0x99, 0x2e, 0xfe, 0x66,
-  0x01, 0x3a, 0x55, 0xfe, 0xc5, 0xab, 0x6f, 0xab, 0x78, 0xaa, 0x6f, 0xac,
-  0xfe, 0xc4, 0x55, 0x01, 0x39, 0xfe, 0x67, 0x2e, 0x01, 0x98, 0xfe, 0x46,
-  0x01, 0xbc, 0xfe, 0x66, 0x2e, 0x01, 0x9b, 0xfe, 0xc5, 0x55, 0x01, 0x3a,
-  0xaa, 0x6f, 0xaa, 0x78, 0xab, 0x6f, 0xa9, 0x01, 0x39, 0x55, 0xfe, 0xc7,
-  0x01, 0x99, 0x2e, 0x00, 0x00, 0x01, 0x00, 0x96, 0xff, 0xe3, 0x05, 0x73,
-  0x05, 0xf0, 0x00, 0x9b, 0x00, 0x00, 0x01, 0x35, 0x34, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d, 0x01,
-  0x17, 0x16, 0x17, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x22,
-  0x23, 0x22, 0x0f, 0x01, 0x16, 0x15, 0x14, 0x07, 0x17, 0x16, 0x33, 0x32,
-  0x3b, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x0f, 0x01,
-  0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x3d, 0x01, 0x26, 0x27, 0x26, 0x27, 0x07, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x33, 0x32, 0x3f, 0x01, 0x26, 0x35,
-  0x34, 0x37, 0x27, 0x26, 0x23, 0x22, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x1f, 0x01, 0x36, 0x37, 0x36, 0x02, 0xd6, 0x43, 0x28, 0x31, 0x32,
-  0x6c, 0x33, 0x30, 0x27, 0x45, 0x0f, 0x1c, 0x15, 0x09, 0x66, 0x3a, 0x23,
-  0x3d, 0x36, 0x2e, 0x14, 0x13, 0x40, 0x1b, 0x12, 0x04, 0x0d, 0x4e, 0x38,
-  0x45, 0x0a, 0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04, 0x05, 0x0b, 0x5c, 0x75,
-  0x0a, 0x09, 0x0a, 0x45, 0x38, 0x4e, 0x0d, 0x04, 0x12, 0x1b, 0x40, 0x13,
-  0x14, 0x2e, 0x36, 0x3d, 0x23, 0x3c, 0x63, 0x0d, 0x18, 0x16, 0x0f, 0x45,
-  0x27, 0x30, 0x33, 0x6c, 0x32, 0x31, 0x28, 0x45, 0x08, 0x07, 0x1a, 0x15,
-  0x0d, 0x63, 0x3c, 0x23, 0x3c, 0x36, 0x2f, 0x14, 0x13, 0x40, 0x1b, 0x12,
-  0x05, 0x0c, 0x4f, 0x38, 0x44, 0x0b, 0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04,
-  0x03, 0x0a, 0x5a, 0x76, 0x09, 0x0a, 0x0b, 0x44, 0x38, 0x4f, 0x0c, 0x05,
-  0x12, 0x1b, 0x40, 0x13, 0x14, 0x2f, 0x36, 0x3c, 0x23, 0x3e, 0x61, 0x0a,
-  0x18, 0x1a, 0x07, 0x03, 0x94, 0x0c, 0x80, 0x77, 0x46, 0x4e, 0x64, 0x30,
-  0x31, 0x31, 0x30, 0x64, 0x4e, 0x46, 0x79, 0x7e, 0x0c, 0x06, 0x0e, 0x17,
-  0x06, 0x44, 0x7a, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34, 0x23, 0x2c, 0x16,
-  0x18, 0x47, 0x32, 0x24, 0x3a, 0x07, 0x13, 0x14, 0x15, 0x14, 0x07, 0x3b,
-  0x24, 0x32, 0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18, 0x07, 0x23, 0x27,
-  0x49, 0x7e, 0x3f, 0x08, 0x19, 0x09, 0x06, 0x0f, 0x7f, 0x79, 0x46, 0x4e,
-  0x64, 0x30, 0x31, 0x31, 0x30, 0x64, 0x4e, 0x46, 0x79, 0x7f, 0x0f, 0x03,
-  0x03, 0x0d, 0x15, 0x08, 0x3f, 0x7e, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34,
-  0x23, 0x2c, 0x16, 0x18, 0x47, 0x32, 0x24, 0x3a, 0x07, 0x14, 0x16, 0x14,
-  0x13, 0x07, 0x3a, 0x24, 0x32, 0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18,
-  0x07, 0x23, 0x27, 0x49, 0x82, 0x3b, 0x06, 0x19, 0x0b, 0x03, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x96, 0xff, 0xe3, 0x05, 0x73, 0x05, 0xf0, 0x00, 0x19,
-  0x00, 0xb5, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01,
-  0x35, 0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x35, 0x34, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d, 0x01,
-  0x17, 0x16, 0x17, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x22,
-  0x23, 0x22, 0x0f, 0x01, 0x16, 0x15, 0x14, 0x07, 0x17, 0x16, 0x33, 0x32,
-  0x3b, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x0f, 0x01,
-  0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x3d, 0x01, 0x26, 0x27, 0x26, 0x27, 0x07, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x33, 0x32, 0x3f, 0x01, 0x26, 0x35,
-  0x34, 0x37, 0x27, 0x26, 0x23, 0x22, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x1f, 0x01, 0x36, 0x37, 0x36, 0x03, 0x17, 0x26, 0x0f, 0x10, 0x0d,
-  0x0d, 0x0e, 0x0e, 0x0d, 0x0d, 0x10, 0x0f, 0x26, 0x0f, 0x11, 0x0c, 0x0e,
-  0x0d, 0x0d, 0x0e, 0x0c, 0x11, 0x50, 0x43, 0x28, 0x31, 0x32, 0x6c, 0x33,
-  0x30, 0x27, 0x45, 0x0f, 0x1c, 0x15, 0x09, 0x66, 0x3a, 0x23, 0x3d, 0x36,
-  0x2e, 0x14, 0x13, 0x40, 0x1b, 0x12, 0x04, 0x0d, 0x4e, 0x38, 0x45, 0x0a,
-  0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04, 0x05, 0x0b, 0x5c, 0x75, 0x0a, 0x09,
-  0x0a, 0x45, 0x38, 0x4e, 0x0d, 0x04, 0x12, 0x1b, 0x40, 0x13, 0x14, 0x2e,
-  0x36, 0x3d, 0x23, 0x3c, 0x63, 0x0d, 0x18, 0x16, 0x0f, 0x45, 0x27, 0x30,
-  0x33, 0x6c, 0x32, 0x31, 0x28, 0x45, 0x08, 0x07, 0x1a, 0x15, 0x0d, 0x63,
-  0x3c, 0x23, 0x3c, 0x36, 0x2f, 0x14, 0x13, 0x40, 0x1b, 0x12, 0x05, 0x0c,
-  0x4f, 0x38, 0x44, 0x0b, 0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04, 0x03, 0x0a,
-  0x5a, 0x76, 0x09, 0x0a, 0x0b, 0x44, 0x38, 0x4f, 0x0c, 0x05, 0x12, 0x1b,
-  0x40, 0x13, 0x14, 0x2f, 0x36, 0x3c, 0x23, 0x3e, 0x61, 0x0a, 0x18, 0x1a,
-  0x07, 0x03, 0x50, 0x08, 0x08, 0x0e, 0x0f, 0x23, 0x15, 0x14, 0x23, 0x0f,
-  0x0e, 0x08, 0x08, 0x08, 0x08, 0x0e, 0x0f, 0x23, 0x14, 0x15, 0x23, 0x0f,
-  0x0e, 0x08, 0x4c, 0x0c, 0x80, 0x77, 0x46, 0x4e, 0x64, 0x30, 0x31, 0x31,
-  0x30, 0x64, 0x4e, 0x46, 0x79, 0x7e, 0x0c, 0x06, 0x0e, 0x17, 0x06, 0x44,
-  0x7a, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34, 0x23, 0x2c, 0x16, 0x18, 0x47,
-  0x32, 0x24, 0x3a, 0x07, 0x13, 0x14, 0x15, 0x14, 0x07, 0x3b, 0x24, 0x32,
-  0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18, 0x07, 0x23, 0x27, 0x49, 0x7e,
-  0x3f, 0x08, 0x19, 0x09, 0x06, 0x0f, 0x7f, 0x79, 0x46, 0x4e, 0x64, 0x30,
-  0x31, 0x31, 0x30, 0x64, 0x4e, 0x46, 0x79, 0x7f, 0x0f, 0x03, 0x03, 0x0d,
-  0x15, 0x08, 0x3f, 0x7e, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34, 0x23, 0x2c,
-  0x16, 0x18, 0x47, 0x32, 0x24, 0x3a, 0x07, 0x14, 0x16, 0x14, 0x13, 0x07,
-  0x3a, 0x24, 0x32, 0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18, 0x07, 0x23,
-  0x27, 0x49, 0x82, 0x3b, 0x06, 0x19, 0x0b, 0x03, 0x00, 0x01, 0x00, 0x90,
-  0xff, 0xe3, 0x05, 0x77, 0x05, 0xf0, 0x00, 0x68, 0x00, 0x00, 0x01, 0x17,
-  0x32, 0x3f, 0x01, 0x27, 0x26, 0x23, 0x07, 0x22, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x35, 0x34,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x14, 0x07, 0x06, 0x1d,
-  0x01, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x0e, 0x01, 0x23, 0x27, 0x22, 0x0f, 0x01, 0x17, 0x16, 0x33, 0x37, 0x32,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x2f, 0x01, 0x15, 0x14, 0x17, 0x16, 0x14, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x3d, 0x01, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x3e, 0x01, 0x01, 0x89, 0x8f, 0x49, 0x1e,
-  0x2a, 0x2a, 0x1c, 0x4d, 0x87, 0x51, 0x92, 0x10, 0x0a, 0x16, 0x26, 0x63,
-  0x12, 0x46, 0x8a, 0x27, 0x40, 0x32, 0x2b, 0x5f, 0x3a, 0x31, 0x4a, 0x97,
-  0x4a, 0x30, 0x39, 0x60, 0x2b, 0x2b, 0x48, 0x2c, 0x84, 0x46, 0x12, 0xa0,
-  0x0a, 0x11, 0x91, 0x4c, 0x8e, 0x48, 0x20, 0x2b, 0x2b, 0x1c, 0x4e, 0x87,
-  0x51, 0x91, 0x11, 0x0a, 0x17, 0x28, 0x61, 0x13, 0x47, 0x39, 0x4f, 0x26,
-  0x40, 0x33, 0x2b, 0x60, 0x39, 0x30, 0x4a, 0x9b, 0x46, 0x31, 0x3a, 0x5f,
-  0x2b, 0x2e, 0x44, 0x2b, 0x86, 0x46, 0x12, 0xa0, 0x0b, 0x11, 0x91, 0x02,
-  0xc4, 0x0a, 0x14, 0x1c, 0x1b, 0x12, 0x07, 0x5d, 0x48, 0x2c, 0x60, 0x2c,
-  0x48, 0x20, 0x06, 0x59, 0x63, 0xa2, 0x21, 0x1c, 0x37, 0x37, 0x99, 0x5c,
-  0xca, 0x34, 0x4f, 0x4f, 0x34, 0xd0, 0x56, 0x8f, 0x41, 0x37, 0x1c, 0x1c,
-  0xa7, 0x67, 0x55, 0x06, 0x33, 0x9a, 0x27, 0x2c, 0x48, 0x5e, 0x0a, 0x14,
-  0x1b, 0x1c, 0x12, 0x07, 0x5d, 0x48, 0x2c, 0x60, 0x2c, 0x4c, 0x1c, 0x06,
-  0x26, 0x33, 0x63, 0xa2, 0x21, 0x1c, 0x37, 0x37, 0x99, 0x5c, 0xca, 0x34,
-  0x4f, 0x4f, 0x37, 0xcd, 0x56, 0x8f, 0x41, 0x37, 0x1c, 0x1e, 0xa5, 0x66,
-  0x56, 0x06, 0x34, 0x9a, 0x26, 0x2c, 0x48, 0x5e, 0x00, 0x04, 0x00, 0x90,
-  0xff, 0xe3, 0x05, 0x77, 0x05, 0xf0, 0x00, 0x0e, 0x00, 0x99, 0x00, 0xb1,
-  0x00, 0xc9, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x13, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x15, 0x14,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x3d, 0x01, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x33, 0x32, 0x3f, 0x01, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x35, 0x34, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d,
-  0x01, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x05, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x36, 0x25, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x23, 0x22, 0x03, 0x04, 0x19, 0x33, 0x21, 0x1b, 0x2c, 0x4c, 0x2c, 0x1b,
-  0x22, 0x32, 0x97, 0x10, 0x30, 0x5b, 0x1d, 0x21, 0x10, 0x0f, 0x51, 0x3f,
-  0x52, 0x11, 0x0a, 0x17, 0x27, 0x62, 0x12, 0x13, 0x33, 0x3b, 0x4b, 0x2a,
-  0x39, 0x43, 0x10, 0x4e, 0x39, 0x30, 0x4a, 0x4c, 0x4f, 0x46, 0x31, 0x3a,
-  0x4d, 0x10, 0x40, 0x3b, 0x2c, 0x49, 0x3c, 0x32, 0x14, 0x12, 0x63, 0x26,
-  0x16, 0x0a, 0x10, 0x53, 0x3f, 0x51, 0x0e, 0x10, 0x22, 0x1c, 0x5b, 0x30,
-  0x10, 0x10, 0x2e, 0x5b, 0x1d, 0x23, 0x10, 0x0e, 0x51, 0x3f, 0x51, 0x12,
-  0x0b, 0x17, 0x26, 0x63, 0x12, 0x14, 0x32, 0x3c, 0x4a, 0x2b, 0x38, 0x43,
-  0x10, 0x4d, 0x3a, 0x31, 0x4a, 0x97, 0x4a, 0x30, 0x39, 0x4e, 0x10, 0x40,
-  0x3c, 0x2c, 0x49, 0x3b, 0x33, 0x13, 0x12, 0x62, 0x27, 0x17, 0x0a, 0x11,
-  0x52, 0x3f, 0x51, 0x0f, 0x10, 0x22, 0x1e, 0x5b, 0x2e, 0xfe, 0xbc, 0x3d,
-  0x3a, 0x1b, 0x1a, 0x08, 0x0a, 0x2f, 0x36, 0x35, 0x07, 0x04, 0x0c, 0x13,
-  0x37, 0x09, 0x0b, 0x1c, 0x27, 0x3f, 0x16, 0x21, 0x01, 0xac, 0x41, 0x20,
-  0x17, 0x3f, 0x26, 0x1c, 0x0b, 0x09, 0x38, 0x13, 0x0c, 0x05, 0x06, 0x35,
-  0x36, 0x30, 0x09, 0x08, 0x1a, 0x1b, 0x3b, 0x03, 0xd3, 0x63, 0x4a, 0x32,
-  0x51, 0x44, 0x1a, 0x2b, 0x2b, 0x1a, 0x44, 0x51, 0x32, 0x4a, 0xfe, 0xb4,
-  0x0b, 0x20, 0x03, 0x01, 0x28, 0x35, 0x48, 0x2c, 0x27, 0x39, 0x2c, 0x4a,
-  0x1e, 0x06, 0x26, 0x30, 0x66, 0x89, 0x29, 0x0a, 0x14, 0x54, 0x7c, 0x5c,
-  0x60, 0x6a, 0x34, 0x4f, 0x4f, 0x37, 0x67, 0x60, 0x5c, 0x7c, 0x54, 0x14,
-  0x0a, 0x27, 0x8b, 0x67, 0x2f, 0x26, 0x06, 0x20, 0x48, 0x2c, 0x39, 0x27,
-  0x2c, 0x49, 0x34, 0x28, 0x01, 0x03, 0x20, 0x0b, 0x0b, 0x1f, 0x03, 0x01,
-  0x28, 0x33, 0x4a, 0x2c, 0x26, 0x39, 0x2d, 0x48, 0x20, 0x06, 0x26, 0x30,
-  0x66, 0x89, 0x29, 0x0a, 0x14, 0x54, 0x7c, 0x5c, 0x60, 0x6a, 0x34, 0x4f,
-  0x4f, 0x34, 0x6a, 0x60, 0x5c, 0x7c, 0x54, 0x14, 0x0a, 0x27, 0x8b, 0x67,
-  0x2f, 0x26, 0x06, 0x1e, 0x4a, 0x2c, 0x39, 0x27, 0x2c, 0x48, 0x35, 0x28,
-  0x01, 0x03, 0x1f, 0x80, 0x12, 0x04, 0x01, 0x22, 0x22, 0x27, 0x18, 0x15,
-  0x21, 0x17, 0x24, 0x15, 0x04, 0x19, 0x28, 0x3a, 0x55, 0x4a, 0x4a, 0x55,
-  0x3a, 0x28, 0x19, 0x04, 0x15, 0x24, 0x17, 0x21, 0x15, 0x18, 0x27, 0x22,
-  0x22, 0x01, 0x04, 0x00, 0x00, 0x02, 0x00, 0x63, 0x00, 0x00, 0x05, 0xa6,
-  0x05, 0xad, 0x00, 0x19, 0x00, 0x77, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37,
-  0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x27,
-  0x0e, 0x01, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01,
-  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e,
-  0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x03, 0x45, 0x82, 0x37,
-  0x37, 0x2e, 0x2f, 0x2e, 0x2e, 0x2f, 0x2e, 0x37, 0x37, 0x82, 0x37, 0x38,
-  0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x38, 0x6c, 0x38, 0x21, 0x32, 0x30,
-  0x31, 0x31, 0x2b, 0x29, 0x25, 0x27, 0x24, 0x28, 0x21, 0x33, 0x2a, 0x52,
-  0x18, 0x2b, 0x1e, 0x28, 0x24, 0x28, 0x24, 0x29, 0x2b, 0x2d, 0x6d, 0x2a,
-  0x33, 0x21, 0x2b, 0x1a, 0x05, 0x04, 0x22, 0x24, 0x29, 0x2b, 0x2d, 0x6d,
-  0x2a, 0x33, 0x21, 0x29, 0x24, 0x2a, 0x23, 0x22, 0x20, 0x14, 0x4e, 0x2b,
-  0x34, 0x1f, 0x29, 0x24, 0x28, 0x25, 0x28, 0x2b, 0x2d, 0x35, 0x38, 0x2a,
-  0x35, 0x25, 0x07, 0x18, 0x28, 0x24, 0x29, 0x2b, 0x2d, 0x35, 0x38, 0x2a,
-  0x33, 0x21, 0x28, 0x24, 0x18, 0x04, 0x0b, 0x1a, 0x1c, 0x30, 0x36, 0x7b,
-  0x49, 0x46, 0x7b, 0x36, 0x30, 0x1c, 0x1a, 0x1a, 0x1c, 0x30, 0x36, 0x7b,
-  0x46, 0x49, 0x7b, 0x36, 0x30, 0x1c, 0x13, 0x35, 0x10, 0x17, 0x17, 0x14,
-  0x2b, 0x27, 0x67, 0x3e, 0x3a, 0x63, 0x2e, 0x26, 0x19, 0x15, 0x05, 0x17,
-  0x22, 0x2e, 0x63, 0x3b, 0x3d, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
-  0x26, 0x31, 0x4e, 0x25, 0x26, 0x57, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
-  0x26, 0x2e, 0x63, 0x3a, 0x3e, 0x6b, 0x23, 0x22, 0x15, 0x04, 0x15, 0x1b,
-  0x24, 0x2e, 0x63, 0x3a, 0x3e, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
-  0x2c, 0x0e, 0x42, 0x3a, 0x3e, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
-  0x26, 0x2e, 0x63, 0x3b, 0x3d, 0x3f, 0x00, 0x00, 0x00, 0x06, 0x00, 0x63,
-  0x00, 0x00, 0x05, 0xa6, 0x05, 0xad, 0x00, 0x5c, 0x00, 0x76, 0x00, 0x8d,
-  0x00, 0xa6, 0x00, 0xbd, 0x00, 0xd6, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36,
-  0x37, 0x36, 0x37, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x2e, 0x01,
-  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e,
-  0x01, 0x15, 0x14, 0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x2e, 0x01, 0x02, 0x32, 0x17, 0x16, 0x17, 0x37, 0x36,
-  0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0x1f, 0x01, 0x36, 0x37, 0x13, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x27, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x03, 0x26, 0x35, 0x34, 0x36, 0x37,
-  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x01, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x2f,
-  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x13, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x0f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x03, 0x04, 0x04, 0x1a, 0x2c,
-  0x21, 0x32, 0x2b, 0x6c, 0x2e, 0x2b, 0x28, 0x25, 0x28, 0x24, 0x29, 0x1d,
-  0x2c, 0x19, 0x51, 0x2b, 0x32, 0x21, 0x29, 0x24, 0x28, 0x25, 0x2b, 0x28,
-  0x36, 0x2c, 0x35, 0x2d, 0x22, 0x37, 0x06, 0x18, 0x24, 0x28, 0x22, 0x32,
-  0x2a, 0x70, 0x2a, 0x33, 0x21, 0x28, 0x24, 0x18, 0x06, 0x38, 0x21, 0x32,
-  0x30, 0x31, 0x31, 0x2b, 0x29, 0x25, 0x27, 0x24, 0x28, 0x21, 0x33, 0x2a,
-  0x52, 0x18, 0x2b, 0x1e, 0x28, 0x24, 0x28, 0x24, 0x29, 0x2b, 0x2d, 0x6d,
-  0x2a, 0x33, 0x21, 0x2b, 0x1a, 0x46, 0x82, 0x37, 0x07, 0x06, 0x0d, 0x0c,
-  0x17, 0x18, 0x17, 0x1c, 0x1b, 0x41, 0x1b, 0x1d, 0x16, 0x19, 0x16, 0x02,
-  0x16, 0x06, 0x07, 0x3d, 0x20, 0x1d, 0x3b, 0x2a, 0x1b, 0x18, 0x5d, 0x16,
-  0x19, 0x16, 0x19, 0x16, 0x1d, 0x1b, 0x41, 0x1b, 0x1d, 0x16, 0x16, 0x03,
-  0xc0, 0x03, 0x2a, 0x26, 0x6c, 0x07, 0x06, 0x20, 0x1c, 0x20, 0x1b, 0x1d,
-  0x16, 0x16, 0x19, 0x16, 0x19, 0x16, 0x1d, 0x13, 0x03, 0x02, 0x00, 0x1f,
-  0x20, 0x15, 0x17, 0x1d, 0x1a, 0x41, 0x1b, 0x1d, 0x17, 0x18, 0x16, 0x19,
-  0x15, 0x5d, 0x18, 0x1b, 0x2b, 0x3b, 0x1d, 0xdd, 0x48, 0x48, 0x12, 0x1d,
-  0x17, 0x18, 0x17, 0x1a, 0x15, 0x17, 0x1d, 0x1a, 0x21, 0x1c, 0x1f, 0x07,
-  0x07, 0x6c, 0x26, 0x2a, 0xf8, 0x25, 0x4e, 0x31, 0x26, 0x19, 0x15, 0x15,
-  0x14, 0x2b, 0x27, 0x67, 0x3d, 0x3b, 0x63, 0x2e, 0x22, 0x17, 0x05, 0x15,
-  0x19, 0x26, 0x2e, 0x63, 0x3a, 0x3e, 0x67, 0x27, 0x2e, 0x11, 0x17, 0x17,
-  0x10, 0x35, 0x0d, 0x3f, 0x3d, 0x3b, 0x63, 0x2e, 0x26, 0x19, 0x15, 0x15,
-  0x19, 0x26, 0x2e, 0x63, 0x3b, 0x3d, 0x3f, 0x0d, 0x35, 0x10, 0x17, 0x17,
-  0x14, 0x2b, 0x27, 0x67, 0x3e, 0x3a, 0x63, 0x2e, 0x26, 0x19, 0x15, 0x05,
-  0x17, 0x22, 0x2e, 0x63, 0x3b, 0x3d, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15,
-  0x19, 0x26, 0x31, 0x4e, 0x03, 0x38, 0x1a, 0x03, 0x04, 0x47, 0x47, 0x14,
-  0x24, 0x3e, 0x1b, 0x18, 0x0e, 0x0d, 0x0d, 0x0e, 0x18, 0x1b, 0x3e, 0x24,
-  0x14, 0x0c, 0x82, 0x04, 0x03, 0xfd, 0x63, 0x06, 0x0e, 0x1e, 0x2e, 0x1e,
-  0x2c, 0x62, 0x17, 0x42, 0x24, 0x23, 0x3e, 0x1b, 0x18, 0x0e, 0x0d, 0x0d,
-  0x0e, 0x18, 0x18, 0x09, 0x01, 0xba, 0x16, 0x17, 0x49, 0x72, 0x30, 0x43,
-  0x04, 0x03, 0x0d, 0x0d, 0x0e, 0x18, 0x18, 0x3e, 0x27, 0x23, 0x3e, 0x1b,
-  0x18, 0x0e, 0x09, 0xfe, 0xc2, 0x4c, 0x4d, 0x18, 0x18, 0x0e, 0x0d, 0x0d,
-  0x0e, 0x18, 0x1b, 0x3e, 0x23, 0x24, 0x42, 0x17, 0x62, 0x2c, 0x1e, 0x2e,
-  0x1e, 0x0e, 0x01, 0x24, 0x0a, 0x0a, 0x09, 0x0e, 0x18, 0x1b, 0x3e, 0x23,
-  0x27, 0x3e, 0x18, 0x18, 0x0e, 0x0d, 0x0d, 0x03, 0x04, 0x43, 0x30, 0x72,
-  0x49, 0x17, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd,
-  0x05, 0xf0, 0x00, 0x29, 0x00, 0x54, 0x00, 0xbd, 0x00, 0xe6, 0x01, 0x11,
-  0x01, 0x3a, 0x01, 0x65, 0x01, 0x7f, 0x01, 0xa9, 0x01, 0xd3, 0x00, 0x00,
-  0x01, 0x26, 0x27, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x36, 0x37,
-  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x25, 0x06, 0x07, 0x17, 0x16, 0x33,
-  0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x26, 0x27, 0x2e, 0x01,
-  0x23, 0x22, 0x0f, 0x01, 0x16, 0x17, 0x37, 0x36, 0x33, 0x32, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23, 0x22,
-  0x23, 0x01, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x16, 0x17, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23, 0x1e, 0x01, 0x15, 0x14,
-  0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x14, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x0e, 0x01,
-  0x23, 0x22, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x34, 0x36, 0x37, 0x22, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x01, 0x26,
-  0x27, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x07, 0x26, 0x27, 0x2e, 0x01, 0x27,
-  0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x3f, 0x01, 0x26, 0x27, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x15, 0x16, 0x17, 0x1e, 0x02, 0x33, 0x32, 0x36, 0x37,
-  0x36, 0x37, 0x01, 0x16, 0x17, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x26,
-  0x27, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x0f, 0x01,
-  0x16, 0x17, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x37, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x0e, 0x01, 0x07, 0x06, 0x07, 0x03, 0x06, 0x07,
-  0x17, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x06, 0x07, 0x0e, 0x01, 0x07, 0x06,
-  0x07, 0x2e, 0x01, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x07, 0x17, 0x16, 0x17,
-  0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x37, 0x36, 0x37, 0x34, 0x26, 0x27,
-  0x26, 0x27, 0x01, 0x36, 0x37, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x14, 0x16, 0x17, 0x16, 0x1f, 0x01,
-  0x36, 0x37, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x1e, 0x01, 0x17, 0x16, 0x17, 0x04, 0x22, 0x07,
-  0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32,
-  0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x13,
-  0x06, 0x07, 0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3f, 0x01, 0x26, 0x27, 0x07,
-  0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x27, 0x03, 0x16, 0x17, 0x37, 0x36, 0x35, 0x34,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
-  0x14, 0x1f, 0x01, 0x36, 0x37, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x02,
-  0x01, 0x05, 0x02, 0xcd, 0x10, 0x08, 0x09, 0x17, 0x09, 0x07, 0x06, 0x03,
-  0x03, 0x06, 0x07, 0x09, 0x15, 0x0b, 0x08, 0x10, 0xcd, 0x02, 0x05, 0xb9,
-  0x21, 0x12, 0x19, 0x2f, 0x14, 0x12, 0x0a, 0x09, 0x09, 0x0a, 0x12, 0x14,
-  0x2f, 0x19, 0x12, 0x21, 0x02, 0xca, 0x02, 0x05, 0x6b, 0x6b, 0x10, 0x1b,
-  0x2f, 0x14, 0x12, 0x0b, 0x09, 0x09, 0x0b, 0x12, 0x14, 0x2f, 0x1b, 0x10,
-  0x08, 0xce, 0x05, 0x02, 0x6d, 0x6c, 0x06, 0x0f, 0x14, 0x09, 0x07, 0x05,
-  0x04, 0x04, 0x05, 0x07, 0x0b, 0x16, 0x0b, 0x06, 0x04, 0xfc, 0x35, 0x21,
-  0x1f, 0x10, 0x0e, 0x1d, 0x1e, 0x24, 0x25, 0x28, 0x27, 0x4c, 0x21, 0x1e,
-  0x1e, 0x1d, 0x24, 0x24, 0x53, 0x24, 0x24, 0x1c, 0x1e, 0x1f, 0x22, 0x4b,
-  0x26, 0x29, 0x25, 0x24, 0x1d, 0x1a, 0x12, 0x0f, 0x1d, 0x23, 0x32, 0x45,
-  0x1e, 0x20, 0x0d, 0x0f, 0x0f, 0x10, 0x1d, 0x19, 0x4d, 0x2d, 0x21, 0x1d,
-  0x0f, 0x0f, 0x3a, 0x24, 0x25, 0x29, 0x29, 0x4a, 0x20, 0x1f, 0x1e, 0x1c,
-  0x24, 0x24, 0x53, 0x24, 0x24, 0x1d, 0x1e, 0x1e, 0x24, 0x47, 0x29, 0x28,
-  0x25, 0x24, 0x3b, 0x0e, 0x10, 0x1f, 0x20, 0x2d, 0x48, 0x1f, 0x1f, 0x0e,
-  0x0e, 0x0e, 0x10, 0x1d, 0x1f, 0x45, 0x01, 0x94, 0x12, 0x0e, 0x80, 0x0a,
-  0x05, 0x07, 0x16, 0x0d, 0x0c, 0x0a, 0x0a, 0x11, 0x05, 0x04, 0x09, 0x08,
-  0x05, 0x0d, 0xa2, 0x0d, 0x0a, 0xa5, 0x1e, 0x0d, 0x13, 0x13, 0x01, 0x09,
-  0x09, 0x26, 0x2f, 0x1a, 0x1d, 0x2d, 0x13, 0x0c, 0x11, 0x01, 0xba, 0x0e,
-  0x09, 0x60, 0x61, 0x0b, 0x14, 0x13, 0x01, 0x09, 0x09, 0x13, 0x13, 0x2f,
-  0x1a, 0x1c, 0x2e, 0x13, 0x0c, 0x05, 0x69, 0x12, 0x0f, 0x44, 0x44, 0x04,
-  0x09, 0x15, 0x0c, 0x0c, 0x0a, 0x0b, 0x09, 0x08, 0x04, 0x04, 0x01, 0x01,
-  0x0a, 0x07, 0x05, 0x03, 0x95, 0x0a, 0x0c, 0xa2, 0x0c, 0x06, 0x06, 0x0a,
-  0x01, 0x01, 0x04, 0x04, 0x11, 0x0b, 0x0a, 0x0c, 0x0c, 0x15, 0x08, 0x05,
-  0x0a, 0x80, 0x10, 0x11, 0x5f, 0x11, 0x0d, 0x12, 0x2e, 0x1c, 0x1a, 0x2f,
-  0x26, 0x09, 0x09, 0x01, 0x13, 0x13, 0x0c, 0x1e, 0xfd, 0xc8, 0x10, 0x11,
-  0x37, 0x37, 0x0b, 0x14, 0x2d, 0x1d, 0x1a, 0x2f, 0x13, 0x13, 0x09, 0x09,
-  0x01, 0x13, 0x14, 0x0c, 0x08, 0xb9, 0x09, 0x0d, 0x56, 0x56, 0x04, 0x09,
-  0x09, 0x04, 0x05, 0x08, 0x09, 0x0a, 0x0a, 0x0c, 0x0f, 0x14, 0x07, 0x05,
-  0x02, 0x01, 0x52, 0x4a, 0x1f, 0x21, 0x1a, 0x1a, 0x1b, 0x1b, 0x1a, 0x1a,
-  0x21, 0x1f, 0x4a, 0x20, 0x20, 0x1a, 0x1a, 0x1b, 0x1b, 0x1a, 0x1a, 0x20,
-  0x02, 0x13, 0x13, 0x18, 0x02, 0x09, 0x08, 0x09, 0x0a, 0x0b, 0x18, 0x0a,
-  0x0a, 0x09, 0x08, 0x09, 0x02, 0x18, 0x14, 0x13, 0x32, 0x09, 0x13, 0x13,
-  0x13, 0x18, 0x16, 0x36, 0x17, 0x17, 0x13, 0x14, 0x13, 0x09, 0x59, 0x14,
-  0x13, 0x1d, 0x1e, 0x13, 0x14, 0x13, 0x17, 0x17, 0x36, 0x16, 0x18, 0x13,
-  0x13, 0x13, 0x02, 0x38, 0x14, 0x14, 0x0d, 0x0d, 0x09, 0x08, 0x09, 0x0a,
-  0x0a, 0x18, 0x0b, 0x0a, 0x09, 0x0a, 0x07, 0x01, 0x02, 0x9a, 0x16, 0x16,
-  0x1c, 0x02, 0x0a, 0x0a, 0x0a, 0x0a, 0x0c, 0x1a, 0x0c, 0x0c, 0x0a, 0x08,
-  0x0a, 0x02, 0x1a, 0x16, 0x14, 0x38, 0x0a, 0x14, 0x16, 0x16, 0x1a, 0x18,
-  0x3c, 0x1a, 0x1a, 0x14, 0x16, 0x16, 0x0a, 0x64, 0x18, 0x14, 0x21, 0x21,
-  0x16, 0x16, 0x14, 0x1a, 0x1a, 0x3c, 0x18, 0x1a, 0x16, 0x16, 0x14, 0x02,
-  0x3e, 0x17, 0x15, 0x0e, 0x0e, 0x0a, 0x08, 0x0a, 0x0c, 0x0c, 0x0c, 0x0e,
-  0x0c, 0x0a, 0x0a, 0x0c, 0x08, 0x01, 0x22, 0x25, 0x55, 0x56, 0x2a, 0x29,
-  0x20, 0x21, 0x10, 0x10, 0x21, 0x24, 0x33, 0x52, 0x20, 0x1f, 0x12, 0x11,
-  0x11, 0x12, 0x1f, 0x20, 0x52, 0x33, 0x26, 0x1f, 0x10, 0x10, 0x21, 0x1c,
-  0x2d, 0x28, 0x2d, 0x25, 0x5a, 0x26, 0x20, 0x22, 0x23, 0x25, 0x28, 0x2e,
-  0x32, 0x24, 0x28, 0x20, 0x1e, 0x26, 0x26, 0x53, 0x2b, 0x2c, 0x29, 0x29,
-  0x41, 0x10, 0x10, 0x21, 0x24, 0x33, 0x52, 0x20, 0x1f, 0x12, 0x11, 0x11,
-  0x12, 0x1f, 0x20, 0x52, 0x33, 0x27, 0x1e, 0x10, 0x10, 0x41, 0x29, 0x29,
-  0x58, 0x54, 0x24, 0x22, 0x22, 0x23, 0x25, 0x28, 0x60, 0x24, 0x28, 0x20,
-  0x22, 0x20, 0xfe, 0x1c, 0x0b, 0x0d, 0xb4, 0x0d, 0x06, 0x08, 0x0a, 0x01,
-  0x01, 0x04, 0x05, 0x12, 0x0c, 0x0c, 0x0d, 0x0d, 0x18, 0x09, 0x06, 0x0a,
-  0x8e, 0x11, 0x13, 0x69, 0x13, 0x0e, 0x14, 0x33, 0x1f, 0x1d, 0x1b, 0x19,
-  0x2b, 0x14, 0x15, 0x14, 0x0e, 0x21, 0x02, 0x78, 0x12, 0x13, 0x3d, 0x3d,
-  0x0d, 0x15, 0x33, 0x1f, 0x1d, 0x1b, 0x19, 0x16, 0x15, 0x14, 0x15, 0x15,
-  0x0d, 0x09, 0xcd, 0x0c, 0x0e, 0x5f, 0x60, 0x05, 0x0b, 0x08, 0x01, 0x01,
-  0x04, 0x05, 0x09, 0x09, 0x0c, 0x0c, 0x0d, 0x10, 0x16, 0x09, 0x05, 0x02,
-  0xfe, 0x1d, 0x13, 0x11, 0x8e, 0x0a, 0x06, 0x08, 0x19, 0x0d, 0x0d, 0x0c,
-  0x0c, 0x12, 0x05, 0x04, 0x01, 0x01, 0x09, 0x09, 0x06, 0x0d, 0xb4, 0x0e,
-  0x0a, 0xb9, 0x21, 0x0e, 0x14, 0x15, 0x14, 0x2b, 0x19, 0x1b, 0x1d, 0x1f,
-  0x33, 0x14, 0x0e, 0x13, 0x01, 0xeb, 0x0f, 0x0b, 0x6b, 0x6b, 0x0d, 0x15,
-  0x15, 0x14, 0x15, 0x16, 0x19, 0x1b, 0x1d, 0x1f, 0x33, 0x15, 0x0d, 0x05,
-  0x75, 0x13, 0x12, 0x4b, 0x4a, 0x05, 0x0b, 0x17, 0x0d, 0x0d, 0x0c, 0x0c,
-  0x09, 0x09, 0x05, 0x04, 0x01, 0x01, 0x0a, 0x09, 0x05, 0x03, 0xdf, 0x0f,
-  0x10, 0x1c, 0x1f, 0x46, 0x29, 0x28, 0x47, 0x1e, 0x1c, 0x10, 0x0f, 0x0f,
-  0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29, 0x46, 0x1f, 0x1c, 0x10, 0xfe, 0x24,
-  0x06, 0x02, 0xe4, 0x11, 0x08, 0x0b, 0x19, 0x0a, 0x09, 0x05, 0x05, 0x05,
-  0x05, 0x09, 0x0a, 0x17, 0x0d, 0x08, 0x11, 0xe4, 0x02, 0x06, 0xcd, 0x25,
-  0x13, 0x1d, 0x33, 0x16, 0x14, 0x0c, 0x0b, 0x0b, 0x0c, 0x14, 0x16, 0x33,
-  0x1d, 0x13, 0x25, 0x03, 0x1a, 0x02, 0x06, 0x77, 0x77, 0x12, 0x1e, 0x33,
-  0x16, 0x14, 0x0c, 0x0b, 0x0b, 0x0c, 0x14, 0x16, 0x33, 0x1e, 0x12, 0x09,
-  0xe5, 0x06, 0x02, 0x78, 0x79, 0x07, 0x0f, 0x16, 0x0a, 0x09, 0x05, 0x05,
-  0x05, 0x05, 0x09, 0x0c, 0x17, 0x0c, 0x07, 0x05, 0x00, 0x04, 0x00, 0x4d,
-  0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x19, 0x00, 0x33, 0x00, 0x4e,
-  0x00, 0x5e, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
-  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01,
-  0x35, 0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x32, 0x17, 0x16, 0x17, 0x1e,
-  0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x2e, 0x01, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
-  0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x36, 0x17,
-  0x03, 0x25, 0x13, 0x0d, 0x01, 0x03, 0x25, 0x1b, 0x01, 0x05, 0x03, 0x2d,
-  0x01, 0x13, 0x05, 0x03, 0x3b, 0x6e, 0x2e, 0x2f, 0x27, 0x27, 0x26, 0x26,
-  0x27, 0x27, 0x2f, 0x2e, 0x6e, 0x2e, 0x30, 0x26, 0x27, 0x27, 0x27, 0x27,
-  0x26, 0x30, 0x65, 0x4e, 0x3e, 0x45, 0x31, 0x33, 0x39, 0x37, 0x35, 0x34,
-  0x42, 0x41, 0x99, 0x3d, 0x46, 0x30, 0x33, 0x39, 0x37, 0x35, 0x33, 0x43,
-  0x41, 0x4a, 0x8b, 0x80, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x63, 0x7d,
-  0x7f, 0xfe, 0xea, 0x80, 0x79, 0x67, 0x65, 0x68, 0x63, 0x6a, 0x61, 0x7f,
-  0x7e, 0x8c, 0x8d, 0xfe, 0xa5, 0x93, 0xfe, 0xa4, 0x01, 0x5c, 0x93, 0x01,
-  0x5b, 0x8d, 0x8e, 0x01, 0x5a, 0x93, 0x01, 0x5d, 0xfe, 0xa3, 0x93, 0xfe,
-  0xa6, 0x04, 0x13, 0x16, 0x18, 0x28, 0x2e, 0x68, 0x3c, 0x3b, 0x68, 0x2e,
-  0x28, 0x18, 0x16, 0x16, 0x18, 0x28, 0x2e, 0x68, 0x3b, 0x3c, 0x68, 0x2e,
-  0x28, 0x18, 0x86, 0x1f, 0x22, 0x36, 0x38, 0x96, 0x54, 0x4e, 0x96, 0x3b,
-  0x39, 0x1f, 0x1f, 0x1f, 0x22, 0x36, 0x38, 0x96, 0xa2, 0x96, 0x3b, 0x39,
-  0x1f, 0x1f, 0x01, 0x6d, 0x3b, 0x38, 0x72, 0x6f, 0xfe, 0xec, 0xa1, 0x98,
-  0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14,
-  0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x08, 0xfe, 0x7d, 0xa3,
-  0xfe, 0x7f, 0x9e, 0x9d, 0xfe, 0x7f, 0xa3, 0xfe, 0x7d, 0x01, 0x83, 0xa3,
-  0x01, 0x81, 0x9d, 0x9e, 0x01, 0x81, 0xa3, 0x00, 0x00, 0x07, 0x00, 0x90,
-  0xff, 0xe3, 0x05, 0x77, 0x05, 0xf0, 0x00, 0x08, 0x00, 0x93, 0x00, 0x9c,
-  0x00, 0xa7, 0x00, 0xb2, 0x00, 0xc1, 0x00, 0xd0, 0x00, 0x00, 0x01, 0x11,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x13, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x15, 0x14,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x3d, 0x01, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x33, 0x32, 0x3f, 0x01, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x35, 0x34, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d,
-  0x01, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23,
-  0x22, 0x0f, 0x01, 0x11, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x13,
-  0x25, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x01, 0x05,
-  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x13, 0x25, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x33, 0x32,
-  0x0d, 0x01, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x23, 0x22, 0x03, 0x04, 0x26, 0x2c, 0x1b, 0x22, 0x32, 0x97, 0x10,
-  0x30, 0x5b, 0x1d, 0x21, 0x10, 0x0f, 0x51, 0x3f, 0x52, 0x11, 0x0a, 0x17,
-  0x27, 0x62, 0x12, 0x13, 0x33, 0x3b, 0x4b, 0x2a, 0x39, 0x43, 0x10, 0x4e,
-  0x39, 0x30, 0x4a, 0x4c, 0x4f, 0x46, 0x31, 0x3a, 0x4d, 0x10, 0x40, 0x3b,
-  0x2c, 0x49, 0x3c, 0x32, 0x14, 0x12, 0x63, 0x26, 0x16, 0x0a, 0x10, 0x53,
-  0x3f, 0x51, 0x0e, 0x10, 0x22, 0x1c, 0x5b, 0x30, 0x10, 0x10, 0x2e, 0x5b,
-  0x1d, 0x23, 0x10, 0x0e, 0x51, 0x3f, 0x51, 0x12, 0x0b, 0x17, 0x26, 0x63,
-  0x12, 0x14, 0x32, 0x3c, 0x4a, 0x2b, 0x38, 0x43, 0x10, 0x4d, 0x3a, 0x31,
-  0x4a, 0x97, 0x4a, 0x30, 0x39, 0x4e, 0x10, 0x40, 0x3c, 0x2c, 0x49, 0x3b,
-  0x33, 0x13, 0x12, 0x62, 0x27, 0x17, 0x0a, 0x11, 0x52, 0x3f, 0x51, 0x0f,
-  0x10, 0x22, 0x1e, 0x5b, 0x2e, 0x8e, 0x26, 0x2c, 0x1b, 0x21, 0x33, 0x9d,
-  0x01, 0x58, 0x13, 0x38, 0x09, 0x0b, 0x1c, 0x26, 0x3f, 0x17, 0x20, 0xfe,
-  0x53, 0xfe, 0xa9, 0x13, 0x37, 0x09, 0x0b, 0x1c, 0x27, 0x3f, 0x16, 0x21,
-  0x40, 0xfe, 0xa9, 0x0c, 0x04, 0x07, 0x35, 0x36, 0x2f, 0x0a, 0x08, 0x1a,
-  0x1b, 0x3a, 0x01, 0xa9, 0x01, 0x58, 0x0c, 0x05, 0x06, 0x35, 0x36, 0x30,
-  0x09, 0x08, 0x1a, 0x1b, 0x3b, 0x03, 0xd3, 0x01, 0xb9, 0x2b, 0x1a, 0x44,
-  0x51, 0x32, 0x4a, 0xfe, 0xb4, 0x0b, 0x20, 0x03, 0x01, 0x28, 0x35, 0x48,
-  0x2c, 0x27, 0x39, 0x2c, 0x4a, 0x1e, 0x06, 0x26, 0x30, 0x66, 0x89, 0x29,
-  0x0a, 0x14, 0x54, 0x7c, 0x5c, 0x60, 0x6a, 0x34, 0x4f, 0x4f, 0x37, 0x67,
-  0x60, 0x5c, 0x7c, 0x54, 0x14, 0x0a, 0x27, 0x8b, 0x67, 0x2f, 0x26, 0x06,
-  0x20, 0x48, 0x2c, 0x39, 0x27, 0x2c, 0x49, 0x34, 0x28, 0x01, 0x03, 0x20,
-  0x0b, 0x0b, 0x1f, 0x03, 0x01, 0x28, 0x33, 0x4a, 0x2c, 0x26, 0x39, 0x2d,
-  0x48, 0x20, 0x06, 0x26, 0x30, 0x66, 0x89, 0x29, 0x0a, 0x14, 0x54, 0x7c,
-  0x5c, 0x60, 0x6a, 0x34, 0x4f, 0x4f, 0x34, 0x6a, 0x60, 0x5c, 0x7c, 0x54,
-  0x14, 0x0a, 0x27, 0x8b, 0x67, 0x2f, 0x26, 0x06, 0x1e, 0x4a, 0x2c, 0x39,
-  0x27, 0x2c, 0x48, 0x35, 0x28, 0x01, 0x03, 0x1f, 0xf5, 0xfe, 0x47, 0x2b,
-  0x1a, 0x44, 0x51, 0x32, 0x4a, 0x01, 0xc1, 0xdd, 0x24, 0x15, 0x04, 0x19,
-  0x28, 0x3a, 0x55, 0xfe, 0xcd, 0xdd, 0x24, 0x15, 0x04, 0x19, 0x28, 0x3a,
-  0x55, 0x01, 0x33, 0xdd, 0x17, 0x21, 0x15, 0x18, 0x27, 0x22, 0x22, 0x01,
-  0x04, 0xfb, 0xdd, 0x17, 0x21, 0x15, 0x18, 0x27, 0x22, 0x22, 0x01, 0x04,
-  0x00, 0x01, 0x00, 0xa3, 0x00, 0x00, 0x05, 0x65, 0x05, 0xd5, 0x00, 0x41,
-  0x00, 0x00, 0x01, 0x27, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x35, 0x33,
-  0x15, 0x17, 0x11, 0x27, 0x37, 0x17, 0x35, 0x33, 0x15, 0x37, 0x17, 0x07,
-  0x11, 0x37, 0x35, 0x33, 0x15, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x07,
-  0x17, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x15, 0x23, 0x35, 0x27, 0x11,
-  0x17, 0x07, 0x27, 0x15, 0x23, 0x35, 0x07, 0x27, 0x37, 0x11, 0x07, 0x15,
-  0x23, 0x35, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x02, 0x98, 0xd8, 0xae,
-  0x36, 0x78, 0xb0, 0x36, 0xb0, 0x6c, 0xd8, 0xae, 0x36, 0x78, 0x6c, 0x79,
-  0x36, 0xaf, 0xd8, 0x6c, 0xb1, 0x36, 0xb1, 0x79, 0x36, 0xaf, 0xd8, 0xd8,
-  0xaf, 0x36, 0x79, 0xb1, 0x36, 0xb1, 0x6c, 0xd8, 0xaf, 0x36, 0x79, 0x6c,
-  0x78, 0x36, 0xae, 0xd8, 0x6c, 0xb0, 0x36, 0xb0, 0x78, 0x36, 0xae, 0x02,
-  0xeb, 0x8a, 0x70, 0x68, 0x4d, 0x72, 0x68, 0x72, 0x9b, 0xe0, 0x8b, 0x01,
-  0x16, 0x6f, 0x68, 0x4d, 0xe3, 0xe3, 0x4d, 0x68, 0x6f, 0xfe, 0xeb, 0x8a,
-  0xe0, 0x9b, 0x72, 0x68, 0x72, 0x4d, 0x68, 0x70, 0x8a, 0x8b, 0x70, 0x68,
-  0x4d, 0x72, 0x68, 0x72, 0x9b, 0xe0, 0x8b, 0xfe, 0xea, 0x6f, 0x68, 0x4d,
-  0xe3, 0xe3, 0x4d, 0x68, 0x6f, 0x01, 0x16, 0x8b, 0xe0, 0x9b, 0x72, 0x68,
-  0x72, 0x4d, 0x68, 0x70, 0x00, 0x07, 0x00, 0x8c, 0x00, 0x00, 0x05, 0x7c,
-  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x25, 0x00, 0x29, 0x00, 0x2d,
-  0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x01, 0x33, 0x11, 0x25, 0x11, 0x37,
-  0x17, 0x07, 0x0d, 0x01, 0x17, 0x07, 0x27, 0x11, 0x25, 0x11, 0x23, 0x11,
-  0x05, 0x11, 0x07, 0x27, 0x37, 0x2d, 0x01, 0x27, 0x37, 0x17, 0x11, 0x05,
-  0x07, 0x15, 0x17, 0x35, 0x25, 0x07, 0x15, 0x37, 0x05, 0x07, 0x17, 0x37,
-  0x25, 0x07, 0x17, 0x37, 0x05, 0x07, 0x15, 0x3f, 0x01, 0x15, 0x17, 0x35,
-  0x02, 0xce, 0x6c, 0x01, 0x06, 0xef, 0x36, 0xf0, 0x01, 0x07, 0xfe, 0xfa,
-  0xef, 0x36, 0xef, 0xfe, 0xfa, 0x6c, 0xfe, 0xfa, 0xee, 0x36, 0xee, 0xfe,
-  0xfa, 0x01, 0x07, 0xef, 0x36, 0xee, 0x01, 0x06, 0x9a, 0x9a, 0x01, 0x06,
-  0x9a, 0x9a, 0xfe, 0x2b, 0x9b, 0x9a, 0x9a, 0x01, 0x71, 0x99, 0x9a, 0x9a,
-  0xfe, 0x2a, 0x9a, 0x9a, 0x6c, 0x9a, 0x05, 0xd5, 0xfe, 0xcc, 0xa9, 0xfe,
-  0xb0, 0x9a, 0x68, 0x9a, 0xa8, 0xa8, 0x99, 0x68, 0x9a, 0xfe, 0xaf, 0xa9,
-  0xfe, 0xcd, 0x01, 0x33, 0xa9, 0x01, 0x51, 0x9a, 0x68, 0x99, 0xa8, 0xa8,
-  0x9a, 0x68, 0x9a, 0x01, 0x50, 0xa9, 0x27, 0xc5, 0x63, 0xc5, 0x63, 0x63,
-  0xc5, 0x63, 0x68, 0x63, 0x62, 0x62, 0x63, 0x63, 0x62, 0x62, 0x67, 0x63,
-  0xc6, 0x63, 0xc6, 0xc6, 0x63, 0xc6, 0x00, 0x00, 0x00, 0x01, 0x00, 0x75,
-  0x00, 0x04, 0x05, 0x92, 0x05, 0xd5, 0x00, 0x41, 0x00, 0x00, 0x01, 0x33,
-  0x15, 0x37, 0x17, 0x07, 0x11, 0x37, 0x11, 0x33, 0x15, 0x37, 0x17, 0x07,
-  0x17, 0x07, 0x27, 0x07, 0x17, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x15,
-  0x23, 0x11, 0x27, 0x11, 0x17, 0x07, 0x27, 0x15, 0x23, 0x35, 0x07, 0x27,
-  0x37, 0x11, 0x07, 0x11, 0x23, 0x35, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17,
-  0x37, 0x27, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x35, 0x33, 0x11, 0x17,
-  0x11, 0x27, 0x37, 0x17, 0x02, 0xce, 0x6c, 0x7e, 0x5a, 0xd8, 0xf1, 0xb4,
-  0x50, 0x36, 0x52, 0x7e, 0x5a, 0xd8, 0xf0, 0xf1, 0xd8, 0x5a, 0x7e, 0x50,
-  0x36, 0x53, 0xb4, 0xed, 0xd8, 0x5a, 0x7e, 0x6c, 0x7e, 0x5a, 0xd8, 0xee,
-  0xb4, 0x52, 0x36, 0x4f, 0x7e, 0x5a, 0xd8, 0xf0, 0xee, 0xd8, 0x5a, 0x7e,
-  0x53, 0x36, 0x50, 0xb4, 0xf2, 0xd8, 0x5a, 0x7e, 0x05, 0xd5, 0x68, 0x51,
-  0xad, 0x8b, 0xfe, 0xce, 0x9b, 0x01, 0x15, 0xa2, 0x34, 0x68, 0x35, 0x51,
-  0xad, 0x8a, 0x99, 0x9b, 0x8b, 0xad, 0x51, 0x34, 0x68, 0x35, 0xa1, 0x01,
-  0x15, 0x98, 0xfe, 0xd0, 0x8b, 0xad, 0x51, 0x68, 0x65, 0x51, 0xad, 0x8b,
-  0x01, 0x35, 0x99, 0xfe, 0xeb, 0xa1, 0x35, 0x68, 0x33, 0x51, 0xae, 0x8b,
-  0x9a, 0x99, 0x8b, 0xad, 0x51, 0x35, 0x68, 0x33, 0xa1, 0xfe, 0xeb, 0x9b,
-  0x01, 0x36, 0x8b, 0xad, 0x51, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x90,
-  0xff, 0xe5, 0x05, 0x78, 0x05, 0xf0, 0x00, 0x87, 0x00, 0x00, 0x01, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x07,
-  0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x27, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x0e, 0x01, 0x22, 0x2e,
-  0x01, 0x34, 0x36, 0x37, 0x36, 0x37, 0x11, 0x07, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x37, 0x27, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x17, 0x11, 0x26, 0x27, 0x2e, 0x01,
-  0x34, 0x36, 0x37, 0x36, 0x33, 0x32, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06,
-  0x07, 0x11, 0x37, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x05, 0x5f, 0x19, 0x19, 0x18, 0x29, 0x2b, 0x2f, 0x31, 0x29,
-  0x12, 0x0f, 0xd9, 0xd9, 0x0f, 0x12, 0x29, 0x31, 0x2f, 0x2b, 0x29, 0x18,
-  0x19, 0x19, 0x19, 0x28, 0x2b, 0x2f, 0x2e, 0x2c, 0x2b, 0x18, 0x17, 0x03,
-  0xd9, 0x13, 0x11, 0x2a, 0x30, 0x30, 0x53, 0x61, 0x53, 0x31, 0x31, 0x29,
-  0x11, 0x13, 0xd9, 0x04, 0x17, 0x19, 0x2a, 0x2a, 0x30, 0x31, 0x29, 0x29,
-  0x19, 0x18, 0x18, 0x19, 0x29, 0x2a, 0x60, 0x2a, 0x11, 0x0f, 0xd9, 0xd9,
-  0x0e, 0x12, 0x2c, 0x2e, 0x31, 0x52, 0x31, 0x18, 0x19, 0x29, 0x2a, 0x30,
-  0x2e, 0x2c, 0x2a, 0x19, 0x17, 0x04, 0xd9, 0x13, 0x11, 0x29, 0x31, 0x31,
-  0x29, 0x2a, 0x30, 0x31, 0x53, 0x30, 0x30, 0x2a, 0x11, 0x13, 0xd9, 0x03,
-  0x17, 0x17, 0x2c, 0x29, 0x31, 0x2f, 0x2b, 0x2d, 0x04, 0x6d, 0x36, 0x2e,
-  0x35, 0x2f, 0x2e, 0x1b, 0x1b, 0x1b, 0x0b, 0x0f, 0x8b, 0x8c, 0x0f, 0x0b,
-  0x1b, 0x1b, 0x1b, 0x2e, 0x2f, 0x35, 0x34, 0x2f, 0x2f, 0x1b, 0x1b, 0x1b,
-  0x1a, 0x2f, 0x2e, 0x36, 0x16, 0x15, 0x8c, 0xfe, 0xe9, 0x07, 0x0b, 0x1b,
-  0x5c, 0x6c, 0x5c, 0x36, 0x36, 0x5c, 0x6c, 0x5c, 0x1b, 0x0b, 0x07, 0x01,
-  0x17, 0x8c, 0x15, 0x16, 0x36, 0x2e, 0x2f, 0x1a, 0x1b, 0x1b, 0x1a, 0x2f,
-  0x2e, 0x36, 0x35, 0x2f, 0x2e, 0x1b, 0x1b, 0x1b, 0x0b, 0x0f, 0x8c, 0x8b,
-  0x0f, 0x0b, 0x1b, 0x36, 0x5c, 0x6c, 0x2e, 0x2f, 0x1a, 0x1b, 0x1b, 0x1a,
-  0x2f, 0x2e, 0x36, 0x16, 0x15, 0x8c, 0x01, 0x17, 0x07, 0x0b, 0x1b, 0x5c,
-  0x6c, 0x5c, 0x1b, 0x1b, 0x36, 0x5c, 0x6c, 0x5c, 0x1b, 0x0b, 0x07, 0xfe,
-  0xe9, 0x8c, 0x15, 0x16, 0x36, 0x2e, 0x2d, 0x1c, 0x1b, 0x1b, 0x1e, 0x00,
-  0x00, 0x09, 0x00, 0x57, 0xff, 0xe5, 0x05, 0xb2, 0x05, 0xd7, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x2e, 0x00, 0x45,
-  0x00, 0x5c, 0x00, 0x73, 0x00, 0x00, 0x00, 0x14, 0x06, 0x22, 0x26, 0x34,
-  0x36, 0x32, 0x09, 0x01, 0x37, 0x09, 0x02, 0x37, 0x09, 0x02, 0x27, 0x09,
-  0x02, 0x27, 0x01, 0x13, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x03, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x03, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x05, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03,
-  0x8b, 0x4f, 0x70, 0x4f, 0x4f, 0x70, 0x01, 0x7d, 0xfe, 0xa3, 0x4d, 0x01,
-  0x5c, 0xfd, 0x59, 0xfe, 0xa5, 0x4d, 0x01, 0x5a, 0x02, 0x5b, 0xfe, 0xa4,
-  0x4d, 0x01, 0x5d, 0xfd, 0xf1, 0xfe, 0xa6, 0x4d, 0x01, 0x5b, 0xa6, 0x33,
-  0x0e, 0x14, 0x04, 0x01, 0x02, 0x03, 0x0d, 0x15, 0x67, 0x14, 0x0e, 0x02,
-  0x02, 0x01, 0x03, 0x15, 0x0d, 0x34, 0x34, 0x0d, 0x15, 0x03, 0x01, 0x02,
-  0x02, 0x0e, 0x14, 0x67, 0x15, 0x0d, 0x03, 0x02, 0x01, 0x04, 0x14, 0x0e,
-  0x8f, 0x36, 0x16, 0x21, 0x3d, 0x1a, 0x4a, 0x3e, 0x1b, 0x3b, 0x1d, 0x2c,
-  0x2c, 0x1d, 0x3b, 0x1b, 0x3e, 0x4a, 0x1a, 0x3d, 0x21, 0x16, 0x01, 0xbb,
-  0x36, 0x15, 0x22, 0x3d, 0x1a, 0x4a, 0x3e, 0x1b, 0x3a, 0x1d, 0x2c, 0x2c,
-  0x1d, 0x3a, 0x1b, 0x3e, 0x4a, 0x1a, 0x3d, 0x22, 0x15, 0x03, 0x2c, 0x7c,
-  0x58, 0x58, 0x7c, 0x58, 0xfd, 0x2e, 0x01, 0x84, 0x55, 0xfe, 0x7c, 0x02,
-  0x4a, 0x01, 0x81, 0x55, 0xfe, 0x7e, 0x01, 0x2d, 0xfe, 0x7c, 0x55, 0x01,
-  0x84, 0xfd, 0x0d, 0xfe, 0x7e, 0x55, 0x01, 0x81, 0x01, 0x2e, 0x3c, 0x18,
-  0x25, 0x44, 0x1d, 0x52, 0x45, 0x1e, 0x41, 0x20, 0x31, 0x31, 0x20, 0x41,
-  0x1e, 0x45, 0x52, 0x1d, 0x44, 0x25, 0x18, 0xfe, 0x14, 0x3c, 0x18, 0x25,
-  0x44, 0x1d, 0x52, 0x45, 0x1e, 0x41, 0x20, 0x31, 0x31, 0x20, 0x41, 0x1e,
-  0x45, 0x52, 0x1d, 0x44, 0x25, 0x18, 0x01, 0x14, 0x39, 0x0f, 0x17, 0x04,
-  0x01, 0x02, 0x03, 0x0f, 0x17, 0x72, 0x17, 0x0f, 0x03, 0x02, 0x01, 0x04,
-  0x17, 0x0f, 0x39, 0x39, 0x0f, 0x17, 0x04, 0x01, 0x02, 0x03, 0x0f, 0x17,
-  0x72, 0x17, 0x0f, 0x03, 0x02, 0x01, 0x04, 0x17, 0x0f, 0x00, 0x00, 0x00,
-  0x00, 0x09, 0x00, 0x57, 0xff, 0xe5, 0x05, 0xb2, 0x05, 0xd7, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x2b, 0x00, 0x3f,
-  0x00, 0x53, 0x00, 0x67, 0x00, 0x00, 0x00, 0x14, 0x06, 0x22, 0x26, 0x34,
-  0x36, 0x32, 0x09, 0x01, 0x17, 0x09, 0x02, 0x17, 0x09, 0x02, 0x07, 0x09,
-  0x02, 0x07, 0x01, 0x02, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x12,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x00, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x24, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x03,
-  0xcf, 0x77, 0xa8, 0x76, 0x76, 0xa8, 0xfd, 0xab, 0x01, 0x0b, 0x4d, 0xfe,
-  0xf5, 0x02, 0x5d, 0x01, 0x0c, 0x4c, 0xfe, 0xf5, 0xfd, 0x56, 0x01, 0x0b,
-  0x4d, 0xfe, 0xf5, 0x02, 0xf7, 0x01, 0x0b, 0x4c, 0xfe, 0xf4, 0x07, 0x11,
-  0x13, 0x23, 0x29, 0x63, 0x2a, 0x23, 0x13, 0x11, 0x11, 0x13, 0x23, 0x2a,
-  0x63, 0x29, 0x23, 0x13, 0x11, 0x11, 0x13, 0x23, 0x29, 0x63, 0x2a, 0x23,
-  0x13, 0x11, 0x11, 0x13, 0x23, 0x2a, 0x63, 0x29, 0x23, 0x13, 0xfd, 0x63,
-  0x65, 0x2c, 0x32, 0x1f, 0x24, 0x24, 0x1f, 0x32, 0x2c, 0x65, 0x2c, 0x31,
-  0x20, 0x24, 0x24, 0x20, 0x31, 0x03, 0xdf, 0x65, 0x2c, 0x32, 0x1f, 0x24,
-  0x24, 0x1f, 0x32, 0x2c, 0x65, 0x2c, 0x31, 0x20, 0x24, 0x24, 0x20, 0x31,
-  0x03, 0x4b, 0xba, 0x84, 0x84, 0xba, 0x84, 0xfd, 0x38, 0x01, 0x29, 0x55,
-  0xfe, 0xd7, 0x03, 0x4c, 0x01, 0x29, 0x55, 0xfe, 0xd7, 0x01, 0x7e, 0xfe,
-  0xd7, 0x55, 0x01, 0x29, 0xfd, 0x5e, 0xfe, 0xd7, 0x55, 0x01, 0x29, 0x03,
-  0x49, 0x70, 0x31, 0x37, 0x23, 0x28, 0x28, 0x23, 0x37, 0x31, 0x70, 0x31,
-  0x37, 0x23, 0x28, 0x28, 0x23, 0x37, 0xfb, 0xb3, 0x70, 0x31, 0x37, 0x23,
-  0x28, 0x28, 0x23, 0x37, 0x31, 0x70, 0x31, 0x37, 0x23, 0x28, 0x28, 0x23,
-  0x37, 0x02, 0x59, 0x13, 0x15, 0x27, 0x2e, 0x6e, 0x2e, 0x27, 0x15, 0x13,
-  0x13, 0x15, 0x27, 0x2e, 0x6e, 0x2e, 0x27, 0x15, 0x13, 0x13, 0x15, 0x27,
-  0x2e, 0x6e, 0x2e, 0x27, 0x15, 0x13, 0x13, 0x15, 0x27, 0x2e, 0x6e, 0x2e,
-  0x27, 0x15, 0x00, 0x00, 0x00, 0x09, 0x00, 0x4b, 0xff, 0xe5, 0x05, 0xbd,
-  0x05, 0xf2, 0x00, 0x0c, 0x00, 0x18, 0x00, 0x25, 0x00, 0x32, 0x00, 0x3f,
-  0x00, 0x4b, 0x00, 0x57, 0x00, 0x5f, 0x00, 0x6b, 0x00, 0x00, 0x01, 0x14,
-  0x07, 0x06, 0x2b, 0x01, 0x25, 0x35, 0x25, 0x33, 0x32, 0x17, 0x16, 0x05,
-  0x34, 0x36, 0x3b, 0x01, 0x05, 0x15, 0x05, 0x23, 0x22, 0x27, 0x26, 0x01,
-  0x16, 0x15, 0x14, 0x0f, 0x01, 0x01, 0x27, 0x13, 0x37, 0x36, 0x33, 0x32,
-  0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x01, 0x17, 0x03, 0x07, 0x06, 0x23,
-  0x22, 0x03, 0x36, 0x33, 0x32, 0x1f, 0x01, 0x13, 0x07, 0x01, 0x27, 0x26,
-  0x35, 0x34, 0x01, 0x06, 0x22, 0x2f, 0x01, 0x03, 0x37, 0x01, 0x17, 0x16,
-  0x15, 0x14, 0x00, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x03, 0x23, 0x03, 0x35,
-  0x34, 0x37, 0x12, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x02, 0x22,
-  0x27, 0x26, 0x3d, 0x01, 0x13, 0x33, 0x13, 0x15, 0x14, 0x07, 0x05, 0xbd,
-  0x19, 0x1a, 0x24, 0x09, 0xfe, 0x8a, 0x01, 0x76, 0x09, 0x23, 0x1b, 0x19,
-  0xfa, 0x8f, 0x32, 0x24, 0x09, 0x01, 0x76, 0xfe, 0x8a, 0x09, 0x22, 0x1b,
-  0x19, 0x04, 0xa5, 0x1b, 0x19, 0x06, 0xfe, 0xd8, 0x40, 0xe8, 0x06, 0x1a,
-  0x25, 0x25, 0xfc, 0x40, 0x1a, 0x18, 0x07, 0x01, 0x28, 0x40, 0xe9, 0x06,
-  0x19, 0x25, 0x24, 0x1c, 0x1a, 0x26, 0x24, 0x1a, 0x06, 0xe9, 0x40, 0xfe,
-  0xd8, 0x07, 0x18, 0x03, 0xf4, 0x1b, 0x49, 0x1a, 0x06, 0xe8, 0x40, 0x01,
-  0x28, 0x06, 0x19, 0xfd, 0xd3, 0x4a, 0x1b, 0x1a, 0x2d, 0x5a, 0x2d, 0x1a,
-  0xc7, 0x4f, 0x70, 0x4f, 0x4f, 0x70, 0x13, 0x4a, 0x1b, 0x1a, 0x2d, 0x5a,
-  0x2d, 0x1a, 0x02, 0xec, 0x2a, 0x1e, 0x1c, 0x32, 0x64, 0x32, 0x1e, 0x1e,
-  0x28, 0x28, 0x3c, 0x32, 0x64, 0x32, 0x1c, 0x1e, 0x02, 0x4d, 0x1d, 0x2a,
-  0x27, 0x1d, 0x07, 0xfe, 0xfe, 0x46, 0x01, 0x49, 0x07, 0x1c, 0xfb, 0x9b,
-  0x1d, 0x2a, 0x27, 0x1d, 0x07, 0x01, 0x02, 0x46, 0xfe, 0xb7, 0x07, 0x1c,
-  0x04, 0x65, 0x1e, 0x1c, 0x07, 0xfe, 0xb7, 0x46, 0x01, 0x02, 0x07, 0x1b,
-  0x29, 0x2a, 0xfb, 0xd6, 0x1e, 0x1c, 0x07, 0x01, 0x49, 0x46, 0xfe, 0xfe,
-  0x07, 0x1b, 0x29, 0x2a, 0x05, 0x0d, 0x1d, 0x1c, 0x28, 0x0a, 0xfe, 0x61,
-  0x01, 0x9f, 0x0a, 0x27, 0x1d, 0xfd, 0x55, 0x7c, 0x58, 0x58, 0x7c, 0x58,
-  0xfc, 0x63, 0x1d, 0x1c, 0x28, 0x0a, 0x01, 0x9f, 0xfe, 0x61, 0x0a, 0x27,
-  0x1d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b, 0xff, 0xe5, 0x05, 0xbd,
-  0x05, 0xf2, 0x00, 0x6c, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x03, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x01, 0x25, 0x36, 0x33, 0x32, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x25, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x03, 0x13, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x13, 0x03, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x05, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x05, 0x01,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x16, 0x17, 0x16, 0x17,
-  0x01, 0x03, 0x26, 0x35, 0x34, 0x37, 0x36, 0x03, 0x04, 0x27, 0x2a, 0x20,
-  0x05, 0x46, 0x01, 0x00, 0x12, 0x02, 0x2f, 0x2d, 0x3c, 0x1b, 0x1b, 0x2e,
-  0x09, 0x17, 0xfe, 0xa2, 0x01, 0xaf, 0x17, 0x0a, 0x45, 0x1e, 0x2a, 0x2a,
-  0x20, 0x43, 0x06, 0x21, 0xfe, 0x57, 0x01, 0x63, 0x19, 0x02, 0x2e, 0x1b,
-  0x1b, 0x3c, 0x27, 0x35, 0x09, 0x10, 0xfb, 0x46, 0x05, 0x20, 0x2a, 0x4d,
-  0x2b, 0x1f, 0x04, 0x46, 0xfb, 0x10, 0x09, 0x2f, 0x2d, 0x3b, 0x1c, 0x1b,
-  0x2f, 0x02, 0x19, 0x01, 0x62, 0xfe, 0x58, 0x22, 0x06, 0x43, 0x20, 0x29,
-  0x29, 0x1f, 0x44, 0x0b, 0x16, 0x01, 0xaf, 0xfe, 0xa2, 0x16, 0x09, 0x2f,
-  0x1b, 0x1c, 0x3b, 0x21, 0x3b, 0x02, 0x13, 0x00, 0xff, 0x46, 0x04, 0x1f,
-  0x2a, 0x05, 0xf2, 0x2f, 0x23, 0x4a, 0x07, 0x1f, 0xfe, 0x22, 0x01, 0x89,
-  0x1d, 0x01, 0x35, 0x1f, 0x1e, 0x43, 0x37, 0x2f, 0x09, 0x12, 0xfe, 0xe9,
-  0x4e, 0x04, 0x22, 0x2e, 0x58, 0x2e, 0x24, 0x06, 0x4d, 0xfe, 0xe5, 0x16,
-  0x01, 0x35, 0x31, 0x43, 0x1e, 0x1f, 0x35, 0x09, 0x19, 0x01, 0x85, 0xfe,
-  0x22, 0x1f, 0x07, 0x4a, 0x23, 0x2f, 0x2f, 0x23, 0x4a, 0x0e, 0x1e, 0x01,
-  0xd8, 0xfe, 0x7b, 0x19, 0x09, 0x35, 0x1f, 0x1e, 0x43, 0x4c, 0x1a, 0x01,
-  0x16, 0x01, 0x1b, 0x4d, 0x06, 0x24, 0x2e, 0x58, 0x2e, 0x22, 0x04, 0x4e,
-  0x01, 0x17, 0x12, 0x09, 0x35, 0x31, 0x43, 0x1e, 0x1f, 0x14, 0x21, 0x01,
-  0x1d, 0xfe, 0x77, 0x01, 0xd8, 0x1e, 0x0e, 0x4a, 0x23, 0x2f, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x5b, 0xff, 0xec, 0x06, 0x19, 0x05, 0xe8, 0x00, 0x0d,
-  0x00, 0x23, 0x00, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
-  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x01, 0x06, 0x23, 0x20, 0x00, 0x11,
-  0x34, 0x12, 0x24, 0x33, 0x32, 0x17, 0x36, 0x33, 0x32, 0x04, 0x12, 0x15,
-  0x10, 0x00, 0x21, 0x22, 0xa6, 0x01, 0x68, 0x00, 0xff, 0x01, 0x00, 0x01,
-  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9b, 0xfe, 0xd8, 0xa4, 0x02, 0x93, 0x16,
-  0x17, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0x17, 0x16, 0x17,
-  0x16, 0xae, 0x01, 0x4c, 0xb9, 0xfe, 0x6b, 0xfe, 0xe2, 0x16, 0x02, 0xea,
-  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
-  0xb1, 0xfe, 0xb9, 0xfc, 0x51, 0x02, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01,
-  0x72, 0xc6, 0x02, 0x02, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xc1, 0xfe, 0x41,
-  0x00, 0x02, 0x00, 0x6d, 0xff, 0x9c, 0x06, 0x07, 0x05, 0xd4, 0x00, 0x03,
-  0x00, 0x0b, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11, 0x17, 0x23, 0x11, 0x21,
-  0x15, 0x33, 0x11, 0x21, 0x05, 0x62, 0xfb, 0x56, 0x10, 0x5a, 0x05, 0x3f,
-  0x5a, 0xfa, 0xc1, 0x53, 0x05, 0x2e, 0xfa, 0xd2, 0x53, 0x05, 0xd4, 0x64,
-  0xfa, 0x2c, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6d, 0x00, 0x00, 0x06, 0x07,
-  0x06, 0x38, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11,
-  0x25, 0x15, 0x21, 0x11, 0x33, 0x35, 0x21, 0x11, 0x05, 0x62, 0xfb, 0x56,
-  0x04, 0xf5, 0xfa, 0xc1, 0x5a, 0x05, 0x3f, 0x53, 0x05, 0x2e, 0xfa, 0xd2,
-  0x11, 0x64, 0x05, 0xd4, 0x64, 0xfa, 0x2c, 0x00, 0x00, 0x02, 0x00, 0x6d,
-  0xff, 0x9c, 0x06, 0x07, 0x05, 0xd4, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00,
-  0x25, 0x11, 0x21, 0x11, 0x07, 0x11, 0x21, 0x17, 0x11, 0x21, 0x05, 0x62,
-  0xfb, 0x56, 0x4a, 0x05, 0x3f, 0x5a, 0xfa, 0xdc, 0x53, 0x05, 0x2e, 0xfa,
-  0xd2, 0x53, 0x05, 0xd4, 0x82, 0xfa, 0x4a, 0x00, 0x00, 0x02, 0x00, 0x6d,
-  0x00, 0x00, 0x06, 0x07, 0x06, 0x38, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00,
-  0x25, 0x11, 0x21, 0x11, 0x05, 0x21, 0x11, 0x37, 0x21, 0x11, 0x05, 0x62,
-  0xfb, 0x56, 0x04, 0xf5, 0xfa, 0xc1, 0x75, 0x05, 0x24, 0x53, 0x05, 0x2e,
-  0xfa, 0xd2, 0x53, 0x05, 0xd4, 0x64, 0xfa, 0x4a, 0x00, 0x04, 0x00, 0x99,
-  0xff, 0xfb, 0x05, 0xdc, 0x05, 0xd3, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x00, 0x13, 0x09, 0x0e, 0x99, 0x01, 0x31, 0x01, 0x31,
-  0xfe, 0xcf, 0x01, 0xaf, 0x01, 0x32, 0x01, 0x30, 0xfe, 0xd0, 0xfd, 0x60,
-  0x01, 0x31, 0x01, 0x31, 0xfe, 0xcf, 0xfe, 0xcf, 0x01, 0x31, 0x01, 0x31,
-  0xfe, 0xcf, 0x02, 0xe9, 0x01, 0x53, 0xfe, 0xad, 0xfe, 0xad, 0x01, 0x53,
-  0x01, 0x52, 0xfe, 0xae, 0xfe, 0xab, 0x02, 0xea, 0x01, 0x55, 0xfe, 0xab,
-  0xfe, 0xae, 0xfe, 0x22, 0x01, 0x53, 0xfe, 0xad, 0xfe, 0xad, 0x00, 0x00,
-  0x00, 0x01, 0x02, 0xb7, 0xfe, 0x14, 0x03, 0x51, 0x06, 0x14, 0x00, 0x03,
-  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x03, 0x51, 0x99, 0x06, 0x14, 0xf8,
-  0x00, 0x08, 0x00, 0x00, 0x00, 0x01, 0x02, 0x6b, 0xfe, 0x14, 0x03, 0x9e,
-  0x06, 0x14, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x03, 0x9d,
-  0xfe, 0xce, 0x06, 0x14, 0xf8, 0x00, 0x08, 0x00, 0x00, 0x01, 0x01, 0xd2,
-  0xfe, 0x14, 0x04, 0x37, 0x06, 0x14, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x11, 0x04, 0x36, 0xfd, 0x9c, 0x06, 0x14, 0xf8, 0x00, 0x08, 0x00,
-  0x00, 0x01, 0x00, 0x9c, 0x03, 0x28, 0x01, 0xe6, 0x05, 0xd5, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x21, 0x11, 0x13, 0x33, 0x03, 0x33, 0x01, 0xe6, 0xfe,
-  0xb7, 0x93, 0x74, 0x4a, 0x8c, 0x03, 0x28, 0x01, 0x6e, 0x01, 0x3f, 0xfe,
-  0xc1, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6c, 0x03, 0x28, 0x01, 0xb6,
-  0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21, 0x11, 0x03, 0x23, 0x13,
-  0x23, 0x6c, 0x01, 0x49, 0x93, 0x74, 0x4a, 0x8c, 0x05, 0xd5, 0xfe, 0x92,
-  0xfe, 0xc1, 0x01, 0x3f, 0xff, 0xff, 0x00, 0x9c, 0x03, 0x28, 0x03, 0x74,
-  0x05, 0xd5, 0x10, 0x26, 0x0c, 0x34, 0x00, 0x00, 0x10, 0x07, 0x0c, 0x34,
-  0x01, 0x8e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c, 0x03, 0x28, 0x03, 0x44,
-  0x05, 0xd5, 0x10, 0x26, 0x0c, 0x35, 0x00, 0x00, 0x10, 0x07, 0x0c, 0x35,
-  0x01, 0x8e, 0x00, 0x00, 0x00, 0x02, 0x01, 0x1e, 0xff, 0x42, 0x05, 0x8f,
-  0x06, 0xcf, 0x00, 0x44, 0x00, 0x48, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x07, 0x06, 0x07, 0x0e, 0x01, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32,
-  0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x11, 0x21, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x33, 0x21, 0x35, 0x37, 0x15, 0x21, 0x07, 0x23, 0x11, 0x14, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x01, 0x11, 0x23, 0x11, 0x02, 0x94, 0x1c,
-  0x17, 0x18, 0x14, 0x13, 0x15, 0x15, 0x13, 0x14, 0x18, 0x17, 0x18, 0x19,
-  0x11, 0x11, 0x0f, 0x0f, 0x0e, 0x11, 0x0e, 0x12, 0x0f, 0x15, 0x56, 0x38,
-  0x41, 0x29, 0x31, 0x2f, 0xfe, 0xec, 0xc8, 0xe4, 0xea, 0xc2, 0x01, 0x14,
-  0x7f, 0x01, 0x32, 0x7e, 0xb4, 0x48, 0x38, 0x3c, 0x48, 0x46, 0xa0, 0x3d,
-  0x40, 0x28, 0x2d, 0x2a, 0x2c, 0x2b, 0x22, 0x3d, 0x33, 0x01, 0x7e, 0xab,
-  0x01, 0xd0, 0x0b, 0x0c, 0x15, 0x14, 0x38, 0x1f, 0x1e, 0x38, 0x14, 0x15,
-  0x0c, 0x0b, 0x09, 0x08, 0x10, 0x10, 0x27, 0x2e, 0x2a, 0x0e, 0x12, 0x06,
-  0x09, 0x1b, 0x21, 0x2d, 0x38, 0x81, 0x44, 0x01, 0x5f, 0xee, 0xb8, 0xbe,
-  0xe8, 0xc8, 0x32, 0xfa, 0x7b, 0xfb, 0xdb, 0x6a, 0xb7, 0x40, 0x46, 0x27,
-  0x25, 0x19, 0x1a, 0x2e, 0x33, 0x72, 0x40, 0x4d, 0x64, 0x37, 0x2b, 0x1d,
-  0x18, 0x01, 0x34, 0x02, 0x56, 0xfd, 0xaa, 0x00, 0x00, 0x02, 0x01, 0x74,
-  0xff, 0xdd, 0x04, 0x94, 0x05, 0xf0, 0x00, 0x15, 0x00, 0x2f, 0x00, 0x00,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x12, 0x32,
-  0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37,
-  0x03, 0x04, 0x90, 0x6d, 0x26, 0x27, 0x23, 0x23, 0x7b, 0xa0, 0x75, 0x78,
-  0x9d, 0x7a, 0x23, 0x22, 0x21, 0x2c, 0x54, 0x71, 0x70, 0x2f, 0x2f, 0x28,
-  0x29, 0x26, 0x26, 0x29, 0x28, 0x2f, 0x2f, 0x70, 0x2e, 0x30, 0x28, 0x28,
-  0x27, 0x27, 0x28, 0x28, 0x30, 0x05, 0xf0, 0x28, 0x0e, 0x2b, 0x26, 0x61,
-  0x34, 0x7c, 0x64, 0x83, 0xce, 0xce, 0x83, 0x66, 0x7a, 0x34, 0x61, 0x26,
-  0x24, 0x15, 0x28, 0xfc, 0x46, 0x16, 0x18, 0x2a, 0x2e, 0x6a, 0x3d, 0x3c,
-  0x6a, 0x2e, 0x2a, 0x18, 0x16, 0x16, 0x18, 0x2a, 0x2e, 0x6a, 0x3c, 0x3d,
-  0x6a, 0x2e, 0x2a, 0x18, 0x00, 0x02, 0x01, 0x2c, 0xff, 0xdd, 0x04, 0xdc,
-  0x05, 0xf0, 0x00, 0x21, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e,
-  0x01, 0x15, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x02, 0x32, 0x17, 0x16, 0x17, 0x1e,
-  0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x03, 0x04, 0x6e, 0xef,
-  0x7a, 0x23, 0x22, 0x21, 0x2c, 0x29, 0x61, 0x29, 0x2b, 0x22, 0x21, 0x24,
-  0x24, 0x22, 0x22, 0x2a, 0x29, 0x62, 0x28, 0x2c, 0x21, 0x23, 0x23, 0x7b,
-  0xef, 0xa6, 0x70, 0x2f, 0x2f, 0x28, 0x29, 0x26, 0x26, 0x29, 0x28, 0x2f,
-  0x2f, 0x70, 0x2e, 0x30, 0x28, 0x28, 0x27, 0x27, 0x28, 0x28, 0x30, 0x02,
-  0xad, 0xc4, 0xa1, 0x53, 0x83, 0x34, 0x61, 0x26, 0x24, 0x15, 0x14, 0x14,
-  0x14, 0x25, 0x25, 0x60, 0x36, 0x36, 0x60, 0x25, 0x25, 0x14, 0x14, 0x14,
-  0x15, 0x24, 0x26, 0x61, 0x34, 0x84, 0x52, 0xa1, 0xfe, 0xc5, 0x16, 0x18,
-  0x2a, 0x2e, 0x6a, 0x3d, 0x3c, 0x6a, 0x2e, 0x2a, 0x18, 0x16, 0x16, 0x18,
-  0x2a, 0x2e, 0x6a, 0x3c, 0x3d, 0x6a, 0x2e, 0x2a, 0x18, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x63, 0x00, 0xab, 0x05, 0xa6, 0x05, 0x28, 0x00, 0x21,
-  0x00, 0x00, 0x25, 0x26, 0x25, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x34, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x04,
-  0x03, 0x04, 0x7b, 0xfe, 0x89, 0xaf, 0x31, 0x32, 0x30, 0x3e, 0x3a, 0x8b,
-  0x3a, 0x3e, 0x30, 0x30, 0x33, 0x34, 0x2f, 0x31, 0x3d, 0x3b, 0x8a, 0x3b,
-  0x3e, 0x2f, 0x32, 0x31, 0xae, 0xfe, 0x89, 0xab, 0xef, 0xf2, 0x71, 0xb2,
-  0x4b, 0x8a, 0x36, 0x34, 0x1e, 0x1c, 0x1c, 0x1d, 0x35, 0x34, 0x89, 0x4e,
-  0x4e, 0x89, 0x34, 0x35, 0x1d, 0x1c, 0x1c, 0x1e, 0x34, 0x36, 0x8a, 0x4b,
-  0xb4, 0x6f, 0xf2, 0x00, 0x00, 0x01, 0x01, 0x35, 0xff, 0xfe, 0x05, 0x3f,
-  0x05, 0xd6, 0x00, 0x23, 0x00, 0x00, 0x01, 0x06, 0x03, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01,
-  0x33, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x33, 0x32, 0x17, 0x12, 0x05, 0x3f, 0xd6, 0xda, 0x67, 0xa0,
-  0x43, 0x7c, 0x30, 0x2f, 0x1b, 0x19, 0x19, 0x19, 0x31, 0x2e, 0x7b, 0x46,
-  0x46, 0x7b, 0x2e, 0x31, 0x19, 0x19, 0x19, 0x1b, 0x2f, 0x30, 0x7c, 0x43,
-  0xa2, 0x65, 0xda, 0x02, 0xea, 0x8a, 0xfe, 0x60, 0xc2, 0x36, 0x38, 0x34,
-  0x46, 0x40, 0x4e, 0x4c, 0x42, 0x44, 0x36, 0x34, 0x3a, 0x38, 0x36, 0x36,
-  0x44, 0x40, 0x4e, 0x4c, 0x42, 0x44, 0x36, 0x36, 0x38, 0xc2, 0xfe, 0x5e,
-  0x00, 0x02, 0x00, 0x71, 0x00, 0x2a, 0x05, 0x37, 0x05, 0x9e, 0x00, 0x0d,
-  0x00, 0x69, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x06, 0x07, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x15, 0x14, 0x05, 0x06, 0x15, 0x14, 0x33, 0x32, 0x37, 0x36,
-  0x33, 0x32, 0x15, 0x14, 0x21, 0x22, 0x27, 0x26, 0x35, 0x10, 0x33, 0x32,
-  0x17, 0x36, 0x37, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x1f, 0x01, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x03, 0x3b, 0x09, 0x1a, 0x16, 0x30, 0x1b, 0x14, 0x11, 0x27,
-  0x42, 0x64, 0x13, 0x29, 0x54, 0x4e, 0x6f, 0x36, 0x28, 0xfe, 0xea, 0x8a,
-  0x5f, 0x68, 0x0f, 0x2d, 0x31, 0x39, 0xfe, 0xe4, 0xb7, 0xa8, 0xb2, 0xeb,
-  0x5c, 0x49, 0x45, 0x0e, 0x5b, 0xcf, 0x3e, 0x42, 0x4b, 0x39, 0x24, 0x26,
-  0x17, 0x21, 0x12, 0x1d, 0x16, 0x0d, 0x68, 0x54, 0x6a, 0x5d, 0x2d, 0x44,
-  0x25, 0x26, 0x46, 0x44, 0x2c, 0x2e, 0x0e, 0x36, 0x4d, 0x45, 0x25, 0x29,
-  0x13, 0x26, 0x13, 0x1c, 0x32, 0x3b, 0x26, 0x12, 0x81, 0x56, 0x6c, 0x3a,
-  0x04, 0x67, 0x30, 0x2c, 0x3f, 0x29, 0x21, 0x12, 0x0f, 0x1b, 0x3a, 0x22,
-  0x39, 0x8c, 0x4a, 0x4f, 0x43, 0x51, 0x3e, 0x5e, 0xda, 0x76, 0x3a, 0x4d,
-  0x63, 0x2a, 0x84, 0x5a, 0x9c, 0x99, 0xa3, 0xfe, 0x01, 0x65, 0x8d, 0x97,
-  0x43, 0x30, 0xaa, 0x33, 0x4e, 0x33, 0x35, 0x25, 0x26, 0x1d, 0x17, 0x14,
-  0x1c, 0x2d, 0x19, 0x4b, 0x74, 0x5c, 0x4b, 0x25, 0x39, 0x53, 0x1f, 0x20,
-  0x3e, 0x42, 0x57, 0x4e, 0x3d, 0x11, 0x21, 0x24, 0x1f, 0x3f, 0x12, 0x24,
-  0x15, 0x38, 0x1c, 0x28, 0x46, 0x21, 0x35, 0x7b, 0x5e, 0x3f, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x90, 0x01, 0x5a, 0x05, 0x78, 0x04, 0x84, 0x00, 0x09,
-  0x00, 0x51, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36,
-  0x35, 0x34, 0x01, 0x20, 0x35, 0x34, 0x37, 0x26, 0x27, 0x26, 0x2b, 0x01,
-  0x16, 0x07, 0x06, 0x07, 0x16, 0x33, 0x32, 0x37, 0x16, 0x15, 0x14, 0x23,
-  0x22, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x32,
-  0x17, 0x16, 0x17, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x13, 0x16,
-  0x33, 0x32, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x15, 0x14,
-  0x07, 0x06, 0x01, 0xaf, 0x39, 0x28, 0x3c, 0x18, 0x47, 0x38, 0x37, 0x01,
-  0xcb, 0xfe, 0xb0, 0x6b, 0x2c, 0x30, 0x22, 0x22, 0x03, 0x01, 0x43, 0x57,
-  0x5a, 0x17, 0x3c, 0x27, 0x24, 0x07, 0x82, 0x61, 0x12, 0x20, 0x23, 0x1b,
-  0x5b, 0x45, 0x39, 0x0d, 0x21, 0x1f, 0x37, 0x41, 0x58, 0x0b, 0x81, 0x3b,
-  0x04, 0x37, 0x25, 0x27, 0x32, 0x1c, 0x37, 0x29, 0x62, 0xc3, 0x33, 0x16,
-  0x5b, 0x58, 0x0b, 0x0a, 0x48, 0x3c, 0xdf, 0x9e, 0x03, 0x3e, 0x0e, 0x24,
-  0x33, 0x67, 0x1d, 0x3a, 0x38, 0x34, 0x04, 0xfe, 0x21, 0xfe, 0x45, 0x42,
-  0x37, 0x1c, 0x14, 0x57, 0x50, 0x66, 0x0f, 0x47, 0x2b, 0x1e, 0x31, 0x4b,
-  0xab, 0x48, 0x8e, 0x50, 0x3c, 0x02, 0x12, 0x12, 0x12, 0x0e, 0x11, 0x46,
-  0x66, 0x1d, 0x23, 0x26, 0x54, 0x27, 0x19, 0x13, 0x14, 0x30, 0x50, 0x2b,
-  0x41, 0x27, 0x1d, 0xfe, 0x93, 0x9a, 0x3c, 0x1e, 0x12, 0x11, 0x1b, 0x3c,
-  0x51, 0xad, 0x62, 0x46, 0x00, 0x01, 0x01, 0x68, 0xfe, 0xe4, 0x04, 0xab,
-  0x06, 0x27, 0x00, 0x20, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x15,
-  0x22, 0x07, 0x06, 0x02, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x33, 0x04, 0xaa, 0xa7, 0x98, 0x91, 0x7c, 0x79, 0x3f, 0x3d,
-  0x3d, 0x3a, 0x7e, 0x76, 0x97, 0x98, 0xa7, 0x62, 0x5d, 0x57, 0x95, 0x24,
-  0x24, 0x24, 0x24, 0x4b, 0x46, 0x5b, 0x59, 0x66, 0xfe, 0xe4, 0x47, 0x43,
-  0x89, 0x85, 0xa7, 0xa4, 0xbb, 0xbd, 0xa9, 0x9d, 0x8f, 0x86, 0x46, 0x47,
-  0x2f, 0x43, 0x3e, 0xfe, 0xfa, 0x9b, 0x9c, 0xb8, 0xb1, 0x9c, 0x9b, 0x83,
-  0x7d, 0x44, 0x43, 0x00, 0x00, 0x01, 0x01, 0x68, 0xfe, 0xe4, 0x04, 0xab,
-  0x06, 0x27, 0x00, 0x22, 0x00, 0x00, 0x01, 0x30, 0x35, 0x32, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x02, 0x27, 0x26, 0x23,
-  0x30, 0x35, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x01, 0x69, 0x67, 0x59, 0x5b, 0x46, 0x4a,
-  0x24, 0x24, 0x24, 0x24, 0x95, 0x56, 0x5e, 0x62, 0xa7, 0x98, 0x97, 0x77,
-  0x7e, 0x39, 0x3d, 0x3d, 0x3f, 0x78, 0x7d, 0x91, 0x98, 0xfe, 0xe4, 0x2f,
-  0x43, 0x44, 0x7d, 0x83, 0x9b, 0x9c, 0xb1, 0xb8, 0x9c, 0x9b, 0x01, 0x06,
-  0x3e, 0x43, 0x2f, 0x47, 0x46, 0x86, 0x8f, 0x9d, 0xa9, 0xbd, 0xbb, 0xa4,
-  0xa7, 0x85, 0x89, 0x43, 0x47, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe6,
-  0xfe, 0xf1, 0x04, 0x23, 0x06, 0x11, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x06,
-  0x02, 0x10, 0x12, 0x17, 0x21, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x04,
-  0x22, 0x78, 0x75, 0x76, 0x77, 0xfe, 0xd2, 0x87, 0x86, 0x85, 0x88, 0x06,
-  0x11, 0xe6, 0xfe, 0x3e, 0xfe, 0x32, 0xfe, 0x3b, 0xe5, 0xeb, 0x01, 0xc6,
-  0xe0, 0xdf, 0x01, 0xc4, 0xec, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe6,
-  0xfe, 0xf1, 0x04, 0x23, 0x06, 0x11, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x30,
-  0x21, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x21, 0x36, 0x12, 0x10, 0x02,
-  0x01, 0xe7, 0x01, 0x2e, 0x88, 0x85, 0x86, 0x87, 0xfe, 0xd2, 0x78, 0x75,
-  0x74, 0x06, 0x11, 0xec, 0xfe, 0x3c, 0xdf, 0xe0, 0xfe, 0x3a, 0xeb, 0xe5,
-  0x01, 0xc5, 0x01, 0xce, 0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x01, 0x8c,
-  0xfe, 0x14, 0x04, 0x5f, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x09, 0x01, 0x21, 0x01, 0x04, 0x5f, 0xfe, 0xf9, 0xfe, 0x35, 0x01, 0xcb,
-  0x01, 0x07, 0xfe, 0x33, 0xfe, 0x14, 0x04, 0x00, 0x04, 0x00, 0xfc, 0x00,
-  0x00, 0x01, 0x01, 0xab, 0xfe, 0x14, 0x04, 0x7d, 0x06, 0x14, 0x00, 0x05,
-  0x00, 0x00, 0x09, 0x02, 0x21, 0x09, 0x01, 0x01, 0xac, 0x01, 0xcb, 0xfe,
-  0x35, 0x01, 0x05, 0x01, 0xcb, 0xfe, 0x35, 0xfe, 0x14, 0x04, 0x00, 0x04,
-  0x00, 0xfc, 0x00, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x05,
-  0xfe, 0x14, 0x04, 0xef, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x09, 0x01, 0x21, 0x01, 0x04, 0xef, 0xfe, 0x69, 0xfd, 0xae, 0x02, 0x52,
-  0x01, 0x97, 0xfd, 0xa3, 0xfe, 0x14, 0x04, 0x00, 0x04, 0x00, 0xfc, 0x00,
-  0x00, 0x01, 0x01, 0x19, 0xfe, 0x14, 0x05, 0x03, 0x06, 0x14, 0x00, 0x05,
-  0x00, 0x00, 0x09, 0x02, 0x21, 0x09, 0x01, 0x01, 0x1a, 0x02, 0x5c, 0xfd,
-  0xa4, 0x01, 0x96, 0x02, 0x52, 0xfd, 0xae, 0xfe, 0x14, 0x04, 0x00, 0x04,
-  0x00, 0xfc, 0x00, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x32,
-  0xfe, 0x14, 0x04, 0xb9, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
-  0x09, 0x01, 0x21, 0x01, 0x04, 0xb9, 0xfe, 0x45, 0xfe, 0x35, 0x01, 0xcb,
-  0x01, 0xbb, 0xfe, 0x33, 0xfe, 0x14, 0x04, 0x00, 0x04, 0x00, 0xfc, 0x00,
-  0x00, 0x01, 0x01, 0x51, 0xfe, 0x14, 0x04, 0xd7, 0x06, 0x14, 0x00, 0x05,
-  0x00, 0x00, 0x09, 0x02, 0x21, 0x09, 0x01, 0x01, 0x52, 0x01, 0xcb, 0xfe,
-  0x35, 0x01, 0xb9, 0x01, 0xcb, 0xfe, 0x35, 0xfe, 0x14, 0x04, 0x00, 0x04,
-  0x00, 0xfc, 0x00, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7d,
-  0xfe, 0x13, 0x03, 0xdb, 0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x05, 0x17,
-  0x07, 0x03, 0x11, 0x13, 0x17, 0x07, 0x03, 0x04, 0xd6, 0x5f, 0xfe, 0xfe,
-  0x5f, 0xd6, 0x95, 0xee, 0x6a, 0x01, 0x1a, 0x05, 0xcd, 0x01, 0x1a, 0x6a,
-  0xee, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x2e, 0xfe, 0x13, 0x03, 0x8c,
-  0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x01, 0x27, 0x37, 0x13, 0x11, 0x03,
-  0x27, 0x37, 0x03, 0x04, 0xd6, 0x5f, 0xfe, 0xfe, 0x5f, 0xd6, 0x04, 0xbc,
-  0xee, 0x6a, 0xfe, 0xe6, 0xfa, 0x33, 0xfe, 0xe6, 0x6a, 0xee, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x42, 0xfe, 0xb2, 0x04, 0x92, 0x06, 0x14, 0x00, 0x24,
-  0x00, 0x00, 0x05, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x34, 0x26, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34, 0x36, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x06, 0x1d, 0x01, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x1d, 0x01,
-  0x14, 0x16, 0x33, 0x04, 0x91, 0xbf, 0xe0, 0x98, 0x61, 0x80, 0x37, 0x37,
-  0x81, 0x60, 0x98, 0xe0, 0xbf, 0x3d, 0x7f, 0x4d, 0x52, 0x63, 0x64, 0x51,
-  0x4d, 0x7f, 0xbe, 0x90, 0x94, 0xdd, 0xef, 0x97, 0x74, 0x8f, 0x73, 0x95,
-  0xf0, 0xdd, 0x93, 0x8f, 0x58, 0x8d, 0xf8, 0x9d, 0x8e, 0x19, 0x1b, 0x8e,
-  0x9c, 0xf8, 0x8d, 0x58, 0x00, 0x01, 0x01, 0x77, 0xfe, 0xb2, 0x04, 0xc7,
-  0x06, 0x14, 0x00, 0x24, 0x00, 0x00, 0x05, 0x33, 0x32, 0x36, 0x3d, 0x01,
-  0x34, 0x36, 0x37, 0x2e, 0x01, 0x3d, 0x01, 0x34, 0x26, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x16, 0x1d, 0x01, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x06, 0x1d, 0x01, 0x14, 0x06, 0x2b, 0x01, 0x01, 0x77, 0x3d, 0x7f, 0x4e,
-  0x51, 0x64, 0x63, 0x52, 0x4e, 0x7f, 0x3d, 0xbf, 0xe0, 0x98, 0x61, 0x80,
-  0x37, 0x37, 0x7f, 0x62, 0x98, 0xe0, 0xbf, 0xbe, 0x58, 0x8d, 0xf8, 0x9c,
-  0x8e, 0x1b, 0x19, 0x8e, 0x9d, 0xf8, 0x8d, 0x58, 0x8f, 0x93, 0xdd, 0xf0,
-  0x95, 0x73, 0x8f, 0x74, 0x97, 0xef, 0xdd, 0x94, 0x00, 0x02, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x18, 0x00, 0x00,
-  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
-  0x04, 0x12, 0x01, 0x21, 0x35, 0x23, 0x11, 0x23, 0x07, 0x15, 0x37, 0x11,
-  0x23, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9,
-  0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfc, 0x3e, 0x02, 0x2b, 0xc4,
-  0x91, 0xe8, 0xd5, 0xc3, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf,
-  0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfd, 0x5c, 0x8e,
-  0x03, 0x1a, 0x2f, 0x98, 0x2b, 0xfd, 0x82, 0x00, 0x00, 0x02, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x2a, 0x00, 0x00,
-  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
-  0x04, 0x12, 0x05, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x0e, 0x01,
-  0x07, 0x15, 0x21, 0x35, 0x21, 0x3e, 0x01, 0x05, 0xec, 0xfe, 0x6c, 0xfe,
-  0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c,
-  0xb9, 0xfe, 0x1b, 0x38, 0x2b, 0xb1, 0x93, 0x36, 0x83, 0x57, 0x67, 0x77,
-  0x35, 0x46, 0x56, 0x2b, 0x37, 0x1e, 0xec, 0x4a, 0x02, 0x61, 0xfe, 0x77,
-  0x71, 0xa0, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f,
-  0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xe9, 0x46, 0x69, 0x3a, 0x7d,
-  0x97, 0x1f, 0x24, 0xab, 0x3a, 0x26, 0x4e, 0x3f, 0x28, 0x55, 0x3f, 0x22,
-  0xf1, 0x4d, 0x81, 0x8e, 0x74, 0xa7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x36, 0x00, 0x00,
-  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
-  0x04, 0x12, 0x25, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x15, 0x3e, 0x01,
-  0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x36, 0x05, 0xec, 0xfe, 0x6c, 0xfe,
-  0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c,
-  0xb9, 0xfe, 0xa2, 0xad, 0x91, 0x37, 0x7b, 0x55, 0x60, 0x6d, 0x2f, 0x52,
-  0x53, 0x50, 0x50, 0x83, 0x7e, 0x59, 0x60, 0x67, 0x69, 0x3e, 0x70, 0x52,
-  0x4f, 0x7b, 0x39, 0xb0, 0xc2, 0x6a, 0x0c, 0x04, 0x5d, 0x02, 0xea, 0xfe,
-  0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6,
-  0xfe, 0x90, 0x18, 0x73, 0x89, 0x14, 0x18, 0x97, 0x20, 0x15, 0x3f, 0x3c,
-  0x3a, 0x3c, 0x8c, 0x4e, 0x47, 0x4c, 0x4f, 0x1c, 0x30, 0xa8, 0x1b, 0x17,
-  0x9c, 0x8d, 0x5d, 0x81, 0x03, 0x72, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x10, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
-  0x33, 0x32, 0x04, 0x12, 0x01, 0x23, 0x13, 0x01, 0x15, 0x21, 0x15, 0x33,
-  0x35, 0x33, 0x35, 0x23, 0x11, 0x23, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1,
-  0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9,
-  0xfd, 0x60, 0xf2, 0xf2, 0xfe, 0x70, 0x01, 0x90, 0xa4, 0x7f, 0x7f, 0xb9,
-  0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01,
-  0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfe, 0xbc, 0x01, 0x7e, 0xfe, 0x83, 0x8e,
-  0xd3, 0xd3, 0x8d, 0x02, 0x48, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x2b, 0x00, 0x00,
-  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
-  0x04, 0x12, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x37, 0x35, 0x21, 0x35, 0x21, 0x05, 0xec, 0xfe, 0x6c,
-  0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01,
-  0x4c, 0xb9, 0xfc, 0x57, 0x50, 0x5b, 0x2d, 0x5d, 0x6a, 0x6a, 0x5d, 0x3d,
-  0x6c, 0x55, 0x4f, 0x78, 0x39, 0xab, 0xc0, 0xba, 0x9f, 0x1b, 0x39, 0x03,
-  0x01, 0x68, 0xfd, 0xfd, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf,
-  0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xf3, 0x25, 0x14,
-  0x61, 0x56, 0x55, 0x61, 0x1b, 0x2f, 0xac, 0x18, 0x14, 0xac, 0x98, 0x95,
-  0xb0, 0x0a, 0x01, 0xab, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
-  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x32,
-  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
-  0x33, 0x32, 0x04, 0x12, 0x01, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x03, 0x22, 0x02, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x37, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0x17, 0x35, 0x2e, 0x01, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe,
-  0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfd,
-  0xde, 0x53, 0x46, 0x46, 0x53, 0x53, 0x46, 0x46, 0x53, 0x66, 0xb4, 0xd2,
-  0xad, 0xa6, 0x90, 0xaf, 0xa8, 0x90, 0x46, 0x73, 0x08, 0x05, 0x72, 0x6b,
-  0x2a, 0x58, 0x4b, 0x42, 0x60, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01,
-  0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfe, 0x8f,
-  0x5a, 0x62, 0x62, 0x5a, 0x5b, 0x62, 0x62, 0x02, 0x2a, 0xfe, 0xf5, 0xda,
-  0xe7, 0xfd, 0xb3, 0x91, 0x94, 0xb1, 0x3d, 0x0b, 0x50, 0x94, 0x16, 0x23,
-  0x9c, 0x18, 0x13, 0x00, 0x00, 0x02, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
-  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x25, 0x21,
-  0x01, 0x33, 0x01, 0x35, 0x21, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe,
-  0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfc,
-  0x2e, 0x01, 0xa1, 0xfe, 0xd1, 0xad, 0x01, 0x48, 0xfd, 0x99, 0x02, 0xea,
-  0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6,
-  0xc6, 0xfe, 0x90, 0x76, 0xfc, 0xe6, 0x03, 0x5d, 0x4b, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
-  0x00, 0x19, 0x00, 0x31, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x01, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x05, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x17, 0x0e, 0x01, 0x01, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x05, 0xec,
-  0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab,
-  0xae, 0x01, 0x4c, 0xb9, 0xfd, 0xf3, 0x56, 0x4b, 0x4c, 0x55, 0x55, 0x4c,
-  0x4b, 0x56, 0xfe, 0x18, 0xab, 0x9c, 0x9c, 0xaa, 0x6a, 0x0d, 0x03, 0x5f,
-  0xa4, 0x8d, 0x8e, 0xa4, 0x5f, 0x04, 0x0e, 0x6a, 0x01, 0x47, 0x43, 0x4a,
-  0x4a, 0x43, 0x46, 0x48, 0x48, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01,
-  0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfe, 0x6c,
-  0x48, 0x51, 0x50, 0x49, 0x49, 0x50, 0x50, 0x49, 0x8a, 0x97, 0x97, 0x8a,
-  0x5c, 0x83, 0x03, 0x01, 0x76, 0x53, 0x74, 0x88, 0x88, 0x74, 0x53, 0x76,
-  0x01, 0x03, 0x83, 0x01, 0xc4, 0x42, 0x3e, 0x3d, 0x42, 0x42, 0x3d, 0x3e,
-  0x42, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
-  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x26, 0x00, 0x32, 0x00, 0x00, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
-  0x01, 0x32, 0x12, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e,
-  0x01, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9,
-  0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfd, 0x22, 0xb4, 0xd2, 0xac,
-  0xa7, 0x90, 0xae, 0xa7, 0x8f, 0x47, 0x74, 0x09, 0x05, 0x72, 0x6b, 0x2a,
-  0x57, 0x4c, 0x42, 0x60, 0x36, 0x53, 0x46, 0x47, 0x52, 0x52, 0x47, 0x46,
-  0x53, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6,
-  0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfd, 0x4b, 0x01, 0x0a, 0xda, 0xe8,
-  0xfd, 0xb4, 0x91, 0x94, 0xaf, 0x3c, 0x0d, 0x4f, 0x93, 0x15, 0x24, 0x9c,
-  0x18, 0x13, 0x02, 0x84, 0x5b, 0x62, 0x62, 0x5b, 0x5b, 0x62, 0x62, 0x00,
-  0x00, 0x04, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
-  0x00, 0x18, 0x00, 0x24, 0x00, 0x30, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x01, 0x21,
-  0x35, 0x23, 0x11, 0x23, 0x07, 0x15, 0x37, 0x11, 0x23, 0x01, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x05, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x05, 0xec, 0xfe,
-  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
-  0x01, 0x4c, 0xb9, 0xfb, 0xa0, 0x01, 0x95, 0x8f, 0x69, 0xaa, 0x9b, 0x8e,
-  0x03, 0x2e, 0x3e, 0x39, 0x3a, 0x3e, 0x3e, 0x3a, 0x39, 0x3e, 0xfe, 0x98,
-  0x7b, 0x76, 0x75, 0x7a, 0x7a, 0x75, 0x76, 0x7b, 0x02, 0xea, 0xfe, 0xc1,
-  0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe,
-  0x90, 0xfd, 0xa9, 0x80, 0x02, 0xca, 0x2a, 0x89, 0x27, 0xfd, 0xc2, 0x01,
-  0x24, 0xa2, 0x97, 0x97, 0xa2, 0xa3, 0x97, 0x97, 0xa3, 0xd0, 0xe4, 0xe4,
-  0xd0, 0xd1, 0xe4, 0xe4, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
-  0x06, 0x3d, 0x00, 0x19, 0x00, 0x24, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x20,
-  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
-  0x01, 0x33, 0x11, 0x05, 0x35, 0x25, 0x33, 0x11, 0x33, 0x15, 0x21, 0x12,
-  0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07,
-  0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36,
-  0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64,
-  0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64,
-  0x62, 0x77, 0xfd, 0xe2, 0xed, 0xfe, 0xfe, 0x01, 0x01, 0x91, 0xee, 0xfd,
-  0x95, 0x7f, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
-  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
-  0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe,
-  0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97,
-  0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfb, 0x7d, 0x03, 0x8f, 0x39, 0x93,
-  0x3a, 0xfb, 0xdd, 0x88, 0x05, 0xa8, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
-  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
-  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
-  0x00, 0x36, 0x00, 0x50, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06,
-  0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
-  0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x01, 0x21, 0x15, 0x21,
-  0x35, 0x36, 0x00, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x0e,
-  0x01, 0x02, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07,
-  0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12,
-  0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62,
-  0x62, 0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62,
-  0x62, 0x64, 0x62, 0x77, 0xfe, 0x59, 0x01, 0xfb, 0xfd, 0x56, 0x53, 0x01,
-  0x1d, 0x25, 0x46, 0x37, 0x78, 0x60, 0x48, 0x95, 0x56, 0x57, 0x99, 0x3f,
-  0xa8, 0xc7, 0x32, 0x42, 0x12, 0xc1, 0xa7, 0x01, 0x39, 0x89, 0x87, 0x6f,
-  0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70,
-  0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f,
-  0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36,
-  0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfb,
-  0x80, 0x88, 0x88, 0x5f, 0x01, 0x41, 0x2e, 0x58, 0x78, 0x3b, 0x5f, 0x78,
-  0x35, 0x35, 0xa3, 0x27, 0x28, 0xba, 0x9b, 0x49, 0x84, 0x5a, 0x17, 0xde,
-  0x04, 0x56, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4,
-  0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1,
-  0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08,
-  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19, 0x00, 0x42, 0x00, 0x5c,
-  0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12,
-  0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34,
-  0x02, 0x27, 0x26, 0x27, 0x03, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x00, 0x20, 0x17,
-  0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03,
-  0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77,
-  0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77,
-  0x68, 0x68, 0x76, 0xda, 0xca, 0x44, 0x8f, 0x4d, 0x3d, 0x90, 0x4e, 0x89,
-  0x8f, 0x85, 0x77, 0x7d, 0x83, 0x6c, 0x71, 0x75, 0x6e, 0x3b, 0x89, 0x53,
-  0x4a, 0x9a, 0x40, 0xa7, 0xc0, 0x66, 0xfe, 0x6a, 0x01, 0x39, 0x89, 0x87,
-  0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87,
-  0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f,
-  0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39,
-  0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36,
-  0xfd, 0x79, 0x19, 0x9c, 0x74, 0xb0, 0xc2, 0x1e, 0x1d, 0x9c, 0x27, 0x28,
-  0x78, 0x72, 0x6a, 0x77, 0x85, 0x5f, 0x5a, 0x5c, 0x62, 0x1d, 0x1e, 0x90,
-  0x17, 0x1c, 0xa7, 0x8e, 0x64, 0x88, 0x03, 0x09, 0x40, 0x3e, 0x7d, 0x7e,
-  0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e,
-  0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00,
-  0x00, 0x04, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
-  0x00, 0x1c, 0x00, 0x27, 0x00, 0x41, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06,
-  0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37,
-  0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x07, 0x01,
-  0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x21, 0x35,
-  0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06,
-  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37,
-  0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62,
-  0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62,
-  0x64, 0x62, 0x77, 0xc7, 0xfe, 0x90, 0x01, 0x70, 0x26, 0xb6, 0x9a, 0x9a,
-  0x90, 0xfe, 0x1a, 0x01, 0x0e, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e,
-  0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f,
-  0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7,
-  0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f,
-  0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xed, 0xfd, 0x82,
-  0x03, 0x0b, 0xfc, 0xf5, 0x86, 0xfe, 0xe6, 0x01, 0x1a, 0x9c, 0x03, 0xf2,
-  0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d,
-  0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c,
-  0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
-  0x06, 0x3d, 0x00, 0x19, 0x00, 0x37, 0x00, 0x51, 0x00, 0x00, 0x00, 0x20,
-  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
-  0x05, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16,
-  0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27,
-  0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb,
-  0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01, 0x15,
-  0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfd, 0xe0, 0x02,
-  0x3b, 0xfe, 0x4a, 0x20, 0x40, 0x1f, 0xb4, 0xd2, 0xd8, 0xc5, 0x43, 0x8c,
-  0x4b, 0x44, 0x86, 0x4e, 0x7c, 0x92, 0x92, 0x7c, 0x3b, 0x74, 0x3c, 0x81,
-  0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89,
-  0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05,
-  0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f,
-  0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01,
-  0x09, 0x6f, 0x6f, 0x36, 0x63, 0x88, 0xfe, 0xdb, 0x0c, 0x0c, 0xdb, 0xbb,
-  0xc1, 0xd6, 0x1a, 0x19, 0xa3, 0x29, 0x25, 0x92, 0x7d, 0x7c, 0x92, 0x1d,
-  0x1e, 0x03, 0x58, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe,
-  0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac,
-  0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00, 0x04, 0x00, 0x08,
-  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19, 0x00, 0x25, 0x00, 0x3e,
-  0x00, 0x58, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15,
-  0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12,
-  0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x07, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x00, 0x20, 0x17, 0x16, 0x17,
-  0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26,
-  0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe,
-  0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01,
-  0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfe, 0xf4,
-  0x61, 0x73, 0x73, 0x61, 0x62, 0x73, 0x73, 0xbf, 0x37, 0x6f, 0x36, 0x90,
-  0x98, 0x0b, 0x2a, 0x80, 0x4d, 0xa2, 0xbc, 0xc4, 0xa3, 0xba, 0xc5, 0xf2,
-  0xcb, 0x37, 0x70, 0xfe, 0x88, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e,
-  0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f,
-  0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7,
-  0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f,
-  0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfd, 0x8b, 0x95,
-  0x82, 0x80, 0x96, 0x96, 0x80, 0x82, 0x95, 0x01, 0xfa, 0x93, 0x1d, 0x1e,
-  0xd8, 0xda, 0x45, 0x4b, 0xdb, 0xbc, 0xb8, 0xde, 0x01, 0x3e, 0x01, 0x2d,
-  0x01, 0x1d, 0x01, 0x4f, 0x18, 0x01, 0x00, 0x40, 0x3e, 0x7d, 0x7e, 0xfe,
-  0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d,
-  0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
-  0x00, 0x20, 0x00, 0x3a, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06,
-  0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
-  0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x05, 0x21, 0x15, 0x01,
-  0x23, 0x01, 0x21, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
-  0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35,
-  0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62,
-  0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62,
-  0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfd, 0xa0, 0x02, 0xb3, 0xfe, 0x7a,
-  0x98, 0x01, 0x70, 0xfd, 0xfb, 0xc1, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72,
-  0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71,
-  0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe,
-  0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f,
-  0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0x60, 0x45,
-  0xfb, 0x9a, 0x04, 0x23, 0x01, 0x85, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
-  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
-  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
-  0x00, 0x23, 0x00, 0x39, 0x00, 0x45, 0x00, 0x5f, 0x00, 0x00, 0x00, 0x20,
-  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
-  0x01, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x2e,
-  0x01, 0x35, 0x34, 0x36, 0x20, 0x16, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x20, 0x26, 0x35, 0x34, 0x36, 0x13, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x12, 0x20, 0x17, 0x16,
-  0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
-  0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f,
-  0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79,
-  0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfe,
-  0xfc, 0x67, 0x77, 0x77, 0xcf, 0x77, 0x76, 0xfa, 0x5e, 0x68, 0xb7, 0x01,
-  0x41, 0xb7, 0x68, 0x5e, 0x69, 0x76, 0xbe, 0xfe, 0x9b, 0xbf, 0x77, 0x33,
-  0x69, 0x5e, 0x5e, 0x6a, 0x6a, 0x5e, 0x5e, 0x69, 0x2c, 0x01, 0x39, 0x89,
-  0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89,
-  0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36,
-  0x6f, 0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39,
-  0x39, 0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f,
-  0x36, 0xfd, 0x2c, 0x7b, 0xd8, 0x7b, 0x7c, 0x6b, 0x6c, 0x7b, 0x45, 0x1a,
-  0x8e, 0x67, 0x8f, 0xa6, 0xa6, 0x8f, 0x67, 0x8e, 0x1a, 0x1b, 0x9e, 0x73,
-  0xad, 0xba, 0xba, 0xad, 0x73, 0x9e, 0x01, 0x1a, 0x5c, 0x68, 0x68, 0x5c,
-  0x5d, 0x68, 0x68, 0x01, 0xd0, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1,
-  0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01,
-  0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x04, 0x00, 0x08,
-  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19, 0x00, 0x32, 0x00, 0x3e,
-  0x00, 0x58, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15,
-  0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12,
-  0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x01, 0x35, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x37, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32,
-  0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x02, 0x20, 0x17, 0x16, 0x17,
-  0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26,
-  0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe,
-  0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01,
-  0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfd, 0xe3,
-  0x37, 0x70, 0x36, 0x90, 0x98, 0x0b, 0x2a, 0x80, 0x4e, 0xa2, 0xbb, 0xc4,
-  0xa2, 0xbc, 0xc4, 0xf1, 0xcc, 0x37, 0x70, 0xe4, 0x63, 0x72, 0x72, 0x63,
-  0x61, 0x73, 0x73, 0x42, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e,
-  0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f,
-  0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7, 0x9c,
-  0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x01,
-  0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfb, 0x0e, 0x93, 0x1d,
-  0x1e, 0xd7, 0xdb, 0x44, 0x4a, 0xd9, 0xbc, 0xb8, 0xde, 0xfe, 0xc3, 0xfe,
-  0xd1, 0xfe, 0xe6, 0xfe, 0xaf, 0x18, 0x02, 0x12, 0x95, 0x82, 0x81, 0x95,
-  0x95, 0x81, 0x82, 0x95, 0x03, 0x95, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
-  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
-  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x1d,
-  0x00, 0x2b, 0x00, 0x38, 0x00, 0x43, 0x00, 0x61, 0x00, 0x00, 0x00, 0x20,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x27, 0x26, 0x27, 0x07, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x27, 0x2e, 0x01, 0x20, 0x17, 0x16, 0x11, 0x10,
-  0x07, 0x06, 0x20, 0x02, 0x11, 0x10, 0x37, 0x01, 0x33, 0x11, 0x07, 0x35,
-  0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
-  0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x30, 0x32, 0x32, 0x30,
-  0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x30, 0x32,
-  0x32, 0x30, 0x64, 0x62, 0x77, 0x1a, 0x4b, 0x28, 0x27, 0x4e, 0x4c, 0x4e,
-  0x4d, 0x27, 0x26, 0xd7, 0x01, 0x13, 0x49, 0x48, 0x48, 0x49, 0xfe, 0xed,
-  0x90, 0x48, 0xfe, 0x61, 0x7f, 0x87, 0x86, 0x74, 0x76, 0xfe, 0x98, 0xeb,
-  0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x36, 0x38, 0x38, 0x36, 0x72, 0x6f,
-  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x36, 0x39, 0x39, 0x36,
-  0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0x83, 0x86, 0x9c,
-  0x97, 0x86, 0x83, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x83,
-  0x86, 0x97, 0x9c, 0x86, 0x83, 0x6f, 0x6f, 0x36, 0xcb, 0x7b, 0x7a, 0xf7,
-  0xf5, 0xf6, 0xf6, 0xf5, 0xf3, 0x7e, 0x7b, 0x80, 0x9f, 0x9e, 0xfe, 0xd1,
-  0xfe, 0xd3, 0x9f, 0x9f, 0x01, 0x3e, 0x01, 0x2d, 0x01, 0x2c, 0xa1, 0xfc,
-  0x67, 0x03, 0x8f, 0x25, 0x93, 0x26, 0xfb, 0xdd, 0x88, 0x05, 0xa8, 0x40,
-  0x3e, 0x7d, 0x7e, 0x95, 0x97, 0xb1, 0xac, 0x97, 0x95, 0x7e, 0x7d, 0x3e,
-  0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x95, 0x97, 0xac, 0xb1, 0x97, 0x95, 0x7e,
-  0x7d, 0x3e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
-  0x06, 0x3d, 0x00, 0x0a, 0x00, 0x24, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35,
-  0x23, 0x11, 0x23, 0x05, 0x15, 0x25, 0x11, 0x02, 0x20, 0x17, 0x16, 0x17,
-  0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26,
-  0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x01, 0xe9, 0x02,
-  0x6b, 0xee, 0x91, 0xfe, 0xff, 0x01, 0x02, 0x6e, 0x01, 0x39, 0x89, 0x87,
-  0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87,
-  0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x01, 0x1d, 0x88, 0x88, 0x04,
-  0x23, 0x3a, 0x93, 0x39, 0xfc, 0x71, 0x05, 0x20, 0x40, 0x3e, 0x7d, 0x7e,
-  0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e,
-  0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00,
-  0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x1c,
-  0x00, 0x36, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x07, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x07, 0x06, 0x00, 0x07, 0x15, 0x21, 0x35, 0x00, 0x20, 0x17,
-  0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x02,
-  0x60, 0xaf, 0xc1, 0x12, 0x42, 0x32, 0xc7, 0xa8, 0x3f, 0x99, 0x57, 0x56,
-  0x99, 0x44, 0x60, 0x78, 0x37, 0x46, 0x25, 0xfe, 0xe3, 0x53, 0x02, 0xaa,
-  0xfe, 0x0d, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
-  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
-  0x87, 0x01, 0x20, 0xc7, 0xde, 0x17, 0x5a, 0x84, 0x49, 0x9b, 0xba, 0x28,
-  0x27, 0xa3, 0x35, 0x35, 0x78, 0x5f, 0x3b, 0x78, 0x58, 0x2e, 0xfe, 0xbf,
-  0x5f, 0x88, 0x88, 0x05, 0x1d, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1,
-  0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01,
-  0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x02, 0x00, 0x08,
-  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x28, 0x00, 0x42, 0x00, 0x00,
-  0x01, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x15, 0x3e,
-  0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12,
-  0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26,
-  0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x9f, 0x5f, 0x66, 0xc1,
-  0xa6, 0x40, 0x91, 0x53, 0x53, 0x89, 0x3b, 0x6e, 0x75, 0x71, 0x6c, 0x83,
-  0x7d, 0x77, 0x85, 0x8f, 0x89, 0x4e, 0x90, 0x3d, 0x4d, 0x8f, 0x44, 0xca,
-  0xda, 0x76, 0xfe, 0x61, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e,
-  0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f,
-  0x71, 0x70, 0x87, 0x03, 0x19, 0x1b, 0x88, 0x64, 0x8e, 0xa7, 0x19, 0x1a,
-  0x90, 0x1e, 0x1d, 0x62, 0x5c, 0x5a, 0x5f, 0x85, 0x77, 0x6a, 0x72, 0x78,
-  0x28, 0x27, 0x9c, 0x1d, 0x1e, 0xc2, 0xb0, 0x74, 0x9c, 0x03, 0x3d, 0x40,
-  0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e,
-  0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e,
-  0x7d, 0x3e, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
-  0x06, 0x3d, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x27, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x09, 0x01, 0x15, 0x21, 0x11, 0x33, 0x11, 0x33, 0x35, 0x23, 0x11,
-  0x24, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06,
-  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37,
-  0x36, 0x37, 0x03, 0x40, 0xfe, 0x90, 0x01, 0x4a, 0xfe, 0x40, 0x01, 0xe6,
-  0x90, 0x9a, 0x9a, 0xfe, 0x98, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e,
-  0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f,
-  0x6f, 0x71, 0x70, 0x87, 0x04, 0xb3, 0xfd, 0x82, 0x03, 0x0b, 0xfd, 0x0b,
-  0x9c, 0xfe, 0xe6, 0x01, 0x1a, 0x86, 0x03, 0x0b, 0xfd, 0x40, 0x3e, 0x7d,
-  0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40,
-  0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e,
-  0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x1d,
-  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x11, 0x21, 0x35, 0x00, 0x20,
-  0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06,
-  0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37,
-  0x01, 0xe7, 0x3c, 0x74, 0x3b, 0x7c, 0x92, 0x92, 0x7c, 0x4e, 0x89, 0x41,
-  0x4b, 0x8c, 0x43, 0xc5, 0xd8, 0xd2, 0xb4, 0x1f, 0x40, 0x20, 0x01, 0xb6,
-  0xfe, 0x46, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
-  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
-  0x87, 0x05, 0x3d, 0xfd, 0xa8, 0x1e, 0x1d, 0x92, 0x7c, 0x7d, 0x92, 0x27,
-  0x27, 0xa3, 0x19, 0x1a, 0xd6, 0xc1, 0xbb, 0xdb, 0x0c, 0x0c, 0x01, 0x25,
-  0x88, 0x01, 0x00, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe,
-  0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac,
-  0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08,
-  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x3e,
-  0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x36, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x17, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
-  0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35,
-  0x34, 0x12, 0x37, 0x36, 0x37, 0x02, 0xfb, 0x62, 0x73, 0x73, 0x62, 0x61,
-  0x73, 0x73, 0x01, 0x82, 0x3c, 0x70, 0x37, 0xcb, 0xf2, 0xc5, 0xba, 0xa3,
-  0xc4, 0xbc, 0xa2, 0x4d, 0x80, 0x2a, 0x0b, 0x98, 0x90, 0x36, 0x6f, 0x37,
-  0xfe, 0x4c, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
-  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
-  0x87, 0x03, 0x2b, 0x95, 0x82, 0x80, 0x96, 0x96, 0x80, 0x82, 0x95, 0x01,
-  0xfa, 0x18, 0x18, 0xfe, 0xaf, 0xfe, 0xe5, 0xfe, 0xd3, 0xfe, 0xc2, 0xde,
-  0xb8, 0xbc, 0xdb, 0x4b, 0x45, 0xda, 0xd8, 0x1e, 0x1d, 0x01, 0xab, 0x40,
-  0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e,
-  0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e,
-  0x7d, 0x3e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
-  0x06, 0x3d, 0x00, 0x06, 0x00, 0x20, 0x00, 0x00, 0x01, 0x15, 0x21, 0x01,
-  0x33, 0x01, 0x35, 0x24, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
-  0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35,
-  0x34, 0x12, 0x37, 0x36, 0x37, 0x01, 0xa7, 0x02, 0x05, 0xfe, 0x90, 0x98,
-  0x01, 0x86, 0xfe, 0x0e, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e,
-  0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f,
-  0x71, 0x70, 0x87, 0x05, 0x40, 0x88, 0xfb, 0xdd, 0x04, 0x66, 0x45, 0xfd,
-  0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d,
-  0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c,
-  0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x04, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
-  0x06, 0x3d, 0x00, 0x09, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x45, 0x00, 0x00,
-  0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x27, 0x0e,
-  0x01, 0x15, 0x14, 0x16, 0x20, 0x36, 0x35, 0x34, 0x26, 0x27, 0x3e, 0x01,
-  0x35, 0x34, 0x26, 0x20, 0x06, 0x15, 0x14, 0x16, 0x37, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x12, 0x20, 0x17, 0x16,
-  0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
-  0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x03,
-  0x69, 0x76, 0x77, 0xcf, 0x77, 0x77, 0x2a, 0x69, 0x77, 0xbf, 0x01, 0x65,
-  0xbe, 0x76, 0x69, 0x5e, 0x68, 0xb7, 0xfe, 0xbf, 0xb7, 0x68, 0x28, 0x69,
-  0x5e, 0x5e, 0x6a, 0x6a, 0x5e, 0x5e, 0x69, 0x2c, 0x01, 0x39, 0x89, 0x87,
-  0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87,
-  0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x02, 0xcc, 0x7b, 0x6c, 0x6b,
-  0x7c, 0x7b, 0xd8, 0x7b, 0x45, 0x1b, 0x9e, 0x73, 0xad, 0xba, 0xba, 0xad,
-  0x73, 0x9e, 0x1b, 0x1a, 0x8e, 0x67, 0x8f, 0xa6, 0xa6, 0x8f, 0x67, 0x8e,
-  0xe5, 0x5d, 0x68, 0x68, 0x5d, 0x5c, 0x68, 0x68, 0x02, 0x89, 0x40, 0x3e,
-  0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40,
-  0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d,
-  0x3e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
-  0x06, 0x3d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x3e, 0x00, 0x00, 0x25, 0x1e,
-  0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x01,
-  0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x00,
-  0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07,
-  0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36,
-  0x37, 0x01, 0xea, 0x3d, 0x70, 0x37, 0xcc, 0xf1, 0xc4, 0xbc, 0xa2, 0xc4,
-  0xbc, 0xa1, 0x4e, 0x80, 0x2a, 0x0b, 0x98, 0x90, 0x36, 0x70, 0x37, 0x01,
-  0x21, 0x61, 0x73, 0x73, 0x61, 0x63, 0x72, 0x72, 0xfe, 0xfa, 0x01, 0x39,
-  0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7,
-  0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0xae, 0x18, 0x18,
-  0x01, 0x51, 0x01, 0x1a, 0x01, 0x2f, 0x01, 0x3d, 0xde, 0xb8, 0xbc, 0xd9,
-  0x4a, 0x44, 0xdb, 0xd7, 0x1e, 0x1d, 0x01, 0x67, 0x95, 0x82, 0x81, 0x95,
-  0x95, 0x81, 0x82, 0x95, 0x03, 0x95, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
-  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
-  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x0b,
-  0x00, 0x15, 0x00, 0x20, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x20, 0x02, 0x11,
-  0x10, 0x12, 0x20, 0x12, 0x11, 0x10, 0x01, 0x15, 0x21, 0x35, 0x23, 0x11,
-  0x23, 0x07, 0x15, 0x37, 0x11, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12,
-  0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26,
-  0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x04, 0x23, 0x5b, 0x5a, 0x5a,
-  0x5b, 0x5a, 0x5a, 0x5a, 0xeb, 0xfe, 0xde, 0x98, 0x98, 0x01, 0x22, 0x99,
-  0xfc, 0x03, 0x01, 0x95, 0x91, 0x74, 0xa1, 0xa2, 0x87, 0x01, 0x39, 0x89,
-  0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89,
-  0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x04, 0xd5, 0xf5, 0xf7,
-  0xf5, 0xf6, 0xf6, 0xf5, 0xf7, 0xf5, 0x80, 0xfe, 0xc3, 0xfe, 0xd1, 0xfe,
-  0xd3, 0xfe, 0xc2, 0x01, 0x3e, 0x01, 0x2d, 0x01, 0x2f, 0xfd, 0x05, 0x88,
-  0x88, 0x04, 0x23, 0x26, 0x93, 0x25, 0xfc, 0x71, 0x05, 0x20, 0x40, 0x3e,
-  0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40,
-  0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d,
-  0x3e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0x9a, 0x05, 0xaf,
-  0x04, 0x6a, 0x00, 0x08, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01, 0x21, 0x35,
-  0x21, 0x01, 0x21, 0x05, 0xae, 0xfe, 0x49, 0xfe, 0xe0, 0x01, 0x4b, 0xfc,
-  0x47, 0x03, 0xb9, 0xfe, 0xb5, 0x01, 0x20, 0x02, 0x82, 0xfe, 0x18, 0x01,
-  0x70, 0xf0, 0x01, 0x70, 0x00, 0x01, 0x00, 0xe2, 0x00, 0x70, 0x04, 0xe9,
-  0x04, 0xe9, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x37, 0x01, 0x1b, 0x01,
-  0x25, 0x03, 0x92, 0xfd, 0x51, 0x98, 0x02, 0x70, 0xbe, 0x3f, 0xfd, 0x93,
-  0x01, 0x8b, 0x02, 0xb4, 0xaa, 0xfd, 0x05, 0x01, 0x34, 0xfd, 0x4e, 0x47,
-  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x05, 0x35, 0x05, 0x03, 0x09, 0x01, 0x04, 0x07, 0xfc,
-  0x62, 0x03, 0x9e, 0x3d, 0x01, 0xe4, 0xfe, 0x1c, 0x02, 0x3c, 0x32, 0xf0,
-  0x32, 0x01, 0x70, 0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x00, 0x01, 0x00, 0xe2,
-  0x00, 0x1b, 0x04, 0xe9, 0x04, 0x94, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01,
-  0x27, 0x01, 0x2d, 0x01, 0x03, 0x03, 0xeb, 0xfd, 0x90, 0x98, 0x02, 0xaf,
-  0xfe, 0xe9, 0x02, 0x6d, 0x3f, 0x03, 0x16, 0xfd, 0x05, 0xaa, 0x02, 0xb4,
-  0xd4, 0x47, 0xfd, 0x4e, 0x00, 0x01, 0x00, 0x69, 0x01, 0x08, 0x05, 0xaf,
-  0x03, 0xfc, 0x00, 0x08, 0x00, 0x00, 0x13, 0x21, 0x03, 0x04, 0x05, 0x04,
-  0x05, 0x13, 0x21, 0x69, 0x02, 0x75, 0x97, 0x01, 0x39, 0x02, 0x2e, 0xfd,
-  0xd2, 0xfe, 0xc7, 0x97, 0xfd, 0x8b, 0x02, 0xbe, 0x01, 0x3e, 0xfc, 0x7e,
-  0x7e, 0xfc, 0x01, 0x3e, 0x00, 0x01, 0x00, 0x69, 0x00, 0x75, 0x05, 0x81,
-  0x04, 0x8f, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x14, 0x06, 0x07, 0x01, 0x06,
-  0x07, 0x06, 0x22, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x3f, 0x01,
-  0x21, 0x22, 0x2e, 0x02, 0x34, 0x3e, 0x02, 0x33, 0x21, 0x27, 0x2e, 0x01,
-  0x35, 0x34, 0x36, 0x37, 0x3e, 0x01, 0x32, 0x17, 0x16, 0x17, 0x01, 0x16,
-  0x05, 0x80, 0x12, 0x0f, 0xfe, 0x98, 0x0e, 0x16, 0x14, 0x2e, 0x28, 0x10,
-  0x10, 0x11, 0x12, 0x0f, 0xa7, 0xfc, 0xda, 0x18, 0x27, 0x21, 0x11, 0x11,
-  0x21, 0x27, 0x18, 0x03, 0x26, 0xa7, 0x0f, 0x12, 0x11, 0x10, 0x10, 0x28,
-  0x2e, 0x14, 0x16, 0x0e, 0x01, 0x68, 0x11, 0x02, 0x9b, 0x32, 0x2e, 0x11,
-  0xfe, 0x70, 0x10, 0x0b, 0x0a, 0x14, 0x11, 0x13, 0x2c, 0x19, 0x1a, 0x2e,
-  0x11, 0xba, 0x14, 0x22, 0x2e, 0x32, 0x2e, 0x22, 0x14, 0xba, 0x11, 0x2e,
-  0x1a, 0x19, 0x2c, 0x13, 0x11, 0x14, 0x0a, 0x0b, 0x10, 0xfe, 0x70, 0x13,
-  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x11, 0x09, 0x01, 0x04, 0x24, 0xfc,
-  0x45, 0x03, 0xbb, 0x01, 0x8a, 0xfe, 0x76, 0x02, 0x5a, 0x50, 0x01, 0x8e,
-  0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x06, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x11, 0x09,
-  0x01, 0x04, 0x24, 0xfc, 0x45, 0x03, 0xbb, 0x01, 0x8a, 0xfe, 0x76, 0x02,
-  0x14, 0xdc, 0x01, 0x48, 0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x04, 0x00, 0x69,
-  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x12, 0x00, 0x00, 0x01, 0x23, 0x11, 0x33, 0x01, 0x23, 0x11, 0x33,
-  0x03, 0x23, 0x11, 0x33, 0x01, 0x21, 0x11, 0x21, 0x35, 0x09, 0x01, 0x02,
-  0x73, 0xd8, 0xd8, 0xfe, 0xe0, 0x6c, 0x6c, 0xb4, 0x36, 0x36, 0x03, 0x85,
-  0xfe, 0x97, 0x01, 0x69, 0x01, 0x8a, 0xfe, 0x76, 0x01, 0xba, 0x01, 0x90,
-  0xfe, 0x70, 0x01, 0x90, 0xfe, 0x70, 0x01, 0x90, 0xfe, 0x70, 0x01, 0x90,
-  0xee, 0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x69,
-  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x10,
-  0x00, 0x14, 0x00, 0x00, 0x01, 0x35, 0x12, 0x17, 0x06, 0x03, 0x35, 0x21,
-  0x11, 0x03, 0x23, 0x11, 0x33, 0x01, 0x23, 0x11, 0x33, 0x03, 0x23, 0x11,
-  0x33, 0x04, 0x24, 0xa6, 0xe4, 0xe4, 0xa6, 0xfe, 0x97, 0x48, 0xd8, 0xd8,
-  0xfe, 0xe0, 0x6c, 0x6c, 0xb4, 0x36, 0x36, 0x03, 0xae, 0x8a, 0xfe, 0xce,
-  0x84, 0x84, 0xfe, 0xce, 0x8a, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0x58, 0xfd,
-  0xa8, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0x58, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x00, 0x86, 0x05, 0xd7, 0x04, 0x7e, 0x00, 0x06, 0x00, 0x00, 0x09, 0x02,
-  0x11, 0x21, 0x11, 0x21, 0x04, 0x0e, 0x01, 0xc9, 0xfe, 0x37, 0xfc, 0x5b,
-  0x03, 0xa5, 0x04, 0x7e, 0xfe, 0x04, 0xfe, 0x04, 0x01, 0x11, 0x01, 0xd6,
-  0x00, 0x02, 0x00, 0xcd, 0x00, 0xc0, 0x05, 0xaf, 0x04, 0x44, 0x00, 0x02,
-  0x00, 0x06, 0x00, 0x00, 0x01, 0x21, 0x01, 0x13, 0x09, 0x02, 0x02, 0xce,
-  0x01, 0xfe, 0xfd, 0x0f, 0x87, 0xfe, 0x6b, 0x04, 0xe1, 0xfb, 0x1f, 0x02,
-  0x82, 0x01, 0x0f, 0xfe, 0xf1, 0x01, 0xc2, 0xfe, 0x3e, 0xfe, 0x3e, 0x00,
-  0x00, 0x02, 0x00, 0xcd, 0x00, 0xc0, 0x05, 0xaf, 0x04, 0x44, 0x00, 0x02,
-  0x00, 0x06, 0x00, 0x00, 0x01, 0x03, 0x01, 0x21, 0x09, 0x02, 0x02, 0xce,
-  0xf3, 0x02, 0xf1, 0xfd, 0x96, 0xfe, 0x6b, 0x04, 0xe1, 0xfb, 0x1f, 0x02,
-  0x82, 0xfe, 0xf1, 0x01, 0x0f, 0x01, 0xc2, 0xfe, 0x3e, 0xfe, 0x3e, 0x00,
-  0x00, 0x01, 0x00, 0xcd, 0xff, 0xf8, 0x05, 0xaf, 0x05, 0x0c, 0x00, 0x03,
-  0x00, 0x00, 0x09, 0x03, 0x02, 0x08, 0xfe, 0xc5, 0x04, 0xe1, 0xfb, 0x1f,
-  0x02, 0x82, 0x02, 0x8a, 0xfd, 0x76, 0xfd, 0x76, 0x00, 0x01, 0x00, 0x69,
-  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x62, 0x00, 0x14, 0x00, 0x00, 0x13, 0x11,
-  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x21, 0x35, 0x09, 0x01, 0x35,
-  0x21, 0x20, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x69, 0x21, 0x1f, 0x20, 0x26,
-  0x26, 0x0b, 0x03, 0x04, 0x01, 0x8a, 0xfe, 0x76, 0xfe, 0x79, 0xfe, 0x78,
-  0x26, 0x26, 0x20, 0x1f, 0x21, 0x02, 0x82, 0x01, 0xe0, 0x30, 0x55, 0x25,
-  0x21, 0x13, 0x12, 0xc6, 0xfe, 0x4a, 0xfe, 0x4a, 0xc6, 0x12, 0x13, 0x21,
-  0x25, 0x55, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xa2, 0x05, 0xaf,
-  0x04, 0x38, 0x00, 0x14, 0x00, 0x00, 0x13, 0x34, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x21, 0x35, 0x09, 0x01, 0x35, 0x21, 0x20, 0x07, 0x06, 0x07,
-  0x0e, 0x01, 0x15, 0x69, 0x21, 0x1f, 0x20, 0x26, 0x26, 0x0b, 0x03, 0x04,
-  0x01, 0x8a, 0xfe, 0x76, 0xfe, 0x79, 0xfe, 0x78, 0x26, 0x26, 0x20, 0x1f,
-  0x21, 0x02, 0x82, 0x30, 0x55, 0x25, 0x21, 0x13, 0x12, 0xc6, 0xfe, 0x4a,
-  0xfe, 0x4a, 0xc6, 0x12, 0x13, 0x21, 0x25, 0x55, 0x30, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0xba, 0xff, 0xf1, 0x04, 0x5d, 0x05, 0x13, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x11, 0x09, 0x01, 0x03, 0x08, 0xfe,
-  0xb3, 0x01, 0x4d, 0x01, 0x55, 0xfe, 0xab, 0x01, 0x56, 0x02, 0x58, 0x01,
-  0x65, 0xfd, 0x6f, 0xfd, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x08, 0x00, 0x00, 0x01, 0x35,
-  0x12, 0x05, 0x04, 0x03, 0x35, 0x21, 0x11, 0x03, 0x9d, 0x82, 0x01, 0x8f,
-  0xfe, 0x71, 0x82, 0xfc, 0xcc, 0x03, 0x9a, 0x9e, 0xfe, 0xce, 0x84, 0x84,
-  0xfe, 0xce, 0x9e, 0x02, 0x30, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
-  0x00, 0x9a, 0x05, 0x82, 0x04, 0x6a, 0x00, 0x08, 0x00, 0x0f, 0x00, 0x00,
-  0x25, 0x35, 0x21, 0x11, 0x21, 0x35, 0x33, 0x09, 0x01, 0x03, 0x15, 0x09,
-  0x01, 0x15, 0x21, 0x11, 0x02, 0xe9, 0xfd, 0x80, 0x02, 0x80, 0xe1, 0x01,
-  0xb7, 0xfe, 0x49, 0x99, 0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x80, 0x9a, 0xee,
-  0x01, 0xf4, 0xee, 0xfe, 0x18, 0xfe, 0x18, 0x01, 0x3e, 0xee, 0x01, 0x98,
-  0x01, 0x98, 0xee, 0xfe, 0xac, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
-  0x00, 0x9a, 0x05, 0x82, 0x04, 0x6a, 0x00, 0x08, 0x00, 0x0f, 0x00, 0x00,
-  0x25, 0x35, 0x21, 0x11, 0x21, 0x35, 0x33, 0x09, 0x01, 0x03, 0x15, 0x09,
-  0x01, 0x15, 0x21, 0x11, 0x02, 0xe9, 0xfd, 0x80, 0x02, 0x80, 0xe1, 0x01,
-  0xb7, 0xfe, 0x49, 0x12, 0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x80, 0x9a, 0xee,
-  0x01, 0xf4, 0xee, 0xfe, 0x18, 0xfe, 0x18, 0x01, 0x3e, 0xee, 0x01, 0x98,
-  0x01, 0x98, 0xee, 0xfe, 0xac, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x26,
-  0x00, 0x18, 0x05, 0xb8, 0x04, 0xb0, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00,
-  0x13, 0x01, 0x21, 0x37, 0x33, 0x13, 0x15, 0x01, 0x23, 0x35, 0x37, 0x21,
-  0x01, 0x07, 0x01, 0x03, 0x07, 0x21, 0x03, 0x27, 0x01, 0x03, 0x02, 0xf5,
-  0x7c, 0x5a, 0xc2, 0xfd, 0x6f, 0x87, 0x14, 0xfd, 0x74, 0x03, 0x6f, 0x7c,
-  0x02, 0x43, 0x9a, 0x7d, 0xfd, 0x0c, 0xb1, 0x01, 0xce, 0x01, 0xf4, 0xee,
-  0xfd, 0xfe, 0xc8, 0xfe, 0x32, 0xc8, 0x26, 0x01, 0x18, 0xee, 0x01, 0x98,
-  0x01, 0x98, 0xee, 0xfe, 0xac, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x26,
-  0x00, 0x18, 0x05, 0xb8, 0x04, 0xb0, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00,
-  0x13, 0x35, 0x21, 0x27, 0x35, 0x33, 0x01, 0x15, 0x03, 0x23, 0x27, 0x21,
-  0x01, 0x21, 0x13, 0x21, 0x17, 0x13, 0x01, 0x27, 0x02, 0x8c, 0x14, 0x87,
-  0x02, 0x91, 0xc2, 0x5a, 0x7c, 0xfd, 0x0b, 0x02, 0x6c, 0xfd, 0x0b, 0xb1,
-  0x02, 0xf4, 0x7d, 0x9a, 0xfd, 0xbd, 0x02, 0xfa, 0xc8, 0x26, 0xc8, 0xfe,
-  0x32, 0xc8, 0xfd, 0xfe, 0xee, 0x01, 0xa4, 0xfe, 0xac, 0xee, 0x01, 0x98,
-  0x01, 0x98, 0x00, 0x00, 0x00, 0x02, 0x00, 0xf9, 0x00, 0x00, 0x05, 0x94,
-  0x04, 0x98, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x00, 0x21, 0x27, 0x21, 0x27,
-  0x11, 0x21, 0x35, 0x33, 0x01, 0x17, 0x01, 0x03, 0x15, 0x09, 0x01, 0x15,
-  0x21, 0x11, 0x03, 0x79, 0x47, 0xfe, 0x21, 0x5a, 0x02, 0x26, 0x63, 0x01,
-  0xb7, 0x5a, 0xfe, 0x49, 0x75, 0x01, 0x6f, 0xfe, 0x91, 0xfd, 0xda, 0x9e,
-  0xc8, 0x02, 0x94, 0x9e, 0xfe, 0x18, 0xc8, 0xfe, 0x18, 0x01, 0xb6, 0x9e,
-  0x01, 0x98, 0x01, 0x98, 0x9e, 0xfe, 0x0c, 0x00, 0x00, 0x02, 0x00, 0xf9,
-  0x00, 0x00, 0x05, 0x94, 0x04, 0x98, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x00,
-  0x01, 0x33, 0x01, 0x07, 0x01, 0x23, 0x35, 0x21, 0x11, 0x37, 0x21, 0x13,
-  0x21, 0x11, 0x21, 0x15, 0x09, 0x01, 0x03, 0x79, 0x63, 0x01, 0xb7, 0x5a,
-  0xfe, 0x49, 0x63, 0xfd, 0xda, 0x5a, 0x01, 0xdf, 0x35, 0xfd, 0xda, 0x02,
-  0x26, 0x01, 0x6f, 0xfe, 0x91, 0x04, 0x98, 0xfe, 0x18, 0xc8, 0xfe, 0x18,
-  0x9e, 0x02, 0x94, 0xc8, 0xfe, 0xe8, 0xfe, 0x0c, 0x9e, 0x01, 0x98, 0x01,
-  0x98, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x72, 0x00, 0x64, 0x05, 0xc1,
-  0x04, 0x98, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x00, 0x13, 0x03, 0x21, 0x35,
-  0x33, 0x01, 0x17, 0x01, 0x23, 0x27, 0x35, 0x21, 0x27, 0x13, 0x07, 0x21,
-  0x15, 0x09, 0x01, 0x15, 0x21, 0xf9, 0x87, 0x03, 0x07, 0x63, 0x01, 0xb7,
-  0x2d, 0xfe, 0x49, 0x63, 0x2d, 0xfd, 0x26, 0x2d, 0xda, 0x66, 0x02, 0xdb,
-  0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x25, 0x02, 0xb0, 0x01, 0x4a, 0x9e, 0xfe,
-  0x18, 0x64, 0xfe, 0x18, 0x63, 0x3b, 0x64, 0x01, 0x4a, 0xfa, 0x9e, 0x01,
-  0x98, 0x01, 0x98, 0x9e, 0x00, 0x02, 0x00, 0x72, 0x00, 0x64, 0x05, 0xc1,
-  0x04, 0x98, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x00, 0x13, 0x03, 0x37, 0x21,
-  0x35, 0x37, 0x33, 0x01, 0x07, 0x01, 0x23, 0x35, 0x21, 0x13, 0x07, 0x21,
-  0x15, 0x09, 0x01, 0x15, 0x21, 0xf9, 0x87, 0x2d, 0x02, 0xda, 0x2d, 0x63,
-  0x01, 0xb7, 0x2d, 0xfe, 0x49, 0x63, 0xfc, 0xf9, 0xda, 0x66, 0x02, 0xdb,
-  0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x25, 0x02, 0x4c, 0x01, 0x4a, 0x64, 0x3b,
-  0x63, 0xfe, 0x18, 0x64, 0xfe, 0x18, 0x9e, 0x01, 0x4a, 0xfa, 0x9e, 0x01,
-  0x98, 0x01, 0x98, 0x9e, 0x00, 0x01, 0x01, 0x1c, 0xff, 0xd8, 0x05, 0x31,
-  0x04, 0xaf, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x21, 0x15, 0x09, 0x01,
-  0x15, 0x01, 0x1c, 0x24, 0x3c, 0x51, 0x62, 0x64, 0x71, 0x6d, 0x69, 0x5e,
-  0x55, 0x51, 0x52, 0x4f, 0x54, 0x4e, 0x65, 0x64, 0xdf, 0x68, 0x5f, 0x54,
-  0x39, 0x25, 0x02, 0x1c, 0x01, 0x9c, 0xfe, 0x64, 0x03, 0x6e, 0x47, 0x43,
-  0x5a, 0x2e, 0x2f, 0x2f, 0x2b, 0x5d, 0x59, 0xdd, 0x80, 0x7a, 0xda, 0x5f,
-  0x58, 0x30, 0x2f, 0x2f, 0x2b, 0x5d, 0x3e, 0x49, 0x9e, 0x01, 0xca, 0x01,
-  0xca, 0x9e, 0x00, 0x00, 0x00, 0x09, 0x00, 0x75, 0x01, 0x42, 0x05, 0xaf,
-  0x03, 0xc2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x1e,
-  0x00, 0x22, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x07,
-  0x33, 0x37, 0x23, 0x07, 0x33, 0x37, 0x23, 0x07, 0x33, 0x37, 0x23, 0x07,
-  0x33, 0x37, 0x23, 0x35, 0x03, 0x21, 0x13, 0x21, 0x11, 0x16, 0x17, 0x06,
-  0x07, 0x11, 0x21, 0x03, 0x21, 0x01, 0x33, 0x27, 0x23, 0x17, 0x33, 0x27,
-  0x23, 0x17, 0x33, 0x27, 0x23, 0x17, 0x33, 0x27, 0x23, 0x02, 0x97, 0x90,
-  0x36, 0x90, 0xa2, 0x90, 0x36, 0x90, 0xa2, 0x90, 0x36, 0x90, 0xa2, 0x90,
-  0x36, 0x90, 0x6c, 0xa8, 0x01, 0xe6, 0xa8, 0x01, 0x60, 0x9c, 0xaf, 0xaf,
-  0x9c, 0xfe, 0xa0, 0xa8, 0xfe, 0x1a, 0x02, 0x22, 0x36, 0x90, 0x36, 0x24,
-  0x36, 0x90, 0x36, 0x24, 0x36, 0x90, 0x36, 0x24, 0x36, 0x90, 0x36, 0x02,
-  0x5a, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0x50, 0x01, 0x18,
-  0xfe, 0xe8, 0x01, 0x16, 0xbc, 0x82, 0x82, 0xbc, 0x01, 0x16, 0xfe, 0xe8,
-  0x01, 0x68, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x94, 0x00, 0x70, 0x04, 0xe9, 0x05, 0x3e, 0x00, 0x0c,
-  0x00, 0x10, 0x00, 0x14, 0x00, 0x00, 0x01, 0x37, 0x06, 0x15, 0x14, 0x17,
-  0x26, 0x23, 0x22, 0x07, 0x37, 0x27, 0x37, 0x09, 0x01, 0x23, 0x01, 0x25,
-  0x11, 0x01, 0x11, 0x04, 0x2b, 0x9e, 0x06, 0x25, 0x7f, 0x94, 0x3b, 0x3f,
-  0x9d, 0xe4, 0x32, 0xfe, 0x4d, 0x01, 0x7f, 0xff, 0xfe, 0x81, 0x01, 0x33,
-  0x01, 0x7e, 0x01, 0x7b, 0xb0, 0x46, 0x43, 0xa3, 0x8f, 0x2a, 0x07, 0xb0,
-  0xfe, 0x39, 0x01, 0x6f, 0xfe, 0x58, 0x01, 0xa8, 0x3a, 0x01, 0x1b, 0xfe,
-  0x57, 0xfe, 0xe6, 0x00, 0x00, 0x03, 0x00, 0x69, 0x01, 0x62, 0x05, 0xaf,
-  0x03, 0xa2, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x00, 0x01, 0x35,
-  0x16, 0x17, 0x06, 0x07, 0x35, 0x21, 0x35, 0x05, 0x21, 0x07, 0x21, 0x13,
-  0x27, 0x21, 0x17, 0x04, 0x7e, 0x8b, 0xa5, 0xa5, 0x8b, 0xfe, 0xbc, 0xfd,
-  0xe3, 0x02, 0x1c, 0xb4, 0xfd, 0xe4, 0xb4, 0xb4, 0x02, 0x1c, 0xb4, 0x02,
-  0xaa, 0xf8, 0xbc, 0x64, 0x64, 0xbc, 0xf8, 0x50, 0x52, 0xc8, 0x01, 0x1a,
-  0xc8, 0xc8, 0x00, 0x00, 0x00, 0x03, 0x00, 0x96, 0xff, 0xc5, 0x04, 0xe9,
-  0x04, 0x94, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x14, 0x00, 0x00, 0x01, 0x27,
-  0x16, 0x33, 0x32, 0x37, 0x06, 0x15, 0x14, 0x17, 0x27, 0x07, 0x27, 0x09,
-  0x01, 0x11, 0x01, 0x03, 0x23, 0x01, 0x21, 0x03, 0xf8, 0x9d, 0x3f, 0x3b,
-  0x94, 0x7f, 0x25, 0x06, 0x9e, 0xe5, 0x32, 0xfe, 0xb5, 0x01, 0x7e, 0xfe,
-  0x82, 0x34, 0xff, 0x01, 0x7e, 0x00, 0xff, 0x03, 0xc1, 0xb0, 0x07, 0x2a,
-  0x90, 0xa2, 0x43, 0x46, 0xb0, 0xff, 0x39, 0xfe, 0x1d, 0x01, 0xa8, 0xfe,
-  0xe5, 0xfe, 0x58, 0x01, 0x55, 0x01, 0xa8, 0x00, 0x00, 0x01, 0x00, 0x96,
-  0x00, 0x70, 0x04, 0xe9, 0x05, 0x3e, 0x00, 0x2a, 0x00, 0x00, 0x25, 0x26,
-  0x23, 0x22, 0x07, 0x3e, 0x01, 0x37, 0x27, 0x26, 0x27, 0x26, 0x22, 0x06,
-  0x07, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x37, 0x26, 0x35, 0x34,
-  0x36, 0x37, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x17, 0x01, 0x3e,
-  0x01, 0x37, 0x06, 0x15, 0x14, 0x04, 0xe8, 0x80, 0x95, 0x3b, 0x3e, 0x40,
-  0x74, 0x15, 0x95, 0x96, 0x1f, 0x22, 0x46, 0x44, 0x19, 0xfe, 0x82, 0x21,
-  0x4e, 0x2a, 0x28, 0x2b, 0x13, 0x05, 0x12, 0x21, 0x1e, 0x01, 0x7e, 0x1d,
-  0x16, 0x0c, 0x0e, 0x06, 0x01, 0x24, 0x03, 0x30, 0x41, 0x06, 0x70, 0x2a,
-  0x07, 0x47, 0x36, 0x03, 0xa6, 0xa6, 0x0e, 0x0f, 0x1e, 0x1c, 0x01, 0xa8,
-  0x24, 0x22, 0x12, 0x08, 0x21, 0x30, 0x2c, 0x30, 0x59, 0x22, 0xfe, 0x57,
-  0x21, 0x46, 0x26, 0x27, 0x26, 0x23, 0x07, 0xfe, 0xbb, 0x17, 0x81, 0x47,
-  0x47, 0x43, 0xa3, 0x00, 0x00, 0x01, 0x00, 0x69, 0x01, 0x61, 0x05, 0xaf,
-  0x03, 0xa3, 0x00, 0x27, 0x00, 0x00, 0x01, 0x06, 0x07, 0x34, 0x36, 0x37,
-  0x23, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x21, 0x34, 0x36, 0x37,
-  0x36, 0x3f, 0x01, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x21, 0x14, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x33, 0x21, 0x2e, 0x01, 0x35, 0x16, 0x05, 0xae,
-  0xa4, 0x8c, 0x30, 0x0c, 0xd3, 0xd3, 0x1f, 0x21, 0x1a, 0x19, 0x1c, 0xfd,
-  0xe4, 0x22, 0x1e, 0x1c, 0x2a, 0x13, 0x13, 0x2a, 0x1c, 0x1e, 0x22, 0x02,
-  0x1c, 0x1c, 0x19, 0x1a, 0x21, 0x1f, 0x09, 0x01, 0x9d, 0x0c, 0x30, 0x8c,
-  0x02, 0x82, 0x65, 0xbc, 0x65, 0x81, 0x13, 0x0f, 0x10, 0x1c, 0x1b, 0x4a,
-  0x28, 0x30, 0x59, 0x21, 0x1f, 0x15, 0x09, 0x1b, 0x15, 0x1f, 0x22, 0x58,
-  0x30, 0x28, 0x4a, 0x1b, 0x1c, 0x10, 0x0f, 0x13, 0x81, 0x65, 0xbc, 0x00,
-  0x00, 0x01, 0x00, 0x96, 0xff, 0xc6, 0x04, 0xe9, 0x04, 0x94, 0x00, 0x2a,
-  0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x17, 0x2e, 0x01, 0x27, 0x07, 0x06,
-  0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x3f,
-  0x01, 0x27, 0x06, 0x23, 0x22, 0x26, 0x27, 0x01, 0x1e, 0x01, 0x32, 0x37,
-  0x36, 0x37, 0x01, 0x2e, 0x01, 0x27, 0x16, 0x33, 0x32, 0x04, 0xe8, 0x24,
-  0x06, 0x41, 0x30, 0x03, 0x97, 0x96, 0x0b, 0x0c, 0x1a, 0x19, 0xfe, 0x82,
-  0x1e, 0x21, 0x12, 0x07, 0x1f, 0x2b, 0x28, 0x2b, 0x4f, 0x1f, 0x01, 0x7e,
-  0x19, 0x44, 0x46, 0x22, 0x1f, 0x07, 0x01, 0x24, 0x15, 0x74, 0x40, 0x3e,
-  0x3b, 0x95, 0x04, 0x94, 0x8e, 0xa3, 0x43, 0x47, 0x47, 0x81, 0x17, 0xa8,
-  0xa8, 0x1f, 0x26, 0x27, 0x26, 0x4b, 0x1c, 0xfe, 0x57, 0x22, 0x59, 0x30,
-  0x2c, 0x30, 0x15, 0x04, 0x12, 0x24, 0x22, 0x01, 0xa8, 0x1c, 0x1e, 0x0f,
-  0x0e, 0x07, 0x01, 0x45, 0x03, 0x36, 0x47, 0x07, 0x00, 0x03, 0x00, 0x67,
-  0x00, 0xac, 0x05, 0xaf, 0x04, 0x58, 0x00, 0x14, 0x00, 0x27, 0x00, 0x3c,
-  0x00, 0x00, 0x01, 0x36, 0x25, 0x06, 0x03, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x24,
-  0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x04, 0x05, 0x04, 0x05,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x26, 0x27, 0x2e, 0x01, 0x35,
-  0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x12, 0x17, 0x24, 0x03, 0xc4, 0xdd, 0x01, 0x0d, 0xcc, 0x6e, 0x0a, 0x13,
-  0x14, 0x19, 0x17, 0x38, 0x17, 0x18, 0x14, 0x13, 0x15, 0x15, 0x13, 0x14,
-  0xfc, 0xbc, 0x1c, 0x19, 0x1a, 0x20, 0x20, 0x49, 0x20, 0x01, 0x3e, 0x03,
-  0x0f, 0xfc, 0xdb, 0xfe, 0xd8, 0x20, 0x49, 0x20, 0x25, 0x15, 0x1b, 0x03,
-  0x42, 0x18, 0x14, 0x13, 0x15, 0x15, 0x13, 0x14, 0x18, 0x17, 0x38, 0x17,
-  0x19, 0x14, 0x10, 0x0d, 0x6c, 0xce, 0xfe, 0xb9, 0x01, 0xce, 0x62, 0x51,
-  0x75, 0xfe, 0xfd, 0x1d, 0x14, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x14,
-  0x38, 0x1f, 0x1e, 0x38, 0x14, 0x15, 0x97, 0x52, 0x4b, 0x1a, 0x1c, 0x10,
-  0x0f, 0x0e, 0x85, 0x36, 0x38, 0x83, 0x0e, 0x0f, 0x12, 0x1a, 0x1f, 0x01,
-  0x23, 0x0c, 0x15, 0x14, 0x38, 0x1e, 0x1f, 0x38, 0x14, 0x15, 0x0c, 0x0b,
-  0x0b, 0x0c, 0x15, 0x11, 0x20, 0xfe, 0xfe, 0x76, 0x63, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x87, 0x01, 0x1f, 0x05, 0x9d, 0x03, 0xe5, 0x00, 0x1a,
-  0x00, 0x2a, 0x00, 0x00, 0x13, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x05, 0x04, 0x07, 0x0e, 0x01, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x25, 0x2e, 0x01, 0x35, 0x34,
-  0x36, 0x37, 0x16, 0x17, 0x06, 0x07, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x87,
-  0x3b, 0x1a, 0x1d, 0x12, 0x23, 0x24, 0x26, 0x2a, 0x30, 0x2f, 0x36, 0x2e,
-  0x92, 0x01, 0x69, 0xfe, 0x97, 0x92, 0x33, 0x62, 0x2e, 0x2d, 0x23, 0x34,
-  0x13, 0x1a, 0x15, 0x1a, 0x03, 0x9f, 0x21, 0x21, 0x21, 0x21, 0x59, 0xe2,
-  0xe2, 0x59, 0x21, 0x21, 0x21, 0x02, 0x82, 0x26, 0x3a, 0x3f, 0x13, 0x24,
-  0x12, 0x13, 0x13, 0x16, 0x20, 0x66, 0x4c, 0x4c, 0x66, 0x23, 0x26, 0x13,
-  0x1d, 0x19, 0x23, 0x2f, 0x3a, 0x26, 0x27, 0x58, 0x32, 0x33, 0x58, 0x27,
-  0xf1, 0x72, 0x72, 0xf1, 0x27, 0x58, 0x33, 0x32, 0x58, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x91, 0x01, 0x56, 0x05, 0x94, 0x03, 0xae, 0x00, 0x63,
-  0x00, 0x00, 0x00, 0x14, 0x06, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3f, 0x01, 0x36, 0x35, 0x34, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x06, 0x07, 0x06, 0x0f,
-  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21, 0x22, 0x2e, 0x02, 0x34,
-  0x3f, 0x01, 0x36, 0x34, 0x2f, 0x01, 0x26, 0x34, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x21, 0x32, 0x17, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35,
-  0x34, 0x2f, 0x01, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x1f, 0x01, 0x16, 0x05, 0x93, 0x05, 0x05, 0xd8, 0x04, 0x08,
-  0x06, 0x0f, 0x06, 0x06, 0x06, 0x05, 0x06, 0x03, 0x18, 0x03, 0x05, 0x06,
-  0x04, 0x07, 0x08, 0x06, 0xfe, 0x07, 0x06, 0x06, 0x06, 0x04, 0x04, 0x51,
-  0x05, 0x02, 0x06, 0x07, 0x05, 0x07, 0xfd, 0xd9, 0x07, 0x0d, 0x0b, 0x05,
-  0x02, 0x35, 0x35, 0x01, 0x69, 0x02, 0x05, 0x06, 0x05, 0x06, 0x07, 0x07,
-  0x02, 0x27, 0x07, 0x05, 0x08, 0x05, 0x02, 0x05, 0x51, 0x04, 0x04, 0x06,
-  0x06, 0x06, 0x07, 0xfe, 0x06, 0x08, 0x07, 0x04, 0x06, 0x05, 0x03, 0x18,
-  0x03, 0x06, 0x05, 0x06, 0x06, 0x06, 0x0f, 0x06, 0x08, 0x04, 0xd8, 0x05,
-  0x02, 0x8b, 0x12, 0x0e, 0x06, 0xf0, 0x04, 0x05, 0x03, 0x03, 0x04, 0x05,
-  0x06, 0x0e, 0x09, 0x04, 0x0b, 0x63, 0x0b, 0x05, 0x07, 0x0f, 0x06, 0x05,
-  0x03, 0x04, 0x03, 0x04, 0x05, 0x05, 0x08, 0xb4, 0x0a, 0x03, 0x05, 0x04,
-  0x03, 0x06, 0x0c, 0x0e, 0x12, 0x06, 0x75, 0x75, 0x14, 0x02, 0xe8, 0x06,
-  0x12, 0x0e, 0x06, 0x05, 0x04, 0x03, 0x03, 0x03, 0x06, 0x03, 0x0a, 0xb4,
-  0x08, 0x05, 0x05, 0x04, 0x03, 0x04, 0x03, 0x05, 0x06, 0x0f, 0x07, 0x05,
-  0x0b, 0x63, 0x0b, 0x04, 0x09, 0x0e, 0x06, 0x05, 0x04, 0x03, 0x03, 0x05,
-  0x04, 0xf0, 0x06, 0x00, 0x00, 0x01, 0x00, 0x91, 0x00, 0xf1, 0x05, 0x94,
-  0x04, 0x13, 0x00, 0x63, 0x00, 0x00, 0x00, 0x14, 0x06, 0x07, 0x01, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3f, 0x01,
-  0x36, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07,
-  0x06, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21,
-  0x22, 0x2e, 0x02, 0x34, 0x3f, 0x01, 0x36, 0x34, 0x27, 0x03, 0x26, 0x34,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x21, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x13, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x37, 0x36,
-  0x37, 0x3e, 0x01, 0x35, 0x34, 0x2f, 0x01, 0x26, 0x35, 0x34, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x01, 0x16, 0x05, 0x93, 0x05,
-  0x05, 0xfe, 0x98, 0x05, 0x07, 0x06, 0x0f, 0x06, 0x06, 0x06, 0x05, 0x06,
-  0x03, 0x4e, 0x03, 0x05, 0x06, 0x04, 0x07, 0x08, 0x06, 0x53, 0x07, 0x06,
-  0x07, 0x05, 0x04, 0x04, 0x6c, 0x05, 0x02, 0x06, 0x07, 0x05, 0x07, 0xfd,
-  0xac, 0x07, 0x0d, 0x0b, 0x05, 0x03, 0x42, 0x42, 0x01, 0x8d, 0x02, 0x05,
-  0x06, 0x05, 0x06, 0x07, 0x07, 0x02, 0x54, 0x07, 0x05, 0x08, 0x05, 0x03,
-  0x04, 0x75, 0x04, 0x04, 0x05, 0x07, 0x06, 0x07, 0x53, 0x06, 0x08, 0x07,
-  0x04, 0x06, 0x05, 0x03, 0x4e, 0x03, 0x06, 0x05, 0x06, 0x06, 0x06, 0x0f,
-  0x06, 0x07, 0x05, 0x01, 0x68, 0x05, 0x02, 0x8b, 0x12, 0x0f, 0x05, 0xfe,
-  0x98, 0x05, 0x04, 0x03, 0x03, 0x04, 0x05, 0x06, 0x0e, 0x09, 0x07, 0x08,
-  0xdb, 0x08, 0x08, 0x07, 0x0f, 0x06, 0x05, 0x03, 0x04, 0x03, 0x04, 0x05,
-  0x05, 0x08, 0xf0, 0x0a, 0x03, 0x05, 0x04, 0x03, 0x06, 0x0c, 0x0e, 0x12,
-  0x06, 0x93, 0x93, 0x14, 0x02, 0x01, 0x38, 0x06, 0x12, 0x0e, 0x06, 0x05,
-  0x04, 0x03, 0x03, 0x03, 0x06, 0x03, 0x0a, 0xfe, 0xfc, 0x08, 0x05, 0x05,
-  0x04, 0x03, 0x04, 0x03, 0x05, 0x06, 0x0f, 0x07, 0x08, 0x08, 0xdb, 0x08,
-  0x07, 0x09, 0x0e, 0x06, 0x05, 0x04, 0x03, 0x03, 0x04, 0x05, 0xfe, 0x98,
-  0x05, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x69, 0x00, 0xa6, 0x05, 0xaf,
-  0x04, 0x5e, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x27, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x07, 0x23, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26,
-  0x2f, 0x01, 0x33, 0x16, 0x17, 0x16, 0x01, 0x23, 0x3e, 0x01, 0x37, 0x21,
-  0x35, 0x21, 0x0e, 0x01, 0x03, 0x1e, 0x01, 0x17, 0x21, 0x35, 0x21, 0x2e,
-  0x01, 0x27, 0x05, 0xae, 0x7a, 0x4b, 0x7e, 0x42, 0x61, 0x29, 0x29, 0x90,
-  0x22, 0x40, 0x40, 0x22, 0x90, 0x12, 0x40, 0x61, 0x41, 0x7f, 0x4b, 0xfe,
-  0x04, 0x5e, 0x11, 0x31, 0x26, 0xfd, 0x27, 0x03, 0x82, 0x63, 0x44, 0x0c,
-  0x0c, 0x44, 0x63, 0xfc, 0x7e, 0x02, 0xd9, 0x26, 0x31, 0x11, 0x02, 0x82,
-  0x4f, 0x55, 0x8f, 0xa9, 0x6e, 0x6d, 0xa4, 0x27, 0x36, 0x36, 0x27, 0xa4,
-  0x31, 0xaa, 0xa4, 0x94, 0x55, 0xfd, 0xd5, 0x3d, 0x85, 0x48, 0x64, 0x8e,
-  0xb7, 0x03, 0x8f, 0x29, 0xb7, 0x8e, 0x64, 0x48, 0x85, 0x3d, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x63, 0xfe, 0xb2, 0x02, 0x88, 0x06, 0x26, 0x00, 0x19,
-  0x00, 0x00, 0x01, 0x2a, 0x01, 0x27, 0x24, 0x03, 0x26, 0x00, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x27, 0x36, 0x37, 0x36, 0x15, 0x14, 0x00, 0x07, 0x06,
-  0x05, 0x16, 0x36, 0x37, 0x02, 0x88, 0x08, 0x5e, 0x31, 0xfe, 0x74, 0x02,
-  0x01, 0x01, 0x49, 0x04, 0x03, 0x54, 0x34, 0x29, 0x7a, 0x2d, 0xc0, 0xc8,
-  0xfe, 0xd2, 0x07, 0x0b, 0x01, 0x00, 0x4a, 0x3e, 0x12, 0xfe, 0xb2, 0x0b,
-  0x53, 0x01, 0x52, 0xae, 0x03, 0xf5, 0x51, 0x4f, 0x89, 0x31, 0xd8, 0x01,
-  0x01, 0xcc, 0xa1, 0xfc, 0x4c, 0x8f, 0xdc, 0x48, 0x15, 0x01, 0x02, 0x00,
-  0x00, 0x01, 0x00, 0x47, 0xfe, 0xb2, 0x02, 0x6d, 0x06, 0x26, 0x00, 0x19,
-  0x00, 0x00, 0x13, 0x35, 0x1e, 0x01, 0x37, 0x24, 0x27, 0x26, 0x00, 0x35,
-  0x34, 0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x06, 0x00, 0x07,
-  0x02, 0x05, 0x06, 0x22, 0x47, 0x12, 0x3e, 0x4a, 0x01, 0x00, 0x0b, 0x06,
-  0xfe, 0xd1, 0xc8, 0xc0, 0x2d, 0x7a, 0x28, 0x35, 0x54, 0x03, 0x04, 0x01,
-  0x49, 0x01, 0x02, 0xfe, 0x74, 0x31, 0x5e, 0xfe, 0xb2, 0x8f, 0x02, 0x01,
-  0x15, 0x48, 0xdc, 0x8f, 0x03, 0xb4, 0xa1, 0xcc, 0x01, 0x01, 0xd8, 0x31,
-  0x89, 0x4f, 0x51, 0xfc, 0x0b, 0xae, 0xfe, 0xae, 0x53, 0x0b, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x05, 0xfe, 0x23, 0x03, 0x8a, 0x06, 0x75, 0x00, 0x03,
-  0x00, 0x06, 0x00, 0x09, 0x00, 0x00, 0x09, 0x05, 0x21, 0x09, 0x01, 0x21,
-  0x01, 0xc6, 0x01, 0xc3, 0xfe, 0x3d, 0xfe, 0x3f, 0x01, 0xc1, 0xfe, 0xbc,
-  0x02, 0x8a, 0xfe, 0xba, 0x01, 0x46, 0xfd, 0x76, 0x06, 0x75, 0xfb, 0xdb,
-  0xfb, 0xd3, 0x04, 0x2d, 0x03, 0x31, 0xfd, 0x08, 0xfc, 0x8e, 0x03, 0x00,
-  0x00, 0x02, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0xdf, 0x06, 0x14, 0x00, 0x03,
-  0x00, 0x0b, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x25, 0x21, 0x15, 0x23,
-  0x11, 0x33, 0x15, 0x21, 0xf8, 0xb4, 0xfe, 0xf2, 0x02, 0x40, 0xd8, 0xd8,
-  0xfd, 0xc0, 0x05, 0xb0, 0xf9, 0xa6, 0x06, 0x5a, 0x64, 0x64, 0xf9, 0xa6,
-  0x64, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d, 0xfe, 0xf2, 0x02, 0xde,
-  0x06, 0x14, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23, 0x11, 0x33,
-  0x13, 0x11, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35, 0x02, 0x84, 0xb4, 0xb4,
-  0x5a, 0xfd, 0xc0, 0xd8, 0xd8, 0x05, 0xb0, 0xf9, 0xa6, 0x06, 0xbe, 0xf8,
-  0xde, 0x64, 0x06, 0x5a, 0x64, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa4,
-  0xfe, 0xf2, 0x02, 0x3c, 0x06, 0x12, 0x00, 0x05, 0x00, 0x00, 0x1b, 0x01,
-  0x33, 0x03, 0x13, 0x23, 0xa5, 0xfd, 0x9a, 0xfe, 0xfe, 0x9a, 0x02, 0x82,
-  0x03, 0x90, 0xfc, 0x70, 0xfc, 0x70, 0x00, 0x00, 0x00, 0x01, 0x00, 0x93,
-  0xfe, 0xf2, 0x02, 0x2b, 0x06, 0x12, 0x00, 0x05, 0x00, 0x00, 0x01, 0x03,
-  0x23, 0x13, 0x03, 0x33, 0x02, 0x2a, 0xfd, 0x99, 0xfd, 0xfd, 0x99, 0x02,
-  0x82, 0xfc, 0x70, 0x03, 0x90, 0x03, 0x90, 0x00, 0xff, 0xff, 0x00, 0xa4,
-  0xfe, 0xf2, 0x03, 0x6e, 0x06, 0x12, 0x10, 0x26, 0x0c, 0x97, 0x00, 0x00,
-  0x10, 0x07, 0x0c, 0x97, 0x01, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0x93,
-  0xfe, 0xf2, 0x03, 0x5d, 0x06, 0x12, 0x10, 0x26, 0x0c, 0x98, 0x00, 0x00,
-  0x10, 0x07, 0x0c, 0x98, 0x01, 0x32, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51,
-  0x00, 0x00, 0x05, 0xb9, 0x05, 0xdc, 0x00, 0x16, 0x00, 0x00, 0x09, 0x01,
-  0x07, 0x27, 0x11, 0x23, 0x11, 0x27, 0x11, 0x23, 0x11, 0x27, 0x07, 0x11,
-  0x23, 0x11, 0x07, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x03, 0x2e, 0x02,
-  0x8a, 0x6c, 0x52, 0x6c, 0xbe, 0x6c, 0x5f, 0x5f, 0x6c, 0xbd, 0x6c, 0x53,
-  0x6c, 0x02, 0x8a, 0x05, 0xdc, 0xfd, 0x2c, 0x78, 0x5c, 0xfd, 0x14, 0x03,
-  0x65, 0xd3, 0xfb, 0xc8, 0x04, 0xb0, 0x68, 0x68, 0xfb, 0x50, 0x04, 0x38,
-  0xd3, 0xfc, 0x9b, 0x02, 0xec, 0x5c, 0x78, 0x02, 0xd4, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x50, 0xff, 0xf9, 0x05, 0xb7, 0x05, 0xd5, 0x00, 0x16,
-  0x00, 0x00, 0x05, 0x01, 0x37, 0x17, 0x11, 0x33, 0x11, 0x17, 0x11, 0x33,
-  0x11, 0x17, 0x37, 0x11, 0x33, 0x11, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17,
-  0x01, 0x02, 0xda, 0xfd, 0x76, 0x6c, 0x53, 0x6c, 0xbd, 0x6c, 0x5f, 0x60,
-  0x6c, 0xbd, 0x6c, 0x52, 0x6c, 0xfd, 0x77, 0x07, 0x02, 0xd4, 0x78, 0x5c,
-  0x02, 0xec, 0xfc, 0x9b, 0xd3, 0x04, 0x38, 0xfb, 0x50, 0x68, 0x68, 0x04,
-  0xb0, 0xfb, 0xc8, 0xd3, 0x03, 0x65, 0xfd, 0x14, 0x5c, 0x78, 0xfd, 0x2c,
-  0x00, 0x01, 0x00, 0x47, 0x00, 0x6c, 0x05, 0xde, 0x05, 0x44, 0x00, 0x3d,
-  0x00, 0x00, 0x01, 0x30, 0x37, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x37, 0x17, 0x01, 0x23, 0x01, 0x37,
-  0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x02, 0x28, 0x6b, 0x39, 0x4a, 0x46, 0xab, 0x43,
-  0x4d, 0x36, 0x3c, 0x3b, 0x1e, 0x1f, 0x3a, 0x39, 0x4a, 0x46, 0xab, 0x43,
-  0x4d, 0x36, 0x3c, 0x1d, 0x15, 0x06, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe,
-  0x9d, 0x6c, 0xd2, 0x07, 0x20, 0x2c, 0x50, 0x4b, 0x69, 0x5c, 0x78, 0x73,
-  0x61, 0x66, 0x4e, 0x52, 0x2a, 0x29, 0x29, 0x2a, 0x52, 0x4a, 0x6a, 0x5c,
-  0x78, 0x73, 0x61, 0x60, 0x01, 0x21, 0x78, 0x3f, 0x23, 0x21, 0x21, 0x27,
-  0x3b, 0x42, 0xa2, 0x5d, 0x59, 0x51, 0x53, 0x40, 0x3f, 0x23, 0x21, 0x21,
-  0x27, 0x3b, 0x42, 0x51, 0x39, 0x3f, 0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a,
-  0x78, 0xe9, 0x60, 0x58, 0x71, 0x59, 0x53, 0x34, 0x2e, 0x2e, 0x30, 0x57,
-  0x59, 0x71, 0x70, 0x7b, 0x7f, 0x70, 0x71, 0x59, 0x53, 0x34, 0x2e, 0x2e,
-  0x2d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x47, 0x00, 0x7c, 0x05, 0xde,
-  0x05, 0x54, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x37,
-  0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x03, 0xfd, 0x55, 0x5f, 0x62,
-  0x73, 0x78, 0x5c, 0x69, 0x4b, 0x50, 0x2c, 0x29, 0x29, 0x2c, 0x50, 0x4f,
-  0x65, 0x61, 0x73, 0x78, 0x5d, 0x68, 0x4c, 0x50, 0x2b, 0x20, 0x08, 0xd1,
-  0x6c, 0xfe, 0x9e, 0x51, 0xfe, 0x9f, 0x6c, 0xd1, 0x07, 0x14, 0x1e, 0x3b,
-  0x36, 0x4e, 0x42, 0xac, 0x46, 0x4a, 0x39, 0x3a, 0x1f, 0x1e, 0x3c, 0x3b,
-  0x36, 0x4d, 0x43, 0xab, 0x46, 0x4a, 0x3a, 0x01, 0x31, 0x5a, 0x2d, 0x2e,
-  0x2e, 0x34, 0x53, 0x59, 0x71, 0x70, 0x7f, 0x7b, 0x70, 0x71, 0x59, 0x57,
-  0x30, 0x2e, 0x2e, 0x34, 0x53, 0x59, 0x71, 0x58, 0x60, 0xe9, 0x78, 0xfe,
-  0x76, 0x01, 0x8a, 0x78, 0xea, 0x3f, 0x39, 0x51, 0x42, 0x3b, 0x27, 0x21,
-  0x21, 0x23, 0x3f, 0x40, 0x53, 0x51, 0x59, 0x5d, 0xa2, 0x42, 0x3b, 0x27,
-  0x21, 0x21, 0x23, 0x3f, 0x00, 0x03, 0x00, 0x69, 0xff, 0xe3, 0x07, 0xfb,
-  0x05, 0x24, 0x00, 0x25, 0x00, 0x39, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x15,
-  0x01, 0x27, 0x37, 0x21, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36, 0x37,
-  0x3e, 0x01, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x27, 0x37,
-  0x24, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x11, 0x33,
-  0x11, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x23,
-  0x11, 0x21, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x07, 0xfb, 0xfe, 0x9e, 0x6c, 0xd2, 0xfe, 0xc3,
-  0x0a, 0x1d, 0x2d, 0x59, 0x58, 0xd6, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x1e,
-  0x0a, 0xaa, 0xaa, 0x09, 0x1f, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58,
-  0x59, 0x2d, 0x1e, 0x09, 0x01, 0x3d, 0xd2, 0x6c, 0xfd, 0x32, 0xc1, 0x53,
-  0x53, 0x44, 0x46, 0x22, 0x15, 0x08, 0x01, 0x83, 0x99, 0x01, 0x83, 0x08,
-  0x14, 0x23, 0x45, 0x44, 0x53, 0x01, 0x1b, 0xfe, 0x7d, 0x99, 0xfe, 0x7d,
-  0x09, 0x14, 0x22, 0x46, 0x44, 0x53, 0x53, 0xc1, 0x54, 0x53, 0x44, 0x45,
-  0x23, 0x13, 0x02, 0xaf, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x5a, 0x51, 0x76,
-  0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x51, 0x5a, 0xaa, 0x5b, 0x52,
-  0x77, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x77, 0x52, 0x5b, 0xe9, 0x78,
-  0x56, 0x27, 0x27, 0x4c, 0x4d, 0x5c, 0x37, 0x3d, 0x01, 0x65, 0xfe, 0x9b,
-  0x3d, 0x37, 0x5c, 0x4d, 0x4c, 0x27, 0xfd, 0xc6, 0xfe, 0x9b, 0x01, 0x65,
-  0x3b, 0x36, 0x5c, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0x5c,
-  0x36, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea,
-  0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21,
-  0x15, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x08, 0x93, 0xf7,
-  0x6d, 0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0xe9,
-  0x78, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9,
-  0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
-  0x35, 0x21, 0x27, 0x37, 0x09, 0xf8, 0xfe, 0x9f, 0x6c, 0xd1, 0xf7, 0x6d,
-  0x08, 0x93, 0xd1, 0x6c, 0x02, 0xaf, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xaa,
-  0xe9, 0x78, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xf9,
-  0x04, 0x38, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21,
-  0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x17, 0x07, 0x5a, 0x01,
-  0x62, 0x6c, 0xd2, 0x07, 0xa6, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
-  0xd1, 0xf8, 0x5a, 0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9,
-  0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xe9, 0x78, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea, 0x04, 0x38, 0x00, 0x0e,
-  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
-  0x07, 0x21, 0x15, 0x21, 0x07, 0x01, 0x68, 0x08, 0x81, 0xf7, 0xeb, 0x54,
-  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x08, 0x15, 0xf7, 0x7f, 0x5e,
-  0x02, 0x19, 0x78, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d,
-  0x78, 0x69, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9,
-  0x04, 0x38, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x37, 0x27, 0x21, 0x35, 0x21,
-  0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x35, 0x08, 0xea, 0x5f,
-  0x5f, 0xf7, 0x7f, 0x08, 0x15, 0x53, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
-  0x53, 0xf7, 0xeb, 0x02, 0x19, 0x69, 0x69, 0x78, 0x5d, 0x78, 0xfe, 0x77,
-  0x5a, 0xfe, 0x77, 0x78, 0x5d, 0x78, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
-  0x00, 0xcc, 0x09, 0xf9, 0x04, 0x38, 0x00, 0x05, 0x00, 0x15, 0x00, 0x00,
-  0x01, 0x21, 0x37, 0x27, 0x21, 0x07, 0x05, 0x21, 0x17, 0x07, 0x01, 0x35,
-  0x01, 0x17, 0x07, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x01, 0x68,
-  0x07, 0x82, 0x5f, 0x5f, 0xf8, 0x7e, 0x5e, 0x07, 0x74, 0xf9, 0x56, 0x54,
-  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x06, 0xaa, 0x53, 0x6c, 0x01,
-  0x61, 0xfe, 0x9f, 0x6c, 0x02, 0x19, 0x69, 0x69, 0x69, 0xe1, 0x5d, 0x78,
-  0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d, 0x5d, 0x78, 0xfe, 0x77, 0x5a,
-  0xfe, 0x77, 0x78, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea,
-  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x17, 0x07, 0x01, 0x35,
-  0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x23, 0x09, 0x50, 0xf8, 0x06,
-  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x07, 0xfa, 0x99, 0x99,
-  0x02, 0x2d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01,
-  0x59, 0xfc, 0xa4, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9,
-  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11,
-  0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x01, 0x02, 0x99, 0x99,
-  0x07, 0xfa, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0x02, 0x2d,
-  0xfe, 0xa7, 0x03, 0x5c, 0xfe, 0xa7, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
-  0x77, 0x78, 0xe9, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea,
-  0x04, 0x38, 0x00, 0x0d, 0x00, 0x12, 0x00, 0x00, 0x01, 0x21, 0x17, 0x07,
-  0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x35, 0x33, 0x11, 0x23, 0x11, 0x35,
-  0x21, 0x07, 0x17, 0x09, 0x50, 0xf8, 0x84, 0x54, 0x6c, 0xfe, 0x9e, 0x01,
-  0x62, 0x6c, 0x54, 0x07, 0x7c, 0x99, 0x99, 0xf8, 0x18, 0x5e, 0x5e, 0x01,
-  0xa1, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d, 0xcd, 0xfc,
-  0xa4, 0x01, 0x45, 0xd2, 0x69, 0x69, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
-  0x00, 0xcc, 0x09, 0xf9, 0x04, 0x38, 0x00, 0x0d, 0x00, 0x12, 0x00, 0x00,
-  0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x15, 0x23,
-  0x11, 0x33, 0x11, 0x15, 0x21, 0x37, 0x27, 0x01, 0x02, 0x07, 0x7c, 0x53,
-  0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0x53, 0xf8, 0x84, 0x99, 0x99, 0x07,
-  0xe8, 0x5f, 0x5f, 0x03, 0x63, 0x5d, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77,
-  0x78, 0x5d, 0xcd, 0x03, 0x5c, 0xfe, 0xbb, 0xd2, 0x69, 0x69, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9, 0x04, 0x38, 0x00, 0x25,
-  0x00, 0x00, 0x13, 0x17, 0x37, 0x17, 0x37, 0x17, 0x37, 0x17, 0x37, 0x17,
-  0x37, 0x17, 0x37, 0x17, 0x37, 0x33, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27,
-  0x37, 0x23, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27,
-  0x07, 0x27, 0x07, 0x27, 0x69, 0x3f, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2,
-  0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x3f, 0x7d, 0xd1, 0x6c, 0x01, 0x61,
-  0xfe, 0x9f, 0x6c, 0xd1, 0x59, 0x63, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2,
-  0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x3f, 0x02, 0xd7, 0x46, 0xb4, 0xb4,
-  0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0xe9,
-  0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x6e, 0xb4, 0xb4, 0xb4,
-  0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x05, 0x14, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x02, 0xdd, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x02, 0x1c,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x02, 0x1c, 0x01, 0xd3, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x02, 0x1c,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x03, 0x2a, 0x05, 0x14, 0x04, 0x38, 0x06, 0x40, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x05, 0x14, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0x02, 0xdd, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
-  0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0x00, 0xa7, 0x04, 0x38,
-  0x01, 0xd3, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0x00, 0xa7, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x03, 0x2a, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c, 0xff, 0x9c, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c,
-  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
-  0xfe, 0x70, 0x04, 0x38, 0xff, 0x9c, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38,
-  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0xff, 0x9c, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
-  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
-  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
-  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
-  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
-  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
-  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
-  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0d, 0x00, 0x12, 0x00, 0x00,
-  0x01, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x35, 0x33,
-  0x11, 0x23, 0x11, 0x35, 0x21, 0x07, 0x17, 0x05, 0x06, 0xfc, 0xce, 0x54,
-  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x03, 0x32, 0x99, 0x99, 0xfc,
-  0x62, 0x5e, 0x5e, 0x01, 0xa1, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89,
-  0x78, 0x5d, 0xcd, 0xfc, 0xa4, 0x01, 0x45, 0xd2, 0x69, 0x69, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0d,
-  0x00, 0x12, 0x00, 0x00, 0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27,
-  0x37, 0x21, 0x15, 0x23, 0x11, 0x33, 0x11, 0x15, 0x21, 0x37, 0x27, 0x01,
-  0x02, 0x03, 0x32, 0x53, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0x53, 0xfc,
-  0xce, 0x99, 0x99, 0x03, 0x9e, 0x5f, 0x5f, 0x03, 0x63, 0x5d, 0x78, 0xfe,
-  0x77, 0x5a, 0xfe, 0x77, 0x78, 0x5d, 0xcd, 0x03, 0x5c, 0xfe, 0xbb, 0xd2,
-  0x69, 0x69, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe6, 0x00, 0x00, 0x05, 0x22,
-  0x05, 0xdc, 0x00, 0x11, 0x00, 0x00, 0x13, 0x01, 0x33, 0x01, 0x07, 0x27,
-  0x11, 0x23, 0x11, 0x27, 0x11, 0x23, 0x11, 0x07, 0x11, 0x23, 0x11, 0x07,
-  0xe6, 0x01, 0xf6, 0x51, 0x01, 0xf5, 0x6c, 0x53, 0x6c, 0xbd, 0x6c, 0xbd,
-  0x6c, 0x53, 0x03, 0xae, 0x02, 0x2e, 0xfd, 0xd2, 0x78, 0x5c, 0xfc, 0x6e,
-  0x04, 0x0a, 0xd3, 0xfb, 0x23, 0x04, 0xdd, 0xd3, 0xfb, 0xf6, 0x03, 0x92,
-  0x5c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe6, 0xff, 0xf9, 0x05, 0x22,
-  0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x13, 0x37, 0x17, 0x11, 0x33, 0x11,
-  0x17, 0x11, 0x33, 0x11, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x23,
-  0xe6, 0x6c, 0x53, 0x6c, 0xbd, 0x6c, 0xbd, 0x6c, 0x53, 0x6c, 0xfe, 0x0b,
-  0x51, 0x02, 0x27, 0x78, 0x5c, 0x03, 0x92, 0xfb, 0xf6, 0xd3, 0x04, 0xdd,
-  0xfb, 0x23, 0xd3, 0x04, 0x0a, 0xfc, 0x6e, 0x5c, 0x78, 0xfd, 0xd2, 0x00,
-  0x00, 0x02, 0x00, 0x47, 0x00, 0x80, 0x04, 0xa4, 0x06, 0xb5, 0x00, 0x1e,
-  0x00, 0x3d, 0x00, 0x00, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x10, 0x37, 0x36, 0x37, 0x36, 0x37, 0x01, 0x17, 0x07, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x10, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x03,
-  0x30, 0x17, 0x07, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x02, 0x77, 0x72, 0x65, 0x60, 0x56,
-  0x4d, 0x2d, 0x29, 0x29, 0x2d, 0x4d, 0x58, 0x67, 0x01, 0x61, 0x6c, 0xd1,
-  0x56, 0x4f, 0x61, 0x55, 0x4e, 0x2c, 0x29, 0x29, 0x2c, 0x4e, 0x55, 0x61,
-  0x64, 0x42, 0xd2, 0x6c, 0xfe, 0xda, 0x50, 0x3e, 0x39, 0x1f, 0x1e, 0x1e,
-  0x23, 0x35, 0x3b, 0x92, 0x54, 0x50, 0x49, 0x4b, 0x39, 0x39, 0x1f, 0x1e,
-  0x1e, 0x23, 0x35, 0x3b, 0x49, 0x34, 0x80, 0x2e, 0x2d, 0x5c, 0x5a, 0x6e,
-  0x6c, 0x01, 0x00, 0x6c, 0x6e, 0x5a, 0x5f, 0x2e, 0x01, 0x89, 0x78, 0xe9,
-  0x08, 0x24, 0x2d, 0x5c, 0x5a, 0x6e, 0x6c, 0xff, 0x00, 0x6c, 0x6e, 0x5a,
-  0x5c, 0x2d, 0x2e, 0x04, 0x29, 0xe8, 0x78, 0x01, 0x46, 0x21, 0x46, 0x40,
-  0x52, 0x4e, 0xbe, 0x4a, 0x56, 0x3c, 0x42, 0x42, 0x21, 0x23, 0x40, 0x40,
-  0x52, 0x4e, 0xbe, 0x4a, 0x56, 0x3c, 0x42, 0x21, 0x17, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x47, 0x00, 0x80, 0x04, 0xa4, 0x06, 0xb5, 0x00, 0x1e,
-  0x00, 0x3c, 0x00, 0x00, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
-  0x10, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x27, 0x37, 0x01, 0x16,
-  0x17, 0x16, 0x17, 0x16, 0x10, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x03,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x01, 0x27, 0x02, 0x73, 0x6e, 0x65, 0x60, 0x56, 0x4d,
-  0x2d, 0x29, 0x29, 0x2d, 0x4d, 0x56, 0x60, 0x4f, 0x57, 0xd2, 0x6c, 0x01,
-  0x61, 0x67, 0x58, 0x4e, 0x2c, 0x29, 0x29, 0x2c, 0x4e, 0x55, 0x61, 0x64,
-  0xa0, 0x38, 0x34, 0x49, 0x3b, 0x35, 0x23, 0x1e, 0x1e, 0x1f, 0x39, 0x3a,
-  0x4a, 0x49, 0x50, 0x54, 0x92, 0x3b, 0x35, 0x23, 0x1e, 0x1e, 0x1f, 0x39,
-  0x3e, 0x4f, 0xfe, 0xd9, 0x6c, 0x80, 0x2e, 0x2d, 0x5c, 0x5a, 0x6e, 0x6c,
-  0x01, 0x00, 0x6c, 0x6e, 0x5a, 0x5c, 0x2d, 0x24, 0x08, 0xe9, 0x78, 0xfe,
-  0x77, 0x2e, 0x5f, 0x5a, 0x6e, 0x6c, 0xff, 0x00, 0x6c, 0x6e, 0x5a, 0x5c,
-  0x2d, 0x2e, 0x04, 0x29, 0x07, 0x17, 0x21, 0x42, 0x3c, 0x56, 0x4a, 0xbe,
-  0x4e, 0x52, 0x40, 0x40, 0x23, 0x21, 0x42, 0x42, 0x3c, 0x56, 0x4a, 0xbe,
-  0x4e, 0x52, 0x40, 0x46, 0x21, 0xfe, 0xba, 0x78, 0x00, 0x02, 0x00, 0xe6,
-  0xfe, 0xb2, 0x04, 0x63, 0x06, 0x14, 0x00, 0x10, 0x00, 0x2e, 0x00, 0x00,
-  0x01, 0x15, 0x14, 0x16, 0x17, 0x26, 0x35, 0x11, 0x34, 0x37, 0x0e, 0x01,
-  0x1d, 0x01, 0x10, 0x07, 0x16, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11,
-  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x34, 0x26,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34, 0x36, 0x33, 0x02,
-  0x59, 0x44, 0x9e, 0x2d, 0x2b, 0x9e, 0x42, 0x9b, 0x9b, 0x02, 0x09, 0x2f,
-  0x7e, 0x4d, 0x4d, 0x7e, 0x2f, 0xec, 0xe0, 0x97, 0x61, 0x80, 0x38, 0x38,
-  0x80, 0x61, 0x97, 0xe0, 0x01, 0x12, 0xef, 0x98, 0x6d, 0x07, 0x47, 0x9d,
-  0x04, 0xd0, 0xa1, 0x42, 0x07, 0x6b, 0x98, 0xf0, 0xfe, 0xee, 0x3e, 0x44,
-  0x03, 0xf4, 0x64, 0x57, 0x8e, 0xfb, 0x30, 0x8d, 0x58, 0x64, 0x94, 0xdd,
-  0xef, 0x97, 0x74, 0x8f, 0x73, 0x95, 0xf0, 0xdd, 0x93, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xe6, 0xfe, 0xb2, 0x04, 0x63, 0x06, 0x14, 0x00, 0x10,
-  0x00, 0x2e, 0x00, 0x00, 0x01, 0x10, 0x37, 0x26, 0x11, 0x35, 0x34, 0x26,
-  0x27, 0x16, 0x15, 0x11, 0x14, 0x07, 0x3e, 0x01, 0x35, 0x01, 0x33, 0x32,
-  0x16, 0x1d, 0x01, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d,
-  0x01, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x34,
-  0x26, 0x2b, 0x01, 0x02, 0xf0, 0x9b, 0x9b, 0x42, 0x9f, 0x2c, 0x2d, 0x9e,
-  0x44, 0xfd, 0xf6, 0xed, 0xe0, 0x97, 0x61, 0x7f, 0x38, 0x38, 0x7f, 0x61,
-  0x97, 0xe0, 0xed, 0x30, 0x7e, 0x4d, 0x4d, 0x7e, 0x30, 0x01, 0x12, 0x01,
-  0x0e, 0x44, 0x3e, 0x01, 0x12, 0xf0, 0x98, 0x6b, 0x07, 0x42, 0xa1, 0xfb,
-  0x30, 0x9d, 0x47, 0x07, 0x6d, 0x98, 0x05, 0xf1, 0x93, 0xdd, 0xf0, 0x95,
-  0x73, 0x8f, 0x74, 0x97, 0xef, 0xdd, 0x94, 0x64, 0x58, 0x8d, 0x04, 0xd0,
-  0x8e, 0x57, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x32, 0x05, 0x46,
-  0x05, 0xf9, 0x00, 0x02, 0x00, 0x06, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x00,
-  0x05, 0x11, 0x09, 0x02, 0x35, 0x01, 0x05, 0x09, 0x01, 0x03, 0x11, 0x01,
-  0x15, 0x04, 0xac, 0xfd, 0x00, 0x03, 0x99, 0xfb, 0x7e, 0x04, 0x82, 0xfc,
-  0x17, 0x03, 0x01, 0xfc, 0xff, 0x99, 0x04, 0x82, 0xcc, 0x02, 0x64, 0xfe,
-  0xce, 0xfd, 0xcc, 0x01, 0xe1, 0xa6, 0x01, 0xe1, 0x07, 0x01, 0x32, 0x01,
-  0x32, 0xfc, 0x9a, 0x04, 0x68, 0xfe, 0x1f, 0xa6, 0x00, 0x03, 0x00, 0xc3,
-  0x00, 0x1e, 0x06, 0x70, 0x04, 0xe6, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a,
-  0x00, 0x00, 0x25, 0x23, 0x11, 0x33, 0x01, 0x11, 0x09, 0x02, 0x35, 0x01,
-  0x06, 0x70, 0x99, 0x99, 0xfe, 0x3c, 0xfc, 0xf8, 0x03, 0xa1, 0xfb, 0x7e,
-  0x04, 0x82, 0x1e, 0x04, 0xc8, 0xfc, 0x3a, 0x02, 0xc4, 0xfe, 0x9e, 0xfd,
-  0x9c, 0x02, 0x11, 0xa6, 0x02, 0x11, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0x00, 0x1e, 0x06, 0x70, 0x04, 0xe6, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a,
-  0x00, 0x00, 0x37, 0x11, 0x33, 0x11, 0x09, 0x02, 0x03, 0x11, 0x01, 0x15,
-  0xc3, 0x99, 0x01, 0x2b, 0x03, 0x08, 0xfc, 0xf8, 0x99, 0x04, 0x82, 0x1e,
-  0x04, 0xc8, 0xfb, 0x38, 0x01, 0x02, 0x01, 0x62, 0x01, 0x62, 0xfc, 0x3a,
-  0x04, 0xc8, 0xfd, 0xef, 0xa6, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x05, 0x00, 0x08, 0x00, 0x00,
-  0x17, 0x11, 0x09, 0x01, 0x11, 0x01, 0x37, 0x01, 0x11, 0xc3, 0x02, 0xd7,
-  0x02, 0xd6, 0xfd, 0x2a, 0x8b, 0x01, 0xb2, 0x3e, 0x05, 0x80, 0xfd, 0xb0,
-  0x02, 0x50, 0xfa, 0x80, 0x02, 0x4e, 0x71, 0xfe, 0xa2, 0x02, 0xc6, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x05,
-  0x00, 0x08, 0x00, 0x00, 0x17, 0x11, 0x09, 0x01, 0x11, 0x01, 0x27, 0x01,
-  0x11, 0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0x8c, 0xfe, 0x4e, 0x3e,
-  0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50, 0xfa, 0x80, 0x02, 0x4e, 0x71, 0x01,
-  0x5e, 0xfd, 0x44, 0x00, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70,
-  0x05, 0x42, 0x00, 0x05, 0x00, 0x00, 0x17, 0x11, 0x09, 0x01, 0x11, 0x01,
-  0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0x3e, 0x05, 0x80, 0xfd, 0xb0,
-  0x02, 0x50, 0xfa, 0x80, 0x02, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
-  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x08, 0x00, 0x00, 0x25, 0x15,
-  0x09, 0x01, 0x11, 0x09, 0x01, 0x15, 0x01, 0x06, 0x70, 0xfd, 0x2a, 0xfd,
-  0x29, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0xb5, 0xa2, 0xe0, 0x02, 0x4e, 0xfd,
-  0xb2, 0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50, 0xdd, 0xfe, 0x1c, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x08,
-  0x00, 0x00, 0x13, 0x35, 0x09, 0x01, 0x11, 0x09, 0x01, 0x35, 0x01, 0xc3,
-  0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0xfd, 0x29, 0x02, 0x4b, 0x04, 0x62,
-  0xe0, 0xfd, 0xb2, 0x02, 0x4e, 0xfa, 0x80, 0x02, 0x50, 0xfd, 0xb0, 0xdd,
-  0x01, 0xe4, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05, 0xfe, 0x23, 0x03, 0x8a,
-  0x06, 0x75, 0x00, 0x03, 0x00, 0x00, 0x09, 0x03, 0x01, 0xc7, 0x01, 0xc2,
-  0xfe, 0x3e, 0xfe, 0x3e, 0x06, 0x75, 0xfb, 0xdb, 0xfb, 0xd3, 0x04, 0x2d,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x13,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15,
-  0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x01, 0xd8,
-  0x97, 0x01, 0x2b, 0x97, 0x01, 0x14, 0xfe, 0xec, 0x97, 0xfe, 0xd5, 0x97,
-  0xfe, 0xeb, 0x02, 0xd7, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3,
-  0xaa, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xaa, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11,
-  0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x01, 0x7e, 0x97, 0xa4, 0x97, 0xa4,
-  0x97, 0xba, 0xba, 0x97, 0xa4, 0x97, 0xa4, 0x97, 0xbb, 0x02, 0xd7, 0x02,
-  0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0xaa,
-  0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d,
-  0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x34, 0xfe, 0x6b, 0x06, 0xff,
-  0x05, 0xfb, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x37, 0x00, 0x00, 0x01, 0x21,
-  0x11, 0x21, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12,
-  0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34,
-  0x02, 0x27, 0x26, 0x27, 0x24, 0x20, 0x04, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x04, 0x20, 0x24, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x11, 0x01, 0x11, 0xfe, 0xef,
-  0x01, 0x19, 0xfe, 0xe0, 0x7e, 0x7c, 0x66, 0x69, 0x66, 0x66, 0x69, 0x66,
-  0x7c, 0x7e, 0x01, 0x20, 0x7e, 0x7b, 0x67, 0x68, 0x66, 0x66, 0x68, 0x67,
-  0x7b, 0xfe, 0x3e, 0x01, 0x67, 0x01, 0x33, 0x80, 0x80, 0x40, 0x3f, 0x3f,
-  0x40, 0x80, 0x80, 0xfe, 0xcd, 0xfe, 0x99, 0xfe, 0xcd, 0x80, 0x80, 0x40,
-  0x3f, 0x3f, 0x40, 0x80, 0x80, 0x02, 0xe8, 0xfe, 0x92, 0x03, 0xc8, 0x3b,
-  0x3a, 0x72, 0x73, 0xfe, 0xec, 0xa3, 0x9f, 0xfe, 0xec, 0x73, 0x72, 0x3a,
-  0x3b, 0x3b, 0x3a, 0x72, 0x73, 0x01, 0x14, 0x9f, 0xa3, 0x01, 0x14, 0x73,
-  0x72, 0x3a, 0xf4, 0x90, 0x8d, 0x8e, 0xac, 0xaa, 0xc9, 0xc5, 0xac, 0xaa,
-  0x8e, 0x8d, 0x90, 0x90, 0x8d, 0x8e, 0xaa, 0xac, 0xc5, 0xc9, 0xaa, 0xac,
-  0x8e, 0x8d, 0x00, 0x00, 0x00, 0x03, 0x00, 0x34, 0xfe, 0x6b, 0x06, 0xff,
-  0x05, 0xfb, 0x00, 0x19, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x20,
-  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
-  0x24, 0x20, 0x04, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x04, 0x20, 0x24, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x05, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x04, 0x2a, 0xfe, 0xe0, 0x7e, 0x7c, 0x66, 0x69, 0x66, 0x66,
-  0x69, 0x66, 0x7c, 0x7e, 0x01, 0x20, 0x7e, 0x7b, 0x67, 0x68, 0x66, 0x66,
-  0x68, 0x67, 0x7b, 0xfe, 0x3e, 0x01, 0x67, 0x01, 0x33, 0x80, 0x80, 0x40,
-  0x3f, 0x3f, 0x40, 0x80, 0x80, 0xfe, 0xcd, 0xfe, 0x99, 0xfe, 0xcd, 0x80,
-  0x80, 0x40, 0x3f, 0x3f, 0x40, 0x80, 0x73, 0x02, 0x3f, 0x02, 0x4c, 0xfd,
-  0xb4, 0x97, 0xfd, 0xb4, 0x02, 0x4c, 0x05, 0x42, 0x3b, 0x3a, 0x72, 0x73,
-  0xfe, 0xec, 0xa3, 0x9f, 0xfe, 0xec, 0x73, 0x72, 0x3a, 0x3b, 0x3b, 0x3a,
-  0x72, 0x73, 0x01, 0x14, 0x9f, 0xa3, 0x01, 0x14, 0x73, 0x72, 0x3a, 0xf4,
-  0x90, 0x8d, 0x8e, 0xac, 0xaa, 0xc9, 0xc5, 0xac, 0xaa, 0x8e, 0x8d, 0x90,
-  0x90, 0x8d, 0x8e, 0xaa, 0xac, 0xc5, 0xc9, 0xaa, 0xac, 0x8e, 0x80, 0x4b,
-  0xfd, 0x73, 0xaa, 0xfd, 0x73, 0x02, 0x8d, 0xaa, 0x02, 0x8d, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x34, 0xfe, 0x6b, 0x06, 0xff, 0x05, 0xfb, 0x00, 0x19,
-  0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06,
-  0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
-  0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x24, 0x20, 0x04, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x04, 0x20, 0x24,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x17, 0x09,
-  0x01, 0x17, 0x09, 0x01, 0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x04, 0x2a,
-  0xfe, 0xe0, 0x7e, 0x7c, 0x66, 0x69, 0x66, 0x66, 0x69, 0x66, 0x7c, 0x7e,
-  0x01, 0x20, 0x7e, 0x7b, 0x67, 0x68, 0x66, 0x66, 0x68, 0x67, 0x7b, 0xfe,
-  0x3e, 0x01, 0x67, 0x01, 0x33, 0x80, 0x80, 0x40, 0x3f, 0x3f, 0x40, 0x80,
-  0x80, 0xfe, 0xcd, 0xfe, 0x99, 0xfe, 0xcd, 0x80, 0x80, 0x40, 0x3f, 0x3f,
-  0x40, 0x80, 0x73, 0x53, 0x01, 0xa0, 0x01, 0xa0, 0x6c, 0xfe, 0x60, 0x01,
-  0xa0, 0x6b, 0xfe, 0x60, 0xfe, 0x61, 0x6d, 0x01, 0xa0, 0xfe, 0x60, 0x05,
-  0x42, 0x3b, 0x3a, 0x72, 0x73, 0xfe, 0xec, 0xa3, 0x9f, 0xfe, 0xec, 0x73,
-  0x72, 0x3a, 0x3b, 0x3b, 0x3a, 0x72, 0x73, 0x01, 0x14, 0x9f, 0xa3, 0x01,
-  0x14, 0x73, 0x72, 0x3a, 0xf4, 0x90, 0x8d, 0x8e, 0xac, 0xaa, 0xc9, 0xc5,
-  0xac, 0xaa, 0x8e, 0x8d, 0x90, 0x90, 0x8d, 0x8e, 0xaa, 0xac, 0xc5, 0xc9,
-  0xaa, 0xac, 0x8e, 0x80, 0xe8, 0xfe, 0x33, 0x01, 0xcd, 0x78, 0xfe, 0x32,
-  0xfe, 0x33, 0x77, 0x01, 0xcd, 0xfe, 0x33, 0x78, 0x01, 0xce, 0x01, 0xcd,
-  0xff, 0xff, 0x00, 0x69, 0xfe, 0x4d, 0x09, 0x22, 0x06, 0x0e, 0x10, 0x27,
-  0x09, 0x07, 0x05, 0xca, 0x00, 0x00, 0x10, 0x26, 0x09, 0x07, 0x00, 0x00,
-  0x10, 0x27, 0x09, 0x07, 0x01, 0xee, 0x00, 0x00, 0x10, 0x07, 0x09, 0x07,
-  0x03, 0xdc, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
-  0x06, 0x0e, 0x00, 0x1d, 0x00, 0x00, 0x17, 0x16, 0x33, 0x32, 0x37, 0x13,
-  0x23, 0x35, 0x33, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23,
-  0x22, 0x07, 0x03, 0x33, 0x15, 0x23, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27,
-  0xee, 0x10, 0x35, 0x3e, 0x07, 0x1d, 0xf7, 0xfe, 0x17, 0x07, 0x8f, 0x89,
-  0x73, 0x12, 0x85, 0x0f, 0x36, 0x3e, 0x07, 0x16, 0xf7, 0xfe, 0x1d, 0x08,
-  0x8f, 0x89, 0x73, 0x12, 0x9b, 0x82, 0xaf, 0x02, 0x9a, 0xaa, 0x02, 0x0c,
-  0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0xfe, 0x0d, 0xaa, 0xfd, 0x4d,
-  0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
-  0x06, 0x0e, 0x00, 0x25, 0x00, 0x00, 0x17, 0x16, 0x33, 0x32, 0x37, 0x13,
-  0x23, 0x35, 0x33, 0x37, 0x21, 0x35, 0x21, 0x13, 0x3e, 0x01, 0x32, 0x16,
-  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x33, 0x15, 0x23, 0x07, 0x21,
-  0x15, 0x21, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0xee, 0x10, 0x35, 0x3e,
-  0x07, 0x14, 0xee, 0xf5, 0x0b, 0xff, 0x00, 0x01, 0x07, 0x0e, 0x07, 0x8f,
-  0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0xed, 0xf5, 0x0a,
-  0x00, 0xff, 0xfe, 0xf9, 0x14, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x9b, 0x82,
-  0xaf, 0x01, 0xce, 0xaa, 0xf0, 0xa8, 0x01, 0x40, 0xa5, 0x87, 0x7a, 0x8f,
-  0x0f, 0x82, 0xaf, 0xfe, 0xd9, 0xa8, 0xf0, 0xaa, 0xfe, 0x19, 0xa5, 0x87,
-  0x7a, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
-  0x06, 0x0e, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03,
-  0x25, 0x15, 0x05, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33,
-  0x32, 0x37, 0x13, 0x05, 0x35, 0x25, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17,
-  0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x17, 0x01, 0x22, 0xfe, 0xd7, 0x1c,
-  0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x18, 0xfe,
-  0xde, 0x01, 0x29, 0x1c, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x04, 0xf6, 0x82,
-  0xaf, 0xfd, 0xe7, 0xb6, 0xa0, 0xba, 0xfd, 0x6d, 0xa5, 0x87, 0x7a, 0x8f,
-  0x0f, 0x82, 0xaf, 0x02, 0x19, 0xb6, 0xa0, 0xba, 0x02, 0x93, 0xa5, 0x87,
-  0x7a, 0x8f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
-  0x06, 0x0e, 0x00, 0x2a, 0x00, 0x33, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
-  0x07, 0x03, 0x16, 0x17, 0x07, 0x26, 0x27, 0x03, 0x36, 0x37, 0x17, 0x06,
-  0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37,
-  0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x13, 0x3e, 0x01,
-  0x32, 0x16, 0x17, 0x01, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x89, 0x42, 0x66, 0x24, 0x48,
-  0x14, 0x1d, 0x13, 0x38, 0x31, 0x3d, 0x0d, 0x08, 0x8f, 0x89, 0x73, 0x12,
-  0x85, 0x10, 0x35, 0x3e, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b, 0x69,
-  0x0e, 0x07, 0x8f, 0x89, 0x73, 0x12, 0xfe, 0x34, 0x14, 0x37, 0x28, 0x40,
-  0x43, 0x21, 0x04, 0xf6, 0x82, 0xaf, 0xfe, 0xd6, 0x29, 0x88, 0x41, 0x48,
-  0x21, 0xfe, 0x2b, 0x06, 0x11, 0x70, 0x24, 0x09, 0xfe, 0xbe, 0xa5, 0x87,
-  0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0x01, 0x31, 0x18, 0x49, 0x6f, 0x9b, 0x9c,
-  0x73, 0x56, 0x13, 0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f, 0xfc, 0x45, 0x01,
-  0xd6, 0x11, 0x2e, 0x4a, 0x67, 0x68, 0x48, 0x24, 0x00, 0x01, 0x00, 0x69,
-  0xfe, 0x4d, 0x03, 0xc3, 0x06, 0x0e, 0x00, 0x32, 0x00, 0x00, 0x01, 0x26,
-  0x23, 0x22, 0x07, 0x03, 0x36, 0x37, 0x36, 0x3d, 0x01, 0x07, 0x27, 0x37,
-  0x33, 0x17, 0x07, 0x27, 0x15, 0x14, 0x07, 0x06, 0x07, 0x03, 0x0e, 0x01,
-  0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26,
-  0x35, 0x33, 0x14, 0x17, 0x16, 0x17, 0x13, 0x3e, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x27, 0x3a, 0x2a, 0x4e, 0x54,
-  0x41, 0xaa, 0x31, 0xa9, 0x41, 0x53, 0x62, 0x4d, 0x62, 0x0f, 0x08, 0x90,
-  0x88, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3d, 0x08, 0x0f, 0x52, 0x38, 0x6b,
-  0x5c, 0x48, 0x2e, 0x27, 0x28, 0x07, 0x90, 0x88, 0x42, 0x30, 0x13, 0x04,
-  0xf6, 0x82, 0xaf, 0xfc, 0x78, 0x10, 0x2f, 0x55, 0x72, 0x1e, 0x5d, 0x48,
-  0xbd, 0xbd, 0x48, 0x5d, 0x1e, 0x9c, 0x6c, 0x56, 0x11, 0xfe, 0xa1, 0xa5,
-  0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0x01, 0x4d, 0x19, 0x3e, 0x77, 0x9a,
-  0x72, 0x4e, 0x33, 0x0b, 0x03, 0x99, 0xa5, 0x87, 0x46, 0x34, 0x8f, 0x00,
-  0x00, 0x02, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x03,
-  0x00, 0x21, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x03, 0x13, 0x21, 0x11,
-  0x21, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
-  0x03, 0x21, 0x11, 0x21, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16,
-  0x33, 0x32, 0x01, 0x87, 0xbd, 0xbd, 0x0f, 0x10, 0x01, 0x51, 0xfe, 0xc8,
-  0x12, 0x07, 0x92, 0x88, 0x71, 0x12, 0x85, 0x10, 0x33, 0x3f, 0x08, 0x0c,
-  0x01, 0x19, 0xfe, 0xc4, 0x0b, 0x08, 0x98, 0x82, 0x71, 0x12, 0x85, 0x10,
-  0x33, 0x40, 0x02, 0xa6, 0xfe, 0xfd, 0xea, 0x01, 0x72, 0x02, 0x30, 0x01,
-  0xae, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xf5, 0xfc, 0xbc,
-  0xfe, 0xff, 0xad, 0x7f, 0x7d, 0x8c, 0x0f, 0x82, 0x00, 0x02, 0x00, 0x69,
-  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x03, 0x00, 0x2b, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x23, 0x13, 0x06, 0x07, 0x13, 0x3e, 0x01, 0x32, 0x16,
-  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x10, 0x07,
-  0x06, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
-  0x37, 0x13, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26, 0x01, 0x87, 0xbd, 0xbd,
-  0x59, 0x25, 0x1c, 0x14, 0x07, 0x92, 0x88, 0x71, 0x12, 0x85, 0x10, 0x33,
-  0x40, 0x07, 0x0c, 0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68, 0x0d, 0x08, 0x91,
-  0x88, 0x72, 0x12, 0x85, 0x10, 0x33, 0x3f, 0x08, 0x14, 0x24, 0x31, 0x63,
-  0x7a, 0x85, 0x02, 0xa6, 0xfe, 0x01, 0x7e, 0x02, 0x05, 0x01, 0xc3, 0xa7,
-  0x85, 0x7c, 0x8d, 0x0f, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0xfe,
-  0xd2, 0x6f, 0x55, 0x13, 0xfe, 0xbe, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82,
-  0xaf, 0x01, 0xb6, 0x10, 0x93, 0xd8, 0x7f, 0x00, 0x00, 0x02, 0x00, 0x69,
-  0xfe, 0x4d, 0x03, 0xff, 0x06, 0x0e, 0x00, 0x03, 0x00, 0x2e, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x23, 0x01, 0x16, 0x33, 0x32, 0x37, 0x13, 0x16, 0x17,
-  0x16, 0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x07, 0x13, 0x3e, 0x01, 0x32,
-  0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x36, 0x33, 0x32, 0x16,
-  0x10, 0x06, 0x23, 0x22, 0x27, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x02,
-  0x4e, 0xbd, 0xbd, 0xfe, 0xa0, 0x10, 0x35, 0x3e, 0x07, 0x18, 0x29, 0x32,
-  0x65, 0xb2, 0x87, 0x7c, 0x65, 0xc0, 0x4b, 0x16, 0x05, 0x92, 0x88, 0x73,
-  0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0d, 0x35, 0x3d, 0x98, 0xb9, 0xc6,
-  0x8b, 0x4e, 0x42, 0x0f, 0x08, 0x90, 0x88, 0x73, 0x12, 0x02, 0xae, 0xfe,
-  0xfd, 0xb5, 0x82, 0xaf, 0x02, 0x33, 0x3e, 0x1c, 0x36, 0x91, 0xd1, 0x8f,
-  0xa1, 0x02, 0x5d, 0xa4, 0x88, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0xfe, 0xcb,
-  0x13, 0xe9, 0xfe, 0xd2, 0xdb, 0x21, 0xfe, 0xa3, 0xa5, 0x87, 0x7a, 0x8f,
-  0x00, 0x03, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x03,
-  0x00, 0x0b, 0x00, 0x31, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x16, 0x36,
-  0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0x03, 0x16, 0x33, 0x32, 0x37, 0x13,
-  0x26, 0x27, 0x26, 0x10, 0x37, 0x36, 0x37, 0x13, 0x3e, 0x01, 0x32, 0x16,
-  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x10, 0x07,
-  0x06, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x01, 0x82, 0xbe, 0xbe,
-  0xb7, 0x85, 0x7c, 0xc1, 0x81, 0x80, 0x92, 0x10, 0x35, 0x3e, 0x07, 0x0e,
-  0x54, 0x42, 0x63, 0x64, 0x4b, 0x69, 0x0e, 0x07, 0x8f, 0x89, 0x73, 0x12,
-  0x85, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68,
-  0x0d, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x02, 0xb0, 0xfe, 0x7a, 0x90, 0xd1,
-  0x8f, 0x91, 0xcf, 0x90, 0xfe, 0x2d, 0x82, 0xaf, 0x01, 0x31, 0x18, 0x49,
-  0x6f, 0x01, 0x37, 0x73, 0x56, 0x13, 0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f,
-  0x0f, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0xfe, 0xd2, 0x6f, 0x55,
-  0x13, 0xfe, 0xbe, 0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x00, 0x03, 0x00, 0x69,
-  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x25,
-  0x00, 0x00, 0x37, 0x11, 0x21, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x07,
-  0x26, 0x23, 0x22, 0x07, 0x03, 0x33, 0x11, 0x21, 0x03, 0x0e, 0x01, 0x22,
-  0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x1b, 0x01, 0x03, 0x33, 0x11,
-  0x21, 0x23, 0x11, 0x33, 0x89, 0x01, 0x1b, 0x0f, 0x07, 0x92, 0x88, 0x71,
-  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0d, 0xfc, 0xfe, 0xe3, 0x0c, 0x08,
-  0x98, 0x80, 0x73, 0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0c, 0xb1, 0x15,
-  0x9a, 0xfe, 0xe5, 0x9a, 0x84, 0x9b, 0x02, 0xfe, 0x01, 0x49, 0xa7, 0x85,
-  0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xd0, 0xfd, 0x02, 0xfe, 0xde, 0xad,
-  0x7f, 0x7b, 0x8e, 0x0f, 0x82, 0xaf, 0x01, 0x09, 0x02, 0x74, 0xfe, 0x16,
-  0x01, 0xea, 0xfe, 0x16, 0x00, 0x01, 0xff, 0xc4, 0xfe, 0x4d, 0x03, 0xfc,
-  0x06, 0x0e, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03,
-  0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x35, 0x36, 0x37, 0x26, 0x27, 0x23,
-  0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13,
-  0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x13, 0x3e, 0x01,
-  0x32, 0x17, 0x16, 0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x16, 0xf3,
-  0x5a, 0x7d, 0x82, 0x55, 0x56, 0x07, 0x07, 0x56, 0xfa, 0x1d, 0x08, 0x8f,
-  0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3d, 0x08, 0x1d, 0xfe, 0xf9, 0xa8,
-  0x56, 0xfe, 0xe5, 0x01, 0x1b, 0x56, 0xa8, 0x01, 0x0c, 0x19, 0x07, 0x8f,
-  0x89, 0x42, 0x30, 0x13, 0x04, 0xf6, 0x82, 0xaf, 0xfd, 0xef, 0x8f, 0xc6,
-  0x8c, 0x88, 0x04, 0x65, 0x62, 0x06, 0xfd, 0x49, 0xa5, 0x87, 0x7a, 0x8f,
-  0x0f, 0x82, 0xaf, 0x02, 0x9e, 0xba, 0x60, 0x01, 0x3a, 0x48, 0x01, 0x3a,
-  0x60, 0xba, 0x02, 0x2a, 0xa5, 0x87, 0x46, 0x34, 0x8f, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x23,
-  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03, 0x37, 0x17, 0x07, 0x17,
-  0x07, 0x27, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
-  0x37, 0x13, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x13, 0x3e, 0x01, 0x32,
-  0x16, 0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x12, 0x8d, 0x6c, 0xe2,
-  0xe2, 0x6c, 0x9f, 0x16, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35,
-  0x3e, 0x07, 0x15, 0x8f, 0x6e, 0xe5, 0xe3, 0x6c, 0xa0, 0x15, 0x07, 0x8f,
-  0x89, 0x73, 0x12, 0x04, 0xf6, 0x82, 0xaf, 0xfe, 0x58, 0x9d, 0x79, 0xfc,
-  0xfc, 0x78, 0xb0, 0xfd, 0xf4, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf,
-  0x01, 0xe2, 0xa0, 0x79, 0xfc, 0xfc, 0x78, 0xb3, 0x01, 0xd8, 0xa5, 0x87,
-  0x7a, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
-  0x06, 0x0e, 0x00, 0x2a, 0x00, 0x00, 0x17, 0x16, 0x33, 0x32, 0x37, 0x13,
-  0x06, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x36, 0x37, 0x13, 0x3e,
-  0x01, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17,
-  0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x27, 0x03, 0x0e, 0x01, 0x22, 0x26,
-  0x27, 0xee, 0x10, 0x35, 0x3e, 0x07, 0x29, 0x3b, 0x1d, 0x2e, 0x6d, 0x8b,
-  0x6d, 0x0d, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07,
-  0x0c, 0x51, 0x38, 0x4e, 0x6d, 0x70, 0x28, 0x08, 0x8f, 0x89, 0x73, 0x12,
-  0x9b, 0x82, 0xaf, 0x03, 0xa6, 0x10, 0x32, 0x50, 0x9c, 0xfe, 0xc8, 0x01,
-  0x49, 0xcf, 0xbc, 0x11, 0x01, 0x2b, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82,
-  0xaf, 0xfe, 0xe6, 0x18, 0x45, 0x61, 0xd6, 0xfe, 0xb7, 0x01, 0x38, 0xf3,
-  0x32, 0xfc, 0x4a, 0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x00, 0x01, 0x00, 0x69,
-  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x27, 0x00, 0x00, 0x01, 0x26,
-  0x23, 0x22, 0x07, 0x03, 0x36, 0x19, 0x01, 0x33, 0x11, 0x10, 0x07, 0x03,
-  0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x26,
-  0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x13, 0x3e, 0x01, 0x32,
-  0x16, 0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x26, 0x84, 0x6d, 0xf6,
-  0x0f, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0f,
-  0x53, 0x39, 0x4d, 0x6d, 0x71, 0x27, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x04,
-  0xf6, 0x82, 0xaf, 0xfc, 0x8d, 0x26, 0x01, 0x07, 0x01, 0x38, 0xfe, 0xb7,
-  0xfe, 0x8c, 0x27, 0xfe, 0xa2, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf,
-  0x01, 0x4c, 0x17, 0x46, 0x61, 0xd6, 0x01, 0x49, 0xfe, 0xc8, 0xf5, 0x31,
-  0x03, 0x85, 0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
-  0xfe, 0x4d, 0x03, 0x60, 0x06, 0xf9, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
-  0x03, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37,
-  0x01, 0x15, 0x21, 0x35, 0x01, 0xb3, 0x07, 0x92, 0x43, 0x45, 0x71, 0x12,
-  0x85, 0x10, 0x33, 0x40, 0x07, 0x3a, 0x08, 0x91, 0x45, 0x43, 0x72, 0x12,
-  0x85, 0x10, 0x33, 0x40, 0x07, 0x01, 0xe8, 0xfd, 0x3e, 0x04, 0xe2, 0xa7,
-  0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfa, 0xb0, 0xa7, 0x85, 0x7d, 0x8c,
-  0x0f, 0x82, 0xaf, 0x07, 0x67, 0xa0, 0xa0, 0x00, 0x00, 0x02, 0x00, 0x60,
-  0xfd, 0x62, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
-  0x03, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37,
-  0x01, 0x35, 0x21, 0x15, 0x01, 0xb3, 0x07, 0x92, 0x43, 0x45, 0x71, 0x12,
-  0x85, 0x10, 0x33, 0x40, 0x07, 0x3a, 0x08, 0x91, 0x45, 0x43, 0x72, 0x12,
-  0x85, 0x10, 0x33, 0x40, 0x07, 0xfe, 0xe8, 0x02, 0xc3, 0x04, 0xe2, 0xa7,
-  0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfa, 0xb0, 0xa7, 0x85, 0x7d, 0x8c,
-  0x0f, 0x82, 0xaf, 0xfd, 0xd0, 0xa0, 0xa0, 0x00, 0xff, 0xff, 0x00, 0xfc,
-  0x00, 0x3f, 0x05, 0x0d, 0x04, 0xc5, 0x10, 0x06, 0x00, 0x99, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xc3, 0x01, 0xd3, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
-  0x09, 0x18, 0x00, 0x00, 0x10, 0x07, 0x09, 0xa1, 0x01, 0xdf, 0x01, 0x24,
-  0xff, 0xff, 0x00, 0xc3, 0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
-  0x09, 0x18, 0x00, 0x00, 0x10, 0x27, 0x09, 0xa1, 0x00, 0xd0, 0xfe, 0x57,
-  0x10, 0x07, 0x09, 0xa1, 0x02, 0xed, 0x01, 0x24, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x04, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
-  0x05, 0x15, 0x01, 0x35, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45,
-  0xfb, 0x7e, 0x04, 0x82, 0xfc, 0x5f, 0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82,
-  0x46, 0xb6, 0x01, 0xd1, 0xb6, 0x02, 0x65, 0xfe, 0x91, 0xfe, 0x93, 0xb6,
-  0x01, 0xd1, 0xa6, 0x01, 0xd1, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x04, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
-  0x17, 0x01, 0x15, 0x01, 0x11, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0xc3,
-  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xa1, 0x46, 0x01,
-  0xd1, 0xb6, 0xfe, 0x2f, 0x04, 0xec, 0xb6, 0xfe, 0x2f, 0xa6, 0xfe, 0x2f,
-  0xb6, 0x01, 0x6d, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x47,
-  0x04, 0xa6, 0x10, 0x27, 0x09, 0xa1, 0x03, 0xc4, 0xff, 0xbb, 0x10, 0x06,
-  0x0d, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
-  0x04, 0xa6, 0x10, 0x26, 0x09, 0xa1, 0xfe, 0xbb, 0x10, 0x06, 0x0d, 0xd6,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
-  0x05, 0x27, 0x10, 0x27, 0x09, 0xa1, 0x00, 0xf4, 0x01, 0xe1, 0x10, 0x06,
-  0x0d, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
-  0x05, 0x27, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xcd, 0x01, 0xe1, 0x10, 0x06,
-  0x0d, 0xd6, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x47,
-  0x06, 0x12, 0x10, 0x27, 0x09, 0xa1, 0x03, 0xc4, 0x02, 0xcc, 0x10, 0x06,
-  0x0d, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
-  0x06, 0x0d, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe, 0x02, 0xc7, 0x10, 0x06,
-  0x0d, 0xd6, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0xf1, 0x05, 0x46,
-  0x05, 0x4e, 0x00, 0x1c, 0x00, 0x3a, 0x00, 0x41, 0x00, 0x00, 0x25, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x1e, 0x01, 0x17, 0x16,
-  0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x09, 0x01,
-  0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x63, 0x83, 0x09,
-  0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x63,
-  0x85, 0x09, 0x0b, 0x0d, 0x8c, 0x55, 0x4d, 0x97, 0x5e, 0x5f, 0xa1, 0x58,
-  0x63, 0x83, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e,
-  0xa2, 0x56, 0x63, 0x85, 0x09, 0x04, 0x07, 0x0d, 0x8c, 0x55, 0x4d, 0x97,
-  0x5d, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x50, 0xb3, 0x4e,
-  0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x45,
-  0x3b, 0x05, 0x04, 0x06, 0x3d, 0x4b, 0x01, 0x9b, 0xb2, 0x50, 0x44, 0x3a,
-  0x04, 0x04, 0x02, 0x06, 0x3c, 0x4c, 0x52, 0xb2, 0x4e, 0x44, 0x3a, 0x04,
-  0x02, 0x04, 0x06, 0x3c, 0x4a, 0x03, 0x5e, 0xfe, 0xeb, 0xfe, 0xee, 0xb2,
-  0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0xfe, 0xf1, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x1c, 0x00, 0x3a, 0x00, 0x41,
-  0x00, 0x00, 0x25, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
-  0x1e, 0x01, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
-  0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x36, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1,
-  0x58, 0x63, 0x83, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58,
-  0x5e, 0xa2, 0x56, 0x63, 0x85, 0x09, 0x0b, 0x0d, 0x8c, 0x55, 0x4d, 0x97,
-  0x5e, 0x5f, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55,
-  0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x63, 0x85, 0x09, 0x04, 0x07, 0x0d,
-  0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60,
-  0x50, 0xb3, 0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54,
-  0xb3, 0x4e, 0x45, 0x3b, 0x05, 0x04, 0x06, 0x3d, 0x4b, 0x01, 0x9b, 0xb2,
-  0x50, 0x44, 0x3a, 0x04, 0x04, 0x02, 0x06, 0x3c, 0x4c, 0x52, 0xb2, 0x4e,
-  0x44, 0x3a, 0x04, 0x02, 0x04, 0x06, 0x3c, 0x4a, 0x03, 0x5e, 0xb0, 0xfe,
-  0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x08, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00,
-  0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21,
-  0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x03, 0x4e, 0x87, 0x51, 0x01, 0xc1,
-  0xfd, 0xed, 0x78, 0x87, 0x51, 0xfe, 0x3f, 0x02, 0x13, 0x02, 0x6f, 0xfc,
-  0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x01, 0xa2, 0x50, 0xa8, 0xaa,
-  0xf8, 0x50, 0xa8, 0xaa, 0x03, 0x4e, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01,
-  0x70, 0xaa, 0x01, 0x6f, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x08, 0x05, 0x46,
-  0x04, 0xa8, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21,
-  0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21, 0x01, 0x35, 0x01, 0x15,
-  0x01, 0x35, 0x01, 0x03, 0x4e, 0x87, 0x51, 0x01, 0xc1, 0xfd, 0xed, 0x78,
-  0x87, 0x51, 0xfe, 0x3f, 0x02, 0x13, 0xfd, 0xed, 0x04, 0x82, 0xfb, 0x7e,
-  0x03, 0x60, 0x01, 0xa2, 0x50, 0xa8, 0xaa, 0xf8, 0x50, 0xa8, 0xaa, 0x03,
-  0x4e, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x5f, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x36,
-  0x00, 0x3d, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
-  0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36,
-  0x17, 0x16, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x13,
-  0x09, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x3d,
-  0x4b, 0x2e, 0x7e, 0x4e, 0x4d, 0x97, 0x5e, 0x5f, 0xa1, 0x58, 0x62, 0x84,
-  0x07, 0x53, 0x94, 0x50, 0x39, 0x2b, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56,
-  0x3e, 0x4b, 0x2e, 0x7d, 0x4e, 0x4f, 0x9b, 0x58, 0x5e, 0x51, 0x62, 0x45,
-  0x84, 0x64, 0x07, 0x52, 0x93, 0x50, 0x3a, 0x2c, 0x4d, 0x97, 0x5d, 0xfc,
-  0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x01, 0x96, 0xb2, 0x50, 0x44,
-  0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b, 0x03, 0xe9, 0x40,
-  0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82, 0x34, 0x4c, 0x52,
-  0xb2, 0x4e, 0x22, 0x2a, 0x08, 0x0e, 0x2c, 0x03, 0xe9, 0x40, 0xe3, 0x0f,
-  0x4a, 0x03, 0x5e, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01,
-  0x6f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xfe, 0x5f, 0x05, 0x46,
-  0x05, 0x4e, 0x00, 0x35, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x27, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x2f, 0x01, 0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16, 0x33,
-  0x32, 0x36, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f,
-  0xa1, 0x58, 0x3d, 0x4b, 0x2e, 0x7e, 0x4e, 0x4d, 0x97, 0x5e, 0x5f, 0xa1,
-  0x58, 0x62, 0x84, 0x07, 0x53, 0x94, 0x50, 0x39, 0x2b, 0x4f, 0x9b, 0x58,
-  0x5e, 0xa2, 0x56, 0x3e, 0x4b, 0x2e, 0x7d, 0x4e, 0x4f, 0x9b, 0x58, 0x5e,
-  0xa2, 0x56, 0x63, 0x85, 0x07, 0x52, 0x93, 0x50, 0x3a, 0x2c, 0x4d, 0x97,
-  0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x01, 0x96, 0xb2, 0x50,
-  0x44, 0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b, 0x03, 0xe9,
-  0x40, 0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82, 0x34, 0x4c,
-  0x52, 0xb2, 0x4e, 0x44, 0x3a, 0x03, 0xe9, 0x40, 0xe3, 0x0f, 0x4a, 0x03,
-  0x5e, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xc3, 0xfd, 0x84, 0x05, 0x46, 0x06, 0x54, 0x00, 0x06,
-  0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x01, 0x15, 0x01, 0x35,
-  0x01, 0x15, 0x05, 0x01, 0x21, 0x35, 0x21, 0x01, 0x2d, 0x01, 0x35, 0x01,
-  0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0x05, 0x45, 0xfb, 0x7e, 0x04, 0x82,
-  0xfc, 0xe4, 0x03, 0x1c, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x1d,
-  0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
-  0x03, 0xfb, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xfd, 0x5c,
-  0xaa, 0xfb, 0x5e, 0xd5, 0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0x03,
-  0x7e, 0xaa, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfd, 0x84, 0x05, 0x46,
-  0x06, 0x54, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00,
-  0x13, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11, 0x35, 0x21, 0x15, 0x11,
-  0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01, 0x35, 0x21, 0x15, 0xc3, 0x03,
-  0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04,
-  0x82, 0xfc, 0xe4, 0xfe, 0x9a, 0x04, 0x82, 0x03, 0xfb, 0xd5, 0xd2, 0xb2,
-  0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xe1, 0xaa, 0xaa, 0xfc, 0x08, 0xb0,
-  0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0x01, 0xf9, 0xaa, 0xaa, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0xff, 0x02, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x1a,
-  0x00, 0x1e, 0x00, 0x25, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
-  0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15, 0x21,
-  0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x63,
-  0x83, 0x0f, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56,
-  0x63, 0x85, 0x0d, 0x14, 0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdc, 0x04, 0x82,
-  0xfb, 0x7e, 0x04, 0x81, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82,
-  0x01, 0x96, 0xb2, 0x50, 0x44, 0x3a, 0x08, 0x02, 0x06, 0x3c, 0x4b, 0x53,
-  0xb2, 0x4e, 0x44, 0x3a, 0x06, 0x0a, 0x3c, 0x4a, 0xfe, 0x6c, 0xaa, 0x05,
-  0x9c, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0xff, 0x02, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x1a,
-  0x00, 0x1e, 0x00, 0x25, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
-  0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
-  0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15, 0x21,
-  0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58,
-  0x63, 0x83, 0x0f, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2,
-  0x56, 0x63, 0x85, 0x0d, 0x14, 0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdc, 0x04,
-  0x82, 0xfb, 0x7e, 0x01, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x01, 0x96,
-  0xb2, 0x50, 0x44, 0x3a, 0x08, 0x02, 0x06, 0x3c, 0x4b, 0x53, 0xb2, 0x4e,
-  0x44, 0x3a, 0x06, 0x0a, 0x3c, 0x4a, 0xfe, 0x6c, 0xaa, 0x05, 0x9c, 0xb0,
-  0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x03, 0x00, 0xc3,
-  0xfe, 0x12, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x1a, 0x00, 0x21, 0x00, 0x28,
-  0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27,
-  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02,
-  0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01,
-  0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63,
-  0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57,
-  0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0xfb, 0x7e, 0x04,
-  0x82, 0xfc, 0xe4, 0xfe, 0x9a, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb,
-  0x7e, 0x02, 0xbe, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c,
-  0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x09, 0x3d, 0x4b, 0x01, 0x4a, 0xb0,
-  0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xfa, 0x3a, 0xd5, 0xd2, 0xb2,
-  0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0xfe, 0x12, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x1a, 0x00, 0x21, 0x00, 0x28,
-  0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27,
-  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02,
-  0x16, 0x33, 0x32, 0x36, 0x01, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01,
-  0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63,
-  0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57,
-  0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0xfb, 0xdb, 0x03, 0x1d,
-  0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
-  0xfc, 0xe4, 0x02, 0xbe, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d,
-  0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x09, 0x3d, 0x4b, 0x01, 0x4a,
-  0xd5, 0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfb, 0xbf, 0xb0, 0x01,
-  0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3,
-  0xfe, 0x2c, 0x05, 0x46, 0x05, 0xd7, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11,
-  0x00, 0x15, 0x00, 0x00, 0x13, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11,
-  0x35, 0x21, 0x15, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01, 0x35,
-  0x21, 0x15, 0xc3, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04,
-  0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xe4, 0xfe, 0x9a, 0x04, 0x82, 0x01,
-  0x25, 0xd5, 0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xe1, 0xaa,
-  0xaa, 0x04, 0x28, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xf9,
-  0xd9, 0xaa, 0xaa, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x2c, 0x05, 0x46,
-  0x05, 0xd7, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00,
-  0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01, 0x21, 0x35, 0x21, 0x01,
-  0x2d, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0x05, 0x45,
-  0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xe4, 0x03, 0x1c, 0xfb, 0x7e, 0x04, 0x82,
-  0xfb, 0x7e, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
-  0xfb, 0x7e, 0x04, 0x82, 0x01, 0x25, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30,
-  0xb2, 0xd2, 0xfd, 0x5c, 0xaa, 0x03, 0x7e, 0xd5, 0xd2, 0xb2, 0xfe, 0xd0,
-  0xaa, 0xfe, 0xd1, 0xfb, 0x5e, 0xaa, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3,
-  0xfe, 0x36, 0x05, 0x46, 0x05, 0xee, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x09,
-  0x01, 0x35, 0x09, 0x01, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11, 0x35,
-  0x01, 0x15, 0x05, 0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xe4, 0x03, 0x1c,
-  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82,
-  0xfb, 0x7e, 0x04, 0x82, 0x03, 0x95, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30,
-  0xb2, 0xd2, 0xfd, 0x56, 0x01, 0x2f, 0xb0, 0xfe, 0xd1, 0xfd, 0xa6, 0xd5,
-  0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xd0, 0xb0, 0x01, 0x2f,
-  0xb0, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x36, 0x05, 0x46,
-  0x05, 0xee, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00,
-  0x13, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11, 0x35, 0x01, 0x15, 0x11,
-  0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x09, 0x01, 0x35, 0x01, 0xc3, 0x03,
-  0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04,
-  0x82, 0xfc, 0xe4, 0x03, 0x1c, 0xfb, 0x7e, 0x04, 0x82, 0x03, 0x95, 0xd5,
-  0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xdb, 0xb0, 0x01, 0x2f,
-  0xb0, 0xfd, 0x27, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xfd,
-  0x4b, 0x01, 0x2f, 0xb0, 0xfe, 0xd1, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x84, 0x05, 0x46, 0x05, 0x26, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
-  0x09, 0x01, 0x35, 0x01, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15, 0x01, 0x05,
-  0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0x5f, 0x04,
-  0x70, 0xfe, 0x2f, 0xb6, 0x01, 0xd1, 0xfb, 0x14, 0xb6, 0x01, 0xd1, 0xa6,
-  0x01, 0xd1, 0xb6, 0xfe, 0x93, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
-  0xff, 0x84, 0x05, 0x46, 0x05, 0x26, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
-  0x13, 0x35, 0x01, 0x15, 0x09, 0x02, 0x35, 0x01, 0x15, 0x01, 0xc3, 0x04,
-  0x82, 0xfb, 0x7e, 0x03, 0xa1, 0xfc, 0x5f, 0x04, 0x82, 0xfb, 0x7e, 0x04,
-  0x70, 0xb6, 0xfe, 0x2f, 0xb6, 0xfd, 0x9b, 0x01, 0x6f, 0x01, 0x6d, 0xb6,
-  0xfe, 0x2f, 0xa6, 0xfe, 0x2f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3,
-  0xff, 0x84, 0x05, 0x47, 0x05, 0x26, 0x10, 0x27, 0x09, 0xa1, 0x03, 0xc4,
-  0xfe, 0xee, 0x10, 0x06, 0x0d, 0xed, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3,
-  0xff, 0x84, 0x05, 0x46, 0x05, 0x26, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe,
-  0xfe, 0xe4, 0x10, 0x06, 0x0d, 0xee, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4,
-  0xff, 0xb6, 0x05, 0x46, 0x05, 0x7b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e,
-  0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15,
-  0x09, 0x01, 0x35, 0x21, 0x15, 0xc4, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
-  0xfc, 0xa0, 0xfe, 0xde, 0x04, 0x82, 0x04, 0xd1, 0xaa, 0xaa, 0xfb, 0x95,
-  0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x02, 0x39, 0xaa,
-  0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4, 0xff, 0xb6, 0x05, 0x46,
-  0x05, 0x7b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x21,
-  0x35, 0x21, 0x09, 0x02, 0x35, 0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21,
-  0x05, 0x46, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0xfc, 0xa0,
-  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0x04, 0xd1,
-  0xaa, 0xfa, 0xeb, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe,
-  0x91, 0x03, 0xfe, 0xaa, 0x00, 0x03, 0x00, 0xc3, 0xff, 0xc0, 0x05, 0x46,
-  0x05, 0xcd, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x35,
-  0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15,
-  0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
-  0xfc, 0xa0, 0x03, 0xab, 0xb2, 0x01, 0x70, 0xb2, 0xfd, 0x4e, 0xb2, 0x01,
-  0x70, 0xb2, 0xfc, 0x97, 0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe,
-  0xee, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xff, 0xc0, 0x05, 0x46,
-  0x05, 0xcd, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01,
-  0x35, 0x01, 0x11, 0x01, 0x35, 0x09, 0x03, 0x35, 0x01, 0x15, 0x01, 0x05,
-  0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03,
-  0x60, 0xfc, 0xa0, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xab, 0x01, 0x70, 0xb2,
-  0xfe, 0x90, 0xfe, 0x0c, 0x01, 0x70, 0xb2, 0xfe, 0x90, 0xfd, 0x55, 0x01,
-  0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe, 0x91, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x11, 0x05, 0x46, 0x05, 0x28, 0x00, 0x1b,
-  0x00, 0x22, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37,
-  0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x03, 0x15, 0x01, 0x35,
-  0x01, 0x15, 0x01, 0x05, 0x46, 0x5e, 0x97, 0x4d, 0x55, 0x8c, 0x0d, 0x0b,
-  0x09, 0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b, 0x0e,
-  0x0b, 0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0x01, 0xfb, 0x7e, 0x04, 0x82,
-  0xfc, 0xa0, 0x03, 0xca, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04, 0x3c, 0x46,
-  0x4e, 0xb2, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04, 0x3c, 0x46, 0x4e, 0xfc,
-  0x45, 0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0x00, 0x30, 0x05, 0x46, 0x05, 0x28, 0x00, 0x1b,
-  0x00, 0x22, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37,
-  0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x09, 0x02, 0x35, 0x01,
-  0x15, 0x01, 0x05, 0x46, 0x5e, 0x97, 0x4d, 0x55, 0x8c, 0x0d, 0x0b, 0x09,
-  0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b, 0x0e, 0x0b,
-  0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0xfb, 0x7d, 0x03, 0x61, 0xfc, 0x9f,
-  0x04, 0x82, 0xfb, 0x7e, 0x03, 0xca, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04,
-  0x3c, 0x46, 0x4e, 0xb2, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04, 0x3c, 0x46,
-  0x4e, 0xfc, 0x64, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe,
-  0x91, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x98, 0x05, 0x46,
-  0x05, 0xd4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x24, 0x00, 0x2b, 0x00, 0x00,
-  0x17, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x13, 0x2e, 0x01, 0x23,
-  0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e,
-  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16,
-  0x17, 0x03, 0x15, 0x01, 0x35, 0x01, 0x15, 0x01, 0xc3, 0x04, 0x82, 0xfb,
-  0x7e, 0x04, 0x82, 0x01, 0x5e, 0x97, 0x4d, 0x55, 0x8c, 0x0d, 0x0b, 0x09,
-  0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b, 0x0e, 0x05,
-  0x06, 0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0x01, 0xfb, 0x7e, 0x04, 0x82,
-  0xfc, 0xa0, 0x3e, 0xaa, 0xaa, 0xfe, 0xd6, 0xaa, 0xaa, 0x05, 0xdc, 0x56,
-  0x4a, 0x3c, 0x06, 0x04, 0x06, 0x3a, 0x44, 0x4e, 0xb4, 0x54, 0x4c, 0x3c,
-  0x06, 0x02, 0x04, 0x04, 0x3a, 0x44, 0x4e, 0xfc, 0x44, 0xb0, 0x01, 0x6f,
-  0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3,
-  0xfe, 0x98, 0x05, 0x46, 0x05, 0xd4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x24,
-  0x00, 0x2b, 0x00, 0x00, 0x17, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
-  0x13, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x16, 0x17, 0x09, 0x02, 0x35, 0x01, 0x15, 0x01, 0xc3,
-  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0x01, 0x5e, 0x97, 0x4d, 0x55, 0x8c,
-  0x0d, 0x0b, 0x09, 0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55,
-  0x8b, 0x0e, 0x05, 0x06, 0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0xfb, 0x7d,
-  0x03, 0x60, 0xfc, 0xa0, 0x04, 0x82, 0xfb, 0x7e, 0x3e, 0xaa, 0xaa, 0xfe,
-  0xd6, 0xaa, 0xaa, 0x05, 0xdc, 0x56, 0x4a, 0x3c, 0x06, 0x04, 0x06, 0x3a,
-  0x44, 0x4e, 0xb4, 0x54, 0x4c, 0x3c, 0x06, 0x02, 0x04, 0x04, 0x3a, 0x44,
-  0x4e, 0xfc, 0x44, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe,
-  0x91, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x00, 0x66, 0x05, 0x46,
-  0x04, 0xce, 0x00, 0x03, 0x00, 0x20, 0x00, 0x24, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x21, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x35, 0x33,
-  0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33,
-  0x15, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x15, 0x21, 0xc3,
-  0x04, 0x82, 0xfb, 0x7e, 0x02, 0x42, 0x3c, 0x2a, 0x32, 0x1b, 0x18, 0x04,
-  0xfe, 0x8d, 0xf0, 0x0b, 0x1a, 0x31, 0x4e, 0x51, 0xb9, 0x50, 0x4d, 0x32,
-  0x19, 0x0d, 0xef, 0xfe, 0x8e, 0x03, 0x19, 0x1b, 0x32, 0x29, 0xfd, 0x82,
-  0x04, 0x82, 0xfb, 0x7e, 0x02, 0x5a, 0xaa, 0x02, 0x7b, 0x04, 0x1e, 0x2b,
-  0x44, 0x44, 0x5c, 0xa8, 0x39, 0x33, 0x5b, 0x32, 0x33, 0x33, 0x32, 0x5b,
-  0x30, 0x3c, 0xa8, 0x5b, 0x45, 0x43, 0x2c, 0x1e, 0xfc, 0xe9, 0xaa, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0xcf, 0x05, 0x46, 0x05, 0x57, 0x00, 0x03,
-  0x00, 0x0e, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x01, 0x00, 0x05, 0x04,
-  0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e,
-  0x04, 0x82, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe, 0xa7,
-  0xfc, 0xd7, 0x03, 0x29, 0x01, 0x59, 0x79, 0xaa, 0x04, 0xb1, 0xfe, 0xe5,
-  0x5d, 0x5d, 0xfe, 0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01, 0x80,
-  0x00, 0x02, 0x00, 0xc3, 0xff, 0xcf, 0x05, 0x46, 0x05, 0x57, 0x00, 0x03,
-  0x00, 0x0f, 0x00, 0x00, 0x25, 0x15, 0x21, 0x35, 0x11, 0x35, 0x00, 0x05,
-  0x30, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0x05, 0x45, 0xfb, 0x7e,
-  0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7, 0x01, 0x59, 0x01, 0xac,
-  0xfe, 0x54, 0x79, 0xaa, 0xaa, 0x04, 0x07, 0xd7, 0xfe, 0x80, 0x7c, 0xa6,
-  0x84, 0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x02, 0x00, 0xc3,
-  0xfe, 0xd7, 0x05, 0x46, 0x05, 0x57, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x00,
-  0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21,
-  0x01, 0x00, 0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x03,
-  0x4e, 0x87, 0x51, 0x01, 0xc1, 0xfd, 0xed, 0x78, 0x87, 0x51, 0xfe, 0x3f,
-  0x02, 0x13, 0x02, 0x6f, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59,
-  0xfe, 0xa7, 0xfc, 0xd7, 0x03, 0x29, 0x01, 0x59, 0x01, 0x71, 0x50, 0xa8,
-  0xaa, 0xf8, 0x50, 0xa8, 0xaa, 0x04, 0x07, 0xfe, 0xe5, 0x5d, 0x5d, 0xfe,
-  0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01, 0x80, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xd7, 0x05, 0x46, 0x05, 0x57, 0x00, 0x0b,
-  0x00, 0x16, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
-  0x37, 0x21, 0x35, 0x21, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35,
-  0x00, 0x25, 0x24, 0x03, 0x4e, 0x87, 0x51, 0x01, 0xc1, 0xfd, 0xed, 0x78,
-  0x87, 0x51, 0xfe, 0x3f, 0x02, 0x13, 0xfd, 0xed, 0x01, 0x59, 0x03, 0x29,
-  0xfc, 0xd7, 0xfe, 0xa7, 0x01, 0x59, 0x01, 0xac, 0xfe, 0x54, 0x01, 0x71,
-  0x50, 0xa8, 0xaa, 0xf8, 0x50, 0xa8, 0xaa, 0x04, 0x07, 0xd7, 0xfe, 0x80,
-  0x7c, 0xa6, 0x84, 0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0xff, 0x09, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x12, 0x00, 0x00, 0x37, 0x35, 0x21, 0x15, 0x01, 0x35,
-  0x21, 0x15, 0x11, 0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24,
-  0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfe, 0xec, 0xfe, 0x0f,
-  0x01, 0xea, 0x01, 0x1b, 0xfe, 0xc6, 0xfc, 0xb8, 0x03, 0x48, 0x01, 0x3a,
-  0x33, 0xaa, 0xaa, 0xfe, 0xd6, 0xaa, 0xaa, 0x05, 0x6b, 0xfe, 0xe5, 0x2d,
-  0x51, 0xf7, 0xd7, 0x01, 0x74, 0x58, 0xa6, 0x56, 0x01, 0x76, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0xff, 0x09, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x12, 0x00, 0x00, 0x37, 0x35, 0x21, 0x15, 0x01, 0x35,
-  0x21, 0x15, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x24, 0x25,
-  0x24, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x01, 0x3a,
-  0x03, 0x48, 0xfc, 0xb8, 0xfe, 0xc6, 0x01, 0x1b, 0x01, 0xea, 0xfe, 0x10,
-  0x33, 0xaa, 0xaa, 0xfe, 0xd6, 0xaa, 0xaa, 0x05, 0x6b, 0xd7, 0xfe, 0x8a,
-  0x56, 0xa6, 0x58, 0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x71, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x13,
-  0x00, 0x1e, 0x00, 0x00, 0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21,
-  0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
-  0x01, 0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x01,
-  0xef, 0xfe, 0xd4, 0x01, 0xab, 0x56, 0xfd, 0xff, 0x02, 0x81, 0x7b, 0x7d,
-  0x25, 0x01, 0x2e, 0xfe, 0x52, 0x56, 0x02, 0x04, 0xfd, 0x7d, 0x7c, 0x7c,
-  0x03, 0x7b, 0xfe, 0xec, 0xfe, 0x0f, 0x01, 0xea, 0x01, 0x1b, 0xfe, 0xc6,
-  0xfc, 0xb8, 0x03, 0x48, 0x01, 0x3a, 0xea, 0xaa, 0x73, 0xaa, 0xa4, 0x73,
-  0x31, 0xaa, 0x73, 0xaa, 0xa5, 0x74, 0x05, 0x8f, 0xfe, 0xe5, 0x2d, 0x51,
-  0xf7, 0xd7, 0x01, 0x74, 0x58, 0xa6, 0x56, 0x01, 0x76, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x71, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x13,
-  0x00, 0x1e, 0x00, 0x00, 0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21,
-  0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
-  0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x24, 0x25, 0x24, 0x01,
-  0xef, 0xfe, 0xd4, 0x01, 0xab, 0x56, 0xfd, 0xff, 0x02, 0x81, 0x7b, 0x7d,
-  0x25, 0x01, 0x2e, 0xfe, 0x52, 0x56, 0x02, 0x04, 0xfd, 0x7d, 0x7c, 0x7c,
-  0xfe, 0xf9, 0x01, 0x3a, 0x03, 0x48, 0xfc, 0xb8, 0xfe, 0xc6, 0x01, 0x1b,
-  0x01, 0xea, 0xfe, 0x10, 0xea, 0xaa, 0x73, 0xaa, 0xa4, 0x73, 0x31, 0xaa,
-  0x73, 0xaa, 0xa5, 0x74, 0x05, 0x8f, 0xd7, 0xfe, 0x8a, 0x56, 0xa6, 0x58,
-  0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0xfe, 0x79, 0x05, 0x46, 0x05, 0x8b, 0x00, 0x1d, 0x00, 0x3a, 0x00, 0x45,
-  0x00, 0x00, 0x05, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x37, 0x36, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3e,
-  0x01, 0x13, 0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01,
-  0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c,
-  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa0, 0x58, 0x57, 0x91, 0x09, 0x05, 0x05,
-  0x0e, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09,
-  0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63,
-  0x85, 0x08, 0x05, 0x06, 0x0e, 0x99, 0x8e, 0x9e, 0x5d, 0xfe, 0xec, 0xfe,
-  0x0f, 0x01, 0xea, 0x01, 0x1b, 0xfe, 0xc6, 0xfc, 0xb8, 0x03, 0x48, 0x01,
-  0x3a, 0x28, 0xb3, 0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c,
-  0x54, 0xb3, 0x4e, 0x39, 0x0c, 0x06, 0x41, 0x05, 0x02, 0x02, 0x06, 0x3d,
-  0x4b, 0x01, 0x9a, 0xb2, 0x4f, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d,
-  0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x04, 0x02, 0x03, 0x06, 0x43, 0x0c,
-  0x45, 0x03, 0xec, 0xfe, 0xe5, 0x2d, 0x51, 0xf7, 0xd7, 0x01, 0x74, 0x58,
-  0xa6, 0x56, 0x01, 0x76, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0x79, 0x05, 0x46,
-  0x05, 0x8b, 0x00, 0x1d, 0x00, 0x3a, 0x00, 0x45, 0x00, 0x00, 0x05, 0x15,
-  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x37, 0x36, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3e, 0x01, 0x01, 0x35, 0x00,
-  0x05, 0x15, 0x04, 0x01, 0x35, 0x24, 0x25, 0x24, 0x05, 0x45, 0x5e, 0xa1,
-  0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59,
-  0x5f, 0xa0, 0x58, 0x57, 0x91, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55, 0x4d,
-  0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c,
-  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x08, 0x05, 0x06,
-  0x0e, 0x99, 0x8e, 0x9e, 0xfb, 0xdb, 0x01, 0x3a, 0x03, 0x48, 0xfc, 0xb8,
-  0xfe, 0xc6, 0x01, 0x1b, 0x01, 0xea, 0xfe, 0x10, 0x28, 0xb3, 0x4e, 0x45,
-  0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x39, 0x0c,
-  0x06, 0x41, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b, 0x01, 0x9a, 0xb2, 0x4f,
-  0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45,
-  0x3b, 0x04, 0x02, 0x03, 0x06, 0x43, 0x0c, 0x45, 0x03, 0xec, 0xd7, 0xfe,
-  0x8a, 0x56, 0xa6, 0x58, 0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc3, 0xfd, 0xed, 0x05, 0x46, 0x05, 0x8b, 0x00, 0x36,
-  0x00, 0x41, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07,
-  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
-  0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36,
-  0x17, 0x16, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x13,
-  0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x05, 0x46,
-  0x5f, 0xa1, 0x58, 0x3d, 0x4b, 0x2e, 0x7e, 0x4e, 0x4d, 0x97, 0x5e, 0x5f,
-  0xa1, 0x58, 0x62, 0x84, 0x07, 0x53, 0x94, 0x50, 0x39, 0x2b, 0x4f, 0x9b,
-  0x58, 0x5e, 0xa2, 0x56, 0x3e, 0x4b, 0x2e, 0x7d, 0x4e, 0x4f, 0x9b, 0x58,
-  0x5e, 0x51, 0x62, 0x45, 0x84, 0x64, 0x07, 0x52, 0x93, 0x50, 0x3a, 0x2c,
-  0x4d, 0x97, 0x5d, 0xfe, 0xec, 0xfe, 0x0f, 0x01, 0xea, 0x01, 0x1b, 0xfe,
-  0xc6, 0xfc, 0xb8, 0x03, 0x48, 0x01, 0x3a, 0x01, 0x24, 0xb2, 0x50, 0x44,
-  0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b, 0x03, 0xe9, 0x40,
-  0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82, 0x34, 0x4c, 0x52,
-  0xb2, 0x4e, 0x22, 0x2a, 0x08, 0x0e, 0x2c, 0x03, 0xe9, 0x40, 0xe3, 0x0f,
-  0x4a, 0x03, 0xe6, 0xfe, 0xe5, 0x2d, 0x51, 0xf7, 0xd7, 0x01, 0x74, 0x58,
-  0xa6, 0x56, 0x01, 0x76, 0x00, 0x02, 0x00, 0xc3, 0xfd, 0xed, 0x05, 0x46,
-  0x05, 0x8b, 0x00, 0x36, 0x00, 0x41, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x27, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x2f, 0x01, 0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
-  0x35, 0x36, 0x37, 0x36, 0x17, 0x16, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16,
-  0x33, 0x32, 0x36, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x24,
-  0x25, 0x24, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x3d, 0x4b, 0x2e, 0x7e, 0x4e,
-  0x4d, 0x97, 0x5e, 0x5f, 0xa1, 0x58, 0x62, 0x84, 0x07, 0x53, 0x94, 0x50,
-  0x39, 0x2b, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x3e, 0x4b, 0x2e, 0x7d,
-  0x4e, 0x4f, 0x9b, 0x58, 0x5e, 0x51, 0x62, 0x45, 0x84, 0x64, 0x07, 0x52,
-  0x93, 0x50, 0x3a, 0x2c, 0x4d, 0x97, 0xfb, 0xdb, 0x01, 0x3a, 0x03, 0x48,
-  0xfc, 0xb8, 0xfe, 0xc6, 0x01, 0x1b, 0x01, 0xea, 0xfe, 0x10, 0x01, 0x24,
-  0xb2, 0x50, 0x44, 0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b,
-  0x03, 0xe9, 0x40, 0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82,
-  0x34, 0x4c, 0x52, 0xb2, 0x4e, 0x22, 0x2a, 0x08, 0x0e, 0x2c, 0x03, 0xe9,
-  0x40, 0xe3, 0x0f, 0x4a, 0x03, 0xe6, 0xd7, 0xfe, 0x8a, 0x56, 0xa6, 0x58,
-  0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
-  0xfe, 0xa1, 0x05, 0x46, 0x04, 0xae, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e,
-  0x00, 0x00, 0x37, 0x01, 0x15, 0x01, 0x11, 0x01, 0x15, 0x09, 0x03, 0x15,
-  0x01, 0x35, 0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e,
-  0x04, 0x82, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xc3, 0xfe,
-  0x90, 0xb2, 0x01, 0x70, 0x01, 0xf4, 0xfe, 0x90, 0xb2, 0x01, 0x70, 0x02,
-  0xab, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00,
-  0x00, 0x03, 0x00, 0xc3, 0xfe, 0xa1, 0x05, 0x46, 0x04, 0xae, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x25, 0x15, 0x01, 0x35, 0x01, 0x15,
-  0x01, 0x35, 0x11, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45, 0xfb,
-  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0xc3,
-  0xb2, 0xfe, 0x90, 0xb2, 0x02, 0xb2, 0xb2, 0xfe, 0x90, 0xb2, 0x03, 0x69,
-  0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa2, 0xff, 0xc9, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x01, 0x17, 0x01, 0x17, 0x01, 0x17, 0x11, 0x13,
-  0x27, 0x09, 0x02, 0x27, 0x21, 0x03, 0x62, 0x54, 0xfd, 0x6c, 0xac, 0x02,
-  0x93, 0x53, 0x5b, 0xae, 0xfd, 0x6d, 0xfe, 0xd5, 0x02, 0x94, 0xaf, 0x02,
-  0x87, 0x04, 0x4e, 0x5c, 0xfd, 0x23, 0xbf, 0x02, 0xdd, 0x5d, 0x01, 0x78,
-  0xfd, 0x96, 0xc2, 0xfd, 0x23, 0x01, 0x4c, 0x02, 0xdd, 0xc1, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x03, 0xff, 0xc9, 0x05, 0x70, 0x04, 0xb3, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x37, 0x01, 0x37, 0x09, 0x01,
-  0x11, 0x21, 0x07, 0x09, 0x02, 0x02, 0xb0, 0xfe, 0xae, 0x53, 0x02, 0x94,
-  0xab, 0xfd, 0x6d, 0xfe, 0xa6, 0x02, 0x87, 0xae, 0x02, 0x93, 0xfe, 0xd6,
-  0xfd, 0x6c, 0x04, 0x4e, 0xfe, 0x88, 0x5d, 0xfd, 0x23, 0xbf, 0x02, 0xdd,
-  0xfd, 0xf2, 0x02, 0xcf, 0xc1, 0xfd, 0x23, 0xfe, 0xb4, 0x02, 0xdd, 0x00,
-  0x00, 0x02, 0x00, 0xa2, 0x00, 0x34, 0x05, 0x10, 0x05, 0x1e, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x01, 0x07, 0x01, 0x07, 0x01, 0x07, 0x21, 0x05,
-  0x37, 0x09, 0x02, 0x37, 0x11, 0x04, 0xb4, 0x53, 0xfd, 0x6d, 0xac, 0x02,
-  0x94, 0x54, 0x01, 0x52, 0xfd, 0xd4, 0xaf, 0xfd, 0x6c, 0x01, 0x2b, 0x02,
-  0x93, 0xae, 0x02, 0x11, 0x5d, 0x02, 0xdd, 0xbf, 0xfd, 0x23, 0x5c, 0x65,
-  0xc1, 0x02, 0xdd, 0x01, 0x4c, 0xfd, 0x23, 0xc2, 0xfd, 0x31, 0x00, 0x00,
-  0x00, 0x02, 0x01, 0x03, 0x00, 0x34, 0x05, 0x70, 0x05, 0x1e, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x00, 0x25, 0x27, 0x01, 0x27, 0x01, 0x27, 0x11, 0x03,
-  0x17, 0x09, 0x02, 0x17, 0x21, 0x02, 0xb0, 0x53, 0x02, 0x93, 0xab, 0xfd,
-  0x6c, 0x53, 0x5b, 0xae, 0x02, 0x94, 0x01, 0x2a, 0xfd, 0x6d, 0xae, 0xfd,
-  0x79, 0x99, 0x5c, 0x02, 0xdd, 0xbf, 0xfd, 0x23, 0x5d, 0xfe, 0x88, 0x02,
-  0x6a, 0xc2, 0x02, 0xdd, 0xfe, 0xb4, 0xfd, 0x23, 0xc1, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x31, 0x00, 0x86, 0x05, 0xaf, 0x04, 0x7e, 0x00, 0x09,
-  0x00, 0x13, 0x00, 0x00, 0x25, 0x09, 0x01, 0x11, 0x21, 0x11, 0x09, 0x01,
-  0x11, 0x21, 0x01, 0x15, 0x21, 0x35, 0x03, 0x13, 0x35, 0x21, 0x15, 0x13,
-  0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9, 0x01, 0xea, 0x01, 0xc9, 0xfe, 0x37,
-  0xfe, 0x16, 0x02, 0x44, 0xfd, 0x62, 0xf0, 0xf0, 0x02, 0x9e, 0xf0, 0x86,
-  0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0x01, 0x11, 0xfe, 0x04, 0xfe, 0x04,
-  0x01, 0x11, 0x01, 0xf5, 0x83, 0x83, 0xfe, 0xf6, 0xfe, 0xf6, 0x83, 0x83,
-  0x01, 0x0a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31, 0x00, 0x86, 0x05, 0xa0,
-  0x04, 0x7e, 0x00, 0x06, 0x00, 0x00, 0x25, 0x09, 0x01, 0x11, 0x21, 0x11,
-  0x21, 0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9, 0x03, 0xa4, 0xfc, 0x5c, 0x86,
-  0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0xfe, 0x2a, 0x00, 0x01, 0x01, 0x3b,
-  0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x06, 0x00, 0x00, 0x09, 0x02,
-  0x23, 0x11, 0x21, 0x11, 0x01, 0x3b, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0xfe,
-  0x59, 0x04, 0x0c, 0x01, 0xfc, 0xfe, 0x04, 0xfb, 0xf4, 0x04, 0x0c, 0x00,
-  0x00, 0x01, 0x01, 0x3b, 0xff, 0xcd, 0x04, 0xce, 0x05, 0xd5, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x33, 0x11, 0x21, 0x11, 0x33, 0x01, 0x01, 0x3b, 0xf6,
-  0x01, 0xa7, 0xf5, 0xfe, 0x37, 0x01, 0xc9, 0x04, 0x0c, 0xfb, 0xf4, 0xfe,
-  0x04, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa2, 0xff, 0xc9, 0x05, 0x10,
-  0x04, 0xb3, 0x00, 0x06, 0x00, 0x00, 0x01, 0x27, 0x09, 0x02, 0x27, 0x21,
-  0x05, 0x0f, 0xae, 0xfd, 0x6d, 0xfe, 0xd5, 0x02, 0x94, 0xaf, 0x02, 0x87,
-  0x01, 0xe4, 0xc2, 0xfd, 0x23, 0x01, 0x4c, 0x02, 0xdd, 0xc1, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x03, 0xff, 0xc9, 0x05, 0x70, 0x04, 0xb3, 0x00, 0x06,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x07, 0x09, 0x02, 0x01, 0x03, 0x02, 0x87,
-  0xae, 0x02, 0x93, 0xfe, 0xd6, 0xfd, 0x6c, 0x01, 0xe4, 0x02, 0xcf, 0xc1,
-  0xfd, 0x23, 0xfe, 0xb4, 0x02, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa2,
-  0x00, 0x34, 0x05, 0x10, 0x05, 0x1e, 0x00, 0x06, 0x00, 0x00, 0x25, 0x37,
-  0x09, 0x02, 0x37, 0x11, 0x02, 0x88, 0xaf, 0xfd, 0x6c, 0x01, 0x2b, 0x02,
-  0x93, 0xae, 0x34, 0xc1, 0x02, 0xdd, 0x01, 0x4c, 0xfd, 0x23, 0xc2, 0xfd,
-  0x31, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x70,
-  0x05, 0x1e, 0x00, 0x06, 0x00, 0x00, 0x01, 0x17, 0x09, 0x02, 0x17, 0x21,
-  0x01, 0x03, 0xae, 0x02, 0x94, 0x01, 0x2a, 0xfd, 0x6d, 0xae, 0xfd, 0x79,
-  0x03, 0x03, 0xc2, 0x02, 0xdd, 0xfe, 0xb4, 0xfd, 0x23, 0xc1, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x31, 0x00, 0x86, 0x05, 0xaf, 0x04, 0x7e, 0x00, 0x09,
-  0x00, 0x00, 0x25, 0x09, 0x01, 0x11, 0x21, 0x11, 0x09, 0x01, 0x11, 0x21,
-  0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9, 0x01, 0xea, 0x01, 0xc9, 0xfe, 0x37,
-  0xfe, 0x16, 0x86, 0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0x01, 0x11, 0xfe,
-  0x04, 0xfe, 0x04, 0x01, 0x11, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x3b,
-  0xff, 0xcd, 0x04, 0xce, 0x06, 0x08, 0x00, 0x09, 0x00, 0x00, 0x01, 0x33,
-  0x09, 0x01, 0x33, 0x11, 0x23, 0x09, 0x01, 0x23, 0x03, 0xd8, 0xf5, 0xfe,
-  0x37, 0xfe, 0x37, 0xf6, 0xf6, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0x01, 0xc9,
-  0xfe, 0x04, 0x01, 0xfc, 0x02, 0x43, 0x01, 0xfc, 0xfe, 0x04, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x69, 0xff, 0xf9, 0x05, 0xb1, 0x02, 0xd7, 0x00, 0x0b,
-  0x00, 0x00, 0x05, 0x23, 0x01, 0x37, 0x17, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x37, 0x17, 0x04, 0x4e, 0x51, 0xfe, 0x9f, 0x6c, 0xd1, 0xfc, 0x90, 0x04,
-  0x09, 0xd2, 0x6c, 0x07, 0x01, 0x8a, 0x78, 0xea, 0x01, 0x1c, 0xaa, 0xfe,
-  0x3a, 0xea, 0x78, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x2d, 0x05, 0xb1,
-  0x05, 0x0b, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01, 0x07, 0x27, 0x11, 0x21,
-  0x35, 0x21, 0x11, 0x07, 0x27, 0x01, 0x04, 0x4e, 0x01, 0x62, 0x6c, 0xd2,
-  0xfb, 0xf7, 0x03, 0x70, 0xd1, 0x6c, 0x01, 0x61, 0x05, 0x0b, 0xfe, 0x76,
-  0x78, 0xea, 0xfe, 0x3a, 0xaa, 0x01, 0x1c, 0xea, 0x78, 0x01, 0x8a, 0x00,
-  0x00, 0x01, 0x00, 0x40, 0xff, 0xf9, 0x05, 0x88, 0x02, 0xd7, 0x00, 0x0b,
-  0x00, 0x00, 0x05, 0x01, 0x37, 0x17, 0x11, 0x21, 0x15, 0x21, 0x11, 0x37,
-  0x17, 0x01, 0x01, 0xa3, 0xfe, 0x9e, 0x6c, 0xd2, 0x04, 0x09, 0xfc, 0x90,
-  0xd1, 0x6c, 0xfe, 0x9f, 0x07, 0x01, 0x8a, 0x78, 0xea, 0x01, 0xc6, 0xaa,
-  0xfe, 0xe4, 0xea, 0x78, 0xfe, 0x76, 0x00, 0x00, 0x00, 0x01, 0x00, 0x40,
-  0x02, 0x2d, 0x05, 0x88, 0x05, 0x0b, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33,
-  0x01, 0x07, 0x27, 0x11, 0x21, 0x15, 0x21, 0x11, 0x07, 0x27, 0x01, 0xa3,
-  0x51, 0x01, 0x61, 0x6c, 0xd1, 0x03, 0x70, 0xfb, 0xf7, 0xd2, 0x6c, 0x05,
-  0x0b, 0xfe, 0x76, 0x78, 0xea, 0xfe, 0xe4, 0xaa, 0x01, 0xc6, 0xea, 0x78,
-  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
-  0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0x04, 0xb2, 0xfb, 0x4e, 0xfc, 0x06, 0x20,
-  0xf9, 0xe0, 0x72, 0x02, 0x9e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x17, 0x11, 0x21, 0x11, 0x01, 0x21, 0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfa,
-  0xe8, 0x04, 0xb2, 0xfb, 0x4e, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x03, 0x10,
-  0x02, 0x9e, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x05, 0x21, 0x01, 0x03,
-  0x11, 0x21, 0x11, 0x01, 0x0e, 0x04, 0xb2, 0xfb, 0x4e, 0x67, 0x05, 0x7f,
-  0x8a, 0x05, 0x3c, 0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x02,
-  0x00, 0x06, 0x00, 0x00, 0x05, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11, 0x05,
-  0xc0, 0xfb, 0x4e, 0x67, 0x05, 0x7f, 0x8a, 0x05, 0x3c, 0xfa, 0x52, 0x06,
-  0x20, 0xf9, 0xe0, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x05, 0x09, 0x05, 0x02,
-  0xc4, 0x02, 0x37, 0xfd, 0xc9, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd,
-  0x40, 0x64, 0x02, 0x78, 0x02, 0x78, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0,
-  0xfc, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x13, 0x01, 0x11, 0x09,
-  0x03, 0x8e, 0x02, 0x36, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40,
-  0x02, 0x14, 0xfd, 0x88, 0x04, 0xf0, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0,
-  0xfc, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x13, 0x09, 0x01, 0x21,
-  0x09, 0x02, 0x8e, 0x02, 0x36, 0x02, 0x37, 0xfb, 0x0a, 0x02, 0xbf, 0x02,
-  0xc0, 0xfd, 0x40, 0x02, 0x14, 0xfd, 0x88, 0x02, 0x78, 0x03, 0x10, 0xfc,
-  0xf0, 0xfc, 0xf0, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
-  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21, 0x09, 0x04,
-  0x8e, 0x04, 0x6d, 0xfd, 0xc9, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd,
-  0x40, 0x02, 0x14, 0x02, 0x78, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0, 0xfc,
-  0xf0, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
-  0x05, 0x24, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x15,
-  0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x29, 0x00, 0x2d, 0x00, 0x31,
-  0x00, 0x37, 0x00, 0x00, 0x05, 0x15, 0x23, 0x35, 0x33, 0x35, 0x13, 0x15,
-  0x23, 0x35, 0x13, 0x15, 0x23, 0x35, 0x01, 0x15, 0x23, 0x35, 0x23, 0x15,
-  0x23, 0x35, 0x01, 0x15, 0x23, 0x35, 0x23, 0x35, 0x23, 0x15, 0x23, 0x35,
-  0x23, 0x15, 0x23, 0x35, 0x01, 0x15, 0x33, 0x15, 0x23, 0x35, 0x13, 0x15,
-  0x23, 0x35, 0x13, 0x15, 0x23, 0x35, 0x13, 0x15, 0x23, 0x15, 0x23, 0x35,
-  0x06, 0x26, 0xcc, 0x66, 0x66, 0x66, 0x66, 0x66, 0xfe, 0xc7, 0xb7, 0xd3,
-  0xb6, 0x03, 0xdf, 0x66, 0x66, 0xd3, 0xb7, 0xd3, 0xb6, 0xfe, 0xc7, 0x67,
-  0xce, 0x67, 0x67, 0x67, 0x67, 0xce, 0x67, 0x67, 0x16, 0xe6, 0x74, 0x72,
-  0x01, 0xb6, 0xcc, 0xcc, 0x01, 0xb4, 0xca, 0xca, 0xfc, 0x24, 0x74, 0x74,
-  0x74, 0x74, 0x05, 0xac, 0xe6, 0x72, 0x74, 0x74, 0x74, 0x74, 0x74, 0xfa,
-  0xc6, 0x72, 0x74, 0xe6, 0x01, 0xb6, 0xcc, 0xcc, 0x01, 0xb4, 0xca, 0xca,
-  0x01, 0xd0, 0x74, 0x72, 0xe6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x20,
-  0xff, 0xca, 0x06, 0x22, 0x06, 0x23, 0x00, 0x04, 0x00, 0x00, 0x13, 0x09,
-  0x02, 0x21, 0x20, 0x03, 0x01, 0x03, 0x01, 0xfe, 0xda, 0xfc, 0x4a, 0x03,
-  0xb6, 0x02, 0x6d, 0xfd, 0x93, 0xfc, 0x14, 0x00, 0x00, 0x02, 0x00, 0x20,
-  0xff, 0xca, 0x06, 0x22, 0x06, 0x23, 0x00, 0x04, 0x00, 0x09, 0x00, 0x00,
-  0x1b, 0x01, 0x21, 0x13, 0x09, 0x04, 0x21, 0x99, 0xf7, 0x03, 0x22, 0xf7,
-  0xfd, 0x78, 0xfc, 0xff, 0x03, 0x01, 0x03, 0x01, 0xfe, 0xda, 0xfc, 0x4a,
-  0x03, 0x8b, 0xfc, 0xb1, 0x03, 0x4f, 0x02, 0x0c, 0xfe, 0x1f, 0x02, 0x6d,
-  0xfd, 0x93, 0xfc, 0x14, 0x00, 0x02, 0x00, 0x87, 0xff, 0x46, 0x05, 0xc3,
-  0x05, 0xfc, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x09, 0x01, 0x11,
-  0x09, 0x01, 0x03, 0x11, 0x09, 0x01, 0x11, 0x01, 0xee, 0x02, 0x37, 0x02,
-  0x37, 0xfd, 0xc9, 0xfd, 0xc9, 0x67, 0x02, 0x9e, 0x02, 0x9d, 0xfd, 0x63,
-  0x01, 0x35, 0xfe, 0x95, 0x01, 0x6b, 0x02, 0xd8, 0x01, 0x6b, 0xfe, 0x95,
-  0xfc, 0xe6, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4, 0xfe, 0x53,
-  0x00, 0x01, 0x00, 0x87, 0xff, 0x46, 0x05, 0xc3, 0x05, 0xfc, 0x00, 0x05,
-  0x00, 0x00, 0x37, 0x11, 0x09, 0x01, 0x11, 0x01, 0x87, 0x02, 0x9e, 0x02,
-  0x9d, 0xfd, 0x63, 0xf3, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4,
-  0xfe, 0x53, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1e, 0xff, 0xb9, 0x06, 0x2a,
-  0x05, 0x89, 0x00, 0x05, 0x00, 0x00, 0x05, 0x09, 0x01, 0x21, 0x09, 0x01,
-  0x01, 0xa2, 0xfe, 0x7d, 0x01, 0x83, 0x03, 0x05, 0x01, 0x83, 0xfe, 0x7d,
-  0x47, 0x02, 0xe8, 0x02, 0xe8, 0xfd, 0x18, 0xfd, 0x18, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x64, 0xfe, 0x00, 0x07, 0xaa, 0x06, 0x28, 0x00, 0x0b,
-  0x00, 0x00, 0x16, 0x10, 0x01, 0x36, 0x20, 0x17, 0x00, 0x10, 0x01, 0x06,
-  0x20, 0x27, 0x65, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xfe,
-  0x2f, 0xe9, 0xfe, 0x2f, 0xe9, 0x40, 0x04, 0xa8, 0x01, 0x2a, 0x96, 0x96,
-  0xfe, 0xd6, 0xfb, 0x58, 0xfe, 0xd6, 0x96, 0x96, 0x00, 0x01, 0x00, 0x45,
-  0xff, 0xa0, 0x05, 0xfd, 0x06, 0x4d, 0x00, 0x04, 0x00, 0x00, 0x09, 0x03,
-  0x11, 0x03, 0xcd, 0x02, 0x2f, 0xfd, 0xd1, 0xfc, 0x79, 0x06, 0x4c, 0xfc,
-  0xaa, 0xfc, 0xaa, 0x01, 0x46, 0x04, 0x20, 0x00, 0x00, 0x02, 0x00, 0x45,
-  0xff, 0xa0, 0x05, 0xfd, 0x06, 0x4d, 0x00, 0x04, 0x00, 0x09, 0x00, 0x00,
-  0x09, 0x01, 0x11, 0x09, 0x05, 0x11, 0x03, 0xa7, 0xfd, 0x05, 0x02, 0xfb,
-  0x01, 0xd7, 0xfe, 0x4f, 0x02, 0x2f, 0xfd, 0xd1, 0xfc, 0x79, 0x05, 0xc6,
-  0xfe, 0xee, 0xfc, 0x86, 0xfe, 0xec, 0x02, 0xd0, 0x03, 0x56, 0xfc, 0xaa,
-  0xfc, 0xaa, 0x01, 0x46, 0x04, 0x20, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
-  0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x15, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
-  0x11, 0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0x01, 0x38,
-  0xfe, 0xc8, 0x01, 0x38, 0xfe, 0xc8, 0x02, 0x8e, 0xfc, 0xbc, 0xac, 0xac,
-  0xac, 0xac, 0x05, 0xd5, 0xfe, 0x07, 0x90, 0x90, 0x90, 0xfe, 0x7e, 0xaa,
-  0x02, 0x2c, 0x90, 0x90, 0x90, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0xf3, 0x06, 0x14, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
-  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33,
-  0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x01, 0x53, 0xa0, 0xa0, 0xa5, 0xa5,
-  0xa5, 0xa5, 0xa5, 0xa5, 0xa0, 0xa0, 0x02, 0xbc, 0x90, 0xfd, 0xd4, 0x02,
-  0x2c, 0x90, 0x90, 0x90, 0x02, 0x38, 0xfd, 0xc8, 0x90, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xdb, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x23,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x33,
-  0x32, 0x17, 0xb5, 0xb6, 0x01, 0x01, 0x10, 0x0b, 0x23, 0x10, 0x10, 0x02,
-  0x70, 0x01, 0x5c, 0x52, 0x12, 0x11, 0x02, 0x8e, 0xfc, 0xbc, 0x05, 0x05,
-  0x0f, 0x0c, 0x22, 0x10, 0x11, 0x01, 0x71, 0x02, 0x5c, 0x52, 0x16, 0x14,
-  0x05, 0xd5, 0xfd, 0x2c, 0x01, 0x01, 0x09, 0x25, 0x24, 0x52, 0x86, 0x94,
-  0x04, 0xfe, 0x2f, 0xaa, 0x03, 0x02, 0x04, 0x03, 0x09, 0x25, 0x24, 0x52,
-  0x86, 0x94, 0x06, 0x00, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x04, 0x19,
-  0x05, 0xd5, 0x00, 0x10, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x21, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x23, 0x35,
-  0x33, 0x17, 0x15, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x15,
-  0x21, 0x15, 0xb5, 0x01, 0x9a, 0xe2, 0x73, 0x74, 0x74, 0x73, 0xe2, 0xe4,
-  0xb6, 0xac, 0xac, 0xb6, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xe4, 0x01, 0x38,
-  0x05, 0xd5, 0x71, 0x72, 0xdb, 0xdd, 0x71, 0x71, 0xfd, 0xa8, 0x03, 0xcf,
-  0x90, 0x90, 0xd1, 0x92, 0x87, 0x86, 0x92, 0xd0, 0x90, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0xfe, 0x66, 0x04, 0xcc, 0x05, 0xd5, 0x00, 0x1b,
-  0x00, 0x24, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17, 0x13, 0x23, 0x03, 0x2e,
-  0x01, 0x2b, 0x01, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
-  0x19, 0x01, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4,
-  0xac, 0x42, 0x7d, 0x6c, 0xc6, 0x63, 0x78, 0x39, 0x45, 0xcd, 0xb8, 0x01,
-  0x9a, 0xe7, 0xe2, 0x75, 0xfd, 0xc8, 0xe4, 0x84, 0x86, 0x86, 0x84, 0x02,
-  0xbc, 0x16, 0x90, 0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0xf1,
-  0xc2, 0x96, 0xaa, 0xf4, 0x01, 0x0e, 0x05, 0x6d, 0xd6, 0xd8, 0x8d, 0xba,
-  0x02, 0x4f, 0xfd, 0xee, 0x87, 0x83, 0x83, 0x85, 0x00, 0x04, 0x00, 0x40,
-  0xff, 0xa2, 0x04, 0x26, 0x04, 0xbc, 0x00, 0x23, 0x00, 0x28, 0x00, 0x30,
-  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22,
-  0x27, 0x07, 0x27, 0x37, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x37, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
-  0x37, 0x17, 0x07, 0x16, 0x0f, 0x01, 0x33, 0x35, 0x34, 0x07, 0x01, 0x16,
-  0x33, 0x32, 0x36, 0x3d, 0x01, 0x01, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14,
-  0x03, 0xc2, 0xa6, 0x38, 0xa9, 0x7b, 0x7a, 0x52, 0x5d, 0x56, 0x63, 0x35,
-  0xe3, 0xe2, 0x26, 0x8d, 0x0a, 0x0c, 0x4b, 0x88, 0x56, 0xa4, 0x4c, 0x5b,
-  0xab, 0x51, 0xd1, 0x6b, 0x85, 0x56, 0x97, 0x33, 0xa8, 0x30, 0x32, 0x9d,
-  0xfe, 0xdd, 0x37, 0x59, 0x8a, 0xa6, 0xfd, 0xff, 0xcd, 0x59, 0x2d, 0x4e,
-  0x02, 0x7f, 0xfd, 0x81, 0xaa, 0x66, 0x61, 0x3c, 0x7d, 0x4e, 0x85, 0x56,
-  0x7b, 0xbd, 0xc0, 0xbf, 0x0c, 0x0c, 0x45, 0x2e, 0x2e, 0xaa, 0x27, 0x27,
-  0x72, 0xb3, 0x4f, 0xcb, 0x73, 0x2b, 0x41, 0x12, 0x18, 0xba, 0xfe, 0x78,
-  0x2e, 0xd9, 0xb4, 0x29, 0xfe, 0xe2, 0x01, 0x15, 0x0c, 0x1e, 0x33, 0x7b,
-  0x20, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xea, 0xff, 0x42, 0x02, 0xc4,
-  0x06, 0x93, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x33, 0x13, 0x33, 0x03,
-  0x33, 0x15, 0x23, 0x03, 0x15, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x03, 0x23, 0x13, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01,
-  0x52, 0x2b, 0xad, 0x99, 0xad, 0x91, 0xbd, 0x98, 0x43, 0x67, 0xab, 0xab,
-  0xbf, 0x49, 0x0b, 0x0a, 0x5c, 0x99, 0xc1, 0x79, 0x79, 0x05, 0x9e, 0xfe,
-  0xc2, 0x02, 0x33, 0xfd, 0xcd, 0x8f, 0xfe, 0x0f, 0x6f, 0x89, 0x4e, 0x9a,
-  0x50, 0x0c, 0x10, 0xfe, 0xd6, 0x02, 0x72, 0x02, 0x1d, 0x8f, 0x01, 0x3e,
-  0xff, 0xff, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x6a, 0x05, 0xd5, 0x10, 0x06,
-  0x04, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0x9a,
-  0x06, 0x14, 0x00, 0x19, 0x00, 0x00, 0x21, 0x23, 0x11, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x11, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x23, 0x03, 0xf4, 0xa6, 0x70,
-  0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0x50, 0x51, 0x6a, 0xad, 0x59, 0x5a,
-  0xa5, 0xa5, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x06, 0x14,
-  0xfd, 0x9e, 0x65, 0x32, 0x32, 0x77, 0x78, 0xe8, 0xfd, 0xf5, 0xfe, 0x4c,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x0e,
-  0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x11, 0x23, 0x11,
-  0x33, 0x11, 0x01, 0x33, 0x01, 0x04, 0x47, 0x98, 0xb1, 0x3e, 0xfd, 0x7b,
-  0xb6, 0xb6, 0x02, 0x5b, 0xea, 0xfd, 0x65, 0xaa, 0xfe, 0x15, 0x01, 0x41,
-  0x02, 0xcf, 0xfd, 0x31, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x77, 0xfd, 0x48,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0x26, 0x06, 0x14, 0x00, 0x0e,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23,
-  0x11, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xa7, 0x01, 0xee, 0xd4, 0xfd, 0xe9,
-  0x01, 0x9e, 0x8f, 0xa6, 0x32, 0xfe, 0x00, 0xa7, 0x06, 0x14, 0xfc, 0x69,
-  0x01, 0xe3, 0xfd, 0xf4, 0xfe, 0x45, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x23,
-  0xfd, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0x52, 0xfe, 0xbf, 0x05, 0x51,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x11,
-  0x23, 0x11, 0x21, 0x35, 0x01, 0x21, 0x68, 0x04, 0x1f, 0xfc, 0xaf, 0x04,
-  0x1b, 0xb5, 0xfb, 0xb7, 0x03, 0x51, 0xfc, 0xc4, 0x05, 0xd5, 0x9a, 0xfb,
-  0x6f, 0xfe, 0x15, 0x01, 0x41, 0x9a, 0x04, 0x91, 0x00, 0x01, 0x00, 0x4f,
-  0xfe, 0xe5, 0x04, 0x1e, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x01, 0x21, 0x66, 0x03,
-  0x12, 0xfd, 0x92, 0x03, 0x14, 0xa6, 0xfc, 0xd7, 0x02, 0x6f, 0xfd, 0xa8,
-  0x04, 0x60, 0xa8, 0xfc, 0xdb, 0xfe, 0x52, 0x01, 0x1b, 0xa8, 0x03, 0x25,
-  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xec, 0x05, 0xf1, 0x00, 0x10,
-  0x00, 0x1c, 0x00, 0x00, 0x01, 0x35, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01,
-  0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x01, 0x10, 0x12,
-  0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x04, 0x3b, 0xb0,
-  0xb0, 0x46, 0xd4, 0x95, 0xf3, 0xfe, 0xcf, 0x01, 0x31, 0xf3, 0x95, 0xd4,
-  0xfd, 0x2f, 0xd3, 0xb8, 0xb8, 0xd4, 0xd4, 0xb8, 0xb8, 0xd3, 0x04, 0xed,
-  0xe8, 0xfa, 0x2b, 0xe7, 0x84, 0x80, 0x01, 0xab, 0x01, 0x5c, 0x01, 0x5c,
-  0x01, 0xab, 0x80, 0xfd, 0x78, 0xfe, 0xe3, 0xfe, 0xbb, 0x01, 0x45, 0x01,
-  0x1d, 0x01, 0x1d, 0x01, 0x45, 0xfe, 0xbb, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0xfe, 0x66, 0x05, 0x83, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x13, 0x21,
-  0x09, 0x01, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36,
-  0x35, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5, 0x01, 0x0f, 0x01, 0x57,
-  0x01, 0x58, 0x01, 0x0f, 0xb8, 0xcc, 0x46, 0x3d, 0x79, 0x63, 0xfe, 0xa5,
-  0xb6, 0xfe, 0xa5, 0xb0, 0x05, 0xd5, 0xfc, 0x08, 0x03, 0xf8, 0xfa, 0x93,
-  0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x04, 0xb7, 0xfc, 0x00, 0x04, 0x00,
-  0xfa, 0xe1, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
-  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00, 0x25, 0x13, 0x21, 0x01,
-  0x23, 0x01, 0x33, 0x13, 0x21, 0x13, 0x33, 0x02, 0x76, 0xf7, 0xfe, 0x11,
-  0x01, 0x5f, 0xcf, 0xfe, 0x00, 0xbd, 0x7b, 0x02, 0x5e, 0x7a, 0xc0, 0xc7,
-  0x02, 0xe7, 0xfc, 0x52, 0x05, 0xd5, 0xfe, 0x81, 0x01, 0x7f, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xec, 0x05, 0xf1, 0x00, 0x0f,
-  0x00, 0x18, 0x00, 0x00, 0x25, 0x15, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01,
-  0x33, 0x32, 0x00, 0x10, 0x00, 0x23, 0x22, 0x26, 0x00, 0x10, 0x02, 0x23,
-  0x22, 0x02, 0x10, 0x12, 0x20, 0x01, 0x18, 0xb0, 0xb0, 0x45, 0xd5, 0x94,
-  0xf3, 0x01, 0x32, 0xfe, 0xce, 0xf3, 0x94, 0xd5, 0x02, 0xd1, 0xd2, 0xb8,
-  0xb9, 0xd3, 0xd3, 0x01, 0x71, 0xe7, 0xe8, 0x05, 0xd5, 0xe7, 0x84, 0x80,
-  0xfe, 0x55, 0xfd, 0x48, 0xfe, 0x55, 0x80, 0x01, 0x6b, 0x02, 0x3a, 0x01,
-  0x45, 0xfe, 0xbb, 0xfd, 0xc6, 0xfe, 0xbb, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0x00, 0x00, 0x05, 0x4a, 0x04, 0x7b, 0x00, 0x14, 0x00, 0x00, 0x01, 0x30,
-  0x01, 0x23, 0x01, 0x33, 0x01, 0x13, 0x36, 0x33, 0x32, 0x16, 0x1d, 0x01,
-  0x23, 0x35, 0x34, 0x26, 0x22, 0x07, 0x06, 0x03, 0xba, 0xfe, 0xd8, 0xe1,
-  0xfe, 0x86, 0xaf, 0x01, 0x3b, 0xf9, 0x4b, 0xc8, 0x76, 0xa7, 0xa1, 0x49,
-  0x66, 0x25, 0x13, 0x03, 0x6d, 0xfc, 0x93, 0x04, 0x60, 0xfc, 0x54, 0x02,
-  0xe6, 0xe1, 0xbf, 0x86, 0x72, 0x72, 0x3a, 0x54, 0x2a, 0x15, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x08, 0x1f, 0x05, 0xf0, 0x00, 0x1d,
-  0x00, 0x00, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x01, 0x33, 0x09, 0x01,
-  0x33, 0x01, 0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1d, 0x01,
-  0x23, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x06, 0xa9, 0xfe, 0xe8,
-  0xe5, 0xfe, 0xe5, 0xfe, 0xe1, 0xe4, 0xfe, 0xaf, 0xb8, 0x01, 0x1a, 0x01,
-  0x1a, 0xcc, 0x01, 0x1b, 0xed, 0x10, 0x36, 0x4d, 0x7c, 0x7a, 0x4c, 0x4d,
-  0x99, 0x49, 0x29, 0x26, 0x24, 0x1a, 0x04, 0xe1, 0xfb, 0x1f, 0x05, 0x10,
-  0xfa, 0xf0, 0x05, 0xd5, 0xfb, 0x12, 0x04, 0xee, 0xfb, 0x12, 0x04, 0x26,
-  0x47, 0x40, 0x5c, 0x5c, 0x5b, 0x6e, 0x83, 0x79, 0x36, 0x50, 0x28, 0x1c,
-  0x00, 0x01, 0x00, 0x4d, 0x00, 0x00, 0x06, 0xed, 0x04, 0x7b, 0x00, 0x1b,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x1d, 0x01, 0x23,
-  0x35, 0x34, 0x26, 0x22, 0x07, 0x06, 0x07, 0x03, 0x23, 0x0b, 0x01, 0x23,
-  0x01, 0x33, 0x1b, 0x01, 0x33, 0x13, 0x04, 0xbf, 0x15, 0x33, 0x52, 0x77,
-  0x76, 0xa6, 0xa0, 0x49, 0x67, 0x24, 0x16, 0x06, 0xce, 0xc3, 0xd9, 0xda,
-  0xc3, 0xfe, 0xf8, 0xa6, 0xcf, 0xce, 0xc3, 0xcf, 0x03, 0x88, 0x56, 0x3d,
-  0x60, 0xbf, 0x86, 0x72, 0x72, 0x3a, 0x54, 0x2a, 0x19, 0x14, 0xfc, 0x93,
-  0x03, 0x96, 0xfc, 0x6a, 0x04, 0x60, 0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96,
-  0x00, 0x02, 0x00, 0x5d, 0x00, 0x00, 0x04, 0x0c, 0x04, 0xb3, 0x00, 0x13,
-  0x00, 0x1b, 0x00, 0x00, 0x13, 0x10, 0x25, 0x36, 0x33, 0x32, 0x15, 0x14,
-  0x0f, 0x01, 0x13, 0x01, 0x33, 0x01, 0x23, 0x03, 0x07, 0x35, 0x36, 0x3f,
-  0x01, 0x36, 0x35, 0x26, 0x23, 0x22, 0x15, 0x14, 0xb4, 0x01, 0x32, 0x12,
-  0x10, 0x97, 0xa5, 0x72, 0x99, 0x01, 0x3b, 0xb0, 0xfe, 0x86, 0xe1, 0xbc,
-  0x97, 0x2c, 0x36, 0x94, 0xc3, 0x01, 0x29, 0x9d, 0x03, 0x4d, 0x01, 0x32,
-  0x31, 0x03, 0xf8, 0x99, 0x5d, 0x40, 0xfe, 0x2f, 0x03, 0xac, 0xfb, 0xa0,
-  0x02, 0x32, 0x55, 0xc4, 0x14, 0x1c, 0x50, 0x6e, 0x34, 0x34, 0xa0, 0x25,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x00, 0x05, 0xd5, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x03, 0xff,
-  0xfd, 0x6c, 0xb6, 0xb6, 0x02, 0x94, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5,
-  0xfd, 0x9c, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x03, 0x6f,
-  0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
-  0x11, 0x21, 0x03, 0x6e, 0xfd, 0xe5, 0xa5, 0xa5, 0x02, 0x1b, 0x02, 0x04,
-  0xfd, 0xfc, 0x04, 0x60, 0xfe, 0x33, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64,
-  0xff, 0xe7, 0x04, 0x56, 0x04, 0x68, 0x00, 0x0a, 0x00, 0x27, 0x00, 0x00,
-  0x01, 0x22, 0x15, 0x11, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
-  0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x07, 0x22, 0x27, 0x26,
-  0x11, 0x10, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x33, 0x11, 0x10, 0x02, 0xea, 0x3a, 0x55, 0x56, 0x4c, 0x4d, 0x3f,
-  0x31, 0x7d, 0x73, 0x7c, 0x7c, 0x74, 0xb6, 0xa5, 0xb4, 0x78, 0x7a, 0x7a,
-  0x5b, 0x96, 0x3b, 0x34, 0x4e, 0x4e, 0x45, 0x65, 0x03, 0xcb, 0x91, 0xfd,
-  0x52, 0x68, 0x5d, 0xdf, 0xd0, 0x70, 0x5b, 0x9d, 0x84, 0x8d, 0xfe, 0xd9,
-  0xfe, 0xf1, 0xa1, 0x98, 0x01, 0x99, 0x9c, 0x01, 0x13, 0x01, 0x1e, 0x92,
-  0x6d, 0x1c, 0xa3, 0x17, 0x4e, 0x73, 0xbe, 0xca, 0x73, 0x67, 0x02, 0xaf,
-  0x01, 0x2e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0xff, 0xe5, 0x02, 0x4f,
-  0x06, 0x14, 0x00, 0x17, 0x00, 0x00, 0x21, 0x35, 0x06, 0x23, 0x22, 0x2f,
-  0x01, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x34, 0x26, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32,
-  0x01, 0x36, 0x4f, 0x8d, 0x96, 0x45, 0x5f, 0xd0, 0xe5, 0xa4, 0x48, 0x49,
-  0xae, 0xc9, 0x0a, 0xbd, 0x23, 0xcb, 0xbe, 0x02, 0x6c, 0x99, 0x61, 0x9c,
-  0x60, 0x62, 0xd4, 0xfb, 0x82, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x20,
-  0x00, 0x00, 0x00, 0x26, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x00, 0x12,
-  0x20, 0x12, 0x10, 0x02, 0x20, 0x02, 0x00, 0x26, 0x20, 0x06, 0x15, 0x14,
-  0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x36, 0x35, 0x02,
-  0xc7, 0x55, 0x79, 0x54, 0x54, 0x7a, 0x54, 0xfd, 0x9f, 0xf5, 0x01, 0xb1,
-  0xf7, 0xf7, 0xfe, 0x4f, 0xf5, 0x02, 0xed, 0x9a, 0xfe, 0xf6, 0x9b, 0x12,
-  0x14, 0x32, 0x52, 0x78, 0x7a, 0x51, 0x2d, 0x15, 0x10, 0x01, 0x61, 0x5f,
-  0x5e, 0x87, 0x5c, 0x5c, 0x02, 0x68, 0x01, 0x38, 0xfe, 0xc8, 0xfd, 0xd9,
-  0xfe, 0xc7, 0x01, 0x39, 0x01, 0xda, 0xe9, 0xe7, 0xc9, 0x60, 0x4d, 0x47,
-  0x38, 0x5d, 0x5f, 0x32, 0x42, 0x49, 0x5b, 0x00, 0x00, 0x01, 0x00, 0x58,
-  0x00, 0x00, 0x02, 0xe2, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x02, 0xe1,
-  0xfd, 0x77, 0x01, 0xe2, 0xfe, 0x3f, 0x01, 0xc1, 0xfe, 0x2a, 0x04, 0x60,
-  0xfb, 0xa0, 0x93, 0x01, 0x78, 0x94, 0x01, 0x2d, 0x94, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xeb, 0xff, 0x11, 0x00, 0xd7, 0x03, 0x67, 0x12, 0x07,
-  0x02, 0x74, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
-  0x02, 0x9c, 0x03, 0x11, 0x05, 0xe0, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01,
-  0x33, 0x09, 0x01, 0x33, 0x01, 0x01, 0x4c, 0xfe, 0xbd, 0x78, 0x01, 0x0c,
-  0x01, 0x0d, 0x77, 0xfe, 0xbd, 0x02, 0x9c, 0x03, 0x44, 0xfd, 0x40, 0x02,
-  0xc0, 0xfc, 0xbc, 0x00, 0x00, 0x01, 0x00, 0x79, 0xfe, 0x10, 0x04, 0x4e,
-  0x05, 0xf0, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x17, 0x1e, 0x01, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2e,
-  0x02, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x03, 0xda, 0x67, 0xb8, 0x55, 0x95, 0xa1, 0x36,
-  0x31, 0x9a, 0x6d, 0xd0, 0x5d, 0x60, 0x83, 0x67, 0xb5, 0x79, 0x70, 0x84,
-  0x3f, 0x16, 0x39, 0x1e, 0x47, 0x5d, 0x6e, 0x36, 0xc9, 0x2c, 0x0d, 0x2d,
-  0x22, 0x6c, 0x73, 0x6f, 0xd4, 0x67, 0x9b, 0xaa, 0x7a, 0x8b, 0x6e, 0xcc,
-  0xb5, 0xfb, 0xdc, 0x5f, 0xc4, 0x05, 0xa4, 0xc5, 0x37, 0x36, 0x80, 0x76,
-  0x63, 0x33, 0x2e, 0x23, 0x19, 0x2f, 0x69, 0x6c, 0xb6, 0xd9, 0x70, 0x59,
-  0x12, 0x77, 0x6e, 0x49, 0xaa, 0x10, 0x27, 0x4f, 0x38, 0xce, 0x2d, 0x0a,
-  0x21, 0x07, 0x18, 0x2f, 0xd0, 0x45, 0x46, 0x88, 0x7e, 0x6e, 0x7c, 0x1f,
-  0x18, 0x2d, 0xc0, 0xab, 0xc6, 0xe4, 0x26, 0x00, 0x00, 0x01, 0x00, 0x52,
-  0xfe, 0x10, 0x04, 0x9c, 0x05, 0xd5, 0x00, 0x18, 0x00, 0x00, 0x01, 0x33,
-  0x15, 0x23, 0x22, 0x2e, 0x02, 0x27, 0x25, 0x26, 0x2b, 0x01, 0x35, 0x01,
-  0x21, 0x35, 0x21, 0x15, 0x01, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x04, 0x3b,
-  0x61, 0x84, 0x23, 0x51, 0x6a, 0x7e, 0x3e, 0xfe, 0xf2, 0x47, 0x66, 0x70,
-  0x03, 0x51, 0xfc, 0xc4, 0x04, 0x1f, 0xfc, 0xb3, 0x67, 0x69, 0xe3, 0x7a,
-  0x90, 0xfe, 0xba, 0xaa, 0x10, 0x27, 0x4f, 0x38, 0xf3, 0x3f, 0x9a, 0x04,
-  0x91, 0xaa, 0x9a, 0xfb, 0x6f, 0x0d, 0x5f, 0xcd, 0x6e, 0x49, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x01, 0x11, 0x33, 0x11,
-  0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x05, 0x58, 0x88, 0xfb, 0x30, 0x05,
-  0x58, 0xfa, 0xa8, 0x00, 0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
-  0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23,
-  0x01, 0x11, 0x33, 0x11, 0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x04, 0x24,
-  0x88, 0xfc, 0x64, 0x05, 0x58, 0xfa, 0xa8, 0x00, 0x00, 0x02, 0x00, 0xc0,
-  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x33, 0x15, 0x23, 0x01, 0x11, 0x33, 0x11, 0xc1, 0x99, 0x99, 0x01,
-  0x92, 0x7a, 0x02, 0xf0, 0x88, 0xfd, 0x98, 0x05, 0x58, 0xfa, 0xa8, 0x00,
-  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x01, 0x11, 0x33, 0x11,
-  0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x01, 0xbc, 0x88, 0xfe, 0xcc, 0x05,
-  0x58, 0xfa, 0xa8, 0x00, 0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
-  0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23,
-  0x01, 0x33, 0x11, 0x23, 0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x7a, 0x88,
-  0x88, 0x05, 0x58, 0xfa, 0xa8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc0,
-  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x23, 0x03, 0x23, 0x11, 0x33, 0x02, 0x34, 0x99, 0x99,
-  0xf9, 0x7a, 0x7a, 0x05, 0x58, 0x88, 0xfb, 0x30, 0x05, 0x58, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x03, 0x23, 0x11, 0x33,
-  0x02, 0x34, 0x99, 0x99, 0xf9, 0x7a, 0x7a, 0x04, 0x24, 0x88, 0xfc, 0x64,
-  0x05, 0x58, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
-  0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23,
-  0x03, 0x23, 0x11, 0x33, 0x02, 0x34, 0x99, 0x99, 0xf9, 0x7a, 0x7a, 0x02,
-  0xf0, 0x88, 0xfd, 0x98, 0x05, 0x58, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc0,
-  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x01, 0x33, 0x15, 0x23, 0x03, 0x23, 0x11, 0x33, 0x02, 0x34, 0x99, 0x99,
-  0xf9, 0x7a, 0x7a, 0x01, 0xbc, 0x88, 0xfe, 0xcc, 0x05, 0x58, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x25, 0x33, 0x15, 0x2b, 0x02, 0x11, 0x33, 0x02,
-  0x34, 0x99, 0x99, 0xf9, 0x7a, 0x7a, 0x88, 0x88, 0x05, 0x58, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x05,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x02,
-  0x0c, 0xfe, 0x6e, 0x05, 0x58, 0x88, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0,
-  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
-  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x7a, 0x01, 0x92,
-  0xfe, 0x6e, 0x05, 0x58, 0xfe, 0xcc, 0x88, 0x00, 0x00, 0x01, 0x00, 0xc0,
-  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
-  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x7a, 0x01, 0x92,
-  0xfe, 0x6e, 0x05, 0x58, 0xfd, 0x98, 0x88, 0x00, 0x00, 0x01, 0x00, 0xc0,
-  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
-  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x7a, 0x01, 0x92,
-  0xfe, 0x6e, 0x05, 0x58, 0xfc, 0x64, 0x88, 0x00, 0x00, 0x01, 0x00, 0xc0,
-  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x25, 0x21,
-  0x15, 0x21, 0x11, 0x33, 0x01, 0x3b, 0x01, 0x92, 0xfd, 0xf4, 0x7a, 0x88,
-  0x88, 0x05, 0x58, 0x00, 0x00, 0x01, 0x00, 0x5b, 0x02, 0x9c, 0x02, 0x4d,
-  0x05, 0xe4, 0x00, 0x09, 0x00, 0x00, 0x01, 0x33, 0x17, 0x07, 0x27, 0x11,
-  0x23, 0x11, 0x07, 0x27, 0x01, 0x3b, 0x33, 0xdf, 0x45, 0x83, 0x61, 0x84,
-  0x44, 0x05, 0xe4, 0xdd, 0x43, 0x83, 0xfd, 0x55, 0x02, 0xab, 0x83, 0x43,
-  0x00, 0x01, 0x00, 0x5b, 0x02, 0x98, 0x02, 0x4d, 0x05, 0xe0, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x23, 0x27, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17,
-  0x01, 0x6e, 0x33, 0xdf, 0x44, 0x84, 0x61, 0x83, 0x45, 0x02, 0x98, 0xdd,
-  0x43, 0x83, 0x02, 0xab, 0xfd, 0x55, 0x83, 0x43, 0x00, 0x02, 0x00, 0xaf,
-  0x02, 0x9c, 0x01, 0x23, 0x05, 0xe0, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00,
-  0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x11, 0x07, 0x23, 0x27, 0xb0, 0x73,
-  0x73, 0x73, 0x0c, 0x5c, 0x0b, 0x03, 0x2a, 0x8e, 0x03, 0x44, 0xfe, 0x91,
-  0xc8, 0xc8, 0x00, 0x00, 0x00, 0x02, 0x00, 0xaf, 0x02, 0x9c, 0x01, 0x23,
-  0x05, 0xe0, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33,
-  0x11, 0x23, 0x11, 0x37, 0x33, 0x17, 0x01, 0x23, 0x73, 0x73, 0x73, 0x0a,
-  0x5c, 0x0d, 0x05, 0x52, 0x8e, 0xfc, 0xbc, 0x01, 0x6f, 0xc8, 0xc8, 0x00,
-  0xff, 0xff, 0x00, 0xaf, 0x00, 0x00, 0x01, 0x23, 0x03, 0x44, 0x10, 0x07,
-  0x0e, 0x5c, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b,
-  0x00, 0x00, 0x02, 0x86, 0x05, 0xd4, 0x00, 0x10, 0x00, 0x00, 0x33, 0x35,
-  0x20, 0x02, 0x21, 0x35, 0x20, 0x02, 0x21, 0x35, 0x20, 0x13, 0x16, 0x07,
-  0x16, 0x13, 0x12, 0xba, 0x01, 0x29, 0x12, 0xfe, 0xd7, 0x01, 0x29, 0x1b,
-  0xfe, 0xc5, 0x01, 0xe7, 0x0d, 0x08, 0x9d, 0xa6, 0x05, 0x09, 0xa3, 0x02,
-  0x27, 0xa3, 0x01, 0xc5, 0xa2, 0xfe, 0x8c, 0xe5, 0x63, 0x6d, 0xfe, 0xfb,
-  0xfe, 0x5a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b, 0x00, 0x00, 0x02, 0x50,
-  0x04, 0x60, 0x00, 0x10, 0x00, 0x00, 0x33, 0x35, 0x20, 0x02, 0x21, 0x35,
-  0x20, 0x02, 0x21, 0x35, 0x20, 0x13, 0x16, 0x07, 0x16, 0x17, 0x12, 0xa8,
-  0x01, 0x0e, 0x12, 0xfe, 0xf2, 0x01, 0x0e, 0x1b, 0xfe, 0xf2, 0x01, 0xb1,
-  0x0d, 0x07, 0x77, 0x81, 0x05, 0x09, 0x99, 0x01, 0x7c, 0x99, 0x01, 0x1a,
-  0x98, 0xfe, 0xe8, 0x9e, 0x4d, 0x59, 0xbc, 0xfe, 0xb8, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x67, 0x01, 0xcb, 0x02, 0xf6, 0x05, 0xf0, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x10, 0x17, 0x07, 0x02, 0x35, 0x10, 0x21, 0x15, 0x20,
-  0x01, 0x0f, 0x69, 0x93, 0x7d, 0x02, 0x8e, 0xfe, 0x19, 0x03, 0xcd, 0xfe,
-  0xfe, 0xd2, 0x2e, 0x01, 0x31, 0xd4, 0x02, 0x20, 0xdb, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x67, 0x00, 0x56, 0x02, 0xf6, 0x04, 0x7b, 0x00, 0x09,
-  0x00, 0x00, 0x01, 0x10, 0x17, 0x07, 0x02, 0x35, 0x10, 0x21, 0x15, 0x20,
-  0x01, 0x0f, 0x69, 0x93, 0x7d, 0x02, 0x8e, 0xfe, 0x19, 0x02, 0x58, 0xfe,
-  0xfe, 0xd2, 0x2e, 0x01, 0x31, 0xd4, 0x02, 0x20, 0xbd, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x13,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x10, 0x06, 0x2b,
-  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6,
-  0x02, 0x94, 0xb6, 0xb8, 0xcd, 0x45, 0x39, 0x78, 0x63, 0xfd, 0x6c, 0xb6,
-  0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfa, 0x93, 0xfe, 0xf2, 0xf4, 0xaa,
-  0x96, 0xc2, 0x02, 0x5f, 0xfd, 0x39, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
-  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x11, 0x3e, 0x01,
-  0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x03, 0x4e, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b,
-  0xa1, 0x6a, 0xad, 0xb3, 0x93, 0xa3, 0x3f, 0x2c, 0x63, 0x1e, 0x22, 0x02,
-  0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x06, 0x14, 0xfd, 0x9e, 0x65,
-  0x64, 0xef, 0xe8, 0xfd, 0x48, 0xd6, 0xc0, 0x9c, 0x30, 0x38, 0x92, 0x00,
-  0x00, 0x01, 0xff, 0xfa, 0xfe, 0x4c, 0x05, 0xe6, 0x05, 0xd5, 0x00, 0x2a,
-  0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x01, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x2b, 0x01, 0x35, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21, 0x05, 0x04, 0x70,
-  0xfe, 0x23, 0x03, 0x08, 0xfe, 0x8e, 0x5f, 0x74, 0x59, 0x4c, 0x49, 0x89,
-  0x88, 0xfc, 0x68, 0x74, 0x75, 0x75, 0x60, 0x72, 0x71, 0x7b, 0xad, 0x59,
-  0x5a, 0x52, 0x54, 0x95, 0x9c, 0x01, 0x5a, 0xfd, 0xdb, 0xb6, 0xfe, 0x23,
-  0x05, 0xd5, 0xaa, 0xcb, 0x9a, 0xfe, 0x16, 0x38, 0x2b, 0x6c, 0x68, 0x8a,
-  0xdc, 0x7a, 0x79, 0x13, 0x13, 0x24, 0xc3, 0x31, 0x19, 0x19, 0x4b, 0x4b,
-  0x8f, 0x86, 0x49, 0x4a, 0x98, 0x01, 0xea, 0xfc, 0x4a, 0x05, 0x2b, 0x00,
-  0x00, 0x01, 0x00, 0x31, 0xfe, 0x4c, 0x04, 0xaf, 0x05, 0x9e, 0x00, 0x30,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x11, 0x14, 0x16, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33,
-  0x11, 0x21, 0x15, 0x02, 0xee, 0x5e, 0x74, 0x59, 0x4d, 0x49, 0xfe, 0xee,
-  0xfc, 0x54, 0x59, 0x5a, 0x60, 0x4c, 0xb4, 0x62, 0xab, 0x59, 0x5a, 0x53,
-  0x52, 0x96, 0x9d, 0x01, 0x83, 0xfd, 0xad, 0x43, 0x67, 0xab, 0xab, 0xbf,
-  0x92, 0x79, 0x79, 0xa7, 0x03, 0x0e, 0x01, 0xdc, 0x38, 0x2b, 0x6c, 0x68,
-  0x8a, 0xdd, 0xf2, 0x12, 0x13, 0x25, 0xc3, 0x31, 0x32, 0x4b, 0x4b, 0x8f,
-  0x84, 0x4b, 0x4a, 0xa6, 0x01, 0xf3, 0xfd, 0xa4, 0x89, 0x4e, 0x9a, 0x9f,
-  0xd2, 0x02, 0x60, 0x8f, 0x01, 0x3e, 0xfe, 0xc2, 0xa8, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x93, 0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x10, 0x06,
-  0x01, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0x77, 0xfe, 0x67, 0x03, 0x68,
-  0x04, 0x7c, 0x00, 0x31, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x64, 0x65, 0x36,
-  0x36, 0x66, 0x66, 0xb0, 0x45, 0x99, 0x58, 0x57, 0x48, 0x49, 0x40, 0x74,
-  0x35, 0x3f, 0x3d, 0x3c, 0x69, 0x8b, 0x85, 0x7b, 0x41, 0x46, 0x4b, 0x4d,
-  0x88, 0x57, 0x49, 0x4c, 0x40, 0x51, 0x4b, 0x4d, 0x48, 0xd6, 0xe8, 0x7c,
-  0x01, 0xac, 0x20, 0x56, 0x55, 0x7b, 0xba, 0x68, 0x68, 0x1a, 0x26, 0xb6,
-  0x2d, 0x14, 0x15, 0x3e, 0x48, 0x6d, 0x6d, 0x46, 0x45, 0x98, 0x4d, 0x55,
-  0x85, 0x88, 0x55, 0x55, 0x1c, 0x1c, 0x38, 0xbe, 0x25, 0x13, 0x12, 0xf0,
-  0xe5, 0x8f, 0xc1, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x25,
-  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x11, 0x23, 0xa7, 0x02, 0x7e, 0xfe, 0x2a, 0x01, 0xa6, 0xfe,
-  0x5a, 0xa8, 0x04, 0x60, 0x94, 0xfe, 0xd3, 0x94, 0xfd, 0xf5, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x04, 0x7b, 0x10, 0x06,
-  0x00, 0x56, 0x00, 0x00, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x08, 0xf0,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x15, 0x00, 0x00, 0x01, 0x33,
-  0x09, 0x01, 0x33, 0x01, 0x23, 0x03, 0x21, 0x03, 0x2b, 0x01, 0x03, 0x21,
-  0x03, 0x23, 0x01, 0x03, 0x21, 0x01, 0x03, 0x21, 0x02, 0x0f, 0xcf, 0x01,
-  0xa1, 0x01, 0xa3, 0xce, 0x02, 0x00, 0xbd, 0x7b, 0xfd, 0xa3, 0x7b, 0x02,
-  0xbd, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0, 0x02, 0x68, 0xf7, 0x01, 0xef, 0x03,
-  0x1a, 0xf6, 0x01, 0xee, 0x05, 0xd5, 0xfb, 0x3e, 0x04, 0xc2, 0xfa, 0x2b,
-  0x01, 0x7f, 0xfe, 0x81, 0x01, 0x7f, 0xfe, 0x81, 0x05, 0x0e, 0xfd, 0x19,
-  0x02, 0xe7, 0xfd, 0x19, 0x00, 0x04, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0x70,
-  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x35, 0x00, 0x40, 0x00, 0x4d, 0x00, 0x00,
-  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x25,
-  0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x15, 0x23, 0x35, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x30, 0x17,
-  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x3d, 0x01, 0x01, 0x16, 0x17, 0x36, 0x3b, 0x01, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x02, 0x78, 0xc9, 0x9b, 0x74, 0x64,
-  0x8a, 0xa6, 0x03, 0x54, 0xa6, 0x38, 0xaa, 0x7a, 0x63, 0x49, 0xa6, 0x38,
-  0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2, 0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c,
-  0x5b, 0xab, 0x51, 0xdb, 0x6c, 0x10, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0xfe,
-  0xb6, 0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0xfd, 0xc8, 0x2f, 0x01, 0x6d,
-  0xb3, 0xe8, 0x96, 0x88, 0x56, 0x52, 0x3b, 0x02, 0x33, 0x66, 0x7b, 0x62,
-  0x73, 0xd9, 0xb4, 0x29, 0x4c, 0xfd, 0x81, 0xaa, 0x66, 0x61, 0x27, 0x0a,
-  0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e,
-  0xaa, 0x27, 0x27, 0x7e, 0x14, 0x44, 0x27, 0x27, 0xfc, 0xfe, 0xb4, 0x66,
-  0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x01, 0x68, 0x6e, 0xa6, 0x3c, 0x12,
-  0x7f, 0x8b, 0x17, 0x10, 0x00, 0x03, 0x00, 0x0e, 0xff, 0xe3, 0x08, 0x43,
-  0x05, 0xf0, 0x00, 0x13, 0x00, 0x16, 0x00, 0x20, 0x00, 0x00, 0x01, 0x33,
-  0x13, 0x36, 0x37, 0x36, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20,
-  0x27, 0x26, 0x27, 0x21, 0x03, 0x23, 0x01, 0x03, 0x21, 0x00, 0x20, 0x02,
-  0x11, 0x10, 0x12, 0x20, 0x12, 0x11, 0x10, 0x02, 0x0f, 0xcf, 0xa5, 0x29,
-  0x64, 0xaa, 0x01, 0x1b, 0x01, 0x1b, 0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5,
-  0xfe, 0xe5, 0xaa, 0x47, 0x2a, 0xfd, 0xa9, 0x7a, 0xc0, 0x02, 0x68, 0xf7,
-  0x01, 0xef, 0x03, 0x2d, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe7, 0x05,
-  0xd5, 0xfe, 0x1e, 0xae, 0x7d, 0xd2, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0x9f,
-  0xfe, 0x5b, 0xd2, 0x58, 0x72, 0xfe, 0x81, 0x05, 0x0e, 0xfd, 0x19, 0x03,
-  0x25, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48, 0x01,
-  0x1a, 0x01, 0x1b, 0x00, 0x00, 0x03, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xbc,
-  0x04, 0x7b, 0x00, 0x22, 0x00, 0x2d, 0x00, 0x38, 0x00, 0x00, 0x01, 0x32,
-  0x12, 0x11, 0x10, 0x02, 0x20, 0x27, 0x26, 0x27, 0x0e, 0x02, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x07, 0x35, 0x3e, 0x01, 0x33, 0x20, 0x17, 0x36, 0x01, 0x22, 0x06, 0x15,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x01, 0x22, 0x06, 0x10, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x04, 0xed, 0xd8, 0xf7, 0xf7, 0xfe,
-  0x4f, 0x7b, 0x31, 0x1e, 0x10, 0x56, 0x7e, 0xa0, 0xa0, 0xb7, 0xe3, 0xe2,
-  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0x01, 0x0c, 0x66,
-  0x7c, 0xfe, 0x7b, 0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0x01, 0xd1, 0x85,
-  0x9b, 0x9a, 0x86, 0x84, 0x9b, 0x9b, 0x04, 0x7b, 0xfe, 0xc8, 0xfe, 0xec,
-  0xfe, 0xed, 0xfe, 0xc7, 0x9d, 0x3e, 0x52, 0x45, 0x87, 0x61, 0xc1, 0xa2,
-  0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xbd, 0xbd,
-  0xfd, 0xb8, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x01, 0xac, 0xe7,
-  0xfe, 0x6e, 0xe7, 0xe8, 0xc8, 0xc7, 0xe9, 0x00, 0x00, 0x02, 0x00, 0x0e,
-  0xff, 0xe3, 0x07, 0x99, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x16, 0x00, 0x00,
-  0x01, 0x03, 0x21, 0x01, 0x33, 0x01, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11,
-  0x33, 0x11, 0x10, 0x00, 0x23, 0x20, 0x03, 0x27, 0x21, 0x03, 0x23, 0x02,
-  0x76, 0xf7, 0x01, 0xef, 0xfe, 0xa1, 0xcf, 0x01, 0x8f, 0x42, 0xe8, 0xaf,
-  0x9c, 0xb7, 0xfe, 0xfc, 0xfe, 0xfe, 0x9a, 0x69, 0x22, 0xfd, 0xa2, 0x7a,
-  0xc0, 0x05, 0x0e, 0xfd, 0x19, 0x03, 0xae, 0xfb, 0x72, 0xc0, 0xd3, 0xf0,
-  0x03, 0x8b, 0xfc, 0x5c, 0xfe, 0xdc, 0xfe, 0xd6, 0x01, 0x34, 0x68, 0xfe,
-  0x81, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0x69,
-  0x04, 0x7b, 0x00, 0x28, 0x00, 0x33, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x11, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23,
-  0x22, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01,
-  0x03, 0x37, 0x41, 0x91, 0xa0, 0x9f, 0xb7, 0xe3, 0xe2, 0xe8, 0x96, 0x88,
-  0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0x70, 0x6f, 0x86, 0x9c,
-  0xa6, 0xa6, 0x3c, 0x9f, 0x6a, 0xfe, 0xfe, 0xf8, 0xc9, 0x9b, 0x74, 0x64,
-  0x8a, 0xa6, 0xdf, 0x8d, 0x6f, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b,
-  0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc, 0xff, 0x00, 0xbe, 0x9f, 0x9f, 0xbe,
-  0xa4, 0x02, 0x7b, 0xfb, 0xa0, 0xac, 0x66, 0x63, 0x02, 0x50, 0x66, 0x7b,
-  0x62, 0x73, 0xd9, 0xb4, 0x29, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e,
-  0x00, 0x00, 0x06, 0xef, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x00,
-  0x01, 0x03, 0x21, 0x13, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33, 0x09, 0x01,
-  0x33, 0x01, 0x02, 0x76, 0xf7, 0x01, 0xef, 0xb3, 0x7b, 0xfd, 0xa2, 0x7a,
-  0xc0, 0x02, 0x01, 0xcf, 0x01, 0xac, 0x01, 0xa8, 0xbd, 0xfe, 0x00, 0x05,
-  0x0e, 0xfd, 0x19, 0xfd, 0xd9, 0x01, 0x7f, 0xfe, 0x81, 0x05, 0xd5, 0xfb,
-  0x1f, 0x04, 0xe1, 0xfa, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6e,
-  0xff, 0xe3, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x0a, 0x00, 0x28, 0x00, 0x00,
-  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x11,
-  0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16,
-  0x19, 0x01, 0x01, 0x33, 0x01, 0x02, 0x78, 0xc9, 0x9b, 0x74, 0x64, 0x8a,
-  0xa6, 0x38, 0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2, 0xe8, 0x96, 0x88, 0x56,
-  0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0x01, 0x3b, 0xb0, 0xfe, 0x86,
-  0x02, 0x33, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0xfd, 0xcd, 0xaa,
-  0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa,
-  0x27, 0x27, 0xfc, 0xff, 0x00, 0xfe, 0x35, 0x03, 0xac, 0xfb, 0xa0, 0x00,
-  0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x06, 0xef, 0x05, 0xd5, 0x00, 0x02,
-  0x00, 0x12, 0x00, 0x15, 0x00, 0x00, 0x01, 0x03, 0x29, 0x02, 0x15, 0x21,
-  0x03, 0x23, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33, 0x01, 0x33, 0x01, 0x33,
-  0x01, 0x23, 0x17, 0x02, 0x76, 0xf7, 0x01, 0xef, 0x02, 0x3e, 0x01, 0x43,
-  0xfe, 0x83, 0x83, 0xce, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0, 0x02, 0x01, 0xcf,
-  0x01, 0x43, 0xd1, 0x01, 0x40, 0xbd, 0xfd, 0xca, 0x5f, 0x30, 0x05, 0x0e,
-  0xfd, 0x19, 0xa8, 0xfe, 0x81, 0x01, 0x7f, 0xfe, 0x81, 0x05, 0xd5, 0xfc,
-  0x52, 0x03, 0xae, 0xfb, 0xaa, 0x8b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6e,
-  0xff, 0xe3, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x22, 0x00, 0x2d, 0x00, 0x30,
-  0x00, 0x00, 0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
-  0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x33, 0x13, 0x33, 0x03, 0x33, 0x15, 0x23,
-  0x03, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01,
-  0x21, 0x23, 0x11, 0x03, 0x1c, 0x38, 0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2,
-  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0x6c, 0x5d,
-  0x0d, 0xb2, 0x8b, 0xb0, 0x8c, 0x8c, 0xbd, 0xbd, 0xfe, 0x45, 0xc9, 0x9b,
-  0x74, 0x64, 0x8a, 0xa6, 0x01, 0x27, 0x81, 0xaa, 0x66, 0x61, 0xc1, 0xa2,
-  0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0x7e, 0x6d,
-  0xcd, 0x01, 0x9d, 0xfe, 0x63, 0x90, 0xfd, 0xcd, 0x02, 0x33, 0x66, 0x7b,
-  0x62, 0x73, 0xd9, 0xb4, 0x29, 0xfe, 0x81, 0x00, 0x00, 0x02, 0x00, 0x0e,
-  0xfe, 0x56, 0x06, 0xd9, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x18, 0x00, 0x00,
-  0x01, 0x03, 0x21, 0x01, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x3f, 0x01, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33, 0x09, 0x01,
-  0x33, 0x02, 0x76, 0xf7, 0x01, 0xef, 0x01, 0x47, 0x43, 0x46, 0x42, 0x70,
-  0xc2, 0x9a, 0x44, 0x26, 0x26, 0x2e, 0x11, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0,
-  0x02, 0x01, 0xcf, 0x01, 0xa0, 0x01, 0x9d, 0xbd, 0x05, 0x0e, 0xfd, 0x19,
-  0xfd, 0x71, 0xc6, 0x3f, 0x3d, 0xaa, 0x24, 0x25, 0x85, 0x32, 0x01, 0x7f,
-  0xfe, 0x81, 0x05, 0xd5, 0xfb, 0x40, 0x04, 0xc0, 0x00, 0x02, 0x00, 0x6e,
-  0xfe, 0x56, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x27, 0x00, 0x32, 0x00, 0x00,
-  0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
-  0x16, 0x19, 0x01, 0x01, 0x33, 0x01, 0x0e, 0x01, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x36, 0x3f, 0x01, 0x03, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x36, 0x3d, 0x01, 0x03, 0x1c, 0x38, 0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2,
-  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0x01,
-  0x3b, 0xb0, 0xfe, 0x45, 0x46, 0x86, 0x6f, 0x85, 0x62, 0x44, 0x4c, 0x2e,
-  0x17, 0xf1, 0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0xaa, 0x66, 0x61, 0xc1,
-  0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc,
-  0xff, 0x00, 0xfe, 0x77, 0x03, 0x6a, 0xfb, 0x38, 0xc8, 0x7a, 0x9a, 0x48,
-  0x86, 0x42, 0x02, 0x33, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x10, 0x06,
-  0x03, 0x93, 0x00, 0x00, 0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90,
-  0x04, 0x7b, 0x10, 0x06, 0x03, 0x19, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
-  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33,
-  0x15, 0x33, 0x15, 0x23, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
-  0x23, 0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0xac, 0xac, 0x02, 0x5b, 0xea,
-  0xfd, 0x65, 0x02, 0xca, 0xef, 0xfd, 0x7b, 0xb6, 0xac, 0xac, 0x05, 0xd5,
-  0xb9, 0xaa, 0xfe, 0xec, 0x02, 0x77, 0xfd, 0x48, 0xfc, 0xe3, 0x02, 0xcf,
-  0xfd, 0x31, 0x04, 0x72, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0c,
-  0x00, 0x00, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33,
-  0x15, 0x21, 0x15, 0x21, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
-  0x23, 0x11, 0x23, 0x35, 0x33, 0xaf, 0xa6, 0x01, 0x05, 0xfe, 0xfb, 0x01,
-  0xee, 0xd4, 0xfd, 0xe9, 0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa6, 0xa2, 0xa2,
-  0x06, 0x14, 0xac, 0xa4, 0xfd, 0xb9, 0x01, 0xe3, 0xfd, 0xf4, 0xfd, 0xac,
-  0x02, 0x23, 0xfd, 0xdd, 0x04, 0xc4, 0xa4, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xdc, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x11,
-  0x33, 0x11, 0x37, 0x11, 0x21, 0x15, 0x21, 0x11, 0xb5, 0xb6, 0xe3, 0x02,
-  0x8e, 0xfc, 0xbc, 0x02, 0xad, 0x03, 0x28, 0xfd, 0x5e, 0x4d, 0xfd, 0x2a,
-  0xaa, 0x02, 0xfa, 0x00, 0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x02, 0x26,
-  0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x37, 0x11,
-  0x23, 0x11, 0xae, 0xa5, 0xd3, 0xa6, 0x02, 0x9c, 0x03, 0x78, 0xfd, 0x05,
-  0x49, 0xfc, 0x9e, 0x02, 0xe5, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4a,
-  0x00, 0x00, 0x04, 0x26, 0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33,
-  0x15, 0x33, 0x15, 0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x35, 0x33,
-  0xe2, 0xb6, 0x97, 0x97, 0x02, 0x8e, 0xfc, 0xbc, 0x97, 0x97, 0x05, 0xd5,
-  0xe0, 0xa4, 0xfc, 0x59, 0xaa, 0x04, 0x51, 0xa4, 0x00, 0x01, 0x00, 0x6c,
-  0x00, 0x00, 0x02, 0xa7, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33,
-  0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x01, 0x36,
-  0xa6, 0xcb, 0xcb, 0xa6, 0xca, 0xca, 0x06, 0x14, 0xfe, 0xe2, 0xa4, 0xfb,
-  0xae, 0x04, 0x52, 0xa4, 0x00, 0x03, 0x00, 0x09, 0xff, 0xe3, 0x05, 0xc6,
-  0x05, 0xf0, 0x00, 0x15, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x00, 0x01, 0x20,
-  0x17, 0x16, 0x13, 0x33, 0x15, 0x23, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27,
-  0x26, 0x03, 0x23, 0x35, 0x33, 0x12, 0x37, 0x36, 0x04, 0x20, 0x07, 0x06,
-  0x07, 0x21, 0x26, 0x27, 0x13, 0x21, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36,
-  0x02, 0xe8, 0x01, 0x1b, 0xa9, 0x91, 0x15, 0x74, 0x72, 0x0a, 0x9e, 0xa9,
-  0xfe, 0xe5, 0xfe, 0xe5, 0xa9, 0xa0, 0x0a, 0x71, 0x74, 0x15, 0x92, 0xa9,
-  0x01, 0xe1, 0xfe, 0x74, 0x74, 0x5f, 0x12, 0x03, 0x55, 0x11, 0x5f, 0x73,
-  0xfc, 0xa5, 0x09, 0x6b, 0x74, 0x01, 0x8c, 0x74, 0x6b, 0x05, 0xf0, 0xd2,
-  0xb5, 0xfe, 0xe3, 0x90, 0xfe, 0xbe, 0xc4, 0xd3, 0xd2, 0xc4, 0x01, 0x43,
-  0x90, 0x01, 0x1d, 0xb5, 0xd2, 0xa4, 0xa4, 0x86, 0xd6, 0xd6, 0x86, 0xfe,
-  0x14, 0xfa, 0x97, 0xa4, 0xa4, 0x97, 0x00, 0x00, 0x00, 0x03, 0x00, 0x09,
-  0xff, 0xe3, 0x05, 0x00, 0x04, 0x7b, 0x00, 0x15, 0x00, 0x1e, 0x00, 0x27,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x23, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36,
-  0x17, 0x22, 0x07, 0x06, 0x07, 0x21, 0x26, 0x27, 0x26, 0x13, 0x21, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x02, 0x85, 0xd8, 0x7c, 0x63, 0x13,
-  0xb1, 0xad, 0x09, 0x71, 0x7c, 0xd8, 0xd9, 0x7a, 0x71, 0x09, 0xaf, 0xb2,
-  0x13, 0x64, 0x7a, 0xd9, 0x85, 0x4d, 0x39, 0x0f, 0x02, 0x34, 0x0f, 0x39,
-  0x4d, 0x9a, 0xfd, 0xc2, 0x07, 0x45, 0x4d, 0x86, 0x85, 0x4d, 0x45, 0x04,
-  0x7b, 0x9c, 0x7e, 0xcd, 0x90, 0xf4, 0x90, 0x9d, 0x9d, 0x90, 0xf4, 0x90,
-  0xcd, 0x7e, 0x9c, 0x9c, 0x73, 0x55, 0x83, 0x81, 0x55, 0x75, 0xfe, 0x25,
-  0xab, 0x67, 0x73, 0x74, 0x67, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67,
-  0xff, 0xe3, 0x09, 0x60, 0x05, 0xf0, 0x00, 0x1a, 0x00, 0x24, 0x00, 0x2e,
-  0x00, 0x00, 0x01, 0x20, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x21, 0x20, 0x00, 0x10, 0x00, 0x04, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20,
-  0x12, 0x11, 0x10, 0x00, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20, 0x12, 0x11,
-  0x10, 0x02, 0xd6, 0x01, 0x1b, 0xa9, 0x2a, 0x20, 0x1f, 0x2a, 0xaa, 0x01,
-  0x1b, 0x01, 0x1b, 0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xaa,
-  0x2a, 0x20, 0x1f, 0x2a, 0xa9, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad, 0x01,
-  0x53, 0x01, 0xe1, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0x03, 0x34,
-  0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0x05, 0xf0, 0xd2, 0x35, 0x3d,
-  0x3d, 0x35, 0xd2, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0x9f, 0xfe, 0x5b, 0xd2,
-  0x34, 0x3d, 0x3c, 0x34, 0xd3, 0x01, 0xa4, 0x02, 0xc4, 0x01, 0xa5, 0xa4,
-  0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48, 0x01, 0x1a,
-  0x01, 0x1b, 0x01, 0x48, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8,
-  0x01, 0x48, 0x01, 0x1a, 0x01, 0x1b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
-  0xff, 0xe3, 0x06, 0xf1, 0x04, 0x7b, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x31,
-  0x00, 0x00, 0x01, 0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x21, 0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x27, 0x32, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12, 0x11,
-  0x10, 0x02, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x02, 0x11, 0x10, 0x12, 0x05, 0x22, 0x85, 0x9b, 0x9a, 0x86, 0x84, 0x9b,
-  0x9b, 0xfc, 0x8e, 0x85, 0x9b, 0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x85, 0xd8,
-  0x7c, 0x12, 0x11, 0x10, 0x13, 0x7b, 0xd9, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9,
-  0x7b, 0x13, 0x10, 0x11, 0x12, 0x7c, 0xd8, 0xd9, 0xf5, 0xf5, 0x03, 0xdf,
-  0xe7, 0xfe, 0x6e, 0xe7, 0xe8, 0xc8, 0xc7, 0xe9, 0xe7, 0xfe, 0x6e, 0xe7,
-  0xe8, 0xc8, 0xc7, 0xe9, 0x9c, 0x9c, 0x18, 0x1b, 0x1b, 0x18, 0x9c, 0xfe,
-  0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x9d, 0x18, 0x1b, 0x1b, 0x18,
-  0x9d, 0x01, 0x39, 0x01, 0x13, 0x01, 0x14, 0x01, 0x38, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x1d, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x25, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01,
-  0x15, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x01, 0x6b,
-  0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xfe, 0x66, 0x01, 0x9a, 0xe2, 0x73, 0x74,
-  0x74, 0x73, 0xe2, 0xe4, 0xd5, 0xd5, 0xb6, 0xac, 0xac, 0x05, 0x2f, 0xfd,
-  0xcf, 0x92, 0x87, 0x86, 0x92, 0xa6, 0x71, 0x72, 0xdb, 0xdd, 0x71, 0x71,
-  0xc4, 0x90, 0xfe, 0xfc, 0x01, 0x04, 0x90, 0x00, 0x00, 0x02, 0xff, 0xfb,
-  0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x1f, 0x00, 0x00,
-  0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20, 0x01, 0x35, 0x33, 0x11,
-  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26,
-  0x27, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x03, 0x81, 0x96, 0xfe,
-  0xf9, 0x96, 0x96, 0x01, 0x07, 0xfd, 0x11, 0xab, 0xa7, 0x34, 0x9f, 0x6f,
-  0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xe4, 0xe4, 0xa7, 0x01, 0x64,
-  0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0xfe, 0x67, 0x90, 0x04, 0xec,
-  0xaa, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x64, 0xfe,
-  0xcc, 0x90, 0x8e, 0x8e, 0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x05, 0x0a,
-  0x05, 0xd5, 0x00, 0x1e, 0x00, 0x27, 0x00, 0x00, 0x01, 0x21, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x23, 0x22, 0x07, 0x06,
-  0x15, 0x16, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x3b, 0x03, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x01, 0xa6,
-  0x01, 0x9a, 0xe2, 0xe8, 0xe8, 0xe2, 0xe4, 0xb6, 0x28, 0x53, 0x2b, 0x35,
-  0x01, 0x18, 0x15, 0x35, 0x3d, 0x47, 0x3e, 0x3f, 0x72, 0x58, 0x91, 0x1e,
-  0xb6, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xe4, 0x05, 0xd5, 0xe3, 0xdb, 0xdd,
-  0xe2, 0xfd, 0xa8, 0x02, 0x58, 0x18, 0x1f, 0x3d, 0x35, 0x27, 0x20, 0x18,
-  0x94, 0x17, 0x49, 0x4b, 0x7d, 0x93, 0x4c, 0x3b, 0x92, 0x87, 0x86, 0x92,
-  0x00, 0x02, 0x00, 0x2d, 0xfe, 0x56, 0x05, 0x2f, 0x04, 0x7b, 0x00, 0x0c,
-  0x00, 0x31, 0x00, 0x00, 0x01, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x26, 0x20, 0x06, 0x15, 0x03, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10,
-  0x02, 0x23, 0x22, 0x27, 0x11, 0x23, 0x02, 0x4f, 0x09, 0x8e, 0x83, 0x80,
-  0x4f, 0x4b, 0x97, 0xfe, 0xfa, 0x97, 0xa6, 0x2e, 0x25, 0x28, 0x2e, 0x35,
-  0x19, 0x15, 0x35, 0x3d, 0x47, 0x3e, 0x3f, 0x72, 0x4b, 0x5e, 0x30, 0x31,
-  0xa6, 0x35, 0x9f, 0x6f, 0xb7, 0xe6, 0xe6, 0xb6, 0xac, 0x98, 0xa6, 0x01,
-  0x32, 0x0b, 0xaa, 0x73, 0x70, 0xcf, 0xcb, 0xe7, 0xe7, 0xcb, 0xfe, 0xe3,
-  0x19, 0x18, 0x1b, 0x41, 0x34, 0x28, 0x20, 0x18, 0x94, 0x17, 0x49, 0x4b,
-  0x7d, 0x86, 0x59, 0x3b, 0x17, 0x02, 0xa6, 0xaa, 0x64, 0x61, 0xfe, 0xbc,
-  0xfd, 0xf0, 0xfe, 0xbc, 0xa2, 0xfd, 0xd1, 0x00, 0x00, 0x02, 0x00, 0x67,
-  0xfe, 0x94, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x09, 0x00, 0x23, 0x00, 0x00,
-  0x00, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20, 0x12, 0x11, 0x10, 0x01, 0x27,
-  0x37, 0x27, 0x07, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x02, 0x07, 0x17, 0x37, 0x17, 0x07, 0x17, 0x23, 0x27,
-  0x03, 0x9c, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0xfe, 0xa6, 0x41,
-  0x99, 0x60, 0x2e, 0x10, 0x0e, 0xfe, 0xe5, 0xfe, 0xad, 0x01, 0x53, 0x01,
-  0x1b, 0x01, 0x1b, 0x01, 0x52, 0xbc, 0xb2, 0x3e, 0xc2, 0x40, 0xa9, 0x58,
-  0xdb, 0x0d, 0x05, 0x4c, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8,
-  0x01, 0x48, 0x01, 0x1a, 0x01, 0x1b, 0xfa, 0x90, 0x7d, 0x62, 0x74, 0x03,
-  0x01, 0x01, 0xa5, 0x01, 0x61, 0x01, 0x62, 0x01, 0xa5, 0xfe, 0x5b, 0xfe,
-  0x9e, 0xfe, 0xfc, 0xfe, 0x8e, 0x58, 0x4b, 0x7c, 0x7d, 0x6c, 0x6b, 0x0f,
-  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x97, 0x04, 0x7b, 0x00, 0x17,
-  0x00, 0x1f, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x10, 0x12,
-  0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23,
-  0x35, 0x23, 0x35, 0x33, 0x00, 0x10, 0x16, 0x20, 0x36, 0x10, 0x26, 0x20,
-  0x03, 0x45, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34,
-  0xa6, 0xab, 0xab, 0xa6, 0xe5, 0xe5, 0xfd, 0xcc, 0x96, 0x01, 0x07, 0x97,
-  0x97, 0xfe, 0xf9, 0xa8, 0x64, 0x61, 0x01, 0x44, 0x02, 0x10, 0x01, 0x44,
-  0x61, 0x64, 0xaa, 0xfb, 0x14, 0x90, 0x8e, 0x8e, 0x90, 0x03, 0x86, 0xfe,
-  0x6a, 0xe7, 0xe7, 0x01, 0x96, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09,
-  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x01, 0x33, 0x15, 0x33,
-  0x15, 0x23, 0x15, 0x33, 0x32, 0x16, 0x10, 0x06, 0x2b, 0x01, 0x11, 0x23,
-  0x11, 0x23, 0x35, 0x33, 0x01, 0x6b, 0xe4, 0x7f, 0x8b, 0x8a, 0x80, 0xfe,
-  0x66, 0xb6, 0xd5, 0xd5, 0xe4, 0xe2, 0xe7, 0xe7, 0xe2, 0xe4, 0xb6, 0xac,
-  0xac, 0x04, 0x27, 0xfd, 0xd1, 0x92, 0x01, 0x0c, 0x91, 0x01, 0xae, 0x2d,
-  0x90, 0x4b, 0xe1, 0xfe, 0x48, 0xe2, 0xfe, 0xae, 0x05, 0x18, 0x90, 0x00,
-  0x00, 0x02, 0xff, 0xfb, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x07,
-  0x00, 0x1f, 0x00, 0x00, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
-  0x25, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15,
-  0x23, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26,
-  0x03, 0x81, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07, 0xfe, 0x63, 0xa7,
-  0xab, 0xab, 0xa7, 0xe4, 0xe4, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8,
-  0x6f, 0x9f, 0x01, 0x64, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x2b,
-  0xfd, 0xae, 0x06, 0x9b, 0x90, 0x93, 0x93, 0x90, 0xfe, 0xc5, 0x64, 0x61,
-  0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x00, 0x00, 0x02, 0x00, 0x09,
-  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x01, 0x33, 0x11, 0x33,
-  0x32, 0x16, 0x10, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x15, 0x23, 0x15, 0x23,
-  0x35, 0x23, 0x35, 0x33, 0x01, 0x6b, 0xe4, 0x7f, 0x8b, 0x8a, 0x80, 0xfe,
-  0x66, 0xb6, 0xe4, 0xe2, 0xe7, 0xe7, 0xe2, 0xe4, 0xd5, 0xd5, 0xb6, 0xac,
-  0xac, 0x04, 0x27, 0xfd, 0xd1, 0x92, 0x01, 0x0c, 0x91, 0x01, 0xae, 0xfe,
-  0xf8, 0xe1, 0xfe, 0x48, 0xe2, 0x5e, 0x90, 0x64, 0x64, 0x90, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xfb, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x07,
-  0x00, 0x1f, 0x00, 0x00, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
-  0x01, 0x35, 0x33, 0x11, 0x33, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10,
-  0x02, 0x23, 0x22, 0x26, 0x27, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35,
-  0x03, 0x81, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07, 0xfd, 0x11, 0xab,
-  0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xe4,
-  0xe4, 0xa7, 0x01, 0x64, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0xfe,
-  0x67, 0x90, 0x06, 0xa0, 0xfd, 0xa2, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0,
-  0xfe, 0xbc, 0x61, 0x64, 0xfe, 0xcc, 0x90, 0x8e, 0x8e, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x03, 0x4e, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x35, 0x21, 0x03, 0x4e, 0xb6, 0xfd,
-  0x72, 0x03, 0x44, 0x05, 0x2b, 0xaa, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
-  0xfe, 0x56, 0x01, 0x54, 0x04, 0x7b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00,
-  0x01, 0x07, 0x33, 0x11, 0x23, 0x01, 0x00, 0x52, 0xa5, 0xa5, 0x04, 0x7b,
-  0x1b, 0xf9, 0xf6, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x97,
-  0x05, 0xf0, 0x00, 0x14, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12,
-  0x19, 0x01, 0x23, 0x03, 0xe2, 0x8b, 0x8a, 0xa1, 0xc1, 0xb6, 0xb6, 0x48,
-  0x5c, 0x5b, 0x8e, 0xcd, 0xd1, 0xb4, 0x03, 0x7f, 0xd7, 0xd5, 0xff, 0xde,
-  0xfb, 0x08, 0x07, 0x7f, 0xf1, 0x87, 0x43, 0x42, 0xfe, 0xc1, 0xfe, 0xcc,
-  0xfc, 0x83, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
-  0x04, 0x7b, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b,
-  0xa1, 0x6a, 0xad, 0xb3, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e,
-  0xbe, 0xa4, 0xfb, 0xdd, 0x06, 0x0a, 0xae, 0x65, 0x64, 0xef, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xd8, 0x00, 0x00, 0x01, 0x96, 0x04, 0x23, 0x12, 0x06,
-  0x00, 0x1d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x90, 0x01, 0x49, 0x02, 0x25,
-  0x03, 0x0b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21,
-  0x35, 0x21, 0x35, 0x21, 0x02, 0x25, 0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b,
-  0x01, 0x95, 0x01, 0x49, 0x96, 0x96, 0x96, 0x00, 0x00, 0x01, 0x01, 0x16,
-  0x01, 0xe1, 0x01, 0xcd, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x01, 0x33,
-  0x11, 0x03, 0x23, 0x03, 0x01, 0x16, 0xb7, 0x12, 0x92, 0x13, 0x05, 0xd5,
-  0xfd, 0x71, 0xfe, 0x9b, 0x01, 0x65, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb1,
-  0x03, 0xaa, 0x01, 0x4b, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x01, 0x4a, 0x99, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0x00,
-  0xff, 0xff, 0x00, 0x9d, 0x00, 0x00, 0x04, 0x3b, 0x05, 0xd5, 0x12, 0x06,
-  0x03, 0xbb, 0x00, 0x00, 0x00, 0x02, 0x00, 0x45, 0xfe, 0x56, 0x02, 0xff,
-  0x06, 0x14, 0x00, 0x06, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
-  0x07, 0x14, 0x33, 0x37, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x14,
-  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x30, 0x03, 0x23, 0x22,
-  0x37, 0x36, 0x33, 0x32, 0x01, 0x6a, 0x15, 0x31, 0x46, 0x01, 0x53, 0x48,
-  0xa6, 0xe1, 0xe1, 0x37, 0x6c, 0x2c, 0x3f, 0xac, 0x8a, 0x02, 0x36, 0xfc,
-  0x01, 0x01, 0xdd, 0x30, 0x03, 0x12, 0x84, 0x4b, 0x39, 0xfa, 0x02, 0x08,
-  0xfc, 0xfe, 0xa0, 0xfd, 0x70, 0x7c, 0x74, 0x9c, 0xcc, 0xca, 0x02, 0x86,
-  0xbd, 0xf6, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x47,
-  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
-  0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x11, 0x23, 0xb5, 0xf5, 0x02, 0x54,
-  0xb0, 0x99, 0x99, 0xf5, 0xfd, 0xac, 0xb0, 0x05, 0xd5, 0xfb, 0x1f, 0x04,
-  0xe1, 0xfa, 0xd5, 0xfe, 0x15, 0x01, 0x41, 0x04, 0xe1, 0xfb, 0x1f, 0x00,
-  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0x78, 0x04, 0x7b, 0x00, 0x17,
-  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x03, 0xf4, 0x84, 0x84, 0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7,
-  0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3, 0x02, 0xa4, 0xfd, 0xef, 0xfe, 0x52,
-  0x01, 0x1b, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60,
-  0xae, 0x65, 0x64, 0xef, 0x00, 0x01, 0x00, 0x03, 0xff, 0xe3, 0x05, 0x9a,
-  0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x25, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x0e, 0x01, 0x23, 0x24, 0x27, 0x26, 0x27, 0x07, 0x27, 0x37, 0x34, 0x35,
-  0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x07,
-  0x06, 0x03, 0x01, 0x17, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x04,
-  0x49, 0xfe, 0xd7, 0x01, 0xdd, 0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xb2, 0x7f,
-  0x24, 0x4c, 0x26, 0x64, 0x01, 0x63, 0x01, 0x3b, 0x83, 0xed, 0x64, 0x65,
-  0xe3, 0x7d, 0xf5, 0x7d, 0x79, 0x03, 0x04, 0x4c, 0x27, 0xfb, 0x94, 0x16,
-  0x5f, 0x7d, 0xf5, 0x61, 0x97, 0xd5, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53,
-  0x55, 0x01, 0xcc, 0x92, 0xe2, 0x1c, 0x7f, 0x25, 0x1e, 0x1f, 0x01, 0x6e,
-  0x01, 0x99, 0x48, 0x46, 0xd7, 0x5f, 0x60, 0x99, 0x97, 0xfe, 0xd9, 0x01,
-  0x95, 0x7f, 0xfe, 0x5f, 0xcf, 0x77, 0x99, 0x25, 0x00, 0x03, 0x00, 0x03,
-  0xfe, 0x56, 0x04, 0x8f, 0x04, 0x7b, 0x00, 0x26, 0x00, 0x30, 0x00, 0x3a,
-  0x00, 0x00, 0x25, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
-  0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x07, 0x27, 0x37, 0x26, 0x35, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35,
-  0x33, 0x11, 0x37, 0x17, 0x0f, 0x01, 0x05, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
-  0x17, 0x03, 0xeb, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a, 0xa3,
-  0xa2, 0x33, 0xa0, 0x70, 0xba, 0x71, 0x3c, 0x1c, 0x5e, 0x1d, 0x68, 0x06,
-  0xe2, 0xba, 0x70, 0xa0, 0x33, 0xa6, 0x86, 0x1d, 0xa3, 0xa7, 0xfd, 0xdc,
-  0x12, 0x29, 0x4a, 0x85, 0x86, 0x95, 0x0c, 0x11, 0x2d, 0x4a, 0x87, 0x85,
-  0x94, 0x01, 0x8b, 0xfe, 0xe2, 0xfe, 0xe9, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a,
-  0xbd, 0xbf, 0x5b, 0x63, 0x62, 0x9d, 0x53, 0x70, 0x23, 0x63, 0x27, 0x38,
-  0x3e, 0x01, 0x04, 0x01, 0x3a, 0x62, 0x63, 0xaa, 0xfe, 0xb1, 0x32, 0x63,
-  0x3d, 0x3d, 0xcb, 0x57, 0x3c, 0x6e, 0xdc, 0xc7, 0x15, 0x7e, 0x62, 0x41,
-  0x6e, 0xdc, 0xc8, 0x1d, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x03,
-  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00,
-  0x13, 0x33, 0x11, 0x01, 0x33, 0x01, 0x17, 0x25, 0x17, 0x05, 0x01, 0x23,
-  0x01, 0x07, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x25, 0x27, 0x15, 0xb5,
-  0xb6, 0x02, 0x5b, 0xea, 0xfd, 0x65, 0x6d, 0x02, 0x16, 0x27, 0xfe, 0x22,
-  0x01, 0xfe, 0xef, 0xfe, 0x3d, 0xc2, 0xb6, 0x8b, 0x26, 0xb1, 0x01, 0x19,
-  0x63, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x77, 0xfd, 0x48, 0x7a, 0xc5, 0x7f,
-  0xb0, 0xfd, 0xc7, 0x01, 0xf7, 0x48, 0xfe, 0x51, 0x01, 0x6c, 0x33, 0x7f,
-  0x41, 0x68, 0x6e, 0x93, 0x00, 0x02, 0x00, 0x03, 0x00, 0x00, 0x04, 0x28,
-  0x06, 0x14, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00, 0x13, 0x33, 0x11, 0x01,
-  0x33, 0x01, 0x17, 0x25, 0x17, 0x05, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23,
-  0x35, 0x07, 0x27, 0x37, 0x25, 0x27, 0x15, 0xa7, 0xa7, 0x01, 0xee, 0xd4,
-  0xfd, 0xe9, 0x55, 0x01, 0xbc, 0x1e, 0xfe, 0x72, 0x01, 0x8c, 0xd8, 0xfe,
-  0xab, 0xab, 0xa7, 0x86, 0x1d, 0xa3, 0x01, 0x05, 0x5e, 0x06, 0x14, 0xfc,
-  0x69, 0x01, 0xe3, 0xfd, 0xf4, 0x5b, 0xa4, 0x62, 0x93, 0xfe, 0x58, 0x01,
-  0x6c, 0x3f, 0xfe, 0xd3, 0xf0, 0x32, 0x63, 0x3c, 0x61, 0x65, 0x88, 0x00,
-  0x00, 0x03, 0x00, 0x03, 0x00, 0x00, 0x05, 0x60, 0x05, 0xd5, 0x00, 0x13,
-  0x00, 0x16, 0x00, 0x19, 0x00, 0x00, 0x13, 0x33, 0x01, 0x25, 0x11, 0x33,
-  0x11, 0x37, 0x17, 0x07, 0x11, 0x23, 0x01, 0x05, 0x11, 0x23, 0x11, 0x07,
-  0x27, 0x37, 0x25, 0x03, 0x11, 0x25, 0x13, 0x11, 0xb5, 0xf5, 0x01, 0x3b,
-  0x01, 0x19, 0xb0, 0x8a, 0x27, 0xb1, 0xf5, 0xfe, 0xc9, 0xfe, 0xe3, 0xb0,
-  0x8b, 0x26, 0xb1, 0x01, 0x93, 0xe3, 0x01, 0xb9, 0xe0, 0x05, 0xd5, 0xfd,
-  0x6b, 0x67, 0x02, 0x2e, 0xfe, 0x13, 0x33, 0x7f, 0x41, 0xfc, 0xa5, 0x02,
-  0x8e, 0x69, 0xfd, 0xdb, 0x01, 0xe4, 0x33, 0x7f, 0x41, 0x95, 0x01, 0xdb,
-  0xfd, 0xd1, 0x16, 0xfe, 0x2c, 0x02, 0x26, 0x00, 0x00, 0x02, 0x00, 0x03,
-  0x00, 0x00, 0x04, 0x8f, 0x04, 0x7b, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00,
-  0x01, 0x11, 0x23, 0x11, 0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x11,
-  0x33, 0x15, 0x3e, 0x01, 0x33, 0x36, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07,
-  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x03, 0xf4, 0xa6,
-  0xfe, 0x00, 0xa7, 0x86, 0x1d, 0xa3, 0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0x59,
-  0x43, 0x11, 0x83, 0x1d, 0x9a, 0xa8, 0x08, 0x2e, 0x38, 0x6f, 0x86, 0x9b,
-  0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x6a, 0xbe, 0xfe, 0x54, 0x01, 0x6f, 0x32,
-  0x63, 0x3d, 0x02, 0x83, 0xae, 0x65, 0x64, 0x01, 0x78, 0x59, 0x99, 0x31,
-  0x63, 0x39, 0x30, 0x75, 0x40, 0x4f, 0xbe, 0xa4, 0x5f, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x03, 0x00, 0x00, 0x04, 0xfe, 0x05, 0xd5, 0x00, 0x1d,
-  0x00, 0x24, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17, 0x13, 0x23,
-  0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x11,
-  0x21, 0x32, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07, 0x14, 0x15, 0x14, 0x06,
-  0x2d, 0x01, 0x26, 0x27, 0x26, 0x27, 0x23, 0x11, 0x15, 0x33, 0x16, 0x37,
-  0x36, 0x37, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4, 0xac, 0x42, 0x7d,
-  0x6c, 0xc6, 0xb6, 0x8b, 0x26, 0xb1, 0x01, 0x9a, 0xe7, 0x71, 0x42, 0x1c,
-  0xd1, 0x27, 0xe5, 0x75, 0xfd, 0xc8, 0x01, 0xe3, 0x10, 0x28, 0x42, 0x85,
-  0xe4, 0xe4, 0x85, 0x42, 0x37, 0x0a, 0x02, 0xbc, 0x16, 0x90, 0x7e, 0xfe,
-  0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0x89, 0x03, 0x01, 0x33, 0x7f, 0x42,
-  0x02, 0x46, 0x6b, 0x3e, 0x64, 0x4e, 0x7f, 0x55, 0x0d, 0x0e, 0x8d, 0xba,
-  0xf2, 0xb3, 0x3f, 0x28, 0x42, 0x01, 0xfe, 0x16, 0x28, 0x01, 0x44, 0x38,
-  0x63, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x02, 0xf6,
-  0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
-  0x1d, 0x01, 0x25, 0x17, 0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x11,
-  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x02, 0xf6, 0x1c, 0x42,
-  0x27, 0x8d, 0x96, 0x01, 0x86, 0x1e, 0xfe, 0x5c, 0xa7, 0x86, 0x1d, 0xa3,
-  0xa7, 0x34, 0xa8, 0x77, 0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11, 0xcb,
-  0xbe, 0x34, 0x90, 0x62, 0x9c, 0xfe, 0x54, 0x01, 0x6f, 0x32, 0x63, 0x3c,
-  0x02, 0x84, 0xae, 0x66, 0x63, 0x05, 0x05, 0x00, 0x00, 0x01, 0x00, 0x03,
-  0xff, 0xe3, 0x04, 0x8f, 0x05, 0xf0, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x15,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x25, 0x17,
-  0x05, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23, 0x22, 0x26, 0x27, 0x35,
-  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x05, 0x27,
-  0x25, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x03, 0xda,
-  0x67, 0xb8, 0x55, 0x95, 0xa1, 0x6b, 0x96, 0x4b, 0x01, 0xec, 0x26, 0xfe,
-  0xbd, 0x4f, 0x30, 0x61, 0xfe, 0xfb, 0xfd, 0x60, 0xd7, 0x73, 0x6f, 0xd4,
-  0x67, 0x9b, 0xaa, 0x7a, 0x8b, 0x57, 0xfe, 0x18, 0x26, 0x01, 0x41, 0x45,
-  0x2c, 0x5a, 0xfb, 0xdc, 0x5f, 0xc4, 0x05, 0xa4, 0xc5, 0x37, 0x36, 0x80,
-  0x76, 0x63, 0x65, 0x1f, 0x11, 0xb5, 0x7f, 0x77, 0x27, 0x38, 0x6c, 0xb6,
-  0xd9, 0xe0, 0x30, 0x2f, 0xd0, 0x45, 0x46, 0x88, 0x7e, 0x6e, 0x7c, 0x1f,
-  0x13, 0xb4, 0x7f, 0x77, 0x22, 0x2e, 0x60, 0xab, 0xc6, 0xe4, 0x26, 0x00,
-  0x00, 0x01, 0x00, 0x03, 0xff, 0xe3, 0x03, 0xbd, 0x04, 0x7b, 0x00, 0x2f,
-  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x1f, 0x01, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x2f, 0x01, 0x05, 0x27, 0x25, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x03, 0x30, 0x46, 0x97, 0x51, 0x7b, 0x7c, 0x59, 0x85, 0x28,
-  0x01, 0x8e, 0x1e, 0xfe, 0xf3, 0x44, 0x28, 0x49, 0x01, 0xde, 0xc2, 0x51,
-  0xb0, 0x61, 0x5c, 0xb2, 0x57, 0x75, 0x7e, 0x5b, 0x9a, 0x20, 0xfe, 0x7a,
-  0x1d, 0x01, 0x06, 0x38, 0x22, 0x45, 0xca, 0xb9, 0x5c, 0xa2, 0x04, 0x3f,
-  0xae, 0x28, 0x28, 0x54, 0x54, 0x40, 0x49, 0x21, 0x0a, 0x93, 0x63, 0x63,
-  0x20, 0x28, 0x4c, 0x89, 0x9c, 0xb6, 0x23, 0x23, 0xbe, 0x35, 0x35, 0x59,
-  0x51, 0x4b, 0x50, 0x25, 0x08, 0x90, 0x63, 0x61, 0x1b, 0x26, 0x4a, 0x83,
-  0x9e, 0xac, 0x1e, 0x00, 0x00, 0x01, 0xff, 0xa1, 0x00, 0x00, 0x05, 0x10,
-  0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x1d, 0x01, 0x23,
-  0x35, 0x34, 0x36, 0x3b, 0x01, 0x11, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11,
-  0x21, 0x11, 0x23, 0x01, 0x0f, 0x77, 0x6a, 0x8c, 0xac, 0xc1, 0xb6, 0x02,
-  0x94, 0xb6, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0x30, 0x01, 0x5e, 0x69, 0x31,
-  0x46, 0xb5, 0xa3, 0xfd, 0x9c, 0x02, 0x64, 0xfa, 0x2b, 0x02, 0xc7, 0xfd,
-  0x39, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x05, 0xf0,
-  0x04, 0x60, 0x12, 0x06, 0x03, 0xdc, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6b,
-  0x00, 0x00, 0x03, 0x70, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x03, 0x6f, 0xb5, 0xfd,
-  0xeb, 0x02, 0x15, 0xfd, 0xb1, 0x05, 0xd5, 0xfa, 0x2b, 0x02, 0xc9, 0xaa,
-  0x01, 0xb8, 0xaa, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x00, 0x00, 0x03, 0xa3,
-  0x05, 0xd5, 0x00, 0x08, 0x00, 0x13, 0x00, 0x00, 0x01, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x3b, 0x01, 0x13, 0x11, 0x23, 0x11, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x33, 0x02, 0xed, 0xe5, 0x7f, 0x8a, 0x8a, 0x7f, 0xe5,
-  0xb6, 0xb6, 0xe5, 0xe2, 0xe7, 0xe7, 0xe2, 0x05, 0x2f, 0x92, 0x86, 0x87,
-  0x92, 0x02, 0xd7, 0xfa, 0x2b, 0x02, 0x58, 0xe2, 0xdd, 0xdb, 0xe3, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x00, 0x0c,
-  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x01, 0x33, 0x01, 0x11, 0x33, 0x11,
-  0x21, 0x09, 0x01, 0xb5, 0xb0, 0x01, 0x5b, 0xb6, 0x01, 0x5b, 0xb1, 0xfe,
-  0xf1, 0xfe, 0xa8, 0xfe, 0xa9, 0x05, 0xd5, 0xfa, 0xe1, 0x04, 0x00, 0xfc,
-  0x00, 0x05, 0x1f, 0xfa, 0x2b, 0x03, 0xf8, 0xfc, 0x08, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6b, 0x07, 0x6d, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0xb5, 0xb6, 0xb6, 0x07, 0x6d, 0xf8,
-  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x08, 0x67,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x01, 0x33, 0x09, 0x01, 0x33,
-  0x01, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x01, 0x33, 0x03, 0x8f,
-  0x01, 0x1e, 0xcc, 0x01, 0x1b, 0x01, 0x1a, 0xb8, 0xfe, 0xaf, 0xe5, 0xfe,
-  0xe4, 0xfe, 0xe2, 0xcc, 0xfe, 0xe5, 0xfe, 0xe7, 0xb9, 0x01, 0x52, 0xe4,
-  0xc5, 0x05, 0x10, 0xfb, 0x12, 0x04, 0xee, 0xfa, 0x2b, 0x05, 0x10, 0xfa,
-  0xf0, 0x04, 0xee, 0xfb, 0x12, 0x05, 0xd5, 0x00, 0x00, 0x01, 0x00, 0xae,
-  0x04, 0xd0, 0x02, 0x53, 0x05, 0x58, 0x00, 0x03, 0x00, 0x00, 0x01, 0x21,
-  0x35, 0x21, 0x02, 0x53, 0xfe, 0x5c, 0x01, 0xa4, 0x04, 0xd0, 0x88, 0x00,
-  0x00, 0x01, 0x00, 0x7e, 0x03, 0x9c, 0x02, 0x77, 0x05, 0x58, 0x00, 0x04,
-  0x00, 0x00, 0x13, 0x27, 0x01, 0x33, 0x15, 0xc1, 0x42, 0x01, 0xd4, 0x24,
-  0x03, 0x9c, 0x73, 0x01, 0x49, 0x88, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0x02, 0x68, 0x02, 0x9a, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
-  0x01, 0x27, 0x01, 0x33, 0x02, 0x9a, 0x0e, 0xfe, 0x35, 0x5e, 0x01, 0xf0,
-  0x47, 0x04, 0xd0, 0xfd, 0x98, 0x57, 0x02, 0x99, 0x00, 0x01, 0x00, 0x56,
-  0x01, 0x34, 0x02, 0xa7, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
-  0x01, 0x27, 0x01, 0x33, 0x02, 0xa7, 0x0d, 0xfe, 0x27, 0x6b, 0x01, 0xfd,
-  0x54, 0x04, 0xd0, 0xfc, 0x64, 0x44, 0x03, 0xe0, 0x00, 0x01, 0x00, 0x51,
-  0x00, 0x00, 0x02, 0xad, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
-  0x01, 0x27, 0x01, 0x33, 0x02, 0xad, 0x0a, 0xfe, 0x1e, 0x70, 0x02, 0x02,
-  0x5a, 0x04, 0xd0, 0xfb, 0x30, 0x37, 0x05, 0x21, 0x00, 0x01, 0x00, 0x7e,
-  0x03, 0x9c, 0x02, 0x77, 0x05, 0x58, 0x00, 0x04, 0x00, 0x00, 0x13, 0x01,
-  0x15, 0x23, 0x01, 0xc1, 0x01, 0xb6, 0x24, 0xfe, 0x2c, 0x05, 0x58, 0xfe,
-  0xcc, 0x88, 0x01, 0x49, 0xff, 0xff, 0x00, 0xae, 0x03, 0x9c, 0x02, 0x53,
-  0x04, 0x24, 0x10, 0x07, 0x0e, 0xa9, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x7e, 0x02, 0x68, 0x02, 0x77, 0x04, 0x24, 0x10, 0x07,
-  0x0e, 0xaa, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
-  0x01, 0x34, 0x02, 0x9a, 0x04, 0x24, 0x10, 0x07, 0x0e, 0xab, 0x00, 0x00,
-  0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x56, 0x00, 0x00, 0x02, 0xa7,
-  0x04, 0x24, 0x10, 0x07, 0x0e, 0xac, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x63, 0x02, 0x68, 0x02, 0x9a, 0x05, 0x58, 0x00, 0x05,
-  0x00, 0x00, 0x01, 0x15, 0x23, 0x01, 0x37, 0x01, 0x02, 0x9a, 0x47, 0xfe,
-  0x10, 0x5e, 0x01, 0xcb, 0x02, 0xf0, 0x88, 0x02, 0x99, 0x57, 0xfd, 0x98,
-  0xff, 0xff, 0x00, 0x7e, 0x02, 0x68, 0x02, 0x77, 0x04, 0x24, 0x10, 0x07,
-  0x0e, 0xae, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0xae,
-  0x02, 0x68, 0x02, 0x53, 0x02, 0xf0, 0x10, 0x07, 0x0e, 0xa9, 0x00, 0x00,
-  0xfd, 0x98, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e, 0x01, 0x34, 0x02, 0x77,
-  0x02, 0xf0, 0x10, 0x07, 0x0e, 0xaa, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0x00, 0x00, 0x02, 0x9a, 0x02, 0xf0, 0x10, 0x07,
-  0x0e, 0xab, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00, 0x00, 0x01, 0x00, 0x56,
-  0x01, 0x34, 0x02, 0xa7, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15,
-  0x23, 0x01, 0x37, 0x01, 0x02, 0xa7, 0x54, 0xfe, 0x03, 0x6b, 0x01, 0xd9,
-  0x01, 0xbc, 0x88, 0x03, 0xe0, 0x44, 0xfc, 0x64, 0xff, 0xff, 0x00, 0x63,
-  0x01, 0x34, 0x02, 0x9a, 0x04, 0x24, 0x10, 0x07, 0x0e, 0xb3, 0x00, 0x00,
-  0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e, 0x01, 0x34, 0x02, 0x77,
-  0x02, 0xf0, 0x10, 0x07, 0x0e, 0xae, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xae, 0x01, 0x34, 0x02, 0x53, 0x01, 0xbc, 0x10, 0x07,
-  0x0e, 0xa9, 0x00, 0x00, 0xfc, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e,
-  0x00, 0x00, 0x02, 0x77, 0x01, 0xbc, 0x10, 0x07, 0x0e, 0xaa, 0x00, 0x00,
-  0xfc, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51, 0x00, 0x00, 0x02, 0xad,
-  0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x25, 0x15, 0x23, 0x01, 0x37, 0x01,
-  0x02, 0xad, 0x5a, 0xfd, 0xfe, 0x70, 0x01, 0xe2, 0x88, 0x88, 0x05, 0x21,
-  0x37, 0xfb, 0x30, 0x00, 0xff, 0xff, 0x00, 0x56, 0x00, 0x00, 0x02, 0xa7,
-  0x04, 0x24, 0x10, 0x07, 0x0e, 0xb8, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x63, 0x00, 0x00, 0x02, 0x9a, 0x02, 0xf0, 0x10, 0x07,
-  0x0e, 0xb3, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e,
-  0x00, 0x00, 0x02, 0x77, 0x01, 0xbc, 0x10, 0x07, 0x0e, 0xae, 0x00, 0x00,
-  0xfc, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0xae, 0x00, 0x00, 0x02, 0x53,
-  0x00, 0x88, 0x11, 0x07, 0x0e, 0xa9, 0x00, 0x00, 0xfb, 0x30, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x01, 0x3b, 0x05, 0x58, 0x00, 0x03,
-  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0xc1, 0x7a, 0x05, 0x58, 0xfa, 0xa8,
-  0x00, 0x0e, 0x00, 0x87, 0x00, 0x00, 0x06, 0x81, 0x05, 0xdc, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
-  0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33,
-  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
-  0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
-  0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11,
-  0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
-  0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
-  0x06, 0x27, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01,
-  0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0xfe, 0x98, 0x5a,
-  0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7,
-  0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2,
-  0xfd, 0x44, 0x02, 0x4e, 0xfd, 0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88,
-  0x64, 0x64, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd,
-  0xad, 0x02, 0x4e, 0xfd, 0xb2, 0x02, 0xbc, 0x02, 0x4e, 0xfd, 0xb2, 0xfd,
-  0x44, 0x02, 0x4e, 0xfd, 0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88, 0x64,
-  0x64, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd, 0xad,
-  0x02, 0x4e, 0xfd, 0xb2, 0x00, 0x0e, 0x00, 0x87, 0x00, 0x00, 0x06, 0x81,
-  0x05, 0xdc, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13,
-  0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b,
-  0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
-  0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
-  0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
-  0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15,
-  0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15,
-  0x01, 0x11, 0x33, 0x11, 0x06, 0x27, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01,
-  0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7,
-  0x5a, 0xfe, 0x98, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11,
-  0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x03, 0x1b,
-  0x02, 0x58, 0xfd, 0xa8, 0xfd, 0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19,
-  0x64, 0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8,
-  0x5f, 0x64, 0x64, 0xfd, 0xa3, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0xbc, 0x02,
-  0x58, 0xfd, 0xa8, 0xfd, 0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19, 0x64,
-  0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8, 0x5f,
-  0x64, 0x64, 0xfd, 0xa3, 0x02, 0x58, 0xfd, 0xa8, 0x00, 0x0e, 0x00, 0x87,
-  0x00, 0x00, 0x06, 0x81, 0x05, 0xdc, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23,
-  0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15,
-  0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15,
-  0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
-  0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
-  0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x06, 0x27, 0x5a, 0x5a,
-  0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7, 0x5a,
-  0x01, 0xef, 0xfd, 0xb7, 0x5a, 0xfe, 0x98, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7,
-  0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd,
-  0xb7, 0x5a, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2, 0xfd, 0x44, 0x02, 0x4e,
-  0xfd, 0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x25,
-  0x02, 0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd, 0xad, 0x02, 0x4e, 0xfd,
-  0xb2, 0x02, 0xbc, 0x02, 0x4e, 0xfd, 0xb2, 0xfd, 0x44, 0x02, 0x4e, 0xfd,
-  0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x25, 0x02,
-  0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd, 0xad, 0x02, 0x4e, 0xfd, 0xb2,
-  0x00, 0x0e, 0x00, 0x87, 0x00, 0x00, 0x06, 0x81, 0x05, 0xdc, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
-  0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33,
-  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
-  0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
-  0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11,
-  0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
-  0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
-  0x06, 0x27, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01,
-  0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0xfe, 0x98, 0x5a,
-  0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7,
-  0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8,
-  0xfd, 0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19, 0x64, 0x64, 0xfa, 0x88,
-  0x64, 0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8, 0x5f, 0x64, 0x64, 0xfd,
-  0xa3, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0xbc, 0x02, 0x58, 0xfd, 0xa8, 0xfd,
-  0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19, 0x64, 0x64, 0xfa, 0x88, 0x64,
-  0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8, 0x5f, 0x64, 0x64, 0xfd, 0xa3,
-  0x02, 0x58, 0xfd, 0xa8, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb,
-  0x06, 0x9f, 0x00, 0x15, 0x00, 0x00, 0x01, 0x15, 0x10, 0x21, 0x20, 0x11,
-  0x35, 0x13, 0x33, 0x03, 0x15, 0x10, 0x21, 0x20, 0x11, 0x35, 0x34, 0x00,
-  0x11, 0x33, 0x16, 0x00, 0x03, 0xca, 0xfe, 0x56, 0xfe, 0x43, 0x35, 0xb4,
-  0x3e, 0x01, 0x12, 0x01, 0x08, 0xfe, 0x41, 0xa3, 0x01, 0x01, 0xbd, 0x02,
-  0xa1, 0x9f, 0xfd, 0xe0, 0x02, 0x25, 0x8b, 0x01, 0x09, 0xfe, 0xda, 0x73,
-  0xfe, 0x80, 0x01, 0x8a, 0xb8, 0xf9, 0x01, 0xcb, 0x01, 0x17, 0xc5, 0xfe,
-  0x07, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb,
-  0x06, 0x9f, 0x00, 0x09, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x12, 0x25, 0x04,
-  0x03, 0x15, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15, 0x10, 0x20, 0x11, 0x35,
-  0x10, 0x25, 0x33, 0x36, 0x27, 0x26, 0x27, 0x33, 0x14, 0x16, 0x07, 0x33,
-  0x04, 0x03, 0x28, 0x01, 0xfe, 0xe8, 0xfe, 0xfe, 0x01, 0x01, 0x09, 0x01,
-  0x11, 0xa2, 0xfc, 0x99, 0x01, 0x6b, 0x12, 0x2e, 0x78, 0x78, 0x02, 0xbb,
-  0xc4, 0x21, 0x12, 0x01, 0x3c, 0x02, 0x9d, 0x01, 0x67, 0x0b, 0x08, 0xfe,
-  0x82, 0x55, 0xfe, 0x4e, 0x01, 0xad, 0x4b, 0x37, 0xfd, 0x9f, 0x02, 0x61,
-  0x3c, 0x01, 0xeb, 0x3d, 0xa3, 0x51, 0x52, 0xb2, 0x6c, 0x9e, 0xf3, 0x45,
-  0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x04, 0x1b, 0x06, 0xb3, 0x00, 0x09,
-  0x00, 0x21, 0x00, 0x00, 0x01, 0x10, 0x21, 0x20, 0x11, 0x15, 0x10, 0x21,
-  0x20, 0x11, 0x37, 0x15, 0x10, 0x21, 0x20, 0x11, 0x35, 0x10, 0x25, 0x33,
-  0x36, 0x27, 0x36, 0x23, 0x22, 0x15, 0x23, 0x10, 0x21, 0x20, 0x03, 0x06,
-  0x07, 0x04, 0x03, 0x70, 0xfe, 0xd8, 0xfe, 0xc6, 0x01, 0x36, 0x01, 0x2c,
-  0xaa, 0xfe, 0x26, 0xfe, 0x23, 0x01, 0xd3, 0x55, 0x45, 0x02, 0x01, 0xab,
-  0xa4, 0x93, 0x01, 0x34, 0x01, 0x3a, 0x01, 0x0b, 0x3d, 0x01, 0x08, 0x02,
-  0x7e, 0x01, 0xa4, 0xfe, 0x62, 0x5f, 0xfe, 0x5d, 0x01, 0xa3, 0x61, 0x57,
-  0xfd, 0xb3, 0x02, 0x3e, 0x78, 0x01, 0xd6, 0x4e, 0x5c, 0x61, 0x9a, 0xc4,
-  0x01, 0x64, 0xfe, 0xc1, 0x8b, 0x55, 0x72, 0x00, 0x00, 0x02, 0x00, 0x63,
-  0x00, 0x00, 0x06, 0x04, 0x06, 0xb3, 0x00, 0x24, 0x00, 0x2e, 0x00, 0x00,
-  0x37, 0x36, 0x37, 0x00, 0x11, 0x35, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33,
-  0x20, 0x11, 0x15, 0x10, 0x05, 0x24, 0x11, 0x35, 0x34, 0x37, 0x26, 0x23,
-  0x22, 0x11, 0x15, 0x10, 0x01, 0x17, 0x04, 0x17, 0x23, 0x26, 0x27, 0x26,
-  0x07, 0x01, 0x10, 0x23, 0x22, 0x11, 0x15, 0x02, 0x17, 0x36, 0x13, 0xf2,
-  0x59, 0x73, 0xfe, 0xa5, 0x01, 0x8d, 0x98, 0x8f, 0x5b, 0xe8, 0x01, 0xaa,
-  0xfe, 0x56, 0xfe, 0x62, 0x23, 0x4b, 0x9c, 0xeb, 0x01, 0x7e, 0xbf, 0x01,
-  0x5f, 0x33, 0xee, 0x0c, 0xd6, 0xe8, 0xdc, 0x04, 0x11, 0xff, 0xf6, 0x01,
-  0xf7, 0xfe, 0x01, 0xc3, 0x4e, 0x21, 0x01, 0x56, 0x01, 0xc6, 0x6d, 0x01,
-  0xf8, 0xb3, 0xa9, 0xfd, 0xff, 0x95, 0xfd, 0xd2, 0x1e, 0x1c, 0x02, 0x30,
-  0x77, 0x5f, 0x8c, 0x9a, 0xfe, 0xb7, 0x63, 0xfe, 0x2d, 0xfe, 0xb1, 0x18,
-  0x53, 0xd6, 0x52, 0x40, 0x40, 0xb4, 0x04, 0x5d, 0x01, 0x8f, 0xfe, 0x9e,
-  0x9a, 0xfe, 0x77, 0x1d, 0x1c, 0x01, 0x6c, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe2, 0x03, 0xcb, 0x06, 0xb3, 0x00, 0x17, 0x00, 0x00, 0x01, 0x10,
-  0x21, 0x20, 0x1b, 0x01, 0x33, 0x03, 0x10, 0x21, 0x04, 0x19, 0x01, 0x34,
-  0x23, 0x22, 0x11, 0x17, 0x23, 0x03, 0x10, 0x21, 0x20, 0x11, 0x03, 0xca,
-  0xfe, 0x47, 0xfe, 0x52, 0x01, 0x51, 0xbb, 0x63, 0x01, 0x0a, 0x01, 0x1a,
-  0xff, 0xdb, 0x4b, 0xab, 0x3f, 0x01, 0x87, 0x01, 0x8b, 0x01, 0xc8, 0xfe,
-  0x1a, 0x01, 0xe9, 0x01, 0x2f, 0xfe, 0xd1, 0xfe, 0xb7, 0x01, 0x01, 0x4f,
-  0x03, 0x73, 0xd1, 0xfe, 0xff, 0xf6, 0x01, 0x0d, 0x01, 0x89, 0xfe, 0x8b,
-  0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb, 0x06, 0xb3, 0x00, 0x21,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x16, 0x1d, 0x01, 0x10, 0x20, 0x11, 0x13,
-  0x33, 0x03, 0x10, 0x21, 0x20, 0x11, 0x35, 0x34, 0x27, 0x23, 0x35, 0x33,
-  0x36, 0x03, 0x34, 0x23, 0x06, 0x07, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20,
-  0x03, 0xa6, 0x04, 0xb9, 0xe1, 0xfc, 0x99, 0x30, 0xb0, 0x36, 0x01, 0x0a,
-  0x01, 0x11, 0xab, 0x99, 0x52, 0xc6, 0x02, 0xe2, 0xe9, 0x02, 0x21, 0xa8,
-  0x16, 0x01, 0x88, 0x01, 0x8e, 0x05, 0x1b, 0xe6, 0x7c, 0x73, 0xfe, 0x7d,
-  0xfe, 0x17, 0x02, 0x01, 0x01, 0x17, 0xfe, 0xe0, 0xfe, 0xa8, 0x01, 0x4e,
-  0x73, 0xcd, 0x28, 0xa9, 0x50, 0x01, 0x0a, 0xda, 0x01, 0xf5, 0x9a, 0x9e,
-  0x01, 0x90, 0x00, 0x00, 0x00, 0x03, 0x00, 0x63, 0xff, 0xe2, 0x04, 0x51,
-  0x06, 0xb3, 0x00, 0x09, 0x00, 0x13, 0x00, 0x26, 0x00, 0x00, 0x01, 0x12,
-  0x07, 0x22, 0x15, 0x14, 0x17, 0x36, 0x37, 0x33, 0x01, 0x10, 0x21, 0x20,
-  0x11, 0x15, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15, 0x10, 0x21, 0x20, 0x11,
-  0x35, 0x34, 0x37, 0x26, 0x35, 0x10, 0x21, 0x20, 0x11, 0x14, 0x07, 0x33,
-  0x04, 0x02, 0x89, 0x02, 0xc1, 0xbc, 0x5e, 0x5b, 0xad, 0x10, 0x01, 0x1e,
-  0xfe, 0xe7, 0xfe, 0xd5, 0x01, 0x26, 0x01, 0x1e, 0xae, 0xfe, 0x33, 0xfe,
-  0x30, 0x5b, 0xab, 0x01, 0x5e, 0x01, 0x69, 0x0b, 0x0a, 0x01, 0x27, 0x04,
-  0xde, 0x01, 0x36, 0x01, 0xdf, 0xb4, 0x5f, 0x63, 0x09, 0xfd, 0xe5, 0x01,
-  0x88, 0xfe, 0x76, 0x4b, 0xfe, 0x5d, 0x01, 0x9b, 0x58, 0x4b, 0xfd, 0xb8,
-  0x02, 0x52, 0x46, 0x8d, 0xbc, 0x94, 0xce, 0x01, 0x8e, 0xfe, 0x2e, 0x25,
-  0x40, 0x7f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x05, 0xf7,
-  0x06, 0xb3, 0x00, 0x09, 0x00, 0x22, 0x00, 0x00, 0x01, 0x10, 0x23, 0x22,
-  0x19, 0x01, 0x10, 0x33, 0x32, 0x11, 0x25, 0x02, 0x03, 0x23, 0x36, 0x13,
-  0x11, 0x10, 0x23, 0x22, 0x03, 0x11, 0x10, 0x21, 0x20, 0x19, 0x01, 0x10,
-  0x21, 0x36, 0x17, 0x36, 0x33, 0x20, 0x13, 0x02, 0xf5, 0xf2, 0xf8, 0xf8,
-  0xf2, 0x03, 0x01, 0x09, 0xb7, 0xef, 0xee, 0x15, 0xda, 0xc2, 0x11, 0xfe,
-  0x5d, 0xfe, 0x69, 0x01, 0xa0, 0xc9, 0x86, 0x68, 0xde, 0x01, 0x5d, 0x01,
-  0x04, 0x92, 0x01, 0x82, 0xfe, 0x7e, 0xfd, 0x93, 0xfe, 0x5c, 0x01, 0xa4,
-  0x9b, 0xfe, 0x46, 0xfe, 0xfa, 0xe5, 0x01, 0xdb, 0x01, 0xd2, 0x01, 0x79,
-  0xfe, 0xed, 0xfd, 0x2d, 0xfd, 0xbd, 0x02, 0x43, 0x02, 0x6d, 0x02, 0x21,
-  0x02, 0xe6, 0xda, 0xfd, 0xe9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0x00, 0x00, 0x03, 0x9d, 0x06, 0xb3, 0x00, 0x15, 0x00, 0x00, 0x01, 0x10,
-  0x03, 0x23, 0x12, 0x19, 0x01, 0x10, 0x23, 0x20, 0x19, 0x01, 0x10, 0x13,
-  0x23, 0x02, 0x19, 0x01, 0x10, 0x21, 0x20, 0x11, 0x03, 0x9c, 0x8b, 0xb2,
-  0x93, 0xdc, 0xfe, 0xf8, 0x9d, 0xb4, 0x94, 0x01, 0xb3, 0x01, 0x86, 0x02,
-  0xfb, 0xfe, 0x8a, 0xfe, 0x7b, 0x01, 0x43, 0x01, 0xb8, 0x01, 0x9a, 0x01,
-  0x7e, 0xfe, 0x82, 0xfe, 0x66, 0xfe, 0x53, 0xfe, 0xb2, 0x01, 0x79, 0x01,
-  0x82, 0x01, 0x9a, 0x02, 0x1e, 0xfd, 0xe2, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe2, 0x03, 0xcb, 0x06, 0xa0, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x02,
-  0x21, 0x20, 0x11, 0x13, 0x33, 0x03, 0x10, 0x05, 0x20, 0x11, 0x35, 0x10,
-  0x2b, 0x01, 0x35, 0x33, 0x36, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x10,
-  0x07, 0x16, 0x11, 0x03, 0xca, 0x01, 0xfe, 0x4e, 0xfe, 0x4c, 0x27, 0xb9,
-  0x36, 0x01, 0x0a, 0x01, 0x11, 0xbd, 0xc6, 0x9e, 0xe5, 0xb4, 0xfc, 0x5a,
-  0xe1, 0xe1, 0x01, 0xc6, 0xfe, 0x1c, 0x01, 0xf3, 0x01, 0x24, 0xfe, 0xdc,
-  0xfe, 0xae, 0x01, 0x01, 0x44, 0x78, 0x01, 0x3c, 0xa8, 0x81, 0xaf, 0x95,
-  0xb9, 0xbe, 0x6d, 0xfe, 0xf7, 0x64, 0x63, 0xfe, 0x9e, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x63, 0x00, 0x00, 0x08, 0x07, 0x06, 0xb3, 0x00, 0x35,
-  0x00, 0x00, 0x25, 0x36, 0x37, 0x24, 0x03, 0x35, 0x10, 0x21, 0x32, 0x17,
-  0x36, 0x20, 0x17, 0x36, 0x33, 0x20, 0x11, 0x15, 0x14, 0x03, 0x23, 0x12,
-  0x3d, 0x01, 0x12, 0x23, 0x22, 0x15, 0x11, 0x23, 0x11, 0x10, 0x23, 0x06,
-  0x15, 0x11, 0x23, 0x11, 0x26, 0x23, 0x22, 0x11, 0x15, 0x12, 0x05, 0x36,
-  0x17, 0x04, 0x13, 0x21, 0x26, 0x25, 0x24, 0x01, 0x01, 0x3a, 0x68, 0x82,
-  0xfe, 0x6a, 0x2b, 0x01, 0x8b, 0xd1, 0x65, 0x5a, 0x01, 0x74, 0x62, 0x55,
-  0xdb, 0x01, 0x83, 0xc9, 0xb8, 0xe2, 0x01, 0xe3, 0xe7, 0x9b, 0xcc, 0xc5,
-  0x9c, 0x02, 0xe8, 0xdf, 0x28, 0x01, 0x87, 0x6e, 0x81, 0x01, 0xda, 0xf6,
-  0xfe, 0xef, 0x24, 0xfe, 0xbd, 0xfe, 0xbe, 0xfe, 0xe9, 0xa6, 0x78, 0x43,
-  0xf3, 0x01, 0xf0, 0x7b, 0x01, 0xeb, 0xb2, 0xbb, 0xbb, 0xb2, 0xfe, 0x1f,
-  0x67, 0xba, 0xfe, 0x64, 0x01, 0xb1, 0xc8, 0x3f, 0x01, 0x47, 0xe7, 0xfe,
-  0x5a, 0x01, 0xa6, 0x01, 0x00, 0x02, 0xfe, 0xfe, 0x5a, 0x01, 0xa6, 0xe7,
-  0xfe, 0xb7, 0x79, 0xfe, 0x41, 0xe9, 0x17, 0x0b, 0x23, 0xfe, 0x76, 0xa5,
-  0x5c, 0x5b, 0xfe, 0xc3, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9,
-  0x06, 0xb3, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x11, 0x26, 0x27,
-  0x20, 0x11, 0x15, 0x10, 0x05, 0x20, 0x13, 0x10, 0x21, 0x20, 0x11, 0x35,
-  0x10, 0x25, 0x32, 0x17, 0x35, 0x34, 0x21, 0x22, 0x06, 0x15, 0x23, 0x10,
-  0x21, 0x20, 0x11, 0x03, 0x30, 0x5f, 0xa6, 0xfe, 0xe3, 0x01, 0x1b, 0x01,
-  0x07, 0x98, 0xfe, 0x61, 0xfe, 0x3a, 0x01, 0xb3, 0x8e, 0x8d, 0xfe, 0xfe,
-  0x8a, 0x6f, 0xa1, 0x01, 0x8e, 0x01, 0xa5, 0x01, 0xda, 0x01, 0xcb, 0x3f,
-  0x01, 0xfe, 0xc1, 0xb8, 0xfe, 0x95, 0x01, 0x01, 0x62, 0xfd, 0xfe, 0x02,
-  0x02, 0xae, 0x01, 0xee, 0x14, 0x4a, 0xd1, 0xf9, 0x71, 0x6c, 0x01, 0x7c,
-  0xfe, 0x63, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75, 0xff, 0xe2, 0x03, 0xdd,
-  0x06, 0xa0, 0x00, 0x09, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x10, 0x21, 0x22,
-  0x07, 0x11, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15, 0x10, 0x21, 0x20, 0x19,
-  0x01, 0x10, 0x29, 0x01, 0x15, 0x21, 0x22, 0x1d, 0x01, 0x36, 0x33, 0x20,
-  0x03, 0x3a, 0xfe, 0xe8, 0x97, 0x74, 0x01, 0x16, 0x01, 0x0d, 0xa2, 0xfe,
-  0x46, 0xfe, 0x53, 0x01, 0x2f, 0x01, 0xd0, 0xfe, 0x35, 0x9b, 0x98, 0x7e,
-  0x01, 0xb8, 0x02, 0xab, 0x01, 0x4f, 0x4b, 0xfe, 0x26, 0xfe, 0xad, 0x01,
-  0x44, 0xfe, 0xfa, 0xfe, 0x18, 0x01, 0xe8, 0x03, 0x54, 0x01, 0x82, 0xa0,
-  0xe6, 0xc7, 0x55, 0x00, 0x00, 0x01, 0x00, 0x63, 0x00, 0x00, 0x05, 0xdf,
-  0x06, 0xb3, 0x00, 0x20, 0x00, 0x00, 0x01, 0x10, 0x01, 0x23, 0x00, 0x19,
-  0x01, 0x10, 0x23, 0x22, 0x19, 0x01, 0x23, 0x11, 0x10, 0x23, 0x22, 0x19,
-  0x01, 0x10, 0x01, 0x23, 0x00, 0x19, 0x01, 0x10, 0x21, 0x32, 0x17, 0x36,
-  0x33, 0x20, 0x11, 0x05, 0xdf, 0xfe, 0xe6, 0xc9, 0x01, 0x3b, 0xf3, 0xce,
-  0xa5, 0xef, 0xd3, 0x01, 0x1e, 0xc1, 0xfe, 0xf7, 0x01, 0x91, 0xc8, 0x6c,
-  0x75, 0xa7, 0x01, 0x9b, 0x02, 0xc2, 0xfe, 0x66, 0xfe, 0xd8, 0x01, 0x6e,
-  0x01, 0x55, 0x01, 0xcf, 0x01, 0x83, 0xfe, 0xcf, 0xfd, 0x82, 0x02, 0x87,
-  0x01, 0x28, 0xfe, 0x7d, 0xfe, 0x31, 0xfe, 0xa7, 0xfe, 0x96, 0x01, 0x28,
-  0x01, 0x9b, 0x01, 0xcf, 0x02, 0x21, 0xf0, 0xf0, 0xfd, 0xdf, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb, 0x06, 0x9f, 0x00, 0x1e,
-  0x00, 0x00, 0x01, 0x15, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10,
-  0x21, 0x20, 0x11, 0x35, 0x34, 0x27, 0x23, 0x35, 0x33, 0x36, 0x35, 0x34,
-  0x24, 0x35, 0x33, 0x14, 0x04, 0x15, 0x14, 0x07, 0x16, 0x03, 0xca, 0xfe,
-  0x5f, 0xfe, 0x3a, 0x12, 0xb3, 0x1a, 0x01, 0x16, 0x01, 0x04, 0x9e, 0xc4,
-  0x67, 0xe9, 0xfe, 0x87, 0xc6, 0x01, 0x55, 0xd3, 0xe5, 0x01, 0xd7, 0x25,
-  0xfe, 0x30, 0x01, 0xdf, 0xb3, 0xb3, 0xfe, 0xc1, 0x01, 0x3f, 0x43, 0xc0,
-  0x2d, 0xb6, 0x3f, 0xb0, 0xa3, 0x72, 0xf4, 0x96, 0x8e, 0xdd, 0xb2, 0x79,
-  0x6e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xca,
-  0x06, 0xc1, 0x00, 0x16, 0x00, 0x00, 0x01, 0x10, 0x25, 0x20, 0x11, 0x33,
-  0x10, 0x21, 0x20, 0x19, 0x01, 0x05, 0x04, 0x15, 0x10, 0x25, 0x35, 0x04,
-  0x27, 0x36, 0x25, 0x35, 0x25, 0x03, 0xc9, 0xfe, 0x49, 0xfe, 0x51, 0xab,
-  0x01, 0x04, 0x01, 0x14, 0xfe, 0x0f, 0x01, 0x3d, 0xfd, 0xf2, 0x01, 0x78,
-  0x01, 0x02, 0xfe, 0x87, 0x03, 0x65, 0x01, 0xd1, 0xfe, 0x0f, 0x02, 0x02,
-  0x4a, 0xfe, 0x56, 0x01, 0x4f, 0x04, 0x3b, 0x32, 0x78, 0xd6, 0xfe, 0x7d,
-  0x02, 0xb2, 0x02, 0xce, 0xb0, 0x5f, 0xa7, 0x82, 0x00, 0x01, 0x00, 0x63,
-  0x00, 0x00, 0x06, 0x31, 0x06, 0xb3, 0x00, 0x26, 0x00, 0x00, 0x01, 0x15,
-  0x10, 0x01, 0x23, 0x00, 0x11, 0x35, 0x10, 0x27, 0x22, 0x03, 0x11, 0x23,
-  0x11, 0x10, 0x23, 0x22, 0x11, 0x15, 0x10, 0x01, 0x23, 0x00, 0x11, 0x35,
-  0x10, 0x37, 0x36, 0x21, 0x15, 0x24, 0x03, 0x37, 0x32, 0x17, 0x36, 0x33,
-  0x20, 0x06, 0x31, 0xfe, 0xc5, 0xd7, 0x01, 0x60, 0xeb, 0xf0, 0x01, 0xad,
-  0xfe, 0xea, 0x01, 0x6c, 0xd4, 0xfe, 0xbd, 0xf8, 0xfa, 0x02, 0x82, 0xfd,
-  0x41, 0x9f, 0x71, 0xef, 0x7c, 0x69, 0xc6, 0x01, 0xac, 0x03, 0x1e, 0x7c,
-  0xfe, 0x62, 0xfe, 0xfc, 0x01, 0x62, 0x01, 0x49, 0x8c, 0x01, 0x4b, 0x02,
-  0xfe, 0xd7, 0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x28, 0xfe, 0xb4, 0x95, 0xfe,
-  0xc1, 0xfe, 0x9d, 0x01, 0x04, 0x01, 0x9e, 0x77, 0x01, 0xa3, 0xfc, 0xfb,
-  0xa0, 0x01, 0xfe, 0xd8, 0x34, 0xf4, 0xf4, 0x00, 0x00, 0x01, 0x00, 0x75,
-  0xff, 0xe2, 0x03, 0xdd, 0x06, 0x9f, 0x00, 0x15, 0x00, 0x00, 0x01, 0x15,
-  0x10, 0x21, 0x20, 0x19, 0x01, 0x33, 0x11, 0x10, 0x21, 0x20, 0x11, 0x35,
-  0x34, 0x02, 0x27, 0x37, 0x33, 0x07, 0x14, 0x12, 0x03, 0xdc, 0xfe, 0x46,
-  0xfe, 0x53, 0xa2, 0x01, 0x0d, 0x01, 0x16, 0xe3, 0x02, 0x28, 0xb4, 0x42,
-  0xed, 0x02, 0x07, 0x2d, 0xfe, 0x08, 0x02, 0x52, 0x04, 0x6b, 0xfb, 0x6d,
-  0xfe, 0x76, 0x01, 0x49, 0x4b, 0xb3, 0x01, 0x26, 0x99, 0xd9, 0xe6, 0x7c,
-  0xfe, 0xfb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x04, 0xe0,
-  0x06, 0xb3, 0x00, 0x24, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x07, 0x11, 0x16,
-  0x12, 0x33, 0x32, 0x12, 0x35, 0x11, 0x34, 0x02, 0x27, 0x23, 0x13, 0x23,
-  0x13, 0x35, 0x33, 0x15, 0x33, 0x04, 0x12, 0x07, 0x11, 0x16, 0x00, 0x21,
-  0x20, 0x00, 0x35, 0x11, 0x34, 0x12, 0x37, 0x01, 0xd6, 0x77, 0x4f, 0x02,
-  0x01, 0xbc, 0xd9, 0xd7, 0xb9, 0xc1, 0x83, 0x11, 0x12, 0xa8, 0x12, 0x84,
-  0x11, 0x01, 0x0f, 0xe1, 0x01, 0x01, 0xfe, 0xf5, 0xfe, 0xcb, 0xfe, 0xdd,
-  0xfe, 0xe6, 0xad, 0xc6, 0x05, 0xa7, 0x2f, 0xf0, 0xb3, 0xfe, 0xbd, 0x98,
-  0xfe, 0x88, 0x01, 0x77, 0x99, 0x01, 0x40, 0xb6, 0x01, 0x44, 0x02, 0xfc,
-  0xed, 0x03, 0x11, 0xe7, 0x44, 0x5c, 0xfe, 0x75, 0xb1, 0xfe, 0xb6, 0xd1,
-  0xfe, 0x26, 0x01, 0xd6, 0xd5, 0x01, 0x49, 0xb0, 0x01, 0x8d, 0x52, 0x00,
-  0x00, 0x01, 0x00, 0x2d, 0xff, 0xe1, 0x03, 0xbd, 0x06, 0xb3, 0x00, 0x1e,
-  0x00, 0x00, 0x01, 0x12, 0x21, 0x20, 0x03, 0x13, 0x33, 0x03, 0x10, 0x21,
-  0x20, 0x19, 0x01, 0x26, 0x23, 0x22, 0x17, 0x11, 0x23, 0x11, 0x26, 0x27,
-  0x23, 0x35, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11, 0x03, 0xbd, 0x01,
-  0xfe, 0x62, 0xfe, 0x3a, 0x04, 0x33, 0xb7, 0x3e, 0x01, 0x22, 0x01, 0x01,
-  0x01, 0xaf, 0x96, 0x02, 0x8f, 0x12, 0x8f, 0x84, 0x7e, 0x8b, 0x44, 0x5e,
-  0x99, 0x01, 0x4c, 0x01, 0xee, 0xfd, 0xf3, 0x01, 0xea, 0x01, 0x2e, 0xfe,
-  0xd7, 0xfe, 0xb2, 0x01, 0x35, 0x03, 0xb4, 0xa9, 0x54, 0xfe, 0x68, 0x01,
-  0x4d, 0x8c, 0x13, 0x9f, 0x9f, 0x9f, 0xfe, 0x86, 0x00, 0x02, 0x00, 0x63,
-  0xff, 0xe2, 0x05, 0xe5, 0x06, 0xb3, 0x00, 0x09, 0x00, 0x37, 0x00, 0x00,
-  0x01, 0x10, 0x23, 0x22, 0x11, 0x15, 0x10, 0x33, 0x32, 0x11, 0x01, 0x14,
-  0x00, 0x2b, 0x01, 0x22, 0x24, 0x35, 0x33, 0x14, 0x16, 0x3b, 0x01, 0x32,
-  0x36, 0x35, 0x10, 0x2b, 0x01, 0x35, 0x37, 0x36, 0x35, 0x10, 0x23, 0x22,
-  0x07, 0x16, 0x07, 0x15, 0x10, 0x25, 0x04, 0x11, 0x35, 0x10, 0x21, 0x32,
-  0x17, 0x36, 0x33, 0x20, 0x11, 0x10, 0x07, 0x16, 0x02, 0xf2, 0xf6, 0xee,
-  0xfa, 0xea, 0x02, 0xe0, 0xfe, 0xdf, 0xfb, 0x5a, 0xbb, 0xfe, 0xd6, 0xb7,
-  0xc4, 0x75, 0x43, 0xb2, 0xd1, 0x73, 0x6f, 0x35, 0xbf, 0xef, 0x77, 0x64,
-  0x22, 0x03, 0xfe, 0x75, 0xfe, 0x5a, 0x01, 0x96, 0xe4, 0x62, 0x7e, 0xa8,
-  0x01, 0x7f, 0xd4, 0xc2, 0x04, 0x9e, 0x01, 0x76, 0xfe, 0x8f, 0x8b, 0xfe,
-  0x79, 0x01, 0x87, 0xfd, 0xc0, 0xd4, 0xfe, 0xde, 0xd9, 0x81, 0x3b, 0x80,
-  0xcd, 0x89, 0x01, 0x01, 0x97, 0x02, 0x89, 0xdf, 0x01, 0x35, 0x80, 0x70,
-  0x94, 0x72, 0xfd, 0xd7, 0x01, 0x01, 0x02, 0x29, 0x8b, 0x02, 0x10, 0xc7,
-  0xc1, 0xfe, 0x5a, 0xfe, 0xe5, 0x92, 0x7b, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe2, 0x03, 0xca, 0x06, 0x9f, 0x00, 0x19, 0x00, 0x00, 0x01, 0x10,
-  0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x21, 0x20, 0x19, 0x01, 0x02,
-  0x27, 0x06, 0x07, 0x13, 0x23, 0x27, 0x10, 0x05, 0x32, 0x13, 0x11, 0x33,
-  0x03, 0xc9, 0xfe, 0x47, 0xfe, 0x53, 0x31, 0xb8, 0x3e, 0x01, 0x04, 0x01,
-  0x1f, 0xbb, 0xa2, 0xb0, 0x01, 0x3b, 0xa1, 0x36, 0x01, 0x49, 0x9a, 0xc7,
-  0x98, 0x01, 0xca, 0xfe, 0x18, 0x01, 0xe8, 0xdd, 0xdc, 0xfe, 0xb7, 0x01,
-  0x4e, 0x02, 0x24, 0x01, 0xb2, 0x02, 0x01, 0xa8, 0xfe, 0xff, 0xf9, 0x01,
-  0x5e, 0x02, 0xfe, 0xaa, 0x01, 0xa2, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe2, 0x06, 0x0f, 0x06, 0xb3, 0x00, 0x2a, 0x00, 0x00, 0x37, 0x36,
-  0x37, 0x00, 0x11, 0x35, 0x10, 0x21, 0x32, 0x13, 0x12, 0x33, 0x20, 0x13,
-  0x15, 0x06, 0x03, 0x23, 0x12, 0x3d, 0x01, 0x10, 0x23, 0x22, 0x19, 0x01,
-  0x23, 0x11, 0x10, 0x20, 0x13, 0x15, 0x02, 0x01, 0x16, 0x17, 0x04, 0x17,
-  0x23, 0x26, 0x27, 0x26, 0x05, 0xe3, 0x6c, 0x8a, 0xfe, 0x8a, 0x01, 0x99,
-  0xc3, 0x7b, 0x6c, 0xcf, 0x01, 0x99, 0x01, 0x02, 0x9e, 0xce, 0xc1, 0xe9,
-  0xf4, 0x9a, 0xfe, 0x21, 0x02, 0x01, 0x01, 0x88, 0x6a, 0x4b, 0x01, 0x7a,
-  0x33, 0xee, 0x03, 0xe3, 0xf6, 0xfe, 0xfc, 0xb1, 0x62, 0x22, 0x01, 0x1c,
-  0x02, 0x20, 0x4b, 0x01, 0xf7, 0xfe, 0xf9, 0x01, 0x07, 0xfe, 0x20, 0x61,
-  0xeb, 0xfe, 0x94, 0x01, 0x60, 0xf2, 0x54, 0x01, 0x54, 0xfe, 0x72, 0xfe,
-  0xc0, 0x01, 0x40, 0x01, 0x8d, 0xfe, 0xa8, 0x6d, 0xfe, 0x4d, 0xfe, 0xad,
-  0x04, 0x12, 0x70, 0xe1, 0x52, 0x63, 0x45, 0xbe, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe2, 0x03, 0xc9, 0x06, 0xa1, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x10,
-  0x21, 0x20, 0x11, 0x13, 0x33, 0x03, 0x10, 0x21, 0x20, 0x19, 0x01, 0x06,
-  0x07, 0x04, 0x11, 0x35, 0x34, 0x37, 0x33, 0x06, 0x1d, 0x01, 0x10, 0x17,
-  0x36, 0x37, 0x11, 0x33, 0x03, 0xc8, 0xfe, 0x4a, 0xfe, 0x51, 0x1b, 0xaf,
-  0x1f, 0x01, 0x04, 0x01, 0x1f, 0x94, 0x82, 0xfe, 0x63, 0x82, 0xca, 0xa1,
-  0xe9, 0x94, 0x8b, 0x97, 0x01, 0xc5, 0xfe, 0x1d, 0x01, 0xbb, 0x01, 0x09,
-  0xfe, 0xf3, 0xfe, 0xe9, 0x01, 0x44, 0x01, 0xf8, 0x63, 0x0b, 0x02, 0x01,
-  0xb9, 0x28, 0xa9, 0xc9, 0xd4, 0x94, 0x28, 0xfe, 0xda, 0x01, 0x0a, 0x74,
-  0x02, 0x39, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9,
-  0x06, 0xb3, 0x00, 0x08, 0x00, 0x23, 0x00, 0x00, 0x01, 0x11, 0x26, 0x23,
-  0x20, 0x11, 0x15, 0x02, 0x20, 0x13, 0x10, 0x21, 0x20, 0x11, 0x35, 0x12,
-  0x21, 0x16, 0x17, 0x11, 0x34, 0x23, 0x22, 0x1d, 0x01, 0x23, 0x35, 0x34,
-  0x23, 0x35, 0x20, 0x17, 0x36, 0x33, 0x20, 0x11, 0x03, 0x31, 0x67, 0xb3,
-  0xfe, 0xf8, 0x01, 0x02, 0x23, 0x97, 0xfe, 0x60, 0xfe, 0x3b, 0x01, 0x01,
-  0xb3, 0x7a, 0xa0, 0x9c, 0xa1, 0x94, 0xfd, 0x01, 0x00, 0x30, 0x4d, 0xbe,
-  0x01, 0x2a, 0x01, 0xcb, 0x01, 0xc6, 0x49, 0xfe, 0x90, 0x72, 0xfe, 0x8a,
-  0x01, 0x5d, 0xfe, 0x03, 0x02, 0x0c, 0x90, 0x01, 0xf9, 0x02, 0x3d, 0x01,
-  0x60, 0x7c, 0xb4, 0x3a, 0x3a, 0xb4, 0x9f, 0xc0, 0xc0, 0xfe, 0xb3, 0x00,
-  0x00, 0x01, 0x00, 0x75, 0x00, 0x00, 0x03, 0xdd, 0x06, 0xb3, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x37, 0x34, 0x23, 0x22, 0x11, 0x15, 0x36, 0x17, 0x04,
-  0x03, 0x15, 0x10, 0x03, 0x23, 0x12, 0x3d, 0x01, 0x10, 0x05, 0x26, 0x07,
-  0x11, 0x23, 0x11, 0x02, 0x21, 0x20, 0x13, 0x07, 0x02, 0x4e, 0x0e, 0x95,
-  0xb0, 0x9d, 0x8b, 0x01, 0x9e, 0x01, 0xad, 0xc6, 0xd1, 0xfe, 0xf8, 0x74,
-  0xa7, 0xa1, 0x01, 0x01, 0x33, 0x01, 0x59, 0x01, 0x12, 0x05, 0x0e, 0x92,
-  0x75, 0xfe, 0xe6, 0xe1, 0x68, 0x04, 0x01, 0xfe, 0x3d, 0x5e, 0xfe, 0xfd,
-  0xfe, 0xa7, 0x01, 0x75, 0xb0, 0xae, 0x01, 0x13, 0x01, 0x01, 0x62, 0xfc,
-  0x7c, 0x04, 0xf0, 0x01, 0xc3, 0xfe, 0xed, 0x92, 0x00, 0x01, 0x00, 0x64,
-  0xff, 0xe2, 0x04, 0x4a, 0x06, 0xa0, 0x00, 0x23, 0x00, 0x00, 0x01, 0x16,
-  0x07, 0x04, 0x11, 0x10, 0x02, 0x20, 0x00, 0x19, 0x01, 0x02, 0x13, 0x33,
-  0x02, 0x15, 0x11, 0x1a, 0x01, 0x17, 0x32, 0x12, 0x35, 0x26, 0x2b, 0x01,
-  0x35, 0x33, 0x36, 0x35, 0x34, 0x24, 0x37, 0x33, 0x14, 0x04, 0x04, 0x1c,
-  0x02, 0xdf, 0x01, 0x0a, 0xff, 0xfe, 0x35, 0xfe, 0xe6, 0x02, 0x67, 0xc1,
-  0x79, 0x01, 0xb8, 0x9a, 0x9d, 0x9b, 0x03, 0xac, 0xbd, 0x51, 0xee, 0xff,
-  0x00, 0x01, 0xa5, 0x01, 0x07, 0x05, 0x07, 0xae, 0x8c, 0x7b, 0xfe, 0xf6,
-  0xfe, 0xe2, 0xfe, 0xb8, 0x01, 0x48, 0x01, 0x70, 0x01, 0x9d, 0x01, 0x2c,
-  0x01, 0x3d, 0xfe, 0x8b, 0xf4, 0xfe, 0x63, 0xfe, 0xf6, 0xfe, 0xf2, 0x01,
-  0x01, 0x0f, 0xad, 0xfb, 0xa3, 0x65, 0xc2, 0x81, 0x91, 0x8c, 0x54, 0x88,
-  0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9, 0x06, 0x9f, 0x00, 0x09,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x11, 0x26, 0x23, 0x20, 0x11, 0x15, 0x10,
-  0x21, 0x20, 0x13, 0x10, 0x21, 0x20, 0x11, 0x35, 0x10, 0x21, 0x36, 0x17,
-  0x11, 0x33, 0x03, 0x31, 0x6e, 0xb5, 0xff, 0x00, 0x01, 0x00, 0x01, 0x23,
-  0x97, 0xfe, 0x4f, 0xfe, 0x4c, 0x01, 0xb4, 0x95, 0x85, 0x97, 0x02, 0x07,
-  0x01, 0xa3, 0x50, 0xfe, 0x70, 0x59, 0xfe, 0x71, 0x01, 0x6c, 0xfd, 0xf4,
-  0x02, 0x3e, 0x4a, 0x02, 0x3d, 0x01, 0x52, 0x02, 0x49, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x75, 0xff, 0xe2, 0x03, 0xdc, 0x06, 0xb3, 0x00, 0x1a,
-  0x00, 0x24, 0x00, 0x00, 0x13, 0x10, 0x21, 0x32, 0x17, 0x36, 0x21, 0x15,
-  0x22, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x23, 0x22, 0x15, 0x11, 0x36, 0x37,
-  0x20, 0x13, 0x15, 0x10, 0x21, 0x20, 0x13, 0x33, 0x10, 0x33, 0x20, 0x11,
-  0x35, 0x10, 0x21, 0x22, 0x07, 0x76, 0x01, 0x38, 0xb4, 0x57, 0x21, 0x01,
-  0x01, 0xfd, 0x93, 0x97, 0x9d, 0x95, 0x7d, 0x01, 0xb1, 0x01, 0xfe, 0x3c,
-  0xfe, 0x5e, 0x02, 0xa1, 0xfb, 0x01, 0x28, 0xfe, 0xee, 0x7c, 0x95, 0x05,
-  0x79, 0x01, 0x3a, 0xbd, 0xbd, 0x9f, 0xa0, 0x44, 0x44, 0xa0, 0x9b, 0xfe,
-  0x9e, 0x55, 0x01, 0xfe, 0x11, 0x77, 0xfd, 0xdb, 0x02, 0x1b, 0xfe, 0x85,
-  0x01, 0x71, 0x8b, 0x01, 0x52, 0x60, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63,
-  0xff, 0xe2, 0x03, 0xed, 0x06, 0xa0, 0x00, 0x1c, 0x00, 0x23, 0x00, 0x00,
-  0x01, 0x23, 0x13, 0x33, 0x15, 0x23, 0x13, 0x10, 0x21, 0x20, 0x11, 0x37,
-  0x33, 0x07, 0x10, 0x21, 0x20, 0x11, 0x03, 0x23, 0x20, 0x11, 0x10, 0x21,
-  0x33, 0x27, 0x33, 0x17, 0x33, 0x01, 0x14, 0x3b, 0x01, 0x03, 0x23, 0x22,
-  0x03, 0xec, 0xc6, 0x38, 0x8e, 0x71, 0x4e, 0xfe, 0x47, 0xfe, 0x53, 0x35,
-  0xb8, 0x41, 0x01, 0x03, 0x01, 0x16, 0x54, 0xcb, 0xfe, 0x90, 0x01, 0x73,
-  0x54, 0x21, 0xb4, 0x1f, 0xda, 0xfd, 0x3c, 0xda, 0xc0, 0x3e, 0x7f, 0xdd,
-  0x05, 0x69, 0xfe, 0xb9, 0x8d, 0xfe, 0x35, 0xfe, 0x18, 0x01, 0xe8, 0xdd,
-  0xdc, 0xfe, 0xb7, 0x01, 0x4e, 0x01, 0xc5, 0x01, 0x2d, 0x01, 0x36, 0xa8,
-  0xa8, 0xfe, 0xcf, 0xa5, 0x01, 0x47, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75,
-  0xff, 0xe2, 0x03, 0xdd, 0x06, 0x9f, 0x00, 0x09, 0x00, 0x15, 0x00, 0x00,
-  0x01, 0x10, 0x21, 0x06, 0x07, 0x11, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15,
-  0x10, 0x21, 0x20, 0x19, 0x01, 0x33, 0x11, 0x36, 0x33, 0x04, 0x03, 0x3a,
-  0xfe, 0xea, 0x92, 0x7a, 0x01, 0x1a, 0x01, 0x08, 0xa2, 0xfe, 0x56, 0xfe,
-  0x43, 0xa3, 0x91, 0x7b, 0x01, 0xb8, 0x02, 0x8d, 0x01, 0x7f, 0x03, 0x55,
-  0xfe, 0x58, 0xfe, 0x76, 0x01, 0x80, 0x6e, 0x5f, 0xfd, 0xd1, 0x02, 0x25,
-  0x04, 0x98, 0xfd, 0xbc, 0x4e, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2d,
-  0xff, 0xe2, 0x03, 0x8b, 0x06, 0xb3, 0x00, 0x21, 0x00, 0x00, 0x01, 0x07,
-  0x25, 0x03, 0x04, 0x17, 0x06, 0x04, 0x21, 0x35, 0x32, 0x36, 0x35, 0x26,
-  0x2f, 0x01, 0x13, 0x25, 0x37, 0x05, 0x37, 0x36, 0x34, 0x26, 0x23, 0x07,
-  0x35, 0x33, 0x32, 0x17, 0x16, 0x14, 0x0f, 0x01, 0x03, 0x8a, 0x45, 0xfe,
-  0xc9, 0x82, 0x01, 0x2e, 0x01, 0x01, 0xfe, 0xe8, 0xfe, 0xbd, 0xfb, 0xb5,
-  0x01, 0xeb, 0x68, 0xd2, 0xfe, 0xa0, 0x48, 0x01, 0x5b, 0x5f, 0x11, 0x43,
-  0x39, 0x75, 0x8c, 0x77, 0x43, 0x43, 0x1b, 0x65, 0x03, 0xcc, 0x8a, 0xab,
-  0xfe, 0xeb, 0x6e, 0xdc, 0xc6, 0xe6, 0xa0, 0x7f, 0x7a, 0xc0, 0x28, 0x45,
-  0x01, 0x95, 0xbe, 0x8c, 0xc5, 0xc2, 0x1c, 0x53, 0x38, 0x13, 0x9b, 0x4b,
-  0x4a, 0xb2, 0x37, 0xc4, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xca,
-  0x06, 0xb3, 0x00, 0x26, 0x00, 0x00, 0x01, 0x10, 0x21, 0x20, 0x11, 0x33,
-  0x10, 0x21, 0x20, 0x11, 0x34, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x35, 0x34,
-  0x27, 0x23, 0x35, 0x33, 0x32, 0x35, 0x34, 0x21, 0x23, 0x35, 0x33, 0x20,
-  0x11, 0x14, 0x07, 0x33, 0x16, 0x15, 0x16, 0x07, 0x16, 0x03, 0xc9, 0xfe,
-  0x49, 0xfe, 0x51, 0xab, 0x01, 0x04, 0x01, 0x0f, 0x8b, 0xd0, 0xbe, 0x8b,
-  0x8b, 0xd0, 0xd0, 0x76, 0xfe, 0x96, 0x6b, 0x6b, 0x02, 0x15, 0x88, 0x02,
-  0x98, 0x01, 0x76, 0x87, 0x01, 0x99, 0xfe, 0x49, 0x02, 0x04, 0xfe, 0x9c,
-  0x01, 0x17, 0xc5, 0xb3, 0x84, 0x79, 0x01, 0xb5, 0x99, 0xb8, 0x9e, 0xfe,
-  0xaa, 0x9b, 0x61, 0x4e, 0x87, 0x94, 0x47, 0x6e, 0x00, 0x01, 0x00, 0x6c,
-  0xff, 0xe2, 0x03, 0xd2, 0x06, 0xb2, 0x00, 0x26, 0x00, 0x00, 0x05, 0x20,
-  0x19, 0x01, 0x33, 0x11, 0x10, 0x21, 0x20, 0x11, 0x34, 0x27, 0x23, 0x35,
-  0x33, 0x32, 0x37, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x36, 0x35, 0x34, 0x21,
-  0x35, 0x20, 0x11, 0x06, 0x07, 0x23, 0x16, 0x17, 0x06, 0x07, 0x16, 0x15,
-  0x10, 0x02, 0x20, 0xfe, 0x4c, 0xa3, 0x01, 0x11, 0x01, 0x0a, 0x76, 0x98,
-  0x98, 0x61, 0x05, 0x05, 0x76, 0x95, 0x95, 0x64, 0xfe, 0xf5, 0x01, 0xb6,
-  0x01, 0x8f, 0x02, 0xa4, 0x01, 0x01, 0x9b, 0xac, 0x1e, 0x01, 0xe6, 0x04,
-  0x4d, 0xfb, 0xb3, 0xfe, 0xba, 0x01, 0x12, 0xe0, 0x02, 0xb1, 0x83, 0x7d,
-  0xb7, 0x01, 0xb4, 0x81, 0x9e, 0xfe, 0xd2, 0xa5, 0x53, 0x67, 0x7e, 0x80,
-  0x5c, 0x56, 0xe1, 0xfe, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63,
-  0xff, 0x5f, 0x03, 0xcb, 0x06, 0xb3, 0x00, 0x09, 0x00, 0x1f, 0x00, 0x00,
-  0x01, 0x10, 0x05, 0x24, 0x19, 0x01, 0x10, 0x21, 0x20, 0x11, 0x03, 0x32,
-  0x37, 0x23, 0x02, 0x19, 0x01, 0x10, 0x21, 0x20, 0x19, 0x01, 0x10, 0x03,
-  0x16, 0x33, 0x15, 0x22, 0x27, 0x23, 0x06, 0x27, 0x01, 0x0e, 0x01, 0x07,
-  0x01, 0x0c, 0xfe, 0xf5, 0xfe, 0xf8, 0xab, 0xc3, 0x39, 0x02, 0xfa, 0x01,
-  0xb2, 0x01, 0xb3, 0xfe, 0x29, 0xd7, 0xaf, 0xfd, 0x13, 0xf7, 0xb1, 0x02,
-  0xd2, 0xfe, 0x68, 0x78, 0x78, 0x01, 0x98, 0x01, 0xa2, 0x01, 0xa0, 0xfe,
-  0x60, 0xfb, 0xa9, 0x53, 0x01, 0x04, 0x01, 0x5e, 0x01, 0xa6, 0x02, 0x3b,
-  0xfd, 0xc1, 0xfe, 0x5e, 0xfe, 0xa2, 0xfe, 0xf8, 0x4f, 0xbe, 0xe6, 0xe7,
-  0x01, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9,
-  0x06, 0xb5, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x10, 0x21, 0x20, 0x11, 0x35,
-  0x33, 0x15, 0x10, 0x21, 0x20, 0x11, 0x35, 0x10, 0x2b, 0x01, 0x35, 0x33,
-  0x24, 0x11, 0x05, 0x15, 0x23, 0x11, 0x25, 0x10, 0x05, 0x04, 0x11, 0x03,
-  0xc8, 0xfe, 0x48, 0xfe, 0x55, 0xaa, 0x01, 0x08, 0x01, 0x0a, 0xda, 0xcd,
-  0x6f, 0x01, 0x38, 0xfd, 0xf0, 0xae, 0x03, 0x65, 0xfe, 0xdb, 0x01, 0x25,
-  0x01, 0x96, 0xfe, 0x4c, 0x01, 0xd4, 0xd3, 0xdd, 0xfe, 0xd6, 0x01, 0x14,
-  0x9b, 0x01, 0x1a, 0xa4, 0xad, 0x01, 0x78, 0x17, 0xec, 0x01, 0x8f, 0x15,
-  0xfd, 0xbf, 0x9e, 0x71, 0xfe, 0xd2, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
-  0xff, 0xe2, 0x03, 0xd5, 0x06, 0xb4, 0x00, 0x20, 0x00, 0x00, 0x01, 0x10,
-  0x21, 0x20, 0x11, 0x35, 0x33, 0x15, 0x10, 0x21, 0x20, 0x11, 0x10, 0x2b,
-  0x01, 0x35, 0x33, 0x24, 0x03, 0x06, 0x23, 0x04, 0x11, 0x33, 0x14, 0x21,
-  0x32, 0x37, 0x33, 0x15, 0x02, 0x05, 0x04, 0x03, 0xc9, 0xfe, 0x49, 0xfe,
-  0x51, 0xac, 0x01, 0x03, 0x01, 0x0f, 0xfa, 0xad, 0x63, 0x01, 0x43, 0x02,
-  0x96, 0x76, 0xfe, 0x51, 0xab, 0x01, 0x04, 0xc8, 0x70, 0x8b, 0x0a, 0xfe,
-  0xf3, 0x01, 0x0b, 0x01, 0xc8, 0xfe, 0x1a, 0x01, 0xe6, 0x8e, 0x8e, 0xfe,
-  0xba, 0x01, 0x46, 0x01, 0x60, 0xad, 0x1e, 0x01, 0xbb, 0x6f, 0x02, 0x01,
-  0x77, 0xc6, 0xc5, 0xe1, 0xfe, 0x80, 0xa6, 0x9c, 0x00, 0x03, 0x00, 0x63,
-  0xff, 0xe2, 0x04, 0x48, 0x06, 0xb3, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x25,
-  0x00, 0x00, 0x01, 0x21, 0x24, 0x11, 0x10, 0x21, 0x20, 0x35, 0x01, 0x10,
-  0x29, 0x01, 0x11, 0x34, 0x21, 0x20, 0x01, 0x15, 0x10, 0x21, 0x20, 0x11,
-  0x10, 0x37, 0x23, 0x26, 0x11, 0x10, 0x21, 0x20, 0x11, 0x15, 0x33, 0x15,
-  0x23, 0x11, 0x33, 0x15, 0x03, 0x2a, 0xfe, 0xe6, 0xfe, 0xfe, 0x01, 0x09,
-  0x01, 0x13, 0xfd, 0xe4, 0x01, 0x02, 0x01, 0x1a, 0xfe, 0xed, 0xfe, 0xf7,
-  0x02, 0xbb, 0xfe, 0x47, 0xfe, 0x53, 0xf1, 0x01, 0xf0, 0x01, 0xb4, 0x01,
-  0xb2, 0x7e, 0x7e, 0x7e, 0x02, 0xde, 0x02, 0xfe, 0xce, 0xfe, 0xd4, 0xf4,
-  0x03, 0x62, 0xfe, 0xba, 0x01, 0x9f, 0xe3, 0xfb, 0xda, 0x78, 0xfe, 0x6c,
-  0x01, 0xcc, 0x01, 0x21, 0x6a, 0x60, 0x01, 0x3f, 0x01, 0xdb, 0xfe, 0x7e,
-  0x97, 0xbe, 0xfe, 0xca, 0xb8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63,
-  0xff, 0xe2, 0x06, 0x7e, 0x06, 0xb4, 0x00, 0x0a, 0x00, 0x2c, 0x00, 0x00,
-  0x01, 0x11, 0x34, 0x26, 0x23, 0x20, 0x13, 0x11, 0x10, 0x05, 0x20, 0x13,
-  0x10, 0x21, 0x22, 0x27, 0x15, 0x10, 0x21, 0x35, 0x32, 0x35, 0x11, 0x10,
-  0x21, 0x22, 0x06, 0x1d, 0x01, 0x10, 0x21, 0x15, 0x20, 0x03, 0x35, 0x10,
-  0x36, 0x37, 0x32, 0x17, 0x36, 0x33, 0x04, 0x12, 0x15, 0x05, 0xd6, 0x74,
-  0x96, 0xfe, 0xfc, 0x01, 0x01, 0x03, 0x01, 0x0a, 0xa7, 0xfe, 0x49, 0x73,
-  0x8b, 0xfe, 0x5e, 0xf8, 0xfe, 0xf8, 0x7d, 0x8a, 0x01, 0x08, 0xfe, 0x4d,
-  0x01, 0xfc, 0xb7, 0xea, 0x7b, 0x6a, 0xe7, 0x01, 0x0a, 0xa7, 0x03, 0xb5,
-  0x01, 0x03, 0xc3, 0x9a, 0xfe, 0xd9, 0xfe, 0x6b, 0xfe, 0xd4, 0x01, 0x01,
-  0x84, 0xfd, 0xdd, 0x87, 0x9e, 0xfe, 0x6c, 0xa0, 0xf4, 0x03, 0x78, 0x01,
-  0x27, 0x9b, 0xc2, 0xfd, 0xfe, 0xaf, 0xa5, 0x01, 0xf6, 0xfd, 0x01, 0x01,
-  0xfa, 0x01, 0xd8, 0xd8, 0x01, 0xfe, 0xc4, 0xbf, 0x00, 0x03, 0x00, 0x6d,
-  0xfe, 0x1e, 0x06, 0x47, 0x06, 0x87, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x23,
-  0x00, 0x00, 0x01, 0x04, 0x07, 0x03, 0x06, 0x33, 0x32, 0x25, 0x17, 0x24,
-  0x37, 0x13, 0x36, 0x23, 0x22, 0x05, 0x01, 0x06, 0x05, 0x13, 0x23, 0x03,
-  0x04, 0x23, 0x22, 0x1b, 0x01, 0x36, 0x25, 0x03, 0x33, 0x13, 0x24, 0x33,
-  0x32, 0x03, 0x03, 0x3e, 0xfe, 0x2f, 0x18, 0x3b, 0x15, 0x65, 0x66, 0x01,
-  0x10, 0x9a, 0x01, 0xd0, 0x0d, 0x41, 0x18, 0x80, 0x52, 0xff, 0x00, 0x02,
-  0x27, 0x1d, 0xfd, 0x8a, 0x54, 0xbb, 0x53, 0xfe, 0xe6, 0x98, 0xbe, 0x26,
-  0x41, 0x20, 0x02, 0x76, 0x47, 0xab, 0x41, 0x01, 0x16, 0xae, 0xbe, 0x26,
-  0x03, 0xfc, 0x4e, 0xa8, 0xfe, 0x2c, 0xae, 0xae, 0xae, 0x46, 0x68, 0x01,
-  0xfa, 0xae, 0x49, 0xfd, 0xa1, 0xe0, 0x28, 0xfd, 0xf4, 0x02, 0x91, 0xaf,
-  0x01, 0x32, 0x01, 0xf9, 0xfa, 0x3a, 0x02, 0x28, 0xfd, 0x6a, 0x6e, 0xfe,
-  0xcd, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xfe, 0x28, 0x05, 0x78,
-  0x06, 0xd3, 0x00, 0x30, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x14, 0x00, 0x15,
-  0x14, 0x07, 0x04, 0x11, 0x02, 0x05, 0x24, 0x03, 0x34, 0x37, 0x27, 0x26,
-  0x27, 0x06, 0x11, 0x10, 0x05, 0x04, 0x17, 0x23, 0x26, 0x25, 0x06, 0x07,
-  0x27, 0x36, 0x37, 0x24, 0x11, 0x10, 0x25, 0x26, 0x35, 0x37, 0x17, 0x07,
-  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x26, 0x00, 0x35, 0x01, 0x10, 0x23,
-  0x22, 0x07, 0x06, 0x07, 0x06, 0x15, 0x12, 0x17, 0x36, 0x03, 0x14, 0x01,
-  0x34, 0x1b, 0x01, 0x4b, 0x13, 0xfe, 0x99, 0xfe, 0x8c, 0x12, 0x36, 0x3f,
-  0x60, 0x4c, 0xc7, 0x01, 0x41, 0x01, 0xf4, 0x04, 0xc5, 0x0a, 0xfe, 0xa3,
-  0x87, 0x68, 0x6e, 0x60, 0x8d, 0xfe, 0xc1, 0x01, 0x1b, 0x21, 0x22, 0x90,
-  0x15, 0x88, 0x57, 0x64, 0x73, 0x01, 0xfe, 0xce, 0x02, 0x62, 0xd8, 0x1c,
-  0x18, 0x30, 0x50, 0x3c, 0x09, 0xe7, 0xce, 0x06, 0xd3, 0xa4, 0xfe, 0xe6,
-  0xab, 0x66, 0x45, 0x14, 0xfe, 0x2c, 0xfe, 0x20, 0x14, 0x14, 0x01, 0xeb,
-  0x66, 0x8e, 0x0a, 0x09, 0x5c, 0x37, 0xfe, 0xb9, 0xfe, 0xac, 0xad, 0xc0,
-  0xde, 0xa8, 0x59, 0x03, 0x98, 0x6c, 0x67, 0x2f, 0xe9, 0x01, 0x42, 0x01,
-  0xbf, 0x38, 0x4d, 0x75, 0xb1, 0x38, 0x79, 0x8e, 0x90, 0x89, 0x8b, 0x7a,
-  0x01, 0x1b, 0xd4, 0xfb, 0x0e, 0x01, 0x52, 0x05, 0x34, 0x1a, 0x5d, 0xa1,
-  0xfe, 0x95, 0x0a, 0x0a, 0x00, 0x02, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e,
-  0x06, 0x1e, 0x00, 0x03, 0x00, 0x16, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
-  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x11,
-  0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0xc3, 0x02, 0x1b, 0xfd, 0xe5,
-  0x02, 0x8b, 0xfe, 0x85, 0xfe, 0x87, 0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01,
-  0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac, 0x06, 0x1e, 0x94, 0xfc, 0x20, 0xfe,
-  0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd,
-  0xad, 0x7e, 0x7e, 0x00, 0x00, 0x03, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e,
-  0x06, 0x38, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x33,
-  0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37,
-  0x33, 0x07, 0x10, 0x33, 0x32, 0x11, 0x26, 0x24, 0x35, 0x33, 0x16, 0x17,
-  0x16, 0x02, 0x11, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0x9d, 0xfe,
-  0x85, 0xfe, 0x87, 0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8,
-  0x02, 0xab, 0xac, 0x06, 0x38, 0xca, 0xca, 0xca, 0xfc, 0x3c, 0xfe, 0x38,
-  0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad,
-  0x7e, 0x7e, 0x00, 0x00, 0x00, 0x04, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e,
-  0x07, 0x00, 0x00, 0x12, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x00,
-  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x11,
-  0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0x01, 0x21, 0x15, 0x21, 0x01,
-  0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x03, 0x4e, 0xfe, 0x85, 0xfe,
-  0x87, 0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab,
-  0xac, 0xfd, 0x58, 0x02, 0x1b, 0xfd, 0xe5, 0x01, 0x62, 0xb7, 0xb7, 0xfe,
-  0xa0, 0xb7, 0xb7, 0x01, 0xaa, 0xfe, 0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe,
-  0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad, 0x7e, 0x7e, 0x02, 0xb6, 0x94,
-  0x02, 0x25, 0xca, 0xca, 0xca, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
-  0xff, 0xe2, 0x03, 0x4e, 0x06, 0x8c, 0x00, 0x03, 0x00, 0x16, 0x00, 0x00,
-  0x01, 0x33, 0x03, 0x23, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07,
-  0x10, 0x33, 0x32, 0x11, 0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0x01,
-  0xf0, 0xd3, 0xe8, 0x9b, 0x02, 0x0e, 0xfe, 0x85, 0xfe, 0x87, 0x23, 0x9f,
-  0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac, 0x06, 0x8c,
-  0xfe, 0xf8, 0xfc, 0x26, 0xfe, 0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce,
-  0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad, 0x7e, 0x7e, 0x00, 0x03, 0x00, 0x5a,
-  0xff, 0xe2, 0x03, 0x4e, 0x07, 0x18, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1a,
-  0x00, 0x00, 0x01, 0x33, 0x03, 0x23, 0x07, 0x21, 0x15, 0x21, 0x01, 0x10,
-  0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x11, 0x26, 0x24,
-  0x35, 0x33, 0x16, 0x17, 0x16, 0x01, 0xf0, 0xa6, 0xcd, 0x89, 0x88, 0x02,
-  0x1b, 0xfd, 0xe5, 0x02, 0x96, 0xfe, 0x85, 0xfe, 0x87, 0x23, 0x9f, 0x20,
-  0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac, 0x07, 0x18, 0xfe,
-  0xf8, 0x79, 0x94, 0xfc, 0xa7, 0xfe, 0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe,
-  0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad, 0x7e, 0x7e, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e, 0x06, 0x79, 0x00, 0x08,
-  0x00, 0x1b, 0x00, 0x00, 0x01, 0x02, 0x20, 0x03, 0x33, 0x16, 0x33, 0x32,
-  0x37, 0x13, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32,
-  0x11, 0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0x02, 0xd7, 0x11, 0xfd,
-  0xef, 0x11, 0x6a, 0x16, 0x9a, 0x9a, 0x15, 0xe1, 0xfe, 0x85, 0xfe, 0x87,
-  0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac,
-  0x06, 0x79, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0xfb, 0x31, 0xfe, 0x38,
-  0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad,
-  0x7e, 0x7e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xfe, 0x1d, 0x03, 0x3c,
-  0x06, 0x1e, 0x00, 0x03, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
-  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19,
-  0x01, 0x10, 0x23, 0x22, 0x15, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20, 0x11,
-  0xf0, 0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x4c, 0xfe, 0x9c, 0xfe, 0x82, 0x1e,
-  0x9a, 0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01, 0x49, 0x01,
-  0x64, 0x06, 0x1e, 0x94, 0xfa, 0x37, 0xfe, 0x5c, 0x01, 0xa6, 0xe1, 0xe3,
-  0xfe, 0xe8, 0x01, 0x16, 0x03, 0x13, 0x01, 0x02, 0xf4, 0xe2, 0xdc, 0x01,
-  0x86, 0xfe, 0x6f, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xfe, 0x1d, 0x03, 0x3c,
-  0x06, 0x64, 0x00, 0x03, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x33, 0x03, 0x23,
-  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19,
-  0x01, 0x10, 0x23, 0x22, 0x15, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20, 0x11,
-  0x02, 0x2f, 0xd3, 0xe8, 0x9c, 0x01, 0xbe, 0xfe, 0x9c, 0xfe, 0x82, 0x1e,
-  0x9a, 0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01, 0x49, 0x01,
-  0x64, 0x06, 0x64, 0xfe, 0xf8, 0xfa, 0x65, 0xfe, 0x5c, 0x01, 0xa6, 0xe1,
-  0xe3, 0xfe, 0xe8, 0x01, 0x16, 0x03, 0x13, 0x01, 0x02, 0xf4, 0xe2, 0xdc,
-  0x01, 0x86, 0xfe, 0x6f, 0x00, 0x03, 0x00, 0x5a, 0xfe, 0x1d, 0x03, 0x3c,
-  0x07, 0x36, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x33,
-  0x03, 0x23, 0x07, 0x21, 0x15, 0x21, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37,
-  0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x10, 0x23, 0x22, 0x15, 0x17,
-  0x23, 0x27, 0x10, 0x21, 0x20, 0x11, 0x02, 0x1d, 0xc1, 0xcd, 0xa5, 0x86,
-  0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x56, 0xfe, 0x9c, 0xfe, 0x82, 0x1e, 0x9a,
-  0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01, 0x49, 0x01, 0x64,
-  0x07, 0x36, 0xfe, 0xf8, 0x79, 0x94, 0xfa, 0xa0, 0xfe, 0x5c, 0x01, 0xa6,
-  0xe1, 0xe3, 0xfe, 0xe8, 0x01, 0x16, 0x03, 0x13, 0x01, 0x02, 0xf4, 0xe2,
-  0xdc, 0x01, 0x86, 0xfe, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
-  0xfe, 0x1d, 0x03, 0x3c, 0x06, 0x79, 0x00, 0x08, 0x00, 0x20, 0x00, 0x00,
-  0x01, 0x02, 0x20, 0x03, 0x33, 0x16, 0x33, 0x32, 0x37, 0x13, 0x10, 0x21,
-  0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x10, 0x23,
-  0x22, 0x15, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20, 0x11, 0x02, 0xfb, 0x11,
-  0xfd, 0xef, 0x11, 0x6a, 0x16, 0x9a, 0x9a, 0x15, 0xab, 0xfe, 0x9c, 0xfe,
-  0x82, 0x1e, 0x9a, 0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01,
-  0x49, 0x01, 0x64, 0x06, 0x79, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0xf9,
-  0x48, 0xfe, 0x5c, 0x01, 0xa6, 0xe1, 0xe3, 0xfe, 0xe8, 0x01, 0x16, 0x03,
-  0x13, 0x01, 0x02, 0xf4, 0xe2, 0xdc, 0x01, 0x86, 0xfe, 0x6f, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x03, 0x60, 0x06, 0x1e, 0x00, 0x11,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x10, 0x03, 0x23, 0x12, 0x11, 0x10, 0x23,
-  0x22, 0x11, 0x10, 0x13, 0x23, 0x02, 0x11, 0x10, 0x21, 0x20, 0x01, 0x21,
-  0x15, 0x21, 0x03, 0x60, 0x8a, 0x9b, 0x83, 0xdd, 0xe5, 0x82, 0x9c, 0x88,
-  0x01, 0x87, 0x01, 0x7f, 0xfd, 0x7e, 0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x44,
-  0xfe, 0xf4, 0xfe, 0xc8, 0x01, 0x21, 0x01, 0x23, 0x01, 0x90, 0xfe, 0x6d,
-  0xfe, 0xe0, 0xfe, 0xdf, 0x01, 0x3a, 0x01, 0x0d, 0x02, 0x19, 0x01, 0xbe,
-  0x94, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x03, 0x60,
-  0x06, 0x64, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x01, 0x10, 0x03, 0x23,
-  0x12, 0x11, 0x10, 0x23, 0x22, 0x11, 0x10, 0x13, 0x23, 0x02, 0x11, 0x10,
-  0x21, 0x20, 0x01, 0x33, 0x03, 0x23, 0x03, 0x60, 0x8a, 0x9b, 0x83, 0xdd,
-  0xe5, 0x82, 0x9c, 0x88, 0x01, 0x87, 0x01, 0x7f, 0xfe, 0xd8, 0xca, 0xe8,
-  0x92, 0x02, 0x44, 0xfe, 0xf4, 0xfe, 0xc9, 0x01, 0x20, 0x01, 0x23, 0x01,
-  0x90, 0xfe, 0x6d, 0xfe, 0xe0, 0xfe, 0xdf, 0x01, 0x3a, 0x01, 0x0d, 0x02,
-  0x19, 0x02, 0x04, 0xfe, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
-  0x00, 0x00, 0x03, 0x60, 0x06, 0x79, 0x00, 0x11, 0x00, 0x1a, 0x00, 0x00,
-  0x01, 0x10, 0x03, 0x23, 0x12, 0x11, 0x10, 0x23, 0x22, 0x11, 0x10, 0x13,
-  0x23, 0x02, 0x11, 0x10, 0x21, 0x20, 0x03, 0x02, 0x20, 0x03, 0x33, 0x16,
-  0x33, 0x32, 0x37, 0x03, 0x60, 0x8a, 0x9b, 0x83, 0xdd, 0xe5, 0x82, 0x9c,
-  0x88, 0x01, 0x87, 0x01, 0x7f, 0x65, 0x11, 0xfd, 0xef, 0x11, 0x6a, 0x16,
-  0x9a, 0x9a, 0x15, 0x02, 0x44, 0xfe, 0xf4, 0xfe, 0xc9, 0x01, 0x20, 0x01,
-  0x23, 0x01, 0x90, 0xfe, 0x6d, 0xfe, 0xe0, 0xfe, 0xdf, 0x01, 0x3a, 0x01,
-  0x0d, 0x02, 0x19, 0x02, 0x19, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0x00,
-  0x00, 0x02, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f, 0x06, 0x1e, 0x00, 0x1c,
-  0x00, 0x20, 0x00, 0x00, 0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23,
-  0x22, 0x11, 0x15, 0x23, 0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23,
-  0x02, 0x11, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x21, 0x15,
-  0x21, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11, 0x01, 0xbd, 0xd0, 0x95,
-  0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01, 0x61, 0xca, 0x4f, 0x58,
-  0xc6, 0x01, 0x5e, 0xfc, 0x78, 0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x56, 0xfe,
-  0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e, 0xfe, 0xa7, 0xd2,
-  0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc, 0x01, 0x24, 0x01,
-  0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x01, 0xbe, 0x94, 0x00, 0x03, 0x00, 0x5a,
-  0xff, 0xff, 0x05, 0x4f, 0x06, 0x38, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x24,
-  0x00, 0x00, 0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23, 0x22, 0x11,
-  0x15, 0x23, 0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23, 0x02, 0x11,
-  0x10, 0x21, 0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x33, 0x15, 0x23, 0x25,
-  0x33, 0x15, 0x23, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11, 0x01, 0xbd,
-  0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01, 0x61, 0xca,
-  0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfd, 0xd8, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7,
-  0xb7, 0x02, 0x56, 0xfe, 0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01,
-  0x7e, 0xfe, 0xa7, 0xd2, 0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe,
-  0xdc, 0x01, 0x24, 0x01, 0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x01, 0xd8, 0xca,
-  0xca, 0xca, 0x00, 0x00, 0x00, 0x04, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f,
-  0x07, 0x28, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x24, 0x00, 0x28, 0x00, 0x00,
-  0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23, 0x22, 0x11, 0x15, 0x23,
-  0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23, 0x02, 0x11, 0x10, 0x21,
-  0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x21, 0x15, 0x21, 0x01, 0x33, 0x15,
-  0x23, 0x25, 0x33, 0x15, 0x23, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11,
-  0x01, 0xbd, 0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01,
-  0x61, 0xca, 0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfc, 0x76, 0x02, 0x1b, 0xfd,
-  0xe5, 0x01, 0x62, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0x56, 0xfe,
-  0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e, 0xfe, 0xa7, 0xd2,
-  0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc, 0x01, 0x24, 0x01,
-  0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x01, 0x37, 0x94, 0x02, 0x25, 0xca, 0xca,
-  0xca, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f,
-  0x06, 0x64, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x12, 0x03, 0x23,
-  0x00, 0x11, 0x02, 0x23, 0x22, 0x11, 0x15, 0x23, 0x35, 0x10, 0x23, 0x22,
-  0x11, 0x02, 0x01, 0x23, 0x02, 0x11, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33,
-  0x20, 0x01, 0x33, 0x03, 0x23, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11,
-  0x01, 0xbd, 0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01,
-  0x61, 0xca, 0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfd, 0xb7, 0xca, 0xe8, 0x93,
-  0x02, 0x56, 0xfe, 0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e,
-  0xfe, 0xa7, 0xd2, 0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc,
-  0x01, 0x24, 0x01, 0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x02, 0x04, 0xfe, 0xf8,
-  0x00, 0x02, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f, 0x06, 0x79, 0x00, 0x1c,
-  0x00, 0x25, 0x00, 0x00, 0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23,
-  0x22, 0x11, 0x15, 0x23, 0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23,
-  0x02, 0x11, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x02, 0x20,
-  0x03, 0x33, 0x16, 0x33, 0x32, 0x37, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01,
-  0x11, 0x01, 0xbd, 0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe,
-  0x01, 0x61, 0xca, 0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfe, 0xb0, 0x11, 0xfd,
-  0xef, 0x11, 0x6a, 0x17, 0x98, 0x9b, 0x15, 0x02, 0x56, 0xfe, 0xd1, 0xfe,
-  0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e, 0xfe, 0xa7, 0xd2, 0xd2, 0x01,
-  0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc, 0x01, 0x24, 0x01, 0x33, 0x02,
-  0x0a, 0xe3, 0xe3, 0x02, 0x19, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0x00,
-  0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x1e, 0x00, 0x03,
-  0x00, 0x24, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x01, 0x10, 0x21, 0x20,
-  0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22,
-  0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32,
-  0x17, 0x36, 0x33, 0x20, 0x11, 0xd5, 0x02, 0x1b, 0xfd, 0xe5, 0x02, 0xaf,
-  0xfe, 0x96, 0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f,
-  0x09, 0x81, 0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c,
-  0x90, 0x01, 0x12, 0x06, 0x1e, 0x94, 0xfa, 0x36, 0xfe, 0x5d, 0x01, 0xa3,
-  0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe, 0xa5,
-  0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x38, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x28, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x25, 0x33,
-  0x15, 0x23, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33,
-  0x32, 0x19, 0x01, 0x26, 0x23, 0x22, 0x15, 0x03, 0x23, 0x03, 0x34, 0x2b,
-  0x01, 0x27, 0x37, 0x17, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11, 0x02,
-  0x35, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0xaf, 0xfe, 0x96, 0xfe,
-  0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81, 0x09,
-  0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01, 0x12,
-  0x06, 0x38, 0xca, 0xca, 0xca, 0xfa, 0x52, 0xfe, 0x5d, 0x01, 0xa3, 0xe3,
-  0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe, 0xa5, 0x01,
-  0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x07, 0x3c, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x2c, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
-  0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x01, 0x10, 0x21, 0x20,
-  0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22,
-  0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32,
-  0x17, 0x36, 0x33, 0x20, 0x11, 0xd4, 0x02, 0x1a, 0xfd, 0xe6, 0x01, 0x61,
-  0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0xaf, 0xfe, 0x96, 0xfe, 0x73,
-  0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81, 0x09, 0x8c,
-  0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01, 0x12, 0x05,
-  0xab, 0x94, 0x02, 0x25, 0xca, 0xca, 0xca, 0xf9, 0x4e, 0xfe, 0x5d, 0x01,
-  0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe,
-  0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00,
-  0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x64, 0x00, 0x03,
-  0x00, 0x24, 0x00, 0x00, 0x01, 0x33, 0x03, 0x23, 0x01, 0x10, 0x21, 0x20,
-  0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22,
-  0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32,
-  0x17, 0x36, 0x33, 0x20, 0x11, 0x02, 0x1d, 0xc1, 0xdf, 0x93, 0x02, 0x18,
-  0xfe, 0x96, 0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f,
-  0x09, 0x81, 0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c,
-  0x90, 0x01, 0x12, 0x06, 0x64, 0xfe, 0xf8, 0xfa, 0x64, 0xfe, 0x5d, 0x01,
-  0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe,
-  0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00,
-  0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x79, 0x00, 0x08,
-  0x00, 0x29, 0x00, 0x00, 0x01, 0x02, 0x20, 0x03, 0x33, 0x16, 0x33, 0x32,
-  0x37, 0x13, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32,
-  0x19, 0x01, 0x26, 0x23, 0x22, 0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01,
-  0x27, 0x37, 0x17, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11, 0x02, 0xf2,
-  0x11, 0xfd, 0xef, 0x11, 0x6a, 0x17, 0x98, 0x9b, 0x15, 0xfc, 0xfe, 0x96,
-  0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81,
-  0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01,
-  0x12, 0x06, 0x79, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0xf9, 0x47, 0xfe,
-  0x5d, 0x01, 0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6,
-  0x8c, 0xfe, 0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe,
-  0xc7, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84,
-  0x06, 0xd1, 0x00, 0x06, 0x00, 0x27, 0x00, 0x00, 0x01, 0x13, 0x23, 0x27,
-  0x07, 0x23, 0x13, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10,
-  0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22, 0x15, 0x03, 0x23, 0x03, 0x34,
-  0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11,
-  0x02, 0x1c, 0xdc, 0x7d, 0xa2, 0xa2, 0x7d, 0xdd, 0x01, 0xed, 0xfe, 0x96,
-  0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81,
-  0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01,
-  0x12, 0x06, 0xd1, 0xfe, 0x88, 0xf5, 0xf5, 0x01, 0x78, 0xf8, 0xef, 0xfe,
-  0x5d, 0x01, 0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6,
-  0x8c, 0xfe, 0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe,
-  0xc7, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
-  0x06, 0x14, 0x00, 0x09, 0x00, 0x20, 0x00, 0x00, 0x01, 0x22, 0x06, 0x10,
-  0x16, 0x20, 0x36, 0x35, 0x34, 0x26, 0x01, 0x10, 0x37, 0x2e, 0x01, 0x35,
-  0x34, 0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x15, 0x14, 0x16, 0x33, 0x32,
-  0x12, 0x10, 0x02, 0x20, 0x02, 0x02, 0x33, 0x84, 0x9b, 0x9a, 0x01, 0x0b,
-  0x9a, 0x9a, 0xfd, 0xad, 0xaf, 0x47, 0x3a, 0xae, 0x8e, 0x01, 0xca, 0xfe,
-  0x57, 0xa9, 0x69, 0x83, 0xd6, 0xf9, 0xf8, 0xfe, 0x50, 0xf5, 0x03, 0xdf,
-  0xe7, 0xfe, 0x6e, 0xe7, 0xe8, 0xc7, 0xc8, 0xe9, 0xfe, 0x50, 0x01, 0x4d,
-  0x9b, 0x2f, 0x8d, 0x31, 0x7c, 0x94, 0x93, 0x89, 0x49, 0x34, 0xfe, 0xc8,
-  0xfd, 0xda, 0xfe, 0xc6, 0x01, 0x39, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a,
-  0x00, 0x00, 0x05, 0x19, 0x06, 0x14, 0x00, 0x24, 0x00, 0x00, 0x01, 0x15,
-  0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x07, 0x06, 0x1d, 0x01, 0x21, 0x35, 0x34, 0x36, 0x33, 0x05,
-  0x19, 0x9e, 0x59, 0x46, 0x01, 0x11, 0xfe, 0xef, 0xa6, 0xfe, 0x39, 0xa6,
-  0x9f, 0x9f, 0x9c, 0xaa, 0x9d, 0x9e, 0x5a, 0x22, 0x23, 0x01, 0xc7, 0x9c,
-  0xaa, 0x06, 0x14, 0x99, 0x50, 0x68, 0x63, 0x8f, 0xfc, 0x2f, 0x03, 0xd1,
-  0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0xab, 0x99, 0x28, 0x28, 0x68,
-  0x63, 0x4e, 0xbb, 0xab, 0x00, 0x02, 0x00, 0x2a, 0x00, 0x00, 0x03, 0xdd,
-  0x06, 0x14, 0x00, 0x15, 0x00, 0x19, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11,
-  0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x01, 0x33, 0x15, 0x23, 0x03, 0xdc,
-  0xa6, 0xfe, 0x39, 0xa6, 0x9f, 0x9f, 0x9b, 0xa2, 0xa6, 0x9e, 0x5a, 0x45,
-  0x01, 0xc7, 0xa6, 0xa6, 0x04, 0x60, 0xfb, 0xa0, 0x03, 0xd1, 0xfc, 0x2f,
-  0x03, 0xd1, 0x8f, 0x4e, 0xb7, 0xaf, 0x99, 0x50, 0x68, 0x63, 0x01, 0xb2,
-  0xe9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x03, 0xdd,
-  0x06, 0x14, 0x00, 0x15, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35,
-  0x33, 0x35, 0x34, 0x36, 0x02, 0x0f, 0x01, 0xcd, 0xa6, 0xfe, 0xd8, 0x5a,
-  0x45, 0x01, 0x11, 0xfe, 0xef, 0xa6, 0x9f, 0x9f, 0x9c, 0x06, 0x14, 0xf9,
-  0xec, 0x05, 0x7b, 0x50, 0x68, 0x63, 0x8f, 0xfc, 0x2f, 0x03, 0xd1, 0x8f,
-  0x4e, 0xbb, 0xab, 0x00, 0x00, 0x02, 0x00, 0x2a, 0x00, 0x00, 0x06, 0x4a,
-  0x06, 0x14, 0x00, 0x29, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x15, 0x23, 0x22,
-  0x07, 0x06, 0x1d, 0x01, 0x21, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34,
-  0x36, 0x33, 0x05, 0x33, 0x15, 0x23, 0x02, 0xac, 0x9e, 0x5a, 0x22, 0x23,
-  0x01, 0xc7, 0x4e, 0x19, 0x23, 0x47, 0x75, 0x9d, 0x9e, 0x59, 0x46, 0x02,
-  0x6d, 0xa6, 0xfe, 0x39, 0xa6, 0xfe, 0x39, 0xa6, 0x9f, 0x9f, 0x9c, 0xaa,
-  0x03, 0x94, 0xa6, 0xa6, 0x06, 0x14, 0x99, 0x28, 0x28, 0x68, 0x63, 0x4e,
-  0xbb, 0x55, 0x1c, 0x13, 0x27, 0x99, 0x50, 0x68, 0x63, 0xfb, 0xa0, 0x03,
-  0xd1, 0xfc, 0x2f, 0x03, 0xd1, 0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb,
-  0xab, 0x02, 0xe9, 0x00, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x06, 0x4a,
-  0x06, 0x14, 0x00, 0x26, 0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06,
-  0x1d, 0x01, 0x21, 0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x23, 0x11, 0x21,
-  0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x33, 0x02, 0xac, 0x9e,
-  0x5a, 0x22, 0x23, 0x01, 0xc7, 0x9c, 0xaa, 0x01, 0xcd, 0xa6, 0xfe, 0xd8,
-  0x59, 0x46, 0x01, 0x11, 0xfe, 0xef, 0xa6, 0xfe, 0x39, 0xa6, 0x9f, 0x9f,
-  0x9c, 0xaa, 0x06, 0x14, 0x99, 0x28, 0x28, 0x68, 0x63, 0x4e, 0xbb, 0xab,
-  0xf9, 0xec, 0x05, 0x7b, 0x50, 0x68, 0x63, 0x8f, 0xfc, 0x2f, 0x03, 0xd1,
-  0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0xab, 0x00, 0x01, 0x00, 0x2a,
-  0x00, 0x00, 0x04, 0xc5, 0x06, 0x14, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x35,
-  0x34, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11,
-  0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x16,
-  0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23, 0x35, 0x02, 0xc9, 0x21, 0x21,
-  0x5b, 0x1e, 0x5a, 0x23, 0x22, 0xa6, 0x9f, 0x9f, 0x4e, 0x4e, 0xaa, 0x1b,
-  0xaa, 0x4f, 0x4c, 0x01, 0x55, 0xfe, 0xab, 0x22, 0x22, 0x67, 0xaa, 0xaa,
-  0xbf, 0x49, 0x49, 0x7a, 0x04, 0x60, 0x63, 0x68, 0x28, 0x28, 0x28, 0x28,
-  0x68, 0xfb, 0x3d, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0x55, 0x56, 0x56, 0x53,
-  0xbd, 0x4e, 0x8f, 0xfd, 0xa0, 0x89, 0x27, 0x27, 0x9a, 0x50, 0x4f, 0xd2,
-  0x02, 0x60, 0x8f, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe3, 0x06, 0x07,
-  0x05, 0xf0, 0x00, 0x59, 0x00, 0x00, 0x01, 0x15, 0x26, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15,
-  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x14,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23,
-  0x35, 0x33, 0x35, 0x34, 0x27, 0x26, 0x07, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x02, 0xfc, 0x4d, 0x42, 0x4c, 0x3f, 0x69, 0x39, 0x35, 0x2c, 0x2d, 0x85,
-  0x38, 0xb0, 0x95, 0x6e, 0x70, 0xc2, 0x57, 0x53, 0x57, 0x61, 0x5c, 0x59,
-  0x59, 0x57, 0x75, 0x3f, 0x3f, 0x2d, 0x28, 0xa0, 0x39, 0x9a, 0x44, 0x45,
-  0x5c, 0x65, 0xa3, 0x40, 0x46, 0x05, 0x53, 0x52, 0x92, 0x7e, 0x58, 0x55,
-  0x01, 0x55, 0xfe, 0xab, 0x21, 0x22, 0x67, 0xab, 0xab, 0xbf, 0x49, 0x49,
-  0x79, 0x79, 0x2b, 0x31, 0x3d, 0x3e, 0x31, 0x2f, 0x04, 0x3f, 0xae, 0x2b,
-  0x11, 0x14, 0x2a, 0x27, 0x57, 0x40, 0x25, 0x24, 0x21, 0x0e, 0x2b, 0x98,
-  0x89, 0x9c, 0x5b, 0x5b, 0x11, 0x12, 0x23, 0xbe, 0x35, 0x1a, 0x1b, 0x2d,
-  0x2c, 0x51, 0x4b, 0x28, 0x23, 0x2a, 0x0f, 0x24, 0x4a, 0x4b, 0x82, 0xa6,
-  0x4e, 0x56, 0x0b, 0x1d, 0x1f, 0x87, 0x5f, 0x5d, 0x01, 0x60, 0x5c, 0x88,
-  0x4c, 0x8f, 0xfd, 0xa0, 0x89, 0x27, 0x27, 0x9a, 0x50, 0x4f, 0xd2, 0x02,
-  0x60, 0x8f, 0x4e, 0x41, 0x2b, 0x32, 0x01, 0x31, 0x30, 0x40, 0x3d, 0x00,
-  0x00, 0x01, 0xfc, 0xcb, 0x06, 0x04, 0x00, 0x00, 0x07, 0x6e, 0x00, 0x07,
-  0x00, 0x00, 0x11, 0x22, 0x04, 0x07, 0x35, 0x36, 0x24, 0x33, 0xd0, 0xfe,
-  0x6a, 0xcf, 0xd5, 0x01, 0x97, 0xc9, 0x06, 0xd4, 0x67, 0x69, 0x7e, 0x77,
-  0x75, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x06, 0x04, 0x03, 0x35,
-  0x07, 0x6e, 0x00, 0x07, 0x00, 0x00, 0x11, 0x35, 0x32, 0x04, 0x17, 0x15,
-  0x26, 0x24, 0xc9, 0x01, 0x97, 0xd5, 0xcf, 0xfe, 0x6a, 0x06, 0xd4, 0x9a,
-  0x75, 0x77, 0x7e, 0x69, 0x67, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x72,
-  0x06, 0x0d, 0x00, 0x00, 0x07, 0x27, 0x00, 0x13, 0x00, 0x00, 0x11, 0x2f,
-  0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x04, 0x81, 0x19, 0x48, 0x27, 0x21,
-  0x5a, 0x30, 0x3f, 0x05, 0x91, 0x03, 0x66, 0x65, 0xb4, 0x52, 0x38, 0x32,
-  0x4f, 0x06, 0x48, 0x02, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x30, 0x47, 0x87,
-  0x4a, 0x49, 0x0e, 0x0d, 0x20, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
-  0x06, 0x0d, 0x02, 0x8e, 0x07, 0x27, 0x00, 0x13, 0x00, 0x00, 0x11, 0x1f,
-  0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x04, 0x81, 0x19, 0x48, 0x27, 0x21,
-  0x57, 0x33, 0x40, 0x04, 0x91, 0x03, 0x66, 0x65, 0xb4, 0x52, 0x38, 0x32,
-  0x4f, 0x06, 0xec, 0x02, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x2c, 0x4b, 0x87,
-  0x4a, 0x49, 0x0e, 0x0d, 0x20, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x1b,
-  0xff, 0x54, 0x07, 0x47, 0x07, 0x4c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x2a,
-  0x00, 0x00, 0x09, 0x04, 0x15, 0x33, 0x35, 0x27, 0x35, 0x34, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x0f, 0x01, 0x0e, 0x01, 0x1d, 0x01, 0x03, 0xb1, 0x03, 0x96, 0xfc, 0x6a,
-  0xfc, 0x6a, 0x03, 0x3a, 0xb7, 0x06, 0x06, 0x05, 0x07, 0x12, 0x14, 0x28,
-  0x4f, 0x53, 0x1e, 0x21, 0xc9, 0xa5, 0x5d, 0xae, 0x54, 0x57, 0xa1, 0x47,
-  0x61, 0x76, 0x2e, 0x33, 0x51, 0x51, 0x32, 0x07, 0x4c, 0xfc, 0x04, 0xfc,
-  0x04, 0x03, 0xfc, 0xfd, 0xae, 0xfe, 0xfe, 0x93, 0x7b, 0x34, 0x3c, 0x15,
-  0x19, 0x1a, 0x1f, 0x2b, 0x56, 0x5a, 0x40, 0x45, 0x4c, 0x9f, 0xc2, 0x38,
-  0x39, 0xbc, 0x43, 0x46, 0x6e, 0x59, 0x31, 0x5e, 0x35, 0x59, 0x56, 0x82,
-  0x65, 0x9a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xff, 0xe3, 0x05, 0x19,
-  0x05, 0xd5, 0x00, 0x07, 0x00, 0x0a, 0x00, 0x00, 0x37, 0x01, 0x33, 0x01,
-  0x07, 0x03, 0x21, 0x03, 0x13, 0x21, 0x03, 0x5a, 0x01, 0xf8, 0xcf, 0x01,
-  0xf8, 0x97, 0xae, 0xfd, 0xcb, 0xae, 0xec, 0x01, 0xb9, 0xdc, 0x23, 0x05,
-  0xb2, 0xfa, 0x4e, 0x40, 0x01, 0xf6, 0xfe, 0x0a, 0x02, 0xaa, 0x02, 0x7c,
-  0x00, 0x03, 0x00, 0xb4, 0xff, 0xed, 0x03, 0xac, 0x05, 0xe8, 0x00, 0x09,
-  0x00, 0x1a, 0x00, 0x24, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x01, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x21, 0x22, 0x27, 0x13, 0x11, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x56, 0x2f, 0xe2, 0x6b,
-  0x37, 0xb3, 0x9d, 0xfe, 0xfb, 0x7a, 0x5a, 0xd8, 0x92, 0xba, 0xc2, 0xc1,
-  0x6a, 0x99, 0xfe, 0xdd, 0x5a, 0x77, 0xa2, 0x64, 0xd2, 0x55, 0x28, 0xd5,
-  0xac, 0x02, 0x7e, 0xfe, 0x23, 0x72, 0x3b, 0x42, 0x59, 0x95, 0x03, 0x57,
-  0x13, 0x61, 0x7b, 0xd0, 0xd5, 0x7a, 0x7a, 0xe4, 0x8e, 0x70, 0xa4, 0x13,
-  0x05, 0x34, 0xfe, 0x15, 0x80, 0x3d, 0x38, 0x68, 0x8e, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x5a, 0xff, 0xe3, 0x03, 0x86, 0x05, 0xf3, 0x00, 0x05,
-  0x00, 0x00, 0x05, 0x09, 0x01, 0x17, 0x09, 0x01, 0x03, 0x14, 0xfd, 0x46,
-  0x02, 0xba, 0x72, 0xfd, 0xb9, 0x02, 0x47, 0x1d, 0x03, 0x08, 0x03, 0x08,
-  0x7f, 0xfd, 0x77, 0xfd, 0x77, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0x9f, 0x05, 0xd2, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
-  0x33, 0x11, 0x33, 0x20, 0x17, 0x16, 0x17, 0x16, 0x10, 0x07, 0x06, 0x04,
-  0x21, 0x37, 0x3e, 0x02, 0x10, 0x27, 0x2e, 0x01, 0x27, 0xb4, 0x51, 0x01,
-  0x5d, 0x8e, 0x90, 0x16, 0x09, 0x23, 0x32, 0xfe, 0xd9, 0xfe, 0xe2, 0x51,
-  0xb9, 0xb3, 0x3b, 0x09, 0x10, 0xa9, 0xe5, 0x05, 0xd2, 0x78, 0x7a, 0xf9,
-  0x65, 0xfe, 0x62, 0x7f, 0xb8, 0xad, 0xc0, 0x08, 0x63, 0xd4, 0x01, 0x7a,
-  0x5c, 0xac, 0x91, 0x0a, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0x40,
-  0x05, 0xf2, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x05, 0x07,
-  0x25, 0x11, 0x05, 0x07, 0x25, 0x11, 0x05, 0x07, 0x01, 0x56, 0xa2, 0x02,
-  0x8c, 0x1a, 0xfe, 0x30, 0x01, 0xea, 0x1a, 0xfe, 0x30, 0x01, 0xea, 0x1a,
-  0x01, 0x36, 0xfe, 0xca, 0x05, 0xf2, 0x75, 0xb2, 0x53, 0xfe, 0xc3, 0x58,
-  0xb2, 0x53, 0xfe, 0xc3, 0x58, 0xb2, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0x40, 0x05, 0xf2, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x05, 0x07, 0x25, 0x11, 0x05, 0x07, 0x01, 0x56, 0xa2, 0x02,
-  0x8c, 0x1a, 0xfe, 0x30, 0x01, 0xea, 0x1a, 0x03, 0x2a, 0xfc, 0xd6, 0x05,
-  0xf2, 0x75, 0xb2, 0x53, 0xfe, 0xc3, 0x58, 0xb2, 0x00, 0x01, 0x00, 0x87,
-  0x00, 0x00, 0x02, 0xa3, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x87, 0x02,
-  0x1c, 0xbd, 0xbd, 0xfd, 0xe4, 0xbd, 0xbd, 0x05, 0xd5, 0xb4, 0xfb, 0x93,
-  0xb4, 0xb4, 0x04, 0x6d, 0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xcc,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
-  0x11, 0x21, 0x01, 0x11, 0x21, 0x11, 0x05, 0x21, 0x11, 0x21, 0xb4, 0x03,
-  0x18, 0xfc, 0xe8, 0x02, 0x76, 0xfe, 0x2c, 0x01, 0xd4, 0xfe, 0x2c, 0x01,
-  0xd4, 0x05, 0xd5, 0xfa, 0x2b, 0x03, 0x45, 0x01, 0xdc, 0xfe, 0x24, 0xb4,
-  0xfe, 0x23, 0x00, 0x00, 0x00, 0x05, 0x00, 0x87, 0xff, 0xe3, 0x05, 0xfa,
-  0x05, 0xf3, 0x00, 0x0f, 0x00, 0x14, 0x00, 0x19, 0x00, 0x1e, 0x00, 0x23,
-  0x00, 0x00, 0x00, 0x02, 0x06, 0x04, 0x20, 0x24, 0x26, 0x02, 0x10, 0x12,
-  0x36, 0x24, 0x20, 0x04, 0x16, 0x12, 0x01, 0x36, 0x12, 0x37, 0x21, 0x03,
-  0x11, 0x21, 0x16, 0x12, 0x01, 0x21, 0x11, 0x06, 0x02, 0x01, 0x11, 0x21,
-  0x26, 0x02, 0x05, 0xfa, 0x6e, 0xbb, 0xfe, 0xfd, 0xfe, 0xe5, 0xfe, 0xfd,
-  0xbb, 0x6e, 0x6e, 0xbb, 0x01, 0x03, 0x01, 0x1b, 0x01, 0x03, 0xbb, 0x6e,
-  0xfd, 0x98, 0xae, 0xf7, 0x1b, 0xfe, 0x40, 0xa2, 0xfe, 0x3f, 0x1b, 0xf7,
-  0xfe, 0xee, 0x01, 0xc1, 0xaf, 0xf7, 0x02, 0x48, 0x01, 0xc0, 0x1b, 0xf7,
-  0x02, 0x4e, 0xfe, 0xe0, 0xd0, 0x7b, 0x7b, 0xd0, 0x01, 0x20, 0x01, 0x3a,
-  0x01, 0x20, 0xd0, 0x7b, 0x7b, 0xd0, 0xfe, 0xe0, 0xfd, 0x16, 0x1e, 0x01,
-  0x12, 0xc3, 0xfe, 0x0d, 0x01, 0xf3, 0xc3, 0xfe, 0xee, 0x02, 0x89, 0x01,
-  0xf3, 0x1e, 0xfe, 0xee, 0x01, 0x30, 0xfe, 0x0d, 0xc3, 0x01, 0x12, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x56, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0xb4, 0xa2, 0xa2, 0x05, 0xd5, 0xfa,
-  0x2b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xff, 0xe3, 0x04, 0x10,
-  0x05, 0xf3, 0x00, 0x0a, 0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x01,
-  0x17, 0x09, 0x01, 0x07, 0x01, 0x01, 0x56, 0xa2, 0xa2, 0x02, 0x47, 0x6c,
-  0xfd, 0x76, 0x02, 0x91, 0x6c, 0xfd, 0xb2, 0x05, 0xd5, 0xfd, 0xe1, 0x02,
-  0x3d, 0x86, 0xfd, 0x81, 0xfd, 0x7b, 0x86, 0x02, 0x43, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0x96, 0x05, 0xd5, 0x00, 0x06,
-  0x00, 0x00, 0x09, 0x01, 0x17, 0x01, 0x23, 0x11, 0x33, 0x01, 0x56, 0x01,
-  0xcc, 0x73, 0xfd, 0x92, 0x73, 0xa2, 0x01, 0x33, 0x02, 0x00, 0x80, 0xfd,
-  0x4d, 0x05, 0xd5, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x09, 0xbf,
-  0x05, 0xf3, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x09, 0x03, 0x17, 0x09,
-  0x03, 0x11, 0x23, 0xb4, 0x68, 0x02, 0x43, 0x01, 0xff, 0x01, 0xf7, 0x01,
-  0xf7, 0x73, 0xfd, 0x96, 0xfe, 0x0a, 0xfe, 0x09, 0xfd, 0xee, 0xa2, 0x05,
-  0xd5, 0xfd, 0xe5, 0x02, 0x39, 0xfd, 0xd1, 0x02, 0x2f, 0x80, 0xfd, 0x53,
-  0x02, 0x2e, 0xfd, 0xd2, 0x01, 0xee, 0xfb, 0x4c, 0x00, 0x01, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0xd2, 0x05, 0xf3, 0x00, 0x08, 0x00, 0x00, 0x13, 0x33,
-  0x09, 0x01, 0x17, 0x09, 0x01, 0x11, 0x23, 0xb4, 0x68, 0x02, 0x43, 0x01,
-  0xff, 0x74, 0xfd, 0x96, 0xfd, 0xee, 0xa2, 0x05, 0xd5, 0xfd, 0xe5, 0x02,
-  0x39, 0x80, 0xfd, 0x53, 0x01, 0xee, 0xfb, 0x4c, 0x00, 0x05, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0xf3, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x21,
-  0x11, 0x21, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x13, 0x11,
-  0x21, 0x11, 0x01, 0x56, 0x01, 0xac, 0xfd, 0xb2, 0x05, 0x3f, 0xfa, 0xc1,
-  0x02, 0xf0, 0x01, 0xad, 0xfc, 0x05, 0x01, 0xac, 0xa2, 0x01, 0xad, 0x02,
-  0x90, 0xfe, 0x24, 0x01, 0xdc, 0x03, 0x45, 0xfa, 0x2b, 0x05, 0x21, 0xfe,
-  0x24, 0x01, 0xdc, 0xfe, 0x24, 0x01, 0xdc, 0xfd, 0x6f, 0xfe, 0x24, 0x01,
-  0xdc, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x87, 0xff, 0xe3, 0x05, 0xfa,
-  0x05, 0xf3, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x27, 0x00, 0x00, 0x00, 0x36,
-  0x34, 0x2e, 0x02, 0x22, 0x0e, 0x02, 0x14, 0x1e, 0x02, 0x32, 0x36, 0x00,
-  0x02, 0x06, 0x04, 0x20, 0x24, 0x26, 0x02, 0x10, 0x12, 0x36, 0x24, 0x20,
-  0x04, 0x16, 0x12, 0x04, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x16, 0x05,
-  0x03, 0x55, 0x55, 0x8f, 0xc8, 0xd8, 0xc7, 0x8f, 0x55, 0x55, 0x8f, 0xc7,
-  0xd8, 0xc8, 0x01, 0x86, 0x6e, 0xbb, 0xfe, 0xfd, 0xfe, 0xe5, 0xfe, 0xfd,
-  0xbb, 0x6e, 0x6e, 0xbb, 0x01, 0x03, 0x01, 0x1b, 0x01, 0x03, 0xbb, 0x6e,
-  0xfd, 0xc4, 0x49, 0x69, 0x4a, 0x4a, 0x69, 0x49, 0x01, 0x94, 0xdf, 0xf0,
-  0xdf, 0x9e, 0x5f, 0x5f, 0x9e, 0xdf, 0xf0, 0xdf, 0x9e, 0x5f, 0x5f, 0x01,
-  0x58, 0xfe, 0xe0, 0xd0, 0x7b, 0x7b, 0xd0, 0x01, 0x20, 0x01, 0x3a, 0x01,
-  0x20, 0xd0, 0x7b, 0x7b, 0xd0, 0xfe, 0xe0, 0xd7, 0x52, 0x52, 0x74, 0x52,
-  0x52, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6a,
-  0x05, 0xe8, 0x00, 0x11, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x24, 0x21,
-  0x22, 0x07, 0x11, 0x23, 0x11, 0x36, 0x33, 0x20, 0x00, 0x11, 0x10, 0x05,
-  0x02, 0xd7, 0xf1, 0xfe, 0xf1, 0xfe, 0xfe, 0x2f, 0x32, 0xa2, 0x92, 0x71,
-  0x01, 0x3f, 0x01, 0x74, 0xfe, 0xa7, 0x02, 0x59, 0x66, 0xd4, 0xb6, 0xf9,
-  0x06, 0xfa, 0xc4, 0x05, 0xd4, 0x14, 0xfe, 0xbf, 0xfe, 0xec, 0xfe, 0xb0,
-  0x92, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x8d,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x33, 0x11, 0x33, 0x09, 0x01, 0x33,
-  0x11, 0x23, 0x11, 0x09, 0x01, 0x11, 0xb4, 0xa2, 0x01, 0xca, 0x01, 0xca,
-  0xa2, 0xa2, 0xfe, 0x36, 0xfe, 0x36, 0x05, 0xd5, 0xfd, 0xa2, 0x02, 0x5e,
-  0xfa, 0x2b, 0x04, 0xbd, 0xfd, 0xa1, 0x02, 0x5f, 0xfb, 0x43, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x87, 0x00, 0x00, 0x03, 0xb1, 0x05, 0xf2, 0x00, 0x0b,
-  0x00, 0x1d, 0x00, 0x00, 0x00, 0x34, 0x2e, 0x01, 0x22, 0x0e, 0x01, 0x14,
-  0x1e, 0x01, 0x32, 0x3e, 0x01, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23, 0x11,
-  0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x03, 0x0f,
-  0x41, 0x70, 0x84, 0x70, 0x41, 0x41, 0x70, 0x84, 0x70, 0xe3, 0x6e, 0x5c,
-  0x39, 0x41, 0xa2, 0x40, 0x3a, 0x5e, 0x6c, 0x6d, 0xba, 0xdc, 0xba, 0x6d,
-  0x03, 0xe7, 0x93, 0x7c, 0x48, 0x48, 0x7c, 0x93, 0x7d, 0x48, 0x48, 0x4c,
-  0xd1, 0x3b, 0x25, 0x0e, 0xfd, 0x89, 0x02, 0x77, 0x0e, 0x25, 0x3c, 0xd0,
-  0xf4, 0xcf, 0x79, 0x79, 0xcf, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0xd7, 0x05, 0xe9, 0x00, 0x0c, 0x00, 0x17, 0x00, 0x00,
-  0x08, 0x01, 0x15, 0x14, 0x02, 0x07, 0x06, 0x23, 0x11, 0x23, 0x11, 0x36,
-  0x33, 0x03, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x02, 0x8f, 0x01, 0x48, 0xb4, 0xe6, 0x6a, 0x7d, 0xa2, 0x92, 0x71, 0x61,
-  0xee, 0x78, 0x79, 0x7d, 0x67, 0xab, 0x26, 0x2a, 0x05, 0xe9, 0xfe, 0xe5,
-  0xfc, 0x8d, 0xfe, 0xd1, 0x4e, 0x24, 0xfe, 0x5c, 0x05, 0xd5, 0x14, 0xfc,
-  0x6f, 0x73, 0x72, 0x96, 0x9e, 0x6c, 0x58, 0x04, 0x00, 0x01, 0x00, 0x87,
-  0xff, 0xf2, 0x02, 0xa7, 0x05, 0xea, 0x00, 0x09, 0x00, 0x00, 0x09, 0x03,
-  0x07, 0x09, 0x03, 0x17, 0x01, 0x6c, 0x01, 0x3b, 0xfe, 0xc5, 0x01, 0x02,
-  0x73, 0xfe, 0x8c, 0x01, 0x3b, 0xfe, 0xc5, 0x01, 0x74, 0x73, 0x04, 0x4c,
-  0xfe, 0xa2, 0xfe, 0xa2, 0xfe, 0xe2, 0x80, 0x01, 0x9e, 0x01, 0x5e, 0x01,
-  0x5e, 0x01, 0x9e, 0x80, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x04, 0x7d,
-  0x05, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x01, 0x07, 0x25, 0x11, 0x23, 0x11,
-  0x25, 0x37, 0x04, 0x7c, 0x32, 0xfe, 0x60, 0xa2, 0xfe, 0x52, 0x32, 0x04,
-  0x8a, 0xac, 0x95, 0xfb, 0x8d, 0x04, 0xad, 0x99, 0xac, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x3c, 0x05, 0xea, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x17, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x03, 0xc8,
-  0x74, 0xfd, 0x1a, 0xa2, 0xa2, 0x05, 0xea, 0x80, 0xfc, 0xc9, 0xfd, 0xcd,
-  0x05, 0xd5, 0xfd, 0x5c, 0x00, 0x01, 0x00, 0x87, 0xff, 0xe3, 0x04, 0x6a,
-  0x05, 0xf2, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01, 0x37, 0x09, 0x01, 0x17,
-  0x09, 0x01, 0x07, 0x09, 0x01, 0x27, 0x02, 0x16, 0xfe, 0x71, 0x87, 0x01,
-  0x6a, 0x01, 0x6a, 0x88, 0xfe, 0x71, 0x01, 0x8f, 0x88, 0xfe, 0x96, 0xfe,
-  0x96, 0x87, 0x02, 0xed, 0x02, 0xa3, 0x62, 0xfd, 0xa1, 0x02, 0x5f, 0x62,
-  0xfd, 0x5d, 0xfd, 0x58, 0x62, 0x02, 0x64, 0xfd, 0x9c, 0x62, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x87, 0x00, 0x00, 0x04, 0x65, 0x05, 0xd5, 0x00, 0x13,
-  0x00, 0x1b, 0x00, 0x24, 0x00, 0x00, 0x21, 0x23, 0x35, 0x26, 0x27, 0x26,
-  0x10, 0x37, 0x36, 0x37, 0x35, 0x33, 0x15, 0x16, 0x17, 0x16, 0x10, 0x07,
-  0x06, 0x07, 0x19, 0x01, 0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x03, 0x11,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x02, 0xc7, 0xa2, 0x99, 0x74,
-  0x91, 0x91, 0x73, 0x9a, 0xa2, 0x99, 0x74, 0x91, 0x91, 0x73, 0x9a, 0x56,
-  0x44, 0x62, 0x62, 0x44, 0xf8, 0x56, 0x44, 0x62, 0x62, 0x44, 0xcc, 0x1a,
-  0x80, 0xa1, 0x01, 0xc7, 0xa2, 0x80, 0x1a, 0xcb, 0xcb, 0x1a, 0x80, 0xa1,
-  0xfe, 0x39, 0xa2, 0x80, 0x1a, 0x03, 0x87, 0xfd, 0x30, 0x17, 0x4c, 0x6c,
-  0x01, 0x32, 0x6c, 0x4b, 0xfd, 0x48, 0x02, 0xd0, 0x17, 0x4c, 0x6e, 0x98,
-  0x96, 0x6e, 0x4c, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x05, 0x7b,
-  0x05, 0xf2, 0x00, 0x0b, 0x00, 0x00, 0x21, 0x23, 0x11, 0x01, 0x37, 0x01,
-  0x11, 0x33, 0x11, 0x01, 0x17, 0x01, 0x03, 0x3b, 0xa2, 0xfd, 0xc1, 0x73,
-  0x01, 0xcc, 0xa2, 0x01, 0xcc, 0x73, 0xfd, 0xc1, 0x02, 0xf4, 0x02, 0x7e,
-  0x80, 0xfe, 0x00, 0x01, 0xe3, 0xfe, 0x1d, 0x02, 0x00, 0x80, 0xfd, 0x82,
-  0x00, 0x03, 0x00, 0x87, 0xff, 0xf1, 0x03, 0x45, 0x05, 0xb9, 0x00, 0x07,
-  0x00, 0x1d, 0x00, 0x25, 0x00, 0x00, 0x00, 0x34, 0x26, 0x22, 0x06, 0x14,
-  0x16, 0x32, 0x24, 0x06, 0x20, 0x26, 0x10, 0x37, 0x36, 0x37, 0x26, 0x27,
-  0x26, 0x10, 0x36, 0x20, 0x16, 0x10, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
-  0x02, 0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0x32, 0x02, 0xa3, 0x6f, 0x9c,
-  0x6f, 0x6f, 0x9c, 0x01, 0x11, 0xce, 0xfe, 0xde, 0xce, 0x67, 0x2a, 0x31,
-  0x31, 0x2a, 0x67, 0xce, 0x01, 0x22, 0xce, 0x67, 0x2a, 0x31, 0x31, 0x2a,
-  0x67, 0xa2, 0x6f, 0x9c, 0x6f, 0x6f, 0x9c, 0x01, 0x20, 0xae, 0x7b, 0x7b,
-  0xae, 0x7b, 0x31, 0xe5, 0xe5, 0x01, 0x42, 0x73, 0x2f, 0x1b, 0x1c, 0x2e,
-  0x72, 0x01, 0x43, 0xe5, 0xe5, 0xfe, 0xbe, 0x73, 0x2f, 0x1b, 0x1c, 0x2e,
-  0x72, 0x01, 0xc3, 0xae, 0x7b, 0x7b, 0xae, 0x7b, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x03, 0x7d, 0x05, 0xe8, 0x00, 0x0a, 0x00, 0x13, 0x00, 0x00,
-  0x33, 0x11, 0x36, 0x33, 0x32, 0x04, 0x15, 0x14, 0x04, 0x23, 0x19, 0x01,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0xb4, 0x77, 0x74, 0xdb,
-  0x01, 0x03, 0xfe, 0xcb, 0xf2, 0xb6, 0xcf, 0xa2, 0x92, 0x26, 0x2b, 0x05,
-  0xd5, 0x13, 0xe6, 0xbd, 0xd0, 0xdc, 0xfd, 0x67, 0x03, 0x4e, 0x7f, 0x76,
-  0x63, 0x9c, 0x06, 0x00, 0x00, 0x02, 0x00, 0xb4, 0xff, 0xed, 0x03, 0x7d,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x14, 0x00, 0x00, 0x13, 0x33, 0x11, 0x32,
-  0x04, 0x15, 0x14, 0x04, 0x23, 0x22, 0x27, 0x13, 0x30, 0x11, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0xb4, 0xa2, 0xf2, 0x01, 0x35, 0xfe, 0xfd,
-  0xdb, 0x74, 0x77, 0xa2, 0x2b, 0x26, 0x92, 0xa2, 0xcf, 0x05, 0xd5, 0xfd,
-  0x67, 0xdc, 0xd0, 0xbd, 0xe6, 0x13, 0x02, 0x87, 0xfe, 0x12, 0x06, 0x9c,
-  0x63, 0x76, 0x7f, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x02, 0x76,
-  0x05, 0xd5, 0x00, 0x07, 0x00, 0x00, 0x13, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x23, 0x11, 0x5a, 0x01, 0x7a, 0xa2, 0xa2, 0x02, 0x91, 0xb4, 0x02, 0x90,
-  0xfa, 0x2b, 0x02, 0x91, 0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x05, 0x19,
-  0x05, 0xf2, 0x00, 0x06, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01, 0x23, 0x01,
-  0x37, 0x09, 0x01, 0x00, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x16, 0x05,
-  0x19, 0xfe, 0x08, 0xcf, 0xfe, 0x08, 0x97, 0x01, 0xc9, 0x01, 0xc8, 0xfe,
-  0xb6, 0x4a, 0x69, 0x49, 0x49, 0x69, 0x4a, 0x05, 0xb2, 0xfa, 0x4e, 0x05,
-  0xb2, 0x40, 0xfa, 0xda, 0x05, 0x26, 0xfd, 0xd8, 0x52, 0x52, 0x74, 0x52,
-  0x52, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x56,
-  0x05, 0xd5, 0x12, 0x06, 0x0f, 0x22, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0xff, 0xe3, 0x05, 0x19, 0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x37, 0x01,
-  0x33, 0x01, 0x07, 0x09, 0x01, 0x5a, 0x01, 0xf8, 0xcf, 0x01, 0xf8, 0x97,
-  0xfe, 0x38, 0xfe, 0x37, 0x23, 0x05, 0xb2, 0xfa, 0x4e, 0x40, 0x05, 0x26,
-  0xfa, 0xda, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0xff, 0xe3, 0x04, 0x6a,
-  0x05, 0xf2, 0x12, 0x06, 0x0f, 0x30, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
-  0x00, 0x00, 0x05, 0x8a, 0x05, 0xf3, 0x00, 0x08, 0x00, 0x00, 0x13, 0x09,
-  0x01, 0x07, 0x01, 0x11, 0x23, 0x11, 0x01, 0x5a, 0x02, 0x81, 0x02, 0xaf,
-  0x6e, 0xfe, 0x12, 0xa2, 0xfe, 0x41, 0x03, 0x2c, 0x02, 0xc7, 0xfd, 0x3b,
-  0x84, 0x01, 0xfe, 0xfb, 0x58, 0x04, 0x9d, 0xfe, 0x0f, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x99, 0x01, 0xe0, 0x05, 0xdc, 0x02, 0xa8, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x05, 0x35,
-  0x21, 0x15, 0x29, 0x01, 0x35, 0x21, 0x01, 0xca, 0xfe, 0xcf, 0x01, 0x31,
-  0x02, 0xe0, 0x01, 0x31, 0xfd, 0xf7, 0xfe, 0xd0, 0x01, 0x30, 0x01, 0xe0,
-  0xc8, 0xc8, 0xc8, 0xc8, 0xc8, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x01, 0x37, 0x05, 0xdc, 0x04, 0x0e, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0xff, 0x58, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x46, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x01, 0x3a, 0x05, 0xdc, 0x04, 0x0a, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x62, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00,
-  0x01, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x01, 0x3d, 0x05, 0xdc,
-  0x04, 0x0b, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xff, 0x5d, 0x10, 0x07,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x01, 0x3b, 0x05, 0xdc, 0x04, 0x0a, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x01, 0x3c, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x62, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x01, 0x3d, 0x05, 0xdc, 0x04, 0x0a, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xff, 0x5d, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
-  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
-  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06,
-  0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26,
-  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c,
-  0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb3,
-  0x00, 0x00, 0x04, 0x80, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
-  0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00,
-  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x07,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26,
-  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00,
-  0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x26,
-  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26,
-  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c,
-  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0f, 0x3c,
-  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26,
-  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80,
-  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
-  0x01, 0x80, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
-  0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
-  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0f, 0x3c,
-  0x00, 0x00, 0xfe, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4,
-  0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x06, 0x0b, 0xb3,
-  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
-  0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0b, 0xb4,
-  0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
-  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
-  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00,
-  0xfe, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x06, 0x0f, 0x3c,
-  0x00, 0xa0, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x06,
-  0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb4,
-  0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
-  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07,
-  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c,
-  0x00, 0xa0, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0xfe, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07, 0x0f, 0x3c,
-  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
-  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
-  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06,
-  0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00,
-  0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
-  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x06,
-  0x0b, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
-  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
-  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
-  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb4,
-  0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
-  0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
-  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00,
-  0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c,
-  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x01, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0f, 0x3c,
-  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
-  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
-  0x01, 0x80, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
-  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
-  0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
-  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26,
-  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
-  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
-  0x01, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07, 0x0f, 0x3c,
-  0x00, 0x00, 0xfe, 0x20, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x46,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x23,
-  0x01, 0x33, 0x09, 0x01, 0x21, 0x03, 0x21, 0x03, 0x23, 0x01, 0x17, 0x01,
-  0x21, 0x03, 0x07, 0xb9, 0x01, 0xbd, 0xb9, 0xfe, 0x81, 0x02, 0x01, 0xfe,
-  0x86, 0x89, 0xfd, 0xc0, 0x89, 0x6c, 0x02, 0x00, 0x16, 0xff, 0x00, 0x01,
-  0xff, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x71, 0xfa, 0x2b, 0x01, 0xa1, 0xfe,
-  0x5f, 0x05, 0xd5, 0xc7, 0xfc, 0xf7, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xc7, 0x05, 0xd5, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x1c,
-  0x00, 0x20, 0x00, 0x25, 0x00, 0x2a, 0x00, 0x00, 0x13, 0x21, 0x32, 0x16,
-  0x15, 0x14, 0x07, 0x16, 0x11, 0x14, 0x06, 0x23, 0x21, 0x01, 0x11, 0x33,
-  0x32, 0x37, 0x11, 0x26, 0x23, 0x03, 0x11, 0x33, 0x36, 0x33, 0x11, 0x26,
-  0x23, 0x21, 0x11, 0x33, 0x11, 0x01, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x36,
-  0x35, 0x34, 0x27, 0xb5, 0x02, 0x29, 0xcf, 0xe1, 0xac, 0xe4, 0xf5, 0xe1,
-  0xfd, 0xc5, 0x01, 0x68, 0xd3, 0x35, 0x2d, 0x2d, 0x35, 0xd3, 0xc1, 0x20,
-  0x1d, 0x1d, 0x20, 0xfe, 0x31, 0xb6, 0x01, 0xec, 0xbb, 0xbb, 0x38, 0xbb,
-  0xbb, 0x05, 0xd5, 0xc0, 0xb1, 0xe5, 0x5d, 0x61, 0xfe, 0xe1, 0xc8, 0xda,
-  0x02, 0xe9, 0xfd, 0x7b, 0x07, 0x02, 0x77, 0x07, 0x02, 0x88, 0xfd, 0xdc,
-  0x03, 0x02, 0x1f, 0x02, 0xfa, 0xf3, 0x05, 0x0d, 0xfb, 0x11, 0x44, 0xdc,
-  0xe5, 0x44, 0x96, 0x36, 0xcd, 0xc4, 0x36, 0x00, 0x00, 0x04, 0x00, 0xd0,
-  0x00, 0x00, 0x05, 0x95, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x10, 0x00, 0x14,
-  0x00, 0x19, 0x00, 0x00, 0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x29,
-  0x01, 0x01, 0x13, 0x33, 0x32, 0x37, 0x11, 0x26, 0x23, 0x21, 0x11, 0x33,
-  0x03, 0x01, 0x36, 0x11, 0x10, 0x27, 0xd1, 0x01, 0xcf, 0x01, 0x87, 0x01,
-  0x6d, 0xfe, 0x91, 0xfe, 0x7b, 0xfe, 0x31, 0x01, 0x6a, 0x01, 0x59, 0xdc,
-  0x90, 0x90, 0xdd, 0xfe, 0x98, 0xb6, 0x01, 0x02, 0x7f, 0xc8, 0xc8, 0x05,
-  0xd5, 0xfe, 0x97, 0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x05, 0x71, 0xfa,
-  0xf3, 0x41, 0x04, 0x8b, 0x41, 0xfa, 0xf3, 0x05, 0x0d, 0xfb, 0x6b, 0x95,
-  0x01, 0x7b, 0x01, 0x71, 0x9c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0xcb, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x11, 0x25, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
-  0x11, 0x21, 0x15, 0x21, 0x01, 0x0f, 0xb6, 0xfe, 0xf0, 0x04, 0x05, 0xfd,
-  0x65, 0x02, 0x80, 0xfd, 0x80, 0x02, 0xac, 0xfb, 0xea, 0x05, 0x71, 0xfa,
-  0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfd, 0xe4, 0x64, 0xfd, 0x73, 0x64, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x09,
-  0x00, 0x0d, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
-  0x11, 0x21, 0x01, 0x23, 0x11, 0x33, 0xb5, 0x03, 0xb9, 0xfd, 0xb1, 0x02,
-  0x15, 0xfd, 0xeb, 0xfe, 0x96, 0x01, 0x10, 0xb6, 0xb6, 0x05, 0xd5, 0x64,
-  0xfd, 0xe4, 0x64, 0xfd, 0x0f, 0x05, 0x71, 0xfa, 0xf3, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe, 0x05, 0xf0, 0x00, 0x1d,
-  0x00, 0x26, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x11, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x37, 0x11, 0x21, 0x35, 0x21, 0x11, 0x0e, 0x01,
-  0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x01, 0x11,
-  0x06, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16, 0x04, 0xda, 0x72, 0xea, 0x78,
-  0xa8, 0x7a, 0x7a, 0xa8, 0x82, 0x73, 0x5b, 0x4d, 0xfe, 0x7d, 0x01, 0xdd,
-  0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01, 0x3b, 0x83,
-  0xed, 0x64, 0xfc, 0xb0, 0x19, 0x17, 0x98, 0x98, 0x17, 0x04, 0xe4, 0x61,
-  0x47, 0x40, 0xfb, 0x3b, 0x40, 0x26, 0x1f, 0x35, 0x01, 0xe7, 0x64, 0xfd,
-  0x7f, 0x53, 0x55, 0x01, 0x99, 0x01, 0x6d, 0x01, 0x6e, 0x01, 0x99, 0x48,
-  0x46, 0xfb, 0x63, 0x04, 0x49, 0x16, 0x1a, 0xaf, 0xfe, 0xba, 0xfe, 0xbb,
-  0xaf, 0x1a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5b, 0x00, 0x00, 0x02, 0x78,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
-  0x25, 0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23,
-  0x01, 0x10, 0xb6, 0xfe, 0x96, 0x02, 0x1c, 0x5a, 0x5a, 0xfd, 0xe4, 0x5a,
-  0x5a, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0xf3, 0x64,
-  0x64, 0x05, 0x0d, 0x00, 0x00, 0x02, 0xff, 0xa0, 0xfe, 0x66, 0x02, 0x1d,
-  0x05, 0xd5, 0x00, 0x08, 0x00, 0x14, 0x00, 0x00, 0x01, 0x11, 0x14, 0x07,
-  0x36, 0x37, 0x36, 0x35, 0x11, 0x25, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x36, 0x35, 0x01, 0x0f, 0x4d, 0x81, 0x39, 0x47, 0xfe,
-  0xf2, 0x01, 0x68, 0xb9, 0xcc, 0xf7, 0x38, 0x79, 0x63, 0x05, 0x71, 0xfa,
-  0xb1, 0xf2, 0x64, 0x0a, 0x4a, 0x5e, 0xea, 0x05, 0x09, 0x64, 0xfa, 0x93,
-  0xfe, 0xf2, 0xf4, 0x64, 0x96, 0xc2, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x92, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00,
-  0x13, 0x21, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x21, 0x13,
-  0x11, 0x33, 0x11, 0xb5, 0x01, 0x68, 0x02, 0xb6, 0x8f, 0xfc, 0xf9, 0x03,
-  0x37, 0x8a, 0xfd, 0x15, 0xfe, 0x98, 0x5a, 0xb6, 0x05, 0xd5, 0xfd, 0x89,
-  0x02, 0x77, 0xfd, 0x40, 0xfc, 0xeb, 0x02, 0xcf, 0xfd, 0x31, 0x05, 0x71,
-  0xfa, 0xf3, 0x05, 0x0d, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xad,
-  0x05, 0xd5, 0x00, 0x05, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x13, 0x11, 0x33, 0x11, 0xb5, 0x01, 0x6a, 0x02, 0x8e, 0xfc,
-  0x08, 0x5a, 0xb6, 0x05, 0xd5, 0xfa, 0x8f, 0x64, 0x05, 0x6f, 0xfa, 0xf3,
-  0x05, 0x0d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb0, 0x00, 0x00, 0x06, 0xb1,
-  0x05, 0xd5, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x14, 0x00, 0x00, 0x21, 0x11,
-  0x01, 0x23, 0x01, 0x03, 0x21, 0x11, 0x21, 0x09, 0x01, 0x21, 0x11, 0x01,
-  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x05, 0x47, 0xfe, 0x89, 0x40,
-  0xfe, 0x8b, 0x01, 0xfe, 0x96, 0x01, 0xa9, 0x01, 0x57, 0x01, 0x59, 0x01,
-  0xa8, 0xfe, 0xf0, 0xb6, 0xfa, 0xb3, 0xb6, 0x05, 0x71, 0xfb, 0xae, 0x04,
-  0x52, 0xfa, 0x8f, 0x05, 0xd5, 0xfc, 0x08, 0x03, 0xf8, 0xfa, 0x2b, 0x05,
-  0x71, 0xfa, 0xf3, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x0d, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x66, 0xff, 0xe3, 0x05, 0x45, 0x05, 0xf0, 0x00, 0x0f,
-  0x00, 0x17, 0x00, 0x1f, 0x00, 0x27, 0x00, 0x28, 0x00, 0x00, 0x01, 0x20,
-  0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x11, 0x10,
-  0x37, 0x36, 0x13, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22, 0x07, 0x03, 0x11,
-  0x06, 0x07, 0x06, 0x10, 0x17, 0x16, 0x01, 0x11, 0x36, 0x37, 0x36, 0x10,
-  0x27, 0x26, 0x01, 0x02, 0xd5, 0x01, 0x1b, 0xa9, 0xab, 0xaa, 0xaa, 0xfe,
-  0xe5, 0xfe, 0xe5, 0xa9, 0xaa, 0xaa, 0xa9, 0x40, 0x61, 0xf5, 0x61, 0x61,
-  0xf5, 0x61, 0x5f, 0x20, 0x1d, 0x8b, 0x8b, 0x1d, 0x02, 0x95, 0x1f, 0x1c,
-  0x8b, 0x8b, 0x1c, 0xfc, 0x38, 0x05, 0xf0, 0xd2, 0xd5, 0xfe, 0xa0, 0xfe,
-  0xa1, 0xd4, 0xd3, 0xd3, 0xd2, 0x01, 0x61, 0x01, 0x62, 0xd3, 0xd2, 0xfa,
-  0x8e, 0x32, 0x32, 0x04, 0xd7, 0x32, 0x32, 0xfb, 0x6a, 0x04, 0x54, 0x1d,
-  0x25, 0xb6, 0xfd, 0x9c, 0xb5, 0x25, 0x04, 0x35, 0xfb, 0xaf, 0x1d, 0x24,
-  0xb6, 0x02, 0x63, 0xb6, 0x24, 0xfd, 0xf4, 0x00, 0x00, 0x02, 0x00, 0x7a,
-  0xff, 0xdc, 0x04, 0x29, 0x05, 0xf6, 0x00, 0x11, 0x00, 0x2d, 0x00, 0x00,
-  0x01, 0x06, 0x10, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x10, 0x07, 0x36, 0x10,
-  0x26, 0x2f, 0x01, 0x2e, 0x01, 0x34, 0x25, 0x15, 0x26, 0x20, 0x06, 0x14,
-  0x16, 0x1f, 0x01, 0x1e, 0x01, 0x10, 0x04, 0x20, 0x27, 0x35, 0x16, 0x20,
-  0x36, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x10, 0x36, 0x20, 0x01, 0x2e,
-  0x5a, 0x7b, 0x9b, 0x64, 0x98, 0x97, 0x22, 0x74, 0x8d, 0x99, 0x63, 0x9e,
-  0x8e, 0x02, 0xc0, 0xb9, 0xfe, 0xe5, 0x92, 0x62, 0x85, 0x63, 0xb6, 0xb5,
-  0xfe, 0xfd, 0xfe, 0x44, 0xeb, 0xc9, 0x01, 0x43, 0x98, 0x6e, 0x7c, 0x64,
-  0xb6, 0xa5, 0xfb, 0x01, 0x98, 0x05, 0x2d, 0x5b, 0xfe, 0xca, 0x9a, 0x29,
-  0x1a, 0x27, 0xb9, 0xfe, 0xff, 0x4e, 0x58, 0x01, 0x64, 0xbb, 0x27, 0x1b,
-  0x27, 0x9d, 0xe3, 0xb4, 0x70, 0x75, 0x89, 0xe9, 0x69, 0x24, 0x1b, 0x32,
-  0xeb, 0xfe, 0x58, 0xee, 0x66, 0x7c, 0x95, 0x92, 0xfd, 0x86, 0x20, 0x1a,
-  0x2f, 0xcf, 0x01, 0x8c, 0xf4, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xfa,
-  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00,
-  0x01, 0x11, 0x33, 0x11, 0x25, 0x21, 0x15, 0x21, 0x11, 0x21, 0x11, 0x21,
-  0x02, 0x33, 0xb4, 0xfd, 0x14, 0x05, 0x23, 0xfe, 0x23, 0xfe, 0x98, 0xfe,
-  0x22, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0x8f, 0x05,
-  0x71, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x9f, 0xff, 0xe3, 0x05, 0x5b,
-  0x05, 0xd5, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x11,
-  0x10, 0x07, 0x24, 0x19, 0x01, 0x21, 0x11, 0x10, 0x05, 0x26, 0x13, 0x11,
-  0x25, 0x21, 0x11, 0x14, 0x16, 0x20, 0x36, 0x35, 0x11, 0x21, 0x11, 0x10,
-  0x00, 0x20, 0x00, 0x11, 0x04, 0x4c, 0x4f, 0x01, 0x04, 0xfb, 0xf8, 0x01,
-  0x04, 0x50, 0x01, 0xfe, 0xf1, 0x01, 0x69, 0x73, 0x01, 0x04, 0x73, 0x01,
-  0x69, 0xfe, 0xce, 0xfd, 0xa8, 0xfe, 0xce, 0x05, 0x71, 0xfc, 0x99, 0xfe,
-  0xe6, 0x82, 0x62, 0x01, 0x61, 0x03, 0x40, 0xfc, 0xc0, 0xfe, 0x9e, 0x60,
-  0x7c, 0x01, 0x1f, 0x03, 0x67, 0x64, 0xfc, 0x35, 0xf0, 0xd3, 0xd3, 0xf0,
-  0x03, 0xcb, 0xfc, 0x5c, 0xfe, 0xdc, 0xfe, 0xd6, 0x01, 0x2a, 0x01, 0x24,
-  0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x25, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x0a, 0x00, 0x00, 0x13, 0x01, 0x33, 0x01, 0x25, 0x21, 0x09, 0x01,
-  0x33, 0x01, 0x21, 0x8b, 0x01, 0xbc, 0xb4, 0xfe, 0x44, 0xfe, 0xcf, 0x01,
-  0x68, 0x01, 0xaa, 0x01, 0xab, 0x5a, 0xfe, 0x00, 0xfe, 0xea, 0x05, 0x71,
-  0xfa, 0xf3, 0x05, 0x0d, 0x64, 0xfb, 0x17, 0x04, 0xe9, 0xfa, 0x2b, 0x00,
-  0x00, 0x03, 0x00, 0x3d, 0x00, 0x00, 0x07, 0xd0, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x14, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x21, 0x01,
-  0x33, 0x01, 0x25, 0x21, 0x09, 0x01, 0x21, 0x09, 0x01, 0x33, 0x01, 0x21,
-  0x09, 0x01, 0x21, 0x04, 0x4a, 0x01, 0x24, 0xb4, 0xfe, 0xdc, 0xfb, 0xb0,
-  0x01, 0x23, 0xb4, 0xfe, 0xdd, 0xfe, 0xdb, 0x01, 0x68, 0x01, 0x1b, 0x01,
-  0x1a, 0x01, 0x68, 0x01, 0x1a, 0x01, 0x1a, 0x5a, 0xfe, 0xae, 0xfe, 0xa3,
-  0xfe, 0xe5, 0xfe, 0xe1, 0xfe, 0xa7, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d,
-  0xfa, 0xf3, 0x05, 0x0d, 0x64, 0xfb, 0x12, 0x04, 0xee, 0xfb, 0x12, 0x04,
-  0xee, 0xfa, 0x2b, 0x05, 0x10, 0xfa, 0xf0, 0x00, 0x00, 0x02, 0x00, 0x61,
-  0x00, 0x00, 0x05, 0x6c, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
-  0x09, 0x01, 0x33, 0x01, 0x25, 0x21, 0x09, 0x01, 0x33, 0x09, 0x01, 0x21,
-  0x09, 0x01, 0x23, 0x01, 0x01, 0x0a, 0x03, 0x06, 0xb3, 0xfc, 0xfa, 0xfe,
-  0xa4, 0x01, 0x8c, 0x01, 0x51, 0x01, 0x5d, 0x58, 0xfe, 0x78, 0x02, 0x01,
-  0xfe, 0x74, 0xfe, 0xaf, 0xfe, 0xa3, 0x5a, 0x01, 0x8a, 0x05, 0x71, 0xfa,
-  0xf3, 0x05, 0x0d, 0x64, 0xfd, 0xce, 0x02, 0x32, 0xfd, 0x84, 0xfc, 0xa7,
-  0x02, 0x32, 0xfd, 0xce, 0x02, 0x7b, 0x00, 0x00, 0x00, 0x02, 0xff, 0xfc,
-  0x00, 0x00, 0x05, 0x1b, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x0e, 0x00, 0x00,
-  0x09, 0x01, 0x33, 0x01, 0x11, 0x21, 0x11, 0x01, 0x21, 0x09, 0x01, 0x23,
-  0x01, 0x11, 0x33, 0x03, 0x16, 0x01, 0xab, 0x5a, 0xfe, 0x25, 0xfe, 0x98,
-  0xfe, 0x24, 0x01, 0x6c, 0x01, 0x7f, 0xfe, 0x61, 0xb4, 0x01, 0x9e, 0xb5,
-  0x03, 0x13, 0x02, 0xc2, 0xfc, 0xf2, 0xfd, 0x39, 0x02, 0xc7, 0x03, 0x0e,
-  0xfc, 0xf2, 0x02, 0xaa, 0xfd, 0x56, 0xfd, 0x9d, 0x00, 0x04, 0x00, 0x6e,
-  0xff, 0xe3, 0x04, 0x1e, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x22, 0x00, 0x2c,
-  0x00, 0x33, 0x00, 0x00, 0x01, 0x34, 0x26, 0x27, 0x16, 0x15, 0x11, 0x33,
-  0x13, 0x11, 0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
-  0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
-  0x33, 0x20, 0x16, 0x01, 0x35, 0x23, 0x22, 0x07, 0x11, 0x3e, 0x01, 0x37,
-  0x36, 0x05, 0x11, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x03, 0xc4, 0x87, 0x37,
-  0x44, 0x7a, 0x5a, 0xfe, 0xd2, 0x39, 0xa9, 0x4e, 0x9b, 0xb6, 0xe3, 0xe2,
-  0xbc, 0x6a, 0x88, 0x56, 0xa4, 0x4c, 0x6c, 0xc8, 0x33, 0x01, 0x01, 0xfe,
-  0xfe, 0xd2, 0xbc, 0x30, 0x2b, 0x55, 0x58, 0x35, 0x35, 0xfe, 0x8f, 0x3c,
-  0x7a, 0x6d, 0x02, 0x7f, 0xd3, 0x86, 0x18, 0x5d, 0x88, 0xfd, 0x59, 0x02,
-  0x1b, 0xfd, 0x81, 0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x48, 0x7f,
-  0x8b, 0x2e, 0x2e, 0x74, 0x27, 0x27, 0xfc, 0xfe, 0x8b, 0x55, 0x04, 0xfd,
-  0xed, 0x04, 0x4e, 0x48, 0x47, 0xdc, 0x01, 0xfd, 0x12, 0x67, 0x8b, 0x77,
-  0x74, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x85, 0xff, 0xe3, 0x04, 0x92,
-  0x06, 0x14, 0x00, 0x0f, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00,
-  0x13, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22,
-  0x26, 0x27, 0x15, 0x21, 0x01, 0x34, 0x27, 0x26, 0x27, 0x11, 0x36, 0x37,
-  0x36, 0x37, 0x36, 0x01, 0x11, 0x33, 0x11, 0x01, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x85, 0x01,
-  0x2d, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0xfe,
-  0xd3, 0x03, 0xaa, 0x55, 0x27, 0x36, 0x36, 0x27, 0x34, 0x14, 0x0d, 0xfc,
-  0xb0, 0x79, 0x01, 0xc6, 0x16, 0x18, 0x94, 0x44, 0x45, 0x14, 0x0c, 0x55,
-  0x54, 0x94, 0x18, 0x16, 0x06, 0x14, 0xfd, 0xa2, 0x64, 0x61, 0xfe, 0xbc,
-  0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x02, 0x74, 0x9f, 0x82, 0x3d,
-  0x20, 0xfc, 0x7a, 0x20, 0x3d, 0x4f, 0x73, 0x4b, 0x03, 0xda, 0xfa, 0xac,
-  0x05, 0x54, 0xfe, 0x64, 0x03, 0x69, 0x68, 0x74, 0x4a, 0x9e, 0x9f, 0x82,
-  0x82, 0x03, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
-  0x04, 0x7b, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01,
-  0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x17, 0x15, 0x26,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x11, 0x16, 0x33, 0x32, 0x37, 0x36, 0x25,
-  0x11, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x03, 0x83, 0x45, 0x95,
-  0x53, 0xe4, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x4d, 0x92, 0x44, 0x3e, 0x62,
-  0x40, 0x43, 0x4f, 0x41, 0x3d, 0x49, 0x49, 0x41, 0x4e, 0xfe, 0x48, 0x27,
-  0x21, 0x6e, 0x6e, 0x20, 0x8f, 0x64, 0x24, 0x24, 0x01, 0x3e, 0x01, 0x0e,
-  0x01, 0x12, 0x01, 0x3a, 0x23, 0x23, 0x64, 0x1f, 0x18, 0x0f, 0x14, 0xfc,
-  0x57, 0x13, 0x10, 0x13, 0x1b, 0x03, 0x53, 0x1a, 0x25, 0x80, 0xea, 0xe6,
-  0x83, 0x26, 0x00, 0x00, 0x00, 0x04, 0x00, 0x85, 0xff, 0xe3, 0x04, 0x92,
-  0x06, 0x14, 0x00, 0x0f, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00,
-  0x01, 0x11, 0x21, 0x11, 0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x10,
-  0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x11,
-  0x06, 0x07, 0x06, 0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x03, 0x64,
-  0x01, 0x2d, 0xfe, 0xd3, 0x34, 0x9f, 0x70, 0xb6, 0xe6, 0xe6, 0xb6, 0x70,
-  0x9f, 0xfd, 0xb7, 0x0e, 0x14, 0x33, 0x28, 0x36, 0x36, 0x28, 0x55, 0x02,
-  0xd7, 0x79, 0xfd, 0xc1, 0x16, 0x18, 0x94, 0x54, 0x56, 0x0d, 0x14, 0x45,
-  0x44, 0x94, 0x18, 0x03, 0xb6, 0x02, 0x5e, 0xf9, 0xec, 0xa8, 0x64, 0x61,
-  0x01, 0x44, 0x02, 0x10, 0x01, 0x44, 0x61, 0xfe, 0x5a, 0x9e, 0x4b, 0x73,
-  0x4f, 0x3d, 0x20, 0x03, 0x86, 0x20, 0x3d, 0x82, 0x02, 0x9d, 0xfa, 0xac,
-  0x05, 0x54, 0xfe, 0x64, 0xfc, 0x36, 0x03, 0x82, 0x82, 0x9f, 0x9e, 0x4a,
-  0x74, 0x68, 0x69, 0x00, 0x00, 0x03, 0x00, 0x63, 0xff, 0xe3, 0x04, 0x0b,
-  0x04, 0x7b, 0x00, 0x13, 0x00, 0x18, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x21,
-  0x13, 0x16, 0x33, 0x32, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11,
-  0x10, 0x00, 0x33, 0x32, 0x12, 0x15, 0x01, 0x06, 0x11, 0x12, 0x17, 0x13,
-  0x21, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x04, 0x0a, 0xfd, 0xca, 0x01, 0x43,
-  0x56, 0xc3, 0xb0, 0x62, 0xb0, 0x60, 0xf1, 0xfe, 0xe6, 0x01, 0x0b, 0xe3,
-  0xce, 0xea, 0xfd, 0x6c, 0xb2, 0x01, 0xb1, 0x5f, 0x01, 0xce, 0x03, 0xb8,
-  0x98, 0x42, 0x3a, 0x02, 0x04, 0xfe, 0x62, 0x15, 0x5d, 0x75, 0x2d, 0x29,
-  0x01, 0x38, 0x01, 0x0a, 0x01, 0x13, 0x01, 0x43, 0xfe, 0xda, 0xf7, 0x01,
-  0x71, 0x7a, 0xfe, 0xdb, 0xfe, 0xf3, 0x8e, 0x01, 0xd3, 0xbe, 0xe7, 0x11,
-  0x00, 0x02, 0x00, 0x2a, 0x00, 0x00, 0x03, 0x80, 0x06, 0x14, 0x00, 0x0a,
-  0x00, 0x20, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x15, 0x11, 0x33, 0x11,
-  0x34, 0x37, 0x36, 0x25, 0x15, 0x23, 0x22, 0x07, 0x06, 0x1d, 0x01, 0x21,
-  0x15, 0x21, 0x11, 0x21, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x01, 0xdc, 0x5d, 0x29, 0x33, 0x79, 0x14, 0x10, 0x01, 0xc0, 0x9d,
-  0x85, 0x34, 0x34, 0x01, 0x5d, 0xfe, 0xa3, 0xfe, 0xd3, 0x9f, 0x9f, 0x4e,
-  0x4f, 0xa9, 0x05, 0xae, 0x0a, 0x2d, 0x38, 0x91, 0xfb, 0xb6, 0x04, 0x4a,
-  0x5f, 0x44, 0x38, 0x8b, 0x64, 0x39, 0x37, 0x92, 0x64, 0x64, 0xfc, 0x1a,
-  0x03, 0xe6, 0x64, 0x64, 0xbc, 0x54, 0x56, 0x00, 0x00, 0x04, 0x00, 0x65,
-  0xfe, 0x56, 0x04, 0x72, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x23, 0x00, 0x2e,
-  0x00, 0x3d, 0x00, 0x00, 0x01, 0x11, 0x14, 0x07, 0x16, 0x36, 0x19, 0x01,
-  0x01, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23,
-  0x22, 0x02, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x21, 0x11, 0x10,
-  0x00, 0x21, 0x22, 0x26, 0x03, 0x14, 0x17, 0x16, 0x17, 0x11, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x03, 0x9f, 0x5f, 0x04, 0xd4, 0xfc,
-  0xc7, 0x49, 0x8e, 0x4a, 0xa3, 0xa2, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
-  0xb7, 0x70, 0x9f, 0x34, 0x01, 0x2d, 0xfe, 0xf3, 0xfe, 0xec, 0x67, 0xb5,
-  0x6d, 0x54, 0x28, 0x36, 0x36, 0x28, 0x33, 0x14, 0x0d, 0x01, 0x10, 0x17,
-  0x17, 0x95, 0x43, 0x46, 0x14, 0x0c, 0x55, 0x54, 0x95, 0x17, 0x17, 0x03,
-  0xfa, 0xfc, 0x3d, 0xca, 0x8c, 0x05, 0x9d, 0x01, 0x12, 0x03, 0x6f, 0xfa,
-  0x97, 0x80, 0x2c, 0x2a, 0xbd, 0xbf, 0x71, 0x64, 0x61, 0x01, 0x44, 0x02,
-  0x10, 0x01, 0x44, 0x61, 0x64, 0xa8, 0xfc, 0x2d, 0xfe, 0xe2, 0xfe, 0xe9,
-  0x1d, 0x03, 0x77, 0x9f, 0x82, 0x3d, 0x20, 0x03, 0x86, 0x20, 0x3d, 0x4f,
-  0x73, 0x4b, 0xfd, 0xc2, 0x03, 0x69, 0x68, 0x74, 0x4a, 0x9e, 0x9f, 0x82,
-  0x82, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc1,
-  0x06, 0x14, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x22, 0x00, 0x00, 0x01, 0x16,
-  0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x34, 0x27, 0x26, 0x01, 0x11, 0x33,
-  0x11, 0x27, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x21,
-  0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x03, 0x9a, 0x08,
-  0x07, 0x40, 0x7e, 0x4b, 0x30, 0xfd, 0x15, 0x7a, 0xd4, 0x01, 0x2e, 0x42,
-  0xb2, 0x74, 0xbf, 0xc5, 0xfe, 0xce, 0x61, 0x60, 0x73, 0x86, 0xfe, 0xd2,
-  0x04, 0x0d, 0x0b, 0x0c, 0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b,
-  0x3a, 0x01, 0xb6, 0xfa, 0xb4, 0x05, 0x4c, 0x64, 0xfd, 0x9e, 0x65, 0x64,
-  0xef, 0xe8, 0xfd, 0x5c, 0x02, 0xd0, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x55,
-  0x00, 0x03, 0x00, 0xcf, 0x00, 0x00, 0x01, 0xfd, 0x06, 0x14, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x03, 0x33,
-  0x15, 0x23, 0x07, 0x21, 0x11, 0x21, 0x01, 0x29, 0x79, 0x90, 0xa7, 0xa7,
-  0x43, 0x01, 0x2d, 0xfe, 0xd3, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x02,
-  0x18, 0xe9, 0xcb, 0xfb, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xdb,
-  0xfe, 0x56, 0x01, 0xd8, 0x06, 0x14, 0x00, 0x08, 0x00, 0x16, 0x00, 0x1a,
-  0x00, 0x00, 0x05, 0x11, 0x23, 0x11, 0x14, 0x07, 0x36, 0x37, 0x36, 0x07,
-  0x23, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x21, 0x11, 0x14, 0x07,
-  0x06, 0x03, 0x33, 0x15, 0x23, 0x01, 0x7e, 0x7a, 0x21, 0x40, 0x24, 0x37,
-  0xdc, 0xc7, 0x2c, 0x61, 0x21, 0x21, 0x01, 0x2e, 0x49, 0x4a, 0x57, 0xa5,
-  0xa5, 0x16, 0x04, 0x12, 0xfb, 0xd0, 0xb5, 0x54, 0x0f, 0x30, 0x48, 0xf4,
-  0x64, 0x30, 0x31, 0x99, 0x04, 0xac, 0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x07,
-  0xbe, 0xe9, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xad,
-  0x06, 0x14, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x21, 0x11, 0x01,
-  0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x21, 0x13, 0x11, 0x33, 0x11, 0xa7,
-  0x01, 0x2e, 0x02, 0x43, 0x7e, 0xfd, 0x8e, 0x02, 0x89, 0x87, 0xfd, 0xaf,
-  0xfe, 0xd2, 0x5a, 0x7a, 0x06, 0x14, 0xfc, 0x69, 0x01, 0xe3, 0xfd, 0xf6,
-  0xfd, 0xaa, 0x02, 0x23, 0xfd, 0xdd, 0x05, 0xb0, 0xfa, 0xb4, 0x05, 0x4c,
-  0x00, 0x02, 0x00, 0xcf, 0x00, 0x00, 0x02, 0xa0, 0x06, 0x14, 0x00, 0x08,
-  0x00, 0x14, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16, 0x17, 0x26, 0x35, 0x11,
-  0x23, 0x13, 0x22, 0x27, 0x26, 0x35, 0x11, 0x21, 0x11, 0x14, 0x16, 0x33,
-  0x15, 0x01, 0x29, 0x37, 0x24, 0x40, 0x22, 0x79, 0xdd, 0xa4, 0x4a, 0x49,
-  0x01, 0x2d, 0x45, 0x5e, 0x01, 0x94, 0xa0, 0x48, 0x30, 0x0f, 0x54, 0xb5,
-  0x04, 0x30, 0xfa, 0x5a, 0x60, 0x60, 0xd6, 0x04, 0x7e, 0xfb, 0x4a, 0x9c,
-  0x5e, 0x64, 0x00, 0x00, 0x00, 0x04, 0x00, 0xa7, 0x00, 0x00, 0x07, 0xad,
-  0x04, 0x7b, 0x00, 0x22, 0x00, 0x26, 0x00, 0x31, 0x00, 0x3c, 0x00, 0x00,
-  0x13, 0x21, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x15, 0x11, 0x21, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x21, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x13,
-  0x11, 0x33, 0x11, 0x25, 0x16, 0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x34,
-  0x27, 0x26, 0x25, 0x16, 0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x34, 0x27,
-  0x26, 0xa7, 0x01, 0x2e, 0x42, 0xb2, 0x74, 0xbf, 0x8d, 0x18, 0x4c, 0xc8,
-  0x74, 0xbf, 0xc5, 0xfe, 0xce, 0x61, 0x60, 0x73, 0x86, 0xfe, 0xce, 0x61,
-  0x60, 0x73, 0x86, 0xfe, 0xd2, 0x5a, 0x7a, 0x02, 0x1f, 0x08, 0x07, 0x40,
-  0x7e, 0x4b, 0x30, 0x02, 0x9a, 0x08, 0x07, 0x40, 0x7e, 0x4b, 0x30, 0x04,
-  0x60, 0xae, 0x65, 0x64, 0xac, 0x4a, 0x80, 0x76, 0xef, 0xe8, 0xfd, 0x5c,
-  0x02, 0xd0, 0x9f, 0x9e, 0xbe, 0xab, 0xfd, 0x5c, 0x02, 0xd0, 0x9f, 0x9e,
-  0xbe, 0xa4, 0xfd, 0x55, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x11, 0x0b,
-  0x0c, 0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b, 0x3a, 0x13, 0x0b,
-  0x0c, 0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b, 0x3a, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc1, 0x04, 0x7b, 0x00, 0x0a,
-  0x00, 0x0e, 0x00, 0x22, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x15, 0x11,
-  0x33, 0x11, 0x34, 0x27, 0x26, 0x25, 0x11, 0x33, 0x11, 0x27, 0x21, 0x15,
-  0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x21, 0x11, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x15, 0x11, 0x21, 0x03, 0x9a, 0x08, 0x07, 0x40, 0x7e, 0x4b,
-  0x30, 0xfd, 0x15, 0x7a, 0xd4, 0x01, 0x2e, 0x42, 0xb2, 0x74, 0xbf, 0xc5,
-  0xfe, 0xce, 0x61, 0x60, 0x73, 0x86, 0xfe, 0xd2, 0x04, 0x0d, 0x0b, 0x0c,
-  0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b, 0x3a, 0x02, 0xfc, 0x68,
-  0x03, 0x98, 0x64, 0xae, 0x65, 0x64, 0xef, 0xe8, 0xfd, 0x5c, 0x02, 0xd0,
-  0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x55, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x13, 0x00, 0x1b,
-  0x00, 0x23, 0x00, 0x00, 0x01, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
-  0x02, 0x11, 0x10, 0x12, 0x13, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22, 0x07,
-  0x03, 0x11, 0x06, 0x07, 0x06, 0x10, 0x17, 0x16, 0x01, 0x11, 0x36, 0x37,
-  0x36, 0x10, 0x27, 0x26, 0x02, 0x34, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xf5,
-  0xf5, 0x75, 0x2e, 0x6c, 0x2e, 0x2e, 0x6c, 0x2e, 0x5a, 0x2e, 0x24, 0x64,
-  0x64, 0x24, 0x01, 0xaa, 0x2e, 0x24, 0x65, 0x65, 0x24, 0x04, 0x7b, 0xfe,
-  0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x39, 0x01, 0x13, 0x01,
-  0x14, 0x01, 0x38, 0xfb, 0xd7, 0x0b, 0x0b, 0x03, 0xba, 0x0b, 0x0b, 0xfc,
-  0x6b, 0x03, 0x70, 0x1d, 0x2d, 0x80, 0xfe, 0x24, 0x80, 0x2d, 0x03, 0x52,
-  0xfc, 0x92, 0x1c, 0x2d, 0x81, 0x01, 0xdb, 0x80, 0x2d, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x72, 0x04, 0x7b, 0x00, 0x0f,
-  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11,
-  0x21, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26,
-  0x01, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x11, 0x36, 0x37, 0x36, 0x01,
-  0x11, 0x23, 0x11, 0x01, 0x11, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
-  0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x01, 0x92, 0xfe, 0xd4, 0x01, 0x2c,
-  0x34, 0xa0, 0x6f, 0xb7, 0xe6, 0xe6, 0xb7, 0x6f, 0xa0, 0x02, 0x4a, 0x0e,
-  0x14, 0x33, 0x28, 0x36, 0x36, 0x28, 0x55, 0xfd, 0x28, 0x78, 0x02, 0x3f,
-  0x17, 0x17, 0x95, 0x53, 0x56, 0x0d, 0x14, 0x45, 0x43, 0x95, 0x17, 0xa8,
-  0xfd, 0xae, 0x06, 0x08, 0xa8, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe,
-  0xbc, 0x61, 0x01, 0xa6, 0x9e, 0x4b, 0x73, 0x4f, 0x3d, 0x20, 0xfc, 0x7a,
-  0x20, 0x3d, 0x82, 0xfd, 0x6f, 0x05, 0x48, 0xfa, 0xb8, 0x01, 0x90, 0x03,
-  0xca, 0x03, 0x82, 0x82, 0x9f, 0x9e, 0x4a, 0x74, 0x68, 0x69, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x72, 0x04, 0x7b, 0x00, 0x0f,
-  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x23,
-  0x22, 0x02, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x21, 0x11, 0x21,
-  0x01, 0x14, 0x17, 0x16, 0x17, 0x11, 0x06, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x33, 0x11, 0x23, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x03, 0x45, 0x34, 0x9f, 0x70, 0xb7,
-  0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0x01, 0x2d, 0xfe, 0xd3, 0xfd, 0x83,
-  0x54, 0x28, 0x36, 0x36, 0x28, 0x33, 0x14, 0x0d, 0x02, 0xd7, 0x79, 0x79,
-  0xfe, 0x39, 0x17, 0x17, 0x95, 0x43, 0x46, 0x14, 0x0c, 0x55, 0x54, 0x95,
-  0x17, 0x17, 0xa8, 0x64, 0x61, 0x01, 0x44, 0x02, 0x10, 0x01, 0x44, 0x61,
-  0x64, 0xa8, 0xf9, 0xf8, 0x03, 0x94, 0x9f, 0x82, 0x3d, 0x20, 0x03, 0x86,
-  0x20, 0x3d, 0x4f, 0x73, 0x4b, 0xfc, 0x32, 0x05, 0x48, 0xfc, 0x48, 0x03,
-  0x69, 0x68, 0x74, 0x4a, 0x9e, 0x9f, 0x82, 0x82, 0x03, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x7c, 0x04, 0x7b, 0x00, 0x03,
-  0x00, 0x15, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x27, 0x21, 0x15, 0x3e,
-  0x01, 0x33, 0x32, 0x1f, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15,
-  0x11, 0x21, 0x01, 0x01, 0x79, 0xd3, 0x01, 0x2d, 0x34, 0xa8, 0x77, 0x19,
-  0x0d, 0x2f, 0x1c, 0x42, 0x27, 0x8d, 0x96, 0xfe, 0xd3, 0x03, 0xfc, 0xfc,
-  0x68, 0x03, 0x98, 0x64, 0xae, 0x66, 0x63, 0x03, 0x07, 0x85, 0x12, 0x11,
-  0xcb, 0xbe, 0xfd, 0x7a, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
-  0x04, 0x7b, 0x00, 0x1d, 0x00, 0x45, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x03, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f,
-  0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x01, 0x45, 0x23, 0x19, 0x44, 0x22,
-  0x23, 0x66, 0x2f, 0x94, 0x37, 0x3c, 0x22, 0x22, 0x1a, 0x4c, 0x26, 0x2a,
-  0x77, 0x2d, 0x82, 0x33, 0x40, 0xbe, 0x4b, 0x90, 0x47, 0x5f, 0x66, 0x45,
-  0x82, 0x2f, 0x81, 0x6a, 0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x42, 0x53, 0x56,
-  0x63, 0x65, 0x48, 0x6c, 0x2e, 0x91, 0x76, 0xde, 0xc2, 0x51, 0xb0, 0x61,
-  0x03, 0xf9, 0x0f, 0x17, 0x3d, 0x76, 0x66, 0x30, 0x33, 0x22, 0x10, 0x33,
-  0x3b, 0x40, 0x7b, 0x52, 0x3f, 0x10, 0x17, 0x42, 0x73, 0x6c, 0x33, 0x37,
-  0x27, 0x0f, 0x2a, 0x37, 0x43, 0x6f, 0x54, 0xfc, 0xfe, 0x37, 0x38, 0x5e,
-  0x55, 0x4e, 0x4f, 0x2c, 0x10, 0x2c, 0x97, 0x88, 0xa6, 0xb5, 0x20, 0x1f,
-  0x7a, 0x31, 0x24, 0x59, 0x58, 0x44, 0x4c, 0x23, 0x0f, 0x2f, 0x9e, 0x90,
-  0xa4, 0xc0, 0x25, 0x25, 0x00, 0x02, 0x00, 0x31, 0x00, 0x00, 0x03, 0x2e,
-  0x05, 0x9e, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00, 0x25, 0x26, 0x37, 0x11,
-  0x23, 0x11, 0x06, 0x16, 0x13, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16,
-  0x3b, 0x01, 0x15, 0x21, 0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11,
-  0x01, 0xa2, 0x26, 0x02, 0x79, 0x01, 0x53, 0x81, 0x01, 0x56, 0xfe, 0xaa,
-  0x44, 0x68, 0xaa, 0xfe, 0xce, 0xbf, 0x92, 0x79, 0x79, 0x6a, 0x55, 0x7c,
-  0x03, 0xff, 0xfc, 0x37, 0xad, 0x4e, 0x05, 0x28, 0xfe, 0xac, 0x64, 0xfd,
-  0x55, 0x89, 0x4e, 0x64, 0x9f, 0xd2, 0x02, 0x75, 0x64, 0x01, 0x54, 0x00,
-  0x00, 0x03, 0x00, 0x9f, 0xff, 0xe5, 0x04, 0xbe, 0x04, 0x60, 0x00, 0x0a,
-  0x00, 0x0e, 0x00, 0x22, 0x00, 0x00, 0x25, 0x26, 0x27, 0x26, 0x35, 0x11,
-  0x23, 0x11, 0x14, 0x17, 0x16, 0x05, 0x11, 0x23, 0x11, 0x17, 0x21, 0x35,
-  0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x11, 0x21, 0x11, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x11, 0x21, 0x01, 0xc6, 0x08, 0x07, 0x40, 0x7e, 0x4b,
-  0x30, 0x02, 0xef, 0x79, 0xd3, 0xfe, 0xce, 0x41, 0xb3, 0x74, 0xbf, 0xc5,
-  0x01, 0x32, 0x61, 0x60, 0x73, 0x86, 0x01, 0x32, 0x53, 0x0b, 0x0c, 0x68,
-  0xbe, 0x02, 0x6c, 0xfd, 0xc0, 0xc1, 0x5b, 0x3a, 0x02, 0x03, 0x98, 0xfc,
-  0x68, 0x64, 0xae, 0x65, 0x64, 0xef, 0xe8, 0x02, 0xa4, 0xfd, 0x30, 0x9f,
-  0x9e, 0xbe, 0xa4, 0x02, 0xab, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36,
-  0x00, 0x00, 0x04, 0x39, 0x04, 0x60, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
-  0x13, 0x01, 0x33, 0x01, 0x27, 0x21, 0x09, 0x01, 0x33, 0x01, 0x21, 0xb8,
-  0x01, 0x37, 0x76, 0xfe, 0xc6, 0xf4, 0x01, 0x32, 0x01, 0x3b, 0x01, 0x3b,
-  0x5a, 0xfe, 0x86, 0xfe, 0xf2, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x64,
-  0xfc, 0x54, 0x03, 0xac, 0xfb, 0xa0, 0x00, 0x00, 0x00, 0x03, 0x00, 0x4d,
-  0x00, 0x00, 0x06, 0x41, 0x04, 0x60, 0x00, 0x03, 0x00, 0x07, 0x00, 0x14,
-  0x00, 0x00, 0x01, 0x13, 0x33, 0x03, 0x21, 0x13, 0x33, 0x03, 0x27, 0x21,
-  0x1b, 0x01, 0x21, 0x1b, 0x01, 0x33, 0x01, 0x21, 0x0b, 0x01, 0x21, 0x03,
-  0x8c, 0xd8, 0x7a, 0xda, 0xfc, 0xbe, 0xd8, 0x7a, 0xda, 0xed, 0x01, 0x32,
-  0xcf, 0xce, 0x01, 0x2d, 0xcf, 0xce, 0x5a, 0xfe, 0xf8, 0xfe, 0xea, 0xd9,
-  0xda, 0xfe, 0xe6, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0xfc, 0x68, 0x03,
-  0x98, 0x64, 0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96, 0x03, 0x6a, 0xfb, 0xa0,
-  0x03, 0x96, 0xfc, 0x6a, 0x00, 0x02, 0x00, 0x44, 0x00, 0x00, 0x04, 0x9a,
-  0x04, 0x60, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x01, 0x33, 0x01,
-  0x25, 0x21, 0x09, 0x01, 0x33, 0x09, 0x01, 0x21, 0x09, 0x01, 0x23, 0x01,
-  0xf8, 0x02, 0x66, 0x88, 0xfd, 0x99, 0xfe, 0xc5, 0x01, 0x68, 0x01, 0x01,
-  0x01, 0x00, 0x70, 0xfe, 0xc8, 0x01, 0xb4, 0xfe, 0x98, 0xff, 0x00, 0xfe,
-  0xff, 0x6f, 0x01, 0x38, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x64, 0xfe,
-  0x81, 0x01, 0x7f, 0xfe, 0x2d, 0xfd, 0x73, 0x01, 0x7f, 0xfe, 0x81, 0x01,
-  0xd3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x4a,
-  0x04, 0x60, 0x00, 0x03, 0x00, 0x12, 0x00, 0x00, 0x13, 0x01, 0x37, 0x01,
-  0x27, 0x21, 0x09, 0x01, 0x33, 0x01, 0x0e, 0x01, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x36, 0x37, 0xbd, 0x01, 0x87, 0x37, 0xfe, 0xba, 0xfe, 0x01, 0x3b,
-  0x01, 0x3a, 0x01, 0x3c, 0x61, 0xfe, 0x45, 0x48, 0x83, 0x70, 0x84, 0x84,
-  0x4f, 0x49, 0x27, 0x03, 0xfc, 0xfb, 0xdb, 0x99, 0x03, 0x8c, 0x64, 0xfc,
-  0x97, 0x03, 0x69, 0xfb, 0x38, 0xc7, 0x7b, 0x64, 0x43, 0x59, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x4f, 0x00, 0x00, 0x03, 0xf2, 0x04, 0x60, 0x00, 0x03,
-  0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x25, 0x21, 0x15, 0x01,
-  0x21, 0x15, 0x21, 0x35, 0x01, 0x21, 0x03, 0x06, 0xfd, 0xb7, 0x7e, 0x02,
-  0x49, 0xfc, 0xe2, 0x03, 0x8c, 0xfd, 0xb8, 0x02, 0x48, 0xfc, 0x5d, 0x02,
-  0x48, 0xfd, 0xcf, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x64, 0x64, 0xfc,
-  0x68, 0x64, 0x64, 0x03, 0x98, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x24, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x25, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4,
-  0x05, 0xf0, 0x10, 0x06, 0x00, 0x26, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xba,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x29, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
-  0xff, 0xe3, 0x04, 0xfe, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x2a, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0x00, 0x00, 0x02, 0xab,
-  0x05, 0xd5, 0x10, 0x06, 0x11, 0x48, 0x00, 0x00, 0xff, 0xff, 0xff, 0xa0,
-  0xfe, 0x66, 0x01, 0x6b, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x2d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x30, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
-  0x05, 0xf0, 0x10, 0x06, 0x00, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
-  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x33, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x67, 0xfe, 0xf8, 0x05, 0x44, 0x05, 0xf0, 0x10, 0x06,
-  0x00, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x35, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x04, 0x2c, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x36, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x38, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
-  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x39, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x3b, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc,
-  0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x3c, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
-  0x04, 0x7b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x10, 0x06, 0x00, 0x45, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x10, 0x06,
-  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xeb,
-  0x06, 0x14, 0x10, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac, 0x06, 0x14, 0x10, 0x06,
-  0x00, 0x49, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb,
-  0x04, 0x7b, 0x10, 0x06, 0x00, 0x4a, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x10, 0x06, 0x00, 0x4b, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x10, 0x06,
-  0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x01, 0x54,
-  0x06, 0x14, 0x10, 0x06, 0x00, 0x4d, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0x26, 0x06, 0x14, 0x10, 0x06, 0x00, 0x4e, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x02, 0x01, 0x06, 0x14, 0x10, 0x06,
-  0x11, 0x3e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67,
-  0x04, 0x7b, 0x10, 0x06, 0x00, 0x50, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
-  0x00, 0x00, 0x03, 0xf4, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x51, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x06,
-  0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e,
-  0x04, 0x7b, 0x10, 0x06, 0x00, 0x53, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
-  0xfe, 0x56, 0x03, 0xeb, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x54, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x02, 0xf6, 0x04, 0x7b, 0x10, 0x06,
-  0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
-  0x04, 0x7b, 0x10, 0x06, 0x00, 0x56, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31,
-  0x00, 0x00, 0x02, 0xa7, 0x05, 0x9e, 0x10, 0x06, 0x00, 0x57, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x04, 0x7b, 0x10, 0x06,
-  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
-  0x04, 0x60, 0x10, 0x06, 0x00, 0x59, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d,
-  0x00, 0x00, 0x05, 0x97, 0x04, 0x60, 0x10, 0x06, 0x00, 0x5a, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x10, 0x06,
-  0x00, 0x5b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
-  0x04, 0x60, 0x10, 0x06, 0x00, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
-  0x00, 0x00, 0x03, 0x79, 0x04, 0x60, 0x10, 0x06, 0x00, 0x5d, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x7a, 0xff, 0xe3, 0x04, 0x1c, 0x05, 0xf0, 0x00, 0x07,
-  0x00, 0x0c, 0x00, 0x14, 0x00, 0x19, 0x00, 0x00, 0x00, 0x20, 0x12, 0x10,
-  0x02, 0x20, 0x02, 0x10, 0x01, 0x36, 0x11, 0x10, 0x2f, 0x01, 0x26, 0x22,
-  0x07, 0x11, 0x16, 0x32, 0x37, 0x01, 0x06, 0x11, 0x10, 0x17, 0x01, 0x68,
-  0x01, 0xc4, 0xef, 0xef, 0xfe, 0x3c, 0xee, 0x02, 0x90, 0xb7, 0xb7, 0x5a,
-  0x2e, 0x6f, 0x2f, 0x2f, 0x6f, 0x2e, 0xfe, 0xda, 0xb6, 0xb6, 0x05, 0xf0,
-  0xfe, 0x73, 0xfd, 0x0d, 0xfe, 0x73, 0x01, 0x8d, 0x02, 0xf3, 0xfc, 0x23,
-  0x8f, 0x01, 0xd4, 0x01, 0xd5, 0x8f, 0x30, 0x0f, 0x0f, 0xfa, 0xd9, 0x0f,
-  0x0f, 0x04, 0xf7, 0x90, 0xfe, 0x2c, 0xfe, 0x2d, 0x90, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x60, 0x00, 0x00, 0x04, 0x35, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x0e, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x37, 0x11, 0x21, 0x15,
-  0x21, 0x35, 0x21, 0x11, 0x05, 0x35, 0x25, 0x01, 0xfd, 0xb6, 0x58, 0x01,
-  0x29, 0xfc, 0x46, 0x01, 0x29, 0xfe, 0xbd, 0x01, 0x43, 0x05, 0x71, 0xfa,
-  0xf3, 0x05, 0x0d, 0x64, 0xfa, 0x8f, 0x64, 0x64, 0x05, 0x0d, 0x48, 0x64,
-  0x48, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75, 0x00, 0x00, 0x04, 0x25,
-  0x05, 0xf0, 0x00, 0x10, 0x00, 0x28, 0x00, 0x00, 0x37, 0x33, 0x01, 0x36,
-  0x37, 0x36, 0x10, 0x27, 0x26, 0x27, 0x17, 0x16, 0x15, 0x14, 0x0e, 0x01,
-  0x0b, 0x01, 0x36, 0x33, 0x32, 0x04, 0x15, 0x14, 0x0e, 0x01, 0x07, 0x03,
-  0x21, 0x15, 0x21, 0x37, 0x36, 0x00, 0x37, 0x36, 0x10, 0x26, 0x23, 0x22,
-  0x07, 0xe2, 0xe6, 0x01, 0x0c, 0x56, 0x1f, 0x44, 0x61, 0x3d, 0x59, 0x03,
-  0x51, 0x3e, 0x75, 0xbc, 0xfd, 0xe9, 0xa3, 0xdb, 0x01, 0x02, 0x2b, 0x49,
-  0x54, 0xec, 0x01, 0xf1, 0xfc, 0x51, 0x01, 0x02, 0x01, 0x74, 0x37, 0x6d,
-  0x79, 0x63, 0x88, 0xae, 0x64, 0x01, 0xcd, 0x95, 0x40, 0x8f, 0x01, 0x39,
-  0x5c, 0x39, 0x18, 0x04, 0x70, 0xa8, 0x64, 0xba, 0xcf, 0xfe, 0xdd, 0x04,
-  0x39, 0x68, 0xf4, 0xcc, 0x62, 0xac, 0x96, 0x91, 0xfe, 0x69, 0x64, 0x64,
-  0x05, 0x02, 0x41, 0x62, 0xbf, 0x01, 0x19, 0xa8, 0x95, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x8c, 0xff, 0xe3, 0x04, 0x02, 0x05, 0xf0, 0x00, 0x24,
-  0x00, 0x2a, 0x00, 0x30, 0x00, 0x00, 0x05, 0x22, 0x27, 0x35, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x11, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x11,
-  0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x04, 0x35, 0x36, 0x35, 0x34, 0x26,
-  0x27, 0x19, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x01, 0xf4, 0xa9, 0xbf, 0x1e,
-  0xb0, 0x9a, 0x5a, 0x48, 0x31, 0x39, 0xb7, 0xbe, 0x35, 0x2e, 0x35, 0x44,
-  0x8d, 0xc3, 0x18, 0xcf, 0x9d, 0xcf, 0xf2, 0x7f, 0x73, 0x7f, 0x92, 0xfe,
-  0xef, 0xb7, 0x69, 0x4e, 0x3e, 0x5a, 0x1d, 0x4a, 0x6a, 0x0c, 0x44, 0x10,
-  0x02, 0x95, 0x0a, 0x64, 0x08, 0x02, 0x20, 0x0a, 0x3c, 0x08, 0x68, 0x40,
-  0xd1, 0xb2, 0x7c, 0xaa, 0x21, 0x1f, 0xc5, 0x90, 0xdd, 0xf2, 0x92, 0x55,
-  0xe8, 0x6c, 0x8d, 0x24, 0x02, 0x96, 0xfe, 0x1a, 0x1d, 0x79, 0x58, 0xac,
-  0x00, 0x03, 0x00, 0x51, 0x00, 0x00, 0x04, 0x40, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x06, 0x00, 0x11, 0x00, 0x00, 0x01, 0x23, 0x13, 0x33, 0x09, 0x01,
-  0x21, 0x03, 0x21, 0x11, 0x33, 0x15, 0x23, 0x11, 0x21, 0x11, 0x21, 0x35,
-  0x03, 0x4a, 0xb7, 0x03, 0xb4, 0xfe, 0xf2, 0xfe, 0x7c, 0x01, 0x84, 0x03,
-  0x01, 0x6b, 0x9b, 0x9b, 0xfe, 0x98, 0xfe, 0x15, 0x05, 0x71, 0xfa, 0xf3,
-  0x04, 0xc1, 0xfc, 0xe3, 0x03, 0xcd, 0xfc, 0x33, 0x64, 0xfe, 0x5c, 0x01,
-  0xa4, 0x7f, 0x00, 0x00, 0x00, 0x03, 0x00, 0x85, 0xff, 0xe3, 0x04, 0x18,
-  0x05, 0xd5, 0x00, 0x04, 0x00, 0x08, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x11,
-  0x23, 0x11, 0x36, 0x01, 0x36, 0x10, 0x27, 0x03, 0x11, 0x26, 0x23, 0x22,
-  0x07, 0x11, 0x21, 0x15, 0x21, 0x11, 0x1e, 0x01, 0x10, 0x04, 0x21, 0x22,
-  0x27, 0x35, 0x16, 0x33, 0x32, 0x01, 0xcc, 0xb4, 0x5d, 0x01, 0x8a, 0xb7,
-  0xb7, 0x5a, 0x2c, 0x60, 0xa2, 0xb9, 0x02, 0xf7, 0xfe, 0x71, 0xf6, 0xfc,
-  0xfe, 0xf2, 0xfe, 0xdd, 0xa7, 0xbb, 0xaa, 0xc6, 0x74, 0x03, 0x91, 0x01,
-  0xe0, 0xfd, 0xfd, 0x1b, 0xfc, 0xe6, 0x5c, 0x01, 0xdc, 0x60, 0xfd, 0x49,
-  0x02, 0xd7, 0x0a, 0x4b, 0x02, 0xef, 0x64, 0xfe, 0x23, 0x09, 0xf5, 0xfe,
-  0x46, 0xf9, 0x3c, 0x88, 0x64, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65,
-  0xff, 0xe3, 0x04, 0x33, 0x05, 0xf0, 0x00, 0x04, 0x00, 0x09, 0x00, 0x11,
-  0x00, 0x25, 0x00, 0x00, 0x25, 0x36, 0x11, 0x10, 0x27, 0x01, 0x06, 0x11,
-  0x10, 0x1f, 0x01, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22, 0x07, 0x13, 0x32,
-  0x17, 0x15, 0x27, 0x26, 0x20, 0x07, 0x11, 0x36, 0x33, 0x32, 0x12, 0x10,
-  0x02, 0x23, 0x20, 0x02, 0x10, 0x00, 0x03, 0x23, 0xb6, 0xb6, 0xfe, 0x55,
-  0xb8, 0xb8, 0x5a, 0x34, 0x9a, 0x29, 0x24, 0x9a, 0x39, 0xdc, 0x96, 0x97,
-  0x1e, 0x8a, 0xfe, 0xf4, 0x55, 0x3c, 0x5d, 0xdd, 0xeb, 0xf5, 0xde, 0xfe,
-  0xfc, 0xf6, 0x01, 0x2e, 0x70, 0x63, 0x01, 0x0c, 0x01, 0x18, 0x5c, 0x01,
-  0xca, 0xb3, 0xfe, 0x91, 0xfe, 0x23, 0x95, 0x32, 0x10, 0x08, 0x03, 0x22,
-  0x06, 0x13, 0x02, 0x8c, 0x3c, 0x6a, 0x0c, 0x36, 0x2d, 0xfe, 0x66, 0x16,
-  0xfe, 0xef, 0xfe, 0x2f, 0xfe, 0xea, 0x01, 0x8d, 0x02, 0xdb, 0x01, 0xa5,
-  0x00, 0x02, 0x00, 0x3a, 0x00, 0x00, 0x04, 0x5b, 0x05, 0xd5, 0x00, 0x03,
-  0x00, 0x0a, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x25, 0x21, 0x15, 0x01,
-  0x21, 0x01, 0x21, 0x03, 0x39, 0xfe, 0x3f, 0xc1, 0x01, 0xc1, 0xfc, 0x40,
-  0x04, 0x20, 0xfe, 0x1d, 0xfe, 0x7e, 0x01, 0xe4, 0xfd, 0x61, 0x05, 0x71,
-  0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0x8f, 0x05, 0x71, 0x00, 0x00,
-  0x00, 0x07, 0x00, 0x7d, 0xff, 0xe3, 0x04, 0x17, 0x05, 0xf0, 0x00, 0x04,
-  0x00, 0x0c, 0x00, 0x24, 0x00, 0x29, 0x00, 0x31, 0x00, 0x39, 0x00, 0x41,
-  0x00, 0x00, 0x25, 0x36, 0x27, 0x26, 0x27, 0x00, 0x10, 0x17, 0x16, 0x17,
-  0x11, 0x06, 0x07, 0x13, 0x35, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x20, 0x16,
-  0x15, 0x14, 0x06, 0x07, 0x15, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x20, 0x26,
-  0x35, 0x34, 0x36, 0x13, 0x11, 0x06, 0x07, 0x06, 0x05, 0x16, 0x32, 0x37,
-  0x11, 0x26, 0x22, 0x07, 0x19, 0x01, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22,
-  0x17, 0x11, 0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x03, 0x02, 0xbc, 0x06,
-  0x06, 0xb0, 0xfd, 0xf5, 0x55, 0x1e, 0x27, 0x27, 0x1d, 0x44, 0x73, 0x81,
-  0xe5, 0x01, 0x91, 0xe4, 0x81, 0x74, 0x83, 0x92, 0xef, 0xfe, 0x44, 0xef,
-  0x93, 0x81, 0xaf, 0x06, 0x07, 0x01, 0x16, 0x2d, 0x64, 0x2c, 0x2c, 0x64,
-  0x2d, 0x2c, 0x66, 0x2b, 0x2b, 0x66, 0xeb, 0x28, 0x1d, 0x56, 0x55, 0x1e,
-  0x64, 0x4a, 0xea, 0xe4, 0x4e, 0x02, 0x27, 0xfe, 0xf8, 0x4d, 0x1b, 0x12,
-  0x01, 0xfc, 0x12, 0x1b, 0xfd, 0xdc, 0x02, 0x20, 0xb1, 0x80, 0xb3, 0xd0,
-  0xd0, 0xb3, 0x80, 0xb1, 0x20, 0x01, 0x23, 0xc5, 0x8f, 0xd9, 0xe8, 0xe8,
-  0xd9, 0x8f, 0xc5, 0xfd, 0x6c, 0x02, 0x66, 0x4e, 0xe4, 0xea, 0x61, 0x06,
-  0x06, 0x02, 0x96, 0x07, 0x07, 0x02, 0xa2, 0xfd, 0xd0, 0x07, 0x07, 0x02,
-  0x30, 0x07, 0x21, 0xfe, 0x04, 0x12, 0x1b, 0x4d, 0x01, 0x08, 0x4d, 0x1b,
-  0x00, 0x04, 0x00, 0x5f, 0xff, 0xe3, 0x04, 0x2d, 0x05, 0xf0, 0x00, 0x04,
-  0x00, 0x09, 0x00, 0x11, 0x00, 0x25, 0x00, 0x00, 0x01, 0x06, 0x11, 0x10,
-  0x17, 0x01, 0x36, 0x11, 0x10, 0x2f, 0x01, 0x26, 0x22, 0x07, 0x11, 0x16,
-  0x32, 0x37, 0x03, 0x22, 0x27, 0x35, 0x17, 0x16, 0x20, 0x37, 0x11, 0x06,
-  0x23, 0x22, 0x02, 0x10, 0x12, 0x33, 0x20, 0x12, 0x10, 0x00, 0x01, 0x6f,
-  0xb6, 0xb6, 0x01, 0xab, 0xb8, 0xb8, 0x5a, 0x34, 0x9a, 0x29, 0x24, 0x9a,
-  0x39, 0xdc, 0x96, 0x97, 0x1e, 0x8a, 0x01, 0x0c, 0x55, 0x3c, 0x5d, 0xdd,
-  0xeb, 0xf5, 0xde, 0x01, 0x04, 0xf6, 0xfe, 0xd2, 0x05, 0x63, 0x63, 0xfe,
-  0xf4, 0xfe, 0xe8, 0x5c, 0xfe, 0x36, 0xb3, 0x01, 0x6f, 0x01, 0xdd, 0x95,
-  0x32, 0x10, 0x08, 0xfc, 0xde, 0x06, 0x13, 0xfd, 0x74, 0x3c, 0x6a, 0x0c,
-  0x36, 0x2d, 0x01, 0x9a, 0x16, 0x01, 0x11, 0x01, 0xd1, 0x01, 0x16, 0xfe,
-  0x73, 0xfd, 0x25, 0xfe, 0x5b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
-  0xff, 0xe3, 0x04, 0x1b, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x13, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0xca, 0x00, 0x00, 0x03, 0xeb, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x14, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0x00, 0x00, 0x03, 0xdd,
-  0x05, 0xf0, 0x10, 0x06, 0x00, 0x15, 0x00, 0x00, 0xff, 0xff, 0x00, 0x8c,
-  0xff, 0xe3, 0x04, 0x02, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x16, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x5a, 0x00, 0x00, 0x04, 0x2e, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x17, 0x00, 0x00, 0xff, 0xff, 0x00, 0x8e, 0xff, 0xe3, 0x03, 0xf4,
-  0x05, 0xd5, 0x10, 0x06, 0x00, 0x18, 0x00, 0x00, 0xff, 0xff, 0x00, 0x80,
-  0xff, 0xe3, 0x04, 0x21, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x19, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x97, 0x00, 0x00, 0x03, 0xf8, 0x05, 0xd5, 0x10, 0x06,
-  0x00, 0x1a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7d, 0xff, 0xe3, 0x04, 0x17,
-  0x05, 0xf0, 0x10, 0x06, 0x00, 0x1b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x74,
-  0xff, 0xe3, 0x04, 0x14, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x1c, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x01, 0x11, 0x21, 0x11,
-  0x04, 0xa9, 0x7f, 0x7f, 0xfc, 0x0b, 0x08, 0x6a, 0x01, 0x5f, 0x02, 0xc3,
-  0xfc, 0x24, 0x04, 0xf5, 0xfb, 0x0b, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0xb4, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x46,
-  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
-  0xfd, 0x3d, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x00,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x06,
-  0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a,
-  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
-  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30,
-  0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
-  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15,
-  0xfd, 0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21,
-  0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08,
-  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01, 0x3f, 0x10, 0x10, 0x1b,
-  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10,
-  0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
-  0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x06, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
-  0x00, 0x4d, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11,
-  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x07, 0xd2,
-  0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
-  0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17,
-  0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01, 0x3f,
-  0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b,
-  0x17, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19,
-  0x1a, 0x12, 0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc,
-  0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
-  0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b,
-  0x00, 0x5f, 0x00, 0x63, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
-  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x05, 0x8a,
-  0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18,
-  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
-  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01,
-  0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
-  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a,
-  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25,
-  0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x05, 0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
-  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f,
-  0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20,
-  0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
-  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0xee, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08,
-  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x03, 0xcc, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8,
-  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
-  0xfd, 0x3d, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
-  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0x00, 0x01, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
-  0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x02, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x06, 0xe0, 0x20, 0x15, 0x17, 0x11,
-  0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15,
-  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xeb, 0x42,
-  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
-  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19, 0x42, 0x14, 0x17, 0x11,
-  0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d,
-  0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18,
-  0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbe, 0x42,
-  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
-  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8,
-  0x94, 0x03, 0x76, 0x7f, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10,
-  0xfd, 0xef, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
-  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24,
-  0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd,
-  0xde, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11,
-  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18,
-  0x19, 0x13, 0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
-  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x19, 0x00, 0x1d,
-  0x00, 0x21, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10,
-  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0xfe, 0x31,
-  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
-  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
-  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x84, 0x0f, 0x0e, 0x19,
-  0x14, 0x43, 0x15, 0x16, 0x11, 0x0f, 0x0f, 0x0f, 0x18, 0x16, 0x41, 0x15,
-  0x18, 0x0f, 0x0f, 0x03, 0xf4, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16,
-  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e,
-  0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3,
-  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
-  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x06, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2c, 0x00, 0x42,
-  0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16,
-  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x05,
-  0x4f, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16,
-  0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
-  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0xfe, 0xa1, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10,
-  0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18,
-  0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
-  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
-  0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2c, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
-  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14,
-  0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18,
-  0x0f, 0x0e, 0x05, 0x4f, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe,
-  0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15,
-  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18,
-  0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e,
-  0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
-  0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfe,
-  0xa1, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11,
-  0x1b, 0x17, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48,
-  0x19, 0x1a, 0x12, 0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10,
-  0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
-  0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d,
-  0x00, 0x71, 0x00, 0x75, 0x00, 0x79, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
-  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x83,
-  0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17,
-  0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x03, 0x07, 0x0e, 0x0f, 0x18, 0x15,
-  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
-  0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15,
-  0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe,
-  0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
-  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18,
-  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
-  0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
-  0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b,
-  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00,
-  0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x84, 0x00, 0x88,
-  0x00, 0x8c, 0x00, 0x90, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
-  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18,
-  0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16,
-  0x18, 0x0f, 0x0e, 0x03, 0x07, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
-  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f,
-  0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20,
-  0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
-  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0xee, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08,
-  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4,
-  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb,
-  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00,
-  0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2a, 0x00, 0x40, 0x00, 0x56, 0x00, 0x6b, 0x00, 0x7f, 0x00, 0x95,
-  0x00, 0x99, 0x00, 0x9d, 0x00, 0xa1, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
-  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
-  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10,
-  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x04, 0x5d,
-  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f,
-  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
-  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19,
-  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
-  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e,
-  0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f,
-  0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
-  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3,
-  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0xb4, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10,
-  0xfd, 0xef, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
-  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24,
-  0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd,
-  0xde, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11,
-  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18,
-  0x19, 0x13, 0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
-  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x2f,
-  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
-  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0x95, 0x08, 0x6a, 0x7f, 0xf8,
-  0x94, 0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfc, 0xf4, 0x04,
-  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
-  0x3d, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38,
-  0x00, 0x4e, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x06,
-  0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a,
-  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0xfd, 0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x02, 0xc3,
-  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb,
-  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x1f,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x00, 0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x4e, 0x00, 0x64, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07,
-  0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16,
-  0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd,
-  0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x01, 0x3f, 0x10, 0x10, 0x1b,
-  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10,
-  0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
-  0x02, 0xc3, 0xfd, 0x3d, 0x1f, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02,
-  0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x08, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x00,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe,
-  0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15,
-  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18,
-  0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e,
-  0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
-  0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
-  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x01, 0x3f, 0x10, 0x10, 0x1b, 0x18,
-  0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f, 0x01,
-  0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb,
-  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x1f,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x00, 0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e, 0x00, 0x53, 0x00, 0x57,
-  0x00, 0x5b, 0x00, 0x5f, 0x00, 0x74, 0x00, 0x89, 0x00, 0x00, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
-  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x05, 0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
-  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15, 0x17, 0x10, 0x0e,
-  0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x42, 0x15, 0x17, 0x10, 0x0f, 0x0f,
-  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18,
-  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15,
-  0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x42, 0x15, 0x17, 0x10,
-  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e,
-  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15,
-  0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
-  0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49,
-  0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x49, 0x18,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02,
-  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb,
-  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x1f,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x49, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x49,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e,
-  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0x00,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x05,
-  0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
-  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
-  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
-  0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
-  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
-  0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10,
-  0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16,
-  0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd,
-  0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x03, 0xcc, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8,
-  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
-  0xfd, 0x3d, 0x1f, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40,
-  0x00, 0x55, 0x00, 0x69, 0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b,
-  0x00, 0xa1, 0x00, 0xb7, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
-  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
-  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x06, 0xe0,
-  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f,
-  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
-  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19,
-  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
-  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e,
-  0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f,
-  0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
-  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3,
-  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15,
-  0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
-  0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f,
-  0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a,
-  0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a, 0x12, 0x02,
-  0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10, 0x11, 0x1b,
-  0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfc, 0xe3,
-  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
-  0xfd, 0x3d, 0x1f, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe, 0xd7,
-  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0xfe, 0x95, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76,
-  0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11,
-  0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49,
-  0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0xfc, 0xf4, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25,
-  0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x58, 0x00, 0x5c, 0x00, 0x60, 0x00, 0x64, 0x00, 0x00, 0x00, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe,
-  0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21,
-  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
-  0x0e, 0x0f, 0x19, 0x14, 0x04, 0x59, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20,
-  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11,
-  0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01,
-  0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11, 0x1a, 0x17,
-  0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19,
-  0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x8f,
-  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb,
-  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00,
-  0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
-  0x00, 0x7a, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27,
-  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17,
-  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16,
-  0xfe, 0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x05, 0xb3, 0x20, 0x15,
-  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
-  0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d,
-  0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f,
-  0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11, 0x1a,
-  0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18,
-  0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0xfd, 0xed, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10,
-  0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18,
-  0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
-  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
-  0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x87,
-  0x00, 0x8b, 0x00, 0x8f, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe,
-  0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x05, 0xb3, 0x20, 0x15, 0x17,
-  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f,
-  0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21,
-  0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08,
-  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0xf9, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x01, 0x09,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xed, 0x10, 0x10, 0x1b,
-  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f,
-  0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5,
-  0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d,
-  0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x99,
-  0x00, 0x9d, 0x00, 0xa1, 0x00, 0xa5, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe,
-  0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x03, 0x6b, 0x0e, 0x0f, 0x18,
-  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
-  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f,
-  0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f,
-  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
-  0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9,
-  0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x7a, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04,
-  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
-  0x3d, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d,
-  0x00, 0x83, 0x00, 0x99, 0x00, 0xb0, 0x00, 0xb4, 0x00, 0xb8, 0x00, 0xbc,
-  0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x25, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04,
-  0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20,
-  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x03, 0x6b, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f,
-  0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f,
-  0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
-  0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17,
-  0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10,
-  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e,
-  0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17,
-  0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8,
-  0x94, 0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0xf9, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x7a, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
-  0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b,
-  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00,
-  0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x56, 0x00, 0x6c, 0x00, 0x82, 0x00, 0x97,
-  0x00, 0xab, 0x00, 0xc1, 0x00, 0xc5, 0x00, 0xc9, 0x00, 0xcd, 0x00, 0x00,
-  0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x21, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
-  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
-  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe, 0xd7,
-  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x04, 0xc1, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f,
-  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
-  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11,
-  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01,
-  0x0f, 0x0f, 0x18, 0x02, 0x19, 0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f,
-  0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15,
-  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
-  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11,
-  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01,
-  0x0f, 0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76,
-  0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11,
-  0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49,
-  0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
-  0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13,
-  0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a, 0x12, 0x02, 0x02,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10, 0x11, 0x1b, 0x18,
-  0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
-  0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfc, 0xe3, 0x04,
-  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
-  0x3d, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e, 0x00, 0x53, 0x00, 0x57,
-  0x00, 0x5b, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x94, 0x0e, 0x10, 0x17, 0x16,
-  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x41, 0x16, 0x16,
-  0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15, 0x17, 0x10,
-  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e,
-  0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
-  0x41, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15,
-  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f,
-  0xfd, 0x43, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x03, 0xcc,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x49, 0x18, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
-  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
-  0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x19, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x36, 0x00, 0x4b, 0x00, 0x60,
-  0x00, 0x75, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x06, 0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17,
-  0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa,
-  0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e,
-  0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
-  0x41, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x42,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
-  0x0f, 0x19, 0x15, 0x41, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19,
-  0x15, 0x42, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16,
-  0x17, 0x10, 0x0f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
-  0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd,
-  0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
-  0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
-  0xe9, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x00,
-  0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16,
-  0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x4e, 0x00, 0x64,
-  0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
-  0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0xd2, 0x20, 0x15, 0x17,
-  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d,
-  0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc,
-  0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e,
-  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15,
-  0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15,
-  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x01, 0x3f, 0x10,
-  0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a,
-  0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
-  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
-  0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0x00,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0xd2,
-  0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
-  0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17,
-  0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c,
-  0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01,
-  0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x01, 0x3f, 0x10, 0x10,
-  0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12,
-  0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04,
-  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
-  0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x0b, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f,
-  0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
-  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x05, 0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01,
-  0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
-  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18,
-  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15,
-  0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f,
-  0xf9, 0x4e, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c,
-  0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01,
-  0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x03, 0xcc, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
-  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e,
-  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0xbc,
-  0x00, 0xd2, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
-  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x05,
-  0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
-  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
-  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
-  0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
-  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
-  0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10,
-  0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16,
-  0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
-  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
-  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03,
-  0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x00, 0x00, 0x0d, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
-  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
-  0x00, 0xcd, 0x00, 0xe3, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
-  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
-  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x06, 0xe0, 0x20, 0x15, 0x17, 0x11,
-  0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15,
-  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xeb, 0x42,
-  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
-  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19, 0x42, 0x14, 0x17, 0x11,
-  0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d,
-  0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18,
-  0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbe, 0x42,
-  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
-  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8,
-  0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15,
-  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
-  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e,
-  0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20,
-  0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17,
-  0x10, 0x0f, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12,
-  0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11,
-  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47,
-  0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a,
-  0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10,
-  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13,
-  0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
-  0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00,
-  0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x21, 0x00, 0x37, 0x00, 0x4d, 0x00, 0x63,
-  0x00, 0x79, 0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11,
-  0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0xb4, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
-  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
-  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f,
-  0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x46, 0x04, 0xf5, 0xfb,
-  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02,
-  0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38,
-  0x00, 0x4e, 0x00, 0x64, 0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21,
-  0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x06,
-  0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a,
-  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16,
-  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
-  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe,
-  0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16,
-  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x02,
-  0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5,
-  0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d,
-  0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02,
-  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x00, 0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x4e, 0x00, 0x64, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0x00,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21,
-  0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07,
-  0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16,
-  0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
-  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
-  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f,
-  0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x01, 0x3f, 0x10, 0x10,
-  0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13,
-  0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25,
-  0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x00, 0x0b, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f,
-  0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe,
-  0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15,
-  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18,
-  0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e,
-  0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
-  0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10,
-  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01,
-  0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17,
-  0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21,
-  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
-  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f,
-  0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f,
-  0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x01, 0x3f, 0x10, 0x10, 0x1b,
-  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f,
-  0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5,
-  0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d,
-  0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02,
-  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x00, 0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b,
-  0x00, 0x5f, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0xbb,
-  0x00, 0xd1, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11,
-  0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x05, 0x8a,
-  0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18,
-  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
-  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01,
-  0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
-  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a,
-  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16,
-  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
-  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe,
-  0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16,
-  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x03,
-  0xcc, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b,
-  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10,
-  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e,
-  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0xbc,
-  0x00, 0xd2, 0x00, 0xe8, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21,
-  0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x05,
-  0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
-  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
-  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
-  0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
-  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
-  0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10,
-  0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16,
-  0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
-  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
-  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
-  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f,
-  0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x03, 0xcc, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd,
-  0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
-  0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
-  0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x00, 0x00, 0x00, 0x0e, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40,
-  0x00, 0x55, 0x00, 0x69, 0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b,
-  0x00, 0xa1, 0x00, 0xb7, 0x00, 0xcd, 0x00, 0xe3, 0x00, 0xf9, 0x00, 0x00,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x17, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x02, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01, 0x11, 0x21, 0x11,
-  0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x06, 0xe0,
-  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f,
-  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
-  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19,
-  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
-  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e,
-  0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f,
-  0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
-  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3,
-  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10,
-  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
-  0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20,
-  0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17,
-  0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e,
-  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f,
-  0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17,
-  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43,
-  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f,
-  0x0e, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f,
-  0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c,
-  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18,
-  0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a, 0x12,
-  0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10, 0x11,
-  0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfc,
-  0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
-  0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
-  0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4,
-  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x22, 0x00, 0x3a, 0x00, 0x50, 0x00, 0x66, 0x00, 0x7c, 0x00, 0x92,
-  0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
-  0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27,
-  0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x00, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x1e, 0x01, 0x07, 0x06, 0x07, 0xb4, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
-  0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21,
-  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec, 0x43, 0x14, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f,
-  0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01,
-  0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
-  0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14,
-  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd3, 0x43,
-  0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17,
-  0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x46, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
-  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17,
-  0x26, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16,
-  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x39, 0x00, 0x51, 0x00, 0x67,
-  0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
-  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x06, 0x78,
-  0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10,
-  0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f,
-  0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e,
-  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
-  0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec,
-  0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15,
-  0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18,
-  0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f,
-  0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
-  0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
-  0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x02, 0xc3, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b,
-  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11,
-  0x1a, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a,
-  0x17, 0x26, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02,
-  0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x4f, 0x00, 0x67, 0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0xbf,
-  0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e,
-  0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
-  0x06, 0x07, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd,
-  0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20,
-  0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a,
-  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10,
-  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe,
-  0xec, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
-  0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14,
-  0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01,
-  0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
-  0x15, 0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0x3f,
-  0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c,
-  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18,
-  0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
-  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x00, 0x00,
-  0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x64,
-  0x00, 0x7c, 0x00, 0x92, 0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0x00,
-  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
-  0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x00,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x07, 0xd2, 0x20,
-  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17,
-  0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17, 0x11,
-  0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa,
-  0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20,
-  0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16,
-  0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e,
-  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
-  0x17, 0x16, 0xfe, 0xec, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01,
-  0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41,
-  0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18,
-  0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e,
-  0x18, 0x01, 0x3f, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09,
-  0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a,
-  0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
-  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x00, 0x00, 0x00,
-  0x00, 0x0d, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
-  0x00, 0x7a, 0x00, 0x92, 0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0xea,
-  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
-  0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x00,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x05, 0x8a, 0x0e,
-  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15,
-  0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15,
-  0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16,
-  0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01, 0xce,
-  0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f,
-  0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a, 0x7f,
-  0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e,
-  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
-  0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec,
-  0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15,
-  0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18,
-  0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f,
-  0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
-  0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
-  0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x03, 0xcc, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
-  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03,
-  0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26,
-  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x00,
-  0x00, 0x0e, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
-  0x00, 0x7a, 0x00, 0x91, 0x00, 0xa9, 0x00, 0xbf, 0x00, 0xd5, 0x00, 0xeb,
-  0x01, 0x01, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
-  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
-  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x05, 0x8a,
-  0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
-  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18,
-  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
-  0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
-  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01,
-  0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
-  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10, 0x17,
-  0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41,
-  0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
-  0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21,
-  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec, 0x43, 0x14, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f,
-  0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01,
-  0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
-  0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14,
-  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd3, 0x43,
-  0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17,
-  0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04,
-  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
-  0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef,
-  0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd,
-  0xee, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x00, 0x0f, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
-  0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
-  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
-  0x00, 0xcc, 0x00, 0xe1, 0x00, 0xf6, 0x01, 0x0b, 0x00, 0x00, 0x01, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
-  0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x02, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
-  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01,
-  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26,
-  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
-  0x06, 0x07, 0x06, 0xe0, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19,
-  0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
-  0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10,
-  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xea, 0x41, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f,
-  0x0f, 0x18, 0x02, 0x19, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10,
-  0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x41,
-  0x15, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18,
-  0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbd, 0x41, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f,
-  0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f,
-  0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x41,
-  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21, 0x20, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0xfe, 0xeb, 0x42, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
-  0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18,
-  0x01, 0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14,
-  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14,
-  0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10,
-  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd2, 0x42, 0x14, 0x18, 0x10, 0x0e,
-  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10,
-  0x0e, 0x18, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12,
-  0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x49, 0x17, 0x1a, 0x13, 0x10, 0xfd, 0xef,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11,
-  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47,
-  0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a,
-  0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10,
-  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13,
-  0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
-  0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x49, 0x18, 0x19, 0x13,
-  0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x12,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49,
-  0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd,
-  0xee, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b,
-  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35,
-  0x01, 0x21, 0x11, 0x21, 0x01, 0xb1, 0x02, 0x7c, 0xfc, 0x87, 0x04, 0x76,
-  0xfb, 0x8a, 0x03, 0x07, 0x8d, 0x8d, 0x04, 0x66, 0xf6, 0xa7, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0xb4, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
-  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x07, 0x6d, 0xf6,
-  0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e,
-  0x00, 0x22, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
-  0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e,
-  0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
-  0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
-  0x02, 0x7c, 0xfd, 0x84, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
-  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x05, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16,
-  0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16,
-  0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
-  0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd,
-  0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02,
-  0x7c, 0xfd, 0x84, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b,
-  0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d,
-  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
-  0x15, 0x21, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef,
-  0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
-  0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41,
-  0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11,
-  0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
-  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10,
-  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24,
-  0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08,
-  0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b,
-  0x00, 0x5f, 0x00, 0x63, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x03, 0xe0,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
-  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11,
-  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
-  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x0e, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d,
-  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
-  0x21, 0x15, 0x21, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
-  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe,
-  0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11,
-  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21,
-  0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16,
-  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a,
-  0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x0e,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd,
-  0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11,
-  0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
-  0xfc, 0x27, 0x8d, 0x00, 0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
-  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0x00, 0x25, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22,
-  0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15,
-  0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17,
-  0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17,
-  0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e,
-  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
-  0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21,
-  0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
-  0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
-  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16,
-  0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x91, 0x24, 0x17, 0x1a,
-  0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c,
-  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x33,
-  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17,
-  0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab, 0x4a, 0x16, 0x1a,
-  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f,
-  0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11,
-  0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x02, 0x82,
-  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17,
-  0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4, 0xf6, 0xa7, 0x8d,
-  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x19, 0x00, 0x1d,
-  0x00, 0x21, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
-  0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
-  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd,
-  0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02,
-  0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0x02,
-  0x02, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
-  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18,
-  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
-  0x0f, 0x0f, 0x17, 0x16, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e,
-  0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
-  0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
-  0x02, 0x7c, 0xfd, 0x84, 0x05, 0x69, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x48, 0x18, 0x1a, 0x11, 0x10,
-  0xfb, 0x9c, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6,
-  0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x06, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2c, 0x00, 0x42,
-  0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
-  0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e,
-  0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
-  0xfe, 0xc4, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f,
-  0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
-  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10,
-  0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x19, 0x1a, 0x11, 0x10, 0xfa, 0x19, 0x24, 0x17, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05,
-  0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00,
-  0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2c, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10,
-  0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f,
-  0x0f, 0x17, 0x16, 0xfe, 0xc4, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
-  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e,
-  0xef, 0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f,
-  0x18, 0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15,
-  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17,
-  0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
-  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17,
-  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a,
-  0x11, 0x10, 0xfa, 0x19, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
-  0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a,
-  0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
-  0x27, 0x8d, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d,
-  0x00, 0x71, 0x00, 0x75, 0x00, 0x79, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1,
-  0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16,
-  0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x01, 0x10, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
-  0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
-  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17,
-  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a,
-  0x11, 0x10, 0xfc, 0xa3, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd,
-  0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00,
-  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x84, 0x00, 0x88,
-  0x00, 0x8c, 0x00, 0x90, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
-  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18,
-  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
-  0x0f, 0x0f, 0x17, 0x16, 0x01, 0x10, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
-  0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
-  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
-  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd,
-  0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16,
-  0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb,
-  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05,
-  0x6b, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0xfc, 0xa3, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19,
-  0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
-  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2a, 0x00, 0x40, 0x00, 0x56, 0x00, 0x6b, 0x00, 0x7f, 0x00, 0x95,
-  0x00, 0x99, 0x00, 0x9d, 0x00, 0xa1, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
-  0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27,
-  0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
-  0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
-  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xa2,
-  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18,
-  0x15, 0x42, 0x14, 0x17, 0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15,
-  0x21, 0x20, 0x15, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16,
-  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
-  0x0e, 0x10, 0x19, 0x15, 0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e,
-  0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18,
-  0x16, 0x41, 0x15, 0x17, 0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f,
-  0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10,
-  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e,
-  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76,
-  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
-  0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0xfb, 0x26, 0x24, 0x17,
-  0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11,
-  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01,
-  0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
-  0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab, 0x4a, 0x16,
-  0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12,
-  0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11,
-  0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x02,
-  0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
-  0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4, 0xf6, 0xa7,
-  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x2f,
-  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
-  0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf,
-  0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
-  0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfd, 0x42, 0x04, 0x76, 0xfb,
-  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03,
-  0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x01, 0x93, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27,
-  0x8d, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38,
-  0x00, 0x4e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
-  0x21, 0x15, 0x21, 0x02, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x02,
-  0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
-  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76,
-  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
-  0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40,
-  0x16, 0x17, 0x11, 0x0e, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
-  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01,
-  0x49, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x00, 0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x4e, 0x00, 0x64, 0x00, 0x00, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
-  0x21, 0x15, 0x21, 0x02, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
-  0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
-  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40,
-  0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
-  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e,
-  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18,
-  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
-  0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02,
-  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x00, 0x08, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x00,
-  0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef,
-  0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
-  0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41,
-  0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11,
-  0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
-  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x7c, 0x24, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10,
-  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8,
-  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
-  0x00, 0x79, 0x00, 0x8f, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
-  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x02, 0x0e, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d,
-  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11,
-  0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x00, 0x00,
-  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
-  0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01,
-  0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0xe0, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
-  0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14,
-  0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4,
-  0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c,
-  0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e,
-  0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e,
-  0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x02, 0x0e, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
-  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10,
-  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
-  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01,
-  0x49, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
-  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
-  0x00, 0x00, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15,
-  0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17,
-  0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17,
-  0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e,
-  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
-  0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21,
-  0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
-  0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
-  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16,
-  0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
-  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e,
-  0x91, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13,
-  0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd,
-  0xab, 0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12,
-  0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f,
-  0x11, 0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05,
-  0xe4, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
-  0x00, 0x4d, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10,
-  0x0e, 0xee, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfd, 0x42, 0x04,
-  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
-  0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x01, 0x93, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
-  0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x5c, 0x00, 0x60, 0x00, 0x64,
-  0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
-  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
-  0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e,
-  0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x81, 0x21, 0x14, 0x18, 0x10, 0x0e,
-  0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f,
-  0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
-  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
-  0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfb, 0x2b, 0x10, 0x11, 0x1a,
-  0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49,
-  0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
-  0x27, 0x8d, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6e,
-  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01,
-  0x95, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14,
-  0x43, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17,
-  0x10, 0x0e, 0xee, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x22,
-  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x19,
-  0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16,
-  0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78,
-  0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19,
-  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
-  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xf9, 0xaa, 0x24, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18, 0x1a, 0x12, 0x0f,
-  0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
-  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x87,
-  0x00, 0x8b, 0x00, 0x8f, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17, 0x16,
-  0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e, 0x10,
-  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16,
-  0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x22, 0x0e, 0x0f, 0x18, 0x16, 0x41,
-  0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17,
-  0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f,
-  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f,
-  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40,
-  0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17,
-  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10,
-  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
-  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xf9, 0xaa, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13,
-  0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05,
-  0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00,
-  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x99,
-  0x00, 0x9d, 0x00, 0xa1, 0x00, 0xa5, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x13, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17, 0x16,
-  0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
-  0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e, 0x10,
-  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16,
-  0x40, 0x16, 0x17, 0x11, 0x0e, 0x6e, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
-  0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
-  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
-  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc,
-  0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02,
-  0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x01,
-  0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0xfc, 0x34, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
-  0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x99,
-  0x00, 0xb0, 0x00, 0xb4, 0x00, 0xb8, 0x00, 0xbc, 0x00, 0x00, 0x00, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x13, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
-  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
-  0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e,
-  0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x6e, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
-  0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
-  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76,
-  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
-  0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10,
-  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0xfc, 0x34, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01,
-  0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7,
-  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x56, 0x00, 0x6c, 0x00, 0x82, 0x00, 0x97, 0x00, 0xab, 0x00, 0xc1,
-  0x00, 0xc5, 0x00, 0xc9, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x11, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10,
-  0x0e, 0xee, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x19,
-  0x15, 0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14,
-  0x17, 0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15,
-  0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e,
-  0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19,
-  0x15, 0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15,
-  0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15,
-  0x17, 0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12,
-  0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e,
-  0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18,
-  0x16, 0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
-  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a,
-  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
-  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfa, 0xb7,
-  0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
-  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
-  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab,
-  0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10,
-  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
-  0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
-  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4,
-  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x07, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e,
-  0x00, 0x53, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x03, 0xe0,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17,
-  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
-  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x06, 0x74, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x49, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x49,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
-  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x03, 0x0b, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27,
-  0x8d, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x19, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x36,
-  0x00, 0x4b, 0x00, 0x60, 0x00, 0x75, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10,
-  0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x42, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f,
-  0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
-  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42,
-  0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68,
-  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49,
-  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
-  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17,
-  0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x4e, 0x00, 0x64, 0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x05, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37,
-  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01,
-  0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
-  0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
-  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40,
-  0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
-  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x10, 0x18, 0x14, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02,
-  0x3b, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7,
-  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
-  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
-  0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0x00,
-  0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x94,
-  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14,
-  0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18,
-  0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e,
-  0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04,
-  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
-  0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0x7c, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10,
-  0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x01, 0x2e, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6,
-  0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10,
-  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f,
-  0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
-  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
-  0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc, 0xf6, 0x04,
-  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
-  0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0x02, 0x0e, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08,
-  0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e, 0x00, 0x53, 0x00, 0x69,
-  0x00, 0x6d, 0x00, 0x71, 0x00, 0x75, 0x00, 0x8a, 0x00, 0x9f, 0x00, 0xb4,
-  0x00, 0xc9, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
-  0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f,
-  0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e,
-  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
-  0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14,
-  0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x42, 0x16, 0x16, 0x10, 0x0f,
-  0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e,
-  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e,
-  0x10, 0x18, 0x14, 0x02, 0x0e, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0xfd,
-  0xee, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19,
-  0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10,
-  0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08,
-  0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10,
-  0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18,
-  0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00,
-  0x00, 0x0d, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x14,
-  0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69, 0x00, 0x7f, 0x00, 0x83,
-  0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7, 0x00, 0xcd, 0x00, 0xe3,
-  0x00, 0x00, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x17, 0x11,
-  0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17, 0x12, 0x0e, 0xfe, 0x24,
-  0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17, 0x12, 0x0e, 0x0e, 0x10,
-  0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x16, 0x3f,
-  0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x20, 0x20, 0x16, 0x18,
-  0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
-  0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0xfe, 0x15, 0x0e,
-  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
-  0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20,
-  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
-  0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
-  0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
-  0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
-  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
-  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0x91,
-  0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
-  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
-  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab,
-  0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10,
-  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
-  0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
-  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4,
-  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
-  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x21, 0x00, 0x37, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x00,
-  0x13, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0xb4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
-  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
-  0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
-  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x07, 0x6d, 0xf6, 0xa7,
-  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
-  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10,
-  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16,
-  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38, 0x00, 0x4e, 0x00, 0x64,
-  0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11,
-  0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x02, 0xf1, 0x21, 0x14, 0x18,
-  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
-  0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
-  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
-  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x01,
-  0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7,
-  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
-  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10,
-  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x4c, 0x00, 0x61,
-  0x00, 0x76, 0x00, 0x8b, 0x00, 0xa0, 0x00, 0x00, 0x05, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21,
-  0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e,
-  0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc,
-  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a,
-  0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f,
-  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17,
-  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e,
-  0x0e, 0x1a, 0x14, 0x42, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
-  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18, 0x1a,
-  0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
-  0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee,
-  0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12,
-  0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11,
-  0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x19, 0x1a, 0x11, 0x10, 0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
-  0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0xbb,
-  0x00, 0x00, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21,
-  0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x94,
-  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
-  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14,
-  0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18,
-  0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e,
-  0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04,
-  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
-  0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18,
-  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
-  0x0f, 0x0f, 0x17, 0x16, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
-  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18,
-  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12,
-  0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
-  0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
-  0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0x00, 0x00, 0x00,
-  0x00, 0x0c, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
-  0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0xbb, 0x00, 0xd1, 0x00, 0x00,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21,
-  0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
-  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
-  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
-  0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
-  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x02, 0x0e, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
-  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08,
-  0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12,
-  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0x00, 0x00,
-  0x00, 0x0d, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
-  0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0xbc, 0x00, 0xd2, 0x00, 0xe8,
-  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11,
-  0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
-  0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14,
-  0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4,
-  0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c,
-  0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
-  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
-  0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
-  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14,
-  0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10,
-  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x02, 0x0e, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18,
-  0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10,
-  0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd,
-  0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11,
-  0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x19, 0x1a, 0x11, 0x10, 0x00, 0x0e, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
-  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
-  0x00, 0xcd, 0x00, 0xe3, 0x00, 0xf9, 0x00, 0x00, 0x25, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26,
-  0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
-  0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e,
-  0x01, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21,
-  0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
-  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15,
-  0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17,
-  0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17,
-  0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e,
-  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
-  0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21,
-  0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
-  0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
-  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10,
-  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16,
-  0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
-  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
-  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
-  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
-  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
-  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
-  0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
-  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x91,
-  0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
-  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
-  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab,
-  0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10,
-  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
-  0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
-  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4,
-  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11,
-  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24,
-  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
-  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17,
-  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a,
-  0x11, 0x10, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x22, 0x00, 0x3a,
-  0x00, 0x50, 0x00, 0x66, 0x00, 0x7c, 0x00, 0x92, 0x00, 0x00, 0x13, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26,
-  0x27, 0xb4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
-  0x02, 0x7c, 0xfd, 0x84, 0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11,
-  0x0f, 0xfe, 0x24, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20,
-  0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17,
-  0x11, 0x0e, 0xfe, 0x23, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01,
-  0xdd, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x07, 0x6d, 0xf6, 0xa7, 0x8d,
-  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33,
-  0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
-  0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11,
-  0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x02, 0x6b, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x00,
-  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16,
-  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x39, 0x00, 0x51, 0x00, 0x67,
-  0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
-  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07,
-  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17,
-  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x02, 0xf1,
-  0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16,
-  0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb,
-  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x01,
-  0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e, 0x10,
-  0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23, 0x0e,
-  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x17, 0x11, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a,
-  0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06,
-  0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
-  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x01, 0x33, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd,
-  0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x02, 0x6b, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10,
-  0x1b, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x4f, 0x00, 0x67, 0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0xbf,
-  0x00, 0x00, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
-  0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e,
-  0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27,
-  0x26, 0x27, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
-  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01,
-  0xdc, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb,
-  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x01,
-  0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e, 0x0e,
-  0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e, 0x10,
-  0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23, 0x0e,
-  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x17, 0x11, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b,
-  0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d,
-  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
-  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33,
-  0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
-  0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11,
-  0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
-  0x02, 0x6b, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
-  0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x00,
-  0x00, 0x0c, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16,
-  0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x64,
-  0x00, 0x7c, 0x00, 0x92, 0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0x00,
-  0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22,
-  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x94, 0x0e,
-  0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
-  0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14, 0x43,
-  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18, 0x10,
-  0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
-  0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76,
-  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
-  0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e,
-  0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40,
-  0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16,
-  0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
-  0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23,
-  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18,
-  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40,
-  0x16, 0x17, 0x11, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
-  0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a,
-  0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
-  0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25,
-  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33, 0x4a, 0x17, 0x1a,
-  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10,
-  0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01,
-  0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x02, 0x6b, 0x4a,
-  0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
-  0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x00, 0x0d, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
-  0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x7a, 0x00, 0x92,
-  0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0xea, 0x00, 0x00, 0x01, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
-  0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x01,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37,
-  0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x0e, 0x01, 0x27, 0x26, 0x27, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
-  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
-  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
-  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
-  0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
-  0x02, 0x7c, 0xfd, 0x84, 0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11,
-  0x0f, 0xfe, 0x24, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
-  0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20,
-  0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17,
-  0x11, 0x0e, 0xfe, 0x23, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01,
-  0xdd, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
-  0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x02, 0x0e, 0x10, 0x11, 0x1a,
-  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
-  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
-  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11,
-  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
-  0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
-  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
-  0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
-  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33, 0x4a, 0x17,
-  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11,
-  0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10,
-  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
-  0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b,
-  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x02, 0x6b,
-  0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
-  0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x0e, 0x00, 0xb4,
-  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e,
-  0x00, 0x53, 0x00, 0x69, 0x00, 0x6d, 0x00, 0x71, 0x00, 0x75, 0x00, 0x8b,
-  0x00, 0xa1, 0x00, 0xb6, 0x00, 0xcb, 0x00, 0xe0, 0x00, 0xf5, 0x00, 0x00,
-  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
-  0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
-  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01,
-  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16,
-  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
-  0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f,
-  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
-  0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
-  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42,
-  0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
-  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
-  0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
-  0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x42,
-  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76,
-  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
-  0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e,
-  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e,
-  0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
-  0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x01,
-  0xcf, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
-  0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23, 0x0e, 0x10, 0x17,
-  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16,
-  0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16,
-  0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x02, 0x0e,
-  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
-  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17,
-  0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
-  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11,
-  0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
-  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
-  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02,
-  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x01, 0x34, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd,
-  0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x02, 0x6c, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10,
-  0x1b, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
-  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
-  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
-  0x00, 0xcc, 0x00, 0xe1, 0x00, 0xf6, 0x01, 0x0b, 0x00, 0x00, 0x25, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22,
-  0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17,
-  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
-  0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
-  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
-  0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01,
-  0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
-  0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
-  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27,
-  0x26, 0x27, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x17, 0x11,
-  0x0d, 0x0d, 0x10, 0x18, 0x15, 0x41, 0x15, 0x17, 0x12, 0x0e, 0xfe, 0x24,
-  0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17, 0x12, 0x0e, 0x0e, 0x10,
-  0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x16, 0x3f,
-  0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x20, 0x20, 0x16, 0x18,
-  0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
-  0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0xfe, 0x15, 0x0e,
-  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
-  0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20,
-  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
-  0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
-  0x02, 0x7c, 0xfd, 0x84, 0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
-  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x16, 0x11,
-  0x0f, 0xfe, 0x24, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10,
-  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
-  0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41,
-  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16,
-  0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe,
-  0x23, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10,
-  0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18,
-  0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
-  0x17, 0x11, 0x91, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
-  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
-  0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x01, 0x34, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11,
-  0x1a, 0xfd, 0xab, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b,
-  0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x49, 0x17,
-  0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12,
-  0x0f, 0x0f, 0x11, 0x1b, 0x02, 0x83, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
-  0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11,
-  0x1a, 0x05, 0xe4, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02,
-  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
-  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12,
-  0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
-  0x1a, 0x18, 0x01, 0x34, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
-  0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd,
-  0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
-  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
-  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
-  0x10, 0x11, 0x1b, 0x17, 0x02, 0x6c, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10,
-  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10,
-  0x1b, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x22,
-  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
-  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x11,
-  0x21, 0x11, 0x01, 0x8c, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x0e, 0x03, 0xda, 0x06,
-  0xf5, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
-  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf7, 0xd3, 0x07, 0x01, 0xf8, 0xff,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x33, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x16,
-  0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23,
-  0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01,
-  0x03, 0x33, 0x03, 0x33, 0x01, 0x23, 0x27, 0x21, 0x07, 0x23, 0x04, 0x5b,
-  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
-  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01, 0x04, 0x77, 0x3d, 0xfe,
-  0xd7, 0x3d, 0x77, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4,
-  0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82,
-  0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
-  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac, 0xfe, 0x55, 0x02,
-  0x0f, 0xfc, 0xbc, 0xda, 0xda, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
-  0x00, 0x49, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23,
-  0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22,
-  0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
-  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
-  0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x21, 0x15, 0x21, 0x35, 0x36, 0x37,
-  0x00, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x01, 0x06, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08,
-  0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf,
-  0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
-  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x75, 0x01,
-  0x7d, 0xfd, 0xe6, 0x1f, 0x38, 0x01, 0x36, 0x5e, 0x4c, 0x2f, 0x6e, 0x41,
-  0x46, 0x77, 0x34, 0x82, 0x9d, 0xfe, 0xd6, 0x33, 0x03, 0x18, 0x79, 0xfe,
-  0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4,
-  0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78,
-  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
-  0xfc, 0x3f, 0x72, 0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23,
-  0x23, 0x7b, 0x1c, 0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x59, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
-  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
-  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
-  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
-  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x1e, 0x01,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
-  0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c,
-  0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c,
-  0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x57, 0x53, 0x5b, 0xab, 0x9f, 0x33,
-  0x71, 0x3f, 0x2f, 0x6b, 0x3c, 0x62, 0x6c, 0x64, 0x61, 0x4d, 0x54, 0x55,
-  0x57, 0x5a, 0x55, 0x24, 0x5c, 0x49, 0x42, 0x73, 0x31, 0x82, 0x98, 0x51,
-  0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b,
-  0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78,
-  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
-  0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x91, 0x12, 0x6d, 0x52, 0x7c, 0x86, 0x15,
-  0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46, 0x4a, 0x4c, 0x6c, 0x3f, 0x3c, 0x3a,
-  0x3d, 0x12, 0x17, 0x73, 0x11, 0x12, 0x76, 0x63, 0x45, 0x60, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x33, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x16,
-  0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23,
-  0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x09,
-  0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x21,
-  0x35, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b,
-  0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd,
-  0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
-  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95,
-  0x7a, 0x7a, 0x81, 0xfe, 0x8b, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25,
-  0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26,
-  0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
-  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe,
-  0x5d, 0x02, 0x1c, 0xfd, 0xe4, 0x6d, 0xba, 0xba, 0x79, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x51, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
-  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
-  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
-  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
-  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21, 0x15,
-  0x21, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08,
-  0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf,
-  0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
-  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb,
-  0xfe, 0xa0, 0x19, 0x1a, 0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e,
-  0x36, 0x72, 0x3b, 0x33, 0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f,
-  0x5d, 0x31, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b,
-  0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04,
-  0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
-  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04,
-  0x4d, 0x4c, 0x83, 0x87, 0x4b, 0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d,
-  0x66, 0xae, 0x66, 0x14, 0x15, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
-  0x00, 0x40, 0x00, 0x60, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15,
-  0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06,
-  0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14,
-  0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11,
-  0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x22, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x13,
-  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x04, 0x5b, 0x3b, 0x01, 0x1b,
-  0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61,
-  0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
-  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x0d,
-  0x4f, 0x2e, 0x2e, 0x2e, 0x2e, 0x4f, 0x4e, 0x2e, 0x2e, 0x2e, 0x2e, 0x9a,
-  0x2c, 0x2d, 0x2d, 0x2c, 0x73, 0x3e, 0x3d, 0x09, 0x22, 0x34, 0x34, 0x3d,
-  0x83, 0x4b, 0x4c, 0x4f, 0x4f, 0x82, 0x97, 0x9e, 0x61, 0x61, 0xa4, 0x2c,
-  0x2d, 0x2d, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b,
-  0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04,
-  0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
-  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x9e, 0x34, 0x35, 0x5b, 0x5a,
-  0x34, 0x35, 0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14,
-  0x0a, 0x0b, 0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f,
-  0x4f, 0x4e, 0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x37, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
-  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
-  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
-  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
-  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21, 0x15,
-  0x01, 0x23, 0x01, 0x21, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0,
-  0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08,
-  0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7,
-  0x7a, 0x01, 0x27, 0xfe, 0x61, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25,
-  0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26,
-  0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
-  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc,
-  0xed, 0x02, 0xe4, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3d, 0x00, 0x5b,
-  0x00, 0x6a, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23,
-  0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22,
-  0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
-  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
-  0x21, 0x22, 0x35, 0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x36, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x22, 0x07, 0x06, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61,
-  0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01,
-  0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
-  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x55, 0xa8, 0x2f, 0x30, 0x5f,
-  0x54, 0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01, 0x02,
-  0x4a, 0x48, 0x29, 0x2a, 0x4b, 0x51, 0x32, 0x30, 0x4c, 0x4e, 0x8e, 0x8f,
-  0x4d, 0x4d, 0x30, 0x30, 0x29, 0x2a, 0x29, 0x4d, 0x49, 0x2c, 0x2b, 0x2b,
-  0x2a, 0x96, 0x2b, 0x2a, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e,
-  0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01,
-  0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x5b, 0x2c, 0x2b,
-  0x4b, 0x4c, 0x56, 0x2c, 0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48,
-  0x64, 0x74, 0x3a, 0x3a, 0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37,
-  0x50, 0x79, 0x41, 0x41, 0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f,
-  0x26, 0x25, 0x25, 0x24, 0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x50, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x16,
-  0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23,
-  0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01,
-  0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x04, 0x5b,
-  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
-  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x01, 0x10, 0x2c, 0x2d, 0x2d, 0x2b, 0x74, 0x3d, 0x3d, 0x09, 0x20,
-  0x36, 0x33, 0x3e, 0x82, 0x97, 0x4e, 0x50, 0x82, 0x96, 0x4f, 0x4f, 0x60,
-  0x62, 0xa4, 0x2c, 0x2d, 0x2d, 0xb8, 0x4f, 0x5c, 0x2e, 0x2e, 0x4f, 0x4c,
-  0x30, 0x2f, 0x2f, 0x2e, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e,
-  0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01,
-  0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xdf, 0x67, 0x14,
-  0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b, 0x1a, 0x98, 0x84, 0x81, 0x4d,
-  0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x01, 0x72, 0x68,
-  0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5c, 0x34, 0x34, 0x00, 0x00,
-  0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x3e, 0x00, 0x4a, 0x00, 0x51, 0x00, 0x00,
-  0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14,
-  0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36,
-  0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34,
-  0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11,
-  0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x04, 0x5b,
-  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
-  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x03, 0x86, 0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e,
-  0x6d, 0x76, 0x99, 0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e,
-  0x7b, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc,
-  0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56,
-  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
-  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56,
-  0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde,
-  0xd4, 0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
-  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
-  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
-  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
-  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x05, 0x33, 0x11,
-  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x04, 0x5b,
-  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
-  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x01, 0x87, 0x72, 0x3b, 0x39, 0x81, 0x2c, 0x24, 0x4c, 0x3f, 0x03,
-  0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b,
-  0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78, 0xf8,
-  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
-  0x07, 0x79, 0xf0, 0xf0, 0xfd, 0xdc, 0x95, 0x46, 0x45, 0x60, 0x54, 0x6c,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
-  0x00, 0x24, 0x00, 0x30, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
-  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
-  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
-  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
-  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x0e, 0x01,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
-  0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x04,
-  0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89,
-  0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c,
-  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
-  0xba, 0xd8, 0x02, 0xe9, 0x2c, 0x5b, 0x33, 0xa3, 0xb4, 0xb5, 0xa2, 0x33,
-  0x5c, 0x2b, 0x2a, 0x5f, 0x31, 0x70, 0x6f, 0x6e, 0x71, 0x31, 0x60, 0x29,
-  0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b,
-  0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78,
-  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
-  0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xeb, 0x17, 0x16, 0xe3, 0xce, 0xcd, 0xe5,
-  0x17, 0x17, 0x74, 0x22, 0x24, 0xaa, 0xac, 0xab, 0xab, 0x24, 0x22, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x11,
-  0x00, 0x1b, 0x00, 0x34, 0x00, 0x40, 0x00, 0x4c, 0x00, 0x00, 0x01, 0x22,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23, 0x22, 0x06, 0x10, 0x16,
-  0x33, 0x32, 0x05, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27,
-  0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34,
-  0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35,
-  0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22,
-  0x35, 0x11, 0x34, 0x02, 0xaf, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c, 0x8e,
-  0x8f, 0x8d, 0x4e, 0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d, 0x4d,
-  0x56, 0x58, 0x01, 0x6b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c,
-  0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c,
-  0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x03, 0x2c, 0x01, 0xd7, 0xda, 0xdb, 0xd7,
-  0xd7, 0xdb, 0xa5, 0xc9, 0x28, 0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e,
-  0x9e, 0xfe, 0x90, 0x9e, 0x6e, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4,
-  0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82,
-  0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
-  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
-  0x00, 0x3b, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23,
-  0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22,
-  0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
-  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
-  0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01,
-  0x23, 0x01, 0x11, 0x23, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0,
-  0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08,
-  0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x72, 0x01, 0x46, 0x94,
-  0xfe, 0x91, 0x01, 0x8c, 0x96, 0xfe, 0x9f, 0x72, 0x03, 0x18, 0x79, 0xfe,
-  0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4,
-  0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78,
-  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
-  0xf0, 0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe,
-  0x6d, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x30, 0x00, 0x38,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x01, 0x03, 0x33, 0x03, 0x33, 0x01, 0x23, 0x27, 0x21, 0x07, 0x23, 0x04,
-  0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe,
-  0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01, 0x04, 0x77, 0x3d, 0xfe,
-  0xd7, 0x3d, 0x77, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e,
-  0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41,
-  0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
-  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac, 0xfe, 0x55, 0x02,
-  0x0f, 0xfc, 0xbc, 0xda, 0xda, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
-  0x00, 0x46, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x01, 0x21, 0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
-  0x14, 0x01, 0x06, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
-  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
-  0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x75, 0x01, 0x7d, 0xfd, 0xe6, 0x1f,
-  0x38, 0x01, 0x36, 0x5e, 0x4c, 0x2f, 0x6e, 0x41, 0x46, 0x77, 0x34, 0x82,
-  0x9d, 0xfe, 0xd6, 0x33, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
-  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
-  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfc, 0x3f, 0x72, 0x6e,
-  0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23, 0x23, 0x7b, 0x1c, 0x1c,
-  0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
-  0x00, 0x56, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27,
-  0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
-  0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x04, 0x51, 0x14, 0x31, 0x38,
-  0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38,
-  0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
-  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x57, 0x53,
-  0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f, 0x2f, 0x6b, 0x3c, 0x62, 0x6c, 0x64,
-  0x61, 0x4d, 0x54, 0x55, 0x57, 0x5a, 0x55, 0x24, 0x5c, 0x49, 0x42, 0x73,
-  0x31, 0x82, 0x98, 0x51, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
-  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
-  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x91, 0x12, 0x6d,
-  0x52, 0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46, 0x4a, 0x4c,
-  0x6c, 0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11, 0x12, 0x76, 0x63,
-  0x45, 0x60, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x30, 0x00, 0x3b,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35,
-  0x21, 0x35, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71,
-  0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd,
-  0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
-  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95,
-  0x7a, 0x7a, 0x81, 0xfe, 0x8b, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d,
-  0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95,
-  0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
-  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe,
-  0x5d, 0x02, 0x1c, 0xfd, 0xe4, 0x6d, 0xba, 0xba, 0x79, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x21, 0x00, 0x2d, 0x00, 0x4e, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33,
-  0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14,
-  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21, 0x15, 0x21, 0x15, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
-  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
-  0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb, 0xfe, 0xa0, 0x19, 0x1a,
-  0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e, 0x36, 0x72, 0x3b, 0x33,
-  0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f, 0x5d, 0x31, 0x01, 0xb6,
-  0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92,
-  0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87,
-  0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07,
-  0x79, 0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04, 0x4d, 0x4c, 0x83, 0x87,
-  0x4b, 0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d, 0x66, 0xae, 0x66, 0x14,
-  0x15, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3d, 0x00, 0x5d,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4,
-  0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c,
-  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
-  0xba, 0xd8, 0x02, 0x0d, 0x4f, 0x2e, 0x2e, 0x2e, 0x2e, 0x4f, 0x4e, 0x2e,
-  0x2e, 0x2e, 0x2e, 0x9a, 0x2c, 0x2d, 0x2d, 0x2c, 0x73, 0x3e, 0x3d, 0x09,
-  0x22, 0x34, 0x34, 0x3d, 0x83, 0x4b, 0x4c, 0x4f, 0x4f, 0x82, 0x97, 0x9e,
-  0x61, 0x61, 0xa4, 0x2c, 0x2d, 0x2d, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95,
-  0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d,
-  0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79,
-  0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x9e,
-  0x34, 0x35, 0x5b, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34,
-  0x01, 0x62, 0x67, 0x14, 0x0a, 0x0b, 0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a,
-  0x4c, 0x4d, 0x84, 0x7f, 0x4f, 0x4e, 0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08,
-  0x09, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x34, 0x00, 0x00,
-  0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x09,
-  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x01, 0x22,
-  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
-  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21,
-  0x15, 0x01, 0x23, 0x01, 0x21, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d,
-  0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e,
-  0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7,
-  0x7a, 0x01, 0x27, 0xfe, 0x61, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d,
-  0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95,
-  0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
-  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc,
-  0xed, 0x02, 0xe4, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3a, 0x00, 0x58,
-  0x00, 0x67, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x20, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06,
-  0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4,
-  0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c,
-  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
-  0xba, 0xd8, 0x02, 0x55, 0xa8, 0x2f, 0x30, 0x5f, 0x54, 0x53, 0x30, 0x30,
-  0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01, 0x02, 0x4a, 0x48, 0x29, 0x2a,
-  0x4b, 0x51, 0x32, 0x30, 0x4c, 0x4e, 0x8e, 0x8f, 0x4d, 0x4d, 0x30, 0x30,
-  0x29, 0x2a, 0x29, 0x4d, 0x49, 0x2c, 0x2b, 0x2b, 0x2a, 0x96, 0x2b, 0x2a,
-  0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e,
-  0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78,
-  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
-  0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x5b, 0x2c, 0x2b, 0x4b, 0x4c, 0x56, 0x2c,
-  0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48, 0x64, 0x74, 0x3a, 0x3a,
-  0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37, 0x50, 0x79, 0x41, 0x41,
-  0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f, 0x26, 0x25, 0x25, 0x24,
-  0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
-  0x00, 0x4d, 0x00, 0x5c, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
-  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
-  0x22, 0x35, 0x11, 0x34, 0x01, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x13, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
-  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
-  0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x10, 0x2c, 0x2d, 0x2d, 0x2b, 0x74,
-  0x3d, 0x3d, 0x09, 0x20, 0x36, 0x33, 0x3e, 0x82, 0x97, 0x4e, 0x50, 0x82,
-  0x96, 0x4f, 0x4f, 0x60, 0x62, 0xa4, 0x2c, 0x2d, 0x2d, 0xb8, 0x4f, 0x5c,
-  0x2e, 0x2e, 0x4f, 0x4c, 0x30, 0x2f, 0x2f, 0x2e, 0x01, 0xb6, 0x76, 0x3e,
-  0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0,
-  0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78,
-  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
-  0xfb, 0xdf, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b, 0x1a,
-  0x98, 0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76, 0x08,
-  0x09, 0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5c,
-  0x34, 0x34, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3b, 0x00, 0x47,
-  0x00, 0x4e, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37,
-  0x36, 0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x04,
-  0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe,
-  0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x03, 0x86, 0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e,
-  0x6d, 0x76, 0x99, 0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e,
-  0x7b, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe,
-  0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc,
-  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
-  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56,
-  0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde,
-  0xd4, 0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15,
-  0x00, 0x21, 0x00, 0x2d, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33,
-  0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14,
-  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x05, 0x33, 0x11, 0x14, 0x07, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x04, 0x51, 0x14, 0x31, 0x38,
-  0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38,
-  0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
-  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x87, 0x72,
-  0x3b, 0x39, 0x81, 0x2c, 0x24, 0x4c, 0x3f, 0x01, 0xb6, 0x76, 0x3e, 0x47,
-  0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b,
-  0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
-  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0,
-  0xfd, 0xdc, 0x95, 0x46, 0x45, 0x60, 0x54, 0x6c, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
-  0x00, 0x47, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
-  0x33, 0x32, 0x36, 0x37, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38,
-  0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36,
-  0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
-  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xe9, 0x2c, 0x5b, 0x33, 0xa3,
-  0xb4, 0xb5, 0xa2, 0x33, 0x5c, 0x2b, 0x2a, 0x5f, 0x31, 0x70, 0x6f, 0x6e,
-  0x71, 0x31, 0x60, 0x29, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
-  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
-  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xeb, 0x17, 0x16,
-  0xe3, 0xce, 0xcd, 0xe5, 0x17, 0x17, 0x74, 0x22, 0x24, 0xaa, 0xac, 0xab,
-  0xab, 0x24, 0x22, 0x00, 0x00, 0x05, 0x00, 0xc3, 0xfe, 0x14, 0x06, 0xb9,
-  0x07, 0x6d, 0x00, 0x11, 0x00, 0x1b, 0x00, 0x31, 0x00, 0x3d, 0x00, 0x49,
-  0x00, 0x00, 0x01, 0x22, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23,
-  0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
-  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
-  0x22, 0x35, 0x11, 0x34, 0x02, 0xaf, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c,
-  0x8e, 0x8f, 0x8d, 0x4e, 0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d,
-  0x4d, 0x56, 0x58, 0x01, 0x61, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
-  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
-  0xfd, 0x5e, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x03, 0x2c, 0x01, 0xd7, 0xda, 0xdb, 0xd7,
-  0xd7, 0xdb, 0xa5, 0xc9, 0x28, 0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e,
-  0x9e, 0xfe, 0x90, 0x9e, 0xfe, 0x30, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
-  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
-  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
-  0x00, 0x38, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x17, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
-  0x23, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe,
-  0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f,
-  0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8,
-  0xfb, 0xba, 0xd8, 0xd8, 0x72, 0x01, 0x46, 0x94, 0xfe, 0x91, 0x01, 0x8c,
-  0x96, 0xfe, 0x9f, 0x72, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
-  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
-  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0xfe, 0x9f, 0x01,
-  0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe, 0x6d, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06,
-  0x00, 0x12, 0x00, 0x1e, 0x00, 0x21, 0x00, 0x29, 0x00, 0x00, 0x01, 0x30,
-  0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
-  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
-  0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x03, 0x33, 0x03, 0x33, 0x01, 0x23,
-  0x27, 0x21, 0x07, 0x23, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f,
-  0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01,
-  0x04, 0x77, 0x3d, 0xfe, 0xd7, 0x3d, 0x77, 0x02, 0xf9, 0xfd, 0xf2, 0xfd,
-  0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79,
-  0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac,
-  0xfe, 0x55, 0x02, 0x0f, 0xfc, 0xbc, 0xda, 0xda, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
-  0x00, 0x37, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01,
-  0x21, 0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34, 0x26, 0x23, 0x22,
-  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x01, 0x06,
-  0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x01, 0x75, 0x01, 0x7d, 0xfd, 0xe6, 0x1f, 0x38, 0x01, 0x36, 0x5e,
-  0x4c, 0x2f, 0x6e, 0x41, 0x46, 0x77, 0x34, 0x82, 0x9d, 0xfe, 0xd6, 0x33,
-  0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8,
-  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
-  0x07, 0x79, 0xf0, 0xfc, 0x3f, 0x72, 0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e,
-  0x42, 0x51, 0x23, 0x23, 0x7b, 0x1c, 0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4,
-  0x30, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x47, 0x00, 0x00,
-  0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14,
-  0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11,
-  0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x1e, 0x01, 0x15, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
-  0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x02, 0x57, 0x53, 0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f, 0x2f, 0x6b,
-  0x3c, 0x62, 0x6c, 0x64, 0x61, 0x4d, 0x54, 0x55, 0x57, 0x5a, 0x55, 0x24,
-  0x5c, 0x49, 0x42, 0x73, 0x31, 0x82, 0x98, 0x51, 0x02, 0xf9, 0xfd, 0xf2,
-  0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
-  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd,
-  0x91, 0x12, 0x6d, 0x52, 0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f,
-  0x46, 0x4a, 0x4c, 0x6c, 0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11,
-  0x12, 0x76, 0x63, 0x45, 0x60, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
-  0x00, 0x21, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01,
-  0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34,
-  0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11,
-  0x34, 0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23,
-  0x35, 0x21, 0x35, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe,
-  0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
-  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95,
-  0x7a, 0x7a, 0x81, 0xfe, 0x8b, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02,
-  0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe, 0x5d,
-  0x02, 0x1c, 0xfd, 0xe4, 0x6d, 0xba, 0xba, 0x79, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
-  0x00, 0x3f, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17,
-  0x21, 0x15, 0x21, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
-  0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x04, 0x4f, 0x01, 0x70,
-  0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
-  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb,
-  0xfe, 0xa0, 0x19, 0x1a, 0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e,
-  0x36, 0x72, 0x3b, 0x33, 0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f,
-  0x5d, 0x31, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a,
-  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
-  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04, 0x4d,
-  0x4c, 0x83, 0x87, 0x4b, 0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d, 0x66,
-  0xae, 0x66, 0x14, 0x15, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x2e, 0x00, 0x4e,
-  0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15,
-  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
-  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x04, 0x4f, 0x01,
-  0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
-  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x0d,
-  0x4f, 0x2e, 0x2e, 0x2e, 0x2e, 0x4f, 0x4e, 0x2e, 0x2e, 0x2e, 0x2e, 0x9a,
-  0x2c, 0x2d, 0x2d, 0x2c, 0x73, 0x3e, 0x3d, 0x09, 0x22, 0x34, 0x34, 0x3d,
-  0x83, 0x4b, 0x4c, 0x4f, 0x4f, 0x82, 0x97, 0x9e, 0x61, 0x61, 0xa4, 0x2c,
-  0x2d, 0x2d, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a,
-  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
-  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x9e, 0x34, 0x35, 0x5b, 0x5a, 0x34,
-  0x35, 0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14, 0x0a,
-  0x0b, 0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f, 0x4f,
-  0x4e, 0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
-  0x00, 0x25, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17,
-  0x21, 0x15, 0x01, 0x23, 0x01, 0x21, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90,
-  0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7,
-  0x7a, 0x01, 0x27, 0xfe, 0x61, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02,
-  0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
-  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc, 0xed,
-  0x02, 0xe4, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x2b, 0x00, 0x49,
-  0x00, 0x58, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x00,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x34, 0x2f,
-  0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x20, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x14, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x04, 0x4f, 0x01,
-  0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
-  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x55,
-  0xa8, 0x2f, 0x30, 0x5f, 0x54, 0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29,
-  0x2a, 0x93, 0x01, 0x02, 0x4a, 0x48, 0x29, 0x2a, 0x4b, 0x51, 0x32, 0x30,
-  0x4c, 0x4e, 0x8e, 0x8f, 0x4d, 0x4d, 0x30, 0x30, 0x29, 0x2a, 0x29, 0x4d,
-  0x49, 0x2c, 0x2b, 0x2b, 0x2a, 0x96, 0x2b, 0x2a, 0x02, 0xf9, 0xfd, 0xf2,
-  0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
-  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd,
-  0x5b, 0x2c, 0x2b, 0x4b, 0x4c, 0x56, 0x2c, 0x2b, 0x96, 0x2b, 0x5d, 0x12,
-  0x31, 0x32, 0x48, 0x64, 0x74, 0x3a, 0x3a, 0x64, 0x4a, 0x30, 0x31, 0x12,
-  0x12, 0x3a, 0x37, 0x50, 0x79, 0x41, 0x41, 0x41, 0x41, 0x79, 0x4e, 0x39,
-  0x38, 0xc6, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x41, 0x3f, 0x26, 0x25, 0x25,
-  0x24, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x3e, 0x00, 0x4d,
-  0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15,
-  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
-  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x35, 0x16,
-  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x04, 0x4f, 0x01, 0x70,
-  0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
-  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x10, 0x2c,
-  0x2d, 0x2d, 0x2b, 0x74, 0x3d, 0x3d, 0x09, 0x20, 0x36, 0x33, 0x3e, 0x82,
-  0x97, 0x4e, 0x50, 0x82, 0x96, 0x4f, 0x4f, 0x60, 0x62, 0xa4, 0x2c, 0x2d,
-  0x2d, 0xb8, 0x4f, 0x5c, 0x2e, 0x2e, 0x4f, 0x4c, 0x30, 0x2f, 0x2f, 0x2e,
-  0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8,
-  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
-  0x07, 0x79, 0xf0, 0xfb, 0xdf, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a,
-  0x2f, 0x1b, 0x1a, 0x98, 0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6,
-  0x75, 0x76, 0x08, 0x09, 0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35,
-  0x34, 0x5a, 0x5c, 0x34, 0x34, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
-  0x00, 0x2c, 0x00, 0x38, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01,
-  0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35,
-  0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22,
-  0x35, 0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11,
-  0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x03, 0x86, 0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e,
-  0x6d, 0x76, 0x99, 0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e,
-  0x7b, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78,
-  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
-  0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56, 0x56,
-  0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde, 0xd4,
-  0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06,
-  0x00, 0x12, 0x00, 0x1e, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01,
-  0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35,
-  0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22,
-  0x35, 0x11, 0x34, 0x05, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x36, 0x35, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f,
-  0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
-  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x87, 0x72, 0x3b, 0x39, 0x81, 0x2c,
-  0x24, 0x4c, 0x3f, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06,
-  0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
-  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0xfd, 0xdc, 0x95, 0x46, 0x45,
-  0x60, 0x54, 0x6c, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x38, 0x00, 0x00,
-  0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14,
-  0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11,
-  0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x0e, 0x01, 0x23, 0x22,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23,
-  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x04, 0x4f, 0x01,
-  0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
-  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xe9,
-  0x2c, 0x5b, 0x33, 0xa3, 0xb4, 0xb5, 0xa2, 0x33, 0x5c, 0x2b, 0x2a, 0x5f,
-  0x31, 0x70, 0x6f, 0x6e, 0x71, 0x31, 0x60, 0x29, 0x02, 0xf9, 0xfd, 0xf2,
-  0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
-  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb,
-  0xeb, 0x17, 0x16, 0xe3, 0xce, 0xcd, 0xe5, 0x17, 0x17, 0x74, 0x22, 0x24,
-  0xaa, 0xac, 0xab, 0xab, 0x24, 0x22, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x18, 0x00, 0x22,
-  0x00, 0x2e, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01,
-  0x30, 0x03, 0x22, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23, 0x22,
-  0x06, 0x10, 0x16, 0x33, 0x32, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
-  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
-  0x21, 0x22, 0x35, 0x11, 0x34, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe,
-  0x8f, 0x2f, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c, 0x8e, 0x8f, 0x8d, 0x4e,
-  0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d, 0x4d, 0x56, 0x58, 0xfe,
-  0x9c, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
-  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06,
-  0x02, 0x41, 0x01, 0xd7, 0xda, 0xdb, 0xd7, 0xd7, 0xdb, 0xa5, 0xc9, 0x28,
-  0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e, 0x9e, 0xfe, 0x90, 0x9e, 0x03,
-  0x6f, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
-  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
-  0x00, 0x29, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
-  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
-  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17,
-  0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x04, 0x4f,
-  0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46,
-  0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8,
-  0x72, 0x01, 0x46, 0x94, 0xfe, 0x91, 0x01, 0x8c, 0x96, 0xfe, 0x9f, 0x72,
-  0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8,
-  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
-  0x07, 0x79, 0xf0, 0xf0, 0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42,
-  0x01, 0x93, 0xfe, 0x6d, 0x00, 0x03, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x09, 0x00, 0x15, 0x00, 0x21, 0x00, 0x00, 0x01, 0x13,
-  0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x01, 0x21, 0x01, 0x22, 0x15, 0x11,
-  0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15,
-  0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x03, 0xaf, 0x80, 0x01,
-  0xa3, 0xfe, 0xae, 0x81, 0xfe, 0xae, 0xfe, 0xad, 0x82, 0xfe, 0xae, 0x01,
-  0xa2, 0xfe, 0x5e, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
-  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x05, 0x31, 0xfe, 0x47, 0xfe, 0xef,
-  0xfe, 0x47, 0x01, 0x11, 0xfe, 0xef, 0x01, 0xb9, 0x01, 0x11, 0x03, 0x7d,
-  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
-  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
-  0x00, 0x3e, 0x00, 0x46, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34,
-  0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33,
-  0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14,
-  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x03, 0x33, 0x03, 0x33, 0x01,
-  0x23, 0x27, 0x21, 0x07, 0x23, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17,
-  0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44,
-  0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c,
-  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
-  0xba, 0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01, 0x04, 0x77, 0x3d,
-  0xfe, 0xd7, 0x3d, 0x77, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43,
-  0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13,
-  0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07,
-  0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
-  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac, 0xfe, 0x55, 0x02, 0x0f,
-  0xfc, 0xbc, 0xda, 0xda, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x54, 0x00, 0x00,
-  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x01, 0x21, 0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34, 0x26, 0x23,
-  0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x01,
-  0x06, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a,
-  0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84,
-  0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
-  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x75,
-  0x01, 0x7d, 0xfd, 0xe6, 0x1f, 0x38, 0x01, 0x36, 0x5e, 0x4c, 0x2f, 0x6e,
-  0x41, 0x46, 0x77, 0x34, 0x82, 0x9d, 0xfe, 0xd6, 0x33, 0xfc, 0x4c, 0xfb,
-  0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a,
-  0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01,
-  0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
-  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfc,
-  0x3f, 0x72, 0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23, 0x23,
-  0x7b, 0x1c, 0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x64, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26,
-  0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11,
-  0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15,
-  0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x1e, 0x01, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x06, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a,
-  0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84,
-  0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
-  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x57,
-  0x53, 0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f, 0x2f, 0x6b, 0x3c, 0x62, 0x6c,
-  0x64, 0x61, 0x4d, 0x54, 0x55, 0x57, 0x5a, 0x55, 0x24, 0x5c, 0x49, 0x42,
-  0x73, 0x31, 0x82, 0x98, 0x51, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c,
-  0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82,
-  0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c,
-  0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
-  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x91, 0x12, 0x6d, 0x52,
-  0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46, 0x4a, 0x4c, 0x6c,
-  0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11, 0x12, 0x76, 0x63, 0x45,
-  0x60, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x3e, 0x00, 0x49,
-  0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
-  0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15,
-  0x23, 0x35, 0x21, 0x35, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83,
-  0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a,
-  0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c,
-  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
-  0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95, 0x7a, 0x7a, 0x81,
-  0xfe, 0x8b, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34,
-  0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24,
-  0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78,
-  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
-  0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe, 0x5d, 0x02, 0x1c, 0xfd, 0xe4,
-  0x6d, 0xba, 0xba, 0x79, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x5c, 0x00, 0x00,
-  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x17, 0x21, 0x15, 0x21, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16,
-  0x33, 0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x03, 0xe6, 0x33,
-  0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01,
-  0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42,
-  0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
-  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb, 0xfe, 0xa0, 0x19,
-  0x1a, 0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e, 0x36, 0x72, 0x3b,
-  0x33, 0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f, 0x5d, 0x31, 0xfc,
-  0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13,
-  0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46,
-  0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78,
-  0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79,
-  0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04, 0x4d, 0x4c, 0x83, 0x87, 0x4b,
-  0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d, 0x66, 0xae, 0x66, 0x14, 0x15,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x4b, 0x00, 0x6b, 0x00, 0x00, 0x05, 0x36,
-  0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22,
-  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
-  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x22,
-  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x03, 0xe6,
-  0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70,
-  0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98,
-  0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x0d, 0x4f, 0x2e, 0x2e,
-  0x2e, 0x2e, 0x4f, 0x4e, 0x2e, 0x2e, 0x2e, 0x2e, 0x9a, 0x2c, 0x2d, 0x2d,
-  0x2c, 0x73, 0x3e, 0x3d, 0x09, 0x22, 0x34, 0x34, 0x3d, 0x83, 0x4b, 0x4c,
-  0x4f, 0x4f, 0x82, 0x97, 0x9e, 0x61, 0x61, 0xa4, 0x2c, 0x2d, 0x2d, 0xfc,
-  0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13,
-  0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46,
-  0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78,
-  0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79,
-  0xf0, 0xfd, 0x9e, 0x34, 0x35, 0x5b, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a,
-  0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14, 0x0a, 0x0b, 0x4b, 0x4c, 0x99,
-  0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f, 0x4f, 0x4e, 0xde, 0xd4, 0xc6,
-  0x75, 0x76, 0x08, 0x09, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x42, 0x00, 0x00,
-  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x17, 0x21, 0x15, 0x01, 0x23, 0x01, 0x21, 0x03, 0xe6, 0x33, 0x40, 0x99,
-  0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70,
-  0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd,
-  0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
-  0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7, 0x7a, 0x01, 0x27,
-  0xfe, 0x61, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34,
-  0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24,
-  0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78,
-  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
-  0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc, 0xed, 0x02, 0xe4, 0x00, 0x00,
-  0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x48, 0x00, 0x66, 0x00, 0x75, 0x00, 0x00,
-  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x34,
-  0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x20, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x03, 0xe6,
-  0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70,
-  0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98,
-  0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x55, 0xa8, 0x2f, 0x30,
-  0x5f, 0x54, 0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01,
-  0x02, 0x4a, 0x48, 0x29, 0x2a, 0x4b, 0x51, 0x32, 0x30, 0x4c, 0x4e, 0x8e,
-  0x8f, 0x4d, 0x4d, 0x30, 0x30, 0x29, 0x2a, 0x29, 0x4d, 0x49, 0x2c, 0x2b,
-  0x2b, 0x2a, 0x96, 0x2b, 0x2a, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c,
-  0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82,
-  0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c,
-  0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
-  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x5b, 0x2c, 0x2b, 0x4b,
-  0x4c, 0x56, 0x2c, 0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48, 0x64,
-  0x74, 0x3a, 0x3a, 0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37, 0x50,
-  0x79, 0x41, 0x41, 0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f, 0x26,
-  0x25, 0x25, 0x24, 0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x5b, 0x00, 0x6a, 0x00, 0x00, 0x05, 0x36,
-  0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22,
-  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
-  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x35,
-  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34, 0x27,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x03, 0xe6, 0x33,
-  0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01,
-  0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42,
-  0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
-  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x10, 0x2c, 0x2d, 0x2d, 0x2b,
-  0x74, 0x3d, 0x3d, 0x09, 0x20, 0x36, 0x33, 0x3e, 0x82, 0x97, 0x4e, 0x50,
-  0x82, 0x96, 0x4f, 0x4f, 0x60, 0x62, 0xa4, 0x2c, 0x2d, 0x2d, 0xb8, 0x4f,
-  0x5c, 0x2e, 0x2e, 0x4f, 0x4c, 0x30, 0x2f, 0x2f, 0x2e, 0xfc, 0x4c, 0xfb,
-  0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a,
-  0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01,
-  0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
-  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb,
-  0xdf, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b, 0x1a, 0x98,
-  0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09,
-  0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5c, 0x34,
-  0x34, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x49, 0x00, 0x55,
-  0x00, 0x5c, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15,
-  0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
-  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
-  0x22, 0x35, 0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33,
-  0x11, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a,
-  0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84,
-  0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
-  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x03, 0x86,
-  0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e, 0x6d, 0x76, 0x99,
-  0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e, 0x7b, 0xfc, 0x4c,
-  0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82,
-  0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c,
-  0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78,
-  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
-  0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56, 0x56, 0x56, 0x56, 0xad, 0xac,
-  0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde, 0xd4, 0xd3, 0xde, 0xfc, 0xac,
-  0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd, 0x00, 0x00, 0x04, 0x00, 0xb4,
-  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
-  0x00, 0x48, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15,
-  0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
-  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
-  0x22, 0x35, 0x11, 0x34, 0x05, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x36, 0x35, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17,
-  0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44,
-  0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c,
-  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
-  0xba, 0xd8, 0x01, 0x87, 0x72, 0x3b, 0x39, 0x81, 0x2c, 0x24, 0x4c, 0x3f,
-  0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d,
-  0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92,
-  0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87,
-  0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07,
-  0x79, 0xf0, 0xf0, 0xfd, 0xdc, 0x95, 0x46, 0x45, 0x60, 0x54, 0x6c, 0x00,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x55, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26,
-  0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11,
-  0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15,
-  0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x0e, 0x01, 0x23,
-  0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x03, 0xe6,
-  0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70,
-  0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98,
-  0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
-  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xe9, 0x2c, 0x5b, 0x33,
-  0xa3, 0xb4, 0xb5, 0xa2, 0x33, 0x5c, 0x2b, 0x2a, 0x5f, 0x31, 0x70, 0x6f,
-  0x6e, 0x71, 0x31, 0x60, 0x29, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c,
-  0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82,
-  0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c,
-  0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
-  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xeb, 0x17, 0x16, 0xe3,
-  0xce, 0xcd, 0xe5, 0x17, 0x17, 0x74, 0x22, 0x24, 0xaa, 0xac, 0xab, 0xab,
-  0x24, 0x22, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x4d, 0x00, 0x57,
-  0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
-  0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
-  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
-  0x11, 0x34, 0x01, 0x22, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23,
-  0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30,
-  0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c,
-  0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b,
-  0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8,
-  0xfb, 0xba, 0xd8, 0x01, 0xfb, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c, 0x8e,
-  0x8f, 0x8d, 0x4e, 0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d, 0x4d,
-  0x56, 0x58, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34,
-  0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24,
-  0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78,
-  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
-  0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xbf, 0x01, 0xd7, 0xda, 0xdb, 0xd7, 0xd7,
-  0xdb, 0xa5, 0xc9, 0x28, 0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e, 0x9e,
-  0xfe, 0x90, 0x9e, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
-  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x46, 0x00, 0x00,
-  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
-  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
-  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
-  0x17, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x03,
-  0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d,
-  0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30,
-  0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb,
-  0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x72, 0x01, 0x46,
-  0x94, 0xfe, 0x91, 0x01, 0x8c, 0x96, 0xfe, 0x9f, 0x72, 0xfc, 0x4c, 0xfb,
-  0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a,
-  0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01,
-  0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
-  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0,
-  0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe, 0x6d,
-  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x09,
-  0x00, 0x13, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x03, 0x21, 0x17,
-  0x03, 0x37, 0x17, 0x03, 0x37, 0x21, 0x03, 0x13, 0x05, 0x01, 0x13, 0x25,
-  0x05, 0x13, 0x01, 0x25, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
-  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
-  0x22, 0x35, 0x11, 0x34, 0x03, 0xaf, 0x5a, 0xfe, 0xdd, 0xeb, 0x5b, 0xed,
-  0xeb, 0x59, 0xeb, 0xfe, 0xdb, 0x58, 0x9c, 0x01, 0x87, 0xfe, 0xd8, 0x57,
-  0xfe, 0xae, 0xfe, 0xad, 0x58, 0xfe, 0xd8, 0x01, 0x88, 0xfe, 0x78, 0x6c,
-  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
-  0xba, 0xd8, 0x04, 0x6e, 0xfe, 0xce, 0xbe, 0xfe, 0xcd, 0xbe, 0xbe, 0x01,
-  0x33, 0xbe, 0x01, 0xf5, 0xfe, 0x6f, 0x28, 0xfe, 0xe2, 0xfe, 0x54, 0xdf,
-  0xdf, 0x01, 0xa8, 0x01, 0x22, 0x28, 0x03, 0x55, 0x78, 0xf8, 0x87, 0x78,
-  0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79,
-  0xf0, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x89, 0xff, 0x6a, 0x06, 0xf9,
-  0x07, 0x56, 0x00, 0x07, 0x00, 0x11, 0x00, 0x19, 0x00, 0x23, 0x00, 0x2b,
-  0x00, 0x33, 0x00, 0x7f, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x34, 0x36, 0x32,
-  0x16, 0x14, 0x06, 0x22, 0x37, 0x22, 0x06, 0x15, 0x14, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x24, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x17, 0x22,
-  0x06, 0x15, 0x14, 0x33, 0x32, 0x36, 0x35, 0x34, 0x00, 0x34, 0x36, 0x32,
-  0x16, 0x14, 0x06, 0x22, 0x36, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32,
-  0x06, 0x32, 0x3e, 0x03, 0x37, 0x13, 0x17, 0x07, 0x3e, 0x04, 0x35, 0x34,
-  0x26, 0x27, 0x26, 0x27, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x0e,
-  0x01, 0x15, 0x14, 0x17, 0x07, 0x26, 0x35, 0x34, 0x37, 0x26, 0x22, 0x07,
-  0x16, 0x15, 0x14, 0x07, 0x27, 0x36, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22,
-  0x06, 0x15, 0x14, 0x16, 0x17, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x1e,
-  0x03, 0x17, 0x27, 0x37, 0x13, 0x1e, 0x03, 0x12, 0x32, 0x17, 0x3e, 0x01,
-  0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x16, 0x15, 0x14, 0x0e, 0x02, 0x07,
-  0x05, 0x07, 0x25, 0x07, 0x06, 0x07, 0x05, 0x07, 0x25, 0x0e, 0x01, 0x22,
-  0x26, 0x27, 0x05, 0x27, 0x25, 0x26, 0x2f, 0x01, 0x05, 0x27, 0x25, 0x2e,
-  0x03, 0x35, 0x34, 0x37, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17,
-  0x02, 0x9c, 0x3b, 0x53, 0x3b, 0x3b, 0x53, 0x69, 0x10, 0x28, 0x0c, 0x0f,
-  0x29, 0x01, 0x84, 0x3b, 0x53, 0x3c, 0x3c, 0x53, 0x14, 0x0f, 0x28, 0x0c,
-  0x10, 0x28, 0xfe, 0x97, 0x14, 0x1d, 0x14, 0x14, 0x1d, 0xd4, 0x13, 0x1d,
-  0x14, 0x14, 0x1d, 0x91, 0x61, 0x46, 0x29, 0x19, 0x08, 0x02, 0x0e, 0x79,
-  0x0b, 0x35, 0x66, 0x67, 0x4e, 0x30, 0x3c, 0x32, 0x2b, 0x3a, 0x41, 0x58,
-  0x58, 0x47, 0x4b, 0x74, 0x3d, 0x10, 0x75, 0x14, 0x01, 0x26, 0x97, 0x26,
-  0x01, 0x15, 0x75, 0x10, 0x3c, 0x75, 0x4b, 0x47, 0x58, 0x58, 0x42, 0x3b,
-  0x2b, 0x31, 0x3d, 0x31, 0x4d, 0x68, 0x66, 0x35, 0x0b, 0x78, 0x0f, 0x02,
-  0x08, 0x18, 0x29, 0x33, 0x89, 0x44, 0x27, 0xb5, 0x81, 0x7d, 0x9c, 0x54,
-  0x8d, 0x44, 0x76, 0x89, 0x50, 0x01, 0x76, 0x04, 0xfe, 0x22, 0x01, 0x02,
-  0x04, 0x01, 0xc9, 0x14, 0xfe, 0x3f, 0x1d, 0x98, 0xe1, 0x98, 0x1d, 0xfe,
-  0x3f, 0x14, 0x01, 0xc8, 0x03, 0x02, 0x01, 0xfe, 0x21, 0x04, 0x01, 0x76,
-  0x50, 0x89, 0x76, 0x43, 0x8c, 0x54, 0x9c, 0x7d, 0x81, 0xb6, 0x26, 0x03,
-  0x38, 0x90, 0x67, 0x67, 0x90, 0x67, 0x82, 0x3d, 0x18, 0x12, 0x3e, 0x18,
-  0x11, 0x75, 0x90, 0x67, 0x67, 0x90, 0x67, 0xdc, 0x3d, 0x18, 0x12, 0x3e,
-  0x18, 0x11, 0xfd, 0x22, 0x36, 0x27, 0x27, 0x36, 0x27, 0x5d, 0x36, 0x27,
-  0x27, 0x36, 0x27, 0xe0, 0x24, 0x39, 0x5d, 0x57, 0x3e, 0x01, 0x3a, 0x06,
-  0xfb, 0x1f, 0x4c, 0x6b, 0x74, 0x93, 0x4c, 0x4a, 0x98, 0x37, 0x33, 0x28,
-  0x23, 0x83, 0x58, 0x51, 0x69, 0x6b, 0xa4, 0x5c, 0x42, 0x3f, 0x26, 0x53,
-  0x54, 0x1b, 0x0e, 0x03, 0x03, 0x0e, 0x1b, 0x54, 0x53, 0x26, 0x3f, 0x42,
-  0x5c, 0xa4, 0x6b, 0x69, 0x51, 0x58, 0x83, 0x23, 0x28, 0x33, 0x37, 0x98,
-  0x4a, 0x4c, 0x93, 0x74, 0x6b, 0x4c, 0x1f, 0xfb, 0x06, 0xfe, 0xc6, 0x3e,
-  0x57, 0x5d, 0x39, 0x06, 0x02, 0x06, 0x86, 0xbe, 0xb7, 0x8c, 0x8a, 0x72,
-  0xac, 0xc8, 0x6c, 0xc8, 0xa1, 0x7e, 0x33, 0x1a, 0x44, 0x23, 0x01, 0x1f,
-  0x1f, 0xae, 0x40, 0xac, 0x6d, 0x8a, 0x8a, 0x6d, 0xac, 0x40, 0xae, 0x1f,
-  0x1f, 0x01, 0x23, 0x44, 0x1a, 0x33, 0x7e, 0xa1, 0xc8, 0x6c, 0xc8, 0xac,
-  0x72, 0x8a, 0x8c, 0xb7, 0xbe, 0x86, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x43,
-  0xff, 0x6a, 0x08, 0x43, 0x06, 0x8a, 0x00, 0x09, 0x00, 0x14, 0x00, 0x18,
-  0x00, 0x22, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x8e, 0x00, 0x99, 0x00, 0x9f,
-  0x00, 0xfd, 0x01, 0x07, 0x00, 0x00, 0x01, 0x22, 0x26, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x14, 0x06, 0x27, 0x32, 0x36, 0x35, 0x34, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x33, 0x15, 0x23, 0x01, 0x22, 0x26, 0x34, 0x36,
-  0x33, 0x32, 0x16, 0x14, 0x06, 0x01, 0x37, 0x17, 0x07, 0x27, 0x37, 0x01,
-  0x15, 0x23, 0x35, 0x25, 0x17, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x1e,
-  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
-  0x37, 0x16, 0x17, 0x3e, 0x04, 0x37, 0x16, 0x33, 0x32, 0x3e, 0x04, 0x37,
-  0x3e, 0x01, 0x35, 0x34, 0x27, 0x2e, 0x04, 0x23, 0x22, 0x0e, 0x02, 0x0f,
-  0x01, 0x06, 0x07, 0x2e, 0x01, 0x20, 0x06, 0x07, 0x26, 0x2f, 0x01, 0x2e,
-  0x03, 0x23, 0x22, 0x0e, 0x03, 0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x1e,
-  0x05, 0x33, 0x32, 0x37, 0x1e, 0x04, 0x17, 0x36, 0x25, 0x32, 0x36, 0x35,
-  0x34, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x01, 0x07, 0x17, 0x07, 0x27,
-  0x37, 0x01, 0x34, 0x37, 0x27, 0x26, 0x27, 0x23, 0x22, 0x2e, 0x06, 0x27,
-  0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x1e,
-  0x02, 0x17, 0x16, 0x1f, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17,
-  0x37, 0x36, 0x37, 0x3e, 0x03, 0x33, 0x32, 0x16, 0x17, 0x1e, 0x02, 0x15,
-  0x14, 0x06, 0x07, 0x0e, 0x07, 0x2b, 0x01, 0x06, 0x0f, 0x01, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x01, 0x06, 0x20, 0x27,
-  0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x03, 0x20, 0x2d, 0x38, 0x37, 0x2e,
-  0x2d, 0x38, 0x37, 0x1b, 0x10, 0x29, 0x0d, 0x0f, 0x15, 0x14, 0x30, 0x63,
-  0x63, 0x02, 0x0f, 0x2e, 0x37, 0x37, 0x2e, 0x2d, 0x37, 0x38, 0xfb, 0xcb,
-  0x2e, 0xb1, 0x33, 0x39, 0x26, 0x03, 0x39, 0x63, 0xfe, 0x09, 0x3c, 0x39,
-  0x0f, 0x05, 0x34, 0x2e, 0xa0, 0x7d, 0x5e, 0x3e, 0x74, 0x3b, 0x33, 0x04,
-  0x0f, 0x39, 0x3b, 0x16, 0x10, 0x04, 0x1c, 0x0b, 0x12, 0x09, 0x01, 0x4a,
-  0x23, 0x1d, 0x32, 0x21, 0x2b, 0x14, 0x30, 0x0b, 0x2c, 0x2a, 0x2f, 0x02,
-  0x22, 0x1b, 0x27, 0x27, 0x10, 0x0f, 0x1d, 0x20, 0x0e, 0x11, 0x11, 0x39,
-  0x50, 0x37, 0xee, 0xfe, 0xde, 0xef, 0x37, 0x50, 0x38, 0x11, 0x11, 0x0f,
-  0x1f, 0x1d, 0x0f, 0x11, 0x26, 0x27, 0x1b, 0x22, 0x02, 0x2f, 0x2a, 0x2c,
-  0x0a, 0x31, 0x14, 0x2a, 0x21, 0x33, 0x1d, 0x23, 0x49, 0x01, 0x09, 0x12,
-  0x0c, 0x1b, 0x05, 0x10, 0x02, 0xb8, 0x11, 0x28, 0x0d, 0x0f, 0x15, 0x13,
-  0x01, 0xbb, 0x99, 0x26, 0x39, 0x33, 0xb1, 0xfb, 0x51, 0x0b, 0x12, 0x34,
-  0x0e, 0x09, 0x1e, 0x35, 0x27, 0x2f, 0x19, 0x31, 0x11, 0x39, 0x09, 0x3b,
-  0x34, 0x24, 0x28, 0x20, 0x2d, 0x7a, 0x3a, 0x1b, 0x2d, 0x2d, 0x17, 0x15,
-  0x21, 0x0f, 0x3b, 0x24, 0x31, 0x94, 0x01, 0x7a, 0x93, 0x32, 0x24, 0x3a,
-  0x10, 0x21, 0x15, 0x16, 0x2d, 0x2e, 0x1a, 0x3b, 0x79, 0x2e, 0x20, 0x27,
-  0x25, 0x34, 0x3c, 0x08, 0x39, 0x11, 0x32, 0x18, 0x30, 0x26, 0x36, 0x1d,
-  0x09, 0x0f, 0x33, 0x13, 0x0c, 0x0c, 0x1f, 0x56, 0x08, 0x14, 0x1d, 0x3b,
-  0x31, 0x7a, 0xb0, 0x7b, 0x30, 0x3c, 0x1d, 0x13, 0x08, 0x56, 0x20, 0x0b,
-  0x02, 0xe2, 0x57, 0xfe, 0xda, 0x57, 0x0f, 0x1c, 0x32, 0x8d, 0x60, 0x71,
-  0x02, 0xd1, 0x6e, 0x82, 0x6e, 0x6e, 0x82, 0x6e, 0x1b, 0x41, 0x15, 0x11,
-  0x1f, 0x1d, 0x19, 0x12, 0xd4, 0xd2, 0x01, 0x8b, 0x6e, 0x82, 0x6e, 0x6e,
-  0x82, 0x6e, 0x02, 0xb5, 0x2d, 0xda, 0xba, 0x18, 0x94, 0xfd, 0x4d, 0xd2,
-  0xd2, 0x93, 0x76, 0x24, 0x44, 0x11, 0x19, 0x4b, 0x3b, 0x37, 0x22, 0x08,
-  0x0d, 0x44, 0x3b, 0x4b, 0x19, 0x11, 0x44, 0x24, 0x76, 0x0d, 0x0f, 0x13,
-  0x68, 0x35, 0x57, 0x4d, 0x27, 0x14, 0x0b, 0x0c, 0x20, 0x11, 0x31, 0x0a,
-  0x2a, 0x4c, 0x37, 0x2e, 0x34, 0x02, 0x28, 0x1a, 0x23, 0x13, 0x0e, 0x22,
-  0x11, 0x19, 0x19, 0x4e, 0x83, 0x65, 0x6d, 0x6d, 0x65, 0x83, 0x4e, 0x19,
-  0x19, 0x11, 0x22, 0x0e, 0x13, 0x23, 0x1a, 0x28, 0x02, 0x34, 0x2e, 0x37,
-  0x4c, 0x2a, 0x0a, 0x31, 0x11, 0x20, 0x0c, 0x0b, 0x14, 0x27, 0x4d, 0x57,
-  0x35, 0x68, 0x13, 0x0f, 0x4e, 0x41, 0x15, 0x11, 0x1f, 0x1d, 0x19, 0x12,
-  0x02, 0x9a, 0xbb, 0x94, 0x18, 0xba, 0xda, 0xfb, 0xef, 0x2a, 0x2c, 0x50,
-  0xdd, 0x49, 0x09, 0x08, 0x1b, 0x0d, 0x2c, 0x0f, 0x39, 0x09, 0x3a, 0x6b,
-  0x52, 0x34, 0x5f, 0x35, 0x22, 0x32, 0x53, 0x12, 0x27, 0x18, 0x19, 0x27,
-  0x15, 0x52, 0x1d, 0x1b, 0x4e, 0x4e, 0x1b, 0x1d, 0x52, 0x15, 0x27, 0x19,
-  0x18, 0x27, 0x12, 0x53, 0x32, 0x22, 0x35, 0x5f, 0x34, 0x52, 0x6b, 0x3a,
-  0x09, 0x39, 0x0f, 0x2c, 0x0d, 0x1b, 0x08, 0x09, 0x49, 0xdd, 0x50, 0x2c,
-  0x2a, 0x30, 0x28, 0x73, 0x42, 0x44, 0x30, 0x48, 0x2e, 0x26, 0x1b, 0x1b,
-  0x26, 0x2e, 0x48, 0x30, 0x44, 0x42, 0x73, 0x28, 0xfe, 0xe0, 0x16, 0x16,
-  0x24, 0x15, 0x27, 0x26, 0x00, 0x08, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e,
-  0x07, 0x14, 0x00, 0x11, 0x00, 0x19, 0x00, 0x28, 0x00, 0x32, 0x00, 0x41,
-  0x00, 0x4e, 0x00, 0x7f, 0x00, 0xb8, 0x00, 0x00, 0x01, 0x37, 0x16, 0x33,
-  0x32, 0x37, 0x16, 0x33, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x06,
-  0x23, 0x22, 0x01, 0x17, 0x06, 0x22, 0x27, 0x37, 0x16, 0x32, 0x03, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
-  0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e, 0x01, 0x37, 0x26, 0x05,
-  0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x23, 0x22, 0x06, 0x05, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27,
-  0x06, 0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03,
-  0x15, 0x14, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16,
-  0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25,
-  0x37, 0x05, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17,
-  0x1e, 0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16,
-  0x17, 0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17,
-  0x07, 0x27, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x07, 0x27,
-  0x37, 0x26, 0x27, 0x07, 0x27, 0x02, 0x62, 0x53, 0x3e, 0x52, 0x34, 0x4c,
-  0x4b, 0x35, 0x51, 0x3f, 0x52, 0x61, 0x81, 0x43, 0x3d, 0x3e, 0x42, 0x82,
-  0x01, 0x8c, 0x38, 0x6e, 0xae, 0x6e, 0x38, 0x51, 0x78, 0xea, 0x26, 0x49,
-  0x1d, 0x24, 0x3f, 0x31, 0x12, 0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21,
-  0x2b, 0x05, 0x26, 0x3e, 0x11, 0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c,
-  0x2a, 0x30, 0x13, 0x31, 0x3f, 0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b,
-  0x24, 0x0e, 0x03, 0x0b, 0x0c, 0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09,
-  0x14, 0x04, 0x18, 0x26, 0xda, 0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb,
-  0x26, 0x18, 0x05, 0x13, 0x09, 0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf,
-  0x0c, 0x15, 0x01, 0x01, 0x18, 0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9,
-  0xa3, 0x93, 0x5d, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0,
-  0x09, 0xfb, 0x46, 0x0f, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e,
-  0x36, 0x80, 0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e,
-  0x22, 0x15, 0x04, 0x1c, 0x0b, 0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d,
-  0x1d, 0x63, 0x17, 0x63, 0x69, 0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
-  0xae, 0x6a, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x01, 0x8c, 0x62,
-  0x40, 0x2c, 0x2c, 0x40, 0x62, 0x64, 0x1c, 0x1c, 0x01, 0xa8, 0x78, 0x3d,
-  0x3d, 0x78, 0x2e, 0x01, 0x06, 0x4c, 0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47,
-  0x30, 0x2c, 0x61, 0x26, 0x30, 0x24, 0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11,
-  0x1d, 0x43, 0x61, 0x2c, 0x30, 0x47, 0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04,
-  0x03, 0x16, 0x18, 0x1c, 0x0e, 0x0c, 0x03, 0x3b, 0xa7, 0x82, 0x74, 0x2e,
-  0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a,
-  0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0x2e, 0x74, 0x82, 0x2b, 0x42, 0x2c,
-  0x45, 0x40, 0x79, 0x3e, 0x7a, 0xe7, 0x77, 0x84, 0x84, 0x77, 0xe7, 0x7a,
-  0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42, 0x3d, 0x7c, 0x8f, 0x39, 0x6a, 0x77,
-  0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d,
-  0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a,
-  0x39, 0x8f, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e, 0xfe,
-  0xf7, 0x8e, 0x9e, 0x9e, 0x8c, 0x01, 0x0b, 0x2e, 0x3e, 0x2e, 0x51, 0x57,
-  0x0e, 0x42, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x99, 0xff, 0x6a, 0x07, 0xbb,
-  0x07, 0x0b, 0x00, 0x07, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x31,
-  0x00, 0x3b, 0x00, 0x47, 0x00, 0x68, 0x00, 0x98, 0x00, 0xaa, 0x00, 0xbc,
-  0x00, 0x00, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x37, 0x22,
-  0x06, 0x15, 0x14, 0x33, 0x32, 0x36, 0x35, 0x34, 0x03, 0x22, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x07, 0x06, 0x00, 0x14, 0x06, 0x22,
-  0x26, 0x34, 0x36, 0x32, 0x03, 0x34, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x23, 0x22, 0x27, 0x26, 0x01, 0x22, 0x06, 0x15, 0x14, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x01, 0x37, 0x16, 0x33, 0x32, 0x36, 0x37, 0x17, 0x06, 0x23,
-  0x22, 0x26, 0x12, 0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x3e, 0x02, 0x35,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x2e, 0x01, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x1e, 0x01, 0x17, 0x06, 0x15, 0x14, 0x17, 0x12, 0x20,
-  0x04, 0x17, 0x16, 0x17, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x07, 0x0e, 0x01, 0x2b, 0x01, 0x06, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x20,
-  0x27, 0x2e, 0x01, 0x27, 0x26, 0x27, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x36, 0x37, 0x36, 0x03, 0x26,
-  0x23, 0x22, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x3b,
-  0x01, 0x36, 0x37, 0x26, 0x25, 0x06, 0x07, 0x16, 0x17, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x27, 0x26, 0x23, 0x22, 0x02, 0xca,
-  0x4a, 0x68, 0x4a, 0x4a, 0x68, 0x82, 0x14, 0x31, 0x0e, 0x14, 0x32, 0x0e,
-  0x16, 0x28, 0x21, 0x1b, 0x16, 0x28, 0x21, 0x01, 0xd8, 0x49, 0x69, 0x4a,
-  0x4a, 0x69, 0xe8, 0x16, 0x1c, 0x21, 0x28, 0x16, 0x1c, 0x21, 0x28, 0x01,
-  0x02, 0x14, 0x32, 0x0f, 0x14, 0x32, 0xfd, 0x33, 0x5f, 0x75, 0xb9, 0x57,
-  0xa2, 0x35, 0x5f, 0x97, 0xf6, 0x74, 0xd2, 0x7c, 0x01, 0x93, 0x95, 0x6f,
-  0x4b, 0x1b, 0x1a, 0x1c, 0x4e, 0x51, 0x75, 0x40, 0x65, 0x1c, 0x19, 0x65,
-  0x40, 0x75, 0x51, 0x4e, 0x1c, 0x1a, 0x1c, 0x4c, 0x70, 0xbb, 0x01, 0x45,
-  0x01, 0x18, 0x58, 0x5e, 0x0f, 0x16, 0x1a, 0x60, 0x81, 0x07, 0x0c, 0x19,
-  0x1e, 0x79, 0x50, 0x07, 0x0d, 0x34, 0x33, 0x9a, 0x62, 0x85, 0xfe, 0xfd,
-  0x85, 0x62, 0x9a, 0x33, 0x34, 0x0d, 0x07, 0x50, 0x78, 0x1f, 0x19, 0x0c,
-  0x07, 0x82, 0x5f, 0x1a, 0x17, 0x0e, 0x5f, 0x57, 0xc1, 0x15, 0x1d, 0x0c,
-  0x13, 0x24, 0x27, 0x07, 0x15, 0x3f, 0x1c, 0x23, 0x03, 0x07, 0x36, 0x2f,
-  0x04, 0xe8, 0x0e, 0x30, 0x36, 0x07, 0x04, 0x22, 0x1c, 0x40, 0x14, 0x07,
-  0x27, 0x24, 0x13, 0x0c, 0x1c, 0x04, 0x08, 0x74, 0x52, 0x52, 0x74, 0x52,
-  0x68, 0x31, 0x13, 0x0e, 0x31, 0x13, 0x0e, 0xfe, 0x52, 0x15, 0x20, 0x24,
-  0x1f, 0x15, 0x20, 0x24, 0x1f, 0x02, 0x0c, 0x74, 0x52, 0x52, 0x74, 0x52,
-  0xfe, 0x05, 0x15, 0x1f, 0x24, 0x20, 0x15, 0x1f, 0x24, 0x01, 0x6b, 0x31,
-  0x13, 0x0e, 0x31, 0x13, 0x0e, 0xfd, 0xa8, 0x54, 0xa4, 0x58, 0x4c, 0x54,
-  0xd6, 0x72, 0xfe, 0xde, 0xcb, 0x9a, 0xb8, 0x86, 0x95, 0x2c, 0x30, 0x5e,
-  0x31, 0x8a, 0x69, 0x6f, 0x45, 0x35, 0x35, 0x45, 0x6f, 0x69, 0x8a, 0x31,
-  0x5e, 0x30, 0x2c, 0x95, 0x86, 0xb8, 0x9a, 0x06, 0x00, 0xa4, 0x7c, 0x88,
-  0x9b, 0x06, 0xa4, 0x87, 0x2c, 0x36, 0x5b, 0x3f, 0x4b, 0x69, 0x7b, 0x70,
-  0x6e, 0xad, 0x37, 0x4c, 0x4c, 0x37, 0xad, 0x6e, 0x70, 0x7b, 0x69, 0x4b,
-  0x3f, 0x5b, 0x36, 0x2c, 0x87, 0xa4, 0x06, 0x9b, 0x88, 0x7c, 0xfd, 0xcc,
-  0x15, 0x07, 0x0f, 0x52, 0x3a, 0x1e, 0x33, 0x97, 0x2f, 0x15, 0x87, 0x7b,
-  0x57, 0x60, 0x60, 0x57, 0x7b, 0x87, 0x15, 0x2f, 0x97, 0x33, 0x1e, 0x3a,
-  0x52, 0x0f, 0x07, 0x00, 0x00, 0x09, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x34,
-  0x00, 0x39, 0x00, 0x3e, 0x00, 0x42, 0x00, 0x46, 0x00, 0x00, 0x01, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34,
-  0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x21, 0x10,
-  0x00, 0x20, 0x00, 0x05, 0x36, 0x37, 0x11, 0x23, 0x03, 0x11, 0x23, 0x11,
-  0x16, 0x25, 0x36, 0x37, 0x23, 0x05, 0x35, 0x23, 0x16, 0x02, 0x42, 0x49,
-  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b,
-  0x4b, 0x34, 0x35, 0x49, 0xfc, 0xc8, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
-  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01,
-  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
-  0xb1, 0xfe, 0x27, 0xf8, 0x04, 0x5f, 0xfe, 0xb9, 0xfe, 0x30, 0xfe, 0xb8,
-  0x02, 0x6d, 0x50, 0x44, 0x94, 0x7a, 0x94, 0x45, 0x01, 0xd7, 0x41, 0x19,
-  0x5a, 0xfd, 0x6a, 0x5b, 0x19, 0x03, 0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a,
-  0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
-  0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
-  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x6a, 0xfe, 0xfe, 0xfe, 0x96, 0x01,
-  0x6a, 0xdf, 0x0b, 0x2a, 0x01, 0x25, 0xfe, 0xa6, 0x01, 0x5a, 0xfe, 0xdb,
-  0x2a, 0x99, 0x52, 0x64, 0xb8, 0xb8, 0x66, 0x00, 0x00, 0x09, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x35, 0x00, 0x3a, 0x00, 0x3f, 0x00, 0x43, 0x00, 0x47,
-  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
-  0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
-  0x06, 0x15, 0x07, 0x21, 0x10, 0x00, 0x20, 0x00, 0x05, 0x36, 0x37, 0x11,
-  0x23, 0x03, 0x11, 0x23, 0x11, 0x16, 0x25, 0x36, 0x37, 0x23, 0x05, 0x35,
-  0x23, 0x16, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x03, 0x5c, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfd, 0x72,
-  0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xc9, 0x04, 0x5f, 0xfe, 0xb9,
-  0xfe, 0x30, 0xfe, 0xb8, 0x02, 0x6d, 0x50, 0x44, 0x94, 0x7a, 0x94, 0x45,
-  0x01, 0xd7, 0x41, 0x19, 0x5a, 0xfd, 0x6a, 0x5b, 0x19, 0x02, 0xea, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
-  0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
-  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x02, 0x16, 0x8b, 0xc5, 0xc5, 0x8b, 0x53,
-  0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xac,
-  0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0xdf, 0x0b, 0x2a, 0x01, 0x25, 0xfe,
-  0xa6, 0x01, 0x5a, 0xfe, 0xdb, 0x2a, 0x99, 0x52, 0x64, 0xb8, 0xb8, 0x66,
-  0x00, 0x09, 0x00, 0x55, 0xff, 0x6a, 0x08, 0x14, 0x06, 0x6e, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0c, 0x00, 0x11, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2f,
-  0x00, 0x59, 0x00, 0x7e, 0x00, 0x00, 0x01, 0x35, 0x23, 0x16, 0x05, 0x36,
-  0x37, 0x23, 0x01, 0x11, 0x23, 0x11, 0x16, 0x17, 0x36, 0x37, 0x11, 0x23,
-  0x25, 0x21, 0x10, 0x00, 0x20, 0x00, 0x13, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x14, 0x07, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x22, 0x27,
-  0x26, 0x2f, 0x01, 0x02, 0x07, 0x02, 0x21, 0x20, 0x03, 0x26, 0x03, 0x07,
-  0x06, 0x07, 0x06, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3f, 0x01, 0x26,
-  0x37, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x27, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x2f, 0x01, 0x17, 0x16, 0x17, 0x26, 0x27, 0x26, 0x21, 0x20,
-  0x07, 0x06, 0x07, 0x36, 0x3f, 0x01, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
-  0x06, 0x02, 0xe9, 0x5b, 0x1a, 0x02, 0xd8, 0x40, 0x1a, 0x5a, 0xfe, 0x77,
-  0x93, 0x44, 0xca, 0x4f, 0x44, 0x93, 0xfd, 0x93, 0x04, 0x5e, 0xfe, 0xba,
-  0xfe, 0x2f, 0xfe, 0xb9, 0x4f, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37,
-  0x01, 0x9c, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfc, 0x2a, 0x01,
-  0xda, 0x01, 0x4e, 0x01, 0x50, 0x01, 0xd8, 0x02, 0x54, 0x35, 0x15, 0x1b,
-  0x30, 0x45, 0x1c, 0x16, 0x10, 0x0a, 0x26, 0xbc, 0xec, 0xfe, 0xb0, 0xfe,
-  0xb2, 0xed, 0xbc, 0x27, 0x09, 0x10, 0x17, 0x1c, 0x44, 0x30, 0x1a, 0x15,
-  0x36, 0x53, 0x02, 0x7a, 0x01, 0x92, 0x01, 0x1c, 0x01, 0x1e, 0x01, 0x90,
-  0x01, 0x18, 0x21, 0x22, 0x1c, 0x17, 0x10, 0x29, 0x7b, 0x25, 0x15, 0x2a,
-  0x8b, 0xc7, 0xfe, 0xe1, 0xfe, 0xe4, 0xca, 0x8a, 0x2a, 0x15, 0x25, 0x7a,
-  0x28, 0x10, 0x17, 0x1c, 0x44, 0x18, 0x01, 0x01, 0xa1, 0xb8, 0x66, 0x50,
-  0x52, 0x64, 0xfe, 0xa6, 0x01, 0x5a, 0xfe, 0xdb, 0x2a, 0x0b, 0x0b, 0x2a,
-  0x01, 0x25, 0x87, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x01, 0xae, 0x8b,
-  0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53,
-  0x77, 0x77, 0x53, 0xa2, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b,
-  0x1d, 0x1b, 0x1f, 0x14, 0x18, 0x1f, 0x25, 0x26, 0x36, 0x1f, 0x19, 0x39,
-  0x20, 0xfe, 0xe9, 0xd1, 0xfe, 0xfa, 0x01, 0x06, 0xd0, 0x01, 0x16, 0x1e,
-  0x39, 0x19, 0x1f, 0x36, 0x26, 0x25, 0x1f, 0x19, 0x13, 0x1e, 0x1c, 0x1d,
-  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x14, 0x13, 0x1a, 0x1f,
-  0x19, 0x39, 0x88, 0x2d, 0x0e, 0x0f, 0xc7, 0x9a, 0xe0, 0xe0, 0x9b, 0xc6,
-  0x10, 0x0d, 0x2d, 0x88, 0x39, 0x19, 0x1f, 0x1b, 0x14, 0x00, 0x00, 0x00,
-  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
-  0x00, 0x16, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x34, 0x00, 0x3c, 0x00, 0x00,
-  0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
-  0x21, 0x10, 0x00, 0x20, 0x00, 0x25, 0x21, 0x16, 0x17, 0x16, 0x24, 0x37,
-  0x36, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02,
-  0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9,
-  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
-  0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe,
-  0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x7f, 0x04, 0x5f, 0xfe, 0xb9,
-  0xfe, 0x30, 0xfe, 0xb8, 0x03, 0xd5, 0xfc, 0xb5, 0x1e, 0x53, 0x7f, 0x01,
-  0x6c, 0x80, 0x53, 0x03, 0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53,
-  0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0x01, 0x75, 0x02,
-  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
-  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
-  0xc0, 0xfe, 0x40, 0xfe, 0xb9, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x7b,
-  0x75, 0x5c, 0x8e, 0x01, 0x8e, 0x5c, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x35, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x34, 0x36, 0x32,
-  0x16, 0x15, 0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32,
-  0x16, 0x15, 0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x21, 0x10, 0x00,
-  0x20, 0x00, 0x25, 0x21, 0x16, 0x17, 0x16, 0x37, 0x32, 0x37, 0x36, 0x01,
-  0xe1, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0x01, 0x9b, 0x7e, 0xb1,
-  0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfc, 0x2a, 0x01, 0xd9, 0x01, 0x4f, 0x01,
-  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
-  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
-  0xfe, 0xe4, 0xfe, 0x6d, 0x7f, 0x04, 0x5f, 0xfe, 0xb9, 0xfe, 0x30, 0xfe,
-  0xb8, 0x03, 0xd5, 0xfc, 0xb5, 0x1e, 0x53, 0x7f, 0xb6, 0xb6, 0x80, 0x53,
-  0x03, 0x8c, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5,
-  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xa2, 0x01, 0x75, 0x02, 0x0f, 0xfd,
-  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
-  0x40, 0xfe, 0xb9, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x7b, 0x75, 0x5c,
-  0x8e, 0x01, 0x8e, 0x5c, 0x00, 0x07, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
-  0x00, 0x41, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x17, 0x16, 0x07, 0x14, 0x07,
-  0x06, 0x22, 0x26, 0x35, 0x34, 0x37, 0x05, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x21, 0x10, 0x00, 0x20, 0x00,
-  0x25, 0x21, 0x16, 0x17, 0x16, 0x37, 0x32, 0x37, 0x36, 0x05, 0xfe, 0x3a,
-  0x19, 0x01, 0x18, 0x18, 0x45, 0x30, 0x18, 0xfc, 0x1e, 0x7e, 0xb0, 0x7e,
-  0x79, 0x37, 0x4c, 0x37, 0x01, 0x9b, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b,
-  0x37, 0xfc, 0x2a, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
-  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
-  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
-  0x7f, 0x04, 0x5f, 0xfe, 0xb9, 0xfe, 0x30, 0xfe, 0xb8, 0x03, 0xd5, 0xfc,
-  0xb5, 0x1e, 0x53, 0x7f, 0xb6, 0xb6, 0x80, 0x53, 0x04, 0x2c, 0x80, 0x38,
-  0x22, 0x2b, 0x1a, 0x1b, 0x36, 0x2c, 0x23, 0x35, 0x20, 0x8b, 0xc5, 0xc5,
-  0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77,
-  0x53, 0xa2, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c,
-  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
-  0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xb9, 0xfe, 0xfe,
-  0xfe, 0x96, 0x01, 0x6a, 0x7b, 0x75, 0x5c, 0x8e, 0x01, 0x8e, 0x5c, 0x00,
-  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x06,
-  0x00, 0x0d, 0x00, 0x19, 0x00, 0x25, 0x00, 0x2b, 0x00, 0x33, 0x00, 0x00,
-  0x01, 0x25, 0x17, 0x07, 0x17, 0x07, 0x25, 0x27, 0x15, 0x05, 0x27, 0x37,
-  0x27, 0x37, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x13, 0x21, 0x10, 0x00, 0x20, 0x00, 0x25, 0x21, 0x16, 0x17,
-  0x16, 0x24, 0x37, 0x36, 0x04, 0x09, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45,
-  0xfe, 0xf6, 0x90, 0xfe, 0xf7, 0x46, 0xb3, 0xb3, 0x46, 0xfe, 0x29, 0x01,
-  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
-  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x7f, 0x04, 0x5f, 0xfe,
-  0xb9, 0xfe, 0x30, 0xfe, 0xb8, 0x03, 0xd5, 0xfc, 0xb5, 0x1e, 0x53, 0x7f,
-  0x01, 0x6c, 0x80, 0x53, 0x04, 0x27, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce,
-  0x55, 0x55, 0xce, 0x6e, 0x8a, 0x8b, 0x6e, 0xfd, 0xf5, 0x01, 0x75, 0x02,
-  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
-  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
-  0xc0, 0xfe, 0x40, 0xfe, 0xb9, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x7b,
-  0x75, 0x5c, 0x8e, 0x01, 0x8e, 0x5c, 0x00, 0x00, 0x00, 0x07, 0x00, 0x80,
-  0xff, 0x6a, 0x07, 0x01, 0x07, 0x63, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x2a,
-  0x00, 0x35, 0x00, 0x49, 0x00, 0x57, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x37,
-  0x16, 0x17, 0x16, 0x04, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x2f, 0x01,
-  0x06, 0x21, 0x20, 0x27, 0x07, 0x06, 0x05, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x01, 0x34, 0x24, 0x21, 0x20, 0x04, 0x15, 0x14,
-  0x07, 0x16, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x37, 0x26,
-  0x25, 0x36, 0x35, 0x34, 0x24, 0x21, 0x20, 0x04, 0x15, 0x14, 0x17, 0x36,
-  0x21, 0x20, 0x17, 0x26, 0x23, 0x22, 0x07, 0x16, 0x33, 0x32, 0x01, 0xe7,
-  0x67, 0x1a, 0x24, 0x80, 0x01, 0x6b, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d,
-  0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0xf6, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
-  0x01, 0x91, 0xc8, 0x0c, 0xcf, 0xfe, 0xf5, 0xfe, 0xf6, 0xcf, 0x0d, 0xc9,
-  0x03, 0x38, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfd, 0xf8, 0x49,
-  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0xfe, 0x3f, 0x01, 0xe7, 0x01,
-  0x59, 0x01, 0x5a, 0x01, 0xe6, 0xe4, 0xcb, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
-  0xb1, 0xfe, 0x27, 0xcc, 0xe4, 0x05, 0x45, 0xa9, 0xfe, 0x6f, 0xfe, 0xe3,
-  0xfe, 0xe4, 0xfe, 0x6d, 0xab, 0xdb, 0x01, 0x29, 0x01, 0x2a, 0x3c, 0x9e,
-  0xc8, 0xc7, 0x9e, 0x9e, 0xc7, 0xc8, 0x01, 0xd1, 0x47, 0x2c, 0x26, 0x8d,
-  0x01, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5, 0xb5, 0x33, 0x01, 0x51,
-  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0xe0, 0x0e,
-  0x39, 0x39, 0x0e, 0xe0, 0x2a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53,
-  0x3a, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x02, 0x5c, 0x86, 0xbe, 0xbe,
-  0x86, 0x82, 0x5c, 0xfc, 0xfe, 0xa5, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c,
-  0x01, 0x74, 0x01, 0x5b, 0xfc, 0x5c, 0x02, 0x36, 0x4a, 0x51, 0x72, 0x72,
-  0x51, 0x4a, 0x36, 0xcf, 0xf5, 0x6e, 0x6e, 0x1c, 0x00, 0x07, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x07, 0x30, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x19,
-  0x00, 0x1d, 0x00, 0x2d, 0x00, 0x39, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x05,
-  0x07, 0x25, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x01, 0x17, 0x05, 0x27, 0x01, 0x37, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36,
-  0x37, 0x17, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x36, 0x20, 0x17,
-  0x25, 0x11, 0x16, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x37,
-  0x11, 0x02, 0x8a, 0x01, 0x10, 0x45, 0xfe, 0xef, 0x02, 0x06, 0x4a, 0x68,
-  0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfd, 0xf8, 0x49, 0x35, 0x34, 0x4a, 0x4a,
-  0x34, 0x35, 0x49, 0x02, 0xb7, 0x45, 0xfe, 0xef, 0x45, 0xfd, 0xff, 0x67,
-  0x1a, 0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4,
-  0xfe, 0x30, 0xa4, 0x2d, 0xf6, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01,
-  0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0xb2, 0x77,
-  0x01, 0x0c, 0x77, 0x01, 0x8f, 0x9b, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
-  0xfe, 0x27, 0x9d, 0x05, 0x67, 0xd4, 0x6f, 0xd5, 0xfe, 0xbc, 0x3b, 0x51,
-  0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53,
-  0x01, 0xec, 0x6e, 0xd5, 0x6f, 0xfd, 0x3e, 0x47, 0x2c, 0x26, 0x8e, 0x8e,
-  0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5, 0xb5, 0x33, 0x01, 0x51, 0xfe, 0xc4,
-  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
-  0x02, 0x1d, 0x2a, 0x2a, 0xec, 0xfd, 0xd0, 0xe7, 0xfe, 0xd1, 0xfe, 0x8c,
-  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0x01, 0x2f, 0xe7, 0x02, 0x30, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0f,
-  0x00, 0x1b, 0x00, 0x27, 0x00, 0x32, 0x00, 0x39, 0x00, 0x00, 0x01, 0x37,
-  0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x2d, 0x01, 0x17, 0x07, 0x17, 0x07, 0x25, 0x01, 0xe7, 0x67, 0x1a,
-  0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe,
-  0x30, 0xa4, 0x2d, 0xf6, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x01, 0xa9, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x01,
-  0xc7, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0x01, 0xd1, 0x47,
-  0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5, 0xb5, 0x33,
-  0x01, 0x51, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d,
-  0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
-  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x02, 0x87, 0x3b, 0x51,
-  0x51, 0x76, 0x52, 0x53, 0x64, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0f,
-  0x00, 0x1b, 0x00, 0x27, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x37,
-  0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x03, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
-  0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
-  0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x01, 0xe7, 0x67, 0x1a, 0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23,
-  0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x27, 0x7e, 0xb0,
-  0x7e, 0x79, 0x37, 0x4c, 0x37, 0x01, 0x9b, 0x7e, 0xb1, 0x7e, 0x7a, 0x37,
-  0x4b, 0x37, 0xfc, 0x2a, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7,
-  0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01,
-  0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe,
-  0x6d, 0x01, 0xd1, 0x47, 0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48, 0x39,
-  0x32, 0xb5, 0xb5, 0x33, 0x01, 0xf3, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77,
-  0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xa2, 0x01,
-  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
-  0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01,
-  0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x37,
-  0x00, 0x43, 0x00, 0x51, 0x00, 0x00, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x32, 0x37,
-  0x26, 0x27, 0x06, 0x23, 0x22, 0x00, 0x11, 0x33, 0x14, 0x00, 0x20, 0x00,
-  0x35, 0x33, 0x14, 0x07, 0x16, 0x1d, 0x01, 0x36, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x05, 0x06, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x34, 0x27, 0x26, 0x03, 0xf5, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b,
-  0x37, 0xfd, 0x72, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfe, 0xb8,
-  0x01, 0x93, 0x01, 0x1c, 0x7b, 0x6a, 0x5b, 0x3b, 0x26, 0x29, 0xe8, 0xfe,
-  0xb8, 0x7a, 0x01, 0x00, 0x01, 0x6c, 0x01, 0x00, 0x79, 0x6f, 0x32, 0xbc,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x04, 0x8e, 0x47, 0x52, 0x1b, 0x23, 0x20, 0x18, 0x0f, 0x0b, 0x1e,
-  0x01, 0x01, 0x02, 0x03, 0x8c, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77,
-  0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xa2, 0xfe, 0xc4,
-  0xfe, 0x43, 0x29, 0x30, 0x6c, 0x05, 0x01, 0x6a, 0x01, 0x02, 0xca, 0xfe,
-  0xe5, 0x01, 0x1c, 0xc9, 0xd5, 0xa0, 0x64, 0x63, 0x04, 0xda, 0x01, 0x33,
-  0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f,
-  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x36, 0x43,
-  0x24, 0x28, 0x18, 0x17, 0x08, 0x13, 0x39, 0x05, 0x06, 0x2e, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0f,
-  0x00, 0x1b, 0x00, 0x27, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x37,
-  0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
-  0x27, 0x26, 0x01, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32,
-  0x36, 0x35, 0x21, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32,
-  0x36, 0x35, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x01, 0xe7, 0x67, 0x1a, 0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23,
-  0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x03, 0x9a, 0x7e,
-  0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0, 0x7e, 0x79,
-  0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01,
-  0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93,
-  0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4,
-  0xfe, 0x6d, 0x01, 0xd1, 0x47, 0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48,
-  0x39, 0x32, 0xb5, 0xb5, 0x33, 0x02, 0xef, 0x8b, 0xc5, 0xc5, 0x8b, 0x53,
-  0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfe,
-  0x62, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
-  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
-  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x05, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x17, 0x00, 0x2f, 0x00, 0x3b,
-  0x00, 0x47, 0x00, 0x57, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x06,
-  0x0f, 0x01, 0x23, 0x27, 0x26, 0x35, 0x26, 0x37, 0x36, 0x33, 0x16, 0x17,
-  0x16, 0x17, 0x33, 0x34, 0x37, 0x36, 0x21, 0x32, 0x17, 0x16, 0x15, 0x33,
-  0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x07, 0x14, 0x0f, 0x01, 0x23,
-  0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x37, 0x16, 0x17, 0x16, 0x20,
-  0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x05, 0x15,
-  0x18, 0x16, 0x36, 0x01, 0x2d, 0x97, 0x02, 0x8f, 0x37, 0x01, 0x09, 0x22,
-  0x38, 0x25, 0x1d, 0x19, 0x09, 0x01, 0x0c, 0x1f, 0xfd, 0x8f, 0x37, 0x1f,
-  0x0c, 0x01, 0x09, 0x19, 0x1d, 0x25, 0x39, 0x22, 0x09, 0x01, 0x38, 0x8f,
-  0x02, 0x97, 0x2d, 0x01, 0x36, 0x17, 0xfe, 0x43, 0x01, 0xd9, 0x01, 0x4f,
-  0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27,
-  0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe,
-  0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x67, 0x1a, 0x24, 0x7f, 0x01, 0x6c,
-  0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x04,
-  0xc0, 0x0e, 0x25, 0x3f, 0x41, 0x3e, 0xcf, 0xbe, 0x44, 0x4c, 0x15, 0x19,
-  0x44, 0x01, 0x20, 0x20, 0x31, 0x0e, 0x1d, 0x47, 0x47, 0x1d, 0x0e, 0x31,
-  0x20, 0x20, 0x01, 0x44, 0x19, 0x15, 0x4c, 0x44, 0xbe, 0xcf, 0x3e, 0x41,
-  0x3f, 0x25, 0x0e, 0xfe, 0x2a, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
-  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd,
-  0xaa, 0x47, 0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5,
-  0xb5, 0x33, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x17, 0x00, 0x23, 0x00, 0x33, 0x00, 0x3c, 0x00, 0x00,
-  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x27, 0x23, 0x15, 0x14,
-  0x06, 0x22, 0x26, 0x35, 0x14, 0x06, 0x22, 0x26, 0x3d, 0x01, 0x23, 0x06,
-  0x07, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x25, 0x37, 0x16, 0x17, 0x16, 0x04, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07,
-  0x06, 0x20, 0x27, 0x26, 0x03, 0x21, 0x26, 0x27, 0x26, 0x21, 0x20, 0x07,
-  0x06, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0x4c,
-  0x63, 0x95, 0xd4, 0x96, 0x95, 0xd5, 0x95, 0x63, 0x4d, 0x79, 0x01, 0xd9,
-  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
-  0xfe, 0x27, 0x01, 0x4e, 0x67, 0x1a, 0x24, 0x80, 0x01, 0x6b, 0x80, 0x23,
-  0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x56, 0x04, 0x1f,
-  0x14, 0x16, 0xc8, 0xfe, 0xe2, 0xfe, 0xe4, 0xca, 0x15, 0x02, 0xea, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0xc3, 0xa0, 0x4f, 0x64, 0x8e,
-  0x8e, 0x64, 0x64, 0x8e, 0x8e, 0x64, 0x4f, 0xa0, 0xc3, 0x01, 0x75, 0x02,
-  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x5b,
-  0x47, 0x2c, 0x26, 0x8d, 0x01, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5,
-  0xb5, 0x33, 0x03, 0x3b, 0x1a, 0x19, 0xe0, 0xe0, 0x19, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x00, 0x01, 0x35,
-  0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x13, 0x32, 0x37, 0x36, 0x37, 0x17,
-  0x06, 0x07, 0x06, 0x23, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x04, 0x22, 0x01, 0x80, 0xfc, 0x3f, 0x01, 0x7f,
-  0x61, 0xb6, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xe8, 0xfc, 0xd8,
-  0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0,
-  0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01,
-  0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0x8c, 0x87,
-  0x87, 0x87, 0x87, 0xfd, 0xac, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5,
-  0x02, 0x39, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c,
-  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
-  0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x05, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x19,
-  0x00, 0x25, 0x00, 0x31, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x01, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x11, 0x03, 0x60,
-  0xfc, 0xd1, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08,
-  0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
-  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x71, 0x87, 0x87, 0x02, 0x8c,
-  0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a,
-  0x53, 0x53, 0xd9, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
-  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
-  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x00, 0x01, 0x35,
-  0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x04, 0x22,
-  0x01, 0x80, 0xfc, 0x3f, 0x01, 0x7f, 0xfe, 0xb1, 0x03, 0x60, 0xfb, 0x28,
-  0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0,
-  0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01,
-  0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0x8c, 0x87,
-  0x87, 0x87, 0x87, 0xfd, 0xe5, 0x87, 0x87, 0x01, 0x79, 0x01, 0x75, 0x02,
-  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
-  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
-  0xc0, 0xfe, 0x40, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x29, 0x00, 0x37,
-  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x05, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x35, 0x21, 0x35, 0x21, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x35, 0x01, 0x12,
-  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
-  0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01,
-  0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x78, 0x03,
-  0x60, 0xfc, 0x68, 0x01, 0x53, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x01,
-  0x34, 0x01, 0x52, 0x34, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0x02, 0xea, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
-  0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
-  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x05, 0x87, 0x87, 0x02, 0x2d, 0x87, 0x51,
-  0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x03, 0x02, 0x87, 0x51, 0x3b, 0x3a, 0x53,
-  0x53, 0x3a, 0x03, 0x02, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x14, 0x00, 0x1f,
-  0x00, 0x2a, 0x00, 0x36, 0x00, 0x42, 0x00, 0x00, 0x01, 0x17, 0x16, 0x14,
-  0x06, 0x22, 0x26, 0x34, 0x37, 0x01, 0x35, 0x21, 0x15, 0x13, 0x25, 0x37,
-  0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x05, 0xae, 0x3b, 0x18, 0x30, 0x45, 0x30, 0x18, 0xfc,
-  0x9d, 0x03, 0x60, 0x0a, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc, 0x47, 0x45,
-  0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49,
-  0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01,
-  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
-  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0xac, 0x80, 0x35,
-  0x4f, 0x36, 0x36, 0x4f, 0x35, 0xfe, 0x45, 0x87, 0x87, 0x02, 0xa5, 0xf0,
-  0x6f, 0xf1, 0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76,
-  0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01,
-  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
-  0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01,
-  0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b,
-  0x00, 0x27, 0x00, 0x33, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x13, 0x14,
-  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x21, 0x14,
-  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x11,
-  0x03, 0x60, 0x31, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65,
-  0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
-  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x71, 0x87, 0x87, 0x03, 0x17,
-  0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b,
-  0x53, 0x77, 0x77, 0x53, 0xfe, 0x62, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
-  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
-  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
-  0x00, 0x0e, 0x00, 0x19, 0x00, 0x25, 0x00, 0x31, 0x00, 0x00, 0x25, 0x27,
-  0x01, 0x17, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x02, 0x53, 0x33, 0x03, 0x10, 0x33, 0xfc, 0xdf, 0x49, 0x35, 0x34, 0x4a,
-  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
-  0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
-  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
-  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
-  0xac, 0x7b, 0x01, 0x96, 0x7b, 0x01, 0xbb, 0x3b, 0x51, 0x51, 0x76, 0x52,
-  0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75,
-  0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c,
-  0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d,
-  0x01, 0xc0, 0xfe, 0x40, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x42,
-  0x00, 0x00, 0x01, 0x27, 0x13, 0x17, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x03, 0x37, 0x13, 0x03, 0x22,
-  0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x27, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x02, 0x82, 0x56,
-  0xf3, 0x56, 0xfd, 0x9d, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x04, 0x68, 0xf3, 0x55, 0xf3, 0x8a, 0x2f, 0x25, 0x0a, 0x16, 0x3f,
-  0xb0, 0x3f, 0x19, 0x0b, 0x1f, 0x2f, 0x33, 0x1d, 0x6c, 0x0e, 0x16, 0x40,
-  0xb0, 0x3f, 0x19, 0x0b, 0x1f, 0x2f, 0x2f, 0x24, 0x0b, 0x15, 0x3f, 0xb1,
-  0x3f, 0x15, 0x0f, 0x6d, 0x1c, 0x03, 0x5c, 0x5f, 0x01, 0x0e, 0x5f, 0xfe,
-  0x80, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
-  0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0xe6, 0x01, 0x0e, 0x5f,
-  0xfe, 0xf2, 0xfe, 0x57, 0x69, 0x1d, 0x22, 0x62, 0x01, 0x63, 0x28, 0x21,
-  0x5f, 0x5f, 0x39, 0x28, 0x22, 0x62, 0x62, 0x28, 0x22, 0x5f, 0x69, 0x1e,
-  0x22, 0x62, 0x62, 0x22, 0x28, 0x39, 0x5f, 0x00, 0x00, 0x05, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x23,
-  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x03, 0x37, 0x27, 0x37, 0x17, 0x15, 0x07,
-  0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
-  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
-  0x49, 0xb9, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48,
-  0xfd, 0x08, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29,
-  0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01,
-  0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03,
-  0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51,
-  0x3b, 0x3a, 0x53, 0x53, 0xfe, 0x24, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e,
-  0x2e, 0x58, 0x8d, 0x76, 0x4e, 0x3e, 0x01, 0x23, 0x01, 0x75, 0x02, 0x0f,
-  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74,
-  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0,
-  0xfe, 0x40, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x17, 0x00, 0x22, 0x00, 0x29, 0x00, 0x36, 0x00, 0x42,
-  0x00, 0x4e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x06, 0x0f, 0x01,
-  0x23, 0x27, 0x26, 0x35, 0x26, 0x37, 0x36, 0x33, 0x16, 0x17, 0x16, 0x17,
-  0x33, 0x34, 0x37, 0x36, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x2d, 0x01, 0x17, 0x07, 0x17, 0x07, 0x25, 0x03, 0x37,
-  0x27, 0x37, 0x17, 0x15, 0x07, 0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x01,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x05,
-  0xc6, 0x17, 0x18, 0x36, 0x02, 0x2d, 0x97, 0x02, 0x8e, 0x38, 0x02, 0x09,
-  0x22, 0x3a, 0x24, 0x1d, 0x19, 0x09, 0x02, 0x0a, 0x1f, 0xfc, 0xb4, 0x49,
-  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x01, 0xc7, 0x01, 0x0a, 0x45,
-  0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0x78, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36,
-  0xe9, 0x3b, 0x82, 0x48, 0xfd, 0x08, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
-  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
-  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
-  0xe4, 0xfe, 0x6d, 0x02, 0xaf, 0x0e, 0x25, 0x3f, 0x41, 0x3e, 0xcf, 0xbe,
-  0x44, 0x4c, 0x15, 0x19, 0x44, 0x01, 0x20, 0x20, 0x31, 0x0e, 0x1d, 0x47,
-  0x01, 0x4e, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x64, 0xce, 0x6e, 0x8b,
-  0x8a, 0x6e, 0xce, 0xfe, 0x17, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e, 0x2e,
-  0x58, 0x8d, 0x76, 0x4e, 0x3e, 0x01, 0x23, 0x01, 0x75, 0x02, 0x0f, 0xfd,
-  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
-  0x40, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3c,
-  0x00, 0x00, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
-  0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
-  0x06, 0x15, 0x03, 0x37, 0x27, 0x37, 0x17, 0x15, 0x07, 0x17, 0x15, 0x07,
-  0x27, 0x37, 0x27, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x01, 0xe1, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37,
-  0x01, 0x9b, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xde, 0x48, 0x82,
-  0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48, 0xfd, 0x08, 0x01, 0xd9,
-  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
-  0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe,
-  0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0x8c, 0x8b, 0xc5, 0xc5,
-  0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77,
-  0x53, 0xfe, 0x5d, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e, 0x2e, 0x58, 0x8d,
-  0x76, 0x4e, 0x3e, 0x01, 0x23, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
-  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0c,
-  0x00, 0x18, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x37,
-  0x27, 0x37, 0x17, 0x15, 0x07, 0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x01,
-  0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x21,
-  0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03,
-  0x91, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48, 0x02,
-  0x11, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0,
-  0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01,
-  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
-  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
-  0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0xe9, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e,
-  0x2e, 0x58, 0x8d, 0x76, 0x4e, 0x3e, 0x02, 0xc1, 0x8b, 0xc5, 0xc5, 0x8b,
-  0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53,
-  0xfe, 0x62, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c,
-  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
-  0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x06, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22,
-  0x00, 0x2e, 0x00, 0x38, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x25, 0x35, 0x21, 0x15, 0x23,
-  0x14, 0x06, 0x22, 0x26, 0x35, 0x21, 0x23, 0x14, 0x16, 0x32, 0x36, 0x02,
-  0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a,
-  0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0xc8, 0x01, 0x93, 0x01, 0x1c,
-  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
-  0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
-  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x78, 0x03, 0x60, 0xda, 0x7e, 0xb0,
-  0x7e, 0x01, 0x33, 0xba, 0x37, 0x4c, 0x37, 0x03, 0xff, 0x3b, 0x51, 0x51,
-  0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53,
-  0xdb, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
-  0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x63, 0x87, 0x87, 0x8b, 0xc5,
-  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x1d,
-  0x00, 0x29, 0x00, 0x33, 0x00, 0x39, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x2d, 0x01, 0x17, 0x07, 0x17,
-  0x07, 0x25, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x25, 0x35, 0x21, 0x15, 0x23, 0x14, 0x06, 0x22, 0x26, 0x35,
-  0x21, 0x23, 0x14, 0x16, 0x32, 0x36, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
-  0x4a, 0x34, 0x35, 0x49, 0x01, 0xc7, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45,
-  0xfe, 0xf6, 0xfd, 0x09, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x01, 0x78, 0x03, 0x60, 0xda, 0x7e, 0xb0, 0x7e, 0x01, 0x33, 0xba,
-  0x37, 0x4c, 0x37, 0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x64,
-  0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0xe8, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
-  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01,
-  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
-  0x0c, 0x63, 0x87, 0x87, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x00,
-  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
-  0x00, 0x17, 0x00, 0x1e, 0x00, 0x25, 0x00, 0x2f, 0x00, 0x35, 0x00, 0x00,
-  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x01, 0x15, 0x05, 0x27, 0x37, 0x27, 0x37, 0x05, 0x25, 0x17, 0x07, 0x17,
-  0x07, 0x25, 0x01, 0x35, 0x21, 0x15, 0x23, 0x14, 0x06, 0x22, 0x26, 0x35,
-  0x21, 0x23, 0x14, 0x16, 0x32, 0x36, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c,
-  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
-  0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
-  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x02, 0xe0, 0xfe, 0xf7, 0x46, 0xb3, 0xb3,
-  0x46, 0x01, 0x99, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0xfe,
-  0x08, 0x03, 0x60, 0xda, 0x7e, 0xb0, 0x7e, 0x01, 0x33, 0xba, 0x37, 0x4c,
-  0x37, 0x02, 0xea, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01,
-  0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd,
-  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x02, 0xb1, 0x55,
-  0xce, 0x6e, 0x8a, 0x8b, 0x6e, 0xce, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce,
-  0xfe, 0x07, 0x87, 0x87, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x00,
-  0x00, 0x07, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x35, 0x00, 0x46,
-  0x00, 0x00, 0x01, 0x25, 0x37, 0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34,
-  0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36,
-  0x20, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06,
-  0x07, 0x05, 0x7b, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc, 0x47, 0x45, 0x01,
-  0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02,
-  0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9,
-  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
-  0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe,
-  0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x21, 0x2d, 0xa4, 0x01,
-  0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6, 0x7f, 0x24,
-  0x1a, 0x04, 0x16, 0xf0, 0x6f, 0xf1, 0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf,
-  0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a,
-  0x53, 0x53, 0x91, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
-  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
-  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd, 0x25, 0x38,
-  0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27,
-  0x2c, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x22, 0x00, 0x2d,
-  0x00, 0x39, 0x00, 0x45, 0x00, 0x56, 0x00, 0x00, 0x25, 0x27, 0x36, 0x37,
-  0x36, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06,
-  0x01, 0x25, 0x37, 0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36, 0x20, 0x17,
-  0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x03,
-  0x73, 0x6d, 0x0e, 0x16, 0x3f, 0xb0, 0x3f, 0x16, 0x0e, 0x6c, 0x07, 0x07,
-  0x1b, 0x4c, 0x1b, 0x07, 0x02, 0x02, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc,
-  0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34,
-  0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc,
-  0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
-  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
-  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x21,
-  0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6,
-  0xb6, 0x7f, 0x24, 0x1a, 0x9f, 0x39, 0x28, 0x22, 0x62, 0x62, 0x22, 0x28,
-  0x39, 0x13, 0x10, 0x3c, 0x3c, 0x10, 0x03, 0x64, 0xf0, 0x6f, 0xf1, 0x6e,
-  0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a,
-  0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01, 0x75, 0x02, 0x0f,
-  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74,
-  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0,
-  0xfe, 0x40, 0xfd, 0x25, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c,
-  0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c, 0x00, 0x00, 0x00, 0x07, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x19,
-  0x00, 0x1d, 0x00, 0x29, 0x00, 0x35, 0x00, 0x46, 0x00, 0x00, 0x01, 0x17,
-  0x05, 0x27, 0x05, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x01, 0x05, 0x07, 0x25, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17,
-  0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x04, 0xf9, 0x45,
-  0xfe, 0xef, 0x45, 0xfe, 0x5a, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35,
-  0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfe, 0x40,
-  0x01, 0x10, 0x45, 0xfe, 0xef, 0xfe, 0x55, 0x01, 0xd9, 0x01, 0x4f, 0x01,
-  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
-  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
-  0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x21, 0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e,
-  0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6, 0x7f, 0x24, 0x1a, 0x05, 0x67,
-  0x6e, 0xd5, 0x6f, 0xde, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b,
-  0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x01, 0xec, 0xd4, 0x6f, 0xd5, 0xfd,
-  0xf1, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
-  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
-  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd, 0x25, 0x38, 0x33, 0xb5,
-  0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c, 0x00,
-  0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x10,
-  0x00, 0x1c, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x37, 0x00, 0x42, 0x00, 0x46,
-  0x00, 0x56, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17,
-  0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x01, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x05, 0x07,
-  0x25, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x01,
-  0x17, 0x05, 0x27, 0x03, 0x27, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
-  0x07, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x01, 0xe7, 0x21, 0x2d, 0xa4,
-  0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6, 0x7f,
-  0x24, 0x1a, 0xfe, 0xc4, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x01, 0xf1, 0x01, 0x10, 0x45, 0xfe, 0xef, 0x02, 0x06, 0x4a, 0x68,
-  0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfd, 0xf8, 0x49, 0x35, 0x34, 0x4a, 0x4a,
-  0x34, 0x35, 0x49, 0x02, 0xb7, 0x45, 0xfe, 0xef, 0x45, 0x75, 0x6d, 0x0e,
-  0x16, 0x3f, 0xb0, 0x3f, 0x16, 0x0e, 0x6c, 0x07, 0x07, 0x1b, 0x4c, 0x1b,
-  0x07, 0x01, 0x4c, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27,
-  0x8e, 0x01, 0x8e, 0x27, 0x2c, 0x01, 0xe5, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
-  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01,
-  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
-  0x0c, 0x03, 0xf1, 0xd4, 0x6f, 0xd5, 0xfe, 0xbc, 0x3b, 0x51, 0x51, 0x3b,
-  0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x01, 0xec,
-  0x6e, 0xd5, 0x6f, 0xfc, 0x0c, 0x39, 0x28, 0x22, 0x62, 0x62, 0x22, 0x28,
-  0x39, 0x13, 0x10, 0x3c, 0x3c, 0x10, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
-  0x00, 0x34, 0x00, 0x4f, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x14, 0x06, 0x22, 0x26, 0x35,
-  0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17,
-  0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x01,
-  0x14, 0x07, 0x06, 0x07, 0x17, 0x16, 0x07, 0x14, 0x07, 0x06, 0x22, 0x26,
-  0x35, 0x34, 0x3f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32,
-  0x36, 0x35, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x02, 0xf4, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfe, 0xd3,
-  0x21, 0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80,
-  0xb6, 0xb6, 0x7f, 0x24, 0x1a, 0x03, 0x54, 0x3f, 0x34, 0x46, 0x1d, 0x19,
-  0x01, 0x18, 0x18, 0x45, 0x30, 0x18, 0x1d, 0x45, 0x35, 0x3f, 0x7a, 0x37,
-  0x4b, 0x37, 0x02, 0xea, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c,
-  0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f,
-  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x03, 0x12,
-  0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfc, 0xc4, 0x38, 0x33,
-  0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c,
-  0x03, 0x83, 0x8c, 0x62, 0x51, 0x0e, 0x3f, 0x37, 0x23, 0x2b, 0x1a, 0x1b,
-  0x36, 0x2c, 0x23, 0x35, 0x3f, 0x0d, 0x52, 0x62, 0x8c, 0x53, 0x77, 0x77,
-  0x53, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x10, 0x00, 0x17, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x36,
-  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17, 0x07, 0x26,
-  0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x01, 0x25, 0x17, 0x07, 0x17,
-  0x07, 0x25, 0x27, 0x15, 0x05, 0x27, 0x37, 0x27, 0x37, 0x01, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0xe7, 0x21,
-  0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6,
-  0xb6, 0x7f, 0x24, 0x1a, 0x01, 0xbb, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45,
-  0xfe, 0xf6, 0x90, 0xfe, 0xf7, 0x46, 0xb3, 0xb3, 0x46, 0xfe, 0x29, 0x01,
-  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
-  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x4c, 0x38, 0x33,
-  0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c,
-  0x03, 0x22, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0x55, 0x55, 0xce, 0x6e,
-  0x8a, 0x8b, 0x6e, 0xfd, 0xf5, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
-  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00,
-  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x18, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x39, 0x00, 0x00,
-  0x01, 0x27, 0x13, 0x17, 0x01, 0x03, 0x37, 0x13, 0x01, 0x36, 0x37, 0x36,
-  0x20, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06,
-  0x07, 0x01, 0x17, 0x16, 0x0e, 0x01, 0x22, 0x26, 0x34, 0x37, 0x05, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x82,
-  0x56, 0xf3, 0x56, 0x01, 0x8c, 0xf3, 0x55, 0xf3, 0xfc, 0x91, 0x21, 0x2d,
-  0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6,
-  0x7f, 0x24, 0x1a, 0x03, 0x78, 0x3b, 0x19, 0x01, 0x31, 0x44, 0x31, 0x19,
-  0xfb, 0x86, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
-  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01,
-  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x03,
-  0x5c, 0x5f, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x01, 0x0e, 0x5f, 0xfe, 0xf2,
-  0xfd, 0x91, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e,
-  0x01, 0x8e, 0x27, 0x2c, 0x03, 0x23, 0x80, 0x35, 0x4f, 0x36, 0x36, 0x4f,
-  0x35, 0xbe, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d,
-  0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
-  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x00, 0x06, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22,
-  0x00, 0x2e, 0x00, 0x34, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32,
-  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20,
-  0x00, 0x05, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x02, 0x42, 0x49,
-  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b,
-  0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
-  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
-  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
-  0xe4, 0xfe, 0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01,
-  0x0a, 0xfc, 0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e,
-  0x03, 0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51,
-  0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
-  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
-  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
-  0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe, 0xba, 0x61, 0x60, 0x4c, 0x74, 0x75,
-  0x4c, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x29,
-  0x00, 0x35, 0x00, 0x3b, 0x00, 0x43, 0x00, 0x00, 0x01, 0x25, 0x37, 0x0d,
-  0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
-  0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20, 0x00, 0x05, 0x21, 0x26, 0x27,
-  0x26, 0x20, 0x07, 0x06, 0x05, 0x7b, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc,
-  0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34,
-  0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc,
-  0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
-  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
-  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x04, 0x75,
-  0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01, 0x0a, 0xfc, 0xfe, 0x02, 0x77,
-  0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e, 0x04, 0x16, 0xf0, 0x6f, 0xf1,
-  0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53,
-  0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01, 0x75, 0x02,
-  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
-  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
-  0xc0, 0xfe, 0x40, 0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe, 0xba, 0x61, 0x60,
-  0x4c, 0x74, 0x75, 0x4c, 0x00, 0x0e, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x13, 0x00, 0x19, 0x00, 0x4e, 0x00, 0x5a,
-  0x00, 0x66, 0x00, 0x6c, 0x00, 0x78, 0x00, 0x84, 0x00, 0x8a, 0x00, 0x90,
-  0x00, 0x96, 0x00, 0x9c, 0x00, 0xa2, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
-  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01, 0x21, 0x26, 0x27,
-  0x26, 0x20, 0x07, 0x06, 0x05, 0x21, 0x34, 0x00, 0x20, 0x00, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x27, 0x15, 0x23, 0x11, 0x26, 0x27,
-  0x11, 0x23, 0x35, 0x0e, 0x01, 0x22, 0x27, 0x23, 0x35, 0x26, 0x34, 0x37,
-  0x11, 0x26, 0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x11, 0x16, 0x14, 0x07,
-  0x15, 0x23, 0x06, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x06, 0x07, 0x11,
-  0x23, 0x35, 0x06, 0x07, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x25, 0x36, 0x37, 0x35, 0x06, 0x07, 0x13, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x27, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x01, 0x15, 0x16,
-  0x17, 0x35, 0x26, 0x27, 0x26, 0x27, 0x15, 0x36, 0x3f, 0x01, 0x26, 0x27,
-  0x15, 0x16, 0x17, 0x25, 0x06, 0x07, 0x15, 0x36, 0x3f, 0x01, 0x06, 0x07,
-  0x15, 0x16, 0x17, 0x04, 0x21, 0x68, 0x43, 0x4c, 0x5f, 0x64, 0x47, 0x45,
-  0x66, 0xfe, 0x64, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e,
-  0x02, 0xec, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01, 0x0a, 0xfb, 0x8b,
-  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0x30, 0x3d, 0x1b, 0x21,
-  0x3d, 0x1b, 0x62, 0x80, 0x33, 0x3d, 0x27, 0x27, 0x1e, 0x1e, 0x3d, 0x1f,
-  0x1e, 0x27, 0x27, 0x3d, 0x32, 0x80, 0x63, 0x1a, 0x3d, 0x22, 0x1b, 0x3d,
-  0x31, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29,
-  0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x03, 0xff, 0x1f, 0x15, 0x15, 0x1e,
-  0x1c, 0x17, 0x14, 0x20, 0xfd, 0xdb, 0x1d, 0x20, 0x20, 0x1d, 0xef, 0x67,
-  0x44, 0x47, 0x64, 0x5e, 0x4d, 0x42, 0x69, 0x78, 0x1f, 0x14, 0x18, 0x1b,
-  0x1d, 0x16, 0x15, 0x1e, 0x01, 0xe9, 0x20, 0x1c, 0x1d, 0x5c, 0x1e, 0x1f,
-  0x1c, 0x21, 0xf3, 0x1e, 0x1f, 0x27, 0x16, 0xfc, 0xad, 0x1f, 0x1d, 0x16,
-  0x26, 0xf3, 0x1f, 0x1d, 0x20, 0x1c, 0x04, 0x1a, 0x52, 0x6c, 0x75, 0x49,
-  0x4f, 0x6f, 0x6f, 0xfc, 0xe9, 0x60, 0x4c, 0x74, 0x75, 0x4c, 0xe6, 0xe8,
-  0x01, 0x46, 0xfe, 0xba, 0x01, 0x37, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
-  0x01, 0x3c, 0x9b, 0x85, 0xba, 0x01, 0x3b, 0x2e, 0x29, 0xfe, 0x6e, 0x59,
-  0x36, 0x47, 0x24, 0x40, 0x3c, 0x9c, 0x3c, 0x01, 0x3d, 0x04, 0x01, 0xfd,
-  0x6a, 0x02, 0x96, 0x01, 0x04, 0xfe, 0xc3, 0x3c, 0x9c, 0x3c, 0x40, 0x24,
-  0x46, 0x37, 0x59, 0x01, 0x93, 0x2a, 0x2e, 0xfe, 0xc5, 0xbc, 0x86, 0x9c,
-  0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4,
-  0x02, 0x0c, 0x02, 0xa4, 0x18, 0x21, 0x21, 0x18, 0x16, 0x23, 0x20, 0xfc,
-  0x0a, 0x01, 0xa2, 0x0f, 0x12, 0xfe, 0x91, 0x4f, 0x6f, 0x6f, 0x4f, 0x49,
-  0x75, 0x6c, 0x52, 0x19, 0x20, 0x23, 0x16, 0x18, 0x21, 0x21, 0x01, 0x79,
-  0xa3, 0x01, 0x0a, 0x8c, 0x13, 0x28, 0x0a, 0x08, 0xf2, 0x14, 0x09, 0x26,
-  0x1e, 0x18, 0x84, 0x21, 0x2d, 0xd2, 0x19, 0x1d, 0x9c, 0x2d, 0x21, 0xfd,
-  0x07, 0x0b, 0xc3, 0x09, 0x14, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x1b, 0x00, 0x27, 0x00, 0x2d, 0x00, 0x35, 0x00, 0x00,
-  0x01, 0x27, 0x13, 0x17, 0x01, 0x03, 0x37, 0x13, 0x01, 0x27, 0x13, 0x17,
-  0x01, 0x03, 0x37, 0x13, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20, 0x00, 0x05, 0x21,
-  0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x02, 0x82, 0x56, 0xf3, 0x56, 0x01,
-  0x8c, 0xf3, 0x55, 0xf3, 0xfd, 0x2c, 0x56, 0xf3, 0x56, 0x01, 0x8c, 0xf3,
-  0x55, 0xf3, 0xfb, 0x43, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7,
-  0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01,
-  0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe,
-  0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01, 0x0a, 0xfc,
-  0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e, 0x04, 0x13,
-  0x5f, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0xfe,
-  0x58, 0x5f, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x01, 0x0e, 0x5f, 0xfe, 0xf2,
-  0x3f, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
-  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
-  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfc, 0xa4, 0xe8, 0x01, 0x46,
-  0xfe, 0xba, 0x61, 0x60, 0x4c, 0x74, 0x75, 0x4c, 0x00, 0x07, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x29,
-  0x00, 0x35, 0x00, 0x41, 0x00, 0x47, 0x00, 0x4f, 0x00, 0x00, 0x01, 0x37,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x03, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14,
-  0x16, 0x32, 0x36, 0x35, 0x21, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14,
-  0x16, 0x32, 0x36, 0x35, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20, 0x00, 0x05, 0x21,
-  0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x05, 0x30, 0x4d, 0x21, 0x1c, 0x17,
-  0x13, 0x0c, 0x0c, 0x20, 0x10, 0x09, 0x04, 0x0b, 0x23, 0x1c, 0x35, 0x10,
-  0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0, 0x7e,
-  0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
-  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
-  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
-  0xe4, 0xfe, 0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01,
-  0x0a, 0xfc, 0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e,
-  0x02, 0xc8, 0x74, 0x32, 0x0f, 0x0b, 0x04, 0x0c, 0x22, 0x14, 0x15, 0x0e,
-  0x0f, 0x24, 0x14, 0x10, 0x01, 0xc0, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77,
-  0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfe, 0x62,
-  0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4,
-  0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c,
-  0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe,
-  0xba, 0x61, 0x60, 0x4c, 0x74, 0x75, 0x4c, 0x00, 0x00, 0x06, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x19,
-  0x00, 0x25, 0x00, 0x2b, 0x00, 0x33, 0x00, 0x00, 0x01, 0x25, 0x17, 0x07,
-  0x17, 0x07, 0x25, 0x27, 0x15, 0x05, 0x27, 0x37, 0x27, 0x37, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x21,
-  0x34, 0x00, 0x20, 0x00, 0x05, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06,
-  0x04, 0x09, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0x90, 0xfe,
-  0xf7, 0x46, 0xb3, 0xb3, 0x46, 0xfe, 0x29, 0x01, 0xd9, 0x01, 0x4f, 0x01,
-  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
-  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
-  0xfe, 0xe4, 0xfe, 0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79,
-  0x01, 0x0a, 0xfc, 0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f,
-  0x3e, 0x04, 0x27, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0x55, 0x55, 0xce,
-  0x6e, 0x8a, 0x8b, 0x6e, 0xfd, 0xf5, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
-  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
-  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
-  0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe, 0xba, 0x61, 0x60, 0x4c, 0x74, 0x75,
-  0x4c, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x55, 0xff, 0x6a, 0x08, 0x14,
-  0x06, 0x6e, 0x00, 0x05, 0x00, 0x0c, 0x00, 0x13, 0x00, 0x3d, 0x00, 0x62,
-  0x00, 0x00, 0x25, 0x21, 0x34, 0x00, 0x20, 0x00, 0x01, 0x15, 0x05, 0x27,
-  0x37, 0x27, 0x37, 0x05, 0x25, 0x17, 0x07, 0x17, 0x07, 0x25, 0x05, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x14, 0x07, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x06, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x02, 0x07, 0x02, 0x21, 0x20,
-  0x03, 0x26, 0x03, 0x07, 0x06, 0x07, 0x06, 0x22, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x3f, 0x01, 0x26, 0x37, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
-  0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x17, 0x16, 0x17, 0x26,
-  0x27, 0x26, 0x21, 0x20, 0x07, 0x06, 0x07, 0x36, 0x3f, 0x01, 0x07, 0x06,
-  0x07, 0x06, 0x22, 0x27, 0x06, 0x05, 0xfa, 0xfc, 0x74, 0x01, 0x09, 0x01,
-  0x79, 0x01, 0x0a, 0xfd, 0xf2, 0xfe, 0xf7, 0x45, 0xb2, 0xb2, 0x45, 0x01,
-  0x99, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0xfc, 0x90, 0x01,
-  0xda, 0x01, 0x4e, 0x01, 0x50, 0x01, 0xd8, 0x02, 0x54, 0x35, 0x15, 0x1b,
-  0x30, 0x45, 0x1c, 0x16, 0x10, 0x0a, 0x26, 0xbc, 0xec, 0xfe, 0xb0, 0xfe,
-  0xb2, 0xed, 0xbc, 0x27, 0x09, 0x10, 0x17, 0x1c, 0x44, 0x30, 0x1a, 0x15,
-  0x36, 0x53, 0x02, 0x7a, 0x01, 0x92, 0x01, 0x1c, 0x01, 0x1e, 0x01, 0x90,
-  0x01, 0x18, 0x21, 0x22, 0x1c, 0x17, 0x10, 0x29, 0x7b, 0x25, 0x15, 0x2a,
-  0x8b, 0xc7, 0xfe, 0xe1, 0xfe, 0xe4, 0xca, 0x8a, 0x2a, 0x15, 0x25, 0x7a,
-  0x28, 0x10, 0x17, 0x1c, 0x44, 0x18, 0x01, 0xcb, 0xe8, 0x01, 0x46, 0xfe,
-  0xba, 0x02, 0x74, 0x55, 0xce, 0x6e, 0x8a, 0x8b, 0x6e, 0xce, 0xce, 0x6e,
-  0x8b, 0x8a, 0x6e, 0xce, 0xe8, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0x1d, 0x1b, 0x1f, 0x14, 0x18, 0x1f, 0x25, 0x26, 0x36, 0x1f, 0x19,
-  0x39, 0x20, 0xfe, 0xe9, 0xd1, 0xfe, 0xfa, 0x01, 0x06, 0xd0, 0x01, 0x16,
-  0x1e, 0x39, 0x19, 0x1f, 0x36, 0x26, 0x25, 0x1f, 0x19, 0x13, 0x1e, 0x1c,
-  0x1d, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x14, 0x13, 0x1a,
-  0x1f, 0x19, 0x39, 0x88, 0x2d, 0x0e, 0x0f, 0xc7, 0x9a, 0xe0, 0xe0, 0x9b,
-  0xc6, 0x10, 0x0d, 0x2d, 0x88, 0x39, 0x19, 0x1f, 0x1b, 0x14, 0x00, 0x00,
-  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x07,
-  0x00, 0x13, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x36, 0x00, 0x00, 0x00, 0x34,
-  0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15,
-  0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11,
-  0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0xdb, 0x87, 0xbf, 0x87, 0x87, 0xbf,
-  0xfe, 0xe0, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08,
-  0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01,
-  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
-  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
-  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x5a, 0xd4, 0x96, 0x96, 0xd4,
-  0x96, 0x03, 0x3b, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b,
-  0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0x01, 0x75, 0x02, 0x0f, 0xfd,
-  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
-  0x40, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x25,
-  0x00, 0x31, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x25, 0x37, 0x0d, 0x01, 0x27,
-  0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
-  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x02, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x05, 0x7b, 0xfe, 0xcb,
-  0x45, 0x01, 0x35, 0xfc, 0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35,
-  0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b,
-  0x34, 0x35, 0x49, 0xfc, 0x44, 0x5f, 0x43, 0x43, 0x5f, 0xfd, 0x07, 0x01,
-  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
-  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
-  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x04, 0x16, 0xf0, 0x6f,
-  0xf1, 0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52,
-  0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xfe, 0x14, 0x6a,
-  0x4b, 0x4b, 0x6a, 0x4b, 0x01, 0xa6, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
-  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
-  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
-  0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x08,
-  0x00, 0x10, 0x00, 0x14, 0x00, 0x18, 0x00, 0x23, 0x00, 0x2e, 0x00, 0x3a,
-  0x00, 0x46, 0x00, 0x00, 0x01, 0x17, 0x16, 0x14, 0x06, 0x22, 0x26, 0x34,
-  0x37, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x25, 0x37,
-  0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14,
-  0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06,
-  0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
-  0x21, 0x20, 0x00, 0x05, 0xae, 0x3b, 0x18, 0x30, 0x45, 0x30, 0x18, 0xfd,
-  0x67, 0x87, 0xbf, 0x87, 0x87, 0xbf, 0x02, 0x19, 0xfe, 0xcb, 0x45, 0x01,
-  0x35, 0xfc, 0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a,
-  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
-  0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
-  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
-  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
-  0x03, 0xac, 0x80, 0x35, 0x4f, 0x36, 0x36, 0x4f, 0x35, 0xfe, 0x2e, 0xd4,
-  0x96, 0x96, 0xd4, 0x96, 0x03, 0x52, 0xf0, 0x6f, 0xf1, 0x6e, 0x6e, 0xf1,
-  0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51,
-  0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
-  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
-  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
-  0x00, 0x07, 0x00, 0x1f, 0xff, 0x3c, 0x07, 0x63, 0x06, 0x6e, 0x00, 0x07,
-  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x6b, 0x00, 0x94,
-  0x00, 0x00, 0x00, 0x26, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x20, 0x26,
-  0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x2f, 0x01, 0x25, 0x17, 0x05, 0x25,
-  0x37, 0x05, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x35,
-  0x2e, 0x01, 0x27, 0x02, 0x11, 0x34, 0x36, 0x37, 0x36, 0x37, 0x12, 0x20,
-  0x13, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x10, 0x03, 0x0e, 0x01, 0x07, 0x15,
-  0x23, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x34, 0x26, 0x22, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x0f, 0x01, 0x0e, 0x01, 0x1d, 0x01, 0x23, 0x35,
-  0x06, 0x22, 0x27, 0x15, 0x23, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x26, 0x27,
-  0x26, 0x27, 0x2e, 0x01, 0x22, 0x06, 0x15, 0x12, 0x17, 0x16, 0x17, 0x16,
-  0x1d, 0x01, 0x25, 0x16, 0x32, 0x37, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27,
-  0x26, 0x20, 0x07, 0x06, 0x07, 0x16, 0x17, 0x1e, 0x02, 0x17, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x04, 0x93, 0x49, 0x4a, 0x68, 0x4b,
-  0x4b, 0xfd, 0x8f, 0x49, 0x49, 0x69, 0x4a, 0x4a, 0xed, 0x45, 0x01, 0x36,
-  0x45, 0x02, 0x3e, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfd, 0x1b, 0x87, 0xbf,
-  0x87, 0x87, 0xbf, 0xfd, 0xde, 0x41, 0x4e, 0x15, 0x7c, 0x5d, 0x37, 0x35,
-  0x9d, 0xec, 0x02, 0x9f, 0xec, 0x9c, 0x35, 0x37, 0x5e, 0x7c, 0x16, 0x4d,
-  0x41, 0x7a, 0x23, 0x74, 0x1a, 0x6e, 0x01, 0x23, 0x34, 0x21, 0x06, 0x0c,
-  0x5f, 0x25, 0x32, 0x55, 0x23, 0x18, 0x7a, 0x63, 0xeb, 0x6d, 0x7b, 0x18,
-  0x23, 0x55, 0x32, 0x25, 0x5e, 0x0d, 0x05, 0x22, 0x34, 0x23, 0x02, 0x6e,
-  0x1a, 0x74, 0x22, 0x01, 0x2b, 0x6b, 0xee, 0x62, 0x18, 0x2b, 0x83, 0x32,
-  0x0f, 0x36, 0x10, 0x01, 0x08, 0x0a, 0x0b, 0x2e, 0x0e, 0x0f, 0x2d, 0x81,
-  0xc8, 0xfd, 0xc6, 0xca, 0x81, 0x2d, 0x10, 0x0d, 0x2e, 0x16, 0x07, 0x02,
-  0x0f, 0x36, 0x0f, 0x33, 0x82, 0x2c, 0x18, 0x03, 0x28, 0x53, 0x75, 0x51,
-  0x51, 0x75, 0x53, 0x53, 0x75, 0x51, 0x51, 0x76, 0x52, 0xee, 0x6e, 0xf1,
-  0x6f, 0xf0, 0xf0, 0x6f, 0xf1, 0xfc, 0xd6, 0xd4, 0x96, 0x96, 0xd4, 0x96,
-  0xfe, 0x78, 0xcb, 0x3e, 0x5b, 0x31, 0x01, 0x17, 0x01, 0x27, 0x53, 0x6b,
-  0x0a, 0xdf, 0xb0, 0x01, 0x08, 0xfe, 0xf8, 0xaf, 0xe0, 0x0a, 0x6b, 0x53,
-  0xfe, 0xd9, 0xfe, 0xe9, 0x31, 0x5b, 0x3e, 0xcb, 0xe7, 0x24, 0x1f, 0x6e,
-  0x39, 0xf0, 0x01, 0x12, 0x1c, 0x28, 0x23, 0x6d, 0xf3, 0x71, 0x2c, 0x25,
-  0x40, 0x1c, 0x3c, 0x3f, 0xfb, 0x4c, 0x1e, 0x20, 0x4e, 0xfb, 0x3f, 0x3c,
-  0x1c, 0x40, 0x25, 0x2c, 0x71, 0xf3, 0x6d, 0x23, 0x28, 0x1c, 0xfe, 0xee,
-  0xf0, 0x39, 0x6e, 0x1f, 0x24, 0xe7, 0xdb, 0x26, 0x25, 0x21, 0x59, 0x3b,
-  0x65, 0x56, 0x22, 0x13, 0x44, 0x78, 0x0f, 0x86, 0x38, 0x36, 0x30, 0x0e,
-  0x0a, 0xb5, 0x90, 0xe0, 0xe0, 0x8f, 0xb5, 0x0b, 0x0e, 0x30, 0x6e, 0x86,
-  0x0f, 0x78, 0x44, 0x13, 0x22, 0x56, 0x65, 0x3b, 0x59, 0x00, 0x00, 0x00,
-  0x00, 0x09, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
-  0x00, 0x17, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x47, 0x00, 0x4f,
-  0x00, 0x5b, 0x00, 0x67, 0x00, 0x00, 0x01, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x34, 0x36, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36,
-  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x17, 0x34, 0x36, 0x33, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x26, 0x23, 0x22, 0x06,
-  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x27, 0x14, 0x06, 0x23, 0x22, 0x26,
-  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x02, 0x34, 0x36, 0x32, 0x16, 0x14,
-  0x06, 0x22, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x03, 0x8d, 0x83, 0x53, 0x60, 0x76, 0x7d, 0x59, 0x55, 0x81,
-  0x68, 0x81, 0x56, 0x59, 0x7d, 0x77, 0x5f, 0x53, 0x84, 0x2c, 0x68, 0x43,
-  0x4c, 0x5f, 0x64, 0x47, 0x45, 0x66, 0x77, 0x1f, 0x15, 0x15, 0x1e, 0x1c,
-  0x17, 0x14, 0x20, 0xfe, 0xca, 0x67, 0x44, 0x47, 0x64, 0x5e, 0x4d, 0x42,
-  0x69, 0x78, 0x1f, 0x14, 0x18, 0x1b, 0x1d, 0x16, 0x15, 0x1e, 0x0f, 0x87,
-  0xbf, 0x87, 0x87, 0xbf, 0xfd, 0x37, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
-  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
-  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
-  0xe4, 0xfe, 0x6d, 0x04, 0x1a, 0x66, 0x88, 0x93, 0x5b, 0x63, 0x8b, 0x8b,
-  0x63, 0x63, 0x8b, 0x8b, 0x63, 0x5b, 0x93, 0x88, 0x66, 0x52, 0x6c, 0x75,
-  0x49, 0x4f, 0x6f, 0x6f, 0x4f, 0x18, 0x21, 0x21, 0x18, 0x16, 0x23, 0x20,
-  0x19, 0x4f, 0x6f, 0x6f, 0x4f, 0x49, 0x75, 0x6c, 0x52, 0x19, 0x20, 0x23,
-  0x16, 0x18, 0x21, 0x21, 0xfd, 0x28, 0xd4, 0x96, 0x96, 0xd4, 0x96, 0x02,
-  0x26, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
-  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
-  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x0a, 0x00, 0x99,
-  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x4a, 0x00, 0x56, 0x00, 0x5e,
-  0x00, 0x62, 0x00, 0x66, 0x00, 0x6b, 0x00, 0x70, 0x00, 0x74, 0x00, 0x79,
-  0x00, 0x7e, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
-  0x27, 0x11, 0x23, 0x11, 0x26, 0x27, 0x15, 0x17, 0x07, 0x11, 0x23, 0x35,
-  0x23, 0x15, 0x23, 0x35, 0x23, 0x15, 0x23, 0x35, 0x23, 0x15, 0x23, 0x11,
-  0x33, 0x11, 0x33, 0x11, 0x27, 0x37, 0x17, 0x35, 0x26, 0x20, 0x07, 0x15,
-  0x37, 0x17, 0x07, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x35, 0x23, 0x15,
-  0x23, 0x35, 0x23, 0x15, 0x23, 0x35, 0x23, 0x15, 0x23, 0x11, 0x27, 0x37,
-  0x35, 0x06, 0x07, 0x11, 0x23, 0x11, 0x06, 0x07, 0x10, 0x00, 0x21, 0x20,
-  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x24, 0x34, 0x36, 0x32, 0x16,
-  0x14, 0x06, 0x22, 0x13, 0x11, 0x33, 0x11, 0x13, 0x33, 0x35, 0x27, 0x17,
-  0x33, 0x35, 0x07, 0x27, 0x11, 0x15, 0x17, 0x35, 0x26, 0x01, 0x35, 0x07,
-  0x15, 0x03, 0x06, 0x07, 0x15, 0x37, 0x11, 0x35, 0x07, 0x27, 0x15, 0x01,
-  0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0x3a, 0x3d, 0x1b,
-  0x22, 0x05, 0x05, 0x3d, 0x2f, 0x3d, 0x3d, 0x3e, 0x3d, 0x3d, 0x3d, 0x3d,
-  0x51, 0x45, 0x87, 0x96, 0xfe, 0x8b, 0x96, 0x87, 0x45, 0x52, 0x3d, 0x3d,
-  0x3d, 0x3d, 0x3d, 0x3d, 0x3e, 0x2e, 0x3e, 0x05, 0x05, 0x21, 0x1c, 0x3d,
-  0x3b, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29,
-  0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x02, 0xb5, 0x44, 0x5f, 0x43, 0x43,
-  0x5f, 0x11, 0x3d, 0xf5, 0x3d, 0x3d, 0x7a, 0x2f, 0x03, 0x2c, 0x2f, 0x17,
-  0xfd, 0x47, 0x3d, 0x3e, 0x18, 0x16, 0x2e, 0x2c, 0x02, 0x02, 0xea, 0xfe,
-  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0xaa, 0x8f, 0xfe, 0x85, 0x01,
-  0xf3, 0x2c, 0x28, 0x67, 0x04, 0x09, 0xfe, 0x2d, 0x88, 0x88, 0x88, 0x88,
-  0x88, 0x88, 0x02, 0x38, 0xfe, 0xd7, 0x01, 0x10, 0x3f, 0x6f, 0x69, 0x7b,
-  0x60, 0x60, 0x7b, 0x69, 0x6f, 0x3f, 0xfe, 0xf0, 0x01, 0x29, 0xfd, 0xc8,
-  0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x01, 0xd3, 0x09, 0x04, 0x68, 0x28,
-  0x2c, 0xfe, 0x0c, 0x01, 0x7d, 0x90, 0xab, 0x01, 0x75, 0x02, 0x0f, 0xfd,
-  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x19, 0x6a, 0x4b,
-  0x4b, 0x6a, 0x4b, 0x01, 0x64, 0x02, 0x38, 0xfd, 0xc8, 0x01, 0x0f, 0xb1,
-  0x2f, 0xe0, 0x63, 0x04, 0x22, 0x01, 0x23, 0x7f, 0x24, 0x7a, 0x16, 0xfe,
-  0x6f, 0xe0, 0x2f, 0xb1, 0x01, 0xa4, 0x13, 0x17, 0x79, 0x24, 0xfe, 0xdb,
-  0x81, 0x22, 0x04, 0x63, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x0b, 0x33,
-  0x07, 0x6c, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x31,
-  0x00, 0x3d, 0x00, 0x49, 0x00, 0x55, 0x00, 0x00, 0x01, 0x21, 0x15, 0x03,
-  0x33, 0x15, 0x21, 0x35, 0x13, 0x23, 0x25, 0x21, 0x15, 0x03, 0x33, 0x15,
-  0x21, 0x35, 0x13, 0x23, 0x25, 0x21, 0x15, 0x03, 0x33, 0x15, 0x21, 0x35,
-  0x13, 0x23, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x14,
-  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x21, 0x14,
-  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
-  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x09, 0xdd,
-  0x01, 0x55, 0xdf, 0xdf, 0xfe, 0xa2, 0xe0, 0xd7, 0xfe, 0x48, 0x01, 0x55,
-  0xdf, 0xdf, 0xfe, 0xa2, 0xe0, 0xd7, 0xfe, 0x48, 0x01, 0x55, 0xdf, 0xdf,
-  0xfe, 0xa2, 0xdf, 0xd6, 0xfc, 0xe1, 0x44, 0x5f, 0x43, 0x43, 0x5f, 0x02,
-  0x10, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0,
-  0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01,
-  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
-  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
-  0xfe, 0xe4, 0xfe, 0x6d, 0x07, 0x6c, 0x68, 0xfe, 0xf4, 0x5c, 0x68, 0x01,
-  0x0c, 0x5c, 0x68, 0xfe, 0xf4, 0x5c, 0x68, 0x01, 0x0c, 0x5c, 0x68, 0xfe,
-  0xf4, 0x5c, 0x68, 0x01, 0x0c, 0xfa, 0x7f, 0x6a, 0x4b, 0x4b, 0x6a, 0x4b,
-  0x03, 0x44, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5,
-  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfe, 0x62, 0x01, 0x75, 0x02, 0x0f,
-  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74,
-  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0,
-  0xfe, 0x40, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
-  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2b, 0x00, 0x37,
-  0x00, 0x00, 0x01, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x17,
-  0x07, 0x27, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x04, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x27,
-  0x37, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x02, 0x53,
-  0x56, 0x66, 0x66, 0x56, 0x66, 0x66, 0x56, 0x66, 0x66, 0x56, 0x66, 0xfe,
-  0x59, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe,
-  0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
-  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x02, 0x42,
-  0x87, 0xbf, 0x87, 0x87, 0xbf, 0x01, 0x01, 0x55, 0x65, 0x65, 0x55, 0x66,
-  0x67, 0x55, 0x66, 0x66, 0x55, 0x67, 0x03, 0x28, 0x5f, 0x71, 0x72, 0x5f,
-  0x71, 0x71, 0x5f, 0x72, 0x71, 0x5f, 0x71, 0xaf, 0xfe, 0xc4, 0xfe, 0x43,
-  0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3,
-  0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4,
-  0x02, 0x0c, 0x1c, 0xd4, 0x96, 0x96, 0xd4, 0x96, 0x02, 0x64, 0x5f, 0x71,
-  0x72, 0x5f, 0x71, 0x71, 0x5f, 0x72, 0x71, 0x5f, 0x71, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a,
-  0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
-  0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16,
-  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
-  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
-  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
-  0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
-  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
-  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
-  0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51,
-  0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
-  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
-  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00,
-  0x00, 0x0a, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x24,
-  0x00, 0x28, 0x00, 0x2c, 0x00, 0x37, 0x00, 0x00, 0x13, 0x10, 0x00, 0x21,
-  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x35, 0x21, 0x15,
-  0x33, 0x35, 0x21, 0x15, 0x25, 0x27, 0x25, 0x17, 0x05, 0x25, 0x37, 0x05,
-  0x01, 0x21, 0x11, 0x21, 0x01, 0x21, 0x16, 0x33, 0x32, 0x37, 0x36, 0x13,
-  0x07, 0x01, 0x11, 0x27, 0x12, 0x01, 0x02, 0x27, 0x26, 0x21, 0x20, 0x07,
-  0x06, 0x03, 0x17, 0x21, 0x99, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01,
-  0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x48, 0x01,
-  0x7f, 0xc2, 0x01, 0x80, 0xfc, 0x65, 0x45, 0x01, 0x36, 0x45, 0x02, 0x3e,
-  0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc, 0x9a, 0x02, 0xce, 0xfd, 0x32, 0x02,
-  0xff, 0xfc, 0xd1, 0xb0, 0xe7, 0xe8, 0xf9, 0xb6, 0x14, 0xca, 0xfc, 0x3f,
-  0xcc, 0x14, 0x05, 0x41, 0x18, 0xab, 0xc8, 0xfe, 0xe2, 0xfe, 0xe4, 0xca,
-  0xab, 0x19, 0xca, 0x03, 0xc1, 0x02, 0xea, 0x01, 0x75, 0x02, 0x0f, 0xfd,
-  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0xba, 0x87,
-  0x87, 0x87, 0x87, 0xe6, 0x6e, 0xf1, 0x6f, 0xf0, 0xf0, 0x6f, 0xf1, 0xfc,
-  0x87, 0x01, 0x18, 0xfe, 0x61, 0x93, 0xd9, 0xc9, 0x01, 0x11, 0x9e, 0xfe,
-  0xc4, 0x01, 0x3c, 0x9e, 0xfe, 0xef, 0x01, 0xb3, 0x01, 0x02, 0xbf, 0xe0,
-  0xe0, 0xbf, 0xfe, 0xff, 0x9d, 0x00, 0x00, 0x00, 0x00, 0x09, 0x00, 0x34,
-  0xff, 0x6a, 0x07, 0x56, 0x07, 0x14, 0x00, 0x08, 0x00, 0x1d, 0x00, 0x52,
-  0x00, 0x8f, 0x00, 0x9d, 0x00, 0xab, 0x00, 0xb5, 0x00, 0xbb, 0x00, 0xc1,
-  0x00, 0x00, 0x00, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x37, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x20, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x16, 0x33, 0x32, 0x01, 0x14, 0x17, 0x25,
-  0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25,
-  0x37, 0x05, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07,
-  0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x07, 0x26,
-  0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17,
-  0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04,
-  0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x06,
-  0x07, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x26, 0x27, 0x07,
-  0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x25, 0x34, 0x2e, 0x01, 0x22, 0x0e,
-  0x01, 0x15, 0x23, 0x34, 0x36, 0x32, 0x16, 0x15, 0x21, 0x34, 0x2e, 0x01,
-  0x22, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x36, 0x32, 0x16, 0x15, 0x01, 0x26,
-  0x27, 0x06, 0x07, 0x15, 0x16, 0x33, 0x32, 0x3f, 0x01, 0x15, 0x36, 0x37,
-  0x06, 0x23, 0x05, 0x35, 0x23, 0x22, 0x27, 0x16, 0x03, 0x88, 0x75, 0x52,
-  0x38, 0x6c, 0x59, 0x5b, 0x6a, 0x38, 0x90, 0x66, 0x69, 0x8e, 0x83, 0x05,
-  0x1a, 0x31, 0xf7, 0xfe, 0xbf, 0xf8, 0x35, 0x20, 0x03, 0x86, 0x90, 0x6d,
-  0xfd, 0xa0, 0x07, 0x01, 0x2b, 0x05, 0xfe, 0xd5, 0x07, 0x0d, 0x01, 0x15,
-  0x14, 0xfe, 0xe7, 0x10, 0x14, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90,
-  0x5d, 0x17, 0x0f, 0xfe, 0xec, 0x13, 0x01, 0x10, 0x0d, 0x07, 0xfe, 0xdb,
-  0x04, 0x01, 0x26, 0x06, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda, 0x8a,
-  0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09, 0x0a,
-  0x73, 0x04, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80,
-  0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15,
-  0x04, 0x1c, 0x0b, 0x11, 0x06, 0x04, 0x5e, 0x03, 0x60, 0x08, 0x13, 0x5e,
-  0x14, 0x5a, 0x11, 0x18, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
-  0xad, 0x68, 0x1b, 0x0e, 0x55, 0x13, 0x58, 0x12, 0x08, 0x5b, 0x04, 0x02,
-  0xe0, 0x13, 0x2d, 0x3b, 0x2c, 0x13, 0x79, 0x7e, 0xb0, 0x7e, 0x01, 0x9b,
-  0x13, 0x2c, 0x3b, 0x2c, 0x13, 0x7a, 0x7e, 0xb1, 0x7e, 0xfe, 0x67, 0x20,
-  0x24, 0x18, 0x2d, 0x27, 0x21, 0x24, 0x1d, 0x7b, 0x56, 0x2e, 0x41, 0x34,
-  0xfe, 0x73, 0x13, 0x39, 0x38, 0x2e, 0x02, 0xfc, 0x2e, 0x78, 0x3d, 0x3d,
-  0x78, 0xfc, 0x25, 0x42, 0x20, 0x19, 0x44, 0x47, 0x81, 0x93, 0x8f, 0x7d,
-  0x4b, 0x53, 0x17, 0x17, 0x42, 0x01, 0xc7, 0x24, 0x62, 0x15, 0x43, 0x16,
-  0x4a, 0x41, 0x69, 0x3f, 0x6c, 0x3a, 0x31, 0xe2, 0x77, 0x84, 0x84, 0x76,
-  0xe3, 0x38, 0x35, 0x6a, 0x3f, 0x67, 0x3e, 0x4c, 0x15, 0x43, 0x15, 0x52,
-  0x34, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15,
-  0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0xbd, 0x4d, 0x45, 0x39,
-  0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61,
-  0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41,
-  0x77, 0x6a, 0x39, 0x44, 0x4d, 0x07, 0x44, 0x07, 0x56, 0x57, 0x24, 0x40,
-  0x22, 0x3c, 0x3c, 0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x40,
-  0x36, 0x20, 0x40, 0x22, 0x4f, 0x60, 0x07, 0x44, 0x51, 0x2b, 0x5a, 0x45,
-  0x45, 0x59, 0x2c, 0x8c, 0xc4, 0xc4, 0x8c, 0x2b, 0x5a, 0x45, 0x45, 0x59,
-  0x2c, 0x8c, 0xc4, 0xc4, 0x8c, 0xfe, 0x03, 0x07, 0x0b, 0x07, 0x0a, 0x91,
-  0x05, 0x04, 0x84, 0x63, 0x27, 0x46, 0x0a, 0x61, 0x61, 0x09, 0x43, 0x00,
-  0x00, 0x09, 0x00, 0x56, 0xff, 0x6a, 0x08, 0x13, 0x07, 0x14, 0x00, 0x3f,
-  0x00, 0x48, 0x00, 0x5d, 0x00, 0xa8, 0x00, 0xb6, 0x00, 0xc4, 0x00, 0xce,
-  0x00, 0xd4, 0x00, 0xda, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x2e, 0x02,
-  0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x20, 0x07, 0x26, 0x27, 0x06, 0x07,
-  0x0e, 0x03, 0x15, 0x14, 0x17, 0x36, 0x3f, 0x01, 0x07, 0x0e, 0x01, 0x23,
-  0x22, 0x27, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x20, 0x37, 0x36, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x06,
-  0x23, 0x22, 0x26, 0x2f, 0x01, 0x17, 0x16, 0x04, 0x32, 0x37, 0x17, 0x06,
-  0x23, 0x22, 0x27, 0x37, 0x17, 0x16, 0x33, 0x32, 0x37, 0x16, 0x15, 0x14,
-  0x07, 0x0e, 0x01, 0x20, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x16, 0x33,
-  0x32, 0x05, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3f, 0x01, 0x34, 0x27, 0x07,
-  0x27, 0x37, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17,
-  0x1e, 0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16,
-  0x17, 0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17,
-  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x2f, 0x01, 0x06, 0x07,
-  0x02, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x26, 0x27, 0x07, 0x06, 0x01,
-  0x34, 0x2e, 0x01, 0x22, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x36, 0x32, 0x16,
-  0x15, 0x21, 0x34, 0x2e, 0x01, 0x22, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x36,
-  0x32, 0x16, 0x15, 0x01, 0x26, 0x27, 0x06, 0x07, 0x15, 0x16, 0x33, 0x32,
-  0x3f, 0x01, 0x15, 0x36, 0x37, 0x06, 0x23, 0x05, 0x35, 0x23, 0x22, 0x27,
-  0x16, 0x06, 0xf4, 0x02, 0x09, 0x09, 0x14, 0x03, 0x18, 0x26, 0xd9, 0x8b,
-  0x68, 0xfe, 0xe7, 0x69, 0x88, 0xdc, 0x26, 0x19, 0x04, 0x13, 0x09, 0x09,
-  0x01, 0x16, 0x48, 0x7a, 0x27, 0x0f, 0x2e, 0x28, 0x2b, 0x19, 0x07, 0x0e,
-  0x01, 0x15, 0x14, 0xfe, 0xe7, 0x11, 0x13, 0x5c, 0x94, 0xa3, 0x01, 0xb8,
-  0xa4, 0x91, 0x5c, 0x18, 0x0e, 0xfe, 0xeb, 0x14, 0x01, 0x0f, 0x0f, 0x07,
-  0x19, 0x2b, 0x28, 0x2f, 0x0e, 0x2a, 0x7d, 0x49, 0xfd, 0x1b, 0x75, 0x53,
-  0x37, 0x6c, 0x58, 0x5c, 0x6a, 0x38, 0x90, 0x67, 0x68, 0x8e, 0x84, 0x05,
-  0x1b, 0x31, 0xf6, 0xfe, 0xbf, 0xf8, 0x36, 0x1f, 0x02, 0x87, 0x90, 0x6c,
-  0xfc, 0xd6, 0x21, 0x32, 0x38, 0x2f, 0x51, 0x07, 0x5c, 0x04, 0x5a, 0x05,
-  0x07, 0x10, 0x0b, 0x1d, 0x04, 0x15, 0x22, 0x0d, 0x36, 0x81, 0xe3, 0x55,
-  0x5e, 0xcb, 0x5f, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x14, 0x04, 0x1c,
-  0x0b, 0x12, 0x06, 0x04, 0x5e, 0x04, 0x5f, 0x06, 0x03, 0x51, 0x2e, 0x36,
-  0x30, 0x21, 0x27, 0x2f, 0x10, 0x0d, 0x15, 0x28, 0x68, 0xad, 0xc3, 0xfd,
-  0xfa, 0xc4, 0xad, 0x68, 0x26, 0x18, 0x0e, 0x20, 0x02, 0x9a, 0x14, 0x2b,
-  0x3c, 0x2d, 0x12, 0x7a, 0x7e, 0xb0, 0x7e, 0x01, 0x9c, 0x13, 0x2c, 0x3b,
-  0x2d, 0x12, 0x7a, 0x7e, 0xb0, 0x7e, 0xfe, 0x67, 0x20, 0x24, 0x17, 0x2d,
-  0x27, 0x21, 0x24, 0x1c, 0x7b, 0x56, 0x2f, 0x41, 0x34, 0xfe, 0x72, 0x12,
-  0x38, 0x39, 0x2f, 0x03, 0x7c, 0x28, 0x2c, 0x2e, 0x66, 0x3e, 0x76, 0x19,
-  0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72,
-  0x41, 0x65, 0x2e, 0x2a, 0x27, 0x2c, 0x19, 0x2c, 0x88, 0x33, 0x3c, 0x25,
-  0x57, 0x4c, 0x69, 0x3f, 0x6c, 0x3a, 0x31, 0xe2, 0x77, 0x84, 0x84, 0x76,
-  0xe3, 0x38, 0x35, 0x6a, 0x3f, 0x67, 0x44, 0x60, 0x28, 0x3c, 0x33, 0x88,
-  0x2c, 0x19, 0xaf, 0x2e, 0x78, 0x3d, 0x3d, 0x78, 0xfc, 0x25, 0x42, 0x20,
-  0x19, 0x44, 0x47, 0x81, 0x93, 0x8f, 0x7d, 0x4b, 0x53, 0x17, 0x17, 0x42,
-  0x41, 0x36, 0x25, 0x2c, 0x34, 0x11, 0x1d, 0x03, 0x4a, 0x07, 0x44, 0x06,
-  0x4d, 0x45, 0x39, 0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09,
-  0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75,
-  0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x44, 0x4d, 0x07, 0x44, 0x07, 0x34,
-  0x19, 0x1d, 0x11, 0x34, 0x2c, 0x25, 0x36, 0x3c, 0x33, 0x2a, 0x68, 0x62,
-  0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x5d, 0x70, 0x2d, 0x6f,
-  0x01, 0xc4, 0x2b, 0x5a, 0x45, 0x45, 0x59, 0x2c, 0x8c, 0xc4, 0xc4, 0x8c,
-  0x2b, 0x5a, 0x45, 0x45, 0x59, 0x2c, 0x8c, 0xc4, 0xc4, 0x8c, 0xfe, 0x03,
-  0x07, 0x0b, 0x07, 0x0a, 0x91, 0x05, 0x04, 0x84, 0x63, 0x27, 0x46, 0x0a,
-  0x61, 0x61, 0x09, 0x43, 0x00, 0x09, 0x00, 0x34, 0xff, 0x6a, 0x07, 0x56,
-  0x07, 0x14, 0x00, 0x08, 0x00, 0x1d, 0x00, 0x2a, 0x00, 0x5f, 0x00, 0x9c,
-  0x00, 0xaa, 0x00, 0xb4, 0x00, 0xc3, 0x00, 0xd0, 0x00, 0x00, 0x00, 0x32,
-  0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x37, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x20, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x16, 0x33, 0x32, 0x17, 0x06, 0x23, 0x22, 0x27, 0x1e, 0x01, 0x32,
-  0x36, 0x37, 0x06, 0x23, 0x22, 0x01, 0x14, 0x17, 0x25, 0x17, 0x05, 0x16,
-  0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36,
-  0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36,
-  0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22,
-  0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x07, 0x26, 0x35, 0x34, 0x3e,
-  0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17, 0x36, 0x32, 0x17,
-  0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x07,
-  0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x02, 0x07,
-  0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x26, 0x27, 0x07, 0x27, 0x37, 0x26,
-  0x27, 0x07, 0x27, 0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x37, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e,
-  0x01, 0x37, 0x26, 0x05, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x07, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x03, 0x88, 0x75, 0x52, 0x38,
-  0x6c, 0x59, 0x5b, 0x6a, 0x38, 0x90, 0x66, 0x69, 0x8e, 0x83, 0x05, 0x1a,
-  0x31, 0xf7, 0xfe, 0xbf, 0xf8, 0x35, 0x20, 0x03, 0x86, 0x90, 0x6d, 0x65,
-  0x67, 0x6b, 0x39, 0x38, 0x2f, 0xad, 0xd3, 0xaa, 0x2d, 0x41, 0x34, 0x69,
-  0xfc, 0xd6, 0x07, 0x01, 0x2b, 0x05, 0xfe, 0xd5, 0x07, 0x0d, 0x01, 0x15,
-  0x14, 0xfe, 0xe7, 0x10, 0x14, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90,
-  0x5d, 0x17, 0x0f, 0xfe, 0xec, 0x13, 0x01, 0x10, 0x0d, 0x07, 0xfe, 0xdb,
-  0x04, 0x01, 0x26, 0x06, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda, 0x8a,
-  0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09, 0x0a,
-  0x73, 0x04, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80,
-  0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15,
-  0x04, 0x1c, 0x0b, 0x11, 0x06, 0x04, 0x5e, 0x03, 0x60, 0x08, 0x13, 0x5e,
-  0x14, 0x5a, 0x11, 0x18, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
-  0xad, 0x68, 0x1b, 0x0e, 0x55, 0x13, 0x58, 0x12, 0x08, 0x5b, 0x04, 0x01,
-  0xb2, 0x59, 0x3c, 0x38, 0x54, 0x06, 0x2b, 0x44, 0x1e, 0x24, 0x3c, 0x33,
-  0x07, 0xe4, 0x21, 0x2b, 0x05, 0x26, 0x3e, 0x11, 0x13, 0x02, 0xb2, 0x07,
-  0x33, 0x3c, 0x21, 0x21, 0x45, 0x2a, 0x07, 0x2d, 0x28, 0x36, 0x3c, 0x59,
-  0x94, 0x0b, 0x18, 0x29, 0x26, 0x0e, 0x03, 0x0b, 0x0c, 0x27, 0x3a, 0x02,
-  0xfc, 0x2e, 0x78, 0x3d, 0x3d, 0x78, 0xfc, 0x25, 0x42, 0x20, 0x19, 0x44,
-  0x47, 0x81, 0x93, 0x8f, 0x7d, 0x4b, 0x53, 0x17, 0x17, 0x42, 0x68, 0x1f,
-  0x09, 0x45, 0x4c, 0x4d, 0x45, 0x0a, 0x02, 0x4e, 0x24, 0x62, 0x15, 0x43,
-  0x16, 0x4a, 0x41, 0x69, 0x3f, 0x6c, 0x3a, 0x31, 0xe2, 0x77, 0x84, 0x84,
-  0x76, 0xe3, 0x38, 0x35, 0x6a, 0x3f, 0x67, 0x3e, 0x4c, 0x15, 0x43, 0x15,
-  0x52, 0x34, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15,
-  0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0xbd, 0x4d, 0x45,
-  0x39, 0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89,
-  0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93,
-  0x41, 0x77, 0x6a, 0x39, 0x44, 0x4d, 0x07, 0x44, 0x07, 0x56, 0x57, 0x24,
-  0x40, 0x22, 0x3c, 0x3c, 0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03,
-  0x40, 0x36, 0x20, 0x40, 0x22, 0x4f, 0x60, 0x07, 0x44, 0x9f, 0x46, 0x5f,
-  0x57, 0x3b, 0x45, 0x18, 0x0b, 0x21, 0x17, 0x49, 0x2b, 0x20, 0x0d, 0x0d,
-  0x06, 0x2f, 0x21, 0x0f, 0x2d, 0x1d, 0x17, 0x21, 0x0c, 0x19, 0x43, 0x42,
-  0x2a, 0x26, 0x5f, 0x7a, 0x03, 0x14, 0x15, 0x19, 0x0c, 0x0b, 0x03, 0x35,
-  0x00, 0x06, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x11,
-  0x00, 0x19, 0x00, 0x4a, 0x00, 0x83, 0x00, 0x98, 0x00, 0xad, 0x00, 0x00,
-  0x01, 0x37, 0x16, 0x33, 0x32, 0x37, 0x16, 0x33, 0x32, 0x37, 0x17, 0x06,
-  0x23, 0x22, 0x27, 0x06, 0x23, 0x22, 0x01, 0x17, 0x06, 0x22, 0x27, 0x37,
-  0x16, 0x32, 0x25, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06,
-  0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x15,
-  0x14, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17,
-  0x16, 0x20, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37,
-  0x05, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e,
-  0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17,
-  0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07,
-  0x27, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x07, 0x27, 0x37,
-  0x26, 0x27, 0x07, 0x27, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
-  0x0f, 0x01, 0x23, 0x27, 0x26, 0x27, 0x34, 0x36, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x25, 0x32, 0x16, 0x17, 0x33, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16,
-  0x15, 0x06, 0x0f, 0x01, 0x23, 0x27, 0x26, 0x35, 0x34, 0x36, 0x02, 0x62,
-  0x53, 0x3e, 0x52, 0x34, 0x4c, 0x4b, 0x35, 0x51, 0x3f, 0x52, 0x61, 0x81,
-  0x43, 0x3d, 0x3e, 0x42, 0x82, 0x01, 0x8c, 0x38, 0x6e, 0xae, 0x6e, 0x38,
-  0x51, 0x78, 0x02, 0x75, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda,
-  0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09,
-  0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01, 0x01, 0x18,
-  0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9, 0xa3, 0x93, 0x5d, 0xfe, 0xfe,
-  0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0xfb, 0x46, 0x0f, 0x06,
-  0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4, 0x54, 0x5e,
-  0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04, 0x1c, 0x0b,
-  0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17, 0x63, 0x69,
-  0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xae, 0x6a, 0x62, 0x18, 0x62,
-  0x1b, 0x0e, 0x62, 0x09, 0x02, 0x99, 0x09, 0x34, 0x29, 0x29, 0x38, 0x38,
-  0x8f, 0x02, 0x97, 0x2c, 0x02, 0x3a, 0x2a, 0x37, 0x1f, 0x0c, 0x01, 0x7e,
-  0x28, 0x34, 0x09, 0x01, 0x0c, 0x1f, 0x37, 0x2b, 0x39, 0x01, 0x2d, 0x97,
-  0x02, 0x8f, 0x37, 0x37, 0x01, 0x8c, 0x62, 0x40, 0x2c, 0x2c, 0x40, 0x62,
-  0x64, 0x1c, 0x1c, 0x01, 0xa8, 0x78, 0x3d, 0x3d, 0x78, 0x2e, 0x38, 0x82,
-  0x74, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15,
-  0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0x2e, 0x74, 0x82, 0x2b,
-  0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e, 0x7a, 0xe7, 0x77, 0x84, 0x84, 0x77,
-  0xe7, 0x7a, 0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42, 0x3d, 0x7c, 0x8f, 0x39,
-  0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61,
-  0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41,
-  0x77, 0x6a, 0x39, 0x8f, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e,
-  0x2e, 0xfe, 0xf7, 0x8e, 0x9e, 0x9e, 0x8c, 0x01, 0x0b, 0x2e, 0x3e, 0x2e,
-  0x51, 0x57, 0x0e, 0x42, 0x01, 0x95, 0x30, 0x42, 0x3d, 0x31, 0x4a, 0x4a,
-  0xbe, 0xcf, 0x3d, 0x42, 0x2a, 0x48, 0x47, 0x1b, 0x10, 0x72, 0x42, 0x30,
-  0x10, 0x1b, 0x47, 0x48, 0x2a, 0x42, 0x3d, 0xcf, 0xbe, 0x4a, 0x4a, 0x31,
-  0x3d, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e,
-  0x07, 0x14, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x1e, 0x00, 0x28,
-  0x00, 0x37, 0x00, 0x44, 0x00, 0x75, 0x00, 0xae, 0x00, 0xb8, 0x00, 0x00,
-  0x01, 0x05, 0x07, 0x2d, 0x01, 0x17, 0x05, 0x27, 0x13, 0x17, 0x06, 0x22,
-  0x27, 0x37, 0x16, 0x32, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14,
-  0x17, 0x3e, 0x01, 0x37, 0x26, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x05, 0x36, 0x35,
-  0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22, 0x07,
-  0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x15, 0x14, 0x17, 0x25, 0x17, 0x05,
-  0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
-  0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37, 0x05, 0x26, 0x35, 0x34, 0x3e,
-  0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17, 0x36, 0x32, 0x17,
-  0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x07,
-  0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x02, 0x07, 0x06, 0x21,
-  0x20, 0x27, 0x26, 0x03, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x01,
-  0x32, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x23, 0x02, 0x8a, 0x01,
-  0x10, 0x45, 0xfe, 0xef, 0x02, 0xb5, 0x45, 0xfe, 0xef, 0x45, 0x67, 0x38,
-  0x6e, 0xae, 0x6e, 0x38, 0x51, 0x78, 0xea, 0x26, 0x49, 0x1d, 0x24, 0x3f,
-  0x31, 0x12, 0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21, 0x2b, 0x05, 0x26,
-  0x3e, 0x11, 0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c, 0x2a, 0x30, 0x13,
-  0x31, 0x3f, 0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b, 0x24, 0x0e, 0x03,
-  0x0b, 0x0c, 0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18,
-  0x26, 0xda, 0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05,
-  0x13, 0x09, 0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01,
-  0x01, 0x18, 0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9, 0xa3, 0x93, 0x5d,
-  0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0xfb, 0x46,
-  0x0f, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4,
-  0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04,
-  0x1c, 0x0b, 0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17,
-  0x63, 0x69, 0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xae, 0x6a, 0x62,
-  0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x03, 0x8a, 0xb6, 0x80, 0x24, 0x19,
-  0x68, 0x1f, 0x30, 0xa3, 0xe9, 0x05, 0x67, 0xd4, 0x6f, 0xd5, 0x6e, 0x6e,
-  0xd5, 0x6f, 0xfe, 0x3d, 0x78, 0x3d, 0x3d, 0x78, 0x2e, 0x01, 0x06, 0x4c,
-  0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47, 0x30, 0x2c, 0x61, 0x26, 0x30, 0x24,
-  0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11, 0x1d, 0x43, 0x61, 0x2c, 0x30, 0x47,
-  0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04, 0x03, 0x16, 0x18, 0x1c, 0x0e, 0x0c,
-  0x03, 0x3b, 0xa7, 0x82, 0x74, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7,
-  0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65,
-  0x2e, 0x74, 0x82, 0x2b, 0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e, 0x7a, 0xe7,
-  0x77, 0x84, 0x84, 0x77, 0xe7, 0x7a, 0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42,
-  0x3d, 0x7c, 0x8f, 0x39, 0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a,
-  0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c,
-  0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x8f, 0x7c, 0x0f, 0x42, 0x0e,
-  0x51, 0x57, 0x2e, 0x3e, 0x2e, 0xfe, 0xf7, 0x8e, 0x9e, 0x9e, 0x8c, 0x01,
-  0x0b, 0x2e, 0x3e, 0x2e, 0x51, 0x57, 0x0e, 0x42, 0xfe, 0x7f, 0x8e, 0x28,
-  0x2b, 0x48, 0x36, 0x35, 0xb5, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x36,
-  0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x0e, 0x00, 0x18, 0x00, 0x27,
-  0x00, 0x34, 0x00, 0x69, 0x00, 0xa8, 0x00, 0xb5, 0x00, 0xbe, 0x00, 0x00,
-  0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e, 0x01, 0x37,
-  0x26, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x23, 0x22, 0x06, 0x05, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27,
-  0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07,
-  0x0e, 0x03, 0x15, 0x14, 0x17, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17,
-  0x25, 0x17, 0x05, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3f, 0x01,
-  0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37, 0x00, 0x32, 0x17, 0x3e, 0x01,
-  0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x06, 0x15, 0x06,
-  0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x07, 0x02, 0x07,
-  0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x27, 0x07, 0x27, 0x37, 0x26, 0x27,
-  0x07, 0x27, 0x37, 0x26, 0x27, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f,
-  0x01, 0x17, 0x1e, 0x01, 0x17, 0x13, 0x37, 0x27, 0x37, 0x17, 0x15, 0x07,
-  0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x02, 0x32, 0x37, 0x17, 0x06, 0x23,
-  0x22, 0x27, 0x37, 0x03, 0x14, 0x26, 0x49, 0x1d, 0x24, 0x3f, 0x31, 0x12,
-  0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21, 0x2b, 0x05, 0x26, 0x3e, 0x11,
-  0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c, 0x2a, 0x30, 0x13, 0x31, 0x3f,
-  0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b, 0x24, 0x0e, 0x03, 0x0b, 0x0c,
-  0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda,
-  0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09,
-  0x0a, 0x02, 0x07, 0x08, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01,
-  0x01, 0x18, 0xfe, 0xfd, 0x02, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90,
-  0x5d, 0x03, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09,
-  0xfe, 0x0a, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04,
-  0x1c, 0x0b, 0x11, 0x06, 0x01, 0x02, 0x0c, 0x61, 0x09, 0x62, 0x0d, 0x1d,
-  0x63, 0x17, 0x63, 0x03, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
-  0xad, 0x68, 0x03, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x61, 0x0c,
-  0x03, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4,
-  0x54, 0x93, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48,
-  0x0a, 0x77, 0x51, 0x38, 0x6b, 0x5a, 0x5b, 0x6a, 0x38, 0x03, 0xa8, 0x4c,
-  0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47, 0x30, 0x2c, 0x61, 0x26, 0x30, 0x24,
-  0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11, 0x1d, 0x43, 0x61, 0x2c, 0x30, 0x47,
-  0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04, 0x03, 0x16, 0x18, 0x1c, 0x0e, 0x0c,
-  0x03, 0x3b, 0xa7, 0x83, 0x73, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7,
-  0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65,
-  0x2e, 0x0f, 0x24, 0x82, 0x41, 0x2b, 0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e,
-  0x7a, 0x05, 0xe2, 0x77, 0x84, 0x84, 0x76, 0xe3, 0x05, 0x7a, 0x3e, 0x79,
-  0x39, 0x4c, 0x2c, 0x42, 0x03, 0x13, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a,
-  0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x07, 0x1c, 0x07, 0x8a,
-  0x57, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e, 0x08, 0xfe, 0xfd,
-  0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x08, 0x2e, 0x3e, 0x2e, 0x51, 0x57,
-  0x0e, 0x42, 0x0f, 0x60, 0x81, 0x2a, 0x39, 0x6a, 0x77, 0x41, 0x93, 0x18,
-  0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0xfb, 0x3a, 0x3d, 0x4e, 0x77,
-  0x8d, 0x59, 0x2e, 0x2d, 0x59, 0x8d, 0x77, 0x4e, 0x3d, 0x01, 0xda, 0x2e,
-  0x78, 0x3d, 0x3d, 0x78, 0x00, 0x0b, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e,
-  0x07, 0x14, 0x00, 0x0e, 0x00, 0x18, 0x00, 0x27, 0x00, 0x34, 0x00, 0x65,
-  0x00, 0x9e, 0x00, 0xa6, 0x00, 0xaf, 0x00, 0xb8, 0x00, 0xbc, 0x00, 0xc0,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e,
-  0x01, 0x37, 0x26, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x05, 0x36, 0x35, 0x34, 0x2e,
-  0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27,
-  0x06, 0x07, 0x0e, 0x03, 0x15, 0x14, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17,
-  0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x25, 0x37,
-  0x05, 0x36, 0x37, 0x25, 0x37, 0x05, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37,
-  0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01,
-  0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07,
-  0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27,
-  0x26, 0x03, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x01, 0x36, 0x32,
-  0x17, 0x07, 0x26, 0x22, 0x07, 0x25, 0x36, 0x20, 0x17, 0x07, 0x26, 0x23,
-  0x22, 0x07, 0x12, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x37, 0x01,
-  0x17, 0x05, 0x27, 0x25, 0x05, 0x07, 0x25, 0x03, 0x14, 0x26, 0x49, 0x1d,
-  0x24, 0x3f, 0x31, 0x12, 0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21, 0x2b,
-  0x05, 0x26, 0x3e, 0x11, 0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c, 0x2a,
-  0x30, 0x13, 0x31, 0x3f, 0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b, 0x24,
-  0x0e, 0x03, 0x0b, 0x0c, 0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09, 0x14,
-  0x04, 0x18, 0x26, 0xda, 0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26,
-  0x18, 0x05, 0x13, 0x09, 0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c,
-  0x15, 0x01, 0x01, 0x18, 0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9, 0xa3,
-  0x93, 0x5d, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09,
-  0xfb, 0x46, 0x0f, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36,
-  0x80, 0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22,
-  0x15, 0x04, 0x1c, 0x0b, 0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d,
-  0x63, 0x17, 0x63, 0x69, 0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xae,
-  0x6a, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x02, 0xf3, 0x3f, 0xb0,
-  0x3f, 0x56, 0x1b, 0x4c, 0x1b, 0xfe, 0xb5, 0xa3, 0x01, 0xd2, 0xa3, 0x56,
-  0x80, 0xb6, 0xb4, 0x81, 0xfb, 0x77, 0x51, 0x38, 0x6b, 0x5a, 0x5b, 0x6a,
-  0x38, 0x01, 0xc4, 0x45, 0xfe, 0xef, 0x45, 0xfe, 0xa2, 0x01, 0x10, 0x45,
-  0xfe, 0xef, 0x03, 0xa8, 0x4c, 0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47, 0x30,
-  0x2c, 0x61, 0x26, 0x30, 0x24, 0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11, 0x1d,
-  0x43, 0x61, 0x2c, 0x30, 0x47, 0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04, 0x03,
-  0x16, 0x18, 0x1c, 0x0e, 0x0c, 0x03, 0x3b, 0xa7, 0x82, 0x74, 0x2e, 0x66,
-  0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7,
-  0xa1, 0x1b, 0x72, 0x41, 0x65, 0x2e, 0x74, 0x82, 0x2b, 0x42, 0x2c, 0x45,
-  0x40, 0x79, 0x3e, 0x7a, 0xe7, 0x77, 0x84, 0x84, 0x77, 0xe7, 0x7a, 0x3e,
-  0x79, 0x39, 0x4c, 0x2c, 0x42, 0x3d, 0x7c, 0x8f, 0x39, 0x6a, 0x77, 0x41,
-  0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61,
-  0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39,
-  0x8f, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e, 0xfe, 0xf7,
-  0x8e, 0x9e, 0x9e, 0x8c, 0x01, 0x0b, 0x2e, 0x3e, 0x2e, 0x51, 0x57, 0x0e,
-  0x42, 0xfe, 0x13, 0x63, 0x63, 0x5f, 0x3c, 0x3c, 0xf5, 0xb5, 0xb5, 0x60,
-  0x8e, 0x8e, 0x01, 0xfa, 0x2e, 0x78, 0x3d, 0x3d, 0x78, 0x02, 0x3d, 0x6e,
-  0xd5, 0x6f, 0xd4, 0xd4, 0x6f, 0xd5, 0x00, 0x00, 0x00, 0x05, 0x00, 0x36,
-  0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x34,
-  0x00, 0x64, 0x00, 0x8e, 0x00, 0x00, 0x01, 0x14, 0x06, 0x07, 0x17, 0x16,
-  0x14, 0x06, 0x22, 0x26, 0x35, 0x34, 0x35, 0x06, 0x22, 0x27, 0x37, 0x16,
-  0x32, 0x37, 0x17, 0x36, 0x3f, 0x01, 0x2e, 0x01, 0x35, 0x33, 0x14, 0x16,
-  0x32, 0x36, 0x35, 0x21, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16,
-  0x32, 0x36, 0x35, 0x03, 0x36, 0x20, 0x17, 0x07, 0x26, 0x20, 0x07, 0x01,
-  0x26, 0x10, 0x36, 0x3f, 0x01, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17,
-  0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x1f, 0x01, 0x1e,
-  0x01, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x02,
-  0x00, 0x20, 0x00, 0x03, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x05,
-  0x12, 0x21, 0x32, 0x24, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37,
-  0x05, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x06, 0x07, 0x26, 0x20,
-  0x07, 0x26, 0x27, 0x06, 0x0f, 0x01, 0x06, 0x15, 0x14, 0x17, 0x25, 0x17,
-  0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0xa2, 0x73, 0x46, 0x1d, 0x18, 0x30,
-  0x45, 0x30, 0x63, 0xaf, 0x6a, 0x38, 0x52, 0x77, 0x51, 0x2e, 0x07, 0x0d,
-  0x1d, 0x45, 0x74, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0, 0x7e,
-  0x79, 0x37, 0x4c, 0x37, 0xdf, 0xa3, 0x01, 0xd2, 0xa3, 0x56, 0x80, 0xfe,
-  0x96, 0x81, 0xfe, 0x0c, 0x0f, 0x1d, 0x13, 0x12, 0x15, 0x22, 0x0e, 0x36,
-  0x80, 0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22,
-  0x15, 0x12, 0x27, 0x09, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17,
-  0x63, 0x69, 0xfe, 0x8d, 0xfd, 0xf9, 0xfe, 0x8f, 0x6a, 0x62, 0x18, 0x62,
-  0x1b, 0x0e, 0x62, 0x09, 0x01, 0x1b, 0xc2, 0x01, 0xae, 0xdd, 0x01, 0x36,
-  0x5d, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0x01,
-  0x21, 0x10, 0x18, 0x1b, 0x0e, 0x27, 0xda, 0x8a, 0x69, 0xfe, 0xe8, 0x69,
-  0x89, 0xdb, 0x26, 0x18, 0x0f, 0x1c, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf,
-  0x0c, 0x15, 0x01, 0x01, 0x18, 0x04, 0x88, 0x8b, 0xb4, 0x0e, 0x3f, 0x35,
-  0x4f, 0x36, 0x36, 0x2c, 0x03, 0x03, 0x35, 0x3d, 0x78, 0x2e, 0x2e, 0x63,
-  0x18, 0x1d, 0x3f, 0x0e, 0xb4, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5,
-  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfc, 0xda, 0xb5, 0xb5, 0x60, 0x8e,
-  0x8e, 0x01, 0xc6, 0x7c, 0x01, 0x06, 0xc4, 0x6a, 0x61, 0x75, 0x8c, 0x3a,
-  0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c,
-  0x75, 0x61, 0xcc, 0xa0, 0xc8, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e,
-  0x3e, 0x2e, 0xfe, 0xf7, 0xfe, 0xd4, 0x01, 0x2a, 0x01, 0x0b, 0x2e, 0x3e,
-  0x2e, 0x51, 0x57, 0x0e, 0x42, 0xe6, 0xfe, 0x1e, 0xfb, 0xe7, 0x7a, 0x3e,
-  0x79, 0x39, 0x4c, 0x2c, 0x42, 0x2b, 0x82, 0x51, 0x88, 0x8d, 0xae, 0x62,
-  0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x54, 0xa8, 0x6e,
-  0x6b, 0x82, 0x2b, 0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e, 0x00, 0x00, 0x00,
-  0x00, 0x06, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x34,
-  0x00, 0x73, 0x00, 0x7b, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0x00,
-  0x01, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26,
-  0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x15, 0x14, 0x17,
-  0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x17, 0x16,
-  0x17, 0x16, 0x20, 0x37, 0x36, 0x3f, 0x01, 0x25, 0x37, 0x05, 0x36, 0x37,
-  0x25, 0x37, 0x00, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17,
-  0x1e, 0x04, 0x15, 0x14, 0x06, 0x15, 0x06, 0x07, 0x17, 0x07, 0x27, 0x06,
-  0x07, 0x17, 0x07, 0x27, 0x07, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26,
-  0x03, 0x27, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x37, 0x26, 0x27,
-  0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17,
-  0x03, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x05, 0x21, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x00, 0x0b, 0x01, 0x37, 0x13, 0x05, 0x27, 0x13, 0x17,
-  0x06, 0x73, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda, 0x8a, 0x69,
-  0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09, 0x0a, 0x02,
-  0x07, 0x08, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01, 0x01, 0x18,
-  0xfe, 0xfd, 0x02, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90, 0x5d, 0x03,
-  0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0xfe, 0x0a,
-  0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04, 0x1c, 0x0b,
-  0x11, 0x06, 0x01, 0x02, 0x0c, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17,
-  0x63, 0x03, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xad, 0x68,
-  0x03, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x61, 0x0c, 0x03, 0x06,
-  0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4, 0x54, 0x79,
-  0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e, 0x02, 0xec, 0xfc,
-  0x74, 0x84, 0x84, 0xbd, 0xbc, 0x01, 0x0b, 0x86, 0xf3, 0x55, 0xf3, 0xfd,
-  0x2c, 0x56, 0xf3, 0x56, 0x02, 0xda, 0x83, 0x73, 0x2e, 0x66, 0x3e, 0x76,
-  0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b,
-  0x72, 0x41, 0x65, 0x2e, 0x0f, 0x24, 0x82, 0x41, 0x2b, 0x42, 0x2c, 0x45,
-  0x40, 0x79, 0x3e, 0x7a, 0x05, 0xe2, 0x77, 0x84, 0x84, 0x76, 0xe3, 0x05,
-  0x7a, 0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42, 0x03, 0x13, 0x0d, 0x61, 0x89,
-  0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x07,
-  0x1c, 0x07, 0x8a, 0x57, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e,
-  0x08, 0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x08, 0x2e, 0x3e,
-  0x2e, 0x51, 0x57, 0x0e, 0x42, 0x0f, 0x60, 0x81, 0x2a, 0x39, 0x6a, 0x77,
-  0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0xfb, 0x47,
-  0x61, 0x4b, 0x74, 0x75, 0x4b, 0xe7, 0xe7, 0xa4, 0xa3, 0xfe, 0xba, 0x01,
-  0x7e, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x5f, 0x5f, 0x01, 0x0e, 0x5f, 0x00,
-  0x00, 0x01, 0xff, 0xc0, 0x04, 0x9a, 0x00, 0xb4, 0x06, 0x12, 0x00, 0x03,
-  0x00, 0x00, 0x11, 0x33, 0x03, 0x23, 0xb3, 0x69, 0x8a, 0x06, 0x12, 0xfe,
-  0x88, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x27, 0x05, 0x0e, 0xff, 0x3f,
-  0x05, 0xd9, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23,
-  0x25, 0x33, 0x15, 0x23, 0xfe, 0x88, 0xb6, 0xb6, 0xfe, 0xa0, 0xb7, 0xb7,
-  0x05, 0xd9, 0xcb, 0xcb, 0xcb, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xb4,
-  0x04, 0xee, 0xff, 0x0c, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33,
-  0x03, 0x23, 0xfe, 0x65, 0xa6, 0xcd, 0x8a, 0x05, 0xf6, 0xfe, 0xf8, 0x00,
-  0x00, 0x01, 0xfd, 0x0a, 0x05, 0x0e, 0xff, 0x5d, 0x05, 0xe9, 0x00, 0x1d,
-  0x00, 0x00, 0x01, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x23,
-  0x34, 0x36, 0x33, 0x32, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x36,
-  0x3d, 0x01, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x26, 0xfe, 0x30, 0x34, 0x16,
-  0x1c, 0x0b, 0x20, 0x24, 0x71, 0x5d, 0x4d, 0x21, 0x37, 0x2b, 0x33, 0x15,
-  0x1e, 0x0e, 0x1d, 0x24, 0x70, 0x02, 0x5c, 0x4c, 0x1e, 0x36, 0x05, 0x39,
-  0x21, 0x0e, 0x0b, 0x32, 0x2d, 0x06, 0x65, 0x76, 0x10, 0x1b, 0x1e, 0x0d,
-  0x0c, 0x33, 0x29, 0x06, 0x64, 0x77, 0x10, 0x00, 0x00, 0x01, 0xfd, 0x57,
-  0x04, 0xee, 0xfe, 0xb1, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x01, 0x13,
-  0x23, 0x03, 0xfe, 0x00, 0xb0, 0x89, 0xcf, 0x05, 0xf6, 0xfe, 0xf8, 0x01,
-  0x08, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x20, 0x04, 0xee, 0xff, 0x46,
-  0x05, 0xf8, 0x00, 0x06, 0x00, 0x00, 0x01, 0x33, 0x13, 0x23, 0x27, 0x07,
-  0x23, 0xfd, 0xdf, 0xa9, 0xbe, 0x7d, 0x96, 0x95, 0x7d, 0x05, 0xf8, 0xfe,
-  0xf6, 0xb2, 0xb2, 0x00, 0x00, 0x01, 0xfd, 0x20, 0x04, 0xee, 0xff, 0x46,
-  0x05, 0xf8, 0x00, 0x06, 0x00, 0x00, 0x01, 0x03, 0x33, 0x17, 0x37, 0x33,
-  0x03, 0xfd, 0xdf, 0xbe, 0x7d, 0x95, 0x96, 0x7d, 0xbe, 0x04, 0xee, 0x01,
-  0x0a, 0xb2, 0xb2, 0xfe, 0xf6, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x19,
-  0x05, 0x06, 0xff, 0x4d, 0x05, 0xf8, 0x00, 0x0d, 0x00, 0x00, 0x03, 0x23,
-  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x33, 0x32, 0x16,
-  0xb3, 0x6a, 0x0c, 0x59, 0x4b, 0x4a, 0x57, 0x0e, 0x6a, 0x08, 0x90, 0x81,
-  0x82, 0x8f, 0x05, 0x06, 0x36, 0x39, 0x37, 0x38, 0x77, 0x7b, 0x7a, 0x00,
-  0x00, 0x01, 0xfd, 0x19, 0x05, 0x06, 0xff, 0x4d, 0x05, 0xf8, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0x33, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x33, 0x0e,
-  0x01, 0x23, 0x22, 0x26, 0xfd, 0x1a, 0x6a, 0x0b, 0x59, 0x4b, 0x4a, 0x57,
-  0x0f, 0x6a, 0x09, 0x90, 0x81, 0x81, 0x90, 0x05, 0xf8, 0x36, 0x39, 0x37,
-  0x38, 0x77, 0x7b, 0x7a, 0x00, 0x01, 0xfd, 0xd7, 0x05, 0x0e, 0xfe, 0x8f,
-  0x05, 0xdb, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0xfd, 0xd7,
-  0xb8, 0xb8, 0x05, 0xdb, 0xcd, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x35,
-  0x04, 0xee, 0xff, 0xba, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x03, 0x33, 0x03, 0x23, 0x03, 0x33, 0x03, 0x23, 0xed, 0xa7, 0xcd, 0x8a,
-  0x7d, 0xa6, 0xcd, 0x8a, 0x05, 0xf6, 0xfe, 0xf8, 0x01, 0x08, 0xfe, 0xf8,
-  0x00, 0x02, 0xfc, 0xac, 0x04, 0xee, 0xff, 0x31, 0x05, 0xf6, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x00, 0x01, 0x13, 0x23, 0x03, 0x21, 0x13, 0x23, 0x03,
-  0xfd, 0x53, 0xb1, 0x8a, 0xcd, 0x01, 0xd4, 0xb0, 0x8a, 0xcd, 0x05, 0xf6,
-  0xfe, 0xf8, 0x01, 0x08, 0xfe, 0xf8, 0x01, 0x08, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x87, 0x00, 0x96, 0x00, 0x03, 0x00, 0x00, 0x35, 0x33,
-  0x15, 0x23, 0x87, 0x87, 0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
-  0x00, 0x00, 0x01, 0x68, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x37, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0xe1, 0x87, 0x87, 0xe1,
-  0x87, 0x87, 0x96, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
-  0x00, 0x00, 0x01, 0x68, 0x01, 0x90, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x70, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01,
-  0x90, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
-  0xff, 0x06, 0x01, 0x68, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x17, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x70, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x64,
-  0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
-  0xff, 0x06, 0x00, 0x87, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x15, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x87, 0x87, 0x87, 0x87,
-  0x64, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00,
-  0xff, 0x06, 0x01, 0x68, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x00, 0x17, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23,
-  0x07, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0xe1, 0x87, 0x87, 0x87,
-  0x87, 0xe1, 0x87, 0x87, 0x87, 0x87, 0x64, 0x96, 0x01, 0x90, 0x96, 0x64,
-  0x96, 0x01, 0x90, 0x96, 0x00, 0x01, 0x00, 0x75, 0xff, 0xec, 0x07, 0x24,
-  0x02, 0x9d, 0x00, 0x26, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x24, 0x03, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x33, 0x16, 0x06, 0x3e, 0x3e,
-  0x39, 0x39, 0x36, 0x5c, 0x68, 0x40, 0x48, 0x16, 0x8b, 0xd2, 0xe9, 0xbe,
-  0xb0, 0x70, 0xfe, 0xd8, 0x01, 0x01, 0x3a, 0xa5, 0x3a, 0xb7, 0x5d, 0x88,
-  0xea, 0xab, 0xb3, 0x6f, 0x35, 0x1a, 0xa5, 0x12, 0x01, 0xf8, 0xd0, 0x3b,
-  0x35, 0xb8, 0x49, 0x53, 0x42, 0x83, 0x35, 0x3a, 0x26, 0x65, 0x01, 0x08,
-  0x8a, 0x5c, 0x5e, 0x88, 0x7d, 0x43, 0x22, 0x02, 0x37, 0x3a, 0x6d, 0x34,
-  0x77, 0x3e, 0x37, 0x4b, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x01, 0x60,
-  0x02, 0x58, 0x00, 0x0d, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x01, 0x0d, 0x41, 0x8d,
-  0x51, 0x20, 0x59, 0x27, 0x2c, 0xa6, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a,
-  0xd9, 0xd9, 0xbb, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3f,
-  0x02, 0x58, 0x00, 0x14, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x01, 0x0d, 0x45, 0x89, 0x51, 0x20, 0x59, 0x27, 0x2c,
-  0xa6, 0x2c, 0x28, 0x59, 0x31, 0x63, 0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31,
-  0x6a, 0xd9, 0xd9, 0x6a, 0x31, 0x2c, 0xb8, 0x00, 0x00, 0x02, 0x00, 0x75,
-  0xff, 0xa5, 0x07, 0x86, 0x03, 0x11, 0x00, 0x2c, 0x00, 0x3e, 0x00, 0x00,
-  0x25, 0x06, 0x07, 0x06, 0x23, 0x24, 0x27, 0x24, 0x03, 0x26, 0x37, 0x33,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x21, 0x32, 0x25, 0x37, 0x26, 0x27, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x05, 0xd2, 0x5d, 0x63, 0xfc, 0xf5, 0xfe, 0xed, 0x70,
-  0xfe, 0xd8, 0x01, 0x01, 0x3a, 0xa5, 0x3a, 0xb7, 0x48, 0x01, 0x0e, 0xd0,
-  0x01, 0x01, 0x19, 0x1f, 0x1a, 0x49, 0x03, 0x14, 0xa9, 0x34, 0x2f, 0x4a,
-  0x49, 0x7b, 0x10, 0x04, 0x48, 0x08, 0x06, 0xed, 0xf1, 0x5f, 0x64, 0x5e,
-  0x04, 0x0d, 0x2f, 0x1e, 0x24, 0x16, 0x14, 0x37, 0x11, 0x05, 0x25, 0x2c,
-  0x24, 0x2b, 0x18, 0x3c, 0x01, 0x27, 0x67, 0x01, 0x06, 0x8a, 0x5c, 0x5e,
-  0x88, 0x73, 0x4d, 0x1f, 0x36, 0x04, 0x1b, 0x2c, 0x7c, 0x79, 0x1f, 0x24,
-  0x9b, 0x4b, 0x17, 0x32, 0x53, 0x96, 0x25, 0x1e, 0x90, 0x6a, 0x01, 0xb8,
-  0xdf, 0x41, 0x7a, 0x14, 0x1b, 0x47, 0x27, 0x19, 0x0a, 0x19, 0x3c, 0x13,
-  0x12, 0x38, 0x42, 0x4e, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x02, 0xec,
-  0x03, 0xd9, 0x00, 0x0f, 0x00, 0x30, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x07, 0x06, 0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x33, 0x32,
-  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21, 0x02, 0x1a, 0x25,
-  0x3b, 0x1c, 0x28, 0x2f, 0x24, 0x24, 0x01, 0x32, 0x24, 0x26, 0x41, 0xfd,
-  0xe9, 0xd9, 0x4b, 0x88, 0x48, 0x36, 0x1b, 0x0e, 0x39, 0x57, 0x75, 0x46,
-  0x58, 0x07, 0x14, 0x87, 0x47, 0x44, 0x51, 0x3b, 0x57, 0x29, 0x15, 0x46,
-  0x43, 0x6f, 0x63, 0x82, 0xfe, 0xdf, 0x02, 0x19, 0x2b, 0x4d, 0x3b, 0x33,
-  0x19, 0x01, 0x01, 0x2a, 0x29, 0x33, 0x50, 0x26, 0x19, 0xfe, 0xb7, 0x17,
-  0x0c, 0x5d, 0x30, 0x32, 0x37, 0x02, 0x02, 0x45, 0x57, 0x81, 0x34, 0x2c,
-  0x94, 0x45, 0x24, 0x32, 0x48, 0x66, 0x33, 0x8c, 0xd0, 0x8f, 0x88, 0x2c,
-  0x27, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xb7,
-  0x03, 0x08, 0x00, 0x21, 0x00, 0x35, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16,
-  0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
-  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x07, 0x22, 0x07, 0x06, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
-  0x27, 0x26, 0x02, 0x29, 0xa4, 0x16, 0x07, 0x13, 0x1a, 0x20, 0x23, 0x84,
-  0x72, 0xc3, 0x7a, 0xa7, 0xa6, 0x7b, 0xc3, 0x72, 0x85, 0x23, 0x1a, 0x21,
-  0x13, 0x08, 0x14, 0xa7, 0x1b, 0x3a, 0x39, 0x39, 0x0d, 0x11, 0x32, 0x16,
-  0x08, 0x15, 0x1c, 0x3d, 0x39, 0x20, 0x17, 0x0a, 0x15, 0x33, 0x11, 0x02,
-  0xfa, 0x50, 0x96, 0x32, 0x2a, 0x49, 0x31, 0x43, 0x32, 0x11, 0xb8, 0x39,
-  0x39, 0xb8, 0x11, 0x28, 0x4d, 0x2e, 0x4c, 0x2c, 0x30, 0x8f, 0x57, 0x0e,
-  0xb8, 0x0a, 0x20, 0x35, 0x15, 0x1d, 0x2b, 0x35, 0x44, 0x16, 0x15, 0x45,
-  0x32, 0x2e, 0x18, 0x1a, 0x34, 0x21, 0x0a, 0x00, 0x00, 0x02, 0x00, 0x60,
-  0xfe, 0x0c, 0x06, 0x14, 0x02, 0xe4, 0x00, 0x2e, 0x00, 0x40, 0x00, 0x00,
-  0x25, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x2b,
-  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x27, 0x24, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x13,
-  0x36, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x17, 0x16, 0x04, 0x3f, 0x3b, 0x2a, 0x6c, 0x34, 0x84,
-  0x05, 0x24, 0x85, 0x24, 0x4f, 0x65, 0x32, 0x59, 0x2d, 0x12, 0x06, 0x17,
-  0x03, 0xed, 0xf1, 0x2b, 0x28, 0x38, 0x72, 0x8f, 0x9e, 0xb8, 0xfe, 0xb3,
-  0x55, 0x3e, 0x38, 0xa6, 0x38, 0x18, 0x36, 0xec, 0x7e, 0x87, 0xc0, 0x61,
-  0x04, 0x14, 0x11, 0x2b, 0x1e, 0x23, 0x1f, 0x13, 0x2e, 0x13, 0x09, 0x34,
-  0x44, 0x5a, 0x2a, 0x0a, 0x05, 0x0d, 0x23, 0x2b, 0x6d, 0xb9, 0x3d, 0x1a,
-  0xa5, 0x45, 0x13, 0x32, 0x58, 0x91, 0x3a, 0xd6, 0x01, 0xb8, 0x7a, 0x46,
-  0x91, 0x4e, 0x56, 0x01, 0x02, 0xbe, 0x8a, 0x7d, 0xa6, 0x60, 0x6b, 0x9b,
-  0x4c, 0x3a, 0x82, 0x44, 0x62, 0x01, 0x5a, 0x7a, 0x57, 0x4b, 0x23, 0x19,
-  0x0a, 0x1b, 0x3a, 0x1e, 0x19, 0x3c, 0x2c, 0x3b, 0x14, 0x09, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0xec, 0x03, 0xd9, 0x10, 0x06,
-  0x11, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x03, 0xb7,
-  0x03, 0x08, 0x10, 0x06, 0x11, 0x01, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x01, 0x60, 0x03, 0xe8, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0x00, 0x02, 0x00, 0x00,
-  0x00, 0x00, 0x01, 0x8b, 0x01, 0xb7, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
-  0x25, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e,
-  0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17,
-  0x01, 0x1c, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38,
-  0x3a, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0xdc, 0x28, 0x1c, 0x1d,
-  0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40,
-  0xb8, 0x40, 0x3f, 0x3f, 0xff, 0xff, 0x00, 0x75, 0xfe, 0x90, 0x07, 0x24,
-  0x03, 0x20, 0x10, 0x27, 0x10, 0xf7, 0x02, 0x76, 0x02, 0x8a, 0x10, 0x27,
-  0x11, 0x07, 0x02, 0x65, 0xfe, 0x90, 0x10, 0x06, 0x10, 0xfc, 0x00, 0x00,
-  0xff, 0xff, 0xff, 0xee, 0xfe, 0xf4, 0x01, 0xd3, 0x03, 0xe8, 0x10, 0x26,
-  0x10, 0xfd, 0x00, 0x00, 0x10, 0x27, 0x10, 0xf7, 0x00, 0x59, 0x03, 0x52,
-  0x10, 0x07, 0x11, 0x07, 0x00, 0x48, 0xfe, 0xf4, 0xff, 0xff, 0xff, 0xee,
-  0xfe, 0xf4, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00,
-  0x10, 0x27, 0x10, 0xf7, 0x00, 0x59, 0x03, 0x52, 0x10, 0x07, 0x11, 0x07,
-  0x00, 0x48, 0xfe, 0xf4, 0xff, 0xff, 0x00, 0x75, 0xff, 0xec, 0x07, 0x24,
-  0x03, 0xb6, 0x10, 0x27, 0x10, 0xf9, 0x02, 0x76, 0x03, 0x20, 0x10, 0x06,
-  0x10, 0xfc, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x01, 0xc2,
-  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf9,
-  0x00, 0x59, 0x04, 0x4c, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3f,
-  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf9,
-  0x00, 0x59, 0x04, 0x4c, 0x00, 0x02, 0x00, 0x8d, 0xfe, 0x0c, 0x04, 0xb8,
-  0x05, 0xaf, 0x00, 0x30, 0x00, 0x49, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x21, 0x32, 0x37, 0x15, 0x06, 0x23, 0x20, 0x27, 0x26, 0x35, 0x10,
-  0x37, 0x36, 0x37, 0x22, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33,
-  0x20, 0x17, 0x15, 0x22, 0x07, 0x17, 0x16, 0x17, 0x16, 0x01, 0x37, 0x26,
-  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x15, 0x05, 0x04, 0x94,
-  0x24, 0x2c, 0x74, 0x6f, 0x4a, 0x37, 0x05, 0x42, 0x67, 0x58, 0xc9, 0x42,
-  0x74, 0x01, 0x29, 0xad, 0xbf, 0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76, 0xbf,
-  0x56, 0x7b, 0x0a, 0x0c, 0x56, 0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01, 0x08,
-  0xb4, 0x62, 0x1c, 0x1a, 0x2e, 0x41, 0x51, 0xfd, 0x62, 0x46, 0x28, 0x0e,
-  0x0e, 0x32, 0x34, 0x53, 0x38, 0x2f, 0x2e, 0x39, 0x3b, 0x10, 0x1a, 0x55,
-  0x1d, 0x6c, 0xfe, 0xcc, 0xb8, 0xb8, 0x96, 0x64, 0x9c, 0x0f, 0xb2, 0x18,
-  0x50, 0xb7, 0xfc, 0x89, 0x5e, 0xa4, 0x76, 0xb8, 0x63, 0xc2, 0x96, 0xe0,
-  0x01, 0x02, 0xdf, 0x65, 0x34, 0x13, 0x13, 0x29, 0xb8, 0x3f, 0x36, 0x9a,
-  0x0d, 0x5b, 0xa0, 0x5f, 0x77, 0x03, 0xa3, 0x12, 0x14, 0x24, 0x25, 0x2d,
-  0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12, 0x20, 0x1a, 0x4d, 0x1b, 0x0a,
-  0x1d, 0x66, 0x4d, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xed,
-  0x05, 0x4b, 0x00, 0x1e, 0x00, 0x37, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
-  0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x15, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x01, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x33, 0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x37, 0x15, 0x05, 0x02, 0xfe, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91,
-  0x41, 0x44, 0x91, 0x9b, 0xe8, 0xc6, 0x44, 0x4f, 0x96, 0x42, 0x83, 0x43,
-  0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55, 0xfe, 0xda, 0x46,
-  0x28, 0x0e, 0x0f, 0x33, 0x34, 0x53, 0x38, 0x2e, 0x2c, 0x3a, 0x3c, 0x0f,
-  0x1a, 0x55, 0x1d, 0x6c, 0xfe, 0xcc, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10,
-  0x07, 0x06, 0xb8, 0x07, 0x01, 0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62,
-  0x42, 0x81, 0x1b, 0x50, 0xb8, 0x48, 0x3a, 0x6a, 0x56, 0x01, 0xfd, 0x12,
-  0x14, 0x24, 0x25, 0x2d, 0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12, 0x20,
-  0x1a, 0x4d, 0x1b, 0x0a, 0x1d, 0x66, 0x4d, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x04, 0xb8, 0x05, 0x4b, 0x00, 0x29, 0x00, 0x42, 0x00, 0x00,
-  0x01, 0x16, 0x17, 0x15, 0x06, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27,
-  0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x27, 0x37, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x37, 0x15, 0x05, 0x02, 0x3e, 0xe8, 0xc6, 0x3a,
-  0x42, 0x2d, 0x1b, 0x5e, 0x66, 0x3c, 0x4e, 0xbc, 0x71, 0x24, 0x35, 0x3e,
-  0x25, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55,
-  0x5b, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x26, 0x46,
-  0x28, 0x0e, 0x0f, 0x33, 0x34, 0x53, 0x38, 0x2e, 0x2c, 0x3a, 0x3c, 0x0f,
-  0x1a, 0x55, 0x1d, 0x6c, 0xfe, 0xcc, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14,
-  0x29, 0x4e, 0x22, 0x77, 0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b,
-  0x50, 0xb8, 0x48, 0x3a, 0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07,
-  0x06, 0xb8, 0x07, 0x01, 0xc8, 0x12, 0x14, 0x24, 0x25, 0x2d, 0x60, 0x2b,
-  0x2d, 0x21, 0x64, 0x21, 0x12, 0x20, 0x1a, 0x4d, 0x1b, 0x0a, 0x1d, 0x66,
-  0x4d, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x8d, 0xfe, 0x0c, 0x04, 0xb8,
-  0x05, 0xaa, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x25, 0x33,
-  0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x21, 0x32, 0x37, 0x15, 0x06, 0x23, 0x20, 0x27, 0x26,
-  0x35, 0x10, 0x37, 0x36, 0x37, 0x22, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35,
-  0x36, 0x33, 0x20, 0x17, 0x15, 0x22, 0x07, 0x17, 0x16, 0x17, 0x16, 0x01,
-  0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x04, 0x94, 0x24, 0x2c, 0x74,
-  0x6f, 0x4a, 0x37, 0x05, 0x42, 0x67, 0x58, 0xc9, 0x42, 0x74, 0x01, 0x29,
-  0xad, 0xbf, 0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76, 0xbf, 0x56, 0x7b, 0x0a,
-  0x0c, 0x56, 0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01, 0x08, 0xb4, 0x62, 0x1c,
-  0x1a, 0x2e, 0x41, 0x51, 0xfd, 0xbe, 0x86, 0x86, 0x86, 0x86, 0xb8, 0xb8,
-  0x96, 0x64, 0x9c, 0x0f, 0xb2, 0x18, 0x50, 0xb7, 0xfc, 0x89, 0x5e, 0xa4,
-  0x76, 0xb8, 0x63, 0xc2, 0x96, 0xe0, 0x01, 0x02, 0xdf, 0x65, 0x34, 0x13,
-  0x13, 0x29, 0xb8, 0x3f, 0x36, 0x9a, 0x0d, 0x5b, 0xa0, 0x5f, 0x77, 0x03,
-  0xf8, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xed, 0x05, 0x46, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x26,
-  0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37,
-  0x32, 0x17, 0x16, 0x17, 0x15, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x03, 0x33, 0x15,
-  0x23, 0x11, 0x33, 0x15, 0x23, 0x02, 0xfe, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a,
-  0x91, 0x41, 0x44, 0x91, 0x9b, 0xe8, 0xc6, 0x44, 0x4f, 0x96, 0x42, 0x83,
-  0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55, 0xcb, 0x88,
-  0x88, 0x88, 0x88, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8,
-  0x07, 0x01, 0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62, 0x42, 0x81, 0x1b,
-  0x50, 0xb8, 0x48, 0x3a, 0x6a, 0x56, 0x02, 0x52, 0x96, 0x01, 0x90, 0x96,
-  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x04, 0xb8, 0x05, 0x46, 0x00, 0x29,
-  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x01, 0x16, 0x17, 0x15, 0x06, 0x07,
-  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32,
-  0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x02, 0x3e, 0xe8, 0xc6,
-  0x3a, 0x42, 0x2d, 0x1b, 0x5e, 0x66, 0x3c, 0x4e, 0xbc, 0x71, 0x24, 0x35,
-  0x3e, 0x25, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68,
-  0x55, 0x5b, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x35,
-  0x88, 0x88, 0x88, 0x88, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14, 0x29, 0x4e,
-  0x22, 0x77, 0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b, 0x50, 0xb8,
-  0x48, 0x3a, 0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8,
-  0x07, 0x01, 0x01, 0x1d, 0x96, 0x01, 0x90, 0x96, 0x00, 0x04, 0x00, 0x8d,
-  0xfe, 0x0c, 0x04, 0xb8, 0x05, 0xaa, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x3c, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27,
-  0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x21, 0x32, 0x37,
-  0x15, 0x06, 0x23, 0x20, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36, 0x37, 0x22,
-  0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33, 0x20, 0x17, 0x15, 0x22,
-  0x07, 0x17, 0x16, 0x17, 0x16, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15,
-  0x23, 0x27, 0x33, 0x15, 0x23, 0x04, 0x94, 0x24, 0x2c, 0x74, 0x6f, 0x4a,
-  0x37, 0x05, 0x42, 0x67, 0x58, 0xc9, 0x42, 0x74, 0x01, 0x29, 0xad, 0xbf,
-  0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76, 0xbf, 0x56, 0x7b, 0x0a, 0x0c, 0x56,
-  0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01, 0x08, 0xb4, 0x62, 0x1c, 0x1a, 0x2e,
-  0x41, 0x51, 0xfd, 0xbe, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87,
-  0xb8, 0xb8, 0x96, 0x64, 0x9c, 0x0f, 0xb2, 0x18, 0x50, 0xb7, 0xfc, 0x89,
-  0x5e, 0xa4, 0x76, 0xb8, 0x63, 0xc2, 0x96, 0xe0, 0x01, 0x02, 0xdf, 0x65,
-  0x34, 0x13, 0x13, 0x29, 0xb8, 0x3f, 0x36, 0x9a, 0x0d, 0x5b, 0xa0, 0x5f,
-  0x77, 0x04, 0xf2, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xed, 0x05, 0x46, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x26,
-  0x00, 0x2a, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35,
-  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x15, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x03,
-  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x02,
-  0xfe, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x9b, 0xe8,
-  0xc6, 0x44, 0x4f, 0x96, 0x42, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc,
-  0x74, 0x5e, 0x68, 0x55, 0xcb, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87,
-  0x87, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07, 0x01,
-  0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62, 0x42, 0x81, 0x1b, 0x50, 0xb8,
-  0x48, 0x3a, 0x6a, 0x56, 0x03, 0x4c, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00,
-  0x00, 0x04, 0xff, 0xee, 0x00, 0x00, 0x04, 0xb8, 0x05, 0x46, 0x00, 0x29,
-  0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x01, 0x16, 0x17, 0x15,
-  0x06, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36,
-  0x37, 0x32, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x02, 0x3e, 0xe8, 0xc6, 0x3a, 0x42, 0x2d, 0x1b, 0x5e, 0x66,
-  0x3c, 0x4e, 0xbc, 0x71, 0x24, 0x35, 0x3e, 0x25, 0x83, 0x43, 0xc7, 0x93,
-  0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55, 0x5b, 0x4b, 0x5d, 0x4c, 0xa2,
-  0x4a, 0x91, 0x41, 0x44, 0x91, 0x35, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1,
-  0x87, 0x87, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14, 0x29, 0x4e, 0x22, 0x77,
-  0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b, 0x50, 0xb8, 0x48, 0x3a,
-  0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07, 0x01,
-  0x02, 0x17, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x05, 0x00, 0x8d,
-  0xfe, 0x0c, 0x04, 0xb8, 0x04, 0xb0, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
-  0x00, 0x3c, 0x00, 0x40, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23, 0x22, 0x27,
-  0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x21,
-  0x32, 0x37, 0x15, 0x06, 0x23, 0x20, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36,
-  0x37, 0x22, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33, 0x20, 0x17,
-  0x15, 0x22, 0x07, 0x17, 0x16, 0x17, 0x16, 0x01, 0x33, 0x15, 0x23, 0x13,
-  0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x04,
-  0x94, 0x24, 0x2c, 0x74, 0x6f, 0x4a, 0x37, 0x05, 0x42, 0x67, 0x58, 0xc9,
-  0x42, 0x74, 0x01, 0x29, 0xad, 0xbf, 0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76,
-  0xbf, 0x56, 0x7b, 0x0a, 0x0c, 0x56, 0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01,
-  0x08, 0xb4, 0x62, 0x1c, 0x1a, 0x2e, 0x41, 0x51, 0xfd, 0xbe, 0x86, 0x86,
-  0x21, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb8, 0xb8, 0x96,
-  0x64, 0x9c, 0x0f, 0xb2, 0x18, 0x50, 0xb7, 0xfc, 0x89, 0x5e, 0xa4, 0x76,
-  0xb8, 0x63, 0xc2, 0x96, 0xe0, 0x01, 0x02, 0xdf, 0x65, 0x34, 0x13, 0x13,
-  0x29, 0xb8, 0x3f, 0x36, 0x9a, 0x0d, 0x5b, 0xa0, 0x5f, 0x77, 0x03, 0xf8,
-  0x96, 0xfb, 0x9b, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0xff, 0xee, 0xfe, 0x3e, 0x03, 0xed, 0x04, 0x4c, 0x00, 0x1e,
-  0x00, 0x22, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17,
-  0x15, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x37, 0x36, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15,
-  0x23, 0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x02, 0xfe, 0x4b,
-  0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x9b, 0xe8, 0xc6, 0x44,
-  0x4f, 0x96, 0x42, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e,
-  0x68, 0x55, 0xcb, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x70,
-  0x88, 0x88, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07,
-  0x01, 0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62, 0x42, 0x81, 0x1b, 0x50,
-  0xb8, 0x48, 0x3a, 0x6a, 0x56, 0xfc, 0xda, 0x96, 0x01, 0x90, 0x96, 0x96,
-  0x96, 0x05, 0x14, 0x96, 0x00, 0x05, 0xff, 0xee, 0xfe, 0x3e, 0x04, 0xb8,
-  0x04, 0x4c, 0x00, 0x29, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x39,
-  0x00, 0x00, 0x01, 0x16, 0x17, 0x15, 0x06, 0x07, 0x16, 0x17, 0x16, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27,
-  0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x13, 0x33, 0x15, 0x23,
-  0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23,
-  0x02, 0x3e, 0xe8, 0xc6, 0x3a, 0x42, 0x2d, 0x1b, 0x5e, 0x66, 0x3c, 0x4e,
-  0xbc, 0x71, 0x24, 0x35, 0x3e, 0x25, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a,
-  0xcc, 0x74, 0x5e, 0x68, 0x55, 0x5b, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91,
-  0x41, 0x44, 0x91, 0x40, 0x87, 0x87, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87,
-  0x65, 0x88, 0x88, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14, 0x29, 0x4e, 0x22,
-  0x77, 0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b, 0x50, 0xb8, 0x48,
-  0x3a, 0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07,
-  0x01, 0xfb, 0xa5, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x05, 0x14, 0x96,
-  0x00, 0x01, 0x00, 0x00, 0x05, 0x33, 0x03, 0x09, 0x07, 0x2b, 0x00, 0x03,
-  0x00, 0x00, 0x09, 0x01, 0x35, 0x01, 0x03, 0x09, 0xfc, 0xf7, 0x03, 0x09,
-  0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0x00, 0x00, 0x01, 0x00, 0xbf,
-  0xfe, 0x56, 0x04, 0xa4, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
-  0x01, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x01, 0x11, 0x23, 0xc0, 0xa5, 0x02, 0x99, 0xa5, 0x4a,
-  0x49, 0xa2, 0xe5, 0xd2, 0x5e, 0x22, 0x23, 0xfd, 0x67, 0xa5, 0x05, 0xd5,
-  0xfb, 0x83, 0x04, 0x7d, 0xfa, 0x17, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31,
-  0xad, 0x04, 0x7d, 0xfb, 0x83, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0d,
-  0x00, 0x00, 0x01, 0xe9, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
-  0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xb0, 0xa5,
-  0x94, 0x94, 0xa5, 0xa2, 0xa2, 0x04, 0x60, 0xfe, 0x08, 0xa4, 0xfe, 0x3c,
-  0x01, 0xc4, 0xa4, 0x00, 0x00, 0x02, 0xff, 0x0d, 0xfe, 0x56, 0x01, 0xf7,
-  0x04, 0x60, 0x00, 0x0e, 0x00, 0x17, 0x00, 0x00, 0x13, 0x20, 0x35, 0x34,
-  0x3b, 0x01, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x03,
-  0x23, 0x22, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x1e, 0xfe, 0xef, 0xf3,
-  0xae, 0xa5, 0xa3, 0xac, 0x10, 0x30, 0x49, 0x1d, 0xa3, 0x6b, 0x02, 0x04,
-  0x6f, 0x5e, 0x23, 0x0f, 0xfe, 0x56, 0xdd, 0xcd, 0x04, 0x60, 0xfb, 0xa0,
-  0x9b, 0x70, 0x3f, 0x60, 0x01, 0x10, 0x33, 0x41, 0x30, 0x17, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x69, 0x06, 0x63, 0x03, 0x84, 0x08, 0x33, 0x10, 0x27,
-  0x00, 0x71, 0x00, 0xaa, 0x02, 0x3d, 0x10, 0x07, 0x10, 0xeb, 0x04, 0x43,
-  0x01, 0x55, 0x00, 0x00, 0xff, 0xff, 0x01, 0x69, 0x06, 0x61, 0x03, 0x84,
-  0x08, 0x34, 0x10, 0x27, 0x00, 0x71, 0x00, 0xaa, 0x00, 0xff, 0x10, 0x07,
-  0x10, 0xeb, 0x04, 0x43, 0x02, 0x5b, 0x00, 0x00, 0xff, 0xff, 0x01, 0x69,
-  0x06, 0x5e, 0x03, 0x84, 0x08, 0x33, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x43,
-  0x01, 0x50, 0x10, 0x07, 0x00, 0x71, 0x00, 0xaa, 0x02, 0x3d, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x6a, 0x06, 0x63, 0x03, 0x82, 0x08, 0x5a, 0x10, 0x27,
-  0x10, 0xec, 0x04, 0x72, 0x02, 0x64, 0x10, 0x07, 0x10, 0xeb, 0x04, 0x43,
-  0x01, 0x55, 0x00, 0x00, 0xff, 0xff, 0x01, 0x6a, 0x06, 0x63, 0x03, 0x82,
-  0x08, 0x5a, 0x10, 0x27, 0x10, 0xee, 0x04, 0x18, 0x02, 0x64, 0x10, 0x07,
-  0x10, 0xeb, 0x04, 0x43, 0x01, 0x55, 0x00, 0x00, 0xff, 0xff, 0x01, 0x69,
-  0x06, 0x61, 0x03, 0x84, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xec, 0x04, 0x72,
-  0x02, 0x64, 0x10, 0x07, 0x00, 0x71, 0x00, 0xaa, 0x00, 0xff, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x69, 0x06, 0x61, 0x03, 0x84, 0x08, 0x5a, 0x10, 0x27,
-  0x10, 0xee, 0x04, 0x18, 0x02, 0x64, 0x10, 0x07, 0x00, 0x71, 0x00, 0xaa,
-  0x00, 0xff, 0x00, 0x00, 0xff, 0xff, 0x01, 0x50, 0x06, 0x6a, 0x03, 0xa3,
-  0x08, 0x33, 0x10, 0x27, 0x10, 0xed, 0x04, 0x46, 0x01, 0x5c, 0x10, 0x07,
-  0x00, 0x71, 0x00, 0xaa, 0x02, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63,
-  0x06, 0x63, 0x03, 0x89, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x43,
-  0x02, 0x62, 0x10, 0x07, 0x10, 0xeb, 0x04, 0x43, 0x01, 0x55, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x50, 0x06, 0x6a, 0x03, 0xa3, 0x08, 0x56, 0x10, 0x27,
-  0x10, 0xeb, 0x04, 0x43, 0x02, 0x7d, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46,
-  0x01, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x03, 0x89,
-  0x08, 0x57, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x43, 0x01, 0x75, 0x10, 0x07,
-  0x10, 0xf3, 0x04, 0x43, 0x02, 0x7c, 0x00, 0x00, 0xff, 0xff, 0x01, 0x50,
-  0x06, 0x6a, 0x03, 0xc5, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xec, 0x04, 0xba,
-  0x02, 0x64, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46, 0x01, 0x5c, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x04, 0x96, 0x08, 0x3a, 0x10, 0x27,
-  0x10, 0xef, 0x04, 0x43, 0x01, 0x75, 0x10, 0x07, 0x10, 0xec, 0x05, 0x8a,
-  0x02, 0x44, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x03, 0xfc,
-  0x08, 0x3a, 0x10, 0x27, 0x10, 0xee, 0x05, 0x4b, 0x02, 0x44, 0x10, 0x07,
-  0x10, 0xef, 0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0xff, 0xff, 0x01, 0x50,
-  0x06, 0x63, 0x03, 0xa3, 0x08, 0x75, 0x10, 0x27, 0x10, 0xef, 0x04, 0x43,
-  0x01, 0x75, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46, 0x02, 0x8c, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x50, 0x06, 0x56, 0x03, 0xa3, 0x08, 0x59, 0x10, 0x27,
-  0x10, 0xf2, 0x04, 0x43, 0x01, 0x50, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46,
-  0x02, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x5c, 0x06, 0x56, 0x03, 0x90,
-  0x08, 0x5a, 0x10, 0x27, 0x10, 0xf2, 0x04, 0x43, 0x01, 0x50, 0x10, 0x07,
-  0x10, 0xec, 0x04, 0x72, 0x02, 0x64, 0x00, 0x00, 0xff, 0xff, 0x01, 0x5c,
-  0x06, 0x56, 0x03, 0x90, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xf2, 0x04, 0x43,
-  0x01, 0x50, 0x10, 0x07, 0x10, 0xee, 0x04, 0x18, 0x02, 0x64, 0x00, 0x00,
-  0xff, 0xff, 0x01, 0x5c, 0x06, 0x56, 0x03, 0x90, 0x08, 0x8b, 0x10, 0x27,
-  0x02, 0xba, 0x04, 0x34, 0x02, 0x10, 0x10, 0x07, 0x10, 0xf2, 0x04, 0x43,
-  0x01, 0x50, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x04, 0x87,
-  0x08, 0x5b, 0x10, 0x27, 0x02, 0xba, 0x05, 0x75, 0x01, 0xe0, 0x10, 0x07,
-  0x10, 0xef, 0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xf1,
-  0x04, 0x7b, 0xff, 0x62, 0x06, 0x6e, 0x10, 0x26, 0x02, 0xb2, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xb8, 0xff, 0x12, 0x00, 0x5a, 0x00, 0x01, 0x00, 0x00,
-  0x00, 0x00, 0x01, 0x0e, 0x01, 0x2c, 0x00, 0x03, 0x00, 0x00, 0x11, 0x21,
-  0x11, 0x21, 0x01, 0x0e, 0xfe, 0xf2, 0x01, 0x2c, 0xfe, 0xd4, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0xff, 0xe3, 0x02, 0xfb, 0x05, 0xd5, 0x00, 0x0f,
-  0x00, 0x00, 0x3d, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33,
-  0x11, 0x10, 0x06, 0x23, 0x22, 0x26, 0x52, 0xae, 0x5e, 0x81, 0x65, 0xb6,
-  0xbe, 0xde, 0x56, 0xab, 0x3d, 0xec, 0x51, 0x51, 0x95, 0xcb, 0x03, 0xee,
-  0xfc, 0x12, 0xfe, 0xe6, 0xea, 0x2c, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb3,
-  0xfe, 0x0c, 0x04, 0x92, 0x02, 0x26, 0x00, 0x06, 0x00, 0x1f, 0x00, 0x00,
-  0x01, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03, 0x01, 0x33, 0x16, 0x17, 0x16,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21,
-  0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x5c, 0xaf, 0x7d,
-  0x75, 0x75, 0x7d, 0xaf, 0xfe, 0x57, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26,
-  0x5b, 0xaf, 0xe1, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01,
-  0x11, 0xb7, 0xc4, 0x20, 0x08, 0xfe, 0x0c, 0x01, 0x46, 0xc3, 0xc3, 0xfe,
-  0xba, 0x04, 0x1a, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea,
-  0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x77, 0x02, 0x26, 0x00, 0x18,
-  0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b,
-  0xaf, 0xe1, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11,
-  0xb7, 0xc4, 0x20, 0x08, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8,
-  0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e,
-  0x00, 0x02, 0x00, 0x81, 0xfe, 0xc8, 0x05, 0x86, 0x07, 0xc4, 0x00, 0x24,
-  0x00, 0x2b, 0x00, 0x00, 0x25, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17,
-  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x24, 0x11, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x13, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03,
-  0x03, 0xaa, 0x46, 0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46, 0x10,
-  0x19, 0x6d, 0xea, 0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39, 0xa6,
-  0x3b, 0x96, 0x24, 0x41, 0x48, 0x63, 0x9c, 0x99, 0xaf, 0x7d, 0x75, 0x75,
-  0x7d, 0xb0, 0x49, 0x7e, 0xe3, 0x04, 0x6a, 0xfb, 0x6b, 0x6a, 0x31, 0x2c,
-  0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22, 0x16, 0x5b, 0x01, 0x12, 0x8a,
-  0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22, 0x35, 0x06, 0xac, 0x01, 0x46,
-  0xc3, 0xc3, 0xfe, 0xba, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x02, 0x24,
-  0x07, 0xc4, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x27, 0x03,
-  0x33, 0x17, 0x37, 0x33, 0x03, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75, 0x44,
-  0x59, 0x27, 0x2c, 0xa6, 0x96, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x01,
-  0x73, 0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0x6a, 0x01,
-  0x46, 0xc3, 0xc3, 0xfe, 0xba, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0x75, 0x07, 0xc4, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00,
-  0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
-  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x0b, 0x01, 0x33,
-  0x17, 0x37, 0x33, 0x03, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27,
-  0x2c, 0xa6, 0x2c, 0x28, 0x59, 0x43, 0x75, 0x87, 0x8a, 0xaf, 0x7d, 0x75,
-  0x75, 0x7d, 0xaf, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xfb,
-  0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x06, 0x7e, 0x01, 0x46, 0xc3, 0xc3, 0xfe,
-  0xba, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75, 0xfe, 0xf0, 0x06, 0x13,
-  0x03, 0x46, 0x00, 0x37, 0x00, 0x3e, 0x00, 0x00, 0x05, 0x36, 0x35, 0x26,
-  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x01, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03, 0x03,
-  0xde, 0x52, 0x01, 0x2a, 0x1a, 0x1b, 0x28, 0x2f, 0x48, 0x4b, 0x1b, 0x26,
-  0x69, 0x4f, 0x73, 0x1d, 0x1f, 0x1f, 0x67, 0x65, 0x61, 0x17, 0x21, 0x0d,
-  0x29, 0x3b, 0x42, 0x02, 0x03, 0x66, 0x73, 0xc4, 0x50, 0x5e, 0xa9, 0x69,
-  0xfe, 0xf8, 0x39, 0xa5, 0x3a, 0x95, 0x3c, 0xa1, 0x52, 0x45, 0x86, 0xfe,
-  0x8b, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x21, 0x33, 0x21, 0x2b, 0x0d,
-  0x08, 0x28, 0x3b, 0x3d, 0x41, 0x3c, 0x5e, 0x0e, 0x06, 0x86, 0xc4, 0xb8,
-  0xac, 0xa5, 0x06, 0x11, 0x23, 0x30, 0x1b, 0x1e, 0x7b, 0x62, 0x56, 0x60,
-  0x1f, 0x0c, 0x29, 0x67, 0x01, 0x06, 0x99, 0x5a, 0x5a, 0x99, 0x72, 0x4e,
-  0x1f, 0x08, 0x0f, 0x02, 0x42, 0x01, 0x46, 0xc3, 0xc3, 0xfe, 0xba, 0x00,
-  0x00, 0x04, 0xff, 0xee, 0xfe, 0xd4, 0x02, 0x00, 0x04, 0x40, 0x00, 0x0d,
-  0x00, 0x14, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x0b, 0x01,
-  0x33, 0x17, 0x37, 0x33, 0x0b, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
-  0x23, 0x01, 0x0d, 0x41, 0x8d, 0x51, 0x20, 0x59, 0x27, 0x2c, 0xa6, 0x96,
-  0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x16, 0x87, 0x87, 0xe1, 0x87, 0x87,
-  0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0xd9, 0xd9, 0xbb, 0x02, 0x36, 0x01,
-  0x46, 0xc3, 0xc3, 0xfe, 0xba, 0xfc, 0x70, 0x96, 0x96, 0x96, 0x00, 0x00,
-  0x00, 0x04, 0xff, 0xee, 0xfe, 0xd4, 0x02, 0x3f, 0x04, 0x40, 0x00, 0x14,
-  0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x0b, 0x01, 0x33, 0x17, 0x37, 0x33, 0x0b,
-  0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0x0d, 0x45, 0x89,
-  0x51, 0x20, 0x59, 0x27, 0x2c, 0xa6, 0x2c, 0x28, 0x59, 0x31, 0x63, 0x87,
-  0x8a, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x16, 0x87, 0x87, 0xe1, 0x87,
-  0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0xd9, 0xd9, 0x6a, 0x31, 0x2c,
-  0xb8, 0x02, 0xfa, 0x01, 0x46, 0xc3, 0xc3, 0xfe, 0xba, 0xfc, 0x70, 0x96,
-  0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x0b,
-  0x04, 0x72, 0x00, 0x18, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x33, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04,
-  0x21, 0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x0b, 0x01, 0x33,
-  0x17, 0x37, 0x33, 0x03, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26,
-  0x5b, 0x43, 0x75, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01,
-  0x11, 0xb7, 0xc4, 0x20, 0x08, 0x35, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf,
-  0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85,
-  0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0x01, 0x8e, 0x01, 0x46,
-  0xc3, 0xc3, 0xfe, 0xba, 0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x02, 0x01,
-  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x14, 0x16, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0xae, 0xa5, 0x45, 0x5e, 0x0a, 0x1d,
-  0xa3, 0x92, 0x06, 0x14, 0xfb, 0x82, 0x99, 0x61, 0x9c, 0xc0, 0xd6, 0x00,
-  0x00, 0x02, 0x00, 0x82, 0x00, 0x00, 0x03, 0xef, 0x02, 0xee, 0x00, 0x0a,
-  0x00, 0x24, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x17, 0x1e, 0x01, 0x13, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x23, 0x22, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x02, 0x60, 0x0d, 0x0c, 0x0b, 0x0b, 0x6c,
-  0x4a, 0x64, 0x02, 0x01, 0xa2, 0x68, 0x04, 0x02, 0xa5, 0x01, 0x21, 0x13,
-  0x32, 0x1c, 0x65, 0x43, 0x75, 0x51, 0x42, 0x28, 0x22, 0x7c, 0x8d, 0x32,
-  0x34, 0xab, 0xb8, 0x62, 0x01, 0x1a, 0x2a, 0x31, 0x32, 0x65, 0x0c, 0x43,
-  0x59, 0x3e, 0x29, 0x32, 0x01, 0xd1, 0x27, 0x2b, 0xa8, 0xae, 0x65, 0x4f,
-  0x2c, 0xb8, 0x33, 0x1f, 0x3b, 0x49, 0x0f, 0x30, 0x9a, 0xad, 0x7f, 0x44,
-  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0xa2, 0x05, 0xf0, 0x10, 0x06,
-  0x01, 0xe4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x00,
-  0x05, 0x0f, 0x10, 0x06, 0x01, 0xe5, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87,
-  0xfe, 0x75, 0x01, 0xd7, 0x04, 0x7b, 0x10, 0x26, 0x00, 0xf3, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0x9d, 0xff, 0x5c, 0x00, 0x00, 0x00, 0x02, 0x00, 0x47,
-  0x00, 0x00, 0x02, 0x38, 0x04, 0x60, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x37, 0x33, 0x13, 0x23, 0x13, 0x21, 0x13, 0x21, 0xb3, 0x79, 0xa0, 0x79,
-  0x21, 0xfe, 0xd3, 0xc4, 0x01, 0x2d, 0x64, 0x03, 0x98, 0xfc, 0x04, 0x04,
-  0x60, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x2d, 0xfe, 0x56, 0x02, 0x38,
-  0x04, 0x60, 0x00, 0x08, 0x00, 0x16, 0x00, 0x00, 0x05, 0x13, 0x23, 0x03,
-  0x06, 0x07, 0x36, 0x37, 0x36, 0x05, 0x23, 0x37, 0x33, 0x32, 0x37, 0x36,
-  0x37, 0x13, 0x21, 0x03, 0x06, 0x07, 0x06, 0x01, 0x16, 0xb6, 0x79, 0xbb,
-  0x1f, 0x30, 0x41, 0x2d, 0x43, 0xfe, 0xf9, 0xc6, 0x12, 0x2d, 0x5e, 0x2b,
-  0x2b, 0x1a, 0xd1, 0x01, 0x2d, 0xc8, 0x25, 0x5a, 0x5b, 0x16, 0x04, 0x12,
-  0xfb, 0xd0, 0xb5, 0x54, 0x0f, 0x30, 0x48, 0xf4, 0x64, 0x30, 0x31, 0x99,
-  0x04, 0xac, 0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x00, 0xff, 0xff, 0xff, 0xd7,
-  0xfe, 0x76, 0x02, 0x2a, 0x04, 0x7b, 0x10, 0x27, 0x02, 0xb0, 0xff, 0x34,
-  0x00, 0x00, 0x10, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xab,
-  0xfe, 0x89, 0x01, 0x54, 0x04, 0x7b, 0x10, 0x26, 0x00, 0xf3, 0x00, 0x00,
-  0x10, 0x07, 0x02, 0xd4, 0x02, 0xcd, 0x00, 0x00, 0x00, 0x02, 0x00, 0xd8,
-  0x00, 0xd8, 0x01, 0x96, 0x04, 0xfb, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
-  0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0xd8, 0xbe, 0xbe, 0xbe,
-  0xbe, 0x01, 0xd6, 0xfe, 0x04, 0x23, 0xfe, 0x00, 0x00, 0x01, 0x00, 0x87,
-  0x00, 0x00, 0x02, 0xab, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
-  0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x88, 0x02,
-  0x21, 0xb5, 0xb6, 0xfd, 0xdf, 0xb5, 0xb6, 0x05, 0xd5, 0xaa, 0xfb, 0x7f,
-  0xaa, 0xaa, 0x04, 0x81, 0x00, 0x01, 0x01, 0x82, 0x02, 0x95, 0x04, 0x89,
-  0x03, 0x3f, 0x00, 0x03, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35, 0x04, 0x88,
-  0xfc, 0xfa, 0x03, 0x3f, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4,
-  0x04, 0xcb, 0x02, 0xe6, 0x08, 0xf2, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x33, 0x16, 0x15, 0x14, 0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x26, 0x01, 0x35, 0x25, 0x15, 0x01,
-  0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48, 0x25, 0x1e,
-  0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56, 0x03, 0x50,
-  0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18, 0xfe, 0xe0,
-  0x02, 0x0e, 0xfd, 0xf2, 0x02, 0x0e, 0x05, 0x84, 0x4c, 0x28, 0x45, 0x3f,
-  0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa,
-  0x52, 0x59, 0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36,
-  0x59, 0x0a, 0x09, 0x21, 0x1e, 0x02, 0xb3, 0x6e, 0x82, 0x6e, 0xfe, 0x8e,
-  0x6e, 0x82, 0x6e, 0x00, 0x00, 0x03, 0x00, 0xb4, 0x04, 0xcb, 0x02, 0xe6,
-  0x09, 0x55, 0x00, 0x28, 0x00, 0x4f, 0x00, 0x5e, 0x00, 0x00, 0x01, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35, 0x33, 0x16, 0x15, 0x14,
-  0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
-  0x06, 0x27, 0x26, 0x03, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
-  0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x33, 0x16, 0x33,
-  0x15, 0x22, 0x2f, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35,
-  0x33, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34,
-  0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0xdb, 0x0d,
-  0x1e, 0x34, 0x3d, 0x48, 0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d,
-  0x37, 0x04, 0x02, 0x56, 0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28,
-  0x4b, 0x40, 0x1c, 0x18, 0x0f, 0x21, 0x13, 0x1e, 0x15, 0x61, 0x3e, 0x1a,
-  0x38, 0x42, 0x24, 0x31, 0x0b, 0x12, 0x0c, 0x11, 0x12, 0x2b, 0x12, 0x2e,
-  0x18, 0x43, 0x4d, 0x55, 0x66, 0x32, 0x0e, 0x51, 0x0b, 0x1f, 0x2b, 0x33,
-  0x8f, 0x03, 0x02, 0x09, 0x1f, 0x12, 0x15, 0x0a, 0x10, 0x29, 0x11, 0x05,
-  0x84, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38, 0x54,
-  0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59, 0x24, 0x36, 0xc3, 0xae, 0x73,
-  0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a, 0x09, 0x21, 0x1e, 0x02, 0x6d,
-  0x24, 0x2a, 0x07, 0x0d, 0x39, 0x5e, 0x57, 0x34, 0x15, 0x27, 0x36, 0x4f,
-  0x27, 0x26, 0x01, 0x01, 0x6e, 0x02, 0x05, 0x3d, 0x4e, 0x56, 0x9a, 0x29,
-  0x71, 0x61, 0x1a, 0x4b, 0xee, 0x07, 0x07, 0x15, 0x18, 0x22, 0x1c, 0x09,
-  0x0d, 0x1c, 0x25, 0x12, 0x08, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4,
-  0x04, 0xba, 0x02, 0xe6, 0x08, 0xe8, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x33, 0x16, 0x15, 0x14, 0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x26, 0x01, 0x35, 0x25, 0x15, 0x01,
-  0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48, 0x25, 0x1e,
-  0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56, 0x03, 0x50,
-  0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18, 0xfe, 0xe0,
-  0x02, 0x0e, 0xfd, 0xf2, 0x02, 0x0e, 0x07, 0x78, 0x4c, 0x28, 0x45, 0x3f,
-  0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa,
-  0x52, 0x59, 0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36,
-  0x59, 0x0a, 0x09, 0x21, 0x1e, 0xfe, 0x67, 0x6e, 0x82, 0x6e, 0xfe, 0x8e,
-  0x6e, 0x82, 0x6e, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x04, 0xcb, 0x02, 0xe6,
-  0x08, 0x02, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x37, 0x36, 0x37, 0x36, 0x35, 0x33, 0x16, 0x15, 0x14, 0x33, 0x32,
-  0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
-  0x26, 0x01, 0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48,
-  0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56,
-  0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18,
-  0xfe, 0xe0, 0x02, 0x0e, 0x05, 0x84, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d,
-  0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59,
-  0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a,
-  0x09, 0x21, 0x1e, 0x01, 0xc3, 0x6e, 0x82, 0x6e, 0x00, 0x03, 0x00, 0xb4,
-  0x04, 0xcb, 0x02, 0xe6, 0x09, 0x55, 0x00, 0x28, 0x00, 0x47, 0x00, 0x56,
-  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
-  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35,
-  0x33, 0x16, 0x15, 0x14, 0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x26, 0x13, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x1e, 0x01,
-  0x33, 0x15, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x35, 0x32,
-  0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48,
-  0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56,
-  0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18,
-  0x0c, 0x08, 0x12, 0x61, 0x3e, 0x1a, 0x38, 0x42, 0x24, 0x31, 0x0c, 0x0f,
-  0x21, 0x12, 0x20, 0x1d, 0x1b, 0x19, 0x26, 0x3f, 0xb4, 0x84, 0x89, 0x7d,
-  0x15, 0x4d, 0x03, 0x02, 0x09, 0x1f, 0x12, 0x15, 0x0a, 0x10, 0x29, 0x11,
-  0x05, 0x84, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38,
-  0x54, 0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59, 0x24, 0x36, 0xc3, 0xae,
-  0x73, 0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a, 0x09, 0x21, 0x1e, 0x02,
-  0xc3, 0x02, 0x0a, 0x38, 0x5f, 0x57, 0x34, 0x15, 0x27, 0x36, 0x4f, 0x20,
-  0x2d, 0x01, 0x01, 0x6e, 0x02, 0x02, 0x03, 0x3d, 0x2a, 0x7b, 0x6e, 0x6d,
-  0x12, 0x70, 0x07, 0x07, 0x15, 0x18, 0x22, 0x1c, 0x09, 0x0d, 0x1c, 0x25,
-  0x12, 0x08, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x04, 0xba, 0x02, 0xe6,
-  0x08, 0x20, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x37, 0x36, 0x37, 0x36, 0x35, 0x33, 0x16, 0x15, 0x14, 0x33, 0x32,
-  0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
-  0x26, 0x01, 0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48,
-  0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56,
-  0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18,
-  0xfe, 0xe0, 0x02, 0x0e, 0x06, 0xb0, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d,
-  0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59,
-  0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a,
-  0x09, 0x21, 0x1e, 0xfe, 0x3f, 0x6e, 0x82, 0x6e, 0x00, 0x02, 0x00, 0xc6,
-  0x04, 0xbf, 0x02, 0xd4, 0x07, 0x9e, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00,
-  0x01, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x15,
-  0x05, 0x03, 0x35, 0x25, 0x15, 0x01, 0x2e, 0x46, 0x28, 0x0e, 0x0f, 0x33,
-  0x34, 0x53, 0x37, 0x2f, 0x2d, 0x39, 0x3c, 0x0f, 0x1a, 0x54, 0x1e, 0x6c,
-  0xfe, 0xcc, 0x68, 0x02, 0x0e, 0x05, 0x23, 0x12, 0x14, 0x24, 0x25, 0x2d,
-  0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12, 0x20, 0x1a, 0x4d, 0x1b, 0x0a,
-  0x1d, 0x66, 0x4d, 0x01, 0xef, 0x6e, 0x82, 0x6e, 0x00, 0x03, 0x00, 0xc6,
-  0x04, 0xbf, 0x02, 0xd4, 0x08, 0xf1, 0x00, 0x18, 0x00, 0x37, 0x00, 0x46,
-  0x00, 0x00, 0x01, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x37, 0x15, 0x05, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x1e, 0x01, 0x33, 0x15, 0x22, 0x27,
-  0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x35, 0x32, 0x37, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x01, 0x2e, 0x46, 0x28, 0x0e, 0x0f, 0x33, 0x34, 0x53, 0x37, 0x2f,
-  0x2d, 0x39, 0x3c, 0x0f, 0x1a, 0x54, 0x1e, 0x6c, 0xfe, 0xcc, 0xc4, 0x08,
-  0x12, 0x61, 0x3e, 0x1a, 0x38, 0x42, 0x24, 0x31, 0x0c, 0x0f, 0x21, 0x12,
-  0x20, 0x1d, 0x1b, 0x19, 0x26, 0x3f, 0xb4, 0x84, 0x89, 0x7d, 0x15, 0x4d,
-  0x03, 0x02, 0x09, 0x1f, 0x12, 0x15, 0x0a, 0x10, 0x29, 0x11, 0x05, 0x23,
-  0x12, 0x14, 0x24, 0x25, 0x2d, 0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12,
-  0x20, 0x1a, 0x4d, 0x1b, 0x0a, 0x1d, 0x66, 0x4d, 0x02, 0xef, 0x02, 0x0a,
-  0x38, 0x5f, 0x57, 0x34, 0x15, 0x27, 0x36, 0x4f, 0x20, 0x2d, 0x01, 0x01,
-  0x6e, 0x02, 0x02, 0x03, 0x3d, 0x2a, 0x7b, 0x6e, 0x6d, 0x12, 0x70, 0x07,
-  0x07, 0x15, 0x18, 0x22, 0x1c, 0x09, 0x0d, 0x1c, 0x25, 0x12, 0x08, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x02, 0x13, 0x05, 0xd5, 0x00, 0x05,
-  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0xae, 0xa5, 0xc0, 0x05,
-  0xd5, 0xfa, 0xbe, 0x93, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x13,
-  0x05, 0xd5, 0x00, 0x07, 0x00, 0x00, 0x25, 0x33, 0x15, 0x21, 0x35, 0x33,
-  0x11, 0x33, 0x01, 0x53, 0xc0, 0xfd, 0xdb, 0xc0, 0xa5, 0x93, 0x93, 0x93,
-  0x05, 0x42, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x01, 0x54,
-  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x33,
-  0x01, 0x53, 0xfe, 0x9b, 0xc0, 0xa5, 0x93, 0x05, 0x42, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x2f, 0x03, 0x93, 0x00, 0x07,
-  0x00, 0x15, 0x00, 0x00, 0x12, 0x10, 0x16, 0x32, 0x36, 0x10, 0x26, 0x22,
-  0x01, 0x06, 0x23, 0x22, 0x02, 0x10, 0x12, 0x20, 0x12, 0x15, 0x14, 0x07,
-  0x33, 0x15, 0xf2, 0xa7, 0xeb, 0xa7, 0xa7, 0xeb, 0x01, 0x0c, 0x46, 0x51,
-  0xaf, 0xf9, 0xf9, 0x01, 0x5f, 0xf9, 0x5d, 0xd5, 0x02, 0x3e, 0xfe, 0xfa,
-  0xb9, 0xb9, 0x01, 0x06, 0xb9, 0xfd, 0x09, 0x1d, 0x01, 0x15, 0x01, 0x86,
-  0x01, 0x15, 0xfe, 0xeb, 0xc3, 0xa9, 0x7f, 0x93, 0x00, 0x02, 0xff, 0xee,
-  0xff, 0xe3, 0x04, 0x2f, 0x03, 0x93, 0x00, 0x07, 0x00, 0x19, 0x00, 0x00,
-  0x12, 0x10, 0x16, 0x32, 0x36, 0x10, 0x26, 0x22, 0x01, 0x06, 0x22, 0x27,
-  0x21, 0x35, 0x33, 0x26, 0x35, 0x34, 0x12, 0x20, 0x12, 0x15, 0x14, 0x07,
-  0x33, 0x15, 0xf2, 0xa7, 0xeb, 0xa7, 0xa7, 0xeb, 0x01, 0x0c, 0x46, 0xa1,
-  0x46, 0xfe, 0x76, 0xd5, 0x5d, 0xf9, 0x01, 0x5f, 0xf9, 0x5d, 0xd5, 0x02,
-  0x3e, 0xfe, 0xfa, 0xb9, 0xb9, 0x01, 0x06, 0xb9, 0xfd, 0x09, 0x1d, 0x1d,
-  0x93, 0x7f, 0xa9, 0xc3, 0x01, 0x15, 0xfe, 0xeb, 0xc3, 0xa9, 0x7f, 0x93,
-  0x00, 0x02, 0xff, 0xee, 0xff, 0xe3, 0x03, 0xb8, 0x03, 0x93, 0x00, 0x07,
-  0x00, 0x15, 0x00, 0x00, 0x12, 0x10, 0x16, 0x32, 0x36, 0x10, 0x26, 0x22,
-  0x03, 0x26, 0x35, 0x34, 0x12, 0x20, 0x12, 0x10, 0x02, 0x23, 0x22, 0x27,
-  0x21, 0x35, 0xf2, 0xa7, 0xeb, 0xa7, 0xa7, 0xeb, 0xd6, 0x5d, 0xf9, 0x01,
-  0x5f, 0xf9, 0xf9, 0xb0, 0x50, 0x46, 0xfe, 0x76, 0x02, 0x3e, 0xfe, 0xfa,
-  0xb9, 0xb9, 0x01, 0x06, 0xb9, 0xfd, 0x9c, 0x7f, 0xa9, 0xc3, 0x01, 0x15,
-  0xfe, 0xeb, 0xfe, 0x7a, 0xfe, 0xeb, 0x1d, 0x93, 0x00, 0x01, 0x00, 0x36,
-  0x00, 0x00, 0x03, 0x20, 0x05, 0xd9, 0x00, 0x0a, 0x00, 0x00, 0x29, 0x01,
-  0x11, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x11, 0x21, 0x03, 0x1f, 0xfe,
-  0x15, 0xfd, 0xaf, 0xa1, 0xa1, 0xae, 0xfd, 0x01, 0x46, 0x03, 0x2a, 0x02,
-  0xaf, 0xfe, 0x5d, 0x01, 0xa3, 0xfd, 0x51, 0xfd, 0x69, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x20, 0x05, 0xd9, 0x00, 0x0c,
-  0x00, 0x00, 0x25, 0x15, 0x21, 0x35, 0x21, 0x11, 0x03, 0x33, 0x1b, 0x01,
-  0x33, 0x03, 0x11, 0x03, 0x1f, 0xfc, 0xcf, 0x01, 0x46, 0xfd, 0xaf, 0xa1,
-  0xa1, 0xae, 0xfd, 0x93, 0x93, 0x93, 0x02, 0x97, 0x02, 0xaf, 0xfe, 0x5d,
-  0x01, 0xa3, 0xfd, 0x51, 0xfd, 0x69, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0xd7, 0x05, 0xd9, 0x00, 0x0a, 0x00, 0x00, 0x23, 0x35,
-  0x21, 0x11, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x11, 0x12, 0x01, 0x46,
-  0xfd, 0xaf, 0xa1, 0xa1, 0xae, 0xfd, 0x93, 0x02, 0x97, 0x02, 0xaf, 0xfe,
-  0x5d, 0x01, 0xa3, 0xfd, 0x51, 0xfc, 0xd6, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0x00, 0x00, 0x04, 0x55, 0x03, 0x71, 0x00, 0x08, 0x00, 0x00, 0x21, 0x23,
-  0x09, 0x01, 0x23, 0x01, 0x33, 0x01, 0x33, 0x04, 0x55, 0xf9, 0xfe, 0xc5,
-  0xfe, 0xc5, 0xaf, 0x01, 0x7a, 0xe1, 0x01, 0x48, 0x7b, 0x02, 0xbd, 0xfd,
-  0x43, 0x03, 0x71, 0xfd, 0x22, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x00, 0x00, 0x04, 0x55, 0x03, 0x71, 0x00, 0x0a, 0x00, 0x00, 0x33, 0x23,
-  0x35, 0x33, 0x01, 0x33, 0x01, 0x33, 0x15, 0x23, 0x01, 0xe6, 0xf8, 0x7a,
-  0x01, 0x49, 0xe1, 0x01, 0x48, 0x7b, 0xf9, 0xfe, 0xc5, 0x93, 0x02, 0xde,
-  0xfd, 0x22, 0x93, 0x02, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x00, 0x00, 0x04, 0x0c, 0x03, 0x71, 0x00, 0x08, 0x00, 0x00, 0x33, 0x23,
-  0x35, 0x33, 0x01, 0x33, 0x01, 0x23, 0x01, 0xe6, 0xf8, 0x7a, 0x01, 0x49,
-  0xe1, 0x01, 0x7a, 0xb0, 0xfe, 0xc5, 0x93, 0x02, 0xde, 0xfc, 0x8f, 0x02,
-  0xbd, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8,
-  0x03, 0x71, 0x00, 0x09, 0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21,
-  0x11, 0x33, 0x11, 0x33, 0x04, 0xc7, 0xfb, 0xe0, 0xa7, 0x02, 0x19, 0xa7,
-  0xb9, 0x03, 0x71, 0xfd, 0x22, 0x02, 0xde, 0xfd, 0x22, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x0b,
-  0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33,
-  0x11, 0x33, 0x04, 0xc7, 0xfb, 0x27, 0xb9, 0xa7, 0x02, 0x19, 0xa7, 0xb9,
-  0x93, 0x02, 0xde, 0xfd, 0x22, 0x02, 0xde, 0xfd, 0x22, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e, 0x03, 0x71, 0x00, 0x09,
-  0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33,
-  0x04, 0x0e, 0xfb, 0xe0, 0xb9, 0xa7, 0x02, 0x19, 0xa7, 0x93, 0x02, 0xde,
-  0xfd, 0x22, 0x02, 0xde, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8,
-  0x03, 0x71, 0x00, 0x09, 0x00, 0x00, 0x33, 0x35, 0x21, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x33, 0x15, 0xa7, 0x02, 0xc0, 0xfd, 0x40, 0x03, 0x67, 0xb9,
-  0x93, 0x02, 0x4b, 0x93, 0xfd, 0x22, 0x93, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x09, 0x00, 0x00, 0x23, 0x35,
-  0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x15, 0x12, 0x03, 0x79, 0xfd,
-  0x40, 0x03, 0x67, 0xb9, 0x93, 0x02, 0x4b, 0x93, 0xfd, 0x22, 0x93, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e, 0x03, 0x71, 0x00, 0x07,
-  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x04, 0x0e,
-  0xfb, 0xe0, 0x03, 0x79, 0xfd, 0x40, 0x03, 0x71, 0xfc, 0x8f, 0x93, 0x02,
-  0x4b, 0x93, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x04, 0x59,
-  0x05, 0xe2, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x00, 0x21, 0x11, 0x26, 0x27,
-  0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06,
-  0x07, 0x11, 0x21, 0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34,
-  0x2e, 0x01, 0x22, 0x06, 0x01, 0xd0, 0x49, 0x43, 0x67, 0x77, 0x77, 0xce,
-  0xf1, 0xcf, 0x76, 0x76, 0x68, 0x43, 0x4a, 0x01, 0xe2, 0xfc, 0x9a, 0x52,
-  0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x03, 0x0e, 0x0b, 0x20,
-  0x31, 0xa8, 0xc5, 0xa9, 0x62, 0x62, 0xa9, 0xc5, 0xa8, 0x31, 0x20, 0x0b,
-  0xfd, 0x85, 0x93, 0x04, 0xad, 0x70, 0x60, 0x38, 0x38, 0x60, 0x70, 0x60,
-  0x38, 0x38, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
-  0x05, 0xe2, 0x00, 0x15, 0x00, 0x21, 0x00, 0x00, 0x25, 0x21, 0x15, 0x21,
-  0x35, 0x21, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32, 0x1e,
-  0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e,
-  0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x02, 0x76, 0x01, 0xe2, 0xfb, 0x96,
-  0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x77, 0xce, 0xf1, 0xcf, 0x76, 0x76,
-  0x68, 0x43, 0x4a, 0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d,
-  0xa6, 0x8c, 0x93, 0x93, 0x93, 0x02, 0x7b, 0x0b, 0x20, 0x31, 0xa8, 0xc5,
-  0xa9, 0x62, 0x62, 0xa9, 0xc5, 0xa8, 0x31, 0x20, 0x0b, 0x01, 0x9f, 0x70,
-  0x60, 0x38, 0x38, 0x60, 0x70, 0x60, 0x38, 0x38, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xe1, 0x05, 0xe2, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x00,
-  0x23, 0x35, 0x21, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32,
-  0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x00, 0x14, 0x1e, 0x01,
-  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x12, 0x01, 0xe2, 0x49,
-  0x43, 0x67, 0x77, 0x77, 0xce, 0xf1, 0xcf, 0x76, 0x76, 0x68, 0x43, 0x4a,
-  0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x93,
-  0x02, 0x7b, 0x0b, 0x20, 0x31, 0xa8, 0xc5, 0xa9, 0x62, 0x62, 0xa9, 0xc5,
-  0xa8, 0x31, 0x20, 0x0b, 0xfc, 0xf2, 0x04, 0xad, 0x70, 0x60, 0x38, 0x38,
-  0x60, 0x70, 0x60, 0x38, 0x38, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
-  0x00, 0x00, 0x04, 0xc8, 0x04, 0xa6, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x00,
-  0x01, 0x10, 0x33, 0x15, 0x22, 0x07, 0x33, 0x15, 0x23, 0x01, 0x21, 0x35,
-  0x21, 0x01, 0xdc, 0xda, 0x77, 0x02, 0x78, 0xd9, 0x02, 0xeb, 0xfb, 0xe0,
-  0x04, 0x20, 0x03, 0x9c, 0x01, 0x0a, 0x66, 0x9a, 0x9e, 0xfc, 0xf8, 0x93,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0xc8, 0x04, 0xa6, 0x00, 0x08,
-  0x00, 0x0c, 0x00, 0x00, 0x01, 0x10, 0x33, 0x15, 0x22, 0x07, 0x33, 0x15,
-  0x23, 0x01, 0x21, 0x35, 0x21, 0x01, 0xdc, 0xda, 0x77, 0x02, 0x78, 0xd9,
-  0x02, 0xeb, 0xfb, 0x27, 0x04, 0xd9, 0x03, 0x9c, 0x01, 0x0a, 0x66, 0x9a,
-  0x9e, 0xfc, 0xf8, 0x93, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e,
-  0x04, 0xa6, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x10, 0x33, 0x15,
-  0x22, 0x07, 0x33, 0x15, 0x23, 0x01, 0x21, 0x35, 0x21, 0x01, 0xdc, 0xda,
-  0x77, 0x02, 0x78, 0xd9, 0x02, 0x32, 0xfb, 0xe0, 0x04, 0x20, 0x03, 0x9c,
-  0x01, 0x0a, 0x66, 0x9a, 0x9e, 0xfc, 0xf8, 0x93, 0x00, 0x02, 0x00, 0x65,
-  0x00, 0x00, 0x06, 0x0a, 0x05, 0xee, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x00,
-  0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x22, 0x26, 0x10, 0x36, 0x20,
-  0x17, 0x16, 0x1d, 0x01, 0x21, 0x11, 0x33, 0x15, 0x01, 0x35, 0x34, 0x27,
-  0x26, 0x22, 0x06, 0x14, 0x16, 0x33, 0x04, 0xa9, 0xfe, 0x70, 0x8d, 0xdf,
-  0xa9, 0x9e, 0x9f, 0x01, 0x42, 0x55, 0x7d, 0x02, 0x37, 0xb9, 0xfc, 0x83,
-  0x53, 0x33, 0xb2, 0x62, 0x67, 0x54, 0x02, 0xde, 0xfe, 0xc4, 0x01, 0x3c,
-  0xd6, 0x01, 0x55, 0xe5, 0x66, 0x98, 0xb6, 0xc9, 0xfd, 0x22, 0x93, 0x03,
-  0x71, 0xc9, 0x83, 0x5d, 0x38, 0x98, 0xc6, 0x83, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x06, 0x0a, 0x05, 0xee, 0x00, 0x15, 0x00, 0x1f, 0x00, 0x00,
-  0x25, 0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x22, 0x26, 0x10, 0x36, 0x20,
-  0x17, 0x16, 0x1d, 0x01, 0x21, 0x11, 0x33, 0x15, 0x21, 0x35, 0x01, 0x35,
-  0x34, 0x27, 0x26, 0x22, 0x06, 0x14, 0x16, 0x33, 0x04, 0xa9, 0xfe, 0x70,
-  0x8d, 0xdf, 0xa9, 0x9e, 0x9f, 0x01, 0x42, 0x55, 0x7d, 0x02, 0x37, 0xb9,
-  0xf9, 0xe5, 0x02, 0x9e, 0x53, 0x33, 0xb2, 0x62, 0x67, 0x54, 0x93, 0x02,
-  0x4b, 0xfe, 0xc4, 0x01, 0x3c, 0xd6, 0x01, 0x55, 0xe5, 0x66, 0x98, 0xb6,
-  0xc9, 0xfd, 0x22, 0x93, 0x93, 0x02, 0xde, 0xc9, 0x83, 0x5d, 0x38, 0x98,
-  0xc6, 0x83, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0x50,
-  0x05, 0xee, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x23, 0x22, 0x26, 0x10, 0x36, 0x20, 0x17, 0x16, 0x1d, 0x01,
-  0x21, 0x11, 0x21, 0x35, 0x01, 0x35, 0x34, 0x27, 0x26, 0x22, 0x06, 0x14,
-  0x16, 0x33, 0x04, 0xa9, 0xfe, 0x70, 0x8d, 0xdf, 0xa9, 0x9e, 0x9f, 0x01,
-  0x42, 0x55, 0x7d, 0x02, 0x37, 0xfa, 0x9e, 0x02, 0x9e, 0x53, 0x33, 0xb2,
-  0x62, 0x67, 0x54, 0x93, 0x02, 0x4b, 0xfe, 0xc4, 0x01, 0x3c, 0xd6, 0x01,
-  0x55, 0xe5, 0x66, 0x98, 0xb6, 0xc9, 0xfc, 0x8f, 0x93, 0x02, 0xde, 0xc9,
-  0x83, 0x5d, 0x38, 0x98, 0xc6, 0x83, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad,
-  0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x33, 0x11,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0xae, 0x02,
-  0x42, 0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x01, 0xe6, 0x05, 0xd5, 0x93,
-  0xfe, 0x2f, 0x92, 0xfd, 0xb4, 0x93, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x23, 0x35,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15,
-  0x12, 0xc0, 0x02, 0x42, 0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x01, 0xe6,
-  0x93, 0x05, 0x42, 0x93, 0xfe, 0x2f, 0x92, 0xfd, 0xb4, 0x93, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0xf1, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
-  0x15, 0x21, 0x01, 0x53, 0xfe, 0x9b, 0xc0, 0x02, 0x42, 0xfe, 0x63, 0x01,
-  0x9d, 0xfe, 0x63, 0x93, 0x05, 0x42, 0x93, 0xfe, 0x2f, 0x92, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0b,
-  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x33, 0x15, 0x01, 0xd4, 0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x02, 0x43,
-  0xbf, 0x02, 0xdf, 0x92, 0x01, 0xd1, 0x93, 0xfa, 0xbe, 0x93, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x33, 0x15, 0x12, 0x01, 0xe6, 0xfe, 0x63, 0x01, 0x9d, 0xfe,
-  0x63, 0x02, 0x43, 0xbf, 0x93, 0x02, 0x4c, 0x92, 0x01, 0xd1, 0x93, 0xfa,
-  0xbe, 0x93, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x7a,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21,
-  0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x02, 0x7a, 0xfd, 0x74, 0x01, 0xe6,
-  0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x02, 0x43, 0x93, 0x02, 0x4c, 0x92,
-  0x01, 0xd1, 0x93, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x18,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x17, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0x11, 0x33, 0x11, 0x21,
-  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x33, 0x15, 0x02, 0x59, 0xfe, 0xef,
-  0x01, 0x0e, 0x49, 0x2f, 0x28, 0x28, 0x37, 0xfe, 0x10, 0xa7, 0x01, 0x33,
-  0x5e, 0x73, 0x4f, 0x47, 0xbe, 0x02, 0xde, 0xfd, 0xb5, 0x5d, 0x4f, 0x7a,
-  0x7d, 0x49, 0x5f, 0xfd, 0x22, 0x05, 0xd5, 0xfd, 0x9c, 0x87, 0x5f, 0xd2,
-  0xa4, 0x82, 0x93, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x18,
-  0x05, 0xd5, 0x00, 0x0e, 0x00, 0x19, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11,
-  0x33, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x33, 0x15, 0x01,
-  0x21, 0x11, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x12, 0xb9,
-  0xa7, 0x01, 0x33, 0x5e, 0x73, 0x4f, 0x47, 0xbe, 0xfe, 0x41, 0xfe, 0xef,
-  0x01, 0x0e, 0x49, 0x2f, 0x28, 0x28, 0x37, 0x93, 0x05, 0x42, 0xfd, 0x9c,
-  0x87, 0x5f, 0xd2, 0xa4, 0x82, 0x93, 0x02, 0xde, 0xfd, 0xb5, 0x5d, 0x4f,
-  0x7a, 0x7d, 0x49, 0x5f, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xa1,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x19, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0x35, 0x33, 0x11, 0x33,
-  0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x02, 0x59,
-  0xfe, 0xef, 0x01, 0x0e, 0x49, 0x2f, 0x28, 0x28, 0x37, 0xfd, 0x57, 0xb9,
-  0xa7, 0x01, 0x33, 0x5e, 0x73, 0x4f, 0x4f, 0x50, 0x61, 0x02, 0xde, 0xfd,
-  0xb5, 0x5d, 0x4f, 0x7a, 0x7d, 0x49, 0x5f, 0xfd, 0x22, 0x93, 0x05, 0x42,
-  0xfd, 0x9c, 0x87, 0x5f, 0xd2, 0xad, 0x87, 0x85, 0x00, 0x01, 0x00, 0xad,
-  0x00, 0x00, 0x04, 0x7a, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x21, 0x34,
-  0x02, 0x27, 0x26, 0x27, 0x03, 0x35, 0x21, 0x15, 0x05, 0x13, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x15, 0x21, 0x15, 0x02, 0x66, 0x18, 0x30, 0x46, 0x7b,
-  0xaf, 0x03, 0x0c, 0xfd, 0xd6, 0x8e, 0x7a, 0x2f, 0x3b, 0x06, 0x02, 0x01,
-  0x70, 0x99, 0x01, 0x5f, 0x96, 0xdc, 0xdc, 0x01, 0x39, 0x56, 0x93, 0x01,
-  0xfe, 0xef, 0xea, 0xb8, 0xe6, 0x9c, 0x40, 0x39, 0x93, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0x7a, 0x05, 0xd5, 0x00, 0x16,
-  0x00, 0x00, 0x23, 0x35, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03,
-  0x35, 0x21, 0x15, 0x05, 0x13, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x21,
-  0x15, 0x12, 0x02, 0x75, 0x03, 0x07, 0x0b, 0x30, 0x46, 0x7b, 0xaf, 0x03,
-  0x0c, 0xfd, 0xd6, 0x8e, 0x7a, 0x2f, 0x3b, 0x06, 0x02, 0x01, 0x70, 0x93,
-  0x58, 0x5d, 0xb0, 0x96, 0xdc, 0xdc, 0x01, 0x39, 0x56, 0x93, 0x01, 0xfe,
-  0xef, 0xea, 0xb8, 0xe6, 0x9c, 0x40, 0x39, 0x93, 0x00, 0x01, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xba, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x23, 0x35,
-  0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x35, 0x21, 0x15, 0x05,
-  0x13, 0x16, 0x17, 0x16, 0x12, 0x07, 0x12, 0x02, 0x75, 0x03, 0x07, 0x0b,
-  0x30, 0x46, 0x7b, 0xaf, 0x03, 0x0c, 0xfd, 0xd6, 0x8e, 0x7a, 0x2f, 0x3b,
-  0x0a, 0x01, 0x93, 0x58, 0x5d, 0xb0, 0x96, 0xdc, 0xdc, 0x01, 0x39, 0x56,
-  0x93, 0x01, 0xfe, 0xef, 0xea, 0xb8, 0xe6, 0xfe, 0xc9, 0x71, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x02, 0x98, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x00, 0x21, 0x11, 0x03, 0x35, 0x13, 0x33, 0x11, 0x33, 0x15, 0x01,
-  0x32, 0xfb, 0xf9, 0xa8, 0xbf, 0x04, 0xdf, 0xfe, 0xc7, 0xf6, 0x01, 0x39,
-  0xfa, 0xbe, 0x93, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x98,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x03, 0x35,
-  0x13, 0x33, 0x11, 0x33, 0x15, 0x12, 0x01, 0x44, 0xfb, 0xf9, 0xa8, 0xbf,
-  0x93, 0x04, 0x4c, 0xfe, 0xc7, 0xf6, 0x01, 0x39, 0xfa, 0xbe, 0x93, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x01, 0xd8, 0x05, 0xd5, 0x00, 0x08,
-  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x03, 0x35, 0x13, 0x33, 0x11, 0x12,
-  0x01, 0x44, 0xfb, 0xf9, 0xa8, 0x93, 0x04, 0x4c, 0xfe, 0xc7, 0xf6, 0x01,
-  0x39, 0xfa, 0x2b, 0x00, 0x00, 0x03, 0x00, 0xad, 0x00, 0x00, 0x06, 0xfa,
-  0x04, 0x1a, 0x00, 0x11, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x33, 0x11,
-  0x34, 0x12, 0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16,
-  0x15, 0x11, 0x33, 0x15, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11,
-  0x21, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0xae, 0xdb,
-  0xb3, 0x70, 0x6c, 0x30, 0x21, 0x87, 0xbe, 0xbd, 0x55, 0x7a, 0xc0, 0xfe,
-  0x98, 0x93, 0x51, 0x74, 0x72, 0x01, 0xca, 0xfd, 0x8e, 0x94, 0x50, 0x62,
-  0x85, 0x01, 0xcb, 0x01, 0xee, 0xa6, 0x00, 0xff, 0x4b, 0x2d, 0x2d, 0xd2,
-  0x58, 0x80, 0x68, 0xfd, 0xb9, 0x93, 0x02, 0x7c, 0x82, 0x80, 0xc5, 0x95,
-  0xfe, 0x6e, 0x01, 0x63, 0x83, 0x7f, 0xa7, 0xd2, 0xf2, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x06, 0xfa, 0x04, 0x1a, 0x00, 0x13,
-  0x00, 0x1c, 0x00, 0x25, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11, 0x34, 0x12,
-  0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
-  0x33, 0x15, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x01,
-  0x34, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x12, 0xc0, 0xdb, 0xb3,
-  0x70, 0x6c, 0x30, 0x21, 0x87, 0xbe, 0xbd, 0x55, 0x7a, 0xc0, 0xfe, 0x98,
-  0x93, 0x51, 0x74, 0x72, 0x01, 0xca, 0xfd, 0x8e, 0x94, 0x50, 0x62, 0x85,
-  0x01, 0xcb, 0x93, 0x01, 0x5b, 0xa6, 0x00, 0xff, 0x4b, 0x2d, 0x2d, 0xd2,
-  0x58, 0x80, 0x68, 0xfd, 0xb9, 0x93, 0x02, 0x7c, 0x82, 0x80, 0xc5, 0x95,
-  0xfe, 0x6e, 0x01, 0x63, 0x83, 0x7f, 0xa7, 0xd2, 0xf2, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x06, 0x3a, 0x04, 0x1a, 0x00, 0x11,
-  0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11, 0x34, 0x12,
-  0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
-  0x03, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x01, 0x34, 0x26,
-  0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x12, 0xc0, 0xdb, 0xb3, 0x70, 0x6c,
-  0x30, 0x21, 0x87, 0xbe, 0xbd, 0x55, 0x7a, 0xa8, 0x93, 0x51, 0x74, 0x72,
-  0x01, 0xca, 0xfd, 0x8e, 0x94, 0x50, 0x62, 0x85, 0x01, 0xcb, 0x93, 0x01,
-  0x5b, 0xa6, 0x00, 0xff, 0x4b, 0x2d, 0x2d, 0xd2, 0x58, 0x80, 0x68, 0xfd,
-  0x26, 0x02, 0x7c, 0x82, 0x80, 0xc5, 0x95, 0xfe, 0x6e, 0x01, 0x63, 0x83,
-  0x7f, 0xa7, 0xd2, 0xf2, 0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x03, 0x7a,
-  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
-  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x01, 0x61, 0xfe, 0xd6,
-  0x01, 0x2a, 0xa5, 0x01, 0x2a, 0xfe, 0xd6, 0x01, 0x73, 0x03, 0x81, 0x93,
-  0x01, 0xc1, 0xfe, 0x3f, 0x93, 0xfd, 0x12, 0x93, 0x00, 0x01, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0x7a, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x23, 0x35,
-  0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x21, 0x15, 0x12, 0x01, 0x73, 0xfe, 0xd6, 0x01, 0x2a, 0xa5, 0x01, 0x2a,
-  0xfe, 0xd6, 0x01, 0x73, 0x93, 0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe, 0x3f,
-  0x93, 0xfd, 0x12, 0x93, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x31,
-  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21,
-  0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x02, 0x06, 0xfd, 0xe8,
-  0x01, 0x73, 0xfe, 0xd6, 0x01, 0x2a, 0xa5, 0x01, 0x2a, 0xfe, 0xd6, 0x93,
-  0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe, 0x3f, 0x93, 0x00, 0x02, 0x00, 0x36,
-  0x00, 0x00, 0x05, 0xb6, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x15, 0x00, 0x00,
-  0x25, 0x11, 0x21, 0x11, 0x07, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x03, 0x9d,
-  0xfe, 0x6a, 0xa6, 0xfe, 0xd6, 0x01, 0x2a, 0xa6, 0x01, 0x96, 0xa6, 0x01,
-  0x2b, 0xfe, 0xd5, 0x01, 0x73, 0x93, 0x02, 0xee, 0xfd, 0x12, 0x93, 0x03,
-  0x81, 0x93, 0x01, 0xc1, 0xfe, 0x3f, 0x01, 0xc1, 0xfe, 0x3f, 0x93, 0xfd,
-  0x12, 0x93, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0xb6,
-  0x05, 0xd5, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11,
-  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15,
-  0x21, 0x11, 0x21, 0x15, 0x25, 0x11, 0x21, 0x11, 0x12, 0x01, 0x73, 0xfe,
-  0xd6, 0x01, 0x2a, 0xa6, 0x01, 0x96, 0xa6, 0x01, 0x2b, 0xfe, 0xd5, 0x01,
-  0x73, 0xfd, 0xe7, 0xfe, 0x6a, 0x93, 0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe,
-  0x3f, 0x01, 0xc1, 0xfe, 0x3f, 0x93, 0xfd, 0x12, 0x93, 0x93, 0x02, 0xee,
-  0xfd, 0x12, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0x6e,
-  0x05, 0xd5, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21,
-  0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
-  0x15, 0x21, 0x03, 0x11, 0x21, 0x11, 0x04, 0x43, 0xfb, 0xab, 0x01, 0x73,
-  0xfe, 0xd6, 0x01, 0x2a, 0xa6, 0x01, 0x96, 0xa6, 0x01, 0x2b, 0xfe, 0xd5,
-  0xa6, 0xfe, 0x6a, 0x93, 0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe, 0x3f, 0x01,
-  0xc1, 0xfe, 0x3f, 0x93, 0xfd, 0x12, 0x02, 0xee, 0xfd, 0x12, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x05,
-  0x00, 0x09, 0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x33, 0x15, 0x01, 0x11,
-  0x21, 0x11, 0xa7, 0x03, 0x67, 0xb9, 0xfc, 0x87, 0x02, 0x19, 0x03, 0x71,
-  0xfd, 0x22, 0x93, 0x02, 0xde, 0xfd, 0xb5, 0x02, 0x4b, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x07,
-  0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11, 0x21, 0x11, 0x33, 0x15,
-  0x01, 0x11, 0x21, 0x11, 0x12, 0xb9, 0x03, 0x67, 0xb9, 0xfc, 0x87, 0x02,
-  0x19, 0x93, 0x02, 0xde, 0xfd, 0x22, 0x93, 0x02, 0xde, 0xfd, 0xb5, 0x02,
-  0x4b, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e,
-  0x03, 0x71, 0x00, 0x05, 0x00, 0x09, 0x00, 0x00, 0x29, 0x01, 0x35, 0x33,
-  0x11, 0x21, 0x05, 0x11, 0x21, 0x11, 0x04, 0x0e, 0xfb, 0xe0, 0xb9, 0x03,
-  0x67, 0xfd, 0x40, 0x02, 0x19, 0x93, 0x02, 0xde, 0x93, 0xfd, 0xb5, 0x02,
-  0x4b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x04, 0x92,
-  0x05, 0xd5, 0x00, 0x02, 0x00, 0x08, 0x00, 0x00, 0x01, 0x21, 0x01, 0x07,
-  0x01, 0x21, 0x01, 0x21, 0x15, 0x03, 0x65, 0xfd, 0xb6, 0x01, 0x25, 0x68,
-  0xfe, 0x5f, 0x04, 0x12, 0xfe, 0x91, 0x01, 0xb8, 0x05, 0x42, 0xfb, 0x7e,
-  0xc0, 0x05, 0xd5, 0xfa, 0xbe, 0x93, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x04, 0x92, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00,
-  0x01, 0x21, 0x01, 0x05, 0x35, 0x21, 0x01, 0x21, 0x01, 0x21, 0x15, 0x03,
-  0x65, 0xfd, 0xb6, 0x01, 0x25, 0xfd, 0xae, 0x01, 0xb8, 0xfe, 0x91, 0x04,
-  0x12, 0xfe, 0x91, 0x01, 0xb8, 0x05, 0x42, 0xfb, 0x7e, 0xc0, 0x93, 0x05,
-  0x42, 0xfa, 0xbe, 0x93, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x4a,
-  0x05, 0xd5, 0x00, 0x02, 0x00, 0x08, 0x00, 0x00, 0x01, 0x21, 0x01, 0x05,
-  0x35, 0x21, 0x01, 0x21, 0x01, 0x03, 0x65, 0xfd, 0xb6, 0x01, 0x25, 0xfd,
-  0xae, 0x01, 0xb8, 0xfe, 0x91, 0x04, 0x12, 0xfe, 0x5f, 0x05, 0x42, 0xfb,
-  0x7e, 0xc0, 0x93, 0x05, 0x42, 0xfa, 0x2b, 0x00, 0x00, 0x03, 0x00, 0xad,
-  0x00, 0x00, 0x05, 0x5b, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x1f,
-  0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b,
-  0x01, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11, 0x21, 0x32, 0x17,
-  0x16, 0x15, 0x06, 0x07, 0x06, 0x2f, 0x01, 0x11, 0x21, 0x15, 0x03, 0x15,
-  0x97, 0x55, 0x21, 0x1b, 0x1b, 0x1b, 0x5e, 0x94, 0xfe, 0x3f, 0x01, 0x1c,
-  0xfe, 0x3e, 0x01, 0xc2, 0x01, 0x84, 0x77, 0x3a, 0x3e, 0x01, 0x3d, 0x53,
-  0x7e, 0xbf, 0x02, 0x46, 0x03, 0x71, 0x51, 0x45, 0x3d, 0x3c, 0x64, 0x5e,
-  0xfd, 0x9c, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x03, 0x71, 0x02, 0x64,
-  0x85, 0x90, 0x7c, 0x91, 0x5b, 0x7c, 0x01, 0x01, 0xfd, 0xb5, 0x93, 0x00,
-  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x05, 0x5b, 0x05, 0xd5, 0x00, 0x0a,
-  0x00, 0x0e, 0x00, 0x21, 0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x2b, 0x01, 0x01, 0x11, 0x21, 0x11, 0x01, 0x35, 0x33,
-  0x11, 0x21, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06, 0x2f,
-  0x01, 0x11, 0x21, 0x15, 0x03, 0x15, 0x97, 0x55, 0x21, 0x1b, 0x1b, 0x1b,
-  0x5e, 0x94, 0xfe, 0x3f, 0x01, 0x1c, 0xfd, 0x7e, 0xc0, 0x01, 0xc2, 0x01,
-  0x84, 0x77, 0x3a, 0x3e, 0x01, 0x3d, 0x53, 0x7e, 0xbf, 0x02, 0x46, 0x03,
-  0x71, 0x51, 0x45, 0x3d, 0x3c, 0x64, 0x5e, 0xfd, 0x9c, 0xfd, 0xb5, 0x02,
-  0x4b, 0xfd, 0x22, 0x93, 0x02, 0xde, 0x02, 0x64, 0x85, 0x90, 0x7c, 0x91,
-  0x5b, 0x7c, 0x01, 0x01, 0xfd, 0xb5, 0x93, 0x00, 0x00, 0x03, 0xff, 0xee,
-  0x00, 0x00, 0x04, 0xe3, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x1f,
-  0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b,
-  0x01, 0x01, 0x11, 0x21, 0x11, 0x13, 0x21, 0x35, 0x33, 0x11, 0x21, 0x11,
-  0x21, 0x32, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06, 0x2f, 0x01, 0x03, 0x15,
-  0x97, 0x55, 0x21, 0x1b, 0x1b, 0x1b, 0x5e, 0x94, 0xfe, 0x3f, 0x01, 0x1c,
-  0xa5, 0xfc, 0xd9, 0xc0, 0x01, 0xc2, 0x01, 0x84, 0x77, 0x3a, 0x3e, 0x01,
-  0x3d, 0x53, 0x7e, 0xbf, 0x03, 0x71, 0x51, 0x45, 0x3d, 0x3c, 0x64, 0x5e,
-  0xfd, 0x9c, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x93, 0x02, 0xde, 0x02,
-  0x64, 0x85, 0x90, 0x7c, 0x91, 0x5b, 0x7c, 0x01, 0x01, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x03, 0xe3, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x33, 0x11, 0x33, 0x15, 0x02, 0x7e, 0xfe, 0xd6, 0xa6, 0xa6, 0x01, 0x2a,
-  0xa6, 0xbe, 0x03, 0x81, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0x01, 0xc1,
-  0xfa, 0xbe, 0x93, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe3,
-  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x12, 0x02,
-  0x90, 0xfe, 0xd6, 0xa6, 0xa6, 0x01, 0x2a, 0xa6, 0xbe, 0x93, 0x02, 0xee,
-  0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0x01, 0xc1, 0xfa, 0xbe, 0x93, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x24, 0x05, 0xd5, 0x00, 0x0d,
-  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x33, 0x11, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6, 0xa6, 0x01,
-  0x2a, 0xa6, 0x93, 0x02, 0xee, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0x01,
-  0xc1, 0xfa, 0x2b, 0x00, 0x00, 0x02, 0x00, 0x64, 0x00, 0x00, 0x05, 0x49,
-  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0x11, 0x21, 0x22, 0x27,
-  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
-  0x21, 0x15, 0x01, 0xac, 0x01, 0x12, 0xfe, 0xf2, 0x4a, 0x2f, 0x27, 0x27,
-  0x37, 0x01, 0x4a, 0xfe, 0xcd, 0x61, 0x70, 0x4f, 0x4f, 0x4f, 0x61, 0x01,
-  0xfa, 0x01, 0x2b, 0xfe, 0xd5, 0x01, 0xeb, 0x02, 0xf7, 0x02, 0x4b, 0x5d,
-  0x4f, 0x7a, 0x7d, 0x49, 0x5f, 0xfd, 0x09, 0x02, 0x64, 0x87, 0x5f, 0xd2,
-  0xad, 0x87, 0x85, 0xfd, 0x22, 0x93, 0xfe, 0x2f, 0x93, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0x49, 0x05, 0xd5, 0x00, 0x0a,
-  0x00, 0x1f, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x22, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x01, 0x35, 0x21, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x33, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15,
-  0x01, 0xac, 0x01, 0x12, 0xfe, 0xf2, 0x4a, 0x2f, 0x27, 0x27, 0x37, 0xfe,
-  0x80, 0x02, 0xca, 0xfe, 0xcd, 0x61, 0x70, 0x4f, 0x4f, 0x4f, 0x61, 0x01,
-  0xfa, 0x01, 0x2b, 0xfe, 0xd5, 0x01, 0xeb, 0x02, 0xf7, 0x02, 0x4b, 0x5d,
-  0x4f, 0x7a, 0x7d, 0x49, 0x5f, 0xfd, 0x09, 0x93, 0x01, 0xd1, 0x87, 0x5f,
-  0xd2, 0xad, 0x87, 0x85, 0xfd, 0x22, 0x93, 0xfe, 0x2f, 0x93, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x89, 0x05, 0xd5, 0x00, 0x0a,
-  0x00, 0x1d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x22, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x01, 0x35, 0x21, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x33, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xac,
-  0x01, 0x12, 0xfe, 0xf2, 0x4a, 0x2f, 0x27, 0x27, 0x37, 0xfe, 0x80, 0x02,
-  0xca, 0xfe, 0xcd, 0x61, 0x70, 0x4f, 0x4f, 0x4f, 0x61, 0x01, 0xfa, 0x01,
-  0x2b, 0xfe, 0xd5, 0x02, 0xf7, 0x02, 0x4b, 0x5d, 0x4f, 0x7a, 0x7d, 0x49,
-  0x5f, 0xfd, 0x09, 0x93, 0x01, 0xd1, 0x87, 0x5f, 0xd2, 0xad, 0x87, 0x85,
-  0xfd, 0x22, 0x93, 0xfd, 0x9c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36,
-  0x00, 0x00, 0x03, 0x7a, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x21, 0x11,
-  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x01, 0x61, 0xfe, 0xd6,
-  0x02, 0xf9, 0xfe, 0xd6, 0x01, 0x73, 0x05, 0x42, 0x93, 0x93, 0xfb, 0x51,
-  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x7a,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x35,
-  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x12, 0x01, 0x73, 0xfe, 0xd6, 0x02,
-  0xf9, 0xfe, 0xd6, 0x01, 0x73, 0x93, 0x04, 0xaf, 0x93, 0x93, 0xfb, 0x51,
-  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x31,
-  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21,
-  0x35, 0x21, 0x15, 0x21, 0x02, 0x06, 0xfd, 0xe8, 0x01, 0x73, 0xfe, 0xd6,
-  0x02, 0xf9, 0xfe, 0xd6, 0x93, 0x04, 0xaf, 0x93, 0x93, 0x00, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x04, 0x92, 0x05, 0xd5, 0x00, 0x02,
-  0x00, 0x08, 0x00, 0x00, 0x25, 0x09, 0x01, 0x07, 0x01, 0x33, 0x01, 0x33,
-  0x15, 0x03, 0x65, 0xfe, 0xdb, 0xfe, 0xdb, 0xe4, 0x01, 0xa1, 0xd0, 0x01,
-  0x6f, 0x7b, 0x93, 0x04, 0x82, 0xfb, 0x7e, 0x93, 0x05, 0xd5, 0xfa, 0xbe,
-  0x93, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x92,
-  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00, 0x25, 0x09, 0x01, 0x05,
-  0x35, 0x33, 0x01, 0x33, 0x01, 0x33, 0x15, 0x03, 0x65, 0xfe, 0xdb, 0xfe,
-  0xdb, 0xfe, 0xd3, 0x7b, 0x01, 0x6f, 0xd0, 0x01, 0x6f, 0x7b, 0x93, 0x04,
-  0x82, 0xfb, 0x7e, 0x93, 0x93, 0x05, 0x42, 0xfa, 0xbe, 0x93, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x4a, 0x05, 0xd5, 0x00, 0x02,
-  0x00, 0x08, 0x00, 0x00, 0x25, 0x09, 0x01, 0x05, 0x35, 0x33, 0x01, 0x33,
-  0x01, 0x03, 0x65, 0xfe, 0xdb, 0xfe, 0xdb, 0xfe, 0xd3, 0x7b, 0x01, 0x6f,
-  0xd0, 0x01, 0xa1, 0x93, 0x04, 0x82, 0xfb, 0x7e, 0x93, 0x93, 0x05, 0x42,
-  0xfa, 0x2b, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x04, 0x59,
-  0x05, 0xd5, 0x00, 0x1c, 0x00, 0x28, 0x00, 0x00, 0x21, 0x11, 0x26, 0x27,
-  0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x21, 0x35, 0x21,
-  0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x15, 0x21,
-  0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22,
-  0x06, 0x01, 0xd0, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49,
-  0xfe, 0xd6, 0x01, 0xd0, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b,
-  0x01, 0xe2, 0xfc, 0x9a, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6,
-  0x8c, 0x01, 0x86, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f,
-  0x0b, 0xf3, 0x93, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31,
-  0x20, 0x0b, 0xf2, 0x93, 0x03, 0x22, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70,
-  0x60, 0x38, 0x38, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
-  0x05, 0xd5, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x00, 0x23, 0x35, 0x21, 0x35,
-  0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x21,
-  0x35, 0x21, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07,
-  0x15, 0x21, 0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e,
-  0x01, 0x22, 0x06, 0x12, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e,
-  0x64, 0x43, 0x49, 0xfe, 0xd6, 0x01, 0xd0, 0x4f, 0x3e, 0x67, 0x77, 0x77,
-  0x67, 0x42, 0x4b, 0x01, 0xe2, 0xfc, 0x9a, 0x52, 0x8c, 0xa6, 0x8d, 0x51,
-  0x51, 0x8d, 0xa6, 0x8c, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53,
-  0x56, 0x2f, 0x1f, 0x0b, 0xf3, 0x93, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6,
-  0xc6, 0xa6, 0x31, 0x20, 0x0b, 0xf2, 0x93, 0x03, 0x22, 0x70, 0x5f, 0x38,
-  0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xe1, 0x05, 0xd5, 0x00, 0x1c, 0x00, 0x28, 0x00, 0x00,
-  0x23, 0x35, 0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37,
-  0x36, 0x37, 0x35, 0x21, 0x35, 0x21, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14,
-  0x06, 0x07, 0x06, 0x07, 0x11, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01,
-  0x34, 0x2e, 0x01, 0x22, 0x06, 0x12, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77,
-  0x3c, 0x3e, 0x64, 0x43, 0x49, 0xfe, 0xd6, 0x01, 0xd0, 0x4f, 0x3e, 0x67,
-  0x77, 0x77, 0x67, 0x42, 0x4b, 0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51,
-  0x51, 0x8d, 0xa6, 0x8c, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53,
-  0x56, 0x2f, 0x1f, 0x0b, 0xf3, 0x93, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6,
-  0xc6, 0xa6, 0x31, 0x20, 0x0b, 0xfe, 0x7b, 0x03, 0x22, 0x70, 0x5f, 0x38,
-  0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad,
-  0x00, 0x00, 0x03, 0xe3, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x21, 0x11,
-  0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x33, 0x15, 0x02, 0x7e, 0xfe, 0xd6,
-  0xa6, 0x02, 0x76, 0xbe, 0x05, 0x42, 0xfe, 0xc5, 0x01, 0xce, 0xfa, 0xbe,
-  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe3,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x21, 0x11, 0x33, 0x15, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6,
-  0x02, 0x76, 0xbe, 0x93, 0x04, 0xaf, 0xfe, 0xc5, 0x01, 0xce, 0xfa, 0xbe,
-  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x24,
-  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x21, 0x11, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6, 0x02, 0x76,
-  0x93, 0x04, 0xaf, 0xfe, 0xc5, 0x01, 0xce, 0xfa, 0x2b, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x03, 0xe3, 0x04, 0xe6, 0x00, 0x0b,
-  0x00, 0x00, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
-  0x33, 0x15, 0x02, 0x7e, 0xfe, 0xd6, 0xa6, 0xa6, 0x01, 0xd0, 0xbe, 0x03,
-  0x4f, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0xfc, 0xb1, 0x93, 0x00, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe3, 0x04, 0xe6, 0x00, 0x0d,
-  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11,
-  0x21, 0x11, 0x33, 0x15, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6, 0xa6, 0x01,
-  0xd0, 0xbe, 0x93, 0x02, 0xbc, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0xfc,
-  0xb1, 0x93, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x24,
-  0x04, 0xe6, 0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
-  0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6,
-  0xa6, 0x01, 0xd0, 0x93, 0x02, 0xbc, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc,
-  0xfc, 0x1e, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad, 0x00, 0x00, 0x03, 0xd5,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
-  0x01, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x15, 0x01, 0x54,
-  0x01, 0x1c, 0xfe, 0x3e, 0x01, 0xc2, 0xfe, 0x3e, 0x02, 0x67, 0xc0, 0x02,
-  0xde, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x03, 0x71, 0x01, 0xd1, 0x93,
-  0xfa, 0xbe, 0x93, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xd5,
-  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
-  0x01, 0x35, 0x33, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x15,
-  0x01, 0x54, 0x01, 0x1c, 0xfd, 0x7e, 0xc0, 0x01, 0xc2, 0xfe, 0x3e, 0x02,
-  0x67, 0xc0, 0x02, 0xde, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x93, 0x02,
-  0xde, 0x01, 0xd1, 0x93, 0xfa, 0xbe, 0x93, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0x16, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00,
-  0x01, 0x11, 0x21, 0x11, 0x01, 0x35, 0x33, 0x11, 0x21, 0x11, 0x21, 0x35,
-  0x21, 0x11, 0x01, 0x54, 0x01, 0x1c, 0xfd, 0x7e, 0xc0, 0x01, 0xc2, 0xfe,
-  0x3e, 0x02, 0x67, 0x02, 0xde, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x93,
-  0x02, 0xde, 0x01, 0xd1, 0x93, 0xfa, 0x2b, 0x00, 0x00, 0x02, 0x00, 0x65,
-  0x00, 0x00, 0x04, 0x59, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x26, 0x00, 0x00,
-  0x12, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06,
-  0x13, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x11, 0x33, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07,
-  0x15, 0x21, 0x15, 0xf2, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6,
-  0x8c, 0x8c, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xa6,
-  0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b, 0x01, 0xe2, 0x03, 0x22,
-  0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0xfc, 0x7e, 0x01,
-  0x86, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f, 0x0b, 0x01,
-  0x86, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31, 0x20, 0x0b,
-  0xf2, 0x93, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x28, 0x00, 0x00, 0x12, 0x14, 0x1e, 0x01,
-  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x01, 0x15, 0x21, 0x35,
-  0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x11, 0x33, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07,
-  0x15, 0xf2, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x03,
-  0x14, 0xfb, 0x96, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64,
-  0x43, 0x49, 0xa6, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b, 0x03,
-  0x22, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0xfd, 0x11,
-  0x93, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f,
-  0x0b, 0x01, 0x86, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31,
-  0x20, 0x0b, 0xf2, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe1,
-  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x26, 0x00, 0x00, 0x12, 0x14, 0x1e, 0x01,
-  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x13, 0x35, 0x26, 0x27,
-  0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x11, 0x33, 0x11, 0x16,
-  0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x21, 0x35, 0xf2,
-  0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x8c, 0x49, 0x43,
-  0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xa6, 0x4f, 0x3e, 0x67, 0x77,
-  0x77, 0x67, 0x42, 0x4b, 0xfd, 0x78, 0x03, 0x22, 0x70, 0x5f, 0x38, 0x38,
-  0x5f, 0x70, 0x60, 0x38, 0x38, 0xfd, 0x11, 0xf3, 0x0b, 0x1f, 0x31, 0xa6,
-  0xc6, 0x53, 0x56, 0x2f, 0x1f, 0x0b, 0x01, 0x86, 0xfe, 0x7b, 0x0d, 0x1e,
-  0x32, 0xa6, 0xc6, 0xa6, 0x31, 0x20, 0x0b, 0xfe, 0x7b, 0x93, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x04, 0x59, 0x05, 0xd5, 0x00, 0x1e,
-  0x00, 0x2a, 0x00, 0x00, 0x21, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x36, 0x37, 0x35, 0x21, 0x35, 0x21, 0x15, 0x21, 0x15, 0x16,
-  0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x15, 0x21, 0x15, 0x00,
-  0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x01,
-  0xd0, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xfe, 0xd6,
-  0x02, 0xfa, 0xfe, 0xd6, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b,
-  0x01, 0xe2, 0xfc, 0x9a, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6,
-  0x8c, 0x01, 0x86, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f,
-  0x0b, 0xf3, 0x93, 0x93, 0xf2, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31,
-  0x20, 0x0b, 0xf2, 0x93, 0x03, 0x22, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70,
-  0x60, 0x38, 0x38, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
-  0x05, 0xd5, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x00, 0x25, 0x15, 0x21, 0x35,
-  0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
-  0x35, 0x21, 0x35, 0x21, 0x15, 0x21, 0x15, 0x16, 0x17, 0x1e, 0x01, 0x14,
-  0x06, 0x07, 0x06, 0x07, 0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01,
-  0x34, 0x2e, 0x01, 0x22, 0x06, 0x04, 0x58, 0xfb, 0x96, 0x01, 0xe2, 0x49,
-  0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xfe, 0xd6, 0x02, 0xfa,
-  0xfe, 0xd6, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b, 0xfe, 0x7c,
-  0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x93, 0x93, 0x93,
-  0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f, 0x0b, 0xf3,
-  0x93, 0x93, 0xf2, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31, 0x20, 0x0b,
-  0xf2, 0x02, 0x8f, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70, 0x60, 0x38, 0x38,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe1, 0x05, 0xd5, 0x00, 0x1e,
-  0x00, 0x2a, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x35, 0x26, 0x27, 0x2e,
-  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x21, 0x35, 0x21, 0x15,
-  0x21, 0x15, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x00,
-  0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x02,
-  0x76, 0xfd, 0x78, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64,
-  0x43, 0x49, 0xfe, 0xd6, 0x02, 0xfa, 0xfe, 0xd6, 0x4f, 0x3e, 0x67, 0x77,
-  0x77, 0x67, 0x42, 0x4b, 0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51,
-  0x8d, 0xa6, 0x8c, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56,
-  0x2f, 0x1f, 0x0b, 0xf3, 0x93, 0x93, 0xf2, 0x0d, 0x1e, 0x32, 0xa6, 0xc6,
-  0xa6, 0x31, 0x20, 0x0b, 0x01, 0x9d, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70,
-  0x60, 0x38, 0x38, 0x00, 0xff, 0xff, 0xfd, 0x3a, 0x03, 0xfb, 0xff, 0x28,
-  0x06, 0x20, 0x10, 0x07, 0x02, 0x9c, 0xfc, 0x65, 0xff, 0x1a, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0xca, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdd, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x01,
-  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
-  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
-  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
-  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
-  0x00, 0x01, 0x01, 0x6e, 0x05, 0x18, 0x04, 0x99, 0x05, 0xe0, 0x00, 0x0b,
-  0x00, 0x00, 0x01, 0x07, 0x23, 0x27, 0x23, 0x07, 0x23, 0x27, 0x23, 0x07,
-  0x23, 0x27, 0x04, 0x98, 0x5a, 0x2d, 0x2d, 0x9d, 0x2d, 0x2d, 0x2d, 0x9e,
-  0x2d, 0x2d, 0x5a, 0x05, 0xe0, 0xc8, 0x64, 0x64, 0x64, 0x64, 0xc8, 0x00,
-  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x05, 0x63, 0x05, 0xd5, 0x00, 0x0e,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x01, 0x23, 0x11, 0x33, 0x11, 0x01, 0x33,
-  0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0xae, 0xb0, 0xfd, 0xac, 0xf5, 0xb0,
-  0x02, 0x54, 0xf5, 0xb5, 0xfe, 0xb6, 0x78, 0x04, 0xe1, 0xfb, 0x1f, 0x05,
-  0xd5, 0xfb, 0x1f, 0x04, 0xe1, 0xfa, 0xd5, 0xaa, 0xfe, 0x56, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x04, 0xb3, 0x04, 0x60, 0x00, 0x0e,
-  0x00, 0x00, 0x21, 0x23, 0x11, 0x01, 0x23, 0x11, 0x33, 0x11, 0x01, 0x33,
-  0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0x0d, 0xa5, 0xfe, 0x1a, 0xd4, 0xa4,
-  0x01, 0xe6, 0xd5, 0xa5, 0xfe, 0xfb, 0x6e, 0x03, 0x83, 0xfc, 0x7d, 0x04,
-  0x60, 0xfc, 0x7f, 0x03, 0x81, 0xfc, 0x39, 0x99, 0xfe, 0x56, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x9c, 0xfe, 0x56, 0x03, 0xe9, 0x04, 0x7b, 0x00, 0x1f,
-  0x00, 0x20, 0x00, 0x00, 0x25, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
-  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
-  0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
-  0x01, 0x03, 0x43, 0x3c, 0x9f, 0x6a, 0xad, 0xb4, 0xa5, 0x70, 0x6f, 0x87,
-  0x9b, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a, 0xa3, 0xa2,
-  0xfe, 0xfa, 0x6a, 0x42, 0x66, 0x63, 0xf0, 0xe7, 0x02, 0xa6, 0xfd, 0x61,
-  0x9f, 0x9f, 0xbe, 0xa4, 0x02, 0x7b, 0xfc, 0x2b, 0xfe, 0xe2, 0xfe, 0xe9,
-  0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd, 0x04, 0xd0, 0x00, 0x03, 0x00, 0x70,
-  0xfe, 0x90, 0x03, 0xda, 0x03, 0x52, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x38,
-  0x00, 0x00, 0x01, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
-  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x35, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03,
-  0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01,
-  0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x01,
-  0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a, 0x28, 0x59, 0x44, 0x76,
-  0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d, 0x68, 0x4c, 0x1d, 0x1f,
-  0x9b, 0x1f, 0x07, 0x08, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32,
-  0x6e, 0x39, 0x39, 0xa6, 0x39, 0x39, 0x39, 0x39, 0xa6, 0x39, 0x02, 0x3f,
-  0x7a, 0x99, 0x4e, 0x89, 0x86, 0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80,
-  0x21, 0x07, 0x26, 0xb8, 0x2a, 0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0xfd,
-  0xab, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8,
-  0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x02, 0x00, 0x70,
-  0xfe, 0xa2, 0x03, 0xda, 0x03, 0x52, 0x00, 0x20, 0x00, 0x24, 0x00, 0x00,
-  0x01, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x33, 0x15,
-  0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a, 0x28, 0x59,
-  0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d, 0x68, 0x4c,
-  0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0xa3, 0x88, 0x88, 0x02, 0x3f, 0x7a, 0x99,
-  0x4e, 0x89, 0x86, 0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07,
-  0x26, 0xb8, 0x2a, 0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0xfd, 0x77, 0x96,
-  0x00, 0x04, 0x00, 0x70, 0xfe, 0xa2, 0x03, 0xda, 0x05, 0xf7, 0x00, 0x20,
-  0x00, 0x2b, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x00, 0x01, 0x26, 0x27, 0x33,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
-  0x27, 0x26, 0x07, 0x06, 0x17, 0x2b, 0x01, 0x35, 0x33, 0x11, 0x33, 0x11,
-  0x36, 0x37, 0x36, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x03, 0x33, 0x15,
-  0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a, 0x28, 0x59,
-  0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d, 0x68, 0x4c,
-  0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0xba, 0x32, 0x46, 0x14, 0x2f, 0x1b, 0x01,
-  0x40, 0x2e, 0x15, 0x9d, 0x65, 0x49, 0x5c, 0x20, 0x5e, 0x38, 0x3f, 0x3b,
-  0x3a, 0x30, 0x98, 0x88, 0x88, 0x02, 0x3f, 0x7a, 0x99, 0x4e, 0x89, 0x86,
-  0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07, 0x26, 0xb8, 0x2a,
-  0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0x02, 0xa7, 0x0d, 0x21, 0x15, 0x20,
-  0x10, 0x01, 0x1c, 0x15, 0xa8, 0x65, 0x01, 0x8f, 0xfe, 0xbf, 0x49, 0x28,
-  0x18, 0x1a, 0x19, 0x52, 0x5b, 0x32, 0x2a, 0xfb, 0x35, 0x96, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x70, 0xff, 0xda, 0x03, 0xda, 0x05, 0x78, 0x00, 0x20,
-  0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x26, 0x27, 0x33,
-  0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15,
-  0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a,
-  0x49, 0x4a, 0x28, 0x59, 0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29,
-  0x5c, 0x5d, 0x68, 0x4c, 0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0xcf, 0x86, 0x86,
-  0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x02, 0x3f, 0x7a, 0x99, 0x4e, 0x89,
-  0x86, 0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07, 0x26, 0xb8,
-  0x2a, 0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0x02, 0xbd, 0x96, 0x01, 0x90,
-  0x96, 0x96, 0x96, 0x00, 0x00, 0x05, 0x00, 0x70, 0xff, 0xda, 0x03, 0xda,
-  0x05, 0xaa, 0x00, 0x20, 0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30,
-  0x00, 0x00, 0x01, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
-  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x35, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03,
-  0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x07, 0x33, 0x15, 0x23, 0x11,
-  0x33, 0x15, 0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a,
-  0x28, 0x59, 0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d,
-  0x68, 0x4c, 0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0x5f, 0x87, 0x87, 0x87, 0x87,
-  0xe1, 0x87, 0x87, 0x87, 0x87, 0x02, 0x3f, 0x7a, 0x99, 0x4e, 0x89, 0x86,
-  0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07, 0x26, 0xb8, 0x2a,
-  0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0x02, 0xef, 0x96, 0x01, 0x90, 0x96,
-  0x64, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xb3,
-  0xfe, 0x0c, 0x04, 0x0b, 0x02, 0x26, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
-  0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x13, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37,
-  0x36, 0x32, 0x17, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b,
-  0x43, 0x75, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11,
-  0xb7, 0xc4, 0x20, 0x08, 0xd0, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a,
-  0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0x02,
-  0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97,
-  0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0xfd, 0x4a, 0x28, 0x1c, 0x1d,
-  0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40,
-  0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x02, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x0b,
-  0x02, 0x26, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x33, 0x16, 0x17,
-  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04,
-  0x21, 0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x13, 0x33, 0x15,
-  0x23, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b, 0x43, 0x75,
-  0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4,
-  0x20, 0x08, 0x7a, 0x87, 0x87, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c,
-  0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48,
-  0x7e, 0xfd, 0x40, 0x96, 0x00, 0x03, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x0b,
-  0x02, 0x26, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x33,
-  0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02,
-  0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x05,
-  0x33, 0x15, 0x23, 0x01, 0x33, 0x15, 0x23, 0x02, 0x39, 0xa5, 0x1b, 0x03,
-  0x09, 0x42, 0x26, 0x5b, 0x43, 0x75, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00,
-  0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4, 0x20, 0x08, 0xfe, 0x3a, 0x87, 0x87,
-  0x02, 0x40, 0x87, 0x87, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8,
-  0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e,
-  0xe0, 0x96, 0xfe, 0xb6, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xb3,
-  0xfe, 0x0c, 0x04, 0x0b, 0x03, 0xb6, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x20,
-  0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37,
-  0x36, 0x35, 0x34, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x02,
-  0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b, 0x43, 0x75, 0x75, 0x2d,
-  0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4, 0x20, 0x08,
-  0x3b, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d,
-  0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a,
-  0x48, 0x7e, 0x02, 0x18, 0x96, 0x96, 0x96, 0x00, 0x00, 0x05, 0xff, 0xb3,
-  0xfe, 0x0c, 0x04, 0x0b, 0x04, 0xb0, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x20,
-  0x00, 0x24, 0x00, 0x28, 0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17,
-  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35,
-  0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x13, 0x33, 0x15, 0x23, 0x11,
-  0x33, 0x15, 0x23, 0x07, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x02,
-  0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b, 0x43, 0x75, 0x75, 0x2d,
-  0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4, 0x20, 0x08,
-  0x3b, 0x87, 0x87, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x87, 0x87, 0x02, 0x26,
-  0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8,
-  0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0x02, 0x18, 0x96, 0x01, 0x90, 0x96,
-  0x64, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x75,
-  0xfe, 0x0c, 0x09, 0x40, 0x03, 0xb6, 0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e,
-  0x00, 0x00, 0x25, 0x16, 0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x33,
-  0x32, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07,
-  0x06, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x26, 0x27,
-  0x26, 0x11, 0x34, 0x37, 0x33, 0x06, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x37, 0x36, 0x27, 0x26, 0x2f, 0x01, 0x33, 0x17, 0x16, 0x17,
-  0x16, 0x13, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x05, 0x26, 0x46,
-  0x2b, 0x21, 0xa6, 0x11, 0x3a, 0x63, 0x7f, 0xa6, 0x4b, 0x27, 0x59, 0x44,
-  0x75, 0x83, 0x6a, 0x3d, 0x62, 0x21, 0x1d, 0x42, 0x2b, 0x7c, 0x10, 0x2c,
-  0x55, 0x3a, 0x32, 0x7b, 0x24, 0x15, 0x4c, 0x77, 0xae, 0x48, 0x6c, 0x73,
-  0x63, 0xf7, 0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x59, 0x55,
-  0x6d, 0x55, 0x39, 0x01, 0x01, 0x0e, 0x3a, 0xa6, 0x20, 0x0f, 0x19, 0x34,
-  0x19, 0x86, 0x86, 0x86, 0x88, 0x88, 0xb5, 0x02, 0x7c, 0x5f, 0xca, 0xcd,
-  0x32, 0xa9, 0x01, 0x18, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8,
-  0x60, 0x5b, 0x19, 0x09, 0x19, 0x46, 0x7b, 0x9f, 0x1e, 0x14, 0x02, 0x02,
-  0x3c, 0xb3, 0x6b, 0xaa, 0x3e, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48, 0xf6,
-  0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x30, 0x9e, 0x6c, 0x8e, 0x7d,
-  0x3d, 0xea, 0x9c, 0x4a, 0x3c, 0x7e, 0x02, 0xfe, 0x96, 0xfc, 0x18, 0x96,
-  0x00, 0x03, 0xff, 0xee, 0xfe, 0xa2, 0x05, 0x70, 0x03, 0xe8, 0x00, 0x31,
-  0x00, 0x35, 0x00, 0x39, 0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x2b, 0x01,
-  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19,
-  0x01, 0x33, 0x11, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x33, 0x15, 0x23,
-  0x13, 0x33, 0x15, 0x23, 0x01, 0x5a, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44,
-  0x59, 0x27, 0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11,
-  0x3a, 0x63, 0x80, 0xa5, 0x52, 0x44, 0x5c, 0x21, 0x20, 0x38, 0x32, 0x7b,
-  0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x01, 0x3c, 0x86, 0x86,
-  0x86, 0x88, 0x88, 0x8a, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0,
-  0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02,
-  0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0xc7, 0x71, 0x5c, 0x18, 0x09, 0x19,
-  0x3d, 0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0x03, 0xa7, 0x96, 0xfb, 0xe6,
-  0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee, 0xfe, 0xa2, 0x06, 0x7f,
-  0x03, 0xe8, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x00, 0x05, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d,
-  0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x33,
-  0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01, 0x33, 0x15, 0x23, 0x13,
-  0x33, 0x15, 0x23, 0x04, 0x7d, 0x21, 0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b,
-  0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x24, 0x27, 0x33, 0x44, 0x59, 0x75,
-  0x44, 0x59, 0x27, 0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5,
-  0x11, 0x3a, 0x63, 0x80, 0xa5, 0x4b, 0x28, 0x59, 0x43, 0x75, 0x82, 0x6a,
-  0x3e, 0xfd, 0xdb, 0x86, 0x86, 0x86, 0x88, 0x88, 0x14, 0x09, 0x19, 0x3d,
-  0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0x49, 0x3b, 0x21, 0x2e, 0xb8, 0x2c,
-  0x50, 0x64, 0xc0, 0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32,
-  0xaa, 0x01, 0x02, 0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c,
-  0xb8, 0x60, 0x5a, 0x03, 0xe2, 0x96, 0xfb, 0xe6, 0x96, 0x00, 0x00, 0x00,
-  0x00, 0x04, 0x00, 0x75, 0xfe, 0x0c, 0x09, 0x40, 0x02, 0xee, 0x00, 0x46,
-  0x00, 0x4a, 0x00, 0x4e, 0x00, 0x52, 0x00, 0x00, 0x25, 0x16, 0x37, 0x36,
-  0x35, 0x33, 0x14, 0x17, 0x16, 0x33, 0x32, 0x19, 0x01, 0x33, 0x11, 0x14,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x27, 0x26, 0x27, 0x06, 0x07,
-  0x06, 0x07, 0x06, 0x23, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37, 0x33, 0x06,
-  0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x27, 0x26,
-  0x2f, 0x01, 0x33, 0x17, 0x16, 0x17, 0x16, 0x13, 0x33, 0x15, 0x23, 0x13,
-  0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0x26, 0x46, 0x2b, 0x21,
-  0xa6, 0x11, 0x3a, 0x63, 0x7f, 0xa6, 0x4b, 0x27, 0x59, 0x44, 0x75, 0x83,
-  0x6a, 0x3d, 0x62, 0x21, 0x1d, 0x42, 0x2b, 0x7c, 0x10, 0x2c, 0x55, 0x3a,
-  0x32, 0x7b, 0x24, 0x15, 0x4c, 0x77, 0xae, 0x48, 0x6c, 0x73, 0x63, 0xf7,
-  0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x59, 0x55, 0x6d, 0x55,
-  0x39, 0x01, 0x01, 0x0e, 0x3a, 0xa6, 0x20, 0x0f, 0x19, 0x34, 0x9f, 0x88,
-  0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb5, 0x02, 0x7c, 0x5f, 0xca,
-  0xcd, 0x32, 0xa9, 0x01, 0x18, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c,
-  0xb8, 0x60, 0x5b, 0x19, 0x09, 0x19, 0x46, 0x7b, 0x9f, 0x1e, 0x14, 0x02,
-  0x02, 0x3c, 0xb3, 0x6b, 0xaa, 0x3e, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48,
-  0xf6, 0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x30, 0x9e, 0x6c, 0x8e,
-  0x7d, 0x3d, 0xea, 0x9c, 0x4a, 0x3c, 0x7e, 0xfd, 0xea, 0x96, 0x01, 0x90,
-  0x96, 0x96, 0x96, 0x00, 0x00, 0x04, 0xff, 0xee, 0xfe, 0x0c, 0x05, 0x70,
-  0x02, 0xee, 0x00, 0x31, 0x00, 0x35, 0x00, 0x39, 0x00, 0x3d, 0x00, 0x00,
-  0x25, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d,
-  0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x33,
-  0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14, 0x07, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x01, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x01, 0x5a, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44, 0x59, 0x27,
-  0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11, 0x3a, 0x63,
-  0x80, 0xa5, 0x52, 0x44, 0x5c, 0x21, 0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b,
-  0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x01, 0xc2, 0x88, 0x88, 0x71, 0x87,
-  0x87, 0xe1, 0x87, 0x87, 0x8a, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64,
-  0xc0, 0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01,
-  0x02, 0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0xc7, 0x71, 0x5c, 0x18, 0x09,
-  0x19, 0x3d, 0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0xfe, 0x61, 0x96, 0x01,
-  0x90, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee, 0xfe, 0x0c, 0x06, 0x7f,
-  0x02, 0xee, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x44, 0x00, 0x00,
-  0x05, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
-  0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
-  0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01, 0x33, 0x15,
-  0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x04, 0x7d, 0x21,
-  0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36,
-  0x24, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44, 0x59, 0x27, 0x48, 0xa6, 0x27,
-  0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11, 0x3a, 0x63, 0x80, 0xa5, 0x4b,
-  0x28, 0x59, 0x43, 0x75, 0x82, 0x6a, 0x3e, 0xfe, 0x61, 0x88, 0x88, 0x71,
-  0x87, 0x87, 0xe1, 0x87, 0x87, 0x14, 0x09, 0x19, 0x3d, 0x84, 0x9c, 0x21,
-  0x18, 0x31, 0x28, 0x49, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0,
-  0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02,
-  0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8, 0x60, 0x5a,
-  0xfe, 0x9c, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x07, 0x00, 0x75,
-  0xfe, 0x0c, 0x09, 0x40, 0x04, 0xb0, 0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e,
-  0x00, 0x52, 0x00, 0x56, 0x00, 0x5a, 0x00, 0x5e, 0x00, 0x00, 0x25, 0x16,
-  0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x33, 0x32, 0x19, 0x01, 0x33,
-  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07,
-  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x27, 0x26, 0x27,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37,
-  0x33, 0x06, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
-  0x27, 0x26, 0x2f, 0x01, 0x33, 0x17, 0x16, 0x17, 0x16, 0x13, 0x33, 0x15,
-  0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15,
-  0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0x26, 0x46,
-  0x2b, 0x21, 0xa6, 0x11, 0x3a, 0x63, 0x7f, 0xa6, 0x4b, 0x27, 0x59, 0x44,
-  0x75, 0x83, 0x6a, 0x3d, 0x62, 0x21, 0x1d, 0x42, 0x2b, 0x7c, 0x10, 0x2c,
-  0x55, 0x3a, 0x32, 0x7b, 0x24, 0x15, 0x4c, 0x77, 0xae, 0x48, 0x6c, 0x73,
-  0x63, 0xf7, 0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x59, 0x55,
-  0x6d, 0x55, 0x39, 0x01, 0x01, 0x0e, 0x3a, 0xa6, 0x20, 0x0f, 0x19, 0x34,
-  0x19, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xf7, 0x88, 0x88,
-  0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb5, 0x02, 0x7c, 0x5f, 0xca, 0xcd,
-  0x32, 0xa9, 0x01, 0x18, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8,
-  0x60, 0x5b, 0x19, 0x09, 0x19, 0x46, 0x7b, 0x9f, 0x1e, 0x14, 0x02, 0x02,
-  0x3c, 0xb3, 0x6b, 0xaa, 0x3e, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48, 0xf6,
-  0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x30, 0x9e, 0x6c, 0x8e, 0x7d,
-  0x3d, 0xea, 0x9c, 0x4a, 0x3c, 0x7e, 0x03, 0xf8, 0x96, 0x64, 0x96, 0x96,
-  0x96, 0xfb, 0x82, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00,
-  0x00, 0x07, 0xff, 0xee, 0xfe, 0x0c, 0x05, 0x70, 0x04, 0xb0, 0x00, 0x31,
-  0x00, 0x35, 0x00, 0x39, 0x00, 0x3d, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
-  0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
-  0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
-  0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23,
-  0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23,
-  0x27, 0x33, 0x15, 0x23, 0x01, 0x5a, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44,
-  0x59, 0x27, 0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11,
-  0x3a, 0x63, 0x80, 0xa5, 0x52, 0x44, 0x5c, 0x21, 0x20, 0x38, 0x32, 0x7b,
-  0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x01, 0x3c, 0x86, 0x86,
-  0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xf7, 0x88, 0x88, 0x71, 0x87, 0x87,
-  0xe1, 0x87, 0x87, 0x8a, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0,
-  0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02,
-  0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0xc7, 0x71, 0x5c, 0x18, 0x09, 0x19,
-  0x3d, 0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0x04, 0x6f, 0x96, 0x64, 0x96,
-  0x96, 0x96, 0xfb, 0x82, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00,
-  0x00, 0x07, 0xff, 0xee, 0xfe, 0x0c, 0x06, 0x7f, 0x04, 0xb0, 0x00, 0x38,
-  0x00, 0x3c, 0x00, 0x40, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c, 0x00, 0x50,
-  0x00, 0x00, 0x05, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33,
-  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01,
-  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x13,
-  0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x04,
-  0x7d, 0x21, 0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59,
-  0x41, 0x36, 0x24, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44, 0x59, 0x27, 0x48,
-  0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11, 0x3a, 0x63, 0x80,
-  0xa5, 0x4b, 0x28, 0x59, 0x43, 0x75, 0x82, 0x6a, 0x3e, 0xfd, 0xdb, 0x86,
-  0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xf7, 0x88, 0x88, 0x71, 0x87,
-  0x87, 0xe1, 0x87, 0x87, 0x14, 0x09, 0x19, 0x3d, 0x84, 0x9c, 0x21, 0x18,
-  0x31, 0x28, 0x49, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0, 0x9c,
-  0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02, 0x01,
-  0x16, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8, 0x60, 0x5a, 0x04,
-  0xaa, 0x96, 0x64, 0x96, 0x96, 0x96, 0xfb, 0x82, 0x96, 0x01, 0x90, 0x96,
-  0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0x00, 0x75, 0xfe, 0x0c, 0x08, 0xe5,
-  0x02, 0xe5, 0x00, 0x3c, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x51, 0x00, 0x00,
-  0x21, 0x23, 0x22, 0x27, 0x26, 0x35, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x26, 0x27, 0x26, 0x11, 0x34, 0x37, 0x33, 0x06, 0x17, 0x16, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x33, 0x06, 0x17,
-  0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x17, 0x16, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01,
-  0x06, 0x03, 0x22, 0x07, 0x06, 0x07, 0x33, 0x32, 0x37, 0x36, 0x27, 0x26,
-  0x27, 0x26, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0xd0,
-  0xf9, 0x22, 0x2f, 0x28, 0x43, 0x4f, 0xd6, 0x48, 0x6c, 0x73, 0x63, 0xf7,
-  0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x5c, 0x52, 0x92, 0x27,
-  0x1d, 0x23, 0x9a, 0x01, 0x0d, 0x09, 0x24, 0x67, 0x6f, 0x61, 0x85, 0x40,
-  0x50, 0x70, 0x57, 0xa8, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x43, 0x75, 0x76,
-  0x5d, 0x19, 0xb7, 0x10, 0x45, 0x71, 0x98, 0x82, 0xa8, 0xd6, 0x74, 0xa8,
-  0x01, 0x02, 0x7b, 0x21, 0xfe, 0xe6, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x1e,
-  0x1a, 0x10, 0xba, 0x80, 0x9b, 0x4d, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48,
-  0xf6, 0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x44, 0x8a, 0x6c, 0x7f,
-  0x93, 0x8a, 0x0f, 0x37, 0x28, 0x32, 0x92, 0x6c, 0x5e, 0x46, 0x22, 0x01,
-  0x02, 0x25, 0x47, 0xe9, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c, 0x1a,
-  0x76, 0x02, 0x37, 0x51, 0x6c, 0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13, 0x05,
-  0xfd, 0x01, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
-  0xfe, 0xa2, 0x05, 0x94, 0x02, 0xe5, 0x00, 0x0c, 0x00, 0x2e, 0x00, 0x32,
-  0x00, 0x36, 0x00, 0x00, 0x01, 0x06, 0x07, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14,
-  0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x05, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
-  0x6e, 0x97, 0x82, 0xa8, 0xd6, 0x73, 0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xa8,
-  0xf8, 0x43, 0x46, 0x3a, 0x23, 0x5c, 0x9b, 0x75, 0x44, 0x59, 0x27, 0x48,
-  0xa6, 0x10, 0x28, 0x5b, 0x56, 0x89, 0x82, 0x44, 0x4c, 0x68, 0x60, 0xa7,
-  0xa5, 0xb6, 0xfe, 0xc5, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01, 0xe6, 0x6c,
-  0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13, 0x05, 0xfd, 0xc9, 0x2a, 0x23, 0x3d,
-  0x8a, 0xb8, 0x2c, 0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32, 0x86, 0x54,
-  0x89, 0x3f, 0x21, 0x27, 0x44, 0xec, 0xa9, 0x6d, 0x78, 0xc8, 0x96, 0x96,
-  0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee, 0xfe, 0xa2, 0x06, 0x51,
-  0x02, 0xe5, 0x00, 0x2b, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x00,
-  0x21, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
-  0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x16, 0x17, 0x36, 0x37, 0x36,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x17, 0x16,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x03, 0x06, 0x07, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x33, 0x15,
-  0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x3c, 0xfc, 0x43, 0x46, 0x3a, 0x23,
-  0x5c, 0x9b, 0x75, 0x44, 0x59, 0x27, 0x48, 0xa6, 0x10, 0x28, 0x5b, 0x56,
-  0x89, 0x82, 0x44, 0x4c, 0x66, 0x62, 0xab, 0x26, 0x0d, 0x0e, 0x37, 0x4a,
-  0x43, 0x75, 0x75, 0x5d, 0x19, 0xb8, 0xca, 0x97, 0x82, 0xa8, 0xd6, 0x73,
-  0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xe3, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x2a,
-  0x23, 0x3d, 0x8a, 0xb8, 0x2c, 0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32,
-  0x86, 0x54, 0x89, 0x3f, 0x21, 0x27, 0x44, 0xec, 0x4b, 0x48, 0x0c, 0x0b,
-  0x2c, 0xb8, 0x5c, 0x1a, 0x76, 0x01, 0xe6, 0x6c, 0xc2, 0x3f, 0x5b, 0x46,
-  0x87, 0x13, 0x05, 0xfd, 0x01, 0x96, 0x96, 0x96, 0x00, 0x05, 0x00, 0x75,
-  0xfe, 0x0c, 0x08, 0xe5, 0x04, 0xb0, 0x00, 0x3c, 0x00, 0x49, 0x00, 0x4d,
-  0x00, 0x51, 0x00, 0x55, 0x00, 0x00, 0x21, 0x23, 0x22, 0x27, 0x26, 0x35,
-  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37,
-  0x33, 0x06, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x33, 0x06, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37,
-  0x36, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x17, 0x16, 0x3b,
-  0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x03, 0x22, 0x07, 0x06, 0x07,
-  0x33, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26, 0x01, 0x33, 0x15, 0x23,
-  0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0xd0, 0xf9, 0x22,
-  0x2f, 0x28, 0x43, 0x4f, 0xd6, 0x48, 0x6c, 0x73, 0x63, 0xf7, 0x5f, 0xa5,
-  0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x5c, 0x52, 0x92, 0x27, 0x1d, 0x23,
-  0x9a, 0x01, 0x0d, 0x09, 0x24, 0x67, 0x6f, 0x61, 0x85, 0x40, 0x50, 0x70,
-  0x57, 0xa8, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x43, 0x75, 0x76, 0x5d, 0x19,
-  0xb7, 0x10, 0x45, 0x71, 0x98, 0x82, 0xa8, 0xd6, 0x74, 0xa8, 0x01, 0x02,
-  0x7b, 0x21, 0xfd, 0x95, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87,
-  0x1e, 0x1a, 0x10, 0xba, 0x80, 0x9b, 0x4d, 0x1a, 0x01, 0x1c, 0x47, 0x01,
-  0x48, 0xf6, 0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x44, 0x8a, 0x6c,
-  0x7f, 0x93, 0x8a, 0x0f, 0x37, 0x28, 0x32, 0x92, 0x6c, 0x5e, 0x46, 0x22,
-  0x01, 0x02, 0x25, 0x47, 0xe9, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c,
-  0x1a, 0x76, 0x02, 0x37, 0x51, 0x6c, 0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13,
-  0x05, 0x02, 0x79, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x05, 0xff, 0xee,
-  0x00, 0x00, 0x05, 0x94, 0x04, 0xb0, 0x00, 0x0c, 0x00, 0x2e, 0x00, 0x32,
-  0x00, 0x36, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x06, 0x07, 0x33, 0x32, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x23, 0x22, 0x27, 0x26,
-  0x27, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33,
-  0x15, 0x14, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15,
-  0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x6e, 0x97, 0x82, 0xa8, 0xd6, 0x73,
-  0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xa8, 0xf8, 0x43, 0x46, 0x3a, 0x23, 0x5c,
-  0x9b, 0x75, 0x44, 0x59, 0x27, 0x48, 0xa6, 0x10, 0x28, 0x5b, 0x56, 0x89,
-  0x82, 0x44, 0x4c, 0x68, 0x60, 0xa7, 0xa5, 0xb6, 0xfd, 0xa0, 0x88, 0x88,
-  0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01, 0xe6, 0x6c, 0xc2, 0x3f, 0x5b,
-  0x46, 0x87, 0x13, 0x05, 0xfd, 0xc9, 0x2a, 0x23, 0x3d, 0x8a, 0xb8, 0x2c,
-  0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32, 0x86, 0x54, 0x89, 0x3f, 0x21,
-  0x27, 0x44, 0xec, 0xa9, 0x6d, 0x78, 0x04, 0xb0, 0x96, 0x64, 0x96, 0x96,
-  0x96, 0x00, 0x00, 0x00, 0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x06, 0x51,
-  0x04, 0xb0, 0x00, 0x2b, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x44,
-  0x00, 0x00, 0x21, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x2b, 0x01, 0x35,
-  0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x16, 0x17, 0x36,
-  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x03, 0x06,
-  0x07, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x01,
-  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
-  0x3c, 0xfc, 0x43, 0x46, 0x3a, 0x23, 0x5c, 0x9b, 0x75, 0x44, 0x59, 0x27,
-  0x48, 0xa6, 0x10, 0x28, 0x5b, 0x56, 0x89, 0x82, 0x44, 0x4c, 0x66, 0x62,
-  0xab, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x43, 0x75, 0x75, 0x5d, 0x19, 0xb8,
-  0xca, 0x97, 0x82, 0xa8, 0xd6, 0x73, 0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xfd,
-  0xf8, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x2a, 0x23, 0x3d,
-  0x8a, 0xb8, 0x2c, 0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32, 0x86, 0x54,
-  0x89, 0x3f, 0x21, 0x27, 0x44, 0xec, 0x4b, 0x48, 0x0c, 0x0b, 0x2c, 0xb8,
-  0x5c, 0x1a, 0x76, 0x01, 0xe6, 0x6c, 0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13,
-  0x05, 0x02, 0x79, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x05, 0x00, 0x81,
-  0x00, 0x00, 0x06, 0xe8, 0x06, 0x14, 0x00, 0x1c, 0x00, 0x29, 0x00, 0x2d,
-  0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x29, 0x02, 0x35, 0x21, 0x11, 0x33,
-  0x11, 0x12, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x25, 0x33,
-  0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x13,
-  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
-  0xd3, 0xfd, 0xf9, 0xfe, 0xb6, 0x01, 0x4a, 0xa6, 0xc3, 0xf8, 0x53, 0x3d,
-  0x69, 0x5f, 0xa9, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x44, 0x75, 0x76, 0x5d,
-  0x19, 0xb8, 0xfe, 0x1f, 0xa8, 0xd5, 0x74, 0xa9, 0x01, 0x02, 0x7b, 0x22,
-  0x2b, 0x48, 0x6e, 0x9f, 0x32, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87,
-  0x87, 0xb8, 0x05, 0x5c, 0xfb, 0x0e, 0x01, 0x3f, 0x63, 0x21, 0x27, 0x45,
-  0xeb, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c, 0x1a, 0x76, 0xb8, 0x3f,
-  0x5d, 0x44, 0x87, 0x13, 0x05, 0x51, 0x78, 0x03, 0x74, 0x96, 0x64, 0x96,
-  0x96, 0x96, 0x00, 0x00, 0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x05, 0x3f,
-  0x06, 0x14, 0x00, 0x0c, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b,
-  0x00, 0x00, 0x25, 0x33, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26, 0x23,
-  0x22, 0x07, 0x06, 0x13, 0x21, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x12,
-  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x33,
-  0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x02, 0x00,
-  0xa8, 0xd6, 0x74, 0xa8, 0x01, 0x02, 0x7b, 0x21, 0x2b, 0x48, 0x6e, 0xa0,
-  0x6a, 0xfd, 0xfa, 0xf0, 0xf0, 0xa6, 0xc3, 0xf9, 0x52, 0x3e, 0x69, 0x5e,
-  0xa8, 0xa6, 0xb6, 0xfe, 0xca, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1, 0x87,
-  0x87, 0xb8, 0x3f, 0x5d, 0x44, 0x87, 0x13, 0x05, 0x51, 0x78, 0xfe, 0x92,
-  0xb8, 0x05, 0x5c, 0xfb, 0x0e, 0x01, 0x3f, 0x63, 0x21, 0x27, 0x45, 0xeb,
-  0xa9, 0x6d, 0x78, 0x04, 0xe2, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00,
-  0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x05, 0xfa, 0x06, 0x14, 0x00, 0x1c,
-  0x00, 0x29, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x29, 0x01,
-  0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x12, 0x37, 0x36, 0x33, 0x32, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
-  0x2f, 0x01, 0x06, 0x25, 0x33, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26,
-  0x23, 0x22, 0x07, 0x06, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23,
-  0x27, 0x33, 0x15, 0x23, 0x02, 0xe6, 0xfd, 0xf8, 0xf0, 0xf0, 0xa6, 0xc3,
-  0xf9, 0x52, 0x3e, 0x69, 0x5e, 0xaa, 0x26, 0x0c, 0x0f, 0x37, 0x49, 0x44,
-  0x75, 0x76, 0x5d, 0x19, 0xb7, 0xfe, 0x1e, 0xa8, 0xd6, 0x74, 0xa8, 0x01,
-  0x02, 0x7b, 0x21, 0x2b, 0x48, 0x6e, 0xa0, 0x33, 0x87, 0x87, 0x70, 0x87,
-  0x87, 0xe1, 0x87, 0x87, 0xb8, 0x05, 0x5c, 0xfb, 0x0e, 0x01, 0x3f, 0x63,
-  0x21, 0x27, 0x45, 0xeb, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c, 0x1a,
-  0x76, 0xb8, 0x3f, 0x5d, 0x44, 0x87, 0x13, 0x05, 0x51, 0x78, 0x03, 0x74,
-  0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x69,
-  0xfe, 0x0c, 0x04, 0x3a, 0x05, 0x46, 0x00, 0x25, 0x00, 0x2b, 0x00, 0x2f,
-  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x01, 0x06, 0x23, 0x20, 0x27, 0x26,
-  0x10, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15,
-  0x14, 0x07, 0x06, 0x07, 0x1e, 0x01, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x21, 0x32, 0x37, 0x01, 0x36, 0x34, 0x22,
-  0x15, 0x14, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x04, 0x3a, 0x89, 0xe7, 0xfe, 0x85, 0x8d, 0x59, 0xa9, 0x37,
-  0x3d, 0x70, 0x57, 0xd7, 0x55, 0x72, 0x52, 0x33, 0x54, 0x3d, 0xa3, 0x4d,
-  0x90, 0x82, 0xef, 0xdf, 0x8b, 0x25, 0x60, 0x01, 0x3c, 0xae, 0xbf, 0xfd,
-  0x79, 0x7a, 0xb9, 0x0a, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87,
-  0xfe, 0x6f, 0x63, 0xbc, 0x7a, 0x01, 0x92, 0x8c, 0x32, 0x74, 0x2a, 0x6e,
-  0x40, 0x30, 0x30, 0x40, 0x70, 0x5b, 0x43, 0x2b, 0x20, 0x40, 0x4d, 0xb8,
-  0xe4, 0x81, 0x6b, 0x6c, 0x3d, 0x9e, 0x76, 0x02, 0x96, 0x38, 0x60, 0x33,
-  0x24, 0x03, 0x48, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0x93, 0x06, 0x40, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22,
-  0x00, 0x26, 0x00, 0x00, 0x37, 0x32, 0x37, 0x26, 0x27, 0x26, 0x35, 0x10,
-  0x37, 0x36, 0x33, 0x15, 0x22, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x25, 0x15, 0x05, 0x04, 0x2b, 0x01, 0x35, 0x01, 0x33, 0x15, 0x23, 0x17,
-  0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x36, 0x91, 0xb6, 0x44, 0x2f,
-  0x4f, 0xb8, 0x70, 0xe2, 0xc4, 0xa7, 0x37, 0x4b, 0x3f, 0x32, 0x42, 0x01,
-  0x03, 0xfe, 0x86, 0xfe, 0xc5, 0xa0, 0x4f, 0x01, 0x90, 0x88, 0x88, 0x71,
-  0x87, 0x87, 0xe1, 0x87, 0x87, 0xb8, 0x5d, 0x18, 0x3b, 0x64, 0x8c, 0x01,
-  0x08, 0x7d, 0x4d, 0xa9, 0x89, 0xff, 0x34, 0x46, 0x21, 0x81, 0xb8, 0xc5,
-  0xa4, 0xb8, 0x05, 0x88, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00,
-  0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x03, 0x8c, 0x05, 0x46, 0x00, 0x24,
-  0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x3b, 0x00, 0x00, 0x25, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35,
-  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
-  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x02,
-  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x36, 0x35, 0x34, 0x27, 0x03, 0x33,
-  0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0xbd,
-  0xaf, 0xb6, 0x6a, 0x56, 0x61, 0x3b, 0x35, 0x24, 0x57, 0x3d, 0x1b, 0x0b,
-  0x0f, 0x5d, 0x51, 0xd6, 0x50, 0x5d, 0x0f, 0x0c, 0x1c, 0x45, 0x4f, 0x1c,
-  0x3d, 0x37, 0x65, 0x56, 0x6a, 0xb6, 0x97, 0x2f, 0x1b, 0x2a, 0x5d, 0x5c,
-  0x2a, 0x71, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb9, 0xb9,
-  0xb8, 0x28, 0x24, 0x27, 0x55, 0x5a, 0x27, 0x2d, 0x1f, 0x29, 0x37, 0x34,
-  0x2d, 0x2d, 0x34, 0x37, 0x29, 0x1f, 0x2d, 0x27, 0x62, 0x4d, 0x1f, 0x2c,
-  0x28, 0xb8, 0x02, 0x55, 0x07, 0x0c, 0x20, 0x1d, 0x5f, 0x5f, 0x1d, 0x20,
-  0x0c, 0x02, 0xf8, 0x96, 0x64, 0x96, 0x96, 0x96, 0xff, 0xff, 0x00, 0x75,
-  0xfe, 0xa2, 0x07, 0x86, 0x03, 0x11, 0x10, 0x26, 0x10, 0xff, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x03, 0x14, 0xfe, 0xa2, 0xff, 0xff, 0xff, 0xee,
-  0xfe, 0xd4, 0x02, 0xec, 0x03, 0xd9, 0x10, 0x26, 0x11, 0x00, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4, 0xff, 0xff, 0xff, 0xee,
-  0xfe, 0xd4, 0x03, 0xb7, 0x03, 0x08, 0x10, 0x26, 0x11, 0x01, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4, 0xff, 0xff, 0x00, 0x75,
-  0xfe, 0xa2, 0x07, 0x86, 0x04, 0x4c, 0x10, 0x26, 0x10, 0xff, 0x00, 0x00,
-  0x10, 0x27, 0x10, 0xf6, 0x05, 0x5c, 0x03, 0xb6, 0x10, 0x07, 0x10, 0xf6,
-  0x03, 0x14, 0xfe, 0xa2, 0xff, 0xff, 0xff, 0xee, 0xfe, 0xd4, 0x02, 0xec,
-  0x05, 0x14, 0x10, 0x26, 0x11, 0x00, 0x00, 0x00, 0x10, 0x27, 0x10, 0xf6,
-  0x01, 0x7e, 0x04, 0x7e, 0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4,
-  0xff, 0xff, 0xff, 0xee, 0xfe, 0xd4, 0x03, 0xb7, 0x04, 0x7e, 0x10, 0x26,
-  0x11, 0x01, 0x00, 0x00, 0x10, 0x27, 0x10, 0xf6, 0x01, 0x8f, 0x03, 0xe8,
-  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4, 0xff, 0xff, 0x00, 0x75,
-  0xfd, 0xa8, 0x07, 0x86, 0x03, 0x11, 0x10, 0x26, 0x10, 0xff, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf9, 0x02, 0xa3, 0xfe, 0xa2, 0xff, 0xff, 0xff, 0xee,
-  0xfd, 0xda, 0x02, 0xec, 0x03, 0xd9, 0x10, 0x26, 0x11, 0x00, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf9, 0x01, 0x0e, 0xfe, 0xd4, 0xff, 0xff, 0xff, 0xee,
-  0xfd, 0xda, 0x03, 0xb7, 0x03, 0x08, 0x10, 0x26, 0x11, 0x01, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf9, 0x01, 0x0e, 0xfe, 0xd4, 0xff, 0xff, 0x00, 0x60,
-  0xfe, 0x0c, 0x06, 0x14, 0x04, 0x01, 0x10, 0x26, 0x11, 0x02, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x03, 0x9a, 0x03, 0x6b, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0xec, 0x05, 0x14, 0x10, 0x26, 0x11, 0x03, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0x04, 0x7e, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xb7, 0x04, 0x7e, 0x10, 0x26, 0x11, 0x04, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x01, 0x8f, 0x03, 0xe8, 0xff, 0xff, 0x00, 0x60,
-  0xfe, 0x0c, 0x06, 0x14, 0x04, 0xfb, 0x10, 0x26, 0x11, 0x02, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf8, 0x03, 0x2a, 0x03, 0x6b, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0xec, 0x06, 0x0e, 0x10, 0x26, 0x11, 0x03, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf8, 0x01, 0x0e, 0x04, 0x7e, 0xff, 0xff, 0xff, 0xee,
-  0x00, 0x00, 0x03, 0xb7, 0x05, 0x78, 0x10, 0x26, 0x11, 0x04, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf8, 0x01, 0x1e, 0x03, 0xe8, 0x00, 0x01, 0x00, 0x75,
-  0xff, 0xa7, 0x07, 0xa9, 0x06, 0x14, 0x00, 0x37, 0x00, 0x00, 0x25, 0x32,
-  0x24, 0x36, 0x3d, 0x01, 0x34, 0x27, 0x25, 0x24, 0x3d, 0x01, 0x34, 0x37,
-  0x36, 0x37, 0x01, 0x21, 0x01, 0x06, 0x07, 0x06, 0x17, 0x16, 0x17, 0x05,
-  0x16, 0x1d, 0x01, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
-  0x27, 0x06, 0x04, 0x23, 0x21, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x04, 0x77, 0xa6, 0x01, 0x46, 0x2c,
-  0x6d, 0xfc, 0xb7, 0xfe, 0xc1, 0x09, 0x11, 0x90, 0x02, 0x6c, 0x01, 0x3c,
-  0xfc, 0xc4, 0x55, 0x0d, 0x09, 0x04, 0x05, 0x9d, 0x03, 0x69, 0xdf, 0x2b,
-  0x0d, 0x14, 0x29, 0x51, 0x53, 0x33, 0x0a, 0x4b, 0xfe, 0x95, 0x91, 0xfe,
-  0x3e, 0xad, 0x73, 0xfe, 0xd7, 0x39, 0xa5, 0x3a, 0xb7, 0x5d, 0x88, 0x58,
-  0x96, 0x6c, 0x05, 0x09, 0x6b, 0x12, 0x91, 0x37, 0xbe, 0x07, 0x06, 0x3e,
-  0x63, 0x60, 0x01, 0x9b, 0xfd, 0xe8, 0x37, 0x23, 0x0a, 0x23, 0x35, 0x1b,
-  0x96, 0x26, 0xf8, 0x45, 0x5e, 0x11, 0x05, 0xb8, 0x32, 0x30, 0x39, 0x82,
-  0x26, 0x62, 0x01, 0x0b, 0x8a, 0x5c, 0x5e, 0x88, 0x7e, 0x42, 0x22, 0x00,
-  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x05, 0xde, 0x06, 0x14, 0x00, 0x20,
-  0x00, 0x00, 0x23, 0x35, 0x21, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x25,
-  0x24, 0x3d, 0x01, 0x34, 0x37, 0x36, 0x37, 0x01, 0x21, 0x01, 0x06, 0x07,
-  0x06, 0x17, 0x16, 0x17, 0x05, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x12,
-  0x04, 0x87, 0x85, 0x29, 0x11, 0x03, 0x0b, 0x5a, 0xfc, 0xb7, 0xfe, 0xc1,
-  0x09, 0x10, 0x91, 0x02, 0x6c, 0x01, 0x3c, 0xfc, 0xc4, 0x55, 0x0d, 0x09,
-  0x04, 0x05, 0x9d, 0x03, 0x69, 0xdf, 0x38, 0x55, 0xc9, 0xb8, 0x68, 0x2c,
-  0x1c, 0x6e, 0x0f, 0x91, 0x37, 0xbe, 0x08, 0x05, 0x3e, 0x62, 0x61, 0x01,
-  0x9b, 0xfd, 0xe8, 0x37, 0x23, 0x0a, 0x23, 0x35, 0x1b, 0x96, 0x26, 0xf8,
-  0x71, 0x65, 0x9b, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x06, 0x53,
-  0x06, 0x14, 0x00, 0x29, 0x00, 0x00, 0x23, 0x35, 0x21, 0x32, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x25, 0x24, 0x3d, 0x01, 0x34, 0x37, 0x36, 0x37, 0x01,
-  0x21, 0x01, 0x06, 0x07, 0x06, 0x17, 0x16, 0x17, 0x05, 0x16, 0x1d, 0x01,
-  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x27, 0x06, 0x23,
-  0x12, 0x04, 0x87, 0x7b, 0x33, 0x0e, 0x65, 0xfc, 0xb7, 0xfe, 0xc1, 0x09,
-  0x10, 0x91, 0x02, 0x6c, 0x01, 0x3c, 0xfc, 0xc4, 0x55, 0x0d, 0x09, 0x04,
-  0x05, 0x9d, 0x03, 0x69, 0xdf, 0x2b, 0x0d, 0x14, 0x29, 0x51, 0x51, 0x32,
-  0x0a, 0x56, 0x97, 0xb8, 0x68, 0x1d, 0x18, 0x7f, 0x11, 0x91, 0x37, 0xbe,
-  0x08, 0x04, 0x3f, 0x62, 0x61, 0x01, 0x9b, 0xfd, 0xe8, 0x37, 0x23, 0x0a,
-  0x23, 0x35, 0x1b, 0x96, 0x26, 0xf8, 0x45, 0x5f, 0x10, 0x05, 0xb8, 0x2f,
-  0x28, 0x57, 0x00, 0x00, 0x00, 0x03, 0x00, 0x75, 0xff, 0xa7, 0x07, 0x11,
-  0x06, 0x14, 0x00, 0x37, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x00, 0x25, 0x06,
-  0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
-  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05, 0x06, 0x07,
-  0x06, 0x15, 0x14, 0x17, 0x01, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x13, 0x34, 0x27, 0x26, 0x22, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x05, 0x0c, 0x59, 0x98, 0xb8, 0xa5,
-  0xad, 0x73, 0xfe, 0xd7, 0x39, 0xa5, 0x3a, 0xb7, 0x5d, 0x88, 0xa6, 0xae,
-  0x8e, 0x20, 0x0e, 0x30, 0xfe, 0xe9, 0x2d, 0x09, 0x1f, 0x5a, 0x02, 0x9f,
-  0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c, 0x02, 0x0d, 0x13, 0x23, 0x26, 0x3a,
-  0x4f, 0x77, 0x3a, 0x34, 0x5d, 0x1e, 0x57, 0x17, 0x99, 0x19, 0x19, 0x4a,
-  0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x39, 0x39, 0xa6, 0x38, 0x3a, 0x3a,
-  0x38, 0xa6, 0x39, 0x78, 0x4c, 0x3c, 0x49, 0x26, 0x62, 0x01, 0x0b, 0x8a,
-  0x5c, 0x5e, 0x88, 0x7e, 0x42, 0x22, 0x50, 0x41, 0x37, 0x1a, 0x2e, 0x45,
-  0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21, 0x77, 0x2a, 0x01, 0x36, 0xba,
-  0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25, 0xfd, 0x3f, 0x1a, 0x0e, 0x10,
-  0xb8, 0x18, 0x2b, 0x29, 0x78, 0x40, 0x03, 0xbc, 0x28, 0x1c, 0x1d, 0x38,
-  0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8,
-  0x40, 0x3f, 0x3f, 0x00, 0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x03, 0x6e,
-  0x06, 0x14, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x37, 0x00, 0x00, 0x29, 0x01,
-  0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x26, 0x35, 0x34,
-  0x37, 0x36, 0x37, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
-  0x13, 0x16, 0x15, 0x14, 0x07, 0x06, 0x13, 0x34, 0x27, 0x26, 0x22, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17,
-  0x85, 0x29, 0x0e, 0x31, 0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f,
-  0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c, 0xf7, 0x5c, 0x38, 0x55, 0xfe, 0x19,
-  0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38,
-  0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01,
-  0x7c, 0x3d, 0x51, 0x23, 0x21, 0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e,
-  0x28, 0x0b, 0x19, 0x20, 0x25, 0xfe, 0xb6, 0x7b, 0x7b, 0x71, 0x65, 0x9b,
-  0x04, 0x60, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85,
-  0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x00, 0x00,
-  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x29,
-  0x00, 0x35, 0x00, 0x41, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37,
-  0x36, 0x35, 0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01,
-  0x15, 0x05, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x01, 0x16, 0x17, 0x16,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x07, 0x06,
-  0x01, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e,
-  0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17,
-  0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29, 0x0e, 0x31, 0xfe, 0xea,
-  0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c,
-  0x02, 0x0c, 0x14, 0x22, 0x27, 0x3a, 0x4f, 0x77, 0x3a, 0x35, 0x5c, 0x1e,
-  0x57, 0x13, 0x10, 0x55, 0x01, 0x01, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19,
-  0x4a, 0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a,
-  0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21,
-  0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25,
-  0xfd, 0x3f, 0x1a, 0x0e, 0x10, 0xb8, 0x18, 0x2b, 0x29, 0x78, 0x2e, 0x1b,
-  0x9b, 0x04, 0x60, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38,
-  0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x00,
-  0x00, 0x03, 0x00, 0x81, 0xff, 0xc9, 0x06, 0x24, 0x06, 0x14, 0x00, 0x21,
-  0x00, 0x44, 0x00, 0x48, 0x00, 0x00, 0x01, 0x15, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27,
-  0x35, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26,
-  0x37, 0x36, 0x37, 0x36, 0x13, 0x06, 0x27, 0x26, 0x27, 0x24, 0x35, 0x34,
-  0x37, 0x33, 0x06, 0x15, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
-  0x36, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x27, 0x06, 0x01, 0x33, 0x15, 0x23, 0x03, 0x6e, 0x42, 0x22, 0x48,
-  0x0c, 0x0b, 0x3d, 0x5c, 0x4f, 0x4a, 0x46, 0x3c, 0x32, 0x3d, 0x29, 0x36,
-  0x33, 0x36, 0x46, 0x43, 0x10, 0x1d, 0x01, 0x02, 0x43, 0x4d, 0x7c, 0x62,
-  0x83, 0xba, 0x5b, 0xfe, 0xf9, 0x0e, 0xa6, 0x0d, 0x02, 0x90, 0x6d, 0x72,
-  0x7e, 0x50, 0x89, 0x58, 0x45, 0xa5, 0x2c, 0x28, 0x59, 0x43, 0x75, 0x89,
-  0x66, 0x8e, 0xfe, 0x72, 0x87, 0x87, 0x04, 0x6f, 0x52, 0x04, 0x0e, 0x1e,
-  0x21, 0x1c, 0x12, 0x10, 0x0a, 0x0f, 0x58, 0x6e, 0x2a, 0x27, 0x0b, 0x58,
-  0x0a, 0x1a, 0x1a, 0x1e, 0x26, 0x11, 0x10, 0x1c, 0x2f, 0x2e, 0x51, 0x26,
-  0x2b, 0xfb, 0x70, 0x14, 0x02, 0x02, 0x1e, 0x58, 0xc3, 0x4b, 0x35, 0x3a,
-  0x2c, 0x5c, 0x2e, 0x23, 0x1b, 0x2f, 0x5e, 0x49, 0x01, 0x01, 0x03, 0xb1,
-  0xfb, 0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x7b, 0x7e, 0x05, 0xdf, 0x96, 0x00,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0x6e, 0x06, 0x72, 0x00, 0x1f,
-  0x00, 0x23, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x13, 0x16, 0x15, 0x14, 0x07, 0x06,
-  0x01, 0x33, 0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29,
-  0x0e, 0x31, 0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8,
-  0x40, 0x13, 0x05, 0x1c, 0xf7, 0x5c, 0x38, 0x55, 0xfe, 0xd4, 0x87, 0x87,
-  0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21,
-  0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25,
-  0xfe, 0xb6, 0x7b, 0x7b, 0x71, 0x65, 0x9b, 0x06, 0x72, 0x96, 0x00, 0x00,
-  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x72, 0x00, 0x29,
-  0x00, 0x2d, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35,
-  0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05,
-  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x01, 0x16, 0x17, 0x16, 0x3b, 0x01,
-  0x15, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x07, 0x06, 0x01, 0x33,
-  0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29, 0x0e, 0x31,
-  0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13,
-  0x05, 0x1c, 0x02, 0x0c, 0x14, 0x22, 0x27, 0x3a, 0x4f, 0x77, 0x3a, 0x35,
-  0x5c, 0x1e, 0x57, 0x13, 0x10, 0x55, 0xfe, 0xd7, 0x87, 0x87, 0xb8, 0x68,
-  0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21, 0x76, 0x2b,
-  0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25, 0xfd, 0x3f,
-  0x1a, 0x0e, 0x10, 0xb8, 0x18, 0x2b, 0x29, 0x78, 0x2e, 0x1b, 0x9b, 0x06,
-  0x72, 0x96, 0x00, 0x00, 0x00, 0x05, 0x00, 0x81, 0xfd, 0xa8, 0x06, 0x24,
-  0x06, 0x14, 0x00, 0x21, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c, 0x00, 0x50,
-  0x00, 0x00, 0x01, 0x15, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17,
-  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35, 0x16, 0x33, 0x32,
-  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x37, 0x36, 0x37, 0x36,
-  0x13, 0x06, 0x27, 0x26, 0x27, 0x24, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15,
-  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x19, 0x01, 0x33,
-  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01,
-  0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
-  0x6e, 0x42, 0x22, 0x48, 0x0c, 0x0b, 0x3d, 0x5c, 0x4f, 0x4a, 0x46, 0x3c,
-  0x32, 0x3d, 0x29, 0x36, 0x33, 0x36, 0x46, 0x43, 0x10, 0x1d, 0x01, 0x02,
-  0x43, 0x4d, 0x7c, 0x62, 0x83, 0xba, 0x5b, 0xfe, 0xf9, 0x0e, 0xa6, 0x0d,
-  0x02, 0x90, 0x6d, 0x72, 0x7e, 0x50, 0x89, 0x58, 0x45, 0xa5, 0x2c, 0x28,
-  0x59, 0x43, 0x75, 0x89, 0x66, 0x8e, 0xfe, 0x5b, 0x88, 0x88, 0x71, 0x87,
-  0x87, 0xe1, 0x87, 0x87, 0x04, 0x6f, 0x52, 0x04, 0x0e, 0x1e, 0x21, 0x1c,
-  0x12, 0x10, 0x0a, 0x0f, 0x58, 0x6e, 0x2a, 0x27, 0x0b, 0x58, 0x0a, 0x1a,
-  0x1a, 0x1e, 0x26, 0x11, 0x10, 0x1c, 0x2f, 0x2e, 0x51, 0x26, 0x2b, 0xfb,
-  0x70, 0x14, 0x02, 0x02, 0x1e, 0x58, 0xc3, 0x4b, 0x35, 0x3a, 0x2c, 0x5c,
-  0x2e, 0x23, 0x1b, 0x2f, 0x5e, 0x49, 0x01, 0x01, 0x03, 0xb1, 0xfb, 0x6b,
-  0x6a, 0x31, 0x2c, 0xb8, 0x7b, 0x7e, 0xfe, 0x41, 0x96, 0x01, 0x90, 0x96,
-  0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee, 0xfd, 0xda, 0x03, 0x6e,
-  0x06, 0x14, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x00,
-  0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x26,
-  0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x15,
-  0x14, 0x17, 0x13, 0x16, 0x15, 0x14, 0x07, 0x06, 0x03, 0x33, 0x15, 0x23,
-  0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7,
-  0x01, 0x17, 0x85, 0x29, 0x0e, 0x31, 0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e,
-  0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c, 0xf7, 0x5c, 0x38, 0x55,
-  0xbc, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb8, 0x68, 0x24,
-  0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21, 0x76, 0x2b, 0x01,
-  0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25, 0xfe, 0xb6, 0x7b,
-  0x7b, 0x71, 0x65, 0x9b, 0xfe, 0x70, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96,
-  0x00, 0x04, 0xff, 0xee, 0xfd, 0xda, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x29,
-  0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21,
-  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36,
-  0x37, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x01, 0x16,
-  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x06,
-  0x07, 0x06, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29, 0x0e, 0x31,
-  0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13,
-  0x05, 0x1c, 0x02, 0x0c, 0x14, 0x22, 0x27, 0x3a, 0x4f, 0x77, 0x3a, 0x35,
-  0x5c, 0x1e, 0x57, 0x13, 0x10, 0x55, 0xb9, 0x88, 0x88, 0x71, 0x87, 0x87,
-  0xe1, 0x87, 0x87, 0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d,
-  0x51, 0x23, 0x21, 0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b,
-  0x19, 0x20, 0x25, 0xfd, 0x3f, 0x1a, 0x0e, 0x10, 0xb8, 0x18, 0x2b, 0x29,
-  0x78, 0x2e, 0x1b, 0x9b, 0xfe, 0x70, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96,
-  0x00, 0x03, 0x03, 0x69, 0x03, 0x84, 0x06, 0x72, 0x07, 0x2b, 0x00, 0x03,
-  0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x09, 0x01, 0x35, 0x01, 0x03, 0x34,
-  0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14,
-  0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x06, 0x72,
-  0xfc, 0xf7, 0x03, 0x09, 0x97, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a,
-  0x32, 0x6e, 0x39, 0x39, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x39, 0x06,
-  0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xfd, 0x35, 0x28, 0x1c, 0x1d, 0x38,
-  0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8,
-  0x40, 0x3f, 0x3f, 0x00, 0x00, 0x03, 0x00, 0x64, 0x03, 0x84, 0x03, 0x6e,
-  0x07, 0x2b, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x09, 0x01,
-  0x35, 0x01, 0x03, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36,
-  0x32, 0x17, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09, 0x90, 0x19, 0x19, 0x4a,
-  0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38, 0x3a, 0x3a,
-  0x38, 0xa6, 0x3a, 0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xfd, 0x35,
-  0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40,
-  0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x00, 0x03, 0x00, 0x64,
-  0x03, 0x84, 0x03, 0x6e, 0x07, 0x2b, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b,
-  0x00, 0x00, 0x09, 0x01, 0x35, 0x01, 0x03, 0x34, 0x27, 0x26, 0x22, 0x06,
-  0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27,
-  0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09,
-  0x90, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38, 0x3a,
-  0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0x06, 0x95, 0xfe, 0x9e, 0x96,
-  0x01, 0x62, 0xfd, 0x35, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b,
-  0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00,
-  0x00, 0x03, 0x02, 0x1c, 0xfe, 0xa2, 0x06, 0x72, 0x07, 0x2b, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01, 0x35, 0x09, 0x01, 0x33,
-  0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x06, 0x72, 0xfc, 0xf7, 0x03, 0x09,
-  0xfc, 0x8b, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x06, 0x95, 0xfe, 0x9e, 0x96,
-  0x01, 0x62, 0xf8, 0x0d, 0x96, 0x96, 0x96, 0x00, 0x00, 0x03, 0x00, 0x64,
-  0xfe, 0xd4, 0x03, 0x6e, 0x07, 0x2b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x00, 0x09, 0x01, 0x35, 0x09, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09, 0xfe, 0x27, 0x87, 0x87,
-  0xe1, 0x87, 0x87, 0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xf8, 0x3f,
-  0x96, 0x96, 0x96, 0x00, 0x00, 0x03, 0x00, 0x64, 0xfe, 0xd4, 0x03, 0x6e,
-  0x07, 0x2b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01,
-  0x35, 0x09, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x6e,
-  0xfc, 0xf7, 0x03, 0x09, 0xfe, 0x27, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x06,
-  0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xf8, 0x3f, 0x96, 0x96, 0x96, 0x00,
-  0x00, 0x04, 0x03, 0x2a, 0x05, 0x33, 0x06, 0x72, 0x08, 0x34, 0x00, 0x03,
-  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x09, 0x01, 0x35, 0x09,
-  0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23,
-  0x06, 0x72, 0xfc, 0xf7, 0x03, 0x09, 0xfd, 0x28, 0x88, 0x88, 0x71, 0x87,
-  0x87, 0xe1, 0x87, 0x87, 0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0x01,
-  0x09, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0x00, 0x43,
-  0x05, 0x33, 0x03, 0x6e, 0x08, 0x34, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
-  0x00, 0x0f, 0x00, 0x00, 0x09, 0x01, 0x35, 0x09, 0x01, 0x33, 0x15, 0x23,
-  0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x6e, 0xfc, 0xf7,
-  0x03, 0x09, 0xfd, 0x46, 0x87, 0x87, 0x70, 0x88, 0x88, 0xe0, 0x86, 0x86,
-  0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0x01, 0x09, 0x96, 0x64, 0x96,
-  0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0x00, 0x43, 0x05, 0x33, 0x03, 0x6e,
-  0x08, 0x34, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
-  0x09, 0x01, 0x35, 0x09, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23,
-  0x27, 0x33, 0x15, 0x23, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09, 0xfd, 0x46,
-  0x87, 0x87, 0x70, 0x88, 0x88, 0xe0, 0x86, 0x86, 0x06, 0x95, 0xfe, 0x9e,
-  0x96, 0x01, 0x62, 0x01, 0x09, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00,
-  0x00, 0x02, 0x00, 0x81, 0xfe, 0xc8, 0x05, 0x86, 0x07, 0x9e, 0x00, 0x24,
-  0x00, 0x28, 0x00, 0x00, 0x25, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17,
-  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06,
-  0x23, 0x22, 0x27, 0x24, 0x11, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
-  0x16, 0x33, 0x32, 0x37, 0x36, 0x13, 0x33, 0x15, 0x23, 0x03, 0xaa, 0x46,
-  0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46, 0x10, 0x19, 0x6d, 0xea,
-  0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39, 0xa6, 0x3b, 0x96, 0x24,
-  0x41, 0x48, 0x63, 0x9c, 0x92, 0x87, 0x87, 0x49, 0x7e, 0xe3, 0x04, 0x6a,
-  0xfb, 0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22,
-  0x16, 0x5b, 0x01, 0x12, 0x8a, 0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22,
-  0x35, 0x07, 0xcc, 0x96, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x01, 0x84,
-  0x07, 0x9e, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06,
-  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x03, 0x33,
-  0x15, 0x23, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75, 0x44, 0x59, 0x27, 0x2c,
-  0xa6, 0x9d, 0x87, 0x87, 0x01, 0x73, 0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31,
-  0x6a, 0x04, 0x95, 0x01, 0x8a, 0x96, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0x75, 0x07, 0x9e, 0x00, 0x14, 0x00, 0x18, 0x00, 0x00,
-  0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
-  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x03, 0x33, 0x15,
-  0x23, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27, 0x2c, 0xa6, 0x2c,
-  0x28, 0x59, 0x43, 0x75, 0x87, 0x91, 0x87, 0x87, 0x56, 0x56, 0xb8, 0x2c,
-  0x31, 0x6a, 0x04, 0x95, 0xfb, 0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x07, 0x9e,
-  0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x81, 0xfe, 0xc8, 0x05, 0x86,
-  0x08, 0x34, 0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x00,
-  0x25, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15,
-  0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24,
-  0x11, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
-  0x36, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
-  0x23, 0x03, 0xaa, 0x46, 0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46,
-  0x10, 0x19, 0x6d, 0xea, 0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39,
-  0xa6, 0x3b, 0x96, 0x24, 0x41, 0x48, 0x63, 0x9c, 0x8d, 0x88, 0x88, 0x71,
-  0x87, 0x87, 0xe1, 0x87, 0x87, 0x49, 0x7e, 0xe3, 0x04, 0x6a, 0xfb, 0x6b,
-  0x6a, 0x31, 0x2c, 0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22, 0x16, 0x5b,
-  0x01, 0x12, 0x8a, 0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22, 0x35, 0x08,
-  0x62, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
-  0x00, 0x00, 0x01, 0xdb, 0x08, 0x34, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x15,
-  0x00, 0x19, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
-  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x03, 0x33, 0x15, 0x23, 0x17, 0x33,
-  0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75,
-  0x44, 0x59, 0x27, 0x2c, 0xa6, 0xa1, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1,
-  0x87, 0x87, 0x01, 0x73, 0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31, 0x6a, 0x04,
-  0x95, 0x02, 0x20, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee,
-  0x00, 0x00, 0x02, 0x75, 0x08, 0x34, 0x00, 0x14, 0x00, 0x18, 0x00, 0x1c,
-  0x00, 0x20, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
-  0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x03, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
-  0x23, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27, 0x2c, 0xa6, 0x2c,
-  0x28, 0x59, 0x43, 0x75, 0x87, 0x95, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1,
-  0x87, 0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xfb, 0x6b,
-  0x6a, 0x31, 0x2c, 0xb8, 0x08, 0x34, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00,
-  0x00, 0x04, 0x00, 0x81, 0xfc, 0xe0, 0x05, 0x86, 0x06, 0x14, 0x00, 0x24,
-  0x00, 0x28, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x00, 0x25, 0x36, 0x35, 0x11,
-  0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06,
-  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x26, 0x37, 0x33,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x01, 0x33, 0x15,
-  0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0xaa, 0x46,
-  0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46, 0x10, 0x19, 0x6d, 0xea,
-  0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39, 0xa6, 0x3b, 0x96, 0x24,
-  0x41, 0x48, 0x63, 0x9c, 0xfe, 0xf9, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1,
-  0x87, 0x87, 0x49, 0x7e, 0xe3, 0x04, 0x6a, 0xfb, 0x6b, 0x6a, 0x31, 0x2c,
-  0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22, 0x16, 0x5b, 0x01, 0x12, 0x8a,
-  0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22, 0x35, 0xfd, 0xa4, 0x96, 0x01,
-  0x90, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee, 0xfe, 0x0c, 0x01, 0xc2,
-  0x06, 0x14, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x15, 0x00, 0x19, 0x00, 0x00,
-  0x01, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
-  0x11, 0x33, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
-  0x15, 0x23, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75, 0x44, 0x59, 0x27, 0x2c,
-  0xa6, 0xba, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01, 0x73,
-  0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xf8, 0x8e, 0x96,
-  0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
-  0xfe, 0x0c, 0x02, 0x75, 0x06, 0x14, 0x00, 0x14, 0x00, 0x18, 0x00, 0x1c,
-  0x00, 0x20, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
-  0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
-  0x22, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
-  0x23, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27, 0x2c, 0xa6, 0x2c,
-  0x28, 0x59, 0x43, 0x75, 0x87, 0x93, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1,
-  0x87, 0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xfb, 0x6b,
-  0x6a, 0x31, 0x2c, 0xb8, 0xfe, 0xa2, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96,
-  0x00, 0x03, 0x00, 0x84, 0xfc, 0xc7, 0x05, 0x8e, 0x02, 0xbc, 0x00, 0x26,
-  0x00, 0x2a, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x17, 0x16,
-  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
-  0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16,
-  0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x25, 0x33, 0x15,
-  0x23, 0x13, 0x33, 0x15, 0x23, 0x04, 0x63, 0x28, 0x18, 0x14, 0x2d, 0x30,
-  0x36, 0x43, 0x75, 0x40, 0x1e, 0x03, 0x50, 0x6c, 0xd7, 0x58, 0x52, 0x69,
-  0x65, 0xfe, 0xd8, 0x2b, 0xa5, 0x2c, 0xb5, 0x51, 0x44, 0x50, 0x47, 0xae,
-  0x44, 0x1d, 0x5a, 0xfe, 0x48, 0x86, 0x86, 0x70, 0x87, 0x87, 0x02, 0x45,
-  0x61, 0x60, 0x50, 0x3c, 0x40, 0xb8, 0x30, 0x6d, 0x93, 0xc7, 0x42, 0x1b,
-  0x25, 0x6b, 0x01, 0x63, 0xaf, 0x8d, 0x89, 0xb3, 0xec, 0x35, 0x18, 0x14,
-  0x30, 0xe3, 0x65, 0x70, 0xb8, 0xcb, 0x77, 0x96, 0xfb, 0x37, 0x96, 0x00,
-  0xff, 0xff, 0xff, 0xee, 0xfe, 0xd4, 0x01, 0x60, 0x03, 0xe8, 0x10, 0x27,
-  0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00,
-  0x10, 0x07, 0x10, 0xf6, 0x00, 0xca, 0xfe, 0xd4, 0xff, 0xff, 0xff, 0xee,
-  0xfe, 0xd4, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x27, 0x10, 0xf6, 0x00, 0xca,
-  0x03, 0x52, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf6,
-  0x00, 0xca, 0xfe, 0xd4, 0x00, 0x04, 0x00, 0x84, 0xfc, 0xae, 0x05, 0x8e,
-  0x02, 0xbc, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x36, 0x00, 0x42, 0x00, 0x00,
-  0x01, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37,
-  0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x25, 0x33, 0x15, 0x23, 0x01, 0x34, 0x27, 0x26, 0x22,
-  0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22,
-  0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x04, 0x63, 0x28, 0x18, 0x14,
-  0x2d, 0x30, 0x36, 0x43, 0x75, 0x40, 0x1e, 0x03, 0x50, 0x6c, 0xd7, 0x58,
-  0x52, 0x69, 0x65, 0xfe, 0xd8, 0x2b, 0xa5, 0x2c, 0xb5, 0x51, 0x44, 0x50,
-  0x47, 0xae, 0x44, 0x1d, 0x5a, 0xfe, 0x48, 0x86, 0x86, 0x01, 0x05, 0x19,
-  0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x39, 0x39, 0xa6, 0x38,
-  0x3a, 0x3a, 0x38, 0xa6, 0x39, 0x02, 0x45, 0x61, 0x60, 0x50, 0x3c, 0x40,
-  0xb8, 0x30, 0x6d, 0x93, 0xc7, 0x42, 0x1b, 0x25, 0x6b, 0x01, 0x63, 0xaf,
-  0x8d, 0x89, 0xb3, 0xec, 0x35, 0x18, 0x14, 0x30, 0xe3, 0x65, 0x70, 0xb8,
-  0xcb, 0x77, 0x96, 0xfb, 0x64, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c,
-  0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f,
-  0xff, 0xff, 0xff, 0xee, 0xfe, 0xf4, 0x01, 0xd3, 0x03, 0xe8, 0x10, 0x27,
-  0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00,
-  0x10, 0x07, 0x11, 0x07, 0x00, 0x48, 0xfe, 0xf4, 0xff, 0xff, 0xff, 0xee,
-  0xfe, 0xf4, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x27, 0x10, 0xf6, 0x00, 0xca,
-  0x03, 0x52, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x11, 0x07,
-  0x00, 0x48, 0xfe, 0xf4, 0x00, 0x04, 0x00, 0x84, 0xfe, 0x0c, 0x05, 0x8e,
-  0x03, 0xb6, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x2e, 0x00, 0x32, 0x00, 0x00,
-  0x01, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
-  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37,
-  0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
-  0x35, 0x34, 0x27, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27,
-  0x33, 0x15, 0x23, 0x04, 0x63, 0x28, 0x18, 0x14, 0x2d, 0x30, 0x36, 0x43,
-  0x75, 0x40, 0x1e, 0x03, 0x50, 0x6c, 0xd7, 0x58, 0x52, 0x69, 0x65, 0xfe,
-  0xd8, 0x2b, 0xa5, 0x2c, 0xb5, 0x51, 0x44, 0x50, 0x47, 0xae, 0x44, 0x1d,
-  0x5a, 0xfe, 0x74, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x02,
-  0x45, 0x61, 0x60, 0x50, 0x3c, 0x40, 0xb8, 0x30, 0x6d, 0x93, 0xc7, 0x42,
-  0x1b, 0x25, 0x6b, 0x01, 0x63, 0xaf, 0x8d, 0x89, 0xb3, 0xec, 0x35, 0x18,
-  0x14, 0x30, 0xe3, 0x65, 0x70, 0xb8, 0xcb, 0x01, 0x71, 0x96, 0x64, 0x96,
-  0x96, 0x96, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x01, 0xc2,
-  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf8,
-  0x00, 0x59, 0x03, 0x52, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3f,
-  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf8,
-  0x00, 0x59, 0x03, 0x52, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x57, 0x0a,
-  0xdd, 0x83, 0xf3, 0x6b, 0x5f, 0x0f, 0x3c, 0xf5, 0x00, 0x1f, 0x08, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0xce, 0x3f, 0xd8, 0x65, 0x00, 0x00, 0x00, 0x00,
-  0xce, 0x3f, 0xd8, 0x65, 0xf8, 0xa7, 0xfc, 0xae, 0x0c, 0x1a, 0x09, 0x55,
-  0x00, 0x20, 0x00, 0x08, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x01, 0x00, 0x00, 0x07, 0x6d, 0xfe, 0x1d, 0x00, 0x00, 0x0c, 0x7e,
-  0xf8, 0xa7, 0xfc, 0xc9, 0x0c, 0x1a, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x0e,
-  0x04, 0x52, 0x00, 0x5b, 0x00, 0x00, 0x00, 0x00, 0x02, 0xaa, 0x00, 0x00,
-  0x02, 0x49, 0x00, 0x00, 0x02, 0xe2, 0x01, 0x16, 0x03, 0x4f, 0x00, 0xb1,
-  0x06, 0x08, 0x00, 0x8e, 0x04, 0x94, 0x00, 0x99, 0x06, 0xd7, 0x00, 0x65,
-  0x05, 0x9d, 0x00, 0x74, 0x01, 0xfa, 0x00, 0xb1, 0x02, 0xcf, 0x00, 0x9e,
-  0x02, 0xcf, 0x00, 0x93, 0x03, 0x99, 0x00, 0x36, 0x06, 0x08, 0x00, 0xc3,
-  0x02, 0x49, 0x00, 0x8e, 0x02, 0x99, 0x00, 0x5a, 0x02, 0x49, 0x00, 0xc5,
-  0x02, 0x6d, 0x00, 0x00, 0x04, 0x94, 0x00, 0x79, 0x04, 0x94, 0x00, 0xca,
-  0x04, 0x94, 0x00, 0x87, 0x04, 0x94, 0x00, 0x8c, 0x04, 0x94, 0x00, 0x5a,
-  0x04, 0x94, 0x00, 0x8e, 0x04, 0x94, 0x00, 0x80, 0x04, 0x94, 0x00, 0x97,
-  0x04, 0x94, 0x00, 0x7d, 0x04, 0x94, 0x00, 0x74, 0x02, 0x6d, 0x00, 0xd8,
-  0x02, 0x6d, 0x00, 0x8e, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x03, 0xd2, 0x00, 0x84, 0x07, 0x33, 0x00, 0x79,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0xf0, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67,
-  0x05, 0x8b, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x24, 0x00, 0xb4,
-  0x05, 0x94, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0xb4,
-  0x02, 0x1f, 0xff, 0xa1, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x02, 0x00, 0xb4,
-  0x06, 0x36, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x57, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x00, 0x00, 0xb4,
-  0x04, 0x92, 0x00, 0x79, 0x04, 0x65, 0xff, 0xfb, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0xec, 0x00, 0x0e, 0x07, 0x1e, 0x00, 0x3d, 0x04, 0xee, 0x00, 0x36,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0xee, 0x00, 0x52, 0x02, 0xcf, 0x00, 0x9e,
-  0x02, 0x6d, 0x00, 0x00, 0x02, 0xcf, 0x00, 0xb3, 0x06, 0x08, 0x00, 0xc3,
-  0x03, 0x99, 0xff, 0xee, 0x03, 0x99, 0x00, 0x99, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0x92, 0x00, 0xa7, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
-  0x04, 0x6e, 0x00, 0x65, 0x02, 0x88, 0x00, 0x2a, 0x04, 0x92, 0x00, 0x65,
-  0x04, 0x90, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x02, 0x00, 0xff, 0xdf,
-  0x04, 0x2b, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x07, 0x03, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x04, 0x92, 0x00, 0xa7,
-  0x04, 0x92, 0x00, 0x65, 0x02, 0xf5, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63,
-  0x02, 0xd2, 0x00, 0x31, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x42, 0x00, 0x36,
-  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x35, 0x04, 0x42, 0x00, 0x36,
-  0x03, 0xc7, 0x00, 0x4f, 0x04, 0x94, 0x00, 0xe6, 0x02, 0x6d, 0x00, 0xea,
-  0x04, 0x94, 0x00, 0xe6, 0x06, 0x08, 0x00, 0xc3, 0x02, 0x49, 0x00, 0x00,
-  0x02, 0xe2, 0x01, 0x16, 0x04, 0x94, 0x00, 0x9a, 0x04, 0x94, 0x00, 0x74,
-  0x04, 0x94, 0x00, 0x54, 0x04, 0x94, 0x00, 0x49, 0x02, 0x6d, 0x00, 0xea,
-  0x03, 0x99, 0x00, 0x52, 0x03, 0x99, 0x00, 0xc1, 0x07, 0x33, 0x00, 0xfe,
-  0x03, 0x64, 0x00, 0x67, 0x04, 0x67, 0x00, 0x8e, 0x06, 0x08, 0x00, 0xc3,
-  0x02, 0x99, 0x00, 0x5a, 0x07, 0x33, 0x00, 0xfe, 0x03, 0x99, 0x00, 0xbf,
-  0x03, 0x99, 0x00, 0xaf, 0x06, 0x08, 0x00, 0xc3, 0x02, 0xe2, 0x00, 0x54,
-  0x02, 0xe2, 0x00, 0x58, 0x03, 0x99, 0x01, 0x4d, 0x04, 0x94, 0x00, 0x9c,
-  0x04, 0x94, 0x00, 0x8e, 0x02, 0x49, 0x00, 0xc5, 0x03, 0x99, 0x01, 0x05,
-  0x02, 0xe2, 0x00, 0x7b, 0x03, 0x64, 0x00, 0x56, 0x04, 0x67, 0x00, 0xad,
-  0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x58,
-  0x03, 0xd2, 0x00, 0x80, 0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0xec, 0x00, 0x0e, 0x07, 0x03, 0x00, 0x07, 0x05, 0x07, 0x00, 0x67,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x8c, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0x35, 0x02, 0x1f, 0x00, 0x91,
-  0x02, 0x1f, 0xff, 0xff, 0x02, 0x1f, 0x00, 0x05, 0x05, 0x94, 0x00, 0x09,
-  0x05, 0x62, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0xaa, 0x00, 0x67,
-  0x05, 0xaa, 0x00, 0x67, 0x05, 0xaa, 0x00, 0x67, 0x05, 0xaa, 0x00, 0x67,
-  0x06, 0x08, 0x00, 0xfc, 0x05, 0xaa, 0x00, 0x5b, 0x05, 0x45, 0x00, 0xa0,
-  0x05, 0x45, 0x00, 0xa0, 0x05, 0x45, 0x00, 0xa0, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0x5b, 0x00, 0xb4, 0x04, 0x89, 0x00, 0xa7,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e,
-  0x07, 0x11, 0x00, 0x6e, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65,
-  0x02, 0x00, 0xff, 0xcd, 0x02, 0x00, 0x00, 0x81, 0x02, 0x00, 0xff, 0xe2,
-  0x02, 0x00, 0xff, 0xf6, 0x04, 0x67, 0x00, 0x65, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x06, 0x08, 0x00, 0xc3,
-  0x04, 0x67, 0x00, 0x40, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x90, 0x00, 0x9c,
-  0x04, 0x90, 0x00, 0x9c, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x42, 0x00, 0x36,
-  0x04, 0x92, 0x00, 0xa7, 0x04, 0x42, 0x00, 0x36, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x05, 0x07, 0x00, 0x67,
-  0x03, 0xf5, 0x00, 0x65, 0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65,
-  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x05, 0x07, 0x00, 0x67,
-  0x03, 0xf5, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65,
-  0x05, 0x94, 0x00, 0x09, 0x04, 0x92, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x05, 0x94, 0x00, 0x67,
-  0x04, 0x92, 0x00, 0x65, 0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
-  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x05, 0x6a, 0x00, 0xb4,
-  0x04, 0x90, 0xff, 0xe8, 0x06, 0x98, 0x00, 0xb4, 0x05, 0x00, 0x00, 0x6c,
-  0x02, 0x1f, 0xff, 0xe7, 0x02, 0x00, 0xff, 0xd8, 0x02, 0x1f, 0x00, 0x02,
-  0x02, 0x00, 0xff, 0xf4, 0x02, 0x1f, 0xff, 0xf7, 0x02, 0x00, 0xff, 0xe7,
-  0x02, 0x1f, 0x00, 0x9e, 0x02, 0x00, 0x00, 0x87, 0x02, 0x1f, 0x00, 0xb4,
-  0x02, 0x00, 0x00, 0xad, 0x04, 0x3f, 0x00, 0xb4, 0x04, 0x00, 0x00, 0xad,
-  0x02, 0x1f, 0xff, 0xa1, 0x02, 0x00, 0xff, 0xdf, 0x04, 0xb8, 0x00, 0xb4,
-  0x04, 0x2b, 0x00, 0xa7, 0x04, 0x2b, 0x00, 0xa7, 0x04, 0x02, 0x00, 0xb4,
-  0x02, 0x00, 0x00, 0xad, 0x04, 0x02, 0x00, 0xb4, 0x02, 0x00, 0x00, 0x7a,
-  0x04, 0x02, 0x00, 0xb4, 0x02, 0xb3, 0x00, 0xad, 0x04, 0x02, 0x00, 0xb4,
-  0x02, 0x76, 0x00, 0xad, 0x04, 0x0b, 0xff, 0xf4, 0x02, 0x0b, 0x00, 0x01,
-  0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4,
-  0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x05, 0xdb, 0x00, 0xb8, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x07, 0xb3, 0x00, 0x67, 0x07, 0x5d, 0x00, 0x65, 0x05, 0x00, 0x00, 0xb4,
-  0x02, 0xf5, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0x75,
-  0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7, 0x04, 0x92, 0x00, 0x79,
-  0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63,
-  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79,
-  0x03, 0xc0, 0x00, 0x63, 0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31,
-  0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb,
-  0x02, 0xd2, 0x00, 0x31, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
-  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
-  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0x90, 0x00, 0x9c, 0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd,
-  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xee, 0x00, 0x52,
-  0x03, 0xc7, 0x00, 0x4f, 0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f,
-  0x02, 0x88, 0x00, 0x2a, 0x04, 0x92, 0x00, 0x1c, 0x05, 0x4a, 0xff, 0xa2,
-  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7, 0x04, 0xf0, 0x00, 0x00,
-  0x04, 0x92, 0x00, 0x00, 0x05, 0x10, 0x00, 0x67, 0x05, 0x07, 0x00, 0x67,
-  0x03, 0xf5, 0x00, 0x65, 0x05, 0x94, 0x00, 0x09, 0x05, 0xe5, 0xff, 0xa2,
-  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0x8c, 0x00, 0x75, 0x05, 0xaa, 0x00, 0x69, 0x04, 0x6c, 0x00, 0x93,
-  0x04, 0x24, 0xff, 0xa1, 0x02, 0x88, 0xff, 0x8c, 0x05, 0x94, 0x00, 0x67,
-  0x04, 0xf1, 0x00, 0x07, 0x07, 0x15, 0x00, 0xa7, 0x02, 0x8b, 0x00, 0xb4,
-  0x02, 0x1f, 0x00, 0x09, 0x05, 0x5e, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa6,
-  0x02, 0x00, 0x00, 0x09, 0x04, 0x42, 0x00, 0x36, 0x07, 0x03, 0x00, 0xa0,
-  0x05, 0x62, 0xff, 0xa1, 0x04, 0x90, 0x00, 0xa7, 0x05, 0xaa, 0x00, 0x67,
-  0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a, 0x06, 0xd4, 0x00, 0x67,
-  0x05, 0x77, 0x00, 0x65, 0x04, 0xb1, 0xff, 0xa2, 0x04, 0x92, 0x00, 0xa6,
-  0x05, 0x00, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x66, 0x03, 0xc0, 0x00, 0x5a,
-  0x04, 0x8c, 0x00, 0xb4, 0x02, 0x6b, 0xff, 0x0d, 0x02, 0xd2, 0x00, 0x31,
-  0x04, 0x65, 0x00, 0x15, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb,
-  0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e, 0x05, 0x80, 0x00, 0x46,
-  0x05, 0x30, 0x00, 0xb4, 0x05, 0x5a, 0xff, 0xfd, 0x05, 0x42, 0x00, 0x36,
-  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xcb, 0x00, 0x90,
-  0x04, 0xcb, 0x00, 0x52, 0x04, 0x28, 0x00, 0x5d, 0x03, 0xc7, 0x00, 0x65,
-  0x04, 0x94, 0x00, 0x87, 0x04, 0xcb, 0x00, 0x53, 0x04, 0x28, 0x00, 0x5d,
-  0x03, 0xac, 0x00, 0x4f, 0x04, 0x92, 0x00, 0xa7, 0x02, 0x1f, 0x00, 0xb4,
-  0x03, 0x8b, 0x00, 0xb4, 0x03, 0x4e, 0x00, 0x12, 0x02, 0x20, 0x00, 0xb4,
-  0x0a, 0x3c, 0x00, 0xb4, 0x09, 0x5a, 0x00, 0xb4, 0x08, 0x4f, 0x00, 0x65,
-  0x06, 0x03, 0x00, 0xb4, 0x05, 0xa9, 0x00, 0xb4, 0x03, 0x49, 0x00, 0xad,
-  0x06, 0xb4, 0x00, 0xb4, 0x06, 0xa6, 0x00, 0xb4, 0x05, 0xbd, 0x00, 0xa7,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x02, 0x1f, 0xff, 0xff,
-  0x02, 0x00, 0xff, 0xe4, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
-  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0x90, 0x00, 0x9c, 0x04, 0x6e, 0x00, 0x65, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x07, 0x03, 0x00, 0x07, 0x07, 0x11, 0x00, 0x6e, 0x05, 0x94, 0x00, 0x67,
-  0x04, 0x92, 0x00, 0x65, 0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
-  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0xff, 0xec, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0xcb, 0x00, 0x90, 0x04, 0x28, 0x00, 0x4f, 0x02, 0x00, 0xff, 0xdf,
-  0x0a, 0x3c, 0x00, 0xb4, 0x09, 0x5a, 0x00, 0xb4, 0x08, 0x4f, 0x00, 0x65,
-  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x08, 0x03, 0x00, 0xb4,
-  0x04, 0xe9, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x07, 0x03, 0x00, 0x07,
-  0x07, 0x11, 0x00, 0x6e, 0x05, 0xaa, 0x00, 0x5b, 0x04, 0x67, 0x00, 0x40,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x02, 0x1f, 0xff, 0xb0,
-  0x02, 0x00, 0xff, 0xca, 0x02, 0x1f, 0x00, 0x04, 0x02, 0x00, 0xff, 0xe6,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0x00, 0x00, 0xb3, 0x02, 0xf5, 0x00, 0x75,
-  0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
-  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x65, 0xff, 0xfb,
-  0x02, 0xd2, 0x00, 0x31, 0x04, 0x83, 0x00, 0x8c, 0x03, 0xc1, 0x00, 0x3f,
-  0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0xff, 0xf2, 0x05, 0x4b, 0x00, 0xb4,
-  0x06, 0x08, 0x00, 0x65, 0x05, 0x07, 0x00, 0x65, 0x04, 0x65, 0x00, 0x65,
-  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x04, 0x65, 0xff, 0xfd,
-  0x04, 0x42, 0x00, 0x36, 0x03, 0x6a, 0x00, 0x7c, 0x06, 0x11, 0x00, 0xa7,
-  0x03, 0x6f, 0x00, 0x31, 0x02, 0x00, 0xff, 0xdf, 0x07, 0x2f, 0x00, 0x65,
-  0x07, 0x2f, 0x00, 0x65, 0x04, 0xec, 0xff, 0xfe, 0x05, 0x07, 0x00, 0x0a,
-  0x03, 0xf5, 0x00, 0x08, 0x04, 0x02, 0x00, 0x09, 0x04, 0x65, 0xff, 0xba,
-  0x03, 0xc0, 0x00, 0x63, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0x57, 0x00, 0x48,
-  0x03, 0x72, 0x00, 0x48, 0x04, 0xf0, 0x00, 0x09, 0x05, 0x45, 0x00, 0x0a,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x02, 0x1f, 0xff, 0xa1, 0x02, 0x00, 0xff, 0xdf, 0x05, 0xa0, 0x00, 0x67,
-  0x04, 0x92, 0x00, 0x65, 0x05, 0x00, 0x00, 0x09, 0x02, 0xf5, 0x00, 0x0c,
-  0x04, 0x65, 0xff, 0xf7, 0x04, 0x42, 0x00, 0x09, 0x04, 0x52, 0x00, 0x9c,
-  0x04, 0x92, 0x00, 0x65, 0x04, 0x92, 0x00, 0xa7, 0x04, 0x92, 0x00, 0xa7,
-  0x03, 0xf4, 0x00, 0x72, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
-  0x05, 0x03, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65,
-  0x05, 0xe6, 0x00, 0x6f, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xd4, 0x00, 0x77,
-  0x05, 0x95, 0x00, 0x77, 0x04, 0xc8, 0x00, 0x65, 0x02, 0x00, 0xff, 0xdf,
-  0x05, 0x02, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65, 0x04, 0x88, 0x00, 0x65,
-  0x04, 0x4a, 0x00, 0x56, 0x04, 0x4a, 0x00, 0x56, 0x04, 0x90, 0x00, 0x9c,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x02, 0x00, 0x00, 0x0c,
-  0x02, 0x6f, 0x00, 0x95, 0x02, 0xac, 0x00, 0x68, 0x02, 0xd9, 0x00, 0x43,
-  0x03, 0x82, 0x00, 0x45, 0x02, 0x01, 0x00, 0xad, 0x05, 0x15, 0x00, 0xad,
-  0x07, 0x03, 0x00, 0xa7, 0x07, 0x03, 0x00, 0xa7, 0x07, 0x03, 0x00, 0xa7,
-  0x04, 0xa6, 0xff, 0xdf, 0x04, 0x9f, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa1,
-  0x04, 0x67, 0x00, 0x65, 0x06, 0x2d, 0x00, 0x65, 0x05, 0x3d, 0x00, 0x85,
-  0x04, 0xbf, 0x00, 0x64, 0x02, 0xfb, 0x00, 0x00, 0x02, 0xfb, 0x00, 0x00,
-  0x02, 0xfa, 0x00, 0x00, 0x02, 0xf5, 0x00, 0xa7, 0x02, 0xf4, 0x00, 0xa7,
-  0x03, 0xd1, 0x00, 0x76, 0x03, 0xd1, 0x00, 0x68, 0x04, 0x58, 0x00, 0xa7,
-  0x04, 0x58, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63, 0x02, 0x6b, 0xff, 0xdd,
-  0x02, 0x6b, 0xff, 0xdd, 0x03, 0x52, 0x00, 0x31, 0x02, 0x6b, 0xff, 0x0d,
-  0x02, 0xd2, 0x00, 0x31, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x90, 0x00, 0x00,
-  0x04, 0x72, 0x00, 0x65, 0x04, 0x4e, 0x00, 0xad, 0x04, 0x42, 0x00, 0x36,
-  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0x00, 0x5b,
-  0x03, 0xc7, 0x00, 0x4f, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0x28, 0x00, 0x4f,
-  0x04, 0x28, 0x00, 0x62, 0x03, 0xac, 0x00, 0x4f, 0x03, 0xac, 0x00, 0x4f,
-  0x03, 0xac, 0x00, 0x4f, 0x03, 0xac, 0x00, 0x4f, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x2c, 0x00, 0xa7, 0x04, 0xc8, 0x00, 0x65, 0x05, 0x19, 0x00, 0x65,
-  0x04, 0xb5, 0x00, 0xa7, 0x02, 0x1a, 0xff, 0x0d, 0x04, 0xcd, 0x00, 0xa7,
-  0x03, 0xa6, 0x00, 0xa7, 0x05, 0x3c, 0x00, 0x65, 0x03, 0xac, 0x00, 0x4f,
-  0x03, 0xac, 0x00, 0x4f, 0x07, 0x4d, 0x00, 0x65, 0x07, 0x9d, 0x00, 0x65,
-  0x07, 0x4a, 0x00, 0x65, 0x05, 0xfa, 0x00, 0x31, 0x04, 0x64, 0x00, 0x31,
-  0x05, 0x9a, 0x00, 0x31, 0x06, 0x1b, 0x00, 0x2a, 0x05, 0x14, 0x00, 0xad,
-  0x04, 0xb6, 0x00, 0xad, 0x03, 0xb5, 0x00, 0x30, 0x03, 0xb5, 0x00, 0x30,
-  0x04, 0xc2, 0x00, 0x00, 0x04, 0xc7, 0x00, 0x00, 0x02, 0xe9, 0x00, 0x69,
-  0x02, 0xdf, 0x00, 0x69, 0x01, 0x42, 0xff, 0xec, 0x01, 0xdd, 0x00, 0x69,
-  0x02, 0x20, 0x00, 0x40, 0x02, 0x21, 0x00, 0x40, 0x02, 0xba, 0x00, 0x1c,
-  0x03, 0xb5, 0x00, 0x30, 0x02, 0xae, 0x00, 0x22, 0x02, 0x01, 0x00, 0x90,
-  0x03, 0x4f, 0x00, 0x90, 0x02, 0x49, 0x00, 0x9c, 0x02, 0x49, 0x00, 0xa0,
-  0x02, 0x49, 0x00, 0xb0, 0x02, 0x36, 0x00, 0x69, 0x02, 0x36, 0x00, 0x69,
-  0x02, 0xa9, 0x00, 0x69, 0x02, 0xa9, 0x00, 0x69, 0x03, 0x99, 0x00, 0xf0,
-  0x03, 0x99, 0x00, 0xf0, 0x03, 0x99, 0x00, 0xad, 0x03, 0x99, 0x00, 0xad,
-  0x03, 0x99, 0x00, 0xad, 0x03, 0x99, 0x00, 0xad, 0x01, 0xfa, 0x00, 0xc0,
-  0x03, 0x99, 0x00, 0xbf, 0x03, 0x99, 0x01, 0x4d, 0x03, 0x99, 0x00, 0x99,
-  0x01, 0xfa, 0x00, 0xc0, 0x03, 0x99, 0x00, 0xbf, 0x03, 0x99, 0x00, 0x99,
-  0x03, 0x99, 0x01, 0x4d, 0x02, 0x6d, 0x00, 0x63, 0x02, 0x6d, 0x00, 0x63,
-  0x02, 0x36, 0x00, 0x69, 0x02, 0x36, 0x00, 0x69, 0x03, 0x99, 0x01, 0x02,
-  0x03, 0x99, 0x01, 0x02, 0x02, 0xce, 0x00, 0x5a, 0x02, 0x49, 0x00, 0x5a,
-  0x03, 0x99, 0x00, 0xb3, 0x03, 0x99, 0x01, 0x71, 0x03, 0x99, 0x00, 0xd6,
-  0x03, 0x99, 0x01, 0x2a, 0x03, 0x99, 0x00, 0xa3, 0x03, 0x99, 0x00, 0xd8,
-  0x02, 0x45, 0x00, 0x00, 0x03, 0x99, 0x00, 0xd7, 0x03, 0x10, 0x00, 0x69,
-  0x01, 0x32, 0x00, 0x6d, 0x02, 0xaf, 0x00, 0x69, 0x03, 0x32, 0x00, 0x69,
-  0x02, 0xa9, 0x00, 0x69, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
-  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
-  0x03, 0x99, 0x00, 0xad, 0x03, 0x99, 0x00, 0xbf, 0x03, 0xba, 0x00, 0x9c,
-  0x03, 0x99, 0x00, 0xd6, 0x03, 0x99, 0x00, 0xa3, 0x00, 0x00, 0xfc, 0xfe,
-  0x00, 0x00, 0xfd, 0xb3, 0x00, 0x00, 0xfd, 0x15, 0x00, 0x00, 0xfd, 0x09,
-  0x00, 0x00, 0xfd, 0x2a, 0x00, 0x00, 0xfc, 0x55, 0x00, 0x00, 0xfd, 0x13,
-  0x00, 0x00, 0xfd, 0xdf, 0x00, 0x00, 0xfd, 0x28, 0x00, 0x00, 0xfd, 0x7f,
-  0x00, 0x00, 0xfd, 0x3b, 0x00, 0x00, 0xfd, 0x42, 0x00, 0x00, 0xfd, 0x18,
-  0x00, 0x00, 0xfd, 0xf6, 0x00, 0x00, 0xfd, 0x3f, 0x00, 0x00, 0xfc, 0xbb,
-  0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfe, 0x50,
-  0x00, 0x00, 0xfd, 0xcf, 0x00, 0x00, 0xfd, 0xcf, 0x00, 0x00, 0xff, 0x87,
-  0x00, 0x00, 0xfc, 0xfe, 0x00, 0x00, 0xfd, 0xb3, 0x00, 0x00, 0xfd, 0x6e,
-  0x00, 0x00, 0xfd, 0xfe, 0x00, 0x00, 0xfe, 0x80, 0x00, 0x00, 0xff, 0x0c,
-  0x00, 0x00, 0xfd, 0xc0, 0x00, 0x00, 0xfd, 0x57, 0x00, 0x00, 0xfd, 0x57,
-  0x00, 0x00, 0xfd, 0x6e, 0x00, 0x00, 0xfd, 0x57, 0x00, 0x00, 0xfd, 0xbb,
-  0x00, 0x00, 0xfd, 0xb8, 0x00, 0x00, 0xfd, 0xdf, 0x00, 0x00, 0xfd, 0x27,
-  0x00, 0x00, 0xfd, 0x71, 0x00, 0x00, 0xfd, 0xad, 0x00, 0x00, 0xfd, 0x6d,
-  0x00, 0x00, 0xfd, 0x92, 0x00, 0x00, 0xfd, 0xf6, 0x00, 0x00, 0xfd, 0x3f,
-  0x00, 0x00, 0xfc, 0xc0, 0x00, 0x00, 0xfd, 0x18, 0x00, 0x00, 0xfd, 0x13,
-  0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfd, 0x09,
-  0x00, 0x00, 0xfd, 0x2a, 0x00, 0x00, 0xfc, 0x55, 0x00, 0x00, 0xfc, 0x55,
-  0x00, 0x00, 0xfb, 0xfe, 0x00, 0x00, 0xfd, 0xb9, 0x00, 0x00, 0xfb, 0x6f,
-  0x00, 0x00, 0xfb, 0xde, 0x00, 0x00, 0xfa, 0xaa, 0x00, 0x00, 0xfd, 0xe8,
-  0x00, 0x00, 0xfd, 0x40, 0x00, 0x00, 0xfd, 0x6b, 0x00, 0x00, 0xfc, 0xc0,
-  0x00, 0x00, 0xfd, 0x74, 0x00, 0x00, 0xfe, 0x39, 0x00, 0x00, 0xfc, 0x55,
-  0x00, 0x00, 0xfc, 0xfe, 0x00, 0x00, 0xfd, 0xb3, 0x00, 0x00, 0xfd, 0x09,
-  0x00, 0x00, 0xfd, 0xcf, 0x00, 0x00, 0xfd, 0x37, 0x00, 0x00, 0xfd, 0xff,
-  0x00, 0x00, 0xfd, 0x27, 0x00, 0x00, 0xfd, 0x69, 0x00, 0x00, 0xfd, 0x60,
-  0x00, 0x00, 0xfd, 0x69, 0x00, 0x00, 0xfd, 0x0b, 0x00, 0x00, 0xfd, 0x0b,
-  0x00, 0x00, 0xfd, 0x0b, 0x00, 0x00, 0xfc, 0xc0, 0x00, 0x00, 0xfd, 0x7b,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfd, 0xb9, 0x00, 0x00, 0xfd, 0x13,
-  0x00, 0x00, 0xfd, 0x74, 0x00, 0x00, 0xfd, 0xb9, 0x00, 0x00, 0xff, 0x43,
-  0x00, 0x00, 0xfc, 0xe8, 0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfc, 0xcc,
-  0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfd, 0x73,
-  0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfc, 0xd2, 0x04, 0xb6, 0x00, 0xb4,
-  0x04, 0x16, 0x00, 0xad, 0x06, 0x34, 0x00, 0xb4, 0x04, 0xa9, 0x00, 0xb4,
-  0x02, 0x01, 0x00, 0x90, 0x02, 0x01, 0x00, 0x90, 0x05, 0x62, 0x00, 0xb4,
-  0x04, 0xad, 0x00, 0xa7, 0x03, 0x99, 0x01, 0x8a, 0x03, 0xf4, 0x00, 0x72,
-  0x03, 0xf5, 0x00, 0x65, 0x03, 0xf4, 0x00, 0x72, 0x02, 0x6d, 0x00, 0x8e,
-  0x03, 0x99, 0x01, 0x4d, 0x03, 0x99, 0x00, 0xc1, 0x04, 0xfc, 0x00, 0x0e,
-  0x02, 0x49, 0x00, 0xc5, 0x05, 0x5f, 0xff, 0xea, 0x06, 0x45, 0xff, 0xf5,
-  0x02, 0xf0, 0xff, 0xef, 0x05, 0xd9, 0xff, 0xf4, 0x05, 0xf0, 0xff, 0xe5,
-  0x05, 0xf1, 0xff, 0xdf, 0x02, 0x6f, 0x00, 0x04, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x02, 0x00, 0xb4, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0xee, 0x00, 0x52, 0x05, 0x6a, 0x00, 0xb4,
-  0x05, 0xaa, 0x00, 0x67, 0x02, 0x1f, 0x00, 0xb4, 0x04, 0xb8, 0x00, 0xb4,
-  0x04, 0xec, 0x00, 0x0e, 0x06, 0x36, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4,
-  0x04, 0x8c, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4,
-  0x04, 0x57, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x65, 0xff, 0xfb,
-  0x04, 0x65, 0xff, 0xfd, 0x05, 0xaa, 0x00, 0x67, 0x04, 0xee, 0x00, 0x36,
-  0x05, 0xaa, 0x00, 0x67, 0x05, 0x80, 0x00, 0x46, 0x02, 0x1f, 0x00, 0x05,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0xbf, 0x00, 0x65, 0x03, 0xe4, 0x00, 0x77,
-  0x04, 0x90, 0x00, 0xa7, 0x02, 0x6f, 0x00, 0x95, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0xbf, 0x00, 0x65, 0x04, 0x98, 0x00, 0xac, 0x04, 0x42, 0x00, 0x1c,
-  0x04, 0x67, 0x00, 0x65, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xea, 0x00, 0x60,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x02, 0x6f, 0x00, 0x95,
-  0x04, 0x3e, 0x00, 0xab, 0x04, 0x42, 0x00, 0x36, 0x04, 0x94, 0x00, 0x9c,
-  0x04, 0x05, 0x00, 0x42, 0x04, 0x03, 0x00, 0x60, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0x55, 0x00, 0x42, 0x04, 0x92, 0x00, 0xa7, 0x04, 0x39, 0x00, 0x65,
-  0x04, 0x90, 0x00, 0x65, 0x04, 0x55, 0x00, 0x5a, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0xbf, 0x00, 0x64, 0x04, 0x28, 0x00, 0x35, 0x04, 0xbf, 0x00, 0x64,
-  0x06, 0x07, 0x00, 0x79, 0x02, 0x6f, 0x00, 0x04, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0x67, 0x00, 0x65, 0x04, 0x2a, 0x00, 0x86, 0x06, 0x07, 0x00, 0x79,
-  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x6c, 0x00, 0x96, 0x04, 0x75, 0x00, 0x65,
-  0x05, 0x07, 0x00, 0x4e, 0x06, 0x10, 0xff, 0xe5, 0x05, 0x07, 0x00, 0x4e,
-  0x04, 0xbf, 0x00, 0x64, 0x06, 0x07, 0x00, 0x3a, 0x04, 0xc7, 0x00, 0x64,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x04, 0xab, 0x00, 0x7d,
-  0x04, 0x39, 0x00, 0x65, 0x04, 0x24, 0x00, 0xb4, 0x03, 0x4d, 0xff, 0x54,
-  0x04, 0xbf, 0x00, 0xa1, 0x04, 0xbf, 0x00, 0xab, 0x06, 0x3a, 0x00, 0x66,
-  0x04, 0x84, 0x00, 0x6b, 0x06, 0xb8, 0x00, 0x67, 0x06, 0x07, 0x00, 0x79,
-  0x05, 0x75, 0x00, 0x67, 0x04, 0xbf, 0x00, 0x65, 0x05, 0xb2, 0x00, 0xb4,
-  0x04, 0x6d, 0x00, 0x28, 0x04, 0xf1, 0x00, 0x47, 0x04, 0x5e, 0x00, 0x5a,
-  0x05, 0x86, 0x00, 0x67, 0x04, 0x80, 0x00, 0x30, 0x05, 0x08, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x04, 0x65, 0x00, 0x27, 0x03, 0xdc, 0x00, 0x31,
-  0x04, 0xc7, 0x00, 0x64, 0x04, 0x92, 0x00, 0xa7, 0x03, 0xf5, 0x00, 0x65,
-  0x02, 0x00, 0xff, 0xdf, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x6e, 0x00, 0x65,
-  0x04, 0x6e, 0x00, 0xb0, 0x04, 0x5b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7,
-  0x05, 0x07, 0x00, 0x67, 0x06, 0x36, 0x00, 0xb4, 0x04, 0xaf, 0x00, 0x72,
-  0x04, 0x92, 0x00, 0x4c, 0x05, 0x10, 0x00, 0x67, 0x05, 0x07, 0x00, 0x67,
-  0x05, 0x10, 0x00, 0x67, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4,
-  0x05, 0xa9, 0xff, 0xfb, 0x04, 0x64, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67,
-  0x04, 0x92, 0x00, 0x79, 0x02, 0x1f, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0x05,
-  0x02, 0x1f, 0xff, 0xa1, 0x07, 0xe0, 0x00, 0x4b, 0x07, 0x86, 0x00, 0xb4,
-  0x05, 0xa9, 0xff, 0xfb, 0x05, 0x1c, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4,
-  0x04, 0x63, 0x00, 0x1f, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0xf0, 0x00, 0xb4, 0x04, 0xf0, 0x00, 0xb4, 0x04, 0x64, 0x00, 0xb4,
-  0x05, 0xa0, 0x00, 0x5a, 0x04, 0x8c, 0x00, 0xb4, 0x07, 0xc1, 0x00, 0x24,
-  0x04, 0x9d, 0x00, 0x79, 0x05, 0x62, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4,
-  0x05, 0x1c, 0x00, 0xb4, 0x05, 0x6a, 0x00, 0x4b, 0x06, 0x36, 0x00, 0xb4,
-  0x05, 0x6a, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4,
-  0x04, 0x57, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67, 0x04, 0x65, 0xff, 0xfb,
-  0x04, 0x63, 0x00, 0x1f, 0x06, 0x32, 0x00, 0x6c, 0x04, 0xee, 0x00, 0x36,
-  0x05, 0x97, 0x00, 0xb4, 0x04, 0xef, 0x00, 0x9d, 0x07, 0xb3, 0x00, 0xb4,
-  0x07, 0xe0, 0x00, 0xb4, 0x05, 0xfe, 0x00, 0x36, 0x06, 0x5a, 0x00, 0xb4,
-  0x04, 0xf0, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x63, 0x07, 0xc5, 0x00, 0xbd,
-  0x05, 0x00, 0x00, 0x7a, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x70, 0x00, 0x64,
-  0x04, 0x3e, 0x00, 0xa7, 0x03, 0xc8, 0x00, 0xa7, 0x04, 0xfa, 0x00, 0x60,
-  0x04, 0x6e, 0x00, 0x65, 0x06, 0x7c, 0x00, 0x3f, 0x03, 0xd4, 0x00, 0x77,
-  0x04, 0xad, 0x00, 0xa7, 0x04, 0xad, 0x00, 0xa7, 0x04, 0x59, 0x00, 0xa7,
-  0x04, 0x9a, 0x00, 0x44, 0x05, 0x6e, 0x00, 0xa7, 0x04, 0xb5, 0x00, 0xa7,
-  0x04, 0x67, 0x00, 0x65, 0x04, 0xb5, 0x00, 0xa7, 0x04, 0x92, 0x00, 0xa7,
-  0x03, 0xf5, 0x00, 0x65, 0x04, 0x31, 0x00, 0x36, 0x04, 0x42, 0x00, 0x36,
-  0x06, 0x27, 0x00, 0x64, 0x04, 0x42, 0x00, 0x35, 0x04, 0xe6, 0x00, 0xa7,
-  0x04, 0x41, 0x00, 0x87, 0x06, 0x96, 0x00, 0xa7, 0x06, 0xc8, 0x00, 0xa7,
-  0x05, 0x16, 0x00, 0x37, 0x05, 0xaf, 0x00, 0xa7, 0x04, 0x3e, 0x00, 0xa7,
-  0x03, 0xf3, 0x00, 0x65, 0x06, 0x0f, 0x00, 0xad, 0x04, 0x54, 0x00, 0x68,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x80, 0x00, 0x2a,
-  0x03, 0xc8, 0x00, 0xa7, 0x03, 0xf3, 0x00, 0x65, 0x03, 0xc0, 0x00, 0x63,
-  0x02, 0x00, 0x00, 0xad, 0x02, 0x00, 0xff, 0xf6, 0x02, 0x00, 0xff, 0xdf,
-  0x06, 0x7f, 0x00, 0x44, 0x06, 0x78, 0x00, 0xa7, 0x04, 0xb1, 0x00, 0x2a,
-  0x04, 0x59, 0x00, 0xa7, 0x04, 0xad, 0x00, 0xa7, 0x04, 0x42, 0x00, 0x36,
-  0x04, 0xb5, 0x00, 0xa7, 0x06, 0xb8, 0x00, 0x67, 0x06, 0x07, 0x00, 0x79,
-  0x05, 0x8c, 0x00, 0x1b, 0x04, 0xd6, 0x00, 0x1b, 0x06, 0xc9, 0x00, 0xbd,
-  0x05, 0x64, 0x00, 0xad, 0x06, 0x54, 0x00, 0x0e, 0x05, 0xa3, 0x00, 0x2d,
-  0x08, 0x59, 0x00, 0xb4, 0x07, 0x35, 0x00, 0xad, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x60, 0x07, 0x64, 0x00, 0xb4, 0x05, 0xef, 0x00, 0xad,
-  0x04, 0x94, 0x00, 0x67, 0x03, 0xe4, 0x00, 0x51, 0x06, 0x2a, 0x00, 0x0e,
-  0x06, 0x4f, 0x00, 0x2d, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x05, 0xa0, 0x00, 0x0e, 0x04, 0xc9, 0x00, 0x2d, 0x05, 0xa0, 0x00, 0x0e,
-  0x04, 0xc9, 0x00, 0x2d, 0x07, 0x24, 0x00, 0x67, 0x06, 0x82, 0x00, 0x65,
-  0x06, 0xdc, 0x00, 0x67, 0x05, 0x75, 0x00, 0x65, 0x08, 0x7e, 0x00, 0x6a,
-  0x07, 0x66, 0x00, 0x88, 0x06, 0xb8, 0x00, 0x67, 0x06, 0x07, 0x00, 0x79,
-  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x03, 0x9e, 0x00, 0x35,
-  0x00, 0x00, 0xfc, 0x45, 0x00, 0x00, 0xfd, 0x54, 0x00, 0x00, 0xfd, 0xee,
-  0x00, 0x00, 0xfd, 0xee, 0x00, 0x00, 0xfa, 0x69, 0x03, 0x02, 0xf8, 0xa7,
-  0x03, 0x02, 0xf9, 0x1c, 0x05, 0x8f, 0x00, 0xb4, 0x04, 0xdf, 0x00, 0xad,
-  0x04, 0xf0, 0x00, 0x1d, 0x04, 0x3e, 0x00, 0x22, 0x04, 0x57, 0x00, 0xb4,
-  0x04, 0x92, 0x00, 0xa7, 0x04, 0x64, 0x00, 0xb4, 0x03, 0xc8, 0x00, 0xa7,
-  0x04, 0xdb, 0x00, 0x3f, 0x04, 0x40, 0x00, 0x32, 0x04, 0x7e, 0x00, 0xb4,
-  0x03, 0xd0, 0x00, 0xa7, 0x07, 0xc1, 0x00, 0x24, 0x06, 0x7c, 0x00, 0x3f,
-  0x04, 0x9d, 0x00, 0x79, 0x03, 0xd4, 0x00, 0x77, 0x05, 0x1c, 0x00, 0xb4,
-  0x04, 0x59, 0x00, 0xa7, 0x05, 0x1c, 0x00, 0xb4, 0x04, 0x59, 0x00, 0xa7,
-  0x05, 0x1c, 0x00, 0x1d, 0x04, 0x59, 0x00, 0x36, 0x06, 0x2a, 0x00, 0x2d,
-  0x05, 0xfc, 0x00, 0x25, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0xc1, 0x00, 0xad,
-  0x07, 0x4d, 0x00, 0xb4, 0x06, 0x50, 0x00, 0xad, 0x07, 0xc8, 0x00, 0xb4,
-  0x06, 0x97, 0x00, 0xad, 0x06, 0x52, 0x00, 0x67, 0x04, 0xfd, 0x00, 0x65,
-  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x65, 0xff, 0xfb,
-  0x04, 0x31, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x04, 0xee, 0x00, 0x36,
-  0x04, 0x42, 0x00, 0x35, 0x06, 0xb9, 0xff, 0xfb, 0x05, 0xce, 0x00, 0x04,
-  0x04, 0xef, 0x00, 0x9d, 0x04, 0x41, 0x00, 0x87, 0x04, 0xef, 0x00, 0x9d,
-  0x04, 0x41, 0x00, 0x87, 0x04, 0xef, 0x00, 0x9d, 0x04, 0x90, 0x00, 0xa7,
-  0x06, 0xc6, 0x00, 0x12, 0x05, 0x3d, 0x00, 0x0d, 0x06, 0xc6, 0x00, 0x12,
-  0x05, 0x3d, 0x00, 0x0d, 0x02, 0x1f, 0x00, 0xb4, 0x07, 0xc1, 0x00, 0x24,
-  0x06, 0x7c, 0x00, 0x3f, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x59, 0x00, 0xab,
-  0x05, 0x96, 0x00, 0x30, 0x04, 0xd3, 0x00, 0x29, 0x05, 0x6a, 0x00, 0xb4,
-  0x04, 0xc1, 0x00, 0xad, 0x05, 0x97, 0x00, 0xb4, 0x04, 0xe6, 0x00, 0xad,
-  0x04, 0xef, 0x00, 0x9d, 0x04, 0x41, 0x00, 0x87, 0x06, 0x64, 0x00, 0xb4,
-  0x05, 0x93, 0x00, 0xad, 0x02, 0x00, 0x00, 0xad, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x07, 0x03, 0x00, 0x07, 0x07, 0x11, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x69, 0x04, 0x6e, 0x00, 0x65,
-  0x05, 0xaa, 0x00, 0x69, 0x04, 0x6e, 0x00, 0x65, 0x07, 0xc1, 0x00, 0x24,
-  0x06, 0x7c, 0x00, 0x3f, 0x04, 0x9d, 0x00, 0x79, 0x03, 0xd4, 0x00, 0x77,
-  0x04, 0xcb, 0x00, 0x90, 0x04, 0x28, 0x00, 0x4f, 0x05, 0x62, 0x00, 0xb4,
-  0x04, 0xad, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4, 0x04, 0xad, 0x00, 0xa7,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x05, 0x07, 0x00, 0x63, 0x03, 0xf3, 0x00, 0x65, 0x04, 0x63, 0x00, 0x1f,
-  0x04, 0x42, 0x00, 0x36, 0x04, 0x63, 0x00, 0x1f, 0x04, 0x42, 0x00, 0x36,
-  0x04, 0x63, 0x00, 0x1f, 0x04, 0x42, 0x00, 0x36, 0x04, 0xef, 0x00, 0x9d,
-  0x04, 0x41, 0x00, 0x87, 0x04, 0x64, 0x00, 0xb4, 0x03, 0xc8, 0x00, 0xa7,
-  0x06, 0x5a, 0x00, 0xb4, 0x05, 0xaf, 0x00, 0xa7, 0x04, 0xdb, 0x00, 0x3f,
-  0x04, 0x40, 0x00, 0x32, 0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35,
-  0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35, 0x04, 0xf0, 0x00, 0x82,
-  0x04, 0x3e, 0x00, 0x65, 0x07, 0x3e, 0x00, 0x82, 0x06, 0x75, 0x00, 0x65,
-  0x07, 0x04, 0x00, 0xb4, 0x06, 0x42, 0x00, 0x99, 0x04, 0xe3, 0x00, 0xb4,
-  0x04, 0x3c, 0x00, 0x99, 0x07, 0xb7, 0x00, 0x30, 0x06, 0xe4, 0x00, 0x29,
-  0x08, 0x03, 0x00, 0xb4, 0x06, 0xf6, 0x00, 0xad, 0x05, 0x94, 0x00, 0x67,
-  0x04, 0xbf, 0x00, 0x65, 0x05, 0x90, 0xff, 0xfb, 0x05, 0x1e, 0x00, 0x04,
-  0x04, 0x6c, 0x00, 0x93, 0x03, 0xe4, 0x00, 0x77, 0x05, 0x6a, 0x00, 0x4b,
-  0x04, 0x9a, 0x00, 0x44, 0x08, 0x6a, 0x00, 0x4b, 0x07, 0x27, 0x00, 0x44,
-  0x06, 0x6f, 0x00, 0xb4, 0x06, 0x39, 0x00, 0xa7, 0x07, 0x6d, 0x00, 0x7a,
-  0x07, 0x19, 0x00, 0x68, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
-  0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d, 0x05, 0x1c, 0x00, 0xb4,
-  0x04, 0x59, 0x00, 0xa7, 0x07, 0xc7, 0x00, 0x4b, 0x06, 0x84, 0x00, 0x44,
-  0x07, 0xc8, 0x00, 0xb4, 0x06, 0x91, 0x00, 0xa7, 0x05, 0xb5, 0x00, 0xb4,
-  0x04, 0xea, 0x00, 0xa7, 0x04, 0x42, 0x00, 0x36, 0x05, 0x2a, 0x00, 0x09,
-  0x07, 0x11, 0x00, 0x6e, 0x04, 0x38, 0x00, 0x37, 0x03, 0xf5, 0x00, 0x65,
-  0x04, 0x5b, 0x00, 0xa7, 0x04, 0x5b, 0x00, 0x20, 0x03, 0x88, 0x00, 0xa7,
-  0x03, 0xe4, 0x00, 0x75, 0x02, 0x00, 0x00, 0xad, 0x02, 0xd7, 0x00, 0x00,
-  0x04, 0x2b, 0x00, 0xa7, 0x04, 0x32, 0x00, 0x01, 0x05, 0x6e, 0x00, 0xa7,
-  0x04, 0xad, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x03, 0xf5, 0x00, 0x72,
-  0x04, 0xec, 0x00, 0x65, 0x04, 0xec, 0x00, 0x65, 0x04, 0xec, 0x00, 0x2d,
-  0x07, 0x5d, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
-  0x03, 0xc6, 0x00, 0x87, 0x04, 0x54, 0x00, 0x2d, 0x04, 0x54, 0x00, 0x2d,
-  0x04, 0x31, 0x00, 0x36, 0x04, 0x22, 0x00, 0xa7, 0x05, 0x4e, 0x00, 0x9c,
-  0x06, 0xd2, 0x00, 0x9c, 0x04, 0x97, 0x00, 0x2a, 0x04, 0x42, 0x00, 0x36,
-  0x05, 0xe3, 0x00, 0x4d, 0x03, 0xc7, 0x00, 0x4f, 0x03, 0xc9, 0x00, 0x6c,
-  0x04, 0x32, 0x00, 0xa1, 0x04, 0x42, 0x00, 0x36, 0x04, 0x0f, 0x00, 0x87,
-  0x03, 0xc6, 0x00, 0x87, 0x04, 0x40, 0x00, 0x51, 0x04, 0x9a, 0x00, 0x44,
-  0x03, 0x19, 0x00, 0x09, 0x04, 0x6a, 0x00, 0x04, 0x03, 0x1c, 0x00, 0x72,
-  0x03, 0x7d, 0x00, 0x72, 0x02, 0xdd, 0x00, 0x72, 0x02, 0xdd, 0x00, 0x4a,
-  0x03, 0x83, 0x00, 0x40, 0x03, 0x69, 0x00, 0x72, 0x01, 0x56, 0x00, 0x72,
-  0x01, 0x56, 0xff, 0xc4, 0x02, 0xf9, 0x00, 0x72, 0x02, 0x86, 0x00, 0x72,
-  0x03, 0xe9, 0x00, 0x72, 0x03, 0x64, 0x00, 0x72, 0x03, 0x64, 0x00, 0x72,
-  0x03, 0x91, 0x00, 0x40, 0x03, 0x2a, 0x00, 0x3f, 0x02, 0xbc, 0x00, 0x72,
-  0x03, 0x26, 0x00, 0x72, 0x02, 0xc5, 0xff, 0xfd, 0x03, 0x51, 0x00, 0x64,
-  0x04, 0x7b, 0x00, 0x26, 0x02, 0xd1, 0x00, 0x45, 0x02, 0xd1, 0x00, 0x45,
-  0x02, 0xeb, 0x00, 0x3f, 0x04, 0xaa, 0x00, 0x45, 0x03, 0x15, 0x00, 0x69,
-  0x02, 0xeb, 0x00, 0x3f, 0x03, 0x00, 0x00, 0x3f, 0x03, 0x00, 0x00, 0x3f,
-  0x02, 0x98, 0x00, 0x4b, 0x02, 0x96, 0x00, 0x49, 0x02, 0xeb, 0x00, 0x3f,
-  0x01, 0x49, 0x00, 0x6d, 0x03, 0x10, 0x00, 0x69, 0x04, 0x7c, 0x00, 0x69,
-  0x02, 0xf1, 0x00, 0x69, 0x02, 0xfa, 0x00, 0x3f, 0x02, 0xaa, 0x00, 0x3f,
-  0x02, 0xfa, 0x00, 0x3f, 0x02, 0xfa, 0x00, 0x3f, 0x03, 0x15, 0x00, 0x69,
-  0x02, 0x1f, 0x00, 0x1f, 0x02, 0xea, 0x00, 0x63, 0x03, 0x61, 0x00, 0x63,
-  0x04, 0x7c, 0x00, 0x69, 0x03, 0x00, 0x00, 0x22, 0x02, 0xe4, 0x00, 0x6c,
-  0x02, 0xae, 0x00, 0x12, 0x02, 0xc6, 0x00, 0x3f, 0x02, 0xfd, 0x00, 0x3f,
-  0x02, 0x9e, 0x00, 0x21, 0x01, 0x49, 0x00, 0x6d, 0x01, 0xdd, 0x00, 0x69,
-  0x02, 0xea, 0x00, 0x63, 0x03, 0x00, 0x00, 0x22, 0x02, 0xe4, 0x00, 0x6c,
-  0x02, 0xae, 0x00, 0x12, 0x02, 0xf6, 0x00, 0x6c, 0x02, 0xfd, 0x00, 0x3f,
-  0x02, 0x9e, 0x00, 0x21, 0x04, 0x92, 0x00, 0xa7, 0x03, 0x69, 0x00, 0x72,
-  0x02, 0xac, 0x00, 0x68, 0x04, 0xcd, 0x00, 0x2d, 0x02, 0x00, 0x00, 0x82,
-  0x02, 0xeb, 0x00, 0x3f, 0x02, 0xaa, 0x00, 0x3f, 0x02, 0xaa, 0x00, 0x3f,
-  0x02, 0xfa, 0x00, 0x3f, 0x02, 0x98, 0x00, 0x4b, 0x02, 0x22, 0x00, 0x1b,
-  0x01, 0xad, 0xff, 0xec, 0x02, 0xeb, 0x00, 0x3f, 0x02, 0xea, 0x00, 0x63,
-  0x01, 0xe1, 0x00, 0x41, 0x01, 0xcb, 0x00, 0x6d, 0x01, 0xe0, 0x00, 0x41,
-  0x01, 0xe1, 0x00, 0x41, 0x01, 0xb0, 0xff, 0x67, 0x01, 0xcb, 0x00, 0x6d,
-  0x01, 0xb0, 0x00, 0x51, 0x02, 0xb5, 0x00, 0x65, 0x04, 0x7c, 0x00, 0x69,
-  0x04, 0x7c, 0x00, 0x69, 0x02, 0xf4, 0xff, 0xec, 0x03, 0x73, 0x00, 0x69,
-  0x02, 0xf1, 0x00, 0x65, 0x02, 0xfa, 0x00, 0x3f, 0x02, 0xfa, 0x00, 0x3f,
-  0x02, 0x98, 0x00, 0x3f, 0x02, 0x10, 0xff, 0xec, 0x02, 0x1f, 0x00, 0x1f,
-  0x03, 0xa8, 0x00, 0x54, 0x03, 0x03, 0x00, 0x3f, 0x02, 0x9a, 0x00, 0x69,
-  0x02, 0xec, 0x00, 0x6d, 0x03, 0x00, 0x00, 0x22, 0x02, 0xa3, 0x00, 0x31,
-  0x03, 0x24, 0x00, 0x31, 0x02, 0xa3, 0x00, 0x31, 0x02, 0xd2, 0x00, 0x31,
-  0x02, 0xfa, 0x00, 0x3f, 0x00, 0x00, 0xfc, 0xb9, 0x00, 0x00, 0xfc, 0xb9,
-  0x00, 0x00, 0xfc, 0xb9, 0x00, 0x00, 0xfc, 0xb9, 0x00, 0x00, 0xfc, 0xa2,
-  0x00, 0x00, 0xfc, 0xa2, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa5, 0x04, 0xf0, 0x00, 0xb4,
-  0x04, 0x92, 0x00, 0xa7, 0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7,
-  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4,
-  0x04, 0x92, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65,
-  0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4,
-  0x04, 0x92, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x24, 0x00, 0xb4, 0x02, 0x88, 0x00, 0x2a,
-  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x05, 0x6a, 0x00, 0xb4,
-  0x04, 0x90, 0x00, 0xa5, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0xff, 0xef, 0x05, 0x6a, 0x00, 0x0f,
-  0x04, 0x90, 0x00, 0x01, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x02, 0x1f, 0x00, 0x00, 0x02, 0x00, 0xff, 0xd8, 0x02, 0x1f, 0x00, 0x06,
-  0x02, 0x00, 0xff, 0xf6, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa7,
-  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa7, 0x04, 0xb8, 0x00, 0xb4,
-  0x04, 0x2b, 0x00, 0xa7, 0x04, 0x02, 0x00, 0xb4, 0x02, 0x12, 0x00, 0xb4,
-  0x04, 0x02, 0x00, 0x02, 0x02, 0x12, 0xff, 0xfe, 0x04, 0x02, 0x00, 0xb4,
-  0x02, 0x00, 0xff, 0xf6, 0x04, 0x02, 0x00, 0xb4, 0x02, 0x00, 0xff, 0xe2,
-  0x06, 0x36, 0x00, 0xb4, 0x07, 0x03, 0x00, 0xa7, 0x06, 0x36, 0x00, 0xb4,
-  0x07, 0x03, 0x00, 0xa7, 0x06, 0x36, 0x00, 0xb4, 0x07, 0x03, 0x00, 0xa7,
-  0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4,
-  0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x04, 0x57, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7,
-  0x04, 0x57, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4,
-  0x02, 0xf5, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7,
-  0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4,
-  0x02, 0xf5, 0x00, 0x4b, 0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63,
-  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79,
-  0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63,
-  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x65, 0xff, 0xfb,
-  0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31,
-  0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb,
-  0x02, 0xd2, 0x00, 0x31, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
-  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
-  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x42, 0x00, 0x36, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x42, 0x00, 0x36,
-  0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d, 0x07, 0x1e, 0x00, 0x3d,
-  0x05, 0xe3, 0x00, 0x4d, 0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d,
-  0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d, 0x07, 0x1e, 0x00, 0x3d,
-  0x05, 0xe3, 0x00, 0x4d, 0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35,
-  0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35, 0x04, 0x65, 0xff, 0xfd,
-  0x04, 0x42, 0x00, 0x36, 0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f,
-  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xee, 0x00, 0x52,
-  0x03, 0xc7, 0x00, 0x4f, 0x04, 0x90, 0x00, 0xa7, 0x02, 0xd2, 0x00, 0x03,
-  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x36, 0x04, 0x69, 0x00, 0x6e,
-  0x02, 0x88, 0x00, 0x2a, 0x02, 0x88, 0x00, 0x01, 0x02, 0x88, 0x00, 0x2a,
-  0x05, 0x88, 0x00, 0xa0, 0x04, 0x67, 0x00, 0x65, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
-  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
-  0x02, 0x1f, 0x00, 0x51, 0x02, 0x00, 0x00, 0x3d, 0x02, 0x1f, 0x00, 0xb4,
-  0x02, 0x00, 0x00, 0xab, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
-  0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a, 0x06, 0x93, 0x00, 0x5c,
-  0x04, 0x67, 0x00, 0x6a, 0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a,
-  0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a, 0x06, 0x93, 0x00, 0x5c,
-  0x04, 0x67, 0x00, 0x6a, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
-  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x06, 0x2d, 0x00, 0x9b,
-  0x04, 0x90, 0x00, 0x9e, 0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e,
-  0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e, 0x06, 0x2d, 0x00, 0x9b,
-  0x04, 0x90, 0x00, 0x9e, 0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd,
-  0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x05, 0x89, 0x00, 0xb4,
-  0x03, 0x6f, 0x00, 0x1c, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e, 0x06, 0x51, 0x00, 0x04,
-  0x06, 0x51, 0x00, 0x05, 0x05, 0x89, 0x00, 0x06, 0x05, 0xc4, 0x00, 0x04,
-  0x05, 0x19, 0x00, 0x06, 0x05, 0x58, 0x00, 0x03, 0x03, 0xe4, 0x00, 0x77,
-  0x03, 0xe4, 0x00, 0x77, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xe4, 0x00, 0x77,
-  0x03, 0xe4, 0x00, 0x77, 0x03, 0xe4, 0x00, 0x77, 0x05, 0x1e, 0x00, 0x06,
-  0x05, 0x1e, 0x00, 0x06, 0x06, 0xf4, 0x00, 0x04, 0x07, 0x04, 0x00, 0x05,
-  0x06, 0x78, 0x00, 0x06, 0x06, 0xae, 0x00, 0x04, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x06, 0x06, 0x00, 0x06, 0x06, 0x03, 0x00, 0x06,
-  0x07, 0xd1, 0x00, 0x04, 0x07, 0xd7, 0x00, 0x05, 0x07, 0x64, 0x00, 0x06,
-  0x07, 0x90, 0x00, 0x04, 0x06, 0xb8, 0x00, 0x06, 0x06, 0xd1, 0x00, 0x03,
-  0x02, 0x6f, 0x00, 0x8b, 0x02, 0x6f, 0x00, 0x82, 0x02, 0x6f, 0xff, 0xb9,
-  0x02, 0x6f, 0xff, 0xc2, 0x02, 0x6f, 0x00, 0x04, 0x02, 0x6f, 0xff, 0xd8,
-  0x02, 0x6f, 0xff, 0xd1, 0x02, 0x6f, 0xff, 0xcc, 0x02, 0xbc, 0x00, 0x06,
-  0x02, 0xb1, 0x00, 0x06, 0x04, 0x92, 0x00, 0x04, 0x04, 0x92, 0x00, 0x05,
-  0x04, 0x1b, 0x00, 0x06, 0x04, 0x51, 0x00, 0x04, 0x03, 0x85, 0x00, 0x06,
-  0x03, 0x8c, 0x00, 0x03, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0xca, 0x00, 0x06, 0x06, 0x1b, 0x00, 0x06,
-  0x07, 0xe1, 0x00, 0x04, 0x07, 0xea, 0x00, 0x05, 0x06, 0xc1, 0x00, 0x06,
-  0x06, 0xfc, 0x00, 0x04, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
-  0x05, 0xa4, 0x00, 0x06, 0x07, 0x2e, 0x00, 0x05, 0x07, 0x49, 0x00, 0x04,
-  0x06, 0x76, 0x00, 0x03, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
-  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
-  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
-  0x05, 0xc6, 0x00, 0x06, 0x06, 0x12, 0x00, 0x06, 0x07, 0xd7, 0x00, 0x04,
-  0x07, 0xe2, 0x00, 0x05, 0x06, 0xcf, 0x00, 0x06, 0x06, 0xff, 0x00, 0x04,
-  0x06, 0xa2, 0x00, 0x06, 0x06, 0xdb, 0x00, 0x03, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xbf, 0x00, 0x65, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xf2, 0x00, 0x77,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0xb6, 0x00, 0xa7, 0x02, 0x6f, 0xff, 0x99,
-  0x02, 0x6f, 0x00, 0x95, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x06, 0x07, 0x00, 0x79,
-  0x06, 0x07, 0x00, 0x79, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e, 0x06, 0x51, 0x00, 0x04,
-  0x06, 0x51, 0x00, 0x05, 0x05, 0x89, 0x00, 0x06, 0x05, 0xc4, 0x00, 0x04,
-  0x05, 0x19, 0x00, 0x06, 0x05, 0x58, 0x00, 0x03, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x06, 0x06, 0x00, 0x06, 0x06, 0x03, 0x00, 0x06,
-  0x07, 0xd1, 0x00, 0x04, 0x07, 0xd7, 0x00, 0x05, 0x07, 0x64, 0x00, 0x06,
-  0x07, 0x90, 0x00, 0x04, 0x06, 0xb8, 0x00, 0x06, 0x06, 0xd1, 0x00, 0x03,
-  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
-  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
-  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x05, 0xc6, 0x00, 0x06,
-  0x06, 0x12, 0x00, 0x06, 0x07, 0xd7, 0x00, 0x04, 0x07, 0xe2, 0x00, 0x05,
-  0x06, 0xcf, 0x00, 0x06, 0x06, 0xff, 0x00, 0x04, 0x06, 0xa2, 0x00, 0x06,
-  0x06, 0xdb, 0x00, 0x03, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
-  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xec, 0x00, 0x0e,
-  0x04, 0xec, 0x00, 0x0e, 0x05, 0x28, 0xff, 0xfd, 0x04, 0xfc, 0x00, 0x0e,
-  0x04, 0xec, 0x00, 0x0e, 0x03, 0x99, 0x01, 0x5f, 0x03, 0x99, 0x01, 0x8a,
-  0x03, 0x99, 0x01, 0x5f, 0x03, 0x99, 0x00, 0xa3, 0x03, 0x99, 0x00, 0xa3,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0xb6, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x05, 0xcb, 0xff, 0xfd,
-  0x05, 0x5f, 0xff, 0xea, 0x06, 0xb3, 0xff, 0xfd, 0x06, 0x45, 0xff, 0xf5,
-  0x05, 0x6a, 0x00, 0xb4, 0x03, 0x99, 0x00, 0x7b, 0x03, 0x99, 0x00, 0xa2,
-  0x03, 0x99, 0x00, 0xa3, 0x02, 0x6f, 0xff, 0xee, 0x02, 0x6f, 0xff, 0xe6,
-  0x02, 0x6f, 0xff, 0xdc, 0x02, 0x6f, 0x00, 0x04, 0x02, 0x6f, 0xff, 0xe7,
-  0x02, 0x6f, 0xff, 0xe9, 0x02, 0x1f, 0xff, 0xf7, 0x02, 0x1f, 0x00, 0x02,
-  0x03, 0x6b, 0xff, 0xfd, 0x02, 0xf0, 0xff, 0xef, 0x03, 0x99, 0x00, 0x71,
-  0x03, 0x99, 0x00, 0x86, 0x03, 0x99, 0x00, 0xa3, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0x92, 0x00, 0xa7, 0x04, 0x92, 0x00, 0xa7, 0x04, 0x2a, 0x00, 0x86,
-  0x04, 0x2a, 0x00, 0x86, 0x04, 0x65, 0xff, 0xfd, 0x04, 0x65, 0xff, 0xfd,
-  0x06, 0x15, 0xff, 0xfd, 0x05, 0xf0, 0xff, 0xe5, 0x04, 0xee, 0x00, 0x06,
-  0x03, 0x99, 0x00, 0x99, 0x03, 0x99, 0x00, 0xc1, 0x03, 0x99, 0x00, 0x99,
-  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
-  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0xc6, 0xff, 0xfd,
-  0x05, 0xd9, 0xff, 0xf4, 0x06, 0xa4, 0xff, 0xfd, 0x05, 0xf1, 0xff, 0xdf,
-  0x05, 0x80, 0x00, 0x46, 0x03, 0x99, 0x01, 0x4d, 0x03, 0x99, 0x01, 0x5f,
-  0x03, 0x99, 0x00, 0x00, 0x07, 0x33, 0x00, 0x00, 0x03, 0x99, 0x00, 0x00,
-  0x07, 0x33, 0x00, 0x00, 0x02, 0x5f, 0x00, 0x00, 0x01, 0xcc, 0x00, 0x00,
-  0x01, 0x33, 0x00, 0x00, 0x04, 0x94, 0x00, 0x00, 0x02, 0x49, 0x00, 0x00,
-  0x01, 0x70, 0x00, 0x00, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x02, 0x99, 0x00, 0x5a, 0x02, 0x99, 0x00, 0x5a,
-  0x04, 0x94, 0x00, 0x5a, 0x03, 0x99, 0x00, 0x5a, 0x07, 0x33, 0x00, 0x5a,
-  0x07, 0x33, 0x00, 0x00, 0x03, 0x99, 0x00, 0xea, 0x03, 0x99, 0xff, 0xee,
-  0x02, 0x49, 0x00, 0x9c, 0x02, 0x49, 0x00, 0xa0, 0x02, 0x49, 0x00, 0x9c,
-  0x02, 0x49, 0x00, 0xa0, 0x03, 0xba, 0x00, 0x9c, 0x03, 0xba, 0x00, 0x9c,
-  0x03, 0xba, 0x00, 0x9c, 0x03, 0xba, 0x00, 0x9c, 0x03, 0x99, 0x00, 0x33,
-  0x03, 0x99, 0x00, 0x33, 0x04, 0x3f, 0x01, 0x14, 0x04, 0x3f, 0x01, 0x14,
-  0x02, 0x68, 0x00, 0xd4, 0x04, 0xce, 0x00, 0xd4, 0x07, 0x33, 0x00, 0xd4,
-  0x02, 0x49, 0x00, 0xc6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x70, 0x00, 0x00,
-  0x09, 0xa9, 0x00, 0x65, 0x0c, 0x7e, 0x00, 0x65, 0x01, 0xa2, 0x00, 0x24,
-  0x02, 0xb0, 0x00, 0x24, 0x03, 0xbe, 0x00, 0x24, 0x01, 0xa2, 0x00, 0x24,
-  0x02, 0xb0, 0x00, 0x24, 0x03, 0xbe, 0x00, 0x24, 0x02, 0x70, 0x00, 0x09,
-  0x02, 0xe1, 0x00, 0x8e, 0x02, 0xe1, 0x00, 0xad, 0x06, 0x08, 0x00, 0xaf,
-  0x03, 0x7e, 0x00, 0x84, 0x03, 0xd2, 0x00, 0x84, 0x03, 0x99, 0xff, 0xee,
-  0x05, 0xc9, 0xff, 0xb0, 0x05, 0xc9, 0xff, 0xb0, 0x01, 0xcc, 0xff, 0xb3,
-  0x07, 0x33, 0x00, 0x36, 0x03, 0x99, 0x00, 0xc6, 0x01, 0x33, 0xfe, 0xaf,
-  0x02, 0xcf, 0x00, 0x9e, 0x02, 0xcf, 0x00, 0x9e, 0x06, 0xa3, 0x00, 0x42,
-  0x05, 0x46, 0x00, 0x84, 0x05, 0x46, 0x00, 0x84, 0x03, 0x94, 0x00, 0x5a,
-  0x04, 0x94, 0x00, 0xd4, 0x03, 0x99, 0x00, 0xc2, 0x03, 0x99, 0x00, 0xc2,
-  0x03, 0x99, 0x00, 0x36, 0x02, 0x6d, 0x01, 0x00, 0x05, 0xc9, 0xff, 0xb0,
-  0x03, 0x99, 0x00, 0x36, 0x03, 0x3c, 0x00, 0x82, 0x07, 0x33, 0x00, 0x5a,
-  0x05, 0xc9, 0xff, 0xb0, 0x06, 0x08, 0x01, 0x18, 0x04, 0x38, 0x00, 0xe1,
-  0x04, 0xc6, 0x00, 0x24, 0x06, 0x08, 0x01, 0x42, 0x06, 0x08, 0x01, 0x42,
-  0x02, 0x49, 0x00, 0xc5, 0x05, 0xbd, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x64,
-  0x02, 0x49, 0x00, 0xc5, 0x02, 0x49, 0x00, 0xc5, 0x01, 0x99, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xe2, 0x00, 0x4e,
-  0x01, 0x49, 0x00, 0x6d, 0x02, 0xe2, 0x00, 0x38, 0x02, 0xe2, 0x00, 0x5b,
-  0x02, 0xe2, 0x00, 0x52, 0x02, 0xe2, 0x00, 0x61, 0x02, 0xe2, 0x00, 0x50,
-  0x02, 0xe2, 0x00, 0x4a, 0x03, 0xcc, 0x00, 0x7b, 0x03, 0xcc, 0x00, 0x7b,
-  0x03, 0xcc, 0x00, 0x7b, 0x01, 0xc4, 0x00, 0x63, 0x01, 0xc4, 0x00, 0x5c,
-  0x02, 0xde, 0x00, 0x69, 0x02, 0xe2, 0x00, 0x4e, 0x02, 0xe2, 0x00, 0x7b,
-  0x02, 0xe2, 0x00, 0x54, 0x02, 0xe2, 0x00, 0x58, 0x02, 0xe2, 0x00, 0x38,
-  0x02, 0xe2, 0x00, 0x5b, 0x02, 0xe2, 0x00, 0x52, 0x02, 0xe2, 0x00, 0x61,
-  0x02, 0xe2, 0x00, 0x50, 0x02, 0xe2, 0x00, 0x4a, 0x03, 0xcc, 0x00, 0x7b,
-  0x03, 0xcc, 0x00, 0x7b, 0x03, 0xcc, 0x00, 0x7b, 0x01, 0xc4, 0x00, 0x63,
-  0x01, 0xc4, 0x00, 0x5c, 0x02, 0xd1, 0x00, 0x45, 0x03, 0x00, 0x00, 0x3f,
-  0x02, 0xfa, 0x00, 0x3f, 0x03, 0x32, 0x00, 0x69, 0x03, 0x00, 0x00, 0x3f,
-  0x02, 0xe9, 0x00, 0x69, 0x03, 0x10, 0x00, 0x69, 0x01, 0x32, 0x00, 0x6d,
-  0x04, 0x7c, 0x00, 0x69, 0x02, 0xde, 0x00, 0x69, 0x03, 0x15, 0x00, 0x69,
-  0x02, 0xaf, 0x00, 0x69, 0x02, 0x1f, 0x00, 0x1f, 0x06, 0x50, 0x00, 0x4d,
-  0x04, 0x94, 0x00, 0x67, 0x04, 0x94, 0x00, 0x56, 0x04, 0x94, 0x00, 0x77,
-  0x04, 0x94, 0x00, 0x74, 0x07, 0x03, 0x00, 0xa7, 0x05, 0x62, 0x00, 0x69,
-  0x09, 0x29, 0x00, 0xb4, 0x07, 0xbb, 0x00, 0xb4, 0x07, 0x1e, 0x00, 0x35,
-  0x05, 0xa5, 0x00, 0x55, 0x04, 0x94, 0x00, 0x65, 0x04, 0x94, 0x00, 0x00,
-  0x04, 0x94, 0x00, 0x24, 0x04, 0x94, 0x00, 0x12, 0x09, 0x29, 0x00, 0xbb,
-  0x04, 0x94, 0x00, 0x29, 0x04, 0x94, 0x00, 0x3d, 0x04, 0x94, 0x00, 0x53,
-  0x04, 0x94, 0x00, 0x0e, 0x05, 0x92, 0x00, 0x69, 0x04, 0x94, 0x00, 0x94,
-  0x04, 0x94, 0x00, 0x12, 0x04, 0x94, 0x00, 0x5f, 0x04, 0xe3, 0x00, 0x09,
-  0x00, 0x00, 0xfc, 0x77, 0x00, 0x00, 0xfc, 0x9e, 0x00, 0x00, 0xfc, 0x9e,
-  0x00, 0x00, 0xfc, 0x9e, 0x00, 0x00, 0xfc, 0x78, 0x00, 0x00, 0xfb, 0xc8,
-  0x00, 0x00, 0xfc, 0x9e, 0x07, 0x55, 0x00, 0x3c, 0x07, 0x55, 0x00, 0x3c,
-  0x05, 0x07, 0x00, 0x67, 0x08, 0x16, 0x00, 0xaf, 0x04, 0x9f, 0xff, 0xdb,
-  0x07, 0x55, 0x00, 0x36, 0x07, 0xae, 0x00, 0x36, 0x04, 0x6c, 0x00, 0x93,
-  0x05, 0x07, 0x00, 0x63, 0x06, 0xda, 0x00, 0xaf, 0x07, 0x1d, 0x00, 0x41,
-  0x05, 0x6e, 0x00, 0x01, 0x06, 0x1e, 0x00, 0xb4, 0x04, 0x90, 0x00, 0x40,
-  0x04, 0x90, 0x00, 0x51, 0x03, 0x61, 0x00, 0x35, 0x05, 0x05, 0x00, 0x5f,
-  0x05, 0x2f, 0x00, 0x3d, 0x02, 0xf9, 0xff, 0xe7, 0x05, 0xe3, 0x00, 0x1c,
-  0x05, 0xc4, 0x00, 0xb2, 0x07, 0x7d, 0x00, 0x30, 0x07, 0x33, 0x00, 0xfe,
-  0x05, 0x05, 0x00, 0x63, 0x05, 0x0c, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67,
-  0x05, 0xbe, 0x00, 0x3b, 0x05, 0xdc, 0x00, 0x4a, 0x05, 0xb3, 0x00, 0xb4,
-  0x06, 0x74, 0x00, 0x98, 0x04, 0xec, 0x00, 0xb4, 0x07, 0x57, 0x00, 0xe9,
-  0x07, 0xbc, 0xff, 0xfd, 0x07, 0x33, 0x01, 0x09, 0x04, 0xec, 0x00, 0x0e,
-  0x05, 0x5c, 0x00, 0x52, 0x04, 0x28, 0x00, 0x4f, 0x05, 0x80, 0x00, 0x46,
-  0x05, 0x80, 0x00, 0x46, 0x04, 0x6f, 0x00, 0x15, 0x02, 0x6f, 0x00, 0x3d,
-  0x04, 0xb8, 0x00, 0xb4, 0x04, 0xec, 0x00, 0x0e, 0x05, 0xa9, 0x00, 0x52,
-  0x05, 0x10, 0x00, 0x75, 0x06, 0x27, 0x00, 0x70, 0x04, 0x42, 0x00, 0x4e,
-  0x04, 0x5c, 0x00, 0x91, 0x05, 0xa9, 0x00, 0x4b, 0x04, 0x24, 0x00, 0xb4,
-  0x07, 0xb3, 0x00, 0x33, 0x03, 0x53, 0x00, 0x5d, 0x05, 0x5d, 0x00, 0x5c,
-  0x04, 0xda, 0xff, 0xfc, 0x03, 0x5a, 0x00, 0x18, 0x04, 0xa4, 0x00, 0x4d,
-  0x02, 0xbc, 0x00, 0x3f, 0x06, 0xaa, 0x00, 0x51, 0x08, 0x98, 0x00, 0x87,
-  0x05, 0x0e, 0x00, 0x20, 0x05, 0x3d, 0x00, 0x00, 0x04, 0xb6, 0x00, 0xb4,
-  0x06, 0x1c, 0x00, 0xb4, 0x05, 0xd6, 0x00, 0x16, 0x05, 0x94, 0x00, 0x92,
-  0x04, 0x02, 0x00, 0x07, 0x04, 0x02, 0x00, 0x06, 0x04, 0x65, 0xff, 0xfd,
-  0x05, 0xe5, 0x00, 0x4e, 0x05, 0x19, 0x00, 0x51, 0x04, 0x6e, 0x00, 0x51,
-  0x02, 0x87, 0x00, 0x47, 0x02, 0x87, 0xff, 0x2e, 0x05, 0x9d, 0x00, 0x35,
-  0x03, 0xca, 0x00, 0x48, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x7b,
-  0x09, 0xdd, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x54,
-  0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x54, 0x06, 0xfa, 0x00, 0x58,
-  0x06, 0xfa, 0x00, 0x38, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x5b,
-  0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x58, 0x06, 0xfa, 0x00, 0x5b,
-  0x06, 0xfa, 0x00, 0x61, 0x04, 0x16, 0x00, 0x7b, 0x02, 0x1f, 0x00, 0xb4,
-  0x03, 0x8b, 0x00, 0xb4, 0x04, 0xf6, 0x00, 0xb4, 0x06, 0xa5, 0x00, 0xb4,
-  0x04, 0xec, 0x00, 0x0e, 0x06, 0xa4, 0x00, 0x0e, 0x08, 0x0f, 0x00, 0x0e,
-  0x09, 0x7b, 0x00, 0x0e, 0x06, 0x9b, 0x00, 0xb4, 0x04, 0xee, 0x00, 0x36,
-  0x06, 0xb7, 0x00, 0x36, 0x08, 0x25, 0x00, 0x36, 0x04, 0x02, 0x00, 0xb4,
-  0x05, 0x07, 0x00, 0x67, 0x05, 0x8b, 0x00, 0xb4, 0x06, 0x36, 0x00, 0xb4,
-  0x02, 0x00, 0x00, 0xad, 0x03, 0x4b, 0x00, 0xad, 0x04, 0x96, 0x00, 0xad,
-  0x05, 0xd7, 0x00, 0xad, 0x04, 0x42, 0x00, 0x36, 0x05, 0xd6, 0x00, 0x36,
-  0x07, 0x22, 0x00, 0x36, 0x08, 0x6d, 0x00, 0x36, 0x05, 0xe5, 0x00, 0xad,
-  0x04, 0x42, 0x00, 0x35, 0x05, 0xeb, 0x00, 0x35, 0x07, 0x36, 0x00, 0x35,
-  0x02, 0x00, 0x00, 0xad, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
-  0x07, 0x03, 0x00, 0xa7, 0x08, 0xf7, 0x00, 0x6c, 0x05, 0x8b, 0x00, 0xb4,
-  0x08, 0xf7, 0x00, 0x6c, 0x05, 0x10, 0x00, 0x67, 0x03, 0xf4, 0x00, 0x72,
-  0x05, 0x07, 0x00, 0x67, 0x06, 0xfa, 0x00, 0x4e, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x79,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x01, 0x03,
-  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x01, 0x03,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x27,
-  0x06, 0x08, 0x00, 0x13, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x01, 0x7a,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x6a, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x00, 0x6a, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x01, 0x0c, 0x06, 0x08, 0x01, 0x37, 0x06, 0x08, 0x01, 0x81,
-  0x06, 0x08, 0x01, 0x37, 0x06, 0x08, 0x01, 0x81, 0x06, 0x08, 0x01, 0xad,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x28, 0x06, 0x08, 0x00, 0x47,
-  0x06, 0x08, 0x00, 0xc7, 0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0xbd,
-  0x06, 0x08, 0x00, 0x8d, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x02, 0xb7, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x02, 0xb7, 0x06, 0x08, 0x01, 0x79,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x6b, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x6c, 0x06, 0x08, 0x00, 0x6a,
-  0x06, 0x08, 0x00, 0x6c, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a,
-  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0xa9, 0x06, 0x08, 0x00, 0xa9,
-  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x79,
-  0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x79,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x60,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x01, 0x3b,
-  0x06, 0x08, 0x00, 0x40, 0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x3b,
-  0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x20, 0x06, 0x08, 0x01, 0x3b,
-  0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x6d, 0x06, 0x08, 0x00, 0x6d, 0x06, 0x08, 0x01, 0x3b,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x6b, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x5a,
-  0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x31,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0x94, 0x00, 0x79, 0x03, 0xb9, 0x00, 0x55,
-  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x06, 0x45, 0x00, 0x8b,
-  0x04, 0xd1, 0xff, 0xfb, 0x04, 0xd1, 0xff, 0xfb, 0x06, 0x45, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x04, 0x94, 0x01, 0x0e,
-  0x05, 0x73, 0x00, 0x8c, 0x05, 0x73, 0x00, 0x8c, 0x04, 0xda, 0x00, 0x16,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x02, 0x6d, 0x00, 0x00, 0x04, 0x95, 0x01, 0x62, 0x06, 0x08, 0x00, 0xeb,
-  0x04, 0x81, 0x01, 0x23, 0x04, 0x81, 0x01, 0x35, 0x04, 0x96, 0x00, 0x36,
-  0x04, 0x96, 0x00, 0x36, 0x04, 0x96, 0x00, 0x36, 0x05, 0x24, 0x00, 0xc6,
-  0x05, 0xff, 0x00, 0xc6, 0x06, 0x08, 0x00, 0xfe, 0x06, 0x74, 0x00, 0x9d,
-  0x06, 0x74, 0x00, 0x9d, 0x06, 0x08, 0x00, 0xd5, 0x03, 0x99, 0x01, 0x84,
-  0x03, 0x99, 0x00, 0x5b, 0x03, 0x99, 0x00, 0xf4, 0x03, 0x99, 0x00, 0x5b,
-  0x05, 0x45, 0x00, 0xed, 0x05, 0x45, 0x00, 0xed, 0x05, 0x45, 0x00, 0xed,
-  0x05, 0x45, 0x00, 0xed, 0x03, 0xc0, 0x00, 0x69, 0x05, 0xae, 0x00, 0x69,
-  0x07, 0x9c, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x05, 0xae, 0x00, 0x69,
-  0x07, 0x9c, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
-  0x03, 0xc0, 0x00, 0x69, 0x04, 0x94, 0x00, 0x6c, 0x04, 0x94, 0x00, 0x6c,
-  0x01, 0xdf, 0x00, 0x90, 0x04, 0x94, 0x00, 0x6c, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc2, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0x91,
-  0x06, 0x08, 0x00, 0xc3, 0x02, 0xb3, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc2,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x0a, 0x00, 0xc3, 0x06, 0x0a, 0x00, 0xc3,
-  0x07, 0x33, 0x00, 0xba, 0x07, 0x33, 0x00, 0xb8, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc4,
-  0x06, 0x08, 0x00, 0xc4, 0x07, 0x89, 0x00, 0x85, 0x07, 0x89, 0x00, 0x85,
-  0x03, 0x57, 0x00, 0x9e, 0x06, 0x08, 0x00, 0xc2, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xbb,
-  0x06, 0x08, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xb7, 0x06, 0x08, 0x00, 0xb7,
-  0x06, 0x08, 0x00, 0xb7, 0x06, 0x08, 0x00, 0xb7, 0x06, 0x08, 0x00, 0xab,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xab, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xab, 0x06, 0x08, 0x00, 0xab, 0x05, 0x45, 0x00, 0xed,
-  0x05, 0x45, 0x00, 0xed, 0x05, 0x45, 0x00, 0xed, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x05, 0x9e, 0x00, 0xc3, 0x05, 0x9e, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xa8,
-  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
-  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
-  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
-  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
-  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x03, 0xbf, 0x00, 0x9d, 0x03, 0xbf, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0x6c,
-  0x07, 0x33, 0x00, 0x6c, 0x06, 0x08, 0x00, 0x58, 0x06, 0x08, 0x00, 0x6c,
-  0x03, 0xbf, 0x00, 0xd6, 0x05, 0x45, 0x00, 0xb4, 0x05, 0x45, 0x00, 0xb4,
-  0x05, 0x45, 0x00, 0xb4, 0x06, 0x08, 0x00, 0xfe, 0x06, 0x08, 0x00, 0xfe,
-  0x05, 0xe8, 0xff, 0xfb, 0x05, 0xe8, 0xff, 0xfb, 0x05, 0xe8, 0x00, 0x7e,
-  0x05, 0xe8, 0x00, 0x7e, 0x03, 0x8e, 0x00, 0x05, 0x02, 0x49, 0x00, 0xc5,
-  0x04, 0x81, 0x00, 0xe0, 0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
-  0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
-  0x07, 0x33, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x05, 0x46, 0x00, 0x59,
-  0x05, 0x46, 0x00, 0x59, 0x06, 0x08, 0x00, 0xab, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xbd, 0x06, 0x08, 0x00, 0xbd, 0x06, 0x08, 0x01, 0x56,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x0a, 0x3d, 0x00, 0x85, 0x0a, 0x3d, 0x00, 0x85, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xca,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xbf, 0x07, 0x33, 0x03, 0x3a, 0x07, 0x33, 0x00, 0xd4,
-  0x07, 0x33, 0x00, 0xd4, 0x07, 0x33, 0x00, 0xd4, 0x07, 0x33, 0x00, 0x4f,
-  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d,
-  0x06, 0x45, 0x00, 0x9d, 0x07, 0x33, 0x00, 0x4f, 0x06, 0x45, 0x00, 0x9d,
-  0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3,
-  0x06, 0x45, 0x00, 0xc3, 0x04, 0x55, 0x00, 0x42, 0x04, 0x55, 0x00, 0x66,
-  0x04, 0x92, 0x00, 0x83, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x01, 0x79,
-  0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x01, 0x79, 0x03, 0x84, 0x01, 0x1b,
-  0x02, 0xcf, 0x00, 0x9e, 0x02, 0xcf, 0x00, 0xb3, 0x02, 0xcf, 0x00, 0x9e,
-  0x02, 0xcf, 0x00, 0xb3, 0x05, 0xd2, 0x02, 0xa8, 0x05, 0xd2, 0x00, 0x5a,
-  0x05, 0xd2, 0x02, 0xa8, 0x05, 0xd2, 0x00, 0x5a, 0x06, 0x08, 0x00, 0xc3,
-  0x03, 0xb1, 0x00, 0x05, 0x07, 0x33, 0x00, 0xde, 0x06, 0x08, 0x00, 0xc3,
-  0x03, 0x60, 0x00, 0x9e, 0x03, 0x60, 0x00, 0x78, 0x03, 0x60, 0x00, 0x9e,
-  0x03, 0x60, 0x00, 0x78, 0x03, 0xc0, 0x01, 0x83, 0x03, 0xc0, 0x00, 0x25,
-  0x08, 0x4c, 0x00, 0x8c, 0x08, 0x4c, 0x00, 0x8c, 0x0a, 0x2e, 0x00, 0x8c,
-  0x08, 0x4c, 0x00, 0x8c, 0x0a, 0x64, 0x00, 0x6c, 0x0a, 0x2e, 0x00, 0x00,
-  0x06, 0x49, 0x00, 0x87, 0x02, 0x6f, 0x00, 0x95, 0x04, 0x92, 0x00, 0xa7,
-  0x06, 0x07, 0x00, 0x79, 0x04, 0xbf, 0x00, 0x65, 0x05, 0x73, 0x00, 0x17,
-  0x08, 0x4c, 0x00, 0x8c, 0x06, 0x49, 0x00, 0x1f, 0x03, 0x99, 0x00, 0x9e,
-  0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e,
-  0x03, 0x99, 0x02, 0x4b, 0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e,
-  0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e,
-  0x03, 0x99, 0x02, 0x4b, 0x03, 0x99, 0x00, 0x9e, 0x05, 0x66, 0x02, 0x5f,
-  0x05, 0x66, 0x00, 0x97, 0x05, 0x66, 0x02, 0x5f, 0x05, 0x66, 0x02, 0x5f,
-  0x05, 0x66, 0x00, 0x97, 0x05, 0x66, 0x02, 0x5f, 0x05, 0x66, 0x00, 0x97,
-  0x03, 0xc0, 0x01, 0x83, 0x06, 0x08, 0x00, 0x31, 0x06, 0xcd, 0x00, 0xa7,
-  0x06, 0x49, 0x00, 0x87, 0x05, 0x89, 0x00, 0x05, 0x04, 0x94, 0x00, 0x50,
-  0x04, 0x92, 0xff, 0x8f, 0x04, 0x92, 0x00, 0x83, 0x06, 0x74, 0x00, 0x88,
-  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
-  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
-  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2,
-  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a,
-  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a,
-  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2,
-  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0xe2,
-  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a,
-  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x52,
-  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x52,
-  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x52,
-  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0xff, 0x9e,
-  0x04, 0x55, 0xff, 0x9e, 0x04, 0x55, 0xff, 0x9e, 0x04, 0x55, 0xff, 0xee,
-  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x02, 0x3c, 0x04, 0x55, 0x01, 0xe2,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x02, 0x3c,
-  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0x9a,
-  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0x9a, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0x02, 0xc4, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0x04, 0xe5,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0x02, 0xc4, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0x02, 0xc4, 0x05, 0x89, 0xff, 0xee,
-  0x05, 0x89, 0xff, 0xee, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x04, 0xe1, 0x00, 0xa7,
-  0x04, 0xe1, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
-  0x03, 0xf6, 0x00, 0xa7, 0x03, 0xf6, 0x00, 0xa7, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
-  0x03, 0x9d, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05,
-  0x03, 0x9d, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
-  0x06, 0x48, 0x00, 0x64, 0x03, 0x8e, 0x00, 0x05, 0x06, 0x48, 0x00, 0x64,
-  0x06, 0x48, 0x00, 0x66, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
-  0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
-  0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
-  0x06, 0x48, 0x00, 0x64, 0x03, 0xcb, 0x00, 0x64, 0x03, 0xcb, 0x00, 0xa7,
-  0x05, 0xb2, 0x00, 0xa7, 0x06, 0xfc, 0x00, 0xa7, 0x06, 0xfc, 0x00, 0xa7,
-  0x06, 0xfc, 0x00, 0xa7, 0x02, 0xc9, 0x00, 0x05, 0x02, 0xc9, 0x00, 0x05,
-  0x02, 0xc9, 0x00, 0x05, 0x02, 0xc9, 0x00, 0x05, 0x06, 0x48, 0x00, 0x64,
-  0x06, 0x48, 0x00, 0x64, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x04, 0x3f, 0x01, 0x14,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x08, 0x0e, 0x00, 0x64,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
-  0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0xfa, 0x00, 0xa7,
-  0x05, 0xfa, 0x00, 0xa7, 0x05, 0x46, 0x00, 0xa7, 0x05, 0x46, 0x00, 0xa7,
-  0x05, 0x89, 0x00, 0x05, 0x06, 0x74, 0x00, 0x99, 0x07, 0x33, 0x00, 0x5d,
-  0x06, 0x74, 0x00, 0x5a, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x75,
-  0x06, 0x74, 0x00, 0x77, 0x06, 0x74, 0x00, 0x77, 0x04, 0x1f, 0x00, 0x99,
-  0x06, 0x73, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x65, 0x00, 0x70,
-  0x06, 0x65, 0x00, 0x70, 0x04, 0xd5, 0x00, 0x70, 0x07, 0x4a, 0x00, 0x70,
-  0x08, 0xf7, 0x00, 0x7e, 0x09, 0x00, 0x00, 0x82, 0x06, 0x74, 0x00, 0xa5,
-  0x06, 0x74, 0x00, 0xa4, 0x06, 0x74, 0x00, 0xa4, 0x03, 0xd5, 0x00, 0x8a,
-  0x06, 0x74, 0x00, 0x5a, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x9a,
-  0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x8f, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0xa0,
-  0x04, 0x62, 0x00, 0x84, 0x06, 0x74, 0x00, 0x9f, 0x04, 0x62, 0x00, 0x84,
-  0x06, 0x74, 0x00, 0x70, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x5a, 0x04, 0xd1, 0x00, 0x5a, 0x05, 0x5f, 0x00, 0x99,
-  0x04, 0xad, 0x00, 0x99, 0x05, 0xa4, 0x00, 0x99, 0x03, 0xec, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0xa0, 0x06, 0x74, 0x00, 0x99,
-  0x05, 0x1d, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x79, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x02, 0x93,
-  0x06, 0x74, 0x00, 0x99, 0x04, 0x6b, 0x00, 0x9d, 0x05, 0x46, 0x00, 0x9d,
-  0x05, 0x46, 0x00, 0x9d, 0x06, 0x74, 0x00, 0x91, 0x06, 0x74, 0x01, 0x31,
-  0x06, 0x74, 0x01, 0x93, 0x06, 0x74, 0x00, 0xdf, 0x06, 0x74, 0x00, 0xea,
-  0x06, 0x74, 0x01, 0xba, 0x06, 0x74, 0x00, 0x53, 0x06, 0x74, 0x00, 0xa4,
-  0x06, 0x74, 0x00, 0xac, 0x06, 0x74, 0x00, 0xcf, 0x06, 0x74, 0x01, 0x01,
-  0x06, 0x74, 0x00, 0x62, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x3e,
-  0x06, 0x74, 0x00, 0x98, 0x06, 0x74, 0x00, 0xac, 0x06, 0x74, 0x00, 0x9e,
-  0x06, 0x74, 0x01, 0x20, 0x06, 0x74, 0x00, 0xb4, 0x06, 0x74, 0x00, 0xcb,
-  0x06, 0x74, 0x01, 0x32, 0x06, 0x74, 0x01, 0x8a, 0x06, 0x74, 0x01, 0x2f,
-  0x06, 0x74, 0x01, 0x11, 0x06, 0x74, 0x00, 0xb4, 0x06, 0x74, 0x00, 0xcb,
-  0x06, 0x74, 0x01, 0x32, 0x06, 0x74, 0x01, 0x8a, 0x06, 0x74, 0x01, 0x2a,
-  0x06, 0x74, 0x01, 0x11, 0x06, 0x74, 0x01, 0x22, 0x06, 0x74, 0x00, 0xa6,
-  0x06, 0x74, 0x01, 0x35, 0x06, 0x74, 0x00, 0xcd, 0x06, 0x74, 0x01, 0x21,
-  0x06, 0x74, 0x00, 0xa3, 0x06, 0x74, 0x01, 0x35, 0x06, 0x74, 0x00, 0xcd,
-  0x06, 0x74, 0x00, 0xc2, 0x03, 0x65, 0x00, 0x9a, 0x04, 0x98, 0x00, 0x9a,
-  0x06, 0x74, 0x01, 0x52, 0x06, 0x74, 0x00, 0xa9, 0x03, 0x65, 0x00, 0xa2,
-  0x02, 0x92, 0x00, 0x9a, 0x03, 0x7b, 0x00, 0x9b, 0x05, 0x62, 0x00, 0x9a,
-  0x05, 0x83, 0x00, 0x76, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x8c,
-  0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c,
-  0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c,
-  0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x01, 0x12,
-  0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87,
-  0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x01, 0x35, 0x06, 0x74, 0x01, 0x35,
-  0x06, 0x74, 0x00, 0x5f, 0x06, 0x74, 0x00, 0xb2, 0x06, 0x74, 0x00, 0xf2,
-  0x03, 0xe5, 0x00, 0x70, 0x06, 0x74, 0x00, 0x6c, 0x06, 0x74, 0x00, 0x70,
-  0x06, 0x74, 0x01, 0x0b, 0x06, 0x74, 0x00, 0xae, 0x06, 0x74, 0x00, 0xeb,
-  0x06, 0x74, 0x00, 0xea, 0x06, 0x74, 0x00, 0xea, 0x06, 0x74, 0x00, 0x5a,
-  0x05, 0x0e, 0x00, 0x99, 0x07, 0x3b, 0x00, 0x9d, 0x07, 0xd7, 0x00, 0x91,
-  0x08, 0x75, 0x00, 0x9d, 0x06, 0x80, 0x00, 0x9d, 0x06, 0x08, 0x00, 0xf2,
-  0x06, 0x08, 0x00, 0xba, 0x06, 0x08, 0x01, 0x59, 0x06, 0x08, 0x00, 0x08,
-  0x06, 0x08, 0x01, 0x58, 0x06, 0x08, 0x01, 0x58, 0x06, 0x08, 0x01, 0xc7,
-  0x06, 0x08, 0x01, 0x40, 0x06, 0x08, 0x00, 0x4b, 0x06, 0x08, 0x00, 0x09,
-  0x06, 0x13, 0x00, 0xbd, 0x06, 0x08, 0x01, 0x85, 0x05, 0x46, 0x00, 0x9d,
-  0x05, 0x46, 0x01, 0x36, 0x05, 0x46, 0x00, 0x9e, 0x05, 0x46, 0x00, 0x9e,
-  0x06, 0x1e, 0x00, 0x6c, 0x05, 0x46, 0x01, 0x66, 0x05, 0x46, 0x01, 0x23,
-  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4d,
-  0x06, 0x08, 0x00, 0x4d, 0x05, 0x46, 0x00, 0x9d, 0x06, 0x08, 0x00, 0x13,
-  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x13, 0x06, 0x08, 0x00, 0x41,
-  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x6c,
-  0x06, 0x08, 0x00, 0x76, 0x06, 0x08, 0x01, 0x87, 0x06, 0x08, 0x00, 0x26,
-  0x06, 0x08, 0x00, 0xa3, 0x06, 0x08, 0x00, 0x2f, 0x06, 0x08, 0x00, 0xa3,
-  0x06, 0x08, 0x00, 0x4f, 0x06, 0x08, 0x00, 0x7c, 0x06, 0x08, 0x01, 0x14,
-  0x06, 0x08, 0x00, 0xd5, 0x06, 0x08, 0x00, 0xe9, 0x06, 0x08, 0x00, 0x9d,
-  0x06, 0x08, 0x00, 0xd8, 0x06, 0x08, 0x00, 0xe2, 0x06, 0x08, 0x00, 0x64,
-  0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x64,
-  0x06, 0x08, 0x01, 0x30, 0x06, 0x08, 0x00, 0xf1, 0x06, 0x08, 0x01, 0x1e,
-  0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0x4b,
-  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4a, 0x06, 0x08, 0x00, 0x4b,
-  0x06, 0x08, 0x00, 0x4e, 0x06, 0x08, 0x00, 0x4e, 0x06, 0x08, 0x00, 0x2a,
-  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x2b, 0x06, 0x08, 0x00, 0x2a,
-  0x06, 0x08, 0x00, 0x2b, 0x06, 0x08, 0x00, 0x2b, 0x06, 0x08, 0x00, 0x2b,
-  0x06, 0x08, 0x00, 0x2d, 0x06, 0x08, 0x00, 0x76, 0x06, 0x08, 0x00, 0x88,
-  0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x39, 0x06, 0x08, 0x00, 0x4b,
-  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0x4b, 0x06, 0x08, 0x00, 0x4b,
-  0x06, 0x08, 0x00, 0x4b, 0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x96,
-  0x06, 0x08, 0x00, 0x96, 0x06, 0x08, 0x00, 0x90, 0x06, 0x08, 0x00, 0x90,
-  0x06, 0x08, 0x00, 0x63, 0x06, 0x08, 0x00, 0x63, 0x06, 0x08, 0x00, 0x4b,
-  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x90, 0x06, 0x08, 0x00, 0xa3,
-  0x06, 0x08, 0x00, 0x8c, 0x06, 0x08, 0x00, 0x75, 0x06, 0x08, 0x00, 0x90,
-  0x06, 0x08, 0x00, 0x57, 0x06, 0x08, 0x00, 0x57, 0x06, 0x08, 0x00, 0x4b,
-  0x06, 0x08, 0x00, 0x4b, 0x06, 0x74, 0x00, 0x5b, 0x06, 0x74, 0x00, 0x6d,
-  0x06, 0x74, 0x00, 0x6d, 0x06, 0x74, 0x00, 0x6d, 0x06, 0x74, 0x00, 0x6d,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x08, 0x02, 0xb7, 0x06, 0x08, 0x02, 0x6b,
-  0x06, 0x08, 0x01, 0xd2, 0x02, 0x52, 0x00, 0x9c, 0x02, 0x52, 0x00, 0x6c,
-  0x03, 0xdf, 0x00, 0x9c, 0x03, 0xdf, 0x00, 0x6c, 0x06, 0x08, 0x01, 0x1e,
-  0x06, 0x08, 0x01, 0x74, 0x06, 0x08, 0x01, 0x2c, 0x06, 0x08, 0x00, 0x63,
-  0x06, 0x08, 0x01, 0x35, 0x06, 0x08, 0x00, 0x71, 0x06, 0x08, 0x00, 0x90,
-  0x06, 0x08, 0x01, 0x68, 0x06, 0x08, 0x01, 0x68, 0x06, 0x08, 0x01, 0xe6,
-  0x06, 0x08, 0x01, 0xe6, 0x06, 0x08, 0x01, 0x8c, 0x06, 0x08, 0x01, 0xab,
-  0x06, 0x08, 0x01, 0x05, 0x06, 0x08, 0x01, 0x19, 0x06, 0x08, 0x01, 0x32,
-  0x06, 0x08, 0x01, 0x51, 0x06, 0x08, 0x02, 0x7d, 0x06, 0x08, 0x02, 0x2e,
-  0x06, 0x08, 0x01, 0x42, 0x06, 0x08, 0x01, 0x77, 0x06, 0x74, 0x00, 0x88,
-  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
-  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
-  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
-  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
-  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
-  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
-  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
-  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
-  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
-  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0xe2, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0xe2,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0xcd, 0x06, 0x08, 0x00, 0xcd,
-  0x06, 0x08, 0x00, 0xcd, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x01, 0xba, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x26, 0x06, 0x08, 0x00, 0x26,
-  0x06, 0x08, 0x00, 0xf9, 0x06, 0x08, 0x00, 0xf9, 0x06, 0x08, 0x00, 0x72,
-  0x06, 0x08, 0x00, 0x72, 0x06, 0x08, 0x01, 0x1c, 0x06, 0x08, 0x00, 0x75,
-  0x06, 0x08, 0x00, 0x94, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x96,
-  0x06, 0x08, 0x00, 0x96, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x96,
-  0x06, 0x08, 0x00, 0x67, 0x06, 0x08, 0x00, 0x87, 0x06, 0x08, 0x00, 0x91,
-  0x06, 0x08, 0x00, 0x91, 0x06, 0x08, 0x00, 0x69, 0x02, 0xcf, 0x00, 0x63,
-  0x02, 0xcf, 0x00, 0x47, 0x03, 0x8e, 0x00, 0x05, 0x03, 0x90, 0x00, 0x9e,
-  0x03, 0x90, 0x00, 0x9d, 0x02, 0xcf, 0x00, 0xa4, 0x02, 0xcf, 0x00, 0x93,
-  0x04, 0x01, 0x00, 0xa4, 0x04, 0x01, 0x00, 0x93, 0x06, 0x08, 0x00, 0x51,
-  0x06, 0x08, 0x00, 0x50, 0x06, 0x08, 0x00, 0x47, 0x06, 0x08, 0x00, 0x47,
-  0x08, 0x55, 0x00, 0x69, 0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69,
-  0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69,
-  0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69,
-  0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69, 0x0a, 0x52, 0x00, 0x69,
-  0x05, 0x46, 0x00, 0x00, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
-  0x05, 0x46, 0x01, 0x0e, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69,
-  0x06, 0x08, 0x00, 0xe6, 0x06, 0x08, 0x00, 0xe6, 0x04, 0xeb, 0x00, 0x47,
-  0x04, 0xeb, 0x00, 0x47, 0x05, 0x48, 0x00, 0xe6, 0x05, 0x48, 0x00, 0xe6,
-  0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
-  0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
-  0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x03, 0x8e, 0x00, 0x05,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0x34,
-  0x07, 0x33, 0x00, 0x34, 0x07, 0x33, 0x00, 0x34, 0x09, 0x8a, 0x00, 0x69,
-  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
-  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
-  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
-  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0xff, 0xc5, 0x03, 0xc0, 0x00, 0x69,
-  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
-  0x03, 0xc0, 0x00, 0x60, 0x06, 0x08, 0x00, 0xfc, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc4,
-  0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
-  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xa2, 0x06, 0x08, 0x01, 0x03,
-  0x06, 0x08, 0x00, 0xa2, 0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0x31,
-  0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x3b,
-  0x06, 0x08, 0x00, 0xa2, 0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0xa2,
-  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x01, 0x3b,
-  0x06, 0x04, 0x00, 0x69, 0x06, 0x04, 0x00, 0x69, 0x06, 0x04, 0x00, 0x40,
-  0x06, 0x04, 0x00, 0x40, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x05, 0x89, 0x00, 0x05,
-  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
-  0x06, 0xcd, 0x00, 0xa7, 0x06, 0x42, 0x00, 0x20, 0x06, 0x42, 0x00, 0x20,
-  0x06, 0x49, 0x00, 0x87, 0x06, 0x49, 0x00, 0x87, 0x06, 0x49, 0x00, 0x1e,
-  0x08, 0x0e, 0x00, 0x64, 0x06, 0x42, 0x00, 0x45, 0x06, 0x42, 0x00, 0x45,
-  0x04, 0x02, 0x00, 0x09, 0x02, 0x00, 0x00, 0x09, 0x04, 0x02, 0xff, 0xdc,
-  0x04, 0x57, 0x00, 0x09, 0x05, 0x00, 0x00, 0xb4, 0x04, 0x69, 0x00, 0x40,
-  0x02, 0xd2, 0xff, 0xeb, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa7, 0x04, 0xee, 0x00, 0x52,
-  0x03, 0xc7, 0x00, 0x4f, 0x05, 0xa0, 0x00, 0x67, 0x06, 0x36, 0x00, 0xb4,
-  0x04, 0xec, 0x00, 0x0e, 0x05, 0xa0, 0x00, 0x67, 0x05, 0x49, 0x00, 0x36,
-  0x08, 0x1f, 0x00, 0x3d, 0x06, 0xec, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x5d,
-  0x04, 0xb6, 0x00, 0xb4, 0x04, 0x16, 0x00, 0xad, 0x04, 0xbf, 0x00, 0x64,
-  0x02, 0xfb, 0x00, 0x00, 0x04, 0x67, 0x00, 0x65, 0x03, 0x88, 0x00, 0x58,
-  0x01, 0x42, 0xff, 0xec, 0x03, 0x19, 0x00, 0x09, 0x04, 0x92, 0x00, 0x79,
-  0x04, 0xee, 0x00, 0x52, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
-  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
-  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
-  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
-  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
-  0x03, 0x8d, 0x00, 0xc0, 0x02, 0xa8, 0x00, 0x5b, 0x02, 0xa8, 0x00, 0x5b,
-  0x01, 0xd1, 0x00, 0xaf, 0x01, 0xd1, 0x00, 0xaf, 0x01, 0xd1, 0x00, 0xaf,
-  0x02, 0xc6, 0x00, 0x7b, 0x02, 0x90, 0x00, 0x7b, 0x03, 0x65, 0x00, 0x67,
-  0x03, 0x65, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
-  0x06, 0x52, 0xff, 0xfb, 0x05, 0x1b, 0x00, 0x31, 0x04, 0x6c, 0x00, 0x93,
-  0x03, 0xe4, 0x00, 0x77, 0x03, 0x88, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63,
-  0x08, 0xff, 0x00, 0x0e, 0x07, 0x17, 0x00, 0x6e, 0x08, 0xa9, 0x00, 0x0e,
-  0x07, 0x20, 0x00, 0x6e, 0x08, 0x39, 0x00, 0x0e, 0x07, 0x10, 0x00, 0x6e,
-  0x06, 0xfe, 0x00, 0x0e, 0x05, 0xe3, 0x00, 0x6e, 0x06, 0xfe, 0x00, 0x0e,
-  0x05, 0xe3, 0x00, 0x6e, 0x06, 0xe7, 0x00, 0x0e, 0x05, 0xe3, 0x00, 0x6e,
-  0x05, 0x10, 0x00, 0x67, 0x03, 0xf4, 0x00, 0x72, 0x04, 0xb8, 0x00, 0x09,
-  0x04, 0x32, 0x00, 0x0c, 0x04, 0xe5, 0x00, 0xb4, 0x02, 0xd2, 0x00, 0xad,
-  0x04, 0x2f, 0x00, 0x4a, 0x03, 0x12, 0x00, 0x6c, 0x05, 0xce, 0x00, 0x09,
-  0x05, 0x11, 0x00, 0x09, 0x09, 0xc6, 0x00, 0x67, 0x07, 0x55, 0x00, 0x65,
-  0x04, 0x57, 0x00, 0x09, 0x04, 0x92, 0xff, 0xfc, 0x05, 0x48, 0x00, 0x2d,
-  0x05, 0x93, 0x00, 0x2d, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
-  0x04, 0x5b, 0x00, 0x09, 0x04, 0x92, 0xff, 0xfc, 0x04, 0x5b, 0x00, 0x09,
-  0x04, 0x92, 0xff, 0xfc, 0x04, 0x02, 0x00, 0x09, 0x02, 0x00, 0x00, 0xad,
-  0x05, 0x4b, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x02, 0x6d, 0x00, 0xd8,
-  0x02, 0xb5, 0x00, 0x90, 0x02, 0xe2, 0x01, 0x16, 0x01, 0xfa, 0x00, 0xb1,
-  0x04, 0xef, 0x00, 0x9d, 0x03, 0x82, 0x00, 0x45, 0x05, 0x8f, 0x00, 0xb4,
-  0x04, 0xcc, 0x00, 0xa7, 0x05, 0x94, 0x00, 0x03, 0x04, 0x92, 0x00, 0x03,
-  0x04, 0xb8, 0x00, 0x03, 0x04, 0x2b, 0x00, 0x03, 0x05, 0x62, 0x00, 0x03,
-  0x04, 0x90, 0x00, 0x03, 0x05, 0x00, 0x00, 0x03, 0x02, 0xf5, 0x00, 0x03,
-  0x04, 0x92, 0x00, 0x03, 0x03, 0xc0, 0x00, 0x03, 0x05, 0xc4, 0xff, 0xa2,
-  0x06, 0x96, 0x00, 0xa7, 0x04, 0x24, 0x00, 0x6b, 0x04, 0x57, 0x00, 0x3f,
-  0x06, 0x36, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0xb4, 0x08, 0xa2, 0x00, 0x3d,
-  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xd9, 0x00, 0x63,
-  0x01, 0xe6, 0x00, 0x56, 0x01, 0xec, 0x00, 0x51, 0x01, 0xb6, 0x00, 0x7e,
-  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xd9, 0x00, 0x63,
-  0x01, 0xe6, 0x00, 0x56, 0x01, 0xd9, 0x00, 0x63, 0x01, 0xb6, 0x00, 0x7e,
-  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xd9, 0x00, 0x63,
-  0x01, 0xe6, 0x00, 0x56, 0x01, 0xd9, 0x00, 0x63, 0x01, 0xb6, 0x00, 0x7e,
-  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xec, 0x00, 0x51,
-  0x01, 0xe6, 0x00, 0x56, 0x01, 0xd9, 0x00, 0x63, 0x01, 0xb6, 0x00, 0x7e,
-  0x01, 0x89, 0x00, 0xae, 0x01, 0xfa, 0x00, 0xc0, 0x07, 0x08, 0x00, 0x87,
-  0x07, 0x08, 0x00, 0x87, 0x07, 0x08, 0x00, 0x87, 0x07, 0x08, 0x00, 0x87,
-  0x04, 0x2d, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63, 0x04, 0x7d, 0x00, 0x63,
-  0x06, 0x66, 0x00, 0x63, 0x04, 0x36, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63,
-  0x04, 0xb3, 0x00, 0x63, 0x06, 0x59, 0x00, 0x63, 0x03, 0xff, 0x00, 0x63,
-  0x04, 0x2d, 0x00, 0x63, 0x08, 0x69, 0x00, 0x63, 0x04, 0x3d, 0x00, 0x63,
-  0x04, 0x3f, 0x00, 0x75, 0x06, 0x42, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63,
-  0x04, 0x3e, 0x00, 0x63, 0x06, 0x93, 0x00, 0x63, 0x04, 0x3f, 0x00, 0x75,
-  0x05, 0x43, 0x00, 0x63, 0x04, 0x32, 0x00, 0x2d, 0x06, 0x47, 0x00, 0x63,
-  0x04, 0x3e, 0x00, 0x63, 0x06, 0x71, 0x00, 0x63, 0x04, 0x3d, 0x00, 0x63,
-  0x04, 0x3d, 0x00, 0x63, 0x04, 0x40, 0x00, 0x75, 0x04, 0xac, 0x00, 0x64,
-  0x04, 0x3d, 0x00, 0x63, 0x04, 0x3e, 0x00, 0x75, 0x04, 0x4f, 0x00, 0x63,
-  0x04, 0x3f, 0x00, 0x75, 0x03, 0xb7, 0x00, 0x2d, 0x04, 0x2c, 0x00, 0x63,
-  0x04, 0x34, 0x00, 0x6c, 0x04, 0x2d, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63,
-  0x04, 0x2e, 0x00, 0x63, 0x04, 0x98, 0x00, 0x63, 0x06, 0xe0, 0x00, 0x63,
-  0x06, 0xb4, 0x00, 0x6d, 0x05, 0xd1, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
-  0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
-  0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
-  0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
-  0x03, 0xba, 0x00, 0x5a, 0x03, 0xba, 0x00, 0x5a, 0x03, 0xba, 0x00, 0x5a,
-  0x05, 0xa9, 0x00, 0x5a, 0x05, 0xa9, 0x00, 0x5a, 0x05, 0xa9, 0x00, 0x5a,
-  0x05, 0xa9, 0x00, 0x5a, 0x05, 0xa9, 0x00, 0x5a, 0x03, 0xef, 0x00, 0x36,
-  0x03, 0xef, 0x00, 0x36, 0x03, 0xef, 0x00, 0x36, 0x03, 0xef, 0x00, 0x36,
-  0x03, 0xef, 0x00, 0x36, 0x03, 0xef, 0x00, 0x36, 0x04, 0x67, 0x00, 0x65,
-  0x04, 0xf5, 0x00, 0x2a, 0x04, 0x89, 0x00, 0x2a, 0x04, 0x89, 0x00, 0x2a,
-  0x06, 0xf6, 0x00, 0x2a, 0x06, 0xf6, 0x00, 0x2a, 0x04, 0xf0, 0x00, 0x2a,
-  0x06, 0x32, 0x00, 0x63, 0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0xfd, 0x73, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x07, 0x62, 0x00, 0x1b, 0x05, 0x73, 0x00, 0x5a, 0x04, 0x5f, 0x00, 0xb4,
-  0x04, 0x0c, 0x00, 0x5a, 0x04, 0x53, 0x00, 0xb4, 0x03, 0xf3, 0x00, 0xb4,
-  0x03, 0xf3, 0x00, 0xb4, 0x03, 0x2a, 0x00, 0x87, 0x04, 0x80, 0x00, 0xb4,
-  0x06, 0x81, 0x00, 0x87, 0x02, 0x0a, 0x00, 0xb4, 0x04, 0x96, 0x00, 0xb4,
-  0x03, 0xef, 0x00, 0xb4, 0x0a, 0x45, 0x00, 0xb4, 0x06, 0x58, 0x00, 0xb4,
-  0x06, 0xa6, 0x00, 0xb4, 0x06, 0x81, 0x00, 0x87, 0x04, 0xf0, 0x00, 0xb4,
-  0x06, 0x40, 0x00, 0xb4, 0x04, 0x38, 0x00, 0x87, 0x04, 0x5d, 0x00, 0xb4,
-  0x03, 0x2d, 0x00, 0x87, 0x05, 0x03, 0x00, 0x5a, 0x04, 0x95, 0x00, 0xb4,
-  0x04, 0xf0, 0x00, 0x87, 0x04, 0xec, 0x00, 0x87, 0x05, 0xd4, 0x00, 0x5a,
-  0x03, 0xcc, 0x00, 0x87, 0x04, 0x03, 0x00, 0xb4, 0x04, 0x03, 0x00, 0xb4,
-  0x03, 0x2a, 0x00, 0x5a, 0x05, 0x73, 0x00, 0x5a, 0x02, 0x0a, 0x00, 0xb4,
-  0x05, 0x73, 0x00, 0x5a, 0x04, 0xf0, 0x00, 0x87, 0x05, 0xe3, 0x00, 0x5a,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x05, 0x55, 0x00, 0x0e, 0x05, 0x43, 0x00, 0xb4, 0x05, 0xe5, 0x00, 0xd0,
-  0x05, 0x40, 0x00, 0xb4, 0x04, 0xd9, 0x00, 0xb4, 0x05, 0x94, 0x00, 0x67,
-  0x02, 0xd3, 0x00, 0x5b, 0x02, 0xd1, 0xff, 0xa1, 0x05, 0x6a, 0x00, 0xb4,
-  0x04, 0xb6, 0x00, 0xb4, 0x07, 0x61, 0x00, 0xb0, 0x05, 0xaa, 0x00, 0x66,
-  0x04, 0x92, 0x00, 0x7a, 0x05, 0x19, 0xff, 0xfb, 0x05, 0xfa, 0x00, 0x9f,
-  0x05, 0x34, 0x00, 0x0e, 0x07, 0xfa, 0x00, 0x3d, 0x05, 0xcd, 0x00, 0x61,
-  0x05, 0x17, 0xff, 0xfd, 0x04, 0xc3, 0x00, 0x6e, 0x05, 0x19, 0x00, 0x85,
-  0x03, 0xf5, 0x00, 0x65, 0x05, 0x19, 0x00, 0x85, 0x04, 0x6e, 0x00, 0x63,
-  0x03, 0x59, 0x00, 0x2a, 0x05, 0x19, 0x00, 0x65, 0x05, 0x4e, 0x00, 0xa7,
-  0x02, 0x87, 0x00, 0xcf, 0x02, 0x87, 0xff, 0xdc, 0x04, 0xaf, 0x00, 0xa7,
-  0x02, 0x87, 0x00, 0xcf, 0x08, 0x38, 0x00, 0xa7, 0x05, 0x4e, 0x00, 0xa7,
-  0x04, 0x67, 0x00, 0x65, 0x05, 0x19, 0x00, 0x65, 0x05, 0x19, 0x00, 0x65,
-  0x03, 0x7b, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63, 0x03, 0x59, 0x00, 0x31,
-  0x05, 0x52, 0x00, 0x9f, 0x04, 0x5f, 0x00, 0x36, 0x06, 0x8d, 0x00, 0x4d,
-  0x04, 0xdd, 0x00, 0x44, 0x04, 0x7f, 0x00, 0x36, 0x04, 0x3f, 0x00, 0x4f,
-  0x04, 0xec, 0x00, 0x0e, 0x04, 0xf0, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67,
-  0x05, 0x8b, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x24, 0x00, 0xb4,
-  0x05, 0x94, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4, 0x03, 0x31, 0x00, 0x87,
-  0x02, 0x1f, 0xff, 0xa1, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x02, 0x00, 0xb4,
-  0x06, 0x36, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67,
-  0x04, 0x57, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x00, 0x00, 0xb4,
-  0x04, 0x92, 0x00, 0x79, 0x04, 0x65, 0xff, 0xfb, 0x05, 0x45, 0x00, 0xa0,
-  0x04, 0xec, 0x00, 0x0e, 0x07, 0x1e, 0x00, 0x3d, 0x04, 0xee, 0x00, 0x36,
-  0x04, 0x65, 0xff, 0xfd, 0x04, 0xee, 0x00, 0x52, 0x04, 0x69, 0x00, 0x6e,
-  0x04, 0x92, 0x00, 0xa7, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
-  0x04, 0x6e, 0x00, 0x65, 0x02, 0x88, 0x00, 0x2a, 0x04, 0x92, 0x00, 0x65,
-  0x04, 0x90, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x02, 0x00, 0xff, 0xdf,
-  0x04, 0x2b, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x07, 0x03, 0x00, 0xa7,
-  0x04, 0x90, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x04, 0x92, 0x00, 0xa7,
-  0x04, 0x92, 0x00, 0x65, 0x02, 0xf5, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63,
-  0x02, 0xd2, 0x00, 0x31, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x42, 0x00, 0x36,
-  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x35, 0x04, 0x42, 0x00, 0x36,
-  0x03, 0xc7, 0x00, 0x4f, 0x04, 0x94, 0x00, 0x7a, 0x04, 0x94, 0x00, 0x60,
-  0x04, 0x94, 0x00, 0x75, 0x04, 0x94, 0x00, 0x8c, 0x04, 0x94, 0x00, 0x51,
-  0x04, 0x94, 0x00, 0x85, 0x04, 0x94, 0x00, 0x65, 0x04, 0x94, 0x00, 0x3a,
-  0x04, 0x94, 0x00, 0x7d, 0x04, 0x92, 0x00, 0x5f, 0x04, 0x94, 0x00, 0x79,
-  0x04, 0x94, 0x00, 0xca, 0x04, 0x94, 0x00, 0x87, 0x04, 0x94, 0x00, 0x8c,
-  0x04, 0x94, 0x00, 0x5a, 0x04, 0x94, 0x00, 0x8e, 0x04, 0x94, 0x00, 0x80,
-  0x04, 0x94, 0x00, 0x97, 0x04, 0x94, 0x00, 0x7d, 0x04, 0x94, 0x00, 0x74,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
-  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
-  0x05, 0xde, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x6c, 0x00, 0xc3, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
-  0x07, 0x82, 0x00, 0x89, 0x08, 0x85, 0x00, 0x43, 0x07, 0x81, 0x00, 0x36,
-  0x08, 0x53, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x08, 0x69, 0x00, 0x55, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x80,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x08, 0x69, 0x00, 0x55,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x1f, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x0b, 0x8c, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
-  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x34, 0x08, 0x69, 0x00, 0x56,
-  0x07, 0x81, 0x00, 0x34, 0x07, 0x81, 0x00, 0x36, 0x07, 0x81, 0x00, 0x36,
-  0x07, 0x81, 0x00, 0x36, 0x07, 0x81, 0x00, 0x36, 0x07, 0x81, 0x00, 0x36,
-  0x07, 0x81, 0x00, 0x36, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0xfd, 0x28,
-  0x00, 0x00, 0xfd, 0xb5, 0x00, 0x00, 0xfd, 0x0b, 0x00, 0x00, 0xfd, 0x58,
-  0x00, 0x00, 0xfd, 0x21, 0x00, 0x00, 0xfd, 0x21, 0x00, 0x00, 0xfd, 0x1a,
-  0x00, 0x00, 0xfd, 0x1a, 0x00, 0x00, 0xfd, 0xd8, 0x00, 0x00, 0xfd, 0x36,
-  0x00, 0x00, 0xfc, 0xad, 0x00, 0x87, 0x00, 0x00, 0x01, 0x68, 0x00, 0x00,
-  0x01, 0x68, 0x00, 0x00, 0x01, 0x68, 0x00, 0x00, 0x00, 0x87, 0x00, 0x00,
-  0x01, 0x68, 0x00, 0x00, 0x07, 0x11, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee,
-  0x02, 0x2c, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75, 0x03, 0x71, 0xff, 0xee,
-  0x03, 0xa4, 0xff, 0xee, 0x06, 0x01, 0x00, 0x60, 0x03, 0x71, 0xff, 0xee,
-  0x03, 0xa4, 0xff, 0xee, 0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee,
-  0x01, 0x8a, 0x00, 0x00, 0x07, 0x11, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee,
-  0x02, 0x2c, 0xff, 0xee, 0x07, 0x11, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee,
-  0x02, 0x2c, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
-  0x04, 0xa5, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
-  0x04, 0xa5, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
-  0x04, 0xa5, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
-  0x04, 0xa5, 0xff, 0xee, 0x03, 0x08, 0x00, 0x00, 0x05, 0x62, 0x00, 0xbf,
-  0x02, 0x00, 0x00, 0x0d, 0x02, 0xa3, 0xff, 0x0d, 0x04, 0xec, 0x01, 0x69,
-  0x04, 0xec, 0x01, 0x69, 0x04, 0xec, 0x01, 0x69, 0x04, 0xec, 0x01, 0x6a,
-  0x04, 0xec, 0x01, 0x6a, 0x04, 0xec, 0x01, 0x69, 0x04, 0xec, 0x01, 0x69,
-  0x04, 0xec, 0x01, 0x50, 0x04, 0xec, 0x01, 0x63, 0x04, 0xec, 0x01, 0x50,
-  0x04, 0xec, 0x01, 0x63, 0x04, 0xec, 0x01, 0x50, 0x04, 0xec, 0x01, 0x63,
-  0x04, 0xec, 0x01, 0x63, 0x04, 0xec, 0x01, 0x50, 0x04, 0xec, 0x01, 0x50,
-  0x04, 0xec, 0x01, 0x5c, 0x04, 0xec, 0x01, 0x5c, 0x04, 0xec, 0x01, 0x5c,
-  0x04, 0xec, 0x01, 0x63, 0x00, 0x00, 0xfc, 0xf1, 0x01, 0x0e, 0x00, 0x00,
-  0x03, 0xaf, 0x00, 0x00, 0x04, 0x65, 0xff, 0xb4, 0x04, 0x65, 0xff, 0xb4,
-  0x05, 0x73, 0x00, 0x81, 0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee,
-  0x06, 0x00, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee,
-  0x03, 0xf9, 0xff, 0xb4, 0x02, 0x00, 0x00, 0xad, 0x03, 0xdc, 0x00, 0x82,
-  0x05, 0x07, 0x00, 0x65, 0x04, 0x65, 0x00, 0x65, 0x02, 0x00, 0x00, 0x87,
-  0x02, 0x87, 0x00, 0x47, 0x02, 0x87, 0xff, 0x2e, 0x02, 0x00, 0xff, 0xd8,
-  0x02, 0x00, 0x00, 0xab, 0x02, 0x6d, 0x00, 0xd8, 0x03, 0x31, 0x00, 0x87,
-  0x06, 0x08, 0x01, 0x82, 0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xb4,
-  0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xb4,
-  0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xc6, 0x00, 0x00, 0x00, 0xc6,
-  0x02, 0x01, 0x00, 0xad, 0x02, 0x01, 0xff, 0xee, 0x02, 0x01, 0xff, 0xee,
-  0x04, 0x1d, 0x00, 0x65, 0x04, 0x1d, 0xff, 0xee, 0x04, 0x1d, 0xff, 0xee,
-  0x03, 0x0d, 0x00, 0x36, 0x03, 0x0d, 0xff, 0xee, 0x03, 0x0d, 0xff, 0xee,
-  0x04, 0x42, 0x00, 0x36, 0x04, 0x42, 0xff, 0xee, 0x04, 0x42, 0xff, 0xee,
-  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
-  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
-  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
-  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
-  0x05, 0xf7, 0x00, 0x65, 0x05, 0xf7, 0xff, 0xee, 0x05, 0xf7, 0xff, 0xee,
-  0x03, 0x27, 0x00, 0xad, 0x03, 0x27, 0xff, 0xee, 0x03, 0x27, 0xff, 0xee,
-  0x03, 0x27, 0x00, 0x36, 0x03, 0x27, 0xff, 0xee, 0x03, 0x27, 0xff, 0xee,
-  0x04, 0x05, 0x00, 0xa7, 0x04, 0x05, 0xff, 0xee, 0x04, 0x05, 0xff, 0xee,
-  0x04, 0x67, 0x00, 0xad, 0x04, 0x67, 0xff, 0xee, 0x04, 0x67, 0xff, 0xee,
-  0x02, 0x85, 0x00, 0x36, 0x02, 0x85, 0xff, 0xee, 0x02, 0x85, 0xff, 0xee,
-  0x06, 0xe7, 0x00, 0xad, 0x06, 0xe7, 0xff, 0xee, 0x06, 0xe7, 0xff, 0xee,
-  0x03, 0x67, 0x00, 0x36, 0x03, 0x67, 0xff, 0xee, 0x03, 0x67, 0xff, 0xee,
-  0x05, 0xa3, 0x00, 0x36, 0x05, 0xa3, 0xff, 0xee, 0x05, 0xa3, 0xff, 0xee,
-  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
-  0x04, 0x80, 0x00, 0x36, 0x04, 0x80, 0xff, 0xee, 0x04, 0x80, 0xff, 0xee,
-  0x05, 0x48, 0x00, 0xad, 0x05, 0x48, 0xff, 0xee, 0x05, 0x48, 0xff, 0xee,
-  0x03, 0xd0, 0x00, 0xad, 0x03, 0xd0, 0xff, 0xee, 0x03, 0xd0, 0xff, 0xee,
-  0x05, 0x36, 0x00, 0x64, 0x05, 0x36, 0xff, 0xee, 0x05, 0x36, 0xff, 0xee,
-  0x03, 0x67, 0x00, 0x36, 0x03, 0x67, 0xff, 0xee, 0x03, 0x67, 0xff, 0xee,
-  0x04, 0x80, 0x00, 0x36, 0x04, 0x80, 0xff, 0xee, 0x04, 0x80, 0xff, 0xee,
-  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
-  0x03, 0xd0, 0x00, 0xad, 0x03, 0xd0, 0xff, 0xee, 0x03, 0xd0, 0xff, 0xee,
-  0x03, 0xd0, 0x00, 0xad, 0x03, 0xd0, 0xff, 0xee, 0x03, 0xd0, 0xff, 0xee,
-  0x03, 0xc3, 0x00, 0xad, 0x03, 0xc3, 0xff, 0xee, 0x03, 0xc3, 0xff, 0xee,
-  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
-  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
-  0x00, 0x00, 0xfd, 0x3b, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
-  0x06, 0x07, 0x01, 0x6e, 0x05, 0x8f, 0x00, 0xb4, 0x04, 0xdf, 0x00, 0xad,
-  0x04, 0x90, 0x00, 0x9c, 0x03, 0xc7, 0x00, 0x70, 0x03, 0xc7, 0x00, 0x70,
-  0x03, 0xc7, 0x00, 0x70, 0x03, 0xc7, 0x00, 0x70, 0x03, 0xc7, 0x00, 0x70,
-  0x03, 0xf9, 0xff, 0xb4, 0x03, 0xf9, 0xff, 0xb4, 0x03, 0xf9, 0xff, 0xb4,
-  0x03, 0xf9, 0xff, 0xb4, 0x03, 0xf9, 0xff, 0xb4, 0x09, 0x2d, 0x00, 0x75,
-  0x06, 0x08, 0xff, 0xee, 0x06, 0x6c, 0xff, 0xee, 0x09, 0x2d, 0x00, 0x75,
-  0x06, 0x08, 0xff, 0xee, 0x06, 0x6c, 0xff, 0xee, 0x09, 0x2d, 0x00, 0x75,
-  0x06, 0x08, 0xff, 0xee, 0x06, 0x6c, 0xff, 0xee, 0x08, 0xd2, 0x00, 0x75,
-  0x06, 0x1d, 0xff, 0xee, 0x06, 0x3e, 0xff, 0xee, 0x08, 0xd2, 0x00, 0x75,
-  0x06, 0x1d, 0xff, 0xee, 0x06, 0x3e, 0xff, 0xee, 0x06, 0xd5, 0x00, 0x81,
-  0x05, 0xbb, 0xff, 0xee, 0x05, 0xe8, 0xff, 0xee, 0x03, 0xd5, 0x00, 0x69,
-  0x04, 0x4b, 0xff, 0xee, 0x03, 0x79, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75,
-  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75,
-  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75,
-  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x06, 0x01, 0x00, 0x60,
-  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x06, 0x01, 0x00, 0x60,
-  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x07, 0x96, 0x00, 0x75,
-  0x06, 0x40, 0xff, 0xee, 0x06, 0x40, 0xff, 0xee, 0x06, 0x71, 0x00, 0x75,
-  0x03, 0x6d, 0xff, 0xee, 0x03, 0xf9, 0xff, 0xee, 0x06, 0x11, 0x00, 0x81,
-  0x03, 0x6d, 0xff, 0xee, 0x03, 0xf9, 0xff, 0xee, 0x06, 0x11, 0x00, 0x81,
-  0x03, 0x6d, 0xff, 0xee, 0x03, 0xf9, 0xff, 0xee, 0x06, 0x71, 0x03, 0x69,
-  0x03, 0x6d, 0x00, 0x64, 0x03, 0xf9, 0x00, 0x64, 0x06, 0x71, 0x02, 0x1c,
-  0x03, 0x6d, 0x00, 0x64, 0x03, 0xf9, 0x00, 0x64, 0x06, 0x71, 0x03, 0x2a,
-  0x03, 0x6d, 0x00, 0x43, 0x03, 0xf9, 0x00, 0x43, 0x05, 0x73, 0x00, 0x81,
-  0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee, 0x05, 0x73, 0x00, 0x81,
-  0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee, 0x05, 0x73, 0x00, 0x81,
-  0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee, 0x05, 0x7b, 0x00, 0x84,
-  0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee, 0x05, 0x7b, 0x00, 0x84,
-  0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee, 0x05, 0x7b, 0x00, 0x84,
-  0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee, 0x00, 0x00, 0x00, 0x01,
-  0x00, 0x00, 0x3f, 0xf8, 0x00, 0x01, 0x0a, 0xa7, 0x30, 0x00, 0x00, 0x0b,
-  0x0f, 0xea, 0x00, 0x10, 0x00, 0x24, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x25,
-  0xff, 0xb7, 0x00, 0x10, 0x00, 0x2a, 0x00, 0x4b, 0x00, 0x10, 0x00, 0x2d,
-  0x00, 0x72, 0x00, 0x10, 0x00, 0x32, 0x00, 0x39, 0x00, 0x10, 0x00, 0x34,
-  0x00, 0x4b, 0x00, 0x10, 0x00, 0x37, 0xff, 0x44, 0x00, 0x10, 0x00, 0x39,
-  0xff, 0x88, 0x00, 0x10, 0x00, 0x3a, 0xff, 0xad, 0x00, 0x10, 0x00, 0x3b,
-  0xff, 0x9a, 0x00, 0x10, 0x00, 0x3c, 0xff, 0x0d, 0x00, 0x10, 0x00, 0x52,
-  0x00, 0x26, 0x00, 0x10, 0x00, 0x59, 0xff, 0xc9, 0x00, 0x10, 0x00, 0x5c,
-  0xff, 0xdc, 0x00, 0x10, 0x00, 0x82, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x83,
-  0xff, 0xd3, 0x00, 0x10, 0x00, 0x84, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x85,
-  0xff, 0xd3, 0x00, 0x10, 0x00, 0x86, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x94,
-  0x00, 0x39, 0x00, 0x10, 0x00, 0x95, 0x00, 0x39, 0x00, 0x10, 0x00, 0x96,
-  0x00, 0x39, 0x00, 0x10, 0x00, 0x97, 0x00, 0x39, 0x00, 0x10, 0x00, 0x98,
-  0x00, 0x39, 0x00, 0x10, 0x00, 0x9f, 0xff, 0x0d, 0x00, 0x10, 0x00, 0xb4,
-  0x00, 0x26, 0x00, 0x10, 0x00, 0xb5, 0x00, 0x26, 0x00, 0x10, 0x00, 0xb6,
-  0x00, 0x26, 0x00, 0x10, 0x00, 0xb7, 0x00, 0x26, 0x00, 0x10, 0x00, 0xb8,
-  0x00, 0x26, 0x00, 0x10, 0x00, 0xbf, 0xff, 0xdc, 0x00, 0x10, 0x00, 0xc1,
-  0xff, 0xdc, 0x00, 0x10, 0x00, 0xc2, 0xff, 0xd3, 0x00, 0x10, 0x00, 0xc4,
-  0xff, 0xd3, 0x00, 0x10, 0x00, 0xc6, 0xff, 0xd3, 0x00, 0x10, 0x00, 0xe0,
-  0x00, 0x4b, 0x00, 0x10, 0x01, 0x26, 0xff, 0x44, 0x00, 0x10, 0x01, 0x3a,
-  0xff, 0x0d, 0x00, 0x24, 0x00, 0x10, 0xff, 0xd3, 0x00, 0x24, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x24,
-  0x00, 0x39, 0x00, 0x24, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x2a,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x32, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x34,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x37, 0xff, 0x61, 0x00, 0x24, 0x00, 0x39,
-  0xff, 0x7d, 0x00, 0x24, 0x00, 0x3a, 0xff, 0x90, 0x00, 0x24, 0x00, 0x3c,
-  0xff, 0x61, 0x00, 0x24, 0x00, 0x46, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x47,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x48, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x49,
-  0xff, 0xb7, 0x00, 0x24, 0x00, 0x52, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x54,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x57, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x59,
-  0xff, 0x88, 0x00, 0x24, 0x00, 0x5a, 0xff, 0xad, 0x00, 0x24, 0x00, 0x5c,
-  0xff, 0x75, 0x00, 0x24, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0x24, 0x00, 0x82,
-  0x00, 0x39, 0x00, 0x24, 0x00, 0x83, 0x00, 0x39, 0x00, 0x24, 0x00, 0x84,
-  0x00, 0x39, 0x00, 0x24, 0x00, 0x85, 0x00, 0x39, 0x00, 0x24, 0x00, 0x86,
-  0x00, 0x39, 0x00, 0x24, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x94,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x96,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x98,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0x9f, 0xff, 0x61, 0x00, 0x24, 0x00, 0xa9,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xab,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xac, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xad,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xb5,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xb7,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xbf,
-  0xff, 0x75, 0x00, 0x24, 0x00, 0xc1, 0xff, 0x75, 0x00, 0x24, 0x00, 0xc2,
-  0x00, 0x39, 0x00, 0x24, 0x00, 0xc4, 0x00, 0x39, 0x00, 0x24, 0x00, 0xc6,
-  0x00, 0x39, 0x00, 0x24, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xc9,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xca, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xcb,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xcd,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xcf,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xd3,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xd7,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xdb,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xde,
-  0xff, 0xdc, 0x00, 0x24, 0x00, 0xe0, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xe2,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0x0e, 0xff, 0xdc, 0x00, 0x24, 0x01, 0x0f,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0x10, 0xff, 0xdc, 0x00, 0x24, 0x01, 0x11,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0x12, 0xff, 0xdc, 0x00, 0x24, 0x01, 0x13,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0x24, 0xff, 0x61, 0x00, 0x24, 0x01, 0x25,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0x26, 0xff, 0x61, 0x00, 0x24, 0x01, 0x27,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0x36, 0xff, 0x90, 0x00, 0x24, 0x01, 0x37,
-  0xff, 0xad, 0x00, 0x24, 0x01, 0x38, 0xff, 0x61, 0x00, 0x24, 0x01, 0x39,
-  0xff, 0x75, 0x00, 0x24, 0x01, 0x3a, 0xff, 0x61, 0x00, 0x24, 0x01, 0x88,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0xac, 0xff, 0xdc, 0x00, 0x24, 0x01, 0xad,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0xae, 0xff, 0xdc, 0x00, 0x24, 0x01, 0xaf,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0xdc, 0xff, 0x61, 0x00, 0x24, 0x01, 0xdd,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x24, 0x01, 0xf3,
-  0xff, 0xdc, 0x00, 0x24, 0x01, 0xf4, 0xff, 0x61, 0x00, 0x24, 0x01, 0xf5,
-  0xff, 0x75, 0x00, 0x24, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x24, 0x05, 0xd1,
-  0xff, 0xad, 0x00, 0x24, 0x05, 0xd2, 0xff, 0x90, 0x00, 0x24, 0x05, 0xd3,
-  0xff, 0xad, 0x00, 0x24, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x24, 0x05, 0xd5,
-  0xff, 0xad, 0x00, 0x24, 0x06, 0x42, 0xff, 0x61, 0x00, 0x24, 0x06, 0x43,
-  0xff, 0x75, 0x00, 0x24, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x24, 0x07, 0x52,
-  0xff, 0x03, 0x00, 0x24, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x25, 0x00, 0x26,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x32,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0x36, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x39,
-  0xff, 0xc1, 0x00, 0x25, 0x00, 0x3a, 0xff, 0xb7, 0x00, 0x25, 0x00, 0x3c,
-  0xff, 0x90, 0x00, 0x25, 0x00, 0x6d, 0xff, 0xc1, 0x00, 0x25, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x94,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x96,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x98,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0x9f, 0xff, 0x90, 0x00, 0x25, 0x00, 0xc8,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0xca, 0xff, 0xdc, 0x00, 0x25, 0x00, 0xcc,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x25, 0x00, 0xde,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0xe0, 0xff, 0xdc, 0x00, 0x25, 0x00, 0xe2,
-  0xff, 0xdc, 0x00, 0x25, 0x00, 0xe4, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x0e,
-  0xff, 0xdc, 0x00, 0x25, 0x01, 0x10, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x12,
-  0xff, 0xdc, 0x00, 0x25, 0x01, 0x1c, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x1e,
-  0xff, 0xdc, 0x00, 0x25, 0x01, 0x20, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x22,
-  0xff, 0xdc, 0x00, 0x25, 0x01, 0x36, 0xff, 0xb7, 0x00, 0x25, 0x01, 0x38,
-  0xff, 0x90, 0x00, 0x25, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x25, 0x01, 0xac,
-  0xff, 0xdc, 0x00, 0x25, 0x01, 0xae, 0xff, 0xdc, 0x00, 0x25, 0x01, 0xda,
-  0xff, 0xdc, 0x00, 0x25, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x25, 0x05, 0xd0,
-  0xff, 0xb7, 0x00, 0x25, 0x05, 0xd2, 0xff, 0xb7, 0x00, 0x25, 0x05, 0xd4,
-  0xff, 0xb7, 0x00, 0x25, 0x06, 0x42, 0xff, 0x90, 0x00, 0x25, 0x07, 0x51,
-  0xff, 0x90, 0x00, 0x25, 0x07, 0x52, 0xff, 0x90, 0x00, 0x25, 0x07, 0x53,
-  0xff, 0xad, 0x00, 0x26, 0x00, 0x3c, 0xff, 0xdc, 0x00, 0x26, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0x26, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x26, 0x00, 0x9f,
-  0xff, 0xdc, 0x00, 0x26, 0x01, 0x38, 0xff, 0xdc, 0x00, 0x26, 0x01, 0x3a,
-  0xff, 0xdc, 0x00, 0x26, 0x01, 0xf4, 0xff, 0xdc, 0x00, 0x26, 0x06, 0x42,
-  0xff, 0xdc, 0x00, 0x26, 0x07, 0x52, 0x00, 0x26, 0x00, 0x27, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x27, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x3c,
-  0xff, 0x90, 0x00, 0x27, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x27, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x27, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x27, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0x27, 0x00, 0xc2, 0xff, 0xdc, 0x00, 0x27, 0x00, 0xc4,
-  0xff, 0xdc, 0x00, 0x27, 0x00, 0xc6, 0xff, 0xdc, 0x00, 0x27, 0x01, 0x38,
-  0xff, 0x90, 0x00, 0x27, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x27, 0x01, 0xf4,
-  0xff, 0x90, 0x00, 0x27, 0x06, 0x42, 0xff, 0x90, 0x00, 0x27, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x27, 0x07, 0x52, 0xff, 0xc9, 0x00, 0x27, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0x11, 0xfe, 0xb7, 0x00, 0x29, 0x00, 0x1d,
-  0xff, 0x61, 0x00, 0x29, 0x00, 0x24, 0xff, 0x44, 0x00, 0x29, 0x00, 0x36,
-  0xff, 0xdc, 0x00, 0x29, 0x00, 0x37, 0xff, 0xdc, 0x00, 0x29, 0x00, 0x44,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0x48, 0xff, 0x90, 0x00, 0x29, 0x00, 0x4c,
-  0xff, 0x6b, 0x00, 0x29, 0x00, 0x52, 0xff, 0xb7, 0x00, 0x29, 0x00, 0x55,
-  0xff, 0x6b, 0x00, 0x29, 0x00, 0x58, 0xff, 0x90, 0x00, 0x29, 0x00, 0x5c,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0x82, 0xff, 0x44, 0x00, 0x29, 0x00, 0x83,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0x84, 0xff, 0x44, 0x00, 0x29, 0x00, 0x85,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0x86, 0xff, 0x44, 0x00, 0x29, 0x00, 0xa2,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0xa3, 0xff, 0x44, 0x00, 0x29, 0x00, 0xa4,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0xa5, 0xff, 0x44, 0x00, 0x29, 0x00, 0xa6,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0xa7, 0xff, 0x44, 0x00, 0x29, 0x00, 0xaa,
-  0xff, 0x90, 0x00, 0x29, 0x00, 0xab, 0xff, 0x90, 0x00, 0x29, 0x00, 0xac,
-  0xff, 0x90, 0x00, 0x29, 0x00, 0xad, 0xff, 0x90, 0x00, 0x29, 0x00, 0xb4,
-  0xff, 0xb7, 0x00, 0x29, 0x00, 0xb5, 0xff, 0xb7, 0x00, 0x29, 0x00, 0xb6,
-  0xff, 0xb7, 0x00, 0x29, 0x00, 0xb7, 0xff, 0xb7, 0x00, 0x29, 0x00, 0xb8,
-  0xff, 0xb7, 0x00, 0x29, 0x00, 0xbb, 0xff, 0x90, 0x00, 0x29, 0x00, 0xbc,
-  0xff, 0x90, 0x00, 0x29, 0x00, 0xbd, 0xff, 0x90, 0x00, 0x29, 0x00, 0xbe,
-  0xff, 0x90, 0x00, 0x29, 0x00, 0xbf, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc1,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0xc2, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc3,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0xc4, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc5,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0xc6, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc7,
-  0xff, 0x44, 0x00, 0x29, 0x00, 0xd5, 0xff, 0x90, 0x00, 0x29, 0x00, 0xd7,
-  0xff, 0x90, 0x00, 0x29, 0x00, 0xd9, 0xff, 0x90, 0x00, 0x29, 0x00, 0xdb,
-  0xff, 0x90, 0x00, 0x29, 0x00, 0xdd, 0xff, 0x90, 0x00, 0x29, 0x00, 0xf1,
-  0xff, 0x6b, 0x00, 0x29, 0x00, 0xf5, 0xff, 0x6b, 0x00, 0x29, 0x01, 0x0f,
-  0xff, 0xb7, 0x00, 0x29, 0x01, 0x11, 0xff, 0xb7, 0x00, 0x29, 0x01, 0x13,
-  0xff, 0xb7, 0x00, 0x29, 0x01, 0x17, 0xff, 0x6b, 0x00, 0x29, 0x01, 0x19,
-  0xff, 0x6b, 0x00, 0x29, 0x01, 0x1b, 0xff, 0x6b, 0x00, 0x29, 0x01, 0x1c,
-  0xff, 0xdc, 0x00, 0x29, 0x01, 0x1e, 0xff, 0xdc, 0x00, 0x29, 0x01, 0x20,
-  0xff, 0xdc, 0x00, 0x29, 0x01, 0x22, 0xff, 0xdc, 0x00, 0x29, 0x01, 0x24,
-  0xff, 0xdc, 0x00, 0x29, 0x01, 0x26, 0xff, 0xdc, 0x00, 0x29, 0x01, 0x28,
-  0xff, 0xdc, 0x00, 0x29, 0x01, 0x2b, 0xff, 0x90, 0x00, 0x29, 0x01, 0x2d,
-  0xff, 0x90, 0x00, 0x29, 0x01, 0x2f, 0xff, 0x90, 0x00, 0x29, 0x01, 0x31,
-  0xff, 0x90, 0x00, 0x29, 0x01, 0x33, 0xff, 0x90, 0x00, 0x29, 0x01, 0x35,
-  0xff, 0x90, 0x00, 0x29, 0x01, 0x39, 0xff, 0x44, 0x00, 0x29, 0x01, 0xad,
-  0xff, 0xb7, 0x00, 0x29, 0x01, 0xaf, 0xff, 0xb7, 0x00, 0x29, 0x01, 0xda,
-  0xff, 0xdc, 0x00, 0x29, 0x01, 0xdc, 0xff, 0xdc, 0x00, 0x29, 0x01, 0xf1,
-  0xff, 0xb7, 0x00, 0x29, 0x01, 0xf5, 0xff, 0x44, 0x00, 0x29, 0x06, 0x43,
-  0xff, 0x44, 0x00, 0x29, 0x07, 0x51, 0xff, 0xd3, 0x00, 0x29, 0x07, 0x53,
-  0xfe, 0x88, 0x00, 0x2a, 0x00, 0x37, 0xff, 0xb7, 0x00, 0x2a, 0x00, 0x3c,
-  0xff, 0x9a, 0x00, 0x2a, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x2a, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x2a, 0x00, 0x9f, 0xff, 0x9a, 0x00, 0x2a, 0x01, 0x26,
-  0xff, 0xb7, 0x00, 0x2a, 0x01, 0x3a, 0xff, 0x9a, 0x00, 0x2a, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x2a, 0x07, 0x52, 0xff, 0xd3, 0x00, 0x2a, 0x07, 0x53,
-  0xff, 0xc9, 0x00, 0x2b, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x2b, 0x07, 0x51,
-  0xff, 0xb7, 0x00, 0x2b, 0x07, 0x52, 0xff, 0xc1, 0x00, 0x2b, 0x07, 0x53,
-  0xff, 0xb7, 0x00, 0x2d, 0x00, 0x10, 0xff, 0xb7, 0x00, 0x2d, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x2d, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x2d, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x2d, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x2d, 0x07, 0x51,
-  0xff, 0xb7, 0x00, 0x2d, 0x07, 0x52, 0xff, 0xc1, 0x00, 0x2d, 0x07, 0x53,
-  0xff, 0x90, 0x00, 0x2e, 0x00, 0x10, 0xff, 0x29, 0x00, 0x2e, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x2e, 0x00, 0x26, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x32,
-  0xff, 0x90, 0x00, 0x2e, 0x00, 0x37, 0xff, 0x61, 0x00, 0x2e, 0x00, 0x38,
-  0xff, 0xc9, 0x00, 0x2e, 0x00, 0x3a, 0xff, 0xb7, 0x00, 0x2e, 0x00, 0x3c,
-  0xff, 0xb7, 0x00, 0x2e, 0x00, 0x44, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x48,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0x52, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0x58,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0x5c, 0xff, 0x6b, 0x00, 0x2e, 0x00, 0x6d,
-  0xff, 0x7d, 0x00, 0x2e, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x2e, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x2e, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x89,
-  0xff, 0x90, 0x00, 0x2e, 0x00, 0x94, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x95,
-  0xff, 0x90, 0x00, 0x2e, 0x00, 0x96, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x97,
-  0xff, 0x90, 0x00, 0x2e, 0x00, 0x98, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x9b,
-  0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9c, 0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9d,
-  0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9e, 0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9f,
-  0xff, 0xb7, 0x00, 0x2e, 0x00, 0xa2, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa3,
-  0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa4, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa5,
-  0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa6, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa7,
-  0xff, 0xdc, 0x00, 0x2e, 0x00, 0xaa, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xab,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xac, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xad,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb4, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb5,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb6, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb7,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb8, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbb,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbc, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbd,
-  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbe, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbf,
-  0xff, 0x6b, 0x00, 0x2e, 0x00, 0xc1, 0xff, 0x6b, 0x00, 0x2e, 0x00, 0xc8,
-  0xff, 0x90, 0x00, 0x2e, 0x00, 0xce, 0xff, 0x90, 0x00, 0x2e, 0x00, 0xdd,
-  0xff, 0x9a, 0x00, 0x2e, 0x01, 0x26, 0xff, 0x61, 0x00, 0x2e, 0x01, 0x30,
-  0xff, 0xc9, 0x00, 0x2e, 0x01, 0x31, 0xff, 0x9a, 0x00, 0x2e, 0x01, 0x3a,
-  0xff, 0xb7, 0x00, 0x2e, 0x07, 0x51, 0xff, 0xc1, 0x00, 0x2e, 0x07, 0x52,
-  0xff, 0xc1, 0x00, 0x2f, 0x00, 0x10, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0x24,
-  0x00, 0x2f, 0x00, 0x2f, 0x00, 0x32, 0xff, 0xb7, 0x00, 0x2f, 0x00, 0x37,
-  0xfe, 0xe6, 0x00, 0x2f, 0x00, 0x38, 0xff, 0x9a, 0x00, 0x2f, 0x00, 0x39,
-  0xff, 0x1f, 0x00, 0x2f, 0x00, 0x3a, 0xff, 0x44, 0x00, 0x2f, 0x00, 0x3c,
-  0xfe, 0xf0, 0x00, 0x2f, 0x00, 0x48, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0x52,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0x58, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0x5c,
-  0xff, 0x44, 0x00, 0x2f, 0x00, 0x82, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x83,
-  0x00, 0x2f, 0x00, 0x2f, 0x00, 0x84, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x85,
-  0x00, 0x2f, 0x00, 0x2f, 0x00, 0x86, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x94,
-  0xff, 0xb7, 0x00, 0x2f, 0x00, 0x95, 0xff, 0xb7, 0x00, 0x2f, 0x00, 0x96,
-  0xff, 0xb7, 0x00, 0x2f, 0x00, 0x97, 0xff, 0xb7, 0x00, 0x2f, 0x00, 0x98,
-  0xff, 0xb7, 0x00, 0x2f, 0x00, 0x9b, 0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9c,
-  0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9d, 0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9e,
-  0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9f, 0xfe, 0xf0, 0x00, 0x2f, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbb, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbc,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbd, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbe,
-  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbf, 0xff, 0x44, 0x00, 0x2f, 0x00, 0xc1,
-  0xff, 0x44, 0x00, 0x2f, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0x2f, 0x01, 0x26,
-  0xfe, 0xe6, 0x00, 0x2f, 0x01, 0x30, 0xff, 0x9a, 0x00, 0x2f, 0x01, 0x31,
-  0xff, 0xdc, 0x00, 0x2f, 0x01, 0x3a, 0xfe, 0xf0, 0x00, 0x2f, 0x07, 0x51,
-  0xfe, 0x61, 0x00, 0x2f, 0x07, 0x52, 0xfd, 0xe6, 0x00, 0x32, 0x00, 0x10,
-  0x00, 0x39, 0x00, 0x32, 0x00, 0x11, 0xff, 0xad, 0x00, 0x32, 0x00, 0x1d,
-  0xff, 0xdc, 0x00, 0x32, 0x00, 0x24, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x39,
-  0xff, 0xdc, 0x00, 0x32, 0x00, 0x3b, 0xff, 0x7d, 0x00, 0x32, 0x00, 0x3c,
-  0xff, 0x90, 0x00, 0x32, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x82,
-  0xff, 0xdc, 0x00, 0x32, 0x00, 0x83, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x84,
-  0xff, 0xdc, 0x00, 0x32, 0x00, 0x85, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x86,
-  0xff, 0xdc, 0x00, 0x32, 0x00, 0x9f, 0xff, 0x90, 0x00, 0x32, 0x01, 0x3a,
-  0xff, 0x90, 0x00, 0x32, 0x07, 0x51, 0xff, 0xd3, 0x00, 0x32, 0x07, 0x52,
-  0xff, 0xdc, 0x00, 0x32, 0x07, 0x53, 0xff, 0x44, 0x00, 0x33, 0x00, 0x10,
-  0xff, 0xd3, 0x00, 0x33, 0x00, 0x11, 0xfe, 0xc1, 0x00, 0x33, 0x00, 0x24,
-  0xff, 0x7d, 0x00, 0x33, 0x00, 0x3c, 0xff, 0xd3, 0x00, 0x33, 0x00, 0x44,
-  0xff, 0xa4, 0x00, 0x33, 0x00, 0x48, 0xff, 0xb7, 0x00, 0x33, 0x00, 0x4c,
-  0xff, 0xd3, 0x00, 0x33, 0x00, 0x51, 0xff, 0xdc, 0x00, 0x33, 0x00, 0x52,
-  0xff, 0xb7, 0x00, 0x33, 0x00, 0x55, 0xff, 0xdc, 0x00, 0x33, 0x00, 0x56,
-  0xff, 0xdc, 0x00, 0x33, 0x00, 0x58, 0xff, 0xdc, 0x00, 0x33, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0x33, 0x00, 0x82, 0xff, 0x7d, 0x00, 0x33, 0x00, 0x83,
-  0xff, 0x7d, 0x00, 0x33, 0x00, 0x84, 0xff, 0x7d, 0x00, 0x33, 0x00, 0x85,
-  0xff, 0x7d, 0x00, 0x33, 0x00, 0x86, 0xff, 0x7d, 0x00, 0x33, 0x00, 0x9f,
-  0xff, 0xd3, 0x00, 0x33, 0x00, 0xa2, 0xff, 0xa4, 0x00, 0x33, 0x00, 0xa3,
-  0xff, 0xa4, 0x00, 0x33, 0x00, 0xa4, 0xff, 0xa4, 0x00, 0x33, 0x00, 0xa5,
-  0xff, 0xa4, 0x00, 0x33, 0x00, 0xa6, 0xff, 0xa4, 0x00, 0x33, 0x00, 0xa7,
-  0xff, 0xa4, 0x00, 0x33, 0x00, 0xaa, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xab,
-  0xff, 0xb7, 0x00, 0x33, 0x00, 0xac, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xad,
-  0xff, 0xb7, 0x00, 0x33, 0x00, 0xb3, 0xff, 0xdc, 0x00, 0x33, 0x00, 0xb4,
-  0xff, 0xb7, 0x00, 0x33, 0x00, 0xb5, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xb6,
-  0xff, 0xb7, 0x00, 0x33, 0x00, 0xb7, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xb8,
-  0xff, 0xb7, 0x00, 0x33, 0x00, 0xbb, 0xff, 0xdc, 0x00, 0x33, 0x00, 0xbc,
-  0xff, 0xdc, 0x00, 0x33, 0x00, 0xbd, 0xff, 0xdc, 0x00, 0x33, 0x00, 0xbe,
-  0xff, 0xdc, 0x00, 0x33, 0x00, 0xdd, 0xff, 0xb7, 0x00, 0x33, 0x01, 0x0a,
-  0xff, 0xdc, 0x00, 0x33, 0x01, 0x17, 0xff, 0xdc, 0x00, 0x33, 0x01, 0x1b,
-  0xff, 0xdc, 0x00, 0x33, 0x01, 0x21, 0xff, 0xdc, 0x00, 0x33, 0x01, 0x23,
-  0xff, 0xdc, 0x00, 0x33, 0x01, 0x31, 0xff, 0xdc, 0x00, 0x33, 0x01, 0x3a,
-  0xff, 0xd3, 0x00, 0x33, 0x07, 0x51, 0x00, 0x26, 0x00, 0x33, 0x07, 0x52,
-  0x00, 0x26, 0x00, 0x33, 0x07, 0x53, 0xfe, 0xb7, 0x00, 0x34, 0x00, 0x10,
-  0x00, 0x39, 0x00, 0x34, 0x07, 0x51, 0xff, 0xd3, 0x00, 0x34, 0x07, 0x52,
-  0xff, 0xdc, 0x00, 0x34, 0x07, 0x53, 0xff, 0x7d, 0x00, 0x35, 0x00, 0x10,
-  0xff, 0xad, 0x00, 0x35, 0x00, 0x11, 0xff, 0xb7, 0x00, 0x35, 0x00, 0x1d,
-  0xff, 0xc1, 0x00, 0x35, 0x00, 0x24, 0xff, 0xad, 0x00, 0x35, 0x00, 0x26,
-  0xff, 0x9a, 0x00, 0x35, 0x00, 0x37, 0xff, 0x6b, 0x00, 0x35, 0x00, 0x39,
-  0xff, 0x90, 0x00, 0x35, 0x00, 0x3a, 0xff, 0xad, 0x00, 0x35, 0x00, 0x3c,
-  0xff, 0x7d, 0x00, 0x35, 0x00, 0x44, 0xff, 0xd3, 0x00, 0x35, 0x00, 0x48,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0x52, 0xff, 0xa4, 0x00, 0x35, 0x00, 0x58,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0x5c, 0xff, 0x90, 0x00, 0x35, 0x00, 0x6d,
-  0xff, 0x90, 0x00, 0x35, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x35, 0x00, 0x82,
-  0xff, 0xad, 0x00, 0x35, 0x00, 0x83, 0xff, 0xad, 0x00, 0x35, 0x00, 0x84,
-  0xff, 0xad, 0x00, 0x35, 0x00, 0x85, 0xff, 0xad, 0x00, 0x35, 0x00, 0x86,
-  0xff, 0xad, 0x00, 0x35, 0x00, 0x89, 0xff, 0x9a, 0x00, 0x35, 0x00, 0x9f,
-  0xff, 0x7d, 0x00, 0x35, 0x00, 0xa2, 0xff, 0xd3, 0x00, 0x35, 0x00, 0xa3,
-  0xff, 0xd3, 0x00, 0x35, 0x00, 0xa4, 0xff, 0xd3, 0x00, 0x35, 0x00, 0xa5,
-  0xff, 0xd3, 0x00, 0x35, 0x00, 0xa6, 0xff, 0xd3, 0x00, 0x35, 0x00, 0xa7,
-  0xff, 0xd3, 0x00, 0x35, 0x00, 0xaa, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xab,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0xac, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xad,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0xb4, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xb5,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0xb6, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xb7,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0xb8, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xbb,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0xbc, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xbd,
-  0xff, 0xa4, 0x00, 0x35, 0x00, 0xbe, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xbf,
-  0xff, 0x90, 0x00, 0x35, 0x00, 0xc1, 0xff, 0x90, 0x00, 0x35, 0x00, 0xc8,
-  0xff, 0x9a, 0x00, 0x35, 0x00, 0xce, 0xff, 0x9a, 0x00, 0x35, 0x00, 0xdd,
-  0xff, 0xa4, 0x00, 0x35, 0x01, 0x26, 0xff, 0x6b, 0x00, 0x35, 0x01, 0x31,
-  0xff, 0xa4, 0x00, 0x35, 0x01, 0x3a, 0xff, 0x7d, 0x00, 0x35, 0x07, 0x51,
-  0xff, 0x6b, 0x00, 0x35, 0x07, 0x52, 0xff, 0x7d, 0x00, 0x35, 0x07, 0x53,
-  0xff, 0xdc, 0x00, 0x36, 0x00, 0x24, 0x00, 0x26, 0x00, 0x36, 0x00, 0x82,
-  0x00, 0x26, 0x00, 0x36, 0x00, 0x83, 0x00, 0x26, 0x00, 0x36, 0x00, 0x84,
-  0x00, 0x26, 0x00, 0x36, 0x00, 0x85, 0x00, 0x26, 0x00, 0x36, 0x00, 0x86,
-  0x00, 0x26, 0x00, 0x37, 0x00, 0x10, 0xff, 0x44, 0x00, 0x37, 0x00, 0x11,
-  0xff, 0x0d, 0x00, 0x37, 0x00, 0x1d, 0xff, 0x1f, 0x00, 0x37, 0x00, 0x24,
-  0xff, 0x61, 0x00, 0x37, 0x00, 0x26, 0xff, 0x88, 0x00, 0x37, 0x00, 0x37,
-  0xff, 0xdc, 0x00, 0x37, 0x00, 0x44, 0xfe, 0xad, 0x00, 0x37, 0x00, 0x46,
-  0xfe, 0xa4, 0x00, 0x37, 0x00, 0x48, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0x4c,
-  0xff, 0xc1, 0x00, 0x37, 0x00, 0x52, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0x55,
-  0xfe, 0xd3, 0x00, 0x37, 0x00, 0x56, 0xfe, 0xad, 0x00, 0x37, 0x00, 0x58,
-  0xfe, 0xc9, 0x00, 0x37, 0x00, 0x5a, 0xfe, 0xad, 0x00, 0x37, 0x00, 0x5c,
-  0xfe, 0xc1, 0x00, 0x37, 0x00, 0x6d, 0xff, 0x44, 0x00, 0x37, 0x00, 0x7d,
-  0xff, 0x90, 0x00, 0x37, 0x00, 0x82, 0xff, 0x61, 0x00, 0x37, 0x00, 0x83,
-  0xff, 0x61, 0x00, 0x37, 0x00, 0x84, 0xff, 0x61, 0x00, 0x37, 0x00, 0x85,
-  0xff, 0x61, 0x00, 0x37, 0x00, 0x86, 0xff, 0x61, 0x00, 0x37, 0x00, 0x89,
-  0xff, 0x88, 0x00, 0x37, 0x00, 0xa2, 0xff, 0x11, 0x00, 0x37, 0x00, 0xa3,
-  0xfe, 0xad, 0x00, 0x37, 0x00, 0xa4, 0xff, 0x11, 0x00, 0x37, 0x00, 0xa5,
-  0xff, 0x11, 0x00, 0x37, 0x00, 0xa6, 0xff, 0x11, 0x00, 0x37, 0x00, 0xa7,
-  0xff, 0x11, 0x00, 0x37, 0x00, 0xa9, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0xaa,
-  0xfe, 0xe0, 0x00, 0x37, 0x00, 0xab, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0xac,
-  0xfe, 0xe0, 0x00, 0x37, 0x00, 0xad, 0xfe, 0xe0, 0x00, 0x37, 0x00, 0xb4,
-  0xfe, 0xf4, 0x00, 0x37, 0x00, 0xb5, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0xb6,
-  0xfe, 0xf4, 0x00, 0x37, 0x00, 0xb7, 0xfe, 0xf4, 0x00, 0x37, 0x00, 0xb8,
-  0xfe, 0xf4, 0x00, 0x37, 0x00, 0xbb, 0xfe, 0xe7, 0x00, 0x37, 0x00, 0xbc,
-  0xfe, 0xc9, 0x00, 0x37, 0x00, 0xbd, 0xfe, 0xe7, 0x00, 0x37, 0x00, 0xbe,
-  0xfe, 0xe7, 0x00, 0x37, 0x00, 0xbf, 0xfe, 0xc1, 0x00, 0x37, 0x00, 0xc1,
-  0xfe, 0xc1, 0x00, 0x37, 0x00, 0xc8, 0xff, 0x88, 0x00, 0x37, 0x00, 0xc9,
-  0xfe, 0xa4, 0x00, 0x37, 0x00, 0xce, 0xff, 0x88, 0x00, 0x37, 0x00, 0xcf,
-  0xfe, 0xa4, 0x00, 0x37, 0x00, 0xdd, 0xfe, 0xa4, 0x00, 0x37, 0x01, 0x17,
-  0xfe, 0xd3, 0x00, 0x37, 0x01, 0x1b, 0xfe, 0xd3, 0x00, 0x37, 0x01, 0x21,
-  0xfe, 0xad, 0x00, 0x37, 0x01, 0x23, 0xfe, 0xad, 0x00, 0x37, 0x01, 0x26,
-  0xff, 0xdc, 0x00, 0x37, 0x01, 0x31, 0xfe, 0xc9, 0x00, 0x37, 0x07, 0x52,
-  0xff, 0xd3, 0x00, 0x37, 0x07, 0x53, 0xfe, 0xf8, 0x00, 0x38, 0x00, 0x3d,
-  0xff, 0xdc, 0x00, 0x38, 0x01, 0x3f, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x10,
-  0xff, 0x88, 0x00, 0x39, 0x00, 0x11, 0xfe, 0xf8, 0x00, 0x39, 0x00, 0x1d,
-  0xff, 0x59, 0x00, 0x39, 0x00, 0x24, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x32,
-  0xff, 0xdc, 0x00, 0x39, 0x00, 0x44, 0xff, 0x61, 0x00, 0x39, 0x00, 0x48,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0x4c, 0xff, 0xd3, 0x00, 0x39, 0x00, 0x52,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0x58, 0xff, 0x75, 0x00, 0x39, 0x00, 0x5c,
-  0xff, 0xc9, 0x00, 0x39, 0x00, 0x6d, 0xff, 0x4e, 0x00, 0x39, 0x00, 0x7d,
-  0xff, 0x90, 0x00, 0x39, 0x00, 0x82, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x83,
-  0xff, 0x7d, 0x00, 0x39, 0x00, 0x84, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x85,
-  0xff, 0x7d, 0x00, 0x39, 0x00, 0x86, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x94,
-  0xff, 0xdc, 0x00, 0x39, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x96,
-  0xff, 0xdc, 0x00, 0x39, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x98,
-  0xff, 0xdc, 0x00, 0x39, 0x00, 0xa2, 0xff, 0x61, 0x00, 0x39, 0x00, 0xa3,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0xa4, 0xff, 0x61, 0x00, 0x39, 0x00, 0xa5,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0xa6, 0xff, 0x61, 0x00, 0x39, 0x00, 0xa7,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0xaa, 0xff, 0x61, 0x00, 0x39, 0x00, 0xab,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0xac, 0xff, 0x61, 0x00, 0x39, 0x00, 0xad,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0xb4, 0xff, 0x61, 0x00, 0x39, 0x00, 0xb5,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0xb6, 0xff, 0x61, 0x00, 0x39, 0x00, 0xb7,
-  0xff, 0x61, 0x00, 0x39, 0x00, 0xb8, 0xff, 0x61, 0x00, 0x39, 0x00, 0xbb,
-  0xff, 0x75, 0x00, 0x39, 0x00, 0xbc, 0xff, 0x75, 0x00, 0x39, 0x00, 0xbd,
-  0xff, 0x75, 0x00, 0x39, 0x00, 0xbe, 0xff, 0x75, 0x00, 0x39, 0x00, 0xbf,
-  0xff, 0xc9, 0x00, 0x39, 0x00, 0xc1, 0xff, 0xc9, 0x00, 0x39, 0x00, 0xdd,
-  0xff, 0x61, 0x00, 0x39, 0x01, 0x31, 0xff, 0x75, 0x00, 0x39, 0x07, 0x53,
-  0xfe, 0xe6, 0x00, 0x3a, 0x00, 0x10, 0xff, 0xad, 0x00, 0x3a, 0x00, 0x11,
-  0xff, 0x15, 0x00, 0x3a, 0x00, 0x1d, 0xff, 0x88, 0x00, 0x3a, 0x00, 0x24,
-  0xff, 0x90, 0x00, 0x3a, 0x00, 0x44, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0x48,
-  0xff, 0x88, 0x00, 0x3a, 0x00, 0x4c, 0xff, 0xd3, 0x00, 0x3a, 0x00, 0x52,
-  0xff, 0x88, 0x00, 0x3a, 0x00, 0x55, 0xff, 0xa4, 0x00, 0x3a, 0x00, 0x58,
-  0xff, 0xb7, 0x00, 0x3a, 0x00, 0x5c, 0xff, 0xdc, 0x00, 0x3a, 0x00, 0x6d,
-  0xff, 0x90, 0x00, 0x3a, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x3a, 0x00, 0x82,
-  0xff, 0x90, 0x00, 0x3a, 0x00, 0x83, 0xff, 0x90, 0x00, 0x3a, 0x00, 0x84,
-  0xff, 0x90, 0x00, 0x3a, 0x00, 0x85, 0xff, 0x90, 0x00, 0x3a, 0x00, 0x86,
-  0xff, 0x90, 0x00, 0x3a, 0x00, 0xa2, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa3,
-  0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa4, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa5,
-  0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa6, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa7,
-  0xff, 0x7d, 0x00, 0x3a, 0x00, 0xaa, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xab,
-  0xff, 0x88, 0x00, 0x3a, 0x00, 0xac, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xad,
-  0xff, 0x88, 0x00, 0x3a, 0x00, 0xb4, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xb5,
-  0xff, 0x88, 0x00, 0x3a, 0x00, 0xb6, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xb7,
-  0xff, 0x88, 0x00, 0x3a, 0x00, 0xb8, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xbb,
-  0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbc, 0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbd,
-  0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbe, 0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbf,
-  0xff, 0xdc, 0x00, 0x3a, 0x00, 0xc1, 0xff, 0xdc, 0x00, 0x3a, 0x00, 0xdd,
-  0xff, 0x88, 0x00, 0x3a, 0x01, 0x17, 0xff, 0xa4, 0x00, 0x3a, 0x01, 0x1b,
-  0xff, 0xa4, 0x00, 0x3a, 0x01, 0x31, 0xff, 0xb7, 0x00, 0x3a, 0x07, 0x51,
-  0xff, 0xdc, 0x00, 0x3a, 0x07, 0x53, 0xfe, 0xf8, 0x00, 0x3b, 0x00, 0x10,
-  0xff, 0x9a, 0x00, 0x3b, 0x00, 0x26, 0xff, 0x6b, 0x00, 0x3b, 0x00, 0x32,
-  0xff, 0x7d, 0x00, 0x3b, 0x00, 0x37, 0xff, 0xdc, 0x00, 0x3b, 0x00, 0x48,
-  0xff, 0xa4, 0x00, 0x3b, 0x00, 0x6d, 0xff, 0x90, 0x00, 0x3b, 0x00, 0x89,
-  0xff, 0x6b, 0x00, 0x3b, 0x00, 0x94, 0xff, 0x7d, 0x00, 0x3b, 0x00, 0x95,
-  0xff, 0x7d, 0x00, 0x3b, 0x00, 0x96, 0xff, 0x7d, 0x00, 0x3b, 0x00, 0x97,
-  0xff, 0x7d, 0x00, 0x3b, 0x00, 0x98, 0xff, 0x7d, 0x00, 0x3b, 0x00, 0xaa,
-  0xff, 0xa4, 0x00, 0x3b, 0x00, 0xab, 0xff, 0xa4, 0x00, 0x3b, 0x00, 0xac,
-  0xff, 0xa4, 0x00, 0x3b, 0x00, 0xad, 0xff, 0xa4, 0x00, 0x3b, 0x00, 0xc8,
-  0xff, 0x6b, 0x00, 0x3b, 0x00, 0xce, 0xff, 0x6b, 0x00, 0x3b, 0x00, 0xdd,
-  0xff, 0xa4, 0x00, 0x3b, 0x01, 0x26, 0xff, 0xdc, 0x00, 0x3b, 0x07, 0x51,
-  0xff, 0x61, 0x00, 0x3b, 0x07, 0x52, 0xff, 0xad, 0x00, 0x3b, 0x07, 0x53,
-  0xff, 0xd3, 0x00, 0x3c, 0x00, 0x10, 0xff, 0x0d, 0x00, 0x3c, 0x00, 0x11,
-  0xfe, 0x61, 0x00, 0x3c, 0x00, 0x1d, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0x24,
-  0xff, 0x61, 0x00, 0x3c, 0x00, 0x26, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x32,
-  0xff, 0x90, 0x00, 0x3c, 0x00, 0x44, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0x48,
-  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0x4c, 0xff, 0xb7, 0x00, 0x3c, 0x00, 0x52,
-  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0x58, 0xff, 0x15, 0x00, 0x3c, 0x00, 0x6d,
-  0xff, 0x1f, 0x00, 0x3c, 0x00, 0x7d, 0xff, 0x6b, 0x00, 0x3c, 0x00, 0x82,
-  0xff, 0x61, 0x00, 0x3c, 0x00, 0x83, 0xff, 0x61, 0x00, 0x3c, 0x00, 0x84,
-  0xff, 0x61, 0x00, 0x3c, 0x00, 0x85, 0xff, 0x61, 0x00, 0x3c, 0x00, 0x86,
-  0xff, 0x61, 0x00, 0x3c, 0x00, 0x89, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x94,
-  0xff, 0x90, 0x00, 0x3c, 0x00, 0x95, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x96,
-  0xff, 0x90, 0x00, 0x3c, 0x00, 0x97, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x98,
-  0xff, 0x90, 0x00, 0x3c, 0x00, 0xa2, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa3,
-  0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa4, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa5,
-  0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa6, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa7,
-  0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xaa, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xab,
-  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xac, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xad,
-  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb4, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb5,
-  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb6, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb7,
-  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb8, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xbb,
-  0xff, 0x15, 0x00, 0x3c, 0x00, 0xbc, 0xff, 0x15, 0x00, 0x3c, 0x00, 0xbd,
-  0xff, 0x15, 0x00, 0x3c, 0x00, 0xbe, 0xff, 0x15, 0x00, 0x3c, 0x00, 0xc8,
-  0xff, 0x90, 0x00, 0x3c, 0x00, 0xce, 0xff, 0x90, 0x00, 0x3c, 0x00, 0xdd,
-  0xfe, 0xf0, 0x00, 0x3c, 0x01, 0x31, 0xff, 0x15, 0x00, 0x3c, 0x07, 0x51,
-  0xff, 0x90, 0x00, 0x3c, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x3c, 0x07, 0x53,
-  0xfe, 0xf8, 0x00, 0x3d, 0x00, 0x10, 0xff, 0xdc, 0x00, 0x3d, 0x07, 0x51,
-  0xff, 0xdc, 0x00, 0x3d, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x3d, 0x07, 0x53,
-  0xff, 0xdc, 0x00, 0x48, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0x49, 0x00, 0x10,
-  0xff, 0x90, 0x00, 0x49, 0x00, 0x11, 0xff, 0x6b, 0x00, 0x49, 0x00, 0x1d,
-  0xff, 0xb7, 0x00, 0x49, 0x00, 0x57, 0xff, 0xdc, 0x00, 0x49, 0x00, 0x5a,
-  0xff, 0xdc, 0x00, 0x49, 0x00, 0x5c, 0xff, 0xdc, 0x00, 0x49, 0x00, 0x6d,
-  0xff, 0xb7, 0x00, 0x49, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x49, 0x00, 0xbf,
-  0xff, 0xdc, 0x00, 0x49, 0x00, 0xc1, 0xff, 0xdc, 0x00, 0x49, 0x01, 0x27,
-  0xff, 0xdc, 0x00, 0x49, 0x07, 0x51, 0x00, 0x41, 0x00, 0x49, 0x07, 0x53,
-  0xff, 0x15, 0x00, 0x4e, 0x00, 0x44, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0x48,
-  0xff, 0xb7, 0x00, 0x4e, 0x00, 0x52, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0x58,
-  0xff, 0xc1, 0x00, 0x4e, 0x00, 0x5c, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xa2,
-  0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa3, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa4,
-  0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa5, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa6,
-  0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa7, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0xaa,
-  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xab, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xac,
-  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xad, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb4,
-  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb5, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb6,
-  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb7, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb8,
-  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xbb, 0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbc,
-  0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbd, 0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbe,
-  0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbf, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xc1,
-  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xdd, 0xff, 0xb7, 0x00, 0x4e, 0x01, 0x31,
-  0xff, 0xc1, 0x00, 0x51, 0x07, 0x51, 0xff, 0x6b, 0x00, 0x51, 0x07, 0x52,
-  0xff, 0x90, 0x00, 0x51, 0x07, 0x53, 0xff, 0xa4, 0x00, 0x52, 0x00, 0x10,
-  0x00, 0x26, 0x00, 0x52, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x52, 0x00, 0x5b,
-  0xff, 0xc1, 0x00, 0x52, 0x07, 0x51, 0xff, 0x6b, 0x00, 0x52, 0x07, 0x52,
-  0xff, 0xb7, 0x00, 0x52, 0x07, 0x53, 0xff, 0x7d, 0x00, 0x55, 0x00, 0x10,
-  0xff, 0x7d, 0x00, 0x55, 0x00, 0x11, 0xff, 0x44, 0x00, 0x55, 0x00, 0x1d,
-  0xff, 0xdc, 0x00, 0x55, 0x00, 0x46, 0xff, 0xd3, 0x00, 0x55, 0x00, 0x47,
-  0xff, 0xdc, 0x00, 0x55, 0x00, 0x48, 0xff, 0xd3, 0x00, 0x55, 0x00, 0x4a,
-  0xff, 0xdc, 0x00, 0x55, 0x00, 0x4b, 0xff, 0xdc, 0x00, 0x55, 0x00, 0x50,
-  0xff, 0xdc, 0x00, 0x55, 0x00, 0x51, 0xff, 0xdc, 0x00, 0x55, 0x00, 0x52,
-  0xff, 0xd3, 0x00, 0x55, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x55, 0x00, 0x55,
-  0xff, 0xdc, 0x00, 0x55, 0x00, 0x5b, 0xff, 0xc9, 0x00, 0x55, 0x00, 0x6d,
-  0xff, 0xb7, 0x00, 0x55, 0x00, 0xa9, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xaa,
-  0xff, 0xd3, 0x00, 0x55, 0x00, 0xab, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xac,
-  0xff, 0xd3, 0x00, 0x55, 0x00, 0xad, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xb3,
-  0xff, 0xdc, 0x00, 0x55, 0x00, 0xb4, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xb5,
-  0xff, 0xd3, 0x00, 0x55, 0x00, 0xb6, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xb7,
-  0xff, 0xd3, 0x00, 0x55, 0x00, 0xb8, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xc9,
-  0xff, 0xd3, 0x00, 0x55, 0x00, 0xcf, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xd1,
-  0x00, 0x48, 0x00, 0x55, 0x00, 0xdd, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xe1,
-  0xff, 0xdc, 0x00, 0x55, 0x01, 0x0a, 0xff, 0xdc, 0x00, 0x55, 0x01, 0x17,
-  0xff, 0xdc, 0x00, 0x55, 0x01, 0x1b, 0xff, 0xdc, 0x00, 0x55, 0x07, 0x52,
-  0x00, 0x56, 0x00, 0x55, 0x07, 0x53, 0xfe, 0xc9, 0x00, 0x59, 0x00, 0x10,
-  0xff, 0xc9, 0x00, 0x59, 0x00, 0x11, 0xff, 0x61, 0x00, 0x59, 0x00, 0x1d,
-  0xff, 0x90, 0x00, 0x59, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x59, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x59, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x59, 0x07, 0x53,
-  0xfe, 0xf0, 0x00, 0x5a, 0x00, 0x11, 0xff, 0x44, 0x00, 0x5a, 0x00, 0x1d,
-  0xff, 0x90, 0x00, 0x5a, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x5a, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x5a, 0x07, 0x53, 0xff, 0x29, 0x00, 0x5b, 0x00, 0x46,
-  0xff, 0xdc, 0x00, 0x5b, 0x00, 0x48, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0x52,
-  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x5b, 0x00, 0xaa,
-  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xab, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xac,
-  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xad, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb4,
-  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb5, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb6,
-  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb7, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb8,
-  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x5b, 0x00, 0xcf,
-  0xff, 0xdc, 0x00, 0x5b, 0x00, 0xdd, 0xff, 0xc1, 0x00, 0x5c, 0x00, 0x10,
-  0xff, 0xdc, 0x00, 0x5c, 0x00, 0x11, 0xfe, 0xdc, 0x00, 0x5c, 0x00, 0x1d,
-  0xff, 0x6b, 0x00, 0x5c, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x5c, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x5c, 0x07, 0x53, 0xfe, 0xd3, 0x00, 0x6d, 0x00, 0x25,
-  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x27,
-  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x2d,
-  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x37, 0xff, 0x90, 0x00, 0x6d, 0x00, 0x39,
-  0xff, 0x90, 0x00, 0x6d, 0x00, 0x3a, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x3c,
-  0xff, 0x6b, 0x00, 0x6d, 0x00, 0x59, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x5a,
-  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x5c, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x88,
-  0x00, 0x97, 0x00, 0x6d, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x9f,
-  0xff, 0x6b, 0x00, 0x6d, 0x00, 0xbf, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0xc1,
-  0xff, 0xdc, 0x00, 0x6d, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0xce,
-  0xff, 0xdc, 0x00, 0x6d, 0x00, 0xd0, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0xe0,
-  0xff, 0xdc, 0x00, 0x6d, 0x01, 0x26, 0xff, 0x90, 0x00, 0x6d, 0x01, 0x3a,
-  0xff, 0x6b, 0x00, 0x7d, 0x00, 0x24, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x25,
-  0xff, 0xb7, 0x00, 0x7d, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x27,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x2d, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x32,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x37, 0xff, 0x44, 0x00, 0x7d, 0x00, 0x39,
-  0xff, 0x4e, 0x00, 0x7d, 0x00, 0x3a, 0xff, 0x90, 0x00, 0x7d, 0x00, 0x3b,
-  0xff, 0x90, 0x00, 0x7d, 0x00, 0x3c, 0xff, 0x1f, 0x00, 0x7d, 0x00, 0x59,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x5a, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x5c,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x82, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x83,
-  0xff, 0xb7, 0x00, 0x7d, 0x00, 0x84, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x85,
-  0xff, 0xb7, 0x00, 0x7d, 0x00, 0x86, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x89,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x95,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x97,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x9f,
-  0xff, 0x1f, 0x00, 0x7d, 0x00, 0xbf, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0xc1,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0xce,
-  0xff, 0xdc, 0x00, 0x7d, 0x00, 0xd0, 0xff, 0xdc, 0x00, 0x7d, 0x01, 0x26,
-  0xff, 0x44, 0x00, 0x7d, 0x01, 0x3a, 0xff, 0x1f, 0x00, 0x82, 0x00, 0x10,
-  0xff, 0xd3, 0x00, 0x82, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x1d,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x24, 0x00, 0x39, 0x00, 0x82, 0x00, 0x26,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x32,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x37,
-  0xff, 0x61, 0x00, 0x82, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x82, 0x00, 0x3a,
-  0xff, 0x90, 0x00, 0x82, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x82, 0x00, 0x46,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x48,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x82, 0x00, 0x52,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x57,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x59, 0xff, 0x88, 0x00, 0x82, 0x00, 0x5a,
-  0xff, 0xad, 0x00, 0x82, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x82, 0x00, 0x6d,
-  0xff, 0xb7, 0x00, 0x82, 0x00, 0x82, 0x00, 0x39, 0x00, 0x82, 0x00, 0x83,
-  0x00, 0x39, 0x00, 0x82, 0x00, 0x84, 0x00, 0x39, 0x00, 0x82, 0x00, 0x85,
-  0x00, 0x39, 0x00, 0x82, 0x00, 0x86, 0x00, 0x39, 0x00, 0x82, 0x00, 0x89,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x95,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x97,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x9f,
-  0xff, 0x61, 0x00, 0x82, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x82, 0x00, 0xc1,
-  0xff, 0x75, 0x00, 0x82, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x82, 0x00, 0xc4,
-  0x00, 0x39, 0x00, 0x82, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x82, 0x00, 0xc8,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xca,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xcd,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xcf,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xd5,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xd9,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xdd,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xe0,
-  0xff, 0xdc, 0x00, 0x82, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x0e,
-  0xff, 0xdc, 0x00, 0x82, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x10,
-  0xff, 0xdc, 0x00, 0x82, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x12,
-  0xff, 0xdc, 0x00, 0x82, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x24,
-  0xff, 0x61, 0x00, 0x82, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x26,
-  0xff, 0x61, 0x00, 0x82, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x36,
-  0xff, 0x90, 0x00, 0x82, 0x01, 0x37, 0xff, 0xad, 0x00, 0x82, 0x01, 0x38,
-  0xff, 0x61, 0x00, 0x82, 0x01, 0x39, 0xff, 0x75, 0x00, 0x82, 0x01, 0x3a,
-  0xff, 0x61, 0x00, 0x82, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x82, 0x01, 0xf1,
-  0xff, 0xdc, 0x00, 0x82, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x82, 0x05, 0xd3,
-  0xff, 0xad, 0x00, 0x82, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x82, 0x05, 0xd5,
-  0xff, 0xad, 0x00, 0x82, 0x06, 0x42, 0xff, 0x61, 0x00, 0x82, 0x06, 0x43,
-  0xff, 0x75, 0x00, 0x82, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x82, 0x07, 0x52,
-  0xff, 0x03, 0x00, 0x82, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x83, 0x00, 0x10,
-  0xff, 0xd3, 0x00, 0x83, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x1d,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x24, 0x00, 0x39, 0x00, 0x83, 0x00, 0x26,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x32,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x37,
-  0xff, 0x61, 0x00, 0x83, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x83, 0x00, 0x3a,
-  0xff, 0x90, 0x00, 0x83, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x83, 0x00, 0x46,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x48,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x83, 0x00, 0x52,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x57,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x59, 0xff, 0x88, 0x00, 0x83, 0x00, 0x5a,
-  0xff, 0xad, 0x00, 0x83, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x83, 0x00, 0x6d,
-  0xff, 0xb7, 0x00, 0x83, 0x00, 0x82, 0x00, 0x39, 0x00, 0x83, 0x00, 0x83,
-  0x00, 0x39, 0x00, 0x83, 0x00, 0x84, 0x00, 0x39, 0x00, 0x83, 0x00, 0x85,
-  0x00, 0x39, 0x00, 0x83, 0x00, 0x86, 0x00, 0x39, 0x00, 0x83, 0x00, 0x89,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x95,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x97,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x9f,
-  0xff, 0x61, 0x00, 0x83, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x83, 0x00, 0xc1,
-  0xff, 0x75, 0x00, 0x83, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x83, 0x00, 0xc4,
-  0x00, 0x39, 0x00, 0x83, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x83, 0x00, 0xc8,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xca,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xcd,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xcf,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xd5,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xd9,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xdd,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xe0,
-  0xff, 0xdc, 0x00, 0x83, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x0e,
-  0xff, 0xdc, 0x00, 0x83, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x10,
-  0xff, 0xdc, 0x00, 0x83, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x12,
-  0xff, 0xdc, 0x00, 0x83, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x24,
-  0xff, 0x61, 0x00, 0x83, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x26,
-  0xff, 0x61, 0x00, 0x83, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x36,
-  0xff, 0x90, 0x00, 0x83, 0x01, 0x37, 0xff, 0xad, 0x00, 0x83, 0x01, 0x38,
-  0xff, 0x61, 0x00, 0x83, 0x01, 0x39, 0xff, 0x75, 0x00, 0x83, 0x01, 0x3a,
-  0xff, 0x61, 0x00, 0x83, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x83, 0x01, 0xf1,
-  0xff, 0xdc, 0x00, 0x83, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x83, 0x05, 0xd2,
-  0xff, 0x90, 0x00, 0x83, 0x05, 0xd3, 0xff, 0xad, 0x00, 0x83, 0x05, 0xd4,
-  0xff, 0x90, 0x00, 0x83, 0x05, 0xd5, 0xff, 0xad, 0x00, 0x83, 0x06, 0x42,
-  0xff, 0x61, 0x00, 0x83, 0x06, 0x43, 0xff, 0x75, 0x00, 0x83, 0x07, 0x51,
-  0xfe, 0xf8, 0x00, 0x83, 0x07, 0x52, 0xff, 0x03, 0x00, 0x83, 0x07, 0x53,
-  0x00, 0x2f, 0x00, 0x84, 0x00, 0x10, 0xff, 0xd3, 0x00, 0x84, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x24,
-  0x00, 0x39, 0x00, 0x84, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x2a,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x32, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x34,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x37, 0xff, 0x61, 0x00, 0x84, 0x00, 0x39,
-  0xff, 0x7d, 0x00, 0x84, 0x00, 0x3a, 0xff, 0x90, 0x00, 0x84, 0x00, 0x3c,
-  0xff, 0x61, 0x00, 0x84, 0x00, 0x46, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x47,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x48, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x49,
-  0xff, 0xb7, 0x00, 0x84, 0x00, 0x52, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x54,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x57, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x59,
-  0xff, 0x88, 0x00, 0x84, 0x00, 0x5a, 0xff, 0xad, 0x00, 0x84, 0x00, 0x5c,
-  0xff, 0x75, 0x00, 0x84, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0x84, 0x00, 0x82,
-  0x00, 0x39, 0x00, 0x84, 0x00, 0x83, 0x00, 0x39, 0x00, 0x84, 0x00, 0x84,
-  0x00, 0x39, 0x00, 0x84, 0x00, 0x85, 0x00, 0x39, 0x00, 0x84, 0x00, 0x86,
-  0x00, 0x39, 0x00, 0x84, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x94,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x96,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x98,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0x9f, 0xff, 0x61, 0x00, 0x84, 0x00, 0xa9,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xab,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xac, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xad,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xb5,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xb7,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xbf,
-  0xff, 0x75, 0x00, 0x84, 0x00, 0xc1, 0xff, 0x75, 0x00, 0x84, 0x00, 0xc2,
-  0x00, 0x39, 0x00, 0x84, 0x00, 0xc4, 0x00, 0x39, 0x00, 0x84, 0x00, 0xc6,
-  0x00, 0x39, 0x00, 0x84, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xc9,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xca, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xcc,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xcd, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xce,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xcf, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xd1,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xd7,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xdb,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xde,
-  0xff, 0xdc, 0x00, 0x84, 0x00, 0xe0, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xe2,
-  0xff, 0xdc, 0x00, 0x84, 0x01, 0x0e, 0xff, 0xdc, 0x00, 0x84, 0x01, 0x0f,
-  0xff, 0xdc, 0x00, 0x84, 0x01, 0x10, 0xff, 0xdc, 0x00, 0x84, 0x01, 0x11,
-  0xff, 0xdc, 0x00, 0x84, 0x01, 0x12, 0xff, 0xdc, 0x00, 0x84, 0x01, 0x13,
-  0xff, 0xdc, 0x00, 0x84, 0x01, 0x24, 0xff, 0x61, 0x00, 0x84, 0x01, 0x25,
-  0xff, 0xdc, 0x00, 0x84, 0x01, 0x26, 0xff, 0x61, 0x00, 0x84, 0x01, 0x27,
-  0xff, 0xdc, 0x00, 0x84, 0x01, 0x36, 0xff, 0x90, 0x00, 0x84, 0x01, 0x37,
-  0xff, 0xad, 0x00, 0x84, 0x01, 0x38, 0xff, 0x61, 0x00, 0x84, 0x01, 0x39,
-  0xff, 0x75, 0x00, 0x84, 0x01, 0x3a, 0xff, 0x61, 0x00, 0x84, 0x01, 0xf0,
-  0xff, 0xdc, 0x00, 0x84, 0x01, 0xf1, 0xff, 0xdc, 0x00, 0x84, 0x05, 0xd0,
-  0xff, 0x90, 0x00, 0x84, 0x05, 0xd2, 0xff, 0x90, 0x00, 0x84, 0x05, 0xd3,
-  0xff, 0xad, 0x00, 0x84, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x84, 0x05, 0xd5,
-  0xff, 0xad, 0x00, 0x84, 0x06, 0x42, 0xff, 0x61, 0x00, 0x84, 0x06, 0x43,
-  0xff, 0x75, 0x00, 0x84, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x84, 0x07, 0x52,
-  0xff, 0x03, 0x00, 0x84, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x85, 0x00, 0x10,
-  0xff, 0xd3, 0x00, 0x85, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x1d,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x24, 0x00, 0x39, 0x00, 0x85, 0x00, 0x26,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x32,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x37,
-  0xff, 0x61, 0x00, 0x85, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x85, 0x00, 0x3a,
-  0xff, 0x90, 0x00, 0x85, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x85, 0x00, 0x46,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x48,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x85, 0x00, 0x52,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x57,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x59, 0xff, 0x88, 0x00, 0x85, 0x00, 0x5a,
-  0xff, 0xad, 0x00, 0x85, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x85, 0x00, 0x6d,
-  0xff, 0xb7, 0x00, 0x85, 0x00, 0x82, 0x00, 0x39, 0x00, 0x85, 0x00, 0x83,
-  0x00, 0x39, 0x00, 0x85, 0x00, 0x84, 0x00, 0x39, 0x00, 0x85, 0x00, 0x85,
-  0x00, 0x39, 0x00, 0x85, 0x00, 0x86, 0x00, 0x39, 0x00, 0x85, 0x00, 0x89,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x95,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x97,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x9f,
-  0xff, 0x61, 0x00, 0x85, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x85, 0x00, 0xc1,
-  0xff, 0x75, 0x00, 0x85, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x85, 0x00, 0xc4,
-  0x00, 0x39, 0x00, 0x85, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x85, 0x00, 0xc8,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xca,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xcd,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xcf,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xd5,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xd9,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xdd,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xe0,
-  0xff, 0xdc, 0x00, 0x85, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x0e,
-  0xff, 0xdc, 0x00, 0x85, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x10,
-  0xff, 0xdc, 0x00, 0x85, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x12,
-  0xff, 0xdc, 0x00, 0x85, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x24,
-  0xff, 0x61, 0x00, 0x85, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x26,
-  0xff, 0x61, 0x00, 0x85, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x36,
-  0xff, 0x90, 0x00, 0x85, 0x01, 0x37, 0xff, 0xad, 0x00, 0x85, 0x01, 0x38,
-  0xff, 0x61, 0x00, 0x85, 0x01, 0x39, 0xff, 0x75, 0x00, 0x85, 0x01, 0x3a,
-  0xff, 0x61, 0x00, 0x85, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x85, 0x05, 0xd0,
-  0xff, 0x90, 0x00, 0x85, 0x05, 0xd2, 0xff, 0x90, 0x00, 0x85, 0x05, 0xd3,
-  0xff, 0xad, 0x00, 0x85, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x85, 0x05, 0xd5,
-  0xff, 0xad, 0x00, 0x85, 0x06, 0x42, 0xff, 0x61, 0x00, 0x85, 0x06, 0x43,
-  0xff, 0x75, 0x00, 0x85, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x85, 0x07, 0x52,
-  0xff, 0x03, 0x00, 0x85, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x86, 0x00, 0x10,
-  0xff, 0xd3, 0x00, 0x86, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x1d,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x24, 0x00, 0x39, 0x00, 0x86, 0x00, 0x26,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x32,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x37,
-  0xff, 0x61, 0x00, 0x86, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x86, 0x00, 0x3a,
-  0xff, 0x90, 0x00, 0x86, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x86, 0x00, 0x46,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x48,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x86, 0x00, 0x52,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x57,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x59, 0xff, 0x88, 0x00, 0x86, 0x00, 0x5a,
-  0xff, 0xad, 0x00, 0x86, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x86, 0x00, 0x6d,
-  0xff, 0xb7, 0x00, 0x86, 0x00, 0x82, 0x00, 0x39, 0x00, 0x86, 0x00, 0x83,
-  0x00, 0x39, 0x00, 0x86, 0x00, 0x84, 0x00, 0x39, 0x00, 0x86, 0x00, 0x85,
-  0x00, 0x39, 0x00, 0x86, 0x00, 0x86, 0x00, 0x39, 0x00, 0x86, 0x00, 0x89,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x95,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x97,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x9f,
-  0xff, 0x61, 0x00, 0x86, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x86, 0x00, 0xc1,
-  0xff, 0x75, 0x00, 0x86, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x86, 0x00, 0xc4,
-  0x00, 0x39, 0x00, 0x86, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x86, 0x00, 0xc8,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xca,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xcd,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xcf,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xd5,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xd9,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xdd,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xe0,
-  0xff, 0xdc, 0x00, 0x86, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x0e,
-  0xff, 0xdc, 0x00, 0x86, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x10,
-  0xff, 0xdc, 0x00, 0x86, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x12,
-  0xff, 0xdc, 0x00, 0x86, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x24,
-  0xff, 0x61, 0x00, 0x86, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x26,
-  0xff, 0x61, 0x00, 0x86, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x36,
-  0xff, 0x90, 0x00, 0x86, 0x01, 0x37, 0xff, 0xad, 0x00, 0x86, 0x01, 0x38,
-  0xff, 0x61, 0x00, 0x86, 0x01, 0x39, 0xff, 0x75, 0x00, 0x86, 0x01, 0x3a,
-  0xff, 0x61, 0x00, 0x86, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x86, 0x01, 0xf1,
-  0xff, 0xdc, 0x00, 0x86, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x86, 0x05, 0xd2,
-  0xff, 0x90, 0x00, 0x86, 0x05, 0xd3, 0xff, 0xad, 0x00, 0x86, 0x05, 0xd4,
-  0xff, 0x90, 0x00, 0x86, 0x05, 0xd5, 0xff, 0xad, 0x00, 0x86, 0x06, 0x42,
-  0xff, 0x61, 0x00, 0x86, 0x06, 0x43, 0xff, 0x75, 0x00, 0x86, 0x07, 0x51,
-  0xfe, 0xf8, 0x00, 0x86, 0x07, 0x52, 0xff, 0x03, 0x00, 0x86, 0x07, 0x53,
-  0x00, 0x2f, 0x00, 0x88, 0x07, 0x51, 0xff, 0xad, 0x00, 0x88, 0x07, 0x52,
-  0xff, 0xa4, 0x00, 0x88, 0x07, 0x53, 0xff, 0x90, 0x00, 0x89, 0x00, 0x3c,
-  0xff, 0xdc, 0x00, 0x89, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x89, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x89, 0x00, 0x9f, 0xff, 0xdc, 0x00, 0x89, 0x01, 0x3a,
-  0xff, 0xdc, 0x00, 0x89, 0x07, 0x52, 0x00, 0x26, 0x00, 0x92, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x92, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x3c,
-  0xff, 0x90, 0x00, 0x92, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0x92, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x92, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x92, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0x92, 0x00, 0xc2, 0xff, 0xdc, 0x00, 0x92, 0x00, 0xc4,
-  0xff, 0xdc, 0x00, 0x92, 0x00, 0xc6, 0xff, 0xdc, 0x00, 0x92, 0x01, 0x38,
-  0xff, 0x90, 0x00, 0x92, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x92, 0x01, 0xf4,
-  0xff, 0x90, 0x00, 0x92, 0x06, 0x42, 0xff, 0x90, 0x00, 0x92, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x92, 0x07, 0x52, 0xff, 0xc9, 0x00, 0x92, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0x94, 0x00, 0x10, 0x00, 0x39, 0x00, 0x94, 0x00, 0x11,
-  0xff, 0xad, 0x00, 0x94, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x94, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x3b,
-  0xff, 0x7d, 0x00, 0x94, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x94, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0x94, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x94, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x94, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0x94, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x94, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x94, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x94, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0x95, 0x00, 0x10, 0x00, 0x39, 0x00, 0x95, 0x00, 0x11,
-  0xff, 0xad, 0x00, 0x95, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x95, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x3b,
-  0xff, 0x7d, 0x00, 0x95, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x95, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0x95, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x95, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x95, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0x95, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x95, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x95, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x95, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0x96, 0x00, 0x10, 0x00, 0x39, 0x00, 0x96, 0x00, 0x11,
-  0xff, 0xad, 0x00, 0x96, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x96, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x3b,
-  0xff, 0x7d, 0x00, 0x96, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x96, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0x96, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x96, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x96, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0x96, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x96, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x96, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x96, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0x97, 0x00, 0x10, 0x00, 0x39, 0x00, 0x97, 0x00, 0x11,
-  0xff, 0xad, 0x00, 0x97, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x97, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x3b,
-  0xff, 0x7d, 0x00, 0x97, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x97, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0x97, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x97, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x97, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0x97, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x97, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x97, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x97, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0x98, 0x00, 0x10, 0x00, 0x39, 0x00, 0x98, 0x00, 0x11,
-  0xff, 0xad, 0x00, 0x98, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0x98, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x3b,
-  0xff, 0x7d, 0x00, 0x98, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x98, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0x98, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0x98, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0x98, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0x98, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x98, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0x98, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x98, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0x9b, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9b, 0x01, 0x3f,
-  0xff, 0xdc, 0x00, 0x9c, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9c, 0x01, 0x3f,
-  0xff, 0xdc, 0x00, 0x9d, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9d, 0x01, 0x3f,
-  0xff, 0xdc, 0x00, 0x9e, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9e, 0x01, 0x3f,
-  0xff, 0xdc, 0x00, 0x9f, 0x00, 0x10, 0xff, 0x0d, 0x00, 0x9f, 0x00, 0x11,
-  0xfe, 0x61, 0x00, 0x9f, 0x00, 0x1d, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0x24,
-  0xff, 0x61, 0x00, 0x9f, 0x00, 0x26, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x32,
-  0xff, 0x90, 0x00, 0x9f, 0x00, 0x44, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0x48,
-  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0x4c, 0xff, 0xb7, 0x00, 0x9f, 0x00, 0x52,
-  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0x58, 0xff, 0x15, 0x00, 0x9f, 0x00, 0x6d,
-  0xff, 0x1f, 0x00, 0x9f, 0x00, 0x7d, 0xff, 0x6b, 0x00, 0x9f, 0x00, 0x82,
-  0xff, 0x61, 0x00, 0x9f, 0x00, 0x83, 0xff, 0x61, 0x00, 0x9f, 0x00, 0x84,
-  0xff, 0x61, 0x00, 0x9f, 0x00, 0x85, 0xff, 0x61, 0x00, 0x9f, 0x00, 0x86,
-  0xff, 0x61, 0x00, 0x9f, 0x00, 0x89, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x94,
-  0xff, 0x90, 0x00, 0x9f, 0x00, 0x95, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x96,
-  0xff, 0x90, 0x00, 0x9f, 0x00, 0x97, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x98,
-  0xff, 0x90, 0x00, 0x9f, 0x00, 0xa2, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa3,
-  0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa4, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa5,
-  0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa6, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa7,
-  0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xaa, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xab,
-  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xac, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xad,
-  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb4, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb5,
-  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb6, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb7,
-  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb8, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xbb,
-  0xff, 0x15, 0x00, 0x9f, 0x00, 0xbc, 0xff, 0x15, 0x00, 0x9f, 0x00, 0xbd,
-  0xff, 0x15, 0x00, 0x9f, 0x00, 0xbe, 0xff, 0x15, 0x00, 0x9f, 0x00, 0xc8,
-  0xff, 0x90, 0x00, 0x9f, 0x00, 0xce, 0xff, 0x90, 0x00, 0x9f, 0x00, 0xdd,
-  0xfe, 0xf0, 0x00, 0x9f, 0x01, 0x31, 0xff, 0x15, 0x00, 0x9f, 0x07, 0x51,
-  0xff, 0x90, 0x00, 0x9f, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x9f, 0x07, 0x53,
-  0xfe, 0xf8, 0x00, 0xa0, 0x00, 0x11, 0xff, 0x6b, 0x00, 0xa0, 0x00, 0x1d,
-  0xff, 0xb7, 0x00, 0xa0, 0x07, 0x51, 0xff, 0xdc, 0x00, 0xa0, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0xa1, 0x00, 0x10, 0x00, 0x26, 0x00, 0xa1, 0x07, 0x51,
-  0xff, 0x90, 0x00, 0xa1, 0x07, 0x52, 0xff, 0x90, 0x00, 0xa1, 0x07, 0x53,
-  0xff, 0xad, 0x00, 0xaa, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0xab, 0x00, 0x5b,
-  0xff, 0xdc, 0x00, 0xac, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0xad, 0x00, 0x5b,
-  0xff, 0xdc, 0x00, 0xb2, 0x07, 0x51, 0xff, 0xa4, 0x00, 0xb2, 0x07, 0x52,
-  0xff, 0x90, 0x00, 0xb2, 0x07, 0x53, 0xff, 0xb7, 0x00, 0xb3, 0x07, 0x51,
-  0xff, 0x6b, 0x00, 0xb3, 0x07, 0x52, 0xff, 0x90, 0x00, 0xb3, 0x07, 0x53,
-  0xff, 0xa4, 0x00, 0xb4, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb4, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xb4, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb4, 0x07, 0x51,
-  0xff, 0x6b, 0x00, 0xb4, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb4, 0x07, 0x53,
-  0xff, 0x7d, 0x00, 0xb5, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb5, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xb5, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb5, 0x07, 0x51,
-  0xff, 0x6b, 0x00, 0xb5, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb5, 0x07, 0x53,
-  0xff, 0x7d, 0x00, 0xb6, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb6, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xb6, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb6, 0x07, 0x51,
-  0xff, 0x6b, 0x00, 0xb6, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb6, 0x07, 0x53,
-  0xff, 0x7d, 0x00, 0xb7, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb7, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xb7, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb7, 0x07, 0x51,
-  0xff, 0x6b, 0x00, 0xb7, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb7, 0x07, 0x53,
-  0xff, 0x7d, 0x00, 0xb8, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb8, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xb8, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb8, 0x07, 0x51,
-  0xff, 0x6b, 0x00, 0xb8, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb8, 0x07, 0x53,
-  0xff, 0x7d, 0x00, 0xbf, 0x00, 0x10, 0xff, 0xdc, 0x00, 0xbf, 0x00, 0x11,
-  0xfe, 0xdc, 0x00, 0xbf, 0x00, 0x1d, 0xff, 0x6b, 0x00, 0xbf, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0xbf, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xbf, 0x07, 0x53,
-  0xfe, 0xd3, 0x00, 0xc1, 0x00, 0x10, 0xff, 0xdc, 0x00, 0xc1, 0x00, 0x11,
-  0xfe, 0xdc, 0x00, 0xc1, 0x00, 0x1d, 0xff, 0x6b, 0x00, 0xc1, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0xc1, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xc1, 0x07, 0x53,
-  0xfe, 0xd3, 0x00, 0xc2, 0x00, 0x10, 0xff, 0xd3, 0x00, 0xc2, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x24,
-  0x00, 0x39, 0x00, 0xc2, 0x00, 0x26, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x2a,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x32, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x34,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x37, 0xff, 0x61, 0x00, 0xc2, 0x00, 0x39,
-  0xff, 0x7d, 0x00, 0xc2, 0x00, 0x3a, 0xff, 0x90, 0x00, 0xc2, 0x00, 0x3c,
-  0xff, 0x61, 0x00, 0xc2, 0x00, 0x46, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x47,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x49,
-  0xff, 0xb7, 0x00, 0xc2, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x54,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x57, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x59,
-  0xff, 0x88, 0x00, 0xc2, 0x00, 0x5a, 0xff, 0xad, 0x00, 0xc2, 0x00, 0x5c,
-  0xff, 0x75, 0x00, 0xc2, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0xc2, 0x00, 0x82,
-  0x00, 0x39, 0x00, 0xc2, 0x00, 0x83, 0x00, 0x39, 0x00, 0xc2, 0x00, 0x84,
-  0x00, 0x39, 0x00, 0xc2, 0x00, 0x85, 0x00, 0x39, 0x00, 0xc2, 0x00, 0x86,
-  0x00, 0x39, 0x00, 0xc2, 0x00, 0x94, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x95,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x96, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x97,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x98, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x9f,
-  0xff, 0x61, 0x00, 0xc2, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xab, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xad, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xbf, 0xff, 0x75, 0x00, 0xc2, 0x00, 0xc1,
-  0xff, 0x75, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x39, 0x00, 0xc2, 0x00, 0xc4,
-  0x00, 0x39, 0x00, 0xc2, 0x00, 0xc6, 0x00, 0x39, 0x00, 0xc2, 0x00, 0xc8,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xca, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xcc,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xcd, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xce,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd3,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd7,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xdb,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xde,
-  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x0e,
-  0xff, 0xdc, 0x00, 0xc2, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x10,
-  0xff, 0xdc, 0x00, 0xc2, 0x01, 0x11, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x12,
-  0xff, 0xdc, 0x00, 0xc2, 0x01, 0x13, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x24,
-  0xff, 0x61, 0x00, 0xc2, 0x01, 0x25, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x26,
-  0xff, 0x61, 0x00, 0xc2, 0x01, 0x27, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x36,
-  0xff, 0x90, 0x00, 0xc2, 0x01, 0x37, 0xff, 0xad, 0x00, 0xc2, 0x01, 0x38,
-  0xff, 0x61, 0x00, 0xc2, 0x01, 0x39, 0xff, 0x75, 0x00, 0xc2, 0x01, 0x3a,
-  0xff, 0x61, 0x00, 0xc2, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0xf1,
-  0xff, 0xdc, 0x00, 0xc2, 0x05, 0xd0, 0xff, 0x90, 0x00, 0xc2, 0x05, 0xd2,
-  0xff, 0x90, 0x00, 0xc2, 0x05, 0xd3, 0xff, 0xad, 0x00, 0xc2, 0x05, 0xd4,
-  0xff, 0x90, 0x00, 0xc2, 0x05, 0xd5, 0xff, 0xad, 0x00, 0xc2, 0x06, 0x42,
-  0xff, 0x61, 0x00, 0xc2, 0x06, 0x43, 0xff, 0x75, 0x00, 0xc2, 0x07, 0x51,
-  0xfe, 0xf8, 0x00, 0xc2, 0x07, 0x52, 0xff, 0x02, 0x00, 0xc2, 0x07, 0x53,
-  0x00, 0x2f, 0x00, 0xc4, 0x00, 0x10, 0xff, 0xd3, 0x00, 0xc4, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x24,
-  0x00, 0x39, 0x00, 0xc4, 0x00, 0x26, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x2a,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x32, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x34,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x37, 0xff, 0x61, 0x00, 0xc4, 0x00, 0x39,
-  0xff, 0x7d, 0x00, 0xc4, 0x00, 0x3a, 0xff, 0x90, 0x00, 0xc4, 0x00, 0x3c,
-  0xff, 0x61, 0x00, 0xc4, 0x00, 0x46, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x47,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x49,
-  0xff, 0xb7, 0x00, 0xc4, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x54,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x57, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x59,
-  0xff, 0x88, 0x00, 0xc4, 0x00, 0x5a, 0xff, 0xad, 0x00, 0xc4, 0x00, 0x5c,
-  0xff, 0x75, 0x00, 0xc4, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0xc4, 0x00, 0x82,
-  0x00, 0x39, 0x00, 0xc4, 0x00, 0x83, 0x00, 0x39, 0x00, 0xc4, 0x00, 0x84,
-  0x00, 0x39, 0x00, 0xc4, 0x00, 0x85, 0x00, 0x39, 0x00, 0xc4, 0x00, 0x86,
-  0x00, 0x39, 0x00, 0xc4, 0x00, 0x94, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x95,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x96, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x97,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x98, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x9f,
-  0xff, 0x61, 0x00, 0xc4, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xab, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xad, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xbf, 0xff, 0x75, 0x00, 0xc4, 0x00, 0xc1,
-  0xff, 0x75, 0x00, 0xc4, 0x00, 0xc2, 0x00, 0x39, 0x00, 0xc4, 0x00, 0xc4,
-  0x00, 0x39, 0x00, 0xc4, 0x00, 0xc6, 0x00, 0x39, 0x00, 0xc4, 0x00, 0xc8,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xca, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xcc,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xcd, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xce,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd3,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd7,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xdb,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xde,
-  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x0e,
-  0xff, 0xdc, 0x00, 0xc4, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x10,
-  0xff, 0xdc, 0x00, 0xc4, 0x01, 0x11, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x12,
-  0xff, 0xdc, 0x00, 0xc4, 0x01, 0x13, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x24,
-  0xff, 0x61, 0x00, 0xc4, 0x01, 0x25, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x26,
-  0xff, 0x61, 0x00, 0xc4, 0x01, 0x27, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x36,
-  0xff, 0x90, 0x00, 0xc4, 0x01, 0x37, 0xff, 0xad, 0x00, 0xc4, 0x01, 0x38,
-  0xff, 0x61, 0x00, 0xc4, 0x01, 0x39, 0xff, 0x75, 0x00, 0xc4, 0x01, 0x3a,
-  0xff, 0x61, 0x00, 0xc4, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0xf1,
-  0xff, 0xdc, 0x00, 0xc4, 0x05, 0xd0, 0xff, 0x90, 0x00, 0xc4, 0x05, 0xd2,
-  0xff, 0x90, 0x00, 0xc4, 0x05, 0xd3, 0xff, 0xad, 0x00, 0xc4, 0x05, 0xd4,
-  0xff, 0x90, 0x00, 0xc4, 0x05, 0xd5, 0xff, 0xad, 0x00, 0xc4, 0x06, 0x42,
-  0xff, 0x61, 0x00, 0xc4, 0x06, 0x43, 0xff, 0x75, 0x00, 0xc4, 0x07, 0x51,
-  0xfe, 0xf8, 0x00, 0xc4, 0x07, 0x52, 0xff, 0x02, 0x00, 0xc4, 0x07, 0x53,
-  0x00, 0x2f, 0x00, 0xc6, 0x00, 0x10, 0xff, 0xd3, 0x00, 0xc6, 0x00, 0x11,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x24,
-  0x00, 0x39, 0x00, 0xc6, 0x00, 0x26, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x2a,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x32, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x34,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x37, 0xff, 0x61, 0x00, 0xc6, 0x00, 0x39,
-  0xff, 0x7d, 0x00, 0xc6, 0x00, 0x3a, 0xff, 0x90, 0x00, 0xc6, 0x00, 0x3c,
-  0xff, 0x61, 0x00, 0xc6, 0x00, 0x46, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x47,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x49,
-  0xff, 0xb7, 0x00, 0xc6, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x54,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x57, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x59,
-  0xff, 0x88, 0x00, 0xc6, 0x00, 0x5a, 0xff, 0xad, 0x00, 0xc6, 0x00, 0x6d,
-  0xff, 0xb7, 0x00, 0xc6, 0x00, 0x82, 0x00, 0x39, 0x00, 0xc6, 0x00, 0x83,
-  0x00, 0x39, 0x00, 0xc6, 0x00, 0x84, 0x00, 0x39, 0x00, 0xc6, 0x00, 0x85,
-  0x00, 0x39, 0x00, 0xc6, 0x00, 0x86, 0x00, 0x39, 0x00, 0xc6, 0x00, 0x94,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x95, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x96,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x97, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x98,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x9f, 0xff, 0x61, 0x00, 0xc6, 0x00, 0xa9,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xab,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xac, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xad,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb5,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb7,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xc2,
-  0x00, 0x39, 0x00, 0xc6, 0x00, 0xc4, 0x00, 0x39, 0x00, 0xc6, 0x00, 0xc6,
-  0x00, 0x39, 0x00, 0xc6, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xca,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xcd,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xce, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd1,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd3, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd5,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd9,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xdd,
-  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xde, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xe2,
-  0xff, 0xdc, 0x00, 0xc6, 0x01, 0x0e, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x0f,
-  0xff, 0xdc, 0x00, 0xc6, 0x01, 0x10, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x11,
-  0xff, 0xdc, 0x00, 0xc6, 0x01, 0x13, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x24,
-  0xff, 0x61, 0x00, 0xc6, 0x01, 0x25, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x26,
-  0xff, 0x61, 0x00, 0xc6, 0x01, 0x27, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x36,
-  0xff, 0x90, 0x00, 0xc6, 0x01, 0x37, 0xff, 0xad, 0x00, 0xc6, 0x01, 0x38,
-  0xff, 0x61, 0x00, 0xc6, 0x01, 0x3a, 0xff, 0x61, 0x00, 0xc6, 0x01, 0xf0,
-  0xff, 0xdc, 0x00, 0xc6, 0x01, 0xf1, 0xff, 0xdc, 0x00, 0xc6, 0x05, 0xd0,
-  0xff, 0x90, 0x00, 0xc6, 0x05, 0xd2, 0xff, 0x90, 0x00, 0xc6, 0x05, 0xd3,
-  0xff, 0xad, 0x00, 0xc6, 0x05, 0xd4, 0xff, 0x90, 0x00, 0xc6, 0x05, 0xd5,
-  0xff, 0xad, 0x00, 0xc6, 0x06, 0x42, 0xff, 0x61, 0x00, 0xc6, 0x07, 0x51,
-  0xfe, 0xf8, 0x00, 0xc6, 0x07, 0x52, 0xff, 0x02, 0x00, 0xc6, 0x07, 0x53,
-  0x00, 0x2f, 0x00, 0xc8, 0x00, 0x3c, 0xff, 0xdc, 0x00, 0xc8, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0xc8, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xc8, 0x00, 0x9f,
-  0xff, 0xdc, 0x00, 0xc8, 0x01, 0x3a, 0xff, 0xdc, 0x00, 0xc8, 0x07, 0x52,
-  0x00, 0x26, 0x00, 0xce, 0x00, 0x3c, 0xff, 0xdc, 0x00, 0xce, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0xce, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xce, 0x00, 0x9f,
-  0xff, 0xdc, 0x00, 0xce, 0x01, 0x3a, 0xff, 0xdc, 0x00, 0xce, 0x07, 0x52,
-  0x00, 0x26, 0x00, 0xd0, 0x00, 0x24, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x39,
-  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x3c, 0xff, 0x90, 0x00, 0xd0, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x82,
-  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x83, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x84,
-  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x85, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x86,
-  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x9f, 0xff, 0x90, 0x00, 0xd0, 0x00, 0xc2,
-  0xff, 0xdc, 0x00, 0xd0, 0x00, 0xc4, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0xc6,
-  0xff, 0xdc, 0x00, 0xd0, 0x01, 0x38, 0xff, 0x90, 0x00, 0xd0, 0x01, 0x3a,
-  0xff, 0x90, 0x00, 0xd0, 0x01, 0xf4, 0xff, 0x90, 0x00, 0xd0, 0x06, 0x42,
-  0xff, 0x90, 0x00, 0xd0, 0x07, 0x51, 0xff, 0xd3, 0x00, 0xd0, 0x07, 0x52,
-  0xff, 0xc9, 0x00, 0xd0, 0x07, 0x53, 0xff, 0x44, 0x00, 0xd2, 0x00, 0x24,
-  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x39, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x3c,
-  0xff, 0x90, 0x00, 0xd2, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x7d,
-  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x82, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x83,
-  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x84, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x85,
-  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x86, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x9f,
-  0xff, 0x90, 0x00, 0xd2, 0x01, 0x3a, 0xff, 0x90, 0x00, 0xd2, 0x07, 0x51,
-  0xff, 0xd3, 0x00, 0xd2, 0x07, 0x52, 0xff, 0xc9, 0x00, 0xd2, 0x07, 0x53,
-  0xff, 0x44, 0x00, 0xdd, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0xe0, 0x00, 0x37,
-  0xff, 0xb7, 0x00, 0xe0, 0x00, 0x3c, 0xff, 0x9a, 0x00, 0xe0, 0x00, 0x6d,
-  0xff, 0xdc, 0x00, 0xe0, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xe0, 0x00, 0x9f,
-  0xff, 0x9a, 0x00, 0xe0, 0x01, 0x26, 0xff, 0xb7, 0x00, 0xe0, 0x01, 0x3a,
-  0xff, 0x9a, 0x00, 0xe0, 0x07, 0x51, 0xff, 0xd3, 0x00, 0xe0, 0x07, 0x52,
-  0xff, 0xd3, 0x00, 0xe0, 0x07, 0x53, 0xff, 0xc9, 0x00, 0xfb, 0x00, 0x10,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0x24, 0x00, 0x2f, 0x00, 0xfb, 0x00, 0x32,
-  0xff, 0xb7, 0x00, 0xfb, 0x00, 0x37, 0xfe, 0xe6, 0x00, 0xfb, 0x00, 0x38,
-  0xff, 0x9a, 0x00, 0xfb, 0x00, 0x39, 0xff, 0x1f, 0x00, 0xfb, 0x00, 0x3a,
-  0xff, 0x44, 0x00, 0xfb, 0x00, 0x3c, 0xfe, 0xf0, 0x00, 0xfb, 0x00, 0x48,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0x58,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0x5c, 0xff, 0x44, 0x00, 0xfb, 0x00, 0x82,
-  0x00, 0x2f, 0x00, 0xfb, 0x00, 0x83, 0x00, 0x2f, 0x00, 0xfb, 0x00, 0x84,
-  0x00, 0x2f, 0x00, 0xfb, 0x00, 0x85, 0x00, 0x2f, 0x00, 0xfb, 0x00, 0x86,
-  0x00, 0x2f, 0x00, 0xfb, 0x00, 0x94, 0xff, 0xb7, 0x00, 0xfb, 0x00, 0x95,
-  0xff, 0xb7, 0x00, 0xfb, 0x00, 0x96, 0xff, 0xb7, 0x00, 0xfb, 0x00, 0x97,
-  0xff, 0xb7, 0x00, 0xfb, 0x00, 0x98, 0xff, 0xb7, 0x00, 0xfb, 0x00, 0x9b,
-  0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9c, 0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9d,
-  0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9e, 0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9f,
-  0xfe, 0xf0, 0x00, 0xfb, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xab,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xac, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xad,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb5,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb7,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbb,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbc, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbd,
-  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbe, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbf,
-  0xff, 0x44, 0x00, 0xfb, 0x00, 0xc1, 0xff, 0x44, 0x00, 0xfb, 0x00, 0xdd,
-  0xff, 0xdc, 0x00, 0xfb, 0x01, 0x26, 0xfe, 0xe6, 0x00, 0xfb, 0x01, 0x30,
-  0xff, 0x9a, 0x00, 0xfb, 0x01, 0x31, 0xff, 0xdc, 0x00, 0xfb, 0x01, 0x3a,
-  0xfe, 0xf0, 0x00, 0xfb, 0x07, 0x51, 0xfe, 0x61, 0x00, 0xfb, 0x07, 0x52,
-  0xfd, 0xe6, 0x00, 0xff, 0x00, 0x10, 0xff, 0xdc, 0x00, 0xff, 0x00, 0x24,
-  0x00, 0x2f, 0x00, 0xff, 0x00, 0x32, 0xff, 0xb7, 0x00, 0xff, 0x00, 0x37,
-  0xfe, 0xe6, 0x00, 0xff, 0x00, 0x38, 0xff, 0x9a, 0x00, 0xff, 0x00, 0x39,
-  0xff, 0x1f, 0x00, 0xff, 0x00, 0x3a, 0xff, 0x44, 0x00, 0xff, 0x00, 0x3c,
-  0xfe, 0xf0, 0x00, 0xff, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xff, 0x00, 0x52,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0x58, 0xff, 0xdc, 0x00, 0xff, 0x00, 0x5c,
-  0xff, 0x44, 0x00, 0xff, 0x00, 0x82, 0x00, 0x2f, 0x00, 0xff, 0x00, 0x83,
-  0x00, 0x2f, 0x00, 0xff, 0x00, 0x84, 0x00, 0x2f, 0x00, 0xff, 0x00, 0x85,
-  0x00, 0x2f, 0x00, 0xff, 0x00, 0x86, 0x00, 0x2f, 0x00, 0xff, 0x00, 0x94,
-  0xff, 0xb7, 0x00, 0xff, 0x00, 0x95, 0xff, 0xb7, 0x00, 0xff, 0x00, 0x96,
-  0xff, 0xb7, 0x00, 0xff, 0x00, 0x97, 0xff, 0xb7, 0x00, 0xff, 0x00, 0x98,
-  0xff, 0xb7, 0x00, 0xff, 0x00, 0x9b, 0xff, 0x9a, 0x00, 0xff, 0x00, 0x9c,
-  0xff, 0x9a, 0x00, 0xff, 0x00, 0x9d, 0xff, 0x9a, 0x00, 0xff, 0x00, 0x9e,
-  0xff, 0x9a, 0x00, 0xff, 0x00, 0x9f, 0xfe, 0xf0, 0x00, 0xff, 0x00, 0xaa,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0xab, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xac,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0xad, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xb4,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xb6,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xb8,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0xbb, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xbc,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0xbd, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xbe,
-  0xff, 0xdc, 0x00, 0xff, 0x00, 0xbf, 0xff, 0x44, 0x00, 0xff, 0x00, 0xc1,
-  0xff, 0x44, 0x00, 0xff, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0xff, 0x01, 0x26,
-  0xfe, 0xe6, 0x00, 0xff, 0x01, 0x30, 0xff, 0x9a, 0x00, 0xff, 0x01, 0x31,
-  0xff, 0xdc, 0x00, 0xff, 0x01, 0x3a, 0xfe, 0xf0, 0x00, 0xff, 0x07, 0x51,
-  0xfe, 0x61, 0x00, 0xff, 0x07, 0x52, 0xfd, 0xe6, 0x01, 0x02, 0x00, 0x4f,
-  0xff, 0x3f, 0x01, 0x0a, 0x07, 0x51, 0xff, 0x6b, 0x01, 0x0a, 0x07, 0x52,
-  0xff, 0x90, 0x01, 0x0a, 0x07, 0x53, 0xff, 0xa4, 0x01, 0x16, 0x00, 0x10,
-  0xff, 0xad, 0x01, 0x16, 0x00, 0x11, 0xff, 0xb7, 0x01, 0x16, 0x00, 0x1d,
-  0xff, 0xc1, 0x01, 0x16, 0x00, 0x24, 0xff, 0xad, 0x01, 0x16, 0x00, 0x26,
-  0xff, 0x9a, 0x01, 0x16, 0x00, 0x37, 0xff, 0x6b, 0x01, 0x16, 0x00, 0x39,
-  0xff, 0x90, 0x01, 0x16, 0x00, 0x3a, 0xff, 0xad, 0x01, 0x16, 0x00, 0x3c,
-  0xff, 0x7d, 0x01, 0x16, 0x00, 0x44, 0xff, 0xd3, 0x01, 0x16, 0x00, 0x48,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0x52, 0xff, 0xa4, 0x01, 0x16, 0x00, 0x58,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0x5c, 0xff, 0x90, 0x01, 0x16, 0x00, 0x6d,
-  0xff, 0x90, 0x01, 0x16, 0x00, 0x7d, 0xff, 0xdc, 0x01, 0x16, 0x00, 0x82,
-  0xff, 0xad, 0x01, 0x16, 0x00, 0x83, 0xff, 0xad, 0x01, 0x16, 0x00, 0x84,
-  0xff, 0xad, 0x01, 0x16, 0x00, 0x85, 0xff, 0xad, 0x01, 0x16, 0x00, 0x86,
-  0xff, 0xad, 0x01, 0x16, 0x00, 0x89, 0xff, 0x9a, 0x01, 0x16, 0x00, 0x9f,
-  0xff, 0x7d, 0x01, 0x16, 0x00, 0xa2, 0xff, 0xd3, 0x01, 0x16, 0x00, 0xa3,
-  0xff, 0xd3, 0x01, 0x16, 0x00, 0xa4, 0xff, 0xd3, 0x01, 0x16, 0x00, 0xa5,
-  0xff, 0xd3, 0x01, 0x16, 0x00, 0xa6, 0xff, 0xd3, 0x01, 0x16, 0x00, 0xa7,
-  0xff, 0xd3, 0x01, 0x16, 0x00, 0xaa, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xab,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0xac, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xad,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0xb4, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xb5,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0xb6, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xb7,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0xb8, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xbb,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0xbc, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xbd,
-  0xff, 0xa4, 0x01, 0x16, 0x00, 0xbe, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xbf,
-  0xff, 0x90, 0x01, 0x16, 0x00, 0xc1, 0xff, 0x90, 0x01, 0x16, 0x00, 0xc8,
-  0xff, 0x9a, 0x01, 0x16, 0x00, 0xce, 0xff, 0x9a, 0x01, 0x16, 0x00, 0xdd,
-  0xff, 0xa4, 0x01, 0x16, 0x01, 0x26, 0xff, 0x6b, 0x01, 0x16, 0x01, 0x31,
-  0xff, 0xa4, 0x01, 0x16, 0x01, 0x3a, 0xff, 0x7d, 0x01, 0x16, 0x07, 0x51,
-  0xff, 0x6b, 0x01, 0x16, 0x07, 0x52, 0xff, 0x7d, 0x01, 0x16, 0x07, 0x53,
-  0xff, 0xdc, 0x01, 0x17, 0x00, 0x10, 0xff, 0x7d, 0x01, 0x17, 0x00, 0x11,
-  0xff, 0x44, 0x01, 0x17, 0x00, 0x1d, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x46,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0x47, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x48,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0x4a, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x4b,
-  0xff, 0xdc, 0x01, 0x17, 0x00, 0x50, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x51,
-  0xff, 0xdc, 0x01, 0x17, 0x00, 0x52, 0xff, 0xd3, 0x01, 0x17, 0x00, 0x54,
-  0xff, 0xdc, 0x01, 0x17, 0x00, 0x55, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x5b,
-  0xff, 0xc9, 0x01, 0x17, 0x00, 0x6d, 0xff, 0xb7, 0x01, 0x17, 0x00, 0xa9,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xaa, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xab,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xac, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xad,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xb3, 0xff, 0xdc, 0x01, 0x17, 0x00, 0xb4,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xb5, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xb6,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xb7, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xb8,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xc9, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xcf,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xd1, 0x00, 0x48, 0x01, 0x17, 0x00, 0xdd,
-  0xff, 0xd3, 0x01, 0x17, 0x00, 0xe1, 0xff, 0xdc, 0x01, 0x17, 0x01, 0x0a,
-  0xff, 0xdc, 0x01, 0x17, 0x01, 0x17, 0xff, 0xdc, 0x01, 0x17, 0x01, 0x1b,
-  0xff, 0xdc, 0x01, 0x17, 0x07, 0x52, 0x00, 0x56, 0x01, 0x17, 0x07, 0x53,
-  0xfe, 0xc9, 0x01, 0x1a, 0x00, 0x10, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x11,
-  0xff, 0xb7, 0x01, 0x1a, 0x00, 0x1d, 0xff, 0xc1, 0x01, 0x1a, 0x00, 0x24,
-  0xff, 0xad, 0x01, 0x1a, 0x00, 0x26, 0xff, 0x9a, 0x01, 0x1a, 0x00, 0x37,
-  0xff, 0x6b, 0x01, 0x1a, 0x00, 0x39, 0xff, 0x90, 0x01, 0x1a, 0x00, 0x3a,
-  0xff, 0xad, 0x01, 0x1a, 0x00, 0x3c, 0xff, 0x7d, 0x01, 0x1a, 0x00, 0x44,
-  0xff, 0xd3, 0x01, 0x1a, 0x00, 0x48, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0x52,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0x58, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0x5c,
-  0xff, 0x90, 0x01, 0x1a, 0x00, 0x6d, 0xff, 0x90, 0x01, 0x1a, 0x00, 0x7d,
-  0xff, 0xdc, 0x01, 0x1a, 0x00, 0x82, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x83,
-  0xff, 0xad, 0x01, 0x1a, 0x00, 0x84, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x85,
-  0xff, 0xad, 0x01, 0x1a, 0x00, 0x86, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x89,
-  0xff, 0x9a, 0x01, 0x1a, 0x00, 0x9f, 0xff, 0x7d, 0x01, 0x1a, 0x00, 0xa2,
-  0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa3, 0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa4,
-  0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa5, 0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa6,
-  0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa7, 0xff, 0xd3, 0x01, 0x1a, 0x00, 0xaa,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xab, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xac,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xad, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb4,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb5, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb6,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb7, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb8,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbb, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbc,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbd, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbe,
-  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbf, 0xff, 0x90, 0x01, 0x1a, 0x00, 0xc1,
-  0xff, 0x90, 0x01, 0x1a, 0x00, 0xc8, 0xff, 0x9a, 0x01, 0x1a, 0x00, 0xce,
-  0xff, 0x9a, 0x01, 0x1a, 0x00, 0xdd, 0xff, 0xa4, 0x01, 0x1a, 0x01, 0x26,
-  0xff, 0x6b, 0x01, 0x1a, 0x01, 0x31, 0xff, 0xa4, 0x01, 0x1a, 0x01, 0x3a,
-  0xff, 0x7d, 0x01, 0x1a, 0x07, 0x51, 0xff, 0x6b, 0x01, 0x1a, 0x07, 0x52,
-  0xff, 0x7d, 0x01, 0x1a, 0x07, 0x53, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x10,
-  0xff, 0x7d, 0x01, 0x1b, 0x00, 0x11, 0xff, 0x44, 0x01, 0x1b, 0x00, 0x1d,
-  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x46, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0x47,
-  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x48, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0x4a,
-  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x4b, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x50,
-  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x51, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x52,
-  0xff, 0xd3, 0x01, 0x1b, 0x00, 0x54, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x55,
-  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x5b, 0xff, 0xc9, 0x01, 0x1b, 0x00, 0x6d,
-  0xff, 0xb7, 0x01, 0x1b, 0x00, 0xa9, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xaa,
-  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xab, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xac,
-  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xad, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb3,
-  0xff, 0xdc, 0x01, 0x1b, 0x00, 0xb4, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb5,
-  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb6, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb7,
-  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb8, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xc9,
-  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xcf, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xd1,
-  0xff, 0xdc, 0x01, 0x1b, 0x00, 0xdd, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xe1,
-  0xff, 0xdc, 0x01, 0x1b, 0x01, 0x0a, 0xff, 0xdc, 0x01, 0x1b, 0x01, 0x17,
-  0xff, 0xdc, 0x01, 0x1b, 0x01, 0x1b, 0xff, 0xdc, 0x01, 0x1b, 0x07, 0x52,
-  0x00, 0x56, 0x01, 0x1b, 0x07, 0x53, 0xfe, 0xc9, 0x01, 0x20, 0x00, 0x24,
-  0x00, 0x26, 0x01, 0x20, 0x00, 0x82, 0x00, 0x26, 0x01, 0x20, 0x00, 0x83,
-  0x00, 0x26, 0x01, 0x20, 0x00, 0x84, 0x00, 0x26, 0x01, 0x20, 0x00, 0x85,
-  0x00, 0x26, 0x01, 0x20, 0x00, 0x86, 0x00, 0x26, 0x01, 0x22, 0x00, 0x24,
-  0x00, 0x26, 0x01, 0x22, 0x00, 0x82, 0x00, 0x26, 0x01, 0x22, 0x00, 0x83,
-  0x00, 0x26, 0x01, 0x22, 0x00, 0x84, 0x00, 0x26, 0x01, 0x22, 0x00, 0x85,
-  0x00, 0x26, 0x01, 0x22, 0x00, 0x86, 0x00, 0x26, 0x01, 0x26, 0x00, 0x10,
-  0xff, 0x44, 0x01, 0x26, 0x00, 0x11, 0xff, 0x0d, 0x01, 0x26, 0x00, 0x1d,
-  0xff, 0x1f, 0x01, 0x26, 0x00, 0x24, 0xff, 0x61, 0x01, 0x26, 0x00, 0x26,
-  0xff, 0x88, 0x01, 0x26, 0x00, 0x37, 0xff, 0xdc, 0x01, 0x26, 0x00, 0x44,
-  0xfe, 0xad, 0x01, 0x26, 0x00, 0x46, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0x48,
-  0xfe, 0xa4, 0x01, 0x26, 0x00, 0x4c, 0xff, 0xc1, 0x01, 0x26, 0x00, 0x52,
-  0xfe, 0xa4, 0x01, 0x26, 0x00, 0x55, 0xfe, 0xd3, 0x01, 0x26, 0x00, 0x56,
-  0xfe, 0xad, 0x01, 0x26, 0x00, 0x58, 0xfe, 0xc9, 0x01, 0x26, 0x00, 0x5a,
-  0xfe, 0xad, 0x01, 0x26, 0x00, 0x5c, 0xfe, 0xc1, 0x01, 0x26, 0x00, 0x6d,
-  0xff, 0x44, 0x01, 0x26, 0x00, 0x7d, 0xff, 0x90, 0x01, 0x26, 0x00, 0x82,
-  0xff, 0x61, 0x01, 0x26, 0x00, 0x83, 0xff, 0x61, 0x01, 0x26, 0x00, 0x84,
-  0xff, 0x61, 0x01, 0x26, 0x00, 0x85, 0xff, 0x61, 0x01, 0x26, 0x00, 0x86,
-  0xff, 0x61, 0x01, 0x26, 0x00, 0x89, 0xff, 0x88, 0x01, 0x26, 0x00, 0xa2,
-  0xfe, 0xad, 0x01, 0x26, 0x00, 0xa3, 0xfe, 0xad, 0x01, 0x26, 0x00, 0xa4,
-  0xfe, 0xad, 0x01, 0x26, 0x00, 0xa5, 0xfe, 0xad, 0x01, 0x26, 0x00, 0xa6,
-  0xfe, 0xad, 0x01, 0x26, 0x00, 0xa7, 0xfe, 0xad, 0x01, 0x26, 0x00, 0xa9,
-  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xaa, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xab,
-  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xac, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xad,
-  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb4, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb5,
-  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb6, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb7,
-  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb8, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xbb,
-  0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbc, 0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbd,
-  0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbe, 0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbf,
-  0xfe, 0xc1, 0x01, 0x26, 0x00, 0xc1, 0xfe, 0xc1, 0x01, 0x26, 0x00, 0xc8,
-  0xff, 0x88, 0x01, 0x26, 0x00, 0xc9, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xce,
-  0xff, 0x88, 0x01, 0x26, 0x00, 0xcf, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xdd,
-  0xfe, 0xa4, 0x01, 0x26, 0x01, 0x17, 0xfe, 0xd3, 0x01, 0x26, 0x01, 0x1b,
-  0xfe, 0xd3, 0x01, 0x26, 0x01, 0x21, 0xfe, 0xad, 0x01, 0x26, 0x01, 0x23,
-  0xfe, 0xad, 0x01, 0x26, 0x01, 0x26, 0xff, 0xdc, 0x01, 0x26, 0x01, 0x31,
-  0xfe, 0xc9, 0x01, 0x26, 0x07, 0x52, 0xff, 0xd3, 0x01, 0x26, 0x07, 0x53,
-  0xfe, 0xf8, 0x01, 0x30, 0x00, 0x3d, 0xff, 0xdc, 0x01, 0x30, 0x01, 0x3f,
-  0xff, 0xdc, 0x01, 0x3a, 0x00, 0x10, 0xff, 0x0d, 0x01, 0x3a, 0x00, 0x11,
-  0xfe, 0x61, 0x01, 0x3a, 0x00, 0x1d, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0x24,
-  0xff, 0x61, 0x01, 0x3a, 0x00, 0x26, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x32,
-  0xff, 0x90, 0x01, 0x3a, 0x00, 0x44, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0x48,
-  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0x4c, 0xff, 0xb7, 0x01, 0x3a, 0x00, 0x52,
-  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0x58, 0xff, 0x15, 0x01, 0x3a, 0x00, 0x6d,
-  0xff, 0x1f, 0x01, 0x3a, 0x00, 0x7d, 0xff, 0x6b, 0x01, 0x3a, 0x00, 0x82,
-  0xff, 0x61, 0x01, 0x3a, 0x00, 0x83, 0xff, 0x61, 0x01, 0x3a, 0x00, 0x84,
-  0xff, 0x61, 0x01, 0x3a, 0x00, 0x85, 0xff, 0x61, 0x01, 0x3a, 0x00, 0x86,
-  0xff, 0x61, 0x01, 0x3a, 0x00, 0x89, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x94,
-  0xff, 0x90, 0x01, 0x3a, 0x00, 0x95, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x96,
-  0xff, 0x90, 0x01, 0x3a, 0x00, 0x97, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x98,
-  0xff, 0x90, 0x01, 0x3a, 0x00, 0xa2, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa3,
-  0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa4, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa5,
-  0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa6, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa7,
-  0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xaa, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xab,
-  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xac, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xad,
-  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb4, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb5,
-  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb6, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb7,
-  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb8, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xbb,
-  0xff, 0x15, 0x01, 0x3a, 0x00, 0xbc, 0xff, 0x15, 0x01, 0x3a, 0x00, 0xbd,
-  0xff, 0x15, 0x01, 0x3a, 0x00, 0xbe, 0xff, 0x15, 0x01, 0x3a, 0x00, 0xc8,
-  0xff, 0x90, 0x01, 0x3a, 0x00, 0xce, 0xff, 0x90, 0x01, 0x3a, 0x00, 0xdd,
-  0xfe, 0xf0, 0x01, 0x3a, 0x01, 0x31, 0xff, 0x15, 0x01, 0x3a, 0x07, 0x51,
-  0xff, 0x90, 0x01, 0x3a, 0x07, 0x52, 0xff, 0xdc, 0x01, 0x3a, 0x07, 0x53,
-  0xfe, 0xf8, 0x01, 0x3f, 0x00, 0x10, 0xff, 0xdc, 0x01, 0x3f, 0x07, 0x51,
-  0xff, 0xdc, 0x01, 0x3f, 0x07, 0x52, 0xff, 0xdc, 0x01, 0x3f, 0x07, 0x53,
-  0xff, 0xdc, 0x07, 0x45, 0x00, 0x24, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x25,
-  0xff, 0xb7, 0x07, 0x45, 0x00, 0x2a, 0x00, 0x4b, 0x07, 0x45, 0x00, 0x2d,
-  0x00, 0x72, 0x07, 0x45, 0x00, 0x32, 0x00, 0x39, 0x07, 0x45, 0x00, 0x34,
-  0x00, 0x4b, 0x07, 0x45, 0x00, 0x37, 0xff, 0x44, 0x07, 0x45, 0x00, 0x39,
-  0xff, 0x88, 0x07, 0x45, 0x00, 0x3a, 0xff, 0xad, 0x07, 0x45, 0x00, 0x3b,
-  0xff, 0x9a, 0x07, 0x45, 0x00, 0x3c, 0xff, 0x0d, 0x07, 0x45, 0x00, 0x52,
-  0x00, 0x26, 0x07, 0x45, 0x00, 0x59, 0xff, 0xc9, 0x07, 0x45, 0x00, 0x5c,
-  0xff, 0xdc, 0x07, 0x45, 0x00, 0x82, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x83,
-  0xff, 0xd3, 0x07, 0x45, 0x00, 0x84, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x85,
-  0xff, 0xd3, 0x07, 0x45, 0x00, 0x86, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x94,
-  0x00, 0x39, 0x07, 0x45, 0x00, 0x95, 0x00, 0x39, 0x07, 0x45, 0x00, 0x96,
-  0x00, 0x39, 0x07, 0x45, 0x00, 0x97, 0x00, 0x39, 0x07, 0x45, 0x00, 0x98,
-  0x00, 0x39, 0x07, 0x45, 0x00, 0x9f, 0xff, 0x0d, 0x07, 0x45, 0x00, 0xb4,
-  0x00, 0x26, 0x07, 0x45, 0x00, 0xb5, 0x00, 0x26, 0x07, 0x45, 0x00, 0xb6,
-  0x00, 0x26, 0x07, 0x45, 0x00, 0xb7, 0x00, 0x26, 0x07, 0x45, 0x00, 0xb8,
-  0x00, 0x26, 0x07, 0x45, 0x00, 0xbf, 0xff, 0xdc, 0x07, 0x45, 0x00, 0xc1,
-  0xff, 0xdc, 0x07, 0x45, 0x00, 0xe0, 0x00, 0x4b, 0x07, 0x45, 0x01, 0x26,
-  0xff, 0x44, 0x07, 0x45, 0x01, 0x3a, 0xff, 0x0d, 0x07, 0x51, 0x00, 0x24,
-  0xfe, 0xf8, 0x07, 0x51, 0x00, 0x25, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x26,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x27, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x29,
-  0xff, 0xc1, 0x07, 0x51, 0x00, 0x2a, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x2b,
-  0xff, 0xc1, 0x07, 0x51, 0x00, 0x2d, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x2e,
-  0xff, 0xc1, 0x07, 0x51, 0x00, 0x2f, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x32,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x33, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x34,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x35, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x3b,
-  0xff, 0x88, 0x07, 0x51, 0x00, 0x3d, 0xff, 0xdc, 0x07, 0x51, 0x00, 0x49,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x51, 0xff, 0x90, 0x07, 0x51, 0x00, 0x52,
-  0xff, 0x6b, 0x07, 0x51, 0x00, 0x55, 0xff, 0x90, 0x07, 0x51, 0x00, 0x59,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x5a, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x5c,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x82, 0xfe, 0xf8, 0x07, 0x51, 0x00, 0x83,
-  0xfe, 0xf8, 0x07, 0x51, 0x00, 0x84, 0xfe, 0xf8, 0x07, 0x51, 0x00, 0x85,
-  0xfe, 0xf8, 0x07, 0x51, 0x00, 0x86, 0xfe, 0xf8, 0x07, 0x51, 0x00, 0x88,
-  0xfe, 0x7d, 0x07, 0x51, 0x00, 0x89, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x94,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x95, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x96,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0x97, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x98,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0xa0, 0xff, 0xc1, 0x07, 0x51, 0x00, 0xa1,
-  0xff, 0xc1, 0x07, 0x51, 0x00, 0xb2, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xb3,
-  0xff, 0x90, 0x07, 0x51, 0x00, 0xb4, 0xff, 0x6b, 0x07, 0x51, 0x00, 0xb5,
-  0xff, 0x6b, 0x07, 0x51, 0x00, 0xb6, 0xff, 0x6b, 0x07, 0x51, 0x00, 0xb7,
-  0xff, 0x6b, 0x07, 0x51, 0x00, 0xb8, 0xff, 0x6b, 0x07, 0x51, 0x00, 0xbf,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0xc1, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xc8,
-  0xff, 0xb7, 0x07, 0x51, 0x00, 0xce, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xd0,
-  0xff, 0xc1, 0x07, 0x51, 0x00, 0xe0, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xfb,
-  0xff, 0xc1, 0x07, 0x51, 0x00, 0xff, 0xff, 0xc1, 0x07, 0x51, 0x01, 0x0a,
-  0xff, 0x90, 0x07, 0x51, 0x01, 0x16, 0xff, 0xc1, 0x07, 0x51, 0x01, 0x17,
-  0xff, 0x90, 0x07, 0x51, 0x01, 0x1a, 0xff, 0xc1, 0x07, 0x51, 0x01, 0x1b,
-  0xff, 0x90, 0x07, 0x51, 0x01, 0x3f, 0xff, 0xdc, 0x07, 0x51, 0x0e, 0x78,
-  0xff, 0xc1, 0x07, 0x53, 0x00, 0x24, 0x00, 0x26, 0x07, 0x53, 0x00, 0x25,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x26, 0xff, 0x90, 0x07, 0x53, 0x00, 0x27,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x29, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x2a,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x2b, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x2d,
-  0x00, 0x2f, 0x07, 0x53, 0x00, 0x2e, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x2f,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x32, 0xff, 0x90, 0x07, 0x53, 0x00, 0x33,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x34, 0xff, 0x90, 0x07, 0x53, 0x00, 0x35,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x37, 0xfe, 0xe6, 0x07, 0x53, 0x00, 0x39,
-  0xfe, 0x88, 0x07, 0x53, 0x00, 0x3a, 0xff, 0x03, 0x07, 0x53, 0x00, 0x3b,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x3c, 0xfe, 0x88, 0x07, 0x53, 0x00, 0x49,
-  0xff, 0xdc, 0x07, 0x53, 0x00, 0x51, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x52,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0x55, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x59,
-  0xff, 0x15, 0x07, 0x53, 0x00, 0x5a, 0xff, 0x3c, 0x07, 0x53, 0x00, 0x5c,
-  0xff, 0x90, 0x07, 0x53, 0x00, 0x82, 0x00, 0x26, 0x07, 0x53, 0x00, 0x83,
-  0x00, 0x26, 0x07, 0x53, 0x00, 0x84, 0x00, 0x26, 0x07, 0x53, 0x00, 0x85,
-  0x00, 0x26, 0x07, 0x53, 0x00, 0x86, 0x00, 0x26, 0x07, 0x53, 0x00, 0x88,
-  0x00, 0x26, 0x07, 0x53, 0x00, 0x89, 0xff, 0x90, 0x07, 0x53, 0x00, 0x94,
-  0xff, 0x90, 0x07, 0x53, 0x00, 0x95, 0xff, 0x90, 0x07, 0x53, 0x00, 0x96,
-  0xff, 0x90, 0x07, 0x53, 0x00, 0x97, 0xff, 0x90, 0x07, 0x53, 0x00, 0x98,
-  0xff, 0x90, 0x07, 0x53, 0x00, 0x9f, 0xfe, 0x88, 0x07, 0x53, 0x00, 0xa0,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0xa1, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb2,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0xb3, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb4,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0xb5, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb6,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0xb7, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb8,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0xbf, 0xff, 0x90, 0x07, 0x53, 0x00, 0xc1,
-  0xff, 0x90, 0x07, 0x53, 0x00, 0xc8, 0xff, 0x90, 0x07, 0x53, 0x00, 0xce,
-  0xff, 0x90, 0x07, 0x53, 0x00, 0xd0, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xe0,
-  0xff, 0xb7, 0x07, 0x53, 0x00, 0xfb, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xff,
-  0xff, 0xb7, 0x07, 0x53, 0x01, 0x0a, 0xff, 0xb7, 0x07, 0x53, 0x01, 0x16,
-  0xff, 0xb7, 0x07, 0x53, 0x01, 0x17, 0xff, 0xb7, 0x07, 0x53, 0x01, 0x1a,
-  0xff, 0xb7, 0x07, 0x53, 0x01, 0x1b, 0xff, 0xb7, 0x07, 0x53, 0x01, 0x26,
-  0xfe, 0xe6, 0x07, 0x53, 0x01, 0x3a, 0xfe, 0x88, 0x07, 0x53, 0x0e, 0x78,
-  0xff, 0xb7, 0x0e, 0x60, 0x00, 0x10, 0xff, 0x44, 0x0e, 0x60, 0x00, 0x11,
-  0xff, 0x0d, 0x0e, 0x60, 0x00, 0x1d, 0xff, 0x1f, 0x0e, 0x60, 0x00, 0x24,
-  0xff, 0x61, 0x0e, 0x60, 0x00, 0x26, 0xff, 0x88, 0x0e, 0x60, 0x00, 0x37,
-  0xff, 0xdc, 0x0e, 0x60, 0x00, 0x44, 0xfe, 0xad, 0x0e, 0x60, 0x00, 0x46,
-  0xfe, 0xa4, 0x0e, 0x60, 0x00, 0x48, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0x4c,
-  0xff, 0xc1, 0x0e, 0x60, 0x00, 0x52, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0x55,
-  0xfe, 0xd3, 0x0e, 0x60, 0x00, 0x56, 0xfe, 0xad, 0x0e, 0x60, 0x00, 0x58,
-  0xfe, 0xc9, 0x0e, 0x60, 0x00, 0x5a, 0xfe, 0xad, 0x0e, 0x60, 0x00, 0x5c,
-  0xfe, 0xc1, 0x0e, 0x60, 0x00, 0x6d, 0xff, 0x44, 0x0e, 0x60, 0x00, 0x7d,
-  0xff, 0x90, 0x0e, 0x60, 0x00, 0x82, 0xff, 0x61, 0x0e, 0x60, 0x00, 0x83,
-  0xff, 0x61, 0x0e, 0x60, 0x00, 0x84, 0xff, 0x61, 0x0e, 0x60, 0x00, 0x85,
-  0xff, 0x61, 0x0e, 0x60, 0x00, 0x86, 0xff, 0x61, 0x0e, 0x60, 0x00, 0x89,
-  0xff, 0x88, 0x0e, 0x60, 0x00, 0xa2, 0xff, 0x11, 0x0e, 0x60, 0x00, 0xa3,
-  0xfe, 0xad, 0x0e, 0x60, 0x00, 0xa4, 0xff, 0x11, 0x0e, 0x60, 0x00, 0xa5,
-  0xff, 0x11, 0x0e, 0x60, 0x00, 0xa6, 0xff, 0x11, 0x0e, 0x60, 0x00, 0xa7,
-  0xff, 0x11, 0x0e, 0x60, 0x00, 0xa9, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xaa,
-  0xfe, 0xe0, 0x0e, 0x60, 0x00, 0xab, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xac,
-  0xfe, 0xe0, 0x0e, 0x60, 0x00, 0xad, 0xfe, 0xe0, 0x0e, 0x60, 0x00, 0xb4,
-  0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xb5, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xb6,
-  0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xb7, 0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xb8,
-  0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xbb, 0xfe, 0xe7, 0x0e, 0x60, 0x00, 0xbc,
-  0xfe, 0xc9, 0x0e, 0x60, 0x00, 0xbd, 0xfe, 0xe7, 0x0e, 0x60, 0x00, 0xbe,
-  0xfe, 0xe7, 0x0e, 0x60, 0x00, 0xbf, 0xfe, 0xc1, 0x0e, 0x60, 0x00, 0xc1,
-  0xfe, 0xc1, 0x0e, 0x60, 0x00, 0xc8, 0xff, 0x88, 0x0e, 0x60, 0x00, 0xc9,
-  0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xce, 0xff, 0x88, 0x0e, 0x60, 0x00, 0xcf,
-  0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xdd, 0xfe, 0xa4, 0x0e, 0x60, 0x01, 0x17,
-  0xfe, 0xd3, 0x0e, 0x60, 0x01, 0x1b, 0xfe, 0xd3, 0x0e, 0x60, 0x01, 0x21,
-  0xfe, 0xad, 0x0e, 0x60, 0x01, 0x23, 0xfe, 0xad, 0x0e, 0x60, 0x01, 0x26,
-  0xff, 0xdc, 0x0e, 0x60, 0x01, 0x31, 0xfe, 0xc9, 0x0e, 0x60, 0x07, 0x52,
-  0xff, 0xd3, 0x0e, 0x60, 0x07, 0x53, 0xfe, 0xf8, 0x0e, 0x78, 0x00, 0x10,
-  0xff, 0x29, 0x0e, 0x78, 0x00, 0x24, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0x26,
-  0xff, 0x90, 0x0e, 0x78, 0x00, 0x32, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x37,
-  0xff, 0x61, 0x0e, 0x78, 0x00, 0x38, 0xff, 0xc9, 0x0e, 0x78, 0x00, 0x3a,
-  0xff, 0xb7, 0x0e, 0x78, 0x00, 0x3c, 0xff, 0xb7, 0x0e, 0x78, 0x00, 0x44,
-  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x48, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0x52,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0x58, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0x5c,
-  0xff, 0x6b, 0x0e, 0x78, 0x00, 0x6d, 0xff, 0x7d, 0x0e, 0x78, 0x00, 0x82,
-  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x83, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0x84,
-  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x85, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0x86,
-  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x89, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x94,
-  0xff, 0x90, 0x0e, 0x78, 0x00, 0x95, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x96,
-  0xff, 0x90, 0x0e, 0x78, 0x00, 0x97, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x98,
-  0xff, 0x90, 0x0e, 0x78, 0x00, 0x9b, 0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9c,
-  0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9d, 0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9e,
-  0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9f, 0xff, 0xb7, 0x0e, 0x78, 0x00, 0xa2,
-  0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa3, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa4,
-  0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa5, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa6,
-  0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa7, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0xaa,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xab, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xac,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xad, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb4,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb5, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb6,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb7, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb8,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbb, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbc,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbd, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbe,
-  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbf, 0xff, 0x6b, 0x0e, 0x78, 0x00, 0xc1,
-  0xff, 0x6b, 0x0e, 0x78, 0x00, 0xc8, 0xff, 0x90, 0x0e, 0x78, 0x00, 0xce,
-  0xff, 0x90, 0x0e, 0x78, 0x00, 0xdd, 0xff, 0x9a, 0x0e, 0x78, 0x01, 0x26,
-  0xff, 0x61, 0x0e, 0x78, 0x01, 0x30, 0xff, 0xc9, 0x0e, 0x78, 0x01, 0x31,
-  0xff, 0x9a, 0x0e, 0x78, 0x01, 0x3a, 0xff, 0xb7, 0x0e, 0x78, 0x07, 0x51,
-  0xff, 0xc1, 0x0e, 0x78, 0x07, 0x52, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0x44,
-  0xff, 0xdc, 0x0e, 0x79, 0x00, 0x48, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0x52,
-  0xff, 0xb7, 0x0e, 0x79, 0x00, 0x58, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0x5c,
-  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xa2, 0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa3,
-  0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa4, 0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa5,
-  0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa6, 0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa7,
-  0xff, 0xdc, 0x0e, 0x79, 0x00, 0xaa, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xab,
-  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xac, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xad,
-  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb4, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb5,
-  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb6, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb7,
-  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb8, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xbb,
-  0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbc, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbd,
-  0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbe, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbf,
-  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xc1, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xdd,
-  0xff, 0xb7, 0x0e, 0x79, 0x01, 0x31, 0xff, 0xc1, 0x0e, 0xaa, 0x0e, 0xc2,
-  0xff, 0xd8, 0x0e, 0xab, 0x0e, 0xc2, 0xff, 0xb1, 0x0e, 0xac, 0x0e, 0xc2,
-  0xff, 0xa3, 0x0e, 0xad, 0x0e, 0xc2, 0xff, 0x9c, 0x0e, 0xae, 0x0e, 0xc2,
-  0xff, 0xd8, 0x0e, 0xb0, 0x0e, 0xc2, 0xff, 0xd8, 0x0e, 0xb1, 0x0e, 0xc2,
-  0xff, 0xb1, 0x0e, 0xb2, 0x0e, 0xc2, 0xff, 0xa3, 0x0e, 0xb3, 0x0e, 0xc2,
-  0xff, 0xb1, 0x0e, 0xb4, 0x0e, 0xc2, 0xff, 0xd8, 0x0e, 0xb6, 0x0e, 0xc2,
-  0xff, 0xd8, 0x0e, 0xb7, 0x0e, 0xc2, 0xff, 0xb1, 0x0e, 0xb8, 0x0e, 0xc2,
-  0xff, 0xa3, 0x0e, 0xb9, 0x0e, 0xc2, 0xff, 0xb1, 0x0e, 0xba, 0x0e, 0xc2,
-  0xff, 0xd8, 0x0e, 0xbc, 0x0e, 0xc2, 0xff, 0xd8, 0x0e, 0xbd, 0x0e, 0xc2,
-  0xff, 0x9c, 0x0e, 0xbe, 0x0e, 0xc2, 0xff, 0xa3, 0x0e, 0xbf, 0x0e, 0xc2,
-  0xff, 0xb1, 0x0e, 0xc0, 0x0e, 0xc2, 0xff, 0xd8, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x2c,
-  0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x58, 0x00, 0x00, 0x00, 0x80,
-  0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0x01, 0x90, 0x00, 0x00, 0x02, 0x2c,
-  0x00, 0x00, 0x02, 0xc8, 0x00, 0x00, 0x02, 0xe4, 0x00, 0x00, 0x03, 0x20,
-  0x00, 0x00, 0x03, 0x58, 0x00, 0x00, 0x03, 0xa4, 0x00, 0x00, 0x03, 0xd8,
-  0x00, 0x00, 0x03, 0xf8, 0x00, 0x00, 0x04, 0x14, 0x00, 0x00, 0x04, 0x2c,
-  0x00, 0x00, 0x04, 0x48, 0x00, 0x00, 0x04, 0xa4, 0x00, 0x00, 0x04, 0xd4,
-  0x00, 0x00, 0x05, 0x34, 0x00, 0x00, 0x05, 0xac, 0x00, 0x00, 0x05, 0xe8,
-  0x00, 0x00, 0x06, 0x48, 0x00, 0x00, 0x06, 0xc0, 0x00, 0x00, 0x06, 0xe8,
-  0x00, 0x00, 0x07, 0x74, 0x00, 0x00, 0x07, 0xec, 0x00, 0x00, 0x08, 0x10,
-  0x00, 0x00, 0x08, 0x3c, 0x00, 0x00, 0x08, 0x68, 0x00, 0x00, 0x08, 0x90,
-  0x00, 0x00, 0x08, 0xb8, 0x00, 0x00, 0x09, 0x2c, 0x00, 0x00, 0x0a, 0x14,
-  0x00, 0x00, 0x0a, 0x4c, 0x00, 0x00, 0x0a, 0xb8, 0x00, 0x00, 0x0b, 0x14,
-  0x00, 0x00, 0x0b, 0x64, 0x00, 0x00, 0x0b, 0x94, 0x00, 0x00, 0x0b, 0xc0,
-  0x00, 0x00, 0x0c, 0x28, 0x00, 0x00, 0x0c, 0x58, 0x00, 0x00, 0x0c, 0x74,
-  0x00, 0x00, 0x0c, 0xa0, 0x00, 0x00, 0x0c, 0xd4, 0x00, 0x00, 0x0c, 0xf4,
-  0x00, 0x00, 0x0d, 0x30, 0x00, 0x00, 0x0d, 0x60, 0x00, 0x00, 0x0d, 0xc4,
-  0x00, 0x00, 0x0e, 0x08, 0x00, 0x00, 0x0e, 0x7c, 0x00, 0x00, 0x0e, 0xe0,
-  0x00, 0x00, 0x0f, 0x58, 0x00, 0x00, 0x0f, 0x80, 0x00, 0x00, 0x0f, 0xc4,
-  0x00, 0x00, 0x0f, 0xf0, 0x00, 0x00, 0x10, 0x30, 0x00, 0x00, 0x10, 0x70,
-  0x00, 0x00, 0x10, 0xa0, 0x00, 0x00, 0x10, 0xd0, 0x00, 0x00, 0x10, 0xf4,
-  0x00, 0x00, 0x11, 0x14, 0x00, 0x00, 0x11, 0x38, 0x00, 0x00, 0x11, 0x64,
-  0x00, 0x00, 0x11, 0x80, 0x00, 0x00, 0x11, 0xa0, 0x00, 0x00, 0x12, 0x10,
-  0x00, 0x00, 0x12, 0x70, 0x00, 0x00, 0x12, 0xc8, 0x00, 0x00, 0x13, 0x28,
-  0x00, 0x00, 0x13, 0x8c, 0x00, 0x00, 0x13, 0xcc, 0x00, 0x00, 0x14, 0x48,
-  0x00, 0x00, 0x14, 0x8c, 0x00, 0x00, 0x14, 0xb0, 0x00, 0x00, 0x14, 0xe8,
-  0x00, 0x00, 0x15, 0x1c, 0x00, 0x00, 0x15, 0x38, 0x00, 0x00, 0x15, 0xa0,
-  0x00, 0x00, 0x15, 0xe4, 0x00, 0x00, 0x16, 0x38, 0x00, 0x00, 0x16, 0x98,
-  0x00, 0x00, 0x16, 0xf8, 0x00, 0x00, 0x17, 0x38, 0x00, 0x00, 0x17, 0xb0,
-  0x00, 0x00, 0x17, 0xf4, 0x00, 0x00, 0x18, 0x3c, 0x00, 0x00, 0x18, 0x64,
-  0x00, 0x00, 0x18, 0xa0, 0x00, 0x00, 0x18, 0xe0, 0x00, 0x00, 0x19, 0x20,
-  0x00, 0x00, 0x19, 0x50, 0x00, 0x00, 0x19, 0xb4, 0x00, 0x00, 0x19, 0xd0,
-  0x00, 0x00, 0x1a, 0x34, 0x00, 0x00, 0x1a, 0x94, 0x00, 0x00, 0x1a, 0x94,
-  0x00, 0x00, 0x1a, 0xc4, 0x00, 0x00, 0x1b, 0x3c, 0x00, 0x00, 0x1b, 0x94,
-  0x00, 0x00, 0x1c, 0x28, 0x00, 0x00, 0x1c, 0x84, 0x00, 0x00, 0x1c, 0xb0,
-  0x00, 0x00, 0x1d, 0x68, 0x00, 0x00, 0x1d, 0x90, 0x00, 0x00, 0x1e, 0x6c,
-  0x00, 0x00, 0x1e, 0xe8, 0x00, 0x00, 0x1f, 0x2c, 0x00, 0x00, 0x1f, 0x4c,
-  0x00, 0x00, 0x1f, 0x68, 0x00, 0x00, 0x20, 0x50, 0x00, 0x00, 0x20, 0x6c,
-  0x00, 0x00, 0x20, 0xc4, 0x00, 0x00, 0x21, 0x04, 0x00, 0x00, 0x21, 0x58,
-  0x00, 0x00, 0x21, 0xcc, 0x00, 0x00, 0x21, 0xe8, 0x00, 0x00, 0x22, 0x4c,
-  0x00, 0x00, 0x22, 0x84, 0x00, 0x00, 0x22, 0x9c, 0x00, 0x00, 0x22, 0xe0,
-  0x00, 0x00, 0x23, 0x0c, 0x00, 0x00, 0x23, 0x68, 0x00, 0x00, 0x23, 0xb0,
-  0x00, 0x00, 0x23, 0xd0, 0x00, 0x00, 0x23, 0xf0, 0x00, 0x00, 0x24, 0x10,
-  0x00, 0x00, 0x24, 0x84, 0x00, 0x00, 0x24, 0x9c, 0x00, 0x00, 0x24, 0xb4,
-  0x00, 0x00, 0x24, 0xd0, 0x00, 0x00, 0x24, 0xec, 0x00, 0x00, 0x25, 0x08,
-  0x00, 0x00, 0x25, 0x7c, 0x00, 0x00, 0x25, 0xcc, 0x00, 0x00, 0x25, 0xe4,
-  0x00, 0x00, 0x25, 0xfc, 0x00, 0x00, 0x26, 0x14, 0x00, 0x00, 0x26, 0x30,
-  0x00, 0x00, 0x26, 0x4c, 0x00, 0x00, 0x26, 0x64, 0x00, 0x00, 0x26, 0x7c,
-  0x00, 0x00, 0x26, 0x98, 0x00, 0x00, 0x26, 0xb4, 0x00, 0x00, 0x27, 0x18,
-  0x00, 0x00, 0x27, 0x34, 0x00, 0x00, 0x27, 0x4c, 0x00, 0x00, 0x27, 0x64,
-  0x00, 0x00, 0x27, 0x80, 0x00, 0x00, 0x27, 0x9c, 0x00, 0x00, 0x27, 0xb8,
-  0x00, 0x00, 0x27, 0xfc, 0x00, 0x00, 0x28, 0x94, 0x00, 0x00, 0x28, 0xac,
-  0x00, 0x00, 0x28, 0xc4, 0x00, 0x00, 0x28, 0xe0, 0x00, 0x00, 0x28, 0xfc,
-  0x00, 0x00, 0x29, 0x14, 0x00, 0x00, 0x29, 0x5c, 0x00, 0x00, 0x29, 0xe8,
-  0x00, 0x00, 0x2a, 0x00, 0x00, 0x00, 0x2a, 0x18, 0x00, 0x00, 0x2a, 0x30,
-  0x00, 0x00, 0x2a, 0x48, 0x00, 0x00, 0x2a, 0x60, 0x00, 0x00, 0x2a, 0x78,
-  0x00, 0x00, 0x2b, 0x30, 0x00, 0x00, 0x2b, 0x48, 0x00, 0x00, 0x2b, 0x60,
-  0x00, 0x00, 0x2b, 0x78, 0x00, 0x00, 0x2b, 0x90, 0x00, 0x00, 0x2b, 0xa8,
-  0x00, 0x00, 0x2b, 0xc0, 0x00, 0x00, 0x2b, 0xd8, 0x00, 0x00, 0x2b, 0xf4,
-  0x00, 0x00, 0x2c, 0x10, 0x00, 0x00, 0x2c, 0x98, 0x00, 0x00, 0x2c, 0xb0,
-  0x00, 0x00, 0x2c, 0xc8, 0x00, 0x00, 0x2c, 0xe0, 0x00, 0x00, 0x2c, 0xf8,
-  0x00, 0x00, 0x2d, 0x10, 0x00, 0x00, 0x2d, 0x28, 0x00, 0x00, 0x2d, 0x5c,
-  0x00, 0x00, 0x2d, 0xec, 0x00, 0x00, 0x2e, 0x04, 0x00, 0x00, 0x2e, 0x1c,
-  0x00, 0x00, 0x2e, 0x34, 0x00, 0x00, 0x2e, 0x4c, 0x00, 0x00, 0x2e, 0x64,
-  0x00, 0x00, 0x2e, 0xc4, 0x00, 0x00, 0x2e, 0xdc, 0x00, 0x00, 0x2e, 0xf8,
-  0x00, 0x00, 0x2f, 0x10, 0x00, 0x00, 0x2f, 0x2c, 0x00, 0x00, 0x2f, 0x44,
-  0x00, 0x00, 0x2f, 0x5c, 0x00, 0x00, 0x2f, 0x74, 0x00, 0x00, 0x2f, 0x8c,
-  0x00, 0x00, 0x2f, 0xa4, 0x00, 0x00, 0x2f, 0xc0, 0x00, 0x00, 0x2f, 0xd8,
-  0x00, 0x00, 0x2f, 0xf0, 0x00, 0x00, 0x30, 0x08, 0x00, 0x00, 0x30, 0x24,
-  0x00, 0x00, 0x30, 0x3c, 0x00, 0x00, 0x30, 0x54, 0x00, 0x00, 0x30, 0x70,
-  0x00, 0x00, 0x30, 0x80, 0x00, 0x00, 0x30, 0xf4, 0x00, 0x00, 0x31, 0x0c,
-  0x00, 0x00, 0x31, 0x28, 0x00, 0x00, 0x31, 0x44, 0x00, 0x00, 0x31, 0x60,
-  0x00, 0x00, 0x31, 0x78, 0x00, 0x00, 0x31, 0x90, 0x00, 0x00, 0x31, 0xa8,
-  0x00, 0x00, 0x31, 0xc0, 0x00, 0x00, 0x31, 0xdc, 0x00, 0x00, 0x31, 0xf8,
-  0x00, 0x00, 0x32, 0x14, 0x00, 0x00, 0x32, 0x2c, 0x00, 0x00, 0x32, 0x44,
-  0x00, 0x00, 0x32, 0x5c, 0x00, 0x00, 0x32, 0x78, 0x00, 0x00, 0x32, 0x90,
-  0x00, 0x00, 0x32, 0xa8, 0x00, 0x00, 0x32, 0xc0, 0x00, 0x00, 0x32, 0xdc,
-  0x00, 0x00, 0x32, 0xf8, 0x00, 0x00, 0x33, 0x44, 0x00, 0x00, 0x33, 0x9c,
-  0x00, 0x00, 0x33, 0xb8, 0x00, 0x00, 0x33, 0xd4, 0x00, 0x00, 0x33, 0xf0,
-  0x00, 0x00, 0x34, 0x0c, 0x00, 0x00, 0x34, 0x28, 0x00, 0x00, 0x34, 0x44,
-  0x00, 0x00, 0x34, 0x5c, 0x00, 0x00, 0x34, 0x74, 0x00, 0x00, 0x34, 0x90,
-  0x00, 0x00, 0x34, 0xb0, 0x00, 0x00, 0x34, 0xcc, 0x00, 0x00, 0x34, 0xe8,
-  0x00, 0x00, 0x35, 0x04, 0x00, 0x00, 0x35, 0x20, 0x00, 0x00, 0x35, 0x38,
-  0x00, 0x00, 0x35, 0x50, 0x00, 0x00, 0x35, 0x84, 0x00, 0x00, 0x35, 0x9c,
-  0x00, 0x00, 0x35, 0xb8, 0x00, 0x00, 0x35, 0xd0, 0x00, 0x00, 0x35, 0xec,
-  0x00, 0x00, 0x36, 0x04, 0x00, 0x00, 0x36, 0x20, 0x00, 0x00, 0x36, 0x38,
-  0x00, 0x00, 0x36, 0x54, 0x00, 0x00, 0x36, 0x90, 0x00, 0x00, 0x36, 0xc4,
-  0x00, 0x00, 0x36, 0xe0, 0x00, 0x00, 0x36, 0xf8, 0x00, 0x00, 0x37, 0x10,
-  0x00, 0x00, 0x37, 0x28, 0x00, 0x00, 0x37, 0x44, 0x00, 0x00, 0x37, 0x5c,
-  0x00, 0x00, 0x37, 0x74, 0x00, 0x00, 0x37, 0xd0, 0x00, 0x00, 0x38, 0x30,
-  0x00, 0x00, 0x38, 0x4c, 0x00, 0x00, 0x38, 0x64, 0x00, 0x00, 0x38, 0x80,
-  0x00, 0x00, 0x38, 0x98, 0x00, 0x00, 0x38, 0xb0, 0x00, 0x00, 0x38, 0xc8,
-  0x00, 0x00, 0x39, 0x2c, 0x00, 0x00, 0x39, 0xcc, 0x00, 0x00, 0x39, 0xe4,
-  0x00, 0x00, 0x39, 0xfc, 0x00, 0x00, 0x3a, 0x14, 0x00, 0x00, 0x3a, 0x2c,
-  0x00, 0x00, 0x3a, 0x48, 0x00, 0x00, 0x3a, 0x60, 0x00, 0x00, 0x3a, 0x78,
-  0x00, 0x00, 0x3a, 0x90, 0x00, 0x00, 0x3a, 0xac, 0x00, 0x00, 0x3a, 0xc4,
-  0x00, 0x00, 0x3a, 0xdc, 0x00, 0x00, 0x3a, 0xf4, 0x00, 0x00, 0x3b, 0x10,
-  0x00, 0x00, 0x3b, 0x2c, 0x00, 0x00, 0x3b, 0x44, 0x00, 0x00, 0x3b, 0x5c,
-  0x00, 0x00, 0x3b, 0x78, 0x00, 0x00, 0x3b, 0x94, 0x00, 0x00, 0x3b, 0xcc,
-  0x00, 0x00, 0x3c, 0x24, 0x00, 0x00, 0x3c, 0x40, 0x00, 0x00, 0x3c, 0x58,
-  0x00, 0x00, 0x3c, 0x74, 0x00, 0x00, 0x3c, 0x8c, 0x00, 0x00, 0x3c, 0xa8,
-  0x00, 0x00, 0x3c, 0xc0, 0x00, 0x00, 0x3c, 0xd8, 0x00, 0x00, 0x3c, 0xf0,
-  0x00, 0x00, 0x3d, 0x08, 0x00, 0x00, 0x3d, 0x20, 0x00, 0x00, 0x3d, 0x38,
-  0x00, 0x00, 0x3d, 0x50, 0x00, 0x00, 0x3d, 0x6c, 0x00, 0x00, 0x3d, 0x88,
-  0x00, 0x00, 0x3d, 0xa4, 0x00, 0x00, 0x3d, 0xbc, 0x00, 0x00, 0x3d, 0xd8,
-  0x00, 0x00, 0x3d, 0xf0, 0x00, 0x00, 0x3e, 0x08, 0x00, 0x00, 0x3e, 0x20,
-  0x00, 0x00, 0x3e, 0x3c, 0x00, 0x00, 0x3e, 0x54, 0x00, 0x00, 0x3e, 0x6c,
-  0x00, 0x00, 0x3e, 0xa4, 0x00, 0x00, 0x3f, 0x2c, 0x00, 0x00, 0x3f, 0xb0,
-  0x00, 0x00, 0x3f, 0xc0, 0x00, 0x00, 0x40, 0x3c, 0x00, 0x00, 0x40, 0x94,
-  0x00, 0x00, 0x40, 0xfc, 0x00, 0x00, 0x41, 0x58, 0x00, 0x00, 0x41, 0xd0,
-  0x00, 0x00, 0x42, 0x3c, 0x00, 0x00, 0x42, 0x4c, 0x00, 0x00, 0x42, 0xb4,
-  0x00, 0x00, 0x43, 0x00, 0x00, 0x00, 0x43, 0x64, 0x00, 0x00, 0x43, 0xe4,
-  0x00, 0x00, 0x44, 0x18, 0x00, 0x00, 0x44, 0x80, 0x00, 0x00, 0x44, 0xf8,
-  0x00, 0x00, 0x45, 0x38, 0x00, 0x00, 0x45, 0x8c, 0x00, 0x00, 0x46, 0x08,
-  0x00, 0x00, 0x46, 0x88, 0x00, 0x00, 0x47, 0x08, 0x00, 0x00, 0x47, 0x34,
-  0x00, 0x00, 0x47, 0x60, 0x00, 0x00, 0x47, 0xb8, 0x00, 0x00, 0x48, 0x00,
-  0x00, 0x00, 0x48, 0x2c, 0x00, 0x00, 0x48, 0x74, 0x00, 0x00, 0x48, 0xec,
-  0x00, 0x00, 0x49, 0x2c, 0x00, 0x00, 0x49, 0x3c, 0x00, 0x00, 0x49, 0xac,
-  0x00, 0x00, 0x49, 0xc4, 0x00, 0x00, 0x49, 0xdc, 0x00, 0x00, 0x4a, 0x50,
-  0x00, 0x00, 0x4a, 0xc0, 0x00, 0x00, 0x4b, 0x1c, 0x00, 0x00, 0x4b, 0x8c,
-  0x00, 0x00, 0x4b, 0xf0, 0x00, 0x00, 0x4c, 0x5c, 0x00, 0x00, 0x4c, 0xd4,
-  0x00, 0x00, 0x4c, 0xe4, 0x00, 0x00, 0x4d, 0x48, 0x00, 0x00, 0x4d, 0xa0,
-  0x00, 0x00, 0x4d, 0xd8, 0x00, 0x00, 0x4e, 0x2c, 0x00, 0x00, 0x4e, 0x64,
-  0x00, 0x00, 0x4e, 0x7c, 0x00, 0x00, 0x4e, 0x94, 0x00, 0x00, 0x4f, 0x04,
-  0x00, 0x00, 0x4f, 0x64, 0x00, 0x00, 0x4f, 0xbc, 0x00, 0x00, 0x50, 0x24,
-  0x00, 0x00, 0x50, 0x6c, 0x00, 0x00, 0x50, 0xb0, 0x00, 0x00, 0x51, 0x20,
-  0x00, 0x00, 0x51, 0x90, 0x00, 0x00, 0x51, 0xfc, 0x00, 0x00, 0x52, 0x68,
-  0x00, 0x00, 0x52, 0xdc, 0x00, 0x00, 0x53, 0x38, 0x00, 0x00, 0x53, 0x90,
-  0x00, 0x00, 0x54, 0x00, 0x00, 0x00, 0x54, 0x54, 0x00, 0x00, 0x54, 0x70,
-  0x00, 0x00, 0x54, 0x88, 0x00, 0x00, 0x54, 0xcc, 0x00, 0x00, 0x54, 0xdc,
-  0x00, 0x00, 0x54, 0xf4, 0x00, 0x00, 0x55, 0x0c, 0x00, 0x00, 0x55, 0x24,
-  0x00, 0x00, 0x55, 0x3c, 0x00, 0x00, 0x55, 0x54, 0x00, 0x00, 0x55, 0x6c,
-  0x00, 0x00, 0x55, 0x84, 0x00, 0x00, 0x55, 0x9c, 0x00, 0x00, 0x55, 0xb4,
-  0x00, 0x00, 0x55, 0xd0, 0x00, 0x00, 0x55, 0xe8, 0x00, 0x00, 0x56, 0x04,
-  0x00, 0x00, 0x56, 0x20, 0x00, 0x00, 0x56, 0x38, 0x00, 0x00, 0x56, 0x50,
-  0x00, 0x00, 0x56, 0x6c, 0x00, 0x00, 0x56, 0x84, 0x00, 0x00, 0x56, 0x9c,
-  0x00, 0x00, 0x56, 0xb4, 0x00, 0x00, 0x56, 0xcc, 0x00, 0x00, 0x56, 0xe4,
-  0x00, 0x00, 0x56, 0xfc, 0x00, 0x00, 0x57, 0x14, 0x00, 0x00, 0x57, 0x2c,
-  0x00, 0x00, 0x57, 0x44, 0x00, 0x00, 0x57, 0x54, 0x00, 0x00, 0x57, 0x6c,
-  0x00, 0x00, 0x57, 0x84, 0x00, 0x00, 0x57, 0x9c, 0x00, 0x00, 0x57, 0xb4,
-  0x00, 0x00, 0x57, 0xcc, 0x00, 0x00, 0x57, 0xe4, 0x00, 0x00, 0x58, 0x5c,
-  0x00, 0x00, 0x58, 0xf8, 0x00, 0x00, 0x59, 0x14, 0x00, 0x00, 0x59, 0x2c,
-  0x00, 0x00, 0x59, 0x44, 0x00, 0x00, 0x59, 0x60, 0x00, 0x00, 0x59, 0x78,
-  0x00, 0x00, 0x59, 0x90, 0x00, 0x00, 0x59, 0xa8, 0x00, 0x00, 0x59, 0xc0,
-  0x00, 0x00, 0x59, 0xd8, 0x00, 0x00, 0x59, 0xf0, 0x00, 0x00, 0x5a, 0x0c,
-  0x00, 0x00, 0x5a, 0x24, 0x00, 0x00, 0x5a, 0x3c, 0x00, 0x00, 0x5a, 0x54,
-  0x00, 0x00, 0x5a, 0x6c, 0x00, 0x00, 0x5a, 0x84, 0x00, 0x00, 0x5a, 0xe4,
-  0x00, 0x00, 0x5b, 0x3c, 0x00, 0x00, 0x5b, 0x54, 0x00, 0x00, 0x5b, 0x6c,
-  0x00, 0x00, 0x5b, 0x84, 0x00, 0x00, 0x5b, 0x9c, 0x00, 0x00, 0x5b, 0xb4,
-  0x00, 0x00, 0x5b, 0xcc, 0x00, 0x00, 0x5b, 0xe4, 0x00, 0x00, 0x5b, 0xfc,
-  0x00, 0x00, 0x5c, 0x14, 0x00, 0x00, 0x5c, 0x2c, 0x00, 0x00, 0x5c, 0x44,
-  0x00, 0x00, 0x5c, 0x5c, 0x00, 0x00, 0x5c, 0x74, 0x00, 0x00, 0x5c, 0x8c,
-  0x00, 0x00, 0x5c, 0xa4, 0x00, 0x00, 0x5c, 0xbc, 0x00, 0x00, 0x5c, 0xd4,
-  0x00, 0x00, 0x5c, 0xec, 0x00, 0x00, 0x5d, 0x04, 0x00, 0x00, 0x5d, 0x1c,
-  0x00, 0x00, 0x5d, 0x34, 0x00, 0x00, 0x5d, 0x4c, 0x00, 0x00, 0x5d, 0x64,
-  0x00, 0x00, 0x5d, 0x7c, 0x00, 0x00, 0x5d, 0x94, 0x00, 0x00, 0x5d, 0xac,
-  0x00, 0x00, 0x5d, 0xc4, 0x00, 0x00, 0x5d, 0xdc, 0x00, 0x00, 0x5d, 0xf4,
-  0x00, 0x00, 0x5e, 0x0c, 0x00, 0x00, 0x5e, 0x24, 0x00, 0x00, 0x5e, 0x3c,
-  0x00, 0x00, 0x5e, 0x54, 0x00, 0x00, 0x5e, 0x6c, 0x00, 0x00, 0x5e, 0x84,
-  0x00, 0x00, 0x5e, 0x9c, 0x00, 0x00, 0x5f, 0x24, 0x00, 0x00, 0x5f, 0xb4,
-  0x00, 0x00, 0x5f, 0xcc, 0x00, 0x00, 0x5f, 0xe8, 0x00, 0x00, 0x60, 0x2c,
-  0x00, 0x00, 0x60, 0xd0, 0x00, 0x00, 0x61, 0x84, 0x00, 0x00, 0x62, 0x28,
-  0x00, 0x00, 0x62, 0x74, 0x00, 0x00, 0x62, 0xc0, 0x00, 0x00, 0x62, 0xd8,
-  0x00, 0x00, 0x62, 0xf0, 0x00, 0x00, 0x63, 0x08, 0x00, 0x00, 0x63, 0x20,
-  0x00, 0x00, 0x63, 0x38, 0x00, 0x00, 0x63, 0x50, 0x00, 0x00, 0x63, 0x68,
-  0x00, 0x00, 0x63, 0x80, 0x00, 0x00, 0x63, 0x98, 0x00, 0x00, 0x63, 0xb0,
-  0x00, 0x00, 0x63, 0xc8, 0x00, 0x00, 0x63, 0xe0, 0x00, 0x00, 0x63, 0xf8,
-  0x00, 0x00, 0x64, 0x10, 0x00, 0x00, 0x64, 0x64, 0x00, 0x00, 0x64, 0xe8,
-  0x00, 0x00, 0x65, 0x50, 0x00, 0x00, 0x65, 0x7c, 0x00, 0x00, 0x66, 0x1c,
-  0x00, 0x00, 0x66, 0xbc, 0x00, 0x00, 0x67, 0x28, 0x00, 0x00, 0x67, 0xbc,
-  0x00, 0x00, 0x68, 0x48, 0x00, 0x00, 0x68, 0x7c, 0x00, 0x00, 0x68, 0xd0,
-  0x00, 0x00, 0x69, 0x88, 0x00, 0x00, 0x69, 0xe0, 0x00, 0x00, 0x6a, 0x2c,
-  0x00, 0x00, 0x6a, 0x7c, 0x00, 0x00, 0x6a, 0xfc, 0x00, 0x00, 0x6b, 0x5c,
-  0x00, 0x00, 0x6b, 0x6c, 0x00, 0x00, 0x6b, 0xd4, 0x00, 0x00, 0x6c, 0x80,
-  0x00, 0x00, 0x6c, 0xc0, 0x00, 0x00, 0x6d, 0x08, 0x00, 0x00, 0x6d, 0x84,
-  0x00, 0x00, 0x6d, 0xf8, 0x00, 0x00, 0x6e, 0x64, 0x00, 0x00, 0x6e, 0xb4,
-  0x00, 0x00, 0x6f, 0x00, 0x00, 0x00, 0x6f, 0x60, 0x00, 0x00, 0x6f, 0xd0,
-  0x00, 0x00, 0x70, 0x30, 0x00, 0x00, 0x70, 0x90, 0x00, 0x00, 0x71, 0x04,
-  0x00, 0x00, 0x71, 0x5c, 0x00, 0x00, 0x71, 0xec, 0x00, 0x00, 0x72, 0x60,
-  0x00, 0x00, 0x72, 0xd0, 0x00, 0x00, 0x73, 0x44, 0x00, 0x00, 0x73, 0xa4,
-  0x00, 0x00, 0x74, 0x4c, 0x00, 0x00, 0x74, 0x5c, 0x00, 0x00, 0x74, 0x6c,
-  0x00, 0x00, 0x75, 0x1c, 0x00, 0x00, 0x75, 0xac, 0x00, 0x00, 0x75, 0xec,
-  0x00, 0x00, 0x76, 0x7c, 0x00, 0x00, 0x76, 0xf0, 0x00, 0x00, 0x77, 0x50,
-  0x00, 0x00, 0x77, 0xcc, 0x00, 0x00, 0x78, 0x48, 0x00, 0x00, 0x78, 0x8c,
-  0x00, 0x00, 0x78, 0xe0, 0x00, 0x00, 0x79, 0x44, 0x00, 0x00, 0x79, 0x7c,
-  0x00, 0x00, 0x79, 0x8c, 0x00, 0x00, 0x79, 0xb8, 0x00, 0x00, 0x7a, 0x28,
-  0x00, 0x00, 0x7a, 0x78, 0x00, 0x00, 0x7a, 0xa8, 0x00, 0x00, 0x7b, 0x1c,
-  0x00, 0x00, 0x7b, 0x90, 0x00, 0x00, 0x7c, 0x04, 0x00, 0x00, 0x7c, 0x90,
-  0x00, 0x00, 0x7c, 0xe4, 0x00, 0x00, 0x7d, 0x40, 0x00, 0x00, 0x7d, 0x70,
-  0x00, 0x00, 0x7d, 0xd4, 0x00, 0x00, 0x7e, 0x38, 0x00, 0x00, 0x7e, 0xb8,
-  0x00, 0x00, 0x7e, 0xc8, 0x00, 0x00, 0x7f, 0x00, 0x00, 0x00, 0x7f, 0x38,
-  0x00, 0x00, 0x7f, 0x80, 0x00, 0x00, 0x7f, 0xc0, 0x00, 0x00, 0x80, 0x10,
-  0x00, 0x00, 0x80, 0x48, 0x00, 0x00, 0x80, 0x80, 0x00, 0x00, 0x80, 0xe4,
-  0x00, 0x00, 0x81, 0x44, 0x00, 0x00, 0x81, 0xd0, 0x00, 0x00, 0x82, 0x10,
-  0x00, 0x00, 0x82, 0x6c, 0x00, 0x00, 0x82, 0xac, 0x00, 0x00, 0x83, 0x0c,
-  0x00, 0x00, 0x83, 0x50, 0x00, 0x00, 0x83, 0x94, 0x00, 0x00, 0x83, 0xf4,
-  0x00, 0x00, 0x84, 0x58, 0x00, 0x00, 0x84, 0xbc, 0x00, 0x00, 0x84, 0xe4,
-  0x00, 0x00, 0x85, 0x1c, 0x00, 0x00, 0x85, 0x64, 0x00, 0x00, 0x85, 0x94,
-  0x00, 0x00, 0x85, 0xd8, 0x00, 0x00, 0x86, 0x48, 0x00, 0x00, 0x86, 0xb0,
-  0x00, 0x00, 0x87, 0x40, 0x00, 0x00, 0x87, 0x9c, 0x00, 0x00, 0x87, 0xfc,
-  0x00, 0x00, 0x88, 0x5c, 0x00, 0x00, 0x88, 0xcc, 0x00, 0x00, 0x89, 0x54,
-  0x00, 0x00, 0x89, 0x64, 0x00, 0x00, 0x89, 0xf8, 0x00, 0x00, 0x8a, 0x70,
-  0x00, 0x00, 0x8a, 0x80, 0x00, 0x00, 0x8a, 0xd4, 0x00, 0x00, 0x8b, 0x0c,
-  0x00, 0x00, 0x8b, 0x2c, 0x00, 0x00, 0x8b, 0xa0, 0x00, 0x00, 0x8c, 0x10,
-  0x00, 0x00, 0x8c, 0x80, 0x00, 0x00, 0x8d, 0x10, 0x00, 0x00, 0x8d, 0xd8,
-  0x00, 0x00, 0x8e, 0x94, 0x00, 0x00, 0x8f, 0x38, 0x00, 0x00, 0x8f, 0xc4,
-  0x00, 0x00, 0x90, 0x94, 0x00, 0x00, 0x91, 0x28, 0x00, 0x00, 0x91, 0xa0,
-  0x00, 0x00, 0x91, 0xdc, 0x00, 0x00, 0x92, 0x40, 0x00, 0x00, 0x92, 0x80,
-  0x00, 0x00, 0x92, 0xd0, 0x00, 0x00, 0x93, 0x34, 0x00, 0x00, 0x93, 0x78,
-  0x00, 0x00, 0x93, 0xcc, 0x00, 0x00, 0x94, 0x08, 0x00, 0x00, 0x94, 0x48,
-  0x00, 0x00, 0x94, 0x88, 0x00, 0x00, 0x94, 0xdc, 0x00, 0x00, 0x95, 0x48,
-  0x00, 0x00, 0x95, 0x80, 0x00, 0x00, 0x95, 0xc4, 0x00, 0x00, 0x95, 0xd4,
-  0x00, 0x00, 0x95, 0xec, 0x00, 0x00, 0x95, 0xfc, 0x00, 0x00, 0x96, 0x0c,
-  0x00, 0x00, 0x96, 0x30, 0x00, 0x00, 0x96, 0x64, 0x00, 0x00, 0x96, 0x9c,
-  0x00, 0x00, 0x96, 0xf8, 0x00, 0x00, 0x97, 0x58, 0x00, 0x00, 0x97, 0x80,
-  0x00, 0x00, 0x97, 0xa8, 0x00, 0x00, 0x97, 0xd0, 0x00, 0x00, 0x97, 0xf8,
-  0x00, 0x00, 0x98, 0x1c, 0x00, 0x00, 0x98, 0x44, 0x00, 0x00, 0x98, 0x60,
-  0x00, 0x00, 0x98, 0x70, 0x00, 0x00, 0x98, 0x8c, 0x00, 0x00, 0x98, 0xac,
-  0x00, 0x00, 0x98, 0xc8, 0x00, 0x00, 0x98, 0xdc, 0x00, 0x00, 0x98, 0xfc,
-  0x00, 0x00, 0x99, 0x18, 0x00, 0x00, 0x99, 0x40, 0x00, 0x00, 0x99, 0x5c,
-  0x00, 0x00, 0x99, 0x70, 0x00, 0x00, 0x99, 0x84, 0x00, 0x00, 0x99, 0xa8,
-  0x00, 0x00, 0x99, 0xcc, 0x00, 0x00, 0x99, 0xf8, 0x00, 0x00, 0x9a, 0x14,
-  0x00, 0x00, 0x9a, 0x48, 0x00, 0x00, 0x9a, 0x64, 0x00, 0x00, 0x9a, 0xb0,
-  0x00, 0x00, 0x9a, 0xf0, 0x00, 0x00, 0x9b, 0x4c, 0x00, 0x00, 0x9b, 0x78,
-  0x00, 0x00, 0x9b, 0xb0, 0x00, 0x00, 0x9b, 0xe4, 0x00, 0x00, 0x9c, 0x30,
-  0x00, 0x00, 0x9c, 0x4c, 0x00, 0x00, 0x9c, 0xe4, 0x00, 0x00, 0x9d, 0x1c,
-  0x00, 0x00, 0x9d, 0x2c, 0x00, 0x00, 0x9d, 0x4c, 0x00, 0x00, 0x9d, 0x70,
-  0x00, 0x00, 0x9d, 0x94, 0x00, 0x00, 0x9d, 0xb8, 0x00, 0x00, 0x9d, 0xd8,
-  0x00, 0x00, 0x9d, 0xec, 0x00, 0x00, 0x9e, 0x04, 0x00, 0x00, 0x9e, 0x14,
-  0x00, 0x00, 0x9e, 0x28, 0x00, 0x00, 0x9e, 0x94, 0x00, 0x00, 0x9e, 0xbc,
-  0x00, 0x00, 0x9e, 0xe0, 0x00, 0x00, 0x9f, 0x0c, 0x00, 0x00, 0x9f, 0x20,
-  0x00, 0x00, 0x9f, 0x34, 0x00, 0x00, 0x9f, 0x48, 0x00, 0x00, 0x9f, 0x5c,
-  0x00, 0x00, 0x9f, 0x7c, 0x00, 0x00, 0x9f, 0xa8, 0x00, 0x00, 0x9f, 0xfc,
-  0x00, 0x00, 0xa0, 0x10, 0x00, 0x00, 0xa0, 0x24, 0x00, 0x00, 0xa0, 0x50,
-  0x00, 0x00, 0xa0, 0x6c, 0x00, 0x00, 0xa0, 0x88, 0x00, 0x00, 0xa0, 0xb4,
-  0x00, 0x00, 0xa0, 0xd0, 0x00, 0x00, 0xa1, 0x04, 0x00, 0x00, 0xa1, 0x20,
-  0x00, 0x00, 0xa1, 0x48, 0x00, 0x00, 0xa1, 0x6c, 0x00, 0x00, 0xa1, 0x88,
-  0x00, 0x00, 0xa1, 0x9c, 0x00, 0x00, 0xa1, 0xb0, 0x00, 0x00, 0xa1, 0xd4,
-  0x00, 0x00, 0xa1, 0xf4, 0x00, 0x00, 0xa2, 0x14, 0x00, 0x00, 0xa2, 0x58,
-  0x00, 0x00, 0xa2, 0x8c, 0x00, 0x00, 0xa2, 0xb0, 0x00, 0x00, 0xa2, 0xd4,
-  0x00, 0x00, 0xa3, 0x00, 0x00, 0x00, 0xa3, 0x1c, 0x00, 0x00, 0xa3, 0x4c,
-  0x00, 0x00, 0xa3, 0x7c, 0x00, 0x00, 0xa3, 0x94, 0x00, 0x00, 0xa3, 0xa8,
-  0x00, 0x00, 0xa3, 0xf4, 0x00, 0x00, 0xa4, 0x10, 0x00, 0x00, 0xa4, 0x24,
-  0x00, 0x00, 0xa4, 0x38, 0x00, 0x00, 0xa4, 0x54, 0x00, 0x00, 0xa4, 0x78,
-  0x00, 0x00, 0xa4, 0xc0, 0x00, 0x00, 0xa4, 0xd4, 0x00, 0x00, 0xa4, 0xe8,
-  0x00, 0x00, 0xa4, 0xfc, 0x00, 0x00, 0xa5, 0x30, 0x00, 0x00, 0xa5, 0x44,
-  0x00, 0x00, 0xa5, 0x58, 0x00, 0x00, 0xa5, 0x6c, 0x00, 0x00, 0xa5, 0x80,
-  0x00, 0x00, 0xa5, 0xdc, 0x00, 0x00, 0xa5, 0xf8, 0x00, 0x00, 0xa6, 0x14,
-  0x00, 0x00, 0xa6, 0x34, 0x00, 0x00, 0xa6, 0x54, 0x00, 0x00, 0xa6, 0x84,
-  0x00, 0x00, 0xa6, 0xa8, 0x00, 0x00, 0xa6, 0xd0, 0x00, 0x00, 0xa7, 0x18,
-  0x00, 0x00, 0xa7, 0x4c, 0x00, 0x00, 0xa7, 0xac, 0x00, 0x00, 0xa7, 0xc8,
-  0x00, 0x00, 0xa7, 0xdc, 0x00, 0x00, 0xa7, 0xf0, 0x00, 0x00, 0xa8, 0x04,
-  0x00, 0x00, 0xa8, 0x14, 0x00, 0x00, 0xa8, 0x28, 0x00, 0x00, 0xa8, 0x3c,
-  0x00, 0x00, 0xa8, 0x60, 0x00, 0x00, 0xa8, 0x88, 0x00, 0x00, 0xa8, 0xb0,
-  0x00, 0x00, 0xa8, 0xd0, 0x00, 0x00, 0xa9, 0x4c, 0x00, 0x00, 0xa9, 0xc0,
-  0x00, 0x00, 0xa9, 0xd8, 0x00, 0x00, 0xaa, 0x10, 0x00, 0x00, 0xaa, 0x38,
-  0x00, 0x00, 0xaa, 0x38, 0x00, 0x00, 0xaa, 0x78, 0x00, 0x00, 0xaa, 0x90,
-  0x00, 0x00, 0xaa, 0xa4, 0x00, 0x00, 0xaa, 0xe4, 0x00, 0x00, 0xaa, 0xf8,
-  0x00, 0x00, 0xab, 0x5c, 0x00, 0x00, 0xab, 0x70, 0x00, 0x00, 0xab, 0x84,
-  0x00, 0x00, 0xab, 0xa0, 0x00, 0x00, 0xab, 0xbc, 0x00, 0x00, 0xac, 0x30,
-  0x00, 0x00, 0xac, 0x44, 0x00, 0x00, 0xac, 0x6c, 0x00, 0x00, 0xac, 0x7c,
-  0x00, 0x00, 0xac, 0x8c, 0x00, 0x00, 0xac, 0xbc, 0x00, 0x00, 0xac, 0xec,
-  0x00, 0x00, 0xad, 0x08, 0x00, 0x00, 0xad, 0x24, 0x00, 0x00, 0xad, 0x34,
-  0x00, 0x00, 0xad, 0x44, 0x00, 0x00, 0xad, 0x78, 0x00, 0x00, 0xad, 0x88,
-  0x00, 0x00, 0xad, 0xa0, 0x00, 0x00, 0xad, 0xb8, 0x00, 0x00, 0xad, 0xc8,
-  0x00, 0x00, 0xad, 0xe4, 0x00, 0x00, 0xae, 0x00, 0x00, 0x00, 0xae, 0x18,
-  0x00, 0x00, 0xae, 0x28, 0x00, 0x00, 0xae, 0x44, 0x00, 0x00, 0xae, 0x60,
-  0x00, 0x00, 0xae, 0x7c, 0x00, 0x00, 0xae, 0x94, 0x00, 0x00, 0xae, 0xb0,
-  0x00, 0x00, 0xae, 0xc8, 0x00, 0x00, 0xae, 0xe0, 0x00, 0x00, 0xae, 0xf0,
-  0x00, 0x00, 0xaf, 0x00, 0x00, 0x00, 0xaf, 0x20, 0x00, 0x00, 0xaf, 0x50,
-  0x00, 0x00, 0xaf, 0x60, 0x00, 0x00, 0xaf, 0x70, 0x00, 0x00, 0xaf, 0x80,
-  0x00, 0x00, 0xaf, 0xfc, 0x00, 0x00, 0xb0, 0x0c, 0x00, 0x00, 0xb0, 0x1c,
-  0x00, 0x00, 0xb0, 0x44, 0x00, 0x00, 0xb0, 0x54, 0x00, 0x00, 0xb0, 0x64,
-  0x00, 0x00, 0xb0, 0x9c, 0x00, 0x00, 0xb0, 0xac, 0x00, 0x00, 0xb0, 0xbc,
-  0x00, 0x00, 0xb0, 0xcc, 0x00, 0x00, 0xb1, 0x04, 0x00, 0x00, 0xb1, 0x14,
-  0x00, 0x00, 0xb1, 0x24, 0x00, 0x00, 0xb1, 0xa8, 0x00, 0x00, 0xb1, 0xb8,
-  0x00, 0x00, 0xb2, 0x20, 0x00, 0x00, 0xb2, 0x9c, 0x00, 0x00, 0xb2, 0xb8,
-  0x00, 0x00, 0xb2, 0xd4, 0x00, 0x00, 0xb2, 0xec, 0x00, 0x00, 0xb3, 0x04,
-  0x00, 0x00, 0xb3, 0x1c, 0x00, 0x00, 0xb3, 0x34, 0x00, 0x00, 0xb3, 0x4c,
-  0x00, 0x00, 0xb3, 0xd4, 0x00, 0x00, 0xb4, 0x38, 0x00, 0x00, 0xb4, 0x78,
-  0x00, 0x00, 0xb5, 0x08, 0x00, 0x00, 0xb5, 0x9c, 0x00, 0x00, 0xb6, 0x00,
-  0x00, 0x00, 0xb6, 0x48, 0x00, 0x00, 0xb6, 0xc4, 0x00, 0x00, 0xb6, 0xf8,
-  0x00, 0x00, 0xb7, 0x30, 0x00, 0x00, 0xb7, 0x70, 0x00, 0x00, 0xb7, 0x80,
-  0x00, 0x00, 0xb7, 0xd0, 0x00, 0x00, 0xb8, 0x4c, 0x00, 0x00, 0xb8, 0x5c,
-  0x00, 0x00, 0xb8, 0xa8, 0x00, 0x00, 0xb9, 0x0c, 0x00, 0x00, 0xb9, 0x80,
-  0x00, 0x00, 0xb9, 0xe4, 0x00, 0x00, 0xba, 0x20, 0x00, 0x00, 0xba, 0x80,
-  0x00, 0x00, 0xbb, 0x04, 0x00, 0x00, 0xbb, 0x60, 0x00, 0x00, 0xbb, 0xbc,
-  0x00, 0x00, 0xbc, 0x18, 0x00, 0x00, 0xbc, 0x30, 0x00, 0x00, 0xbc, 0x48,
-  0x00, 0x00, 0xbc, 0x60, 0x00, 0x00, 0xbc, 0x78, 0x00, 0x00, 0xbc, 0x90,
-  0x00, 0x00, 0xbc, 0xcc, 0x00, 0x00, 0xbd, 0x54, 0x00, 0x00, 0xbd, 0xc4,
-  0x00, 0x00, 0xbe, 0x34, 0x00, 0x00, 0xbe, 0x50, 0x00, 0x00, 0xbe, 0x68,
-  0x00, 0x00, 0xbe, 0xf0, 0x00, 0x00, 0xbf, 0x58, 0x00, 0x00, 0xc0, 0x04,
-  0x00, 0x00, 0xc0, 0x78, 0x00, 0x00, 0xc0, 0xe4, 0x00, 0x00, 0xc1, 0x58,
-  0x00, 0x00, 0xc1, 0xc0, 0x00, 0x00, 0xc1, 0xd0, 0x00, 0x00, 0xc2, 0x48,
-  0x00, 0x00, 0xc2, 0xa4, 0x00, 0x00, 0xc2, 0xd0, 0x00, 0x00, 0xc3, 0x44,
-  0x00, 0x00, 0xc3, 0xa0, 0x00, 0x00, 0xc4, 0x60, 0x00, 0x00, 0xc4, 0xe0,
-  0x00, 0x00, 0xc5, 0x48, 0x00, 0x00, 0xc5, 0xa8, 0x00, 0x00, 0xc6, 0x24,
-  0x00, 0x00, 0xc7, 0x0c, 0x00, 0x00, 0xc7, 0x80, 0x00, 0x00, 0xc7, 0xec,
-  0x00, 0x00, 0xc8, 0x9c, 0x00, 0x00, 0xc9, 0x4c, 0x00, 0x00, 0xc9, 0xe0,
-  0x00, 0x00, 0xca, 0x78, 0x00, 0x00, 0xca, 0xb0, 0x00, 0x00, 0xca, 0xe8,
-  0x00, 0x00, 0xcb, 0x84, 0x00, 0x00, 0xcc, 0x00, 0x00, 0x00, 0xcc, 0x10,
-  0x00, 0x00, 0xcc, 0x20, 0x00, 0x00, 0xcc, 0x30, 0x00, 0x00, 0xcc, 0x9c,
-  0x00, 0x00, 0xcd, 0x08, 0x00, 0x00, 0xcd, 0x18, 0x00, 0x00, 0xcd, 0x28,
-  0x00, 0x00, 0xcd, 0x38, 0x00, 0x00, 0xcd, 0x74, 0x00, 0x00, 0xcd, 0xac,
-  0x00, 0x00, 0xce, 0x2c, 0x00, 0x00, 0xce, 0x3c, 0x00, 0x00, 0xce, 0x54,
-  0x00, 0x00, 0xce, 0x6c, 0x00, 0x00, 0xce, 0x84, 0x00, 0x00, 0xce, 0xa0,
-  0x00, 0x00, 0xce, 0xf8, 0x00, 0x00, 0xcf, 0x10, 0x00, 0x00, 0xcf, 0x68,
-  0x00, 0x00, 0xcf, 0x78, 0x00, 0x00, 0xcf, 0x88, 0x00, 0x00, 0xcf, 0x98,
-  0x00, 0x00, 0xcf, 0xa8, 0x00, 0x00, 0xd0, 0x0c, 0x00, 0x00, 0xd0, 0x68,
-  0x00, 0x00, 0xd0, 0xac, 0x00, 0x00, 0xd0, 0xc4, 0x00, 0x00, 0xd0, 0xdc,
-  0x00, 0x00, 0xd0, 0xf4, 0x00, 0x00, 0xd1, 0x24, 0x00, 0x00, 0xd1, 0x34,
-  0x00, 0x00, 0xd1, 0x84, 0x00, 0x00, 0xd1, 0x94, 0x00, 0x00, 0xd1, 0xb4,
-  0x00, 0x00, 0xd2, 0x0c, 0x00, 0x00, 0xd2, 0x1c, 0x00, 0x00, 0xd2, 0x74,
-  0x00, 0x00, 0xd2, 0xec, 0x00, 0x00, 0xd3, 0x1c, 0x00, 0x00, 0xd3, 0x38,
-  0x00, 0x00, 0xd3, 0x70, 0x00, 0x00, 0xd3, 0xac, 0x00, 0x00, 0xd3, 0xbc,
-  0x00, 0x00, 0xd3, 0xcc, 0x00, 0x00, 0xd3, 0xdc, 0x00, 0x00, 0xd4, 0x04,
-  0x00, 0x00, 0xd4, 0x14, 0x00, 0x00, 0xd4, 0x24, 0x00, 0x00, 0xd4, 0x34,
-  0x00, 0x00, 0xd4, 0x78, 0x00, 0x00, 0xd4, 0xf0, 0x00, 0x00, 0xd5, 0x00,
-  0x00, 0x00, 0xd5, 0x30, 0x00, 0x00, 0xd5, 0x68, 0x00, 0x00, 0xd5, 0x98,
-  0x00, 0x00, 0xd5, 0xd4, 0x00, 0x00, 0xd6, 0x28, 0x00, 0x00, 0xd6, 0x40,
-  0x00, 0x00, 0xd6, 0x90, 0x00, 0x00, 0xd6, 0xe8, 0x00, 0x00, 0xd7, 0x70,
-  0x00, 0x00, 0xd7, 0xc4, 0x00, 0x00, 0xd7, 0xd4, 0x00, 0x00, 0xd8, 0x60,
-  0x00, 0x00, 0xd8, 0xcc, 0x00, 0x00, 0xd8, 0xec, 0x00, 0x00, 0xd9, 0x40,
-  0x00, 0x00, 0xd9, 0x50, 0x00, 0x00, 0xd9, 0xa8, 0x00, 0x00, 0xda, 0x1c,
-  0x00, 0x00, 0xda, 0x4c, 0x00, 0x00, 0xda, 0x68, 0x00, 0x00, 0xda, 0xa0,
-  0x00, 0x00, 0xda, 0xdc, 0x00, 0x00, 0xdb, 0x18, 0x00, 0x00, 0xdb, 0x48,
-  0x00, 0x00, 0xdb, 0x58, 0x00, 0x00, 0xdb, 0x80, 0x00, 0x00, 0xdb, 0x90,
-  0x00, 0x00, 0xdb, 0xa0, 0x00, 0x00, 0xdb, 0xc8, 0x00, 0x00, 0xdb, 0xd8,
-  0x00, 0x00, 0xdc, 0x80, 0x00, 0x00, 0xdc, 0x90, 0x00, 0x00, 0xdc, 0xc0,
-  0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xdd, 0x30, 0x00, 0x00, 0xdd, 0x6c,
-  0x00, 0x00, 0xdd, 0xb8, 0x00, 0x00, 0xdd, 0xd0, 0x00, 0x00, 0xde, 0x18,
-  0x00, 0x00, 0xde, 0x6c, 0x00, 0x00, 0xde, 0xd4, 0x00, 0x00, 0xdf, 0x28,
-  0x00, 0x00, 0xdf, 0x40, 0x00, 0x00, 0xdf, 0x5c, 0x00, 0x00, 0xdf, 0xc0,
-  0x00, 0x00, 0xdf, 0xd8, 0x00, 0x00, 0xe0, 0x30, 0x00, 0x00, 0xe0, 0x40,
-  0x00, 0x00, 0xe0, 0x50, 0x00, 0x00, 0xe0, 0x60, 0x00, 0x00, 0xe0, 0x70,
-  0x00, 0x00, 0xe0, 0xd4, 0x00, 0x00, 0xe1, 0x30, 0x00, 0x00, 0xe1, 0x88,
-  0x00, 0x00, 0xe1, 0xa0, 0x00, 0x00, 0xe1, 0xb8, 0x00, 0x00, 0xe1, 0xd0,
-  0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe2, 0xa0, 0x00, 0x00, 0xe2, 0xb0,
-  0x00, 0x00, 0xe3, 0x10, 0x00, 0x00, 0xe3, 0x68, 0x00, 0x00, 0xe3, 0xf4,
-  0x00, 0x00, 0xe4, 0x64, 0x00, 0x00, 0xe4, 0xa4, 0x00, 0x00, 0xe4, 0xe4,
-  0x00, 0x00, 0xe5, 0x3c, 0x00, 0x00, 0xe5, 0x94, 0x00, 0x00, 0xe5, 0xfc,
-  0x00, 0x00, 0xe6, 0x64, 0x00, 0x00, 0xe6, 0xe0, 0x00, 0x00, 0xe7, 0x58,
-  0x00, 0x00, 0xe8, 0x44, 0x00, 0x00, 0xe9, 0x20, 0x00, 0x00, 0xe9, 0x84,
-  0x00, 0x00, 0xe9, 0xe8, 0x00, 0x00, 0xe9, 0xf8, 0x00, 0x00, 0xea, 0x08,
-  0x00, 0x00, 0xea, 0x54, 0x00, 0x00, 0xea, 0xa4, 0x00, 0x00, 0xea, 0xbc,
-  0x00, 0x00, 0xea, 0xd4, 0x00, 0x00, 0xeb, 0x78, 0x00, 0x00, 0xeb, 0xfc,
-  0x00, 0x00, 0xec, 0xf4, 0x00, 0x00, 0xed, 0xdc, 0x00, 0x00, 0xee, 0xb8,
-  0x00, 0x00, 0xef, 0x68, 0x00, 0x00, 0xef, 0x80, 0x00, 0x00, 0xef, 0x98,
-  0x00, 0x00, 0xef, 0xfc, 0x00, 0x00, 0xf0, 0x58, 0x00, 0x00, 0xf0, 0xa4,
-  0x00, 0x00, 0xf1, 0x3c, 0x00, 0x00, 0xf1, 0x70, 0x00, 0x00, 0xf1, 0x98,
-  0x00, 0x00, 0xf1, 0xc0, 0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0xf3, 0x44,
-  0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf4, 0x18, 0x00, 0x00, 0xf4, 0x30,
-  0x00, 0x00, 0xf4, 0x90, 0x00, 0x00, 0xf4, 0xf4, 0x00, 0x00, 0xf5, 0x54,
-  0x00, 0x00, 0xf5, 0xd8, 0x00, 0x00, 0xf5, 0xfc, 0x00, 0x00, 0xf6, 0x20,
-  0x00, 0x00, 0xf6, 0x54, 0x00, 0x00, 0xf6, 0x88, 0x00, 0x00, 0xf6, 0xe0,
-  0x00, 0x00, 0xf7, 0x3c, 0x00, 0x00, 0xf7, 0xa0, 0x00, 0x00, 0xf8, 0x00,
-  0x00, 0x00, 0xf8, 0x18, 0x00, 0x00, 0xf8, 0x30, 0x00, 0x00, 0xf8, 0x74,
-  0x00, 0x00, 0xf8, 0xb8, 0x00, 0x00, 0xf9, 0x04, 0x00, 0x00, 0xf9, 0x4c,
-  0x00, 0x00, 0xf9, 0x98, 0x00, 0x00, 0xf9, 0xe4, 0x00, 0x00, 0xfa, 0x24,
-  0x00, 0x00, 0xfa, 0x64, 0x00, 0x00, 0xfa, 0xa0, 0x00, 0x00, 0xfa, 0xdc,
-  0x00, 0x00, 0xfb, 0x14, 0x00, 0x00, 0xfb, 0x4c, 0x00, 0x00, 0xfb, 0xac,
-  0x00, 0x00, 0xfc, 0x10, 0x00, 0x00, 0xfd, 0x04, 0x00, 0x00, 0xfd, 0xe0,
-  0x00, 0x00, 0xfd, 0xf8, 0x00, 0x00, 0xfe, 0x10, 0x00, 0x00, 0xfe, 0x40,
-  0x00, 0x00, 0xfe, 0x70, 0x00, 0x00, 0xfe, 0x80, 0x00, 0x00, 0xfe, 0xb0,
-  0x00, 0x00, 0xfe, 0xf4, 0x00, 0x00, 0xff, 0x34, 0x00, 0x00, 0xff, 0x7c,
-  0x00, 0x00, 0xff, 0xc4, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3c,
-  0x00, 0x01, 0x00, 0x84, 0x00, 0x01, 0x00, 0xcc, 0x00, 0x01, 0x01, 0x1c,
-  0x00, 0x01, 0x01, 0x68, 0x00, 0x01, 0x01, 0xa4, 0x00, 0x01, 0x01, 0xb4,
-  0x00, 0x01, 0x02, 0x44, 0x00, 0x01, 0x02, 0xd4, 0x00, 0x01, 0x03, 0x6c,
-  0x00, 0x01, 0x04, 0x04, 0x00, 0x01, 0x04, 0x14, 0x00, 0x01, 0x04, 0x2c,
-  0x00, 0x01, 0x04, 0x44, 0x00, 0x01, 0x04, 0xa0, 0x00, 0x01, 0x05, 0x00,
-  0x00, 0x01, 0x05, 0x4c, 0x00, 0x01, 0x05, 0x98, 0x00, 0x01, 0x05, 0xe0,
-  0x00, 0x01, 0x06, 0x28, 0x00, 0x01, 0x06, 0x64, 0x00, 0x01, 0x06, 0xa0,
-  0x00, 0x01, 0x06, 0xe8, 0x00, 0x01, 0x07, 0x30, 0x00, 0x01, 0x07, 0x7c,
-  0x00, 0x01, 0x07, 0xc4, 0x00, 0x01, 0x07, 0xd4, 0x00, 0x01, 0x07, 0xf0,
-  0x00, 0x01, 0x08, 0x08, 0x00, 0x01, 0x08, 0x24, 0x00, 0x01, 0x08, 0x3c,
-  0x00, 0x01, 0x08, 0x4c, 0x00, 0x01, 0x08, 0x5c, 0x00, 0x01, 0x08, 0x78,
-  0x00, 0x01, 0x08, 0x94, 0x00, 0x01, 0x08, 0xa4, 0x00, 0x01, 0x08, 0xb4,
-  0x00, 0x01, 0x08, 0xcc, 0x00, 0x01, 0x08, 0xe4, 0x00, 0x01, 0x08, 0xfc,
-  0x00, 0x01, 0x09, 0x14, 0x00, 0x01, 0x09, 0x2c, 0x00, 0x01, 0x09, 0x44,
-  0x00, 0x01, 0x09, 0x54, 0x00, 0x01, 0x09, 0x64, 0x00, 0x01, 0x09, 0x7c,
-  0x00, 0x01, 0x09, 0x94, 0x00, 0x01, 0x09, 0xac, 0x00, 0x01, 0x09, 0xc4,
-  0x00, 0x01, 0x09, 0xe0, 0x00, 0x01, 0x09, 0xf8, 0x00, 0x01, 0x0a, 0x08,
-  0x00, 0x01, 0x0a, 0x18, 0x00, 0x01, 0x0a, 0x30, 0x00, 0x01, 0x0a, 0x48,
-  0x00, 0x01, 0x0a, 0x60, 0x00, 0x01, 0x0a, 0x78, 0x00, 0x01, 0x0a, 0x90,
-  0x00, 0x01, 0x0a, 0xa8, 0x00, 0x01, 0x0a, 0xc0, 0x00, 0x01, 0x0a, 0xd8,
-  0x00, 0x01, 0x0a, 0xf0, 0x00, 0x01, 0x0b, 0x08, 0x00, 0x01, 0x0b, 0x20,
-  0x00, 0x01, 0x0b, 0x38, 0x00, 0x01, 0x0b, 0x60, 0x00, 0x01, 0x0b, 0x88,
-  0x00, 0x01, 0x0b, 0xa0, 0x00, 0x01, 0x0b, 0xb8, 0x00, 0x01, 0x0c, 0x08,
-  0x00, 0x01, 0x0c, 0x58, 0x00, 0x01, 0x0c, 0xb8, 0x00, 0x01, 0x0d, 0x18,
-  0x00, 0x01, 0x0d, 0x68, 0x00, 0x01, 0x0d, 0xb8, 0x00, 0x01, 0x0e, 0x08,
-  0x00, 0x01, 0x0e, 0x5c, 0x00, 0x01, 0x0e, 0xf0, 0x00, 0x01, 0x0f, 0x80,
-  0x00, 0x01, 0x10, 0x20, 0x00, 0x01, 0x10, 0xbc, 0x00, 0x01, 0x11, 0x38,
-  0x00, 0x01, 0x11, 0xb4, 0x00, 0x01, 0x12, 0x24, 0x00, 0x01, 0x12, 0x90,
-  0x00, 0x01, 0x12, 0xa0, 0x00, 0x01, 0x12, 0xfc, 0x00, 0x01, 0x13, 0x5c,
-  0x00, 0x01, 0x13, 0xb4, 0x00, 0x01, 0x14, 0x08, 0x00, 0x01, 0x14, 0x5c,
-  0x00, 0x01, 0x14, 0x6c, 0x00, 0x01, 0x14, 0x7c, 0x00, 0x01, 0x14, 0xcc,
-  0x00, 0x01, 0x15, 0x1c, 0x00, 0x01, 0x15, 0x80, 0x00, 0x01, 0x15, 0xe8,
-  0x00, 0x01, 0x16, 0x48, 0x00, 0x01, 0x16, 0xc0, 0x00, 0x01, 0x17, 0x28,
-  0x00, 0x01, 0x17, 0xc0, 0x00, 0x01, 0x17, 0xd0, 0x00, 0x01, 0x17, 0xe0,
-  0x00, 0x01, 0x17, 0xf0, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x18, 0x54,
-  0x00, 0x01, 0x18, 0xa0, 0x00, 0x01, 0x19, 0x14, 0x00, 0x01, 0x19, 0x88,
-  0x00, 0x01, 0x19, 0xf0, 0x00, 0x01, 0x1a, 0x5c, 0x00, 0x01, 0x1a, 0x8c,
-  0x00, 0x01, 0x1a, 0xbc, 0x00, 0x01, 0x1a, 0xf4, 0x00, 0x01, 0x1b, 0x44,
-  0x00, 0x01, 0x1c, 0x1c, 0x00, 0x01, 0x1c, 0x88, 0x00, 0x01, 0x1c, 0x98,
-  0x00, 0x01, 0x1c, 0xe0, 0x00, 0x01, 0x1d, 0x38, 0x00, 0x01, 0x1d, 0x68,
-  0x00, 0x01, 0x1d, 0xf8, 0x00, 0x01, 0x1e, 0x1c, 0x00, 0x01, 0x1e, 0x58,
-  0x00, 0x01, 0x1e, 0x68, 0x00, 0x01, 0x1e, 0xa0, 0x00, 0x01, 0x1e, 0xb0,
-  0x00, 0x01, 0x1e, 0xc0, 0x00, 0x01, 0x1e, 0xd0, 0x00, 0x01, 0x1e, 0xe0,
-  0x00, 0x01, 0x1f, 0x34, 0x00, 0x01, 0x1f, 0x88, 0x00, 0x01, 0x20, 0x18,
-  0x00, 0x01, 0x20, 0xd4, 0x00, 0x01, 0x21, 0x0c, 0x00, 0x01, 0x21, 0x44,
-  0x00, 0x01, 0x21, 0x88, 0x00, 0x01, 0x21, 0xf8, 0x00, 0x01, 0x22, 0x68,
-  0x00, 0x01, 0x22, 0x78, 0x00, 0x01, 0x22, 0xb0, 0x00, 0x01, 0x22, 0xf4,
-  0x00, 0x01, 0x23, 0x50, 0x00, 0x01, 0x23, 0xc4, 0x00, 0x01, 0x23, 0xd4,
-  0x00, 0x01, 0x23, 0xe4, 0x00, 0x01, 0x23, 0xf4, 0x00, 0x01, 0x24, 0x44,
-  0x00, 0x01, 0x24, 0x64, 0x00, 0x01, 0x24, 0x74, 0x00, 0x01, 0x24, 0x9c,
-  0x00, 0x01, 0x24, 0xac, 0x00, 0x01, 0x25, 0x08, 0x00, 0x01, 0x25, 0x18,
-  0x00, 0x01, 0x25, 0x4c, 0x00, 0x01, 0x25, 0x98, 0x00, 0x01, 0x26, 0x14,
-  0x00, 0x01, 0x26, 0x5c, 0x00, 0x01, 0x26, 0x8c, 0x00, 0x01, 0x26, 0xbc,
-  0x00, 0x01, 0x27, 0x2c, 0x00, 0x01, 0x27, 0x5c, 0x00, 0x01, 0x27, 0x78,
-  0x00, 0x01, 0x27, 0xa8, 0x00, 0x01, 0x27, 0xdc, 0x00, 0x01, 0x27, 0xfc,
-  0x00, 0x01, 0x28, 0x34, 0x00, 0x01, 0x28, 0x64, 0x00, 0x01, 0x28, 0x94,
-  0x00, 0x01, 0x28, 0xf4, 0x00, 0x01, 0x29, 0xb0, 0x00, 0x01, 0x29, 0xfc,
-  0x00, 0x01, 0x2a, 0x68, 0x00, 0x01, 0x2a, 0x90, 0x00, 0x01, 0x2a, 0xd4,
-  0x00, 0x01, 0x2b, 0x0c, 0x00, 0x01, 0x2b, 0x8c, 0x00, 0x01, 0x2c, 0x14,
-  0x00, 0x01, 0x2c, 0x7c, 0x00, 0x01, 0x2d, 0x54, 0x00, 0x01, 0x2d, 0xb8,
-  0x00, 0x01, 0x2e, 0x20, 0x00, 0x01, 0x2e, 0x94, 0x00, 0x01, 0x2e, 0xf0,
-  0x00, 0x01, 0x2f, 0x84, 0x00, 0x01, 0x30, 0x14, 0x00, 0x01, 0x30, 0xa8,
-  0x00, 0x01, 0x30, 0xcc, 0x00, 0x01, 0x31, 0x00, 0x00, 0x01, 0x31, 0x68,
-  0x00, 0x01, 0x31, 0xc8, 0x00, 0x01, 0x32, 0x14, 0x00, 0x01, 0x32, 0x7c,
-  0x00, 0x01, 0x32, 0xb8, 0x00, 0x01, 0x32, 0xf0, 0x00, 0x01, 0x33, 0x54,
-  0x00, 0x01, 0x33, 0x94, 0x00, 0x01, 0x33, 0xe0, 0x00, 0x01, 0x34, 0x2c,
-  0x00, 0x01, 0x34, 0xa8, 0x00, 0x01, 0x34, 0xcc, 0x00, 0x01, 0x35, 0x2c,
-  0x00, 0x01, 0x35, 0x64, 0x00, 0x01, 0x35, 0xec, 0x00, 0x01, 0x36, 0x68,
-  0x00, 0x01, 0x36, 0xc0, 0x00, 0x01, 0x36, 0xd4, 0x00, 0x01, 0x36, 0xe8,
-  0x00, 0x01, 0x36, 0xfc, 0x00, 0x01, 0x37, 0x10, 0x00, 0x01, 0x37, 0x24,
-  0x00, 0x01, 0x37, 0x38, 0x00, 0x01, 0x37, 0x94, 0x00, 0x01, 0x37, 0xa8,
-  0x00, 0x01, 0x37, 0xbc, 0x00, 0x01, 0x38, 0x38, 0x00, 0x01, 0x38, 0x48,
-  0x00, 0x01, 0x38, 0x88, 0x00, 0x01, 0x39, 0x14, 0x00, 0x01, 0x39, 0x50,
-  0x00, 0x01, 0x39, 0xb8, 0x00, 0x01, 0x3a, 0x18, 0x00, 0x01, 0x3a, 0x9c,
-  0x00, 0x01, 0x3b, 0x2c, 0x00, 0x01, 0x3b, 0xbc, 0x00, 0x01, 0x3c, 0x00,
-  0x00, 0x01, 0x3c, 0x44, 0x00, 0x01, 0x3c, 0xcc, 0x00, 0x01, 0x3d, 0x18,
-  0x00, 0x01, 0x3d, 0x50, 0x00, 0x01, 0x3d, 0x80, 0x00, 0x01, 0x3d, 0xac,
-  0x00, 0x01, 0x3d, 0xe8, 0x00, 0x01, 0x3e, 0x40, 0x00, 0x01, 0x3e, 0x74,
-  0x00, 0x01, 0x3e, 0xb4, 0x00, 0x01, 0x3e, 0xd4, 0x00, 0x01, 0x3f, 0x6c,
-  0x00, 0x01, 0x3f, 0xe8, 0x00, 0x01, 0x40, 0x48, 0x00, 0x01, 0x40, 0xac,
-  0x00, 0x01, 0x40, 0xdc, 0x00, 0x01, 0x41, 0x4c, 0x00, 0x01, 0x41, 0xdc,
-  0x00, 0x01, 0x42, 0x84, 0x00, 0x01, 0x42, 0xd4, 0x00, 0x01, 0x43, 0x2c,
-  0x00, 0x01, 0x43, 0x94, 0x00, 0x01, 0x44, 0x08, 0x00, 0x01, 0x44, 0x4c,
-  0x00, 0x01, 0x44, 0xb0, 0x00, 0x01, 0x44, 0xd8, 0x00, 0x01, 0x45, 0x08,
-  0x00, 0x01, 0x45, 0x54, 0x00, 0x01, 0x45, 0xac, 0x00, 0x01, 0x46, 0x14,
-  0x00, 0x01, 0x46, 0x80, 0x00, 0x01, 0x46, 0xa0, 0x00, 0x01, 0x46, 0xc4,
-  0x00, 0x01, 0x46, 0xe8, 0x00, 0x01, 0x47, 0x08, 0x00, 0x01, 0x47, 0x34,
-  0x00, 0x01, 0x47, 0x64, 0x00, 0x01, 0x47, 0x7c, 0x00, 0x01, 0x47, 0x94,
-  0x00, 0x01, 0x47, 0xac, 0x00, 0x01, 0x47, 0xc4, 0x00, 0x01, 0x47, 0xdc,
-  0x00, 0x01, 0x47, 0xf4, 0x00, 0x01, 0x48, 0x0c, 0x00, 0x01, 0x48, 0x24,
-  0x00, 0x01, 0x48, 0x3c, 0x00, 0x01, 0x48, 0x54, 0x00, 0x01, 0x48, 0x6c,
-  0x00, 0x01, 0x48, 0x84, 0x00, 0x01, 0x48, 0x9c, 0x00, 0x01, 0x48, 0xb4,
-  0x00, 0x01, 0x48, 0xcc, 0x00, 0x01, 0x48, 0xe4, 0x00, 0x01, 0x48, 0xfc,
-  0x00, 0x01, 0x49, 0x14, 0x00, 0x01, 0x49, 0x2c, 0x00, 0x01, 0x49, 0x44,
-  0x00, 0x01, 0x49, 0x5c, 0x00, 0x01, 0x49, 0x74, 0x00, 0x01, 0x49, 0x8c,
-  0x00, 0x01, 0x49, 0xa4, 0x00, 0x01, 0x49, 0xbc, 0x00, 0x01, 0x49, 0xd4,
-  0x00, 0x01, 0x49, 0xec, 0x00, 0x01, 0x4a, 0x04, 0x00, 0x01, 0x4a, 0x24,
-  0x00, 0x01, 0x4a, 0x40, 0x00, 0x01, 0x4a, 0x58, 0x00, 0x01, 0x4a, 0x70,
-  0x00, 0x01, 0x4a, 0x88, 0x00, 0x01, 0x4a, 0xa0, 0x00, 0x01, 0x4a, 0xb8,
-  0x00, 0x01, 0x4a, 0xd0, 0x00, 0x01, 0x4a, 0xe8, 0x00, 0x01, 0x4b, 0x00,
-  0x00, 0x01, 0x4b, 0x18, 0x00, 0x01, 0x4b, 0x30, 0x00, 0x01, 0x4b, 0x48,
-  0x00, 0x01, 0x4b, 0x60, 0x00, 0x01, 0x4b, 0x78, 0x00, 0x01, 0x4b, 0x90,
-  0x00, 0x01, 0x4b, 0xa8, 0x00, 0x01, 0x4b, 0xc0, 0x00, 0x01, 0x4b, 0xd8,
-  0x00, 0x01, 0x4b, 0xf0, 0x00, 0x01, 0x4c, 0x08, 0x00, 0x01, 0x4c, 0x20,
-  0x00, 0x01, 0x4c, 0x38, 0x00, 0x01, 0x4c, 0x50, 0x00, 0x01, 0x4c, 0x68,
-  0x00, 0x01, 0x4c, 0x80, 0x00, 0x01, 0x4c, 0x98, 0x00, 0x01, 0x4c, 0xb0,
-  0x00, 0x01, 0x4c, 0xd0, 0x00, 0x01, 0x4c, 0xe8, 0x00, 0x01, 0x4d, 0x00,
-  0x00, 0x01, 0x4d, 0x18, 0x00, 0x01, 0x4d, 0x30, 0x00, 0x01, 0x4d, 0x48,
-  0x00, 0x01, 0x4d, 0x60, 0x00, 0x01, 0x4d, 0x78, 0x00, 0x01, 0x4d, 0x90,
-  0x00, 0x01, 0x4d, 0xa8, 0x00, 0x01, 0x4d, 0xc0, 0x00, 0x01, 0x4d, 0xd8,
-  0x00, 0x01, 0x4d, 0xf0, 0x00, 0x01, 0x4e, 0x08, 0x00, 0x01, 0x4e, 0x20,
-  0x00, 0x01, 0x4e, 0x38, 0x00, 0x01, 0x4e, 0x50, 0x00, 0x01, 0x4e, 0x68,
-  0x00, 0x01, 0x4e, 0x80, 0x00, 0x01, 0x4e, 0x98, 0x00, 0x01, 0x4e, 0xb0,
-  0x00, 0x01, 0x4e, 0xc8, 0x00, 0x01, 0x4e, 0xe0, 0x00, 0x01, 0x4f, 0x00,
-  0x00, 0x01, 0x4f, 0x18, 0x00, 0x01, 0x4f, 0x30, 0x00, 0x01, 0x4f, 0x48,
-  0x00, 0x01, 0x4f, 0x60, 0x00, 0x01, 0x4f, 0x78, 0x00, 0x01, 0x4f, 0x90,
-  0x00, 0x01, 0x4f, 0xa8, 0x00, 0x01, 0x4f, 0xc0, 0x00, 0x01, 0x4f, 0xd8,
-  0x00, 0x01, 0x4f, 0xf0, 0x00, 0x01, 0x50, 0x08, 0x00, 0x01, 0x50, 0x20,
-  0x00, 0x01, 0x50, 0x38, 0x00, 0x01, 0x50, 0x50, 0x00, 0x01, 0x50, 0x68,
-  0x00, 0x01, 0x50, 0x80, 0x00, 0x01, 0x50, 0x98, 0x00, 0x01, 0x50, 0xb0,
-  0x00, 0x01, 0x50, 0xc8, 0x00, 0x01, 0x50, 0xe0, 0x00, 0x01, 0x51, 0x00,
-  0x00, 0x01, 0x51, 0x20, 0x00, 0x01, 0x51, 0x38, 0x00, 0x01, 0x51, 0x50,
-  0x00, 0x01, 0x51, 0x68, 0x00, 0x01, 0x51, 0x80, 0x00, 0x01, 0x51, 0x98,
-  0x00, 0x01, 0x51, 0xb0, 0x00, 0x01, 0x51, 0xc8, 0x00, 0x01, 0x51, 0xe0,
-  0x00, 0x01, 0x51, 0xf8, 0x00, 0x01, 0x52, 0x10, 0x00, 0x01, 0x52, 0x28,
-  0x00, 0x01, 0x52, 0x40, 0x00, 0x01, 0x52, 0x58, 0x00, 0x01, 0x52, 0x70,
-  0x00, 0x01, 0x52, 0x88, 0x00, 0x01, 0x52, 0xa0, 0x00, 0x01, 0x52, 0xb8,
-  0x00, 0x01, 0x52, 0xd0, 0x00, 0x01, 0x52, 0xe8, 0x00, 0x01, 0x53, 0x00,
-  0x00, 0x01, 0x53, 0x18, 0x00, 0x01, 0x53, 0x30, 0x00, 0x01, 0x53, 0x48,
-  0x00, 0x01, 0x53, 0x60, 0x00, 0x01, 0x53, 0x78, 0x00, 0x01, 0x53, 0x90,
-  0x00, 0x01, 0x53, 0xa8, 0x00, 0x01, 0x53, 0xc0, 0x00, 0x01, 0x53, 0xd8,
-  0x00, 0x01, 0x53, 0xf0, 0x00, 0x01, 0x54, 0x08, 0x00, 0x01, 0x54, 0x20,
-  0x00, 0x01, 0x54, 0x38, 0x00, 0x01, 0x54, 0x50, 0x00, 0x01, 0x54, 0x68,
-  0x00, 0x01, 0x54, 0x80, 0x00, 0x01, 0x54, 0x98, 0x00, 0x01, 0x54, 0xb0,
-  0x00, 0x01, 0x54, 0xc8, 0x00, 0x01, 0x54, 0xe0, 0x00, 0x01, 0x54, 0xf8,
-  0x00, 0x01, 0x55, 0x10, 0x00, 0x01, 0x55, 0x28, 0x00, 0x01, 0x55, 0x40,
-  0x00, 0x01, 0x55, 0x58, 0x00, 0x01, 0x55, 0x70, 0x00, 0x01, 0x55, 0x88,
-  0x00, 0x01, 0x55, 0xa0, 0x00, 0x01, 0x55, 0xb8, 0x00, 0x01, 0x55, 0xd0,
-  0x00, 0x01, 0x55, 0xe8, 0x00, 0x01, 0x56, 0x00, 0x00, 0x01, 0x56, 0x18,
-  0x00, 0x01, 0x56, 0x30, 0x00, 0x01, 0x56, 0x80, 0x00, 0x01, 0x56, 0xc8,
-  0x00, 0x01, 0x57, 0x60, 0x00, 0x01, 0x57, 0x70, 0x00, 0x01, 0x57, 0x88,
-  0x00, 0x01, 0x57, 0xa0, 0x00, 0x01, 0x57, 0xb8, 0x00, 0x01, 0x57, 0xd0,
-  0x00, 0x01, 0x57, 0xe8, 0x00, 0x01, 0x58, 0x00, 0x00, 0x01, 0x58, 0x18,
-  0x00, 0x01, 0x58, 0x30, 0x00, 0x01, 0x58, 0x48, 0x00, 0x01, 0x58, 0x60,
-  0x00, 0x01, 0x58, 0x78, 0x00, 0x01, 0x58, 0x90, 0x00, 0x01, 0x58, 0xa8,
-  0x00, 0x01, 0x58, 0xc0, 0x00, 0x01, 0x58, 0xd8, 0x00, 0x01, 0x58, 0xf0,
-  0x00, 0x01, 0x59, 0x08, 0x00, 0x01, 0x59, 0x20, 0x00, 0x01, 0x59, 0x38,
-  0x00, 0x01, 0x59, 0x50, 0x00, 0x01, 0x59, 0x68, 0x00, 0x01, 0x59, 0x80,
-  0x00, 0x01, 0x59, 0x98, 0x00, 0x01, 0x59, 0xb0, 0x00, 0x01, 0x59, 0xc8,
-  0x00, 0x01, 0x59, 0xe0, 0x00, 0x01, 0x59, 0xf8, 0x00, 0x01, 0x5a, 0x10,
-  0x00, 0x01, 0x5a, 0x28, 0x00, 0x01, 0x5a, 0x40, 0x00, 0x01, 0x5a, 0x58,
-  0x00, 0x01, 0x5a, 0x70, 0x00, 0x01, 0x5a, 0x88, 0x00, 0x01, 0x5a, 0xa0,
-  0x00, 0x01, 0x5a, 0xb8, 0x00, 0x01, 0x5a, 0xd0, 0x00, 0x01, 0x5a, 0xe8,
-  0x00, 0x01, 0x5b, 0x00, 0x00, 0x01, 0x5b, 0x18, 0x00, 0x01, 0x5b, 0x38,
-  0x00, 0x01, 0x5b, 0x50, 0x00, 0x01, 0x5b, 0x68, 0x00, 0x01, 0x5b, 0x80,
-  0x00, 0x01, 0x5b, 0x98, 0x00, 0x01, 0x5b, 0xb0, 0x00, 0x01, 0x5b, 0xc8,
-  0x00, 0x01, 0x5b, 0xe0, 0x00, 0x01, 0x5b, 0xf8, 0x00, 0x01, 0x5c, 0x10,
-  0x00, 0x01, 0x5c, 0x28, 0x00, 0x01, 0x5c, 0x40, 0x00, 0x01, 0x5c, 0x58,
-  0x00, 0x01, 0x5c, 0x70, 0x00, 0x01, 0x5c, 0x88, 0x00, 0x01, 0x5c, 0xa0,
-  0x00, 0x01, 0x5c, 0xb8, 0x00, 0x01, 0x5c, 0xd0, 0x00, 0x01, 0x5c, 0xf0,
-  0x00, 0x01, 0x5d, 0x08, 0x00, 0x01, 0x5d, 0x20, 0x00, 0x01, 0x5d, 0x38,
-  0x00, 0x01, 0x5d, 0x50, 0x00, 0x01, 0x5d, 0x68, 0x00, 0x01, 0x5d, 0x80,
-  0x00, 0x01, 0x5d, 0x98, 0x00, 0x01, 0x5d, 0xb0, 0x00, 0x01, 0x5d, 0xc8,
-  0x00, 0x01, 0x5d, 0xe0, 0x00, 0x01, 0x5d, 0xf8, 0x00, 0x01, 0x5e, 0x10,
-  0x00, 0x01, 0x5e, 0x28, 0x00, 0x01, 0x5e, 0x40, 0x00, 0x01, 0x5e, 0x58,
-  0x00, 0x01, 0x5e, 0x70, 0x00, 0x01, 0x5e, 0x88, 0x00, 0x01, 0x5e, 0xa0,
-  0x00, 0x01, 0x5e, 0xb8, 0x00, 0x01, 0x5e, 0xd0, 0x00, 0x01, 0x5e, 0xe8,
-  0x00, 0x01, 0x5f, 0x00, 0x00, 0x01, 0x5f, 0x18, 0x00, 0x01, 0x5f, 0x30,
-  0x00, 0x01, 0x5f, 0x48, 0x00, 0x01, 0x5f, 0x60, 0x00, 0x01, 0x5f, 0x78,
-  0x00, 0x01, 0x5f, 0x90, 0x00, 0x01, 0x5f, 0xa8, 0x00, 0x01, 0x5f, 0xc0,
-  0x00, 0x01, 0x5f, 0xd8, 0x00, 0x01, 0x5f, 0xf0, 0x00, 0x01, 0x60, 0x1c,
-  0x00, 0x01, 0x60, 0x58, 0x00, 0x01, 0x60, 0x70, 0x00, 0x01, 0x60, 0x88,
-  0x00, 0x01, 0x60, 0xa0, 0x00, 0x01, 0x60, 0xb8, 0x00, 0x01, 0x60, 0xd0,
-  0x00, 0x01, 0x60, 0xe8, 0x00, 0x01, 0x61, 0x00, 0x00, 0x01, 0x61, 0x18,
-  0x00, 0x01, 0x61, 0x30, 0x00, 0x01, 0x61, 0x48, 0x00, 0x01, 0x61, 0x60,
-  0x00, 0x01, 0x61, 0x78, 0x00, 0x01, 0x61, 0x94, 0x00, 0x01, 0x61, 0xb0,
-  0x00, 0x01, 0x61, 0xc8, 0x00, 0x01, 0x61, 0xe0, 0x00, 0x01, 0x61, 0xf8,
-  0x00, 0x01, 0x62, 0x10, 0x00, 0x01, 0x62, 0x28, 0x00, 0x01, 0x62, 0x40,
-  0x00, 0x01, 0x62, 0x58, 0x00, 0x01, 0x62, 0x70, 0x00, 0x01, 0x62, 0x8c,
-  0x00, 0x01, 0x62, 0xa8, 0x00, 0x01, 0x62, 0xc0, 0x00, 0x01, 0x62, 0xd8,
-  0x00, 0x01, 0x62, 0xf4, 0x00, 0x01, 0x63, 0x10, 0x00, 0x01, 0x63, 0x28,
-  0x00, 0x01, 0x63, 0x40, 0x00, 0x01, 0x63, 0x58, 0x00, 0x01, 0x63, 0x70,
-  0x00, 0x01, 0x63, 0x88, 0x00, 0x01, 0x63, 0xa0, 0x00, 0x01, 0x63, 0xb8,
-  0x00, 0x01, 0x63, 0xd0, 0x00, 0x01, 0x63, 0xec, 0x00, 0x01, 0x64, 0x08,
-  0x00, 0x01, 0x64, 0x20, 0x00, 0x01, 0x64, 0x38, 0x00, 0x01, 0x64, 0x54,
-  0x00, 0x01, 0x64, 0x70, 0x00, 0x01, 0x64, 0x8c, 0x00, 0x01, 0x64, 0xa8,
-  0x00, 0x01, 0x64, 0xc0, 0x00, 0x01, 0x64, 0xd8, 0x00, 0x01, 0x64, 0xf0,
-  0x00, 0x01, 0x65, 0x08, 0x00, 0x01, 0x65, 0x20, 0x00, 0x01, 0x65, 0x38,
-  0x00, 0x01, 0x65, 0x50, 0x00, 0x01, 0x65, 0x68, 0x00, 0x01, 0x65, 0x84,
-  0x00, 0x01, 0x65, 0xa0, 0x00, 0x01, 0x65, 0xb8, 0x00, 0x01, 0x65, 0xd0,
-  0x00, 0x01, 0x65, 0xec, 0x00, 0x01, 0x66, 0x08, 0x00, 0x01, 0x66, 0x24,
-  0x00, 0x01, 0x66, 0x40, 0x00, 0x01, 0x66, 0x58, 0x00, 0x01, 0x66, 0x70,
-  0x00, 0x01, 0x66, 0x88, 0x00, 0x01, 0x66, 0xa0, 0x00, 0x01, 0x66, 0xb8,
-  0x00, 0x01, 0x66, 0xd0, 0x00, 0x01, 0x66, 0xe8, 0x00, 0x01, 0x67, 0x00,
-  0x00, 0x01, 0x67, 0x18, 0x00, 0x01, 0x67, 0x30, 0x00, 0x01, 0x67, 0x4c,
-  0x00, 0x01, 0x67, 0x68, 0x00, 0x01, 0x67, 0x80, 0x00, 0x01, 0x67, 0x98,
-  0x00, 0x01, 0x67, 0xb0, 0x00, 0x01, 0x67, 0xc8, 0x00, 0x01, 0x67, 0xe0,
-  0x00, 0x01, 0x67, 0xf8, 0x00, 0x01, 0x68, 0x10, 0x00, 0x01, 0x68, 0x28,
-  0x00, 0x01, 0x68, 0x44, 0x00, 0x01, 0x68, 0x5c, 0x00, 0x01, 0x68, 0x78,
-  0x00, 0x01, 0x68, 0x94, 0x00, 0x01, 0x68, 0xac, 0x00, 0x01, 0x68, 0xc4,
-  0x00, 0x01, 0x68, 0xdc, 0x00, 0x01, 0x68, 0xf4, 0x00, 0x01, 0x69, 0x0c,
-  0x00, 0x01, 0x69, 0x24, 0x00, 0x01, 0x69, 0x3c, 0x00, 0x01, 0x69, 0x54,
-  0x00, 0x01, 0x69, 0x6c, 0x00, 0x01, 0x69, 0x88, 0x00, 0x01, 0x69, 0xa0,
-  0x00, 0x01, 0x69, 0xb8, 0x00, 0x01, 0x69, 0xd4, 0x00, 0x01, 0x69, 0xf0,
-  0x00, 0x01, 0x6a, 0x0c, 0x00, 0x01, 0x6a, 0x28, 0x00, 0x01, 0x6a, 0x40,
-  0x00, 0x01, 0x6a, 0x50, 0x00, 0x01, 0x6a, 0x68, 0x00, 0x01, 0x6a, 0x78,
-  0x00, 0x01, 0x6a, 0x90, 0x00, 0x01, 0x6a, 0xa0, 0x00, 0x01, 0x6a, 0xb8,
-  0x00, 0x01, 0x6a, 0xc8, 0x00, 0x01, 0x6a, 0xe0, 0x00, 0x01, 0x6a, 0xf0,
-  0x00, 0x01, 0x6b, 0x08, 0x00, 0x01, 0x6b, 0x18, 0x00, 0x01, 0x6b, 0x30,
-  0x00, 0x01, 0x6b, 0x40, 0x00, 0x01, 0x6b, 0x58, 0x00, 0x01, 0x6b, 0x70,
-  0x00, 0x01, 0x6b, 0x88, 0x00, 0x01, 0x6b, 0xa0, 0x00, 0x01, 0x6b, 0xb8,
-  0x00, 0x01, 0x6b, 0xd0, 0x00, 0x01, 0x6b, 0xe8, 0x00, 0x01, 0x6c, 0x00,
-  0x00, 0x01, 0x6c, 0x18, 0x00, 0x01, 0x6c, 0x30, 0x00, 0x01, 0x6c, 0x48,
-  0x00, 0x01, 0x6c, 0x60, 0x00, 0x01, 0x6c, 0x78, 0x00, 0x01, 0x6c, 0x90,
-  0x00, 0x01, 0x6c, 0xa8, 0x00, 0x01, 0x6c, 0xc0, 0x00, 0x01, 0x6c, 0xd8,
-  0x00, 0x01, 0x6c, 0xf0, 0x00, 0x01, 0x6d, 0x08, 0x00, 0x01, 0x6d, 0x20,
-  0x00, 0x01, 0x6d, 0x38, 0x00, 0x01, 0x6d, 0x50, 0x00, 0x01, 0x6d, 0x68,
-  0x00, 0x01, 0x6d, 0x80, 0x00, 0x01, 0x6d, 0x98, 0x00, 0x01, 0x6d, 0xb0,
-  0x00, 0x01, 0x6d, 0xc8, 0x00, 0x01, 0x6d, 0xe0, 0x00, 0x01, 0x6d, 0xf8,
-  0x00, 0x01, 0x6e, 0x10, 0x00, 0x01, 0x6e, 0x28, 0x00, 0x01, 0x6e, 0x40,
-  0x00, 0x01, 0x6e, 0x58, 0x00, 0x01, 0x6e, 0x70, 0x00, 0x01, 0x6e, 0x88,
-  0x00, 0x01, 0x6e, 0xa0, 0x00, 0x01, 0x6e, 0xb8, 0x00, 0x01, 0x6e, 0xd0,
-  0x00, 0x01, 0x6e, 0xe8, 0x00, 0x01, 0x6f, 0x00, 0x00, 0x01, 0x6f, 0x18,
-  0x00, 0x01, 0x6f, 0x30, 0x00, 0x01, 0x6f, 0x48, 0x00, 0x01, 0x6f, 0x60,
-  0x00, 0x01, 0x6f, 0x78, 0x00, 0x01, 0x6f, 0x90, 0x00, 0x01, 0x6f, 0xa8,
-  0x00, 0x01, 0x6f, 0xc0, 0x00, 0x01, 0x6f, 0xd8, 0x00, 0x01, 0x6f, 0xf0,
-  0x00, 0x01, 0x70, 0x08, 0x00, 0x01, 0x70, 0x20, 0x00, 0x01, 0x70, 0x38,
-  0x00, 0x01, 0x70, 0x50, 0x00, 0x01, 0x70, 0x68, 0x00, 0x01, 0x70, 0x80,
-  0x00, 0x01, 0x70, 0x98, 0x00, 0x01, 0x70, 0xb0, 0x00, 0x01, 0x70, 0xc0,
-  0x00, 0x01, 0x70, 0xd8, 0x00, 0x01, 0x70, 0xe8, 0x00, 0x01, 0x70, 0xf8,
-  0x00, 0x01, 0x71, 0x20, 0x00, 0x01, 0x71, 0x30, 0x00, 0x01, 0x71, 0x48,
-  0x00, 0x01, 0x71, 0x60, 0x00, 0x01, 0x71, 0x78, 0x00, 0x01, 0x71, 0x90,
-  0x00, 0x01, 0x71, 0xa8, 0x00, 0x01, 0x71, 0xc0, 0x00, 0x01, 0x71, 0xdc,
-  0x00, 0x01, 0x71, 0xec, 0x00, 0x01, 0x72, 0x08, 0x00, 0x01, 0x72, 0x18,
-  0x00, 0x01, 0x72, 0x30, 0x00, 0x01, 0x72, 0x4c, 0x00, 0x01, 0x72, 0x64,
-  0x00, 0x01, 0x72, 0x7c, 0x00, 0x01, 0x72, 0x94, 0x00, 0x01, 0x72, 0xac,
-  0x00, 0x01, 0x72, 0xc4, 0x00, 0x01, 0x72, 0xd4, 0x00, 0x01, 0x72, 0xec,
-  0x00, 0x01, 0x73, 0x04, 0x00, 0x01, 0x73, 0x1c, 0x00, 0x01, 0x73, 0x34,
-  0x00, 0x01, 0x73, 0x50, 0x00, 0x01, 0x73, 0x60, 0x00, 0x01, 0x73, 0x7c,
-  0x00, 0x01, 0x73, 0x94, 0x00, 0x01, 0x73, 0xac, 0x00, 0x01, 0x73, 0xc4,
-  0x00, 0x01, 0x73, 0xdc, 0x00, 0x01, 0x73, 0xf4, 0x00, 0x01, 0x74, 0x04,
-  0x00, 0x01, 0x74, 0x1c, 0x00, 0x01, 0x74, 0x34, 0x00, 0x01, 0x74, 0x4c,
-  0x00, 0x01, 0x74, 0x64, 0x00, 0x01, 0x74, 0x7c, 0x00, 0x01, 0x74, 0x94,
-  0x00, 0x01, 0x74, 0xb0, 0x00, 0x01, 0x74, 0xc0, 0x00, 0x01, 0x74, 0xdc,
-  0x00, 0x01, 0x74, 0xf4, 0x00, 0x01, 0x75, 0x04, 0x00, 0x01, 0x75, 0x14,
-  0x00, 0x01, 0x75, 0x2c, 0x00, 0x01, 0x75, 0x44, 0x00, 0x01, 0x75, 0x5c,
-  0x00, 0x01, 0x75, 0x74, 0x00, 0x01, 0x75, 0x8c, 0x00, 0x01, 0x75, 0xa8,
-  0x00, 0x01, 0x75, 0xb8, 0x00, 0x01, 0x75, 0xd4, 0x00, 0x01, 0x75, 0xe4,
-  0x00, 0x01, 0x75, 0xfc, 0x00, 0x01, 0x76, 0x0c, 0x00, 0x01, 0x76, 0x30,
-  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
-  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
-  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
-  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
-  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
-  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x4c, 0x00, 0x01, 0x76, 0x5c,
-  0x00, 0x01, 0x76, 0x78, 0x00, 0x01, 0x76, 0x94, 0x00, 0x01, 0x76, 0xb0,
-  0x00, 0x01, 0x76, 0xcc, 0x00, 0x01, 0x76, 0xe4, 0x00, 0x01, 0x76, 0xfc,
-  0x00, 0x01, 0x77, 0x20, 0x00, 0x01, 0x77, 0x40, 0x00, 0x01, 0x77, 0x60,
-  0x00, 0x01, 0x77, 0x84, 0x00, 0x01, 0x77, 0xbc, 0x00, 0x01, 0x77, 0xf0,
-  0x00, 0x01, 0x78, 0x24, 0x00, 0x01, 0x78, 0x58, 0x00, 0x01, 0x78, 0x88,
-  0x00, 0x01, 0x78, 0xd0, 0x00, 0x01, 0x79, 0x00, 0x00, 0x01, 0x79, 0x1c,
-  0x00, 0x01, 0x79, 0x34, 0x00, 0x01, 0x79, 0x58, 0x00, 0x01, 0x79, 0x88,
-  0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0,
-  0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0,
-  0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0,
-  0x00, 0x01, 0x7a, 0x7c, 0x00, 0x01, 0x7b, 0x8c, 0x00, 0x01, 0x7b, 0xac,
-  0x00, 0x01, 0x7b, 0xc4, 0x00, 0x01, 0x7b, 0xe4, 0x00, 0x01, 0x7c, 0x00,
-  0x00, 0x01, 0x7c, 0x18, 0x00, 0x01, 0x7c, 0x38, 0x00, 0x01, 0x7c, 0x5c,
-  0x00, 0x01, 0x7c, 0x84, 0x00, 0x01, 0x7c, 0xb0, 0x00, 0x01, 0x7c, 0xe0,
-  0x00, 0x01, 0x7c, 0xfc, 0x00, 0x01, 0x7d, 0x78, 0x00, 0x01, 0x7d, 0x8c,
-  0x00, 0x01, 0x7d, 0xc8, 0x00, 0x01, 0x7e, 0x04, 0x00, 0x01, 0x7e, 0x30,
-  0x00, 0x01, 0x7e, 0x54, 0x00, 0x01, 0x7e, 0x70, 0x00, 0x01, 0x7e, 0x8c,
-  0x00, 0x01, 0x7e, 0xbc, 0x00, 0x01, 0x7e, 0xec, 0x00, 0x01, 0x7f, 0x04,
-  0x00, 0x01, 0x7f, 0x1c, 0x00, 0x01, 0x7f, 0x38, 0x00, 0x01, 0x7f, 0x6c,
-  0x00, 0x01, 0x7f, 0xa0, 0x00, 0x01, 0x7f, 0xd0, 0x00, 0x01, 0x80, 0x00,
-  0x00, 0x01, 0x80, 0x14, 0x00, 0x01, 0x80, 0x44, 0x00, 0x01, 0x80, 0x5c,
-  0x00, 0x01, 0x80, 0x78, 0x00, 0x01, 0x80, 0x9c, 0x00, 0x01, 0x80, 0xfc,
-  0x00, 0x01, 0x81, 0x10, 0x00, 0x01, 0x81, 0x64, 0x00, 0x01, 0x81, 0x98,
-  0x00, 0x01, 0x81, 0xc0, 0x00, 0x01, 0x82, 0x00, 0x00, 0x01, 0x82, 0x4c,
-  0x00, 0x01, 0x82, 0x70, 0x00, 0x01, 0x82, 0xac, 0x00, 0x01, 0x83, 0x10,
-  0x00, 0x01, 0x83, 0x40, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
-  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
-  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
-  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
-  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0xd0,
-  0x00, 0x01, 0x83, 0xf4, 0x00, 0x01, 0x84, 0x2c, 0x00, 0x01, 0x84, 0x90,
-  0x00, 0x01, 0x85, 0x20, 0x00, 0x01, 0x85, 0x48, 0x00, 0x01, 0x85, 0xf8,
-  0x00, 0x01, 0x86, 0x84, 0x00, 0x01, 0x86, 0xb8, 0x00, 0x01, 0x86, 0xd4,
-  0x00, 0x01, 0x86, 0xfc, 0x00, 0x01, 0x87, 0x34, 0x00, 0x01, 0x87, 0x70,
-  0x00, 0x01, 0x87, 0xb4, 0x00, 0x01, 0x87, 0xc8, 0x00, 0x01, 0x87, 0xdc,
-  0x00, 0x01, 0x87, 0xf0, 0x00, 0x01, 0x88, 0x04, 0x00, 0x01, 0x88, 0x18,
-  0x00, 0x01, 0x88, 0x2c, 0x00, 0x01, 0x88, 0x40, 0x00, 0x01, 0x88, 0x54,
-  0x00, 0x01, 0x88, 0x68, 0x00, 0x01, 0x88, 0x7c, 0x00, 0x01, 0x88, 0x90,
-  0x00, 0x01, 0x88, 0xa4, 0x00, 0x01, 0x88, 0xb8, 0x00, 0x01, 0x88, 0xcc,
-  0x00, 0x01, 0x88, 0xe0, 0x00, 0x01, 0x88, 0xf4, 0x00, 0x01, 0x89, 0x08,
-  0x00, 0x01, 0x89, 0x1c, 0x00, 0x01, 0x89, 0x30, 0x00, 0x01, 0x89, 0x44,
-  0x00, 0x01, 0x89, 0x58, 0x00, 0x01, 0x89, 0x6c, 0x00, 0x01, 0x89, 0x80,
-  0x00, 0x01, 0x89, 0x94, 0x00, 0x01, 0x89, 0xa8, 0x00, 0x01, 0x89, 0xbc,
-  0x00, 0x01, 0x89, 0xd0, 0x00, 0x01, 0x89, 0xe4, 0x00, 0x01, 0x8a, 0x58,
-  0x00, 0x01, 0x8b, 0x08, 0x00, 0x01, 0x8b, 0x98, 0x00, 0x01, 0x8b, 0xd8,
-  0x00, 0x01, 0x8c, 0x40, 0x00, 0x01, 0x8c, 0xc4, 0x00, 0x01, 0x8d, 0x48,
-  0x00, 0x01, 0x8e, 0x2c, 0x00, 0x01, 0x8e, 0xf8, 0x00, 0x01, 0x8f, 0xa4,
-  0x00, 0x01, 0x90, 0x04, 0x00, 0x01, 0x90, 0x1c, 0x00, 0x01, 0x90, 0xb4,
-  0x00, 0x01, 0x90, 0xfc, 0x00, 0x01, 0x91, 0x54, 0x00, 0x01, 0x92, 0xe0,
-  0x00, 0x01, 0x93, 0x7c, 0x00, 0x01, 0x94, 0x14, 0x00, 0x01, 0x94, 0xa8,
-  0x00, 0x01, 0x95, 0x14, 0x00, 0x01, 0x95, 0xb4, 0x00, 0x01, 0x96, 0x44,
-  0x00, 0x01, 0x96, 0x78, 0x00, 0x01, 0x96, 0xf8, 0x00, 0x01, 0x97, 0x60,
-  0x00, 0x01, 0x97, 0x84, 0x00, 0x01, 0x97, 0xa4, 0x00, 0x01, 0x97, 0xcc,
-  0x00, 0x01, 0x97, 0xf4, 0x00, 0x01, 0x98, 0x2c, 0x00, 0x01, 0x98, 0x70,
-  0x00, 0x01, 0x98, 0xa8, 0x00, 0x01, 0x99, 0x68, 0x00, 0x01, 0x9a, 0x40,
-  0x00, 0x01, 0x9a, 0xb8, 0x00, 0x01, 0x9a, 0xd0, 0x00, 0x01, 0x9b, 0x5c,
-  0x00, 0x01, 0x9b, 0xf8, 0x00, 0x01, 0x9c, 0x90, 0x00, 0x01, 0x9c, 0xa0,
-  0x00, 0x01, 0x9c, 0xb4, 0x00, 0x01, 0x9c, 0xcc, 0x00, 0x01, 0x9e, 0x0c,
-  0x00, 0x01, 0x9e, 0xfc, 0x00, 0x01, 0x9f, 0x4c, 0x00, 0x01, 0x9f, 0xa8,
-  0x00, 0x01, 0xa0, 0x08, 0x00, 0x01, 0xa0, 0xb4, 0x00, 0x01, 0xa1, 0x48,
-  0x00, 0x01, 0xa2, 0x24, 0x00, 0x01, 0xa2, 0xa4, 0x00, 0x01, 0xa3, 0x20,
-  0x00, 0x01, 0xa3, 0x64, 0x00, 0x01, 0xa3, 0xf4, 0x00, 0x01, 0xa4, 0x98,
-  0x00, 0x01, 0xa5, 0x4c, 0x00, 0x01, 0xa5, 0xbc, 0x00, 0x01, 0xa6, 0x58,
-  0x00, 0x01, 0xa7, 0x70, 0x00, 0x01, 0xa8, 0x6c, 0x00, 0x01, 0xa9, 0x1c,
-  0x00, 0x01, 0xa9, 0x8c, 0x00, 0x01, 0xaa, 0x34, 0x00, 0x01, 0xaa, 0xd4,
-  0x00, 0x01, 0xab, 0x34, 0x00, 0x01, 0xab, 0x80, 0x00, 0x01, 0xab, 0xd0,
-  0x00, 0x01, 0xac, 0x10, 0x00, 0x01, 0xac, 0x7c, 0x00, 0x01, 0xac, 0x8c,
-  0x00, 0x01, 0xac, 0x9c, 0x00, 0x01, 0xad, 0x90, 0x00, 0x01, 0xad, 0xc4,
-  0x00, 0x01, 0xad, 0xd4, 0x00, 0x01, 0xad, 0xe4, 0x00, 0x01, 0xae, 0xd8,
-  0x00, 0x01, 0xaf, 0x9c, 0x00, 0x01, 0xb0, 0x24, 0x00, 0x01, 0xb0, 0xa0,
-  0x00, 0x01, 0xb1, 0x68, 0x00, 0x01, 0xb2, 0x48, 0x00, 0x01, 0xb2, 0x74,
-  0x00, 0x01, 0xb3, 0xb8, 0x00, 0x01, 0xb4, 0x0c, 0x00, 0x01, 0xb4, 0xb0,
-  0x00, 0x01, 0xb5, 0x40, 0x00, 0x01, 0xb5, 0xcc, 0x00, 0x01, 0xb6, 0x44,
-  0x00, 0x01, 0xb6, 0x8c, 0x00, 0x01, 0xb6, 0xfc, 0x00, 0x01, 0xb7, 0x7c,
-  0x00, 0x01, 0xb8, 0x10, 0x00, 0x01, 0xb8, 0x84, 0x00, 0x01, 0xb8, 0xb4,
-  0x00, 0x01, 0xb8, 0xf8, 0x00, 0x01, 0xb9, 0x4c, 0x00, 0x01, 0xb9, 0xb4,
-  0x00, 0x01, 0xb9, 0xd4, 0x00, 0x01, 0xb9, 0xf8, 0x00, 0x01, 0xba, 0x24,
-  0x00, 0x01, 0xba, 0xa8, 0x00, 0x01, 0xbb, 0x54, 0x00, 0x01, 0xbb, 0xf4,
-  0x00, 0x01, 0xbc, 0x2c, 0x00, 0x01, 0xbc, 0x94, 0x00, 0x01, 0xbd, 0x2c,
-  0x00, 0x01, 0xbd, 0x58, 0x00, 0x01, 0xbd, 0x78, 0x00, 0x01, 0xbd, 0x98,
-  0x00, 0x01, 0xbd, 0xc0, 0x00, 0x01, 0xbd, 0xe0, 0x00, 0x01, 0xbe, 0x00,
-  0x00, 0x01, 0xbe, 0x20, 0x00, 0x01, 0xbe, 0x40, 0x00, 0x01, 0xbe, 0x60,
-  0x00, 0x01, 0xbe, 0x80, 0x00, 0x01, 0xbe, 0xa0, 0x00, 0x01, 0xbe, 0xc0,
-  0x00, 0x01, 0xbe, 0xe0, 0x00, 0x01, 0xbf, 0x00, 0x00, 0x01, 0xbf, 0x20,
-  0x00, 0x01, 0xbf, 0x40, 0x00, 0x01, 0xbf, 0x58, 0x00, 0x01, 0xbf, 0x68,
-  0x00, 0x01, 0xbf, 0x80, 0x00, 0x01, 0xbf, 0xa0, 0x00, 0x01, 0xbf, 0xb8,
-  0x00, 0x01, 0xbf, 0xc8, 0x00, 0x01, 0xbf, 0xe0, 0x00, 0x01, 0xc0, 0x00,
-  0x00, 0x01, 0xc0, 0x28, 0x00, 0x01, 0xc0, 0x40, 0x00, 0x01, 0xc0, 0x50,
-  0x00, 0x01, 0xc0, 0x68, 0x00, 0x01, 0xc0, 0x88, 0x00, 0x01, 0xc0, 0x98,
-  0x00, 0x01, 0xc0, 0xa8, 0x00, 0x01, 0xc0, 0xb8, 0x00, 0x01, 0xc0, 0xc8,
-  0x00, 0x01, 0xc0, 0xd8, 0x00, 0x01, 0xc0, 0xf0, 0x00, 0x01, 0xc1, 0x10,
-  0x00, 0x01, 0xc1, 0x28, 0x00, 0x01, 0xc1, 0x38, 0x00, 0x01, 0xc1, 0x50,
-  0x00, 0x01, 0xc1, 0x70, 0x00, 0x01, 0xc1, 0x98, 0x00, 0x01, 0xc1, 0xb0,
-  0x00, 0x01, 0xc1, 0xc0, 0x00, 0x01, 0xc1, 0xd8, 0x00, 0x01, 0xc1, 0xf8,
-  0x00, 0x01, 0xc2, 0x08, 0x00, 0x01, 0xc2, 0x18, 0x00, 0x01, 0xc2, 0x28,
-  0x00, 0x01, 0xc2, 0x38, 0x00, 0x01, 0xc2, 0xbc, 0x00, 0x01, 0xc3, 0x38,
-  0x00, 0x01, 0xc4, 0x14, 0x00, 0x01, 0xc4, 0x24, 0x00, 0x01, 0xc4, 0x34,
-  0x00, 0x01, 0xc4, 0x9c, 0x00, 0x01, 0xc4, 0xbc, 0x00, 0x01, 0xc4, 0xec,
-  0x00, 0x01, 0xc5, 0x1c, 0x00, 0x01, 0xc5, 0x4c, 0x00, 0x01, 0xc5, 0x7c,
-  0x00, 0x01, 0xc5, 0xc0, 0x00, 0x01, 0xc6, 0x04, 0x00, 0x01, 0xc6, 0x34,
-  0x00, 0x01, 0xc6, 0x64, 0x00, 0x01, 0xc6, 0x94, 0x00, 0x01, 0xc6, 0xc4,
-  0x00, 0x01, 0xc7, 0x10, 0x00, 0x01, 0xc7, 0x5c, 0x00, 0x01, 0xc8, 0x04,
-  0x00, 0x01, 0xc8, 0xac, 0x00, 0x01, 0xc8, 0xf8, 0x00, 0x01, 0xc9, 0x44,
-  0x00, 0x01, 0xc9, 0x90, 0x00, 0x01, 0xc9, 0xdc, 0x00, 0x01, 0xca, 0x24,
-  0x00, 0x01, 0xca, 0x70, 0x00, 0x01, 0xca, 0xac, 0x00, 0x01, 0xca, 0xe8,
-  0x00, 0x01, 0xcb, 0x24, 0x00, 0x01, 0xcb, 0x60, 0x00, 0x01, 0xcb, 0xb4,
-  0x00, 0x01, 0xcc, 0x34, 0x00, 0x01, 0xcc, 0xc0, 0x00, 0x01, 0xcd, 0x84,
-  0x00, 0x01, 0xce, 0x48, 0x00, 0x01, 0xcf, 0x5c, 0x00, 0x01, 0xcf, 0xbc,
-  0x00, 0x01, 0xd0, 0x04, 0x00, 0x01, 0xd0, 0x3c, 0x00, 0x01, 0xd0, 0x74,
-  0x00, 0x01, 0xd0, 0xac, 0x00, 0x01, 0xd0, 0xe4, 0x00, 0x01, 0xd1, 0x1c,
-  0x00, 0x01, 0xd1, 0x54, 0x00, 0x01, 0xd1, 0xd4, 0x00, 0x01, 0xd2, 0x54,
-  0x00, 0x01, 0xd2, 0x90, 0x00, 0x01, 0xd2, 0xfc, 0x00, 0x01, 0xd3, 0xa4,
-  0x00, 0x01, 0xd4, 0x4c, 0x00, 0x01, 0xd4, 0x70, 0x00, 0x01, 0xd4, 0x98,
-  0x00, 0x01, 0xd4, 0xc0, 0x00, 0x01, 0xd4, 0xe8, 0x00, 0x01, 0xd5, 0x10,
-  0x00, 0x01, 0xd5, 0x38, 0x00, 0x01, 0xd5, 0x5c, 0x00, 0x01, 0xd5, 0x80,
-  0x00, 0x01, 0xd5, 0x9c, 0x00, 0x01, 0xd5, 0xb8, 0x00, 0x01, 0xd5, 0xd4,
-  0x00, 0x01, 0xd6, 0x1c, 0x00, 0x01, 0xd6, 0x64, 0x00, 0x01, 0xd6, 0xac,
-  0x00, 0x01, 0xd6, 0xf4, 0x00, 0x01, 0xd7, 0x10, 0x00, 0x01, 0xd7, 0x2c,
-  0x00, 0x01, 0xd7, 0x94, 0x00, 0x01, 0xd8, 0x14, 0x00, 0x01, 0xd8, 0x7c,
-  0x00, 0x01, 0xd8, 0xbc, 0x00, 0x01, 0xd8, 0xfc, 0x00, 0x01, 0xd9, 0x3c,
-  0x00, 0x01, 0xd9, 0x7c, 0x00, 0x01, 0xd9, 0xd8, 0x00, 0x01, 0xda, 0x34,
-  0x00, 0x01, 0xda, 0x74, 0x00, 0x01, 0xda, 0xb4, 0x00, 0x01, 0xda, 0xf4,
-  0x00, 0x01, 0xdb, 0x34, 0x00, 0x01, 0xdb, 0x74, 0x00, 0x01, 0xdb, 0xb4,
-  0x00, 0x01, 0xdc, 0x10, 0x00, 0x01, 0xdc, 0x6c, 0x00, 0x01, 0xdc, 0xc4,
-  0x00, 0x01, 0xdd, 0x1c, 0x00, 0x01, 0xdd, 0x60, 0x00, 0x01, 0xdd, 0xa8,
-  0x00, 0x01, 0xdd, 0xf0, 0x00, 0x01, 0xde, 0x3c, 0x00, 0x01, 0xde, 0x78,
-  0x00, 0x01, 0xde, 0xb4, 0x00, 0x01, 0xde, 0xf8, 0x00, 0x01, 0xdf, 0x38,
-  0x00, 0x01, 0xdf, 0x78, 0x00, 0x01, 0xdf, 0xb4, 0x00, 0x01, 0xe0, 0x10,
-  0x00, 0x01, 0xe0, 0x60, 0x00, 0x01, 0xe0, 0xc0, 0x00, 0x01, 0xe1, 0x1c,
-  0x00, 0x01, 0xe1, 0x7c, 0x00, 0x01, 0xe1, 0xf0, 0x00, 0x01, 0xe2, 0x44,
-  0x00, 0x01, 0xe2, 0x88, 0x00, 0x01, 0xe2, 0xcc, 0x00, 0x01, 0xe3, 0x20,
-  0x00, 0x01, 0xe3, 0xfc, 0x00, 0x01, 0xe4, 0x18, 0x00, 0x01, 0xe4, 0x78,
-  0x00, 0x01, 0xe4, 0xbc, 0x00, 0x01, 0xe5, 0x04, 0x00, 0x01, 0xe5, 0x60,
-  0x00, 0x01, 0xe5, 0xb8, 0x00, 0x01, 0xe6, 0x14, 0x00, 0x01, 0xe6, 0x84,
-  0x00, 0x01, 0xe6, 0xb8, 0x00, 0x01, 0xe6, 0xec, 0x00, 0x01, 0xe7, 0x3c,
-  0x00, 0x01, 0xe7, 0x74, 0x00, 0x01, 0xe7, 0xd8, 0x00, 0x01, 0xe8, 0x6c,
-  0x00, 0x01, 0xe8, 0xa0, 0x00, 0x01, 0xe9, 0x08, 0x00, 0x01, 0xe9, 0xc8,
-  0x00, 0x01, 0xe9, 0xf4, 0x00, 0x01, 0xea, 0x24, 0x00, 0x01, 0xea, 0x88,
-  0x00, 0x01, 0xeb, 0x2c, 0x00, 0x01, 0xeb, 0x80, 0x00, 0x01, 0xeb, 0xe4,
-  0x00, 0x01, 0xec, 0x88, 0x00, 0x01, 0xec, 0xdc, 0x00, 0x01, 0xec, 0xf8,
-  0x00, 0x01, 0xed, 0x20, 0x00, 0x01, 0xed, 0x48, 0x00, 0x01, 0xed, 0x80,
-  0x00, 0x01, 0xed, 0x9c, 0x00, 0x01, 0xed, 0xd8, 0x00, 0x01, 0xee, 0x14,
-  0x00, 0x01, 0xee, 0x24, 0x00, 0x01, 0xee, 0x38, 0x00, 0x01, 0xee, 0x84,
-  0x00, 0x01, 0xee, 0x98, 0x00, 0x01, 0xee, 0xa8, 0x00, 0x01, 0xee, 0xdc,
-  0x00, 0x01, 0xee, 0xf4, 0x00, 0x01, 0xef, 0x0c, 0x00, 0x01, 0xef, 0xa4,
-  0x00, 0x01, 0xf0, 0x5c, 0x00, 0x01, 0xf0, 0x7c, 0x00, 0x01, 0xf0, 0xa0,
-  0x00, 0x01, 0xf1, 0x0c, 0x00, 0x01, 0xf1, 0x84, 0x00, 0x01, 0xf1, 0xa0,
-  0x00, 0x01, 0xf1, 0xd4, 0x00, 0x01, 0xf1, 0xfc, 0x00, 0x01, 0xf2, 0x44,
-  0x00, 0x01, 0xf2, 0x6c, 0x00, 0x01, 0xf2, 0x94, 0x00, 0x01, 0xf2, 0xd4,
-  0x00, 0x01, 0xf3, 0x14, 0x00, 0x01, 0xf3, 0x64, 0x00, 0x01, 0xf3, 0x7c,
-  0x00, 0x01, 0xf3, 0x9c, 0x00, 0x01, 0xf4, 0x68, 0x00, 0x01, 0xf5, 0xa0,
-  0x00, 0x01, 0xf7, 0x48, 0x00, 0x01, 0xf7, 0xe8, 0x00, 0x01, 0xf8, 0xb0,
-  0x00, 0x01, 0xf9, 0x78, 0x00, 0x01, 0xf9, 0x9c, 0x00, 0x01, 0xf9, 0xc0,
-  0x00, 0x01, 0xf9, 0xdc, 0x00, 0x01, 0xfa, 0x08, 0x00, 0x01, 0xfa, 0x20,
-  0x00, 0x01, 0xfa, 0x54, 0x00, 0x01, 0xfa, 0x84, 0x00, 0x01, 0xfa, 0xa4,
-  0x00, 0x01, 0xfb, 0x04, 0x00, 0x01, 0xfb, 0x64, 0x00, 0x01, 0xfb, 0xe0,
-  0x00, 0x01, 0xfc, 0x28, 0x00, 0x01, 0xfc, 0x88, 0x00, 0x01, 0xfc, 0xe8,
-  0x00, 0x01, 0xfd, 0x54, 0x00, 0x01, 0xfd, 0xbc, 0x00, 0x01, 0xfe, 0x3c,
-  0x00, 0x01, 0xfe, 0xb0, 0x00, 0x01, 0xff, 0x40, 0x00, 0x01, 0xff, 0xd0,
-  0x00, 0x02, 0x00, 0x84, 0x00, 0x02, 0x01, 0x24, 0x00, 0x02, 0x01, 0xd4,
-  0x00, 0x02, 0x02, 0xbc, 0x00, 0x02, 0x03, 0x30, 0x00, 0x02, 0x03, 0x88,
-  0x00, 0x02, 0x04, 0x40, 0x00, 0x02, 0x04, 0xb4, 0x00, 0x02, 0x04, 0xcc,
-  0x00, 0x02, 0x04, 0xec, 0x00, 0x02, 0x05, 0x0c, 0x00, 0x02, 0x05, 0x2c,
-  0x00, 0x02, 0x05, 0x50, 0x00, 0x02, 0x05, 0x70, 0x00, 0x02, 0x05, 0xcc,
-  0x00, 0x02, 0x06, 0x38, 0x00, 0x02, 0x06, 0x7c, 0x00, 0x02, 0x06, 0xc0,
-  0x00, 0x02, 0x07, 0x00, 0x00, 0x02, 0x07, 0x4c, 0x00, 0x02, 0x07, 0x90,
-  0x00, 0x02, 0x08, 0x70, 0x00, 0x02, 0x08, 0xf4, 0x00, 0x02, 0x09, 0x80,
-  0x00, 0x02, 0x09, 0xcc, 0x00, 0x02, 0x0a, 0x00, 0x00, 0x02, 0x0a, 0x60,
-  0x00, 0x02, 0x0a, 0xa4, 0x00, 0x02, 0x0a, 0xe0, 0x00, 0x02, 0x0b, 0x18,
-  0x00, 0x02, 0x0b, 0x60, 0x00, 0x02, 0x0b, 0xa0, 0x00, 0x02, 0x0c, 0x08,
-  0x00, 0x02, 0x0c, 0x6c, 0x00, 0x02, 0x0c, 0xb4, 0x00, 0x02, 0x0c, 0xf8,
-  0x00, 0x02, 0x0d, 0x80, 0x00, 0x02, 0x0d, 0xe8, 0x00, 0x02, 0x0e, 0x3c,
-  0x00, 0x02, 0x0e, 0x90, 0x00, 0x02, 0x0e, 0xfc, 0x00, 0x02, 0x0f, 0x64,
-  0x00, 0x02, 0x0f, 0xe4, 0x00, 0x02, 0x10, 0x5c, 0x00, 0x02, 0x11, 0x10,
-  0x00, 0x02, 0x11, 0xc4, 0x00, 0x02, 0x12, 0x08, 0x00, 0x02, 0x12, 0x50,
-  0x00, 0x02, 0x12, 0xdc, 0x00, 0x02, 0x13, 0x64, 0x00, 0x02, 0x13, 0xa0,
-  0x00, 0x02, 0x13, 0xd8, 0x00, 0x02, 0x14, 0x2c, 0x00, 0x02, 0x14, 0x7c,
-  0x00, 0x02, 0x15, 0x0c, 0x00, 0x02, 0x15, 0x98, 0x00, 0x02, 0x16, 0x08,
-  0x00, 0x02, 0x16, 0x78, 0x00, 0x02, 0x16, 0xbc, 0x00, 0x02, 0x17, 0x00,
-  0x00, 0x02, 0x17, 0x68, 0x00, 0x02, 0x17, 0xd0, 0x00, 0x02, 0x18, 0x24,
-  0x00, 0x02, 0x18, 0x74, 0x00, 0x02, 0x18, 0xf0, 0x00, 0x02, 0x19, 0x70,
-  0x00, 0x02, 0x19, 0xdc, 0x00, 0x02, 0x1a, 0x48, 0x00, 0x02, 0x1a, 0xa8,
-  0x00, 0x02, 0x1a, 0xc0, 0x00, 0x02, 0x1b, 0x1c, 0x00, 0x02, 0x1b, 0x44,
-  0x00, 0x02, 0x1b, 0x6c, 0x00, 0x02, 0x1b, 0xa0, 0x00, 0x02, 0x1b, 0xd4,
-  0x00, 0x02, 0x1b, 0xfc, 0x00, 0x02, 0x1c, 0x20, 0x00, 0x02, 0x1c, 0xe8,
-  0x00, 0x02, 0x1d, 0x9c, 0x00, 0x02, 0x1e, 0x68, 0x00, 0x02, 0x1f, 0x20,
-  0x00, 0x02, 0x1f, 0xd0, 0x00, 0x02, 0x20, 0xb8, 0x00, 0x02, 0x21, 0x9c,
-  0x00, 0x02, 0x22, 0x5c, 0x00, 0x02, 0x23, 0x10, 0x00, 0x02, 0x23, 0x60,
-  0x00, 0x02, 0x23, 0x9c, 0x00, 0x02, 0x24, 0x00, 0x00, 0x02, 0x24, 0x38,
-  0x00, 0x02, 0x24, 0x5c, 0x00, 0x02, 0x24, 0x80, 0x00, 0x02, 0x24, 0xa8,
-  0x00, 0x02, 0x24, 0xcc, 0x00, 0x02, 0x24, 0xf0, 0x00, 0x02, 0x25, 0x20,
-  0x00, 0x02, 0x25, 0x50, 0x00, 0x02, 0x25, 0x80, 0x00, 0x02, 0x25, 0xc0,
-  0x00, 0x02, 0x25, 0xfc, 0x00, 0x02, 0x26, 0x40, 0x00, 0x02, 0x26, 0x9c,
-  0x00, 0x02, 0x26, 0xf0, 0x00, 0x02, 0x27, 0x58, 0x00, 0x02, 0x27, 0xdc,
-  0x00, 0x02, 0x28, 0x64, 0x00, 0x02, 0x28, 0x94, 0x00, 0x02, 0x28, 0xc0,
-  0x00, 0x02, 0x28, 0xf8, 0x00, 0x02, 0x29, 0x30, 0x00, 0x02, 0x29, 0x9c,
-  0x00, 0x02, 0x2a, 0x08, 0x00, 0x02, 0x2a, 0x58, 0x00, 0x02, 0x2a, 0x9c,
-  0x00, 0x02, 0x2a, 0xc0, 0x00, 0x02, 0x2a, 0xf4, 0x00, 0x02, 0x2b, 0x2c,
-  0x00, 0x02, 0x2b, 0x60, 0x00, 0x02, 0x2b, 0xb4, 0x00, 0x02, 0x2b, 0xe4,
-  0x00, 0x02, 0x2c, 0x10, 0x00, 0x02, 0x2c, 0x3c, 0x00, 0x02, 0x2c, 0x80,
-  0x00, 0x02, 0x2c, 0xc4, 0x00, 0x02, 0x2c, 0xd4, 0x00, 0x02, 0x2c, 0xec,
-  0x00, 0x02, 0x2d, 0x20, 0x00, 0x02, 0x2d, 0x8c, 0x00, 0x02, 0x2d, 0xd0,
-  0x00, 0x02, 0x2e, 0x10, 0x00, 0x02, 0x2e, 0x50, 0x00, 0x02, 0x2e, 0x7c,
-  0x00, 0x02, 0x2e, 0xac, 0x00, 0x02, 0x2f, 0x10, 0x00, 0x02, 0x2f, 0x48,
-  0x00, 0x02, 0x2f, 0x80, 0x00, 0x02, 0x30, 0x00, 0x00, 0x02, 0x30, 0x80,
-  0x00, 0x02, 0x30, 0xf8, 0x00, 0x02, 0x31, 0x70, 0x00, 0x02, 0x31, 0xcc,
-  0x00, 0x02, 0x32, 0x30, 0x00, 0x02, 0x32, 0x68, 0x00, 0x02, 0x32, 0x9c,
-  0x00, 0x02, 0x33, 0x04, 0x00, 0x02, 0x33, 0x64, 0x00, 0x02, 0x33, 0xbc,
-  0x00, 0x02, 0x34, 0x10, 0x00, 0x02, 0x34, 0x48, 0x00, 0x02, 0x34, 0x80,
-  0x00, 0x02, 0x34, 0xd4, 0x00, 0x02, 0x35, 0x28, 0x00, 0x02, 0x35, 0xb8,
-  0x00, 0x02, 0x36, 0x48, 0x00, 0x02, 0x36, 0xb0, 0x00, 0x02, 0x37, 0x18,
-  0x00, 0x02, 0x37, 0x64, 0x00, 0x02, 0x37, 0xb0, 0x00, 0x02, 0x38, 0x28,
-  0x00, 0x02, 0x38, 0xa0, 0x00, 0x02, 0x39, 0x28, 0x00, 0x02, 0x39, 0xb0,
-  0x00, 0x02, 0x3a, 0x08, 0x00, 0x02, 0x3a, 0x60, 0x00, 0x02, 0x3a, 0xd4,
-  0x00, 0x02, 0x3b, 0x44, 0x00, 0x02, 0x3b, 0x68, 0x00, 0x02, 0x3b, 0x88,
-  0x00, 0x02, 0x3b, 0xac, 0x00, 0x02, 0x3b, 0xd0, 0x00, 0x02, 0x3c, 0x44,
-  0x00, 0x02, 0x3c, 0xa8, 0x00, 0x02, 0x3d, 0x00, 0x00, 0x02, 0x3d, 0x18,
-  0x00, 0x02, 0x3d, 0x8c, 0x00, 0x02, 0x3d, 0xec, 0x00, 0x02, 0x3e, 0x60,
-  0x00, 0x02, 0x3e, 0xcc, 0x00, 0x02, 0x3f, 0x40, 0x00, 0x02, 0x3f, 0xa4,
-  0x00, 0x02, 0x40, 0x00, 0x00, 0x02, 0x40, 0x74, 0x00, 0x02, 0x40, 0xd8,
-  0x00, 0x02, 0x41, 0x0c, 0x00, 0x02, 0x41, 0x84, 0x00, 0x02, 0x41, 0xb0,
-  0x00, 0x02, 0x41, 0xe8, 0x00, 0x02, 0x42, 0x18, 0x00, 0x02, 0x42, 0x44,
-  0x00, 0x02, 0x42, 0x5c, 0x00, 0x02, 0x42, 0x7c, 0x00, 0x02, 0x42, 0xd4,
-  0x00, 0x02, 0x42, 0xf4, 0x00, 0x02, 0x43, 0x14, 0x00, 0x02, 0x43, 0x34,
-  0x00, 0x02, 0x43, 0x54, 0x00, 0x02, 0x43, 0x7c, 0x00, 0x02, 0x43, 0xa4,
-  0x00, 0x02, 0x43, 0xcc, 0x00, 0x02, 0x43, 0xf4, 0x00, 0x02, 0x44, 0x14,
-  0x00, 0x02, 0x44, 0x64, 0x00, 0x02, 0x45, 0x5c, 0x00, 0x02, 0x45, 0x80,
-  0x00, 0x02, 0x45, 0xa4, 0x00, 0x02, 0x45, 0xc4, 0x00, 0x02, 0x45, 0xe4,
-  0x00, 0x02, 0x46, 0x04, 0x00, 0x02, 0x46, 0x5c, 0x00, 0x02, 0x46, 0xb4,
-  0x00, 0x02, 0x47, 0x00, 0x00, 0x02, 0x47, 0x38, 0x00, 0x02, 0x47, 0xa4,
-  0x00, 0x02, 0x48, 0x04, 0x00, 0x02, 0x4c, 0xb8, 0x00, 0x02, 0x4d, 0x24,
-  0x00, 0x02, 0x4d, 0x98, 0x00, 0x02, 0x4d, 0xa8, 0x00, 0x02, 0x4d, 0xb8,
-  0x00, 0x02, 0x4d, 0xc8, 0x00, 0x02, 0x4d, 0xd8, 0x00, 0x02, 0x4e, 0x08,
-  0x00, 0x02, 0x4e, 0x54, 0x00, 0x02, 0x4e, 0x98, 0x00, 0x02, 0x4e, 0xd0,
-  0x00, 0x02, 0x4e, 0xec, 0x00, 0x02, 0x4f, 0x24, 0x00, 0x02, 0x4f, 0x5c,
-  0x00, 0x02, 0x4f, 0x78, 0x00, 0x02, 0x4f, 0xb0, 0x00, 0x02, 0x4f, 0xd0,
-  0x00, 0x02, 0x4f, 0xec, 0x00, 0x02, 0x50, 0x10, 0x00, 0x02, 0x50, 0x34,
-  0x00, 0x02, 0x50, 0x50, 0x00, 0x02, 0x50, 0x70, 0x00, 0x02, 0x50, 0xa4,
-  0x00, 0x02, 0x50, 0xfc, 0x00, 0x02, 0x51, 0x30, 0x00, 0x02, 0x51, 0x4c,
-  0x00, 0x02, 0x51, 0x80, 0x00, 0x02, 0x51, 0xd8, 0x00, 0x02, 0x52, 0x0c,
-  0x00, 0x02, 0x52, 0x28, 0x00, 0x02, 0x52, 0x78, 0x00, 0x02, 0x52, 0xa4,
-  0x00, 0x02, 0x53, 0x4c, 0x00, 0x02, 0x53, 0x5c, 0x00, 0x02, 0x53, 0xc8,
-  0x00, 0x02, 0x54, 0x38, 0x00, 0x02, 0x54, 0x60, 0x00, 0x02, 0x54, 0xf4,
-  0x00, 0x02, 0x55, 0xb8, 0x00, 0x02, 0x56, 0x90, 0x00, 0x02, 0x57, 0x2c,
-  0x00, 0x02, 0x57, 0xec, 0x00, 0x02, 0x58, 0xc0, 0x00, 0x02, 0x59, 0x4c,
-  0x00, 0x02, 0x5a, 0x3c, 0x00, 0x02, 0x5b, 0x10, 0x00, 0x02, 0x5b, 0xe0,
-  0x00, 0x02, 0x5b, 0xfc, 0x00, 0x02, 0x5c, 0x18, 0x00, 0x02, 0x5c, 0x34,
-  0x00, 0x02, 0x5c, 0x50, 0x00, 0x02, 0x5c, 0x84, 0x00, 0x02, 0x5c, 0xbc,
-  0x00, 0x02, 0x5c, 0xf4, 0x00, 0x02, 0x5d, 0x30, 0x00, 0x02, 0x5d, 0x68,
-  0x00, 0x02, 0x5d, 0xa8, 0x00, 0x02, 0x5d, 0xf0, 0x00, 0x02, 0x5e, 0x3c,
-  0x00, 0x02, 0x5e, 0x60, 0x00, 0x02, 0x5e, 0x84, 0x00, 0x02, 0x5e, 0xa8,
-  0x00, 0x02, 0x5e, 0xcc, 0x00, 0x02, 0x5e, 0xf0, 0x00, 0x02, 0x5f, 0x14,
-  0x00, 0x02, 0x5f, 0x38, 0x00, 0x02, 0x5f, 0x5c, 0x00, 0x02, 0x5f, 0x7c,
-  0x00, 0x02, 0x5f, 0xa0, 0x00, 0x02, 0x5f, 0xc4, 0x00, 0x02, 0x5f, 0xe8,
-  0x00, 0x02, 0x60, 0x08, 0x00, 0x02, 0x60, 0x28, 0x00, 0x02, 0x60, 0x48,
-  0x00, 0x02, 0x60, 0x6c, 0x00, 0x02, 0x60, 0x94, 0x00, 0x02, 0x60, 0xbc,
-  0x00, 0x02, 0x60, 0xe8, 0x00, 0x02, 0x61, 0x14, 0x00, 0x02, 0x61, 0x3c,
-  0x00, 0x02, 0x61, 0x6c, 0x00, 0x02, 0x61, 0x98, 0x00, 0x02, 0x61, 0xc0,
-  0x00, 0x02, 0x61, 0xe8, 0x00, 0x02, 0x62, 0x10, 0x00, 0x02, 0x62, 0x3c,
-  0x00, 0x02, 0x62, 0x68, 0x00, 0x02, 0x62, 0x90, 0x00, 0x02, 0x62, 0xc0,
-  0x00, 0x02, 0x62, 0xec, 0x00, 0x02, 0x63, 0x14, 0x00, 0x02, 0x63, 0x3c,
-  0x00, 0x02, 0x63, 0x68, 0x00, 0x02, 0x63, 0x94, 0x00, 0x02, 0x63, 0xbc,
-  0x00, 0x02, 0x63, 0xe4, 0x00, 0x02, 0x64, 0x10, 0x00, 0x02, 0x64, 0x3c,
-  0x00, 0x02, 0x64, 0x64, 0x00, 0x02, 0x64, 0x88, 0x00, 0x02, 0x64, 0xb4,
-  0x00, 0x02, 0x64, 0xe0, 0x00, 0x02, 0x65, 0x08, 0x00, 0x02, 0x65, 0x30,
-  0x00, 0x02, 0x65, 0x5c, 0x00, 0x02, 0x65, 0x88, 0x00, 0x02, 0x65, 0xb0,
-  0x00, 0x02, 0x65, 0xe0, 0x00, 0x02, 0x66, 0x14, 0x00, 0x02, 0x66, 0x48,
-  0x00, 0x02, 0x66, 0x7c, 0x00, 0x02, 0x66, 0xb0, 0x00, 0x02, 0x66, 0xe4,
-  0x00, 0x02, 0x67, 0x18, 0x00, 0x02, 0x67, 0x50, 0x00, 0x02, 0x67, 0x88,
-  0x00, 0x02, 0x67, 0xc0, 0x00, 0x02, 0x67, 0xf8, 0x00, 0x02, 0x68, 0x2c,
-  0x00, 0x02, 0x68, 0x60, 0x00, 0x02, 0x68, 0x94, 0x00, 0x02, 0x68, 0xc8,
-  0x00, 0x02, 0x68, 0xfc, 0x00, 0x02, 0x69, 0x20, 0x00, 0x02, 0x69, 0x4c,
-  0x00, 0x02, 0x69, 0x78, 0x00, 0x02, 0x69, 0xa4, 0x00, 0x02, 0x69, 0xcc,
-  0x00, 0x02, 0x69, 0xf4, 0x00, 0x02, 0x6a, 0x20, 0x00, 0x02, 0x6a, 0x4c,
-  0x00, 0x02, 0x6a, 0x80, 0x00, 0x02, 0x6a, 0xac, 0x00, 0x02, 0x6a, 0xd8,
-  0x00, 0x02, 0x6b, 0x0c, 0x00, 0x02, 0x6b, 0x38, 0x00, 0x02, 0x6b, 0x64,
-  0x00, 0x02, 0x6b, 0x98, 0x00, 0x02, 0x6b, 0xc4, 0x00, 0x02, 0x6b, 0xf0,
-  0x00, 0x02, 0x6c, 0x24, 0x00, 0x02, 0x6c, 0x54, 0x00, 0x02, 0x6c, 0x88,
-  0x00, 0x02, 0x6c, 0xcc, 0x00, 0x02, 0x6c, 0xfc, 0x00, 0x02, 0x6d, 0x30,
-  0x00, 0x02, 0x6d, 0x70, 0x00, 0x02, 0x6d, 0xa4, 0x00, 0x02, 0x6d, 0xd4,
-  0x00, 0x02, 0x6e, 0x14, 0x00, 0x02, 0x6e, 0x48, 0x00, 0x02, 0x6e, 0x78,
-  0x00, 0x02, 0x6e, 0xb8, 0x00, 0x02, 0x6f, 0x00, 0x00, 0x02, 0x6f, 0x44,
-  0x00, 0x02, 0x6f, 0xa0, 0x00, 0x02, 0x6f, 0xd4, 0x00, 0x02, 0x70, 0x0c,
-  0x00, 0x02, 0x70, 0x3c, 0x00, 0x02, 0x70, 0x70, 0x00, 0x02, 0x70, 0x90,
-  0x00, 0x02, 0x70, 0xac, 0x00, 0x02, 0x70, 0xec, 0x00, 0x02, 0x71, 0x08,
-  0x00, 0x02, 0x71, 0x24, 0x00, 0x02, 0x71, 0x40, 0x00, 0x02, 0x71, 0x5c,
-  0x00, 0x02, 0x71, 0x78, 0x00, 0x02, 0x71, 0x94, 0x00, 0x02, 0x71, 0xb0,
-  0x00, 0x02, 0x71, 0xcc, 0x00, 0x02, 0x71, 0xf0, 0x00, 0x02, 0x72, 0x18,
-  0x00, 0x02, 0x72, 0x3c, 0x00, 0x02, 0x72, 0x64, 0x00, 0x02, 0x72, 0x78,
-  0x00, 0x02, 0x72, 0x94, 0x00, 0x02, 0x72, 0xb0, 0x00, 0x02, 0x72, 0xcc,
-  0x00, 0x02, 0x72, 0xe8, 0x00, 0x02, 0x73, 0x04, 0x00, 0x02, 0x73, 0x20,
-  0x00, 0x02, 0x73, 0x3c, 0x00, 0x02, 0x73, 0x58, 0x00, 0x02, 0x73, 0x74,
-  0x00, 0x02, 0x73, 0x90, 0x00, 0x02, 0x73, 0xac, 0x00, 0x02, 0x73, 0xc8,
-  0x00, 0x02, 0x73, 0xe4, 0x00, 0x02, 0x74, 0x00, 0x00, 0x02, 0x74, 0x1c,
-  0x00, 0x02, 0x74, 0x30, 0x00, 0x02, 0x74, 0xe4, 0x00, 0x02, 0x77, 0xf8,
-  0x00, 0x02, 0x78, 0xa0, 0x00, 0x02, 0x78, 0xb4, 0x00, 0x02, 0x78, 0xc8,
-  0x00, 0x02, 0x78, 0xe4, 0x00, 0x02, 0x79, 0x00, 0x00, 0x02, 0x79, 0x1c,
-  0x00, 0x02, 0x79, 0x40, 0x00, 0x02, 0x79, 0x68, 0x00, 0x02, 0x79, 0x8c,
-  0x00, 0x02, 0x79, 0xb0, 0x00, 0x02, 0x79, 0xcc, 0x00, 0x02, 0x79, 0xf4,
-  0x00, 0x02, 0x7a, 0x18, 0x00, 0x02, 0x7a, 0x34, 0x00, 0x02, 0x7a, 0x60,
-  0x00, 0x02, 0x7a, 0xb4, 0x00, 0x02, 0x7a, 0xcc, 0x00, 0x02, 0x7b, 0x24,
-  0x00, 0x02, 0x7b, 0x84, 0x00, 0x02, 0x7c, 0xc0, 0x00, 0x02, 0x7d, 0x48,
-  0x00, 0x02, 0x7d, 0xd0, 0x00, 0x02, 0x7f, 0x8c, 0x00, 0x02, 0x7f, 0xa8,
-  0x00, 0x02, 0x7f, 0xd4, 0x00, 0x02, 0x7f, 0xf0, 0x00, 0x02, 0x80, 0x1c,
-  0x00, 0x02, 0x80, 0x38, 0x00, 0x02, 0x80, 0x64, 0x00, 0x02, 0x80, 0x84,
-  0x00, 0x02, 0x80, 0xb4, 0x00, 0x02, 0x80, 0xd0, 0x00, 0x02, 0x80, 0xf8,
-  0x00, 0x02, 0x81, 0x14, 0x00, 0x02, 0x81, 0x3c, 0x00, 0x02, 0x81, 0x58,
-  0x00, 0x02, 0x81, 0x84, 0x00, 0x02, 0x81, 0xa0, 0x00, 0x02, 0x81, 0xcc,
-  0x00, 0x02, 0x81, 0xe8, 0x00, 0x02, 0x82, 0x14, 0x00, 0x02, 0x82, 0x30,
-  0x00, 0x02, 0x82, 0x5c, 0x00, 0x02, 0x82, 0x78, 0x00, 0x02, 0x82, 0xa4,
-  0x00, 0x02, 0x82, 0xc0, 0x00, 0x02, 0x82, 0xec, 0x00, 0x02, 0x83, 0x08,
-  0x00, 0x02, 0x83, 0x34, 0x00, 0x02, 0x83, 0x50, 0x00, 0x02, 0x83, 0x7c,
-  0x00, 0x02, 0x83, 0x9c, 0x00, 0x02, 0x83, 0xd0, 0x00, 0x02, 0x84, 0x14,
-  0x00, 0x02, 0x84, 0xa4, 0x00, 0x02, 0x84, 0xd8, 0x00, 0x02, 0x85, 0x40,
-  0x00, 0x02, 0x86, 0x38, 0x00, 0x02, 0x86, 0xec, 0x00, 0x02, 0x87, 0xa8,
-  0x00, 0x02, 0x87, 0xf8, 0x00, 0x02, 0x88, 0x50, 0x00, 0x02, 0x88, 0xa8,
-  0x00, 0x02, 0x89, 0x04, 0x00, 0x02, 0x89, 0x60, 0x00, 0x02, 0x89, 0xc8,
-  0x00, 0x02, 0x8a, 0x18, 0x00, 0x02, 0x8a, 0x40, 0x00, 0x02, 0x8a, 0x68,
-  0x00, 0x02, 0x8a, 0xa4, 0x00, 0x02, 0x8b, 0x1c, 0x00, 0x02, 0x8b, 0x70,
-  0x00, 0x02, 0x8b, 0xc4, 0x00, 0x02, 0x8b, 0xf0, 0x00, 0x02, 0x8c, 0x1c,
-  0x00, 0x02, 0x8c, 0x48, 0x00, 0x02, 0x8c, 0x78, 0x00, 0x02, 0x8c, 0xbc,
-  0x00, 0x02, 0x8d, 0x00, 0x00, 0x02, 0x8d, 0x1c, 0x00, 0x02, 0x8d, 0x38,
-  0x00, 0x02, 0x8d, 0x50, 0x00, 0x02, 0x8d, 0x68, 0x00, 0x02, 0x8d, 0xb0,
-  0x00, 0x02, 0x8d, 0xdc, 0x00, 0x02, 0x8e, 0x08, 0x00, 0x02, 0x8e, 0x30,
-  0x00, 0x02, 0x8e, 0x58, 0x00, 0x02, 0x8e, 0x94, 0x00, 0x02, 0x8e, 0xd8,
-  0x00, 0x02, 0x8f, 0x04, 0x00, 0x02, 0x8f, 0x2c, 0x00, 0x02, 0x8f, 0x94,
-  0x00, 0x02, 0x8f, 0xd4, 0x00, 0x02, 0x90, 0x14, 0x00, 0x02, 0x90, 0x54,
-  0x00, 0x02, 0x90, 0x94, 0x00, 0x02, 0x91, 0x14, 0x00, 0x02, 0x91, 0x94,
-  0x00, 0x02, 0x92, 0x14, 0x00, 0x02, 0x92, 0x94, 0x00, 0x02, 0x92, 0xbc,
-  0x00, 0x02, 0x92, 0xe4, 0x00, 0x02, 0x93, 0x0c, 0x00, 0x02, 0x93, 0x38,
-  0x00, 0x02, 0x93, 0x54, 0x00, 0x02, 0x93, 0x80, 0x00, 0x02, 0x93, 0x9c,
-  0x00, 0x02, 0x93, 0xc4, 0x00, 0x02, 0x94, 0xb4, 0x00, 0x02, 0x95, 0x20,
-  0x00, 0x02, 0x95, 0xd4, 0x00, 0x02, 0x9e, 0xb4, 0x00, 0x02, 0xa1, 0x94,
-  0x00, 0x02, 0xa1, 0xcc, 0x00, 0x02, 0xa2, 0x30, 0x00, 0x02, 0xa2, 0x80,
-  0x00, 0x02, 0xa2, 0xe4, 0x00, 0x02, 0xa3, 0x78, 0x00, 0x02, 0xa4, 0x44,
-  0x00, 0x02, 0xa5, 0x10, 0x00, 0x02, 0xa5, 0x74, 0x00, 0x02, 0xa6, 0x10,
-  0x00, 0x02, 0xa8, 0x90, 0x00, 0x02, 0xab, 0x70, 0x00, 0x02, 0xab, 0xa8,
-  0x00, 0x02, 0xac, 0x20, 0x00, 0x02, 0xac, 0x94, 0x00, 0x02, 0xac, 0xec,
-  0x00, 0x02, 0xae, 0x48, 0x00, 0x02, 0xaf, 0xf4, 0x00, 0x02, 0xb0, 0x3c,
-  0x00, 0x02, 0xb0, 0x70, 0x00, 0x02, 0xb1, 0x64, 0x00, 0x02, 0xb2, 0x34,
-  0x00, 0x02, 0xb2, 0xc8, 0x00, 0x02, 0xb3, 0x5c, 0x00, 0x02, 0xb4, 0x20,
-  0x00, 0x02, 0xb4, 0xe8, 0x00, 0x02, 0xb5, 0xac, 0x00, 0x02, 0xb6, 0x70,
-  0x00, 0x02, 0xb9, 0xf4, 0x00, 0x02, 0xba, 0x70, 0x00, 0x02, 0xbb, 0x90,
-  0x00, 0x02, 0xbd, 0x2c, 0x00, 0x02, 0xc0, 0x88, 0x00, 0x02, 0xc1, 0x08,
-  0x00, 0x02, 0xc1, 0x8c, 0x00, 0x02, 0xc2, 0x00, 0x00, 0x02, 0xc2, 0x64,
-  0x00, 0x02, 0xc2, 0xe8, 0x00, 0x02, 0xc3, 0x78, 0x00, 0x02, 0xc4, 0xbc,
-  0x00, 0x02, 0xc5, 0xec, 0x00, 0x02, 0xc6, 0x88, 0x00, 0x02, 0xc7, 0x1c,
-  0x00, 0x02, 0xc7, 0xd0, 0x00, 0x02, 0xc7, 0xf0, 0x00, 0x02, 0xc8, 0x10,
-  0x00, 0x02, 0xc8, 0x30, 0x00, 0x02, 0xc8, 0x50, 0x00, 0x02, 0xc8, 0x70,
-  0x00, 0x02, 0xc8, 0x90, 0x00, 0x02, 0xc8, 0xb0, 0x00, 0x02, 0xc8, 0xd0,
-  0x00, 0x02, 0xca, 0x44, 0x00, 0x02, 0xcb, 0x20, 0x00, 0x02, 0xcb, 0xfc,
-  0x00, 0x02, 0xcc, 0xa8, 0x00, 0x02, 0xcd, 0xc4, 0x00, 0x02, 0xce, 0x54,
-  0x00, 0x02, 0xce, 0xe4, 0x00, 0x02, 0xcf, 0x9c, 0x00, 0x02, 0xd0, 0x10,
-  0x00, 0x02, 0xd0, 0x84, 0x00, 0x02, 0xd0, 0xf8, 0x00, 0x02, 0xd1, 0x50,
-  0x00, 0x02, 0xd1, 0xac, 0x00, 0x02, 0xd2, 0x40, 0x00, 0x02, 0xd2, 0xec,
-  0x00, 0x02, 0xd3, 0x54, 0x00, 0x02, 0xd3, 0xc8, 0x00, 0x02, 0xd4, 0x60,
-  0x00, 0x02, 0xd4, 0xc4, 0x00, 0x02, 0xd5, 0x84, 0x00, 0x02, 0xd6, 0x64,
-  0x00, 0x02, 0xd7, 0x34, 0x00, 0x02, 0xd7, 0xa8, 0x00, 0x02, 0xd8, 0x4c,
-  0x00, 0x02, 0xd8, 0xa8, 0x00, 0x02, 0xd9, 0x44, 0x00, 0x02, 0xda, 0x2c,
-  0x00, 0x02, 0xda, 0xa8, 0x00, 0x02, 0xdb, 0xd0, 0x00, 0x02, 0xdd, 0xfc,
-  0x00, 0x02, 0xde, 0x94, 0x00, 0x02, 0xdf, 0xb0, 0x00, 0x02, 0xe0, 0xf8,
-  0x00, 0x02, 0xe2, 0x0c, 0x00, 0x02, 0xe3, 0xa0, 0x00, 0x02, 0xe4, 0x98,
-  0x00, 0x02, 0xe5, 0x18, 0x00, 0x02, 0xe5, 0xdc, 0x00, 0x02, 0xe6, 0xc4,
-  0x00, 0x02, 0xe7, 0x58, 0x00, 0x02, 0xe7, 0xcc, 0x00, 0x02, 0xe8, 0x6c,
-  0x00, 0x02, 0xe8, 0xb4, 0x00, 0x02, 0xe9, 0x54, 0x00, 0x02, 0xea, 0x1c,
-  0x00, 0x02, 0xea, 0x70, 0x00, 0x02, 0xea, 0xa0, 0x00, 0x02, 0xeb, 0xc0,
-  0x00, 0x02, 0xec, 0xac, 0x00, 0x02, 0xec, 0xec, 0x00, 0x02, 0xed, 0x48,
-  0x00, 0x02, 0xed, 0xac, 0x00, 0x02, 0xee, 0x0c, 0x00, 0x02, 0xee, 0x60,
-  0x00, 0x02, 0xee, 0xac, 0x00, 0x02, 0xef, 0x40, 0x00, 0x02, 0xf0, 0x00,
-  0x00, 0x02, 0xf0, 0xe8, 0x00, 0x02, 0xf2, 0xf4, 0x00, 0x02, 0xf3, 0xe8,
-  0x00, 0x02, 0xf5, 0x0c, 0x00, 0x02, 0xf6, 0x48, 0x00, 0x02, 0xf7, 0x48,
-  0x00, 0x02, 0xf8, 0x6c, 0x00, 0x02, 0xf9, 0xa0, 0x00, 0x02, 0xfa, 0x90,
-  0x00, 0x02, 0xfb, 0x64, 0x00, 0x02, 0xfc, 0x70, 0x00, 0x02, 0xfd, 0xa4,
-  0x00, 0x02, 0xfe, 0xfc, 0x00, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0x98,
-  0x00, 0x03, 0x01, 0x08, 0x00, 0x03, 0x01, 0xbc, 0x00, 0x03, 0x02, 0xb0,
-  0x00, 0x03, 0x03, 0xe8, 0x00, 0x03, 0x05, 0x64, 0x00, 0x03, 0x07, 0x24,
-  0x00, 0x03, 0x07, 0xc0, 0x00, 0x03, 0x08, 0x80, 0x00, 0x03, 0x08, 0xe8,
-  0x00, 0x03, 0x09, 0x74, 0x00, 0x03, 0x09, 0x90, 0x00, 0x03, 0x09, 0xb8,
-  0x00, 0x03, 0x09, 0xd0, 0x00, 0x03, 0x09, 0xe8, 0x00, 0x03, 0x0a, 0x00,
-  0x00, 0x03, 0x0a, 0x18, 0x00, 0x03, 0x0a, 0x98, 0x00, 0x03, 0x0a, 0xe8,
-  0x00, 0x03, 0x0b, 0x6c, 0x00, 0x03, 0x0c, 0x64, 0x00, 0x03, 0x0d, 0x0c,
-  0x00, 0x03, 0x0e, 0x2c, 0x00, 0x03, 0x0e, 0xdc, 0x00, 0x03, 0x0f, 0x64,
-  0x00, 0x03, 0x10, 0x08, 0x00, 0x03, 0x11, 0x0c, 0x00, 0x03, 0x12, 0xf4,
-  0x00, 0x03, 0x15, 0xb8, 0x00, 0x03, 0x17, 0x78, 0x00, 0x03, 0x17, 0xfc,
-  0x00, 0x03, 0x18, 0x48, 0x00, 0x03, 0x19, 0x20, 0x00, 0x03, 0x1a, 0x08,
-  0x00, 0x03, 0x1a, 0xec, 0x00, 0x03, 0x1b, 0x78, 0x00, 0x03, 0x1c, 0x58,
-  0x00, 0x03, 0x1d, 0x68, 0x00, 0x03, 0x1e, 0x40, 0x00, 0x03, 0x1f, 0x1c,
-  0x00, 0x03, 0x1f, 0x6c, 0x00, 0x03, 0x1f, 0xa0, 0x00, 0x03, 0x1f, 0xec,
-  0x00, 0x03, 0x20, 0x8c, 0x00, 0x03, 0x21, 0xd8, 0x00, 0x03, 0x23, 0x1c,
-  0x00, 0x03, 0x23, 0x58, 0x00, 0x03, 0x23, 0xd8, 0x00, 0x03, 0x24, 0x30,
-  0x00, 0x03, 0x24, 0x8c, 0x00, 0x03, 0x24, 0xe4, 0x00, 0x03, 0x25, 0x50,
-  0x00, 0x03, 0x25, 0xb4, 0x00, 0x03, 0x26, 0x1c, 0x00, 0x03, 0x26, 0x80,
-  0x00, 0x03, 0x27, 0x28, 0x00, 0x03, 0x28, 0x08, 0x00, 0x03, 0x29, 0x18,
-  0x00, 0x03, 0x2a, 0x84, 0x00, 0x03, 0x2b, 0x18, 0x00, 0x03, 0x2c, 0xa8,
-  0x00, 0x03, 0x2e, 0x0c, 0x00, 0x03, 0x2f, 0x98, 0x00, 0x03, 0x33, 0x58,
-  0x00, 0x03, 0x34, 0xe4, 0x00, 0x03, 0x36, 0x5c, 0x00, 0x03, 0x36, 0xe8,
-  0x00, 0x03, 0x37, 0x98, 0x00, 0x03, 0x3a, 0x4c, 0x00, 0x03, 0x3b, 0xec,
-  0x00, 0x03, 0x3d, 0x04, 0x00, 0x03, 0x3d, 0xf0, 0x00, 0x03, 0x3f, 0x04,
-  0x00, 0x03, 0x3f, 0xec, 0x00, 0x03, 0x40, 0x74, 0x00, 0x03, 0x40, 0xd8,
-  0x00, 0x03, 0x41, 0x3c, 0x00, 0x03, 0x41, 0x80, 0x00, 0x03, 0x41, 0xc0,
-  0x00, 0x03, 0x42, 0x8c, 0x00, 0x03, 0x43, 0x84, 0x00, 0x03, 0x44, 0x04,
-  0x00, 0x03, 0x44, 0x38, 0x00, 0x03, 0x44, 0x74, 0x00, 0x03, 0x44, 0xb8,
-  0x00, 0x03, 0x44, 0xe8, 0x00, 0x03, 0x45, 0x48, 0x00, 0x03, 0x45, 0xbc,
-  0x00, 0x03, 0x46, 0xa0, 0x00, 0x03, 0x47, 0x38, 0x00, 0x03, 0x47, 0xf4,
-  0x00, 0x03, 0x49, 0x74, 0x00, 0x03, 0x4a, 0xf8, 0x00, 0x03, 0x4e, 0x58,
-  0x00, 0x03, 0x4e, 0xb8, 0x00, 0x03, 0x4f, 0x68, 0x00, 0x03, 0x4f, 0xd0,
-  0x00, 0x03, 0x50, 0x5c, 0x00, 0x03, 0x50, 0xec, 0x00, 0x03, 0x51, 0xac,
-  0x00, 0x03, 0x52, 0x38, 0x00, 0x03, 0x52, 0xb8, 0x00, 0x03, 0x53, 0x34,
-  0x00, 0x03, 0x53, 0xa4, 0x00, 0x03, 0x53, 0xf8, 0x00, 0x03, 0x54, 0x60,
-  0x00, 0x03, 0x54, 0xc4, 0x00, 0x03, 0x55, 0x1c, 0x00, 0x03, 0x55, 0xe0,
-  0x00, 0x03, 0x56, 0x24, 0x00, 0x03, 0x56, 0x78, 0x00, 0x03, 0x56, 0xc8,
-  0x00, 0x03, 0x57, 0x34, 0x00, 0x03, 0x57, 0xf0, 0x00, 0x03, 0x59, 0x9c,
-  0x00, 0x03, 0x5b, 0x90, 0x00, 0x03, 0x5c, 0xbc, 0x00, 0x03, 0x5e, 0xec,
-  0x00, 0x03, 0x60, 0x4c, 0x00, 0x03, 0x62, 0xc4, 0x00, 0x03, 0x68, 0x14,
-  0x00, 0x03, 0x69, 0x4c, 0x00, 0x03, 0x6b, 0x9c, 0x00, 0x03, 0x6c, 0x60,
-  0x00, 0x03, 0x6d, 0x24, 0x00, 0x03, 0x6d, 0xf0, 0x00, 0x03, 0x6f, 0x74,
-  0x00, 0x03, 0x70, 0xf4, 0x00, 0x03, 0x72, 0x54, 0x00, 0x03, 0x73, 0xb0,
-  0x00, 0x03, 0x74, 0xfc, 0x00, 0x03, 0x75, 0x80, 0x00, 0x03, 0x75, 0xb4,
-  0x00, 0x03, 0x75, 0xe8, 0x00, 0x03, 0x76, 0x18, 0x00, 0x03, 0x76, 0x48,
-  0x00, 0x03, 0x76, 0xa0, 0x00, 0x03, 0x76, 0xbc, 0x00, 0x03, 0x76, 0xd8,
-  0x00, 0x03, 0x76, 0xf4, 0x00, 0x03, 0x77, 0x1c, 0x00, 0x03, 0x77, 0x40,
-  0x00, 0x03, 0x77, 0x58, 0x00, 0x03, 0x77, 0x70, 0x00, 0x03, 0x78, 0x4c,
-  0x00, 0x03, 0x78, 0xe4, 0x00, 0x03, 0x79, 0xa0, 0x00, 0x03, 0x7a, 0x10,
-  0x00, 0x03, 0x7a, 0x84, 0x00, 0x03, 0x7b, 0xa4, 0x00, 0x03, 0x7c, 0x8c,
-  0x00, 0x03, 0x7c, 0xf8, 0x00, 0x03, 0x7d, 0x68, 0x00, 0x03, 0x7d, 0xa4,
-  0x00, 0x03, 0x7d, 0xe0, 0x00, 0x03, 0x7e, 0x08, 0x00, 0x03, 0x7e, 0x34,
-  0x00, 0x03, 0x7e, 0x5c, 0x00, 0x03, 0x7e, 0x88, 0x00, 0x03, 0x7e, 0xb0,
-  0x00, 0x03, 0x7e, 0xdc, 0x00, 0x03, 0x7f, 0x08, 0x00, 0x03, 0x7f, 0x34,
-  0x00, 0x03, 0x7f, 0x98, 0x00, 0x03, 0x7f, 0xfc, 0x00, 0x03, 0x80, 0x5c,
-  0x00, 0x03, 0x80, 0xec, 0x00, 0x03, 0x81, 0x94, 0x00, 0x03, 0x82, 0x00,
-  0x00, 0x03, 0x82, 0x90, 0x00, 0x03, 0x83, 0x34, 0x00, 0x03, 0x83, 0x90,
-  0x00, 0x03, 0x84, 0x54, 0x00, 0x03, 0x84, 0xf8, 0x00, 0x03, 0x85, 0x98,
-  0x00, 0x03, 0x86, 0x6c, 0x00, 0x03, 0x87, 0x70, 0x00, 0x03, 0x88, 0x88,
-  0x00, 0x03, 0x89, 0x64, 0x00, 0x03, 0x8a, 0x64, 0x00, 0x03, 0x8b, 0x7c,
-  0x00, 0x03, 0x8c, 0x48, 0x00, 0x03, 0x8d, 0x70, 0x00, 0x03, 0x8e, 0x88,
-  0x00, 0x03, 0x8f, 0xb8, 0x00, 0x03, 0x90, 0x38, 0x00, 0x03, 0x90, 0xe8,
-  0x00, 0x03, 0x91, 0xb0, 0x00, 0x03, 0x92, 0x3c, 0x00, 0x03, 0x92, 0xec,
-  0x00, 0x03, 0x93, 0xb4, 0x00, 0x03, 0x94, 0x2c, 0x00, 0x03, 0x95, 0x04,
-  0x00, 0x03, 0x95, 0xcc, 0x00, 0x03, 0x96, 0x90, 0x00, 0x03, 0x96, 0xc0,
-  0x00, 0x03, 0x96, 0xec, 0x00, 0x03, 0x97, 0x18, 0x00, 0x03, 0x97, 0x44,
-  0x00, 0x03, 0x97, 0x74, 0x00, 0x03, 0x98, 0x00, 0x00, 0x03, 0x98, 0x28,
-  0x00, 0x03, 0x98, 0x50, 0x00, 0x03, 0x98, 0xa4, 0x00, 0x03, 0x98, 0xf8,
-  0x00, 0x03, 0x99, 0x20, 0x00, 0x03, 0x99, 0x50, 0x00, 0x03, 0x99, 0x80,
-  0x00, 0x03, 0x99, 0xa0, 0x00, 0x03, 0x99, 0xf0, 0x00, 0x03, 0x9a, 0x40,
-  0x00, 0x03, 0x9a, 0x6c, 0x00, 0x03, 0x9a, 0x9c, 0x00, 0x03, 0x9a, 0xe4,
-  0x00, 0x03, 0x9b, 0x2c, 0x00, 0x03, 0x9b, 0x80, 0x00, 0x03, 0x9b, 0xd0,
-  0x00, 0x03, 0x9c, 0x1c, 0x00, 0x03, 0x9c, 0x6c, 0x00, 0x03, 0x9c, 0xc0,
-  0x00, 0x03, 0x9d, 0x14, 0x00, 0x03, 0x9d, 0x80, 0x00, 0x03, 0x9e, 0x24,
-  0x00, 0x03, 0x9e, 0x7c, 0x00, 0x03, 0x9e, 0xc4, 0x00, 0x03, 0x9f, 0x1c,
-  0x00, 0x03, 0x9f, 0xa8, 0x00, 0x03, 0xa0, 0x28, 0x00, 0x03, 0xa0, 0xb4,
-  0x00, 0x03, 0xa1, 0x84, 0x00, 0x03, 0xa2, 0x14, 0x00, 0x03, 0xa3, 0x38,
-  0x00, 0x03, 0xa4, 0x64, 0x00, 0x03, 0xa4, 0xf0, 0x00, 0x03, 0xa5, 0x50,
-  0x00, 0x03, 0xa5, 0xb0, 0x00, 0x03, 0xa5, 0xec, 0x00, 0x03, 0xa6, 0x20,
-  0x00, 0x03, 0xa6, 0x54, 0x00, 0x03, 0xa6, 0x78, 0x00, 0x03, 0xa6, 0x9c,
-  0x00, 0x03, 0xa6, 0xb4, 0x00, 0x03, 0xa6, 0xcc, 0x00, 0x03, 0xa7, 0x24,
-  0x00, 0x03, 0xa7, 0x78, 0x00, 0x03, 0xa8, 0x3c, 0x00, 0x03, 0xa8, 0xfc,
-  0x00, 0x03, 0xa9, 0xf8, 0x00, 0x03, 0xaa, 0x28, 0x00, 0x03, 0xaa, 0x58,
-  0x00, 0x03, 0xaa, 0x9c, 0x00, 0x03, 0xaa, 0xdc, 0x00, 0x03, 0xab, 0x1c,
-  0x00, 0x03, 0xab, 0x78, 0x00, 0x03, 0xab, 0xb4, 0x00, 0x03, 0xab, 0xf0,
-  0x00, 0x03, 0xac, 0x3c, 0x00, 0x03, 0xac, 0x88, 0x00, 0x03, 0xad, 0x0c,
-  0x00, 0x03, 0xad, 0x0c, 0x00, 0x03, 0xad, 0x20, 0x00, 0x03, 0xad, 0x34,
-  0x00, 0x03, 0xad, 0x50, 0x00, 0x03, 0xad, 0x64, 0x00, 0x03, 0xad, 0x80,
-  0x00, 0x03, 0xad, 0x9c, 0x00, 0x03, 0xad, 0xc0, 0x00, 0x03, 0xad, 0xd4,
-  0x00, 0x03, 0xad, 0xf0, 0x00, 0x03, 0xae, 0x0c, 0x00, 0x03, 0xae, 0x30,
-  0x00, 0x03, 0xae, 0x4c, 0x00, 0x03, 0xae, 0x70, 0x00, 0x03, 0xae, 0x94,
-  0x00, 0x03, 0xae, 0xc0, 0x00, 0x03, 0xae, 0xd4, 0x00, 0x03, 0xae, 0xf0,
-  0x00, 0x03, 0xaf, 0x0c, 0x00, 0x03, 0xaf, 0x30, 0x00, 0x03, 0xaf, 0x4c,
-  0x00, 0x03, 0xaf, 0x70, 0x00, 0x03, 0xaf, 0x94, 0x00, 0x03, 0xaf, 0xc0,
-  0x00, 0x03, 0xaf, 0xdc, 0x00, 0x03, 0xb0, 0x00, 0x00, 0x03, 0xb0, 0x24,
-  0x00, 0x03, 0xb0, 0x50, 0x00, 0x03, 0xb0, 0x74, 0x00, 0x03, 0xb0, 0xa0,
-  0x00, 0x03, 0xb0, 0xcc, 0x00, 0x03, 0xb1, 0x00, 0x00, 0x03, 0xb1, 0x14,
-  0x00, 0x03, 0xb1, 0x30, 0x00, 0x03, 0xb1, 0x4c, 0x00, 0x03, 0xb1, 0x70,
-  0x00, 0x03, 0xb1, 0x8c, 0x00, 0x03, 0xb1, 0xb0, 0x00, 0x03, 0xb1, 0xd4,
-  0x00, 0x03, 0xb2, 0x00, 0x00, 0x03, 0xb2, 0x1c, 0x00, 0x03, 0xb2, 0x40,
-  0x00, 0x03, 0xb2, 0x64, 0x00, 0x03, 0xb2, 0x90, 0x00, 0x03, 0xb2, 0xb4,
-  0x00, 0x03, 0xb2, 0xe0, 0x00, 0x03, 0xb3, 0x0c, 0x00, 0x03, 0xb3, 0x40,
-  0x00, 0x03, 0xb3, 0x5c, 0x00, 0x03, 0xb3, 0x80, 0x00, 0x03, 0xb3, 0xa4,
-  0x00, 0x03, 0xb3, 0xd0, 0x00, 0x03, 0xb3, 0xf4, 0x00, 0x03, 0xb4, 0x20,
-  0x00, 0x03, 0xb4, 0x4c, 0x00, 0x03, 0xb4, 0x80, 0x00, 0x03, 0xb4, 0xa4,
-  0x00, 0x03, 0xb4, 0xd0, 0x00, 0x03, 0xb4, 0xfc, 0x00, 0x03, 0xb5, 0x30,
-  0x00, 0x03, 0xb5, 0x5c, 0x00, 0x03, 0xb5, 0x90, 0x00, 0x03, 0xb5, 0xc4,
-  0x00, 0x03, 0xb6, 0x00, 0x00, 0x03, 0xb6, 0x14, 0x00, 0x03, 0xb6, 0x30,
-  0x00, 0x03, 0xb6, 0x4c, 0x00, 0x03, 0xb6, 0x70, 0x00, 0x03, 0xb6, 0x8c,
-  0x00, 0x03, 0xb6, 0xb0, 0x00, 0x03, 0xb6, 0xd4, 0x00, 0x03, 0xb7, 0x00,
-  0x00, 0x03, 0xb7, 0x1c, 0x00, 0x03, 0xb7, 0x40, 0x00, 0x03, 0xb7, 0x64,
-  0x00, 0x03, 0xb7, 0x90, 0x00, 0x03, 0xb7, 0xb4, 0x00, 0x03, 0xb7, 0xe0,
-  0x00, 0x03, 0xb8, 0x0c, 0x00, 0x03, 0xb8, 0x40, 0x00, 0x03, 0xb8, 0x5c,
-  0x00, 0x03, 0xb8, 0x80, 0x00, 0x03, 0xb8, 0xa4, 0x00, 0x03, 0xb8, 0xd0,
-  0x00, 0x03, 0xb8, 0xf4, 0x00, 0x03, 0xb9, 0x20, 0x00, 0x03, 0xb9, 0x4c,
-  0x00, 0x03, 0xb9, 0x80, 0x00, 0x03, 0xb9, 0xa4, 0x00, 0x03, 0xb9, 0xd0,
-  0x00, 0x03, 0xb9, 0xfc, 0x00, 0x03, 0xba, 0x30, 0x00, 0x03, 0xba, 0x5c,
-  0x00, 0x03, 0xba, 0x90, 0x00, 0x03, 0xba, 0xc4, 0x00, 0x03, 0xbb, 0x00,
-  0x00, 0x03, 0xbb, 0x1c, 0x00, 0x03, 0xbb, 0x40, 0x00, 0x03, 0xbb, 0x64,
-  0x00, 0x03, 0xbb, 0x90, 0x00, 0x03, 0xbb, 0xb4, 0x00, 0x03, 0xbb, 0xe0,
-  0x00, 0x03, 0xbc, 0x0c, 0x00, 0x03, 0xbc, 0x40, 0x00, 0x03, 0xbc, 0x64,
-  0x00, 0x03, 0xbc, 0x90, 0x00, 0x03, 0xbc, 0xbc, 0x00, 0x03, 0xbc, 0xf0,
-  0x00, 0x03, 0xbd, 0x1c, 0x00, 0x03, 0xbd, 0x50, 0x00, 0x03, 0xbd, 0x84,
-  0x00, 0x03, 0xbd, 0xc0, 0x00, 0x03, 0xbd, 0xe4, 0x00, 0x03, 0xbe, 0x10,
-  0x00, 0x03, 0xbe, 0x3c, 0x00, 0x03, 0xbe, 0x70, 0x00, 0x03, 0xbe, 0x9c,
-  0x00, 0x03, 0xbe, 0xd0, 0x00, 0x03, 0xbf, 0x04, 0x00, 0x03, 0xbf, 0x40,
-  0x00, 0x03, 0xbf, 0x6c, 0x00, 0x03, 0xbf, 0xa0, 0x00, 0x03, 0xbf, 0xd4,
-  0x00, 0x03, 0xc0, 0x10, 0x00, 0x03, 0xc0, 0x44, 0x00, 0x03, 0xc0, 0x80,
-  0x00, 0x03, 0xc0, 0xbc, 0x00, 0x03, 0xc1, 0x00, 0x00, 0x03, 0xc1, 0x14,
-  0x00, 0x03, 0xc1, 0x30, 0x00, 0x03, 0xc1, 0x4c, 0x00, 0x03, 0xc1, 0x70,
-  0x00, 0x03, 0xc1, 0x8c, 0x00, 0x03, 0xc1, 0xb0, 0x00, 0x03, 0xc1, 0xd4,
-  0x00, 0x03, 0xc2, 0x00, 0x00, 0x03, 0xc2, 0x1c, 0x00, 0x03, 0xc2, 0x40,
-  0x00, 0x03, 0xc2, 0x64, 0x00, 0x03, 0xc2, 0x90, 0x00, 0x03, 0xc2, 0xb4,
-  0x00, 0x03, 0xc2, 0xe0, 0x00, 0x03, 0xc3, 0x0c, 0x00, 0x03, 0xc3, 0x40,
-  0x00, 0x03, 0xc3, 0x5c, 0x00, 0x03, 0xc3, 0x80, 0x00, 0x03, 0xc3, 0xa4,
-  0x00, 0x03, 0xc3, 0xd0, 0x00, 0x03, 0xc3, 0xf4, 0x00, 0x03, 0xc4, 0x20,
-  0x00, 0x03, 0xc4, 0x4c, 0x00, 0x03, 0xc4, 0x80, 0x00, 0x03, 0xc4, 0xa4,
-  0x00, 0x03, 0xc4, 0xd0, 0x00, 0x03, 0xc4, 0xfc, 0x00, 0x03, 0xc5, 0x30,
-  0x00, 0x03, 0xc5, 0x5c, 0x00, 0x03, 0xc5, 0x90, 0x00, 0x03, 0xc5, 0xc4,
-  0x00, 0x03, 0xc6, 0x00, 0x00, 0x03, 0xc6, 0x1c, 0x00, 0x03, 0xc6, 0x40,
-  0x00, 0x03, 0xc6, 0x64, 0x00, 0x03, 0xc6, 0x90, 0x00, 0x03, 0xc6, 0xb4,
-  0x00, 0x03, 0xc6, 0xe0, 0x00, 0x03, 0xc7, 0x0c, 0x00, 0x03, 0xc7, 0x40,
-  0x00, 0x03, 0xc7, 0x64, 0x00, 0x03, 0xc7, 0x90, 0x00, 0x03, 0xc7, 0xbc,
-  0x00, 0x03, 0xc7, 0xf0, 0x00, 0x03, 0xc8, 0x1c, 0x00, 0x03, 0xc8, 0x50,
-  0x00, 0x03, 0xc8, 0x84, 0x00, 0x03, 0xc8, 0xc0, 0x00, 0x03, 0xc8, 0xe4,
-  0x00, 0x03, 0xc9, 0x10, 0x00, 0x03, 0xc9, 0x3c, 0x00, 0x03, 0xc9, 0x70,
-  0x00, 0x03, 0xc9, 0x9c, 0x00, 0x03, 0xc9, 0xd0, 0x00, 0x03, 0xca, 0x04,
-  0x00, 0x03, 0xca, 0x40, 0x00, 0x03, 0xca, 0x6c, 0x00, 0x03, 0xca, 0xa0,
-  0x00, 0x03, 0xca, 0xd4, 0x00, 0x03, 0xcb, 0x10, 0x00, 0x03, 0xcb, 0x44,
-  0x00, 0x03, 0xcb, 0x80, 0x00, 0x03, 0xcb, 0xbc, 0x00, 0x03, 0xcc, 0x00,
-  0x00, 0x03, 0xcc, 0x1c, 0x00, 0x03, 0xcc, 0x40, 0x00, 0x03, 0xcc, 0x64,
-  0x00, 0x03, 0xcc, 0x90, 0x00, 0x03, 0xcc, 0xb4, 0x00, 0x03, 0xcc, 0xe0,
-  0x00, 0x03, 0xcd, 0x0c, 0x00, 0x03, 0xcd, 0x40, 0x00, 0x03, 0xcd, 0x64,
-  0x00, 0x03, 0xcd, 0x90, 0x00, 0x03, 0xcd, 0xbc, 0x00, 0x03, 0xcd, 0xf0,
-  0x00, 0x03, 0xce, 0x1c, 0x00, 0x03, 0xce, 0x50, 0x00, 0x03, 0xce, 0x84,
-  0x00, 0x03, 0xce, 0xc0, 0x00, 0x03, 0xce, 0xe4, 0x00, 0x03, 0xcf, 0x10,
-  0x00, 0x03, 0xcf, 0x3c, 0x00, 0x03, 0xcf, 0x70, 0x00, 0x03, 0xcf, 0x9c,
-  0x00, 0x03, 0xcf, 0xd0, 0x00, 0x03, 0xd0, 0x04, 0x00, 0x03, 0xd0, 0x40,
-  0x00, 0x03, 0xd0, 0x6c, 0x00, 0x03, 0xd0, 0xa0, 0x00, 0x03, 0xd0, 0xd4,
-  0x00, 0x03, 0xd1, 0x10, 0x00, 0x03, 0xd1, 0x44, 0x00, 0x03, 0xd1, 0x80,
-  0x00, 0x03, 0xd1, 0xbc, 0x00, 0x03, 0xd2, 0x00, 0x00, 0x03, 0xd2, 0x24,
-  0x00, 0x03, 0xd2, 0x50, 0x00, 0x03, 0xd2, 0x7c, 0x00, 0x03, 0xd2, 0xb0,
-  0x00, 0x03, 0xd2, 0xdc, 0x00, 0x03, 0xd3, 0x10, 0x00, 0x03, 0xd3, 0x44,
-  0x00, 0x03, 0xd3, 0x80, 0x00, 0x03, 0xd3, 0xac, 0x00, 0x03, 0xd3, 0xe0,
-  0x00, 0x03, 0xd4, 0x14, 0x00, 0x03, 0xd4, 0x50, 0x00, 0x03, 0xd4, 0x84,
-  0x00, 0x03, 0xd4, 0xc0, 0x00, 0x03, 0xd4, 0xfc, 0x00, 0x03, 0xd5, 0x40,
-  0x00, 0x03, 0xd5, 0x6c, 0x00, 0x03, 0xd5, 0xa0, 0x00, 0x03, 0xd5, 0xd4,
-  0x00, 0x03, 0xd6, 0x10, 0x00, 0x03, 0xd6, 0x44, 0x00, 0x03, 0xd6, 0x80,
-  0x00, 0x03, 0xd6, 0xbc, 0x00, 0x03, 0xd7, 0x00, 0x00, 0x03, 0xd7, 0x34,
-  0x00, 0x03, 0xd7, 0x70, 0x00, 0x03, 0xd7, 0xac, 0x00, 0x03, 0xd7, 0xf0,
-  0x00, 0x03, 0xd8, 0x2c, 0x00, 0x03, 0xd8, 0x70, 0x00, 0x03, 0xd8, 0xb4,
-  0x00, 0x03, 0xd9, 0x00, 0x00, 0x03, 0xd9, 0x4c, 0x00, 0x03, 0xd9, 0x98,
-  0x00, 0x03, 0xd9, 0xe0, 0x00, 0x03, 0xda, 0x24, 0x00, 0x03, 0xda, 0xf0,
-  0x00, 0x03, 0xdb, 0xb8, 0x00, 0x03, 0xdc, 0x40, 0x00, 0x03, 0xdc, 0xc8,
-  0x00, 0x03, 0xdd, 0x14, 0x00, 0x03, 0xdd, 0x50, 0x00, 0x03, 0xdd, 0x8c,
-  0x00, 0x03, 0xdd, 0xc0, 0x00, 0x03, 0xdd, 0xf4, 0x00, 0x03, 0xde, 0x1c,
-  0x00, 0x03, 0xde, 0x50, 0x00, 0x03, 0xde, 0x84, 0x00, 0x03, 0xde, 0xa4,
-  0x00, 0x03, 0xde, 0xec, 0x00, 0x03, 0xdf, 0x44, 0x00, 0x03, 0xe0, 0x04,
-  0x00, 0x03, 0xe0, 0xd8, 0x00, 0x03, 0xe1, 0xbc, 0x00, 0x03, 0xe1, 0xe4,
-  0x00, 0x03, 0xe2, 0x44, 0x00, 0x03, 0xe2, 0xbc, 0x00, 0x03, 0xe3, 0x28,
-  0x00, 0x03, 0xe3, 0xd4, 0x00, 0x03, 0xe4, 0x74, 0x00, 0x03, 0xe4, 0xe8,
-  0x00, 0x03, 0xe5, 0x78, 0x00, 0x03, 0xe6, 0x0c, 0x00, 0x03, 0xe6, 0xb0,
-  0x00, 0x03, 0xe7, 0x30, 0x00, 0x03, 0xe7, 0xc8, 0x00, 0x03, 0xe8, 0x44,
-  0x00, 0x03, 0xe8, 0xcc, 0x00, 0x03, 0xe9, 0x50, 0x00, 0x03, 0xe9, 0xb0,
-  0x00, 0x03, 0xea, 0x10, 0x00, 0x03, 0xea, 0x20, 0x00, 0x03, 0xea, 0x38,
-  0x00, 0x03, 0xea, 0x58, 0x00, 0x03, 0xea, 0x94, 0x00, 0x03, 0xea, 0xcc,
-  0x00, 0x03, 0xea, 0xe4, 0x00, 0x03, 0xea, 0xfc, 0x00, 0x03, 0xeb, 0x14,
-  0x00, 0x03, 0xeb, 0x2c, 0x00, 0x03, 0xeb, 0x44, 0x00, 0x03, 0xeb, 0x5c,
-  0x00, 0x03, 0xec, 0x2c, 0x00, 0x03, 0xec, 0xf8, 0x00, 0x03, 0xed, 0x48,
-  0x00, 0x03, 0xed, 0x98, 0x00, 0x03, 0xee, 0x5c, 0x00, 0x03, 0xef, 0x18,
-  0x00, 0x03, 0xef, 0x7c, 0x00, 0x03, 0xef, 0xd8, 0x00, 0x03, 0xf0, 0x5c,
-  0x00, 0x03, 0xf0, 0xdc, 0x00, 0x03, 0xf1, 0x6c, 0x00, 0x03, 0xf1, 0xfc,
-  0x00, 0x03, 0xf2, 0x58, 0x00, 0x03, 0xf2, 0xbc, 0x00, 0x03, 0xf3, 0x24,
-  0x00, 0x03, 0xf3, 0x88, 0x00, 0x03, 0xf3, 0xc4, 0x00, 0x03, 0xf4, 0x00,
-  0x00, 0x03, 0xf4, 0x18, 0x00, 0x03, 0xf4, 0x30, 0x00, 0x03, 0xf4, 0x74,
-  0x00, 0x03, 0xf4, 0xbc, 0x00, 0x03, 0xf5, 0x04, 0x00, 0x03, 0xf5, 0x54,
-  0x00, 0x03, 0xf5, 0xcc, 0x00, 0x03, 0xf6, 0x48, 0x00, 0x03, 0xf6, 0xdc,
-  0x00, 0x03, 0xf7, 0x74, 0x00, 0x03, 0xf7, 0xf4, 0x00, 0x03, 0xf8, 0x3c,
-  0x00, 0x03, 0xf8, 0x80, 0x00, 0x03, 0xf8, 0xe4, 0x00, 0x03, 0xf9, 0x44,
-  0x00, 0x03, 0xf9, 0x98, 0x00, 0x03, 0xf9, 0xec, 0x00, 0x03, 0xfa, 0x64,
-  0x00, 0x03, 0xfa, 0xd8, 0x00, 0x03, 0xfb, 0xb8, 0x00, 0x03, 0xfc, 0x98,
-  0x00, 0x03, 0xfd, 0x68, 0x00, 0x03, 0xfe, 0x38, 0x00, 0x03, 0xfe, 0x84,
-  0x00, 0x03, 0xfe, 0xcc, 0x00, 0x03, 0xff, 0x14, 0x00, 0x03, 0xff, 0x5c,
-  0x00, 0x03, 0xff, 0xa4, 0x00, 0x03, 0xff, 0xec, 0x00, 0x04, 0x00, 0x44,
-  0x00, 0x04, 0x00, 0x6c, 0x00, 0x04, 0x00, 0x94, 0x00, 0x04, 0x00, 0xbc,
-  0x00, 0x04, 0x00, 0xe8, 0x00, 0x04, 0x01, 0x14, 0x00, 0x04, 0x01, 0x40,
-  0x00, 0x04, 0x01, 0x6c, 0x00, 0x04, 0x01, 0xa4, 0x00, 0x04, 0x01, 0xd8,
-  0x00, 0x04, 0x02, 0x0c, 0x00, 0x04, 0x02, 0x44, 0x00, 0x04, 0x02, 0x7c,
-  0x00, 0x04, 0x02, 0xb0, 0x00, 0x04, 0x02, 0xdc, 0x00, 0x04, 0x03, 0x08,
-  0x00, 0x04, 0x03, 0x34, 0x00, 0x04, 0x03, 0x5c, 0x00, 0x04, 0x03, 0x8c,
-  0x00, 0x04, 0x03, 0xbc, 0x00, 0x04, 0x03, 0xec, 0x00, 0x04, 0x04, 0x1c,
-  0x00, 0x04, 0x04, 0xc8, 0x00, 0x04, 0x04, 0xec, 0x00, 0x04, 0x05, 0x24,
-  0x00, 0x04, 0x05, 0x68, 0x00, 0x04, 0x05, 0x90, 0x00, 0x04, 0x05, 0xbc,
-  0x00, 0x04, 0x05, 0xf4, 0x00, 0x04, 0x06, 0x18, 0x00, 0x04, 0x06, 0x54,
-  0x00, 0x04, 0x06, 0x9c, 0x00, 0x04, 0x06, 0xdc, 0x00, 0x04, 0x07, 0x4c,
-  0x00, 0x04, 0x07, 0xa8, 0x00, 0x04, 0x08, 0x1c, 0x00, 0x04, 0x08, 0xcc,
-  0x00, 0x04, 0x09, 0x28, 0x00, 0x04, 0x09, 0x38, 0x00, 0x04, 0x09, 0x88,
-  0x00, 0x04, 0x09, 0xc4, 0x00, 0x04, 0x0a, 0x04, 0x00, 0x04, 0x0a, 0x38,
-  0x00, 0x04, 0x0a, 0x6c, 0x00, 0x04, 0x0a, 0xd4, 0x00, 0x04, 0x0b, 0x24,
-  0x00, 0x04, 0x0b, 0x5c, 0x00, 0x04, 0x0b, 0xb8, 0x00, 0x04, 0x0c, 0x04,
-  0x00, 0x04, 0x0c, 0x70, 0x00, 0x04, 0x0c, 0xd0, 0x00, 0x04, 0x0d, 0x30,
-  0x00, 0x04, 0x0d, 0x58, 0x00, 0x04, 0x0d, 0x80, 0x00, 0x04, 0x0e, 0x00,
-  0x00, 0x04, 0x0e, 0x4c, 0x00, 0x04, 0x0e, 0xc4, 0x00, 0x04, 0x0e, 0xf8,
-  0x00, 0x04, 0x0f, 0x0c, 0x00, 0x04, 0x0f, 0x38, 0x00, 0x04, 0x0f, 0xe4,
-  0x00, 0x04, 0x10, 0x3c, 0x00, 0x04, 0x10, 0x64, 0x00, 0x04, 0x10, 0x8c,
-  0x00, 0x04, 0x10, 0xb4, 0x00, 0x04, 0x10, 0xdc, 0x00, 0x04, 0x11, 0x04,
-  0x00, 0x04, 0x11, 0x2c, 0x00, 0x04, 0x11, 0x54, 0x00, 0x04, 0x11, 0x7c,
-  0x00, 0x04, 0x11, 0xa4, 0x00, 0x04, 0x11, 0xc8, 0x00, 0x04, 0x11, 0xe8,
-  0x00, 0x04, 0x12, 0x0c, 0x00, 0x04, 0x12, 0x30, 0x00, 0x04, 0x12, 0x54,
-  0x00, 0x04, 0x12, 0x74, 0x00, 0x04, 0x12, 0xa0, 0x00, 0x04, 0x12, 0xcc,
-  0x00, 0x04, 0x12, 0xf8, 0x00, 0x04, 0x13, 0x24, 0x00, 0x04, 0x13, 0x38,
-  0x00, 0x04, 0x13, 0x7c, 0x00, 0x04, 0x13, 0xc0, 0x00, 0x04, 0x13, 0xf0,
-  0x00, 0x04, 0x14, 0x20, 0x00, 0x04, 0x14, 0x64, 0x00, 0x04, 0x14, 0xbc,
-  0x00, 0x04, 0x15, 0x40, 0x00, 0x04, 0x15, 0xd0, 0x00, 0x04, 0x15, 0xe0,
-  0x00, 0x04, 0x16, 0x70, 0x00, 0x04, 0x16, 0x9c, 0x00, 0x04, 0x16, 0xac,
-  0x00, 0x04, 0x17, 0x0c, 0x00, 0x04, 0x17, 0xe4, 0x00, 0x04, 0x18, 0x68,
-  0x00, 0x04, 0x19, 0x14, 0x00, 0x04, 0x19, 0x70, 0x00, 0x04, 0x1a, 0x04,
-  0x00, 0x04, 0x1a, 0x4c, 0x00, 0x04, 0x1a, 0xc8, 0x00, 0x04, 0x1b, 0x24,
-  0x00, 0x04, 0x1b, 0xb4, 0x00, 0x04, 0x1c, 0x14, 0x00, 0x04, 0x1c, 0xa8,
-  0x00, 0x04, 0x1c, 0xb8, 0x00, 0x04, 0x1c, 0xc8, 0x00, 0x04, 0x1d, 0x10,
-  0x00, 0x04, 0x1d, 0x58, 0x00, 0x04, 0x1d, 0x84, 0x00, 0x04, 0x1d, 0xac,
-  0x00, 0x04, 0x1d, 0xdc, 0x00, 0x04, 0x1e, 0x08, 0x00, 0x04, 0x1e, 0x90,
-  0x00, 0x04, 0x1f, 0x14, 0x00, 0x04, 0x1f, 0xc8, 0x00, 0x04, 0x20, 0x68,
-  0x00, 0x04, 0x20, 0xc4, 0x00, 0x04, 0x21, 0x2c, 0x00, 0x04, 0x21, 0xa0,
-  0x00, 0x04, 0x22, 0x38, 0x00, 0x04, 0x22, 0xc0, 0x00, 0x04, 0x23, 0x28,
-  0x00, 0x04, 0x23, 0x80, 0x00, 0x04, 0x23, 0xe8, 0x00, 0x04, 0x24, 0x40,
-  0x00, 0x04, 0x24, 0xac, 0x00, 0x04, 0x24, 0xcc, 0x00, 0x04, 0x24, 0xec,
-  0x00, 0x04, 0x25, 0x34, 0x00, 0x04, 0x25, 0x78, 0x00, 0x04, 0x25, 0x88,
-  0x00, 0x04, 0x25, 0xb0, 0x00, 0x04, 0x25, 0xd4, 0x00, 0x04, 0x25, 0xf0,
-  0x00, 0x04, 0x26, 0x00, 0x00, 0x04, 0x26, 0x60, 0x00, 0x04, 0x26, 0x98,
-  0x00, 0x04, 0x26, 0xe4, 0x00, 0x04, 0x27, 0x6c, 0x00, 0x04, 0x28, 0x20,
-  0x00, 0x04, 0x28, 0x7c, 0x00, 0x04, 0x28, 0xd8, 0x00, 0x04, 0x29, 0x40,
-  0x00, 0x04, 0x29, 0xb0, 0x00, 0x04, 0x2a, 0x44, 0x00, 0x04, 0x2a, 0x9c,
-  0x00, 0x04, 0x2b, 0x30, 0x00, 0x04, 0x2b, 0xc4, 0x00, 0x04, 0x2c, 0x0c,
-  0x00, 0x04, 0x2c, 0x1c, 0x00, 0x04, 0x2c, 0x48, 0x00, 0x04, 0x2c, 0x8c,
-  0x00, 0x04, 0x2c, 0xc8, 0x00, 0x04, 0x2c, 0xe4, 0x00, 0x04, 0x2d, 0x30,
-  0x00, 0x04, 0x2d, 0x4c, 0x00, 0x04, 0x2d, 0x6c, 0x00, 0x04, 0x2d, 0x90,
-  0x00, 0x04, 0x2d, 0xb4, 0x00, 0x04, 0x2d, 0xd8, 0x00, 0x04, 0x2d, 0xf8,
-  0x00, 0x04, 0x2e, 0x0c, 0x00, 0x04, 0x2e, 0x20, 0x00, 0x04, 0x2e, 0x34,
-  0x00, 0x04, 0x2e, 0x48, 0x00, 0x04, 0x2e, 0x6c, 0x00, 0x04, 0x2e, 0x80,
-  0x00, 0x04, 0x2e, 0x94, 0x00, 0x04, 0x2e, 0xa8, 0x00, 0x04, 0x2e, 0xbc,
-  0x00, 0x04, 0x2e, 0xe0, 0x00, 0x04, 0x2e, 0xf4, 0x00, 0x04, 0x2f, 0x08,
-  0x00, 0x04, 0x2f, 0x1c, 0x00, 0x04, 0x2f, 0x30, 0x00, 0x04, 0x2f, 0x54,
-  0x00, 0x04, 0x2f, 0x68, 0x00, 0x04, 0x2f, 0x7c, 0x00, 0x04, 0x2f, 0x90,
-  0x00, 0x04, 0x2f, 0xa4, 0x00, 0x04, 0x2f, 0xbc, 0x00, 0x04, 0x30, 0x8c,
-  0x00, 0x04, 0x31, 0x5c, 0x00, 0x04, 0x32, 0x2c, 0x00, 0x04, 0x32, 0xfc,
-  0x00, 0x04, 0x33, 0x50, 0x00, 0x04, 0x33, 0xb8, 0x00, 0x04, 0x34, 0x2c,
-  0x00, 0x04, 0x34, 0xc8, 0x00, 0x04, 0x35, 0x20, 0x00, 0x04, 0x35, 0x90,
-  0x00, 0x04, 0x36, 0x14, 0x00, 0x04, 0x36, 0x90, 0x00, 0x04, 0x36, 0xe4,
-  0x00, 0x04, 0x37, 0x48, 0x00, 0x04, 0x37, 0xf4, 0x00, 0x04, 0x38, 0x60,
-  0x00, 0x04, 0x38, 0xc0, 0x00, 0x04, 0x39, 0x34, 0x00, 0x04, 0x39, 0x98,
-  0x00, 0x04, 0x39, 0xf0, 0x00, 0x04, 0x3a, 0x74, 0x00, 0x04, 0x3a, 0xc4,
-  0x00, 0x04, 0x3b, 0x44, 0x00, 0x04, 0x3b, 0xac, 0x00, 0x04, 0x3c, 0x54,
-  0x00, 0x04, 0x3c, 0xb4, 0x00, 0x04, 0x3d, 0x44, 0x00, 0x04, 0x3d, 0xac,
-  0x00, 0x04, 0x3e, 0x20, 0x00, 0x04, 0x3e, 0x88, 0x00, 0x04, 0x3f, 0x04,
-  0x00, 0x04, 0x3f, 0x58, 0x00, 0x04, 0x3f, 0xcc, 0x00, 0x04, 0x40, 0x44,
-  0x00, 0x04, 0x40, 0x98, 0x00, 0x04, 0x41, 0x0c, 0x00, 0x04, 0x41, 0x7c,
-  0x00, 0x04, 0x41, 0xf4, 0x00, 0x04, 0x42, 0x68, 0x00, 0x04, 0x42, 0xcc,
-  0x00, 0x04, 0x43, 0x38, 0x00, 0x04, 0x43, 0xbc, 0x00, 0x04, 0x44, 0x4c,
-  0x00, 0x04, 0x44, 0xd8, 0x00, 0x04, 0x45, 0xa4, 0x00, 0x04, 0x45, 0xf8,
-  0x00, 0x04, 0x46, 0x58, 0x00, 0x04, 0x46, 0xc8, 0x00, 0x04, 0x47, 0x1c,
-  0x00, 0x04, 0x47, 0x80, 0x00, 0x04, 0x47, 0xe4, 0x00, 0x04, 0x48, 0x44,
-  0x00, 0x04, 0x48, 0xa4, 0x00, 0x04, 0x49, 0x14, 0x00, 0x04, 0x49, 0x84,
-  0x00, 0x04, 0x49, 0xdc, 0x00, 0x04, 0x4a, 0x34, 0x00, 0x04, 0x4a, 0x98,
-  0x00, 0x04, 0x4b, 0x0c, 0x00, 0x04, 0x4b, 0x8c, 0x00, 0x04, 0x4c, 0x1c,
-  0x00, 0x04, 0x4c, 0x90, 0x00, 0x04, 0x4d, 0x14, 0x00, 0x04, 0x4d, 0x8c,
-  0x00, 0x04, 0x4e, 0x10, 0x00, 0x04, 0x4e, 0xa0, 0x00, 0x04, 0x4f, 0x18,
-  0x00, 0x04, 0x4f, 0xa0, 0x00, 0x04, 0x50, 0x24, 0x00, 0x04, 0x50, 0x94,
-  0x00, 0x04, 0x50, 0xfc, 0x00, 0x04, 0x51, 0x50, 0x00, 0x04, 0x51, 0x98,
-  0x00, 0x04, 0x52, 0x1c, 0x00, 0x04, 0x52, 0x8c, 0x00, 0x04, 0x53, 0x0c,
-  0x00, 0x04, 0x54, 0x04, 0x00, 0x04, 0x54, 0x2c, 0x00, 0x04, 0x54, 0x54,
-  0x00, 0x04, 0x54, 0x9c, 0x00, 0x04, 0x54, 0xe4, 0x00, 0x04, 0x54, 0xe4,
-  0x00, 0x04, 0x54, 0xe4, 0x00, 0x04, 0x54, 0xe4, 0x00, 0x04, 0x54, 0xe4,
-  0x00, 0x04, 0x55, 0x70, 0x00, 0x04, 0x55, 0xa8, 0x00, 0x04, 0x56, 0x20,
-  0x00, 0x04, 0x56, 0x4c, 0x00, 0x04, 0x56, 0x9c, 0x00, 0x04, 0x56, 0xdc,
-  0x00, 0x04, 0x57, 0x0c, 0x00, 0x04, 0x57, 0x38, 0x00, 0x04, 0x57, 0x74,
-  0x00, 0x04, 0x58, 0x0c, 0x00, 0x04, 0x58, 0x28, 0x00, 0x04, 0x58, 0x60,
-  0x00, 0x04, 0x58, 0x88, 0x00, 0x04, 0x58, 0xc8, 0x00, 0x04, 0x58, 0xf8,
-  0x00, 0x04, 0x59, 0x54, 0x00, 0x04, 0x59, 0xe4, 0x00, 0x04, 0x5a, 0x2c,
-  0x00, 0x04, 0x5a, 0x64, 0x00, 0x04, 0x5a, 0xcc, 0x00, 0x04, 0x5b, 0x20,
-  0x00, 0x04, 0x5b, 0x58, 0x00, 0x04, 0x5b, 0x84, 0x00, 0x04, 0x5b, 0xac,
-  0x00, 0x04, 0x5b, 0xf0, 0x00, 0x04, 0x5c, 0x6c, 0x00, 0x04, 0x5c, 0xa4,
-  0x00, 0x04, 0x5d, 0x24, 0x00, 0x04, 0x5d, 0x68, 0x00, 0x04, 0x5d, 0xb0,
-  0x00, 0x04, 0x5d, 0xd4, 0x00, 0x04, 0x5e, 0x1c, 0x00, 0x04, 0x5e, 0x2c,
-  0x00, 0x04, 0x5e, 0x58, 0x00, 0x04, 0x5e, 0x68, 0x00, 0x04, 0x5e, 0x9c,
-  0x00, 0x04, 0x5e, 0xd4, 0x00, 0x04, 0x5e, 0xf0, 0x00, 0x04, 0x5f, 0x0c,
-  0x00, 0x04, 0x5f, 0x28, 0x00, 0x04, 0x5f, 0x44, 0x00, 0x04, 0x5f, 0x60,
-  0x00, 0x04, 0x5f, 0x88, 0x00, 0x04, 0x5f, 0xb0, 0x00, 0x04, 0x5f, 0xdc,
-  0x00, 0x04, 0x60, 0x04, 0x00, 0x04, 0x60, 0x2c, 0x00, 0x04, 0x60, 0x58,
-  0x00, 0x04, 0x60, 0x80, 0x00, 0x04, 0x60, 0xa8, 0x00, 0x04, 0x60, 0xd0,
-  0x00, 0x04, 0x60, 0xf8, 0x00, 0x04, 0x61, 0x20, 0x00, 0x04, 0x61, 0x4c,
-  0x00, 0x04, 0x61, 0x74, 0x00, 0x04, 0x61, 0x9c, 0x00, 0x04, 0x61, 0xc8,
-  0x00, 0x04, 0x61, 0xf0, 0x00, 0x04, 0x62, 0x18, 0x00, 0x04, 0x62, 0x40,
-  0x00, 0x04, 0x62, 0x68, 0x00, 0x04, 0x62, 0x90, 0x00, 0x04, 0x62, 0xbc,
-  0x00, 0x04, 0x62, 0xe4, 0x00, 0x04, 0x63, 0x0c, 0x00, 0x04, 0x63, 0x38,
-  0x00, 0x04, 0x63, 0x60, 0x00, 0x04, 0x63, 0x88, 0x00, 0x04, 0x63, 0xb0,
-  0x00, 0x04, 0x63, 0xd8, 0x00, 0x04, 0x64, 0x00, 0x00, 0x04, 0x64, 0x2c,
-  0x00, 0x04, 0x64, 0x54, 0x00, 0x04, 0x64, 0x7c, 0x00, 0x04, 0x64, 0xa8,
-  0x00, 0x04, 0x64, 0xd0, 0x00, 0x04, 0x64, 0xf8, 0x00, 0x04, 0x65, 0x20,
-  0x00, 0x04, 0x65, 0x48, 0x00, 0x04, 0x65, 0x70, 0x00, 0x04, 0x65, 0x9c,
-  0x00, 0x04, 0x65, 0xc4, 0x00, 0x04, 0x65, 0xec, 0x00, 0x04, 0x66, 0x18,
-  0x00, 0x04, 0x66, 0x40, 0x00, 0x04, 0x66, 0x68, 0x00, 0x04, 0x66, 0x90,
-  0x00, 0x04, 0x66, 0xb8, 0x00, 0x04, 0x66, 0xe0, 0x00, 0x04, 0x67, 0x0c,
-  0x00, 0x04, 0x67, 0x34, 0x00, 0x04, 0x67, 0x5c, 0x00, 0x04, 0x67, 0x88,
-  0x00, 0x04, 0x67, 0xb0, 0x00, 0x04, 0x67, 0xd8, 0x00, 0x04, 0x68, 0x00,
-  0x00, 0x04, 0x68, 0x28, 0x00, 0x04, 0x68, 0x50, 0x00, 0x04, 0x68, 0x7c,
-  0x00, 0x04, 0x68, 0xa4, 0x00, 0x04, 0x68, 0xcc, 0x00, 0x04, 0x68, 0xf8,
-  0x00, 0x04, 0x69, 0x20, 0x00, 0x04, 0x69, 0x48, 0x00, 0x04, 0x69, 0x70,
-  0x00, 0x04, 0x69, 0x98, 0x00, 0x04, 0x69, 0xc0, 0x00, 0x04, 0x69, 0xec,
-  0x00, 0x04, 0x6a, 0x14, 0x00, 0x04, 0x6a, 0x3c, 0x00, 0x04, 0x6a, 0x68,
-  0x00, 0x04, 0x6a, 0x90, 0x00, 0x04, 0x6a, 0xb8, 0x00, 0x04, 0x6a, 0xe0,
-  0x00, 0x04, 0x6b, 0x08, 0x00, 0x04, 0x6b, 0x30, 0x00, 0x04, 0x6b, 0x5c,
-  0x00, 0x04, 0x6b, 0x84, 0x00, 0x04, 0x6b, 0xac, 0x00, 0x04, 0x6b, 0xd8,
-  0x00, 0x04, 0x6c, 0x00, 0x00, 0x04, 0x6c, 0x28, 0x00, 0x04, 0x6c, 0x50,
-  0x00, 0x04, 0x6c, 0x9c, 0x00, 0x04, 0x6d, 0x2c, 0x00, 0x04, 0x6d, 0x98,
-  0x00, 0x04, 0x6d, 0xd8, 0x00, 0x04, 0x6e, 0x14, 0x00, 0x04, 0x6e, 0x9c,
-  0x00, 0x04, 0x6e, 0xd8, 0x00, 0x04, 0x6f, 0x24, 0x00, 0x04, 0x6f, 0x68,
-  0x00, 0x04, 0x6f, 0x98, 0x00, 0x04, 0x6f, 0xf4, 0x00, 0x04, 0x70, 0x8c,
-  0x00, 0x04, 0x71, 0x28, 0x00, 0x04, 0x71, 0x60, 0x00, 0x04, 0x71, 0xd4,
-  0x00, 0x04, 0x72, 0x10, 0x00, 0x04, 0x72, 0x78, 0x00, 0x04, 0x72, 0xcc,
-  0x00, 0x04, 0x73, 0x14, 0x00, 0x04, 0x73, 0xb8, 0x00, 0x04, 0x74, 0x54,
-  0x00, 0x04, 0x74, 0xcc, 0x00, 0x04, 0x75, 0x68, 0x00, 0x04, 0x75, 0xdc,
-  0x00, 0x04, 0x76, 0x44, 0x00, 0x04, 0x77, 0x0c, 0x00, 0x04, 0x77, 0x80,
-  0x00, 0x04, 0x77, 0xb8, 0x00, 0x04, 0x78, 0x14, 0x00, 0x04, 0x78, 0x58,
-  0x00, 0x04, 0x78, 0xa4, 0x00, 0x04, 0x79, 0x60, 0x00, 0x04, 0x79, 0xd4,
-  0x00, 0x04, 0x7a, 0x5c, 0x00, 0x04, 0x7a, 0xf8, 0x00, 0x04, 0x7b, 0x94,
-  0x00, 0x04, 0x7b, 0xe0, 0x00, 0x04, 0x7c, 0xac, 0x00, 0x04, 0x7d, 0x08,
-  0x00, 0x04, 0x7d, 0x7c, 0x00, 0x04, 0x7d, 0xb8, 0x00, 0x04, 0x7e, 0x14,
-  0x00, 0x04, 0x7e, 0x68, 0x00, 0x04, 0x7e, 0xb8, 0x00, 0x04, 0x7e, 0xfc,
-  0x00, 0x04, 0x7f, 0x0c, 0x00, 0x04, 0x7f, 0x1c, 0x00, 0x04, 0x7f, 0x2c,
-  0x00, 0x04, 0x7f, 0x3c, 0x00, 0x04, 0x7f, 0x4c, 0x00, 0x04, 0x7f, 0x5c,
-  0x00, 0x04, 0x7f, 0x6c, 0x00, 0x04, 0x7f, 0x7c, 0x00, 0x04, 0x7f, 0x8c,
-  0x00, 0x04, 0x7f, 0x9c, 0x00, 0x04, 0x7f, 0xac, 0x00, 0x04, 0x7f, 0xbc,
-  0x00, 0x04, 0x7f, 0xcc, 0x00, 0x04, 0x7f, 0xdc, 0x00, 0x04, 0x7f, 0xec,
-  0x00, 0x04, 0x7f, 0xfc, 0x00, 0x04, 0x80, 0x0c, 0x00, 0x04, 0x80, 0x1c,
-  0x00, 0x04, 0x80, 0x2c, 0x00, 0x04, 0x80, 0x3c, 0x00, 0x04, 0x80, 0x4c,
-  0x00, 0x04, 0x80, 0x5c, 0x00, 0x04, 0x80, 0x6c, 0x00, 0x04, 0x80, 0x7c,
-  0x00, 0x04, 0x80, 0x8c, 0x00, 0x04, 0x80, 0x9c, 0x00, 0x04, 0x80, 0xac,
-  0x00, 0x04, 0x80, 0xbc, 0x00, 0x04, 0x80, 0xcc, 0x00, 0x04, 0x80, 0xdc,
-  0x00, 0x04, 0x80, 0xec, 0x00, 0x04, 0x80, 0xfc, 0x00, 0x04, 0x81, 0x0c,
-  0x00, 0x04, 0x81, 0x1c, 0x00, 0x04, 0x81, 0x2c, 0x00, 0x04, 0x81, 0x3c,
-  0x00, 0x04, 0x81, 0x4c, 0x00, 0x04, 0x81, 0x5c, 0x00, 0x04, 0x81, 0x6c,
-  0x00, 0x04, 0x81, 0x7c, 0x00, 0x04, 0x81, 0x8c, 0x00, 0x04, 0x81, 0x9c,
-  0x00, 0x04, 0x81, 0xac, 0x00, 0x04, 0x81, 0xbc, 0x00, 0x04, 0x81, 0xcc,
-  0x00, 0x04, 0x81, 0xdc, 0x00, 0x04, 0x81, 0xec, 0x00, 0x04, 0x81, 0xfc,
-  0x00, 0x04, 0x82, 0x0c, 0x00, 0x04, 0x82, 0x1c, 0x00, 0x04, 0x82, 0x2c,
-  0x00, 0x04, 0x82, 0x3c, 0x00, 0x04, 0x82, 0xa8, 0x00, 0x04, 0x82, 0xe8,
-  0x00, 0x04, 0x83, 0x74, 0x00, 0x04, 0x84, 0x04, 0x00, 0x04, 0x84, 0x50,
-  0x00, 0x04, 0x84, 0xc0, 0x00, 0x04, 0x85, 0x48, 0x00, 0x04, 0x85, 0x84,
-  0x00, 0x04, 0x86, 0x5c, 0x00, 0x04, 0x86, 0xe8, 0x00, 0x04, 0x86, 0xf8,
-  0x00, 0x04, 0x87, 0x08, 0x00, 0x04, 0x87, 0x18, 0x00, 0x04, 0x87, 0x28,
-  0x00, 0x04, 0x87, 0x38, 0x00, 0x04, 0x87, 0x48, 0x00, 0x04, 0x87, 0x58,
-  0x00, 0x04, 0x87, 0x68, 0x00, 0x04, 0x87, 0x78, 0x00, 0x04, 0x87, 0x88,
-  0x00, 0x04, 0x87, 0xb4, 0x00, 0x04, 0x87, 0xec, 0x00, 0x04, 0x88, 0x68,
-  0x00, 0x04, 0x89, 0x24, 0x00, 0x04, 0x8a, 0x20, 0x00, 0x04, 0x8b, 0x5c,
-  0x00, 0x04, 0x8c, 0xd8, 0x00, 0x04, 0x8e, 0x8c, 0x00, 0x04, 0x8f, 0x08,
-  0x00, 0x04, 0x8f, 0xc4, 0x00, 0x04, 0x90, 0xc4, 0x00, 0x04, 0x92, 0x00,
-  0x00, 0x04, 0x93, 0x7c, 0x00, 0x04, 0x95, 0x38, 0x00, 0x04, 0x97, 0x2c,
-  0x00, 0x04, 0x97, 0xe8, 0x00, 0x04, 0x98, 0xe4, 0x00, 0x04, 0x9a, 0x20,
-  0x00, 0x04, 0x9b, 0x9c, 0x00, 0x04, 0x9d, 0x4c, 0x00, 0x04, 0x9f, 0x48,
-  0x00, 0x04, 0xa1, 0x7c, 0x00, 0x04, 0xa2, 0x78, 0x00, 0x04, 0xa3, 0xb4,
-  0x00, 0x04, 0xa5, 0x34, 0x00, 0x04, 0xa6, 0xf0, 0x00, 0x04, 0xa8, 0xec,
-  0x00, 0x04, 0xab, 0x28, 0x00, 0x04, 0xad, 0x9c, 0x00, 0x04, 0xae, 0xd0,
-  0x00, 0x04, 0xb0, 0x44, 0x00, 0x04, 0xb2, 0x04, 0x00, 0x04, 0xb4, 0x00,
-  0x00, 0x04, 0xb6, 0x3c, 0x00, 0x04, 0xb8, 0xb8, 0x00, 0x04, 0xbb, 0x6c,
-  0x00, 0x04, 0xbc, 0xe4, 0x00, 0x04, 0xbe, 0xa0, 0x00, 0x04, 0xc0, 0x9c,
-  0x00, 0x04, 0xc2, 0xd8, 0x00, 0x04, 0xc5, 0x54, 0x00, 0x04, 0xc8, 0x10,
-  0x00, 0x04, 0xcb, 0x04, 0x00, 0x04, 0xcc, 0xc4, 0x00, 0x04, 0xce, 0xcc,
-  0x00, 0x04, 0xd1, 0x14, 0x00, 0x04, 0xd3, 0x9c, 0x00, 0x04, 0xd6, 0x60,
-  0x00, 0x04, 0xd9, 0x64, 0x00, 0x04, 0xdc, 0x94, 0x00, 0x04, 0xdc, 0xc0,
-  0x00, 0x04, 0xdc, 0xf8, 0x00, 0x04, 0xdd, 0x74, 0x00, 0x04, 0xde, 0x30,
-  0x00, 0x04, 0xdf, 0x28, 0x00, 0x04, 0xe0, 0x64, 0x00, 0x04, 0xe1, 0xe0,
-  0x00, 0x04, 0xe3, 0x94, 0x00, 0x04, 0xe4, 0x10, 0x00, 0x04, 0xe4, 0xcc,
-  0x00, 0x04, 0xe5, 0xcc, 0x00, 0x04, 0xe7, 0x08, 0x00, 0x04, 0xe8, 0x84,
-  0x00, 0x04, 0xea, 0x40, 0x00, 0x04, 0xec, 0x34, 0x00, 0x04, 0xec, 0xf0,
-  0x00, 0x04, 0xed, 0xec, 0x00, 0x04, 0xef, 0x28, 0x00, 0x04, 0xf0, 0xa0,
-  0x00, 0x04, 0xf2, 0x5c, 0x00, 0x04, 0xf4, 0x58, 0x00, 0x04, 0xf6, 0x8c,
-  0x00, 0x04, 0xf7, 0x84, 0x00, 0x04, 0xf8, 0xc0, 0x00, 0x04, 0xfa, 0x3c,
-  0x00, 0x04, 0xfb, 0xf8, 0x00, 0x04, 0xfd, 0xf0, 0x00, 0x05, 0x00, 0x2c,
-  0x00, 0x05, 0x02, 0x9c, 0x00, 0x05, 0x03, 0xd0, 0x00, 0x05, 0x05, 0x44,
-  0x00, 0x05, 0x07, 0x00, 0x00, 0x05, 0x08, 0xfc, 0x00, 0x05, 0x0b, 0x38,
-  0x00, 0x05, 0x0d, 0xa4, 0x00, 0x05, 0x10, 0x58, 0x00, 0x05, 0x11, 0xd0,
-  0x00, 0x05, 0x13, 0x8c, 0x00, 0x05, 0x15, 0x7c, 0x00, 0x05, 0x17, 0xb8,
-  0x00, 0x05, 0x1a, 0x34, 0x00, 0x05, 0x1c, 0xf0, 0x00, 0x05, 0x1f, 0xe4,
-  0x00, 0x05, 0x21, 0xa8, 0x00, 0x05, 0x23, 0xb0, 0x00, 0x05, 0x25, 0xf8,
-  0x00, 0x05, 0x28, 0x7c, 0x00, 0x05, 0x2b, 0x40, 0x00, 0x05, 0x2e, 0x30,
-  0x00, 0x05, 0x31, 0x60, 0x00, 0x05, 0x31, 0xbc, 0x00, 0x05, 0x32, 0x78,
-  0x00, 0x05, 0x33, 0x54, 0x00, 0x05, 0x34, 0x50, 0x00, 0x05, 0x35, 0x10,
-  0x00, 0x05, 0x35, 0xfc, 0x00, 0x05, 0x37, 0x14, 0x00, 0x05, 0x37, 0xc0,
-  0x00, 0x05, 0x38, 0xf4, 0x00, 0x05, 0x3a, 0x08, 0x00, 0x05, 0x3a, 0xf8,
-  0x00, 0x05, 0x3b, 0xac, 0x00, 0x05, 0x3c, 0x84, 0x00, 0x05, 0x3d, 0x64,
-  0x00, 0x05, 0x3e, 0x20, 0x00, 0x05, 0x3e, 0xd8, 0x00, 0x05, 0x3f, 0xb0,
-  0x00, 0x05, 0x40, 0xa8, 0x00, 0x05, 0x41, 0x64, 0x00, 0x05, 0x42, 0x4c,
-  0x00, 0x05, 0x43, 0x60, 0x00, 0x05, 0x44, 0x08, 0x00, 0x05, 0x45, 0x38,
-  0x00, 0x05, 0x46, 0x48, 0x00, 0x05, 0x47, 0x34, 0x00, 0x05, 0x47, 0xe4,
-  0x00, 0x05, 0x48, 0xb8, 0x00, 0x05, 0x49, 0x94, 0x00, 0x05, 0x4a, 0x4c,
-  0x00, 0x05, 0x4a, 0xd8, 0x00, 0x05, 0x4b, 0x88, 0x00, 0x05, 0x4c, 0x58,
-  0x00, 0x05, 0x4c, 0xe8, 0x00, 0x05, 0x4d, 0xa4, 0x00, 0x05, 0x4e, 0x8c,
-  0x00, 0x05, 0x4f, 0x0c, 0x00, 0x05, 0x50, 0x14, 0x00, 0x05, 0x50, 0xfc,
-  0x00, 0x05, 0x51, 0xc0, 0x00, 0x05, 0x52, 0x48, 0x00, 0x05, 0x52, 0xf4,
-  0x00, 0x05, 0x53, 0xa8, 0x00, 0x05, 0x54, 0x34, 0x00, 0x05, 0x54, 0xb0,
-  0x00, 0x05, 0x55, 0x84, 0x00, 0x05, 0x56, 0x7c, 0x00, 0x05, 0x57, 0x94,
-  0x00, 0x05, 0x58, 0x6c, 0x00, 0x05, 0x59, 0x70, 0x00, 0x05, 0x5a, 0xa0,
-  0x00, 0x05, 0x5b, 0x68, 0x00, 0x05, 0x5c, 0xb8, 0x00, 0x05, 0x5d, 0xe8,
-  0x00, 0x05, 0x5e, 0xf4, 0x00, 0x05, 0x5f, 0xc4, 0x00, 0x05, 0x60, 0xb8,
-  0x00, 0x05, 0x61, 0xb4, 0x00, 0x05, 0x62, 0x88, 0x00, 0x05, 0x63, 0x28,
-  0x00, 0x05, 0x65, 0x30, 0x00, 0x05, 0x68, 0x14, 0x00, 0x05, 0x6a, 0x3c,
-  0x00, 0x05, 0x6c, 0x58, 0x00, 0x05, 0x6d, 0x58, 0x00, 0x05, 0x6e, 0x58,
-  0x00, 0x05, 0x6f, 0xf0, 0x00, 0x05, 0x70, 0xd0, 0x00, 0x05, 0x71, 0xb0,
-  0x00, 0x05, 0x72, 0xb4, 0x00, 0x05, 0x73, 0x88, 0x00, 0x05, 0x74, 0xc0,
-  0x00, 0x05, 0x75, 0xcc, 0x00, 0x05, 0x76, 0xa4, 0x00, 0x05, 0x77, 0x84,
-  0x00, 0x05, 0x78, 0x90, 0x00, 0x05, 0x79, 0x70, 0x00, 0x05, 0x7a, 0x98,
-  0x00, 0x05, 0x7b, 0x6c, 0x00, 0x05, 0x7c, 0x10, 0x00, 0x05, 0x7c, 0xc8,
-  0x00, 0x05, 0x7d, 0x5c, 0x00, 0x05, 0x7e, 0x1c, 0x00, 0x05, 0x7f, 0x10,
-  0x00, 0x05, 0x7f, 0xc8, 0x00, 0x05, 0x80, 0x80, 0x00, 0x05, 0x81, 0x74,
-  0x00, 0x05, 0x82, 0x48, 0x00, 0x05, 0x83, 0x5c, 0x00, 0x05, 0x84, 0x30,
-  0x00, 0x05, 0x85, 0x04, 0x00, 0x05, 0x85, 0xdc, 0x00, 0x05, 0x86, 0xac,
-  0x00, 0x05, 0x87, 0x78, 0x00, 0x05, 0x88, 0x78, 0x00, 0x05, 0x89, 0xa8,
-  0x00, 0x05, 0x8a, 0xa8, 0x00, 0x05, 0x8b, 0xdc, 0x00, 0x05, 0x8c, 0xec,
-  0x00, 0x05, 0x8d, 0xc0, 0x00, 0x05, 0x8e, 0xa0, 0x00, 0x05, 0x8f, 0x80,
-  0x00, 0x05, 0x90, 0x7c, 0x00, 0x05, 0x92, 0x78, 0x00, 0x05, 0x93, 0x5c,
-  0x00, 0x05, 0x94, 0x70, 0x00, 0x05, 0x95, 0x44, 0x00, 0x05, 0x96, 0x90,
-  0x00, 0x05, 0x97, 0x54, 0x00, 0x05, 0x98, 0x34, 0x00, 0x05, 0x99, 0x30,
-  0x00, 0x05, 0x9a, 0xf8, 0x00, 0x05, 0x9c, 0x38, 0x00, 0x05, 0x9d, 0xb4,
-  0x00, 0x05, 0x9e, 0xd4, 0x00, 0x05, 0x9f, 0xa8, 0x00, 0x05, 0xa0, 0x50,
-  0x00, 0x05, 0xa1, 0x30, 0x00, 0x05, 0xa3, 0x74, 0x00, 0x05, 0xa5, 0xf4,
-  0x00, 0x05, 0xa8, 0x60, 0x00, 0x05, 0xaa, 0x68, 0x00, 0x05, 0xac, 0xa0,
-  0x00, 0x05, 0xae, 0xdc, 0x00, 0x05, 0xb1, 0x2c, 0x00, 0x05, 0xb2, 0xec,
-  0x00, 0x05, 0xb4, 0xa8, 0x00, 0x05, 0xb4, 0xc4, 0x00, 0x05, 0xb4, 0xec,
-  0x00, 0x05, 0xb5, 0x08, 0x00, 0x05, 0xb5, 0x64, 0x00, 0x05, 0xb5, 0x84,
-  0x00, 0x05, 0xb5, 0xa8, 0x00, 0x05, 0xb5, 0xd0, 0x00, 0x05, 0xb6, 0x04,
-  0x00, 0x05, 0xb6, 0x38, 0x00, 0x05, 0xb6, 0x54, 0x00, 0x05, 0xb6, 0x7c,
-  0x00, 0x05, 0xb6, 0xa8, 0x00, 0x05, 0xb6, 0xc0, 0x00, 0x05, 0xb6, 0xe4,
-  0x00, 0x05, 0xb7, 0x14, 0x00, 0x05, 0xb7, 0x44, 0x00, 0x05, 0xb7, 0x68,
-  0x00, 0x05, 0xb7, 0xa0, 0x00, 0x05, 0xb8, 0x18, 0x00, 0x05, 0xb8, 0x48,
-  0x00, 0x05, 0xb8, 0x88, 0x00, 0x05, 0xb9, 0x44, 0x00, 0x05, 0xb9, 0xe0,
-  0x00, 0x05, 0xba, 0x80, 0x00, 0x05, 0xbb, 0x44, 0x00, 0x05, 0xbb, 0x54,
-  0x00, 0x05, 0xbb, 0x64, 0x00, 0x05, 0xbb, 0x7c, 0x00, 0x05, 0xbb, 0x94,
-  0x00, 0x05, 0xbb, 0xe4, 0x00, 0x05, 0xbc, 0x04, 0x00, 0x05, 0xbc, 0x24,
-  0x00, 0x05, 0xbc, 0x44, 0x00, 0x05, 0xbc, 0x5c, 0x00, 0x05, 0xbc, 0x74,
-  0x00, 0x05, 0xbc, 0x8c, 0x00, 0x05, 0xbd, 0x64, 0x00, 0x05, 0xbe, 0x10,
-  0x00, 0x05, 0xbe, 0xd8, 0x00, 0x05, 0xbf, 0x84, 0x00, 0x05, 0xc0, 0x00,
-  0x00, 0x05, 0xc0, 0x98, 0x00, 0x05, 0xc1, 0x4c, 0x00, 0x05, 0xc1, 0xd4,
-  0x00, 0x05, 0xc2, 0x78, 0x00, 0x05, 0xc3, 0x3c, 0x00, 0x05, 0xc3, 0xd0,
-  0x00, 0x05, 0xc4, 0x80, 0x00, 0x05, 0xc4, 0xa0, 0x00, 0x05, 0xc4, 0xe8,
-  0x00, 0x05, 0xc5, 0x14, 0x00, 0x05, 0xc5, 0x64, 0x00, 0x05, 0xc5, 0x80,
-  0x00, 0x05, 0xc5, 0x9c, 0x00, 0x05, 0xc5, 0xb8, 0x00, 0x05, 0xc5, 0xd4,
-  0x00, 0x05, 0xc5, 0xf0, 0x00, 0x05, 0xc6, 0x0c, 0x00, 0x05, 0xc6, 0x28,
-  0x00, 0x05, 0xc6, 0x44, 0x00, 0x05, 0xc6, 0x60, 0x00, 0x05, 0xc6, 0x7c,
-  0x00, 0x05, 0xc6, 0x98, 0x00, 0x05, 0xc6, 0xb4, 0x00, 0x05, 0xc6, 0xd0,
-  0x00, 0x05, 0xc6, 0xec, 0x00, 0x05, 0xc7, 0x08, 0x00, 0x05, 0xc7, 0x24,
-  0x00, 0x05, 0xc7, 0x40, 0x00, 0x05, 0xc7, 0x5c, 0x00, 0x05, 0xc7, 0x78,
-  0x00, 0x05, 0xc7, 0x94, 0x00, 0x05, 0xc7, 0xac, 0x00, 0x05, 0xc7, 0xc8,
-  0x00, 0x05, 0xc8, 0x00, 0x00, 0x05, 0xc8, 0x70, 0x00, 0x05, 0xc8, 0xc4,
-  0x00, 0x05, 0xc9, 0x4c, 0x00, 0x05, 0xc9, 0x98, 0x00, 0x05, 0xc9, 0xf4,
-  0x00, 0x05, 0xca, 0xb0, 0x00, 0x05, 0xcb, 0x10, 0x00, 0x05, 0xcb, 0x80,
-  0x00, 0x05, 0xcb, 0xec, 0x00, 0x05, 0xcc, 0x18, 0x00, 0x05, 0xcc, 0x90,
-  0x00, 0x05, 0xcc, 0xa0, 0x00, 0x05, 0xcc, 0xb0, 0x00, 0x05, 0xcc, 0xc8,
-  0x00, 0x05, 0xcc, 0xf4, 0x00, 0x05, 0xcd, 0x4c, 0x00, 0x05, 0xcd, 0x64,
-  0x00, 0x05, 0xcd, 0x7c, 0x00, 0x05, 0xcd, 0xa0, 0x00, 0x05, 0xcd, 0xcc,
-  0x00, 0x05, 0xcd, 0xe8, 0x00, 0x05, 0xce, 0x80, 0x00, 0x05, 0xcf, 0x8c,
-  0x00, 0x05, 0xd0, 0x24, 0x00, 0x05, 0xd0, 0xac, 0x00, 0x05, 0xd1, 0xa4,
-  0x00, 0x05, 0xd2, 0x2c, 0x00, 0x05, 0xd2, 0x8c, 0x00, 0x05, 0xd3, 0x5c,
-  0x00, 0x05, 0xd3, 0x78, 0x00, 0x05, 0xd3, 0x9c, 0x00, 0x05, 0xd3, 0xbc,
-  0x00, 0x05, 0xd4, 0x0c, 0x00, 0x05, 0xd4, 0x64, 0x00, 0x05, 0xd4, 0xb4,
-  0x00, 0x05, 0xd4, 0xe8, 0x00, 0x05, 0xd5, 0x20, 0x00, 0x05, 0xd5, 0x50,
-  0x00, 0x05, 0xd5, 0x80, 0x00, 0x05, 0xd5, 0xb0, 0x00, 0x05, 0xd5, 0xdc,
-  0x00, 0x05, 0xd6, 0x08, 0x00, 0x05, 0xd6, 0x38, 0x00, 0x05, 0xd6, 0x60,
-  0x00, 0x05, 0xd6, 0x88, 0x00, 0x05, 0xd6, 0xb0, 0x00, 0x05, 0xd6, 0xd8,
-  0x00, 0x05, 0xd7, 0x44, 0x00, 0x05, 0xd7, 0xb4, 0x00, 0x05, 0xd8, 0x20,
-  0x00, 0x05, 0xd8, 0x54, 0x00, 0x05, 0xd8, 0x88, 0x00, 0x05, 0xd8, 0xbc,
-  0x00, 0x05, 0xd9, 0x1c, 0x00, 0x05, 0xd9, 0x84, 0x00, 0x05, 0xd9, 0xe8,
-  0x00, 0x05, 0xda, 0x18, 0x00, 0x05, 0xda, 0x4c, 0x00, 0x05, 0xda, 0x7c,
-  0x00, 0x05, 0xda, 0xac, 0x00, 0x05, 0xda, 0xe0, 0x00, 0x05, 0xdb, 0x10,
-  0x00, 0x05, 0xdb, 0x64, 0x00, 0x05, 0xdb, 0xb8, 0x00, 0x05, 0xdc, 0x10,
-  0x00, 0x05, 0xdc, 0x5c, 0x00, 0x05, 0xdc, 0xac, 0x00, 0x05, 0xdc, 0xf8,
-  0x00, 0x05, 0xdd, 0x20, 0x00, 0x05, 0xdd, 0x4c, 0x00, 0x05, 0xdd, 0x74,
-  0x00, 0x05, 0xdd, 0xe8, 0x00, 0x05, 0xde, 0x60, 0x00, 0x05, 0xde, 0xd0,
-  0x00, 0x05, 0xdf, 0x04, 0x00, 0x05, 0xdf, 0x3c, 0x00, 0x05, 0xdf, 0x70,
-  0x00, 0x05, 0xdf, 0xc0, 0x00, 0x05, 0xe0, 0x14, 0x00, 0x05, 0xe0, 0x64,
-  0x00, 0x05, 0xe0, 0x94, 0x00, 0x05, 0xe0, 0xc8, 0x00, 0x05, 0xe0, 0xf8,
-  0x00, 0x05, 0xe1, 0x2c, 0x00, 0x05, 0xe1, 0x64, 0x00, 0x05, 0xe1, 0x98,
-  0x00, 0x05, 0xe2, 0x08, 0x00, 0x05, 0xe2, 0x7c, 0x00, 0x05, 0xe2, 0xec,
-  0x00, 0x05, 0xe3, 0x20, 0x00, 0x05, 0xe3, 0x58, 0x00, 0x05, 0xe3, 0x8c,
-  0x00, 0x05, 0xe3, 0xf4, 0x00, 0x05, 0xe4, 0x60, 0x00, 0x05, 0xe4, 0xc8,
-  0x00, 0x05, 0xe4, 0xf4, 0x00, 0x05, 0xe5, 0x24, 0x00, 0x05, 0xe5, 0x50,
-  0x00, 0x05, 0xe5, 0x84, 0x00, 0x05, 0xe5, 0xbc, 0x00, 0x05, 0xe5, 0xf0,
-  0x00, 0x05, 0xe6, 0x74, 0x00, 0x05, 0xe6, 0xfc, 0x00, 0x05, 0xe7, 0x80,
-  0x00, 0x05, 0xe7, 0xac, 0x00, 0x05, 0xe7, 0xdc, 0x00, 0x05, 0xe8, 0x08,
-  0x00, 0x05, 0xe8, 0x38, 0x00, 0x05, 0xe8, 0x6c, 0x00, 0x05, 0xe8, 0x9c,
-  0x00, 0x05, 0xe8, 0xd8, 0x00, 0x05, 0xe9, 0x18, 0x00, 0x05, 0xe9, 0x54,
-  0x00, 0x05, 0xe9, 0xd4, 0x00, 0x05, 0xea, 0x58, 0x00, 0x05, 0xea, 0xd8,
-  0x00, 0x05, 0xeb, 0x60, 0x00, 0x05, 0xeb, 0xec, 0x00, 0x05, 0xec, 0x74,
-  0x00, 0x05, 0xec, 0x88, 0x00, 0x05, 0xec, 0xac, 0x00, 0x05, 0xec, 0xd0,
-  0x00, 0x05, 0xec, 0xf4, 0x00, 0x05, 0xed, 0x18, 0x00, 0x05, 0xed, 0x3c,
-  0x00, 0x05, 0xed, 0x60, 0x00, 0x05, 0xed, 0x84, 0x00, 0x05, 0xed, 0xa8,
-  0x00, 0x05, 0xed, 0xd8, 0x00, 0x05, 0xee, 0x14, 0x00, 0x05, 0xee, 0x50,
-  0x00, 0x05, 0xee, 0xb8, 0x00, 0x05, 0xef, 0x60, 0x00, 0x05, 0xef, 0xd0,
-  0x00, 0x05, 0xf0, 0x90, 0x00, 0x05, 0xf1, 0x18, 0x00, 0x05, 0xf1, 0xac,
-  0x00, 0x05, 0xf2, 0x44, 0x00, 0x05, 0xf2, 0xa4, 0x00, 0x05, 0xf3, 0x14,
-  0x00, 0x05, 0xf3, 0x80, 0x00, 0x05, 0xf4, 0x04, 0x00, 0x05, 0xf4, 0xec,
-  0x00, 0x05, 0xf5, 0x98, 0x00, 0x05, 0xf6, 0x54, 0x00, 0x05, 0xf7, 0x48,
-  0x00, 0x05, 0xf7, 0xfc, 0x00, 0x05, 0xf8, 0xc0, 0x00, 0x05, 0xf9, 0xd8,
-  0x00, 0x05, 0xfa, 0xb0, 0x00, 0x05, 0xfb, 0x98, 0x00, 0x05, 0xfc, 0x8c,
-  0x00, 0x05, 0xfd, 0x30, 0x00, 0x05, 0xfd, 0xe8, 0x00, 0x05, 0xfe, 0xe4,
-  0x00, 0x05, 0xff, 0x94, 0x00, 0x06, 0x00, 0x58, 0x00, 0x06, 0x00, 0xfc,
-  0x00, 0x06, 0x01, 0x88, 0x00, 0x06, 0x02, 0x2c, 0x00, 0x06, 0x02, 0xd4,
-  0x00, 0x06, 0x03, 0x50, 0x00, 0x06, 0x04, 0x00, 0x00, 0x06, 0x04, 0x18,
-  0x00, 0x06, 0x04, 0x30, 0x00, 0x06, 0x04, 0x48, 0x00, 0x06, 0x04, 0x68,
-  0x00, 0x06, 0x04, 0x88, 0x00, 0x06, 0x04, 0xa8, 0x00, 0x06, 0x04, 0xc0,
-  0x00, 0x06, 0x04, 0xd8, 0x00, 0x06, 0x04, 0xf0, 0x00, 0x06, 0x05, 0x08,
-  0x00, 0x06, 0x05, 0x20, 0x00, 0x06, 0x05, 0x38, 0x00, 0x06, 0x05, 0x50,
-  0x00, 0x06, 0x05, 0x68, 0x00, 0x06, 0x05, 0x80, 0x00, 0x06, 0x06, 0x2c,
-  0x00, 0x06, 0x06, 0x9c, 0x00, 0x06, 0x07, 0x20, 0x00, 0x06, 0x08, 0x10,
-  0x00, 0x06, 0x08, 0xc0, 0x00, 0x06, 0x09, 0x8c, 0x00, 0x06, 0x0a, 0x64,
-  0x00, 0x06, 0x0a, 0xdc, 0x00, 0x06, 0x0b, 0x70, 0x00, 0x06, 0x0c, 0x60,
-  0x00, 0x06, 0x0c, 0xec, 0x00, 0x06, 0x0d, 0x94, 0x00, 0x06, 0x0d, 0xf8,
-  0x00, 0x06, 0x0e, 0x5c, 0x00, 0x06, 0x0e, 0xc0, 0x00, 0x06, 0x0e, 0xf8,
-  0x00, 0x06, 0x0f, 0x30, 0x00, 0x06, 0x0f, 0x68, 0x00, 0x06, 0x0f, 0xac,
-  0x00, 0x06, 0x0f, 0xf0, 0x00, 0x06, 0x10, 0x34, 0x00, 0x06, 0x10, 0xb0,
-  0x00, 0x06, 0x10, 0xf0, 0x00, 0x06, 0x11, 0x40, 0x00, 0x06, 0x11, 0xd4,
-  0x00, 0x06, 0x12, 0x28, 0x00, 0x06, 0x12, 0x8c, 0x00, 0x06, 0x13, 0x20,
-  0x00, 0x06, 0x13, 0x78, 0x00, 0x06, 0x13, 0xdc, 0x00, 0x06, 0x14, 0x6c,
-  0x00, 0x06, 0x14, 0x8c, 0x00, 0x06, 0x14, 0xac, 0x00, 0x06, 0x15, 0x74,
-  0x00, 0x06, 0x15, 0x94, 0x00, 0x06, 0x15, 0xb4, 0x00, 0x06, 0x16, 0x50,
-  0x00, 0x06, 0x16, 0x68, 0x00, 0x06, 0x16, 0x80, 0x00, 0x01, 0x00, 0x00,
-  0x12, 0x0e, 0x03, 0x54, 0x00, 0x2b, 0x00, 0x68, 0x00, 0x0c, 0x00, 0x02,
-  0x00, 0x10, 0x00, 0x99, 0x00, 0x08, 0x00, 0x00, 0x04, 0x15, 0x00, 0x00,
-  0x00, 0x08, 0x00, 0x04, 0x00, 0x00, 0x00, 0x1a, 0x01, 0x3e, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x98, 0x01, 0x32, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x19, 0x01, 0xff, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x04, 0x02, 0x23, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x19, 0x02, 0x5c, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x19, 0x02, 0xaa, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x0c, 0x02, 0xde, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x16, 0x03, 0x19, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x11, 0x03, 0x54, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x1d, 0x03, 0xa2, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x12, 0x9d, 0x28, 0xfc, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x34, 0x3c, 0x04, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x0f, 0x3c, 0x59, 0x00, 0x01,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x09, 0x3c, 0x7d, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x00, 0x01, 0x30, 0x00, 0x00, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x01, 0x00, 0x32, 0x01, 0xcb, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x02, 0x00, 0x08, 0x02, 0x19, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x03, 0x00, 0x32, 0x02, 0x28, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x04, 0x00, 0x32, 0x02, 0x76, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x05, 0x00, 0x18, 0x02, 0xc4, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x06, 0x00, 0x2c, 0x02, 0xeb, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x08, 0x00, 0x22, 0x03, 0x30, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x0b, 0x00, 0x3a, 0x03, 0x66, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x0d, 0x25, 0x3a, 0x03, 0xc0, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x0e, 0x00, 0x68, 0x3b, 0x9a, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x10, 0x00, 0x1e, 0x3c, 0x39, 0x00, 0x03,
-  0x00, 0x01, 0x04, 0x09, 0x00, 0x11, 0x00, 0x12, 0x3c, 0x69, 0x00, 0x43,
-  0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67,
-  0x00, 0x68, 0x00, 0x74, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29,
-  0x00, 0x20, 0x00, 0x32, 0x00, 0x30, 0x00, 0x30, 0x00, 0x33, 0x00, 0x20,
-  0x00, 0x62, 0x00, 0x79, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74,
-  0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e,
-  0x00, 0x20, 0x00, 0x41, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x52,
-  0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x52, 0x00, 0x65, 0x00, 0x73, 0x00, 0x65, 0x00, 0x72, 0x00, 0x76,
-  0x00, 0x65, 0x00, 0x64, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x43, 0x00, 0x6f,
-  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20,
-  0x00, 0x32, 0x00, 0x30, 0x00, 0x30, 0x00, 0x36, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x79, 0x00, 0x20, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d,
-  0x00, 0x6a, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42,
-  0x00, 0x61, 0x00, 0x68, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x6c,
-  0x00, 0x6c, 0x00, 0x20, 0x00, 0x52, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x52, 0x00, 0x65, 0x00, 0x73,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x76, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2e,
-  0x00, 0x0a, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56,
-  0x00, 0x75, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6e,
-  0x00, 0x67, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x70,
-  0x00, 0x75, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63, 0x00, 0x20,
-  0x00, 0x64, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e,
-  0x00, 0x0a, 0x00, 0x00, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68,
-  0x74, 0x20, 0x28, 0x63, 0x29, 0x20, 0x32, 0x30, 0x30, 0x33, 0x20, 0x62,
-  0x79, 0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x2c,
-  0x20, 0x49, 0x6e, 0x63, 0x2e, 0x20, 0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69,
-  0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65, 0x73, 0x65, 0x72, 0x76, 0x65,
-  0x64, 0x2e, 0x0a, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74,
-  0x20, 0x28, 0x63, 0x29, 0x20, 0x32, 0x30, 0x30, 0x36, 0x20, 0x62, 0x79,
-  0x20, 0x54, 0x61, 0x76, 0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61,
-  0x68, 0x2e, 0x20, 0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69, 0x67, 0x68, 0x74,
-  0x73, 0x20, 0x52, 0x65, 0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2e, 0x0a,
-  0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x63, 0x68, 0x61, 0x6e, 0x67,
-  0x65, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20, 0x69, 0x6e, 0x20, 0x70, 0x75,
-  0x62, 0x6c, 0x69, 0x63, 0x20, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x0a,
-  0x00, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00,
-  0x75, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x47, 0x00, 0x43, 0x00, 0x20, 0x00,
-  0x53, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00,
-  0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00,
-  0x65, 0x00, 0x64, 0x00, 0x00, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20,
-  0x4c, 0x47, 0x43, 0x20, 0x53, 0x61, 0x6e, 0x73, 0x20, 0x43, 0x6f, 0x6e,
-  0x64, 0x65, 0x6e, 0x73, 0x65, 0x64, 0x00, 0x00, 0x42, 0x00, 0x6f, 0x00,
-  0x6f, 0x00, 0x6b, 0x00, 0x00, 0x42, 0x6f, 0x6f, 0x6b, 0x00, 0x00, 0x44,
-  0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75, 0x00, 0x20,
-  0x00, 0x4c, 0x00, 0x47, 0x00, 0x43, 0x00, 0x20, 0x00, 0x53, 0x00, 0x61,
-  0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x64, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00, 0x64,
-  0x00, 0x00, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x4c, 0x47, 0x43,
-  0x20, 0x53, 0x61, 0x6e, 0x73, 0x20, 0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e,
-  0x73, 0x65, 0x64, 0x00, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61,
-  0x00, 0x56, 0x00, 0x75, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x47, 0x00, 0x43,
-  0x00, 0x20, 0x00, 0x53, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x43, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6e,
-  0x00, 0x73, 0x00, 0x65, 0x00, 0x64, 0x00, 0x00, 0x44, 0x65, 0x6a, 0x61,
-  0x56, 0x75, 0x20, 0x4c, 0x47, 0x43, 0x20, 0x53, 0x61, 0x6e, 0x73, 0x20,
-  0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e, 0x73, 0x65, 0x64, 0x00, 0x00, 0x56,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x20, 0x00, 0x32, 0x00, 0x2e, 0x00, 0x33, 0x00, 0x34, 0x00, 0x00,
-  0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x32, 0x2e, 0x33, 0x34,
-  0x00, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00,
-  0x75, 0x00, 0x4c, 0x00, 0x47, 0x00, 0x43, 0x00, 0x53, 0x00, 0x61, 0x00,
-  0x6e, 0x00, 0x73, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00,
-  0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00, 0x64, 0x00, 0x00, 0x44,
-  0x65, 0x6a, 0x61, 0x56, 0x75, 0x4c, 0x47, 0x43, 0x53, 0x61, 0x6e, 0x73,
-  0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e, 0x73, 0x65, 0x64, 0x00, 0x00, 0x44,
-  0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75, 0x00, 0x20,
-  0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x00, 0x44, 0x65,
-  0x6a, 0x61, 0x56, 0x75, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x74,
-  0x65, 0x61, 0x6d, 0x00, 0x00, 0x68, 0x00, 0x74, 0x00, 0x74, 0x00, 0x70,
-  0x00, 0x3a, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6a,
-  0x00, 0x61, 0x00, 0x76, 0x00, 0x75, 0x00, 0x2e, 0x00, 0x73, 0x00, 0x6f,
-  0x00, 0x75, 0x00, 0x72, 0x00, 0x63, 0x00, 0x65, 0x00, 0x66, 0x00, 0x6f,
-  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2e, 0x00, 0x6e, 0x00, 0x65,
-  0x00, 0x74, 0x00, 0x00, 0x68, 0x74, 0x74, 0x70, 0x3a, 0x2f, 0x2f, 0x64,
-  0x65, 0x6a, 0x61, 0x76, 0x75, 0x2e, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65,
-  0x66, 0x6f, 0x72, 0x67, 0x65, 0x2e, 0x6e, 0x65, 0x74, 0x00, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29,
-  0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x28,
-  0x00, 0x73, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65,
-  0x00, 0x6c, 0x00, 0x6f, 0x00, 0x77, 0x00, 0x29, 0x00, 0x2e, 0x00, 0x20,
-  0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75,
-  0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x67,
-  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x70, 0x00, 0x75,
-  0x00, 0x62, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63, 0x00, 0x20, 0x00, 0x64,
-  0x00, 0x6f, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x2e,
-  0x00, 0x20, 0x00, 0x47, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6d, 0x00, 0x70, 0x00, 0x6f,
-  0x00, 0x72, 0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x66,
-  0x00, 0x72, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x41, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x76, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20, 0x00, 0x54,
-  0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a, 0x00, 0x75, 0x00, 0x6e,
-  0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61, 0x00, 0x68, 0x00, 0x20,
-  0x00, 0x28, 0x00, 0x73, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x65, 0x00, 0x6c, 0x00, 0x6f, 0x00, 0x77, 0x00, 0x29, 0x00, 0x0a,
-  0x00, 0x0a, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x56,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x61, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00, 0x6f,
-  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
-  0x00, 0x74, 0x00, 0x0a, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x43, 0x00, 0x6f,
-  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20,
-  0x00, 0x32, 0x00, 0x30, 0x00, 0x30, 0x00, 0x33, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x79, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73,
-  0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x2c,
-  0x00, 0x20, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e, 0x00, 0x20,
-  0x00, 0x41, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x52, 0x00, 0x69,
-  0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x52,
-  0x00, 0x65, 0x00, 0x73, 0x00, 0x65, 0x00, 0x72, 0x00, 0x76, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74,
-  0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d,
-  0x00, 0x20, 0x00, 0x56, 0x00, 0x65, 0x00, 0x72, 0x00, 0x61, 0x00, 0x20,
-  0x00, 0x69, 0x00, 0x73, 0x00, 0x0a, 0x00, 0x61, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x72, 0x00, 0x61, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6d, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x6b, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
-  0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x49,
-  0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x50,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69, 0x00, 0x73, 0x00, 0x73,
-  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x69, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x65, 0x00, 0x62,
-  0x00, 0x79, 0x00, 0x20, 0x00, 0x67, 0x00, 0x72, 0x00, 0x61, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x66,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x72, 0x00, 0x67,
-  0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x6e, 0x00, 0x79, 0x00, 0x20, 0x00, 0x70, 0x00, 0x65,
-  0x00, 0x72, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6f,
-  0x00, 0x62, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x69,
-  0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x61, 0x00, 0x20, 0x00, 0x63,
-  0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x66,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61,
-  0x00, 0x63, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x70, 0x00, 0x61,
-  0x00, 0x6e, 0x00, 0x79, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6c,
-  0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x28, 0x00, 0x22, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x22, 0x00, 0x29, 0x00, 0x20, 0x00, 0x61,
-  0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x73,
-  0x00, 0x6f, 0x00, 0x63, 0x00, 0x69, 0x00, 0x61, 0x00, 0x74, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x0a, 0x00, 0x64, 0x00, 0x6f, 0x00, 0x63, 0x00, 0x75,
-  0x00, 0x6d, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x74,
-  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x66, 0x00, 0x69,
-  0x00, 0x6c, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x28, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x22, 0x00, 0x46, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x22,
-  0x00, 0x29, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x70, 0x00, 0x72, 0x00, 0x6f, 0x00, 0x64,
-  0x00, 0x75, 0x00, 0x63, 0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74,
-  0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x6c,
-  0x00, 0x75, 0x00, 0x64, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
-  0x00, 0x77, 0x00, 0x69, 0x00, 0x74, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x75,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x6d, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x72,
-  0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x72, 0x00, 0x67,
-  0x00, 0x65, 0x00, 0x2c, 0x00, 0x0a, 0x00, 0x70, 0x00, 0x75, 0x00, 0x62,
-  0x00, 0x6c, 0x00, 0x69, 0x00, 0x73, 0x00, 0x68, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x69,
-  0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x2f, 0x00, 0x6f, 0x00, 0x72,
-  0x00, 0x20, 0x00, 0x73, 0x00, 0x65, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20,
-  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x69, 0x00, 0x65, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x61,
-  0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
-  0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69, 0x00, 0x74,
-  0x00, 0x0a, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
-  0x00, 0x77, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
-  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x69,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75, 0x00, 0x72, 0x00, 0x6e,
-  0x00, 0x69, 0x00, 0x73, 0x00, 0x68, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x64, 0x00, 0x6f, 0x00, 0x20,
-  0x00, 0x73, 0x00, 0x6f, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x73, 0x00, 0x75,
-  0x00, 0x62, 0x00, 0x6a, 0x00, 0x65, 0x00, 0x63, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
-  0x00, 0x0a, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x6f,
-  0x00, 0x77, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x63,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x69, 0x00, 0x74, 0x00, 0x69,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x3a, 0x00, 0x0a, 0x00, 0x0a,
-  0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x62,
-  0x00, 0x6f, 0x00, 0x76, 0x00, 0x65, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
-  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x72, 0x00, 0x61, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6d,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x6b, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72,
-  0x00, 0x6d, 0x00, 0x69, 0x00, 0x73, 0x00, 0x73, 0x00, 0x69, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x69,
-  0x00, 0x63, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x68, 0x00, 0x61,
-  0x00, 0x6c, 0x00, 0x6c, 0x00, 0x0a, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x69, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x6c, 0x00, 0x75, 0x00, 0x64,
-  0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
-  0x00, 0x70, 0x00, 0x69, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
-  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x79, 0x00, 0x70, 0x00, 0x65, 0x00, 0x66, 0x00, 0x61, 0x00, 0x63,
-  0x00, 0x65, 0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
-  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6d,
-  0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69,
-  0x00, 0x65, 0x00, 0x64, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6c,
-  0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64,
-  0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x70, 0x00, 0x61, 0x00, 0x72,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x75, 0x00, 0x6c, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x0a, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x64, 0x00, 0x65, 0x00, 0x73, 0x00, 0x69, 0x00, 0x67, 0x00, 0x6e,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x67,
-  0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74, 0x00, 0x65, 0x00, 0x72,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79,
-  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f,
-  0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x0a, 0x00, 0x61,
-  0x00, 0x64, 0x00, 0x64, 0x00, 0x69, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x67, 0x00, 0x6c,
-  0x00, 0x79, 0x00, 0x70, 0x00, 0x68, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f,
-  0x00, 0x72, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x72,
-  0x00, 0x61, 0x00, 0x63, 0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64, 0x00, 0x64, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x6c, 0x00, 0x79, 0x00, 0x20, 0x00, 0x69, 0x00, 0x66, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x0a, 0x00, 0x61, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x61,
-  0x00, 0x6d, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
-  0x00, 0x20, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x20, 0x00, 0x63,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e,
-  0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x65, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x6f, 0x00, 0x72,
-  0x00, 0x64, 0x00, 0x73, 0x00, 0x20, 0x00, 0x22, 0x00, 0x42, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
-  0x00, 0x6d, 0x00, 0x22, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x6f,
-  0x00, 0x72, 0x00, 0x64, 0x00, 0x0a, 0x00, 0x22, 0x00, 0x56, 0x00, 0x65,
-  0x00, 0x72, 0x00, 0x61, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
-  0x00, 0x54, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x4c,
-  0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d,
-  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x75, 0x00, 0x6c,
-  0x00, 0x6c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x76, 0x00, 0x6f, 0x00, 0x69, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x65, 0x00, 0x78, 0x00, 0x74, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x70, 0x00, 0x70, 0x00, 0x6c, 0x00, 0x69,
-  0x00, 0x63, 0x00, 0x61, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
-  0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x53,
-  0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x61, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x68, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x65, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f,
-  0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74,
-  0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x75, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65,
-  0x00, 0x72, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x22, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x0a, 0x00, 0x56,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x61, 0x00, 0x22, 0x00, 0x20, 0x00, 0x6e,
-  0x00, 0x61, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a,
-  0x00, 0x0a, 0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6c, 0x00, 0x64,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x70, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x74, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x20, 0x00, 0x6c, 0x00, 0x61, 0x00, 0x72, 0x00, 0x67,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x70, 0x00, 0x61, 0x00, 0x63, 0x00, 0x6b, 0x00, 0x61, 0x00, 0x67,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x6e, 0x00, 0x6f, 0x00, 0x0a, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70,
-  0x00, 0x79, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
-  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53,
-  0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x79, 0x00, 0x70, 0x00, 0x65,
-  0x00, 0x66, 0x00, 0x61, 0x00, 0x63, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6c, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x62, 0x00, 0x79, 0x00, 0x20, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73,
-  0x00, 0x65, 0x00, 0x6c, 0x00, 0x66, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
-  0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x20, 0x00, 0x46, 0x00, 0x4f,
-  0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x46,
-  0x00, 0x54, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52, 0x00, 0x45, 0x00, 0x20,
-  0x00, 0x49, 0x00, 0x53, 0x00, 0x20, 0x00, 0x50, 0x00, 0x52, 0x00, 0x4f,
-  0x00, 0x56, 0x00, 0x49, 0x00, 0x44, 0x00, 0x45, 0x00, 0x44, 0x00, 0x20,
-  0x00, 0x22, 0x00, 0x41, 0x00, 0x53, 0x00, 0x20, 0x00, 0x49, 0x00, 0x53,
-  0x00, 0x22, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x57, 0x00, 0x49, 0x00, 0x54,
-  0x00, 0x48, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x54, 0x00, 0x20, 0x00, 0x57,
-  0x00, 0x41, 0x00, 0x52, 0x00, 0x52, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x54,
-  0x00, 0x59, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x41,
-  0x00, 0x4e, 0x00, 0x59, 0x00, 0x20, 0x00, 0x4b, 0x00, 0x49, 0x00, 0x4e,
-  0x00, 0x44, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x45, 0x00, 0x58, 0x00, 0x50,
-  0x00, 0x52, 0x00, 0x45, 0x00, 0x53, 0x00, 0x53, 0x00, 0x0a, 0x00, 0x4f,
-  0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x50, 0x00, 0x4c,
-  0x00, 0x49, 0x00, 0x45, 0x00, 0x44, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x49,
-  0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x55, 0x00, 0x44, 0x00, 0x49,
-  0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x42, 0x00, 0x55, 0x00, 0x54,
-  0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4c,
-  0x00, 0x49, 0x00, 0x4d, 0x00, 0x49, 0x00, 0x54, 0x00, 0x45, 0x00, 0x44,
-  0x00, 0x20, 0x00, 0x54, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e,
-  0x00, 0x59, 0x00, 0x20, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52, 0x00, 0x52,
-  0x00, 0x41, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x49, 0x00, 0x45, 0x00, 0x53,
-  0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x4d, 0x00, 0x45,
-  0x00, 0x52, 0x00, 0x43, 0x00, 0x48, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x54,
-  0x00, 0x41, 0x00, 0x42, 0x00, 0x49, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x54,
-  0x00, 0x59, 0x00, 0x2c, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x49, 0x00, 0x54,
-  0x00, 0x4e, 0x00, 0x45, 0x00, 0x53, 0x00, 0x53, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x41, 0x00, 0x20, 0x00, 0x50,
-  0x00, 0x41, 0x00, 0x52, 0x00, 0x54, 0x00, 0x49, 0x00, 0x43, 0x00, 0x55,
-  0x00, 0x4c, 0x00, 0x41, 0x00, 0x52, 0x00, 0x20, 0x00, 0x50, 0x00, 0x55,
-  0x00, 0x52, 0x00, 0x50, 0x00, 0x4f, 0x00, 0x53, 0x00, 0x45, 0x00, 0x20,
-  0x00, 0x41, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f,
-  0x00, 0x4e, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x46, 0x00, 0x52, 0x00, 0x49,
-  0x00, 0x4e, 0x00, 0x47, 0x00, 0x45, 0x00, 0x4d, 0x00, 0x45, 0x00, 0x4e,
-  0x00, 0x54, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x43,
-  0x00, 0x4f, 0x00, 0x50, 0x00, 0x59, 0x00, 0x52, 0x00, 0x49, 0x00, 0x47,
-  0x00, 0x48, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x50, 0x00, 0x41,
-  0x00, 0x54, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x0a,
-  0x00, 0x54, 0x00, 0x52, 0x00, 0x41, 0x00, 0x44, 0x00, 0x45, 0x00, 0x4d,
-  0x00, 0x41, 0x00, 0x52, 0x00, 0x4b, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f,
-  0x00, 0x52, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
-  0x00, 0x52, 0x00, 0x20, 0x00, 0x52, 0x00, 0x49, 0x00, 0x47, 0x00, 0x48,
-  0x00, 0x54, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x20,
-  0x00, 0x4e, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x45, 0x00, 0x56, 0x00, 0x45,
-  0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53, 0x00, 0x48, 0x00, 0x41,
-  0x00, 0x4c, 0x00, 0x4c, 0x00, 0x20, 0x00, 0x42, 0x00, 0x49, 0x00, 0x54,
-  0x00, 0x53, 0x00, 0x54, 0x00, 0x52, 0x00, 0x45, 0x00, 0x41, 0x00, 0x4d,
-  0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x47, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x4d,
-  0x00, 0x45, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x4e,
-  0x00, 0x44, 0x00, 0x41, 0x00, 0x54, 0x00, 0x49, 0x00, 0x4f, 0x00, 0x4e,
-  0x00, 0x20, 0x00, 0x42, 0x00, 0x45, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x49,
-  0x00, 0x41, 0x00, 0x42, 0x00, 0x4c, 0x00, 0x45, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59,
-  0x00, 0x20, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x41, 0x00, 0x49, 0x00, 0x4d,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x44, 0x00, 0x41, 0x00, 0x4d, 0x00, 0x41,
-  0x00, 0x47, 0x00, 0x45, 0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52,
-  0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x52,
-  0x00, 0x20, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x41, 0x00, 0x42, 0x00, 0x49,
-  0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x55, 0x00, 0x44,
-  0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x0a, 0x00, 0x41, 0x00, 0x4e,
-  0x00, 0x59, 0x00, 0x20, 0x00, 0x47, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x45,
-  0x00, 0x52, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x53,
-  0x00, 0x50, 0x00, 0x45, 0x00, 0x43, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x49,
-  0x00, 0x52, 0x00, 0x45, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x49, 0x00, 0x44, 0x00, 0x45,
-  0x00, 0x4e, 0x00, 0x54, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e,
-  0x00, 0x53, 0x00, 0x45, 0x00, 0x51, 0x00, 0x55, 0x00, 0x45, 0x00, 0x4e,
-  0x00, 0x54, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x20, 0x00, 0x44,
-  0x00, 0x41, 0x00, 0x4d, 0x00, 0x41, 0x00, 0x47, 0x00, 0x45, 0x00, 0x53,
-  0x00, 0x2c, 0x00, 0x0a, 0x00, 0x57, 0x00, 0x48, 0x00, 0x45, 0x00, 0x54,
-  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e,
-  0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x43,
-  0x00, 0x54, 0x00, 0x49, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x4f,
-  0x00, 0x46, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
-  0x00, 0x52, 0x00, 0x41, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x54, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4f,
-  0x00, 0x52, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
-  0x00, 0x52, 0x00, 0x57, 0x00, 0x49, 0x00, 0x53, 0x00, 0x45, 0x00, 0x2c,
-  0x00, 0x20, 0x00, 0x41, 0x00, 0x52, 0x00, 0x49, 0x00, 0x53, 0x00, 0x49,
-  0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x46, 0x00, 0x52, 0x00, 0x4f,
-  0x00, 0x4d, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x54,
-  0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x48,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53, 0x00, 0x45, 0x00, 0x20,
-  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x41,
-  0x00, 0x42, 0x00, 0x49, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59,
-  0x00, 0x20, 0x00, 0x54, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x20,
-  0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53,
-  0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x52, 0x00, 0x4f, 0x00, 0x4d, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54,
-  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x44, 0x00, 0x45,
-  0x00, 0x41, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x53,
-  0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
-  0x00, 0x45, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
-  0x00, 0x20, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57,
-  0x00, 0x41, 0x00, 0x52, 0x00, 0x45, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
-  0x00, 0x45, 0x00, 0x78, 0x00, 0x63, 0x00, 0x65, 0x00, 0x70, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61,
-  0x00, 0x6d, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x20, 0x00, 0x47, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x47, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x0a,
-  0x00, 0x46, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x61,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
-  0x00, 0x6d, 0x00, 0x20, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x73, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6c,
-  0x00, 0x6c, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x61,
-  0x00, 0x64, 0x00, 0x76, 0x00, 0x65, 0x00, 0x72, 0x00, 0x74, 0x00, 0x69,
-  0x00, 0x73, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x6f,
-  0x00, 0x72, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
-  0x00, 0x72, 0x00, 0x77, 0x00, 0x69, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x70, 0x00, 0x72, 0x00, 0x6f,
-  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x61, 0x00, 0x6c,
-  0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x64, 0x00, 0x65,
-  0x00, 0x61, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
-  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x77,
-  0x00, 0x69, 0x00, 0x74, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x70, 0x00, 0x72, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x72,
-  0x00, 0x20, 0x00, 0x77, 0x00, 0x72, 0x00, 0x69, 0x00, 0x74, 0x00, 0x74,
-  0x00, 0x65, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x75, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x69, 0x00, 0x7a, 0x00, 0x61,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x66,
-  0x00, 0x72, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x47, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x6e,
-  0x00, 0x64, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
-  0x00, 0x6d, 0x00, 0x0a, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65, 0x00, 0x73, 0x00, 0x70,
-  0x00, 0x65, 0x00, 0x63, 0x00, 0x74, 0x00, 0x69, 0x00, 0x76, 0x00, 0x65,
-  0x00, 0x6c, 0x00, 0x79, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f,
-  0x00, 0x72, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75, 0x00, 0x72, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e,
-  0x00, 0x66, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x74,
-  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x63,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74,
-  0x00, 0x3a, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x74, 0x00, 0x20, 0x00, 0x67,
-  0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x20, 0x00, 0x64,
-  0x00, 0x6f, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x67,
-  0x00, 0x2e, 0x00, 0x20, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x41, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x76, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x70,
-  0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
-  0x00, 0x0a, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
-  0x00, 0x2d, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x70,
-  0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20, 0x00, 0x32,
-  0x00, 0x30, 0x00, 0x30, 0x00, 0x36, 0x00, 0x20, 0x00, 0x62, 0x00, 0x79,
-  0x00, 0x20, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61,
-  0x00, 0x68, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x6c, 0x00, 0x6c,
-  0x00, 0x20, 0x00, 0x52, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x52, 0x00, 0x65, 0x00, 0x73, 0x00, 0x65,
-  0x00, 0x72, 0x00, 0x76, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2e, 0x00, 0x0a,
-  0x00, 0x0a, 0x00, 0x50, 0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69,
-  0x00, 0x73, 0x00, 0x73, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20,
-  0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x62, 0x00, 0x79, 0x00, 0x20, 0x00, 0x67, 0x00, 0x72,
-  0x00, 0x61, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c,
-  0x00, 0x20, 0x00, 0x66, 0x00, 0x72, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x79, 0x00, 0x20,
-  0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x62, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69,
-  0x00, 0x6e, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x0a, 0x00, 0x61,
-  0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x63, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d,
-  0x00, 0x70, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x79, 0x00, 0x69, 0x00, 0x6e,
-  0x00, 0x67, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e,
-  0x00, 0x73, 0x00, 0x65, 0x00, 0x20, 0x00, 0x28, 0x00, 0x22, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x22, 0x00, 0x29,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x0a, 0x00, 0x61,
-  0x00, 0x73, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x63, 0x00, 0x69, 0x00, 0x61,
-  0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x64, 0x00, 0x6f,
-  0x00, 0x63, 0x00, 0x75, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74,
-  0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20,
-  0x00, 0x66, 0x00, 0x69, 0x00, 0x6c, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x28, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x22,
-  0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53,
-  0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x22, 0x00, 0x29, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65, 0x00, 0x70, 0x00, 0x72,
-  0x00, 0x6f, 0x00, 0x64, 0x00, 0x75, 0x00, 0x63, 0x00, 0x65, 0x00, 0x0a,
-  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x64, 0x00, 0x69,
-  0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75,
-  0x00, 0x74, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69, 0x00, 0x66,
-  0x00, 0x69, 0x00, 0x63, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
-  0x00, 0x6d, 0x00, 0x20, 0x00, 0x56, 0x00, 0x65, 0x00, 0x72, 0x00, 0x61,
-  0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x0a, 0x00, 0x69, 0x00, 0x6e,
-  0x00, 0x63, 0x00, 0x6c, 0x00, 0x75, 0x00, 0x64, 0x00, 0x69, 0x00, 0x6e,
-  0x00, 0x67, 0x00, 0x20, 0x00, 0x77, 0x00, 0x69, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x6f, 0x00, 0x75, 0x00, 0x74, 0x00, 0x20, 0x00, 0x6c, 0x00, 0x69,
-  0x00, 0x6d, 0x00, 0x69, 0x00, 0x74, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x75,
-  0x00, 0x73, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
-  0x00, 0x70, 0x00, 0x79, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x65,
-  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x70,
-  0x00, 0x75, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x73, 0x00, 0x68,
-  0x00, 0x2c, 0x00, 0x0a, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74,
-  0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x2f,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x73, 0x00, 0x65, 0x00, 0x6c,
-  0x00, 0x6c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x69,
-  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x2c,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x6d,
-  0x00, 0x69, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72,
-  0x00, 0x73, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x77, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x6d,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75,
-  0x00, 0x72, 0x00, 0x6e, 0x00, 0x69, 0x00, 0x73, 0x00, 0x68, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x64,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x73, 0x00, 0x75, 0x00, 0x62, 0x00, 0x6a, 0x00, 0x65, 0x00, 0x63,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x0a, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6c,
-  0x00, 0x6c, 0x00, 0x6f, 0x00, 0x77, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67,
-  0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x3a,
-  0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x62, 0x00, 0x6f, 0x00, 0x76, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69,
-  0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x72, 0x00, 0x61, 0x00, 0x64,
-  0x00, 0x65, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x72, 0x00, 0x6b, 0x00, 0x20,
-  0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x70,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69, 0x00, 0x73, 0x00, 0x73,
-  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x73,
-  0x00, 0x68, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x6c,
-  0x00, 0x75, 0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69,
-  0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20,
-  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x69, 0x00, 0x65, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6d,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x0a, 0x00, 0x74, 0x00, 0x79, 0x00, 0x70, 0x00, 0x65, 0x00, 0x66,
-  0x00, 0x61, 0x00, 0x63, 0x00, 0x65, 0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a,
-  0x00, 0x0a, 0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69,
-  0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x6c, 0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x64, 0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x6f, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x0a, 0x00, 0x70,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x75,
-  0x00, 0x6c, 0x00, 0x61, 0x00, 0x72, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x64, 0x00, 0x65, 0x00, 0x73, 0x00, 0x69,
-  0x00, 0x67, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
-  0x00, 0x20, 0x00, 0x67, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x63,
-  0x00, 0x68, 0x00, 0x61, 0x00, 0x72, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d,
-  0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x0a,
-  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69,
-  0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x64, 0x00, 0x64, 0x00, 0x69, 0x00, 0x74,
-  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x20,
-  0x00, 0x67, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74, 0x00, 0x65,
-  0x00, 0x72, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79,
-  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64,
-  0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x20, 0x00, 0x69,
-  0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d,
-  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61,
-  0x00, 0x69, 0x00, 0x6e, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
-  0x00, 0x65, 0x00, 0x69, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72,
-  0x00, 0x0a, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x64, 0x00, 0x73, 0x00, 0x20, 0x00, 0x22,
-  0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61, 0x00, 0x68,
-  0x00, 0x22, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x6f, 0x00, 0x72,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x22, 0x00, 0x41, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x76, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54,
-  0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x69,
-  0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x62, 0x00, 0x65, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x75, 0x00, 0x6c, 0x00, 0x6c,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x76,
-  0x00, 0x6f, 0x00, 0x69, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x65,
-  0x00, 0x78, 0x00, 0x74, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x70, 0x00, 0x70, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63,
-  0x00, 0x61, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
-  0x00, 0x73, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x61, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x68, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65,
-  0x00, 0x65, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64,
-  0x00, 0x69, 0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
-  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72,
-  0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65, 0x00, 0x64,
-  0x00, 0x20, 0x00, 0x75, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x72,
-  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x0a,
-  0x00, 0x22, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a,
-  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61,
-  0x00, 0x68, 0x00, 0x20, 0x00, 0x41, 0x00, 0x72, 0x00, 0x65, 0x00, 0x76,
-  0x00, 0x22, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x65,
-  0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x68,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61,
-  0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73,
-  0x00, 0x6f, 0x00, 0x6c, 0x00, 0x64, 0x00, 0x20, 0x00, 0x61, 0x00, 0x73,
-  0x00, 0x20, 0x00, 0x70, 0x00, 0x61, 0x00, 0x72, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x61, 0x00, 0x20, 0x00, 0x6c,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20,
-  0x00, 0x73, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61,
-  0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x70, 0x00, 0x61, 0x00, 0x63,
-  0x00, 0x6b, 0x00, 0x61, 0x00, 0x67, 0x00, 0x65, 0x00, 0x20, 0x00, 0x62,
-  0x00, 0x75, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x20,
-  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x20, 0x00, 0x6f,
-  0x00, 0x66, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x72,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
-  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
-  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x79, 0x00, 0x70, 0x00, 0x65, 0x00, 0x66, 0x00, 0x61, 0x00, 0x63,
-  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79,
-  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f,
-  0x00, 0x6c, 0x00, 0x64, 0x00, 0x20, 0x00, 0x62, 0x00, 0x79, 0x00, 0x0a,
-  0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x65, 0x00, 0x6c, 0x00, 0x66,
-  0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
-  0x00, 0x20, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20,
-  0x00, 0x53, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57, 0x00, 0x41,
-  0x00, 0x52, 0x00, 0x45, 0x00, 0x20, 0x00, 0x49, 0x00, 0x53, 0x00, 0x20,
-  0x00, 0x50, 0x00, 0x52, 0x00, 0x4f, 0x00, 0x56, 0x00, 0x49, 0x00, 0x44,
-  0x00, 0x45, 0x00, 0x44, 0x00, 0x20, 0x00, 0x22, 0x00, 0x41, 0x00, 0x53,
-  0x00, 0x20, 0x00, 0x49, 0x00, 0x53, 0x00, 0x22, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x57, 0x00, 0x49, 0x00, 0x54, 0x00, 0x48, 0x00, 0x4f, 0x00, 0x55,
-  0x00, 0x54, 0x00, 0x20, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52, 0x00, 0x52,
-  0x00, 0x41, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x59, 0x00, 0x20, 0x00, 0x4f,
-  0x00, 0x46, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59, 0x00, 0x20,
-  0x00, 0x4b, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x2c, 0x00, 0x0a,
-  0x00, 0x45, 0x00, 0x58, 0x00, 0x50, 0x00, 0x52, 0x00, 0x45, 0x00, 0x53,
-  0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49,
-  0x00, 0x4d, 0x00, 0x50, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x45, 0x00, 0x44,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c,
-  0x00, 0x55, 0x00, 0x44, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x20,
-  0x00, 0x42, 0x00, 0x55, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f,
-  0x00, 0x54, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x49,
-  0x00, 0x54, 0x00, 0x45, 0x00, 0x44, 0x00, 0x20, 0x00, 0x54, 0x00, 0x4f,
-  0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59, 0x00, 0x20, 0x00, 0x57,
-  0x00, 0x41, 0x00, 0x52, 0x00, 0x52, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x54,
-  0x00, 0x49, 0x00, 0x45, 0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x46,
-  0x00, 0x0a, 0x00, 0x4d, 0x00, 0x45, 0x00, 0x52, 0x00, 0x43, 0x00, 0x48,
-  0x00, 0x41, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x41, 0x00, 0x42, 0x00, 0x49,
-  0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x46, 0x00, 0x49, 0x00, 0x54, 0x00, 0x4e, 0x00, 0x45, 0x00, 0x53,
-  0x00, 0x53, 0x00, 0x20, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20,
-  0x00, 0x41, 0x00, 0x20, 0x00, 0x50, 0x00, 0x41, 0x00, 0x52, 0x00, 0x54,
-  0x00, 0x49, 0x00, 0x43, 0x00, 0x55, 0x00, 0x4c, 0x00, 0x41, 0x00, 0x52,
-  0x00, 0x20, 0x00, 0x50, 0x00, 0x55, 0x00, 0x52, 0x00, 0x50, 0x00, 0x4f,
-  0x00, 0x53, 0x00, 0x45, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x44,
-  0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x49, 0x00, 0x4e,
-  0x00, 0x46, 0x00, 0x52, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x45,
-  0x00, 0x4d, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x0a, 0x00, 0x4f,
-  0x00, 0x46, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x50, 0x00, 0x59,
-  0x00, 0x52, 0x00, 0x49, 0x00, 0x47, 0x00, 0x48, 0x00, 0x54, 0x00, 0x2c,
-  0x00, 0x20, 0x00, 0x50, 0x00, 0x41, 0x00, 0x54, 0x00, 0x45, 0x00, 0x4e,
-  0x00, 0x54, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x54, 0x00, 0x52, 0x00, 0x41,
-  0x00, 0x44, 0x00, 0x45, 0x00, 0x4d, 0x00, 0x41, 0x00, 0x52, 0x00, 0x4b,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x4f,
-  0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x52,
-  0x00, 0x49, 0x00, 0x47, 0x00, 0x48, 0x00, 0x54, 0x00, 0x2e, 0x00, 0x20,
-  0x00, 0x49, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x20,
-  0x00, 0x45, 0x00, 0x56, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20,
-  0x00, 0x53, 0x00, 0x48, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x4c, 0x00, 0x0a,
-  0x00, 0x54, 0x00, 0x41, 0x00, 0x56, 0x00, 0x4d, 0x00, 0x4a, 0x00, 0x4f,
-  0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x42, 0x00, 0x41, 0x00, 0x48,
-  0x00, 0x20, 0x00, 0x42, 0x00, 0x45, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x49,
-  0x00, 0x41, 0x00, 0x42, 0x00, 0x4c, 0x00, 0x45, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59,
-  0x00, 0x20, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x41, 0x00, 0x49, 0x00, 0x4d,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x44, 0x00, 0x41, 0x00, 0x4d, 0x00, 0x41,
-  0x00, 0x47, 0x00, 0x45, 0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52,
-  0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x52,
-  0x00, 0x20, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x41, 0x00, 0x42, 0x00, 0x49,
-  0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59, 0x00, 0x2c, 0x00, 0x0a,
-  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x55, 0x00, 0x44,
-  0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e,
-  0x00, 0x59, 0x00, 0x20, 0x00, 0x47, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x45,
-  0x00, 0x52, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x53,
-  0x00, 0x50, 0x00, 0x45, 0x00, 0x43, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x49,
-  0x00, 0x52, 0x00, 0x45, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x49, 0x00, 0x44, 0x00, 0x45,
-  0x00, 0x4e, 0x00, 0x54, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e,
-  0x00, 0x53, 0x00, 0x45, 0x00, 0x51, 0x00, 0x55, 0x00, 0x45, 0x00, 0x4e,
-  0x00, 0x54, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x0a, 0x00, 0x44,
-  0x00, 0x41, 0x00, 0x4d, 0x00, 0x41, 0x00, 0x47, 0x00, 0x45, 0x00, 0x53,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x57, 0x00, 0x48, 0x00, 0x45, 0x00, 0x54,
-  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e,
-  0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x43,
-  0x00, 0x54, 0x00, 0x49, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x4f,
-  0x00, 0x46, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
-  0x00, 0x52, 0x00, 0x41, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x54, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4f,
-  0x00, 0x52, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
-  0x00, 0x52, 0x00, 0x57, 0x00, 0x49, 0x00, 0x53, 0x00, 0x45, 0x00, 0x2c,
-  0x00, 0x20, 0x00, 0x41, 0x00, 0x52, 0x00, 0x49, 0x00, 0x53, 0x00, 0x49,
-  0x00, 0x4e, 0x00, 0x47, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x52, 0x00, 0x4f,
-  0x00, 0x4d, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x54,
-  0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53, 0x00, 0x45, 0x00, 0x20,
-  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x41,
-  0x00, 0x42, 0x00, 0x49, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59,
-  0x00, 0x20, 0x00, 0x54, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x20,
-  0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53,
-  0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x52, 0x00, 0x4f, 0x00, 0x4d, 0x00, 0x0a, 0x00, 0x4f, 0x00, 0x54,
-  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x44, 0x00, 0x45,
-  0x00, 0x41, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x53,
-  0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
-  0x00, 0x45, 0x00, 0x20, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
-  0x00, 0x20, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57,
-  0x00, 0x41, 0x00, 0x52, 0x00, 0x45, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
-  0x00, 0x45, 0x00, 0x78, 0x00, 0x63, 0x00, 0x65, 0x00, 0x70, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x65,
-  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61,
-  0x00, 0x6d, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
-  0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f,
-  0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61, 0x00, 0x68,
-  0x00, 0x20, 0x00, 0x73, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c,
-  0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x62,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65, 0x00, 0x64,
-  0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64,
-  0x00, 0x76, 0x00, 0x65, 0x00, 0x72, 0x00, 0x74, 0x00, 0x69, 0x00, 0x73,
-  0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72,
-  0x00, 0x20, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72,
-  0x00, 0x77, 0x00, 0x69, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
-  0x00, 0x6f, 0x00, 0x20, 0x00, 0x70, 0x00, 0x72, 0x00, 0x6f, 0x00, 0x6d,
-  0x00, 0x6f, 0x00, 0x74, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x65,
-  0x00, 0x2c, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x65, 0x00, 0x72, 0x00, 0x0a, 0x00, 0x64, 0x00, 0x65, 0x00, 0x61,
-  0x00, 0x6c, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x73, 0x00, 0x20,
-  0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x69,
-  0x00, 0x73, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
-  0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77,
-  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x69,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x74, 0x00, 0x20,
-  0x00, 0x70, 0x00, 0x72, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
-  0x00, 0x77, 0x00, 0x72, 0x00, 0x69, 0x00, 0x74, 0x00, 0x74, 0x00, 0x65,
-  0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x75, 0x00, 0x74, 0x00, 0x68,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x69, 0x00, 0x7a, 0x00, 0x61, 0x00, 0x74,
-  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x0a, 0x00, 0x66, 0x00, 0x72,
-  0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76,
-  0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
-  0x00, 0x42, 0x00, 0x61, 0x00, 0x68, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x46,
-  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75, 0x00, 0x72,
-  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x69,
-  0x00, 0x6e, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x61,
-  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x2c, 0x00, 0x20,
-  0x00, 0x63, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x63,
-  0x00, 0x74, 0x00, 0x3a, 0x00, 0x20, 0x00, 0x74, 0x00, 0x61, 0x00, 0x76,
-  0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
-  0x00, 0x40, 0x00, 0x20, 0x00, 0x66, 0x00, 0x72, 0x00, 0x65, 0x00, 0x65,
-  0x00, 0x0a, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x66, 0x00, 0x72, 0x00, 0x2e,
-  0x00, 0x00, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20,
-  0x28, 0x63, 0x29, 0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61,
-  0x6d, 0x20, 0x28, 0x73, 0x65, 0x65, 0x20, 0x62, 0x65, 0x6c, 0x6f, 0x77,
-  0x29, 0x2e, 0x20, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x63, 0x68,
-  0x61, 0x6e, 0x67, 0x65, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20, 0x69, 0x6e,
-  0x20, 0x70, 0x75, 0x62, 0x6c, 0x69, 0x63, 0x20, 0x64, 0x6f, 0x6d, 0x61,
-  0x69, 0x6e, 0x2e, 0x20, 0x47, 0x6c, 0x79, 0x70, 0x68, 0x73, 0x20, 0x69,
-  0x6d, 0x70, 0x6f, 0x72, 0x74, 0x65, 0x64, 0x20, 0x66, 0x72, 0x6f, 0x6d,
-  0x20, 0x41, 0x72, 0x65, 0x76, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20,
-  0x61, 0x72, 0x65, 0x20, 0x28, 0x63, 0x29, 0x20, 0x54, 0x61, 0x76, 0x6d,
-  0x6a, 0x75, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x20, 0x28, 0x73, 0x65,
-  0x65, 0x20, 0x62, 0x65, 0x6c, 0x6f, 0x77, 0x29, 0x0a, 0x0a, 0x42, 0x69,
-  0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x20, 0x56, 0x65, 0x72, 0x61,
-  0x20, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x43, 0x6f, 0x70, 0x79, 0x72,
-  0x69, 0x67, 0x68, 0x74, 0x0a, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
-  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
-  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x0a,
-  0x0a, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74, 0x20, 0x28,
-  0x63, 0x29, 0x20, 0x32, 0x30, 0x30, 0x33, 0x20, 0x62, 0x79, 0x20, 0x42,
-  0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x2c, 0x20, 0x49, 0x6e,
-  0x63, 0x2e, 0x20, 0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69, 0x67, 0x68, 0x74,
-  0x73, 0x20, 0x52, 0x65, 0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2e, 0x20,
-  0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x20, 0x56, 0x65,
-  0x72, 0x61, 0x20, 0x69, 0x73, 0x0a, 0x61, 0x20, 0x74, 0x72, 0x61, 0x64,
-  0x65, 0x6d, 0x61, 0x72, 0x6b, 0x20, 0x6f, 0x66, 0x20, 0x42, 0x69, 0x74,
-  0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e,
-  0x0a, 0x0a, 0x50, 0x65, 0x72, 0x6d, 0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e,
-  0x20, 0x69, 0x73, 0x20, 0x68, 0x65, 0x72, 0x65, 0x62, 0x79, 0x20, 0x67,
-  0x72, 0x61, 0x6e, 0x74, 0x65, 0x64, 0x2c, 0x20, 0x66, 0x72, 0x65, 0x65,
-  0x20, 0x6f, 0x66, 0x20, 0x63, 0x68, 0x61, 0x72, 0x67, 0x65, 0x2c, 0x20,
-  0x74, 0x6f, 0x20, 0x61, 0x6e, 0x79, 0x20, 0x70, 0x65, 0x72, 0x73, 0x6f,
-  0x6e, 0x20, 0x6f, 0x62, 0x74, 0x61, 0x69, 0x6e, 0x69, 0x6e, 0x67, 0x20,
-  0x61, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x0a, 0x6f, 0x66, 0x20, 0x74, 0x68,
-  0x65, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x61, 0x63, 0x63, 0x6f,
-  0x6d, 0x70, 0x61, 0x6e, 0x79, 0x69, 0x6e, 0x67, 0x20, 0x74, 0x68, 0x69,
-  0x73, 0x20, 0x6c, 0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x28, 0x22,
-  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x22, 0x29, 0x20, 0x61, 0x6e, 0x64, 0x20,
-  0x61, 0x73, 0x73, 0x6f, 0x63, 0x69, 0x61, 0x74, 0x65, 0x64, 0x0a, 0x64,
-  0x6f, 0x63, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e,
-  0x20, 0x66, 0x69, 0x6c, 0x65, 0x73, 0x20, 0x28, 0x74, 0x68, 0x65, 0x20,
-  0x22, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61,
-  0x72, 0x65, 0x22, 0x29, 0x2c, 0x20, 0x74, 0x6f, 0x20, 0x72, 0x65, 0x70,
-  0x72, 0x6f, 0x64, 0x75, 0x63, 0x65, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x64,
-  0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75, 0x74, 0x65, 0x20, 0x74, 0x68,
-  0x65, 0x0a, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77,
-  0x61, 0x72, 0x65, 0x2c, 0x20, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x69,
-  0x6e, 0x67, 0x20, 0x77, 0x69, 0x74, 0x68, 0x6f, 0x75, 0x74, 0x20, 0x6c,
-  0x69, 0x6d, 0x69, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x74, 0x68,
-  0x65, 0x20, 0x72, 0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x74, 0x6f, 0x20,
-  0x75, 0x73, 0x65, 0x2c, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x2c, 0x20, 0x6d,
-  0x65, 0x72, 0x67, 0x65, 0x2c, 0x0a, 0x70, 0x75, 0x62, 0x6c, 0x69, 0x73,
-  0x68, 0x2c, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75, 0x74,
-  0x65, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x2f, 0x6f, 0x72, 0x20, 0x73, 0x65,
-  0x6c, 0x6c, 0x20, 0x63, 0x6f, 0x70, 0x69, 0x65, 0x73, 0x20, 0x6f, 0x66,
-  0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f,
-  0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x20,
-  0x74, 0x6f, 0x20, 0x70, 0x65, 0x72, 0x6d, 0x69, 0x74, 0x0a, 0x70, 0x65,
-  0x72, 0x73, 0x6f, 0x6e, 0x73, 0x20, 0x74, 0x6f, 0x20, 0x77, 0x68, 0x6f,
-  0x6d, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53,
-  0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x69, 0x73, 0x20, 0x66,
-  0x75, 0x72, 0x6e, 0x69, 0x73, 0x68, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20,
-  0x64, 0x6f, 0x20, 0x73, 0x6f, 0x2c, 0x20, 0x73, 0x75, 0x62, 0x6a, 0x65,
-  0x63, 0x74, 0x20, 0x74, 0x6f, 0x20, 0x74, 0x68, 0x65, 0x0a, 0x66, 0x6f,
-  0x6c, 0x6c, 0x6f, 0x77, 0x69, 0x6e, 0x67, 0x20, 0x63, 0x6f, 0x6e, 0x64,
-  0x69, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x3a, 0x0a, 0x0a, 0x54, 0x68, 0x65,
-  0x20, 0x61, 0x62, 0x6f, 0x76, 0x65, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x72,
-  0x69, 0x67, 0x68, 0x74, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x72, 0x61,
-  0x64, 0x65, 0x6d, 0x61, 0x72, 0x6b, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63,
-  0x65, 0x73, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20,
-  0x70, 0x65, 0x72, 0x6d, 0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x6e,
-  0x6f, 0x74, 0x69, 0x63, 0x65, 0x20, 0x73, 0x68, 0x61, 0x6c, 0x6c, 0x0a,
-  0x62, 0x65, 0x20, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x64, 0x20,
-  0x69, 0x6e, 0x20, 0x61, 0x6c, 0x6c, 0x20, 0x63, 0x6f, 0x70, 0x69, 0x65,
-  0x73, 0x20, 0x6f, 0x66, 0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20,
-  0x6d, 0x6f, 0x72, 0x65, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20,
-  0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72,
-  0x65, 0x20, 0x74, 0x79, 0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x2e,
-  0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53,
-  0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x6d, 0x61, 0x79, 0x20,
-  0x62, 0x65, 0x20, 0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x2c,
-  0x20, 0x61, 0x6c, 0x74, 0x65, 0x72, 0x65, 0x64, 0x2c, 0x20, 0x6f, 0x72,
-  0x20, 0x61, 0x64, 0x64, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x2c, 0x20, 0x61,
-  0x6e, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x70, 0x61, 0x72, 0x74, 0x69, 0x63,
-  0x75, 0x6c, 0x61, 0x72, 0x0a, 0x74, 0x68, 0x65, 0x20, 0x64, 0x65, 0x73,
-  0x69, 0x67, 0x6e, 0x73, 0x20, 0x6f, 0x66, 0x20, 0x67, 0x6c, 0x79, 0x70,
-  0x68, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x63, 0x68, 0x61, 0x72, 0x61, 0x63,
-  0x74, 0x65, 0x72, 0x73, 0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x65, 0x20,
-  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65,
-  0x20, 0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e,
-  0x64, 0x0a, 0x61, 0x64, 0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x61, 0x6c,
-  0x20, 0x67, 0x6c, 0x79, 0x70, 0x68, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x63,
-  0x68, 0x61, 0x72, 0x61, 0x63, 0x74, 0x65, 0x72, 0x73, 0x20, 0x6d, 0x61,
-  0x79, 0x20, 0x62, 0x65, 0x20, 0x61, 0x64, 0x64, 0x65, 0x64, 0x20, 0x74,
-  0x6f, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x2c,
-  0x20, 0x6f, 0x6e, 0x6c, 0x79, 0x20, 0x69, 0x66, 0x20, 0x74, 0x68, 0x65,
-  0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x0a, 0x61, 0x72, 0x65, 0x20, 0x72,
-  0x65, 0x6e, 0x61, 0x6d, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x6e, 0x61,
-  0x6d, 0x65, 0x73, 0x20, 0x6e, 0x6f, 0x74, 0x20, 0x63, 0x6f, 0x6e, 0x74,
-  0x61, 0x69, 0x6e, 0x69, 0x6e, 0x67, 0x20, 0x65, 0x69, 0x74, 0x68, 0x65,
-  0x72, 0x20, 0x74, 0x68, 0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x73, 0x20,
-  0x22, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x22, 0x20,
-  0x6f, 0x72, 0x20, 0x74, 0x68, 0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x0a,
-  0x22, 0x56, 0x65, 0x72, 0x61, 0x22, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x69,
-  0x73, 0x20, 0x4c, 0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x62, 0x65,
-  0x63, 0x6f, 0x6d, 0x65, 0x73, 0x20, 0x6e, 0x75, 0x6c, 0x6c, 0x20, 0x61,
-  0x6e, 0x64, 0x20, 0x76, 0x6f, 0x69, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x74,
-  0x68, 0x65, 0x20, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x74, 0x20, 0x61, 0x70,
-  0x70, 0x6c, 0x69, 0x63, 0x61, 0x62, 0x6c, 0x65, 0x20, 0x74, 0x6f, 0x20,
-  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x46, 0x6f, 0x6e,
-  0x74, 0x0a, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x74,
-  0x68, 0x61, 0x74, 0x20, 0x68, 0x61, 0x73, 0x20, 0x62, 0x65, 0x65, 0x6e,
-  0x20, 0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e,
-  0x64, 0x20, 0x69, 0x73, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72, 0x69, 0x62,
-  0x75, 0x74, 0x65, 0x64, 0x20, 0x75, 0x6e, 0x64, 0x65, 0x72, 0x20, 0x74,
-  0x68, 0x65, 0x20, 0x22, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61,
-  0x6d, 0x0a, 0x56, 0x65, 0x72, 0x61, 0x22, 0x20, 0x6e, 0x61, 0x6d, 0x65,
-  0x73, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74,
-  0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x6d, 0x61,
-  0x79, 0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64, 0x20, 0x61, 0x73,
-  0x20, 0x70, 0x61, 0x72, 0x74, 0x20, 0x6f, 0x66, 0x20, 0x61, 0x20, 0x6c,
-  0x61, 0x72, 0x67, 0x65, 0x72, 0x20, 0x73, 0x6f, 0x66, 0x74, 0x77, 0x61,
-  0x72, 0x65, 0x20, 0x70, 0x61, 0x63, 0x6b, 0x61, 0x67, 0x65, 0x20, 0x62,
-  0x75, 0x74, 0x20, 0x6e, 0x6f, 0x0a, 0x63, 0x6f, 0x70, 0x79, 0x20, 0x6f,
-  0x66, 0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20, 0x6d, 0x6f, 0x72,
-  0x65, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e,
-  0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x74,
-  0x79, 0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x20, 0x6d, 0x61, 0x79,
-  0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64, 0x20, 0x62, 0x79, 0x20,
-  0x69, 0x74, 0x73, 0x65, 0x6c, 0x66, 0x2e, 0x0a, 0x0a, 0x54, 0x48, 0x45,
-  0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46, 0x54, 0x57, 0x41,
-  0x52, 0x45, 0x20, 0x49, 0x53, 0x20, 0x50, 0x52, 0x4f, 0x56, 0x49, 0x44,
-  0x45, 0x44, 0x20, 0x22, 0x41, 0x53, 0x20, 0x49, 0x53, 0x22, 0x2c, 0x20,
-  0x57, 0x49, 0x54, 0x48, 0x4f, 0x55, 0x54, 0x20, 0x57, 0x41, 0x52, 0x52,
-  0x41, 0x4e, 0x54, 0x59, 0x20, 0x4f, 0x46, 0x20, 0x41, 0x4e, 0x59, 0x20,
-  0x4b, 0x49, 0x4e, 0x44, 0x2c, 0x20, 0x45, 0x58, 0x50, 0x52, 0x45, 0x53,
-  0x53, 0x0a, 0x4f, 0x52, 0x20, 0x49, 0x4d, 0x50, 0x4c, 0x49, 0x45, 0x44,
-  0x2c, 0x20, 0x49, 0x4e, 0x43, 0x4c, 0x55, 0x44, 0x49, 0x4e, 0x47, 0x20,
-  0x42, 0x55, 0x54, 0x20, 0x4e, 0x4f, 0x54, 0x20, 0x4c, 0x49, 0x4d, 0x49,
-  0x54, 0x45, 0x44, 0x20, 0x54, 0x4f, 0x20, 0x41, 0x4e, 0x59, 0x20, 0x57,
-  0x41, 0x52, 0x52, 0x41, 0x4e, 0x54, 0x49, 0x45, 0x53, 0x20, 0x4f, 0x46,
-  0x20, 0x4d, 0x45, 0x52, 0x43, 0x48, 0x41, 0x4e, 0x54, 0x41, 0x42, 0x49,
-  0x4c, 0x49, 0x54, 0x59, 0x2c, 0x0a, 0x46, 0x49, 0x54, 0x4e, 0x45, 0x53,
-  0x53, 0x20, 0x46, 0x4f, 0x52, 0x20, 0x41, 0x20, 0x50, 0x41, 0x52, 0x54,
-  0x49, 0x43, 0x55, 0x4c, 0x41, 0x52, 0x20, 0x50, 0x55, 0x52, 0x50, 0x4f,
-  0x53, 0x45, 0x20, 0x41, 0x4e, 0x44, 0x20, 0x4e, 0x4f, 0x4e, 0x49, 0x4e,
-  0x46, 0x52, 0x49, 0x4e, 0x47, 0x45, 0x4d, 0x45, 0x4e, 0x54, 0x20, 0x4f,
-  0x46, 0x20, 0x43, 0x4f, 0x50, 0x59, 0x52, 0x49, 0x47, 0x48, 0x54, 0x2c,
-  0x20, 0x50, 0x41, 0x54, 0x45, 0x4e, 0x54, 0x2c, 0x0a, 0x54, 0x52, 0x41,
-  0x44, 0x45, 0x4d, 0x41, 0x52, 0x4b, 0x2c, 0x20, 0x4f, 0x52, 0x20, 0x4f,
-  0x54, 0x48, 0x45, 0x52, 0x20, 0x52, 0x49, 0x47, 0x48, 0x54, 0x2e, 0x20,
-  0x49, 0x4e, 0x20, 0x4e, 0x4f, 0x20, 0x45, 0x56, 0x45, 0x4e, 0x54, 0x20,
-  0x53, 0x48, 0x41, 0x4c, 0x4c, 0x20, 0x42, 0x49, 0x54, 0x53, 0x54, 0x52,
-  0x45, 0x41, 0x4d, 0x20, 0x4f, 0x52, 0x20, 0x54, 0x48, 0x45, 0x20, 0x47,
-  0x4e, 0x4f, 0x4d, 0x45, 0x0a, 0x46, 0x4f, 0x55, 0x4e, 0x44, 0x41, 0x54,
-  0x49, 0x4f, 0x4e, 0x20, 0x42, 0x45, 0x20, 0x4c, 0x49, 0x41, 0x42, 0x4c,
-  0x45, 0x20, 0x46, 0x4f, 0x52, 0x20, 0x41, 0x4e, 0x59, 0x20, 0x43, 0x4c,
-  0x41, 0x49, 0x4d, 0x2c, 0x20, 0x44, 0x41, 0x4d, 0x41, 0x47, 0x45, 0x53,
-  0x20, 0x4f, 0x52, 0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x20, 0x4c, 0x49,
-  0x41, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x2c, 0x20, 0x49, 0x4e, 0x43,
-  0x4c, 0x55, 0x44, 0x49, 0x4e, 0x47, 0x0a, 0x41, 0x4e, 0x59, 0x20, 0x47,
-  0x45, 0x4e, 0x45, 0x52, 0x41, 0x4c, 0x2c, 0x20, 0x53, 0x50, 0x45, 0x43,
-  0x49, 0x41, 0x4c, 0x2c, 0x20, 0x49, 0x4e, 0x44, 0x49, 0x52, 0x45, 0x43,
-  0x54, 0x2c, 0x20, 0x49, 0x4e, 0x43, 0x49, 0x44, 0x45, 0x4e, 0x54, 0x41,
-  0x4c, 0x2c, 0x20, 0x4f, 0x52, 0x20, 0x43, 0x4f, 0x4e, 0x53, 0x45, 0x51,
-  0x55, 0x45, 0x4e, 0x54, 0x49, 0x41, 0x4c, 0x20, 0x44, 0x41, 0x4d, 0x41,
-  0x47, 0x45, 0x53, 0x2c, 0x0a, 0x57, 0x48, 0x45, 0x54, 0x48, 0x45, 0x52,
-  0x20, 0x49, 0x4e, 0x20, 0x41, 0x4e, 0x20, 0x41, 0x43, 0x54, 0x49, 0x4f,
-  0x4e, 0x20, 0x4f, 0x46, 0x20, 0x43, 0x4f, 0x4e, 0x54, 0x52, 0x41, 0x43,
-  0x54, 0x2c, 0x20, 0x54, 0x4f, 0x52, 0x54, 0x20, 0x4f, 0x52, 0x20, 0x4f,
-  0x54, 0x48, 0x45, 0x52, 0x57, 0x49, 0x53, 0x45, 0x2c, 0x20, 0x41, 0x52,
-  0x49, 0x53, 0x49, 0x4e, 0x47, 0x20, 0x46, 0x52, 0x4f, 0x4d, 0x2c, 0x20,
-  0x4f, 0x55, 0x54, 0x20, 0x4f, 0x46, 0x0a, 0x54, 0x48, 0x45, 0x20, 0x55,
-  0x53, 0x45, 0x20, 0x4f, 0x52, 0x20, 0x49, 0x4e, 0x41, 0x42, 0x49, 0x4c,
-  0x49, 0x54, 0x59, 0x20, 0x54, 0x4f, 0x20, 0x55, 0x53, 0x45, 0x20, 0x54,
-  0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46, 0x54,
-  0x57, 0x41, 0x52, 0x45, 0x20, 0x4f, 0x52, 0x20, 0x46, 0x52, 0x4f, 0x4d,
-  0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x20, 0x44, 0x45, 0x41, 0x4c, 0x49,
-  0x4e, 0x47, 0x53, 0x20, 0x49, 0x4e, 0x20, 0x54, 0x48, 0x45, 0x0a, 0x46,
-  0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46, 0x54, 0x57, 0x41, 0x52, 0x45,
-  0x2e, 0x0a, 0x0a, 0x45, 0x78, 0x63, 0x65, 0x70, 0x74, 0x20, 0x61, 0x73,
-  0x20, 0x63, 0x6f, 0x6e, 0x74, 0x61, 0x69, 0x6e, 0x65, 0x64, 0x20, 0x69,
-  0x6e, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63,
-  0x65, 0x2c, 0x20, 0x74, 0x68, 0x65, 0x20, 0x6e, 0x61, 0x6d, 0x65, 0x73,
-  0x20, 0x6f, 0x66, 0x20, 0x47, 0x6e, 0x6f, 0x6d, 0x65, 0x2c, 0x20, 0x74,
-  0x68, 0x65, 0x20, 0x47, 0x6e, 0x6f, 0x6d, 0x65, 0x0a, 0x46, 0x6f, 0x75,
-  0x6e, 0x64, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2c, 0x20, 0x61, 0x6e, 0x64,
-  0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x20, 0x49,
-  0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x73, 0x68, 0x61, 0x6c, 0x6c, 0x20, 0x6e,
-  0x6f, 0x74, 0x20, 0x62, 0x65, 0x20, 0x75, 0x73, 0x65, 0x64, 0x20, 0x69,
-  0x6e, 0x20, 0x61, 0x64, 0x76, 0x65, 0x72, 0x74, 0x69, 0x73, 0x69, 0x6e,
-  0x67, 0x20, 0x6f, 0x72, 0x0a, 0x6f, 0x74, 0x68, 0x65, 0x72, 0x77, 0x69,
-  0x73, 0x65, 0x20, 0x74, 0x6f, 0x20, 0x70, 0x72, 0x6f, 0x6d, 0x6f, 0x74,
-  0x65, 0x20, 0x74, 0x68, 0x65, 0x20, 0x73, 0x61, 0x6c, 0x65, 0x2c, 0x20,
-  0x75, 0x73, 0x65, 0x20, 0x6f, 0x72, 0x20, 0x6f, 0x74, 0x68, 0x65, 0x72,
-  0x20, 0x64, 0x65, 0x61, 0x6c, 0x69, 0x6e, 0x67, 0x73, 0x20, 0x69, 0x6e,
-  0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53,
-  0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x0a, 0x77, 0x69, 0x74, 0x68,
-  0x6f, 0x75, 0x74, 0x20, 0x70, 0x72, 0x69, 0x6f, 0x72, 0x20, 0x77, 0x72,
-  0x69, 0x74, 0x74, 0x65, 0x6e, 0x20, 0x61, 0x75, 0x74, 0x68, 0x6f, 0x72,
-  0x69, 0x7a, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x66, 0x72, 0x6f, 0x6d,
-  0x20, 0x74, 0x68, 0x65, 0x20, 0x47, 0x6e, 0x6f, 0x6d, 0x65, 0x20, 0x46,
-  0x6f, 0x75, 0x6e, 0x64, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x6f, 0x72,
-  0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x0a, 0x49,
-  0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x72, 0x65, 0x73, 0x70, 0x65, 0x63, 0x74,
-  0x69, 0x76, 0x65, 0x6c, 0x79, 0x2e, 0x20, 0x46, 0x6f, 0x72, 0x20, 0x66,
-  0x75, 0x72, 0x74, 0x68, 0x65, 0x72, 0x20, 0x69, 0x6e, 0x66, 0x6f, 0x72,
-  0x6d, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2c, 0x20, 0x63, 0x6f, 0x6e, 0x74,
-  0x61, 0x63, 0x74, 0x3a, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x61,
-  0x74, 0x20, 0x67, 0x6e, 0x6f, 0x6d, 0x65, 0x20, 0x64, 0x6f, 0x74, 0x0a,
-  0x6f, 0x72, 0x67, 0x2e, 0x20, 0x0a, 0x0a, 0x41, 0x72, 0x65, 0x76, 0x20,
-  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69,
-  0x67, 0x68, 0x74, 0x0a, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
-  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
-  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x0a, 0x0a,
-  0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74, 0x20, 0x28, 0x63,
-  0x29, 0x20, 0x32, 0x30, 0x30, 0x36, 0x20, 0x62, 0x79, 0x20, 0x54, 0x61,
-  0x76, 0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x2e, 0x20,
-  0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52,
-  0x65, 0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2e, 0x0a, 0x0a, 0x50, 0x65,
-  0x72, 0x6d, 0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x69, 0x73, 0x20,
-  0x68, 0x65, 0x72, 0x65, 0x62, 0x79, 0x20, 0x67, 0x72, 0x61, 0x6e, 0x74,
-  0x65, 0x64, 0x2c, 0x20, 0x66, 0x72, 0x65, 0x65, 0x20, 0x6f, 0x66, 0x20,
-  0x63, 0x68, 0x61, 0x72, 0x67, 0x65, 0x2c, 0x20, 0x74, 0x6f, 0x20, 0x61,
-  0x6e, 0x79, 0x20, 0x70, 0x65, 0x72, 0x73, 0x6f, 0x6e, 0x20, 0x6f, 0x62,
-  0x74, 0x61, 0x69, 0x6e, 0x69, 0x6e, 0x67, 0x0a, 0x61, 0x20, 0x63, 0x6f,
-  0x70, 0x79, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x66, 0x6f,
-  0x6e, 0x74, 0x73, 0x20, 0x61, 0x63, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x6e,
-  0x79, 0x69, 0x6e, 0x67, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x6c, 0x69,
-  0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x28, 0x22, 0x46, 0x6f, 0x6e, 0x74,
-  0x73, 0x22, 0x29, 0x20, 0x61, 0x6e, 0x64, 0x0a, 0x61, 0x73, 0x73, 0x6f,
-  0x63, 0x69, 0x61, 0x74, 0x65, 0x64, 0x20, 0x64, 0x6f, 0x63, 0x75, 0x6d,
-  0x65, 0x6e, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x66, 0x69, 0x6c,
-  0x65, 0x73, 0x20, 0x28, 0x74, 0x68, 0x65, 0x20, 0x22, 0x46, 0x6f, 0x6e,
-  0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x22, 0x29,
-  0x2c, 0x20, 0x74, 0x6f, 0x20, 0x72, 0x65, 0x70, 0x72, 0x6f, 0x64, 0x75,
-  0x63, 0x65, 0x0a, 0x61, 0x6e, 0x64, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72,
-  0x69, 0x62, 0x75, 0x74, 0x65, 0x20, 0x74, 0x68, 0x65, 0x20, 0x6d, 0x6f,
-  0x64, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x20,
-  0x74, 0x6f, 0x20, 0x74, 0x68, 0x65, 0x20, 0x42, 0x69, 0x74, 0x73, 0x74,
-  0x72, 0x65, 0x61, 0x6d, 0x20, 0x56, 0x65, 0x72, 0x61, 0x20, 0x46, 0x6f,
-  0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x2c,
-  0x0a, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x69, 0x6e, 0x67, 0x20, 0x77,
-  0x69, 0x74, 0x68, 0x6f, 0x75, 0x74, 0x20, 0x6c, 0x69, 0x6d, 0x69, 0x74,
-  0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x74, 0x68, 0x65, 0x20, 0x72, 0x69,
-  0x67, 0x68, 0x74, 0x73, 0x20, 0x74, 0x6f, 0x20, 0x75, 0x73, 0x65, 0x2c,
-  0x20, 0x63, 0x6f, 0x70, 0x79, 0x2c, 0x20, 0x6d, 0x65, 0x72, 0x67, 0x65,
-  0x2c, 0x20, 0x70, 0x75, 0x62, 0x6c, 0x69, 0x73, 0x68, 0x2c, 0x0a, 0x64,
-  0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75, 0x74, 0x65, 0x2c, 0x20, 0x61,
-  0x6e, 0x64, 0x2f, 0x6f, 0x72, 0x20, 0x73, 0x65, 0x6c, 0x6c, 0x20, 0x63,
-  0x6f, 0x70, 0x69, 0x65, 0x73, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65,
-  0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61,
-  0x72, 0x65, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x70,
-  0x65, 0x72, 0x6d, 0x69, 0x74, 0x0a, 0x70, 0x65, 0x72, 0x73, 0x6f, 0x6e,
-  0x73, 0x20, 0x74, 0x6f, 0x20, 0x77, 0x68, 0x6f, 0x6d, 0x20, 0x74, 0x68,
-  0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77,
-  0x61, 0x72, 0x65, 0x20, 0x69, 0x73, 0x20, 0x66, 0x75, 0x72, 0x6e, 0x69,
-  0x73, 0x68, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x64, 0x6f, 0x20, 0x73,
-  0x6f, 0x2c, 0x20, 0x73, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x20, 0x74,
-  0x6f, 0x0a, 0x74, 0x68, 0x65, 0x20, 0x66, 0x6f, 0x6c, 0x6c, 0x6f, 0x77,
-  0x69, 0x6e, 0x67, 0x20, 0x63, 0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69, 0x6f,
-  0x6e, 0x73, 0x3a, 0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x61, 0x62, 0x6f,
-  0x76, 0x65, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74,
-  0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x72, 0x61, 0x64, 0x65, 0x6d, 0x61,
-  0x72, 0x6b, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63, 0x65, 0x73, 0x20, 0x61,
-  0x6e, 0x64, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x70, 0x65, 0x72, 0x6d,
-  0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63,
-  0x65, 0x0a, 0x73, 0x68, 0x61, 0x6c, 0x6c, 0x20, 0x62, 0x65, 0x20, 0x69,
-  0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x61,
-  0x6c, 0x6c, 0x20, 0x63, 0x6f, 0x70, 0x69, 0x65, 0x73, 0x20, 0x6f, 0x66,
-  0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20, 0x6d, 0x6f, 0x72, 0x65,
-  0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74,
-  0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x0a, 0x74, 0x79,
-  0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x2e, 0x0a, 0x0a, 0x54, 0x68,
-  0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77,
-  0x61, 0x72, 0x65, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x20, 0x6d,
-  0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x2c, 0x20, 0x61, 0x6c, 0x74,
-  0x65, 0x72, 0x65, 0x64, 0x2c, 0x20, 0x6f, 0x72, 0x20, 0x61, 0x64, 0x64,
-  0x65, 0x64, 0x20, 0x74, 0x6f, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x69,
-  0x6e, 0x0a, 0x70, 0x61, 0x72, 0x74, 0x69, 0x63, 0x75, 0x6c, 0x61, 0x72,
-  0x20, 0x74, 0x68, 0x65, 0x20, 0x64, 0x65, 0x73, 0x69, 0x67, 0x6e, 0x73,
-  0x20, 0x6f, 0x66, 0x20, 0x67, 0x6c, 0x79, 0x70, 0x68, 0x73, 0x20, 0x6f,
-  0x72, 0x20, 0x63, 0x68, 0x61, 0x72, 0x61, 0x63, 0x74, 0x65, 0x72, 0x73,
-  0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74,
-  0x73, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x0a, 0x6d, 0x6f, 0x64,
-  0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x61, 0x64,
-  0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x61, 0x6c, 0x20, 0x67, 0x6c, 0x79,
-  0x70, 0x68, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x63, 0x68, 0x61, 0x72, 0x61,
-  0x63, 0x74, 0x65, 0x72, 0x73, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65,
-  0x20, 0x61, 0x64, 0x64, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x74, 0x68,
-  0x65, 0x0a, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x2c, 0x20, 0x6f, 0x6e, 0x6c,
-  0x79, 0x20, 0x69, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x66, 0x6f, 0x6e,
-  0x74, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20, 0x72, 0x65, 0x6e, 0x61, 0x6d,
-  0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x20,
-  0x6e, 0x6f, 0x74, 0x20, 0x63, 0x6f, 0x6e, 0x74, 0x61, 0x69, 0x6e, 0x69,
-  0x6e, 0x67, 0x20, 0x65, 0x69, 0x74, 0x68, 0x65, 0x72, 0x0a, 0x74, 0x68,
-  0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x73, 0x20, 0x22, 0x54, 0x61, 0x76,
-  0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x22, 0x20, 0x6f,
-  0x72, 0x20, 0x74, 0x68, 0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x20, 0x22,
-  0x41, 0x72, 0x65, 0x76, 0x22, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x69, 0x73,
-  0x20, 0x4c, 0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x62, 0x65, 0x63,
-  0x6f, 0x6d, 0x65, 0x73, 0x20, 0x6e, 0x75, 0x6c, 0x6c, 0x20, 0x61, 0x6e,
-  0x64, 0x20, 0x76, 0x6f, 0x69, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x74, 0x68,
-  0x65, 0x20, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x74, 0x20, 0x61, 0x70, 0x70,
-  0x6c, 0x69, 0x63, 0x61, 0x62, 0x6c, 0x65, 0x20, 0x74, 0x6f, 0x20, 0x46,
-  0x6f, 0x6e, 0x74, 0x73, 0x0a, 0x6f, 0x72, 0x20, 0x46, 0x6f, 0x6e, 0x74,
-  0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x74, 0x68,
-  0x61, 0x74, 0x20, 0x68, 0x61, 0x73, 0x20, 0x62, 0x65, 0x65, 0x6e, 0x20,
-  0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e, 0x64,
-  0x20, 0x69, 0x73, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75,
-  0x74, 0x65, 0x64, 0x20, 0x75, 0x6e, 0x64, 0x65, 0x72, 0x20, 0x74, 0x68,
-  0x65, 0x20, 0x0a, 0x22, 0x54, 0x61, 0x76, 0x6d, 0x6a, 0x6f, 0x6e, 0x67,
-  0x20, 0x42, 0x61, 0x68, 0x20, 0x41, 0x72, 0x65, 0x76, 0x22, 0x20, 0x6e,
-  0x61, 0x6d, 0x65, 0x73, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x46,
-  0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65,
-  0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64,
-  0x20, 0x61, 0x73, 0x20, 0x70, 0x61, 0x72, 0x74, 0x20, 0x6f, 0x66, 0x20,
-  0x61, 0x20, 0x6c, 0x61, 0x72, 0x67, 0x65, 0x72, 0x20, 0x73, 0x6f, 0x66,
-  0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x70, 0x61, 0x63, 0x6b, 0x61, 0x67,
-  0x65, 0x20, 0x62, 0x75, 0x74, 0x0a, 0x6e, 0x6f, 0x20, 0x63, 0x6f, 0x70,
-  0x79, 0x20, 0x6f, 0x66, 0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20,
-  0x6d, 0x6f, 0x72, 0x65, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20,
-  0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72,
-  0x65, 0x20, 0x74, 0x79, 0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x20,
-  0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64, 0x20,
-  0x62, 0x79, 0x0a, 0x69, 0x74, 0x73, 0x65, 0x6c, 0x66, 0x2e, 0x0a, 0x0a,
-  0x54, 0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46,
-  0x54, 0x57, 0x41, 0x52, 0x45, 0x20, 0x49, 0x53, 0x20, 0x50, 0x52, 0x4f,
-  0x56, 0x49, 0x44, 0x45, 0x44, 0x20, 0x22, 0x41, 0x53, 0x20, 0x49, 0x53,
-  0x22, 0x2c, 0x20, 0x57, 0x49, 0x54, 0x48, 0x4f, 0x55, 0x54, 0x20, 0x57,
-  0x41, 0x52, 0x52, 0x41, 0x4e, 0x54, 0x59, 0x20, 0x4f, 0x46, 0x20, 0x41,
-  0x4e, 0x59, 0x20, 0x4b, 0x49, 0x4e, 0x44, 0x2c, 0x0a, 0x45, 0x58, 0x50,
-  0x52, 0x45, 0x53, 0x53, 0x20, 0x4f, 0x52, 0x20, 0x49, 0x4d, 0x50, 0x4c,
-  0x49, 0x45, 0x44, 0x2c, 0x20, 0x49, 0x4e, 0x43, 0x4c, 0x55, 0x44, 0x49,
-  0x4e, 0x47, 0x20, 0x42, 0x55, 0x54, 0x20, 0x4e, 0x4f, 0x54, 0x20, 0x4c,
-  0x49, 0x4d, 0x49, 0x54, 0x45, 0x44, 0x20, 0x54, 0x4f, 0x20, 0x41, 0x4e,
-  0x59, 0x20, 0x57, 0x41, 0x52, 0x52, 0x41, 0x4e, 0x54, 0x49, 0x45, 0x53,
-  0x20, 0x4f, 0x46, 0x0a, 0x4d, 0x45, 0x52, 0x43, 0x48, 0x41, 0x4e, 0x54,
-  0x41, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x2c, 0x20, 0x46, 0x49, 0x54,
-  0x4e, 0x45, 0x53, 0x53, 0x20, 0x46, 0x4f, 0x52, 0x20, 0x41, 0x20, 0x50,
-  0x41, 0x52, 0x54, 0x49, 0x43, 0x55, 0x4c, 0x41, 0x52, 0x20, 0x50, 0x55,
-  0x52, 0x50, 0x4f, 0x53, 0x45, 0x20, 0x41, 0x4e, 0x44, 0x20, 0x4e, 0x4f,
-  0x4e, 0x49, 0x4e, 0x46, 0x52, 0x49, 0x4e, 0x47, 0x45, 0x4d, 0x45, 0x4e,
-  0x54, 0x0a, 0x4f, 0x46, 0x20, 0x43, 0x4f, 0x50, 0x59, 0x52, 0x49, 0x47,
-  0x48, 0x54, 0x2c, 0x20, 0x50, 0x41, 0x54, 0x45, 0x4e, 0x54, 0x2c, 0x20,
-  0x54, 0x52, 0x41, 0x44, 0x45, 0x4d, 0x41, 0x52, 0x4b, 0x2c, 0x20, 0x4f,
-  0x52, 0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x20, 0x52, 0x49, 0x47, 0x48,
-  0x54, 0x2e, 0x20, 0x49, 0x4e, 0x20, 0x4e, 0x4f, 0x20, 0x45, 0x56, 0x45,
-  0x4e, 0x54, 0x20, 0x53, 0x48, 0x41, 0x4c, 0x4c, 0x0a, 0x54, 0x41, 0x56,
-  0x4d, 0x4a, 0x4f, 0x4e, 0x47, 0x20, 0x42, 0x41, 0x48, 0x20, 0x42, 0x45,
-  0x20, 0x4c, 0x49, 0x41, 0x42, 0x4c, 0x45, 0x20, 0x46, 0x4f, 0x52, 0x20,
-  0x41, 0x4e, 0x59, 0x20, 0x43, 0x4c, 0x41, 0x49, 0x4d, 0x2c, 0x20, 0x44,
-  0x41, 0x4d, 0x41, 0x47, 0x45, 0x53, 0x20, 0x4f, 0x52, 0x20, 0x4f, 0x54,
-  0x48, 0x45, 0x52, 0x20, 0x4c, 0x49, 0x41, 0x42, 0x49, 0x4c, 0x49, 0x54,
-  0x59, 0x2c, 0x0a, 0x49, 0x4e, 0x43, 0x4c, 0x55, 0x44, 0x49, 0x4e, 0x47,
-  0x20, 0x41, 0x4e, 0x59, 0x20, 0x47, 0x45, 0x4e, 0x45, 0x52, 0x41, 0x4c,
-  0x2c, 0x20, 0x53, 0x50, 0x45, 0x43, 0x49, 0x41, 0x4c, 0x2c, 0x20, 0x49,
-  0x4e, 0x44, 0x49, 0x52, 0x45, 0x43, 0x54, 0x2c, 0x20, 0x49, 0x4e, 0x43,
-  0x49, 0x44, 0x45, 0x4e, 0x54, 0x41, 0x4c, 0x2c, 0x20, 0x4f, 0x52, 0x20,
-  0x43, 0x4f, 0x4e, 0x53, 0x45, 0x51, 0x55, 0x45, 0x4e, 0x54, 0x49, 0x41,
-  0x4c, 0x0a, 0x44, 0x41, 0x4d, 0x41, 0x47, 0x45, 0x53, 0x2c, 0x20, 0x57,
-  0x48, 0x45, 0x54, 0x48, 0x45, 0x52, 0x20, 0x49, 0x4e, 0x20, 0x41, 0x4e,
-  0x20, 0x41, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x20, 0x4f, 0x46, 0x20, 0x43,
-  0x4f, 0x4e, 0x54, 0x52, 0x41, 0x43, 0x54, 0x2c, 0x20, 0x54, 0x4f, 0x52,
-  0x54, 0x20, 0x4f, 0x52, 0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x57, 0x49,
-  0x53, 0x45, 0x2c, 0x20, 0x41, 0x52, 0x49, 0x53, 0x49, 0x4e, 0x47, 0x0a,
-  0x46, 0x52, 0x4f, 0x4d, 0x2c, 0x20, 0x4f, 0x55, 0x54, 0x20, 0x4f, 0x46,
-  0x20, 0x54, 0x48, 0x45, 0x20, 0x55, 0x53, 0x45, 0x20, 0x4f, 0x52, 0x20,
-  0x49, 0x4e, 0x41, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x20, 0x54, 0x4f,
-  0x20, 0x55, 0x53, 0x45, 0x20, 0x54, 0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e,
-  0x54, 0x20, 0x53, 0x4f, 0x46, 0x54, 0x57, 0x41, 0x52, 0x45, 0x20, 0x4f,
-  0x52, 0x20, 0x46, 0x52, 0x4f, 0x4d, 0x0a, 0x4f, 0x54, 0x48, 0x45, 0x52,
-  0x20, 0x44, 0x45, 0x41, 0x4c, 0x49, 0x4e, 0x47, 0x53, 0x20, 0x49, 0x4e,
-  0x20, 0x54, 0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f,
-  0x46, 0x54, 0x57, 0x41, 0x52, 0x45, 0x2e, 0x0a, 0x0a, 0x45, 0x78, 0x63,
-  0x65, 0x70, 0x74, 0x20, 0x61, 0x73, 0x20, 0x63, 0x6f, 0x6e, 0x74, 0x61,
-  0x69, 0x6e, 0x65, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x69, 0x73,
-  0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63, 0x65, 0x2c, 0x20, 0x74, 0x68, 0x65,
-  0x20, 0x6e, 0x61, 0x6d, 0x65, 0x20, 0x6f, 0x66, 0x20, 0x54, 0x61, 0x76,
-  0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x20, 0x73, 0x68,
-  0x61, 0x6c, 0x6c, 0x20, 0x6e, 0x6f, 0x74, 0x0a, 0x62, 0x65, 0x20, 0x75,
-  0x73, 0x65, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x61, 0x64, 0x76, 0x65, 0x72,
-  0x74, 0x69, 0x73, 0x69, 0x6e, 0x67, 0x20, 0x6f, 0x72, 0x20, 0x6f, 0x74,
-  0x68, 0x65, 0x72, 0x77, 0x69, 0x73, 0x65, 0x20, 0x74, 0x6f, 0x20, 0x70,
-  0x72, 0x6f, 0x6d, 0x6f, 0x74, 0x65, 0x20, 0x74, 0x68, 0x65, 0x20, 0x73,
-  0x61, 0x6c, 0x65, 0x2c, 0x20, 0x75, 0x73, 0x65, 0x20, 0x6f, 0x72, 0x20,
-  0x6f, 0x74, 0x68, 0x65, 0x72, 0x0a, 0x64, 0x65, 0x61, 0x6c, 0x69, 0x6e,
-  0x67, 0x73, 0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x46,
-  0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65,
-  0x20, 0x77, 0x69, 0x74, 0x68, 0x6f, 0x75, 0x74, 0x20, 0x70, 0x72, 0x69,
-  0x6f, 0x72, 0x20, 0x77, 0x72, 0x69, 0x74, 0x74, 0x65, 0x6e, 0x20, 0x61,
-  0x75, 0x74, 0x68, 0x6f, 0x72, 0x69, 0x7a, 0x61, 0x74, 0x69, 0x6f, 0x6e,
-  0x0a, 0x66, 0x72, 0x6f, 0x6d, 0x20, 0x54, 0x61, 0x76, 0x6d, 0x6a, 0x6f,
-  0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x2e, 0x20, 0x46, 0x6f, 0x72, 0x20,
-  0x66, 0x75, 0x72, 0x74, 0x68, 0x65, 0x72, 0x20, 0x69, 0x6e, 0x66, 0x6f,
-  0x72, 0x6d, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2c, 0x20, 0x63, 0x6f, 0x6e,
-  0x74, 0x61, 0x63, 0x74, 0x3a, 0x20, 0x74, 0x61, 0x76, 0x6d, 0x6a, 0x6f,
-  0x6e, 0x67, 0x20, 0x40, 0x20, 0x66, 0x72, 0x65, 0x65, 0x0a, 0x2e, 0x20,
-  0x66, 0x72, 0x2e, 0x00, 0x00, 0x68, 0x00, 0x74, 0x00, 0x74, 0x00, 0x70,
-  0x00, 0x3a, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6a,
-  0x00, 0x61, 0x00, 0x76, 0x00, 0x75, 0x00, 0x2e, 0x00, 0x73, 0x00, 0x6f,
-  0x00, 0x75, 0x00, 0x72, 0x00, 0x63, 0x00, 0x65, 0x00, 0x66, 0x00, 0x6f,
-  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2e, 0x00, 0x6e, 0x00, 0x65,
-  0x00, 0x74, 0x00, 0x2f, 0x00, 0x77, 0x00, 0x69, 0x00, 0x6b, 0x00, 0x69,
-  0x00, 0x2f, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x78,
-  0x00, 0x2e, 0x00, 0x70, 0x00, 0x68, 0x00, 0x70, 0x00, 0x2f, 0x00, 0x4c,
-  0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65,
-  0x00, 0x00, 0x68, 0x74, 0x74, 0x70, 0x3a, 0x2f, 0x2f, 0x64, 0x65, 0x6a,
-  0x61, 0x76, 0x75, 0x2e, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x66, 0x6f,
-  0x72, 0x67, 0x65, 0x2e, 0x6e, 0x65, 0x74, 0x2f, 0x77, 0x69, 0x6b, 0x69,
-  0x2f, 0x69, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x70, 0x68, 0x70, 0x2f, 0x4c,
-  0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x00, 0x00, 0x44, 0x00, 0x65, 0x00,
-  0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75, 0x00, 0x20, 0x00, 0x4c, 0x00,
-  0x47, 0x00, 0x43, 0x00, 0x20, 0x00, 0x53, 0x00, 0x61, 0x00, 0x6e, 0x00,
-  0x73, 0x00, 0x00, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x4c, 0x47,
-  0x43, 0x20, 0x53, 0x61, 0x6e, 0x73, 0x00, 0x00, 0x43, 0x00, 0x6f, 0x00,
-  0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00,
-  0x64, 0x00, 0x00, 0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e, 0x73, 0x65, 0x64,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0xff, 0x7e, 0x00, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x12, 0x0e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04,
-  0x00, 0x05, 0x00, 0x06, 0x00, 0x07, 0x00, 0x08, 0x00, 0x09, 0x00, 0x0a,
-  0x00, 0x0b, 0x00, 0x0c, 0x00, 0x0d, 0x00, 0x0e, 0x00, 0x0f, 0x00, 0x10,
-  0x00, 0x11, 0x00, 0x12, 0x00, 0x13, 0x00, 0x14, 0x00, 0x15, 0x00, 0x16,
-  0x00, 0x17, 0x00, 0x18, 0x00, 0x19, 0x00, 0x1a, 0x00, 0x1b, 0x00, 0x1c,
-  0x00, 0x1d, 0x00, 0x1e, 0x00, 0x1f, 0x00, 0x20, 0x00, 0x21, 0x00, 0x22,
-  0x00, 0x23, 0x00, 0x24, 0x00, 0x25, 0x00, 0x26, 0x00, 0x27, 0x00, 0x28,
-  0x00, 0x29, 0x00, 0x2a, 0x00, 0x2b, 0x00, 0x2c, 0x00, 0x2d, 0x00, 0x2e,
-  0x00, 0x2f, 0x00, 0x30, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34,
-  0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39, 0x00, 0x3a,
-  0x00, 0x3b, 0x00, 0x3c, 0x00, 0x3d, 0x00, 0x3e, 0x00, 0x3f, 0x00, 0x40,
-  0x00, 0x41, 0x00, 0x42, 0x00, 0x43, 0x00, 0x44, 0x00, 0x45, 0x00, 0x46,
-  0x00, 0x47, 0x00, 0x48, 0x00, 0x49, 0x00, 0x4a, 0x00, 0x4b, 0x00, 0x4c,
-  0x00, 0x4d, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x50, 0x00, 0x51, 0x00, 0x52,
-  0x00, 0x53, 0x00, 0x54, 0x00, 0x55, 0x00, 0x56, 0x00, 0x57, 0x00, 0x58,
-  0x00, 0x59, 0x00, 0x5a, 0x00, 0x5b, 0x00, 0x5c, 0x00, 0x5d, 0x00, 0x5e,
-  0x00, 0x5f, 0x00, 0x60, 0x00, 0x61, 0x00, 0xac, 0x00, 0xa3, 0x00, 0x84,
-  0x00, 0x85, 0x00, 0xbd, 0x00, 0x96, 0x00, 0xe8, 0x00, 0x86, 0x00, 0x8e,
-  0x00, 0x8b, 0x00, 0x9d, 0x00, 0xa9, 0x00, 0xa4, 0x01, 0x02, 0x00, 0x8a,
-  0x00, 0xda, 0x00, 0x83, 0x00, 0x93, 0x00, 0xf2, 0x00, 0xf3, 0x00, 0x8d,
-  0x00, 0x97, 0x00, 0x88, 0x00, 0xc3, 0x00, 0xde, 0x00, 0xf1, 0x00, 0x9e,
-  0x00, 0xaa, 0x00, 0xf5, 0x00, 0xf4, 0x00, 0xf6, 0x00, 0xa2, 0x00, 0xad,
-  0x00, 0xc9, 0x00, 0xc7, 0x00, 0xae, 0x00, 0x62, 0x00, 0x63, 0x00, 0x90,
-  0x00, 0x64, 0x00, 0xcb, 0x00, 0x65, 0x00, 0xc8, 0x00, 0xca, 0x00, 0xcf,
-  0x00, 0xcc, 0x00, 0xcd, 0x00, 0xce, 0x00, 0xe9, 0x00, 0x66, 0x00, 0xd3,
-  0x00, 0xd0, 0x00, 0xd1, 0x00, 0xaf, 0x00, 0x67, 0x00, 0xf0, 0x00, 0x91,
-  0x00, 0xd6, 0x00, 0xd4, 0x00, 0xd5, 0x00, 0x68, 0x00, 0xeb, 0x00, 0xed,
-  0x00, 0x89, 0x00, 0x6a, 0x00, 0x69, 0x00, 0x6b, 0x00, 0x6d, 0x00, 0x6c,
-  0x00, 0x6e, 0x00, 0xa0, 0x00, 0x6f, 0x00, 0x71, 0x00, 0x70, 0x00, 0x72,
-  0x00, 0x73, 0x00, 0x75, 0x00, 0x74, 0x00, 0x76, 0x00, 0x77, 0x00, 0xea,
-  0x00, 0x78, 0x00, 0x7a, 0x00, 0x79, 0x00, 0x7b, 0x00, 0x7d, 0x00, 0x7c,
-  0x00, 0xb8, 0x00, 0xa1, 0x00, 0x7f, 0x00, 0x7e, 0x00, 0x80, 0x00, 0x81,
-  0x00, 0xec, 0x00, 0xee, 0x00, 0xba, 0x01, 0x03, 0x01, 0x04, 0x01, 0x05,
-  0x01, 0x06, 0x01, 0x07, 0x01, 0x08, 0x00, 0xfd, 0x00, 0xfe, 0x01, 0x09,
-  0x01, 0x0a, 0x01, 0x0b, 0x01, 0x0c, 0x00, 0xff, 0x01, 0x00, 0x01, 0x0d,
-  0x01, 0x0e, 0x01, 0x0f, 0x01, 0x01, 0x01, 0x10, 0x01, 0x11, 0x01, 0x12,
-  0x01, 0x13, 0x01, 0x14, 0x01, 0x15, 0x01, 0x16, 0x01, 0x17, 0x01, 0x18,
-  0x01, 0x19, 0x01, 0x1a, 0x01, 0x1b, 0x00, 0xf8, 0x00, 0xf9, 0x01, 0x1c,
-  0x01, 0x1d, 0x01, 0x1e, 0x01, 0x1f, 0x01, 0x20, 0x01, 0x21, 0x01, 0x22,
-  0x01, 0x23, 0x01, 0x24, 0x01, 0x25, 0x01, 0x26, 0x01, 0x27, 0x01, 0x28,
-  0x01, 0x29, 0x01, 0x2a, 0x01, 0x2b, 0x00, 0xfa, 0x00, 0xd7, 0x01, 0x2c,
-  0x01, 0x2d, 0x01, 0x2e, 0x01, 0x2f, 0x01, 0x30, 0x01, 0x31, 0x01, 0x32,
-  0x01, 0x33, 0x01, 0x34, 0x01, 0x35, 0x01, 0x36, 0x01, 0x37, 0x01, 0x38,
-  0x01, 0x39, 0x01, 0x3a, 0x00, 0xe2, 0x00, 0xe3, 0x01, 0x3b, 0x01, 0x3c,
-  0x01, 0x3d, 0x01, 0x3e, 0x01, 0x3f, 0x01, 0x40, 0x01, 0x41, 0x01, 0x42,
-  0x01, 0x43, 0x01, 0x44, 0x01, 0x45, 0x01, 0x46, 0x01, 0x47, 0x01, 0x48,
-  0x01, 0x49, 0x00, 0xb0, 0x00, 0xb1, 0x01, 0x4a, 0x01, 0x4b, 0x01, 0x4c,
-  0x01, 0x4d, 0x01, 0x4e, 0x01, 0x4f, 0x01, 0x50, 0x01, 0x51, 0x01, 0x52,
-  0x01, 0x53, 0x00, 0xfb, 0x00, 0xfc, 0x00, 0xe4, 0x00, 0xe5, 0x01, 0x54,
-  0x01, 0x55, 0x01, 0x56, 0x01, 0x57, 0x01, 0x58, 0x01, 0x59, 0x01, 0x5a,
-  0x01, 0x5b, 0x01, 0x5c, 0x01, 0x5d, 0x01, 0x5e, 0x01, 0x5f, 0x01, 0x60,
-  0x01, 0x61, 0x01, 0x62, 0x01, 0x63, 0x01, 0x64, 0x01, 0x65, 0x01, 0x66,
-  0x01, 0x67, 0x01, 0x68, 0x01, 0x69, 0x00, 0xbb, 0x01, 0x6a, 0x01, 0x6b,
-  0x01, 0x6c, 0x01, 0x6d, 0x00, 0xe6, 0x00, 0xe7, 0x01, 0x6e, 0x01, 0x6f,
-  0x01, 0x70, 0x01, 0x71, 0x01, 0x72, 0x01, 0x73, 0x01, 0x74, 0x01, 0x75,
-  0x01, 0x76, 0x01, 0x77, 0x01, 0x78, 0x01, 0x79, 0x01, 0x7a, 0x01, 0x7b,
-  0x01, 0x7c, 0x01, 0x7d, 0x01, 0x7e, 0x01, 0x7f, 0x01, 0x80, 0x00, 0xa6,
-  0x01, 0x81, 0x01, 0x82, 0x01, 0x83, 0x01, 0x84, 0x01, 0x85, 0x01, 0x86,
-  0x01, 0x87, 0x01, 0x88, 0x01, 0x89, 0x01, 0x8a, 0x01, 0x8b, 0x01, 0x8c,
-  0x01, 0x8d, 0x01, 0x8e, 0x01, 0x8f, 0x01, 0x90, 0x01, 0x91, 0x01, 0x92,
-  0x01, 0x93, 0x01, 0x94, 0x01, 0x95, 0x01, 0x96, 0x01, 0x97, 0x01, 0x98,
-  0x01, 0x99, 0x01, 0x9a, 0x01, 0x9b, 0x01, 0x9c, 0x01, 0x9d, 0x01, 0x9e,
-  0x01, 0x9f, 0x01, 0xa0, 0x01, 0xa1, 0x01, 0xa2, 0x01, 0xa3, 0x01, 0xa4,
-  0x01, 0xa5, 0x01, 0xa6, 0x01, 0xa7, 0x01, 0xa8, 0x01, 0xa9, 0x01, 0xaa,
-  0x01, 0xab, 0x01, 0xac, 0x01, 0xad, 0x01, 0xae, 0x01, 0xaf, 0x01, 0xb0,
-  0x01, 0xb1, 0x01, 0xb2, 0x01, 0xb3, 0x01, 0xb4, 0x01, 0xb5, 0x01, 0xb6,
-  0x01, 0xb7, 0x01, 0xb8, 0x01, 0xb9, 0x01, 0xba, 0x01, 0xbb, 0x01, 0xbc,
-  0x01, 0xbd, 0x01, 0xbe, 0x01, 0xbf, 0x01, 0xc0, 0x01, 0xc1, 0x01, 0xc2,
-  0x01, 0xc3, 0x01, 0xc4, 0x01, 0xc5, 0x01, 0xc6, 0x01, 0xc7, 0x01, 0xc8,
-  0x01, 0xc9, 0x01, 0xca, 0x01, 0xcb, 0x01, 0xcc, 0x01, 0xcd, 0x01, 0xce,
-  0x01, 0xcf, 0x01, 0xd0, 0x01, 0xd1, 0x01, 0xd2, 0x01, 0xd3, 0x01, 0xd4,
-  0x01, 0xd5, 0x01, 0xd6, 0x01, 0xd7, 0x01, 0xd8, 0x01, 0xd9, 0x01, 0xda,
-  0x01, 0xdb, 0x01, 0xdc, 0x01, 0xdd, 0x01, 0xde, 0x01, 0xdf, 0x01, 0xe0,
-  0x01, 0xe1, 0x01, 0xe2, 0x01, 0xe3, 0x01, 0xe4, 0x01, 0xe5, 0x01, 0xe6,
-  0x01, 0xe7, 0x01, 0xe8, 0x01, 0xe9, 0x01, 0xea, 0x01, 0xeb, 0x01, 0xec,
-  0x01, 0xed, 0x01, 0xee, 0x01, 0xef, 0x01, 0xf0, 0x01, 0xf1, 0x01, 0xf2,
-  0x01, 0xf3, 0x01, 0xf4, 0x01, 0xf5, 0x01, 0xf6, 0x01, 0xf7, 0x01, 0xf8,
-  0x01, 0xf9, 0x01, 0xfa, 0x01, 0xfb, 0x01, 0xfc, 0x01, 0xfd, 0x01, 0xfe,
-  0x01, 0xff, 0x02, 0x00, 0x02, 0x01, 0x02, 0x02, 0x02, 0x03, 0x02, 0x04,
-  0x02, 0x05, 0x02, 0x06, 0x02, 0x07, 0x02, 0x08, 0x02, 0x09, 0x02, 0x0a,
-  0x02, 0x0b, 0x02, 0x0c, 0x02, 0x0d, 0x02, 0x0e, 0x02, 0x0f, 0x02, 0x10,
-  0x02, 0x11, 0x02, 0x12, 0x02, 0x13, 0x02, 0x14, 0x02, 0x15, 0x02, 0x16,
-  0x02, 0x17, 0x02, 0x18, 0x02, 0x19, 0x02, 0x1a, 0x02, 0x1b, 0x02, 0x1c,
-  0x02, 0x1d, 0x02, 0x1e, 0x02, 0x1f, 0x02, 0x20, 0x02, 0x21, 0x02, 0x22,
-  0x02, 0x23, 0x02, 0x24, 0x02, 0x25, 0x02, 0x26, 0x02, 0x27, 0x02, 0x28,
-  0x02, 0x29, 0x02, 0x2a, 0x02, 0x2b, 0x02, 0x2c, 0x02, 0x2d, 0x02, 0x2e,
-  0x02, 0x2f, 0x02, 0x30, 0x02, 0x31, 0x02, 0x32, 0x02, 0x33, 0x02, 0x34,
-  0x02, 0x35, 0x02, 0x36, 0x02, 0x37, 0x02, 0x38, 0x02, 0x39, 0x02, 0x3a,
-  0x02, 0x3b, 0x02, 0x3c, 0x02, 0x3d, 0x02, 0x3e, 0x02, 0x3f, 0x02, 0x40,
-  0x02, 0x41, 0x02, 0x42, 0x02, 0x43, 0x02, 0x44, 0x02, 0x45, 0x02, 0x46,
-  0x02, 0x47, 0x02, 0x48, 0x02, 0x49, 0x02, 0x4a, 0x02, 0x4b, 0x02, 0x4c,
-  0x02, 0x4d, 0x02, 0x4e, 0x02, 0x4f, 0x02, 0x50, 0x02, 0x51, 0x02, 0x52,
-  0x02, 0x53, 0x02, 0x54, 0x02, 0x55, 0x02, 0x56, 0x02, 0x57, 0x02, 0x58,
-  0x02, 0x59, 0x02, 0x5a, 0x02, 0x5b, 0x02, 0x5c, 0x02, 0x5d, 0x02, 0x5e,
-  0x02, 0x5f, 0x02, 0x60, 0x02, 0x61, 0x02, 0x62, 0x02, 0x63, 0x02, 0x64,
-  0x02, 0x65, 0x02, 0x66, 0x02, 0x67, 0x02, 0x68, 0x02, 0x69, 0x02, 0x6a,
-  0x02, 0x6b, 0x02, 0x6c, 0x02, 0x6d, 0x02, 0x6e, 0x02, 0x6f, 0x02, 0x70,
-  0x02, 0x71, 0x02, 0x72, 0x02, 0x73, 0x02, 0x74, 0x02, 0x75, 0x02, 0x76,
-  0x02, 0x77, 0x02, 0x78, 0x02, 0x79, 0x02, 0x7a, 0x02, 0x7b, 0x02, 0x7c,
-  0x02, 0x7d, 0x02, 0x7e, 0x02, 0x7f, 0x02, 0x80, 0x02, 0x81, 0x02, 0x82,
-  0x02, 0x83, 0x02, 0x84, 0x02, 0x85, 0x02, 0x86, 0x02, 0x87, 0x02, 0x88,
-  0x02, 0x89, 0x02, 0x8a, 0x02, 0x8b, 0x02, 0x8c, 0x02, 0x8d, 0x02, 0x8e,
-  0x02, 0x8f, 0x02, 0x90, 0x02, 0x91, 0x02, 0x92, 0x02, 0x93, 0x02, 0x94,
-  0x02, 0x95, 0x02, 0x96, 0x02, 0x97, 0x02, 0x98, 0x02, 0x99, 0x02, 0x9a,
-  0x02, 0x9b, 0x02, 0x9c, 0x02, 0x9d, 0x02, 0x9e, 0x02, 0x9f, 0x02, 0xa0,
-  0x02, 0xa1, 0x02, 0xa2, 0x02, 0xa3, 0x02, 0xa4, 0x02, 0xa5, 0x02, 0xa6,
-  0x02, 0xa7, 0x02, 0xa8, 0x02, 0xa9, 0x02, 0xaa, 0x02, 0xab, 0x02, 0xac,
-  0x02, 0xad, 0x02, 0xae, 0x02, 0xaf, 0x02, 0xb0, 0x02, 0xb1, 0x02, 0xb2,
-  0x02, 0xb3, 0x00, 0xd8, 0x00, 0xe1, 0x02, 0xb4, 0x02, 0xb5, 0x02, 0xb6,
-  0x02, 0xb7, 0x02, 0xb8, 0x02, 0xb9, 0x02, 0xba, 0x02, 0xbb, 0x02, 0xbc,
-  0x02, 0xbd, 0x02, 0xbe, 0x02, 0xbf, 0x02, 0xc0, 0x02, 0xc1, 0x02, 0xc2,
-  0x02, 0xc3, 0x00, 0xdb, 0x00, 0xdc, 0x00, 0xdd, 0x00, 0xe0, 0x00, 0xd9,
-  0x00, 0xdf, 0x02, 0xc4, 0x02, 0xc5, 0x02, 0xc6, 0x02, 0xc7, 0x02, 0xc8,
-  0x02, 0xc9, 0x02, 0xca, 0x02, 0xcb, 0x02, 0xcc, 0x02, 0xcd, 0x02, 0xce,
-  0x02, 0xcf, 0x02, 0xd0, 0x02, 0xd1, 0x02, 0xd2, 0x02, 0xd3, 0x02, 0xd4,
-  0x02, 0xd5, 0x02, 0xd6, 0x02, 0xd7, 0x02, 0xd8, 0x02, 0xd9, 0x02, 0xda,
-  0x02, 0xdb, 0x02, 0xdc, 0x02, 0xdd, 0x02, 0xde, 0x02, 0xdf, 0x02, 0xe0,
-  0x02, 0xe1, 0x02, 0xe2, 0x02, 0xe3, 0x02, 0xe4, 0x02, 0xe5, 0x02, 0xe6,
-  0x02, 0xe7, 0x02, 0xe8, 0x02, 0xe9, 0x02, 0xea, 0x02, 0xeb, 0x02, 0xec,
-  0x02, 0xed, 0x02, 0xee, 0x02, 0xef, 0x02, 0xf0, 0x02, 0xf1, 0x02, 0xf2,
-  0x02, 0xf3, 0x02, 0xf4, 0x02, 0xf5, 0x02, 0xf6, 0x02, 0xf7, 0x02, 0xf8,
-  0x02, 0xf9, 0x02, 0xfa, 0x02, 0xfb, 0x02, 0xfc, 0x02, 0xfd, 0x02, 0xfe,
-  0x02, 0xff, 0x03, 0x00, 0x03, 0x01, 0x03, 0x02, 0x03, 0x03, 0x03, 0x04,
-  0x03, 0x05, 0x03, 0x06, 0x03, 0x07, 0x03, 0x08, 0x03, 0x09, 0x03, 0x0a,
-  0x03, 0x0b, 0x03, 0x0c, 0x03, 0x0d, 0x03, 0x0e, 0x03, 0x0f, 0x03, 0x10,
-  0x03, 0x11, 0x03, 0x12, 0x03, 0x13, 0x03, 0x14, 0x03, 0x15, 0x03, 0x16,
-  0x03, 0x17, 0x03, 0x18, 0x03, 0x19, 0x03, 0x1a, 0x03, 0x1b, 0x03, 0x1c,
-  0x03, 0x1d, 0x03, 0x1e, 0x03, 0x1f, 0x03, 0x20, 0x03, 0x21, 0x03, 0x22,
-  0x03, 0x23, 0x03, 0x24, 0x03, 0x25, 0x03, 0x26, 0x03, 0x27, 0x03, 0x28,
-  0x03, 0x29, 0x03, 0x2a, 0x03, 0x2b, 0x03, 0x2c, 0x03, 0x2d, 0x03, 0x2e,
-  0x03, 0x2f, 0x03, 0x30, 0x03, 0x31, 0x03, 0x32, 0x03, 0x33, 0x03, 0x34,
-  0x03, 0x35, 0x03, 0x36, 0x03, 0x37, 0x03, 0x38, 0x03, 0x39, 0x03, 0x3a,
-  0x03, 0x3b, 0x03, 0x3c, 0x03, 0x3d, 0x03, 0x3e, 0x03, 0x3f, 0x03, 0x40,
-  0x03, 0x41, 0x03, 0x42, 0x03, 0x43, 0x03, 0x44, 0x03, 0x45, 0x03, 0x46,
-  0x03, 0x47, 0x03, 0x48, 0x03, 0x49, 0x03, 0x4a, 0x03, 0x4b, 0x03, 0x4c,
-  0x03, 0x4d, 0x03, 0x4e, 0x03, 0x4f, 0x03, 0x50, 0x03, 0x51, 0x03, 0x52,
-  0x03, 0x53, 0x03, 0x54, 0x03, 0x55, 0x03, 0x56, 0x03, 0x57, 0x03, 0x58,
-  0x03, 0x59, 0x03, 0x5a, 0x03, 0x5b, 0x03, 0x5c, 0x03, 0x5d, 0x03, 0x5e,
-  0x03, 0x5f, 0x03, 0x60, 0x00, 0x9f, 0x03, 0x61, 0x03, 0x62, 0x03, 0x63,
-  0x03, 0x64, 0x03, 0x65, 0x03, 0x66, 0x03, 0x67, 0x03, 0x68, 0x03, 0x69,
-  0x03, 0x6a, 0x03, 0x6b, 0x03, 0x6c, 0x03, 0x6d, 0x03, 0x6e, 0x03, 0x6f,
-  0x03, 0x70, 0x03, 0x71, 0x03, 0x72, 0x03, 0x73, 0x03, 0x74, 0x03, 0x75,
-  0x03, 0x76, 0x00, 0x9b, 0x03, 0x77, 0x03, 0x78, 0x03, 0x79, 0x03, 0x7a,
-  0x03, 0x7b, 0x03, 0x7c, 0x03, 0x7d, 0x03, 0x7e, 0x03, 0x7f, 0x03, 0x80,
-  0x03, 0x81, 0x03, 0x82, 0x03, 0x83, 0x03, 0x84, 0x03, 0x85, 0x03, 0x86,
-  0x03, 0x87, 0x03, 0x88, 0x03, 0x89, 0x03, 0x8a, 0x03, 0x8b, 0x03, 0x8c,
-  0x03, 0x8d, 0x03, 0x8e, 0x03, 0x8f, 0x03, 0x90, 0x03, 0x91, 0x03, 0x92,
-  0x03, 0x93, 0x03, 0x94, 0x03, 0x95, 0x03, 0x96, 0x03, 0x97, 0x03, 0x98,
-  0x03, 0x99, 0x03, 0x9a, 0x03, 0x9b, 0x03, 0x9c, 0x03, 0x9d, 0x03, 0x9e,
-  0x03, 0x9f, 0x03, 0xa0, 0x03, 0xa1, 0x03, 0xa2, 0x03, 0xa3, 0x03, 0xa4,
-  0x03, 0xa5, 0x03, 0xa6, 0x03, 0xa7, 0x03, 0xa8, 0x03, 0xa9, 0x03, 0xaa,
-  0x03, 0xab, 0x03, 0xac, 0x03, 0xad, 0x03, 0xae, 0x03, 0xaf, 0x03, 0xb0,
-  0x03, 0xb1, 0x03, 0xb2, 0x03, 0xb3, 0x03, 0xb4, 0x03, 0xb5, 0x03, 0xb6,
-  0x03, 0xb7, 0x03, 0xb8, 0x03, 0xb9, 0x03, 0xba, 0x03, 0xbb, 0x03, 0xbc,
-  0x03, 0xbd, 0x03, 0xbe, 0x03, 0xbf, 0x03, 0xc0, 0x03, 0xc1, 0x03, 0xc2,
-  0x03, 0xc3, 0x03, 0xc4, 0x03, 0xc5, 0x03, 0xc6, 0x03, 0xc7, 0x03, 0xc8,
-  0x03, 0xc9, 0x03, 0xca, 0x03, 0xcb, 0x03, 0xcc, 0x03, 0xcd, 0x03, 0xce,
-  0x03, 0xcf, 0x03, 0xd0, 0x03, 0xd1, 0x03, 0xd2, 0x03, 0xd3, 0x03, 0xd4,
-  0x03, 0xd5, 0x03, 0xd6, 0x03, 0xd7, 0x03, 0xd8, 0x03, 0xd9, 0x03, 0xda,
-  0x03, 0xdb, 0x03, 0xdc, 0x03, 0xdd, 0x03, 0xde, 0x03, 0xdf, 0x03, 0xe0,
-  0x03, 0xe1, 0x03, 0xe2, 0x03, 0xe3, 0x03, 0xe4, 0x03, 0xe5, 0x03, 0xe6,
-  0x03, 0xe7, 0x03, 0xe8, 0x03, 0xe9, 0x03, 0xea, 0x03, 0xeb, 0x03, 0xec,
-  0x03, 0xed, 0x03, 0xee, 0x03, 0xef, 0x03, 0xf0, 0x03, 0xf1, 0x03, 0xf2,
-  0x03, 0xf3, 0x03, 0xf4, 0x03, 0xf5, 0x03, 0xf6, 0x03, 0xf7, 0x03, 0xf8,
-  0x03, 0xf9, 0x03, 0xfa, 0x03, 0xfb, 0x03, 0xfc, 0x03, 0xfd, 0x03, 0xfe,
-  0x03, 0xff, 0x04, 0x00, 0x04, 0x01, 0x04, 0x02, 0x04, 0x03, 0x04, 0x04,
-  0x04, 0x05, 0x04, 0x06, 0x04, 0x07, 0x04, 0x08, 0x04, 0x09, 0x04, 0x0a,
-  0x04, 0x0b, 0x04, 0x0c, 0x04, 0x0d, 0x04, 0x0e, 0x04, 0x0f, 0x04, 0x10,
-  0x04, 0x11, 0x04, 0x12, 0x04, 0x13, 0x04, 0x14, 0x04, 0x15, 0x04, 0x16,
-  0x04, 0x17, 0x04, 0x18, 0x04, 0x19, 0x04, 0x1a, 0x04, 0x1b, 0x04, 0x1c,
-  0x04, 0x1d, 0x04, 0x1e, 0x04, 0x1f, 0x04, 0x20, 0x04, 0x21, 0x04, 0x22,
-  0x04, 0x23, 0x04, 0x24, 0x04, 0x25, 0x04, 0x26, 0x04, 0x27, 0x04, 0x28,
-  0x04, 0x29, 0x04, 0x2a, 0x04, 0x2b, 0x04, 0x2c, 0x04, 0x2d, 0x04, 0x2e,
-  0x04, 0x2f, 0x04, 0x30, 0x04, 0x31, 0x04, 0x32, 0x04, 0x33, 0x04, 0x34,
-  0x04, 0x35, 0x04, 0x36, 0x04, 0x37, 0x04, 0x38, 0x04, 0x39, 0x04, 0x3a,
-  0x04, 0x3b, 0x04, 0x3c, 0x04, 0x3d, 0x04, 0x3e, 0x04, 0x3f, 0x04, 0x40,
-  0x04, 0x41, 0x04, 0x42, 0x04, 0x43, 0x04, 0x44, 0x04, 0x45, 0x04, 0x46,
-  0x04, 0x47, 0x04, 0x48, 0x04, 0x49, 0x04, 0x4a, 0x04, 0x4b, 0x04, 0x4c,
-  0x04, 0x4d, 0x04, 0x4e, 0x04, 0x4f, 0x04, 0x50, 0x04, 0x51, 0x04, 0x52,
-  0x04, 0x53, 0x04, 0x54, 0x04, 0x55, 0x04, 0x56, 0x04, 0x57, 0x04, 0x58,
-  0x04, 0x59, 0x04, 0x5a, 0x04, 0x5b, 0x04, 0x5c, 0x04, 0x5d, 0x04, 0x5e,
-  0x04, 0x5f, 0x04, 0x60, 0x04, 0x61, 0x04, 0x62, 0x04, 0x63, 0x04, 0x64,
-  0x04, 0x65, 0x04, 0x66, 0x04, 0x67, 0x04, 0x68, 0x04, 0x69, 0x04, 0x6a,
-  0x04, 0x6b, 0x04, 0x6c, 0x04, 0x6d, 0x04, 0x6e, 0x04, 0x6f, 0x04, 0x70,
-  0x04, 0x71, 0x04, 0x72, 0x04, 0x73, 0x04, 0x74, 0x04, 0x75, 0x04, 0x76,
-  0x04, 0x77, 0x04, 0x78, 0x04, 0x79, 0x04, 0x7a, 0x04, 0x7b, 0x04, 0x7c,
-  0x04, 0x7d, 0x04, 0x7e, 0x04, 0x7f, 0x04, 0x80, 0x04, 0x81, 0x04, 0x82,
-  0x04, 0x83, 0x04, 0x84, 0x04, 0x85, 0x04, 0x86, 0x04, 0x87, 0x04, 0x88,
-  0x04, 0x89, 0x04, 0x8a, 0x04, 0x8b, 0x04, 0x8c, 0x04, 0x8d, 0x04, 0x8e,
-  0x04, 0x8f, 0x04, 0x90, 0x04, 0x91, 0x04, 0x92, 0x04, 0x93, 0x04, 0x94,
-  0x04, 0x95, 0x04, 0x96, 0x04, 0x97, 0x04, 0x98, 0x04, 0x99, 0x04, 0x9a,
-  0x04, 0x9b, 0x04, 0x9c, 0x04, 0x9d, 0x04, 0x9e, 0x04, 0x9f, 0x04, 0xa0,
-  0x04, 0xa1, 0x04, 0xa2, 0x04, 0xa3, 0x04, 0xa4, 0x04, 0xa5, 0x04, 0xa6,
-  0x04, 0xa7, 0x04, 0xa8, 0x04, 0xa9, 0x04, 0xaa, 0x04, 0xab, 0x04, 0xac,
-  0x04, 0xad, 0x04, 0xae, 0x04, 0xaf, 0x04, 0xb0, 0x04, 0xb1, 0x04, 0xb2,
-  0x04, 0xb3, 0x04, 0xb4, 0x04, 0xb5, 0x04, 0xb6, 0x04, 0xb7, 0x04, 0xb8,
-  0x04, 0xb9, 0x04, 0xba, 0x04, 0xbb, 0x04, 0xbc, 0x04, 0xbd, 0x04, 0xbe,
-  0x04, 0xbf, 0x04, 0xc0, 0x04, 0xc1, 0x04, 0xc2, 0x04, 0xc3, 0x04, 0xc4,
-  0x04, 0xc5, 0x04, 0xc6, 0x04, 0xc7, 0x04, 0xc8, 0x04, 0xc9, 0x04, 0xca,
-  0x04, 0xcb, 0x04, 0xcc, 0x04, 0xcd, 0x04, 0xce, 0x04, 0xcf, 0x04, 0xd0,
-  0x04, 0xd1, 0x04, 0xd2, 0x04, 0xd3, 0x04, 0xd4, 0x04, 0xd5, 0x04, 0xd6,
-  0x04, 0xd7, 0x04, 0xd8, 0x04, 0xd9, 0x04, 0xda, 0x04, 0xdb, 0x04, 0xdc,
-  0x04, 0xdd, 0x04, 0xde, 0x04, 0xdf, 0x04, 0xe0, 0x04, 0xe1, 0x04, 0xe2,
-  0x04, 0xe3, 0x04, 0xe4, 0x04, 0xe5, 0x04, 0xe6, 0x04, 0xe7, 0x04, 0xe8,
-  0x04, 0xe9, 0x04, 0xea, 0x04, 0xeb, 0x04, 0xec, 0x04, 0xed, 0x04, 0xee,
-  0x04, 0xef, 0x04, 0xf0, 0x04, 0xf1, 0x04, 0xf2, 0x04, 0xf3, 0x04, 0xf4,
-  0x04, 0xf5, 0x04, 0xf6, 0x04, 0xf7, 0x04, 0xf8, 0x04, 0xf9, 0x04, 0xfa,
-  0x04, 0xfb, 0x04, 0xfc, 0x04, 0xfd, 0x04, 0xfe, 0x04, 0xff, 0x05, 0x00,
-  0x05, 0x01, 0x05, 0x02, 0x05, 0x03, 0x05, 0x04, 0x05, 0x05, 0x05, 0x06,
-  0x05, 0x07, 0x05, 0x08, 0x05, 0x09, 0x05, 0x0a, 0x05, 0x0b, 0x05, 0x0c,
-  0x05, 0x0d, 0x05, 0x0e, 0x05, 0x0f, 0x05, 0x10, 0x05, 0x11, 0x05, 0x12,
-  0x05, 0x13, 0x05, 0x14, 0x05, 0x15, 0x05, 0x16, 0x05, 0x17, 0x05, 0x18,
-  0x05, 0x19, 0x05, 0x1a, 0x05, 0x1b, 0x05, 0x1c, 0x05, 0x1d, 0x05, 0x1e,
-  0x05, 0x1f, 0x05, 0x20, 0x05, 0x21, 0x05, 0x22, 0x05, 0x23, 0x05, 0x24,
-  0x05, 0x25, 0x05, 0x26, 0x05, 0x27, 0x05, 0x28, 0x05, 0x29, 0x05, 0x2a,
-  0x05, 0x2b, 0x05, 0x2c, 0x05, 0x2d, 0x05, 0x2e, 0x05, 0x2f, 0x05, 0x30,
-  0x05, 0x31, 0x05, 0x32, 0x05, 0x33, 0x05, 0x34, 0x05, 0x35, 0x05, 0x36,
-  0x05, 0x37, 0x05, 0x38, 0x05, 0x39, 0x05, 0x3a, 0x05, 0x3b, 0x05, 0x3c,
-  0x05, 0x3d, 0x05, 0x3e, 0x05, 0x3f, 0x05, 0x40, 0x05, 0x41, 0x05, 0x42,
-  0x05, 0x43, 0x05, 0x44, 0x05, 0x45, 0x05, 0x46, 0x05, 0x47, 0x05, 0x48,
-  0x05, 0x49, 0x05, 0x4a, 0x05, 0x4b, 0x05, 0x4c, 0x05, 0x4d, 0x05, 0x4e,
-  0x05, 0x4f, 0x05, 0x50, 0x05, 0x51, 0x05, 0x52, 0x05, 0x53, 0x05, 0x54,
-  0x05, 0x55, 0x05, 0x56, 0x05, 0x57, 0x05, 0x58, 0x05, 0x59, 0x05, 0x5a,
-  0x05, 0x5b, 0x05, 0x5c, 0x05, 0x5d, 0x05, 0x5e, 0x05, 0x5f, 0x05, 0x60,
-  0x05, 0x61, 0x05, 0x62, 0x05, 0x63, 0x05, 0x64, 0x05, 0x65, 0x05, 0x66,
-  0x05, 0x67, 0x05, 0x68, 0x05, 0x69, 0x05, 0x6a, 0x05, 0x6b, 0x05, 0x6c,
-  0x05, 0x6d, 0x05, 0x6e, 0x05, 0x6f, 0x05, 0x70, 0x05, 0x71, 0x05, 0x72,
-  0x05, 0x73, 0x05, 0x74, 0x05, 0x75, 0x05, 0x76, 0x05, 0x77, 0x05, 0x78,
-  0x05, 0x79, 0x05, 0x7a, 0x05, 0x7b, 0x05, 0x7c, 0x05, 0x7d, 0x05, 0x7e,
-  0x05, 0x7f, 0x05, 0x80, 0x05, 0x81, 0x05, 0x82, 0x05, 0x83, 0x05, 0x84,
-  0x05, 0x85, 0x05, 0x86, 0x05, 0x87, 0x05, 0x88, 0x05, 0x89, 0x05, 0x8a,
-  0x05, 0x8b, 0x05, 0x8c, 0x05, 0x8d, 0x05, 0x8e, 0x05, 0x8f, 0x05, 0x90,
-  0x05, 0x91, 0x05, 0x92, 0x05, 0x93, 0x05, 0x94, 0x05, 0x95, 0x05, 0x96,
-  0x05, 0x97, 0x05, 0x98, 0x05, 0x99, 0x05, 0x9a, 0x05, 0x9b, 0x05, 0x9c,
-  0x05, 0x9d, 0x05, 0x9e, 0x05, 0x9f, 0x05, 0xa0, 0x05, 0xa1, 0x05, 0xa2,
-  0x05, 0xa3, 0x05, 0xa4, 0x05, 0xa5, 0x05, 0xa6, 0x05, 0xa7, 0x05, 0xa8,
-  0x05, 0xa9, 0x05, 0xaa, 0x05, 0xab, 0x05, 0xac, 0x05, 0xad, 0x05, 0xae,
-  0x05, 0xaf, 0x05, 0xb0, 0x05, 0xb1, 0x05, 0xb2, 0x05, 0xb3, 0x05, 0xb4,
-  0x05, 0xb5, 0x05, 0xb6, 0x05, 0xb7, 0x05, 0xb8, 0x05, 0xb9, 0x05, 0xba,
-  0x05, 0xbb, 0x05, 0xbc, 0x05, 0xbd, 0x05, 0xbe, 0x05, 0xbf, 0x05, 0xc0,
-  0x05, 0xc1, 0x05, 0xc2, 0x05, 0xc3, 0x05, 0xc4, 0x05, 0xc5, 0x05, 0xc6,
-  0x05, 0xc7, 0x05, 0xc8, 0x05, 0xc9, 0x05, 0xca, 0x05, 0xcb, 0x05, 0xcc,
-  0x05, 0xcd, 0x05, 0xce, 0x05, 0xcf, 0x05, 0xd0, 0x05, 0xd1, 0x05, 0xd2,
-  0x05, 0xd3, 0x05, 0xd4, 0x05, 0xd5, 0x05, 0xd6, 0x05, 0xd7, 0x05, 0xd8,
-  0x05, 0xd9, 0x05, 0xda, 0x05, 0xdb, 0x05, 0xdc, 0x05, 0xdd, 0x05, 0xde,
-  0x05, 0xdf, 0x05, 0xe0, 0x05, 0xe1, 0x05, 0xe2, 0x05, 0xe3, 0x05, 0xe4,
-  0x05, 0xe5, 0x05, 0xe6, 0x05, 0xe7, 0x05, 0xe8, 0x05, 0xe9, 0x05, 0xea,
-  0x05, 0xeb, 0x05, 0xec, 0x05, 0xed, 0x05, 0xee, 0x05, 0xef, 0x05, 0xf0,
-  0x05, 0xf1, 0x05, 0xf2, 0x05, 0xf3, 0x05, 0xf4, 0x05, 0xf5, 0x05, 0xf6,
-  0x05, 0xf7, 0x05, 0xf8, 0x05, 0xf9, 0x05, 0xfa, 0x05, 0xfb, 0x05, 0xfc,
-  0x05, 0xfd, 0x05, 0xfe, 0x05, 0xff, 0x06, 0x00, 0x06, 0x01, 0x06, 0x02,
-  0x06, 0x03, 0x06, 0x04, 0x06, 0x05, 0x06, 0x06, 0x06, 0x07, 0x06, 0x08,
-  0x06, 0x09, 0x06, 0x0a, 0x06, 0x0b, 0x06, 0x0c, 0x06, 0x0d, 0x06, 0x0e,
-  0x06, 0x0f, 0x06, 0x10, 0x06, 0x11, 0x06, 0x12, 0x06, 0x13, 0x06, 0x14,
-  0x06, 0x15, 0x06, 0x16, 0x06, 0x17, 0x06, 0x18, 0x06, 0x19, 0x06, 0x1a,
-  0x06, 0x1b, 0x06, 0x1c, 0x06, 0x1d, 0x06, 0x1e, 0x06, 0x1f, 0x06, 0x20,
-  0x06, 0x21, 0x06, 0x22, 0x06, 0x23, 0x06, 0x24, 0x06, 0x25, 0x06, 0x26,
-  0x06, 0x27, 0x06, 0x28, 0x06, 0x29, 0x06, 0x2a, 0x06, 0x2b, 0x06, 0x2c,
-  0x06, 0x2d, 0x06, 0x2e, 0x06, 0x2f, 0x06, 0x30, 0x06, 0x31, 0x06, 0x32,
-  0x06, 0x33, 0x06, 0x34, 0x06, 0x35, 0x06, 0x36, 0x06, 0x37, 0x06, 0x38,
-  0x06, 0x39, 0x06, 0x3a, 0x06, 0x3b, 0x06, 0x3c, 0x06, 0x3d, 0x06, 0x3e,
-  0x06, 0x3f, 0x06, 0x40, 0x06, 0x41, 0x06, 0x42, 0x06, 0x43, 0x06, 0x44,
-  0x06, 0x45, 0x06, 0x46, 0x06, 0x47, 0x06, 0x48, 0x06, 0x49, 0x06, 0x4a,
-  0x06, 0x4b, 0x06, 0x4c, 0x06, 0x4d, 0x06, 0x4e, 0x06, 0x4f, 0x06, 0x50,
-  0x06, 0x51, 0x06, 0x52, 0x06, 0x53, 0x06, 0x54, 0x06, 0x55, 0x06, 0x56,
-  0x06, 0x57, 0x06, 0x58, 0x06, 0x59, 0x06, 0x5a, 0x06, 0x5b, 0x06, 0x5c,
-  0x06, 0x5d, 0x06, 0x5e, 0x06, 0x5f, 0x06, 0x60, 0x06, 0x61, 0x06, 0x62,
-  0x06, 0x63, 0x06, 0x64, 0x06, 0x65, 0x06, 0x66, 0x06, 0x67, 0x06, 0x68,
-  0x06, 0x69, 0x06, 0x6a, 0x06, 0x6b, 0x06, 0x6c, 0x06, 0x6d, 0x06, 0x6e,
-  0x06, 0x6f, 0x06, 0x70, 0x06, 0x71, 0x06, 0x72, 0x06, 0x73, 0x06, 0x74,
-  0x06, 0x75, 0x06, 0x76, 0x06, 0x77, 0x06, 0x78, 0x06, 0x79, 0x06, 0x7a,
-  0x06, 0x7b, 0x06, 0x7c, 0x06, 0x7d, 0x06, 0x7e, 0x06, 0x7f, 0x06, 0x80,
-  0x06, 0x81, 0x06, 0x82, 0x06, 0x83, 0x06, 0x84, 0x06, 0x85, 0x06, 0x86,
-  0x06, 0x87, 0x06, 0x88, 0x06, 0x89, 0x06, 0x8a, 0x06, 0x8b, 0x06, 0x8c,
-  0x06, 0x8d, 0x06, 0x8e, 0x06, 0x8f, 0x06, 0x90, 0x06, 0x91, 0x06, 0x92,
-  0x06, 0x93, 0x06, 0x94, 0x06, 0x95, 0x06, 0x96, 0x06, 0x97, 0x06, 0x98,
-  0x06, 0x99, 0x06, 0x9a, 0x06, 0x9b, 0x06, 0x9c, 0x06, 0x9d, 0x06, 0x9e,
-  0x06, 0x9f, 0x06, 0xa0, 0x06, 0xa1, 0x06, 0xa2, 0x06, 0xa3, 0x06, 0xa4,
-  0x06, 0xa5, 0x06, 0xa6, 0x06, 0xa7, 0x06, 0xa8, 0x06, 0xa9, 0x06, 0xaa,
-  0x06, 0xab, 0x06, 0xac, 0x06, 0xad, 0x06, 0xae, 0x06, 0xaf, 0x06, 0xb0,
-  0x06, 0xb1, 0x06, 0xb2, 0x06, 0xb3, 0x06, 0xb4, 0x06, 0xb5, 0x06, 0xb6,
-  0x06, 0xb7, 0x06, 0xb8, 0x06, 0xb9, 0x06, 0xba, 0x06, 0xbb, 0x06, 0xbc,
-  0x06, 0xbd, 0x06, 0xbe, 0x06, 0xbf, 0x06, 0xc0, 0x06, 0xc1, 0x06, 0xc2,
-  0x06, 0xc3, 0x06, 0xc4, 0x06, 0xc5, 0x06, 0xc6, 0x06, 0xc7, 0x06, 0xc8,
-  0x06, 0xc9, 0x06, 0xca, 0x06, 0xcb, 0x06, 0xcc, 0x06, 0xcd, 0x06, 0xce,
-  0x06, 0xcf, 0x06, 0xd0, 0x06, 0xd1, 0x06, 0xd2, 0x06, 0xd3, 0x06, 0xd4,
-  0x06, 0xd5, 0x06, 0xd6, 0x06, 0xd7, 0x06, 0xd8, 0x06, 0xd9, 0x06, 0xda,
-  0x06, 0xdb, 0x06, 0xdc, 0x06, 0xdd, 0x06, 0xde, 0x06, 0xdf, 0x06, 0xe0,
-  0x06, 0xe1, 0x06, 0xe2, 0x06, 0xe3, 0x06, 0xe4, 0x06, 0xe5, 0x06, 0xe6,
-  0x06, 0xe7, 0x06, 0xe8, 0x06, 0xe9, 0x06, 0xea, 0x06, 0xeb, 0x06, 0xec,
-  0x06, 0xed, 0x06, 0xee, 0x06, 0xef, 0x06, 0xf0, 0x06, 0xf1, 0x06, 0xf2,
-  0x06, 0xf3, 0x06, 0xf4, 0x06, 0xf5, 0x06, 0xf6, 0x06, 0xf7, 0x06, 0xf8,
-  0x06, 0xf9, 0x06, 0xfa, 0x06, 0xfb, 0x06, 0xfc, 0x06, 0xfd, 0x06, 0xfe,
-  0x06, 0xff, 0x07, 0x00, 0x07, 0x01, 0x07, 0x02, 0x07, 0x03, 0x07, 0x04,
-  0x07, 0x05, 0x07, 0x06, 0x07, 0x07, 0x07, 0x08, 0x07, 0x09, 0x07, 0x0a,
-  0x07, 0x0b, 0x07, 0x0c, 0x07, 0x0d, 0x07, 0x0e, 0x07, 0x0f, 0x07, 0x10,
-  0x07, 0x11, 0x07, 0x12, 0x07, 0x13, 0x07, 0x14, 0x07, 0x15, 0x07, 0x16,
-  0x07, 0x17, 0x07, 0x18, 0x07, 0x19, 0x07, 0x1a, 0x07, 0x1b, 0x07, 0x1c,
-  0x07, 0x1d, 0x07, 0x1e, 0x07, 0x1f, 0x07, 0x20, 0x07, 0x21, 0x07, 0x22,
-  0x07, 0x23, 0x07, 0x24, 0x07, 0x25, 0x07, 0x26, 0x07, 0x27, 0x07, 0x28,
-  0x07, 0x29, 0x07, 0x2a, 0x07, 0x2b, 0x07, 0x2c, 0x07, 0x2d, 0x07, 0x2e,
-  0x07, 0x2f, 0x07, 0x30, 0x07, 0x31, 0x07, 0x32, 0x07, 0x33, 0x07, 0x34,
-  0x07, 0x35, 0x07, 0x36, 0x07, 0x37, 0x07, 0x38, 0x07, 0x39, 0x07, 0x3a,
-  0x07, 0x3b, 0x07, 0x3c, 0x07, 0x3d, 0x07, 0x3e, 0x07, 0x3f, 0x07, 0x40,
-  0x07, 0x41, 0x07, 0x42, 0x07, 0x43, 0x07, 0x44, 0x07, 0x45, 0x07, 0x46,
-  0x07, 0x47, 0x07, 0x48, 0x07, 0x49, 0x07, 0x4a, 0x07, 0x4b, 0x07, 0x4c,
-  0x07, 0x4d, 0x07, 0x4e, 0x07, 0x4f, 0x07, 0x50, 0x07, 0x51, 0x07, 0x52,
-  0x07, 0x53, 0x07, 0x54, 0x07, 0x55, 0x07, 0x56, 0x07, 0x57, 0x07, 0x58,
-  0x07, 0x59, 0x07, 0x5a, 0x07, 0x5b, 0x07, 0x5c, 0x07, 0x5d, 0x07, 0x5e,
-  0x07, 0x5f, 0x07, 0x60, 0x07, 0x61, 0x07, 0x62, 0x07, 0x63, 0x07, 0x64,
-  0x07, 0x65, 0x07, 0x66, 0x07, 0x67, 0x07, 0x68, 0x07, 0x69, 0x00, 0xb2,
-  0x00, 0xb3, 0x07, 0x6a, 0x07, 0x6b, 0x07, 0x6c, 0x00, 0xb6, 0x00, 0xb7,
-  0x00, 0xc4, 0x07, 0x6d, 0x00, 0xb4, 0x00, 0xb5, 0x00, 0xc5, 0x07, 0x6e,
-  0x00, 0x82, 0x00, 0xc2, 0x00, 0x87, 0x07, 0x6f, 0x07, 0x70, 0x07, 0x71,
-  0x00, 0xab, 0x07, 0x72, 0x07, 0x73, 0x07, 0x74, 0x07, 0x75, 0x07, 0x76,
-  0x07, 0x77, 0x07, 0x78, 0x07, 0x79, 0x07, 0x7a, 0x00, 0xc6, 0x07, 0x7b,
-  0x07, 0x7c, 0x07, 0x7d, 0x07, 0x7e, 0x07, 0x7f, 0x07, 0x80, 0x07, 0x81,
-  0x07, 0x82, 0x00, 0xbe, 0x00, 0xbf, 0x07, 0x83, 0x07, 0x84, 0x07, 0x85,
-  0x07, 0x86, 0x07, 0x87, 0x07, 0x88, 0x07, 0x89, 0x07, 0x8a, 0x07, 0x8b,
-  0x00, 0xbc, 0x07, 0x8c, 0x07, 0x8d, 0x07, 0x8e, 0x07, 0x8f, 0x07, 0x90,
-  0x07, 0x91, 0x07, 0x92, 0x07, 0x93, 0x07, 0x94, 0x07, 0x95, 0x07, 0x96,
-  0x07, 0x97, 0x07, 0x98, 0x07, 0x99, 0x07, 0x9a, 0x07, 0x9b, 0x07, 0x9c,
-  0x07, 0x9d, 0x07, 0x9e, 0x07, 0x9f, 0x07, 0xa0, 0x07, 0xa1, 0x07, 0xa2,
-  0x07, 0xa3, 0x07, 0xa4, 0x07, 0xa5, 0x07, 0xa6, 0x07, 0xa7, 0x07, 0xa8,
-  0x07, 0xa9, 0x07, 0xaa, 0x07, 0xab, 0x07, 0xac, 0x07, 0xad, 0x07, 0xae,
-  0x07, 0xaf, 0x07, 0xb0, 0x07, 0xb1, 0x07, 0xb2, 0x07, 0xb3, 0x07, 0xb4,
-  0x07, 0xb5, 0x07, 0xb6, 0x07, 0xb7, 0x07, 0xb8, 0x07, 0xb9, 0x07, 0xba,
-  0x07, 0xbb, 0x07, 0xbc, 0x07, 0xbd, 0x07, 0xbe, 0x07, 0xbf, 0x07, 0xc0,
-  0x07, 0xc1, 0x07, 0xc2, 0x07, 0xc3, 0x07, 0xc4, 0x07, 0xc5, 0x07, 0xc6,
-  0x07, 0xc7, 0x07, 0xc8, 0x07, 0xc9, 0x07, 0xca, 0x07, 0xcb, 0x07, 0xcc,
-  0x07, 0xcd, 0x07, 0xce, 0x07, 0xcf, 0x07, 0xd0, 0x07, 0xd1, 0x07, 0xd2,
-  0x07, 0xd3, 0x07, 0xd4, 0x07, 0xd5, 0x07, 0xd6, 0x07, 0xd7, 0x07, 0xd8,
-  0x07, 0xd9, 0x07, 0xda, 0x07, 0xdb, 0x07, 0xdc, 0x07, 0xdd, 0x07, 0xde,
-  0x00, 0xf7, 0x07, 0xdf, 0x07, 0xe0, 0x07, 0xe1, 0x07, 0xe2, 0x07, 0xe3,
-  0x07, 0xe4, 0x07, 0xe5, 0x07, 0xe6, 0x07, 0xe7, 0x07, 0xe8, 0x07, 0xe9,
-  0x07, 0xea, 0x07, 0xeb, 0x07, 0xec, 0x07, 0xed, 0x07, 0xee, 0x07, 0xef,
-  0x07, 0xf0, 0x07, 0xf1, 0x07, 0xf2, 0x07, 0xf3, 0x07, 0xf4, 0x07, 0xf5,
-  0x07, 0xf6, 0x07, 0xf7, 0x07, 0xf8, 0x07, 0xf9, 0x07, 0xfa, 0x07, 0xfb,
-  0x07, 0xfc, 0x07, 0xfd, 0x07, 0xfe, 0x07, 0xff, 0x08, 0x00, 0x08, 0x01,
-  0x08, 0x02, 0x08, 0x03, 0x08, 0x04, 0x08, 0x05, 0x08, 0x06, 0x08, 0x07,
-  0x08, 0x08, 0x08, 0x09, 0x08, 0x0a, 0x08, 0x0b, 0x08, 0x0c, 0x08, 0x0d,
-  0x08, 0x0e, 0x08, 0x0f, 0x08, 0x10, 0x08, 0x11, 0x08, 0x12, 0x08, 0x13,
-  0x08, 0x14, 0x08, 0x15, 0x08, 0x16, 0x08, 0x17, 0x08, 0x18, 0x08, 0x19,
-  0x08, 0x1a, 0x08, 0x1b, 0x00, 0x8c, 0x08, 0x1c, 0x08, 0x1d, 0x08, 0x1e,
-  0x08, 0x1f, 0x08, 0x20, 0x08, 0x21, 0x08, 0x22, 0x08, 0x23, 0x08, 0x24,
-  0x08, 0x25, 0x08, 0x26, 0x08, 0x27, 0x08, 0x28, 0x08, 0x29, 0x08, 0x2a,
-  0x08, 0x2b, 0x08, 0x2c, 0x08, 0x2d, 0x08, 0x2e, 0x08, 0x2f, 0x08, 0x30,
-  0x08, 0x31, 0x08, 0x32, 0x08, 0x33, 0x08, 0x34, 0x08, 0x35, 0x08, 0x36,
-  0x08, 0x37, 0x08, 0x38, 0x08, 0x39, 0x08, 0x3a, 0x08, 0x3b, 0x08, 0x3c,
-  0x08, 0x3d, 0x08, 0x3e, 0x08, 0x3f, 0x08, 0x40, 0x08, 0x41, 0x08, 0x42,
-  0x08, 0x43, 0x08, 0x44, 0x08, 0x45, 0x08, 0x46, 0x08, 0x47, 0x08, 0x48,
-  0x08, 0x49, 0x08, 0x4a, 0x08, 0x4b, 0x08, 0x4c, 0x08, 0x4d, 0x08, 0x4e,
-  0x08, 0x4f, 0x08, 0x50, 0x08, 0x51, 0x08, 0x52, 0x08, 0x53, 0x08, 0x54,
-  0x08, 0x55, 0x08, 0x56, 0x08, 0x57, 0x08, 0x58, 0x08, 0x59, 0x08, 0x5a,
-  0x08, 0x5b, 0x08, 0x5c, 0x08, 0x5d, 0x08, 0x5e, 0x08, 0x5f, 0x08, 0x60,
-  0x08, 0x61, 0x08, 0x62, 0x08, 0x63, 0x08, 0x64, 0x08, 0x65, 0x08, 0x66,
-  0x08, 0x67, 0x08, 0x68, 0x08, 0x69, 0x08, 0x6a, 0x08, 0x6b, 0x08, 0x6c,
-  0x08, 0x6d, 0x08, 0x6e, 0x08, 0x6f, 0x08, 0x70, 0x08, 0x71, 0x08, 0x72,
-  0x08, 0x73, 0x08, 0x74, 0x08, 0x75, 0x08, 0x76, 0x08, 0x77, 0x08, 0x78,
-  0x08, 0x79, 0x08, 0x7a, 0x08, 0x7b, 0x08, 0x7c, 0x08, 0x7d, 0x08, 0x7e,
-  0x08, 0x7f, 0x08, 0x80, 0x08, 0x81, 0x08, 0x82, 0x08, 0x83, 0x08, 0x84,
-  0x08, 0x85, 0x08, 0x86, 0x08, 0x87, 0x08, 0x88, 0x08, 0x89, 0x08, 0x8a,
-  0x08, 0x8b, 0x08, 0x8c, 0x08, 0x8d, 0x08, 0x8e, 0x08, 0x8f, 0x08, 0x90,
-  0x08, 0x91, 0x08, 0x92, 0x08, 0x93, 0x08, 0x94, 0x08, 0x95, 0x08, 0x96,
-  0x08, 0x97, 0x08, 0x98, 0x08, 0x99, 0x08, 0x9a, 0x08, 0x9b, 0x08, 0x9c,
-  0x08, 0x9d, 0x08, 0x9e, 0x08, 0x9f, 0x08, 0xa0, 0x08, 0xa1, 0x08, 0xa2,
-  0x08, 0xa3, 0x08, 0xa4, 0x08, 0xa5, 0x08, 0xa6, 0x08, 0xa7, 0x08, 0xa8,
-  0x08, 0xa9, 0x08, 0xaa, 0x08, 0xab, 0x08, 0xac, 0x08, 0xad, 0x08, 0xae,
-  0x08, 0xaf, 0x08, 0xb0, 0x08, 0xb1, 0x08, 0xb2, 0x08, 0xb3, 0x08, 0xb4,
-  0x08, 0xb5, 0x08, 0xb6, 0x08, 0xb7, 0x08, 0xb8, 0x08, 0xb9, 0x08, 0xba,
-  0x08, 0xbb, 0x08, 0xbc, 0x08, 0xbd, 0x08, 0xbe, 0x08, 0xbf, 0x08, 0xc0,
-  0x08, 0xc1, 0x08, 0xc2, 0x08, 0xc3, 0x08, 0xc4, 0x08, 0xc5, 0x08, 0xc6,
-  0x08, 0xc7, 0x08, 0xc8, 0x08, 0xc9, 0x08, 0xca, 0x08, 0xcb, 0x08, 0xcc,
-  0x08, 0xcd, 0x08, 0xce, 0x08, 0xcf, 0x08, 0xd0, 0x08, 0xd1, 0x08, 0xd2,
-  0x08, 0xd3, 0x08, 0xd4, 0x08, 0xd5, 0x08, 0xd6, 0x08, 0xd7, 0x08, 0xd8,
-  0x08, 0xd9, 0x08, 0xda, 0x08, 0xdb, 0x08, 0xdc, 0x08, 0xdd, 0x08, 0xde,
-  0x08, 0xdf, 0x08, 0xe0, 0x08, 0xe1, 0x08, 0xe2, 0x08, 0xe3, 0x08, 0xe4,
-  0x08, 0xe5, 0x08, 0xe6, 0x08, 0xe7, 0x08, 0xe8, 0x08, 0xe9, 0x08, 0xea,
-  0x08, 0xeb, 0x08, 0xec, 0x08, 0xed, 0x00, 0x98, 0x08, 0xee, 0x08, 0xef,
-  0x08, 0xf0, 0x00, 0xa8, 0x08, 0xf1, 0x08, 0xf2, 0x08, 0xf3, 0x08, 0xf4,
-  0x08, 0xf5, 0x08, 0xf6, 0x08, 0xf7, 0x08, 0xf8, 0x00, 0x9a, 0x08, 0xf9,
-  0x00, 0x99, 0x00, 0xef, 0x08, 0xfa, 0x08, 0xfb, 0x08, 0xfc, 0x08, 0xfd,
-  0x08, 0xfe, 0x08, 0xff, 0x09, 0x00, 0x00, 0xa5, 0x09, 0x01, 0x09, 0x02,
-  0x09, 0x03, 0x00, 0x92, 0x09, 0x04, 0x09, 0x05, 0x09, 0x06, 0x09, 0x07,
-  0x09, 0x08, 0x09, 0x09, 0x09, 0x0a, 0x09, 0x0b, 0x09, 0x0c, 0x09, 0x0d,
-  0x09, 0x0e, 0x09, 0x0f, 0x00, 0x9c, 0x09, 0x10, 0x09, 0x11, 0x09, 0x12,
-  0x09, 0x13, 0x09, 0x14, 0x09, 0x15, 0x09, 0x16, 0x09, 0x17, 0x09, 0x18,
-  0x09, 0x19, 0x09, 0x1a, 0x09, 0x1b, 0x09, 0x1c, 0x09, 0x1d, 0x09, 0x1e,
-  0x09, 0x1f, 0x09, 0x20, 0x09, 0x21, 0x09, 0x22, 0x09, 0x23, 0x09, 0x24,
-  0x09, 0x25, 0x09, 0x26, 0x09, 0x27, 0x09, 0x28, 0x09, 0x29, 0x09, 0x2a,
-  0x09, 0x2b, 0x00, 0xa7, 0x09, 0x2c, 0x09, 0x2d, 0x09, 0x2e, 0x09, 0x2f,
-  0x09, 0x30, 0x09, 0x31, 0x09, 0x32, 0x09, 0x33, 0x09, 0x34, 0x09, 0x35,
-  0x09, 0x36, 0x09, 0x37, 0x09, 0x38, 0x09, 0x39, 0x09, 0x3a, 0x09, 0x3b,
-  0x09, 0x3c, 0x09, 0x3d, 0x09, 0x3e, 0x09, 0x3f, 0x09, 0x40, 0x09, 0x41,
-  0x09, 0x42, 0x00, 0x8f, 0x09, 0x43, 0x09, 0x44, 0x09, 0x45, 0x00, 0x94,
-  0x00, 0x95, 0x09, 0x46, 0x09, 0x47, 0x09, 0x48, 0x09, 0x49, 0x09, 0x4a,
-  0x09, 0x4b, 0x09, 0x4c, 0x09, 0x4d, 0x09, 0x4e, 0x09, 0x4f, 0x09, 0x50,
-  0x09, 0x51, 0x09, 0x52, 0x09, 0x53, 0x09, 0x54, 0x09, 0x55, 0x09, 0x56,
-  0x09, 0x57, 0x09, 0x58, 0x09, 0x59, 0x09, 0x5a, 0x09, 0x5b, 0x09, 0x5c,
-  0x09, 0x5d, 0x09, 0x5e, 0x09, 0x5f, 0x09, 0x60, 0x09, 0x61, 0x09, 0x62,
-  0x09, 0x63, 0x09, 0x64, 0x09, 0x65, 0x09, 0x66, 0x09, 0x67, 0x09, 0x68,
-  0x09, 0x69, 0x09, 0x6a, 0x09, 0x6b, 0x09, 0x6c, 0x09, 0x6d, 0x09, 0x6e,
-  0x09, 0x6f, 0x09, 0x70, 0x09, 0x71, 0x09, 0x72, 0x09, 0x73, 0x09, 0x74,
-  0x09, 0x75, 0x09, 0x76, 0x09, 0x77, 0x09, 0x78, 0x09, 0x79, 0x09, 0x7a,
-  0x09, 0x7b, 0x09, 0x7c, 0x09, 0x7d, 0x09, 0x7e, 0x09, 0x7f, 0x09, 0x80,
-  0x09, 0x81, 0x09, 0x82, 0x09, 0x83, 0x09, 0x84, 0x09, 0x85, 0x09, 0x86,
-  0x09, 0x87, 0x09, 0x88, 0x09, 0x89, 0x09, 0x8a, 0x09, 0x8b, 0x09, 0x8c,
-  0x09, 0x8d, 0x09, 0x8e, 0x09, 0x8f, 0x09, 0x90, 0x09, 0x91, 0x09, 0x92,
-  0x09, 0x93, 0x09, 0x94, 0x09, 0x95, 0x09, 0x96, 0x09, 0x97, 0x09, 0x98,
-  0x09, 0x99, 0x09, 0x9a, 0x09, 0x9b, 0x09, 0x9c, 0x09, 0x9d, 0x09, 0x9e,
-  0x09, 0x9f, 0x09, 0xa0, 0x09, 0xa1, 0x09, 0xa2, 0x09, 0xa3, 0x09, 0xa4,
-  0x09, 0xa5, 0x09, 0xa6, 0x09, 0xa7, 0x09, 0xa8, 0x09, 0xa9, 0x09, 0xaa,
-  0x09, 0xab, 0x09, 0xac, 0x09, 0xad, 0x09, 0xae, 0x09, 0xaf, 0x09, 0xb0,
-  0x09, 0xb1, 0x09, 0xb2, 0x09, 0xb3, 0x09, 0xb4, 0x09, 0xb5, 0x09, 0xb6,
-  0x09, 0xb7, 0x09, 0xb8, 0x09, 0xb9, 0x09, 0xba, 0x09, 0xbb, 0x09, 0xbc,
-  0x09, 0xbd, 0x09, 0xbe, 0x09, 0xbf, 0x09, 0xc0, 0x09, 0xc1, 0x09, 0xc2,
-  0x09, 0xc3, 0x09, 0xc4, 0x09, 0xc5, 0x09, 0xc6, 0x09, 0xc7, 0x09, 0xc8,
-  0x09, 0xc9, 0x09, 0xca, 0x09, 0xcb, 0x09, 0xcc, 0x09, 0xcd, 0x09, 0xce,
-  0x09, 0xcf, 0x09, 0xd0, 0x09, 0xd1, 0x09, 0xd2, 0x09, 0xd3, 0x09, 0xd4,
-  0x09, 0xd5, 0x09, 0xd6, 0x09, 0xd7, 0x09, 0xd8, 0x09, 0xd9, 0x09, 0xda,
-  0x09, 0xdb, 0x09, 0xdc, 0x09, 0xdd, 0x09, 0xde, 0x09, 0xdf, 0x09, 0xe0,
-  0x09, 0xe1, 0x09, 0xe2, 0x09, 0xe3, 0x09, 0xe4, 0x09, 0xe5, 0x09, 0xe6,
-  0x09, 0xe7, 0x09, 0xe8, 0x09, 0xe9, 0x09, 0xea, 0x09, 0xeb, 0x09, 0xec,
-  0x09, 0xed, 0x09, 0xee, 0x09, 0xef, 0x09, 0xf0, 0x09, 0xf1, 0x09, 0xf2,
-  0x09, 0xf3, 0x09, 0xf4, 0x09, 0xf5, 0x09, 0xf6, 0x09, 0xf7, 0x09, 0xf8,
-  0x09, 0xf9, 0x09, 0xfa, 0x09, 0xfb, 0x09, 0xfc, 0x09, 0xfd, 0x09, 0xfe,
-  0x09, 0xff, 0x0a, 0x00, 0x0a, 0x01, 0x0a, 0x02, 0x0a, 0x03, 0x0a, 0x04,
-  0x0a, 0x05, 0x0a, 0x06, 0x0a, 0x07, 0x0a, 0x08, 0x0a, 0x09, 0x0a, 0x0a,
-  0x0a, 0x0b, 0x0a, 0x0c, 0x0a, 0x0d, 0x0a, 0x0e, 0x0a, 0x0f, 0x0a, 0x10,
-  0x0a, 0x11, 0x0a, 0x12, 0x0a, 0x13, 0x0a, 0x14, 0x0a, 0x15, 0x0a, 0x16,
-  0x0a, 0x17, 0x0a, 0x18, 0x0a, 0x19, 0x0a, 0x1a, 0x0a, 0x1b, 0x0a, 0x1c,
-  0x0a, 0x1d, 0x0a, 0x1e, 0x0a, 0x1f, 0x0a, 0x20, 0x0a, 0x21, 0x0a, 0x22,
-  0x0a, 0x23, 0x0a, 0x24, 0x0a, 0x25, 0x0a, 0x26, 0x0a, 0x27, 0x0a, 0x28,
-  0x0a, 0x29, 0x0a, 0x2a, 0x0a, 0x2b, 0x0a, 0x2c, 0x0a, 0x2d, 0x0a, 0x2e,
-  0x0a, 0x2f, 0x0a, 0x30, 0x0a, 0x31, 0x0a, 0x32, 0x0a, 0x33, 0x0a, 0x34,
-  0x0a, 0x35, 0x0a, 0x36, 0x0a, 0x37, 0x0a, 0x38, 0x0a, 0x39, 0x0a, 0x3a,
-  0x0a, 0x3b, 0x0a, 0x3c, 0x0a, 0x3d, 0x0a, 0x3e, 0x0a, 0x3f, 0x0a, 0x40,
-  0x0a, 0x41, 0x0a, 0x42, 0x0a, 0x43, 0x0a, 0x44, 0x0a, 0x45, 0x0a, 0x46,
-  0x0a, 0x47, 0x0a, 0x48, 0x0a, 0x49, 0x0a, 0x4a, 0x0a, 0x4b, 0x0a, 0x4c,
-  0x0a, 0x4d, 0x0a, 0x4e, 0x0a, 0x4f, 0x0a, 0x50, 0x0a, 0x51, 0x0a, 0x52,
-  0x0a, 0x53, 0x0a, 0x54, 0x0a, 0x55, 0x0a, 0x56, 0x0a, 0x57, 0x0a, 0x58,
-  0x0a, 0x59, 0x0a, 0x5a, 0x0a, 0x5b, 0x0a, 0x5c, 0x0a, 0x5d, 0x0a, 0x5e,
-  0x0a, 0x5f, 0x0a, 0x60, 0x0a, 0x61, 0x0a, 0x62, 0x0a, 0x63, 0x0a, 0x64,
-  0x0a, 0x65, 0x0a, 0x66, 0x0a, 0x67, 0x0a, 0x68, 0x0a, 0x69, 0x0a, 0x6a,
-  0x0a, 0x6b, 0x0a, 0x6c, 0x0a, 0x6d, 0x0a, 0x6e, 0x0a, 0x6f, 0x0a, 0x70,
-  0x0a, 0x71, 0x0a, 0x72, 0x0a, 0x73, 0x0a, 0x74, 0x0a, 0x75, 0x0a, 0x76,
-  0x0a, 0x77, 0x0a, 0x78, 0x0a, 0x79, 0x0a, 0x7a, 0x0a, 0x7b, 0x0a, 0x7c,
-  0x0a, 0x7d, 0x0a, 0x7e, 0x0a, 0x7f, 0x0a, 0x80, 0x0a, 0x81, 0x0a, 0x82,
-  0x0a, 0x83, 0x0a, 0x84, 0x0a, 0x85, 0x0a, 0x86, 0x0a, 0x87, 0x0a, 0x88,
-  0x0a, 0x89, 0x0a, 0x8a, 0x0a, 0x8b, 0x0a, 0x8c, 0x0a, 0x8d, 0x0a, 0x8e,
-  0x0a, 0x8f, 0x0a, 0x90, 0x0a, 0x91, 0x0a, 0x92, 0x0a, 0x93, 0x0a, 0x94,
-  0x0a, 0x95, 0x0a, 0x96, 0x0a, 0x97, 0x0a, 0x98, 0x0a, 0x99, 0x0a, 0x9a,
-  0x0a, 0x9b, 0x0a, 0x9c, 0x0a, 0x9d, 0x0a, 0x9e, 0x0a, 0x9f, 0x0a, 0xa0,
-  0x0a, 0xa1, 0x0a, 0xa2, 0x0a, 0xa3, 0x0a, 0xa4, 0x0a, 0xa5, 0x0a, 0xa6,
-  0x0a, 0xa7, 0x0a, 0xa8, 0x0a, 0xa9, 0x0a, 0xaa, 0x0a, 0xab, 0x0a, 0xac,
-  0x0a, 0xad, 0x0a, 0xae, 0x0a, 0xaf, 0x0a, 0xb0, 0x0a, 0xb1, 0x0a, 0xb2,
-  0x0a, 0xb3, 0x0a, 0xb4, 0x0a, 0xb5, 0x0a, 0xb6, 0x0a, 0xb7, 0x0a, 0xb8,
-  0x0a, 0xb9, 0x0a, 0xba, 0x0a, 0xbb, 0x0a, 0xbc, 0x0a, 0xbd, 0x0a, 0xbe,
-  0x0a, 0xbf, 0x0a, 0xc0, 0x0a, 0xc1, 0x0a, 0xc2, 0x0a, 0xc3, 0x0a, 0xc4,
-  0x0a, 0xc5, 0x0a, 0xc6, 0x0a, 0xc7, 0x0a, 0xc8, 0x0a, 0xc9, 0x0a, 0xca,
-  0x0a, 0xcb, 0x0a, 0xcc, 0x0a, 0xcd, 0x0a, 0xce, 0x0a, 0xcf, 0x0a, 0xd0,
-  0x0a, 0xd1, 0x0a, 0xd2, 0x0a, 0xd3, 0x0a, 0xd4, 0x0a, 0xd5, 0x0a, 0xd6,
-  0x0a, 0xd7, 0x0a, 0xd8, 0x0a, 0xd9, 0x0a, 0xda, 0x0a, 0xdb, 0x0a, 0xdc,
-  0x0a, 0xdd, 0x0a, 0xde, 0x0a, 0xdf, 0x0a, 0xe0, 0x0a, 0xe1, 0x0a, 0xe2,
-  0x0a, 0xe3, 0x0a, 0xe4, 0x0a, 0xe5, 0x0a, 0xe6, 0x0a, 0xe7, 0x0a, 0xe8,
-  0x0a, 0xe9, 0x0a, 0xea, 0x0a, 0xeb, 0x0a, 0xec, 0x0a, 0xed, 0x0a, 0xee,
-  0x0a, 0xef, 0x0a, 0xf0, 0x0a, 0xf1, 0x0a, 0xf2, 0x0a, 0xf3, 0x0a, 0xf4,
-  0x0a, 0xf5, 0x0a, 0xf6, 0x00, 0xb9, 0x0a, 0xf7, 0x0a, 0xf8, 0x0a, 0xf9,
-  0x0a, 0xfa, 0x0a, 0xfb, 0x0a, 0xfc, 0x0a, 0xfd, 0x0a, 0xfe, 0x0a, 0xff,
-  0x0b, 0x00, 0x0b, 0x01, 0x0b, 0x02, 0x0b, 0x03, 0x0b, 0x04, 0x0b, 0x05,
-  0x0b, 0x06, 0x0b, 0x07, 0x0b, 0x08, 0x0b, 0x09, 0x0b, 0x0a, 0x0b, 0x0b,
-  0x0b, 0x0c, 0x0b, 0x0d, 0x0b, 0x0e, 0x0b, 0x0f, 0x0b, 0x10, 0x0b, 0x11,
-  0x0b, 0x12, 0x0b, 0x13, 0x0b, 0x14, 0x0b, 0x15, 0x0b, 0x16, 0x0b, 0x17,
-  0x0b, 0x18, 0x0b, 0x19, 0x0b, 0x1a, 0x0b, 0x1b, 0x0b, 0x1c, 0x0b, 0x1d,
-  0x0b, 0x1e, 0x0b, 0x1f, 0x0b, 0x20, 0x0b, 0x21, 0x0b, 0x22, 0x0b, 0x23,
-  0x0b, 0x24, 0x0b, 0x25, 0x0b, 0x26, 0x0b, 0x27, 0x0b, 0x28, 0x0b, 0x29,
-  0x0b, 0x2a, 0x0b, 0x2b, 0x0b, 0x2c, 0x0b, 0x2d, 0x0b, 0x2e, 0x0b, 0x2f,
-  0x0b, 0x30, 0x0b, 0x31, 0x0b, 0x32, 0x0b, 0x33, 0x0b, 0x34, 0x0b, 0x35,
-  0x0b, 0x36, 0x0b, 0x37, 0x0b, 0x38, 0x0b, 0x39, 0x0b, 0x3a, 0x0b, 0x3b,
-  0x0b, 0x3c, 0x0b, 0x3d, 0x0b, 0x3e, 0x0b, 0x3f, 0x0b, 0x40, 0x0b, 0x41,
-  0x0b, 0x42, 0x0b, 0x43, 0x0b, 0x44, 0x0b, 0x45, 0x0b, 0x46, 0x0b, 0x47,
-  0x0b, 0x48, 0x0b, 0x49, 0x0b, 0x4a, 0x0b, 0x4b, 0x0b, 0x4c, 0x0b, 0x4d,
-  0x0b, 0x4e, 0x0b, 0x4f, 0x0b, 0x50, 0x0b, 0x51, 0x0b, 0x52, 0x0b, 0x53,
-  0x0b, 0x54, 0x0b, 0x55, 0x0b, 0x56, 0x0b, 0x57, 0x0b, 0x58, 0x0b, 0x59,
-  0x0b, 0x5a, 0x0b, 0x5b, 0x0b, 0x5c, 0x0b, 0x5d, 0x0b, 0x5e, 0x0b, 0x5f,
-  0x0b, 0x60, 0x0b, 0x61, 0x0b, 0x62, 0x0b, 0x63, 0x0b, 0x64, 0x0b, 0x65,
-  0x0b, 0x66, 0x0b, 0x67, 0x0b, 0x68, 0x0b, 0x69, 0x0b, 0x6a, 0x0b, 0x6b,
-  0x0b, 0x6c, 0x0b, 0x6d, 0x0b, 0x6e, 0x0b, 0x6f, 0x0b, 0x70, 0x0b, 0x71,
-  0x0b, 0x72, 0x0b, 0x73, 0x0b, 0x74, 0x0b, 0x75, 0x0b, 0x76, 0x0b, 0x77,
-  0x0b, 0x78, 0x0b, 0x79, 0x0b, 0x7a, 0x0b, 0x7b, 0x0b, 0x7c, 0x0b, 0x7d,
-  0x0b, 0x7e, 0x0b, 0x7f, 0x0b, 0x80, 0x0b, 0x81, 0x0b, 0x82, 0x0b, 0x83,
-  0x0b, 0x84, 0x0b, 0x85, 0x0b, 0x86, 0x0b, 0x87, 0x0b, 0x88, 0x0b, 0x89,
-  0x0b, 0x8a, 0x0b, 0x8b, 0x0b, 0x8c, 0x0b, 0x8d, 0x0b, 0x8e, 0x0b, 0x8f,
-  0x0b, 0x90, 0x0b, 0x91, 0x0b, 0x92, 0x0b, 0x93, 0x0b, 0x94, 0x0b, 0x95,
-  0x0b, 0x96, 0x0b, 0x97, 0x0b, 0x98, 0x0b, 0x99, 0x0b, 0x9a, 0x0b, 0x9b,
-  0x0b, 0x9c, 0x0b, 0x9d, 0x0b, 0x9e, 0x0b, 0x9f, 0x0b, 0xa0, 0x0b, 0xa1,
-  0x0b, 0xa2, 0x0b, 0xa3, 0x0b, 0xa4, 0x0b, 0xa5, 0x0b, 0xa6, 0x0b, 0xa7,
-  0x0b, 0xa8, 0x0b, 0xa9, 0x0b, 0xaa, 0x0b, 0xab, 0x0b, 0xac, 0x0b, 0xad,
-  0x0b, 0xae, 0x0b, 0xaf, 0x0b, 0xb0, 0x0b, 0xb1, 0x0b, 0xb2, 0x0b, 0xb3,
-  0x0b, 0xb4, 0x0b, 0xb5, 0x0b, 0xb6, 0x0b, 0xb7, 0x0b, 0xb8, 0x0b, 0xb9,
-  0x0b, 0xba, 0x0b, 0xbb, 0x0b, 0xbc, 0x0b, 0xbd, 0x0b, 0xbe, 0x0b, 0xbf,
-  0x0b, 0xc0, 0x0b, 0xc1, 0x0b, 0xc2, 0x0b, 0xc3, 0x0b, 0xc4, 0x0b, 0xc5,
-  0x0b, 0xc6, 0x0b, 0xc7, 0x0b, 0xc8, 0x0b, 0xc9, 0x0b, 0xca, 0x0b, 0xcb,
-  0x0b, 0xcc, 0x0b, 0xcd, 0x0b, 0xce, 0x0b, 0xcf, 0x0b, 0xd0, 0x0b, 0xd1,
-  0x0b, 0xd2, 0x0b, 0xd3, 0x0b, 0xd4, 0x0b, 0xd5, 0x0b, 0xd6, 0x0b, 0xd7,
-  0x0b, 0xd8, 0x0b, 0xd9, 0x0b, 0xda, 0x0b, 0xdb, 0x0b, 0xdc, 0x0b, 0xdd,
-  0x0b, 0xde, 0x0b, 0xdf, 0x0b, 0xe0, 0x0b, 0xe1, 0x0b, 0xe2, 0x0b, 0xe3,
-  0x0b, 0xe4, 0x0b, 0xe5, 0x0b, 0xe6, 0x0b, 0xe7, 0x0b, 0xe8, 0x0b, 0xe9,
-  0x0b, 0xea, 0x0b, 0xeb, 0x0b, 0xec, 0x0b, 0xed, 0x0b, 0xee, 0x0b, 0xef,
-  0x0b, 0xf0, 0x0b, 0xf1, 0x0b, 0xf2, 0x0b, 0xf3, 0x0b, 0xf4, 0x0b, 0xf5,
-  0x0b, 0xf6, 0x0b, 0xf7, 0x0b, 0xf8, 0x0b, 0xf9, 0x0b, 0xfa, 0x0b, 0xfb,
-  0x0b, 0xfc, 0x0b, 0xfd, 0x0b, 0xfe, 0x0b, 0xff, 0x0c, 0x00, 0x0c, 0x01,
-  0x0c, 0x02, 0x0c, 0x03, 0x0c, 0x04, 0x0c, 0x05, 0x0c, 0x06, 0x0c, 0x07,
-  0x0c, 0x08, 0x0c, 0x09, 0x0c, 0x0a, 0x0c, 0x0b, 0x0c, 0x0c, 0x0c, 0x0d,
-  0x0c, 0x0e, 0x0c, 0x0f, 0x0c, 0x10, 0x0c, 0x11, 0x0c, 0x12, 0x0c, 0x13,
-  0x0c, 0x14, 0x0c, 0x15, 0x0c, 0x16, 0x0c, 0x17, 0x0c, 0x18, 0x0c, 0x19,
-  0x0c, 0x1a, 0x0c, 0x1b, 0x0c, 0x1c, 0x0c, 0x1d, 0x0c, 0x1e, 0x0c, 0x1f,
-  0x0c, 0x20, 0x0c, 0x21, 0x0c, 0x22, 0x0c, 0x23, 0x0c, 0x24, 0x0c, 0x25,
-  0x0c, 0x26, 0x0c, 0x27, 0x0c, 0x28, 0x0c, 0x29, 0x0c, 0x2a, 0x0c, 0x2b,
-  0x0c, 0x2c, 0x0c, 0x2d, 0x0c, 0x2e, 0x0c, 0x2f, 0x0c, 0x30, 0x0c, 0x31,
-  0x0c, 0x32, 0x0c, 0x33, 0x0c, 0x34, 0x0c, 0x35, 0x0c, 0x36, 0x0c, 0x37,
-  0x0c, 0x38, 0x0c, 0x39, 0x0c, 0x3a, 0x0c, 0x3b, 0x0c, 0x3c, 0x0c, 0x3d,
-  0x0c, 0x3e, 0x0c, 0x3f, 0x0c, 0x40, 0x0c, 0x41, 0x0c, 0x42, 0x0c, 0x43,
-  0x0c, 0x44, 0x0c, 0x45, 0x0c, 0x46, 0x0c, 0x47, 0x0c, 0x48, 0x0c, 0x49,
-  0x0c, 0x4a, 0x0c, 0x4b, 0x0c, 0x4c, 0x0c, 0x4d, 0x0c, 0x4e, 0x0c, 0x4f,
-  0x0c, 0x50, 0x0c, 0x51, 0x0c, 0x52, 0x0c, 0x53, 0x0c, 0x54, 0x0c, 0x55,
-  0x0c, 0x56, 0x0c, 0x57, 0x0c, 0x58, 0x0c, 0x59, 0x0c, 0x5a, 0x0c, 0x5b,
-  0x0c, 0x5c, 0x0c, 0x5d, 0x0c, 0x5e, 0x0c, 0x5f, 0x0c, 0x60, 0x0c, 0x61,
-  0x0c, 0x62, 0x0c, 0x63, 0x0c, 0x64, 0x0c, 0x65, 0x0c, 0x66, 0x0c, 0x67,
-  0x0c, 0x68, 0x0c, 0x69, 0x0c, 0x6a, 0x0c, 0x6b, 0x0c, 0x6c, 0x0c, 0x6d,
-  0x0c, 0x6e, 0x0c, 0x6f, 0x0c, 0x70, 0x0c, 0x71, 0x0c, 0x72, 0x0c, 0x73,
-  0x0c, 0x74, 0x0c, 0x75, 0x0c, 0x76, 0x0c, 0x77, 0x0c, 0x78, 0x0c, 0x79,
-  0x0c, 0x7a, 0x0c, 0x7b, 0x0c, 0x7c, 0x0c, 0x7d, 0x0c, 0x7e, 0x0c, 0x7f,
-  0x0c, 0x80, 0x0c, 0x81, 0x0c, 0x82, 0x0c, 0x83, 0x0c, 0x84, 0x0c, 0x85,
-  0x0c, 0x86, 0x0c, 0x87, 0x0c, 0x88, 0x0c, 0x89, 0x0c, 0x8a, 0x0c, 0x8b,
-  0x0c, 0x8c, 0x0c, 0x8d, 0x0c, 0x8e, 0x0c, 0x8f, 0x0c, 0x90, 0x0c, 0x91,
-  0x0c, 0x92, 0x0c, 0x93, 0x0c, 0x94, 0x0c, 0x95, 0x0c, 0x96, 0x0c, 0x97,
-  0x0c, 0x98, 0x0c, 0x99, 0x0c, 0x9a, 0x0c, 0x9b, 0x0c, 0x9c, 0x0c, 0x9d,
-  0x0c, 0x9e, 0x0c, 0x9f, 0x0c, 0xa0, 0x0c, 0xa1, 0x0c, 0xa2, 0x0c, 0xa3,
-  0x0c, 0xa4, 0x0c, 0xa5, 0x0c, 0xa6, 0x0c, 0xa7, 0x0c, 0xa8, 0x0c, 0xa9,
-  0x0c, 0xaa, 0x0c, 0xab, 0x0c, 0xac, 0x0c, 0xad, 0x0c, 0xae, 0x0c, 0xaf,
-  0x0c, 0xb0, 0x0c, 0xb1, 0x0c, 0xb2, 0x0c, 0xb3, 0x0c, 0xb4, 0x0c, 0xb5,
-  0x0c, 0xb6, 0x0c, 0xb7, 0x0c, 0xb8, 0x0c, 0xb9, 0x0c, 0xba, 0x0c, 0xbb,
-  0x0c, 0xbc, 0x0c, 0xbd, 0x0c, 0xbe, 0x0c, 0xbf, 0x0c, 0xc0, 0x0c, 0xc1,
-  0x0c, 0xc2, 0x0c, 0xc3, 0x0c, 0xc4, 0x0c, 0xc5, 0x0c, 0xc6, 0x0c, 0xc7,
-  0x0c, 0xc8, 0x0c, 0xc9, 0x0c, 0xca, 0x0c, 0xcb, 0x0c, 0xcc, 0x0c, 0xcd,
-  0x0c, 0xce, 0x0c, 0xcf, 0x0c, 0xd0, 0x0c, 0xd1, 0x0c, 0xd2, 0x0c, 0xd3,
-  0x0c, 0xd4, 0x0c, 0xd5, 0x0c, 0xd6, 0x0c, 0xd7, 0x0c, 0xd8, 0x0c, 0xd9,
-  0x0c, 0xda, 0x0c, 0xdb, 0x0c, 0xdc, 0x0c, 0xdd, 0x0c, 0xde, 0x0c, 0xdf,
-  0x0c, 0xe0, 0x0c, 0xe1, 0x0c, 0xe2, 0x0c, 0xe3, 0x0c, 0xe4, 0x0c, 0xe5,
-  0x0c, 0xe6, 0x0c, 0xe7, 0x0c, 0xe8, 0x0c, 0xe9, 0x0c, 0xea, 0x0c, 0xeb,
-  0x0c, 0xec, 0x0c, 0xed, 0x0c, 0xee, 0x0c, 0xef, 0x0c, 0xf0, 0x0c, 0xf1,
-  0x0c, 0xf2, 0x0c, 0xf3, 0x0c, 0xf4, 0x0c, 0xf5, 0x0c, 0xf6, 0x0c, 0xf7,
-  0x0c, 0xf8, 0x0c, 0xf9, 0x0c, 0xfa, 0x0c, 0xfb, 0x0c, 0xfc, 0x0c, 0xfd,
-  0x0c, 0xfe, 0x0c, 0xff, 0x0d, 0x00, 0x0d, 0x01, 0x0d, 0x02, 0x0d, 0x03,
-  0x0d, 0x04, 0x0d, 0x05, 0x0d, 0x06, 0x0d, 0x07, 0x0d, 0x08, 0x0d, 0x09,
-  0x0d, 0x0a, 0x0d, 0x0b, 0x0d, 0x0c, 0x0d, 0x0d, 0x0d, 0x0e, 0x0d, 0x0f,
-  0x0d, 0x10, 0x0d, 0x11, 0x0d, 0x12, 0x0d, 0x13, 0x0d, 0x14, 0x0d, 0x15,
-  0x0d, 0x16, 0x0d, 0x17, 0x0d, 0x18, 0x0d, 0x19, 0x0d, 0x1a, 0x0d, 0x1b,
-  0x0d, 0x1c, 0x0d, 0x1d, 0x0d, 0x1e, 0x0d, 0x1f, 0x0d, 0x20, 0x0d, 0x21,
-  0x0d, 0x22, 0x0d, 0x23, 0x0d, 0x24, 0x0d, 0x25, 0x0d, 0x26, 0x0d, 0x27,
-  0x0d, 0x28, 0x0d, 0x29, 0x0d, 0x2a, 0x0d, 0x2b, 0x0d, 0x2c, 0x0d, 0x2d,
-  0x0d, 0x2e, 0x0d, 0x2f, 0x0d, 0x30, 0x0d, 0x31, 0x0d, 0x32, 0x0d, 0x33,
-  0x0d, 0x34, 0x0d, 0x35, 0x0d, 0x36, 0x0d, 0x37, 0x0d, 0x38, 0x0d, 0x39,
-  0x0d, 0x3a, 0x0d, 0x3b, 0x0d, 0x3c, 0x0d, 0x3d, 0x0d, 0x3e, 0x0d, 0x3f,
-  0x0d, 0x40, 0x0d, 0x41, 0x0d, 0x42, 0x0d, 0x43, 0x0d, 0x44, 0x0d, 0x45,
-  0x0d, 0x46, 0x0d, 0x47, 0x0d, 0x48, 0x0d, 0x49, 0x0d, 0x4a, 0x0d, 0x4b,
-  0x0d, 0x4c, 0x0d, 0x4d, 0x0d, 0x4e, 0x0d, 0x4f, 0x0d, 0x50, 0x0d, 0x51,
-  0x0d, 0x52, 0x0d, 0x53, 0x0d, 0x54, 0x0d, 0x55, 0x0d, 0x56, 0x0d, 0x57,
-  0x0d, 0x58, 0x0d, 0x59, 0x0d, 0x5a, 0x0d, 0x5b, 0x0d, 0x5c, 0x0d, 0x5d,
-  0x0d, 0x5e, 0x0d, 0x5f, 0x0d, 0x60, 0x0d, 0x61, 0x0d, 0x62, 0x0d, 0x63,
-  0x0d, 0x64, 0x0d, 0x65, 0x0d, 0x66, 0x0d, 0x67, 0x0d, 0x68, 0x0d, 0x69,
-  0x0d, 0x6a, 0x0d, 0x6b, 0x0d, 0x6c, 0x0d, 0x6d, 0x0d, 0x6e, 0x0d, 0x6f,
-  0x0d, 0x70, 0x0d, 0x71, 0x0d, 0x72, 0x0d, 0x73, 0x0d, 0x74, 0x0d, 0x75,
-  0x0d, 0x76, 0x0d, 0x77, 0x0d, 0x78, 0x0d, 0x79, 0x0d, 0x7a, 0x0d, 0x7b,
-  0x0d, 0x7c, 0x0d, 0x7d, 0x0d, 0x7e, 0x0d, 0x7f, 0x0d, 0x80, 0x0d, 0x81,
-  0x0d, 0x82, 0x0d, 0x83, 0x0d, 0x84, 0x0d, 0x85, 0x0d, 0x86, 0x0d, 0x87,
-  0x0d, 0x88, 0x0d, 0x89, 0x0d, 0x8a, 0x0d, 0x8b, 0x0d, 0x8c, 0x0d, 0x8d,
-  0x0d, 0x8e, 0x0d, 0x8f, 0x0d, 0x90, 0x0d, 0x91, 0x0d, 0x92, 0x0d, 0x93,
-  0x0d, 0x94, 0x0d, 0x95, 0x0d, 0x96, 0x0d, 0x97, 0x0d, 0x98, 0x0d, 0x99,
-  0x0d, 0x9a, 0x0d, 0x9b, 0x0d, 0x9c, 0x0d, 0x9d, 0x0d, 0x9e, 0x0d, 0x9f,
-  0x0d, 0xa0, 0x0d, 0xa1, 0x0d, 0xa2, 0x0d, 0xa3, 0x0d, 0xa4, 0x0d, 0xa5,
-  0x0d, 0xa6, 0x0d, 0xa7, 0x0d, 0xa8, 0x0d, 0xa9, 0x0d, 0xaa, 0x0d, 0xab,
-  0x0d, 0xac, 0x0d, 0xad, 0x0d, 0xae, 0x0d, 0xaf, 0x0d, 0xb0, 0x0d, 0xb1,
-  0x0d, 0xb2, 0x0d, 0xb3, 0x0d, 0xb4, 0x0d, 0xb5, 0x0d, 0xb6, 0x0d, 0xb7,
-  0x0d, 0xb8, 0x0d, 0xb9, 0x0d, 0xba, 0x0d, 0xbb, 0x0d, 0xbc, 0x0d, 0xbd,
-  0x0d, 0xbe, 0x0d, 0xbf, 0x0d, 0xc0, 0x0d, 0xc1, 0x0d, 0xc2, 0x0d, 0xc3,
-  0x0d, 0xc4, 0x0d, 0xc5, 0x0d, 0xc6, 0x0d, 0xc7, 0x0d, 0xc8, 0x0d, 0xc9,
-  0x0d, 0xca, 0x0d, 0xcb, 0x0d, 0xcc, 0x0d, 0xcd, 0x0d, 0xce, 0x0d, 0xcf,
-  0x0d, 0xd0, 0x0d, 0xd1, 0x0d, 0xd2, 0x0d, 0xd3, 0x0d, 0xd4, 0x0d, 0xd5,
-  0x0d, 0xd6, 0x0d, 0xd7, 0x0d, 0xd8, 0x0d, 0xd9, 0x0d, 0xda, 0x0d, 0xdb,
-  0x0d, 0xdc, 0x0d, 0xdd, 0x0d, 0xde, 0x0d, 0xdf, 0x0d, 0xe0, 0x0d, 0xe1,
-  0x0d, 0xe2, 0x0d, 0xe3, 0x0d, 0xe4, 0x0d, 0xe5, 0x0d, 0xe6, 0x0d, 0xe7,
-  0x0d, 0xe8, 0x0d, 0xe9, 0x0d, 0xea, 0x0d, 0xeb, 0x0d, 0xec, 0x0d, 0xed,
-  0x0d, 0xee, 0x0d, 0xef, 0x0d, 0xf0, 0x0d, 0xf1, 0x0d, 0xf2, 0x0d, 0xf3,
-  0x0d, 0xf4, 0x0d, 0xf5, 0x0d, 0xf6, 0x0d, 0xf7, 0x0d, 0xf8, 0x0d, 0xf9,
-  0x0d, 0xfa, 0x0d, 0xfb, 0x0d, 0xfc, 0x0d, 0xfd, 0x0d, 0xfe, 0x0d, 0xff,
-  0x0e, 0x00, 0x0e, 0x01, 0x0e, 0x02, 0x0e, 0x03, 0x0e, 0x04, 0x0e, 0x05,
-  0x0e, 0x06, 0x0e, 0x07, 0x0e, 0x08, 0x0e, 0x09, 0x0e, 0x0a, 0x0e, 0x0b,
-  0x0e, 0x0c, 0x0e, 0x0d, 0x0e, 0x0e, 0x0e, 0x0f, 0x0e, 0x10, 0x0e, 0x11,
-  0x0e, 0x12, 0x0e, 0x13, 0x0e, 0x14, 0x0e, 0x15, 0x0e, 0x16, 0x0e, 0x17,
-  0x0e, 0x18, 0x0e, 0x19, 0x0e, 0x1a, 0x0e, 0x1b, 0x0e, 0x1c, 0x0e, 0x1d,
-  0x0e, 0x1e, 0x0e, 0x1f, 0x0e, 0x20, 0x0e, 0x21, 0x0e, 0x22, 0x0e, 0x23,
-  0x0e, 0x24, 0x0e, 0x25, 0x0e, 0x26, 0x0e, 0x27, 0x0e, 0x28, 0x0e, 0x29,
-  0x0e, 0x2a, 0x0e, 0x2b, 0x0e, 0x2c, 0x0e, 0x2d, 0x0e, 0x2e, 0x0e, 0x2f,
-  0x0e, 0x30, 0x0e, 0x31, 0x0e, 0x32, 0x0e, 0x33, 0x0e, 0x34, 0x0e, 0x35,
-  0x0e, 0x36, 0x0e, 0x37, 0x0e, 0x38, 0x0e, 0x39, 0x0e, 0x3a, 0x0e, 0x3b,
-  0x0e, 0x3c, 0x0e, 0x3d, 0x0e, 0x3e, 0x0e, 0x3f, 0x0e, 0x40, 0x0e, 0x41,
-  0x0e, 0x42, 0x0e, 0x43, 0x0e, 0x44, 0x0e, 0x45, 0x0e, 0x46, 0x0e, 0x47,
-  0x0e, 0x48, 0x0e, 0x49, 0x0e, 0x4a, 0x0e, 0x4b, 0x0e, 0x4c, 0x0e, 0x4d,
-  0x0e, 0x4e, 0x0e, 0x4f, 0x0e, 0x50, 0x0e, 0x51, 0x0e, 0x52, 0x0e, 0x53,
-  0x0e, 0x54, 0x0e, 0x55, 0x0e, 0x56, 0x0e, 0x57, 0x0e, 0x58, 0x0e, 0x59,
-  0x0e, 0x5a, 0x0e, 0x5b, 0x0e, 0x5c, 0x0e, 0x5d, 0x0e, 0x5e, 0x0e, 0x5f,
-  0x0e, 0x60, 0x0e, 0x61, 0x0e, 0x62, 0x0e, 0x63, 0x0e, 0x64, 0x0e, 0x65,
-  0x0e, 0x66, 0x0e, 0x67, 0x0e, 0x68, 0x0e, 0x69, 0x0e, 0x6a, 0x0e, 0x6b,
-  0x0e, 0x6c, 0x0e, 0x6d, 0x0e, 0x6e, 0x0e, 0x6f, 0x0e, 0x70, 0x0e, 0x71,
-  0x0e, 0x72, 0x0e, 0x73, 0x0e, 0x74, 0x0e, 0x75, 0x0e, 0x76, 0x0e, 0x77,
-  0x0e, 0x78, 0x0e, 0x79, 0x0e, 0x7a, 0x0e, 0x7b, 0x0e, 0x7c, 0x0e, 0x7d,
-  0x0e, 0x7e, 0x0e, 0x7f, 0x0e, 0x80, 0x0e, 0x81, 0x0e, 0x82, 0x0e, 0x83,
-  0x0e, 0x84, 0x0e, 0x85, 0x0e, 0x86, 0x0e, 0x87, 0x0e, 0x88, 0x0e, 0x89,
-  0x0e, 0x8a, 0x0e, 0x8b, 0x0e, 0x8c, 0x0e, 0x8d, 0x0e, 0x8e, 0x0e, 0x8f,
-  0x0e, 0x90, 0x0e, 0x91, 0x0e, 0x92, 0x0e, 0x93, 0x0e, 0x94, 0x0e, 0x95,
-  0x0e, 0x96, 0x0e, 0x97, 0x0e, 0x98, 0x0e, 0x99, 0x0e, 0x9a, 0x0e, 0x9b,
-  0x0e, 0x9c, 0x0e, 0x9d, 0x0e, 0x9e, 0x0e, 0x9f, 0x0e, 0xa0, 0x0e, 0xa1,
-  0x0e, 0xa2, 0x0e, 0xa3, 0x0e, 0xa4, 0x0e, 0xa5, 0x0e, 0xa6, 0x0e, 0xa7,
-  0x0e, 0xa8, 0x0e, 0xa9, 0x0e, 0xaa, 0x0e, 0xab, 0x0e, 0xac, 0x0e, 0xad,
-  0x0e, 0xae, 0x0e, 0xaf, 0x0e, 0xb0, 0x0e, 0xb1, 0x0e, 0xb2, 0x0e, 0xb3,
-  0x0e, 0xb4, 0x0e, 0xb5, 0x0e, 0xb6, 0x0e, 0xb7, 0x0e, 0xb8, 0x0e, 0xb9,
-  0x0e, 0xba, 0x0e, 0xbb, 0x0e, 0xbc, 0x0e, 0xbd, 0x0e, 0xbe, 0x0e, 0xbf,
-  0x0e, 0xc0, 0x0e, 0xc1, 0x0e, 0xc2, 0x0e, 0xc3, 0x0e, 0xc4, 0x0e, 0xc5,
-  0x0e, 0xc6, 0x0e, 0xc7, 0x0e, 0xc8, 0x0e, 0xc9, 0x0e, 0xca, 0x0e, 0xcb,
-  0x0e, 0xcc, 0x0e, 0xcd, 0x0e, 0xce, 0x0e, 0xcf, 0x0e, 0xd0, 0x0e, 0xd1,
-  0x0e, 0xd2, 0x0e, 0xd3, 0x0e, 0xd4, 0x0e, 0xd5, 0x0e, 0xd6, 0x0e, 0xd7,
-  0x0e, 0xd8, 0x0e, 0xd9, 0x0e, 0xda, 0x0e, 0xdb, 0x0e, 0xdc, 0x0e, 0xdd,
-  0x0e, 0xde, 0x0e, 0xdf, 0x0e, 0xe0, 0x0e, 0xe1, 0x0e, 0xe2, 0x0e, 0xe3,
-  0x0e, 0xe4, 0x0e, 0xe5, 0x0e, 0xe6, 0x0e, 0xe7, 0x0e, 0xe8, 0x0e, 0xe9,
-  0x0e, 0xea, 0x0e, 0xeb, 0x0e, 0xec, 0x0e, 0xed, 0x0e, 0xee, 0x0e, 0xef,
-  0x0e, 0xf0, 0x0e, 0xf1, 0x0e, 0xf2, 0x0e, 0xf3, 0x0e, 0xf4, 0x0e, 0xf5,
-  0x0e, 0xf6, 0x0e, 0xf7, 0x0e, 0xf8, 0x0e, 0xf9, 0x0e, 0xfa, 0x0e, 0xfb,
-  0x0e, 0xfc, 0x0e, 0xfd, 0x0e, 0xfe, 0x0e, 0xff, 0x0f, 0x00, 0x0f, 0x01,
-  0x0f, 0x02, 0x0f, 0x03, 0x0f, 0x04, 0x0f, 0x05, 0x0f, 0x06, 0x0f, 0x07,
-  0x0f, 0x08, 0x0f, 0x09, 0x0f, 0x0a, 0x0f, 0x0b, 0x0f, 0x0c, 0x00, 0xc0,
-  0x00, 0xc1, 0x0f, 0x0d, 0x0f, 0x0e, 0x0f, 0x0f, 0x0f, 0x10, 0x0f, 0x11,
-  0x0f, 0x12, 0x0f, 0x13, 0x0f, 0x14, 0x0f, 0x15, 0x0f, 0x16, 0x0f, 0x17,
-  0x0f, 0x18, 0x0f, 0x19, 0x0f, 0x1a, 0x0f, 0x1b, 0x0f, 0x1c, 0x0f, 0x1d,
-  0x0f, 0x1e, 0x0f, 0x1f, 0x0f, 0x20, 0x0f, 0x21, 0x0f, 0x22, 0x0f, 0x23,
-  0x0f, 0x24, 0x0f, 0x25, 0x0f, 0x26, 0x0f, 0x27, 0x0f, 0x28, 0x0f, 0x29,
-  0x0f, 0x2a, 0x0f, 0x2b, 0x0f, 0x2c, 0x0f, 0x2d, 0x0f, 0x2e, 0x0f, 0x2f,
-  0x0f, 0x30, 0x0f, 0x31, 0x0f, 0x32, 0x0f, 0x33, 0x0f, 0x34, 0x0f, 0x35,
-  0x0f, 0x36, 0x0f, 0x37, 0x0f, 0x38, 0x0f, 0x39, 0x0f, 0x3a, 0x0f, 0x3b,
-  0x0f, 0x3c, 0x0f, 0x3d, 0x0f, 0x3e, 0x0f, 0x3f, 0x0f, 0x40, 0x0f, 0x41,
-  0x0f, 0x42, 0x0f, 0x43, 0x0f, 0x44, 0x0f, 0x45, 0x0f, 0x46, 0x0f, 0x47,
-  0x0f, 0x48, 0x0f, 0x49, 0x0f, 0x4a, 0x0f, 0x4b, 0x0f, 0x4c, 0x0f, 0x4d,
-  0x0f, 0x4e, 0x0f, 0x4f, 0x0f, 0x50, 0x0f, 0x51, 0x0f, 0x52, 0x0f, 0x53,
-  0x0f, 0x54, 0x0f, 0x55, 0x0f, 0x56, 0x0f, 0x57, 0x0f, 0x58, 0x0f, 0x59,
-  0x0f, 0x5a, 0x0f, 0x5b, 0x0f, 0x5c, 0x0f, 0x5d, 0x0f, 0x5e, 0x0f, 0x5f,
-  0x0f, 0x60, 0x0f, 0x61, 0x0f, 0x62, 0x0f, 0x63, 0x0f, 0x64, 0x0f, 0x65,
-  0x0f, 0x66, 0x0f, 0x67, 0x0f, 0x68, 0x0f, 0x69, 0x0f, 0x6a, 0x0f, 0x6b,
-  0x0f, 0x6c, 0x0f, 0x6d, 0x0f, 0x6e, 0x0f, 0x6f, 0x0f, 0x70, 0x0f, 0x71,
-  0x0f, 0x72, 0x0f, 0x73, 0x0f, 0x74, 0x0f, 0x75, 0x0f, 0x76, 0x0f, 0x77,
-  0x0f, 0x78, 0x0f, 0x79, 0x0f, 0x7a, 0x0f, 0x7b, 0x0f, 0x7c, 0x0f, 0x7d,
-  0x0f, 0x7e, 0x0f, 0x7f, 0x0f, 0x80, 0x0f, 0x81, 0x0f, 0x82, 0x0f, 0x83,
-  0x0f, 0x84, 0x0f, 0x85, 0x0f, 0x86, 0x0f, 0x87, 0x0f, 0x88, 0x0f, 0x89,
-  0x0f, 0x8a, 0x0f, 0x8b, 0x0f, 0x8c, 0x0f, 0x8d, 0x0f, 0x8e, 0x0f, 0x8f,
-  0x0f, 0x90, 0x0f, 0x91, 0x0f, 0x92, 0x0f, 0x93, 0x0f, 0x94, 0x0f, 0x95,
-  0x0f, 0x96, 0x0f, 0x97, 0x0f, 0x98, 0x0f, 0x99, 0x0f, 0x9a, 0x0f, 0x9b,
-  0x0f, 0x9c, 0x0f, 0x9d, 0x0f, 0x9e, 0x0f, 0x9f, 0x0f, 0xa0, 0x0f, 0xa1,
-  0x0f, 0xa2, 0x0f, 0xa3, 0x0f, 0xa4, 0x0f, 0xa5, 0x0f, 0xa6, 0x0f, 0xa7,
-  0x0f, 0xa8, 0x0f, 0xa9, 0x0f, 0xaa, 0x0f, 0xab, 0x0f, 0xac, 0x0f, 0xad,
-  0x0f, 0xae, 0x0f, 0xaf, 0x0f, 0xb0, 0x0f, 0xb1, 0x0f, 0xb2, 0x0f, 0xb3,
-  0x0f, 0xb4, 0x0f, 0xb5, 0x0f, 0xb6, 0x0f, 0xb7, 0x0f, 0xb8, 0x0f, 0xb9,
-  0x0f, 0xba, 0x0f, 0xbb, 0x0f, 0xbc, 0x0f, 0xbd, 0x0f, 0xbe, 0x0f, 0xbf,
-  0x0f, 0xc0, 0x0f, 0xc1, 0x0f, 0xc2, 0x0f, 0xc3, 0x0f, 0xc4, 0x0f, 0xc5,
-  0x0f, 0xc6, 0x0f, 0xc7, 0x0f, 0xc8, 0x0f, 0xc9, 0x0f, 0xca, 0x0f, 0xcb,
-  0x0f, 0xcc, 0x0f, 0xcd, 0x0f, 0xce, 0x0f, 0xcf, 0x0f, 0xd0, 0x0f, 0xd1,
-  0x0f, 0xd2, 0x0f, 0xd3, 0x0f, 0xd4, 0x0f, 0xd5, 0x0f, 0xd6, 0x0f, 0xd7,
-  0x0f, 0xd8, 0x0f, 0xd9, 0x0f, 0xda, 0x0f, 0xdb, 0x0f, 0xdc, 0x0f, 0xdd,
-  0x0f, 0xde, 0x0f, 0xdf, 0x0f, 0xe0, 0x0f, 0xe1, 0x0f, 0xe2, 0x0f, 0xe3,
-  0x0f, 0xe4, 0x0f, 0xe5, 0x0f, 0xe6, 0x0f, 0xe7, 0x0f, 0xe8, 0x0f, 0xe9,
-  0x0f, 0xea, 0x0f, 0xeb, 0x0f, 0xec, 0x0f, 0xed, 0x0f, 0xee, 0x0f, 0xef,
-  0x0f, 0xf0, 0x0f, 0xf1, 0x0f, 0xf2, 0x0f, 0xf3, 0x0f, 0xf4, 0x0f, 0xf5,
-  0x0f, 0xf6, 0x0f, 0xf7, 0x0f, 0xf8, 0x0f, 0xf9, 0x0f, 0xfa, 0x0f, 0xfb,
-  0x0f, 0xfc, 0x0f, 0xfd, 0x0f, 0xfe, 0x0f, 0xff, 0x10, 0x00, 0x10, 0x01,
-  0x10, 0x02, 0x10, 0x03, 0x10, 0x04, 0x10, 0x05, 0x10, 0x06, 0x10, 0x07,
-  0x10, 0x08, 0x10, 0x09, 0x10, 0x0a, 0x10, 0x0b, 0x10, 0x0c, 0x10, 0x0d,
-  0x10, 0x0e, 0x10, 0x0f, 0x10, 0x10, 0x10, 0x11, 0x10, 0x12, 0x10, 0x13,
-  0x10, 0x14, 0x10, 0x15, 0x10, 0x16, 0x10, 0x17, 0x10, 0x18, 0x10, 0x19,
-  0x10, 0x1a, 0x10, 0x1b, 0x10, 0x1c, 0x10, 0x1d, 0x10, 0x1e, 0x10, 0x1f,
-  0x10, 0x20, 0x10, 0x21, 0x10, 0x22, 0x10, 0x23, 0x10, 0x24, 0x10, 0x25,
-  0x10, 0x26, 0x10, 0x27, 0x10, 0x28, 0x10, 0x29, 0x10, 0x2a, 0x10, 0x2b,
-  0x10, 0x2c, 0x10, 0x2d, 0x10, 0x2e, 0x10, 0x2f, 0x10, 0x30, 0x10, 0x31,
-  0x10, 0x32, 0x10, 0x33, 0x10, 0x34, 0x10, 0x35, 0x10, 0x36, 0x10, 0x37,
-  0x10, 0x38, 0x10, 0x39, 0x10, 0x3a, 0x10, 0x3b, 0x10, 0x3c, 0x10, 0x3d,
-  0x10, 0x3e, 0x10, 0x3f, 0x10, 0x40, 0x10, 0x41, 0x10, 0x42, 0x10, 0x43,
-  0x10, 0x44, 0x10, 0x45, 0x10, 0x46, 0x10, 0x47, 0x10, 0x48, 0x10, 0x49,
-  0x10, 0x4a, 0x10, 0x4b, 0x10, 0x4c, 0x10, 0x4d, 0x10, 0x4e, 0x10, 0x4f,
-  0x10, 0x50, 0x10, 0x51, 0x10, 0x52, 0x10, 0x53, 0x10, 0x54, 0x10, 0x55,
-  0x10, 0x56, 0x10, 0x57, 0x10, 0x58, 0x10, 0x59, 0x10, 0x5a, 0x10, 0x5b,
-  0x10, 0x5c, 0x10, 0x5d, 0x10, 0x5e, 0x10, 0x5f, 0x10, 0x60, 0x10, 0x61,
-  0x10, 0x62, 0x10, 0x63, 0x10, 0x64, 0x10, 0x65, 0x10, 0x66, 0x10, 0x67,
-  0x10, 0x68, 0x10, 0x69, 0x10, 0x6a, 0x10, 0x6b, 0x10, 0x6c, 0x10, 0x6d,
-  0x10, 0x6e, 0x10, 0x6f, 0x10, 0x70, 0x10, 0x71, 0x10, 0x72, 0x10, 0x73,
-  0x10, 0x74, 0x10, 0x75, 0x10, 0x76, 0x10, 0x77, 0x10, 0x78, 0x10, 0x79,
-  0x10, 0x7a, 0x10, 0x7b, 0x10, 0x7c, 0x10, 0x7d, 0x10, 0x7e, 0x10, 0x7f,
-  0x10, 0x80, 0x10, 0x81, 0x10, 0x82, 0x10, 0x83, 0x10, 0x84, 0x10, 0x85,
-  0x10, 0x86, 0x10, 0x87, 0x10, 0x88, 0x10, 0x89, 0x10, 0x8a, 0x10, 0x8b,
-  0x10, 0x8c, 0x10, 0x8d, 0x10, 0x8e, 0x10, 0x8f, 0x10, 0x90, 0x10, 0x91,
-  0x10, 0x92, 0x10, 0x93, 0x10, 0x94, 0x10, 0x95, 0x10, 0x96, 0x10, 0x97,
-  0x10, 0x98, 0x10, 0x99, 0x10, 0x9a, 0x10, 0x9b, 0x10, 0x9c, 0x10, 0x9d,
-  0x10, 0x9e, 0x10, 0x9f, 0x10, 0xa0, 0x10, 0xa1, 0x10, 0xa2, 0x10, 0xa3,
-  0x10, 0xa4, 0x10, 0xa5, 0x10, 0xa6, 0x10, 0xa7, 0x10, 0xa8, 0x10, 0xa9,
-  0x10, 0xaa, 0x10, 0xab, 0x10, 0xac, 0x10, 0xad, 0x10, 0xae, 0x10, 0xaf,
-  0x10, 0xb0, 0x10, 0xb1, 0x10, 0xb2, 0x10, 0xb3, 0x10, 0xb4, 0x10, 0xb5,
-  0x10, 0xb6, 0x10, 0xb7, 0x10, 0xb8, 0x10, 0xb9, 0x10, 0xba, 0x10, 0xbb,
-  0x10, 0xbc, 0x10, 0xbd, 0x10, 0xbe, 0x10, 0xbf, 0x10, 0xc0, 0x10, 0xc1,
-  0x10, 0xc2, 0x10, 0xc3, 0x10, 0xc4, 0x10, 0xc5, 0x10, 0xc6, 0x10, 0xc7,
-  0x10, 0xc8, 0x10, 0xc9, 0x10, 0xca, 0x10, 0xcb, 0x10, 0xcc, 0x10, 0xcd,
-  0x10, 0xce, 0x10, 0xcf, 0x10, 0xd0, 0x10, 0xd1, 0x10, 0xd2, 0x10, 0xd3,
-  0x10, 0xd4, 0x10, 0xd5, 0x10, 0xd6, 0x10, 0xd7, 0x10, 0xd8, 0x10, 0xd9,
-  0x10, 0xda, 0x10, 0xdb, 0x10, 0xdc, 0x10, 0xdd, 0x10, 0xde, 0x10, 0xdf,
-  0x10, 0xe0, 0x10, 0xe1, 0x10, 0xe2, 0x10, 0xe3, 0x10, 0xe4, 0x10, 0xe5,
-  0x10, 0xe6, 0x10, 0xe7, 0x10, 0xe8, 0x10, 0xe9, 0x10, 0xea, 0x10, 0xeb,
-  0x10, 0xec, 0x10, 0xed, 0x10, 0xee, 0x10, 0xef, 0x10, 0xf0, 0x10, 0xf1,
-  0x10, 0xf2, 0x10, 0xf3, 0x10, 0xf4, 0x10, 0xf5, 0x10, 0xf6, 0x10, 0xf7,
-  0x10, 0xf8, 0x10, 0xf9, 0x10, 0xfa, 0x10, 0xfb, 0x10, 0xfc, 0x10, 0xfd,
-  0x10, 0xfe, 0x10, 0xff, 0x11, 0x00, 0x11, 0x01, 0x11, 0x02, 0x11, 0x03,
-  0x11, 0x04, 0x11, 0x05, 0x11, 0x06, 0x11, 0x07, 0x11, 0x08, 0x11, 0x09,
-  0x11, 0x0a, 0x11, 0x0b, 0x11, 0x0c, 0x11, 0x0d, 0x11, 0x0e, 0x11, 0x0f,
-  0x11, 0x10, 0x11, 0x11, 0x11, 0x12, 0x11, 0x13, 0x11, 0x14, 0x11, 0x15,
-  0x11, 0x16, 0x11, 0x17, 0x11, 0x18, 0x11, 0x19, 0x11, 0x1a, 0x11, 0x1b,
-  0x11, 0x1c, 0x11, 0x1d, 0x11, 0x1e, 0x11, 0x1f, 0x11, 0x20, 0x11, 0x21,
-  0x11, 0x22, 0x11, 0x23, 0x11, 0x24, 0x11, 0x25, 0x11, 0x26, 0x11, 0x27,
-  0x11, 0x28, 0x11, 0x29, 0x11, 0x2a, 0x11, 0x2b, 0x11, 0x2c, 0x11, 0x2d,
-  0x11, 0x2e, 0x11, 0x2f, 0x11, 0x30, 0x11, 0x31, 0x11, 0x32, 0x11, 0x33,
-  0x11, 0x34, 0x11, 0x35, 0x11, 0x36, 0x11, 0x37, 0x11, 0x38, 0x11, 0x39,
-  0x11, 0x3a, 0x11, 0x3b, 0x11, 0x3c, 0x11, 0x3d, 0x11, 0x3e, 0x11, 0x3f,
-  0x11, 0x40, 0x11, 0x41, 0x11, 0x42, 0x11, 0x43, 0x11, 0x44, 0x11, 0x45,
-  0x11, 0x46, 0x11, 0x47, 0x11, 0x48, 0x11, 0x49, 0x11, 0x4a, 0x11, 0x4b,
-  0x11, 0x4c, 0x11, 0x4d, 0x11, 0x4e, 0x11, 0x4f, 0x11, 0x50, 0x11, 0x51,
-  0x11, 0x52, 0x11, 0x53, 0x11, 0x54, 0x11, 0x55, 0x11, 0x56, 0x11, 0x57,
-  0x11, 0x58, 0x11, 0x59, 0x11, 0x5a, 0x11, 0x5b, 0x11, 0x5c, 0x11, 0x5d,
-  0x11, 0x5e, 0x11, 0x5f, 0x11, 0x60, 0x11, 0x61, 0x11, 0x62, 0x11, 0x63,
-  0x11, 0x64, 0x11, 0x65, 0x11, 0x66, 0x11, 0x67, 0x11, 0x68, 0x11, 0x69,
-  0x11, 0x6a, 0x11, 0x6b, 0x11, 0x6c, 0x11, 0x6d, 0x11, 0x6e, 0x11, 0x6f,
-  0x11, 0x70, 0x11, 0x71, 0x11, 0x72, 0x11, 0x73, 0x11, 0x74, 0x11, 0x75,
-  0x11, 0x76, 0x11, 0x77, 0x11, 0x78, 0x11, 0x79, 0x11, 0x7a, 0x11, 0x7b,
-  0x11, 0x7c, 0x11, 0x7d, 0x11, 0x7e, 0x11, 0x7f, 0x11, 0x80, 0x11, 0x81,
-  0x11, 0x82, 0x11, 0x83, 0x11, 0x84, 0x11, 0x85, 0x11, 0x86, 0x11, 0x87,
-  0x11, 0x88, 0x11, 0x89, 0x11, 0x8a, 0x11, 0x8b, 0x11, 0x8c, 0x11, 0x8d,
-  0x11, 0x8e, 0x11, 0x8f, 0x11, 0x90, 0x11, 0x91, 0x11, 0x92, 0x11, 0x93,
-  0x11, 0x94, 0x11, 0x95, 0x11, 0x96, 0x11, 0x97, 0x11, 0x98, 0x11, 0x99,
-  0x11, 0x9a, 0x11, 0x9b, 0x11, 0x9c, 0x11, 0x9d, 0x11, 0x9e, 0x11, 0x9f,
-  0x11, 0xa0, 0x11, 0xa1, 0x11, 0xa2, 0x11, 0xa3, 0x11, 0xa4, 0x11, 0xa5,
-  0x11, 0xa6, 0x11, 0xa7, 0x11, 0xa8, 0x11, 0xa9, 0x11, 0xaa, 0x11, 0xab,
-  0x11, 0xac, 0x11, 0xad, 0x11, 0xae, 0x11, 0xaf, 0x11, 0xb0, 0x11, 0xb1,
-  0x11, 0xb2, 0x11, 0xb3, 0x11, 0xb4, 0x11, 0xb5, 0x11, 0xb6, 0x11, 0xb7,
-  0x11, 0xb8, 0x11, 0xb9, 0x11, 0xba, 0x11, 0xbb, 0x11, 0xbc, 0x11, 0xbd,
-  0x11, 0xbe, 0x11, 0xbf, 0x11, 0xc0, 0x11, 0xc1, 0x11, 0xc2, 0x11, 0xc3,
-  0x11, 0xc4, 0x11, 0xc5, 0x11, 0xc6, 0x11, 0xc7, 0x11, 0xc8, 0x11, 0xc9,
-  0x11, 0xca, 0x11, 0xcb, 0x11, 0xcc, 0x11, 0xcd, 0x11, 0xce, 0x11, 0xcf,
-  0x11, 0xd0, 0x11, 0xd1, 0x11, 0xd2, 0x11, 0xd3, 0x11, 0xd4, 0x11, 0xd5,
-  0x11, 0xd6, 0x11, 0xd7, 0x11, 0xd8, 0x11, 0xd9, 0x11, 0xda, 0x11, 0xdb,
-  0x11, 0xdc, 0x11, 0xdd, 0x11, 0xde, 0x11, 0xdf, 0x11, 0xe0, 0x11, 0xe1,
-  0x11, 0xe2, 0x11, 0xe3, 0x11, 0xe4, 0x11, 0xe5, 0x11, 0xe6, 0x11, 0xe7,
-  0x11, 0xe8, 0x11, 0xe9, 0x11, 0xea, 0x11, 0xeb, 0x11, 0xec, 0x11, 0xed,
-  0x11, 0xee, 0x11, 0xef, 0x11, 0xf0, 0x11, 0xf1, 0x11, 0xf2, 0x11, 0xf3,
-  0x11, 0xf4, 0x11, 0xf5, 0x11, 0xf6, 0x11, 0xf7, 0x11, 0xf8, 0x11, 0xf9,
-  0x11, 0xfa, 0x11, 0xfb, 0x11, 0xfc, 0x11, 0xfd, 0x11, 0xfe, 0x11, 0xff,
-  0x12, 0x00, 0x12, 0x01, 0x12, 0x02, 0x12, 0x03, 0x12, 0x04, 0x12, 0x05,
-  0x12, 0x06, 0x12, 0x07, 0x12, 0x08, 0x12, 0x09, 0x12, 0x0a, 0x12, 0x0b,
-  0x12, 0x0c, 0x12, 0x0d, 0x12, 0x0e, 0x09, 0x73, 0x66, 0x74, 0x68, 0x79,
-  0x70, 0x68, 0x65, 0x6e, 0x07, 0x41, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e,
-  0x07, 0x61, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e, 0x06, 0x41, 0x62, 0x72,
-  0x65, 0x76, 0x65, 0x06, 0x61, 0x62, 0x72, 0x65, 0x76, 0x65, 0x07, 0x41,
-  0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x07, 0x61, 0x6f, 0x67, 0x6f, 0x6e,
-  0x65, 0x6b, 0x0b, 0x43, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
-  0x65, 0x78, 0x0b, 0x63, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
-  0x65, 0x78, 0x0a, 0x43, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e,
-  0x74, 0x0a, 0x63, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74,
-  0x06, 0x44, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x64, 0x63, 0x61, 0x72,
-  0x6f, 0x6e, 0x06, 0x44, 0x63, 0x72, 0x6f, 0x61, 0x74, 0x07, 0x45, 0x6d,
-  0x61, 0x63, 0x72, 0x6f, 0x6e, 0x07, 0x65, 0x6d, 0x61, 0x63, 0x72, 0x6f,
-  0x6e, 0x06, 0x45, 0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x65, 0x62, 0x72,
-  0x65, 0x76, 0x65, 0x0a, 0x45, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65,
-  0x6e, 0x74, 0x0a, 0x65, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e,
-  0x74, 0x07, 0x45, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x07, 0x65, 0x6f,
-  0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x06, 0x45, 0x63, 0x61, 0x72, 0x6f, 0x6e,
-  0x06, 0x65, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x0b, 0x47, 0x63, 0x69, 0x72,
-  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x67, 0x63, 0x69, 0x72,
-  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0a, 0x47, 0x64, 0x6f, 0x74,
-  0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0a, 0x67, 0x64, 0x6f, 0x74, 0x61,
-  0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x47, 0x63, 0x6f, 0x6d, 0x6d, 0x61,
-  0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x67, 0x63, 0x6f, 0x6d, 0x6d,
-  0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0b, 0x48, 0x63, 0x69, 0x72,
-  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x68, 0x63, 0x69, 0x72,
-  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x04, 0x48, 0x62, 0x61, 0x72,
-  0x04, 0x68, 0x62, 0x61, 0x72, 0x06, 0x49, 0x74, 0x69, 0x6c, 0x64, 0x65,
-  0x06, 0x69, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x07, 0x49, 0x6d, 0x61, 0x63,
-  0x72, 0x6f, 0x6e, 0x07, 0x69, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e, 0x06,
-  0x49, 0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x69, 0x62, 0x72, 0x65, 0x76,
-  0x65, 0x07, 0x49, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x07, 0x69, 0x6f,
-  0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x02, 0x49, 0x4a, 0x02, 0x69, 0x6a, 0x0b,
-  0x4a, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b,
-  0x6a, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0c,
-  0x4b, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74,
-  0x0c, 0x6b, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e,
-  0x74, 0x0c, 0x6b, 0x67, 0x72, 0x65, 0x65, 0x6e, 0x6c, 0x61, 0x6e, 0x64,
-  0x69, 0x63, 0x06, 0x4c, 0x61, 0x63, 0x75, 0x74, 0x65, 0x06, 0x6c, 0x61,
-  0x63, 0x75, 0x74, 0x65, 0x0c, 0x4c, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61,
-  0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x6c, 0x63, 0x6f, 0x6d, 0x6d, 0x61,
-  0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x06, 0x4c, 0x63, 0x61, 0x72, 0x6f,
-  0x6e, 0x06, 0x6c, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x04, 0x4c, 0x64, 0x6f,
-  0x74, 0x04, 0x6c, 0x64, 0x6f, 0x74, 0x06, 0x4e, 0x61, 0x63, 0x75, 0x74,
-  0x65, 0x06, 0x6e, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0c, 0x4e, 0x63, 0x6f,
-  0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x6e, 0x63,
-  0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x06, 0x4e,
-  0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x6e, 0x63, 0x61, 0x72, 0x6f, 0x6e,
-  0x0b, 0x6e, 0x61, 0x70, 0x6f, 0x73, 0x74, 0x72, 0x6f, 0x70, 0x68, 0x65,
-  0x03, 0x45, 0x6e, 0x67, 0x03, 0x65, 0x6e, 0x67, 0x07, 0x4f, 0x6d, 0x61,
-  0x63, 0x72, 0x6f, 0x6e, 0x07, 0x6f, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e,
-  0x06, 0x4f, 0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x6f, 0x62, 0x72, 0x65,
-  0x76, 0x65, 0x0d, 0x4f, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75, 0x6d,
-  0x6c, 0x61, 0x75, 0x74, 0x0d, 0x6f, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72,
-  0x75, 0x6d, 0x6c, 0x61, 0x75, 0x74, 0x06, 0x52, 0x61, 0x63, 0x75, 0x74,
-  0x65, 0x06, 0x72, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0c, 0x52, 0x63, 0x6f,
-  0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x72, 0x63,
-  0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x06, 0x52,
-  0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x72, 0x63, 0x61, 0x72, 0x6f, 0x6e,
-  0x06, 0x53, 0x61, 0x63, 0x75, 0x74, 0x65, 0x06, 0x73, 0x61, 0x63, 0x75,
-  0x74, 0x65, 0x0b, 0x53, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
-  0x65, 0x78, 0x0b, 0x73, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
-  0x65, 0x78, 0x0c, 0x54, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63,
-  0x65, 0x6e, 0x74, 0x0c, 0x74, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63,
-  0x63, 0x65, 0x6e, 0x74, 0x06, 0x54, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06,
-  0x74, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x04, 0x54, 0x62, 0x61, 0x72, 0x04,
-  0x74, 0x62, 0x61, 0x72, 0x06, 0x55, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x06,
-  0x75, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x07, 0x55, 0x6d, 0x61, 0x63, 0x72,
-  0x6f, 0x6e, 0x07, 0x75, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e, 0x06, 0x55,
-  0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x75, 0x62, 0x72, 0x65, 0x76, 0x65,
-  0x05, 0x55, 0x72, 0x69, 0x6e, 0x67, 0x05, 0x75, 0x72, 0x69, 0x6e, 0x67,
-  0x0d, 0x55, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75, 0x6d, 0x6c, 0x61,
-  0x75, 0x74, 0x0d, 0x75, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75, 0x6d,
-  0x6c, 0x61, 0x75, 0x74, 0x07, 0x55, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b,
-  0x07, 0x75, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x0b, 0x57, 0x63, 0x69,
-  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x77, 0x63, 0x69,
-  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x59, 0x63, 0x69,
-  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x79, 0x63, 0x69,
-  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x06, 0x5a, 0x61, 0x63,
-  0x75, 0x74, 0x65, 0x06, 0x7a, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0a, 0x5a,
-  0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0a, 0x7a, 0x64,
-  0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x05, 0x6c, 0x6f, 0x6e,
-  0x67, 0x73, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x46, 0x05, 0x4f,
-  0x68, 0x6f, 0x72, 0x6e, 0x05, 0x6f, 0x68, 0x6f, 0x72, 0x6e, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x41, 0x45, 0x05, 0x55, 0x68, 0x6f, 0x72, 0x6e,
-  0x05, 0x75, 0x68, 0x6f, 0x72, 0x6e, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x31, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
-  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x35, 0x06, 0x47,
-  0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x67, 0x63, 0x61, 0x72, 0x6f, 0x6e,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x31, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x31, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x31, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x31, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x31, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x31, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x39,
-  0x0a, 0x41, 0x72, 0x69, 0x6e, 0x67, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0a,
-  0x61, 0x72, 0x69, 0x6e, 0x67, 0x61, 0x63, 0x75, 0x74, 0x65, 0x07, 0x41,
-  0x45, 0x61, 0x63, 0x75, 0x74, 0x65, 0x07, 0x61, 0x65, 0x61, 0x63, 0x75,
-  0x74, 0x65, 0x0b, 0x4f, 0x73, 0x6c, 0x61, 0x73, 0x68, 0x61, 0x63, 0x75,
-  0x74, 0x65, 0x0b, 0x6f, 0x73, 0x6c, 0x61, 0x73, 0x68, 0x61, 0x63, 0x75,
-  0x74, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x32, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
-  0x31, 0x37, 0x0c, 0x53, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63,
-  0x65, 0x6e, 0x74, 0x0c, 0x73, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63,
-  0x63, 0x65, 0x6e, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x43,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x46,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x32,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x30, 0x32, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x36, 0x08, 0x64, 0x6f, 0x74,
-  0x6c, 0x65, 0x73, 0x73, 0x6a, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x43, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x46,
-  0x37, 0x09, 0x67, 0x72, 0x61, 0x76, 0x65, 0x63, 0x6f, 0x6d, 0x62, 0x09,
-  0x61, 0x63, 0x75, 0x74, 0x65, 0x63, 0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x30, 0x32, 0x09, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x63,
-  0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30,
-  0x33, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x0d, 0x68, 0x6f, 0x6f, 0x6b,
-  0x61, 0x62, 0x6f, 0x76, 0x65, 0x63, 0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x30, 0x33, 0x32, 0x32, 0x0c, 0x64, 0x6f, 0x74, 0x62, 0x65, 0x6c,
-  0x6f, 0x77, 0x63, 0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x35, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x35, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x35, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x36, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x37, 0x45, 0x05, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x0d, 0x64, 0x69, 0x65,
-  0x72, 0x65, 0x73, 0x69, 0x73, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x0a, 0x41,
-  0x6c, 0x70, 0x68, 0x61, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x09, 0x61, 0x6e,
-  0x6f, 0x74, 0x65, 0x6c, 0x65, 0x69, 0x61, 0x0c, 0x45, 0x70, 0x73, 0x69,
-  0x6c, 0x6f, 0x6e, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x08, 0x45, 0x74, 0x61,
-  0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x09, 0x49, 0x6f, 0x74, 0x61, 0x74, 0x6f,
-  0x6e, 0x6f, 0x73, 0x0c, 0x4f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x74,
-  0x6f, 0x6e, 0x6f, 0x73, 0x0c, 0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e,
-  0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x0a, 0x4f, 0x6d, 0x65, 0x67, 0x61, 0x74,
-  0x6f, 0x6e, 0x6f, 0x73, 0x11, 0x69, 0x6f, 0x74, 0x61, 0x64, 0x69, 0x65,
-  0x72, 0x65, 0x73, 0x69, 0x73, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x05, 0x41,
-  0x6c, 0x70, 0x68, 0x61, 0x04, 0x42, 0x65, 0x74, 0x61, 0x05, 0x47, 0x61,
-  0x6d, 0x6d, 0x61, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x39, 0x34, 0x07,
-  0x45, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x04, 0x5a, 0x65, 0x74, 0x61,
-  0x03, 0x45, 0x74, 0x61, 0x05, 0x54, 0x68, 0x65, 0x74, 0x61, 0x04, 0x49,
-  0x6f, 0x74, 0x61, 0x05, 0x4b, 0x61, 0x70, 0x70, 0x61, 0x06, 0x4c, 0x61,
-  0x6d, 0x62, 0x64, 0x61, 0x02, 0x4d, 0x75, 0x02, 0x4e, 0x75, 0x02, 0x58,
-  0x69, 0x07, 0x4f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x02, 0x50, 0x69,
-  0x03, 0x52, 0x68, 0x6f, 0x05, 0x53, 0x69, 0x67, 0x6d, 0x61, 0x03, 0x54,
-  0x61, 0x75, 0x07, 0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x03, 0x50,
-  0x68, 0x69, 0x03, 0x43, 0x68, 0x69, 0x03, 0x50, 0x73, 0x69, 0x0c, 0x49,
-  0x6f, 0x74, 0x61, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73, 0x0f,
-  0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x64, 0x69, 0x65, 0x72, 0x65,
-  0x73, 0x69, 0x73, 0x0a, 0x61, 0x6c, 0x70, 0x68, 0x61, 0x74, 0x6f, 0x6e,
-  0x6f, 0x73, 0x0c, 0x65, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x74, 0x6f,
-  0x6e, 0x6f, 0x73, 0x08, 0x65, 0x74, 0x61, 0x74, 0x6f, 0x6e, 0x6f, 0x73,
-  0x09, 0x69, 0x6f, 0x74, 0x61, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x14, 0x75,
-  0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73,
-  0x69, 0x73, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x05, 0x61, 0x6c, 0x70, 0x68,
-  0x61, 0x04, 0x62, 0x65, 0x74, 0x61, 0x05, 0x67, 0x61, 0x6d, 0x6d, 0x61,
-  0x05, 0x64, 0x65, 0x6c, 0x74, 0x61, 0x07, 0x65, 0x70, 0x73, 0x69, 0x6c,
-  0x6f, 0x6e, 0x04, 0x7a, 0x65, 0x74, 0x61, 0x03, 0x65, 0x74, 0x61, 0x05,
-  0x74, 0x68, 0x65, 0x74, 0x61, 0x04, 0x69, 0x6f, 0x74, 0x61, 0x05, 0x6b,
-  0x61, 0x70, 0x70, 0x61, 0x06, 0x6c, 0x61, 0x6d, 0x62, 0x64, 0x61, 0x07,
-  0x75, 0x6e, 0x69, 0x30, 0x33, 0x42, 0x43, 0x02, 0x6e, 0x75, 0x02, 0x78,
-  0x69, 0x07, 0x6f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x03, 0x72, 0x68,
-  0x6f, 0x06, 0x73, 0x69, 0x67, 0x6d, 0x61, 0x31, 0x05, 0x73, 0x69, 0x67,
-  0x6d, 0x61, 0x03, 0x74, 0x61, 0x75, 0x07, 0x75, 0x70, 0x73, 0x69, 0x6c,
-  0x6f, 0x6e, 0x03, 0x70, 0x68, 0x69, 0x03, 0x63, 0x68, 0x69, 0x03, 0x70,
-  0x73, 0x69, 0x05, 0x6f, 0x6d, 0x65, 0x67, 0x61, 0x0c, 0x69, 0x6f, 0x74,
-  0x61, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73, 0x0f, 0x75, 0x70,
-  0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69,
-  0x73, 0x0c, 0x6f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x74, 0x6f, 0x6e,
-  0x6f, 0x73, 0x0c, 0x75, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x74, 0x6f,
-  0x6e, 0x6f, 0x73, 0x0a, 0x6f, 0x6d, 0x65, 0x67, 0x61, 0x74, 0x6f, 0x6e,
-  0x6f, 0x73, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x43, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x44, 0x30, 0x06, 0x74, 0x68, 0x65, 0x74, 0x61,
-  0x31, 0x08, 0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x44, 0x34, 0x04, 0x70, 0x68, 0x69, 0x31, 0x06, 0x6f, 0x6d, 0x65, 0x67,
-  0x61, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x44, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x44, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x44, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x44, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x44, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x45, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x45, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
-  0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x33, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x34, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x32, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
-  0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x32, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x30, 0x35, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x37, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x38, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x39, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x43, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x43, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
-  0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x43, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x44, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x46, 0x06, 0x57,
-  0x67, 0x72, 0x61, 0x76, 0x65, 0x06, 0x77, 0x67, 0x72, 0x61, 0x76, 0x65,
-  0x06, 0x57, 0x61, 0x63, 0x75, 0x74, 0x65, 0x06, 0x77, 0x61, 0x63, 0x75,
-  0x74, 0x65, 0x09, 0x57, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73,
-  0x09, 0x77, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x38, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x38, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x38, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x31, 0x45, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
-  0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x31, 0x06, 0x59,
-  0x67, 0x72, 0x61, 0x76, 0x65, 0x06, 0x79, 0x67, 0x72, 0x61, 0x76, 0x65,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x45, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x45, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x45, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x43,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x46,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x32,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x32,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x45,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x31,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x34,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x43,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x46,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x32,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x43,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x46,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x32,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x45,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x31,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x34,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x46,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x32,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x45,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x31, 0x46, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x31,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x30, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x34,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x30, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x30, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x30, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x30, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x31, 0x0a, 0x66, 0x69, 0x67,
-  0x75, 0x72, 0x65, 0x64, 0x61, 0x73, 0x68, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x30, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x36, 0x0d,
-  0x75, 0x6e, 0x64, 0x65, 0x72, 0x73, 0x63, 0x6f, 0x72, 0x65, 0x64, 0x62,
-  0x6c, 0x0d, 0x71, 0x75, 0x6f, 0x74, 0x65, 0x72, 0x65, 0x76, 0x65, 0x72,
-  0x73, 0x65, 0x64, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x33, 0x0e, 0x6f, 0x6e, 0x65, 0x64,
-  0x6f, 0x74, 0x65, 0x6e, 0x6c, 0x65, 0x61, 0x64, 0x65, 0x72, 0x0e, 0x74,
-  0x77, 0x6f, 0x64, 0x6f, 0x74, 0x65, 0x6e, 0x6c, 0x65, 0x61, 0x64, 0x65,
-  0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x31, 0x06, 0x6d, 0x69,
-  0x6e, 0x75, 0x74, 0x65, 0x06, 0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x30, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x30, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x42, 0x09,
-  0x65, 0x78, 0x63, 0x6c, 0x61, 0x6d, 0x64, 0x62, 0x6c, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x41, 0x30, 0x0d, 0x63, 0x6f, 0x6c, 0x6f, 0x6e, 0x6d,
-  0x6f, 0x6e, 0x65, 0x74, 0x61, 0x72, 0x79, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x30, 0x41, 0x32, 0x04, 0x6c, 0x69, 0x72, 0x61, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x30, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x36,
-  0x06, 0x70, 0x65, 0x73, 0x65, 0x74, 0x61, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x30, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x41, 0x04, 0x64, 0x6f, 0x6e, 0x67,
-  0x04, 0x45, 0x75, 0x72, 0x6f, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x30, 0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x45,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x31, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x31, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x31, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x31, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x31, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x30, 0x08, 0x49, 0x66,
-  0x72, 0x61, 0x6b, 0x74, 0x75, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x31, 0x37, 0x0b, 0x77, 0x65, 0x69, 0x65, 0x72,
-  0x73, 0x74, 0x72, 0x61, 0x73, 0x73, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x31, 0x42, 0x08, 0x52, 0x66, 0x72, 0x61, 0x6b,
-  0x74, 0x75, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x44, 0x0c,
-  0x70, 0x72, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x31,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x32, 0x44, 0x09, 0x65, 0x73, 0x74, 0x69, 0x6d, 0x61, 0x74,
-  0x65, 0x64, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x33, 0x34, 0x05, 0x61, 0x6c, 0x65, 0x70, 0x68, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x31, 0x35, 0x32, 0x08, 0x6f, 0x6e, 0x65, 0x74, 0x68, 0x69, 0x72,
-  0x64, 0x09, 0x74, 0x77, 0x6f, 0x74, 0x68, 0x69, 0x72, 0x64, 0x73, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x41, 0x09,
-  0x6f, 0x6e, 0x65, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x0c, 0x74, 0x68,
-  0x72, 0x65, 0x65, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x73, 0x0b, 0x66,
-  0x69, 0x76, 0x65, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x73, 0x0c, 0x73,
-  0x65, 0x76, 0x65, 0x6e, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x73, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x39, 0x09, 0x61, 0x72, 0x72, 0x6f,
-  0x77, 0x6c, 0x65, 0x66, 0x74, 0x07, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x75,
-  0x70, 0x0a, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x72, 0x69, 0x67, 0x68, 0x74,
-  0x09, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x6f, 0x77, 0x6e, 0x09, 0x61,
-  0x72, 0x72, 0x6f, 0x77, 0x62, 0x6f, 0x74, 0x68, 0x09, 0x61, 0x72, 0x72,
-  0x6f, 0x77, 0x75, 0x70, 0x64, 0x6e, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x39, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x39, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x39, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x41, 0x37, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77,
-  0x75, 0x70, 0x64, 0x6e, 0x62, 0x73, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x31, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x34, 0x0e, 0x63, 0x61, 0x72, 0x72,
-  0x69, 0x61, 0x67, 0x65, 0x72, 0x65, 0x74, 0x75, 0x72, 0x6e, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x43, 0x46, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62, 0x6c, 0x6c,
-  0x65, 0x66, 0x74, 0x0a, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62, 0x6c,
-  0x75, 0x70, 0x0d, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62, 0x6c, 0x72,
-  0x69, 0x67, 0x68, 0x74, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62,
-  0x6c, 0x64, 0x6f, 0x77, 0x6e, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64,
-  0x62, 0x6c, 0x62, 0x6f, 0x74, 0x68, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x31, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
-  0x46, 0x46, 0x09, 0x75, 0x6e, 0x69, 0x76, 0x65, 0x72, 0x73, 0x61, 0x6c,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x30, 0x31, 0x0b, 0x65, 0x78, 0x69,
-  0x73, 0x74, 0x65, 0x6e, 0x74, 0x69, 0x61, 0x6c, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x32, 0x30, 0x34, 0x08, 0x65, 0x6d, 0x70, 0x74, 0x79, 0x73, 0x65,
-  0x74, 0x08, 0x67, 0x72, 0x61, 0x64, 0x69, 0x65, 0x6e, 0x74, 0x07, 0x65,
-  0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x0a, 0x6e, 0x6f, 0x74, 0x65, 0x6c,
-  0x65, 0x6d, 0x65, 0x6e, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x30,
-  0x41, 0x08, 0x73, 0x75, 0x63, 0x68, 0x74, 0x68, 0x61, 0x74, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x32, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32,
-  0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x30, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x32, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32,
-  0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x32, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32,
-  0x31, 0x36, 0x0c, 0x61, 0x73, 0x74, 0x65, 0x72, 0x69, 0x73, 0x6b, 0x6d,
-  0x61, 0x74, 0x68, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x43, 0x0c,
-  0x70, 0x72, 0x6f, 0x70, 0x6f, 0x72, 0x74, 0x69, 0x6f, 0x6e, 0x61, 0x6c,
-  0x0a, 0x6f, 0x72, 0x74, 0x68, 0x6f, 0x67, 0x6f, 0x6e, 0x61, 0x6c, 0x05,
-  0x61, 0x6e, 0x67, 0x6c, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x32, 0x36, 0x0a, 0x6c, 0x6f, 0x67, 0x69, 0x63, 0x61,
-  0x6c, 0x61, 0x6e, 0x64, 0x09, 0x6c, 0x6f, 0x67, 0x69, 0x63, 0x61, 0x6c,
-  0x6f, 0x72, 0x0c, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x73, 0x65, 0x63, 0x74,
-  0x69, 0x6f, 0x6e, 0x05, 0x75, 0x6e, 0x69, 0x6f, 0x6e, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33,
-  0x33, 0x09, 0x74, 0x68, 0x65, 0x72, 0x65, 0x66, 0x6f, 0x72, 0x65, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x42, 0x07, 0x73, 0x69, 0x6d, 0x69,
-  0x6c, 0x61, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x34, 0x09, 0x63, 0x6f, 0x6e, 0x67,
-  0x72, 0x75, 0x65, 0x6e, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
-  0x46, 0x0b, 0x65, 0x71, 0x75, 0x69, 0x76, 0x61, 0x6c, 0x65, 0x6e, 0x63,
-  0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x39, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38,
-  0x31, 0x0c, 0x70, 0x72, 0x6f, 0x70, 0x65, 0x72, 0x73, 0x75, 0x62, 0x73,
-  0x65, 0x74, 0x0e, 0x70, 0x72, 0x6f, 0x70, 0x65, 0x72, 0x73, 0x75, 0x70,
-  0x65, 0x72, 0x73, 0x65, 0x74, 0x09, 0x6e, 0x6f, 0x74, 0x73, 0x75, 0x62,
-  0x73, 0x65, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x35, 0x0c,
-  0x72, 0x65, 0x66, 0x6c, 0x65, 0x78, 0x73, 0x75, 0x62, 0x73, 0x65, 0x74,
-  0x0e, 0x72, 0x65, 0x66, 0x6c, 0x65, 0x78, 0x73, 0x75, 0x70, 0x65, 0x72,
-  0x73, 0x65, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x34, 0x0a,
-  0x63, 0x69, 0x72, 0x63, 0x6c, 0x65, 0x70, 0x6c, 0x75, 0x73, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x32, 0x39, 0x36, 0x0e, 0x63, 0x69, 0x72, 0x63, 0x6c,
-  0x65, 0x6d, 0x75, 0x6c, 0x74, 0x69, 0x70, 0x6c, 0x79, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39,
-  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x32, 0x41, 0x34, 0x0d, 0x70, 0x65, 0x72, 0x70, 0x65, 0x6e,
-  0x64, 0x69, 0x63, 0x75, 0x6c, 0x61, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x43, 0x34, 0x07, 0x64, 0x6f, 0x74, 0x6d, 0x61, 0x74, 0x68, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x43, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x43, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x44, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x44, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x44, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x45, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x45, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x32, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x33, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x31, 0x05,
-  0x68, 0x6f, 0x75, 0x73, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
-  0x46, 0x0d, 0x72, 0x65, 0x76, 0x6c, 0x6f, 0x67, 0x69, 0x63, 0x61, 0x6c,
-  0x6e, 0x6f, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x33, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x33, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x46, 0x0a,
-  0x69, 0x6e, 0x74, 0x65, 0x67, 0x72, 0x61, 0x6c, 0x74, 0x70, 0x0a, 0x69,
-  0x6e, 0x74, 0x65, 0x67, 0x72, 0x61, 0x6c, 0x62, 0x74, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x34, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x37, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
-  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x41, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
-  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x44, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x43,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x43, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x33, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x45,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x45, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x34, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x32,
-  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x34, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36,
-  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x34, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36,
-  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x36, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x34, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36,
-  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x39, 0x08, 0x53, 0x46,
-  0x31, 0x30, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x30, 0x31, 0x08, 0x53, 0x46, 0x31, 0x31, 0x30, 0x30, 0x30, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x42, 0x08,
-  0x53, 0x46, 0x30, 0x31, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x45,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x46, 0x08, 0x53, 0x46, 0x30,
-  0x33, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x31, 0x33, 0x08, 0x53, 0x46, 0x30, 0x32, 0x30, 0x30,
-  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x35, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x31, 0x37, 0x08, 0x53, 0x46, 0x30, 0x34, 0x30, 0x30, 0x30, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x42, 0x08,
-  0x53, 0x46, 0x30, 0x38, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x45,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x31,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x32, 0x33, 0x08, 0x53, 0x46, 0x30, 0x39, 0x30, 0x30, 0x30,
-  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x42, 0x08, 0x53, 0x46,
-  0x30, 0x36, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x35, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x35, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x33, 0x33, 0x08, 0x53, 0x46, 0x30, 0x37, 0x30, 0x30, 0x30, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x42, 0x08, 0x53, 0x46, 0x30, 0x35,
-  0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x43,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x46,
-  0x08, 0x53, 0x46, 0x34, 0x33, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
-  0x32, 0x34, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x31, 0x30,
-  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x32, 0x30, 0x30, 0x30, 0x30,
-  0x08, 0x53, 0x46, 0x33, 0x39, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
-  0x32, 0x32, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x31, 0x30,
-  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x35, 0x30, 0x30, 0x30, 0x30,
-  0x08, 0x53, 0x46, 0x35, 0x30, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
-  0x34, 0x39, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x33, 0x38, 0x30,
-  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x38, 0x30, 0x30, 0x30, 0x30,
-  0x08, 0x53, 0x46, 0x32, 0x37, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
-  0x32, 0x36, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x33, 0x36, 0x30,
-  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x33, 0x37, 0x30, 0x30, 0x30, 0x30,
-  0x08, 0x53, 0x46, 0x34, 0x32, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
-  0x31, 0x39, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x30, 0x30,
-  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x33, 0x30, 0x30, 0x30, 0x30,
-  0x08, 0x53, 0x46, 0x34, 0x37, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
-  0x34, 0x38, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x34, 0x31, 0x30,
-  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x34, 0x35, 0x30, 0x30, 0x30, 0x30,
-  0x08, 0x53, 0x46, 0x34, 0x36, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
-  0x34, 0x30, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x34, 0x30,
-  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x33, 0x30, 0x30, 0x30, 0x30,
-  0x08, 0x53, 0x46, 0x34, 0x34, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x36,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x36, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x37, 0x46, 0x07, 0x75, 0x70, 0x62, 0x6c, 0x6f, 0x63,
-  0x6b, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x31, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38,
-  0x33, 0x07, 0x64, 0x6e, 0x62, 0x6c, 0x6f, 0x63, 0x6b, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38,
-  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x37, 0x05, 0x62, 0x6c,
-  0x6f, 0x63, 0x6b, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x38, 0x42, 0x07, 0x6c, 0x66, 0x62, 0x6c, 0x6f, 0x63, 0x6b, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x46, 0x07,
-  0x72, 0x74, 0x62, 0x6c, 0x6f, 0x63, 0x6b, 0x07, 0x6c, 0x74, 0x73, 0x68,
-  0x61, 0x64, 0x65, 0x05, 0x73, 0x68, 0x61, 0x64, 0x65, 0x07, 0x64, 0x6b,
-  0x73, 0x68, 0x61, 0x64, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
-  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x38, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
-  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x42, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
-  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x45, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x39, 0x46, 0x09, 0x66, 0x69, 0x6c, 0x6c, 0x65, 0x64,
-  0x62, 0x6f, 0x78, 0x06, 0x48, 0x32, 0x32, 0x30, 0x37, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x35, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x35, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x35, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x41, 0x39, 0x06, 0x48, 0x31, 0x38, 0x35, 0x34, 0x33, 0x06, 0x48, 0x31,
-  0x38, 0x35, 0x35, 0x31, 0x0a, 0x66, 0x69, 0x6c, 0x6c, 0x65, 0x64, 0x72,
-  0x65, 0x63, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x31, 0x07, 0x74, 0x72, 0x69, 0x61,
-  0x67, 0x75, 0x70, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x39, 0x07,
-  0x74, 0x72, 0x69, 0x61, 0x67, 0x72, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x42, 0x42, 0x07, 0x74, 0x72, 0x69, 0x61, 0x67, 0x64, 0x6e, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x33, 0x07, 0x74, 0x72, 0x69, 0x61,
-  0x67, 0x6c, 0x66, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x35, 0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x39, 0x06, 0x63, 0x69, 0x72, 0x63,
-  0x6c, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x35, 0x43, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
-  0x43, 0x45, 0x06, 0x48, 0x31, 0x38, 0x35, 0x33, 0x33, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x44, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x35, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
-  0x37, 0x09, 0x69, 0x6e, 0x76, 0x62, 0x75, 0x6c, 0x6c, 0x65, 0x74, 0x09,
-  0x69, 0x6e, 0x76, 0x63, 0x69, 0x72, 0x63, 0x6c, 0x65, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
-  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x43, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
-  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x46, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45,
-  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x32, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x35, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45,
-  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x35, 0x0a, 0x6f, 0x70,
-  0x65, 0x6e, 0x62, 0x75, 0x6c, 0x6c, 0x65, 0x74, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x45,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x31,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x34,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x35, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x39,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x43,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x46,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x32,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x35,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x38,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x42,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x45,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x31,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x34,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x41,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x44,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x30,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x33,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x36,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x39,
-  0x09, 0x73, 0x6d, 0x69, 0x6c, 0x65, 0x66, 0x61, 0x63, 0x65, 0x0c, 0x69,
-  0x6e, 0x76, 0x73, 0x6d, 0x69, 0x6c, 0x65, 0x66, 0x61, 0x63, 0x65, 0x03,
-  0x73, 0x75, 0x6e, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x33, 0x46, 0x06, 0x66, 0x65, 0x6d, 0x61, 0x6c, 0x65, 0x07, 0x75,
-  0x6e, 0x69, 0x32, 0x36, 0x34, 0x31, 0x04, 0x6d, 0x61, 0x6c, 0x65, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x35, 0x46, 0x05, 0x73, 0x70, 0x61, 0x64, 0x65, 0x07, 0x75, 0x6e,
-  0x69, 0x32, 0x36, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36,
-  0x32, 0x04, 0x63, 0x6c, 0x75, 0x62, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36,
-  0x36, 0x34, 0x05, 0x68, 0x65, 0x61, 0x72, 0x74, 0x07, 0x64, 0x69, 0x61,
-  0x6d, 0x6f, 0x6e, 0x64, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x37,
-  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69,
-  0x32, 0x36, 0x36, 0x39, 0x0b, 0x6d, 0x75, 0x73, 0x69, 0x63, 0x61, 0x6c,
-  0x6e, 0x6f, 0x74, 0x65, 0x0e, 0x6d, 0x75, 0x73, 0x69, 0x63, 0x61, 0x6c,
-  0x6e, 0x6f, 0x74, 0x65, 0x64, 0x62, 0x6c, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x43, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x36, 0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x36, 0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x43, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x37, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x43, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x43, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x43, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x44, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x44, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x44, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x45, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x45, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x38, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x39, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x30, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x39, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x39, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x34, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x39, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x39, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x38, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x39, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x39, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x39, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x39, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x45, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x39, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x39, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x36, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x37, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x41, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x41, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x46, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x41, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x33, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x42, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x35, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x38, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x42, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
-  0x43, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x45, 0x07,
-  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x35, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x44, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x46, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x32, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x36, 0x36, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x39, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x39, 0x30, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x31, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x34, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x37, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x41, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x43, 0x07,
-  0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
-  0x37, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x46, 0x09,
-  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x35, 0x2e, 0x35, 0x09, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x36, 0x2e, 0x35, 0x09, 0x75, 0x6e, 0x69, 0x30,
-  0x32, 0x45, 0x37, 0x2e, 0x35, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x38, 0x2e, 0x35, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x39, 0x2e,
-  0x35, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x35, 0x2e, 0x34, 0x09,
-  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x2e, 0x34, 0x09, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x37, 0x2e, 0x34, 0x09, 0x75, 0x6e, 0x69, 0x30,
-  0x32, 0x45, 0x38, 0x2e, 0x34, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x39, 0x2e, 0x34, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x35, 0x2e,
-  0x33, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x2e, 0x33, 0x09,
-  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x37, 0x2e, 0x33, 0x09, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x38, 0x2e, 0x33, 0x09, 0x75, 0x6e, 0x69, 0x30,
-  0x32, 0x45, 0x39, 0x2e, 0x33, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x35, 0x2e, 0x32, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x2e,
-  0x32, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x37, 0x2e, 0x32, 0x09,
-  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x38, 0x2e, 0x32, 0x09, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x45, 0x39, 0x2e, 0x32, 0x09, 0x75, 0x6e, 0x69, 0x30,
-  0x32, 0x45, 0x35, 0x2e, 0x31, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
-  0x36, 0x2e, 0x31, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x37, 0x2e,
-  0x31, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x38, 0x2e, 0x31, 0x09,
-  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x39, 0x2e, 0x31, 0x04, 0x73, 0x74,
-  0x65, 0x6d, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x30, 0x30, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x30, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x30,
-  0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x30, 0x30, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x32, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x38, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x45, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x31, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x37, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x41, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x44, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x36, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x39, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x43, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x46, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x34, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
-  0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x36, 0x43, 0x35, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x42, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x42,
-  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x42, 0x30, 0x34, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x42, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x42,
-  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x45, 0x32, 0x30, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x45, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x45,
-  0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x45, 0x32, 0x33, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x46, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x46,
-  0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x46, 0x46, 0x42, 0x07, 0x75,
-  0x6e, 0x69, 0x46, 0x46, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x46,
-  0x46, 0x44, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x30, 0x06, 0x75, 0x31,
-  0x30, 0x33, 0x30, 0x31, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x32, 0x06,
-  0x75, 0x31, 0x30, 0x33, 0x30, 0x33, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30,
-  0x34, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x35, 0x06, 0x75, 0x31, 0x30,
-  0x33, 0x30, 0x36, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x37, 0x06, 0x75,
-  0x31, 0x30, 0x33, 0x30, 0x38, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x39,
-  0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x41, 0x06, 0x75, 0x31, 0x30, 0x33,
-  0x30, 0x42, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x43, 0x06, 0x75, 0x31,
-  0x30, 0x33, 0x30, 0x44, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x45, 0x06,
-  0x75, 0x31, 0x30, 0x33, 0x30, 0x46, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31,
-  0x30, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x31, 0x06, 0x75, 0x31, 0x30,
-  0x33, 0x31, 0x32, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x33, 0x06, 0x75,
-  0x31, 0x30, 0x33, 0x31, 0x34, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x35,
-  0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x36, 0x06, 0x75, 0x31, 0x30, 0x33,
-  0x31, 0x37, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x38, 0x06, 0x75, 0x31,
-  0x30, 0x33, 0x31, 0x39, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x41, 0x06,
-  0x75, 0x31, 0x30, 0x33, 0x31, 0x42, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31,
-  0x43, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x44, 0x06, 0x75, 0x31, 0x30,
-  0x33, 0x31, 0x45, 0x06, 0x75, 0x31, 0x30, 0x33, 0x32, 0x30, 0x06, 0x75,
-  0x31, 0x30, 0x33, 0x32, 0x31, 0x06, 0x75, 0x31, 0x30, 0x33, 0x32, 0x32,
-  0x06, 0x75, 0x31, 0x30, 0x33, 0x32, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x30, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x31, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x30, 0x32, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x33, 0x06,
-  0x75, 0x31, 0x44, 0x33, 0x30, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30,
-  0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x36, 0x06, 0x75, 0x31, 0x44,
-  0x33, 0x30, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x38, 0x06, 0x75,
-  0x31, 0x44, 0x33, 0x30, 0x39, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x41,
-  0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x42, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x30, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x44, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x30, 0x45, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x46, 0x06,
-  0x75, 0x31, 0x44, 0x33, 0x31, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31,
-  0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x32, 0x06, 0x75, 0x31, 0x44,
-  0x33, 0x31, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x34, 0x06, 0x75,
-  0x31, 0x44, 0x33, 0x31, 0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x36,
-  0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x31, 0x38, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x39, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x31, 0x41, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x42, 0x06,
-  0x75, 0x31, 0x44, 0x33, 0x31, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31,
-  0x44, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x45, 0x06, 0x75, 0x31, 0x44,
-  0x33, 0x31, 0x46, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x30, 0x06, 0x75,
-  0x31, 0x44, 0x33, 0x32, 0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x32,
-  0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x32, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x35, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x32, 0x36, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x37, 0x06,
-  0x75, 0x31, 0x44, 0x33, 0x32, 0x38, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32,
-  0x39, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x41, 0x06, 0x75, 0x31, 0x44,
-  0x33, 0x32, 0x42, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x43, 0x06, 0x75,
-  0x31, 0x44, 0x33, 0x32, 0x44, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x45,
-  0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x46, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x33, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x31, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x33, 0x32, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x33, 0x06,
-  0x75, 0x31, 0x44, 0x33, 0x33, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33,
-  0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x36, 0x06, 0x75, 0x31, 0x44,
-  0x33, 0x33, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x38, 0x06, 0x75,
-  0x31, 0x44, 0x33, 0x33, 0x39, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x41,
-  0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x42, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x33, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x44, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x33, 0x45, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x46, 0x06,
-  0x75, 0x31, 0x44, 0x33, 0x34, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34,
-  0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x32, 0x06, 0x75, 0x31, 0x44,
-  0x33, 0x34, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x34, 0x06, 0x75,
-  0x31, 0x44, 0x33, 0x34, 0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x36,
-  0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x34, 0x38, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x39, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x34, 0x41, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x42, 0x06,
-  0x75, 0x31, 0x44, 0x33, 0x34, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34,
-  0x44, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x45, 0x06, 0x75, 0x31, 0x44,
-  0x33, 0x34, 0x46, 0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x30, 0x06, 0x75,
-  0x31, 0x44, 0x33, 0x35, 0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x32,
-  0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33,
-  0x35, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x35, 0x06, 0x75, 0x31,
-  0x44, 0x33, 0x35, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33, 0x38, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x33, 0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33,
-  0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33, 0x43, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x33, 0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33, 0x45, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x34, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x31,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x34, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x34, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x34, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x41, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x34, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34,
-  0x43, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x44, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x34, 0x45, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x46, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x35, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x32,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x35, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x35, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x35, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x37, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x35, 0x38, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35,
-  0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x41, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x35, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x43, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x35, 0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x45,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x46, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x36, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x31, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x36, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x33, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x36, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36,
-  0x35, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x36, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x36, 0x37, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x38, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x36, 0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x41,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x41, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x31, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x41, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x33, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x41, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41,
-  0x35, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x36, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x41, 0x37, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x38, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x41, 0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x41,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x41, 0x43, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x44, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x41, 0x45, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x46, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x42, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42,
-  0x31, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x32, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x42, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x34, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x42, 0x35, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x36,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x37, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x42, 0x38, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x39, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x42, 0x41, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x42, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x42, 0x43, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42,
-  0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x45, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x42, 0x46, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x30, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x43, 0x31, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x32,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x43, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x35, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x43, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x37, 0x06,
-  0x75, 0x31, 0x44, 0x35, 0x43, 0x38, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43,
-  0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x41, 0x06, 0x75, 0x31, 0x44,
-  0x35, 0x43, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x43, 0x06, 0x75,
-  0x31, 0x44, 0x35, 0x43, 0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x45,
-  0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x46, 0x06, 0x75, 0x31, 0x44, 0x35,
-  0x44, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x44, 0x31, 0x06, 0x75, 0x31,
-  0x44, 0x35, 0x44, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35, 0x44, 0x33, 0x06,
-  0x75, 0x31, 0x44, 0x37, 0x44, 0x38, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44,
-  0x39, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x41, 0x06, 0x75, 0x31, 0x44,
-  0x37, 0x44, 0x42, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x43, 0x06, 0x75,
-  0x31, 0x44, 0x37, 0x44, 0x44, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x45,
-  0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x46, 0x06, 0x75, 0x31, 0x44, 0x37,
-  0x45, 0x30, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x31, 0x06, 0x75, 0x31,
-  0x44, 0x37, 0x45, 0x32, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x33, 0x06,
-  0x75, 0x31, 0x44, 0x37, 0x45, 0x34, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45,
-  0x35, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x36, 0x06, 0x75, 0x31, 0x44,
-  0x37, 0x45, 0x37, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x38, 0x06, 0x75,
-  0x31, 0x44, 0x37, 0x45, 0x39, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x41,
-  0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x33, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x31, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x33, 0x32, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x33, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x33, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33,
-  0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x36, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x33, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x38, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x33, 0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x41,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x33, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x44, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x33, 0x45, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x46, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x34, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34,
-  0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x32, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x34, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x34, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x34, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x36,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x34, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x39, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x34, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x42, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x34, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34,
-  0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x45, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x34, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x30, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x35, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x32,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x35, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x35, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x35, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x37, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x35, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35,
-  0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x41, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x35, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x43, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x35, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x45,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x36, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x31, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x36, 0x32, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x33, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x36, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36,
-  0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x36, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x36, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x38, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x36, 0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x41,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x36, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x44, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x36, 0x45, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x46, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x37, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37,
-  0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x32, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x37, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x34, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x37, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x36,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x37, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x39, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x37, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x42, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x37, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37,
-  0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x45, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x37, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x30, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x38, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x32,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x38, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x35, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x38, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x37, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x38, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38,
-  0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x41, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x38, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x43, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x38, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x45,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x39, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x39, 0x31, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x39, 0x32, 0x06, 0x75, 0x31, 0x46, 0x30, 0x39, 0x33, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x41, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41,
-  0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x32, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x41, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x34, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x41, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x36,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x41, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x39, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x41, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x42, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x41, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41,
-  0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x45, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x42, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x32, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x42, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x34,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x42, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x37, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x42, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x39, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x42, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42,
-  0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x43, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x42, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x45, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x43, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x32,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x43, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x35, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x43, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x37, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x43, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43,
-  0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x41, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x43, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x43, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x43, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x45,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x44, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x32, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x44, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x34, 0x06,
-  0x75, 0x31, 0x46, 0x30, 0x44, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44,
-  0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x37, 0x06, 0x75, 0x31, 0x46,
-  0x30, 0x44, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x39, 0x06, 0x75,
-  0x31, 0x46, 0x30, 0x44, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x42,
-  0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30,
-  0x44, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x45, 0x06, 0x75, 0x31,
-  0x46, 0x30, 0x44, 0x46, 0x06, 0x75, 0x31, 0x46, 0x34, 0x32, 0x44, 0x06,
-  0x75, 0x31, 0x46, 0x34, 0x32, 0x45, 0x06, 0x75, 0x31, 0x46, 0x34, 0x33,
-  0x31, 0x06, 0x75, 0x31, 0x46, 0x34, 0x33, 0x35, 0x06, 0x75, 0x31, 0x46,
-  0x36, 0x30, 0x30, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x31, 0x06, 0x75,
-  0x31, 0x46, 0x36, 0x30, 0x32, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x33,
-  0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x34, 0x06, 0x75, 0x31, 0x46, 0x36,
-  0x30, 0x35, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x36, 0x06, 0x75, 0x31,
-  0x46, 0x36, 0x30, 0x37, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x38, 0x06,
-  0x75, 0x31, 0x46, 0x36, 0x30, 0x39, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30,
-  0x41, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x42, 0x06, 0x75, 0x31, 0x46,
-  0x36, 0x30, 0x43, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x44, 0x06, 0x75,
-  0x31, 0x46, 0x36, 0x30, 0x45, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x46,
-  0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x30, 0x06, 0x75, 0x31, 0x46, 0x36,
-  0x31, 0x31, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x32, 0x06, 0x75, 0x31,
-  0x46, 0x36, 0x31, 0x33, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x34, 0x06,
-  0x75, 0x31, 0x46, 0x36, 0x31, 0x35, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31,
-  0x36, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x37, 0x06, 0x75, 0x31, 0x46,
-  0x36, 0x31, 0x38, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x39, 0x06, 0x75,
-  0x31, 0x46, 0x36, 0x31, 0x41, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x42,
-  0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x43, 0x06, 0x75, 0x31, 0x46, 0x36,
-  0x31, 0x44, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x45, 0x06, 0x75, 0x31,
-  0x46, 0x36, 0x31, 0x46, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x30, 0x06,
-  0x75, 0x31, 0x46, 0x36, 0x32, 0x31, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32,
-  0x32, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x33, 0x06, 0x75, 0x31, 0x46,
-  0x36, 0x32, 0x35, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x36, 0x06, 0x75,
-  0x31, 0x46, 0x36, 0x32, 0x37, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x38,
-  0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x39, 0x06, 0x75, 0x31, 0x46, 0x36,
-  0x32, 0x41, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x42, 0x06, 0x75, 0x31,
-  0x46, 0x36, 0x32, 0x44, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x45, 0x06,
-  0x75, 0x31, 0x46, 0x36, 0x32, 0x46, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33,
-  0x30, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x31, 0x06, 0x75, 0x31, 0x46,
-  0x36, 0x33, 0x32, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x33, 0x06, 0x75,
-  0x31, 0x46, 0x36, 0x33, 0x34, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x35,
-  0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x36, 0x06, 0x75, 0x31, 0x46, 0x36,
-  0x33, 0x37, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x38, 0x06, 0x75, 0x31,
-  0x46, 0x36, 0x33, 0x39, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x41, 0x06,
-  0x75, 0x31, 0x46, 0x36, 0x33, 0x42, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33,
-  0x43, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x44, 0x06, 0x75, 0x31, 0x46,
-  0x36, 0x33, 0x45, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x46, 0x06, 0x75,
-  0x31, 0x46, 0x36, 0x34, 0x30, 0x09, 0x64, 0x6c, 0x4c, 0x74, 0x63, 0x61,
-  0x72, 0x6f, 0x6e, 0x08, 0x44, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73,
-  0x05, 0x41, 0x63, 0x75, 0x74, 0x65, 0x05, 0x54, 0x69, 0x6c, 0x64, 0x65,
-  0x05, 0x47, 0x72, 0x61, 0x76, 0x65, 0x0a, 0x43, 0x69, 0x72, 0x63, 0x75,
-  0x6d, 0x66, 0x6c, 0x65, 0x78, 0x05, 0x43, 0x61, 0x72, 0x6f, 0x6e, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x31, 0x2e, 0x63, 0x61, 0x73, 0x65,
-  0x05, 0x42, 0x72, 0x65, 0x76, 0x65, 0x09, 0x44, 0x6f, 0x74, 0x61, 0x63,
-  0x63, 0x65, 0x6e, 0x74, 0x0c, 0x48, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75,
-  0x6d, 0x6c, 0x61, 0x75, 0x74, 0x0b, 0x44, 0x6f, 0x75, 0x62, 0x6c, 0x65,
-  0x67, 0x72, 0x61, 0x76, 0x65, 0x0a, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63,
-  0x5f, 0x64, 0x6f, 0x74, 0x0c, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63, 0x5f,
-  0x32, 0x64, 0x6f, 0x74, 0x73, 0x0c, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63,
-  0x5f, 0x33, 0x64, 0x6f, 0x74, 0x73, 0x0e, 0x61, 0x72, 0x61, 0x62, 0x69,
-  0x63, 0x5f, 0x33, 0x64, 0x6f, 0x74, 0x73, 0x5f, 0x61, 0x0e, 0x61, 0x72,
-  0x61, 0x62, 0x69, 0x63, 0x5f, 0x32, 0x64, 0x6f, 0x74, 0x73, 0x5f, 0x61,
-  0x0c, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63, 0x5f, 0x34, 0x64, 0x6f, 0x74,
-  0x73, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x36, 0x45, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x36, 0x45, 0x2e, 0x69,
-  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x36, 0x45, 0x2e,
-  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x31,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
-  0x31, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x41, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x36, 0x46, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x36, 0x46, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x36, 0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x42, 0x41, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x41, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0b, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63, 0x5f, 0x72, 0x69, 0x6e, 0x67,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x43, 0x2e, 0x66, 0x69, 0x6e,
-  0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x43, 0x2e, 0x69, 0x6e,
-  0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x43, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x44, 0x2e,
-  0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x44,
-  0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37,
-  0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x38, 0x31, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x38, 0x31, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x38, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x38, 0x32, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x38, 0x32, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x32, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x35, 0x2e, 0x66, 0x69, 0x6e,
-  0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x35, 0x2e, 0x69, 0x6e,
-  0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x35, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x46, 0x2e,
-  0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x46,
-  0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42,
-  0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0e, 0x61, 0x72, 0x61, 0x62, 0x69,
-  0x63, 0x5f, 0x67, 0x61, 0x66, 0x5f, 0x62, 0x61, 0x72, 0x07, 0x45, 0x6e,
-  0x67, 0x2e, 0x61, 0x6c, 0x74, 0x0f, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
-  0x38, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73, 0x0f, 0x75, 0x6e,
-  0x69, 0x30, 0x32, 0x39, 0x44, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73,
-  0x73, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
-  0x34, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x30, 0x33, 0x30,
-  0x38, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x37, 0x30, 0x33, 0x30,
-  0x34, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
-  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
-  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x30, 0x33, 0x30,
-  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x30, 0x33, 0x30,
-  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x33, 0x30, 0x33, 0x30,
-  0x34, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
-  0x43, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x33, 0x30, 0x33, 0x30,
-  0x38, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x43, 0x30, 0x33, 0x30,
-  0x37, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x33, 0x30, 0x33, 0x30,
-  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
-  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
-  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
-  0x33, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
-  0x33, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
-  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
-  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
-  0x39, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
-  0x39, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x31, 0x30, 0x33, 0x30,
-  0x37, 0x0a, 0x62, 0x72, 0x61, 0x69, 0x6c, 0x6c, 0x65, 0x64, 0x6f, 0x74,
-  0x05, 0x4a, 0x2e, 0x61, 0x6c, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x39, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x16, 0x75, 0x6e, 0x69, 0x46,
-  0x45, 0x41, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x2e, 0x6c, 0x6f, 0x6e,
-  0x67, 0x73, 0x74, 0x61, 0x72, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x42, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x42, 0x35, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x42, 0x35, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x43, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x43, 0x45, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x43, 0x45, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x32, 0x2e, 0x66, 0x69, 0x6e,
-  0x61, 0x05, 0x6c, 0x2e, 0x61, 0x6c, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x44, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x11, 0x75, 0x6e, 0x69,
-  0x30, 0x34, 0x37, 0x38, 0x2e, 0x6d, 0x6f, 0x6e, 0x6f, 0x67, 0x72, 0x61,
-  0x70, 0x68, 0x11, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x39, 0x2e, 0x6d,
-  0x6f, 0x6e, 0x6f, 0x67, 0x72, 0x61, 0x70, 0x68, 0x0f, 0x69, 0x6f, 0x67,
-  0x6f, 0x6e, 0x65, 0x6b, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73,
-  0x0f, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x38, 0x2e, 0x64, 0x6f, 0x74,
-  0x6c, 0x65, 0x73, 0x73, 0x0f, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x39,
-  0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73, 0x0f, 0x75, 0x6e, 0x69,
-  0x31, 0x45, 0x32, 0x44, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73,
-  0x0f, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x42, 0x2e, 0x64, 0x6f, 0x74,
-  0x6c, 0x65, 0x73, 0x73, 0x03, 0x64, 0x63, 0x6f, 0x05, 0x49, 0x2e, 0x61,
-  0x6c, 0x74, 0x0a, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x2e, 0x62, 0x61, 0x73,
-  0x65, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
-  0x42, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
-  0x43, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x34, 0x42, 0x30, 0x36, 0x35,
-  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
-  0x45, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
-  0x46, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x34, 0x45, 0x30, 0x36, 0x35,
-  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x34, 0x30, 0x36, 0x34,
-  0x45, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x34, 0x30, 0x36, 0x34,
-  0x46, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x41, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x41, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x41, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x42,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43,
-  0x42, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x43, 0x42, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x37, 0x43, 0x43, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x37, 0x43, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x37, 0x43, 0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x37, 0x43, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x44, 0x2e, 0x69, 0x6e, 0x69,
-  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x45, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x45, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x45, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x46,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43,
-  0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x43, 0x46, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x37, 0x44, 0x30, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x37, 0x44, 0x30, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x37, 0x44, 0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x37, 0x44, 0x31, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x31, 0x2e, 0x69, 0x6e, 0x69,
-  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x32, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x32, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x32, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x33,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
-  0x33, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x44, 0x33, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x37, 0x44, 0x34, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x37, 0x44, 0x34, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x37, 0x44, 0x34, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x37, 0x44, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x35, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x35, 0x2e, 0x69, 0x6e, 0x69,
-  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x36, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x36, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x36, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x37,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
-  0x37, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x44, 0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x37, 0x44, 0x38, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x37, 0x44, 0x38, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x37, 0x44, 0x38, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x37, 0x44, 0x39, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x39, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x39, 0x2e, 0x69, 0x6e, 0x69,
-  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x41, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x41, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x41, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x42,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
-  0x42, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x44, 0x42, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x37, 0x44, 0x43, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x37, 0x44, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x37, 0x44, 0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x37, 0x44, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x44, 0x2e, 0x69, 0x6e, 0x69,
-  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x45, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x45, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x45, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x46,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
-  0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x44, 0x46, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x37, 0x45, 0x30, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x37, 0x45, 0x30, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x37, 0x45, 0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x37, 0x45, 0x31, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x31, 0x2e, 0x69, 0x6e, 0x69,
-  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x32, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x32, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x32, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x33,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45,
-  0x33, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x45, 0x33, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x37, 0x45, 0x34, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x37, 0x45, 0x34, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x37, 0x45, 0x34, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x37, 0x45, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x35, 0x2e, 0x6d, 0x65, 0x64, 0x69,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x35, 0x2e, 0x69, 0x6e, 0x69,
-  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x36, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x36, 0x2e, 0x6d,
-  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x36, 0x2e,
-  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x37,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45,
-  0x37, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
-  0x45, 0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x09, 0x52, 0x69, 0x6e, 0x67,
-  0x61, 0x62, 0x6f, 0x76, 0x65, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x30, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x31, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x32, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x33, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x34, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x35, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x36, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
-  0x37, 0x2e, 0x61, 0x6c, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37,
-  0x45, 0x2e, 0x64, 0x69, 0x61, 0x63, 0x11, 0x75, 0x6e, 0x69, 0x30, 0x34,
-  0x38, 0x41, 0x2e, 0x62, 0x72, 0x65, 0x76, 0x65, 0x6c, 0x65, 0x73, 0x73,
-  0x11, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x42, 0x2e, 0x62, 0x72, 0x65,
-  0x76, 0x65, 0x6c, 0x65, 0x73, 0x73, 0x05, 0x79, 0x2e, 0x61, 0x6c, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x39, 0x2e, 0x66, 0x69, 0x6e,
-  0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x41, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x42, 0x2e, 0x66,
-  0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x46, 0x2e,
-  0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x30,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39,
-  0x33, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x39, 0x34, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x39, 0x36, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x39, 0x37, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x39, 0x39, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x39, 0x41, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x41, 0x2e, 0x69, 0x6e, 0x69, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x41, 0x2e, 0x6d, 0x65, 0x64,
-  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x42, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x42, 0x2e, 0x69,
-  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x42, 0x2e,
-  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x43,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39,
-  0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x39, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x39, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x39, 0x44, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x39, 0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x39, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x45, 0x2e, 0x69, 0x6e, 0x69, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x45, 0x2e, 0x6d, 0x65, 0x64,
-  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x46, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x46, 0x2e, 0x69,
-  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x46, 0x2e,
-  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x30,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
-  0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x41, 0x30, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x41, 0x32, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x41, 0x32, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x41, 0x32, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x41, 0x33, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x33, 0x2e, 0x69, 0x6e, 0x69, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x33, 0x2e, 0x6d, 0x65, 0x64,
-  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x35, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x35, 0x2e, 0x69,
-  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x35, 0x2e,
-  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x37,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
-  0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x41, 0x37, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x41, 0x38, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x41, 0x38, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x41, 0x38, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x41, 0x41, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x41, 0x2e, 0x69, 0x6e, 0x69, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x41, 0x2e, 0x6d, 0x65, 0x64,
-  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x42, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x42, 0x2e, 0x69,
-  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x42, 0x2e,
-  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x43,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
-  0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x41, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x41, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x41, 0x45, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x41, 0x45, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x42, 0x30, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x30, 0x2e, 0x6d, 0x65, 0x64,
-  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x32, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x32, 0x2e, 0x69,
-  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x32, 0x2e,
-  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x34,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42,
-  0x34, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x42, 0x34, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x42, 0x36, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x42, 0x36, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x42, 0x36, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x42, 0x37, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x37, 0x2e, 0x6d, 0x65, 0x64,
-  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x38, 0x2e, 0x66, 0x69,
-  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x38, 0x2e, 0x69,
-  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x38, 0x2e,
-  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x39,
-  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42,
-  0x39, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
-  0x42, 0x39, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
-  0x36, 0x42, 0x43, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
-  0x30, 0x36, 0x42, 0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
-  0x69, 0x30, 0x36, 0x42, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
-  0x6e, 0x69, 0x30, 0x36, 0x42, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
-  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x44, 0x2e, 0x69, 0x6e, 0x69, 0x74,
-  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x44, 0x2e, 0x6d, 0x65, 0x64,
-  0x69, 0x00, 0x00, 0x00, 0xb8, 0x02, 0x80, 0x40, 0xff, 0xfb, 0xfe, 0x03,
-  0xfa, 0x14, 0x03, 0xf9, 0x25, 0x03, 0xf8, 0x32, 0x03, 0xf7, 0x96, 0x03,
-  0xf6, 0x0e, 0x03, 0xf5, 0xfe, 0x03, 0xf4, 0xfe, 0x03, 0xf3, 0x25, 0x03,
-  0xf2, 0x0e, 0x03, 0xf1, 0x96, 0x03, 0xf0, 0x25, 0x03, 0xef, 0x8a, 0x41,
-  0x05, 0xef, 0xfe, 0x03, 0xee, 0x96, 0x03, 0xed, 0x96, 0x03, 0xec, 0xfa,
-  0x03, 0xeb, 0xfa, 0x03, 0xea, 0xfe, 0x03, 0xe9, 0x3a, 0x03, 0xe8, 0x42,
-  0x03, 0xe7, 0xfe, 0x03, 0xe6, 0x32, 0x03, 0xe5, 0xe4, 0x53, 0x05, 0xe5,
-  0x96, 0x03, 0xe4, 0x8a, 0x41, 0x05, 0xe4, 0x53, 0x03, 0xe3, 0xe2, 0x2f,
-  0x05, 0xe3, 0xfa, 0x03, 0xe2, 0x2f, 0x03, 0xe1, 0xfe, 0x03, 0xe0, 0xfe,
-  0x03, 0xdf, 0x32, 0x03, 0xde, 0x14, 0x03, 0xdd, 0x96, 0x03, 0xdc, 0xfe,
-  0x03, 0xdb, 0x12, 0x03, 0xda, 0x7d, 0x03, 0xd9, 0xbb, 0x03, 0xd8, 0xfe,
-  0x03, 0xd6, 0x8a, 0x41, 0x05, 0xd6, 0x7d, 0x03, 0xd5, 0xd4, 0x47, 0x05,
-  0xd5, 0x7d, 0x03, 0xd4, 0x47, 0x03, 0xd3, 0xd2, 0x1b, 0x05, 0xd3, 0xfe,
-  0x03, 0xd2, 0x1b, 0x03, 0xd1, 0xfe, 0x03, 0xd0, 0xfe, 0x03, 0xcf, 0xfe,
-  0x03, 0xce, 0xfe, 0x03, 0xcd, 0x96, 0x03, 0xcc, 0xcb, 0x1e, 0x05, 0xcc,
-  0xfe, 0x03, 0xcb, 0x1e, 0x03, 0xca, 0x32, 0x03, 0xc9, 0xfe, 0x03, 0xc6,
-  0x85, 0x11, 0x05, 0xc6, 0x1c, 0x03, 0xc5, 0x16, 0x03, 0xc4, 0xfe, 0x03,
-  0xc3, 0xfe, 0x03, 0xc2, 0xfe, 0x03, 0xc1, 0xfe, 0x03, 0xc0, 0xfe, 0x03,
-  0xbf, 0xfe, 0x03, 0xbe, 0xfe, 0x03, 0xbd, 0xfe, 0x03, 0xbc, 0xfe, 0x03,
-  0xbb, 0xfe, 0x03, 0xba, 0x11, 0x03, 0xb9, 0x86, 0x25, 0x05, 0xb9, 0xfe,
-  0x03, 0xb8, 0xb7, 0xbb, 0x05, 0xb8, 0xfe, 0x03, 0xb7, 0xb6, 0x5d, 0x05,
-  0xb7, 0xbb, 0x03, 0xb7, 0x80, 0x04, 0xb6, 0xb5, 0x25, 0x05, 0xb6, 0x5d,
-  0x40, 0xff, 0x03, 0xb6, 0x40, 0x04, 0xb5, 0x25, 0x03, 0xb4, 0xfe, 0x03,
-  0xb3, 0x96, 0x03, 0xb2, 0xfe, 0x03, 0xb1, 0xfe, 0x03, 0xb0, 0xfe, 0x03,
-  0xaf, 0xfe, 0x03, 0xae, 0x64, 0x03, 0xad, 0x0e, 0x03, 0xac, 0xab, 0x25,
-  0x05, 0xac, 0x64, 0x03, 0xab, 0xaa, 0x12, 0x05, 0xab, 0x25, 0x03, 0xaa,
-  0x12, 0x03, 0xa9, 0x8a, 0x41, 0x05, 0xa9, 0xfa, 0x03, 0xa8, 0xfe, 0x03,
-  0xa7, 0xfe, 0x03, 0xa6, 0xfe, 0x03, 0xa5, 0x12, 0x03, 0xa4, 0xfe, 0x03,
-  0xa3, 0xa2, 0x0e, 0x05, 0xa3, 0x32, 0x03, 0xa2, 0x0e, 0x03, 0xa1, 0x64,
-  0x03, 0xa0, 0x8a, 0x41, 0x05, 0xa0, 0x96, 0x03, 0x9f, 0xfe, 0x03, 0x9e,
-  0x9d, 0x0c, 0x05, 0x9e, 0xfe, 0x03, 0x9d, 0x0c, 0x03, 0x9c, 0x9b, 0x19,
-  0x05, 0x9c, 0x64, 0x03, 0x9b, 0x9a, 0x10, 0x05, 0x9b, 0x19, 0x03, 0x9a,
-  0x10, 0x03, 0x99, 0x0a, 0x03, 0x98, 0xfe, 0x03, 0x97, 0x96, 0x0d, 0x05,
-  0x97, 0xfe, 0x03, 0x96, 0x0d, 0x03, 0x95, 0x8a, 0x41, 0x05, 0x95, 0x96,
-  0x03, 0x94, 0x93, 0x0e, 0x05, 0x94, 0x28, 0x03, 0x93, 0x0e, 0x03, 0x92,
-  0xfa, 0x03, 0x91, 0x90, 0xbb, 0x05, 0x91, 0xfe, 0x03, 0x90, 0x8f, 0x5d,
-  0x05, 0x90, 0xbb, 0x03, 0x90, 0x80, 0x04, 0x8f, 0x8e, 0x25, 0x05, 0x8f,
-  0x5d, 0x03, 0x8f, 0x40, 0x04, 0x8e, 0x25, 0x03, 0x8d, 0xfe, 0x03, 0x8c,
-  0x8b, 0x2e, 0x05, 0x8c, 0xfe, 0x03, 0x8b, 0x2e, 0x03, 0x8a, 0x86, 0x25,
-  0x05, 0x8a, 0x41, 0x03, 0x89, 0x88, 0x0b, 0x05, 0x89, 0x14, 0x03, 0x88,
-  0x0b, 0x03, 0x87, 0x86, 0x25, 0x05, 0x87, 0x64, 0x03, 0x86, 0x85, 0x11,
-  0x05, 0x86, 0x25, 0x03, 0x85, 0x11, 0x03, 0x84, 0xfe, 0x03, 0x83, 0x82,
-  0x11, 0x05, 0x83, 0xfe, 0x03, 0x82, 0x11, 0x03, 0x81, 0xfe, 0x03, 0x80,
-  0xfe, 0x03, 0x7f, 0xfe, 0x03, 0x40, 0xff, 0x7e, 0x7d, 0x7d, 0x05, 0x7e,
-  0xfe, 0x03, 0x7d, 0x7d, 0x03, 0x7c, 0x64, 0x03, 0x7b, 0x54, 0x15, 0x05,
-  0x7b, 0x25, 0x03, 0x7a, 0xfe, 0x03, 0x79, 0xfe, 0x03, 0x78, 0x0e, 0x03,
-  0x77, 0x0c, 0x03, 0x76, 0x0a, 0x03, 0x75, 0xfe, 0x03, 0x74, 0xfa, 0x03,
-  0x73, 0xfa, 0x03, 0x72, 0xfa, 0x03, 0x71, 0xfa, 0x03, 0x70, 0xfe, 0x03,
-  0x6f, 0xfe, 0x03, 0x6e, 0xfe, 0x03, 0x6c, 0x21, 0x03, 0x6b, 0xfe, 0x03,
-  0x6a, 0x11, 0x42, 0x05, 0x6a, 0x53, 0x03, 0x69, 0xfe, 0x03, 0x68, 0x7d,
-  0x03, 0x67, 0x11, 0x42, 0x05, 0x66, 0xfe, 0x03, 0x65, 0xfe, 0x03, 0x64,
-  0xfe, 0x03, 0x63, 0xfe, 0x03, 0x62, 0xfe, 0x03, 0x61, 0x3a, 0x03, 0x60,
-  0xfa, 0x03, 0x5e, 0x0c, 0x03, 0x5d, 0xfe, 0x03, 0x5b, 0xfe, 0x03, 0x5a,
-  0xfe, 0x03, 0x59, 0x58, 0x0a, 0x05, 0x59, 0xfa, 0x03, 0x58, 0x0a, 0x03,
-  0x57, 0x16, 0x19, 0x05, 0x57, 0x32, 0x03, 0x56, 0xfe, 0x03, 0x55, 0x54,
-  0x15, 0x05, 0x55, 0x42, 0x03, 0x54, 0x15, 0x03, 0x53, 0x01, 0x10, 0x05,
-  0x53, 0x18, 0x03, 0x52, 0x14, 0x03, 0x51, 0x4a, 0x13, 0x05, 0x51, 0xfe,
-  0x03, 0x50, 0x0b, 0x03, 0x4f, 0xfe, 0x03, 0x4e, 0x4d, 0x10, 0x05, 0x4e,
-  0xfe, 0x03, 0x4d, 0x10, 0x03, 0x4c, 0xfe, 0x03, 0x4b, 0x4a, 0x13, 0x05,
-  0x4b, 0xfe, 0x03, 0x4a, 0x49, 0x10, 0x05, 0x4a, 0x13, 0x03, 0x49, 0x1d,
-  0x0d, 0x05, 0x49, 0x10, 0x03, 0x48, 0x0d, 0x03, 0x47, 0xfe, 0x03, 0x46,
-  0x96, 0x03, 0x45, 0x96, 0x03, 0x44, 0xfe, 0x03, 0x43, 0x02, 0x2d, 0x05,
-  0x43, 0xfa, 0x03, 0x42, 0xbb, 0x03, 0x41, 0x4b, 0x03, 0x40, 0xfe, 0x03,
-  0x3f, 0xfe, 0x03, 0x3e, 0x3d, 0x12, 0x05, 0x3e, 0x14, 0x03, 0x3d, 0x3c,
-  0x0f, 0x05, 0x3d, 0x12, 0x03, 0x3c, 0x3b, 0x0d, 0x05, 0x3c, 0x40, 0xff,
-  0x0f, 0x03, 0x3b, 0x0d, 0x03, 0x3a, 0xfe, 0x03, 0x39, 0xfe, 0x03, 0x38,
-  0x37, 0x14, 0x05, 0x38, 0xfa, 0x03, 0x37, 0x36, 0x10, 0x05, 0x37, 0x14,
-  0x03, 0x36, 0x35, 0x0b, 0x05, 0x36, 0x10, 0x03, 0x35, 0x0b, 0x03, 0x34,
-  0x1e, 0x03, 0x33, 0x0d, 0x03, 0x32, 0x31, 0x0b, 0x05, 0x32, 0xfe, 0x03,
-  0x31, 0x0b, 0x03, 0x30, 0x2f, 0x0b, 0x05, 0x30, 0x0d, 0x03, 0x2f, 0x0b,
-  0x03, 0x2e, 0x2d, 0x09, 0x05, 0x2e, 0x10, 0x03, 0x2d, 0x09, 0x03, 0x2c,
-  0x32, 0x03, 0x2b, 0x2a, 0x25, 0x05, 0x2b, 0x64, 0x03, 0x2a, 0x29, 0x12,
-  0x05, 0x2a, 0x25, 0x03, 0x29, 0x12, 0x03, 0x28, 0x27, 0x25, 0x05, 0x28,
-  0x41, 0x03, 0x27, 0x25, 0x03, 0x26, 0x25, 0x0b, 0x05, 0x26, 0x0f, 0x03,
-  0x25, 0x0b, 0x03, 0x24, 0xfe, 0x03, 0x23, 0xfe, 0x03, 0x22, 0x0f, 0x03,
-  0x21, 0x01, 0x10, 0x05, 0x21, 0x12, 0x03, 0x20, 0x64, 0x03, 0x1f, 0xfa,
-  0x03, 0x1e, 0x1d, 0x0d, 0x05, 0x1e, 0x64, 0x03, 0x1d, 0x0d, 0x03, 0x1c,
-  0x11, 0x42, 0x05, 0x1c, 0xfe, 0x03, 0x1b, 0xfa, 0x03, 0x1a, 0x42, 0x03,
-  0x19, 0x11, 0x42, 0x05, 0x19, 0xfe, 0x03, 0x18, 0x64, 0x03, 0x17, 0x16,
-  0x19, 0x05, 0x17, 0xfe, 0x03, 0x16, 0x01, 0x10, 0x05, 0x16, 0x19, 0x03,
-  0x15, 0xfe, 0x03, 0x14, 0xfe, 0x03, 0x13, 0xfe, 0x03, 0x12, 0x11, 0x42,
-  0x05, 0x12, 0xfe, 0x03, 0x11, 0x02, 0x2d, 0x05, 0x11, 0x42, 0x03, 0x10,
-  0x7d, 0x03, 0x0f, 0x64, 0x03, 0x0e, 0xfe, 0x03, 0x0d, 0x0c, 0x16, 0x05,
-  0x0d, 0xfe, 0x03, 0x0c, 0x01, 0x10, 0x05, 0x0c, 0x16, 0x03, 0x0b, 0xfe,
-  0x03, 0x0a, 0x10, 0x03, 0x09, 0xfe, 0x03, 0x08, 0x02, 0x2d, 0x05, 0x08,
-  0xfe, 0x03, 0x07, 0x14, 0x03, 0x06, 0x64, 0x03, 0x04, 0x01, 0x10, 0x05,
-  0x04, 0xfe, 0x03, 0x40, 0x15, 0x03, 0x02, 0x2d, 0x05, 0x03, 0xfe, 0x03,
-  0x02, 0x01, 0x10, 0x05, 0x02, 0x2d, 0x03, 0x01, 0x10, 0x03, 0x00, 0xfe,
-  0x03, 0x01, 0xb8, 0x01, 0x64, 0x85, 0x8d, 0x01, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x00, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
-  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x1d
-};
-unsigned int dejavu_sans_condensed_ttf_len = 552620;
-#endif
diff -pruN 8.0.1-5/dxfcolor.h 8.2.0~beta1-1~exp1/dxfcolor.h
--- 8.0.1-5/dxfcolor.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/dxfcolor.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,261 +0,0 @@
-struct dxfcolor {
-  int r,g,b;
-};
-struct dxfcolor ctable[256] = {
-  {0,   0,  0},
-  {255,   0,  0},
-  {255,   255,  0},
-  {0,   255,  0},
-  {0,   255,  255},
-  {0,   0,  255},
-  {255,   0,  255},
-  {255,   255,  255},
-  {128,   128,  128},
-  {192,   192,  192},
-  {255,   0,  0},
-  {255,   127,  127},
-  {204,   0,  0},
-  {204,   102,  102},
-  {153,   0,  0},
-  {153,   76,   76},
-  {127,   0,  0},
-  {127,   63,   63},
-  {76,  0,  0},
-  {76,  38,   38},
-  {255,   63,   0},
-  {255,   159,  127},
-  {204,   51,   0},
-  {204,   127,  102},
-  {153,   38,   0},
-  {153,   95,   76},
-  {127,   31,   0},
-  {127,   79,   63},
-  {76,  19,   0},
-  {76,  47,   38},
-  {255,   127,  0},
-  {255,   191,  127},
-  {204,   102,  0},
-  {204,   153,  102},
-  {153,   76,   0},
-  {153,   114,  76},
-  {127,   63,   0},
-  {127,   95,   63},
-  {76,  38,   0},
-  {76,  57,   38},
-  {255,   191,  0},
-  {255,   223,  127},
-  {204,   153,  0},
-  {204,   178,  102},
-  {153,   114,  0},
-  {153,   133,  76},
-  {127,   95,   0},
-  {127,   111,  63},
-  {76,  57,   0},
-  {76,  66,   38},
-  {255,   255,  0},
-  {255,   255,  127},
-  {204,   204,  0},
-  {204,   204,  102},
-  {153,   153,  0},
-  {153,   153,  76},
-  {127,   127,  0},
-  {127,   127,  63},
-  {76,  76,   0},
-  {76,  76,   38},
-  {191,   255,  0},
-  {223,   255,  127},
-  {153,   204,  0},
-  {178,   204,  102},
-  {114,   153,  0},
-  {133,   153,  76},
-  {95,  127,  0},
-  {111,   127,  63},
-  {57,  76,   0},
-  {66,  76,   38},
-  {127,   255,  0},
-  {191,   255,  127},
-  {102,   204,  0},
-  {153,   204,  102},
-  {76,  153,  0},
-  {114,   153,  76},
-  {63,  127,  0},
-  {95,  127,  63},
-  {38,  76,   0},
-  {57,  76,   38},
-  {63,  255,  0},
-  {159,   255,  127},
-  {51,  204,  0},
-  {127,   204,  102},
-  {38,  153,  0},
-  {95,  153,  76},
-  {31,  127,  0},
-  {79,  127,  63},
-  {19,  76,   0},
-  {47,  76,   38},
-  {0,   255,  0},
-  {127,   255,  127},
-  {0,   204,  0},
-  {102,   204,  102},
-  {0,   153,  0},
-  {76,  153,  76},
-  {0,   127,  0},
-  {63,  127,  63},
-  {0,   76,   0},
-  {38,  76,   38},
-  {0,   255,  63},
-  {127,   255,  159},
-  {0,   204,  51},
-  {102,   204,  127},
-  {0,   153,  38},
-  {76,  153,  95},
-  {0,   127,  31},
-  {63,  127,  79},
-  {0,   76,   19},
-  {38,  76,   47},
-  {0,   255,  127},
-  {127,   255,  191},
-  {0,   204,  102},
-  {102,   204,  153},
-  {0,   153,  76},
-  {76,  153,  114},
-  {0,   127,  63},
-  {63,  127,  95},
-  {0,   76,   38},
-  {38,  76,   57},
-  {0,   255,  191},
-  {127,   255,  223},
-  {0,   204,  153},
-  {102,   204,  178},
-  {0,   153,  114},
-  {76,  153,  133},
-  {0,   127,  95},
-  {63,  127,  111},
-  {0,   76,   57},
-  {38,  76,   66},
-  {0,   255,  255},
-  {127,   255,  255},
-  {0,   204,  204},
-  {102,   204,  204},
-  {0,   153,  153},
-  {76,  153,  153},
-  {0,   127,  127},
-  {63,  127,  127},
-  {0,   76,   76},
-  {38,  76,   76},
-  {0,   191,  255},
-  {127,   223,  255},
-  {0,   153,  204},
-  {102,   178,  204},
-  {0,   114,  153},
-  {76,  133,  153},
-  {0,   95,   127},
-  {63,  111,  127},
-  {0,   57,   76},
-  {38,  66,   76},
-  {0,   127,  255},
-  {127,   191,  255},
-  {0,   102,  204},
-  {102,   153,  204},
-  {0,   76,   153},
-  {76,  114,  153},
-  {0,   63,   127},
-  {63,  95,   127},
-  {0,   38,   76},
-  {38,  57,   76},
-  {0,   63,   255},
-  {127,   159,  255},
-  {0,   51,   204},
-  {102,   127,  204},
-  {0,   38,   153},
-  {76,  95,   153},
-  {0,   31,   127},
-  {63,  79,   127},
-  {0,   19,   76},
-  {38,  47,   76},
-  {0,   0,  255},
-  {127,   127,  255},
-  {0,   0,  204},
-  {102,   102,  204},
-  {0,   0,  153},
-  {76,  76,   153},
-  {0,   0,  127},
-  {63,  63,   127},
-  {0,   0,  76},
-  {38,  38,   76},
-  {63,  0,  255},
-  {159,   127,  255},
-  {51,  0,  204},
-  {127,   102,  204},
-  {38,  0,  153},
-  {95,  76,   153},
-  {31,  0,  127},
-  {79,  63,   127},
-  {19,  0,  76},
-  {47,  38,   76},
-  {127,   0,  255},
-  {191,   127,  255},
-  {102,   0,  204},
-  {153,   102,  204},
-  {76,  0,  153},
-  {114,   76,   153},
-  {63,  0,  127},
-  {95,  63,   127},
-  {38,  0,  76},
-  {57,  38,   76},
-  {191,   0,  255},
-  {223,   127,  255},
-  {153,   0,  204},
-  {178,   102,  204},
-  {114,   0,  153},
-  {133,   76,   153},
-  {95,  0,  127},
-  {111,   63,   127},
-  {57,  0,  76},
-  {66,  38,   76},
-  {255,   0,  255},
-  {255,   127,  255},
-  {204,   0,  204},
-  {204,   102,  204},
-  {153,   0,  153},
-  {153,   76,   153},
-  {127,   0,  127},
-  {127,   63,   127},
-  {76,  0,  76},
-  {76,  38,   76},
-  {255,   0,  191},
-  {255,   127,  223},
-  {204,   0,  153},
-  {204,   102,  178},
-  {153,   0,  114},
-  {153,   76,   133},
-  {127,   0,  95},
-  {127,   63,   111},
-  {76,  0,  57},
-  {76,  38,   66},
-  {255,   0,  127},
-  {255,   127,  191},
-  {204,   0,  102},
-  {204,   102,  153},
-  {153,   0,  76},
-  {153,   76,   114},
-  {127,   0,  63},
-  {127,   63,   95},
-  {76,  0,  38},
-  {76,  38,   57},
-  {255,   0,  63},
-  {255,   127,  159},
-  {204,   0,  51},
-  {204,   102,  127},
-  {153,   0,  38},
-  {153,   76,   95},
-  {127,   0,  31},
-  {127,   63,   79},
-  {76,  0,  19},
-  {76,  38,   47},
-  {51,  51,   51},
-  {91,  91,   91},
-  {132,   132,  132},
-  {173,   173,  173},
-  {214,   214,  214},
-  {255,   255,  255},
-};
diff -pruN 8.0.1-5/etc/mapserver-sample.conf 8.2.0~beta1-1~exp1/etc/mapserver-sample.conf
--- 8.0.1-5/etc/mapserver-sample.conf	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/etc/mapserver-sample.conf	2024-06-06 20:07:58.000000000 +0000
@@ -21,6 +21,15 @@ CONFIG
     # MS_ERRORFILE "/opt/mapserver/logs/mapserver.log"
 
     #
+    # Global Error Redirect Handling
+    #
+    # see https://mapserver.org/mapfile/web.html#EMPTY
+    # MS_EMPTY_URL "https://mapserver.org/"
+    #
+    # see https://mapserver.org/mapfile/web.html#ERROR
+    # MS_ERROR_URL "https://mapserver.org/"
+
+    #
     # Default Map
     #
     # MS_MAPFILE "/opt/mapserver/test/test.map"
diff -pruN 8.0.1-5/flatgeobuf/LICENSE 8.2.0~beta1-1~exp1/flatgeobuf/LICENSE
--- 8.0.1-5/flatgeobuf/LICENSE	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/LICENSE	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-Copyright (c) 2018, Björn Harrtell
-
-Redistribution and use in source and binary forms, with or without
-modification, are permitted provided that the following conditions are met:
-
-1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
-2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
-
-THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
diff -pruN 8.0.1-5/flatgeobuf/feature_generated.h 8.2.0~beta1-1~exp1/flatgeobuf/feature_generated.h
--- 8.0.1-5/flatgeobuf/feature_generated.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/feature_generated.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,287 +0,0 @@
-// automatically generated by the FlatBuffers compiler, do not modify
-
-
-#ifndef FLATBUFFERS_GENERATED_FEATURE_FLATGEOBUF_H_
-#define FLATBUFFERS_GENERATED_FEATURE_FLATGEOBUF_H_
-
-#include "flatbuffers/flatbuffers.h"
-
-// Ensure the included flatbuffers.h is the same version as when this file was
-// generated, otherwise it may not be compatible.
-static_assert(FLATBUFFERS_VERSION_MAJOR == 2 &&
-              FLATBUFFERS_VERSION_MINOR == 0 &&
-              FLATBUFFERS_VERSION_REVISION == 6,
-             "Non-compatible flatbuffers version included");
-
-#include "header_generated.h"
-
-namespace mapserver {
-namespace FlatGeobuf {
-
-struct Geometry;
-struct GeometryBuilder;
-
-struct Feature;
-struct FeatureBuilder;
-
-struct Geometry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef GeometryBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_ENDS = 4,
-    VT_XY = 6,
-    VT_Z = 8,
-    VT_M = 10,
-    VT_T = 12,
-    VT_TM = 14,
-    VT_TYPE = 16,
-    VT_PARTS = 18
-  };
-  const flatbuffers::Vector<uint32_t> *ends() const {
-    return GetPointer<const flatbuffers::Vector<uint32_t> *>(VT_ENDS);
-  }
-  const flatbuffers::Vector<double> *xy() const {
-    return GetPointer<const flatbuffers::Vector<double> *>(VT_XY);
-  }
-  const flatbuffers::Vector<double> *z() const {
-    return GetPointer<const flatbuffers::Vector<double> *>(VT_Z);
-  }
-  const flatbuffers::Vector<double> *m() const {
-    return GetPointer<const flatbuffers::Vector<double> *>(VT_M);
-  }
-  const flatbuffers::Vector<double> *t() const {
-    return GetPointer<const flatbuffers::Vector<double> *>(VT_T);
-  }
-  const flatbuffers::Vector<uint64_t> *tm() const {
-    return GetPointer<const flatbuffers::Vector<uint64_t> *>(VT_TM);
-  }
-  FlatGeobuf::GeometryType type() const {
-    return static_cast<FlatGeobuf::GeometryType>(GetField<uint8_t>(VT_TYPE, 0));
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>> *parts() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>> *>(VT_PARTS);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffset(verifier, VT_ENDS) &&
-           verifier.VerifyVector(ends()) &&
-           VerifyOffset(verifier, VT_XY) &&
-           verifier.VerifyVector(xy()) &&
-           VerifyOffset(verifier, VT_Z) &&
-           verifier.VerifyVector(z()) &&
-           VerifyOffset(verifier, VT_M) &&
-           verifier.VerifyVector(m()) &&
-           VerifyOffset(verifier, VT_T) &&
-           verifier.VerifyVector(t()) &&
-           VerifyOffset(verifier, VT_TM) &&
-           verifier.VerifyVector(tm()) &&
-           VerifyField<uint8_t>(verifier, VT_TYPE, 1) &&
-           VerifyOffset(verifier, VT_PARTS) &&
-           verifier.VerifyVector(parts()) &&
-           verifier.VerifyVectorOfTables(parts()) &&
-           verifier.EndTable();
-  }
-};
-
-struct GeometryBuilder {
-  typedef Geometry Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_ends(flatbuffers::Offset<flatbuffers::Vector<uint32_t>> ends) {
-    fbb_.AddOffset(Geometry::VT_ENDS, ends);
-  }
-  void add_xy(flatbuffers::Offset<flatbuffers::Vector<double>> xy) {
-    fbb_.AddOffset(Geometry::VT_XY, xy);
-  }
-  void add_z(flatbuffers::Offset<flatbuffers::Vector<double>> z) {
-    fbb_.AddOffset(Geometry::VT_Z, z);
-  }
-  void add_m(flatbuffers::Offset<flatbuffers::Vector<double>> m) {
-    fbb_.AddOffset(Geometry::VT_M, m);
-  }
-  void add_t(flatbuffers::Offset<flatbuffers::Vector<double>> t) {
-    fbb_.AddOffset(Geometry::VT_T, t);
-  }
-  void add_tm(flatbuffers::Offset<flatbuffers::Vector<uint64_t>> tm) {
-    fbb_.AddOffset(Geometry::VT_TM, tm);
-  }
-  void add_type(FlatGeobuf::GeometryType type) {
-    fbb_.AddElement<uint8_t>(Geometry::VT_TYPE, static_cast<uint8_t>(type), 0);
-  }
-  void add_parts(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>>> parts) {
-    fbb_.AddOffset(Geometry::VT_PARTS, parts);
-  }
-  explicit GeometryBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Geometry> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Geometry>(end);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Geometry> CreateGeometry(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::Vector<uint32_t>> ends = 0,
-    flatbuffers::Offset<flatbuffers::Vector<double>> xy = 0,
-    flatbuffers::Offset<flatbuffers::Vector<double>> z = 0,
-    flatbuffers::Offset<flatbuffers::Vector<double>> m = 0,
-    flatbuffers::Offset<flatbuffers::Vector<double>> t = 0,
-    flatbuffers::Offset<flatbuffers::Vector<uint64_t>> tm = 0,
-    FlatGeobuf::GeometryType type = FlatGeobuf::GeometryType::Unknown,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>>> parts = 0) {
-  GeometryBuilder builder_(_fbb);
-  builder_.add_parts(parts);
-  builder_.add_tm(tm);
-  builder_.add_t(t);
-  builder_.add_m(m);
-  builder_.add_z(z);
-  builder_.add_xy(xy);
-  builder_.add_ends(ends);
-  builder_.add_type(type);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Geometry> CreateGeometryDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const std::vector<uint32_t> *ends = nullptr,
-    const std::vector<double> *xy = nullptr,
-    const std::vector<double> *z = nullptr,
-    const std::vector<double> *m = nullptr,
-    const std::vector<double> *t = nullptr,
-    const std::vector<uint64_t> *tm = nullptr,
-    FlatGeobuf::GeometryType type = FlatGeobuf::GeometryType::Unknown,
-    const std::vector<flatbuffers::Offset<FlatGeobuf::Geometry>> *parts = nullptr) {
-  auto ends__ = ends ? _fbb.CreateVector<uint32_t>(*ends) : 0;
-  auto xy__ = xy ? _fbb.CreateVector<double>(*xy) : 0;
-  auto z__ = z ? _fbb.CreateVector<double>(*z) : 0;
-  auto m__ = m ? _fbb.CreateVector<double>(*m) : 0;
-  auto t__ = t ? _fbb.CreateVector<double>(*t) : 0;
-  auto tm__ = tm ? _fbb.CreateVector<uint64_t>(*tm) : 0;
-  auto parts__ = parts ? _fbb.CreateVector<flatbuffers::Offset<FlatGeobuf::Geometry>>(*parts) : 0;
-  return FlatGeobuf::CreateGeometry(
-      _fbb,
-      ends__,
-      xy__,
-      z__,
-      m__,
-      t__,
-      tm__,
-      type,
-      parts__);
-}
-
-struct Feature FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef FeatureBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_GEOMETRY = 4,
-    VT_PROPERTIES = 6,
-    VT_COLUMNS = 8
-  };
-  const FlatGeobuf::Geometry *geometry() const {
-    return GetPointer<const FlatGeobuf::Geometry *>(VT_GEOMETRY);
-  }
-  const flatbuffers::Vector<uint8_t> *properties() const {
-    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_PROPERTIES);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *>(VT_COLUMNS);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffset(verifier, VT_GEOMETRY) &&
-           verifier.VerifyTable(geometry()) &&
-           VerifyOffset(verifier, VT_PROPERTIES) &&
-           verifier.VerifyVector(properties()) &&
-           VerifyOffset(verifier, VT_COLUMNS) &&
-           verifier.VerifyVector(columns()) &&
-           verifier.VerifyVectorOfTables(columns()) &&
-           verifier.EndTable();
-  }
-};
-
-struct FeatureBuilder {
-  typedef Feature Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_geometry(flatbuffers::Offset<FlatGeobuf::Geometry> geometry) {
-    fbb_.AddOffset(Feature::VT_GEOMETRY, geometry);
-  }
-  void add_properties(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> properties) {
-    fbb_.AddOffset(Feature::VT_PROPERTIES, properties);
-  }
-  void add_columns(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns) {
-    fbb_.AddOffset(Feature::VT_COLUMNS, columns);
-  }
-  explicit FeatureBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Feature> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Feature>(end);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Feature> CreateFeature(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<FlatGeobuf::Geometry> geometry = 0,
-    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> properties = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns = 0) {
-  FeatureBuilder builder_(_fbb);
-  builder_.add_columns(columns);
-  builder_.add_properties(properties);
-  builder_.add_geometry(geometry);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Feature> CreateFeatureDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<FlatGeobuf::Geometry> geometry = 0,
-    const std::vector<uint8_t> *properties = nullptr,
-    const std::vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns = nullptr) {
-  auto properties__ = properties ? _fbb.CreateVector<uint8_t>(*properties) : 0;
-  auto columns__ = columns ? _fbb.CreateVector<flatbuffers::Offset<FlatGeobuf::Column>>(*columns) : 0;
-  return FlatGeobuf::CreateFeature(
-      _fbb,
-      geometry,
-      properties__,
-      columns__);
-}
-
-inline const FlatGeobuf::Feature *GetFeature(const void *buf) {
-  return flatbuffers::GetRoot<FlatGeobuf::Feature>(buf);
-}
-
-inline const FlatGeobuf::Feature *GetSizePrefixedFeature(const void *buf) {
-  return flatbuffers::GetSizePrefixedRoot<FlatGeobuf::Feature>(buf);
-}
-
-inline bool VerifyFeatureBuffer(
-    flatbuffers::Verifier &verifier) {
-  return verifier.VerifyBuffer<FlatGeobuf::Feature>(nullptr);
-}
-
-inline bool VerifySizePrefixedFeatureBuffer(
-    flatbuffers::Verifier &verifier) {
-  return verifier.VerifySizePrefixedBuffer<FlatGeobuf::Feature>(nullptr);
-}
-
-inline void FinishFeatureBuffer(
-    flatbuffers::FlatBufferBuilder &fbb,
-    flatbuffers::Offset<FlatGeobuf::Feature> root) {
-  fbb.Finish(root);
-}
-
-inline void FinishSizePrefixedFeatureBuffer(
-    flatbuffers::FlatBufferBuilder &fbb,
-    flatbuffers::Offset<FlatGeobuf::Feature> root) {
-  fbb.FinishSizePrefixed(root);
-}
-
-}  // namespace FlatGeobuf
-}
-
-#endif  // FLATBUFFERS_GENERATED_FEATURE_FLATGEOBUF_H_
diff -pruN 8.0.1-5/flatgeobuf/flatgeobuf_c.cpp 8.2.0~beta1-1~exp1/flatgeobuf/flatgeobuf_c.cpp
--- 8.0.1-5/flatgeobuf/flatgeobuf_c.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/flatgeobuf_c.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,399 +0,0 @@
-#include "flatgeobuf_c.h"
-
-#include "feature_generated.h"
-#include "geometryreader.h"
-#include "packedrtree.h"
-#include <stdexcept>
-
-using namespace mapserver::flatbuffers;
-using namespace mapserver::FlatGeobuf;
-
-typedef flatgeobuf_ctx ctx;
-
-uint8_t flatgeobuf_magicbytes[] = { 0x66, 0x67, 0x62, 0x03, 0x66, 0x67, 0x62, 0x01 };
-uint8_t FLATGEOBUF_MAGICBYTES_SIZE = sizeof(flatgeobuf_magicbytes);
-uint32_t INIT_BUFFER_SIZE = 1024 * 4;
-
-template <typename T>
-void parse_value(uint8_t *data, char **values, uint16_t i, uint32_t &offset, bool found)
-{
-    using std::to_string;
-    if (found)
-    {
-        msFree(values[i]);
-        values[i] = msStrdup(to_string(*((T*) (data + offset))).c_str());
-    }
-    offset += sizeof(T);
-}
-
-ctx *flatgeobuf_init_ctx()
-{
-    ctx *c = (ctx *) malloc(sizeof(ctx));
-    memset(c, 0, sizeof(ctx));
-    c->is_null_geom = false;
-    c->done = false;
-    return c;
-}
-
-void flatgeobuf_free_ctx(ctx *ctx)
-{
-    if (ctx->columns) {
-        for (uint32_t i = 0; i < ctx->columns_len; i++)
-            free(ctx->columns[i].name);
-        free(ctx->columns);
-    }
-    if (ctx->search_result)
-        free(ctx->search_result);
-    if (ctx->buf)
-        free(ctx->buf);
-    if (ctx->wkt)
-        free(ctx->wkt);
-    free(ctx);
-}
-
-void flatgeobuf_ensure_line(ctx *ctx, uint32_t len)
-{
-    if (!ctx->line) {
-        ctx->line_len = len;
-        ctx->line = (lineObj *) malloc(ctx->line_len * sizeof(lineObj));
-        return;
-    }
-    if (ctx->line_len < len) {
-        ctx->line_len = len;
-        ctx->line = (lineObj *) realloc(ctx->buf, ctx->line_len * sizeof(lineObj));
-    }
-}
-
-void flatgeobuf_ensure_point(ctx *ctx, uint32_t len)
-{
-    if (!ctx->point) {
-        ctx->point_len = len;
-        ctx->point = (pointObj *) malloc(ctx->point_len * sizeof(pointObj));
-        return;
-    }
-    if (ctx->point_len < len) {
-        ctx->point_len = len;
-        ctx->point = (pointObj *) realloc(ctx->buf, ctx->point_len * sizeof(pointObj));
-    }
-}
-
-int flatgeobuf_ensure_buf(ctx *ctx, uint32_t size)
-{
-    if (size > 100 * 1024 * 1024) {
-        msSetError(MS_FGBERR, "Invalid buffer size requested", "flatgeobuf_ensure_buf");
-        return -1;
-    }
-    if (!ctx->buf) {
-        ctx->buf_size = std::max(INIT_BUFFER_SIZE, size);
-        ctx->buf = (uint8_t *) malloc(ctx->buf_size);
-        if (ctx->buf == NULL) {
-            msSetError(MS_FGBERR, "Failed to allocate buffer", "flatgeobuf_ensure_buf");
-            return -1;
-        }
-        return 0;
-    }
-    if (ctx->buf_size < size) {
-        ctx->buf_size = std::max(ctx->buf_size * 2, size);
-        auto buf = (uint8_t *) realloc(ctx->buf, ctx->buf_size);
-        if (buf == NULL) {
-            msSetError(MS_FGBERR, "Failed to reallocate buffer", "flatgeobuf_ensure_buf");
-            return -1;
-        }
-        ctx->buf = buf;
-    }
-    return 0;
-}
-
-int flatgeobuf_decode_feature(ctx *ctx, layerObj *layer, shapeObj *shape)
-{
-    ctx->is_null_geom = false;
-
-    uint32_t featureSize;
-    if (VSIFReadL(&featureSize, sizeof(featureSize), 1, ctx->file) != 1) {
-        if (VSIFEofL(ctx->file)) {
-            ctx->done = true;
-            return 0;
-        }
-        return -1;
-    }
-
-    ctx->offset += sizeof(uoffset_t);
-    if (flatgeobuf_ensure_buf(ctx, featureSize) != 0) {
-        return -1;
-    }
-
-    if (VSIFReadL(ctx->buf, 1, featureSize, ctx->file) != featureSize) {
-        msSetError(MS_FGBERR, "Failed to read feature", "flatgeobuf_decode_feature");
-        return -1;
-    }
-    ctx->offset += featureSize;
-    auto feature = GetFeature(ctx->buf);
-    const auto geometry = feature->geometry();
-    if (geometry) {
-        GeometryReader(ctx, geometry).read(shape);
-    } else {
-        ctx->is_null_geom = true;
-        return 0;
-    }
-    auto properties = feature->properties();
-    if (properties && properties->size() != 0) {
-        ctx->properties = (uint8_t *) properties->data();
-        ctx->properties_size = properties->size();
-        flatgeobuf_decode_properties(ctx, layer, shape);
-    } else {
-        ctx->properties_size = 0;
-    }
-
-    return 0;
-}
-
-int flatgeobuf_decode_properties(ctx *ctx, layerObj *layer, shapeObj *shape)
-{
-	uint8_t type;
-	uint32_t offset = 0;
-	uint8_t *data = ctx->properties;
-	uint32_t size = ctx->properties_size;
-    uint16_t numvalues = layer->numitems;
-    bool found;
-    char **values;
-
-    if (numvalues == 0)
-        return 0;
-
-    values = (char **) msSmallCalloc(sizeof(char *), numvalues);
-    if (shape->values) msFreeCharArray(shape->values, shape->numvalues);
-    shape->numvalues = numvalues;
-    shape->values = values;
-
-    if (size > 0 && size < (sizeof(uint16_t) + sizeof(uint8_t))) {
-        msSetError(MS_FGBERR, "Unexpected properties data size", "flatgeobuf_decode_properties");
-        return -1;
-    }
-	while (offset + 1 < size) {
-        uint16_t i;
-        memcpy(&i, data + offset, sizeof(uint16_t));
-		offset += sizeof(uint16_t);
-		if (i >= ctx->columns_len) {
-            msSetError(MS_FGBERR, "Column index out of range", "flatgeobuf_decode_properties");
-            return -1;
-        }
-		const auto& column = ctx->columns[i];
-        const int32_t ii = column.itemindex;
-        found = ii != -1;
-		type = column.type;
-		switch (type) {
-		case flatgeobuf_column_type_bool:
-            parse_value<uint8_t>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_byte:
-            parse_value<int8_t>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_ubyte:
-            parse_value<uint8_t>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_short:
-			parse_value<int16_t>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_ushort:
-            parse_value<uint16_t>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_int:
-            parse_value<int32_t>(data, values, ii, offset, found);
-            break;
-		case flatgeobuf_column_type_uint:
-			parse_value<uint32_t>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_long:
-            parse_value<int64_t>(data, values, ii, offset, found);
-            break;
-		case flatgeobuf_column_type_ulong:
-			parse_value<uint64_t>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_float:
-            parse_value<float>(data, values, ii, offset, found);
-			break;
-		case flatgeobuf_column_type_double:
-			parse_value<double>(data, values, ii, offset, found);
-			break;
-        case flatgeobuf_column_type_datetime:
-		case flatgeobuf_column_type_string: {
-			uint32_t len;
-			if (offset + sizeof(len) > size){
-                msSetError(MS_FGBERR, "Invalid size for string value", "flatgeobuf_decode_properties");
-                return -1;
-            }
-			memcpy(&len, data + offset, sizeof(uint32_t));
-			offset += sizeof(len);
-			if (found) {
-                char *str = (char *) msSmallMalloc(len + 1);
-                memcpy(str, data + offset, len);
-                str[len] = '\0';
-                msFree(values[ii]);
-                values[ii] = str;
-            }
-			offset += len;
-			break;
-		}
-        }
-    }
-
-    for(int i = 0; i < shape->numvalues; i++)
-    {
-        if( shape->values[i] == NULL)
-            shape->values[i] = msStrdup("");
-    }
-
-    return 0;
-}
-
-int flatgeobuf_check_magicbytes(ctx *ctx)
-{
-    if (ctx->offset != 0) {
-        msSetError(MS_FGBERR, "Unexpected offset", "flatgeobuf_check_magicbytes");
-        return -1;
-    }
-    if (flatgeobuf_ensure_buf(ctx, FLATGEOBUF_MAGICBYTES_SIZE) != 0)
-        return -1;
-    if (VSIFReadL(ctx->buf, 8, 1, ctx->file) != 1) {
-        msSetError(MS_FGBERR, "Failed to read magicbytes", "flatgeobuf_check_magicbytes");
-        return -1;
-    }
-	uint32_t i;
-	for (i = 0; i < FLATGEOBUF_MAGICBYTES_SIZE / 2; i++) {
-        if (ctx->buf[i] != flatgeobuf_magicbytes[i]) {
-            msSetError(MS_FGBERR, "Data is not FlatGeobuf", "flatgeobuf_check_magicbytes");
-            return -1;
-        }
-    }
-	ctx->offset += FLATGEOBUF_MAGICBYTES_SIZE;
-    return 0;
-}
-
-int flatgeobuf_decode_header(ctx *ctx)
-{
-    if (ctx->offset != FLATGEOBUF_MAGICBYTES_SIZE) {
-        msSetError(MS_FGBERR, "Unexpected offset", "flatgeobuf_decode_header");
-        return -1;
-    }
-    if (VSIFSeekL(ctx->file, ctx->offset, SEEK_SET) == -1) {
-        msSetError(MS_FGBERR, "Unable to get seek in file", "flatgeobuf_decode_header");
-        return -1;
-    }
-    uint32_t headerSize;
-    if (VSIFReadL(&headerSize, 4, 1, ctx->file) != 1) {
-        msSetError(MS_FGBERR, "Failed to read header size", "flatgeobuf_decode_header");
-        return -1;
-    }
-    ctx->offset += sizeof(uoffset_t);
-    if (flatgeobuf_ensure_buf(ctx, headerSize) != 0) {
-        return -1;
-    }
-    if (VSIFReadL(ctx->buf, 1, headerSize, ctx->file) != headerSize) {
-        msSetError(MS_FGBERR, "Failed to read header", "flatgeobuf_decode_header");
-        return -1;
-    }
-    auto header = GetHeader(ctx->buf);
-	ctx->offset += headerSize;
-
-	ctx->geometry_type = (uint8_t) header->geometry_type();
-    ctx->features_count = header->features_count();
-    auto envelope = header->envelope();
-    if (envelope != nullptr) {
-        ctx->has_extent = true;
-        ctx->xmin = envelope->Get(0);
-        ctx->ymin = envelope->Get(1);
-        ctx->xmax = envelope->Get(2);
-        ctx->ymax = envelope->Get(3);
-        ctx->bounds.minx = ctx->xmin;
-        ctx->bounds.miny = ctx->ymin;
-        ctx->bounds.maxx = ctx->xmax;
-        ctx->bounds.maxy = ctx->ymax;
-    }
-	ctx->has_z = header->has_z();
-    ctx->has_m = header->has_m();
-    ctx->has_t = header->has_t();
-    ctx->has_tm = header->has_tm();
-    ctx->index_node_size = header->index_node_size();
-    auto crs = header->crs();
-    if (crs != nullptr) {
-        ctx->srid = crs->code();
-        auto wkt = crs->wkt();
-        if (wkt != nullptr)
-            ctx->wkt = msStrdup(wkt->c_str());
-    }
-    auto columns = header->columns();
-    if (columns != nullptr) {
-        auto size = columns->size();
-        ctx->columns = (flatgeobuf_column *) malloc(size * sizeof(flatgeobuf_column));
-        memset(ctx->columns, 0, size * sizeof(flatgeobuf_column));
-        ctx->columns_len = size;
-        for (uint32_t i = 0; i < size; i++) {
-            auto column = columns->Get(i);
-            ctx->columns[i].name = msStrdup(column->name()->c_str());
-            ctx->columns[i].type = (uint8_t) column->type();
-            ctx->columns[i].itemindex = -1;
-        }
-    }
-
-    ctx->index_offset = ctx->offset;
-    ctx->feature_offset = ctx->offset;
-    if ( ctx->index_node_size > 0)
-        ctx->feature_offset += PackedRTree::size(ctx->features_count, ctx->index_node_size);
-
-    return 0;
-}
-
-int flatgeobuf_index_search(ctx *ctx, rectObj *rect)
-{
-    const auto treeOffset = ctx->offset;
-    const auto readNode = [treeOffset, ctx] (uint8_t *buf, size_t i, size_t s) {
-        if (VSIFSeekL(ctx->file, treeOffset + i, SEEK_SET) == -1)
-            throw std::runtime_error("Unable to seek in file");
-        if (VSIFReadL(buf, 1, s, ctx->file) != s)
-            throw std::runtime_error("Unable to read file");
-    };
-    NodeItem n { rect->minx, rect->miny, rect->maxx, rect->maxy, 0 };
-    try {
-        const auto foundItems = PackedRTree::streamSearch(ctx->features_count, ctx->index_node_size, n, readNode);
-        ctx->search_result = (flatgeobuf_search_item *) malloc(foundItems.size() * sizeof(flatgeobuf_search_item));
-        memcpy(ctx->search_result, foundItems.data(), foundItems.size() * sizeof(flatgeobuf_search_item));
-        ctx->search_result_len = (uint32_t) foundItems.size();
-    } catch (const std::exception &e) {
-        msSetError(MS_FGBERR, "Unable to seek or read file", "flatgeobuf_index_search");
-        return -1;
-    }
-    return 0;
-}
-
-int flatgeobuf_index_skip(ctx *ctx)
-{
-    auto treeSize = PackedRTree::size(ctx->features_count, ctx->index_node_size);
-    ctx->offset += treeSize;
-    if (VSIFSeekL(ctx->file, ctx->offset, SEEK_SET) == -1) {
-        msSetError(MS_FGBERR, "Unable to seek in file", "flatgeobuf_index_skip");
-        return -1;
-    }
-    return 0;
-}
-
-int flatgeobuf_read_feature_offset(ctx *ctx, uint64_t index, uint64_t *featureOffset)
-{
-    try {
-        const auto levelBounds = PackedRTree::generateLevelBounds(ctx->features_count, ctx->index_node_size);
-        const auto bottomLevelOffset = ctx->index_offset + (levelBounds.front().first * sizeof(NodeItem));
-        const auto nodeItemOffset = bottomLevelOffset + (index * sizeof(NodeItem));
-        const auto featureOffsetOffset = nodeItemOffset + (sizeof(double) * 4);
-        if (VSIFSeekL(ctx->file, featureOffsetOffset, SEEK_SET) == -1) {
-            msSetError(MS_FGBERR, "Failed to seek feature offset", "flatgeobuf_read_feature_offset");
-            return -1;
-        }
-        if (VSIFReadL(featureOffset, sizeof(uint64_t), 1, ctx->file) != 1) {
-            msSetError(MS_FGBERR, "Failed to read feature offset", "flatgeobuf_read_feature_offset");
-            return -1;
-        }
-        return 0;
-    } catch (const std::exception& e) {
-        msSetError(MS_FGBERR, "Failed to calculate tree size", "flatgeobuf_read_feature_offset");
-        return -1;
-    }
-}
diff -pruN 8.0.1-5/flatgeobuf/flatgeobuf_c.h 8.2.0~beta1-1~exp1/flatgeobuf/flatgeobuf_c.h
--- 8.0.1-5/flatgeobuf/flatgeobuf_c.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/flatgeobuf_c.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,136 +0,0 @@
-#ifndef FLATGEOBUF_C_H
-#define FLATGEOBUF_C_H
-
-#include "../../mapserver.h"
-#include "../../maperror.h"
-#include "../../mapprimitive.h"
-#include <stdbool.h>
-#include <stdint.h>
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-extern uint8_t flatgeobuf_magicbytes[];
-extern uint8_t FLATGEOBUF_MAGICBYTES_SIZE;
-
-// need c compatible variant of this enum
-#define flatgeobuf_column_type_byte UINT8_C(0)
-#define flatgeobuf_column_type_ubyte UINT8_C(1)
-#define flatgeobuf_column_type_bool UINT8_C(2)
-#define flatgeobuf_column_type_short UINT8_C(3)
-#define flatgeobuf_column_type_ushort UINT8_C(4)
-#define flatgeobuf_column_type_int UINT8_C(5)
-#define flatgeobuf_column_type_uint UINT8_C(6)
-#define flatgeobuf_column_type_long UINT8_C(7)
-#define flatgeobuf_column_type_ulong UINT8_C(8)
-#define flatgeobuf_column_type_float UINT8_C(9)
-#define flatgeobuf_column_type_double UINT8_C(10)
-#define flatgeobuf_column_type_string UINT8_C(11)
-#define flatgeobuf_column_type_json UINT8_C(12)
-#define flatgeobuf_column_type_datetime UINT8_C(13)
-#define flatgeobuf_column_type_binary UINT8_C(14)
-
-typedef struct flatgeobuf_column
-{
-	char *name;
-	uint8_t type;
-	const char *title;
-	const char *description;
-	uint32_t width;
-	uint32_t precision;
-	uint32_t scale;
-	bool nullable;
-	bool unique;
-	bool primary_key;
-	const char * metadata;
-	int32_t itemindex;
-} flatgeobuf_column;
-
-typedef struct flatgeobuf_item
-{
-	double xmin;
-	double xmax;
-	double ymin;
-	double ymax;
-	uint32_t size;
-	uint64_t offset;
-} flatgeobuf_item;
-
-typedef struct flatgeobuf_search_item {
-    uint64_t offset;
-    uint64_t index;
-} flatgeobuf_search_item;
-
-typedef struct flatgeobuf_ctx
-{
-	VSILFILE *file;
-	uint64_t index_offset;
-	uint64_t feature_offset;
-	uint64_t offset;
-	uint8_t *buf;
-	uint32_t buf_size;
-	bool done;
-
-    // header contents
-	const char *name;
-	uint64_t features_count;
-	uint8_t geometry_type;
-	bool has_extent;
-	double xmin;
-	double xmax;
-	double ymin;
-	double ymax;
-	bool has_z;
-	bool has_m;
-	bool has_t;
-	bool has_tm;
-	uint16_t index_node_size;
-	int32_t srid;
-	char *wkt;
-	flatgeobuf_column *columns;
-	uint16_t columns_len;
-
-	// mapserver structs
-	rectObj bounds;
-
-	// index search result
-	flatgeobuf_search_item *search_result;
-	uint32_t search_result_len;
-	uint32_t search_index;
-
-	// shape parts buffers
-	// NOTE: not used at this time, need to introduce optional free in mapdraw
-	lineObj *line;
-	uint32_t line_len;
-	pointObj *point;
-	uint32_t point_len;
-
-	bool is_null_geom;
-	uint64_t feature_index;
-	int ms_type;
-    uint8_t *properties;
-	uint32_t properties_size;
-} flatgeobuf_ctx;
-
-flatgeobuf_ctx *flatgeobuf_init_ctx();
-void flatgeobuf_free_ctx(flatgeobuf_ctx *ctx);
-
-int flatgeobuf_ensure_buf(flatgeobuf_ctx *ctx, uint32_t size);
-void flatgeobuf_ensure_line(flatgeobuf_ctx *ctx, uint32_t len);
-void flatgeobuf_ensure_point(flatgeobuf_ctx *ctx, uint32_t len);
-
-int flatgeobuf_check_magicbytes(flatgeobuf_ctx *ctx);
-int flatgeobuf_decode_header(flatgeobuf_ctx *ctx);
-int flatgeobuf_decode_feature(flatgeobuf_ctx *ctx, layerObj *layer, shapeObj *shape);
-int flatgeobuf_decode_properties(flatgeobuf_ctx *ctx, layerObj *layer, shapeObj *shape);
-
-int flatgeobuf_index_search(flatgeobuf_ctx *ctx, rectObj *rect);
-int flatgeobuf_index_skip(flatgeobuf_ctx *ctx);
-int flatgeobuf_read_feature_offset(flatgeobuf_ctx *ctx, uint64_t index, uint64_t *featureOffset);
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* FLATGEOBUF_C_H */
diff -pruN 8.0.1-5/flatgeobuf/geometryreader.cpp 8.2.0~beta1-1~exp1/flatgeobuf/geometryreader.cpp
--- 8.0.1-5/flatgeobuf/geometryreader.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/geometryreader.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,150 +0,0 @@
-#include "geometryreader.h"
-
-using namespace mapserver::flatbuffers;
-using namespace mapserver::FlatGeobuf;
-
-void GeometryReader::readPoint(shapeObj *shape)
-{
-    lineObj *l = (lineObj *) malloc(sizeof(lineObj));
-    pointObj *p = (pointObj *) malloc(sizeof(pointObj));
-
-	p->x = m_xy[m_offset + 0];
-	p->y = m_xy[m_offset + 1];
-    if (m_has_z)
-        p->z = m_geometry->z()->data()[m_offset];
-    if (m_has_m)
-        p->m = m_geometry->m()->data()[m_offset];
-
-    l[0].numpoints = 1;
-    l[0].point = p;
-    shape->numlines = 1;
-    shape->line = l;
-    shape->type = MS_SHAPE_POINT;
-}
-
-void GeometryReader::readLineObj(lineObj *line)
-{
-    const double *z = m_has_z ? m_geometry->z()->data() : nullptr;
-    const double *m = m_has_m ? m_geometry->m()->data() : nullptr;
-
-    line->point = (pointObj *) malloc(m_length * sizeof(pointObj));
-    line->numpoints = m_length;
-
-    for (uint32_t i = m_offset; i < m_offset + m_length; i++) {
-        pointObj *point = &line->point[i - m_offset];
-        memcpy(point, &m_xy[i * 2], 2 * sizeof(double));
-        if (m_has_z)
-            point->z = z[i];
-        if (m_has_m)
-            point->m = m[i];
-    }
-}
-
-void GeometryReader::readMultiPoint(shapeObj *shape)
-{
-    readLineString(shape);
-    shape->type = MS_SHAPE_POINT;
-}
-
-void GeometryReader::readLineString(shapeObj *shape)
-{
-    lineObj *line = (lineObj *) malloc(sizeof(lineObj));
-    readLineObj(line);
-    shape->numlines = 1;
-    shape->line = line;
-    shape->type = MS_SHAPE_LINE;
-}
-
-void GeometryReader::readMultiLineString(shapeObj *shape)
-{
-    readPolygon(shape);
-    shape->type = MS_SHAPE_LINE;
-}
-
-void GeometryReader::readPolygon(shapeObj *shape)
-{
-    const auto ends = m_geometry->ends();
-
-    uint32_t nrings = 1;
-    if (ends != nullptr && ends->size() > 1)
-        nrings = ends->size();
-
-    lineObj *line = (lineObj *) malloc(nrings * sizeof(lineObj));
-    if (nrings > 1) {
-        for (uint32_t i = 0; i < nrings; i++) {
-            const auto e = ends->Get(i);
-            m_length = e - m_offset;
-            readLineObj(&line[i]);
-            m_offset = e;
-        }
-    } else {
-        readLineObj(line);
-    }
-    shape->numlines = nrings;
-    shape->line = line;
-    shape->type = MS_SHAPE_POLYGON;
-}
-
-void GeometryReader::readMultiPolygon(shapeObj *shape)
-{
-    const auto parts = m_geometry->parts();
-    lineObj *line = (lineObj *) nullptr;
-    auto numlines = 0;
-    for (size_t i = 0; i < parts->size(); i++) {
-        GeometryReader(m_ctx, parts->Get(i), GeometryType::Polygon).read(shape);
-        lineObj *tmp = line;
-        line = (lineObj *) realloc(line, (numlines + shape->numlines) * sizeof(lineObj));
-        if (!line) {
-            free(tmp);
-            free(shape->line);
-            break;
-        }
-        for (int j = 0; j < shape->numlines; j++)
-            line[numlines + j] = shape->line[j];
-        numlines += shape->numlines;
-        free(shape->line);
-    }
-    shape->line = line;
-    shape->numlines = numlines;
-}
-
-/*void GeometryReader::readGeometryCollection(shapeObj *shape)
-{
-    // TODO
-    return;
-}*/
-
-void GeometryReader::read(shapeObj *shape)
-{
-    // nested types
-    switch (m_geometry_type) {
-        //case GeometryType::GeometryCollection: return readGeometryCollection(shape);
-        case GeometryType::MultiPolygon: return readMultiPolygon(shape);
-        /*case GeometryType::CompoundCurve: return readCompoundCurve();
-        case GeometryType::CurvePolygon: return readCurvePolygon();
-        case GeometryType::MultiCurve: return readMultiCurve();
-        case GeometryType::MultiSurface: return readMultiSurface();
-        case GeometryType::PolyhedralSurface: return readPolyhedralSurface();*/
-        default: break;
-    }
-
-    // if not nested must have geometry data
-    const auto pXy = m_geometry->xy();
-    const auto xySize = pXy->size();
-    m_xy = pXy->data();
-    m_length = xySize / 2;
-
-    switch (m_geometry_type) {
-        case GeometryType::Point: return readPoint(shape);
-        case GeometryType::MultiPoint: return readMultiPoint(shape);
-        case GeometryType::LineString: return readLineString(shape);
-        case GeometryType::MultiLineString: return readMultiLineString(shape);
-        case GeometryType::Polygon: return readPolygon(shape);
-        /*
-        case GeometryType::CircularString: return readSimpleCurve<OGRCircularString>(true);
-        case GeometryType::Triangle: return readTriangle();
-        case GeometryType::TIN: return readTIN();
-        */
-        default: break;
-    }
-}
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/geometryreader.h 8.2.0~beta1-1~exp1/flatgeobuf/geometryreader.h
--- 8.0.1-5/flatgeobuf/geometryreader.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/geometryreader.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,63 +0,0 @@
-#ifndef FLATGEOBUF_GEOMETRYREADER_H
-#define FLATGEOBUF_GEOMETRYREADER_H
-
-#include "../../mapserver.h"
-#include "../../maperror.h"
-#include "../../mapprimitive.h"
-
-#include "flatgeobuf_c.h"
-#include "feature_generated.h"
-
-namespace mapserver {
-namespace FlatGeobuf {
-
-class GeometryReader {
-    private:
-        flatgeobuf_ctx *m_ctx;
-        const FlatGeobuf::Geometry *m_geometry;
-        FlatGeobuf::GeometryType m_geometry_type;
-        bool m_has_z;
-        bool m_has_m;
-
-        const double *m_xy = nullptr;
-        uint32_t m_length = 0;
-        uint32_t m_offset = 0;
-
-        void readPoint(shapeObj *);
-        void readMultiPoint(shapeObj *);
-        void readLineString(shapeObj *);
-        void readMultiLineString(shapeObj *);
-        void readPolygon(shapeObj *);
-        void readMultiPolygon(shapeObj *);
-        //void readGeometryCollection(shapeObj *);
-
-        void readLineObj(lineObj *line);
-
-    public:
-        GeometryReader(
-            flatgeobuf_ctx *ctx,
-            const FlatGeobuf::Geometry *geometry) :
-            m_ctx (ctx),
-            m_geometry (geometry),
-            m_geometry_type ((FlatGeobuf::GeometryType) ctx->geometry_type),
-            m_has_z (ctx->has_z),
-            m_has_m (ctx->has_m)
-            { }
-        GeometryReader(
-            flatgeobuf_ctx *ctx,
-            const FlatGeobuf::Geometry *geometry,
-            const FlatGeobuf::GeometryType geometry_type) :
-            m_ctx (ctx),
-            m_geometry (geometry),
-            m_geometry_type (geometry_type),
-            m_has_z (ctx->has_z),
-            m_has_m (ctx->has_m)
-            { }
-        void read(shapeObj *);
-};
-
-}
-}
-
-
-#endif /* FLATGEOBUF_GEOMETRYREADER_H */
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/header_generated.h 8.2.0~beta1-1~exp1/flatgeobuf/header_generated.h
--- 8.0.1-5/flatgeobuf/header_generated.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/header_generated.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,724 +0,0 @@
-// automatically generated by the FlatBuffers compiler, do not modify
-
-
-#ifndef FLATBUFFERS_GENERATED_HEADER_FLATGEOBUF_H_
-#define FLATBUFFERS_GENERATED_HEADER_FLATGEOBUF_H_
-
-#include "flatbuffers/flatbuffers.h"
-
-// Ensure the included flatbuffers.h is the same version as when this file was
-// generated, otherwise it may not be compatible.
-static_assert(FLATBUFFERS_VERSION_MAJOR == 2 &&
-              FLATBUFFERS_VERSION_MINOR == 0 &&
-              FLATBUFFERS_VERSION_REVISION == 6,
-             "Non-compatible flatbuffers version included");
-
-namespace mapserver {
-namespace FlatGeobuf {
-
-struct Column;
-struct ColumnBuilder;
-
-struct Crs;
-struct CrsBuilder;
-
-struct Header;
-struct HeaderBuilder;
-
-enum class GeometryType : uint8_t {
-  Unknown = 0,
-  Point = 1,
-  LineString = 2,
-  Polygon = 3,
-  MultiPoint = 4,
-  MultiLineString = 5,
-  MultiPolygon = 6,
-  GeometryCollection = 7,
-  CircularString = 8,
-  CompoundCurve = 9,
-  CurvePolygon = 10,
-  MultiCurve = 11,
-  MultiSurface = 12,
-  Curve = 13,
-  Surface = 14,
-  PolyhedralSurface = 15,
-  TIN = 16,
-  Triangle = 17,
-  MIN = Unknown,
-  MAX = Triangle
-};
-
-inline const GeometryType (&EnumValuesGeometryType())[18] {
-  static const GeometryType values[] = {
-    GeometryType::Unknown,
-    GeometryType::Point,
-    GeometryType::LineString,
-    GeometryType::Polygon,
-    GeometryType::MultiPoint,
-    GeometryType::MultiLineString,
-    GeometryType::MultiPolygon,
-    GeometryType::GeometryCollection,
-    GeometryType::CircularString,
-    GeometryType::CompoundCurve,
-    GeometryType::CurvePolygon,
-    GeometryType::MultiCurve,
-    GeometryType::MultiSurface,
-    GeometryType::Curve,
-    GeometryType::Surface,
-    GeometryType::PolyhedralSurface,
-    GeometryType::TIN,
-    GeometryType::Triangle
-  };
-  return values;
-}
-
-inline const char * const *EnumNamesGeometryType() {
-  static const char * const names[19] = {
-    "Unknown",
-    "Point",
-    "LineString",
-    "Polygon",
-    "MultiPoint",
-    "MultiLineString",
-    "MultiPolygon",
-    "GeometryCollection",
-    "CircularString",
-    "CompoundCurve",
-    "CurvePolygon",
-    "MultiCurve",
-    "MultiSurface",
-    "Curve",
-    "Surface",
-    "PolyhedralSurface",
-    "TIN",
-    "Triangle",
-    nullptr
-  };
-  return names;
-}
-
-inline const char *EnumNameGeometryType(GeometryType e) {
-  if (flatbuffers::IsOutRange(e, GeometryType::Unknown, GeometryType::Triangle)) return "";
-  const size_t index = static_cast<size_t>(e);
-  return EnumNamesGeometryType()[index];
-}
-
-enum class ColumnType : uint8_t {
-  Byte = 0,
-  UByte = 1,
-  Bool = 2,
-  Short = 3,
-  UShort = 4,
-  Int = 5,
-  UInt = 6,
-  Long = 7,
-  ULong = 8,
-  Float = 9,
-  Double = 10,
-  String = 11,
-  Json = 12,
-  DateTime = 13,
-  Binary = 14,
-  MIN = Byte,
-  MAX = Binary
-};
-
-inline const ColumnType (&EnumValuesColumnType())[15] {
-  static const ColumnType values[] = {
-    ColumnType::Byte,
-    ColumnType::UByte,
-    ColumnType::Bool,
-    ColumnType::Short,
-    ColumnType::UShort,
-    ColumnType::Int,
-    ColumnType::UInt,
-    ColumnType::Long,
-    ColumnType::ULong,
-    ColumnType::Float,
-    ColumnType::Double,
-    ColumnType::String,
-    ColumnType::Json,
-    ColumnType::DateTime,
-    ColumnType::Binary
-  };
-  return values;
-}
-
-inline const char * const *EnumNamesColumnType() {
-  static const char * const names[16] = {
-    "Byte",
-    "UByte",
-    "Bool",
-    "Short",
-    "UShort",
-    "Int",
-    "UInt",
-    "Long",
-    "ULong",
-    "Float",
-    "Double",
-    "String",
-    "Json",
-    "DateTime",
-    "Binary",
-    nullptr
-  };
-  return names;
-}
-
-inline const char *EnumNameColumnType(ColumnType e) {
-  if (flatbuffers::IsOutRange(e, ColumnType::Byte, ColumnType::Binary)) return "";
-  const size_t index = static_cast<size_t>(e);
-  return EnumNamesColumnType()[index];
-}
-
-struct Column FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef ColumnBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_TYPE = 6,
-    VT_TITLE = 8,
-    VT_DESCRIPTION = 10,
-    VT_WIDTH = 12,
-    VT_PRECISION = 14,
-    VT_SCALE = 16,
-    VT_NULLABLE = 18,
-    VT_UNIQUE = 20,
-    VT_PRIMARY_KEY = 22,
-    VT_METADATA = 24
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  FlatGeobuf::ColumnType type() const {
-    return static_cast<FlatGeobuf::ColumnType>(GetField<uint8_t>(VT_TYPE, 0));
-  }
-  const flatbuffers::String *title() const {
-    return GetPointer<const flatbuffers::String *>(VT_TITLE);
-  }
-  const flatbuffers::String *description() const {
-    return GetPointer<const flatbuffers::String *>(VT_DESCRIPTION);
-  }
-  int32_t width() const {
-    return GetField<int32_t>(VT_WIDTH, -1);
-  }
-  int32_t precision() const {
-    return GetField<int32_t>(VT_PRECISION, -1);
-  }
-  int32_t scale() const {
-    return GetField<int32_t>(VT_SCALE, -1);
-  }
-  bool nullable() const {
-    return GetField<uint8_t>(VT_NULLABLE, 1) != 0;
-  }
-  bool unique() const {
-    return GetField<uint8_t>(VT_UNIQUE, 0) != 0;
-  }
-  bool primary_key() const {
-    return GetField<uint8_t>(VT_PRIMARY_KEY, 0) != 0;
-  }
-  const flatbuffers::String *metadata() const {
-    return GetPointer<const flatbuffers::String *>(VT_METADATA);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyField<uint8_t>(verifier, VT_TYPE, 1) &&
-           VerifyOffset(verifier, VT_TITLE) &&
-           verifier.VerifyString(title()) &&
-           VerifyOffset(verifier, VT_DESCRIPTION) &&
-           verifier.VerifyString(description()) &&
-           VerifyField<int32_t>(verifier, VT_WIDTH, 4) &&
-           VerifyField<int32_t>(verifier, VT_PRECISION, 4) &&
-           VerifyField<int32_t>(verifier, VT_SCALE, 4) &&
-           VerifyField<uint8_t>(verifier, VT_NULLABLE, 1) &&
-           VerifyField<uint8_t>(verifier, VT_UNIQUE, 1) &&
-           VerifyField<uint8_t>(verifier, VT_PRIMARY_KEY, 1) &&
-           VerifyOffset(verifier, VT_METADATA) &&
-           verifier.VerifyString(metadata()) &&
-           verifier.EndTable();
-  }
-};
-
-struct ColumnBuilder {
-  typedef Column Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(Column::VT_NAME, name);
-  }
-  void add_type(FlatGeobuf::ColumnType type) {
-    fbb_.AddElement<uint8_t>(Column::VT_TYPE, static_cast<uint8_t>(type), 0);
-  }
-  void add_title(flatbuffers::Offset<flatbuffers::String> title) {
-    fbb_.AddOffset(Column::VT_TITLE, title);
-  }
-  void add_description(flatbuffers::Offset<flatbuffers::String> description) {
-    fbb_.AddOffset(Column::VT_DESCRIPTION, description);
-  }
-  void add_width(int32_t width) {
-    fbb_.AddElement<int32_t>(Column::VT_WIDTH, width, -1);
-  }
-  void add_precision(int32_t precision) {
-    fbb_.AddElement<int32_t>(Column::VT_PRECISION, precision, -1);
-  }
-  void add_scale(int32_t scale) {
-    fbb_.AddElement<int32_t>(Column::VT_SCALE, scale, -1);
-  }
-  void add_nullable(bool nullable) {
-    fbb_.AddElement<uint8_t>(Column::VT_NULLABLE, static_cast<uint8_t>(nullable), 1);
-  }
-  void add_unique(bool unique) {
-    fbb_.AddElement<uint8_t>(Column::VT_UNIQUE, static_cast<uint8_t>(unique), 0);
-  }
-  void add_primary_key(bool primary_key) {
-    fbb_.AddElement<uint8_t>(Column::VT_PRIMARY_KEY, static_cast<uint8_t>(primary_key), 0);
-  }
-  void add_metadata(flatbuffers::Offset<flatbuffers::String> metadata) {
-    fbb_.AddOffset(Column::VT_METADATA, metadata);
-  }
-  explicit ColumnBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Column> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Column>(end);
-    fbb_.Required(o, Column::VT_NAME);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Column> CreateColumn(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    FlatGeobuf::ColumnType type = FlatGeobuf::ColumnType::Byte,
-    flatbuffers::Offset<flatbuffers::String> title = 0,
-    flatbuffers::Offset<flatbuffers::String> description = 0,
-    int32_t width = -1,
-    int32_t precision = -1,
-    int32_t scale = -1,
-    bool nullable = true,
-    bool unique = false,
-    bool primary_key = false,
-    flatbuffers::Offset<flatbuffers::String> metadata = 0) {
-  ColumnBuilder builder_(_fbb);
-  builder_.add_metadata(metadata);
-  builder_.add_scale(scale);
-  builder_.add_precision(precision);
-  builder_.add_width(width);
-  builder_.add_description(description);
-  builder_.add_title(title);
-  builder_.add_name(name);
-  builder_.add_primary_key(primary_key);
-  builder_.add_unique(unique);
-  builder_.add_nullable(nullable);
-  builder_.add_type(type);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Column> CreateColumnDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    FlatGeobuf::ColumnType type = FlatGeobuf::ColumnType::Byte,
-    const char *title = nullptr,
-    const char *description = nullptr,
-    int32_t width = -1,
-    int32_t precision = -1,
-    int32_t scale = -1,
-    bool nullable = true,
-    bool unique = false,
-    bool primary_key = false,
-    const char *metadata = nullptr) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto title__ = title ? _fbb.CreateString(title) : 0;
-  auto description__ = description ? _fbb.CreateString(description) : 0;
-  auto metadata__ = metadata ? _fbb.CreateString(metadata) : 0;
-  return FlatGeobuf::CreateColumn(
-      _fbb,
-      name__,
-      type,
-      title__,
-      description__,
-      width,
-      precision,
-      scale,
-      nullable,
-      unique,
-      primary_key,
-      metadata__);
-}
-
-struct Crs FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef CrsBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_ORG = 4,
-    VT_CODE = 6,
-    VT_NAME = 8,
-    VT_DESCRIPTION = 10,
-    VT_WKT = 12,
-    VT_CODE_STRING = 14
-  };
-  const flatbuffers::String *org() const {
-    return GetPointer<const flatbuffers::String *>(VT_ORG);
-  }
-  int32_t code() const {
-    return GetField<int32_t>(VT_CODE, 0);
-  }
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  const flatbuffers::String *description() const {
-    return GetPointer<const flatbuffers::String *>(VT_DESCRIPTION);
-  }
-  const flatbuffers::String *wkt() const {
-    return GetPointer<const flatbuffers::String *>(VT_WKT);
-  }
-  const flatbuffers::String *code_string() const {
-    return GetPointer<const flatbuffers::String *>(VT_CODE_STRING);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffset(verifier, VT_ORG) &&
-           verifier.VerifyString(org()) &&
-           VerifyField<int32_t>(verifier, VT_CODE, 4) &&
-           VerifyOffset(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyOffset(verifier, VT_DESCRIPTION) &&
-           verifier.VerifyString(description()) &&
-           VerifyOffset(verifier, VT_WKT) &&
-           verifier.VerifyString(wkt()) &&
-           VerifyOffset(verifier, VT_CODE_STRING) &&
-           verifier.VerifyString(code_string()) &&
-           verifier.EndTable();
-  }
-};
-
-struct CrsBuilder {
-  typedef Crs Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_org(flatbuffers::Offset<flatbuffers::String> org) {
-    fbb_.AddOffset(Crs::VT_ORG, org);
-  }
-  void add_code(int32_t code) {
-    fbb_.AddElement<int32_t>(Crs::VT_CODE, code, 0);
-  }
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(Crs::VT_NAME, name);
-  }
-  void add_description(flatbuffers::Offset<flatbuffers::String> description) {
-    fbb_.AddOffset(Crs::VT_DESCRIPTION, description);
-  }
-  void add_wkt(flatbuffers::Offset<flatbuffers::String> wkt) {
-    fbb_.AddOffset(Crs::VT_WKT, wkt);
-  }
-  void add_code_string(flatbuffers::Offset<flatbuffers::String> code_string) {
-    fbb_.AddOffset(Crs::VT_CODE_STRING, code_string);
-  }
-  explicit CrsBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Crs> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Crs>(end);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Crs> CreateCrs(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> org = 0,
-    int32_t code = 0,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    flatbuffers::Offset<flatbuffers::String> description = 0,
-    flatbuffers::Offset<flatbuffers::String> wkt = 0,
-    flatbuffers::Offset<flatbuffers::String> code_string = 0) {
-  CrsBuilder builder_(_fbb);
-  builder_.add_code_string(code_string);
-  builder_.add_wkt(wkt);
-  builder_.add_description(description);
-  builder_.add_name(name);
-  builder_.add_code(code);
-  builder_.add_org(org);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Crs> CreateCrsDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *org = nullptr,
-    int32_t code = 0,
-    const char *name = nullptr,
-    const char *description = nullptr,
-    const char *wkt = nullptr,
-    const char *code_string = nullptr) {
-  auto org__ = org ? _fbb.CreateString(org) : 0;
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto description__ = description ? _fbb.CreateString(description) : 0;
-  auto wkt__ = wkt ? _fbb.CreateString(wkt) : 0;
-  auto code_string__ = code_string ? _fbb.CreateString(code_string) : 0;
-  return FlatGeobuf::CreateCrs(
-      _fbb,
-      org__,
-      code,
-      name__,
-      description__,
-      wkt__,
-      code_string__);
-}
-
-struct Header FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef HeaderBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_ENVELOPE = 6,
-    VT_GEOMETRY_TYPE = 8,
-    VT_HAS_Z = 10,
-    VT_HAS_M = 12,
-    VT_HAS_T = 14,
-    VT_HAS_TM = 16,
-    VT_COLUMNS = 18,
-    VT_FEATURES_COUNT = 20,
-    VT_INDEX_NODE_SIZE = 22,
-    VT_CRS = 24,
-    VT_TITLE = 26,
-    VT_DESCRIPTION = 28,
-    VT_METADATA = 30
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  const flatbuffers::Vector<double> *envelope() const {
-    return GetPointer<const flatbuffers::Vector<double> *>(VT_ENVELOPE);
-  }
-  FlatGeobuf::GeometryType geometry_type() const {
-    return static_cast<FlatGeobuf::GeometryType>(GetField<uint8_t>(VT_GEOMETRY_TYPE, 0));
-  }
-  bool has_z() const {
-    return GetField<uint8_t>(VT_HAS_Z, 0) != 0;
-  }
-  bool has_m() const {
-    return GetField<uint8_t>(VT_HAS_M, 0) != 0;
-  }
-  bool has_t() const {
-    return GetField<uint8_t>(VT_HAS_T, 0) != 0;
-  }
-  bool has_tm() const {
-    return GetField<uint8_t>(VT_HAS_TM, 0) != 0;
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *>(VT_COLUMNS);
-  }
-  uint64_t features_count() const {
-    return GetField<uint64_t>(VT_FEATURES_COUNT, 0);
-  }
-  uint16_t index_node_size() const {
-    return GetField<uint16_t>(VT_INDEX_NODE_SIZE, 16);
-  }
-  const FlatGeobuf::Crs *crs() const {
-    return GetPointer<const FlatGeobuf::Crs *>(VT_CRS);
-  }
-  const flatbuffers::String *title() const {
-    return GetPointer<const flatbuffers::String *>(VT_TITLE);
-  }
-  const flatbuffers::String *description() const {
-    return GetPointer<const flatbuffers::String *>(VT_DESCRIPTION);
-  }
-  const flatbuffers::String *metadata() const {
-    return GetPointer<const flatbuffers::String *>(VT_METADATA);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffset(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyOffset(verifier, VT_ENVELOPE) &&
-           verifier.VerifyVector(envelope()) &&
-           VerifyField<uint8_t>(verifier, VT_GEOMETRY_TYPE, 1) &&
-           VerifyField<uint8_t>(verifier, VT_HAS_Z, 1) &&
-           VerifyField<uint8_t>(verifier, VT_HAS_M, 1) &&
-           VerifyField<uint8_t>(verifier, VT_HAS_T, 1) &&
-           VerifyField<uint8_t>(verifier, VT_HAS_TM, 1) &&
-           VerifyOffset(verifier, VT_COLUMNS) &&
-           verifier.VerifyVector(columns()) &&
-           verifier.VerifyVectorOfTables(columns()) &&
-           VerifyField<uint64_t>(verifier, VT_FEATURES_COUNT, 8) &&
-           VerifyField<uint16_t>(verifier, VT_INDEX_NODE_SIZE, 2) &&
-           VerifyOffset(verifier, VT_CRS) &&
-           verifier.VerifyTable(crs()) &&
-           VerifyOffset(verifier, VT_TITLE) &&
-           verifier.VerifyString(title()) &&
-           VerifyOffset(verifier, VT_DESCRIPTION) &&
-           verifier.VerifyString(description()) &&
-           VerifyOffset(verifier, VT_METADATA) &&
-           verifier.VerifyString(metadata()) &&
-           verifier.EndTable();
-  }
-};
-
-struct HeaderBuilder {
-  typedef Header Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(Header::VT_NAME, name);
-  }
-  void add_envelope(flatbuffers::Offset<flatbuffers::Vector<double>> envelope) {
-    fbb_.AddOffset(Header::VT_ENVELOPE, envelope);
-  }
-  void add_geometry_type(FlatGeobuf::GeometryType geometry_type) {
-    fbb_.AddElement<uint8_t>(Header::VT_GEOMETRY_TYPE, static_cast<uint8_t>(geometry_type), 0);
-  }
-  void add_has_z(bool has_z) {
-    fbb_.AddElement<uint8_t>(Header::VT_HAS_Z, static_cast<uint8_t>(has_z), 0);
-  }
-  void add_has_m(bool has_m) {
-    fbb_.AddElement<uint8_t>(Header::VT_HAS_M, static_cast<uint8_t>(has_m), 0);
-  }
-  void add_has_t(bool has_t) {
-    fbb_.AddElement<uint8_t>(Header::VT_HAS_T, static_cast<uint8_t>(has_t), 0);
-  }
-  void add_has_tm(bool has_tm) {
-    fbb_.AddElement<uint8_t>(Header::VT_HAS_TM, static_cast<uint8_t>(has_tm), 0);
-  }
-  void add_columns(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns) {
-    fbb_.AddOffset(Header::VT_COLUMNS, columns);
-  }
-  void add_features_count(uint64_t features_count) {
-    fbb_.AddElement<uint64_t>(Header::VT_FEATURES_COUNT, features_count, 0);
-  }
-  void add_index_node_size(uint16_t index_node_size) {
-    fbb_.AddElement<uint16_t>(Header::VT_INDEX_NODE_SIZE, index_node_size, 16);
-  }
-  void add_crs(flatbuffers::Offset<FlatGeobuf::Crs> crs) {
-    fbb_.AddOffset(Header::VT_CRS, crs);
-  }
-  void add_title(flatbuffers::Offset<flatbuffers::String> title) {
-    fbb_.AddOffset(Header::VT_TITLE, title);
-  }
-  void add_description(flatbuffers::Offset<flatbuffers::String> description) {
-    fbb_.AddOffset(Header::VT_DESCRIPTION, description);
-  }
-  void add_metadata(flatbuffers::Offset<flatbuffers::String> metadata) {
-    fbb_.AddOffset(Header::VT_METADATA, metadata);
-  }
-  explicit HeaderBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Header> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Header>(end);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Header> CreateHeader(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    flatbuffers::Offset<flatbuffers::Vector<double>> envelope = 0,
-    FlatGeobuf::GeometryType geometry_type = FlatGeobuf::GeometryType::Unknown,
-    bool has_z = false,
-    bool has_m = false,
-    bool has_t = false,
-    bool has_tm = false,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns = 0,
-    uint64_t features_count = 0,
-    uint16_t index_node_size = 16,
-    flatbuffers::Offset<FlatGeobuf::Crs> crs = 0,
-    flatbuffers::Offset<flatbuffers::String> title = 0,
-    flatbuffers::Offset<flatbuffers::String> description = 0,
-    flatbuffers::Offset<flatbuffers::String> metadata = 0) {
-  HeaderBuilder builder_(_fbb);
-  builder_.add_features_count(features_count);
-  builder_.add_metadata(metadata);
-  builder_.add_description(description);
-  builder_.add_title(title);
-  builder_.add_crs(crs);
-  builder_.add_columns(columns);
-  builder_.add_envelope(envelope);
-  builder_.add_name(name);
-  builder_.add_index_node_size(index_node_size);
-  builder_.add_has_tm(has_tm);
-  builder_.add_has_t(has_t);
-  builder_.add_has_m(has_m);
-  builder_.add_has_z(has_z);
-  builder_.add_geometry_type(geometry_type);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Header> CreateHeaderDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    const std::vector<double> *envelope = nullptr,
-    FlatGeobuf::GeometryType geometry_type = FlatGeobuf::GeometryType::Unknown,
-    bool has_z = false,
-    bool has_m = false,
-    bool has_t = false,
-    bool has_tm = false,
-    const std::vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns = nullptr,
-    uint64_t features_count = 0,
-    uint16_t index_node_size = 16,
-    flatbuffers::Offset<FlatGeobuf::Crs> crs = 0,
-    const char *title = nullptr,
-    const char *description = nullptr,
-    const char *metadata = nullptr) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto envelope__ = envelope ? _fbb.CreateVector<double>(*envelope) : 0;
-  auto columns__ = columns ? _fbb.CreateVector<flatbuffers::Offset<FlatGeobuf::Column>>(*columns) : 0;
-  auto title__ = title ? _fbb.CreateString(title) : 0;
-  auto description__ = description ? _fbb.CreateString(description) : 0;
-  auto metadata__ = metadata ? _fbb.CreateString(metadata) : 0;
-  return FlatGeobuf::CreateHeader(
-      _fbb,
-      name__,
-      envelope__,
-      geometry_type,
-      has_z,
-      has_m,
-      has_t,
-      has_tm,
-      columns__,
-      features_count,
-      index_node_size,
-      crs,
-      title__,
-      description__,
-      metadata__);
-}
-
-inline const FlatGeobuf::Header *GetHeader(const void *buf) {
-  return flatbuffers::GetRoot<FlatGeobuf::Header>(buf);
-}
-
-inline const FlatGeobuf::Header *GetSizePrefixedHeader(const void *buf) {
-  return flatbuffers::GetSizePrefixedRoot<FlatGeobuf::Header>(buf);
-}
-
-inline bool VerifyHeaderBuffer(
-    flatbuffers::Verifier &verifier) {
-  return verifier.VerifyBuffer<FlatGeobuf::Header>(nullptr);
-}
-
-inline bool VerifySizePrefixedHeaderBuffer(
-    flatbuffers::Verifier &verifier) {
-  return verifier.VerifySizePrefixedBuffer<FlatGeobuf::Header>(nullptr);
-}
-
-inline void FinishHeaderBuffer(
-    flatbuffers::FlatBufferBuilder &fbb,
-    flatbuffers::Offset<FlatGeobuf::Header> root) {
-  fbb.Finish(root);
-}
-
-inline void FinishSizePrefixedHeaderBuffer(
-    flatbuffers::FlatBufferBuilder &fbb,
-    flatbuffers::Offset<FlatGeobuf::Header> root) {
-  fbb.FinishSizePrefixed(root);
-}
-
-}  // namespace FlatGeobuf
-}
-
-#endif  // FLATBUFFERS_GENERATED_HEADER_FLATGEOBUF_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/LICENSE 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/LICENSE
--- 8.0.1-5/flatgeobuf/include/flatbuffers/LICENSE	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/LICENSE	1970-01-01 00:00:00.000000000 +0000
@@ -1,203 +0,0 @@
-
-                                 Apache License
-                           Version 2.0, January 2004
-                        http://www.apache.org/licenses/
-
-   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
-
-   1. Definitions.
-
-      "License" shall mean the terms and conditions for use, reproduction,
-      and distribution as defined by Sections 1 through 9 of this document.
-
-      "Licensor" shall mean the copyright owner or entity authorized by
-      the copyright owner that is granting the License.
-
-      "Legal Entity" shall mean the union of the acting entity and all
-      other entities that control, are controlled by, or are under common
-      control with that entity. For the purposes of this definition,
-      "control" means (i) the power, direct or indirect, to cause the
-      direction or management of such entity, whether by contract or
-      otherwise, or (ii) ownership of fifty percent (50%) or more of the
-      outstanding shares, or (iii) beneficial ownership of such entity.
-
-      "You" (or "Your") shall mean an individual or Legal Entity
-      exercising permissions granted by this License.
-
-      "Source" form shall mean the preferred form for making modifications,
-      including but not limited to software source code, documentation
-      source, and configuration files.
-
-      "Object" form shall mean any form resulting from mechanical
-      transformation or translation of a Source form, including but
-      not limited to compiled object code, generated documentation,
-      and conversions to other media types.
-
-      "Work" shall mean the work of authorship, whether in Source or
-      Object form, made available under the License, as indicated by a
-      copyright notice that is included in or attached to the work
-      (an example is provided in the Appendix below).
-
-      "Derivative Works" shall mean any work, whether in Source or Object
-      form, that is based on (or derived from) the Work and for which the
-      editorial revisions, annotations, elaborations, or other modifications
-      represent, as a whole, an original work of authorship. For the purposes
-      of this License, Derivative Works shall not include works that remain
-      separable from, or merely link (or bind by name) to the interfaces of,
-      the Work and Derivative Works thereof.
-
-      "Contribution" shall mean any work of authorship, including
-      the original version of the Work and any modifications or additions
-      to that Work or Derivative Works thereof, that is intentionally
-      submitted to Licensor for inclusion in the Work by the copyright owner
-      or by an individual or Legal Entity authorized to submit on behalf of
-      the copyright owner. For the purposes of this definition, "submitted"
-      means any form of electronic, verbal, or written communication sent
-      to the Licensor or its representatives, including but not limited to
-      communication on electronic mailing lists, source code control systems,
-      and issue tracking systems that are managed by, or on behalf of, the
-      Licensor for the purpose of discussing and improving the Work, but
-      excluding communication that is conspicuously marked or otherwise
-      designated in writing by the copyright owner as "Not a Contribution."
-
-      "Contributor" shall mean Licensor and any individual or Legal Entity
-      on behalf of whom a Contribution has been received by Licensor and
-      subsequently incorporated within the Work.
-
-   2. Grant of Copyright License. Subject to the terms and conditions of
-      this License, each Contributor hereby grants to You a perpetual,
-      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
-      copyright license to reproduce, prepare Derivative Works of,
-      publicly display, publicly perform, sublicense, and distribute the
-      Work and such Derivative Works in Source or Object form.
-
-   3. Grant of Patent License. Subject to the terms and conditions of
-      this License, each Contributor hereby grants to You a perpetual,
-      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
-      (except as stated in this section) patent license to make, have made,
-      use, offer to sell, sell, import, and otherwise transfer the Work,
-      where such license applies only to those patent claims licensable
-      by such Contributor that are necessarily infringed by their
-      Contribution(s) alone or by combination of their Contribution(s)
-      with the Work to which such Contribution(s) was submitted. If You
-      institute patent litigation against any entity (including a
-      cross-claim or counterclaim in a lawsuit) alleging that the Work
-      or a Contribution incorporated within the Work constitutes direct
-      or contributory patent infringement, then any patent licenses
-      granted to You under this License for that Work shall terminate
-      as of the date such litigation is filed.
-
-   4. Redistribution. You may reproduce and distribute copies of the
-      Work or Derivative Works thereof in any medium, with or without
-      modifications, and in Source or Object form, provided that You
-      meet the following conditions:
-
-      (a) You must give any other recipients of the Work or
-          Derivative Works a copy of this License; and
-
-      (b) You must cause any modified files to carry prominent notices
-          stating that You changed the files; and
-
-      (c) You must retain, in the Source form of any Derivative Works
-          that You distribute, all copyright, patent, trademark, and
-          attribution notices from the Source form of the Work,
-          excluding those notices that do not pertain to any part of
-          the Derivative Works; and
-
-      (d) If the Work includes a "NOTICE" text file as part of its
-          distribution, then any Derivative Works that You distribute must
-          include a readable copy of the attribution notices contained
-          within such NOTICE file, excluding those notices that do not
-          pertain to any part of the Derivative Works, in at least one
-          of the following places: within a NOTICE text file distributed
-          as part of the Derivative Works; within the Source form or
-          documentation, if provided along with the Derivative Works; or,
-          within a display generated by the Derivative Works, if and
-          wherever such third-party notices normally appear. The contents
-          of the NOTICE file are for informational purposes only and
-          do not modify the License. You may add Your own attribution
-          notices within Derivative Works that You distribute, alongside
-          or as an addendum to the NOTICE text from the Work, provided
-          that such additional attribution notices cannot be construed
-          as modifying the License.
-
-      You may add Your own copyright statement to Your modifications and
-      may provide additional or different license terms and conditions
-      for use, reproduction, or distribution of Your modifications, or
-      for any such Derivative Works as a whole, provided Your use,
-      reproduction, and distribution of the Work otherwise complies with
-      the conditions stated in this License.
-
-   5. Submission of Contributions. Unless You explicitly state otherwise,
-      any Contribution intentionally submitted for inclusion in the Work
-      by You to the Licensor shall be under the terms and conditions of
-      this License, without any additional terms or conditions.
-      Notwithstanding the above, nothing herein shall supersede or modify
-      the terms of any separate license agreement you may have executed
-      with Licensor regarding such Contributions.
-
-   6. Trademarks. This License does not grant permission to use the trade
-      names, trademarks, service marks, or product names of the Licensor,
-      except as required for reasonable and customary use in describing the
-      origin of the Work and reproducing the content of the NOTICE file.
-
-   7. Disclaimer of Warranty. Unless required by applicable law or
-      agreed to in writing, Licensor provides the Work (and each
-      Contributor provides its Contributions) on an "AS IS" BASIS,
-      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
-      implied, including, without limitation, any warranties or conditions
-      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
-      PARTICULAR PURPOSE. You are solely responsible for determining the
-      appropriateness of using or redistributing the Work and assume any
-      risks associated with Your exercise of permissions under this License.
-
-   8. Limitation of Liability. In no event and under no legal theory,
-      whether in tort (including negligence), contract, or otherwise,
-      unless required by applicable law (such as deliberate and grossly
-      negligent acts) or agreed to in writing, shall any Contributor be
-      liable to You for damages, including any direct, indirect, special,
-      incidental, or consequential damages of any character arising as a
-      result of this License or out of the use or inability to use the
-      Work (including but not limited to damages for loss of goodwill,
-      work stoppage, computer failure or malfunction, or any and all
-      other commercial damages or losses), even if such Contributor
-      has been advised of the possibility of such damages.
-
-   9. Accepting Warranty or Additional Liability. While redistributing
-      the Work or Derivative Works thereof, You may choose to offer,
-      and charge a fee for, acceptance of support, warranty, indemnity,
-      or other liability obligations and/or rights consistent with this
-      License. However, in accepting such obligations, You may act only
-      on Your own behalf and on Your sole responsibility, not on behalf
-      of any other Contributor, and only if You agree to indemnify,
-      defend, and hold each Contributor harmless for any liability
-      incurred by, or claims asserted against, such Contributor by reason
-      of your accepting any such warranty or additional liability.
-
-   END OF TERMS AND CONDITIONS
-
-   APPENDIX: How to apply the Apache License to your work.
-
-      To apply the Apache License to your work, attach the following
-      boilerplate notice, with the fields enclosed by brackets "[]"
-      replaced with your own identifying information. (Don't include
-      the brackets!)  The text should be enclosed in the appropriate
-      comment syntax for the file format. We also recommend that a
-      file or class name and description of purpose be included on the
-      same "printed page" as the copyright notice for easier
-      identification within third-party archives.
-
-   Copyright 2014 Google Inc.
-
-   Licensed under the Apache License, Version 2.0 (the "License");
-   you may not use this file except in compliance with the License.
-   You may obtain a copy of the License at
-
-       http://www.apache.org/licenses/LICENSE-2.0
-
-   Unless required by applicable law or agreed to in writing, software
-   distributed under the License is distributed on an "AS IS" BASIS,
-   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-   See the License for the specific language governing permissions and
-   limitations under the License.
-
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/allocator.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/allocator.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/allocator.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/allocator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,70 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_ALLOCATOR_H_
-#define FLATBUFFERS_ALLOCATOR_H_
-
-#include "flatbuffers/base.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Allocator interface. This is flatbuffers-specific and meant only for
-// `vector_downward` usage.
-class Allocator {
- public:
-  virtual ~Allocator() {}
-
-  // Allocate `size` bytes of memory.
-  virtual uint8_t *allocate(size_t size) = 0;
-
-  // Deallocate `size` bytes of memory at `p` allocated by this allocator.
-  virtual void deallocate(uint8_t *p, size_t size) = 0;
-
-  // Reallocate `new_size` bytes of memory, replacing the old region of size
-  // `old_size` at `p`. In contrast to a normal realloc, this grows downwards,
-  // and is intended specifcally for `vector_downward` use.
-  // `in_use_back` and `in_use_front` indicate how much of `old_size` is
-  // actually in use at each end, and needs to be copied.
-  virtual uint8_t *reallocate_downward(uint8_t *old_p, size_t old_size,
-                                       size_t new_size, size_t in_use_back,
-                                       size_t in_use_front) {
-    FLATBUFFERS_ASSERT(new_size > old_size);  // vector_downward only grows
-    uint8_t *new_p = allocate(new_size);
-    memcpy_downward(old_p, old_size, new_p, new_size, in_use_back,
-                    in_use_front);
-    deallocate(old_p, old_size);
-    return new_p;
-  }
-
- protected:
-  // Called by `reallocate_downward` to copy memory from `old_p` of `old_size`
-  // to `new_p` of `new_size`. Only memory of size `in_use_front` and
-  // `in_use_back` will be copied from the front and back of the old memory
-  // allocation.
-  void memcpy_downward(uint8_t *old_p, size_t old_size, uint8_t *new_p,
-                       size_t new_size, size_t in_use_back,
-                       size_t in_use_front) {
-    memcpy(new_p + new_size - in_use_back, old_p + old_size - in_use_back,
-           in_use_back);
-    memcpy(new_p, old_p, in_use_front);
-  }
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_ALLOCATOR_H_
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/array.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/array.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/array.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/array.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,245 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_ARRAY_H_
-#define FLATBUFFERS_ARRAY_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/stl_emulation.h"
-#include "flatbuffers/vector.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// This is used as a helper type for accessing arrays.
-template<typename T, uint16_t length> class Array {
-  // Array<T> can carry only POD data types (scalars or structs).
-  typedef typename flatbuffers::bool_constant<flatbuffers::is_scalar<T>::value>
-      scalar_tag;
-  typedef
-      typename flatbuffers::conditional<scalar_tag::value, T, const T *>::type
-          IndirectHelperType;
-
- public:
-  typedef uint16_t size_type;
-  typedef typename IndirectHelper<IndirectHelperType>::return_type return_type;
-  typedef VectorIterator<T, return_type> const_iterator;
-  typedef VectorReverseIterator<const_iterator> const_reverse_iterator;
-
-  // If T is a LE-scalar or a struct (!scalar_tag::value).
-  static FLATBUFFERS_CONSTEXPR bool is_span_observable =
-      (scalar_tag::value && (FLATBUFFERS_LITTLEENDIAN || sizeof(T) == 1)) ||
-      !scalar_tag::value;
-
-  FLATBUFFERS_CONSTEXPR uint16_t size() const { return length; }
-
-  return_type Get(uoffset_t i) const {
-    FLATBUFFERS_ASSERT(i < size());
-    return IndirectHelper<IndirectHelperType>::Read(Data(), i);
-  }
-
-  return_type operator[](uoffset_t i) const { return Get(i); }
-
-  // If this is a Vector of enums, T will be its storage type, not the enum
-  // type. This function makes it convenient to retrieve value with enum
-  // type E.
-  template<typename E> E GetEnum(uoffset_t i) const {
-    return static_cast<E>(Get(i));
-  }
-
-  const_iterator begin() const { return const_iterator(Data(), 0); }
-  const_iterator end() const { return const_iterator(Data(), size()); }
-
-  const_reverse_iterator rbegin() const {
-    return const_reverse_iterator(end());
-  }
-  const_reverse_iterator rend() const {
-    return const_reverse_iterator(begin());
-  }
-
-  const_iterator cbegin() const { return begin(); }
-  const_iterator cend() const { return end(); }
-
-  const_reverse_iterator crbegin() const { return rbegin(); }
-  const_reverse_iterator crend() const { return rend(); }
-
-  // Get a mutable pointer to elements inside this array.
-  // This method used to mutate arrays of structs followed by a @p Mutate
-  // operation. For primitive types use @p Mutate directly.
-  // @warning Assignments and reads to/from the dereferenced pointer are not
-  //  automatically converted to the correct endianness.
-  typename flatbuffers::conditional<scalar_tag::value, void, T *>::type
-  GetMutablePointer(uoffset_t i) const {
-    FLATBUFFERS_ASSERT(i < size());
-    return const_cast<T *>(&data()[i]);
-  }
-
-  // Change elements if you have a non-const pointer to this object.
-  void Mutate(uoffset_t i, const T &val) { MutateImpl(scalar_tag(), i, val); }
-
-  // The raw data in little endian format. Use with care.
-  const uint8_t *Data() const { return data_; }
-
-  uint8_t *Data() { return data_; }
-
-  // Similarly, but typed, much like std::vector::data
-  const T *data() const { return reinterpret_cast<const T *>(Data()); }
-  T *data() { return reinterpret_cast<T *>(Data()); }
-
-  // Copy data from a span with endian conversion.
-  // If this Array and the span overlap, the behavior is undefined.
-  void CopyFromSpan(flatbuffers::span<const T, length> src) {
-    const auto p1 = reinterpret_cast<const uint8_t *>(src.data());
-    const auto p2 = Data();
-    FLATBUFFERS_ASSERT(!(p1 >= p2 && p1 < (p2 + length)) &&
-                       !(p2 >= p1 && p2 < (p1 + length)));
-    (void)p1;
-    (void)p2;
-    CopyFromSpanImpl(flatbuffers::bool_constant<is_span_observable>(), src);
-  }
-
- protected:
-  void MutateImpl(flatbuffers::true_type, uoffset_t i, const T &val) {
-    FLATBUFFERS_ASSERT(i < size());
-    WriteScalar(data() + i, val);
-  }
-
-  void MutateImpl(flatbuffers::false_type, uoffset_t i, const T &val) {
-    *(GetMutablePointer(i)) = val;
-  }
-
-  void CopyFromSpanImpl(flatbuffers::true_type,
-                        flatbuffers::span<const T, length> src) {
-    // Use std::memcpy() instead of std::copy() to avoid performance degradation
-    // due to aliasing if T is char or unsigned char.
-    // The size is known at compile time, so memcpy would be inlined.
-    std::memcpy(data(), src.data(), length * sizeof(T));
-  }
-
-  // Copy data from flatbuffers::span with endian conversion.
-  void CopyFromSpanImpl(flatbuffers::false_type,
-                        flatbuffers::span<const T, length> src) {
-    for (size_type k = 0; k < length; k++) { Mutate(k, src[k]); }
-  }
-
-  // This class is only used to access pre-existing data. Don't ever
-  // try to construct these manually.
-  // 'constexpr' allows us to use 'size()' at compile time.
-  // @note Must not use 'FLATBUFFERS_CONSTEXPR' here, as const is not allowed on
-  //  a constructor.
-#if defined(__cpp_constexpr)
-  constexpr Array();
-#else
-  Array();
-#endif
-
-  uint8_t data_[length * sizeof(T)];
-
- private:
-  // This class is a pointer. Copying will therefore create an invalid object.
-  // Private and unimplemented copy constructor.
-  Array(const Array &);
-  Array &operator=(const Array &);
-};
-
-// Specialization for Array[struct] with access using Offset<void> pointer.
-// This specialization used by idl_gen_text.cpp.
-template<typename T, uint16_t length> class Array<Offset<T>, length> {
-  static_assert(flatbuffers::is_same<T, void>::value, "unexpected type T");
-
- public:
-  typedef const void *return_type;
-
-  const uint8_t *Data() const { return data_; }
-
-  // Make idl_gen_text.cpp::PrintContainer happy.
-  return_type operator[](uoffset_t) const {
-    FLATBUFFERS_ASSERT(false);
-    return nullptr;
-  }
-
- private:
-  // This class is only used to access pre-existing data.
-  Array();
-  Array(const Array &);
-  Array &operator=(const Array &);
-
-  uint8_t data_[1];
-};
-
-template<class U, uint16_t N>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<U, N> make_span(Array<U, N> &arr)
-    FLATBUFFERS_NOEXCEPT {
-  static_assert(
-      Array<U, N>::is_span_observable,
-      "wrong type U, only plain struct, LE-scalar, or byte types are allowed");
-  return span<U, N>(arr.data(), N);
-}
-
-template<class U, uint16_t N>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const U, N> make_span(
-    const Array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
-  static_assert(
-      Array<U, N>::is_span_observable,
-      "wrong type U, only plain struct, LE-scalar, or byte types are allowed");
-  return span<const U, N>(arr.data(), N);
-}
-
-template<class U, uint16_t N>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<uint8_t, sizeof(U) * N>
-make_bytes_span(Array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
-  static_assert(Array<U, N>::is_span_observable,
-                "internal error, Array<T> might hold only scalars or structs");
-  return span<uint8_t, sizeof(U) * N>(arr.Data(), sizeof(U) * N);
-}
-
-template<class U, uint16_t N>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const uint8_t, sizeof(U) * N>
-make_bytes_span(const Array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
-  static_assert(Array<U, N>::is_span_observable,
-                "internal error, Array<T> might hold only scalars or structs");
-  return span<const uint8_t, sizeof(U) * N>(arr.Data(), sizeof(U) * N);
-}
-
-// Cast a raw T[length] to a raw flatbuffers::Array<T, length>
-// without endian conversion. Use with care.
-// TODO: move these Cast-methods to `internal` namespace.
-template<typename T, uint16_t length>
-Array<T, length> &CastToArray(T (&arr)[length]) {
-  return *reinterpret_cast<Array<T, length> *>(arr);
-}
-
-template<typename T, uint16_t length>
-const Array<T, length> &CastToArray(const T (&arr)[length]) {
-  return *reinterpret_cast<const Array<T, length> *>(arr);
-}
-
-template<typename E, typename T, uint16_t length>
-Array<E, length> &CastToArrayOfEnum(T (&arr)[length]) {
-  static_assert(sizeof(E) == sizeof(T), "invalid enum type E");
-  return *reinterpret_cast<Array<E, length> *>(arr);
-}
-
-template<typename E, typename T, uint16_t length>
-const Array<E, length> &CastToArrayOfEnum(const T (&arr)[length]) {
-  static_assert(sizeof(E) == sizeof(T), "invalid enum type E");
-  return *reinterpret_cast<const Array<E, length> *>(arr);
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_ARRAY_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/base.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/base.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/base.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/base.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,482 +0,0 @@
-#ifndef FLATBUFFERS_BASE_H_
-#define FLATBUFFERS_BASE_H_
-
-// clang-format off
-
-// If activate should be declared and included first.
-#if defined(FLATBUFFERS_MEMORY_LEAK_TRACKING) && \
-    defined(_MSC_VER) && defined(_DEBUG)
-  // The _CRTDBG_MAP_ALLOC inside <crtdbg.h> will replace
-  // calloc/free (etc) to its debug version using #define directives.
-  #define _CRTDBG_MAP_ALLOC
-  #include <stdlib.h>
-  #include <crtdbg.h>
-  // Replace operator new by trace-enabled version.
-  #define DEBUG_NEW new(_NORMAL_BLOCK, __FILE__, __LINE__)
-  #define new DEBUG_NEW
-#endif
-
-#if !defined(FLATBUFFERS_ASSERT)
-#include <assert.h>
-#define FLATBUFFERS_ASSERT assert
-#elif defined(FLATBUFFERS_ASSERT_INCLUDE)
-// Include file with forward declaration
-#include FLATBUFFERS_ASSERT_INCLUDE
-#endif
-
-#ifndef ARDUINO
-#include <cstdint>
-#endif
-
-#include <cstddef>
-#include <cstdlib>
-#include <cstring>
-
-#if defined(ARDUINO) && !defined(ARDUINOSTL_M_H)
-  #include <utility.h>
-#else
-  #include <utility>
-#endif
-
-#include <string>
-#include <type_traits>
-#include <vector>
-#include <set>
-#include <algorithm>
-#include <iterator>
-#include <memory>
-
-#if defined(__unix__) && !defined(FLATBUFFERS_LOCALE_INDEPENDENT)
-  #include <unistd.h>
-#endif
-
-#ifdef __ANDROID__
-  #include <android/api-level.h>
-#endif
-
-#if defined(__ICCARM__)
-#include <intrinsics.h>
-#endif
-
-// Note the __clang__ check is needed, because clang presents itself
-// as an older GNUC compiler (4.2).
-// Clang 3.3 and later implement all of the ISO C++ 2011 standard.
-// Clang 3.4 and later implement all of the ISO C++ 2014 standard.
-// http://clang.llvm.org/cxx_status.html
-
-// Note the MSVC value '__cplusplus' may be incorrect:
-// The '__cplusplus' predefined macro in the MSVC stuck at the value 199711L,
-// indicating (erroneously!) that the compiler conformed to the C++98 Standard.
-// This value should be correct starting from MSVC2017-15.7-Preview-3.
-// The '__cplusplus' will be valid only if MSVC2017-15.7-P3 and the `/Zc:__cplusplus` switch is set.
-// Workaround (for details see MSDN):
-// Use the _MSC_VER and _MSVC_LANG definition instead of the __cplusplus  for compatibility.
-// The _MSVC_LANG macro reports the Standard version regardless of the '/Zc:__cplusplus' switch.
-
-#if defined(__GNUC__) && !defined(__clang__)
-  #define FLATBUFFERS_GCC (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
-#else
-  #define FLATBUFFERS_GCC 0
-#endif
-
-#if defined(__clang__)
-  #define FLATBUFFERS_CLANG (__clang_major__ * 10000 + __clang_minor__ * 100 + __clang_patchlevel__)
-#else
-  #define FLATBUFFERS_CLANG 0
-#endif
-
-/// @cond FLATBUFFERS_INTERNAL
-#if __cplusplus <= 199711L && \
-    (!defined(_MSC_VER) || _MSC_VER < 1600) && \
-    (!defined(__GNUC__) || \
-      (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__ < 40400))
-  #error A C++11 compatible compiler with support for the auto typing is \
-         required for FlatBuffers.
-  #error __cplusplus _MSC_VER __GNUC__  __GNUC_MINOR__  __GNUC_PATCHLEVEL__
-#endif
-
-#if !defined(__clang__) && \
-    defined(__GNUC__) && \
-    (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__ < 40600)
-  // Backwards compatibility for g++ 4.4, and 4.5 which don't have the nullptr
-  // and constexpr keywords. Note the __clang__ check is needed, because clang
-  // presents itself as an older GNUC compiler.
-  #ifndef nullptr_t
-    const class nullptr_t {
-    public:
-      template<class T> inline operator T*() const { return 0; }
-    private:
-      void operator&() const;
-    } nullptr = {};
-  #endif
-  #ifndef constexpr
-    #define constexpr const
-  #endif
-#endif
-
-// The wire format uses a little endian encoding (since that's efficient for
-// the common platforms).
-#if defined(__s390x__)
-  #define FLATBUFFERS_LITTLEENDIAN 0
-#endif // __s390x__
-#if !defined(FLATBUFFERS_LITTLEENDIAN)
-  #if defined(__GNUC__) || defined(__clang__) || defined(__ICCARM__)
-    #if (defined(__BIG_ENDIAN__) || \
-         (defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__))
-      #define FLATBUFFERS_LITTLEENDIAN 0
-    #else
-      #define FLATBUFFERS_LITTLEENDIAN 1
-    #endif // __BIG_ENDIAN__
-  #elif defined(_MSC_VER)
-    #if defined(_M_PPC)
-      #define FLATBUFFERS_LITTLEENDIAN 0
-    #else
-      #define FLATBUFFERS_LITTLEENDIAN 1
-    #endif
-  #else
-    #error Unable to determine endianness, define FLATBUFFERS_LITTLEENDIAN.
-  #endif
-#endif // !defined(FLATBUFFERS_LITTLEENDIAN)
-
-#define FLATBUFFERS_VERSION_MAJOR 2
-#define FLATBUFFERS_VERSION_MINOR 0
-#define FLATBUFFERS_VERSION_REVISION 6
-#define FLATBUFFERS_STRING_EXPAND(X) #X
-#define FLATBUFFERS_STRING(X) FLATBUFFERS_STRING_EXPAND(X)
-namespace mapserver {
-namespace flatbuffers {
-  // Returns version as string  "MAJOR.MINOR.REVISION".
-  const char* FLATBUFFERS_VERSION();
-} }
-
-#if (!defined(_MSC_VER) || _MSC_VER > 1600) && \
-    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 407)) || \
-    defined(__clang__)
-  #define FLATBUFFERS_FINAL_CLASS final
-  #define FLATBUFFERS_OVERRIDE override
-  #define FLATBUFFERS_EXPLICIT_CPP11 explicit
-  #define FLATBUFFERS_VTABLE_UNDERLYING_TYPE : flatbuffers::voffset_t
-#else
-  #define FLATBUFFERS_FINAL_CLASS
-  #define FLATBUFFERS_OVERRIDE
-  #define FLATBUFFERS_EXPLICIT_CPP11
-  #define FLATBUFFERS_VTABLE_UNDERLYING_TYPE
-#endif
-
-#if (!defined(_MSC_VER) || _MSC_VER >= 1900) && \
-    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 406)) || \
-    (defined(__cpp_constexpr) && __cpp_constexpr >= 200704)
-  #define FLATBUFFERS_CONSTEXPR constexpr
-  #define FLATBUFFERS_CONSTEXPR_CPP11 constexpr
-  #define FLATBUFFERS_CONSTEXPR_DEFINED
-#else
-  #define FLATBUFFERS_CONSTEXPR const
-  #define FLATBUFFERS_CONSTEXPR_CPP11
-#endif
-
-#if (defined(__cplusplus) && __cplusplus >= 201402L) || \
-    (defined(__cpp_constexpr) && __cpp_constexpr >= 201304)
-  #define FLATBUFFERS_CONSTEXPR_CPP14 FLATBUFFERS_CONSTEXPR_CPP11
-#else
-  #define FLATBUFFERS_CONSTEXPR_CPP14
-#endif
-
-#if (defined(__GXX_EXPERIMENTAL_CXX0X__) && (__GNUC__ * 100 + __GNUC_MINOR__ >= 406)) || \
-    (defined(_MSC_FULL_VER) && (_MSC_FULL_VER >= 190023026)) || \
-    defined(__clang__)
-  #define FLATBUFFERS_NOEXCEPT noexcept
-#else
-  #define FLATBUFFERS_NOEXCEPT
-#endif
-
-// NOTE: the FLATBUFFERS_DELETE_FUNC macro may change the access mode to
-// private, so be sure to put it at the end or reset access mode explicitly.
-#if (!defined(_MSC_VER) || _MSC_FULL_VER >= 180020827) && \
-    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 404)) || \
-    defined(__clang__)
-  #define FLATBUFFERS_DELETE_FUNC(func) func = delete
-#else
-  #define FLATBUFFERS_DELETE_FUNC(func) private: func
-#endif
-
-#if (!defined(_MSC_VER) || _MSC_VER >= 1900) && \
-    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 409)) || \
-    defined(__clang__)
-  #define FLATBUFFERS_DEFAULT_DECLARATION
-#endif
-
-// Check if we can use template aliases
-// Not possible if Microsoft Compiler before 2012
-// Possible is the language feature __cpp_alias_templates is defined well
-// Or possible if the C++ std is C+11 or newer
-#if (defined(_MSC_VER) && _MSC_VER > 1700 /* MSVC2012 */) \
-    || (defined(__cpp_alias_templates) && __cpp_alias_templates >= 200704) \
-    || (defined(__cplusplus) && __cplusplus >= 201103L)
-  #define FLATBUFFERS_TEMPLATES_ALIASES
-#endif
-
-#ifndef FLATBUFFERS_HAS_STRING_VIEW
-  // Only provide flatbuffers::string_view if __has_include can be used
-  // to detect a header that provides an implementation
-  #if defined(__has_include)
-    // Check for std::string_view (in c++17)
-    #if __has_include(<string_view>) && (__cplusplus >= 201606 || (defined(_HAS_CXX17) && _HAS_CXX17))
-      #include <string_view>
-      namespace mapserver {
-namespace flatbuffers {
-        typedef std::string_view string_view;
-      } }
-      #define FLATBUFFERS_HAS_STRING_VIEW 1
-    // Check for std::experimental::string_view (in c++14, compiler-dependent)
-    #elif __has_include(<experimental/string_view>) && (__cplusplus >= 201411)
-      #include <experimental/string_view>
-      namespace mapserver {
-namespace flatbuffers {
-        typedef std::experimental::string_view string_view;
-      } }
-      #define FLATBUFFERS_HAS_STRING_VIEW 1
-    // Check for absl::string_view
-    #elif __has_include("absl/strings/string_view.h") && (__cplusplus >= 201411)
-      #include "absl/strings/string_view.h"
-      namespace mapserver {
-namespace flatbuffers {
-        typedef absl::string_view string_view;
-      } }
-      #define FLATBUFFERS_HAS_STRING_VIEW 1
-    #endif
-  #endif // __has_include
-#endif // !FLATBUFFERS_HAS_STRING_VIEW
-
-#ifndef FLATBUFFERS_GENERAL_HEAP_ALLOC_OK
-  // Allow heap allocations to be used
-  #define FLATBUFFERS_GENERAL_HEAP_ALLOC_OK 1
-#endif // !FLATBUFFERS_GENERAL_HEAP_ALLOC_OK
-
-#ifndef FLATBUFFERS_HAS_NEW_STRTOD
-  // Modern (C++11) strtod and strtof functions are available for use.
-  // 1) nan/inf strings as argument of strtod;
-  // 2) hex-float  as argument of  strtod/strtof.
-  #if (defined(_MSC_VER) && _MSC_VER >= 1900) || \
-      (defined(__GNUC__) && (__GNUC__ * 100 + __GNUC_MINOR__ >= 409)) || \
-      (defined(__clang__))
-    #define FLATBUFFERS_HAS_NEW_STRTOD 1
-  #endif
-#endif // !FLATBUFFERS_HAS_NEW_STRTOD
-
-#ifndef FLATBUFFERS_LOCALE_INDEPENDENT
-  // Enable locale independent functions {strtof_l, strtod_l,strtoll_l, strtoull_l}.
-  #if ((defined(_MSC_VER) && _MSC_VER >= 1800)            || \
-       (defined(_XOPEN_VERSION) && (_XOPEN_VERSION>=700)) && (!defined(__ANDROID_API__) || (defined(__ANDROID_API__) && (__ANDROID_API__>=21))))
-    #define FLATBUFFERS_LOCALE_INDEPENDENT 1
-  #else
-    #define FLATBUFFERS_LOCALE_INDEPENDENT 0
-  #endif
-#endif  // !FLATBUFFERS_LOCALE_INDEPENDENT
-
-// Suppress Undefined Behavior Sanitizer (recoverable only). Usage:
-// - __supress_ubsan__("undefined")
-// - __supress_ubsan__("signed-integer-overflow")
-#if defined(__clang__) && (__clang_major__ > 3 || (__clang_major__ == 3 && __clang_minor__ >=7))
-  #define __supress_ubsan__(type) __attribute__((no_sanitize(type)))
-#elif defined(__GNUC__) && (__GNUC__ * 100 + __GNUC_MINOR__ >= 409)
-  #define __supress_ubsan__(type) __attribute__((no_sanitize_undefined))
-#else
-  #define __supress_ubsan__(type)
-#endif
-
-// This is constexpr function used for checking compile-time constants.
-// Avoid `#pragma warning(disable: 4127) // C4127: expression is constant`.
-template<typename T> FLATBUFFERS_CONSTEXPR inline bool IsConstTrue(T t) {
-  return !!t;
-}
-
-// Enable C++ attribute [[]] if std:c++17 or higher.
-#if ((__cplusplus >= 201703L) \
-    || (defined(_MSVC_LANG) &&  (_MSVC_LANG >= 201703L)))
-  // All attributes unknown to an implementation are ignored without causing an error.
-  #define FLATBUFFERS_ATTRIBUTE(attr) attr
-
-  #define FLATBUFFERS_FALLTHROUGH() [[fallthrough]]
-#else
-  #define FLATBUFFERS_ATTRIBUTE(attr)
-
-  #if FLATBUFFERS_CLANG >= 30800
-    #define FLATBUFFERS_FALLTHROUGH() [[clang::fallthrough]]
-  #elif FLATBUFFERS_GCC >= 70300
-    #define FLATBUFFERS_FALLTHROUGH() [[gnu::fallthrough]]
-  #else
-    #define FLATBUFFERS_FALLTHROUGH()
-  #endif
-#endif
-
-/// @endcond
-
-/// @file
-namespace mapserver {
-namespace flatbuffers {
-
-/// @cond FLATBUFFERS_INTERNAL
-// Our default offset / size type, 32bit on purpose on 64bit systems.
-// Also, using a consistent offset type maintains compatibility of serialized
-// offset values between 32bit and 64bit systems.
-typedef uint32_t uoffset_t;
-
-// Signed offsets for references that can go in both directions.
-typedef int32_t soffset_t;
-
-// Offset/index used in v-tables, can be changed to uint8_t in
-// format forks to save a bit of space if desired.
-typedef uint16_t voffset_t;
-
-typedef uintmax_t largest_scalar_t;
-
-// In 32bits, this evaluates to 2GB - 1
-#define FLATBUFFERS_MAX_BUFFER_SIZE ((1ULL << (sizeof(::mapserver::flatbuffers::soffset_t) * 8 - 1)) - 1)
-
-// We support aligning the contents of buffers up to this size.
-#ifndef FLATBUFFERS_MAX_ALIGNMENT
-  #define FLATBUFFERS_MAX_ALIGNMENT 32
-#endif
-
-/// @brief The length of a FlatBuffer file header.
-static const size_t kFileIdentifierLength = 4;
-
-inline bool VerifyAlignmentRequirements(size_t align, size_t min_align = 1) {
-  return (min_align <= align) && (align <= (FLATBUFFERS_MAX_ALIGNMENT)) &&
-         (align & (align - 1)) == 0;  // must be power of 2
-}
-
-#if defined(_MSC_VER)
-  #pragma warning(disable: 4351) // C4351: new behavior: elements of array ... will be default initialized
-  #pragma warning(push)
-  #pragma warning(disable: 4127) // C4127: conditional expression is constant
-#endif
-
-template<typename T> T EndianSwap(T t) {
-  #if defined(_MSC_VER)
-    #define FLATBUFFERS_BYTESWAP16 _byteswap_ushort
-    #define FLATBUFFERS_BYTESWAP32 _byteswap_ulong
-    #define FLATBUFFERS_BYTESWAP64 _byteswap_uint64
-  #elif defined(__ICCARM__)
-    #define FLATBUFFERS_BYTESWAP16 __REV16
-    #define FLATBUFFERS_BYTESWAP32 __REV
-    #define FLATBUFFERS_BYTESWAP64(x) \
-       ((__REV(static_cast<uint32_t>(x >> 32U))) | (static_cast<uint64_t>(__REV(static_cast<uint32_t>(x)))) << 32U)
-  #else
-    #if defined(__GNUC__) && __GNUC__ * 100 + __GNUC_MINOR__ < 408 && !defined(__clang__)
-      // __builtin_bswap16 was missing prior to GCC 4.8.
-      #define FLATBUFFERS_BYTESWAP16(x) \
-        static_cast<uint16_t>(__builtin_bswap32(static_cast<uint32_t>(x) << 16))
-    #else
-      #define FLATBUFFERS_BYTESWAP16 __builtin_bswap16
-    #endif
-    #define FLATBUFFERS_BYTESWAP32 __builtin_bswap32
-    #define FLATBUFFERS_BYTESWAP64 __builtin_bswap64
-  #endif
-  if (sizeof(T) == 1) {   // Compile-time if-then's.
-    return t;
-  } else if (sizeof(T) == 2) {
-    union { T t; uint16_t i; } u = { t };
-    u.i = FLATBUFFERS_BYTESWAP16(u.i);
-    return u.t;
-  } else if (sizeof(T) == 4) {
-    union { T t; uint32_t i; } u = { t };
-    u.i = FLATBUFFERS_BYTESWAP32(u.i);
-    return u.t;
-  } else if (sizeof(T) == 8) {
-    union { T t; uint64_t i; } u = { t };
-    u.i = FLATBUFFERS_BYTESWAP64(u.i);
-    return u.t;
-  } else {
-    FLATBUFFERS_ASSERT(0);
-    return t;
-  }
-}
-
-#if defined(_MSC_VER)
-  #pragma warning(pop)
-#endif
-
-
-template<typename T> T EndianScalar(T t) {
-  #if FLATBUFFERS_LITTLEENDIAN
-    return t;
-  #else
-    return EndianSwap(t);
-  #endif
-}
-
-template<typename T>
-// UBSAN: C++ aliasing type rules, see std::bit_cast<> for details.
-__supress_ubsan__("alignment")
-T ReadScalar(const void *p) {
-  return EndianScalar(*reinterpret_cast<const T *>(p));
-}
-
-// See https://github.com/google/flatbuffers/issues/5950
-
-#if (FLATBUFFERS_GCC >= 100000) && (FLATBUFFERS_GCC < 110000)
-  #pragma GCC diagnostic push
-  #pragma GCC diagnostic ignored "-Wstringop-overflow"
-#endif
-
-template<typename T>
-// UBSAN: C++ aliasing type rules, see std::bit_cast<> for details.
-__supress_ubsan__("alignment")
-void WriteScalar(void *p, T t) {
-  *reinterpret_cast<T *>(p) = EndianScalar(t);
-}
-
-template<typename T> struct Offset;
-template<typename T> __supress_ubsan__("alignment") void WriteScalar(void *p, Offset<T> t) {
-  *reinterpret_cast<uoffset_t *>(p) = EndianScalar(t.o);
-}
-
-#if (FLATBUFFERS_GCC >= 100000) && (FLATBUFFERS_GCC < 110000)
-  #pragma GCC diagnostic pop
-#endif
-
-// Computes how many bytes you'd have to pad to be able to write an
-// "scalar_size" scalar if the buffer had grown to "buf_size" (downwards in
-// memory).
-__supress_ubsan__("unsigned-integer-overflow")
-inline size_t PaddingBytes(size_t buf_size, size_t scalar_size) {
-  return ((~buf_size) + 1) & (scalar_size - 1);
-}
-
-// Generic 'operator==' with conditional specialisations.
-// T e - new value of a scalar field.
-// T def - default of scalar (is known at compile-time).
-template<typename T> inline bool IsTheSameAs(T e, T def) { return e == def; }
-
-#if defined(FLATBUFFERS_NAN_DEFAULTS) && \
-    defined(FLATBUFFERS_HAS_NEW_STRTOD) && (FLATBUFFERS_HAS_NEW_STRTOD > 0)
-// Like `operator==(e, def)` with weak NaN if T=(float|double).
-template<typename T> inline bool IsFloatTheSameAs(T e, T def) {
-  return (e == def) || ((def != def) && (e != e));
-}
-template<> inline bool IsTheSameAs<float>(float e, float def) {
-  return IsFloatTheSameAs(e, def);
-}
-template<> inline bool IsTheSameAs<double>(double e, double def) {
-  return IsFloatTheSameAs(e, def);
-}
-#endif
-
-// Check 'v' is out of closed range [low; high].
-// Workaround for GCC warning [-Werror=type-limits]:
-// comparison is always true due to limited range of data type.
-template<typename T>
-inline bool IsOutRange(const T &v, const T &low, const T &high) {
-  return (v < low) || (high < v);
-}
-
-// Check 'v' is in closed range [low; high].
-template<typename T>
-inline bool IsInRange(const T &v, const T &low, const T &high) {
-  return !IsOutRange(v, low, high);
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-#endif  // FLATBUFFERS_BASE_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/bfbs_generator.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/bfbs_generator.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/bfbs_generator.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/bfbs_generator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_BFBS_GENERATOR_H_
-#define FLATBUFFERS_BFBS_GENERATOR_H_
-
-#include <cstdint>
-
-namespace mapserver {
-namespace flatbuffers {
-
-enum GeneratorStatus {
-  OK,
-  FAILED,
-  FAILED_VERIFICATION,
-};
-
-// A Flatbuffer Code Generator that receives a binary serialized reflection.fbs
-// and generates code from it.
-class BfbsGenerator {
- public:
-  virtual ~BfbsGenerator() {}
-
-  // Generate code from the provided `buffer` of given `length`. The buffer is
-  // a serialized reflection.fbs.
-  virtual GeneratorStatus Generate(const uint8_t *buffer, int64_t length) = 0;
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_BFBS_GENERATOR_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/buffer.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/buffer.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/buffer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/buffer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,144 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_BUFFER_H_
-#define FLATBUFFERS_BUFFER_H_
-
-#include "flatbuffers/base.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Wrapper for uoffset_t to allow safe template specialization.
-// Value is allowed to be 0 to indicate a null object (see e.g. AddOffset).
-template<typename T> struct Offset {
-  uoffset_t o;
-  Offset() : o(0) {}
-  Offset(uoffset_t _o) : o(_o) {}
-  Offset<void> Union() const { return Offset<void>(o); }
-  bool IsNull() const { return !o; }
-};
-
-inline void EndianCheck() {
-  int endiantest = 1;
-  // If this fails, see FLATBUFFERS_LITTLEENDIAN above.
-  FLATBUFFERS_ASSERT(*reinterpret_cast<char *>(&endiantest) ==
-                     FLATBUFFERS_LITTLEENDIAN);
-  (void)endiantest;
-}
-
-template<typename T> FLATBUFFERS_CONSTEXPR size_t AlignOf() {
-  // clang-format off
-  #ifdef _MSC_VER
-    return __alignof(T);
-  #else
-    #ifndef alignof
-      return __alignof__(T);
-    #else
-      return alignof(T);
-    #endif
-  #endif
-  // clang-format on
-}
-
-// Lexicographically compare two strings (possibly containing nulls), and
-// return true if the first is less than the second.
-static inline bool StringLessThan(const char *a_data, uoffset_t a_size,
-                                  const char *b_data, uoffset_t b_size) {
-  const auto cmp = memcmp(a_data, b_data, (std::min)(a_size, b_size));
-  return cmp == 0 ? a_size < b_size : cmp < 0;
-}
-
-// When we read serialized data from memory, in the case of most scalars,
-// we want to just read T, but in the case of Offset, we want to actually
-// perform the indirection and return a pointer.
-// The template specialization below does just that.
-// It is wrapped in a struct since function templates can't overload on the
-// return type like this.
-// The typedef is for the convenience of callers of this function
-// (avoiding the need for a trailing return decltype)
-template<typename T> struct IndirectHelper {
-  typedef T return_type;
-  typedef T mutable_return_type;
-  static const size_t element_stride = sizeof(T);
-  static return_type Read(const uint8_t *p, uoffset_t i) {
-    return EndianScalar((reinterpret_cast<const T *>(p))[i]);
-  }
-};
-template<typename T> struct IndirectHelper<Offset<T>> {
-  typedef const T *return_type;
-  typedef T *mutable_return_type;
-  static const size_t element_stride = sizeof(uoffset_t);
-  static return_type Read(const uint8_t *p, uoffset_t i) {
-    p += i * sizeof(uoffset_t);
-    return reinterpret_cast<return_type>(p + ReadScalar<uoffset_t>(p));
-  }
-};
-template<typename T> struct IndirectHelper<const T *> {
-  typedef const T *return_type;
-  typedef T *mutable_return_type;
-  static const size_t element_stride = sizeof(T);
-  static return_type Read(const uint8_t *p, uoffset_t i) {
-    return reinterpret_cast<const T *>(p + i * sizeof(T));
-  }
-};
-
-/// @brief Get a pointer to the the file_identifier section of the buffer.
-/// @return Returns a const char pointer to the start of the file_identifier
-/// characters in the buffer.  The returned char * has length
-/// 'flatbuffers::FlatBufferBuilder::kFileIdentifierLength'.
-/// This function is UNDEFINED for FlatBuffers whose schema does not include
-/// a file_identifier (likely points at padding or the start of a the root
-/// vtable).
-inline const char *GetBufferIdentifier(const void *buf,
-                                       bool size_prefixed = false) {
-  return reinterpret_cast<const char *>(buf) +
-         ((size_prefixed) ? 2 * sizeof(uoffset_t) : sizeof(uoffset_t));
-}
-
-// Helper to see if the identifier in a buffer has the expected value.
-inline bool BufferHasIdentifier(const void *buf, const char *identifier,
-                                bool size_prefixed = false) {
-  return strncmp(GetBufferIdentifier(buf, size_prefixed), identifier,
-                 flatbuffers::kFileIdentifierLength) == 0;
-}
-
-/// @cond FLATBUFFERS_INTERNAL
-// Helpers to get a typed pointer to the root object contained in the buffer.
-template<typename T> T *GetMutableRoot(void *buf) {
-  EndianCheck();
-  return reinterpret_cast<T *>(
-      reinterpret_cast<uint8_t *>(buf) +
-      EndianScalar(*reinterpret_cast<uoffset_t *>(buf)));
-}
-
-template<typename T> T *GetMutableSizePrefixedRoot(void *buf) {
-  return GetMutableRoot<T>(reinterpret_cast<uint8_t *>(buf) +
-                           sizeof(uoffset_t));
-}
-
-template<typename T> const T *GetRoot(const void *buf) {
-  return GetMutableRoot<T>(const_cast<void *>(buf));
-}
-
-template<typename T> const T *GetSizePrefixedRoot(const void *buf) {
-  return GetRoot<T>(reinterpret_cast<const uint8_t *>(buf) + sizeof(uoffset_t));
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_BUFFER_H_
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/buffer_ref.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/buffer_ref.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/buffer_ref.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/buffer_ref.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_BUFFER_REF_H_
-#define FLATBUFFERS_BUFFER_REF_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/verifier.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Convenient way to bundle a buffer and its length, to pass it around
-// typed by its root.
-// A BufferRef does not own its buffer.
-struct BufferRefBase {};  // for std::is_base_of
-
-template<typename T> struct BufferRef : BufferRefBase {
-  BufferRef() : buf(nullptr), len(0), must_free(false) {}
-  BufferRef(uint8_t *_buf, uoffset_t _len)
-      : buf(_buf), len(_len), must_free(false) {}
-
-  ~BufferRef() {
-    if (must_free) free(buf);
-  }
-
-  const T *GetRoot() const { return flatbuffers::GetRoot<T>(buf); }
-
-  bool Verify() {
-    Verifier verifier(buf, len);
-    return verifier.VerifyBuffer<T>(nullptr);
-  }
-
-  uint8_t *buf;
-  uoffset_t len;
-  bool must_free;
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_BUFFER_REF_H_
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/code_generators.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/code_generators.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/code_generators.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/code_generators.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,235 +0,0 @@
-/*
- * Copyright 2014 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_CODE_GENERATORS_H_
-#define FLATBUFFERS_CODE_GENERATORS_H_
-
-#include <map>
-#include <sstream>
-
-#include "flatbuffers/idl.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Utility class to assist in generating code through use of text templates.
-//
-// Example code:
-//   CodeWriter code("\t");
-//   code.SetValue("NAME", "Foo");
-//   code += "void {{NAME}}() { printf("%s", "{{NAME}}"); }";
-//   code.SetValue("NAME", "Bar");
-//   code += "void {{NAME}}() { printf("%s", "{{NAME}}"); }";
-//   std::cout << code.ToString() << std::endl;
-//
-// Output:
-//  void Foo() { printf("%s", "Foo"); }
-//  void Bar() { printf("%s", "Bar"); }
-class CodeWriter {
- public:
-  CodeWriter(std::string pad = std::string())
-      : pad_(pad), cur_ident_lvl_(0), ignore_ident_(false) {}
-
-  // Clears the current "written" code.
-  void Clear() {
-    stream_.str("");
-    stream_.clear();
-  }
-
-  // Associates a key with a value.  All subsequent calls to operator+=, where
-  // the specified key is contained in {{ and }} delimiters will be replaced by
-  // the given value.
-  void SetValue(const std::string &key, const std::string &value) {
-    value_map_[key] = value;
-  }
-
-  std::string GetValue(const std::string &key) const {
-    const auto it = value_map_.find(key);
-    return it == value_map_.end() ? "" : it->second;
-  }
-
-  // Appends the given text to the generated code as well as a newline
-  // character.  Any text within {{ and }} delimiters is replaced by values
-  // previously stored in the CodeWriter by calling SetValue above.  The newline
-  // will be suppressed if the text ends with the \\ character.
-  void operator+=(std::string text);
-
-  // Returns the current contents of the CodeWriter as a std::string.
-  std::string ToString() const { return stream_.str(); }
-
-  // Increase ident level for writing code
-  void IncrementIdentLevel() { cur_ident_lvl_++; }
-  // Decrease ident level for writing code
-  void DecrementIdentLevel() {
-    if (cur_ident_lvl_) cur_ident_lvl_--;
-  }
-
-  void SetPadding(const std::string &padding) { pad_ = padding; }
-
- private:
-  std::map<std::string, std::string> value_map_;
-  std::stringstream stream_;
-  std::string pad_;
-  int cur_ident_lvl_;
-  bool ignore_ident_;
-
-  // Add ident padding (tab or space) based on ident level
-  void AppendIdent(std::stringstream &stream);
-};
-
-class BaseGenerator {
- public:
-  virtual bool generate() = 0;
-
-  static std::string NamespaceDir(const Parser &parser, const std::string &path,
-                                  const Namespace &ns,
-                                  const bool dasherize = false);
-
-  std::string GeneratedFileName(const std::string &path,
-                                const std::string &file_name,
-                                const IDLOptions &options) const;
-
- protected:
-  BaseGenerator(const Parser &parser, const std::string &path,
-                const std::string &file_name, std::string qualifying_start,
-                std::string qualifying_separator, std::string default_extension)
-      : parser_(parser),
-        path_(path),
-        file_name_(file_name),
-        qualifying_start_(qualifying_start),
-        qualifying_separator_(qualifying_separator),
-        default_extension_(default_extension) {}
-  virtual ~BaseGenerator() {}
-
-  // No copy/assign.
-  BaseGenerator &operator=(const BaseGenerator &);
-  BaseGenerator(const BaseGenerator &);
-
-  std::string NamespaceDir(const Namespace &ns,
-                           const bool dasherize = false) const;
-
-  static const char *FlatBuffersGeneratedWarning();
-
-  static std::string FullNamespace(const char *separator, const Namespace &ns);
-
-  static std::string LastNamespacePart(const Namespace &ns);
-
-  // tracks the current namespace for early exit in WrapInNameSpace
-  // c++, java and csharp returns a different namespace from
-  // the following default (no early exit, always fully qualify),
-  // which works for js and php
-  virtual const Namespace *CurrentNameSpace() const { return nullptr; }
-
-  // Ensure that a type is prefixed with its namespace even within
-  // its own namespace to avoid conflict between generated method
-  // names and similarly named classes or structs
-  std::string WrapInNameSpace(const Namespace *ns,
-                              const std::string &name) const;
-
-  std::string WrapInNameSpace(const Definition &def) const;
-
-  std::string GetNameSpace(const Definition &def) const;
-
-  const Parser &parser_;
-  const std::string &path_;
-  const std::string &file_name_;
-  const std::string qualifying_start_;
-  const std::string qualifying_separator_;
-  const std::string default_extension_;
-};
-
-struct CommentConfig {
-  const char *first_line;
-  const char *content_line_prefix;
-  const char *last_line;
-};
-
-extern void GenComment(const std::vector<std::string> &dc,
-                       std::string *code_ptr, const CommentConfig *config,
-                       const char *prefix = "");
-
-class FloatConstantGenerator {
- public:
-  virtual ~FloatConstantGenerator() {}
-  std::string GenFloatConstant(const FieldDef &field) const;
-
- private:
-  virtual std::string Value(double v, const std::string &src) const = 0;
-  virtual std::string Inf(double v) const = 0;
-  virtual std::string NaN(double v) const = 0;
-
-  virtual std::string Value(float v, const std::string &src) const = 0;
-  virtual std::string Inf(float v) const = 0;
-  virtual std::string NaN(float v) const = 0;
-
-  template<typename T>
-  std::string GenFloatConstantImpl(const FieldDef &field) const;
-};
-
-class SimpleFloatConstantGenerator : public FloatConstantGenerator {
- public:
-  SimpleFloatConstantGenerator(const char *nan_number,
-                               const char *pos_inf_number,
-                               const char *neg_inf_number);
-
- private:
-  std::string Value(double v,
-                    const std::string &src) const FLATBUFFERS_OVERRIDE;
-  std::string Inf(double v) const FLATBUFFERS_OVERRIDE;
-  std::string NaN(double v) const FLATBUFFERS_OVERRIDE;
-
-  std::string Value(float v, const std::string &src) const FLATBUFFERS_OVERRIDE;
-  std::string Inf(float v) const FLATBUFFERS_OVERRIDE;
-  std::string NaN(float v) const FLATBUFFERS_OVERRIDE;
-
-  const std::string nan_number_;
-  const std::string pos_inf_number_;
-  const std::string neg_inf_number_;
-};
-
-// C++, C#, Java like generator.
-class TypedFloatConstantGenerator : public FloatConstantGenerator {
- public:
-  TypedFloatConstantGenerator(const char *double_prefix,
-                              const char *single_prefix, const char *nan_number,
-                              const char *pos_inf_number,
-                              const char *neg_inf_number = "");
-
- private:
-  std::string Value(double v,
-                    const std::string &src) const FLATBUFFERS_OVERRIDE;
-  std::string Inf(double v) const FLATBUFFERS_OVERRIDE;
-
-  std::string NaN(double v) const FLATBUFFERS_OVERRIDE;
-
-  std::string Value(float v, const std::string &src) const FLATBUFFERS_OVERRIDE;
-  std::string Inf(float v) const FLATBUFFERS_OVERRIDE;
-  std::string NaN(float v) const FLATBUFFERS_OVERRIDE;
-
-  std::string MakeNaN(const std::string &prefix) const;
-  std::string MakeInf(bool neg, const std::string &prefix) const;
-
-  const std::string double_prefix_;
-  const std::string single_prefix_;
-  const std::string nan_number_;
-  const std::string pos_inf_number_;
-  const std::string neg_inf_number_;
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_CODE_GENERATORS_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/default_allocator.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/default_allocator.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/default_allocator.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/default_allocator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_DEFAULT_ALLOCATOR_H_
-#define FLATBUFFERS_DEFAULT_ALLOCATOR_H_
-
-#include "flatbuffers/allocator.h"
-#include "flatbuffers/base.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// DefaultAllocator uses new/delete to allocate memory regions
-class DefaultAllocator : public Allocator {
- public:
-  uint8_t *allocate(size_t size) FLATBUFFERS_OVERRIDE {
-    return new uint8_t[size];
-  }
-
-  void deallocate(uint8_t *p, size_t) FLATBUFFERS_OVERRIDE { delete[] p; }
-
-  static void dealloc(void *p, size_t) { delete[] static_cast<uint8_t *>(p); }
-};
-
-// These functions allow for a null allocator to mean use the default allocator,
-// as used by DetachedBuffer and vector_downward below.
-// This is to avoid having a statically or dynamically allocated default
-// allocator, or having to move it between the classes that may own it.
-inline uint8_t *Allocate(Allocator *allocator, size_t size) {
-  return allocator ? allocator->allocate(size)
-                   : DefaultAllocator().allocate(size);
-}
-
-inline void Deallocate(Allocator *allocator, uint8_t *p, size_t size) {
-  if (allocator)
-    allocator->deallocate(p, size);
-  else
-    DefaultAllocator().deallocate(p, size);
-}
-
-inline uint8_t *ReallocateDownward(Allocator *allocator, uint8_t *old_p,
-                                   size_t old_size, size_t new_size,
-                                   size_t in_use_back, size_t in_use_front) {
-  return allocator ? allocator->reallocate_downward(old_p, old_size, new_size,
-                                                    in_use_back, in_use_front)
-                   : DefaultAllocator().reallocate_downward(
-                         old_p, old_size, new_size, in_use_back, in_use_front);
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_DEFAULT_ALLOCATOR_H_
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/detached_buffer.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/detached_buffer.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/detached_buffer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/detached_buffer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,116 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_DETACHED_BUFFER_H_
-#define FLATBUFFERS_DETACHED_BUFFER_H_
-
-#include "flatbuffers/allocator.h"
-#include "flatbuffers/base.h"
-#include "flatbuffers/default_allocator.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// DetachedBuffer is a finished flatbuffer memory region, detached from its
-// builder. The original memory region and allocator are also stored so that
-// the DetachedBuffer can manage the memory lifetime.
-class DetachedBuffer {
- public:
-  DetachedBuffer()
-      : allocator_(nullptr),
-        own_allocator_(false),
-        buf_(nullptr),
-        reserved_(0),
-        cur_(nullptr),
-        size_(0) {}
-
-  DetachedBuffer(Allocator *allocator, bool own_allocator, uint8_t *buf,
-                 size_t reserved, uint8_t *cur, size_t sz)
-      : allocator_(allocator),
-        own_allocator_(own_allocator),
-        buf_(buf),
-        reserved_(reserved),
-        cur_(cur),
-        size_(sz) {}
-
-  DetachedBuffer(DetachedBuffer &&other)
-      : allocator_(other.allocator_),
-        own_allocator_(other.own_allocator_),
-        buf_(other.buf_),
-        reserved_(other.reserved_),
-        cur_(other.cur_),
-        size_(other.size_) {
-    other.reset();
-  }
-
-  DetachedBuffer &operator=(DetachedBuffer &&other) {
-    if (this == &other) return *this;
-
-    destroy();
-
-    allocator_ = other.allocator_;
-    own_allocator_ = other.own_allocator_;
-    buf_ = other.buf_;
-    reserved_ = other.reserved_;
-    cur_ = other.cur_;
-    size_ = other.size_;
-
-    other.reset();
-
-    return *this;
-  }
-
-  ~DetachedBuffer() { destroy(); }
-
-  const uint8_t *data() const { return cur_; }
-
-  uint8_t *data() { return cur_; }
-
-  size_t size() const { return size_; }
-
-  // These may change access mode, leave these at end of public section
-  FLATBUFFERS_DELETE_FUNC(DetachedBuffer(const DetachedBuffer &other));
-  FLATBUFFERS_DELETE_FUNC(
-      DetachedBuffer &operator=(const DetachedBuffer &other));
-
- protected:
-  Allocator *allocator_;
-  bool own_allocator_;
-  uint8_t *buf_;
-  size_t reserved_;
-  uint8_t *cur_;
-  size_t size_;
-
-  inline void destroy() {
-    if (buf_) Deallocate(allocator_, buf_, reserved_);
-    if (own_allocator_ && allocator_) { delete allocator_; }
-    reset();
-  }
-
-  inline void reset() {
-    allocator_ = nullptr;
-    own_allocator_ = false;
-    buf_ = nullptr;
-    reserved_ = 0;
-    cur_ = nullptr;
-    size_ = 0;
-  }
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_DETACHED_BUFFER_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/flatbuffer_builder.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flatbuffer_builder.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/flatbuffer_builder.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flatbuffer_builder.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1216 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_FLATBUFFER_BUILDER_H_
-#define FLATBUFFERS_FLATBUFFER_BUILDER_H_
-
-#include <functional>
-#include <initializer_list>
-
-#include "flatbuffers/allocator.h"
-#include "flatbuffers/array.h"
-#include "flatbuffers/base.h"
-#include "flatbuffers/buffer_ref.h"
-#include "flatbuffers/default_allocator.h"
-#include "flatbuffers/detached_buffer.h"
-#include "flatbuffers/stl_emulation.h"
-#include "flatbuffers/string.h"
-#include "flatbuffers/struct.h"
-#include "flatbuffers/table.h"
-#include "flatbuffers/vector.h"
-#include "flatbuffers/vector_downward.h"
-#include "flatbuffers/verifier.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Converts a Field ID to a virtual table offset.
-inline voffset_t FieldIndexToOffset(voffset_t field_id) {
-  // Should correspond to what EndTable() below builds up.
-  const int fixed_fields = 2;  // Vtable size and Object Size.
-  return static_cast<voffset_t>((field_id + fixed_fields) * sizeof(voffset_t));
-}
-
-template<typename T, typename Alloc = std::allocator<T>>
-const T *data(const std::vector<T, Alloc> &v) {
-  // Eventually the returned pointer gets passed down to memcpy, so
-  // we need it to be non-null to avoid undefined behavior.
-  static uint8_t t;
-  return v.empty() ? reinterpret_cast<const T *>(&t) : &v.front();
-}
-template<typename T, typename Alloc = std::allocator<T>>
-T *data(std::vector<T, Alloc> &v) {
-  // Eventually the returned pointer gets passed down to memcpy, so
-  // we need it to be non-null to avoid undefined behavior.
-  static uint8_t t;
-  return v.empty() ? reinterpret_cast<T *>(&t) : &v.front();
-}
-
-/// @addtogroup flatbuffers_cpp_api
-/// @{
-/// @class FlatBufferBuilder
-/// @brief Helper class to hold data needed in creation of a FlatBuffer.
-/// To serialize data, you typically call one of the `Create*()` functions in
-/// the generated code, which in turn call a sequence of `StartTable`/
-/// `PushElement`/`AddElement`/`EndTable`, or the builtin `CreateString`/
-/// `CreateVector` functions. Do this is depth-first order to build up a tree to
-/// the root. `Finish()` wraps up the buffer ready for transport.
-class FlatBufferBuilder {
- public:
-  /// @brief Default constructor for FlatBufferBuilder.
-  /// @param[in] initial_size The initial size of the buffer, in bytes. Defaults
-  /// to `1024`.
-  /// @param[in] allocator An `Allocator` to use. If null will use
-  /// `DefaultAllocator`.
-  /// @param[in] own_allocator Whether the builder/vector should own the
-  /// allocator. Defaults to / `false`.
-  /// @param[in] buffer_minalign Force the buffer to be aligned to the given
-  /// minimum alignment upon reallocation. Only needed if you intend to store
-  /// types with custom alignment AND you wish to read the buffer in-place
-  /// directly after creation.
-  explicit FlatBufferBuilder(
-      size_t initial_size = 1024, Allocator *allocator = nullptr,
-      bool own_allocator = false,
-      size_t buffer_minalign = AlignOf<largest_scalar_t>())
-      : buf_(initial_size, allocator, own_allocator, buffer_minalign),
-        num_field_loc(0),
-        max_voffset_(0),
-        nested(false),
-        finished(false),
-        minalign_(1),
-        force_defaults_(false),
-        dedup_vtables_(true),
-        string_pool(nullptr) {
-    EndianCheck();
-  }
-
-  /// @brief Move constructor for FlatBufferBuilder.
-  FlatBufferBuilder(FlatBufferBuilder &&other)
-      : buf_(1024, nullptr, false, AlignOf<largest_scalar_t>()),
-        num_field_loc(0),
-        max_voffset_(0),
-        nested(false),
-        finished(false),
-        minalign_(1),
-        force_defaults_(false),
-        dedup_vtables_(true),
-        string_pool(nullptr) {
-    EndianCheck();
-    // Default construct and swap idiom.
-    // Lack of delegating constructors in vs2010 makes it more verbose than
-    // needed.
-    Swap(other);
-  }
-
-  /// @brief Move assignment operator for FlatBufferBuilder.
-  FlatBufferBuilder &operator=(FlatBufferBuilder &&other) {
-    // Move construct a temporary and swap idiom
-    FlatBufferBuilder temp(std::move(other));
-    Swap(temp);
-    return *this;
-  }
-
-  void Swap(FlatBufferBuilder &other) {
-    using std::swap;
-    buf_.swap(other.buf_);
-    swap(num_field_loc, other.num_field_loc);
-    swap(max_voffset_, other.max_voffset_);
-    swap(nested, other.nested);
-    swap(finished, other.finished);
-    swap(minalign_, other.minalign_);
-    swap(force_defaults_, other.force_defaults_);
-    swap(dedup_vtables_, other.dedup_vtables_);
-    swap(string_pool, other.string_pool);
-  }
-
-  ~FlatBufferBuilder() {
-    if (string_pool) delete string_pool;
-  }
-
-  void Reset() {
-    Clear();       // clear builder state
-    buf_.reset();  // deallocate buffer
-  }
-
-  /// @brief Reset all the state in this FlatBufferBuilder so it can be reused
-  /// to construct another buffer.
-  void Clear() {
-    ClearOffsets();
-    buf_.clear();
-    nested = false;
-    finished = false;
-    minalign_ = 1;
-    if (string_pool) string_pool->clear();
-  }
-
-  /// @brief The current size of the serialized buffer, counting from the end.
-  /// @return Returns an `uoffset_t` with the current size of the buffer.
-  uoffset_t GetSize() const { return buf_.size(); }
-
-  /// @brief Get the serialized buffer (after you call `Finish()`).
-  /// @return Returns an `uint8_t` pointer to the FlatBuffer data inside the
-  /// buffer.
-  uint8_t *GetBufferPointer() const {
-    Finished();
-    return buf_.data();
-  }
-
-  /// @brief Get the serialized buffer (after you call `Finish()`) as a span.
-  /// @return Returns a constructed flatbuffers::span that is a view over the
-  /// FlatBuffer data inside the buffer.
-  flatbuffers::span<uint8_t> GetBufferSpan() const {
-    Finished();
-    return flatbuffers::span<uint8_t>(buf_.data(), buf_.size());
-  }
-
-  /// @brief Get a pointer to an unfinished buffer.
-  /// @return Returns a `uint8_t` pointer to the unfinished buffer.
-  uint8_t *GetCurrentBufferPointer() const { return buf_.data(); }
-
-  /// @brief Get the released pointer to the serialized buffer.
-  /// @warning Do NOT attempt to use this FlatBufferBuilder afterwards!
-  /// @return A `FlatBuffer` that owns the buffer and its allocator and
-  /// behaves similar to a `unique_ptr` with a deleter.
-  FLATBUFFERS_ATTRIBUTE([[deprecated("use Release() instead")]])
-  DetachedBuffer ReleaseBufferPointer() {
-    Finished();
-    return buf_.release();
-  }
-
-  /// @brief Get the released DetachedBuffer.
-  /// @return A `DetachedBuffer` that owns the buffer and its allocator.
-  DetachedBuffer Release() {
-    Finished();
-    return buf_.release();
-  }
-
-  /// @brief Get the released pointer to the serialized buffer.
-  /// @param size The size of the memory block containing
-  /// the serialized `FlatBuffer`.
-  /// @param offset The offset from the released pointer where the finished
-  /// `FlatBuffer` starts.
-  /// @return A raw pointer to the start of the memory block containing
-  /// the serialized `FlatBuffer`.
-  /// @remark If the allocator is owned, it gets deleted when the destructor is
-  /// called..
-  uint8_t *ReleaseRaw(size_t &size, size_t &offset) {
-    Finished();
-    return buf_.release_raw(size, offset);
-  }
-
-  /// @brief get the minimum alignment this buffer needs to be accessed
-  /// properly. This is only known once all elements have been written (after
-  /// you call Finish()). You can use this information if you need to embed
-  /// a FlatBuffer in some other buffer, such that you can later read it
-  /// without first having to copy it into its own buffer.
-  size_t GetBufferMinAlignment() const {
-    Finished();
-    return minalign_;
-  }
-
-  /// @cond FLATBUFFERS_INTERNAL
-  void Finished() const {
-    // If you get this assert, you're attempting to get access a buffer
-    // which hasn't been finished yet. Be sure to call
-    // FlatBufferBuilder::Finish with your root table.
-    // If you really need to access an unfinished buffer, call
-    // GetCurrentBufferPointer instead.
-    FLATBUFFERS_ASSERT(finished);
-  }
-  /// @endcond
-
-  /// @brief In order to save space, fields that are set to their default value
-  /// don't get serialized into the buffer.
-  /// @param[in] fd When set to `true`, always serializes default values that
-  /// are set. Optional fields which are not set explicitly, will still not be
-  /// serialized.
-  void ForceDefaults(bool fd) { force_defaults_ = fd; }
-
-  /// @brief By default vtables are deduped in order to save space.
-  /// @param[in] dedup When set to `true`, dedup vtables.
-  void DedupVtables(bool dedup) { dedup_vtables_ = dedup; }
-
-  /// @cond FLATBUFFERS_INTERNAL
-  void Pad(size_t num_bytes) { buf_.fill(num_bytes); }
-
-  void TrackMinAlign(size_t elem_size) {
-    if (elem_size > minalign_) minalign_ = elem_size;
-  }
-
-  void Align(size_t elem_size) {
-    TrackMinAlign(elem_size);
-    buf_.fill(PaddingBytes(buf_.size(), elem_size));
-  }
-
-  void PushFlatBuffer(const uint8_t *bytes, size_t size) {
-    PushBytes(bytes, size);
-    finished = true;
-  }
-
-  void PushBytes(const uint8_t *bytes, size_t size) { buf_.push(bytes, size); }
-
-  void PopBytes(size_t amount) { buf_.pop(amount); }
-
-  template<typename T> void AssertScalarT() {
-    // The code assumes power of 2 sizes and endian-swap-ability.
-    static_assert(flatbuffers::is_scalar<T>::value, "T must be a scalar type");
-  }
-
-  // Write a single aligned scalar to the buffer
-  template<typename T> uoffset_t PushElement(T element) {
-    AssertScalarT<T>();
-    Align(sizeof(T));
-    buf_.push_small(EndianScalar(element));
-    return GetSize();
-  }
-
-  template<typename T> uoffset_t PushElement(Offset<T> off) {
-    // Special case for offsets: see ReferTo below.
-    return PushElement(ReferTo(off.o));
-  }
-
-  // When writing fields, we track where they are, so we can create correct
-  // vtables later.
-  void TrackField(voffset_t field, uoffset_t off) {
-    FieldLoc fl = { off, field };
-    buf_.scratch_push_small(fl);
-    num_field_loc++;
-    if (field > max_voffset_) { max_voffset_ = field; }
-  }
-
-  // Like PushElement, but additionally tracks the field this represents.
-  template<typename T> void AddElement(voffset_t field, T e, T def) {
-    // We don't serialize values equal to the default.
-    if (IsTheSameAs(e, def) && !force_defaults_) return;
-    TrackField(field, PushElement(e));
-  }
-
-  template<typename T> void AddElement(voffset_t field, T e) {
-    TrackField(field, PushElement(e));
-  }
-
-  template<typename T> void AddOffset(voffset_t field, Offset<T> off) {
-    if (off.IsNull()) return;  // Don't store.
-    AddElement(field, ReferTo(off.o), static_cast<uoffset_t>(0));
-  }
-
-  template<typename T> void AddStruct(voffset_t field, const T *structptr) {
-    if (!structptr) return;  // Default, don't store.
-    Align(AlignOf<T>());
-    buf_.push_small(*structptr);
-    TrackField(field, GetSize());
-  }
-
-  void AddStructOffset(voffset_t field, uoffset_t off) {
-    TrackField(field, off);
-  }
-
-  // Offsets initially are relative to the end of the buffer (downwards).
-  // This function converts them to be relative to the current location
-  // in the buffer (when stored here), pointing upwards.
-  uoffset_t ReferTo(uoffset_t off) {
-    // Align to ensure GetSize() below is correct.
-    Align(sizeof(uoffset_t));
-    // Offset must refer to something already in buffer.
-    const uoffset_t size = GetSize();
-    FLATBUFFERS_ASSERT(off && off <= size);
-    return size - off + static_cast<uoffset_t>(sizeof(uoffset_t));
-  }
-
-  void NotNested() {
-    // If you hit this, you're trying to construct a Table/Vector/String
-    // during the construction of its parent table (between the MyTableBuilder
-    // and table.Finish().
-    // Move the creation of these sub-objects to above the MyTableBuilder to
-    // not get this assert.
-    // Ignoring this assert may appear to work in simple cases, but the reason
-    // it is here is that storing objects in-line may cause vtable offsets
-    // to not fit anymore. It also leads to vtable duplication.
-    FLATBUFFERS_ASSERT(!nested);
-    // If you hit this, fields were added outside the scope of a table.
-    FLATBUFFERS_ASSERT(!num_field_loc);
-  }
-
-  // From generated code (or from the parser), we call StartTable/EndTable
-  // with a sequence of AddElement calls in between.
-  uoffset_t StartTable() {
-    NotNested();
-    nested = true;
-    return GetSize();
-  }
-
-  // This finishes one serialized object by generating the vtable if it's a
-  // table, comparing it against existing vtables, and writing the
-  // resulting vtable offset.
-  uoffset_t EndTable(uoffset_t start) {
-    // If you get this assert, a corresponding StartTable wasn't called.
-    FLATBUFFERS_ASSERT(nested);
-    // Write the vtable offset, which is the start of any Table.
-    // We fill it's value later.
-    auto vtableoffsetloc = PushElement<soffset_t>(0);
-    // Write a vtable, which consists entirely of voffset_t elements.
-    // It starts with the number of offsets, followed by a type id, followed
-    // by the offsets themselves. In reverse:
-    // Include space for the last offset and ensure empty tables have a
-    // minimum size.
-    max_voffset_ =
-        (std::max)(static_cast<voffset_t>(max_voffset_ + sizeof(voffset_t)),
-                   FieldIndexToOffset(0));
-    buf_.fill_big(max_voffset_);
-    auto table_object_size = vtableoffsetloc - start;
-    // Vtable use 16bit offsets.
-    FLATBUFFERS_ASSERT(table_object_size < 0x10000);
-    WriteScalar<voffset_t>(buf_.data() + sizeof(voffset_t),
-                           static_cast<voffset_t>(table_object_size));
-    WriteScalar<voffset_t>(buf_.data(), max_voffset_);
-    // Write the offsets into the table
-    for (auto it = buf_.scratch_end() - num_field_loc * sizeof(FieldLoc);
-         it < buf_.scratch_end(); it += sizeof(FieldLoc)) {
-      auto field_location = reinterpret_cast<FieldLoc *>(it);
-      auto pos = static_cast<voffset_t>(vtableoffsetloc - field_location->off);
-      // If this asserts, it means you've set a field twice.
-      FLATBUFFERS_ASSERT(
-          !ReadScalar<voffset_t>(buf_.data() + field_location->id));
-      WriteScalar<voffset_t>(buf_.data() + field_location->id, pos);
-    }
-    ClearOffsets();
-    auto vt1 = reinterpret_cast<voffset_t *>(buf_.data());
-    auto vt1_size = ReadScalar<voffset_t>(vt1);
-    auto vt_use = GetSize();
-    // See if we already have generated a vtable with this exact same
-    // layout before. If so, make it point to the old one, remove this one.
-    if (dedup_vtables_) {
-      for (auto it = buf_.scratch_data(); it < buf_.scratch_end();
-           it += sizeof(uoffset_t)) {
-        auto vt_offset_ptr = reinterpret_cast<uoffset_t *>(it);
-        auto vt2 = reinterpret_cast<voffset_t *>(buf_.data_at(*vt_offset_ptr));
-        auto vt2_size = ReadScalar<voffset_t>(vt2);
-        if (vt1_size != vt2_size || 0 != memcmp(vt2, vt1, vt1_size)) continue;
-        vt_use = *vt_offset_ptr;
-        buf_.pop(GetSize() - vtableoffsetloc);
-        break;
-      }
-    }
-    // If this is a new vtable, remember it.
-    if (vt_use == GetSize()) { buf_.scratch_push_small(vt_use); }
-    // Fill the vtable offset we created above.
-    // The offset points from the beginning of the object to where the
-    // vtable is stored.
-    // Offsets default direction is downward in memory for future format
-    // flexibility (storing all vtables at the start of the file).
-    WriteScalar(buf_.data_at(vtableoffsetloc),
-                static_cast<soffset_t>(vt_use) -
-                    static_cast<soffset_t>(vtableoffsetloc));
-
-    nested = false;
-    return vtableoffsetloc;
-  }
-
-  FLATBUFFERS_ATTRIBUTE([[deprecated("call the version above instead")]])
-  uoffset_t EndTable(uoffset_t start, voffset_t /*numfields*/) {
-    return EndTable(start);
-  }
-
-  // This checks a required field has been set in a given table that has
-  // just been constructed.
-  template<typename T> void Required(Offset<T> table, voffset_t field);
-
-  uoffset_t StartStruct(size_t alignment) {
-    Align(alignment);
-    return GetSize();
-  }
-
-  uoffset_t EndStruct() { return GetSize(); }
-
-  void ClearOffsets() {
-    buf_.scratch_pop(num_field_loc * sizeof(FieldLoc));
-    num_field_loc = 0;
-    max_voffset_ = 0;
-  }
-
-  // Aligns such that when "len" bytes are written, an object can be written
-  // after it with "alignment" without padding.
-  void PreAlign(size_t len, size_t alignment) {
-    if (len == 0) return;
-    TrackMinAlign(alignment);
-    buf_.fill(PaddingBytes(GetSize() + len, alignment));
-  }
-  template<typename T> void PreAlign(size_t len) {
-    AssertScalarT<T>();
-    PreAlign(len, sizeof(T));
-  }
-  /// @endcond
-
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// @param[in] str A const char pointer to the data to be stored as a string.
-  /// @param[in] len The number of bytes that should be stored from `str`.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateString(const char *str, size_t len) {
-    NotNested();
-    PreAlign<uoffset_t>(len + 1);  // Always 0-terminated.
-    buf_.fill(1);
-    PushBytes(reinterpret_cast<const uint8_t *>(str), len);
-    PushElement(static_cast<uoffset_t>(len));
-    return Offset<String>(GetSize());
-  }
-
-  /// @brief Store a string in the buffer, which is null-terminated.
-  /// @param[in] str A const char pointer to a C-string to add to the buffer.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateString(const char *str) {
-    return CreateString(str, strlen(str));
-  }
-
-  /// @brief Store a string in the buffer, which is null-terminated.
-  /// @param[in] str A char pointer to a C-string to add to the buffer.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateString(char *str) {
-    return CreateString(str, strlen(str));
-  }
-
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// @param[in] str A const reference to a std::string to store in the buffer.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateString(const std::string &str) {
-    return CreateString(str.c_str(), str.length());
-  }
-
-  // clang-format off
-  #ifdef FLATBUFFERS_HAS_STRING_VIEW
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// @param[in] str A const string_view to copy in to the buffer.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateString(flatbuffers::string_view str) {
-    return CreateString(str.data(), str.size());
-  }
-  #endif // FLATBUFFERS_HAS_STRING_VIEW
-  // clang-format on
-
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// @param[in] str A const pointer to a `String` struct to add to the buffer.
-  /// @return Returns the offset in the buffer where the string starts
-  Offset<String> CreateString(const String *str) {
-    return str ? CreateString(str->c_str(), str->size()) : 0;
-  }
-
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// @param[in] str A const reference to a std::string like type with support
-  /// of T::c_str() and T::length() to store in the buffer.
-  /// @return Returns the offset in the buffer where the string starts.
-  template<typename T> Offset<String> CreateString(const T &str) {
-    return CreateString(str.c_str(), str.length());
-  }
-
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// If a string with this exact contents has already been serialized before,
-  /// instead simply returns the offset of the existing string. This uses a map
-  /// stored on the heap, but only stores the numerical offsets.
-  /// @param[in] str A const char pointer to the data to be stored as a string.
-  /// @param[in] len The number of bytes that should be stored from `str`.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateSharedString(const char *str, size_t len) {
-    FLATBUFFERS_ASSERT(FLATBUFFERS_GENERAL_HEAP_ALLOC_OK);
-    if (!string_pool)
-      string_pool = new StringOffsetMap(StringOffsetCompare(buf_));
-    auto size_before_string = buf_.size();
-    // Must first serialize the string, since the set is all offsets into
-    // buffer.
-    auto off = CreateString(str, len);
-    auto it = string_pool->find(off);
-    // If it exists we reuse existing serialized data!
-    if (it != string_pool->end()) {
-      // We can remove the string we serialized.
-      buf_.pop(buf_.size() - size_before_string);
-      return *it;
-    }
-    // Record this string for future use.
-    string_pool->insert(off);
-    return off;
-  }
-
-#ifdef FLATBUFFERS_HAS_STRING_VIEW
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// If a string with this exact contents has already been serialized before,
-  /// instead simply returns the offset of the existing string. This uses a map
-  /// stored on the heap, but only stores the numerical offsets.
-  /// @param[in] str A const std::string_view to store in the buffer.
-  /// @return Returns the offset in the buffer where the string starts
-  Offset<String> CreateSharedString(const flatbuffers::string_view str) {
-    return CreateSharedString(str.data(), str.size());
-  }
-#else
-  /// @brief Store a string in the buffer, which null-terminated.
-  /// If a string with this exact contents has already been serialized before,
-  /// instead simply returns the offset of the existing string. This uses a map
-  /// stored on the heap, but only stores the numerical offsets.
-  /// @param[in] str A const char pointer to a C-string to add to the buffer.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateSharedString(const char *str) {
-    return CreateSharedString(str, strlen(str));
-  }
-
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// If a string with this exact contents has already been serialized before,
-  /// instead simply returns the offset of the existing string. This uses a map
-  /// stored on the heap, but only stores the numerical offsets.
-  /// @param[in] str A const reference to a std::string to store in the buffer.
-  /// @return Returns the offset in the buffer where the string starts.
-  Offset<String> CreateSharedString(const std::string &str) {
-    return CreateSharedString(str.c_str(), str.length());
-  }
-#endif
-
-  /// @brief Store a string in the buffer, which can contain any binary data.
-  /// If a string with this exact contents has already been serialized before,
-  /// instead simply returns the offset of the existing string. This uses a map
-  /// stored on the heap, but only stores the numerical offsets.
-  /// @param[in] str A const pointer to a `String` struct to add to the buffer.
-  /// @return Returns the offset in the buffer where the string starts
-  Offset<String> CreateSharedString(const String *str) {
-    return CreateSharedString(str->c_str(), str->size());
-  }
-
-  /// @cond FLATBUFFERS_INTERNAL
-  uoffset_t EndVector(size_t len) {
-    FLATBUFFERS_ASSERT(nested);  // Hit if no corresponding StartVector.
-    nested = false;
-    return PushElement(static_cast<uoffset_t>(len));
-  }
-
-  void StartVector(size_t len, size_t elemsize) {
-    NotNested();
-    nested = true;
-    PreAlign<uoffset_t>(len * elemsize);
-    PreAlign(len * elemsize, elemsize);  // Just in case elemsize > uoffset_t.
-  }
-
-  // Call this right before StartVector/CreateVector if you want to force the
-  // alignment to be something different than what the element size would
-  // normally dictate.
-  // This is useful when storing a nested_flatbuffer in a vector of bytes,
-  // or when storing SIMD floats, etc.
-  void ForceVectorAlignment(size_t len, size_t elemsize, size_t alignment) {
-    if (len == 0) return;
-    FLATBUFFERS_ASSERT(VerifyAlignmentRequirements(alignment));
-    PreAlign(len * elemsize, alignment);
-  }
-
-  // Similar to ForceVectorAlignment but for String fields.
-  void ForceStringAlignment(size_t len, size_t alignment) {
-    if (len == 0) return;
-    FLATBUFFERS_ASSERT(VerifyAlignmentRequirements(alignment));
-    PreAlign((len + 1) * sizeof(char), alignment);
-  }
-
-  /// @endcond
-
-  /// @brief Serialize an array into a FlatBuffer `vector`.
-  /// @tparam T The data type of the array elements.
-  /// @param[in] v A pointer to the array of type `T` to serialize into the
-  /// buffer as a `vector`.
-  /// @param[in] len The number of elements to serialize.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T> Offset<Vector<T>> CreateVector(const T *v, size_t len) {
-    // If this assert hits, you're specifying a template argument that is
-    // causing the wrong overload to be selected, remove it.
-    AssertScalarT<T>();
-    StartVector(len, sizeof(T));
-    if (len == 0) { return Offset<Vector<T>>(EndVector(len)); }
-    // clang-format off
-    #if FLATBUFFERS_LITTLEENDIAN
-      PushBytes(reinterpret_cast<const uint8_t *>(v), len * sizeof(T));
-    #else
-      if (sizeof(T) == 1) {
-        PushBytes(reinterpret_cast<const uint8_t *>(v), len);
-      } else {
-        for (auto i = len; i > 0; ) {
-          PushElement(v[--i]);
-        }
-      }
-    #endif
-    // clang-format on
-    return Offset<Vector<T>>(EndVector(len));
-  }
-
-  /// @brief Serialize an array like object into a FlatBuffer `vector`.
-  /// @tparam T The data type of the array elements.
-  /// @tparam C The type of the array.
-  /// @param[in] array A reference to an array like object of type `T` to
-  /// serialize into the buffer as a `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, class C> Offset<Vector<T>> CreateVector(const C &array) {
-    return CreateVector(array.data(), array.size());
-  }
-
-  /// @brief Serialize an initializer list into a FlatBuffer `vector`.
-  /// @tparam T The data type of the initializer list elements.
-  /// @param[in] v The value of the initializer list.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T>
-  Offset<Vector<T>> CreateVector(std::initializer_list<T> v) {
-    return CreateVector(v.begin(), v.size());
-  }
-
-  template<typename T>
-  Offset<Vector<Offset<T>>> CreateVector(const Offset<T> *v, size_t len) {
-    StartVector(len, sizeof(Offset<T>));
-    for (auto i = len; i > 0;) { PushElement(v[--i]); }
-    return Offset<Vector<Offset<T>>>(EndVector(len));
-  }
-
-  /// @brief Serialize a `std::vector` into a FlatBuffer `vector`.
-  /// @tparam T The data type of the `std::vector` elements.
-  /// @param v A const reference to the `std::vector` to serialize into the
-  /// buffer as a `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename Alloc = std::allocator<T>>
-  Offset<Vector<T>> CreateVector(const std::vector<T, Alloc> &v) {
-    return CreateVector(data(v), v.size());
-  }
-
-  // vector<bool> may be implemented using a bit-set, so we can't access it as
-  // an array. Instead, read elements manually.
-  // Background: https://isocpp.org/blog/2012/11/on-vectorbool
-  Offset<Vector<uint8_t>> CreateVector(const std::vector<bool> &v) {
-    StartVector(v.size(), sizeof(uint8_t));
-    for (auto i = v.size(); i > 0;) {
-      PushElement(static_cast<uint8_t>(v[--i]));
-    }
-    return Offset<Vector<uint8_t>>(EndVector(v.size()));
-  }
-
-  /// @brief Serialize values returned by a function into a FlatBuffer `vector`.
-  /// This is a convenience function that takes care of iteration for you.
-  /// @tparam T The data type of the `std::vector` elements.
-  /// @param f A function that takes the current iteration 0..vector_size-1 and
-  /// returns any type that you can construct a FlatBuffers vector out of.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T>
-  Offset<Vector<T>> CreateVector(size_t vector_size,
-                                 const std::function<T(size_t i)> &f) {
-    FLATBUFFERS_ASSERT(FLATBUFFERS_GENERAL_HEAP_ALLOC_OK);
-    std::vector<T> elems(vector_size);
-    for (size_t i = 0; i < vector_size; i++) elems[i] = f(i);
-    return CreateVector(elems);
-  }
-
-  /// @brief Serialize values returned by a function into a FlatBuffer `vector`.
-  /// This is a convenience function that takes care of iteration for you. This
-  /// uses a vector stored on the heap to store the intermediate results of the
-  /// iteration.
-  /// @tparam T The data type of the `std::vector` elements.
-  /// @param f A function that takes the current iteration 0..vector_size-1,
-  /// and the state parameter returning any type that you can construct a
-  /// FlatBuffers vector out of.
-  /// @param state State passed to f.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename F, typename S>
-  Offset<Vector<T>> CreateVector(size_t vector_size, F f, S *state) {
-    FLATBUFFERS_ASSERT(FLATBUFFERS_GENERAL_HEAP_ALLOC_OK);
-    std::vector<T> elems(vector_size);
-    for (size_t i = 0; i < vector_size; i++) elems[i] = f(i, state);
-    return CreateVector(elems);
-  }
-
-  /// @brief Serialize a `std::vector<StringType>` into a FlatBuffer `vector`.
-  /// whereas StringType is any type that is accepted by the CreateString()
-  /// overloads.
-  /// This is a convenience function for a common case.
-  /// @param v A const reference to the `std::vector` to serialize into the
-  /// buffer as a `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename StringType = std::string,
-           typename Alloc = std::allocator<StringType>>
-  Offset<Vector<Offset<String>>> CreateVectorOfStrings(
-      const std::vector<StringType, Alloc> &v) {
-    return CreateVectorOfStrings(v.cbegin(), v.cend());
-  }
-
-  /// @brief Serialize a collection of Strings into a FlatBuffer `vector`.
-  /// This is a convenience function for a common case.
-  /// @param begin The begining iterator of the collection
-  /// @param end The ending iterator of the collection
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<class It>
-  Offset<Vector<Offset<String>>> CreateVectorOfStrings(It begin, It end) {
-    auto size = std::distance(begin, end);
-    auto scratch_buffer_usage = size * sizeof(Offset<String>);
-    // If there is not enough space to store the offsets, there definitely won't
-    // be enough space to store all the strings. So ensuring space for the
-    // scratch region is OK, for it it fails, it would have failed later.
-    buf_.ensure_space(scratch_buffer_usage);
-    for (auto it = begin; it != end; ++it) {
-      buf_.scratch_push_small(CreateString(*it));
-    }
-    StartVector(size, sizeof(Offset<String>));
-    for (auto i = 1; i <= size; i++) {
-      // Note we re-evaluate the buf location each iteration to account for any
-      // underlying buffer resizing that may occur.
-      PushElement(*reinterpret_cast<Offset<String> *>(
-          buf_.scratch_end() - i * sizeof(Offset<String>)));
-    }
-    buf_.scratch_pop(scratch_buffer_usage);
-    return Offset<Vector<Offset<String>>>(EndVector(size));
-  }
-
-  /// @brief Serialize an array of structs into a FlatBuffer `vector`.
-  /// @tparam T The data type of the struct array elements.
-  /// @param[in] v A pointer to the array of type `T` to serialize into the
-  /// buffer as a `vector`.
-  /// @param[in] len The number of elements to serialize.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T>
-  Offset<Vector<const T *>> CreateVectorOfStructs(const T *v, size_t len) {
-    StartVector(len * sizeof(T) / AlignOf<T>(), AlignOf<T>());
-    if (len > 0) {
-      PushBytes(reinterpret_cast<const uint8_t *>(v), sizeof(T) * len);
-    }
-    return Offset<Vector<const T *>>(EndVector(len));
-  }
-
-  /// @brief Serialize an array of native structs into a FlatBuffer `vector`.
-  /// @tparam T The data type of the struct array elements.
-  /// @tparam S The data type of the native struct array elements.
-  /// @param[in] v A pointer to the array of type `S` to serialize into the
-  /// buffer as a `vector`.
-  /// @param[in] len The number of elements to serialize.
-  /// @param[in] pack_func Pointer to a function to convert the native struct
-  /// to the FlatBuffer struct.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename S>
-  Offset<Vector<const T *>> CreateVectorOfNativeStructs(
-      const S *v, size_t len, T (*const pack_func)(const S &)) {
-    FLATBUFFERS_ASSERT(pack_func);
-    auto structs = StartVectorOfStructs<T>(len);
-    for (size_t i = 0; i < len; i++) { structs[i] = pack_func(v[i]); }
-    return EndVectorOfStructs<T>(len);
-  }
-
-  /// @brief Serialize an array of native structs into a FlatBuffer `vector`.
-  /// @tparam T The data type of the struct array elements.
-  /// @tparam S The data type of the native struct array elements.
-  /// @param[in] v A pointer to the array of type `S` to serialize into the
-  /// buffer as a `vector`.
-  /// @param[in] len The number of elements to serialize.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename S>
-  Offset<Vector<const T *>> CreateVectorOfNativeStructs(const S *v,
-                                                        size_t len) {
-    extern T Pack(const S &);
-    return CreateVectorOfNativeStructs(v, len, Pack);
-  }
-
-  /// @brief Serialize an array of structs into a FlatBuffer `vector`.
-  /// @tparam T The data type of the struct array elements.
-  /// @param[in] filler A function that takes the current iteration
-  /// 0..vector_size-1 and a pointer to the struct that must be filled.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  /// This is mostly useful when flatbuffers are generated with mutation
-  /// accessors.
-  template<typename T>
-  Offset<Vector<const T *>> CreateVectorOfStructs(
-      size_t vector_size, const std::function<void(size_t i, T *)> &filler) {
-    T *structs = StartVectorOfStructs<T>(vector_size);
-    for (size_t i = 0; i < vector_size; i++) {
-      filler(i, structs);
-      structs++;
-    }
-    return EndVectorOfStructs<T>(vector_size);
-  }
-
-  /// @brief Serialize an array of structs into a FlatBuffer `vector`.
-  /// @tparam T The data type of the struct array elements.
-  /// @param[in] f A function that takes the current iteration 0..vector_size-1,
-  /// a pointer to the struct that must be filled and the state argument.
-  /// @param[in] state Arbitrary state to pass to f.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  /// This is mostly useful when flatbuffers are generated with mutation
-  /// accessors.
-  template<typename T, typename F, typename S>
-  Offset<Vector<const T *>> CreateVectorOfStructs(size_t vector_size, F f,
-                                                  S *state) {
-    T *structs = StartVectorOfStructs<T>(vector_size);
-    for (size_t i = 0; i < vector_size; i++) {
-      f(i, structs, state);
-      structs++;
-    }
-    return EndVectorOfStructs<T>(vector_size);
-  }
-
-  /// @brief Serialize a `std::vector` of structs into a FlatBuffer `vector`.
-  /// @tparam T The data type of the `std::vector` struct elements.
-  /// @param[in] v A const reference to the `std::vector` of structs to
-  /// serialize into the buffer as a `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename Alloc = std::allocator<T>>
-  Offset<Vector<const T *>> CreateVectorOfStructs(
-      const std::vector<T, Alloc> &v) {
-    return CreateVectorOfStructs(data(v), v.size());
-  }
-
-  /// @brief Serialize a `std::vector` of native structs into a FlatBuffer
-  /// `vector`.
-  /// @tparam T The data type of the `std::vector` struct elements.
-  /// @tparam S The data type of the `std::vector` native struct elements.
-  /// @param[in] v A const reference to the `std::vector` of structs to
-  /// serialize into the buffer as a `vector`.
-  /// @param[in] pack_func Pointer to a function to convert the native struct
-  /// to the FlatBuffer struct.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename S, typename Alloc = std::allocator<T>>
-  Offset<Vector<const T *>> CreateVectorOfNativeStructs(
-      const std::vector<S, Alloc> &v, T (*const pack_func)(const S &)) {
-    return CreateVectorOfNativeStructs<T, S>(data(v), v.size(), pack_func);
-  }
-
-  /// @brief Serialize a `std::vector` of native structs into a FlatBuffer
-  /// `vector`.
-  /// @tparam T The data type of the `std::vector` struct elements.
-  /// @tparam S The data type of the `std::vector` native struct elements.
-  /// @param[in] v A const reference to the `std::vector` of structs to
-  /// serialize into the buffer as a `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename S, typename Alloc = std::allocator<S>>
-  Offset<Vector<const T *>> CreateVectorOfNativeStructs(
-      const std::vector<S, Alloc> &v) {
-    return CreateVectorOfNativeStructs<T, S>(data(v), v.size());
-  }
-
-  /// @cond FLATBUFFERS_INTERNAL
-  template<typename T> struct StructKeyComparator {
-    bool operator()(const T &a, const T &b) const {
-      return a.KeyCompareLessThan(&b);
-    }
-  };
-  /// @endcond
-
-  /// @brief Serialize a `std::vector` of structs into a FlatBuffer `vector`
-  /// in sorted order.
-  /// @tparam T The data type of the `std::vector` struct elements.
-  /// @param[in] v A const reference to the `std::vector` of structs to
-  /// serialize into the buffer as a `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename Alloc = std::allocator<T>>
-  Offset<Vector<const T *>> CreateVectorOfSortedStructs(
-      std::vector<T, Alloc> *v) {
-    return CreateVectorOfSortedStructs(data(*v), v->size());
-  }
-
-  /// @brief Serialize a `std::vector` of native structs into a FlatBuffer
-  /// `vector` in sorted order.
-  /// @tparam T The data type of the `std::vector` struct elements.
-  /// @tparam S The data type of the `std::vector` native struct elements.
-  /// @param[in] v A const reference to the `std::vector` of structs to
-  /// serialize into the buffer as a `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename S, typename Alloc = std::allocator<T>>
-  Offset<Vector<const T *>> CreateVectorOfSortedNativeStructs(
-      std::vector<S, Alloc> *v) {
-    return CreateVectorOfSortedNativeStructs<T, S>(data(*v), v->size());
-  }
-
-  /// @brief Serialize an array of structs into a FlatBuffer `vector` in sorted
-  /// order.
-  /// @tparam T The data type of the struct array elements.
-  /// @param[in] v A pointer to the array of type `T` to serialize into the
-  /// buffer as a `vector`.
-  /// @param[in] len The number of elements to serialize.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T>
-  Offset<Vector<const T *>> CreateVectorOfSortedStructs(T *v, size_t len) {
-    std::stable_sort(v, v + len, StructKeyComparator<T>());
-    return CreateVectorOfStructs(v, len);
-  }
-
-  /// @brief Serialize an array of native structs into a FlatBuffer `vector` in
-  /// sorted order.
-  /// @tparam T The data type of the struct array elements.
-  /// @tparam S The data type of the native struct array elements.
-  /// @param[in] v A pointer to the array of type `S` to serialize into the
-  /// buffer as a `vector`.
-  /// @param[in] len The number of elements to serialize.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename S>
-  Offset<Vector<const T *>> CreateVectorOfSortedNativeStructs(S *v,
-                                                              size_t len) {
-    extern T Pack(const S &);
-    auto structs = StartVectorOfStructs<T>(len);
-    for (size_t i = 0; i < len; i++) { structs[i] = Pack(v[i]); }
-    std::stable_sort(structs, structs + len, StructKeyComparator<T>());
-    return EndVectorOfStructs<T>(len);
-  }
-
-  /// @cond FLATBUFFERS_INTERNAL
-  template<typename T> struct TableKeyComparator {
-    TableKeyComparator(vector_downward &buf) : buf_(buf) {}
-    TableKeyComparator(const TableKeyComparator &other) : buf_(other.buf_) {}
-    bool operator()(const Offset<T> &a, const Offset<T> &b) const {
-      auto table_a = reinterpret_cast<T *>(buf_.data_at(a.o));
-      auto table_b = reinterpret_cast<T *>(buf_.data_at(b.o));
-      return table_a->KeyCompareLessThan(table_b);
-    }
-    vector_downward &buf_;
-
-   private:
-    FLATBUFFERS_DELETE_FUNC(
-        TableKeyComparator &operator=(const TableKeyComparator &other));
-  };
-  /// @endcond
-
-  /// @brief Serialize an array of `table` offsets as a `vector` in the buffer
-  /// in sorted order.
-  /// @tparam T The data type that the offset refers to.
-  /// @param[in] v An array of type `Offset<T>` that contains the `table`
-  /// offsets to store in the buffer in sorted order.
-  /// @param[in] len The number of elements to store in the `vector`.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T>
-  Offset<Vector<Offset<T>>> CreateVectorOfSortedTables(Offset<T> *v,
-                                                       size_t len) {
-    std::stable_sort(v, v + len, TableKeyComparator<T>(buf_));
-    return CreateVector(v, len);
-  }
-
-  /// @brief Serialize an array of `table` offsets as a `vector` in the buffer
-  /// in sorted order.
-  /// @tparam T The data type that the offset refers to.
-  /// @param[in] v An array of type `Offset<T>` that contains the `table`
-  /// offsets to store in the buffer in sorted order.
-  /// @return Returns a typed `Offset` into the serialized data indicating
-  /// where the vector is stored.
-  template<typename T, typename Alloc = std::allocator<T>>
-  Offset<Vector<Offset<T>>> CreateVectorOfSortedTables(
-      std::vector<Offset<T>, Alloc> *v) {
-    return CreateVectorOfSortedTables(data(*v), v->size());
-  }
-
-  /// @brief Specialized version of `CreateVector` for non-copying use cases.
-  /// Write the data any time later to the returned buffer pointer `buf`.
-  /// @param[in] len The number of elements to store in the `vector`.
-  /// @param[in] elemsize The size of each element in the `vector`.
-  /// @param[out] buf A pointer to a `uint8_t` pointer that can be
-  /// written to at a later time to serialize the data into a `vector`
-  /// in the buffer.
-  uoffset_t CreateUninitializedVector(size_t len, size_t elemsize,
-                                      uint8_t **buf) {
-    NotNested();
-    StartVector(len, elemsize);
-    buf_.make_space(len * elemsize);
-    auto vec_start = GetSize();
-    auto vec_end = EndVector(len);
-    *buf = buf_.data_at(vec_start);
-    return vec_end;
-  }
-
-  /// @brief Specialized version of `CreateVector` for non-copying use cases.
-  /// Write the data any time later to the returned buffer pointer `buf`.
-  /// @tparam T The data type of the data that will be stored in the buffer
-  /// as a `vector`.
-  /// @param[in] len The number of elements to store in the `vector`.
-  /// @param[out] buf A pointer to a pointer of type `T` that can be
-  /// written to at a later time to serialize the data into a `vector`
-  /// in the buffer.
-  template<typename T>
-  Offset<Vector<T>> CreateUninitializedVector(size_t len, T **buf) {
-    AssertScalarT<T>();
-    return CreateUninitializedVector(len, sizeof(T),
-                                     reinterpret_cast<uint8_t **>(buf));
-  }
-
-  template<typename T>
-  Offset<Vector<const T *>> CreateUninitializedVectorOfStructs(size_t len,
-                                                               T **buf) {
-    return CreateUninitializedVector(len, sizeof(T),
-                                     reinterpret_cast<uint8_t **>(buf));
-  }
-
-  // @brief Create a vector of scalar type T given as input a vector of scalar
-  // type U, useful with e.g. pre "enum class" enums, or any existing scalar
-  // data of the wrong type.
-  template<typename T, typename U>
-  Offset<Vector<T>> CreateVectorScalarCast(const U *v, size_t len) {
-    AssertScalarT<T>();
-    AssertScalarT<U>();
-    StartVector(len, sizeof(T));
-    for (auto i = len; i > 0;) { PushElement(static_cast<T>(v[--i])); }
-    return Offset<Vector<T>>(EndVector(len));
-  }
-
-  /// @brief Write a struct by itself, typically to be part of a union.
-  template<typename T> Offset<const T *> CreateStruct(const T &structobj) {
-    NotNested();
-    Align(AlignOf<T>());
-    buf_.push_small(structobj);
-    return Offset<const T *>(GetSize());
-  }
-
-  /// @brief Finish serializing a buffer by writing the root offset.
-  /// @param[in] file_identifier If a `file_identifier` is given, the buffer
-  /// will be prefixed with a standard FlatBuffers file header.
-  template<typename T>
-  void Finish(Offset<T> root, const char *file_identifier = nullptr) {
-    Finish(root.o, file_identifier, false);
-  }
-
-  /// @brief Finish a buffer with a 32 bit size field pre-fixed (size of the
-  /// buffer following the size field). These buffers are NOT compatible
-  /// with standard buffers created by Finish, i.e. you can't call GetRoot
-  /// on them, you have to use GetSizePrefixedRoot instead.
-  /// All >32 bit quantities in this buffer will be aligned when the whole
-  /// size pre-fixed buffer is aligned.
-  /// These kinds of buffers are useful for creating a stream of FlatBuffers.
-  template<typename T>
-  void FinishSizePrefixed(Offset<T> root,
-                          const char *file_identifier = nullptr) {
-    Finish(root.o, file_identifier, true);
-  }
-
-  void SwapBufAllocator(FlatBufferBuilder &other) {
-    buf_.swap_allocator(other.buf_);
-  }
-
-  /// @brief The length of a FlatBuffer file header.
-  static const size_t kFileIdentifierLength =
-      ::mapserver::flatbuffers::kFileIdentifierLength;
-
- protected:
-  // You shouldn't really be copying instances of this class.
-  FlatBufferBuilder(const FlatBufferBuilder &);
-  FlatBufferBuilder &operator=(const FlatBufferBuilder &);
-
-  void Finish(uoffset_t root, const char *file_identifier, bool size_prefix) {
-    NotNested();
-    buf_.clear_scratch();
-    // This will cause the whole buffer to be aligned.
-    PreAlign((size_prefix ? sizeof(uoffset_t) : 0) + sizeof(uoffset_t) +
-                 (file_identifier ? kFileIdentifierLength : 0),
-             minalign_);
-    if (file_identifier) {
-      FLATBUFFERS_ASSERT(strlen(file_identifier) == kFileIdentifierLength);
-      PushBytes(reinterpret_cast<const uint8_t *>(file_identifier),
-                kFileIdentifierLength);
-    }
-    PushElement(ReferTo(root));  // Location of root.
-    if (size_prefix) { PushElement(GetSize()); }
-    finished = true;
-  }
-
-  struct FieldLoc {
-    uoffset_t off;
-    voffset_t id;
-  };
-
-  vector_downward buf_;
-
-  // Accumulating offsets of table members while it is being built.
-  // We store these in the scratch pad of buf_, after the vtable offsets.
-  uoffset_t num_field_loc;
-  // Track how much of the vtable is in use, so we can output the most compact
-  // possible vtable.
-  voffset_t max_voffset_;
-
-  // Ensure objects are not nested.
-  bool nested;
-
-  // Ensure the buffer is finished before it is being accessed.
-  bool finished;
-
-  size_t minalign_;
-
-  bool force_defaults_;  // Serialize values equal to their defaults anyway.
-
-  bool dedup_vtables_;
-
-  struct StringOffsetCompare {
-    StringOffsetCompare(const vector_downward &buf) : buf_(&buf) {}
-    bool operator()(const Offset<String> &a, const Offset<String> &b) const {
-      auto stra = reinterpret_cast<const String *>(buf_->data_at(a.o));
-      auto strb = reinterpret_cast<const String *>(buf_->data_at(b.o));
-      return StringLessThan(stra->data(), stra->size(), strb->data(),
-                            strb->size());
-    }
-    const vector_downward *buf_;
-  };
-
-  // For use with CreateSharedString. Instantiated on first use only.
-  typedef std::set<Offset<String>, StringOffsetCompare> StringOffsetMap;
-  StringOffsetMap *string_pool;
-
- private:
-  // Allocates space for a vector of structures.
-  // Must be completed with EndVectorOfStructs().
-  template<typename T> T *StartVectorOfStructs(size_t vector_size) {
-    StartVector(vector_size * sizeof(T) / AlignOf<T>(), AlignOf<T>());
-    return reinterpret_cast<T *>(buf_.make_space(vector_size * sizeof(T)));
-  }
-
-  // End the vector of structures in the flatbuffers.
-  // Vector should have previously be started with StartVectorOfStructs().
-  template<typename T>
-  Offset<Vector<const T *>> EndVectorOfStructs(size_t vector_size) {
-    return Offset<Vector<const T *>>(EndVector(vector_size));
-  }
-};
-/// @}
-
-/// Helpers to get a typed pointer to objects that are currently being built.
-/// @warning Creating new objects will lead to reallocations and invalidates
-/// the pointer!
-template<typename T>
-T *GetMutableTemporaryPointer(FlatBufferBuilder &fbb, Offset<T> offset) {
-  return reinterpret_cast<T *>(fbb.GetCurrentBufferPointer() + fbb.GetSize() -
-                               offset.o);
-}
-
-template<typename T>
-const T *GetTemporaryPointer(FlatBufferBuilder &fbb, Offset<T> offset) {
-  return GetMutableTemporaryPointer<T>(fbb, offset);
-}
-
-template<typename T>
-void FlatBufferBuilder::Required(Offset<T> table, voffset_t field) {
-  auto table_ptr = reinterpret_cast<const Table *>(buf_.data_at(table.o));
-  bool ok = table_ptr->GetOptionalFieldOffset(field) != 0;
-  // If this fails, the caller will show what field needs to be set.
-  FLATBUFFERS_ASSERT(ok);
-  (void)ok;
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_VECTOR_DOWNWARD_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/flatbuffers.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flatbuffers.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/flatbuffers.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flatbuffers.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,272 +0,0 @@
-/*
- * Copyright 2014 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_H_
-#define FLATBUFFERS_H_
-
-// TODO: These includes are for mitigating the pains of users editing their
-// source because they relied on flatbuffers.h to include everything for them.
-#include "flatbuffers/array.h"
-#include "flatbuffers/base.h"
-#include "flatbuffers/buffer.h"
-#include "flatbuffers/buffer_ref.h"
-#include "flatbuffers/detached_buffer.h"
-#include "flatbuffers/flatbuffer_builder.h"
-#include "flatbuffers/stl_emulation.h"
-#include "flatbuffers/string.h"
-#include "flatbuffers/struct.h"
-#include "flatbuffers/table.h"
-#include "flatbuffers/vector.h"
-#include "flatbuffers/vector_downward.h"
-#include "flatbuffers/verifier.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-/// @brief This can compute the start of a FlatBuffer from a root pointer, i.e.
-/// it is the opposite transformation of GetRoot().
-/// This may be useful if you want to pass on a root and have the recipient
-/// delete the buffer afterwards.
-inline const uint8_t *GetBufferStartFromRootPointer(const void *root) {
-  auto table = reinterpret_cast<const Table *>(root);
-  auto vtable = table->GetVTable();
-  // Either the vtable is before the root or after the root.
-  auto start = (std::min)(vtable, reinterpret_cast<const uint8_t *>(root));
-  // Align to at least sizeof(uoffset_t).
-  start = reinterpret_cast<const uint8_t *>(reinterpret_cast<uintptr_t>(start) &
-                                            ~(sizeof(uoffset_t) - 1));
-  // Additionally, there may be a file_identifier in the buffer, and the root
-  // offset. The buffer may have been aligned to any size between
-  // sizeof(uoffset_t) and FLATBUFFERS_MAX_ALIGNMENT (see "force_align").
-  // Sadly, the exact alignment is only known when constructing the buffer,
-  // since it depends on the presence of values with said alignment properties.
-  // So instead, we simply look at the next uoffset_t values (root,
-  // file_identifier, and alignment padding) to see which points to the root.
-  // None of the other values can "impersonate" the root since they will either
-  // be 0 or four ASCII characters.
-  static_assert(flatbuffers::kFileIdentifierLength == sizeof(uoffset_t),
-                "file_identifier is assumed to be the same size as uoffset_t");
-  for (auto possible_roots = FLATBUFFERS_MAX_ALIGNMENT / sizeof(uoffset_t) + 1;
-       possible_roots; possible_roots--) {
-    start -= sizeof(uoffset_t);
-    if (ReadScalar<uoffset_t>(start) + start ==
-        reinterpret_cast<const uint8_t *>(root))
-      return start;
-  }
-  // We didn't find the root, either the "root" passed isn't really a root,
-  // or the buffer is corrupt.
-  // Assert, because calling this function with bad data may cause reads
-  // outside of buffer boundaries.
-  FLATBUFFERS_ASSERT(false);
-  return nullptr;
-}
-
-/// @brief This return the prefixed size of a FlatBuffer.
-inline uoffset_t GetPrefixedSize(const uint8_t *buf) {
-  return ReadScalar<uoffset_t>(buf);
-}
-
-// Base class for native objects (FlatBuffer data de-serialized into native
-// C++ data structures).
-// Contains no functionality, purely documentative.
-struct NativeTable {};
-
-/// @brief Function types to be used with resolving hashes into objects and
-/// back again. The resolver gets a pointer to a field inside an object API
-/// object that is of the type specified in the schema using the attribute
-/// `cpp_type` (it is thus important whatever you write to this address
-/// matches that type). The value of this field is initially null, so you
-/// may choose to implement a delayed binding lookup using this function
-/// if you wish. The resolver does the opposite lookup, for when the object
-/// is being serialized again.
-typedef uint64_t hash_value_t;
-typedef std::function<void(void **pointer_adr, hash_value_t hash)>
-    resolver_function_t;
-typedef std::function<hash_value_t(void *pointer)> rehasher_function_t;
-
-// Helper function to test if a field is present, using any of the field
-// enums in the generated code.
-// `table` must be a generated table type. Since this is a template parameter,
-// this is not typechecked to be a subclass of Table, so beware!
-// Note: this function will return false for fields equal to the default
-// value, since they're not stored in the buffer (unless force_defaults was
-// used).
-template<typename T>
-bool IsFieldPresent(const T *table, typename T::FlatBuffersVTableOffset field) {
-  // Cast, since Table is a private baseclass of any table types.
-  return reinterpret_cast<const Table *>(table)->CheckField(
-      static_cast<voffset_t>(field));
-}
-
-// Utility function for reverse lookups on the EnumNames*() functions
-// (in the generated C++ code)
-// names must be NULL terminated.
-inline int LookupEnum(const char **names, const char *name) {
-  for (const char **p = names; *p; p++)
-    if (!strcmp(*p, name)) return static_cast<int>(p - names);
-  return -1;
-}
-
-// These macros allow us to layout a struct with a guarantee that they'll end
-// up looking the same on different compilers and platforms.
-// It does this by disallowing the compiler to do any padding, and then
-// does padding itself by inserting extra padding fields that make every
-// element aligned to its own size.
-// Additionally, it manually sets the alignment of the struct as a whole,
-// which is typically its largest element, or a custom size set in the schema
-// by the force_align attribute.
-// These are used in the generated code only.
-
-// clang-format off
-#if defined(_MSC_VER)
-  #define FLATBUFFERS_MANUALLY_ALIGNED_STRUCT(alignment) \
-    __pragma(pack(1)) \
-    struct __declspec(align(alignment))
-  #define FLATBUFFERS_STRUCT_END(name, size) \
-    __pragma(pack()) \
-    static_assert(sizeof(name) == size, "compiler breaks packing rules")
-#elif defined(__GNUC__) || defined(__clang__) || defined(__ICCARM__)
-  #define FLATBUFFERS_MANUALLY_ALIGNED_STRUCT(alignment) \
-    _Pragma("pack(1)") \
-    struct __attribute__((aligned(alignment)))
-  #define FLATBUFFERS_STRUCT_END(name, size) \
-    _Pragma("pack()") \
-    static_assert(sizeof(name) == size, "compiler breaks packing rules")
-#else
-  #error Unknown compiler, please define structure alignment macros
-#endif
-// clang-format on
-
-// Minimal reflection via code generation.
-// Besides full-fat reflection (see reflection.h) and parsing/printing by
-// loading schemas (see idl.h), we can also have code generation for minimal
-// reflection data which allows pretty-printing and other uses without needing
-// a schema or a parser.
-// Generate code with --reflect-types (types only) or --reflect-names (names
-// also) to enable.
-// See minireflect.h for utilities using this functionality.
-
-// These types are organized slightly differently as the ones in idl.h.
-enum SequenceType { ST_TABLE, ST_STRUCT, ST_UNION, ST_ENUM };
-
-// Scalars have the same order as in idl.h
-// clang-format off
-#define FLATBUFFERS_GEN_ELEMENTARY_TYPES(ET) \
-  ET(ET_UTYPE) \
-  ET(ET_BOOL) \
-  ET(ET_CHAR) \
-  ET(ET_UCHAR) \
-  ET(ET_SHORT) \
-  ET(ET_USHORT) \
-  ET(ET_INT) \
-  ET(ET_UINT) \
-  ET(ET_LONG) \
-  ET(ET_ULONG) \
-  ET(ET_FLOAT) \
-  ET(ET_DOUBLE) \
-  ET(ET_STRING) \
-  ET(ET_SEQUENCE)  // See SequenceType.
-
-enum ElementaryType {
-  #define FLATBUFFERS_ET(E) E,
-    FLATBUFFERS_GEN_ELEMENTARY_TYPES(FLATBUFFERS_ET)
-  #undef FLATBUFFERS_ET
-};
-
-inline const char * const *ElementaryTypeNames() {
-  static const char * const names[] = {
-    #define FLATBUFFERS_ET(E) #E,
-      FLATBUFFERS_GEN_ELEMENTARY_TYPES(FLATBUFFERS_ET)
-    #undef FLATBUFFERS_ET
-  };
-  return names;
-}
-// clang-format on
-
-// Basic type info cost just 16bits per field!
-// We're explicitly defining the signedness since the signedness of integer
-// bitfields is otherwise implementation-defined and causes warnings on older
-// GCC compilers.
-struct TypeCode {
-  // ElementaryType
-  unsigned short base_type : 4;
-  // Either vector (in table) or array (in struct)
-  unsigned short is_repeating : 1;
-  // Index into type_refs below, or -1 for none.
-  signed short sequence_ref : 11;
-};
-
-static_assert(sizeof(TypeCode) == 2, "TypeCode");
-
-struct TypeTable;
-
-// Signature of the static method present in each type.
-typedef const TypeTable *(*TypeFunction)();
-
-struct TypeTable {
-  SequenceType st;
-  size_t num_elems;  // of type_codes, values, names (but not type_refs).
-  const TypeCode *type_codes;     // num_elems count
-  const TypeFunction *type_refs;  // less than num_elems entries (see TypeCode).
-  const int16_t *array_sizes;     // less than num_elems entries (see TypeCode).
-  const int64_t *values;  // Only set for non-consecutive enum/union or structs.
-  const char *const *names;  // Only set if compiled with --reflect-names.
-};
-
-// String which identifies the current version of FlatBuffers.
-inline const char *flatbuffers_version_string() {
-  return "FlatBuffers " FLATBUFFERS_STRING(FLATBUFFERS_VERSION_MAJOR) "."
-      FLATBUFFERS_STRING(FLATBUFFERS_VERSION_MINOR) "."
-      FLATBUFFERS_STRING(FLATBUFFERS_VERSION_REVISION);
-}
-
-// clang-format off
-#define FLATBUFFERS_DEFINE_BITMASK_OPERATORS(E, T)\
-    inline E operator | (E lhs, E rhs){\
-        return E(T(lhs) | T(rhs));\
-    }\
-    inline E operator & (E lhs, E rhs){\
-        return E(T(lhs) & T(rhs));\
-    }\
-    inline E operator ^ (E lhs, E rhs){\
-        return E(T(lhs) ^ T(rhs));\
-    }\
-    inline E operator ~ (E lhs){\
-        return E(~T(lhs));\
-    }\
-    inline E operator |= (E &lhs, E rhs){\
-        lhs = lhs | rhs;\
-        return lhs;\
-    }\
-    inline E operator &= (E &lhs, E rhs){\
-        lhs = lhs & rhs;\
-        return lhs;\
-    }\
-    inline E operator ^= (E &lhs, E rhs){\
-        lhs = lhs ^ rhs;\
-        return lhs;\
-    }\
-    inline bool operator !(E rhs) \
-    {\
-        return !bool(T(rhs)); \
-    }
-/// @endcond
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-// clang-format on
-
-#endif  // FLATBUFFERS_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/flatc.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flatc.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/flatc.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flatc.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,118 +0,0 @@
-/*
- * Copyright 2017 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_FLATC_H_
-#define FLATBUFFERS_FLATC_H_
-
-#include <functional>
-#include <limits>
-#include <string>
-
-#include "flatbuffers/bfbs_generator.h"
-#include "flatbuffers/flatbuffers.h"
-#include "flatbuffers/idl.h"
-#include "flatbuffers/util.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-extern void LogCompilerWarn(const std::string &warn);
-extern void LogCompilerError(const std::string &err);
-
-struct FlatCOption {
-  std::string short_opt;
-  std::string long_opt;
-  std::string parameter;
-  std::string description;
-};
-
-class FlatCompiler {
- public:
-  // Output generator for the various programming languages and formats we
-  // support.
-  struct Generator {
-    typedef bool (*GenerateFn)(const flatbuffers::Parser &parser,
-                               const std::string &path,
-                               const std::string &file_name);
-    typedef std::string (*MakeRuleFn)(const flatbuffers::Parser &parser,
-                                      const std::string &path,
-                                      const std::string &file_name);
-    typedef bool (*ParsingCompletedFn)(const flatbuffers::Parser &parser,
-                                       const std::string &output_path);
-
-    GenerateFn generate;
-    const char *lang_name;
-    bool schema_only;
-    GenerateFn generateGRPC;
-    flatbuffers::IDLOptions::Language lang;
-    FlatCOption option;
-    MakeRuleFn make_rule;
-    BfbsGenerator *bfbs_generator;
-    ParsingCompletedFn parsing_completed;
-  };
-
-  typedef void (*WarnFn)(const FlatCompiler *flatc, const std::string &warn,
-                         bool show_exe_name);
-
-  typedef void (*ErrorFn)(const FlatCompiler *flatc, const std::string &err,
-                          bool usage, bool show_exe_name);
-
-  // Parameters required to initialize the FlatCompiler.
-  struct InitParams {
-    InitParams()
-        : generators(nullptr),
-          num_generators(0),
-          warn_fn(nullptr),
-          error_fn(nullptr) {}
-
-    const Generator *generators;
-    size_t num_generators;
-    WarnFn warn_fn;
-    ErrorFn error_fn;
-  };
-
-  explicit FlatCompiler(const InitParams &params) : params_(params) {}
-
-  int Compile(int argc, const char **argv);
-
-  std::string GetShortUsageString(const char *program_name) const;
-  std::string GetUsageString(const char *program_name) const;
-
- private:
-  void ParseFile(flatbuffers::Parser &parser, const std::string &filename,
-                 const std::string &contents,
-                 std::vector<const char *> &include_directories) const;
-
-  void LoadBinarySchema(Parser &parser, const std::string &filename,
-                        const std::string &contents);
-
-  void Warn(const std::string &warn, bool show_exe_name = true) const;
-
-  void Error(const std::string &err, bool usage = true,
-             bool show_exe_name = true) const;
-
-  void AnnotateBinaries(const uint8_t *binary_schema,
-                        uint64_t binary_schema_size,
-                        const std::string & schema_filename,
-                        const std::vector<std::string> &binary_files);
-
-  InitParams params_;
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_FLATC_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/flex_flat_util.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flex_flat_util.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/flex_flat_util.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flex_flat_util.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,36 +0,0 @@
-/*
- * Copyright 2022 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_FLEX_FLAT_UTIL_H_
-#define FLATBUFFERS_FLEX_FLAT_UTIL_H_
-
-#include "flatbuffers/flatbuffers.h"
-#include "flatbuffers/flexbuffers.h"
-
-namespace flexbuffers {
-
-// Verifies the `nested` flexbuffer within a flatbuffer vector is valid.
-inline bool VerifyNestedFlexBuffer(
-    const flatbuffers::Vector<uint8_t> *const nested,
-    flatbuffers::Verifier &verifier) {
-  if (!nested) return true;
-  return verifier.Check(flexbuffers::VerifyBuffer(
-      nested->data(), nested->size(), verifier.GetFlexReuseTracker()));
-}
-
-}  // namespace flexbuffers
-
-#endif  // FLATBUFFERS_FLEX_FLAT_UTIL_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/flexbuffers.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flexbuffers.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/flexbuffers.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/flexbuffers.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1888 +0,0 @@
-/*
- * Copyright 2017 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_FLEXBUFFERS_H_
-#define FLATBUFFERS_FLEXBUFFERS_H_
-
-#include <map>
-// Used to select STL variant.
-#include "flatbuffers/base.h"
-// We use the basic binary writing functions from the regular FlatBuffers.
-#include "flatbuffers/util.h"
-
-#ifdef _MSC_VER
-#  include <intrin.h>
-#endif
-
-#if defined(_MSC_VER)
-#  pragma warning(push)
-#  pragma warning(disable : 4127)  // C4127: conditional expression is constant
-#endif
-
-namespace flexbuffers {
-
-class Reference;
-class Map;
-
-// These are used in the lower 2 bits of a type field to determine the size of
-// the elements (and or size field) of the item pointed to (e.g. vector).
-enum BitWidth {
-  BIT_WIDTH_8 = 0,
-  BIT_WIDTH_16 = 1,
-  BIT_WIDTH_32 = 2,
-  BIT_WIDTH_64 = 3,
-};
-
-// These are used as the upper 6 bits of a type field to indicate the actual
-// type.
-enum Type {
-  FBT_NULL = 0,
-  FBT_INT = 1,
-  FBT_UINT = 2,
-  FBT_FLOAT = 3,
-  // Types above stored inline, types below (except FBT_BOOL) store an offset.
-  FBT_KEY = 4,
-  FBT_STRING = 5,
-  FBT_INDIRECT_INT = 6,
-  FBT_INDIRECT_UINT = 7,
-  FBT_INDIRECT_FLOAT = 8,
-  FBT_MAP = 9,
-  FBT_VECTOR = 10,      // Untyped.
-  FBT_VECTOR_INT = 11,  // Typed any size (stores no type table).
-  FBT_VECTOR_UINT = 12,
-  FBT_VECTOR_FLOAT = 13,
-  FBT_VECTOR_KEY = 14,
-  // DEPRECATED, use FBT_VECTOR or FBT_VECTOR_KEY instead.
-  // Read test.cpp/FlexBuffersDeprecatedTest() for details on why.
-  FBT_VECTOR_STRING_DEPRECATED = 15,
-  FBT_VECTOR_INT2 = 16,  // Typed tuple (no type table, no size field).
-  FBT_VECTOR_UINT2 = 17,
-  FBT_VECTOR_FLOAT2 = 18,
-  FBT_VECTOR_INT3 = 19,  // Typed triple (no type table, no size field).
-  FBT_VECTOR_UINT3 = 20,
-  FBT_VECTOR_FLOAT3 = 21,
-  FBT_VECTOR_INT4 = 22,  // Typed quad (no type table, no size field).
-  FBT_VECTOR_UINT4 = 23,
-  FBT_VECTOR_FLOAT4 = 24,
-  FBT_BLOB = 25,
-  FBT_BOOL = 26,
-  FBT_VECTOR_BOOL =
-      36,  // To Allow the same type of conversion of type to vector type
-
-  FBT_MAX_TYPE = 37
-};
-
-inline bool IsInline(Type t) { return t <= FBT_FLOAT || t == FBT_BOOL; }
-
-inline bool IsTypedVectorElementType(Type t) {
-  return (t >= FBT_INT && t <= FBT_STRING) || t == FBT_BOOL;
-}
-
-inline bool IsTypedVector(Type t) {
-  return (t >= FBT_VECTOR_INT && t <= FBT_VECTOR_STRING_DEPRECATED) ||
-         t == FBT_VECTOR_BOOL;
-}
-
-inline bool IsFixedTypedVector(Type t) {
-  return t >= FBT_VECTOR_INT2 && t <= FBT_VECTOR_FLOAT4;
-}
-
-inline Type ToTypedVector(Type t, size_t fixed_len = 0) {
-  FLATBUFFERS_ASSERT(IsTypedVectorElementType(t));
-  switch (fixed_len) {
-    case 0: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT);
-    case 2: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT2);
-    case 3: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT3);
-    case 4: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT4);
-    default: FLATBUFFERS_ASSERT(0); return FBT_NULL;
-  }
-}
-
-inline Type ToTypedVectorElementType(Type t) {
-  FLATBUFFERS_ASSERT(IsTypedVector(t));
-  return static_cast<Type>(t - FBT_VECTOR_INT + FBT_INT);
-}
-
-inline Type ToFixedTypedVectorElementType(Type t, uint8_t *len) {
-  FLATBUFFERS_ASSERT(IsFixedTypedVector(t));
-  auto fixed_type = t - FBT_VECTOR_INT2;
-  *len = static_cast<uint8_t>(fixed_type / 3 +
-                              2);  // 3 types each, starting from length 2.
-  return static_cast<Type>(fixed_type % 3 + FBT_INT);
-}
-
-// TODO: implement proper support for 8/16bit floats, or decide not to
-// support them.
-typedef int16_t half;
-typedef int8_t quarter;
-
-// TODO: can we do this without conditionals using intrinsics or inline asm
-// on some platforms? Given branch prediction the method below should be
-// decently quick, but it is the most frequently executed function.
-// We could do an (unaligned) 64-bit read if we ifdef out the platforms for
-// which that doesn't work (or where we'd read into un-owned memory).
-template<typename R, typename T1, typename T2, typename T4, typename T8>
-R ReadSizedScalar(const uint8_t *data, uint8_t byte_width) {
-  return byte_width < 4
-             ? (byte_width < 2
-                    ? static_cast<R>(flatbuffers::ReadScalar<T1>(data))
-                    : static_cast<R>(flatbuffers::ReadScalar<T2>(data)))
-             : (byte_width < 8
-                    ? static_cast<R>(flatbuffers::ReadScalar<T4>(data))
-                    : static_cast<R>(flatbuffers::ReadScalar<T8>(data)));
-}
-
-inline int64_t ReadInt64(const uint8_t *data, uint8_t byte_width) {
-  return ReadSizedScalar<int64_t, int8_t, int16_t, int32_t, int64_t>(
-      data, byte_width);
-}
-
-inline uint64_t ReadUInt64(const uint8_t *data, uint8_t byte_width) {
-  // This is the "hottest" function (all offset lookups use this), so worth
-  // optimizing if possible.
-  // TODO: GCC apparently replaces memcpy by a rep movsb, but only if count is a
-  // constant, which here it isn't. Test if memcpy is still faster than
-  // the conditionals in ReadSizedScalar. Can also use inline asm.
-
-  // clang-format off
-  #if defined(_MSC_VER) && defined(_M_X64) && !defined(_M_ARM64EC)
-  // This is 64-bit Windows only, __movsb does not work on 32-bit Windows.
-    uint64_t u = 0;
-    __movsb(reinterpret_cast<uint8_t *>(&u),
-            reinterpret_cast<const uint8_t *>(data), byte_width);
-    return flatbuffers::EndianScalar(u);
-  #else
-    return ReadSizedScalar<uint64_t, uint8_t, uint16_t, uint32_t, uint64_t>(
-             data, byte_width);
-  #endif
-  // clang-format on
-}
-
-inline double ReadDouble(const uint8_t *data, uint8_t byte_width) {
-  return ReadSizedScalar<double, quarter, half, float, double>(data,
-                                                               byte_width);
-}
-
-inline const uint8_t *Indirect(const uint8_t *offset, uint8_t byte_width) {
-  return offset - ReadUInt64(offset, byte_width);
-}
-
-template<typename T> const uint8_t *Indirect(const uint8_t *offset) {
-  return offset - flatbuffers::ReadScalar<T>(offset);
-}
-
-inline BitWidth WidthU(uint64_t u) {
-#define FLATBUFFERS_GET_FIELD_BIT_WIDTH(value, width)                   \
-  {                                                                     \
-    if (!((u) & ~((1ULL << (width)) - 1ULL))) return BIT_WIDTH_##width; \
-  }
-  FLATBUFFERS_GET_FIELD_BIT_WIDTH(u, 8);
-  FLATBUFFERS_GET_FIELD_BIT_WIDTH(u, 16);
-  FLATBUFFERS_GET_FIELD_BIT_WIDTH(u, 32);
-#undef FLATBUFFERS_GET_FIELD_BIT_WIDTH
-  return BIT_WIDTH_64;
-}
-
-inline BitWidth WidthI(int64_t i) {
-  auto u = static_cast<uint64_t>(i) << 1;
-  return WidthU(i >= 0 ? u : ~u);
-}
-
-inline BitWidth WidthF(double f) {
-  return static_cast<double>(static_cast<float>(f)) == f ? BIT_WIDTH_32
-                                                         : BIT_WIDTH_64;
-}
-
-// Base class of all types below.
-// Points into the data buffer and allows access to one type.
-class Object {
- public:
-  Object(const uint8_t *data, uint8_t byte_width)
-      : data_(data), byte_width_(byte_width) {}
-
- protected:
-  const uint8_t *data_;
-  uint8_t byte_width_;
-};
-
-// Object that has a size, obtained either from size prefix, or elsewhere.
-class Sized : public Object {
- public:
-  // Size prefix.
-  Sized(const uint8_t *data, uint8_t byte_width)
-      : Object(data, byte_width), size_(read_size()) {}
-  // Manual size.
-  Sized(const uint8_t *data, uint8_t byte_width, size_t sz)
-      : Object(data, byte_width), size_(sz) {}
-  size_t size() const { return size_; }
-  // Access size stored in `byte_width_` bytes before data_ pointer.
-  size_t read_size() const {
-    return static_cast<size_t>(ReadUInt64(data_ - byte_width_, byte_width_));
-  }
-
- protected:
-  size_t size_;
-};
-
-class String : public Sized {
- public:
-  // Size prefix.
-  String(const uint8_t *data, uint8_t byte_width) : Sized(data, byte_width) {}
-  // Manual size.
-  String(const uint8_t *data, uint8_t byte_width, size_t sz)
-      : Sized(data, byte_width, sz) {}
-
-  size_t length() const { return size(); }
-  const char *c_str() const { return reinterpret_cast<const char *>(data_); }
-  std::string str() const { return std::string(c_str(), size()); }
-
-  static String EmptyString() {
-    static const char *empty_string = "";
-    return String(reinterpret_cast<const uint8_t *>(empty_string), 1, 0);
-  }
-  bool IsTheEmptyString() const { return data_ == EmptyString().data_; }
-};
-
-class Blob : public Sized {
- public:
-  Blob(const uint8_t *data_buf, uint8_t byte_width)
-      : Sized(data_buf, byte_width) {}
-
-  static Blob EmptyBlob() {
-    static const uint8_t empty_blob[] = { 0 /*len*/ };
-    return Blob(empty_blob + 1, 1);
-  }
-  bool IsTheEmptyBlob() const { return data_ == EmptyBlob().data_; }
-  const uint8_t *data() const { return data_; }
-};
-
-class Vector : public Sized {
- public:
-  Vector(const uint8_t *data, uint8_t byte_width) : Sized(data, byte_width) {}
-
-  Reference operator[](size_t i) const;
-
-  static Vector EmptyVector() {
-    static const uint8_t empty_vector[] = { 0 /*len*/ };
-    return Vector(empty_vector + 1, 1);
-  }
-  bool IsTheEmptyVector() const { return data_ == EmptyVector().data_; }
-};
-
-class TypedVector : public Sized {
- public:
-  TypedVector(const uint8_t *data, uint8_t byte_width, Type element_type)
-      : Sized(data, byte_width), type_(element_type) {}
-
-  Reference operator[](size_t i) const;
-
-  static TypedVector EmptyTypedVector() {
-    static const uint8_t empty_typed_vector[] = { 0 /*len*/ };
-    return TypedVector(empty_typed_vector + 1, 1, FBT_INT);
-  }
-  bool IsTheEmptyVector() const {
-    return data_ == TypedVector::EmptyTypedVector().data_;
-  }
-
-  Type ElementType() { return type_; }
-
-  friend Reference;
-
- private:
-  Type type_;
-
-  friend Map;
-};
-
-class FixedTypedVector : public Object {
- public:
-  FixedTypedVector(const uint8_t *data, uint8_t byte_width, Type element_type,
-                   uint8_t len)
-      : Object(data, byte_width), type_(element_type), len_(len) {}
-
-  Reference operator[](size_t i) const;
-
-  static FixedTypedVector EmptyFixedTypedVector() {
-    static const uint8_t fixed_empty_vector[] = { 0 /* unused */ };
-    return FixedTypedVector(fixed_empty_vector, 1, FBT_INT, 0);
-  }
-  bool IsTheEmptyFixedTypedVector() const {
-    return data_ == FixedTypedVector::EmptyFixedTypedVector().data_;
-  }
-
-  Type ElementType() const { return type_; }
-  uint8_t size() const { return len_; }
-
- private:
-  Type type_;
-  uint8_t len_;
-};
-
-class Map : public Vector {
- public:
-  Map(const uint8_t *data, uint8_t byte_width) : Vector(data, byte_width) {}
-
-  Reference operator[](const char *key) const;
-  Reference operator[](const std::string &key) const;
-
-  Vector Values() const { return Vector(data_, byte_width_); }
-
-  TypedVector Keys() const {
-    const size_t num_prefixed_fields = 3;
-    auto keys_offset = data_ - byte_width_ * num_prefixed_fields;
-    return TypedVector(Indirect(keys_offset, byte_width_),
-                       static_cast<uint8_t>(
-                           ReadUInt64(keys_offset + byte_width_, byte_width_)),
-                       FBT_KEY);
-  }
-
-  static Map EmptyMap() {
-    static const uint8_t empty_map[] = {
-      0 /*keys_len*/, 0 /*keys_offset*/, 1 /*keys_width*/, 0 /*len*/
-    };
-    return Map(empty_map + 4, 1);
-  }
-
-  bool IsTheEmptyMap() const { return data_ == EmptyMap().data_; }
-};
-
-template<typename T>
-void AppendToString(std::string &s, T &&v, bool keys_quoted) {
-  s += "[ ";
-  for (size_t i = 0; i < v.size(); i++) {
-    if (i) s += ", ";
-    v[i].ToString(true, keys_quoted, s);
-  }
-  s += " ]";
-}
-
-class Reference {
- public:
-  Reference()
-      : data_(nullptr), parent_width_(0), byte_width_(0), type_(FBT_NULL) {}
-
-  Reference(const uint8_t *data, uint8_t parent_width, uint8_t byte_width,
-            Type type)
-      : data_(data),
-        parent_width_(parent_width),
-        byte_width_(byte_width),
-        type_(type) {}
-
-  Reference(const uint8_t *data, uint8_t parent_width, uint8_t packed_type)
-      : data_(data), parent_width_(parent_width) {
-    byte_width_ = 1U << static_cast<BitWidth>(packed_type & 3);
-    type_ = static_cast<Type>(packed_type >> 2);
-  }
-
-  Type GetType() const { return type_; }
-
-  bool IsNull() const { return type_ == FBT_NULL; }
-  bool IsBool() const { return type_ == FBT_BOOL; }
-  bool IsInt() const { return type_ == FBT_INT || type_ == FBT_INDIRECT_INT; }
-  bool IsUInt() const {
-    return type_ == FBT_UINT || type_ == FBT_INDIRECT_UINT;
-  }
-  bool IsIntOrUint() const { return IsInt() || IsUInt(); }
-  bool IsFloat() const {
-    return type_ == FBT_FLOAT || type_ == FBT_INDIRECT_FLOAT;
-  }
-  bool IsNumeric() const { return IsIntOrUint() || IsFloat(); }
-  bool IsString() const { return type_ == FBT_STRING; }
-  bool IsKey() const { return type_ == FBT_KEY; }
-  bool IsVector() const { return type_ == FBT_VECTOR || type_ == FBT_MAP; }
-  bool IsUntypedVector() const { return type_ == FBT_VECTOR; }
-  bool IsTypedVector() const { return flexbuffers::IsTypedVector(type_); }
-  bool IsFixedTypedVector() const {
-    return flexbuffers::IsFixedTypedVector(type_);
-  }
-  bool IsAnyVector() const {
-    return (IsTypedVector() || IsFixedTypedVector() || IsVector());
-  }
-  bool IsMap() const { return type_ == FBT_MAP; }
-  bool IsBlob() const { return type_ == FBT_BLOB; }
-  bool AsBool() const {
-    return (type_ == FBT_BOOL ? ReadUInt64(data_, parent_width_)
-                              : AsUInt64()) != 0;
-  }
-
-  // Reads any type as a int64_t. Never fails, does most sensible conversion.
-  // Truncates floats, strings are attempted to be parsed for a number,
-  // vectors/maps return their size. Returns 0 if all else fails.
-  int64_t AsInt64() const {
-    if (type_ == FBT_INT) {
-      // A fast path for the common case.
-      return ReadInt64(data_, parent_width_);
-    } else
-      switch (type_) {
-        case FBT_INDIRECT_INT: return ReadInt64(Indirect(), byte_width_);
-        case FBT_UINT: return ReadUInt64(data_, parent_width_);
-        case FBT_INDIRECT_UINT: return ReadUInt64(Indirect(), byte_width_);
-        case FBT_FLOAT:
-          return static_cast<int64_t>(ReadDouble(data_, parent_width_));
-        case FBT_INDIRECT_FLOAT:
-          return static_cast<int64_t>(ReadDouble(Indirect(), byte_width_));
-        case FBT_NULL: return 0;
-        case FBT_STRING: return flatbuffers::StringToInt(AsString().c_str());
-        case FBT_VECTOR: return static_cast<int64_t>(AsVector().size());
-        case FBT_BOOL: return ReadInt64(data_, parent_width_);
-        default:
-          // Convert other things to int.
-          return 0;
-      }
-  }
-
-  // TODO: could specialize these to not use AsInt64() if that saves
-  // extension ops in generated code, and use a faster op than ReadInt64.
-  int32_t AsInt32() const { return static_cast<int32_t>(AsInt64()); }
-  int16_t AsInt16() const { return static_cast<int16_t>(AsInt64()); }
-  int8_t AsInt8() const { return static_cast<int8_t>(AsInt64()); }
-
-  uint64_t AsUInt64() const {
-    if (type_ == FBT_UINT) {
-      // A fast path for the common case.
-      return ReadUInt64(data_, parent_width_);
-    } else
-      switch (type_) {
-        case FBT_INDIRECT_UINT: return ReadUInt64(Indirect(), byte_width_);
-        case FBT_INT: return ReadInt64(data_, parent_width_);
-        case FBT_INDIRECT_INT: return ReadInt64(Indirect(), byte_width_);
-        case FBT_FLOAT:
-          return static_cast<uint64_t>(ReadDouble(data_, parent_width_));
-        case FBT_INDIRECT_FLOAT:
-          return static_cast<uint64_t>(ReadDouble(Indirect(), byte_width_));
-        case FBT_NULL: return 0;
-        case FBT_STRING: return flatbuffers::StringToUInt(AsString().c_str());
-        case FBT_VECTOR: return static_cast<uint64_t>(AsVector().size());
-        case FBT_BOOL: return ReadUInt64(data_, parent_width_);
-        default:
-          // Convert other things to uint.
-          return 0;
-      }
-  }
-
-  uint32_t AsUInt32() const { return static_cast<uint32_t>(AsUInt64()); }
-  uint16_t AsUInt16() const { return static_cast<uint16_t>(AsUInt64()); }
-  uint8_t AsUInt8() const { return static_cast<uint8_t>(AsUInt64()); }
-
-  double AsDouble() const {
-    if (type_ == FBT_FLOAT) {
-      // A fast path for the common case.
-      return ReadDouble(data_, parent_width_);
-    } else
-      switch (type_) {
-        case FBT_INDIRECT_FLOAT: return ReadDouble(Indirect(), byte_width_);
-        case FBT_INT:
-          return static_cast<double>(ReadInt64(data_, parent_width_));
-        case FBT_UINT:
-          return static_cast<double>(ReadUInt64(data_, parent_width_));
-        case FBT_INDIRECT_INT:
-          return static_cast<double>(ReadInt64(Indirect(), byte_width_));
-        case FBT_INDIRECT_UINT:
-          return static_cast<double>(ReadUInt64(Indirect(), byte_width_));
-        case FBT_NULL: return 0.0;
-        case FBT_STRING: {
-          double d;
-          flatbuffers::StringToNumber(AsString().c_str(), &d);
-          return d;
-        }
-        case FBT_VECTOR: return static_cast<double>(AsVector().size());
-        case FBT_BOOL:
-          return static_cast<double>(ReadUInt64(data_, parent_width_));
-        default:
-          // Convert strings and other things to float.
-          return 0;
-      }
-  }
-
-  float AsFloat() const { return static_cast<float>(AsDouble()); }
-
-  const char *AsKey() const {
-    if (type_ == FBT_KEY || type_ == FBT_STRING) {
-      return reinterpret_cast<const char *>(Indirect());
-    } else {
-      return "";
-    }
-  }
-
-  // This function returns the empty string if you try to read something that
-  // is not a string or key.
-  String AsString() const {
-    if (type_ == FBT_STRING) {
-      return String(Indirect(), byte_width_);
-    } else if (type_ == FBT_KEY) {
-      auto key = Indirect();
-      return String(key, byte_width_,
-                    strlen(reinterpret_cast<const char *>(key)));
-    } else {
-      return String::EmptyString();
-    }
-  }
-
-  // Unlike AsString(), this will convert any type to a std::string.
-  std::string ToString() const {
-    std::string s;
-    ToString(false, false, s);
-    return s;
-  }
-
-  // Convert any type to a JSON-like string. strings_quoted determines if
-  // string values at the top level receive "" quotes (inside other values
-  // they always do). keys_quoted determines if keys are quoted, at any level.
-  // TODO(wvo): add further options to have indentation/newlines.
-  void ToString(bool strings_quoted, bool keys_quoted, std::string &s) const {
-    if (type_ == FBT_STRING) {
-      String str(Indirect(), byte_width_);
-      if (strings_quoted) {
-        flatbuffers::EscapeString(str.c_str(), str.length(), &s, true, false);
-      } else {
-        s.append(str.c_str(), str.length());
-      }
-    } else if (IsKey()) {
-      auto str = AsKey();
-      if (keys_quoted) {
-        flatbuffers::EscapeString(str, strlen(str), &s, true, false);
-      } else {
-        s += str;
-      }
-    } else if (IsInt()) {
-      s += flatbuffers::NumToString(AsInt64());
-    } else if (IsUInt()) {
-      s += flatbuffers::NumToString(AsUInt64());
-    } else if (IsFloat()) {
-      s += flatbuffers::NumToString(AsDouble());
-    } else if (IsNull()) {
-      s += "null";
-    } else if (IsBool()) {
-      s += AsBool() ? "true" : "false";
-    } else if (IsMap()) {
-      s += "{ ";
-      auto m = AsMap();
-      auto keys = m.Keys();
-      auto vals = m.Values();
-      for (size_t i = 0; i < keys.size(); i++) {
-        bool kq = keys_quoted;
-        if (!kq) {
-          // FlexBuffers keys may contain arbitrary characters, only allow
-          // unquoted if it looks like an "identifier":
-          const char *p = keys[i].AsKey();
-          if (!flatbuffers::is_alpha(*p) && *p != '_') {
-            kq = true;
-          } else {
-            while (*++p) {
-              if (!flatbuffers::is_alnum(*p) && *p != '_') {
-                kq = true;
-                break;
-              }
-            }
-          }
-        }
-        keys[i].ToString(true, kq, s);
-        s += ": ";
-        vals[i].ToString(true, keys_quoted, s);
-        if (i < keys.size() - 1) s += ", ";
-      }
-      s += " }";
-    } else if (IsVector()) {
-      AppendToString<Vector>(s, AsVector(), keys_quoted);
-    } else if (IsTypedVector()) {
-      AppendToString<TypedVector>(s, AsTypedVector(), keys_quoted);
-    } else if (IsFixedTypedVector()) {
-      AppendToString<FixedTypedVector>(s, AsFixedTypedVector(), keys_quoted);
-    } else if (IsBlob()) {
-      auto blob = AsBlob();
-      flatbuffers::EscapeString(reinterpret_cast<const char *>(blob.data()),
-                                blob.size(), &s, true, false);
-    } else {
-      s += "(?)";
-    }
-  }
-
-  // This function returns the empty blob if you try to read a not-blob.
-  // Strings can be viewed as blobs too.
-  Blob AsBlob() const {
-    if (type_ == FBT_BLOB || type_ == FBT_STRING) {
-      return Blob(Indirect(), byte_width_);
-    } else {
-      return Blob::EmptyBlob();
-    }
-  }
-
-  // This function returns the empty vector if you try to read a not-vector.
-  // Maps can be viewed as vectors too.
-  Vector AsVector() const {
-    if (type_ == FBT_VECTOR || type_ == FBT_MAP) {
-      return Vector(Indirect(), byte_width_);
-    } else {
-      return Vector::EmptyVector();
-    }
-  }
-
-  TypedVector AsTypedVector() const {
-    if (IsTypedVector()) {
-      auto tv =
-          TypedVector(Indirect(), byte_width_, ToTypedVectorElementType(type_));
-      if (tv.type_ == FBT_STRING) {
-        // These can't be accessed as strings, since we don't know the bit-width
-        // of the size field, see the declaration of
-        // FBT_VECTOR_STRING_DEPRECATED above for details.
-        // We change the type here to be keys, which are a subtype of strings,
-        // and will ignore the size field. This will truncate strings with
-        // embedded nulls.
-        tv.type_ = FBT_KEY;
-      }
-      return tv;
-    } else {
-      return TypedVector::EmptyTypedVector();
-    }
-  }
-
-  FixedTypedVector AsFixedTypedVector() const {
-    if (IsFixedTypedVector()) {
-      uint8_t len = 0;
-      auto vtype = ToFixedTypedVectorElementType(type_, &len);
-      return FixedTypedVector(Indirect(), byte_width_, vtype, len);
-    } else {
-      return FixedTypedVector::EmptyFixedTypedVector();
-    }
-  }
-
-  Map AsMap() const {
-    if (type_ == FBT_MAP) {
-      return Map(Indirect(), byte_width_);
-    } else {
-      return Map::EmptyMap();
-    }
-  }
-
-  template<typename T> T As() const;
-
-  // Experimental: Mutation functions.
-  // These allow scalars in an already created buffer to be updated in-place.
-  // Since by default scalars are stored in the smallest possible space,
-  // the new value may not fit, in which case these functions return false.
-  // To avoid this, you can construct the values you intend to mutate using
-  // Builder::ForceMinimumBitWidth.
-  bool MutateInt(int64_t i) {
-    if (type_ == FBT_INT) {
-      return Mutate(data_, i, parent_width_, WidthI(i));
-    } else if (type_ == FBT_INDIRECT_INT) {
-      return Mutate(Indirect(), i, byte_width_, WidthI(i));
-    } else if (type_ == FBT_UINT) {
-      auto u = static_cast<uint64_t>(i);
-      return Mutate(data_, u, parent_width_, WidthU(u));
-    } else if (type_ == FBT_INDIRECT_UINT) {
-      auto u = static_cast<uint64_t>(i);
-      return Mutate(Indirect(), u, byte_width_, WidthU(u));
-    } else {
-      return false;
-    }
-  }
-
-  bool MutateBool(bool b) {
-    return type_ == FBT_BOOL && Mutate(data_, b, parent_width_, BIT_WIDTH_8);
-  }
-
-  bool MutateUInt(uint64_t u) {
-    if (type_ == FBT_UINT) {
-      return Mutate(data_, u, parent_width_, WidthU(u));
-    } else if (type_ == FBT_INDIRECT_UINT) {
-      return Mutate(Indirect(), u, byte_width_, WidthU(u));
-    } else if (type_ == FBT_INT) {
-      auto i = static_cast<int64_t>(u);
-      return Mutate(data_, i, parent_width_, WidthI(i));
-    } else if (type_ == FBT_INDIRECT_INT) {
-      auto i = static_cast<int64_t>(u);
-      return Mutate(Indirect(), i, byte_width_, WidthI(i));
-    } else {
-      return false;
-    }
-  }
-
-  bool MutateFloat(float f) {
-    if (type_ == FBT_FLOAT) {
-      return MutateF(data_, f, parent_width_, BIT_WIDTH_32);
-    } else if (type_ == FBT_INDIRECT_FLOAT) {
-      return MutateF(Indirect(), f, byte_width_, BIT_WIDTH_32);
-    } else {
-      return false;
-    }
-  }
-
-  bool MutateFloat(double d) {
-    if (type_ == FBT_FLOAT) {
-      return MutateF(data_, d, parent_width_, WidthF(d));
-    } else if (type_ == FBT_INDIRECT_FLOAT) {
-      return MutateF(Indirect(), d, byte_width_, WidthF(d));
-    } else {
-      return false;
-    }
-  }
-
-  bool MutateString(const char *str, size_t len) {
-    auto s = AsString();
-    if (s.IsTheEmptyString()) return false;
-    // This is very strict, could allow shorter strings, but that creates
-    // garbage.
-    if (s.length() != len) return false;
-    memcpy(const_cast<char *>(s.c_str()), str, len);
-    return true;
-  }
-  bool MutateString(const char *str) { return MutateString(str, strlen(str)); }
-  bool MutateString(const std::string &str) {
-    return MutateString(str.data(), str.length());
-  }
-
- private:
-  const uint8_t *Indirect() const {
-    return flexbuffers::Indirect(data_, parent_width_);
-  }
-
-  template<typename T>
-  bool Mutate(const uint8_t *dest, T t, size_t byte_width,
-              BitWidth value_width) {
-    auto fits = static_cast<size_t>(static_cast<size_t>(1U) << value_width) <=
-                byte_width;
-    if (fits) {
-      t = flatbuffers::EndianScalar(t);
-      memcpy(const_cast<uint8_t *>(dest), &t, byte_width);
-    }
-    return fits;
-  }
-
-  template<typename T>
-  bool MutateF(const uint8_t *dest, T t, size_t byte_width,
-               BitWidth value_width) {
-    if (byte_width == sizeof(double))
-      return Mutate(dest, static_cast<double>(t), byte_width, value_width);
-    if (byte_width == sizeof(float))
-      return Mutate(dest, static_cast<float>(t), byte_width, value_width);
-    FLATBUFFERS_ASSERT(false);
-    return false;
-  }
-
-  friend class Verifier;
-
-  const uint8_t *data_;
-  uint8_t parent_width_;
-  uint8_t byte_width_;
-  Type type_;
-};
-
-// Template specialization for As().
-template<> inline bool Reference::As<bool>() const { return AsBool(); }
-
-template<> inline int8_t Reference::As<int8_t>() const { return AsInt8(); }
-template<> inline int16_t Reference::As<int16_t>() const { return AsInt16(); }
-template<> inline int32_t Reference::As<int32_t>() const { return AsInt32(); }
-template<> inline int64_t Reference::As<int64_t>() const { return AsInt64(); }
-
-template<> inline uint8_t Reference::As<uint8_t>() const { return AsUInt8(); }
-template<> inline uint16_t Reference::As<uint16_t>() const {
-  return AsUInt16();
-}
-template<> inline uint32_t Reference::As<uint32_t>() const {
-  return AsUInt32();
-}
-template<> inline uint64_t Reference::As<uint64_t>() const {
-  return AsUInt64();
-}
-
-template<> inline double Reference::As<double>() const { return AsDouble(); }
-template<> inline float Reference::As<float>() const { return AsFloat(); }
-
-template<> inline String Reference::As<String>() const { return AsString(); }
-template<> inline std::string Reference::As<std::string>() const {
-  return AsString().str();
-}
-
-template<> inline Blob Reference::As<Blob>() const { return AsBlob(); }
-template<> inline Vector Reference::As<Vector>() const { return AsVector(); }
-template<> inline TypedVector Reference::As<TypedVector>() const {
-  return AsTypedVector();
-}
-template<> inline FixedTypedVector Reference::As<FixedTypedVector>() const {
-  return AsFixedTypedVector();
-}
-template<> inline Map Reference::As<Map>() const { return AsMap(); }
-
-inline uint8_t PackedType(BitWidth bit_width, Type type) {
-  return static_cast<uint8_t>(bit_width | (type << 2));
-}
-
-inline uint8_t NullPackedType() { return PackedType(BIT_WIDTH_8, FBT_NULL); }
-
-// Vector accessors.
-// Note: if you try to access outside of bounds, you get a Null value back
-// instead. Normally this would be an assert, but since this is "dynamically
-// typed" data, you may not want that (someone sends you a 2d vector and you
-// wanted 3d).
-// The Null converts seamlessly into a default value for any other type.
-// TODO(wvo): Could introduce an #ifdef that makes this into an assert?
-inline Reference Vector::operator[](size_t i) const {
-  auto len = size();
-  if (i >= len) return Reference(nullptr, 1, NullPackedType());
-  auto packed_type = (data_ + len * byte_width_)[i];
-  auto elem = data_ + i * byte_width_;
-  return Reference(elem, byte_width_, packed_type);
-}
-
-inline Reference TypedVector::operator[](size_t i) const {
-  auto len = size();
-  if (i >= len) return Reference(nullptr, 1, NullPackedType());
-  auto elem = data_ + i * byte_width_;
-  return Reference(elem, byte_width_, 1, type_);
-}
-
-inline Reference FixedTypedVector::operator[](size_t i) const {
-  if (i >= len_) return Reference(nullptr, 1, NullPackedType());
-  auto elem = data_ + i * byte_width_;
-  return Reference(elem, byte_width_, 1, type_);
-}
-
-template<typename T> int KeyCompare(const void *key, const void *elem) {
-  auto str_elem = reinterpret_cast<const char *>(
-      Indirect<T>(reinterpret_cast<const uint8_t *>(elem)));
-  auto skey = reinterpret_cast<const char *>(key);
-  return strcmp(skey, str_elem);
-}
-
-inline Reference Map::operator[](const char *key) const {
-  auto keys = Keys();
-  // We can't pass keys.byte_width_ to the comparison function, so we have
-  // to pick the right one ahead of time.
-  int (*comp)(const void *, const void *) = nullptr;
-  switch (keys.byte_width_) {
-    case 1: comp = KeyCompare<uint8_t>; break;
-    case 2: comp = KeyCompare<uint16_t>; break;
-    case 4: comp = KeyCompare<uint32_t>; break;
-    case 8: comp = KeyCompare<uint64_t>; break;
-    default: FLATBUFFERS_ASSERT(false); return Reference();
-  }
-  auto res = std::bsearch(key, keys.data_, keys.size(), keys.byte_width_, comp);
-  if (!res) return Reference(nullptr, 1, NullPackedType());
-  auto i = (reinterpret_cast<uint8_t *>(res) - keys.data_) / keys.byte_width_;
-  return (*static_cast<const Vector *>(this))[i];
-}
-
-inline Reference Map::operator[](const std::string &key) const {
-  return (*this)[key.c_str()];
-}
-
-inline Reference GetRoot(const uint8_t *buffer, size_t size) {
-  // See Finish() below for the serialization counterpart of this.
-  // The root starts at the end of the buffer, so we parse backwards from there.
-  auto end = buffer + size;
-  auto byte_width = *--end;
-  auto packed_type = *--end;
-  end -= byte_width;  // The root data item.
-  return Reference(end, byte_width, packed_type);
-}
-
-inline Reference GetRoot(const std::vector<uint8_t> &buffer) {
-  return GetRoot(buffer.data(), buffer.size());
-}
-
-// Flags that configure how the Builder behaves.
-// The "Share" flags determine if the Builder automatically tries to pool
-// this type. Pooling can reduce the size of serialized data if there are
-// multiple maps of the same kind, at the expense of slightly slower
-// serialization (the cost of lookups) and more memory use (std::set).
-// By default this is on for keys, but off for strings.
-// Turn keys off if you have e.g. only one map.
-// Turn strings on if you expect many non-unique string values.
-// Additionally, sharing key vectors can save space if you have maps with
-// identical field populations.
-enum BuilderFlag {
-  BUILDER_FLAG_NONE = 0,
-  BUILDER_FLAG_SHARE_KEYS = 1,
-  BUILDER_FLAG_SHARE_STRINGS = 2,
-  BUILDER_FLAG_SHARE_KEYS_AND_STRINGS = 3,
-  BUILDER_FLAG_SHARE_KEY_VECTORS = 4,
-  BUILDER_FLAG_SHARE_ALL = 7,
-};
-
-class Builder FLATBUFFERS_FINAL_CLASS {
- public:
-  Builder(size_t initial_size = 256,
-          BuilderFlag flags = BUILDER_FLAG_SHARE_KEYS)
-      : buf_(initial_size),
-        finished_(false),
-        has_duplicate_keys_(false),
-        flags_(flags),
-        force_min_bit_width_(BIT_WIDTH_8),
-        key_pool(KeyOffsetCompare(buf_)),
-        string_pool(StringOffsetCompare(buf_)) {
-    buf_.clear();
-  }
-
-#ifdef FLATBUFFERS_DEFAULT_DECLARATION
-  Builder(Builder &&) = default;
-  Builder &operator=(Builder &&) = default;
-#endif
-
-  /// @brief Get the serialized buffer (after you call `Finish()`).
-  /// @return Returns a vector owned by this class.
-  const std::vector<uint8_t> &GetBuffer() const {
-    Finished();
-    return buf_;
-  }
-
-  // Size of the buffer. Does not include unfinished values.
-  size_t GetSize() const { return buf_.size(); }
-
-  // Reset all state so we can re-use the buffer.
-  void Clear() {
-    buf_.clear();
-    stack_.clear();
-    finished_ = false;
-    // flags_ remains as-is;
-    force_min_bit_width_ = BIT_WIDTH_8;
-    key_pool.clear();
-    string_pool.clear();
-  }
-
-  // All value constructing functions below have two versions: one that
-  // takes a key (for placement inside a map) and one that doesn't (for inside
-  // vectors and elsewhere).
-
-  void Null() { stack_.push_back(Value()); }
-  void Null(const char *key) {
-    Key(key);
-    Null();
-  }
-
-  void Int(int64_t i) { stack_.push_back(Value(i, FBT_INT, WidthI(i))); }
-  void Int(const char *key, int64_t i) {
-    Key(key);
-    Int(i);
-  }
-
-  void UInt(uint64_t u) { stack_.push_back(Value(u, FBT_UINT, WidthU(u))); }
-  void UInt(const char *key, uint64_t u) {
-    Key(key);
-    UInt(u);
-  }
-
-  void Float(float f) { stack_.push_back(Value(f)); }
-  void Float(const char *key, float f) {
-    Key(key);
-    Float(f);
-  }
-
-  void Double(double f) { stack_.push_back(Value(f)); }
-  void Double(const char *key, double d) {
-    Key(key);
-    Double(d);
-  }
-
-  void Bool(bool b) { stack_.push_back(Value(b)); }
-  void Bool(const char *key, bool b) {
-    Key(key);
-    Bool(b);
-  }
-
-  void IndirectInt(int64_t i) { PushIndirect(i, FBT_INDIRECT_INT, WidthI(i)); }
-  void IndirectInt(const char *key, int64_t i) {
-    Key(key);
-    IndirectInt(i);
-  }
-
-  void IndirectUInt(uint64_t u) {
-    PushIndirect(u, FBT_INDIRECT_UINT, WidthU(u));
-  }
-  void IndirectUInt(const char *key, uint64_t u) {
-    Key(key);
-    IndirectUInt(u);
-  }
-
-  void IndirectFloat(float f) {
-    PushIndirect(f, FBT_INDIRECT_FLOAT, BIT_WIDTH_32);
-  }
-  void IndirectFloat(const char *key, float f) {
-    Key(key);
-    IndirectFloat(f);
-  }
-
-  void IndirectDouble(double f) {
-    PushIndirect(f, FBT_INDIRECT_FLOAT, WidthF(f));
-  }
-  void IndirectDouble(const char *key, double d) {
-    Key(key);
-    IndirectDouble(d);
-  }
-
-  size_t Key(const char *str, size_t len) {
-    auto sloc = buf_.size();
-    WriteBytes(str, len + 1);
-    if (flags_ & BUILDER_FLAG_SHARE_KEYS) {
-      auto it = key_pool.find(sloc);
-      if (it != key_pool.end()) {
-        // Already in the buffer. Remove key we just serialized, and use
-        // existing offset instead.
-        buf_.resize(sloc);
-        sloc = *it;
-      } else {
-        key_pool.insert(sloc);
-      }
-    }
-    stack_.push_back(Value(static_cast<uint64_t>(sloc), FBT_KEY, BIT_WIDTH_8));
-    return sloc;
-  }
-
-  size_t Key(const char *str) { return Key(str, strlen(str)); }
-  size_t Key(const std::string &str) { return Key(str.c_str(), str.size()); }
-
-  size_t String(const char *str, size_t len) {
-    auto reset_to = buf_.size();
-    auto sloc = CreateBlob(str, len, 1, FBT_STRING);
-    if (flags_ & BUILDER_FLAG_SHARE_STRINGS) {
-      StringOffset so(sloc, len);
-      auto it = string_pool.find(so);
-      if (it != string_pool.end()) {
-        // Already in the buffer. Remove string we just serialized, and use
-        // existing offset instead.
-        buf_.resize(reset_to);
-        sloc = it->first;
-        stack_.back().u_ = sloc;
-      } else {
-        string_pool.insert(so);
-      }
-    }
-    return sloc;
-  }
-  size_t String(const char *str) { return String(str, strlen(str)); }
-  size_t String(const std::string &str) {
-    return String(str.c_str(), str.size());
-  }
-  void String(const flexbuffers::String &str) {
-    String(str.c_str(), str.length());
-  }
-
-  void String(const char *key, const char *str) {
-    Key(key);
-    String(str);
-  }
-  void String(const char *key, const std::string &str) {
-    Key(key);
-    String(str);
-  }
-  void String(const char *key, const flexbuffers::String &str) {
-    Key(key);
-    String(str);
-  }
-
-  size_t Blob(const void *data, size_t len) {
-    return CreateBlob(data, len, 0, FBT_BLOB);
-  }
-  size_t Blob(const std::vector<uint8_t> &v) {
-    return CreateBlob(v.data(), v.size(), 0, FBT_BLOB);
-  }
-
-  void Blob(const char *key, const void *data, size_t len) {
-    Key(key);
-    Blob(data, len);
-  }
-  void Blob(const char *key, const std::vector<uint8_t> &v) {
-    Key(key);
-    Blob(v);
-  }
-
-  // TODO(wvo): support all the FlexBuffer types (like flexbuffers::String),
-  // e.g. Vector etc. Also in overloaded versions.
-  // Also some FlatBuffers types?
-
-  size_t StartVector() { return stack_.size(); }
-  size_t StartVector(const char *key) {
-    Key(key);
-    return stack_.size();
-  }
-  size_t StartMap() { return stack_.size(); }
-  size_t StartMap(const char *key) {
-    Key(key);
-    return stack_.size();
-  }
-
-  // TODO(wvo): allow this to specify an alignment greater than the natural
-  // alignment.
-  size_t EndVector(size_t start, bool typed, bool fixed) {
-    auto vec = CreateVector(start, stack_.size() - start, 1, typed, fixed);
-    // Remove temp elements and return vector.
-    stack_.resize(start);
-    stack_.push_back(vec);
-    return static_cast<size_t>(vec.u_);
-  }
-
-  size_t EndMap(size_t start) {
-    // We should have interleaved keys and values on the stack.
-    // Make sure it is an even number:
-    auto len = stack_.size() - start;
-    FLATBUFFERS_ASSERT(!(len & 1));
-    len /= 2;
-    // Make sure keys are all strings:
-    for (auto key = start; key < stack_.size(); key += 2) {
-      FLATBUFFERS_ASSERT(stack_[key].type_ == FBT_KEY);
-    }
-    // Now sort values, so later we can do a binary search lookup.
-    // We want to sort 2 array elements at a time.
-    struct TwoValue {
-      Value key;
-      Value val;
-    };
-    // TODO(wvo): strict aliasing?
-    // TODO(wvo): allow the caller to indicate the data is already sorted
-    // for maximum efficiency? With an assert to check sortedness to make sure
-    // we're not breaking binary search.
-    // Or, we can track if the map is sorted as keys are added which would be
-    // be quite cheap (cheaper than checking it here), so we can skip this
-    // step automatically when appliccable, and encourage people to write in
-    // sorted fashion.
-    // std::sort is typically already a lot faster on sorted data though.
-    auto dict = reinterpret_cast<TwoValue *>(stack_.data() + start);
-    std::sort(
-        dict, dict + len, [&](const TwoValue &a, const TwoValue &b) -> bool {
-          auto as = reinterpret_cast<const char *>(buf_.data() + a.key.u_);
-          auto bs = reinterpret_cast<const char *>(buf_.data() + b.key.u_);
-          auto comp = strcmp(as, bs);
-          // We want to disallow duplicate keys, since this results in a
-          // map where values cannot be found.
-          // But we can't assert here (since we don't want to fail on
-          // random JSON input) or have an error mechanism.
-          // Instead, we set has_duplicate_keys_ in the builder to
-          // signal this.
-          // TODO: Have to check for pointer equality, as some sort
-          // implementation apparently call this function with the same
-          // element?? Why?
-          if (!comp && &a != &b) has_duplicate_keys_ = true;
-          return comp < 0;
-        });
-    // First create a vector out of all keys.
-    // TODO(wvo): if kBuilderFlagShareKeyVectors is true, see if we can share
-    // the first vector.
-    auto keys = CreateVector(start, len, 2, true, false);
-    auto vec = CreateVector(start + 1, len, 2, false, false, &keys);
-    // Remove temp elements and return map.
-    stack_.resize(start);
-    stack_.push_back(vec);
-    return static_cast<size_t>(vec.u_);
-  }
-
-  // Call this after EndMap to see if the map had any duplicate keys.
-  // Any map with such keys won't be able to retrieve all values.
-  bool HasDuplicateKeys() const { return has_duplicate_keys_; }
-
-  template<typename F> size_t Vector(F f) {
-    auto start = StartVector();
-    f();
-    return EndVector(start, false, false);
-  }
-  template<typename F, typename T> size_t Vector(F f, T &state) {
-    auto start = StartVector();
-    f(state);
-    return EndVector(start, false, false);
-  }
-  template<typename F> size_t Vector(const char *key, F f) {
-    auto start = StartVector(key);
-    f();
-    return EndVector(start, false, false);
-  }
-  template<typename F, typename T>
-  size_t Vector(const char *key, F f, T &state) {
-    auto start = StartVector(key);
-    f(state);
-    return EndVector(start, false, false);
-  }
-
-  template<typename T> void Vector(const T *elems, size_t len) {
-    if (flatbuffers::is_scalar<T>::value) {
-      // This path should be a lot quicker and use less space.
-      ScalarVector(elems, len, false);
-    } else {
-      auto start = StartVector();
-      for (size_t i = 0; i < len; i++) Add(elems[i]);
-      EndVector(start, false, false);
-    }
-  }
-  template<typename T>
-  void Vector(const char *key, const T *elems, size_t len) {
-    Key(key);
-    Vector(elems, len);
-  }
-  template<typename T> void Vector(const std::vector<T> &vec) {
-    Vector(vec.data(), vec.size());
-  }
-
-  template<typename F> size_t TypedVector(F f) {
-    auto start = StartVector();
-    f();
-    return EndVector(start, true, false);
-  }
-  template<typename F, typename T> size_t TypedVector(F f, T &state) {
-    auto start = StartVector();
-    f(state);
-    return EndVector(start, true, false);
-  }
-  template<typename F> size_t TypedVector(const char *key, F f) {
-    auto start = StartVector(key);
-    f();
-    return EndVector(start, true, false);
-  }
-  template<typename F, typename T>
-  size_t TypedVector(const char *key, F f, T &state) {
-    auto start = StartVector(key);
-    f(state);
-    return EndVector(start, true, false);
-  }
-
-  template<typename T> size_t FixedTypedVector(const T *elems, size_t len) {
-    // We only support a few fixed vector lengths. Anything bigger use a
-    // regular typed vector.
-    FLATBUFFERS_ASSERT(len >= 2 && len <= 4);
-    // And only scalar values.
-    static_assert(flatbuffers::is_scalar<T>::value, "Unrelated types");
-    return ScalarVector(elems, len, true);
-  }
-
-  template<typename T>
-  size_t FixedTypedVector(const char *key, const T *elems, size_t len) {
-    Key(key);
-    return FixedTypedVector(elems, len);
-  }
-
-  template<typename F> size_t Map(F f) {
-    auto start = StartMap();
-    f();
-    return EndMap(start);
-  }
-  template<typename F, typename T> size_t Map(F f, T &state) {
-    auto start = StartMap();
-    f(state);
-    return EndMap(start);
-  }
-  template<typename F> size_t Map(const char *key, F f) {
-    auto start = StartMap(key);
-    f();
-    return EndMap(start);
-  }
-  template<typename F, typename T> size_t Map(const char *key, F f, T &state) {
-    auto start = StartMap(key);
-    f(state);
-    return EndMap(start);
-  }
-  template<typename T> void Map(const std::map<std::string, T> &map) {
-    auto start = StartMap();
-    for (auto it = map.begin(); it != map.end(); ++it)
-      Add(it->first.c_str(), it->second);
-    EndMap(start);
-  }
-
-  // If you wish to share a value explicitly (a value not shared automatically
-  // through one of the BUILDER_FLAG_SHARE_* flags) you can do so with these
-  // functions. Or if you wish to turn those flags off for performance reasons
-  // and still do some explicit sharing. For example:
-  // builder.IndirectDouble(M_PI);
-  // auto id = builder.LastValue();  // Remember where we stored it.
-  // .. more code goes here ..
-  // builder.ReuseValue(id);  // Refers to same double by offset.
-  // LastValue works regardless of whether the value has a key or not.
-  // Works on any data type.
-  struct Value;
-  Value LastValue() { return stack_.back(); }
-  void ReuseValue(Value v) { stack_.push_back(v); }
-  void ReuseValue(const char *key, Value v) {
-    Key(key);
-    ReuseValue(v);
-  }
-
-  // Overloaded Add that tries to call the correct function above.
-  void Add(int8_t i) { Int(i); }
-  void Add(int16_t i) { Int(i); }
-  void Add(int32_t i) { Int(i); }
-  void Add(int64_t i) { Int(i); }
-  void Add(uint8_t u) { UInt(u); }
-  void Add(uint16_t u) { UInt(u); }
-  void Add(uint32_t u) { UInt(u); }
-  void Add(uint64_t u) { UInt(u); }
-  void Add(float f) { Float(f); }
-  void Add(double d) { Double(d); }
-  void Add(bool b) { Bool(b); }
-  void Add(const char *str) { String(str); }
-  void Add(const std::string &str) { String(str); }
-  void Add(const flexbuffers::String &str) { String(str); }
-
-  template<typename T> void Add(const std::vector<T> &vec) { Vector(vec); }
-
-  template<typename T> void Add(const char *key, const T &t) {
-    Key(key);
-    Add(t);
-  }
-
-  template<typename T> void Add(const std::map<std::string, T> &map) {
-    Map(map);
-  }
-
-  template<typename T> void operator+=(const T &t) { Add(t); }
-
-  // This function is useful in combination with the Mutate* functions above.
-  // It forces elements of vectors and maps to have a minimum size, such that
-  // they can later be updated without failing.
-  // Call with no arguments to reset.
-  void ForceMinimumBitWidth(BitWidth bw = BIT_WIDTH_8) {
-    force_min_bit_width_ = bw;
-  }
-
-  void Finish() {
-    // If you hit this assert, you likely have objects that were never included
-    // in a parent. You need to have exactly one root to finish a buffer.
-    // Check your Start/End calls are matched, and all objects are inside
-    // some other object.
-    FLATBUFFERS_ASSERT(stack_.size() == 1);
-
-    // Write root value.
-    auto byte_width = Align(stack_[0].ElemWidth(buf_.size(), 0));
-    WriteAny(stack_[0], byte_width);
-    // Write root type.
-    Write(stack_[0].StoredPackedType(), 1);
-    // Write root size. Normally determined by parent, but root has no parent :)
-    Write(byte_width, 1);
-
-    finished_ = true;
-  }
-
- private:
-  void Finished() const {
-    // If you get this assert, you're attempting to get access a buffer
-    // which hasn't been finished yet. Be sure to call
-    // Builder::Finish with your root object.
-    FLATBUFFERS_ASSERT(finished_);
-  }
-
-  // Align to prepare for writing a scalar with a certain size.
-  uint8_t Align(BitWidth alignment) {
-    auto byte_width = 1U << alignment;
-    buf_.insert(buf_.end(), flatbuffers::PaddingBytes(buf_.size(), byte_width),
-                0);
-    return static_cast<uint8_t>(byte_width);
-  }
-
-  void WriteBytes(const void *val, size_t size) {
-    buf_.insert(buf_.end(), reinterpret_cast<const uint8_t *>(val),
-                reinterpret_cast<const uint8_t *>(val) + size);
-  }
-
-  template<typename T> void Write(T val, size_t byte_width) {
-    FLATBUFFERS_ASSERT(sizeof(T) >= byte_width);
-    val = flatbuffers::EndianScalar(val);
-    WriteBytes(&val, byte_width);
-  }
-
-  void WriteDouble(double f, uint8_t byte_width) {
-    switch (byte_width) {
-      case 8: Write(f, byte_width); break;
-      case 4: Write(static_cast<float>(f), byte_width); break;
-      // case 2: Write(static_cast<half>(f), byte_width); break;
-      // case 1: Write(static_cast<quarter>(f), byte_width); break;
-      default: FLATBUFFERS_ASSERT(0);
-    }
-  }
-
-  void WriteOffset(uint64_t o, uint8_t byte_width) {
-    auto reloff = buf_.size() - o;
-    FLATBUFFERS_ASSERT(byte_width == 8 || reloff < 1ULL << (byte_width * 8));
-    Write(reloff, byte_width);
-  }
-
-  template<typename T> void PushIndirect(T val, Type type, BitWidth bit_width) {
-    auto byte_width = Align(bit_width);
-    auto iloc = buf_.size();
-    Write(val, byte_width);
-    stack_.push_back(Value(static_cast<uint64_t>(iloc), type, bit_width));
-  }
-
-  static BitWidth WidthB(size_t byte_width) {
-    switch (byte_width) {
-      case 1: return BIT_WIDTH_8;
-      case 2: return BIT_WIDTH_16;
-      case 4: return BIT_WIDTH_32;
-      case 8: return BIT_WIDTH_64;
-      default: FLATBUFFERS_ASSERT(false); return BIT_WIDTH_64;
-    }
-  }
-
-  template<typename T> static Type GetScalarType() {
-    static_assert(flatbuffers::is_scalar<T>::value, "Unrelated types");
-    return flatbuffers::is_floating_point<T>::value
-               ? FBT_FLOAT
-               : flatbuffers::is_same<T, bool>::value
-                     ? FBT_BOOL
-                     : (flatbuffers::is_unsigned<T>::value ? FBT_UINT
-                                                           : FBT_INT);
-  }
-
- public:
-  // This was really intended to be private, except for LastValue/ReuseValue.
-  struct Value {
-    union {
-      int64_t i_;
-      uint64_t u_;
-      double f_;
-    };
-
-    Type type_;
-
-    // For scalars: of itself, for vector: of its elements, for string: length.
-    BitWidth min_bit_width_;
-
-    Value() : i_(0), type_(FBT_NULL), min_bit_width_(BIT_WIDTH_8) {}
-
-    Value(bool b)
-        : u_(static_cast<uint64_t>(b)),
-          type_(FBT_BOOL),
-          min_bit_width_(BIT_WIDTH_8) {}
-
-    Value(int64_t i, Type t, BitWidth bw)
-        : i_(i), type_(t), min_bit_width_(bw) {}
-    Value(uint64_t u, Type t, BitWidth bw)
-        : u_(u), type_(t), min_bit_width_(bw) {}
-
-    Value(float f)
-        : f_(static_cast<double>(f)),
-          type_(FBT_FLOAT),
-          min_bit_width_(BIT_WIDTH_32) {}
-    Value(double f) : f_(f), type_(FBT_FLOAT), min_bit_width_(WidthF(f)) {}
-
-    uint8_t StoredPackedType(BitWidth parent_bit_width_ = BIT_WIDTH_8) const {
-      return PackedType(StoredWidth(parent_bit_width_), type_);
-    }
-
-    BitWidth ElemWidth(size_t buf_size, size_t elem_index) const {
-      if (IsInline(type_)) {
-        return min_bit_width_;
-      } else {
-        // We have an absolute offset, but want to store a relative offset
-        // elem_index elements beyond the current buffer end. Since whether
-        // the relative offset fits in a certain byte_width depends on
-        // the size of the elements before it (and their alignment), we have
-        // to test for each size in turn.
-        for (size_t byte_width = 1;
-             byte_width <= sizeof(flatbuffers::largest_scalar_t);
-             byte_width *= 2) {
-          // Where are we going to write this offset?
-          auto offset_loc = buf_size +
-                            flatbuffers::PaddingBytes(buf_size, byte_width) +
-                            elem_index * byte_width;
-          // Compute relative offset.
-          auto offset = offset_loc - u_;
-          // Does it fit?
-          auto bit_width = WidthU(offset);
-          if (static_cast<size_t>(static_cast<size_t>(1U) << bit_width) ==
-              byte_width)
-            return bit_width;
-        }
-        FLATBUFFERS_ASSERT(false);  // Must match one of the sizes above.
-        return BIT_WIDTH_64;
-      }
-    }
-
-    BitWidth StoredWidth(BitWidth parent_bit_width_ = BIT_WIDTH_8) const {
-      if (IsInline(type_)) {
-        return (std::max)(min_bit_width_, parent_bit_width_);
-      } else {
-        return min_bit_width_;
-      }
-    }
-  };
-
- private:
-  void WriteAny(const Value &val, uint8_t byte_width) {
-    switch (val.type_) {
-      case FBT_NULL:
-      case FBT_INT: Write(val.i_, byte_width); break;
-      case FBT_BOOL:
-      case FBT_UINT: Write(val.u_, byte_width); break;
-      case FBT_FLOAT: WriteDouble(val.f_, byte_width); break;
-      default: WriteOffset(val.u_, byte_width); break;
-    }
-  }
-
-  size_t CreateBlob(const void *data, size_t len, size_t trailing, Type type) {
-    auto bit_width = WidthU(len);
-    auto byte_width = Align(bit_width);
-    Write<uint64_t>(len, byte_width);
-    auto sloc = buf_.size();
-    WriteBytes(data, len + trailing);
-    stack_.push_back(Value(static_cast<uint64_t>(sloc), type, bit_width));
-    return sloc;
-  }
-
-  template<typename T>
-  size_t ScalarVector(const T *elems, size_t len, bool fixed) {
-    auto vector_type = GetScalarType<T>();
-    auto byte_width = sizeof(T);
-    auto bit_width = WidthB(byte_width);
-    // If you get this assert, you're trying to write a vector with a size
-    // field that is bigger than the scalars you're trying to write (e.g. a
-    // byte vector > 255 elements). For such types, write a "blob" instead.
-    // TODO: instead of asserting, could write vector with larger elements
-    // instead, though that would be wasteful.
-    FLATBUFFERS_ASSERT(WidthU(len) <= bit_width);
-    Align(bit_width);
-    if (!fixed) Write<uint64_t>(len, byte_width);
-    auto vloc = buf_.size();
-    for (size_t i = 0; i < len; i++) Write(elems[i], byte_width);
-    stack_.push_back(Value(static_cast<uint64_t>(vloc),
-                           ToTypedVector(vector_type, fixed ? len : 0),
-                           bit_width));
-    return vloc;
-  }
-
-  Value CreateVector(size_t start, size_t vec_len, size_t step, bool typed,
-                     bool fixed, const Value *keys = nullptr) {
-    FLATBUFFERS_ASSERT(
-        !fixed ||
-        typed);  // typed=false, fixed=true combination is not supported.
-    // Figure out smallest bit width we can store this vector with.
-    auto bit_width = (std::max)(force_min_bit_width_, WidthU(vec_len));
-    auto prefix_elems = 1;
-    if (keys) {
-      // If this vector is part of a map, we will pre-fix an offset to the keys
-      // to this vector.
-      bit_width = (std::max)(bit_width, keys->ElemWidth(buf_.size(), 0));
-      prefix_elems += 2;
-    }
-    Type vector_type = FBT_KEY;
-    // Check bit widths and types for all elements.
-    for (size_t i = start; i < stack_.size(); i += step) {
-      auto elem_width =
-          stack_[i].ElemWidth(buf_.size(), i - start + prefix_elems);
-      bit_width = (std::max)(bit_width, elem_width);
-      if (typed) {
-        if (i == start) {
-          vector_type = stack_[i].type_;
-        } else {
-          // If you get this assert, you are writing a typed vector with
-          // elements that are not all the same type.
-          FLATBUFFERS_ASSERT(vector_type == stack_[i].type_);
-        }
-      }
-    }
-    // If you get this assert, your typed types are not one of:
-    // Int / UInt / Float / Key.
-    FLATBUFFERS_ASSERT(!typed || IsTypedVectorElementType(vector_type));
-    auto byte_width = Align(bit_width);
-    // Write vector. First the keys width/offset if available, and size.
-    if (keys) {
-      WriteOffset(keys->u_, byte_width);
-      Write<uint64_t>(1ULL << keys->min_bit_width_, byte_width);
-    }
-    if (!fixed) Write<uint64_t>(vec_len, byte_width);
-    // Then the actual data.
-    auto vloc = buf_.size();
-    for (size_t i = start; i < stack_.size(); i += step) {
-      WriteAny(stack_[i], byte_width);
-    }
-    // Then the types.
-    if (!typed) {
-      for (size_t i = start; i < stack_.size(); i += step) {
-        buf_.push_back(stack_[i].StoredPackedType(bit_width));
-      }
-    }
-    return Value(static_cast<uint64_t>(vloc),
-                 keys ? FBT_MAP
-                      : (typed ? ToTypedVector(vector_type, fixed ? vec_len : 0)
-                               : FBT_VECTOR),
-                 bit_width);
-  }
-
-  // You shouldn't really be copying instances of this class.
-  Builder(const Builder &);
-  Builder &operator=(const Builder &);
-
-  std::vector<uint8_t> buf_;
-  std::vector<Value> stack_;
-
-  bool finished_;
-  bool has_duplicate_keys_;
-
-  BuilderFlag flags_;
-
-  BitWidth force_min_bit_width_;
-
-  struct KeyOffsetCompare {
-    explicit KeyOffsetCompare(const std::vector<uint8_t> &buf) : buf_(&buf) {}
-    bool operator()(size_t a, size_t b) const {
-      auto stra = reinterpret_cast<const char *>(buf_->data() + a);
-      auto strb = reinterpret_cast<const char *>(buf_->data() + b);
-      return strcmp(stra, strb) < 0;
-    }
-    const std::vector<uint8_t> *buf_;
-  };
-
-  typedef std::pair<size_t, size_t> StringOffset;
-  struct StringOffsetCompare {
-    explicit StringOffsetCompare(const std::vector<uint8_t> &buf)
-        : buf_(&buf) {}
-    bool operator()(const StringOffset &a, const StringOffset &b) const {
-      auto stra = buf_->data() + a.first;
-      auto strb = buf_->data() + b.first;
-      auto cr = memcmp(stra, strb, (std::min)(a.second, b.second) + 1);
-      return cr < 0 || (cr == 0 && a.second < b.second);
-    }
-    const std::vector<uint8_t> *buf_;
-  };
-
-  typedef std::set<size_t, KeyOffsetCompare> KeyOffsetMap;
-  typedef std::set<StringOffset, StringOffsetCompare> StringOffsetMap;
-
-  KeyOffsetMap key_pool;
-  StringOffsetMap string_pool;
-
-  friend class Verifier;
-};
-
-// Helper class to verify the integrity of a FlexBuffer
-class Verifier FLATBUFFERS_FINAL_CLASS {
- public:
-  Verifier(const uint8_t *buf, size_t buf_len,
-           // Supplying this vector likely results in faster verification
-           // of larger buffers with many shared keys/strings, but
-           // comes at the cost of using additional memory the same size of
-           // the buffer being verified, so it is by default off.
-           std::vector<uint8_t> *reuse_tracker = nullptr,
-           bool _check_alignment = true, size_t max_depth = 64)
-      : buf_(buf),
-        size_(buf_len),
-        depth_(0),
-        max_depth_(max_depth),
-        num_vectors_(0),
-        max_vectors_(buf_len),
-        check_alignment_(_check_alignment),
-        reuse_tracker_(reuse_tracker) {
-    FLATBUFFERS_ASSERT(size_ < FLATBUFFERS_MAX_BUFFER_SIZE);
-    if (reuse_tracker_) {
-      reuse_tracker_->clear();
-      reuse_tracker_->resize(size_, PackedType(BIT_WIDTH_8, FBT_NULL));
-    }
-  }
-
- private:
-  // Central location where any verification failures register.
-  bool Check(bool ok) const {
-    // clang-format off
-    #ifdef FLATBUFFERS_DEBUG_VERIFICATION_FAILURE
-      FLATBUFFERS_ASSERT(ok);
-    #endif
-    // clang-format on
-    return ok;
-  }
-
-  // Verify any range within the buffer.
-  bool VerifyFrom(size_t elem, size_t elem_len) const {
-    return Check(elem_len < size_ && elem <= size_ - elem_len);
-  }
-  bool VerifyBefore(size_t elem, size_t elem_len) const {
-    return Check(elem_len <= elem);
-  }
-
-  bool VerifyFromPointer(const uint8_t *p, size_t len) {
-    auto o = static_cast<size_t>(p - buf_);
-    return VerifyFrom(o, len);
-  }
-  bool VerifyBeforePointer(const uint8_t *p, size_t len) {
-    auto o = static_cast<size_t>(p - buf_);
-    return VerifyBefore(o, len);
-  }
-
-  bool VerifyByteWidth(size_t width) {
-    return Check(width == 1 || width == 2 || width == 4 || width == 8);
-  }
-
-  bool VerifyType(int type) { return Check(type >= 0 && type < FBT_MAX_TYPE); }
-
-  bool VerifyOffset(uint64_t off, const uint8_t *p) {
-    return Check(off <= static_cast<uint64_t>(size_)) &&
-           off <= static_cast<uint64_t>(p - buf_);
-  }
-
-  bool VerifyAlignment(const uint8_t *p, size_t size) const {
-    auto o = static_cast<size_t>(p - buf_);
-    return Check((o & (size - 1)) == 0 || !check_alignment_);
-  }
-
-// Macro, since we want to escape from parent function & use lazy args.
-#define FLEX_CHECK_VERIFIED(P, PACKED_TYPE)                     \
-  if (reuse_tracker_) {                                         \
-    auto packed_type = PACKED_TYPE;                             \
-    auto existing = (*reuse_tracker_)[P - buf_];                \
-    if (existing == packed_type) return true;                   \
-    /* Fail verification if already set with different type! */ \
-    if (!Check(existing == 0)) return false;                    \
-    (*reuse_tracker_)[P - buf_] = packed_type;                  \
-  }
-
-  bool VerifyVector(Reference r, const uint8_t *p, Type elem_type) {
-    // Any kind of nesting goes thru this function, so guard against that
-    // here, both with simple nesting checks, and the reuse tracker if on.
-    depth_++;
-    num_vectors_++;
-    if (!Check(depth_ <= max_depth_ && num_vectors_ <= max_vectors_))
-      return false;
-    auto size_byte_width = r.byte_width_;
-    FLEX_CHECK_VERIFIED(p,
-                        PackedType(Builder::WidthB(size_byte_width), r.type_));
-    if (!VerifyBeforePointer(p, size_byte_width)) return false;
-    auto sized = Sized(p, size_byte_width);
-    auto num_elems = sized.size();
-    auto elem_byte_width = r.type_ == FBT_STRING || r.type_ == FBT_BLOB
-                               ? uint8_t(1)
-                               : r.byte_width_;
-    auto max_elems = SIZE_MAX / elem_byte_width;
-    if (!Check(num_elems < max_elems))
-      return false;  // Protect against byte_size overflowing.
-    auto byte_size = num_elems * elem_byte_width;
-    if (!VerifyFromPointer(p, byte_size)) return false;
-    if (elem_type == FBT_NULL) {
-      // Verify type bytes after the vector.
-      if (!VerifyFromPointer(p + byte_size, num_elems)) return false;
-      auto v = Vector(p, size_byte_width);
-      for (size_t i = 0; i < num_elems; i++)
-        if (!VerifyRef(v[i])) return false;
-    } else if (elem_type == FBT_KEY) {
-      auto v = TypedVector(p, elem_byte_width, FBT_KEY);
-      for (size_t i = 0; i < num_elems; i++)
-        if (!VerifyRef(v[i])) return false;
-    } else {
-      FLATBUFFERS_ASSERT(IsInline(elem_type));
-    }
-    depth_--;
-    return true;
-  }
-
-  bool VerifyKeys(const uint8_t *p, uint8_t byte_width) {
-    // The vector part of the map has already been verified.
-    const size_t num_prefixed_fields = 3;
-    if (!VerifyBeforePointer(p, byte_width * num_prefixed_fields)) return false;
-    p -= byte_width * num_prefixed_fields;
-    auto off = ReadUInt64(p, byte_width);
-    if (!VerifyOffset(off, p)) return false;
-    auto key_byte_with =
-        static_cast<uint8_t>(ReadUInt64(p + byte_width, byte_width));
-    if (!VerifyByteWidth(key_byte_with)) return false;
-    return VerifyVector(Reference(p, byte_width, key_byte_with, FBT_VECTOR_KEY),
-                        p - off, FBT_KEY);
-  }
-
-  bool VerifyKey(const uint8_t *p) {
-    FLEX_CHECK_VERIFIED(p, PackedType(BIT_WIDTH_8, FBT_KEY));
-    while (p < buf_ + size_)
-      if (*p++) return true;
-    return false;
-  }
-
-#undef FLEX_CHECK_VERIFIED
-
-  bool VerifyTerminator(const String &s) {
-    return VerifyFromPointer(reinterpret_cast<const uint8_t *>(s.c_str()),
-                             s.size() + 1);
-  }
-
-  bool VerifyRef(Reference r) {
-    // r.parent_width_ and r.data_ already verified.
-    if (!VerifyByteWidth(r.byte_width_) || !VerifyType(r.type_)) {
-      return false;
-    }
-    if (IsInline(r.type_)) {
-      // Inline scalars, don't require further verification.
-      return true;
-    }
-    // All remaining types are an offset.
-    auto off = ReadUInt64(r.data_, r.parent_width_);
-    if (!VerifyOffset(off, r.data_)) return false;
-    auto p = r.Indirect();
-    if (!VerifyAlignment(p, r.byte_width_)) return false;
-    switch (r.type_) {
-      case FBT_INDIRECT_INT:
-      case FBT_INDIRECT_UINT:
-      case FBT_INDIRECT_FLOAT: return VerifyFromPointer(p, r.byte_width_);
-      case FBT_KEY: return VerifyKey(p);
-      case FBT_MAP:
-        return VerifyVector(r, p, FBT_NULL) && VerifyKeys(p, r.byte_width_);
-      case FBT_VECTOR: return VerifyVector(r, p, FBT_NULL);
-      case FBT_VECTOR_INT: return VerifyVector(r, p, FBT_INT);
-      case FBT_VECTOR_BOOL:
-      case FBT_VECTOR_UINT: return VerifyVector(r, p, FBT_UINT);
-      case FBT_VECTOR_FLOAT: return VerifyVector(r, p, FBT_FLOAT);
-      case FBT_VECTOR_KEY: return VerifyVector(r, p, FBT_KEY);
-      case FBT_VECTOR_STRING_DEPRECATED:
-        // Use of FBT_KEY here intentional, see elsewhere.
-        return VerifyVector(r, p, FBT_KEY);
-      case FBT_BLOB: return VerifyVector(r, p, FBT_UINT);
-      case FBT_STRING:
-        return VerifyVector(r, p, FBT_UINT) &&
-               VerifyTerminator(String(p, r.byte_width_));
-      case FBT_VECTOR_INT2:
-      case FBT_VECTOR_UINT2:
-      case FBT_VECTOR_FLOAT2:
-      case FBT_VECTOR_INT3:
-      case FBT_VECTOR_UINT3:
-      case FBT_VECTOR_FLOAT3:
-      case FBT_VECTOR_INT4:
-      case FBT_VECTOR_UINT4:
-      case FBT_VECTOR_FLOAT4: {
-        uint8_t len = 0;
-        auto vtype = ToFixedTypedVectorElementType(r.type_, &len);
-        if (!VerifyType(vtype)) return false;
-        return VerifyFromPointer(p, r.byte_width_ * len);
-      }
-      default: return false;
-    }
-  }
-
- public:
-  bool VerifyBuffer() {
-    if (!Check(size_ >= 3)) return false;
-    auto end = buf_ + size_;
-    auto byte_width = *--end;
-    auto packed_type = *--end;
-    return VerifyByteWidth(byte_width) && Check(end - buf_ >= byte_width) &&
-           VerifyRef(Reference(end - byte_width, byte_width, packed_type));
-  }
-
- private:
-  const uint8_t *buf_;
-  size_t size_;
-  size_t depth_;
-  const size_t max_depth_;
-  size_t num_vectors_;
-  const size_t max_vectors_;
-  bool check_alignment_;
-  std::vector<uint8_t> *reuse_tracker_;
-};
-
-// Utility function that contructs the Verifier for you, see above for
-// parameters.
-inline bool VerifyBuffer(const uint8_t *buf, size_t buf_len,
-                         std::vector<uint8_t> *reuse_tracker = nullptr) {
-  Verifier verifier(buf, buf_len, reuse_tracker);
-  return verifier.VerifyBuffer();
-}
-
-}  // namespace flexbuffers
-
-#if defined(_MSC_VER)
-#  pragma warning(pop)
-#endif
-
-#endif  // FLATBUFFERS_FLEXBUFFERS_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/grpc.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/grpc.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/grpc.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/grpc.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,302 +0,0 @@
-/*
- * Copyright 2014 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_GRPC_H_
-#define FLATBUFFERS_GRPC_H_
-
-// Helper functionality to glue FlatBuffers and GRPC.
-
-#include "flatbuffers/flatbuffers.h"
-#include "grpc/byte_buffer_reader.h"
-#include "grpcpp/support/byte_buffer.h"
-#include "grpcpp/support/slice.h"
-
-namespace mapserver {
-namespace flatbuffers {
-namespace grpc {
-
-// Message is a typed wrapper around a buffer that manages the underlying
-// `grpc_slice` and also provides flatbuffers-specific helpers such as `Verify`
-// and `GetRoot`. Since it is backed by a `grpc_slice`, the underlying buffer
-// is refcounted and ownership is be managed automatically.
-template<class T> class Message {
- public:
-  Message() {}
-
-  Message(::grpc::Slice slice) : slice_(slice) {}
-
-  Message &operator=(const Message &other) = delete;
-
-  Message(Message &&other) = default;
-
-  Message(const Message &other) = delete;
-
-  Message &operator=(Message &&other) = default;
-
-  const uint8_t *mutable_data() const { return slice_.begin(); }
-
-  const uint8_t *data() const { return slice_.begin(); }
-
-  size_t size() const { return slice_.size(); }
-
-  bool Verify() const {
-    Verifier verifier(data(), size());
-    return verifier.VerifyBuffer<T>(nullptr);
-  }
-
-  T *GetMutableRoot() { return flatbuffers::GetMutableRoot<T>(mutable_data()); }
-
-  const T *GetRoot() const { return flatbuffers::GetRoot<T>(data()); }
-
-  // This is only intended for serializer use, or if you know what you're doing
-  const ::grpc::Slice &BorrowSlice() const { return slice_; }
-
- private:
-  ::grpc::Slice slice_;
-};
-
-class MessageBuilder;
-
-// SliceAllocator is a gRPC-specific allocator that uses the `grpc_slice`
-// refcounted slices to manage memory ownership. This makes it easy and
-// efficient to transfer buffers to gRPC.
-class SliceAllocator : public Allocator {
- public:
-  SliceAllocator() {}
-
-  SliceAllocator(const SliceAllocator &other) = delete;
-  SliceAllocator &operator=(const SliceAllocator &other) = delete;
-
-  SliceAllocator(SliceAllocator &&other) {
-    // default-construct and swap idiom
-    swap(other);
-  }
-
-  SliceAllocator &operator=(SliceAllocator &&other) {
-    // move-construct and swap idiom
-    SliceAllocator temp(std::move(other));
-    swap(temp);
-    return *this;
-  }
-
-  void swap(SliceAllocator &other) {
-    using std::swap;
-    swap(slice_, other.slice_);
-  }
-
-  virtual ~SliceAllocator() {}
-
-  virtual uint8_t *allocate(size_t size) override {
-    FLATBUFFERS_ASSERT(slice_.size() == 0);
-    slice_ = ::grpc::Slice(size);
-    return const_cast<uint8_t *>(slice_.begin());
-  }
-
-  virtual void deallocate(uint8_t *p, size_t size) override {
-    FLATBUFFERS_ASSERT(p == slice_.begin());
-    FLATBUFFERS_ASSERT(size == slice_.size());
-    slice_ = ::grpc::Slice();
-  }
-
-  virtual uint8_t *reallocate_downward(uint8_t *old_p, size_t old_size,
-                                       size_t new_size, size_t in_use_back,
-                                       size_t in_use_front) override {
-    FLATBUFFERS_ASSERT(old_p == slice_.begin());
-    FLATBUFFERS_ASSERT(old_size == slice_.size());
-    FLATBUFFERS_ASSERT(new_size > old_size);
-    ::grpc::Slice old_slice = slice_;
-    ::grpc::Slice new_slice = ::grpc::Slice(new_size);
-    uint8_t *new_p = const_cast<uint8_t *>(new_slice.begin());
-    memcpy_downward(old_p, old_size, new_p, new_size, in_use_back,
-                    in_use_front);
-    slice_ = new_slice;
-    return new_p;
-  }
-
- private:
-  ::grpc::Slice &get_slice(uint8_t *p, size_t size) {
-    FLATBUFFERS_ASSERT(p == slice_.begin());
-    FLATBUFFERS_ASSERT(size == slice_.size());
-    return slice_;
-  }
-
-  ::grpc::Slice slice_;
-
-  friend class MessageBuilder;
-};
-
-// SliceAllocatorMember is a hack to ensure that the MessageBuilder's
-// slice_allocator_ member is constructed before the FlatBufferBuilder, since
-// the allocator is used in the FlatBufferBuilder ctor.
-namespace detail {
-struct SliceAllocatorMember {
-  SliceAllocator slice_allocator_;
-};
-}  // namespace detail
-
-// MessageBuilder is a gRPC-specific FlatBufferBuilder that uses SliceAllocator
-// to allocate gRPC buffers.
-class MessageBuilder : private detail::SliceAllocatorMember,
-                       public FlatBufferBuilder {
- public:
-  explicit MessageBuilder(uoffset_t initial_size = 1024)
-      : FlatBufferBuilder(initial_size, &slice_allocator_, false) {}
-
-  MessageBuilder(const MessageBuilder &other) = delete;
-  MessageBuilder &operator=(const MessageBuilder &other) = delete;
-
-  MessageBuilder(MessageBuilder &&other)
-      : FlatBufferBuilder(1024, &slice_allocator_, false) {
-    // Default construct and swap idiom.
-    Swap(other);
-  }
-
-  /// Create a MessageBuilder from a FlatBufferBuilder.
-  explicit MessageBuilder(FlatBufferBuilder &&src,
-                          void (*dealloc)(void *,
-                                          size_t) = &DefaultAllocator::dealloc)
-      : FlatBufferBuilder(1024, &slice_allocator_, false) {
-    src.Swap(*this);
-    src.SwapBufAllocator(*this);
-    if (buf_.capacity()) {
-      uint8_t *buf = buf_.scratch_data();  // pointer to memory
-      size_t capacity = buf_.capacity();   // size of memory
-      slice_allocator_.slice_ = ::grpc::Slice(buf, capacity, dealloc);
-    } else {
-      slice_allocator_.slice_ = ::grpc::Slice();
-    }
-  }
-
-  /// Move-assign a FlatBufferBuilder to a MessageBuilder.
-  /// Only FlatBufferBuilder with default allocator (basically, nullptr) is
-  /// supported.
-  MessageBuilder &operator=(FlatBufferBuilder &&src) {
-    // Move construct a temporary and swap
-    MessageBuilder temp(std::move(src));
-    Swap(temp);
-    return *this;
-  }
-
-  MessageBuilder &operator=(MessageBuilder &&other) {
-    // Move construct a temporary and swap
-    MessageBuilder temp(std::move(other));
-    Swap(temp);
-    return *this;
-  }
-
-  void Swap(MessageBuilder &other) {
-    slice_allocator_.swap(other.slice_allocator_);
-    FlatBufferBuilder::Swap(other);
-    // After swapping the FlatBufferBuilder, we swap back the allocator, which
-    // restores the original allocator back in place. This is necessary because
-    // MessageBuilder's allocator is its own member (SliceAllocatorMember). The
-    // allocator passed to FlatBufferBuilder::vector_downward must point to this
-    // member.
-    buf_.swap_allocator(other.buf_);
-  }
-
-  // Releases the ownership of the buffer pointer.
-  // Returns the size, offset, and the original grpc_slice that
-  // allocated the buffer. Also see grpc_slice_unref().
-  uint8_t *ReleaseRaw(size_t &size, size_t &offset, ::grpc::Slice &slice) {
-    uint8_t *buf = FlatBufferBuilder::ReleaseRaw(size, offset);
-    slice = slice_allocator_.slice_;
-    slice_allocator_.slice_ = ::grpc::Slice();
-    return buf;
-  }
-
-  ~MessageBuilder() {}
-
-  // GetMessage extracts the subslice of the buffer corresponding to the
-  // flatbuffers-encoded region and wraps it in a `Message<T>` to handle buffer
-  // ownership.
-  template<class T> Message<T> GetMessage() {
-    auto buf_data = buf_.scratch_data();  // pointer to memory
-    auto buf_size = buf_.capacity();      // size of memory
-    auto msg_data = buf_.data();          // pointer to msg
-    auto msg_size = buf_.size();          // size of msg
-    // Do some sanity checks on data/size
-    FLATBUFFERS_ASSERT(msg_data);
-    FLATBUFFERS_ASSERT(msg_size);
-    FLATBUFFERS_ASSERT(msg_data >= buf_data);
-    FLATBUFFERS_ASSERT(msg_data + msg_size <= buf_data + buf_size);
-    // Calculate offsets from the buffer start
-    auto begin = msg_data - buf_data;
-    auto end = begin + msg_size;
-    // Get the slice we are working with (no refcount change)
-    ::grpc::Slice slice = slice_allocator_.get_slice(buf_data, buf_size);
-    // Extract a subslice of the existing slice (increment refcount)
-    ::grpc::Slice subslice = slice.sub(begin, end);
-    // Wrap the subslice in a `Message<T>`, but don't increment refcount
-    Message<T> msg(subslice);
-    return msg;
-  }
-
-  template<class T> Message<T> ReleaseMessage() {
-    Message<T> msg = GetMessage<T>();
-    Reset();
-    return msg;
-  }
-
- private:
-  // SliceAllocator slice_allocator_;  // part of SliceAllocatorMember
-};
-
-}  // namespace grpc
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-namespace grpc {
-
-template<class T> class SerializationTraits<flatbuffers::grpc::Message<T>> {
- public:
-  static grpc::Status Serialize(const flatbuffers::grpc::Message<T> &msg,
-                                ByteBuffer *buffer, bool *own_buffer) {
-    // Package the single slice into a `ByteBuffer`,
-    // incrementing the refcount in the process.
-    *buffer = ByteBuffer(&msg.BorrowSlice(), 1);
-    *own_buffer = true;
-    return grpc::Status::OK;
-  }
-
-  // Deserialize by pulling the
-  static grpc::Status Deserialize(ByteBuffer *buf,
-                                  flatbuffers::grpc::Message<T> *msg) {
-    Slice slice;
-    if (!buf->TrySingleSlice(&slice).ok()) {
-      if (!buf->DumpToSingleSlice(&slice).ok()) {
-        buf->Clear();
-        return ::grpc::Status(::grpc::StatusCode::INTERNAL, "No payload");
-      }
-    }
-    *msg = flatbuffers::grpc::Message<T>(slice);
-    buf->Clear();
-#if FLATBUFFERS_GRPC_DISABLE_AUTO_VERIFICATION
-    return ::grpc::Status::OK;
-#else
-    if (msg->Verify()) {
-      return ::grpc::Status::OK;
-    } else {
-      return ::grpc::Status(::grpc::StatusCode::INTERNAL,
-                            "Message verification failed");
-    }
-#endif
-  }
-};
-
-}  // namespace grpc
-
-#endif  // FLATBUFFERS_GRPC_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/hash.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/hash.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/hash.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/hash.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,129 +0,0 @@
-/*
- * Copyright 2015 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_HASH_H_
-#define FLATBUFFERS_HASH_H_
-
-#include <cstdint>
-#include <cstring>
-
-#include "flatbuffers/flatbuffers.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-template<typename T> struct FnvTraits {
-  static const T kFnvPrime;
-  static const T kOffsetBasis;
-};
-
-template<> struct FnvTraits<uint32_t> {
-  static const uint32_t kFnvPrime = 0x01000193;
-  static const uint32_t kOffsetBasis = 0x811C9DC5;
-};
-
-template<> struct FnvTraits<uint64_t> {
-  static const uint64_t kFnvPrime = 0x00000100000001b3ULL;
-  static const uint64_t kOffsetBasis = 0xcbf29ce484222645ULL;
-};
-
-template<typename T> T HashFnv1(const char *input) {
-  T hash = FnvTraits<T>::kOffsetBasis;
-  for (const char *c = input; *c; ++c) {
-    hash *= FnvTraits<T>::kFnvPrime;
-    hash ^= static_cast<unsigned char>(*c);
-  }
-  return hash;
-}
-
-template<typename T> T HashFnv1a(const char *input) {
-  T hash = FnvTraits<T>::kOffsetBasis;
-  for (const char *c = input; *c; ++c) {
-    hash ^= static_cast<unsigned char>(*c);
-    hash *= FnvTraits<T>::kFnvPrime;
-  }
-  return hash;
-}
-
-template<> inline uint16_t HashFnv1<uint16_t>(const char *input) {
-  uint32_t hash = HashFnv1<uint32_t>(input);
-  return (hash >> 16) ^ (hash & 0xffff);
-}
-
-template<> inline uint16_t HashFnv1a<uint16_t>(const char *input) {
-  uint32_t hash = HashFnv1a<uint32_t>(input);
-  return (hash >> 16) ^ (hash & 0xffff);
-}
-
-template<typename T> struct NamedHashFunction {
-  const char *name;
-
-  typedef T (*HashFunction)(const char *);
-  HashFunction function;
-};
-
-const NamedHashFunction<uint16_t> kHashFunctions16[] = {
-  { "fnv1_16", HashFnv1<uint16_t> },
-  { "fnv1a_16", HashFnv1a<uint16_t> },
-};
-
-const NamedHashFunction<uint32_t> kHashFunctions32[] = {
-  { "fnv1_32", HashFnv1<uint32_t> },
-  { "fnv1a_32", HashFnv1a<uint32_t> },
-};
-
-const NamedHashFunction<uint64_t> kHashFunctions64[] = {
-  { "fnv1_64", HashFnv1<uint64_t> },
-  { "fnv1a_64", HashFnv1a<uint64_t> },
-};
-
-inline NamedHashFunction<uint16_t>::HashFunction FindHashFunction16(
-    const char *name) {
-  std::size_t size = sizeof(kHashFunctions16) / sizeof(kHashFunctions16[0]);
-  for (std::size_t i = 0; i < size; ++i) {
-    if (std::strcmp(name, kHashFunctions16[i].name) == 0) {
-      return kHashFunctions16[i].function;
-    }
-  }
-  return nullptr;
-}
-
-inline NamedHashFunction<uint32_t>::HashFunction FindHashFunction32(
-    const char *name) {
-  std::size_t size = sizeof(kHashFunctions32) / sizeof(kHashFunctions32[0]);
-  for (std::size_t i = 0; i < size; ++i) {
-    if (std::strcmp(name, kHashFunctions32[i].name) == 0) {
-      return kHashFunctions32[i].function;
-    }
-  }
-  return nullptr;
-}
-
-inline NamedHashFunction<uint64_t>::HashFunction FindHashFunction64(
-    const char *name) {
-  std::size_t size = sizeof(kHashFunctions64) / sizeof(kHashFunctions64[0]);
-  for (std::size_t i = 0; i < size; ++i) {
-    if (std::strcmp(name, kHashFunctions64[i].name) == 0) {
-      return kHashFunctions64[i].function;
-    }
-  }
-  return nullptr;
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_HASH_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/idl.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/idl.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/idl.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/idl.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1234 +0,0 @@
-/*
- * Copyright 2014 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_IDL_H_
-#define FLATBUFFERS_IDL_H_
-
-#include <functional>
-#include <map>
-#include <memory>
-#include <stack>
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/flatbuffers.h"
-#include "flatbuffers/flexbuffers.h"
-#include "flatbuffers/hash.h"
-#include "flatbuffers/reflection.h"
-
-// This file defines the data types representing a parsed IDL (Interface
-// Definition Language) / schema file.
-
-// Limits maximum depth of nested objects.
-// Prevents stack overflow while parse scheme, or json, or flexbuffer.
-#if !defined(FLATBUFFERS_MAX_PARSING_DEPTH)
-#  define FLATBUFFERS_MAX_PARSING_DEPTH 64
-#endif
-
-namespace mapserver {
-namespace flatbuffers {
-
-// The order of these matters for Is*() functions below.
-// Additionally, Parser::ParseType assumes bool..string is a contiguous range
-// of type tokens.
-// clang-format off
-#define FLATBUFFERS_GEN_TYPES_SCALAR(TD) \
-  TD(NONE,   "",       uint8_t,  byte,   byte,    byte,   uint8,   u8,   UByte, UInt8) \
-  TD(UTYPE,  "",       uint8_t,  byte,   byte,    byte,   uint8,   u8,   UByte, UInt8) /* begin scalar/int */ \
-  TD(BOOL,   "bool",   uint8_t,  boolean,bool,    bool,   bool,    bool, Boolean, Bool) \
-  TD(CHAR,   "byte",   int8_t,   byte,   int8,    sbyte,  int8,    i8,   Byte, Int8) \
-  TD(UCHAR,  "ubyte",  uint8_t,  byte,   byte,    byte,   uint8,   u8,   UByte, UInt8) \
-  TD(SHORT,  "short",  int16_t,  short,  int16,   short,  int16,   i16,  Short, Int16) \
-  TD(USHORT, "ushort", uint16_t, short,  uint16,  ushort, uint16,  u16,  UShort, UInt16) \
-  TD(INT,    "int",    int32_t,  int,    int32,   int,    int32,   i32,  Int, Int32) \
-  TD(UINT,   "uint",   uint32_t, int,    uint32,  uint,   uint32,  u32,  UInt, UInt32) \
-  TD(LONG,   "long",   int64_t,  long,   int64,   long,   int64,   i64,  Long, Int64) \
-  TD(ULONG,  "ulong",  uint64_t, long,   uint64,  ulong,  uint64,  u64,  ULong, UInt64) /* end int */ \
-  TD(FLOAT,  "float",  float,    float,  float32, float,  float32, f32,  Float, Float32) /* begin float */ \
-  TD(DOUBLE, "double", double,   double, float64, double, float64, f64,  Double, Double) /* end float/scalar */
-#define FLATBUFFERS_GEN_TYPES_POINTER(TD) \
-  TD(STRING, "string", Offset<void>, int, int, StringOffset, int, unused, Int, Offset<String>) \
-  TD(VECTOR, "",       Offset<void>, int, int, VectorOffset, int, unused, Int, Offset<UOffset>) \
-  TD(STRUCT, "",       Offset<void>, int, int, int,          int, unused, Int, Offset<UOffset>) \
-  TD(UNION,  "",       Offset<void>, int, int, int,          int, unused, Int, Offset<UOffset>)
-#define FLATBUFFERS_GEN_TYPE_ARRAY(TD) \
-  TD(ARRAY,  "",       int,          int, int, int,          int, unused, Int, Offset<UOffset>)
-// The fields are:
-// - enum
-// - FlatBuffers schema type.
-// - C++ type.
-// - Java type.
-// - Go type.
-// - C# / .Net type.
-// - Python type.
-// - Kotlin type.
-// - Rust type.
-
-// using these macros, we can now write code dealing with types just once, e.g.
-
-/*
-switch (type) {
-  #define FLATBUFFERS_TD(ENUM, IDLTYPE, CTYPE, JTYPE, GTYPE, NTYPE, PTYPE, \
-                         RTYPE, KTYPE) \
-    case BASE_TYPE_ ## ENUM: \
-      // do something specific to CTYPE here
-    FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
-  #undef FLATBUFFERS_TD
-}
-*/
-
-// If not all FLATBUFFERS_GEN_() arguments are necessary for implementation
-// of FLATBUFFERS_TD, you can use a variadic macro (with __VA_ARGS__ if needed).
-// In the above example, only CTYPE is used to generate the code, it can be rewritten:
-
-/*
-switch (type) {
-  #define FLATBUFFERS_TD(ENUM, IDLTYPE, CTYPE, ...) \
-    case BASE_TYPE_ ## ENUM: \
-      // do something specific to CTYPE here
-    FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
-  #undef FLATBUFFERS_TD
-}
-*/
-
-#define FLATBUFFERS_GEN_TYPES(TD) \
-        FLATBUFFERS_GEN_TYPES_SCALAR(TD) \
-        FLATBUFFERS_GEN_TYPES_POINTER(TD) \
-        FLATBUFFERS_GEN_TYPE_ARRAY(TD)
-
-// Create an enum for all the types above.
-#ifdef __GNUC__
-__extension__  // Stop GCC complaining about trailing comma with -Wpendantic.
-#endif
-enum BaseType {
-  #define FLATBUFFERS_TD(ENUM, ...) \
-    BASE_TYPE_ ## ENUM,
-    FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
-  #undef FLATBUFFERS_TD
-};
-
-#define FLATBUFFERS_TD(ENUM, IDLTYPE, CTYPE, ...) \
-  static_assert(sizeof(CTYPE) <= sizeof(largest_scalar_t), \
-                "define largest_scalar_t as " #CTYPE);
-  FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
-#undef FLATBUFFERS_TD
-
-inline bool IsScalar (BaseType t) { return t >= BASE_TYPE_UTYPE &&
-                                           t <= BASE_TYPE_DOUBLE; }
-inline bool IsInteger(BaseType t) { return t >= BASE_TYPE_UTYPE &&
-                                           t <= BASE_TYPE_ULONG; }
-inline bool IsFloat  (BaseType t) { return t == BASE_TYPE_FLOAT ||
-                                           t == BASE_TYPE_DOUBLE; }
-inline bool IsLong   (BaseType t) { return t == BASE_TYPE_LONG ||
-                                           t == BASE_TYPE_ULONG; }
-inline bool IsBool   (BaseType t) { return t == BASE_TYPE_BOOL; }
-inline bool IsOneByte(BaseType t) { return t >= BASE_TYPE_UTYPE &&
-                                           t <= BASE_TYPE_UCHAR; }
-
-inline bool IsUnsigned(BaseType t) {
-  return (t == BASE_TYPE_UTYPE)  || (t == BASE_TYPE_UCHAR) ||
-         (t == BASE_TYPE_USHORT) || (t == BASE_TYPE_UINT)  ||
-         (t == BASE_TYPE_ULONG);
-}
-
-// clang-format on
-
-extern const char *const kTypeNames[];
-extern const char kTypeSizes[];
-
-inline size_t SizeOf(BaseType t) { return kTypeSizes[t]; }
-
-struct StructDef;
-struct EnumDef;
-class Parser;
-
-// Represents any type in the IDL, which is a combination of the BaseType
-// and additional information for vectors/structs_.
-struct Type {
-  explicit Type(BaseType _base_type = BASE_TYPE_NONE, StructDef *_sd = nullptr,
-                EnumDef *_ed = nullptr, uint16_t _fixed_length = 0)
-      : base_type(_base_type),
-        element(BASE_TYPE_NONE),
-        struct_def(_sd),
-        enum_def(_ed),
-        fixed_length(_fixed_length) {}
-
-  bool operator==(const Type &o) {
-    return base_type == o.base_type && element == o.element &&
-           struct_def == o.struct_def && enum_def == o.enum_def;
-  }
-
-  Type VectorType() const {
-    return Type(element, struct_def, enum_def, fixed_length);
-  }
-
-  Offset<reflection::Type> Serialize(FlatBufferBuilder *builder) const;
-
-  bool Deserialize(const Parser &parser, const reflection::Type *type);
-
-  BaseType base_type;
-  BaseType element;       // only set if t == BASE_TYPE_VECTOR
-  StructDef *struct_def;  // only set if t or element == BASE_TYPE_STRUCT
-  EnumDef *enum_def;      // set if t == BASE_TYPE_UNION / BASE_TYPE_UTYPE,
-                          // or for an integral type derived from an enum.
-  uint16_t fixed_length;  // only set if t == BASE_TYPE_ARRAY
-};
-
-// Represents a parsed scalar value, it's type, and field offset.
-struct Value {
-  Value()
-      : constant("0"),
-        offset(static_cast<voffset_t>(~(static_cast<voffset_t>(0U)))) {}
-  Type type;
-  std::string constant;
-  voffset_t offset;
-};
-
-// Helper class that retains the original order of a set of identifiers and
-// also provides quick lookup.
-template<typename T> class SymbolTable {
- public:
-  ~SymbolTable() {
-    for (auto it = vec.begin(); it != vec.end(); ++it) { delete *it; }
-  }
-
-  bool Add(const std::string &name, T *e) {
-    vec.emplace_back(e);
-    auto it = dict.find(name);
-    if (it != dict.end()) return true;
-    dict[name] = e;
-    return false;
-  }
-
-  void Move(const std::string &oldname, const std::string &newname) {
-    auto it = dict.find(oldname);
-    if (it != dict.end()) {
-      auto obj = it->second;
-      dict.erase(it);
-      dict[newname] = obj;
-    } else {
-      FLATBUFFERS_ASSERT(false);
-    }
-  }
-
-  T *Lookup(const std::string &name) const {
-    auto it = dict.find(name);
-    return it == dict.end() ? nullptr : it->second;
-  }
-
- public:
-  std::map<std::string, T *> dict;  // quick lookup
-  std::vector<T *> vec;             // Used to iterate in order of insertion
-};
-
-// A name space, as set in the schema.
-struct Namespace {
-  Namespace() : from_table(0) {}
-
-  // Given a (potentially unqualified) name, return the "fully qualified" name
-  // which has a full namespaced descriptor.
-  // With max_components you can request less than the number of components
-  // the current namespace has.
-  std::string GetFullyQualifiedName(const std::string &name,
-                                    size_t max_components = 1000) const;
-
-  std::vector<std::string> components;
-  size_t from_table;  // Part of the namespace corresponds to a message/table.
-};
-
-inline bool operator<(const Namespace &a, const Namespace &b) {
-  size_t min_size = std::min(a.components.size(), b.components.size());
-  for (size_t i = 0; i < min_size; ++i) {
-    if (a.components[i] != b.components[i])
-      return a.components[i] < b.components[i];
-  }
-  return a.components.size() < b.components.size();
-}
-
-// Base class for all definition types (fields, structs_, enums_).
-struct Definition {
-  Definition()
-      : generated(false),
-        defined_namespace(nullptr),
-        serialized_location(0),
-        index(-1),
-        refcount(1),
-        declaration_file(nullptr) {}
-
-  flatbuffers::Offset<
-      flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>>
-  SerializeAttributes(FlatBufferBuilder *builder, const Parser &parser) const;
-
-  bool DeserializeAttributes(Parser &parser,
-                             const Vector<Offset<reflection::KeyValue>> *attrs);
-
-  std::string name;
-  std::string file;
-  std::vector<std::string> doc_comment;
-  SymbolTable<Value> attributes;
-  bool generated;  // did we already output code for this definition?
-  Namespace *defined_namespace;  // Where it was defined.
-
-  // For use with Serialize()
-  uoffset_t serialized_location;
-  int index;  // Inside the vector it is stored.
-  int refcount;
-  const std::string *declaration_file;
-};
-
-struct FieldDef : public Definition {
-  FieldDef()
-      : deprecated(false),
-        key(false),
-        shared(false),
-        native_inline(false),
-        flexbuffer(false),
-        presence(kDefault),
-        nested_flatbuffer(NULL),
-        padding(0) {}
-
-  Offset<reflection::Field> Serialize(FlatBufferBuilder *builder, uint16_t id,
-                                      const Parser &parser) const;
-
-  bool Deserialize(Parser &parser, const reflection::Field *field);
-
-  bool IsScalarOptional() const {
-    return IsScalar(value.type.base_type) && IsOptional();
-  }
-  bool IsOptional() const { return presence == kOptional; }
-  bool IsRequired() const { return presence == kRequired; }
-  bool IsDefault() const { return presence == kDefault; }
-
-  Value value;
-  bool deprecated;  // Field is allowed to be present in old data, but can't be.
-                    // written in new data nor accessed in new code.
-  bool key;         // Field functions as a key for creating sorted vectors.
-  bool shared;  // Field will be using string pooling (i.e. CreateSharedString)
-                // as default serialization behavior if field is a string.
-  bool native_inline;  // Field will be defined inline (instead of as a pointer)
-                       // for native tables if field is a struct.
-  bool flexbuffer;     // This field contains FlexBuffer data.
-
-  enum Presence {
-    // Field must always be present.
-    kRequired,
-    // Non-presence should be signalled to and controlled by users.
-    kOptional,
-    // Non-presence is hidden from users.
-    // Implementations may omit writing default values.
-    kDefault,
-  };
-  Presence static MakeFieldPresence(bool optional, bool required) {
-    FLATBUFFERS_ASSERT(!(required && optional));
-    // clang-format off
-    return required ? FieldDef::kRequired
-         : optional ? FieldDef::kOptional
-                    : FieldDef::kDefault;
-    // clang-format on
-  }
-  Presence presence;
-
-  StructDef *nested_flatbuffer;  // This field contains nested FlatBuffer data.
-  size_t padding;                // Bytes to always pad after this field.
-};
-
-struct StructDef : public Definition {
-  StructDef()
-      : fixed(false),
-        predecl(true),
-        sortbysize(true),
-        has_key(false),
-        minalign(1),
-        bytesize(0) {}
-
-  void PadLastField(size_t min_align) {
-    auto padding = PaddingBytes(bytesize, min_align);
-    bytesize += padding;
-    if (fields.vec.size()) fields.vec.back()->padding = padding;
-  }
-
-  Offset<reflection::Object> Serialize(FlatBufferBuilder *builder,
-                                       const Parser &parser) const;
-
-  bool Deserialize(Parser &parser, const reflection::Object *object);
-
-  SymbolTable<FieldDef> fields;
-
-  bool fixed;       // If it's struct, not a table.
-  bool predecl;     // If it's used before it was defined.
-  bool sortbysize;  // Whether fields come in the declaration or size order.
-  bool has_key;     // It has a key field.
-  size_t minalign;  // What the whole object needs to be aligned to.
-  size_t bytesize;  // Size if fixed.
-
-  flatbuffers::unique_ptr<std::string> original_location;
-};
-
-struct EnumDef;
-struct EnumValBuilder;
-
-struct EnumVal {
-  Offset<reflection::EnumVal> Serialize(FlatBufferBuilder *builder,
-                                        const Parser &parser) const;
-
-  bool Deserialize(const Parser &parser, const reflection::EnumVal *val);
-
-  uint64_t GetAsUInt64() const { return static_cast<uint64_t>(value); }
-  int64_t GetAsInt64() const { return value; }
-  bool IsZero() const { return 0 == value; }
-  bool IsNonZero() const { return !IsZero(); }
-
-  std::string name;
-  std::vector<std::string> doc_comment;
-  Type union_type;
-
- private:
-  friend EnumDef;
-  friend EnumValBuilder;
-  friend bool operator==(const EnumVal &lhs, const EnumVal &rhs);
-
-  EnumVal(const std::string &_name, int64_t _val) : name(_name), value(_val) {}
-  EnumVal() : value(0) {}
-
-  int64_t value;
-};
-
-struct EnumDef : public Definition {
-  EnumDef() : is_union(false), uses_multiple_type_instances(false) {}
-
-  Offset<reflection::Enum> Serialize(FlatBufferBuilder *builder,
-                                     const Parser &parser) const;
-
-  bool Deserialize(Parser &parser, const reflection::Enum *values);
-
-  template<typename T> void ChangeEnumValue(EnumVal *ev, T new_val);
-  void SortByValue();
-  void RemoveDuplicates();
-
-  std::string AllFlags() const;
-  const EnumVal *MinValue() const;
-  const EnumVal *MaxValue() const;
-  // Returns the number of integer steps from v1 to v2.
-  uint64_t Distance(const EnumVal *v1, const EnumVal *v2) const;
-  // Returns the number of integer steps from Min to Max.
-  uint64_t Distance() const { return Distance(MinValue(), MaxValue()); }
-
-  EnumVal *ReverseLookup(int64_t enum_idx,
-                         bool skip_union_default = false) const;
-  EnumVal *FindByValue(const std::string &constant) const;
-
-  std::string ToString(const EnumVal &ev) const {
-    return IsUInt64() ? NumToString(ev.GetAsUInt64())
-                      : NumToString(ev.GetAsInt64());
-  }
-
-  size_t size() const { return vals.vec.size(); }
-
-  const std::vector<EnumVal *> &Vals() const { return vals.vec; }
-
-  const EnumVal *Lookup(const std::string &enum_name) const {
-    return vals.Lookup(enum_name);
-  }
-
-  bool is_union;
-  // Type is a union which uses type aliases where at least one type is
-  // available under two different names.
-  bool uses_multiple_type_instances;
-  Type underlying_type;
-
- private:
-  bool IsUInt64() const {
-    return (BASE_TYPE_ULONG == underlying_type.base_type);
-  }
-
-  friend EnumValBuilder;
-  SymbolTable<EnumVal> vals;
-};
-
-inline bool IsString(const Type &type) {
-  return type.base_type == BASE_TYPE_STRING;
-}
-
-inline bool IsStruct(const Type &type) {
-  return type.base_type == BASE_TYPE_STRUCT && type.struct_def->fixed;
-}
-
-inline bool IsUnion(const Type &type) {
-  return type.enum_def != nullptr && type.enum_def->is_union;
-}
-
-inline bool IsUnionType(const Type &type) {
-  return IsUnion(type) && IsInteger(type.base_type);
-}
-
-inline bool IsVector(const Type &type) {
-  return type.base_type == BASE_TYPE_VECTOR;
-}
-
-inline bool IsArray(const Type &type) {
-  return type.base_type == BASE_TYPE_ARRAY;
-}
-
-inline bool IsSeries(const Type &type) {
-  return IsVector(type) || IsArray(type);
-}
-
-inline bool IsEnum(const Type &type) {
-  return type.enum_def != nullptr && IsInteger(type.base_type);
-}
-
-inline size_t InlineSize(const Type &type) {
-  return IsStruct(type)
-             ? type.struct_def->bytesize
-             : (IsArray(type)
-                    ? InlineSize(type.VectorType()) * type.fixed_length
-                    : SizeOf(type.base_type));
-}
-
-inline size_t InlineAlignment(const Type &type) {
-  if (IsStruct(type)) {
-    return type.struct_def->minalign;
-  } else if (IsArray(type)) {
-    return IsStruct(type.VectorType()) ? type.struct_def->minalign
-                                       : SizeOf(type.element);
-  } else {
-    return SizeOf(type.base_type);
-  }
-}
-inline bool operator==(const EnumVal &lhs, const EnumVal &rhs) {
-  return lhs.value == rhs.value;
-}
-inline bool operator!=(const EnumVal &lhs, const EnumVal &rhs) {
-  return !(lhs == rhs);
-}
-
-inline bool EqualByName(const Type &a, const Type &b) {
-  return a.base_type == b.base_type && a.element == b.element &&
-         (a.struct_def == b.struct_def ||
-          a.struct_def->name == b.struct_def->name) &&
-         (a.enum_def == b.enum_def || a.enum_def->name == b.enum_def->name);
-}
-
-struct RPCCall : public Definition {
-  Offset<reflection::RPCCall> Serialize(FlatBufferBuilder *builder,
-                                        const Parser &parser) const;
-
-  bool Deserialize(Parser &parser, const reflection::RPCCall *call);
-
-  StructDef *request, *response;
-};
-
-struct ServiceDef : public Definition {
-  Offset<reflection::Service> Serialize(FlatBufferBuilder *builder,
-                                        const Parser &parser) const;
-  bool Deserialize(Parser &parser, const reflection::Service *service);
-
-  SymbolTable<RPCCall> calls;
-};
-
-// Container of options that may apply to any of the source/text generators.
-struct IDLOptions {
-  // field case style options for C++
-  enum CaseStyle { CaseStyle_Unchanged = 0, CaseStyle_Upper, CaseStyle_Lower };
-
-  bool gen_jvmstatic;
-  // Use flexbuffers instead for binary and text generation
-  bool use_flexbuffers;
-  bool strict_json;
-  bool output_default_scalars_in_json;
-  int indent_step;
-  bool output_enum_identifiers;
-  bool prefixed_enums;
-  bool scoped_enums;
-  bool swift_implementation_only;
-  bool include_dependence_headers;
-  bool mutable_buffer;
-  bool one_file;
-  bool proto_mode;
-  bool proto_oneof_union;
-  bool generate_all;
-  bool skip_unexpected_fields_in_json;
-  bool generate_name_strings;
-  bool generate_object_based_api;
-  bool gen_compare;
-  std::string cpp_object_api_pointer_type;
-  std::string cpp_object_api_string_type;
-  bool cpp_object_api_string_flexible_constructor;
-  CaseStyle cpp_object_api_field_case_style;
-  bool cpp_direct_copy;
-  bool gen_nullable;
-  bool java_checkerframework;
-  bool gen_generated;
-  bool gen_json_coders;
-  std::string object_prefix;
-  std::string object_suffix;
-  bool union_value_namespacing;
-  bool allow_non_utf8;
-  bool natural_utf8;
-  std::string include_prefix;
-  bool keep_include_path;
-  bool binary_schema_comments;
-  bool binary_schema_builtins;
-  bool binary_schema_gen_embed;
-  std::string go_import;
-  std::string go_namespace;
-  bool protobuf_ascii_alike;
-  bool size_prefixed;
-  std::string root_type;
-  bool force_defaults;
-  bool java_primitive_has_method;
-  bool cs_gen_json_serializer;
-  std::vector<std::string> cpp_includes;
-  std::string cpp_std;
-  bool cpp_static_reflection;
-  std::string proto_namespace_suffix;
-  std::string filename_suffix;
-  std::string filename_extension;
-  bool no_warnings;
-  bool warnings_as_errors;
-  std::string project_root;
-  bool cs_global_alias;
-  bool json_nested_flatbuffers;
-  bool json_nested_flexbuffers;
-  bool json_nested_legacy_flatbuffers;
-  bool ts_flat_file;
-
-  // Possible options for the more general generator below.
-  enum Language {
-    kJava = 1 << 0,
-    kCSharp = 1 << 1,
-    kGo = 1 << 2,
-    kCpp = 1 << 3,
-    kPython = 1 << 5,
-    kPhp = 1 << 6,
-    kJson = 1 << 7,
-    kBinary = 1 << 8,
-    kTs = 1 << 9,
-    kJsonSchema = 1 << 10,
-    kDart = 1 << 11,
-    kLua = 1 << 12,
-    kLobster = 1 << 13,
-    kRust = 1 << 14,
-    kKotlin = 1 << 15,
-    kSwift = 1 << 16,
-    kMAX
-  };
-
-  enum MiniReflect { kNone, kTypes, kTypesAndNames };
-
-  MiniReflect mini_reflect;
-
-  // If set, require all fields in a table to be explicitly numbered.
-  bool require_explicit_ids;
-
-  // If set, implement serde::Serialize for generated Rust types
-  bool rust_serialize;
-
-  // If set, generate rust types in individual files with a root module file.
-  bool rust_module_root_file;
-
-  // The corresponding language bit will be set if a language is included
-  // for code generation.
-  unsigned long lang_to_generate;
-
-  // If set (default behavior), empty string fields will be set to nullptr to
-  // make the flatbuffer more compact.
-  bool set_empty_strings_to_null;
-
-  // If set (default behavior), empty vector fields will be set to nullptr to
-  // make the flatbuffer more compact.
-  bool set_empty_vectors_to_null;
-
-  IDLOptions()
-      : gen_jvmstatic(false),
-        use_flexbuffers(false),
-        strict_json(false),
-        output_default_scalars_in_json(false),
-        indent_step(2),
-        output_enum_identifiers(true),
-        prefixed_enums(true),
-        scoped_enums(false),
-        swift_implementation_only(false),
-        include_dependence_headers(true),
-        mutable_buffer(false),
-        one_file(false),
-        proto_mode(false),
-        proto_oneof_union(false),
-        generate_all(false),
-        skip_unexpected_fields_in_json(false),
-        generate_name_strings(false),
-        generate_object_based_api(false),
-        gen_compare(false),
-        cpp_object_api_pointer_type("std::unique_ptr"),
-        cpp_object_api_string_flexible_constructor(false),
-        cpp_object_api_field_case_style(CaseStyle_Unchanged),
-        cpp_direct_copy(true),
-        gen_nullable(false),
-        java_checkerframework(false),
-        gen_generated(false),
-        gen_json_coders(false),
-        object_suffix("T"),
-        union_value_namespacing(true),
-        allow_non_utf8(false),
-        natural_utf8(false),
-        keep_include_path(false),
-        binary_schema_comments(false),
-        binary_schema_builtins(false),
-        binary_schema_gen_embed(false),
-        protobuf_ascii_alike(false),
-        size_prefixed(false),
-        force_defaults(false),
-        java_primitive_has_method(false),
-        cs_gen_json_serializer(false),
-        cpp_static_reflection(false),
-        filename_suffix("_generated"),
-        filename_extension(),
-        no_warnings(false),
-        warnings_as_errors(false),
-        project_root(""),
-        cs_global_alias(false),
-        json_nested_flatbuffers(true),
-        json_nested_flexbuffers(true),
-        json_nested_legacy_flatbuffers(false),
-        ts_flat_file(false),
-        mini_reflect(IDLOptions::kNone),
-        require_explicit_ids(false),
-        rust_serialize(false),
-        rust_module_root_file(false),
-        lang_to_generate(0),
-        set_empty_strings_to_null(true),
-        set_empty_vectors_to_null(true) {}
-};
-
-// This encapsulates where the parser is in the current source file.
-struct ParserState {
-  ParserState()
-      : cursor_(nullptr),
-        line_start_(nullptr),
-        line_(0),
-        token_(-1),
-        attr_is_trivial_ascii_string_(true) {}
-
- protected:
-  void ResetState(const char *source) {
-    cursor_ = source;
-    line_ = 0;
-    MarkNewLine();
-  }
-
-  void MarkNewLine() {
-    line_start_ = cursor_;
-    line_ += 1;
-  }
-
-  int64_t CursorPosition() const {
-    FLATBUFFERS_ASSERT(cursor_ && line_start_ && cursor_ >= line_start_);
-    return static_cast<int64_t>(cursor_ - line_start_);
-  }
-
-  const char *cursor_;
-  const char *line_start_;
-  int line_;  // the current line being parsed
-  int token_;
-
-  // Flag: text in attribute_ is true ASCII string without escape
-  // sequences. Only printable ASCII (without [\t\r\n]).
-  // Used for number-in-string (and base64 string in future).
-  bool attr_is_trivial_ascii_string_;
-  std::string attribute_;
-  std::vector<std::string> doc_comment_;
-};
-
-// A way to make error propagation less error prone by requiring values to be
-// checked.
-// Once you create a value of this type you must either:
-// - Call Check() on it.
-// - Copy or assign it to another value.
-// Failure to do so leads to an assert.
-// This guarantees that this as return value cannot be ignored.
-class CheckedError {
- public:
-  explicit CheckedError(bool error)
-      : is_error_(error), has_been_checked_(false) {}
-
-  CheckedError &operator=(const CheckedError &other) {
-    is_error_ = other.is_error_;
-    has_been_checked_ = false;
-    other.has_been_checked_ = true;
-    return *this;
-  }
-
-  CheckedError(const CheckedError &other) {
-    *this = other;  // Use assignment operator.
-  }
-
-  ~CheckedError() { FLATBUFFERS_ASSERT(has_been_checked_); }
-
-  bool Check() {
-    has_been_checked_ = true;
-    return is_error_;
-  }
-
- private:
-  bool is_error_;
-  mutable bool has_been_checked_;
-};
-
-// Additionally, in GCC we can get these errors statically, for additional
-// assurance:
-// clang-format off
-#ifdef __GNUC__
-#define FLATBUFFERS_CHECKED_ERROR CheckedError \
-          __attribute__((warn_unused_result))
-#else
-#define FLATBUFFERS_CHECKED_ERROR CheckedError
-#endif
-// clang-format on
-
-class Parser : public ParserState {
- public:
-  explicit Parser(const IDLOptions &options = IDLOptions())
-      : current_namespace_(nullptr),
-        empty_namespace_(nullptr),
-        flex_builder_(256, flexbuffers::BUILDER_FLAG_SHARE_ALL),
-        root_struct_def_(nullptr),
-        opts(options),
-        uses_flexbuffers_(false),
-        has_warning_(false),
-        advanced_features_(0),
-        source_(nullptr),
-        anonymous_counter_(0),
-        parse_depth_counter_(0) {
-    if (opts.force_defaults) { builder_.ForceDefaults(true); }
-    // Start out with the empty namespace being current.
-    empty_namespace_ = new Namespace();
-    namespaces_.push_back(empty_namespace_);
-    current_namespace_ = empty_namespace_;
-    known_attributes_["deprecated"] = true;
-    known_attributes_["required"] = true;
-    known_attributes_["key"] = true;
-    known_attributes_["shared"] = true;
-    known_attributes_["hash"] = true;
-    known_attributes_["id"] = true;
-    known_attributes_["force_align"] = true;
-    known_attributes_["bit_flags"] = true;
-    known_attributes_["original_order"] = true;
-    known_attributes_["nested_flatbuffer"] = true;
-    known_attributes_["csharp_partial"] = true;
-    known_attributes_["streaming"] = true;
-    known_attributes_["idempotent"] = true;
-    known_attributes_["cpp_type"] = true;
-    known_attributes_["cpp_ptr_type"] = true;
-    known_attributes_["cpp_ptr_type_get"] = true;
-    known_attributes_["cpp_str_type"] = true;
-    known_attributes_["cpp_str_flex_ctor"] = true;
-    known_attributes_["native_inline"] = true;
-    known_attributes_["native_custom_alloc"] = true;
-    known_attributes_["native_type"] = true;
-    known_attributes_["native_type_pack_name"] = true;
-    known_attributes_["native_default"] = true;
-    known_attributes_["flexbuffer"] = true;
-    known_attributes_["private"] = true;
-  }
-
-  ~Parser() {
-    for (auto it = namespaces_.begin(); it != namespaces_.end(); ++it) {
-      delete *it;
-    }
-  }
-
-  // Parse the string containing either schema or JSON data, which will
-  // populate the SymbolTable's or the FlatBufferBuilder above.
-  // include_paths is used to resolve any include statements, and typically
-  // should at least include the project path (where you loaded source_ from).
-  // include_paths must be nullptr terminated if specified.
-  // If include_paths is nullptr, it will attempt to load from the current
-  // directory.
-  // If the source was loaded from a file and isn't an include file,
-  // supply its name in source_filename.
-  // All paths specified in this call must be in posix format, if you accept
-  // paths from user input, please call PosixPath on them first.
-  bool Parse(const char *_source, const char **include_paths = nullptr,
-             const char *source_filename = nullptr);
-
-  bool ParseJson(const char *json, const char *json_filename = nullptr);
-
-  // Set the root type. May override the one set in the schema.
-  bool SetRootType(const char *name);
-
-  // Mark all definitions as already having code generated.
-  void MarkGenerated();
-
-  // Get the files recursively included by the given file. The returned
-  // container will have at least the given file.
-  std::set<std::string> GetIncludedFilesRecursive(
-      const std::string &file_name) const;
-
-  // Fills builder_ with a binary version of the schema parsed.
-  // See reflection/reflection.fbs
-  void Serialize();
-
-  // Deserialize a schema buffer
-  bool Deserialize(const uint8_t *buf, const size_t size);
-
-  // Fills internal structure as if the schema passed had been loaded by parsing
-  // with Parse except that included filenames will not be populated.
-  bool Deserialize(const reflection::Schema *schema);
-
-  Type *DeserializeType(const reflection::Type *type);
-
-  // Checks that the schema represented by this parser is a safe evolution
-  // of the schema provided. Returns non-empty error on any problems.
-  std::string ConformTo(const Parser &base);
-
-  // Similar to Parse(), but now only accepts JSON to be parsed into a
-  // FlexBuffer.
-  bool ParseFlexBuffer(const char *source, const char *source_filename,
-                       flexbuffers::Builder *builder);
-
-  StructDef *LookupStruct(const std::string &id) const;
-  StructDef *LookupStructThruParentNamespaces(const std::string &id) const;
-
-  std::string UnqualifiedName(const std::string &fullQualifiedName);
-
-  FLATBUFFERS_CHECKED_ERROR Error(const std::string &msg);
-
-  // @brief Verify that any of 'opts.lang_to_generate' supports Optional scalars
-  // in a schema.
-  // @param opts Options used to parce a schema and generate code.
-  static bool SupportsOptionalScalars(const flatbuffers::IDLOptions &opts);
-
- private:
-  class ParseDepthGuard;
-
-  void Message(const std::string &msg);
-  void Warning(const std::string &msg);
-  FLATBUFFERS_CHECKED_ERROR ParseHexNum(int nibbles, uint64_t *val);
-  FLATBUFFERS_CHECKED_ERROR Next();
-  FLATBUFFERS_CHECKED_ERROR SkipByteOrderMark();
-  bool Is(int t) const;
-  bool IsIdent(const char *id) const;
-  FLATBUFFERS_CHECKED_ERROR Expect(int t);
-  std::string TokenToStringId(int t) const;
-  EnumDef *LookupEnum(const std::string &id);
-  FLATBUFFERS_CHECKED_ERROR ParseNamespacing(std::string *id,
-                                             std::string *last);
-  FLATBUFFERS_CHECKED_ERROR ParseTypeIdent(Type &type);
-  FLATBUFFERS_CHECKED_ERROR ParseType(Type &type);
-  FLATBUFFERS_CHECKED_ERROR AddField(StructDef &struct_def,
-                                     const std::string &name, const Type &type,
-                                     FieldDef **dest);
-  FLATBUFFERS_CHECKED_ERROR ParseField(StructDef &struct_def);
-  FLATBUFFERS_CHECKED_ERROR ParseString(Value &val, bool use_string_pooling);
-  FLATBUFFERS_CHECKED_ERROR ParseComma();
-  FLATBUFFERS_CHECKED_ERROR ParseAnyValue(Value &val, FieldDef *field,
-                                          size_t parent_fieldn,
-                                          const StructDef *parent_struct_def,
-                                          uoffset_t count,
-                                          bool inside_vector = false);
-  template<typename F>
-  FLATBUFFERS_CHECKED_ERROR ParseTableDelimiters(size_t &fieldn,
-                                                 const StructDef *struct_def,
-                                                 F body);
-  FLATBUFFERS_CHECKED_ERROR ParseTable(const StructDef &struct_def,
-                                       std::string *value, uoffset_t *ovalue);
-  void SerializeStruct(const StructDef &struct_def, const Value &val);
-  void SerializeStruct(FlatBufferBuilder &builder, const StructDef &struct_def,
-                       const Value &val);
-  template<typename F>
-  FLATBUFFERS_CHECKED_ERROR ParseVectorDelimiters(uoffset_t &count, F body);
-  FLATBUFFERS_CHECKED_ERROR ParseVector(const Type &type, uoffset_t *ovalue,
-                                        FieldDef *field, size_t fieldn);
-  FLATBUFFERS_CHECKED_ERROR ParseArray(Value &array);
-  FLATBUFFERS_CHECKED_ERROR ParseNestedFlatbuffer(
-      Value &val, FieldDef *field, size_t fieldn,
-      const StructDef *parent_struct_def);
-  FLATBUFFERS_CHECKED_ERROR ParseMetaData(SymbolTable<Value> *attributes);
-  FLATBUFFERS_CHECKED_ERROR TryTypedValue(const std::string *name, int dtoken,
-                                          bool check, Value &e, BaseType req,
-                                          bool *destmatch);
-  FLATBUFFERS_CHECKED_ERROR ParseHash(Value &e, FieldDef *field);
-  FLATBUFFERS_CHECKED_ERROR TokenError();
-  FLATBUFFERS_CHECKED_ERROR ParseSingleValue(const std::string *name, Value &e,
-                                             bool check_now);
-  FLATBUFFERS_CHECKED_ERROR ParseFunction(const std::string *name, Value &e);
-  FLATBUFFERS_CHECKED_ERROR ParseEnumFromString(const Type &type,
-                                                std::string *result);
-  StructDef *LookupCreateStruct(const std::string &name,
-                                bool create_if_new = true,
-                                bool definition = false);
-  FLATBUFFERS_CHECKED_ERROR ParseEnum(bool is_union, EnumDef **dest,
-                                      const char *filename);
-  FLATBUFFERS_CHECKED_ERROR ParseNamespace();
-  FLATBUFFERS_CHECKED_ERROR StartStruct(const std::string &name,
-                                        StructDef **dest);
-  FLATBUFFERS_CHECKED_ERROR StartEnum(const std::string &name, bool is_union,
-                                      EnumDef **dest);
-  FLATBUFFERS_CHECKED_ERROR ParseDecl(const char *filename);
-  FLATBUFFERS_CHECKED_ERROR ParseService(const char *filename);
-  FLATBUFFERS_CHECKED_ERROR ParseProtoFields(StructDef *struct_def,
-                                             bool isextend, bool inside_oneof);
-  FLATBUFFERS_CHECKED_ERROR ParseProtoOption();
-  FLATBUFFERS_CHECKED_ERROR ParseProtoKey();
-  FLATBUFFERS_CHECKED_ERROR ParseProtoDecl();
-  FLATBUFFERS_CHECKED_ERROR ParseProtoCurliesOrIdent();
-  FLATBUFFERS_CHECKED_ERROR ParseTypeFromProtoType(Type *type);
-  FLATBUFFERS_CHECKED_ERROR SkipAnyJsonValue();
-  FLATBUFFERS_CHECKED_ERROR ParseFlexBufferNumericConstant(
-      flexbuffers::Builder *builder);
-  FLATBUFFERS_CHECKED_ERROR ParseFlexBufferValue(flexbuffers::Builder *builder);
-  FLATBUFFERS_CHECKED_ERROR StartParseFile(const char *source,
-                                           const char *source_filename);
-  FLATBUFFERS_CHECKED_ERROR ParseRoot(const char *_source,
-                                      const char **include_paths,
-                                      const char *source_filename);
-  FLATBUFFERS_CHECKED_ERROR DoParse(const char *_source,
-                                    const char **include_paths,
-                                    const char *source_filename,
-                                    const char *include_filename);
-  FLATBUFFERS_CHECKED_ERROR DoParseJson();
-  FLATBUFFERS_CHECKED_ERROR CheckClash(std::vector<FieldDef *> &fields,
-                                       StructDef *struct_def,
-                                       const char *suffix, BaseType baseType);
-  FLATBUFFERS_CHECKED_ERROR ParseAlignAttribute(
-      const std::string &align_constant, size_t min_align, size_t *align);
-
-  bool SupportsAdvancedUnionFeatures() const;
-  bool SupportsAdvancedArrayFeatures() const;
-  bool SupportsOptionalScalars() const;
-  bool SupportsDefaultVectorsAndStrings() const;
-  Namespace *UniqueNamespace(Namespace *ns);
-
-  FLATBUFFERS_CHECKED_ERROR RecurseError();
-  template<typename F> CheckedError Recurse(F f);
-
-  const std::string &GetPooledString(const std::string &s) const;
-
- public:
-  SymbolTable<Type> types_;
-  SymbolTable<StructDef> structs_;
-  SymbolTable<EnumDef> enums_;
-  SymbolTable<ServiceDef> services_;
-  std::vector<Namespace *> namespaces_;
-  Namespace *current_namespace_;
-  Namespace *empty_namespace_;
-  std::string error_;  // User readable error_ if Parse() == false
-
-  FlatBufferBuilder builder_;  // any data contained in the file
-  flexbuffers::Builder flex_builder_;
-  flexbuffers::Reference flex_root_;
-  StructDef *root_struct_def_;
-  std::string file_identifier_;
-  std::string file_extension_;
-
-  std::map<uint64_t, std::string> included_files_;
-  std::map<std::string, std::set<std::string>> files_included_per_file_;
-  std::vector<std::string> native_included_files_;
-
-  std::map<std::string, bool> known_attributes_;
-
-  IDLOptions opts;
-  bool uses_flexbuffers_;
-  bool has_warning_;
-
-  uint64_t advanced_features_;
-
- private:
-  const char *source_;
-
-  std::string file_being_parsed_;
-
-  std::vector<std::pair<Value, FieldDef *>> field_stack_;
-
-  // TODO(cneo): Refactor parser to use string_cache more often to save
-  // on memory usage.
-  mutable std::set<std::string> string_cache_;
-
-  int anonymous_counter_;
-  int parse_depth_counter_;  // stack-overflow guard
-};
-
-// Utility functions for multiple generators:
-
-// Generate text (JSON) from a given FlatBuffer, and a given Parser
-// object that has been populated with the corresponding schema.
-// If ident_step is 0, no indentation will be generated. Additionally,
-// if it is less than 0, no linefeeds will be generated either.
-// See idl_gen_text.cpp.
-// strict_json adds "quotes" around field names if true.
-// If the flatbuffer cannot be encoded in JSON (e.g., it contains non-UTF-8
-// byte arrays in String values), returns false.
-extern bool GenerateTextFromTable(const Parser &parser, const void *table,
-                                  const std::string &tablename,
-                                  std::string *text);
-extern bool GenerateText(const Parser &parser, const void *flatbuffer,
-                         std::string *text);
-extern bool GenerateTextFile(const Parser &parser, const std::string &path,
-                             const std::string &file_name);
-
-// Generate Json schema to string
-// See idl_gen_json_schema.cpp.
-extern bool GenerateJsonSchema(const Parser &parser, std::string *json);
-
-// Generate binary files from a given FlatBuffer, and a given Parser
-// object that has been populated with the corresponding schema.
-// See code_generators.cpp.
-extern bool GenerateBinary(const Parser &parser, const std::string &path,
-                           const std::string &file_name);
-
-// Generate a C++ header from the definitions in the Parser object.
-// See idl_gen_cpp.
-extern bool GenerateCPP(const Parser &parser, const std::string &path,
-                        const std::string &file_name);
-
-// Generate C# files from the definitions in the Parser object.
-// See idl_gen_csharp.cpp.
-extern bool GenerateCSharp(const Parser &parser, const std::string &path,
-                           const std::string &file_name);
-
-extern bool GenerateDart(const Parser &parser, const std::string &path,
-                         const std::string &file_name);
-
-// Generate Java files from the definitions in the Parser object.
-// See idl_gen_java.cpp.
-extern bool GenerateJava(const Parser &parser, const std::string &path,
-                         const std::string &file_name);
-
-// Generate JavaScript or TypeScript code from the definitions in the Parser
-// object. See idl_gen_js.
-extern bool GenerateTS(const Parser &parser, const std::string &path,
-                       const std::string &file_name);
-
-// Generate Go files from the definitions in the Parser object.
-// See idl_gen_go.cpp.
-extern bool GenerateGo(const Parser &parser, const std::string &path,
-                       const std::string &file_name);
-
-// Generate Php code from the definitions in the Parser object.
-// See idl_gen_php.
-extern bool GeneratePhp(const Parser &parser, const std::string &path,
-                        const std::string &file_name);
-
-// Generate Python files from the definitions in the Parser object.
-// See idl_gen_python.cpp.
-extern bool GeneratePython(const Parser &parser, const std::string &path,
-                           const std::string &file_name);
-
-// Generate Lobster files from the definitions in the Parser object.
-// See idl_gen_lobster.cpp.
-extern bool GenerateLobster(const Parser &parser, const std::string &path,
-                            const std::string &file_name);
-
-// Generate Lua files from the definitions in the Parser object.
-// See idl_gen_lua.cpp.
-extern bool GenerateLua(const Parser &parser, const std::string &path,
-                        const std::string &file_name);
-
-// Generate Rust files from the definitions in the Parser object.
-// See idl_gen_rust.cpp.
-extern bool GenerateRust(const Parser &parser, const std::string &path,
-                         const std::string &file_name);
-
-// Generate Json schema file
-// See idl_gen_json_schema.cpp.
-extern bool GenerateJsonSchema(const Parser &parser, const std::string &path,
-                               const std::string &file_name);
-
-extern bool GenerateKotlin(const Parser &parser, const std::string &path,
-                           const std::string &file_name);
-
-// Generate Swift classes.
-// See idl_gen_swift.cpp
-extern bool GenerateSwift(const Parser &parser, const std::string &path,
-                          const std::string &file_name);
-
-// Generate a schema file from the internal representation, useful after
-// parsing a .proto schema.
-extern std::string GenerateFBS(const Parser &parser,
-                               const std::string &file_name);
-extern bool GenerateFBS(const Parser &parser, const std::string &path,
-                        const std::string &file_name);
-
-// Generate a make rule for the generated TypeScript code.
-// See idl_gen_ts.cpp.
-extern std::string TSMakeRule(const Parser &parser, const std::string &path,
-                              const std::string &file_name);
-
-// Generate a make rule for the generated C++ header.
-// See idl_gen_cpp.cpp.
-extern std::string CPPMakeRule(const Parser &parser, const std::string &path,
-                               const std::string &file_name);
-
-// Generate a make rule for the generated Dart code
-// see idl_gen_dart.cpp
-extern std::string DartMakeRule(const Parser &parser, const std::string &path,
-                                const std::string &file_name);
-
-// Generate a make rule for the generated Rust code.
-// See idl_gen_rust.cpp.
-extern std::string RustMakeRule(const Parser &parser, const std::string &path,
-                                const std::string &file_name);
-
-// Generate a make rule for generated Java or C# files.
-// See code_generators.cpp.
-extern std::string CSharpMakeRule(const Parser &parser, const std::string &path,
-                                  const std::string &file_name);
-extern std::string JavaMakeRule(const Parser &parser, const std::string &path,
-                                const std::string &file_name);
-
-// Generate a make rule for the generated text (JSON) files.
-// See idl_gen_text.cpp.
-extern std::string TextMakeRule(const Parser &parser, const std::string &path,
-                                const std::string &file_names);
-
-// Generate a make rule for the generated binary files.
-// See code_generators.cpp.
-extern std::string BinaryMakeRule(const Parser &parser, const std::string &path,
-                                  const std::string &file_name);
-
-// Generate GRPC Cpp interfaces.
-// See idl_gen_grpc.cpp.
-bool GenerateCppGRPC(const Parser &parser, const std::string &path,
-                     const std::string &file_name);
-
-// Generate GRPC Go interfaces.
-// See idl_gen_grpc.cpp.
-bool GenerateGoGRPC(const Parser &parser, const std::string &path,
-                    const std::string &file_name);
-
-// Generate GRPC Java classes.
-// See idl_gen_grpc.cpp
-bool GenerateJavaGRPC(const Parser &parser, const std::string &path,
-                      const std::string &file_name);
-
-// Generate GRPC Python interfaces.
-// See idl_gen_grpc.cpp.
-bool GeneratePythonGRPC(const Parser &parser, const std::string &path,
-                        const std::string &file_name);
-
-// Generate GRPC Swift interfaces.
-// See idl_gen_grpc.cpp.
-extern bool GenerateSwiftGRPC(const Parser &parser, const std::string &path,
-                              const std::string &file_name);
-
-extern bool GenerateTSGRPC(const Parser &parser, const std::string &path,
-                           const std::string &file_name);
-
-extern bool GenerateRustModuleRootFile(const Parser &parser,
-                                       const std::string &path);
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_IDL_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/minireflect.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/minireflect.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/minireflect.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/minireflect.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,421 +0,0 @@
-/*
- * Copyright 2017 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_MINIREFLECT_H_
-#define FLATBUFFERS_MINIREFLECT_H_
-
-#include "flatbuffers/flatbuffers.h"
-#include "flatbuffers/util.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Utilities that can be used with the "mini reflection" tables present
-// in generated code with --reflect-types (only types) or --reflect-names
-// (also names).
-// This allows basic reflection functionality such as pretty-printing
-// that does not require the use of the schema parser or loading of binary
-// schema files at runtime (reflection.h).
-
-// For any of the functions below that take `const TypeTable *`, you pass
-// `FooTypeTable()` if the type of the root is `Foo`.
-
-// First, a generic iterator that can be used by multiple algorithms.
-
-struct IterationVisitor {
-  // These mark the scope of a table or struct.
-  virtual void StartSequence() {}
-  virtual void EndSequence() {}
-  // Called for each field regardless of whether it is present or not.
-  // If not present, val == nullptr. set_idx is the index of all set fields.
-  virtual void Field(size_t /*field_idx*/, size_t /*set_idx*/,
-                     ElementaryType /*type*/, bool /*is_vector*/,
-                     const TypeTable * /*type_table*/, const char * /*name*/,
-                     const uint8_t * /*val*/) {}
-  // Called for a value that is actually present, after a field, or as part
-  // of a vector.
-  virtual void UType(uint8_t, const char *) {}
-  virtual void Bool(bool) {}
-  virtual void Char(int8_t, const char *) {}
-  virtual void UChar(uint8_t, const char *) {}
-  virtual void Short(int16_t, const char *) {}
-  virtual void UShort(uint16_t, const char *) {}
-  virtual void Int(int32_t, const char *) {}
-  virtual void UInt(uint32_t, const char *) {}
-  virtual void Long(int64_t) {}
-  virtual void ULong(uint64_t) {}
-  virtual void Float(float) {}
-  virtual void Double(double) {}
-  virtual void String(const String *) {}
-  virtual void Unknown(const uint8_t *) {}  // From a future version.
-  // These mark the scope of a vector.
-  virtual void StartVector() {}
-  virtual void EndVector() {}
-  virtual void Element(size_t /*i*/, ElementaryType /*type*/,
-                       const TypeTable * /*type_table*/,
-                       const uint8_t * /*val*/) {}
-  virtual ~IterationVisitor() {}
-};
-
-inline size_t InlineSize(ElementaryType type, const TypeTable *type_table) {
-  switch (type) {
-    case ET_UTYPE:
-    case ET_BOOL:
-    case ET_CHAR:
-    case ET_UCHAR: return 1;
-    case ET_SHORT:
-    case ET_USHORT: return 2;
-    case ET_INT:
-    case ET_UINT:
-    case ET_FLOAT:
-    case ET_STRING: return 4;
-    case ET_LONG:
-    case ET_ULONG:
-    case ET_DOUBLE: return 8;
-    case ET_SEQUENCE:
-      switch (type_table->st) {
-        case ST_TABLE:
-        case ST_UNION: return 4;
-        case ST_STRUCT:
-          return static_cast<size_t>(type_table->values[type_table->num_elems]);
-        default: FLATBUFFERS_ASSERT(false); return 1;
-      }
-    default: FLATBUFFERS_ASSERT(false); return 1;
-  }
-}
-
-inline int64_t LookupEnum(int64_t enum_val, const int64_t *values,
-                          size_t num_values) {
-  if (!values) return enum_val;
-  for (size_t i = 0; i < num_values; i++) {
-    if (enum_val == values[i]) return static_cast<int64_t>(i);
-  }
-  return -1;  // Unknown enum value.
-}
-
-template<typename T> const char *EnumName(T tval, const TypeTable *type_table) {
-  if (!type_table || !type_table->names) return nullptr;
-  auto i = LookupEnum(static_cast<int64_t>(tval), type_table->values,
-                      type_table->num_elems);
-  if (i >= 0 && i < static_cast<int64_t>(type_table->num_elems)) {
-    return type_table->names[i];
-  }
-  return nullptr;
-}
-
-void IterateObject(const uint8_t *obj, const TypeTable *type_table,
-                   IterationVisitor *visitor);
-
-inline void IterateValue(ElementaryType type, const uint8_t *val,
-                         const TypeTable *type_table, const uint8_t *prev_val,
-                         soffset_t vector_index, IterationVisitor *visitor) {
-  switch (type) {
-    case ET_UTYPE: {
-      auto tval = ReadScalar<uint8_t>(val);
-      visitor->UType(tval, EnumName(tval, type_table));
-      break;
-    }
-    case ET_BOOL: {
-      visitor->Bool(ReadScalar<uint8_t>(val) != 0);
-      break;
-    }
-    case ET_CHAR: {
-      auto tval = ReadScalar<int8_t>(val);
-      visitor->Char(tval, EnumName(tval, type_table));
-      break;
-    }
-    case ET_UCHAR: {
-      auto tval = ReadScalar<uint8_t>(val);
-      visitor->UChar(tval, EnumName(tval, type_table));
-      break;
-    }
-    case ET_SHORT: {
-      auto tval = ReadScalar<int16_t>(val);
-      visitor->Short(tval, EnumName(tval, type_table));
-      break;
-    }
-    case ET_USHORT: {
-      auto tval = ReadScalar<uint16_t>(val);
-      visitor->UShort(tval, EnumName(tval, type_table));
-      break;
-    }
-    case ET_INT: {
-      auto tval = ReadScalar<int32_t>(val);
-      visitor->Int(tval, EnumName(tval, type_table));
-      break;
-    }
-    case ET_UINT: {
-      auto tval = ReadScalar<uint32_t>(val);
-      visitor->UInt(tval, EnumName(tval, type_table));
-      break;
-    }
-    case ET_LONG: {
-      visitor->Long(ReadScalar<int64_t>(val));
-      break;
-    }
-    case ET_ULONG: {
-      visitor->ULong(ReadScalar<uint64_t>(val));
-      break;
-    }
-    case ET_FLOAT: {
-      visitor->Float(ReadScalar<float>(val));
-      break;
-    }
-    case ET_DOUBLE: {
-      visitor->Double(ReadScalar<double>(val));
-      break;
-    }
-    case ET_STRING: {
-      val += ReadScalar<uoffset_t>(val);
-      visitor->String(reinterpret_cast<const String *>(val));
-      break;
-    }
-    case ET_SEQUENCE: {
-      switch (type_table->st) {
-        case ST_TABLE:
-          val += ReadScalar<uoffset_t>(val);
-          IterateObject(val, type_table, visitor);
-          break;
-        case ST_STRUCT: IterateObject(val, type_table, visitor); break;
-        case ST_UNION: {
-          val += ReadScalar<uoffset_t>(val);
-          FLATBUFFERS_ASSERT(prev_val);
-          auto union_type = *prev_val;  // Always a uint8_t.
-          if (vector_index >= 0) {
-            auto type_vec = reinterpret_cast<const Vector<uint8_t> *>(prev_val);
-            union_type = type_vec->Get(static_cast<uoffset_t>(vector_index));
-          }
-          auto type_code_idx =
-              LookupEnum(union_type, type_table->values, type_table->num_elems);
-          if (type_code_idx >= 0 &&
-              type_code_idx < static_cast<int32_t>(type_table->num_elems)) {
-            auto type_code = type_table->type_codes[type_code_idx];
-            switch (type_code.base_type) {
-              case ET_SEQUENCE: {
-                auto ref = type_table->type_refs[type_code.sequence_ref]();
-                IterateObject(val, ref, visitor);
-                break;
-              }
-              case ET_STRING:
-                visitor->String(reinterpret_cast<const String *>(val));
-                break;
-              default: visitor->Unknown(val);
-            }
-          } else {
-            visitor->Unknown(val);
-          }
-          break;
-        }
-        case ST_ENUM: FLATBUFFERS_ASSERT(false); break;
-      }
-      break;
-    }
-    default: {
-      visitor->Unknown(val);
-      break;
-    }
-  }
-}
-
-inline void IterateObject(const uint8_t *obj, const TypeTable *type_table,
-                          IterationVisitor *visitor) {
-  visitor->StartSequence();
-  const uint8_t *prev_val = nullptr;
-  size_t set_idx = 0;
-  size_t array_idx = 0;
-  for (size_t i = 0; i < type_table->num_elems; i++) {
-    auto type_code = type_table->type_codes[i];
-    auto type = static_cast<ElementaryType>(type_code.base_type);
-    auto is_repeating = type_code.is_repeating != 0;
-    auto ref_idx = type_code.sequence_ref;
-    const TypeTable *ref = nullptr;
-    if (ref_idx >= 0) { ref = type_table->type_refs[ref_idx](); }
-    auto name = type_table->names ? type_table->names[i] : nullptr;
-    const uint8_t *val = nullptr;
-    if (type_table->st == ST_TABLE) {
-      val = reinterpret_cast<const Table *>(obj)->GetAddressOf(
-          FieldIndexToOffset(static_cast<voffset_t>(i)));
-    } else {
-      val = obj + type_table->values[i];
-    }
-    visitor->Field(i, set_idx, type, is_repeating, ref, name, val);
-    if (val) {
-      set_idx++;
-      if (is_repeating) {
-        auto elem_ptr = val;
-        size_t size = 0;
-        if (type_table->st == ST_TABLE) {
-          // variable length vector
-          val += ReadScalar<uoffset_t>(val);
-          auto vec = reinterpret_cast<const Vector<uint8_t> *>(val);
-          elem_ptr = vec->Data();
-          size = vec->size();
-        } else {
-          // otherwise fixed size array
-          size = type_table->array_sizes[array_idx];
-          ++array_idx;
-        }
-        visitor->StartVector();
-        for (size_t j = 0; j < size; j++) {
-          visitor->Element(j, type, ref, elem_ptr);
-          IterateValue(type, elem_ptr, ref, prev_val, static_cast<soffset_t>(j),
-                       visitor);
-          elem_ptr += InlineSize(type, ref);
-        }
-        visitor->EndVector();
-      } else {
-        IterateValue(type, val, ref, prev_val, -1, visitor);
-      }
-    }
-    prev_val = val;
-  }
-  visitor->EndSequence();
-}
-
-inline void IterateFlatBuffer(const uint8_t *buffer,
-                              const TypeTable *type_table,
-                              IterationVisitor *callback) {
-  IterateObject(GetRoot<uint8_t>(buffer), type_table, callback);
-}
-
-// Outputting a Flatbuffer to a string. Tries to conform as close to JSON /
-// the output generated by idl_gen_text.cpp.
-
-struct ToStringVisitor : public IterationVisitor {
-  std::string s;
-  std::string d;
-  bool q;
-  std::string in;
-  size_t indent_level;
-  bool vector_delimited;
-  ToStringVisitor(std::string delimiter, bool quotes, std::string indent,
-                  bool vdelimited = true)
-      : d(delimiter),
-        q(quotes),
-        in(indent),
-        indent_level(0),
-        vector_delimited(vdelimited) {}
-  ToStringVisitor(std::string delimiter)
-      : d(delimiter),
-        q(false),
-        in(""),
-        indent_level(0),
-        vector_delimited(true) {}
-
-  void append_indent() {
-    for (size_t i = 0; i < indent_level; i++) { s += in; }
-  }
-
-  void StartSequence() {
-    s += "{";
-    s += d;
-    indent_level++;
-  }
-  void EndSequence() {
-    s += d;
-    indent_level--;
-    append_indent();
-    s += "}";
-  }
-  void Field(size_t /*field_idx*/, size_t set_idx, ElementaryType /*type*/,
-             bool /*is_vector*/, const TypeTable * /*type_table*/,
-             const char *name, const uint8_t *val) {
-    if (!val) return;
-    if (set_idx) {
-      s += ",";
-      s += d;
-    }
-    append_indent();
-    if (name) {
-      if (q) s += "\"";
-      s += name;
-      if (q) s += "\"";
-      s += ": ";
-    }
-  }
-  template<typename T> void Named(T x, const char *name) {
-    if (name) {
-      if (q) s += "\"";
-      s += name;
-      if (q) s += "\"";
-    } else {
-      s += NumToString(x);
-    }
-  }
-  void UType(uint8_t x, const char *name) { Named(x, name); }
-  void Bool(bool x) { s += x ? "true" : "false"; }
-  void Char(int8_t x, const char *name) { Named(x, name); }
-  void UChar(uint8_t x, const char *name) { Named(x, name); }
-  void Short(int16_t x, const char *name) { Named(x, name); }
-  void UShort(uint16_t x, const char *name) { Named(x, name); }
-  void Int(int32_t x, const char *name) { Named(x, name); }
-  void UInt(uint32_t x, const char *name) { Named(x, name); }
-  void Long(int64_t x) { s += NumToString(x); }
-  void ULong(uint64_t x) { s += NumToString(x); }
-  void Float(float x) { s += NumToString(x); }
-  void Double(double x) { s += NumToString(x); }
-  void String(const struct String *str) {
-    EscapeString(str->c_str(), str->size(), &s, true, false);
-  }
-  void Unknown(const uint8_t *) { s += "(?)"; }
-  void StartVector() {
-    s += "[";
-    if (vector_delimited) {
-      s += d;
-      indent_level++;
-      append_indent();
-    } else {
-      s += " ";
-    }
-  }
-  void EndVector() {
-    if (vector_delimited) {
-      s += d;
-      indent_level--;
-      append_indent();
-    } else {
-      s += " ";
-    }
-    s += "]";
-  }
-  void Element(size_t i, ElementaryType /*type*/,
-               const TypeTable * /*type_table*/, const uint8_t * /*val*/) {
-    if (i) {
-      s += ",";
-      if (vector_delimited) {
-        s += d;
-        append_indent();
-      } else {
-        s += " ";
-      }
-    }
-  }
-};
-
-inline std::string FlatBufferToString(const uint8_t *buffer,
-                                      const TypeTable *type_table,
-                                      bool multi_line = false,
-                                      bool vector_delimited = true) {
-  ToStringVisitor tostring_visitor(multi_line ? "\n" : " ", false, "",
-                                   vector_delimited);
-  IterateFlatBuffer(buffer, type_table, &tostring_visitor);
-  return tostring_visitor.s;
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_MINIREFLECT_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/pch/flatc_pch.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/pch/flatc_pch.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/pch/flatc_pch.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/pch/flatc_pch.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
-/*
- * Copyright 2017 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_FLATC_PCH_H_
-#define FLATBUFFERS_FLATC_PCH_H_
-
-// stl
-#include <cmath>
-#include <sstream>
-#include <cassert>
-#include <unordered_set>
-#include <unordered_map>
-#include <iostream>
-#include <functional>
-#include <set>
-#include <iterator>
-#include <tuple>
-
-// flatbuffers
-#include "flatbuffers/pch/pch.h"
-#include "flatbuffers/code_generators.h"
-#include "flatbuffers/flatbuffers.h"
-#include "flatbuffers/flexbuffers.h"
-#include "flatbuffers/idl.h"
-
-#endif // FLATBUFFERS_FLATC_PCH_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/pch/pch.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/pch/pch.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/pch/pch.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/pch/pch.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
-/*
- * Copyright 2017 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_PCH_H_
-#define FLATBUFFERS_PCH_H_
-
-// stl
-#include <cstdint>
-#include <cstring>
-#include <algorithm>
-#include <list>
-#include <string>
-#include <utility>
-#include <iomanip>
-#include <map>
-#include <memory>
-#include <limits>
-#include <stack>
-#include <vector>
-#include <type_traits>
-
-// flatbuffers
-#include "flatbuffers/util.h"
-
-#endif // FLATBUFFERS_PCH_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/reflection.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/reflection.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/reflection.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/reflection.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,524 +0,0 @@
-/*
- * Copyright 2015 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_REFLECTION_H_
-#define FLATBUFFERS_REFLECTION_H_
-
-// This is somewhat of a circular dependency because flatc (and thus this
-// file) is needed to generate this header in the first place.
-// Should normally not be a problem since it can be generated by the
-// previous version of flatc whenever this code needs to change.
-// See scripts/generate_code.py for generation.
-#include "flatbuffers/reflection_generated.h"
-
-// Helper functionality for reflection.
-
-namespace mapserver {
-namespace flatbuffers {
-
-// ------------------------- GETTERS -------------------------
-
-inline bool IsScalar(reflection::BaseType t) {
-  return t >= reflection::UType && t <= reflection::Double;
-}
-inline bool IsInteger(reflection::BaseType t) {
-  return t >= reflection::UType && t <= reflection::ULong;
-}
-inline bool IsFloat(reflection::BaseType t) {
-  return t == reflection::Float || t == reflection::Double;
-}
-inline bool IsLong(reflection::BaseType t) {
-  return t == reflection::Long || t == reflection::ULong;
-}
-
-// Size of a basic type, don't use with structs.
-inline size_t GetTypeSize(reflection::BaseType base_type) {
-  // This needs to correspond to the BaseType enum.
-  static size_t sizes[] = {
-    0,  // None
-    1,  // UType
-    1,  // Bool
-    1,  // Byte
-    1,  // UByte
-    2,  // Short
-    2,  // UShort
-    4,  // Int
-    4,  // UInt
-    8,  // Long
-    8,  // ULong
-    4,  // Float
-    8,  // Double
-    4,  // String
-    4,  // Vector
-    4,  // Obj
-    4,  // Union
-    0,  // Array. Only used in structs. 0 was chosen to prevent out-of-bounds
-        // errors.
-
-    0  // MaxBaseType. This must be kept the last entry in this array.
-  };
-  static_assert(sizeof(sizes) / sizeof(size_t) == reflection::MaxBaseType + 1,
-                "Size of sizes[] array does not match the count of BaseType "
-                "enum values.");
-  return sizes[base_type];
-}
-
-// Same as above, but now correctly returns the size of a struct if
-// the field (or vector element) is a struct.
-inline size_t GetTypeSizeInline(reflection::BaseType base_type, int type_index,
-                                const reflection::Schema &schema) {
-  if (base_type == reflection::Obj &&
-      schema.objects()->Get(type_index)->is_struct()) {
-    return schema.objects()->Get(type_index)->bytesize();
-  } else {
-    return GetTypeSize(base_type);
-  }
-}
-
-// Get the root, regardless of what type it is.
-inline Table *GetAnyRoot(uint8_t *const flatbuf) {
-  return GetMutableRoot<Table>(flatbuf);
-}
-
-inline const Table *GetAnyRoot(const uint8_t *const flatbuf) {
-  return GetRoot<Table>(flatbuf);
-}
-
-inline Table *GetAnySizePrefixedRoot(uint8_t *const flatbuf) {
-  return GetMutableSizePrefixedRoot<Table>(flatbuf);
-}
-
-inline const Table *GetAnySizePrefixedRoot(const uint8_t *const flatbuf) {
-  return GetSizePrefixedRoot<Table>(flatbuf);
-}
-
-// Get a field's default, if you know it's an integer, and its exact type.
-template<typename T> T GetFieldDefaultI(const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
-  return static_cast<T>(field.default_integer());
-}
-
-// Get a field's default, if you know it's floating point and its exact type.
-template<typename T> T GetFieldDefaultF(const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
-  return static_cast<T>(field.default_real());
-}
-
-// Get a field, if you know it's an integer, and its exact type.
-template<typename T>
-T GetFieldI(const Table &table, const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
-  return table.GetField<T>(field.offset(),
-                           static_cast<T>(field.default_integer()));
-}
-
-// Get a field, if you know it's floating point and its exact type.
-template<typename T>
-T GetFieldF(const Table &table, const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
-  return table.GetField<T>(field.offset(),
-                           static_cast<T>(field.default_real()));
-}
-
-// Get a field, if you know it's a string.
-inline const String *GetFieldS(const Table &table,
-                               const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::String);
-  return table.GetPointer<const String *>(field.offset());
-}
-
-// Get a field, if you know it's a vector.
-template<typename T>
-Vector<T> *GetFieldV(const Table &table, const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Vector &&
-                     sizeof(T) == GetTypeSize(field.type()->element()));
-  return table.GetPointer<Vector<T> *>(field.offset());
-}
-
-// Get a field, if you know it's a vector, generically.
-// To actually access elements, use the return value together with
-// field.type()->element() in any of GetAnyVectorElemI below etc.
-inline VectorOfAny *GetFieldAnyV(const Table &table,
-                                 const reflection::Field &field) {
-  return table.GetPointer<VectorOfAny *>(field.offset());
-}
-
-// Get a field, if you know it's a table.
-inline Table *GetFieldT(const Table &table, const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Obj ||
-                     field.type()->base_type() == reflection::Union);
-  return table.GetPointer<Table *>(field.offset());
-}
-
-// Get a field, if you know it's a struct.
-inline const Struct *GetFieldStruct(const Table &table,
-                                    const reflection::Field &field) {
-  // TODO: This does NOT check if the field is a table or struct, but we'd need
-  // access to the schema to check the is_struct flag.
-  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Obj);
-  return table.GetStruct<const Struct *>(field.offset());
-}
-
-// Get a structure's field, if you know it's a struct.
-inline const Struct *GetFieldStruct(const Struct &structure,
-                                    const reflection::Field &field) {
-  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Obj);
-  return structure.GetStruct<const Struct *>(field.offset());
-}
-
-// Raw helper functions used below: get any value in memory as a 64bit int, a
-// double or a string.
-// All scalars get static_cast to an int64_t, strings use strtoull, every other
-// data type returns 0.
-int64_t GetAnyValueI(reflection::BaseType type, const uint8_t *data);
-// All scalars static cast to double, strings use strtod, every other data
-// type is 0.0.
-double GetAnyValueF(reflection::BaseType type, const uint8_t *data);
-// All scalars converted using stringstream, strings as-is, and all other
-// data types provide some level of debug-pretty-printing.
-std::string GetAnyValueS(reflection::BaseType type, const uint8_t *data,
-                         const reflection::Schema *schema, int type_index);
-
-// Get any table field as a 64bit int, regardless of what type it is.
-inline int64_t GetAnyFieldI(const Table &table,
-                            const reflection::Field &field) {
-  auto field_ptr = table.GetAddressOf(field.offset());
-  return field_ptr ? GetAnyValueI(field.type()->base_type(), field_ptr)
-                   : field.default_integer();
-}
-
-// Get any table field as a double, regardless of what type it is.
-inline double GetAnyFieldF(const Table &table, const reflection::Field &field) {
-  auto field_ptr = table.GetAddressOf(field.offset());
-  return field_ptr ? GetAnyValueF(field.type()->base_type(), field_ptr)
-                   : field.default_real();
-}
-
-// Get any table field as a string, regardless of what type it is.
-// You may pass nullptr for the schema if you don't care to have fields that
-// are of table type pretty-printed.
-inline std::string GetAnyFieldS(const Table &table,
-                                const reflection::Field &field,
-                                const reflection::Schema *schema) {
-  auto field_ptr = table.GetAddressOf(field.offset());
-  return field_ptr ? GetAnyValueS(field.type()->base_type(), field_ptr, schema,
-                                  field.type()->index())
-                   : "";
-}
-
-// Get any struct field as a 64bit int, regardless of what type it is.
-inline int64_t GetAnyFieldI(const Struct &st, const reflection::Field &field) {
-  return GetAnyValueI(field.type()->base_type(),
-                      st.GetAddressOf(field.offset()));
-}
-
-// Get any struct field as a double, regardless of what type it is.
-inline double GetAnyFieldF(const Struct &st, const reflection::Field &field) {
-  return GetAnyValueF(field.type()->base_type(),
-                      st.GetAddressOf(field.offset()));
-}
-
-// Get any struct field as a string, regardless of what type it is.
-inline std::string GetAnyFieldS(const Struct &st,
-                                const reflection::Field &field) {
-  return GetAnyValueS(field.type()->base_type(),
-                      st.GetAddressOf(field.offset()), nullptr, -1);
-}
-
-// Get any vector element as a 64bit int, regardless of what type it is.
-inline int64_t GetAnyVectorElemI(const VectorOfAny *vec,
-                                 reflection::BaseType elem_type, size_t i) {
-  return GetAnyValueI(elem_type, vec->Data() + GetTypeSize(elem_type) * i);
-}
-
-// Get any vector element as a double, regardless of what type it is.
-inline double GetAnyVectorElemF(const VectorOfAny *vec,
-                                reflection::BaseType elem_type, size_t i) {
-  return GetAnyValueF(elem_type, vec->Data() + GetTypeSize(elem_type) * i);
-}
-
-// Get any vector element as a string, regardless of what type it is.
-inline std::string GetAnyVectorElemS(const VectorOfAny *vec,
-                                     reflection::BaseType elem_type, size_t i) {
-  return GetAnyValueS(elem_type, vec->Data() + GetTypeSize(elem_type) * i,
-                      nullptr, -1);
-}
-
-// Get a vector element that's a table/string/vector from a generic vector.
-// Pass Table/String/VectorOfAny as template parameter.
-// Warning: does no typechecking.
-template<typename T>
-T *GetAnyVectorElemPointer(const VectorOfAny *vec, size_t i) {
-  auto elem_ptr = vec->Data() + sizeof(uoffset_t) * i;
-  return reinterpret_cast<T *>(elem_ptr + ReadScalar<uoffset_t>(elem_ptr));
-}
-
-// Get the inline-address of a vector element. Useful for Structs (pass Struct
-// as template arg), or being able to address a range of scalars in-line.
-// Get elem_size from GetTypeSizeInline().
-// Note: little-endian data on all platforms, use EndianScalar() instead of
-// raw pointer access with scalars).
-template<typename T>
-T *GetAnyVectorElemAddressOf(const VectorOfAny *vec, size_t i,
-                             size_t elem_size) {
-  return reinterpret_cast<T *>(vec->Data() + elem_size * i);
-}
-
-// Similarly, for elements of tables.
-template<typename T>
-T *GetAnyFieldAddressOf(const Table &table, const reflection::Field &field) {
-  return reinterpret_cast<T *>(table.GetAddressOf(field.offset()));
-}
-
-// Similarly, for elements of structs.
-template<typename T>
-T *GetAnyFieldAddressOf(const Struct &st, const reflection::Field &field) {
-  return reinterpret_cast<T *>(st.GetAddressOf(field.offset()));
-}
-
-// Loop over all the fields of the provided `object` and call `func` on each one
-// in increasing order by their field->id(). If `reverse` is true, `func` is
-// called in descending order
-void ForAllFields(const reflection::Object *object, bool reverse,
-                  std::function<void(const reflection::Field *)> func);
-
-// ------------------------- SETTERS -------------------------
-
-// Set any scalar field, if you know its exact type.
-template<typename T>
-bool SetField(Table *table, const reflection::Field &field, T val) {
-  reflection::BaseType type = field.type()->base_type();
-  if (!IsScalar(type)) { return false; }
-  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(type));
-  T def;
-  if (IsInteger(type)) {
-    def = GetFieldDefaultI<T>(field);
-  } else {
-    FLATBUFFERS_ASSERT(IsFloat(type));
-    def = GetFieldDefaultF<T>(field);
-  }
-  return table->SetField(field.offset(), val, def);
-}
-
-// Raw helper functions used below: set any value in memory as a 64bit int, a
-// double or a string.
-// These work for all scalar values, but do nothing for other data types.
-// To set a string, see SetString below.
-void SetAnyValueI(reflection::BaseType type, uint8_t *data, int64_t val);
-void SetAnyValueF(reflection::BaseType type, uint8_t *data, double val);
-void SetAnyValueS(reflection::BaseType type, uint8_t *data, const char *val);
-
-// Set any table field as a 64bit int, regardless of type what it is.
-inline bool SetAnyFieldI(Table *table, const reflection::Field &field,
-                         int64_t val) {
-  auto field_ptr = table->GetAddressOf(field.offset());
-  if (!field_ptr) return val == GetFieldDefaultI<int64_t>(field);
-  SetAnyValueI(field.type()->base_type(), field_ptr, val);
-  return true;
-}
-
-// Set any table field as a double, regardless of what type it is.
-inline bool SetAnyFieldF(Table *table, const reflection::Field &field,
-                         double val) {
-  auto field_ptr = table->GetAddressOf(field.offset());
-  if (!field_ptr) return val == GetFieldDefaultF<double>(field);
-  SetAnyValueF(field.type()->base_type(), field_ptr, val);
-  return true;
-}
-
-// Set any table field as a string, regardless of what type it is.
-inline bool SetAnyFieldS(Table *table, const reflection::Field &field,
-                         const char *val) {
-  auto field_ptr = table->GetAddressOf(field.offset());
-  if (!field_ptr) return false;
-  SetAnyValueS(field.type()->base_type(), field_ptr, val);
-  return true;
-}
-
-// Set any struct field as a 64bit int, regardless of type what it is.
-inline void SetAnyFieldI(Struct *st, const reflection::Field &field,
-                         int64_t val) {
-  SetAnyValueI(field.type()->base_type(), st->GetAddressOf(field.offset()),
-               val);
-}
-
-// Set any struct field as a double, regardless of type what it is.
-inline void SetAnyFieldF(Struct *st, const reflection::Field &field,
-                         double val) {
-  SetAnyValueF(field.type()->base_type(), st->GetAddressOf(field.offset()),
-               val);
-}
-
-// Set any struct field as a string, regardless of type what it is.
-inline void SetAnyFieldS(Struct *st, const reflection::Field &field,
-                         const char *val) {
-  SetAnyValueS(field.type()->base_type(), st->GetAddressOf(field.offset()),
-               val);
-}
-
-// Set any vector element as a 64bit int, regardless of type what it is.
-inline void SetAnyVectorElemI(VectorOfAny *vec, reflection::BaseType elem_type,
-                              size_t i, int64_t val) {
-  SetAnyValueI(elem_type, vec->Data() + GetTypeSize(elem_type) * i, val);
-}
-
-// Set any vector element as a double, regardless of type what it is.
-inline void SetAnyVectorElemF(VectorOfAny *vec, reflection::BaseType elem_type,
-                              size_t i, double val) {
-  SetAnyValueF(elem_type, vec->Data() + GetTypeSize(elem_type) * i, val);
-}
-
-// Set any vector element as a string, regardless of type what it is.
-inline void SetAnyVectorElemS(VectorOfAny *vec, reflection::BaseType elem_type,
-                              size_t i, const char *val) {
-  SetAnyValueS(elem_type, vec->Data() + GetTypeSize(elem_type) * i, val);
-}
-
-// ------------------------- RESIZING SETTERS -------------------------
-
-// "smart" pointer for use with resizing vectors: turns a pointer inside
-// a vector into a relative offset, such that it is not affected by resizes.
-template<typename T, typename U> class pointer_inside_vector {
- public:
-  pointer_inside_vector(T *ptr, std::vector<U> &vec)
-      : offset_(reinterpret_cast<uint8_t *>(ptr) -
-                reinterpret_cast<uint8_t *>(vec.data())),
-        vec_(vec) {}
-
-  T *operator*() const {
-    return reinterpret_cast<T *>(reinterpret_cast<uint8_t *>(vec_.data()) +
-                                 offset_);
-  }
-  T *operator->() const { return operator*(); }
-
- private:
-  size_t offset_;
-  std::vector<U> &vec_;
-};
-
-// Helper to create the above easily without specifying template args.
-template<typename T, typename U>
-pointer_inside_vector<T, U> piv(T *ptr, std::vector<U> &vec) {
-  return pointer_inside_vector<T, U>(ptr, vec);
-}
-
-inline const char *UnionTypeFieldSuffix() { return "_type"; }
-
-// Helper to figure out the actual table type a union refers to.
-inline const reflection::Object &GetUnionType(
-    const reflection::Schema &schema, const reflection::Object &parent,
-    const reflection::Field &unionfield, const Table &table) {
-  auto enumdef = schema.enums()->Get(unionfield.type()->index());
-  // TODO: this is clumsy and slow, but no other way to find it?
-  auto type_field = parent.fields()->LookupByKey(
-      (unionfield.name()->str() + UnionTypeFieldSuffix()).c_str());
-  FLATBUFFERS_ASSERT(type_field);
-  auto union_type = GetFieldI<uint8_t>(table, *type_field);
-  auto enumval = enumdef->values()->LookupByKey(union_type);
-  return *schema.objects()->Get(enumval->union_type()->index());
-}
-
-// Changes the contents of a string inside a FlatBuffer. FlatBuffer must
-// live inside a std::vector so we can resize the buffer if needed.
-// "str" must live inside "flatbuf" and may be invalidated after this call.
-// If your FlatBuffer's root table is not the schema's root table, you should
-// pass in your root_table type as well.
-void SetString(const reflection::Schema &schema, const std::string &val,
-               const String *str, std::vector<uint8_t> *flatbuf,
-               const reflection::Object *root_table = nullptr);
-
-// Resizes a flatbuffers::Vector inside a FlatBuffer. FlatBuffer must
-// live inside a std::vector so we can resize the buffer if needed.
-// "vec" must live inside "flatbuf" and may be invalidated after this call.
-// If your FlatBuffer's root table is not the schema's root table, you should
-// pass in your root_table type as well.
-uint8_t *ResizeAnyVector(const reflection::Schema &schema, uoffset_t newsize,
-                         const VectorOfAny *vec, uoffset_t num_elems,
-                         uoffset_t elem_size, std::vector<uint8_t> *flatbuf,
-                         const reflection::Object *root_table = nullptr);
-
-template<typename T>
-void ResizeVector(const reflection::Schema &schema, uoffset_t newsize, T val,
-                  const Vector<T> *vec, std::vector<uint8_t> *flatbuf,
-                  const reflection::Object *root_table = nullptr) {
-  auto delta_elem = static_cast<int>(newsize) - static_cast<int>(vec->size());
-  auto newelems = ResizeAnyVector(
-      schema, newsize, reinterpret_cast<const VectorOfAny *>(vec), vec->size(),
-      static_cast<uoffset_t>(sizeof(T)), flatbuf, root_table);
-  // Set new elements to "val".
-  for (int i = 0; i < delta_elem; i++) {
-    auto loc = newelems + i * sizeof(T);
-    auto is_scalar = flatbuffers::is_scalar<T>::value;
-    if (is_scalar) {
-      WriteScalar(loc, val);
-    } else {  // struct
-      *reinterpret_cast<T *>(loc) = val;
-    }
-  }
-}
-
-// Adds any new data (in the form of a new FlatBuffer) to an existing
-// FlatBuffer. This can be used when any of the above methods are not
-// sufficient, in particular for adding new tables and new fields.
-// This is potentially slightly less efficient than a FlatBuffer constructed
-// in one piece, since the new FlatBuffer doesn't share any vtables with the
-// existing one.
-// The return value can now be set using Vector::MutateOffset or SetFieldT
-// below.
-const uint8_t *AddFlatBuffer(std::vector<uint8_t> &flatbuf,
-                             const uint8_t *newbuf, size_t newlen);
-
-inline bool SetFieldT(Table *table, const reflection::Field &field,
-                      const uint8_t *val) {
-  FLATBUFFERS_ASSERT(sizeof(uoffset_t) ==
-                     GetTypeSize(field.type()->base_type()));
-  return table->SetPointer(field.offset(), val);
-}
-
-// ------------------------- COPYING -------------------------
-
-// Generic copying of tables from a FlatBuffer into a FlatBuffer builder.
-// Can be used to do any kind of merging/selecting you may want to do out
-// of existing buffers. Also useful to reconstruct a whole buffer if the
-// above resizing functionality has introduced garbage in a buffer you want
-// to remove.
-// Note: this does not deal with DAGs correctly. If the table passed forms a
-// DAG, the copy will be a tree instead (with duplicates). Strings can be
-// shared however, by passing true for use_string_pooling.
-
-Offset<const Table *> CopyTable(FlatBufferBuilder &fbb,
-                                const reflection::Schema &schema,
-                                const reflection::Object &objectdef,
-                                const Table &table,
-                                bool use_string_pooling = false);
-
-// Verifies the provided flatbuffer using reflection.
-// root should point to the root type for this flatbuffer.
-// buf should point to the start of flatbuffer data.
-// length specifies the size of the flatbuffer data.
-bool Verify(const reflection::Schema &schema, const reflection::Object &root,
-            const uint8_t *buf, size_t length, uoffset_t max_depth = 64,
-            uoffset_t max_tables = 1000000);
-
-bool VerifySizePrefixed(const reflection::Schema &schema,
-                        const reflection::Object &root, const uint8_t *buf,
-                        size_t length, uoffset_t max_depth = 64,
-                        uoffset_t max_tables = 1000000);
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_REFLECTION_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/reflection_generated.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/reflection_generated.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/reflection_generated.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/reflection_generated.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1456 +0,0 @@
-// automatically generated by the FlatBuffers compiler, do not modify
-
-
-#ifndef FLATBUFFERS_GENERATED_REFLECTION_REFLECTION_H_
-#define FLATBUFFERS_GENERATED_REFLECTION_REFLECTION_H_
-
-#include "flatbuffers/flatbuffers.h"
-
-// Ensure the included flatbuffers.h is the same version as when this file was
-// generated, otherwise it may not be compatible.
-static_assert(FLATBUFFERS_VERSION_MAJOR == 2 &&
-              FLATBUFFERS_VERSION_MINOR == 0 &&
-              FLATBUFFERS_VERSION_REVISION == 6,
-             "Non-compatible flatbuffers version included");
-
-namespace reflection {
-
-struct Type;
-struct TypeBuilder;
-
-struct KeyValue;
-struct KeyValueBuilder;
-
-struct EnumVal;
-struct EnumValBuilder;
-
-struct Enum;
-struct EnumBuilder;
-
-struct Field;
-struct FieldBuilder;
-
-struct Object;
-struct ObjectBuilder;
-
-struct RPCCall;
-struct RPCCallBuilder;
-
-struct Service;
-struct ServiceBuilder;
-
-struct SchemaFile;
-struct SchemaFileBuilder;
-
-struct Schema;
-struct SchemaBuilder;
-
-enum BaseType {
-  None = 0,
-  UType = 1,
-  Bool = 2,
-  Byte = 3,
-  UByte = 4,
-  Short = 5,
-  UShort = 6,
-  Int = 7,
-  UInt = 8,
-  Long = 9,
-  ULong = 10,
-  Float = 11,
-  Double = 12,
-  String = 13,
-  Vector = 14,
-  Obj = 15,
-  Union = 16,
-  Array = 17,
-  MaxBaseType = 18
-};
-
-inline const BaseType (&EnumValuesBaseType())[19] {
-  static const BaseType values[] = {
-    None,
-    UType,
-    Bool,
-    Byte,
-    UByte,
-    Short,
-    UShort,
-    Int,
-    UInt,
-    Long,
-    ULong,
-    Float,
-    Double,
-    String,
-    Vector,
-    Obj,
-    Union,
-    Array,
-    MaxBaseType
-  };
-  return values;
-}
-
-inline const char * const *EnumNamesBaseType() {
-  static const char * const names[20] = {
-    "None",
-    "UType",
-    "Bool",
-    "Byte",
-    "UByte",
-    "Short",
-    "UShort",
-    "Int",
-    "UInt",
-    "Long",
-    "ULong",
-    "Float",
-    "Double",
-    "String",
-    "Vector",
-    "Obj",
-    "Union",
-    "Array",
-    "MaxBaseType",
-    nullptr
-  };
-  return names;
-}
-
-inline const char *EnumNameBaseType(BaseType e) {
-  if (flatbuffers::IsOutRange(e, None, MaxBaseType)) return "";
-  const size_t index = static_cast<size_t>(e);
-  return EnumNamesBaseType()[index];
-}
-
-/// New schema language features that are not supported by old code generators.
-enum AdvancedFeatures {
-  AdvancedArrayFeatures = 1ULL,
-  AdvancedUnionFeatures = 2ULL,
-  OptionalScalars = 4ULL,
-  DefaultVectorsAndStrings = 8ULL
-};
-
-inline const AdvancedFeatures (&EnumValuesAdvancedFeatures())[4] {
-  static const AdvancedFeatures values[] = {
-    AdvancedArrayFeatures,
-    AdvancedUnionFeatures,
-    OptionalScalars,
-    DefaultVectorsAndStrings
-  };
-  return values;
-}
-
-inline const char * const *EnumNamesAdvancedFeatures() {
-  static const char * const names[9] = {
-    "AdvancedArrayFeatures",
-    "AdvancedUnionFeatures",
-    "",
-    "OptionalScalars",
-    "",
-    "",
-    "",
-    "DefaultVectorsAndStrings",
-    nullptr
-  };
-  return names;
-}
-
-inline const char *EnumNameAdvancedFeatures(AdvancedFeatures e) {
-  if (flatbuffers::IsOutRange(e, AdvancedArrayFeatures, DefaultVectorsAndStrings)) return "";
-  const size_t index = static_cast<size_t>(e) - static_cast<size_t>(AdvancedArrayFeatures);
-  return EnumNamesAdvancedFeatures()[index];
-}
-
-struct Type FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef TypeBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_BASE_TYPE = 4,
-    VT_ELEMENT = 6,
-    VT_INDEX = 8,
-    VT_FIXED_LENGTH = 10,
-    VT_BASE_SIZE = 12,
-    VT_ELEMENT_SIZE = 14
-  };
-  reflection::BaseType base_type() const {
-    return static_cast<reflection::BaseType>(GetField<int8_t>(VT_BASE_TYPE, 0));
-  }
-  reflection::BaseType element() const {
-    return static_cast<reflection::BaseType>(GetField<int8_t>(VT_ELEMENT, 0));
-  }
-  int32_t index() const {
-    return GetField<int32_t>(VT_INDEX, -1);
-  }
-  uint16_t fixed_length() const {
-    return GetField<uint16_t>(VT_FIXED_LENGTH, 0);
-  }
-  /// The size (octets) of the `base_type` field.
-  uint32_t base_size() const {
-    return GetField<uint32_t>(VT_BASE_SIZE, 4);
-  }
-  /// The size (octets) of the `element` field, if present.
-  uint32_t element_size() const {
-    return GetField<uint32_t>(VT_ELEMENT_SIZE, 0);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyField<int8_t>(verifier, VT_BASE_TYPE, 1) &&
-           VerifyField<int8_t>(verifier, VT_ELEMENT, 1) &&
-           VerifyField<int32_t>(verifier, VT_INDEX, 4) &&
-           VerifyField<uint16_t>(verifier, VT_FIXED_LENGTH, 2) &&
-           VerifyField<uint32_t>(verifier, VT_BASE_SIZE, 4) &&
-           VerifyField<uint32_t>(verifier, VT_ELEMENT_SIZE, 4) &&
-           verifier.EndTable();
-  }
-};
-
-struct TypeBuilder {
-  typedef Type Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_base_type(reflection::BaseType base_type) {
-    fbb_.AddElement<int8_t>(Type::VT_BASE_TYPE, static_cast<int8_t>(base_type), 0);
-  }
-  void add_element(reflection::BaseType element) {
-    fbb_.AddElement<int8_t>(Type::VT_ELEMENT, static_cast<int8_t>(element), 0);
-  }
-  void add_index(int32_t index) {
-    fbb_.AddElement<int32_t>(Type::VT_INDEX, index, -1);
-  }
-  void add_fixed_length(uint16_t fixed_length) {
-    fbb_.AddElement<uint16_t>(Type::VT_FIXED_LENGTH, fixed_length, 0);
-  }
-  void add_base_size(uint32_t base_size) {
-    fbb_.AddElement<uint32_t>(Type::VT_BASE_SIZE, base_size, 4);
-  }
-  void add_element_size(uint32_t element_size) {
-    fbb_.AddElement<uint32_t>(Type::VT_ELEMENT_SIZE, element_size, 0);
-  }
-  explicit TypeBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Type> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Type>(end);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Type> CreateType(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    reflection::BaseType base_type = reflection::None,
-    reflection::BaseType element = reflection::None,
-    int32_t index = -1,
-    uint16_t fixed_length = 0,
-    uint32_t base_size = 4,
-    uint32_t element_size = 0) {
-  TypeBuilder builder_(_fbb);
-  builder_.add_element_size(element_size);
-  builder_.add_base_size(base_size);
-  builder_.add_index(index);
-  builder_.add_fixed_length(fixed_length);
-  builder_.add_element(element);
-  builder_.add_base_type(base_type);
-  return builder_.Finish();
-}
-
-struct KeyValue FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef KeyValueBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_KEY = 4,
-    VT_VALUE = 6
-  };
-  const flatbuffers::String *key() const {
-    return GetPointer<const flatbuffers::String *>(VT_KEY);
-  }
-  bool KeyCompareLessThan(const KeyValue *o) const {
-    return *key() < *o->key();
-  }
-  int KeyCompareWithValue(const char *_key) const {
-    return strcmp(key()->c_str(), _key);
-  }
-  const flatbuffers::String *value() const {
-    return GetPointer<const flatbuffers::String *>(VT_VALUE);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_KEY) &&
-           verifier.VerifyString(key()) &&
-           VerifyOffset(verifier, VT_VALUE) &&
-           verifier.VerifyString(value()) &&
-           verifier.EndTable();
-  }
-};
-
-struct KeyValueBuilder {
-  typedef KeyValue Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_key(flatbuffers::Offset<flatbuffers::String> key) {
-    fbb_.AddOffset(KeyValue::VT_KEY, key);
-  }
-  void add_value(flatbuffers::Offset<flatbuffers::String> value) {
-    fbb_.AddOffset(KeyValue::VT_VALUE, value);
-  }
-  explicit KeyValueBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<KeyValue> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<KeyValue>(end);
-    fbb_.Required(o, KeyValue::VT_KEY);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<KeyValue> CreateKeyValue(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> key = 0,
-    flatbuffers::Offset<flatbuffers::String> value = 0) {
-  KeyValueBuilder builder_(_fbb);
-  builder_.add_value(value);
-  builder_.add_key(key);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<KeyValue> CreateKeyValueDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *key = nullptr,
-    const char *value = nullptr) {
-  auto key__ = key ? _fbb.CreateString(key) : 0;
-  auto value__ = value ? _fbb.CreateString(value) : 0;
-  return reflection::CreateKeyValue(
-      _fbb,
-      key__,
-      value__);
-}
-
-struct EnumVal FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef EnumValBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_VALUE = 6,
-    VT_UNION_TYPE = 10,
-    VT_DOCUMENTATION = 12
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  int64_t value() const {
-    return GetField<int64_t>(VT_VALUE, 0);
-  }
-  bool KeyCompareLessThan(const EnumVal *o) const {
-    return value() < o->value();
-  }
-  int KeyCompareWithValue(int64_t _value) const {
-    return static_cast<int>(value() > _value) - static_cast<int>(value() < _value);
-  }
-  const reflection::Type *union_type() const {
-    return GetPointer<const reflection::Type *>(VT_UNION_TYPE);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyField<int64_t>(verifier, VT_VALUE, 8) &&
-           VerifyOffset(verifier, VT_UNION_TYPE) &&
-           verifier.VerifyTable(union_type()) &&
-           VerifyOffset(verifier, VT_DOCUMENTATION) &&
-           verifier.VerifyVector(documentation()) &&
-           verifier.VerifyVectorOfStrings(documentation()) &&
-           verifier.EndTable();
-  }
-};
-
-struct EnumValBuilder {
-  typedef EnumVal Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(EnumVal::VT_NAME, name);
-  }
-  void add_value(int64_t value) {
-    fbb_.AddElement<int64_t>(EnumVal::VT_VALUE, value, 0);
-  }
-  void add_union_type(flatbuffers::Offset<reflection::Type> union_type) {
-    fbb_.AddOffset(EnumVal::VT_UNION_TYPE, union_type);
-  }
-  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
-    fbb_.AddOffset(EnumVal::VT_DOCUMENTATION, documentation);
-  }
-  explicit EnumValBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<EnumVal> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<EnumVal>(end);
-    fbb_.Required(o, EnumVal::VT_NAME);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<EnumVal> CreateEnumVal(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    int64_t value = 0,
-    flatbuffers::Offset<reflection::Type> union_type = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0) {
-  EnumValBuilder builder_(_fbb);
-  builder_.add_value(value);
-  builder_.add_documentation(documentation);
-  builder_.add_union_type(union_type);
-  builder_.add_name(name);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<EnumVal> CreateEnumValDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    int64_t value = 0,
-    flatbuffers::Offset<reflection::Type> union_type = 0,
-    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
-  return reflection::CreateEnumVal(
-      _fbb,
-      name__,
-      value,
-      union_type,
-      documentation__);
-}
-
-struct Enum FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef EnumBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_VALUES = 6,
-    VT_IS_UNION = 8,
-    VT_UNDERLYING_TYPE = 10,
-    VT_ATTRIBUTES = 12,
-    VT_DOCUMENTATION = 14,
-    VT_DECLARATION_FILE = 16
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  bool KeyCompareLessThan(const Enum *o) const {
-    return *name() < *o->name();
-  }
-  int KeyCompareWithValue(const char *_name) const {
-    return strcmp(name()->c_str(), _name);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>> *values() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>> *>(VT_VALUES);
-  }
-  bool is_union() const {
-    return GetField<uint8_t>(VT_IS_UNION, 0) != 0;
-  }
-  const reflection::Type *underlying_type() const {
-    return GetPointer<const reflection::Type *>(VT_UNDERLYING_TYPE);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
-  }
-  /// File that this Enum is declared in.
-  const flatbuffers::String *declaration_file() const {
-    return GetPointer<const flatbuffers::String *>(VT_DECLARATION_FILE);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyOffsetRequired(verifier, VT_VALUES) &&
-           verifier.VerifyVector(values()) &&
-           verifier.VerifyVectorOfTables(values()) &&
-           VerifyField<uint8_t>(verifier, VT_IS_UNION, 1) &&
-           VerifyOffsetRequired(verifier, VT_UNDERLYING_TYPE) &&
-           verifier.VerifyTable(underlying_type()) &&
-           VerifyOffset(verifier, VT_ATTRIBUTES) &&
-           verifier.VerifyVector(attributes()) &&
-           verifier.VerifyVectorOfTables(attributes()) &&
-           VerifyOffset(verifier, VT_DOCUMENTATION) &&
-           verifier.VerifyVector(documentation()) &&
-           verifier.VerifyVectorOfStrings(documentation()) &&
-           VerifyOffset(verifier, VT_DECLARATION_FILE) &&
-           verifier.VerifyString(declaration_file()) &&
-           verifier.EndTable();
-  }
-};
-
-struct EnumBuilder {
-  typedef Enum Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(Enum::VT_NAME, name);
-  }
-  void add_values(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>>> values) {
-    fbb_.AddOffset(Enum::VT_VALUES, values);
-  }
-  void add_is_union(bool is_union) {
-    fbb_.AddElement<uint8_t>(Enum::VT_IS_UNION, static_cast<uint8_t>(is_union), 0);
-  }
-  void add_underlying_type(flatbuffers::Offset<reflection::Type> underlying_type) {
-    fbb_.AddOffset(Enum::VT_UNDERLYING_TYPE, underlying_type);
-  }
-  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
-    fbb_.AddOffset(Enum::VT_ATTRIBUTES, attributes);
-  }
-  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
-    fbb_.AddOffset(Enum::VT_DOCUMENTATION, documentation);
-  }
-  void add_declaration_file(flatbuffers::Offset<flatbuffers::String> declaration_file) {
-    fbb_.AddOffset(Enum::VT_DECLARATION_FILE, declaration_file);
-  }
-  explicit EnumBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Enum> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Enum>(end);
-    fbb_.Required(o, Enum::VT_NAME);
-    fbb_.Required(o, Enum::VT_VALUES);
-    fbb_.Required(o, Enum::VT_UNDERLYING_TYPE);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Enum> CreateEnum(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>>> values = 0,
-    bool is_union = false,
-    flatbuffers::Offset<reflection::Type> underlying_type = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
-    flatbuffers::Offset<flatbuffers::String> declaration_file = 0) {
-  EnumBuilder builder_(_fbb);
-  builder_.add_declaration_file(declaration_file);
-  builder_.add_documentation(documentation);
-  builder_.add_attributes(attributes);
-  builder_.add_underlying_type(underlying_type);
-  builder_.add_values(values);
-  builder_.add_name(name);
-  builder_.add_is_union(is_union);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Enum> CreateEnumDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    std::vector<flatbuffers::Offset<reflection::EnumVal>> *values = nullptr,
-    bool is_union = false,
-    flatbuffers::Offset<reflection::Type> underlying_type = 0,
-    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
-    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
-    const char *declaration_file = nullptr) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto values__ = values ? _fbb.CreateVectorOfSortedTables<reflection::EnumVal>(values) : 0;
-  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
-  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
-  auto declaration_file__ = declaration_file ? _fbb.CreateString(declaration_file) : 0;
-  return reflection::CreateEnum(
-      _fbb,
-      name__,
-      values__,
-      is_union,
-      underlying_type,
-      attributes__,
-      documentation__,
-      declaration_file__);
-}
-
-struct Field FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef FieldBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_TYPE = 6,
-    VT_ID = 8,
-    VT_OFFSET = 10,
-    VT_DEFAULT_INTEGER = 12,
-    VT_DEFAULT_REAL = 14,
-    VT_DEPRECATED = 16,
-    VT_REQUIRED = 18,
-    VT_KEY = 20,
-    VT_ATTRIBUTES = 22,
-    VT_DOCUMENTATION = 24,
-    VT_OPTIONAL = 26,
-    VT_PADDING = 28
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  bool KeyCompareLessThan(const Field *o) const {
-    return *name() < *o->name();
-  }
-  int KeyCompareWithValue(const char *_name) const {
-    return strcmp(name()->c_str(), _name);
-  }
-  const reflection::Type *type() const {
-    return GetPointer<const reflection::Type *>(VT_TYPE);
-  }
-  uint16_t id() const {
-    return GetField<uint16_t>(VT_ID, 0);
-  }
-  uint16_t offset() const {
-    return GetField<uint16_t>(VT_OFFSET, 0);
-  }
-  int64_t default_integer() const {
-    return GetField<int64_t>(VT_DEFAULT_INTEGER, 0);
-  }
-  double default_real() const {
-    return GetField<double>(VT_DEFAULT_REAL, 0.0);
-  }
-  bool deprecated() const {
-    return GetField<uint8_t>(VT_DEPRECATED, 0) != 0;
-  }
-  bool required() const {
-    return GetField<uint8_t>(VT_REQUIRED, 0) != 0;
-  }
-  bool key() const {
-    return GetField<uint8_t>(VT_KEY, 0) != 0;
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
-  }
-  bool optional() const {
-    return GetField<uint8_t>(VT_OPTIONAL, 0) != 0;
-  }
-  /// Number of padding octets to always add after this field. Structs only.
-  uint16_t padding() const {
-    return GetField<uint16_t>(VT_PADDING, 0);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyOffsetRequired(verifier, VT_TYPE) &&
-           verifier.VerifyTable(type()) &&
-           VerifyField<uint16_t>(verifier, VT_ID, 2) &&
-           VerifyField<uint16_t>(verifier, VT_OFFSET, 2) &&
-           VerifyField<int64_t>(verifier, VT_DEFAULT_INTEGER, 8) &&
-           VerifyField<double>(verifier, VT_DEFAULT_REAL, 8) &&
-           VerifyField<uint8_t>(verifier, VT_DEPRECATED, 1) &&
-           VerifyField<uint8_t>(verifier, VT_REQUIRED, 1) &&
-           VerifyField<uint8_t>(verifier, VT_KEY, 1) &&
-           VerifyOffset(verifier, VT_ATTRIBUTES) &&
-           verifier.VerifyVector(attributes()) &&
-           verifier.VerifyVectorOfTables(attributes()) &&
-           VerifyOffset(verifier, VT_DOCUMENTATION) &&
-           verifier.VerifyVector(documentation()) &&
-           verifier.VerifyVectorOfStrings(documentation()) &&
-           VerifyField<uint8_t>(verifier, VT_OPTIONAL, 1) &&
-           VerifyField<uint16_t>(verifier, VT_PADDING, 2) &&
-           verifier.EndTable();
-  }
-};
-
-struct FieldBuilder {
-  typedef Field Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(Field::VT_NAME, name);
-  }
-  void add_type(flatbuffers::Offset<reflection::Type> type) {
-    fbb_.AddOffset(Field::VT_TYPE, type);
-  }
-  void add_id(uint16_t id) {
-    fbb_.AddElement<uint16_t>(Field::VT_ID, id, 0);
-  }
-  void add_offset(uint16_t offset) {
-    fbb_.AddElement<uint16_t>(Field::VT_OFFSET, offset, 0);
-  }
-  void add_default_integer(int64_t default_integer) {
-    fbb_.AddElement<int64_t>(Field::VT_DEFAULT_INTEGER, default_integer, 0);
-  }
-  void add_default_real(double default_real) {
-    fbb_.AddElement<double>(Field::VT_DEFAULT_REAL, default_real, 0.0);
-  }
-  void add_deprecated(bool deprecated) {
-    fbb_.AddElement<uint8_t>(Field::VT_DEPRECATED, static_cast<uint8_t>(deprecated), 0);
-  }
-  void add_required(bool required) {
-    fbb_.AddElement<uint8_t>(Field::VT_REQUIRED, static_cast<uint8_t>(required), 0);
-  }
-  void add_key(bool key) {
-    fbb_.AddElement<uint8_t>(Field::VT_KEY, static_cast<uint8_t>(key), 0);
-  }
-  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
-    fbb_.AddOffset(Field::VT_ATTRIBUTES, attributes);
-  }
-  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
-    fbb_.AddOffset(Field::VT_DOCUMENTATION, documentation);
-  }
-  void add_optional(bool optional) {
-    fbb_.AddElement<uint8_t>(Field::VT_OPTIONAL, static_cast<uint8_t>(optional), 0);
-  }
-  void add_padding(uint16_t padding) {
-    fbb_.AddElement<uint16_t>(Field::VT_PADDING, padding, 0);
-  }
-  explicit FieldBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Field> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Field>(end);
-    fbb_.Required(o, Field::VT_NAME);
-    fbb_.Required(o, Field::VT_TYPE);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Field> CreateField(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    flatbuffers::Offset<reflection::Type> type = 0,
-    uint16_t id = 0,
-    uint16_t offset = 0,
-    int64_t default_integer = 0,
-    double default_real = 0.0,
-    bool deprecated = false,
-    bool required = false,
-    bool key = false,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
-    bool optional = false,
-    uint16_t padding = 0) {
-  FieldBuilder builder_(_fbb);
-  builder_.add_default_real(default_real);
-  builder_.add_default_integer(default_integer);
-  builder_.add_documentation(documentation);
-  builder_.add_attributes(attributes);
-  builder_.add_type(type);
-  builder_.add_name(name);
-  builder_.add_padding(padding);
-  builder_.add_offset(offset);
-  builder_.add_id(id);
-  builder_.add_optional(optional);
-  builder_.add_key(key);
-  builder_.add_required(required);
-  builder_.add_deprecated(deprecated);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Field> CreateFieldDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    flatbuffers::Offset<reflection::Type> type = 0,
-    uint16_t id = 0,
-    uint16_t offset = 0,
-    int64_t default_integer = 0,
-    double default_real = 0.0,
-    bool deprecated = false,
-    bool required = false,
-    bool key = false,
-    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
-    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
-    bool optional = false,
-    uint16_t padding = 0) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
-  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
-  return reflection::CreateField(
-      _fbb,
-      name__,
-      type,
-      id,
-      offset,
-      default_integer,
-      default_real,
-      deprecated,
-      required,
-      key,
-      attributes__,
-      documentation__,
-      optional,
-      padding);
-}
-
-struct Object FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef ObjectBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_FIELDS = 6,
-    VT_IS_STRUCT = 8,
-    VT_MINALIGN = 10,
-    VT_BYTESIZE = 12,
-    VT_ATTRIBUTES = 14,
-    VT_DOCUMENTATION = 16,
-    VT_DECLARATION_FILE = 18
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  bool KeyCompareLessThan(const Object *o) const {
-    return *name() < *o->name();
-  }
-  int KeyCompareWithValue(const char *_name) const {
-    return strcmp(name()->c_str(), _name);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::Field>> *fields() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Field>> *>(VT_FIELDS);
-  }
-  bool is_struct() const {
-    return GetField<uint8_t>(VT_IS_STRUCT, 0) != 0;
-  }
-  int32_t minalign() const {
-    return GetField<int32_t>(VT_MINALIGN, 0);
-  }
-  int32_t bytesize() const {
-    return GetField<int32_t>(VT_BYTESIZE, 0);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
-  }
-  /// File that this Object is declared in.
-  const flatbuffers::String *declaration_file() const {
-    return GetPointer<const flatbuffers::String *>(VT_DECLARATION_FILE);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyOffsetRequired(verifier, VT_FIELDS) &&
-           verifier.VerifyVector(fields()) &&
-           verifier.VerifyVectorOfTables(fields()) &&
-           VerifyField<uint8_t>(verifier, VT_IS_STRUCT, 1) &&
-           VerifyField<int32_t>(verifier, VT_MINALIGN, 4) &&
-           VerifyField<int32_t>(verifier, VT_BYTESIZE, 4) &&
-           VerifyOffset(verifier, VT_ATTRIBUTES) &&
-           verifier.VerifyVector(attributes()) &&
-           verifier.VerifyVectorOfTables(attributes()) &&
-           VerifyOffset(verifier, VT_DOCUMENTATION) &&
-           verifier.VerifyVector(documentation()) &&
-           verifier.VerifyVectorOfStrings(documentation()) &&
-           VerifyOffset(verifier, VT_DECLARATION_FILE) &&
-           verifier.VerifyString(declaration_file()) &&
-           verifier.EndTable();
-  }
-};
-
-struct ObjectBuilder {
-  typedef Object Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(Object::VT_NAME, name);
-  }
-  void add_fields(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Field>>> fields) {
-    fbb_.AddOffset(Object::VT_FIELDS, fields);
-  }
-  void add_is_struct(bool is_struct) {
-    fbb_.AddElement<uint8_t>(Object::VT_IS_STRUCT, static_cast<uint8_t>(is_struct), 0);
-  }
-  void add_minalign(int32_t minalign) {
-    fbb_.AddElement<int32_t>(Object::VT_MINALIGN, minalign, 0);
-  }
-  void add_bytesize(int32_t bytesize) {
-    fbb_.AddElement<int32_t>(Object::VT_BYTESIZE, bytesize, 0);
-  }
-  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
-    fbb_.AddOffset(Object::VT_ATTRIBUTES, attributes);
-  }
-  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
-    fbb_.AddOffset(Object::VT_DOCUMENTATION, documentation);
-  }
-  void add_declaration_file(flatbuffers::Offset<flatbuffers::String> declaration_file) {
-    fbb_.AddOffset(Object::VT_DECLARATION_FILE, declaration_file);
-  }
-  explicit ObjectBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Object> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Object>(end);
-    fbb_.Required(o, Object::VT_NAME);
-    fbb_.Required(o, Object::VT_FIELDS);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Object> CreateObject(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Field>>> fields = 0,
-    bool is_struct = false,
-    int32_t minalign = 0,
-    int32_t bytesize = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
-    flatbuffers::Offset<flatbuffers::String> declaration_file = 0) {
-  ObjectBuilder builder_(_fbb);
-  builder_.add_declaration_file(declaration_file);
-  builder_.add_documentation(documentation);
-  builder_.add_attributes(attributes);
-  builder_.add_bytesize(bytesize);
-  builder_.add_minalign(minalign);
-  builder_.add_fields(fields);
-  builder_.add_name(name);
-  builder_.add_is_struct(is_struct);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Object> CreateObjectDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    std::vector<flatbuffers::Offset<reflection::Field>> *fields = nullptr,
-    bool is_struct = false,
-    int32_t minalign = 0,
-    int32_t bytesize = 0,
-    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
-    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
-    const char *declaration_file = nullptr) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto fields__ = fields ? _fbb.CreateVectorOfSortedTables<reflection::Field>(fields) : 0;
-  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
-  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
-  auto declaration_file__ = declaration_file ? _fbb.CreateString(declaration_file) : 0;
-  return reflection::CreateObject(
-      _fbb,
-      name__,
-      fields__,
-      is_struct,
-      minalign,
-      bytesize,
-      attributes__,
-      documentation__,
-      declaration_file__);
-}
-
-struct RPCCall FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef RPCCallBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_REQUEST = 6,
-    VT_RESPONSE = 8,
-    VT_ATTRIBUTES = 10,
-    VT_DOCUMENTATION = 12
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  bool KeyCompareLessThan(const RPCCall *o) const {
-    return *name() < *o->name();
-  }
-  int KeyCompareWithValue(const char *_name) const {
-    return strcmp(name()->c_str(), _name);
-  }
-  const reflection::Object *request() const {
-    return GetPointer<const reflection::Object *>(VT_REQUEST);
-  }
-  const reflection::Object *response() const {
-    return GetPointer<const reflection::Object *>(VT_RESPONSE);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyOffsetRequired(verifier, VT_REQUEST) &&
-           verifier.VerifyTable(request()) &&
-           VerifyOffsetRequired(verifier, VT_RESPONSE) &&
-           verifier.VerifyTable(response()) &&
-           VerifyOffset(verifier, VT_ATTRIBUTES) &&
-           verifier.VerifyVector(attributes()) &&
-           verifier.VerifyVectorOfTables(attributes()) &&
-           VerifyOffset(verifier, VT_DOCUMENTATION) &&
-           verifier.VerifyVector(documentation()) &&
-           verifier.VerifyVectorOfStrings(documentation()) &&
-           verifier.EndTable();
-  }
-};
-
-struct RPCCallBuilder {
-  typedef RPCCall Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(RPCCall::VT_NAME, name);
-  }
-  void add_request(flatbuffers::Offset<reflection::Object> request) {
-    fbb_.AddOffset(RPCCall::VT_REQUEST, request);
-  }
-  void add_response(flatbuffers::Offset<reflection::Object> response) {
-    fbb_.AddOffset(RPCCall::VT_RESPONSE, response);
-  }
-  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
-    fbb_.AddOffset(RPCCall::VT_ATTRIBUTES, attributes);
-  }
-  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
-    fbb_.AddOffset(RPCCall::VT_DOCUMENTATION, documentation);
-  }
-  explicit RPCCallBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<RPCCall> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<RPCCall>(end);
-    fbb_.Required(o, RPCCall::VT_NAME);
-    fbb_.Required(o, RPCCall::VT_REQUEST);
-    fbb_.Required(o, RPCCall::VT_RESPONSE);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<RPCCall> CreateRPCCall(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    flatbuffers::Offset<reflection::Object> request = 0,
-    flatbuffers::Offset<reflection::Object> response = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0) {
-  RPCCallBuilder builder_(_fbb);
-  builder_.add_documentation(documentation);
-  builder_.add_attributes(attributes);
-  builder_.add_response(response);
-  builder_.add_request(request);
-  builder_.add_name(name);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<RPCCall> CreateRPCCallDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    flatbuffers::Offset<reflection::Object> request = 0,
-    flatbuffers::Offset<reflection::Object> response = 0,
-    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
-    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
-  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
-  return reflection::CreateRPCCall(
-      _fbb,
-      name__,
-      request,
-      response,
-      attributes__,
-      documentation__);
-}
-
-struct Service FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef ServiceBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_NAME = 4,
-    VT_CALLS = 6,
-    VT_ATTRIBUTES = 8,
-    VT_DOCUMENTATION = 10,
-    VT_DECLARATION_FILE = 12
-  };
-  const flatbuffers::String *name() const {
-    return GetPointer<const flatbuffers::String *>(VT_NAME);
-  }
-  bool KeyCompareLessThan(const Service *o) const {
-    return *name() < *o->name();
-  }
-  int KeyCompareWithValue(const char *_name) const {
-    return strcmp(name()->c_str(), _name);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>> *calls() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>> *>(VT_CALLS);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
-  }
-  /// File that this Service is declared in.
-  const flatbuffers::String *declaration_file() const {
-    return GetPointer<const flatbuffers::String *>(VT_DECLARATION_FILE);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_NAME) &&
-           verifier.VerifyString(name()) &&
-           VerifyOffset(verifier, VT_CALLS) &&
-           verifier.VerifyVector(calls()) &&
-           verifier.VerifyVectorOfTables(calls()) &&
-           VerifyOffset(verifier, VT_ATTRIBUTES) &&
-           verifier.VerifyVector(attributes()) &&
-           verifier.VerifyVectorOfTables(attributes()) &&
-           VerifyOffset(verifier, VT_DOCUMENTATION) &&
-           verifier.VerifyVector(documentation()) &&
-           verifier.VerifyVectorOfStrings(documentation()) &&
-           VerifyOffset(verifier, VT_DECLARATION_FILE) &&
-           verifier.VerifyString(declaration_file()) &&
-           verifier.EndTable();
-  }
-};
-
-struct ServiceBuilder {
-  typedef Service Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
-    fbb_.AddOffset(Service::VT_NAME, name);
-  }
-  void add_calls(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>>> calls) {
-    fbb_.AddOffset(Service::VT_CALLS, calls);
-  }
-  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
-    fbb_.AddOffset(Service::VT_ATTRIBUTES, attributes);
-  }
-  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
-    fbb_.AddOffset(Service::VT_DOCUMENTATION, documentation);
-  }
-  void add_declaration_file(flatbuffers::Offset<flatbuffers::String> declaration_file) {
-    fbb_.AddOffset(Service::VT_DECLARATION_FILE, declaration_file);
-  }
-  explicit ServiceBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Service> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Service>(end);
-    fbb_.Required(o, Service::VT_NAME);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Service> CreateService(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> name = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>>> calls = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
-    flatbuffers::Offset<flatbuffers::String> declaration_file = 0) {
-  ServiceBuilder builder_(_fbb);
-  builder_.add_declaration_file(declaration_file);
-  builder_.add_documentation(documentation);
-  builder_.add_attributes(attributes);
-  builder_.add_calls(calls);
-  builder_.add_name(name);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Service> CreateServiceDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *name = nullptr,
-    std::vector<flatbuffers::Offset<reflection::RPCCall>> *calls = nullptr,
-    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
-    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
-    const char *declaration_file = nullptr) {
-  auto name__ = name ? _fbb.CreateString(name) : 0;
-  auto calls__ = calls ? _fbb.CreateVectorOfSortedTables<reflection::RPCCall>(calls) : 0;
-  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
-  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
-  auto declaration_file__ = declaration_file ? _fbb.CreateString(declaration_file) : 0;
-  return reflection::CreateService(
-      _fbb,
-      name__,
-      calls__,
-      attributes__,
-      documentation__,
-      declaration_file__);
-}
-
-/// File specific information.
-/// Symbols declared within a file may be recovered by iterating over all
-/// symbols and examining the `declaration_file` field.
-struct SchemaFile FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef SchemaFileBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_FILENAME = 4,
-    VT_INCLUDED_FILENAMES = 6
-  };
-  /// Filename, relative to project root.
-  const flatbuffers::String *filename() const {
-    return GetPointer<const flatbuffers::String *>(VT_FILENAME);
-  }
-  bool KeyCompareLessThan(const SchemaFile *o) const {
-    return *filename() < *o->filename();
-  }
-  int KeyCompareWithValue(const char *_filename) const {
-    return strcmp(filename()->c_str(), _filename);
-  }
-  /// Names of included files, relative to project root.
-  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *included_filenames() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_INCLUDED_FILENAMES);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_FILENAME) &&
-           verifier.VerifyString(filename()) &&
-           VerifyOffset(verifier, VT_INCLUDED_FILENAMES) &&
-           verifier.VerifyVector(included_filenames()) &&
-           verifier.VerifyVectorOfStrings(included_filenames()) &&
-           verifier.EndTable();
-  }
-};
-
-struct SchemaFileBuilder {
-  typedef SchemaFile Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_filename(flatbuffers::Offset<flatbuffers::String> filename) {
-    fbb_.AddOffset(SchemaFile::VT_FILENAME, filename);
-  }
-  void add_included_filenames(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> included_filenames) {
-    fbb_.AddOffset(SchemaFile::VT_INCLUDED_FILENAMES, included_filenames);
-  }
-  explicit SchemaFileBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<SchemaFile> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<SchemaFile>(end);
-    fbb_.Required(o, SchemaFile::VT_FILENAME);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<SchemaFile> CreateSchemaFile(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::String> filename = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> included_filenames = 0) {
-  SchemaFileBuilder builder_(_fbb);
-  builder_.add_included_filenames(included_filenames);
-  builder_.add_filename(filename);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<SchemaFile> CreateSchemaFileDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    const char *filename = nullptr,
-    const std::vector<flatbuffers::Offset<flatbuffers::String>> *included_filenames = nullptr) {
-  auto filename__ = filename ? _fbb.CreateString(filename) : 0;
-  auto included_filenames__ = included_filenames ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*included_filenames) : 0;
-  return reflection::CreateSchemaFile(
-      _fbb,
-      filename__,
-      included_filenames__);
-}
-
-struct Schema FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
-  typedef SchemaBuilder Builder;
-  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
-    VT_OBJECTS = 4,
-    VT_ENUMS = 6,
-    VT_FILE_IDENT = 8,
-    VT_FILE_EXT = 10,
-    VT_ROOT_TABLE = 12,
-    VT_SERVICES = 14,
-    VT_ADVANCED_FEATURES = 16,
-    VT_FBS_FILES = 18
-  };
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::Object>> *objects() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Object>> *>(VT_OBJECTS);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>> *enums() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>> *>(VT_ENUMS);
-  }
-  const flatbuffers::String *file_ident() const {
-    return GetPointer<const flatbuffers::String *>(VT_FILE_IDENT);
-  }
-  const flatbuffers::String *file_ext() const {
-    return GetPointer<const flatbuffers::String *>(VT_FILE_EXT);
-  }
-  const reflection::Object *root_table() const {
-    return GetPointer<const reflection::Object *>(VT_ROOT_TABLE);
-  }
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::Service>> *services() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Service>> *>(VT_SERVICES);
-  }
-  reflection::AdvancedFeatures advanced_features() const {
-    return static_cast<reflection::AdvancedFeatures>(GetField<uint64_t>(VT_ADVANCED_FEATURES, 0));
-  }
-  /// All the files used in this compilation. Files are relative to where
-  /// flatc was invoked.
-  const flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>> *fbs_files() const {
-    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>> *>(VT_FBS_FILES);
-  }
-  bool Verify(flatbuffers::Verifier &verifier) const {
-    return VerifyTableStart(verifier) &&
-           VerifyOffsetRequired(verifier, VT_OBJECTS) &&
-           verifier.VerifyVector(objects()) &&
-           verifier.VerifyVectorOfTables(objects()) &&
-           VerifyOffsetRequired(verifier, VT_ENUMS) &&
-           verifier.VerifyVector(enums()) &&
-           verifier.VerifyVectorOfTables(enums()) &&
-           VerifyOffset(verifier, VT_FILE_IDENT) &&
-           verifier.VerifyString(file_ident()) &&
-           VerifyOffset(verifier, VT_FILE_EXT) &&
-           verifier.VerifyString(file_ext()) &&
-           VerifyOffset(verifier, VT_ROOT_TABLE) &&
-           verifier.VerifyTable(root_table()) &&
-           VerifyOffset(verifier, VT_SERVICES) &&
-           verifier.VerifyVector(services()) &&
-           verifier.VerifyVectorOfTables(services()) &&
-           VerifyField<uint64_t>(verifier, VT_ADVANCED_FEATURES, 8) &&
-           VerifyOffset(verifier, VT_FBS_FILES) &&
-           verifier.VerifyVector(fbs_files()) &&
-           verifier.VerifyVectorOfTables(fbs_files()) &&
-           verifier.EndTable();
-  }
-};
-
-struct SchemaBuilder {
-  typedef Schema Table;
-  flatbuffers::FlatBufferBuilder &fbb_;
-  flatbuffers::uoffset_t start_;
-  void add_objects(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Object>>> objects) {
-    fbb_.AddOffset(Schema::VT_OBJECTS, objects);
-  }
-  void add_enums(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>>> enums) {
-    fbb_.AddOffset(Schema::VT_ENUMS, enums);
-  }
-  void add_file_ident(flatbuffers::Offset<flatbuffers::String> file_ident) {
-    fbb_.AddOffset(Schema::VT_FILE_IDENT, file_ident);
-  }
-  void add_file_ext(flatbuffers::Offset<flatbuffers::String> file_ext) {
-    fbb_.AddOffset(Schema::VT_FILE_EXT, file_ext);
-  }
-  void add_root_table(flatbuffers::Offset<reflection::Object> root_table) {
-    fbb_.AddOffset(Schema::VT_ROOT_TABLE, root_table);
-  }
-  void add_services(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Service>>> services) {
-    fbb_.AddOffset(Schema::VT_SERVICES, services);
-  }
-  void add_advanced_features(reflection::AdvancedFeatures advanced_features) {
-    fbb_.AddElement<uint64_t>(Schema::VT_ADVANCED_FEATURES, static_cast<uint64_t>(advanced_features), 0);
-  }
-  void add_fbs_files(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>>> fbs_files) {
-    fbb_.AddOffset(Schema::VT_FBS_FILES, fbs_files);
-  }
-  explicit SchemaBuilder(flatbuffers::FlatBufferBuilder &_fbb)
-        : fbb_(_fbb) {
-    start_ = fbb_.StartTable();
-  }
-  flatbuffers::Offset<Schema> Finish() {
-    const auto end = fbb_.EndTable(start_);
-    auto o = flatbuffers::Offset<Schema>(end);
-    fbb_.Required(o, Schema::VT_OBJECTS);
-    fbb_.Required(o, Schema::VT_ENUMS);
-    return o;
-  }
-};
-
-inline flatbuffers::Offset<Schema> CreateSchema(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Object>>> objects = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>>> enums = 0,
-    flatbuffers::Offset<flatbuffers::String> file_ident = 0,
-    flatbuffers::Offset<flatbuffers::String> file_ext = 0,
-    flatbuffers::Offset<reflection::Object> root_table = 0,
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Service>>> services = 0,
-    reflection::AdvancedFeatures advanced_features = static_cast<reflection::AdvancedFeatures>(0),
-    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>>> fbs_files = 0) {
-  SchemaBuilder builder_(_fbb);
-  builder_.add_advanced_features(advanced_features);
-  builder_.add_fbs_files(fbs_files);
-  builder_.add_services(services);
-  builder_.add_root_table(root_table);
-  builder_.add_file_ext(file_ext);
-  builder_.add_file_ident(file_ident);
-  builder_.add_enums(enums);
-  builder_.add_objects(objects);
-  return builder_.Finish();
-}
-
-inline flatbuffers::Offset<Schema> CreateSchemaDirect(
-    flatbuffers::FlatBufferBuilder &_fbb,
-    std::vector<flatbuffers::Offset<reflection::Object>> *objects = nullptr,
-    std::vector<flatbuffers::Offset<reflection::Enum>> *enums = nullptr,
-    const char *file_ident = nullptr,
-    const char *file_ext = nullptr,
-    flatbuffers::Offset<reflection::Object> root_table = 0,
-    std::vector<flatbuffers::Offset<reflection::Service>> *services = nullptr,
-    reflection::AdvancedFeatures advanced_features = static_cast<reflection::AdvancedFeatures>(0),
-    std::vector<flatbuffers::Offset<reflection::SchemaFile>> *fbs_files = nullptr) {
-  auto objects__ = objects ? _fbb.CreateVectorOfSortedTables<reflection::Object>(objects) : 0;
-  auto enums__ = enums ? _fbb.CreateVectorOfSortedTables<reflection::Enum>(enums) : 0;
-  auto file_ident__ = file_ident ? _fbb.CreateString(file_ident) : 0;
-  auto file_ext__ = file_ext ? _fbb.CreateString(file_ext) : 0;
-  auto services__ = services ? _fbb.CreateVectorOfSortedTables<reflection::Service>(services) : 0;
-  auto fbs_files__ = fbs_files ? _fbb.CreateVectorOfSortedTables<reflection::SchemaFile>(fbs_files) : 0;
-  return reflection::CreateSchema(
-      _fbb,
-      objects__,
-      enums__,
-      file_ident__,
-      file_ext__,
-      root_table,
-      services__,
-      advanced_features,
-      fbs_files__);
-}
-
-inline const reflection::Schema *GetSchema(const void *buf) {
-  return flatbuffers::GetRoot<reflection::Schema>(buf);
-}
-
-inline const reflection::Schema *GetSizePrefixedSchema(const void *buf) {
-  return flatbuffers::GetSizePrefixedRoot<reflection::Schema>(buf);
-}
-
-inline const char *SchemaIdentifier() {
-  return "BFBS";
-}
-
-inline bool SchemaBufferHasIdentifier(const void *buf) {
-  return flatbuffers::BufferHasIdentifier(
-      buf, SchemaIdentifier());
-}
-
-inline bool SizePrefixedSchemaBufferHasIdentifier(const void *buf) {
-  return flatbuffers::BufferHasIdentifier(
-      buf, SchemaIdentifier(), true);
-}
-
-inline bool VerifySchemaBuffer(
-    flatbuffers::Verifier &verifier) {
-  return verifier.VerifyBuffer<reflection::Schema>(SchemaIdentifier());
-}
-
-inline bool VerifySizePrefixedSchemaBuffer(
-    flatbuffers::Verifier &verifier) {
-  return verifier.VerifySizePrefixedBuffer<reflection::Schema>(SchemaIdentifier());
-}
-
-inline const char *SchemaExtension() {
-  return "bfbs";
-}
-
-inline void FinishSchemaBuffer(
-    flatbuffers::FlatBufferBuilder &fbb,
-    flatbuffers::Offset<reflection::Schema> root) {
-  fbb.Finish(root, SchemaIdentifier());
-}
-
-inline void FinishSizePrefixedSchemaBuffer(
-    flatbuffers::FlatBufferBuilder &fbb,
-    flatbuffers::Offset<reflection::Schema> root) {
-  fbb.FinishSizePrefixed(root, SchemaIdentifier());
-}
-
-}  // namespace reflection
-
-#endif  // FLATBUFFERS_GENERATED_REFLECTION_REFLECTION_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/registry.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/registry.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/registry.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/registry.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,130 +0,0 @@
-/*
- * Copyright 2017 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_REGISTRY_H_
-#define FLATBUFFERS_REGISTRY_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/idl.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Convenience class to easily parse or generate text for arbitrary FlatBuffers.
-// Simply pre-populate it with all schema filenames that may be in use, and
-// This class will look them up using the file_identifier declared in the
-// schema.
-class Registry {
- public:
-  // Call this for all schemas that may be in use. The identifier has
-  // a function in the generated code, e.g. MonsterIdentifier().
-  void Register(const char *file_identifier, const char *schema_path) {
-    Schema schema;
-    schema.path_ = schema_path;
-    schemas_[file_identifier] = schema;
-  }
-
-  // Generate text from an arbitrary FlatBuffer by looking up its
-  // file_identifier in the registry.
-  bool FlatBufferToText(const uint8_t *flatbuf, size_t len, std::string *dest) {
-    // Get the identifier out of the buffer.
-    // If the buffer is truncated, exit.
-    if (len < sizeof(uoffset_t) + kFileIdentifierLength) {
-      lasterror_ = "buffer truncated";
-      return false;
-    }
-    std::string ident(
-        reinterpret_cast<const char *>(flatbuf) + sizeof(uoffset_t),
-        kFileIdentifierLength);
-    // Load and parse the schema.
-    Parser parser;
-    if (!LoadSchema(ident, &parser)) return false;
-    // Now we're ready to generate text.
-    if (!GenerateText(parser, flatbuf, dest)) {
-      lasterror_ = "unable to generate text for FlatBuffer binary";
-      return false;
-    }
-    return true;
-  }
-
-  // Converts a binary buffer to text using one of the schemas in the registry,
-  // use the file_identifier to indicate which.
-  // If DetachedBuffer::data() is null then parsing failed.
-  DetachedBuffer TextToFlatBuffer(const char *text,
-                                  const char *file_identifier) {
-    // Load and parse the schema.
-    Parser parser;
-    if (!LoadSchema(file_identifier, &parser)) return DetachedBuffer();
-    // Parse the text.
-    if (!parser.Parse(text)) {
-      lasterror_ = parser.error_;
-      return DetachedBuffer();
-    }
-    // We have a valid FlatBuffer. Detach it from the builder and return.
-    return parser.builder_.Release();
-  }
-
-  // Modify any parsing / output options used by the other functions.
-  void SetOptions(const IDLOptions &opts) { opts_ = opts; }
-
-  // If schemas used contain include statements, call this function for every
-  // directory the parser should search them for.
-  void AddIncludeDirectory(const char *path) { include_paths_.push_back(path); }
-
-  // Returns a human readable error if any of the above functions fail.
-  const std::string &GetLastError() { return lasterror_; }
-
- private:
-  bool LoadSchema(const std::string &ident, Parser *parser) {
-    // Find the schema, if not, exit.
-    auto it = schemas_.find(ident);
-    if (it == schemas_.end()) {
-      // Don't attach the identifier, since it may not be human readable.
-      lasterror_ = "identifier for this buffer not in the registry";
-      return false;
-    }
-    auto &schema = it->second;
-    // Load the schema from disk. If not, exit.
-    std::string schematext;
-    if (!LoadFile(schema.path_.c_str(), false, &schematext)) {
-      lasterror_ = "could not load schema: " + schema.path_;
-      return false;
-    }
-    // Parse schema.
-    parser->opts = opts_;
-    if (!parser->Parse(schematext.c_str(), include_paths_.data(),
-                       schema.path_.c_str())) {
-      lasterror_ = parser->error_;
-      return false;
-    }
-    return true;
-  }
-
-  struct Schema {
-    std::string path_;
-    // TODO(wvo) optionally cache schema file or parsed schema here.
-  };
-
-  std::string lasterror_;
-  IDLOptions opts_;
-  std::vector<const char *> include_paths_;
-  std::map<std::string, Schema> schemas_;
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_REGISTRY_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/stl_emulation.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/stl_emulation.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/stl_emulation.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/stl_emulation.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,515 +0,0 @@
-/*
- * Copyright 2017 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_STL_EMULATION_H_
-#define FLATBUFFERS_STL_EMULATION_H_
-
-// clang-format off
-#include "flatbuffers/base.h"
-
-#include <string>
-#include <type_traits>
-#include <vector>
-#include <memory>
-#include <limits>
-
-#ifndef FLATBUFFERS_USE_STD_OPTIONAL
-  // Detect C++17 compatible compiler.
-  // __cplusplus >= 201703L - a compiler has support of 'static inline' variables.
-  #if (defined(__cplusplus) && __cplusplus >= 201703L) \
-      || (defined(_MSVC_LANG) && _MSVC_LANG >= 201703L)
-    #define FLATBUFFERS_USE_STD_OPTIONAL 1
-  #else
-    #define FLATBUFFERS_USE_STD_OPTIONAL 0
-  #endif // (defined(__cplusplus) && __cplusplus >= 201703L) ...
-#endif // FLATBUFFERS_USE_STD_OPTIONAL
-
-#if FLATBUFFERS_USE_STD_OPTIONAL
-  #include <optional>
-#endif
-
-// The __cpp_lib_span is the predefined feature macro.
-#if defined(FLATBUFFERS_USE_STD_SPAN)
-    #include <span>
-#elif defined(__cpp_lib_span) && defined(__has_include)
-  #if __has_include(<span>)
-    #include <span>
-    #define FLATBUFFERS_USE_STD_SPAN
-  #endif
-#else
-  // Disable non-trivial ctors if FLATBUFFERS_SPAN_MINIMAL defined.
-  #if !defined(FLATBUFFERS_TEMPLATES_ALIASES)
-    #define FLATBUFFERS_SPAN_MINIMAL
-  #else
-    // Enable implicit construction of a span<T,N> from a std::array<T,N>.
-    #include <array>
-  #endif
-#endif // defined(FLATBUFFERS_USE_STD_SPAN)
-
-// This header provides backwards compatibility for older versions of the STL.
-namespace mapserver {
-namespace flatbuffers {
-
-#if defined(FLATBUFFERS_TEMPLATES_ALIASES)
-  template <typename T>
-  using numeric_limits = std::numeric_limits<T>;
-#else
-  template <typename T> class numeric_limits :
-    public std::numeric_limits<T> {};
-#endif  // defined(FLATBUFFERS_TEMPLATES_ALIASES)
-
-#if defined(FLATBUFFERS_TEMPLATES_ALIASES)
-  template <typename T> using is_scalar = std::is_scalar<T>;
-  template <typename T, typename U> using is_same = std::is_same<T,U>;
-  template <typename T> using is_floating_point = std::is_floating_point<T>;
-  template <typename T> using is_unsigned = std::is_unsigned<T>;
-  template <typename T> using is_enum = std::is_enum<T>;
-  template <typename T> using make_unsigned = std::make_unsigned<T>;
-  template<bool B, class T, class F>
-  using conditional = std::conditional<B, T, F>;
-  template<class T, T v>
-  using integral_constant = std::integral_constant<T, v>;
-  template <bool B>
-  using bool_constant = integral_constant<bool, B>;
-  using true_type  = std::true_type;
-  using false_type = std::false_type;
-#else
-  // MSVC 2010 doesn't support C++11 aliases.
-  template <typename T> struct is_scalar : public std::is_scalar<T> {};
-  template <typename T, typename U> struct is_same : public std::is_same<T,U> {};
-  template <typename T> struct is_floating_point :
-        public std::is_floating_point<T> {};
-  template <typename T> struct is_unsigned : public std::is_unsigned<T> {};
-  template <typename T> struct is_enum : public std::is_enum<T> {};
-  template <typename T> struct make_unsigned : public std::make_unsigned<T> {};
-  template<bool B, class T, class F>
-  struct conditional : public std::conditional<B, T, F> {};
-  template<class T, T v>
-  struct integral_constant : public std::integral_constant<T, v> {};
-  template <bool B>
-  struct bool_constant : public integral_constant<bool, B> {};
-  typedef bool_constant<true>  true_type;
-  typedef bool_constant<false> false_type;
-#endif  // defined(FLATBUFFERS_TEMPLATES_ALIASES)
-
-#if defined(FLATBUFFERS_TEMPLATES_ALIASES)
-  template <class T> using unique_ptr = std::unique_ptr<T>;
-#else
-  // MSVC 2010 doesn't support C++11 aliases.
-  // We're manually "aliasing" the class here as we want to bring unique_ptr
-  // into the flatbuffers namespace.  We have unique_ptr in the flatbuffers
-  // namespace we have a completely independent implementation (see below)
-  // for C++98 STL implementations.
-  template <class T> class unique_ptr : public std::unique_ptr<T> {
-    public:
-    unique_ptr() {}
-    explicit unique_ptr(T* p) : std::unique_ptr<T>(p) {}
-    unique_ptr(std::unique_ptr<T>&& u) { *this = std::move(u); }
-    unique_ptr(unique_ptr&& u) { *this = std::move(u); }
-    unique_ptr& operator=(std::unique_ptr<T>&& u) {
-      std::unique_ptr<T>::reset(u.release());
-      return *this;
-    }
-    unique_ptr& operator=(unique_ptr&& u) {
-      std::unique_ptr<T>::reset(u.release());
-      return *this;
-    }
-    unique_ptr& operator=(T* p) {
-      return std::unique_ptr<T>::operator=(p);
-    }
-  };
-#endif  // defined(FLATBUFFERS_TEMPLATES_ALIASES)
-
-#if FLATBUFFERS_USE_STD_OPTIONAL
-template<class T>
-using Optional = std::optional<T>;
-using nullopt_t = std::nullopt_t;
-inline constexpr nullopt_t nullopt = std::nullopt;
-
-#else
-// Limited implementation of Optional<T> type for a scalar T.
-// This implementation limited by trivial types compatible with
-// std::is_arithmetic<T> or std::is_enum<T> type traits.
-
-// A tag to indicate an empty flatbuffers::optional<T>.
-struct nullopt_t {
-  explicit FLATBUFFERS_CONSTEXPR_CPP11 nullopt_t(int) {}
-};
-
-#if defined(FLATBUFFERS_CONSTEXPR_DEFINED)
-  namespace internal {
-    template <class> struct nullopt_holder {
-      static constexpr nullopt_t instance_ = nullopt_t(0);
-    };
-    template<class Dummy>
-    constexpr nullopt_t nullopt_holder<Dummy>::instance_;
-  }
-  static constexpr const nullopt_t &nullopt = internal::nullopt_holder<void>::instance_;
-
-#else
-  namespace internal {
-    template <class> struct nullopt_holder {
-      static const nullopt_t instance_;
-    };
-    template<class Dummy>
-    const nullopt_t nullopt_holder<Dummy>::instance_  = nullopt_t(0);
-  }
-  static const nullopt_t &nullopt = internal::nullopt_holder<void>::instance_;
-
-#endif
-
-template<class T>
-class Optional FLATBUFFERS_FINAL_CLASS {
-  // Non-scalar 'T' would extremely complicated Optional<T>.
-  // Use is_scalar<T> checking because flatbuffers flatbuffers::is_arithmetic<T>
-  // isn't implemented.
-  static_assert(flatbuffers::is_scalar<T>::value, "unexpected type T");
-
- public:
-  ~Optional() {}
-
-  FLATBUFFERS_CONSTEXPR_CPP11 Optional() FLATBUFFERS_NOEXCEPT
-    : value_(), has_value_(false) {}
-
-  FLATBUFFERS_CONSTEXPR_CPP11 Optional(nullopt_t) FLATBUFFERS_NOEXCEPT
-    : value_(), has_value_(false) {}
-
-  FLATBUFFERS_CONSTEXPR_CPP11 Optional(T val) FLATBUFFERS_NOEXCEPT
-    : value_(val), has_value_(true) {}
-
-  FLATBUFFERS_CONSTEXPR_CPP11 Optional(const Optional &other) FLATBUFFERS_NOEXCEPT
-    : value_(other.value_), has_value_(other.has_value_) {}
-
-  FLATBUFFERS_CONSTEXPR_CPP14 Optional &operator=(const Optional &other) FLATBUFFERS_NOEXCEPT {
-    value_ = other.value_;
-    has_value_ = other.has_value_;
-    return *this;
-  }
-
-  FLATBUFFERS_CONSTEXPR_CPP14 Optional &operator=(nullopt_t) FLATBUFFERS_NOEXCEPT {
-    value_ = T();
-    has_value_ = false;
-    return *this;
-  }
-
-  FLATBUFFERS_CONSTEXPR_CPP14 Optional &operator=(T val) FLATBUFFERS_NOEXCEPT {
-    value_ = val;
-    has_value_ = true;
-    return *this;
-  }
-
-  void reset() FLATBUFFERS_NOEXCEPT {
-    *this = nullopt;
-  }
-
-  void swap(Optional &other) FLATBUFFERS_NOEXCEPT {
-    std::swap(value_, other.value_);
-    std::swap(has_value_, other.has_value_);
-  }
-
-  FLATBUFFERS_CONSTEXPR_CPP11 FLATBUFFERS_EXPLICIT_CPP11 operator bool() const FLATBUFFERS_NOEXCEPT {
-    return has_value_;
-  }
-
-  FLATBUFFERS_CONSTEXPR_CPP11 bool has_value() const FLATBUFFERS_NOEXCEPT {
-    return has_value_;
-  }
-
-  FLATBUFFERS_CONSTEXPR_CPP11 const T& operator*() const FLATBUFFERS_NOEXCEPT {
-    return value_;
-  }
-
-  const T& value() const {
-    FLATBUFFERS_ASSERT(has_value());
-    return value_;
-  }
-
-  T value_or(T default_value) const FLATBUFFERS_NOEXCEPT {
-    return has_value() ? value_ : default_value;
-  }
-
- private:
-  T value_;
-  bool has_value_;
-};
-
-template<class T>
-FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const Optional<T>& opt, nullopt_t) FLATBUFFERS_NOEXCEPT {
-  return !opt;
-}
-template<class T>
-FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(nullopt_t, const Optional<T>& opt) FLATBUFFERS_NOEXCEPT {
-  return !opt;
-}
-
-template<class T, class U>
-FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const Optional<T>& lhs, const U& rhs) FLATBUFFERS_NOEXCEPT {
-  return static_cast<bool>(lhs) && (*lhs == rhs);
-}
-
-template<class T, class U>
-FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const T& lhs, const Optional<U>& rhs) FLATBUFFERS_NOEXCEPT {
-  return static_cast<bool>(rhs) && (lhs == *rhs);
-}
-
-template<class T, class U>
-FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const Optional<T>& lhs, const Optional<U>& rhs) FLATBUFFERS_NOEXCEPT {
-  return static_cast<bool>(lhs) != static_cast<bool>(rhs)
-              ? false
-              : !static_cast<bool>(lhs) ? false : (*lhs == *rhs);
-}
-#endif // FLATBUFFERS_USE_STD_OPTIONAL
-
-
-// Very limited and naive partial implementation of C++20 std::span<T,Extent>.
-#if defined(FLATBUFFERS_USE_STD_SPAN)
-  inline constexpr std::size_t dynamic_extent = std::dynamic_extent;
-  template<class T, std::size_t Extent = std::dynamic_extent>
-  using span = std::span<T, Extent>;
-
-#else // !defined(FLATBUFFERS_USE_STD_SPAN)
-FLATBUFFERS_CONSTEXPR std::size_t dynamic_extent = static_cast<std::size_t>(-1);
-
-// Exclude this code if MSVC2010 or non-STL Android is active.
-// The non-STL Android doesn't have `std::is_convertible` required for SFINAE.
-#if !defined(FLATBUFFERS_SPAN_MINIMAL)
-namespace internal {
-  // This is SFINAE helper class for checking of a common condition:
-  // > This overload only participates in overload resolution
-  // > Check whether a pointer to an array of U can be converted
-  // > to a pointer to an array of E.
-  // This helper is used for checking of 'U -> const U'.
-  template<class E, std::size_t Extent, class U, std::size_t N>
-  struct is_span_convertable {
-    using type =
-      typename std::conditional<std::is_convertible<U (*)[], E (*)[]>::value
-                                && (Extent == dynamic_extent || N == Extent),
-                                int, void>::type;
-  };
-
-  template<typename T>
-  struct SpanIterator {
-    // TODO: upgrade to std::random_access_iterator_tag.
-    using iterator_category = std::forward_iterator_tag;
-    using difference_type  = std::ptrdiff_t;
-    using value_type = typename std::remove_cv<T>::type;
-    using reference = T&;
-    using pointer   = T*;
-
-    // Convince MSVC compiler that this iterator is trusted (it is verified).
-    #ifdef _MSC_VER
-      using _Unchecked_type = pointer;
-    #endif // _MSC_VER
-
-    SpanIterator(pointer ptr) : ptr_(ptr) {}
-    reference operator*() const { return *ptr_; }
-    pointer operator->() { return ptr_; }
-    SpanIterator& operator++() { ptr_++; return *this; }  
-    SpanIterator  operator++(int) { auto tmp = *this; ++(*this); return tmp; }
-
-    friend bool operator== (const SpanIterator& lhs, const SpanIterator& rhs) { return lhs.ptr_ == rhs.ptr_; }
-    friend bool operator!= (const SpanIterator& lhs, const SpanIterator& rhs) { return lhs.ptr_ != rhs.ptr_; }
-
-   private:
-    pointer ptr_;
-  };
-}  // namespace internal
-#endif  // !defined(FLATBUFFERS_SPAN_MINIMAL)
-
-// T - element type; must be a complete type that is not an abstract
-// class type.
-// Extent - the number of elements in the sequence, or dynamic.
-template<class T, std::size_t Extent = dynamic_extent>
-class span FLATBUFFERS_FINAL_CLASS {
- public:
-  typedef T element_type;
-  typedef T& reference;
-  typedef const T& const_reference;
-  typedef T* pointer;
-  typedef const T* const_pointer;
-  typedef std::size_t size_type;
-
-  static FLATBUFFERS_CONSTEXPR size_type extent = Extent;
-
-  // Returns the number of elements in the span.
-  FLATBUFFERS_CONSTEXPR_CPP11 size_type size() const FLATBUFFERS_NOEXCEPT {
-    return count_;
-  }
-
-  // Returns the size of the sequence in bytes.
-  FLATBUFFERS_CONSTEXPR_CPP11
-  size_type size_bytes() const FLATBUFFERS_NOEXCEPT {
-    return size() * sizeof(element_type);
-  }
-
-  // Checks if the span is empty.
-  FLATBUFFERS_CONSTEXPR_CPP11 bool empty() const FLATBUFFERS_NOEXCEPT {
-    return size() == 0;
-  }
-
-  // Returns a pointer to the beginning of the sequence.
-  FLATBUFFERS_CONSTEXPR_CPP11 pointer data() const FLATBUFFERS_NOEXCEPT {
-    return data_;
-  }
-
-  #if !defined(FLATBUFFERS_SPAN_MINIMAL)
-    using Iterator = internal::SpanIterator<T>;
-    using ConstIterator = internal::SpanIterator<const T>;
-
-    Iterator begin() const { return Iterator(data()); }
-    Iterator end() const   { return Iterator(data() + size()); }
-
-    ConstIterator cbegin() const { return ConstIterator(data()); }
-    ConstIterator cend() const  { return ConstIterator(data() + size()); }
-  #endif
-
-  // Returns a reference to the idx-th element of the sequence.
-  // The behavior is undefined if the idx is greater than or equal to size().
-  FLATBUFFERS_CONSTEXPR_CPP11 reference operator[](size_type idx) const {
-    return data()[idx];
-  }
-
-  FLATBUFFERS_CONSTEXPR_CPP11 span(const span &other) FLATBUFFERS_NOEXCEPT
-      : data_(other.data_), count_(other.count_) {}
-
-  FLATBUFFERS_CONSTEXPR_CPP14 span &operator=(const span &other)
-      FLATBUFFERS_NOEXCEPT {
-    data_ = other.data_;
-    count_ = other.count_;
-  }
-
-  // Limited implementation of
-  // `template <class It> constexpr std::span(It first, size_type count);`.
-  //
-  // Constructs a span that is a view over the range [first, first + count);
-  // the resulting span has: data() == first and size() == count.
-  // The behavior is undefined if [first, first + count) is not a valid range,
-  // or if (extent != flatbuffers::dynamic_extent && count != extent).
-  FLATBUFFERS_CONSTEXPR_CPP11
-  explicit span(pointer first, size_type count) FLATBUFFERS_NOEXCEPT
-    : data_ (Extent == dynamic_extent ? first : (Extent == count ? first : nullptr)),
-      count_(Extent == dynamic_extent ? count : (Extent == count ? Extent : 0)) {
-      // Make span empty if the count argument is incompatible with span<T,N>.
-  }
-
-  // Exclude this code if MSVC2010 is active. The MSVC2010 isn't C++11
-  // compliant, it doesn't support default template arguments for functions.
-  #if defined(FLATBUFFERS_SPAN_MINIMAL)
-  FLATBUFFERS_CONSTEXPR_CPP11 span() FLATBUFFERS_NOEXCEPT : data_(nullptr),
-                                                            count_(0) {
-    static_assert(extent == 0 || extent == dynamic_extent, "invalid span");
-  }
-
-  #else
-  // Constructs an empty span whose data() == nullptr and size() == 0.
-  // This overload only participates in overload resolution if
-  // extent == 0 || extent == flatbuffers::dynamic_extent.
-  // A dummy template argument N is need dependency for SFINAE.
-  template<std::size_t N = 0,
-    typename internal::is_span_convertable<element_type, Extent, element_type, (N - N)>::type = 0>
-  FLATBUFFERS_CONSTEXPR_CPP11 span() FLATBUFFERS_NOEXCEPT : data_(nullptr),
-                                                            count_(0) {
-    static_assert(extent == 0 || extent == dynamic_extent, "invalid span");
-  }
-
-  // Constructs a span that is a view over the array arr; the resulting span
-  // has size() == N and data() == std::data(arr). These overloads only
-  // participate in overload resolution if
-  // extent == std::dynamic_extent || N == extent is true and
-  // std::remove_pointer_t<decltype(std::data(arr))>(*)[]
-  // is convertible to element_type (*)[].
-  template<std::size_t N,
-    typename internal::is_span_convertable<element_type, Extent, element_type, N>::type = 0>
-  FLATBUFFERS_CONSTEXPR_CPP11 span(element_type (&arr)[N]) FLATBUFFERS_NOEXCEPT
-      : data_(arr), count_(N) {}
-
-  template<class U, std::size_t N,
-    typename internal::is_span_convertable<element_type, Extent, U, N>::type = 0>
-  FLATBUFFERS_CONSTEXPR_CPP11 span(std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT
-     : data_(arr.data()), count_(N) {}
-
-  //template<class U, std::size_t N,
-  //  int = 0>
-  //FLATBUFFERS_CONSTEXPR_CPP11 span(std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT
-  //   : data_(arr.data()), count_(N) {}
-
-  template<class U, std::size_t N,
-    typename internal::is_span_convertable<element_type, Extent, U, N>::type = 0>
-  FLATBUFFERS_CONSTEXPR_CPP11 span(const std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT
-    : data_(arr.data()), count_(N) {}
-
-  // Converting constructor from another span s;
-  // the resulting span has size() == s.size() and data() == s.data().
-  // This overload only participates in overload resolution
-  // if extent == std::dynamic_extent || N == extent is true and U (*)[]
-  // is convertible to element_type (*)[].
-  template<class U, std::size_t N,
-    typename internal::is_span_convertable<element_type, Extent, U, N>::type = 0>
-  FLATBUFFERS_CONSTEXPR_CPP11 span(const flatbuffers::span<U, N> &s) FLATBUFFERS_NOEXCEPT
-      : span(s.data(), s.size()) {
-  }
-
-  #endif  // !defined(FLATBUFFERS_SPAN_MINIMAL)
-
- private:
-  // This is a naive implementation with 'count_' member even if (Extent != dynamic_extent).
-  pointer const data_;
-  size_type count_;
-};
-#endif  // defined(FLATBUFFERS_USE_STD_SPAN)
-
-#if !defined(FLATBUFFERS_SPAN_MINIMAL)
-template<class U, std::size_t N>
-FLATBUFFERS_CONSTEXPR_CPP11
-flatbuffers::span<U, N> make_span(U(&arr)[N]) FLATBUFFERS_NOEXCEPT {
-  return span<U, N>(arr);
-}
-
-template<class U, std::size_t N>
-FLATBUFFERS_CONSTEXPR_CPP11
-flatbuffers::span<const U, N> make_span(const U(&arr)[N]) FLATBUFFERS_NOEXCEPT {
-  return span<const U, N>(arr);
-}
-
-template<class U, std::size_t N>
-FLATBUFFERS_CONSTEXPR_CPP11
-flatbuffers::span<U, N> make_span(std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
-  return span<U, N>(arr);
-}
-
-template<class U, std::size_t N>
-FLATBUFFERS_CONSTEXPR_CPP11
-flatbuffers::span<const U, N> make_span(const std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
-  return span<const U, N>(arr);
-}
-
-template<class U, std::size_t N>
-FLATBUFFERS_CONSTEXPR_CPP11
-flatbuffers::span<U, dynamic_extent> make_span(U *first, std::size_t count) FLATBUFFERS_NOEXCEPT {
-  return span<U, dynamic_extent>(first, count);
-}
-
-template<class U, std::size_t N>
-FLATBUFFERS_CONSTEXPR_CPP11
-flatbuffers::span<const U, dynamic_extent> make_span(const U *first, std::size_t count) FLATBUFFERS_NOEXCEPT {
-  return span<const U, dynamic_extent>(first, count);
-}
-#endif // !defined(FLATBUFFERS_SPAN_MINIMAL)
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_STL_EMULATION_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/string.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/string.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/string.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/string.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_STRING_H_
-#define FLATBUFFERS_STRING_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/vector.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-struct String : public Vector<char> {
-  const char *c_str() const { return reinterpret_cast<const char *>(Data()); }
-  std::string str() const { return std::string(c_str(), size()); }
-
-  // clang-format off
-  #ifdef FLATBUFFERS_HAS_STRING_VIEW
-  flatbuffers::string_view string_view() const {
-    return flatbuffers::string_view(c_str(), size());
-  }
-  #endif // FLATBUFFERS_HAS_STRING_VIEW
-  // clang-format on
-
-  bool operator<(const String &o) const {
-    return StringLessThan(this->data(), this->size(), o.data(), o.size());
-  }
-};
-
-// Convenience function to get std::string from a String returning an empty
-// string on null pointer.
-static inline std::string GetString(const String *str) {
-  return str ? str->str() : "";
-}
-
-// Convenience function to get char* from a String returning an empty string on
-// null pointer.
-static inline const char *GetCstring(const String *str) {
-  return str ? str->c_str() : "";
-}
-
-#ifdef FLATBUFFERS_HAS_STRING_VIEW
-// Convenience function to get string_view from a String returning an empty
-// string_view on null pointer.
-static inline flatbuffers::string_view GetStringView(const String *str) {
-  return str ? str->string_view() : flatbuffers::string_view();
-}
-#endif  // FLATBUFFERS_HAS_STRING_VIEW
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_STRING_H_
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/struct.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/struct.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/struct.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/struct.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_STRUCT_H_
-#define FLATBUFFERS_STRUCT_H_
-
-#include "flatbuffers/base.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// "structs" are flat structures that do not have an offset table, thus
-// always have all members present and do not support forwards/backwards
-// compatible extensions.
-
-class Struct FLATBUFFERS_FINAL_CLASS {
- public:
-  template<typename T> T GetField(uoffset_t o) const {
-    return ReadScalar<T>(&data_[o]);
-  }
-
-  template<typename T> T GetStruct(uoffset_t o) const {
-    return reinterpret_cast<T>(&data_[o]);
-  }
-
-  const uint8_t *GetAddressOf(uoffset_t o) const { return &data_[o]; }
-  uint8_t *GetAddressOf(uoffset_t o) { return &data_[o]; }
-
- private:
-  // private constructor & copy constructor: you obtain instances of this
-  // class by pointing to existing data only
-  Struct();
-  Struct(const Struct &);
-  Struct &operator=(const Struct &);
-
-  uint8_t data_[1];
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_STRUCT_H_
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/table.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/table.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/table.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/table.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,170 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_TABLE_H_
-#define FLATBUFFERS_TABLE_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/verifier.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// "tables" use an offset table (possibly shared) that allows fields to be
-// omitted and added at will, but uses an extra indirection to read.
-class Table {
- public:
-  const uint8_t *GetVTable() const {
-    return data_ - ReadScalar<soffset_t>(data_);
-  }
-
-  // This gets the field offset for any of the functions below it, or 0
-  // if the field was not present.
-  voffset_t GetOptionalFieldOffset(voffset_t field) const {
-    // The vtable offset is always at the start.
-    auto vtable = GetVTable();
-    // The first element is the size of the vtable (fields + type id + itself).
-    auto vtsize = ReadScalar<voffset_t>(vtable);
-    // If the field we're accessing is outside the vtable, we're reading older
-    // data, so it's the same as if the offset was 0 (not present).
-    return field < vtsize ? ReadScalar<voffset_t>(vtable + field) : 0;
-  }
-
-  template<typename T> T GetField(voffset_t field, T defaultval) const {
-    auto field_offset = GetOptionalFieldOffset(field);
-    return field_offset ? ReadScalar<T>(data_ + field_offset) : defaultval;
-  }
-
-  template<typename P> P GetPointer(voffset_t field) {
-    auto field_offset = GetOptionalFieldOffset(field);
-    auto p = data_ + field_offset;
-    return field_offset ? reinterpret_cast<P>(p + ReadScalar<uoffset_t>(p))
-                        : nullptr;
-  }
-  template<typename P> P GetPointer(voffset_t field) const {
-    return const_cast<Table *>(this)->GetPointer<P>(field);
-  }
-
-  template<typename P> P GetStruct(voffset_t field) const {
-    auto field_offset = GetOptionalFieldOffset(field);
-    auto p = const_cast<uint8_t *>(data_ + field_offset);
-    return field_offset ? reinterpret_cast<P>(p) : nullptr;
-  }
-
-  template<typename Raw, typename Face>
-  flatbuffers::Optional<Face> GetOptional(voffset_t field) const {
-    auto field_offset = GetOptionalFieldOffset(field);
-    auto p = data_ + field_offset;
-    return field_offset ? Optional<Face>(static_cast<Face>(ReadScalar<Raw>(p)))
-                        : Optional<Face>();
-  }
-
-  template<typename T> bool SetField(voffset_t field, T val, T def) {
-    auto field_offset = GetOptionalFieldOffset(field);
-    if (!field_offset) return IsTheSameAs(val, def);
-    WriteScalar(data_ + field_offset, val);
-    return true;
-  }
-  template<typename T> bool SetField(voffset_t field, T val) {
-    auto field_offset = GetOptionalFieldOffset(field);
-    if (!field_offset) return false;
-    WriteScalar(data_ + field_offset, val);
-    return true;
-  }
-
-  bool SetPointer(voffset_t field, const uint8_t *val) {
-    auto field_offset = GetOptionalFieldOffset(field);
-    if (!field_offset) return false;
-    WriteScalar(data_ + field_offset,
-                static_cast<uoffset_t>(val - (data_ + field_offset)));
-    return true;
-  }
-
-  uint8_t *GetAddressOf(voffset_t field) {
-    auto field_offset = GetOptionalFieldOffset(field);
-    return field_offset ? data_ + field_offset : nullptr;
-  }
-  const uint8_t *GetAddressOf(voffset_t field) const {
-    return const_cast<Table *>(this)->GetAddressOf(field);
-  }
-
-  bool CheckField(voffset_t field) const {
-    return GetOptionalFieldOffset(field) != 0;
-  }
-
-  // Verify the vtable of this table.
-  // Call this once per table, followed by VerifyField once per field.
-  bool VerifyTableStart(Verifier &verifier) const {
-    return verifier.VerifyTableStart(data_);
-  }
-
-  // Verify a particular field.
-  template<typename T>
-  bool VerifyField(const Verifier &verifier, voffset_t field,
-                   size_t align) const {
-    // Calling GetOptionalFieldOffset should be safe now thanks to
-    // VerifyTable().
-    auto field_offset = GetOptionalFieldOffset(field);
-    // Check the actual field.
-    return !field_offset || verifier.VerifyField<T>(data_, field_offset, align);
-  }
-
-  // VerifyField for required fields.
-  template<typename T>
-  bool VerifyFieldRequired(const Verifier &verifier, voffset_t field,
-                           size_t align) const {
-    auto field_offset = GetOptionalFieldOffset(field);
-    return verifier.Check(field_offset != 0) &&
-           verifier.VerifyField<T>(data_, field_offset, align);
-  }
-
-  // Versions for offsets.
-  bool VerifyOffset(const Verifier &verifier, voffset_t field) const {
-    auto field_offset = GetOptionalFieldOffset(field);
-    return !field_offset || verifier.VerifyOffset(data_, field_offset);
-  }
-
-  bool VerifyOffsetRequired(const Verifier &verifier, voffset_t field) const {
-    auto field_offset = GetOptionalFieldOffset(field);
-    return verifier.Check(field_offset != 0) &&
-           verifier.VerifyOffset(data_, field_offset);
-  }
-
- private:
-  // private constructor & copy constructor: you obtain instances of this
-  // class by pointing to existing data only
-  Table();
-  Table(const Table &other);
-  Table &operator=(const Table &);
-
-  uint8_t data_[1];
-};
-
-// This specialization allows avoiding warnings like:
-// MSVC C4800: type: forcing value to bool 'true' or 'false'.
-template<>
-inline flatbuffers::Optional<bool> Table::GetOptional<uint8_t, bool>(
-    voffset_t field) const {
-  auto field_offset = GetOptionalFieldOffset(field);
-  auto p = data_ + field_offset;
-  return field_offset ? Optional<bool>(ReadScalar<uint8_t>(p) != 0)
-                      : Optional<bool>();
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_TABLE_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/util.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/util.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/util.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/util.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,718 +0,0 @@
-/*
- * Copyright 2014 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_UTIL_H_
-#define FLATBUFFERS_UTIL_H_
-
-#include <ctype.h>
-#include <errno.h>
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/stl_emulation.h"
-
-#ifndef FLATBUFFERS_PREFER_PRINTF
-#  include <iomanip>
-#  include <sstream>
-#else  // FLATBUFFERS_PREFER_PRINTF
-#  include <float.h>
-#  include <stdio.h>
-#endif  // FLATBUFFERS_PREFER_PRINTF
-
-#include <string>
-
-namespace mapserver {
-namespace flatbuffers {
-
-// @locale-independent functions for ASCII characters set.
-
-// Fast checking that character lies in closed range: [a <= x <= b]
-// using one compare (conditional branch) operator.
-inline bool check_ascii_range(char x, char a, char b) {
-  FLATBUFFERS_ASSERT(a <= b);
-  // (Hacker's Delight): `a <= x <= b` <=> `(x-a) <={u} (b-a)`.
-  // The x, a, b will be promoted to int and subtracted without overflow.
-  return static_cast<unsigned int>(x - a) <= static_cast<unsigned int>(b - a);
-}
-
-// Case-insensitive isalpha
-inline bool is_alpha(char c) {
-  // ASCII only: alpha to upper case => reset bit 0x20 (~0x20 = 0xDF).
-  return check_ascii_range(c & 0xDF, 'a' & 0xDF, 'z' & 0xDF);
-}
-
-// Check for uppercase alpha
-inline bool is_alpha_upper(char c) { return check_ascii_range(c, 'A', 'Z'); }
-
-// Check (case-insensitive) that `c` is equal to alpha.
-inline bool is_alpha_char(char c, char alpha) {
-  FLATBUFFERS_ASSERT(is_alpha(alpha));
-  // ASCII only: alpha to upper case => reset bit 0x20 (~0x20 = 0xDF).
-  return ((c & 0xDF) == (alpha & 0xDF));
-}
-
-// https://en.cppreference.com/w/cpp/string/byte/isxdigit
-// isdigit and isxdigit are the only standard narrow character classification
-// functions that are not affected by the currently installed C locale. although
-// some implementations (e.g. Microsoft in 1252 codepage) may classify
-// additional single-byte characters as digits.
-inline bool is_digit(char c) { return check_ascii_range(c, '0', '9'); }
-
-inline bool is_xdigit(char c) {
-  // Replace by look-up table.
-  return is_digit(c) || check_ascii_range(c & 0xDF, 'a' & 0xDF, 'f' & 0xDF);
-}
-
-// Case-insensitive isalnum
-inline bool is_alnum(char c) { return is_alpha(c) || is_digit(c); }
-
-inline char CharToUpper(char c) {
-  return static_cast<char>(::toupper(static_cast<unsigned char>(c)));
-}
-
-inline char CharToLower(char c) {
-  return static_cast<char>(::tolower(static_cast<unsigned char>(c)));
-}
-
-// @end-locale-independent functions for ASCII character set
-
-#ifdef FLATBUFFERS_PREFER_PRINTF
-template<typename T> size_t IntToDigitCount(T t) {
-  size_t digit_count = 0;
-  // Count the sign for negative numbers
-  if (t < 0) digit_count++;
-  // Count a single 0 left of the dot for fractional numbers
-  if (-1 < t && t < 1) digit_count++;
-  // Count digits until fractional part
-  T eps = std::numeric_limits<T>::epsilon();
-  while (t <= (-1 + eps) || (1 - eps) <= t) {
-    t /= 10;
-    digit_count++;
-  }
-  return digit_count;
-}
-
-template<typename T> size_t NumToStringWidth(T t, int precision = 0) {
-  size_t string_width = IntToDigitCount(t);
-  // Count the dot for floating point numbers
-  if (precision) string_width += (precision + 1);
-  return string_width;
-}
-
-template<typename T>
-std::string NumToStringImplWrapper(T t, const char *fmt, int precision = 0) {
-  size_t string_width = NumToStringWidth(t, precision);
-  std::string s(string_width, 0x00);
-  // Allow snprintf to use std::string trailing null to detect buffer overflow
-  snprintf(const_cast<char *>(s.data()), (s.size() + 1), fmt, string_width, t);
-  return s;
-}
-#endif  // FLATBUFFERS_PREFER_PRINTF
-
-// Convert an integer or floating point value to a string.
-// In contrast to std::stringstream, "char" values are
-// converted to a string of digits, and we don't use scientific notation.
-template<typename T> std::string NumToString(T t) {
-  // clang-format off
-
-  #ifndef FLATBUFFERS_PREFER_PRINTF
-    std::stringstream ss;
-    ss << t;
-    return ss.str();
-  #else // FLATBUFFERS_PREFER_PRINTF
-    auto v = static_cast<long long>(t);
-    return NumToStringImplWrapper(v, "%.*lld");
-  #endif // FLATBUFFERS_PREFER_PRINTF
-  // clang-format on
-}
-// Avoid char types used as character data.
-template<> inline std::string NumToString<signed char>(signed char t) {
-  return NumToString(static_cast<int>(t));
-}
-template<> inline std::string NumToString<unsigned char>(unsigned char t) {
-  return NumToString(static_cast<int>(t));
-}
-template<> inline std::string NumToString<char>(char t) {
-  return NumToString(static_cast<int>(t));
-}
-
-// Special versions for floats/doubles.
-template<typename T> std::string FloatToString(T t, int precision) {
-  // clang-format off
-
-  #ifndef FLATBUFFERS_PREFER_PRINTF
-    // to_string() prints different numbers of digits for floats depending on
-    // platform and isn't available on Android, so we use stringstream
-    std::stringstream ss;
-    // Use std::fixed to suppress scientific notation.
-    ss << std::fixed;
-    // Default precision is 6, we want that to be higher for doubles.
-    ss << std::setprecision(precision);
-    ss << t;
-    auto s = ss.str();
-  #else // FLATBUFFERS_PREFER_PRINTF
-    auto v = static_cast<double>(t);
-    auto s = NumToStringImplWrapper(v, "%0.*f", precision);
-  #endif // FLATBUFFERS_PREFER_PRINTF
-  // clang-format on
-  // Sadly, std::fixed turns "1" into "1.00000", so here we undo that.
-  auto p = s.find_last_not_of('0');
-  if (p != std::string::npos) {
-    // Strip trailing zeroes. If it is a whole number, keep one zero.
-    s.resize(p + (s[p] == '.' ? 2 : 1));
-  }
-  return s;
-}
-
-template<> inline std::string NumToString<double>(double t) {
-  return FloatToString(t, 12);
-}
-template<> inline std::string NumToString<float>(float t) {
-  return FloatToString(t, 6);
-}
-
-// Convert an integer value to a hexadecimal string.
-// The returned string length is always xdigits long, prefixed by 0 digits.
-// For example, IntToStringHex(0x23, 8) returns the string "00000023".
-inline std::string IntToStringHex(int i, int xdigits) {
-  FLATBUFFERS_ASSERT(i >= 0);
-  // clang-format off
-
-  #ifndef FLATBUFFERS_PREFER_PRINTF
-    std::stringstream ss;
-    ss << std::setw(xdigits) << std::setfill('0') << std::hex << std::uppercase
-       << i;
-    return ss.str();
-  #else // FLATBUFFERS_PREFER_PRINTF
-    return NumToStringImplWrapper(i, "%.*X", xdigits);
-  #endif // FLATBUFFERS_PREFER_PRINTF
-  // clang-format on
-}
-
-// clang-format off
-// Use locale independent functions {strtod_l, strtof_l, strtoll_l, strtoull_l}.
-#if defined(FLATBUFFERS_LOCALE_INDEPENDENT) && (FLATBUFFERS_LOCALE_INDEPENDENT > 0)
-  class ClassicLocale {
-    #ifdef _MSC_VER
-      typedef _locale_t locale_type;
-    #else
-      typedef locale_t locale_type;  // POSIX.1-2008 locale_t type
-    #endif
-    ClassicLocale();
-    ~ClassicLocale();
-    locale_type locale_;
-    static ClassicLocale instance_;
-  public:
-    static locale_type Get() { return instance_.locale_; }
-  };
-
-  #ifdef _MSC_VER
-    #define __strtoull_impl(s, pe, b) _strtoui64_l(s, pe, b, ClassicLocale::Get())
-    #define __strtoll_impl(s, pe, b) _strtoi64_l(s, pe, b, ClassicLocale::Get())
-    #define __strtod_impl(s, pe) _strtod_l(s, pe, ClassicLocale::Get())
-    #define __strtof_impl(s, pe) _strtof_l(s, pe, ClassicLocale::Get())
-  #else
-    #define __strtoull_impl(s, pe, b) strtoull_l(s, pe, b, ClassicLocale::Get())
-    #define __strtoll_impl(s, pe, b) strtoll_l(s, pe, b, ClassicLocale::Get())
-    #define __strtod_impl(s, pe) strtod_l(s, pe, ClassicLocale::Get())
-    #define __strtof_impl(s, pe) strtof_l(s, pe, ClassicLocale::Get())
-  #endif
-#else
-  #define __strtod_impl(s, pe) strtod(s, pe)
-  #define __strtof_impl(s, pe) static_cast<float>(strtod(s, pe))
-  #ifdef _MSC_VER
-    #define __strtoull_impl(s, pe, b) _strtoui64(s, pe, b)
-    #define __strtoll_impl(s, pe, b) _strtoi64(s, pe, b)
-  #else
-    #define __strtoull_impl(s, pe, b) strtoull(s, pe, b)
-    #define __strtoll_impl(s, pe, b) strtoll(s, pe, b)
-  #endif
-#endif
-
-inline void strtoval_impl(int64_t *val, const char *str, char **endptr,
-                                 int base) {
-    *val = __strtoll_impl(str, endptr, base);
-}
-
-inline void strtoval_impl(uint64_t *val, const char *str, char **endptr,
-                                 int base) {
-  *val = __strtoull_impl(str, endptr, base);
-}
-
-inline void strtoval_impl(double *val, const char *str, char **endptr) {
-  *val = __strtod_impl(str, endptr);
-}
-
-// UBSAN: double to float is safe if numeric_limits<float>::is_iec559 is true.
-__supress_ubsan__("float-cast-overflow")
-inline void strtoval_impl(float *val, const char *str, char **endptr) {
-  *val = __strtof_impl(str, endptr);
-}
-#undef __strtoull_impl
-#undef __strtoll_impl
-#undef __strtod_impl
-#undef __strtof_impl
-// clang-format on
-
-// Adaptor for strtoull()/strtoll().
-// Flatbuffers accepts numbers with any count of leading zeros (-009 is -9),
-// while strtoll with base=0 interprets first leading zero as octal prefix.
-// In future, it is possible to add prefixed 0b0101.
-// 1) Checks errno code for overflow condition (out of range).
-// 2) If base <= 0, function try to detect base of number by prefix.
-//
-// Return value (like strtoull and strtoll, but reject partial result):
-// - If successful, an integer value corresponding to the str is returned.
-// - If full string conversion can't be performed, 0 is returned.
-// - If the converted value falls out of range of corresponding return type, a
-// range error occurs. In this case value MAX(T)/MIN(T) is returned.
-template<typename T>
-inline bool StringToIntegerImpl(T *val, const char *const str,
-                                const int base = 0,
-                                const bool check_errno = true) {
-  // T is int64_t or uint64_T
-  FLATBUFFERS_ASSERT(str);
-  if (base <= 0) {
-    auto s = str;
-    while (*s && !is_digit(*s)) s++;
-    if (s[0] == '0' && is_alpha_char(s[1], 'X'))
-      return StringToIntegerImpl(val, str, 16, check_errno);
-    // if a prefix not match, try base=10
-    return StringToIntegerImpl(val, str, 10, check_errno);
-  } else {
-    if (check_errno) errno = 0;  // clear thread-local errno
-    auto endptr = str;
-    strtoval_impl(val, str, const_cast<char **>(&endptr), base);
-    if ((*endptr != '\0') || (endptr == str)) {
-      *val = 0;      // erase partial result
-      return false;  // invalid string
-    }
-    // errno is out-of-range, return MAX/MIN
-    if (check_errno && errno) return false;
-    return true;
-  }
-}
-
-template<typename T>
-inline bool StringToFloatImpl(T *val, const char *const str) {
-  // Type T must be either float or double.
-  FLATBUFFERS_ASSERT(str && val);
-  auto end = str;
-  strtoval_impl(val, str, const_cast<char **>(&end));
-  auto done = (end != str) && (*end == '\0');
-  if (!done) *val = 0;  // erase partial result
-  return done;
-}
-
-// Convert a string to an instance of T.
-// Return value (matched with StringToInteger64Impl and strtod):
-// - If successful, a numeric value corresponding to the str is returned.
-// - If full string conversion can't be performed, 0 is returned.
-// - If the converted value falls out of range of corresponding return type, a
-// range error occurs. In this case value MAX(T)/MIN(T) is returned.
-template<typename T> inline bool StringToNumber(const char *s, T *val) {
-  // Assert on `unsigned long` and `signed long` on LP64.
-  // If it is necessary, it could be solved with flatbuffers::enable_if<B,T>.
-  static_assert(sizeof(T) < sizeof(int64_t), "unexpected type T");
-  FLATBUFFERS_ASSERT(s && val);
-  int64_t i64;
-  // The errno check isn't needed, will return MAX/MIN on overflow.
-  if (StringToIntegerImpl(&i64, s, 0, false)) {
-    const int64_t max = (flatbuffers::numeric_limits<T>::max)();
-    const int64_t min = flatbuffers::numeric_limits<T>::lowest();
-    if (i64 > max) {
-      *val = static_cast<T>(max);
-      return false;
-    }
-    if (i64 < min) {
-      // For unsigned types return max to distinguish from
-      // "no conversion can be performed" when 0 is returned.
-      *val = static_cast<T>(flatbuffers::is_unsigned<T>::value ? max : min);
-      return false;
-    }
-    *val = static_cast<T>(i64);
-    return true;
-  }
-  *val = 0;
-  return false;
-}
-
-template<> inline bool StringToNumber<int64_t>(const char *str, int64_t *val) {
-  return StringToIntegerImpl(val, str);
-}
-
-template<>
-inline bool StringToNumber<uint64_t>(const char *str, uint64_t *val) {
-  if (!StringToIntegerImpl(val, str)) return false;
-  // The strtoull accepts negative numbers:
-  // If the minus sign was part of the input sequence, the numeric value
-  // calculated from the sequence of digits is negated as if by unary minus
-  // in the result type, which applies unsigned integer wraparound rules.
-  // Fix this behaviour (except -0).
-  if (*val) {
-    auto s = str;
-    while (*s && !is_digit(*s)) s++;
-    s = (s > str) ? (s - 1) : s;  // step back to one symbol
-    if (*s == '-') {
-      // For unsigned types return the max to distinguish from
-      // "no conversion can be performed".
-      *val = (flatbuffers::numeric_limits<uint64_t>::max)();
-      return false;
-    }
-  }
-  return true;
-}
-
-template<> inline bool StringToNumber(const char *s, float *val) {
-  return StringToFloatImpl(val, s);
-}
-
-template<> inline bool StringToNumber(const char *s, double *val) {
-  return StringToFloatImpl(val, s);
-}
-
-inline int64_t StringToInt(const char *s, int base = 10) {
-  int64_t val;
-  return StringToIntegerImpl(&val, s, base) ? val : 0;
-}
-
-inline uint64_t StringToUInt(const char *s, int base = 10) {
-  uint64_t val;
-  return StringToIntegerImpl(&val, s, base) ? val : 0;
-}
-
-typedef bool (*LoadFileFunction)(const char *filename, bool binary,
-                                 std::string *dest);
-typedef bool (*FileExistsFunction)(const char *filename);
-
-LoadFileFunction SetLoadFileFunction(LoadFileFunction load_file_function);
-
-FileExistsFunction SetFileExistsFunction(
-    FileExistsFunction file_exists_function);
-
-// Check if file "name" exists.
-bool FileExists(const char *name);
-
-// Check if "name" exists and it is also a directory.
-bool DirExists(const char *name);
-
-// Load file "name" into "buf" returning true if successful
-// false otherwise.  If "binary" is false data is read
-// using ifstream's text mode, otherwise data is read with
-// no transcoding.
-bool LoadFile(const char *name, bool binary, std::string *buf);
-
-// Save data "buf" of length "len" bytes into a file
-// "name" returning true if successful, false otherwise.
-// If "binary" is false data is written using ifstream's
-// text mode, otherwise data is written with no
-// transcoding.
-bool SaveFile(const char *name, const char *buf, size_t len, bool binary);
-
-// Save data "buf" into file "name" returning true if
-// successful, false otherwise.  If "binary" is false
-// data is written using ifstream's text mode, otherwise
-// data is written with no transcoding.
-inline bool SaveFile(const char *name, const std::string &buf, bool binary) {
-  return SaveFile(name, buf.c_str(), buf.size(), binary);
-}
-
-// Functionality for minimalistic portable path handling.
-
-// The functions below behave correctly regardless of whether posix ('/') or
-// Windows ('/' or '\\') separators are used.
-
-// Any new separators inserted are always posix.
-FLATBUFFERS_CONSTEXPR char kPathSeparator = '/';
-
-// Returns the path with the extension, if any, removed.
-std::string StripExtension(const std::string &filepath);
-
-// Returns the extension, if any.
-std::string GetExtension(const std::string &filepath);
-
-// Return the last component of the path, after the last separator.
-std::string StripPath(const std::string &filepath);
-
-// Strip the last component of the path + separator.
-std::string StripFileName(const std::string &filepath);
-
-// Concatenates a path with a filename, regardless of whether the path
-// ends in a separator or not.
-std::string ConCatPathFileName(const std::string &path,
-                               const std::string &filename);
-
-// Replaces any '\\' separators with '/'
-std::string PosixPath(const char *path);
-std::string PosixPath(const std::string &path);
-
-// This function ensure a directory exists, by recursively
-// creating dirs for any parts of the path that don't exist yet.
-void EnsureDirExists(const std::string &filepath);
-
-// Obtains the absolute path from any other path.
-// Returns the input path if the absolute path couldn't be resolved.
-std::string AbsolutePath(const std::string &filepath);
-
-// Returns files relative to the --project_root path, prefixed with `//`.
-std::string RelativeToRootPath(const std::string &project,
-                               const std::string &filepath);
-
-// To and from UTF-8 unicode conversion functions
-
-// Convert a unicode code point into a UTF-8 representation by appending it
-// to a string. Returns the number of bytes generated.
-inline int ToUTF8(uint32_t ucc, std::string *out) {
-  FLATBUFFERS_ASSERT(!(ucc & 0x80000000));  // Top bit can't be set.
-  // 6 possible encodings: http://en.wikipedia.org/wiki/UTF-8
-  for (int i = 0; i < 6; i++) {
-    // Max bits this encoding can represent.
-    uint32_t max_bits = 6 + i * 5 + static_cast<int>(!i);
-    if (ucc < (1u << max_bits)) {  // does it fit?
-      // Remaining bits not encoded in the first byte, store 6 bits each
-      uint32_t remain_bits = i * 6;
-      // Store first byte:
-      (*out) += static_cast<char>((0xFE << (max_bits - remain_bits)) |
-                                  (ucc >> remain_bits));
-      // Store remaining bytes:
-      for (int j = i - 1; j >= 0; j--) {
-        (*out) += static_cast<char>(((ucc >> (j * 6)) & 0x3F) | 0x80);
-      }
-      return i + 1;  // Return the number of bytes added.
-    }
-  }
-  FLATBUFFERS_ASSERT(0);  // Impossible to arrive here.
-  return -1;
-}
-
-// Converts whatever prefix of the incoming string corresponds to a valid
-// UTF-8 sequence into a unicode code. The incoming pointer will have been
-// advanced past all bytes parsed.
-// returns -1 upon corrupt UTF-8 encoding (ignore the incoming pointer in
-// this case).
-inline int FromUTF8(const char **in) {
-  int len = 0;
-  // Count leading 1 bits.
-  for (int mask = 0x80; mask >= 0x04; mask >>= 1) {
-    if (**in & mask) {
-      len++;
-    } else {
-      break;
-    }
-  }
-  if ((static_cast<unsigned char>(**in) << len) & 0x80)
-    return -1;  // Bit after leading 1's must be 0.
-  if (!len) return *(*in)++;
-  // UTF-8 encoded values with a length are between 2 and 4 bytes.
-  if (len < 2 || len > 4) { return -1; }
-  // Grab initial bits of the code.
-  int ucc = *(*in)++ & ((1 << (7 - len)) - 1);
-  for (int i = 0; i < len - 1; i++) {
-    if ((**in & 0xC0) != 0x80) return -1;  // Upper bits must 1 0.
-    ucc <<= 6;
-    ucc |= *(*in)++ & 0x3F;  // Grab 6 more bits of the code.
-  }
-  // UTF-8 cannot encode values between 0xD800 and 0xDFFF (reserved for
-  // UTF-16 surrogate pairs).
-  if (ucc >= 0xD800 && ucc <= 0xDFFF) { return -1; }
-  // UTF-8 must represent code points in their shortest possible encoding.
-  switch (len) {
-    case 2:
-      // Two bytes of UTF-8 can represent code points from U+0080 to U+07FF.
-      if (ucc < 0x0080 || ucc > 0x07FF) { return -1; }
-      break;
-    case 3:
-      // Three bytes of UTF-8 can represent code points from U+0800 to U+FFFF.
-      if (ucc < 0x0800 || ucc > 0xFFFF) { return -1; }
-      break;
-    case 4:
-      // Four bytes of UTF-8 can represent code points from U+10000 to U+10FFFF.
-      if (ucc < 0x10000 || ucc > 0x10FFFF) { return -1; }
-      break;
-  }
-  return ucc;
-}
-
-#ifndef FLATBUFFERS_PREFER_PRINTF
-// Wraps a string to a maximum length, inserting new lines where necessary. Any
-// existing whitespace will be collapsed down to a single space. A prefix or
-// suffix can be provided, which will be inserted before or after a wrapped
-// line, respectively.
-inline std::string WordWrap(const std::string in, size_t max_length,
-                            const std::string wrapped_line_prefix,
-                            const std::string wrapped_line_suffix) {
-  std::istringstream in_stream(in);
-  std::string wrapped, line, word;
-
-  in_stream >> word;
-  line = word;
-
-  while (in_stream >> word) {
-    if ((line.length() + 1 + word.length() + wrapped_line_suffix.length()) <
-        max_length) {
-      line += " " + word;
-    } else {
-      wrapped += line + wrapped_line_suffix + "\n";
-      line = wrapped_line_prefix + word;
-    }
-  }
-  wrapped += line;
-
-  return wrapped;
-}
-#endif  // !FLATBUFFERS_PREFER_PRINTF
-
-inline bool EscapeString(const char *s, size_t length, std::string *_text,
-                         bool allow_non_utf8, bool natural_utf8) {
-  std::string &text = *_text;
-  text += "\"";
-  for (uoffset_t i = 0; i < length; i++) {
-    char c = s[i];
-    switch (c) {
-      case '\n': text += "\\n"; break;
-      case '\t': text += "\\t"; break;
-      case '\r': text += "\\r"; break;
-      case '\b': text += "\\b"; break;
-      case '\f': text += "\\f"; break;
-      case '\"': text += "\\\""; break;
-      case '\\': text += "\\\\"; break;
-      default:
-        if (c >= ' ' && c <= '~') {
-          text += c;
-        } else {
-          // Not printable ASCII data. Let's see if it's valid UTF-8 first:
-          const char *utf8 = s + i;
-          int ucc = FromUTF8(&utf8);
-          if (ucc < 0) {
-            if (allow_non_utf8) {
-              text += "\\x";
-              text += IntToStringHex(static_cast<uint8_t>(c), 2);
-            } else {
-              // There are two cases here:
-              //
-              // 1) We reached here by parsing an IDL file. In that case,
-              // we previously checked for non-UTF-8, so we shouldn't reach
-              // here.
-              //
-              // 2) We reached here by someone calling GenerateText()
-              // on a previously-serialized flatbuffer. The data might have
-              // non-UTF-8 Strings, or might be corrupt.
-              //
-              // In both cases, we have to give up and inform the caller
-              // they have no JSON.
-              return false;
-            }
-          } else {
-            if (natural_utf8) {
-              // utf8 points to past all utf-8 bytes parsed
-              text.append(s + i, static_cast<size_t>(utf8 - s - i));
-            } else if (ucc <= 0xFFFF) {
-              // Parses as Unicode within JSON's \uXXXX range, so use that.
-              text += "\\u";
-              text += IntToStringHex(ucc, 4);
-            } else if (ucc <= 0x10FFFF) {
-              // Encode Unicode SMP values to a surrogate pair using two \u
-              // escapes.
-              uint32_t base = ucc - 0x10000;
-              auto high_surrogate = (base >> 10) + 0xD800;
-              auto low_surrogate = (base & 0x03FF) + 0xDC00;
-              text += "\\u";
-              text += IntToStringHex(high_surrogate, 4);
-              text += "\\u";
-              text += IntToStringHex(low_surrogate, 4);
-            }
-            // Skip past characters recognized.
-            i = static_cast<uoffset_t>(utf8 - s - 1);
-          }
-        }
-        break;
-    }
-  }
-  text += "\"";
-  return true;
-}
-
-inline std::string BufferToHexText(const void *buffer, size_t buffer_size,
-                                   size_t max_length,
-                                   const std::string &wrapped_line_prefix,
-                                   const std::string &wrapped_line_suffix) {
-  std::string text = wrapped_line_prefix;
-  size_t start_offset = 0;
-  const char *s = reinterpret_cast<const char *>(buffer);
-  for (size_t i = 0; s && i < buffer_size; i++) {
-    // Last iteration or do we have more?
-    bool have_more = i + 1 < buffer_size;
-    text += "0x";
-    text += IntToStringHex(static_cast<uint8_t>(s[i]), 2);
-    if (have_more) { text += ','; }
-    // If we have more to process and we reached max_length
-    if (have_more &&
-        text.size() + wrapped_line_suffix.size() >= start_offset + max_length) {
-      text += wrapped_line_suffix;
-      text += '\n';
-      start_offset = text.size();
-      text += wrapped_line_prefix;
-    }
-  }
-  text += wrapped_line_suffix;
-  return text;
-}
-
-// Remove paired quotes in a string: "text"|'text' -> text.
-std::string RemoveStringQuotes(const std::string &s);
-
-// Change th global C-locale to locale with name <locale_name>.
-// Returns an actual locale name in <_value>, useful if locale_name is "" or
-// null.
-bool SetGlobalTestLocale(const char *locale_name,
-                         std::string *_value = nullptr);
-
-// Read (or test) a value of environment variable.
-bool ReadEnvironmentVariable(const char *var_name,
-                             std::string *_value = nullptr);
-
-// MSVC specific: Send all assert reports to STDOUT to prevent CI hangs.
-void SetupDefaultCRTReportMode();
-
-enum class Case {
-  kUnknown = 0,
-  // TheQuickBrownFox
-  kUpperCamel = 1,
-  // theQuickBrownFox
-  kLowerCamel = 2,
-  // the_quick_brown_fox
-  kSnake = 3,
-  // THE_QUICK_BROWN_FOX
-  kScreamingSnake = 4,
-  // THEQUICKBROWNFOX
-  kAllUpper = 5,
-  // thequickbrownfox
-  kAllLower = 6,
-  // the-quick-brown-fox
-  kDasher = 7,
-  // THEQuiCKBr_ownFox (or whatever you want, we won't change it)
-  kKeep = 8,
-  // the_quick_brown_fox123 (as opposed to the_quick_brown_fox_123)
-  kSnake2 = 9,
-};
-
-// Convert the `input` string of case `input_case` to the specified `output_case`.
-std::string ConvertCase(const std::string &input, Case output_case,
-                    Case input_case = Case::kSnake);
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_UTIL_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/vector.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/vector.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/vector.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/vector.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,373 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_VECTOR_H_
-#define FLATBUFFERS_VECTOR_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/buffer.h"
-#include "flatbuffers/stl_emulation.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-struct String;
-
-// An STL compatible iterator implementation for Vector below, effectively
-// calling Get() for every element.
-template<typename T, typename IT> struct VectorIterator {
-  typedef std::random_access_iterator_tag iterator_category;
-  typedef IT value_type;
-  typedef ptrdiff_t difference_type;
-  typedef IT *pointer;
-  typedef IT &reference;
-
-  VectorIterator(const uint8_t *data, uoffset_t i)
-      : data_(data + IndirectHelper<T>::element_stride * i) {}
-  VectorIterator(const VectorIterator &other) : data_(other.data_) {}
-  VectorIterator() : data_(nullptr) {}
-
-  VectorIterator &operator=(const VectorIterator &other) {
-    data_ = other.data_;
-    return *this;
-  }
-
-  VectorIterator &operator=(VectorIterator &&other) {
-    data_ = other.data_;
-    return *this;
-  }
-
-  bool operator==(const VectorIterator &other) const {
-    return data_ == other.data_;
-  }
-
-  bool operator<(const VectorIterator &other) const {
-    return data_ < other.data_;
-  }
-
-  bool operator!=(const VectorIterator &other) const {
-    return data_ != other.data_;
-  }
-
-  difference_type operator-(const VectorIterator &other) const {
-    return (data_ - other.data_) / IndirectHelper<T>::element_stride;
-  }
-
-  // Note: return type is incompatible with the standard
-  // `reference operator*()`.
-  IT operator*() const { return IndirectHelper<T>::Read(data_, 0); }
-
-  // Note: return type is incompatible with the standard
-  // `pointer operator->()`.
-  IT operator->() const { return IndirectHelper<T>::Read(data_, 0); }
-
-  VectorIterator &operator++() {
-    data_ += IndirectHelper<T>::element_stride;
-    return *this;
-  }
-
-  VectorIterator operator++(int) {
-    VectorIterator temp(data_, 0);
-    data_ += IndirectHelper<T>::element_stride;
-    return temp;
-  }
-
-  VectorIterator operator+(const uoffset_t &offset) const {
-    return VectorIterator(data_ + offset * IndirectHelper<T>::element_stride,
-                          0);
-  }
-
-  VectorIterator &operator+=(const uoffset_t &offset) {
-    data_ += offset * IndirectHelper<T>::element_stride;
-    return *this;
-  }
-
-  VectorIterator &operator--() {
-    data_ -= IndirectHelper<T>::element_stride;
-    return *this;
-  }
-
-  VectorIterator operator--(int) {
-    VectorIterator temp(data_, 0);
-    data_ -= IndirectHelper<T>::element_stride;
-    return temp;
-  }
-
-  VectorIterator operator-(const uoffset_t &offset) const {
-    return VectorIterator(data_ - offset * IndirectHelper<T>::element_stride,
-                          0);
-  }
-
-  VectorIterator &operator-=(const uoffset_t &offset) {
-    data_ -= offset * IndirectHelper<T>::element_stride;
-    return *this;
-  }
-
- private:
-  const uint8_t *data_;
-};
-
-template<typename Iterator>
-struct VectorReverseIterator : public std::reverse_iterator<Iterator> {
-  explicit VectorReverseIterator(Iterator iter)
-      : std::reverse_iterator<Iterator>(iter) {}
-
-  // Note: return type is incompatible with the standard
-  // `reference operator*()`.
-  typename Iterator::value_type operator*() const {
-    auto tmp = std::reverse_iterator<Iterator>::current;
-    return *--tmp;
-  }
-
-  // Note: return type is incompatible with the standard
-  // `pointer operator->()`.
-  typename Iterator::value_type operator->() const {
-    auto tmp = std::reverse_iterator<Iterator>::current;
-    return *--tmp;
-  }
-};
-
-// This is used as a helper type for accessing vectors.
-// Vector::data() assumes the vector elements start after the length field.
-template<typename T> class Vector {
- public:
-  typedef VectorIterator<T, typename IndirectHelper<T>::mutable_return_type>
-      iterator;
-  typedef VectorIterator<T, typename IndirectHelper<T>::return_type>
-      const_iterator;
-  typedef VectorReverseIterator<iterator> reverse_iterator;
-  typedef VectorReverseIterator<const_iterator> const_reverse_iterator;
-
-  typedef typename flatbuffers::bool_constant<flatbuffers::is_scalar<T>::value>
-      scalar_tag;
-
-  static FLATBUFFERS_CONSTEXPR bool is_span_observable =
-      scalar_tag::value && (FLATBUFFERS_LITTLEENDIAN || sizeof(T) == 1);
-
-  uoffset_t size() const { return EndianScalar(length_); }
-
-  // Deprecated: use size(). Here for backwards compatibility.
-  FLATBUFFERS_ATTRIBUTE([[deprecated("use size() instead")]])
-  uoffset_t Length() const { return size(); }
-
-  typedef typename IndirectHelper<T>::return_type return_type;
-  typedef typename IndirectHelper<T>::mutable_return_type mutable_return_type;
-  typedef return_type value_type;
-
-  return_type Get(uoffset_t i) const {
-    FLATBUFFERS_ASSERT(i < size());
-    return IndirectHelper<T>::Read(Data(), i);
-  }
-
-  return_type operator[](uoffset_t i) const { return Get(i); }
-
-  // If this is a Vector of enums, T will be its storage type, not the enum
-  // type. This function makes it convenient to retrieve value with enum
-  // type E.
-  template<typename E> E GetEnum(uoffset_t i) const {
-    return static_cast<E>(Get(i));
-  }
-
-  // If this a vector of unions, this does the cast for you. There's no check
-  // to make sure this is the right type!
-  template<typename U> const U *GetAs(uoffset_t i) const {
-    return reinterpret_cast<const U *>(Get(i));
-  }
-
-  // If this a vector of unions, this does the cast for you. There's no check
-  // to make sure this is actually a string!
-  const String *GetAsString(uoffset_t i) const {
-    return reinterpret_cast<const String *>(Get(i));
-  }
-
-  const void *GetStructFromOffset(size_t o) const {
-    return reinterpret_cast<const void *>(Data() + o);
-  }
-
-  iterator begin() { return iterator(Data(), 0); }
-  const_iterator begin() const { return const_iterator(Data(), 0); }
-
-  iterator end() { return iterator(Data(), size()); }
-  const_iterator end() const { return const_iterator(Data(), size()); }
-
-  reverse_iterator rbegin() { return reverse_iterator(end()); }
-  const_reverse_iterator rbegin() const {
-    return const_reverse_iterator(end());
-  }
-
-  reverse_iterator rend() { return reverse_iterator(begin()); }
-  const_reverse_iterator rend() const {
-    return const_reverse_iterator(begin());
-  }
-
-  const_iterator cbegin() const { return begin(); }
-
-  const_iterator cend() const { return end(); }
-
-  const_reverse_iterator crbegin() const { return rbegin(); }
-
-  const_reverse_iterator crend() const { return rend(); }
-
-  // Change elements if you have a non-const pointer to this object.
-  // Scalars only. See reflection.h, and the documentation.
-  void Mutate(uoffset_t i, const T &val) {
-    FLATBUFFERS_ASSERT(i < size());
-    WriteScalar(data() + i, val);
-  }
-
-  // Change an element of a vector of tables (or strings).
-  // "val" points to the new table/string, as you can obtain from
-  // e.g. reflection::AddFlatBuffer().
-  void MutateOffset(uoffset_t i, const uint8_t *val) {
-    FLATBUFFERS_ASSERT(i < size());
-    static_assert(sizeof(T) == sizeof(uoffset_t), "Unrelated types");
-    WriteScalar(data() + i,
-                static_cast<uoffset_t>(val - (Data() + i * sizeof(uoffset_t))));
-  }
-
-  // Get a mutable pointer to tables/strings inside this vector.
-  mutable_return_type GetMutableObject(uoffset_t i) const {
-    FLATBUFFERS_ASSERT(i < size());
-    return const_cast<mutable_return_type>(IndirectHelper<T>::Read(Data(), i));
-  }
-
-  // The raw data in little endian format. Use with care.
-  const uint8_t *Data() const {
-    return reinterpret_cast<const uint8_t *>(&length_ + 1);
-  }
-
-  uint8_t *Data() { return reinterpret_cast<uint8_t *>(&length_ + 1); }
-
-  // Similarly, but typed, much like std::vector::data
-  const T *data() const { return reinterpret_cast<const T *>(Data()); }
-  T *data() { return reinterpret_cast<T *>(Data()); }
-
-  template<typename K> return_type LookupByKey(K key) const {
-    void *search_result = std::bsearch(
-        &key, Data(), size(), IndirectHelper<T>::element_stride, KeyCompare<K>);
-
-    if (!search_result) {
-      return nullptr;  // Key not found.
-    }
-
-    const uint8_t *element = reinterpret_cast<const uint8_t *>(search_result);
-
-    return IndirectHelper<T>::Read(element, 0);
-  }
-
-  template<typename K> mutable_return_type MutableLookupByKey(K key) {
-    return const_cast<mutable_return_type>(LookupByKey(key));
-  }
-
- protected:
-  // This class is only used to access pre-existing data. Don't ever
-  // try to construct these manually.
-  Vector();
-
-  uoffset_t length_;
-
- private:
-  // This class is a pointer. Copying will therefore create an invalid object.
-  // Private and unimplemented copy constructor.
-  Vector(const Vector &);
-  Vector &operator=(const Vector &);
-
-  template<typename K> static int KeyCompare(const void *ap, const void *bp) {
-    const K *key = reinterpret_cast<const K *>(ap);
-    const uint8_t *data = reinterpret_cast<const uint8_t *>(bp);
-    auto table = IndirectHelper<T>::Read(data, 0);
-
-    // std::bsearch compares with the operands transposed, so we negate the
-    // result here.
-    return -table->KeyCompareWithValue(*key);
-  }
-};
-
-template<class U>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<U> make_span(Vector<U> &vec)
-    FLATBUFFERS_NOEXCEPT {
-  static_assert(Vector<U>::is_span_observable,
-                "wrong type U, only LE-scalar, or byte types are allowed");
-  return span<U>(vec.data(), vec.size());
-}
-
-template<class U>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const U> make_span(
-    const Vector<U> &vec) FLATBUFFERS_NOEXCEPT {
-  static_assert(Vector<U>::is_span_observable,
-                "wrong type U, only LE-scalar, or byte types are allowed");
-  return span<const U>(vec.data(), vec.size());
-}
-
-template<class U>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<uint8_t> make_bytes_span(
-    Vector<U> &vec) FLATBUFFERS_NOEXCEPT {
-  static_assert(Vector<U>::scalar_tag::value,
-                "wrong type U, only LE-scalar, or byte types are allowed");
-  return span<uint8_t>(vec.Data(), vec.size() * sizeof(U));
-}
-
-template<class U>
-FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const uint8_t> make_bytes_span(
-    const Vector<U> &vec) FLATBUFFERS_NOEXCEPT {
-  static_assert(Vector<U>::scalar_tag::value,
-                "wrong type U, only LE-scalar, or byte types are allowed");
-  return span<const uint8_t>(vec.Data(), vec.size() * sizeof(U));
-}
-
-// Represent a vector much like the template above, but in this case we
-// don't know what the element types are (used with reflection.h).
-class VectorOfAny {
- public:
-  uoffset_t size() const { return EndianScalar(length_); }
-
-  const uint8_t *Data() const {
-    return reinterpret_cast<const uint8_t *>(&length_ + 1);
-  }
-  uint8_t *Data() { return reinterpret_cast<uint8_t *>(&length_ + 1); }
-
- protected:
-  VectorOfAny();
-
-  uoffset_t length_;
-
- private:
-  VectorOfAny(const VectorOfAny &);
-  VectorOfAny &operator=(const VectorOfAny &);
-};
-
-template<typename T, typename U>
-Vector<Offset<T>> *VectorCast(Vector<Offset<U>> *ptr) {
-  static_assert(std::is_base_of<T, U>::value, "Unrelated types");
-  return reinterpret_cast<Vector<Offset<T>> *>(ptr);
-}
-
-template<typename T, typename U>
-const Vector<Offset<T>> *VectorCast(const Vector<Offset<U>> *ptr) {
-  static_assert(std::is_base_of<T, U>::value, "Unrelated types");
-  return reinterpret_cast<const Vector<Offset<T>> *>(ptr);
-}
-
-// Convenient helper function to get the length of any vector, regardless
-// of whether it is null or not (the field is not set).
-template<typename T> static inline size_t VectorLength(const Vector<T> *v) {
-  return v ? v->size() : 0;
-}
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_VERIFIER_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/vector_downward.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/vector_downward.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/vector_downward.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/vector_downward.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,273 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_VECTOR_DOWNWARD_H_
-#define FLATBUFFERS_VECTOR_DOWNWARD_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/default_allocator.h"
-#include "flatbuffers/detached_buffer.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// This is a minimal replication of std::vector<uint8_t> functionality,
-// except growing from higher to lower addresses. i.e push_back() inserts data
-// in the lowest address in the vector.
-// Since this vector leaves the lower part unused, we support a "scratch-pad"
-// that can be stored there for temporary data, to share the allocated space.
-// Essentially, this supports 2 std::vectors in a single buffer.
-class vector_downward {
- public:
-  explicit vector_downward(size_t initial_size, Allocator *allocator,
-                           bool own_allocator, size_t buffer_minalign)
-      : allocator_(allocator),
-        own_allocator_(own_allocator),
-        initial_size_(initial_size),
-        buffer_minalign_(buffer_minalign),
-        reserved_(0),
-        size_(0),
-        buf_(nullptr),
-        cur_(nullptr),
-        scratch_(nullptr) {}
-
-  vector_downward(vector_downward &&other)
-      // clang-format on
-      : allocator_(other.allocator_),
-        own_allocator_(other.own_allocator_),
-        initial_size_(other.initial_size_),
-        buffer_minalign_(other.buffer_minalign_),
-        reserved_(other.reserved_),
-        size_(other.size_),
-        buf_(other.buf_),
-        cur_(other.cur_),
-        scratch_(other.scratch_) {
-    // No change in other.allocator_
-    // No change in other.initial_size_
-    // No change in other.buffer_minalign_
-    other.own_allocator_ = false;
-    other.reserved_ = 0;
-    other.buf_ = nullptr;
-    other.cur_ = nullptr;
-    other.scratch_ = nullptr;
-  }
-
-  vector_downward &operator=(vector_downward &&other) {
-    // Move construct a temporary and swap idiom
-    vector_downward temp(std::move(other));
-    swap(temp);
-    return *this;
-  }
-
-  ~vector_downward() {
-    clear_buffer();
-    clear_allocator();
-  }
-
-  void reset() {
-    clear_buffer();
-    clear();
-  }
-
-  void clear() {
-    if (buf_) {
-      cur_ = buf_ + reserved_;
-    } else {
-      reserved_ = 0;
-      cur_ = nullptr;
-    }
-    size_ = 0;
-    clear_scratch();
-  }
-
-  void clear_scratch() { scratch_ = buf_; }
-
-  void clear_allocator() {
-    if (own_allocator_ && allocator_) { delete allocator_; }
-    allocator_ = nullptr;
-    own_allocator_ = false;
-  }
-
-  void clear_buffer() {
-    if (buf_) Deallocate(allocator_, buf_, reserved_);
-    buf_ = nullptr;
-  }
-
-  // Relinquish the pointer to the caller.
-  uint8_t *release_raw(size_t &allocated_bytes, size_t &offset) {
-    auto *buf = buf_;
-    allocated_bytes = reserved_;
-    offset = static_cast<size_t>(cur_ - buf_);
-
-    // release_raw only relinquishes the buffer ownership.
-    // Does not deallocate or reset the allocator. Destructor will do that.
-    buf_ = nullptr;
-    clear();
-    return buf;
-  }
-
-  // Relinquish the pointer to the caller.
-  DetachedBuffer release() {
-    // allocator ownership (if any) is transferred to DetachedBuffer.
-    DetachedBuffer fb(allocator_, own_allocator_, buf_, reserved_, cur_,
-                      size());
-    if (own_allocator_) {
-      allocator_ = nullptr;
-      own_allocator_ = false;
-    }
-    buf_ = nullptr;
-    clear();
-    return fb;
-  }
-
-  size_t ensure_space(size_t len) {
-    FLATBUFFERS_ASSERT(cur_ >= scratch_ && scratch_ >= buf_);
-    if (len > static_cast<size_t>(cur_ - scratch_)) { reallocate(len); }
-    // Beyond this, signed offsets may not have enough range:
-    // (FlatBuffers > 2GB not supported).
-    FLATBUFFERS_ASSERT(size() < FLATBUFFERS_MAX_BUFFER_SIZE);
-    return len;
-  }
-
-  inline uint8_t *make_space(size_t len) {
-    if (len) {
-      ensure_space(len);
-      cur_ -= len;
-      size_ += static_cast<uoffset_t>(len);
-    }
-    return cur_;
-  }
-
-  // Returns nullptr if using the DefaultAllocator.
-  Allocator *get_custom_allocator() { return allocator_; }
-
-  inline uoffset_t size() const { return size_; }
-
-  uoffset_t scratch_size() const {
-    return static_cast<uoffset_t>(scratch_ - buf_);
-  }
-
-  size_t capacity() const { return reserved_; }
-
-  uint8_t *data() const {
-    FLATBUFFERS_ASSERT(cur_);
-    return cur_;
-  }
-
-  uint8_t *scratch_data() const {
-    FLATBUFFERS_ASSERT(buf_);
-    return buf_;
-  }
-
-  uint8_t *scratch_end() const {
-    FLATBUFFERS_ASSERT(scratch_);
-    return scratch_;
-  }
-
-  uint8_t *data_at(size_t offset) const { return buf_ + reserved_ - offset; }
-
-  void push(const uint8_t *bytes, size_t num) {
-    if (num > 0) { memcpy(make_space(num), bytes, num); }
-  }
-
-  // Specialized version of push() that avoids memcpy call for small data.
-  template<typename T> void push_small(const T &little_endian_t) {
-    make_space(sizeof(T));
-    *reinterpret_cast<T *>(cur_) = little_endian_t;
-  }
-
-  template<typename T> void scratch_push_small(const T &t) {
-    ensure_space(sizeof(T));
-    *reinterpret_cast<T *>(scratch_) = t;
-    scratch_ += sizeof(T);
-  }
-
-  // fill() is most frequently called with small byte counts (<= 4),
-  // which is why we're using loops rather than calling memset.
-  void fill(size_t zero_pad_bytes) {
-    make_space(zero_pad_bytes);
-    for (size_t i = 0; i < zero_pad_bytes; i++) cur_[i] = 0;
-  }
-
-  // Version for when we know the size is larger.
-  // Precondition: zero_pad_bytes > 0
-  void fill_big(size_t zero_pad_bytes) {
-    memset(make_space(zero_pad_bytes), 0, zero_pad_bytes);
-  }
-
-  void pop(size_t bytes_to_remove) {
-    cur_ += bytes_to_remove;
-    size_ -= static_cast<uoffset_t>(bytes_to_remove);
-  }
-
-  void scratch_pop(size_t bytes_to_remove) { scratch_ -= bytes_to_remove; }
-
-  void swap(vector_downward &other) {
-    using std::swap;
-    swap(allocator_, other.allocator_);
-    swap(own_allocator_, other.own_allocator_);
-    swap(initial_size_, other.initial_size_);
-    swap(buffer_minalign_, other.buffer_minalign_);
-    swap(reserved_, other.reserved_);
-    swap(size_, other.size_);
-    swap(buf_, other.buf_);
-    swap(cur_, other.cur_);
-    swap(scratch_, other.scratch_);
-  }
-
-  void swap_allocator(vector_downward &other) {
-    using std::swap;
-    swap(allocator_, other.allocator_);
-    swap(own_allocator_, other.own_allocator_);
-  }
-
- private:
-  // You shouldn't really be copying instances of this class.
-  FLATBUFFERS_DELETE_FUNC(vector_downward(const vector_downward &));
-  FLATBUFFERS_DELETE_FUNC(vector_downward &operator=(const vector_downward &));
-
-  Allocator *allocator_;
-  bool own_allocator_;
-  size_t initial_size_;
-  size_t buffer_minalign_;
-  size_t reserved_;
-  uoffset_t size_;
-  uint8_t *buf_;
-  uint8_t *cur_;  // Points at location between empty (below) and used (above).
-  uint8_t *scratch_;  // Points to the end of the scratchpad in use.
-
-  void reallocate(size_t len) {
-    auto old_reserved = reserved_;
-    auto old_size = size();
-    auto old_scratch_size = scratch_size();
-    reserved_ +=
-        (std::max)(len, old_reserved ? old_reserved / 2 : initial_size_);
-    reserved_ = (reserved_ + buffer_minalign_ - 1) & ~(buffer_minalign_ - 1);
-    if (buf_) {
-      buf_ = ReallocateDownward(allocator_, buf_, old_reserved, reserved_,
-                                old_size, old_scratch_size);
-    } else {
-      buf_ = Allocate(allocator_, reserved_);
-    }
-    cur_ = buf_ + reserved_ - old_size;
-    scratch_ = buf_ + old_scratch_size;
-  }
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_VECTOR_DOWNWARD_H_
diff -pruN 8.0.1-5/flatgeobuf/include/flatbuffers/verifier.h 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/verifier.h
--- 8.0.1-5/flatgeobuf/include/flatbuffers/verifier.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/include/flatbuffers/verifier.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,284 +0,0 @@
-/*
- * Copyright 2021 Google Inc. All rights reserved.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#ifndef FLATBUFFERS_VERIFIER_H_
-#define FLATBUFFERS_VERIFIER_H_
-
-#include "flatbuffers/base.h"
-#include "flatbuffers/vector.h"
-
-namespace mapserver {
-namespace flatbuffers {
-
-// Helper class to verify the integrity of a FlatBuffer
-class Verifier FLATBUFFERS_FINAL_CLASS {
- public:
-  Verifier(const uint8_t *buf, size_t buf_len, uoffset_t _max_depth = 64,
-           uoffset_t _max_tables = 1000000, bool _check_alignment = true)
-      : buf_(buf),
-        size_(buf_len),
-        depth_(0),
-        max_depth_(_max_depth),
-        num_tables_(0),
-        max_tables_(_max_tables),
-        upper_bound_(0),
-        check_alignment_(_check_alignment),
-        flex_reuse_tracker_(nullptr) {
-    FLATBUFFERS_ASSERT(size_ < FLATBUFFERS_MAX_BUFFER_SIZE);
-  }
-
-  // Central location where any verification failures register.
-  bool Check(bool ok) const {
-    // clang-format off
-    #ifdef FLATBUFFERS_DEBUG_VERIFICATION_FAILURE
-      FLATBUFFERS_ASSERT(ok);
-    #endif
-    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
-      if (!ok)
-        upper_bound_ = 0;
-    #endif
-    // clang-format on
-    return ok;
-  }
-
-  // Verify any range within the buffer.
-  bool Verify(size_t elem, size_t elem_len) const {
-    // clang-format off
-    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
-      auto upper_bound = elem + elem_len;
-      if (upper_bound_ < upper_bound)
-        upper_bound_ =  upper_bound;
-    #endif
-    // clang-format on
-    return Check(elem_len < size_ && elem <= size_ - elem_len);
-  }
-
-  bool VerifyAlignment(size_t elem, size_t align) const {
-    return Check((elem & (align - 1)) == 0 || !check_alignment_);
-  }
-
-  // Verify a range indicated by sizeof(T).
-  template<typename T> bool Verify(size_t elem) const {
-    return VerifyAlignment(elem, sizeof(T)) && Verify(elem, sizeof(T));
-  }
-
-  bool VerifyFromPointer(const uint8_t *p, size_t len) {
-    auto o = static_cast<size_t>(p - buf_);
-    return Verify(o, len);
-  }
-
-  // Verify relative to a known-good base pointer.
-  bool VerifyFieldStruct(const uint8_t *base, voffset_t elem_off,
-                         size_t elem_len, size_t align) const {
-    auto f = static_cast<size_t>(base - buf_) + elem_off;
-    return VerifyAlignment(f, align) && Verify(f, elem_len);
-  }
-
-  template<typename T>
-  bool VerifyField(const uint8_t *base, voffset_t elem_off,
-                   size_t align) const {
-    auto f = static_cast<size_t>(base - buf_) + elem_off;
-    return VerifyAlignment(f, align) && Verify(f, sizeof(T));
-  }
-
-  // Verify a pointer (may be NULL) of a table type.
-  template<typename T> bool VerifyTable(const T *table) {
-    return !table || table->Verify(*this);
-  }
-
-  // Verify a pointer (may be NULL) of any vector type.
-  template<typename T> bool VerifyVector(const Vector<T> *vec) const {
-    return !vec || VerifyVectorOrString(reinterpret_cast<const uint8_t *>(vec),
-                                        sizeof(T));
-  }
-
-  // Verify a pointer (may be NULL) of a vector to struct.
-  template<typename T> bool VerifyVector(const Vector<const T *> *vec) const {
-    return VerifyVector(reinterpret_cast<const Vector<T> *>(vec));
-  }
-
-  // Verify a pointer (may be NULL) to string.
-  bool VerifyString(const String *str) const {
-    size_t end;
-    return !str || (VerifyVectorOrString(reinterpret_cast<const uint8_t *>(str),
-                                         1, &end) &&
-                    Verify(end, 1) &&           // Must have terminator
-                    Check(buf_[end] == '\0'));  // Terminating byte must be 0.
-  }
-
-  // Common code between vectors and strings.
-  bool VerifyVectorOrString(const uint8_t *vec, size_t elem_size,
-                            size_t *end = nullptr) const {
-    auto veco = static_cast<size_t>(vec - buf_);
-    // Check we can read the size field.
-    if (!Verify<uoffset_t>(veco)) return false;
-    // Check the whole array. If this is a string, the byte past the array
-    // must be 0.
-    auto size = ReadScalar<uoffset_t>(vec);
-    auto max_elems = FLATBUFFERS_MAX_BUFFER_SIZE / elem_size;
-    if (!Check(size < max_elems))
-      return false;  // Protect against byte_size overflowing.
-    auto byte_size = sizeof(size) + elem_size * size;
-    if (end) *end = veco + byte_size;
-    return Verify(veco, byte_size);
-  }
-
-  // Special case for string contents, after the above has been called.
-  bool VerifyVectorOfStrings(const Vector<Offset<String>> *vec) const {
-    if (vec) {
-      for (uoffset_t i = 0; i < vec->size(); i++) {
-        if (!VerifyString(vec->Get(i))) return false;
-      }
-    }
-    return true;
-  }
-
-  // Special case for table contents, after the above has been called.
-  template<typename T> bool VerifyVectorOfTables(const Vector<Offset<T>> *vec) {
-    if (vec) {
-      for (uoffset_t i = 0; i < vec->size(); i++) {
-        if (!vec->Get(i)->Verify(*this)) return false;
-      }
-    }
-    return true;
-  }
-
-  __supress_ubsan__("unsigned-integer-overflow") bool VerifyTableStart(
-      const uint8_t *table) {
-    // Check the vtable offset.
-    auto tableo = static_cast<size_t>(table - buf_);
-    if (!Verify<soffset_t>(tableo)) return false;
-    // This offset may be signed, but doing the subtraction unsigned always
-    // gives the result we want.
-    auto vtableo = tableo - static_cast<size_t>(ReadScalar<soffset_t>(table));
-    // Check the vtable size field, then check vtable fits in its entirety.
-    return VerifyComplexity() && Verify<voffset_t>(vtableo) &&
-           VerifyAlignment(ReadScalar<voffset_t>(buf_ + vtableo),
-                           sizeof(voffset_t)) &&
-           Verify(vtableo, ReadScalar<voffset_t>(buf_ + vtableo));
-  }
-
-  template<typename T>
-  bool VerifyBufferFromStart(const char *identifier, size_t start) {
-    if (identifier && !Check((size_ >= 2 * sizeof(flatbuffers::uoffset_t) &&
-                              BufferHasIdentifier(buf_ + start, identifier)))) {
-      return false;
-    }
-
-    // Call T::Verify, which must be in the generated code for this type.
-    auto o = VerifyOffset(start);
-    return o && reinterpret_cast<const T *>(buf_ + start + o)->Verify(*this)
-    // clang-format off
-    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
-           && GetComputedSize()
-    #endif
-        ;
-    // clang-format on
-  }
-
-  template<typename T>
-  bool VerifyNestedFlatBuffer(const Vector<uint8_t> *buf,
-                              const char *identifier) {
-    if (!buf) return true;
-    Verifier nested_verifier(buf->data(), buf->size());
-    return nested_verifier.VerifyBuffer<T>(identifier);
-  }
-
-  // Verify this whole buffer, starting with root type T.
-  template<typename T> bool VerifyBuffer() { return VerifyBuffer<T>(nullptr); }
-
-  template<typename T> bool VerifyBuffer(const char *identifier) {
-    return VerifyBufferFromStart<T>(identifier, 0);
-  }
-
-  template<typename T> bool VerifySizePrefixedBuffer(const char *identifier) {
-    return Verify<uoffset_t>(0U) &&
-           ReadScalar<uoffset_t>(buf_) == size_ - sizeof(uoffset_t) &&
-           VerifyBufferFromStart<T>(identifier, sizeof(uoffset_t));
-  }
-
-  uoffset_t VerifyOffset(size_t start) const {
-    if (!Verify<uoffset_t>(start)) return 0;
-    auto o = ReadScalar<uoffset_t>(buf_ + start);
-    // May not point to itself.
-    if (!Check(o != 0)) return 0;
-    // Can't wrap around / buffers are max 2GB.
-    if (!Check(static_cast<soffset_t>(o) >= 0)) return 0;
-    // Must be inside the buffer to create a pointer from it (pointer outside
-    // buffer is UB).
-    if (!Verify(start + o, 1)) return 0;
-    return o;
-  }
-
-  uoffset_t VerifyOffset(const uint8_t *base, voffset_t start) const {
-    return VerifyOffset(static_cast<size_t>(base - buf_) + start);
-  }
-
-  // Called at the start of a table to increase counters measuring data
-  // structure depth and amount, and possibly bails out with false if
-  // limits set by the constructor have been hit. Needs to be balanced
-  // with EndTable().
-  bool VerifyComplexity() {
-    depth_++;
-    num_tables_++;
-    return Check(depth_ <= max_depth_ && num_tables_ <= max_tables_);
-  }
-
-  // Called at the end of a table to pop the depth count.
-  bool EndTable() {
-    depth_--;
-    return true;
-  }
-
-  // Returns the message size in bytes
-  size_t GetComputedSize() const {
-    // clang-format off
-    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
-      uintptr_t size = upper_bound_;
-      // Align the size to uoffset_t
-      size = (size - 1 + sizeof(uoffset_t)) & ~(sizeof(uoffset_t) - 1);
-      return (size > size_) ?  0 : size;
-    #else
-      // Must turn on FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE for this to work.
-      (void)upper_bound_;
-      FLATBUFFERS_ASSERT(false);
-      return 0;
-    #endif
-    // clang-format on
-  }
-
-  std::vector<uint8_t> *GetFlexReuseTracker() { return flex_reuse_tracker_; }
-
-  void SetFlexReuseTracker(std::vector<uint8_t> *rt) {
-    flex_reuse_tracker_ = rt;
-  }
-
- private:
-  const uint8_t *buf_;
-  size_t size_;
-  uoffset_t depth_;
-  uoffset_t max_depth_;
-  uoffset_t num_tables_;
-  uoffset_t max_tables_;
-  mutable size_t upper_bound_;
-  bool check_alignment_;
-  std::vector<uint8_t> *flex_reuse_tracker_;
-};
-
-}  // namespace flatbuffers
-}  // namespace mapserver
-
-#endif  // FLATBUFFERS_VERIFIER_H_
diff -pruN 8.0.1-5/flatgeobuf/packedrtree.cpp 8.2.0~beta1-1~exp1/flatgeobuf/packedrtree.cpp
--- 8.0.1-5/flatgeobuf/packedrtree.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/packedrtree.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,413 +0,0 @@
-/******************************************************************************
- *
- * Project:  FlatGeobuf
- * Purpose:  Packed RTree management
- * Author:   Björn Harrtell <bjorn at wololo dot org>
- *
- ******************************************************************************
- * Copyright (c) 2018-2020, Björn Harrtell <bjorn at wololo dot org>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included
- * in all copies or substantial portions of the Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-// NOTE: The upstream of this file is in https://github.com/bjornharrtell/flatgeobuf/tree/master/src/cpp
-
-#ifdef GDAL_COMPILATION
-#include "cpl_port.h"
-#else
-#define CPL_IS_LSB 1
-#endif
-
-#include "packedrtree.h"
-
-#include <map>
-#include <unordered_map>
-#include <iostream>
-
-namespace mapserver
-{
-namespace FlatGeobuf
-{
-
-const NodeItem &NodeItem::expand(const NodeItem &r)
-{
-    if (r.minX < minX) minX = r.minX;
-    if (r.minY < minY) minY = r.minY;
-    if (r.maxX > maxX) maxX = r.maxX;
-    if (r.maxY > maxY) maxY = r.maxY;
-    return *this;
-}
-
-NodeItem NodeItem::create(uint64_t offset)
-{
-    return {
-        std::numeric_limits<double>::infinity(),
-        std::numeric_limits<double>::infinity(),
-        -1 * std::numeric_limits<double>::infinity(),
-        -1 * std::numeric_limits<double>::infinity(),
-        offset
-    };
-}
-
-bool NodeItem::intersects(const NodeItem &r) const
-{
-    if (maxX < r.minX) return false;
-    if (maxY < r.minY) return false;
-    if (minX > r.maxX) return false;
-    if (minY > r.maxY) return false;
-    return true;
-}
-
-std::vector<double> NodeItem::toVector()
-{
-    return std::vector<double> { minX, minY, maxX, maxY };
-}
-
-// Based on public domain code at https://github.com/rawrunprotected/hilbert_curves
-uint32_t hilbert(uint32_t x, uint32_t y)
-{
-    uint32_t a = x ^ y;
-    uint32_t b = 0xFFFF ^ a;
-    uint32_t c = 0xFFFF ^ (x | y);
-    uint32_t d = x & (y ^ 0xFFFF);
-
-    uint32_t A = a | (b >> 1);
-    uint32_t B = (a >> 1) ^ a;
-    uint32_t C = ((c >> 1) ^ (b & (d >> 1))) ^ c;
-    uint32_t D = ((a & (c >> 1)) ^ (d >> 1)) ^ d;
-
-    a = A; b = B; c = C; d = D;
-    A = ((a & (a >> 2)) ^ (b & (b >> 2)));
-    B = ((a & (b >> 2)) ^ (b & ((a ^ b) >> 2)));
-    C ^= ((a & (c >> 2)) ^ (b & (d >> 2)));
-    D ^= ((b & (c >> 2)) ^ ((a ^ b) & (d >> 2)));
-
-    a = A; b = B; c = C; d = D;
-    A = ((a & (a >> 4)) ^ (b & (b >> 4)));
-    B = ((a & (b >> 4)) ^ (b & ((a ^ b) >> 4)));
-    C ^= ((a & (c >> 4)) ^ (b & (d >> 4)));
-    D ^= ((b & (c >> 4)) ^ ((a ^ b) & (d >> 4)));
-
-    a = A; b = B; c = C; d = D;
-    C ^= ((a & (c >> 8)) ^ (b & (d >> 8)));
-    D ^= ((b & (c >> 8)) ^ ((a ^ b) & (d >> 8)));
-
-    a = C ^ (C >> 1);
-    b = D ^ (D >> 1);
-
-    uint32_t i0 = x ^ y;
-    uint32_t i1 = b | (0xFFFF ^ (i0 | a));
-
-    i0 = (i0 | (i0 << 8)) & 0x00FF00FF;
-    i0 = (i0 | (i0 << 4)) & 0x0F0F0F0F;
-    i0 = (i0 | (i0 << 2)) & 0x33333333;
-    i0 = (i0 | (i0 << 1)) & 0x55555555;
-
-    i1 = (i1 | (i1 << 8)) & 0x00FF00FF;
-    i1 = (i1 | (i1 << 4)) & 0x0F0F0F0F;
-    i1 = (i1 | (i1 << 2)) & 0x33333333;
-    i1 = (i1 | (i1 << 1)) & 0x55555555;
-
-    uint32_t value = ((i1 << 1) | i0);
-
-    return value;
-}
-
-uint32_t hilbert(const NodeItem &r, uint32_t hilbertMax, const double minX, const double minY, const double width, const double height)
-{
-    uint32_t x = 0;
-    uint32_t y = 0;
-    uint32_t v;
-    if (width != 0.0)
-        x = static_cast<uint32_t>(floor(hilbertMax * ((r.minX + r.maxX) / 2 - minX) / width));
-    if (height != 0.0)
-        y = static_cast<uint32_t>(floor(hilbertMax * ((r.minY + r.maxY) / 2 - minY) / height));
-    v = hilbert(x, y);
-    return v;
-}
-
-const uint32_t hilbertMax = (1 << 16) - 1;
-
-void hilbertSort(std::vector<std::shared_ptr<Item>> &items)
-{
-    NodeItem extent = calcExtent(items);
-    const double minX = extent.minX;
-    const double minY = extent.minY;
-    const double width = extent.width();
-    const double height = extent.height();
-    std::sort(items.begin(), items.end(), [minX, minY, width, height] (std::shared_ptr<Item> a, std::shared_ptr<Item> b) {
-        uint32_t ha = hilbert(a->nodeItem, hilbertMax, minX, minY, width, height);
-        uint32_t hb = hilbert(b->nodeItem, hilbertMax, minX, minY, width, height);
-        return ha > hb;
-    });
-}
-
-void hilbertSort(std::vector<NodeItem> &items)
-{
-    NodeItem extent = calcExtent(items);
-    const double minX = extent.minX;
-    const double minY = extent.minY;
-    const double width = extent.width();
-    const double height = extent.height();
-    std::sort(items.begin(), items.end(), [minX, minY, width, height] (const NodeItem &a, const NodeItem &b) {
-        uint32_t ha = hilbert(a, hilbertMax, minX, minY, width, height);
-        uint32_t hb = hilbert(b, hilbertMax, minX, minY, width, height);
-        return ha > hb;
-    });
-}
-
-NodeItem calcExtent(const std::vector<std::shared_ptr<Item>> &items)
-{
-    return std::accumulate(items.begin(), items.end(), NodeItem::create(0), [] (NodeItem a, const std::shared_ptr<Item>& b) {
-        return a.expand(b->nodeItem);
-    });
-}
-
-NodeItem calcExtent(const std::vector<NodeItem> &nodes)
-{
-    return std::accumulate(nodes.begin(), nodes.end(), NodeItem::create(0), [] (NodeItem a, const NodeItem &b) {
-        return a.expand(b);
-    });
-}
-
-void PackedRTree::init(const uint16_t nodeSize)
-{
-    if (nodeSize < 2)
-        throw std::invalid_argument("Node size must be at least 2");
-    if (_numItems == 0)
-        throw std::invalid_argument("Cannot create empty tree");
-    _nodeSize = std::min(std::max(nodeSize, static_cast<uint16_t>(2)), static_cast<uint16_t>(65535));
-    _levelBounds = generateLevelBounds(_numItems, _nodeSize);
-    _numNodes = _levelBounds.front().second;
-    _nodeItems = new NodeItem[static_cast<size_t>(_numNodes)];
-}
-
-std::vector<std::pair<uint64_t, uint64_t>> PackedRTree::generateLevelBounds(const uint64_t numItems, const uint16_t nodeSize) {
-    if (nodeSize < 2)
-        throw std::invalid_argument("Node size must be at least 2");
-    if (numItems == 0)
-        throw std::invalid_argument("Number of items must be greater than 0");
-    if (numItems > std::numeric_limits<uint64_t>::max() - ((numItems / nodeSize) * 2))
-        throw std::overflow_error("Number of items too large");
-
-    // number of nodes per level in bottom-up order
-    std::vector<uint64_t> levelNumNodes;
-    uint64_t n = numItems;
-    uint64_t numNodes = n;
-    levelNumNodes.push_back(n);
-    do {
-        n = (n + nodeSize - 1) / nodeSize;
-        numNodes += n;
-        levelNumNodes.push_back(n);
-    } while (n != 1);
-
-    // bounds per level in reversed storage order (top-down)
-    std::vector<uint64_t> levelOffsets;
-    n = numNodes;
-    for (auto size : levelNumNodes)
-        levelOffsets.push_back(n -= size);
-    std::reverse(levelOffsets.begin(), levelOffsets.end());
-    std::reverse(levelNumNodes.begin(), levelNumNodes.end());
-    std::vector<std::pair<uint64_t, uint64_t>> levelBounds;
-    for (size_t i = 0; i < levelNumNodes.size(); i++)
-        levelBounds.push_back(std::pair<uint64_t, uint64_t>(levelOffsets[i], levelOffsets[i] + levelNumNodes[i]));
-    std::reverse(levelBounds.begin(), levelBounds.end());
-    return levelBounds;
-}
-
-void PackedRTree::generateNodes()
-{
-    for (uint32_t i = 0; i < _levelBounds.size() - 1; i++) {
-        auto pos = _levelBounds[i].first;
-        auto end = _levelBounds[i].second;
-        auto newpos = _levelBounds[i + 1].first;
-        while (pos < end) {
-            NodeItem node = NodeItem::create(pos);
-            for (uint32_t j = 0; j < _nodeSize && pos < end; j++)
-                node.expand(_nodeItems[pos++]);
-            _nodeItems[newpos++] = node;
-        }
-    }
-}
-
-void PackedRTree::fromData(const void *data)
-{
-    auto buf = reinterpret_cast<const uint8_t *>(data);
-    const NodeItem *pn = reinterpret_cast<const NodeItem *>(buf);
-    for (uint64_t i = 0; i < _numNodes; i++) {
-        NodeItem n = *pn++;
-        _nodeItems[i] = n;
-        _extent.expand(n);
-    }
-}
-
-PackedRTree::PackedRTree(const std::vector<std::shared_ptr<Item>> &items, const NodeItem &extent, const uint16_t nodeSize) :
-    _extent(extent),
-    _numItems(items.size())
-{
-    init(nodeSize);
-    for (size_t i = 0; i < _numItems; i++)
-        _nodeItems[_numNodes - _numItems + i] = items[i]->nodeItem;
-    generateNodes();
-}
-
-PackedRTree::PackedRTree(const std::vector<NodeItem> &nodes, const NodeItem &extent, const uint16_t nodeSize) :
-    _extent(extent),
-    _numItems(nodes.size())
-{
-    init(nodeSize);
-    for (size_t i = 0; i < _numItems; i++)
-        _nodeItems[_numNodes - _numItems + i] = nodes[i];
-    generateNodes();
-}
-
-PackedRTree::PackedRTree(const void *data, const uint64_t numItems, const uint16_t nodeSize) :
-    _extent(NodeItem::create(0)),
-    _numItems(numItems)
-{
-    init(nodeSize);
-    fromData(data);
-}
-
-std::vector<SearchResultItem> PackedRTree::search(double minX, double minY, double maxX, double maxY) const
-{
-    uint64_t leafNodesOffset = _levelBounds.front().first;
-    NodeItem n { minX, minY, maxX, maxY, 0 };
-    std::vector<SearchResultItem> results;
-    std::unordered_map<uint64_t, uint64_t> queue;
-    queue.insert(std::pair<uint64_t, uint64_t>(0, _levelBounds.size() - 1));
-    while(queue.size() != 0) {
-        auto next = queue.begin();
-        uint64_t nodeIndex = next->first;
-        uint64_t level = next->second;
-        queue.erase(next);
-        bool isLeafNode = nodeIndex >= _numNodes - _numItems;
-        // find the end index of the node
-        uint64_t end = std::min(static_cast<uint64_t>(nodeIndex + _nodeSize), _levelBounds[static_cast<size_t>(level)].second);
-        // search through child nodes
-        for (uint64_t pos = nodeIndex; pos < end; pos++) {
-            auto nodeItem = _nodeItems[static_cast<size_t>(pos)];
-            if (!n.intersects(nodeItem))
-                continue;
-            if (isLeafNode)
-                results.push_back({ nodeItem.offset, pos - leafNodesOffset });
-            else
-                queue.insert(std::pair<uint64_t, uint64_t>(nodeItem.offset, level - 1));
-        }
-    }
-    return results;
-}
-
-std::vector<SearchResultItem> PackedRTree::streamSearch(
-    const uint64_t numItems, const uint16_t nodeSize, const NodeItem &item,
-    const std::function<void(uint8_t *, size_t, size_t)> &readNode)
-{
-    auto levelBounds = generateLevelBounds(numItems, nodeSize);
-    uint64_t leafNodesOffset = levelBounds.front().first;
-    uint64_t numNodes = levelBounds.front().second;
-    auto nodeItems = std::vector<NodeItem>(nodeSize);
-    uint8_t *nodesBuf = reinterpret_cast<uint8_t *>(nodeItems.data());
-    // use ordered search queue to make index traversal in sequential order
-    std::map<uint64_t, uint64_t> queue;
-    std::vector<SearchResultItem> results;
-    queue.insert(std::pair<uint64_t, uint64_t>(0, levelBounds.size() - 1));
-    while(queue.size() != 0) {
-        auto next = queue.begin();
-        uint64_t nodeIndex = next->first;
-        uint64_t level = next->second;
-        queue.erase(next);
-        bool isLeafNode = nodeIndex >= numNodes - numItems;
-        // find the end index of the node
-        uint64_t end = std::min(static_cast<uint64_t>(nodeIndex + nodeSize), levelBounds[static_cast<size_t>(level)].second);
-        uint64_t length = end - nodeIndex;
-        readNode(nodesBuf, static_cast<size_t>(nodeIndex * sizeof(NodeItem)), static_cast<size_t>(length * sizeof(NodeItem)));
-#if !CPL_IS_LSB
-        for( size_t i = 0; i < static_cast<size_t>(length); i++ )
-        {
-            CPL_LSBPTR64(&nodeItems[i].minX);
-            CPL_LSBPTR64(&nodeItems[i].minY);
-            CPL_LSBPTR64(&nodeItems[i].maxX);
-            CPL_LSBPTR64(&nodeItems[i].maxY);
-            CPL_LSBPTR64(&nodeItems[i].offset);
-        }
-#endif
-        // search through child nodes
-        for (uint64_t pos = nodeIndex; pos < end; pos++) {
-            uint64_t nodePos = pos - nodeIndex;
-            auto nodeItem = nodeItems[static_cast<size_t>(nodePos)];
-            if (!item.intersects(nodeItem))
-                continue;
-            if (isLeafNode)
-                results.push_back({ nodeItem.offset, pos - leafNodesOffset });
-            else
-                queue.insert(std::pair<uint64_t, uint64_t>(nodeItem.offset, level - 1));
-        }
-    }
-    return results;
-}
-
-uint64_t PackedRTree::size() const { return _numNodes * sizeof(NodeItem); }
-
-uint64_t PackedRTree::size(const uint64_t numItems, const uint16_t nodeSize)
-{
-    if (nodeSize < 2)
-        throw std::invalid_argument("Node size must be at least 2");
-    if (numItems == 0)
-        throw std::invalid_argument("Number of items must be greater than 0");
-    const uint16_t nodeSizeMin = std::min(std::max(nodeSize, static_cast<uint16_t>(2)), static_cast<uint16_t>(65535));
-    // limit so that resulting size in bytes can be represented by uint64_t
-    if (numItems > static_cast<uint64_t>(1) << 56)
-        throw std::overflow_error("Number of items must be less than 2^56");
-    uint64_t n = numItems;
-    uint64_t numNodes = n;
-    do {
-        n = (n + nodeSizeMin - 1) / nodeSizeMin;
-        numNodes += n;
-    } while (n != 1);
-    return numNodes * sizeof(NodeItem);
-}
-
-void PackedRTree::streamWrite(const std::function<void(uint8_t *, size_t)> &writeData) {
-#if !CPL_IS_LSB
-    for( size_t i = 0; i < static_cast<size_t>(_numNodes); i++ )
-    {
-        CPL_LSBPTR64(&_nodeItems[i].minX);
-        CPL_LSBPTR64(&_nodeItems[i].minY);
-        CPL_LSBPTR64(&_nodeItems[i].maxX);
-        CPL_LSBPTR64(&_nodeItems[i].maxY);
-        CPL_LSBPTR64(&_nodeItems[i].offset);
-    }
-#endif
-    writeData(reinterpret_cast<uint8_t *>(_nodeItems), static_cast<size_t>(_numNodes * sizeof(NodeItem)));
-#if !CPL_IS_LSB
-    for( size_t i = 0; i < static_cast<size_t>(_numNodes); i++ )
-    {
-        CPL_LSBPTR64(&_nodeItems[i].minX);
-        CPL_LSBPTR64(&_nodeItems[i].minY);
-        CPL_LSBPTR64(&_nodeItems[i].maxX);
-        CPL_LSBPTR64(&_nodeItems[i].maxY);
-        CPL_LSBPTR64(&_nodeItems[i].offset);
-    }
-#endif
-}
-
-NodeItem PackedRTree::getExtent() const { return _extent; }
-
-}
-}
\ No newline at end of file
diff -pruN 8.0.1-5/flatgeobuf/packedrtree.h 8.2.0~beta1-1~exp1/flatgeobuf/packedrtree.h
--- 8.0.1-5/flatgeobuf/packedrtree.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/flatgeobuf/packedrtree.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,113 +0,0 @@
-/******************************************************************************
- *
- * Project:  FlatGeobuf
- * Purpose:  Packed RTree management
- * Author:   Björn Harrtell <bjorn at wololo dot org>
- *
- ******************************************************************************
- * Copyright (c) 2018-2020, Björn Harrtell <bjorn at wololo dot org>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included
- * in all copies or substantial portions of the Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-// NOTE: The upstream of this file is in https://github.com/bjornharrtell/flatgeobuf/tree/master/src/cpp
-
-#ifndef FLATGEOBUF_PACKEDRTREE_H_
-#define FLATGEOBUF_PACKEDRTREE_H_
-
-#include <cmath>
-#include <numeric>
-
-#include "flatbuffers/flatbuffers.h"
-
-namespace mapserver {
-namespace FlatGeobuf {
-
-struct NodeItem {
-    double minX;
-    double minY;
-    double maxX;
-    double maxY;
-    uint64_t offset;
-    double width() const { return maxX - minX; }
-    double height() const { return maxY - minY; }
-    static NodeItem sum(NodeItem a, const NodeItem &b) {
-        a.expand(b);
-        return a;
-    }
-    static NodeItem create(uint64_t offset = 0);
-    const NodeItem &expand(const NodeItem &r);
-    bool intersects(const NodeItem &r) const;
-    std::vector<double> toVector();
-};
-
-struct Item {
-    NodeItem nodeItem;
-};
-
-struct SearchResultItem {
-    uint64_t offset;
-    uint64_t index;
-};
-
-std::ostream& operator << (std::ostream& os, NodeItem const& value);
-
-uint32_t hilbert(uint32_t x, uint32_t y);
-uint32_t hilbert(const NodeItem &n, uint32_t hilbertMax, const double minX, const double minY, const double width, const double height);
-void hilbertSort(std::vector<std::shared_ptr<Item>> &items);
-void hilbertSort(std::vector<NodeItem> &items);
-NodeItem calcExtent(const std::vector<std::shared_ptr<Item>> &items);
-NodeItem calcExtent(const std::vector<NodeItem> &rects);
-
-/**
- * Packed R-Tree
- * Based on https://github.com/mourner/flatbush
- */
-class PackedRTree {
-    NodeItem _extent;
-    NodeItem *_nodeItems = nullptr;
-    uint64_t _numItems;
-    uint64_t _numNodes;
-    uint16_t _nodeSize;
-    std::vector<std::pair<uint64_t, uint64_t>> _levelBounds;
-    void init(const uint16_t nodeSize);
-    void generateNodes();
-    void fromData(const void *data);
-public:
-    ~PackedRTree() {
-        if (_nodeItems != nullptr)
-            delete[] _nodeItems;
-    }
-    PackedRTree(const std::vector<std::shared_ptr<Item>> &items, const NodeItem &extent, const uint16_t nodeSize = 16);
-    PackedRTree(const std::vector<NodeItem> &nodes, const NodeItem &extent, const uint16_t nodeSize = 16);
-    PackedRTree(const void *data, const uint64_t numItems, const uint16_t nodeSize = 16);
-    std::vector<SearchResultItem> search(double minX, double minY, double maxX, double maxY) const;
-    static std::vector<SearchResultItem> streamSearch(
-        const uint64_t numItems, const uint16_t nodeSize, const NodeItem &item,
-        const std::function<void(uint8_t *, size_t, size_t)> &readNode);
-    static std::vector<std::pair<uint64_t, uint64_t>> generateLevelBounds(const uint64_t numItems, const uint16_t nodeSize);
-    uint64_t size() const;
-    static uint64_t size(const uint64_t numItems, const uint16_t nodeSize = 16);
-    NodeItem getExtent() const;
-    void streamWrite(const std::function<void(uint8_t *, size_t)> &writeData);
-};
-
-} }
-
-#endif
diff -pruN 8.0.1-5/fontcache.c 8.2.0~beta1-1~exp1/fontcache.c
--- 8.0.1-5/fontcache.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fontcache.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,380 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Freetype Font helper functions
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2013 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-
-#include "mapserver.h"
-#include "mapthread.h"
-#include "fontcache.h"
-#include "dejavu-sans-condensed.h"
-
-#include "cpl_conv.h"
-
-typedef struct {
-  FT_Library library;
-  face_element *face_cache;
-  glyph_element *bitmap_glyph_cache;
-} ft_cache;
-
-#ifdef USE_THREAD
-typedef struct ft_thread_cache ft_thread_cache;
-struct ft_thread_cache{
-  void* thread_id;
-  ft_thread_cache *next;
-  ft_cache cache;
-};
-ft_thread_cache *ft_caches;
-int use_global_ft_cache;
-#else
-  ft_cache global_ft_cache;
-#endif
-
-
-void msInitFontCache(ft_cache *c) {
-  memset(c,0,sizeof(ft_cache));
-  FT_Init_FreeType(&c->library);
-}
-
-void msFreeFontCache(ft_cache *c) {
-  /* ... TODO ... */
-  face_element *cur_face,*tmp_face;
-  glyph_element *cur_bitmap, *tmp_bitmap;
-  UT_HASH_ITER(hh, c->face_cache, cur_face, tmp_face) {
-      index_element *cur_index,*tmp_index;
-      outline_element *cur_outline,*tmp_outline;
-      glyph_element *cur_glyph,*tmp_glyph;
-      UT_HASH_ITER(hh, cur_face->index_cache, cur_index, tmp_index) {
-        UT_HASH_DEL(cur_face->index_cache,cur_index);
-        free(cur_index);
-      }
-      UT_HASH_ITER(hh, cur_face->outline_cache, cur_outline, tmp_outline) {
-        UT_HASH_DEL(cur_face->outline_cache,cur_outline);
-        FT_Outline_Done(c->library,&cur_outline->outline);
-        free(cur_outline);
-      }
-      UT_HASH_ITER(hh, cur_face->glyph_cache, cur_glyph, tmp_glyph) {
-        UT_HASH_DEL(cur_face->glyph_cache,cur_glyph);
-        free(cur_glyph);
-      }
-#ifdef USE_HARFBUZZ
-      if(cur_face->hbfont) {
-        hb_font_destroy(cur_face->hbfont->hbfont);
-        hb_font_destroy(cur_face->hbfont->hbparentfont);
-        hb_font_funcs_destroy(cur_face->hbfont->funcs);
-        free(cur_face->hbfont);
-      }
-#endif
-      FT_Done_Face(cur_face->face);
-      free(cur_face->font);
-      UT_HASH_DEL(c->face_cache,cur_face);
-      free(cur_face);
-  }
-  FT_Done_FreeType(c->library);
-
-  UT_HASH_ITER(hh,c->bitmap_glyph_cache, cur_bitmap, tmp_bitmap) {
-    UT_HASH_DEL(c->bitmap_glyph_cache, cur_bitmap);
-    free(cur_bitmap);
-  }
-  memset(c,0,sizeof(ft_cache));
-}
-
-ft_cache* msGetFontCache() {
-#ifndef USE_THREAD
-  return &global_ft_cache;
-#else
-  void* nThreadId = 0;
-  ft_thread_cache *prev = NULL, *cur = ft_caches;
-
-  if (!use_global_ft_cache)
-    nThreadId = msGetThreadId();
-
-  if( cur != NULL && cur->thread_id == nThreadId )
-    return &cur->cache;
-
-  /* -------------------------------------------------------------------- */
-  /*      Search for cache for this thread                                */
-  /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_TTF );
-
-  cur = ft_caches;
-  while( cur != NULL && cur->thread_id != nThreadId ) {
-    prev = cur;
-    cur = cur->next;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If we found it, make sure it is pushed to the front of the      */
-  /*      link for faster finding next time, and return it.               */
-  /* -------------------------------------------------------------------- */
-  if( cur != NULL ) {
-    if( prev != NULL ) {
-      prev->next = cur->next;
-      cur->next = ft_caches;
-      ft_caches = cur;
-    }
-
-    msReleaseLock( TLOCK_TTF );
-    return &cur->cache;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create a new context group for this thread.                     */
-  /* -------------------------------------------------------------------- */
-  cur = msSmallMalloc(sizeof(ft_thread_cache));
-  cur->next = NULL;
-  cur->thread_id = nThreadId;
-  msInitFontCache(&cur->cache);
-  cur->next = ft_caches;
-  ft_caches = cur;
-
-  msReleaseLock( TLOCK_TTF );
-
-  return &cur->cache;
-#endif
-}
-
-void msFontCacheSetup() {
-#ifndef USE_THREAD
-  ft_cache *c = msGetFontCache();
-  msInitFontCache(c);
-#else
-  const char *use_global_cache = CPLGetConfigOption("MS_USE_GLOBAL_FT_CACHE", NULL);
-  if (use_global_cache)
-    use_global_ft_cache = atoi(use_global_cache);
-  else
-    use_global_ft_cache = 0;
-
-  ft_caches = NULL;
-#endif
-}
-
-void msFontCacheCleanup() {
-#ifndef USE_THREAD
-  ft_cache *c = msGetFontCache();
-  msFreeFontCache(c);
-#else
-  ft_thread_cache *cur,*next;
-  msAcquireLock( TLOCK_TTF );
-  cur =  ft_caches;
-  while( cur != NULL ) {
-    msFreeFontCache(&cur->cache);
-    next = cur->next;
-    free(cur);
-    cur = next;
-  }
-  ft_caches = NULL;
-  msReleaseLock( TLOCK_TTF );
-#endif
-}
-
-unsigned int msGetGlyphIndex(face_element *face, unsigned int unicode) {
-  index_element *ic;
-  if(face->face->charmap && face->face->charmap->encoding == FT_ENCODING_MS_SYMBOL) {
-    unicode |= 0xf000; /* why? */
-  }
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-	  msAcquireLock(TLOCK_TTF);
-#endif   
-  UT_HASH_FIND_INT(face->index_cache,&unicode,ic);
-  if(!ic) {
-    ic = msSmallMalloc(sizeof(index_element));
-    ic->codepoint = FT_Get_Char_Index(face->face,unicode);
-    ic->unicode = unicode;
-    UT_HASH_ADD_INT(face->index_cache,unicode,ic);
-  }
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-	  msReleaseLock(TLOCK_TTF);
-#endif  
-  return ic->codepoint;
-}
-
-#define MS_DEFAULT_FONT_KEY "_ms_default_"
-
-face_element* msGetFontFace(char *key, fontSetObj *fontset) {
-  face_element *fc;
-  int error;
-  ft_cache *cache = msGetFontCache();
-  if(!key) {
-    key = MS_DEFAULT_FONT_KEY;
-  }
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-    msAcquireLock(TLOCK_TTF);
-#endif
-  UT_HASH_FIND_STR(cache->face_cache,key,fc);
-  if(!fc) {
-    const char *fontfile = NULL;
-    fc = msSmallCalloc(1,sizeof(face_element));
-    if(fontset && strcmp(key,MS_DEFAULT_FONT_KEY)) {
-      fontfile = msLookupHashTable(&(fontset->fonts),key);
-      if(!fontfile) {
-        msSetError(MS_MISCERR, "Could not find font with key \"%s\" in fontset", "msGetFontFace()", key);
-        free(fc);
-#ifdef USE_THREAD
-        if (use_global_ft_cache)
-          msReleaseLock(TLOCK_TTF);
-#endif
-        return NULL;
-      }
-      error = FT_New_Face(cache->library,fontfile,0, &(fc->face));
-    } else {
-      error = FT_New_Memory_Face(cache->library,dejavu_sans_condensed_ttf, dejavu_sans_condensed_ttf_len , 0, &(fc->face));
-    }
-    if(error) {
-      msSetError(MS_MISCERR, "Freetype was unable to load font file \"%s\" for key \"%s\"", "msGetFontFace()", fontfile, key);
-      free(fc);
-#ifdef USE_THREAD
-      if (use_global_ft_cache)
-        msReleaseLock(TLOCK_TTF);
-#endif
-      return NULL;
-    }
-    if(!fc->face->charmap) {
-      /* The font file has no unicode charmap, select an alternate one */
-      if( FT_Select_Charmap(fc->face, FT_ENCODING_MS_SYMBOL) )
-        FT_Select_Charmap(fc->face, FT_ENCODING_APPLE_ROMAN);
-      /* the previous calls may have failed, we ignore as there's nothing much left to do */
-    }
-    fc->font = msStrdup(key);
-    UT_HASH_ADD_KEYPTR(hh,cache->face_cache,fc->font, strlen(key), fc);
-  }
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-    msReleaseLock(TLOCK_TTF);
-#endif
-  return fc;
-}
-
-glyph_element* msGetGlyphByIndex(face_element *face, unsigned int size, unsigned int codepoint) {
-  glyph_element *gc;
-  glyph_element_key key;
-  memset(&key,0,sizeof(glyph_element_key));
-  key.codepoint = codepoint;
-  key.size = size;
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-    msAcquireLock(TLOCK_TTF);
-#endif   
-  UT_HASH_FIND(hh,face->glyph_cache,&key,sizeof(glyph_element_key),gc);
-  if(!gc) {
-    FT_Error error;
-    gc = msSmallMalloc(sizeof(glyph_element));
-    if(MS_NINT(size * 96.0/72.0) != face->face->size->metrics.x_ppem) {
-      FT_Set_Pixel_Sizes(face->face,0,MS_NINT(size * 96/72.0));
-    }
-    error = FT_Load_Glyph(face->face,key.codepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
-    if (error) {
-      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n", key.codepoint, face->font);
-      // If we can't find a glyph then try to fallback to a question mark.
-      unsigned int fallbackCodepoint = msGetGlyphIndex(face, 0x3F);
-      error = FT_Load_Glyph(face->face,fallbackCodepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
-    }
-    if(error) {
-      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"", "msGetGlyphByIndex()",key.codepoint, face->font);
-      free(gc);
-#ifdef USE_THREAD
-      if (use_global_ft_cache)
-        msReleaseLock(TLOCK_TTF);
-#endif      
-      return NULL;
-    }
-    gc->metrics.minx = face->face->glyph->metrics.horiBearingX / 64.0;
-    gc->metrics.maxx = gc->metrics.minx + face->face->glyph->metrics.width / 64.0;
-    gc->metrics.maxy = face->face->glyph->metrics.horiBearingY / 64.0;
-    gc->metrics.miny = gc->metrics.maxy - face->face->glyph->metrics.height / 64.0;
-    gc->metrics.advance = face->face->glyph->metrics.horiAdvance / 64.0;
-    gc->key = key;
-    UT_HASH_ADD(hh,face->glyph_cache,key,sizeof(glyph_element_key), gc);
-  }
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-    msReleaseLock(TLOCK_TTF);
-#endif  
-  return gc;
-}
-
-outline_element* msGetGlyphOutline(face_element *face, glyph_element *glyph) {
-  outline_element *oc;
-  outline_element_key key;
-  ft_cache *cache = msGetFontCache();
-  memset(&key,0,sizeof(outline_element_key));
-  key.glyph = glyph;
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-    msAcquireLock(TLOCK_TTF);
-#endif
-  UT_HASH_FIND(hh,face->outline_cache,&key, sizeof(outline_element_key),oc);
-  if(!oc) {
-    FT_Matrix matrix;
-    FT_Vector pen;
-    FT_Error error;
-    oc = msSmallMalloc(sizeof(outline_element));
-    if(MS_NINT(glyph->key.size * 96.0/72.0) != face->face->size->metrics.x_ppem) {
-      FT_Set_Pixel_Sizes(face->face,0,MS_NINT(glyph->key.size * 96/72.0));
-    }
-    matrix.xx = matrix.yy = 0x10000L;
-    matrix.xy = matrix.yx = 0x00000L;
-    pen.x = pen.y = 0;
-    FT_Set_Transform(face->face, &matrix, &pen);
-    error = FT_Load_Glyph(face->face,glyph->key.codepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP/*|FT_LOAD_IGNORE_TRANSFORM*/|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
-    if (error) {
-      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n", glyph->key.codepoint, face->font);
-      // If we can't find a glyph then try to fallback to a question mark.
-      unsigned int fallbackCodepoint = msGetGlyphIndex(face, 0x3F);
-      error = FT_Load_Glyph(face->face,fallbackCodepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP/*|FT_LOAD_IGNORE_TRANSFORM*/|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
-    }
-    if(error) {
-      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"", "msGetGlyphOutline()",glyph->key.codepoint, face->font);
-#ifdef USE_THREAD
-      if (use_global_ft_cache)
-        msReleaseLock(TLOCK_TTF);
-#endif
-      return NULL;
-    }
-    error = FT_Outline_New(cache->library, face->face->glyph->outline.n_points,
-        face->face->glyph->outline.n_contours, &oc->outline);
-    (void)error;
-    FT_Outline_Copy(&face->face->glyph->outline, &oc->outline);
-    oc->key = key;
-    UT_HASH_ADD(hh,face->outline_cache,key,sizeof(outline_element_key), oc);
-  }
-#ifdef USE_THREAD
-  if (use_global_ft_cache)
-    msReleaseLock(TLOCK_TTF);
-#endif
-  return oc;
-}
-
-int msIsGlyphASpace(glyphObj *glyph) {
-  /* space or tab, for now */
-  unsigned int space,tab;
-  space = msGetGlyphIndex(glyph->face,0x20);
-  tab = msGetGlyphIndex(glyph->face,0x9);
-  return glyph->glyph->key.codepoint == space || glyph->glyph->key.codepoint == tab;
-}
diff -pruN 8.0.1-5/fontcache.h 8.2.0~beta1-1~exp1/fontcache.h
--- 8.0.1-5/fontcache.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fontcache.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,87 +0,0 @@
-#include "mapserver.h"
-#include "uthash.h"
-
-#include <ft2build.h>
-#include FT_FREETYPE_H
-#include FT_GLYPH_H
-#include FT_OUTLINE_H
-
-#ifdef USE_FRIBIDI
- #if (defined(_WIN32) && !defined(__CYGWIN__)) || defined(HAVE_FRIBIDI2)
-  #include "fribidi.h"
- #else
-  #include <fribidi/fribidi.h>
- #endif
- #include <hb-ft.h>
-#endif
-
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-typedef struct { /* this one can remain private */
-  unsigned int unicode;
-  unsigned int codepoint;
-  UT_hash_handle hh;
-} index_element;
-
-typedef struct {
-  void *hbparentfont;
-  void *hbfont;
-  void *funcs;
-  int cursize;
-} hb_font_element;
-
-typedef struct {
-  unsigned int codepoint;
-  unsigned int size;
-} glyph_element_key;
-
-struct glyph_element{
-  glyph_element_key key;
-  glyph_metrics metrics;
-  UT_hash_handle hh;
-};
-
-typedef struct {
-  glyph_element *glyph;
-} outline_element_key;
-
-typedef struct {
-  outline_element_key key;
-  FT_Outline outline;
-  UT_hash_handle hh;
-} outline_element;
-
-typedef struct {
-  glyph_element *glyph;
-} bitmap_element_key;
-
-typedef struct {
-  bitmap_element_key key;
-  void *bitmap;
-  UT_hash_handle hh;
-} bitmap_element;
-
-struct face_element{
-  char *font;
-  FT_Face face;
-  index_element *index_cache;
-  glyph_element *glyph_cache;
-  outline_element *outline_cache;
-  hb_font_element *hbfont;
-  UT_hash_handle hh;
-};
-
-
-face_element* msGetFontFace(char *key, fontSetObj *fontset);
-outline_element* msGetGlyphOutline(face_element *face, glyph_element *glyph);
-glyph_element* msGetBitmapGlyph(rendererVTableObj *renderer, unsigned int size, unsigned int unicode);
-unsigned int msGetGlyphIndex(face_element *face, unsigned int unicode);
-glyph_element* msGetGlyphByIndex(face_element *face, unsigned int size, unsigned int codepoint);
-int msIsGlyphASpace(glyphObj *glyph);
-
-#ifdef __cplusplus
-}
-#endif
diff -pruN 8.0.1-5/fuzzers/CMakeLists.txt 8.2.0~beta1-1~exp1/fuzzers/CMakeLists.txt
--- 8.0.1-5/fuzzers/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fuzzers/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -1,3 +1,13 @@
-add_executable(shapefuzzer shapefuzzer.c)
-target_compile_options(shapefuzzer PRIVATE -Wall -Wextra -Werror=format-security)
-target_link_libraries(shapefuzzer ${MAPSERVER_LIBMAPSERVER})
+foreach(FUZZER_NAME IN ITEMS shapefuzzer mapfuzzer configfuzzer)
+    if(FUZZER)
+        add_executable(${FUZZER_NAME} ${FUZZER_NAME}.c)
+        target_compile_options(${FUZZER_NAME} PRIVATE -Wall -Wextra -Werror=format-security)
+        target_include_directories(${FUZZER_NAME} PRIVATE ${PROJECT_SOURCE_DIR})
+        target_link_libraries(${FUZZER_NAME} ${MAPSERVER_LIBMAPSERVER})
+    else()
+        set(FUZZER_REPRODUCER "${FUZZER_NAME}_reproducer")
+        add_executable(${FUZZER_REPRODUCER} ${FUZZER_NAME}.c reproducer_main.cpp)
+        target_include_directories(${FUZZER_REPRODUCER} PRIVATE ${PROJECT_SOURCE_DIR})
+        target_link_libraries(${FUZZER_REPRODUCER} ${MAPSERVER_LIBMAPSERVER})
+    endif()
+endforeach()
diff -pruN 8.0.1-5/fuzzers/README.md 8.2.0~beta1-1~exp1/fuzzers/README.md
--- 8.0.1-5/fuzzers/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fuzzers/README.md	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+This directory contain fuzzer main functions and scripts for the
+Google OSS Fuzz project: https://github.com/google/oss-fuzz/
+
+The main Dockerfile is in:
+https://github.com/google/oss-fuzz/blob/master/projects/mapserver/Dockerfile
+and use the build.sh script and fuzzer source code in this
+(https://github.com/MapServer/MapServer/blob/main/fuzzers) directory.
+
+The list of issues is in:
+https://bugs.chromium.org/p/oss-fuzz/issues/list?q=mapserver
+
+- Build fuzzer reproducer programs (BUILD_FUZZER_REPRODUCER=ON is the default)
+  ```
+    $ cmake -DBUILD_FUZZER_REPRODUCER=ON /path/to/source/root
+    $ make
+  ```
+
+  Run one against a reproducer file (typically generated by OSS Fuzz):
+  ```
+    $ fuzzers/shapefuzzer_reproducer path_to_reproducer_file
+  ```
+
+- Run OSS Fuzz locally. Note you need to have Docker installed and the Docker daemon running for the Python script to run.
+  The helper.py script builds and runs the Docker images, then the fuzzers can be run.
+
+  ```
+    $ git clone https://github.com/google/oss-fuzz.git
+    $ cd oss-fuzz
+    $ export PROJECT_NAME=mapserver
+    # if you want to run it against your own MapServer fork & branch,
+    # you need to edit projects/mapserver/Dockerfile and comment out the following line:
+    # #RUN git clone --depth 1 https://github.com/MapServer/MapServer
+    # and replace it with something like
+    # RUN git clone --depth 1 --branch ossfuzz_run_live_and_minimal_gdal https://github.com/rouault/MapServer
+    $ python infra/helper.py build_image $PROJECT_NAME
+  ```
+
+  Build fuzzers with the address sanitizer (could use undefined, etc...)
+  ```
+    $ python infra/helper.py build_fuzzers --sanitizer address $PROJECT_NAME
+  ```
+
+  Test a particular fuzzer (replace shapefuzzer by other fuzzers)
+  ```
+    $ python infra/helper.py run_fuzzer $PROJECT_NAME shapefuzzer
+  ```
+
+- Build fuzzer programs for local fuzzing against current MapServer build.
+  Requires to use CLang as compiler.
+  ```
+    $ cmake -DBUILD_FUZZER_REPRODUCER=OFF -DFUZZER=ON /path/to/source/root
+    $ make
+  ```
+
+  Run the shapefuzzer:
+  ```
+    $ fuzzers/shapefuzzer
+  ```
+
+How to deal with issues reported in https://bugs.chromium.org/p/oss-fuzz/issues/list?q=mapserver ?
+
+    1. Leave a comment in (chromium database) bug entry to indicate that you work on it
+    2. Work
+    3. Commit a bug fix with commit message with a link to the bugs.chromium.org ticket
+    4. Add in the bugs.chromium.org ticket a link to the github pull request or commit implementing the fix.
+    5. Check chromium closed the bug (after one or two days typically)
diff -pruN 8.0.1-5/fuzzers/build.sh 8.2.0~beta1-1~exp1/fuzzers/build.sh
--- 8.0.1-5/fuzzers/build.sh	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fuzzers/build.sh	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,92 @@
+#!/bin/bash -eu
+# Copyright 2022 Google LLC
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+################################################################################
+
+BUILD_SH_FROM_REPO="$SRC/MapServer/fuzzers/build.sh"
+if test -f "$BUILD_SH_FROM_REPO"; then
+    if test "$0" != "$BUILD_SH_FROM_REPO"; then
+        echo "Running $BUILD_SH_FROM_REPO"
+        exec "$BUILD_SH_FROM_REPO"
+        exit $?
+    fi
+fi
+
+apt-get install -y libsqlite3-dev liblzma-dev sqlite3
+apt-get remove -y libproj15 libproj-dev libxml2-dev libxml2
+
+# Build libxml2 from source (packaged one depends on libicu which is C++)
+wget https://gitlab.gnome.org/GNOME/libxml2/-/archive/v2.10.2/libxml2-v2.10.2.tar.gz
+tar xvzf libxml2-v2.10.2.tar.gz
+cd libxml2-v2.10.2
+cmake . -DBUILD_SHARED_LIBS=OFF -DCMAKE_C_FLAGS="-fPIC" -DCMAKE_CXX_FLAGS="-fPIC"
+make -j$(nproc) -s
+make install
+cd ..
+
+# Build PROJ dependency (we can't use the packaged one because of incompatibilities
+# between libstdc++ from clang and the libc++ of clang used by ossfuzz
+git clone --depth 1 https://github.com/OSGeo/PROJ proj
+cd proj
+cmake . -DBUILD_SHARED_LIBS:BOOL=OFF \
+      -DENABLE_TIFF:BOOL=OFF \
+      -DENABLE_CURL:BOOL=OFF \
+      -DCMAKE_INSTALL_PREFIX=/usr \
+      -DBUILD_APPS:BOOL=OFF \
+      -DBUILD_TESTING:BOOL=OFF
+make -j$(nproc) -s
+make install
+cd ..
+
+#Build gdal dependency
+pushd $SRC/gdal
+mkdir build
+cd build
+cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_SHARED_LIBS=OFF -DBUILD_TESTING=OFF \
+-DGDAL_BUILD_OPTIONAL_DRIVERS:BOOL=OFF -DOGR_BUILD_OPTIONAL_DRIVERS:BOOL=OFF \
+-DBUILD_APPS=OFF \
+-DCMAKE_EXE_LINKER_FLAGS="-pthread" ../
+make -j$(nproc) GDAL
+make install
+popd
+
+
+#Build MapServer
+cd $SRC/MapServer
+mkdir build
+cd build
+cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_STATIC=ON \
+-DWITH_PROTOBUFC=0 -DWITH_FRIBIDI=0 -DWITH_HARFBUZZ=0 -DWITH_CAIRO=0 -DWITH_FCGI=0 \
+-DWITH_GEOS=0 -DWITH_POSTGIS=0 -DWITH_GIF=0 ../
+#While using undefined sanitizer, Project cannot compile binary but can compile library.
+make -j$(nproc) mapserver_static
+
+#Fuzzers
+for fuzzer in mapfuzzer shapefuzzer configfuzzer; do
+    $CC $CFLAGS -Wall -Wextra -I. -I.. -I/usr/include/gdal/. -DPROJ_VERSION_MAJOR=6 -c ../fuzzers/${fuzzer}.c
+
+    $CXX $CXXFLAGS $LIB_FUZZING_ENGINE ${fuzzer}.o -o ${fuzzer} \
+        -L. -lmapserver_static -lgdal \
+        -Wl,-Bstatic -lpng -ljpeg -lfreetype -lproj -lxml2 -lz -lsqlite3 -llzma \
+        -Wl,-Bdynamic  -lpthread -ldl -lc++
+
+    cp ${fuzzer} $OUT/
+done
+
+cd ..
+
+zip -r $OUT/mapfuzzer_seed_corpus.zip tests/*.map
+zip -r $OUT/shapefuzzer_seed_corpus.zip tests/*.shp tests/*.shx tests/*.dbf
+zip -r $OUT/configfuzzer_seed_corpus.zip tests/*.conf etc/*.conf msautotest/config/*.conf
diff -pruN 8.0.1-5/fuzzers/configfuzzer.c 8.2.0~beta1-1~exp1/fuzzers/configfuzzer.c
--- 8.0.1-5/fuzzers/configfuzzer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fuzzers/configfuzzer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,54 @@
+/* Copyright 2022 Google LLC
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+      http://www.apache.org/licenses/LICENSE-2.0
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+
+#include <stdint.h>
+#include <string.h>
+
+#include "cpl_conv.h"
+#include "cpl_string.h"
+#include "src/mapserver.h"
+
+#define kMinInputLength 10
+#define kMaxInputLength 10240
+
+extern int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size);
+extern int LLVMFuzzerInitialize(int *argc, char ***argv);
+
+int LLVMFuzzerInitialize(int *argc, char ***argv) {
+  (void)argc;
+  (void)argv;
+  return 0;
+}
+
+extern int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
+
+  if (Size < kMinInputLength || Size > kMaxInputLength) {
+    return 1;
+  }
+
+  char *filename =
+      msStrdup(CPLSPrintf("%s.config", CPLGenerateTempFilename(NULL)));
+  FILE *fp = fopen(filename, "wb");
+  if (!fp) {
+    msFree(filename);
+    return 1;
+  }
+  fwrite(Data, Size, 1, fp);
+  fclose(fp);
+
+  msFreeConfig(msLoadConfig(filename));
+  VSIUnlink(filename);
+  msFree(filename);
+  msResetErrorList();
+
+  return 0;
+}
diff -pruN 8.0.1-5/fuzzers/mapfuzzer.c 8.2.0~beta1-1~exp1/fuzzers/mapfuzzer.c
--- 8.0.1-5/fuzzers/mapfuzzer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fuzzers/mapfuzzer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,56 @@
+/* Copyright 2022 Google LLC
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+      http://www.apache.org/licenses/LICENSE-2.0
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
+*/
+
+#include <stdint.h>
+#include <string.h>
+
+#include "cpl_conv.h"
+#include "cpl_string.h"
+#include "src/mapserver.h"
+
+#define kMinInputLength 10
+#define kMaxInputLength 10240
+
+extern int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size);
+extern int LLVMFuzzerInitialize(int *argc, char ***argv);
+
+int LLVMFuzzerInitialize(int *argc, char ***argv) {
+  (void)argc;
+  (void)argv;
+  return 0;
+}
+
+extern int LLVMFuzzerTestOneInput(const uint8_t *Data, size_t Size) {
+
+  if (Size < kMinInputLength || Size > kMaxInputLength) {
+    return 1;
+  }
+
+  // .map extension is required otherwise default pattern validation of
+  // msLoadMap() would reject it
+  char *filename =
+      msStrdup(CPLSPrintf("%s.map", CPLGenerateTempFilename(NULL)));
+  FILE *fp = fopen(filename, "wb");
+  if (!fp) {
+    msFree(filename);
+    return 1;
+  }
+  fwrite(Data, Size, 1, fp);
+  fclose(fp);
+
+  msFreeMap(msLoadMap(filename, NULL, NULL));
+  VSIUnlink(filename);
+  msFree(filename);
+  msResetErrorList();
+
+  return 0;
+}
diff -pruN 8.0.1-5/fuzzers/reproducer_main.cpp 8.2.0~beta1-1~exp1/fuzzers/reproducer_main.cpp
--- 8.0.1-5/fuzzers/reproducer_main.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fuzzers/reproducer_main.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,107 @@
+/******************************************************************************
+ *
+ * Project:  GDAL
+ * Purpose:  Fuzzer
+ * Author:   Even Rouault, even.rouault at spatialys.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2017, Even Rouault <even.rouault at spatialys.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included
+ * in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <limits.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+
+extern "C" {
+int LLVMFuzzerTestOneInput(const void *buf, size_t len);
+int LLVMFuzzerInitialize(int *argc, char ***argv);
+}
+
+template <class T> static void CPL_IGNORE_RET_VAL(T) {}
+
+static void Usage(int, char *argv[]) {
+  fprintf(stderr, "%s [--help] [-repeat N] filename.\n", argv[0]);
+  exit(1);
+}
+
+int main(int argc, char *argv[]) {
+  LLVMFuzzerInitialize(&argc, &argv);
+
+  int nRet = 0;
+  void *buf = nullptr;
+  size_t nLen = 0;
+  int nLoops = 1;
+  const char *pszFilename = nullptr;
+  for (int i = 1; i < argc; i++) {
+    if (i + 1 < argc && strcmp(argv[i], "-repeat") == 0) {
+      nLoops = atoi(argv[i + 1]);
+      // Limit to INT_MAX - 1 :-)
+      // to make fun of coverity scan that complains about tainted data
+      // being used as a loop boundary.
+      if (nLoops > INT_MAX - 1)
+        nLoops = INT_MAX - 1;
+      i++;
+    } else if (strcmp(argv[i], "-dummy") == 0) {
+      return LLVMFuzzerTestOneInput(" ", 1);
+    } else if (strcmp(argv[i], "--help") == 0) {
+      Usage(argc, argv);
+    } else if (argv[i][0] == '-') {
+      fprintf(stderr, "Unrecognized option: %s", argv[i]);
+      Usage(argc, argv);
+    } else {
+      pszFilename = argv[i];
+    }
+  }
+  if (pszFilename == nullptr) {
+    fprintf(stderr, "No filename specified\n");
+    Usage(argc, argv);
+  }
+  FILE *f = fopen(pszFilename, "rb");
+  if (!f) {
+    fprintf(stderr, "%s does not exist.\n", pszFilename);
+    exit(1);
+  }
+  fseek(f, 0, SEEK_END);
+  long pos = ftell(f);
+  if (pos < 0) {
+    fprintf(stderr, "ftell() failed.\n");
+    fclose(f);
+    exit(1);
+  }
+  nLen = (size_t)pos;
+  fseek(f, 0, SEEK_SET);
+  buf = malloc(nLen);
+  if (!buf) {
+    fprintf(stderr, "malloc failed.\n");
+    fclose(f);
+    exit(1);
+  }
+  CPL_IGNORE_RET_VAL(fread(buf, nLen, 1, f));
+  fclose(f);
+  for (int i = 0; i < nLoops; i++) {
+    nRet = LLVMFuzzerTestOneInput(buf, nLen);
+    if (nRet != 0)
+      break;
+  }
+  free(buf);
+  return nRet;
+}
diff -pruN 8.0.1-5/fuzzers/shapefuzzer.c 8.2.0~beta1-1~exp1/fuzzers/shapefuzzer.c
--- 8.0.1-5/fuzzers/shapefuzzer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/fuzzers/shapefuzzer.c	2024-06-06 20:07:58.000000000 +0000
@@ -1,19 +1,37 @@
-#include "../mapserver.h"
-#include "../mapshape.h"
+#include "src/mapserver.h"
+#include "src/mapshape.h"
+
+#include "cpl_vsi.h"
 
 #include <stdlib.h>
 #include <string.h>
 #include <stdbool.h>
 
 extern int LLVMFuzzerTestOneInput(GByte *data, size_t size);
+extern int LLVMFuzzerInitialize(int *argc, char ***argv);
+
+static void *msMemmem(const void *haystack, size_t haystack_len,
+                      const void *const needle, const size_t needle_len) {
+  if (haystack_len == 0)
+    return NULL;
+  if (needle_len == 0)
+    return NULL;
+
+  for (const char *h = (const char *)haystack; haystack_len >= needle_len;
+       ++h, --haystack_len) {
+    if (!memcmp(h, needle, needle_len)) {
+      return (void *)h;
+    }
+  }
+  return NULL;
+}
 
-static VSILFILE *
-SegmentFile(const char *filename, GByte **data_p, size_t *size_p)
-{
+static VSILFILE *SegmentFile(const char *filename, GByte **data_p,
+                             size_t *size_p) {
   GByte *data = *data_p;
   size_t size = *size_p;
 
-  GByte *separator = memmem(data, size, "deadbeef", 8);
+  GByte *separator = (GByte *)msMemmem(data, size, "deadbeef", 8);
   if (separator != NULL) {
     size = separator - data;
     *data_p = separator + 8;
@@ -25,13 +43,18 @@ SegmentFile(const char *filename, GByte
   return VSIFileFromMemBuffer(filename, data, size, false);
 }
 
-int
-LLVMFuzzerTestOneInput(GByte *data, size_t size)
-{
+int LLVMFuzzerInitialize(int *argc, char ***argv) {
+  (void)argc;
+  (void)argv;
+  return 0;
+}
+
+int LLVMFuzzerTestOneInput(GByte *data, size_t size) {
   /* this fuzzer expects three files concatenated, separated by the
      string "deadbeef"; you can generate such a file by typing:
 
-     { cat foo.shp; echo -n "deadbeef"; cat foo.shx; echo -n "deadbeef"; cat foo.dbf; } >/tmp/corpus/start
+     { cat foo.shp; echo -n "deadbeef"; cat foo.shx; echo -n "deadbeef"; cat
+     foo.dbf; } >/tmp/corpus/start
 
      then run the fuzzer:
 
@@ -43,12 +66,25 @@ LLVMFuzzerTestOneInput(GByte *data, size
   VSILFILE *dbf = SegmentFile("/vsimem/foo.dbf", &data, &size);
 
   shapefileObj file;
-  if (msShapefileOpenVirtualFile(&file, "/vsimem/foo.shp", shp, shx, dbf, false) == 0) {
+  errorObj *ms_error = msGetErrorObj();
+  if (msShapefileOpenVirtualFile(&file, "/vsimem/foo.shp", shp, shx, dbf,
+                                 false) == 0) {
+    if (file.numshapes > 100 * 1000) {
+      VSIStatBufL sStat;
+      if (VSIStatL("/vsimem/foo.shx", &sStat) == 0 && sStat.st_size >= 100 &&
+          file.numshapes > (int)(sStat.st_size - 100) / 8) {
+        file.numshapes = (int)(sStat.st_size - 100) / 8;
+      }
+    }
     for (int i = 0; i < file.numshapes; ++i) {
       shapeObj shape;
       msInitShape(&shape);
       msSHPReadShape(file.hSHP, i, &shape);
       msFreeShape(&shape);
+      // Give up as soon an error is triggered to avoid too long processing
+      // time.
+      if (ms_error->code != MS_NOERR)
+        break;
     }
 
     msShapefileClose(&file);
@@ -56,5 +92,9 @@ LLVMFuzzerTestOneInput(GByte *data, size
 
   msResetErrorList();
 
+  VSIUnlink("/vsimem/foo.shp");
+  VSIUnlink("/vsimem/foo.shx");
+  VSIUnlink("/vsimem/foo.dbf");
+
   return EXIT_SUCCESS;
 }
diff -pruN 8.0.1-5/hittest.c 8.2.0~beta1-1~exp1/hittest.c
--- 8.0.1-5/hittest.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/hittest.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,302 +0,0 @@
-/*****************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Content Dependant Legend rendering support
- * Author:   Thomas Bonfort (tbonfort@terriscope.fr)
- *
- ******************************************************************************
- * Copyright (c) 1996-2013 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-void initStyleHitTests(styleObj *s, style_hittest *sh, int default_status) {
-  (void)s;
-  sh->status = default_status;
-}
-
-void initLabelHitTests(labelObj *l, label_hittest *lh, int default_status) {
-  int i;
-  lh->stylehits = msSmallCalloc(l->numstyles,sizeof(style_hittest));
-  lh->status = default_status;
-  for(i=0; i<l->numstyles; i++) {
-    initStyleHitTests(l->styles[i],&lh->stylehits[i],default_status);
-  }
-}
-
-void initClassHitTests(classObj *c, class_hittest *ch, int default_status) {
-  int i;
-  ch->stylehits = msSmallCalloc(c->numstyles,sizeof(style_hittest));
-  ch->labelhits = msSmallCalloc(c->numlabels,sizeof(label_hittest));
-  ch->status = default_status;
-  for(i=0; i<c->numstyles; i++) {
-    initStyleHitTests(c->styles[i],&ch->stylehits[i],default_status);
-  }
-  for(i=0; i<c->numlabels; i++) {
-    initLabelHitTests(c->labels[i],&ch->labelhits[i],default_status);
-  }
-}
-
-void initLayerHitTests(layerObj *l, layer_hittest *lh) {
-  int i,default_status;
-  lh->classhits = msSmallCalloc(l->numclasses,sizeof(class_hittest));
-
-  switch(l->type) {
-    case MS_LAYER_POLYGON:
-    case MS_LAYER_POINT:
-    case MS_LAYER_LINE:
-    case MS_LAYER_ANNOTATION:
-      default_status = 0; /* needs testing */
-      break;
-    default:
-      default_status = 1; /* no hittesting needed, use traditional mode */
-      break;
-  }
-  lh->status = default_status;
-  for(i=0; i<l->numclasses; i++) {
-    initClassHitTests(l->class[i],&lh->classhits[i], default_status);
-  }
-}
-void initMapHitTests(mapObj *map, map_hittest *mh) {
-  int i;
-  mh->layerhits = msSmallCalloc(map->numlayers,sizeof(layer_hittest));
-  for(i=0; i<map->numlayers; i++) {
-    initLayerHitTests(GET_LAYER(map,i),&mh->layerhits[i]);
-  }
-}
-
-void freeLabelHitTests(labelObj *l, label_hittest *lh) {
-  (void)l;
-  free(lh->stylehits);
-}
-
-void freeClassHitTests(classObj *c, class_hittest *ch) {
-  int i;
-  for(i=0; i<c->numlabels; i++) {
-    freeLabelHitTests(c->labels[i],&ch->labelhits[i]);
-  }
-  free(ch->stylehits);
-  free(ch->labelhits);
-}
-void freeLayerHitTests(layerObj *l, layer_hittest *lh) {
-  int i;
-  for(i=0; i<l->numclasses; i++) {
-    freeClassHitTests(l->class[i],&lh->classhits[i]);
-  }
-  free(lh->classhits);
-}
-void freeMapHitTests(mapObj *map, map_hittest *mh) {
-  int i;
-  for(i=0; i<map->numlayers; i++) {
-    freeLayerHitTests(GET_LAYER(map,i),&mh->layerhits[i]);
-  }
-  free(mh->layerhits);
-}
-
-int msHitTestShape(mapObj *map, layerObj *layer, shapeObj *shape, int drawmode, class_hittest *hittest) {
-  int i;
-  classObj *cp = layer->class[shape->classindex];
-  if(MS_DRAW_FEATURES(drawmode)) {
-    for(i=0;i<cp->numstyles;i++) {
-      styleObj *sp = cp->styles[i];
-      if(msScaleInBounds(map->scaledenom,sp->minscaledenom,sp->maxscaledenom)) {
-        hittest->stylehits[i].status = 1;
-      }
-    }
-  }
-  if(MS_DRAW_LABELS(drawmode)) {
-    for(i=0;i<cp->numlabels;i++) {
-      labelObj *l = cp->labels[i];
-      if(msGetLabelStatus(map,layer,shape,l) == MS_ON) {
-        int s;
-        hittest->labelhits[i].status = 1;
-        for(s=0; s<l->numstyles;s++) {
-          hittest->labelhits[i].stylehits[s].status = 1;
-        }
-      }
-    }
-  }
-  return MS_SUCCESS;
-}
-
-int msHitTestLayer(mapObj *map, layerObj *layer, layer_hittest *hittest) {
-  int status;
-#ifdef USE_GEOS
-  shapeObj searchpoly;
-#endif
-  if(!msLayerIsVisible(map,layer)) {
-    hittest->status = 0;
-    return MS_SUCCESS;
-  }
-  if(layer->type == MS_LAYER_LINE || layer->type == MS_LAYER_POLYGON || layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_ANNOTATION) {
-    int maxfeatures=msLayerGetMaxFeaturesToDraw(layer, NULL);
-    int annotate = msEvalContext(map, layer, layer->labelrequires);
-    shapeObj shape;
-    int nclasses,featuresdrawn = 0;
-    int *classgroup;
-    rectObj searchrect;
-    int minfeaturesize=-1;
-    if(map->scaledenom > 0) {
-      if((layer->labelmaxscaledenom != -1) && (map->scaledenom >= layer->labelmaxscaledenom)) annotate = MS_FALSE;
-      if((layer->labelminscaledenom != -1) && (map->scaledenom < layer->labelminscaledenom)) annotate = MS_FALSE;
-    }
-
-    status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-
-    /* build item list */
-    status = msLayerWhichItems(layer, MS_FALSE, NULL);
-
-    if(status != MS_SUCCESS) {
-      msLayerClose(layer);
-      return MS_FAILURE;
-    }
-
-    /* identify target shapes */
-    if(layer->transform == MS_TRUE) {
-      searchrect = map->extent;
-      if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-        msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-    }
-    else {
-      searchrect.minx = searchrect.miny = 0;
-      searchrect.maxx = map->width-1;
-      searchrect.maxy = map->height-1;
-    }
-#ifdef USE_GEOS
-    msInitShape(&searchpoly);
-    msRectToPolygon(searchrect,&searchpoly);
-#endif
-
-    status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-    if(status == MS_DONE) { /* no overlap */
-#ifdef USE_GEOS
-      msFreeShape(&searchpoly);
-#endif
-      msLayerClose(layer);
-      hittest->status = 0;
-      return MS_SUCCESS;
-    } else if(status != MS_SUCCESS) {
-#ifdef USE_GEOS
-      msFreeShape(&searchpoly);
-#endif
-      msLayerClose(layer);
-      return MS_FAILURE;
-    }
-
-    /* step through the target shapes */
-    msInitShape(&shape);
-
-    nclasses = 0;
-    classgroup = NULL;
-    if(layer->classgroup && layer->numclasses > 0)
-      classgroup = msAllocateValidClassGroups(layer, &nclasses);
-
-    if(layer->minfeaturesize > 0)
-      minfeaturesize = Pix2LayerGeoref(map, layer, layer->minfeaturesize);
-
-    while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
-      int drawmode = MS_DRAWMODE_FEATURES;
-#ifdef USE_GEOS
-      if(!msGEOSIntersects(&shape,&searchpoly)) {
-        msFreeShape(&shape);
-        continue;
-      }
-#else
-      if(shape.type == MS_SHAPE_POLYGON) {
-        msClipPolygonRect(&shape, map->extent);
-      } else {
-        msClipPolylineRect(&shape, map->extent);
-      }
-      if(shape.numlines == 0) {
-        msFreeShape(&shape);
-        continue;
-      }
-#endif
-      /* Check if the shape size is ok to be drawn, we need to clip */
-      if((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0)) {
-        msTransformShape(&shape, map->extent, map->cellsize, NULL);
-        msComputeBounds(&shape);
-        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          msFreeShape(&shape);
-          continue;
-        }
-      }
-
-      shape.classindex = msShapeGetClass(layer, map, &shape, classgroup, nclasses);
-      if((shape.classindex == -1) || (layer->class[shape.classindex]->status == MS_OFF)) {
-        msFreeShape(&shape);
-        continue;
-      }
-      hittest->classhits[shape.classindex].status = 1;
-      hittest->status = 1;
-
-      if(maxfeatures >=0 && featuresdrawn >= maxfeatures) {
-        msFreeShape(&shape);
-        status = MS_DONE;
-        break;
-      }
-      featuresdrawn++;
-
-      if(annotate && layer->class[shape.classindex]->numlabels > 0) {
-        drawmode |= MS_DRAWMODE_LABELS;
-      }
-
-      status = msHitTestShape(map, layer, &shape, drawmode, &hittest->classhits[shape.classindex]); /* all styles  */
-      msFreeShape(&shape);
-    }
-
-#ifdef USE_GEOS
-    msFreeShape(&searchpoly);
-#endif
-
-    if (classgroup)
-      msFree(classgroup);
-
-    if(status != MS_DONE) {
-      msLayerClose(layer);
-      return MS_FAILURE;
-    }
-    msLayerClose(layer);
-    return MS_SUCCESS;
-
-  } else {
-    /* we don't hittest these layers, skip as they already have been initialised */
-    return MS_SUCCESS;
-  }
-}
-int msHitTestMap(mapObj *map, map_hittest *hittest) {
-  int i,status;
-  map->cellsize = msAdjustExtent(&(map->extent),map->width,map->height);
-  status = msCalculateScale(map->extent,map->units,map->width,map->height, map->resolution, &map->scaledenom);
-  if(status != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-  for(i=0; i<map->numlayers; i++) {
-    layerObj *lp = map->layers[i];
-    status = msHitTestLayer(map,lp,&hittest->layerhits[i]);
-    if(status != MS_SUCCESS) {
-      return MS_FAILURE;
-    }
-  }
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/hittest.h 8.2.0~beta1-1~exp1/hittest.h
--- 8.0.1-5/hittest.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/hittest.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,69 +0,0 @@
-/*****************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Content Dependant Legend rendering support
- * Author:   Thomas Bonfort (tbonfort@terriscope.fr)
- *
- ******************************************************************************
- * Copyright (c) 1996-2013 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-#ifndef HITTEST_H
-#define HITTEST_H
-
-typedef struct {
-  int status;
-} style_hittest;
-
-typedef struct {
-  style_hittest *stylehits;
-  int status;
-} label_hittest;
-
-typedef struct {
-  style_hittest *stylehits;
-  label_hittest *labelhits;
-  int status;
-} class_hittest;
-
-typedef struct {
-  class_hittest *classhits;
-  int status;
-} layer_hittest;
-
-typedef struct map_hittest{
-  layer_hittest *layerhits;
-} map_hittest;
-
-int msHitTestMap(mapObj *map, map_hittest *hittest);
-int msHitTestLayer(mapObj *map, layerObj *layer, layer_hittest *hittest);
-void initStyleHitTests(styleObj *s, style_hittest *sh, int default_status);
-void initLabelHitTests(labelObj *l, label_hittest *lh, int default_status);
-void initClassHitTests(classObj *c, class_hittest *ch, int default_status);
-void initLayerHitTests(layerObj *l, layer_hittest *lh);
-void initMapHitTests(mapObj *map, map_hittest *mh);
-void freeLabelHitTests(labelObj *l, label_hittest *lh);
-void freeClassHitTests(classObj *c, class_hittest *ch);
-void freeLayerHitTests(layerObj *l, layer_hittest *lh);
-void freeMapHitTests(mapObj *map, map_hittest *mh);
-
-#endif
diff -pruN 8.0.1-5/idw.c 8.2.0~beta1-1~exp1/idw.c
--- 8.0.1-5/idw.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/idw.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,76 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Inverse Distance Weighted layer interpolation.
- * Author:   Hermes L. Herrera Martinez and the MapServer team.
- * Thanks:   Thomas Bonfort
- *
- ******************************************************************************
- * Copyright (c) 2014 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include <float.h>
-#define EPSILON 0.000000001
-#include <time.h>
-
-void msIdw(float *xyz, int width, int height, int npoints, interpolationProcessingParams *interpParams, unsigned char *iValues) {
-    int i,j,index;
-    int radius = interpParams->radius;
-    float power = interpParams->power;
-    for (j=0; j < height; j++) {
-        for (i=0; i < width; i++) {
-            double den = EPSILON, num = 0;
-            for(index = 0; index < npoints*3; index += 3){
-                double d = (xyz[index] - i)*(xyz[index] - i)+(xyz[index+1] - j)*(xyz[index+1] - j);
-                if(radius*radius > d) {
-                    double w = 1.0/(pow(d, power) + EPSILON);
-                    num += w*xyz[index+2];
-                    den += w;
-                }
-            }
-            iValues[j*width + i] = num/den;
-        }
-    }
-}
-
-void msIdwProcessing(layerObj *layer, interpolationProcessingParams *interpParams) {
-    const char *interpParamsProcessing = msLayerGetProcessingKey( layer, "IDW_POWER" );
-    if(interpParamsProcessing) {
-        interpParams->power = atof(interpParamsProcessing);
-    } else{
-        interpParams->power = 1.0;
-    }
-
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "IDW_RADIUS" );
-    if(interpParamsProcessing){
-        interpParams->radius = atof(interpParamsProcessing);
-    } else {
-        interpParams->radius = MAX(layer->map->width,layer->map->height);
-    }
-
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "IDW_COMPUTE_BORDERS" );
-    if(interpParamsProcessing && strcasecmp(interpParamsProcessing,"OFF")){
-        interpParams->expand_searchrect = 1;
-    } else {
-        interpParams->expand_searchrect = 0;
-    }
-}
diff -pruN 8.0.1-5/interpolation.c 8.2.0~beta1-1~exp1/interpolation.c
--- 8.0.1-5/interpolation.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/interpolation.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,259 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  KernelDensity layer implementation and related functions.
- * Author:   Hermes L. Herrera and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 2014 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include <float.h>
-
-#include "gdal.h"
-#include "cpl_string.h"
-
-/******************************************************************************
- * kernel density.
- ******************************************************************************/
-void msKernelDensity(imageObj *image, float *values, int width, int height, int npoints,
-                   interpolationProcessingParams *interpParams, unsigned char *iValues);
-void msKernelDensityProcessing(layerObj *layer, interpolationProcessingParams *interpParams);
-
-/******************************************************************************
- * kernel density.
- ******************************************************************************/
-void msIdw(float *xyz, int width, int height, int npoints,
-         interpolationProcessingParams *interpParams, unsigned char *iValues);
-void msIdwProcessing(layerObj *layer, interpolationProcessingParams *interpParams);
-
-//---------------------------------------------------------------------------//
-int msInterpolationDataset(mapObj *map, imageObj *image, layerObj *interpolation_layer, void **hDSvoid, void **cleanup_ptr) {
-
-    int status, layer_idx, i, nclasses=0, npoints=0, length=0;
-    rectObj searchrect;
-    shapeObj shape;
-    layerObj *layer = NULL;
-    float *values = NULL,*xyz_values=NULL;
-    int im_width = image->width, im_height = image->height;
-    double invcellsize = 1.0 / map->cellsize, georadius=0;
-    unsigned char *iValues;
-    GDALDatasetH hDS;
-    interpolationProcessingParams interpParams;
-    int *classgroup = NULL;
-
-    memset(&interpParams, 0, sizeof(interpParams));
-
-    assert(interpolation_layer->connectiontype == MS_KERNELDENSITY ||
-           interpolation_layer->connectiontype == MS_IDW);
-    *cleanup_ptr = NULL;
-
-    if(!interpolation_layer->connection || !*interpolation_layer->connection) {
-        msSetError(MS_MISCERR, "msInterpolationDataset()", "Interpolation layer has no CONNECTION defined");
-        return MS_FAILURE;
-    }
-
-    if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
-        msKernelDensityProcessing(interpolation_layer, &interpParams);
-    } else if(interpolation_layer->connectiontype == MS_IDW) {
-        msIdwProcessing(interpolation_layer, &interpParams);
-    }
-
-    layer_idx = msGetLayerIndex(map, interpolation_layer->connection);
-    if(layer_idx == -1) {
-        int nLayers, *aLayers;
-        aLayers = msGetLayersIndexByGroup(map, interpolation_layer->connection, &nLayers);
-        if(!aLayers || !nLayers) {
-            msSetError(MS_MISCERR, "Interpolation layer (%s) references unknown layer (%s)", "msInterpolationDataset()",
-                       interpolation_layer->name,interpolation_layer->connection);
-            return (MS_FAILURE);
-        }
-        for(i=0; i<nLayers; i++) {
-            layer_idx = aLayers[i];
-            layer = GET_LAYER(map, layer_idx);
-            if(msScaleInBounds(map->scaledenom, layer->minscaledenom, layer->maxscaledenom))
-                break;
-        }
-        free(aLayers);
-        if(i == nLayers) {
-            msSetError(MS_MISCERR, "Interpolation layer (%s) references no layer for current scale", "msInterpolationDataset()",
-                       interpolation_layer->name);
-            return (MS_FAILURE);
-        }
-    } else {
-        layer = GET_LAYER(map, layer_idx);
-    }
-    /* open the linked layer */
-    status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-
-    status = msLayerWhichItems(layer, MS_FALSE, NULL);
-    if(status != MS_SUCCESS) {
-        msLayerClose(layer);
-        return MS_FAILURE;
-    }
-
-    /* identify target shapes */
-    if(layer->transform == MS_TRUE) {
-        searchrect = map->extent;
-        if(interpParams.expand_searchrect) {
-            georadius = interpParams.radius * map->cellsize;
-            searchrect.minx -= georadius;
-            searchrect.miny -= georadius;
-            searchrect.maxx += georadius;
-            searchrect.maxy += georadius;
-            im_width += 2 * interpParams.radius;
-            im_height += 2 * interpParams.radius;
-        }
-    } else {
-        searchrect.minx = searchrect.miny = 0;
-        searchrect.maxx = map->width-1;
-        searchrect.maxy = map->height-1;
-    }
-
-    layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
-    if(layer->project)
-        msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-
-    status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-    /* nothing to do */
-    if(status == MS_SUCCESS) { /* at least one sample may have overlapped */
-
-        if(layer->classgroup && layer->numclasses > 0)
-            classgroup = msAllocateValidClassGroups(layer, &nclasses);
-
-        msInitShape(&shape);
-        while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
-            int l,p,s,c;
-            double weight = 1.0;
-            if(!values){ /* defer allocation until we effectively have a feature */
-                values = (float*) msSmallCalloc(im_width * im_height, sizeof(float));
-                xyz_values = (float*) msSmallCalloc(im_width * im_height, sizeof(float));
-            }
-            if(layer->project)
-                msProjectShape(&layer->projection, &map->projection, &shape);
-
-            /* the weight for the sample is set to 1.0 by default. If the
-            * layer has some classes defined, we will read the weight from
-            * the class->style->size (which can be binded to an attribute)
-            */
-            if(layer->numclasses > 0) {
-                c = msShapeGetClass(layer, map, &shape, classgroup, nclasses);
-                if((c == -1) || (layer->class[c]->status == MS_OFF)) {
-                    goto nextshape; /* no class matched, skip */
-                }
-                for (s = 0; s < layer->class[c]->numstyles; s++) {
-                    if (msScaleInBounds(map->scaledenom,
-                                        layer->class[c]->styles[s]->minscaledenom,
-                                        layer->class[c]->styles[s]->maxscaledenom)) {
-                        if(layer->class[c]->styles[s]->bindings[MS_STYLE_BINDING_SIZE].index != -1) {
-                            weight = atof(shape.values[layer->class[c]->styles[s]->bindings[MS_STYLE_BINDING_SIZE].index]);
-                        } else {
-                            weight = layer->class[c]->styles[s]->size;
-                        }
-                        break;
-                    }
-                }
-                if(s == layer->class[c]->numstyles) {
-                    /* no style in scale bounds */
-                    goto nextshape;
-                }
-            }
-            for(l=0; l<shape.numlines; l++) {
-                for(p=0; p<shape.line[l].numpoints; p++) {
-                    int x = MS_MAP2IMAGE_XCELL_IC(shape.line[l].point[p].x, map->extent.minx - georadius, invcellsize);
-                    int y = MS_MAP2IMAGE_YCELL_IC(shape.line[l].point[p].y, map->extent.maxy + georadius, invcellsize);
-                    if(x>=0 && y>=0 && x<im_width && y<im_height) {
-                        float *value = values + y * im_width + x;
-                        (*value) += weight;
-                        xyz_values[length++] = x;
-                        xyz_values[length++] = y;
-                        xyz_values[length++] = (*value);
-                    }
-                }
-            }
-
-nextshape:
-            msFreeShape(&shape);
-        }
-        //number of layer points.
-        npoints = length/3;
-    } else if(status != MS_DONE) {
-        msLayerClose(layer);
-        return MS_FAILURE;
-    }
-
-    /* status == MS_DONE */
-    msLayerClose(layer);
-    status = MS_SUCCESS;
-
-    if(npoints > 0 && interpParams.expand_searchrect) {
-        iValues = msSmallMalloc(image->width*image->height*sizeof(unsigned char));
-    } else {
-        iValues = msSmallCalloc(1,image->width*image->height*sizeof(unsigned char));
-    }
-
-    if(npoints > 0) { /* no use applying the filtering kernel if we have no samples */
-        if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
-            msKernelDensity(image, values, im_width, im_height, npoints, &interpParams, iValues);
-        } else if(interpolation_layer->connectiontype == MS_IDW) {
-            msIdw(xyz_values, image->width, image->height, npoints, &interpParams, iValues);
-        }
-    }
-
-    free(values);
-    free(xyz_values);
-
-
-    char pointer[64];
-    char ds_string [1024];
-    double adfGeoTransform[6];
-    memset(pointer, 0, sizeof(pointer));
-    CPLPrintPointer(pointer, iValues, sizeof(pointer));
-    snprintf(ds_string,1024,"MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Byte,PIXELOFFSET=1,LINEOFFSET=%d",
-        pointer,image->width,image->height,image->width);
-    hDS = GDALOpenShared( ds_string, GA_ReadOnly );
-    if(hDS == NULL) {
-        msSetError(MS_MISCERR,"msInterpolationDataset()","failed to create in-memory gdal dataset for interpolated data");
-        status = MS_FAILURE;
-        free(iValues);
-    }
-    adfGeoTransform[0] = map->extent.minx - map->cellsize * 0.5; /* top left x */
-    adfGeoTransform[1] = map->cellsize;/* w-e pixel resolution */
-    adfGeoTransform[2] = 0; /* 0 */
-    adfGeoTransform[3] = map->extent.maxy + map->cellsize * 0.5;/* top left y */
-    adfGeoTransform[4] = 0; /* 0 */
-    adfGeoTransform[5] = -map->cellsize;/* n-s pixel resolution (negative value) */
-    GDALSetGeoTransform(hDS,adfGeoTransform);
-    *hDSvoid = hDS;
-    *cleanup_ptr = (void*)iValues;
-
-    return status;
-}
-
-int msCleanupInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer, void *cleanup_ptr) {
-    (void)map;
-    (void)image;
-    (void)layer;
-    free(cleanup_ptr);
-    return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/kerneldensity.c 8.2.0~beta1-1~exp1/kerneldensity.c
--- 8.0.1-5/kerneldensity.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/kerneldensity.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,159 +0,0 @@
-
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  KernelDensity layer implementation and related functions.
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 2014 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include <float.h>
-
-#include "gdal.h"
-
-static
-void gaussian_blur(float *values, int width, int height, int radius) {
-  float *tmp = (float*)msSmallMalloc(width*height*sizeof(float));
-  int length = radius*2+1;
-  float *kernel = (float*)msSmallMalloc(length*sizeof(float));
-  float sigma=radius/3.0;
-	float a=1.0/ sqrt(2.0*M_PI*sigma*sigma);
-	float den=2.0*sigma*sigma;
-	int i,x,y;
-
-	for (i=0; i<length; i++) {
-	  float x=i - radius;
-	  float v=a * exp(-(x*x) / den);
-	  kernel[i]=v;
-	}
-	memset(tmp,0,width*height*sizeof(float));
-
-	for(y=0; y<height; y++) {
-		float* src_row=values + width*y;
-		float* dst_row=tmp + width*y;
-
-		for(x=radius; x<width-radius; x++) {
-			float accum=0;
-			for(i=0; i<length; i++) {
-				accum+=src_row[x+i-radius] * kernel[i];
-			}
-			dst_row[x]=accum;
-		}
-	}
-
-	for(x=0; x<width; x++) {
-		float* src_col=tmp+x;
-		float* dst_col=values+x;
-
-		for(y=radius; y<height-radius; y++) {
-			float accum=0;
-			for (i=0; i<length; i++) {
-				accum+=src_col[width*(y+i-radius)] * kernel[i];
-			}
-			dst_col[y*width]=accum;
-		}
-	}
-  free(tmp);
-  free(kernel);
-}
-
-void msKernelDensityProcessing(layerObj *layer, interpolationProcessingParams *interpParams) {
-    const char *interpParamsProcessing = msLayerGetProcessingKey( layer, "KERNELDENSITY_RADIUS" );
-    if(interpParamsProcessing) {
-        interpParams->radius = atoi(interpParamsProcessing);
-    } else {
-        interpParams->radius = 10;
-    }
-
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "KERNELDENSITY_COMPUTE_BORDERS" );
-    if(interpParamsProcessing && strcasecmp(interpParamsProcessing,"OFF")) {
-        interpParams->expand_searchrect = 1;
-    } else {
-        interpParams->expand_searchrect = 0;
-    }
-
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "KERNELDENSITY_NORMALIZATION" );
-    if(!interpParamsProcessing || !strcasecmp(interpParamsProcessing,"AUTO")) {
-        interpParams->normalization_scale = 0.0;
-    } else {
-        interpParams->normalization_scale = atof(interpParamsProcessing);
-        if(interpParams->normalization_scale != 0) {
-            interpParams->normalization_scale = 1.0 / interpParams->normalization_scale;
-        } else {
-            interpParams->normalization_scale = 1.0;
-        }
-    }
-}
-
-void msKernelDensity(imageObj *image, float *values, int width, int height, int npoints,
-                   interpolationProcessingParams *interpParams, unsigned char *iValues) {
-    int i,j;
-    float valmax=FLT_MIN, valmin=FLT_MAX;
-    int radius = interpParams->radius;
-    float normalization_scale = interpParams->normalization_scale;
-    int expand_searchrect = interpParams->expand_searchrect;
-
-    gaussian_blur(values, width, height, radius);
-
-    if(normalization_scale == 0.0) {   /* auto normalization */
-        for (j = radius; j < height-radius; j++) {
-            for (i = radius; i < width-radius; i++) {
-                float val = values[j*width + i];
-                if(val >0 && val>valmax) {
-                    valmax = val;
-                }
-                if(val>0 && val<valmin) {
-                    valmin = val;
-                }
-            }
-        }
-    } else {
-        valmin = 0;
-        valmax = normalization_scale;
-    }
-
-    if(expand_searchrect) {
-        for (j=0; j < image->height; j++) {
-            for (i=0; i < image->width; i++) {
-                float norm = (values[(j+radius)*width + i + radius] - valmin) / valmax;
-                int v = 255 * norm;
-                if (v<0) v=0;
-                else if (v>255) v = 255;
-                iValues[j*image->width + i] = v;
-            }
-        }
-    } else {
-        if(npoints > 0) {
-            for (j=radius; j < image->height-radius; j++) {
-                for (i=radius; i < image->width-radius; i++) {
-                    float norm=(values[j*width + i] - valmin) / valmax;
-                    int v=255 * norm;
-                    if (v<0) v=0;
-                    else if (v>255) v=255;
-                    iValues[j*image->width + i]=v;
-                }
-            }
-        }
-    }
-}
diff -pruN 8.0.1-5/layerobject.c 8.2.0~beta1-1~exp1/layerobject.c
--- 8.0.1-5/layerobject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/layerobject.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,201 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Functions for operating on a layerObj that don't belong in a
- *           more specific file such as mapfile.c.
- *           Adapted from mapobject.c.
- * Author:   Sean Gillies, sgillies@frii.com
- *
- ******************************************************************************
- * Copyright (c) 2004, Sean Gillies
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-/* ===========================================================================
-   msInsertClass
-
-   Returns the index at which the class was inserted.
-   ======================================================================== */
-
-int msInsertClass(layerObj *layer, classObj *classobj, int nIndex)
-{
-  int i;
-
-  if (!classobj) {
-    msSetError(MS_CHILDERR, "Cannot insert NULL class", "msInsertClass()");
-    return -1;
-  }
-
-  /* Ensure there is room for a new class */
-  if (msGrowLayerClasses(layer) == NULL) {
-    return -1;
-  }
-  /* Catch attempt to insert past end of styles array */
-  else if (nIndex >= layer->numclasses) {
-    msSetError(MS_CHILDERR, "Cannot insert class beyond index %d",
-               "msInsertClass()", layer->numclasses-1);
-    return -1;
-  } else if (nIndex < 0) { /* Insert at the end by default */
-#ifndef __cplusplus
-    layer->class[layer->numclasses]=classobj;
-#else
-    layer->_class[layer->numclasses]=classobj;
-#endif
-    /* set parent pointer */
-    classobj->layer=layer;
-    MS_REFCNT_INCR(classobj);
-    layer->numclasses++;
-    return layer->numclasses-1;
-  } else {
-
-    /* Copy classes existing at the specified nIndex or greater */
-    /* to an index one higher */
-
-#ifndef __cplusplus
-    for (i=layer->numclasses-1; i>=nIndex; i--)
-      layer->class[i+1] = layer->class[i];
-    layer->class[nIndex]=classobj;
-#else
-    for (i=layer->numclasses-1; i>=nIndex; i--)
-      layer->_class[i+1] = layer->_class[i];
-    layer->_class[nIndex]=classobj;
-#endif
-
-    /* set parent pointer */
-    classobj->layer=layer;
-    MS_REFCNT_INCR(classobj);
-    /* increment number of classes and return */
-    layer->numclasses++;
-    return nIndex;
-  }
-}
-
-/* ===========================================================================
-   msRemoveClass
-
-   remove the class at an index from a layer, returning a copy
-   ======================================================================== */
-
-classObj *msRemoveClass(layerObj *layer, int nIndex)
-{
-  int i;
-  classObj *classobj;
-
-  if (nIndex < 0 || nIndex >= layer->numclasses) {
-    msSetError(MS_CHILDERR, "Cannot remove class, invalid index %d",
-               "removeClass()", nIndex);
-    return NULL;
-  } else {
-#ifndef __cplusplus
-    classobj=layer->class[nIndex];
-#else
-    classobj=layer->_class[nIndex];
-#endif
-    classobj->layer=NULL;
-    MS_REFCNT_DECR(classobj);
-
-    /* Iteratively copy the higher index classes down one index */
-    for (i=nIndex; i<layer->numclasses-1; i++) {
-#ifndef __cplusplus
-      layer->class[i]=layer->class[i+1];
-#else
-      layer->_class[i]=layer->_class[i+1];
-#endif
-    }
-#ifndef __cplusplus
-    layer->class[i]=NULL;
-#else
-    layer->_class[i]=NULL;
-#endif
-
-    /* decrement number of layers and return copy of removed layer */
-    layer->numclasses--;
-    return classobj;
-  }
-}
-
-/**
- * Move the class up inside the array of classes.
- */
-int msMoveClassUp(layerObj *layer, int nClassIndex)
-{
-  classObj *psTmpClass = NULL;
-  if (layer && nClassIndex < layer->numclasses && nClassIndex >0) {
-    psTmpClass=layer->class[nClassIndex];
-
-    layer->class[nClassIndex] = layer->class[nClassIndex-1];
-
-    layer->class[nClassIndex-1] = psTmpClass;
-
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveClassUp()",
-             nClassIndex);
-  return (MS_FAILURE);
-}
-
-
-/**
- * Move the class down inside the array of classes.
- */
-int msMoveClassDown(layerObj *layer, int nClassIndex)
-{
-  classObj *psTmpClass = NULL;
-  if (layer && nClassIndex < layer->numclasses-1 && nClassIndex >=0) {
-    psTmpClass=layer->class[nClassIndex];
-
-    layer->class[nClassIndex] = layer->class[nClassIndex+1];
-
-    layer->class[nClassIndex+1] = psTmpClass;
-
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveClassDown()",
-             nClassIndex);
-  return (MS_FAILURE);
-}
-
-/**
- * Set the extent of a layer.
- */
-
-int msLayerSetExtent( layerObj *layer,
-                      double minx, double miny, double maxx, double maxy)
-{
-
-  layer->extent.minx = minx;
-  layer->extent.miny = miny;
-  layer->extent.maxx = maxx;
-  layer->extent.maxy = maxy;
-
-  if (minx == -1.0 && miny == -1.0 && maxx == -1.0 && maxy == -1.0)
-    return(MS_SUCCESS);
-
-  if (!MS_VALID_EXTENT(layer->extent)) {
-    msSetError(MS_MISCERR, "Given layer extent is invalid. minx=%lf, miny=%lf, maxx=%lf, maxy=%lf.", "msLayerSetExtent()", layer->extent.minx, layer->extent.miny, layer->extent.maxx, layer->extent.maxy);
-    return(MS_FAILURE);
-  }
-
-  return(MS_SUCCESS);
-}
diff -pruN 8.0.1-5/legend.c 8.2.0~beta1-1~exp1/legend.c
--- 8.0.1-5/legend.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/legend.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,68 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Mainline of commandline legend generation test utility.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-int main(int argc, char *argv[])
-{
-  mapObj *map=NULL;
-  imageObj *img=NULL;
-
-  msSetup();
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
-    printf("%s\n", msGetVersion());
-    exit(0);
-  }
-
-  if( argc < 3 ) {
-    fprintf(stdout,"Syntax: legend [mapfile] [output image]\n" );
-    exit(0);
-  }
-
-  map = msLoadMap(argv[1], NULL, NULL);
-  if(!map) {
-    msWriteError(stderr);
-    exit(0);
-  }
-
-  img = msDrawLegend(map, MS_FALSE, NULL);
-  if(!img) {
-    msWriteError(stderr);
-    exit(0);
-  }
-
-  msSaveImage(NULL, img, argv[2]);
-
-  msFreeImage(img);
-  msFreeMap(map);
-
-  return(MS_TRUE);
-}
diff -pruN 8.0.1-5/map2img.c 8.2.0~beta1-1~exp1/map2img.c
--- 8.0.1-5/map2img.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/map2img.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,348 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Commandline .map rendering utility, mostly for testing.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <stdbool.h>
-
-#include "mapserver.h"
-#include "maptime.h"
-
-#include "limits.h"
-
-int main(int argc, char *argv[])
-{
-  int i,j,k;
-
-  mapObj         *map=NULL;
-  imageObj         *image = NULL;
-  configObj* config = NULL;
-
-  char **layers=NULL;
-  int num_layers=0;
-
-  int layer_found=0;
-
-  char *outfile=NULL; /* no -o sends image to STDOUT */
-
-  int iterations = 1;
-  int draws = 0;
-
-  /* ---- output version info and exit --- */
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
-    printf("%s\n", msGetVersion());
-    exit(0);
-  }
-  
-  /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 3 ) {
-    fprintf(stdout, "\nPurpose: convert a mapfile to an image\n\n");
-    fprintf(stdout,
-            "Syntax: map2img -m mapfile [-o image] [-e minx miny maxx maxy] [-s sizex sizey]\n"
-            "               [-l \"layer1 [layers2...]\"] [-i format]\n"
-            "               [-all_debug n] [-map_debug n] [-layer_debug n] [-p n] [-c n] [-d layername datavalue]\n"
-            "               [-conf filename]\n");
-    fprintf(stdout,"  -m mapfile: Map file to operate on - required\n" );
-    fprintf(stdout,"  -i format: Override the IMAGETYPE value to pick output format\n" );
-    fprintf(stdout,"  -o image: output filename (stdout if not provided)\n");
-    fprintf(stdout,"  -e minx miny maxx maxy: extents to render\n");
-    fprintf(stdout,"  -s sizex sizey: output image size\n");
-    fprintf(stdout,"  -l layers: layers / groups to enable - make sure they are quoted and space separated if more than one listed\n" );
-    fprintf(stdout,"  -all_debug n: Set debug level for map and all layers\n" );
-    fprintf(stdout,"  -map_debug n: Set map debug level\n" );
-    fprintf(stdout,"  -layer_debug layer_name n: Set layer debug level\n" );
-    fprintf(stdout,"  -c n: draw map n number of times\n" );
-    fprintf(stdout,"  -p n: pause for n seconds after reading the map\n" );
-    fprintf(stdout,"  -d layername datavalue: change DATA value for layer\n" );
-    fprintf(stdout,"  -conf filename: filename of the MapServer configuration file.\n" );
-    exit(0);
-  }
-
-  if ( msSetup() != MS_SUCCESS ) {
-    msWriteError(stderr);
-    exit(1);
-  }
-
-  bool some_debug_requested = FALSE;
-  const char* config_filename = NULL;
-  for(i=1; i<argc; i++) {
-    if (strcmp(argv[i],"-c") == 0) { /* user specified number of draws */
-      iterations = atoi(argv[i+1]);
-      if( iterations < 0 || iterations > INT_MAX - 1 ) {
-        printf("Invalid number of iterations");
-        return 1;
-      }
-      printf("We will draw %d times...\n", iterations);
-      continue;
-    }
-
-    if(i < argc-1 && strcmp(argv[i], "-all_debug") == 0) { /* global debug */
-      int debug_level = atoi(argv[++i]);
-
-      some_debug_requested = TRUE;
-
-      msSetGlobalDebugLevel(debug_level);
-
-      continue;
-    }
-
-    if(i < argc-1 && (strcmp(argv[i], "-map_debug") == 0 ||
-                      strcmp(argv[i], "-layer_debug") == 0)) {
-
-      some_debug_requested = TRUE;
-      continue;
-    }
-
-    if(i < argc-1 && strcmp(argv[i], "-conf") == 0) {
-      config_filename = argv[i+1];
-      ++i;
-      continue;
-    }
-  }
-
-  if( some_debug_requested ) {
-    /* Send output to stderr by default */
-    if (msGetErrorFile() == NULL)
-      msSetErrorFile("stderr", NULL);
-  }
-
-  config = msLoadConfig(config_filename);
-
-  for(draws=0; draws<iterations; draws++) {
-
-    struct mstimeval requeststarttime, requestendtime;
-
-    if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
-      msGettimeofday(&requeststarttime, NULL);
-
-    /* Use PROJ_DATA/PROJ_LIB env vars if set */
-    msProjDataInitFromEnv();
-
-    /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
-    if ( msDebugInitFromEnv() != MS_SUCCESS ) {
-      msWriteError(stderr);
-      msCleanup();
-      msFreeConfig(config);
-      exit(1);
-    }
-
-
-
-    for(i=1; i<argc; i++) { /* Step though the user arguments, 1st to find map file */
-
-      if(strcmp(argv[i],"-m") == 0) {
-        map = msLoadMap(argv[i+1], NULL, config);
-        if(!map) {
-          msWriteError(stderr);
-          msCleanup();
-          msFreeConfig(config);
-          exit(1);
-        }
-        msApplyDefaultSubstitutions(map);
-      }
-    }
-
-    if(!map) {
-      fprintf(stderr, "Mapfile (-m) option not specified.\n");
-      msCleanup();
-      msFreeConfig(config);
-      exit(1);
-    }
-
-
-    for(i=1; i<argc; i++) { /* Step though the user arguments */
-
-      if(strcmp(argv[i],"-m") == 0) { /* skip it */
-        i+=1;
-      }
-
-      if(strcmp(argv[i],"-p") == 0) {
-        int pause_length = atoi(argv[i+1]);
-        time_t start_time = time(NULL);
-
-        printf( "Start pause of %d seconds.\n", pause_length );
-        while( time(NULL) < start_time + pause_length ) {}
-        printf( "Done pause.\n" );
-
-        i+=1;
-      }
-
-      if(strcmp(argv[i],"-o") == 0) { /* load the output image filename */
-        outfile = argv[i+1];
-        i+=1;
-      }
-
-      if(strcmp(argv[i],"-i") == 0) {
-        outputFormatObj *format;
-
-        format = msSelectOutputFormat( map, argv[i+1] );
-
-        if( format == NULL )
-          printf( "No such OUTPUTFORMAT as %s.\n", argv[i+1] );
-        else {
-          msFree( (char *) map->imagetype );
-          map->imagetype = msStrdup( argv[i+1] );
-          msApplyOutputFormat( &(map->outputformat), format, MS_NOOVERRIDE);
-        }
-        i+=1;
-      }
-
-      if(strcmp(argv[i],"-d") == 0) { /* swap layer data */
-        for(j=0; j<map->numlayers; j++) {
-          if(strcmp(GET_LAYER(map, j)->name, argv[i+1]) == 0) {
-            free(GET_LAYER(map, j)->data);
-            GET_LAYER(map, j)->data = msStrdup(argv[i+2]);
-            break;
-          }
-        }
-        i+=2;
-      }
-
-      if(i < argc-1 && strcmp(argv[i], "-all_debug") == 0) { /* global debug */
-        int debug_level = atoi(argv[++i]);
-
-        /* msSetGlobalDebugLevel() already called. Just need to force debug
-         * level in map and all layers
-         */
-        map->debug = debug_level;
-        for(j=0; j<map->numlayers; j++) {
-          GET_LAYER(map, j)->debug = debug_level;
-        }
-
-      }
-
-      if(i < argc-1 && strcmp(argv[i], "-map_debug") == 0) { /* debug */
-        map->debug = atoi(argv[++i]);
-      }
-
-      if(i < argc-1 && strcmp(argv[i], "-layer_debug") == 0) { /* debug */
-        const char *layer_name = argv[++i];
-        int debug_level = atoi(argv[++i]);
-        int got_layer = 0;
-
-        for(j=0; j<map->numlayers; j++) {
-          if(strcmp(GET_LAYER(map, j)->name,layer_name) == 0 ) {
-            GET_LAYER(map, j)->debug = debug_level;
-            got_layer = 1;
-          }
-        }
-        if( !got_layer )
-          fprintf( stderr,
-                   " Did not find layer '%s' from -layer_debug switch.\n",
-                   layer_name );
-      }
-
-      if(strcmp(argv[i],"-e") == 0) { /* change extent */
-        if( argc <= i+4 ) {
-          fprintf( stderr,
-                   "Argument -e needs 4 space separated numbers as argument.\n" );
-          msCleanup();
-          msFreeConfig(config);
-          exit(1);
-        }
-        map->extent.minx = atof(argv[i+1]);
-        map->extent.miny = atof(argv[i+2]);
-        map->extent.maxx = atof(argv[i+3]);
-        map->extent.maxy = atof(argv[i+4]);
-        i+=4;
-      }
-
-      if (strcmp(argv[i], "-s") == 0) {
-        msMapSetSize(map, atoi(argv[i+1]), atoi(argv[i+2]));
-        i+=2;
-      }
-
-      if(strcmp(argv[i],"-l") == 0) { /* load layer list */
-        layers = msStringSplit(argv[i+1], ' ', &(num_layers));
-
-        for(j=0; j<num_layers; j++) { /* loop over -l */
-          layer_found=0;
-          for(k=0; k<map->numlayers; k++) {
-            if((GET_LAYER(map, k)->name && strcasecmp(GET_LAYER(map, k)->name, layers[j]) == 0) || (GET_LAYER(map, k)->group && strcasecmp(GET_LAYER(map, k)->group, layers[j]) == 0)) {
-              layer_found = 1;
-              break;
-            }
-          }
-          if (layer_found==0) {
-            fprintf(stderr, "Layer (-l) \"%s\" not found\n", layers[j]);
-            msCleanup();
-            msFreeConfig(config);
-            exit(1);
-          }
-        }
-
-        for(j=0; j<map->numlayers; j++) {
-          if(GET_LAYER(map, j)->status == MS_DEFAULT)
-            continue;
-          else {
-            GET_LAYER(map, j)->status = MS_OFF;
-            for(k=0; k<num_layers; k++) {
-              if((GET_LAYER(map, j)->name && strcasecmp(GET_LAYER(map, j)->name, layers[k]) == 0) ||
-                  (GET_LAYER(map, j)->group && strcasecmp(GET_LAYER(map, j)->group, layers[k]) == 0)) {
-                GET_LAYER(map, j)->status = MS_ON;
-                break;
-              }
-            }
-          }
-        }
-
-        msFreeCharArray(layers, num_layers);
-
-        i+=1;
-      }
-    }
-
-    image = msDrawMap(map, MS_FALSE);
-
-    if(!image) {
-      msWriteError(stderr);
-
-      msFreeMap(map);
-      msCleanup();
-      msFreeConfig(config);
-      exit(1);
-    }
-
-    if( msSaveImage(map, image, outfile) != MS_SUCCESS ) {
-      msWriteError(stderr);
-    }
-
-    msFreeImage(image);
-    msFreeMap(map);
-
-    if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
-      msGettimeofday(&requestendtime, NULL);
-      msDebug("map2img total time: %.3fs\n",
-              (requestendtime.tv_sec+requestendtime.tv_usec/1.0e6)-
-              (requeststarttime.tv_sec+requeststarttime.tv_usec/1.0e6) );
-    }
-
-  } /*   for(draws=0; draws<iterations; draws++) { */
-  msCleanup();
-  msFreeConfig(config);
-  return(0);
-} /* ---- END Main Routine ---- */
diff -pruN 8.0.1-5/mapagg.cpp 8.2.0~beta1-1~exp1/mapagg.cpp
--- 8.0.1-5/mapagg.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapagg.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1361 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  AGG rendering and other AGG related functions.
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "fontcache.h"
-#include "mapagg.h"
-#include <assert.h>
-#include "renderers/agg/include/agg_color_rgba.h"
-#include "renderers/agg/include/agg_pixfmt_rgba.h"
-#include "renderers/agg/include/agg_renderer_base.h"
-#include "renderers/agg/include/agg_renderer_scanline.h"
-#include "renderers/agg/include/agg_math_stroke.h"
-#include "renderers/agg/include/agg_scanline_p.h"
-#include "renderers/agg/include/agg_scanline_u.h"
-#include "renderers/agg/include/agg_rasterizer_scanline_aa.h"
-#include "renderers/agg/include/agg_span_pattern_rgba.h"
-#include "renderers/agg/include/agg_span_allocator.h"
-#include "renderers/agg/include/agg_span_interpolator_linear.h"
-#include "renderers/agg/include/agg_pattern_filters_rgba.h"
-#include "renderers/agg/include/agg_image_accessors.h"
-#include "renderers/agg/include/agg_conv_stroke.h"
-#include "renderers/agg/include/agg_conv_dash.h"
-#include "renderers/agg/include/agg_font_freetype.h"
-#include "renderers/agg/include/agg_conv_contour.h"
-#include "renderers/agg/include/agg_ellipse.h"
-#include "renderers/agg/include/agg_gamma_functions.h"
-#include "renderers/agg/include/agg_blur.h"
-
-#include "renderers/agg/include/agg_rasterizer_outline_aa.h"
-#include "renderers/agg/include/agg_renderer_outline_aa.h"
-#include "renderers/agg/include/agg_renderer_outline_image.h"
-#include "renderers/agg/include/agg_span_pattern_rgba.h"
-#include "renderers/agg/include/agg_span_image_filter_rgba.h"
-#include "renderers/agg/include/agg_glyph_raster_bin.h"
-#include "renderers/agg/include/agg_renderer_raster_text.h"
-#include "renderers/agg/include/agg_path_storage_integer.h"
-
-#include "renderers/agg/include/agg_conv_clipper.h"
-
-#ifdef USE_PIXMAN
-#include <pixman.h>
-#endif
-
-#include <memory>
-#include <new>
-#include <vector>
-
-typedef mapserver::order_bgra band_order;
-
-#define AGG_LINESPACE 1.33
-
-typedef mapserver::int8u band_type;
-typedef mapserver::rgba8 color_type;
-typedef mapserver::pixel32_type pixel_type;
-
-typedef mapserver::blender_rgba_pre<color_type, band_order> blender_pre;
-typedef mapserver::comp_op_adaptor_rgba_pre<color_type, band_order> compop_blender_pre;
-
-typedef mapserver::pixfmt_alpha_blend_rgba<blender_pre, mapserver::rendering_buffer, pixel_type> pixel_format;
-typedef mapserver::pixfmt_custom_blend_rgba<compop_blender_pre, mapserver::rendering_buffer> compop_pixel_format;
-typedef mapserver::rendering_buffer rendering_buffer;
-typedef mapserver::renderer_base<pixel_format> renderer_base;
-typedef mapserver::renderer_base<compop_pixel_format> compop_renderer_base;
-typedef mapserver::renderer_scanline_aa_solid<renderer_base> renderer_scanline;
-typedef mapserver::renderer_scanline_bin_solid<renderer_base> renderer_scanline_aliased;
-typedef mapserver::rasterizer_scanline_aa<> rasterizer_scanline;
-typedef mapserver::font_engine_freetype_int16 font_engine_type;
-typedef mapserver::font_cache_manager<font_engine_type> font_manager_type;
-typedef mapserver::conv_curve<font_manager_type::path_adaptor_type> font_curve_type;
-typedef mapserver::glyph_raster_bin<color_type> glyph_gen;
-
-static const color_type AGG_NO_COLOR = color_type(0, 0, 0, 0);
-
-#define aggColor(c) mapserver::rgba8_pre((c)->red, (c)->green, (c)->blue, (c)->alpha)
-
-class aggRendererCache
-{
-public:
-  font_engine_type m_feng;
-  font_manager_type m_fman;
-  aggRendererCache(): m_fman(m_feng) {}
-};
-
-class AGG2Renderer
-{
-public:
-  std::vector<band_type> buffer{};
-  rendering_buffer m_rendering_buffer;
-  pixel_format m_pixel_format;
-  compop_pixel_format m_compop_pixel_format;
-  renderer_base m_renderer_base;
-  compop_renderer_base m_compop_renderer_base;
-  renderer_scanline m_renderer_scanline;
-  renderer_scanline_aliased m_renderer_scanline_aliased;
-  rasterizer_scanline m_rasterizer_aa;
-  rasterizer_scanline m_rasterizer_aa_gamma;
-  mapserver::scanline_p8 sl_poly; /*packed scanlines, works faster when the area is larger
-    than the perimeter, in number of pixels*/
-  mapserver::scanline_u8 sl_line; /*unpacked scanlines, works faster if the area is roughly
-    equal to the perimeter, in number of pixels*/
-  bool use_alpha = false;
-  std::unique_ptr<mapserver::conv_stroke<line_adaptor>> stroke{};
-  std::unique_ptr<mapserver::conv_dash<line_adaptor>> dash{};
-  std::unique_ptr<mapserver::conv_stroke<mapserver::conv_dash<line_adaptor> >> stroke_dash{};
-  double default_gamma = 0.0;
-  mapserver::gamma_linear gamma_function;
-};
-
-#define AGG_RENDERER(image) ((AGG2Renderer*) (image)->img.plugin)
-
-template<class VertexSource>
-static void applyCJC(VertexSource &stroke, int caps, int joins)
-{
-  switch (joins) {
-    case MS_CJC_ROUND:
-      stroke.line_join(mapserver::round_join);
-      break;
-    case MS_CJC_MITER:
-      stroke.line_join(mapserver::miter_join);
-      break;
-    case MS_CJC_BEVEL:
-    case MS_CJC_NONE:
-      stroke.line_join(mapserver::bevel_join);
-      break;
-  }
-  switch (caps) {
-    case MS_CJC_BUTT:
-    case MS_CJC_NONE:
-      stroke.line_cap(mapserver::butt_cap);
-      break;
-    case MS_CJC_ROUND:
-      stroke.line_cap(mapserver::round_cap);
-      break;
-    case MS_CJC_SQUARE:
-      stroke.line_cap(mapserver::square_cap);
-      break;
-  }
-}
-
-int agg2RenderLine(imageObj *img, shapeObj *p, strokeStyleObj *style)
-{
-
-  AGG2Renderer *r = AGG_RENDERER(img);
-  line_adaptor lines = line_adaptor(p);
-
-  r->m_rasterizer_aa.reset();
-  r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-  if (style->antialiased== MS_FALSE)
-  {
-    r->m_renderer_scanline_aliased.color(aggColor(style->color));
-  }
-  else
-  {
-    r->m_renderer_scanline.color(aggColor(style->color));
-  }
-
-  if (style->patternlength <= 0) {
-    if(!r->stroke) {
-      r->stroke.reset(new mapserver::conv_stroke<line_adaptor>(lines));
-    } else {
-      r->stroke->attach(lines);
-    }
-    r->stroke->width(style->width);
-    if(style->width>1) {
-      applyCJC(*r->stroke, style->linecap, style->linejoin);
-    } else {
-      r->stroke->inner_join(mapserver::inner_bevel);
-      r->stroke->line_join(mapserver::bevel_join);
-    }
-    r->m_rasterizer_aa.add_path(*r->stroke);
-  } else {
-    if(!r->dash) {
-      r->dash.reset(new mapserver::conv_dash<line_adaptor>(lines));
-    } else {
-      r->dash->remove_all_dashes();
-      r->dash->dash_start(0.0);
-      r->dash->attach(lines);
-    }
-    if(!r->stroke_dash) {
-      r->stroke_dash.reset(new mapserver::conv_stroke<mapserver::conv_dash<line_adaptor> > (*r->dash));
-    } else {
-      r->stroke_dash->attach(*r->dash);
-    }
-    int patt_length = 0;
-    for (int i = 0; i < style->patternlength; i += 2) {
-      if (i < style->patternlength - 1) {
-        r->dash->add_dash(MS_MAX(1,MS_NINT(style->pattern[i])),
-                      MS_MAX(1,MS_NINT(style->pattern[i + 1])));
-        if(style->patternoffset) {
-          patt_length += MS_MAX(1,MS_NINT(style->pattern[i])) +
-                         MS_MAX(1,MS_NINT(style->pattern[i + 1]));
-        }
-      }
-    }
-    if(style->patternoffset > 0) {
-      r->dash->dash_start(patt_length - style->patternoffset);
-    }
-    r->stroke_dash->width(style->width);
-    if(style->width>1) {
-      applyCJC(*r->stroke_dash, style->linecap, style->linejoin);
-    } else {
-      r->stroke_dash->inner_join(mapserver::inner_bevel);
-      r->stroke_dash->line_join(mapserver::bevel_join);
-    }
-    r->m_rasterizer_aa.add_path(*r->stroke_dash);
-  }
-  if (style->antialiased == MS_FALSE)
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline_aliased);
-  else 
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
-  return MS_SUCCESS;
-}
-
-int agg2RenderLineTiled(imageObj *img, shapeObj *p, imageObj * tile)
-{
-
-  mapserver::pattern_filter_bilinear_rgba8 fltr;
-  typedef mapserver::line_image_pattern<mapserver::pattern_filter_bilinear_rgba8> pattern_type;
-  typedef mapserver::renderer_outline_image<renderer_base, pattern_type> renderer_img_type;
-  typedef mapserver::rasterizer_outline_aa<renderer_img_type, mapserver::line_coord_sat> rasterizer_img_type;
-  pattern_type patt(fltr);
-
-  AGG2Renderer *r = AGG_RENDERER(img);
-  AGG2Renderer *tileRenderer = AGG_RENDERER(tile);
-
-  line_adaptor lines(p);
-
-  patt.create(tileRenderer->m_pixel_format);
-  renderer_img_type ren_img(r->m_renderer_base, patt);
-  rasterizer_img_type ras_img(ren_img);
-  ras_img.add_path(lines);
-  return MS_SUCCESS;
-}
-
-int agg2RenderPolygon(imageObj *img, shapeObj *p, colorObj * color)
-{
-  AGG2Renderer *r = AGG_RENDERER(img);
-  polygon_adaptor polygons(p);
-  r->m_rasterizer_aa_gamma.reset();
-  r->m_rasterizer_aa_gamma.filling_rule(mapserver::fill_even_odd);
-  r->m_rasterizer_aa_gamma.add_path(polygons);
-  r->m_renderer_scanline.color(aggColor(color));
-  mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly, r->m_renderer_scanline);
-  return MS_SUCCESS;
-}
-
-static inline double int26p6_to_dbl(int p)
-    {
-        return double(p) / 64.0;
-    }
-
-template<class PathStorage>
-    bool decompose_ft_outline(const FT_Outline& outline,
-                              bool flip_y,
-                              const mapserver::trans_affine& mtx,
-                              PathStorage& path)
-    {
-        double x1, y1, x2, y2, x3, y3;
-
-        FT_Vector*  point;
-        FT_Vector*  limit;
-        char*       tags;
-
-        int   n;         // index of contour in outline
-        int   first;     // index of first point in contour
-        char  tag;       // current point's state
-
-        first = 0;
-
-        for(n = 0; n < outline.n_contours; n++)
-        {
-            int  last;  // index of last point in contour
-
-            last  = outline.contours[n];
-            limit = outline.points + last;
-
-            FT_Vector v_start = outline.points[first];
-
-            FT_Vector v_control = v_start;
-
-            point = outline.points + first;
-            tags  = outline.tags  + first;
-            tag   = FT_CURVE_TAG(tags[0]);
-
-            // A contour cannot start with a cubic control point!
-            if(tag == FT_CURVE_TAG_CUBIC) return false;
-
-            // check first point to determine origin
-            if( tag == FT_CURVE_TAG_CONIC)
-            {
-                const FT_Vector v_last  = outline.points[last];
-
-                // first point is conic control.  Yes, this happens.
-                if(FT_CURVE_TAG(outline.tags[last]) == FT_CURVE_TAG_ON)
-                {
-                    // start at last point if it is on the curve
-                    v_start = v_last;
-                    limit--;
-                }
-                else
-                {
-                    // if both first and last points are conic,
-                    // start at their middle and record its position
-                    // for closure
-                    v_start.x = (v_start.x + v_last.x) / 2;
-                    v_start.y = (v_start.y + v_last.y) / 2;
-                }
-                point--;
-                tags--;
-            }
-
-            x1 = int26p6_to_dbl(v_start.x);
-            y1 = int26p6_to_dbl(v_start.y);
-            if(flip_y) y1 = -y1;
-            mtx.transform(&x1, &y1);
-            path.move_to(x1,y1);
-
-            while(point < limit)
-            {
-                point++;
-                tags++;
-
-                tag = FT_CURVE_TAG(tags[0]);
-                switch(tag)
-                {
-                    case FT_CURVE_TAG_ON:  // emit a single line_to
-                    {
-                        x1 = int26p6_to_dbl(point->x);
-                        y1 = int26p6_to_dbl(point->y);
-                        if(flip_y) y1 = -y1;
-                        mtx.transform(&x1, &y1);
-                        path.line_to(x1,y1);
-                        //path.line_to(conv(point->x), flip_y ? -conv(point->y) : conv(point->y));
-                        continue;
-                    }
-
-                    case FT_CURVE_TAG_CONIC:  // consume conic arcs
-                    {
-                        v_control.x = point->x;
-                        v_control.y = point->y;
-
-                    Do_Conic:
-                        if(point < limit)
-                        {
-                            FT_Vector vec;
-                            FT_Vector v_middle;
-
-                            point++;
-                            tags++;
-                            tag = FT_CURVE_TAG(tags[0]);
-
-                            vec.x = point->x;
-                            vec.y = point->y;
-
-                            if(tag == FT_CURVE_TAG_ON)
-                            {
-                                x1 = int26p6_to_dbl(v_control.x);
-                                y1 = int26p6_to_dbl(v_control.y);
-                                x2 = int26p6_to_dbl(vec.x);
-                                y2 = int26p6_to_dbl(vec.y);
-                                if(flip_y) { y1 = -y1; y2 = -y2; }
-                                mtx.transform(&x1, &y1);
-                                mtx.transform(&x2, &y2);
-                                path.curve3(x1,y1,x2,y2);
-                                continue;
-                            }
-
-                            if(tag != FT_CURVE_TAG_CONIC) return false;
-
-                            v_middle.x = (v_control.x + vec.x) / 2;
-                            v_middle.y = (v_control.y + vec.y) / 2;
-
-                            x1 = int26p6_to_dbl(v_control.x);
-                            y1 = int26p6_to_dbl(v_control.y);
-                            x2 = int26p6_to_dbl(v_middle.x);
-                            y2 = int26p6_to_dbl(v_middle.y);
-                            if(flip_y) { y1 = -y1; y2 = -y2; }
-                            mtx.transform(&x1, &y1);
-                            mtx.transform(&x2, &y2);
-                            path.curve3(x1,y1,x2,y2);
-
-                            //path.curve3(conv(v_control.x),
-                            //            flip_y ? -conv(v_control.y) : conv(v_control.y),
-                            //            conv(v_middle.x),
-                            //            flip_y ? -conv(v_middle.y) : conv(v_middle.y));
-
-                            v_control = vec;
-                            goto Do_Conic;
-                        }
-
-                        x1 = int26p6_to_dbl(v_control.x);
-                        y1 = int26p6_to_dbl(v_control.y);
-                        x2 = int26p6_to_dbl(v_start.x);
-                        y2 = int26p6_to_dbl(v_start.y);
-                        if(flip_y) { y1 = -y1; y2 = -y2; }
-                        mtx.transform(&x1, &y1);
-                        mtx.transform(&x2, &y2);
-                        path.curve3(x1,y1,x2,y2);
-
-                        //path.curve3(conv(v_control.x),
-                        //            flip_y ? -conv(v_control.y) : conv(v_control.y),
-                        //            conv(v_start.x),
-                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
-                        goto Close;
-                    }
-
-                    default:  // FT_CURVE_TAG_CUBIC
-                    {
-                        FT_Vector vec1, vec2;
-
-                        if(point + 1 > limit || FT_CURVE_TAG(tags[1]) != FT_CURVE_TAG_CUBIC)
-                        {
-                            return false;
-                        }
-
-                        vec1.x = point[0].x;
-                        vec1.y = point[0].y;
-                        vec2.x = point[1].x;
-                        vec2.y = point[1].y;
-
-                        point += 2;
-                        tags  += 2;
-
-                        if(point <= limit)
-                        {
-                            FT_Vector vec;
-
-                            vec.x = point->x;
-                            vec.y = point->y;
-
-                            x1 = int26p6_to_dbl(vec1.x);
-                            y1 = int26p6_to_dbl(vec1.y);
-                            x2 = int26p6_to_dbl(vec2.x);
-                            y2 = int26p6_to_dbl(vec2.y);
-                            x3 = int26p6_to_dbl(vec.x);
-                            y3 = int26p6_to_dbl(vec.y);
-                            if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
-                            mtx.transform(&x1, &y1);
-                            mtx.transform(&x2, &y2);
-                            mtx.transform(&x3, &y3);
-                            path.curve4(x1,y1,x2,y2,x3,y3);
-
-                            //path.curve4(conv(vec1.x),
-                            //            flip_y ? -conv(vec1.y) : conv(vec1.y),
-                            //            conv(vec2.x),
-                            //            flip_y ? -conv(vec2.y) : conv(vec2.y),
-                            //            conv(vec.x),
-                            //            flip_y ? -conv(vec.y) : conv(vec.y));
-                            continue;
-                        }
-
-                        x1 = int26p6_to_dbl(vec1.x);
-                        y1 = int26p6_to_dbl(vec1.y);
-                        x2 = int26p6_to_dbl(vec2.x);
-                        y2 = int26p6_to_dbl(vec2.y);
-                        x3 = int26p6_to_dbl(v_start.x);
-                        y3 = int26p6_to_dbl(v_start.y);
-                        if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
-                        mtx.transform(&x1, &y1);
-                        mtx.transform(&x2, &y2);
-                        mtx.transform(&x3, &y3);
-                        path.curve4(x1,y1,x2,y2,x3,y3);
-
-                        //path.curve4(conv(vec1.x),
-                        //            flip_y ? -conv(vec1.y) : conv(vec1.y),
-                        //            conv(vec2.x),
-                        //            flip_y ? -conv(vec2.y) : conv(vec2.y),
-                        //            conv(v_start.x),
-                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
-                        goto Close;
-                    }
-                }
-            }
-
-            path.close_polygon();
-
-       Close:
-            first = last + 1;
-        }
-
-        return true;
-    }
-
-int agg2RenderPolygonTiled(imageObj *img, shapeObj *p, imageObj * tile)
-{
-  assert(img->format->renderer == tile->format->renderer);
-
-  AGG2Renderer *r = AGG_RENDERER(img);
-  AGG2Renderer *tileRenderer = AGG_RENDERER(tile);
-  polygon_adaptor polygons(p);
-  typedef mapserver::wrap_mode_repeat wrap_type;
-  typedef mapserver::image_accessor_wrap<pixel_format,wrap_type,wrap_type> img_source_type;
-  typedef mapserver::span_pattern_rgba<img_source_type> span_gen_type;
-  mapserver::span_allocator<mapserver::rgba8> sa;
-  r->m_rasterizer_aa.reset();
-  r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
-  img_source_type img_src(tileRenderer->m_pixel_format);
-  span_gen_type sg(img_src, 0, 0);
-  r->m_rasterizer_aa.add_path(polygons);
-  mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_base, sa , sg);
-  return MS_SUCCESS;
-}
-
-int agg2RenderGlyphsPath(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow, int /*isMarker*/) {
-    
-  const textPathObj *tp = ts->textpath;
-  mapserver::path_storage glyphs;
-  mapserver::trans_affine trans;
-  AGG2Renderer *r = AGG_RENDERER(img);
-  r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-  for(int i=0; i<tp->numglyphs; i++) {
-    glyphObj *gl  = tp->glyphs + i;
-    trans.reset();
-    trans.rotate(-gl->rot);
-    trans.translate(gl->pnt.x, gl->pnt.y);
-    outline_element *ol = msGetGlyphOutline(gl->face,gl->glyph);
-    if(!ol) {
-      return MS_FAILURE;
-    }
-    decompose_ft_outline(ol->outline,true,trans,glyphs);
-  }
-  mapserver::conv_curve<mapserver::path_storage> m_curves(glyphs);
-  if (oc) {
-    r->m_rasterizer_aa.reset();
-    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-    mapserver::conv_contour<mapserver::conv_curve<mapserver::path_storage> > cc(m_curves);
-    cc.width(ow + 1);
-    r->m_rasterizer_aa.add_path(cc);
-    r->m_renderer_scanline.color(aggColor(oc));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
-  }
-  if(c) {
-    r->m_rasterizer_aa.reset();
-    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-    r->m_rasterizer_aa.add_path(m_curves);
-    r->m_renderer_scanline.color(aggColor(c));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
-  }
-  return MS_SUCCESS;
-}
-
-mapserver::path_storage imageVectorSymbol(symbolObj *symbol)
-{
-  mapserver::path_storage path;
-  int is_new=1;
-
-  for(int i=0; i < symbol->numpoints; i++) {
-    if((symbol->points[i].x == -99) && (symbol->points[i].y == -99))
-      is_new=1;
-
-    else {
-      if(is_new) {
-        path.move_to(symbol->points[i].x,symbol->points[i].y);
-        is_new=0;
-      } else {
-        path.line_to(symbol->points[i].x,symbol->points[i].y);
-      }
-    }
-  }
-  return path;
-}
-
-int agg2RenderVectorSymbol(imageObj *img, double x, double y,
-                           symbolObj *symbol, symbolStyleObj * style)
-{
-  AGG2Renderer *r = AGG_RENDERER(img);
-  double ox = symbol->sizex * 0.5;
-  double oy = symbol->sizey * 0.5;
-
-  mapserver::path_storage path = imageVectorSymbol(symbol);
-  mapserver::trans_affine mtx;
-  mtx *= mapserver::trans_affine_translation(-ox,-oy);
-  mtx *= mapserver::trans_affine_scaling(style->scale);
-  mtx *= mapserver::trans_affine_rotation(-style->rotation);
-  mtx *= mapserver::trans_affine_translation(x, y);
-  path.transform(mtx);
-  if (style->color) {
-    r->m_rasterizer_aa.reset();
-    r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
-    r->m_rasterizer_aa.add_path(path);
-    r->m_renderer_scanline.color(aggColor(style->color));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_scanline);
-  }
-  if(style->outlinecolor) {
-    r->m_rasterizer_aa.reset();
-    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-    r->m_renderer_scanline.color(aggColor(style->outlinecolor));
-    mapserver::conv_stroke<mapserver::path_storage> stroke(path);
-    stroke.width(style->outlinewidth);
-    r->m_rasterizer_aa.add_path(stroke);
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_scanline);
-  }
-  return MS_SUCCESS;
-}
-
-int agg2RenderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
-  AGG2Renderer *r = AGG_RENDERER(img);
-  rasterBufferObj *pixmap = symbol->pixmap_buffer;
-  assert(pixmap->type == MS_BUFFER_BYTE_RGBA);
-  rendering_buffer b(pixmap->data.rgba.pixels,pixmap->width,pixmap->height,pixmap->data.rgba.row_step);
-  pixel_format pf(b);
-
-  r->m_rasterizer_aa.reset();
-  r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-  if ( (style->rotation != 0 && style->rotation != MS_PI*2.)|| style->scale != 1) {
-    mapserver::trans_affine image_mtx;
-    image_mtx *= mapserver::trans_affine_translation(-(pf.width()/2.),-(pf.height()/2.));
-    /*agg angles are antitrigonometric*/
-    image_mtx *= mapserver::trans_affine_rotation(-style->rotation);
-    image_mtx *= mapserver::trans_affine_scaling(style->scale);
-
-
-
-    image_mtx *= mapserver::trans_affine_translation(x,y);
-    image_mtx.invert();
-    typedef mapserver::span_interpolator_linear<> interpolator_type;
-    interpolator_type interpolator(image_mtx);
-    mapserver::span_allocator<color_type> sa;
-
-    // "hardcoded" bilinear filter
-    //------------------------------------------
-    typedef mapserver::span_image_filter_rgba_bilinear_clip<pixel_format, interpolator_type> span_gen_type;
-    span_gen_type sg(pf, mapserver::rgba(0,0,0,0), interpolator);
-    mapserver::path_storage pixmap_bbox;
-    int ims_2 = MS_NINT(MS_MAX(pixmap->width,pixmap->height)*style->scale*1.415)/2+1;
-
-    pixmap_bbox.move_to(x-ims_2,y-ims_2);
-    pixmap_bbox.line_to(x+ims_2,y-ims_2);
-    pixmap_bbox.line_to(x+ims_2,y+ims_2);
-    pixmap_bbox.line_to(x-ims_2,y+ims_2);
-
-    r->m_rasterizer_aa.add_path(pixmap_bbox);
-    mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_base, sa, sg);
-  } else {
-    //just copy the image at the correct location (we place the pixmap on
-    //the nearest integer pixel to avoid blurring)
-    r->m_renderer_base.blend_from(pf,0,MS_NINT(x-pixmap->width/2.),MS_NINT(y-pixmap->height/2.));
-  }
-  return MS_SUCCESS;
-}
-
-int agg2RenderEllipseSymbol(imageObj *image, double x, double y,
-                            symbolObj *symbol, symbolStyleObj * style)
-{
-  AGG2Renderer *r = AGG_RENDERER(image);
-  mapserver::path_storage path;
-  mapserver::ellipse ellipse(x,y,symbol->sizex*style->scale/2,symbol->sizey*style->scale/2);
-  path.concat_path(ellipse);
-  if( style->rotation != 0) {
-    mapserver::trans_affine mtx;
-    mtx *= mapserver::trans_affine_translation(-x,-y);
-    /*agg angles are antitrigonometric*/
-    mtx *= mapserver::trans_affine_rotation(-style->rotation);
-    mtx *= mapserver::trans_affine_translation(x,y);
-    path.transform(mtx);
-  }
-
-  if(style->color) {
-    r->m_rasterizer_aa.reset();
-    r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
-    r->m_rasterizer_aa.add_path(path);
-    r->m_renderer_scanline.color(aggColor(style->color));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
-  }
-  if(style->outlinewidth) {
-    r->m_rasterizer_aa.reset();
-    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-    mapserver::conv_stroke<mapserver::path_storage> stroke(path);
-    stroke.width(style->outlinewidth);
-    r->m_rasterizer_aa.add_path(stroke);
-    r->m_renderer_scanline.color(aggColor(style->outlinecolor));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_scanline);
-  }
-  return MS_SUCCESS;
-}
-
-int agg2RenderTile(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/, double /*y*/)
-{
-  /*
-  AGG2Renderer *imgRenderer = agg2GetRenderer(img);
-  AGG2Renderer *tileRenderer = agg2GetRenderer(tile);
-  */
-  return MS_FAILURE;
-}
-
-int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height, int mode)
-{
-  rb->type = MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.pixel_step = 4;
-  rb->data.rgba.row_step = rb->data.rgba.pixel_step * width;
-  rb->width = width;
-  rb->height = height;
-  int nBytes = rb->data.rgba.row_step * height;
-  rb->data.rgba.pixels = (band_type*)msSmallCalloc(nBytes,sizeof(band_type));
-  rb->data.rgba.r = &(rb->data.rgba.pixels[band_order::R]);
-  rb->data.rgba.g = &(rb->data.rgba.pixels[band_order::G]);
-  rb->data.rgba.b = &(rb->data.rgba.pixels[band_order::B]);
-  if(mode == MS_IMAGEMODE_RGBA) {
-    rb->data.rgba.a = &(rb->data.rgba.pixels[band_order::A]);
-  }
-  return MS_SUCCESS;
-}
-
-
-
-int aggGetRasterBufferHandle(imageObj *img, rasterBufferObj * rb)
-{
-  AGG2Renderer *r = AGG_RENDERER(img);
-  rb->type =MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.pixels = r->buffer.data();
-  rb->data.rgba.row_step = r->m_rendering_buffer.stride();
-  rb->data.rgba.pixel_step = 4;
-  rb->width = r->m_rendering_buffer.width();
-  rb->height = r->m_rendering_buffer.height();
-  rb->data.rgba.r = &(r->buffer[band_order::R]);
-  rb->data.rgba.g = &(r->buffer[band_order::G]);
-  rb->data.rgba.b = &(r->buffer[band_order::B]);
-  if(r->use_alpha)
-    rb->data.rgba.a = &(r->buffer[band_order::A]);
-  else
-    rb->data.rgba.a = NULL;
-  return MS_SUCCESS;
-}
-
-int aggGetRasterBufferCopy(imageObj *img, rasterBufferObj *rb)
-{
-  AGG2Renderer *r = AGG_RENDERER(img);
-  aggInitializeRasterBuffer(rb, img->width, img->height, MS_IMAGEMODE_RGBA);
-  int nBytes = r->m_rendering_buffer.stride()*r->m_rendering_buffer.height();
-  memcpy(rb->data.rgba.pixels,r->buffer.data(), nBytes);
-  return MS_SUCCESS;
-}
-
-
-
-int agg2MergeRasterBuffer(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY,
-                          int dstX, int dstY, int width, int height)
-{
-  assert(overlay->type == MS_BUFFER_BYTE_RGBA);
-  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height, overlay->data.rgba.row_step);
-  pixel_format pf(b);
-  AGG2Renderer *r = AGG_RENDERER(dest);
-  mapserver::rect_base<int> src_rect(srcX,srcY,srcX+width,srcY+height);
-  r->m_renderer_base.blend_from(pf,&src_rect, dstX-srcX, dstY-srcY, unsigned(opacity * 255));
-  return MS_SUCCESS;
-}
-
-/* image i/o */
-imageObj *agg2CreateImage(int width, int height, outputFormatObj *format, colorObj * bg)
-{
-  imageObj *image = NULL;
-  if (format->imagemode != MS_IMAGEMODE_RGB && format->imagemode != MS_IMAGEMODE_RGBA) {
-    msSetError(MS_MISCERR,
-               "AGG2 driver only supports RGB or RGBA pixel models.", "agg2CreateImage()");
-    return image;
-  }
-  if (width > 0 && height > 0) {
-    image = (imageObj *) calloc(1, sizeof (imageObj));
-    MS_CHECK_ALLOC(image, sizeof (imageObj), NULL);
-    AGG2Renderer *r = new AGG2Renderer();
-  
-    /* Compute size on 64bit and check that it is compatible of the platform size_t */
-    AGG_INT64U bufSize64 = (AGG_INT64U)width * height * 4 * sizeof(band_type);
-    size_t bufSize = (size_t)bufSize64;
-    if( (AGG_INT64U)bufSize != bufSize64 ) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating " AGG_INT64U_FRMT " bytes.\n", "agg2CreateImage()",
-                 __FILE__, __LINE__, bufSize64);
-      free(image);
-      delete r;
-      return NULL;
-    }
-
-    try
-    {
-      r->buffer.resize(bufSize / sizeof(band_type));
-    }
-    catch( const std::bad_alloc& ) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating " AGG_INT64U_FRMT " bytes.\n", "agg2CreateImage()",
-                 __FILE__, __LINE__, bufSize64);
-      free(image);
-      delete r;
-      return NULL;
-    }
-    r->m_rendering_buffer.attach(r->buffer.data(), width, height, width * 4);
-    r->m_pixel_format.attach(r->m_rendering_buffer);
-    r->m_compop_pixel_format.attach(r->m_rendering_buffer);
-    r->m_renderer_base.attach(r->m_pixel_format);
-    r->m_compop_renderer_base.attach(r->m_compop_pixel_format);
-    r->m_renderer_scanline.attach(r->m_renderer_base);
-    r->m_renderer_scanline_aliased.attach(r->m_renderer_base);
-    r->default_gamma = atof(msGetOutputFormatOption( format, "GAMMA", "0.75" ));
-    if(r->default_gamma <= 0.0 || r->default_gamma >= 1.0) {
-      r->default_gamma = 0.75;
-    }
-    r->gamma_function.set(0,r->default_gamma);
-    r->m_rasterizer_aa_gamma.gamma(r->gamma_function);
-    if( bg && !format->transparent )
-      r->m_renderer_base.clear(aggColor(bg));
-    else
-      r->m_renderer_base.clear(AGG_NO_COLOR);
-
-    if (!bg || format->transparent || format->imagemode == MS_IMAGEMODE_RGBA ) {
-      r->use_alpha = true;
-    } else {
-      r->use_alpha = false;
-    }
-    image->img.plugin = (void*) r;
-  } else {
-    msSetError(MS_RENDERERERR, "Cannot create cairo image of size %dx%d.",
-               "msImageCreateCairo()", width, height);
-  }
-
-  return image;
-}
-
-int agg2SaveImage(imageObj * /*img*/, mapObj* /*map*/, FILE * /*fp*/, outputFormatObj * /*format*/)
-{
-  
-
-  return MS_FAILURE;
-}
-
-int agg2StartNewLayer(imageObj *img, mapObj* /*map*/, layerObj *layer)
-{
-  AGG2Renderer *r = AGG_RENDERER(img);
-  const char *sgamma = msLayerGetProcessingKey( layer, "GAMMA" );
-  double gamma;
-  if(sgamma) {
-    gamma = atof(sgamma);
-    if(gamma <= 0 || gamma >= 1) gamma = 0.75;
-  } else {
-    gamma = r->default_gamma;
-  }
-  if(r->gamma_function.end() != gamma) {
-    r->gamma_function.end(gamma);
-    r->m_rasterizer_aa_gamma.gamma(r->gamma_function);
-  }
-  return MS_SUCCESS;
-}
-
-int agg2CloseNewLayer(imageObj * /*img*/, mapObj * /*map*/, layerObj * /*layer*/)
-{
-  return MS_SUCCESS;
-}
-
-int agg2FreeImage(imageObj * image)
-{
-  AGG2Renderer *r = AGG_RENDERER(image);
-  delete r;
-  image->img.plugin = NULL;
-  return MS_SUCCESS;
-}
-
-int agg2FreeSymbol(symbolObj * /*symbol*/)
-{
-  return MS_SUCCESS;
-}
-
-int agg2InitCache(void **vcache)
-{
-  aggRendererCache *cache = new aggRendererCache();
-  *vcache = (void*)cache;
-  return MS_SUCCESS;
-}
-
-int agg2Cleanup(void *vcache)
-{
-  aggRendererCache *cache = (aggRendererCache*)vcache;
-  delete cache;
-  return MS_SUCCESS;
-}
-
-
-// ------------------------------------------------------------------------
-// Function to create a custom hatch symbol based on an arbitrary angle.
-// ------------------------------------------------------------------------
-static mapserver::path_storage createHatch(double ox, double oy,
-    double rx, double ry,
-    int sx, int sy, double angle, double step)
-{
-  mapserver::path_storage path;
-  //restrict the angle to [0 180[, i.e ]-pi/2,pi/2] in radians
-  angle = fmod(angle, 360.0);
-  if(angle < 0) angle += 360;
-  if(angle >= 180) angle -= 180;
-
-  //treat 2 easy cases which would cause divide by 0 in generic case
-  if(angle==0) {
-    double y0 = step-fmod(oy-ry,step);
-    if((oy - ry) < 0) {
-      y0 -= step;
-    }
-    for(double y=y0; y<sy; y+=step) {
-      path.move_to(0,y);
-      path.line_to(sx,y);
-    }
-    return path;
-  }
-  if(angle==90) {
-    double x0 = step-fmod(ox-rx,step);
-    if((ox - rx) < 0) {
-      x0 -= step;
-    }
-    for(double x=x0; x<sx; x+=step) {
-      path.move_to(x,0);
-      path.line_to(x,sy);
-    }
-    return path;
-  }
-
-
-  double theta = (90-angle)*MS_DEG_TO_RAD; /* theta in ]-pi/2 , pi/2] */
-  double ct = cos(theta);
-  double st = sin(theta);
-  double invct = 1.0/ct;
-  double invst = 1.0/st;
-  double r0; /* distance from first hatch line to the top-left (if angle in  0,pi/2)
-                  or bottom-left (if angle in -pi/2,0) corner of the hatch bbox */
-  double rmax = sqrt((double)(sx*sx+sy*sy)); /* distance to the furthest hatch we will have to create
-TODO: this could be optimized for bounding boxes where width is very different than height for
-certain hatch angles */
-  double rref= rx*ct + ry*st; /* distance to the line passing through the refpoint, origin is
-                                   (0,0) of the imageObj */
-  double rcorner; /* distance to the line passing through the topleft or bottomleft corner
-                       of the hatch bbox (origin is (0,0) of imageObj) */
-
-  /* calculate the distance from the refpoint to the top right of the path */
-  if(angle < 90) {
-    rcorner = ox*ct + oy*st;
-    r0 = step - fmod(rcorner-rref,step);
-    if(rcorner-rref<0) r0 -= step;
-  } else {
-    rcorner = ox*ct + (oy+sy)*st;
-    r0 = step - fmod(rcorner-rref,step);
-    if(rcorner-rref<0) r0 -= step;
-    st = -st;
-    invst = -invst;
-  }
-
-
-  //parametrize each line as r = x.cos(theta) + y.sin(theta)
-  for(double r=r0; r<rmax; r+=step) {
-    int inter=0;
-    double x,y;
-    double pt[4]; //array to store the coordinates of intersection of the line with the sides
-    //in the general case there will only be two intersections
-    //so pt[4] should be sufficient to store the coordinates of the intersection,
-    //but we allocate pt[8] to treat the special and rare/unfortunate case when the
-    //line is a perfect diagonal (and therfore intersects all four sides)
-    //note that the order for testing is important in this case so that the first
-    //two intersection points actually correspond to the diagonal and not a degenerate line
-
-    //test for intersection with each side
-
-    y=r*invst;
-    x=0; // test for intersection with left of image
-    if(y>=0&&y<=sy) {
-      pt[2*inter]=x;
-      pt[2*inter+1]=y;
-      inter++;
-    }
-    x=sx;
-    y=(r-sx*ct)*invst;// test for intersection with right of image
-    if(y>=0&&y<=sy) {
-      pt[2*inter]=x;
-      pt[2*inter+1]=y;
-      inter++;
-    }
-    if(inter<2) {
-      y=0;
-      x=r*invct;// test for intersection with top of image
-      if(x>=0&&x<=sx) {
-        pt[2*inter]=x;
-        pt[2*inter+1]=y;
-        inter++;
-      }
-    }
-    if(inter<2) {
-      y=sy;
-      x=(r-sy*st)*invct;// test for intersection with bottom of image
-      if(x>=0&&x<=sx) {
-        pt[2*inter]=x;
-        pt[2*inter+1]=y;
-        inter++;
-      }
-    }
-    if(inter==2 && (pt[0]!=pt[2] || pt[1]!=pt[3])) {
-      //the line intersects with two sides of the image, it should therefore be drawn
-      if(angle<90) {
-        path.move_to(pt[0],pt[1]);
-        path.line_to(pt[2],pt[3]);
-      } else {
-        path.move_to(pt[0],sy-pt[1]);
-        path.line_to(pt[2],sy-pt[3]);
-      }
-    }
-  }
-  return path;
-}
-
-template<class VertexSource> int renderPolygonHatches(imageObj *img,VertexSource &clipper, colorObj *color)
-{
-  if(img->format->renderer == MS_RENDER_WITH_AGG) {
-    AGG2Renderer *r = AGG_RENDERER(img);
-    r->m_rasterizer_aa_gamma.reset();
-    r->m_rasterizer_aa_gamma.filling_rule(mapserver::fill_non_zero);
-    r->m_rasterizer_aa_gamma.add_path(clipper);
-    r->m_renderer_scanline.color(aggColor(color));
-    mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly, r->m_renderer_scanline);
-  } else {
-    shapeObj shape;
-    msInitShape(&shape);
-    int allocated = 20;
-    lineObj line;
-    shape.line = &line;
-    shape.numlines = 1;
-    shape.line[0].point = (pointObj*)msSmallCalloc(allocated,sizeof(pointObj));
-    shape.line[0].numpoints = 0;
-    double x=0,y=0;
-    unsigned int cmd;
-    clipper.rewind(0);
-    while((cmd = clipper.vertex(&x,&y)) != mapserver::path_cmd_stop) {
-      switch(cmd) {
-        case mapserver::path_cmd_line_to:
-          if(shape.line[0].numpoints == allocated) {
-            allocated *= 2;
-            shape.line[0].point = (pointObj*)msSmallRealloc(shape.line[0].point, allocated*sizeof(pointObj));
-          }
-          shape.line[0].point[shape.line[0].numpoints].x = x;
-          shape.line[0].point[shape.line[0].numpoints].y = y;
-          shape.line[0].numpoints++;
-          break;
-        case mapserver::path_cmd_move_to:
-          shape.line[0].point[0].x = x;
-          shape.line[0].point[0].y = y;
-          shape.line[0].numpoints = 1;
-          break;
-        case mapserver::path_cmd_end_poly|mapserver::path_flags_close:
-          if(shape.line[0].numpoints > 2) {
-            if(MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(img)->renderPolygon(img,&shape,color))) {
-              free(shape.line[0].point);
-              return MS_FAILURE;
-            }
-          }
-          break;
-        default:
-          assert(0); //WTF?
-      }
-    }
-    free(shape.line[0].point);
-  }
-  return MS_SUCCESS;
-}
-
-int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing, double width, double *pattern, int patternlength, double angle, colorObj *color)
-{
-  assert(MS_RENDERER_PLUGIN(img->format));
-  msComputeBounds(poly);
-
-  /* amount we should expand the bounding box by */
-  double exp = width * 0.7072;
-
-  /* width and height of the bounding box we will be creating the hatch in */
-  int pw=(int)(poly->bounds.maxx-poly->bounds.minx+exp*2)+1;
-  int ph=(int)(poly->bounds.maxy-poly->bounds.miny+exp*2)+1;
-
-  /* position of the top-left corner of the bounding box */
-  double ox = poly->bounds.minx - exp;
-  double oy = poly->bounds.miny - exp;
-
-  //create a rectangular hatch of size pw,ph starting at 0,0
-  //the created hatch is of the size of the shape's bounding box
-  mapserver::path_storage hatch = createHatch(ox,oy,
-                                  img->refpt.x,img->refpt.y,pw,ph,angle,spacing);
-  if(hatch.total_vertices()<=0) return MS_SUCCESS;
-
-  //translate the hatch so it overlaps the current shape
-  hatch.transform(mapserver::trans_affine_translation(ox,oy));
-
-  polygon_adaptor polygons(poly);
-
-
-
-  if(patternlength>1) {
-    //dash the color-hatch and render it clipped by the shape
-    mapserver::conv_dash<mapserver::path_storage > dash(hatch);
-    mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage> > stroke(dash);
-    for (int i=0; i<patternlength; i+=2) {
-      if (i < patternlength-1) {
-        dash.add_dash(pattern[i], pattern[i+1]);
-      }
-    }
-    stroke.width(width);
-    stroke.line_cap(mapserver::butt_cap);
-    mapserver::conv_clipper<polygon_adaptor,mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage> > > clipper(polygons,stroke, mapserver::clipper_and);
-    renderPolygonHatches(img,clipper,color);
-  } else {
-    //render the hatch clipped by the shape
-    mapserver::conv_stroke <mapserver::path_storage > stroke(hatch);
-    stroke.width(width);
-    stroke.line_cap(mapserver::butt_cap);
-    mapserver::conv_clipper<polygon_adaptor,mapserver::conv_stroke<mapserver::path_storage> > clipper(polygons,stroke, mapserver::clipper_and);
-    renderPolygonHatches(img,clipper,color);
-  }
-
-
-  //assert(prevCmd == mapserver::path_cmd_line_to);
-  //delete lines;
-  return MS_SUCCESS;
-}
-
-#ifdef USE_PIXMAN
-static pixman_op_t ms2pixman_compop(CompositingOperation c) {
-  switch(c) {
-    case MS_COMPOP_CLEAR:
-      return PIXMAN_OP_CLEAR;
-    case MS_COMPOP_SRC:
-      return PIXMAN_OP_SRC;
-    case MS_COMPOP_DST:
-      return PIXMAN_OP_DST;
-    case MS_COMPOP_SRC_OVER:
-      return PIXMAN_OP_OVER;
-    case MS_COMPOP_DST_OVER:
-      return PIXMAN_OP_OVER_REVERSE;
-    case MS_COMPOP_SRC_IN:
-      return PIXMAN_OP_IN;
-    case MS_COMPOP_DST_IN:
-      return PIXMAN_OP_IN_REVERSE;
-    case MS_COMPOP_SRC_OUT:
-      return PIXMAN_OP_OUT;
-    case MS_COMPOP_DST_OUT:
-      return PIXMAN_OP_OUT_REVERSE;
-    case MS_COMPOP_SRC_ATOP:
-      return PIXMAN_OP_ATOP;
-    case MS_COMPOP_DST_ATOP:
-      return PIXMAN_OP_ATOP_REVERSE;
-    case MS_COMPOP_XOR:
-      return PIXMAN_OP_XOR;
-    case MS_COMPOP_PLUS:
-      return PIXMAN_OP_ADD;
-    case MS_COMPOP_MULTIPLY:
-      return PIXMAN_OP_MULTIPLY;
-    case MS_COMPOP_SCREEN:
-      return PIXMAN_OP_SCREEN;
-    case MS_COMPOP_OVERLAY:
-      return PIXMAN_OP_OVERLAY;
-    case MS_COMPOP_DARKEN:
-      return PIXMAN_OP_DARKEN;
-    case MS_COMPOP_LIGHTEN:
-      return PIXMAN_OP_LIGHTEN;
-    case MS_COMPOP_COLOR_DODGE:
-      return PIXMAN_OP_COLOR_DODGE;
-    case MS_COMPOP_COLOR_BURN:
-      return PIXMAN_OP_COLOR_DODGE;
-    case MS_COMPOP_HARD_LIGHT:
-      return PIXMAN_OP_HARD_LIGHT;
-    case MS_COMPOP_SOFT_LIGHT:
-      return PIXMAN_OP_SOFT_LIGHT;
-    case MS_COMPOP_DIFFERENCE:
-      return PIXMAN_OP_DIFFERENCE;
-    case MS_COMPOP_EXCLUSION:
-      return PIXMAN_OP_EXCLUSION;
-    case MS_COMPOP_INVERT:
-    case MS_COMPOP_INVERT_RGB:
-    case MS_COMPOP_MINUS:
-    case MS_COMPOP_CONTRAST:
-    default:
-      return PIXMAN_OP_OVER;
-  }
-}
-#else
-static mapserver::comp_op_e ms2agg_compop(CompositingOperation c) {
-  switch(c) {
-    case MS_COMPOP_CLEAR:
-      return mapserver::comp_op_clear;
-    case MS_COMPOP_SRC:
-      return mapserver::comp_op_src;
-    case MS_COMPOP_DST:
-      return mapserver::comp_op_dst;
-    case MS_COMPOP_SRC_OVER:
-      return mapserver::comp_op_src_over;
-    case MS_COMPOP_DST_OVER:
-      return mapserver::comp_op_dst_over;
-    case MS_COMPOP_SRC_IN:
-      return mapserver::comp_op_src_in;
-    case MS_COMPOP_DST_IN:
-      return mapserver::comp_op_dst_in;
-    case MS_COMPOP_SRC_OUT:
-      return mapserver::comp_op_src_out;
-    case MS_COMPOP_DST_OUT:
-      return mapserver::comp_op_dst_out;
-    case MS_COMPOP_SRC_ATOP:
-      return mapserver::comp_op_src_atop;
-    case MS_COMPOP_DST_ATOP:
-      return mapserver::comp_op_dst_atop;
-    case MS_COMPOP_XOR:
-      return mapserver::comp_op_xor;
-    case MS_COMPOP_PLUS:
-      return mapserver::comp_op_plus;
-    case MS_COMPOP_MINUS:
-      return mapserver::comp_op_minus;
-    case MS_COMPOP_MULTIPLY:
-      return mapserver::comp_op_multiply;
-    case MS_COMPOP_SCREEN:
-      return mapserver::comp_op_screen;
-    case MS_COMPOP_OVERLAY:
-      return mapserver::comp_op_overlay;
-    case MS_COMPOP_DARKEN:
-      return mapserver::comp_op_darken;
-    case MS_COMPOP_LIGHTEN:
-      return mapserver::comp_op_lighten;
-    case MS_COMPOP_COLOR_DODGE:
-      return mapserver::comp_op_color_dodge;
-    case MS_COMPOP_COLOR_BURN:
-      return mapserver::comp_op_color_burn;
-    case MS_COMPOP_HARD_LIGHT:
-      return mapserver::comp_op_hard_light;
-    case MS_COMPOP_SOFT_LIGHT:
-      return mapserver::comp_op_soft_light;
-    case MS_COMPOP_DIFFERENCE:
-      return mapserver::comp_op_difference;
-    case MS_COMPOP_EXCLUSION:
-      return mapserver::comp_op_exclusion;
-    case MS_COMPOP_CONTRAST:
-      return mapserver::comp_op_contrast;
-    case MS_COMPOP_INVERT:
-      return mapserver::comp_op_invert;
-    case MS_COMPOP_INVERT_RGB:
-      return mapserver::comp_op_invert_rgb;
-    default:
-      return mapserver::comp_op_src_over;
-  }
-}
-#endif
-
-int aggCompositeRasterBuffer(imageObj *dest, rasterBufferObj *overlay, CompositingOperation comp, int opacity) {
-  assert(overlay->type == MS_BUFFER_BYTE_RGBA);
-  AGG2Renderer *r = AGG_RENDERER(dest);
-#ifdef USE_PIXMAN
-  pixman_image_t *si = pixman_image_create_bits(PIXMAN_a8r8g8b8,overlay->width,overlay->height,
-                       (uint32_t*)overlay->data.rgba.pixels,overlay->data.rgba.row_step);
-  pixman_image_t *bi = pixman_image_create_bits(PIXMAN_a8r8g8b8,dest->width,dest->height,
-                       reinterpret_cast<uint32_t*>(&(r->buffer[0])),dest->width*4);
-  pixman_image_t *alpha_mask_i=NULL, *alpha_mask_i_ptr;
-  pixman_image_set_filter(si,PIXMAN_FILTER_NEAREST, NULL, 0);
-  unsigned char *alpha_mask = NULL;
-    if(opacity > 0) {
-      if(opacity == 100) {
-        alpha_mask_i_ptr = NULL;
-      } else {
-          unsigned char alpha = (unsigned char)(opacity * 2.55);
-          if(!alpha_mask_i) {
-              alpha_mask = (unsigned char*)msSmallMalloc(dest->width * dest->height);
-              alpha_mask_i = pixman_image_create_bits(PIXMAN_a8,dest->width,dest->height,
-                      (uint32_t*)alpha_mask,dest->width);
-          }
-          memset(alpha_mask,alpha,dest->width*dest->height);
-          alpha_mask_i_ptr = alpha_mask_i;
-      }
-      pixman_image_composite (ms2pixman_compop(comp), si, alpha_mask_i_ptr, bi,
-                  0, 0, 0, 0, 0, 0, dest->width,dest->height);
-    }
-  pixman_image_unref(si);
-  pixman_image_unref(bi);
-  if(alpha_mask_i) {
-    pixman_image_unref(alpha_mask_i);
-    msFree(alpha_mask);
-  }
-  return MS_SUCCESS;
-#else
-  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height, overlay->data.rgba.row_step);
-  pixel_format pf(b);
-  mapserver::comp_op_e comp_op = ms2agg_compop(comp);
-  if(comp_op == mapserver::comp_op_src_over) {
-    r->m_renderer_base.blend_from(pf,0,0,0,unsigned(opacity * 2.55));
-  } else {
-    compop_pixel_format pixf(r->m_rendering_buffer);
-    compop_renderer_base ren(pixf);
-    pixf.comp_op(comp_op);
-    ren.blend_from(pf,0,0,0,unsigned(opacity * 2.55));
-  }
-  return MS_SUCCESS;
-#endif
-}
-
-void msApplyBlurringCompositingFilter(rasterBufferObj *rb, unsigned int radius) {
-  rendering_buffer b(rb->data.rgba.pixels, rb->width, rb->height, rb->data.rgba.row_step);
-  pixel_format pf(b);
-  mapserver::stack_blur_rgba32(pf,radius,radius);
-}
-
-int msPopulateRendererVTableAGG(rendererVTableObj * renderer)
-{
-  renderer->compositeRasterBuffer = &aggCompositeRasterBuffer;
-  renderer->supports_pixel_buffer = 1;
-  renderer->use_imagecache = 0;
-  renderer->supports_clipping = 0;
-  renderer->supports_svg = 0;
-  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
-  agg2InitCache(&(MS_RENDERER_CACHE(renderer)));
-  renderer->cleanup = agg2Cleanup;
-  renderer->renderLine = &agg2RenderLine;
-
-  renderer->renderPolygon = &agg2RenderPolygon;
-  renderer->renderPolygonTiled = &agg2RenderPolygonTiled;
-  renderer->renderLineTiled = &agg2RenderLineTiled;
-
-  renderer->renderGlyphs = &agg2RenderGlyphsPath;
-
-  renderer->renderVectorSymbol = &agg2RenderVectorSymbol;
-
-  renderer->renderPixmapSymbol = &agg2RenderPixmapSymbol;
-
-  renderer->renderEllipseSymbol = &agg2RenderEllipseSymbol;
-
-  renderer->renderTile = &agg2RenderTile;
-
-  renderer->getRasterBufferHandle = &aggGetRasterBufferHandle;
-  renderer->getRasterBufferCopy = aggGetRasterBufferCopy;
-  renderer->initializeRasterBuffer = aggInitializeRasterBuffer;
-
-  renderer->mergeRasterBuffer = &agg2MergeRasterBuffer;
-  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
-  renderer->createImage = &agg2CreateImage;
-  renderer->saveImage = &agg2SaveImage;
-
-  renderer->startLayer = &agg2StartNewLayer;
-  renderer->endLayer = &agg2CloseNewLayer;
-
-  renderer->freeImage = &agg2FreeImage;
-  renderer->freeSymbol = &agg2FreeSymbol;
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapagg.h 8.2.0~beta1-1~exp1/mapagg.h
--- 8.0.1-5/mapagg.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapagg.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,152 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  AGG template library types.
- * Author:   John Novak (jnovak@novacell.com)
- * Author:   Thomas Bonfort (tbonfort@terriscope.fr)
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ******************************************************************************/
-
-#include "renderers/agg/include/agg_path_storage.h"
-
-/*
- * interface to a shapeObj representing lines, providing the functions
- * needed by the agg rasterizer. treats shapeObjs with multiple linestrings.
- */
-class line_adaptor
-{
-public:
-  explicit line_adaptor(shapeObj *shape):s(shape) {
-    m_line=s->line; /*first line*/
-    m_point=m_line->point; /*current vertex is first vertex of first line*/
-    m_lend=&(s->line[s->numlines]); /*pointer to after last line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of first line*/
-  }
-
-  /* a class with virtual functions should also provide a virtual destructor */
-  virtual ~line_adaptor() {}
-
-  void rewind(unsigned) {
-    m_line=s->line; /*first line*/
-    m_point=m_line->point; /*current vertex is first vertex of first line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of first line*/
-  }
-
-  virtual unsigned vertex(double* x, double* y) {
-    if(m_point < m_pend) {
-      /*here we treat the case where a real vertex is returned*/
-      bool first = m_point == m_line->point; /*is this the first vertex of a line*/
-      *x = m_point->x;
-      *y = m_point->y;
-      m_point++;
-      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
-    }
-    /*if here, we're at the end of a line*/
-    m_line++;
-    *x = *y = 0.0;
-    if(m_line>=m_lend) /*is this the last line of the shapObj. normally,
-        (m_line==m_lend) should be a sufficient test, as the caller should not call
-        this function if a previous call returned path_cmd_stop.*/
-      return mapserver::path_cmd_stop; /*no more points to process*/
-
-    /*if here, there are more lines in the shapeObj, continue with next one*/
-    m_point=m_line->point; /*pointer to first point of next line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last point of next line*/
-
-    return vertex(x,y); /*this will return the first point of the next line*/
-  }
-protected:
-  shapeObj *s;
-  lineObj *m_line, /*current line pointer*/
-          *m_lend; /*points to after the last line*/
-  pointObj *m_point, /*current point*/
-           *m_pend; /*points to after last point of current line*/
-};
-
-
-class polygon_adaptor
-{
-public:
-  explicit polygon_adaptor(shapeObj *shape):s(shape) {
-    m_line=s->line; /*first lines*/
-    m_point=m_line->point; /*first vertex of first line*/
-    m_lend=&(s->line[s->numlines]); /*pointer to after last line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of first line*/
-  }
-
-  /* a class with virtual functions should also provide a virtual destructor */
-  virtual ~polygon_adaptor() {}
-
-  void rewind(unsigned) {
-    /*reset pointers*/
-    m_stop=false;
-    m_line=s->line;
-    m_point=m_line->point;
-    m_pend=&(m_line->point[m_line->numpoints]);
-  }
-
-  virtual unsigned vertex(double* x, double* y) {
-    if(m_point < m_pend) {
-      /*if here, we have a real vertex*/
-      bool first = m_point == m_line->point;
-      *x = m_point->x;
-      *y = m_point->y;
-      m_point++;
-      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
-    }
-    *x = *y = 0.0;
-    if(!m_stop) {
-      /*if here, we're after the last vertex of the current line
-       * we return the command to close the current polygon*/
-      m_line++;
-      if(m_line>=m_lend) {
-        /*if here, we've finished all the vertexes of the shape.
-         * we still return the command to close the current polygon,
-         * but set m_stop so the subsequent call to vertex() will return
-         * the stop command*/
-        m_stop=true;
-        return mapserver::path_cmd_end_poly;
-      }
-      /*if here, there's another line in the shape, so we set the pointers accordingly
-       * and return the command to close the current polygon*/
-      m_point=m_line->point; /*first vertex of next line*/
-      m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of next line*/
-      return mapserver::path_cmd_end_poly;
-    }
-    /*if here, a previous call to vertex informed us that we'd consumed all the vertexes
-     * of the shape. return the command to stop processing this shape*/
-    return mapserver::path_cmd_stop;
-  }
-protected:
-  shapeObj *s;
-  double ox = 0.0;
-  double oy = 0.0;
-  lineObj *m_line, /*pointer to current line*/
-          *m_lend; /*pointer to after last line of the shape*/
-  pointObj *m_point, /*pointer to current vertex*/
-           *m_pend; /*pointer to after last vertex of current line*/
-  bool m_stop = false; /*should next call return stop command*/
-};
-
-mapserver::path_storage imageVectorSymbol(symbolObj *);
diff -pruN 8.0.1-5/mapaxisorder.h 8.2.0~beta1-1~exp1/mapaxisorder.h
--- 8.0.1-5/mapaxisorder.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapaxisorder.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,4140 +0,0 @@
-/******************************************************************************
- * $Id: $
- *
- * Project:  MapServer
- * Purpose:  Axis lookup table
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
- 
-/*
- * Generated file
- *
- * This file was generated from by means of a script. Do not edit manually.
- */
- 
-#ifdef __cplusplus
-extern "C" {
-#endif
- 
-static const unsigned char axisOrientationEpsgCodes[] = {
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0
-};
- 
-#ifdef __cplusplus
-}
-#endif
diff -pruN 8.0.1-5/mapbits.c 8.2.0~beta1-1~exp1/mapbits.c
--- 8.0.1-5/mapbits.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapbits.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,118 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of bit array functions.
- * Author:   Steve Lime and the MapServer team.
- *
- * Notes: Derived from code placed in the public domain by Bob Stout, for more
- * information see http://c.snippets.org/snip_lister.php?fname=bitarray.c.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
-
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-#include <limits.h>
-
-/*
- * Hardcoded size of our bit array.
- * See function msGetNextBit for another hardcoded value.
- */
-
-/* #define msGetBit(array, index) (*((array) + (index)/MS_ARRAY_BIT) & ( 1 << ((index) % MS_ARRAY_BIT))) */
-
-size_t msGetBitArraySize(int numbits)
-{
-  return((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT);
-}
-
-ms_bitarray msAllocBitArray(int numbits)
-{
-  ms_bitarray array = calloc((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT, MS_ARRAY_BIT);
-
-  return(array);
-}
-
-int msGetBit(ms_const_bitarray array, int index)
-{
-  array += index / MS_ARRAY_BIT;
-  return (*array & (1U << (index % MS_ARRAY_BIT))) != 0;    /* 0 or 1 */
-}
-
-/*
-** msGetNextBit( status, start, size)
-**
-** Quickly find the next bit set. If start == 0 and 0 is set, will return 0.
-** If hits end of bitmap without finding set bit, will return -1.
-**
-*/
-int msGetNextBit(ms_const_bitarray array, int i, int size)
-{
-
-  register ms_uint32 b;
-
-  while(i < size) {
-    b = *(array + (i/MS_ARRAY_BIT));
-    if( b && (b >> (i % MS_ARRAY_BIT)) ) {
-      /* There is something in this byte */
-      /* And it is not to the right of us */
-      if( b & ( 1U << (i % MS_ARRAY_BIT)) ) {
-        /* There is something at this bit! */
-        return i;
-      } else {
-        i++;
-      }
-    } else {
-      /* Nothing in this byte, move to start of next byte */
-      i += MS_ARRAY_BIT - (i % MS_ARRAY_BIT);
-    }
-  }
-
-  /* Got to the last byte with no hits! */
-  return -1;
-}
-
-void msSetBit(ms_bitarray array, int index, int value)
-{
-  array += index / MS_ARRAY_BIT;
-  if (value)
-    *array |= 1U << (index % MS_ARRAY_BIT);           /* set bit */
-  else
-    *array &= ~(1U << (index % MS_ARRAY_BIT));        /* clear bit */
-}
-
-void msSetAllBits(ms_bitarray array, int numbits, int value)
-{
-  if (value)
-    memset(array, 0xff, ((numbits + 7) / 8) ); /* set bit */
-  else
-    memset(array, 0x0,  ((numbits + 7) / 8) ); /* clear bit */
-}
-
-void msFlipBit(ms_bitarray array, int index)
-{
-  array += index / MS_ARRAY_BIT;
-  *array ^= 1U << (index % MS_ARRAY_BIT);                   /* flip bit */
-}
diff -pruN 8.0.1-5/mapcairo.c 8.2.0~beta1-1~exp1/mapcairo.c
--- 8.0.1-5/mapcairo.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcairo.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1235 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Cairo Rendering functions
- * Author:   Thomas Bonfort
- *
- ******************************************************************************
- * Copyright (c) 1996-2009 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-#include "mapserver.h"
-
-#ifdef USE_CAIRO
-
-#include <cairo.h>
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#include <cairo-pdf.h>
-#include <cairo-svg.h>
-#include <cairo-win32.h>
-#else
-#include <cairo/cairo-pdf.h>
-#include <cairo/cairo-svg.h>
-#endif
-
-#ifdef USE_SVG_CAIRO
-#include <svg-cairo.h>
-#else
-#ifdef USE_RSVG
-  #include <librsvg/rsvg.h>
-  #ifndef LIBRSVG_CHECK_VERSION
-    #include <librsvg/librsvg-features.h>
-  #endif
-  #ifndef RSVG_CAIRO_H
-    #include <librsvg/rsvg-cairo.h>
-  #endif
-  #include <glib-object.h>
-#endif
-#endif
-
-#include <cpl_string.h>
-#include "cpl_conv.h"
-#include <gdal.h>
-
-#include "fontcache.h"
-
-# include <cairo-ft.h>
-/*
-#include <pango/pangocairo.h>
-#include <glib.h>
-*/
-#include <string.h>
-/*
-#include <ft2build.h>
-#include FT_FREETYPE_H
-*/
-
-typedef struct cairoFaceCache cairoFaceCache;
-struct cairoFaceCache {
-  cairo_font_face_t *face;
-  FT_Face ftface;
-  cairo_font_options_t *options;
-  cairoFaceCache *next;
-};
-
-void freeCairoFaceCache(cairoFaceCache *fc) {
-  cairo_font_face_destroy(fc->face);
-  cairo_font_options_destroy(fc->options);
-}
-
-typedef struct {
-  cairoFaceCache *cairofacecache;
-  /* dummy surface and context */
-  unsigned char dummydata[4];
-  cairo_surface_t *dummysurface;
-  cairo_t *dummycr;
-} cairoCacheData;
-
-void initializeCache(void **vcache)
-{
-  cairoCacheData *cache = (cairoCacheData*)malloc(sizeof(cairoCacheData));
-  *vcache = cache;
-
-  cache->cairofacecache = NULL;
-  /* dummy surface and context */
-  cache->dummysurface = cairo_image_surface_create_for_data(cache->dummydata, CAIRO_FORMAT_ARGB32, 1,1,4);
-  cache->dummycr = cairo_create(cache->dummysurface);
-}
-
-int cleanupCairo(void *cache)
-{
-  cairoCacheData *ccache = (cairoCacheData*)cache;
-
-  if(ccache->dummycr) {
-    cairo_destroy(ccache->dummycr);
-  }
-  if(ccache->dummysurface) {
-    cairo_surface_destroy(ccache->dummysurface);
-  }
-  if(ccache->cairofacecache) {
-    cairoFaceCache *next,*cur;
-    cur = ccache->cairofacecache;
-    do {
-      next = cur->next;
-      freeCairoFaceCache(cur);
-      free(cur);
-      cur=next;
-    } while(cur);
-  }
-
-  free(ccache);
-  return MS_SUCCESS;
-}
-
-
-
-
-
-typedef struct {
-  cairo_surface_t *surface;
-  cairo_t *cr;
-  bufferObj *outputStream;
-  int use_alpha;
-} cairo_renderer;
-
-
-#define CAIRO_RENDERER(im) ((cairo_renderer*)(im->img.plugin))
-
-
-int freeImageCairo(imageObj *img)
-{
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  if(r) {
-    cairo_destroy(r->cr);
-    cairo_surface_finish(r->surface);
-    cairo_surface_destroy(r->surface);
-    if(r->outputStream) {
-      msBufferFree(r->outputStream);
-      free(r->outputStream);
-    }
-    free(r);
-  }
-  return MS_SUCCESS;
-}
-
-static cairoFaceCache* getCairoFontFace(cairoCacheData *cache, FT_Face ftface) {
-  cairoFaceCache *cur = cache->cairofacecache;
-  while(cur) {
-    if(cur->ftface == ftface) return cur;
-    cur = cur->next;
-  }
-  cur = msSmallMalloc(sizeof(cairoFaceCache));
-  cur->next = cache->cairofacecache;
-  cache->cairofacecache = cur;
-  cur->ftface = ftface;
-  cur->face = cairo_ft_font_face_create_for_ft_face(ftface, 0);
-  cur->options = cairo_font_options_create();
-  cairo_font_options_set_hint_style(cur->options,CAIRO_HINT_STYLE_NONE);
-  return cur;
-}
-
-#define msCairoSetSourceColor(cr, c) cairo_set_source_rgba((cr),(c)->red/255.0,(c)->green/255.0,(c)->blue/255.0,(c)->alpha/255.0);
-
-int renderLineCairo(imageObj *img, shapeObj *p, strokeStyleObj *stroke)
-{
-  int i,j;
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  assert(stroke->color);
-  cairo_new_path(r->cr);
-  msCairoSetSourceColor(r->cr,stroke->color);
-  for(i=0; i<p->numlines; i++) {
-    lineObj *l = &(p->line[i]);
-    if(l->numpoints == 0) continue;
-    cairo_move_to(r->cr,l->point[0].x,l->point[0].y);
-    for(j=1; j<l->numpoints; j++) {
-      cairo_line_to(r->cr,l->point[j].x,l->point[j].y);
-    }
-  }
-  if(stroke->patternlength>0) {
-    cairo_set_dash(r->cr,stroke->pattern,stroke->patternlength,-stroke->patternoffset);
-  }
-  switch(stroke->linecap) {
-    case MS_CJC_BUTT:
-      cairo_set_line_cap(r->cr,CAIRO_LINE_CAP_BUTT);
-      break;
-    case MS_CJC_SQUARE:
-      cairo_set_line_cap(r->cr,CAIRO_LINE_CAP_SQUARE);
-      break;
-    case MS_CJC_ROUND:
-    case MS_CJC_NONE:
-    default:
-      cairo_set_line_cap(r->cr,CAIRO_LINE_CAP_ROUND);
-  }
-  cairo_set_line_width (r->cr, stroke->width);
-  cairo_stroke (r->cr);
-  if(stroke->patternlength>0) {
-    cairo_set_dash(r->cr,stroke->pattern,0,0);
-  }
-  return MS_SUCCESS;
-}
-
-int renderPolygonCairo(imageObj *img, shapeObj *p, colorObj *c)
-{
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  int i,j;
-  cairo_new_path(r->cr);
-  cairo_set_fill_rule(r->cr,CAIRO_FILL_RULE_EVEN_ODD);
-  msCairoSetSourceColor(r->cr,c);
-  for(i=0; i<p->numlines; i++) {
-    lineObj *l = &(p->line[i]);
-    cairo_move_to(r->cr,l->point[0].x,l->point[0].y);
-    for(j=1; j<l->numpoints; j++) {
-      cairo_line_to(r->cr,l->point[j].x,l->point[j].y);
-    }
-    cairo_close_path(r->cr);
-  }
-  cairo_fill(r->cr);
-  return MS_SUCCESS;
-}
-
-int renderPolygonTiledCairo(imageObj *img, shapeObj *p,  imageObj *tile)
-{
-  int i,j;
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  cairo_renderer *tileRenderer = CAIRO_RENDERER(tile);
-  cairo_pattern_t *pattern = cairo_pattern_create_for_surface(tileRenderer->surface);
-  cairo_pattern_set_extend(pattern, CAIRO_EXTEND_REPEAT);
-
-  cairo_set_source(r->cr, pattern);
-  for (i = 0; i < p->numlines; i++) {
-    lineObj *l = &(p->line[i]);
-    cairo_move_to(r->cr, l->point[0].x, l->point[0].y);
-    for (j = 1; j < l->numpoints; j++) {
-      cairo_line_to(r->cr, l->point[j].x, l->point[j].y);
-    }
-    /* cairo_close_path(r->cr); */
-  }
-  cairo_fill(r->cr);
-  cairo_pattern_destroy(pattern);
-  return MS_SUCCESS;
-}
-
-cairo_surface_t *createSurfaceFromBuffer(rasterBufferObj *b)
-{
-  assert(b->type == MS_BUFFER_BYTE_RGBA);
-  return cairo_image_surface_create_for_data (b->data.rgba.pixels,
-         CAIRO_FORMAT_ARGB32,
-         b->width,
-         b->height,
-         b->data.rgba.row_step);
-}
-
-
-int renderPixmapSymbolCairo(imageObj *img, double x, double y,symbolObj *symbol,
-                            symbolStyleObj *style)
-{
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  cairo_surface_t *im;
-  rasterBufferObj *b = symbol->pixmap_buffer;
-  assert(b);
-  if(!symbol->renderer_cache) {
-    symbol->renderer_cache = (void*)createSurfaceFromBuffer(b);
-  }
-  assert(symbol->renderer_cache);
-  im=(cairo_surface_t*)symbol->renderer_cache;
-  cairo_save(r->cr);
-  if(style->rotation != 0 || style->scale != 1) {
-    cairo_translate (r->cr, x,y);
-    cairo_rotate (r->cr, -style->rotation);
-    cairo_scale  (r->cr, style->scale,style->scale);
-    cairo_translate (r->cr, -0.5*b->width, -0.5*b->height);
-  } else {
-    cairo_translate (r->cr, MS_NINT(x-0.5*b->width),MS_NINT(y-0.5*b->height));
-  }
-  cairo_set_source_surface (r->cr, im, 0, 0);
-  cairo_paint (r->cr);
-  cairo_restore(r->cr);
-  return MS_SUCCESS;
-}
-
-int renderVectorSymbolCairo(imageObj *img, double x, double y, symbolObj *symbol,
-                            symbolStyleObj *style)
-{
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  double ox=symbol->sizex*0.5,oy=symbol->sizey*0.5;
-  int is_new = 1,i;
-  cairo_new_path(r->cr);
-  cairo_save(r->cr);
-  cairo_translate(r->cr,x,y);
-  cairo_scale(r->cr,style->scale,style->scale);
-  cairo_rotate(r->cr,-style->rotation);
-  cairo_translate(r->cr,-ox,-oy);
-  for (i = 0; i < symbol->numpoints; i++) {
-    if ((symbol->points[i].x == -99) && (symbol->points[i].y == -99)) { /* (PENUP) */
-      is_new = 1;
-    } else {
-      if (is_new) {
-        cairo_move_to(r->cr,symbol->points[i].x,symbol->points[i].y);
-        is_new = 0;
-      } else {
-        cairo_line_to(r->cr,symbol->points[i].x,symbol->points[i].y);
-      }
-    }
-  }
-  cairo_restore(r->cr);
-  if(style->color) {
-    msCairoSetSourceColor(r->cr,style->color);
-    cairo_fill_preserve(r->cr);
-  }
-  if(style->outlinewidth>0) {
-    msCairoSetSourceColor(r->cr,style->outlinecolor);
-    cairo_set_line_width (r->cr, style->outlinewidth);
-    cairo_stroke_preserve(r->cr);
-  }
-  cairo_new_path(r->cr);
-  return MS_SUCCESS;
-}
-
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-struct svg_symbol_cache {
-  rasterBufferObj *pixmap_buffer;
-#ifdef USE_RSVG
-  RsvgHandle *svgc;
-#else
-  svg_cairo_t *svgc;
-#endif
-  double scale,rotation;
-} ;
-#endif
-
-int renderSVGSymbolCairo(imageObj *img, double x, double y, symbolObj *symbol,
-                         symbolStyleObj *style)
-{
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-  struct svg_symbol_cache *cache;
-  cairo_renderer *r = CAIRO_RENDERER(img);
-
-
-
-  msPreloadSVGSymbol(symbol);
-  assert(symbol->renderer_cache);
-  cache = symbol->renderer_cache;
-
-  cairo_save(r->cr);
-  cairo_translate(r->cr,x,y);
-  cairo_scale(r->cr,style->scale,style->scale);
-
-  if (style->rotation != 0) {
-    cairo_rotate(r->cr, -style->rotation);
-    cairo_translate (r->cr, -(int)(symbol->sizex/2), -(int)(symbol->sizey/2));
-  } else
-    cairo_translate (r->cr, -(int)(symbol->sizex/2), -(int)(symbol->sizey/2));
-
-#ifdef USE_SVG_CAIRO
-  {
-    svg_cairo_status_t status;
-    status = svg_cairo_render(cache->svgc, r->cr);
-    if(status != SVG_CAIRO_STATUS_SUCCESS) {
-      cairo_restore(r->cr);
-      return MS_FAILURE;
-    }
-  }
-#else
-  rsvg_handle_render_cairo(cache->svgc, r->cr);
-#endif
-
-  cairo_restore(r->cr);
-
-  return MS_SUCCESS;
-
-
-#else
-  msSetError(MS_MISCERR, "SVG Symbols requested but is not built with libsvgcairo",
-             "renderSVGSymbolCairo()");
-  return MS_FAILURE;
-#endif
-}
-
-int renderTileCairo(imageObj *img, imageObj *tile, double x, double y)
-{
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  cairo_surface_t *im = CAIRO_RENDERER(tile)->surface;
-  int w = cairo_image_surface_get_width (im);
-  int h = cairo_image_surface_get_height (im);
-  cairo_save(r->cr);
-  cairo_translate(r->cr, MS_NINT(x-0.5 * w), MS_NINT(y -0.5 * h));
-  cairo_set_source_surface(r->cr, im, 0, 0);
-  cairo_pattern_set_filter (cairo_get_source (r->cr), CAIRO_FILTER_NEAREST);
-  cairo_paint(r->cr);
-  cairo_restore(r->cr);
-  return MS_SUCCESS;
-}
-
-int renderGlyphs2Cairo(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow, int isMarker) {
-  const textPathObj *tp = ts->textpath;
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  cairoCacheData *cache = MS_IMAGE_RENDERER_CACHE(img);
-  cairoFaceCache *cairo_face = NULL;
-  FT_Face prevface = NULL;
-  int g;
-  (void)isMarker;
-
-  cairo_set_font_size(r->cr,MS_NINT(tp->glyph_size * 96.0/72.0));
-  for(g=0;g<tp->numglyphs;g++) {
-    glyphObj *gl = &tp->glyphs[g];
-    cairo_glyph_t glyph;
-    /* load the glyph's face into cairo, if not already present */
-    if(gl->face->face != prevface) {
-      cairo_face = getCairoFontFace(cache,gl->face->face);
-      cairo_set_font_face(r->cr, cairo_face->face);
-      cairo_set_font_options(r->cr,cairo_face->options);
-      prevface = gl->face->face;
-      cairo_set_font_size(r->cr,MS_NINT(tp->glyph_size * 96.0/72.0));
-    }
-    cairo_save(r->cr);
-    cairo_translate(r->cr,gl->pnt.x,gl->pnt.y);
-    if(gl->rot != 0.0)
-      cairo_rotate(r->cr, -gl->rot);
-    glyph.x = glyph.y = 0;
-    glyph.index = gl->glyph->key.codepoint;
-    cairo_glyph_path(r->cr,&glyph,1);
-    cairo_restore(r->cr);
-  }
-  if (oc) {
-    cairo_save(r->cr);
-    msCairoSetSourceColor(r->cr, oc);
-    cairo_set_line_width(r->cr, ow + 1);
-    cairo_stroke_preserve(r->cr);
-    cairo_restore(r->cr);
-  }
-  if(c) {
-    msCairoSetSourceColor(r->cr, c);
-    cairo_fill(r->cr);
-  }
-  cairo_new_path(r->cr);
-  return MS_SUCCESS;
-}
-
-cairo_status_t _stream_write_fn(void *b, const unsigned char *data, unsigned int length)
-{
-  msBufferAppend((bufferObj*)b,(void*)data,length);
-  return CAIRO_STATUS_SUCCESS;
-}
-
-imageObj* createImageCairo(int width, int height, outputFormatObj *format,colorObj* bg)
-{
-  imageObj *image = NULL;
-  cairo_renderer *r=NULL;
-  if (format->imagemode != MS_IMAGEMODE_RGB && format->imagemode!= MS_IMAGEMODE_RGBA) {
-    msSetError(MS_MISCERR,
-               "Cairo driver only supports RGB or RGBA pixel models.","msImageCreateCairo()");
-    return image;
-  }
-  if (width > 0 && height > 0) {
-    image = (imageObj *) calloc(1, sizeof(imageObj));
-    r = (cairo_renderer*)calloc(1,sizeof(cairo_renderer));
-    if(!strcasecmp(format->driver,"cairo/pdf")) {
-      r->outputStream = (bufferObj*)malloc(sizeof(bufferObj));
-      msBufferInit(r->outputStream);
-      r->surface = cairo_pdf_surface_create_for_stream(
-                     _stream_write_fn,
-                     r->outputStream,
-                     width,height);
-#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1,15,10)
-      {
-          const char *msPDFCreationDate = CPLGetConfigOption("MS_PDF_CREATION_DATE", NULL);
-          if( msPDFCreationDate )
-          {
-              cairo_pdf_surface_set_metadata (r->surface,
-                                              CAIRO_PDF_METADATA_CREATE_DATE,
-                                              msPDFCreationDate);
-          }
-      }
-#endif
-    } else if(!strcasecmp(format->driver,"cairo/svg")) {
-      r->outputStream = (bufferObj*)malloc(sizeof(bufferObj));
-      msBufferInit(r->outputStream);
-      r->surface = cairo_svg_surface_create_for_stream(
-                     _stream_write_fn,
-                     r->outputStream,
-                     width,height);
-    } else if(!strcasecmp(format->driver,"cairo/winGDI") && format->device) {
-#if CAIRO_HAS_WIN32_SURFACE
-      r->outputStream = NULL;
-      r->surface = cairo_win32_surface_create(format->device);
-#else
-      msSetError(MS_RENDERERERR, "Cannot create cairo image. Cairo was not compiled with support for the win32 backend.",
-                 "msImageCreateCairo()");
-#endif
-    } else if(!strcasecmp(format->driver,"cairo/winGDIPrint") && format->device) {
-#if CAIRO_HAS_WIN32_SURFACE
-      r->outputStream = NULL;
-      r->surface = cairo_win32_printing_surface_create(format->device);
-#else
-      msSetError(MS_RENDERERERR, "Cannot create cairo image. Cairo was not compiled with support for the win32 backend.",
-                 "msImageCreateCairo()");
-#endif
-    } else {
-      r->outputStream = NULL;
-      r->surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
-    }
-    r->cr = cairo_create(r->surface);
-    if(format->transparent || !bg || !MS_VALID_COLOR(*bg)) {
-      r->use_alpha = 1;
-      cairo_set_source_rgba (r->cr, 0,0,0,0);
-    } else {
-      r->use_alpha = 0;
-      msCairoSetSourceColor(r->cr,bg);
-    }
-    cairo_save (r->cr);
-    cairo_set_operator (r->cr, CAIRO_OPERATOR_SOURCE);
-    cairo_paint (r->cr);
-    cairo_restore (r->cr);
-
-    cairo_set_line_cap (r->cr,CAIRO_LINE_CAP_ROUND);
-    cairo_set_line_join(r->cr,CAIRO_LINE_JOIN_ROUND);
-    image->img.plugin = (void*)r;
-  } else {
-    msSetError(MS_RENDERERERR, "Cannot create cairo image of size %dx%d.",
-               "msImageCreateCairo()", width, height);
-  }
-  return image;
-}
-
-/* msSaveImagePostPDFProcessing() will call the GDAL PDF driver to add geospatial */
-/* information to the regular PDF generated by cairo. This is only triggered if the */
-/* GEO_ENCODING outputformat option is set (to ISO32000 or OGC_BP). Additionnal */
-/* options can be provided by specifying outputformat options starting with */
-/* METADATA_ITEM: prefix. For example METADATA_ITEM:PRODUCER=MapServer */
-/* Those options are AUTHOR, CREATOR, CREATION_DATE, KEYWORDS, PRODUCER, SUBJECT, TITLE */
-/* See http://gdal.org/frmt_pdf.html documentation. */
-
-static void msTransformToGeospatialPDF(imageObj *img, mapObj *map, cairo_renderer *r)
-{
-  GDALDatasetH hDS = NULL;
-  const char* pszGEO_ENCODING = NULL;
-  GDALDriverH hPDFDriver = NULL;
-  const char* pszVirtualIO = NULL;
-  int bVirtualIO = FALSE;
-  char* pszTmpFilename = NULL;
-  VSILFILE* fp = NULL;
-
-  if (map == NULL)
-    return;
-
-  pszGEO_ENCODING = msGetOutputFormatOption(img->format, "GEO_ENCODING", NULL);
-  if (pszGEO_ENCODING == NULL)
-    return;
-
-  msGDALInitialize();
-
-  hPDFDriver = GDALGetDriverByName("PDF");
-  if (hPDFDriver == NULL)
-    return;
-
-  /* When compiled against libpoppler, the PDF driver is VirtualIO capable */
-  /* but not, when it is compiled against libpodofo. */
-  pszVirtualIO = GDALGetMetadataItem( hPDFDriver, GDAL_DCAP_VIRTUALIO, NULL );
-  if (pszVirtualIO)
-    bVirtualIO = CSLTestBoolean(pszVirtualIO);
-
-  if (bVirtualIO)
-    pszTmpFilename = msTmpFile(map, NULL, "/vsimem/mscairopdf/", "pdf");
-  else
-    pszTmpFilename = msTmpFile(map, map->mappath, NULL, "pdf");
-
-  /* Copy content of outputStream buffer into file */
-  fp = VSIFOpenL(pszTmpFilename, "wb");
-  if (fp == NULL) {
-    msFree(pszTmpFilename);
-    return;
-  }
-  VSIFWriteL(r->outputStream->data, 1, r->outputStream->size, fp);
-  VSIFCloseL(fp);
-  fp = NULL;
-
-  hDS = GDALOpen(pszTmpFilename, GA_Update);
-  if ( hDS != NULL ) {
-    char* pszWKT = msProjectionObj2OGCWKT( &(map->projection) );
-    if( pszWKT != NULL ) {
-      double adfGeoTransform[6];
-      int i;
-
-      /* Add user-specified options */
-      for( i = 0; i < img->format->numformatoptions; i++ ) {
-        const char* pszOption = img->format->formatoptions[i];
-        if( strncasecmp(pszOption,"METADATA_ITEM:",14) == 0 ) {
-          char* pszKey = NULL;
-          const char* pszValue = CPLParseNameValue(pszOption + 14,
-                                 &pszKey);
-          if( pszKey != NULL ) {
-            GDALSetMetadataItem(hDS, pszKey, pszValue, NULL);
-            CPLFree(pszKey);
-          }
-        }
-      }
-
-      /* We need to rescale the geotransform because GDAL will not necessary */
-      /* open the PDF with the DPI that was used to generate it */
-      memcpy(adfGeoTransform, map->gt.geotransform, 6 * sizeof(double));
-      adfGeoTransform[1] = adfGeoTransform[1] * map->width / GDALGetRasterXSize(hDS);
-      adfGeoTransform[5] = adfGeoTransform[5] * map->height / GDALGetRasterYSize(hDS);
-      GDALSetGeoTransform(hDS, adfGeoTransform);
-      GDALSetProjection(hDS, pszWKT);
-
-      msFree( pszWKT );
-      pszWKT = NULL;
-
-      CPLSetThreadLocalConfigOption("GDAL_PDF_GEO_ENCODING", pszGEO_ENCODING);
-
-      GDALClose(hDS);
-      hDS = NULL;
-
-      CPLSetThreadLocalConfigOption("GDAL_PDF_GEO_ENCODING", NULL);
-
-      /* We need to replace the buffer with the content of the GDAL file */
-      fp = VSIFOpenL(pszTmpFilename, "rb");
-      if( fp != NULL ) {
-        int nFileSize;
-
-        VSIFSeekL(fp, 0, SEEK_END);
-        nFileSize = (int)VSIFTellL(fp);
-
-        msBufferResize(r->outputStream, nFileSize);
-
-        VSIFSeekL(fp, 0, SEEK_SET);
-        r->outputStream->size = VSIFReadL(r->outputStream->data, 1, nFileSize, fp);
-
-        VSIFCloseL(fp);
-        fp = NULL;
-      }
-    }
-  }
-
-  if ( hDS != NULL )
-    GDALClose(hDS);
-
-  VSIUnlink(pszTmpFilename);
-
-  msFree(pszTmpFilename);
-}
-
-int saveImageCairo(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format_unused)
-{
-  (void)format_unused;
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  if(!strcasecmp(img->format->driver,"cairo/pdf") || !strcasecmp(img->format->driver,"cairo/svg")) {
-    cairo_surface_finish (r->surface);
-
-    if (map != NULL && !strcasecmp(img->format->driver,"cairo/pdf"))
-      msTransformToGeospatialPDF(img, map, r);
-
-    msIO_fwrite(r->outputStream->data,r->outputStream->size,1,fp);
-  } else {
-    /* not supported */
-  }
-  return MS_SUCCESS;
-}
-
-unsigned char* saveImageBufferCairo(imageObj *img, int *size_ptr, outputFormatObj *format_unused)
-{
-  (void)format_unused;
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  unsigned char *data;
-  assert(!strcasecmp(img->format->driver,"cairo/pdf") || !strcasecmp(img->format->driver,"cairo/svg"));
-  cairo_surface_finish (r->surface);
-  data = msSmallMalloc(r->outputStream->size);
-  memcpy(data,r->outputStream->data,r->outputStream->size);
-  *size_ptr = (int)r->outputStream->size;
-  return data;
-}
-
-int renderEllipseSymbolCairo(imageObj *img, double x, double y, symbolObj *symbol,
-                             symbolStyleObj *style)
-{
-  cairo_renderer *r = CAIRO_RENDERER(img);
-
-  cairo_save(r->cr);
-  cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_BUTT);
-  cairo_set_line_join(r->cr, CAIRO_LINE_JOIN_MITER);
-  cairo_translate(r->cr,x,y);
-  cairo_rotate(r->cr,-style->rotation);
-  cairo_scale(r->cr,symbol->sizex*style->scale/2,symbol->sizey*style->scale/2);
-  cairo_arc (r->cr, 0,0,1, 0, 2 * MS_PI);
-  cairo_restore(r->cr);
-  if(style->color) {
-    msCairoSetSourceColor(r->cr, style->color);
-    cairo_fill_preserve(r->cr);
-  }
-  if(style->outlinewidth > 0) {
-    cairo_set_line_width (r->cr, style->outlinewidth);
-    msCairoSetSourceColor(r->cr, style->outlinecolor);
-    cairo_stroke_preserve(r->cr);
-  }
-  cairo_new_path(r->cr);
-  return MS_SUCCESS;
-}
-
-
-
-int startLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
-  (void)map;
-  if(layer->compositer && layer->compositer->opacity<100) {
-    cairo_renderer *r = CAIRO_RENDERER(img);
-    cairo_push_group (r->cr);
-  }
-  return MS_SUCCESS;
-}
-
-int closeLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
-  (void)map;
-  if(layer->compositer && layer->compositer->opacity<100) {
-    cairo_renderer *r = CAIRO_RENDERER(img);
-    cairo_pop_group_to_source (r->cr);
-    cairo_paint_with_alpha (r->cr, layer->compositer->opacity*0.01);
-  }
-  return MS_SUCCESS;
-}
-
-int startLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
-  (void)img;
-  (void)map;
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-int closeLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
-  (void)img;
-  (void)map;
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-
-int getRasterBufferHandleCairo(imageObj *img, rasterBufferObj *rb)
-{
-  unsigned char *pb;
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  rb->type = MS_BUFFER_BYTE_RGBA;
-  pb = cairo_image_surface_get_data(r->surface);
-  rb->data.rgba.pixels = pb;
-  rb->data.rgba.row_step = cairo_image_surface_get_stride(r->surface);
-  rb->data.rgba.pixel_step=4;
-  rb->width = cairo_image_surface_get_width(r->surface);
-  rb->height = cairo_image_surface_get_height(r->surface);
-  rb->data.rgba.r = &(pb[2]);
-  rb->data.rgba.g = &(pb[1]);
-  rb->data.rgba.b = &(pb[0]);
-  if(r->use_alpha)
-    rb->data.rgba.a = &(pb[3]);
-  else
-    rb->data.rgba.a = NULL;
-  return MS_SUCCESS;
-}
-
-int getRasterBufferCopyCairo(imageObj *img, rasterBufferObj *rb)
-{
-  cairo_renderer *r = CAIRO_RENDERER(img);
-  unsigned char *pb;
-  rb->type = MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.row_step = cairo_image_surface_get_stride(r->surface);
-  rb->data.rgba.pixel_step=4;
-  rb->width = cairo_image_surface_get_width(r->surface);
-  rb->height = cairo_image_surface_get_height(r->surface);
-  pb = (unsigned char*)malloc(rb->height * rb->data.rgba.row_step * sizeof(unsigned char));
-  memcpy(pb,cairo_image_surface_get_data(r->surface),rb->height * rb->data.rgba.row_step);
-  rb->data.rgba.pixels = pb;
-  rb->data.rgba.r = &(pb[2]);
-  rb->data.rgba.g = &(pb[1]);
-  rb->data.rgba.b = &(pb[0]);
-  if(r->use_alpha)
-    rb->data.rgba.a = &(pb[3]);
-  else
-    rb->data.rgba.a = NULL;
-  return MS_SUCCESS;
-}
-
-static cairo_operator_t ms2cairo_compop(CompositingOperation op) {
-  switch(op) {
-    case MS_COMPOP_CLEAR:
-      return CAIRO_OPERATOR_CLEAR;
-    case MS_COMPOP_SRC:
-      return CAIRO_OPERATOR_SOURCE;
-    case MS_COMPOP_DST:
-      return CAIRO_OPERATOR_DEST;
-    case MS_COMPOP_SRC_OVER:
-      return CAIRO_OPERATOR_OVER;
-    case MS_COMPOP_DST_OVER:
-      return CAIRO_OPERATOR_DEST_OVER;
-    case MS_COMPOP_SRC_IN:
-      return CAIRO_OPERATOR_IN;
-    case MS_COMPOP_DST_IN:
-      return CAIRO_OPERATOR_DEST_IN;
-    case MS_COMPOP_SRC_OUT:
-      return CAIRO_OPERATOR_OUT;
-    case MS_COMPOP_DST_OUT:
-      return CAIRO_OPERATOR_DEST_OUT;
-    case MS_COMPOP_SRC_ATOP:
-      return CAIRO_OPERATOR_ATOP;
-    case MS_COMPOP_DST_ATOP:
-      return CAIRO_OPERATOR_DEST_ATOP;
-    case MS_COMPOP_XOR:
-      return CAIRO_OPERATOR_XOR;
-    case MS_COMPOP_PLUS:
-      return CAIRO_OPERATOR_ADD;
-    case MS_COMPOP_MULTIPLY:
-      return CAIRO_OPERATOR_MULTIPLY;
-    case MS_COMPOP_SCREEN:
-      return CAIRO_OPERATOR_SCREEN;
-    case MS_COMPOP_OVERLAY:
-      return CAIRO_OPERATOR_OVERLAY;
-    case MS_COMPOP_DARKEN:
-      return CAIRO_OPERATOR_DARKEN;
-    case MS_COMPOP_LIGHTEN:
-      return CAIRO_OPERATOR_LIGHTEN;
-    case MS_COMPOP_COLOR_DODGE:
-      return CAIRO_OPERATOR_COLOR_DODGE;
-    case MS_COMPOP_COLOR_BURN:
-      return CAIRO_OPERATOR_COLOR_BURN;
-    case MS_COMPOP_HARD_LIGHT:
-      return CAIRO_OPERATOR_HARD_LIGHT;
-    case MS_COMPOP_SOFT_LIGHT:
-      return CAIRO_OPERATOR_SOFT_LIGHT;
-    case MS_COMPOP_DIFFERENCE:
-      return CAIRO_OPERATOR_DIFFERENCE;
-    case MS_COMPOP_EXCLUSION:
-      return CAIRO_OPERATOR_EXCLUSION;
-    case MS_COMPOP_INVERT:
-    case MS_COMPOP_INVERT_RGB:
-    case MS_COMPOP_MINUS:
-    case MS_COMPOP_CONTRAST:
-    default:
-      return CAIRO_OPERATOR_OVER;
-  }
-}
-
-int cairoCompositeRasterBuffer(imageObj *img, rasterBufferObj *rb, CompositingOperation comp, int opacity) {
-  cairo_surface_t *src;
-  cairo_renderer *r;
-  if(rb->type != MS_BUFFER_BYTE_RGBA) {
-    return MS_FAILURE;
-  }
-  r = CAIRO_RENDERER(img);
-
-  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,CAIRO_FORMAT_ARGB32,
-        rb->width,rb->height,
-        rb->data.rgba.row_step);
-
-  cairo_set_source_surface (r->cr,src,0,0);
-  cairo_set_operator(r->cr, ms2cairo_compop(comp));
-  cairo_paint_with_alpha(r->cr,opacity/100.0);
-  cairo_surface_finish(src);
-  cairo_surface_destroy(src);
-  cairo_set_operator(r->cr,CAIRO_OPERATOR_OVER);
-  return MS_SUCCESS;
-}
-
-int mergeRasterBufferCairo(imageObj *img, rasterBufferObj *rb, double opacity,
-                           int srcX, int srcY, int dstX, int dstY,
-                           int width, int height)
-{
-  cairo_surface_t *src;
-  cairo_renderer *r;
-  /* not implemented for src,dst,width and height */
-  if(rb->type != MS_BUFFER_BYTE_RGBA) {
-    return MS_FAILURE;
-  }
-  r = CAIRO_RENDERER(img);
-
-  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,CAIRO_FORMAT_ARGB32,
-        rb->width,rb->height,
-        rb->data.rgba.row_step);
-
-  if(dstX||dstY||srcX||srcY||width!=img->width||height!=img->height) {
-    cairo_set_source_surface (r->cr, src, dstX - srcX, dstY - srcY);
-    cairo_rectangle (r->cr, dstX, dstY, width, height);
-    cairo_fill (r->cr);
-  } else {
-    cairo_set_source_surface (r->cr,src,0,0);
-    cairo_paint_with_alpha(r->cr,opacity);
-  }
-  cairo_surface_finish(src);
-  cairo_surface_destroy(src);
-  return MS_SUCCESS;
-}
-
-
-void freeSVGCache(symbolObj *s) {
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-      struct svg_symbol_cache *cache = s->renderer_cache;
-      if(!cache) return;
-      assert(cache->svgc);
-#ifdef USE_SVG_CAIRO
-      svg_cairo_destroy(cache->svgc);
-#else
-  #if LIBRSVG_CHECK_VERSION(2,35,0)
-      g_object_unref(cache->svgc);
-  #else
-      rsvg_handle_free(cache->svgc);
-  #endif
-#endif
-      if(cache->pixmap_buffer) {
-        msFreeRasterBuffer(cache->pixmap_buffer);
-        free(cache->pixmap_buffer);
-      }
-      msFree(s->renderer_cache);
-      s->renderer_cache = NULL;
-#endif
-}
-
-int freeSymbolCairo(symbolObj *s)
-{
-  if(!s->renderer_cache)
-    return MS_SUCCESS;
-  switch(s->type) {
-    case MS_SYMBOL_VECTOR:
-      cairo_path_destroy(s->renderer_cache);
-      break;
-    case MS_SYMBOL_PIXMAP:
-      cairo_surface_destroy(s->renderer_cache);
-      break;
-    case MS_SYMBOL_SVG:
-      freeSVGCache(s);
-      break;
-  }
-  s->renderer_cache=NULL;
-  return MS_SUCCESS;
-}
-
-int initializeRasterBufferCairo(rasterBufferObj *rb, int width, int height, int mode)
-{
-  (void)mode;
-  rb->type = MS_BUFFER_BYTE_RGBA;
-  rb->width = width;
-  rb->height = height;
-  rb->data.rgba.pixel_step = 4;
-  rb->data.rgba.row_step = width * 4;
-  rb->data.rgba.pixels = (unsigned char*)calloc(width*height*4,sizeof(unsigned char));
-  rb->data.rgba.r = &(rb->data.rgba.pixels[2]);
-  rb->data.rgba.g = &(rb->data.rgba.pixels[1]);
-  rb->data.rgba.b = &(rb->data.rgba.pixels[0]);
-  rb->data.rgba.a = &(rb->data.rgba.pixels[3]);
-  return MS_SUCCESS;
-}
-
-
-int msPreloadSVGSymbol(symbolObj *symbol)
-{
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-  struct svg_symbol_cache *cache;
-
-  if(!symbol->renderer_cache) {
-    cache = msSmallCalloc(1,sizeof(struct svg_symbol_cache));
-    symbol->renderer_free_func = &freeSVGCache;
-  } else {
-    cache = symbol->renderer_cache;
-  }
-  if(cache->svgc)
-    return MS_SUCCESS;
-
-#ifdef USE_SVG_CAIRO
-  {
-    unsigned int svg_width, svg_height;
-    int status;
-    status = svg_cairo_create(&cache->svgc);
-    if (status) {
-      msSetError(MS_RENDERERERR, "problem creating cairo svg", "msPreloadSVGSymbol()");
-      return MS_FAILURE;
-    }
-    status = svg_cairo_parse(cache->svgc, symbol->full_pixmap_path);
-    if (status) {
-      msSetError(MS_RENDERERERR, "problem parsing svg symbol", "msPreloadSVGSymbol()");
-      return MS_FAILURE;
-    }
-    svg_cairo_get_size (cache->svgc, &svg_width, &svg_height);
-    if (svg_width == 0 || svg_height == 0) {
-      msSetError(MS_RENDERERERR, "problem parsing svg symbol", "msPreloadSVGSymbol()");
-      return MS_FAILURE;
-    }
-
-    symbol->sizex = svg_width;
-    symbol->sizey = svg_height;
-  }
-#else
-  {
-    cache->svgc = rsvg_handle_new_from_file(symbol->full_pixmap_path,NULL);
-    if(!cache->svgc) {
-      msSetError(MS_RENDERERERR,"failed to load svg file %s", "msPreloadSVGSymbol()", symbol->full_pixmap_path);
-      return MS_FAILURE;
-    }
-#if LIBRSVG_CHECK_VERSION(2,46,0)
-    /* rsvg_handle_get_dimensions_sub() is deprecated since librsvg 2.46 */
-    /* It seems rsvg_handle_get_intrinsic_dimensions() is the best equivalent */
-    /* when the <svg> root node includes a width and height attributes in pixels */
-    gboolean has_width = FALSE;
-    RsvgLength width = {0, RSVG_UNIT_PX};
-    gboolean has_height = FALSE;
-    RsvgLength height = {0, RSVG_UNIT_PX};
-    rsvg_handle_get_intrinsic_dimensions(cache->svgc,
-                                         &has_width, &width,
-                                         &has_height, &height,
-                                         NULL, NULL);
-    if( has_width && width.unit == RSVG_UNIT_PX &&
-        has_height && height.unit == RSVG_UNIT_PX )
-    {
-        symbol->sizex = width.length;
-        symbol->sizey = height.length;
-    }
-    else
-    {
-        RsvgRectangle ink_rect = { 0, 0, 0, 0 };
-        rsvg_handle_get_geometry_for_element (cache->svgc, NULL, &ink_rect, NULL, NULL);
-        symbol->sizex = ink_rect.width;
-        symbol->sizey = ink_rect.height;
-    }
-#else
-    RsvgDimensionData dim;
-    rsvg_handle_get_dimensions_sub (cache->svgc, &dim, NULL);
-    symbol->sizex = dim.width;
-    symbol->sizey = dim.height;
-#endif
-  }
-#endif
-
-  symbol->renderer_cache = cache;
-
-  return MS_SUCCESS;
-
-#else
-  msSetError(MS_MISCERR, "SVG Symbols requested but is not built with libsvgcairo",
-             "msPreloadSVGSymbol()");
-  return MS_FAILURE;
-#endif
-}
-
-
-
-int msRenderRasterizedSVGSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style)
-{
-
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-  struct svg_symbol_cache *svg_cache;
-  symbolStyleObj pixstyle;
-  symbolObj pixsymbol;
-  int status;
-
-  if(MS_SUCCESS != msPreloadSVGSymbol(symbol))
-    return MS_FAILURE;
-  svg_cache = (struct svg_symbol_cache*) symbol->renderer_cache;
-
-  //already rendered at the right size and scale? return
-  if(svg_cache->scale != style->scale || svg_cache->rotation != style->rotation) {
-    cairo_t *cr;
-    cairo_surface_t *surface;
-    unsigned char *pb;
-    int width, height, surface_w, surface_h;
-    /* need to recompute the pixmap */
-    if(svg_cache->pixmap_buffer) {
-      msFreeRasterBuffer(svg_cache->pixmap_buffer);
-    } else {
-      svg_cache->pixmap_buffer = msSmallCalloc(1,sizeof(rasterBufferObj));
-    }
-
-    //increase pixmap size to accomodate scaling/rotation
-    if (style->scale != 1.0) {
-      width = surface_w = (symbol->sizex * style->scale + 0.5);
-      height = surface_h = (symbol->sizey * style->scale + 0.5);
-    } else {
-      width = surface_w = symbol->sizex;
-      height = surface_h = symbol->sizey;
-    }
-    if (style->rotation != 0) {
-      surface_w = surface_h = MS_NINT(MS_MAX(height, width) * 1.415);
-    }
-
-    surface = cairo_image_surface_create(CAIRO_FORMAT_ARGB32, surface_w, surface_h);
-    cr = cairo_create(surface);
-
-    if (style->rotation != 0) {
-      cairo_translate(cr, surface_w / 2, surface_h / 2);
-      cairo_rotate(cr, -style->rotation);
-      cairo_translate(cr, -width / 2, -height / 2);
-    }
-    if (style->scale != 1.0) {
-      cairo_scale(cr, style->scale, style->scale);
-    }
-#ifdef USE_SVG_CAIRO
-    if(svg_cairo_render(svg_cache->svgc, cr) != SVG_CAIRO_STATUS_SUCCESS) {
-      return MS_FAILURE;
-    }
-#else
-  rsvg_handle_render_cairo(svg_cache->svgc, cr);
-#endif
-    pb = cairo_image_surface_get_data(surface);
-
-    //set up raster
-    initializeRasterBufferCairo(svg_cache->pixmap_buffer, surface_w, surface_h, 0);
-    memcpy(svg_cache->pixmap_buffer->data.rgba.pixels, pb, surface_w * surface_h * 4 * sizeof (unsigned char));
-    svg_cache->scale = style->scale;
-    svg_cache->rotation = style->rotation;
-    cairo_destroy(cr);
-    cairo_surface_destroy(surface);
-  }
-  assert(svg_cache->pixmap_buffer->height && svg_cache->pixmap_buffer->width);
-
-  pixstyle = *style;
-  pixstyle.rotation = 0.0;
-  pixstyle.scale = 1.0;
-
-  pixsymbol.pixmap_buffer = svg_cache->pixmap_buffer;
-  pixsymbol.type = MS_SYMBOL_PIXMAP;
-
-  status = MS_IMAGE_RENDERER(img)->renderPixmapSymbol(img,x,y,&pixsymbol,&pixstyle);
-  MS_IMAGE_RENDERER(img)->freeSymbol(&pixsymbol);
-  return status;
-#else
-  msSetError(MS_MISCERR, "SVG Symbols requested but MapServer is not built with libsvgcairo",
-             "renderSVGSymbolCairo()");
-  return MS_FAILURE;
-#endif
-}
-
-void msCairoCleanup() {
-   cairo_debug_reset_static_data();
-}
-
-#endif /*USE_CAIRO*/
-
-
-int msPopulateRendererVTableCairoRaster( rendererVTableObj *renderer )
-{
-#ifdef USE_CAIRO
-  renderer->supports_pixel_buffer=1;
-  renderer->compositeRasterBuffer = cairoCompositeRasterBuffer;
-  renderer->supports_svg = 1;
-  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
-  initializeCache(&MS_RENDERER_CACHE(renderer));
-  renderer->startLayer = startLayerRasterCairo;
-  renderer->endLayer = closeLayerRasterCairo;
-  renderer->renderLineTiled = NULL;
-  renderer->renderLine=&renderLineCairo;
-  renderer->createImage=&createImageCairo;
-  renderer->saveImage=&saveImageCairo;
-  renderer->getRasterBufferHandle=&getRasterBufferHandleCairo;
-  renderer->getRasterBufferCopy=&getRasterBufferCopyCairo;
-  renderer->renderPolygon=&renderPolygonCairo;
-  renderer->renderGlyphs=&renderGlyphs2Cairo;
-  renderer->freeImage=&freeImageCairo;
-  renderer->renderEllipseSymbol = &renderEllipseSymbolCairo;
-  renderer->renderVectorSymbol = &renderVectorSymbolCairo;
-  renderer->renderSVGSymbol = &renderSVGSymbolCairo;
-  renderer->renderPixmapSymbol = &renderPixmapSymbolCairo;
-  renderer->mergeRasterBuffer = &mergeRasterBufferCairo;
-  renderer->renderTile = &renderTileCairo;
-  renderer->loadImageFromFile = &msLoadMSRasterBufferFromFile;
-  renderer->renderPolygonTiled = &renderPolygonTiledCairo;
-  renderer->freeSymbol = &freeSymbolCairo;
-  renderer->cleanup = &cleanupCairo;
-  return MS_SUCCESS;
-#else
-  msSetError(MS_MISCERR, "Cairo Driver requested but MapServer is not built in",
-             "msPopulateRendererVTableCairoRaster()");
-  return MS_FAILURE;
-#endif
-}
-
-int populateRendererVTableCairoVector( rendererVTableObj *renderer )
-{
-#ifdef USE_CAIRO
-  renderer->use_imagecache=0;
-  renderer->supports_pixel_buffer=0;
-  renderer->compositeRasterBuffer = NULL;
-  renderer->supports_svg = 1;
-  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
-  initializeCache(&MS_RENDERER_CACHE(renderer));
-  renderer->startLayer = startLayerVectorCairo;
-  renderer->endLayer = closeLayerVectorCairo;
-  renderer->renderLine=&renderLineCairo;
-  renderer->renderLineTiled = NULL;
-  renderer->createImage=&createImageCairo;
-  renderer->saveImage=&saveImageCairo;
-  renderer->saveImageBuffer = &saveImageBufferCairo;
-  renderer->getRasterBufferHandle=&getRasterBufferHandleCairo;
-  renderer->renderPolygon=&renderPolygonCairo;
-  renderer->renderGlyphs=&renderGlyphs2Cairo;
-  renderer->freeImage=&freeImageCairo;
-  renderer->renderEllipseSymbol = &renderEllipseSymbolCairo;
-  renderer->renderVectorSymbol = &renderVectorSymbolCairo;
-  renderer->renderSVGSymbol = &renderSVGSymbolCairo;
-  renderer->renderPixmapSymbol = &renderPixmapSymbolCairo;
-  renderer->loadImageFromFile = &msLoadMSRasterBufferFromFile;
-  renderer->mergeRasterBuffer = &mergeRasterBufferCairo;
-  renderer->initializeRasterBuffer = initializeRasterBufferCairo;
-  renderer->renderTile = &renderTileCairo;
-  renderer->renderPolygonTiled = &renderPolygonTiledCairo;
-  renderer->freeSymbol = &freeSymbolCairo;
-  renderer->cleanup = &cleanupCairo;
-  return MS_SUCCESS;
-#else
-  msSetError(MS_MISCERR, "Cairo Driver requested but MapServer is not built in",
-             "msPopulateRendererVTableCairoRaster()");
-  return MS_FAILURE;
-#endif
-}
-
-int msPopulateRendererVTableCairoSVG( rendererVTableObj *renderer )
-{
-  return populateRendererVTableCairoVector(renderer);
-}
-int msPopulateRendererVTableCairoPDF( rendererVTableObj *renderer )
-{
-  return populateRendererVTableCairoVector(renderer);
-}
-
diff -pruN 8.0.1-5/mapchart.c 8.2.0~beta1-1~exp1/mapchart.c
--- 8.0.1-5/mapchart.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapchart.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,672 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of dynamic charting (MS-RFC-29)
- * Author:   Thomas Bonfort ( thomas.bonfort[at]gmail.com )
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-#include "mapserver.h"
-
-
-
-#define MS_CHART_TYPE_PIE 1
-#define MS_CHART_TYPE_BAR 2
-#define MS_CHART_TYPE_VBAR 3
-
-/*
-** check if an object of width w and height h placed at point x,y can fit in an image of width mw and height mh
-*/
-#define MS_CHART_FITS(x,y,w,h,mw,mh) (((x)-(w)/2.>0.)&&((x)+(w)/2.<(mw))&&((y)-(h)/2.>0.)&&((y)+(h)/2.)<(mh))
-
-/*
-** find a point on a shape. check if it fits in image
-** returns
-**  MS_SUCCESS and point coordinates in 'p' if chart fits in image
-**  MS_FAILURE if no point could be found
-*/
-int findChartPoint(mapObj *map, shapeObj *shape, int width, int height, pointObj *center)
-{
-  int middle,numpoints;
-  double invcellsize = 1.0/map->cellsize; /*speed up MAP2IMAGE_X/Y_IC_DBL*/
-  switch(shape->type) {
-    case MS_SHAPE_POINT:
-      center->x=MS_MAP2IMAGE_X_IC_DBL(shape->line[0].point[0].x, map->extent.minx, invcellsize);
-      center->y=MS_MAP2IMAGE_Y_IC_DBL(shape->line[0].point[0].y, map->extent.maxy, invcellsize);
-
-      if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
-        return MS_SUCCESS;
-      else
-        return MS_FAILURE;
-      break;
-    case MS_SHAPE_LINE:
-      /*loop through line segments starting from middle (alternate between before and after middle point)
-      **first segment that fits is chosen
-      */
-      middle=shape->line[0].numpoints/2; /*start with middle segment of line*/
-      numpoints=shape->line[0].numpoints;
-      if( 1 <= middle ) {
-        int idx=middle+1;
-        if(idx<numpoints) {
-          center->x=(shape->line[0].point[idx-1].x+shape->line[0].point[idx].x)/2.;
-          center->y=(shape->line[0].point[idx-1].y+shape->line[0].point[idx].y)/2.;
-          center->x=MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
-          center->y=MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
-
-          if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
-            return MS_SUCCESS;
-
-          return MS_FAILURE;
-        }
-        idx=middle-1;
-        center->x=(shape->line[0].point[idx].x+shape->line[0].point[idx+1].x)/2;
-        center->y=(shape->line[0].point[idx].y+shape->line[0].point[idx+1].y)/2;
-        center->x=MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
-        center->y=MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
-
-        if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
-          return MS_SUCCESS;
-        return MS_FAILURE;
-      }
-      return MS_FAILURE;
-      break;
-    case MS_SHAPE_POLYGON:
-      msPolygonLabelPoint(shape, center, -1);
-      center->x=MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
-      center->y=MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
-
-      if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
-        return MS_SUCCESS;
-      else
-        return MS_FAILURE;
-      break;
-    default:
-      return MS_FAILURE;
-  }
-}
-
-int WARN_UNUSED drawRectangle(mapObj *map, imageObj *image, double mx, double my, double Mx, double My,
-                   styleObj *style)
-{
-  shapeObj shape;
-  lineObj line;
-  pointObj point[5];
-  line.point = point;
-  line.numpoints = 5;
-  shape.line = &line;
-  shape.numlines = 1;
-
-  point[0].x = point[4].x = point[3].x = mx;
-  point[0].y = point[4].y = point[1].y = my;
-  /* cppcheck-suppress unreadVariable */
-  point[1].x = point[2].x = Mx;
-  /* cppcheck-suppress unreadVariable */
-  point[2].y = point[3].y = My;
-
-  return msDrawShadeSymbol(map,image,&shape,style,1.0);
-}
-
-int WARN_UNUSED msDrawVBarChart(mapObj *map, imageObj *image, pointObj *center,
-                    double *values, styleObj **styles, int numvalues,
-                    double barWidth)
-{
-
-  int c;
-  double left,bottom,cur; /*shortcut to pixel boundaries of the chart*/
-  double height = 0;
-
-  for(c=0; c<numvalues; c++) {
-    height += values[c];
-  }
-
-  cur = bottom = center->y+height/2.;
-  left = center->x-barWidth/2.;
-
-  for(c=0; c<numvalues; c++) {
-    if(MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, left, cur, left+barWidth, cur-values[c], styles[c])))
-      return MS_FAILURE;
-    cur -= values[c];
-  }
-  return MS_SUCCESS;
-}
-
-
-int msDrawBarChart(mapObj *map, imageObj *image, pointObj *center,
-                   double *values, styleObj **styles, int numvalues,
-                   double width, double height, double *maxVal, double *minVal, double barWidth)
-{
-
-  double upperLimit,lowerLimit;
-  double shapeMaxVal,shapeMinVal,pixperval;
-  int c;
-  double vertOrigin,vertOriginClipped,horizStart,y;
-  double left,top,bottom; /*shortcut to pixel boundaries of the chart*/
-
-  top=center->y-height/2.;
-  bottom=center->y+height/2.;
-  left=center->x-width/2.;
-
-  shapeMaxVal=shapeMinVal=values[0];
-  for(c=1; c<numvalues; c++) {
-    if(maxVal==NULL || minVal==NULL) { /*compute bounds if not specified*/
-      if(values[c]>shapeMaxVal)
-        shapeMaxVal=values[c];
-      if(values[c]<shapeMinVal)
-        shapeMinVal=values[c];
-    }
-  }
-
-  /*
-   * use specified bounds if wanted
-   * if not, always show the origin
-   */
-  upperLimit = (maxVal!=NULL)? *maxVal : MS_MAX(shapeMaxVal,0);
-  lowerLimit = (minVal!=NULL)? *minVal : MS_MIN(shapeMinVal,0);
-  if(upperLimit==lowerLimit) {
-    /* treat the case where we would have an unspecified behavior */
-    upperLimit+=0.5;
-    lowerLimit-=0.5;
-  }
-
-  pixperval=height/(upperLimit-lowerLimit);
-  vertOrigin=bottom+lowerLimit*pixperval;
-  vertOriginClipped=(vertOrigin<top) ? top :
-                    (vertOrigin>bottom) ? bottom : vertOrigin;
-  horizStart=left;
-  
-  for(c=0; c<numvalues; c++) {
-    double barHeight=values[c]*pixperval;
-    /*clip bars*/
-    y=((vertOrigin-barHeight)<top) ? top :
-      (vertOrigin-barHeight>bottom) ? bottom : vertOrigin-barHeight;
-    if(y!=vertOriginClipped) { /*don't draw bars of height == 0 (i.e. either values==0, or clipped)*/
-      if(values[c]>0) {
-        if(MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, horizStart, y, horizStart+barWidth-1, vertOriginClipped, styles[c])))
-          return MS_FAILURE;
-      }
-      else {
-        if(MS_UNLIKELY(MS_FAILURE == drawRectangle(map,image, horizStart, vertOriginClipped, horizStart+barWidth-1 , y, styles[c])))
-          return MS_FAILURE;
-      }
-    }
-    horizStart+=barWidth;
-  }
-  return MS_SUCCESS;
-}
-
-int WARN_UNUSED msDrawPieChart(mapObj *map, imageObj *image,
-                   pointObj *center, double diameter,
-                   double *values, styleObj **styles, int numvalues)
-{
-  int i;
-  double dTotal=0.,start=0;
-
-  for(i=0; i<numvalues; i++) {
-    if(values[i]<0.) {
-      msSetError(MS_MISCERR, "cannot draw pie charts for negative values", "msDrawPieChart()");
-      return MS_FAILURE;
-    }
-    dTotal+=values[i];
-  }
-
-  for(i=0; i < numvalues; i++) {
-    double angle = values[i];
-    if(angle==0) continue; /*no need to draw. causes artifacts with outlines*/
-    angle*=360.0/dTotal;
-    if(MS_UNLIKELY(MS_FAILURE == msDrawPieSlice(map ,image, center, styles[i], diameter/2., start, start+angle)))
-      return MS_FAILURE;
-
-    start+=angle;
-  }
-  return MS_SUCCESS;
-}
-
-int getNextShape(mapObj *map, layerObj *layer, double *values, int *nvalues, styleObj **styles, shapeObj *shape)
-{
-  int status;
-  int c;
-  status = msLayerNextShape(layer, shape);
-  if(status == MS_SUCCESS) {
-
-    if(layer->project)
-    {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-        layer->reprojectorLayerToMap = msProjectCreateReprojector(
-            &layer->projection, &map->projection);
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            return MS_FAILURE;
-        }
-      }
-      msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-    }
-
-    if(msBindLayerToShape(layer, shape, MS_DRAWMODE_FEATURES|MS_DRAWMODE_LABELS) != MS_SUCCESS)
-      return MS_FAILURE; /* error message is set in msBindLayerToShape() */
-
-    *nvalues = 0;
-    for(c=0; c<layer->numclasses; c++) {
-      if(msEvalExpression(layer, shape, &(layer->class[c]->expression), layer->classitemindex) == MS_TRUE) {
-        values[*nvalues]=(layer->class[c]->styles[0]->size);
-        styles[*nvalues]=layer->class[c]->styles[0];
-        (*nvalues)++;
-      }
-    }
-  }
-  return status;
-}
-
-/* eventually add a class to the layer to get the diameter from an attribute */
-int pieLayerProcessDynamicDiameter(layerObj *layer)
-{
-  const char *chartRangeProcessingKey=NULL;
-  char *attrib;
-  double mindiameter=-1, maxdiameter, minvalue, maxvalue;
-  classObj *newclass;
-  styleObj *newstyle;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  if(chartSizeProcessingKey != NULL)
-    return MS_FALSE;
-  chartRangeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE_RANGE" );
-  if(chartRangeProcessingKey==NULL)
-    return MS_FALSE;
-  attrib = msStrdup(chartRangeProcessingKey);
-  char* space = strchr(attrib, ' ');
-  if( space ) {
-      *space = '\0';
-      switch(sscanf(space+1,"%lf %lf %lf %lf",
-                    &mindiameter,&maxdiameter,&minvalue,&maxvalue)) {
-        case 4: /*we have the attribute and the four range values*/
-          break;
-        default:
-          free(attrib);
-          msSetError(MS_MISCERR, "Chart Layer format error for processing key \"CHART_RANGE\"", "msDrawChartLayer()");
-          return MS_FAILURE;
-      }
-  }
-
-  /*create a new class in the layer containing the wanted attribute
-   * as the SIZE of its first STYLE*/
-  newclass=msGrowLayerClasses(layer);
-  if(newclass==NULL) {
-    free(attrib);
-    return MS_FAILURE;
-  }
-  initClass(newclass);
-  layer->numclasses++;
-
-  /*create and attach a new styleObj to our temp class
-   * and bind the wanted attribute to its SIZE
-   */
-  newstyle=msGrowClassStyles(newclass);
-  if(newstyle==NULL) {
-    free(attrib);
-    return MS_FAILURE;
-  }
-  initStyle(newstyle);
-  newclass->numstyles++;
-  newclass->name=(char*)msStrdup("__MS_SIZE_ATTRIBUTE_");
-  newstyle->bindings[MS_STYLE_BINDING_SIZE].item=msStrdup(attrib);
-  newstyle->numbindings++;
-  free(attrib);
-
-  return MS_TRUE;
-
-}
-
-/* clean up the class added temporarily */
-static void pieLayerCleanupDynamicDiameter(layerObj *layer)
-{
-  if( layer->numclasses > 0 && EQUALN(layer->class[layer->numclasses - 1]->name, "__MS_SIZE_ATTRIBUTE_", 20) ) {
-    classObj *c=msRemoveClass(layer, layer->numclasses - 1);
-    freeClass(c);
-    msFree(c);
-  }
-}
-
-
-int msDrawPieChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  shapeObj    shape;
-  int         status=MS_SUCCESS;
-  const char *chartRangeProcessingKey=NULL;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  double diameter=0, mindiameter=-1, maxdiameter=0, minvalue=0, maxvalue=0, exponent=0;
-  double *values;
-  styleObj **styles;
-  pointObj center;
-  int numvalues = layer->numclasses; /* the number of classes to represent in the graph */
-  int numvalues_for_shape = 0;
-
-  if(chartSizeProcessingKey==NULL) {
-    chartRangeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE_RANGE" );
-    if(chartRangeProcessingKey==NULL)
-      diameter=20;
-    else {
-      sscanf(chartRangeProcessingKey,"%*s %lf %lf %lf %lf %lf",
-             &mindiameter,&maxdiameter,&minvalue,&maxvalue,&exponent);
-    }
-  } else {
-    if(sscanf(chartSizeProcessingKey ,"%lf",&diameter)!=1) {
-      msSetError(MS_MISCERR, "msDrawChart format error for processing key \"CHART_SIZE\"", "msDrawPieChartLayer()");
-      return MS_FAILURE;
-    }
-  }
-
-  layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
-
-  /* step through the target shapes */
-  msInitShape(&shape);
-
-  values=(double*)calloc(numvalues,sizeof(double));
-  MS_CHECK_ALLOC(values, numvalues*sizeof(double), MS_FAILURE);
-  styles = (styleObj**)malloc((numvalues)*sizeof(styleObj*));
-  if (styles == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawPieChartLayer()",
-               __FILE__, __LINE__, (unsigned int)(numvalues*sizeof(styleObj*)));
-    free(values);
-    return MS_FAILURE;
-  }
-
-  while(MS_SUCCESS == getNextShape(map,layer,values,&numvalues_for_shape,styles,&shape)) {
-    if(chartRangeProcessingKey!=NULL)
-      numvalues_for_shape--;
-    if(numvalues_for_shape == 0) {
-      msFreeShape(&shape);
-      continue;
-    }
-    msDrawStartShape(map, layer, image, &shape);
-    if(chartRangeProcessingKey!=NULL) {
-      diameter = values[numvalues_for_shape];
-      if(mindiameter>=0) {
-        if(diameter<=minvalue)
-          diameter=mindiameter;
-        else if(diameter>=maxvalue)
-          diameter=maxdiameter;
-        else {
-          if (exponent <= 0)
-            diameter=MS_NINT(
-                       mindiameter+
-                       ((diameter-minvalue)/(maxvalue-minvalue))*
-                       (maxdiameter-mindiameter)
-                     );
-          else
-            diameter=MS_NINT(
-                       mindiameter+
-                       pow((diameter-minvalue)/(maxvalue-minvalue),1.0/exponent)*
-                       (maxdiameter-mindiameter)
-                     );
-        }
-      }
-    }
-    if(findChartPoint(map, &shape, diameter, diameter, &center) == MS_SUCCESS) {
-      status = msDrawPieChart(map,image, &center, diameter,
-                              values,styles,numvalues_for_shape);
-    }
-    msDrawEndShape(map,layer,image,&shape);
-    msFreeShape(&shape);
-  }
-  free(values);
-  free(styles);
-  return status;
-}
-
-int msDrawVBarChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  shapeObj    shape;
-  int         status=MS_SUCCESS;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  const char *chartScaleProcessingKey=msLayerGetProcessingKey( layer,"CHART_SCALE" );
-  double barWidth,scale=1.0;
-  double *values;
-  styleObj **styles;
-  pointObj center;
-  int numvalues = layer->numclasses;
-  int numvalues_for_shape;
-  if(chartSizeProcessingKey==NULL) {
-    barWidth=20;
-  } else {
-    if(sscanf(chartSizeProcessingKey ,"%lf",&barWidth) != 1) {
-      msSetError(MS_MISCERR, "msDrawChart format error for processing key \"CHART_SIZE\"", "msDrawVBarChartLayer()");
-      return MS_FAILURE;
-    }
-  }
-
-  if(chartScaleProcessingKey) {
-    if(sscanf(chartScaleProcessingKey,"%lf",&scale)!=1) {
-      msSetError(MS_MISCERR, "Error reading value for processing key \"CHART_SCALE\"", "msDrawVBarChartLayer()");
-      return MS_FAILURE;
-    }
-  }
-  msInitShape(&shape);
-
-  values=(double*)calloc(numvalues,sizeof(double));
-  MS_CHECK_ALLOC(values, numvalues*sizeof(double), MS_FAILURE);
-  styles = (styleObj**)malloc(numvalues*sizeof(styleObj*));
-  if (styles == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawVBarChartLayer()",
-               __FILE__, __LINE__, (unsigned int)(numvalues*sizeof(styleObj*)));
-    free(values);
-    return MS_FAILURE;
-  }
-
-  while(MS_SUCCESS == getNextShape(map,layer,values,&numvalues_for_shape,styles,&shape)) {
-    int i;
-    double h=0;
-    if(numvalues_for_shape == 0) {
-      continue;
-    }
-    for(i=0; i<numvalues_for_shape; i++) {
-      values[i]*=scale;
-      h += values[i];
-    }
-    msDrawStartShape(map, layer, image, &shape);
-    if(findChartPoint(map, &shape, barWidth,h, &center)==MS_SUCCESS) {
-      status = msDrawVBarChart(map,image,
-                               &center,
-                               values, styles, numvalues_for_shape,
-                               barWidth);
-    }
-    msDrawEndShape(map,layer,image,&shape);
-    msFreeShape(&shape);
-  }
-  free(values);
-  free(styles);
-  return status;
-}
-
-
-int msDrawBarChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  shapeObj    shape;
-  int         status=MS_SUCCESS;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  const char *barMax=msLayerGetProcessingKey( layer,"CHART_BAR_MAXVAL" );
-  const char *barMin=msLayerGetProcessingKey( layer,"CHART_BAR_MINVAL" );
-  double width,height;
-  double barWidth;
-  double *values;
-  styleObj **styles;
-  pointObj center;
-  double barMaxVal = 0.0,barMinVal = 0.0;
-  int numvalues = layer->numclasses;
-  int numvalues_for_shape;
-  if(chartSizeProcessingKey==NULL) {
-    width=height=20;
-  } else {
-    switch(sscanf(chartSizeProcessingKey ,"%lf %lf",&width,&height)) {
-      case 2:
-        break;
-      case 1:
-        height = width;
-        break;
-      default:
-        msSetError(MS_MISCERR, "msDrawChart format error for processing key \"CHART_SIZE\"", "msDrawBarChartLayer()");
-        return MS_FAILURE;
-    }
-  }
-
-  if(barMax) {
-    if(sscanf(barMax,"%lf",&barMaxVal)!=1) {
-      msSetError(MS_MISCERR, "Error reading value for processing key \"CHART_BAR_MAXVAL\"", "msDrawBarChartLayer()");
-      return MS_FAILURE;
-    }
-  }
-  if(barMin) {
-    if(sscanf(barMin,"%lf",&barMinVal)!=1) {
-      msSetError(MS_MISCERR, "Error reading value for processing key \"CHART_BAR_MINVAL\"", "msDrawBarChartLayer()");
-      return MS_FAILURE;
-    }
-  }
-  if(barMin && barMax && barMinVal>=barMaxVal) {
-    msSetError(MS_MISCERR, "\"CHART_BAR_MINVAL\" must be less than \"CHART_BAR_MAXVAL\"", "msDrawBarChartLayer()");
-    return MS_FAILURE;
-  }
-  barWidth=(double)width/(double)layer->numclasses;
-  if(!barWidth) {
-    msSetError(MS_MISCERR, "Specified width of chart too small to fit given number of classes", "msDrawBarChartLayer()");
-    return MS_FAILURE;
-  }
-
-  msInitShape(&shape);
-
-  values=(double*)calloc(numvalues,sizeof(double));
-  MS_CHECK_ALLOC(values, numvalues*sizeof(double), MS_FAILURE);
-  styles = (styleObj**)malloc(numvalues*sizeof(styleObj*));
-  if (styles == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawBarChartLayer()",
-               __FILE__, __LINE__, (unsigned int)(numvalues*sizeof(styleObj*)));
-    free(values);
-    return MS_FAILURE;
-  }
-
-  while(MS_SUCCESS == getNextShape(map,layer,values,&numvalues_for_shape,styles,&shape)) {
-    if(numvalues_for_shape == 0 ) continue;
-    msDrawStartShape(map, layer, image, &shape);
-    if(findChartPoint(map, &shape, width,height, &center)==MS_SUCCESS) {
-      status = msDrawBarChart(map,image,
-                              &center,
-                              values, styles, numvalues_for_shape,
-                              width,height,
-                              (barMax!=NULL)?&barMaxVal:NULL,
-                              (barMin!=NULL)?&barMinVal:NULL,
-                              barWidth);
-    }
-    msDrawEndShape(map,layer,image,&shape);
-    msFreeShape(&shape);
-  }
-  free(values);
-  free(styles);
-  return status;
-}
-
-/**
- * Generic function to render chart layers.
- */
-int msDrawChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-
-  rectObj     searchrect;
-  const char *chartTypeProcessingKey=msLayerGetProcessingKey( layer,"CHART_TYPE" );
-  int chartType=MS_CHART_TYPE_PIE;
-  int status = MS_FAILURE;
-
-  if (image && map) {
-    if( !(MS_RENDERER_PLUGIN(image->format) )) {
-      msSetError(MS_MISCERR, "chart drawing currently only supports GD and AGG renderers", "msDrawChartLayer()");
-      return MS_FAILURE;
-    }
-
-    if(chartTypeProcessingKey!=NULL) {
-      if( strcasecmp(chartTypeProcessingKey,"PIE") == 0 ) {
-        chartType=MS_CHART_TYPE_PIE;
-      } else if( strcasecmp(chartTypeProcessingKey,"BAR") == 0 ) {
-        chartType=MS_CHART_TYPE_BAR;
-      } else if( strcasecmp(chartTypeProcessingKey,"VBAR") == 0 ) {
-        chartType=MS_CHART_TYPE_VBAR;
-      } else {
-        msSetError(MS_MISCERR,"unknown chart type for processing key \"CHART_TYPE\", must be one of \"PIE\" or \"BAR\"", "msDrawChartLayer()");
-        return MS_FAILURE;
-      }
-    }
-    if(chartType == MS_CHART_TYPE_PIE) {
-      pieLayerProcessDynamicDiameter(layer);
-    }
-
-    /* open this layer */
-    status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-
-    status = msLayerWhichItems(layer, MS_FALSE, NULL);
-    if(status != MS_SUCCESS) {
-      msLayerClose(layer);
-      return MS_FAILURE;
-    }
-    /* identify target shapes */
-    if(layer->transform == MS_TRUE)
-      searchrect = map->extent;
-    else {
-      searchrect.minx = searchrect.miny = 0;
-      searchrect.maxx = map->width-1;
-      searchrect.maxy = map->height-1;
-    }
-
-    if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-      msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-
-    status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-    if(status == MS_DONE) { /* no overlap */
-      msLayerClose(layer);
-      if(chartType == MS_CHART_TYPE_PIE)
-        pieLayerCleanupDynamicDiameter(layer);
-      return MS_SUCCESS;
-    } else if(status != MS_SUCCESS) {
-      msLayerClose(layer);
-      if(chartType == MS_CHART_TYPE_PIE)
-        pieLayerCleanupDynamicDiameter(layer);
-      return MS_FAILURE;
-    }
-    switch(chartType) {
-      case MS_CHART_TYPE_PIE:
-        status = msDrawPieChartLayer(map, layer, image);
-        break;
-      case MS_CHART_TYPE_BAR:
-        status = msDrawBarChartLayer(map, layer, image);
-        break;
-      case MS_CHART_TYPE_VBAR:
-        status = msDrawVBarChartLayer(map, layer, image);
-        break;
-      default:
-        return MS_FAILURE;/*shouldn't be here anyways*/
-    }
-
-    msLayerClose(layer);
-
-    if(chartType == MS_CHART_TYPE_PIE)
-      pieLayerCleanupDynamicDiameter(layer);
-  }
-  return status;
-}
diff -pruN 8.0.1-5/mapcluster.c 8.2.0~beta1-1~exp1/mapcluster.c
--- 8.0.1-5/mapcluster.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcluster.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1802 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of the cluster layer data provider (RFC-69).
- * Author:   Tamas Szekeres (szekerest@gmail.com).
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#define _CRT_SECURE_NO_WARNINGS 1
-
-/* $Id$ */
-#include <assert.h>
-#include "mapserver.h"
-
-
-
-
-#ifdef USE_CLUSTER_PLUGIN
-#define USE_CLUSTER_EXTERNAL
-#endif
-
-/* custom attributes provided by this layer data source */
-#define MSCLUSTER_NUMITEMS        3
-#define MSCLUSTER_FEATURECOUNT    "Cluster_FeatureCount"
-#define MSCLUSTER_FEATURECOUNTINDEX   -100
-#define MSCLUSTER_GROUP    "Cluster_Group"
-#define MSCLUSTER_GROUPINDEX   -101
-#define MSCLUSTER_BASEFID    "Cluster_BaseFID"
-#define MSCLUSTER_BASEFIDINDEX   -102
-
-typedef struct cluster_tree_node clusterTreeNode;
-typedef struct cluster_info clusterInfo;
-typedef struct cluster_layer_info msClusterLayerInfo;
-
-/* forward declarations */
-void msClusterLayerCopyVirtualTable(layerVTableObj* vtable);
-static void clusterTreeNodeDestroy(msClusterLayerInfo* layerinfo, clusterTreeNode *node);
-
-/* cluster compare func */
-typedef int (*clusterCompareRegionFunc)(clusterInfo* current, clusterInfo* other);
-
-/* quadtree constants */
-#define SPLITRATIO  0.55
-#define TREE_MAX_DEPTH  10
-
-/* cluster algorithm */
-#define MSCLUSTER_ALGORITHM_FULL 0
-#define MSCLUSTER_ALGORITHM_SIMPLE 1
-
-/* cluster data */
-struct cluster_info {
-  double x;    /* x position of the current point */
-  double y;    /* y position of the current point */
-  double avgx; /* average x positions of this cluster */
-  double avgy; /* average y positions of this cluster */
-  double varx; /* variance of the x positions of this cluster */
-  double vary; /* variance of the y positions of this cluster */
-  shapeObj shape; /* current shape */
-  rectObj bounds; /* clustering region */
-  /* number of the neighbouring shapes */
-  int numsiblings;
-  /* diagnostics */
-  int numcollected;
-  int numremoved;
-  int index;
-  clusterTreeNode* node;
-  /* collection of the siblings */
-  clusterInfo* siblings;
-  /* next shape in the linked list */
-  clusterInfo* next;
-  /* current group */
-  char* group;
-  int filter;
-};
-
-/* quadtree node */
-struct cluster_tree_node {
-  /* area covered by this node */
-  rectObj rect;
-  /* linked list of the shapes stored at this node. */
-  int numshapes;
-  int index;
-  int position;
-  clusterInfo* shapes;
-  /* quad tree subnodes */
-  clusterTreeNode* subnode[4];
-};
-
-/* layeinfo */
-struct cluster_layer_info {
-  /* array of features (finalized clusters) */
-  clusterInfo* finalized;
-  clusterInfo* finalizedSiblings;
-  clusterInfo* filtered;
-  int numFeatures;
-  int numFinalized;
-  int numFinalizedSiblings;
-  int numFiltered;
-  /* variables for collecting the best cluster and iterating with NextShape */
-  clusterInfo* current;
-  /* check whether all shapes should be returned behind a cluster */
-  int get_all_shapes;
-  /* check whether the location of the shapes should be preserved (no averaging) */
-  int keep_locations;
-  /* the maxdistance and the buffer parameters are specified in map units (scale independent clustering) */
-  int use_map_units;
-  double rank;
-  /* root node of the quad tree */
-  clusterTreeNode* root;
-  int numNodes;
-  clusterTreeNode* finalizedNodes;
-  int numFinalizedNodes;
-  /* map extent used for building cluster data */
-  rectObj searchRect;
-  /* source layer parameters */
-  layerObj srcLayer;
-  /* distance comparator function */
-  clusterCompareRegionFunc fnCompare;
-  /* diagnostics */
-  int depth;
-  /* processing algorithm */
-  int algorithm;
-};
-
-
-extern int yyparse(parseObj *p);
-
-/* evaluate the filter expression */
-int msClusterEvaluateFilter(expressionObj* expression, shapeObj *shape)
-{
-  if (expression->type == MS_EXPRESSION) {
-    int status;
-    parseObj p;
-
-    p.shape = shape;
-    p.expr = expression;
-    p.expr->curtoken = p.expr->tokens; /* reset */
-    p.type = MS_PARSE_TYPE_BOOLEAN;
-
-    status = yyparse(&p);
-
-    if (status != 0) {
-      msSetError(MS_PARSEERR, "Failed to parse expression: %s", "msClusterEvaluateFilter", expression->string);
-      return 0;
-    }
-
-    return p.result.intval;
-  }
-
-  return 0;
-}
-
-/* get the group text when creating the clusters */
-char *msClusterGetGroupText(expressionObj* expression, shapeObj *shape)
-{
-  char *tmpstr=NULL;
-
-  if(expression->string) {
-    switch(expression->type) {
-      case(MS_STRING):
-        tmpstr = msStrdup(expression->string);
-        break;
-      case(MS_EXPRESSION): {
-        int status;
-        parseObj p;
-
-        p.shape = shape;
-        p.expr = expression;
-        p.expr->curtoken = p.expr->tokens; /* reset */
-        p.type = MS_PARSE_TYPE_STRING;
-
-        status = yyparse(&p);
-
-        if (status != 0) {
-          msSetError(MS_PARSEERR, "Failed to process text expression: %s", "msClusterGetGroupText", expression->string);
-          return NULL;
-        }
-
-        tmpstr = p.result.strval;
-        break;
-      }
-      default:
-        break;
-    }
-  }
-
-  return(tmpstr);
-}
-
-int CompareEllipseRegion(clusterInfo* current, clusterInfo* other)
-{
-  if (current->group && other->group && !EQUAL(current->group, other->group))
-    return MS_FALSE;
-
-  if ((other->x - current->x) * (other->x - current->x) /
-      ((current->bounds.maxx - current->x) * (current->bounds.maxx - current->x)) +
-      (other->y - current->y) * (other->y - current->y) /
-      ((current->bounds.maxy - current->y) * (current->bounds.maxy - current->y)) > 1)
-    return MS_FALSE;
-
-  return MS_TRUE;
-}
-
-int CompareRectangleRegion(clusterInfo* current, clusterInfo* other)
-{
-  if (current->group && other->group && !EQUAL(current->group, other->group))
-    return MS_FALSE;
-
-  if (other->x < current->bounds.minx)
-    return MS_FALSE;
-  if (other->x > current->bounds.maxx)
-    return MS_FALSE;
-  if (other->y < current->bounds.miny)
-    return MS_FALSE;
-  if (other->y > current->bounds.maxy)
-    return MS_FALSE;
-
-  return MS_TRUE;
-}
-
-static void treeSplitBounds( rectObj *in, rectObj *out1, rectObj *out2)
-{
-  double range;
-
-  /* -------------------------------------------------------------------- */
-  /*      The output bounds will be very similar to the input bounds,     */
-  /*      so just copy over to start.                                     */
-  /* -------------------------------------------------------------------- */
-  memcpy(out1, in, sizeof(rectObj));
-  memcpy(out2, in, sizeof(rectObj));
-
-  /* -------------------------------------------------------------------- */
-  /*      Split in X direction.                                           */
-  /* -------------------------------------------------------------------- */
-  if((in->maxx - in->minx) > (in->maxy - in->miny)) {
-    range = in->maxx - in->minx;
-
-    out1->maxx = in->minx + range * SPLITRATIO;
-    out2->minx = in->maxx - range * SPLITRATIO;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise split in Y direction.                                 */
-  /* -------------------------------------------------------------------- */
-  else {
-    range = in->maxy - in->miny;
-
-    out1->maxy = in->miny + range * SPLITRATIO;
-    out2->miny = in->maxy - range * SPLITRATIO;
-  }
-}
-
-/* alloc memory for a new tentative cluster */
-static clusterInfo *clusterInfoCreate(msClusterLayerInfo* layerinfo)
-{
-  clusterInfo* feature = (clusterInfo*)msSmallMalloc(sizeof(clusterInfo));
-  msInitShape(&feature->shape);
-  feature->numsiblings = 0;
-  feature->numcollected = 0;
-  feature->numremoved = 0;
-  feature->next = NULL;
-  feature->group = NULL;
-  feature->node = NULL;
-  feature->siblings = NULL;
-  feature->index = layerinfo->numFeatures;
-  feature->filter = -1; /* not yet calculated */
-  ++layerinfo->numFeatures;
-  return feature;
-}
-
-/* destroy memory of the cluster list */
-static void clusterInfoDestroyList(msClusterLayerInfo* layerinfo, clusterInfo* feature)
-{
-  clusterInfo* s = feature;
-  clusterInfo* next;
-  /* destroy the shapes added to this node */
-  while (s) {
-    next = s->next;
-    if (s->siblings) {
-      clusterInfoDestroyList(layerinfo, s->siblings);
-    }
-    msFreeShape(&s->shape);
-    msFree(s->group);
-    msFree(s);
-    --layerinfo->numFeatures;
-    s = next;
-  }
-}
-
-/* alloc memory for a new treenode */
-static clusterTreeNode *clusterTreeNodeCreate(msClusterLayerInfo* layerinfo, rectObj rect)
-{
-  clusterTreeNode* node = (clusterTreeNode*)msSmallMalloc(sizeof(clusterTreeNode));
-  node->rect = rect;
-  node->numshapes = 0;
-  node->shapes = NULL;
-  node->subnode[0] = node->subnode[1] = node->subnode[2] = node->subnode[3] = NULL;
-  node->index = layerinfo->numNodes;
-  node->position = 0;
-  ++layerinfo->numNodes;
-  return node;
-}
-
-/* traverse the quadtree and destroy all sub elements */
-static void clusterTreeNodeDestroy(msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
-  int i;
-  /* destroy the shapes added to this node */
-  clusterInfoDestroyList(layerinfo, node->shapes);
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i])
-      clusterTreeNodeDestroy(layerinfo, node->subnode[i]);
-  }
-
-  msFree(node);
-  --layerinfo->numNodes;
-}
-
-/* destroy memory of the cluster finalized list (without recursion) */
-static void clusterTreeNodeDestroyList(msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
-  clusterTreeNode* n = node;
-  clusterTreeNode* next;
-  /* destroy the list of nodes */
-  while (n) {
-    next = n->subnode[0];
-    n->subnode[0] = NULL;
-    clusterTreeNodeDestroy(layerinfo, n);
-    --layerinfo->numFinalizedNodes;
-    n = next;
-  }
-}
-
-void clusterDestroyData(msClusterLayerInfo *layerinfo)
-{
-  if (layerinfo->finalized) {
-    clusterInfoDestroyList(layerinfo, layerinfo->finalized);
-    layerinfo->finalized = NULL;
-  }
-  layerinfo->numFinalized = 0;
-
-  if (layerinfo->finalizedSiblings) {
-    clusterInfoDestroyList(layerinfo, layerinfo->finalizedSiblings);
-    layerinfo->finalizedSiblings = NULL;
-  }
-  layerinfo->numFinalizedSiblings = 0;
-
-  if (layerinfo->filtered) {
-    clusterInfoDestroyList(layerinfo, layerinfo->filtered);
-    layerinfo->filtered = NULL;
-  }
-  layerinfo->numFiltered = 0;
-
-  if (layerinfo->finalizedNodes) {
-    clusterTreeNodeDestroyList(layerinfo, layerinfo->finalizedNodes);
-    layerinfo->finalizedNodes = NULL;
-  }
-
-  layerinfo->numFinalizedNodes = 0;
-
-  if (layerinfo->root) {
-    clusterTreeNodeDestroy(layerinfo, layerinfo->root);
-    layerinfo->root = NULL;
-  }
-
-  layerinfo->numNodes = 0;
-}
-
-/* traverse the quadtree to find the neighbouring shapes and update some data
-on the related shapes (when adding a new feature)*/
-static void findRelatedShapes(msClusterLayerInfo* layerinfo,
-                              clusterTreeNode *node, clusterInfo* current)
-{
-  int i;
-  clusterInfo* s;
-
-  /* -------------------------------------------------------------------- */
-  /*      Does this node overlap the area of interest at all?  If not,    */
-  /*      return without adding to the list at all.                       */
-  /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &current->bounds))
-    return;
-
-  /* Modify the feature count of the related shapes */
-  s = node->shapes;
-  while (s) {
-    if (layerinfo->fnCompare(current, s)) {
-      ++current->numsiblings;
-      /* calculating the average positions */
-      current->avgx = (current->avgx * current->numsiblings + s->x) / (current->numsiblings + 1);
-      current->avgy = (current->avgy * current->numsiblings + s->y) / (current->numsiblings + 1);
-      /* calculating the variance */
-      current->varx = current->varx * current->numsiblings / (current->numsiblings + 1) +
-                      (s->x - current->avgx) * (s->x - current->avgx) / (current->numsiblings + 1);
-      current->vary = current->vary * current->numsiblings / (current->numsiblings + 1) +
-                      (s->y - current->avgy) * (s->y - current->avgy) / (current->numsiblings + 1);
-
-      if (layerinfo->fnCompare(s, current)) {
-        /* this feature falls into the region of the other as well */
-        ++s->numsiblings;
-        /* calculating the average positions */
-        s->avgx = (s->avgx * s->numsiblings + current->x) / (s->numsiblings + 1);
-        s->avgy = (s->avgy * s->numsiblings + current->y) / (s->numsiblings + 1);
-        /* calculating the variance */
-        s->varx = s->varx * s->numsiblings / (s->numsiblings + 1) +
-                  (current->x - s->avgx) * (current->x - s->avgx) / (s->numsiblings + 1);
-        s->vary = s->vary * s->numsiblings / (s->numsiblings + 1) +
-                  (current->y - s->avgy) * (current->y - s->avgy) / (s->numsiblings + 1);
-      }
-    }
-    s = s->next;
-  }
-
-  if (node->subnode[0] == NULL)
-    return;
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i])
-      findRelatedShapes(layerinfo, node->subnode[i], current);
-  }
-}
-
-/* traverse the quadtree to find the neighbouring clusters and update data on the cluster*/
-static void findRelatedShapes2(msClusterLayerInfo* layerinfo,
-                              clusterTreeNode *node, clusterInfo* current)
-{
-  int i;
-  clusterInfo* s;
-  
-  /* -------------------------------------------------------------------- */
-  /*      Does this node overlap the area of interest at all?  If not,    */
-  /*      return without adding to the list at all.                       */
-  /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &current->bounds))
-    return;
-
-  /* Modify the feature count of the related shapes */
-  s = node->shapes;
-  while (s) {
-    if (layerinfo->fnCompare(s, current)) {
-      if (layerinfo->rank > 0) {
-        double r = (current->x - s->x) * (current->x - s->x) + (current->y - s->y) * (current->y - s->y);
-        if (r < layerinfo->rank) {
-          layerinfo->current = s;
-          layerinfo->rank = r;
-        }
-      }
-      else {
-        /* no rank was specified, return immediately */
-        layerinfo->current = s;
-        return;
-      }      
-    }
-    s = s->next;
-  }
-
-  if (node->subnode[0] == NULL)
-    return;
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i])
-      findRelatedShapes2(layerinfo, node->subnode[i], current);
-  }
-}
-
-/* traverse the quadtree to find the neighbouring shapes and update some data
-on the related shapes (when removing a feature) */
-static void findRelatedShapesRemove(msClusterLayerInfo* layerinfo, clusterTreeNode *node, clusterInfo* current)
-{
-  int i;
-  clusterInfo* s;
-
-  /* -------------------------------------------------------------------- */
-  /*      Does this node overlap the area of interest at all?  If not,    */
-  /*      return without adding to the list at all.                       */
-  /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &current->bounds))
-    return;
-
-  /* Modify the feature count of the related shapes */
-  s = node->shapes;
-  while (s) {
-    if (layerinfo->fnCompare(current, s)) {
-      if (s->numsiblings > 0) {
-        /* calculating the average positions */
-        s->avgx = (s->avgx * (s->numsiblings + 1) - current->x) / s->numsiblings;
-        s->avgy = (s->avgy * (s->numsiblings + 1) - current->y) / s->numsiblings;
-        /* calculating the variance */
-        s->varx = (s->varx - (current->x - s->avgx) * (current->x - s->avgx) / s->numsiblings) *
-                  (s->numsiblings + 1) / s->numsiblings;
-        s->vary = (s->vary - (current->y - s->avgy) * (current->y - s->avgy) / s->numsiblings) *
-                  (s->numsiblings + 1) / s->numsiblings;
-        --s->numsiblings;
-        ++s->numremoved;
-      }
-    }
-    s = s->next;
-  }
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i])
-      findRelatedShapesRemove(layerinfo, node->subnode[i], current);
-  }
-}
-
-/* setting the aggregated attributes */
-static void InitShapeAttributes(layerObj* layer, clusterInfo* base)
-{
-  int i;
-  int* itemindexes = layer->iteminfo;
-
-  for (i = 0; i < layer->numitems; i++) {
-    if (base->shape.numvalues <= i)
-      break;
-
-    if (itemindexes[i] == MSCLUSTER_FEATURECOUNTINDEX) {
-      if (base->shape.values[i])
-        msFree(base->shape.values[i]);
-
-      base->shape.values[i] = msIntToString(base->numsiblings + 1);
-    } else if (itemindexes[i] == MSCLUSTER_GROUPINDEX) {
-      if (base->shape.values[i])
-        msFree(base->shape.values[i]);
-
-      if (base->group)
-        base->shape.values[i] = msStrdup(base->group);
-      else
-        base->shape.values[i] = msStrdup("");
-    } else if (itemindexes[i] == MSCLUSTER_BASEFIDINDEX) {
-      if (base->shape.values[i])
-        msFree(base->shape.values[i]);
-
-      base->shape.values[i] = msIntToString(base->shape.index);
-    } else if (EQUALN(layer->items[i], "Count:", 6)) {
-      if (base->shape.values[i])
-        msFree(base->shape.values[i]);
-
-      base->shape.values[i] = msStrdup("1"); /* initial count */
-    }
-  }
-}
-
-/* update the shape attributes (aggregate) */
-static void UpdateShapeAttributes(layerObj* layer, clusterInfo* base, clusterInfo* current)
-{
-  int i;
-  int* itemindexes = layer->iteminfo;
-
-  for (i = 0; i < layer->numitems; i++) {
-    if (base->shape.numvalues <= i)
-      break;
-
-    if (itemindexes[i] == MSCLUSTER_FEATURECOUNTINDEX ||
-        itemindexes[i] == MSCLUSTER_GROUPINDEX)
-      continue;
-
-    if (current->shape.numvalues <= i)
-      break;
-
-    /* setting the base feature index for each cluster member */
-    if (itemindexes[i] == MSCLUSTER_BASEFIDINDEX) {
-        msFree(current->shape.values[i]);
-        current->shape.values[i] = msIntToString(base->shape.index);
-    }
-
-    if (current->shape.values[i]) {
-      if (EQUALN(layer->items[i], "Min:", 4)) {
-        if (strcasecmp(base->shape.values[i], current->shape.values[i]) > 0) {
-          msFree(base->shape.values[i]);
-          base->shape.values[i] = msStrdup(current->shape.values[i]);
-        }
-      } else if (EQUALN(layer->items[i], "Max:", 4)) {
-        if (strcasecmp(base->shape.values[i], current->shape.values[i]) < 0) {
-          msFree(base->shape.values[i]);
-          base->shape.values[i] = msStrdup(current->shape.values[i]);
-        }
-      } else if (EQUALN(layer->items[i], "Sum:", 4)) {
-        double sum = atof(base->shape.values[i]) + atof(current->shape.values[i]);
-        msFree(base->shape.values[i]);
-        base->shape.values[i] = msDoubleToString(sum, MS_FALSE);
-      } else if (EQUALN(layer->items[i], "Count:", 6)) {
-        int count = atoi(base->shape.values[i]) + 1;
-        msFree(base->shape.values[i]);
-        base->shape.values[i] = msIntToString(count);
-      }
-    }
-  }
-}
-
-static int BuildFeatureAttributes(layerObj* layer, msClusterLayerInfo* layerinfo, shapeObj* shape)
-{
-  char** values;
-  int i;
-  int* itemindexes = layer->iteminfo;
-
-  if (layer->numitems == layerinfo->srcLayer.numitems)
-    return MS_SUCCESS; /* we don't have custom attributes, no need to reconstruct the array */
-
-  values = msSmallMalloc(sizeof(char*) * (layer->numitems));
-
-  for (i = 0; i < layer->numitems; i++) {
-    if (itemindexes[i] == MSCLUSTER_FEATURECOUNTINDEX) {
-      values[i] = NULL; /* not yet assigned */
-    } else if (itemindexes[i] == MSCLUSTER_GROUPINDEX) {
-      values[i] = NULL; /* not yet assigned */
-    } else if (itemindexes[i] == MSCLUSTER_BASEFIDINDEX) {
-      values[i] = NULL; /* not yet assigned */
-    } else if (shape->values[itemindexes[i]])
-      values[i] = msStrdup(shape->values[itemindexes[i]]);
-    else
-      values[i] = msStrdup("");
-  }
-
-  if (shape->values)
-    msFreeCharArray(shape->values, shape->numvalues);
-
-  shape->values = values;
-  shape->numvalues = layer->numitems;
-
-  return MS_SUCCESS;
-}
-
-/* traverse the quadtree to find the best renking cluster */
-static void findBestCluster(layerObj* layer, msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
-  int i;
-  double rank;
-  clusterInfo* s = node->shapes;
-  while (s) {
-    if (s->filter < 0 && layer->cluster.filter.string != NULL) {
-      InitShapeAttributes(layer, s);
-      s->filter = msClusterEvaluateFilter(&layer->cluster.filter, &s->shape);
-    }
-
-    if (s->numsiblings == 0 || s->filter == 0) {
-      /* individual or filtered shapes must be removed for sure */
-      layerinfo->current = s;
-      return;
-    }
-
-    /* calculating the rank */
-    rank = (s->x - s->avgx) * (s->x - s->avgx) + (s->y - s->avgy) * (s->y - s->avgy) /*+ s->varx + s->vary*/ + (double)1/ (1 + s->numsiblings);
-
-    if (rank < layerinfo->rank) {
-      layerinfo->current = s;
-      layerinfo->rank = rank;
-    }
-    s = s->next;
-  }
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i])
-      findBestCluster(layer, layerinfo, node->subnode[i]);
-  }
-}
-
-/* adding the shape based on the shape bounds (point) */
-static int treeNodeAddShape(msClusterLayerInfo* layerinfo, clusterTreeNode* node, clusterInfo* shape, int depth)
-{
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*      If there are subnodes, then consider whether this object        */
-  /*      will fit in them.                                               */
-  /* -------------------------------------------------------------------- */
-  if( depth > 1 && node->subnode[0] != NULL ) {
-    for(i = 0; i < 4; i++ ) {
-      if( msRectContained(&shape->shape.bounds, &node->subnode[i]->rect)) {
-        return treeNodeAddShape( layerinfo, node->subnode[i], shape, depth-1);
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise, consider creating four subnodes if could fit into    */
-  /*      them, and adding to the appropriate subnode.                    */
-  /* -------------------------------------------------------------------- */
-  else if( depth > 1 && node->subnode[0] == NULL ) {
-    rectObj half1, half2, quad1, quad2, quad3, quad4;
-    int subnode = -1;
-
-    treeSplitBounds(&node->rect, &half1, &half2);
-    treeSplitBounds(&half1, &quad1, &quad2);
-    treeSplitBounds(&half2, &quad3, &quad4);
-
-    if(msRectContained(&shape->shape.bounds, &quad1))
-      subnode = 0;
-    else if(msRectContained(&shape->shape.bounds, &quad2))
-      subnode = 1;
-    else if(msRectContained(&shape->shape.bounds, &quad3))
-      subnode = 2;
-    else if(msRectContained(&shape->shape.bounds, &quad4))
-      subnode = 3;
-
-    if (subnode >= 0) {
-      if ((node->subnode[0] = clusterTreeNodeCreate(layerinfo, quad1)) == NULL)
-        return MS_FAILURE;
-      node->subnode[0]->position = node->position * 4;
-
-      if ((node->subnode[1] = clusterTreeNodeCreate(layerinfo, quad2)) == NULL)
-        return MS_FAILURE;
-      node->subnode[1]->position = node->position * 4 + 1;
-
-      if ((node->subnode[2] = clusterTreeNodeCreate(layerinfo, quad3)) == NULL)
-        return MS_FAILURE;
-      node->subnode[2]->position = node->position * 4 + 2;
-
-      if ((node->subnode[3] = clusterTreeNodeCreate(layerinfo, quad4)) == NULL)
-        return MS_FAILURE;
-      node->subnode[3]->position = node->position * 4 + 3;
-
-      /* add to subnode */
-      return treeNodeAddShape(layerinfo, node->subnode[subnode], shape, depth-1);
-    }
-  }
-
-  /* found the right place, add this shape to the node */
-  node->numshapes++;
-  shape->next = node->shapes;
-  node->shapes = shape;
-  shape->node = node;
-
-  return MS_SUCCESS;
-}
-
-/* collecting the cluster shapes, returns true if this subnode must be removed */
-static int collectClusterShapes(msClusterLayerInfo* layerinfo, clusterTreeNode *node, clusterInfo* current)
-{
-  int i;
-  clusterInfo* prev = NULL;
-  clusterInfo* s = node->shapes;
-
-  if(!msRectOverlap(&node->rect, &current->bounds))
-    return (!node->shapes && !node->subnode[0] && !node->subnode[1]
-            && !node->subnode[2] && !node->subnode[3]);
-
-  /* removing the shapes from this node if overlap with the cluster */
-  while (s) {
-    if (s == current || layerinfo->fnCompare(current, s)) {
-      if (s != current && current->filter == 0) {
-        /* skip siblings of the filtered shapes */
-        prev = s;
-        s = prev->next;
-        continue;
-      }
-
-      /* removing from the list */
-      if (!prev)
-        node->shapes = s->next;
-      else
-        prev->next = s->next;
-
-      ++current->numcollected;
-
-      /* adding the shape to the finalization list */
-      if (s == current) {
-        if (s->filter) {
-          s->next = layerinfo->finalized;
-          layerinfo->finalized = s;
-          ++layerinfo->numFinalized;
-        } else {
-          /* this shape is filtered */
-          s->next = layerinfo->filtered;
-          layerinfo->filtered = s;
-          ++layerinfo->numFiltered;
-        }
-      } else {
-        s->next = layerinfo->finalizedSiblings;
-        layerinfo->finalizedSiblings = s;
-        ++layerinfo->numFinalizedSiblings;
-      }
-
-      if (!prev)
-        s = node->shapes;
-      else
-        s = prev->next;
-    } else {
-      prev = s;
-      s = prev->next;
-    }
-  }
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i] && collectClusterShapes(layerinfo, node->subnode[i], current)) {
-      /* placing this empty node to the finalization queue */
-      node->subnode[i]->subnode[0] = layerinfo->finalizedNodes;
-      layerinfo->finalizedNodes = node->subnode[i];
-      node->subnode[i] = NULL;
-      ++layerinfo->numFinalizedNodes;
-    }
-  }
-
-  /* returns true is this subnode must be removed */
-  return (!node->shapes && !node->subnode[0] && !node->subnode[1]
-          && !node->subnode[2] && !node->subnode[3]);
-}
-
-/* collecting the cluster shapes, returns true if this subnode must be removed */
-static int collectClusterShapes2(layerObj* layer, msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
-  int i;
-  clusterInfo* current = NULL;
-  clusterInfo* s;
-
-  while (node->shapes) {
-    s = node->shapes;
-    /* removing from the list */
-    node->shapes = s->next;
-
-    InitShapeAttributes(layer, s);
-
-    if (s->filter) {
-        s->next = layerinfo->finalized;
-        layerinfo->finalized = s;
-        ++layerinfo->numFinalized;
-    } else {
-        /* this shape is filtered */
-        s->next = layerinfo->filtered;
-        layerinfo->filtered = s;
-        ++layerinfo->numFiltered;
-    }
-
-    /* update the parameters of the related shapes if any */
-    if (s->siblings) {
-      current = s->siblings;
-      while(current) {
-        UpdateShapeAttributes(layer, s, current);
-
-        /* setting the average position to the cluster position */
-        current->avgx = s->x;
-        current->avgy = s->y;
-
-        if (current->next == NULL) {
-          if (layerinfo->get_all_shapes == MS_TRUE) {
-            /* insert the siblings into the finalization list */
-            current->next = layerinfo->finalized;
-            layerinfo->finalized = s->siblings;
-            s->siblings = NULL;
-          }
-          break;
-        }
-
-        current = current->next;
-      }
-    }
-  }
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i] && collectClusterShapes2(layer, layerinfo, node->subnode[i])) {
-      /* placing this empty node to the finalization queue */
-      node->subnode[i]->subnode[0] = layerinfo->finalizedNodes;
-      layerinfo->finalizedNodes = node->subnode[i];
-      node->subnode[i] = NULL;
-      ++layerinfo->numFinalizedNodes;
-    }
-  }
-
-  /* returns true is this subnode must be removed */
-  return (!node->shapes && !node->subnode[0] && !node->subnode[1]
-          && !node->subnode[2] && !node->subnode[3]);
-}
-
-int selectClusterShape(layerObj* layer, long shapeindex)
-{
-  int i;
-  clusterInfo* current;
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer not open: %s", "selectClusterShape()", layer->name);
-    return MS_FAILURE;
-  }
-
-  i = 0;
-  current = layerinfo->finalized;
-  while (current && i < shapeindex) {
-    ++i;
-    current = current->next;
-  }
-  assert(current);
-
-  current->next = current->siblings;
-  layerinfo->current = current;
-
-  if (layerinfo->keep_locations == MS_FALSE) {
-    current->shape.line[0].point[0].x = current->shape.bounds.minx = current->shape.bounds.maxx = current->avgx;
-    current->shape.line[0].point[0].y = current->shape.bounds.miny = current->shape.bounds.maxy = current->avgy;
-  }
-
-  return MS_SUCCESS;
-}
-
-/* update the parameters from the related shapes */
-#ifdef ms_notused
-static void UpdateClusterParameters(msClusterLayerInfo* layerinfo, clusterTreeNode *node, clusterInfo *shape)
-{
-  int i;
-  clusterInfo* s = node->shapes;
-
-  while (s) {
-    if (layerinfo->fnCompare(shape, s)) {
-      shape->avgx += s->x;
-      shape->avgy += s->y;
-      ++shape->numsiblings;
-    }
-    s = s->next;
-  }
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i])
-      UpdateClusterParameters(layerinfo, node->subnode[i], shape);
-  }
-}
-
-/* check for the validity of the clusters added to the tree (for debug purposes) */
-static int ValidateTree(msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
-  int i;
-  int isValid = MS_TRUE;
-
-  clusterInfo* s = node->shapes;
-  while (s) {
-    double avgx = s->avgx;
-    double avgy = s->avgy;
-    int numsiblings = s->numsiblings;
-
-    s->avgx = 0;
-    s->avgy = 0;
-    s->numsiblings = 0;
-
-    UpdateClusterParameters(layerinfo, layerinfo->root, s);
-
-    if (numsiblings + 1 != s->numsiblings)
-      isValid = MS_FALSE;
-    else if ((avgx * s->numsiblings - s->avgx) / s->avgx > 0.000001)
-      isValid = MS_FALSE;
-    else if ((avgy * s->numsiblings - s->avgy) / s->avgy > 0.000001)
-      isValid = MS_FALSE;
-
-    s->avgx = avgx;
-    s->avgy = avgy;
-    s->numsiblings = numsiblings;
-
-    if (isValid == MS_FALSE)
-      return MS_FALSE;
-
-    s = s->next;
-  }
-
-  /* Recurse to subnodes if they exist */
-  for (i = 0; i < 4; i++) {
-    if (node->subnode[i] && ValidateTree(layerinfo, node->subnode[i]) == MS_FALSE)
-      return MS_FALSE;
-  }
-
-  /* returns true if this node contains only valid clusters */
-  return MS_TRUE;
-}
-#endif
-
-/* rebuild the clusters according to the current extent */
-int RebuildClusters(layerObj *layer, int isQuery)
-{
-  mapObj* map;
-  layerObj* srcLayer;
-  double distance, maxDistanceX, maxDistanceY, cellSizeX, cellSizeY;
-  rectObj searchrect;
-  int status;
-  clusterInfo* current;
-  int depth;
-  const char *pszProcessing;
-#ifdef USE_CLUSTER_EXTERNAL
-  int layerIndex;
-#endif
-  reprojectionObj* reprojector = NULL;
-
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
-
-  if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "RebuildClusters()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (!layer->map) {
-    msSetError(MS_MISCERR, "No map associated with this layer: %s", "RebuildClusters()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (layer->debug >= MS_DEBUGLEVEL_VVV)
-    msDebug("Clustering started.\n");
-
-  map = layer->map;
-
-  layerinfo->current = layerinfo->finalized; /* restart */
-
-  /* check whether the simplified algorithm was selected */
-  pszProcessing = msLayerGetProcessingKey(layer, "CLUSTER_ALGORITHM");
-  if(pszProcessing && !strncasecmp(pszProcessing,"SIMPLE",6))
-      layerinfo->algorithm = MSCLUSTER_ALGORITHM_SIMPLE;
-  else
-      layerinfo->algorithm = MSCLUSTER_ALGORITHM_FULL;
-
-  /* check whether all shapes should be returned from a query */
-  if(msLayerGetProcessingKey(layer, "CLUSTER_GET_ALL_SHAPES") != NULL)
-    layerinfo->get_all_shapes = MS_TRUE;
-  else
-    layerinfo->get_all_shapes = MS_FALSE;
-
-  /* check whether the location of the shapes should be preserved */
-  if(msLayerGetProcessingKey(layer, "CLUSTER_KEEP_LOCATIONS") != NULL)
-    layerinfo->keep_locations = MS_TRUE;
-  else
-    layerinfo->keep_locations = MS_FALSE; 
-
-  /* check whether the maxdistance and the buffer parameters 
-  are specified in map units (scale independent clustering) */
-  if(msLayerGetProcessingKey(layer, "CLUSTER_USE_MAP_UNITS") != NULL)
-    layerinfo->use_map_units = MS_TRUE;
-  else
-    layerinfo->use_map_units = MS_FALSE;
-
-  /* identify the current extent */
-  if(layer->transform == MS_TRUE)
-    searchrect = map->extent;
-  else {
-    searchrect.minx = searchrect.miny = 0;
-    searchrect.maxx = map->width-1;
-    searchrect.maxy = map->height-1;
-  }
-
-  if (searchrect.minx == layerinfo->searchRect.minx &&
-      searchrect.miny == layerinfo->searchRect.miny &&
-      searchrect.maxx == layerinfo->searchRect.maxx &&
-      searchrect.maxy == layerinfo->searchRect.maxy) {
-    /* already built */
-    return MS_SUCCESS;
-  }
-
-  /* destroy previous data*/
-  clusterDestroyData(layerinfo);
-
-  layerinfo->searchRect = searchrect;
-
-  /* reproject the rectangle to layer coordinates */
-  if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-    msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-
-  /* determine the compare method */
-  layerinfo->fnCompare = CompareRectangleRegion;
-  if (layer->cluster.region) {
-    if (EQUAL(layer->cluster.region, "ellipse"))
-      layerinfo->fnCompare = CompareEllipseRegion;
-  }
-
-  /* trying to find a reasonable quadtree depth */
-  depth = 0;
-  distance = layer->cluster.maxdistance;
-  if (layerinfo->use_map_units == MS_TRUE) {
-    while ((distance < (searchrect.maxx - searchrect.minx) || distance < (searchrect.maxy - searchrect.miny)) && depth <= TREE_MAX_DEPTH) {
-      distance *= 2;
-      ++depth;
-    }
-    cellSizeX = 1;
-    cellSizeY = 1;
-  }
-  else {
-    while ((distance < map->width || distance < map->height) && depth <= TREE_MAX_DEPTH) {
-      distance *= 2;
-      ++depth;
-    }
-    cellSizeX = MS_CELLSIZE(searchrect.minx, searchrect.maxx, map->width);
-    cellSizeY = MS_CELLSIZE(searchrect.miny, searchrect.maxy, map->height);
-  }
-
-  layerinfo->depth = depth;
-
-  maxDistanceX = layer->cluster.maxdistance * cellSizeX;
-  maxDistanceY = layer->cluster.maxdistance * cellSizeY;
-
-  /* increase the search rectangle so that the neighbouring shapes are also retrieved */
-  searchrect.minx -= layer->cluster.buffer * cellSizeX;
-  searchrect.maxx += layer->cluster.buffer * cellSizeX;
-  searchrect.miny -= layer->cluster.buffer * cellSizeY;
-  searchrect.maxy += layer->cluster.buffer * cellSizeY;
-
-  /* create the root node */
-  if (layerinfo->root)
-    clusterTreeNodeDestroy(layerinfo, layerinfo->root);
-  layerinfo->root = clusterTreeNodeCreate(layerinfo, searchrect);
-
-  srcLayer = &layerinfo->srcLayer;
-
-  /* start retrieving the shapes */
-  status = msLayerWhichShapes(srcLayer, searchrect, isQuery);
-  if(status == MS_DONE) {
-    /* no overlap */
-    return MS_SUCCESS;
-  } else if(status != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-  /* step through the source shapes and populate the quadtree with the tentative clusters */
-  if ((current = clusterInfoCreate(layerinfo)) == NULL)
-    return MS_FAILURE;
-
-#if defined(USE_CLUSTER_EXTERNAL)
-    if(srcLayer->transform == MS_TRUE && srcLayer->project && layer->transform == MS_TRUE && layer->project &&msProjectionsDiffer(&(srcLayer->projection), &(layer->projection)))
-    {
-        reprojector = msProjectCreateReprojector(&srcLayer->projection, &layer->projection);
-    }
-#endif
-  
-  while((status = msLayerNextShape(srcLayer, &current->shape)) == MS_SUCCESS) {
-#if defined(USE_CLUSTER_EXTERNAL)
-    /* transform the shape to the projection of this layer */
-    if( reprojector )
-      msProjectShapeEx(reprojector, &current->shape);
-#endif
-    /* set up positions and variance */
-    current->avgx = current->x = current->shape.bounds.minx;
-    current->avgy = current->y = current->shape.bounds.miny;
-    current->varx = current->vary = 0;
-    /* set up the area of interest when searching for the neighboring shapes */
-    current->bounds.minx = current->x - maxDistanceX;
-    current->bounds.miny = current->y - maxDistanceY;
-    current->bounds.maxx = current->x + maxDistanceX;
-    current->bounds.maxy = current->y + maxDistanceY;
-
-    /* if the shape doesn't overlap we must skip it to avoid further issues */
-    if(!msRectOverlap(&searchrect, &current->bounds)) {
-      msFreeShape(&current->shape);
-      msInitShape(&current->shape);
-
-      msDebug("Skipping an invalid shape falling outside of the given extent\n");
-      continue;
-    }
-
-    /* construct the item array */
-    if (layer->iteminfo)
-      BuildFeatureAttributes(layer, layerinfo, &current->shape);
-
-    /* evaluate the group expression */
-    if (layer->cluster.group.string)
-      current->group = msClusterGetGroupText(&layer->cluster.group, &current->shape);
-
-    if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_FULL) {
-      /*start a query for the related shapes */
-      findRelatedShapes(layerinfo, layerinfo->root, current);
-
-      /* add this shape to the tree */
-      if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) != MS_SUCCESS) {
-        clusterInfoDestroyList(layerinfo, current);
-        msProjectDestroyReprojector(reprojector);
-        return MS_FAILURE;
-      }
-    }
-    else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
-      /* find a related cluster and try to assign */
-      layerinfo->rank = 0;
-      layerinfo->current = NULL;
-      findRelatedShapes2(layerinfo, layerinfo->root, current);
-      if (layerinfo->current) {
-        /* store these points until all clusters are created */
-        current->next = layerinfo->finalizedSiblings;
-        layerinfo->finalizedSiblings = current;
-      }
-      else {
-        /* if not found add this shape as a new cluster */
-        if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) != MS_SUCCESS) {
-          clusterInfoDestroyList(layerinfo, current);
-          msProjectDestroyReprojector(reprojector);
-          return MS_FAILURE;
-        }
-      }
-    }
-
-    if ((current = clusterInfoCreate(layerinfo)) == NULL) {
-      clusterInfoDestroyList(layerinfo, current);
-      msProjectDestroyReprojector(reprojector);
-      return MS_FAILURE;
-    }
-  }
-
-  msProjectDestroyReprojector(reprojector);
-
-  clusterInfoDestroyList(layerinfo, current);
-
-  if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_FULL) {
-    while (layerinfo->root) {
-#ifdef TESTCOUNT
-      int n;
-      double avgx, avgy;
-#endif
-
-      /* pick up the best cluster from the tree and do the finalization */
-      /* the initial rank must be big enough */
-      layerinfo->rank = (searchrect.maxx - searchrect.minx) * (searchrect.maxx - searchrect.minx) +
-                        (searchrect.maxy - searchrect.miny) * (searchrect.maxy - searchrect.miny) + 1;
-      
-      layerinfo->current = NULL;
-      findBestCluster(layer, layerinfo, layerinfo->root);
-      
-      if (layerinfo->current == NULL) {
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug("Clustering terminated.\n");
-        break; /* completed */
-      }
-
-      /* Update the feature count of the shape */
-      InitShapeAttributes(layer, layerinfo->current);
-      
-      /* collecting the shapes of the cluster */
-      collectClusterShapes(layerinfo, layerinfo->root, layerinfo->current);
-
-      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
-        msDebug("processing cluster %p: rank=%lf fcount=%d ncoll=%d nfin=%d nfins=%d nflt=%d bounds={%lf %lf %lf %lf}\n", layerinfo->current, layerinfo->rank, layerinfo->current->numsiblings + 1,
-              layerinfo->current->numcollected, layerinfo->numFinalized, layerinfo->numFinalizedSiblings,
-              layerinfo->numFiltered, layerinfo->current->bounds.minx, layerinfo->current->bounds.miny,
-              layerinfo->current->bounds.maxx, layerinfo->current->bounds.maxy);
-        if (layerinfo->current->node) {
-          char pszBuffer[TREE_MAX_DEPTH + 1];
-          clusterTreeNode* node = layerinfo->current->node;
-          int position = node->position;
-          int i = 1;
-          while (position > 0 && i <= TREE_MAX_DEPTH) {
-            pszBuffer[TREE_MAX_DEPTH - i] = '0' + (position % 4);
-            position = position >> 2;
-            ++i;
-          }
-          pszBuffer[TREE_MAX_DEPTH] = 0;
-        
-          msDebug(" ->node %p: count=%d index=%d pos=%s subn={%p %p %p %p} rect={%lf %lf %lf %lf}\n",
-                  node, node->numshapes, node->index, pszBuffer + TREE_MAX_DEPTH - i + 1,
-                  node->subnode[0], node->subnode[1], node->subnode[2], node->subnode[3],
-                node->rect.minx, node->rect.miny, node->rect.maxx, node->rect.maxy);
-        }
-      }
-
-#ifdef TESTCOUNT
-      avgx = layerinfo->current->x;
-      avgy = layerinfo->current->y;
-      n = 0;
-#endif
-
-      if (layerinfo->current->numsiblings > 0) {
-        /* update the parameters due to the shape removal */
-        findRelatedShapesRemove(layerinfo, layerinfo->root, layerinfo->current);
-  
-        if (layerinfo->current->filter == 0) {
-          /* filtered shapes has no siblings */
-          layerinfo->current->numsiblings = 0;
-          layerinfo->current->avgx = layerinfo->current->x;
-          layerinfo->current->avgy = layerinfo->current->y;
-        }
-
-        /* update the parameters of the related shapes if any */
-        if (layerinfo->finalizedSiblings) {
-          current = layerinfo->finalizedSiblings;
-          while(current) {
-            /* update the parameters due to the shape removal */
-            findRelatedShapesRemove(layerinfo, layerinfo->root, current);
-            UpdateShapeAttributes(layer, layerinfo->current, current);
-#ifdef TESTCOUNT
-            avgx += current->x;
-            avgy += current->y;
-            ++n;
-#endif
-            /* setting the average position to the same value */
-            current->avgx = layerinfo->current->avgx;
-            current->avgy = layerinfo->current->avgy;
-
-            if (current->next == NULL) {
-              if (layerinfo->get_all_shapes == MS_TRUE) {
-                /* insert the siblings into the finalization list */
-                current->next = layerinfo->finalized;
-                layerinfo->finalized = layerinfo->finalizedSiblings;
-              } else {
-              /* preserve the clustered siblings for later use */
-                layerinfo->current->siblings = layerinfo->finalizedSiblings;
-              }
-              break;
-            }
-
-            current = current->next;
-          }
-
-          layerinfo->finalizedSiblings = NULL;
-        }
-      }
-
-#ifdef TESTCOUNT
-      avgx /= (n + 1);
-      avgy /= (n + 1);
-
-      if (layerinfo->current->numsiblings != n)
-        layerinfo->current->numsiblings = n;
-
-      if (fabs(layerinfo->current->avgx - avgx) / avgx > 0.000000001 ||
-          fabs(layerinfo->current->avgy - avgy) / avgy > 0.000000001) {
-        layerinfo->current->avgx = avgx;
-        layerinfo->current->avgy = avgy;
-      }
-#endif
-    }
-  }
-  else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
-    /* assingn stired points to clusters */
-    while (layerinfo->finalizedSiblings) {
-      current = layerinfo->finalizedSiblings;
-      layerinfo->rank = maxDistanceX * maxDistanceX + maxDistanceY * maxDistanceY;
-      layerinfo->current = NULL;      
-      findRelatedShapes2(layerinfo, layerinfo->root, current);
-      if (layerinfo->current) {
-        clusterInfo* s = layerinfo->current;
-        /* found a matching cluster */
-        ++s->numsiblings;
-        /* assign to cluster */
-        layerinfo->finalizedSiblings = current->next;
-        current->next = s->siblings;
-        s->siblings = current;
-      }
-      else {
-        /* this appears to be a bug */
-        layerinfo->finalizedSiblings = current->next;
-        current->next = layerinfo->filtered;
-        layerinfo->filtered = current;
-        ++layerinfo->numFiltered;
-      }     
-    }
-    
-    /* collecting the shapes of the cluster */
-    collectClusterShapes2(layer, layerinfo, layerinfo->root);
-  }
-
-  /* set the pointer to the first shape */
-  layerinfo->current = layerinfo->finalized;
-
-  return MS_SUCCESS;
-}
-
-/* Close the the combined layer */
-int msClusterLayerClose(layerObj *layer)
-{
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo)
-    return MS_SUCCESS;
-
-  clusterDestroyData(layerinfo);
-
-  msLayerClose(&layerinfo->srcLayer);
-  freeLayer(&layerinfo->srcLayer);
-
-  msFree(layerinfo);
-  layer->layerinfo = NULL;
-
-#ifndef USE_CLUSTER_EXTERNAL
-  /* switch back to the source layer vtable */
-  if( msInitializeVirtualTable(layer) != MS_SUCCESS )
-      return MS_FAILURE;
-#endif
-
-  return MS_SUCCESS;
-}
-
-/* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
-int msClusterLayerIsOpen(layerObj *layer)
-{
-  if (layer->layerinfo)
-    return(MS_TRUE);
-  else
-    return(MS_FALSE);
-}
-
-/* Free the itemindexes array in a layer. */
-void msClusterLayerFreeItemInfo(layerObj *layer)
-{
-  msFree(layer->iteminfo);
-  layer->iteminfo = NULL;
-}
-
-
-/* allocate the iteminfo index array - same order as the item list */
-int msClusterLayerInitItemInfo(layerObj *layer)
-{
-  int i, numitems;
-  int *itemindexes;
-
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
-
-  if(layer->numitems == 0) {
-    return MS_SUCCESS;
-  }
-
-  if (!layerinfo)
-    return MS_FAILURE;
-
-  /* Cleanup any previous item selection */
-  msClusterLayerFreeItemInfo(layer);
-
-  layer->iteminfo = (int *) msSmallMalloc(sizeof(int) * layer->numitems);
-
-  itemindexes = layer->iteminfo;
-
-  /* check whether we require attributes from the source layers also */
-  numitems = 0;
-  for (i = 0; i < layer->numitems; i++) {
-    if (EQUAL(layer->items[i], MSCLUSTER_FEATURECOUNT))
-      itemindexes[i] = MSCLUSTER_FEATURECOUNTINDEX;
-    else if (EQUAL(layer->items[i], MSCLUSTER_GROUP))
-      itemindexes[i] = MSCLUSTER_GROUPINDEX;
-    else if (EQUAL(layer->items[i], MSCLUSTER_BASEFID))
-      itemindexes[i] = MSCLUSTER_BASEFIDINDEX;
-    else
-      itemindexes[i] = numitems++;
-  }
-
-  msLayerFreeItemInfo(&layerinfo->srcLayer);
-  if(layerinfo->srcLayer.items) {
-    msFreeCharArray(layerinfo->srcLayer.items, layerinfo->srcLayer.numitems);
-    layerinfo->srcLayer.items = NULL;
-    layerinfo->srcLayer.numitems = 0;
-  }
-
-  if (numitems > 0) {
-    /* now allocate and set the layer item parameters  */
-    layerinfo->srcLayer.items = (char **)msSmallMalloc(sizeof(char *)*numitems);
-    layerinfo->srcLayer.numitems = numitems;
-
-    for (i = 0; i < layer->numitems; i++) {
-      if (itemindexes[i] >= 0) {
-        if (EQUALN(layer->items[i], "Min:", 4))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 4);
-        else if (EQUALN(layer->items[i], "Max:", 4))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 4);
-        else if (EQUALN(layer->items[i], "Sum:", 4))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 4);
-        else if (EQUALN(layer->items[i], "Count:", 6))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 6);
-        else
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i]);
-      }
-    }
-
-    if (msLayerInitItemInfo(&layerinfo->srcLayer) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/* Execute a query for this layer */
-int msClusterLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)rect;
-  /* rebuild the cluster database */
-  return RebuildClusters(layer, isQuery);
-}
-
-static int prepareShape(layerObj* layer, msClusterLayerInfo* layerinfo, clusterInfo* current, shapeObj* shape)
-{
-  (void)layer;
-  if (msCopyShape(&(current->shape), shape) != MS_SUCCESS) {
-    msSetError(MS_SHPERR, "Cannot retrieve inline shape. There some problem with the shape", "msClusterLayerNextShape()");
-    return MS_FAILURE;
-  }
-
-  /* update the positions of the cluster shape */
-  if (layerinfo->keep_locations == MS_FALSE) {
-    shape->line[0].point[0].x = shape->bounds.minx = shape->bounds.maxx = current->avgx;
-    shape->line[0].point[0].y = shape->bounds.miny = shape->bounds.maxy = current->avgy;
-  }
-
-  return MS_SUCCESS;
-}
-
-/* Execute a query on the DB based on fid. */
-int msClusterLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  clusterInfo* current;
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerGetShape()", layer->name);
-    return MS_FAILURE;
-  }
-
-  current = layerinfo->finalized;
-  while (current) {
-    if (record->shapeindex == current->shape.index &&
-        record->tileindex == current->shape.tileindex)
-      break;
-    current = current->next;
-  }
-
-  if (current == NULL) {
-    msSetError(MS_SHPERR, "No feature with this index.", "msClusterLayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  return prepareShape(layer, layerinfo, current, shape);
-}
-
-/* find the next shape with the appropriate shape type */
-/* also, load in the attribute data */
-/* MS_DONE => no more data */
-int msClusterLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  int rv;
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerNextShape()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (!layerinfo->current)
-    return MS_DONE;
-
-  rv = prepareShape(layer, layerinfo, layerinfo->current, shape);
-
-  layerinfo->current = layerinfo->current->next;
-
-  return rv;
-}
-
-/* Query for the items collection */
-int msClusterLayerGetItems(layerObj *layer)
-{
-  /* we support certain built in attributes */
-  layer->numitems = MSCLUSTER_NUMITEMS;
-  layer->items = msSmallMalloc(sizeof(char*) * (layer->numitems));
-  layer->items[0] = msStrdup(MSCLUSTER_FEATURECOUNT);
-  layer->items[1] = msStrdup(MSCLUSTER_GROUP);
-  layer->items[2] = msStrdup(MSCLUSTER_BASEFID);
-
-  return msClusterLayerInitItemInfo(layer);
-}
-
-
-int msClusterLayerGetNumFeatures(layerObj *layer)
-{
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo)
-    return -1;
-
-  return layerinfo->numFinalized;
-}
-
-static int msClusterLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
-                                      shapeObj* shape)
-{
-  (void)map;
-  (void)layer;
-  (void)c;
-  (void)shape;
-  /* TODO */
-  return MS_SUCCESS;
-}
-
-msClusterLayerInfo* msClusterInitialize(layerObj *layer)
-{
-  msClusterLayerInfo *layerinfo =(msClusterLayerInfo*)msSmallMalloc(sizeof(msClusterLayerInfo));
-
-  layer->layerinfo = layerinfo;
-
-  layerinfo->searchRect.minx = -1;
-  layerinfo->searchRect.miny = -1;
-  layerinfo->searchRect.maxx = -1;
-  layerinfo->searchRect.maxy = -1;
-
-  layerinfo->root = NULL;
-
-  layerinfo->get_all_shapes = MS_FALSE;
-
-  layerinfo->numFeatures = 0;
-  layerinfo->numNodes = 0;
-
-  layerinfo->finalized = NULL;
-  layerinfo->numFinalized = 0;
-  layerinfo->finalizedSiblings = NULL;
-  layerinfo->numFinalizedSiblings = 0;
-  layerinfo->filtered = NULL;
-  layerinfo->numFiltered = 0;
-
-  layerinfo->finalizedNodes = NULL;
-  layerinfo->numFinalizedNodes = 0;
-
-  return layerinfo;
-}
-
-int msClusterLayerOpen(layerObj *layer)
-{
-  msClusterLayerInfo* layerinfo;
-
-  if (layer->type != MS_LAYER_POINT) {
-    msSetError(MS_MISCERR, "Only point layers are supported for clustering: %s", "msClusterLayerOpen()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (!layer->map)
-    return MS_FAILURE;
-
-  if (layer->layerinfo)
-  {
-    if (layer->vtable->LayerOpen != msClusterLayerOpen)
-        msLayerClose(layer);
-    else
-      return MS_SUCCESS;  /* already open */
-  }
-
-  layerinfo = msClusterInitialize(layer);
-
-  if (!layer->layerinfo)
-    return MS_FAILURE;
-
-  /* prepare the source layer */
-  if(initLayer(&layerinfo->srcLayer, layer->map) == -1)
-    return MS_FAILURE;
-
-#ifdef USE_CLUSTER_EXTERNAL
-  if (!layer->map)
-    return MS_FAILURE;
-
-  layerIndex = msGetLayerIndex(layer->map, layer->connection);
-
-  if (layerIndex < 0 && layerIndex >= layer->map->numlayers) {
-    msSetError(MS_MISCERR, "No source layers specified in layer: %s", "msClusterLayerOpen()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (layer->map->layers[layerIndex]->type != MS_LAYER_POINT) {
-    msSetError(MS_MISCERR, "Only point layers are supported for cluster data source: %s", "msClusterLayerOpen()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (msCopyLayer(&layerinfo->srcLayer, layer->map->layers[layerIndex]) != MS_SUCCESS)
-    return(MS_FAILURE);
-#else
-  /* hook the vtable to this driver, will be restored in LayerClose*/
-  if (!layer->vtable) {
-    if (msInitializeVirtualTable(layer) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-  assert(layer->vtable);
-  msClusterLayerCopyVirtualTable(layer->vtable);
-
-  if (msCopyLayer(&layerinfo->srcLayer, layer) != MS_SUCCESS)
-    return(MS_FAILURE);
-#endif
-
-  /* disable the connection pool for this layer */
-  msLayerSetProcessingKey(&layerinfo->srcLayer, "CLOSE_CONNECTION", "ALWAYS");
-
-  /* open the source layer */
-  if ( !layerinfo->srcLayer.vtable) {
-    if (msInitializeVirtualTable(&layerinfo->srcLayer) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-
-  if (layerinfo->srcLayer.vtable->LayerOpen(&layerinfo->srcLayer) != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-int msClusterLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-  (void)filter;
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
-
-  if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "msClusterLayerTranslateFilter()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (layerinfo->srcLayer.filter.type == MS_EXPRESSION && layerinfo->srcLayer.filter.tokens == NULL)
-    msTokenizeExpression(&(layerinfo->srcLayer.filter), layer->items, &(layer->numitems));
-
-  return layerinfo->srcLayer.vtable->LayerTranslateFilter(&layerinfo->srcLayer, &layerinfo->srcLayer.filter, filteritem);
-}
-
-char* msClusterLayerEscapeSQLParam(layerObj *layer, const char* pszString)
-{
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
-
-  if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "msClusterLayerEscapeSQLParam()", layer->name);
-    return msStrdup("");
-  }
-
-  return layerinfo->srcLayer.vtable->LayerEscapeSQLParam(&layerinfo->srcLayer, pszString);
-}
-
-int msClusterLayerGetAutoProjection(layerObj *layer, projectionObj* projection)
-{
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
-
-  if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "msClusterLayerGetAutoProjection()", layer->name);
-    return MS_FAILURE;
-  }
-
-  return layerinfo->srcLayer.vtable->LayerGetAutoProjection(&layerinfo->srcLayer, projection);
-}
-
-int msClusterLayerGetPaging(layerObj *layer)
-{
-  (void)layer;
-  return MS_FALSE;
-}
-
-void msClusterLayerEnablePaging(layerObj *layer, int value)
-{
-  (void)layer;
-  (void)value;
-}
-
-void msClusterLayerCopyVirtualTable(layerVTableObj* vtable)
-{
-  vtable->LayerInitItemInfo = msClusterLayerInitItemInfo;
-  vtable->LayerFreeItemInfo = msClusterLayerFreeItemInfo;
-  vtable->LayerOpen = msClusterLayerOpen;
-  vtable->LayerIsOpen = msClusterLayerIsOpen;
-  vtable->LayerWhichShapes = msClusterLayerWhichShapes;
-  vtable->LayerNextShape = msClusterLayerNextShape;
-  vtable->LayerGetShape = msClusterLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-
-  vtable->LayerClose = msClusterLayerClose;
-
-  vtable->LayerGetItems = msClusterLayerGetItems;
-  vtable->LayerCloseConnection = msClusterLayerClose;
-
-  vtable->LayerGetNumFeatures = msClusterLayerGetNumFeatures;
-  vtable->LayerGetAutoStyle = msClusterLayerGetAutoStyle;
-  vtable->LayerTranslateFilter = msClusterLayerTranslateFilter;
-  /* vtable->LayerSupportsCommonFilters, use driver implementation */
-  vtable->LayerEscapeSQLParam = msClusterLayerEscapeSQLParam;
-  /* vtable->LayerEscapePropertyName, use driver implementation */
-
-  vtable->LayerEnablePaging = msClusterLayerEnablePaging;
-  vtable->LayerGetPaging = msClusterLayerGetPaging;
-  vtable->LayerGetAutoProjection = msClusterLayerGetAutoProjection;
-}
-
-#ifdef USE_CLUSTER_PLUGIN
-
-MS_DLL_EXPORT  int
-PluginInitializeVirtualTable(layerVTableObj* vtable, layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(vtable != NULL);
-
-  msClusterLayerCopyVirtualTable(vtable);
-
-  return MS_SUCCESS;
-}
-
-#endif
-
-int msClusterLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  msClusterLayerCopyVirtualTable(layer->vtable);
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapcompositingfilter.c 8.2.0~beta1-1~exp1/mapcompositingfilter.c
--- 8.0.1-5/mapcompositingfilter.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcompositingfilter.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,220 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  RFC 113 Layer compositing
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2015 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-#include "mapserver.h"
-#include <regex.h>
-#define pixmove(rb,srcx,srcy,dstx,dsty) \
-  memcpy(rb->data.rgba.pixels+dsty*rb->data.rgba.row_step+dstx*4,\
-          rb->data.rgba.pixels+srcy*rb->data.rgba.row_step+srcx*4,\
-          4)
-#define pixerase(rb,x,y) memset(rb->data.rgba.pixels+y*rb->data.rgba.row_step+x*4,0,4)
-
-void msApplyTranslationCompositingFilter(rasterBufferObj *rb, int xtrans, int ytrans) {
-  int src_sx,src_sy,dst_sx,dst_sy;
-  if((unsigned)abs(xtrans)>=rb->width || (unsigned)abs(ytrans)>=rb->height) {
-    for(unsigned y = 0; y<rb->height; y++)
-      for(unsigned x = 0; x<rb->width; x++)
-        pixerase(rb,x,y);
-  }
-  if(xtrans == 0 && ytrans == 0)
-    return;
-  if(xtrans>=0) {
-    if(ytrans>=0) {
-      src_sx = rb->width - xtrans - 1;
-      src_sy = rb->height - ytrans - 1;
-      dst_sx = rb->width - 1;
-      dst_sy = rb->height -1;
-      for(int y = src_sy,dst_y= dst_sy;y>=0;y--,dst_y--) {
-        for(int x = src_sx,dst_x= dst_sx;x>=0;x--,dst_x--) {
-          pixmove(rb,x,y,dst_x,dst_y);
-        }
-      }
-      for(int y=0;y<ytrans;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);  
-      for(unsigned y=ytrans;y<rb->height;y++)
-        for(int x=0;x<xtrans;x++)
-          pixerase(rb,x,y);
-    } else {
-      src_sx = rb->width - xtrans - 1;
-      src_sy = - ytrans;
-      dst_sx = rb->width - 1;
-      dst_sy = 0;
-      for(unsigned y = src_sy,dst_y= dst_sy;y<rb->height;y++,dst_y++) {
-        for(int x = src_sx,dst_x= dst_sx;x>=0;x--,dst_x--) {
-          pixmove(rb,x,y,dst_x,dst_y);
-        }
-      }
-      for(unsigned y=0;y<rb->height+ytrans;y++)
-        for(int x=0;x<xtrans;x++)
-          pixerase(rb,x,y);  
-      for(unsigned y=rb->height+ytrans;y<rb->height;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);
-    }
-  } else {
-    if(ytrans>=0) {
-      src_sx = - xtrans;
-      src_sy = rb->height - ytrans - 1;
-      dst_sx = 0;
-      dst_sy = rb->height -1;
-      for(int y = src_sy,dst_y= dst_sy;y>=0;y--,dst_y--) {
-        for(unsigned x = src_sx,dst_x= dst_sx;x<rb->width;x++,dst_x++) {
-          pixmove(rb,x,y,dst_x,dst_y);
-        }
-      }
-      for(int y=0;y<ytrans;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);
-      for(unsigned y=ytrans;y<rb->height;y++)
-        for(unsigned x=rb->width+xtrans;x<rb->width;x++)
-          pixerase(rb,x,y);
-    } else {
-      src_sx = - xtrans;
-      src_sy = - ytrans;
-      dst_sx = 0;
-      dst_sy = 0;
-      for(unsigned y = src_sy,dst_y= dst_sy;y<rb->height;y++,dst_y++) {
-        for(unsigned x = src_sx,dst_x= dst_sx;x<rb->width;x++,dst_x++) {
-          pixmove(rb,x,y,dst_x,dst_y);
-        }
-      }
-      for(unsigned y=0;y<rb->height+ytrans;y++)
-        for(unsigned x=rb->width+xtrans;x<rb->width;x++)
-          pixerase(rb,x,y);
-      for(unsigned y=rb->height+ytrans;y<rb->height;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);
-    }
-  }
-}
-
-void msApplyBlackeningCompositingFilter(rasterBufferObj *rb) {
-  unsigned char *r,*g,*b;
-  for(unsigned row=0;row<rb->height;row++) {
-    r = rb->data.rgba.r + row*rb->data.rgba.row_step;
-    g = rb->data.rgba.g + row*rb->data.rgba.row_step;
-    b = rb->data.rgba.b + row*rb->data.rgba.row_step;
-    for(unsigned col=0;col<rb->width;col++) {
-      *r = *g = *b = 0;
-      r+=4;g+=4;b+=4;
-    }    
-  }
-}
-
-void msApplyWhiteningCompositingFilter(rasterBufferObj *rb) {
-  unsigned char *r,*g,*b,*a;
-  for(unsigned row=0;row<rb->height;row++) {
-    r = rb->data.rgba.r + row*rb->data.rgba.row_step;
-    g = rb->data.rgba.g + row*rb->data.rgba.row_step;
-    b = rb->data.rgba.b + row*rb->data.rgba.row_step;
-    a = rb->data.rgba.a + row*rb->data.rgba.row_step;
-    for(unsigned col=0;col<rb->width;col++) {
-      *r = *g = *b = *a;
-      r+=4;g+=4;b+=4;a+=4;
-    }    
-  }
-}
-
-void msApplyGrayscaleCompositingFilter(rasterBufferObj *rb) {
-  unsigned char *r,*g,*b;
-  for(unsigned row=0;row<rb->height;row++) {
-    r = rb->data.rgba.r + row*rb->data.rgba.row_step;
-    g = rb->data.rgba.g + row*rb->data.rgba.row_step;
-    b = rb->data.rgba.b + row*rb->data.rgba.row_step;
-    for(unsigned col=0;col<rb->width;col++) {
-      unsigned int mix = (unsigned int)*r + (unsigned int)*g + (unsigned int)*b;
-      mix /=3;
-      *r = *g = *b = (unsigned char)mix;
-      r+=4;g+=4;b+=4;
-    }    
-  }
-}
-
-int msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb, CompositingFilter *filter) {
-  int rstatus;
-  regex_t regex;
-  regmatch_t pmatch[3];
-  
-  /* test for blurring filter */
-  regcomp(&regex, "blur\\(([0-9]+)\\)", REG_EXTENDED);
-  rstatus = regexec(&regex, filter->filter, 2, pmatch, 0);
-  regfree(&regex);
-  if(!rstatus) {
-    char *rad = malloc(pmatch[1].rm_eo - pmatch[1].rm_so + 1);
-    unsigned int irad;
-    strncpy(rad,filter->filter+pmatch[1].rm_so,pmatch[1].rm_eo-pmatch[1].rm_so);
-    rad[pmatch[1].rm_eo - pmatch[1].rm_so]=0;
-    //msDebug("got blur filter with radius %s\n",rad);
-    irad = atoi(rad);
-    free(rad);
-    irad = MS_NINT(irad*map->resolution/map->defresolution);
-    msApplyBlurringCompositingFilter(rb,irad);
-    return MS_SUCCESS;
-  }
-  
-  /* test for translation filter */
-  regcomp(&regex, "translate\\((-?[0-9]+),(-?[0-9]+)\\)", REG_EXTENDED);
-  rstatus = regexec(&regex, filter->filter, 3, pmatch, 0);
-  regfree(&regex);
-  if(!rstatus) {
-    char *num;
-    int xtrans,ytrans;
-    num = malloc(pmatch[1].rm_eo - pmatch[1].rm_so + 1);
-    strncpy(num,filter->filter+pmatch[1].rm_so,pmatch[1].rm_eo-pmatch[1].rm_so);
-    num[pmatch[1].rm_eo - pmatch[1].rm_so]=0;
-    xtrans = atoi(num);
-    free(num);
-    num = malloc(pmatch[2].rm_eo - pmatch[2].rm_so + 1);
-    strncpy(num,filter->filter+pmatch[2].rm_so,pmatch[2].rm_eo-pmatch[2].rm_so);
-    num[pmatch[2].rm_eo - pmatch[2].rm_so]=0;
-    ytrans = atoi(num);
-    free(num);
-    //msDebug("got translation filter of radius %d,%d\n",xtrans,ytrans);
-    xtrans = MS_NINT(xtrans*map->resolution/map->defresolution);
-    ytrans = MS_NINT(ytrans*map->resolution/map->defresolution);
-    msApplyTranslationCompositingFilter(rb,xtrans,ytrans);
-    return MS_SUCCESS;
-  }
-  
-  /* test for grayscale filter */
-  if(!strncmp(filter->filter,"grayscale()",strlen("grayscale()"))) {
-    msApplyGrayscaleCompositingFilter(rb);
-    return MS_SUCCESS;
-  }
-  if(!strncmp(filter->filter,"blacken()",strlen("blacken()"))) {
-    msApplyBlackeningCompositingFilter(rb);
-    return MS_SUCCESS;
-  }
-  if(!strncmp(filter->filter,"whiten()",strlen("whiten()"))) {
-    msApplyWhiteningCompositingFilter(rb);
-    return MS_SUCCESS;
-  }
-  
-  msSetError(MS_MISCERR,"unknown compositing filter (%s)", "msApplyCompositingFilter()", filter->filter);
-  return MS_FAILURE;
-}
diff -pruN 8.0.1-5/mapcontext.c 8.2.0~beta1-1~exp1/mapcontext.c
--- 8.0.1-5/mapcontext.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcontext.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2014 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC Web Map Context implementation
- * Author:   Julien-Samuel Lacroix, DM Solutions Group (lacroix@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2002-2003, Julien-Samuel Lacroix, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#include "cpl_vsi.h"
-#include "cpl_conv.h"
-
-
-#if defined(USE_WMS_LYR)
-
-/* There is a dependency to GDAL/OGR for the GML driver and MiniXML parser */
-#include "cpl_minixml.h"
-
-#endif
-
-/* msGetMapContextFileText()
-**
-** Read a file and return is content
-**
-** Take the filename in argument
-** Return value must be freed by caller
-*/
-static char * msGetMapContextFileText(const char *filename)
-{
-  char *pszBuffer;
-  VSILFILE *stream;
-  vsi_l_offset  nLength;
-
-  /* open file */
-  if(filename != NULL && strlen(filename) > 0) {
-    stream = VSIFOpenL(filename, "rb");
-    if(!stream) {
-      msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
-      return NULL;
-    }
-  } else {
-    msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
-    return NULL;
-  }
-
-  VSIFSeekL( stream, 0, SEEK_END );
-  nLength = VSIFTellL( stream );
-  VSIFSeekL( stream, 0, SEEK_SET );
-  if( nLength > 100 * 1024 * 1024U )
-  {
-    msSetError(MS_MEMERR, "(%s): too big file", "msGetMapContextFileText()", filename);
-    VSIFCloseL( stream );
-    return NULL;
-  }
-
-  pszBuffer = (char *) malloc((size_t)nLength+1);
-  if( pszBuffer == NULL ) {
-    msSetError(MS_MEMERR, "(%s)", "msGetMapContextFileText()", filename);
-    VSIFCloseL( stream );
-    return NULL;
-  }
-
-  if(VSIFReadL( pszBuffer, nLength, 1, stream ) == 0) {
-    free( pszBuffer );
-    VSIFCloseL( stream );
-    msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
-    return NULL;
-  }
-  pszBuffer[nLength] = '\0';
-
-  VSIFCloseL( stream );
-
-  return pszBuffer;
-}
-
-
-#if defined(USE_WMS_LYR)
-
-/*
-**msGetMapContextXMLHashValue()
-**
-**Get the xml value and put it in the hash table
-**
-*/
-int msGetMapContextXMLHashValue( CPLXMLNode *psRoot, const char *pszXMLPath,
-                                 hashTableObj *metadata, char *pszMetadata )
-{
-  char *pszValue;
-
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( metadata != NULL ) {
-      msInsertHashTable(metadata, pszMetadata, pszValue );
-    } else {
-      return MS_FAILURE;
-    }
-  } else {
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-**msGetMapContextXMLHashValue()
-**
-**Get the xml value and put it in the hash table
-**
-*/
-int msGetMapContextXMLHashValueDecode( CPLXMLNode *psRoot,
-                                       const char *pszXMLPath,
-                                       hashTableObj *metadata,
-                                       char *pszMetadata )
-{
-  char *pszValue;
-
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( metadata != NULL ) {
-      msDecodeHTMLEntities(pszValue);
-      msInsertHashTable(metadata, pszMetadata, pszValue );
-    } else {
-      return MS_FAILURE;
-    }
-  } else {
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/*
-**msGetMapContextXMLStringValue()
-**
-**Get the xml value and put it in the string field
-**
-*/
-int msGetMapContextXMLStringValue( CPLXMLNode *psRoot, char *pszXMLPath,
-                                   char **pszField)
-{
-  char *pszValue;
-
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( pszField != NULL ) {
-      *pszField = msStrdup(pszValue);
-    } else {
-      return MS_FAILURE;
-    }
-  } else {
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/*
-**msGetMapContextXMLStringValue()
-**
-**Get the xml value and put it in the string field
-**
-*/
-int msGetMapContextXMLStringValueDecode( CPLXMLNode *psRoot, char *pszXMLPath,
-    char **pszField)
-{
-  char *pszValue;
-
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( pszField != NULL ) {
-      msDecodeHTMLEntities(pszValue);
-      *pszField = msStrdup(pszValue);
-    } else {
-      return MS_FAILURE;
-    }
-  } else {
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/*
-**msGetMapContextXMLFloatValue()
-**
-**Get the xml value and put it in the string field
-**
-*/
-int msGetMapContextXMLFloatValue( CPLXMLNode *psRoot, char *pszXMLPath,
-                                  double *pszField)
-{
-  char *pszValue;
-
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( pszField != NULL ) {
-      *pszField = atof(pszValue);
-    } else {
-      return MS_FAILURE;
-    }
-  } else {
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** msLoadMapContextURLELements
-**
-** Take a Node and get the width, height, format and href from it.
-** Then put this info in metadatas.
-*/
-int msLoadMapContextURLELements( CPLXMLNode *psRoot, hashTableObj *metadata,
-                                 const char *pszMetadataRoot)
-{
-  char *pszMetadataName;
-
-  if( psRoot == NULL || metadata == NULL || pszMetadataRoot == NULL )
-    return MS_FAILURE;
-
-  pszMetadataName = (char*) malloc( strlen(pszMetadataRoot) + 10 );
-
-  sprintf( pszMetadataName, "%s_width", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "width", metadata, pszMetadataName );
-
-  sprintf( pszMetadataName, "%s_height", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "height", metadata, pszMetadataName );
-
-  sprintf( pszMetadataName, "%s_format", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "format", metadata, pszMetadataName );
-
-  sprintf( pszMetadataName, "%s_href", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "OnlineResource.xlink:href", metadata,
-                               pszMetadataName );
-
-  free(pszMetadataName);
-
-  return MS_SUCCESS;
-}
-
-/* msLoadMapContextKeyword
-**
-** Put the keywords from a XML node and put them in a metadata.
-** psRoot should be set to keywordlist
-*/
-int msLoadMapContextListInMetadata( CPLXMLNode *psRoot, hashTableObj *metadata,
-                                    char *pszXMLName, char *pszMetadataName,
-                                    char *pszHashDelimiter)
-{
-  const char *pszHash, *pszXMLValue;
-  char *pszMetadata;
-
-  if(psRoot == NULL || psRoot->psChild == NULL ||
-      metadata == NULL || pszMetadataName == NULL || pszXMLName == NULL)
-    return MS_FAILURE;
-
-  /* Pass from KeywordList to Keyword level */
-  psRoot = psRoot->psChild;
-
-  /* Loop on all elements and append keywords to the hash table */
-  while (psRoot) {
-    if (psRoot->psChild && strcasecmp(psRoot->pszValue, pszXMLName) == 0) {
-      pszXMLValue = psRoot->psChild->pszValue;
-      pszHash = msLookupHashTable(metadata, pszMetadataName);
-      if (pszHash != NULL) {
-        pszMetadata = (char*)malloc(strlen(pszHash)+
-                                    strlen(pszXMLValue)+2);
-        if(pszHashDelimiter == NULL)
-          sprintf( pszMetadata, "%s%s", pszHash, pszXMLValue );
-        else
-          sprintf( pszMetadata, "%s%s%s", pszHash, pszHashDelimiter,
-                   pszXMLValue );
-        msInsertHashTable(metadata, pszMetadataName, pszMetadata);
-        free(pszMetadata);
-      } else
-        msInsertHashTable(metadata, pszMetadataName, pszXMLValue);
-    }
-    psRoot = psRoot->psNext;
-  }
-
-  return MS_SUCCESS;
-}
-
-/* msLoadMapContextContactInfo
-**
-** Put the Contact informations from a XML node and put them in a metadata.
-**
-*/
-int msLoadMapContextContactInfo( CPLXMLNode *psRoot, hashTableObj *metadata )
-{
-  if(psRoot == NULL || metadata == NULL)
-    return MS_FAILURE;
-
-  /* Contact Person primary */
-  msGetMapContextXMLHashValue(psRoot,
-                              "ContactPersonPrimary.ContactPerson",
-                              metadata, "wms_contactperson");
-  msGetMapContextXMLHashValue(psRoot,
-                              "ContactPersonPrimary.ContactOrganization",
-                              metadata, "wms_contactorganization");
-  /* Contact Position */
-  msGetMapContextXMLHashValue(psRoot,
-                              "ContactPosition",
-                              metadata, "wms_contactposition");
-  /* Contact Address */
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.AddressType",
-                              metadata, "wms_addresstype");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Address",
-                              metadata, "wms_address");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.City",
-                              metadata, "wms_city");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.StateOrProvince",
-                              metadata, "wms_stateorprovince");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.PostCode",
-                              metadata, "wms_postcode");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Country",
-                              metadata, "wms_country");
-
-  /* Others */
-  msGetMapContextXMLHashValue(psRoot, "ContactVoiceTelephone",
-                              metadata, "wms_contactvoicetelephone");
-  msGetMapContextXMLHashValue(psRoot, "ContactFacsimileTelephone",
-                              metadata, "wms_contactfacsimiletelephone");
-  msGetMapContextXMLHashValue(psRoot, "ContactElectronicMailAddress",
-                              metadata, "wms_contactelectronicmailaddress");
-
-  return MS_SUCCESS;
-}
-
-/*
-** msLoadMapContextLayerFormat
-**
-**
-*/
-int msLoadMapContextLayerFormat(CPLXMLNode *psFormat, layerObj *layer)
-{
-  const char *pszValue;
-  char *pszValue1;
-  const char* pszHash;
-
-  if(psFormat->psChild != NULL &&
-      strcasecmp(psFormat->pszValue, "Format") == 0 ) {
-    if(psFormat->psChild->psNext == NULL)
-      pszValue = psFormat->psChild->pszValue;
-    else
-      pszValue = psFormat->psChild->psNext->pszValue;
-  } else
-    pszValue = NULL;
-
-  if(pszValue != NULL && strcasecmp(pszValue, "") != 0) {
-    /* wms_format */
-    pszValue1 = (char*)CPLGetXMLValue(psFormat,
-                                      "current", NULL);
-    if(pszValue1 != NULL &&
-        (strcasecmp(pszValue1, "1") == 0 || strcasecmp(pszValue1, "true")==0))
-      msInsertHashTable(&(layer->metadata),
-                        "wms_format", pszValue);
-    /* wms_formatlist */
-    pszHash = msLookupHashTable(&(layer->metadata),
-                                "wms_formatlist");
-    if(pszHash != NULL) {
-      pszValue1 = (char*)malloc(strlen(pszHash)+
-                                strlen(pszValue)+2);
-      sprintf(pszValue1, "%s,%s", pszHash, pszValue);
-      msInsertHashTable(&(layer->metadata),
-                        "wms_formatlist", pszValue1);
-      free(pszValue1);
-    } else
-      msInsertHashTable(&(layer->metadata),
-                        "wms_formatlist", pszValue);
-  }
-
-  /* Make sure selected format is supported or select another
-   * supported format.  Note that we can efficiently do this
-   * only for GIF/PNG/JPEG, can't try to handle all GDAL
-   * formats.
-   */
-  pszValue = msLookupHashTable(&(layer->metadata), "wms_format");
-
-  if (
-    pszValue && (
-#if !(defined USE_PNG)
-    strcasecmp(pszValue, "image/png") == 0 ||
-    strcasecmp(pszValue, "PNG") == 0 ||
-#endif
-#if !(defined USE_JPEG)
-    strcasecmp(pszValue, "image/jpeg") == 0 ||
-    strcasecmp(pszValue, "JPEG") == 0 ||
-#endif
-    0 )) {
-    char **papszList=NULL;
-    int i, numformats=0;
-
-    pszValue = msLookupHashTable(&(layer->metadata),
-                                 "wms_formatlist");
-
-    papszList = msStringSplit(pszValue, ',', &numformats);
-    for(i=0; i < numformats; i++) {
-      if (
-#if (defined USE_PNG)
-        strcasecmp(papszList[i], "image/png") == 0 ||
-        strcasecmp(papszList[i], "PNG") == 0 ||
-#endif
-#if (defined USE_JPEG)
-        strcasecmp(papszList[i], "image/jpeg") == 0 ||
-        strcasecmp(papszList[i], "JPEG") == 0 ||
-#endif
-#ifdef USE_GD_GIF
-        strcasecmp(papszList[i], "image/gif") == 0 ||
-        strcasecmp(papszList[i], "GIF") == 0 ||
-#endif
-        0 ) {
-        /* Found a match */
-        msInsertHashTable(&(layer->metadata),
-                          "wms_format", papszList[i]);
-        break;
-      }
-    }
-    if(papszList)
-      msFreeCharArray(papszList, numformats);
-
-  } /* end if unsupported format */
-
-  return MS_SUCCESS;
-}
-
-int msLoadMapContextLayerStyle(CPLXMLNode *psStyle, layerObj *layer,
-                               int nStyle)
-{
-  char *pszValue, *pszValue1, *pszValue2;
-  const char *pszHash;
-  char* pszStyle=NULL;
-  char *pszStyleName;
-  CPLXMLNode *psStyleSLDBody;
-
-  pszStyleName =(char*)CPLGetXMLValue(psStyle,"Name",NULL);
-  if(pszStyleName == NULL) {
-    pszStyleName = (char*)malloc(20);
-    sprintf(pszStyleName, "Style{%d}", nStyle);
-  } else
-    pszStyleName = msStrdup(pszStyleName);
-
-  /* wms_style */
-  pszValue = (char*)CPLGetXMLValue(psStyle,"current",NULL);
-  if(pszValue != NULL &&
-      (strcasecmp(pszValue, "1") == 0 ||
-       strcasecmp(pszValue, "true") == 0))
-    msInsertHashTable(&(layer->metadata),
-                      "wms_style", pszStyleName);
-  /* wms_stylelist */
-  pszHash = msLookupHashTable(&(layer->metadata),
-                              "wms_stylelist");
-  if(pszHash != NULL) {
-    pszValue1 = (char*)malloc(strlen(pszHash)+
-                              strlen(pszStyleName)+2);
-    sprintf(pszValue1, "%s,%s", pszHash, pszStyleName);
-    msInsertHashTable(&(layer->metadata),
-                      "wms_stylelist", pszValue1);
-    free(pszValue1);
-  } else
-    msInsertHashTable(&(layer->metadata),
-                      "wms_stylelist", pszStyleName);
-
-  /* Title */
-  pszStyle = (char*)malloc(strlen(pszStyleName)+20);
-  sprintf(pszStyle,"wms_style_%s_title",pszStyleName);
-
-  if( msGetMapContextXMLHashValue(psStyle, "Title", &(layer->metadata),
-                                  pszStyle) == MS_FAILURE )
-    msInsertHashTable(&(layer->metadata), pszStyle, layer->name);
-
-  free(pszStyle);
-
-  /* SLD */
-  pszStyle = (char*)malloc(strlen(pszStyleName)+15);
-  sprintf(pszStyle, "wms_style_%s_sld", pszStyleName);
-
-  msGetMapContextXMLHashValueDecode( psStyle, "SLD.OnlineResource.xlink:href",
-                                     &(layer->metadata), pszStyle );
-  free(pszStyle);
-
-  /* SLDBODY */
-  pszStyle = (char*)malloc(strlen(pszStyleName)+20);
-  sprintf(pszStyle, "wms_style_%s_sld_body", pszStyleName);
-
-  psStyleSLDBody = CPLGetXMLNode(psStyle, "SLD.StyledLayerDescriptor");
-  /*some clients such as OpenLayers add a name space, which I believe is wrong but
-   added this additional test for compatibility #3115*/
-  if (psStyleSLDBody == NULL)
-    psStyleSLDBody = CPLGetXMLNode(psStyle, "SLD.sld:StyledLayerDescriptor");
-
-  if(psStyleSLDBody != NULL && &(layer->metadata) != NULL) {
-    pszValue = CPLSerializeXMLTree(psStyleSLDBody);
-    if(pszValue != NULL) {
-      /* Before including SLDBody in the mapfile, we must replace the */
-      /* double quote for single quote. This is to prevent having this: */
-      /* "metadata" "<string attriute="ttt">" */
-      char *c;
-      for(c=pszValue; *c != '\0'; c++)
-        if(*c == '"')
-          *c = '\'';
-      msInsertHashTable(&(layer->metadata), pszStyle, pszValue );
-      msFree(pszValue);
-    }
-  }
-
-  free(pszStyle);
-
-  /* LegendURL */
-  pszStyle = (char*) malloc(strlen(pszStyleName) + 25);
-
-  sprintf( pszStyle, "wms_style_%s_legendurl",
-           pszStyleName);
-  msLoadMapContextURLELements( CPLGetXMLNode(psStyle, "LegendURL"),
-                               &(layer->metadata), pszStyle );
-
-  free(pszStyle);
-
-  free(pszStyleName);
-
-  /*  */
-  /* Add the stylelist to the layer connection */
-  /*  */
-  if(msLookupHashTable(&(layer->metadata),
-                       "wms_stylelist") == NULL) {
-    if(layer->connection)
-      pszValue = msStrdup(layer->connection);
-    else
-      pszValue = msStrdup( "" );
-    pszValue1 = strstr(pszValue, "STYLELIST=");
-    if(pszValue1 != NULL) {
-      pszValue1 += 10;
-      pszValue2 = strchr(pszValue, '&');
-      if(pszValue2 != NULL)
-        pszValue1[pszValue2-pszValue1] = '\0';
-      msInsertHashTable(&(layer->metadata), "wms_stylelist",
-                        pszValue1);
-    }
-    free(pszValue);
-  }
-
-  /*  */
-  /* Add the style to the layer connection */
-  /*  */
-  if(msLookupHashTable(&(layer->metadata), "wms_style") == NULL) {
-    if(layer->connection)
-      pszValue = msStrdup(layer->connection);
-    else
-      pszValue = msStrdup( "" );
-    pszValue1 = strstr(pszValue, "STYLE=");
-    if(pszValue1 != NULL) {
-      pszValue1 += 6;
-      pszValue2 = strchr(pszValue, '&');
-      if(pszValue2 != NULL)
-        pszValue1[pszValue2-pszValue1] = '\0';
-      msInsertHashTable(&(layer->metadata), "wms_style",
-                        pszValue1);
-    }
-    free(pszValue);
-  }
-
-  return MS_SUCCESS;
-}
-
-int msLoadMapContextLayerDimension(CPLXMLNode *psDimension, layerObj *layer)
-{
-  char *pszValue;
-  const char *pszHash;
-  char *pszDimension=NULL, *pszDimensionName=NULL;
-
-  pszDimensionName =(char*)CPLGetXMLValue(psDimension,"name",NULL);
-  if(pszDimensionName == NULL) {
-    return MS_FALSE;
-  } else
-    pszDimensionName = msStrdup(pszDimensionName);
-
-  pszDimension = (char*)malloc(strlen(pszDimensionName)+50);
-
-  /* wms_dimension: This is the current dimension */
-  pszValue = (char*)CPLGetXMLValue(psDimension, "current", NULL);
-  if(pszValue != NULL && (strcasecmp(pszValue, "1") == 0 ||
-                          strcasecmp(pszValue, "true") == 0))
-    msInsertHashTable(&(layer->metadata),
-                      "wms_dimension", pszDimensionName);
-  /* wms_dimensionlist */
-  pszHash = msLookupHashTable(&(layer->metadata),
-                              "wms_dimensionlist");
-  if(pszHash != NULL) {
-    pszValue = (char*)malloc(strlen(pszHash)+
-                             strlen(pszDimensionName)+2);
-    sprintf(pszValue, "%s,%s", pszHash, pszDimensionName);
-    msInsertHashTable(&(layer->metadata),
-                      "wms_dimensionlist", pszValue);
-    free(pszValue);
-  } else
-    msInsertHashTable(&(layer->metadata),
-                      "wms_dimensionlist", pszDimensionName);
-
-  /* Units */
-  sprintf(pszDimension, "wms_dimension_%s_units", pszDimensionName);
-  msGetMapContextXMLHashValue(psDimension, "units", &(layer->metadata),
-                              pszDimension);
-
-  /* UnitSymbol */
-  sprintf(pszDimension, "wms_dimension_%s_unitsymbol", pszDimensionName);
-  msGetMapContextXMLHashValue(psDimension, "unitSymbol", &(layer->metadata),
-                              pszDimension);
-
-  /* userValue */
-  sprintf(pszDimension, "wms_dimension_%s_uservalue", pszDimensionName);
-  msGetMapContextXMLHashValue(psDimension, "userValue", &(layer->metadata),
-                              pszDimension);
-  if(strcasecmp(pszDimensionName, "time") == 0)
-    msGetMapContextXMLHashValue(psDimension, "userValue", &(layer->metadata),
-                                "wms_time");
-
-  /* default */
-  sprintf(pszDimension, "wms_dimension_%s_default", pszDimensionName);
-  msGetMapContextXMLHashValue(psDimension, "default", &(layer->metadata),
-                              pszDimension);
-
-  /* multipleValues */
-  sprintf(pszDimension, "wms_dimension_%s_multiplevalues", pszDimensionName);
-  msGetMapContextXMLHashValue(psDimension, "multipleValues",&(layer->metadata),
-                              pszDimension);
-
-  /* nearestValue */
-  sprintf(pszDimension, "wms_dimension_%s_nearestvalue", pszDimensionName);
-  msGetMapContextXMLHashValue(psDimension, "nearestValue", &(layer->metadata),
-                              pszDimension);
-
-  free(pszDimension);
-
-  free(pszDimensionName);
-
-  return MS_SUCCESS;
-}
-
-
-
-/*
-** msLoadMapContextGeneral
-**
-** Load the General block of the mapcontext document
-*/
-int msLoadMapContextGeneral(mapObj *map, CPLXMLNode *psGeneral,
-                            CPLXMLNode *psMapContext, int nVersion,
-                            const char *filename)
-{
-
-  char *pszProj=NULL;
-  char *pszValue, *pszValue1, *pszValue2;
-  int nTmp;
-
-  /* Projection */
-  pszValue = (char*)CPLGetXMLValue(psGeneral,
-                                   "BoundingBox.SRS", NULL);
-  if(pszValue != NULL && !EQUAL(pszValue, "(null)")) {
-    if(strncasecmp(pszValue, "AUTO:", 5) == 0) {
-      pszProj = msStrdup(pszValue);
-    } else {
-      pszProj = (char*) malloc(sizeof(char)*(strlen(pszValue)+10));
-      sprintf(pszProj, "init=epsg:%s", pszValue+5);
-    }
-
-    msFreeProjection(&map->projection);
-    msInitProjection(&map->projection);
-    map->projection.args[map->projection.numargs] = msStrdup(pszProj);
-    map->projection.numargs++;
-    msProcessProjection(&map->projection);
-
-    if( (nTmp = GetMapserverUnitUsingProj(&(map->projection))) == -1) {
-      free(pszProj);
-      msSetError( MS_MAPCONTEXTERR,
-                  "Unable to set units for projection '%s'",
-                  "msLoadMapContext()", pszProj );
-      return MS_FAILURE;
-    } else {
-      map->units = nTmp;
-    }
-    free(pszProj);
-  } else {
-    msDebug("Mandatory data General.BoundingBox.SRS missing in %s.",
-            filename);
-  }
-
-  /* Extent */
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.minx",
-                                   &(map->extent.minx)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.minx missing in %s.",
-            filename);
-  }
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.miny",
-                                   &(map->extent.miny)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.miny missing in %s.",
-            filename);
-  }
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxx",
-                                   &(map->extent.maxx)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.maxx missing in %s.",
-            filename);
-  }
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxy",
-                                   &(map->extent.maxy)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.maxy missing in %s.",
-            filename);
-  }
-
-  /* Title */
-  if( msGetMapContextXMLHashValue(psGeneral, "Title",
-                                  &(map->web.metadata), "wms_title") == MS_FAILURE) {
-    if ( nVersion >= OWS_1_0_0 )
-      msDebug("Mandatory data General.Title missing in %s.", filename);
-    else {
-      if( msGetMapContextXMLHashValue(psGeneral, "gml:name",
-                                      &(map->web.metadata), "wms_title") == MS_FAILURE ) {
-        if( nVersion < OWS_0_1_7 )
-          msDebug("Mandatory data General.Title missing in %s.", filename);
-        else
-          msDebug("Mandatory data General.gml:name missing in %s.",
-                  filename);
-      }
-    }
-  }
-
-  /* Name */
-  if( nVersion >= OWS_1_0_0 ) {
-    pszValue = (char*)CPLGetXMLValue(psMapContext,
-                                     "id", NULL);
-    if (pszValue)
-    {
-      msFree(map->name);
-      map->name = msStrdup(pszValue);
-    }
-  } else {
-    char* pszMapName = NULL;
-    if(msGetMapContextXMLStringValue(psGeneral, "Name",
-                                     &pszMapName) == MS_FAILURE) {
-      msGetMapContextXMLStringValue(psGeneral, "gml:name",
-                                    &pszMapName);
-    }
-    if( pszMapName ) {
-      msFree(map->name);
-      map->name = pszMapName;
-    }
-  }
-  /* Keyword */
-  if( nVersion >= OWS_1_0_0 ) {
-    msLoadMapContextListInMetadata(
-      CPLGetXMLNode(psGeneral, "KeywordList"),
-      &(map->web.metadata), "KEYWORD", "wms_keywordlist", "," );
-  } else
-    msGetMapContextXMLHashValue(psGeneral, "Keywords",
-                                &(map->web.metadata), "wms_keywordlist");
-
-  /* Window */
-  pszValue1 = (char*)CPLGetXMLValue(psGeneral,"Window.width",NULL);
-  pszValue2 = (char*)CPLGetXMLValue(psGeneral,"Window.height",NULL);
-  if(pszValue1 != NULL && pszValue2 != NULL) {
-    map->width = atoi(pszValue1);
-    map->height = atoi(pszValue2);
-  }
-
-  /* Abstract */
-  if( msGetMapContextXMLHashValue( psGeneral,
-                                   "Abstract", &(map->web.metadata),
-                                   "wms_abstract") == MS_FAILURE ) {
-    msGetMapContextXMLHashValue( psGeneral, "gml:description",
-                                 &(map->web.metadata), "wms_abstract");
-  }
-
-  /* DataURL */
-  msGetMapContextXMLHashValueDecode(psGeneral,
-                                    "DataURL.OnlineResource.xlink:href",
-                                    &(map->web.metadata), "wms_dataurl");
-
-  /* LogoURL */
-  /* The logourl have a width, height, format and an URL */
-  msLoadMapContextURLELements( CPLGetXMLNode(psGeneral, "LogoURL"),
-                               &(map->web.metadata), "wms_logourl" );
-
-  /* DescriptionURL */
-  /* The descriptionurl have a width, height, format and an URL */
-  msLoadMapContextURLELements( CPLGetXMLNode(psGeneral,
-                               "DescriptionURL"),
-                               &(map->web.metadata), "wms_descriptionurl" );
-
-  /* Contact Info */
-  msLoadMapContextContactInfo(
-    CPLGetXMLNode(psGeneral, "ContactInformation"),
-    &(map->web.metadata) );
-
-  return MS_SUCCESS;
-}
-
-/*
-** msLoadMapContextLayer
-**
-** Load a Layer block from a MapContext document
-*/
-int msLoadMapContextLayer(mapObj *map, CPLXMLNode *psLayer, int nVersion,
-                          const char *filename, int unique_layer_names)
-{
-  char *pszValue;
-  const char *pszHash;
-  char *pszName=NULL;
-  CPLXMLNode *psFormatList, *psFormat, *psStyleList, *psStyle, *psExtension;
-  CPLXMLNode *psDimensionList, *psDimension;
-  int nStyle;
-  layerObj *layer;
-
-  /* Init new layer */
-  if(msGrowMapLayers(map) == NULL)
-    return MS_FAILURE;
-
-  layer = (GET_LAYER(map, map->numlayers));
-  initLayer(layer, map);
-  layer->map = (mapObj *)map;
-  layer->type = MS_LAYER_RASTER;
-  /* save the index */
-  GET_LAYER(map, map->numlayers)->index = map->numlayers;
-  map->layerorder[map->numlayers] = map->numlayers;
-  map->numlayers++;
-
-
-  /* Status */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "hidden", "1");
-  if((pszValue != NULL) && (atoi(pszValue) == 0 &&
-                            strcasecmp(pszValue, "true") != 0))
-    layer->status = MS_ON;
-  else
-    layer->status = MS_OFF;
-
-  /* Queryable */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "queryable", "0");
-  if(pszValue !=NULL && (atoi(pszValue) == 1  ||
-                         strcasecmp(pszValue, "true") == 0))
-    layer->template = msStrdup("ttt");
-
-  /* Name and Title */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "Name", NULL);
-  if(pszValue != NULL) {
-    msInsertHashTable( &(layer->metadata), "wms_name", pszValue );
-
-    if (unique_layer_names) {
-      pszName = (char*)malloc(sizeof(char)*(strlen(pszValue)+15));
-      sprintf(pszName, "l%d:%s", layer->index, pszValue);
-      layer->name = msStrdup(pszName);
-      free(pszName);
-    } else
-      layer->name  = msStrdup(pszValue);
-  } else {
-    pszName = (char*)malloc(sizeof(char)*15);
-    sprintf(pszName, "l%d:", layer->index);
-    layer->name = msStrdup(pszName);
-    free(pszName);
-  }
-
-  if(msGetMapContextXMLHashValue(psLayer, "Title", &(layer->metadata),
-                                 "wms_title") == MS_FAILURE) {
-    if(msGetMapContextXMLHashValue(psLayer, "Server.title",
-                                   &(layer->metadata), "wms_title") == MS_FAILURE) {
-      msDebug("Mandatory data Layer.Title missing in %s.", filename);
-    }
-  }
-
-  /* Server Title */
-  msGetMapContextXMLHashValue(psLayer, "Server.title", &(layer->metadata),  "wms_server_title");
-
-  /* Abstract */
-  msGetMapContextXMLHashValue(psLayer, "Abstract", &(layer->metadata),
-                              "wms_abstract");
-
-  /* DataURL */
-  if(nVersion <= OWS_0_1_4) {
-    msGetMapContextXMLHashValueDecode(psLayer,
-                                      "DataURL.OnlineResource.xlink:href",
-                                      &(layer->metadata), "wms_dataurl");
-  } else {
-    /* The DataURL have a width, height, format and an URL */
-    /* Width and height are not used, but they are included to */
-    /* be consistent with the spec. */
-    msLoadMapContextURLELements( CPLGetXMLNode(psLayer, "DataURL"),
-                                 &(layer->metadata), "wms_dataurl" );
-  }
-
-  /* The MetadataURL have a width, height, format and an URL */
-  /* Width and height are not used, but they are included to */
-  /* be consistent with the spec. */
-  msLoadMapContextURLELements( CPLGetXMLNode(psLayer, "MetadataURL"),
-                               &(layer->metadata), "wms_metadataurl" );
-
-
-  /* MinScale && MaxScale */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "sld:MinScaleDenominator", NULL);
-  if(pszValue != NULL) {
-    layer->minscaledenom = atof(pszValue);
-  }
-
-  pszValue = (char*)CPLGetXMLValue(psLayer, "sld:MaxScaleDenominator", NULL);
-  if(pszValue != NULL) {
-    layer->maxscaledenom = atof(pszValue);
-  }
-
-  /*  */
-  /* Server */
-  /*  */
-  if(nVersion >= OWS_0_1_4) {
-    if(msGetMapContextXMLStringValueDecode(psLayer,
-                                           "Server.OnlineResource.xlink:href",
-                                           &(layer->connection)) == MS_FAILURE) {
-      msSetError(MS_MAPCONTEXTERR,
-                 "Mandatory data Server.OnlineResource.xlink:href missing in %s.",
-                 "msLoadMapContext()", filename);
-      return MS_FAILURE;
-    } else {
-      msGetMapContextXMLHashValueDecode(psLayer,
-                                        "Server.OnlineResource.xlink:href",
-                                        &(layer->metadata), "wms_onlineresource");
-      layer->connectiontype = MS_WMS;
-    }
-  } else {
-    if(msGetMapContextXMLStringValueDecode(psLayer,
-                                           "Server.onlineResource",
-                                           &(layer->connection)) == MS_FAILURE) {
-      msSetError(MS_MAPCONTEXTERR,
-                 "Mandatory data Server.onlineResource missing in %s.",
-                 "msLoadMapContext()", filename);
-      return MS_FAILURE;
-    } else {
-      msGetMapContextXMLHashValueDecode(psLayer, "Server.onlineResource",
-                                        &(layer->metadata), "wms_onlineresource");
-      layer->connectiontype = MS_WMS;
-    }
-  }
-
-  if(nVersion >= OWS_0_1_4) {
-    if(msGetMapContextXMLHashValue(psLayer, "Server.version",
-                                   &(layer->metadata), "wms_server_version") == MS_FAILURE) {
-      msSetError(MS_MAPCONTEXTERR,
-                 "Mandatory data Server.version missing in %s.",
-                 "msLoadMapContext()", filename);
-      return MS_FAILURE;
-    }
-  } else {
-    if(msGetMapContextXMLHashValue(psLayer, "Server.wmtver",
-                                   &(layer->metadata), "wms_server_version") == MS_FAILURE) {
-      msSetError(MS_MAPCONTEXTERR,
-                 "Mandatory data Server.wmtver missing in %s.",
-                 "msLoadMapContext()", filename);
-      return MS_FAILURE;
-    }
-  }
-
-  /* Projection */
-  msLoadMapContextListInMetadata( psLayer, &(layer->metadata),
-                                  "SRS", "wms_srs", " " );
-
-  pszHash = msLookupHashTable(&(layer->metadata), "wms_srs");
-  if(((pszHash == NULL) || (strcasecmp(pszHash, "") == 0)) &&
-      map->projection.numargs != 0) {
-    char* pszProj = map->projection.args[map->projection.numargs-1];
-
-    if(pszProj != NULL) {
-      if(strncasecmp(pszProj, "AUTO:", 5) == 0) {
-        msInsertHashTable(&(layer->metadata),"wms_srs", pszProj);
-      } else {
-        if(strlen(pszProj) > 10) {
-          pszProj = (char*) malloc(sizeof(char) * (strlen(pszProj)));
-          sprintf( pszProj, "EPSG:%s",
-                   map->projection.args[map->projection.numargs-1]+10);
-          msInsertHashTable(&(layer->metadata),"wms_srs", pszProj);
-        } else {
-          msDebug("Unable to set data for layer wms_srs from this"
-                  " value %s.",
-                  pszProj);
-        }
-      }
-      msFree(pszProj);
-    }
-  }
-
-  /*  */
-  /* Format */
-  /*  */
-  if( nVersion >= OWS_0_1_4 ) {
-    psFormatList = CPLGetXMLNode(psLayer, "FormatList");
-  } else {
-    psFormatList = psLayer;
-  }
-
-  if(psFormatList != NULL) {
-    for(psFormat = psFormatList->psChild;
-        psFormat != NULL;
-        psFormat = psFormat->psNext) {
-      msLoadMapContextLayerFormat(psFormat, layer);
-    }
-
-  } /* end FormatList parsing */
-
-  /* Style */
-  if( nVersion >= OWS_0_1_4 ) {
-    psStyleList = CPLGetXMLNode(psLayer, "StyleList");
-  } else {
-    psStyleList = psLayer;
-  }
-
-  if(psStyleList != NULL) {
-    nStyle = 0;
-    for(psStyle = psStyleList->psChild;
-        psStyle != NULL;
-        psStyle = psStyle->psNext) {
-      if(strcasecmp(psStyle->pszValue, "Style") == 0) {
-        nStyle++;
-        msLoadMapContextLayerStyle(psStyle, layer, nStyle);
-      }
-    }
-  }
-
-  /* Dimension */
-  psDimensionList = CPLGetXMLNode(psLayer, "DimensionList");
-  if(psDimensionList != NULL) {
-    for(psDimension = psDimensionList->psChild;
-        psDimension != NULL;
-        psDimension = psDimension->psNext) {
-      if(strcasecmp(psDimension->pszValue, "Dimension") == 0) {
-        msLoadMapContextLayerDimension(psDimension, layer);
-      }
-    }
-  }
-
-  /* Extension */
-  psExtension = CPLGetXMLNode(psLayer, "Extension");
-  if (psExtension != NULL) {
-    pszValue = (char*)CPLGetXMLValue(psExtension, "ol:opacity", NULL);
-    if(pszValue != NULL) {
-      if(!layer->compositer) {
-        layer->compositer = msSmallMalloc(sizeof(LayerCompositer));
-        initLayerCompositer(layer->compositer);
-      }
-      layer->compositer->opacity = atof(pszValue)*100;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-#endif
-
-
-
-/* msLoadMapContextURL()
-**
-** load an OGC Web Map Context format from an URL
-**
-** Take a map object and a URL to a conect file in arguments
-*/
-
-int msLoadMapContextURL(mapObj *map, char *urlfilename, int unique_layer_names)
-{
-#if defined(USE_WMS_LYR)
-  char *pszTmpFile = NULL;
-  int status = 0;
-
-  if (!map || !urlfilename) {
-    msSetError(MS_MAPCONTEXTERR,
-               "Invalid map or url given.",
-               "msGetMapContextURL()");
-    return MS_FAILURE;
-  }
-
-  pszTmpFile = msTmpFile(map, map->mappath, NULL, "context.xml");
-  if (msHTTPGetFile(urlfilename, pszTmpFile, &status,-1, 0, 0, 0) ==  MS_SUCCESS) {
-    return msLoadMapContext(map, pszTmpFile, unique_layer_names);
-  } else {
-    msSetError(MS_MAPCONTEXTERR,
-               "Could not open context file %s.",
-               "msGetMapContextURL()", urlfilename);
-    return MS_FAILURE;
-  }
-
-#else
-  msSetError(MS_MAPCONTEXTERR,
-             "Not implemented since Map Context is not enabled.",
-             "msGetMapContextURL()");
-  return MS_FAILURE;
-#endif
-}
-/* msLoadMapContext()
-**
-** Get a mapfile from a OGC Web Map Context format
-**
-** Take as first map object and a file in arguments
-** If The 2nd aregument unique_layer_names is set to MS_TRUE, the layer
-** name created would be unique and be prefixed with an l plus the layers's index
-** (eg l:1:park. l:2:road ...). If It is set to MS_FALSE, the layer name
-** would be the same name as the layer name in the context
-*/
-int msLoadMapContext(mapObj *map, const char *filename, int unique_layer_names)
-{
-#if defined(USE_WMS_LYR)
-  char *pszWholeText, *pszValue;
-  CPLXMLNode *psRoot, *psMapContext, *psLayer, *psLayerList, *psChild;
-  char szPath[MS_MAXPATHLEN];
-  int nVersion=-1;
-  char szVersionBuf[OWS_VERSION_MAXLEN];
-
-  const char *ms_contextfile_pattern = CPLGetConfigOption("MS_CONTEXTFILE_PATTERN", MS_DEFAULT_CONTEXTFILE_PATTERN);
-  if(msEvalRegex(ms_contextfile_pattern, filename) != MS_TRUE) {
-    msSetError(MS_REGEXERR, "Filename validation failed." , "msLoadMapContext()");
-    return MS_FAILURE;
-  }
-
-  /*  */
-  /* Load the raw XML file */
-  /*  */
-
-  pszWholeText = msGetMapContextFileText(
-                   msBuildPath(szPath, map->mappath, filename));
-  if(pszWholeText == NULL) {
-    msSetError( MS_MAPCONTEXTERR, "Unable to read %s",
-                "msLoadMapContext()", filename );
-    return MS_FAILURE;
-  }
-
-  if( ( strstr( pszWholeText, "<WMS_Viewer_Context" ) == NULL ) &&
-      ( strstr( pszWholeText, "<View_Context" ) == NULL ) &&
-      ( strstr( pszWholeText, "<ViewContext" ) == NULL ) )
-
-  {
-    free( pszWholeText );
-    msSetError( MS_MAPCONTEXTERR, "Not a Map Context file (%s)",
-                "msLoadMapContext()", filename );
-    return MS_FAILURE;
-  }
-
-  /*  */
-  /* Convert to XML parse tree. */
-  /*  */
-  psRoot = CPLParseXMLString( pszWholeText );
-  free( pszWholeText );
-
-  /* We assume parser will report errors via CPL. */
-  if( psRoot == NULL ) {
-    msSetError( MS_MAPCONTEXTERR, "Invalid XML file (%s)",
-                "msLoadMapContext()", filename );
-    return MS_FAILURE;
-  }
-
-  /*  */
-  /* Valid the MapContext file and get the root of the document */
-  /*  */
-  psChild = psRoot;
-  psMapContext = NULL;
-  while( psChild != NULL ) {
-    if( psChild->eType == CXT_Element &&
-        (EQUAL(psChild->pszValue,"WMS_Viewer_Context") ||
-         EQUAL(psChild->pszValue,"View_Context") ||
-         EQUAL(psChild->pszValue,"ViewContext")) ) {
-      psMapContext = psChild;
-      break;
-    } else {
-      psChild = psChild->psNext;
-    }
-  }
-
-  if( psMapContext == NULL ) {
-    CPLDestroyXMLNode(psRoot);
-    msSetError( MS_MAPCONTEXTERR, "Invalid Map Context File (%s)",
-                "msLoadMapContext()", filename );
-    return MS_FAILURE;
-  }
-
-  /* Fetch document version number */
-  pszValue = (char*)CPLGetXMLValue(psMapContext,
-                                   "version", NULL);
-  if( !pszValue ) {
-    msDebug( "msLoadMapContext(): Mandatory data version missing in %s, assuming 0.1.4.",
-             filename );
-    pszValue = "0.1.4";
-  }
-
-  nVersion = msOWSParseVersionString(pszValue);
-
-  /* Make sure this is a supported version */
-  switch (nVersion) {
-    case OWS_0_1_2:
-    case OWS_0_1_4:
-    case OWS_0_1_7:
-    case OWS_1_0_0:
-    case OWS_1_1_0:
-      /* All is good, this is a supported version. */
-      break;
-    default:
-      /* Not a supported version */
-      msSetError(MS_MAPCONTEXTERR,
-                 "This version of Map Context is not supported (%s).",
-                 "msLoadMapContext()", pszValue);
-      CPLDestroyXMLNode(psRoot);
-      return MS_FAILURE;
-  }
-
-  /* Reformat and save Version in metadata */
-  msInsertHashTable( &(map->web.metadata), "wms_context_version",
-                     msOWSGetVersionString(nVersion, szVersionBuf));
-
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
-    if( msGetMapContextXMLHashValue(psMapContext, "fid",
-                                    &(map->web.metadata), "wms_context_fid") == MS_FAILURE ) {
-      msDebug("Mandatory data fid missing in %s.", filename);
-    }
-  }
-
-  /*  */
-  /* Load the General bloc */
-  /*  */
-  psChild = CPLGetXMLNode( psMapContext, "General" );
-  if( psChild == NULL ) {
-    CPLDestroyXMLNode(psRoot);
-    msSetError(MS_MAPCONTEXTERR,
-               "The Map Context document provided (%s) does not contain any "
-               "General elements.",
-               "msLoadMapContext()", filename);
-    return MS_FAILURE;
-  }
-
-  if( msLoadMapContextGeneral(map, psChild, psMapContext,
-                              nVersion, filename) == MS_FAILURE ) {
-    CPLDestroyXMLNode(psRoot);
-    return MS_FAILURE;
-  }
-
-  /*  */
-  /* Load the bloc LayerList */
-  /*  */
-  psLayerList = CPLGetXMLNode(psMapContext, "LayerList");
-  if( psLayerList != NULL ) {
-    for(psLayer = psLayerList->psChild;
-        psLayer != NULL;
-        psLayer = psLayer->psNext) {
-      if(EQUAL(psLayer->pszValue, "Layer")) {
-        if( msLoadMapContextLayer(map, psLayer, nVersion,
-                                  filename, unique_layer_names) == MS_FAILURE ) {
-          CPLDestroyXMLNode(psRoot);
-          return MS_FAILURE;
-        }
-      }/* end Layer parsing */
-    }/* for */
-  }
-
-  CPLDestroyXMLNode(psRoot);
-
-  return MS_SUCCESS;
-
-#else
-  msSetError(MS_MAPCONTEXTERR,
-             "Not implemented since Map Context is not enabled.",
-             "msGetMapContext()");
-  return MS_FAILURE;
-#endif
-}
-
-
-/* msSaveMapContext()
-**
-** Save a mapfile into the OGC Web Map Context format
-**
-** Take a map object and a file in arguments
-*/
-int msSaveMapContext(mapObj *map, char *filename)
-{
-#if defined(USE_WMS_LYR)
-  FILE *stream;
-  char szPath[MS_MAXPATHLEN];
-  int nStatus;
-
-  /* open file */
-  if(filename != NULL && strlen(filename) > 0) {
-    stream = fopen(msBuildPath(szPath, map->mappath, filename), "wb");
-    if(!stream) {
-      msSetError(MS_IOERR, "(%s)", "msSaveMapContext()", filename);
-      return(MS_FAILURE);
-    }
-  } else {
-    msSetError(MS_IOERR, "Filename is undefined.", "msSaveMapContext()");
-    return MS_FAILURE;
-  }
-
-  nStatus = msWriteMapContext(map, stream);
-
-  fclose(stream);
-
-  return nStatus;
-#else
-  msSetError(MS_MAPCONTEXTERR,
-             "Not implemented since Map Context is not enabled.",
-             "msSaveMapContext()");
-  return MS_FAILURE;
-#endif
-}
-
-
-
-int msWriteMapContext(mapObj *map, FILE *stream)
-{
-#if defined(USE_WMS_LYR)
-  const char * version;
-  char *pszEPSG;
-  char * tabspace=NULL, *pszChar,*pszSLD=NULL,*pszSLD2=NULL;
-  char *pszStyleItem, *pszSLDBody;
-  char *pszEncodedVal;
-  int i, nValue, nVersion=OWS_VERSION_NOTSET;
-  /* Dimension element */
-  char *pszDimension;
-  const char *pszDimUserValue=NULL, *pszDimUnits=NULL, *pszDimDefault=NULL;
-  const char *pszDimNearValue=NULL, *pszDimUnitSymbol=NULL;
-  const char *pszDimMultiValue=NULL;
-  int bDimensionList = 0;
-
-  /* Decide which version we're going to return... */
-  version = msLookupHashTable(&(map->web.metadata), "wms_context_version");
-  if(version == NULL)
-    version = "1.1.0";
-
-  nVersion = msOWSParseVersionString(version);
-  if (nVersion == OWS_VERSION_BADFORMAT)
-    return MS_FAILURE;  /* msSetError() already called. */
-
-  /* Make sure this is a supported version */
-  /* Note that we don't write 0.1.2 even if we read it. */
-  switch (nVersion) {
-    case OWS_0_1_4:
-    case OWS_0_1_7:
-    case OWS_1_0_0:
-    case OWS_1_1_0:
-      /* All is good, this is a supported version. */
-      break;
-    default:
-      /* Not a supported version */
-      msSetError(MS_MAPCONTEXTERR,
-                 "This version of Map Context is not supported (%s).",
-                 "msSaveMapContext()", version);
-      return MS_FAILURE;
-  }
-
-  /* file header */
-  msIO_fprintf( stream, "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-
-  /* set the WMS_Viewer_Context information */
-  pszEncodedVal = msEncodeHTMLEntities(version);
-  if(nVersion >= OWS_1_0_0) {
-    msIO_fprintf( stream, "<ViewContext version=\"%s\"", pszEncodedVal );
-  } else if(nVersion >= OWS_0_1_7) {
-    msIO_fprintf( stream, "<View_Context version=\"%s\"", pszEncodedVal );
-
-  } else { /* 0.1.4 */
-    msIO_fprintf( stream, "<WMS_Viewer_Context version=\"%s\"", pszEncodedVal );
-  }
-  msFree(pszEncodedVal);
-
-  if ( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), NULL,
-                             "wms_context_fid", OWS_NOERR," fid=\"%s\"","0");
-  }
-  if ( nVersion >= OWS_1_0_0 )
-    msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
-                          " id=\"%s\"", NULL);
-
-  msIO_fprintf( stream, " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
-  msIO_fprintf( stream, " xmlns:ogc=\"http://www.opengis.net/ogc\"");
-
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
-    msIO_fprintf( stream, " xmlns:gml=\"http://www.opengis.net/gml\"");
-  }
-  if( nVersion >= OWS_1_0_0 ) {
-    msIO_fprintf( stream, " xmlns:xlink=\"http://www.w3.org/1999/xlink\"");
-    msIO_fprintf( stream, " xmlns=\"http://www.opengis.net/context\"");
-    msIO_fprintf( stream, " xmlns:sld=\"http://www.opengis.net/sld\"");
-    pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    if( nVersion >= OWS_1_1_0 )
-      msIO_fprintf( stream,
-                    " xsi:schemaLocation=\"http://www.opengis.net/context %s/context/1.1.0/context.xsd\">\n",
-                    pszEncodedVal);
-    else
-      msIO_fprintf( stream,
-                    " xsi:schemaLocation=\"http://www.opengis.net/context %s/context/1.0.0/context.xsd\">\n",
-                    pszEncodedVal);
-    msFree(pszEncodedVal);
-  } else {
-    msIO_fprintf( stream, " xmlns:xlink=\"http://www.w3.org/TR/xlink\"");
-
-    pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    msIO_fprintf( stream, " xsi:noNamespaceSchemaLocation=\"%s/contexts/",
-                  pszEncodedVal );
-    msFree(pszEncodedVal);
-    pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    msIO_fprintf( stream, "%s/context.xsd\">\n", pszEncodedVal);
-    msFree(pszEncodedVal);
-  }
-
-  /* set the General information */
-  msIO_fprintf( stream, "  <General>\n" );
-
-  /* Window */
-  if( map->width != -1 || map->height != -1 )
-    msIO_fprintf( stream, "    <Window width=\"%d\" height=\"%d\"/>\n",
-                  map->width, map->height );
-
-  /* Bounding box corners and spatial reference system */
-  if(tabspace)
-    free(tabspace);
-  tabspace = msStrdup("    ");
-  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_TRUE, &pszEPSG);
-  msIO_fprintf( stream,
-                "%s<!-- Bounding box corners and spatial reference system -->\n",
-                tabspace );
-  if(!pszEPSG || (strcasecmp(pszEPSG, "(null)") == 0))
-    msIO_fprintf(stream, "<!-- WARNING: Mandatory data 'projection' was missing in this context. -->\n");
-
-  pszEncodedVal = msEncodeHTMLEntities(pszEPSG);
-  msIO_fprintf( stream, "%s<BoundingBox SRS=\"%s\" minx=\"%f\" miny=\"%f\" maxx=\"%f\" maxy=\"%f\"/>\n",
-                tabspace, pszEncodedVal, map->extent.minx, map->extent.miny,
-                map->extent.maxx, map->extent.maxy );
-  msFree(pszEncodedVal);
-  msFree(pszEPSG);
-
-  /* Title, name */
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
-    msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
-                          "    <gml:name>%s</gml:name>\n", NULL);
-  } else {
-    if (nVersion < OWS_0_1_7)
-      msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
-                            "    <Name>%s</Name>\n", NULL);
-
-    msIO_fprintf( stream, "%s<!-- Title of Context -->\n", tabspace );
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                             NULL, "wms_title", OWS_WARN,
-                             "    <Title>%s</Title>\n", map->name);
-  }
-
-  /* keyword */
-  if (nVersion >= OWS_1_0_0) {
-    if (msLookupHashTable(&(map->web.metadata),"wms_keywordlist")!=NULL) {
-      char **papszKeywords;
-      int nKeywords, iKey;
-
-      const char* pszValue = msLookupHashTable(&(map->web.metadata),
-                                   "wms_keywordlist");
-      papszKeywords = msStringSplit(pszValue, ',', &nKeywords);
-      if(nKeywords > 0 && papszKeywords) {
-        msIO_fprintf( stream, "    <KeywordList>\n");
-        for(iKey=0; iKey<nKeywords; iKey++) {
-          pszEncodedVal = msEncodeHTMLEntities(papszKeywords[iKey]);
-          msIO_fprintf( stream, "      <Keyword>%s</Keyword>\n",
-                        pszEncodedVal);
-          msFree(pszEncodedVal);
-        }
-        msIO_fprintf( stream, "    </KeywordList>\n");
-      }
-    }
-  } else
-    msOWSPrintEncodeMetadataList(stream, &(map->web.metadata), NULL,
-                                 "wms_keywordlist",
-                                 "    <Keywords>\n", "    </Keywords>\n",
-                                 "      %s\n", NULL);
-
-  /* abstract */
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                             NULL, "wms_abstract", OWS_NOERR,
-                             "    <gml:description>%s</gml:description>\n", NULL);
-  } else {
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                             NULL, "wms_abstract", OWS_NOERR,
-                             "    <Abstract>%s</Abstract>\n", NULL);
-  }
-
-  /* LogoURL */
-  /* The LogoURL have a width, height, format and an URL */
-  msOWSPrintURLType(stream, &(map->web.metadata), "MO", "logourl",
-                    OWS_NOERR, NULL, "LogoURL", NULL, " width=\"%s\"",
-                    " height=\"%s\""," format=\"%s\"",
-                    "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                    MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE,
-                    NULL, NULL, NULL, NULL, NULL, "    ");
-
-  /* DataURL */
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                           NULL, "wms_dataurl", OWS_NOERR,
-                           "    <DataURL>\n      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n    </DataURL>\n", NULL);
-
-  /* DescriptionURL */
-  /* The DescriptionURL have a width, height, format and an URL */
-  /* The metadata is structured like this: "width height format url" */
-  msOWSPrintURLType(stream, &(map->web.metadata), "MO", "descriptionurl",
-                    OWS_NOERR, NULL, "DescriptionURL", NULL, " width=\"%s\"",
-                    " height=\"%s\""," format=\"%s\"",
-                    "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                    MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE,
-                    NULL, NULL, NULL, NULL, NULL, "    ");
-
-  /* Contact Info */
-  msOWSPrintContactInfo( stream, tabspace, OWS_1_1_0, &(map->web.metadata), "MO" );
-
-  /* Close General */
-  msIO_fprintf( stream, "  </General>\n" );
-  free(tabspace);
-
-  /* Set the layer list */
-  msIO_fprintf(stream, "  <LayerList>\n");
-
-  /* Loop on all layer   */
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->status != MS_DELETE && GET_LAYER(map, i)->connectiontype == MS_WMS) {
-      const char* pszValue;
-      char* pszValueMod;
-      const char* pszCurrent;
-      if(GET_LAYER(map, i)->status == MS_OFF)
-        nValue = 1;
-      else
-        nValue = 0;
-      msIO_fprintf(stream, "    <Layer queryable=\"%d\" hidden=\"%d\">\n",
-                   msIsLayerQueryable(GET_LAYER(map, i)), nValue);
-
-      /*  */
-      /* Server definition */
-      /*  */
-      if(nVersion < OWS_1_0_0 )
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_server_version", OWS_WARN,
-                                 "      <Server service=\"WMS\" version=\"%s\" ",
-                                 "1.0.0");
-      else
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_server_version", OWS_WARN,
-                                 "      <Server service=\"OGC:WMS\" version=\"%s\" ",
-                                 "1.0.0");
-
-      if(msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "MO", "server_title"))
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_server_title", OWS_NOERR,
-                                 "title=\"%s\">\n", "");
-
-      else if(GET_LAYER(map, i)->name)
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_title", OWS_NOERR,
-                                 "title=\"%s\">\n", GET_LAYER(map, i)->name);
-      else {
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_title", OWS_NOERR,
-                                 "title=\"%s\">\n", "");
-      }
-
-      /* Get base url of the online resource to be the default value */
-      if(GET_LAYER(map, i)->connection)
-        pszValueMod = msStrdup( GET_LAYER(map, i)->connection );
-      else
-        pszValueMod = msStrdup( "" );
-      pszChar = strchr(pszValueMod, '?');
-      if( pszChar )
-        pszValueMod[pszChar - pszValueMod] = '\0';
-      if(msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                  NULL, "wms_onlineresource", OWS_WARN,
-                                  "        <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                                  pszValueMod) == OWS_WARN)
-        msIO_fprintf(stream, "<!-- wms_onlineresource not set, using base URL"
-                     " , but probably not what you want -->\n");
-      msIO_fprintf(stream, "      </Server>\n");
-      if(pszValueMod)
-        free(pszValueMod);
-
-      /*  */
-      /* Layer information */
-      /*  */
-      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                               NULL, "wms_name", OWS_WARN,
-                               "      <Name>%s</Name>\n",
-                               GET_LAYER(map, i)->name);
-      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                               NULL, "wms_title", OWS_WARN,
-                               "      <Title>%s</Title>\n",
-                               GET_LAYER(map, i)->name);
-      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                               NULL, "wms_abstract", OWS_NOERR,
-                               "      <Abstract>%s</Abstract>\n",
-                               NULL);
-
-      /* DataURL */
-      if(nVersion <= OWS_0_1_4) {
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_dataurl", OWS_NOERR,
-                                 "      <DataURL>%s</DataURL>\n",
-                                 NULL);
-      } else {
-        /* The DataURL have a width, height, format and an URL */
-        /* The metadata will be structured like this:  */
-        /* "width height format url" */
-        /* Note: in version 0.1.7 the width and height are not included  */
-        /* in the Context file, but they are included in the metadata for */
-        /* for consistency with the URLType. */
-        msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "MO",
-                          "dataurl", OWS_NOERR, NULL, "DataURL", NULL,
-                          " width=\"%s\"", " height=\"%s\"",
-                          " format=\"%s\"",
-                          "        <OnlineResource xlink:type=\"simple\""
-                          " xlink:href=\"%s\"/>\n",
-                          MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                          MS_TRUE, NULL, NULL, NULL,NULL,NULL, "      ");
-      }
-
-      /* MetadataURL */
-      /* The MetadataURL have a width, height, format and an URL */
-      /* The metadata will be structured like this:  */
-      /* "width height format url" */
-      msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "MO",
-                        "metadataurl", OWS_NOERR, NULL, "MetadataURL",NULL,
-                        " width=\"%s\"", " height=\"%s\""," format=\"%s\"",
-                        "        <OnlineResource xlink:type=\"simple\""
-                        " xlink:href=\"%s\"/>\n",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                        MS_TRUE, NULL, NULL, NULL, NULL, NULL, "      ");
-
-      /* MinScale && MaxScale */
-      if(nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->minscaledenom > 0)
-        msIO_fprintf(stream,
-                     "      <sld:MinScaleDenominator>%g</sld:MinScaleDenominator>\n",
-                     GET_LAYER(map, i)->minscaledenom);
-      if(nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->maxscaledenom > 0)
-        msIO_fprintf(stream,
-                     "      <sld:MaxScaleDenominator>%g</sld:MaxScaleDenominator>\n",
-                     GET_LAYER(map, i)->maxscaledenom);
-
-      /* Layer SRS */
-      msOWSGetEPSGProj(&(GET_LAYER(map, i)->projection),
-                                         &(GET_LAYER(map, i)->metadata),
-                                         "MO", MS_FALSE, &pszEPSG);
-      if(pszEPSG && (strcasecmp(pszEPSG, "(null)") != 0)) {
-        pszEncodedVal = msEncodeHTMLEntities(pszEPSG);
-        msIO_fprintf(stream, "      <SRS>%s</SRS>\n", pszEncodedVal);
-        msFree(pszEncodedVal);
-      }
-      msFree(pszEPSG);
-
-      /* Format */
-      if(msLookupHashTable(&(GET_LAYER(map, i)->metadata),"wms_formatlist")==NULL &&
-          msLookupHashTable(&(GET_LAYER(map, i)->metadata),"wms_format")==NULL) {
-        char* pszURL;
-        if(GET_LAYER(map, i)->connection)
-          pszURL = msStrdup( GET_LAYER(map, i)->connection );
-        else
-          pszURL = msStrdup( "" );
-
-        pszValueMod = strstr( pszURL, "FORMAT=" );
-        if( pszValueMod ) {
-          pszValueMod += 7;
-          pszChar = strchr(pszValueMod, '&');
-          if( pszChar )
-            pszValueMod[pszChar - pszValueMod] = '\0';
-          if(strcasecmp(pszValueMod, "") != 0) {
-            pszEncodedVal = msEncodeHTMLEntities(pszValueMod);
-            msIO_fprintf( stream, "      <FormatList>\n");
-            msIO_fprintf(stream,"        <Format>%s</Format>\n",pszValueMod);
-            msIO_fprintf( stream, "      </FormatList>\n");
-            msFree(pszEncodedVal);
-          }
-        }
-        free(pszURL);
-      } else {
-        char **papszFormats;
-        int numFormats, nForm;
-
-        pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                     "wms_formatlist");
-        if(!pszValue)
-          pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                       "wms_format");
-        pszCurrent = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                       "wms_format");
-
-        papszFormats = msStringSplit(pszValue, ',', &numFormats);
-        if(numFormats > 0 && papszFormats) {
-          msIO_fprintf( stream, "      <FormatList>\n");
-          for(nForm=0; nForm<numFormats; nForm++) {
-            pszEncodedVal =msEncodeHTMLEntities(papszFormats[nForm]);
-            if(pszCurrent && (strcasecmp(papszFormats[nForm],
-                                         pszCurrent) == 0))
-              msIO_fprintf( stream,
-                            "        <Format current=\"1\">%s</Format>\n",
-                            pszEncodedVal);
-            else
-              msIO_fprintf( stream, "        <Format>%s</Format>\n",
-                            pszEncodedVal);
-            msFree(pszEncodedVal);
-          }
-          msIO_fprintf( stream, "      </FormatList>\n");
-        }
-        if(papszFormats)
-          msFreeCharArray(papszFormats, numFormats);
-      }
-      /* Style */
-      /* First check the stylelist */
-      pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                   "wms_stylelist");
-      while( pszValue && *pszValue == ' ' )
-          pszValue ++;
-      if(pszValue == NULL || strlen(pszValue) < 1) {
-        /* Check if the style is in the connection URL */
-        char* pszURL;
-        if(GET_LAYER(map, i)->connection)
-          pszURL = msStrdup( GET_LAYER(map, i)->connection );
-        else
-          pszURL = msStrdup( "" );
-
-        /* Grab the STYLES in the URL */
-        pszValueMod = strstr( pszURL, "STYLES=" );
-        if( pszValueMod ) {
-          pszValueMod += 7;
-          pszChar = strchr(pszValueMod, '&');
-          if( pszChar )
-            pszValueMod[pszChar - pszValueMod] = '\0';
-
-          /* Check the SLD string from the URL */
-          if(GET_LAYER(map, i)->connection)
-            pszSLD2 = msStrdup(GET_LAYER(map, i)->connection);
-          else
-            pszSLD2 = msStrdup( "" );
-          if(pszSLD2) {
-            pszSLD = strstr(pszSLD2, "SLD=");
-            pszSLDBody = strstr(pszSLD2, "SLD_BODY=");
-          } else {
-            pszSLD = NULL;
-            pszSLDBody = NULL;
-          }
-          /* Check SLD */
-          if( pszSLD ) {
-            pszChar = strchr(pszSLD, '&');
-            if( pszChar )
-              pszSLD[pszChar - pszSLD] = '\0';
-            pszSLD += 4;
-          }
-          /* Check SLDBody  */
-          if( pszSLDBody ) {
-            pszChar = strchr(pszSLDBody, '&');
-            if( pszChar )
-              pszSLDBody[pszChar - pszSLDBody] = '\0';
-            pszSLDBody += 9;
-          }
-          if( (pszValueMod && (strcasecmp(pszValueMod, "") != 0)) ||
-              (pszSLD && (strcasecmp(pszSLD, "") != 0)) ||
-              (pszSLDBody && (strcasecmp(pszSLDBody, "") != 0))) {
-            /* Write Name and Title */
-            msIO_fprintf( stream, "      <StyleList>\n");
-            msIO_fprintf( stream, "        <Style current=\"1\">\n");
-            if( pszValueMod && (strcasecmp(pszValueMod, "") != 0)) {
-              pszEncodedVal = msEncodeHTMLEntities(pszValueMod);
-              msIO_fprintf(stream, "          <Name>%s</Name>\n",
-                           pszEncodedVal);
-              msIO_fprintf(stream,"          <Title>%s</Title>\n",
-                           pszEncodedVal);
-              msFree(pszEncodedVal);
-            }
-            /* Write the SLD string from the URL */
-            if( pszSLD && (strcasecmp(pszSLD, "") != 0)) {
-              pszEncodedVal = msEncodeHTMLEntities(pszSLD);
-              msIO_fprintf( stream, "          <SLD>\n" );
-              msIO_fprintf( stream,
-                            "            <OnlineResource xlink:type=\"simple\" ");
-              msIO_fprintf(stream,"xlink:href=\"%s\"/>",
-                           pszEncodedVal);
-              msIO_fprintf( stream, "          </SLD>\n" );
-              free(pszEncodedVal);
-            } else if(pszSLDBody && (strcasecmp(pszSLDBody, "") != 0)) {
-              msIO_fprintf( stream, "          <SLD>\n" );
-              msIO_fprintf( stream, "            %s\n",pszSLDBody);
-              msIO_fprintf( stream, "          </SLD>\n" );
-            }
-            msIO_fprintf( stream, "        </Style>\n");
-            msIO_fprintf( stream, "      </StyleList>\n");
-          }
-          if(pszSLD2) {
-            free(pszSLD2);
-            pszSLD2 = NULL;
-          }
-        }
-        free(pszURL);
-      } else {
-        const char* pszCurrent;
-        /* If the style information is not in the connection URL, */
-        /* read the metadata. */
-        pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                     "wms_stylelist");
-        pszCurrent = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                       "wms_style");
-        msIO_fprintf( stream, "      <StyleList>\n");
-        /* Loop in each style in the style list */
-        while(pszValue != NULL) {
-          char* pszStyle = msStrdup(pszValue);
-          pszChar = strchr(pszStyle, ',');
-          if(pszChar != NULL)
-            pszStyle[pszChar - pszStyle] = '\0';
-          if(pszStyle[0] == '\0')
-          {
-            msFree(pszStyle);
-            continue;
-          }
-
-          if(pszCurrent && (strcasecmp(pszStyle, pszCurrent) == 0))
-            msIO_fprintf( stream,"        <Style current=\"1\">\n" );
-          else
-            msIO_fprintf( stream, "        <Style>\n" );
-
-          /* Write SLDURL if it is in the metadata */
-          pszStyleItem = (char*)malloc(strlen(pszStyle)+10+10);
-          sprintf(pszStyleItem, "wms_style_%s_sld", pszStyle);
-          if(msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                               pszStyleItem) != NULL) {
-            msIO_fprintf(stream, "          <SLD>\n");
-            msOWSPrintEncodeMetadata(stream,
-                                     &(GET_LAYER(map, i)->metadata),
-                                     NULL, pszStyleItem,
-                                     OWS_NOERR,
-                                     "            <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                                     NULL);
-            msIO_fprintf(stream, "          </SLD>\n");
-            free(pszStyleItem);
-          } else {
-            /* If the URL is not there, check for SLDBody */
-            sprintf(pszStyleItem, "wms_style_%s_sld_body", pszStyle);
-            if(msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                 pszStyleItem) != NULL) {
-              msIO_fprintf(stream, "          <SLD>\n");
-              msOWSPrintMetadata(stream,&(GET_LAYER(map, i)->metadata),
-                                 NULL, pszStyleItem, OWS_NOERR,
-                                 "            %s\n", NULL);
-              msIO_fprintf(stream, "          </SLD>\n");
-              free(pszStyleItem);
-            } else {
-              /* If the SLD is not specified, then write the */
-              /* name, Title and LegendURL */
-              free(pszStyleItem);
-              /* Name */
-              pszEncodedVal = msEncodeHTMLEntities(pszStyle);
-              msIO_fprintf(stream, "          <Name>%s</Name>\n",
-                           pszEncodedVal);
-              msFree(pszEncodedVal);
-              pszStyleItem = (char*)malloc(strlen(pszStyle)+10+8);
-              sprintf(pszStyleItem, "wms_style_%s_title",pszStyle);
-              /* Title */
-              msOWSPrintEncodeMetadata(stream,
-                                       &(GET_LAYER(map, i)->metadata),
-                                       NULL, pszStyleItem,
-                                       OWS_NOERR,
-                                       "          <Title>%s</Title>\n",
-                                       NULL);
-              free(pszStyleItem);
-
-              /* LegendURL */
-              pszStyleItem = (char*)malloc(strlen(pszStyle)+10+20);
-              sprintf(pszStyleItem, "style_%s_legendurl",
-                      pszStyle);
-              msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata),
-                                "M", pszStyleItem, OWS_NOERR, NULL,
-                                "LegendURL", NULL, " width=\"%s\"",
-                                " height=\"%s\""," format=\"%s\"",
-                                "            <OnlineResource "
-                                "xlink:type=\"simple\""
-                                " xlink:href=\"%s\"/>\n          ",
-                                MS_FALSE, MS_FALSE, MS_FALSE,
-                                MS_FALSE, MS_TRUE, NULL, NULL,
-                                NULL, NULL, NULL, "          ");
-              free(pszStyleItem);
-            }
-          }
-
-          msIO_fprintf( stream,"        </Style>\n" );
-
-          msFree(pszStyle);
-          pszValue = strchr(pszValue, ',');
-          if(pszValue)
-            pszValue++;
-        }
-        msIO_fprintf( stream, "      </StyleList>\n");
-      }
-
-      /* Dimension element */;
-      pszCurrent = NULL;
-
-      pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                   "wms_dimensionlist");
-      pszCurrent = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                     "wms_dimension");
-      while(pszValue != NULL) {
-        /* Extract the dimension name from the list */
-        pszDimension = msStrdup(pszValue);
-        pszChar = strchr(pszDimension, ',');
-        if(pszChar != NULL)
-          pszDimension[pszChar - pszDimension] = '\0';
-        if(strcasecmp(pszDimension, "") == 0) {
-          free(pszDimension);
-          pszValue = strchr(pszValue, ',');
-          if(pszValue)
-            pszValue++;
-          continue;
-        }
-
-        /* From the dimension list, extract the required dimension */
-        msOWSGetDimensionInfo(GET_LAYER(map, i), pszDimension,
-                              &pszDimUserValue, &pszDimUnits,
-                              &pszDimDefault, &pszDimNearValue,
-                              &pszDimUnitSymbol, &pszDimMultiValue);
-
-        if(pszDimUserValue == NULL || pszDimUnits == NULL ||
-            pszDimUnitSymbol == NULL) {
-          free(pszDimension);
-          pszValue = strchr(pszValue, ',');
-          if(pszValue)
-            pszValue++;
-          continue;
-        }
-
-        if(!bDimensionList) {
-          bDimensionList = 1;
-          msIO_fprintf( stream, "      <DimensionList>\n");
-        }
-
-        /* name */
-        msIO_fprintf( stream, "        <Dimension name=\"%s\"",
-                      pszDimension);
-        /* units */
-        msIO_fprintf( stream, " units=\"%s\"",      pszDimUnits);
-        /* unitSymbol */
-        msIO_fprintf( stream, " unitSymbol=\"%s\"", pszDimUnitSymbol);
-        /* userValue */
-        msIO_fprintf( stream, " userValue=\"%s\"",  pszDimUserValue);
-        /* default */
-        if(pszDimDefault)
-          msIO_fprintf( stream, " default=\"%s\"", pszDimDefault);
-        /* multipleValues */
-        if(pszDimMultiValue)
-          msIO_fprintf(stream, " multipleValues=\"%s\"",
-                       pszDimMultiValue);
-        /* nearestValue */
-        if(pszDimNearValue)
-          msIO_fprintf( stream," nearestValue=\"%s\"",pszDimNearValue);
-
-        if(pszCurrent && strcasecmp(pszDimension, pszCurrent) == 0)
-          msIO_fprintf( stream, " current=\"1\"");
-
-        msIO_fprintf( stream, "/>\n");
-
-        free(pszDimension);
-        pszValue = strchr(pszValue, ',');
-        if(pszValue)
-          pszValue++;
-      }
-
-      if(bDimensionList) {
-        msIO_fprintf( stream, "      </DimensionList>\n");
-        bDimensionList = 0;
-      }
-
-      msIO_fprintf(stream, "    </Layer>\n");
-    }
-  }
-
-  /* Close layer list */
-  msIO_fprintf(stream, "  </LayerList>\n");
-  /* Close Map Context */
-
-  if(nVersion >= OWS_1_0_0) {
-    msIO_fprintf(stream, "</ViewContext>\n");
-  } else if(nVersion >= OWS_0_1_7) {
-    msIO_fprintf(stream, "</View_Context>\n");
-  } else { /* 0.1.4 */
-    msIO_fprintf(stream, "</WMS_Viewer_Context>\n");
-  }
-
-  return MS_SUCCESS;
-#else
-  msSetError(MS_MAPCONTEXTERR,
-             "Not implemented since Map Context is not enabled.",
-             "msWriteMapContext()");
-  return MS_FAILURE;
-#endif
-}
-
-
diff -pruN 8.0.1-5/mapcontour.c 8.2.0~beta1-1~exp1/mapcontour.c
--- 8.0.1-5/mapcontour.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcontour.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1042 +0,0 @@
-/**********************************************************************
- * $Id: mapcontour.c 12629 2011-10-06 18:06:34Z aboudreault $
- *
- * Project:  MapServer
- * Purpose:  Contour Layer
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- * Author:   Daniel Morissette (dmorissette@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2011, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include "mapserver.h"
-#include "mapcopy.h"
-#include "mapresample.h"
-
-#include "ogr_api.h"
-#include "ogr_srs_api.h"
-#include "gdal.h"
-#include "gdal_alg.h"
-
-#include "mapows.h"
-#include "mapthread.h"
-#include "mapraster.h"
-#include "cpl_string.h"
-
-#define GEO_TRANS(tr,x,y)  ((tr)[0]+(tr)[1]*(x)+(tr)[2]*(y))
-
-extern int InvGeoTransform(double *gt_in, double *gt_out);
-
-typedef struct {
-
-  /* OGR DataSource */
-  layerObj ogrLayer;
-
-  /* internal use */
-  GDALDatasetH hOrigDS;
-  GDALDatasetH  hDS;
-  double *buffer; /* memory dataset buffer */
-  rectObj extent; /* original dataset extent */
-  OGRDataSourceH hOGRDS;
-  double cellsize;
-
-} contourLayerInfo;
-
-
-static int msContourLayerInitItemInfo(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerInitItemInfo()");
-    return MS_FAILURE;
-  }
-
-  return msLayerInitItemInfo(&clinfo->ogrLayer);
-}
-
-static void msContourLayerFreeItemInfo(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerFreeItemInfo()");
-    return;
-  }
-
-  msLayerFreeItemInfo(&clinfo->ogrLayer);
-}
-
-static void msContourLayerInfoInitialize(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (clinfo != NULL)
-    return;
-
-  clinfo = (contourLayerInfo *) msSmallCalloc(1,sizeof(contourLayerInfo));
-  layer->layerinfo = clinfo;
-  clinfo->hOrigDS = NULL;  
-  clinfo->hDS = NULL;
-  clinfo->extent.minx = -1.0;
-  clinfo->extent.miny = -1.0;
-  clinfo->extent.maxx = -1.0;
-  clinfo->extent.maxy = -1.0;
-  
-  initLayer(&clinfo->ogrLayer, layer->map);
-  clinfo->ogrLayer.type = layer->type;
-  clinfo->ogrLayer.debug = layer->debug;
-  clinfo->ogrLayer.connectiontype = MS_OGR;
-  clinfo->ogrLayer.name = msStrdup(layer->name);
-  clinfo->ogrLayer.connection = (char*)msSmallMalloc(strlen(clinfo->ogrLayer.name)+13);
-  sprintf(clinfo->ogrLayer.connection, "__%s_CONTOUR__", clinfo->ogrLayer.name);
-  clinfo->ogrLayer.units = layer->units;
-
-  if (msOWSLookupMetadata(&(layer->metadata), "OFG", "ID_type") == NULL) {
-    msInsertHashTable(&(layer->metadata), "gml_ID_type", "Integer");
-  }
-  {
-    const char* elevItem = CSLFetchNameValue(layer->processing,"CONTOUR_ITEM");
-    if (elevItem && strlen(elevItem) > 0) {
-       char szTmp[100];
-       snprintf(szTmp, sizeof(szTmp), "%s_type", elevItem);
-       if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
-         snprintf(szTmp, sizeof(szTmp), "gml_%s_type", elevItem);
-         msInsertHashTable(&(layer->metadata), szTmp, "Real");
-       }
-    }
-  }
-}
-
-static void msContourLayerInfoFree(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (clinfo == NULL)
-    return;
-
-  freeLayer(&clinfo->ogrLayer);
-  free(clinfo);
-
-  layer->layerinfo = NULL;
-}
-
-static int msContourLayerReadRaster(layerObj *layer, rectObj rect)
-{
-  mapObj *map = layer->map;  
-  char **bands;
-  char pointer[64], memDSPointer[128];
-  int band = 1;
-  double adfGeoTransform[6], adfInvGeoTransform[6];
-  double llx, lly, urx, ury;  
-  rectObj copyRect, mapRect;
-  int dst_xsize, dst_ysize;
-  int virtual_grid_step_x, virtual_grid_step_y;
-  int src_xoff, src_yoff, src_xsize, src_ysize;  
-  double map_cellsize_x, map_cellsize_y, dst_cellsize_x, dst_cellsize_y;
-  GDALRasterBandH hBand = NULL;
-  CPLErr eErr;
-  
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (layer->debug)
-    msDebug("Entering msContourLayerReadRaster().\n");
-
-  if (clinfo == NULL || clinfo->hOrigDS == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerReadRaster()");
-    return MS_FAILURE;    
-  }
-
-  bands = CSLTokenizeStringComplex(
-               CSLFetchNameValue(layer->processing,"BANDS"), " ,", FALSE, FALSE );
-  if (CSLCount(bands) > 0) {
-    band = atoi(bands[0]);
-    if (band < 1 || band > GDALGetRasterCount(clinfo->hOrigDS)) {
-      msSetError( MS_IMGERR,
-                  "BANDS PROCESSING directive includes illegal band '%d', should be from 1 to %d.",
-                  "msContourLayerReadRaster()",
-                  band, GDALGetRasterCount(clinfo->hOrigDS));
-      CSLDestroy(bands);
-      return MS_FAILURE;
-    }
-  }
-  CSLDestroy(bands);
-
-  hBand = GDALGetRasterBand(clinfo->hOrigDS, band);
-  if (hBand == NULL)
-  {
-    msSetError(MS_IMGERR,
-               "Band %d does not exist on dataset.",
-               "msContourLayerReadRaster()", band);
-    return MS_FAILURE;
-  }
-
-  if (layer->projection.numargs > 0 &&
-      EQUAL(layer->projection.args[0], "auto")) {
-    const char *wkt;
-    wkt = GDALGetProjectionRef(clinfo->hOrigDS);
-    if (wkt != NULL && strlen(wkt) > 0) {
-      if (msOGCWKT2ProjectionObj(wkt, &(layer->projection),
-                                 layer->debug) != MS_SUCCESS) {
-        char  msg[MESSAGELENGTH*2];
-        errorObj *ms_error = msGetErrorObj();
-
-        snprintf( msg, sizeof(msg),
-                  "%s\n"
-                  "PROJECTION AUTO cannot be used for this "
-                  "GDAL raster (`%s').",
-                  ms_error->message, layer->data);
-        msg[MESSAGELENGTH-1] = '\0';
-
-        msSetError(MS_OGRERR, "%s","msDrawRasterLayer()",
-                   msg);
-        return MS_FAILURE;
-      }
-    }
-  }
-  
-  /*
-   * Compute the georeferenced window of overlap, and read the source data
-   * downsampled to match output resolution, or at full resolution if
-   * output resolution is lower than the source resolution.
-   *
-   * A large portion of this overlap calculation code was borrowed from 
-   * msDrawRasterLayerGDAL(). 
-   * Would be possible to move some of this to a reusable function?
-   *
-   * Note: This code works only if no reprojection is involved. It would
-   * need rework to support cases where output projection differs from source
-   * data file projection.
-   */
-  
-  src_xsize = GDALGetRasterXSize(clinfo->hOrigDS);
-  src_ysize = GDALGetRasterYSize(clinfo->hOrigDS);
-
-  /* set the Dataset extent */
-  msGetGDALGeoTransform(clinfo->hOrigDS, map, layer, adfGeoTransform);  
-  clinfo->extent.minx = adfGeoTransform[0];
-  clinfo->extent.maxy = adfGeoTransform[3];
-  clinfo->extent.maxx = adfGeoTransform[0] + src_xsize * adfGeoTransform[1];
-  clinfo->extent.miny = adfGeoTransform[3] + src_ysize * adfGeoTransform[5];
-  
-  if (layer->transform) {
-    if (layer->debug)
-      msDebug("msContourLayerReadRaster(): Entering transform.\n");
-
-    InvGeoTransform(adfGeoTransform, adfInvGeoTransform);
-
-    mapRect = rect;
-    if( map->cellsize == 0 )
-    {
-        map->cellsize = msAdjustExtent(&mapRect,map->width,map->height);
-    }
-    map_cellsize_x = map_cellsize_y = map->cellsize;
-    /* if necessary, project the searchrect to source coords */
-    if (msProjectionsDiffer( &(map->projection), &(layer->projection)))  {
-      if ( msProjectRect(&map->projection, &layer->projection, &mapRect)
-          != MS_SUCCESS ) {
-        msDebug("msContourLayerReadRaster(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name);
-        return MS_FAILURE;
-      }
-
-      map_cellsize_x = MS_CELLSIZE(mapRect.minx, mapRect.maxx, map->width);
-      map_cellsize_y = MS_CELLSIZE(mapRect.miny, mapRect.maxy, map->height);
-
-      /* if the projection failed to project the extent requested, we need to
-         calculate the cellsize to preserve the initial map cellsize ratio */
-      if ( (mapRect.minx < GEO_TRANS(adfGeoTransform,0,src_ysize)) ||
-           (mapRect.maxx > GEO_TRANS(adfGeoTransform,src_xsize,0)) ||
-           (mapRect.miny < GEO_TRANS(adfGeoTransform+3,0,src_ysize)) || 
-           (mapRect.maxy > GEO_TRANS(adfGeoTransform+3,src_xsize,0)) ) {
-
-        int src_unit, dst_unit;
-        src_unit = GetMapserverUnitUsingProj(&map->projection);
-        dst_unit = GetMapserverUnitUsingProj(&layer->projection);
-        if (src_unit == -1 || dst_unit == -1) {
-          msDebug("msContourLayerReadRaster(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name);
-          return MS_FAILURE;
-        }
-
-        map_cellsize_x =  MS_CONVERT_UNIT(src_unit, dst_unit,
-                                          MS_CELLSIZE(rect.minx, rect.maxx, map->width)); 
-        map_cellsize_y = MS_CONVERT_UNIT(src_unit, dst_unit,
-                                         MS_CELLSIZE(rect.miny, rect.maxy, map->height));
-      }       
-    }
-
-    if (map_cellsize_x == 0 || map_cellsize_y == 0) {
-      if (layer->debug)
-        msDebug("msContourLayerReadRaster(): Cellsize can't be 0.\n");
-      return MS_FAILURE;
-    }
-    
-    /* Adjust MapServer pixel model to GDAL pixel model */
-    mapRect.minx -= map_cellsize_x*0.5;
-    mapRect.maxx += map_cellsize_x*0.5;
-    mapRect.miny -= map_cellsize_y*0.5;
-    mapRect.maxy += map_cellsize_y*0.5;
-
-
-    /*
-     * If raw data cellsize (from geotransform) is larger than output map_cellsize
-     * then we want to extract only enough data to match the output map resolution
-     * which means that GDAL will automatically sample the data on read.
-     *
-     * To prevent bad contour effects on tile edges, we adjust the target cellsize 
-     * to align the extracted window with a virtual grid based on the origin of the 
-     * raw data and a virtual grid step size corresponding to an integer sampling step.
-     *
-     * If source data has a greater cellsize (i.e. lower res) that requested ouptut map
-     * then we use the raw data cellsize as target cellsize since there is no point in 
-     * interpolating the data for contours in this case.
-     */
-
-    virtual_grid_step_x = (int)floor(map_cellsize_x / ABS(adfGeoTransform[1]));
-    if (virtual_grid_step_x < 1)
-      virtual_grid_step_x = 1; /* Do not interpolate data if grid sampling step < 1 */
-
-    virtual_grid_step_y = (int)floor(map_cellsize_y / ABS(adfGeoTransform[5]));
-    if (virtual_grid_step_y < 1)
-      virtual_grid_step_y = 1; /* Do not interpolate data if grid sampling step < 1 */
-    
-    /* target cellsize is a multiple of raw data cellsize based on grid step*/
-    dst_cellsize_x = ABS(adfGeoTransform[1]) * virtual_grid_step_x;
-    dst_cellsize_y = ABS(adfGeoTransform[5]) * virtual_grid_step_y;
-
-    /* Compute overlap between source and target views */
-
-    copyRect = mapRect;
-
-    if (copyRect.minx < GEO_TRANS(adfGeoTransform,0,src_ysize))
-      copyRect.minx = GEO_TRANS(adfGeoTransform,0,src_ysize);
-    if (copyRect.maxx > GEO_TRANS(adfGeoTransform,src_xsize,0))
-      copyRect.maxx = GEO_TRANS(adfGeoTransform,src_xsize,0);
-    if (copyRect.miny < GEO_TRANS(adfGeoTransform+3,0,src_ysize))
-      copyRect.miny = GEO_TRANS(adfGeoTransform+3,0,src_ysize);
-    if (copyRect.maxy > GEO_TRANS(adfGeoTransform+3,src_xsize,0))
-      copyRect.maxy = GEO_TRANS(adfGeoTransform+3,src_xsize,0);
-    
-    if (copyRect.minx >= copyRect.maxx || copyRect.miny >= copyRect.maxy) {
-      if (layer->debug)
-        msDebug("msContourLayerReadRaster(): No overlap.\n");
-      return MS_SUCCESS;
-    }
-
-    /*
-     * Convert extraction window to raster coordinates
-     */
-    llx = GEO_TRANS(adfInvGeoTransform+0,copyRect.minx,copyRect.miny);
-    lly = GEO_TRANS(adfInvGeoTransform+3,copyRect.minx,copyRect.miny);
-    urx = GEO_TRANS(adfInvGeoTransform+0,copyRect.maxx,copyRect.maxy);
-    ury = GEO_TRANS(adfInvGeoTransform+3,copyRect.maxx,copyRect.maxy);
-
-    /* 
-     * Align extraction window with virtual grid 
-     * (keep in mind raster coordinates origin is at upper-left)
-     * We also add an extra buffer to fix tile boundarie issues when zoomed
-     */
-    llx = floor(llx / virtual_grid_step_x) * virtual_grid_step_x - (virtual_grid_step_x*5);
-    urx = ceil(urx / virtual_grid_step_x) * virtual_grid_step_x + (virtual_grid_step_x*5);
-    ury = floor(ury / virtual_grid_step_y) * virtual_grid_step_y - (virtual_grid_step_x*5);
-    lly = ceil(lly / virtual_grid_step_y) * virtual_grid_step_y + (virtual_grid_step_x*5);
-    
-    src_xoff = MS_MAX(0,(int) floor(llx+0.5));
-    src_yoff = MS_MAX(0,(int) floor(ury+0.5));
-    src_xsize = MS_MIN(MS_MAX(0,(int) (urx - llx + 0.5)),
-                    GDALGetRasterXSize(clinfo->hOrigDS) - src_xoff);
-    src_ysize = MS_MIN(MS_MAX(0,(int) (lly - ury + 0.5)),
-                    GDALGetRasterYSize(clinfo->hOrigDS) - src_yoff);
-
-    /* Update the geographic extent (buffer added) */
-    /* TODO: a better way to go the geo_trans */
-    copyRect.minx = GEO_TRANS(adfGeoTransform+0,src_xoff,0);
-    copyRect.maxx = GEO_TRANS(adfGeoTransform+0,src_xoff+src_xsize,0);
-    copyRect.miny = GEO_TRANS(adfGeoTransform+3,0,src_yoff+src_ysize);
-    copyRect.maxy = GEO_TRANS(adfGeoTransform+3,0,src_yoff);
-    
-    /* 
-     * If input window is to small then stop here
-     */
-    if (src_xsize < 2 || src_ysize < 2)
-    {
-      if (layer->debug)
-        msDebug("msContourLayerReadRaster(): input window too small, or no apparent overlap between map view and this window(1).\n");
-      return MS_SUCCESS;
-    }
-
-    /* Target buffer size */
-    dst_xsize = (int)ceil((copyRect.maxx - copyRect.minx) / dst_cellsize_x);
-    dst_ysize = (int)ceil((copyRect.maxy - copyRect.miny) / dst_cellsize_y);
-
-    if (dst_xsize == 0 || dst_ysize == 0) {
-      if (layer->debug)
-        msDebug("msContourLayerReadRaster(): no apparent overlap between map view and this window(2).\n");
-      return MS_SUCCESS;
-    }
-
-    if (layer->debug)
-      msDebug( "msContourLayerReadRaster(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
-               src_xoff, src_yoff, src_xsize, src_ysize,
-               0, 0, dst_xsize, dst_ysize );
-  } else {
-    src_xoff = 0;
-    src_yoff = 0;
-    dst_xsize = src_xsize = MS_MIN(map->width,src_xsize);
-    dst_ysize = src_ysize = MS_MIN(map->height,src_ysize);
-    copyRect.minx = 0;
-    copyRect.miny = 0;
-    (void)copyRect.miny;
-    copyRect.maxx = map->width;
-    copyRect.maxy = map->height;
-    (void)copyRect.maxx;
-    dst_cellsize_y = dst_cellsize_x = 1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Allocate buffer, and read data into it.                         */
-  /* -------------------------------------------------------------------- */
-
-  clinfo->buffer = (double *) malloc(sizeof(double) * dst_xsize * dst_ysize);
-  if (clinfo->buffer == NULL) {
-    msSetError(MS_MEMERR, "Malloc(): Out of memory.", "msContourLayerReadRaster()");
-    return MS_FAILURE;
-  }
-
-  eErr = GDALRasterIO(hBand, GF_Read,
-                      src_xoff, src_yoff, src_xsize, src_ysize,
-                      clinfo->buffer, dst_xsize, dst_ysize, GDT_Float64,
-                      0, 0);
-
-  if (eErr != CE_None) {
-    msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                "msContourLayerReadRaster()", CPLGetLastErrorMsg() );
-    free(clinfo->buffer);
-    return MS_FAILURE;
-  }
-
-  memset(pointer, 0, sizeof(pointer));
-  CPLPrintPointer(pointer, clinfo->buffer, sizeof(pointer));
-  sprintf(memDSPointer,"MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Float64",
-          pointer, dst_xsize, dst_ysize);
-  clinfo->hDS = GDALOpen(memDSPointer,  GA_ReadOnly);
-  if (clinfo->hDS == NULL) {
-    msSetError(MS_IMGERR,
-               "Unable to open GDAL Memory dataset.",
-               "msContourLayerReadRaster()");
-    free(clinfo->buffer);
-    return MS_FAILURE;
-  }
-
-  {
-      // Copy nodata value from source dataset to memory dataset
-      int bHasNoData = FALSE;
-      double dfNoDataValue = GDALGetRasterNoDataValue(hBand, &bHasNoData);
-      if( bHasNoData )
-      {
-          GDALSetRasterNoDataValue(GDALGetRasterBand(clinfo->hDS, 1),
-                                   dfNoDataValue);
-      }
-  }
-
-  adfGeoTransform[0] = copyRect.minx;
-  adfGeoTransform[1] = dst_cellsize_x;
-  adfGeoTransform[2] = 0;
-  adfGeoTransform[3] = copyRect.maxy;
-  adfGeoTransform[4] = 0;
-  adfGeoTransform[5] = -dst_cellsize_y;
-
-  clinfo->cellsize = MS_MAX(dst_cellsize_x, dst_cellsize_y);
-  {
-    char buf[64];
-    sprintf(buf, "%lf", clinfo->cellsize);
-    msInsertHashTable(&layer->metadata, "__data_cellsize__", buf);
-  }
-      
-  GDALSetGeoTransform(clinfo->hDS, adfGeoTransform);
-  return MS_SUCCESS;
-}
-
-static void msContourOGRCloseConnection(void *conn_handle)
-{
-  OGRDataSourceH hDS = (OGRDataSourceH) conn_handle;
-
-  msAcquireLock(TLOCK_OGR);
-  OGR_DS_Destroy(hDS);
-  msReleaseLock(TLOCK_OGR);
-}
-
-/* Function that parses multiple options in the a list. It also supports
-   min/maxscaledenom checks. ie. "CONTOUR_INTERVAL=0,3842942:10" */
-static char* msContourGetOption(layerObj *layer, const char *name)
-{
-  int c, i, found = MS_FALSE;
-  char **values, **tmp, **options;
-  double maxscaledenom, minscaledenom;
-  char *value = NULL;
-  
-  options = CSLFetchNameValueMultiple(layer->processing, name);
-  c = CSLCount(options);
-
-  /* First pass to find the value among options that have min/maxscaledenom */
-  /* specified */
-  for (i=0; i<c && found == MS_FALSE; ++i) {
-    values = CSLTokenizeStringComplex(options[i], ":", FALSE, FALSE);
-    if (CSLCount(values) == 2) {
-      tmp = CSLTokenizeStringComplex(values[0], ",", FALSE, FALSE);
-      if (CSLCount(tmp) == 2) {
-        minscaledenom = atof(tmp[0]);
-        maxscaledenom = atof(tmp[1]);
-        if (layer->map->scaledenom <= 0 ||
-            (((maxscaledenom <= 0) || (layer->map->scaledenom <= maxscaledenom)) &&
-             ((minscaledenom <= 0) || (layer->map->scaledenom > minscaledenom)))) {
-          value = msStrdup(values[1]);
-          found = MS_TRUE;
-        }
-      }
-      CSLDestroy(tmp);
-    }
-    CSLDestroy(values);
-  }
-  
-  /* Second pass to find the value among options that do NOT have */
-  /* min/maxscaledenom specified */
-  for (i=0; i<c && found == MS_FALSE; ++i) {
-    values = CSLTokenizeStringComplex(options[i], ":", FALSE, FALSE);
-    if (CSLCount(values) == 1) {
-      value = msStrdup(values[0]);
-      found = MS_TRUE;
-    }
-    CSLDestroy(values);
-  }
-
-  CSLDestroy(options);
-
-  return value;
-}
-
-static int msContourLayerGenerateContour(layerObj *layer)
-{
-  OGRSFDriverH hDriver;
-  OGRFieldDefnH hFld;
-  OGRLayerH hLayer;
-  const char *elevItem;
-  char *option;
-  double interval = 1.0, levels[1000];
-  int levelCount = 0;
-  GDALRasterBandH hBand = NULL;
-  CPLErr eErr;
-  int bHasNoData = FALSE;
-  double dfNoDataValue;
-
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  OGRRegisterAll();
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerCreateOGRDataSource()");
-    return MS_FAILURE;
-  }
-
-  if (!clinfo->hDS) { /* no overlap */
-    return MS_SUCCESS;
-  }
-  
-  hBand = GDALGetRasterBand(clinfo->hDS, 1);
-  if (hBand == NULL)
-  {
-    msSetError(MS_IMGERR,
-               "Band %d does not exist on dataset.",
-               "msContourLayerGenerateContour()", 1);
-    return MS_FAILURE;
-  }
-
-  /* Create the OGR DataSource */
-  hDriver = OGRGetDriverByName("Memory");
-  if (hDriver == NULL) {
-    msSetError(MS_OGRERR,
-               "Unable to get OGR driver 'Memory'.",
-               "msContourLayerCreateOGRDataSource()");
-    return MS_FAILURE;
-  }
-
-  clinfo->hOGRDS = OGR_Dr_CreateDataSource(hDriver, "", NULL);
-  if (clinfo->hOGRDS == NULL) {
-    msSetError(MS_OGRERR,
-               "Unable to create OGR DataSource.",
-               "msContourLayerCreateOGRDataSource()");
-    return MS_FAILURE;
-  }
-
-  hLayer = OGR_DS_CreateLayer(clinfo->hOGRDS, clinfo->ogrLayer.name, NULL,
-                              wkbLineString, NULL );
-
-  hFld = OGR_Fld_Create("ID", OFTInteger);
-  OGR_Fld_SetWidth(hFld, 8);
-  OGR_L_CreateField(hLayer, hFld, FALSE);
-  OGR_Fld_Destroy(hFld);
-
-  /* Check if we have a coutour item specified */
-  elevItem = CSLFetchNameValue(layer->processing,"CONTOUR_ITEM");
-  if (elevItem && strlen(elevItem) > 0) {
-    hFld = OGR_Fld_Create(elevItem, OFTReal);
-    OGR_Fld_SetWidth(hFld, 12);
-    OGR_Fld_SetPrecision(hFld, 3);
-    OGR_L_CreateField(hLayer, hFld, FALSE);
-    OGR_Fld_Destroy(hFld);
-  }
-  else {
-    elevItem = NULL;
-  }
-
-  option = msContourGetOption(layer, "CONTOUR_INTERVAL");
-  if (option) {
-    interval = atof(option);
-    free(option);
-  }
-
-  option = msContourGetOption(layer, "CONTOUR_LEVELS");
-  if (option) {
-    int i,c;
-    char **levelsTmp;
-    levelsTmp = CSLTokenizeStringComplex(option, ",", FALSE, FALSE);
-    c = CSLCount(levelsTmp);
-    for (i=0;i<c && i<(int)(sizeof(levels)/sizeof(double)) ;++i)
-      levels[levelCount++] = atof(levelsTmp[i]);
-
-    CSLDestroy(levelsTmp);
-    free(option);
-  }
-
-  dfNoDataValue = GDALGetRasterNoDataValue(hBand, &bHasNoData);
-
-  eErr = GDALContourGenerate( hBand, interval, 0.0,
-                              levelCount, levels,
-                              bHasNoData, dfNoDataValue, hLayer,
-                              OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn( hLayer),
-                                                    "ID" ),
-                              (elevItem == NULL) ? -1 :
-                              OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn( hLayer), 
-                                                    elevItem ),
-                              NULL, NULL );
-
-  if (eErr != CE_None) {
-    msSetError( MS_IOERR, "GDALContourGenerate() failed: %s",
-                "msContourLayerGenerateContour()", CPLGetLastErrorMsg() );
-    return MS_FAILURE;
-  }
-  
-  msConnPoolRegister(&clinfo->ogrLayer, clinfo->hOGRDS, msContourOGRCloseConnection);
-
-  return MS_SUCCESS;
-
-}
-
-int msContourLayerOpen(layerObj *layer)
-{
-  char *decrypted_path;
-  char szPath[MS_MAXPATHLEN];
-  contourLayerInfo *clinfo;
-
-  if (layer->debug)
-    msDebug("Entering msContourLayerOpen().\n");
-
-  /* If we don't have info, initialize an empty one now */
-  if (layer->layerinfo == NULL)
-    msContourLayerInfoInitialize(layer);
-
-  clinfo = (contourLayerInfo *) layer->layerinfo;
-  if (layer->data == NULL && layer->tileindex == NULL ) {
-    msSetError(MS_MISCERR,
-               "Layer %s has neither DATA nor TILEINDEX defined.",
-               "msContourLayerOpen()",
-               layer->name);
-    return MS_FAILURE;
-  }
-
-  if( layer->tileindex != NULL )
-  {
-      char szTilename[MS_MAXPATHLEN];
-      int status;
-      int tilelayerindex, tileitemindex, tilesrsindex;
-      rectObj searchrect;
-      layerObj* tlp;
-      shapeObj tshp;
-      char tilesrsname[1];
-
-      msInitShape(&tshp);
-      searchrect = layer->map->extent;
-
-      status = msDrawRasterSetupTileLayer(layer->map, layer,
-                                 &searchrect, MS_FALSE,
-                                 &tilelayerindex,
-                                 &tileitemindex,
-                                 &tilesrsindex,
-                                 &tlp);
-      if( status == MS_FAILURE )
-      {
-          return MS_FAILURE;
-      }
-
-      status = msDrawRasterIterateTileIndex(layer, tlp, &tshp,
-                                            tileitemindex, -1,
-                                            szTilename, sizeof(szTilename),
-                                            tilesrsname, sizeof(tilesrsname));
-      if( status == MS_FAILURE || status == MS_DONE ) {
-          if( status == MS_DONE )
-          {
-              if (layer->debug)
-                msDebug("No raster matching filter.\n");
-          }
-          msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
-          return MS_FAILURE;
-      }
-
-      msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
-
-      msDrawRasterBuildRasterPath(layer->map, layer, szTilename, szPath);
-      decrypted_path = msStrdup(szPath);
-
-      /* Cancel the time filter that might have been set on ours in case of */
-      /* a inline tileindex */
-      msFreeExpression(&layer->filter);
-      msInitExpression(&layer->filter);
-  }
-  else
-  {
-      msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->data);
-      decrypted_path = msDecryptStringTokens(layer->map, szPath);
-  }
-  
-  GDALAllRegister();
-
-  /* Open the original Dataset */
-
-  msAcquireLock(TLOCK_GDAL);
-  if (decrypted_path) {
-    clinfo->hOrigDS = GDALOpen(decrypted_path, GA_ReadOnly);
-    msFree(decrypted_path);
-  } else
-    clinfo->hOrigDS = NULL;
-
-  msReleaseLock(TLOCK_GDAL);
-
-  if (clinfo->hOrigDS == NULL) {
-    msSetError(MS_IMGERR,
-               "Unable to open GDAL dataset.",
-               "msContourLayerOpen()");
-    return MS_FAILURE;
-  }
-  
-  /* Open the raster source */
-  if (msContourLayerReadRaster(layer, layer->map->extent) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  /* Generate Contour Dataset */
-  if (msContourLayerGenerateContour(layer) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if (clinfo->hDS) {
-    GDALClose(clinfo->hDS);
-    clinfo->hDS = NULL;  
-    free(clinfo->buffer);
-  }
-
-  /* Open our virtual ogr layer */
-  if (clinfo->hOGRDS && (msLayerOpen(&clinfo->ogrLayer) != MS_SUCCESS))
-    return MS_FAILURE;
-  
-  return MS_SUCCESS;
-}
-
-int msContourLayerIsOpen(layerObj *layer)
-{
-  if (layer->layerinfo)
-    return MS_TRUE;
-  return MS_FALSE;
-}
-  
-int msContourLayerClose(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (layer->debug)
-    msDebug("Entering msContourLayerClose().\n");
-
-  if (clinfo) {
-    if (clinfo->hOGRDS)
-      msConnPoolRelease(&clinfo->ogrLayer, clinfo->hOGRDS);
-
-    msLayerClose(&clinfo->ogrLayer);
-    
-    if (clinfo->hDS) {
-      GDALClose(clinfo->hDS);
-      clinfo->hDS = NULL;
-      free(clinfo->buffer);      
-    }
-
-    if (clinfo->hOrigDS) {
-      GDALClose(clinfo->hOrigDS);
-      clinfo->hOrigDS = NULL;      
-    }
-
-    msContourLayerInfoFree(layer);
-
-  }
-  
-  return MS_SUCCESS;
-}
-
-int msContourLayerGetItems(layerObj *layer)
-{
-  const char* elevItem;
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerGetItems()");
-    return MS_FAILURE;
-  }
-
-  layer->numitems = 0;
-  layer->items = (char **) msSmallCalloc(sizeof(char *),2);
-
-  layer->items[layer->numitems++] = msStrdup("ID");
-  elevItem = CSLFetchNameValue(layer->processing,"CONTOUR_ITEM");
-  if (elevItem && strlen(elevItem) > 0) {
-    layer->items[layer->numitems++] = msStrdup(elevItem);
-  }
-
-  return msLayerGetItems(&clinfo->ogrLayer);
-}
-
-int msContourLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  int i;
-  rectObj newRect;
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (layer->debug)
-    msDebug("Entering msContourLayerWhichShapes().\n");
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerWhichShapes()");
-    return MS_FAILURE;
-  }
-
-  if( isQuery )
-  {
-    newRect = layer->map->extent;
-  }
-  else
-  {
-    newRect = rect;
-    /* if necessary, project the searchrect to source coords */
-    if (msProjectionsDiffer( &(layer->map->projection), &(layer->projection)))  {
-      if (msProjectRect(&layer->projection, &layer->map->projection, &newRect)
-          != MS_SUCCESS ) {
-        msDebug("msContourLayerWhichShapes(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name);
-        return MS_FAILURE;
-      }
-    }
-  }
-
-  /* regenerate the raster io */
-  if (clinfo->hOGRDS)
-    msConnPoolRelease(&clinfo->ogrLayer, clinfo->hOGRDS);
-  
-  msLayerClose(&clinfo->ogrLayer);
-  
-  /* Open the raster source */
-  if (msContourLayerReadRaster(layer, newRect) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  /* Generate Contour Dataset */
-  if (msContourLayerGenerateContour(layer) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if (clinfo->hDS) {
-    GDALClose(clinfo->hDS);
-    clinfo->hDS = NULL;
-    free(clinfo->buffer);
-  }
-  
-  if (!clinfo->hOGRDS) /* no overlap */
-    return MS_DONE;
-  
-  /* Open our virtual ogr layer */
-  if (msLayerOpen(&clinfo->ogrLayer) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  clinfo->ogrLayer.numitems = layer->numitems;
-  clinfo->ogrLayer.items = (char **) msSmallMalloc(sizeof(char *)*layer->numitems);
-  for (i=0; i<layer->numitems;++i) {
-    clinfo->ogrLayer.items[i] = msStrdup(layer->items[i]);
-  }
-
-  return msLayerWhichShapes(&clinfo->ogrLayer, rect, isQuery);
-}
-
-int msContourLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (layer->debug)
-    msDebug("Entering msContourLayerGetShape().\n");
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  return msLayerGetShape(&clinfo->ogrLayer, shape, record);
-}
-
-int msContourLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (layer->debug)
-    msDebug("Entering msContourLayerNextShape().\n");
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerNextShape()");
-    return MS_FAILURE;
-  }
-
-  return msLayerNextShape(&clinfo->ogrLayer, shape);
-}
-
-/************************************************************************/
-/*                       msContourLayerGetExtent()                     */
-/* Simple copy of the maprasterquery.c file. might change in the future */
-/************************************************************************/
-
-int msContourLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
-
-  if (layer->debug)
-    msDebug("Entering msContourLayerGetExtent().\n");
-
-  if (clinfo == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
-               "msContourLayerGetExtent()");
-    return MS_FAILURE;
-  }
-
-  MS_COPYRECT(extent, &clinfo->extent);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                     msContourLayerSetTimeFilter()                    */
-/*                                                                      */
-/*      This function is actually just used in the context of           */
-/*      setting a filter on the tileindex for time based queries.       */
-/*      For instance via WMS requests.                                  */
-/*                                                                      */
-/*      If a local shapefile tileindex is in use, we will set a         */
-/*      backtics filter (shapefile compatible).  If another layer is    */
-/*      being used as the tileindex then we will forward the            */
-/*      SetTimeFilter call to it.  If there is no tileindex in          */
-/*      place, we do nothing.                                           */
-/************************************************************************/
-
-int msContourLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                               const char *timefield)
-{
-  int tilelayerindex;
-
-  if (layer->debug)
-    msDebug("msContourLayerSetTimeFilter(%s,%s).\n", timestring, timefield);
-
-  /* -------------------------------------------------------------------- */
-  /*      If we don't have a tileindex the time filter has no effect.     */
-  /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL )
-  {
-      if (layer->debug)
-          msDebug("msContourLayerSetTimeFilter(): time filter without effect on layers without tileindex.\n");
-      return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Find the tileindex layer.                                       */
-  /* -------------------------------------------------------------------- */
-  tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
-
-  /* -------------------------------------------------------------------- */
-  /*      If we are using a local shapefile as our tileindex (that is     */
-  /*      to say, the tileindex name is not of another layer), then we    */
-  /*      just install a backtics style filter on the current layer.      */
-  /* -------------------------------------------------------------------- */
-  if( tilelayerindex == -1 )
-    return msLayerMakeBackticsTimeFilter( layer, timestring, timefield );
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
-  /*      method.                                                         */
-  /* -------------------------------------------------------------------- */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-  return msLayerSetTimeFilter( layer->GET_LAYER(map,tilelayerindex),
-                               timestring, timefield );
-}
-
-/************************************************************************/
-/*                msRASTERLayerInitializeVirtualTable()                 */
-/************************************************************************/
-
-int msContourLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerInitItemInfo = msContourLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msContourLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msContourLayerOpen;
-  layer->vtable->LayerIsOpen = msContourLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msContourLayerWhichShapes;
-  layer->vtable->LayerNextShape = msContourLayerNextShape;
-  layer->vtable->LayerGetShape = msContourLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msContourLayerClose;
-  layer->vtable->LayerGetItems = msContourLayerGetItems;
-  layer->vtable->LayerGetExtent = msContourLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /*layer->vtable->LayerCloseConnection = msContourLayerClose;*/
-  /* we use backtics for proper tileindex shapefile functioning */
-  layer->vtable->LayerSetTimeFilter = msContourLayerSetTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapcopy.c 8.2.0~beta1-1~exp1/mapcopy.c
--- 8.0.1-5/mapcopy.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcopy.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1321 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project: MapServer
- * Purpose: Functions to allow copying/cloning of maps
- * Author:  Sean Gillies, sgillies@frii.com
- *
- * Notes:
- * These functions are not in mapfile.c because that file is
- * cumbersome enough as it is.  There is agreement that this code and
- * that in mapfile.c should eventually be split up by object into
- * mapobj.c, layerobj.c, etc.  Or something like that.
- *
- * Unit tests are written in Python using PyUnit and are in
- * mapscript/python/tests/testCopyMap.py.  The tests can be
- * executed from the python directory as
- *
- *   python2 tests/testCopyMap.py
- *
- * I just find Python to be very handy for unit testing, that's all.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <assert.h>
-#include "mapserver.h"
-#include "mapsymbol.h"
-
-#include "mapcopy.h"
-
-/***********************************************************************
- * msCopyProjectioExtended()                                           *
- *                                                                     *
- * Copy a projectionObj while adding additional arguments              *
- **********************************************************************/
-
-int msCopyProjectionExtended(projectionObj *dst, const projectionObj *src, char ** args, int num_args)
-{
-  MS_COPYSTELEM(numargs);
-  MS_COPYSTELEM(gt);
-  MS_COPYSTELEM(automatic);
-
-  for (int i = 0; i < dst->numargs; i++) {
-    /* Our destination consists of unallocated pointers */
-    dst->args[i] = msStrdup(src->args[i]);
-  }
-  if( args )
-  {
-      for(int i=0 ; i< num_args; i++) {
-        dst->args[dst->numargs++] = msStrdup(args[i]);
-      }
-  }
-  msProjectionInheritContextFrom(dst, src);
-  if (dst->numargs != 0) {
-    if (msProcessProjection(dst) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-  MS_COPYSTELEM(wellknownprojection);
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyProjection()                                                  *
- *                                                                     *
- * Copy a projectionObj                                                *
- **********************************************************************/
-
-int msCopyProjection(projectionObj *dst, const projectionObj *src)
-{
-  return msCopyProjectionExtended(dst,src,NULL,0);
-}
-
-/***********************************************************************
- * msCopyLine()                                                        *
- *                                                                     *
- * Copy a lineObj, using msCopyPoint()                                 *
- **********************************************************************/
-int msCopyLine(lineObj *dst, const lineObj *src)
-{
-
-  int i;
-
-  dst->numpoints = src->numpoints;
-  for (i = 0; i < dst->numpoints; i++) {
-    MS_COPYPOINT(&(dst->point[i]), &(src->point[i]));
-  }
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyShape()                                                       *
- *                                                                     *
- * Copy a shapeObj, using msCopyLine(), msCopyRect()                   *
- * Not completely implemented or tested.                               *
- **********************************************************************/
-/*
-int msCopyShapeObj(shapeObj *dst, shapeObj *src) {
-  int i;
-  copyProperty(&(dst->numlines), &(src->numlines), sizeof(int));
-  for (i = 0; i < dst->numlines; i++) {
-    msCopyLine(&(dst->line[i]), &(src->line[i]));
-  }
-  msCopyRect(&(dst->bounds), &(src->bounds));
-  copyProperty(&(dst->type), &(src->type), sizeof(int));
-  copyProperty(&(dst->index), &(src->index), sizeof(long));
-  copyProperty(&(dst->tileindex), &(src->tileindex), sizeof(int));
-  copyProperty(&(dst->classindex), &(src->classindex), sizeof(int));
-  copyStringPropertyRealloc(&(dst->text), src->text);
-  copyProperty(&(dst->numvalues), &(src->numvalues), sizeof(int));
-  for (i = 0; i < dst->numvalues; i++) {
-    copyStringPropertyRealloc(&(dst->values[i]), src->values[i]);
-  }
-
-  return(0);
-}
-*/
-
-/**********************************************************************
- * msCopyItem()                                                        *
- *                                                                     *
- * Copy an itemObj                                                     *
- **********************************************************************/
-
-int msCopyItem(itemObj *dst, const itemObj *src)
-{
-
-  MS_COPYSTRING(dst->name, src->name);
-  MS_COPYSTELEM(type);
-  MS_COPYSTELEM(index);
-  MS_COPYSTELEM(size);
-  MS_COPYSTELEM(numdecimals);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyHashTable()                                                   *
- *                                                                     *
- * Copy a hashTableObj, using msInsertHashTable()                      *
- **********************************************************************/
-
-int msCopyHashTable(hashTableObj *dst, const hashTableObj *src)
-{
-  const char *key=NULL;
-  while (1) {
-    key = msNextKeyFromHashTable(src, key);
-    if (!key)
-      break;
-    else
-      msInsertHashTable(dst, key, msLookupHashTable(src, key));
-  }
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyFontSet()                                                     *
- *                                                                     *
- * Copy a fontSetObj, using msCreateHashTable() and msCopyHashTable()  *
- **********************************************************************/
-
-int msCopyFontSet(fontSetObj *dst, const fontSetObj *src, mapObj *map)
-{
-
-  MS_COPYSTRING(dst->filename, src->filename);
-  MS_COPYSTELEM(numfonts);
-  if (&(src->fonts)) {
-    /* if (!dst->fonts) */
-    /* dst->fonts = msCreateHashTable(); */
-    if (msCopyHashTable(&(dst->fonts), &(src->fonts)) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-
-  dst->map = map;
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyExpression()                                                  *
- *                                                                     *
- * Copy an expressionObj, but only its string, type and flags          *
- **********************************************************************/
-
-int msCopyExpression(expressionObj *dst, const expressionObj *src)
-{
-  if((dst->type == MS_REGEX) && dst->compiled) ms_regfree(&(dst->regex));
-  dst->compiled = MS_FALSE;
-
-  MS_COPYSTRING(dst->string, src->string);
-  MS_COPYSTELEM(type);
-  MS_COPYSTELEM(flags);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyJoin()                                                        *
- *                                                                     *
- * Copy a joinObj                                                      *
- **********************************************************************/
-
-int msCopyJoin(joinObj *dst, const joinObj *src)
-{
-  MS_COPYSTRING(dst->name, src->name);
-
-  /* makes no sense to copy the items or values
-     since they are runtime additions to the mapfile */
-
-  MS_COPYSTRING(dst->table, src->table);
-  MS_COPYSTRING(dst->from, src->from);
-  MS_COPYSTRING(dst->to, src->to);
-  MS_COPYSTRING(dst->header, src->header);
-#ifndef __cplusplus
-  MS_COPYSTRING(dst->template, src->template);
-#else
-  MS_COPYSTRING(dst->_template, src->_template);
-#endif
-  MS_COPYSTRING(dst->footer, src->footer);
-  dst->type = src->type;
-  MS_COPYSTRING(dst->connection, src->connection);
-
-  MS_COPYSTELEM(connectiontype);
-
-  /* TODO: need to handle joininfo (probably should be just set to NULL) */
-  dst->joininfo = NULL;
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyQueryMap()                                                    *
- *                                                                     *
- * Copy a queryMapObj, using msCopyColor()                             *
- **********************************************************************/
-
-int msCopyQueryMap(queryMapObj *dst, const queryMapObj *src)
-{
-  MS_COPYSTELEM(height);
-  MS_COPYSTELEM(width);
-  MS_COPYSTELEM(status);
-  MS_COPYSTELEM(style);
-  MS_COPYCOLOR(&(dst->color), &(src->color));
-
-  return MS_SUCCESS;
-}
-
-
-/***********************************************************************
- * msCopyLeader()                                                      *
- *                                                                     *
- * Copy a labelLeaderObj, using msCopyStyle()                          *
- **********************************************************************/
-
-int msCopyLabelLeader(labelLeaderObj *dst, const labelLeaderObj *src)
-{
-  int i;
-  assert(dst && src);
-  MS_COPYSTELEM(gridstep);
-  MS_COPYSTELEM(maxdistance);
-  /*
-   ** now the styles
-   */
-
-  /* free any previous styles on the dst label */
-  for(i=0; i<dst->numstyles; i++) { /* each style */
-    if (dst->styles[i]!=NULL) {
-      if( freeStyle(dst->styles[i]) == MS_SUCCESS ) msFree(dst->styles[i]);
-    }
-  }
-  dst->numstyles = 0;
-
-  for (i = 0; i < src->numstyles; i++) {
-    if (msGrowLeaderStyles(dst) == NULL)
-      return MS_FAILURE;
-    if (initStyle(dst->styles[i]) != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to init style.", "msCopyLabel()");
-      return MS_FAILURE;
-    }
-    if (msCopyStyle(dst->styles[i], src->styles[i]) != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to copy style.", "msCopyLabel()");
-      return MS_FAILURE;
-    }
-    dst->numstyles++;
-  }
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyLabel()                                                       *
- *                                                                     *
- * Copy a labelObj, using msCopyColor() and msCopyStyle()              *
- **********************************************************************/
-
-int msCopyLabel(labelObj *dst, const labelObj *src)
-{
-  int i;
-
-  for(i=0; i<MS_LABEL_BINDING_LENGTH; i++) {
-    MS_COPYSTRING(dst->bindings[i].item, src->bindings[i].item);
-    dst->bindings[i].index = src->bindings[i].index; /* no way to use the macros */
-    MS_COPYSTRING(dst->exprBindings[i].string, src->exprBindings[i].string);
-    dst->exprBindings[i].type = src->exprBindings[i].type;
-  }
-  MS_COPYSTELEM(numbindings);
-  MS_COPYSTELEM(nexprbindings);
-
-  MS_COPYSTRING(dst->font, src->font);
-
-  MS_COPYCOLOR(&(dst->color), &(src->color));
-  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
-  MS_COPYCOLOR(&(dst->shadowcolor), &(src->shadowcolor));
-
-  MS_COPYSTELEM(shadowsizex);
-  MS_COPYSTELEM(shadowsizey);
-
-  MS_COPYSTELEM(size);
-  MS_COPYSTELEM(minsize);
-  MS_COPYSTELEM(maxsize);
-  MS_COPYSTELEM(position);
-  MS_COPYSTELEM(offsetx);
-  MS_COPYSTELEM(offsety);
-  MS_COPYSTELEM(angle);
-  MS_COPYSTELEM(anglemode);
-  MS_COPYSTELEM(buffer);
-  MS_COPYSTELEM(wrap);
-  MS_COPYSTELEM(align);
-  MS_COPYSTELEM(maxlength);
-  MS_COPYSTELEM(minfeaturesize);
-
-  MS_COPYSTELEM(minscaledenom);
-  MS_COPYSTELEM(maxscaledenom);
-
-  MS_COPYSTELEM(autominfeaturesize);
-
-  MS_COPYSTELEM(mindistance);
-  MS_COPYSTELEM(partials);
-  MS_COPYSTELEM(force);
-  MS_COPYSTELEM(priority);
-
-  MS_COPYSTELEM(repeatdistance);
-  MS_COPYSTELEM(maxoverlapangle);
-
-
-  MS_COPYSTRING(dst->encoding, src->encoding);
-
-  MS_COPYSTELEM(outlinewidth);
-  MS_COPYSTELEM(space_size_10);
-
-  if (msCopyExpression(&(dst->expression), &(src->expression)) != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy expression.", "msCopyLabel()");
-    return MS_FAILURE;
-  }
-
-  if (msCopyExpression(&(dst->text), &(src->text)) != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy text.", "msCopyLabel()");
-    return MS_FAILURE;
-  }
-
-  /*
-  ** now the styles
-  */
-
-  /* free any previous styles on the dst label */
-  for(i=0; i<dst->numstyles; i++) { /* each style */
-    if (dst->styles[i]!=NULL) {
-      if( freeStyle(dst->styles[i]) == MS_SUCCESS ) msFree(dst->styles[i]);
-    }
-  }
-  dst->numstyles = 0;
-
-  for (i = 0; i < src->numstyles; i++) {
-    if (msGrowLabelStyles(dst) == NULL)
-      return MS_FAILURE;
-    if (initStyle(dst->styles[i]) != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to init style.", "msCopyLabel()");
-      return MS_FAILURE;
-    }
-    if (msCopyStyle(dst->styles[i], src->styles[i]) != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to copy style.", "msCopyLabel()");
-      return MS_FAILURE;
-    }
-    dst->numstyles++;
-  }
-
-  if(src->leader) {
-    dst->leader = msSmallMalloc(sizeof(labelLeaderObj));
-    initLeader(dst->leader);
-    msCopyLabelLeader(dst->leader,src->leader);
-  } else {
-    if(dst->leader) {
-      freeLabelLeader(dst->leader);
-      msFree(dst->leader);
-    }
-    dst->leader = NULL;
-  }
-
-  MS_COPYSTELEM(sizeunits);
-  MS_COPYSTELEM(scalefactor);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyWeb()                                                         *
- *                                                                     *
- * Copy webObj, using msCopyRect(), msCreateHashTable(), and           *
- * msCopyHashTable()                                                   *
- **********************************************************************/
-
-int msCopyWeb(webObj *dst, const webObj *src, mapObj *map)
-{
-
-  MS_COPYSTRING(dst->imagepath, src->imagepath);
-  MS_COPYSTRING(dst->imageurl, src->imageurl);
-  dst->map = map;
-#ifndef __cplusplus
-  MS_COPYSTRING(dst->template, src->template);
-#else
-  MS_COPYSTRING(dst->_template, src->_template);
-#endif
-  MS_COPYSTRING(dst->header, src->header);
-  MS_COPYSTRING(dst->footer, src->footer);
-  MS_COPYSTRING(dst->empty, src->empty);
-  MS_COPYSTRING(dst->error, src->error);
-
-  MS_COPYSTELEM(minscaledenom);
-  MS_COPYSTELEM(maxscaledenom);
-  MS_COPYSTRING(dst->mintemplate, src->mintemplate);
-  MS_COPYSTRING(dst->maxtemplate, src->maxtemplate);
-
-  if (&(src->metadata)) {
-    /* dst->metadata = msCreateHashTable(); */
-    if (msCopyHashTable(&(dst->metadata), &(src->metadata)) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-  msCopyHashTable(&dst->validation,&src->validation);
-
-  MS_COPYSTRING(dst->queryformat, src->queryformat);
-  MS_COPYSTRING(dst->legendformat, src->legendformat);
-  MS_COPYSTRING(dst->browseformat, src->browseformat);
-
-  return MS_SUCCESS ;
-}
-
-/***********************************************************************
- * msCopyStyle()                                                       *
- *                                                                     *
- * Copy a styleObj, using msCopyColor()                                *
- **********************************************************************/
-
-int msCopyStyle(styleObj *dst, const styleObj *src)
-{
-  int i;
-
-  for(i=0; i<MS_STYLE_BINDING_LENGTH; i++) {
-    MS_COPYSTRING(dst->bindings[i].item, src->bindings[i].item);
-    dst->bindings[i].index = src->bindings[i].index; /* no way to use the macros */
-    MS_COPYSTRING(dst->exprBindings[i].string, src->exprBindings[i].string);
-    dst->exprBindings[i].type = src->exprBindings[i].type;
-  }
-  MS_COPYSTELEM(numbindings);
-  MS_COPYSTELEM(nexprbindings);
-
-  MS_COPYCOLOR(&(dst->color), &(src->color));
-  MS_COPYCOLOR(&(dst->outlinecolor),&(src->outlinecolor));
-
-  MS_COPYCOLOR(&(dst->mincolor), &(src->mincolor));
-  MS_COPYCOLOR(&(dst->maxcolor), &(src->maxcolor));
-
-  MS_COPYSTRING(dst->symbolname, src->symbolname);
-  MS_COPYSTELEM(patternlength);
-  for(i=0; i<src->patternlength; i++)
-    dst->pattern[i]=src->pattern[i];
-  MS_COPYSTELEM(initialgap);
-  MS_COPYSTELEM(gap);
-  MS_COPYSTELEM(linejoin);
-  MS_COPYSTELEM(linejoinmaxsize);
-  MS_COPYSTELEM(antialiased);
-  MS_COPYSTELEM(linecap);
-  MS_COPYSTELEM(symbol);
-  MS_COPYSTELEM(size);
-  MS_COPYSTELEM(minsize);
-  MS_COPYSTELEM(maxsize);
-  MS_COPYSTELEM(width);
-  MS_COPYSTELEM(minwidth);
-  MS_COPYSTELEM(maxwidth);
-  MS_COPYSTELEM(offsetx);
-  MS_COPYSTELEM(offsety);
-  MS_COPYSTELEM(angle);
-  MS_COPYSTELEM(autoangle);
-  MS_COPYSTELEM(minvalue);
-  MS_COPYSTELEM(maxvalue);
-  MS_COPYSTELEM(opacity);
-  MS_COPYSTRING(dst->_geomtransform.string, src->_geomtransform.string);
-  MS_COPYSTELEM(_geomtransform.type);
-  MS_COPYSTRING(dst->rangeitem, src->rangeitem);
-  MS_COPYSTELEM(rangeitemindex);
-  MS_COPYSTELEM(outlinewidth);
-  MS_COPYSTELEM(minscaledenom);
-  MS_COPYSTELEM(maxscaledenom);
-  /* TODO: add copy for bindings */
-
-  MS_COPYSTELEM(sizeunits);
-  MS_COPYSTELEM(scalefactor);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyClass()                                                       *
- *                                                                     *
- * Copy a classObj, using msCopyExpression(), msCopyStyle(),           *
- * msCopyLabel(), msCreateHashTable(), msCopyHashTable()               *
- **********************************************************************/
-
-int msCopyClass(classObj *dst, const classObj *src, layerObj *layer_unused)
-{
-  int i, return_value;
-  (void)layer_unused;
-
-  return_value = msCopyExpression(&(dst->expression),&(src->expression));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy expression.", "msCopyClass()");
-    return MS_FAILURE;
-  }
-
-  MS_COPYSTELEM(status);
-  MS_COPYSTELEM(isfallback);
-
-  /* free any previous styles on the dst layer */
-  for(i=0; i<dst->numstyles; i++) { /* each style */
-    if (dst->styles[i]!=NULL) {
-      if( freeStyle(dst->styles[i]) == MS_SUCCESS ) {
-        msFree(dst->styles[i]);
-      }
-    }
-  }
-  dst->numstyles = 0;
-
-  for (i = 0; i < src->numstyles; i++) {
-    if (msGrowClassStyles(dst) == NULL)
-      return MS_FAILURE;
-    if (initStyle(dst->styles[i]) != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to init style.", "msCopyClass()");
-      return MS_FAILURE;
-    }
-    if (msCopyStyle(dst->styles[i], src->styles[i]) != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to copy style.", "msCopyClass()");
-      return MS_FAILURE;
-    }
-
-    dst->numstyles++;
-  }
-
-  for (i=0; i<src->numlabels; i++) {
-    if (msGrowClassLabels(dst) == NULL)
-      return MS_FAILURE;
-    initLabel(dst->labels[i]);
-    if (msCopyLabel(dst->labels[i], src->labels[i]) != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to copy label.", "msCopyClass()");
-      return MS_FAILURE;
-    }
-
-    dst->numlabels++;
-  }
-  MS_COPYSTELEM(numlabels);
-
-  if(src->leader) {
-    if(dst->leader) {
-      freeLabelLeader(dst->leader);
-    }
-    if(!dst->leader) {
-      dst->leader = msSmallMalloc(sizeof(labelLeaderObj));
-      initLeader(dst->leader);
-    }
-    msCopyLabelLeader(dst->leader,src->leader);
-  }
-
-  MS_COPYSTRING(dst->keyimage, src->keyimage);
-  MS_COPYSTRING(dst->name, src->name);
-  MS_COPYSTRING(dst->title, src->title);
-  MS_COPYSTRING(dst->group, src->group);
-
-  if (msCopyExpression(&(dst->text), &(src->text)) != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy text.", "msCopyClass()");
-    return MS_FAILURE;
-  }
-
-#ifndef __cplusplus
-  MS_COPYSTRING(dst->template, src->template);
-#else
-  MS_COPYSTRING(dst->_template, src->_template);
-#endif
-
-  if (&(src->metadata) != NULL) {
-    /* dst->metadata = msCreateHashTable(); */
-    msCopyHashTable(&(dst->metadata), &(src->metadata));
-  }
-  msCopyHashTable(&dst->validation,&src->validation);
-
-  MS_COPYSTELEM(minscaledenom);
-  MS_COPYSTELEM(maxscaledenom);
-  MS_COPYSTELEM(layer);
-  MS_COPYSTELEM(debug);
-
-  MS_COPYSTELEM(sizeunits);
-  MS_COPYSTELEM(scalefactor);
-
-  return MS_SUCCESS;
-}
-
-int msCopyCluster(clusterObj *dst, const clusterObj *src)
-{
-  int return_value;
-
-  MS_COPYSTELEM(maxdistance);
-  MS_COPYSTELEM(buffer);
-  MS_COPYSTRING(dst->region, src->region);
-
-  return_value = msCopyExpression(&(dst->group),&(src->group));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy cluster group.", "msCopyCluster()");
-    return MS_FAILURE;
-  }
-
-  return_value = msCopyExpression(&(dst->filter),&(src->filter));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy cluster filter.", "msCopyCluster()");
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyGrid()                                                        *
- **********************************************************************/
-
-int msCopyGrid(graticuleObj *dst, const graticuleObj *src)
-{
-  MS_COPYSTELEM(dwhichlatitude);
-  MS_COPYSTELEM(dwhichlongitude);
-  MS_COPYSTELEM(dstartlatitude);
-  MS_COPYSTELEM(dstartlongitude);
-  MS_COPYSTELEM(dendlatitude);
-  MS_COPYSTELEM(dendlongitude);
-  MS_COPYSTELEM(dincrementlatitude);
-  MS_COPYSTELEM(dincrementlongitude);
-  MS_COPYSTELEM(minarcs);
-  MS_COPYSTELEM(maxarcs);
-  MS_COPYSTELEM(minincrement);
-  MS_COPYSTELEM(maxincrement);
-  MS_COPYSTELEM(minsubdivides);
-  MS_COPYSTELEM(maxsubdivides);
-  MS_COPYSTELEM(bvertical);
-  MS_COPYSTELEM(blabelaxes);
-  MS_COPYSTELEM(ilabelstate);
-  MS_COPYSTELEM(ilabeltype);
-  MS_COPYRECT(&(dst->extent), &(src->extent));
-  MS_COPYSTRING(dst->labelformat, src->labelformat);
-  
-  return MS_SUCCESS;
-}
-
-#ifdef why_on_earth_would_you_copy_a_labelcache
-
-/***********************************************************************
- * msCopyLabelCacheMember()                                            *
- *                                                                     *
- * Copy a labelCacheMemberObj using msCopyStyle(), msCopyPoint()       *
- *                                                                     *
- * Note: since it seems most users will want to clone maps rather than *
- * make exact copies, this method might not get much use.              *
- **********************************************************************/
-
-int msCopyLabelCacheMember(labelCacheMemberObj *dst, const labelCacheMemberObj *src)
-{
-  int i;
-
-  MS_COPYSTELEM(featuresize);
-
-  MS_COPYSTELEM(numstyles);
-  for (i = 0; i < dst->numstyles; i++) {
-    msCopyStyle(&(dst->styles[i]), &(src->styles[i]));
-  }
-
-  MS_COPYSTELEM(numlabels);
-  dst->labels = (labelObj *) msSmallMalloc(sizeof(labelObj)*dst->numlabels);
-  for (i = 0; i < dst->numlabels; i++) {
-    msCopyLabel(&(dst->labels[i]), &(src->labels[i]));
-  }
-
-  MS_COPYSTELEM(layerindex);
-  MS_COPYSTELEM(classindex);
-  MS_COPYSTELEM(tileindex);
-  MS_COPYSTELEM(shapeindex);
-  MS_COPYPOINT(&(dst->point), &(src->point));
-  /* msCopyShape(&(dst->poly), &(src->poly)); */
-  MS_COPYSTELEM(status);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyMarkerCacheMember()                                           *
- *                                                                     *
- * Copy a markerCacheMemberObj                                         *
- **********************************************************************/
-
-int msCopyMarkerCacheMember(markerCacheMemberObj *dst,
-                            const markerCacheMemberObj *src)
-{
-  MS_COPYSTELEM(id);
-
-  /* msCopyShape(&(dst->poly), &(src->poly)); */
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyLabelCacheSlot()                                                  *
- **********************************************************************/
-
-int msCopyLabelCacheSlot(labelCacheSlotObj *dst, const labelCacheSlotObj *src)
-{
-  int i;
-
-  for (i = 0; i < dst->numlabels; i++) {
-    msCopyLabelCacheMember(&(dst->labels[i]), &(src->labels[i]));
-  }
-  MS_COPYSTELEM(cachesize);
-  MS_COPYSTELEM(nummarkers);
-  for (i = 0; i < dst->nummarkers; i++) {
-    msCopyMarkerCacheMember(&(dst->markers[i]), &(src->markers[i]));
-  }
-  MS_COPYSTELEM(markercachesize);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyLabelCache()                                                  *
- **********************************************************************/
-
-int msCopyLabelCache(labelCacheObj *dst, const labelCacheObj *src)
-{
-  int p;
-  MS_COPYSTELEM(numlabels);
-
-  for (p=0; p<MS_MAX_LABEL_PRIORITY; p++) {
-    msCopyLabelCacheSlot(&(dst->slots[p]), &(src->slots[p]));
-  }
-
-  return MS_SUCCESS;
-}
-
-#endif
-
-/***********************************************************************
- * msCopyResult()                                                      *
- **********************************************************************/
-
-int msCopyResult(resultObj *dst, const resultObj *src)
-{
-  MS_COPYSTELEM(shapeindex);
-  MS_COPYSTELEM(tileindex);
-  MS_COPYSTELEM(classindex);
-  MS_COPYSTELEM(resultindex);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyResultCache()                                                 *
- **********************************************************************/
-
-int msCopyResultCache(resultCacheObj *dst, const resultCacheObj *src)
-{
-  int i;
-  MS_COPYSTELEM(cachesize);
-  MS_COPYSTELEM(numresults);
-  for (i = 0; i < dst->numresults; i++) {
-    msCopyResult(&(dst->results[i]), &(src->results[i]));
-  }
-  MS_COPYRECT(&(dst->bounds), &(src->bounds));
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyReferenceMap()                                                *
- *                                                                     *
- * Copy a referenceMapObj using mapfile.c:initReferenceMap(),          *
- * msCopyRect(), msCopyColor()                                         *
- **********************************************************************/
-
-int msCopyReferenceMap(referenceMapObj *dst, const referenceMapObj *src,
-                       mapObj *map)
-{
-
-  initReferenceMap(dst);
-
-  MS_COPYRECT(&(dst->extent), &(src->extent));
-
-  MS_COPYSTELEM(height);
-  MS_COPYSTELEM(width);
-
-
-  MS_COPYCOLOR(&(dst->color), &(src->color));
-  MS_COPYCOLOR(&(dst->outlinecolor),&(src->outlinecolor));
-  MS_COPYSTRING(dst->image, src->image);
-
-  MS_COPYSTELEM(status);
-  MS_COPYSTELEM(marker);
-  MS_COPYSTRING(dst->markername, src->markername);
-  MS_COPYSTELEM(markersize);
-  MS_COPYSTELEM(minboxsize);
-  MS_COPYSTELEM(maxboxsize);
-  dst->map = map;
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyScalebar()                                                    *
- *                                                                     *
- * Copy a scalebarObj, using initScalebar(), msCopyColor(),            *
- * and msCopyLabel()                                                   *
- **********************************************************************/
-
-int msCopyScalebar(scalebarObj *dst, const scalebarObj *src)
-{
-
-  initScalebar(dst);
-
-  MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
-  MS_COPYSTELEM(height);
-  MS_COPYSTELEM(width);
-  MS_COPYSTELEM(style);
-  MS_COPYSTELEM(intervals);
-
-  if (msCopyLabel(&(dst->label), &(src->label)) != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy label.","msCopyScalebar()");
-    return MS_FAILURE;
-  }
-
-  MS_COPYCOLOR(&(dst->color), &(src->color));
-  MS_COPYCOLOR(&(dst->backgroundcolor), &(src->backgroundcolor));
-
-  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
-
-  MS_COPYSTELEM(units);
-  MS_COPYSTELEM(status);
-  MS_COPYSTELEM(position);
-  MS_COPYSTELEM(transparent);
-  MS_COPYSTELEM(postlabelcache);
-  MS_COPYSTELEM(align);
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyLegend()                                                      *
- *                                                                     *
- * Copy a legendObj, using msCopyColor()                               *
- **********************************************************************/
-
-int msCopyLegend(legendObj *dst, const legendObj *src, mapObj *map)
-{
-  int return_value;
-
-  MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
-
-  return_value = msCopyLabel(&(dst->label), &(src->label));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy label.",
-               "msCopyLegend()");
-    return MS_FAILURE;
-  }
-
-  MS_COPYSTELEM(keysizex);
-  MS_COPYSTELEM(keysizey);
-  MS_COPYSTELEM(keyspacingx);
-  MS_COPYSTELEM(keyspacingy);
-
-  MS_COPYCOLOR(&(dst->outlinecolor),&(src->outlinecolor));
-
-  MS_COPYSTELEM(status);
-  MS_COPYSTELEM(height);
-  MS_COPYSTELEM(width);
-  MS_COPYSTELEM(position);
-  MS_COPYSTELEM(transparent);
-  MS_COPYSTELEM(postlabelcache);
-
-#ifndef __cplusplus
-  MS_COPYSTRING(dst->template, src->template);
-#else
-  MS_COPYSTRING(dst->_template, src->_template);
-#endif
-  dst->map = map;
-
-  return MS_SUCCESS;
-}
-
-int msCopyScaleTokenEntry(const scaleTokenEntryObj *src, scaleTokenEntryObj *dst) {
-  MS_COPYSTRING(dst->value,src->value);
-  MS_COPYSTELEM(minscale);
-  MS_COPYSTELEM(maxscale);
-  return MS_SUCCESS;
-}
-
-int msCopyScaleToken(const scaleTokenObj *src, scaleTokenObj *dst) {
-  int i;
-  MS_COPYSTRING(dst->name,src->name);
-  MS_COPYSTELEM(n_entries);
-  dst->tokens = (scaleTokenEntryObj*)msSmallCalloc(src->n_entries,sizeof(scaleTokenEntryObj));
-  for(i=0;i<src->n_entries;i++) {
-    msCopyScaleTokenEntry(&src->tokens[i],&dst->tokens[i]);
-  }
-  return MS_SUCCESS;
-}
-
-int msCopyCompositingFilter(CompositingFilter **pdst, const CompositingFilter *src) {
-  CompositingFilter *dst = NULL;
-  if(!src) {
-    *pdst = NULL;
-    return MS_SUCCESS;
-  }
-  while(src) {
-    if(!dst) {
-      dst = *pdst = msSmallMalloc(sizeof(CompositingFilter));
-    } else {
-      dst->next = msSmallMalloc(sizeof(CompositingFilter));
-      dst = dst->next;
-    }
-    dst->filter = msStrdup(src->filter);
-    dst->next = NULL;
-    src = src->next;
-  }
-  return MS_SUCCESS;
-}
-
-int msCopyCompositer(LayerCompositer **ldst, const LayerCompositer *src) {
-  LayerCompositer *dst = NULL;
-  if(!src) {
-    *ldst = NULL;
-    return MS_SUCCESS;
-  }
-
-  while(src) {
-    if(!dst) {
-      dst = *ldst = msSmallMalloc(sizeof(LayerCompositer));
-    } else {
-      dst->next = msSmallMalloc(sizeof(LayerCompositer));
-      dst = dst->next;
-    }
-    dst->comp_op = src->comp_op;
-    dst->opacity = src->opacity;
-    dst->next = NULL;
-    msCopyCompositingFilter(&dst->filter, src->filter);
-    src = src->next;
-  }
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyLayer()                                                       *
- *                                                                     *
- * Copy a layerObj, using mapfile.c:initClass(), msCopyClass(),        *
- * msCopyColor(), msCopyProjection(), msShapefileOpen(),                 *
- * msCreateHashTable(), msCopyHashTable(), msCopyExpression()          *
- *                                                                     *
- * As it stands, we are not copying a layer's resultcache              *
- **********************************************************************/
-
-int msCopyLayer(layerObj *dst, const layerObj *src)
-{
-  int i, return_value;
-  featureListNodeObjPtr current;
-
-  MS_COPYSTELEM(index);
-  MS_COPYSTRING(dst->classitem, src->classitem);
-
-  MS_COPYSTELEM(classitemindex);
-
-  for(i = 0; i < src->numscaletokens; i++) {
-    if(msGrowLayerScaletokens(dst) == NULL)
-      return MS_FAILURE;
-    initScaleToken(&dst->scaletokens[i]);
-    msCopyScaleToken(&src->scaletokens[i],&dst->scaletokens[i]);
-    dst->numscaletokens++;
-  }
-
-  for (i = 0; i < src->numclasses; i++) {
-    if (msGrowLayerClasses(dst) == NULL)
-      return MS_FAILURE;
-#ifndef __cplusplus
-    initClass(dst->class[i]);
-    return_value = msCopyClass(dst->class[i], src->class[i], dst);
-#else
-    initClass(dst->_class[i]);
-    return_value = msCopyClass(dst->_class[i], src->_class[i], dst);
-#endif
-    if (return_value != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to copy class.", "msCopyLayer()");
-      return MS_FAILURE;
-    }
-    dst->numclasses++;
-  }
-  MS_COPYSTRING(dst->header, src->header);
-  MS_COPYSTRING(dst->footer, src->footer);
-#ifndef __cplusplus
-  MS_COPYSTRING(dst->template, src->template);
-#else
-  MS_COPYSTRING(dst->_template, src->_template);
-#endif
-
-  MS_COPYSTRING(dst->name, src->name);
-  MS_COPYSTRING(dst->group, src->group);
-  MS_COPYSTRING(dst->data, src->data);
-  MS_COPYSTRING(dst->encoding, src->encoding);
-
-  MS_COPYSTELEM(rendermode);
-  MS_COPYSTELEM(status);
-  MS_COPYSTELEM(type);
-  MS_COPYSTELEM(tolerance);
-  MS_COPYSTELEM(toleranceunits);
-  MS_COPYSTELEM(symbolscaledenom);
-  MS_COPYSTELEM(scalefactor);
-  MS_COPYSTELEM(minscaledenom);
-  MS_COPYSTELEM(maxscaledenom);
-
-  MS_COPYSTELEM(labelminscaledenom);
-  MS_COPYSTELEM(labelmaxscaledenom);
-  MS_COPYSTELEM(mingeowidth);
-  MS_COPYSTELEM(maxgeowidth);
-
-  MS_COPYSTELEM(sizeunits);
-  MS_COPYSTELEM(maxfeatures);
-
-  MS_COPYCOLOR(&(dst->offsite), &(src->offsite));
-
-  MS_COPYSTELEM(transform);
-  MS_COPYSTELEM(labelcache);
-  MS_COPYSTELEM(postlabelcache);
-
-  MS_COPYSTRING(dst->labelitem, src->labelitem);
-  MS_COPYSTELEM(labelitemindex);
-
-  MS_COPYSTRING(dst->tileitem, src->tileitem);
-  MS_COPYSTELEM(tileitemindex);
-
-  MS_COPYSTRING(dst->tilesrs, src->tilesrs);
-
-  MS_COPYSTRING(dst->tileindex, src->tileindex);
-
-  return_value = msCopyProjection(&(dst->projection),&(src->projection));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy projection.", "msCopyLayer()");
-    return MS_FAILURE;
-  }
-
-  return_value = msCopyCluster(&(dst->cluster),&(src->cluster));
-  if (return_value != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-  MS_COPYSTELEM(project);
-  MS_COPYSTELEM(units);
-
-  current = src->features;
-  while(current != NULL) {
-    insertFeatureList(&(dst->features), &(current->shape));
-    current = current->next;
-  }
-
-  MS_COPYSTRING(dst->connection, src->connection);
-  MS_COPYSTELEM(connectiontype);
-
-  MS_COPYSTRING(dst->plugin_library, src->plugin_library);
-  MS_COPYSTRING(dst->plugin_library_original, src->plugin_library_original);
-
-  /* Do not copy *layerinfo, items, or iteminfo. these are all initialized
-     when the copied layer is opened */
-
-  return_value = msCopyExpression(&(dst->filter), &(src->filter));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy filter.", "msCopyLayer()");
-    return MS_FAILURE;
-  }
-
-  MS_COPYSTRING(dst->filteritem, src->filteritem);
-  MS_COPYSTELEM(filteritemindex);
-
-  MS_COPYSTRING(dst->styleitem, src->styleitem);
-  MS_COPYSTELEM(styleitemindex);
-
-  MS_COPYSTRING(dst->requires, src->requires);
-  MS_COPYSTRING(dst->labelrequires, src->labelrequires);
-
-  if (&(src->metadata)) {
-    msCopyHashTable(&(dst->metadata), &(src->metadata));
-  }
-  msCopyHashTable(&dst->validation,&src->validation);
-  msCopyHashTable(&dst->connectionoptions,&src->connectionoptions);
-
-  MS_COPYSTELEM(debug);
-
-  /* No need to copy the numprocessing member, as it is incremented by
-     msLayerAddProcessing */
-  for (i = 0; i < src->numprocessing; i++) {
-    msLayerAddProcessing(dst, msLayerGetProcessing(src, i));
-  }
-
-  MS_COPYSTELEM(numjoins);
-
-  for (i = 0; i < dst->numjoins; i++) {
-    initJoin(&(dst->joins[i]));
-    return_value = msCopyJoin(&(dst->joins[i]), &(src->joins[i]));
-    if (return_value != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-
-  MS_COPYRECT(&(dst->extent), &(src->extent));
-
-  MS_COPYSTRING(dst->classgroup, src->classgroup);
-  MS_COPYSTRING(dst->mask, src->mask);
-
-  if (src->grid) {
-    if (dst->grid) {
-      freeGrid(dst->grid);
-      msFree(dst->grid);
-    }
-    dst->grid = (void *) malloc(sizeof(graticuleObj));
-    MS_CHECK_ALLOC(dst->grid, sizeof(graticuleObj), -1);
-    initGrid(dst->grid);
-    msCopyGrid(dst->grid, src->grid);
-  }
-
-  if(src->compositer) {
-    msCopyCompositer(&dst->compositer, src->compositer);
-  }
-
-  return MS_SUCCESS;
-}
-
-/***********************************************************************
- * msCopyMap()                                                         *
- *                                                                     *
- * Copy a mapObj, using mapfile.c:initLayer(), msCopyLayer(),          *
-
- * msCopyLegend(), msCopyScalebar(), msCopyProjection()                *
- * msCopyOutputFormat(), msCopyWeb(), msCopyReferenceMap()             *
- **********************************************************************/
-
-int msCopyMap(mapObj *dst, const mapObj *src)
-{
-  int i, return_value;
-  outputFormatObj *format;
-
-  MS_COPYSTRING(dst->name, src->name);
-  MS_COPYSTELEM(status);
-  MS_COPYSTELEM(height);
-  MS_COPYSTELEM(width);
-  MS_COPYSTELEM(maxsize);
-
-  for (i = 0; i < src->numlayers; i++) {
-    if (msGrowMapLayers(dst) == NULL)
-      return MS_FAILURE;
-    initLayer((GET_LAYER(dst, i)), dst);
-
-    return_value = msCopyLayer((GET_LAYER(dst, i)), (GET_LAYER(src, i)));
-    if (return_value != MS_SUCCESS) {
-      msSetError(MS_MEMERR, "Failed to copy layer.", "msCopyMap()");
-      return MS_FAILURE;
-    }
-    dst->numlayers++;
-  }
-
-  return_value = msCopyFontSet(&(dst->fontset), &(src->fontset), dst);
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy fontset.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  return_value = msCopySymbolSet(&(dst->symbolset), &(src->symbolset), dst);
-  if(return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy symbolset.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  /* msCopyLabelCache(&(dst->labelcache), &(src->labelcache)); */
-  MS_COPYRECT(&(dst->extent), &(src->extent));
-
-  MS_COPYSTELEM(cellsize);
-  MS_COPYSTELEM(units);
-  MS_COPYSTELEM(scaledenom);
-  MS_COPYSTELEM(defresolution);
-  MS_COPYSTELEM(resolution);
-  MS_COPYSTRING(dst->shapepath, src->shapepath);
-  MS_COPYSTRING(dst->mappath, src->mappath);
-  MS_COPYSTELEM(sldurl);
-
-  MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
-
-  /* clear existing destination format list */
-  if( dst->outputformat && --dst->outputformat->refcount < 1 ) {
-    msFreeOutputFormat( dst->outputformat );
-    dst->outputformat = NULL;
-  }
-
-  for(i=0; i < dst->numoutputformats; i++ ) {
-    if( --dst->outputformatlist[i]->refcount < 1 )
-      msFreeOutputFormat( dst->outputformatlist[i] );
-  }
-  if( dst->outputformatlist != NULL )
-    msFree( dst->outputformatlist );
-  dst->outputformatlist = NULL;
-  dst->outputformat = NULL;
-  dst->numoutputformats = 0;
-
-  for (i = 0; i < src->numoutputformats; i++)
-    msAppendOutputFormat( dst,
-                          msCloneOutputFormat( src->outputformatlist[i]) );
-
-  /* set the active output format */
-  MS_COPYSTRING(dst->imagetype, src->imagetype);
-  format = msSelectOutputFormat( dst, dst->imagetype );
-  msApplyOutputFormat(&(dst->outputformat), format, MS_NOOVERRIDE);
-
-  return_value = msCopyProjection(&(dst->projection),&(src->projection));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy projection.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  /* No need to copy latlon projection */
-
-  return_value = msCopyReferenceMap(&(dst->reference),&(src->reference),
-                                    dst);
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy reference.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  return_value = msCopyScalebar(&(dst->scalebar), &(src->scalebar));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy scalebar.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  return_value = msCopyLegend(&(dst->legend), &(src->legend),dst);
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy legend.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  return_value = msCopyQueryMap(&(dst->querymap), &(src->querymap));
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy querymap.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  return_value = msCopyWeb(&(dst->web), &(src->web), dst);
-  if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy web.", "msCopyMap()");
-    return MS_FAILURE;
-  }
-
-  if( src->layerorder ) {
-    for (i = 0; i < dst->numlayers; i++) {
-        MS_COPYSTELEM(layerorder[i]);
-    }
-  }
-  MS_COPYSTELEM(debug);
-  MS_COPYSTRING(dst->datapattern, src->datapattern);
-  MS_COPYSTRING(dst->templatepattern, src->templatepattern);
-
-  if( msCopyHashTable( &(dst->configoptions), &(src->configoptions) ) != MS_SUCCESS )
-    return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-int msCopyRasterBuffer(rasterBufferObj *dst, const rasterBufferObj *src) {
-  *dst = *src;
-  if(src->type == MS_BUFFER_BYTE_RGBA) {
-    dst->data.rgba = src->data.rgba;
-    dst->data.rgba.pixels = msSmallMalloc(src->height * src->data.rgba.row_step);
-    memcpy(dst->data.rgba.pixels, src->data.rgba.pixels, src->data.rgba.row_step*src->height);
-    dst->data.rgba.r = dst->data.rgba.pixels + (src->data.rgba.r - src->data.rgba.pixels);
-    dst->data.rgba.g = dst->data.rgba.pixels + (src->data.rgba.g - src->data.rgba.pixels);
-    dst->data.rgba.b = dst->data.rgba.pixels + (src->data.rgba.b - src->data.rgba.pixels);
-    if(src->data.rgba.a) {
-      dst->data.rgba.a = dst->data.rgba.pixels + (src->data.rgba.a - src->data.rgba.pixels);
-    } else {
-      dst->data.rgba.a = NULL;
-    }
-  }
-  return MS_SUCCESS;
-}
-
diff -pruN 8.0.1-5/mapcopy.h 8.2.0~beta1-1~exp1/mapcopy.h
--- 8.0.1-5/mapcopy.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcopy.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,73 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Declarations related to copyng mapObjs.  Provided by Mladen Turk
- *           for resolution of bug 701
- *           http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=701.
- * Author:   Mladen Turk (and Sean Gilles?)
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/* Following works for GCC and MSVC.  That's ~98% of our users, if Tyler
- * Mitchell's survey is correct
- */
-#define MS_COPYSTELEM(_name) (dst)->/**/_name = (src)->/**/_name
-
-#define MS_MACROBEGIN              do {
-#define MS_MACROEND                } while (0)
-
-#define MS_COPYRECT(_dst, _src)       \
-    MS_MACROBEGIN                     \
-        (_dst)->minx = (_src)->minx;  \
-        (_dst)->miny = (_src)->miny;  \
-        (_dst)->maxx = (_src)->maxx;  \
-        (_dst)->maxy = (_src)->maxy;  \
-    MS_MACROEND
-
-#define MS_COPYPOINT(_dst, _src)      \
-    MS_MACROBEGIN                     \
-        (_dst)->x = (_src)->x;        \
-        (_dst)->y = (_src)->y;        \
-        (_dst)->m = (_src)->m;        \
-    MS_MACROEND
-
-#define MS_COPYCOLOR(_dst, _src)      \
-    MS_MACROBEGIN                     \
-        (_dst)->red   = (_src)->red;  \
-        (_dst)->green = (_src)->green;\
-        (_dst)->blue  = (_src)->blue; \
-        (_dst)->alpha  = (_src)->alpha; \
-    MS_MACROEND
-
-#define MS_COPYSTRING(_dst, _src)     \
-    MS_MACROBEGIN                     \
-        if ((_dst) != NULL)           \
-            msFree((_dst));           \
-        if ((_src))                   \
-            (_dst) = msStrdup((_src));  \
-        else                          \
-            (_dst) = NULL;            \
-    MS_MACROEND
-
-
diff -pruN 8.0.1-5/mapcpl.c 8.2.0~beta1-1~exp1/mapcpl.c
--- 8.0.1-5/mapcpl.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcpl.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,264 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Functions copied from GDAL's CPL. This file contain utility
- *           functions that come from the GDAL/OGR cpl library. The idea
- *           behind it is to have access in mapserver to all these
- *           utilities, without being constrained to link with GDAL/OGR.
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- *
- * Note:
- * Names of functions used here are the same as those in the cpl
- * library with the exception the the CPL prefix is changed to ms
- * (eg : CPLGetBasename() would become msGetBasename())
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/* $Id$ */
-
-#include <assert.h>
-#include "mapserver.h"
-
-
-
-/* should be size of largest possible filename */
-#define MS_PATH_BUF_SIZE 2048
-static char     szStaticResult[MS_PATH_BUF_SIZE];
-
-
-/************************************************************************/
-/*                        msFindFilenameStart()                         */
-/************************************************************************/
-
-static int msFindFilenameStart( const char * pszFilename )
-
-{
-  int         iFileStart;
-
-  for( iFileStart = strlen(pszFilename);
-       iFileStart > 0
-       && pszFilename[iFileStart-1] != '/'
-       && pszFilename[iFileStart-1] != '\\';
-       iFileStart-- ) {}
-
-  return iFileStart;
-}
-
-/************************************************************************/
-/*                           msGetBasename()                            */
-/************************************************************************/
-
-/**
- * Extract basename (non-directory, non-extension) portion of filename.
- *
- * Returns a string containing the file basename portion of the passed
- * name.  If there is no basename (passed value ends in trailing directory
- * separator, or filename starts with a dot) an empty string is returned.
- *
- * <pre>
- * msGetBasename( "abc/def.xyz" ) == "def"
- * msGetBasename( "abc/def" ) == "def"
- * msGetBasename( "abc/def/" ) == ""
- * </pre>
- *
- * @param pszFullFilename the full filename potentially including a path.
- *
- * @return just the non-directory, non-extension portion of the path in
- * an internal string which must not be freed.  The string
- * may be destroyed by the next ms filename handling call.
- */
-
-const char *msGetBasename( const char *pszFullFilename )
-
-{
-  int iFileStart = msFindFilenameStart( pszFullFilename );
-  int iExtStart, nLength;
-
-  for( iExtStart = strlen(pszFullFilename);
-       iExtStart > iFileStart && pszFullFilename[iExtStart] != '.';
-       iExtStart-- ) {}
-
-  if( iExtStart == iFileStart )
-    iExtStart = strlen(pszFullFilename);
-
-  nLength = iExtStart - iFileStart;
-
-  assert( nLength < MS_PATH_BUF_SIZE );
-
-  strlcpy( szStaticResult, pszFullFilename + iFileStart, nLength+1 );
-
-  return szStaticResult;
-}
-
-/* Id: GDAL/port/cplgetsymbol.cpp,v 1.14 2004/11/11 20:40:38 fwarmerdam Exp */
-/* ==================================================================== */
-/*                  Unix Implementation                                 */
-/* ==================================================================== */
-#if defined(HAVE_DLFCN_H)
-
-#define GOT_GETSYMBOL
-
-#include <dlfcn.h>
-
-/************************************************************************/
-/*                            msGetSymbol()                            */
-/************************************************************************/
-
-/**
- * Fetch a function pointer from a shared library / DLL.
- *
- * This function is meant to abstract access to shared libraries and
- * DLLs and performs functions similar to dlopen()/dlsym() on Unix and
- * LoadLibrary() / GetProcAddress() on Windows.
- *
- * If no support for loading entry points from a shared library is available
- * this function will always return NULL.   Rules on when this function
- * issues a msError() or not are not currently well defined, and will have
- * to be resolved in the future.
- *
- * Currently msGetSymbol() doesn't try to:
- * <ul>
- *  <li> prevent the reference count on the library from going up
- *    for every request, or given any opportunity to unload
- *    the library.
- *  <li> Attempt to look for the library in non-standard
- *    locations.
- *  <li> Attempt to try variations on the symbol name, like
- *    pre-prending or post-pending an underscore.
- * </ul>
- *
- * Some of these issues may be worked on in the future.
- *
- * @param pszLibrary the name of the shared library or DLL containing
- * the function.  May contain path to file.  If not system supplies search
- * paths will be used.
- * @param pszSymbolName the name of the function to fetch a pointer to.
- * @return A pointer to the function if found, or NULL if the function isn't
- * found, or the shared library can't be loaded.
- */
-
-void *msGetSymbol( const char * pszLibrary, const char * pszSymbolName )
-{
-  void        *pLibrary;
-  void        *pSymbol;
-
-  pLibrary = dlopen(pszLibrary, RTLD_LAZY);
-  if( pLibrary == NULL ) {
-    msSetError(MS_MISCERR,
-               "Dynamic loading failed: %s",
-               "msGetSymbol()", dlerror());
-    return NULL;
-  }
-
-  pSymbol = dlsym( pLibrary, pszSymbolName );
-
-#if (defined(__APPLE__) && defined(__MACH__))
-  /* On mach-o systems, C symbols have a leading underscore and depending
-   * on how dlcompat is configured it may or may not add the leading
-   * underscore.  So if dlsym() fails add an underscore and try again.
-   */
-  if( pSymbol == NULL ) {
-    char withUnder[strlen(pszSymbolName) + 2];
-    withUnder[0] = '_';
-    withUnder[1] = 0;
-    strcat(withUnder, pszSymbolName);
-    pSymbol = dlsym( pLibrary, withUnder );
-  }
-#endif
-
-  if( pSymbol == NULL ) {
-    msSetError(MS_MISCERR,
-               "Dynamic loading failed: %s",
-               "msGetSymbol()", dlerror());
-    return NULL;
-  }
-
-  /* We accept leakage of pLibrary */
-  /* coverity[leaked_storage] */
-  return( pSymbol );
-}
-
-#endif /* def __unix__ && defined(HAVE_DLFCN_H) */
-
-/* ==================================================================== */
-/*                 Windows Implementation                               */
-/* ==================================================================== */
-#ifdef WIN32
-
-#define GOT_GETSYMBOL
-
-#include <windows.h>
-
-/************************************************************************/
-/*                            msGetSymbol()                            */
-/************************************************************************/
-
-void *msGetSymbol( const char * pszLibrary, const char * pszSymbolName )
-{
-  void        *pLibrary;
-  void        *pSymbol;
-
-  pLibrary = LoadLibrary(pszLibrary);
-  if( pLibrary == NULL ) {
-    msSetError(MS_MISCERR,
-               "Can't load requested dynamic library: %s",
-               "msGetSymbol()", pszLibrary);
-    return NULL;
-  }
-
-  pSymbol = (void *) GetProcAddress( (HINSTANCE) pLibrary, pszSymbolName );
-
-  if( pSymbol == NULL ) {
-    msSetError(MS_MISCERR,
-               "Can't find requested entry point: %s in lib %s",
-               "msGetSymbol()", pszSymbolName, pLibrary);
-    return NULL;
-  }
-
-  return( pSymbol );
-}
-
-#endif /* def _WIN32 */
-
-/* ==================================================================== */
-/*      Dummy implementation.                                           */
-/* ==================================================================== */
-
-#ifndef GOT_GETSYMBOL
-
-/************************************************************************/
-/*                            msGetSymbol()                            */
-/*                                                                      */
-/*      Dummy implementation.                                           */
-/************************************************************************/
-
-void *msGetSymbol(const char *pszLibrary, const char *pszEntryPoint)
-{
-  msSetError(MS_MISCERR,
-             "msGetSymbol(%s,%s) called.  Failed as this is stub implementation.",
-             "msGetSymbol()", pszLibrary, pszEntryPoint);
-  return NULL;
-}
-#endif
diff -pruN 8.0.1-5/mapcrypto.c 8.2.0~beta1-1~exp1/mapcrypto.c
--- 8.0.1-5/mapcrypto.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapcrypto.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,600 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Encryption functions (see MS-RFC-18)
- * Author:   Daniel Morissette
- *
- ******************************************************************************
- * Copyright (c) 1996-2006 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <assert.h>
-#include <ctype.h>    /* isxdigit() */
-#include <stdlib.h>   /* rand() */
-#include <time.h>     /* time() */
-
-#include "mapserver.h"
-
-#include "cpl_conv.h"
-
-
-/**********************************************************************
- * encipher() and decipher() from the Tiny Encryption Algorithm (TEA)
- * website at:
- *   http://www.simonshepherd.supanet.com/tea.htm
- *
- * TEA was developed and placed in the public domain by David Wheeler
- * and Roger Needham at the Computer Laboratory of Cambridge University.
- *
- * The source below came with the following public domain notice:
- *
- *   "Please feel free to use any of this code in your applications.
- *    The TEA algorithm (including new-variant TEA) has been placed
- *    in the public domain, as have my assembly language implementations."
- *
- * ... and the following usage notes:
- *
- * All the routines have the general form
- *
- *  void encipher(const unsigned long *const v,unsigned long *const w,
- *                const unsigned long * const k);
- *
- *  void decipher(const unsigned long *const v,unsigned long *const w,
- *                const unsigned long * const k);
- *
- * TEA takes 64 bits of data in v[0] and v[1], and 128 bits of key in
- * k[0] - k[3]. The result is returned in w[0] and w[1]. Returning the
- * result separately makes implementation of cipher modes other than
- * Electronic Code Book a little bit easier.
- *
- * TEA can be operated in any of the modes of DES.
- *
- * n is the number of iterations. 32 is ample, 16 is sufficient, as few
- * as eight should be OK for most applications, especially ones where
- * the data age quickly (real-time video, for example). The algorithm
- * achieves good dispersion after six iterations. The iteration count
- * can be made variable if required.
- *
- * Note this algorithm is optimised for 32-bit CPUs with fast shift
- * capabilities. It can very easily be ported to assembly language
- * on most CPUs.
- *
- * delta is chosen to be the Golden ratio ((5/4)1/2 - 1/2 ~ 0.618034)
- * multiplied by 232. On entry to decipher(), sum is set to be delta * n.
- * Which way round you call the functions is arbitrary: DK(EK(P)) = EK(DK(P))
- * where EK and DK are encryption and decryption under key K respectively.
- *
- **********************************************************************/
-
-static void encipher(const ms_uint32 *const v, ms_uint32 *const w,
-                     const ms_uint32 *const k)
-{
-  register ms_uint32   y=v[0],z=v[1],sum=0,delta=0x9E3779B9,n=32;
-
-  while(n-->0) {
-    y += ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum&3]);
-    sum += delta;
-    z += ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum>>11 & 3]);
-  }
-
-  w[0]=y;
-  w[1]=z;
-}
-
-static void decipher(const ms_uint32 *const v, ms_uint32 *const w,
-                     const ms_uint32 *const k)
-{
-  register ms_uint32       y=v[0],z=v[1],sum=0xC6EF3720, delta=0x9E3779B9,n=32;
-
-  /* sum = delta<<5, in general sum = delta * n */
-
-  while(n-->0) {
-    z -= ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum>>11 & 3]);
-    sum -= delta;
-    y -= ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum&3]);
-  }
-
-  w[0]=y;
-  w[1]=z;
-}
-
-/**********************************************************************
- *                          msHexEncode()
- *
- * Hex-encode numbytes from in[] and return the result in out[].
- *
- * out[] should be preallocated by the caller to be at least 2*numbytes+1
- * (+1 for the terminating '\0')
- **********************************************************************/
-void msHexEncode(const unsigned char *in, char *out, int numbytes)
-{
-  char *hex = "0123456789ABCDEF";
-
-  while (numbytes-- > 0) {
-    *out++ = hex[*in/16];
-    *out++ = hex[*in%16];
-    in++;
-  }
-  *out = '\0';
-}
-
-/**********************************************************************
- *                          msHexDecode()
- *
- * Hex-decode numchars from in[] and return the result in out[].
- *
- * If numchars > 0 then only up to this number of chars from in[] are
- * processed, otherwise the full in[] string up to the '\0' is processed.
- *
- * out[] should be preallocated by the caller to be large enough to hold
- * the resulting bytes.
- *
- * Returns the number of bytes written to out[] which may be different from
- * numchars/2 if an error or a '\0' is encountered.
- **********************************************************************/
-int msHexDecode(const char *in, unsigned char *out, int numchars)
-{
-  int numbytes_out = 0;
-
-  /* Make sure numchars is even */
-  numchars = (numchars/2) * 2;
-
-  if (numchars < 2)
-    numchars = -1; /* Will result in this value being ignored in the loop*/
-
-  while (*in != '\0' && *(in+1) != '\0' && numchars != 0) {
-    *out = 0x10 * (*in >= 'A' ? ((*in & 0xdf) - 'A')+10 : (*in - '0'));
-    in++;
-    *out += (*in >= 'A' ? ((*in & 0xdf) - 'A')+10 : (*in - '0'));
-    in++;
-
-    out++;
-    numbytes_out++;
-
-    numchars -= 2;
-  }
-
-  return numbytes_out;
-}
-
-
-/**********************************************************************
- *                       msGenerateEncryptionKey()
- *
- * Create a new encryption key.
- *
- * The output buffer should be at least MS_ENCRYPTION_KEY_SIZE bytes.
- **********************************************************************/
-
-int msGenerateEncryptionKey(unsigned char *k)
-{
-  int i;
-
-  /* Use current time as seed for rand() */
-  srand( (unsigned int) time( NULL ));
-
-  for(i=0; i<MS_ENCRYPTION_KEY_SIZE; i++)
-  {
-    /* coverity[dont_call] */
-    k[i] = (unsigned char)rand();
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                       msReadEncryptionKeyFromFile()
- *
- * Read and decode hex-encoded encryption key from file and returns the
- * key in the 'unsigned char k[MS_ENCRYPTION_KEY_SIZE]' buffer that is
- * provided by the caller.
- *
- * Returns MS_SUCCESS/MS_FAILURE.
- **********************************************************************/
-
-int msReadEncryptionKeyFromFile(const char *keyfile, unsigned char *k)
-{
-  FILE *fp;
-  char szBuf[100];
-  int numchars;
-
-  if ((fp = fopen(keyfile, "rt")) == NULL) {
-    msSetError(MS_MISCERR, "Cannot open key file.",
-               "msReadEncryptionKeyFromFile()");
-    return MS_FAILURE;
-  }
-
-  numchars = fread(szBuf, sizeof(unsigned char), MS_ENCRYPTION_KEY_SIZE*2, fp);
-  fclose(fp);
-  szBuf[MS_ENCRYPTION_KEY_SIZE*2] = '\0';
-
-  if (numchars != MS_ENCRYPTION_KEY_SIZE*2) {
-    msSetError(MS_MISCERR, "Invalid key file, got %d chars, expected %d.",
-               "msReadEncryptionKeyFromFile()",
-               numchars, MS_ENCRYPTION_KEY_SIZE*2);
-    return MS_FAILURE;
-  }
-
-  msHexDecode(szBuf, k, MS_ENCRYPTION_KEY_SIZE*2);
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                       msLoadEncryptionKey()
- *
- * Load and decode hex-encoded encryption key from file and returns the
- * key in the 'unsigned char k[MS_ENCRYPTION_KEY_SIZE]' buffer that is
- * provided by the caller.
- *
- * The first time that msLoadEncryptionKey() is called for a given mapObj
- * it will load the encryption key and cache it in mapObj->encryption_key.
- * If the key is already set in the mapObj then it does nothing and returns.
- *
- * The location of the encryption key can be specified in two ways,
- * either by setting the environment variable MS_ENCRYPTION_KEY or using
- * a CONFIG directive:
- *    CONFIG MS_ENCRYPTION_KEY "/path/to/mykey.txt"
- * Returns MS_SUCCESS/MS_FAILURE.
- **********************************************************************/
-
-static int msLoadEncryptionKey(mapObj *map)
-{
-  const char *keyfile;
-
-  if (map == NULL) {
-    msSetError(MS_MISCERR, "NULL MapObj.", "msLoadEncryptionKey()");
-    return MS_FAILURE;
-  }
-
-  if (map->encryption_key_loaded)
-    return MS_SUCCESS;  /* Already loaded */
-
-  keyfile = msGetConfigOption(map, "MS_ENCRYPTION_KEY");
-  if(!keyfile) keyfile = CPLGetConfigOption("MS_ENCRYPTION_KEY", NULL);
-
-  if (keyfile &&
-      msReadEncryptionKeyFromFile(keyfile,map->encryption_key) == MS_SUCCESS) {
-    map->encryption_key_loaded = MS_TRUE;
-  } else {
-    msSetError(MS_MISCERR, "Failed reading encryption key. Make sure "
-               "MS_ENCRYPTION_KEY is set and points to a valid key file.",
-               "msLoadEncryptionKey()");
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                        msEncryptStringWithKey()
- *
- * Encrypts and hex-encodes the contents of string in[] and returns the
- * result in out[] which should have been pre-allocated by the caller
- * to be at least twice the size of in[] + 16+1 bytes (for padding + '\0').
- *
- **********************************************************************/
-
-void msEncryptStringWithKey(const unsigned char *key, const char *in, char *out)
-{
-  ms_uint32 v[4], w[4];
-  const ms_uint32 *k;
-  int last_block = MS_FALSE;
-
-  /* Casting the key this way is safe only as long as longs are 4 bytes
-   * on this platform */
-  assert(sizeof(ms_uint32) == 4);
-  k = (const ms_uint32 *) key;
-
-  while(!last_block) {
-    int i, j;
-    /* encipher() takes v[2] (64 bits) as input.
-     * Copy bytes from in[] to the v[2] input array (pair of 4 bytes)
-     * v[] is padded with zeros if string doesn't align with 8 bytes
-     */
-    v[0] = 0;
-    v[1] = 0;
-    for(i=0; !last_block && i<2; i++) {
-      for(j=0; j<4; j++) {
-        if (*in == '\0') {
-          last_block = MS_TRUE;
-          break;
-        }
-
-        v[i] |= *in << (j*8);
-        in++;
-      }
-    }
-
-    if (*in == '\0')
-      last_block = MS_TRUE;
-
-    /* Do the actual encryption */
-    encipher(v, w, k);
-
-    /* Append hex-encoded bytes to output, 4 bytes at a time */
-    msHexEncode((unsigned char *)w, out, 4);
-    out += 8;
-    msHexEncode((unsigned char *)(w+1), out, 4);
-    out += 8;
-
-  }
-
-  /* Make sure output is 0-terminated */
-  *out = '\0';
-}
-
-/**********************************************************************
- *                        msDecryptStringWithKey()
- *
- * Hex-decodes and then decrypts the contents of string in[] and returns the
- * result in out[] which should have been pre-allocated by the caller
- * to be at least half the size of in[].
- *
- **********************************************************************/
-
-void msDecryptStringWithKey(const unsigned char *key, const char *in, char *out)
-{
-  ms_uint32 v[4], w[4];
-  const ms_uint32 *k;
-  int last_block = MS_FALSE;
-
-  /* Casting the key this way is safe only as long as longs are 4 bytes
-   * on this platform */
-  assert(sizeof(ms_uint32) == 4);
-  k = (const ms_uint32 *) key;
-
-  while(!last_block) {
-    int i;
-    /* decipher() takes v[2] (64 bits) as input.
-     * Copy bytes from in[] to the v[2] input array (pair of 4 bytes)
-     * v[] is padded with zeros if string doesn't align with 8 bytes
-     */
-    v[0] = 0;
-    v[1] = 0;
-
-    if (msHexDecode(in, (unsigned char *)v, 8) != 4)
-      last_block = MS_TRUE;
-    else {
-      in += 8;
-      if (msHexDecode(in, (unsigned char *)(v+1), 8) != 4)
-        last_block = MS_TRUE;
-      else
-        in += 8;
-    }
-
-    /* Do the actual decryption */
-    decipher(v, w, k);
-
-    /* Copy the results to out[] */
-    for(i=0; i<2; i++) {
-      *out++ = (w[i] & 0x000000ff);
-      *out++ = (w[i] & 0x0000ff00) >> 8;
-      *out++ = (w[i] & 0x00ff0000) >> 16;
-      *out++ = (w[i] & 0xff000000) >> 24;
-    }
-
-    if (*in == '\0')
-      last_block = MS_TRUE;
-  }
-
-  /* Make sure output is 0-terminated */
-  *out = '\0';
-}
-
-/**********************************************************************
- *                        msDecryptStringTokens()
- *
- * Returns a newly allocated string (to be msFree'd by the caller) in
- * which all occurences of encrypted strings delimited by {...} have
- * been decrypted.
- *
- **********************************************************************/
-
-char *msDecryptStringTokens(mapObj *map, const char *in)
-{
-  char *outbuf, *out;
-
-  if (map == NULL) {
-    msSetError(MS_MISCERR, "NULL MapObj.", "msLoadEncryptionKey()");
-    return NULL;
-  }
-
-  /* Start with a copy of the string. Decryption can only result in
-   * a string with the same or shorter length */
-  if ((outbuf = (char *)malloc((strlen(in)+1)*sizeof(char))) == NULL) {
-    msSetError(MS_MEMERR, NULL, "msDecryptStringTokens()");
-    return NULL;
-  }
-  out = outbuf;
-
-  while(*in != '\0') {
-    if (*in == '{') {
-      /* Possibly beginning of a token, look for closing bracket
-      ** and make sure all chars in between are valid hex encoding chars
-      */
-      const char *pszStart, *pszEnd;
-      int valid_token = MS_FALSE;
-
-      pszStart = in+1;
-      if ( (pszEnd = strchr(pszStart, '}')) != NULL &&
-           pszEnd - pszStart > 1) {
-        const char *pszTmp;
-        valid_token = MS_TRUE;
-        for(pszTmp = pszStart; pszTmp < pszEnd; pszTmp++) {
-          if (!isxdigit(*pszTmp)) {
-            valid_token = MS_FALSE;
-            break;
-          }
-        }
-      }
-
-      if (valid_token) {
-        /* Go ahead and decrypt the token */
-        char *pszTmp;
-
-        /* Make sure encryption key is loaded. We do this here instead
-         * of at the beginning of the function to avoid loading the
-         * key unless ready necessary. This is a very cheap call if
-         * the key is already loaded
-         */
-        if (msLoadEncryptionKey(map) != MS_SUCCESS)
-          return NULL;
-
-        pszTmp = (char*)malloc( (pszEnd-pszStart+1)*sizeof(char));
-        strlcpy(pszTmp, pszStart, (pszEnd-pszStart)+1);
-
-        msDecryptStringWithKey(map->encryption_key, pszTmp, out);
-
-        out += strlen(out);
-        in = pszEnd+1;
-        free(pszTmp);
-      } else {
-        /* Not a valid token, just copy the '{' and keep going */
-        *out++ = *in++;
-      }
-    } else {
-      /* Just copy any other chars */
-      *out++ = *in++;
-    }
-  }
-  *out = '\0';
-
-  return outbuf;
-}
-
-
-#ifdef TEST_MAPCRYPTO
-
-/* Test for mapcrypto.c functions. To run these tests, use the following
-** Makefile directive:
-
-test_mapcrypto: $(LIBMAP_STATIC) mapcrypto.c
-  $(CC) $(CFLAGS) mapcrypto.c -DTEST_MAPCRYPTO $(EXE_LDFLAGS) -o test_mapcrypto
-
-**
-*/
-int main(int argc, char *argv[])
-{
-  const unsigned char bytes_in[] = {0x12, 0x34, 0xff, 0x00, 0x44, 0x22};
-  unsigned char bytes_out[8], encryption_key[MS_ENCRYPTION_KEY_SIZE*2+1];
-  char string_buf[256], string_buf2[256];
-  int numbytes = 0;
-
-  /*
-  ** Test msHexEncode()
-  */
-  msHexEncode(bytes_in, string_buf, 6);
-  printf("msHexEncode returned '%s'\n", string_buf);
-
-  /*
-  ** Test msHexDecode()
-  */
-  memset(bytes_out, 0, 8);
-  numbytes = msHexDecode(string_buf, bytes_out, -1);
-  printf("msHexDecode(%s, -1) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
-         string_buf, numbytes,
-         bytes_out[0], bytes_out[1], bytes_out[2], bytes_out[3],
-         bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
-
-  memset(bytes_out, 0, 8);
-  numbytes = msHexDecode(string_buf, bytes_out, 4);
-  printf("msHexDecode(%s, 4) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
-         string_buf, numbytes,
-         bytes_out[0], bytes_out[1], bytes_out[2], bytes_out[3],
-         bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
-
-  memset(bytes_out, 0, 8);
-  numbytes = msHexDecode(string_buf, bytes_out, 20);
-  printf("msHexDecode(%s, 20) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
-         string_buf, numbytes,
-         bytes_out[0], bytes_out[1], bytes_out[2], bytes_out[3],
-         bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
-
-  /*
-  ** Test loading encryption key
-  */
-  if (msReadEncryptionKeyFromFile("/tmp/test.key", encryption_key) != MS_SUCCESS) {
-    printf("msReadEncryptionKeyFromFile() = MS_FAILURE\n");
-    printf("Aborting tests!\n");
-    msWriteError(stderr);
-    return -1;
-  } else {
-    msHexEncode(encryption_key, string_buf, MS_ENCRYPTION_KEY_SIZE);
-    printf("msReadEncryptionKeyFromFile() returned '%s'\n", string_buf);
-  }
-
-  /*
-  ** Test Encryption/Decryption
-  */
-
-  /* First with an 8 bytes input string (test boundaries) */
-  msEncryptStringWithKey(encryption_key, "test1234", string_buf);
-  printf("msEncryptStringWithKey('test1234') returned '%s'\n", string_buf);
-
-  msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
-  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf, string_buf2);
-
-  /* Next with an 1 byte input string */
-  msEncryptStringWithKey(encryption_key, "t", string_buf);
-  printf("msEncryptStringWithKey('t') returned '%s'\n", string_buf);
-
-  msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
-  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf, string_buf2);
-
-  /* Next with an 12 bytes input string */
-  msEncryptStringWithKey(encryption_key, "test123456", string_buf);
-  printf("msEncryptStringWithKey('test123456') returned '%s'\n", string_buf);
-
-  msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
-  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf, string_buf2);
-
-  /*
-  ** Test decryption with tokens
-  */
-  {
-    char *pszBuf;
-    mapObj *map;
-    /* map = msNewMapObj(); */
-    map = msLoadMap("/tmp/test.map", NULL);
-
-    sprintf(string_buf2, "string with a {%s} encrypted token", string_buf);
-
-    pszBuf = msDecryptStringTokens(map, string_buf2);
-    if (pszBuf == NULL) {
-      printf("msDecryptStringTokens() failed.\n");
-      printf("Aborting tests!\n");
-      msWriteError(stderr);
-      return -1;
-    } else {
-      printf("msDecryptStringTokens('%s') returned '%s'\n",
-             string_buf2, pszBuf);
-    }
-    msFree(pszBuf);
-    msFreeMap(map);
-  }
-
-  return 0;
-}
-
-
-#endif /* TEST_MAPCRYPTO */
diff -pruN 8.0.1-5/mapdebug.c 8.2.0~beta1-1~exp1/mapdebug.c
--- 8.0.1-5/mapdebug.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapdebug.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,378 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of debug/logging, msDebug() and related functions.
- * Author:   Daniel Morissette
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapthread.h"
-#include "maptime.h"
-
-#include "cpl_conv.h"
-
-#include <time.h>
-#ifndef _WIN32
-#include <sys/time.h>
-#include <unistd.h>
-#endif
-#include <stdarg.h>
-
-#ifdef NEED_NONBLOCKING_STDERR
-#include <fcntl.h>
-#endif
-
-#ifdef _WIN32
-#include <windows.h> /* OutputDebugStringA() */
-#endif
-
-
-
-
-#ifndef USE_THREAD
-
-debugInfoObj *msGetDebugInfoObj()
-{
-  static debugInfoObj debuginfo = {MS_DEBUGLEVEL_ERRORSONLY,
-                                   MS_DEBUGMODE_OFF, NULL, NULL
-                                  };
-  return &debuginfo;
-}
-
-#else
-
-static debugInfoObj *debuginfo_list = NULL;
-
-debugInfoObj *msGetDebugInfoObj()
-{
-  debugInfoObj *link;
-  void* thread_id;
-  debugInfoObj *ret_obj;
-
-  msAcquireLock( TLOCK_DEBUGOBJ );
-
-  thread_id = msGetThreadId();
-
-  /* find link for this thread */
-
-  for( link = debuginfo_list;
-       link != NULL && link->thread_id != thread_id
-       && link->next != NULL && link->next->thread_id != thread_id;
-       link = link->next ) {}
-
-  /* If the target thread link is already at the head of the list were ok */
-  if( debuginfo_list != NULL && debuginfo_list->thread_id == thread_id ) {
-  }
-
-  /* We don't have one ... initialize one. */
-  else if( link == NULL || link->next == NULL ) {
-    debugInfoObj *new_link;
-
-    new_link = (debugInfoObj *) msSmallMalloc(sizeof(debugInfoObj));
-    new_link->next = debuginfo_list;
-    new_link->thread_id = thread_id;
-    new_link->global_debug_level = MS_DEBUGLEVEL_ERRORSONLY;
-    new_link->debug_mode = MS_DEBUGMODE_OFF;
-    new_link->errorfile = NULL;
-    new_link->fp = NULL;
-    debuginfo_list = new_link;
-  }
-
-  /* If the link is not already at the head of the list, promote it */
-  else {
-    debugInfoObj *target = link->next;
-
-    link->next = link->next->next;
-    target->next = debuginfo_list;
-    debuginfo_list = target;
-  }
-
-  ret_obj = debuginfo_list;
-
-  msReleaseLock( TLOCK_DEBUGOBJ );
-
-  return ret_obj;
-}
-#endif
-
-
-/* msSetErrorFile()
-**
-** Set output target, ready to write to it, open file if necessary
-**
-** If pszRelToPath != NULL then we will try to make the value relative to
-** this path if it is not absolute already and it's not one of the special
-** values (stderr, stdout, windowsdebug)
-**
-** Returns MS_SUCCESS/MS_FAILURE
-*/
-int msSetErrorFile(const char *pszErrorFile, const char *pszRelToPath)
-{
-  char extended_path[MS_MAXPATHLEN];
-  debugInfoObj *debuginfo = msGetDebugInfoObj();
-
-  if (strcmp(pszErrorFile, "stderr") != 0 &&
-      strcmp(pszErrorFile, "stdout") != 0 &&
-      strcmp(pszErrorFile, "windowsdebug") != 0) {
-    /* Try to make the path relative */
-    if(msBuildPath(extended_path, pszRelToPath, pszErrorFile) == NULL)
-      return MS_FAILURE;
-    pszErrorFile = extended_path;
-  }
-
-  if (debuginfo->errorfile && pszErrorFile &&
-      strcmp(debuginfo->errorfile, pszErrorFile) == 0) {
-    /* Nothing to do, already writing to the right place */
-    return MS_SUCCESS;
-  }
-
-  /* Close current output file if any */
-  msCloseErrorFile();
-
-  /* NULL or empty target will just close current output and return */
-  if (pszErrorFile == NULL || *pszErrorFile == '\0')
-    return MS_SUCCESS;
-
-  if (strcmp(pszErrorFile, "stderr") == 0) {
-    debuginfo->fp = stderr;
-    debuginfo->errorfile = msStrdup(pszErrorFile);
-    debuginfo->debug_mode = MS_DEBUGMODE_STDERR;
-  } else if (strcmp(pszErrorFile, "stdout") == 0) {
-    debuginfo->fp = stdout;
-    debuginfo->errorfile = msStrdup(pszErrorFile);
-    debuginfo->debug_mode = MS_DEBUGMODE_STDOUT;
-  } else if (strcmp(pszErrorFile, "windowsdebug") == 0) {
-#ifdef _WIN32
-    debuginfo->errorfile = msStrdup(pszErrorFile);
-    debuginfo->fp = NULL;
-    debuginfo->debug_mode = MS_DEBUGMODE_WINDOWSDEBUG;
-#else
-    msSetError(MS_MISCERR, "'MS_ERRORFILE windowsdebug' is available only on Windows platforms.", "msSetErrorFile()");
-    return MS_FAILURE;
-#endif
-  } else {
-    debuginfo->fp = fopen(pszErrorFile, "a");
-    if (debuginfo->fp == NULL) {
-      msSetError(MS_MISCERR, "Failed to open MS_ERRORFILE %s", "msSetErrorFile()", pszErrorFile);
-      return MS_FAILURE;
-    }
-    debuginfo->errorfile = msStrdup(pszErrorFile);
-    debuginfo->debug_mode = MS_DEBUGMODE_FILE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/* msCloseErrorFile()
-**
-** Close current output file (if one is open) and reset related members
-*/
-void msCloseErrorFile()
-{
-  debugInfoObj *debuginfo = msGetDebugInfoObj();
-
-  if (debuginfo && debuginfo->debug_mode != MS_DEBUGMODE_OFF) {
-    if (debuginfo->fp && debuginfo->debug_mode == MS_DEBUGMODE_FILE)
-      fclose(debuginfo->fp);
-
-    if (debuginfo->fp && (debuginfo->debug_mode == MS_DEBUGMODE_STDERR ||
-                          debuginfo->debug_mode == MS_DEBUGMODE_STDOUT))
-      fflush(debuginfo->fp); /* just flush stderr or stdout */
-
-    debuginfo->fp = NULL;
-
-    msFree(debuginfo->errorfile);
-    debuginfo->errorfile = NULL;
-
-    debuginfo->debug_mode = MS_DEBUGMODE_OFF;
-  }
-}
-
-
-
-/* msGetErrorFile()
-**
-** Returns name of current error file
-**
-** Returns NULL if not set.
-*/
-const char *msGetErrorFile()
-{
-  debugInfoObj *debuginfo = msGetDebugInfoObj();
-
-  if (debuginfo)
-    return debuginfo->errorfile;
-
-  return NULL;
-}
-
-/* Set/Get the current global debug level value, used as default value for
-** new map and layer objects and to control msDebug() calls outside of
-** the context of mapObj or layerObj.
-**
-*/
-void msSetGlobalDebugLevel(int level)
-{
-  debugInfoObj *debuginfo = msGetDebugInfoObj();
-
-  if (debuginfo)
-    debuginfo->global_debug_level = (debugLevel)level;
-}
-
-debugLevel msGetGlobalDebugLevel()
-{
-  debugInfoObj *debuginfo = msGetDebugInfoObj();
-
-  if (debuginfo)
-    return debuginfo->global_debug_level;
-
-  return MS_DEBUGLEVEL_ERRORSONLY;
-}
-
-
-/* msDebugInitFromEnv()
-**
-** Init debug state from MS_ERRORFILE and MS_DEBUGLEVEL env vars if set
-**
-** Returns MS_SUCCESS/MS_FAILURE
-*/
-int msDebugInitFromEnv()
-{
-  const char *val;
-
-  if( (val=CPLGetConfigOption("MS_ERRORFILE", NULL)) != NULL ) {
-    if ( msSetErrorFile(val, NULL) != MS_SUCCESS )
-      return MS_FAILURE;
-  }
-
-  if( (val=CPLGetConfigOption("MS_DEBUGLEVEL", NULL)) != NULL )
-    msSetGlobalDebugLevel(atoi(val));
-
-  return MS_SUCCESS;
-}
-
-
-/* msDebugCleanup()
-**
-** Called by msCleanup to remove info related to this thread.
-*/
-void msDebugCleanup()
-{
-  /* make sure file is closed */
-  msCloseErrorFile();
-
-#ifdef USE_THREAD
-  {
-    void*  thread_id = msGetThreadId();
-    debugInfoObj *link;
-
-    msAcquireLock( TLOCK_DEBUGOBJ );
-
-    /* find link for this thread */
-
-    for( link = debuginfo_list;
-         link != NULL && link->thread_id != thread_id
-         && link->next != NULL && link->next->thread_id != thread_id;
-         link = link->next ) {}
-
-    if( link->thread_id == thread_id ) {
-      /* presumably link is at head of list.  */
-      if( debuginfo_list == link )
-        debuginfo_list = link->next;
-
-      free( link );
-    } else if( link->next != NULL && link->next->thread_id == thread_id ) {
-      debugInfoObj *next_link = link->next;
-      link->next = link->next->next;
-      free( next_link );
-    }
-    msReleaseLock( TLOCK_DEBUGOBJ );
-  }
-#endif
-
-}
-
-/* msDebug()
-**
-** Outputs/logs messages to the MS_ERRORFILE if one is set
-** (see msSetErrorFile())
-**
-*/
-void msDebug( const char * pszFormat, ... )
-{
-  va_list args;
-  debugInfoObj *debuginfo = msGetDebugInfoObj();
-  char szMessage[MESSAGELENGTH];
-
-  if (debuginfo == NULL || debuginfo->debug_mode == MS_DEBUGMODE_OFF)
-    return;  /* Don't waste time here! */
-
-  va_start(args, pszFormat);
-  vsnprintf( szMessage, MESSAGELENGTH, pszFormat, args );
-  va_end(args);
-  szMessage[MESSAGELENGTH-1] = '\0';
-
-  msRedactCredentials(szMessage);
-
-  if (debuginfo->fp) {
-    /* Writing to a stdio file handle */
-
-#if defined(USE_FASTCGI)
-    /* It seems the FastCGI stuff inserts a timestamp anyways, so  */
-    /* we might as well skip this one if writing to stderr w/ FastCGI. */
-    if (debuginfo->debug_mode != MS_DEBUGMODE_STDERR)
-#endif
-    {
-      struct mstimeval tv;
-      time_t t;
-      msGettimeofday(&tv, NULL);
-      t = tv.tv_sec;
-      msIO_fprintf(debuginfo->fp, "[%s].%ld ",
-                   msStringChop(ctime(&t)), (long)tv.tv_usec);
-    }
-
-    msIO_fprintf(debuginfo->fp, "%s", szMessage);
-  }
-#ifdef _WIN32
-  else if (debuginfo->debug_mode == MS_DEBUGMODE_WINDOWSDEBUG) {
-    /* Writing to Windows Debug Console */
-    OutputDebugStringA(szMessage);
-  }
-#endif
-
-}
-
-
-/* msDebug2()
-**
-** Variadic function with no operation
-**
-*/
-void msDebug2( int level, ... )
-{
-    (void)level;
-}
diff -pruN 8.0.1-5/mapdraw.c 8.2.0~beta1-1~exp1/mapdraw.c
--- 8.0.1-5/mapdraw.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapdraw.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,3686 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  High level msDrawMap() implementation and related functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <assert.h>
-#include <math.h>
-#include "mapserver.h"
-#include "maptime.h"
-#include "mapcopy.h"
-#include "mapfile.h"
-#include "mapows.h"
-
-
-/* msPrepareImage()
- *
- * Returns a new imageObj ready for rendering the current map.
- *
- * If allow_nonsquare is set to MS_TRUE then the caller should call
- * msMapRestoreRealExtent() once they are done with the image.
- * This should be set to MS_TRUE only when called from msDrawMap(), see bug 945.
- */
-imageObj *msPrepareImage(mapObj *map, int allow_nonsquare)
-{
-  int i, status;
-  imageObj *image=NULL;
-  double geo_cellsize;
-
-  if(map->width == -1 || map->height == -1) {
-    msSetError(MS_MISCERR, "Image dimensions not specified.", "msPrepareImage()");
-    return(NULL);
-  }
-
-  msFreeLabelCache(&(map->labelcache));
-  msInitLabelCache(&(map->labelcache)); /* this clears any previously allocated cache */
-
-  /* clear any previously created mask layer images */
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->maskimage) {
-      msFreeImage(GET_LAYER(map, i)->maskimage);
-      GET_LAYER(map, i)->maskimage = NULL;
-    }
-  }
-
-  status = msValidateContexts(map); /* make sure there are no recursive REQUIRES or LABELREQUIRES expressions */
-  if(status != MS_SUCCESS) return NULL;
-
-  if(!map->outputformat) {
-    msSetError(MS_IMGERR, "Map outputformat not set!", "msPrepareImage()");
-    return(NULL);
-  } else if (MS_RENDERER_PLUGIN(map->outputformat)) {
-    rendererVTableObj *renderer = map->outputformat->vtable;
-    colorObj *bg = &map->imagecolor;
-    map->imagecolor.alpha=255;
-
-    image = renderer->createImage(map->width, map->height, map->outputformat,bg);
-    if (image == NULL)
-      return(NULL);
-    image->format = map->outputformat;
-    image->format->refcount++;
-    image->width = map->width;
-    image->height = map->height;
-    
-    image->resolution = map->resolution;
-    image->resolutionfactor = map->resolution/map->defresolution;
-    if (map->web.imagepath)
-      image->imagepath = msStrdup(map->web.imagepath);
-    if (map->web.imageurl)
-      image->imageurl = msStrdup(map->web.imageurl);
-
-  } else if( MS_RENDERER_IMAGEMAP(map->outputformat) ) {
-    image = msImageCreateIM(map->width, map->height, map->outputformat,
-                            map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution);
-  } else if( MS_RENDERER_RAWDATA(map->outputformat) ) {
-    image = msImageCreate(map->width, map->height, map->outputformat,
-                          map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &map->imagecolor);
-  } else {
-    image = NULL;
-  }
-  
-  if(!image) {
-    msSetError(MS_IMGERR, "Unable to initialize image.", "msPrepareImage()");
-    return(NULL);
-  }
-  
-  image->map = map;
-
-  /*
-   * If we want to support nonsquare pixels, note that now, otherwise
-   * adjust the extent size to have square pixels.
-   *
-   * If allow_nonsquare is set to MS_TRUE then the caller should call
-   * msMapRestoreRealExtent() once they are done with the image.
-   * This should be set to MS_TRUE only when called from msDrawMap(), see bug 945.
-   */
-  if( allow_nonsquare && msTestConfigOption( map, "MS_NONSQUARE", MS_FALSE ) ) {
-    double cellsize_x = (map->extent.maxx - map->extent.minx)/map->width;
-    double cellsize_y = (map->extent.maxy - map->extent.miny)/map->height;
-
-    if( cellsize_y != 0.0
-        && (fabs(cellsize_x/cellsize_y) > 1.00001
-            || fabs(cellsize_x/cellsize_y) < 0.99999) ) {
-      map->gt.need_geotransform = MS_TRUE;
-      if (map->debug)
-        msDebug( "msDrawMap(): kicking into non-square pixel preserving mode.\n" );
-    }
-    map->cellsize = (cellsize_x*0.5 + cellsize_y*0.5);
-  } else
-    map->cellsize = msAdjustExtent(&(map->extent),map->width,map->height);
-
-  status = msCalculateScale(map->extent,map->units,map->width,map->height, map->resolution, &map->scaledenom);
-  if(status != MS_SUCCESS) {
-    msFreeImage(image);
-    return(NULL);
-  }
-
-  /* update geotransform based on adjusted extent. */
-  msMapComputeGeotransform( map );
-
-  /* Do we need to fake out stuff for rotated support? */
-  if( map->gt.need_geotransform )
-    msMapSetFakedExtent( map );
-
-  /* We will need a cellsize that represents a real georeferenced */
-  /* coordinate cellsize here, so compute it from saved extents.   */
-
-  geo_cellsize = map->cellsize;
-  if( map->gt.need_geotransform == MS_TRUE ) {
-    double cellsize_x = (map->saved_extent.maxx - map->saved_extent.minx)
-                        / map->width;
-    double cellsize_y = (map->saved_extent.maxy - map->saved_extent.miny)
-                        / map->height;
-
-    geo_cellsize = sqrt(cellsize_x*cellsize_x + cellsize_y*cellsize_y)
-                   / sqrt(2.0);
-  }
-
-  /* compute layer/class/style/label scale factors now */
-  for(int lid=0; lid<map->numlayers; lid++) {
-    layerObj * layer = GET_LAYER(map, lid);
-    if(layer->sizeunits != MS_PIXELS)
-      layer->scalefactor = (msInchesPerUnit(layer->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
-    else if(layer->symbolscaledenom > 0 && map->scaledenom > 0)
-      layer->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
-    else
-      layer->scalefactor = map->resolution/map->defresolution;
-    for (int cid=0 ; cid<layer->numclasses ; cid++)
-    {
-      classObj * class = GET_CLASS(map, lid, cid);
-      if (class->sizeunits == MS_INHERIT)
-        class->scalefactor = layer->scalefactor;
-      else if (class->sizeunits != MS_PIXELS)
-        class->scalefactor = (msInchesPerUnit(class->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
-      else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-        class->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
-      else
-        class->scalefactor = map->resolution/map->defresolution;
-      for (int sid=0 ; sid<class->numstyles ; sid++)
-      {
-        styleObj * style = class->styles[sid];
-        if (style->sizeunits == MS_INHERIT)
-          style->scalefactor = class->scalefactor;
-        else if (style->sizeunits != MS_PIXELS)
-          style->scalefactor = (msInchesPerUnit(style->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
-        else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-          style->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
-        else
-          style->scalefactor = map->resolution/map->defresolution;
-      }
-      for (int sid=0 ; sid<class->numlabels ; sid++)
-      {
-        labelObj * label = class->labels[sid];
-        if (label->sizeunits == MS_INHERIT)
-          label->scalefactor = class->scalefactor;
-        else if (label->sizeunits != MS_PIXELS)
-          label->scalefactor = (msInchesPerUnit(label->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
-        else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-          label->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
-        else
-          label->scalefactor = map->resolution/map->defresolution;
-        for (int lsid=0 ; lsid<label->numstyles ; lsid++)
-        {
-          styleObj * lstyle = label->styles[lsid];
-          if (lstyle->sizeunits == MS_INHERIT)
-            lstyle->scalefactor = label->scalefactor;
-          else if (lstyle->sizeunits != MS_PIXELS)
-            lstyle->scalefactor = (msInchesPerUnit(lstyle->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
-          else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-            lstyle->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
-          else
-            lstyle->scalefactor = map->resolution/map->defresolution;
-        }
-      }
-    }
-  }
-
-  image->refpt.x = MS_MAP2IMAGE_X_IC_DBL(0, map->extent.minx, 1.0/map->cellsize);
-  image->refpt.y = MS_MAP2IMAGE_Y_IC_DBL(0, map->extent.maxy, 1.0/map->cellsize);
-
-  return image;
-  
-}
-
-static int msCompositeRasterBuffer(mapObj *map, imageObj *img, rasterBufferObj *rb, LayerCompositer *comp) {
-  int ret = MS_SUCCESS;
-  if(MS_IMAGE_RENDERER(img)->compositeRasterBuffer) {
-    while(comp && ret == MS_SUCCESS) {
-      rasterBufferObj *rb_ptr = rb;
-      CompositingFilter *filter = comp->filter;
-      if(filter && comp->next) {
-       /* if we have another compositor to apply, then we need to copy the rasterBufferObj. Otherwise
-       * we can work on it directly */
-	rb_ptr = (rasterBufferObj*)msSmallCalloc(sizeof(rasterBufferObj),1);
-	msCopyRasterBuffer(rb_ptr,rb);
-      }
-      while(filter && ret == MS_SUCCESS) {
-        ret = msApplyCompositingFilter(map,rb_ptr,filter);
-        filter = filter->next;
-      }
-      if(ret == MS_SUCCESS)
-      	ret = MS_IMAGE_RENDERER(img)->compositeRasterBuffer(img,rb_ptr,comp->comp_op, comp->opacity);
-      if(rb_ptr != rb) {
-        msFreeRasterBuffer(rb_ptr);
-        msFree(rb_ptr);
-      }
-      comp = comp->next;
-    }
-  } else {
-    ret = MS_FAILURE;
-  }
-  return ret;
-}
-
-/*
- * Generic function to render the map file.
- * The type of the image created is based on the imagetype parameter in the map file.
- *
- * mapObj *map - map object loaded in MapScript or via a mapfile to use
- * int querymap - is this map the result of a query operation, MS_TRUE|MS_FALSE
-*/
-imageObj *msDrawMap(mapObj *map, int querymap)
-{
-  int i;
-  layerObj *lp=NULL;
-  int status = MS_FAILURE;
-  imageObj *image = NULL;
-  struct mstimeval mapstarttime = {0}, mapendtime = {0};
-  struct mstimeval starttime = {0}, endtime = {0};
-
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-  enum MS_CONNECTION_TYPE lastconnectiontype;
-  httpRequestObj *pasOWSReqInfo=NULL;
-  int numOWSLayers=0;
-  int numOWSRequests=0;
-  wmsParamsObj sLastWMSParams;
-#endif
-
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) msGettimeofday(&mapstarttime, NULL);
-
-  if(querymap) { /* use queryMapObj image dimensions */
-    if(map->querymap.width > 0 && map->querymap.width <= map->maxsize) map->width = map->querymap.width;
-    if(map->querymap.height > 0 && map->querymap.height <= map->maxsize) map->height = map->querymap.height;
-  }
-
-  msApplyMapConfigOptions(map);
-  image = msPrepareImage(map, MS_TRUE);
-
-  if(!image) {
-    msSetError(MS_IMGERR, "Unable to initialize image.", "msDrawMap()");
-    return(NULL);
-  }
-
-  if( map->debug >= MS_DEBUGLEVEL_DEBUG )
-    msDebug( "msDrawMap(): rendering using outputformat named %s (%s).\n",
-             map->outputformat->name,
-             map->outputformat->driver );
-
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-
-  /* Time the OWS query phase */
-  if(map->debug >= MS_DEBUGLEVEL_TUNING ) msGettimeofday(&starttime, NULL);
-
-  /* How many OWS (WMS/WFS) layers do we have to draw?
-   * Note: numOWSLayers is the number of actual layers and numOWSRequests is
-   * the number of HTTP requests which could be lower if multiple layers
-   * are merged into the same request.
-   */
-  numOWSLayers=0;
-  for(i=0; i<map->numlayers; i++) {
-      if(map->layerorder[i] == -1 )
-        continue;
-
-      lp = GET_LAYER(map,map->layerorder[i]);
-      if( lp->connectiontype != MS_WMS &&
-          lp->connectiontype != MS_WFS ) {
-        continue;
-      }
-      numOWSLayers++;
-  }
-
-  if (numOWSLayers > 0) {
-
-    /* Alloc and init pasOWSReqInfo...
-     */
-    pasOWSReqInfo = (httpRequestObj *)malloc(numOWSLayers*sizeof(httpRequestObj));
-    if (pasOWSReqInfo == NULL) {
-      msSetError(MS_MEMERR, "Allocation of httpRequestObj failed.", "msDrawMap()");
-      return NULL;
-    }
-    msHTTPInitRequestObj(pasOWSReqInfo, numOWSLayers);
-    msInitWmsParamsObj(&sLastWMSParams);
-
-    /* Pre-download all WMS/WFS layers in parallel before starting to draw map */
-    lastconnectiontype = MS_SHAPEFILE;
-    for(i=0; i<map->numlayers; i++) {
-      if(map->layerorder[i] == -1 )
-        continue;
-
-      lp = GET_LAYER(map,map->layerorder[i]);
-      if( lp->connectiontype != MS_WMS &&
-          lp->connectiontype != MS_WFS ) {
-        continue;
-      }
-
-      if( !msLayerIsVisible(map, lp) )
-        continue;
-
-#ifdef USE_WMS_LYR
-      if(lp->connectiontype == MS_WMS) {
-        if(msPrepareWMSLayerRequest(map->layerorder[i], map, lp, 1, lastconnectiontype, &sLastWMSParams, 0, 0, 0, NULL, pasOWSReqInfo, &numOWSRequests) == MS_FAILURE) {
-          msFreeWmsParamsObj(&sLastWMSParams);
-          msFreeImage(image);
-          msFree(pasOWSReqInfo);
-          return NULL;
-        }
-      }
-#endif
-
-#ifdef USE_WFS_LYR
-      if(lp->connectiontype == MS_WFS) {
-        if(msPrepareWFSLayerRequest(map->layerorder[i], map, lp, pasOWSReqInfo, &numOWSRequests) == MS_FAILURE) {
-          msFreeWmsParamsObj(&sLastWMSParams);
-          msFreeImage(image);
-          msFree(pasOWSReqInfo);
-          return NULL;
-        }
-      }
-#endif
-
-      lastconnectiontype = lp->connectiontype;
-    }
-
-    msFreeWmsParamsObj(&sLastWMSParams);
-  } /* if numOWSLayers > 0 */
-
-  if(numOWSRequests && msOWSExecuteRequests(pasOWSReqInfo, numOWSRequests, map, MS_TRUE) == MS_FAILURE) {
-    msFreeImage(image);
-    msFree(pasOWSReqInfo);
-    return NULL;
-  }
-
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&endtime, NULL);
-    msDebug("msDrawMap(): WMS/WFS set-up and query, %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-  }
-
-#endif /* USE_WMS_LYR || USE_WFS_LYR */
-
-  /* OK, now we can start drawing */
-  for(i=0; i<map->numlayers; i++) {
-
-    if(map->layerorder[i] != -1) {
-      const char *force_draw_label_cache = NULL;
-
-      lp = (GET_LAYER(map,  map->layerorder[i]));
-
-      if(lp->postlabelcache) /* wait to draw */
-        continue;
-
-      if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING ) msGettimeofday(&starttime, NULL);
-
-      if(!msLayerIsVisible(map, lp)) continue;
-
-      if(lp->connectiontype == MS_WMS) {
-#ifdef USE_WMS_LYR
-        if(MS_RENDERER_PLUGIN(image->format) || MS_RENDERER_RAWDATA(image->format)) {
-          assert(pasOWSReqInfo);
-          status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo, numOWSRequests,  map, lp, image);
-        }
-        else {
-          msSetError(MS_WMSCONNERR, "Output format '%s' doesn't support WMS layers.", "msDrawMap()", image->format->name);
-          status = MS_FAILURE;
-        }
-
-        if(status == MS_FAILURE) {
-          msSetError(MS_WMSCONNERR,
-                     "Failed to draw WMS layer named '%s'. This most likely happened because "
-                     "the remote WMS server returned an invalid image, and XML exception "
-                     "or another unexpected result in response to the GetMap request. Also check "
-                     "and make sure that the layer's connection URL is valid.",
-                     "msDrawMap()", lp->name);
-          msFreeImage(image);
-          msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-          msFree(pasOWSReqInfo);
-          return(NULL);
-        }
-
-
-#else /* ndef USE_WMS_LYR */
-        msSetError(MS_WMSCONNERR, "MapServer not built with WMS Client support, unable to render layer '%s'.", "msDrawMap()", lp->name);
-        msFreeImage(image);
-        return(NULL);
-#endif
-      } else { /* Default case: anything but WMS layers */
-        if(querymap)
-          status = msDrawQueryLayer(map, lp, image);
-        else
-          status = msDrawLayer(map, lp, image);
-        if(status == MS_FAILURE) {
-          msSetError(MS_IMGERR, "Failed to draw layer named '%s'.", "msDrawMap()", lp->name);
-          msFreeImage(image);
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-          if (pasOWSReqInfo) {
-            msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-            msFree(pasOWSReqInfo);
-          }
-#endif /* USE_WMS_LYR || USE_WFS_LYR */
-          return(NULL);
-        }
-      }
-      if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING) {
-        msGettimeofday(&endtime, NULL);
-        msDebug("msDrawMap(): Layer %d (%s), %.3fs\n",
-                map->layerorder[i], lp->name?lp->name:"(null)",
-                (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-                (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-      }
-
-      /* Flush layer cache in-between layers if requested by PROCESSING directive*/
-      force_draw_label_cache = msLayerGetProcessingKey(lp, "FORCE_DRAW_LABEL_CACHE");
-      if (force_draw_label_cache &&
-	  strncasecmp(force_draw_label_cache,"FLUSH",5)==0) {
-	if(map->debug >= MS_DEBUGLEVEL_V)
-	  msDebug("msDrawMap(): PROCESSING FORCE_DRAW_LABEL_CACHE=FLUSH found.\n");
-	if(msDrawLabelCache(map, image) != MS_SUCCESS) {
-	  msFreeImage(image);
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-	  if (pasOWSReqInfo) {
-	    msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-	    msFree(pasOWSReqInfo);
-	  }
-#endif /* USE_WMS_LYR || USE_WFS_LYR */
-	  return(NULL);
-	}
-	msFreeLabelCache(&(map->labelcache));
-	msInitLabelCache(&(map->labelcache));
-      } /* PROCESSING FORCE_DRAW_LABEL_CACHE */
-
-    }
-  }
-
-  if(map->scalebar.status == MS_EMBED && !map->scalebar.postlabelcache) {
-
-    /* We need to temporarily restore the original extent for drawing */
-    /* the scalebar as it uses the extent to recompute cellsize. */
-    if(map->gt.need_geotransform)
-      msMapRestoreRealExtent(map);
-
-
-    if(MS_SUCCESS != msEmbedScalebar(map, image)) {
-      msFreeImage( image );
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-      /* Cleanup WMS/WFS Request stuff */
-      if (pasOWSReqInfo) {
-         msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-         msFree(pasOWSReqInfo);
-      }
-#endif
-      return NULL;
-    }
-
-
-    if(map->gt.need_geotransform)
-      msMapSetFakedExtent(map);
-  }
-
-  if(map->legend.status == MS_EMBED && !map->legend.postlabelcache) {
-    if( msEmbedLegend(map, image) != MS_SUCCESS ) {
-      msFreeImage( image );
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-      /* Cleanup WMS/WFS Request stuff */
-      if (pasOWSReqInfo) {
-         msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-         msFree(pasOWSReqInfo);
-      }
-#endif
-      return NULL;
-    }
-  }
-
-  if(msDrawLabelCache(map, image) != MS_SUCCESS) {
-    msFreeImage(image);
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-    if (pasOWSReqInfo) {
-      msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-      msFree(pasOWSReqInfo);
-    }
-#endif /* USE_WMS_LYR || USE_WFS_LYR */
-    return(NULL);
-  }
-
-
-  for(i=0; i<map->numlayers; i++) { /* for each layer, check for postlabelcache layers */
-
-    lp = (GET_LAYER(map, map->layerorder[i]));
-
-    if(!lp->postlabelcache) continue;
-    if(!msLayerIsVisible(map, lp)) continue;
-
-    if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING) msGettimeofday(&starttime, NULL);
-
-    if(lp->connectiontype == MS_WMS) {
-#ifdef USE_WMS_LYR
-      if(MS_RENDERER_PLUGIN(image->format) || MS_RENDERER_RAWDATA(image->format))
-      {
-        assert(pasOWSReqInfo);
-        status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo, numOWSRequests, map, lp, image);
-      }
-
-#else
-      status = MS_FAILURE;
-#endif
-    } else {
-      if(querymap)
-        status = msDrawQueryLayer(map, lp, image);
-      else
-        status = msDrawLayer(map, lp, image);
-    }
-
-    if(status == MS_FAILURE) {
-      msFreeImage(image);
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-      if (pasOWSReqInfo) {
-        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-        msFree(pasOWSReqInfo);
-      }
-#endif /* USE_WMS_LYR || USE_WFS_LYR */
-      return(NULL);
-    }
-
-    if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING) {
-      msGettimeofday(&endtime, NULL);
-      msDebug("msDrawMap(): Layer %d (%s), %.3fs\n",
-              map->layerorder[i], lp->name?lp->name:"(null)",
-              (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-              (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-    }
-
-  }
-
-  /* Do we need to fake out stuff for rotated support? */
-  /* This really needs to be done on every preceeding exit point too... */
-  if(map->gt.need_geotransform)
-    msMapRestoreRealExtent(map);
-
-  if(map->legend.status == MS_EMBED && map->legend.postlabelcache)
-    if(MS_UNLIKELY(MS_FAILURE == msEmbedLegend(map, image))) {
-      msFreeImage( image );
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-      /* Cleanup WMS/WFS Request stuff */
-      if (pasOWSReqInfo) {
-        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-        msFree(pasOWSReqInfo);
-      }
-#endif
-      return NULL;
-    }
-
-  if(map->scalebar.status == MS_EMBED && map->scalebar.postlabelcache) {
-
-    /* We need to temporarily restore the original extent for drawing */
-    /* the scalebar as it uses the extent to recompute cellsize. */
-    if(map->gt.need_geotransform)
-      msMapRestoreRealExtent(map);
-
-    if(MS_SUCCESS != msEmbedScalebar(map, image)) {
-      msFreeImage( image );
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-      /* Cleanup WMS/WFS Request stuff */
-      if (pasOWSReqInfo) {
-         msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-         msFree(pasOWSReqInfo);
-      }
-#endif
-      return NULL;
-    }
-
-
-    if(map->gt.need_geotransform)
-      msMapSetFakedExtent(map);
-  }
-
-#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-  /* Cleanup WMS/WFS Request stuff */
-  if (pasOWSReqInfo) {
-    msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-    msFree(pasOWSReqInfo);
-  }
-#endif
-
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&mapendtime, NULL);
-    msDebug("msDrawMap() total time: %.3fs\n",
-            (mapendtime.tv_sec+mapendtime.tv_usec/1.0e6)-
-            (mapstarttime.tv_sec+mapstarttime.tv_usec/1.0e6) );
-  }
-
-  return(image);
-}
-
-/*
- * Test whether a layer should be drawn or not in the current map view and
- * at the current scale.
- * Returns TRUE if layer is visible, FALSE if not.
-*/
-int msLayerIsVisible(mapObj *map, layerObj *layer)
-{
-  int i;
-
-  if(!layer->data && !layer->tileindex && !layer->connection && !layer->features && !layer->grid)
-    return(MS_FALSE); /* no data associated with this layer, not an error since layer may be used as a template from MapScript */
-
-  if(layer->type == MS_LAYER_QUERY || layer->type == MS_LAYER_TILEINDEX) return(MS_FALSE);
-  if((layer->status != MS_ON) && (layer->status != MS_DEFAULT)) return(MS_FALSE);
-
-  /* Do comparisons of layer scale vs map scale now, since msExtentsOverlap() */
-  /* can be slow */
-  if(map->scaledenom > 0) {
-
-    /* layer scale boundaries should be checked first */
-    if((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.MAXSCALE is too small for this MAP scale\n", layer->name);
-      }
-      return(MS_FALSE);
-    }
-    if(/*(layer->minscaledenom > 0) &&*/ (map->scaledenom <= layer->minscaledenom)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.MINSCALE is too large for this MAP scale\n", layer->name);
-      }
-      return(MS_FALSE);
-    }
-  }
-
-  /* Only return MS_FALSE if it is definitely false. Sometimes it will return MS_UNKNOWN, which we
-  ** consider true, for this use case (it might be visible, try and draw it, see what happens). */
-  if ( msExtentsOverlap(map, layer) == MS_FALSE ) {
-    if( layer->debug >= MS_DEBUGLEVEL_V ) {
-      msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.EXTENT does not intersect MAP.EXTENT\n", layer->name);
-    }
-    return(MS_FALSE);
-  }
-
-  if(msEvalContext(map, layer, layer->requires) == MS_FALSE) return(MS_FALSE);
-
-  if(map->scaledenom > 0) {
-
-    /* now check class scale boundaries (all layers *must* pass these tests) */
-    if(layer->numclasses > 0) {
-      for(i=0; i<layer->numclasses; i++) {
-        if((layer->class[i]->maxscaledenom > 0) && (map->scaledenom > layer->class[i]->maxscaledenom))
-          continue; /* can skip this one, next class */
-        if((layer->class[i]->minscaledenom > 0) && (map->scaledenom <= layer->class[i]->minscaledenom))
-          continue; /* can skip this one, next class */
-
-        break; /* can't skip this class (or layer for that matter) */
-      }
-      if(i == layer->numclasses) {
-        if( layer->debug >= MS_DEBUGLEVEL_V ) {
-          msDebug("msLayerIsVisible(): Skipping layer (%s) because no CLASS in the layer is in-scale for this MAP scale\n", layer->name);
-        }
-        return(MS_FALSE);
-      }
-    }
-
-  }
-
-  if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
-    if((layer->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width is much smaller than map width\n", layer->name);
-      }
-      return(MS_FALSE);
-    }
-    if((layer->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width is much larger than map width\n", layer->name);
-      }
-      return(MS_FALSE);
-    }
-  }
-
-  return MS_TRUE;  /* All tests passed.  Layer is visible. */
-}
-
-
-#define LAYER_NEEDS_COMPOSITING(layer) (((layer)->compositer != NULL) && ((layer)->compositer->next || (layer)->compositor->opacity < 100 || (layer)->compositor->compop != MS_COMPOP_SRC_OVER || (layer)->compositer->filter ))
-/*
- * Generic function to render a layer object.
-*/
-int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  imageObj *image_draw = image;
-  outputFormatObj *altFormat=NULL;
-  int retcode=MS_SUCCESS;
-  const char *alternativeFomatString = NULL;
-  layerObj *maskLayer = NULL;
-
-  if(!msLayerIsVisible(map, layer))
-    return MS_SUCCESS;
-
-  if(layer->compositer && !layer->compositer->next && layer->compositer->opacity == 0) return MS_SUCCESS; /* layer is completely transparent, skip it */
-  
-
-  /* conditions may have changed since this layer last drawn, so retest
-     layer->project (Bug #673) */
-  layer->project = msProjectionsDiffer(&(layer->projection),&(map->projection));
-
-  /* make sure labelcache setting is set correctly if postlabelcache is set. This is done by the parser but
-     may have been altered by a mapscript. see #5142 */
-  if(layer->postlabelcache) {
-    layer->labelcache = MS_FALSE;
-  }
-
-  if(layer->mask) {
-    int maskLayerIdx;
-    /* render the mask layer in its own imageObj */
-    if(!MS_IMAGE_RENDERER(image)->supports_pixel_buffer) {
-      msSetError(MS_MISCERR, "Layer (%s) references references a mask layer, but the selected renderer does not support them", "msDrawLayer()",
-                 layer->name);
-      return (MS_FAILURE);
-    }
-    maskLayerIdx = msGetLayerIndex(map,layer->mask);
-    if(maskLayerIdx == -1) {
-      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)", "msDrawLayer()",
-                 layer->name,layer->mask);
-      return (MS_FAILURE);
-    }
-    maskLayer = GET_LAYER(map, maskLayerIdx);
-    if(!maskLayer->maskimage) {
-      int i;
-      int origstatus, origlabelcache;
-      altFormat =  msSelectOutputFormat(map, "png24");
-      msInitializeRendererVTable(altFormat);
-      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg */
-      maskLayer->maskimage= msImageCreate(image->width, image->height,altFormat,
-                                          image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
-      if (!maskLayer->maskimage) {
-        msSetError(MS_MISCERR, "Unable to initialize mask image.", "msDrawLayer()");
-        return (MS_FAILURE);
-      }
-
-      /*
-       * force the masked layer to status on, and turn off the labelcache so that
-       * eventual labels are added to the temporary image instead of being added
-       * to the labelcache
-       */
-      origstatus = maskLayer->status;
-      origlabelcache = maskLayer->labelcache;
-      maskLayer->status = MS_ON;
-      maskLayer->labelcache = MS_OFF;
-
-      /* draw the mask layer in the temporary image */
-      retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
-      maskLayer->status = origstatus;
-      maskLayer->labelcache = origlabelcache;
-      if(retcode != MS_SUCCESS) {
-        return MS_FAILURE;
-      }
-      /*
-       * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-       * symbols that reference it. We want to remove those references before the altFormat is destroyed
-       * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-       * it's for him.
-       */
-      for(i=0; i<map->symbolset.numsymbols; i++) {
-        if (map->symbolset.symbol[i]!=NULL) {
-          symbolObj *s = map->symbolset.symbol[i];
-          if(s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
-            MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
-            s->renderer = NULL;
-          }
-        }
-      }
-      /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
-      msFree(map->imagetype);
-      map->imagetype = msStrdup(image->format->name);
-    }
-
-  }
-  altFormat = NULL;
-  /* inform the rendering device that layer draw is starting. */
-  msImageStartLayer(map, layer, image);
-
-
-  /*check if an alternative renderer should be used for this layer*/
-  alternativeFomatString = msLayerGetProcessingKey( layer, "RENDERER");
-  if (MS_RENDERER_PLUGIN(image_draw->format) && alternativeFomatString!=NULL &&
-      (altFormat=  msSelectOutputFormat(map, alternativeFomatString))) {
-    rendererVTableObj *renderer=NULL;
-    msInitializeRendererVTable(altFormat);
-
-    image_draw = msImageCreate(image->width, image->height,
-                               altFormat, image->imagepath, image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
-    renderer = MS_IMAGE_RENDERER(image_draw);
-    renderer->startLayer(image_draw,map,layer);
-  } else if (MS_RENDERER_PLUGIN(image_draw->format)) {
-    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
-    if ((layer->mask && layer->connectiontype!=MS_WMS && layer->type != MS_LAYER_RASTER) || layer->compositer) {
-      /* masking occurs at the pixel/layer level for raster images, so we don't need to create a temporary image
-       in these cases
-       */
-      if (layer->mask || renderer->compositeRasterBuffer) {
-        image_draw = msImageCreate(image->width, image->height,
-                                   image->format, image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
-        if (!image_draw) {
-          msSetError(MS_MISCERR, "Unable to initialize temporary transparent image.",
-                     "msDrawLayer()");
-          return (MS_FAILURE);
-        }
-        image_draw->map = map;
-        renderer->startLayer(image_draw,map,layer);
-      }
-    }
-  }
-  /*
-  ** redirect procesing of some layer types.
-  */
-  if(layer->connectiontype == MS_WMS) {
-#ifdef USE_WMS_LYR
-    retcode = msDrawWMSLayer(map, layer, image_draw);
-#else
-    retcode = MS_FAILURE;
-#endif
-  } else if(layer->type == MS_LAYER_RASTER) {
-    retcode = msDrawRasterLayer(map, layer, image_draw);
-  } else if(layer->type == MS_LAYER_CHART) {
-    retcode = msDrawChartLayer(map, layer, image_draw);
-  } else {   /* must be a Vector layer */
-    retcode = msDrawVectorLayer(map, layer, image_draw);
-  }
-
-  if (altFormat) {
-    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-    rendererVTableObj *altrenderer = MS_IMAGE_RENDERER(image_draw);
-    rasterBufferObj rb;
-    int i;
-    memset(&rb,0,sizeof(rasterBufferObj));
-
-    altrenderer->endLayer(image_draw,map,layer);
-
-    retcode = altrenderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
-      goto altformat_cleanup;
-    }
-    retcode = renderer->mergeRasterBuffer(image,&rb,((layer->compositer)?(layer->compositer->opacity*0.01):(1.0)),0,0,0,0,rb.width,rb.height);
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
-      goto altformat_cleanup;
-    }
-
-altformat_cleanup:
-    /*
-     * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-     * symbols that reference it. We want to remove those references before the altFormat is destroyed
-     * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-     * it's for him.
-     */
-    for(i=0; i<map->symbolset.numsymbols; i++) {
-      if (map->symbolset.symbol[i]!=NULL) {
-        symbolObj *s = map->symbolset.symbol[i];
-        if(s->renderer == altrenderer) {
-          altrenderer->freeSymbol(s);
-          s->renderer = NULL;
-        }
-      }
-    }
-    msFreeImage(image_draw);
-    /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
-    msFree(map->imagetype);
-    map->imagetype = msStrdup(image->format->name);
-  } else if( image != image_draw) {
-    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
-    rasterBufferObj rb;
-    memset(&rb,0,sizeof(rasterBufferObj));
-
-    renderer->endLayer(image_draw,map,layer);
-
-    retcode = renderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
-      goto imagedraw_cleanup;
-    }
-    if(maskLayer && maskLayer->maskimage) {
-      rasterBufferObj mask;
-      unsigned int row,col;
-      memset(&mask,0,sizeof(rasterBufferObj));
-      retcode = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,&mask);
-      if(MS_UNLIKELY(retcode == MS_FAILURE)) {
-        goto imagedraw_cleanup;
-      }
-      /* modify the pixels of the overlay */
-
-      if(rb.type == MS_BUFFER_BYTE_RGBA) {
-        for(row=0; row<rb.height; row++) {
-          unsigned char *ma,*a,*r,*g,*b;
-          r=rb.data.rgba.r+row*rb.data.rgba.row_step;
-          g=rb.data.rgba.g+row*rb.data.rgba.row_step;
-          b=rb.data.rgba.b+row*rb.data.rgba.row_step;
-          a=rb.data.rgba.a+row*rb.data.rgba.row_step;
-          ma=mask.data.rgba.a+row*mask.data.rgba.row_step;
-          for(col=0; col<rb.width; col++) {
-            if(*ma == 0) {
-              *a = *r = *g = *b = 0;
-            }
-            a+=rb.data.rgba.pixel_step;
-            r+=rb.data.rgba.pixel_step;
-            g+=rb.data.rgba.pixel_step;
-            b+=rb.data.rgba.pixel_step;
-            ma+=mask.data.rgba.pixel_step;
-          }
-        }
-      }
-    }
-    if(!layer->compositer) {
-      /*we have a mask layer with no composition configured, do a nomral blend */
-      retcode = renderer->mergeRasterBuffer(image,&rb,1.0,0,0,0,0,rb.width,rb.height);
-    } else {
-      retcode = msCompositeRasterBuffer(map,image,&rb,layer->compositer);
-    }
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
-      goto imagedraw_cleanup;
-    }
-
-imagedraw_cleanup:
-    msFreeImage(image_draw);
-  }
-
-  msImageEndLayer(map,layer,image);
-  return(retcode);
-}
-
-int msDrawVectorLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  int         status, retcode=MS_SUCCESS;
-  int         drawmode=MS_DRAWMODE_FEATURES;
-  char        annotate=MS_TRUE;
-  shapeObj    shape;
-  shapeObj    savedShape;
-  rectObj     searchrect;
-  char        cache=MS_FALSE;
-  int         maxnumstyles=1;
-  featureListNodeObjPtr shpcache=NULL, current=NULL;
-  int nclasses = 0;
-  int *classgroup = NULL;
-  double minfeaturesize = -1;
-  int maxfeatures=-1;
-  int featuresdrawn=0;
-
-  if (image)
-    maxfeatures=msLayerGetMaxFeaturesToDraw(layer, image->format);
-
-  /* TODO TBT: draw as raster layer in vector renderers */
-
-  annotate = msEvalContext(map, layer, layer->labelrequires);
-  if(map->scaledenom > 0) {
-    if((layer->labelmaxscaledenom != -1) && (map->scaledenom >= layer->labelmaxscaledenom)) annotate = MS_FALSE;
-    if((layer->labelminscaledenom != -1) && (map->scaledenom < layer->labelminscaledenom)) annotate = MS_FALSE;
-  }
-
-  /* open this layer */
-  status = msLayerOpen(layer);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  /* build item list. STYLEITEM javascript needs the shape attributes */
-  if (layer->styleitem && (strncasecmp(layer->styleitem, "javascript://", 13) == 0)) {  
-    status = msLayerWhichItems(layer, MS_TRUE, NULL);
-  } else {
-    status = msLayerWhichItems(layer, MS_FALSE, NULL);
-  }
-
-  if(status != MS_SUCCESS) {
-    msLayerClose(layer);
-    return MS_FAILURE;
-  }
-
-  /* identify target shapes */
-  if(layer->transform == MS_TRUE) {
-    searchrect = map->extent;
-
-    if((map->projection.numargs > 0) && (layer->projection.numargs > 0)) {
-      int bDone = MS_FALSE;
-
-      if( layer->connectiontype == MS_UVRASTER )
-      {
-          /* Nasty hack to make msUVRASTERLayerWhichShapes() aware that the */
-          /* original area of interest is (map->extent, map->projection)... */
-          /* Useful when dealin with UVRASTER that extend beyond 180 deg */
-          msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes( layer, map );
-
-          searchrect = msUVRASTERGetSearchRect( layer, map );
-          bDone = MS_TRUE;
-      }
-
-      if( !bDone )
-        msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-    }
-
-  } else {
-    searchrect.minx = searchrect.miny = 0;
-    searchrect.maxx = map->width-1;
-    searchrect.maxy = map->height-1;
-  }
-
-  status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-
-  if( layer->connectiontype == MS_UVRASTER )
-  {
-    msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes( layer, NULL );
-  }
-
-  if(status == MS_DONE) { /* no overlap */
-    msLayerClose(layer);
-    return MS_SUCCESS;
-  } else if(status != MS_SUCCESS) {
-    msLayerClose(layer);
-    return MS_FAILURE;
-  }
-
-  nclasses = 0;
-  classgroup = NULL;
-  if(layer->classgroup && layer->numclasses > 0)
-    classgroup = msAllocateValidClassGroups(layer, &nclasses);
-
-  if(layer->minfeaturesize > 0)
-    minfeaturesize = Pix2LayerGeoref(map, layer, layer->minfeaturesize);
-
-  // Select how to render classes
-  //    MS_FIRST_MATCHING_CLASS: Default and historic MapServer behavior
-  //    MS_ALL_MATCHING_CLASSES: SLD behavior
-  int ref_rendermode;
-  const char * rendermodestr = msLayerGetProcessingKey(layer, "RENDERMODE");
-  if (layer->rendermode == MS_ALL_MATCHING_CLASSES)
-  {
-    // SLD takes precedence
-    ref_rendermode = MS_ALL_MATCHING_CLASSES;
-  }
-  else if (!rendermodestr)
-  {
-    // Default Mapfile
-    ref_rendermode = MS_FIRST_MATCHING_CLASS;
-  }
-  else if (!strcmp(rendermodestr,"FIRST_MATCHING_CLASS"))
-  {
-    // Explicit default Mapfile
-    ref_rendermode = MS_FIRST_MATCHING_CLASS;
-  }
-  else if (!strcmp(rendermodestr,"ALL_MATCHING_CLASSES"))
-  {
-    // SLD-like Mapfile
-    ref_rendermode = MS_ALL_MATCHING_CLASSES;
-  }
-  else
-  {
-    msLayerClose(layer);
-    msSetError(MS_MISCERR,
-    "Unknown RENDERMODE: %s, should be one of: FIRST_MATCHING_CLASS, ALL_MATCHING_CLASSES.",
-    "msDrawVectorLayer()",
-    rendermodestr);
-    return MS_FAILURE;
-  }
-
-  /* step through the target shapes and their classes */
-  msInitShape(&shape);
-  int classindex = -1;
-  int classcount = 0;
-  for (;;) {
-    int rendermode;
-    if (classindex == -1) {
-      msFreeShape(&shape);
-      status = msLayerNextShape(layer, &shape);
-      if (status != MS_SUCCESS) {
-        break;
-      }
-
-      /* Check if the shape size is ok to be drawn */
-      if((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) && (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE)) {
-        if(layer->debug >= MS_DEBUGLEVEL_V)
-          msDebug("msDrawVectorLayer(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
-        continue;
-      }
-      classcount = 0;
-    }
-
-    classindex = msShapeGetNextClass(classindex, layer, map, &shape, classgroup, nclasses);
-    if((classindex == -1) || (layer->class[classindex]->status == MS_OFF)) {
-      continue;
-    }
-    shape.classindex = classindex;
-
-    // When only one class is applicable, rendering mode is forced to its default,
-    // i.e. only the first applicable class is actually applied. As a consequence,
-    // cache can be enabled when relevant.
-    classcount++;
-    rendermode = ref_rendermode;
-    if ((classcount == 1) && (msShapeGetNextClass(classindex, layer, map, &shape, classgroup, nclasses) == -1))
-    {
-      rendermode = MS_FIRST_MATCHING_CLASS;
-    }
-
-    if (rendermode == MS_FIRST_MATCHING_CLASS)
-    {
-      classindex = -1;
-    }
-
-    if(maxfeatures >=0 && featuresdrawn >= maxfeatures) {
-      status = MS_DONE;
-      break;
-    }
-    featuresdrawn++;
-
-    cache = MS_FALSE;
-    if(layer->type == MS_LAYER_LINE && (layer->class[shape.classindex]->numstyles > 1 || (layer->class[shape.classindex]->numstyles == 1 && layer->class[shape.classindex]->styles[0]->outlinewidth > 0))) {
-      int i;
-      cache = MS_TRUE; /* only line layers with multiple styles need be cached (I don't think POLYLINE layers need caching - SDL) */
-
-      /* we can't handle caching with attribute binding other than for the first style (#3976) */
-      for(i=1; i<layer->class[shape.classindex]->numstyles; i++) {
-        if(layer->class[shape.classindex]->styles[i]->numbindings > 0) cache = MS_FALSE;
-      }
-    }
-
-    /* With 'STYLEITEM AUTO', we will have the datasource fill the class' */
-    /* style parameters for this shape. */
-    if(layer->styleitem) {
-      if(strcasecmp(layer->styleitem, "AUTO") == 0) {
-        if(msLayerGetAutoStyle(map, layer, layer->class[shape.classindex], &shape) != MS_SUCCESS) {
-          retcode = MS_FAILURE;
-          break;
-        }
-      } else {
-        /* Generic feature style handling as per RFC-61 */
-        if(msLayerGetFeatureStyle(map, layer, layer->class[shape.classindex], &shape) != MS_SUCCESS) {
-          retcode = MS_FAILURE;
-          break;
-        }
-      }
-
-      /* __TODO__ For now, we can't cache features with 'AUTO' style */
-      cache = MS_FALSE;
-    }
-
-    if (rendermode == MS_ALL_MATCHING_CLASSES)
-    {
-      // Cache is designed to handle only one class. Therefore it is
-      // disabled when using SLD "painters model" rendering mode.
-      cache = MS_FALSE;
-    }
-
-    /* RFC77 TODO: check return value, may need a more sophisticated if-then test. */
-    if(annotate && layer->class[shape.classindex]->numlabels > 0) {
-      drawmode |= MS_DRAWMODE_LABELS;
-      if (msLayerGetProcessingKey(layer, "LABEL_NO_CLIP")) {
-        drawmode |= MS_DRAWMODE_UNCLIPPEDLABELS;
-      }
-    }
-
-    if (layer->type == MS_LAYER_LINE && msLayerGetProcessingKey(layer, "POLYLINE_NO_CLIP")) {
-      drawmode |= MS_DRAWMODE_UNCLIPPEDLINES;
-    }
-
-    if (rendermode == MS_ALL_MATCHING_CLASSES)
-    {
-      // In SLD "painters model" rendering mode, all applicable classes are actually applied.
-      // Coordinates stored in the shape must keep their original values for
-      // the shape to be drawn multiple times.
-      // Here the original shape is saved.
-      msInitShape(&savedShape);
-      msCopyShape(&shape, &savedShape);
-    }
-
-    if (cache) {
-      styleObj *pStyle = layer->class[shape.classindex]->styles[0];
-      if (pStyle->outlinewidth > 0) {
-        /*
-         * RFC 49 implementation
-         * if an outlinewidth is used:
-         *  - augment the style's width to account for the outline width
-         *  - swap the style color and outlinecolor
-         *  - draw the shape (the outline) in the first pass of the
-         *    caching mechanism
-         */
-	msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
-      }
-      status = msDrawShape(map, layer, &shape, image, 0, drawmode|MS_DRAWMODE_SINGLESTYLE); /* draw a single style */
-      if (pStyle->outlinewidth > 0) {
-        /*
-         * RFC 49 implementation: switch back the styleobj to its
-         * original state, so the line fill will be drawn in the
-         * second pass of the caching mechanism
-         */
-	msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
-      }
-    }
-
-    else
-      status = msDrawShape(map, layer, &shape, image, -1, drawmode); /* all styles  */
-
-    if (rendermode == MS_ALL_MATCHING_CLASSES)
-    {
-      // In SLD "painters model" rendering mode, all applicable classes are actually applied.
-      // Coordinates stored in the shape must keep their original values for
-      // the shape to be drawn multiple times.
-      // Here the original shape is restored.
-      msFreeShape(&shape);
-      msCopyShape(&savedShape, &shape);
-      msFreeShape(&savedShape);
-    }
-
-    if(status != MS_SUCCESS) {
-      retcode = MS_FAILURE;
-      break;
-    }
-    
-    if(shape.numlines == 0) { /* once clipped the shape didn't need to be drawn */
-      continue;
-    }
-
-    if(cache) {
-      if(insertFeatureList(&shpcache, &shape) == NULL) {
-        retcode = MS_FAILURE; /* problem adding to the cache */
-        break;
-      }
-    }
-
-    maxnumstyles = MS_MAX(maxnumstyles, layer->class[shape.classindex]->numstyles);
-
-  }
-  msFreeShape(&shape);
-
-  if (classgroup)
-    msFree(classgroup);
-
-  if(status != MS_DONE || retcode == MS_FAILURE) {
-    msLayerClose(layer);
-    if(shpcache) {
-      freeFeatureList(shpcache);
-      shpcache = NULL;
-    }
-    return MS_FAILURE;
-  }
-
-  if(shpcache && MS_DRAW_FEATURES(drawmode)) {
-    int s;
-    for(s=0; s<maxnumstyles; s++) {
-      for(current=shpcache; current; current=current->next) {
-        if(layer->class[current->shape.classindex]->numstyles > s) {
-          styleObj *pStyle = layer->class[current->shape.classindex]->styles[s];
-          if(pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
-            continue; /*skip this as it has already been rendered*/
-          if(map->scaledenom > 0) {
-            if((pStyle->maxscaledenom != -1) && (map->scaledenom >= pStyle->maxscaledenom))
-              continue;
-            if((pStyle->minscaledenom != -1) && (map->scaledenom < pStyle->minscaledenom))
-              continue;
-          }
-          if(s==0 && pStyle->outlinewidth>0 && MS_VALID_COLOR(pStyle->color)) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
-              return MS_FAILURE;
-            }
-          } else if(s>0) {
-            if (pStyle->outlinewidth > 0 && MS_VALID_COLOR(pStyle->outlinecolor)) {
-              /*
-               * RFC 49 implementation
-               * if an outlinewidth is used:
-               *  - augment the style's width to account for the outline width
-               *  - swap the style color and outlinecolor
-               *  - draw the shape (the outline) in the first pass of the
-               *    caching mechanism
-               */
-	      msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
-                return MS_FAILURE;
-              }
-              /*
-               * RFC 49 implementation: switch back the styleobj to its
-               * original state, so the line fill will be drawn in the
-               * second pass of the caching mechanism
-               */
-	      msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
-            }
-            /* draw a valid line, i.e. one with a color defined or of type pixmap*/
-            if(MS_VALID_COLOR(pStyle->color) || 
-                    (
-                      pStyle->symbol<map->symbolset.numsymbols &&
-                      ( 
-                        map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_PIXMAP ||
-                        map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_SVG
-                      )
-                    )
-              ) {
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor)))
-                return MS_FAILURE;
-            }
-          }
-        }
-      }
-    }
-
-    freeFeatureList(shpcache);
-    shpcache = NULL;
-  }
-
-  msLayerClose(layer);
-  return MS_SUCCESS;
-
-}
-
-/*
-** Function to draw a layer IF it already has a result cache associated with it. Called by msDrawMap and via MapScript.
-*/
-int msDrawQueryLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  int i, status;
-  char annotate=MS_TRUE, cache=MS_FALSE;
-  int drawmode = MS_DRAWMODE_FEATURES;
-  shapeObj shape;
-  int maxnumstyles=1;
-
-  featureListNodeObjPtr shpcache=NULL, current=NULL;
-
-  colorObj *colorbuffer = NULL;
-  int *mindistancebuffer = NULL;
-
-  if(!layer->resultcache) return(msDrawLayer(map, layer, image));
-
-  if(!msLayerIsVisible(map, layer)) return(MS_SUCCESS); /* not an error, just nothing to do */
-
-  /* conditions may have changed since this layer last drawn, so reset
-     layer->project to recheck projection needs (Bug #673) */
-  layer->project = msProjectionsDiffer(&(layer->projection),&(map->projection));
-
-  /* set annotation status */
-  annotate = msEvalContext(map, layer, layer->labelrequires);
-  if(map->scaledenom > 0) {
-    if((layer->labelmaxscaledenom != -1) && (map->scaledenom >= layer->labelmaxscaledenom)) annotate = MS_FALSE;
-    if((layer->labelminscaledenom != -1) && (map->scaledenom < layer->labelminscaledenom)) annotate = MS_FALSE;
-  }
-
-  /*
-  ** Certain query map styles require us to render all features only (MS_NORMAL) or first (MS_HILITE). With
-  ** single-pass queries we have to make a copy of the layer and work from it instead.
-  */
-  if(map->querymap.style == MS_NORMAL || map->querymap.style == MS_HILITE) {
-    layerObj tmp_layer;
-
-    if(initLayer(&tmp_layer, map) == -1)
-      return(MS_FAILURE);
-
-    if (msCopyLayer(&tmp_layer, layer) != MS_SUCCESS)
-      return(MS_FAILURE);
-
-    /* disable the connection pool for this layer */
-    msLayerSetProcessingKey(&tmp_layer, "CLOSE_CONNECTION", "ALWAYS");
-
-    status = msDrawLayer(map, &tmp_layer, image);
-
-    freeLayer(&tmp_layer);
-
-    if(map->querymap.style == MS_NORMAL || status != MS_SUCCESS) return(status);
-  }
-
-  /* if MS_HILITE, alter the one style (always at least 1 style), and set a MINDISTANCE for the labelObj to avoid duplicates */
-  if(map->querymap.style == MS_HILITE) {
-
-    drawmode |= MS_DRAWMODE_QUERY;
-
-    if (layer->numclasses > 0) {
-      colorbuffer = (colorObj*)msSmallMalloc(layer->numclasses*sizeof(colorObj));
-      mindistancebuffer = (int*)msSmallMalloc(layer->numclasses*sizeof(int));
-    }
-
-    for(i=0; i<layer->numclasses; i++) {
-      if(layer->type == MS_LAYER_POLYGON && layer->class[i]->numstyles > 0) { /* alter BOTTOM style since that's almost always the fill */
-        if (layer->class[i]->styles == NULL) {
-          msSetError(MS_MISCERR, "Don't know how to draw class %s of layer %s without a style definition.", "msDrawQueryLayer()", layer->class[i]->name, layer->name);
-          msFree(colorbuffer);
-          msFree(mindistancebuffer);
-          return(MS_FAILURE);
-        }
-        if(MS_VALID_COLOR(layer->class[i]->styles[0]->color)) {
-          colorbuffer[i] = layer->class[i]->styles[0]->color; /* save the color from the BOTTOM style */
-          layer->class[i]->styles[0]->color = map->querymap.color;
-        } else if(MS_VALID_COLOR(layer->class[i]->styles[0]->outlinecolor)) {
-          colorbuffer[i] = layer->class[i]->styles[0]->outlinecolor; /* if no color, save the outlinecolor from the BOTTOM style */
-          layer->class[i]->styles[0]->outlinecolor = map->querymap.color;
-        }
-      } else if (layer->type == MS_LAYER_LINE && layer->class[i]->numstyles > 0 && layer->class[i]->styles[0]->outlinewidth > 0) { /* alter BOTTOM style for lines with outlines */
-	if(MS_VALID_COLOR(layer->class[i]->styles[0]->color)) {
-          colorbuffer[i] = layer->class[i]->styles[0]->color; /* save the color from the BOTTOM style */
-          layer->class[i]->styles[0]->color = map->querymap.color;
-        } /* else ??? */
-      } else if (layer->class[i]->numstyles > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->color)) {
-          colorbuffer[i] = layer->class[i]->styles[layer->class[i]->numstyles-1]->color; /* save the color from the TOP style */
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->color = map->querymap.color;
-        } else if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor)) {
-          colorbuffer[i] = layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor; /* if no color, save the outlinecolor from the TOP style */
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor = map->querymap.color;
-        }
-      } else if (layer->class[i]->numlabels > 0) {
-          colorbuffer[i] = layer->class[i]->labels[0]->color;
-          layer->class[i]->labels[0]->color = map->querymap.color;
-      } /* else ??? */
-
-      mindistancebuffer[i] = -1; /* RFC77 TODO: only using the first label, is that cool? */
-      if(layer->class[i]->numlabels > 0) {
-        mindistancebuffer[i] = layer->class[i]->labels[0]->mindistance;
-        layer->class[i]->labels[0]->mindistance = MS_MAX(0, layer->class[i]->labels[0]->mindistance);
-      }
-    }
-  }
-
-  /*
-  ** Layer was opened as part of the query process, msLayerWhichItems() has also been run, shapes have been classified - start processing!
-  */
-
-  msInitShape(&shape);
-
-  for(i=0; i<layer->resultcache->numresults; i++) {
-    status = msLayerGetShape(layer, &shape, &(layer->resultcache->results[i]));
-    if(status != MS_SUCCESS) {
-      msFree(colorbuffer);
-      msFree(mindistancebuffer);
-      return(MS_FAILURE);
-    }
-
-    shape.classindex = layer->resultcache->results[i].classindex;
-    /* classindex may be -1 here if there was a template at the top level
-     * in this layer and the current shape selected even if it didn't
-     * match any class
-     *
-     * FrankW: classindex is also sometimes 0 even if there are no classes, so
-     * we are careful not to use out of range class values as an index.
-     */
-    if(shape.classindex==-1
-        || shape.classindex >= layer->numclasses
-        || layer->class[shape.classindex]->status == MS_OFF) {
-      msFreeShape(&shape);
-      continue;
-    }
-
-    cache = MS_FALSE;
-    if(layer->type == MS_LAYER_LINE && (layer->class[shape.classindex]->numstyles > 1 || (layer->class[shape.classindex]->numstyles == 1 && layer->class[shape.classindex]->styles[0]->outlinewidth > 0))) {
-      int i;
-      cache = MS_TRUE; /* only line layers with multiple styles need be cached (I don't think POLYLINE layers need caching - SDL) */
-
-      /* we can't handle caching with attribute binding other than for the first style (#3976) */
-      for(i=1; i<layer->class[shape.classindex]->numstyles; i++) {
-        if(layer->class[shape.classindex]->styles[i]->numbindings > 0) cache = MS_FALSE;
-      }
-    }
-
-    if(annotate && layer->class[shape.classindex]->numlabels > 0) {
-      drawmode |= MS_DRAWMODE_LABELS;
-    }
-
-    if(cache) {
-      styleObj *pStyle = layer->class[shape.classindex]->styles[0];
-      if (pStyle->outlinewidth > 0) msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
-      status = msDrawShape(map, layer, &shape, image, 0, drawmode|MS_DRAWMODE_SINGLESTYLE); /* draw only the first style */
-      if (pStyle->outlinewidth > 0) msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
-    } else {
-      status = msDrawShape(map, layer, &shape, image, -1, drawmode); /* all styles  */
-    }
-    if(status != MS_SUCCESS) {
-      msLayerClose(layer);
-      msFree(colorbuffer);
-      msFree(mindistancebuffer);
-      return(MS_FAILURE);
-    }
-
-    if(shape.numlines == 0) { /* once clipped the shape didn't need to be drawn */
-      msFreeShape(&shape);
-      continue;
-    }
-
-    if(cache) {
-      if(insertFeatureList(&shpcache, &shape) == NULL) {
-        msFree(colorbuffer);
-        msFree(mindistancebuffer);
-        return(MS_FAILURE); /* problem adding to the cache */
-      }
-    }
-
-    maxnumstyles = MS_MAX(maxnumstyles, layer->class[shape.classindex]->numstyles);
-    msFreeShape(&shape);
-  }
-
-  if(shpcache) {
-    int s;
-    for(s=0; s<maxnumstyles; s++) {
-      for(current=shpcache; current; current=current->next) {
-        if(layer->class[current->shape.classindex]->numstyles > s) {
-          styleObj *pStyle = layer->class[current->shape.classindex]->styles[s];
-          if(pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
-            continue; /* skip this as it has already been rendered */
-          if(map->scaledenom > 0) {
-            if((pStyle->maxscaledenom != -1) && (map->scaledenom >= pStyle->maxscaledenom))
-              continue;
-            if((pStyle->minscaledenom != -1) && (map->scaledenom < pStyle->minscaledenom))
-              continue;
-          }
-          if(s==0 && pStyle->outlinewidth>0 && MS_VALID_COLOR(pStyle->color)) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
-              return MS_FAILURE;
-            }
-          } else if(s>0) {
-            if (pStyle->outlinewidth > 0 && MS_VALID_COLOR(pStyle->outlinecolor)) {
-              msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
-                return MS_FAILURE;
-              }
-              msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
-            }
-            /* draw a valid line, i.e. one with a color defined or of type pixmap */
-            if(MS_VALID_COLOR(pStyle->color) || (pStyle->symbol<map->symbolset.numsymbols && (map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_PIXMAP || map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_SVG))) {
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor)))
-                return MS_FAILURE;
-            }
-          }
-        }
-      }
-    }
-
-    freeFeatureList(shpcache);
-    shpcache = NULL;
-  }
-
-  /* if MS_HILITE, restore color and mindistance values */
-  if(map->querymap.style == MS_HILITE) {
-    for(i=0; i<layer->numclasses; i++) {
-      if(layer->type == MS_LAYER_POLYGON && layer->class[i]->numstyles > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[0]->color))
-          layer->class[i]->styles[0]->color = colorbuffer[i];
-        else if(MS_VALID_COLOR(layer->class[i]->styles[0]->outlinecolor))
-          layer->class[i]->styles[0]->outlinecolor = colorbuffer[i]; /* if no color, restore outlinecolor for the BOTTOM style */
-      } else if (layer->type == MS_LAYER_LINE && layer->class[i]->numstyles > 0 && layer->class[i]->styles[0]->outlinewidth > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[0]->color))
-	  layer->class[i]->styles[0]->color = colorbuffer[i];
-      } else if (layer->class[i]->numstyles > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->color))
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->color = colorbuffer[i];
-        else if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor))
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor = colorbuffer[i]; /* if no color, restore outlinecolor for the TOP style */
-      } else if (layer->class[i]->numlabels > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->labels[0]->color))
-          layer->class[i]->labels[0]->color = colorbuffer[i];
-      }
-
-      if(layer->class[i]->numlabels > 0)
-        layer->class[i]->labels[0]->mindistance = mindistancebuffer[i]; /* RFC77 TODO: again, only using the first label, is that cool? */
-    }
-
-    msFree(colorbuffer);
-    msFree(mindistancebuffer);
-  }
-
-  return(MS_SUCCESS);
-}
-
-/**
- * msDrawRasterLayerPlugin()
- */
-
-static int
-msDrawRasterLayerPlugin( mapObj *map, layerObj *layer, imageObj *image)
-
-{
-  rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-  rasterBufferObj  *rb = msSmallCalloc(1,sizeof(rasterBufferObj));
-  int ret;
-  if( renderer->supports_pixel_buffer ) {
-    if (MS_SUCCESS != renderer->getRasterBufferHandle( image, rb )) {
-      msSetError(MS_MISCERR,"renderer failed to extract raster buffer","msDrawRasterLayer()");
-      return MS_FAILURE;
-    }
-    ret = msDrawRasterLayerLow( map, layer, image, rb );
-  } else {
-    if (MS_SUCCESS != renderer->initializeRasterBuffer( rb, image->width, image->height, MS_IMAGEMODE_RGBA )) {
-      msSetError(MS_MISCERR,"renderer failed to create raster buffer","msDrawRasterLayer()");
-      return MS_FAILURE;
-    }
-
-    ret = msDrawRasterLayerLow( map, layer, image, rb );
-
-    if( ret == 0 ) {
-      ret = renderer->mergeRasterBuffer( image, rb, 1.0, 0, 0, 0, 0, rb->width, rb->height );
-    }
-
-    msFreeRasterBuffer(rb);
-  }
-#define RB_GET_R(rb,x,y) *((rb)->data.rgba.r + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
-#define RB_GET_G(rb,x,y) *((rb)->data.rgba.g + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
-#define RB_GET_B(rb,x,y) *((rb)->data.rgba.b + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
-#define RB_GET_A(rb,x,y) *((rb)->data.rgba.a + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
-
-  free(rb);
-
-  return ret;
-}
-
-/**
- * Generic function to render raster layers.
- */
-int msDrawRasterLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  
-  int rv = MS_FAILURE;
-  if (!image || !map || !layer) {
-    return rv;
-  }
-
-  /* RFC-86 Scale dependant token replacements*/
-  rv = msLayerApplyScaletokens(layer,(layer->map)?layer->map->scaledenom:-1);
-  if (rv != MS_SUCCESS) return rv;
-  if( MS_RENDERER_PLUGIN(image->format) )
-    rv = msDrawRasterLayerPlugin(map, layer, image);
-  else if( MS_RENDERER_RAWDATA(image->format) )
-    rv = msDrawRasterLayerLow(map, layer, image, NULL);
-  msLayerRestoreFromScaletokens(layer);
-  return rv;
-}
-
-/**
- * msDrawWMSLayer()
- *
- * Draw a single WMS layer.
- * Multiple WMS layers in a map are preloaded and then drawn using
- * msDrawWMSLayerLow()
- */
-
-#ifdef USE_WMS_LYR
-int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  int nStatus = MS_FAILURE;
-
-  if (image && map && layer) {
-    /* ------------------------------------------------------------------
-     * Start by downloading the layer
-     * ------------------------------------------------------------------ */
-    httpRequestObj asReqInfo[2];
-    int numReq = 0;
-
-    msHTTPInitRequestObj(asReqInfo, 2);
-
-    if ( msPrepareWMSLayerRequest(1, map, layer, 1,
-                                  0, NULL, 0, 0, 0, NULL,
-                                  asReqInfo, &numReq) == MS_FAILURE  ||
-         msOWSExecuteRequests(asReqInfo, numReq, map, MS_TRUE) == MS_FAILURE ) {
-      return MS_FAILURE;
-    }
-
-    /* ------------------------------------------------------------------
-     * Then draw layer based on output format
-     * ------------------------------------------------------------------ */
-    if( MS_RENDERER_PLUGIN(image->format) )
-      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq,
-                                  map, layer, image) ;
-    else if( MS_RENDERER_RAWDATA(image->format) )
-      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq,
-                                  map, layer, image) ;
-
-    else {
-      msSetError(MS_WMSCONNERR,
-                 "Output format '%s' doesn't support WMS layers.",
-                 "msDrawWMSLayer()", image->format->name);
-      nStatus = MS_SUCCESS; /* Should we fail if output doesn't support WMS? */
-    }
-    /* Cleanup */
-    msHTTPFreeRequestObj(asReqInfo, numReq);
-  }
-
-  return nStatus;
-}
-#endif
-
-int circleLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer, shapeObj *shape)
-{
-  pointObj center;
-  double r;
-  int s;
-  int c = shape->classindex;
-
-  if (shape->numlines != 1) return (MS_SUCCESS); /* invalid shape */
-  if (shape->line[0].numpoints != 2) return (MS_SUCCESS); /* invalid shape */
-
-  center.x = (shape->line[0].point[0].x + shape->line[0].point[1].x) / 2.0;
-  center.y = (shape->line[0].point[0].y + shape->line[0].point[1].y) / 2.0;
-  r = MS_ABS(center.x - shape->line[0].point[0].x);
-  if (r == 0)
-    r = MS_ABS(center.y - shape->line[0].point[0].y);
-  if (r == 0)
-    return (MS_SUCCESS);
-
-  if (layer->transform == MS_TRUE) {
-
-    if (layer->project)
-      msProjectPoint(&layer->projection, &map->projection, &center);
-
-    center.x = MS_MAP2IMAGE_X(center.x, map->extent.minx, map->cellsize);
-    center.y = MS_MAP2IMAGE_Y(center.y, map->extent.maxy, map->cellsize);
-    r /= map->cellsize;
-  } else
-    msOffsetPointRelativeTo(&center, layer);
-
-  for (s = 0; s < layer->class[c]->numstyles; s++) {
-    if (msScaleInBounds(map->scaledenom,
-                        layer->class[c]->styles[s]->minscaledenom,
-                        layer->class[c]->styles[s]->maxscaledenom))
-      if(MS_UNLIKELY(MS_FAILURE == msCircleDrawShadeSymbol(map, image, &center, r,
-                              layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
-        return MS_FAILURE;
-      }
-  }
-  return MS_SUCCESS;
-  /* TODO: need to handle circle annotation */
-}
-
-static
-int pointLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer, shapeObj *shape, int drawmode)
-{
-  int l, c = shape->classindex, j, i, s;
-  pointObj *point;
-  int ret = MS_FAILURE;
-
-  if (layer->project && layer->transform == MS_TRUE)
-  {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-          layer->reprojectorLayerToMap = msProjectCreateReprojector(
-              &layer->projection, &map->projection);
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            return MS_FAILURE;
-        }
-      }
-      msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-  }
-
-  // Only take into account map rotation if the label and style angles are
-  // non-zero.
-  if( map->gt.rotation_angle )
-  {
-    for (l = 0; l < layer->class[c]->numlabels; l++)
-    {
-        if( layer->class[c]->labels[l]->angle != 0 )
-            layer->class[c]->labels[l]->angle -= map->gt.rotation_angle;
-    }
-
-    for (s = 0; s < layer->class[c]->numstyles; s++)
-    {
-        if( layer->class[c]->styles[s]->angle != 0 )
-            layer->class[c]->styles[s]->angle -= map->gt.rotation_angle;
-    }
-  }
-
-  for (j = 0; j < shape->numlines; j++) {
-    for (i = 0; i < shape->line[j].numpoints; i++) {
-      point = &(shape->line[j].point[i]);
-      if (layer->transform == MS_TRUE) {
-        if (!msPointInRect(point, &map->extent)) continue; /* next point */
-        msTransformPoint(point, &map->extent, map->cellsize, image);
-      } else
-        msOffsetPointRelativeTo(point, layer);
-
-      if(MS_DRAW_FEATURES(drawmode)) {
-        for (s = 0; s < layer->class[c]->numstyles; s++) {
-          if (msScaleInBounds(map->scaledenom,
-              layer->class[c]->styles[s]->minscaledenom,
-              layer->class[c]->styles[s]->maxscaledenom))
-            if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, point, layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
-              goto end;
-            }
-        }
-      }
-      if(MS_DRAW_LABELS(drawmode)) {
-        if (layer->labelcache) {
-          if (msAddLabelGroup(map, image, layer, c, shape, point, -1) != MS_SUCCESS) goto end;
-        } else {
-          for (l = 0; l < layer->class[c]->numlabels; l++)
-            if(msGetLabelStatus(map,layer,shape,layer->class[c]->labels[l]) == MS_ON) {
-              char *annotext = msShapeGetLabelAnnotation(layer,shape,layer->class[c]->labels[l]);
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLabel(map, image, *point, annotext, layer->class[c]->labels[l], layer->class[c]->labels[l]->scalefactor))) {
-                goto end;
-              }
-            }
-        }
-      }
-    }
-  }
-  ret = MS_SUCCESS;
-
-end:
-  if( map->gt.rotation_angle )
-  {
-    for (l = 0; l < layer->class[c]->numlabels; l++)
-    {
-        if( layer->class[c]->labels[l]->angle != 0 )
-            layer->class[c]->labels[l]->angle += map->gt.rotation_angle;
-    }
-
-    for (s = 0; s < layer->class[c]->numstyles; s++)
-    {
-        if( layer->class[c]->styles[s]->angle != 0 )
-            layer->class[c]->styles[s]->angle += map->gt.rotation_angle;
-    }
-  }
-
-  return ret;
-}
-
-int lineLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer, shapeObj *shape,
-                       shapeObj *anno_shape, shapeObj *unclipped_shape, int style, int drawmode)
-{
-  int c = shape->classindex;
-  int ret = MS_SUCCESS;
-
-  /* RFC48: loop through the styles, and pass off to the type-specific
-  function if the style has an appropriate type */
-  if(MS_DRAW_FEATURES(drawmode)) {
-    for (int s = 0; s < layer->class[c]->numstyles; s++) {
-      if (msScaleInBounds(map->scaledenom,
-          layer->class[c]->styles[s]->minscaledenom,
-          layer->class[c]->styles[s]->maxscaledenom)) {
-        if (layer->class[c]->styles[s]->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawTransformedShape(map, image, unclipped_shape, layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
-            return MS_FAILURE;
-          }
-        }
-        else if (!MS_DRAW_SINGLESTYLE(drawmode) || s == style) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, shape, layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
-            return MS_FAILURE;
-          }
-        }
-      }
-    }
-  }
-  
-  if(MS_DRAW_LABELS(drawmode)) {
-    for (int l = 0; l < layer->class[c]->numlabels; l++) {
-      labelObj *label = layer->class[c]->labels[l];
-      textSymbolObj ts;
-      char *annotext;
-      if(!msGetLabelStatus(map,layer,shape,label)) {
-        continue;
-      }
-
-      annotext = msShapeGetLabelAnnotation(layer,anno_shape,label);
-      if(!annotext) continue;
-      initTextSymbol(&ts);
-      msPopulateTextSymbolForLabelAndString(&ts,label,annotext,label->scalefactor,image->resolutionfactor, layer->labelcache);
-      
-      
-      if (label->anglemode == MS_FOLLOW) { /* bug #1620 implementation */
-        struct label_follow_result lfr;
-        
-        if (!layer->labelcache) {
-          msSetError(MS_MISCERR, "Angle mode 'FOLLOW' is supported only with labelcache on", "msDrawShape()");
-          ret = MS_FAILURE;
-          goto line_cleanup;
-        }
-        
-        memset(&lfr,0,sizeof(lfr));
-        msPolylineLabelPath(map, image, anno_shape, &ts, label, &lfr);
-
-        for (int i = 0; i < lfr.num_follow_labels; i++) {
-          if (msAddLabel(map, image, label, layer->index, c, anno_shape, NULL, -1, lfr.follow_labels[i]) != MS_SUCCESS) {
-            ret = MS_FAILURE;
-            goto line_cleanup;
-          }
-        }
-        free(lfr.follow_labels);
-        for(int i=0; i<lfr.lar.num_label_points; i++) {
-          textSymbolObj *ts_auto = msSmallMalloc(sizeof(textSymbolObj));
-          initTextSymbol(ts_auto);
-          msCopyTextSymbol(ts_auto,&ts);
-          ts_auto->rotation = lfr.lar.angles[i];
-          {
-            if (msAddLabel(map, image, label, layer->index, c, anno_shape, &lfr.lar.label_points[i], -1, ts_auto) != MS_SUCCESS) {
-              ret = MS_FAILURE;
-              free(lfr.lar.angles);
-              free(lfr.lar.label_points);
-              goto line_cleanup;
-            }
-          }
-        }
-        free(lfr.lar.angles);
-        free(lfr.lar.label_points);
-      } else {
-        struct label_auto_result lar;
-        memset(&lar,0,sizeof(struct label_auto_result));
-        ret = msPolylineLabelPoint(map, anno_shape, &ts, label, &lar, image->resolutionfactor);
-        if(MS_UNLIKELY(MS_FAILURE == ret)) goto line_cleanup;
-
-        if (label->angle != 0)
-          label->angle -= map->gt.rotation_angle; /* apply rotation angle */
-
-        for(int i=0; i<lar.num_label_points; i++) {
-          textSymbolObj *ts_auto = msSmallMalloc(sizeof(textSymbolObj));
-          initTextSymbol(ts_auto);
-          msCopyTextSymbol(ts_auto,&ts);
-          ts_auto->rotation = lar.angles[i];
-          if (layer->labelcache) {
-            if (msAddLabel(map, image, label, layer->index, c, anno_shape, &lar.label_points[i], -1, ts_auto) != MS_SUCCESS) {
-              ret = MS_FAILURE;
-              free(lar.angles);
-              free(lar.label_points);
-              freeTextSymbol(ts_auto);
-              free(ts_auto);
-              goto line_cleanup;
-            }
-          } else {
-            if(!ts_auto->textpath) {
-              if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts_auto))) {
-                ret = MS_FAILURE;
-                free(lar.angles);
-                free(lar.label_points);
-                freeTextSymbol(ts_auto);
-                free(ts_auto);
-                goto line_cleanup;
-              }
-            }
-            ret = msDrawTextSymbol(map,image,lar.label_points[i],ts_auto);
-            freeTextSymbol(ts_auto);
-            free(ts_auto); /* TODO RFC98: could we not re-use the original ts instead of duplicating into ts_auto ?
-                            * we cannot for now, as the rendering code will modify the glyph positions to apply
-                            * the labelpoint and rotation offsets */
-            ts_auto = NULL;
-            if(MS_UNLIKELY(MS_FAILURE == ret)) goto line_cleanup;
-          }
-          
-        }
-        free(lar.angles);
-        free(lar.label_points);
-      }
-
-line_cleanup:
-      /* clean up and reset */
-      if (ret == MS_FAILURE) {
-        break; /* from the label looping */
-      }
-      freeTextSymbol(&ts);
-    } /* next label */
-  }
-
-  return ret;
-
-}
-
-int polygonLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
-                          shapeObj *shape, shapeObj *anno_shape, shapeObj *unclipped_shape, int drawmode)
-{
-
-  int c = shape->classindex;
-  pointObj annopnt = {0}; // initialize
-  int i;
-
-  if(MS_DRAW_FEATURES(drawmode)) {
-    for (i = 0; i < layer->class[c]->numstyles; i++) {
-      if (msScaleInBounds(map->scaledenom, layer->class[c]->styles[i]->minscaledenom,
-                          layer->class[c]->styles[i]->maxscaledenom)) {
-        if (layer->class[c]->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, shape, layer->class[c]->styles[i], layer->class[c]->styles[i]->scalefactor))) {
-            return MS_FAILURE;
-          }
-        }
-        else {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawTransformedShape(map, image, unclipped_shape,
-                                 layer->class[c]->styles[i], layer->class[c]->styles[i]->scalefactor))) {
-            return MS_FAILURE;
-          }
-        }
-      }
-    }
-  }
-
-  if(MS_DRAW_LABELS(drawmode)) {
-    if (layer->class[c]->numlabels > 0) {
-      double minfeaturesize = layer->class[c]->labels[0]->minfeaturesize * image->resolutionfactor;
-      if (msPolygonLabelPoint(anno_shape, &annopnt, minfeaturesize) == MS_SUCCESS) {
-        for (i = 0; i < layer->class[c]->numlabels; i++)
-          if (layer->class[c]->labels[i]->angle != 0) layer->class[c]->labels[i]->angle -= map->gt.rotation_angle; /* TODO: is this correct ??? */
-        if (layer->labelcache) {
-          if (msAddLabelGroup(map, image, layer, c, anno_shape, &annopnt,
-                              MS_MIN(shape->bounds.maxx - shape->bounds.minx, shape->bounds.maxy - shape->bounds.miny)) != MS_SUCCESS) {
-            return MS_FAILURE;
-          }
-        } else {
-          for (i = 0; i < layer->class[c]->numlabels; i++)
-            if(msGetLabelStatus(map,layer,shape,layer->class[c]->labels[i]) == MS_ON) {
-              char *annotext = msShapeGetLabelAnnotation(layer,shape,layer->class[c]->labels[i]); /*ownership taken by msDrawLabel, no need to free */
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLabel(map, image, annopnt, annotext, layer->class[c]->labels[i], layer->class[c]->labels[i]->scalefactor))) {
-                return MS_FAILURE;
-              }
-            }
-        }
-      }
-    }
-  }
-  return MS_SUCCESS;
-}
-
-/*
-** Function to render an individual shape, the style variable enables/disables the drawing of a single style
-** versus a single style. This is necessary when drawing entire layers as proper overlay can only be achived
-** through caching. "querymapMode" parameter is used to tell msBindLayerToShape to not override the
-** QUERYMAP HILITE color.
-*/
-int msDrawShape(mapObj *map, layerObj *layer, shapeObj *shape, imageObj *image, int style, int drawmode)
-{
-  int c,s,ret=MS_SUCCESS;
-  shapeObj *anno_shape, *unclipped_shape = shape;
-  int bNeedUnclippedShape = MS_FALSE;
-  int bNeedUnclippedAnnoShape = MS_FALSE;
-  int bShapeNeedsClipping = MS_TRUE;
-
-  if(shape->numlines == 0 || shape->type == MS_SHAPE_NULL) return MS_SUCCESS;
-
-  c = shape->classindex;
-
-  /* Before we do anything else, we will check for a rangeitem.
-     If its there, we need to change the style's color to map
-     the range to the shape */
-  for(s=0; s<layer->class[c]->numstyles; s++) {
-    styleObj *style = layer->class[c]->styles[s];
-    if(style->rangeitem !=  NULL)
-      msShapeToRange((layer->class[c]->styles[s]), shape);
-  }
-
-  /* circle and point layers go through their own treatment */
-  if(layer->type == MS_LAYER_CIRCLE) {
-    if(msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) return MS_FAILURE;
-    msDrawStartShape(map, layer, image, shape);
-    ret = circleLayerDrawShape(map,image,layer,shape);
-    msDrawEndShape(map,layer,image,shape);
-    return ret;
-  } else if(layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_RASTER) {
-    if(msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) return MS_FAILURE;
-    msDrawStartShape(map, layer, image, shape);
-    ret = pointLayerDrawShape(map,image,layer,shape,drawmode);
-    msDrawEndShape(map,layer,image,shape);
-    return ret;
-  }
-
-  if (layer->type == MS_LAYER_POLYGON && shape->type != MS_SHAPE_POLYGON) {
-    msSetError(MS_MISCERR, "Only polygon shapes can be drawn using a polygon layer definition.", "polygonLayerDrawShape()");
-    return (MS_FAILURE);
-  }
-  if (layer->type == MS_LAYER_LINE && shape->type != MS_SHAPE_POLYGON && shape->type != MS_SHAPE_LINE) {
-    msSetError(MS_MISCERR, "Only polygon or line shapes can be drawn using a line layer definition.", "msDrawShape()");
-    return (MS_FAILURE);
-  }
-
-  if (layer->project && layer->transform == MS_TRUE)
-  {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-          layer->reprojectorLayerToMap = msProjectCreateReprojector(
-              &layer->projection, &map->projection);
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            return MS_FAILURE;
-        }
-      }
-      msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-  }
-
-  /* check if we'll need the unclipped shape */
-  if (shape->type != MS_SHAPE_POINT) {
-    if(MS_DRAW_FEATURES(drawmode)) {
-      for (s = 0; s < layer->class[c]->numstyles; s++) {
-        styleObj *style = layer->class[c]->styles[s];
-        if (style->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
-          bNeedUnclippedShape = MS_TRUE;
-      }
-    }
-    /* check if we need to clip the shape */
-    if (shape->bounds.minx < map->extent.minx ||
-        shape->bounds.miny < map->extent.miny ||
-        shape->bounds.maxx > map->extent.maxx ||
-        shape->bounds.maxy > map->extent.maxy) {
-      bShapeNeedsClipping = MS_TRUE;
-    }
-   
-    if(MS_DRAW_LABELS(drawmode) && MS_DRAW_UNCLIPPED_LABELS(drawmode)) {
-      bNeedUnclippedAnnoShape = MS_TRUE;
-      bNeedUnclippedShape = MS_TRUE;
-    }
-
-    if(MS_DRAW_UNCLIPPED_LINES(drawmode)) {
-      bShapeNeedsClipping = MS_FALSE;
-    }
-  } else {
-    bShapeNeedsClipping = MS_FALSE;
-  }
-
-  if(layer->transform == MS_TRUE && bShapeNeedsClipping) {
-    /* compute the size of the clipping buffer, in pixels. This buffer must account
-     for the size of symbols drawn to avoid artifacts around the image edges */
-    int clip_buf = 0;
-    int s;
-    rectObj cliprect;
-    for (s=0;s<layer->class[c]->numstyles;s++) {
-      double maxsize, maxunscaledsize;
-      symbolObj *symbol;
-      styleObj *style = layer->class[c]->styles[s];
-      if (!MS_IS_VALID_ARRAY_INDEX(style->symbol, map->symbolset.numsymbols)) {
-        msSetError(MS_SYMERR, "Invalid symbol index: %d", "msDrawShape()", style->symbol);
-        return MS_FAILURE;
-      }
-      symbol = map->symbolset.symbol[style->symbol];
-      if (symbol->type == MS_SYMBOL_PIXMAP) {
-        if (MS_SUCCESS != msPreloadImageSymbol(MS_MAP_RENDERER(map), symbol))
-          return MS_FAILURE;
-      } else if (symbol->type == MS_SYMBOL_SVG) {
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-        if (MS_SUCCESS != msPreloadSVGSymbol(symbol))
-          return MS_FAILURE;
-#else
-        msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msDrawShape()");
-        return MS_FAILURE;
-#endif
-      }
-      maxsize = MS_MAX(msSymbolGetDefaultSize(symbol), MS_MAX(style->size, style->width));
-      maxunscaledsize = MS_MAX(style->minsize*image->resolutionfactor, style->minwidth*image->resolutionfactor);
-      if(shape->type == MS_SHAPE_POLYGON && !IS_PARALLEL_OFFSET(style->offsety)) {
-         maxsize += MS_MAX(fabs(style->offsety),fabs(style->offsetx));
-      }
-      clip_buf = MS_MAX(clip_buf,MS_NINT(MS_MAX(maxsize * style->scalefactor, maxunscaledsize) + 1));
-    }
-
-
-    /* if we need a copy of the unclipped shape, transform first, then clip to avoid transforming twice */
-    if(bNeedUnclippedShape) {
-      msTransformShape(shape, map->extent, map->cellsize, image);
-      if(shape->numlines == 0) return MS_SUCCESS;
-      msComputeBounds(shape);
-
-      /* TODO: there's an optimization here that can be implemented:
-         - no need to allocate unclipped_shape for each call to this function
-         - the calls to msClipXXXRect will discard the original lineObjs, whereas
-           we have just copied them because they where needed. These two functions
-           could be changed so they are instructed not to free the original lineObjs. */
-      unclipped_shape = (shapeObj *) msSmallMalloc(sizeof (shapeObj));
-      msInitShape(unclipped_shape);
-      msCopyShape(shape, unclipped_shape);
-      if(shape->type == MS_SHAPE_POLYGON) {
-         /* #179: additional buffer for polygons */
-         clip_buf += 2;
-      }
-
-      cliprect.minx = cliprect.miny = -clip_buf;
-      cliprect.maxx = image->width + clip_buf;
-      cliprect.maxy = image->height + clip_buf;
-      if(shape->type == MS_SHAPE_POLYGON) {
-        msClipPolygonRect(shape, cliprect);
-      } else {
-        assert(shape->type == MS_SHAPE_LINE);
-        msClipPolylineRect(shape, cliprect);
-      }
-      if(bNeedUnclippedAnnoShape) {
-        anno_shape = unclipped_shape;
-      } else {
-        anno_shape = shape;
-      }
-    } else {
-      /* clip first, then transform. This means we are clipping in geographical space */
-      double clip_buf_d;
-      if(shape->type == MS_SHAPE_POLYGON) {
-         /*
-          * add a small buffer around the cliping rectangle to
-          * avoid lines around the edges : #179
-          */
-         clip_buf += 2;
-      }
-      clip_buf_d = clip_buf * map->cellsize;
-      cliprect.minx = map->extent.minx - clip_buf_d;
-      cliprect.miny = map->extent.miny - clip_buf_d;
-      cliprect.maxx = map->extent.maxx + clip_buf_d;
-      cliprect.maxy = map->extent.maxy + clip_buf_d;
-      if(shape->type == MS_SHAPE_POLYGON) {
-        msClipPolygonRect(shape, cliprect);
-      } else {
-        assert(shape->type == MS_SHAPE_LINE);
-        msClipPolylineRect(shape, cliprect);
-      }
-      msTransformShape(shape, map->extent, map->cellsize, image);
-      msComputeBounds(shape);
-      anno_shape = shape;
-    }
-
-  } else {
-    /* the shape is fully in the map extent,
-     * or is a point type layer where out of bounds points are treated differently*/
-    if (layer->transform == MS_TRUE) {
-      msTransformShape(shape, map->extent, map->cellsize, image);
-      msComputeBounds(shape);
-    } else {
-      msOffsetShapeRelativeTo(shape, layer);
-    }
-    anno_shape = shape;
-  }
-  if(shape->numlines == 0) {
-    ret = MS_SUCCESS; /* error message is set in msBindLayerToShape() */
-    goto draw_shape_cleanup;
-  }
-
-  if(msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) {
-    ret = MS_FAILURE; /* error message is set in msBindLayerToShape() */
-    goto draw_shape_cleanup;
-  }
-
-  switch(layer->type) {
-    case MS_LAYER_LINE:
-      msDrawStartShape(map, layer, image, shape);
-      ret = lineLayerDrawShape(map, image, layer, shape, anno_shape, unclipped_shape, style, drawmode);
-      break;
-    case MS_LAYER_POLYGON:
-      msDrawStartShape(map, layer, image, shape);
-      ret = polygonLayerDrawShape(map, image, layer, shape, anno_shape, unclipped_shape, drawmode);
-      break;
-    case MS_LAYER_POINT:
-    case MS_LAYER_RASTER:
-      assert(0); //bug !
-    default:
-      msSetError(MS_MISCERR, "Unknown layer type.", "msDrawShape()");
-      ret = MS_FAILURE;
-  }
-
-draw_shape_cleanup:
-  msDrawEndShape(map,layer,image,shape);
-  if(unclipped_shape != shape) {
-    msFreeShape(unclipped_shape);
-    msFree(unclipped_shape);
-  }
-  return ret;
-}
-
-/*
-** Function to render an individual point, used as a helper function for mapscript only. Since a point
-** can't carry attributes you can't do attribute based font size or angle.
-*/
-int msDrawPoint(mapObj *map, layerObj *layer, pointObj *point, imageObj *image, int classindex, char *labeltext)
-{
-  int s,ret;
-  classObj *theclass=NULL;
-  labelObj *label=NULL;
-
-  if(layer->transform == MS_TRUE && layer->project && msProjectionsDiffer(&(layer->projection), &(map->projection))) {
-    msProjectPoint(&(layer->projection), &(map->projection), point);
-  }
-  
-  if(classindex > layer->numclasses) {
-    msSetError(MS_MISCERR, "Invalid classindex (%d)", "msDrawPoint()", classindex);
-    return MS_FAILURE; 
-  }
-  theclass = layer->class[classindex];
-  
-  if(labeltext && theclass->numlabels > 0) {
-    label = theclass->labels[0];
-  }
-  
-  switch(layer->type) {
-    case MS_LAYER_POINT:
-      if(layer->transform == MS_TRUE) {
-        if(!msPointInRect(point, &map->extent)) return(0);
-        point->x = MS_MAP2IMAGE_X(point->x, map->extent.minx, map->cellsize);
-        point->y = MS_MAP2IMAGE_Y(point->y, map->extent.maxy, map->cellsize);
-      } else
-        msOffsetPointRelativeTo(point, layer);
-
-      for(s=0; s<theclass->numstyles; s++) {
-        if(msScaleInBounds(map->scaledenom, theclass->styles[s]->minscaledenom, theclass->styles[s]->maxscaledenom))
-          if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, point, theclass->styles[s], theclass->styles[s]->scalefactor))) {
-            return MS_FAILURE;
-          }
-      }
-      if(label && labeltext && *labeltext) {
-        textSymbolObj *ts = msSmallMalloc(sizeof(textSymbolObj));
-        initTextSymbol(ts);
-        msPopulateTextSymbolForLabelAndString(ts, label, msStrdup(labeltext), label->scalefactor, image->resolutionfactor, layer->labelcache);
-        if(layer->labelcache) {
-          if(msAddLabel(map, image, label, layer->index, classindex, NULL, point, -1, ts) != MS_SUCCESS) {
-            return(MS_FAILURE);
-          }
-        } else {
-          if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
-            freeTextSymbol(ts);
-            free(ts);
-            return MS_FAILURE;
-          }
-          ret = msDrawTextSymbol(map,image,*point,ts);
-          freeTextSymbol(ts);
-          free(ts); 
-          if(MS_UNLIKELY(ret == MS_FAILURE)) return MS_FAILURE;
-        }
-      }
-      break;
-    default:
-      break; /* don't do anything with layer of other types */
-  }
-
-  return(MS_SUCCESS); /* all done, no cleanup */
-}
-
-/*
-** Draws a single label independently of the label cache. No collision avoidance is performed.
-*/
-int msDrawLabel(mapObj *map, imageObj *image, pointObj labelPnt, char *string, labelObj *label, double scalefactor)
-{
-  shapeObj labelPoly;
-  label_bounds lbounds = {0};
-  lineObj labelPolyLine;
-  pointObj labelPolyPoints[5];
-  textSymbolObj ts = {0};
-  int needLabelPoly=MS_TRUE;
-  int needLabelPoint=MS_TRUE;
-  int haveLabelText=MS_TRUE;
-
-  if(!string || !*string)
-    haveLabelText = MS_FALSE;
-
-  if(haveLabelText) {
-    initTextSymbol(&ts);
-    msPopulateTextSymbolForLabelAndString(&ts, label, string, scalefactor, image->resolutionfactor, 0);
-    if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,&ts))) {
-      freeTextSymbol(&ts);
-      return MS_FAILURE;
-    }
-  }
-
-  labelPoly.line = &labelPolyLine; /* setup the label polygon structure */
-  labelPoly.numlines = 1;
-  lbounds.poly = &labelPolyLine; /* setup the label polygon structure */
-  labelPoly.line->point = labelPolyPoints;
-  labelPoly.line->numpoints = 5;
-
-  if(label->position != MS_XY) {
-    pointObj p = {0};
-
-    if(label->numstyles > 0) {
-      int i;
-
-      for(i=0; i<label->numstyles; i++) {
-        if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT || label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelPnt, label->styles[i], scalefactor))) {
-            if(haveLabelText)
-              freeTextSymbol(&ts);
-            return MS_FAILURE;
-          }
-        } else if(haveLabelText && (label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER)) {
-          if(needLabelPoly) {
-            p = get_metrics(&labelPnt, label->position, ts.textpath, label->offsetx * ts.scalefactor,
-                    label->offsety * ts.scalefactor, ts.rotation, 1, &lbounds);
-            if(!lbounds.poly) {
-              /* we need the full shape to draw the label background */
-              labelPolyPoints[0].x = labelPolyPoints[4].x = lbounds.bbox.minx;
-              labelPolyPoints[0].y = labelPolyPoints[4].y = lbounds.bbox.miny;
-              labelPolyPoints[1].x = lbounds.bbox.minx;
-              labelPolyPoints[1].y = lbounds.bbox.maxy;
-              labelPolyPoints[2].x = lbounds.bbox.maxx;
-              labelPolyPoints[2].y = lbounds.bbox.maxy;
-              labelPolyPoints[3].x = lbounds.bbox.maxx;
-              labelPolyPoints[3].y = lbounds.bbox.miny;
-            }
-            needLabelPoint = MS_FALSE; /* don't re-compute */
-            needLabelPoly = MS_FALSE;
-          }
-          if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, &labelPoly, label->styles[i], ts.scalefactor))) {
-              freeTextSymbol(&ts);
-              return MS_FAILURE;
-            }
-          } else {
-            pointObj labelCenter;
-            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx)/2;
-            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny)/2;
-            if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelCenter, label->styles[i], scalefactor))) {
-              freeTextSymbol(&ts);
-              return MS_FAILURE;
-            }
-          }
-        } else {
-          msSetError(MS_MISCERR,"Unknown label geomtransform %s", "msDrawLabel()",label->styles[i]->_geomtransform.string);
-          if(haveLabelText)
-            freeTextSymbol(&ts);
-          return MS_FAILURE;
-        }
-      }
-    }
-
-    if(haveLabelText) {
-      if(needLabelPoint)
-        p = get_metrics(&labelPnt, label->position, ts.textpath, label->offsetx * ts.scalefactor,
-                        label->offsety * ts.scalefactor, ts.rotation, 0, &lbounds);
-
-      /* draw the label text */
-      if(MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map,image,p,&ts))) {
-        freeTextSymbol(&ts);
-        return MS_FAILURE;
-      }
-    }
-  } else {
-    labelPnt.x += label->offsetx * ts.scalefactor;
-    labelPnt.y += label->offsety * ts.scalefactor;
-
-    if(label->numstyles > 0) {
-      int i;
-
-      for(i=0; i<label->numstyles; i++) {
-        if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT ||
-           label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelPnt, label->styles[i], scalefactor))) {
-            freeTextSymbol(&ts);
-            return MS_FAILURE;
-          }
-        } else if(haveLabelText && (label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER)) {
-          if(needLabelPoly) {
-            get_metrics(&labelPnt, label->position, ts.textpath, label->offsetx * ts.scalefactor,
-                    label->offsety * ts.scalefactor, ts.rotation, 1, &lbounds);
-            needLabelPoly = MS_FALSE; /* don't re-compute */
-            if(!lbounds.poly) {
-              /* we need the full shape to draw the label background */
-              labelPolyPoints[0].x = labelPolyPoints[4].x = lbounds.bbox.minx;
-              labelPolyPoints[0].y = labelPolyPoints[4].y = lbounds.bbox.miny;
-              labelPolyPoints[1].x = lbounds.bbox.minx;
-              labelPolyPoints[1].y = lbounds.bbox.maxy;
-              labelPolyPoints[2].x = lbounds.bbox.maxx;
-              labelPolyPoints[2].y = lbounds.bbox.maxy;
-              labelPolyPoints[3].x = lbounds.bbox.maxx;
-              labelPolyPoints[3].y = lbounds.bbox.miny;
-            }
-          }
-          if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, &labelPoly, label->styles[i], scalefactor))) {
-              freeTextSymbol(&ts);
-              return MS_FAILURE;
-            }
-          } else {
-	    pointObj labelCenter;
-            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx)/2;
-            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny)/2;
-            if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelCenter, label->styles[i], scalefactor))) {
-              freeTextSymbol(&ts);
-              return MS_FAILURE;
-            }
-          }
-        } else {
-          msSetError(MS_MISCERR,"Unknown label geomtransform %s", "msDrawLabel()",label->styles[i]->_geomtransform.string);
-          if(haveLabelText)
-            freeTextSymbol(&ts);
-          return MS_FAILURE;
-        }
-      }
-    }
-
-    if(haveLabelText) {
-      /* draw the label text */
-      if(MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map,image,labelPnt,&ts))) {
-        freeTextSymbol(&ts);
-        return MS_FAILURE;
-      }
-    }
-  }
-  if(haveLabelText)
-    freeTextSymbol(&ts);
-
-  return MS_SUCCESS;
-}
-
-static inline void offset_bbox(const rectObj *from, rectObj *to, double ox, double oy) {
-  to->minx = from->minx + ox;
-  to->miny = from->miny + oy;
-  to->maxx = from->maxx + ox;
-  to->maxy = from->maxy + oy;
-}
-
-static inline void offset_label_bounds(const label_bounds *from, label_bounds *to, double ox, double oy) {
-  if(from->poly) {
-    int i;
-    for(i=0; i<from->poly->numpoints; i++) {
-      to->poly->point[i].x = from->poly->point[i].x + ox;
-      to->poly->point[i].y = from->poly->point[i].y + oy;
-    }
-    to->poly->numpoints = from->poly->numpoints;
-  } else {
-    to->poly = NULL;
-  }
-  offset_bbox(&from->bbox, &to->bbox, ox, oy);
-}
-
-/* private shortcut function to try a leader offsetted label
- * the caller must ensure that scratch->poly->points has been sufficiently allocated
- * to hold the points from the cachePtr's label_bounds */
-void offsetAndTest(mapObj *map, labelCacheMemberObj *cachePtr, double ox, double oy,
-                   int priority, int label_idx, label_bounds *scratch)
-{
-  int i,j,status;
-  pointObj leaderpt;
-  lineObj *scratch_line = scratch->poly;
-
-  for(i=0; i<cachePtr->numtextsymbols; i++) {
-    textSymbolObj *ts = cachePtr->textsymbols[i];
-    if(ts->textpath) {
-      offset_label_bounds(&ts->textpath->bounds, scratch, ox, oy);
-      status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority, label_idx);
-      if(!status) {
-        return;
-      }
-    }
-    for(j=0; j<ts->label->numstyles; j++) {
-      if(ts->label->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-        scratch->poly = scratch_line;
-        offset_label_bounds(ts->style_bounds[j], scratch, ox, oy);
-        status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority, label_idx);
-        if(!status) {
-          return;
-        }
-      }
-    }
-  }
-
-  leaderpt.x = cachePtr->point.x + ox;
-  leaderpt.y = cachePtr->point.y + oy;
-
-  status = msTestLabelCacheLeaderCollision(map, &cachePtr->point, &leaderpt);
-  if(!status) {
-    return;
-  }
-
-
-  /* the current offset is ok */
-  cachePtr->leaderbbox = msSmallMalloc(sizeof(rectObj));
-  cachePtr->leaderline = msSmallMalloc(sizeof(lineObj));
-  cachePtr->leaderline->point = msSmallMalloc(2 * sizeof(pointObj));
-  cachePtr->leaderline->numpoints = 2;
-  cachePtr->leaderline->point[0] = cachePtr->point;
-  cachePtr->leaderline->point[1] = leaderpt;
-  cachePtr->leaderbbox->minx = MS_MIN(leaderpt.x,cachePtr->point.x);
-  cachePtr->leaderbbox->maxx = MS_MAX(leaderpt.x,cachePtr->point.x);
-  cachePtr->leaderbbox->miny = MS_MIN(leaderpt.y,cachePtr->point.y);
-  cachePtr->leaderbbox->maxy = MS_MAX(leaderpt.y,cachePtr->point.y);
-  cachePtr->status = MS_ON;
-
-  offset_bbox(&cachePtr->bbox,&cachePtr->bbox,ox,oy);
-
-  for(i=0; i<cachePtr->numtextsymbols; i++) {
-    textSymbolObj *ts = cachePtr->textsymbols[i];
-    if(ts->textpath) {
-      offset_label_bounds(&ts->textpath->bounds, &ts->textpath->bounds, ox, oy);
-      ts->annopoint.x += ox;
-      ts->annopoint.y += oy;
-    }
-    if(ts->style_bounds) {
-      for(j=0; j<ts->label->numstyles; j++) {
-        if(ts->label->styles[j]->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
-          offset_label_bounds(ts->style_bounds[j], ts->style_bounds[j], ox, oy);
-      }
-    }
-  }
-}
-
-int msDrawOffsettedLabels(imageObj *image, mapObj *map, int priority)
-{
-  int retval = MS_SUCCESS;
-  int l;
-  labelCacheObj *labelcache = &(map->labelcache);
-  labelCacheSlotObj *cacheslot;
-  labelCacheMemberObj *cachePtr;
-  label_bounds scratch;
-  lineObj scratch_line;
-  pointObj *scratch_points = NULL;
-  int num_allocated_scratch_points = 0;
-  assert(MS_RENDERER_PLUGIN(image->format));
-  cacheslot = &(labelcache->slots[priority]);
-  scratch.poly = &scratch_line;
-
-  for(l=cacheslot->numlabels-1; l>=0; l--) {
-    cachePtr = &(cacheslot->labels[l]); /* point to right spot in the label cache */
-    if(cachePtr->status == MS_OFF) {
-      /* only test regular labels that have had their bounding box computed
-       and that haven't been rendered  */
-      classObj *classPtr = (GET_CLASS(map,cachePtr->layerindex,cachePtr->classindex));
-      layerObj *layerPtr = (GET_LAYER(map,cachePtr->layerindex));
-      int steps,i,num_scratch_points_to_allocate = 0;
-
-      assert(classPtr->leader); /* cachePtrs that don't need to be tested have been marked as status on or delete */
-
-      if(cachePtr->point.x < labelcache->gutter ||
-          cachePtr->point.y < labelcache->gutter ||
-          cachePtr->point.x >= image->width - labelcache->gutter ||
-          cachePtr->point.y >= image->height - labelcache->gutter) {
-        /* don't look for leaders if point is in edge buffer as the leader line would end up chopped off */
-        continue;
-      }
-
-      for(i=0; i<cachePtr->numtextsymbols; i++) {
-        int j;
-        textSymbolObj *ts = cachePtr->textsymbols[i];
-        if(ts->textpath && ts->textpath->bounds.poly) {
-          num_scratch_points_to_allocate = MS_MAX(num_scratch_points_to_allocate, ts->textpath->bounds.poly->numpoints);
-        }
-        if(ts->style_bounds) {
-          for(j=0;j<ts->label->numstyles; j++) {
-            if(ts->label->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
-                ts->style_bounds[j]->poly) {
-              num_scratch_points_to_allocate = MS_MAX(num_scratch_points_to_allocate, ts->style_bounds[j]->poly->numpoints);
-            }
-          }
-        }
-      }
-      if(num_scratch_points_to_allocate > num_allocated_scratch_points) {
-        scratch_points = msSmallRealloc(scratch_points, num_scratch_points_to_allocate * sizeof(pointObj));
-        num_allocated_scratch_points = num_scratch_points_to_allocate;
-      }
-
-
-      steps = classPtr->leader->maxdistance / classPtr->leader->gridstep;
-
-#define x0 (cachePtr->point.x)
-#define y0 (cachePtr->point.y)
-#define gridstepsc (classPtr->leader->gridstep)
-
-
-#define otest(ox,oy) if((x0+(ox)) >= labelcache->gutter &&\
-                (y0+(oy)) >= labelcache->gutter &&\
-                (x0+(ox)) < image->width - labelcache->gutter &&\
-                (y0+(oy)) < image->height - labelcache->gutter) {\
-                   scratch_line.point = scratch_points;\
-                   scratch.poly = &scratch_line; \
-                   offsetAndTest(map,cachePtr,(ox),(oy),priority,l,&scratch); \
-                   if(cachePtr->status == MS_ON) break;\
-                }
-
-      /* loop through possible offsetted positions */
-      for(i=1; i<=steps; i++) {
-
-
-
-
-        /* test the intermediate points on the ring */
-
-        /* (points marked "0" are the ones being tested)
-
-           X00X00X
-           0XXXXX0
-           0XXXXX0
-           XXX.XXX
-           0XXXXX0
-           0XXXXX0
-           X00X00X
-        */
-        int j;
-        for(j=1; j<i-1; j++) {
-          /* test the right positions */
-          otest(i*gridstepsc,j * gridstepsc);
-          otest(i*gridstepsc,- j * gridstepsc);
-          /* test the left positions */
-          otest(- i*gridstepsc,j * gridstepsc);
-          otest(- i*gridstepsc,- j * gridstepsc);
-          /* test the top positions */
-          otest(j*gridstepsc,- i * gridstepsc);
-          otest(- j *gridstepsc,- i * gridstepsc);
-          /* test the bottom positions */
-          otest(j*gridstepsc,i * gridstepsc);
-          otest(- j *gridstepsc,i * gridstepsc);
-        }
-        if(j<(i-1)) break;
-
-        otest(i*gridstepsc,i*gridstepsc);
-        otest(-i*gridstepsc,-i*gridstepsc);
-        otest(i*gridstepsc,-i*gridstepsc);
-        otest(-i*gridstepsc,i*gridstepsc);
-
-
-        /* test the intermediate points on the ring */
-
-        /* (points marked "0" are the ones being tested)
-
-           X00X00X
-           0XXXXX0
-           0XXXXX0
-           XXX.XXX
-           0XXXXX0
-           0XXXXX0
-           X00X00X
-
-        */
-
-        /* test the extreme diagonal points */
-
-        /* (points marked "0" are the ones being tested)
-
-           0XXXXX0
-           XXXXXXX
-           XXXXXXX
-           XXX.XXX
-           XXXXXXX
-           XXXXXXX
-           0XXXXX0
-
-           (x0+i*gridstep, y0+i*gridstep), pos lr
-           (x0-i*gridstep, y0-i*gridstep), pos ul
-           (x0+i*gridstep, y0-i*gridstep), pos ur
-           (x0-i*gridstep, y0+i*gridstep), pos ll
-
-        */
-
-        /* test the 4 cardinal points on the ring */
-
-        /* (points marked "0" are the ones being tested)
-
-           XXX0XXX
-           XXXXXXX
-           XXXXXXX
-           0XX.XX0
-           XXXXXXX
-           XXXXXXX
-           XXX0XXX
-
-         * (x0+i*gridtep,y0), pos cr
-
-         * (x0-i*gridstep,y0), pos cl
-         * (x0,y0-i*gridstep), pos uc
-         * (x0,y0+i*gridstep), pos lc
-         */
-        otest(i*gridstepsc,0);
-        otest(-i*gridstepsc,0);
-        otest(0,-i*gridstepsc);
-        otest(0,i*gridstepsc);
-      }
-      if(cachePtr->status == MS_ON) {
-        int ll;
-        shapeObj labelLeader; /* label polygon (bounding box, possibly rotated) */
-        labelLeader.line = cachePtr->leaderline; /* setup the label polygon structure */
-        labelLeader.numlines = 1;
-        insertRenderedLabelMember(map, cachePtr);
-
-        for(ll=0; ll<classPtr->leader->numstyles; ll++) {
-          retval = msDrawLineSymbol(map, image,&labelLeader , classPtr->leader->styles[ll], layerPtr->scalefactor);
-          if(MS_UNLIKELY(retval == MS_FAILURE)) {
-            goto offset_cleanup;
-          }
-        }
-        for(ll=0; ll<cachePtr->numtextsymbols; ll++) {
-          textSymbolObj *ts = cachePtr->textsymbols[ll];
-
-          if(ts->style_bounds) {
-            /* here's where we draw the label styles */
-            for(i=0; i<ts->label->numstyles; i++) {
-              if(ts->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                retval = msDrawMarkerSymbol(map, image, &(labelLeader.line->point[1]), ts->label->styles[i], layerPtr->scalefactor);
-                if(MS_UNLIKELY(retval == MS_FAILURE)) {
-                  goto offset_cleanup;
-                }
-              } else if(ts->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-                retval = msDrawLabelBounds(map,image,ts->style_bounds[i],ts->label->styles[i], ts->scalefactor);
-                if(MS_UNLIKELY(retval == MS_FAILURE)) {
-                  goto offset_cleanup;
-                }
-	      } else if(ts->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
-                pointObj labelCenter;
-                labelCenter.x = (ts->style_bounds[i]->bbox.maxx + ts->style_bounds[i]->bbox.minx)/2;
-                labelCenter.y = (ts->style_bounds[i]->bbox.maxy + ts->style_bounds[i]->bbox.miny)/2;
-                retval = msDrawMarkerSymbol(map, image, &labelCenter, ts->label->styles[i], layerPtr->scalefactor);
-                if(MS_UNLIKELY(retval == MS_FAILURE)) {
-                  goto offset_cleanup;
-                }
-              } else {
-                msSetError(MS_MISCERR,"Labels only support LABELPNT, LABELPOLY and LABELCENTER GEOMTRANSFORMS", "msDrawOffsettedLabels()");
-                retval = MS_FAILURE;
-              }
-            }
-          }
-          if(ts->annotext) {
-            retval = msDrawTextSymbol(map,image,ts->annopoint,ts);
-            if(MS_UNLIKELY(retval == MS_FAILURE)) {
-              goto offset_cleanup;
-            }
-          }
-        }
-        /* TODO: draw cachePtr->marker, but where ? */
-
-        /*
-         styleObj tstyle;
-         static int foo =0;
-         if(!foo) {
-            srand(time(NULL));
-            foo = 1;
-            initStyle(&tstyle);
-            tstyle.width = 1;
-            tstyle.color.alpha = 255;
-         }
-         tstyle.color.red = random()%255;
-         tstyle.color.green = random()%255;
-         tstyle.color.blue =random()%255;
-         msDrawLineSymbol(&map->symbolset, image, cachePtr->poly, &tstyle, layerPtr->scalefactor);
-        */
-
-      }
-    }
-  }
-
-offset_cleanup:
-
-  free(scratch_points);
-
-
-  return retval;
-}
-
-void fastComputeBounds(lineObj *line, rectObj *bounds)
-{
-  int j;
-  bounds->minx = bounds->maxx = line->point[0].x;
-  bounds->miny = bounds->maxy = line->point[0].y;
-
-
-  for( j=0; j<line->numpoints; j++ ) {
-    bounds->minx = MS_MIN(bounds->minx, line->point[j].x);
-    bounds->maxx = MS_MAX(bounds->maxx, line->point[j].x);
-    bounds->miny = MS_MIN(bounds->miny, line->point[j].y);
-    bounds->maxy = MS_MAX(bounds->maxy, line->point[j].y);
-  }
-}
-
-int computeMarkerBounds(mapObj *map, pointObj *annopoint, textSymbolObj *ts, label_bounds *poly)
-{
-  int i;
-  for (i=0; i<ts->label->numstyles; i++) {
-    styleObj *style = ts->label->styles[i];
-    if(style->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
-        style->symbol < map->symbolset.numsymbols && style->symbol >= 0) {
-      double sx,sy;
-      int p;
-      double aox,aoy;
-      symbolObj *symbol = map->symbolset.symbol[style->symbol];
-      if(msGetMarkerSize(map, style, &sx, &sy, ts->scalefactor) != MS_SUCCESS)
-        return -1; /* real error, different from MS_FALSE, return -1 so we can trap it */
-      if(style->angle) {
-        pointObj *point = poly->poly->point;
-        point[0].x = sx / 2.0;
-        point[0].y = sy / 2.0;
-        point[1].x =  point[0].x;
-        point[1].y = -point[0].y;
-        point[2].x = -point[0].x;
-        point[2].y = -point[0].y;
-        point[3].x = -point[0].x;
-        point[3].y =  point[0].y;
-        point[4].x =  point[0].x;
-        point[4].y =  point[0].y;
-        if(symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
-          aox = (0.5 - symbol->anchorpoint_x) * sx;
-          aoy = (0.5 - symbol->anchorpoint_y) * sy;
-          for(p=0; p<5; p++) {
-            point[p].x += aox;
-            point[p].y += aoy;
-          }
-        }
-        {
-          double rot = -style->angle * MS_DEG_TO_RAD;
-          double sina = sin(rot);
-          double cosa = cos(rot);
-          for(p=0; p<5; p++) {
-            double tmpx = point[p].x;
-            point[p].x = point[p].x * cosa - point[p].y * sina;
-            point[p].y = tmpx * sina + point[p].y * cosa;
-          }
-        }
-        aox = annopoint->x + style->offsetx * ts->scalefactor;
-        aoy = annopoint->y + style->offsety * ts->scalefactor;
-        for(p=0; p<5; p++) {
-          point[p].x += aox;
-          point[p].y += aoy;
-        }
-        fastComputeBounds(poly->poly,&poly->bbox);
-      } else {
-        double aox = (0.5 - symbol->anchorpoint_x)*sx + annopoint->x + style->offsetx * ts->scalefactor;
-        double aoy = (0.5 - symbol->anchorpoint_y)*sy + annopoint->y + style->offsety * ts->scalefactor;
-        poly->poly = NULL;
-        poly->bbox.maxx = sx/2.0 + aox; 
-        poly->bbox.minx = -sx/2.0 + aox; 
-        poly->bbox.maxy = sy/2.0 + aoy;
-        poly->bbox.miny = -sy/2.0 + aoy;
-      }
-      break;
-    }
-  }
-  if(i == ts->label->numstyles)
-    return MS_FALSE; /* the label has no marker styles */
-  else
-    return MS_TRUE;
-}
-
-
-/* check that the current entry does not fall close to a label with identical text, if configured so.
- * Currently only checks the first label/text */
-
-int msCheckLabelMinDistance(mapObj *map, labelCacheMemberObj *lc)
-{
-  int i;
-  textSymbolObj *s; /* shortcut */
-  textSymbolObj *ts;
-  rectObj buffered;
-  if (lc->numtextsymbols == 0)
-    return MS_FALSE; /* no label with text */
-  s = lc->textsymbols[0];
-
-  if (!s->annotext || s->label->mindistance <= 0.0 || s->label->force == MS_TRUE)
-    return MS_FALSE; /*  min distance is not checked */
-
-  /* we buffer the label and check for intersection instead of calculating
-     the distance of two textpaths. we also buffer only the bbox of lc for 
-     faster computation (it is still compared to the full textpath
-     of the label cache members). 
-  */
-  buffered = lc->bbox;
-  buffered.minx -= s->label->mindistance * s->resolutionfactor;
-  buffered.miny -= s->label->mindistance * s->resolutionfactor;
-  buffered.maxx += s->label->mindistance * s->resolutionfactor;
-  buffered.maxy += s->label->mindistance * s->resolutionfactor;
-
-  for (i = 0; i < map->labelcache.num_rendered_members; i++) {
-    labelCacheMemberObj *ilc = map->labelcache.rendered_text_symbols[i];
-    if (ilc->numtextsymbols == 0 || !ilc->textsymbols[0]->annotext)
-       continue;
-
-    ts = ilc->textsymbols[0];
-    if (strcmp(s->annotext, ts->annotext) != 0) {
-      /* only check min distance against same label */
-      continue;
-    }
-
-    if (msPointInRect(&ilc->point, &buffered) == MS_TRUE) {
-      return MS_TRUE;
-    }
-
-    if(ts->textpath && ts->textpath->absolute) {
-      if (intersectLabelPolygons(ts->textpath->bounds.poly, &ilc->bbox, NULL, &buffered) == MS_TRUE) {
-        return MS_TRUE;
-      }
-      continue;
-    }
-
-
-    if (intersectLabelPolygons(NULL, &ilc->bbox, NULL, &buffered) == MS_TRUE) {
-        return MS_TRUE;
-    }
-
-  }
-  return MS_FALSE;
-}
-
-void copyLabelBounds(label_bounds *dst, label_bounds *src) {
-  *dst = *src;
-  if(src->poly) {
-    int i;
-    dst->poly = msSmallMalloc(sizeof(lineObj));
-    dst->poly->numpoints = src->poly->numpoints;
-    dst->poly->point = msSmallMalloc(dst->poly->numpoints * sizeof(pointObj));
-    for(i=0; i<dst->poly->numpoints; i++) {
-      dst->poly->point[i] = src->poly->point[i];
-    }
-  }
-}
-
-static int getLabelPositionFromString(char *pszString) {
-  if (strcasecmp(pszString, "UL")==0) return MS_UL;
-  else if (strcasecmp(pszString, "LR")==0) return MS_LR;
-  else if (strcasecmp(pszString, "UR")==0) return MS_UR;
-  else if (strcasecmp(pszString, "LL")==0) return MS_LL;
-  else if (strcasecmp(pszString, "CR")==0) return MS_CR;
-  else if (strcasecmp(pszString, "CL")==0) return MS_CL;
-  else if (strcasecmp(pszString, "UC")==0) return MS_UC;
-  else if (strcasecmp(pszString, "LC")==0) return MS_LC;
-  else return MS_CC;
-}
-
-int msDrawLabelCache(mapObj *map, imageObj *image)
-{
-  int nReturnVal = MS_SUCCESS;
-  struct mstimeval starttime={0}, endtime={0};
-
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) msGettimeofday(&starttime, NULL);
-
-  if(image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
-      int i, l, ll, priority, its;
-
-      double marker_offset_x, marker_offset_y;
-      int label_offset_x, label_offset_y;
-      const char *value;
-
-      labelCacheMemberObj *cachePtr=NULL;
-      layerObj *layerPtr=NULL;
-      classObj *classPtr=NULL;
-      textSymbolObj *textSymbolPtr=NULL;
-
-      /*
-       * some statically allocated containers for storing label bounds before
-       * copying them into the cachePtr: we avoid allocating these structures
-       * at runtime, except for the labels that are actually rendered.
-       */
-      lineObj labelpoly_line;
-      pointObj labelpoly_points[5];
-      label_bounds labelpoly_bounds = {0};
-      lineObj  label_marker_line;
-      pointObj label_marker_points[5];
-      label_bounds label_marker_bounds;
-      lineObj metrics_line;
-      pointObj metrics_points[5];
-      label_bounds metrics_bounds;
-
-      label_marker_line.point = label_marker_points;
-      label_marker_line.numpoints = 5;
-      metrics_line.point = metrics_points;
-      metrics_line.numpoints = 5;
-      labelpoly_line.point = labelpoly_points;
-      labelpoly_line.numpoints = 5;
-
-      /* Look for labelcache_map_edge_buffer map metadata
-       * If set then the value defines a buffer (in pixels) along the edge of the
-       * map image where labels can't fall
-       */
-      if((value = msLookupHashTable(&(map->web.metadata), "labelcache_map_edge_buffer")) != NULL) {
-        map->labelcache.gutter = MS_ABS(atoi(value));
-        if(map->debug) msDebug("msDrawLabelCache(): labelcache_map_edge_buffer = %d\n", map->labelcache.gutter);
-      }
-
-      for(priority=MS_MAX_LABEL_PRIORITY-1; priority>=0; priority--) {
-        labelCacheSlotObj *cacheslot;
-        cacheslot = &(map->labelcache.slots[priority]);
-
-        for(l=cacheslot->numlabels-1; l>=0; l--) {
-          cachePtr = &(cacheslot->labels[l]); /* point to right spot in the label cache */
-
-          layerPtr = (GET_LAYER(map, cachePtr->layerindex)); /* set a couple of other pointers, avoids nasty references */
-          classPtr = (GET_CLASS(map, cachePtr->layerindex, cachePtr->classindex));
-
-          if(cachePtr->textsymbols[0]->textpath && cachePtr->textsymbols[0]->textpath->absolute) {
-            /* we have an angle follow label */
-            cachePtr->bbox = cachePtr->textsymbols[0]->textpath->bounds.bbox;
-
-            /* before going any futher, check that mindistance is respected */
-            if (cachePtr->numtextsymbols && cachePtr->textsymbols[0]->label->mindistance > 0.0 && cachePtr->textsymbols[0]->annotext) {
-              if (msCheckLabelMinDistance(map, cachePtr) == MS_TRUE) {
-                cachePtr->status = MS_DELETE;
-                MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                          "Skipping labelgroup %d \"%s\" in layer \"%s\": too close to an identical label (mindistance)\n",
-                          l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
-                continue; /* move on to next entry, this one is too close to an already placed one */
-              }
-            }
-
-            if(!cachePtr->textsymbols[0]->label->force)
-              cachePtr->status = msTestLabelCacheCollisions(map,cachePtr,&cachePtr->textsymbols[0]->textpath->bounds, priority, l);
-            else
-              cachePtr->status = MS_ON;
-            if(cachePtr->status) {
-
-
-              if (MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map, image, cachePtr->textsymbols[0]->annopoint /*not used*/, cachePtr->textsymbols[0])))
-              {
-                return MS_FAILURE;
-              }
-              insertRenderedLabelMember(map, cachePtr);
-            } else {
-              MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG,map,
-                  "Skipping follow labelgroup %d \"%s\" in layer \"%s\": text collided\n",
-                  l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
-            }
-            cachePtr->status = MS_DELETE; /* we're done with this label, it won't even have a second chance in the leader phase */
-          } else {
-            marker_offset_x = marker_offset_y = 0; /* assume no marker */
-            
-            if (layerPtr->type == MS_LAYER_POINT && cachePtr->markerid!=-1) { /* there is a marker already in the image that we need to account for */
-              markerCacheMemberObj *markerPtr = &(cacheslot->markers[cachePtr->markerid]); /* point to the right spot in the marker cache*/
-              marker_offset_x = (markerPtr->bounds.maxx-markerPtr->bounds.minx)/2.0;
-              marker_offset_y = (markerPtr->bounds.maxy-markerPtr->bounds.miny)/2.0;
-            }
-
-
-            /*
-            ** all other cases *could* have multiple labels defined
-            */
-            cachePtr->status = MS_ON; /* assume this cache element can be placed */
-            for(ll=0; ll<cachePtr->numtextsymbols; ll++) { /* RFC 77 TODO: Still may want to step through backwards... */
-              int label_marker_status = MS_ON, have_label_marker, metrics_status = MS_ON;
-              int need_labelpoly = 0;
-              
-              /* reset the lineObj which may have been unset by a previous call to get_metrics() */
-              label_marker_bounds.poly = &label_marker_line;
-              labelpoly_bounds.poly = &labelpoly_line;
-
-              textSymbolPtr = cachePtr->textsymbols[ll];
-              for(i=0; i<textSymbolPtr->label->numstyles; i++) {
-                if(textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || 
-                   textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
-                  need_labelpoly = 1;
-                  break;
-                }
-              }
-
-              /* compute the poly of the label styles */
-              if((have_label_marker = computeMarkerBounds(map,&cachePtr->point,textSymbolPtr, &label_marker_bounds)) == MS_TRUE) {
-                if(cachePtr->numtextsymbols > 1) { /* FIXME this test doesn't seem right, should probably check if we have an annotation layer with a regular style defined */
-                  marker_offset_x = (label_marker_bounds.bbox.maxx-label_marker_bounds.bbox.minx)/2.0;
-                  marker_offset_y = (label_marker_bounds.bbox.maxy-label_marker_bounds.bbox.miny)/2.0;
-                } else {
-                  /* we might be using an old style behavior with a markerPtr */
-                  marker_offset_x = MS_MAX(marker_offset_x,(label_marker_bounds.bbox.maxx-label_marker_bounds.bbox.minx)/2.0);
-                  marker_offset_y = MS_MAX(marker_offset_y,(label_marker_bounds.bbox.maxy-label_marker_bounds.bbox.miny)/2.0);
-                }
-                /* add marker to cachePtr->poly */
-                if(textSymbolPtr->label->force != MS_TRUE) {
-                  label_marker_status = msTestLabelCacheCollisions(map, cachePtr, &label_marker_bounds ,priority, l);
-                }
-                if(label_marker_status == MS_OFF &&
-                    !(textSymbolPtr->label->force==MS_ON || classPtr->leader)) {
-                  cachePtr->status = MS_DELETE;
-                  MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                      "Skipping label %d of labelgroup %d of class %d in layer \"%s\": marker collided\n",
-                      ll, l, cachePtr->classindex, layerPtr->name);
-                  break; /* the marker collided, break from multi-label loop */
-                }
-              }
-              if(have_label_marker == -1) return MS_FAILURE; /* error occured (symbol not found, etc...) */
-
-              if(textSymbolPtr->annotext) {
-                /*
-                 * if we don't have an offset defined, first check that the labelpoint itself does not collide
-                 * this helps speed things up in dense labelling, as if the labelpoint collides there's
-                 * no use in computing the labeltext bounds (i.e. going into shaping+freetype).
-                 * We do however skip collision testing against the marker cache, as we want to allow rendering
-                 * a label for points that overlap each other: this is done by setting priority to MAX_PRIORITY
-                 * in the call to msTestLabelCacheCollisions (which is a hack!!)
-                 */
-                if(!have_label_marker && textSymbolPtr->label->force != MS_TRUE && !classPtr->leader &&
-                    !textSymbolPtr->label->offsetx && !textSymbolPtr->label->offsety) {
-                  label_bounds labelpoint_bounds;
-                  labelpoint_bounds.poly = NULL;
-                  labelpoint_bounds.bbox.minx = cachePtr->point.x - 0.1;
-                  labelpoint_bounds.bbox.maxx = cachePtr->point.x + 0.1;
-                  labelpoint_bounds.bbox.miny = cachePtr->point.y - 0.1;
-                  labelpoint_bounds.bbox.maxy = cachePtr->point.y + 0.1;
-                  if(MS_OFF == msTestLabelCacheCollisions(map, cachePtr, &labelpoint_bounds, MS_MAX_LABEL_PRIORITY, l)) {
-                    cachePtr->status = MS_DELETE; /* we won't check for leader offseted positions, as the anchor point colided */
-                    MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                        "Skipping label %d \"%s\" of labelgroup %d of class %d in layer \"%s\": labelpoint collided\n",
-                        ll, textSymbolPtr->annotext, l, cachePtr->classindex, layerPtr->name);
-                    break;
-                  }
-                }
-
-                /* compute label size */
-                if(!textSymbolPtr->textpath) {
-                  if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,textSymbolPtr))) {
-                    return MS_FAILURE;
-                  }
-                }
-
-                /* if our label has an outline, adjust the marker offset so the outlinecolor does
-                 * not bleed into the marker */
-                if(marker_offset_x && MS_VALID_COLOR(textSymbolPtr->label->outlinecolor)) {
-                  marker_offset_x += textSymbolPtr->label->outlinewidth/2.0 * textSymbolPtr->scalefactor;
-                  marker_offset_y += textSymbolPtr->label->outlinewidth/2.0 * textSymbolPtr->scalefactor;
-                }
-                
-                /* apply offset and buffer settings */
-                if(textSymbolPtr->label->anglemode != MS_FOLLOW) {
-                  label_offset_x = textSymbolPtr->label->offsetx * textSymbolPtr->scalefactor;
-                  label_offset_y = textSymbolPtr->label->offsety * textSymbolPtr-> scalefactor;
-                } else {
-                  label_offset_x = 0;
-                  label_offset_y = 0;
-                }
-
-                if(textSymbolPtr->label->position == MS_AUTO) {
-                  /* no point in using auto positionning if the marker cannot be placed */
-                  int positions[MS_POSITIONS_LENGTH], npositions=0;
-		  
-                  /*
-                  **   (Note: might be able to re-order this for more speed.)
-                  */
-		  if(msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS")) {
-                    int p, ncustom_positions=0;
-                    char **custom_positions = msStringSplitComplex(msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS"), ",", &ncustom_positions, MS_STRIPLEADSPACES|MS_STRIPENDSPACES);
-                    for(p=0; p<MS_MIN(9,ncustom_positions); p++)
-                      positions[p] = getLabelPositionFromString(custom_positions[p]);
-                    npositions = p;
-                    msFree(custom_positions);
-		  } else if(layerPtr->type == MS_LAYER_POLYGON && marker_offset_x==0 ) {
-                    positions[0]=MS_CC;
-                    positions[1]=MS_UC;
-                    positions[2]=MS_LC;
-                    positions[3]=MS_CL;
-                    positions[4]=MS_CR;
-                    npositions = 5;
-                  } else if(layerPtr->type == MS_LAYER_LINE && marker_offset_x == 0) {
-                    positions[0]=MS_UC;
-                    positions[1]=MS_LC;
-                    positions[2]=MS_CC;
-                    npositions = 3;
-                  } else {
-                    positions[0]=MS_UL;
-                    positions[1]=MS_LR;
-                    positions[2]=MS_UR;
-                    positions[3]=MS_LL;
-                    positions[4]=MS_CR;
-                    positions[5]=MS_CL;
-                    positions[6]=MS_UC;
-                    positions[7]=MS_LC;
-                    npositions = 8;
-                  }
-
-                  for(i=0; i<npositions; i++) {
-                    // RFC 77 TODO: take label_marker_offset_x/y into account
-                    metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), positions[i], textSymbolPtr->textpath,
-                                                           marker_offset_x + label_offset_x, marker_offset_y + label_offset_y,
-                                                           textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor, &metrics_bounds);
-                    if(textSymbolPtr->label->force == MS_OFF) {
-                      for(its=0;its<ll;its++) {
-                        /* check for collisions inside the label group */
-                        if(intersectTextSymbol(cachePtr->textsymbols[its],&metrics_bounds) == MS_TRUE) {
-                          /* there was a self intersection */
-                          break; /* next position, will break out to next position in containing loop*/
-                        }
-                        if(its != ll)
-                          continue; /* goto next position, this one had an intersection with our own label group */
-                      }
-                    }
-
-                    metrics_status = msTestLabelCacheCollisions(map, cachePtr,&metrics_bounds, priority, l);
-
-                    /* found a suitable place for this label */
-                    if(metrics_status == MS_TRUE || (i==(npositions-1) && textSymbolPtr->label->force == MS_ON)) {
-                      metrics_status = MS_TRUE; /* set to true in case we are forcing it */
-                      /* compute anno poly for label background if needed */
-                      if(need_labelpoly) get_metrics(&(cachePtr->point), positions[i], textSymbolPtr->textpath,
-                                                                marker_offset_x + label_offset_x, marker_offset_y + label_offset_y,
-                                                                textSymbolPtr->rotation, 1, &labelpoly_bounds);
-
-                      break; /* ...out of position loop */
-                    }
-                  } /* next position */
-
-                  /* if position auto didn't manage to find a position, but we have leader configured
-                   * for the class, then we want to compute the label poly anyway, placed as MS_CC */
-                  if(classPtr->leader && metrics_status == MS_FALSE) {
-                    metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath, label_offset_x, label_offset_y,
-                                                           textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor,
-                                                           &metrics_bounds);
-                    if(need_labelpoly) get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath,
-                                                              label_offset_x, label_offset_y,
-                                                              textSymbolPtr->rotation, 1, &labelpoly_bounds);
-                  }
-                } else { /* explicit position */
-                  if(textSymbolPtr->label->position == MS_CC) { /* don't need the marker_offset */
-                    metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath, label_offset_x, label_offset_y,
-                            textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor, &metrics_bounds);
-                    if(need_labelpoly) get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath,
-                                                              label_offset_x, label_offset_y, textSymbolPtr->rotation, 1, &labelpoly_bounds);
-                  } else {
-                    metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), textSymbolPtr->label->position, textSymbolPtr->textpath,
-                                                           marker_offset_x + label_offset_x, marker_offset_y + label_offset_y,
-                                                           textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor,
-                                                           &metrics_bounds);
-                    if(need_labelpoly) get_metrics(&(cachePtr->point), textSymbolPtr->label->position, textSymbolPtr->textpath,
-                                                              marker_offset_x + label_offset_x, marker_offset_y + label_offset_y, textSymbolPtr->rotation, 1, &labelpoly_bounds);
-                  }
-
-                  if(textSymbolPtr->label->force == MS_ON) {
-                    metrics_status = MS_ON;
-                  } else {
-                    if(textSymbolPtr->label->force == MS_OFF) {
-                      /* check for collisions inside the label group unless the label is FORCE GROUP */
-                      for(its=0;its<ll;its++) {
-                        /* check for collisions inside the label group */
-                        if(intersectTextSymbol(cachePtr->textsymbols[its],&metrics_bounds) == MS_TRUE) {
-                          /* there was a self intersection */
-                          break; /* will break out to next position in containing loop*/
-                        }
-                        if(its != ll) {
-                          cachePtr->status = MS_DELETE; /* TODO RFC98: check if this is correct */
-                          MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG,map,
-                              "Skipping label %d (\"%s\") of labelgroup %d of class %d in layer \"%s\": intercollision with label text inside labelgroup\n",
-                              ll, textSymbolPtr->annotext, l,cachePtr->classindex, layerPtr->name);
-                          break; /* collision within the group, break out of textSymbol loop */
-                        }
-                      }
-                    }
-                    /* TODO: in case we have leader lines and multiple labels, there's no use in testing for labelcache collisions
-                    * once a first collision has been found. we only need to know that the label group has collided, and the
-                    * poly of the whole label group: if(label_group) testLabelCacheCollisions */
-                    metrics_status = msTestLabelCacheCollisions(map, cachePtr,&metrics_bounds, priority, l);
-                  }
-                } /* end POSITION AUTO vs Fixed POSITION */
-
-                if(!metrics_status && classPtr->leader == 0) {
-                  cachePtr->status = MS_DELETE;
-                  MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG,map,
-                      "Skipping label %d \"%s\" of labelgroup %d of class %d in layer \"%s\": text collided\n",
-                      ll, textSymbolPtr->annotext, l, cachePtr->classindex, layerPtr->name);
-                  break; /* no point looking at more labels, unless their is a leader defined */
-                }
-              }
-
-              /* if we're here, we can either fit the label directly, or we need to put it in the leader queue */
-              assert((metrics_status && label_marker_status) || classPtr->leader);
-
-              if(textSymbolPtr->annotext) {
-                copyLabelBounds(&textSymbolPtr->textpath->bounds, &metrics_bounds);
-              }
-              if(have_label_marker) {
-                if(!textSymbolPtr->style_bounds)
-                  textSymbolPtr->style_bounds = msSmallCalloc(textSymbolPtr->label->numstyles, sizeof(label_bounds*));
-                for(its=0;its<textSymbolPtr->label->numstyles; its++) {
-                  if(textSymbolPtr->label->styles[its]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                    textSymbolPtr->style_bounds[its] = msSmallMalloc(sizeof(label_bounds));
-                    copyLabelBounds(textSymbolPtr->style_bounds[its], &label_marker_bounds);
-                  }
-                }
-              }
-              if(!label_marker_status || ! metrics_status) {
-                MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                    "Putting label %d of labelgroup %d of class %d , layer \"%s\" in leader queue\n",
-                    ll, l, cachePtr->classindex, layerPtr->name);
-                cachePtr->status = MS_OFF; /* we have a collision, but this entry is a candidate for leader testing */
-              }
-
-              /* do we need to copy the labelpoly, or can we use the static one ?*/
-              if(cachePtr->numtextsymbols > 1 || (cachePtr->status == MS_OFF && classPtr->leader)) {
-                /*
-                 * if we have more than one label, or if we have a single one which didn't fit but needs
-                 * to go through leader offset testing
-                 */
-                if(!textSymbolPtr->style_bounds)
-                  textSymbolPtr->style_bounds = msSmallCalloc(textSymbolPtr->label->numstyles, sizeof(label_bounds*));
-                for(its=0;its<textSymbolPtr->label->numstyles; its++) {
-                  if(textSymbolPtr->label->styles[its]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || 
-                     textSymbolPtr->label->styles[its]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
-                    textSymbolPtr->style_bounds[its] = msSmallMalloc(sizeof(label_bounds));
-                    copyLabelBounds(textSymbolPtr->style_bounds[its], &labelpoly_bounds);
-                  }
-                }
-
-              } /* else: we'll use labelpoly_bounds directly below */
-            } /* next label in the group */
-
-            if(cachePtr->status != MS_DELETE) {
-              /* compute the global label bbox */
-              int inited = 0,s;
-              for(its=0;its<cachePtr->numtextsymbols;its++) {
-                if(cachePtr->textsymbols[its]->annotext) {
-                  if(inited == 0) {
-                    cachePtr->bbox = cachePtr->textsymbols[its]->textpath->bounds.bbox;
-                    inited = 1;
-                  } else {
-                    cachePtr->bbox.minx = MS_MIN(cachePtr->bbox.minx, cachePtr->textsymbols[its]->textpath->bounds.bbox.minx);
-                    cachePtr->bbox.miny = MS_MIN(cachePtr->bbox.miny, cachePtr->textsymbols[its]->textpath->bounds.bbox.miny);
-                    cachePtr->bbox.maxx = MS_MAX(cachePtr->bbox.maxx, cachePtr->textsymbols[its]->textpath->bounds.bbox.maxx);
-                    cachePtr->bbox.maxy = MS_MAX(cachePtr->bbox.maxy, cachePtr->textsymbols[its]->textpath->bounds.bbox.maxy);
-                  }
-                }
-                for(s=0; s<cachePtr->textsymbols[its]->label->numstyles; s++) {
-                  if(cachePtr->textsymbols[its]->label->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                    if(inited == 0) {
-                      cachePtr->bbox = cachePtr->textsymbols[its]->style_bounds[s]->bbox;
-                      inited = 1;
-                      break;
-                    } else {
-                      cachePtr->bbox.minx = MS_MIN(cachePtr->bbox.minx, cachePtr->textsymbols[its]->style_bounds[s]->bbox.minx);
-                      cachePtr->bbox.miny = MS_MIN(cachePtr->bbox.miny, cachePtr->textsymbols[its]->style_bounds[s]->bbox.miny);
-                      cachePtr->bbox.maxx = MS_MAX(cachePtr->bbox.maxx, cachePtr->textsymbols[its]->style_bounds[s]->bbox.maxx);
-                      cachePtr->bbox.maxy = MS_MAX(cachePtr->bbox.maxy, cachePtr->textsymbols[its]->style_bounds[s]->bbox.maxy);
-                      break; 
-                    }
-                  }
-                }
-              }
-            }
-
-            /* check that mindistance is respected */
-            if (cachePtr->numtextsymbols && cachePtr->textsymbols[0]->label->mindistance > 0.0 && cachePtr->textsymbols[0]->annotext) {
-              if (msCheckLabelMinDistance(map, cachePtr) == MS_TRUE) {
-                cachePtr->status = MS_DELETE;
-                MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                         "Skipping labelgroup %d \"%s\" in layer \"%s\": too close to an identical label (mindistance)\n",
-                         l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
-              }
-            }
-
-            if(cachePtr->status == MS_OFF || cachePtr->status == MS_DELETE)
-              continue; /* next labelCacheMemberObj, as we had a collision */
-
-            /* insert the rendered label */
-            insertRenderedLabelMember(map, cachePtr);
-
-            for(ll=0; ll<cachePtr->numtextsymbols; ll++) {
-              textSymbolPtr = cachePtr->textsymbols[ll];
-
-              /* here's where we draw the label styles */
-                for(i=0; i<textSymbolPtr->label->numstyles; i++) {
-                  if(textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                    if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &(cachePtr->point), textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                      return MS_FAILURE;
-                    }
-                  } else if(textSymbolPtr->annotext && textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-                    if(textSymbolPtr->style_bounds && textSymbolPtr->style_bounds[i]) {
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawLabelBounds(map,image,textSymbolPtr->style_bounds[i],textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
-                    } else {
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawLabelBounds(map,image,&labelpoly_bounds,textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
-                    }
-		  } else if(textSymbolPtr->annotext && textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
-                    pointObj labelCenter;
-
-                    if(textSymbolPtr->style_bounds && textSymbolPtr->style_bounds[i]) {
-                      labelCenter.x = (textSymbolPtr->style_bounds[i]->bbox.maxx + textSymbolPtr->style_bounds[i]->bbox.minx)/2;
-                      labelCenter.y = (textSymbolPtr->style_bounds[i]->bbox.maxy + textSymbolPtr->style_bounds[i]->bbox.miny)/2;
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map,image,&labelCenter,textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
-                    } else {
-                      labelCenter.x = (labelpoly_bounds.bbox.maxx + labelpoly_bounds.bbox.minx)/2;
-                      labelCenter.y = (labelpoly_bounds.bbox.maxy + labelpoly_bounds.bbox.miny)/2;
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map,image,&labelCenter,textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
-                    }
-
-                  } else {
-                    msSetError(MS_MISCERR,"Labels only support LABELPNT, LABELPOLY and LABELCENTER GEOMTRANSFORMS", "msDrawLabelCache()");
-                    return MS_FAILURE;
-                  }
-                }
-              
-              if(textSymbolPtr->annotext) {
-                if(MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map,image,textSymbolPtr->annopoint,textSymbolPtr))) {
-                  return MS_FAILURE;
-                }
-              }
-            }
-          }
-        } /* next label(group) from cacheslot */
-        if(MS_UNLIKELY(MS_FAILURE == msDrawOffsettedLabels(image, map, priority))) {
-          return MS_FAILURE;
-        }
-      } /* next priority */
-#ifdef TBDEBUG
-      styleObj tstyle;
-      initStyle(&tstyle);
-      tstyle.width = 1;
-      tstyle.color.alpha = 255;
-      tstyle.color.red = 255;
-      tstyle.color.green = 0;
-      tstyle.color.blue = 0;
-      for(priority=MS_MAX_LABEL_PRIORITY-1; priority>=0; priority--) {
-        labelCacheSlotObj *cacheslot;
-        cacheslot = &(map->labelcache.slots[priority]);
-
-        for(l=cacheslot->numlabels-1; l>=0; l--) {
-          cachePtr = &(cacheslot->labels[l]); /* point to right spot in the label cache */
-          /*
-          assert((cachePtr->poly == NULL && cachePtr->status == MS_OFF) ||
-                  (cachePtr->poly && (cachePtr->status == MS_ON));
-           */
-          if(cachePtr->status) {
-            msDrawLineSymbol(map, image, cachePtr->poly, &tstyle, layerPtr->scalefactor);
-          }
-        }
-      }
-#endif
-
-      nReturnVal = MS_SUCCESS; /* necessary? */
-    }
-  }
-
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&endtime, NULL);
-    msDebug("msDrawMap(): Drawing Label Cache, %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-  }
-
-  return nReturnVal;
-}
-
-
-/**
- * Generic function to tell the underline device that layer
- * drawing is stating
- */
-
-void msImageStartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  if (image) {
-    if( MS_RENDERER_PLUGIN(image->format) ) {
-      const char *approximation_scale = msLayerGetProcessingKey( layer, "APPROXIMATION_SCALE" );
-      if(approximation_scale) {
-        if(!strncasecmp(approximation_scale,"ROUND",5)) {
-          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_ROUND;
-        } else if(!strncasecmp(approximation_scale,"FULL",4)) {
-          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_FULLRESOLUTION;
-        } else if(!strncasecmp(approximation_scale,"SIMPLIFY",8)) {
-          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_SIMPLIFY;
-        } else {
-          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_SNAPTOGRID;
-          MS_IMAGE_RENDERER(image)->approximation_scale = atof(approximation_scale);
-        }
-      } else {
-        MS_IMAGE_RENDERER(image)->transform_mode = MS_IMAGE_RENDERER(image)->default_transform_mode;
-        MS_IMAGE_RENDERER(image)->approximation_scale = MS_IMAGE_RENDERER(image)->default_approximation_scale;
-      }
-      MS_IMAGE_RENDERER(image)->startLayer(image, map, layer);
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
-      msImageStartLayerIM(map, layer, image);
-
-  }
-}
-
-
-/**
- * Generic function to tell the underline device that layer
- * drawing is ending
- */
-
-void msImageEndLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  if(image) {
-    if( MS_RENDERER_PLUGIN(image->format) ) {
-      MS_IMAGE_RENDERER(image)->endLayer(image,map,layer);
-    }
-  }
-}
-
-/**
- * Generic function to tell the underline device that shape
- * drawing is starting
- */
-
-void msDrawStartShape(mapObj *map, layerObj *layer, imageObj *image,
-                      shapeObj *shape)
-{
-  (void)map;
-  (void)layer;
-  if (image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
-      if (image->format->vtable->startShape)
-        image->format->vtable->startShape(image, shape);
-    }
-
-
-  }
-}
-
-
-/**
- * Generic function to tell the underline device that shape
- * drawing is ending
- */
-
-void msDrawEndShape(mapObj *map, layerObj *layer, imageObj *image,
-                    shapeObj *shape)
-{
-  (void)map;
-  (void)layer;
-  if(MS_RENDERER_PLUGIN(image->format)) {
-    if (image->format->vtable->endShape)
-      image->format->vtable->endShape(image, shape);
-  }
-}
-/**
- * take the value from the shape and use it to change the
- * color in the style to match the range map
- */
-int msShapeToRange(styleObj *style, shapeObj *shape)
-{
-  /*first, get the value of the rangeitem, which should*/
-  /*evaluate to a double*/
-  const char* fieldStr = shape->values[style->rangeitemindex];
-  if (fieldStr == NULL) { /*if there's not value, bail*/
-    return MS_FAILURE;
-  }
-  double fieldVal = atof(fieldStr); /*faith that it's ok -- */
-  /*should switch to strtod*/
-  return msValueToRange(style, fieldVal, MS_COLORSPACE_RGB);
-}
-
-/**
- * Allow direct mapping of a value so that mapscript can use the
- * Ranges.  The styls passed in is updated to reflect the right color
- * based on the fieldVal
- */
-int msValueToRange(styleObj *style, double fieldVal, colorspace cs)
-{
-  double range;
-  double scaledVal;
-
-  range = style->maxvalue - style->minvalue;
-  scaledVal = (fieldVal - style->minvalue)/range;
-
-  if(cs == MS_COLORSPACE_RGB) {
-    /*At this point, we know where on the range we need to be*/
-    /*However, we don't know how to map it yet, since RGB(A) can */
-    /*Go up or down*/
-    style->color.red = (int)(MS_MAX(0,(MS_MIN(255, (style->mincolor.red + ((style->maxcolor.red - style->mincolor.red) * scaledVal))))));
-    style->color.green = (int)(MS_MAX(0,(MS_MIN(255,(style->mincolor.green + ((style->maxcolor.green - style->mincolor.green) * scaledVal))))));
-    style->color.blue = (int)(MS_MAX(0,(MS_MIN(255,(style->mincolor.blue + ((style->maxcolor.blue - style->mincolor.blue) * scaledVal))))));
-    style->color.alpha = (int)(MS_MAX(0,(MS_MIN(255,(style->mincolor.alpha + ((style->maxcolor.alpha - style->mincolor.alpha) * scaledVal))))));
-  } else {
-    /* HSL */
-    assert(cs == MS_COLORSPACE_HSL);
-    if(fieldVal <= style->minvalue) style->color = style->mincolor;
-    else if(fieldVal >= style->maxvalue) style->color = style->maxcolor;
-    else {
-      double mh,ms,ml,Mh,Ms,Ml;
-      msRGBtoHSL(&style->mincolor,&mh,&ms,&ml);
-      msRGBtoHSL(&style->maxcolor,&Mh,&Ms,&Ml);
-      mh+=(Mh-mh)*scaledVal;
-      ms+=(Ms-ms)*scaledVal;
-      ml+=(Ml-ml)*scaledVal;
-      msHSLtoRGB(mh,ms,ml,&style->color);
-      style->color.alpha = style->mincolor.alpha + (style->maxcolor.alpha - style->mincolor.alpha)*scaledVal;
-    }
-  }
-  /*( "msMapRange(): %i %i %i", style->color.red , style->color.green, style->color.blue);*/
-
-#if ALPHACOLOR_ENABLED
-  /*NO ALPHA RANGE YET  style->color.alpha = style->mincolor.alpha + ((style->maxcolor.alpha - style->mincolor.alpha) * scaledVal);*/
-#endif
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapdrawgdal.c 8.2.0~beta1-1~exp1/mapdrawgdal.c
--- 8.0.1-5/mapdrawgdal.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapdrawgdal.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2408 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Code for drawing GDAL raster layers.  Called from
- *           msDrawRasterLayerLow() in mapraster.c.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <assert.h>
-#include <stdbool.h>
-#include "mapserver.h"
-#include "mapresample.h"
-#include "mapthread.h"
-#include "maptime.h"
-
-
-extern int InvGeoTransform( double *gt_in, double *gt_out );
-
-#define MAXCOLORS 256
-#define GEO_TRANS(tr,x,y)  ((tr)[0]+(tr)[1]*(x)+(tr)[2]*(y))
-#define SKIP_MASK(x,y) (mask_rb && !*(mask_rb->data.rgba.a+(y)*mask_rb->data.rgba.row_step+(x)*mask_rb->data.rgba.pixel_step))
-
-#include "gdal.h"
-#include "cpl_string.h"
-
-#include "gdal_alg.h"
-
-static bool
-IsNoData( double dfValue, double dfNoDataValue );
-
-static int
-LoadGDALImages( GDALDatasetH hDS, int band_numbers[4], int band_count,
-                layerObj *layer,
-                int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-                GByte *pabyBuffer,
-                int dst_xsize, int dst_ysize,
-                int *pbHaveRGBNoData,
-                int *pnNoData1, int *pnNoData2, int *pnNoData3,
-                bool *pbScaled, double *pdfScaleMin, double *pdfScaleRatio,
-                bool **ppbIsNoDataBuffer );
-static int
-msDrawRasterLayerGDAL_RawMode(
-  mapObj *map, layerObj *layer, imageObj *image, GDALDatasetH hDS,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize );
-
-static int
-msDrawRasterLayerGDAL_16BitClassification(
-  mapObj *map, layerObj *layer, rasterBufferObj *rb,
-  GDALRasterBandH hBand,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize );
-
-
-/*
- * rasterBufferObj setting macros.
- */
-
-
-
-/************************************************************************/
-/*                       msDrawRasterLayerGDAL()                        */
-/************************************************************************/
-
-int msDrawRasterLayerGDAL(mapObj *map, layerObj *layer, imageObj *image,
-                          rasterBufferObj *rb, void *hDSVoid )
-
-{
-  int i; /* loop counters */
-  int cmap[MAXCOLORS];
-#ifndef NDEBUG
-  int cmap_set = FALSE;
-#endif
-  unsigned char rb_cmap[4][MAXCOLORS];
-  double adfGeoTransform[6], adfInvGeoTransform[6];
-  int dst_xoff, dst_yoff, dst_xsize, dst_ysize;
-  int src_xoff, src_yoff, src_xsize, src_ysize;
-  double llx, lly, urx, ury;
-  rectObj copyRect, mapRect;
-  unsigned char *pabyRaw1=NULL, *pabyRaw2=NULL, *pabyRaw3=NULL,
-                 *pabyRawAlpha = NULL;
-  int classified = FALSE;
-  int red_band=0, green_band=0, blue_band=0, alpha_band=0;
-  int band_count, band_numbers[4];
-  GDALDatasetH hDS = hDSVoid;
-  GDALColorTableH hColorMap=NULL;
-  GDALRasterBandH hBand1=NULL, hBand2=NULL, hBand3=NULL, hBandAlpha=NULL;
-  int bHaveRGBNoData = FALSE;
-  int nNoData1=-1,nNoData2=-1,nNoData3=-1;
-  rasterBufferObj *mask_rb = NULL;
-  rasterBufferObj s_mask_rb;
-
-  if(layer->mask) {
-    int ret;
-    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map,layer->mask));
-    mask_rb = &s_mask_rb;
-    memset(mask_rb, 0, sizeof(s_mask_rb));
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS)
-      return -1;
-  }
-
-  /*only support rawdata and pluggable renderers*/
-  assert(MS_RENDERER_RAWDATA(image->format) || (MS_RENDERER_PLUGIN(image->format) && rb));
-
-
-  memset( cmap, 0xff, MAXCOLORS * sizeof(int) );
-  memset( rb_cmap, 0, sizeof(rb_cmap) );
-
-  /* -------------------------------------------------------------------- */
-  /*      Test the image format instead of the map format.                */
-  /*      Normally the map format and the image format should be the      */
-  /*      same but In somes cases like swf and pdf support, a temporary   */
-  /*      GD image object is created and used to render raster layers     */
-  /*      and then dumped into the SWF or the PDF file.                   */
-  /* -------------------------------------------------------------------- */
-
-
-  src_xsize = GDALGetRasterXSize( hDS );
-  src_ysize = GDALGetRasterYSize( hDS );
-
-  /*
-   * If the RAW_WINDOW attribute is set, use that to establish what to
-   * load.  This is normally just set by the mapresample.c module to avoid
-   * problems with rotated maps.
-   */
-
-  if( CSLFetchNameValue( layer->processing, "RAW_WINDOW" ) != NULL ) {
-    char **papszTokens =
-      CSLTokenizeString(
-        CSLFetchNameValue( layer->processing, "RAW_WINDOW" ) );
-
-    if( layer->debug )
-      msDebug( "msDrawGDAL(%s): using RAW_WINDOW=%s, dst=0,0,%d,%d\n",
-               layer->name,
-               CSLFetchNameValue( layer->processing, "RAW_WINDOW" ),
-               image->width, image->height );
-
-    if( CSLCount(papszTokens) != 4 ) {
-      CSLDestroy( papszTokens );
-      msSetError( MS_IMGERR, "RAW_WINDOW PROCESSING directive corrupt.",
-                  "msDrawGDAL()" );
-      return -1;
-    }
-
-    src_xoff = atoi(papszTokens[0]);
-    src_yoff = atoi(papszTokens[1]);
-    src_xsize = atoi(papszTokens[2]);
-    src_ysize = atoi(papszTokens[3]);
-
-    dst_xoff = 0;
-    dst_yoff = 0;
-    dst_xsize = image->width;
-    dst_ysize = image->height;
-
-    CSLDestroy( papszTokens );
-  }
-
-  /*
-   * Compute the georeferenced window of overlap, and do nothing if there
-   * is no overlap between the map extents, and the file we are operating on.
-   */
-  else if( layer->transform ) {
-    int dst_lrx, dst_lry;
-
-    if( layer->debug )
-      msDebug( "msDrawRasterLayerGDAL(): Entering transform.\n" );
-
-    msGetGDALGeoTransform( hDS, map, layer, adfGeoTransform );
-    InvGeoTransform( adfGeoTransform, adfInvGeoTransform );
-
-    mapRect = map->extent;
-
-    mapRect.minx -= map->cellsize*0.5;
-    mapRect.maxx += map->cellsize*0.5;
-    mapRect.miny -= map->cellsize*0.5;
-    mapRect.maxy += map->cellsize*0.5;
-
-    copyRect = mapRect;
-
-    if( copyRect.minx < GEO_TRANS(adfGeoTransform,0,src_ysize) )
-      copyRect.minx = GEO_TRANS(adfGeoTransform,0,src_ysize);
-    if( copyRect.maxx > GEO_TRANS(adfGeoTransform,src_xsize,0) )
-      copyRect.maxx = GEO_TRANS(adfGeoTransform,src_xsize,0);
-
-    if( copyRect.miny < GEO_TRANS(adfGeoTransform+3,0,src_ysize) )
-      copyRect.miny = GEO_TRANS(adfGeoTransform+3,0,src_ysize);
-    if( copyRect.maxy > GEO_TRANS(adfGeoTransform+3,src_xsize,0) )
-      copyRect.maxy = GEO_TRANS(adfGeoTransform+3,src_xsize,0);
-
-    if( copyRect.minx >= copyRect.maxx || copyRect.miny >= copyRect.maxy ) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): Error in overlap calculation.\n" );
-      return 0;
-    }
-
-    /*
-     * Copy the source and destination raster coordinates.
-     */
-    llx = GEO_TRANS(adfInvGeoTransform+0,copyRect.minx,copyRect.miny);
-    lly = GEO_TRANS(adfInvGeoTransform+3,copyRect.minx,copyRect.miny);
-    urx = GEO_TRANS(adfInvGeoTransform+0,copyRect.maxx,copyRect.maxy);
-    ury = GEO_TRANS(adfInvGeoTransform+3,copyRect.maxx,copyRect.maxy);
-
-    src_xoff = MS_MAX(0,(int) floor(llx+0.5));
-    src_yoff = MS_MAX(0,(int) floor(ury+0.5));
-    src_xsize = MS_MIN(MS_MAX(0,(int) (urx - llx + 0.5)),
-                    GDALGetRasterXSize(hDS) - src_xoff);
-    src_ysize = MS_MIN(MS_MAX(0,(int) (lly - ury + 0.5)),
-                    GDALGetRasterYSize(hDS) - src_yoff);
-
-    /* We want very small windows to use at least one source pixel (#4172) */
-    if( src_xsize == 0 && (urx - llx) > 0.0 ) {
-      src_xsize = 1;
-      src_xoff = MS_MIN(src_xoff,GDALGetRasterXSize(hDS)-1);
-    }
-    if( src_ysize == 0 && (lly - ury) > 0.0 ) {
-      src_ysize = 1;
-      src_yoff = MS_MIN(src_yoff,GDALGetRasterYSize(hDS)-1);
-    }
-
-    if( src_xsize == 0 || src_ysize == 0 ) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): no apparent overlap between map view and this window(1).\n" );
-      return 0;
-    }
-
-    if (map->cellsize == 0) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): Cellsize can't be 0.\n" );
-      return 0;
-    }
-
-    dst_xoff = (int) ((copyRect.minx - mapRect.minx) / map->cellsize);
-    dst_yoff = (int) ((mapRect.maxy - copyRect.maxy) / map->cellsize);
-
-    dst_lrx = (int) ((copyRect.maxx - mapRect.minx) / map->cellsize + 0.5);
-    dst_lry = (int) ((mapRect.maxy - copyRect.miny) / map->cellsize + 0.5);
-    dst_lrx = MS_MAX(0,MS_MIN(image->width,dst_lrx));
-    dst_lry = MS_MAX(0,MS_MIN(image->height,dst_lry));
-
-    dst_xsize = MS_MAX(0,MS_MIN(image->width,dst_lrx - dst_xoff));
-    dst_ysize = MS_MAX(0,MS_MIN(image->height,dst_lry - dst_yoff));
-
-    if( dst_xsize == 0 || dst_ysize == 0 ) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): no apparent overlap between map view and this window(2).\n" );
-      return 0;
-    }
-
-    if( layer->debug )
-      msDebug( "msDrawRasterLayerGDAL(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
-               src_xoff, src_yoff, src_xsize, src_ysize,
-               dst_xoff, dst_yoff, dst_xsize, dst_ysize );
-#ifndef notdef
-    if( layer->debug ) {
-      double d_src_xoff, d_src_yoff, geo_x, geo_y;
-
-      geo_x = mapRect.minx + dst_xoff * map->cellsize;
-      geo_y = mapRect.maxy - dst_yoff * map->cellsize;
-
-      d_src_xoff = (geo_x - adfGeoTransform[0]) / adfGeoTransform[1];
-      d_src_yoff = (geo_y - adfGeoTransform[3]) / adfGeoTransform[5];
-
-      msDebug( "msDrawRasterLayerGDAL(): source raster PL (%.3f,%.3f) for dst PL (%d,%d).\n",
-               d_src_xoff, d_src_yoff,
-               dst_xoff, dst_yoff );
-    }
-#endif
-  }
-
-  /*
-   * If layer transforms are turned off, just map 1:1.
-   */
-  else {
-    dst_xoff = src_xoff = 0;
-    dst_yoff = src_yoff = 0;
-    dst_xsize = src_xsize = MS_MIN(image->width,src_xsize);
-    dst_ysize = src_ysize = MS_MIN(image->height,src_ysize);
-  }
-
-  /*
-   * In RAWDATA mode we don't fool with colors.  Do the raw processing,
-   * and return from the function early.
-   */
-  if( MS_RENDERER_RAWDATA( image->format ) ) {
-    return msDrawRasterLayerGDAL_RawMode(
-             map, layer, image, hDS,
-             src_xoff, src_yoff, src_xsize, src_ysize,
-             dst_xoff, dst_yoff, dst_xsize, dst_ysize );
-  }
-
-  /*
-   * Is this image classified?  We consider it classified if there are
-   * classes with an expression string *or* a color range.  We don't want
-   * to treat the raster as classified if there is just a bogus class here
-   * to force inclusion in the legend.
-   */
-  for( i = 0; i < layer->numclasses; i++ ) {
-    int s;
-
-    /* change colour based on colour range? */
-    for(s=0; s<layer->class[i]->numstyles; s++) {
-      if( MS_VALID_COLOR(layer->class[i]->styles[s]->mincolor)
-          && MS_VALID_COLOR(layer->class[i]->styles[s]->maxcolor) ) {
-        classified = TRUE;
-        break;
-      }
-    }
-
-    if( layer->class[i]->expression.string != NULL ) {
-      classified = TRUE;
-      break;
-    }
-  }
-
-  /*
-   * Set up the band selection.  We look for a BANDS directive in the
-   * the PROCESSING options.  If not found we default to grey=1, grey=1,alpha=2,
-   * red=1,green=2,blue=3 or red=1,green=2,blue=3,alpha>=4.
-   */
-
-  if( CSLFetchNameValue( layer->processing, "BANDS" ) == NULL ) {
-    const int gdal_band_count = GDALGetRasterCount( hDS );
-    red_band = 1;
-
-    if( gdal_band_count >= 4 )
-    {
-        /* The alpha band is not necessarily the 4th one */
-        for( i = 4; i <= gdal_band_count; i ++ ) {
-            if( GDALGetRasterColorInterpretation(
-                GDALGetRasterBand( hDS, i ) ) == GCI_AlphaBand ) {
-                alpha_band = i;
-                break;
-            }
-        }
-    }
-
-    if( gdal_band_count >= 3 ) {
-      green_band = 2;
-      blue_band = 3;
-    }
-
-    if( gdal_band_count == 2
-        && GDALGetRasterColorInterpretation(
-          GDALGetRasterBand( hDS, 2 ) ) == GCI_AlphaBand )
-      alpha_band = 2;
-
-    hBand1 = GDALGetRasterBand( hDS, red_band );
-    if( classified
-        || GDALGetRasterColorTable( hBand1 ) != NULL ) {
-      alpha_band = 0;
-      green_band = 0;
-      blue_band = 0;
-    }
-  } else {
-    int *band_list;
-
-    band_list = msGetGDALBandList( layer, hDS, 4, &band_count );
-    if( band_list == NULL )
-      return -1;
-
-    if( band_count > 0 )
-      red_band = band_list[0];
-    else
-      red_band = 0;
-    if( band_count > 2 ) {
-      green_band = band_list[1];
-      blue_band = band_list[2];
-    } else {
-      green_band = 0;
-      blue_band = 0;
-    }
-
-    if( band_count > 3 )
-      alpha_band = band_list[3];
-    else
-      alpha_band = 0;
-
-    free( band_list );
-  }
-
-  band_numbers[0] = red_band;
-  band_numbers[1] = green_band;
-  band_numbers[2] = blue_band;
-  band_numbers[3] = 0;
-
-  if( blue_band != 0 && alpha_band != 0 ) {
-    band_numbers[3] = alpha_band;
-    band_count = 4;
-  } else if( blue_band != 0 && alpha_band == 0 )
-    band_count = 3;
-  else if( alpha_band != 0 ) {
-    band_numbers[1] = alpha_band;
-    band_count = 2;
-  } else
-    band_count = 1;
-
-  if( layer->debug > 1 || (layer->debug > 0 && green_band != 0) ) {
-    msDebug( "msDrawRasterLayerGDAL(): red,green,blue,alpha bands = %d,%d,%d,%d\n",
-             red_band, green_band, blue_band, alpha_band );
-  }
-
-  /*
-   * Get band handles for PC256, RGB or RGBA cases.
-   */
-  hBand1 = GDALGetRasterBand( hDS, red_band );
-  if( hBand1 == NULL )
-    return -1;
-
-  hBand2 = hBand3 = hBandAlpha = NULL;
-
-  if( green_band != 0 ) {
-    hBand1 = GDALGetRasterBand( hDS, red_band );
-    hBand2 = GDALGetRasterBand( hDS, green_band );
-    hBand3 = GDALGetRasterBand( hDS, blue_band );
-    if( hBand1 == NULL || hBand2 == NULL || hBand3 == NULL )
-      return -1;
-  }
-
-  if( alpha_band != 0 )
-    hBandAlpha = GDALGetRasterBand( hDS, alpha_band );
-
-  /*
-   * The logic for a classification rendering of non-8bit raster bands
-   * is sufficiently different than the normal mechanism of loading
-   * into an 8bit buffer, that we isolate it into it's own subfunction.
-   */
-  if( classified
-      && hBand1 != NULL && GDALGetRasterDataType( hBand1 ) != GDT_Byte ) {
-    return msDrawRasterLayerGDAL_16BitClassification(
-             map, layer, rb, hBand1,
-             src_xoff, src_yoff, src_xsize, src_ysize,
-             dst_xoff, dst_yoff, dst_xsize, dst_ysize );
-  }
-
-  /*
-   * Get colormap for this image.  If there isn't one, and we have only
-   * one band create a greyscale colormap.
-   */
-  bool isDefaultGreyscale = false;
-
-  if( hBand2 != NULL )
-    hColorMap = NULL;
-  else {
-    hColorMap = GDALGetRasterColorTable( hBand1 );
-    if( hColorMap != NULL )
-      hColorMap = GDALCloneColorTable( hColorMap );
-    else {
-      hColorMap = GDALCreateColorTable( GPI_RGB );
-      isDefaultGreyscale = true;
-
-      for( i = 0; i < 256; i++ ) {
-        colorObj pixel;
-        GDALColorEntry sEntry;
-
-        pixel.red = i;
-        pixel.green = i;
-        pixel.blue = i;
-
-        if(MS_COMPARE_COLORS(pixel, layer->offsite)) {
-          sEntry.c1 = 0;
-          sEntry.c2 = 0;
-          sEntry.c3 = 0;
-          sEntry.c4 = 0; /* alpha set to zero */
-        } else {
-          sEntry.c1 = i;
-          sEntry.c2 = i;
-          sEntry.c3 = i;
-          sEntry.c4 = 255;
-        }
-
-        GDALSetColorEntry( hColorMap, i, &sEntry );
-      }
-    }
-
-    /*
-    ** If we have a known NODATA value, mark it now as transparent.
-    */
-    {
-      int    bGotNoData;
-      double dfNoDataValue = msGetGDALNoDataValue( layer, hBand1,
-                             &bGotNoData);
-
-      if( bGotNoData && dfNoDataValue >= 0
-          && dfNoDataValue < GDALGetColorEntryCount( hColorMap ) ) {
-        GDALColorEntry sEntry;
-
-        memcpy( &sEntry,
-                GDALGetColorEntry( hColorMap, (int) dfNoDataValue ),
-                sizeof(GDALColorEntry) );
-
-        sEntry.c4 = 0;
-        GDALSetColorEntry( hColorMap, (int) dfNoDataValue, &sEntry );
-      }
-    }
-  }
-
-  /*
-   * Allocate imagery buffers.
-   */
-  pabyRaw1 = (unsigned char *) malloc(dst_xsize * dst_ysize * band_count);
-  if( pabyRaw1 == NULL ) {
-    msSetError(MS_MEMERR, "Allocating work image of size %dx%dx%d failed.",
-               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count );
-    return -1;
-  }
-
-  if( hBand2 != NULL && hBand3 != NULL ) {
-    pabyRaw2 = pabyRaw1 + dst_xsize * dst_ysize * 1;
-    pabyRaw3 = pabyRaw1 + dst_xsize * dst_ysize * 2;
-  }
-
-  if( hBandAlpha != NULL ) {
-    if( hBand2 != NULL )
-      pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 3;
-    else
-      pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 1;
-  }
-
-  /*
-   * Load image data into buffers with scaling, etc.
-   */
-  bool bScaled = false;
-  double dfScaleMin = 0;
-  double dfScaleRatio = 0;
-  bool* pbIsNoDataBuffer = NULL;
-  if( LoadGDALImages( hDS, band_numbers, band_count, layer,
-                      src_xoff, src_yoff, src_xsize, src_ysize,
-                      pabyRaw1, dst_xsize, dst_ysize,
-                      &bHaveRGBNoData,
-                      &nNoData1, &nNoData2, &nNoData3,
-                      &bScaled, &dfScaleMin, &dfScaleRatio,
-                      &pbIsNoDataBuffer ) == -1 ) {
-    free( pabyRaw1 );
-    free( pbIsNoDataBuffer );
-    return -1;
-  }
-
-  /*
-   * Setup the mapping between source eight bit pixel values, and the
-   * output images color table.  There are two general cases, where the
-   * class colors are provided by the MAP file, or where we use the native
-   * color table.
-   */
-  if( classified ) {
-    int c;
-    const char* pszRangeColorspace = msLayerGetProcessingKey( layer, "RANGE_COLORSPACE" );
-    colorspace iRangeColorspace;
-
-#ifndef NDEBUG
-    cmap_set = TRUE;
-#endif
-
-    if( hColorMap == NULL ) {
-      msSetError(MS_IOERR,
-                 "Attempt to classify 24bit image, this is unsupported.",
-                 "drawGDAL()");
-      free( pabyRaw1 );
-      free( pbIsNoDataBuffer );
-      return -1;
-    }
-    
-    if(!pszRangeColorspace || !strcasecmp(pszRangeColorspace, "RGB")) {
-      iRangeColorspace = MS_COLORSPACE_RGB;
-    } else if(!strcasecmp(pszRangeColorspace, "HSL")) {
-      iRangeColorspace = MS_COLORSPACE_HSL;
-    } else {
-      msSetError(MS_MISCERR,
-                 "Unknown RANGE_COLORSPACE \"%s\", expecting RGB or HSL",
-                 "drawGDAL()", pszRangeColorspace);
-      GDALDestroyColorTable( hColorMap );
-      free( pabyRaw1 );
-      free( pbIsNoDataBuffer );
-      return -1;
-    }
-
-    int color_count = GDALGetColorEntryCount(hColorMap);
-    const bool bScaleColors = bScaled && !isDefaultGreyscale;
-
-    if( !bScaleColors && color_count > 256 )
-      color_count = 256;
-
-    for(i=0; i < color_count; i++) {
-      colorObj pixel;
-      int colormap_index;
-      GDALColorEntry sEntry;
-
-      GDALGetColorEntryAsRGB( hColorMap, i, &sEntry );
-
-      const int j = bScaleColors ? MAX(0, MIN(255, (int) ((i-dfScaleMin)*dfScaleRatio))) : i;
-
-      pixel.red = sEntry.c1;
-      pixel.green = sEntry.c2;
-      pixel.blue = sEntry.c3;
-      colormap_index = i;
-
-      if(!MS_COMPARE_COLORS(pixel, layer->offsite)) {
-        c = msGetClass(layer, &pixel, colormap_index);
-
-        if(c != -1) { /* belongs to any class */
-          int s;
-
-          /* change colour based on colour range?  Currently we
-             only address the greyscale case properly. */
-
-          if( MS_VALID_COLOR(layer->class[c]->styles[0]->mincolor) ) {
-            for(s=0; s<layer->class[c]->numstyles; s++) {
-              if( MS_VALID_COLOR(layer->class[c]->styles[s]->mincolor)
-                 && MS_VALID_COLOR(layer->class[c]->styles[s]->maxcolor)) {
-                if( sEntry.c1 >= layer->class[c]->styles[s]->minvalue
-                     && sEntry.c1 <= layer->class[c]->styles[s]->maxvalue ) {
-                  msValueToRange(layer->class[c]->styles[s], sEntry.c1, iRangeColorspace);
-                  if(MS_VALID_COLOR(layer->class[c]->styles[s]->color)) {
-                    rb_cmap[0][j] = layer->class[c]->styles[s]->color.red;
-                    rb_cmap[1][j] = layer->class[c]->styles[s]->color.green;
-                    rb_cmap[2][j] = layer->class[c]->styles[s]->color.blue;
-                    rb_cmap[3][j] = (layer->class[c]->styles[s]->color.alpha != 255)?(layer->class[c]->styles[s]->color.alpha):(255*layer->class[c]->styles[0]->opacity / 100);
-                    break;
-                  }
-                }
-              }
-            }
-          }
-          else if( MS_TRANSPARENT_COLOR(layer->class[c]->styles[0]->color))
-            /* leave it transparent */;
-
-          else if( MS_VALID_COLOR(layer->class[c]->styles[0]->color)) {
-            rb_cmap[0][j] = layer->class[c]->styles[0]->color.red;
-            rb_cmap[1][j] = layer->class[c]->styles[0]->color.green;
-            rb_cmap[2][j] = layer->class[c]->styles[0]->color.blue;
-            rb_cmap[3][j] = (255*layer->class[c]->styles[0]->opacity / 100);
-          }
-
-          else { /* Use raster color */
-            rb_cmap[0][j] = pixel.red;
-            rb_cmap[1][j] = pixel.green;
-            rb_cmap[2][j] = pixel.blue;
-            rb_cmap[3][j] = 255;
-          }
-        }
-      }
-    }
-  } else if( hBand2 == NULL && hColorMap != NULL && rb->type == MS_BUFFER_BYTE_RGBA ) {
-    int color_count;
-#ifndef NDEBUG
-    cmap_set = TRUE;
-#endif
-
-    color_count = MS_MIN(256,GDALGetColorEntryCount(hColorMap));
-    const bool bScaleColors = bScaled && !isDefaultGreyscale;
-
-    if( !bScaleColors && color_count > 256 )
-      color_count = 256;
-
-    for(i=0; i < color_count; i++) {
-      GDALColorEntry sEntry;
-
-      GDALGetColorEntryAsRGB( hColorMap, i, &sEntry );
-      const int j = bScaleColors ? MAX(0, MIN(255, (int) ((i-dfScaleMin)*dfScaleRatio))) : i;
-
-      if( sEntry.c4 != 0
-          && (!MS_VALID_COLOR( layer->offsite )
-              || layer->offsite.red != sEntry.c1
-              || layer->offsite.green != sEntry.c2
-              || layer->offsite.blue != sEntry.c3 ) ) {
-        rb_cmap[0][j] = sEntry.c1;
-        rb_cmap[1][j] = sEntry.c2;
-        rb_cmap[2][j] = sEntry.c3;
-        rb_cmap[3][j] = sEntry.c4;
-      }
-    }
-  }
-
-  if( bHaveRGBNoData && layer->debug )
-    msDebug( "msDrawGDAL(): using RGB nodata values from GDAL dataset.\n" );
-
-  /* -------------------------------------------------------------------- */
-  /*      If there was no alpha band, but we have a dataset level mask    */
-  /*      load it as massage it so it will function as our alpha for      */
-  /*      transparency purposes.                                          */
-  /* -------------------------------------------------------------------- */
-  if( hBandAlpha == NULL ) {
-    int nMaskFlags = GDALGetMaskFlags(hBand1);
-
-    if( CSLTestBoolean(CSLFetchNameValueDef( layer->processing, "USE_MASK_BAND", "YES" )) &&
-        (nMaskFlags & GMF_PER_DATASET) != 0 &&
-        (nMaskFlags & (GMF_NODATA|GMF_ALL_VALID)) == 0 ) {
-      CPLErr eErr;
-      unsigned char * pabyOrig = pabyRaw1;
-
-
-      if( layer->debug )
-        msDebug( "msDrawGDAL(): using GDAL mask band for alpha.\n" );
-
-      band_count++;
-
-      pabyRaw1 = (unsigned char *)
-                 realloc(pabyOrig,dst_xsize * dst_ysize * band_count);
-
-      if( pabyRaw1 == NULL ) {
-        msSetError(MS_MEMERR,
-                   "Allocating work image of size %dx%dx%d failed.",
-                   "msDrawRasterLayerGDAL()",
-                   dst_xsize, dst_ysize, band_count );
-        free(pabyOrig);
-        if( hColorMap != NULL )     
-          GDALDestroyColorTable( hColorMap );
-        free( pbIsNoDataBuffer );
-        return -1;
-      }
-
-      if( hBand2 != NULL ) {
-        pabyRaw2 = pabyRaw1 + dst_xsize * dst_ysize * 1;
-        pabyRaw3 = pabyRaw1 + dst_xsize * dst_ysize * 2;
-        pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 3;
-      } else {
-        pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 1;
-      }
-
-      hBandAlpha = GDALGetMaskBand(hBand1);
-
-      eErr = GDALRasterIO( hBandAlpha, GF_Read,
-                           src_xoff, src_yoff, src_xsize, src_ysize,
-                           pabyRawAlpha, dst_xsize, dst_ysize, GDT_Byte, 0,0);
-
-      if( eErr != CE_None ) {
-        msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                    "drawGDAL()", CPLGetLastErrorMsg() );
-        if( hColorMap != NULL )     
-          GDALDestroyColorTable( hColorMap );
-        free( pabyRaw1 );
-        free( pbIsNoDataBuffer );
-        return -1;
-      }
-
-      /* In case the mask is not an alpha channel, expand values of 1 to 255, */
-      /* so we can deal as it was an alpha band afterwards */
-      if ((nMaskFlags & GMF_ALPHA) == 0) {
-        for(i=0; i<dst_xsize * dst_ysize; i++)
-          if (pabyRawAlpha[i])
-            pabyRawAlpha[i] = 255;
-      }
-    }
-  }
-
-    /* -------------------------------------------------------------------- */
-    /*      Single band plus colormap and alpha to truecolor. (RB)          */
-    /* -------------------------------------------------------------------- */
-    if( hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA && hBandAlpha != NULL ) {
-      assert( cmap_set );
-
-      int k = 0;
-      for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-        for( int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++ ) {
-          int src_pixel, src_alpha, cmap_alpha, merged_alpha;
-          if(SKIP_MASK(j,i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
-            continue;
-
-          src_pixel = pabyRaw1[k];
-          src_alpha = pabyRawAlpha[k];
-          cmap_alpha = rb_cmap[3][src_pixel];
-
-          merged_alpha = (src_alpha * cmap_alpha) / 255;
-
-          if( merged_alpha < 2 )
-            /* do nothing - transparent */;
-          else if( merged_alpha > 253 ) {
-            RB_SET_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          cmap_alpha );
-          } else {
-            RB_MIX_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          merged_alpha );
-          }
-        }
-      }
-    }
-
-  /* -------------------------------------------------------------------- */
-  /*      Single band plus colormap (no alpha) to truecolor (RB)          */
-  /* -------------------------------------------------------------------- */
-    else if( hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA ) {
-      assert( cmap_set );
-
-      int k = 0;
-      for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-        for( int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++ ) {
-          int src_pixel = pabyRaw1[k];
-          if(SKIP_MASK(j,i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
-            continue;
-
-          if( rb_cmap[3][src_pixel] > 253 ) {
-            RB_SET_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          rb_cmap[3][src_pixel] );
-          } else if( rb_cmap[3][src_pixel] > 1 ) {
-            RB_MIX_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          rb_cmap[3][src_pixel] );
-          }
-        }
-      }
-    }
-
-  /* -------------------------------------------------------------------- */
-  /*      Input is 3 band RGB.  Alpha blending is mixed into the loop     */
-  /*      since this case is less commonly used and has lots of other     */
-  /*      overhead. (RB)                                                  */
-  /* -------------------------------------------------------------------- */
-    else if( hBand3 != NULL && rb->type == MS_BUFFER_BYTE_RGBA ) {
-      int k = 0;
-      for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-        for( int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++ ) {
-          if(SKIP_MASK(j,i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
-            continue;
-          if( MS_VALID_COLOR( layer->offsite )
-              && pabyRaw1[k] == layer->offsite.red
-              && pabyRaw2[k] == layer->offsite.green
-              && pabyRaw3[k] == layer->offsite.blue )
-            continue;
-
-          if( bHaveRGBNoData
-              && pabyRaw1[k] == nNoData1
-              && pabyRaw2[k] == nNoData2
-              && pabyRaw3[k] == nNoData3 )
-            continue;
-
-          if( pabyRawAlpha == NULL || pabyRawAlpha[k] == 255 ) {
-            RB_SET_PIXEL( rb, j, i,
-                          pabyRaw1[k],
-                          pabyRaw2[k],
-                          pabyRaw3[k],
-                          255 );
-          } else if( pabyRawAlpha[k] != 0 ) {
-            RB_MIX_PIXEL( rb, j, i,
-                          pabyRaw1[k],
-                          pabyRaw2[k],
-                          pabyRaw3[k],
-                          pabyRawAlpha[k] );
-          }
-        }
-      }
-    }
-
-
-  /*
-  ** Cleanup
-  */
-  free( pabyRaw1 );
-  free( pbIsNoDataBuffer );
-
-  if( hColorMap != NULL )
-    GDALDestroyColorTable( hColorMap );
-
-  return 0;
-}
-
-/************************************************************************/
-/*                          ParseDefaultLUT()                           */
-/************************************************************************/
-
-static int ParseDefaultLUT( const char *lut_def, GByte *lut, int nMaxValIn )
-
-{
-  const char *lut_read;
-  int last_in=0, last_out=0, all_done=FALSE;
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse definition, applying to lut on the fly.                   */
-  /* -------------------------------------------------------------------- */
-  lut_read = lut_def;
-  while( !all_done ) {
-    int this_in=0, this_out=0;
-    int lut_i;
-
-    while( isspace(*lut_read) )
-      lut_read++;
-
-    /* if we are at end, assume nMaxValIn:255 */
-    if( *lut_read == '\0' ) {
-      all_done = TRUE;
-      if ( last_in != nMaxValIn ) {
-        this_in = nMaxValIn;
-        this_out = 255;
-      }
-    }
-
-    /* otherwise read "in:out", and skip past */
-    else {
-      this_in = atoi(lut_read);
-      while( *lut_read != ':' && *lut_read )
-        lut_read++;
-      if( *lut_read == ':' )
-        lut_read++;
-      while( isspace(*lut_read) )
-        lut_read++;
-      this_out = atoi(lut_read);
-      while( *lut_read && *lut_read != ',' && *lut_read != '\n' )
-        lut_read++;
-      if( *lut_read == ',' || *lut_read == '\n' )
-        lut_read++;
-      while( isspace(*lut_read) )
-        lut_read++;
-    }
-
-    this_in = MS_MAX(0,MS_MIN(nMaxValIn,this_in));
-    this_out = MS_MAX(0,MS_MIN(255,this_out));
-
-    /* apply linear values from last in:out to this in:out */
-    for( lut_i = last_in; lut_i <= this_in; lut_i++ ) {
-      double ratio;
-
-      if( last_in == this_in )
-        ratio = 1.0;
-      else
-        ratio = (lut_i - last_in) / (double) (this_in - last_in);
-
-      lut[lut_i] = (int)
-                   floor(((1.0 - ratio)*last_out + ratio*this_out) + 0.5);
-    }
-
-    last_in = this_in;
-    last_out = this_out;
-  }
-
-  return 0;
-}
-
-/************************************************************************/
-/*                          LutFromGimpLine()                           */
-/************************************************************************/
-
-static int LutFromGimpLine( char *lut_line, GByte *lut )
-
-{
-  char wrkLUTDef[1000];
-  int  i, count = 0;
-  char **tokens;
-
-  /* cleanup white space at end of line (DOS LF, etc) */
-  i = strlen(lut_line) - 1;
-  while( i > 0 && isspace(lut_line[i]) )
-    lut_line[i--] = '\0';
-
-  while( *lut_line == 10 || *lut_line == 13 )
-    lut_line++;
-
-  /* tokenize line */
-  tokens = CSLTokenizeString( lut_line );
-  if( CSLCount(tokens) != 17 * 2 ) {
-    CSLDestroy( tokens );
-    msSetError(MS_MISCERR,
-               "GIMP curve file appears corrupt.",
-               "LutFromGimpLine()" );
-    return -1;
-  }
-
-  /* Convert to our own format */
-  wrkLUTDef[0] = '\0';
-  for( i = 0; i < 17; i++ ) {
-    if( atoi(tokens[i*2]) >= 0 ) {
-      if( count++ > 0 )
-        strlcat( wrkLUTDef, ",", sizeof(wrkLUTDef));
-
-      snprintf( wrkLUTDef + strlen(wrkLUTDef), sizeof(wrkLUTDef)-strlen(wrkLUTDef),
-                "%s:%s", tokens[i*2], tokens[i*2+1] );
-    }
-  }
-
-  CSLDestroy( tokens );
-
-  return ParseDefaultLUT( wrkLUTDef, lut, 255 );
-}
-
-/************************************************************************/
-/*                            ParseGimpLUT()                            */
-/*                                                                      */
-/*      Parse a Gimp style LUT.                                         */
-/************************************************************************/
-
-static int ParseGimpLUT( const char *lut_def, GByte *lut, int iColorIndex )
-
-{
-  int i;
-  GByte lutValue[256];
-  GByte lutColorBand[256];
-  char **lines =
-    CSLTokenizeStringComplex( lut_def, "\n", FALSE, FALSE );
-
-  if( !EQUALN(lines[0],"# GIMP Curves File",18)
-      || CSLCount(lines) < 6 ) {
-    msSetError(MS_MISCERR,
-               "GIMP curve file appears corrupt.",
-               "ParseGimpLUT()" );
-    CSLDestroy( lines );
-    return -1;
-  }
-
-  /*
-   * Convert the overall curve, and the color band specific curve into LUTs.
-   */
-  if( LutFromGimpLine( lines[1], lutValue ) != 0
-      || LutFromGimpLine( lines[iColorIndex + 1], lutColorBand ) != 0 ) {
-    CSLDestroy( lines );
-    return -1;
-  }
-  CSLDestroy( lines );
-
-  /*
-   * Compose the two luts as if the raw value passed through the color band
-   * specific lut, and then the general value lut.  Usually one or the
-   * other will be the identity mapping, but not always.
-   */
-
-  for( i = 0; i < 256; i++ ) {
-    lut[i] = lutValue[lutColorBand[i]];
-  }
-
-  return 0;
-}
-
-/************************************************************************/
-/*                              LoadLUT()                               */
-/*                                                                      */
-/*      Load a LUT according to RFC 21.                                 */
-/************************************************************************/
-
-static int LoadLUT( layerObj *layer, int iColorIndex, char** ppszLutDef )
-
-{
-  const char *lut_def;
-  char key[20], lut_def_fromfile[2500];
-
-  *ppszLutDef = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Get lut specifier from processing directives.  Do nothing if    */
-  /*      none are found.                                                 */
-  /* -------------------------------------------------------------------- */
-  sprintf( key, "LUT_%d", iColorIndex );
-  lut_def = msLayerGetProcessingKey( layer, key );
-  if( lut_def == NULL )
-    lut_def = msLayerGetProcessingKey( layer, "LUT" );
-  if( lut_def == NULL )
-    return 0;
-
-  /* -------------------------------------------------------------------- */
-  /*      Does this look like a file?  If so, read it into memory.        */
-  /* -------------------------------------------------------------------- */
-  if( strspn(lut_def,"0123456789:, ") != strlen(lut_def) ) {
-    FILE *fp;
-    char path[MS_MAXPATHLEN];
-    int len;
-    msBuildPath(path, layer->map->mappath, lut_def);
-    fp = fopen( path, "rb" );
-    if( fp == NULL ) {
-      msSetError(MS_IOERR,
-                 "Failed to open LUT file '%s'.",
-                 "drawGDAL()", path );
-      return -1;
-    }
-
-    len = fread( lut_def_fromfile, 1, sizeof(lut_def_fromfile), fp );
-    fclose( fp );
-
-    if( len == sizeof(lut_def_fromfile) ) {
-      msSetError(MS_IOERR,
-                 "LUT definition from file %s longer than maximum buffer size (%d bytes).",
-                 "drawGDAL()",
-                 path, (int)sizeof(lut_def_fromfile) );
-      return -1;
-    }
-
-    lut_def_fromfile[len] = '\0';
-
-    lut_def = lut_def_fromfile;
-  }
-
-  *ppszLutDef = msStrdup(lut_def);
-
-  return 0;
-
-}
-
-/************************************************************************/
-/*                              FreeLUTs()                              */
-/************************************************************************/
-
-static void FreeLUTs(char** apszLUTs)
-{
-    int i;
-    for( i = 0; i < 4; i++ )
-        msFree(apszLUTs[i]);
-    msFree(apszLUTs);
-}
-
-/************************************************************************/
-/*                            LoadLUTs()                                */
-/*                                                                      */
-/* Return an array of 4 strings (some possibly NULL) with loaded LUTs   */
-/* or NULL in case of failure.                                          */
-/************************************************************************/
-
-static char** LoadLUTs(layerObj *layer, int band_count)
-{
-    int i;
-    char** apszLUTs;
-    
-    assert(band_count <= 4);
-
-    apszLUTs = (char**) msSmallCalloc( 4, sizeof(char*) );
-    for( i = 0; i < band_count; i++ )
-    {
-        if( LoadLUT( layer, i+1, &apszLUTs[i] ) != 0 )
-        {
-            FreeLUTs(apszLUTs);
-            return NULL;
-        }
-    }
-
-    return apszLUTs;
-}
-
-/************************************************************************/
-/*                  GetDataTypeAppropriateForLUTS()                     */
-/*                                                                      */
-/*      This does a quick examination of the LUT strings to determine   */
-/*      if they have input values > 255, in which case the raster data  */
-/*      must be queries on 16-bits.                                     */
-/************************************************************************/
-
-static GDALDataType GetDataTypeAppropriateForLUTS(char** apszLUTs)
-{
-    GDALDataType eDT = GDT_Byte;
-    int i;
-    for( i = 0; i < 4; i++ )
-    {
-        const char* pszLastTuple;
-        int nLastInValue;
-        if( apszLUTs[i] == NULL )
-            continue;
-        if( EQUALN(apszLUTs[i],"# GIMP",6) )
-            continue;
-        /* Find last in:out tuple in string */
-        pszLastTuple = strrchr( apszLUTs[i], ',' );
-        if( pszLastTuple == NULL )
-            pszLastTuple = apszLUTs[i];
-        else
-            pszLastTuple ++;
-        while( *pszLastTuple == ' ' )
-            pszLastTuple ++;
-        nLastInValue = atoi(pszLastTuple);
-        if( nLastInValue > 255 )
-        {
-            eDT = GDT_UInt16;
-            break;
-        }
-    }
-    return eDT;
-}
-
-/************************************************************************/
-/*                              ApplyLUT()                              */
-/************************************************************************/
-
-static int ApplyLUT( int iColorIndex, const char* lut_def,
-                     const void* pInBuffer, GDALDataType eDT,
-                     GByte* pabyOutBuffer,
-                     int nPixelCount )
-{
-  int i, err;
-  GByte byteLut[256];
-  GByte* uint16Lut = NULL;
-
-  assert( eDT == GDT_Byte || eDT == GDT_UInt16 );
-  
-  if( lut_def == NULL )
-  {
-      if( pInBuffer != pabyOutBuffer )
-      {
-        GDALCopyWords( (void*)pInBuffer, eDT, GDALGetDataTypeSize(eDT) / 8,
-                        pabyOutBuffer, GDT_Byte, 1,
-                        nPixelCount );
-      }
-      return 0;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse the LUT description.                                      */
-  /* -------------------------------------------------------------------- */
-  if( EQUALN(lut_def,"# GIMP",6) ) {
-    if( eDT != GDT_Byte ) {
-      msSetError(MS_MISCERR,
-                 "Cannot apply a GIMP LUT on a 16-bit buffer",
-                 "ApplyLUT()");
-      return -1;
-    }
-    err = ParseGimpLUT( lut_def, byteLut, iColorIndex );
-  } else {
-    if( eDT == GDT_Byte )
-        err = ParseDefaultLUT( lut_def, byteLut, 255 );
-    else
-    {
-        uint16Lut = (GByte*) malloc( 65536 );
-        if( uint16Lut == NULL )
-        {
-            msSetError(MS_MEMERR,
-                 "Cannot allocate 16-bit LUT",
-                 "ApplyLUT()" );
-            return -1;
-        }
-        err = ParseDefaultLUT( lut_def, uint16Lut, 65535 );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Apply LUT.                                                      */
-  /* -------------------------------------------------------------------- */
-  if( eDT == GDT_Byte )
-  {
-    for( i = 0; i < nPixelCount; i++ )
-        pabyOutBuffer[i] = byteLut[((GByte*)pInBuffer)[i]];
-  }
-  else
-  {
-      for( i = 0; i < nPixelCount; i++ )
-        pabyOutBuffer[i] = uint16Lut[((GUInt16*)pInBuffer)[i]];
-      free(uint16Lut);
-  }
-  
-  return err;
-}
-
-/************************************************************************/
-/*                           LoadGDALImages()                           */
-/*                                                                      */
-/*      This call will load and process 1-4 bands of input for the      */
-/*      selected rectangle, loading the result into the passed 8bit     */
-/*      buffer.  The processing options include scaling.                */
-/************************************************************************/
-
-static int
-LoadGDALImages( GDALDatasetH hDS, int band_numbers[4], int band_count,
-                layerObj *layer,
-                int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-                GByte *pabyWholeBuffer,
-                int dst_xsize, int dst_ysize,
-                int *pbHaveRGBNoData,
-                int *pnNoData1, int *pnNoData2, int *pnNoData3,
-                bool *pbScaled, double *pdfScaleMin, double *pdfScaleRatio,
-                bool **ppbIsNoDataBuffer )
-
-{
-  int    iColorIndex, result_code=0;
-  CPLErr eErr;
-  float *pafWholeRawData;
-  char** papszLUTs;
-
-  *pbScaled = false;
-  *pdfScaleMin = 0;
-  *pdfScaleRatio = 0;
-  *ppbIsNoDataBuffer = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      If we have no alpha band, but we do have three input            */
-  /*      bands, then check for nodata values.  If we only have one       */
-  /*      input band, then nodata will already have been adderssed as     */
-  /*      part of the real or manufactured color table.                   */
-  /* -------------------------------------------------------------------- */
-  if( band_count == 3 ) {
-    *pnNoData1 = (int)
-                 msGetGDALNoDataValue( layer,
-                                       GDALGetRasterBand(hDS,band_numbers[0]),
-                                       pbHaveRGBNoData);
-
-    if( *pbHaveRGBNoData )
-      *pnNoData2 = (int)
-                   msGetGDALNoDataValue( layer,
-                                         GDALGetRasterBand(hDS,band_numbers[1]),
-                                         pbHaveRGBNoData);
-    if( *pbHaveRGBNoData )
-      *pnNoData3 = (int)
-                   msGetGDALNoDataValue( layer,
-                                         GDALGetRasterBand(hDS,band_numbers[2]),
-                                         pbHaveRGBNoData);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Are we doing a simple, non-scaling case?  If so, read directly  */
-  /*      and return.                                                     */
-  /* -------------------------------------------------------------------- */
-  if( CSLFetchNameValue( layer->processing, "SCALE" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_1" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_2" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_3" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_4" ) == NULL ) {
-      
-    GDALDataType eDT;
-    GUInt16* panBuffer = NULL;
-    void* pBuffer;
-
-    papszLUTs = LoadLUTs(layer, band_count);
-    if( papszLUTs == NULL ) {
-        return -1;
-    }
-
-    eDT = GetDataTypeAppropriateForLUTS(papszLUTs);
-    if( eDT == GDT_UInt16 ) {
-        panBuffer =
-            (GUInt16 *) malloc(sizeof(GUInt16) * dst_xsize * dst_ysize * band_count );
-
-        if( panBuffer == NULL ) {
-            msSetError(MS_MEMERR,
-                    "Allocating work uint16 image of size %dx%dx%d failed.",
-                    "msDrawRasterLayerGDAL()",
-                    dst_xsize, dst_ysize, band_count );
-            FreeLUTs(papszLUTs);
-            return -1;
-        }
-        pBuffer = panBuffer;
-    }
-    else
-        pBuffer = pabyWholeBuffer;
-
-    eErr = GDALDatasetRasterIO( hDS, GF_Read,
-                                src_xoff, src_yoff, src_xsize, src_ysize,
-                                pBuffer,
-                                dst_xsize, dst_ysize, eDT,
-                                band_count, band_numbers,
-                                0,0,0);
-
-    if( eErr != CE_None ) {
-      msSetError( MS_IOERR,
-                  "GDALDatasetRasterIO() failed: %s",
-                  "drawGDAL()",
-                  CPLGetLastErrorMsg() );
-      FreeLUTs(papszLUTs);
-      msFree(panBuffer);
-      return -1;
-    }
-
-    for( iColorIndex = 0;
-         iColorIndex < band_count && result_code == 0; iColorIndex++ ) {
-      result_code = ApplyLUT( iColorIndex+1,
-                              papszLUTs[iColorIndex],
-                              (GByte*)pBuffer
-                                + dst_xsize*dst_ysize*iColorIndex*(GDALGetDataTypeSize(eDT)/8),
-                              eDT,
-                              pabyWholeBuffer + dst_xsize*dst_ysize*iColorIndex,
-                              dst_xsize * dst_ysize );
-    }
-
-    FreeLUTs(papszLUTs);
-    msFree(panBuffer);
-    return result_code;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Disable use of nodata if we are doing scaling.                  */
-  /* -------------------------------------------------------------------- */
-  *pbHaveRGBNoData = FALSE;
-
-  /* -------------------------------------------------------------------- */
-  /*      We need to do some scaling.  Will load into either a 16bit      */
-  /*      unsigned or a floating point buffer depending on the source     */
-  /*      data.  We offer a special case for 16U data because it is       */
-  /*      common and it is a substantial win to avoid alot of floating    */
-  /*      point operations on it.                                         */
-  /* -------------------------------------------------------------------- */
-  /* TODO */
-
-  /* -------------------------------------------------------------------- */
-  /*      Allocate the raw imagery buffer, and load into it (band         */
-  /*      interleaved).                                                   */
-  /* -------------------------------------------------------------------- */
-  pafWholeRawData =
-    (float *) malloc(sizeof(float) * dst_xsize * dst_ysize * band_count );
-
-  if( pafWholeRawData == NULL ) {
-    msSetError(MS_MEMERR,
-               "Allocating work float image of size %dx%dx%d failed.",
-               "msDrawRasterLayerGDAL()",
-               dst_xsize, dst_ysize, band_count );
-    return -1;
-  }
-
-  eErr = GDALDatasetRasterIO(
-           hDS, GF_Read,
-           src_xoff, src_yoff, src_xsize, src_ysize,
-           pafWholeRawData, dst_xsize, dst_ysize, GDT_Float32,
-           band_count, band_numbers,
-           0, 0, 0 );
-
-  if( eErr != CE_None ) {
-    msSetError( MS_IOERR, "GDALDatasetRasterIO() failed: %s",
-                "drawGDAL()",
-                CPLGetLastErrorMsg() );
-
-    free( pafWholeRawData );
-    return -1;
-  }
-
-  papszLUTs = LoadLUTs(layer, band_count);
-  if( papszLUTs == NULL ) {
-    free( pafWholeRawData );
-    return -1;
-  }
-
-  if( GetDataTypeAppropriateForLUTS(papszLUTs) != GDT_Byte ) {
-    msDebug( "LoadGDALImage(%s): One of the LUT contains a input value > 255.\n"
-             "This is not properly supported in combination with SCALE\n",
-             layer->name );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch the scale processing option.                              */
-  /* -------------------------------------------------------------------- */
-  for( iColorIndex = 0; iColorIndex < band_count; iColorIndex++ ) {
-    unsigned char *pabyBuffer;
-    double dfScaleMin=0.0, dfScaleMax=255.0, dfScaleRatio, dfNoDataValue;
-    const char *pszScaleInfo;
-    float *pafRawData;
-    int   nPixelCount = dst_xsize * dst_ysize, i, bGotNoData = FALSE;
-    GDALRasterBandH hBand =GDALGetRasterBand(hDS,band_numbers[iColorIndex]);
-    pszScaleInfo = CSLFetchNameValue( layer->processing, "SCALE" );
-    if( pszScaleInfo == NULL ) {
-      char szBandScalingName[20];
-
-      sprintf( szBandScalingName, "SCALE_%d", iColorIndex+1 );
-      pszScaleInfo = CSLFetchNameValue( layer->processing,
-                                        szBandScalingName);
-    }
-
-    if( pszScaleInfo != NULL ) {
-      char **papszTokens;
-
-      papszTokens = CSLTokenizeStringComplex( pszScaleInfo, " ,",
-                                              FALSE, FALSE );
-      if( CSLCount(papszTokens) == 1
-          && EQUAL(papszTokens[0],"AUTO") ) {
-        dfScaleMin = dfScaleMax = 0.0;
-      } else if( CSLCount(papszTokens) != 2 ) {
-        free( pafWholeRawData );
-        CSLDestroy( papszTokens );
-        FreeLUTs( papszLUTs );
-        msSetError( MS_MISCERR,
-                    "SCALE PROCESSING option unparsable for layer %s.",
-                    "msDrawGDAL()",
-                    layer->name );
-        return -1;
-      } else {
-        dfScaleMin = atof(papszTokens[0]);
-        dfScaleMax = atof(papszTokens[1]);
-      }
-      CSLDestroy( papszTokens );
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      If we are using autoscaling, then compute the max and min       */
-    /*      now.  Perhaps we should eventually honour the offsite value     */
-    /*      as a nodata value, or get it from GDAL.                         */
-    /* -------------------------------------------------------------------- */
-    pafRawData = pafWholeRawData + iColorIndex * dst_xsize * dst_ysize;
-
-    dfNoDataValue = msGetGDALNoDataValue( layer, hBand, &bGotNoData );
-
-    /* we force assignment to a float rather than letting pafRawData[i]
-       get promoted to double later to avoid float precision issues. */
-    float fNoDataValue = (float) dfNoDataValue;
-
-    if( dfScaleMin == dfScaleMax ) {
-      int bMinMaxSet = 0;
-
-      /* we force assignment to a float rather than letting pafRawData[i]
-         get promoted to double later to avoid float precision issues. */
-      float fNoDataValue = (float) dfNoDataValue;
-
-      for( i = 0; i < nPixelCount; i++ ) {
-        if( bGotNoData && IsNoData(pafRawData[i], fNoDataValue) )
-          continue;
-
-        if( CPLIsNan(pafRawData[i]) )
-          continue;
-
-        if( !bMinMaxSet ) {
-          dfScaleMin = dfScaleMax = pafRawData[i];
-          bMinMaxSet = TRUE;
-        }
-
-        dfScaleMin = MS_MIN(dfScaleMin,pafRawData[i]);
-        dfScaleMax = MS_MAX(dfScaleMax,pafRawData[i]);
-      }
-
-      if( dfScaleMin == dfScaleMax )
-        dfScaleMax = dfScaleMin + 1.0;
-    }
-
-    if( layer->debug > 0 )
-      msDebug( "msDrawGDAL(%s): scaling to 8bit, src range=%g,%g\n",
-               layer->name, dfScaleMin, dfScaleMax );
-
-    /* -------------------------------------------------------------------- */
-    /*      Now process the data.                                           */
-    /* -------------------------------------------------------------------- */
-    dfScaleRatio = 256.0 / (dfScaleMax - dfScaleMin);
-    pabyBuffer = pabyWholeBuffer + iColorIndex * nPixelCount;
-
-    if( iColorIndex == 0 && bGotNoData )
-      *ppbIsNoDataBuffer = (bool *)calloc(nPixelCount, 1);
-
-    for( i = 0; i < nPixelCount; i++ ) {
-      float fScaledValue;
-
-      if( bGotNoData && IsNoData(pafRawData[i], fNoDataValue) ) {
-        if( iColorIndex == 0 )
-          (*ppbIsNoDataBuffer)[i] = true;
-        continue;
-      }
-
-      fScaledValue = (float) ((pafRawData[i]-dfScaleMin)*dfScaleRatio);
-
-      if( fScaledValue < 0.0 )
-        pabyBuffer[i] = 0;
-      else if( fScaledValue > 255.0 )
-        pabyBuffer[i] = 255;
-      else
-        pabyBuffer[i] = (int) fScaledValue;
-    }
-
-    if( iColorIndex == 0 ) {
-      *pbScaled = true;
-      *pdfScaleMin = dfScaleMin;
-      *pdfScaleRatio = dfScaleRatio;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Report a warning if NODATA keyword was applied.  We are         */
-    /*      unable to utilize it since we can't return any pixels marked    */
-    /*      as nodata from this function.  Need to fix someday.             */
-    /* -------------------------------------------------------------------- */
-    if( bGotNoData )
-      msDebug( "LoadGDALImage(%s): NODATA value %g in GDAL\n"
-               "file or PROCESSING directive largely ignored.  Not yet fully supported for\n"
-               "unclassified scaled data.  The NODATA value is excluded from auto-scaling\n"
-               "min/max computation, but will not be transparent.\n",
-               layer->name, dfNoDataValue );
-
-    /* -------------------------------------------------------------------- */
-    /*      Apply LUT if there is one.                                      */
-    /* -------------------------------------------------------------------- */
-    result_code = ApplyLUT( iColorIndex+1,
-                            papszLUTs[iColorIndex],
-                            pabyBuffer,
-                            GDT_Byte,
-                            pabyBuffer,
-                            dst_xsize * dst_ysize );
-    if( result_code == -1 ) {
-      free( pafWholeRawData );
-      FreeLUTs( papszLUTs );
-      return result_code;
-    }
-  }
-
-  free( pafWholeRawData );
-  FreeLUTs( papszLUTs );
-
-  return result_code;
-}
-
-
-/************************************************************************/
-/*                       msGetGDALGeoTransform()                        */
-/*                                                                      */
-/*      Cover function that tries GDALGetGeoTransform(), a world        */
-/*      file or OWS extents.  It is assumed that TLOCK_GDAL is held     */
-/*      before this function is called.                                 */
-/************************************************************************/
-
-int msGetGDALGeoTransform( GDALDatasetH hDS, mapObj *map, layerObj *layer,
-                           double *padfGeoTransform )
-
-{
-  const char *extent_priority = NULL;
-  const char *value;
-  const char *gdalDesc;
-  const char *fullPath;
-  char *fileExtension = NULL;
-  char szPath[MS_MAXPATHLEN];
-  int fullPathLen;
-  int success = 0;
-  rectObj  rect;
-
-  /* -------------------------------------------------------------------- */
-  /*      some GDAL drivers (ie. GIF) don't set geotransform on failure.  */
-  /* -------------------------------------------------------------------- */
-  padfGeoTransform[0] = 0.0;
-  padfGeoTransform[1] = 1.0;
-  padfGeoTransform[2] = 0.0;
-  padfGeoTransform[3] = GDALGetRasterYSize(hDS);
-  padfGeoTransform[4] = 0.0;
-  padfGeoTransform[5] = -1.0;
-
-  /* -------------------------------------------------------------------- */
-  /*      Do we want to override GDAL with a worldfile if one is present? */
-  /* -------------------------------------------------------------------- */
-  extent_priority = CSLFetchNameValue( layer->processing,
-                                       "EXTENT_PRIORITY" );
-
-  if( extent_priority != NULL
-      && EQUALN(extent_priority,"WORLD",5) ) {
-    /* is there a user configured worldfile? */
-    value = CSLFetchNameValue( layer->processing, "WORLDFILE" );
-
-    if( value != NULL ) {
-      /* at this point, fullPath may be a filePath or path only */
-      fullPath = msBuildPath(szPath, map->mappath, value);
-
-      /* fullPath is a path only, so let's append the dataset filename */
-      if( strrchr(szPath,'.') == NULL ) {
-        fullPathLen = strlen(fullPath);
-        gdalDesc = msStripPath((char*)GDALGetDescription(hDS));
-
-        if ( (fullPathLen + strlen(gdalDesc)) < MS_MAXPATHLEN ) {
-          strcpy((char*)(fullPath + fullPathLen), gdalDesc);
-        } else {
-          msDebug("Path length to alternative worldfile exceeds MS_MAXPATHLEN.\n");
-          fullPath = NULL;
-        }
-      }
-      /* fullPath has a filename included, so get the extension */
-      else {
-        fileExtension = msStrdup(strrchr(szPath,'.') + 1);
-      }
-    }
-    /* common behaviour with worldfile generated from basename + .wld */
-    else {
-      fullPath = GDALGetDescription(hDS);
-      fileExtension = msStrdup("wld");
-    }
-
-    if( fullPath )
-      success = GDALReadWorldFile(fullPath, fileExtension, padfGeoTransform);
-
-    if( success && layer->debug >= MS_DEBUGLEVEL_VVV ) {
-      msDebug("Worldfile location: %s.\n", fullPath);
-    } else if( layer->debug >= MS_DEBUGLEVEL_VVV ) {
-      msDebug("Failed using worldfile location: %s.\n", fullPath);
-    }
-
-    msFree(fileExtension);
-
-    if( success )
-      return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Try GDAL.                                                       */
-  /*                                                                      */
-  /*      Make sure that ymax is always at the top, and ymin at the       */
-  /*      bottom ... that is flip any files without the usual             */
-  /*      orientation.  This is intended to enable display of "raw"       */
-  /*      files with no coordinate system otherwise they break down in    */
-  /*      many ways.                                                      */
-  /* -------------------------------------------------------------------- */
-  if (GDALGetGeoTransform( hDS, padfGeoTransform ) == CE_None ) {
-    if( padfGeoTransform[5] == 1.0 && padfGeoTransform[3] == 0.0 ) {
-      padfGeoTransform[5] = -1.0;
-      padfGeoTransform[3] = GDALGetRasterYSize(hDS);
-    }
-
-    return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Try worldfile.                                                  */
-  /* -------------------------------------------------------------------- */
-  if( GDALGetDescription(hDS) != NULL
-      && GDALReadWorldFile(GDALGetDescription(hDS), "wld",
-                           padfGeoTransform) ) {
-    return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Do we have the extent keyword on the layer?  We only use        */
-  /*      this if we have a single raster associated with the layer as    */
-  /*      opposed to a tile index.                                        */
-  /*                                                                      */
-  /*      Arguably this ought to take priority over all the other         */
-  /*      stuff.                                                          */
-  /* -------------------------------------------------------------------- */
-  if (MS_VALID_EXTENT(layer->extent) && layer->data != NULL) {
-    rect = layer->extent;
-
-    padfGeoTransform[0] = rect.minx;
-    padfGeoTransform[1] = (rect.maxx - rect.minx) /
-                          (double) GDALGetRasterXSize( hDS );
-    padfGeoTransform[2] = 0;
-    padfGeoTransform[3] = rect.maxy;
-    padfGeoTransform[4] = 0;
-    padfGeoTransform[5] = (rect.miny - rect.maxy) /
-                          (double) GDALGetRasterYSize( hDS );
-
-    return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      We didn't find any info ... use the default.                    */
-  /*      Reset our default geotransform.  GDALGetGeoTransform() may      */
-  /*      have altered it even if GDALGetGeoTransform() failed.           */
-  /* -------------------------------------------------------------------- */
-  padfGeoTransform[0] = 0.0;
-  padfGeoTransform[1] = 1.0;
-  padfGeoTransform[2] = 0.0;
-  padfGeoTransform[3] = GDALGetRasterYSize(hDS);
-  padfGeoTransform[4] = 0.0;
-  padfGeoTransform[5] = -1.0;
-
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                   msDrawRasterLayerGDAL_RawMode()                    */
-/*                                                                      */
-/*      Handle the loading and application of data in rawmode.          */
-/************************************************************************/
-
-static int
-msDrawRasterLayerGDAL_RawMode(
-  mapObj *map, layerObj *layer, imageObj *image, GDALDatasetH hDS,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize )
-
-{
-  void *pBuffer;
-  GDALDataType eDataType;
-  int *band_list, band_count;
-  int  i, j, k, band;
-  CPLErr eErr;
-  float *f_nodatas = NULL;
-  unsigned char *b_nodatas = NULL;
-  GInt16 *i_nodatas = NULL;
-  int got_nodata=FALSE;
-  rasterBufferObj *mask_rb = NULL;
-  rasterBufferObj s_mask_rb;
-  if(layer->mask) {
-    int ret;
-    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map,layer->mask));
-    mask_rb = &s_mask_rb;
-    memset(mask_rb, 0, sizeof(s_mask_rb));
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS)
-      return -1;
-  }
-
-  if( image->format->bands > 256 ) {
-    msSetError( MS_IMGERR, "Too many bands (more than 256).",
-                "msDrawRasterLayerGDAL_RawMode()" );
-    return -1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      What data type do we need?                                      */
-  /* -------------------------------------------------------------------- */
-  if( image->format->imagemode == MS_IMAGEMODE_INT16 )
-    eDataType = GDT_Int16;
-  else if( image->format->imagemode == MS_IMAGEMODE_FLOAT32 )
-    eDataType = GDT_Float32;
-  else if( image->format->imagemode == MS_IMAGEMODE_BYTE )
-    eDataType = GDT_Byte;
-  else
-    return -1;
-
-  /* -------------------------------------------------------------------- */
-  /*      Work out the band list.                                         */
-  /* -------------------------------------------------------------------- */
-  band_list = msGetGDALBandList( layer, hDS, image->format->bands,
-                                 &band_count );
-  if( band_list == NULL )
-    return -1;
-
-  if( band_count != image->format->bands ) {
-    free( band_list );
-    msSetError( MS_IMGERR, "BANDS PROCESSING directive has wrong number of bands, expected %d, got %d.",
-                "msDrawRasterLayerGDAL_RawMode()",
-                image->format->bands, band_count );
-    return -1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Do we have nodata values?                                       */
-  /* -------------------------------------------------------------------- */
-  f_nodatas = (float *) calloc(sizeof(float),band_count);
-  if (f_nodatas == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawRasterLayerGDAL_RawMode()",
-               __FILE__, __LINE__, (unsigned int)(sizeof(float)*band_count));
-    free( band_list );
-    return -1;
-  }
-
-  if( band_count <= 3
-      && (layer->offsite.red != -1
-          || layer->offsite.green != -1
-          || layer->offsite.blue != -1) ) {
-    if( band_count > 0 )
-      f_nodatas[0] = layer->offsite.red;
-    if( band_count > 1 )
-      f_nodatas[1] = layer->offsite.green;
-    if( band_count > 2 )
-      f_nodatas[2] = layer->offsite.blue;
-    got_nodata = TRUE;
-  }
-
-  if( !got_nodata ) {
-    got_nodata = TRUE;
-    for( band = 0; band < band_count && got_nodata; band++ ) {
-      f_nodatas[band] = msGetGDALNoDataValue(
-                          layer, GDALGetRasterBand(hDS,band_list[band]), &got_nodata );
-    }
-  }
-
-  if( !got_nodata ) {
-    free( f_nodatas );
-    f_nodatas = NULL;
-  } else if( eDataType == GDT_Byte ) {
-    b_nodatas = (unsigned char *) f_nodatas;
-    for( band = 0; band < band_count; band++ )
-      b_nodatas[band] = (unsigned char) f_nodatas[band];
-  } else if( eDataType == GDT_Int16 ) {
-    i_nodatas = (GInt16 *) f_nodatas;
-    for( band = 0; band < band_count; band++ )
-      i_nodatas[band] = (GInt16) f_nodatas[band];
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Allocate buffer, and read data into it.                         */
-  /* -------------------------------------------------------------------- */
-  pBuffer = malloc(dst_xsize * dst_ysize * image->format->bands
-                   * (GDALGetDataTypeSize(eDataType)/8) );
-  if( pBuffer == NULL ) {
-    msSetError(MS_MEMERR,
-               "Allocating work image of size %dx%d failed.",
-               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize );
-    free( band_list );
-    free( f_nodatas );
-    return -1;
-  }
-
-  eErr = GDALDatasetRasterIO( hDS, GF_Read,
-                              src_xoff, src_yoff, src_xsize, src_ysize,
-                              pBuffer, dst_xsize, dst_ysize, eDataType,
-                              image->format->bands, band_list,
-                              0, 0, 0 );
-  free( band_list );
-
-  if( eErr != CE_None ) {
-    msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                "msDrawRasterLayerGDAL_RawMode()", CPLGetLastErrorMsg() );
-    free( pBuffer );
-    free( f_nodatas );
-    return -1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Transfer the data to the imageObj.                              */
-  /* -------------------------------------------------------------------- */
-  k = 0;
-  for( band = 0; band < image->format->bands; band++ ) {
-    for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-      if( image->format->imagemode == MS_IMAGEMODE_INT16 ) {
-        for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
-          int off = j + i * image->width
-                    + band*image->width*image->height;
-          int off_mask = j + i * image->width;
-
-          if( ( i_nodatas && ((GInt16 *) pBuffer)[k] == i_nodatas[band] )
-              || SKIP_MASK(j,i)) {
-            k++;
-            continue;
-          }
-
-          image->img.raw_16bit[off] = ((GInt16 *) pBuffer)[k++];
-          MS_SET_BIT(image->img_mask,off_mask);
-        }
-      } else if( image->format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
-        for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
-          int off = j + i * image->width
-                    + band*image->width*image->height;
-          int off_mask = j + i * image->width;
-
-          if( ( f_nodatas && ((float *) pBuffer)[k] == f_nodatas[band] )
-              || SKIP_MASK(j,i)) {
-            k++;
-            continue;
-          }
-
-          image->img.raw_float[off] = ((float *) pBuffer)[k++];
-          MS_SET_BIT(image->img_mask,off_mask);
-        }
-      } else if( image->format->imagemode == MS_IMAGEMODE_BYTE ) {
-        for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
-          int off = j + i * image->width
-                    + band*image->width*image->height;
-          int off_mask = j + i * image->width;
-
-          if( ( b_nodatas && ((unsigned char *) pBuffer)[k] == b_nodatas[band] )
-              || SKIP_MASK(j,i)) {
-            k++;
-            continue;
-          }
-
-          image->img.raw_byte[off] = ((unsigned char *) pBuffer)[k++];
-          MS_SET_BIT(image->img_mask,off_mask);
-        }
-      }
-    }
-  }
-
-  free( pBuffer );
-  free( f_nodatas );
-
-  return 0;
-}
-
-/************************************************************************/
-/*              msDrawRasterLayerGDAL_16BitClassifcation()              */
-/*                                                                      */
-/*      Handle the rendering of rasters going through a 16bit           */
-/*      classification lookup instead of the more common 8bit one.      */
-/*                                                                      */
-/*      Currently we are using one data path where we load the          */
-/*      raster into a floating point buffer, and then scale to          */
-/*      16bit.  Eventually we could add optimizations for some of       */
-/*      the 16bit cases at the cost of some complication.               */
-/************************************************************************/
-
-static int
-msDrawRasterLayerGDAL_16BitClassification(
-  mapObj *map, layerObj *layer, rasterBufferObj *rb,
-  GDALRasterBandH hBand,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize )
-
-{
-  float *pafRawData;
-  double dfScaleMin=0.0, dfScaleMax=0.0, dfScaleRatio;
-  int   nPixelCount = dst_xsize * dst_ysize, i, nBucketCount=0;
-  GDALDataType eDataType;
-  float fDataMin=0.0, fDataMax=255.0, fNoDataValue;
-  const char *pszScaleInfo;
-  const char *pszBuckets;
-  int  *cmap, c, j, k, bGotNoData = FALSE, bGotFirstValue;
-  unsigned char *rb_cmap[4];
-  CPLErr eErr;
-  rasterBufferObj *mask_rb = NULL;
-  rasterBufferObj s_mask_rb;
-  int lastC;
-  struct mstimeval starttime={0}, endtime={0};
-
-  const char *pszClassifyScaled;
-  int bClassifyScaled = FALSE;
-
-  if(layer->mask) {
-    int ret;
-    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map,layer->mask));
-    mask_rb = &s_mask_rb;
-    memset(mask_rb, 0, sizeof(s_mask_rb));
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS)
-      return -1;
-  }
-
-  assert( rb->type == MS_BUFFER_BYTE_RGBA );
-
-  /* ==================================================================== */
-  /*      Read the requested data in one gulp into a floating point       */
-  /*      buffer.                                                         */
-  /* ==================================================================== */
-  pafRawData = (float *) malloc(sizeof(float) * dst_xsize * dst_ysize );
-  if( pafRawData == NULL ) {
-    msSetError( MS_MEMERR, "Out of memory allocating working buffer.",
-                "msDrawRasterLayerGDAL_16BitClassification()" );
-    return -1;
-  }
-
-  eErr = GDALRasterIO( hBand, GF_Read,
-                       src_xoff, src_yoff, src_xsize, src_ysize,
-                       pafRawData, dst_xsize, dst_ysize, GDT_Float32, 0, 0 );
-
-  if( eErr != CE_None ) {
-    free( pafRawData );
-    msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                "msDrawRasterLayerGDAL_16BitClassification()",
-                CPLGetLastErrorMsg() );
-    return -1;
-  }
-
-  fNoDataValue = (float) msGetGDALNoDataValue( layer, hBand, &bGotNoData );
-
-  /* ==================================================================== */
-  /*      Determine scaling.                                              */
-  /* ==================================================================== */
-  eDataType = GDALGetRasterDataType( hBand );
-
-  /* -------------------------------------------------------------------- */
-  /*      Scan for absolute min/max of this block.                        */
-  /* -------------------------------------------------------------------- */
-  bGotFirstValue = FALSE;
-
-  for( i = 1; i < nPixelCount; i++ ) {
-    if( bGotNoData && IsNoData(pafRawData[i], fNoDataValue) )
-      continue;
-
-    if( CPLIsNan(pafRawData[i]) )
-      continue;
-
-    if( !bGotFirstValue ) {
-      fDataMin = fDataMax = pafRawData[i];
-      bGotFirstValue = TRUE;
-    } else {
-      fDataMin = MS_MIN(fDataMin,pafRawData[i]);
-      fDataMax = MS_MAX(fDataMax,pafRawData[i]);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch the scale classification option.                          */
-  /* -------------------------------------------------------------------- */
-  pszClassifyScaled = CSLFetchNameValue( layer->processing, "CLASSIFY_SCALED" );
-  if( pszClassifyScaled != NULL )
-    bClassifyScaled = CSLTestBoolean(pszClassifyScaled);
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch the scale processing option.                              */
-  /* -------------------------------------------------------------------- */
-  pszBuckets = CSLFetchNameValue( layer->processing, "SCALE_BUCKETS" );
-  pszScaleInfo = CSLFetchNameValue( layer->processing, "SCALE" );
-
-  if( pszScaleInfo != NULL ) {
-    char **papszTokens;
-
-    papszTokens = CSLTokenizeStringComplex( pszScaleInfo, " ,",
-                                            FALSE, FALSE );
-    if( CSLCount(papszTokens) == 1
-        && EQUAL(papszTokens[0],"AUTO") ) {
-      dfScaleMin = dfScaleMax = 0.0;
-    } else if( CSLCount(papszTokens) != 2 ) {
-      free( pafRawData );
-      CSLDestroy( papszTokens );
-      msSetError( MS_MISCERR,
-                  "SCALE PROCESSING option unparsable for layer %s.",
-                  "msDrawGDAL()",
-                  layer->name );
-      return -1;
-    } else {
-      dfScaleMin = atof(papszTokens[0]);
-      dfScaleMax = atof(papszTokens[1]);
-    }
-    CSLDestroy( papszTokens );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Special integer cases for scaling.                              */
-  /*                                                                      */
-  /*      TODO: Treat Int32 and UInt32 case the same way *if* the min     */
-  /*      and max are less than 65536 apart.                              */
-  /* -------------------------------------------------------------------- */
-  if( eDataType == GDT_Byte || eDataType == GDT_Int16
-      || eDataType == GDT_UInt16 ) {
-    if( pszScaleInfo == NULL ) {
-      dfScaleMin = fDataMin - 0.5;
-      dfScaleMax = fDataMax + 0.5;
-    }
-
-    if( pszBuckets == NULL ) {
-      nBucketCount = (int) floor(fDataMax - fDataMin + 1.1);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      General case if no scaling values provided in mapfile.          */
-  /* -------------------------------------------------------------------- */
-  else if( dfScaleMin == 0.0 && dfScaleMax == 0.0 ) {
-    double dfEpsilon = (fDataMax - fDataMin) / (65536*2);
-    dfScaleMin = fDataMin - dfEpsilon;
-    dfScaleMax = fDataMax + dfEpsilon;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      How many buckets?  Only set if we don't already have a value.   */
-  /* -------------------------------------------------------------------- */
-  if( pszBuckets == NULL ) {
-    if( nBucketCount == 0 )
-      nBucketCount = 65536;
-  } else {
-    nBucketCount = atoi(pszBuckets);
-    if( nBucketCount < 2 ) {
-      free( pafRawData );
-      msSetError( MS_MISCERR,
-                  "SCALE_BUCKETS PROCESSING option is not a value of 2 or more: %s.",
-                  "msDrawRasterLayerGDAL_16BitClassification()",
-                  pszBuckets );
-      return -1;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Compute scaling ratio.                                          */
-  /* -------------------------------------------------------------------- */
-  if( dfScaleMax == dfScaleMin )
-    dfScaleMax = dfScaleMin + 1.0;
-
-  dfScaleRatio = nBucketCount / (dfScaleMax - dfScaleMin);
-
-  if( layer->debug > 0 )
-    msDebug( "msDrawRasterGDAL_16BitClassification(%s):\n"
-             "  scaling to %d buckets from range=%g,%g.\n",
-             layer->name, nBucketCount, dfScaleMin, dfScaleMax );
-
-  /* ==================================================================== */
-  /*      Compute classification lookup table.                            */
-  /* ==================================================================== */
-
-  cmap = (int *) msSmallCalloc(sizeof(int),nBucketCount);
-  rb_cmap[0] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-  rb_cmap[1] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-  rb_cmap[2] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-  rb_cmap[3] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-
-
-  if(layer->debug >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&starttime, NULL);
-  }
-
-  lastC = -1;
-  for(i=0; i < nBucketCount; i++) {
-    double dfOriginalValue;
-
-    cmap[i] = -1;
-
-    // i = (int) ((dfOriginalValue - dfScaleMin) * dfScaleRatio+1)-1;
-    dfOriginalValue = (i+0.5) / dfScaleRatio + dfScaleMin;
-
-    /* The creation of buckets takes a significant time when they are many, and many classes
-       as well. When iterating over buckets, a faster strategy is to reuse first the last used
-       class index. */
-    if(bClassifyScaled == TRUE)
-      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float) i, -1, -1, -1, lastC);
-    else
-      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float) dfOriginalValue, -1, -1, -1, lastC);
-
-    lastC = c;
-    if( c != -1 ) {
-      int s;
-      int styleindex = 0;
-
-      /* change colour based on colour range? */
-      if( MS_VALID_COLOR(layer->class[c]->styles[0]->mincolor) )
-      {
-        styleindex = -1;
-        for(s=0; s<layer->class[c]->numstyles; s++) {
-          if( MS_VALID_COLOR(layer->class[c]->styles[s]->mincolor)
-              && MS_VALID_COLOR(layer->class[c]->styles[s]->maxcolor)
-              && dfOriginalValue + 0.5 / dfScaleRatio >= layer->class[c]->styles[s]->minvalue
-              && dfOriginalValue - 0.5 / dfScaleRatio <= layer->class[c]->styles[s]->maxvalue ) {
-            msValueToRange(layer->class[c]->styles[s],dfOriginalValue, MS_COLORSPACE_RGB);
-            styleindex = s;
-            break;
-          }
-        }
-      }
-      if( styleindex >= 0 ) {
-        if( MS_TRANSPARENT_COLOR(layer->class[c]->styles[styleindex]->color) ) {
-          /* leave it transparent */
-        } else if( MS_VALID_COLOR(layer->class[c]->styles[styleindex]->color)) {
-          /* use class color */
-          rb_cmap[0][i] = layer->class[c]->styles[styleindex]->color.red;
-          rb_cmap[1][i] = layer->class[c]->styles[styleindex]->color.green;
-          rb_cmap[2][i] = layer->class[c]->styles[styleindex]->color.blue;
-          rb_cmap[3][i] = (255*layer->class[c]->styles[styleindex]->opacity / 100);
-        }
-      }
-    }
-  }
-
-  if(layer->debug >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&endtime, NULL);
-    msDebug("msDrawRasterGDAL_16BitClassification() bucket creation time: %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-  }
-
-  /* ==================================================================== */
-  /*      Now process the data, applying to the working imageObj.         */
-  /* ==================================================================== */
-  k = 0;
-
-  for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-    for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
-      float fRawValue = pafRawData[k++];
-      int   iMapIndex;
-
-      /*
-       * Skip nodata pixels ... no processing.
-       */
-      if( bGotNoData && IsNoData(fRawValue, fNoDataValue) )
-        continue;
-
-      if( CPLIsNan(fRawValue) )
-        continue;
-
-      if(SKIP_MASK(j,i))
-        continue;
-
-      /*
-       * The funny +1/-1 is to avoid odd rounding around zero.
-       * We could use floor() but sometimes it is expensive.
-       */
-      iMapIndex = (int) ((fRawValue - dfScaleMin) * dfScaleRatio+1)-1;
-
-      if( iMapIndex >= nBucketCount || iMapIndex < 0 ) {
-        continue;
-      }
-      /* currently we never have partial alpha so keep simple */
-      if( rb_cmap[3][iMapIndex] > 0 )
-        RB_SET_PIXEL( rb, j, i,
-                      rb_cmap[0][iMapIndex],
-                      rb_cmap[1][iMapIndex],
-                      rb_cmap[2][iMapIndex],
-                      rb_cmap[3][iMapIndex] );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Cleanup                                                         */
-  /* -------------------------------------------------------------------- */
-  free( pafRawData );
-  free( cmap );
-  free( rb_cmap[0] );
-  free( rb_cmap[1] );
-  free( rb_cmap[2] );
-  free( rb_cmap[3] );
-
-  assert( k == dst_xsize * dst_ysize );
-
-  return 0;
-}
-
-/************************************************************************/
-/*                          IsNoData()                                  */
-/************************************************************************/
-static bool
-IsNoData( double dfValue, double dfNoDataValue )
-{
-  return isnan(dfValue) || dfValue == dfNoDataValue;
-}
-
-/************************************************************************/
-/*                          msGetGDALNoDataValue()                      */
-/************************************************************************/
-double
-msGetGDALNoDataValue( layerObj *layer, void *hBand, int *pbGotNoData )
-
-{
-  const char *pszNODATAOpt;
-
-  *pbGotNoData = FALSE;
-
-  /* -------------------------------------------------------------------- */
-  /*      Check for a NODATA setting in the .map file.                    */
-  /* -------------------------------------------------------------------- */
-  pszNODATAOpt = CSLFetchNameValue(layer->processing,"NODATA");
-  if( pszNODATAOpt != NULL ) {
-    if( EQUAL(pszNODATAOpt,"OFF") || strlen(pszNODATAOpt) == 0 )
-      return -1234567.0;
-    if( !EQUAL(pszNODATAOpt,"AUTO") ) {
-      *pbGotNoData = TRUE;
-      return atof(pszNODATAOpt);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Check for a NODATA setting on the raw file.                     */
-  /* -------------------------------------------------------------------- */
-  if( hBand == NULL )
-    return -1234567.0;
-  else
-    return GDALGetRasterNoDataValue( hBand, pbGotNoData );
-}
-
-/************************************************************************/
-/*                         msGetGDALBandList()                          */
-/*                                                                      */
-/*      max_bands - pass zero for no limit.                             */
-/*      band_count - location in which length of the return band        */
-/*      list is placed.                                                 */
-/*                                                                      */
-/*      returns malloc() list of band numbers (*band_count long).       */
-/************************************************************************/
-
-int *msGetGDALBandList( layerObj *layer, void *hDS,
-                        int max_bands, int *band_count )
-
-{
-  int i, file_bands;
-  int *band_list = NULL;
-
-  file_bands = GDALGetRasterCount( hDS );
-  if( file_bands == 0 ) {
-    msSetError( MS_IMGERR,
-                "Attempt to operate on GDAL file with no bands, layer=%s.",
-                "msGetGDALBandList()",
-                layer->name );
-
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Use all (or first) bands.                                       */
-  /* -------------------------------------------------------------------- */
-  if( CSLFetchNameValue( layer->processing, "BANDS" ) == NULL ) {
-    if( max_bands > 0 )
-      *band_count = MS_MIN(file_bands,max_bands);
-    else
-      *band_count = file_bands;
-
-    band_list = (int *) malloc(sizeof(int) * *band_count );
-
-    /* FIXME MS_CHECK_ALLOC leaks papszItems */
-    MS_CHECK_ALLOC(band_list, sizeof(int) * *band_count, NULL);
-
-    for( i = 0; i < *band_count; i++ )
-      band_list[i] = i+1;
-    return band_list;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      get bands from BANDS processing directive.                      */
-  /* -------------------------------------------------------------------- */
-  else {
-    char **papszItems = CSLTokenizeStringComplex(
-                          CSLFetchNameValue(layer->processing,"BANDS"), " ,", FALSE, FALSE );
-
-    if( CSLCount(papszItems) == 0 ) {
-      CSLDestroy( papszItems );
-      msSetError( MS_IMGERR, "BANDS PROCESSING directive has no items.",
-                  "msGetGDALBandList()" );
-      return NULL;
-    } else if( max_bands != 0 && CSLCount(papszItems) > max_bands ) {
-      msSetError( MS_IMGERR, "BANDS PROCESSING directive has wrong number of bands, expected at most %d, got %d.",
-                  "msGetGDALBandList()",
-                  max_bands, CSLCount(papszItems) );
-      CSLDestroy( papszItems );
-      return NULL;
-    }
-
-    *band_count = CSLCount(papszItems);
-    band_list = (int *) malloc(sizeof(int) * *band_count);
-    MS_CHECK_ALLOC(band_list, sizeof(int) * *band_count, NULL);
-
-    for( i = 0; i < *band_count; i++ ) {
-      band_list[i] = atoi(papszItems[i]);
-      if( band_list[i] < 1 || band_list[i] > GDALGetRasterCount(hDS) ) {
-        msSetError( MS_IMGERR,
-                    "BANDS PROCESSING directive includes illegal band '%s', should be from 1 to %d.",
-                    "msGetGDALBandList()",
-                    papszItems[i], GDALGetRasterCount(hDS) );
-        CSLDestroy( papszItems );
-        free( band_list );
-        return NULL;
-      }
-    }
-    CSLDestroy( papszItems );
-
-    return band_list;
-  }
-}
diff -pruN 8.0.1-5/mapdummyrenderer.c 8.2.0~beta1-1~exp1/mapdummyrenderer.c
--- 8.0.1-5/mapdummyrenderer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapdummyrenderer.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,401 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Dummy functions to implement when using a pluggable renderer
- * Author:   Thomas Bonfort, thomas.bonfort@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 2010, Thomas Bonfort
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-
-int renderLineDummy(imageObj *img, shapeObj *p, strokeStyleObj *style)
-{
-  (void)img;
-  (void)p;
-  (void)style;
-  msSetError(MS_RENDERERERR,"renderLine not implemented","renderLine()");
-  return MS_FAILURE;
-}
-
-int renderPolygonDummy(imageObj *img, shapeObj *p, colorObj *color)
-{
-  (void)img;
-  (void)p;
-  (void)color;
-  msSetError(MS_RENDERERERR,"renderPolygon not implemented","renderPolygon()");
-  return MS_FAILURE;
-}
-
-int renderPolygonTiledDummy(imageObj *img, shapeObj *p, imageObj *tile)
-{
-  (void)img;
-  (void)p;
-  (void)tile;
-  msSetError(MS_RENDERERERR,"renderPolygonTiled not implemented","renderPolygonTiled()");
-  return MS_FAILURE;
-}
-
-int renderLineTiledDummy(imageObj *img, shapeObj *p, imageObj *tile)
-{
-  (void)img;
-  (void)p;
-  (void)tile;
-  msSetError(MS_RENDERERERR,"renderLineTiled not implemented","renderLineTiled()");
-  return MS_FAILURE;
-}
-
-int renderRasterGlyphsDummy(imageObj *img, double x, double y, int fontIndex,
-                            colorObj *color, char* text)
-{
-  (void)img;
-  (void)x;
-  (void)y;
-  (void)fontIndex;
-  (void)color;
-  (void)text;
-  msSetError(MS_RENDERERERR,"renderRasterGlyphs not implemented","renderRasterGlyphs()");
-  return MS_FAILURE;
-}
-
-int renderGlyphsLineDummy(imageObj *img,labelPathObj *labelpath,
-                          labelStyleObj *style, char *text)
-{
-  (void)img;
-  (void)labelpath;
-  (void)style;
-  (void)text;
-  msSetError(MS_RENDERERERR,"renderGlyphsLine not implemented","renderGlyphsLine()");
-  return MS_FAILURE;
-}
-
-int renderVectorSymbolDummy(imageObj *img, double x, double y,
-                            symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)img;
-  (void)x;
-  (void)y;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"renderVectorSymbol not implemented","renderVectorSymbol()");
-  return MS_FAILURE;
-}
-
-void* createVectorSymbolTileDummy(int width, int height,
-                                  symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)width;
-  (void)height;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"createVectorSymbolTile not implemented","createVectorSymbolTile()");
-  return NULL;
-}
-
-int renderPixmapSymbolDummy(imageObj *img, double x, double y,
-                            symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)img;
-  (void)x;
-  (void)y;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"renderPixmapSymbol not implemented","renderPixmapSymbol()");
-  return MS_FAILURE;
-}
-
-void* createPixmapSymbolTileDummy(int width, int height,
-                                  symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)width;
-  (void)height;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"createPixmapSymbolTile not implemented","createPixmapSymbolTile()");
-  return NULL;
-}
-
-int renderEllipseSymbolDummy(imageObj *image, double x, double y,
-                             symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)image;
-  (void)x;
-  (void)y;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"renderEllipseSymbol not implemented","renderEllipseSymbol()");
-  return MS_FAILURE;
-}
-
-void* createEllipseSymbolTileDummy(int width, int height,
-                                   symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)width;
-  (void)height;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"createEllipseSymbolTile not implemented","createEllipseSymbolTile()");
-  return NULL;
-}
-
-int renderTruetypeSymbolDummy(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)img;
-  (void)x;
-  (void)y;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"renderTruetypeSymbol not implemented","renderTruetypeSymbol()");
-  return MS_FAILURE;
-}
-
-void* createTruetypeSymbolTileDummy(int width, int height,
-                                    symbolObj *symbol, symbolStyleObj *style)
-{
-  (void)width;
-  (void)height;
-  (void)symbol;
-  (void)style;
-  msSetError(MS_RENDERERERR,"createTruetypeSymbolTile not implemented","createTruetypeSymbolTile()");
-  return NULL;
-}
-
-int renderTileDummy(imageObj *img, imageObj *tile, double x, double y)
-{
-  (void)img;
-  (void)tile;
-  (void)x;
-  (void)y;
-  msSetError(MS_RENDERERERR,"renderTile not implemented","renderTile()");
-  return MS_FAILURE;
-}
-
-rasterBufferObj* loadImageFromFileDummy(char *path)
-{
-  (void)path;
-  msSetError(MS_RENDERERERR,"loadImageFromFile not implemented","loadImageFromFile()");
-  return NULL;
-}
-
-
-int getRasterBufferHandleDummy(imageObj *img, rasterBufferObj *rb)
-{
-  (void)img;
-  (void)rb;
-  msSetError(MS_RENDERERERR,"getRasterBufferHandle not implemented","getRasterBufferHandle()");
-  return MS_FAILURE;
-}
-
-int getRasterBufferCopyDummy(imageObj *img, rasterBufferObj *rb)
-{
-  (void)img;
-  (void)rb;
-  msSetError(MS_RENDERERERR,"getRasterBufferCopy not implemented","getRasterBufferCopy()");
-  return MS_FAILURE;
-}
-
-rasterBufferObj* createRasterBufferDummy(int width, int height)
-{
-  (void)width;
-  (void)height;
-  msSetError(MS_RENDERERERR,"createRasterBuffer not implemented","createRasterBuffer()");
-  return NULL;
-}
-
-int mergeRasterBufferDummy(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height)
-{
-  (void)dest;
-  (void)overlay;
-  (void)opacity;
-  (void)srcX;
-  (void)srcY;
-  (void)dstX;
-  (void)dstY;
-  (void)width;
-  (void)height;
-  msSetError(MS_RENDERERERR,"mergeRasterBuffer not implemented","mergeRasterBuffer()");
-  return MS_FAILURE;
-}
-
-int initializeRasterBufferDummy(rasterBufferObj *rb, int width, int height, int mode)
-{
-  (void)rb;
-  (void)width;
-  (void)height;
-  (void)mode;
-  msSetError(MS_RENDERERERR,"initializeRasterBuffer not implemented","initializeRasterBuffer()");
-  return MS_FAILURE;
-}
-
-
-
-/* image i/o */
-imageObj* createImageDummy(int width, int height, outputFormatObj *format, colorObj* bg)
-{
-  (void)width;
-  (void)height;
-  (void)format;
-  (void)bg;
-  msSetError(MS_RENDERERERR,"createImage not implemented","createImage()");
-  return NULL;
-}
-
-int saveImageDummy(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format)
-{
-  (void)img;
-  (void)map;
-  (void)fp;
-  (void)format;
-  msSetError(MS_RENDERERERR,"saveImage not implemented","saveImage()");
-  return MS_FAILURE;
-}
-/*...*/
-
-/* helper functions */
-int getTruetypeTextBBoxDummy(rendererVTableObj *renderer, char **fonts, int numfonts, double size,
-                             char *string,rectObj *rect, double **advances, int bAdjustBaseline)
-{
-  (void)renderer;
-  (void)fonts;
-  (void)numfonts;
-  (void)size;
-  (void)string;
-  (void)rect;
-  (void)advances;
-  (void)bAdjustBaseline;
-  msSetError(MS_RENDERERERR,"getTruetypeTextBBox not implemented","getTruetypeTextBBox()");
-  return MS_FAILURE;
-}
-
-int startLayerDummy(imageObj *img, mapObj *map, layerObj *layer)
-{
-  (void)img;
-  (void)map;
-  (void)layer;
-  msSetError(MS_RENDERERERR,"startLayer not implemented","startLayer()");
-  return MS_FAILURE;
-}
-
-int endLayerDummy(imageObj *img, mapObj *map, layerObj *layer)
-{
-  (void)img;
-  (void)map;
-  (void)layer;
-  msSetError(MS_RENDERERERR,"endLayer not implemented","endLayer()");
-  return MS_FAILURE;
-}
-
-int startShapeDummy(imageObj *img, shapeObj *shape)
-{
-  (void)img;
-  (void)shape;
-  msSetError(MS_RENDERERERR,"startShape not implemented","startShape()");
-  return MS_FAILURE;
-}
-
-int endShapeDummy(imageObj *img, shapeObj *shape)
-{
-  (void)img;
-  (void)shape;
-  msSetError(MS_RENDERERERR,"endShape not implemented","endShape()");
-  return MS_FAILURE;
-}
-
-int setClipDummy(imageObj *img, rectObj clipRect)
-{
-  (void)img;
-  (void)clipRect;
-  msSetError(MS_RENDERERERR,"setClip not implemented","setClip()");
-  return MS_FAILURE;
-}
-int resetClipDummy(imageObj *img)
-{
-  (void)img;
-  msSetError(MS_RENDERERERR,"resetClip not implemented","resetClip()");
-  return MS_FAILURE;
-}
-
-int freeImageDummy(imageObj *image)
-{
-  (void)image;
-  msSetError(MS_RENDERERERR,"freeImage not implemented","freeImage()");
-  return MS_FAILURE;
-}
-
-int freeTileDummy(imageObj *tile)
-{
-  (void)tile;
-  msSetError(MS_RENDERERERR,"freeTile not implemented","freeTile()");
-  return MS_FAILURE;
-}
-
-int freeSymbolDummy(symbolObj *symbol)
-{
-  (void)symbol;
-  msSetError(MS_RENDERERERR,"freeSymbol not implemented","freeSymbol()");
-  return MS_FAILURE;
-}
-
-int cleanupDummy(void *renderer_data)
-{
-  (void)renderer_data;
-  return MS_SUCCESS;
-}
-
-int msInitializeDummyRenderer(rendererVTableObj *renderer)
-{
-
-  renderer->use_imagecache = 0;
-  renderer->supports_pixel_buffer = 0;
-  renderer->compositeRasterBuffer = NULL;
-  renderer->supports_clipping = 0;
-  renderer->supports_svg = 0;
-  renderer->renderer_data = NULL;
-  renderer->transform_mode = MS_TRANSFORM_SIMPLIFY;
-  renderer->startLayer = &startLayerDummy;
-  renderer->endLayer = &endLayerDummy;
-  renderer->renderLine=&renderLineDummy;
-  renderer->renderLineTiled = NULL;
-  renderer->createImage=&createImageDummy;
-  renderer->saveImage=&saveImageDummy;
-  renderer->getRasterBufferHandle=&getRasterBufferHandleDummy;
-  renderer->getRasterBufferCopy=getRasterBufferCopyDummy;
-  renderer->initializeRasterBuffer=initializeRasterBufferDummy;
-  renderer->renderPolygon=&renderPolygonDummy;
-  renderer->freeImage=&freeImageDummy;
-  renderer->renderEllipseSymbol = &renderEllipseSymbolDummy;
-  renderer->renderVectorSymbol = &renderVectorSymbolDummy;
-  renderer->renderPixmapSymbol = &renderPixmapSymbolDummy;
-  renderer->mergeRasterBuffer = &mergeRasterBufferDummy;
-  renderer->renderTile = &renderTileDummy;
-  renderer->renderPolygonTiled = &renderPolygonTiledDummy;
-  renderer->freeSymbol = &freeSymbolDummy;
-  renderer->cleanup = &cleanupDummy;
-  renderer->startShape = NULL;
-  renderer->endShape = NULL;
-  renderer->renderGlyphs = NULL;
-  return MS_SUCCESS;
-}
-
-
diff -pruN 8.0.1-5/mapentities.h 8.2.0~beta1-1~exp1/mapentities.h
--- 8.0.1-5/mapentities.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapentities.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,307 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  HTML entity to unicode lookup table
- * Author:   Thomas Bonfort
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/*
- * Generated file
- *
- * This file was generated from:
- *       http://www.w3.org/TR/REC-html40/sgml/entities.html
- * by means of the libgd script:
- *       entities.tcl
- * and modified to avoid namespace collisions
- */
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-  static const struct mapentities_s {
-    const char  *name;
-    int value;
-  } mapentities[] = {
-    {"AElig", 198},
-    {"Aacute", 193},
-    {"Acirc", 194},
-    {"Agrave", 192},
-    {"Alpha", 913},
-    {"Aring", 197},
-    {"Atilde", 195},
-    {"Auml", 196},
-    {"Beta", 914},
-    {"Ccedil", 199},
-    {"Chi", 935},
-    {"Dagger", 8225},
-    {"Delta", 916},
-    {"ETH", 208},
-    {"Eacute", 201},
-    {"Ecirc", 202},
-    {"Egrave", 200},
-    {"Epsilon", 917},
-    {"Eta", 919},
-    {"Euml", 203},
-    {"Gamma", 915},
-    {"Iacute", 205},
-    {"Icirc", 206},
-    {"Igrave", 204},
-    {"Iota", 921},
-    {"Iuml", 207},
-    {"Kappa", 922},
-    {"Lambda", 923},
-    {"Mu", 924},
-    {"Ntilde", 209},
-    {"Nu", 925},
-    {"OElig", 338},
-    {"Oacute", 211},
-    {"Ocirc", 212},
-    {"Ograve", 210},
-    {"Omega", 937},
-    {"Omicron", 927},
-    {"Oslash", 216},
-    {"Otilde", 213},
-    {"Ouml", 214},
-    {"Phi", 934},
-    {"Pi", 928},
-    {"Prime", 8243},
-    {"Psi", 936},
-    {"Rho", 929},
-    {"Scaron", 352},
-    {"Sigma", 931},
-    {"THORN", 222},
-    {"Tau", 932},
-    {"Theta", 920},
-    {"Uacute", 218},
-    {"Ucirc", 219},
-    {"Ugrave", 217},
-    {"Upsilon", 933},
-    {"Uuml", 220},
-    {"Xi", 926},
-    {"Yacute", 221},
-    {"Yuml", 376},
-    {"Zeta", 918},
-    {"aacute", 225},
-    {"acirc", 226},
-    {"acute", 180},
-    {"aelig", 230},
-    {"agrave", 224},
-    {"alefsym", 8501},
-    {"alpha", 945},
-    {"amp", 38},
-    {"and", 8743},
-    {"ang", 8736},
-    {"aring", 229},
-    {"asymp", 8776},
-    {"atilde", 227},
-    {"auml", 228},
-    {"bdquo", 8222},
-    {"beta", 946},
-    {"brvbar", 166},
-    {"bull", 8226},
-    {"cap", 8745},
-    {"ccedil", 231},
-    {"cedil", 184},
-    {"cent", 162},
-    {"chi", 967},
-    {"circ", 710},
-    {"clubs", 9827},
-    {"cong", 8773},
-    {"copy", 169},
-    {"crarr", 8629},
-    {"cup", 8746},
-    {"curren", 164},
-    {"dArr", 8659},
-    {"dagger", 8224},
-    {"darr", 8595},
-    {"deg", 176},
-    {"delta", 948},
-    {"diams", 9830},
-    {"divide", 247},
-    {"eacute", 233},
-    {"ecirc", 234},
-    {"egrave", 232},
-    {"empty", 8709},
-    {"emsp", 8195},
-    {"ensp", 8194},
-    {"epsilon", 949},
-    {"equiv", 8801},
-    {"eta", 951},
-    {"eth", 240},
-    {"euml", 235},
-    {"euro", 8364},
-    {"exist", 8707},
-    {"fnof", 402},
-    {"forall", 8704},
-    {"frac12", 189},
-    {"frac14", 188},
-    {"frac34", 190},
-    {"frasl", 8260},
-    {"gamma", 947},
-    {"ge", 8805},
-    {"gt", 62},
-    {"hArr", 8660},
-    {"harr", 8596},
-    {"hearts", 9829},
-    {"hellip", 8230},
-    {"iacute", 237},
-    {"icirc", 238},
-    {"iexcl", 161},
-    {"igrave", 236},
-    {"image", 8465},
-    {"infin", 8734},
-    {"int", 8747},
-    {"iota", 953},
-    {"iquest", 191},
-    {"isin", 8712},
-    {"iuml", 239},
-    {"kappa", 954},
-    {"lArr", 8656},
-    {"lambda", 955},
-    {"lang", 9001},
-    {"laquo", 171},
-    {"larr", 8592},
-    {"lceil", 8968},
-    {"ldquo", 8220},
-    {"le", 8804},
-    {"lfloor", 8970},
-    {"lowast", 8727},
-    {"loz", 9674},
-    {"lrm", 8206},
-    {"lsaquo", 8249},
-    {"lsquo", 8216},
-    {"lt", 60},
-    {"macr", 175},
-    {"mdash", 8212},
-    {"micro", 181},
-    {"middot", 183},
-    {"minus", 8722},
-    {"mu", 956},
-    {"nabla", 8711},
-    {"nbsp", 160},
-    {"ndash", 8211},
-    {"ne", 8800},
-    {"ni", 8715},
-    {"not", 172},
-    {"notin", 8713},
-    {"nsub", 8836},
-    {"ntilde", 241},
-    {"nu", 957},
-    {"oacute", 243},
-    {"ocirc", 244},
-    {"oelig", 339},
-    {"ograve", 242},
-    {"oline", 8254},
-    {"omega", 969},
-    {"omicron", 959},
-    {"oplus", 8853},
-    {"or", 8744},
-    {"ordf", 170},
-    {"ordm", 186},
-    {"oslash", 248},
-    {"otilde", 245},
-    {"otimes", 8855},
-    {"ouml", 246},
-    {"para", 182},
-    {"part", 8706},
-    {"permil", 8240},
-    {"perp", 8869},
-    {"phi", 966},
-    {"pi", 960},
-    {"piv", 982},
-    {"plusmn", 177},
-    {"pound", 163},
-    {"prime", 8242},
-    {"prod", 8719},
-    {"prop", 8733},
-    {"psi", 968},
-    {"quot", 34},
-    {"rArr", 8658},
-    {"radic", 8730},
-    {"rang", 9002},
-    {"raquo", 187},
-    {"rarr", 8594},
-    {"rceil", 8969},
-    {"rdquo", 8221},
-    {"real", 8476},
-    {"reg", 174},
-    {"rfloor", 8971},
-    {"rho", 961},
-    {"rlm", 8207},
-    {"rsaquo", 8250},
-    {"rsquo", 8217},
-    {"sbquo", 8218},
-    {"scaron", 353},
-    {"sdot", 8901},
-    {"sect", 167},
-    {"shy", 173},
-    {"sigma", 963},
-    {"sigmaf", 962},
-    {"sim", 8764},
-    {"spades", 9824},
-    {"sub", 8834},
-    {"sube", 8838},
-    {"sum", 8721},
-    {"sup", 8835},
-    {"sup1", 185},
-    {"sup2", 178},
-    {"sup3", 179},
-    {"supe", 8839},
-    {"szlig", 223},
-    {"tau", 964},
-    {"there4", 8756},
-    {"theta", 952},
-    {"thetasym", 977},
-    {"thinsp", 8201},
-    {"thorn", 254},
-    {"tilde", 732},
-    {"times", 215},
-    {"trade", 8482},
-    {"uArr", 8657},
-    {"uacute", 250},
-    {"uarr", 8593},
-    {"ucirc", 251},
-    {"ugrave", 249},
-    {"uml", 168},
-    {"upsih", 978},
-    {"upsilon", 965},
-    {"uuml", 252},
-    {"weierp", 8472},
-    {"xi", 958},
-    {"yacute", 253},
-    {"yen", 165},
-    {"yuml", 255},
-    {"zeta", 950},
-    {"zwj", 8205},
-    {"zwnj", 8204},
-  };
-
-#define MAP_ENTITY_NAME_LENGTH_MAX 8
-#define MAP_NR_OF_ENTITIES 252
-
-#ifdef __cplusplus
-}
-#endif
diff -pruN 8.0.1-5/maperror.c 8.2.0~beta1-1~exp1/maperror.c
--- 8.0.1-5/maperror.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maperror.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,653 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of msSetError(), msDebug() and related functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapthread.h"
-#include "maptime.h"
-
-#include <time.h>
-#ifndef _WIN32
-#include <sys/time.h>
-#include <unistd.h>
-#endif
-#include <stdarg.h>
-
-#include "cpl_conv.h"
-
-static char *const ms_errorCodes[MS_NUMERRORCODES] = { "",
-  "Unable to access file.",
-  "Memory allocation error.",
-  "Incorrect data type.",
-  "Symbol definition error.",
-  "Regular expression error.",
-  "TrueType Font error.",
-  "DBASE file error.",
-  "GD library error.",
-  "Unknown identifier.",
-  "Premature End-of-File.",
-  "Projection library error.",
-  "General error message.",
-  "CGI error.",
-  "Web application error.",
-  "Image handling error.",
-  "Hash table error.",
-  "Join error.",
-  "Search returned no results.",
-  "Shapefile error.",
-  "Expression parser error.",
-  "SDE error.",
-  "OGR error.",
-  "Query error.",
-  "WMS server error.",
-  "WMS connection error.",
-  "OracleSpatial error.",
-  "WFS server error.",
-  "WFS connection error.",
-  "WMS Map Context error.",
-  "HTTP request error.",
-  "Child array error.",
-  "WCS server error.",
-  "GEOS library error.",
-  "Invalid rectangle.",
-  "Date/time error.",
-  "GML encoding error.",
-  "SOS server error.",
-  "NULL parent pointer error.",
-  "AGG library error.",
-  "OWS error.",
-  "OpenGL renderer error.",
-  "Renderer error.",
-  "V8 engine error.",
-  "OCG API error."
-};
-
-#ifndef USE_THREAD
-
-// Get the MapServer error object
-errorObj *msGetErrorObj()
-{
-  static errorObj ms_error = {MS_NOERR, "", "", MS_FALSE, 0, NULL};
-  return &ms_error;
-}
-#endif
-
-#ifdef USE_THREAD
-
-typedef struct te_info {
-  struct te_info *next;
-  void *thread_id;
-  errorObj ms_error;
-} te_info_t;
-
-static te_info_t *error_list = NULL;
-
-errorObj *msGetErrorObj()
-{
-  te_info_t *link;
-  void *thread_id;
-  errorObj *ret_obj;
-
-  msAcquireLock( TLOCK_ERROROBJ );
-
-  thread_id = msGetThreadId();
-
-  /* find link for this thread */
-
-  for( link = error_list;
-       link != NULL && link->thread_id != thread_id
-       && link->next != NULL && link->next->thread_id != thread_id;
-       link = link->next ) {}
-
-  /* If the target thread link is already at the head of the list were ok */
-  if( error_list != NULL && error_list->thread_id == thread_id ) {
-  }
-
-  /* We don't have one ... initialize one. */
-  else if( link == NULL || link->next == NULL ) {
-    te_info_t *new_link;
-    errorObj   error_obj = { MS_NOERR, "", "", 0, 0, NULL, 0 };
-
-    new_link = (te_info_t *) malloc(sizeof(te_info_t));
-    new_link->next = error_list;
-    new_link->thread_id = thread_id;
-    new_link->ms_error = error_obj;
-
-    error_list = new_link;
-  }
-
-  /* If the link is not already at the head of the list, promote it */
-  else {
-    te_info_t *target = link->next;
-
-    link->next = link->next->next;
-    target->next = error_list;
-    error_list = target;
-  }
-
-  ret_obj = &(error_list->ms_error);
-
-  msReleaseLock( TLOCK_ERROROBJ );
-
-  return ret_obj;
-}
-#endif
-
-/* msInsertErrorObj()
-**
-** We maintain a chained list of errorObj in which the first errorObj is
-** the most recent (i.e. a stack).  msErrorReset() should be used to clear
-** the list.
-**
-** Note that since some code in MapServer will fetch the head of the list and
-** keep a handle on it for a while, the head of the chained list is static
-** and never changes.
-** A new errorObj is always inserted after the head, and only if the
-** head of the list already contains some information.  i.e. If the static
-** errorObj at the head of the list is empty then it is returned directly,
-** otherwise a new object is inserted after the head and the data that was in
-** the head is moved to the new errorObj, freeing the head errorObj to receive
-** the new error information.
-*/
-static errorObj *msInsertErrorObj(void)
-{
-  errorObj *ms_error;
-  ms_error = msGetErrorObj();
-
-  if (ms_error->code != MS_NOERR && ms_error->totalerrorcount < 100) {
-    /* Head of the list already in use, insert a new errorObj after the head
-     * and move head contents to this new errorObj, freeing the errorObj
-     * for reuse.
-     */
-    errorObj *new_error;
-    new_error = (errorObj *)malloc(sizeof(errorObj));
-
-    /* Note: if malloc() failed then we simply do nothing and the head will
-     * be overwritten by the caller... we cannot produce an error here
-     * since we are already inside a msSetError() call.
-     */
-    if (new_error) {
-      new_error->next = ms_error->next;
-      new_error->code = ms_error->code;
-      new_error->isreported = ms_error->isreported;
-      strlcpy(new_error->routine, ms_error->routine, sizeof(new_error->routine));
-      strlcpy(new_error->message, ms_error->message, sizeof(new_error->message));
-      new_error->errorcount = ms_error->errorcount;
-
-      ms_error->next = new_error;
-      ms_error->code = MS_NOERR;
-      ms_error->isreported = MS_FALSE;
-      ms_error->routine[0] = '\0';
-      ms_error->message[0] = '\0';
-      ms_error->errorcount = 0;
-    }
-    ms_error->totalerrorcount ++;
-  }
-
-  return ms_error;
-}
-
-/* msResetErrorList()
-**
-** Clear the list of error objects.
-*/
-void msResetErrorList()
-{
-  errorObj *ms_error, *this_error;
-  ms_error = msGetErrorObj();
-
-  this_error = ms_error->next;
-  while( this_error != NULL) {
-    errorObj *next_error;
-
-    next_error = this_error->next;
-    msFree(this_error);
-    this_error = next_error;
-  }
-
-  ms_error->next = NULL;
-  ms_error->code = MS_NOERR;
-  ms_error->isreported = MS_FALSE;
-  ms_error->routine[0] = '\0';
-  ms_error->message[0] = '\0';
-  ms_error->errorcount = 0;
-  ms_error->totalerrorcount = 0;
-
-  /* -------------------------------------------------------------------- */
-  /*      Cleanup our entry in the thread list.  This is mainly           */
-  /*      imprortant when msCleanup() calls msResetErrorList().           */
-  /* -------------------------------------------------------------------- */
-#ifdef USE_THREAD
-  {
-    void*  thread_id = msGetThreadId();
-    te_info_t *link;
-
-    msAcquireLock( TLOCK_ERROROBJ );
-
-    /* find link for this thread */
-
-    for( link = error_list;
-         link != NULL && link->thread_id != thread_id
-         && link->next != NULL && link->next->thread_id != thread_id;
-         link = link->next ) {}
-
-    if( link->thread_id == thread_id ) {
-      /* presumably link is at head of list.  */
-      if( error_list == link )
-        error_list = link->next;
-
-      free( link );
-    } else if( link->next != NULL && link->next->thread_id == thread_id ) {
-      te_info_t *next_link = link->next;
-      link->next = link->next->next;
-      free( next_link );
-    }
-    msReleaseLock( TLOCK_ERROROBJ );
-  }
-#endif
-}
-
-char *msGetErrorCodeString(int code)
-{
-
-  if(code<0 || code>MS_NUMERRORCODES-1)
-    return("Invalid error code.");
-
-  return(ms_errorCodes[code]);
-}
-
-/* -------------------------------------------------------------------- */
-/*      Adding the displayable error string to a given string           */
-/*      and reallocates the memory enough to hold the characters.       */
-/*      If source is null returns a newly allocated string              */
-/* -------------------------------------------------------------------- */
-char *msAddErrorDisplayString(char *source, errorObj *error)
-{
-  if((source = msStringConcatenate(source, error->routine)) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, ": ")) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, ms_errorCodes[error->code])) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, " ")) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, error->message)) == NULL) return(NULL);
-  if (error->errorcount > 0) {
-    char* pszTmp;
-    if((source = msStringConcatenate(source, " (message repeated ")) == NULL) return(NULL);
-    pszTmp = msIntToString(error->errorcount);
-    if((source = msStringConcatenate(source, pszTmp)) == NULL) {
-      msFree(pszTmp);
-      return(NULL);
-    }
-    msFree(pszTmp);
-    if((source = msStringConcatenate(source, " times)")) == NULL) return(NULL);
-  }
-
-  return source;
-}
-
-char *msGetErrorString(const char *delimiter)
-{
-  char *errstr=NULL;
-
-  errorObj *error = msGetErrorObj();
-
-  if(!delimiter || !error) return(NULL);
-
-  while(error && error->code != MS_NOERR) {
-    if((errstr = msAddErrorDisplayString(errstr, error)) == NULL) return(NULL);
-
-    if(error->next && error->next->code != MS_NOERR) { /* (peek ahead) more errors, use delimiter */
-      if((errstr = msStringConcatenate(errstr, delimiter)) == NULL) return(NULL);
-    }
-    error = error->next;
-  }
-
-  return(errstr);
-}
-
-void msRedactString(char* str, const char* keyword, const char delimeter)
-{
-
-    char* password = strstr(str, keyword);
-    if (password != NULL) {
-        char* ptr = password + strlen(keyword);
-        while (*ptr != '\0' && *ptr != delimeter) {
-            *ptr = '*';
-            ptr++;
-        }
-    }
-}
-
-void msRedactCredentials(char* str)
-{
-
-  // postgres formats
-  msRedactString(str, "password=", ' ');
-  // mssql use semi-colons as delimeters for parameters
-  msRedactString(str, "password=", ';');
-  // ODBC connections can use pwd rather than password
-  msRedactString(str, "pwd=", ';');
-}
-
-void msSetError(int code, const char *message_fmt, const char *routine, ...)
-{
-  errorObj *ms_error;
-  va_list args;
-  char message[MESSAGELENGTH];
-
-  if(!message_fmt)
-    strcpy(message, "");
-  else {
-    va_start(args, routine);
-    vsnprintf( message, MESSAGELENGTH, message_fmt, args );
-    va_end(args);
-  }
-
-  ms_error = msGetErrorObj();
-
-  /* Insert the error to the list if it is not the same as the previous error*/
-  if (ms_error->code != code || !EQUAL(message, ms_error->message) || 
-                     !EQUAL(routine, ms_error->routine)) {
-      ms_error = msInsertErrorObj();
-      if(!routine)
-        strcpy(ms_error->routine, "");
-      else {
-        strlcpy(ms_error->routine, routine, sizeof(ms_error->routine));
-      }
-      strlcpy(ms_error->message, message, sizeof(ms_error->message));
-      ms_error->code = code;
-      ms_error->errorcount = 0;
-  }
-  else
-      ++ms_error->errorcount;
-
-  msRedactCredentials(ms_error->message);
-
-  /* Log a copy of errors to MS_ERRORFILE if set (handled automatically inside msDebug()) */
-  msDebug("%s: %s %s\n", ms_error->routine, ms_errorCodes[ms_error->code], ms_error->message);
-
-}
-
-void msWriteError(FILE *stream)
-{
-  errorObj *ms_error = msGetErrorObj();
-
-  while (ms_error && ms_error->code != MS_NOERR) {
-    msIO_fprintf(stream, "%s: %s %s <br>\n", ms_error->routine, ms_errorCodes[ms_error->code], ms_error->message);
-    ms_error->isreported = MS_TRUE;
-    ms_error = ms_error->next;
-  }
-}
-
-void msWriteErrorXML(FILE *stream)
-{
-  char *message;
-  errorObj *ms_error = msGetErrorObj();
-
-  while (ms_error && ms_error->code != MS_NOERR) {
-    message = msEncodeHTMLEntities(ms_error->message);
-
-    msIO_fprintf(stream, "%s: %s %s\n", ms_error->routine,
-                 ms_errorCodes[ms_error->code], message);
-    ms_error->isreported = MS_TRUE;
-    ms_error = ms_error->next;
-
-    msFree(message);
-  }
-}
-
-void msWriteErrorImage(mapObj *map, char *filename, int blank)
-{
-  imageObj *img;
-  int width=400, height=300;
-  const int nMargin =5;
-
-  char **papszLines = NULL;
-  pointObj pnt = { 0 };
-  outputFormatObj *format = NULL;
-  char *errormsg = msGetErrorString("; ");
-  errorObj *error = msGetErrorObj();
-  char *imagepath = NULL, *imageurl = NULL;
-  colorObj imagecolor, *imagecolorptr=NULL;
-  textSymbolObj ts;
-  labelObj label;
-  int charWidth = 5, charHeight = 8; /* hardcoded, should be looked up from ft face */
-  if(!errormsg) {
-    errormsg = msStrdup("No error found sorry. This is likely a bug");
-  }
-
-  if (map) {
-    if( map->width > 0 && map->height > 0 ) {
-      width = map->width;
-      height = map->height;
-    }
-    format = map->outputformat;
-    imagepath = map->web.imagepath;
-    imageurl = map->web.imageurl;
-  }
-
-  /* Default to GIF if no suitable GD output format set */
-  if (format == NULL || !MS_RENDERER_PLUGIN(format))
-    format = msCreateDefaultOutputFormat( NULL, "AGG/PNG8", "png", NULL );
-
-  if(!format->transparent) {
-    if(map && MS_VALID_COLOR(map->imagecolor)) {
-      imagecolorptr = &map->imagecolor;
-    } else {
-      MS_INIT_COLOR(imagecolor,255,255,255,255);
-      imagecolorptr = &imagecolor;
-    }
-  }
-
-  img = msImageCreate(width,height,format,imagepath,imageurl,MS_DEFAULT_RESOLUTION,MS_DEFAULT_RESOLUTION,imagecolorptr);
-
-  const int nTextLength = strlen(errormsg);
-  const int nWidthTxt  =  nTextLength * charWidth;
-  const int nUsableWidth = width - (nMargin*2);
-
-  /* Check to see if it all fits on one line. If not, split the text on several lines. */
-  if(!blank) {
-    int nLines;
-    if (nWidthTxt > nUsableWidth) {
-      const int nMaxCharsPerLine =  nUsableWidth/charWidth;
-      nLines = (int) ceil ((double)nTextLength / (double)nMaxCharsPerLine);
-      if (nLines > 0) {
-        papszLines = (char **)malloc(nLines*sizeof(char *));
-        for (int i=0; i<nLines; i++) {
-          papszLines[i] = (char *)malloc((nMaxCharsPerLine+1)*sizeof(char));
-          papszLines[i][0] = '\0';
-        }
-      }
-      for (int i=0; i<nLines; i++) {
-        const int nStart = i*nMaxCharsPerLine;
-        int nEnd = nStart + nMaxCharsPerLine;
-        if (nStart < nTextLength) {
-          if (nEnd > nTextLength)
-            nEnd = nTextLength;
-          const int nLength = nEnd-nStart;
-
-          strncpy(papszLines[i], errormsg+nStart, nLength);
-          papszLines[i][nLength] = '\0';
-        }
-      }
-    } else {
-      nLines = 1;
-      papszLines = (char **)malloc(nLines*sizeof(char *));
-      papszLines[0] = msStrdup(errormsg);
-    }
-    initLabel(&label);
-    MS_INIT_COLOR(label.color,0,0,0,255);
-    MS_INIT_COLOR(label.outlinecolor,255,255,255,255);
-    label.outlinewidth = 1;
-
-    label.size = MS_SMALL;
-    MS_REFCNT_INCR((&label));
-    for (int i=0; i<nLines; i++) {
-      pnt.y = charHeight * ((i*2) +1);
-      pnt.x = charWidth;
-      initTextSymbol(&ts);
-      msPopulateTextSymbolForLabelAndString(&ts,&label,papszLines[i],1,1,0);
-      if(MS_LIKELY(MS_SUCCESS == msComputeTextPath(map,&ts))) {
-        if(MS_SUCCESS!=msDrawTextSymbol(NULL,img,pnt,&ts)) {
-          /* an error occured, but there's nothing much we can do about it here as we are already handling an error condition */
-        }
-        freeTextSymbol(&ts);
-      }
-    }
-    if (papszLines) {
-      free(papszLines);
-    }
-  }
-
-  /* actually write the image */
-  if(!filename) {
-    msIO_setHeader("Content-Type","%s", MS_IMAGE_MIME_TYPE(format));
-    msIO_sendHeaders();
-  }
-  msSaveImage(NULL,img,filename);
-  msFreeImage(img);
-
-  /* the errors are reported */
-  while(error && error->code != MS_NOERR) {
-    error->isreported = MS_TRUE;
-    error = error->next;
-  }
-
-  if (format->refcount == 0)
-    msFreeOutputFormat(format);
-  msFree(errormsg);
-}
-
-char *msGetVersion()
-{
-  static char version[2048];
-
-  sprintf(version, "MapServer version %s", MS_VERSION);
-
-  // add versions of required dependencies
-  static char PROJVersion[20];
-  sprintf(PROJVersion, " PROJ version %d.%d", PROJ_VERSION_MAJOR, PROJ_VERSION_MINOR);
-  strcat(version, PROJVersion);
-
-  static char GDALVersion[20];
-  sprintf(GDALVersion, " GDAL version %d.%d", GDAL_VERSION_MAJOR, GDAL_VERSION_MINOR);
-  strcat(version, GDALVersion);
-
-#if (defined USE_PNG)
-  strcat(version, " OUTPUT=PNG");
-#endif
-#if (defined USE_JPEG)
-  strcat(version, " OUTPUT=JPEG");
-#endif
-#ifdef USE_KML
-  strcat(version, " OUTPUT=KML");
-#endif
-  strcat(version, " SUPPORTS=PROJ");
-  strcat(version, " SUPPORTS=AGG");
-  strcat(version, " SUPPORTS=FREETYPE");
-#ifdef USE_CAIRO
-  strcat(version, " SUPPORTS=CAIRO");
-#endif
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-  strcat(version, " SUPPORTS=SVG_SYMBOLS");
-  #ifdef USE_SVG_CAIRO
-    strcat(version, " SUPPORTS=SVGCAIRO");
-  #else
-    strcat(version, " SUPPORTS=RSVG");
-  #endif
-#endif
-#ifdef USE_OGL
-  strcat(version, " SUPPORTS=OPENGL");
-#endif
-#ifdef USE_ICONV
-  strcat(version, " SUPPORTS=ICONV");
-#endif
-#ifdef USE_EXEMPI
-  strcat(version, " SUPPORTS=XMP");
-#endif
-#ifdef USE_FRIBIDI
-  strcat(version, " SUPPORTS=FRIBIDI");
-#endif
-#ifdef USE_WMS_SVR
-  strcat(version, " SUPPORTS=WMS_SERVER");
-#endif
-#ifdef USE_WMS_LYR
-  strcat(version, " SUPPORTS=WMS_CLIENT");
-#endif
-#ifdef USE_WFS_SVR
-  strcat(version, " SUPPORTS=WFS_SERVER");
-#endif
-#ifdef USE_WFS_LYR
-  strcat(version, " SUPPORTS=WFS_CLIENT");
-#endif
-#ifdef USE_WCS_SVR
-  strcat(version, " SUPPORTS=WCS_SERVER");
-#endif
-#ifdef USE_SOS_SVR
-  strcat(version, " SUPPORTS=SOS_SERVER");
-#endif
-#ifdef USE_OGCAPI_SVR
-  strcat(version, " SUPPORTS=OGCAPI_SERVER");
-#endif
-#ifdef USE_FASTCGI
-  strcat(version, " SUPPORTS=FASTCGI");
-#endif
-#ifdef USE_THREAD
-  strcat(version, " SUPPORTS=THREADS");
-#endif
-#ifdef USE_GEOS
-  strcat(version, " SUPPORTS=GEOS");
-#endif
-#ifdef USE_V8_MAPSCRIPT
-  strcat(version, " SUPPORTS=V8");
-#endif
-#ifdef USE_PBF
-  strcat(version, " SUPPORTS=PBF");
-#endif
-#ifdef USE_JPEG
-  strcat(version, " INPUT=JPEG");
-#endif
-#ifdef USE_SDE
-  strcat(version, " INPUT=SDE");
-#endif
-#ifdef USE_POSTGIS
-  strcat(version, " INPUT=POSTGIS");
-#endif
-#ifdef USE_ORACLESPATIAL
-  strcat(version, " INPUT=ORACLESPATIAL");
-#endif
-  strcat(version, " INPUT=OGR");
-  strcat(version, " INPUT=GDAL");
-  strcat(version, " INPUT=SHAPEFILE");
-  strcat(version, " INPUT=FLATGEOBUF");
-  return(version);
-}
-
-int msGetVersionInt()
-{
-  return MS_VERSION_NUM;
-}
diff -pruN 8.0.1-5/maperror.h 8.2.0~beta1-1~exp1/maperror.h
--- 8.0.1-5/maperror.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maperror.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,214 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Declarations for Error and Debug functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPERROR_H
-#define MAPERROR_H
-
-#include "mapthread.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-  /*====================================================================
-   *   maperror.c
-   *====================================================================*/
-
-#define MS_NOERR 0 /* general error codes */
-#define MS_IOERR 1
-#define MS_MEMERR 2
-#define MS_TYPEERR 3
-#define MS_SYMERR 4
-#define MS_REGEXERR 5
-#define MS_TTFERR 6
-#define MS_DBFERR 7
-#define MS_IDENTERR 9
-#define MS_EOFERR 10
-#define MS_PROJERR 11
-#define MS_MISCERR 12
-#define MS_CGIERR 13
-#define MS_WEBERR 14
-#define MS_IMGERR 15
-#define MS_HASHERR 16
-#define MS_JOINERR 17
-#define MS_NOTFOUND 18 /* empty search results */
-#define MS_SHPERR 19
-#define MS_PARSEERR 20
-#define MS_UNUSEDERR 21
-#define MS_OGRERR 22
-#define MS_QUERYERR 23
-#define MS_WMSERR 24      /* WMS server error */
-#define MS_WMSCONNERR 25  /* WMS connectiontype error */
-#define MS_ORACLESPATIALERR 26
-#define MS_WFSERR 27      /* WFS server error */
-#define MS_WFSCONNERR 28  /* WFS connectiontype error */
-#define MS_MAPCONTEXTERR 29 /* Map Context error */
-#define MS_HTTPERR 30
-#define MS_CHILDERR 31    /* Errors involving arrays of child objects */
-#define MS_WCSERR 32
-#define MS_GEOSERR 33
-#define MS_RECTERR 34
-#define MS_TIMEERR 35
-#define MS_GMLERR 36
-#define MS_SOSERR 37
-#define MS_NULLPARENTERR 38
-#define MS_AGGERR 39
-#define MS_OWSERR 40
-#define MS_OGLERR 41
-#define MS_RENDERERERR 42
-#define MS_V8ERR 43
-#define MS_OGCAPIERR 44
-#define MS_FGBERR 45
-#define MS_NUMERRORCODES 46
-
-#define MESSAGELENGTH 2048
-#define ROUTINELENGTH 64
-
-#define MS_ERROR_LANGUAGE "en-US"
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
-#else
-#define  MS_DLL_EXPORT
-#endif
-
-#ifndef MS_PRINT_FUNC_FORMAT
-#if defined(__GNUC__) && __GNUC__ >= 3 && !defined(DOXYGEN_SKIP)
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )  __attribute__((__format__ (__printf__, format_idx, arg_idx)))
-#else
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )
-#endif
-#endif
-
-/**
-This class allows inspection of the MapServer error stack. 
-Instances of errorObj are created internally by MapServer as errors happen. 
-Errors are managed as a chained list with the first item being the most recent error.
-*/
-  typedef struct errorObj {
-    int code; ///< MapServer error code such as :data:`MS_IMGERR`
-    char routine[ROUTINELENGTH]; ///< MapServer function in which the error was set
-    char message[MESSAGELENGTH]; ///< Context-dependent error message
-    int isreported; ///< :data:`MS_TRUE` or :data:`MS_FALSE` flag indicating if the error has been output
-    int errorcount; ///< Number of subsequent errors
-#ifndef SWIG
-    struct errorObj *next;
-    int totalerrorcount;
-#endif
-  } errorObj;
-
-  /*
-  ** Function prototypes
-  */
-
-  /**
-  Get the MapServer error object
-  */
-  MS_DLL_EXPORT errorObj *msGetErrorObj(void);
-  /**
-  Clear the list of error objects
-  */
-  MS_DLL_EXPORT void msResetErrorList(void);
-  /**
-  Returns a string containing MapServer version information, and details on what optional components 
-  are built in - the same report as produced by ``mapserv -v``
-  */
-  MS_DLL_EXPORT char *msGetVersion(void);
-  /**
-  Returns the MapServer version number (x.y.z) as an integer (x*10000 + y*100 + z) 
-  e.g. V7.4.2 would return 70402
-  */
-  MS_DLL_EXPORT int  msGetVersionInt(void);
-  /**
-  Return a string of all errors
-  */
-  MS_DLL_EXPORT char *msGetErrorString(const char *delimiter);
-
-#ifndef SWIG
-  MS_DLL_EXPORT void msRedactCredentials(char* str);
-  MS_DLL_EXPORT void msSetError(int code, const char *message, const char *routine, ...) MS_PRINT_FUNC_FORMAT(2,4) ;
-  MS_DLL_EXPORT void msWriteError(FILE *stream);
-  MS_DLL_EXPORT void msWriteErrorXML(FILE *stream);
-  MS_DLL_EXPORT char *msGetErrorCodeString(int code);
-  MS_DLL_EXPORT char *msAddErrorDisplayString(char *source, errorObj *error);
-
-  struct mapObj;
-  MS_DLL_EXPORT void msWriteErrorImage(struct mapObj *map, char *filename, int blank);
-
-#endif /* SWIG */
-
-  /*====================================================================
-   *   mapdebug.c (See also MS-RFC-28)
-   *====================================================================*/
-
-  typedef enum { MS_DEBUGLEVEL_ERRORSONLY = 0,  /* DEBUG OFF, log fatal errors */
-                 MS_DEBUGLEVEL_DEBUG      = 1,  /* DEBUG ON */
-                 MS_DEBUGLEVEL_TUNING     = 2,  /* Reports timing info */
-                 MS_DEBUGLEVEL_V          = 3,  /* Verbose */
-                 MS_DEBUGLEVEL_VV         = 4,  /* Very verbose */
-                 MS_DEBUGLEVEL_VVV        = 5,  /* Very very verbose */
-                 MS_DEBUGLEVEL_DEVDEBUG   = 20, /* Undocumented, will trigger debug messages only useful for developers */
-               } debugLevel;
-
-#ifndef SWIG
-
-  typedef enum { MS_DEBUGMODE_OFF,
-                 MS_DEBUGMODE_FILE,
-                 MS_DEBUGMODE_STDERR,
-                 MS_DEBUGMODE_STDOUT,
-                 MS_DEBUGMODE_WINDOWSDEBUG
-               } debugMode;
-
-  typedef struct debug_info_obj {
-    debugLevel  global_debug_level;
-    debugMode   debug_mode;
-    char        *errorfile;
-    FILE        *fp;
-    /* The following 2 members are used only with USE_THREAD (but we won't #ifndef them) */
-    void* thread_id;
-    struct debug_info_obj *next;
-  } debugInfoObj;
-
-
-  MS_DLL_EXPORT void msDebug( const char * pszFormat, ... ) MS_PRINT_FUNC_FORMAT(1,2) ;
-  MS_DLL_EXPORT int msSetErrorFile(const char *pszErrorFile, const char *pszRelToPath);
-  MS_DLL_EXPORT void msCloseErrorFile( void );
-  MS_DLL_EXPORT const char *msGetErrorFile( void );
-  MS_DLL_EXPORT void msSetGlobalDebugLevel(int level);
-  MS_DLL_EXPORT debugLevel msGetGlobalDebugLevel( void );
-  MS_DLL_EXPORT int msDebugInitFromEnv( void );
-  MS_DLL_EXPORT void msDebugCleanup( void );
-
-#endif /* SWIG */
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPERROR_H */
diff -pruN 8.0.1-5/mapfile.c 8.2.0~beta1-1~exp1/mapfile.c
--- 8.0.1-5/mapfile.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapfile.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,6849 +0,0 @@
-/******************************************************************************
- * $id: mapfile.c 7854 2008-08-14 19:22:48Z dmorissette $
- *
- * Project:  MapServer
- * Purpose:  High level Map file parsing code.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef _GNU_SOURCE
-#define _GNU_SOURCE
-#endif
-
-#include <stdarg.h>
-#include <stdbool.h>
-#include <assert.h>
-#include <ctype.h>
-#include <float.h>
-
-#include "mapserver.h"
-#include "mapfile.h"
-#include "mapthread.h"
-#include "maptime.h"
-
-#include "cpl_conv.h"
-
-extern int msyylex(void);
-extern void msyyrestart(FILE *);
-extern int msyylex_destroy(void);
-extern void msyycleanup_includes();
-
-extern double msyynumber;
-extern int msyylineno;
-extern FILE *msyyin;
-
-extern int msyysource;
-extern int msyystate;
-extern char *msyystring;
-extern char *msyybasepath;
-extern int msyyreturncomments;
-extern char *msyystring_buffer;
-extern int msyystring_icase;
-
-extern int loadSymbol(symbolObj *s, char *symbolpath); /* in mapsymbol.c */
-extern void writeSymbol(symbolObj *s, FILE *stream); /* in mapsymbol.c */
-static int loadGrid( layerObj *pLayer );
-static int loadStyle(styleObj *style);
-static void writeStyle(FILE* stream, int indent, styleObj *style);
-static int resolveSymbolNames(mapObj *map);
-static int loadExpression(expressionObj *exp);
-static void writeExpression(FILE *stream, int indent, const char *name, expressionObj *exp);
-
-
-/*
-** Symbol to string static arrays needed for writing map files.
-** Must be kept in sync with enumerations and defines found in mapserver.h.
-*/
-/* static char *msUnits[9]={"INCHES", "FEET", "MILES", "METERS", "KILOMETERS", "DD", "PIXELS", "PERCENTAGES", "NAUTICALMILES"}; */
-/* static char *msLayerTypes[10]={"POINT", "LINE", "POLYGON", "RASTER", "ANNOTATION", "QUERY", "CIRCLE", "TILEINDEX","CHART"}; */
-char *msPositionsText[MS_POSITIONS_LENGTH] = {"UL", "LR", "UR", "LL", "CR", "CL", "UC", "LC", "CC", "AUTO", "XY", "FOLLOW"}; /* msLabelPositions[] also used in mapsymbols.c (not static) */
-/* static char *msBitmapFontSizes[5]={"TINY", "SMALL", "MEDIUM", "LARGE", "GIANT"}; */
-/* static char *msQueryMapStyles[4]={"NORMAL", "HILITE", "SELECTED", "INVERTED"}; */
-/* static char *msStatus[4]={"OFF", "ON", "DEFAULT", "EMBED"}; */
-/* static char *msOnOff[2]={"OFF", "ON"}; */
-/* static char *msTrueFalse[2]={"FALSE", "TRUE"}; */
-/* static char *msYesNo[2]={"NO", "YES"}; */
-/* static char *msJoinType[2]={"ONE-TO-ONE", "ONE-TO-MANY"}; */
-/* static char *msAlignValue[3]={"LEFT","CENTER","RIGHT"}; */
-
-/*
-** Validates a string (value) against a series of patterns. We support up to four to allow cascading from classObj to
-** layerObj to webObj plus a legacy pattern like TEMPLATEPATTERN.
-*/
-int msValidateParameter(const char *value, const char *pattern1, const char *pattern2, const char *pattern3, const char *pattern4)
-{
-  if(msEvalRegex(pattern1, value) == MS_TRUE) return MS_SUCCESS;
-  if(msEvalRegex(pattern2, value) == MS_TRUE) return MS_SUCCESS;
-  if(msEvalRegex(pattern3, value) == MS_TRUE) return MS_SUCCESS;
-  if(msEvalRegex(pattern4, value) == MS_TRUE) return MS_SUCCESS;
-
-  return(MS_FAILURE);
-}
-
-int msIsValidRegex(const char* e) {
-  ms_regex_t re;
-  if(ms_regcomp(&re, e, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {
-    msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msEvalRegex()", e);
-    return(MS_FALSE);
-  }
-  ms_regfree(&re);
-  return MS_TRUE;
-}
-
-int msEvalRegex(const char *e, const char *s)
-{
-  ms_regex_t re;
-
-  if(!e || !s) return(MS_FALSE);
-
-  if(ms_regcomp(&re, e, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {
-    msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msEvalRegex()", e);
-    return(MS_FALSE);
-  }
-
-  if(ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
-    ms_regfree(&re);
-    return(MS_FALSE);
-  }
-  ms_regfree(&re);
-
-  return(MS_TRUE);
-}
-
-int msCaseEvalRegex(const char *e, const char *s)
-{
-  ms_regex_t re;
-
-  if(!e || !s) return(MS_FALSE);
-
-  if(ms_regcomp(&re, e, MS_REG_EXTENDED|MS_REG_ICASE|MS_REG_NOSUB) != 0) {
-    msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msEvalRegex()", e);
-    return(MS_FALSE);
-  }
-
-  if(ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
-    ms_regfree(&re);
-    return(MS_FALSE);
-  }
-  ms_regfree(&re);
-
-  return(MS_TRUE);
-}
-
-#ifdef USE_MSFREE
-void msFree(void *p)
-{
-  if(p) free(p);
-}
-#endif
-
-/*
-** Free memory allocated for a character array
-*/
-void msFreeCharArray(char **array, int num_items)
-{
-  int i;
-  if(!array) return;
-  for(i=0; i<num_items; i++)
-    msFree(array[i]);
-  msFree(array);
-}
-
-/*
-** Checks symbol from lexer against variable length list of
-** legal symbols.
-*/
-int getSymbol(int n, ...)
-{
-  int symbol;
-  va_list argp;
-  int i=0;
-
-  symbol = msyylex();
-
-  va_start(argp, n);
-  while(i<n) { /* check each symbol in the list */
-    if(symbol == va_arg(argp, int)) {
-      va_end(argp);
-      return(symbol);
-    }
-    i++;
-  }
-
-  va_end(argp);
-
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getSymbol()", msyystring_buffer, msyylineno);
-  return(-1);
-}
-
-/*
-** Same as getSymbol, except no error message is set on failure
-*/
-int getSymbol2(int n, ...)
-{
-  int symbol;
-  va_list argp;
-  int i=0;
-
-  symbol = msyylex();
-
-  va_start(argp, n);
-  while(i<n) { /* check each symbol in the list */
-    if(symbol == va_arg(argp, int)) {
-      va_end(argp);
-      return(symbol);
-    }
-    i++;
-  }
-
-  va_end(argp);
-  return(-1);
-}
-
-/*
-** Get a string or symbol as a string.   Operates like getString(), but also
-** supports symbols.
-*/
-static char *getToken(void)
-{
-  msyylex();
-  return msStrdup(msyystring_buffer);
-}
-
-/*
-** Load a string from the map file. A "string" is defined in lexer.l.
-*/
-int getString(char **s)
-{
-  /* if (*s)
-    msSetError(MS_SYMERR, "Duplicate item (%s):(line %d)", "getString()", msyystring_buffer, msyylineno);
-    return(MS_FAILURE);
-  } else */
-  if(msyylex() == MS_STRING) {
-    if(*s) free(*s); /* avoid leak */
-    *s = msStrdup(msyystring_buffer);
-    return(MS_SUCCESS);
-  }
-
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getString()", msyystring_buffer, msyylineno);
-  return(MS_FAILURE);
-}
-
-int msCheckNumber(double number, int num_check_type, double value1, double value2)
-{
-  if(num_check_type == MS_NUM_CHECK_NONE) {
-    return MS_SUCCESS;
-  } else if(num_check_type == MS_NUM_CHECK_RANGE && number >= value1 && number <= value2) {
-    return MS_SUCCESS;
-  } else if(num_check_type == MS_NUM_CHECK_GT && number > value1) {
-    return MS_SUCCESS;
-  } else if(num_check_type == MS_NUM_CHECK_GTE && number >= value1) {
-    return MS_SUCCESS;
-  }
-
-  return MS_FAILURE;
-}
-
-/*
-** Load a floating point number from the map file. (see lexer.l)
-*/
-int getDouble(double *d, int num_check_type, double value1, double value2)
-{
-  if(msyylex() == MS_NUMBER) {
-    if(msCheckNumber(msyynumber, num_check_type, value1, value2) == MS_SUCCESS) {
-      *d = msyynumber;
-      return(0);
-    }
-  }
-
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getDouble()", msyystring_buffer, msyylineno);
-  return(-1);
-}
-
-/*
-** Load a integer from the map file. (see lexer.l)
-*/
-int getInteger(int *i, int num_check_type, int value1, int value2)
-{
-  if(msyylex() == MS_NUMBER) {
-    if(msCheckNumber(msyynumber, num_check_type, value1, value2) == MS_SUCCESS) {
-      *i = (int)msyynumber;
-      return(0);
-    }
-  }
-
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getInteger()", msyystring_buffer, msyylineno);
-  return(-1);
-}
-
-int getCharacter(char *c)
-{
-  if(msyylex() == MS_STRING) {
-    *c = msyystring_buffer[0];
-    return(0);
-  }
-
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getCharacter()", msyystring_buffer, msyylineno);
-  return(-1);
-}
-
-/*
-** Try to load as an integer, then try as a named symbol.
-** Part of work on bug 490.
-*/
-int getIntegerOrSymbol(int *i, int n, ...)
-{
-  int symbol;
-  va_list argp;
-  int j=0;
-
-  symbol = msyylex();
-
-  if (symbol == MS_NUMBER) {
-    *i = (int)msyynumber;
-    return MS_SUCCESS; /* success */
-  }
-
-  va_start(argp, n);
-  while (j<n) { /* check each symbol in the list */
-    if(symbol == va_arg(argp, int)) {
-      va_end(argp);
-      *i = symbol;
-      return MS_SUCCESS;
-    }
-    j++;
-  }
-  va_end(argp);
-
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)",
-             "getIntegerOrSymbol()", msyystring_buffer, msyylineno);
-  return(-1);
-}
-
-
-/*
-** msBuildPluginLibraryPath
-**
-** This function builds a path to be used dynamically to load plugin library.
-*/
-int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map)
-{
-  char szLibPath[MS_MAXPATHLEN] = { '\0' };
-  char szLibPathExt[MS_MAXPATHLEN] = { '\0' };
-  const char *plugin_dir = NULL;
-
-  if (map)
-    plugin_dir = msLookupHashTable(&(map->configoptions), "MS_PLUGIN_DIR");
-
-  /* do nothing on windows, filename without .dll will be loaded by default*/
-#if !defined(_WIN32)
-  if (lib_str) {
-    size_t len = strlen(lib_str);
-    if (3 < len && strcmp(lib_str + len-3, ".so")) {
-      strlcpy(szLibPathExt, lib_str, MS_MAXPATHLEN);
-      strlcat(szLibPathExt, ".so", MS_MAXPATHLEN);
-      lib_str = szLibPathExt;
-    }
-  }
-#endif /* !defined(_WIN32) */
-  if (NULL == msBuildPath(szLibPath, plugin_dir, lib_str)) {
-    return MS_FAILURE;
-  }
-  msFree(*dest);
-  *dest = msStrdup(szLibPath);
-
-  return MS_SUCCESS;
-}
-
-/*
-** Returns the index of specified symbol or -1 if not found.
-**
-** If try_addimage_if_notfound==MS_TRUE then msAddImageSymbol() will be called
-** to try to allocate the symbol as an image symbol.
-*/
-int msGetSymbolIndex(symbolSetObj *symbols, char *name, int try_addimage_if_notfound)
-{
-  int i;
-
-  if(!symbols || !name) return(-1);
-
-  /* symbol 0 has no name */
-  for(i=1; i<symbols->numsymbols; i++) {
-    if(symbols->symbol[i]->name)
-      if(strcasecmp(symbols->symbol[i]->name, name) == 0) return(i);
-  }
-
-  if (try_addimage_if_notfound)
-    return(msAddImageSymbol(symbols, name)); /* make sure it's not a filename */
-
-  return(-1);
-}
-
-/*
-** Return the index number for a given layer based on its name.
-*/
-int msGetLayerIndex(mapObj *map, const char *name)
-{
-  int i;
-
-  if(!name) return(-1);
-
-  for(i=0; i<map->numlayers; i++) {
-    if(!GET_LAYER(map, i)->name) /* skip it */
-      continue;
-    if(strcmp(name, GET_LAYER(map, i)->name) == 0)
-      return(i);
-  }
-  return(-1);
-}
-
-int loadColor(colorObj *color, attributeBindingObj *binding)
-{
-  int symbol;
-  char hex[2];
-
-  /*
-  ** Note that negative color values can be used to suppress or change behavior. For example, referenceObj uses 
-  ** a negative color component to suppress rectangle fills.
-  */
-
-  if(binding) {
-    if((symbol = getSymbol(3, MS_NUMBER, MS_BINDING, MS_STRING)) == -1) return MS_FAILURE;
-  } else {
-    if((symbol = getSymbol(2, MS_NUMBER, MS_STRING)) == -1) return MS_FAILURE;
-  }
-
-  color->alpha=255;
-  if(symbol == MS_NUMBER) {
-    if(msyynumber >= -255 && msyynumber <= 255) {
-      color->red = (int) msyynumber;
-    } else {
-      return MS_FAILURE;
-    }
-    if(getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1) return MS_FAILURE;
-    if(getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1) return MS_FAILURE;
-  } else if(symbol == MS_STRING) {
-    int len = strlen(msyystring_buffer);
-    if(msyystring_buffer[0] == '#' && (len == 7 || len == 9)) { /* got a hex color w/optional alpha */
-      hex[0] = msyystring_buffer[1];
-      hex[1] = msyystring_buffer[2];
-      color->red = msHexToInt(hex);
-      hex[0] = msyystring_buffer[3];
-      hex[1] = msyystring_buffer[4];
-      color->green = msHexToInt(hex);
-      hex[0] = msyystring_buffer[5];
-      hex[1] = msyystring_buffer[6];
-      color->blue = msHexToInt(hex);
-      if(len == 9) {
-        hex[0] = msyystring_buffer[7];
-        hex[1] = msyystring_buffer[8];
-        color->alpha = msHexToInt(hex);
-      }
-    } else {
-      /* TODO: consider named colors here */
-      msSetError(MS_SYMERR, "Invalid hex color (%s):(line %d)", "loadColor()", msyystring_buffer, msyylineno);
-      return MS_FAILURE;
-    }
-  } else {
-    assert(binding);
-    msFree(binding->item);
-    binding->item = msStrdup(msyystring_buffer);
-    binding->index = -1;
-  }
-
-  return MS_SUCCESS;
-}
-
-#if ALPHACOLOR_ENABLED
-int loadColorWithAlpha(colorObj *color)
-{
-  char hex[2];
-
-
-  /*
-  ** Note that negative color values can be used to suppress or change behavior. For example, referenceObj uses 
-  ** a negative color component to suppress rectangle fills.
-  */
-
-  if(getInteger(&(color->red), MS_NUM_CHECK_RANGE, -255, 255) == -1) {
-    if(msyystring_buffer[0] == '#' && strlen(msyystring_buffer) == 7) { /* got a hex color */
-      hex[0] = msyystring_buffer[1];
-      hex[1] = msyystring_buffer[2];
-      color->red = msHexToInt(hex);
-      hex[0] = msyystring_buffer[3];
-      hex[1] = msyystring_buffer[4];
-      color->green = msHexToInt(hex);
-      hex[0] = msyystring_buffer[5];
-      hex[1] = msyystring_buffer[6];
-      color->blue = msHexToInt(hex);
-      color->alpha = 0;
-
-      return(MS_SUCCESS);
-    } else if(msyystring_buffer[0] == '#' && strlen(msyystring_buffer) == 9) { /* got a hex color with alpha */
-      hex[0] = msyystring_buffer[1];
-      hex[1] = msyystring_buffer[2];
-      color->red = msHexToInt(hex);
-      hex[0] = msyystring_buffer[3];
-      hex[1] = msyystring_buffer[4];
-      color->green = msHexToInt(hex);
-      hex[0] = msyystring_buffer[5];
-      hex[1] = msyystring_buffer[6];
-      color->blue = msHexToInt(hex);
-      hex[0] = msyystring_buffer[7];
-      hex[1] = msyystring_buffer[8];
-      color->alpha = msHexToInt(hex);
-      return(MS_SUCCESS);
-    }
-    return(MS_FAILURE);
-  }
-  if(getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1) return(MS_FAILURE);
-  if(getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1) return(MS_FAILURE);
-  if(getInteger(&(color->alpha), MS_NUM_CHECK_RANGE, 0, 255) == -1) return(MS_FAILURE);
-
-  return(MS_SUCCESS);
-}
-#endif
-
-/*
-** Helper functions for writing mapfiles.
-*/
-static void writeLineFeed(FILE *stream)
-{
-  msIO_fprintf(stream, "\n");
-}
-
-static void writeIndent(FILE *stream, int indent)
-{
-  const char *str="  "; /* change this string to define the indent */
-  int i;
-  for(i=0; i<indent; i++) msIO_fprintf(stream, "%s", str);
-}
-
-static void writeBlockBegin(FILE *stream, int indent, const char *name)
-{
-  writeIndent(stream, indent);
-  msIO_fprintf(stream, "%s\n", name);
-}
-
-static void writeBlockEnd(FILE *stream, int indent, const char *name)
-{
-  writeIndent(stream, indent);
-  msIO_fprintf(stream, "END # %s\n", name);
-}
-
-static void writeKeyword(FILE *stream, int indent, const char *name, int value, int size, ...)
-{
-  va_list argp;
-  int i, j=0;
-  const char *s;
-
-  va_start(argp, size);
-  while (j<size) { /* check each value/keyword mapping in the list, values with no match are ignored */
-    i = va_arg(argp, int);
-    s = va_arg(argp, const char *);
-    if(value == i) {
-      writeIndent(stream, ++indent);
-      msIO_fprintf(stream, "%s %s\n", name, s);
-      va_end(argp);
-      return;
-    }
-    j++;
-  }
-  va_end(argp);
-}
-
-static void writeDimension(FILE *stream, int indent, const char *name, double x, double y, char *bind_x, char *bind_y)
-{
-  writeIndent(stream, ++indent);
-  if(bind_x) msIO_fprintf(stream, "%s [%s] ", name, bind_x);
-  else msIO_fprintf(stream, "%s %.15g ", name, x);
-  if(bind_y) msIO_fprintf(stream, "[%s]\n", bind_y);
-  else msIO_fprintf(stream, "%.15g\n", y);
-}
-
-static void writeDoubleRange(FILE *stream, int indent, const char *name, double x, double y)
-{
-  writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s %f %f\n", name, x, y);
-}
-
-static void writeExtent(FILE *stream, int indent, const char *name, rectObj extent)
-{
-  if(!MS_VALID_EXTENT(extent)) return;
-  writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s %.15g %.15g %.15g %.15g\n", name, extent.minx, extent.miny, extent.maxx, extent.maxy);
-}
-
-static void writeNumber(FILE *stream, int indent, const char *name, double defaultNumber, double number)
-{
-  if(number == defaultNumber) return; /* don't output default */
-  writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s %.15g\n", name, number);
-}
-
-static void writeCharacter(FILE *stream, int indent, const char *name, const char defaultCharacter, char character)
-{
-  if(defaultCharacter == character) return;
-  writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s '%c'\n", name, character);
-}
-
-static void writeStringElement(FILE *stream, char *string)
-{
-    char *string_escaped;
-
-    if(strchr(string,'\\')) {
-      string_escaped = msStrdup(string);
-      string_escaped = msReplaceSubstring(string_escaped,"\\","\\\\");
-    } else {
-      string_escaped = string;
-    }
-    if ( (strchr(string_escaped, '\'') == NULL) && (strchr(string_escaped, '\"') == NULL))
-      msIO_fprintf(stream, "\"%s\"", string_escaped);
-    else if ( (strchr(string_escaped, '\"') != NULL) && (strchr(string_escaped, '\'') == NULL))
-      msIO_fprintf(stream, "'%s'", string_escaped);
-    else if ( (strchr(string_escaped, '\'') != NULL) && (strchr(string_escaped, '\"') == NULL))
-      msIO_fprintf(stream, "\"%s\"", string_escaped);
-    else {
-      char *string_tmp = msStringEscape(string_escaped);
-      msIO_fprintf(stream, "\"%s\"", string_tmp);
-      if(string_escaped!=string_tmp) free(string_tmp);
-    }
-    if(string_escaped!=string) free(string_escaped);
-}
-
-static void writeString(FILE *stream, int indent, const char *name, const char *defaultString, char *string)
-{
-  if(!string) return;
-  if(defaultString && strcmp(string, defaultString) == 0) return;
-  writeIndent(stream, ++indent);
-  if(name) msIO_fprintf(stream, "%s ", name);
-  writeStringElement(stream, string);
-  writeLineFeed(stream);
-}
-
-static void writeNumberOrString(FILE *stream, int indent, const char *name, double defaultNumber, double number, char *string)
-{
-  if(string)
-    writeString(stream, indent, name, NULL, string);
-  else
-    writeNumber(stream, indent, name, defaultNumber, number);
-}
-
-static void writeNumberOrKeyword(FILE *stream, int indent, const char *name, double defaultNumber, double number, int value, int size, ...)
-{
-  va_list argp;
-  int i, j=0;
-  const char *s;
-
-  va_start(argp, size);
-  while (j<size) { /* check each value/keyword mapping in the list */
-    i = va_arg(argp, int);
-    s = va_arg(argp, const char *);
-    if(value == i) {
-      writeIndent(stream, ++indent);
-      msIO_fprintf(stream, "%s %s\n", name, s);
-      va_end(argp);
-      return;
-    }
-    j++;
-  }
-  va_end(argp);
-
-  writeNumber(stream, indent, name, defaultNumber, number);
-}
-
-static void writeNameValuePair(FILE *stream, int indent, const char *name, const char *value)
-{
-  if(!name || !value) return;
-  writeIndent(stream, ++indent);
-
-  writeStringElement(stream, (char*)name);
-  msIO_fprintf(stream,"\t");
-  writeStringElement(stream, (char*)value);
-  writeLineFeed(stream);
-}
-
-static void writeAttributeBinding(FILE *stream, int indent, const char *name, attributeBindingObj *binding)
-{
-  if(!binding || !binding->item) return;
-  writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s [%s]\n", name, binding->item);
-}
-
-static void writeColor(FILE *stream, int indent, const char *name, colorObj *defaultColor, colorObj *color)
-{
-  if (!defaultColor && !MS_VALID_COLOR(*color)) return;
-  else if(defaultColor && MS_COMPARE_COLOR(*defaultColor, *color)) return; /* if defaultColor has the same value than the color, return.*/
-
-  writeIndent(stream, ++indent);
-#if ALPHACOLOR_ENABLED
-  msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green, color->blue, color->alpha);
-#else
-  if(color->alpha != 255) {
-    char buffer[9];
-    sprintf(buffer, "%02x", color->red);
-    sprintf(buffer+2, "%02x", color->green);
-    sprintf(buffer+4, "%02x", color->blue);
-    sprintf(buffer+6, "%02x", color->alpha);
-    *(buffer+8) = 0;
-    msIO_fprintf(stream, "%s \"#%s\"\n", name, buffer);
-  } else {
-    msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green, color->blue);
-  }
-#endif
-}
-
-/* todo: deal with alpha's... */
-static void writeColorRange(FILE *stream, int indent, const char *name, colorObj *mincolor, colorObj *maxcolor)
-{
-  if(!MS_VALID_COLOR(*mincolor) || !MS_VALID_COLOR(*maxcolor)) return;
-  writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s %d %d %d  %d %d %d\n", name, mincolor->red, mincolor->green, mincolor->blue, maxcolor->red, maxcolor->green, maxcolor->blue);
-}
-
-/*
-** Initialize, load and free a single join
-*/
-void initJoin(joinObj *join)
-{
-  join->numitems = 0;
-
-  join->name = NULL; /* unique join name, used for variable substitution */
-
-  join->items = NULL; /* array to hold item names for the joined table */
-  join->values = NULL; /* arrays of strings to holds one record worth of data */
-
-  join->table = NULL;
-
-  join->joininfo = NULL;
-
-  join->from = NULL; /* join items */
-  join->to = NULL;
-
-  join->header = NULL;
-  join->template = NULL; /* only html type templates are supported */
-  join->footer = NULL;
-
-  join->type = MS_JOIN_ONE_TO_ONE;
-
-  join->connection = NULL;
-  join->connectiontype = MS_DB_XBASE;
-}
-
-void freeJoin(joinObj *join)
-{
-  msFree(join->name);
-  msFree(join->table);
-  msFree(join->from);
-  msFree(join->to);
-
-  msFree(join->header);
-  msFree(join->template);
-  msFree(join->footer);
-
-  msFreeCharArray(join->items, join->numitems); /* these may have been free'd elsewhere */
-  msFreeCharArray(join->values, join->numitems);
-  join->numitems = 0;
-
-  msJoinClose(join);
-  msFree(join->connection);
-}
-
-int loadJoin(joinObj *join)
-{
-  int nTmp;
-  initJoin(join);
-
-  for(;;) {
-    switch(msyylex()) {
-      case(CONNECTION):
-        if(getString(&join->connection) == MS_FAILURE) return(-1);
-        break;
-      case(CONNECTIONTYPE):
-        if((nTmp = getSymbol(5, MS_DB_XBASE, MS_DB_MYSQL, MS_DB_ORACLE, MS_DB_POSTGRES, MS_DB_CSV)) == -1) return(-1);
-        join->connectiontype = nTmp;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadJoin()");
-        return(-1);
-      case(END):
-        if((join->from == NULL) || (join->to == NULL) || (join->table == NULL)) {
-          msSetError(MS_EOFERR, "Join must define table, name, from and to properties.", "loadJoin()");
-          return(-1);
-        }
-        if((join->type == MS_MULTIPLE) && ((join->template == NULL) || (join->name == NULL))) {
-          msSetError(MS_EOFERR, "One-to-many joins must define template and name properties.", "loadJoin()");
-          return(-1);
-        }
-        return(0);
-      case(FOOTER):
-        if(getString(&join->footer) == MS_FAILURE) return(-1);
-        break;
-      case(FROM):
-        if(getString(&join->from) == MS_FAILURE) return(-1);
-        break;
-      case(HEADER):
-        if(getString(&join->header) == MS_FAILURE) return(-1);
-        break;
-      case(JOIN):
-        break; /* for string loads */
-      case(NAME):
-        if(getString(&join->name) == MS_FAILURE) return(-1);
-        break;
-      case(TABLE):
-        if(getString(&join->table) == MS_FAILURE) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&join->template) == MS_FAILURE) return(-1);
-        break;
-      case(TO):
-        if(getString(&join->to) == MS_FAILURE) return(-1);
-        break;
-      case(TYPE):
-        if((nTmp = getSymbol(2, MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY)) == -1) return(-1);
-        join->type = nTmp;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadJoin()", msyystring_buffer, msyylineno);
-        return(-1);
-    }
-  } /* next token */
-}
-
-static void writeScaleToken(FILE *stream, int indent, scaleTokenObj *token) {
-  int i;
-  indent++;
-  writeBlockBegin(stream,indent,"SCALETOKEN");
-  writeString(stream, indent, "NAME", NULL, token->name);
-  indent++;
-  writeBlockBegin(stream,indent,"VALUES");
-  for(i=0;i<token->n_entries;i++) {
-    char minscale[32];
-    sprintf(minscale,"%g",token->tokens[i].minscale);
-    writeNameValuePair(stream, indent, minscale, token->tokens[i].value);
-  }
-  writeBlockEnd(stream,indent,"VALUES");
-  indent--;
-  writeBlockEnd(stream,indent,"SCALETOKEN");
-}
-
-static void writeJoin(FILE *stream, int indent, joinObj *join)
-{
-  indent++;
-  writeBlockBegin(stream, indent, "JOIN");
-  writeString(stream, indent, "FOOTER", NULL, join->footer);
-  writeString(stream, indent, "FROM", NULL, join->from);
-  writeString(stream, indent, "HEADER", NULL, join->header);
-  writeString(stream, indent, "NAME", NULL, join->name);
-  writeString(stream, indent, "TABLE", NULL, join->table);
-  writeString(stream, indent, "TEMPLATE", NULL, join->template);
-  writeString(stream, indent, "TO", NULL, join->to);
-  writeKeyword(stream, indent, "CONNECTIONTYPE", join->connectiontype, 3, MS_DB_CSV, "CSV", MS_DB_POSTGRES, "POSTGRESQL", MS_DB_MYSQL, "MYSQL");
-  writeKeyword(stream, indent, "TYPE", join->type, 1, MS_JOIN_ONE_TO_MANY, "ONE-TO-MANY");
-  writeBlockEnd(stream, indent, "JOIN");
-}
-
-/* inserts a feature at the end of the list, can create a new list */
-featureListNodeObjPtr insertFeatureList(featureListNodeObjPtr *list, shapeObj *shape)
-{
-  featureListNodeObjPtr node;
-
-  node = (featureListNodeObjPtr) msSmallMalloc(sizeof(featureListNodeObj));
-
-  msInitShape(&(node->shape));
-  if(msCopyShape(shape, &(node->shape)) == -1) {
-    msFree(node);
-    return(NULL);
-  }
-
-  /* AJS - alans@wunderground.com O(n^2) -> O(n) conversion, keep a pointer to the end */
-
-  /* set the tailifhead to NULL, since it is only set for the head of the list */
-  node->tailifhead = NULL;
-  node->next = NULL;
-
-  /* if we are at the head of the list, we need to set the list to node, before pointing tailifhead somewhere  */
-  if(*list == NULL) {
-    *list=node;
-  } else {
-    if((*list)->tailifhead!=NULL) /* this should never be NULL, but just in case */
-      (*list)->tailifhead->next=node; /* put the node at the end of the list */
-  }
-
-  /* repoint the head of the list to the end  - our new element
-     this causes a loop if we are at the head, be careful not to
-     walk in a loop */
-  (*list)->tailifhead = node;
-
-  return(node); /* a pointer to last object in the list */
-}
-
-void freeFeatureList(featureListNodeObjPtr list)
-{
-  featureListNodeObjPtr listNext = NULL;
-  while (list!=NULL) {
-    listNext = list->next;
-    msFreeShape(&(list->shape));
-    msFree(list);
-    list = listNext;
-  }
-}
-
-/* lineObj = multipointObj */
-static int loadFeaturePoints(lineObj *points)
-{
-  int ret = -1;
-  int buffer_size=0;
-
-  points->point = (pointObj *)malloc(sizeof(pointObj)*MS_FEATUREINITSIZE);
-  MS_CHECK_ALLOC(points->point, sizeof(pointObj)*MS_FEATUREINITSIZE, MS_FAILURE);
-  points->numpoints = 0;
-  buffer_size = MS_FEATUREINITSIZE;
-
-  while( ret < 0 ) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadFeaturePoints()");
-        ret = MS_FAILURE;
-        break;
-      case(END):
-        ret = MS_SUCCESS;
-        break;
-      case(MS_NUMBER):
-        if(points->numpoints == buffer_size) { /* just add it to the end */
-          pointObj* newPoints = (pointObj *) realloc(points->point, sizeof(pointObj)*(buffer_size+MS_FEATUREINCREMENT));
-          if( newPoints == NULL ) {
-            msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", __FUNCTION__,
-                       __FILE__, __LINE__, (unsigned int)(sizeof(pointObj)*(buffer_size+MS_FEATUREINCREMENT)));
-            ret = MS_FAILURE;
-            break;
-          }
-          points->point = newPoints;
-          buffer_size+=MS_FEATUREINCREMENT;
-        }
-
-        points->point[points->numpoints].x = atof(msyystring_buffer);
-        if(getDouble(&(points->point[points->numpoints].y), MS_NUM_CHECK_NONE, -1, -1) == -1) {
-          ret = MS_FAILURE;
-          break;
-        }
-        points->numpoints++;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadFeaturePoints()",  msyystring_buffer, msyylineno );
-        ret = MS_FAILURE;
-        break;
-    }
-  }
-
-  if( ret == MS_FAILURE ) {
-    msFree(points->point); /* clean up */
-    points->point = NULL;
-    points->numpoints = 0;
-  }
-  return ret;
-}
-
-static int loadFeature(layerObj *player, int type)
-{
-  int status=MS_SUCCESS;
-  featureListNodeObjPtr *list = &(player->features);
-  multipointObj points= {0,NULL};
-  shapeObj *shape=NULL;
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  MS_CHECK_ALLOC(shape, sizeof(shapeObj), MS_FAILURE);
-
-  msInitShape(shape);
-  shape->type = type;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadFeature()");
-        msFreeShape(shape); /* clean up */
-        msFree(shape);
-        return(MS_FAILURE);
-      case(END):
-        if(player->features != NULL && player->features->tailifhead != NULL)
-          shape->index = player->features->tailifhead->shape.index + 1;
-        else
-          shape->index = 0;
-        if(insertFeatureList(list, shape) == NULL)
-          status = MS_FAILURE;
-
-        msFreeShape(shape); /* clean up */
-        msFree(shape);
-
-        return(status);
-      case(FEATURE):
-        break; /* for string loads */
-      case(POINTS):
-        if(loadFeaturePoints(&points) == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        status = msAddLine(shape, &points);
-
-        msFree(points.point); /* clean up */
-        points.numpoints = 0;
-
-        if(status == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        break;
-      case(ITEMS): {
-        char *string=NULL;
-        if(getString(&string) == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        if (string) {
-          if(shape->values) msFreeCharArray(shape->values, shape->numvalues);
-          shape->values = msStringSplitComplex(string, ";", &shape->numvalues,MS_ALLOWEMPTYTOKENS);
-          msFree(string); /* clean up */
-        }
-        break;
-      }
-      case(TEXT):
-        if(getString(&shape->text) == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        break;
-      case(WKT): {
-        char *string=NULL;
-
-        /* todo, what do we do with multiple WKT property occurances? */
-
-        msFreeShape(shape);
-        msFree(shape);
-        if(getString(&string) == MS_FAILURE) return(MS_FAILURE);
-
-        if((shape = msShapeFromWKT(string)) == NULL)
-          status = MS_FAILURE;
-
-        msFree(string); /* clean up */
-
-        if(status == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        break;
-      }
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadfeature()", msyystring_buffer, msyylineno);
-        msFreeShape(shape); /* clean up */
-        msFree(shape);
-        return(MS_FAILURE);
-    }
-  } /* next token */
-}
-
-static void writeFeature(FILE *stream, int indent, shapeObj *feature)
-{
-  int i,j;
-
-  indent++;
-  writeBlockBegin(stream, indent, "FEATURE");
-
-  indent++;
-  for(i=0; i<feature->numlines; i++) {
-    writeBlockBegin(stream, indent, "POINTS");
-    for(j=0; j<feature->line[i].numpoints; j++) {
-      writeIndent(stream, indent);
-      msIO_fprintf(stream, "%.15g %.15g\n", feature->line[i].point[j].x, feature->line[i].point[j].y);
-    }
-    writeBlockEnd(stream, indent, "POINTS");
-  }
-  indent--;
-
-  if (feature->numvalues) {
-    writeIndent(stream, indent);
-    msIO_fprintf(stream, "ITEMS \"");
-    for (i=0; i<feature->numvalues; i++) {
-      if (i == 0)
-        msIO_fprintf(stream, "%s", feature->values[i]);
-      else
-        msIO_fprintf(stream, ";%s", feature->values[i]);
-    }
-    msIO_fprintf(stream, "\"\n");
-  }
-
-  writeString(stream, indent, "TEXT", NULL, feature->text);
-  writeBlockEnd(stream, indent, "FEATURE");
-}
-
-void initGrid( graticuleObj *pGraticule )
-{
-  memset( pGraticule, 0, sizeof( graticuleObj ) );
-}
-
-void freeGrid( graticuleObj *pGraticule )
-{
-  msFree(pGraticule->labelformat);
-  msFree(pGraticule->pboundingpoints);
-  msFree(pGraticule->pboundinglines);
-}
-
-static int loadGrid( layerObj *pLayer )
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadGrid()");
-        return(-1);
-      case(END):
-        return(0);
-      case(GRID):
-        break; /* for string loads */
-      case( LABELFORMAT ):
-        if(getString(&(pLayer->grid->labelformat)) == MS_FAILURE) {
-          if(strcasecmp(msyystring_buffer, "DD") == 0) /* DD triggers a symbol to be returned instead of a string so check for this special case */ {
-            msFree(pLayer->grid->labelformat);
-            pLayer->grid->labelformat = msStrdup("DD");
-          }
-          else
-            return(-1);
-        }
-        break;
-      case( MINARCS ):
-        if(getDouble(&(pLayer->grid->minarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MAXARCS ):
-        if(getDouble(&(pLayer->grid->maxarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MININTERVAL ):
-        if(getDouble(&(pLayer->grid->minincrement), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MAXINTERVAL ):
-        if(getDouble(&(pLayer->grid->maxincrement), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MINSUBDIVIDE ):
-        if(getDouble(&(pLayer->grid->minsubdivides), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MAXSUBDIVIDE ):
-        if(getDouble(&(pLayer->grid->maxsubdivides), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadGrid()", msyystring_buffer, msyylineno);
-        return(-1);
-    }
-  }
-}
-
-static void writeGrid(FILE *stream, int indent, graticuleObj *pGraticule)
-{
-  if(!pGraticule) return;
-
-  indent++;
-  writeBlockBegin(stream, indent, "GRID");
-  writeString(stream, indent, "LABELFORMAT", NULL, pGraticule->labelformat);
-  writeNumber(stream, indent, "MAXARCS", 0, pGraticule->maxarcs);
-  writeNumber(stream, indent, "MAXSUBDIVIDE", 0, pGraticule->maxsubdivides);
-  writeNumber(stream, indent, "MAXINTERVAL", 0, pGraticule->maxincrement);
-  writeNumber(stream, indent, "MINARCS", 0, pGraticule->minarcs);
-  writeNumber(stream, indent, "MININTERVAL", 0, pGraticule->minincrement);
-  writeNumber(stream, indent, "MINSUBDIVIDE", 0, pGraticule->minsubdivides);
-  writeBlockEnd(stream, indent, "GRID");
-}
-
-static int loadProjection(projectionObj *p)
-{
-  p->gt.need_geotransform = MS_FALSE;
-
-  if ( p->proj != NULL || p->numargs != 0 ) {
-    msSetError(MS_MISCERR, "Projection is already initialized. Multiple projection definitions are not allowed in this object. (line %d)",
-               "loadProjection()", msyylineno);
-    return(-1);
-  }
-
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadProjection()");
-        return(-1);
-      case(END):
-        if( p->numargs == 1 && strstr(p->args[0],"+") != NULL ) {
-          char *one_line_def = p->args[0];
-          int result;
-
-          p->args[0] = NULL;
-          p->numargs = 0;
-          result = msLoadProjectionString( p, one_line_def );
-          free( one_line_def );
-          return result;
-        } else {
-          if(p->numargs != 0)
-            return msProcessProjection(p);
-          else
-            return 0;
-        }
-        break;
-      case(MS_STRING):
-      case(MS_AUTO):
-        if( p->numargs == MS_MAXPROJARGS ) {
-            msSetError(MS_MISCERR, "Parsing error near (%s):(line %d): Too many arguments in projection string", "loadProjection()",
-                   msyystring_buffer, msyylineno);
-            return -1;
-        }
-        p->args[p->numargs] = msStrdup(msyystring_buffer);
-        p->automatic = MS_TRUE;
-        p->numargs++;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadProjection()",
-                   msyystring_buffer, msyylineno);
-        return(-1);
-    }
-  } /* next token */
-}
-
-
-/************************************************************************/
-/*                     msLoadProjectionStringEPSGLike                   */
-/************************************************************************/
-
-static int msLoadProjectionStringEPSGLike(projectionObj *p, const char *value,
-                                          const char* pszPrefix,
-                                          int bFollowEPSGAxisOrder)
-{
-    size_t buffer_size = 0;
-    char *init_string =  NULL;
-    const char *code;
-    const char *next_sep;
-    size_t prefix_len;
-
-    prefix_len = strlen(pszPrefix);
-    if( strncasecmp(value, pszPrefix, prefix_len) != 0 )
-        return -1;
-
-    code = value + prefix_len;
-    next_sep = strchr(code, pszPrefix[prefix_len-1]);
-    if( next_sep != NULL )
-        code = next_sep + 1;
-
-    buffer_size = 10 + strlen(code) + 1;
-    init_string = (char*)msSmallMalloc(buffer_size);
-
-    /* translate into PROJ.4 format. */
-    snprintf( init_string, buffer_size, "init=epsg:%s", code );
-
-    p->args = (char**)msSmallMalloc(sizeof(char*) * 2);
-    p->args[0] = init_string;
-    p->numargs = 1;
-
-    if( bFollowEPSGAxisOrder && msIsAxisInverted(atoi(code))) {
-      p->args[1] = msStrdup("+epsgaxis=ne");
-      p->numargs = 2;
-    }
-
-    return 0;
-}
-
-/************************************************************************/
-/*                     msLoadProjectionStringCRSLike                    */
-/************************************************************************/
-
-static int msLoadProjectionStringCRSLike(projectionObj *p, const char *value,
-                                         const char* pszPrefix)
-{
-    char init_string[100];
-    const char *id;
-    const char *next_sep;
-    size_t prefix_len;
-
-    prefix_len = strlen(pszPrefix);
-    if( strncasecmp(value, pszPrefix, prefix_len) != 0 )
-        return -1;
-
-    id = value + prefix_len;
-    next_sep = strchr(id, pszPrefix[prefix_len-1]);
-    if( next_sep != NULL )
-        id = next_sep + 1;
-
-    init_string[0] = '\0';
-
-    if( strcasecmp(id,"84") == 0 || strcasecmp(id,"CRS84") == 0 )
-      strncpy( init_string, "init=epsg:4326", sizeof(init_string) );
-    else if( strcasecmp(id,"83") == 0 || strcasecmp(id,"CRS83") == 0 )
-      strncpy( init_string, "init=epsg:4269", sizeof(init_string) );
-    else if( strcasecmp(id,"27") == 0 || strcasecmp(id,"CRS27") == 0 )
-      strncpy( init_string, "init=epsg:4267", sizeof(init_string) );
-    else {
-      msSetError( MS_PROJERR,
-                  "Unrecognised OGC CRS def '%s'.",
-                  "msLoadProjectionString()",
-                  value );
-      return -1;
-    }
-
-    p->args = (char**)msSmallMalloc(sizeof(char*) * 2);
-    p->args[0] = msStrdup(init_string);
-    p->numargs = 1;
-
-    return 0;
-}
-
-/************************************************************************/
-/*                         msLoadProjectionStringEPSG                   */
-/*                                                                      */
-/*      Checks for EPSG type projection and set the axes for a          */
-/*      certain code ranges.                                            */
-/*      Use for now in WMS 1.3.0 and WFS >= 1.1.0                       */
-/************************************************************************/
-int msLoadProjectionStringEPSG(projectionObj *p, const char *value)
-{
-  assert(p);
-
-  msFreeProjectionExceptContext(p);
-
-  p->gt.need_geotransform = MS_FALSE;
-#ifdef USE_PROJ_FASTPATHS
-  if(strcasestr(value,"epsg:4326")) {
-    p->wellknownprojection = wkp_lonlat;
-  } else if(strcasestr(value,"epsg:3857")) {
-    p->wellknownprojection = wkp_gmerc;
-  } else {
-    p->wellknownprojection = wkp_none;
-  }
-#endif
-
-  if( msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_TRUE) == 0 )
-  {
-    return msProcessProjection( p );
-  }
-
-  return msLoadProjectionString(p, value);
-}
-
-int msLoadProjectionString(projectionObj *p, const char *value)
-{
-  assert(p);
-  p->gt.need_geotransform = MS_FALSE;
-
-  msFreeProjectionExceptContext(p);
-
-  /*
-   * Handle new style definitions, the same as they would be given to
-   * the proj program.
-   * eg.
-   *    "+proj=utm +zone=11 +ellps=WGS84"
-   */
-  if( value[0] == '+' ) {
-    char  *trimmed;
-    int i, i_out=0;
-
-    trimmed = msStrdup(value+1);
-    for( i = 1; value[i] != '\0'; i++ ) {
-      if( !isspace( value[i] ) )
-        trimmed[i_out++] = value[i];
-    }
-    trimmed[i_out] = '\0';
-
-    p->args = msStringSplit(trimmed,'+', &p->numargs);
-    free( trimmed );
-  } else if (strncasecmp(value, "AUTO:", 5) == 0 ||
-             strncasecmp(value, "AUTO2:", 6) == 0) {
-    /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
-    /* WMS 1.3.0 projection: "AUTO2:auto_crs_id,factor,lon0,lat0"*/
-    /* Keep the projection defn into a single token for writeProjection() */
-    /* to work fine. */
-    p->args = (char**)msSmallMalloc(sizeof(char*));
-    p->args[0] = msStrdup(value);
-    p->numargs = 1;
-  } else if (msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_FALSE) == 0 ) {
-   /* Assume lon/lat ordering. Use msLoadProjectionStringEPSG() if wanting to follow EPSG axis */
-  } else if (msLoadProjectionStringEPSGLike(p, value, "urn:ogc:def:crs:EPSG:", MS_TRUE) == 0 ) {
-  } else if (msLoadProjectionStringEPSGLike(p, value, "urn:EPSG:geographicCRS:", MS_TRUE) == 0 ) {
-  } else if (msLoadProjectionStringEPSGLike(p, value, "urn:x-ogc:def:crs:EPSG:", MS_TRUE) == 0 ) {
-    /*this case is to account for OGC CITE tests where x-ogc was used
-      before the ogc name became an official NID. Note also we also account
-      for the fact that a space for the version of the espg is not used with CITE tests.
-      (Syntax used could be urn:ogc:def:objectType:authority:code)*/
-  } else if (msLoadProjectionStringCRSLike(p, value, "urn:ogc:def:crs:OGC:") == 0 ) {
-  } else if (msLoadProjectionStringEPSGLike(p, value, "http://www.opengis.net/def/crs/EPSG/", MS_TRUE) == 0 ) {
-    /* URI projection support */
-  } else if (msLoadProjectionStringCRSLike(p, value, "http://www.opengis.net/def/crs/OGC/") == 0 ) {
-    /* Mandatory support for this URI format specified in WFS1.1 (also in 1.0?) */
-  } else if (msLoadProjectionStringEPSGLike(p, value, "http://www.opengis.net/gml/srs/epsg.xml#", MS_FALSE) == 0 ) {
-    /* We assume always lon/lat ordering, as that is what GeoServer does... */
-  } else if (msLoadProjectionStringCRSLike(p, value, "CRS:") == 0 ) {
-  }
-  /*
-   * Handle old style comma delimited.  eg. "proj=utm,zone=11,ellps=WGS84".
-   */
-  else {
-    p->args = msStringSplit(value,',', &p->numargs);
-  }
-
-  return msProcessProjection( p );
-}
-
-static void writeProjection(FILE *stream, int indent, projectionObj *p)
-{
-  int i;
-
-  if(!p || p->numargs <= 0) return;
-  indent++;
-  writeBlockBegin(stream, indent, "PROJECTION");
-  for(i=0; i<p->numargs; i++)
-    writeString(stream, indent, NULL, NULL, p->args[i]);
-  writeBlockEnd(stream, indent, "PROJECTION");
-}
-
-void initLeader(labelLeaderObj *leader)
-{
-  leader->gridstep = 5;
-  leader->maxdistance = 0;
-
-  /* Set maxstyles = 0, styles[] will be allocated as needed on first call
-   * to msGrowLabelLeaderStyles()
-   */
-  leader->numstyles = leader->maxstyles = 0;
-  leader->styles = NULL;
-}
-
-/*
-** Initialize, load and free a labelObj structure
-*/
-void initLabel(labelObj *label)
-{
-  int i;
-
-  MS_REFCNT_INIT(label);
-
-  label->align = MS_ALIGN_DEFAULT;
-  MS_INIT_COLOR(label->color, 0,0,0,255);
-  MS_INIT_COLOR(label->outlinecolor, -1,-1,-1,255); /* don't use it */
-  label->outlinewidth=1;
-
-  MS_INIT_COLOR(label->shadowcolor, -1,-1,-1,255); /* don't use it */
-  label->shadowsizex = label->shadowsizey = 1;
-
-  label->font = NULL;
-  label->size = MS_MEDIUM;
-
-  label->position = MS_CC;
-  label->angle = 0;
-  label->anglemode = MS_NONE;
-  label->minsize = MS_MINFONTSIZE;
-  label->maxsize = MS_MAXFONTSIZE;
-  label->buffer = 0;
-  label->offsetx = label->offsety = 0;
-  label->minscaledenom=-1;
-  label->maxscaledenom=-1;
-  label->minfeaturesize = -1; /* no limit */
-  label->autominfeaturesize = MS_FALSE;
-  label->mindistance = -1; /* no limit */
-  label->repeatdistance = 0; /* no repeat */
-  label->maxoverlapangle = 22.5; /* default max overlap angle */
-  label->partials = MS_FALSE;
-  label->wrap = '\0';
-  label->maxlength = 0;
-  label->space_size_10=0.0;
-
-  label->encoding = NULL;
-
-  label->force = MS_OFF;
-  label->priority = MS_DEFAULT_LABEL_PRIORITY;
-
-  /* Set maxstyles = 0, styles[] will be allocated as needed on first call
-   * to msGrowLabelStyles()
-   */
-  label->numstyles = label->maxstyles = 0;
-  label->styles = NULL;
-
-  label->numbindings = 0;
-  label->nexprbindings = 0;
-  for(i=0; i<MS_LABEL_BINDING_LENGTH; i++) {
-    label->bindings[i].item = NULL;
-    label->bindings[i].index = -1;
-    msInitExpression(&(label->exprBindings[i]));
-  }
-
-  msInitExpression(&(label->expression));
-  msInitExpression(&(label->text));
-
-  label->leader = NULL;
-
-  label->sizeunits = MS_INHERIT;
-  label->scalefactor = 1.0;
-
-  return;
-}
-
-int freeLabelLeader(labelLeaderObj *leader)
-{
-  int i;
-  for(i=0; i<leader->numstyles; i++) {
-    if(freeStyle(leader->styles[i]) == MS_SUCCESS) {
-      msFree(leader->styles[i]);
-    }
-  }
-  msFree(leader->styles);
-
-  return MS_SUCCESS;
-}
-int freeLabel(labelObj *label)
-{
-  int i;
-
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(label) ) {
-    return MS_FAILURE;
-  }
-
-  msFree(label->font);
-  msFree(label->encoding);
-
-  for(i=0; i<label->numstyles; i++) { /* each style */
-    if(label->styles[i]!=NULL) {
-      if(freeStyle(label->styles[i]) == MS_SUCCESS) {
-        msFree(label->styles[i]);
-      }
-    }
-  }
-  msFree(label->styles);
-
-  for(i=0; i<MS_LABEL_BINDING_LENGTH; i++) {
-    msFree(label->bindings[i].item);
-    msFreeExpression(&(label->exprBindings[i]));
-  }
-
-  msFreeExpression(&(label->expression));
-  msFreeExpression(&(label->text));
-
-  if(label->leader) {
-    freeLabelLeader(label->leader);
-    msFree(label->leader);
-    label->leader = NULL;
-  }
-
-  return MS_SUCCESS;
-}
-
-static int loadLeader(labelLeaderObj *leader)
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(END):
-        return(0);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLeader()");
-        return(-1);
-      case GRIDSTEP:
-        if(getInteger(&(leader->gridstep), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case MAXDISTANCE:
-        if(getInteger(&(leader->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case STYLE:
-        if(msGrowLeaderStyles(leader) == NULL)
-          return(-1);
-        initStyle(leader->styles[leader->numstyles]);
-        if(loadStyle(leader->styles[leader->numstyles]) != MS_SUCCESS)
-        {
-            freeStyle(leader->styles[leader->numstyles]);
-            free(leader->styles[leader->numstyles]);
-            leader->styles[leader->numstyles] = NULL;
-            return -1;
-        }
-        leader->numstyles++;
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLeader()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  }
-}
-
-static int loadLabel(labelObj *label)
-{
-  int symbol;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(ANGLE):
-        if((symbol = getSymbol(5, MS_NUMBER,MS_AUTO,MS_AUTO2,MS_FOLLOW,MS_BINDING)) == -1)
-          return(-1);
-
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid ANGLE, must be between -360 and 360 (line %d)", "loadLabel()", msyylineno);
-            return(MS_FAILURE);
-          }
-          label->angle = (double) msyynumber;
-        } else if(symbol == MS_BINDING) {
-          if (label->bindings[MS_LABEL_BINDING_ANGLE].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_ANGLE].item);
-          label->bindings[MS_LABEL_BINDING_ANGLE].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        } else {
-          label->anglemode = symbol;
-        }
-        break;
-      case(ALIGN):
-        if((symbol = getSymbol(4, MS_ALIGN_LEFT,MS_ALIGN_CENTER,MS_ALIGN_RIGHT,MS_BINDING)) == -1)
-          return(-1);
-        if((symbol == MS_ALIGN_LEFT)||(symbol == MS_ALIGN_CENTER)||(symbol == MS_ALIGN_RIGHT)) {
-          label->align = symbol;
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_ALIGN].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_ALIGN].item);
-          label->bindings[MS_LABEL_BINDING_ALIGN].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(ANTIALIAS): /*ignore*/
-        msyylex();
-        break;
-      case(BUFFER):
-        if(getInteger(&(label->buffer), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        break;
-      case(COLOR):
-        if(loadColor(&(label->color), &(label->bindings[MS_LABEL_BINDING_COLOR])) != MS_SUCCESS) return(-1);
-        if(label->bindings[MS_LABEL_BINDING_COLOR].item) label->numbindings++;
-        break;
-      case(ENCODING):
-        if((getString(&label->encoding)) == MS_FAILURE) return(-1);
-        break;
-      case(END):
-        return(0);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLabel()");
-        return(-1);
-      case(EXPRESSION):
-        if(loadExpression(&(label->expression)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(FONT):
-        if((symbol = getSymbol(2, MS_STRING, MS_BINDING)) == -1)
-          return(-1);
-
-        if(symbol == MS_STRING) {
-          if (label->font != NULL)
-            msFree(label->font);
-          label->font = msStrdup(msyystring_buffer);
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_FONT].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_FONT].item);
-          label->bindings[MS_LABEL_BINDING_FONT].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(FORCE):
-        switch(msyylex()) {
-          case MS_ON:
-            label->force = MS_ON;
-            break;
-          case MS_OFF:
-            label->force = MS_OFF;
-            break;
-          case GROUP:
-            label->force = MS_LABEL_FORCE_GROUP;
-            break;
-          default:
-            msSetError(MS_MISCERR, "Invalid FORCE, must be ON,OFF,or GROUP (line %d)" , "loadLabel()", msyylineno);
-            return(-1);
-        }
-        break;
-      case(LABEL):
-        break; /* for string loads */
-      case(LEADER):
-        msSetError(MS_MISCERR, "LABEL LEADER not implemented. LEADER goes at the CLASS level (line %d)" , "loadLabel()", msyylineno);
-        return(-1);
-      case(MAXSIZE):
-        if(getInteger(&(label->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXSCALEDENOM):
-        if(getDouble(&(label->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MAXLENGTH):
-        if(getInteger(&(label->maxlength), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MINDISTANCE):
-        if(getInteger(&(label->mindistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(REPEATDISTANCE):
-        if(getInteger(&(label->repeatdistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXOVERLAPANGLE):
-        if(getDouble(&(label->maxoverlapangle), MS_NUM_CHECK_RANGE, 0, 360) == -1) return(-1);
-        break;
-      case(MINFEATURESIZE):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_AUTO)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid MINFEATURESIZE, must be greater than 0 (line %d)", "loadLabel()", msyylineno);
-            return(MS_FAILURE);
-          }
-          label->minfeaturesize = (int)msyynumber;
-        } else
-          label->autominfeaturesize = MS_TRUE;
-        break;
-      case(MINSCALEDENOM):
-        if(getDouble(&(label->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MINSIZE):
-        if(getInteger(&(label->minsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(OFFSET):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          label->offsetx = (int) msyynumber; // any integer ok
-        else {
-          if (label->bindings[MS_LABEL_BINDING_OFFSET_X].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_OFFSET_X].item);
-          label->bindings[MS_LABEL_BINDING_OFFSET_X].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          label->offsety = (int) msyynumber; // any integer ok
-        else {
-          if (label->bindings[MS_LABEL_BINDING_OFFSET_Y].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_OFFSET_Y].item);
-          label->bindings[MS_LABEL_BINDING_OFFSET_Y].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(label->outlinecolor), &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR])) != MS_SUCCESS) return(-1);
-        if(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item) label->numbindings++;
-        break;
-      case(OUTLINEWIDTH):
-        if(getInteger(&(label->outlinewidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(PARTIALS):
-        if((label->partials = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(-1);
-        break;
-      case(POSITION):
-        if((label->position = getSymbol(11, MS_UL,MS_UC,MS_UR,MS_CL,MS_CC,MS_CR,MS_LL,MS_LC,MS_LR,MS_AUTO,MS_BINDING)) == -1)
-          return(-1);
-        if(label->position == MS_BINDING) {
-          if(label->bindings[MS_LABEL_BINDING_POSITION].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_POSITION].item);
-          label->bindings[MS_LABEL_BINDING_POSITION].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(PRIORITY):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 1, MS_MAX_LABEL_PRIORITY) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid PRIORITY, must be an integer between 1 and %d (line %d)" , "loadLabel()", MS_MAX_LABEL_PRIORITY, msyylineno);
-            return(-1);
-          }
-          label->priority = (int) msyynumber;
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_PRIORITY].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_PRIORITY].item);
-          label->bindings[MS_LABEL_BINDING_PRIORITY].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(SHADOWCOLOR):
-        if(loadColor(&(label->shadowcolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(SHADOWSIZE):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-          label->shadowsizex = (int) msyynumber; // x offset, any int ok
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item);
-          label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-          label->shadowsizey = (int) msyynumber; // y offset, any int ok
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
-          label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(SIZE):
-        if(label->bindings[MS_LABEL_BINDING_SIZE].item) {
-          msFree(label->bindings[MS_LABEL_BINDING_SIZE].item);
-          label->bindings[MS_LABEL_BINDING_SIZE].item = NULL;
-          label->numbindings--;
-        }
-        if (label->exprBindings[MS_LABEL_BINDING_SIZE].string) {
-          msFreeExpression(&label->exprBindings[MS_LABEL_BINDING_SIZE]);
-          label->nexprbindings--;
-        }
-
-        if((symbol = getSymbol(8, MS_EXPRESSION,MS_NUMBER,MS_BINDING,MS_TINY,MS_SMALL,MS_MEDIUM,MS_LARGE,MS_GIANT)) == -1)
-          return(-1);
-
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid SIZE, must be greater than 0 (line %d)" , "loadLabel()", msyylineno);
-            return(-1);
-          }
-          label->size = (double) msyynumber;
-        } else if(symbol == MS_BINDING) {
-          label->bindings[MS_LABEL_BINDING_SIZE].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        } else if (symbol == MS_EXPRESSION) {
-          msFree(label->exprBindings[MS_LABEL_BINDING_SIZE].string);
-          label->exprBindings[MS_LABEL_BINDING_SIZE].string = msStrdup(msyystring_buffer);
-          label->exprBindings[MS_LABEL_BINDING_SIZE].type = MS_EXPRESSION;
-          label->nexprbindings++;
-        } else
-          label->size = symbol;
-        break;
-      case(STYLE):
-        if(msGrowLabelStyles(label) == NULL)
-          return(-1);
-        initStyle(label->styles[label->numstyles]);
-        if(loadStyle(label->styles[label->numstyles]) != MS_SUCCESS) {
-            freeStyle(label->styles[label->numstyles]);
-            free(label->styles[label->numstyles]);
-            label->styles[label->numstyles] = NULL;
-            return(-1);
-        }
-        if(label->styles[label->numstyles]->_geomtransform.type == MS_GEOMTRANSFORM_NONE)
-          label->styles[label->numstyles]->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT; /* set a default, a marker? */
-        label->numstyles++;
-        break;
-      case(TEXT):
-        if(loadExpression(&(label->text)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        if((label->text.type != MS_STRING) && (label->text.type != MS_EXPRESSION)) {
-          msSetError(MS_MISCERR, "Text expressions support constant or tagged replacement strings." , "loadLabel()");
-          return(-1);
-        }
-        break;
-      case(TYPE):
-        if(getSymbol(2, MS_TRUETYPE,MS_BITMAP) == -1) return(-1); /* ignore TYPE */
-        break;
-      case(WRAP):
-        if(getCharacter(&(label->wrap)) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLabel()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  } /* next token */
-}
-
-int msUpdateLabelFromString(labelObj *label, char *string)
-{
-  if(!label || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadLabel(label) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-static void writeLeader(FILE *stream, int indent, labelLeaderObj *leader)
-{
-  int i;
-  if(leader->maxdistance == 0 && leader->numstyles == 0) {
-    return;
-  }
-  indent++;
-  writeBlockBegin(stream, indent, "LEADER");
-  writeNumber(stream, indent, "MAXDISTANCE", 0, leader->maxdistance);
-  writeNumber(stream, indent, "GRIDSTEP", 5, leader->gridstep);
-  for(i=0; i<leader->numstyles; i++)
-    writeStyle(stream, indent, leader->styles[i]);
-
-  writeBlockEnd(stream, indent, "LEADER");
-}
-
-static void writeLabel(FILE *stream, int indent, labelObj *label)
-{
-  int i;
-  colorObj c;
-
-  if(label->size == -1) return; /* there is no default label anymore */
-
-  indent++;
-  writeBlockBegin(stream, indent, "LABEL");
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_ANGLE].item)
-    writeAttributeBinding(stream, indent, "ANGLE", &(label->bindings[MS_LABEL_BINDING_ANGLE]));
-  else writeNumberOrKeyword(stream, indent, "ANGLE", 0, label->angle, label->anglemode, 3, MS_FOLLOW, "FOLLOW", MS_AUTO, "AUTO", MS_AUTO2, "AUTO2");
-
-  writeExpression(stream, indent, "EXPRESSION", &(label->expression));
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_FONT].item)
-    writeAttributeBinding(stream, indent, "FONT", &(label->bindings[MS_LABEL_BINDING_FONT]));
-  else writeString(stream, indent, "FONT", NULL, label->font);
-
-  writeNumber(stream, indent, "MAXSIZE",  MS_MAXFONTSIZE, label->maxsize);
-  writeNumber(stream, indent, "MINSIZE",  MS_MINFONTSIZE, label->minsize);
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_SIZE].item)
-    writeAttributeBinding(stream, indent, "SIZE", &(label->bindings[MS_LABEL_BINDING_SIZE]));
-  else writeNumber(stream, indent, "SIZE", -1, label->size);
-
-  writeKeyword(stream, indent, "ALIGN", label->align, 3, MS_ALIGN_LEFT, "LEFT", MS_ALIGN_CENTER, "CENTER", MS_ALIGN_RIGHT, "RIGHT");
-  writeNumber(stream, indent, "BUFFER", 0, label->buffer);
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_COLOR].item)
-    writeAttributeBinding(stream, indent, "COLOR", &(label->bindings[MS_LABEL_BINDING_COLOR]));
-  else {
-    MS_INIT_COLOR(c,0,0,0,255);
-    writeColor(stream, indent, "COLOR", &c, &(label->color));
-  }
-
-  writeString(stream, indent, "ENCODING", NULL, label->encoding);
-  if(label->leader)
-    writeLeader(stream,indent,label->leader);
-  writeKeyword(stream, indent, "FORCE", label->force, 2, MS_TRUE, "TRUE", MS_LABEL_FORCE_GROUP, "GROUP");
-  writeNumber(stream, indent, "MAXLENGTH", 0, label->maxlength);
-  writeNumber(stream, indent, "MAXSCALEDENOM", -1, label->maxscaledenom);
-  writeNumber(stream, indent, "MINDISTANCE", -1, label->mindistance);
-  writeNumberOrKeyword(stream, indent, "MINFEATURESIZE", -1, label->minfeaturesize, 1, label->autominfeaturesize, MS_TRUE, "AUTO");
-  writeNumber(stream, indent, "MINSCALEDENOM", -1, label->minscaledenom);
-  writeDimension(stream, indent, "OFFSET",  label->offsetx, label->offsety, NULL, NULL);
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item)
-    writeAttributeBinding(stream, indent, "OUTLINECOLOR", &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR]));
-  else  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(label->outlinecolor));
-
-  writeNumber(stream, indent, "OUTLINEWIDTH", 1, label->outlinewidth);
-  writeKeyword(stream, indent, "PARTIALS", label->partials, 1, MS_TRUE, "TRUE");
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_POSITION].item)
-    writeAttributeBinding(stream, indent, "POSITION", &(label->bindings[MS_LABEL_BINDING_POSITION]));
-  else writeKeyword(stream, indent, "POSITION", label->position, 10, MS_UL, "UL", MS_UC, "UC", MS_UR, "UR", MS_CL, "CL", MS_CC, "CC", MS_CR, "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR", MS_AUTO, "AUTO");
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_PRIORITY].item)
-    writeAttributeBinding(stream, indent, "PRIORITY", &(label->bindings[MS_LABEL_BINDING_PRIORITY]));
-  else writeNumber(stream, indent, "PRIORITY", MS_DEFAULT_LABEL_PRIORITY, label->priority);
-
-  writeNumber(stream, indent, "REPEATDISTANCE", 0, label->repeatdistance);
-  writeColor(stream, indent, "SHADOWCOLOR", NULL, &(label->shadowcolor));
-  writeDimension(stream, indent, "SHADOWSIZE", label->shadowsizex, label->shadowsizey, label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item, label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
-
-  writeNumber(stream, indent, "MAXOVERLAPANGLE", 22.5, label->maxoverlapangle);
-  for(i=0; i<label->numstyles; i++)
-    writeStyle(stream, indent, label->styles[i]);
-
-  writeExpression(stream, indent, "TEXT", &(label->text));
-
-  writeCharacter(stream, indent, "WRAP", '\0', label->wrap);
-  writeBlockEnd(stream, indent, "LABEL");
-}
-
-char* msWriteLabelToString(labelObj *label)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeLabel(stdout, -1, label);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-void msInitExpression(expressionObj *exp)
-{
-  memset(exp, 0, sizeof(*exp));
-  exp->type = MS_STRING;
-}
-
-void msFreeExpressionTokens(expressionObj *exp)
-{
-  tokenListNodeObjPtr node = NULL;
-  tokenListNodeObjPtr nextNode = NULL;
-
-  if(!exp) return;
-
-  if(exp->tokens) {
-    node = exp->tokens;
-    while (node != NULL) {
-      nextNode = node->next;
-
-      msFree(node->tokensrc); /* not set very often */
-
-      switch(node->token) {
-        case MS_TOKEN_BINDING_DOUBLE:
-        case MS_TOKEN_BINDING_INTEGER:
-        case MS_TOKEN_BINDING_STRING:
-        case MS_TOKEN_BINDING_TIME:
-          msFree(node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_LITERAL_TIME:
-          /* anything to do? */
-          break;
-        case MS_TOKEN_LITERAL_STRING:
-          msFree(node->tokenval.strval);
-          break;
-        case MS_TOKEN_LITERAL_SHAPE:
-          msFreeShape(node->tokenval.shpval);
-          free(node->tokenval.shpval);
-          break;
-      }
-
-      msFree(node);
-      node = nextNode;
-    }
-    exp->tokens = exp->curtoken = NULL;
-  }
-}
-
-void msFreeExpression(expressionObj *exp)
-{
-  if(!exp) return;
-  msFree(exp->string);
-  msFree(exp->native_string);
-  if((exp->type == MS_REGEX) && exp->compiled) ms_regfree(&(exp->regex));
-  msFreeExpressionTokens(exp);
-  msInitExpression(exp); /* re-initialize */
-}
-
-int loadExpression(expressionObj *exp)
-{
-  /* TODO: should we call msFreeExpression if exp->string != NULL? We do some checking to avoid a leak but is it enough... */
-
-  msyystring_icase = MS_TRUE;
-  if((exp->type = getSymbol(6, MS_STRING,MS_EXPRESSION,MS_REGEX,MS_ISTRING,MS_IREGEX,MS_LIST)) == -1) return(-1);
-  if (exp->string != NULL) {
-    msFree(exp->string);
-    msFree(exp->native_string);
-  }
-  exp->string = msStrdup(msyystring_buffer);
-  exp->native_string = NULL;
-
-  if(exp->type == MS_ISTRING) {
-    exp->flags = exp->flags | MS_EXP_INSENSITIVE;
-    exp->type = MS_STRING;
-  } else if(exp->type == MS_IREGEX) {
-    exp->flags = exp->flags | MS_EXP_INSENSITIVE;
-    exp->type = MS_REGEX;
-  }
-
-  return(0);
-}
-
-/* ---------------------------------------------------------------------------
-   msLoadExpressionString and loadExpressionString
-
-   msLoadExpressionString wraps call to loadExpressionString with mutex
-   acquisition and release.  This function should be used everywhere outside
-   the mapfile loading phase of an application.  loadExpressionString does
-   not check for a mutex!  It should be used only within code that has
-   properly acquired a mutex.
-
-   See bug 339 for more details -- SG.
-   ------------------------------------------------------------------------ */
-
-int msLoadExpressionString(expressionObj *exp, char *value)
-{
-  int retval = MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-  retval = loadExpressionString( exp, value );
-  msReleaseLock( TLOCK_PARSER );
-
-  return retval;
-}
-
-int loadExpressionString(expressionObj *exp, char *value)
-{
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = value;
-  msyylex(); /* sets things up but processes no tokens */
-
-  msFreeExpression(exp); /* we're totally replacing the old expression so free (which re-inits) to start over */
-
-  msyystring_icase = MS_TRUE;
-  if((exp->type = getSymbol2(5, MS_EXPRESSION,MS_REGEX,MS_IREGEX,MS_ISTRING,MS_LIST)) != -1) {
-    exp->string = msStrdup(msyystring_buffer);
-
-    if(exp->type == MS_ISTRING) {
-      exp->type = MS_STRING;
-      exp->flags = exp->flags | MS_EXP_INSENSITIVE;
-    } else if(exp->type == MS_IREGEX) {
-      exp->type = MS_REGEX;
-      exp->flags = exp->flags | MS_EXP_INSENSITIVE;
-    }
-  } else {
-    /* failure above is not an error since we'll consider anything not matching (like an unquoted number) as a STRING) */
-    exp->type = MS_STRING;
-    if((strlen(value) - strlen(msyystring_buffer)) == 2)
-      exp->string = msStrdup(msyystring_buffer); /* value was quoted */
-    else
-      exp->string = msStrdup(value); /* use the whole value */
-  }
-
-  return(0);
-}
-
-/* msGetExpressionString()
- *
- * Returns the string representation of this expression, including delimiters
- * and any flags (e.g. i = case-insensitive).
- *
- * Returns a newly allocated buffer that should be freed by the caller or NULL.
- */
-char *msGetExpressionString(expressionObj *exp)
-{
-  if(exp->string) {
-    char *exprstring;
-    size_t buffer_size;
-    const char *case_insensitive = "";
-
-    if(exp->flags & MS_EXP_INSENSITIVE)
-      case_insensitive = "i";
-
-    /* Alloc buffer big enough for string + 2 delimiters + 'i' + \0 */
-    buffer_size = strlen(exp->string)+4;
-    exprstring = (char*)msSmallMalloc(buffer_size);
-
-    switch(exp->type) {
-      case(MS_REGEX):
-        snprintf(exprstring, buffer_size, "/%s/%s", exp->string, case_insensitive);
-        return exprstring;
-      case(MS_STRING):
-        snprintf(exprstring, buffer_size, "\"%s\"%s", exp->string, case_insensitive);
-        return exprstring;
-      case(MS_EXPRESSION):
-        snprintf(exprstring, buffer_size, "(%s)", exp->string);
-        return exprstring;
-      case(MS_LIST):
-        snprintf(exprstring, buffer_size, "{%s}", exp->string);
-        return exprstring;
-      default:
-        /* We should never get to here really! */
-        free(exprstring);
-        return NULL;
-    }
-  }
-  return NULL;
-}
-
-static void writeExpression(FILE *stream, int indent, const char *name, expressionObj *exp)
-{
-  if(!exp || !exp->string) return;
-
-  writeIndent(stream, ++indent);
-  switch(exp->type) {
-    case(MS_LIST):
-      fprintf(stream, "%s {%s}", name, exp->string);
-      break;
-    case(MS_REGEX):
-      msIO_fprintf(stream, "%s /%s/", name, exp->string);
-      break;
-    case(MS_STRING):
-      msIO_fprintf(stream, "%s ", name);
-      writeStringElement(stream, exp->string);
-      break;
-    case(MS_EXPRESSION):
-      msIO_fprintf(stream, "%s (%s)", name, exp->string);
-      break;
-  }
-  if((exp->type == MS_STRING || exp->type == MS_REGEX) && (exp->flags & MS_EXP_INSENSITIVE))
-    msIO_fprintf(stream, "i");
-  writeLineFeed(stream);
-}
-
-int loadHashTable(hashTableObj *ptable)
-{
-  assert(ptable);
-
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadHashTable()");
-        return(MS_FAILURE);
-      case(END):
-        return(MS_SUCCESS);
-      case(MS_STRING):
-      {
-        char* data = NULL;
-        char* key = msStrdup(msyystring_buffer); /* the key is *always* a string */
-        if(getString(&data) == MS_FAILURE) {
-          free(key);
-          return(MS_FAILURE);
-        }
-        msInsertHashTable(ptable, key, data);
-
-        free(key);
-        free(data);
-        break;
-      }
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadHashTable()", msyystring_buffer, msyylineno );
-        return(MS_FAILURE);
-    }
-  }
-
-  return(MS_SUCCESS);
-}
-
-static void writeHashTable(FILE *stream, int indent, const char *title, hashTableObj *table)
-{
-  struct hashObj *tp;
-  int i;
-
-  if(!table) return;
-  if(msHashIsEmpty(table)) return;
-
-  indent++;
-  writeBlockBegin(stream, indent, title);
-  for (i=0; i<MS_HASHSIZE; i++) {
-    if (table->items[i] != NULL) {
-      for (tp=table->items[i]; tp!=NULL; tp=tp->next)
-        writeNameValuePair(stream, indent, tp->key, tp->data);
-    }
-  }
-  writeBlockEnd(stream, indent, title);
-}
-
-static void writeHashTableInline(FILE *stream, int indent, char *name, hashTableObj* table)
-{
-  struct hashObj *tp = NULL;
-  int i;
-
-  if(!table) return;
-  if(msHashIsEmpty(table)) return;
-
-  ++indent;
-  for (i=0; i<MS_HASHSIZE; ++i) {
-    if (table->items[i] != NULL) {
-      for (tp=table->items[i]; tp!=NULL; tp=tp->next) {
-        writeIndent(stream, indent);
-        msIO_fprintf(stream, "%s ", name);
-        writeStringElement(stream, tp->key);
-        msIO_fprintf(stream," ");
-        writeStringElement(stream, tp->data);
-        writeLineFeed(stream);
-      }
-    }
-  }
-}
-
-/*
-** Initialize, load and free a cluster object
-*/
-void initCluster(clusterObj *cluster)
-{
-  cluster->maxdistance = 10;
-  cluster->buffer = 0;
-  cluster->region = NULL;
-  msInitExpression(&(cluster->group));
-  msInitExpression(&(cluster->filter));
-}
-
-void freeCluster(clusterObj *cluster)
-{
-  msFree(cluster->region);
-  msFreeExpression(&(cluster->group));
-  msFreeExpression(&(cluster->filter));
-}
-
-int loadCluster(clusterObj *cluster)
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(CLUSTER):
-        break; /* for string loads */
-      case(MAXDISTANCE):
-        if(getDouble(&(cluster->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(BUFFER):
-        if(getDouble(&(cluster->buffer), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(REGION):
-        if(getString(&cluster->region) == MS_FAILURE) return(-1);
-        break;
-      case(END):
-        return(0);
-        break;
-      case(GROUP):
-        if(loadExpression(&(cluster->group)) == -1) return(-1);
-        break;
-      case(FILTER):
-        if(loadExpression(&(cluster->filter)) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadCluster()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-
-    }
-  }
-  return(MS_SUCCESS);
-}
-
-int msUpdateClusterFromString(clusterObj *cluster, char *string)
-{
-  if(!cluster || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadCluster(cluster) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-static void writeCluster(FILE *stream, int indent, clusterObj *cluster)
-{
-
-  if (cluster->maxdistance == 10 &&
-      cluster->buffer == 0.0 &&
-      cluster->region == NULL &&
-      cluster->group.string == NULL &&
-      cluster->filter.string == NULL)
-    return;  /* Nothing to write */
-
-  indent++;
-  writeBlockBegin(stream, indent, "CLUSTER");
-  writeNumber(stream, indent, "MAXDISTANCE", 10, cluster->maxdistance);
-  writeNumber(stream, indent, "BUFFER", 0, cluster->buffer);
-  writeString(stream, indent, "REGION", NULL, cluster->region);
-  writeExpression(stream, indent, "GROUP", &(cluster->group));
-  writeExpression(stream, indent, "FILTER", &(cluster->filter));
-  writeBlockEnd(stream, indent, "CLUSTER");
-}
-
-char* msWriteClusterToString(clusterObj *cluster)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeCluster(stdout, -1, cluster);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-/*
-** Initialize, load and free a single style
-*/
-int initStyle(styleObj *style)
-{
-  int i;
-  MS_REFCNT_INIT(style);
-  MS_INIT_COLOR(style->color, -1,-1,-1,255); /* must explictly set colors */
-  MS_INIT_COLOR(style->outlinecolor, -1,-1,-1,255);
-  /* New Color Range fields*/
-  MS_INIT_COLOR(style->mincolor, -1,-1,-1,255);
-  MS_INIT_COLOR(style->maxcolor, -1,-1,-1,255);
-  style->minvalue = 0.0;
-  style->maxvalue = 1.0;
-  style->rangeitem = NULL;
-  /* End Color Range fields*/
-  style->symbol = 0; /* there is always a default symbol*/
-  style->symbolname = NULL;
-  style->size = -1; /* in SIZEUNITS (layerObj) */
-  style->minsize = MS_MINSYMBOLSIZE;
-  style->maxsize = MS_MAXSYMBOLSIZE;
-  style->width = 1; /* in pixels */
-  style->outlinewidth = 0; /* in pixels */
-  style->minwidth = MS_MINSYMBOLWIDTH;
-  style->maxwidth = MS_MAXSYMBOLWIDTH;
-  style->minscaledenom=style->maxscaledenom = -1.0;
-  style->offsetx = style->offsety = 0; /* no offset */
-  style->polaroffsetpixel = style->polaroffsetangle = 0; /* no polar offset */
-  style->angle = 0;
-  style->autoangle= MS_FALSE;
-  style->antialiased = MS_TRUE;
-  style->opacity = 100; /* fully opaque */
-
-  msInitExpression(&(style->_geomtransform));
-  style->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
-
-  style->patternlength = 0; /* solid line */
-  style->gap = 0;
-  style->initialgap = -1;
-  style->linecap = MS_CJC_DEFAULT_CAPS;
-  style->linejoin = MS_CJC_DEFAULT_JOINS;
-  style->linejoinmaxsize = MS_CJC_DEFAULT_JOIN_MAXSIZE;
-
-  style->numbindings = 0;
-  style->nexprbindings = 0;
-  for(i=0; i<MS_STYLE_BINDING_LENGTH; i++) {
-    style->bindings[i].item = NULL;
-    style->bindings[i].index = -1;
-    msInitExpression(&(style->exprBindings[i]));
-  }
-
-  style->sizeunits = MS_INHERIT;
-  style->scalefactor = 1.0;
-
-  return MS_SUCCESS;
-}
-
-int loadStyle(styleObj *style)
-{
-  int symbol;
-
-  for(;;) {
-    switch(msyylex()) {
-        /* New Color Range fields*/
-      case (COLORRANGE):
-        /*These are both in one line now*/
-        if(loadColor(&(style->mincolor), NULL) != MS_SUCCESS) return(MS_FAILURE);
-        if(loadColor(&(style->maxcolor), NULL) != MS_SUCCESS) return(MS_FAILURE);
-        break;
-      case(DATARANGE):
-        /*These are both in one line now*/
-        if(getDouble(&(style->minvalue), MS_NUM_CHECK_NONE, -1, -1) == -1) return(MS_FAILURE);
-        if(getDouble(&(style->maxvalue), MS_NUM_CHECK_NONE, -1, -1) == -1) return(MS_FAILURE);
-        break;
-      case(RANGEITEM):
-        if(getString(&style->rangeitem) == MS_FAILURE) return(MS_FAILURE);
-        break;
-        /* End Range fields*/
-      case(ANGLE):
-        if((symbol = getSymbol(3, MS_NUMBER,MS_BINDING,MS_AUTO)) == -1) return(MS_FAILURE);
-
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid ANGLE, must be between -360 and 360 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          style->angle = (double) msyynumber;
-        } else if(symbol==MS_BINDING) {
-          if (style->bindings[MS_STYLE_BINDING_ANGLE].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_ANGLE].item);
-          style->bindings[MS_STYLE_BINDING_ANGLE].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        } else {
-          style->autoangle=MS_TRUE;
-        }
-        break;
-      case(ANTIALIAS):
-        if ((symbol = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(MS_FAILURE);
-        if (symbol == MS_FALSE) {
-            style->antialiased = MS_FALSE;
-        }
-        break;
-      case(COLOR):
-        if(loadColor(&(style->color), &(style->bindings[MS_STYLE_BINDING_COLOR])) != MS_SUCCESS) return(MS_FAILURE);
-        if(style->bindings[MS_STYLE_BINDING_COLOR].item) style->numbindings++;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadStyle()");
-        return(MS_FAILURE); /* missing END (probably) */
-      case(END): {
-        int alpha;
-
-        /* apply opacity as the alpha channel color(s) */
-        if(style->opacity < 100) {
-          alpha = MS_NINT(style->opacity*2.55);
-
-          style->color.alpha = alpha;
-          style->outlinecolor.alpha = alpha;
-
-          style->mincolor.alpha = alpha;
-          style->maxcolor.alpha = alpha;
-        }
-
-        return(MS_SUCCESS);
-      }
-      break;
-      case(GAP):
-        if(getDouble(&(style->gap), MS_NUM_CHECK_NONE, -1, -1) == -1) return(MS_FAILURE);
-        break;
-      case(INITIALGAP):
-        if(getDouble(&(style->initialgap), MS_NUM_CHECK_GTE, 0, -1) == -1) { // zero is ok
-          msSetError(MS_MISCERR, "INITIALGAP requires a positive values (line %d)", "loadStyle()", msyylineno);
-          return(MS_FAILURE);
-        }
-        break;
-      case(MAXSCALEDENOM):
-        if(getDouble(&(style->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MINSCALEDENOM):
-        if(getDouble(&(style->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(GEOMTRANSFORM): {
-        int s;
-        if((s = getSymbol(2, MS_STRING, MS_EXPRESSION)) == -1) return(MS_FAILURE);
-        if(s == MS_STRING)
-          msStyleSetGeomTransform(style, msyystring_buffer);
-        else {
-          /* handle expression case here for the moment */
-          msFree(style->_geomtransform.string);
-          style->_geomtransform.string = msStrdup(msyystring_buffer);
-          style->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
-        }
-      }
-      break;
-      case(LINECAP):
-        if((style->linecap = getSymbol(4,MS_CJC_BUTT, MS_CJC_ROUND, MS_CJC_SQUARE, MS_CJC_TRIANGLE)) == -1) return(MS_FAILURE);
-        break;
-      case(LINEJOIN):
-        if((style->linejoin = getSymbol(4,MS_CJC_NONE, MS_CJC_ROUND, MS_CJC_MITER, MS_CJC_BEVEL)) == -1) return(MS_FAILURE);
-        break;
-      case(LINEJOINMAXSIZE):
-        if(getDouble(&(style->linejoinmaxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MAXSIZE):
-        if(getDouble(&(style->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MINSIZE):
-        if(getDouble(&(style->minsize), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MAXWIDTH):
-        if(getDouble(&(style->maxwidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MINWIDTH):
-        if(getDouble(&(style->minwidth), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(OFFSET):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          style->offsetx = (double) msyynumber; // any double ok
-        else {
-          if (style->bindings[MS_STYLE_BINDING_OFFSET_X].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OFFSET_X].item);
-          style->bindings[MS_STYLE_BINDING_OFFSET_X].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          style->offsety = (double) msyynumber; // any double ok
-        else {
-          if (style->bindings[MS_STYLE_BINDING_OFFSET_Y].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
-          style->bindings[MS_STYLE_BINDING_OFFSET_Y].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(OPACITY):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          style->opacity = MS_MAX(MS_MIN((int) msyynumber, 100), 0); /* force opacity to between 0 and 100 */
-        else {
-          if (style->bindings[MS_STYLE_BINDING_OPACITY].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OPACITY].item);
-          style->bindings[MS_STYLE_BINDING_OPACITY].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(style->outlinecolor), &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR])) != MS_SUCCESS) return(MS_FAILURE);
-        if(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item) style->numbindings++;
-        break;
-      case(PATTERN): {
-        int done = MS_FALSE;
-        for(;;) { /* read till the next END */
-          switch(msyylex()) {
-            case(END):
-              if(style->patternlength < 2) {
-                msSetError(MS_SYMERR, "Not enough pattern elements. A minimum of 2 are required (line %d)", "loadStyle()", msyylineno);
-                return(MS_FAILURE);
-              }
-              done = MS_TRUE;
-              break;
-            case(MS_NUMBER): /* read the pattern values */
-              if(style->patternlength == MS_MAXPATTERNLENGTH) {
-                msSetError(MS_SYMERR, "Pattern too long.", "loadStyle()");
-                return(MS_FAILURE);
-              }
-              style->pattern[style->patternlength] = atof(msyystring_buffer); // good enough?
-              style->patternlength++;
-              break;
-            default:
-              msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)", "loadStyle()", msyystring_buffer, msyylineno);
-              return(MS_FAILURE);
-          }
-          if(done == MS_TRUE)
-            break;
-        }
-        break;
-      }
-      case(OUTLINEWIDTH):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid OUTLINEWIDTH, must be greater then or equal to 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          style->outlinewidth = (double) msyynumber;
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item);
-          style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(SIZE):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid SIZE, must be greater than 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          style->size = (double) msyynumber;
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_SIZE].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_SIZE].item);
-          style->bindings[MS_STYLE_BINDING_SIZE].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(STYLE):
-        break; /* for string loads */
-      case(SYMBOL):
-        if((symbol = getSymbol(3, MS_NUMBER,MS_STRING,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid SYMBOL id, must be greater than or equal to 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          if(style->symbolname != NULL) {
-            msFree(style->symbolname);
-            style->symbolname = NULL;
-          }
-          style->symbol = (int) msyynumber;
-        } else if(symbol == MS_STRING) {
-          if (style->symbolname != NULL)
-            msFree(style->symbolname);
-          style->symbolname = msStrdup(msyystring_buffer);
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_SYMBOL].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_SYMBOL].item);
-          style->bindings[MS_STYLE_BINDING_SYMBOL].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(WIDTH):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid WIDTH, must be greater than or equal to 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          style->width = (double) msyynumber;
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_WIDTH].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_WIDTH].item);
-          style->bindings[MS_STYLE_BINDING_WIDTH].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(POLAROFFSET):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          style->polaroffsetpixel = (double) msyynumber; // ok?
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item);
-          style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          style->polaroffsetangle = (double) msyynumber; // ok?
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
-          style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadStyle()", msyystring_buffer, msyylineno);
-          return(MS_FAILURE);
-        } else {
-          return(MS_SUCCESS); /* end of a string, not an error */
-        }
-    }
-  }
-}
-
-int msUpdateStyleFromString(styleObj *style, char *string)
-{
-  if(!style || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadStyle(style) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-int freeStyle(styleObj *style)
-{
-  int i;
-
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(style) ) {
-    return MS_FAILURE;
-  }
-
-  msFree(style->symbolname);
-  msFreeExpression(&style->_geomtransform);
-  msFree(style->rangeitem);
-
-  for(i=0; i<MS_STYLE_BINDING_LENGTH; i++) {
-    msFree(style->bindings[i].item);
-    msFreeExpression(&(style->exprBindings[i]));
-  }
-
-  return MS_SUCCESS;
-}
-
-void writeStyle(FILE *stream, int indent, styleObj *style)
-{
-
-  indent++;
-  writeBlockBegin(stream, indent, "STYLE");
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_ANGLE].item)
-    writeAttributeBinding(stream, indent, "ANGLE", &(style->bindings[MS_STYLE_BINDING_ANGLE]));
-  else writeNumberOrKeyword(stream, indent, "ANGLE", 0, style->angle, style->autoangle, 1, MS_TRUE, "AUTO");
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_COLOR].item)
-    writeAttributeBinding(stream, indent, "COLOR", &(style->bindings[MS_STYLE_BINDING_COLOR]));
-  else writeColor(stream, indent, "COLOR", NULL, &(style->color));
-
-  writeNumber(stream, indent, "GAP", 0, style->gap);
-  writeNumber(stream, indent, "INITIALGAP", -1, style->initialgap);
-
-  if(style->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
-    writeIndent(stream, indent + 1);
-    msIO_fprintf(stream, "GEOMTRANSFORM (%s)\n", style->_geomtransform.string);
-  }
-  else if(style->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
-    writeKeyword(stream, indent, "GEOMTRANSFORM", style->_geomtransform.type, 8,
-                 MS_GEOMTRANSFORM_BBOX, "\"bbox\"",
-                 MS_GEOMTRANSFORM_END, "\"end\"",
-                 MS_GEOMTRANSFORM_LABELPOINT, "\"labelpnt\"",
-                 MS_GEOMTRANSFORM_LABELPOLY, "\"labelpoly\"",
-                 MS_GEOMTRANSFORM_LABELCENTER, "\"labelcenter\"",
-                 MS_GEOMTRANSFORM_START, "\"start\"",
-                 MS_GEOMTRANSFORM_VERTICES, "\"vertices\"",
-                 MS_GEOMTRANSFORM_CENTROID, "\"centroid\""
-                );
-  }
-
-  if(style->linecap != MS_CJC_DEFAULT_CAPS) {
-    writeKeyword(stream,indent,"LINECAP",(int)style->linecap,5,
-                 MS_CJC_NONE,"NONE",
-                 MS_CJC_ROUND, "ROUND",
-                 MS_CJC_SQUARE, "SQUARE",
-                 MS_CJC_BUTT, "BUTT",
-                 MS_CJC_TRIANGLE, "TRIANGLE");
-  }
-  if(style->linejoin != MS_CJC_DEFAULT_JOINS) {
-    writeKeyword(stream,indent,"LINEJOIN",(int)style->linejoin,5,
-                 MS_CJC_NONE,"NONE",
-                 MS_CJC_ROUND, "ROUND",
-                 MS_CJC_BEVEL, "BEVEL",
-                 MS_CJC_MITER, "MITER");
-  }
-  writeNumber(stream, indent, "LINEJOINMAXSIZE", MS_CJC_DEFAULT_JOIN_MAXSIZE , style->linejoinmaxsize);
-
-
-  writeNumber(stream, indent, "MAXSCALEDENOM", -1, style->maxscaledenom);
-  writeNumber(stream, indent, "MAXSIZE", MS_MAXSYMBOLSIZE, style->maxsize);
-  writeNumber(stream, indent, "MAXWIDTH", MS_MAXSYMBOLWIDTH, style->maxwidth);
-  writeNumber(stream, indent, "MINSCALEDENOM", -1, style->minscaledenom);
-  writeNumber(stream, indent, "MINSIZE", MS_MINSYMBOLSIZE, style->minsize);
-  writeNumber(stream, indent, "MINWIDTH", MS_MINSYMBOLWIDTH, style->minwidth);
-  if((style->numbindings > 0 && (style->bindings[MS_STYLE_BINDING_OFFSET_X].item||style->bindings[MS_STYLE_BINDING_OFFSET_Y].item))||style->offsetx!=0||style->offsety!=0)
-    writeDimension(stream, indent, "OFFSET", style->offsetx, style->offsety, style->bindings[MS_STYLE_BINDING_OFFSET_X].item, style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
-  if((style->numbindings > 0 && (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item||style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item))||style->polaroffsetangle!=0||style->polaroffsetpixel!=0)
-    writeDimension(stream, indent, "POLAROFFSET", style->polaroffsetpixel, style->polaroffsetangle,
-                 style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item, style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OPACITY].item)
-    writeAttributeBinding(stream, indent, "OPACITY", &(style->bindings[MS_STYLE_BINDING_OPACITY]));
-  else writeNumber(stream, indent, "OPACITY", 100, style->opacity);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item)
-    writeAttributeBinding(stream, indent, "OUTLINECOLOR", &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR]));
-  else  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(style->outlinecolor));
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item)
-    writeAttributeBinding(stream, indent, "OUTLINEWIDTH", &(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH]));
-  else writeNumber(stream, indent, "OUTLINEWIDTH", 0, style->outlinewidth);
-
-  /* PATTERN */
-  if(style->patternlength != 0) {
-    int i;
-    indent++;
-    writeBlockBegin(stream,indent,"PATTERN");
-    writeIndent(stream, indent);
-    for(i=0; i<style->patternlength; i++)
-      msIO_fprintf(stream, " %.2f", style->pattern[i]);
-    msIO_fprintf(stream,"\n");
-    writeBlockEnd(stream,indent,"PATTERN");
-    indent--;
-  }
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SIZE].item)
-    writeAttributeBinding(stream, indent, "SIZE", &(style->bindings[MS_STYLE_BINDING_SIZE]));
-  else writeNumber(stream, indent, "SIZE", -1, style->size);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SYMBOL].item)
-    writeAttributeBinding(stream, indent, "SYMBOL", &(style->bindings[MS_STYLE_BINDING_SYMBOL]));
-  else writeNumberOrString(stream, indent, "SYMBOL", 0, style->symbol, style->symbolname);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_WIDTH].item)
-    writeAttributeBinding(stream, indent, "WIDTH", &(style->bindings[MS_STYLE_BINDING_WIDTH]));
-  else writeNumber(stream, indent, "WIDTH", 1, style->width);
-
-  writeString(stream, indent, "RANGEITEM", NULL, style->rangeitem);
-  /* If COLORRANGE is valid, assume DATARANGE also needs to be written */
-  if(MS_VALID_COLOR(style->mincolor) && MS_VALID_COLOR(style->maxcolor)) {
-    writeColorRange(stream, indent, "COLORRANGE", &(style->mincolor), &(style->maxcolor));
-    writeDoubleRange(stream, indent, "DATARANGE", style->minvalue, style->maxvalue);
-  }
-
-  writeBlockEnd(stream, indent, "STYLE");
-}
-
-char* msWriteStyleToString(styleObj *style)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeStyle(stdout, -1, style);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-/*
-** Initialize, load and free a single class
-*/
-int initClass(classObj *class)
-{
-  class->status = MS_ON;
-  class->debug = MS_OFF;
-  MS_REFCNT_INIT(class);
-  class->isfallback = FALSE;
-
-  msInitExpression(&(class->expression));
-  class->name = NULL;
-  class->title = NULL;
-  msInitExpression(&(class->text));
-
-  class->template = NULL;
-
-  initHashTable(&(class->metadata));
-  initHashTable(&(class->validation));
-
-  class->maxscaledenom = class->minscaledenom = -1.0;
-  class->minfeaturesize = -1; /* no limit */
-
-  /* Set maxstyles = 0, styles[] will be allocated as needed on first call
-   * to msGrowClassStyles()
-   */
-  class->numstyles = class->maxstyles = 0;
-  class->styles = NULL;
-
-  class->numlabels = class->maxlabels = 0;
-  class->labels = NULL;
-
-  class->keyimage = NULL;
-
-  class->group = NULL;
-
-  class->leader = NULL;
-
-  class->sizeunits = MS_INHERIT;
-  class->scalefactor = 1.0;
-
-  return(0);
-}
-
-int freeClass(classObj *class)
-{
-  int i;
-
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(class) ) {
-    return MS_FAILURE;
-  }
-
-  msFreeExpression(&(class->expression));
-  msFreeExpression(&(class->text));
-  msFree(class->name);
-  msFree(class->title);
-  msFree(class->template);
-  msFree(class->group);
-
-  if (&(class->metadata)) msFreeHashItems(&(class->metadata));
-  if (&(class->validation)) msFreeHashItems(&(class->validation));
-
-  for(i=0; i<class->numstyles; i++) { /* each style */
-    if(class->styles[i]!=NULL) {
-      if(freeStyle(class->styles[i]) == MS_SUCCESS) {
-        msFree(class->styles[i]);
-      }
-    }
-  }
-  msFree(class->styles);
-
-  for(i=0; i<class->numlabels; i++) { /* each label */
-    if(class->labels[i]!=NULL) {
-      if(freeLabel(class->labels[i]) == MS_SUCCESS) {
-        msFree(class->labels[i]);
-      }
-    }
-  }
-  msFree(class->labels);
-
-  msFree(class->keyimage);
-
-  if(class->leader) {
-    freeLabelLeader(class->leader);
-    msFree(class->leader);
-    class->leader = NULL;
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Ensure there is at least one free entry in the sttyles array of this
-** classObj. Grow the allocated styles array if necessary and allocate
-** a new style for styles[numstyles] if there is not already one,
-** setting its contents to all zero bytes (i.e. does not call initStyle()
-** on it).
-**
-** This function is safe to use for the initial allocation of the styles[]
-** array as well (i.e. when maxstyles==0 and styles==NULL)
-**
-** Returns a reference to the new styleObj on success, NULL on error.
-*/
-styleObj *msGrowClassStyles( classObj *class )
-{
-  /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
-   */
-  if (class->numstyles == class->maxstyles) {
-    styleObj **newStylePtr;
-    int i, newsize;
-
-    newsize = class->maxstyles + MS_STYLE_ALLOCSIZE;
-
-    /* Alloc/realloc styles */
-    newStylePtr = (styleObj**)realloc(class->styles, newsize*sizeof(styleObj*));
-    MS_CHECK_ALLOC(newStylePtr, newsize*sizeof(styleObj*), NULL);
-
-    class->styles = newStylePtr;
-    class->maxstyles = newsize;
-    for(i=class->numstyles; i<class->maxstyles; i++) {
-      class->styles[i] = NULL;
-    }
-  }
-
-  if (class->styles[class->numstyles]==NULL) {
-    class->styles[class->numstyles]=(styleObj*)calloc(1,sizeof(styleObj));
-    MS_CHECK_ALLOC(class->styles[class->numstyles], sizeof(styleObj), NULL);
-  }
-
-  return class->styles[class->numstyles];
-}
-
-/* exactly the same as for a classObj */
-styleObj *msGrowLabelStyles( labelObj *label )
-{
-  /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
-   */
-  if (label->numstyles == label->maxstyles) {
-    styleObj **newStylePtr;
-    int i, newsize;
-
-    newsize = label->maxstyles + MS_STYLE_ALLOCSIZE;
-
-    /* Alloc/realloc styles */
-    newStylePtr = (styleObj**)realloc(label->styles, newsize*sizeof(styleObj*));
-    MS_CHECK_ALLOC(newStylePtr, newsize*sizeof(styleObj*), NULL);
-
-    label->styles = newStylePtr;
-    label->maxstyles = newsize;
-    for(i=label->numstyles; i<label->maxstyles; i++) {
-      label->styles[i] = NULL;
-    }
-  }
-
-  if (label->styles[label->numstyles]==NULL) {
-    label->styles[label->numstyles]=(styleObj*)calloc(1,sizeof(styleObj));
-    MS_CHECK_ALLOC(label->styles[label->numstyles], sizeof(styleObj), NULL);
-  }
-
-  return label->styles[label->numstyles];
-}
-
-/* exactly the same as for a labelLeaderObj, needs refactoring */
-styleObj *msGrowLeaderStyles( labelLeaderObj *leader )
-{
-  /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
-   */
-  if (leader->numstyles == leader->maxstyles) {
-    styleObj **newStylePtr;
-    int i, newsize;
-
-    newsize = leader->maxstyles + MS_STYLE_ALLOCSIZE;
-
-    /* Alloc/realloc styles */
-    newStylePtr = (styleObj**)realloc(leader->styles,
-                                      newsize*sizeof(styleObj*));
-    MS_CHECK_ALLOC(newStylePtr, newsize*sizeof(styleObj*), NULL);
-
-    leader->styles = newStylePtr;
-    leader->maxstyles = newsize;
-    for(i=leader->numstyles; i<leader->maxstyles; i++) {
-      leader->styles[i] = NULL;
-    }
-  }
-
-  if (leader->styles[leader->numstyles]==NULL) {
-    leader->styles[leader->numstyles]=(styleObj*)calloc(1,sizeof(styleObj));
-    MS_CHECK_ALLOC(leader->styles[leader->numstyles], sizeof(styleObj), NULL);
-  }
-
-  return leader->styles[leader->numstyles];
-}
-
-/* msMaybeAllocateClassStyle()
-**
-** Ensure that requested style index exists and has been initialized.
-**
-** Returns MS_SUCCESS/MS_FAILURE.
-*/
-int msMaybeAllocateClassStyle(classObj* c, int idx)
-{
-  if (c==NULL) return MS_FAILURE;
-
-  if ( idx < 0 ) {
-    msSetError(MS_MISCERR, "Invalid style index: %d", "msMaybeAllocateClassStyle()", idx);
-    return MS_FAILURE;
-  }
-
-  /* Alloc empty styles as needed up to idx.
-   * Nothing to do if requested style already exists
-   */
-  while(c->numstyles <= idx) {
-    if (msGrowClassStyles(c) == NULL)
-      return MS_FAILURE;
-
-    if ( initStyle(c->styles[c->numstyles]) == MS_FAILURE ) {
-      msSetError(MS_MISCERR, "Failed to init new styleObj",
-                 "msMaybeAllocateClassStyle()");
-      freeStyle(c->styles[c->numstyles]);
-      free(c->styles[c->numstyles]);
-      c->styles[c->numstyles] = NULL;
-      return(MS_FAILURE);
-    }
-    c->numstyles++;
-  }
-  return MS_SUCCESS;
-}
-
-
-
-/*
- * Reset style info in the class to defaults
- * the only members we don't touch are name, expression, and join/query stuff
- * This is used with STYLEITEM before overwriting the contents of a class.
- */
-void resetClassStyle(classObj *class)
-{
-  int i;
-
-  /* reset labels */
-  for(i=0; i<class->numlabels; i++) {
-    if(class->labels[i] != NULL) {
-      if(freeLabel(class->labels[i]) == MS_SUCCESS ) {
-        msFree(class->labels[i]);
-      }
-      class->labels[i] = NULL;
-    }
-  }
-  class->numlabels = 0;
-
-  msFreeExpression(&(class->text));
-  msInitExpression(&(class->text));
-
-  /* reset styles */
-  for(i=0; i<class->numstyles; i++) {
-    if(class->styles[i] != NULL) {
-      if( freeStyle(class->styles[i]) == MS_SUCCESS ) {
-        msFree(class->styles[i]);
-      }
-      class->styles[i] = NULL;
-    }
-  }
-  class->numstyles = 0;
-
-  class->layer = NULL;
-}
-
-labelObj *msGrowClassLabels( classObj *class )
-{
-
-  /* Do we need to increase the size of labels[] by MS_LABEL_ALLOCSIZE?
-   */
-  if (class->numlabels == class->maxlabels) {
-    labelObj **newLabelPtr;
-    int i, newsize;
-
-    newsize = class->maxlabels + MS_LABEL_ALLOCSIZE;
-
-    /* Alloc/realloc labels */
-    newLabelPtr = (labelObj**)realloc(class->labels, newsize*sizeof(labelObj*));
-    MS_CHECK_ALLOC(newLabelPtr, newsize*sizeof(labelObj*), NULL);
-
-    class->labels = newLabelPtr;
-    class->maxlabels = newsize;
-    for(i=class->numlabels; i<class->maxlabels; i++) {
-      class->labels[i] = NULL;
-    }
-  }
-
-  if (class->labels[class->numlabels]==NULL) {
-    class->labels[class->numlabels]=(labelObj*)calloc(1,sizeof(labelObj));
-    MS_CHECK_ALLOC(class->labels[class->numlabels], sizeof(labelObj), NULL);
-  }
-
-  return class->labels[class->numlabels];
-}
-
-int loadClass(classObj *class, layerObj *layer)
-{
-  if(!class || !layer) return(-1);
-
-  class->layer = (layerObj *) layer;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(CLASS):
-        break; /* for string loads */
-      case(DEBUG):
-        if((class->debug = getSymbol(3, MS_ON,MS_OFF, MS_NUMBER)) == -1) return(-1);
-        if(class->debug == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid DEBUG level, must be between 0 and 5 (line %d)", "loadClass()", msyylineno);
-            return(-1);
-          }
-          class->debug = (int) msyynumber;
-        }
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadClass()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(EXPRESSION):
-        if(loadExpression(&(class->expression)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(GROUP):
-        if(getString(&class->group) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(KEYIMAGE):
-        if(getString(&class->keyimage) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(LABEL):
-        if(msGrowClassLabels(class) == NULL) return(-1);
-        initLabel(class->labels[class->numlabels]);
-        class->labels[class->numlabels]->size = MS_MEDIUM; /* only set a default if the LABEL section is present */
-        if(loadLabel(class->labels[class->numlabels]) == -1) {
-          freeLabel(class->labels[class->numlabels]);
-          free(class->labels[class->numlabels]);
-          class->labels[class->numlabels] = NULL;
-          return(-1);
-        }
-        class->numlabels++;
-        break;
-      case(LEADER):
-        if(!class->leader) {
-          class->leader = msSmallMalloc(sizeof(labelLeaderObj));
-          initLeader(class->leader);
-        }
-        if(loadLeader(class->leader) == -1) return(-1);
-        break;
-      case(MAXSCALE):
-      case(MAXSCALEDENOM):
-        if(getDouble(&(class->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(METADATA):
-        if(loadHashTable(&(class->metadata)) != MS_SUCCESS) return(-1);
-        break;
-      case(MINSCALE):
-      case(MINSCALEDENOM):
-        if(getDouble(&(class->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MINFEATURESIZE):
-        if(getInteger(&(class->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(NAME):
-        if(getString(&class->name) == MS_FAILURE) return(-1);
-        break;
-      case(STATUS):
-        if((class->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(STYLE):
-        if(msGrowClassStyles(class) == NULL)
-          return(-1);
-        initStyle(class->styles[class->numstyles]);
-        if(loadStyle(class->styles[class->numstyles]) != MS_SUCCESS) {
-            freeStyle(class->styles[class->numstyles]);
-            free(class->styles[class->numstyles]);
-            class->styles[class->numstyles] = NULL;
-            return(-1);
-        }
-        class->numstyles++;
-        break;
-      case(TEMPLATE):
-        if(getString(&class->template) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TEXT):
-        if(loadExpression(&(class->text)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        if((class->text.type != MS_STRING) && (class->text.type != MS_EXPRESSION)) {
-          msSetError(MS_MISCERR, "Text expressions support constant or tagged replacement strings." , "loadClass()");
-          return(-1);
-        }
-        break;
-      case(TITLE):
-        if(getString(&class->title) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(VALIDATION):
-        if(loadHashTable(&(class->validation)) != MS_SUCCESS) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadClass()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  }
-}
-
-static int classResolveSymbolNames(classObj *class)
-{
-  int i,j;
-  int try_addimage_if_notfound = MS_TRUE;
-
-  /* step through styles and labels to resolve symbol names */
-  /* class styles */
-  for(i=0; i<class->numstyles; i++) {
-    if(class->styles[i]->symbolname) {
-      if((class->styles[i]->symbol =  msGetSymbolIndex(&(class->layer->map->symbolset), class->styles[i]->symbolname, try_addimage_if_notfound)) == -1) {
-        msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class, style %d of layer %s.", "classResolveSymbolNames()", class->styles[i]->symbolname, i, class->layer->name);
-        return MS_FAILURE;
-      }
-    }
-  }
-
-  /* label styles */
-  for(i=0; i<class->numlabels; i++) {
-    for(j=0; j<class->labels[i]->numstyles; j++) {
-      if(class->labels[i]->styles[j]->symbolname) {
-        if((class->labels[i]->styles[j]->symbol =  msGetSymbolIndex(&(class->layer->map->symbolset), class->labels[i]->styles[j]->symbolname, try_addimage_if_notfound)) == -1) {
-          msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class, label style %d of layer %s.", "classResolveSymbolNames()", class->labels[i]->styles[j]->symbolname, j, class->layer->name);
-          return MS_FAILURE;
-        }
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-int msUpdateClassFromString(classObj *class, char *string)
-{
-  if(!class || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadClass(class, class->layer) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-
-  if(classResolveSymbolNames(class) != MS_SUCCESS) return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-static void writeClass(FILE *stream, int indent, classObj *class)
-{
-  int i;
-
-  if(class->status == MS_DELETE) return;
-
-  indent++;
-  writeBlockBegin(stream, indent, "CLASS");
-  writeString(stream, indent, "NAME", NULL, class->name);
-  writeString(stream, indent, "GROUP", NULL, class->group);
-  writeNumber(stream, indent, "DEBUG", 0, class->debug);
-  writeExpression(stream, indent, "EXPRESSION", &(class->expression));
-  writeString(stream, indent, "KEYIMAGE", NULL, class->keyimage);
-  for(i=0; i<class->numlabels; i++) writeLabel(stream, indent, class->labels[i]);
-  if(class->leader)
-    writeLeader(stream,indent,class->leader);
-  writeNumber(stream, indent, "MAXSCALEDENOM", -1, class->maxscaledenom);
-  writeHashTable(stream, indent, "METADATA", &(class->metadata));
-  writeNumber(stream, indent, "MINSCALEDENOM", -1, class->minscaledenom);
-  writeNumber(stream, indent, "MINFEATURESIZE", -1, class->minfeaturesize);
-  writeKeyword(stream, indent, "STATUS", class->status, 1, MS_OFF, "OFF");
-  for(i=0; i<class->numstyles; i++) writeStyle(stream, indent, class->styles[i]);
-  writeString(stream, indent, "TEMPLATE", NULL, class->template);
-  writeExpression(stream, indent, "TEXT", &(class->text));
-  writeString(stream, indent, "TITLE", NULL, class->title);
-  writeHashTable(stream, indent, "VALIDATION", &(class->validation));
-  writeBlockEnd(stream, indent, "CLASS");
-}
-
-char* msWriteClassToString(classObj *class)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeClass(stdout, -1, class);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-int initCompositingFilter(CompositingFilter *filter) {
-  filter->filter = NULL;
-  filter->next = NULL;
-  return MS_SUCCESS;
-}
-
-void freeCompositingFilter(CompositingFilter *filter) {
-  if(!filter) return;
-  if(filter->next)
-    freeCompositingFilter(filter->next);
-  free(filter->filter);
-  free(filter);
-}
-
-int initLayerCompositer(LayerCompositer *compositer) {
-  compositer->comp_op = MS_COMPOP_SRC_OVER;
-  compositer->opacity = 100;
-  compositer->next = NULL;
-  compositer->filter = NULL;
-  return MS_SUCCESS;
-}
-
-void freeLayerCompositer(LayerCompositer *compositer) {
-  if(!compositer) return;
-  if(compositer->next)
-    freeLayerCompositer(compositer->next);
-  freeCompositingFilter(compositer->filter);
-  free(compositer);
-}
-
-/*
-** Initialize, load and free a single layer structure
-*/
-int initLayer(layerObj *layer, mapObj *map)
-{
-  if (layer==NULL) {
-    msSetError(MS_MEMERR, "Layer is null", "initLayer()");
-    return(-1);
-  }
-  layer->debug = (int)msGetGlobalDebugLevel();
-  MS_REFCNT_INIT(layer);
-
-  /* Set maxclasses = 0, class[] will be allocated as needed on first call
-   * to msGrowLayerClasses()
-   */
-  layer->numclasses = 0;
-  layer->maxclasses = 0;
-  layer->class = NULL;
-
-  layer->name = NULL;
-  layer->group = NULL;
-  layer->status = MS_OFF;
-  layer->data = NULL;
-  layer->rendermode = MS_FIRST_MATCHING_CLASS;
-
-  layer->map = map; /* point back to the encompassing structure */
-
-  layer->type = -1;
-
-  layer->toleranceunits = MS_PIXELS;
-  layer->tolerance = -1; /* perhaps this should have a different value based on type */
-
-  layer->symbolscaledenom = -1.0; /* -1 means nothing is set */
-  layer->scalefactor = 1.0;
-  layer->maxscaledenom = -1.0;
-  layer->minscaledenom = -1.0;
-  layer->minfeaturesize = -1; /* no limit */
-  layer->maxgeowidth = -1.0;
-  layer->mingeowidth = -1.0;
-
-  layer->sizeunits = MS_PIXELS;
-
-  layer->maxfeatures = -1; /* no quota */
-  layer->startindex = -1; /*used for pagination*/
-
-  layer->scaletokens = NULL;
-  layer->numscaletokens = 0;
-
-  layer->template = layer->header = layer->footer = NULL;
-
-  layer->transform = MS_TRUE;
-
-  layer->classitem = NULL;
-  layer->classitemindex = -1;
-
-  layer->units = MS_METERS;
-  if(msInitProjection(&(layer->projection)) == -1) return(-1);
-
-  if( map )
-  {
-    msProjectionInheritContextFrom(&(layer->projection), &(map->projection));
-  }
-
-  layer->project = MS_TRUE;
-  layer->reprojectorLayerToMap = NULL;
-  layer->reprojectorMapToLayer = NULL;
-
-  initCluster(&layer->cluster);
-
-  MS_INIT_COLOR(layer->offsite, -1,-1,-1, 255);
-
-  layer->labelcache = MS_ON;
-  layer->postlabelcache = MS_FALSE;
-
-  layer->labelitem = NULL;
-  layer->labelitemindex = -1;
-
-  layer->labelmaxscaledenom = -1;
-  layer->labelminscaledenom = -1;
-
-  layer->tileitem = msStrdup("location");
-  layer->tileitemindex = -1;
-  layer->tileindex = NULL;
-  layer->tilesrs = NULL;
-
-  layer->bandsitem = NULL;
-  layer->bandsitemindex = -1;
-
-  layer->currentfeature = layer->features = NULL;
-
-  layer->connection = NULL;
-  layer->plugin_library = NULL;
-  layer->plugin_library_original = NULL;
-  layer->connectiontype = MS_SHAPEFILE;
-  layer->vtable = NULL;
-  layer->classgroup = NULL;
-
-  layer->layerinfo = NULL;
-  layer->wfslayerinfo = NULL;
-
-  layer->items = NULL;
-  layer->iteminfo = NULL;
-  layer->numitems = 0;
-
-  layer->resultcache= NULL;
-
-  msInitExpression(&(layer->filter));
-  layer->filteritem = NULL;
-  layer->filteritemindex = -1;
-
-  layer->requires = layer->labelrequires = NULL;
-
-  initHashTable(&(layer->metadata));
-  initHashTable(&(layer->bindvals));
-  initHashTable(&(layer->validation));
-
-  layer->styleitem = NULL;
-  layer->styleitemindex = -1;
-
-  layer->numprocessing = 0;
-  layer->processing = NULL;
-  layer->numjoins = 0;
-  layer->joins = (joinObj *) malloc(MS_MAXJOINS*sizeof(joinObj));
-  MS_CHECK_ALLOC(layer->joins, MS_MAXJOINS*sizeof(joinObj), -1);
-
-  layer->extent.minx = -1.0;
-  layer->extent.miny = -1.0;
-  layer->extent.maxx = -1.0;
-  layer->extent.maxy = -1.0;
-
-  layer->mask = NULL;
-  layer->maskimage = NULL;
-  layer->grid = NULL;
-
-  msInitExpression(&(layer->_geomtransform));
-  layer->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
-
-  msInitExpression(&(layer->utfdata));
-  layer->utfitem = NULL;
-  layer->utfitemindex = -1;
-
-  layer->encoding = NULL;
-
-  layer->sortBy.nProperties = 0;
-  layer->sortBy.properties = NULL;
-  layer->orig_st = NULL;
-
-  layer->compositer = NULL;
-
-  initHashTable(&(layer->connectionoptions));
-
-  return(0);
-}
-
-int initScaleToken(scaleTokenObj* token) {
-  token->n_entries = 0;
-  token->name = NULL;
-  token->tokens = NULL;
-  return MS_SUCCESS;
-}
-
-int freeScaleTokenEntry( scaleTokenEntryObj *token) {
-  msFree(token->value);
-  return MS_SUCCESS;
-}
-
-int freeScaleToken(scaleTokenObj *scaletoken) {
-  int i;
-  msFree(scaletoken->name);
-  for(i=0;i<scaletoken->n_entries;i++) {
-    freeScaleTokenEntry(&scaletoken->tokens[i]);
-  }
-  msFree(scaletoken->tokens);
-  return MS_SUCCESS;
-}
-
-int freeLayer(layerObj *layer)
-{
-  int i;
-  if (!layer) return MS_FAILURE;
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(layer) ) {
-    return MS_FAILURE;
-  }
-
-  if (layer->debug >= MS_DEBUGLEVEL_VVV)
-    msDebug("freeLayer(): freeing layer at %p.\n",layer);
-
-  if(msLayerIsOpen(layer))
-    msLayerClose(layer);
-
-  msFree(layer->name);
-  msFree(layer->encoding);
-  msFree(layer->group);
-  msFree(layer->data);
-  msFree(layer->classitem);
-  msFree(layer->labelitem);
-  msFree(layer->header);
-  msFree(layer->footer);
-  msFree(layer->template);
-  msFree(layer->tileindex);
-  msFree(layer->tileitem);
-  msFree(layer->tilesrs);
-  msFree(layer->bandsitem);
-  msFree(layer->plugin_library);
-  msFree(layer->plugin_library_original);
-  msFree(layer->connection);
-  msFree(layer->vtable);
-  msFree(layer->classgroup);
-
-  msProjectDestroyReprojector(layer->reprojectorLayerToMap);
-  msProjectDestroyReprojector(layer->reprojectorMapToLayer);
-  msFreeProjection(&(layer->projection));
-  msFreeExpression(&layer->_geomtransform);
-
-  freeCluster(&layer->cluster);
-
-  for(i=0; i<layer->maxclasses; i++) {
-    if (layer->class[i] != NULL) {
-      layer->class[i]->layer=NULL;
-      if ( freeClass(layer->class[i]) == MS_SUCCESS ) {
-        msFree(layer->class[i]);
-      }
-    }
-  }
-  msFree(layer->class);
-
-  if(layer->numscaletokens>0) {
-    for(i=0;i<layer->numscaletokens;i++) {
-      freeScaleToken(&layer->scaletokens[i]);
-    }
-    msFree(layer->scaletokens);
-  }
-
-  if(layer->features)
-    freeFeatureList(layer->features);
-
-  if(layer->resultcache) {
-    cleanupResultCache(layer->resultcache);
-    msFree(layer->resultcache);
-  }
-
-  msFree(layer->styleitem);
-
-  msFree(layer->filteritem);
-  msFreeExpression(&(layer->filter));
-
-  msFree(layer->requires);
-  msFree(layer->labelrequires);
-
-  if(&(layer->metadata)) msFreeHashItems(&(layer->metadata));
-  if(&(layer->validation)) msFreeHashItems(&(layer->validation));
-  if(&(layer->bindvals))  msFreeHashItems(&layer->bindvals);
-
-  if(layer->numprocessing > 0)
-    msFreeCharArray(layer->processing, layer->numprocessing);
-
-  for(i=0; i<layer->numjoins; i++) /* each join */
-    freeJoin(&(layer->joins[i]));
-  msFree(layer->joins);
-  layer->numjoins = 0;
-
-  layer->classgroup = NULL;
-
-  msFree(layer->mask);
-  if(layer->maskimage) {
-    msFreeImage(layer->maskimage);
-  }
-
-  if(layer->compositer) {
-    freeLayerCompositer(layer->compositer);
-  }
-
-  if (layer->grid) {
-    freeGrid(layer->grid);
-    msFree(layer->grid);
-  }
-
-  msFreeExpression(&(layer->utfdata));
-  msFree(layer->utfitem);
-
-  for(i=0;i<layer->sortBy.nProperties;i++)
-      msFree(layer->sortBy.properties[i].item);
-  msFree(layer->sortBy.properties);
-
-  if(&(layer->connectionoptions))  msFreeHashItems(&layer->connectionoptions);
-
-  return MS_SUCCESS;
-}
-
-/*
-** Ensure there is at least one free entry in the class array of this
-** layerObj. Grow the allocated class array if necessary and allocate
-** a new class for class[numclasses] if there is not already one,
-** setting its contents to all zero bytes (i.e. does not call initClass()
-** on it).
-**
-** This function is safe to use for the initial allocation of the class[]
-** array as well (i.e. when maxclasses==0 and class==NULL)
-**
-** Returns a reference to the new classObj on success, NULL on error.
-*/
-classObj *msGrowLayerClasses( layerObj *layer )
-{
-  /* Do we need to increase the size of class[] by  MS_CLASS_ALLOCSIZE?
-   */
-  if (layer->numclasses == layer->maxclasses) {
-    classObj **newClassPtr;
-    int i, newsize;
-
-    newsize = layer->maxclasses + MS_CLASS_ALLOCSIZE;
-
-    /* Alloc/realloc classes */
-    newClassPtr = (classObj**)realloc(layer->class,
-                                      newsize*sizeof(classObj*));
-    MS_CHECK_ALLOC(newClassPtr, newsize*sizeof(classObj*), NULL);
-
-    layer->class = newClassPtr;
-    layer->maxclasses = newsize;
-    for(i=layer->numclasses; i<layer->maxclasses; i++) {
-      layer->class[i] = NULL;
-    }
-  }
-
-  if (layer->class[layer->numclasses]==NULL) {
-    layer->class[layer->numclasses]=(classObj*)calloc(1,sizeof(classObj));
-    MS_CHECK_ALLOC(layer->class[layer->numclasses], sizeof(classObj), NULL);
-  }
-
-  return layer->class[layer->numclasses];
-}
-
-scaleTokenObj *msGrowLayerScaletokens( layerObj *layer )
-{
-  layer->scaletokens = msSmallRealloc(layer->scaletokens,(layer->numscaletokens+1)*sizeof(scaleTokenObj));
-  memset(&layer->scaletokens[layer->numscaletokens],0,sizeof(scaleTokenObj));
-  return &layer->scaletokens[layer->numscaletokens];
-}
-
-int loadScaletoken(scaleTokenObj *token, layerObj *layer) {
-  (void)layer;
-  for(;;) {
-    int stop = 0;
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadScaletoken()");
-        return(MS_FAILURE);
-      case(NAME):
-        if(getString(&token->name) == MS_FAILURE) return(MS_FAILURE);
-        break;
-      case(VALUES):
-         for(;;) {
-           if(stop) break;
-           switch(msyylex()) {
-             case(EOF):
-               msSetError(MS_EOFERR, NULL, "loadScaletoken()");
-               return(MS_FAILURE);
-             case(END):
-               stop = 1;
-               if(token->n_entries == 0) {
-                 msSetError(MS_PARSEERR,"Scaletoken (line:%d) has no VALUES defined","loadScaleToken()",msyylineno);
-                 return(MS_FAILURE);
-               }
-               token->tokens[token->n_entries-1].maxscale = DBL_MAX;
-               break;
-             case(MS_STRING):
-               /* we have a key */
-               token->tokens = msSmallRealloc(token->tokens,(token->n_entries+1)*sizeof(scaleTokenEntryObj));
-
-               if(1 != sscanf(msyystring_buffer,"%lf",&token->tokens[token->n_entries].minscale)) {
-                 msSetError(MS_PARSEERR, "failed to parse SCALETOKEN VALUE (%s):(line %d), expecting \"minscale\"", "loadScaletoken()",
-                         msyystring_buffer,msyylineno);
-                 return(MS_FAILURE);
-               }
-               if(token->n_entries == 0) {
-                 /* check supplied value was 0*/
-                 if(token->tokens[0].minscale != 0) {
-                  msSetError(MS_PARSEERR, "First SCALETOKEN VALUE (%s):(line %d) must be zero, expecting \"0\"", "loadScaletoken()",
-                         msyystring_buffer,msyylineno);
-                  return(MS_FAILURE);
-                 }
-               } else {
-                 /* set max scale of previous token */
-                 token->tokens[token->n_entries-1].maxscale = token->tokens[token->n_entries].minscale;
-               }
-               token->tokens[token->n_entries].value = NULL;
-               if(getString(&(token->tokens[token->n_entries].value)) == MS_FAILURE) return(MS_FAILURE);
-               token->n_entries++;
-               break;
-             default:
-               msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadScaletoken()",  msyystring_buffer, msyylineno );
-               return(MS_FAILURE);
-           }
-         }
-         break;
-      case(END):
-        if(!token->name || !*(token->name)) {
-          msSetError(MS_PARSEERR,"ScaleToken missing mandatory NAME entry (line %d)","loadScaleToken()",msyylineno);
-          return MS_FAILURE;
-        }
-        if(token->n_entries == 0) {
-          msSetError(MS_PARSEERR,"ScaleToken missing at least one VALUES entry (line %d)","loadScaleToken()",msyylineno);
-          return MS_FAILURE;
-        }
-        return MS_SUCCESS;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)", "loadScaletoken()",  msyystring_buffer, msyylineno );
-        return(MS_FAILURE);
-    }
-  } /* next token*/
-}
-
-int loadLayerCompositer(LayerCompositer *compositer) {
-  for(;;) {
-    switch(msyylex()) {
-      case COMPFILTER: {
-        CompositingFilter **filter = &compositer->filter;
-        while(*filter) {
-          filter = &((*filter)->next);
-        }
-        *filter = msSmallMalloc(sizeof(CompositingFilter));
-        initCompositingFilter(*filter);
-        if(getString(&((*filter)->filter)) == MS_FAILURE) return(MS_FAILURE);
-      }
-        break;
-      case COMPOP: {
-        char *compop=NULL;
-        if(getString(&compop) == MS_FAILURE) return(MS_FAILURE);
-        else if(!strcmp(compop,"clear"))
-          compositer->comp_op = MS_COMPOP_CLEAR;
-        else if(!strcmp(compop,"color-burn"))
-          compositer->comp_op = MS_COMPOP_COLOR_BURN;
-        else if(!strcmp(compop,"color-dodge"))
-          compositer->comp_op = MS_COMPOP_COLOR_DODGE;
-        else if(!strcmp(compop,"contrast"))
-          compositer->comp_op = MS_COMPOP_CONTRAST;
-        else if(!strcmp(compop,"darken"))
-          compositer->comp_op = MS_COMPOP_DARKEN;
-        else if(!strcmp(compop,"difference"))
-          compositer->comp_op = MS_COMPOP_DIFFERENCE;
-        else if(!strcmp(compop,"dst"))
-          compositer->comp_op = MS_COMPOP_DST;
-        else if(!strcmp(compop,"dst-atop"))
-          compositer->comp_op = MS_COMPOP_DST_ATOP;
-        else if(!strcmp(compop,"dst-in"))
-          compositer->comp_op = MS_COMPOP_DST_IN;
-        else if(!strcmp(compop,"dst-out"))
-          compositer->comp_op = MS_COMPOP_DST_OUT;
-        else if(!strcmp(compop,"dst-over"))
-          compositer->comp_op = MS_COMPOP_DST_OVER;
-        else if(!strcmp(compop,"exclusion"))
-          compositer->comp_op = MS_COMPOP_EXCLUSION;
-        else if(!strcmp(compop,"hard-light"))
-          compositer->comp_op = MS_COMPOP_HARD_LIGHT;
-        else if(!strcmp(compop,"invert"))
-          compositer->comp_op = MS_COMPOP_INVERT;
-        else if(!strcmp(compop,"invert-rgb"))
-          compositer->comp_op = MS_COMPOP_INVERT_RGB;
-        else if(!strcmp(compop,"lighten"))
-          compositer->comp_op = MS_COMPOP_LIGHTEN;
-        else if(!strcmp(compop,"minus"))
-          compositer->comp_op = MS_COMPOP_MINUS;
-        else if(!strcmp(compop,"multiply"))
-          compositer->comp_op = MS_COMPOP_MULTIPLY;
-        else if(!strcmp(compop,"overlay"))
-          compositer->comp_op = MS_COMPOP_OVERLAY;
-        else if(!strcmp(compop,"plus"))
-          compositer->comp_op = MS_COMPOP_PLUS;
-        else if(!strcmp(compop,"screen"))
-          compositer->comp_op = MS_COMPOP_SCREEN;
-        else if(!strcmp(compop,"soft-light"))
-          compositer->comp_op = MS_COMPOP_SOFT_LIGHT;
-        else if(!strcmp(compop,"src"))
-          compositer->comp_op = MS_COMPOP_SRC;
-        else if(!strcmp(compop,"src-atop"))
-          compositer->comp_op = MS_COMPOP_SRC_ATOP;
-        else if(!strcmp(compop,"src-in"))
-          compositer->comp_op = MS_COMPOP_SRC_IN;
-        else if(!strcmp(compop,"src-out"))
-          compositer->comp_op = MS_COMPOP_SRC_OUT;
-        else if(!strcmp(compop,"src-over"))
-          compositer->comp_op = MS_COMPOP_SRC_OVER;
-        else if(!strcmp(compop,"xor"))
-          compositer->comp_op = MS_COMPOP_XOR;
-        else {
-          msSetError(MS_PARSEERR,"Unknown COMPOP \"%s\"", "loadLayerCompositer()", compop);
-          free(compop);
-          return MS_FAILURE;
-        }
-        free(compop);
-      }
-        break;
-      case END:
-        return MS_SUCCESS;
-      case OPACITY:
-        if (getInteger(&(compositer->opacity), MS_NUM_CHECK_RANGE, 0, 100) == -1) {
-          msSetError(MS_PARSEERR,"OPACITY must be between 0 and 100 (line %d)","loadLayerCompositer()",msyylineno);
-          return MS_FAILURE;
-        }
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)", "loadLayerCompositer()",  msyystring_buffer, msyylineno );
-        return(MS_FAILURE);
-    }
-  }
-}
-int loadLayer(layerObj *layer, mapObj *map)
-{
-  int type;
-
-  layer->map = (mapObj *)map;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(BINDVALS):
-        if(loadHashTable(&(layer->bindvals)) != MS_SUCCESS) return(-1);
-        break;
-      case(CLASS):
-        if (msGrowLayerClasses(layer) == NULL)
-          return(-1);
-        initClass(layer->class[layer->numclasses]);
-        if(loadClass(layer->class[layer->numclasses], layer) == -1)
-        {
-            freeClass(layer->class[layer->numclasses]);
-            free(layer->class[layer->numclasses]);
-            layer->class[layer->numclasses] = NULL;
-            return(-1);
-        }
-        layer->numclasses++;
-        break;
-      case(CLUSTER):
-        if(loadCluster(&layer->cluster) == -1) return(-1);
-        break;
-      case(CLASSGROUP):
-        if(getString(&layer->classgroup) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(CLASSITEM):
-        if(getString(&layer->classitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(COMPOSITE): {
-        LayerCompositer *compositer = msSmallMalloc(sizeof(LayerCompositer));
-        initLayerCompositer(compositer);
-        if(MS_FAILURE == loadLayerCompositer(compositer)) {
-          freeLayerCompositer(compositer);
-          return -1;
-          }
-        if(!layer->compositer) {
-          layer->compositer = compositer;
-        } else {
-          LayerCompositer *lctmp = layer->compositer;
-          while(lctmp->next) lctmp = lctmp->next;
-          lctmp->next = compositer;
-        }
-        break;
-      }
-      case(CONNECTION):
-        if(getString(&layer->connection) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(CONNECTIONTYPE):
-        if((type = getSymbol(13, MS_OGR, MS_POSTGIS, MS_WMS, MS_ORACLESPATIAL, MS_WFS, MS_GRATICULE, MS_PLUGIN, MS_UNION, MS_UVRASTER, MS_CONTOUR, MS_KERNELDENSITY, MS_IDW, MS_FLATGEOBUF)) == -1) return(-1);
-        layer->connectiontype = type;
-        break;
-      case(DATA):
-        if(getString(&layer->data) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(DEBUG):
-        if((layer->debug = getSymbol(3, MS_ON,MS_OFF, MS_NUMBER)) == -1) return(-1);
-	if(layer->debug == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid DEBUG level, must be between 0 and 5 (line %d)", "loadLayer()", msyylineno);
-            return(-1);
-          }
-          layer->debug = (int) msyynumber;
-        }
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLayer()");
-        return(-1);
-        break;
-      case(ENCODING):
-        if(getString(&layer->encoding) == MS_FAILURE) return(-1);
-        break;
-      case(END):
-        if((int)layer->type == -1) {
-          msSetError(MS_MISCERR, "Layer type not set.", "loadLayer()");
-          return(-1);
-        }
-
-        return(0);
-        break;
-      case(EXTENT): {
-        if(getDouble(&(layer->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(layer->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(layer->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(layer->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if (!MS_VALID_EXTENT(layer->extent)) {
-          msSetError(MS_MISCERR, "Given layer extent is invalid. Check that it is in the form: minx, miny, maxx, maxy", "loadLayer()");
-          return(-1);
-        }
-        break;
-      }
-      case(FEATURE):
-        if((int)layer->type == -1) {
-          msSetError(MS_MISCERR, "Layer type must be set before defining inline features.", "loadLayer()");
-          return(-1);
-        }
-
-        if(layer->type == MS_LAYER_POLYGON)
-          type = MS_SHAPE_POLYGON;
-        else if(layer->type == MS_LAYER_LINE)
-          type = MS_SHAPE_LINE;
-        else
-          type = MS_SHAPE_POINT;
-
-        layer->connectiontype = MS_INLINE;
-
-        if(loadFeature(layer, type) == MS_FAILURE) return(-1);
-        break;
-      case(FILTER):
-        if(loadExpression(&(layer->filter)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(FILTERITEM):
-        if(getString(&layer->filteritem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(FOOTER):
-        if(getString(&layer->footer) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(GRID):
-        layer->connectiontype = MS_GRATICULE;
-        if (layer->grid) {
-          freeGrid(layer->grid);
-          msFree(layer->grid);
-        }
-        layer->grid = (void *) malloc(sizeof(graticuleObj));
-        MS_CHECK_ALLOC(layer->grid, sizeof(graticuleObj), -1);
-
-        initGrid(layer->grid);
-        loadGrid(layer);
-        break;
-      case(GROUP):
-        if(getString(&layer->group) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(GEOMTRANSFORM): {
-        int s;
-        if((s = getSymbol(1, MS_EXPRESSION)) == -1) return(MS_FAILURE);
-        /* handle expression case here for the moment */
-        msFree(layer->_geomtransform.string);
-        layer->_geomtransform.string = msStrdup(msyystring_buffer);
-        layer->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
-      }
-      break;
-      case(HEADER):
-        if(getString(&layer->header) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(JOIN):
-        if(layer->numjoins == MS_MAXJOINS) { /* no room */
-          msSetError(MS_IDENTERR, "Maximum number of joins reached.", "loadLayer()");
-          return(-1);
-        }
-
-        if(loadJoin(&(layer->joins[layer->numjoins])) == -1) {
-            freeJoin(&(layer->joins[layer->numjoins]));
-            return(-1);
-        }
-        layer->numjoins++;
-        break;
-      case(LABELCACHE):
-        if((layer->labelcache = getSymbol(2, MS_ON, MS_OFF)) == -1) return(-1);
-        break;
-      case(LABELITEM):
-        if(getString(&layer->labelitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(LABELMAXSCALE):
-      case(LABELMAXSCALEDENOM):
-        if(getDouble(&(layer->labelmaxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(LABELMINSCALE):
-      case(LABELMINSCALEDENOM):
-        if(getDouble(&(layer->labelminscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(LABELREQUIRES):
-        if(getString(&layer->labelrequires) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(LAYER):
-        break; /* for string loads */
-      case(MASK):
-        if(getString(&layer->mask) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(MAXFEATURES):
-        if(getInteger(&(layer->maxfeatures), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXSCALE):
-      case(MAXSCALEDENOM):
-        if(getDouble(&(layer->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MAXGEOWIDTH):
-        if(getDouble(&(layer->maxgeowidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(METADATA):
-        if(loadHashTable(&(layer->metadata)) != MS_SUCCESS) return(-1);
-        break;
-      case(MINSCALE):
-      case(MINSCALEDENOM):
-        if(getDouble(&(layer->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MINGEOWIDTH):
-        if(getDouble(&(layer->mingeowidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MINFEATURESIZE):
-        if(getInteger(&(layer->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(NAME):
-        if(getString(&layer->name) == MS_FAILURE) return(-1);
-        break;
-      case(OFFSITE):
-        if(loadColor(&(layer->offsite), NULL) != MS_SUCCESS) return(-1);
-        break;
-
-      case(CONNECTIONOPTIONS):
-        if(loadHashTable(&(layer->connectionoptions)) != MS_SUCCESS) return(-1);
-        break;
-      case(MS_PLUGIN): {
-        int rv;
-        if(map->config) { // value *must* represent a config key
-          char *value = NULL;
-          const char *plugin_library = NULL;
-
-          if(getString(&value) == MS_FAILURE) return(-1);
-          plugin_library = msConfigGetPlugin(map->config, value);
-          msFree(value);
-          if(!plugin_library) {
-            msSetError(MS_MISCERR, "Plugin value not found in config file. See mapserver.org/mapfile/config.html for more information." , "loadLayer()");
-            return(-1);
-          }
-          msFree(layer->plugin_library_original);
-          layer->plugin_library_original = strdup(plugin_library);
-        } else {
-          if(getString(&layer->plugin_library_original) == MS_FAILURE) return(-1);
-        }
-        rv = msBuildPluginLibraryPath(&layer->plugin_library, layer->plugin_library_original, map);
-        if (rv == MS_FAILURE) return(-1);
-      }
-      break;
-      case(PROCESSING): {
-        /* NOTE: processing array maintained as size+1 with NULL terminator.
-                 This ensure that CSL (GDAL string list) functions can be
-                 used on the list for easy processing. */
-        char *value=NULL;
-        if(getString(&value) == MS_FAILURE) return(-1);
-        msLayerAddProcessing( layer, value );
-        free(value);
-        value=NULL;
-      }
-      break;
-      case(POSTLABELCACHE):
-        if((layer->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1) return(-1);
-        if(layer->postlabelcache)
-          layer->labelcache = MS_OFF;
-        break;
-      case(PROJECTION):
-        if(loadProjection(&(layer->projection)) == -1) return(-1);
-        layer->project = MS_TRUE;
-        break;
-      case(REQUIRES):
-        if(getString(&layer->requires) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(SCALETOKEN):
-        if (msGrowLayerScaletokens(layer) == NULL)
-          return(-1);
-        initScaleToken(&layer->scaletokens[layer->numscaletokens]);
-        if(loadScaletoken(&layer->scaletokens[layer->numscaletokens], layer) == -1) {
-            freeScaleToken(&layer->scaletokens[layer->numscaletokens]);
-            return(-1);
-        }
-        layer->numscaletokens++;
-        break;
-      case(SIZEUNITS):
-        if((layer->sizeunits = getSymbol(8, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD,MS_PIXELS)) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((layer->status = getSymbol(3, MS_ON,MS_OFF,MS_DEFAULT)) == -1) return(-1);
-        break;
-      case(STYLEITEM):
-        if(getString(&layer->styleitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(SYMBOLSCALE):
-      case(SYMBOLSCALEDENOM):
-        if(getDouble(&(layer->symbolscaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&layer->template) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TILEINDEX):
-        if(getString(&layer->tileindex) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TILEITEM):
-        if(getString(&layer->tileitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TILESRS):
-        if(getString(&layer->tilesrs) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TOLERANCE):
-        if(getDouble(&(layer->tolerance), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(TOLERANCEUNITS):
-        if((layer->toleranceunits = getSymbol(8, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD,MS_PIXELS)) == -1) return(-1);
-        break;
-      case(TRANSFORM):
-        if((layer->transform = getSymbol(11, MS_TRUE,MS_FALSE, MS_UL,MS_UC,MS_UR,MS_CL,MS_CC,MS_CR,MS_LL,MS_LC,MS_LR)) == -1) return(-1);
-        break;
-      case(TYPE):
-        if((type = getSymbol(9, MS_LAYER_POINT,MS_LAYER_LINE,MS_LAYER_RASTER,MS_LAYER_POLYGON,MS_LAYER_ANNOTATION,MS_LAYER_QUERY,MS_LAYER_CIRCLE,MS_LAYER_CHART,TILEINDEX)) == -1) return(-1);
-        if(type == TILEINDEX) type = MS_LAYER_TILEINDEX; /* TILEINDEX is also a parameter */
-        if(type == MS_LAYER_ANNOTATION) {
-          msSetError(MS_IDENTERR, "Annotation Layers have been removed. To obtain same functionality, use a layer with label->styles and no class->styles", "loadLayer()");
-          return -1;
-        }
-        layer->type = type;
-        break;
-      case(UNITS):
-        if((layer->units = getSymbol(9, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD,MS_PIXELS,MS_PERCENTAGES)) == -1) return(-1);
-        break;
-      case(UTFDATA):
-        if(loadExpression(&(layer->utfdata)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(UTFITEM):
-        if(getString(&layer->utfitem) == MS_FAILURE) return(-1);
-        break;
-      case(VALIDATION):
-        if(loadHashTable(&(layer->validation)) != MS_SUCCESS) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLayer()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  } /* next token */
-}
-
-int msUpdateLayerFromString(layerObj *layer, char *string)
-{
-  int i;
-
-  if(!layer || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadLayer(layer, layer->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-
-  /* step through classes to resolve symbol names */
-  for(i=0; i<layer->numclasses; i++) {
-    if(classResolveSymbolNames(layer->class[i]) != MS_SUCCESS) return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-static void writeCompositingFilter(FILE *stream, int indent, CompositingFilter *filter) {
-  while(filter) {
-    writeString(stream, indent, "COMPFILTER", "", filter->filter);
-    filter = filter->next;
-  }
-}
-
-static void writeLayerCompositer(FILE *stream, int indent, LayerCompositer *compositor) {
-  indent++;
-  while(compositor) {
-    writeBlockBegin(stream, indent, "COMPOSITE");
-    writeCompositingFilter(stream, indent, compositor->filter);
-    if(compositor->comp_op != MS_COMPOP_SRC_OVER) {
-      switch(compositor->comp_op) {
-        case MS_COMPOP_CLEAR:
-          writeString(stream, indent, "COMPOP", NULL, "clear");
-          break;
-        case MS_COMPOP_COLOR_BURN:
-          writeString(stream, indent, "COMPOP", NULL, "color-burn");
-          break;
-        case MS_COMPOP_COLOR_DODGE:
-          writeString(stream, indent, "COMPOP", NULL, "color-dodge");
-          break;
-        case MS_COMPOP_CONTRAST:
-          writeString(stream, indent, "COMPOP", NULL, "contrast");
-          break;
-        case MS_COMPOP_DARKEN:
-          writeString(stream, indent, "COMPOP", NULL, "darken");
-          break;
-        case MS_COMPOP_DIFFERENCE:
-          writeString(stream, indent, "COMPOP", NULL, "difference");
-          break;
-        case MS_COMPOP_DST:
-          writeString(stream, indent, "COMPOP", NULL, "dst");
-          break;
-        case MS_COMPOP_DST_ATOP:
-          writeString(stream, indent, "COMPOP", NULL, "dst-atop");
-          break;
-        case MS_COMPOP_DST_IN:
-          writeString(stream, indent, "COMPOP", NULL, "dst-in");
-          break;
-        case MS_COMPOP_DST_OUT:
-          writeString(stream, indent, "COMPOP", NULL, "dst-out");
-          break;
-        case MS_COMPOP_DST_OVER:
-          writeString(stream, indent, "COMPOP", NULL, "dst-over");
-          break;
-        case MS_COMPOP_EXCLUSION:
-          writeString(stream, indent, "COMPOP", NULL, "exclusion");
-          break;
-        case MS_COMPOP_HARD_LIGHT:
-          writeString(stream, indent, "COMPOP", NULL, "hard-light");
-          break;
-        case MS_COMPOP_INVERT:
-          writeString(stream, indent, "COMPOP", NULL, "invert");
-          break;
-        case MS_COMPOP_INVERT_RGB:
-          writeString(stream, indent, "COMPOP", NULL, "invert-rgb");
-          break;
-        case MS_COMPOP_LIGHTEN:
-          writeString(stream, indent, "COMPOP", NULL, "lighten");
-          break;
-        case MS_COMPOP_MINUS:
-          writeString(stream, indent, "COMPOP", NULL, "minus");
-          break;
-        case MS_COMPOP_MULTIPLY:
-          writeString(stream, indent, "COMPOP", NULL, "multiply");
-          break;
-        case MS_COMPOP_OVERLAY:
-          writeString(stream, indent, "COMPOP", NULL, "overlay");
-          break;
-        case MS_COMPOP_PLUS:
-          writeString(stream, indent, "COMPOP", NULL, "plus");
-          break;
-        case MS_COMPOP_SCREEN:
-          writeString(stream, indent, "COMPOP", NULL, "screen");
-          break;
-        case MS_COMPOP_SOFT_LIGHT:
-          writeString(stream, indent, "COMPOP", NULL, "soft-light");
-          break;
-        case MS_COMPOP_SRC:
-          writeString(stream, indent, "COMPOP", NULL, "src");
-          break;
-        case MS_COMPOP_SRC_ATOP:
-          writeString(stream, indent, "COMPOP", NULL, "src-atop");
-          break;
-        case MS_COMPOP_SRC_IN:
-          writeString(stream, indent, "COMPOP", NULL, "src-in");
-          break;
-        case MS_COMPOP_SRC_OUT:
-          writeString(stream, indent, "COMPOP", NULL, "src-out");
-          break;
-        case MS_COMPOP_SRC_OVER:
-          writeString(stream, indent, "COMPOP", NULL, "src-over");
-          break;
-        case MS_COMPOP_XOR:
-          writeString(stream, indent, "COMPOP", NULL, "xor");
-          break;
-      }
-    }
-    writeNumber(stream,indent,"OPACITY",100,compositor->opacity);
-    writeBlockEnd(stream,indent,"COMPOSITE");
-    compositor = compositor->next;
-  }
-}
-static void writeLayer(FILE *stream, int indent, layerObj *layer)
-{
-  int i;
-  featureListNodeObjPtr current=NULL;
-
-  if(layer->status == MS_DELETE)
-    return;
-
-  indent++;
-  writeBlockBegin(stream, indent, "LAYER");
-  writeHashTable(stream, indent, "BINDVALS", &(layer->bindvals));
-  /* class - see below */
-  writeString(stream, indent, "CLASSGROUP", NULL, layer->classgroup);
-  writeString(stream, indent, "CLASSITEM", NULL, layer->classitem);
-  writeCluster(stream, indent, &(layer->cluster));
-  writeLayerCompositer(stream, indent, layer->compositer);
-  writeString(stream, indent, "CONNECTION", NULL, layer->connection);
-  writeKeyword(stream, indent, "CONNECTIONTYPE", layer->connectiontype, 12, MS_OGR, "OGR", MS_POSTGIS, "POSTGIS", MS_WMS, "WMS", MS_ORACLESPATIAL, "ORACLESPATIAL", MS_WFS, "WFS", MS_PLUGIN, "PLUGIN", MS_UNION, "UNION", MS_UVRASTER, "UVRASTER", MS_CONTOUR, "CONTOUR", MS_KERNELDENSITY, "KERNELDENSITY", MS_IDW, "IDW", MS_FLATGEOBUF, "FLATGEOBUF");
-  writeHashTable(stream, indent, "CONNECTIONOPTIONS", &(layer->connectionoptions));
-  writeString(stream, indent, "DATA", NULL, layer->data);
-  writeNumber(stream, indent, "DEBUG", 0, layer->debug); /* is this right? see loadLayer() */
-  writeString(stream, indent, "ENCODING", NULL, layer->encoding);
-  writeExtent(stream, indent, "EXTENT", layer->extent);
-  writeExpression(stream, indent, "FILTER", &(layer->filter));
-  writeString(stream, indent, "FILTERITEM", NULL, layer->filteritem);
-  writeString(stream, indent, "FOOTER", NULL, layer->footer);
-  writeString(stream, indent, "GROUP", NULL, layer->group);
-
-  if(layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
-    writeIndent(stream, indent + 1);
-    fprintf(stream, "GEOMTRANSFORM (%s)\n", layer->_geomtransform.string);
-  }
-
-  writeString(stream, indent, "HEADER", NULL, layer->header);
-  /* join - see below */
-  writeKeyword(stream, indent, "LABELCACHE", layer->labelcache, 1, MS_OFF, "OFF");
-  writeString(stream, indent, "LABELITEM", NULL, layer->labelitem);
-  writeNumber(stream, indent, "LABELMAXSCALEDENOM", -1, layer->labelmaxscaledenom);
-  writeNumber(stream, indent, "LABELMINSCALEDENOM", -1, layer->labelminscaledenom);
-  writeString(stream, indent, "LABELREQUIRES", NULL, layer->labelrequires);
-  writeNumber(stream, indent, "MAXFEATURES", -1, layer->maxfeatures);
-  writeNumber(stream, indent, "MAXGEOWIDTH", -1, layer->maxgeowidth);
-  writeNumber(stream, indent, "MAXSCALEDENOM", -1, layer->maxscaledenom);
-  writeString(stream, indent, "MASK", NULL, layer->mask);
-  writeHashTable(stream, indent, "METADATA", &(layer->metadata));
-  writeNumber(stream, indent, "MINGEOWIDTH", -1, layer->mingeowidth);
-  writeNumber(stream, indent, "MINSCALEDENOM", -1, layer->minscaledenom);
-  writeNumber(stream, indent, "MINFEATURESIZE", -1, layer->minfeaturesize);
-  writeString(stream, indent, "NAME", NULL, layer->name);
-  writeColor(stream, indent, "OFFSITE", NULL, &(layer->offsite));
-  writeString(stream, indent, "PLUGIN", NULL, layer->plugin_library_original);
-  writeKeyword(stream, indent, "POSTLABELCACHE", layer->postlabelcache, 1, MS_TRUE, "TRUE");
-  for(i=0; i<layer->numprocessing; i++)
-    writeString(stream, indent, "PROCESSING", NULL, layer->processing[i]);
-  writeProjection(stream, indent, &(layer->projection));
-  writeString(stream, indent, "REQUIRES", NULL, layer->requires);
-  writeKeyword(stream, indent, "SIZEUNITS", layer->sizeunits, 7, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
-  writeKeyword(stream, indent, "STATUS", layer->status, 3, MS_ON, "ON", MS_OFF, "OFF", MS_DEFAULT, "DEFAULT");
-  writeString(stream, indent, "STYLEITEM", NULL, layer->styleitem);
-  writeNumber(stream, indent, "SYMBOLSCALEDENOM", -1, layer->symbolscaledenom);
-  writeString(stream, indent, "TEMPLATE", NULL, layer->template);
-  writeString(stream, indent, "TILEINDEX", NULL, layer->tileindex);
-  writeString(stream, indent, "TILEITEM", NULL, layer->tileitem);
-  writeString(stream, indent, "TILESRS", NULL, layer->tilesrs);
-  writeNumber(stream, indent, "TOLERANCE", -1, layer->tolerance);
-  writeKeyword(stream, indent, "TOLERANCEUNITS", layer->toleranceunits, 7, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
-  writeKeyword(stream, indent, "TRANSFORM", layer->transform, 10, MS_FALSE, "FALSE", MS_UL, "UL", MS_UC, "UC", MS_UR, "UR", MS_CL, "CL", MS_CC, "CC", MS_CR, "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR");
-  writeKeyword(stream, indent, "TYPE", layer->type, 9, MS_LAYER_POINT, "POINT", MS_LAYER_LINE, "LINE", MS_LAYER_POLYGON, "POLYGON", MS_LAYER_RASTER, "RASTER", MS_LAYER_ANNOTATION, "ANNOTATION", MS_LAYER_QUERY, "QUERY", MS_LAYER_CIRCLE, "CIRCLE", MS_LAYER_TILEINDEX, "TILEINDEX", MS_LAYER_CHART, "CHART");
-  writeKeyword(stream, indent, "UNITS", layer->units, 9, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD", MS_PIXELS, "PIXELS", MS_PERCENTAGES, "PERCENTATGES");
-  writeExpression(stream, indent, "UTFDATA", &(layer->utfdata));
-  writeString(stream, indent, "UTFITEM", NULL, layer->utfitem);
-  writeHashTable(stream, indent, "VALIDATION", &(layer->validation));
-
-  /* write potentially multiply occuring objects last */
-  for(i=0; i<layer->numscaletokens; i++)  writeScaleToken(stream, indent, &(layer->scaletokens[i]));
-  for(i=0; i<layer->numjoins; i++)  writeJoin(stream, indent, &(layer->joins[i]));
-  for(i=0; i<layer->numclasses; i++) writeClass(stream, indent, layer->class[i]);
-
-  if( layer->grid &&  layer->connectiontype == MS_GRATICULE)
-    writeGrid(stream, indent, layer->grid);
-  else {
-    current = layer->features;
-    while(current != NULL) {
-      writeFeature(stream, indent, &(current->shape));
-      current = current->next;
-    }
-  }
-
-  writeBlockEnd(stream, indent, "LAYER");
-  writeLineFeed(stream);
-}
-
-char* msWriteLayerToString(layerObj *layer)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeLayer(stdout, -1, layer);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-/*
-** Initialize, load and free a referenceMapObj structure
-*/
-void initReferenceMap(referenceMapObj *ref)
-{
-  ref->height = ref->width = 0;
-  ref->extent.minx = ref->extent.miny = ref->extent.maxx = ref->extent.maxy = -1.0;
-  ref->image = NULL;
-  MS_INIT_COLOR(ref->color, 255, 0, 0, 255);
-  MS_INIT_COLOR(ref->outlinecolor, 0, 0, 0, 255);
-  ref->status = MS_OFF;
-  ref->marker = 0;
-  ref->markername = NULL;
-  ref->markersize = 0;
-  ref->minboxsize = 3;
-  ref->maxboxsize = 0;
-  ref->map = NULL;
-}
-
-void freeReferenceMap(referenceMapObj *ref)
-{
-  msFree(ref->image);
-  msFree(ref->markername);
-}
-
-int loadReferenceMap(referenceMapObj *ref, mapObj *map)
-{
-  int state;
-
-  ref->map = (mapObj *)map;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadReferenceMap()");
-        return(-1);
-      case(END):
-        if(!ref->image) {
-          msSetError(MS_MISCERR, "No image defined for the reference map.", "loadReferenceMap()");
-          return(-1);
-        }
-        if(ref->width == 0 || ref->height == 0) {
-          msSetError(MS_MISCERR, "No image size defined for the reference map.", "loadReferenceMap()");
-          return(-1);
-        }
-        return(0);
-        break;
-      case(COLOR):
-        if(loadColor(&(ref->color), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(EXTENT):
-        if(getDouble(&(ref->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(ref->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(ref->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(ref->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if (!MS_VALID_EXTENT(ref->extent)) {
-          msSetError(MS_MISCERR, "Given reference extent is invalid. Check that it " \
-                     "is in the form: minx, miny, maxx, maxy", "loadReferenceMap()");
-          return(-1);
-        }
-        break;
-      case(IMAGE):
-        if(getString(&ref->image) == MS_FAILURE) return(-1);
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(ref->outlinecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(SIZE):
-        if(getInteger(&(ref->width), MS_NUM_CHECK_RANGE, 5, ref->map->maxsize) == -1) return(-1); // is 5 reasonable?
-        if(getInteger(&(ref->height), MS_NUM_CHECK_RANGE, 5, ref->map->maxsize) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((ref->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(MARKER):
-        if((state = getSymbol(2, MS_NUMBER,MS_STRING)) == -1) return(-1);
-
-        if(state == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid MARKER, must be greater than 0 (line %d)", "loadReferenceMap()", msyylineno);
-            return(-1);
-          }
-          ref->marker = (int) msyynumber;
-        } else {
-          if (ref->markername != NULL)
-            msFree(ref->markername);
-          ref->markername = msStrdup(msyystring_buffer);
-        }
-        break;
-      case(MARKERSIZE):
-        if(getInteger(&(ref->markersize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MINBOXSIZE):
-        if(getInteger(&(ref->minboxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXBOXSIZE):
-        if(getInteger(&(ref->maxboxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(REFERENCE):
-        break; /* for string loads */
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadReferenceMap()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  } /* next token */
-}
-
-int msUpdateReferenceMapFromString(referenceMapObj *ref, char *string)
-{
-  if(!ref || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadReferenceMap(ref, ref->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-static void writeReferenceMap(FILE *stream, int indent, referenceMapObj *ref)
-{
-  colorObj c;
-
-  if(!ref->image) return;
-
-  indent++;
-  writeBlockBegin(stream, indent, "REFERENCE");
-  MS_INIT_COLOR(c,255,0,0,255);
-  writeColor(stream, indent, "COLOR", &c, &(ref->color));
-  writeExtent(stream, indent, "EXTENT", ref->extent);
-  writeString(stream, indent, "IMAGE", NULL, ref->image);
-  MS_INIT_COLOR(c,0,0,0,255);
-  writeColor(stream, indent, "OUTLINECOLOR", &c, &(ref->outlinecolor));
-  writeDimension(stream, indent, "SIZE", ref->width, ref->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", ref->status, 2, MS_ON, "ON", MS_OFF, "OFF");
-  writeNumberOrString(stream, indent, "MARKER", 0, ref->marker, ref->markername);
-  writeNumber(stream, indent, "MARKERSIZE", -1, ref->markersize);
-  writeNumber(stream, indent, "MAXBOXSIZE", -1, ref->maxboxsize);
-  writeNumber(stream, indent, "MINBOXSIZE", -1, ref->minboxsize);
-  writeBlockEnd(stream, indent, "REFERENCE");
-  writeLineFeed(stream);
-}
-
-char* msWriteReferenceMapToString(referenceMapObj *ref)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeReferenceMap(stdout, -1, ref);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-#define MAX_FORMATOPTIONS 100
-
-static int loadOutputFormat(mapObj *map)
-{
-  char *name = NULL;
-  char *mimetype = NULL;
-  char *driver = NULL;
-  char *extension = NULL;
-  int imagemode = MS_NOOVERRIDE;
-  int transparent = MS_NOOVERRIDE;
-  char *formatoptions[MAX_FORMATOPTIONS];
-  int  numformatoptions = 0;
-  char *value = NULL;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadOutputFormat()");
-        goto load_output_error;
-
-      case(END): {
-        outputFormatObj *format;
-
-        if( driver == NULL ) {
-          msSetError(MS_MISCERR,
-                     "OUTPUTFORMAT clause lacks DRIVER keyword near (%s):(%d)",
-                     "loadOutputFormat()",
-                     msyystring_buffer, msyylineno );
-          goto load_output_error;
-        }
-
-        format = msCreateDefaultOutputFormat( map, driver, name, NULL );
-        if( format == NULL ) {
-          msSetError(MS_MISCERR,
-                     "OUTPUTFORMAT (%s) clause references driver (%s), but this driver isn't configured.",
-                     "loadOutputFormat()", name, driver );
-          goto load_output_error;
-        }
-        msFree( name );
-        name = NULL;
-        msFree( driver );
-        driver = NULL;
-
-        if( transparent != MS_NOOVERRIDE )
-          format->transparent = transparent;
-        if( extension != NULL ) {
-          msFree( format->extension );
-          format->extension = extension;
-          extension = NULL;
-        }
-        if( mimetype != NULL ) {
-          msFree( format->mimetype );
-          format->mimetype = mimetype;
-          mimetype = NULL;
-        }
-        if( imagemode != MS_NOOVERRIDE ) {
-          if(format->renderer != MS_RENDER_WITH_AGG || imagemode != MS_IMAGEMODE_PC256) {
-            /* don't force to PC256 with agg, this can happen when using mapfile defined GD
-             * outputformats that are now falling back to agg/png8
-             */
-            format->imagemode = imagemode;
-          }
-
-          if( transparent == MS_NOOVERRIDE ) {
-            if( imagemode == MS_IMAGEMODE_RGB  )
-              format->transparent = MS_FALSE;
-            else if( imagemode == MS_IMAGEMODE_RGBA  )
-              format->transparent = MS_TRUE;
-          }
-          if( format->imagemode == MS_IMAGEMODE_INT16
-              || format->imagemode == MS_IMAGEMODE_FLOAT32
-              || format->imagemode == MS_IMAGEMODE_BYTE )
-            format->renderer = MS_RENDER_WITH_RAWDATA;
-        }
-        while(numformatoptions--) {
-          char *key = strchr(formatoptions[numformatoptions],'=');
-          if(!key || !*(key+1)) {
-            msSetError(MS_MISCERR,"Failed to parse FORMATOPTION, expecting \"KEY=VALUE\" syntax.","loadOutputFormat()");
-            goto load_output_error;
-          }
-          *key = 0;
-          key++;
-          msSetOutputFormatOption(format,formatoptions[numformatoptions],key);
-          free(formatoptions[numformatoptions]);
-        }
-
-        format->inmapfile = MS_TRUE;
-
-        msOutputFormatValidate( format, MS_FALSE );
-        return(0);
-      }
-      case(NAME):
-        msFree( name );
-        if((name = getToken()) == NULL)
-          goto load_output_error;
-        break;
-      case(MIMETYPE):
-        if(getString(&mimetype) == MS_FAILURE)
-          goto load_output_error;
-        break;
-      case(DRIVER): {
-        int s;
-        if((s = getSymbol(2, MS_STRING, TEMPLATE)) == -1) /* allow the template to be quoted or not in the mapfile */
-          goto load_output_error;
-        free(driver);
-        if(s == MS_STRING)
-          driver = msStrdup(msyystring_buffer);
-        else
-          driver = msStrdup("TEMPLATE");
-      }
-      break;
-      case(EXTENSION):
-        if(getString(&extension) == MS_FAILURE)
-          goto load_output_error;
-        if( extension[0] == '.' ) {
-          char *temp = msStrdup(extension+1);
-          free( extension );
-          extension = temp;
-        }
-        break;
-      case(FORMATOPTION):
-        if(getString(&value) == MS_FAILURE)
-          goto load_output_error;
-        if( numformatoptions < MAX_FORMATOPTIONS )
-          formatoptions[numformatoptions++] = value;
-        value=NULL;
-        break;
-      case(IMAGEMODE):
-        value = getToken();
-        if( strcasecmp(value,"PC256") == 0 )
-          imagemode = MS_IMAGEMODE_PC256;
-        else if( strcasecmp(value,"RGB") == 0 )
-          imagemode = MS_IMAGEMODE_RGB;
-        else if( strcasecmp(value,"RGBA") == 0)
-          imagemode = MS_IMAGEMODE_RGBA;
-        else if( strcasecmp(value,"INT16") == 0)
-          imagemode = MS_IMAGEMODE_INT16;
-        else if( strcasecmp(value,"FLOAT32") == 0)
-          imagemode = MS_IMAGEMODE_FLOAT32;
-        else if( strcasecmp(value,"BYTE") == 0)
-          imagemode = MS_IMAGEMODE_BYTE;
-        else if( strcasecmp(value,"FEATURE") == 0)
-          imagemode = MS_IMAGEMODE_FEATURE;
-        else {
-          msSetError(MS_IDENTERR,
-                     "Parsing error near (%s):(line %d), expected PC256, RGB, RGBA, FEATURE, BYTE, INT16, or FLOAT32 for IMAGEMODE.", "loadOutputFormat()",
-                     msyystring_buffer, msyylineno);
-          goto load_output_error;
-        }
-        free(value);
-        value=NULL;
-        break;
-      case(TRANSPARENT):
-        if((transparent = getSymbol(2, MS_ON,MS_OFF)) == -1)
-          goto load_output_error;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadOutputFormat()",
-                   msyystring_buffer, msyylineno);
-        goto load_output_error;
-    }
-  } /* next token */
-load_output_error:
-  msFree( driver );
-  msFree( extension );
-  msFree( mimetype );
-  msFree( name );
-  msFree( value );
-  return -1;
-}
-
-/*
-** utility function to write an output format structure to file
-*/
-static void writeOutputformatobject(FILE *stream, int indent, outputFormatObj *outputformat)
-{
-  int i = 0;
-  if(!outputformat) return;
-
-  indent++;
-  writeBlockBegin(stream, indent, "OUTPUTFORMAT");
-  writeString(stream, indent, "NAME", NULL, outputformat->name);
-  writeString(stream, indent, "MIMETYPE", NULL, outputformat->mimetype);
-  writeString(stream, indent, "DRIVER", NULL, outputformat->driver);
-  writeString(stream, indent, "EXTENSION", NULL, outputformat->extension);
-  writeKeyword(stream, indent, "IMAGEMODE", outputformat->imagemode, 7, MS_IMAGEMODE_PC256, "PC256", MS_IMAGEMODE_RGB, "RGB", MS_IMAGEMODE_RGBA, "RGBA", MS_IMAGEMODE_INT16, "INT16", MS_IMAGEMODE_FLOAT32, "FLOAT32", MS_IMAGEMODE_BYTE, "BYTE", MS_IMAGEMODE_FEATURE, "FEATURE");
-  writeKeyword(stream, indent, "TRANSPARENT", outputformat->transparent, 2, MS_TRUE, "TRUE", MS_FALSE, "FALSE");
-  for (i=0; i<outputformat->numformatoptions; i++)
-    writeString(stream, indent, "FORMATOPTION", NULL, outputformat->formatoptions[i]);
-  writeBlockEnd(stream, indent, "OUTPUTFORMAT");
-  writeLineFeed(stream);
-}
-
-
-/*
-** Write the output formats to file
-*/
-static void writeOutputformat(FILE *stream, int indent, mapObj *map)
-{
-  int i=0;
-  if(!map->outputformat) return;
-
-  writeOutputformatobject(stream, indent, map->outputformat);
-  for(i=0; i<map->numoutputformats; i++) {
-    if(map->outputformatlist[i]->inmapfile == MS_TRUE && strcmp(map->outputformatlist[i]->name, map->outputformat->name) != 0)
-      writeOutputformatobject(stream, indent, map->outputformatlist[i]);
-  }
-}
-
-/*
-** Initialize, load and free a legendObj structure
-*/
-void initLegend(legendObj *legend)
-{
-  legend->height = legend->width = 0;
-  MS_INIT_COLOR(legend->imagecolor, 255,255,255,255); /* white */
-  MS_INIT_COLOR(legend->outlinecolor, -1,-1,-1,255);
-  initLabel(&legend->label);
-  legend->label.position = MS_XY; /* override */
-  legend->keysizex = 20;
-  legend->keysizey = 10;
-  legend->keyspacingx = 5;
-  legend->keyspacingy = 5;
-  legend->status = MS_OFF;
-  legend->transparent = MS_NOOVERRIDE;
-  legend->position = MS_LL;
-  legend->postlabelcache = MS_FALSE; /* draw with labels */
-  legend->template = NULL;
-  legend->map = NULL;
-}
-
-void freeLegend(legendObj *legend)
-{
-  if (legend->template)
-    free(legend->template);
-  freeLabel(&(legend->label));
-}
-
-int loadLegend(legendObj *legend, mapObj *map)
-{
-  legend->map = (mapObj *)map;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLegend()");
-        return(-1);
-      case(END):
-        legend->label.position = MS_XY; /* overrides go here */
-        return(0);
-        break;
-      case(IMAGECOLOR):
-        if(loadColor(&(legend->imagecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(KEYSIZE):
-        if(getInteger(&(legend->keysizex), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1) return(-1);
-        if(getInteger(&(legend->keysizey), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1) return(-1);
-        break;
-      case(KEYSPACING):
-        if(getInteger(&(legend->keyspacingx), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1) return(-1);
-        if(getInteger(&(legend->keyspacingy), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1) return(-1);
-        break;
-      case(LABEL):
-        if(loadLabel(&(legend->label)) == -1) return(-1);
-        legend->label.angle = 0; /* force */
-        break;
-      case(LEGEND):
-        break; /* for string loads */
-      case(OUTLINECOLOR):
-        if(loadColor(&(legend->outlinecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(POSITION):
-        if((legend->position = getSymbol(6, MS_UL,MS_UR,MS_LL,MS_LR,MS_UC,MS_LC)) == -1) return(-1);
-        break;
-      case(POSTLABELCACHE):
-        if((legend->postlabelcache = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((legend->status = getSymbol(3, MS_ON,MS_OFF,MS_EMBED)) == -1) return(-1);
-        break;
-      case(TRANSPARENT):
-        if((legend->transparent = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&legend->template) == MS_FAILURE) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLegend()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  } /* next token */
-}
-
-int msUpdateLegendFromString(legendObj *legend, char *string)
-{
-  if(!legend || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadLegend(legend, legend->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-static void writeLegend(FILE *stream, int indent, legendObj *legend)
-{
-  colorObj c;
-
-  indent++;
-  writeBlockBegin(stream, indent, "LEGEND");
-  MS_INIT_COLOR(c,255,255,255,255);
-  writeColor(stream, indent, "IMAGECOLOR", &c, &(legend->imagecolor));
-  writeDimension(stream, indent, "KEYSIZE", legend->keysizex, legend->keysizey, NULL, NULL);
-  writeDimension(stream, indent, "KEYSPACING", legend->keyspacingx, legend->keyspacingy, NULL, NULL);
-  writeLabel(stream, indent, &(legend->label));
-  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(legend->outlinecolor));
-  if(legend->status == MS_EMBED) writeKeyword(stream, indent, "POSITION", legend->position, 6, MS_LL, "LL", MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC, "LC");
-  writeKeyword(stream, indent, "POSTLABELCACHE", legend->postlabelcache, 1, MS_TRUE, "TRUE");
-  writeKeyword(stream, indent, "STATUS", legend->status, 3, MS_ON, "ON", MS_OFF, "OFF", MS_EMBED, "EMBED");
-  writeKeyword(stream, indent, "TRANSPARENT", legend->transparent, 2, MS_TRUE, "TRUE", MS_FALSE, "FALSE");
-  writeString(stream, indent, "TEMPLATE", NULL, legend->template);
-  writeBlockEnd(stream, indent, "LEGEND");
-  writeLineFeed(stream);
-}
-
-char* msWriteLegendToString(legendObj *legend)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeLegend(stdout, -1, legend);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-/*
-** Initialize, load and free a scalebarObj structure
-*/
-void initScalebar(scalebarObj *scalebar)
-{
-  MS_INIT_COLOR(scalebar->imagecolor, -1,-1,-1,255);
-  scalebar->width = 200;
-  scalebar->height = 3;
-  scalebar->style = 0; /* only 2 styles at this point */
-  scalebar->intervals = 4;
-  initLabel(&scalebar->label);
-  scalebar->label.position = MS_XY; /* override */
-  MS_INIT_COLOR(scalebar->backgroundcolor, -1,-1,-1,255);  /* if not set, scalebar creation needs to set this to match the background color */
-  MS_INIT_COLOR(scalebar->color, 0,0,0,255); /* default to black */
-  MS_INIT_COLOR(scalebar->outlinecolor, -1,-1,-1,255);
-  scalebar->units = MS_MILES;
-  scalebar->status = MS_OFF;
-  scalebar->position = MS_LL;
-  scalebar->transparent = MS_NOOVERRIDE; /* no transparency */
-  scalebar->postlabelcache = MS_FALSE; /* draw with labels */
-  scalebar->align = MS_ALIGN_CENTER;
-  scalebar->offsetx = 0;
-  scalebar->offsety = 0;
-}
-
-void freeScalebar(scalebarObj *scalebar)
-{
-  freeLabel(&(scalebar->label));
-}
-
-int loadScalebar(scalebarObj *scalebar)
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(ALIGN):
-        if((scalebar->align = getSymbol(3, MS_ALIGN_LEFT,MS_ALIGN_CENTER,MS_ALIGN_RIGHT)) == -1) return(-1);
-        break;
-      case(BACKGROUNDCOLOR):
-        if(loadColor(&(scalebar->backgroundcolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(COLOR):
-        if(loadColor(&(scalebar->color), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadScalebar()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(IMAGECOLOR):
-        if(loadColor(&(scalebar->imagecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(INTERVALS):
-        if(getInteger(&(scalebar->intervals), MS_NUM_CHECK_RANGE, MS_SCALEBAR_INTERVALS_MIN, MS_SCALEBAR_INTERVALS_MAX) == -1) return(-1);
-        break;
-      case(LABEL):
-        if(loadLabel(&(scalebar->label)) == -1) return(-1);
-        scalebar->label.angle = 0;
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(scalebar->outlinecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(POSITION):
-        if((scalebar->position = getSymbol(6, MS_UL,MS_UR,MS_LL,MS_LR,MS_UC,MS_LC)) == -1)
-          return(-1);
-        break;
-      case(POSTLABELCACHE):
-        if((scalebar->postlabelcache = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(-1);
-        break;
-      case(SCALEBAR):
-        break; /* for string loads */
-      case(SIZE):
-        if(getInteger(&(scalebar->width), MS_NUM_CHECK_RANGE, MS_SCALEBAR_WIDTH_MIN, MS_SCALEBAR_WIDTH_MAX) == -1) return(-1);
-        if(getInteger(&(scalebar->height), MS_NUM_CHECK_RANGE, MS_SCALEBAR_HEIGHT_MIN, MS_SCALEBAR_HEIGHT_MAX) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((scalebar->status = getSymbol(3, MS_ON,MS_OFF,MS_EMBED)) == -1) return(-1);
-        break;
-      case(STYLE):
-        if(getInteger(&(scalebar->style), MS_NUM_CHECK_RANGE, 0, 1) == -1) return(-1); // only 2 styles: 0 and 1
-        break;
-      case(TRANSPARENT):
-        if((scalebar->transparent = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(UNITS):
-        if((scalebar->units = getSymbol(6, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES)) == -1) return(-1);
-        break;
-      case(OFFSET):
-        if(getInteger(&(scalebar->offsetx), MS_NUM_CHECK_RANGE, MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1) return(-1);
-        if(getInteger(&(scalebar->offsety), MS_NUM_CHECK_RANGE, MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadScalebar()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  } /* next token */
-}
-
-int msUpdateScalebarFromString(scalebarObj *scalebar, char *string)
-{
-  if(!scalebar || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadScalebar(scalebar) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-static void writeScalebar(FILE *stream, int indent, scalebarObj *scalebar)
-{
-  colorObj c;
-
-  indent++;
-  writeBlockBegin(stream, indent, "SCALEBAR");
-  writeKeyword(stream, indent, "ALIGN", scalebar->align, 2, MS_ALIGN_LEFT, "LEFT", MS_ALIGN_RIGHT, "RIGHT");
-  writeColor(stream, indent, "BACKGROUNDCOLOR", NULL, &(scalebar->backgroundcolor));
-  MS_INIT_COLOR(c,0,0,0,255);
-  writeColor(stream, indent, "COLOR", &c, &(scalebar->color));
-  writeColor(stream, indent, "IMAGECOLOR", NULL, &(scalebar->imagecolor));
-  writeNumber(stream, indent, "INTERVALS", -1, scalebar->intervals);
-  writeLabel(stream, indent, &(scalebar->label));
-  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(scalebar->outlinecolor));
-  if(scalebar->status == MS_EMBED) writeKeyword(stream, indent, "POSITION", scalebar->position, 6, MS_LL, "LL", MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC, "LC");
-  writeKeyword(stream, indent, "POSTLABELCACHE", scalebar->postlabelcache, 1, MS_TRUE, "TRUE");
-  writeDimension(stream, indent, "SIZE", scalebar->width, scalebar->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", scalebar->status, 3, MS_ON, "ON", MS_OFF, "OFF", MS_EMBED, "EMBED");
-  writeNumber(stream, indent, "STYLE", 0, scalebar->style);
-  writeKeyword(stream, indent, "TRANSPARENT", scalebar->transparent, 2, MS_TRUE, "TRUE", MS_FALSE, "FALSE");
-  writeKeyword(stream, indent, "UNITS", scalebar->units, 6, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES");
-  writeBlockEnd(stream, indent, "SCALEBAR");
-  writeLineFeed(stream);
-}
-
-char* msWriteScalebarToString(scalebarObj *scalebar)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeScalebar(stdout, -1, scalebar);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-/*
-** Initialize a queryMapObj structure
-*/
-void initQueryMap(queryMapObj *querymap)
-{
-  querymap->width = querymap->height = -1;
-  querymap->style = MS_HILITE;
-  querymap->status = MS_OFF;
-  MS_INIT_COLOR(querymap->color, 255,255,0,255); /* yellow */
-}
-
-int loadQueryMap(queryMapObj *querymap, mapObj *map)
-{
-  querymap->map = (mapObj *)map;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(QUERYMAP):
-        break; /* for string loads */
-      case(COLOR):
-        if(loadColor(&(querymap->color), NULL) != MS_SUCCESS) return MS_FAILURE;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadQueryMap()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(SIZE):
-        /*
-	** we do -1 (and avoid 0) here to maintain backwards compatability as older versions write "SIZE -1 -1" when saving a mapfile
-        */
-        if(getInteger(&(querymap->width), MS_NUM_CHECK_RANGE, -1, querymap->map->maxsize) == -1 || querymap->width == 0) {
-          msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()", msyylineno);
-          return(-1);
-        }
-        if(getInteger(&(querymap->height), MS_NUM_CHECK_RANGE, -1, querymap->map->maxsize) == -1 || querymap->height == 0) {
-          msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()", msyylineno);
-          return(-1);
-        }
-        break;
-      case(STATUS):
-        if((querymap->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(STYLE):
-      case(TYPE):
-        if((querymap->style = getSymbol(3, MS_NORMAL,MS_HILITE,MS_SELECTED)) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadQueryMap()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  }
-}
-
-int msUpdateQueryMapFromString(queryMapObj *querymap, char *string)
-{
-  if(!querymap || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadQueryMap(querymap, querymap->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-static void writeQueryMap(FILE *stream, int indent, queryMapObj *querymap)
-{
-  colorObj c;
-
-  indent++;
-  writeBlockBegin(stream, indent, "QUERYMAP");
-  MS_INIT_COLOR(c,255,255,0,255);
-  writeColor(stream, indent, "COLOR",  &c, &(querymap->color));
-  if(querymap->width != -1 && querymap->height != -1) // don't write SIZE if not explicitly set
-    writeDimension(stream, indent, "SIZE", querymap->width, querymap->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", querymap->status, 2, MS_ON, "ON", MS_OFF, "OFF");
-  writeKeyword(stream, indent, "STYLE", querymap->style, 3, MS_NORMAL, "NORMAL", MS_HILITE, "HILITE", MS_SELECTED, "SELECTED");
-  writeBlockEnd(stream, indent, "QUERYMAP");
-  writeLineFeed(stream);
-}
-
-char* msWriteQueryMapToString(queryMapObj *querymap)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeQueryMap(stdout, -1, querymap);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-/*
-** Initialize a webObj structure
-*/
-void initWeb(webObj *web)
-{
-  web->template = NULL;
-  web->header = web->footer = NULL;
-  web->error =  web->empty = NULL;
-  web->mintemplate = web->maxtemplate = NULL;
-  web->minscaledenom = web->maxscaledenom = -1;
-  web->imagepath = msStrdup("");
-  web->temppath = NULL;
-  web->imageurl = msStrdup("");
-
-  initHashTable(&(web->metadata));
-  initHashTable(&(web->validation));
-
-  web->map = NULL;
-  web->queryformat = msStrdup("text/html");
-  web->legendformat = msStrdup("text/html");
-  web->browseformat = msStrdup("text/html");
-}
-
-void freeWeb(webObj *web)
-{
-  msFree(web->template);
-  msFree(web->header);
-  msFree(web->footer);
-  msFree(web->error);
-  msFree(web->empty);
-  msFree(web->maxtemplate);
-  msFree(web->mintemplate);
-  msFree(web->imagepath);
-  msFree(web->temppath);
-  msFree(web->imageurl);
-  msFree(web->queryformat);
-  msFree(web->legendformat);
-  msFree(web->browseformat);
-  if(&(web->metadata)) msFreeHashItems(&(web->metadata));
-  if(&(web->validation)) msFreeHashItems(&(web->validation));
-}
-
-static void writeWeb(FILE *stream, int indent, webObj *web)
-{
-  indent++;
-  writeBlockBegin(stream, indent, "WEB");
-  writeString(stream, indent, "BROWSEFORMAT", "text/html", web->browseformat);
-  writeString(stream, indent, "EMPTY", NULL, web->empty);
-  writeString(stream, indent, "ERROR", NULL, web->error);
-  writeString(stream, indent, "FOOTER", NULL, web->footer);
-  writeString(stream, indent, "HEADER", NULL, web->header);
-  writeString(stream, indent, "IMAGEPATH", "", web->imagepath);
-  writeString(stream, indent, "TEMPPATH", NULL, web->temppath);
-  writeString(stream, indent, "IMAGEURL", "", web->imageurl);
-  writeString(stream, indent, "LEGENDFORMAT", "text/html", web->legendformat);
-  writeNumber(stream, indent, "MAXSCALEDENOM", -1, web->maxscaledenom);
-  writeString(stream, indent, "MAXTEMPLATE", NULL, web->maxtemplate);
-  writeHashTable(stream, indent, "METADATA", &(web->metadata));
-  writeNumber(stream, indent, "MINSCALEDENOM", -1, web->minscaledenom);
-  writeString(stream, indent, "MINTEMPLATE", NULL, web->mintemplate);
-  writeString(stream, indent, "QUERYFORMAT", "text/html", web->queryformat);
-  writeString(stream, indent, "TEMPLATE", NULL, web->template);
-  writeHashTable(stream, indent, "VALIDATION", &(web->validation));
-  writeBlockEnd(stream, indent, "WEB");
-  writeLineFeed(stream);
-}
-
-char* msWriteWebToString(webObj *web)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeWeb(stdout, -1, web);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-int loadWeb(webObj *web, mapObj *map)
-{
-  web->map = (mapObj *)map;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(BROWSEFORMAT): /* change to use validation in 6.0 */
-        free(web->browseformat);
-        web->browseformat = NULL; /* there is a default */
-        if(getString(&web->browseformat) == MS_FAILURE) return(-1);
-        break;
-      case(EMPTY):
-        if(getString(&web->empty) == MS_FAILURE) return(-1);
-        break;
-      case(WEB):
-        break; /* for string loads */
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadWeb()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(ERROR):
-        if(getString(&web->error) == MS_FAILURE) return(-1);
-        break;
-      case(FOOTER):
-        if(getString(&web->footer) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(HEADER):
-        if(getString(&web->header) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(IMAGEPATH):
-        if(getString(&web->imagepath) == MS_FAILURE) return(-1);
-        break;
-      case(TEMPPATH):
-        if(getString(&web->temppath) == MS_FAILURE) return(-1);
-        break;
-      case(IMAGEURL):
-        if(getString(&web->imageurl) == MS_FAILURE) return(-1);
-        break;
-      case(LEGENDFORMAT): /* change to use validation in 6.0 */
-        free(web->legendformat);
-        web->legendformat = NULL; /* there is a default */
-        if(getString(&web->legendformat) == MS_FAILURE) return(-1);
-        break;
-      case(MAXSCALEDENOM):
-        if(getDouble(&web->maxscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MAXTEMPLATE):
-        if(getString(&web->maxtemplate) == MS_FAILURE) return(-1);
-        break;
-      case(METADATA):
-        if(loadHashTable(&(web->metadata)) != MS_SUCCESS) return(-1);
-        break;
-      case(MINSCALEDENOM):
-        if(getDouble(&web->minscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MINTEMPLATE):
-        if(getString(&web->mintemplate) == MS_FAILURE) return(-1);
-        break;
-      case(QUERYFORMAT): /* change to use validation in 6.0 */
-        free(web->queryformat);
-        web->queryformat = NULL; /* there is a default */
-        if(getString(&web->queryformat) == MS_FAILURE) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&web->template) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(VALIDATION):
-        if(loadHashTable(&(web->validation)) != MS_SUCCESS) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadWeb()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-    }
-  }
-}
-
-int msUpdateWebFromString(webObj *web, char *string)
-{
-  if(!web || !string) return MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = string;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 */
-
-  if(loadWeb(web, web->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  msyylex_destroy();
-  return MS_SUCCESS;
-}
-
-/*
-** Initialize, load and free a mapObj structure
-**
-** This really belongs in mapobject.c, but currently it also depends on
-** lots of other init methods in this file.
-*/
-
-int initMap(mapObj *map)
-{
-  int i=0;
-  MS_REFCNT_INIT(map);
-
-  map->debug = (int)msGetGlobalDebugLevel();
-
-  /* Set maxlayers = 0, layers[] and layerorder[] will be allocated as needed,
-   * on the first call to msGrowMapLayers()
-   */
-  map->numlayers = 0;
-  map->maxlayers = 0;
-  map->layers = NULL;
-  map->layerorder = NULL; /* used to modify the order in which the layers are drawn */
-
-  map->status = MS_ON;
-  map->name = msStrdup("MS");
-  map->extent.minx = map->extent.miny = map->extent.maxx = map->extent.maxy = -1.0;
-
-  map->scaledenom = -1.0;
-  map->resolution = MS_DEFAULT_RESOLUTION; /* pixels per inch */
-  map->defresolution = MS_DEFAULT_RESOLUTION; /* pixels per inch */
-
-  map->height = map->width = -1;
-  map->maxsize = MS_MAXIMAGESIZE_DEFAULT;
-
-  map->gt.need_geotransform = MS_FALSE;
-  map->gt.rotation_angle = 0.0;
-
-  map->units = MS_METERS;
-  map->cellsize = 0;
-  map->shapepath = NULL;
-  map->mappath = NULL;
-  map->sldurl = NULL;
-
-  MS_INIT_COLOR(map->imagecolor, 255,255,255,255); /* white */
-
-  map->numoutputformats = 0;
-  map->outputformatlist = NULL;
-  map->outputformat = NULL;
-
-  /* map->configoptions = msCreateHashTable();; */
-  initHashTable(&(map->configoptions));
-
-  map->imagetype = NULL;
-
-  map->palette.numcolors = 0;
-
-  for(i=0; i<MS_MAX_LABEL_PRIORITY; i++) {
-    map->labelcache.slots[i].labels = NULL; /* cache is initialize at draw time */
-    map->labelcache.slots[i].cachesize = 0;
-    map->labelcache.slots[i].numlabels = 0;
-    map->labelcache.slots[i].markers = NULL;
-    map->labelcache.slots[i].markercachesize = 0;
-    map->labelcache.slots[i].nummarkers = 0;
-  }
-
-  map->fontset.filename = NULL;
-  map->fontset.numfonts = 0;
-
-  /* map->fontset.fonts = NULL; */
-  initHashTable(&(map->fontset.fonts));
-
-  msInitSymbolSet(&map->symbolset);
-  map->symbolset.fontset =  &(map->fontset);
-  map->symbolset.map = map;
-
-  initLegend(&map->legend);
-  initScalebar(&map->scalebar);
-  initWeb(&map->web);
-  initReferenceMap(&map->reference);
-  initQueryMap(&map->querymap);
-
-  map->projContext = msProjectionContextGetFromPool();
-
-  if(msInitProjection(&(map->projection)) == -1)
-    return(-1);
-  if(msInitProjection(&(map->latlon)) == -1)
-    return(-1);
-
-  msProjectionSetContext(&(map->projection), map->projContext);
-  msProjectionSetContext(&(map->latlon), map->projContext);
-
-  /* initialize a default "geographic" projection */
-  map->latlon.numargs = 2;
-  map->latlon.args[0] = msStrdup("proj=latlong");
-  map->latlon.args[1] = msStrdup("ellps=WGS84"); /* probably want a different ellipsoid */
-  if(msProcessProjection(&(map->latlon)) == -1) return(-1);
-
-  map->templatepattern = map->datapattern = NULL;
-
-  /* Encryption key information - see mapcrypto.c */
-  map->encryption_key_loaded = MS_FALSE;
-
-  msInitQuery(&(map->query));
-
-#ifdef USE_V8_MAPSCRIPT
-  map->v8context = NULL;
-#endif
-
-  map->config = NULL;
-
-  return(0);
-}
-
-/*
-** Ensure there is at least one free entry in the layers and layerorder
-** arrays of this mapObj. Grow the allocated layers/layerorder arrays if
-** necessary and allocate a new layer for layers[numlayers] if there is
-** not already one, setting its contents to all zero bytes (i.e. does not
-** call initLayer() on it).
-**
-** This function is safe to use for the initial allocation of the layers[]
-** and layerorder[] arrays as well (i.e. when maxlayers==0 and layers==NULL)
-**
-** Returns a reference to the new layerObj on success, NULL on error.
-*/
-layerObj *msGrowMapLayers( mapObj *map )
-{
-  /* Do we need to increase the size of layers/layerorder by
-   * MS_LAYER_ALLOCSIZE?
-   */
-  if (map->numlayers == map->maxlayers) {
-    layerObj **newLayersPtr;
-    int *newLayerorderPtr;
-    int i, newsize;
-
-    newsize = map->maxlayers + MS_LAYER_ALLOCSIZE;
-
-    /* Alloc/realloc layers */
-    newLayersPtr = (layerObj**)realloc(map->layers,
-                                       newsize*sizeof(layerObj*));
-    MS_CHECK_ALLOC(newLayersPtr, newsize*sizeof(layerObj*), NULL);
-
-    map->layers = newLayersPtr;
-
-    /* Alloc/realloc layerorder */
-    newLayerorderPtr = (int *)realloc(map->layerorder,
-                                      newsize*sizeof(int));
-    MS_CHECK_ALLOC(newLayerorderPtr, newsize*sizeof(int), NULL);
-
-    map->layerorder = newLayerorderPtr;
-
-    map->maxlayers = newsize;
-    for(i=map->numlayers; i<map->maxlayers; i++) {
-      map->layers[i] = NULL;
-      map->layerorder[i] = 0;
-    }
-  }
-
-  if (map->layers[map->numlayers]==NULL) {
-    map->layers[map->numlayers]=(layerObj*)calloc(1,sizeof(layerObj));
-    MS_CHECK_ALLOC(map->layers[map->numlayers], sizeof(layerObj), NULL);
-  }
-
-  return map->layers[map->numlayers];
-}
-
-
-int msFreeLabelCacheSlot(labelCacheSlotObj *cacheslot)
-{
-  int i, j;
-
-  /* free the labels */
-  if (cacheslot->labels) {
-    for(i=0; i<cacheslot->numlabels; i++) {
-
-      for(j=0; j<cacheslot->labels[i].numtextsymbols; j++) {
-        freeTextSymbol(cacheslot->labels[i].textsymbols[j]);
-        free(cacheslot->labels[i].textsymbols[j]);
-      }
-      msFree(cacheslot->labels[i].textsymbols);
-
-      if(cacheslot->labels[i].leaderline) {
-        msFree(cacheslot->labels[i].leaderline->point);
-        msFree(cacheslot->labels[i].leaderline);
-        msFree(cacheslot->labels[i].leaderbbox);
-      }
-    }
-  }
-  msFree(cacheslot->labels);
-  cacheslot->labels = NULL;
-  cacheslot->cachesize = 0;
-  cacheslot->numlabels = 0;
-
-  msFree(cacheslot->markers);
-  cacheslot->markers = NULL;
-  cacheslot->markercachesize = 0;
-  cacheslot->nummarkers = 0;
-
-  return(MS_SUCCESS);
-}
-
-int msFreeLabelCache(labelCacheObj *cache)
-{
-  int p;
-
-  for(p=0; p<MS_MAX_LABEL_PRIORITY; p++) {
-    if (msFreeLabelCacheSlot(&(cache->slots[p])) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-
-  cache->num_allocated_rendered_members = cache->num_rendered_members = 0;
-  msFree(cache->rendered_text_symbols);
-
-  return MS_SUCCESS;
-}
-
-int msInitLabelCacheSlot(labelCacheSlotObj *cacheslot)
-{
-
-  if(cacheslot->labels || cacheslot->markers)
-    msFreeLabelCacheSlot(cacheslot);
-
-  cacheslot->labels = (labelCacheMemberObj *)malloc(sizeof(labelCacheMemberObj)*MS_LABELCACHEINITSIZE);
-  MS_CHECK_ALLOC(cacheslot->labels, sizeof(labelCacheMemberObj)*MS_LABELCACHEINITSIZE, MS_FAILURE);
-
-  cacheslot->cachesize = MS_LABELCACHEINITSIZE;
-  cacheslot->numlabels = 0;
-
-  cacheslot->markers = (markerCacheMemberObj *)malloc(sizeof(markerCacheMemberObj)*MS_LABELCACHEINITSIZE);
-  MS_CHECK_ALLOC(cacheslot->markers, sizeof(markerCacheMemberObj)*MS_LABELCACHEINITSIZE, MS_FAILURE);
-
-  cacheslot->markercachesize = MS_LABELCACHEINITSIZE;
-  cacheslot->nummarkers = 0;
-
-  return(MS_SUCCESS);
-}
-
-int msInitLabelCache(labelCacheObj *cache)
-{
-  int p;
-
-  for(p=0; p<MS_MAX_LABEL_PRIORITY; p++) {
-    if (msInitLabelCacheSlot(&(cache->slots[p])) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-  cache->gutter = 0;
-  cache->num_allocated_rendered_members = cache->num_rendered_members = 0;
-  cache->rendered_text_symbols = NULL;
-
-  return MS_SUCCESS;
-}
-
-static void writeMap(FILE *stream, int indent, mapObj *map)
-{
-  int i;
-  colorObj c;
-
-  writeBlockBegin(stream, indent, "MAP");
-  writeNumber(stream, indent, "ANGLE", 0, map->gt.rotation_angle);
-  writeHashTableInline(stream, indent, "CONFIG", &(map->configoptions));
-  writeNumber(stream, indent, "DEBUG", 0, map->debug);
-  writeNumber(stream, indent, "DEFRESOLUTION", 72.0, map->defresolution);
-  writeExtent(stream, indent, "EXTENT", map->extent);
-  writeString(stream, indent, "FONTSET", NULL, map->fontset.filename);
-  MS_INIT_COLOR(c,255,255,255,255);
-  writeColor(stream, indent, "IMAGECOLOR", &c, &(map->imagecolor));
-  writeString(stream, indent, "IMAGETYPE", NULL, map->imagetype);
-  writeNumber(stream, indent, "MAXSIZE", MS_MAXIMAGESIZE_DEFAULT, map->maxsize);
-  writeString(stream, indent, "NAME", NULL, map->name);
-  writeNumber(stream, indent, "RESOLUTION", 72.0, map->resolution);
-  writeString(stream, indent, "SHAPEPATH", NULL, map->shapepath);
-  writeDimension(stream, indent, "SIZE", map->width, map->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", map->status, 2, MS_ON, "ON", MS_OFF, "OFF");
-  writeString(stream, indent, "SYMBOLSET", NULL, map->symbolset.filename);
-  writeKeyword(stream, indent, "UNITS", map->units, 7, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
-  writeLineFeed(stream);
-
-  writeOutputformat(stream, indent, map);
-
-  /* write symbol with INLINE tag in mapfile */
-  for(i=0; i<map->symbolset.numsymbols; i++) {
-    if(map->symbolset.symbol[i]->inmapfile) writeSymbol(map->symbolset.symbol[i], stream);
-  }
-
-  writeProjection(stream, indent, &(map->projection));
-
-  writeLegend(stream, indent, &(map->legend));
-  writeQueryMap(stream, indent, &(map->querymap));
-  writeReferenceMap(stream, indent, &(map->reference));
-  writeScalebar(stream, indent, &(map->scalebar));
-  writeWeb(stream, indent, &(map->web));
-
-  for(i=0; i<map->numlayers; i++)
-    writeLayer(stream, indent, GET_LAYER(map, map->layerorder[i]));
-
-  writeBlockEnd(stream, indent, "MAP");
-}
-
-char* msWriteMapToString(mapObj *map)
-{
-  msIOContext  context;
-  msIOBuffer buffer;
-
-  context.label = NULL;
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = &buffer;
-  buffer.data = NULL;
-  buffer.data_len = 0;
-  buffer.data_offset = 0;
-
-  msIO_installHandlers( NULL, &context, NULL );
-
-  writeMap(stdout, 0, map);
-  msIO_bufferWrite( &buffer, "", 1 );
-
-  msIO_installHandlers( NULL, NULL, NULL );
-
-  return (char*)buffer.data;
-}
-
-int msSaveMap(mapObj *map, char *filename)
-{
-  FILE *stream;
-  char szPath[MS_MAXPATHLEN];
-
-  if(!map) {
-    msSetError(MS_MISCERR, "Map is undefined.", "msSaveMap()");
-    return(-1);
-  }
-
-  if(!filename) {
-    msSetError(MS_MISCERR, "Filename is undefined.", "msSaveMap()");
-    return(-1);
-  }
-
-  stream = fopen(msBuildPath(szPath, map->mappath, filename), "w");
-  if(!stream) {
-    msSetError(MS_IOERR, "(%s)", "msSaveMap()", filename);
-    return(-1);
-  }
-
-  writeMap(stream, 0, map);
-  fclose(stream);
-
-  return(0);
-}
-
-static void writeConfig(FILE *stream, int indent, configObj *config)
-{
-  writeBlockBegin(stream, indent, "CONFIG");
-  writeHashTable(stream, indent, "ENV", &(config->env));
-  writeHashTable(stream, indent, "MAPS", &(config->maps));
-  writeBlockEnd(stream, indent, "CONFIG");
-}
-
-int msSaveConfig(configObj *config, const char *filename)
-{
-  FILE *stream;
-
-  if(!config) {
-    msSetError(MS_MISCERR, "Config is undefined.", "msSaveConfigMap()");
-    return(-1);
-  }
-
-  if(!filename) {
-    msSetError(MS_MISCERR, "Filename is undefined.", "msSaveConfigMap()");
-    return(-1);
-  }
-
-  stream = fopen(filename, "w");
-  if(!stream) {
-    msSetError(MS_IOERR, "(%s)", "msSaveConfig()", filename);
-    return(-1);
-  }
-
-  writeConfig(stream,0,config);
-  fclose(stream);
-
-  return(0);
-}
-
-static int loadMapInternal(mapObj *map)
-{
-  int foundMapToken=MS_FALSE;
-  int foundBomToken = MS_FALSE;
-  int token;
-
-  for(;;) {
-
-    token = msyylex();
-
-    if(!foundBomToken && token == BOM) {
-      foundBomToken = MS_TRUE;
-      if(!foundMapToken) {
-        continue; /*skip a leading bom*/
-      }
-    }
-    if(!foundMapToken && token != MAP) {
-      msSetError(MS_IDENTERR, "First token must be MAP, this doesn't look like a mapfile.", "msLoadMap()");
-      return(MS_FAILURE);
-    }
-
-    switch(token) {
-
-      case(CONFIG): {
-        char *key=NULL, *value=NULL;
-
-        if( getString(&key) == MS_FAILURE )
-          return MS_FAILURE;
-
-        if( getString(&value) == MS_FAILURE ) {
-          free(key);
-          return MS_FAILURE;
-        }
-
-        if (msSetConfigOption( map, key, value ) == MS_FAILURE) {
-          free(key);
-          free(value);
-          return MS_FAILURE;
-        }
-
-        free( key );
-        free( value );
-      }
-      break;
-      case(DEBUG):
-        if((map->debug = getSymbol(3, MS_ON,MS_OFF, MS_NUMBER)) == -1) return MS_FAILURE;
-        if(map->debug == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid DEBUG level, must be between 0 and 5 (line %d)", "msLoadMap()", msyylineno);
-            return(-1);
-          }
-          map->debug = (int) msyynumber;
-        }
-        break;
-      case(END):
-        if(msyyin) {
-          fclose(msyyin);
-          msyyin = NULL;
-        }
-
-        /*** Make config options current ***/
-        msApplyMapConfigOptions( map );
-
-        /*** Compute rotated extent info if applicable ***/
-        msMapComputeGeotransform( map );
-
-        /*** OUTPUTFORMAT related setup ***/
-        if( msPostMapParseOutputFormatSetup( map ) == MS_FAILURE )
-          return MS_FAILURE;
-
-        if(loadSymbolSet(&(map->symbolset), map) == -1) return MS_FAILURE;
-
-        if (resolveSymbolNames(map) == MS_FAILURE) return MS_FAILURE;
-
-
-        if(msLoadFontSet(&(map->fontset), map) == -1) return MS_FAILURE;
-
-        return MS_SUCCESS;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "msLoadMap()");
-        return MS_FAILURE;
-      case(EXTENT): {
-        if(getDouble(&(map->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if(getDouble(&(map->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if(getDouble(&(map->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if(getDouble(&(map->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if (!MS_VALID_EXTENT(map->extent)) {
-          msSetError(MS_MISCERR, "Given map extent is invalid. Check that it " \
-                     "is in the form: minx, miny, maxx, maxy", "loadMapInternal()");
-          return MS_FAILURE;
-        }
-      }
-      break;
-      case(ANGLE): {
-        double rotation_angle;
-        if(getDouble(&(rotation_angle), MS_NUM_CHECK_RANGE, -360, 360) == -1) return MS_FAILURE;
-        msMapSetRotation( map, rotation_angle );
-      }
-      break;
-      case(FONTSET):
-        if(getString(&map->fontset.filename) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(IMAGECOLOR):
-        if(loadColor(&(map->imagecolor), NULL) != MS_SUCCESS) return MS_FAILURE;
-        break;
-      case(IMAGETYPE):
-        msFree(map->imagetype);
-        map->imagetype = getToken();
-        break;
-      case(LATLON):
-        if(loadProjection(&map->latlon) == -1) return MS_FAILURE;
-        break;
-      case(LAYER):
-        if(msGrowMapLayers(map) == NULL)
-          return MS_FAILURE;
-        if(initLayer((GET_LAYER(map, map->numlayers)), map) == -1) return MS_FAILURE;
-        if(loadLayer((GET_LAYER(map, map->numlayers)), map) == -1) return MS_FAILURE;
-        GET_LAYER(map, map->numlayers)->index = map->numlayers; /* save the index */
-        /* Update the layer order list with the layer's index. */
-        map->layerorder[map->numlayers] = map->numlayers;
-        map->numlayers++;
-        break;
-      case(OUTPUTFORMAT):
-        if(loadOutputFormat(map) == -1) return MS_FAILURE;
-        break;
-      case(LEGEND):
-        if(loadLegend(&(map->legend), map) == -1) return MS_FAILURE;
-        break;
-      case(MAP):
-        foundMapToken = MS_TRUE;
-        break;
-      case(MAXSIZE):
-        if(getInteger(&(map->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return MS_FAILURE;
-        break;
-      case(NAME):
-        free(map->name);
-        map->name = NULL; /* erase default */
-        if(getString(&map->name) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(PROJECTION):
-        if(loadProjection(&map->projection) == -1) return MS_FAILURE;
-        break;
-      case(QUERYMAP):
-        if(loadQueryMap(&(map->querymap), map) == -1) return MS_FAILURE;
-        break;
-      case(REFERENCE):
-        if(loadReferenceMap(&(map->reference), map) == -1) return MS_FAILURE;
-        break;
-      case(RESOLUTION):
-        if(getDouble(&(map->resolution), MS_NUM_CHECK_RANGE, MS_RESOLUTION_MIN, MS_RESOLUTION_MAX) == -1) return MS_FAILURE;
-        break;
-      case(DEFRESOLUTION):
-        if(getDouble(&(map->defresolution), MS_NUM_CHECK_RANGE, MS_RESOLUTION_MIN, MS_RESOLUTION_MAX) == -1) return MS_FAILURE;
-        break;
-      case(SCALE):
-      case(SCALEDENOM):
-        if(getDouble(&(map->scaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1) return MS_FAILURE;
-        break;
-      case(SCALEBAR):
-        if(loadScalebar(&(map->scalebar)) == -1) return MS_FAILURE;
-        break;
-      case(SHAPEPATH):
-        if(getString(&map->shapepath) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(SIZE):
-        if(getInteger(&(map->width), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1) return MS_FAILURE;
-        if(getInteger(&(map->height), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1) return MS_FAILURE;
-        break;
-      case(STATUS):
-        if((map->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return MS_FAILURE;
-        break;
-      case(SYMBOL):
-        if(msGrowSymbolSet(&(map->symbolset)) == NULL)
-          return MS_FAILURE;
-        if((loadSymbol(map->symbolset.symbol[map->symbolset.numsymbols], map->mappath) == -1)) {
-            msFreeSymbol(map->symbolset.symbol[map->symbolset.numsymbols]);
-            free(map->symbolset.symbol[map->symbolset.numsymbols]);
-            map->symbolset.symbol[map->symbolset.numsymbols] = NULL;
-            return MS_FAILURE;
-        }
-        map->symbolset.symbol[map->symbolset.numsymbols]->inmapfile = MS_TRUE;
-        map->symbolset.numsymbols++;
-        break;
-      case(SYMBOLSET):
-        if(getString(&map->symbolset.filename) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(UNITS):
-        if((int)(map->units = getSymbol(7, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD)) == -1) return MS_FAILURE;
-        break;
-      case(WEB):
-        if(loadWeb(&(map->web), map) == -1) return MS_FAILURE;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "msLoadMap()", msyystring_buffer, msyylineno);
-        return MS_FAILURE;
-    }
-  } /* next token */
-}
-
-static bool msGetCWD(char* szBuffer, size_t nBufferSize, const char* pszFunctionName)
-{
-  if(NULL == getcwd(szBuffer, nBufferSize)) {
-#ifndef _WIN32
-    if( errno == EACCES )
-        msSetError(MS_MISCERR,
-                   "getcwd() failed with EACCES: you may need to force the "
-                   "current directory in the mapserver launcher "
-                   "(e.g -d option of spawn-fcgi)", pszFunctionName);
-    else if( errno == ENAMETOOLONG )
-        msSetError(MS_MISCERR, "getcwd() returned a too long path",
-                   pszFunctionName);
-    else
-        msSetError(MS_MISCERR, "getcwd() failed with errno code %d",
-                   pszFunctionName, errno);
-#else
-    msSetError(MS_MISCERR, "getcwd() returned a too long path", pszFunctionName);
-#endif
-    return FALSE;
-  }
-  return TRUE;
-}
-
-/*
-** Sets up string-based mapfile loading and calls loadMapInternal to do the work.
-*/
-mapObj *msLoadMapFromString(char *buffer, char *new_mappath, const configObj *config)
-{
-  mapObj *map;
-  struct mstimeval starttime = {0}, endtime = {0};
-  char szPath[MS_MAXPATHLEN], szCWDPath[MS_MAXPATHLEN];
-  char *mappath=NULL;
-  int debuglevel;
-
-  debuglevel = (int)msGetGlobalDebugLevel();
-
-  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
-    /* In debug mode, track time spent loading/parsing mapfile. */
-    msGettimeofday(&starttime, NULL);
-  }
-
-  if(!buffer) {
-    msSetError(MS_MISCERR, "No buffer to load.", "msLoadMapFromString()");
-    return(NULL);
-  }
-
-  /*
-  ** Allocate mapObj structure
-  */
-  map = (mapObj *)calloc(sizeof(mapObj),1);
-  MS_CHECK_ALLOC(map, sizeof(mapObj), NULL);
-
-  if(initMap(map) == -1) { /* initialize this map */
-    msFreeMap(map);
-    return(NULL);
-  }
-
-  map->config = config; // create a read-only reference
-  
-  msAcquireLock( TLOCK_PARSER ); /* might need to move this lock a bit higher, yup (bug 2108) */
-
-  msyystate = MS_TOKENIZE_STRING;
-  msyystring = buffer;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 1; /* start at line 1 (do lines mean anything here?) */
-
-  /* If new_mappath is provided then use it, otherwise use the CWD */
-  if(!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMapFromString()")) {
-    msFreeMap(map);
-    msReleaseLock( TLOCK_PARSER );
-  }
-  if (new_mappath) {
-    mappath = msStrdup(new_mappath);
-    map->mappath = msStrdup(msBuildPath(szPath, szCWDPath, mappath));
-  } else
-    map->mappath = msStrdup(szCWDPath);
-
-  msyybasepath = map->mappath; /* for INCLUDEs */
-
-  if(loadMapInternal(map) != MS_SUCCESS) {
-    msFreeMap(map);
-    msReleaseLock( TLOCK_PARSER );
-    if(mappath != NULL) free(mappath);
-    return NULL;
-  }
-
-  if (mappath != NULL) free(mappath);
-  msyylex_destroy();
-
-  msReleaseLock( TLOCK_PARSER );
-
-  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
-    /* In debug mode, report time spent loading/parsing mapfile. */
-    msGettimeofday(&endtime, NULL);
-    msDebug("msLoadMap(): %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-  }
-
-  if (resolveSymbolNames(map) == MS_FAILURE) return NULL;
-
-  return map;
-}
-
-/*
-** Sets up file-based mapfile loading and calls loadMapInternal to do the work.
-*/
-mapObj *msLoadMap(const char *filename, const char *new_mappath, const configObj *config)
-{
-  mapObj *map;
-  struct mstimeval starttime={0}, endtime={0};
-  char szPath[MS_MAXPATHLEN], szCWDPath[MS_MAXPATHLEN];
-  int debuglevel;
-
-  debuglevel = (int)msGetGlobalDebugLevel();
-
-  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
-    /* In debug mode, track time spent loading/parsing mapfile. */
-    msGettimeofday(&starttime, NULL);
-  }
-
-  if(!filename) {
-    msSetError(MS_MISCERR, "Filename is undefined.", "msLoadMap()");
-    return(NULL);
-  }
-
-  const char *ms_mapfile_pattern = CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
-  if(msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
-    msSetError(MS_REGEXERR, "Filename validation failed." , "msLoadMap()");
-    return(NULL);
-  }
-
-  /*
-  ** Allocate mapObj structure
-  */
-  map = (mapObj *)calloc(sizeof(mapObj),1);
-  MS_CHECK_ALLOC(map, sizeof(mapObj), NULL);
-
-  if(initMap(map) == -1) { /* initialize this map */
-    msFreeMap(map);
-    return(NULL);
-  }
-
-  map->config = config; // create a read-only reference
-
-  msAcquireLock( TLOCK_PARSER );  /* Steve: might need to move this lock a bit higher; Umberto: done */
-
-#ifdef USE_XMLMAPFILE
-  /* If the mapfile is an xml mapfile, transform it */
-  const char *ms_xmlmapfile_xslt = CPLGetConfigOption("MS_XMLMAPFILE_XSLT", NULL);
-  if (ms_xmlmapfile_xslt &&
-      (msEvalRegex(MS_DEFAULT_XMLMAPFILE_PATTERN, filename) == MS_TRUE)) {
-
-    msyyin = tmpfile();
-    if (msyyin == NULL) {
-      msSetError(MS_IOERR, "tmpfile() failed to create temporary file", "msLoadMap()");
-      msReleaseLock( TLOCK_PARSER );
-      msFreeMap(map);
-      return NULL;
-    }
-
-    if (msTransformXmlMapfile(ms_xmlmapfile_xslt, filename, msyyin) != MS_SUCCESS) {
-      fclose(msyyin);
-      msFreeMap(map);
-      return NULL;
-    }
-    fseek ( msyyin , 0 , SEEK_SET );
-  } else {
-#endif
-    if((msyyin = fopen(filename,"r")) == NULL) {
-      msSetError(MS_IOERR, "(%s)", "msLoadMap()", filename);
-      msReleaseLock( TLOCK_PARSER );
-      msFreeMap(map);
-      return NULL;
-    }
-#ifdef USE_XMLMAPFILE
-  }
-#endif
-
-  msyystate = MS_TOKENIZE_FILE;
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyyrestart(msyyin); /* start at line begining, line 1 */
-  msyylineno = 1;
-
-  /* If new_mappath is provided then use it, otherwise use the location */
-  /* of the mapfile as the default path */
-  if(!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMap()")) {
-    msReleaseLock( TLOCK_PARSER );
-    msFreeMap(map);
-    return NULL;
-  }
-
-  if (new_mappath)
-    map->mappath = msStrdup(msBuildPath(szPath, szCWDPath, new_mappath));
-  else {
-    char *path = msGetPath(filename);
-    map->mappath = msStrdup(msBuildPath(szPath, szCWDPath, path));
-    free( path );
-  }
-
-  msyybasepath = map->mappath; /* for INCLUDEs */
-
-  if(loadMapInternal(map) != MS_SUCCESS) {
-    msFreeMap(map);
-    msReleaseLock( TLOCK_PARSER );
-    if( msyyin ) {
-      msyycleanup_includes();
-      fclose(msyyin);
-      msyyin = NULL;
-    }
-    return NULL;
-  }
-  msReleaseLock( TLOCK_PARSER );
-
-  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
-    /* In debug mode, report time spent loading/parsing mapfile. */
-    msGettimeofday(&endtime, NULL);
-    msDebug("msLoadMap(): %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-  }
-
-  return map;
-}
-
-static void hashTableSubstituteString(hashTableObj *hash, const char *from, const char *to) {
-  const char *key, *val;
-  char *new_val;
-  key = msFirstKeyFromHashTable(hash);
-  while(key != NULL) {
-    val = msLookupHashTable(hash, key);
-    if(strcasestr(val, from)) {
-      new_val = msCaseReplaceSubstring(msStrdup(val), from, to);
-      msInsertHashTable(hash, key, new_val);
-      msFree(new_val);
-    }
-    key = msNextKeyFromHashTable(hash, key);
-  }
-}
-
-static void classSubstituteString(classObj *class, const char *from, const char *to) {
-  if(class->expression.string) class->expression.string = msCaseReplaceSubstring(class->expression.string, from, to);
-  if(class->text.string) class->text.string = msCaseReplaceSubstring(class->text.string, from, to);
-  if(class->title) class->title = msCaseReplaceSubstring(class->title, from, to);
-}
-
-
-static void layerSubstituteString(layerObj *layer, const char *from, const char *to)
-{
-  int c;
-  if(layer->data) layer->data = msCaseReplaceSubstring(layer->data, from, to);
-  if(layer->tileindex) layer->tileindex = msCaseReplaceSubstring(layer->tileindex, from, to);
-  if(layer->connection) layer->connection = msCaseReplaceSubstring(layer->connection, from, to);
-  if(layer->filter.string) layer->filter.string = msCaseReplaceSubstring(layer->filter.string, from, to);
-  if(layer->mask) layer->mask = msCaseReplaceSubstring(layer->mask, from, to); // new for 8.0
-
-  /* The bindvalues are most useful when able to substitute values from the URL */
-  hashTableSubstituteString(&layer->bindvals, from, to);
-  hashTableSubstituteString(&layer->metadata, from, to);
-  msLayerSubstituteProcessing( layer, from, to );
-  for(c=0; c<layer->numclasses;c++) {
-    classSubstituteString(layer->class[c], from, to);
-  }
-}
-
-static void mapSubstituteString(mapObj *map, const char *from, const char *to) {
-  int l;
-  for(l=0;l<map->numlayers; l++) {
-    layerSubstituteString(GET_LAYER(map,l), from, to);
-  }
-
-  /* output formats (#3751) */
-  for(l=0; l<map->numoutputformats; l++) {
-    int o;
-    for(o=0; o<map->outputformatlist[l]->numformatoptions; o++) {
-      map->outputformatlist[l]->formatoptions[o] = msCaseReplaceSubstring(map->outputformatlist[l]->formatoptions[o], from, to);
-    }
-  }
-
-  hashTableSubstituteString(&map->web.metadata, from, to);
-  if(map->web.template) map->web.template = msCaseReplaceSubstring(map->web.template, from, to);
-}
-
-static void applyOutputFormatDefaultSubstitutions(outputFormatObj *format, const char *option, hashTableObj *table)
-{
-  const char *filename;
-
-  filename = msGetOutputFormatOption(format, option, NULL);
-  if(filename && strlen(filename)>0) {
-    char *tmpfilename = msStrdup(filename);
-    const char *default_key = msFirstKeyFromHashTable(table);
-    while(default_key) {
-      if(!strncasecmp(default_key,"default_",8)) {
-        char *new_filename = NULL;
-        size_t buffer_size = (strlen(default_key)-5);
-        char *tag = (char *)msSmallMalloc(buffer_size);
-        snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
-
-        new_filename = msStrdup(tmpfilename);
-        new_filename = msCaseReplaceSubstring(new_filename, tag, msLookupHashTable(table, default_key));
-        free(tag);
-
-        msSetOutputFormatOption(format, option, new_filename);
-        free(new_filename);
-      }
-      default_key = msNextKeyFromHashTable(table, default_key);
-    }
-    msFree(tmpfilename);
-  }
-  return;
-}
-
-static void applyClassDefaultSubstitutions(classObj *class, hashTableObj *table)
-{
-  const char *default_key = msFirstKeyFromHashTable(table);
-  while(default_key) {
-    if(!strncasecmp(default_key,"default_",8)) {
-      size_t buffer_size = (strlen(default_key)-5);
-      char *tag = (char *)msSmallMalloc(buffer_size);
-      snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
-
-      classSubstituteString(class, tag, msLookupHashTable(table, default_key));
-      free(tag);
-    }
-    default_key = msNextKeyFromHashTable(table, default_key);
-  }
-  return;
-}
-
-static void applyLayerDefaultSubstitutions(layerObj *layer, hashTableObj *table)
-{
-  int i;
-  const char *default_key = msFirstKeyFromHashTable(table);
-  while(default_key) {
-    if(!strncasecmp(default_key,"default_",8)) {
-      size_t buffer_size = (strlen(default_key)-5);
-      const char *to = msLookupHashTable(table, default_key);
-      char *tag = (char *)msSmallMalloc(buffer_size);
-      snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
-
-      for(i=0; i<layer->numclasses; i++) {
-        classSubstituteString(layer->class[i], tag, to);
-      }
-      layerSubstituteString(layer, tag, to);
-      free(tag);
-    }
-    default_key = msNextKeyFromHashTable(table, default_key);
-  }
-  return;
-}
-
-static void applyHashTableDefaultSubstitutions(hashTableObj *hashTab, hashTableObj *table)
-{
-  const char *default_key = msFirstKeyFromHashTable(table);
-  while (default_key) {
-    if (!strncasecmp(default_key, "default_", 8)) {
-      size_t buffer_size = (strlen(default_key) - 5);
-      const char *to = msLookupHashTable(table, default_key);
-      char *tag = (char *)msSmallMalloc(buffer_size);
-      snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
-
-      hashTableSubstituteString(hashTab, tag, to);
-      free(tag);
-    }
-    default_key = msNextKeyFromHashTable(table, default_key);
-  }
-  return;
-}
-
-/*
-** Loop through layer metadata for keys that have a default_%key% pattern to replace
-** remaining %key% entries by their default value.
-*/
-void msApplyDefaultSubstitutions(mapObj *map)
-{
-  int i,j;
-
-  /* output formats (#3751) */
-  for(i=0; i<map->numoutputformats; i++) {
-    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "filename", &(map->web.validation));
-    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "JSONP", &(map->web.validation));
-  }
-
-  for(i=0; i<map->numlayers; i++) {
-    layerObj *layer = GET_LAYER(map, i);
-
-    for(j=0; j<layer->numclasses; j++) {    /* class settings take precedence...  */
-      classObj *class = GET_CLASS(map, i, j);
-      applyClassDefaultSubstitutions(class, &(class->validation));
-    }
-
-    applyLayerDefaultSubstitutions(layer, &(layer->validation)); /* ...then layer settings... */
-    applyLayerDefaultSubstitutions(layer, &(map->web.validation)); /* ...and finally web settings */
-  }
-  applyHashTableDefaultSubstitutions(&map->web.metadata, &(map->web.validation));
-}
-
-char *_get_param_value(const char *key, char **names, char **values, int npairs) 
-{
-  if(npairs <= 0) return NULL; // bail, no point searching
-
-  if(getenv(key)) { /* envirronment override */
-    return getenv(key);
-  }
-  while(npairs) {
-    npairs--;
-    if(strcasecmp(key, names[npairs]) == 0) {
-      return values[npairs];
-    }
-  }
-  return NULL;
-}
-
-void msApplySubstitutions(mapObj *map, char **names, char **values, int npairs)
-{
-  int l;
-  const char *key, *value, *validation;
-  char *tag;
-  for(l=0; l<map->numlayers; l++) {
-    int c;
-    layerObj *lp = GET_LAYER(map,l);
-    for(c=0; c<lp->numclasses; c++) {
-      classObj *cp = lp->class[c];
-      key = NULL;
-      while( (key = msNextKeyFromHashTable(&cp->validation, key)) ) {
-        value = _get_param_value(key,names,values,npairs);
-        if(!value) continue; /*parameter was not in url*/
-        validation = msLookupHashTable(&cp->validation, key);
-        if(msEvalRegex(validation, value)) {
-          /* we've found a substitution and it validates correctly, now let's apply it */
-          tag = msSmallMalloc(strlen(key)+3);
-          sprintf(tag,"%%%s%%",key);
-          classSubstituteString(cp,tag,value);
-          free(tag);
-        } else {
-          msSetError(MS_REGEXERR, "Parameter pattern validation failed." , "msApplySubstitutions()");
-          if(map->debug || lp->debug) {
-            msDebug("layer (%s), class %d: failed to validate (%s=%s) for regex (%s)\n", lp->name, c, key, value, validation);
-          }
-        }
-
-      }
-    }
-    key = NULL;
-    while( (key = msNextKeyFromHashTable(&lp->validation, key)) ) {
-      value = _get_param_value(key,names,values,npairs);
-      if(!value) continue; /*parameter was not in url*/
-      validation = msLookupHashTable(&lp->validation, key);
-      if(msEvalRegex(validation, value)) {
-        /* we've found a substitution and it validates correctly, now let's apply it */
-        tag = msSmallMalloc(strlen(key)+3);
-        sprintf(tag,"%%%s%%",key);
-        layerSubstituteString(lp,tag,value);
-        free(tag);
-      } else {
-        msSetError(MS_REGEXERR, "Parameter pattern validation failed." , "msApplySubstitutions()");
-        if(map->debug || lp->debug) {
-          msDebug("layer (%s): failed to validate (%s=%s) for regex (%s)\n", lp->name, key, value, validation);
-        }
-      }
-
-    }
-  }
-  key = NULL;
-  while( (key = msNextKeyFromHashTable(&map->web.validation, key)) ) {
-    value = _get_param_value(key,names,values,npairs);
-    if(!value) continue; /*parameter was not in url*/
-    validation = msLookupHashTable(&map->web.validation, key);
-    if(msEvalRegex(validation, value)) {
-      /* we've found a substitution and it validates correctly, now let's apply it */
-      tag = msSmallMalloc(strlen(key)+3);
-      sprintf(tag,"%%%s%%",key);
-      mapSubstituteString(map,tag,value);
-      free(tag);
-    } else {
-      msSetError(MS_REGEXERR, "Parameter pattern validation failed." , "msApplySubstitutions()");
-      if(map->debug) {
-        msDebug("failed to validate (%s=%s) for regex (%s)\n", key, value, validation);
-      }
-    }
-
-  }
-}
-
-/*
-** Returns an array with one entry per mapfile token.  Useful to manipulate
-** mapfiles in MapScript.
-**
-** The returned array should be freed using msFreeCharArray().
-*/
-static char **tokenizeMapInternal(char *filename, int *ret_numtokens)
-{
-  char **tokens = NULL;
-  int  numtokens=0, numtokens_allocated=0;
-  size_t buffer_size = 0;
-
-  *ret_numtokens = 0;
-
-  if(!filename) {
-    msSetError(MS_MISCERR, "Filename is undefined.", "msTokenizeMap()");
-    return NULL;
-  }
-
-  /*
-  ** Check map filename to make sure it's legal
-  */
-  const char *ms_mapfile_pattern = CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
-  if(msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
-    msSetError(MS_REGEXERR, "Filename validation failed." , "msLoadMap()");
-    return(NULL);
-  }
-
-  if((msyyin = fopen(filename,"r")) == NULL) {
-    msSetError(MS_IOERR, "(%s)", "msTokenizeMap()", filename);
-    return NULL;
-  }
-
-  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return comments */
-  msyylex();
-  msyyreturncomments = 1; /* want all tokens, including comments */
-
-  msyyrestart(msyyin); /* start at line begining, line 1 */
-  msyylineno = 1;
-
-  numtokens = 0;
-  numtokens_allocated = 256;
-  tokens = (char **) malloc(numtokens_allocated*sizeof(char*));
-  if(tokens == NULL) {
-    msSetError(MS_MEMERR, NULL, "msTokenizeMap()");
-    fclose(msyyin);
-    return NULL;
-  }
-
-  for(;;) {
-
-    if(numtokens_allocated <= numtokens) {
-      numtokens_allocated *= 2; /* double size of the array every time we reach the limit */
-      char** tokensNew = (char **)realloc(tokens, numtokens_allocated*sizeof(char*));
-      if(tokensNew == NULL) {
-        msSetError(MS_MEMERR, "Realloc() error.", "msTokenizeMap()");
-        fclose(msyyin);
-        for(int i=0; i<numtokens; i++)
-            msFree(tokens[i]);
-        msFree(tokens);
-        return NULL;
-      }
-      tokens = tokensNew;
-    }
-
-    switch(msyylex()) {
-      case(EOF): /* This is the normal way out... cleanup and exit */
-        fclose(msyyin);
-        *ret_numtokens = numtokens;
-        return(tokens);
-        break;
-      case(MS_STRING):
-        buffer_size = strlen(msyystring_buffer)+2+1;
-        tokens[numtokens] = (char*) msSmallMalloc(buffer_size);
-        snprintf(tokens[numtokens], buffer_size, "\"%s\"", msyystring_buffer);
-        break;
-      case(MS_EXPRESSION):
-        buffer_size = strlen(msyystring_buffer)+2+1;
-        tokens[numtokens] = (char*) msSmallMalloc(buffer_size);
-        snprintf(tokens[numtokens], buffer_size, "(%s)", msyystring_buffer);
-        break;
-      case(MS_REGEX):
-        buffer_size = strlen(msyystring_buffer)+2+1;
-        tokens[numtokens] = (char*) msSmallMalloc(buffer_size);
-        snprintf(tokens[numtokens], buffer_size, "/%s/", msyystring_buffer);
-        break;
-      default:
-        tokens[numtokens] = msStrdup(msyystring_buffer);
-        break;
-    }
-
-    if(tokens[numtokens] == NULL) {
-      int i;
-      msSetError(MS_MEMERR, NULL, "msTokenizeMap()");
-      fclose(msyyin);
-      for(i=0; i<numtokens; i++)
-        msFree(tokens[i]);
-      msFree(tokens);
-      return NULL;
-    }
-
-    numtokens++;
-  }
-
-  return NULL;   /* should never get here */
-}
-
-/*
-** Wraps tokenizeMapInternal
-*/
-char **msTokenizeMap(char *filename, int *numtokens)
-{
-  char **tokens;
-
-  msAcquireLock( TLOCK_PARSER );
-  tokens = tokenizeMapInternal( filename, numtokens );
-  msReleaseLock( TLOCK_PARSER );
-
-  return tokens;
-}
-
-void msCloseConnections(mapObj *map)
-{
-  int i;
-  layerObj *lp;
-
-  for (i=0; i<map->numlayers; i++) {
-    lp = (GET_LAYER(map, i));
-
-    /* If the vtable is null, then the layer is never accessed or used -> skip it
-     */
-    if (lp->vtable) {
-      lp->vtable->LayerCloseConnection(lp);
-    }
-  }
-}
-
-void initResultCache(resultCacheObj *resultcache)
-{
-  if (resultcache) {
-    resultcache->results = NULL;
-    resultcache->numresults = 0;
-    resultcache->cachesize = 0;
-    resultcache->bounds.minx = resultcache->bounds.miny = resultcache->bounds.maxx = resultcache->bounds.maxy = -1;
-    resultcache->previousBounds = resultcache->bounds;
-  }
-}
-
-void cleanupResultCache(resultCacheObj *resultcache)
-{
-  if(resultcache) {
-    if(resultcache->results)
-    {
-        int i;
-        for( i = 0; i < resultcache->numresults; i++ )
-        {
-            if( resultcache->results[i].shape )
-            {
-                msFreeShape( resultcache->results[i].shape );
-                msFree( resultcache->results[i].shape );
-            }
-        }
-        free(resultcache->results);
-    }
-    resultcache->results = NULL;
-    initResultCache(resultcache);
-  }
-}
-
-
-static int resolveSymbolNames(mapObj* map)
-{
-  int i, j;
-
-  /* step through layers and classes to resolve symbol names */
-  for(i=0; i<map->numlayers; i++) {
-    for(j=0; j<GET_LAYER(map, i)->numclasses; j++) {
-      if(classResolveSymbolNames(GET_LAYER(map, i)->class[j]) != MS_SUCCESS) return MS_FAILURE;
-    }
-  }
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapfile.dtd 8.2.0~beta1-1~exp1/mapfile.dtd
--- 8.0.1-5/mapfile.dtd	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapfile.dtd	1970-01-01 00:00:00.000000000 +0000
@@ -1,243 +0,0 @@
-<!-- MapServer Map File DTD -->
-
-<!-- 
-  top level MAP object 
-
-<!ELEMENT MAP 
-  ((EXTENT|FONTSET|IMAGECOLOR|IMAGETYPE|IMAGEQUALITY|INTERLACE|SHAPEPATH|SIZE|SYMBOLSET|TRANSPARENT|UNITS|METADATA)*,(LEGEND|PROJECTION|QUERYMAP|REFERENCE|SCALEBAR|WEB)*,(SYMBOL|LAYER)+)
->
-
-  -->
-<!ELEMENT MAP 
-  (EXTENT|FONTSET|IMAGECOLOR|IMAGETYPE|IMAGEQUALITY|INTERLACE|SHAPEPATH|SIZE|SYMBOLSET|TRANSPARENT|UNITS|METADATA|LEGEND|PROJECTION|QUERYMAP|REFERENCE|SCALEBAR|WEB|SYMBOL|LAYER)*
->
-<!ATTLIST MAP 
-  NAME NMTOKEN #REQUIRED
-  STATUS (ON|OFF) "ON"
->
-<!ELEMENT EXTENT (#PCDATA)>
-<!ELEMENT FONTSET (#PCDATA)>
-<!ELEMENT IMAGECOLOR (#PCDATA)>
-<!ELEMENT IMAGETYPE (#PCDATA)>
-<!ELEMENT IMAGEQUALITY (#PCDATA)>
-<!ELEMENT INTERLACE (#PCDATA)>
-<!ELEMENT SHAPEPATH (#PCDATA)>
-<!ELEMENT SIZE (#PCDATA)>
-<!ELEMENT SYMBOLSET (#PCDATA)>
-<!ELEMENT TRANSPARENT (#PCDATA)>
-<!ELEMENT UNITS (#PCDATA)>
-
-<!-- 
-  LEGEND object
-  -->
-<!ELEMENT LEGEND 
-  (IMAGECOLOR|INTERLACE|KEYSIZE|KEYSPACING|LABEL|OUTLINECOLOR|POSITION|POSTLABELCACHE|TRANSPARENT)*
->
-<!ATTLIST LEGEND
-  STATUS (ON|OFF|EMBED) "OFF"
->
-<!-- IMAGECOLOR already declared -->
-<!-- INTERLACE already declared -->
-<!ELEMENT KEYSIZE (#PCDATA)>
-<!ELEMENT KEYSPACING (#PCDATA)>
-<!ELEMENT OUTLINECOLOR (#PCDATA)>
-<!ELEMENT POSITION (#PCDATA)>
-<!ELEMENT POSTLABELCACHE (#PCDATA)>
-<!-- TRANSPARENT already declared -->
-
-<!-- 
-  QUERYMAP object
-  -->
-<!ELEMENT QUERYMAP 
-  (COLOR|SIZE)*
->
-<!ATTLIST QUERYMAP   
-  STATUS (ON|OFF) "OFF"
-  STYLE (HILITE|NORMAL|SELECTED) "HILITE"
->
-<!ELEMENT COLOR (#PCDATA)>
-<!-- SIZE already declared -->
-
-<!-- 
-  a PROJECTION object - nothing more that character data 
-  -->
-<!ELEMENT PROJECTION (#PCDATA)>
-
-<!-- 
-  a SCALEBAR object
-  -->
-<!ELEMENT SCALEBAR 
-  (BACKGROUNDCOLOR|COLOR|IMAGECOLOR|INTERLACE|INTERVALS|LABEL|OUTLINECOLOR|POSITION|POSTLABELCACHE|SIZE|TRANSPARENT|UNITS)*
->
-<!ATTLIST SCALEBAR
-  STATUS (ON|OFF|EMBED) "OFF"
-  STYLE (0|1) "0"
->
-<!ELEMENT BACKGROUNDCOLOR (#PCDATA)>
-<!-- ELEMENT COLOR (#PCDATA) -->
-<!-- IMAGECOLOR already declared -->
-<!-- INTERLACE already declared -->
-<!ELEMENT INTERVALS (#PCDATA)>
-<!-- OUTLINECOLOR already declared -->
-<!-- POSITION already declared -->
-<!-- POSTLABELCACHE already declared -->
-<!-- SIZE already declared -->
-<!-- TRANSPARENT already declared -->
-<!-- UNITS already declared -->
-
-<!-- 
-  a REFERENCE map object
-  -->
-<!ELEMENT REFERENCE
-  (COLOR|EXTENT|IMAGE|OUTLINECOLOR|SIZE)*
->
-<!ATTLIST REFERENCE
-  STATUS (ON|OFF) "OFF"
->
-<!-- COLOR already declared -->
-<!-- EXTENT already declared -->
-<!ELEMENT IMAGE (#PCDATA)>
-<!-- OUTLINECOLOR already declared -->
-<!-- SIZE already declared -->
-
-<!-- 
-  a WEB object
-  -->
-<!ELEMENT WEB
-  (ERROR|EMPTY|FOOTER|HEADER|IMAGEPATH|IMAGEURL|LOG|MAXSCALE|MAXTEMPLATE|MINSCALE|MINTEMPLATE|TEMPLATE|METADATA)*
->
-<!ELEMENT EMPTY (#PCDATA)>
-<!ELEMENT ERROR (#PCDATA)>
-<!ELEMENT FOOTER (#PCDATA)>
-<!ELEMENT HEADER (#PCDATA)>
-<!ELEMENT IMAGEPATH (#PCDATA)>
-<!ELEMENT IMAGEURL (#PCDATA)>
-<!ELEMENT LOG (#PCDATA)>
-<!ELEMENT MAXSCALE (#PCDATA)>
-<!ELEMENT MAXTEMPLATE (#PCDATA)>
-<!ELEMENT MINSCALE (#PCDATA)>
-<!ELEMENT MINTEMPLATE (#PCDATA)>
-<!ELEMENT TEMPLATE (#PCDATA)>
-<!ELEMENT METADATA (#PCDATA)>
-
-<!--
-  a LAYER object
-  -->
-<!ELEMENT LAYER 
-  (CLASS|CLASSITEM|CONNECTION|CONNECTIONTYPE|DATA|DESCRIPTION|FEATURE|FILTER|FILTERITEM|FOOTER|GROUP|HEADER|TEMPLATE|LABELANGLEITEM|LABELCACHE|LABELITEM|LABELMAXSCALE|LABELMINSCALE|LABELREQUIRES|LABELSIZEITEM|MAXFEATURES|MAXSCALE|MINSCALE|OFFSITE|POSTLABELCACHE|PROJECTION|REQUIRES|SYMBOLSCALE|TILEINDEX|TILEITEM|TILESRS|TOLERANCE|TOLERANCEUNITS|TRANSFORM|TRANSPARENCY|METADATA)*
->
-<!ATTLIST LAYER 
-  NAME NMTOKEN #REQUIRED
-  STATUS (ON|OFF|DEFAULT) "OFF"
-  TYPE (ANNOTATION|POINT|LINE|POLYGON|POLYLINE|QUERY|RASTER) #REQUIRED
->
-<!ELEMENT CLASSITEM (#PCDATA)>
-<!ELEMENT CONNECTION (#PCDATA)>
-<!ELEMENT CONNECTIONTYPE (#PCDATA)>
-<!ELEMENT DATA (#PCDATA)>
-<!ELEMENT DESCRIPTION (#PCDATA)>
-<!-- ELEMENT FEATURE (#PCDATA) -->
-<!ELEMENT FILTER (#PCDATA)>
-<!ELEMENT FILTERITEM (#PCDATA)>
-<!-- FOOTER already declared -->
-<!ELEMENT GROUP (#PCDATA)>
-<!-- HEADER already declared -->
-<!ELEMENT LABELANGLEITEM (#PCDATA)>
-<!ELEMENT LABELCACHE (#PCDATA)>
-<!ELEMENT LABELITEM (#PCDATA)>
-<!ELEMENT LABELMAXSCALE (#PCDATA)>
-<!ELEMENT LABELMINSCALE (#PCDATA)>
-<!ELEMENT LABELREQUIRES (#PCDATA)>
-<!ELEMENT LABELSIZEITEM (#PCDATA)>
-<!ELEMENT MAXFEATURES (#PCDATA)>
-<!-- MAXSCALE already declared -->
-<!-- MINSCALE already declared -->
-<!ELEMENT OFFSITE (#PCDATA)>
-<!-- POSTLABELCACHE already declared -->
-<!ELEMENT REQUIRES (#PCDATA)>
-<!ELEMENT SYMBOLSCALE (#PCDATA)>
-<!ELEMENT TILEINDEX (#PCDATA)>
-<!ELEMENT TILEITEM (#PCDATA)>
-<!ELEMENT TILESRS (#PCDATA)>
-<!ELEMENT TOLERANCE (#PCDATA)>
-<!ELEMENT TOLERANCEUNITS (#PCDATA)>
-<!ELEMENT TRANSFORM (#PCDATA)>
-<!ELEMENT TRANSPARENCY (#PCDATA)>
-
-<!--
-  a FEATURE object
-  -->
-<!ELEMENT FEATURE
-  (POINTS|TEXT)*
->
-<!ELEMENT POINTS (#PCDATA)>
-<!ELEMENT TEXT (#PCDATA)>
-
-<!--
-  a CLASS object
-  -->
-<!ELEMENT CLASS
-  (BACKGROUNDCOLOR|COLOR|EXPRESSION|LABEL|MAXSIZE|MINSIZE|OUTLINECOLOR|OVERLAYBACKGROUNDCOLOR|OVERLAYCOLOR|OVERLAYMAXSIZE|OVERLAYMINSIZE|OVERLAYOUTLINECOLOR|OVERLAYSIZE|OVERLAYSYMBOL|SIZE|SYMBOL|TEMPLATE|TEXT|TYPE)*
->
-<!ATTLIST CLASS
-  NAME CDATA #IMPLIED
->
-<!-- BACKGROUNDCOLOR already declared -->
-<!-- COLOR already declared -->
-<!ELEMENT EXPRESSION (#PCDATA)>
-<!ELEMENT MAXSIZE (#PCDATA)>
-<!ELEMENT MINSIZE (#PCDATA)>
-<!-- OUTLINECOLOR already declared -->
-<!ELEMENT OVERLAYBACKGROUNDCOLOR (#PCDATA)>
-<!ELEMENT OVERLAYCOLOR (#PCDATA)>
-<!ELEMENT OVERLAYMAXSIZE (#PCDATA)>
-<!ELEMENT OVERLAYMINSIZE (#PCDATA)>
-<!ELEMENT OVERLAYOUTLINECOLOR (#PCDATA)>
-<!ELEMENT OVERLAYSIZE (#PCDATA)>
-<!ELEMENT OVERLAYSYMBOL (#PCDATA)>
-<!-- SIZE already declared -->
-<!ELEMENT SYMBOL (#PCDATA)>
-<!-- TEMPLATE already declared -->
-<!-- TEXT already declared -->
-<!ELEMENT TYPE (#PCDATA)>
-
-<!--
-  a LABEL object
-  -->
-<!ELEMENT LABEL
- (ANGLE|ANTIALIAS|BUFFER|BACKGROUNDCOLOR|BACKGROUNDSHADOWCOLOR|BACKGROUNDSHADOWSIZE|COLOR|FONT|FORCE|MAXSIZE|MINDISTANCE|MINFEATURESIZE|MINSIZE|OFFSET|OUTLINECOLOR|PARTIALS|POSITION|SHADOWCOLOR|SHADOWSIZE|SIZE|WRAP)*
->
-<!ATTLIST LABEL   
-  TYPE (BITMAP|TRUETYPE) #REQUIRED
->
-<!ELEMENT ANGLE (#PCDATA)>
-<!ELEMENT ANTIALIAS (#PCDATA)>
-<!ELEMENT BUFFER (#PCDATA)>
-<!-- BACKGROUNDCOLOR already declared -->
-<!ELEMENT BACKGROUNDSHADOWCOLOR (#PCDATA)>
-<!ELEMENT BACKGROUNDSHADOWSIZE (#PCDATA)>
-<!-- COLOR already declared -->
-<!ELEMENT FONT (#PCDATA)>
-<!ELEMENT FORCE (#PCDATA)>
-<!-- MAXSIZE already declared -->
-<!ELEMENT MINDISTANCE (#PCDATA)>
-<!ELEMENT MINFEATURESIZE (#PCDATA)>
-<!-- MINSIZE already declared -->
-<!-- OFFSET already declared -->
-<!ELEMENT OFFSET (#PCDATA)>
-<!-- OUTLINECOLOR already declared -->
-<!ELEMENT PARTIALS (#PCDATA)>
-<!-- POSITION already declared -->
-<!ELEMENT SHADOWCOLOR (#PCDATA)>
-<!ELEMENT SHADOWSIZE (#PCDATA)>
-<!-- SIZE already declared -->
-<!ELEMENT WRAP (#PCDATA)>
-
-<!--
-  a JOIN object (still under development)
-  -->
-
-<!--
-  a SYMBOL object
-  -->
-  
diff -pruN 8.0.1-5/mapfile.h 8.2.0~beta1-1~exp1/mapfile.h
--- 8.0.1-5/mapfile.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapfile.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,319 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Keyword definitions for the mapfiles and symbolfiles.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-#ifndef MAPFILE_H
-#define MAPFILE_H
-
-enum MS_LEXER_STATES {MS_TOKENIZE_DEFAULT=0, MS_TOKENIZE_FILE, MS_TOKENIZE_STRING, MS_TOKENIZE_EXPRESSION, MS_TOKENIZE_VALUE, MS_TOKENIZE_NAME, MS_TOKENIZE_CONFIG};
-enum MS_TOKEN_SOURCES {MS_FILE_TOKENS=0, MS_STRING_TOKENS};
-
-/*
-** Keyword definitions for the mapfiles and symbolfiles (used by lexer)
-*/
-#define ANGLE 1000
-#define ANTIALIAS 1001
-#define BACKGROUNDCOLOR 1002
-#define BUFFER 1003
-#define CLASS 1004
-#define CLASSITEM 1005
-#define COLOR 1006
-#define DATA 1007
-#define DD 1008
-
-#define EMPTY 1010
-#define END 1011
-#define ERROR 1012
-#define EXPRESSION 1013
-#define EXTENT 1014
-#define FEATURE 1015
-#define FILLED 1016
-#define FOOTER 1017
-#define FONT 1018
-#define FONTSET 1019
-#define FROM 1020
-#define GROUP 1021
-#define HEADER 1022
-#define IMAGE 1023
-#define IMAGECOLOR 1024
-#define IMAGEPATH 1025
-#define IMAGEURL 1026
-#define INDEX 1027
-#define INTERLACE 1028
-#define INTERVALS 1029
-#define JOIN 1030
-#define KEYSIZE 1031
-#define KEYSPACING 1032
-#define LABEL 1033
-#define LABELCACHE 1035
-#define LABELITEM 1036
-#define LABELMAXSCALE 1037
-#define LABELMINSCALE 1038
-#define LAYER 1040
-#define LEGEND 1041
-
-#define LOG 1043
-#define MAP 1044
-
-
-#define MAXFEATURES 1047
-#define MAXSCALE 1048
-#define MAXSIZE 1049
-#define MAXTEMPLATE 1050
-#define MINDISTANCE 1051
-#define MINFEATURESIZE 1053
-#define MINSCALE 1054
-#define MINSIZE 1055
-#define MINTEMPLATE 1056
-#define NAME 1057
-#define NFTEMPLATE 1058
-
-#define OFFSET 1060
-#define OFFSITE 1061
-#define OUTLINECOLOR 1062
-#define PARTIALS 1063
-#define POINTS 1064
-#define POSITION 1065
-#define POSTLABELCACHE 1098
-#define PROJECTION 1066
-#define QUERY 1067
-#define QUERYITEM 1068
-#define QUERYMAP 1069
-#define REFERENCE 1070
-#define SCALE 1071
-#define SCALEBAR 1072
-
-#define SHADOWCOLOR 1074
-#define SHADOWSIZE 1075
-#define SHAPEPATH 1076
-#define SIZE 1077
-#define STATUS 1078
-
-#define STYLE 1080
-#define SYMBOL 1081
-#define SYMBOLSCALE 1082
-#define TABLE 1083
-#define TEMPLATE 1084
-#define TEXT 1085
-#define TEXTITEM 1086
-
-#define TILEINDEX 1088
-#define TILEITEM 1089
-#define TOLERANCE 1090
-#define TO 1091
-#define TRANSPARENT 1092
-#define TRANSFORM 1093
-#define TYPE 1094
-#define UNITS 1095
-#define WEB 1096
-#define WRAP 1097
-
-#define FORCE 1098
-#define TOLERANCEUNITS 1099
-#define CHARACTER 1100
-
-#define CONNECTION 1101
-#define CONNECTIONTYPE 1102
-
-#define SYMBOLSET 1105
-
-#define IMAGETYPE 1113
-#define IMAGEQUALITY 1114
-
-#define GAP 1115
-
-#define FILTER 1116
-#define FILTERITEM 1117
-
-#define REQUIRES 1118
-#define LABELREQUIRES 1119
-
-#define METADATA 1120
-#define LATLON 1121
-
-#define RESOLUTION 1122
-
-#define SIZEUNITS 1123
-
-#define STYLEITEM 1124
-
-#define TITLE 1126
-
-#define LINECAP 1127
-#define LINEJOIN 1128
-#define LINEJOINMAXSIZE 1129
-
-#define TRANSPARENCY 1130
-
-#define MARKER 1131
-#define MARKERSIZE 1132
-#define MINBOXSIZE 1133
-#define MAXBOXSIZE 1134
-
-#define OUTPUTFORMAT 1135
-#define MIMETYPE 1136
-#define DRIVER 1137
-#define IMAGEMODE 1138
-#define FORMATOPTION 1139
-
-#define GRATICULE 1140
-#define GRID 1141
-
-#define MAXARCS 1142
-#define MINARCS 1143
-#define MAXINTERVAL 1144
-#define MININTERVAL 1145
-#define MAXSUBDIVIDE 1146
-#define MINSUBDIVIDE  1147
-#define LABELFORMAT  1148
-
-#define PROCESSING  1153
-
-/* The DEBUG macro is also used to request debugging output.  Redefine
-   for keyword purposes.  */
-
-#ifdef DEBUG
-#undef DEBUG
-#endif
-
-#define DEBUG 1154
-
-#define EXTENSION 1155
-
-#define KEYIMAGE 1156
-#define QUERYFORMAT 1157
-
-#define CONFIG 1158
-#define BANDSITEM 1159
-
-#define ENCODING 1162
-
-#define WIDTH 1163
-#define MINWIDTH 1164
-#define MAXWIDTH 1165
-
-#define OUTLINEWIDTH 1166
-
-/* Color Range support (was Gradient Support)*/
-#define COLORRANGE 1170
-#define DATARANGE 1172
-#define RANGEITEM 1173
-
-/* WKT support (bug 1466) */
-#define WKT 1180
-
-#define LEGENDFORMAT 1190 /* bug 1518 */
-#define BROWSEFORMAT 1191
-
-#define RELATIVETO 1192
-
-#define OPACITY 1193
-#define PRIORITY 1194
-#define PATTERN 1195
-
-#define MAXSCALEDENOM 1196
-#define MINSCALEDENOM 1197
-#define LABELMAXSCALEDENOM 1198
-#define LABELMINSCALEDENOM 1199
-#define SYMBOLSCALEDENOM 1200
-#define SCALEDENOM 1201
-
-#define CLASSGROUP 1202
-
-#define ALIGN 1203 /* bug 2468 */
-
-#define MAXGEOWIDTH 1204
-#define MINGEOWIDTH 1205
-
-#define ITEMS 1206
-
-/* rfc40 label wrapping */
-#define MAXLENGTH 1210
-
-/* rfc44 URL configuration support */
-#define VALIDATION 1212
-
-/* rfc48 geometry transforms */
-#define GEOMTRANSFORM 1220
-
-/* rfc55 output resolution */
-#define DEFRESOLUTION 1221
-
-/* label repeat enhancement */
-#define REPEATDISTANCE 1222
-
-/* rfc60 label collision detection */
-#define MAXOVERLAPANGLE 1223
-
-/* rfc66 temporary path */
-#define TEMPPATH 1224
-
-/* rfc68 union connection type */
-#define UNION 1225
-
-/* rfc69 cluster */
-#define CLUSTER 1226
-#define MAXDISTANCE 1227
-#define REGION 1228
-
-#define INITIALGAP 1229
-#define ANCHORPOINT 1230
-
-#define MASK 1250
-
-#define POLAROFFSET 1251
-
-/* rfc78 leader-lines labels */
-#define LEADER 1260
-#define GRIDSTEP 1261
-
-/* rfc 86 scale-dependant token substitutions */
-#define SCALETOKEN 1270
-#define VALUES 1271
-
-#define TILESRS 1272
-
-/* rfc 93 support for utfgrid */
-#define UTFDATA 1280
-#define UTFITEM 1281
-
-/* rfc 113 layer compositing */
-#define COMPOSITE 1290
-#define COMPOP 1291
-#define COMPFILTER 1292
-
-
-#define BOM 1300
-
-/* rfc59 bindvals objects */
-#define BINDVALS 2000
-
-#define CONNECTIONOPTIONS 2001
-
-#endif /* MAPFILE_H */
diff -pruN 8.0.1-5/mapflatgeobuf.c 8.2.0~beta1-1~exp1/mapflatgeobuf.c
--- 8.0.1-5/mapflatgeobuf.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapflatgeobuf.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,366 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implements support for FlatGeobuf access.
- * Authors:  Björn Harrtell
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#define NEED_IGNORE_RET_VAL
-
-#include <limits.h>
-#include <assert.h>
-#include "mapserver.h"
-#include "mapows.h"
-
-#include "flatgeobuf/flatgeobuf_c.h"
-
-#include <cpl_conv.h>
-#include <ogr_srs_api.h>
-
-static void msFGBPassThroughFieldDefinitions(layerObj *layer, flatgeobuf_ctx *ctx)
-{
-  for (int i = 0; i < ctx->columns_len; i++) {
-    char item[255];
-    char gml_width[32], gml_precision[32];
-    const char *gml_type = NULL;
-
-    const flatgeobuf_column* column = &(ctx->columns[i]);
-    strncpy(item, column->name, 255 - 1);
-
-    gml_width[0] = '\0';
-    gml_precision[0] = '\0';
-
-    switch( column->type ) {
-      case flatgeobuf_column_type_byte:
-      case flatgeobuf_column_type_ubyte:
-      case flatgeobuf_column_type_bool:
-      case flatgeobuf_column_type_short:
-      case flatgeobuf_column_type_ushort:
-      case flatgeobuf_column_type_int:
-      case flatgeobuf_column_type_uint:
-        gml_type = "Integer";
-        sprintf( gml_width, "%d", 4 );
-        break;
-      case flatgeobuf_column_type_long:
-      case flatgeobuf_column_type_ulong:
-        gml_type = "Long";
-        sprintf( gml_width, "%d", 8 );
-        break;
-      case flatgeobuf_column_type_float:
-      case flatgeobuf_column_type_double:
-        gml_type = "Real";
-        sprintf( gml_width, "%d", 8 );
-        sprintf( gml_precision, "%d", 15 );
-        break;
-      case flatgeobuf_column_type_string:
-      case flatgeobuf_column_type_json:
-      case flatgeobuf_column_type_datetime:
-      default:
-        gml_type = "Character";
-        sprintf( gml_width, "%d", 4096 );
-        break;
-    }
-
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
-  }
-}
-
-void msFlatGeobufLayerFreeItemInfo(layerObj *layer)
-{
-  if (layer->iteminfo) {
-    free(layer->iteminfo);
-    layer->iteminfo = NULL;
-  }
-}
-
-int msFlatGeobufLayerInitItemInfo(layerObj *layer)
-{
-  if(!layer->layerinfo) {
-    msSetError(MS_FGBERR, "FlatGeobuf layer has not been opened.", "msFlatGeobufLayerInitItemInfo()");
-    return MS_FAILURE;
-  }
-
-  msFlatGeobufLayerFreeItemInfo(layer);
-
-  flatgeobuf_ctx *ctx;
-  ctx = layer->layerinfo;
-  if (!ctx)
-    return MS_FAILURE;
-
-  for (int j = 0; j < ctx->columns_len; j++)
-  {
-    ctx->columns[j].itemindex = -1;
-    for (int i = 0; i < layer->numitems; i++)
-    {
-        if (strcasecmp(layer->items[i], ctx->columns[j].name) == 0)
-        {
-            ctx->columns[j].itemindex = i;
-            break;
-        }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-int msFlatGeobufLayerOpen(layerObj *layer)
-{
-  char szPath[MS_MAXPATHLEN];
-  int ret;
-
-  if(layer->layerinfo)
-    return MS_SUCCESS;
-
-  if (msCheckParentPointer(layer->map,"map") == MS_FAILURE)
-    return MS_FAILURE;
-
-  flatgeobuf_ctx *ctx = flatgeobuf_init_ctx();
-  layer->layerinfo = ctx;
-
-  ctx->file = VSIFOpenL(msBuildPath(szPath, layer->map->mappath, layer->data), "rb");
-  if (!ctx->file)
-    ctx->file = VSIFOpenL(msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->data), "rb");
-  if (!ctx->file) {
-    layer->layerinfo = NULL;
-    flatgeobuf_free_ctx(ctx);
-    return MS_FAILURE;
-  }
-
-  ret = flatgeobuf_check_magicbytes(ctx);
-  if (ret == -1) {
-    layer->layerinfo = NULL;
-    flatgeobuf_free_ctx(ctx);
-    return MS_FAILURE;
-  }
-
-  ret = flatgeobuf_decode_header(ctx);
-  if (ret == -1) {
-    layer->layerinfo = NULL;
-    flatgeobuf_free_ctx(ctx);
-    return MS_FAILURE;
-  }
-
-  if (layer->projection.numargs > 0 &&
-      EQUAL(layer->projection.args[0], "auto")) {
-    OGRSpatialReferenceH hSRS = OSRNewSpatialReference( NULL );
-    char *pszWKT = NULL;
-    if (ctx->srid > 0) {
-      if (OSRImportFromEPSG(hSRS, ctx->srid) != OGRERR_NONE) {
-        OSRDestroySpatialReference(hSRS);
-        flatgeobuf_free_ctx(ctx);
-        return MS_FAILURE;
-      }
-      if (OSRExportToWkt(hSRS, &pszWKT) != OGRERR_NONE) {
-        OSRDestroySpatialReference(hSRS);
-        flatgeobuf_free_ctx(ctx);
-        return MS_FAILURE;
-      }
-    } else if (ctx->wkt == NULL) {
-      OSRDestroySpatialReference(hSRS);
-      return MS_SUCCESS;
-    }
-    int bOK = MS_FALSE;
-    if (msOGCWKT2ProjectionObj(ctx->wkt ? ctx->wkt : pszWKT, &(layer->projection), layer->debug) == MS_SUCCESS)
-      bOK = MS_TRUE;
-    CPLFree(pszWKT);
-    OSRDestroySpatialReference(hSRS);
-    if( bOK != MS_TRUE )
-      if( layer->debug || layer->map->debug )
-        msDebug( "Unable to get SRS from FlatGeobuf '%s' for layer '%s'.\n", szPath, layer->name );
-  }
-
-  return MS_SUCCESS;
-}
-
-int msFlatGeobufLayerIsOpen(layerObj *layer)
-{
-  if(layer->layerinfo)
-    return MS_TRUE;
-  else
-    return MS_FALSE;
-}
-
-int msFlatGeobufLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)isQuery;
-  flatgeobuf_ctx *ctx;
-  ctx = layer->layerinfo;
-  if (!ctx)
-    return MS_FAILURE;
-
-  if (!ctx->has_extent || !ctx->index_node_size)
-    return MS_SUCCESS;
-
-  if(msRectOverlap(&ctx->bounds, &rect) != MS_TRUE)
-    return MS_DONE;
-
-  if (msRectContained(&ctx->bounds, &rect) == MS_FALSE && ctx->index_node_size > 0)
-    flatgeobuf_index_search(ctx, &rect);
-  else
-    flatgeobuf_index_skip(ctx);
-
-  return MS_SUCCESS;
-}
-
-int msFlatGeobufLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  flatgeobuf_ctx *ctx;
-  ctx = layer->layerinfo;
-  if (!ctx)
-    return MS_FAILURE;
-
-  do {
-    if (ctx->search_result) {
-      if (ctx->search_index >= ctx->search_result_len - 1)
-        return MS_DONE;
-      flatgeobuf_search_item item = ctx->search_result[ctx->search_index];
-      if (VSIFSeekL(ctx->file, ctx->feature_offset + item.offset, SEEK_SET) == -1) {
-          msSetError(MS_FGBERR, "Unable to seek in file", "msFlatGeobufLayerNextShape");
-          return MS_FAILURE;
-      }
-      ctx->offset = ctx->feature_offset + item.offset;
-      ctx->search_index++;
-      ctx->feature_index = item.index;
-    }
-    int ret = flatgeobuf_decode_feature(ctx, layer, shape);
-    if (ret == -1)
-      return MS_FAILURE;
-    shape->index = ctx->feature_index;
-    if (!ctx->search_result)
-      ctx->feature_index++;
-    if (ctx->done)
-      return MS_DONE;
-    if (ctx->is_null_geom) {
-        msFreeCharArray(shape->values, shape->numvalues);
-        shape->values = NULL;
-    }
-  } while(ctx->is_null_geom);
-
-  return MS_SUCCESS;
-}
-
-int msFlatGeobufLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  
-  (void)shape;
-  (void)record;
-  flatgeobuf_ctx *ctx;
-  ctx = layer->layerinfo;
-  if (!ctx)
-    return MS_FAILURE;
-  long i = record->shapeindex;
-  if (i < 0 || (uint64_t) i >= ctx->features_count) {
-    msSetError(MS_MISCERR, "Invalid feature id", "msFlatGeobufLayerGetShape");
-    return MS_FAILURE;
-  }
-  uint64_t offset;
-  flatgeobuf_read_feature_offset(ctx, i, &offset);
-  if (VSIFSeekL(ctx->file, ctx->feature_offset + offset, SEEK_SET) == -1) {
-      msSetError(MS_FGBERR, "Unable to seek in file", "msFlatGeobufLayerGetShape");
-      return MS_FAILURE;
-  }
-  int ret = flatgeobuf_decode_feature(ctx, layer, shape);
-  if (ret == -1)
-    return MS_FAILURE;
-  return MS_SUCCESS;
-}
-
-int msFlatGeobufLayerClose(layerObj *layer)
-{
-  flatgeobuf_ctx *ctx;
-  ctx = layer->layerinfo;
-  if (!ctx)
-    return MS_SUCCESS;
-  VSIFCloseL(ctx->file);
-  flatgeobuf_free_ctx(ctx);
-  layer->layerinfo = NULL;
-  return MS_SUCCESS;
-}
-
-int msFlatGeobufLayerGetItems(layerObj *layer)
-{
-  const char *value;
-  flatgeobuf_ctx *ctx;
-  ctx = layer->layerinfo;
-  if (!ctx)
-    return MS_FAILURE;
-  layer->numitems = ctx->columns_len;
-
-  char **items = (char **) malloc(sizeof(char *) * ctx->columns_len);
-  for (int i = 0; i < ctx->columns_len; i++)
-    items[i] = msStrdup(ctx->columns[i].name);
-  layer->items = items;
-
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    msFGBPassThroughFieldDefinitions(layer, ctx);
-
-  return msLayerInitItemInfo(layer);
-}
-
-int msFlatGeobufLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  flatgeobuf_ctx *ctx;
-  ctx = layer->layerinfo;
-  extent->minx = ctx->xmin;
-  extent->miny = ctx->ymin;
-  extent->maxx = ctx->xmax;
-  extent->maxy = ctx->ymax;
-  return MS_SUCCESS;
-}
-
-int msFlatGeobufLayerSupportsCommonFilters(layerObj *layer)
-{
-  (void)layer;
-  return MS_TRUE;
-}
-
-int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerSupportsCommonFilters = msFlatGeobufLayerSupportsCommonFilters;
-  layer->vtable->LayerInitItemInfo = msFlatGeobufLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msFlatGeobufLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msFlatGeobufLayerOpen;
-  layer->vtable->LayerIsOpen = msFlatGeobufLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msFlatGeobufLayerWhichShapes;
-  layer->vtable->LayerNextShape = msFlatGeobufLayerNextShape;
-  layer->vtable->LayerGetShape = msFlatGeobufLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msFlatGeobufLayerClose;
-  layer->vtable->LayerGetItems = msFlatGeobufLayerGetItems;
-  layer->vtable->LayerGetExtent = msFlatGeobufLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerCloseConnection, use default */
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  /* layer->vtable->LayerTranslateFilter, use default */
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapflatgeobuf.h 8.2.0~beta1-1~exp1/mapflatgeobuf.h
--- 8.0.1-5/mapflatgeobuf.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapflatgeobuf.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,47 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  FlatGeobuf access API
- * Author:   Björn Harrtell.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPFLATGEOBUF_H
-#define MAPFLATGEOBUF_H
-
-#include <stdio.h>
-#include "mapprimitive.h"
-#include "mapproject.h"
-
-#include "cpl_vsi.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPFLATGEOBUF_H */
diff -pruN 8.0.1-5/mapgdal.cpp 8.2.0~beta1-1~exp1/mapgdal.cpp
--- 8.0.1-5/mapgdal.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgdal.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,710 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of support for output using GDAL.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 2002, Frank Warmerdam
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapthread.h"
-#include "mapgdal.h"
-#include <assert.h>
-
-
-#include "cpl_conv.h"
-#include "cpl_string.h"
-#include "ogr_srs_api.h"
-
-#include "gdal.h"
-
-static int    bGDALInitialized = 0;
-
-/************************************************************************/
-/*                          msGDALInitialize()                          */
-/************************************************************************/
-
-void msGDALInitialize( void )
-
-{
-  if( !bGDALInitialized ) {
-    msAcquireLock( TLOCK_GDAL );
-
-    GDALAllRegister();
-    CPLPushErrorHandler( CPLQuietErrorHandler );
-    msReleaseLock( TLOCK_GDAL );
-
-    bGDALInitialized = 1;
-  }
-}
-
-/************************************************************************/
-/*                           msGDALCleanup()                            */
-/************************************************************************/
-
-void msGDALCleanup( void )
-
-{
-  if( bGDALInitialized ) {
-    int iRepeat = 5;
-
-      /*
-      ** Cleanup any unreferenced but open datasets as will tend
-      ** to exist due to deferred close requests.  We are careful
-      ** to only close one file at a time before refecting the
-      ** list as closing some datasets may cause others to be
-      ** closed (subdatasets in a VRT for instance).
-      */
-    GDALDatasetH *pahDSList = NULL;
-    int nDSCount = 0;
-    int bDidSomething;
-
-    msAcquireLock( TLOCK_GDAL );
-
-    do {
-        int i;
-        GDALGetOpenDatasets( &pahDSList, &nDSCount );
-        bDidSomething = FALSE;
-        for( i = 0; i < nDSCount && !bDidSomething; i++ ) {
-          if( GDALReferenceDataset( pahDSList[i] ) == 1 ) {
-            GDALClose( pahDSList[i] );
-            bDidSomething = TRUE;
-          } else
-            GDALDereferenceDataset( pahDSList[i] );
-        }
-    } while( bDidSomething );
-
-    while( iRepeat-- )
-      CPLPopErrorHandler();
-
-    msReleaseLock( TLOCK_GDAL );
-
-    bGDALInitialized = 0;
-  }
-}
-
-/************************************************************************/
-/*                          msCleanVSIDir()                             */
-/*                                                                      */
-/*      For the temporary /vsimem/msout directory we need to be sure    */
-/*      things are clean before we start, and after we are done.        */
-/************************************************************************/
-
-void msCleanVSIDir( const char *pszDir )
-
-{
-  char **papszFiles = CPLReadDir( pszDir );
-  int i, nFileCount = CSLCount( papszFiles );
-
-  for( i = 0; i < nFileCount; i++ ) {
-    if( strcasecmp(papszFiles[i],".") == 0
-        || strcasecmp(papszFiles[i],"..") == 0 )
-      continue;
-
-    VSIUnlink( CPLFormFilename(pszDir, papszFiles[i], NULL) );
-  }
-
-  CSLDestroy( papszFiles );
-}
-
-/************************************************************************/
-/*                          msSaveImageGDAL()                           */
-/************************************************************************/
-
-int msSaveImageGDAL( mapObj *map, imageObj *image, const char *filenameIn )
-
-{
-  int  bFileIsTemporary = MS_FALSE;
-  GDALDatasetH hMemDS, hOutputDS;
-  GDALDriverH  hMemDriver, hOutputDriver;
-  int          nBands = 1;
-  int          iLine;
-  outputFormatObj *format = image->format;
-  rasterBufferObj rb;
-  GDALDataType eDataType = GDT_Byte;
-  int bUseXmp = MS_FALSE;
-  const char   *filename = NULL;
-  char         *filenameToFree = NULL;
-  const char   *gdal_driver_shortname = format->driver+5;
-
-  msGDALInitialize();
-  memset(&rb,0,sizeof(rasterBufferObj));
-
-#ifdef USE_EXEMPI
-  if( map != NULL ) {
-    bUseXmp = msXmpPresent(map);
-  }
-#endif
-
-
-  /* -------------------------------------------------------------------- */
-  /*      Identify the proposed output driver.                            */
-  /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_GDAL );
-  hOutputDriver = GDALGetDriverByName( gdal_driver_shortname );
-  if( hOutputDriver == NULL ) {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to find %s driver.",
-                "msSaveImageGDAL()", gdal_driver_shortname );
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      We will need to write the output to a temporary file and        */
-  /*      then stream to stdout if no filename is passed.  If the         */
-  /*      driver supports virtualio then we hold the temporary file in    */
-  /*      memory, otherwise we try to put it in a reasonable temporary    */
-  /*      file location.                                                  */
-  /* -------------------------------------------------------------------- */
-  if( filenameIn == NULL ) {
-    const char *pszExtension = format->extension;
-    if( pszExtension == NULL )
-      pszExtension = "img.tmp";
-
-    if( bUseXmp == MS_FALSE &&
-        msGDALDriverSupportsVirtualIOOutput(hOutputDriver) ) {
-      msCleanVSIDir( "/vsimem/msout" );
-      filenameToFree = msTmpFile(map, NULL, "/vsimem/msout/", pszExtension );
-    }
-
-    if( filenameToFree == NULL && map != NULL)
-      filenameToFree = msTmpFile(map, map->mappath,NULL,pszExtension);
-    else if( filenameToFree == NULL ) {
-      filenameToFree = msTmpFile(map, NULL, NULL, pszExtension );
-    }
-    filename = filenameToFree;
-
-    bFileIsTemporary = MS_TRUE;
-  }
-  else {
-    filename = filenameIn;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Establish the characteristics of our memory, and final          */
-  /*      dataset.                                                        */
-  /* -------------------------------------------------------------------- */
-
-  if( format->imagemode == MS_IMAGEMODE_RGB ) {
-    nBands = 3;
-    assert( MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer );
-    if(MS_UNLIKELY(MS_FAILURE == format->vtable->getRasterBufferHandle(image,&rb))) {
-      msReleaseLock( TLOCK_GDAL );
-      msFree( filenameToFree );
-      return MS_FAILURE;
-    }
-  } else if( format->imagemode == MS_IMAGEMODE_RGBA ) {
-    nBands = 4;
-    assert( MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer );
-    if(MS_UNLIKELY(MS_FAILURE == format->vtable->getRasterBufferHandle(image,&rb))) {
-      msReleaseLock( TLOCK_GDAL );
-      msFree( filenameToFree );
-      return MS_FAILURE;
-    }
-  } else if( format->imagemode == MS_IMAGEMODE_INT16 ) {
-    nBands = format->bands;
-    eDataType = GDT_Int16;
-  } else if( format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
-    nBands = format->bands;
-    eDataType = GDT_Float32;
-  } else if( format->imagemode == MS_IMAGEMODE_BYTE ) {
-    nBands = format->bands;
-    eDataType = GDT_Byte;
-  } else {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MEMERR, "Unknown format. This is a bug.", "msSaveImageGDAL()");
-    msFree( filenameToFree );
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create a memory dataset which we can use as a source for a      */
-  /*      CreateCopy().                                                   */
-  /* -------------------------------------------------------------------- */
-  hMemDriver = GDALGetDriverByName( "MEM" );
-  if( hMemDriver == NULL ) {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to find MEM driver.",
-                "msSaveImageGDAL()" );
-    msFree( filenameToFree );
-    return MS_FAILURE;
-  }
-
-  hMemDS = GDALCreate( hMemDriver, "msSaveImageGDAL_temp",
-                       image->width, image->height, nBands,
-                       eDataType, NULL );
-  if( hMemDS == NULL ) {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to create MEM dataset.",
-                "msSaveImageGDAL()" );
-    msFree( filenameToFree );
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Copy the gd image into the memory dataset.                      */
-  /* -------------------------------------------------------------------- */
-  for( iLine = 0; iLine < image->height; iLine++ ) {
-    int iBand;
-
-    for( iBand = 0; iBand < nBands; iBand++ ) {
-      CPLErr eErr;
-      GDALRasterBandH hBand = GDALGetRasterBand( hMemDS, iBand+1 );
-
-      if( format->imagemode == MS_IMAGEMODE_INT16 ) {
-        eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                      image->img.raw_16bit + iLine * image->width
-                      + iBand * image->width * image->height,
-                      image->width, 1, GDT_Int16, 2, 0 );
-
-      } else if( format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
-        eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                      image->img.raw_float + iLine * image->width
-                      + iBand * image->width * image->height,
-                      image->width, 1, GDT_Float32, 4, 0 );
-      } else if( format->imagemode == MS_IMAGEMODE_BYTE ) {
-        eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                      image->img.raw_byte + iLine * image->width
-                      + iBand * image->width * image->height,
-                      image->width, 1, GDT_Byte, 1, 0 );
-      } else {
-        GByte *pabyData;
-        unsigned char *pixptr = NULL;
-        assert( rb.type == MS_BUFFER_BYTE_RGBA );
-        switch(iBand) {
-          case 0:
-            pixptr = rb.data.rgba.r;
-            break;
-          case 1:
-            pixptr = rb.data.rgba.g;
-            break;
-          case 2:
-            pixptr = rb.data.rgba.b;
-            break;
-          case 3:
-            pixptr = rb.data.rgba.a;
-            break;
-        }
-        assert(pixptr);
-        if( pixptr == NULL ) {
-          msReleaseLock( TLOCK_GDAL );
-          msSetError( MS_MISCERR, "Missing RGB or A buffer.\n",
-                      "msSaveImageGDAL()" );
-          GDALClose(hMemDS);
-          msFree( filenameToFree );
-          return MS_FAILURE;
-        }
-
-        pabyData = (GByte *)(pixptr + iLine*rb.data.rgba.row_step);
-
-        if( rb.data.rgba.a == NULL || iBand == 3 ) {
-          eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                        pabyData, image->width, 1, GDT_Byte,
-                        rb.data.rgba.pixel_step, 0 );
-        } else { /* We need to un-pre-multiple RGB by alpha. */
-          GByte *pabyUPM = (GByte*) malloc(image->width);
-          GByte *pabyAlpha= (GByte *)(rb.data.rgba.a + iLine*rb.data.rgba.row_step);
-          int i;
-
-          for( i = 0; i < image->width; i++ ) {
-            int alpha = pabyAlpha[i*rb.data.rgba.pixel_step];
-
-            if( alpha == 0 )
-              pabyUPM[i] = 0;
-            else {
-              int result = (pabyData[i*rb.data.rgba.pixel_step] * 255) / alpha;
-
-              if( result > 255 )
-                result = 255;
-
-              pabyUPM[i] = result;
-            }
-          }
-
-          eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                        pabyUPM, image->width, 1, GDT_Byte, 1, 0 );
-          free( pabyUPM );
-        }
-      }
-      if( eErr != CE_None ) {
-          msReleaseLock( TLOCK_GDAL );
-          msSetError( MS_MISCERR, "GDALRasterIO() failed.\n",
-                      "msSaveImageGDAL()" );
-          GDALClose(hMemDS);
-          msFree( filenameToFree );
-          return MS_FAILURE;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Attach the palette if appropriate.                              */
-  /* -------------------------------------------------------------------- */
-    if( format->imagemode == MS_IMAGEMODE_RGB ) {
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 1 ), GCI_RedBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 2 ), GCI_GreenBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 3 ), GCI_BlueBand );
-    } else if( format->imagemode == MS_IMAGEMODE_RGBA ) {
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 1 ), GCI_RedBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 2 ), GCI_GreenBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 3 ), GCI_BlueBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 4 ), GCI_AlphaBand );
-    }
-
-  /* -------------------------------------------------------------------- */
-  /*      Assign the projection and coordinate system to the memory       */
-  /*      dataset.                                                        */
-  /* -------------------------------------------------------------------- */
-
-  if( map != NULL ) {
-    char *pszWKT;
-
-    GDALSetGeoTransform( hMemDS, map->gt.geotransform );
-
-    pszWKT = msProjectionObj2OGCWKT( &(map->projection) );
-    if( pszWKT != NULL ) {
-      GDALSetProjection( hMemDS, pszWKT );
-      msFree( pszWKT );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Possibly assign a nodata value.                                 */
-  /* -------------------------------------------------------------------- */
-  const char *nullvalue = msGetOutputFormatOption(format,"NULLVALUE",NULL);
-  if( nullvalue != NULL ) {
-    const double dfNullValue = atof(nullvalue);
-    for( int iBand = 0; iBand < nBands; iBand++ ) {
-      GDALRasterBandH hBand = GDALGetRasterBand( hMemDS, iBand+1 );
-      GDALSetRasterNoDataValue( hBand, dfNullValue );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Try to save resolution in the output file.                          */
-  /* -------------------------------------------------------------------- */
-  if( image->resolution > 0 ) {
-    char res[30];
-
-    sprintf( res, "%lf", image->resolution );
-    GDALSetMetadataItem( hMemDS, "TIFFTAG_XRESOLUTION", res, NULL );
-    GDALSetMetadataItem( hMemDS, "TIFFTAG_YRESOLUTION", res, NULL );
-    GDALSetMetadataItem( hMemDS, "TIFFTAG_RESOLUTIONUNIT", "2", NULL );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Separate creation options from metadata items.                  */
-  /* -------------------------------------------------------------------- */
-  std::vector<char*> apszCreationOptions;
-  for( int i = 0; i < format->numformatoptions; i++ )
-  {
-    char* option = format->formatoptions[i];
-
-    // MDI stands for MetaDataItem
-    if( STARTS_WITH(option, "mdi_") )
-    {
-      const char* option_without_band = option + strlen("mdi_");
-      GDALMajorObjectH hObject = (GDALMajorObjectH)hMemDS;
-      if( STARTS_WITH(option_without_band, "BAND_") )
-      {
-        int nBandNumber = atoi(option_without_band + strlen("BAND_"));
-        if( nBandNumber > 0 && nBandNumber <= nBands )
-        {
-          const char* pszAfterBand = strchr(option_without_band + strlen("BAND_"), '_');
-          if( pszAfterBand != NULL )
-          {
-              hObject = (GDALMajorObjectH)GDALGetRasterBand(hMemDS, nBandNumber);
-              option_without_band = pszAfterBand + 1;
-          }
-        }
-        else {
-          msDebug("Invalid band number %d in metadata item option %s", nBandNumber, option);
-        }
-      }
-      if( hObject ) {
-        std::string osDomain(option_without_band);
-        size_t nUnderscorePos = osDomain.find('_');
-        if( nUnderscorePos != std::string::npos ) {
-          std::string osKeyValue = osDomain.substr(nUnderscorePos + 1);
-          osDomain.resize(nUnderscorePos);
-          if( osDomain == "default" )
-              osDomain.clear();
-          size_t nEqualPos = osKeyValue.find('=');
-          if( nEqualPos != std::string::npos )
-          {
-              GDALSetMetadataItem(hObject,
-                                  osKeyValue.substr(0, nEqualPos).c_str(),
-                                  osKeyValue.substr(nEqualPos + 1).c_str(),
-                                  osDomain.c_str());
-          }
-        }
-        else {
-          msDebug("Invalid format in metadata item option %s", option);
-        }
-      }
-    }
-    else
-    {
-      apszCreationOptions.emplace_back(option);
-    }
-  }
-  apszCreationOptions.emplace_back(nullptr);
-
-  /* -------------------------------------------------------------------- */
-  /*      Create a disk image in the selected output format from the      */
-  /*      memory image.                                                   */
-  /* -------------------------------------------------------------------- */
-  hOutputDS = GDALCreateCopy( hOutputDriver, filename, hMemDS, FALSE,
-                              &apszCreationOptions[0], NULL, NULL );
-
-
-  if( hOutputDS == NULL ) {
-    GDALClose( hMemDS );
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to create output %s file.\n%s",
-                "msSaveImageGDAL()", format->driver+5,
-                CPLGetLastErrorMsg() );
-    msFree( filenameToFree );
-    return MS_FAILURE;
-  }
-
-  /* closing the memory DS also frees all associated resources. */
-  GDALClose( hMemDS );
-
-  GDALClose( hOutputDS );
-  msReleaseLock( TLOCK_GDAL );
-
-
-  /* -------------------------------------------------------------------- */
-  /*      Are we writing license info into the image?                     */
-  /*      If so, add it to the temp file on disk now.                     */
-  /* -------------------------------------------------------------------- */
-#ifdef USE_EXEMPI
-  if ( bUseXmp == MS_TRUE ) {
-    if( msXmpWrite(map, filename) == MS_FAILURE ) {
-      /* Something bad happened. */
-      msSetError( MS_MISCERR, "XMP write to %s failed.\n",
-                  "msSaveImageGDAL()", filename);
-      msFree( filenameToFree );
-      return MS_FAILURE;
-    }
-  }
-#endif
-
-  /* -------------------------------------------------------------------- */
-  /*      Is this supposed to be a temporary file?  If so, stream to      */
-  /*      stdout and delete the file.                                     */
-  /* -------------------------------------------------------------------- */
-  if( bFileIsTemporary ) {
-    VSILFILE *fp;
-    unsigned char block[4000];
-    int bytes_read;
-
-    if( msIO_needBinaryStdout() == MS_FAILURE )
-    {
-      msFree( filenameToFree );
-      return MS_FAILURE;
-    }
-
-    /* We aren't sure how far back GDAL exports the VSI*L API, so
-       we only use it if we suspect we need it.  But we do need it if
-       holding temporary file in memory. */
-    fp = VSIFOpenL( filename, "rb" );
-    if( fp == NULL ) {
-      msSetError( MS_MISCERR,
-                  "Failed to open %s for streaming to stdout.",
-                  "msSaveImageGDAL()", filename );
-      msFree( filenameToFree );
-      return MS_FAILURE;
-    }
-
-    while( (bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0 )
-      msIO_fwrite( block, 1, bytes_read, stdout );
-
-    VSIFCloseL( fp );
-
-    VSIUnlink( filename );
-    msCleanVSIDir( "/vsimem/msout" );
-
-  }
-  msFree( filenameToFree );
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msInitGDALOutputFormat()                       */
-/************************************************************************/
-
-int msInitDefaultGDALOutputFormat( outputFormatObj *format )
-
-{
-  GDALDriverH hDriver;
-
-  msGDALInitialize();
-
-  /* -------------------------------------------------------------------- */
-  /*      check that this driver exists.  Note visiting drivers should    */
-  /*      be pretty threadsafe so don't bother acquiring the GDAL         */
-  /*      lock.                                                           */
-  /* -------------------------------------------------------------------- */
-  hDriver = GDALGetDriverByName( format->driver+5 );
-  if( hDriver == NULL ) {
-    msSetError( MS_MISCERR, "No GDAL driver named `%s' available.",
-                "msInitGDALOutputFormat()", format->driver+5 );
-    return MS_FAILURE;
-  }
-
-  if( GDALGetMetadataItem( hDriver, GDAL_DCAP_CREATE, NULL ) == NULL
-      && GDALGetMetadataItem( hDriver, GDAL_DCAP_CREATECOPY, NULL ) == NULL ) {
-    msSetError( MS_MISCERR, "GDAL `%s' driver does not support output.",
-                "msInitGDALOutputFormat()", format->driver+5 );
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize the object.                                          */
-  /* -------------------------------------------------------------------- */
-  format->imagemode = MS_IMAGEMODE_RGB;
-  format->renderer = MS_RENDER_WITH_AGG;
-
-  if( GDALGetMetadataItem( hDriver, GDAL_DMD_MIMETYPE, NULL ) != NULL )
-    format->mimetype =
-      msStrdup(GDALGetMetadataItem(hDriver,GDAL_DMD_MIMETYPE,NULL));
-  if( GDALGetMetadataItem( hDriver, GDAL_DMD_EXTENSION, NULL ) != NULL )
-    format->extension =
-      msStrdup(GDALGetMetadataItem(hDriver,GDAL_DMD_EXTENSION,NULL));
-
-  return MS_SUCCESS;
-}
-
-char** msGetStringListFromHashTable(hashTableObj* table)
-{
-  struct hashObj *tp = NULL;
-  int i;
-  char** papszRet = NULL;
-
-  if(!table) return NULL;
-  if(msHashIsEmpty(table)) return NULL;
-
-  for (i=0; i<MS_HASHSIZE; ++i) {
-    if (table->items[i] != NULL) {
-      for (tp=table->items[i]; tp!=NULL; tp=tp->next) {
-        papszRet = CSLSetNameValue(papszRet, tp->key, tp->data);
-      }
-    }
-  }
-  return papszRet;
-}
-
-
-/************************************************************************/
-/*                      msProjectionObj2OGCWKT()                        */
-/*                                                                      */
-/*      We stick to the C API for OGRSpatialReference object access     */
-/*      to allow MapServer+GDAL to be built without C++                 */
-/*      complications.                                                  */
-/*                                                                      */
-/*      Note that this function will return NULL on failure, and the    */
-/*      returned string should be freed with msFree().                  */
-/************************************************************************/
-
-char *msProjectionObj2OGCWKT( projectionObj *projection )
-
-{
-  OGRSpatialReferenceH hSRS;
-  char *pszWKT=NULL, *pszProj4, *pszInitEpsg=NULL;
-  int  nLength = 0, i;
-  OGRErr eErr;
-
-  if( projection->proj == NULL )
-    return NULL;
-
-  hSRS = OSRNewSpatialReference( NULL );
-  /* -------------------------------------------------------------------- */
-  /*      Look for an EPSG-like projection argument                       */
-  /* -------------------------------------------------------------------- */
-  if( projection->numargs == 1 &&
-        (pszInitEpsg = strcasestr(projection->args[0],"init=epsg:"))) {
-     int nEpsgCode = atoi(pszInitEpsg + strlen("init=epsg:"));
-     eErr = OSRImportFromEPSG(hSRS, nEpsgCode);
-  } else {
-    /* -------------------------------------------------------------------- */
-    /*      Form arguments into a full Proj.4 definition string.            */
-    /* -------------------------------------------------------------------- */
-    for( i = 0; i < projection->numargs; i++ )
-      nLength += strlen(projection->args[i]) + 2;
-
-    pszProj4 = (char *) CPLMalloc(nLength+2);
-    pszProj4[0] = '\0';
-
-    for( i = 0; i < projection->numargs; i++ ) {
-      strcat( pszProj4, "+" );
-      strcat( pszProj4, projection->args[i] );
-      strcat( pszProj4, " " );
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Ingest the string into OGRSpatialReference.                     */
-    /* -------------------------------------------------------------------- */
-    eErr =  OSRImportFromProj4( hSRS, pszProj4 );
-    CPLFree( pszProj4 );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Export as a WKT string.                                         */
-  /* -------------------------------------------------------------------- */
-  if( eErr == OGRERR_NONE )
-    OSRExportToWkt( hSRS, &pszWKT );
-
-  OSRDestroySpatialReference( hSRS );
-
-  if( pszWKT ) {
-    char *pszWKT2 = msStrdup(pszWKT);
-    CPLFree( pszWKT );
-
-    return pszWKT2;
-  } else
-    return NULL;
-}
-
-/************************************************************************/
-/*                    msGDALDriverSupportsVirtualIOOutput()             */
-/************************************************************************/
-
-int msGDALDriverSupportsVirtualIOOutput( GDALDriverH hDriver )
-{
-    /* We need special testing here for the netCDF driver, since recent */
-    /* GDAL versions advertize VirtualIO support, but this is only for the */
-    /* read-side of the driver, not the write-side. */
-    return GDALGetMetadataItem( hDriver, GDAL_DCAP_VIRTUALIO, NULL ) != NULL &&
-           !EQUAL(GDALGetDescription(hDriver), "netCDF");
-}
diff -pruN 8.0.1-5/mapgdal.h 8.2.0~beta1-1~exp1/mapgdal.h
--- 8.0.1-5/mapgdal.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgdal.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,46 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  GDAL interface
- * Author:   Even Rouault <even.rouault at spatialys.com>
- *
- ******************************************************************************
- * Copyright (c) 2020, Even Rouault <even.rouault at spatialys.com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPGDAL_H
-#define MAPGDAL_H
-
-#include "mapserver.h"
-#include "gdal.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-int msGDALDriverSupportsVirtualIOOutput( GDALDriverH hDriver );
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPGDAL_H */
diff -pruN 8.0.1-5/mapgeomtransform.c 8.2.0~beta1-1~exp1/mapgeomtransform.c
--- 8.0.1-5/mapgeomtransform.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgeomtransform.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,320 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose: RFC48 implementation of geometry transformations for styling
- * Author:   Thomas Bonfort , Camptocamp (thomas.bonfort at camptocamp.com)
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "mapthread.h"
-
-extern int yyparse(parseObj *p);
-
-void msStyleSetGeomTransform(styleObj *s, char *transform)
-{
-  msFree(s->_geomtransform.string);
-  if (!transform) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
-    s->_geomtransform.string = NULL;
-    return;
-  }
-  s->_geomtransform.string = msStrdup(transform);
-  if(!strncasecmp("start",transform,5)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_START;
-  } else if(!strncasecmp("end",transform,3)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_END;
-  } else if(!strncasecmp("vertices",transform,8)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_VERTICES;
-  } else if(!strncasecmp("bbox",transform,4)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_BBOX;
-  } else if(!strncasecmp("labelpnt",transform,8)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
-  } else if(!strncasecmp("labelpoly",transform,9)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOLY;
-  } else if(!strncasecmp("labelcenter",transform,11)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_LABELCENTER;
-  } else if(!strncasecmp("centroid",transform,8)) {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_CENTROID;
-  } else {
-    s->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
-    msSetError(MS_MISCERR,"unknown transform expression","msStyleSetGeomTransform()");
-    msFree(s->_geomtransform.string);
-    s->_geomtransform.string = NULL;
-  }
-}
-
-
-/*
- * return a copy of the geometry transform expression
- * returned char* must be freed by the caller
- */
-char *msStyleGetGeomTransform(styleObj *s)
-{
-  return msStrdup(s->_geomtransform.string);
-}
-
-
-double calcOrientation(pointObj *p1, pointObj *p2)
-{
-  double theta;
-  theta = atan2(p2->x - p1->x,p2->y - p1->y);
-  return MS_RAD_TO_DEG*(theta-MS_PI2);
-}
-
-double calcMidAngle(pointObj *p1, pointObj *p2, pointObj *p3)
-{
-  pointObj p1n;
-  double dx12, dy12, dx23, dy23, l12, l23;
-
-  /* We treat both segments as vector 1-2 and vector 2-3 and 
-   * compute their dx,dy and length 
-   */
-  dx12 = p2->x - p1->x;
-  dy12 = p2->y - p1->y;
-  l12 = sqrt(dx12*dx12 + dy12*dy12);
-  dx23 = p3->x - p2->x;
-  dy23 = p3->y - p2->y;
-  l23 = sqrt(dx23*dx23 + dy23*dy23);
-
-  /* Normalize length of vector 1-2 to same as length of vector 2-3 */
-  if (l12 > 0.0)
-  {
-    p1n.x = p2->x - dx12*(l23/l12);
-    p1n.y = p2->y - dy12*(l23/l12);
-  }
-  else
-    p1n = *p2;  /* segment 1-2 is 0-length, use segment 2-3 for orientation */
-
-  /* Return the orientation defined by the sum of the normalized vectors */
-  return calcOrientation(&p1n, p3);
-}
-
-/*
- * RFC48 implementation:
- *  - transform the original shapeobj
- *  - use the styleObj to render the transformed shapeobj
- */
-int msDrawTransformedShape(mapObj *map, imageObj *image, shapeObj *shape, styleObj *style, double scalefactor)
-{
-  int type = style->_geomtransform.type;
-  int i,j,status = MS_SUCCESS;
-  switch(type) {
-    case MS_GEOMTRANSFORM_END: /*render point on last vertex only*/
-      for(j=0; j<shape->numlines; j++) {
-        lineObj *line = &(shape->line[j]);
-        pointObj *p = &(line->point[line->numpoints-1]);
-        if(p->x<0||p->x>image->width||p->y<0||p->y>image->height)
-          continue;
-        if(style->autoangle==MS_TRUE && line->numpoints>1) {
-          style->angle = calcOrientation(&(line->point[line->numpoints-2]),p);
-        }
-        status = msDrawMarkerSymbol(map,image,p,style,scalefactor);
-      }
-      break;
-    case MS_GEOMTRANSFORM_START: /*render point on first vertex only*/
-      for(j=0; j<shape->numlines; j++) {
-        lineObj *line = &(shape->line[j]);
-        pointObj *p = &(line->point[0]);
-        /*skip if outside image*/
-        if(p->x<0||p->x>image->width||p->y<0||p->y>image->height)
-          continue;
-        if(style->autoangle==MS_TRUE && line->numpoints>1) {
-          style->angle = calcOrientation(p,&(line->point[1]));
-        }
-        status = msDrawMarkerSymbol(map,image,p,style,scalefactor);
-      }
-      break;
-    case MS_GEOMTRANSFORM_VERTICES:
-      for(j=0; j<shape->numlines; j++) {
-        lineObj *line = &(shape->line[j]);
-        for(i=1; i<line->numpoints-1; i++) {
-          pointObj *p = &(line->point[i]);
-          /*skip points outside image*/
-          if(p->x<0||p->x>image->width||p->y<0||p->y>image->height)
-            continue;
-          if(style->autoangle==MS_TRUE) {
-            style->angle = calcMidAngle(&(line->point[i-1]),&(line->point[i]),&(line->point[i+1]));
-          }
-          status = msDrawMarkerSymbol(map,image,p,style,scalefactor);
-        }
-      }
-      break;
-    case MS_GEOMTRANSFORM_BBOX: {
-      shapeObj bbox;
-      lineObj bbox_line;
-      pointObj bbox_points[5];
-      int padding = MS_MAX(style->width,style->size)+3; /* so clipped shape does not extent into image */
-
-      /*create a shapeObj representing the bounding box (clipped by the image size)*/
-      bbox.numlines = 1;
-      bbox.line = &bbox_line;
-      bbox.line->numpoints = 5;
-      bbox.line->point = bbox_points;
-
-      msComputeBounds(shape);
-      bbox_points[0].x=bbox_points[4].x=bbox_points[1].x =
-                                          (shape->bounds.minx < -padding) ? -padding : shape->bounds.minx;
-      /* cppcheck-suppress unreadVariable */
-      bbox_points[2].x=bbox_points[3].x =
-                         (shape->bounds.maxx > image->width+padding) ? image->width+padding : shape->bounds.maxx;
-      bbox_points[0].y=bbox_points[4].y=bbox_points[3].y =
-                                          (shape->bounds.miny < -padding) ? -padding : shape->bounds.miny;
-      /* cppcheck-suppress unreadVariable */
-      bbox_points[1].y=bbox_points[2].y =
-                         (shape->bounds.maxy > image->height+padding) ? image->height+padding : shape->bounds.maxy;
-      status = msDrawShadeSymbol(map, image, &bbox, style, scalefactor);
-    }
-    break;
-    case MS_GEOMTRANSFORM_CENTROID: {
-      double unused; /*used by centroid function*/
-      pointObj centroid;
-      if(MS_SUCCESS == msGetPolygonCentroid(shape,&centroid,&unused,&unused)) {
-        status = msDrawMarkerSymbol(map,image,&centroid,style,scalefactor);
-      }
-    }
-    break;
-    case MS_GEOMTRANSFORM_EXPRESSION: {
-      int status;
-      shapeObj *tmpshp;
-      parseObj p;
-
-      p.shape = shape; /* set a few parser globals (hence the lock) */
-      p.expr = &(style->_geomtransform);
-
-      if(p.expr->tokens == NULL) { /* this could happen if drawing originates from legend code (#5193) */
-        status = msTokenizeExpression(p.expr, NULL, NULL);
-        if(status != MS_SUCCESS) {
-          msSetError(MS_MISCERR, "Unable to tokenize expression.", "msDrawTransformedShape()");
-          return MS_FAILURE;
-        }
-      }
-
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_SHAPE;
-
-      status = yyparse(&p);
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to process shape expression: %s", "msDrawTransformedShape", style->_geomtransform.string);
-        return MS_FAILURE;
-      }
-      tmpshp = p.result.shpval;
-
-      switch (tmpshp->type) {
-        case MS_SHAPE_POINT:
-        case MS_SHAPE_POLYGON:
-          /* cppcheck-suppress unreadVariable */
-          status = msDrawShadeSymbol(map, image, tmpshp, style, scalefactor);
-          break;
-        case MS_SHAPE_LINE:
-          /* cppcheck-suppress unreadVariable */
-          status = msDrawLineSymbol(map, image, tmpshp, style, scalefactor);
-          break;
-      }
-
-      msFreeShape(tmpshp);
-      msFree(tmpshp);
-    }
-    break;
-    case MS_GEOMTRANSFORM_LABELPOINT:
-    case MS_GEOMTRANSFORM_LABELPOLY:
-      break;
-    default:
-      msSetError(MS_MISCERR, "unknown geomtransform", "msDrawTransformedShape()");
-      return MS_FAILURE;
-  }
-  return status;
-}
-
-/*
- * RFC89 implementation:
- *  - transform directly the shapeobj
- */
-int msGeomTransformShape(mapObj *map, layerObj *layer, shapeObj *shape)
-{
-  int i;
-  expressionObj *e =  &layer->_geomtransform;  
-
-#ifdef USE_V8_MAPSCRIPT
-  if (!map->v8context) {
-    msV8CreateContext(map);
-    if (!map->v8context)
-    {
-      msSetError(MS_V8ERR, "Unable to create v8 context.", "msGeomTransformShape()");
-      return MS_FAILURE;
-    }
-  }
-
-  msV8ContextSetLayer(map, layer);
-#endif
- 
-  switch(e->type) {
-    case MS_GEOMTRANSFORM_EXPRESSION: {
-      int status;
-      shapeObj *tmpshp;
-      parseObj p;
-
-      p.shape = shape; /* set a few parser globals (hence the lock) */
-      p.expr = e;
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_SHAPE;
-      p.dblval = map->cellsize * (msInchesPerUnit(map->units,0)/msInchesPerUnit(layer->units,0));
-      p.dblval2 = 0;
-      /* data_cellsize is only set with contour layer */
-      if (layer->connectiontype == MS_CONTOUR)
-      {
-        const char *value = msLookupHashTable(&layer->metadata, "__data_cellsize__");
-        if (value)
-          p.dblval2 = atof(value);
-      }
-          
-      status = yyparse(&p);
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to process shape expression: %s", "msGeomTransformShape()", e->string);
-        return MS_FAILURE;
-      }
-      
-      tmpshp = p.result.shpval;
-
-      for (i= 0; i < shape->numlines; i++)
-        free(shape->line[i].point);
-      shape->numlines = 0;
-      if (shape->line) free(shape->line);
-      shape->line = NULL;
-      shape->type = tmpshp->type; /* might have been a change (e.g. centerline) */
-
-      for(i=0; i<tmpshp->numlines; i++)
-        msAddLine(shape, &(tmpshp->line[i])); /* copy each line */
-
-      msFreeShape(tmpshp);
-      msFree(tmpshp);
-    }
-    break;
-    default:
-      msSetError(MS_MISCERR, "unknown geomtransform", "msGeomTransformShape()");
-      return MS_FAILURE;
-  }
-  
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapgeomutil.cpp 8.2.0~beta1-1~exp1/mapgeomutil.cpp
--- 8.0.1-5/mapgeomutil.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgeomutil.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,107 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Rendering utility functions
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2011 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "renderers/agg/include/agg_arc.h"
-#include "renderers/agg/include/agg_basics.h"
-
-
-
-shapeObj *msRasterizeArc(double x0, double y0, double radius, double startAngle, double endAngle, int isSlice)
-{
-  static int allocated_size=100;
-  shapeObj *shape = (shapeObj*)calloc(1,sizeof(shapeObj));
-  MS_CHECK_ALLOC(shape, sizeof(shapeObj), NULL);
-  mapserver::arc arc ( x0, y0,radius,radius, startAngle*MS_DEG_TO_RAD, endAngle*MS_DEG_TO_RAD,true );
-  arc.approximation_scale ( 1 );
-  arc.rewind(1);
-  msInitShape(shape);
-
-  lineObj *line = (lineObj*)calloc(1,sizeof(lineObj));
-  if (!line) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msRasterizeArc()" ,
-               __FILE__, __LINE__, (unsigned int)sizeof(lineObj));
-    free(shape);
-    return NULL;
-  }
-  shape->line = line;
-  shape->numlines = 1;
-  line->point = (pointObj*)calloc(allocated_size,sizeof(pointObj));
-  if (!line->point) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msRasterizeArc()" ,
-               __FILE__, __LINE__, (unsigned int)(allocated_size*sizeof(pointObj)));
-    free(line);
-    free(shape);
-    return NULL;
-  }
-
-  line->numpoints = 0;
-
-  double x,y;
-
-  //first segment from center to first point of arc
-  if(isSlice) {
-    line->point[0].x = x0;
-    line->point[0].y = y0;
-    line->numpoints = 1;
-  }
-  while(arc.vertex(&x,&y) != mapserver::path_cmd_stop) {
-    if(line->numpoints == allocated_size) {
-      allocated_size *= 2;
-      line->point = (pointObj*)realloc(line->point, allocated_size * sizeof(pointObj));
-      if (!line->point) {
-        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msRasterizeArc()" ,
-                   __FILE__, __LINE__, (unsigned int)(allocated_size * sizeof(pointObj)));
-        free(line);
-        free(shape);
-        return NULL;
-      }
-    }
-    line->point[line->numpoints].x = x;
-    line->point[line->numpoints].y = y;
-    line->numpoints++;
-  }
-
-  //make sure the shape is closed
-  if(line->point[line->numpoints-1].x != line->point[0].x ||
-      line->point[line->numpoints-1].y != line->point[0].y) {
-    if(line->numpoints == allocated_size) {
-      allocated_size *= 2;
-      line->point = (pointObj*)msSmallRealloc(line->point, allocated_size * sizeof(pointObj));
-    }
-    line->point[line->numpoints].x = line->point[0].x;
-    line->point[line->numpoints].y = line->point[0].y;
-    line->numpoints++;
-  }
-
-  return shape;
-}
-
-
-
diff -pruN 8.0.1-5/mapgeos.c 8.2.0~beta1-1~exp1/mapgeos.c
--- 8.0.1-5/mapgeos.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgeos.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1683 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  MapServer-GEOS integration.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "mapgraph.h"
-
-#ifdef USE_GEOS
-
-// To avoid accidental use of non reentrant GEOS API.
-// (check only effective in GEOS >= 3.5)
-#define GEOS_USE_ONLY_R_API
-
-#include <geos_c.h>
-
-/*
-** Error handling...
-*/
-static void msGEOSError(const char *format, ...)
-{
-  va_list args;
-
-  va_start (args, format);
-  msSetError(MS_GEOSERR, format, "msGEOSError()", args); /* just pass along to MapServer error handling */
-  va_end(args);
-
-  return;
-}
-
-static void msGEOSNotice(const char *fmt, ...)
-{
-  (void)fmt; /* do nothing with notices at this point */
-}
-
-#ifndef USE_THREAD
-static GEOSContextHandle_t geos_handle;
-
-static inline GEOSContextHandle_t msGetGeosContextHandle()
-{
-  return geos_handle;
-}
-
-#else
-#include "mapthread.h"
-typedef struct geos_thread_info {
-  struct geos_thread_info *next;
-  void*             thread_id;
-  GEOSContextHandle_t        geos_handle;
-} geos_thread_info_t;
-
-static geos_thread_info_t *geos_list = NULL;
-
-static GEOSContextHandle_t msGetGeosContextHandle()
-{
-  geos_thread_info_t *link;
-  GEOSContextHandle_t ret_obj;
-  void*        thread_id;
-
-  msAcquireLock( TLOCK_GEOS );
-
-  thread_id = msGetThreadId();
-
-  /* find link for this thread */
-
-  for( link = geos_list;
-       link != NULL && link->thread_id != thread_id
-       && link->next != NULL && link->next->thread_id != thread_id;
-       link = link->next ) {}
-
-  /* If the target thread link is already at the head of the list were ok */
-  if( geos_list != NULL && geos_list->thread_id == thread_id ) {
-  }
-
-  /* We don't have one ... initialize one. */
-  else if( link == NULL || link->next == NULL ) {
-    geos_thread_info_t *new_link;
-    new_link = (geos_thread_info_t *) malloc(sizeof(geos_thread_info_t));
-    new_link->next = geos_list;
-    new_link->thread_id = thread_id;
-    new_link->geos_handle = initGEOS_r(msGEOSNotice, msGEOSError);
-
-    geos_list = new_link;
-  }
-
-  /* If the link is not already at the head of the list, promote it */
-  else {
-    geos_thread_info_t *target = link->next;
-
-    link->next = link->next->next;
-    target->next = geos_list;
-    geos_list = target;
-  }
-
-  ret_obj = geos_list->geos_handle;
-
-  msReleaseLock( TLOCK_GEOS );
-
-  return ret_obj;
-}
-#endif
-
-/*
-** Setup/Cleanup wrappers
-*/
-void msGEOSSetup()
-{
-#ifndef USE_THREAD
-  geos_handle = initGEOS_r(msGEOSNotice, msGEOSError);
-#endif
-}
-
-void msGEOSCleanup()
-{
-#ifndef USE_THREAD
-  finishGEOS_r(geos_handle);
-  geos_handle = NULL;
-#else
-  geos_thread_info_t *link;
-  msAcquireLock( TLOCK_GEOS );
-  for( link = geos_list; link != NULL;) {
-    geos_thread_info_t *cur = link;
-    link = link->next;
-    finishGEOS_r(cur->geos_handle);
-    free(cur);
-  }
-  geos_list = NULL;
-  msReleaseLock( TLOCK_GEOS );
-#endif
-}
-
-/*
-** Translation functions
-*/
-static GEOSGeom msGEOSShape2Geometry_point(pointObj *point)
-{
-  GEOSCoordSeq coords;
-  GEOSGeom g;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!point) return NULL;
-
-  coords = GEOSCoordSeq_create_r(handle,1, 2); /* todo handle z's */
-  if(!coords) return NULL;
-
-  GEOSCoordSeq_setX_r(handle,coords, 0, point->x);
-  GEOSCoordSeq_setY_r(handle,coords, 0, point->y);
-  /* GEOSCoordSeq_setY(coords, 0, point->z); */
-
-  g = GEOSGeom_createPoint_r(handle,coords); /* g owns the coordinate in coords */
-
-  return g;
-}
-
-static GEOSGeom msGEOSShape2Geometry_multipoint(lineObj *multipoint)
-{
-  int i;
-  GEOSGeom g;
-  GEOSGeom *points;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!multipoint) return NULL;
-
-  points = malloc(multipoint->numpoints*sizeof(GEOSGeom));
-  if(!points) return NULL;
-
-  for(i=0; i<multipoint->numpoints; i++)
-    points[i] = msGEOSShape2Geometry_point(&(multipoint->point[i]));
-
-  g = GEOSGeom_createCollection_r(handle,GEOS_MULTIPOINT, points, multipoint->numpoints);
-
-  free(points);
-
-  return g;
-}
-
-static GEOSGeom msGEOSShape2Geometry_line(lineObj *line)
-{
-  int i;
-  GEOSGeom g;
-  GEOSCoordSeq coords;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!line) return NULL;
-
-  coords = GEOSCoordSeq_create_r(handle,line->numpoints, 2); /* todo handle z's */
-  if(!coords) return NULL;
-
-  for(i=0; i<line->numpoints; i++) {
-    GEOSCoordSeq_setX_r(handle,coords, i, line->point[i].x);
-    GEOSCoordSeq_setY_r(handle,coords, i, line->point[i].y);
-    /* GEOSCoordSeq_setZ(coords, i, line->point[i].z); */
-  }
-
-  g = GEOSGeom_createLineString_r(handle,coords); /* g owns the coordinates in coords */
-
-  return g;
-}
-
-static GEOSGeom msGEOSShape2Geometry_multiline(shapeObj *multiline)
-{
-  int i;
-  GEOSGeom g;
-  GEOSGeom *lines;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!multiline) return NULL;
-
-  lines = malloc(multiline->numlines*sizeof(GEOSGeom));
-  if(!lines) return NULL;
-
-  for(i=0; i<multiline->numlines; i++)
-    lines[i] = msGEOSShape2Geometry_line(&(multiline->line[i]));
-
-  g = GEOSGeom_createCollection_r(handle,GEOS_MULTILINESTRING, lines, multiline->numlines);
-
-  free(lines);
-
-  return g;
-}
-
-static GEOSGeom msGEOSShape2Geometry_simplepolygon(shapeObj *shape, int r, int *outerList)
-{
-  int i, j, k;
-  GEOSCoordSeq coords;
-  GEOSGeom g;
-  GEOSGeom outerRing;
-  GEOSGeom *innerRings=NULL;
-  int numInnerRings=0, *innerList;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape || !outerList) return NULL;
-
-  /* build the outer shell */
-  coords = GEOSCoordSeq_create_r(handle,shape->line[r].numpoints, 2); /* todo handle z's */
-  if(!coords) return NULL;
-
-  for(i=0; i<shape->line[r].numpoints; i++) {
-    GEOSCoordSeq_setX_r(handle,coords, i, shape->line[r].point[i].x);
-    GEOSCoordSeq_setY_r(handle,coords, i, shape->line[r].point[i].y);
-    /* GEOSCoordSeq_setZ(coords, i, shape->line[r].point[i].z); */
-  }
-
-  outerRing = GEOSGeom_createLinearRing_r(handle,coords); /* outerRing owns the coordinates in coords */
-
-  /* build the holes */
-  innerList = msGetInnerList(shape, r, outerList);
-  for(j=0; j<shape->numlines; j++)
-    if(innerList[j] == MS_TRUE) numInnerRings++;
-
-  if(numInnerRings > 0) {
-    k = 0; /* inner ring counter */
-
-    innerRings = msSmallMalloc(numInnerRings*sizeof(GEOSGeom));
-
-    for(j=0; j<shape->numlines; j++) {
-      if(innerList[j] == MS_FALSE) continue;
-
-      coords = GEOSCoordSeq_create_r(handle,shape->line[j].numpoints, 2); /* todo handle z's */
-      if(!coords) {
-        free(innerRings);
-        free(innerList);
-        return NULL; /* todo, this will leak memory (shell + allocated holes) */
-      }
-
-      for(i=0; i<shape->line[j].numpoints; i++) {
-        GEOSCoordSeq_setX_r(handle,coords, i, shape->line[j].point[i].x);
-        GEOSCoordSeq_setY_r(handle,coords, i, shape->line[j].point[i].y);
-        /* GEOSCoordSeq_setZ(coords, i, shape->line[j].point[i].z); */
-      }
-
-      innerRings[k] = GEOSGeom_createLinearRing_r(handle,coords); /* innerRings[k] owns the coordinates in coords */
-      k++;
-    }
-  }
-
-  g = GEOSGeom_createPolygon_r(handle,outerRing, innerRings, numInnerRings);
-
-  free(innerList); /* clean up */
-  free(innerRings); /* clean up */
-
-  return g;
-}
-
-static GEOSGeom msGEOSShape2Geometry_polygon(shapeObj *shape)
-{
-  int i, j;
-  GEOSGeom *polygons;
-  int *outerList, numOuterRings=0, lastOuterRing=0;
-  GEOSGeom g;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  outerList = msGetOuterList(shape);
-  for(i=0; i<shape->numlines; i++) {
-    if(outerList[i] == MS_TRUE) {
-      numOuterRings++;
-      lastOuterRing = i; /* save for the simple case */
-    }
-  }
-
-  if(numOuterRings == 1) {
-    g = msGEOSShape2Geometry_simplepolygon(shape, lastOuterRing, outerList);
-  } else { /* a true multipolygon */
-    polygons = msSmallMalloc(numOuterRings*sizeof(GEOSGeom));
-
-    j = 0; /* part counter */
-    for(i=0; i<shape->numlines; i++) {
-      if(outerList[i] == MS_FALSE) continue;
-      polygons[j] = msGEOSShape2Geometry_simplepolygon(shape, i, outerList); /* TODO: account for NULL return values */
-      j++;
-    }
-
-    g = GEOSGeom_createCollection_r(handle,GEOS_MULTIPOLYGON, polygons, numOuterRings);
-    free(polygons);
-  }
-
-  free(outerList);
-  return g;
-}
-
-GEOSGeom msGEOSShape2Geometry(shapeObj *shape)
-{
-  if(!shape)
-    return NULL; /* a NULL shape generates a NULL geometry */
-
-  switch(shape->type) {
-    case MS_SHAPE_POINT:
-      if(shape->numlines == 0 || shape->line[0].numpoints == 0) /* not enough info for a point */
-        return NULL;
-
-      if(shape->line[0].numpoints == 1) /* simple point */
-        return msGEOSShape2Geometry_point(&(shape->line[0].point[0]));
-      else /* multi-point */
-        return msGEOSShape2Geometry_multipoint(&(shape->line[0]));
-      break;
-    case MS_SHAPE_LINE:
-      if(shape->numlines == 0 || shape->line[0].numpoints < 2) /* not enough info for a line */
-        return NULL;
-
-      if(shape->numlines == 1) /* simple line */
-        return msGEOSShape2Geometry_line(&(shape->line[0]));
-      else /* multi-line */
-        return msGEOSShape2Geometry_multiline(shape);
-      break;
-    case MS_SHAPE_POLYGON:
-      if(shape->numlines == 0 || shape->line[0].numpoints < 4) /* not enough info for a polygon (first=last) */
-        return NULL;
-
-      return msGEOSShape2Geometry_polygon(shape); /* simple and multipolygon cases are addressed */
-      break;
-    default:
-      break;
-  }
-
-  return NULL; /* should not get here */
-}
-
-static shapeObj *msGEOSGeometry2Shape_point(GEOSGeom g)
-{
-  GEOSCoordSeq coords;
-  shapeObj *shape=NULL;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!g) return NULL;
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  msInitShape(shape);
-
-  shape->type = MS_SHAPE_POINT;
-  shape->line = (lineObj *) malloc(sizeof(lineObj));
-  shape->numlines = 1;
-  shape->line[0].point = (pointObj *) malloc(sizeof(pointObj));
-  shape->line[0].numpoints = 1;
-  shape->geometry = (GEOSGeom) g;
-
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,g);
-
-  GEOSCoordSeq_getX_r(handle,coords, 0, &(shape->line[0].point[0].x));
-  GEOSCoordSeq_getY_r(handle,coords, 0, &(shape->line[0].point[0].y));
-  /* GEOSCoordSeq_getZ(coords, 0, &(shape->line[0].point[0].z)); */
-
-  shape->bounds.minx = shape->bounds.maxx = shape->line[0].point[0].x;
-  shape->bounds.miny = shape->bounds.maxy = shape->line[0].point[0].y;
-
-  return shape;
-}
-
-static shapeObj *msGEOSGeometry2Shape_multipoint(GEOSGeom g)
-{
-  int i;
-  int numPoints;
-  GEOSCoordSeq coords;
-  GEOSGeom point;
-
-  shapeObj *shape=NULL;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!g) return NULL;
-  numPoints = GEOSGetNumGeometries_r(handle,g); /* each geometry has 1 point */
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  msInitShape(shape);
-
-  shape->type = MS_SHAPE_POINT;
-  shape->line = (lineObj *) malloc(sizeof(lineObj));
-  shape->numlines = 1;
-  shape->line[0].point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
-  shape->line[0].numpoints = numPoints;
-  shape->geometry = (GEOSGeom) g;
-
-  for(i=0; i<numPoints; i++) {
-    point = (GEOSGeom) GEOSGetGeometryN_r(handle,g, i);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,point);
-
-    GEOSCoordSeq_getX_r(handle,coords, 0, &(shape->line[0].point[i].x));
-    GEOSCoordSeq_getY_r(handle,coords, 0, &(shape->line[0].point[i].y));
-    /* GEOSCoordSeq_getZ(coords, 0, &(shape->line[0].point[i].z)); */
-  }
-
-  msComputeBounds(shape);
-
-  return shape;
-}
-
-static shapeObj *msGEOSGeometry2Shape_line(GEOSGeom g)
-{
-  shapeObj *shape=NULL;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  int i;
-  int numPoints;
-  GEOSCoordSeq coords;
-
-  if(!g) return NULL;
-  numPoints = GEOSGetNumCoordinates_r(handle,g);
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,g);
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  msInitShape(shape);
-
-  shape->type = MS_SHAPE_LINE;
-  shape->line = (lineObj *) malloc(sizeof(lineObj));
-  shape->numlines = 1;
-  shape->line[0].point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
-  shape->line[0].numpoints = numPoints;
-  shape->geometry = (GEOSGeom) g;
-
-  for(i=0; i<numPoints; i++) {
-    GEOSCoordSeq_getX_r(handle,coords, i, &(shape->line[0].point[i].x));
-    GEOSCoordSeq_getY_r(handle,coords, i, &(shape->line[0].point[i].y));
-    /* GEOSCoordSeq_getZ(coords, i, &(shape->line[0].point[i].z)); */
-  }
-
-  msComputeBounds(shape);
-
-  return shape;
-}
-
-static void msGEOSGeometry2Shape_multiline_part(GEOSContextHandle_t handle, GEOSGeom part, shapeObj *shape) {
-  int i;
-  int type, numGeometries, numPoints;
-  GEOSCoordSeq coords;
-  lineObj line;
-  
-  type = GEOSGeomTypeId_r(handle,part); 
-  if (type == GEOS_MULTILINESTRING) {
-    numGeometries = GEOSGetNumGeometries_r(handle,part);
-
-    for(i=0; i<numGeometries; i++) {
-      GEOSGeom subPart = (GEOSGeom) GEOSGetGeometryN_r(handle, part, i);
-      msGEOSGeometry2Shape_multiline_part(handle, subPart, shape);
-    }
-  } else {
-    numPoints = GEOSGetNumCoordinates_r(handle,part);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,part);
-    line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
-    line.numpoints = numPoints;
-
-    for(i=0; i<numPoints; i++) {
-      GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-      GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
-      /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
-    }
-
-    msAddLineDirectly(shape, &line);
-  }
-}
-
-static shapeObj *msGEOSGeometry2Shape_multiline(GEOSGeom g)
-{
-  int i;
-  int numGeometries;
-  GEOSGeom part;
-
-  shapeObj *shape=NULL;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!g) return NULL;
-  numGeometries = GEOSGetNumGeometries_r(handle,g);
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  msInitShape(shape);
-
-  shape->type = MS_SHAPE_LINE;
-  shape->geometry = (GEOSGeom) g;
-
-  for(i=0; i<numGeometries; i++) {
-    part = (GEOSGeom) GEOSGetGeometryN_r(handle, g, i);
-    msGEOSGeometry2Shape_multiline_part(handle, part, shape);
-  }
-
-  msComputeBounds(shape);
-
-  return shape;
-}
-
-static shapeObj *msGEOSGeometry2Shape_polygon(GEOSGeom g)
-{
-  shapeObj *shape=NULL;
-  lineObj line;
-  int numPoints, numRings;
-  int i, j;
-
-  GEOSCoordSeq coords;
-  GEOSGeom ring;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!g) return NULL;
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  msInitShape(shape);
-  shape->type = MS_SHAPE_POLYGON;
-  shape->geometry = (GEOSGeom) g;
-
-  /* exterior ring */
-  ring = (GEOSGeom) GEOSGetExteriorRing_r(handle,g);
-  numPoints = GEOSGetNumCoordinates_r(handle,ring);
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
-
-  line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
-  line.numpoints = numPoints;
-
-  for(i=0; i<numPoints; i++) {
-    GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-    GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
-    /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
-  }
-  msAddLineDirectly(shape, &line);
-
-  /* interior rings */
-  numRings = GEOSGetNumInteriorRings_r(handle,g);
-  for(j=0; j<numRings; j++) {
-    ring = (GEOSGeom) GEOSGetInteriorRingN_r(handle,g, j);
-    if(GEOSisRing_r(handle,ring) != 1) continue; /* skip it */
-
-    numPoints = GEOSGetNumCoordinates_r(handle,ring);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
-
-    line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
-    line.numpoints = numPoints;
-
-    for(i=0; i<numPoints; i++) {
-      GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-      GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
-      /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
-    }
-    msAddLineDirectly(shape, &line);
-  }
-
-  msComputeBounds(shape);
-
-  return shape;
-}
-
-static shapeObj *msGEOSGeometry2Shape_multipolygon(GEOSGeom g)
-{
-  int i, j, k;
-  shapeObj *shape=NULL;
-  lineObj line;
-  int numPoints, numRings, numPolygons;
-
-  GEOSCoordSeq coords;
-  GEOSGeom polygon, ring;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!g) return NULL;
-  numPolygons = GEOSGetNumGeometries_r(handle,g);
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  msInitShape(shape);
-  shape->type = MS_SHAPE_POLYGON;
-  shape->geometry = (GEOSGeom) g;
-
-  for(k=0; k<numPolygons; k++) { /* for each polygon */
-    polygon = (GEOSGeom) GEOSGetGeometryN_r(handle,g, k);
-
-    /* exterior ring */
-    ring = (GEOSGeom) GEOSGetExteriorRing_r(handle,polygon);
-    numPoints = GEOSGetNumCoordinates_r(handle,ring);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
-
-    line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
-    line.numpoints = numPoints;
-
-    for(i=0; i<numPoints; i++) {
-      GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-      GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
-      /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
-    }
-    msAddLineDirectly(shape, &line);
-
-    /* interior rings */
-    numRings = GEOSGetNumInteriorRings_r(handle,polygon);
-
-    for(j=0; j<numRings; j++) {
-      ring = (GEOSGeom) GEOSGetInteriorRingN_r(handle,polygon, j);
-      if(GEOSisRing_r(handle,ring) != 1) continue; /* skip it */
-
-      numPoints = GEOSGetNumCoordinates_r(handle,ring);
-      coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
-
-      line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
-      line.numpoints = numPoints;
-
-      for(i=0; i<numPoints; i++) {
-        GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-        GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
-        /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
-      }
-      msAddLineDirectly(shape, &line);
-    }
-  } /* next polygon */
-
-  msComputeBounds(shape);
-
-  return shape;
-}
-
-shapeObj *msGEOSGeometry2Shape(GEOSGeom g)
-{
-  int type;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!g)
-    return NULL; /* a NULL geometry generates a NULL shape */
-
-  type = GEOSGeomTypeId_r(handle,g);
-  switch(type) {
-    case GEOS_POINT:
-      return msGEOSGeometry2Shape_point(g);
-      break;
-    case GEOS_MULTIPOINT:
-      return msGEOSGeometry2Shape_multipoint(g);
-      break;
-    case GEOS_LINESTRING:
-      return msGEOSGeometry2Shape_line(g);
-      break;
-    case GEOS_MULTILINESTRING:
-      return msGEOSGeometry2Shape_multiline(g);
-      break;
-    case GEOS_POLYGON:
-      return msGEOSGeometry2Shape_polygon(g);
-      break;
-    case GEOS_MULTIPOLYGON:
-      return msGEOSGeometry2Shape_multipolygon(g);
-      break;
-    case GEOS_GEOMETRYCOLLECTION:
-      if (!GEOSisEmpty_r(handle,g))
-      {
-        shapeObj* shape = (shapeObj *) malloc(sizeof(shapeObj));
-        msInitShape(shape);
-        shape->type = MS_SHAPE_LINE;
-        shape->geometry = (GEOSGeom) g;
-
-        const int numGeoms = GEOSGetNumGeometries_r(handle,g);
-        for(int i = 0; i < numGeoms; i++) { /* for each geometry */
-           shapeObj* shape2 = msGEOSGeometry2Shape((GEOSGeom)GEOSGetGeometryN_r(handle,g, i));
-           if (shape2) {
-              for (int j = 0; j < shape2->numlines; j++)
-                 msAddLineDirectly(shape, &shape2->line[j]);
-              shape2->numlines = 0;
-              shape2->geometry = NULL; /* not owned */
-              msFreeShape(shape2);
-           }
-        }
-        msComputeBounds(shape);
-        return shape;
-      }
-      break;
-    default:
-      msSetError(MS_GEOSERR, "Unsupported GEOS geometry type (%d).", "msGEOSGeometry2Shape()", type);
-  }
-  return NULL;
-}
-#endif
-
-/*
-** Maintenence functions exposed to MapServer/MapScript.
-*/
-
-void msGEOSFreeGeometry(shapeObj *shape)
-{
-#ifdef USE_GEOS
-  GEOSGeom g=NULL;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape || !shape->geometry)
-    return;
-
-  g = (GEOSGeom) shape->geometry;
-  GEOSGeom_destroy_r(handle,g);
-  shape->geometry = NULL;
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSFreeGEOSGeom()");
-  return;
-#endif
-}
-
-/*
-** WKT input and output functions
-*/
-shapeObj *msGEOSShapeFromWKT(const char *wkt)
-{
-#ifdef USE_GEOS
-  GEOSGeom g;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!wkt)
-    return NULL;
-
-  g = GEOSGeomFromWKT_r(handle,wkt);
-  if(!g) {
-    msSetError(MS_GEOSERR, "Error reading WKT geometry \"%s\".", "msGEOSShapeFromWKT()", wkt);
-    return NULL;
-  } else {
-    return msGEOSGeometry2Shape(g);
-  }
-
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSShapeFromWKT()");
-  return NULL;
-#endif
-}
-
-/* Return should be freed with msGEOSFreeWKT */
-char *msGEOSShapeToWKT(shapeObj *shape)
-{
-#ifdef USE_GEOS
-  GEOSGeom g;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape)
-    return NULL;
-
-  /* if we have a geometry, we should update it*/
-  msGEOSFreeGeometry(shape);
-
-  shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g = (GEOSGeom) shape->geometry;
-  if(!g) return NULL;
-
-  return GEOSGeomToWKT_r(handle,g);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSShapeToWKT()");
-  return NULL;
-#endif
-}
-
-void msGEOSFreeWKT(char* pszGEOSWKT)
-{
-#ifdef USE_GEOS
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-#if GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 2)
-  GEOSFree_r(handle,pszGEOSWKT);
-#endif
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSFreeWKT()");
-#endif
-}
-
-shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset) {
-#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
-  int typeChanged = 0;
-  GEOSGeom g1, g2 = NULL;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!p) 
-    return NULL;
-
-  /*
-   * GEOSOffsetCurve_r() uses BufferBuilder.bufferLineSingleSided(), which
-   * works with lines, naturally. In order to allow offsets for a MapServer
-   * polygonObj, it has to be processed as line and afterwards reverted.
-   */
-  if(p->type == MS_SHAPE_POLYGON) {
-    p->type = MS_SHAPE_LINE;
-    typeChanged = 1;
-    msGEOSFreeGeometry(p);
-  }
-
-  if(typeChanged || !p->geometry)
-    p->geometry = (GEOSGeom) msGEOSShape2Geometry(p);
-
-  g1 = (GEOSGeom) p->geometry;
-  if(!g1) return NULL;
-  
-  if (GEOSGeomTypeId_r(handle,g1) == GEOS_MULTILINESTRING)
-  {
-    GEOSGeom *lines = malloc(p->numlines*sizeof(GEOSGeom));
-    if (!lines) return NULL;
-    for(int i=0; i<p->numlines; i++)
-    {
-      lines[i] = GEOSOffsetCurve_r(handle, GEOSGetGeometryN_r(handle,g1,i),
-                                   offset, 4, GEOSBUF_JOIN_MITRE, fabs(offset*1.5));
-    }
-    g2 = GEOSGeom_createCollection_r(handle,GEOS_MULTILINESTRING, lines, p->numlines);
-    free(lines);
-  }
-  else
-  {
-    g2 = GEOSOffsetCurve_r(handle,g1, offset, 4, GEOSBUF_JOIN_MITRE, fabs(offset*1.5));
-  }
-
-  /*
-   * Undo change of geometry type. We won't re-create the geos gemotry here,
-   * it's up to each geos function to create it.
-   */
-  if(typeChanged) {
-    msGEOSFreeGeometry(p);
-    p->type = MS_SHAPE_POLYGON;
-  }
-
-  if (g2)
-    return msGEOSGeometry2Shape(g2);
-
-  return NULL;
-#else
-  msSetError(MS_GEOSERR, "GEOS Offset Curve support is not available.", "msGEOSingleSidedBuffer()");
-  return NULL;
-#endif
-}
-
-/*
-** Analytical functions exposed to MapServer/MapScript.
-*/
-
-shapeObj *msGEOSBuffer(shapeObj *shape, double width)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape)
-    return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSBuffer_r(handle,g1, width, 30);
-  return msGEOSGeometry2Shape(g2);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSBuffer()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape)
-    return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSSimplify_r(handle,g1, tolerance);
-  return msGEOSGeometry2Shape(g2);
-#else
-  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.", "msGEOSSimplify()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape, double tolerance)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape)
-    return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSTopologyPreserveSimplify_r(handle,g1, tolerance);
-  return msGEOSGeometry2Shape(g2);
-#else
-  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.", "msGEOSTopologyPreservingSimplify()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSConvexHull(shapeObj *shape)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape) return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSConvexHull_r(handle,g1);
-  return msGEOSGeometry2Shape(g2);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSConvexHull()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSBoundary(shapeObj *shape)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape) return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSBoundary_r(handle,g1);
-  return msGEOSGeometry2Shape(g2);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSBoundary()");
-  return NULL;
-#endif
-}
-
-pointObj *msGEOSGetCentroid(shapeObj *shape)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  GEOSCoordSeq coords;
-  pointObj *point;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape) return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSGetCentroid_r(handle,g1);
-  if (!g2) return NULL;
-
-  point = (pointObj *) malloc(sizeof(pointObj));
-
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,g2);
-
-  GEOSCoordSeq_getX_r(handle,coords, 0, &(point->x));
-  GEOSCoordSeq_getY_r(handle,coords, 0, &(point->y));
-  /* GEOSCoordSeq_getZ(coords, 0, &(point->z)); */
-
-  GEOSGeom_destroy_r(handle, g2);
-
-  return point;
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSGetCentroid()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2, g3;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return NULL;
-
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
-
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
-
-  g3 = GEOSUnion_r(handle,g1, g2);
-  return msGEOSGeometry2Shape(g3);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSUnion()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2, g3;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return NULL;
-
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
-
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
-
-  g3 = GEOSIntersection_r(handle,g1, g2);
-  return msGEOSGeometry2Shape(g3);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSIntersection()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2, g3;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return NULL;
-
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
-
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
-
-  g3 = GEOSDifference_r(handle,g1, g2);
-  return msGEOSGeometry2Shape(g3);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSDifference()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2, g3;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return NULL;
-
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
-
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
-
-  g3 = GEOSSymDifference_r(handle,g1, g2);
-  return msGEOSGeometry2Shape(g3);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSSymDifference()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSLineMerge(shapeObj *shape)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_LINE) return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSLineMerge_r(handle, g1);
-  return msGEOSGeometry2Shape(g2);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSLineMerge()");
-  return NULL;
-#endif
-}
-
-shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance, int onlyEdges)
-{
-#if defined(USE_GEOS) && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
-  GEOSGeom g1, g2;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape) return NULL;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
-
-  g2 = GEOSVoronoiDiagram_r(handle, g1, NULL, tolerance, onlyEdges);
-  return msGEOSGeometry2Shape(g2);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available or GEOS version is not 3.5 or higher.", "msGEOSVoronoiDiagram()");
-  return NULL;
-#endif
-}
-
-static int keepEdge(lineObj *segment, shapeObj *polygon)
-{
-  int i,j;
-
-  if(segment->numpoints<2) return MS_FALSE;
-  if(msIntersectPointPolygon(&segment->point[0], polygon) != MS_TRUE) return MS_FALSE;
-  if(msIntersectPointPolygon(&segment->point[1], polygon) != MS_TRUE) return MS_FALSE;
-
-  for(i=0; i<polygon->numlines; i++)
-    for(j=1; j<polygon->line[i].numpoints; j++)
-      if(msIntersectSegments(&(segment->point[0]), &(segment->point[1]), &(polygon->line[i].point[j-1]), &(polygon->line[i].point[j])) ==  MS_TRUE)
-        return(MS_FALSE);
-
-  return(MS_TRUE);
-}
-
-#define ARE_SAME_POINTS(a,b) (((a).x!=(b).x || (a).y!=(b).y)?MS_FALSE:MS_TRUE)
-
-// returns the index of the node, we use z to store a count of points at the same coordinate
-static int buildNodes(multipointObj *nodes, pointObj *point)
-{
-  int i;
-
-  for(i=0; i<nodes->numpoints; i++) {
-    if(ARE_SAME_POINTS(nodes->point[i], *point)) { // found it
-      nodes->point[i].z++;
-      return i;
-    }
-  }
-
-  // not found, add it
-  nodes->point[i].x = point->x;
-  nodes->point[i].y = point->y;
-  nodes->point[i].z = 1;
-  nodes->numpoints++;
-
-  return i;
-}
-
-shapeObj *msGEOSCenterline(shapeObj *shape)
-{
-#if defined(USE_GEOS) && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
-  int i;
-  shapeObj *shape2=NULL;
-
-  multipointObj nodes;
-  graphObj *graph;
-
-  int *path=NULL; // array of node indexes
-  int path_size=0;
-  double path_dist=-1, max_path_dist=-1;
-
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_POLYGON) {
-    msSetError(MS_GEOSERR, "Centerlines can only be computed for polygon shapes.", "msGEOSCenterline()");
-    return NULL;
-  }
-
-  shape2 = msGEOSVoronoiDiagram(shape, 0.0, MS_TRUE);
-  if(!shape2) {
-    msSetError(MS_GEOSERR, "Voronoi diagram generation failed.", "msGEOSCenterline()");
-    return NULL;
-  }
-
-  // process the edges and build a graph representation
-  nodes.point = (pointObj *) malloc(shape2->numlines*sizeof(pointObj)*2);
-  nodes.numpoints = 0;
-  if(!nodes.point) {
-    msFreeShape(shape2);
-    free(shape2);
-    return NULL;
-  }
-
-  graph = msCreateGraph(shape2->numlines*2);
-  if(!graph) {
-    msFreeShape(shape2);
-    free(shape2);
-    free(nodes.point);
-    return NULL;
-  }
-
-  for(i=0; i<shape2->numlines; i++) {
-    if(keepEdge(&shape2->line[i], shape) == MS_TRUE) {
-      int src = buildNodes(&nodes, &shape2->line[i].point[0]);
-      int dest = buildNodes(&nodes, &shape2->line[i].point[1]);
-      msGraphAddEdge(graph, src, dest, msDistancePointToPoint(&shape2->line[i].point[0], &shape2->line[i].point[1]));
-    }
-  }
-  msFreeShape(shape2); // done with voronoi geometry, shape2 is still allocated though, just empty
-  shape2->type = MS_SHAPE_LINE; // will fill with centerline
-
-  if(nodes.numpoints == 0) {
-    msSetError(MS_GEOSERR, "Centerline generation failed, try densifying the shapes.", "msGEOSCenterline()");
-    free(shape2);
-    msFreeGraph(graph);
-    free(nodes.point);
-    return NULL;
-  }
-
-  // step through edge nodes (z=1)
-  for(i=0; i<nodes.numpoints; i++) {
-    if(nodes.point[i].z != 1) continue; // skip
-
-    if(!path) { // first one, keep this path
-      path = msGraphGetLongestShortestPath(graph, i, &path_size, &path_dist);
-      max_path_dist = path_dist;
-    } else {
-      int *tmp_path=NULL;
-      int tmp_path_size=0;
-      double tmp_path_dist=-1;
-
-      if(i == path[path_size-1]) continue; // skip, graph is bi-directional so it can't be any longer
-      tmp_path = msGraphGetLongestShortestPath(graph, i, &tmp_path_size, &tmp_path_dist);
-      if(tmp_path_dist > max_path_dist) {
-        free(path);
-        path = tmp_path;
-        path_size = tmp_path_size;
-        path_dist = tmp_path_dist;
-        max_path_dist = tmp_path_dist;
-      } else { // skip path
-        msFree(tmp_path);
-      }
-    }
-  }
-  msFreeGraph(graph); // done with graph
-
-  // transform the path into a shape
-  if(!path) {
-    msSetError(MS_GEOSERR, "Centerline generation failed.", "msGEOSCenterline()");
-    free(shape2);
-    free(nodes.point);
-    return NULL;
-  } else {
-    lineObj line;
-    line.point = (pointObj *) malloc(path_size*sizeof(pointObj));
-    if(!line.point) {
-      free(shape2);
-      free(path);
-      free(nodes.point);
-      return NULL;
-    }
-    line.numpoints = path_size;
-
-    for(i=0; i<path_size; i++) {
-      line.point[i].x = nodes.point[path[i]].x;
-      line.point[i].y = nodes.point[path[i]].y;
-    }
-    msAddLineDirectly(shape2, &line);
-  }
-
-  free(path); // clean up
-  free(nodes.point);
-
-  return shape2;
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available or GEOS version is not 3.5 or higher.", "msGEOSCenterline()");
-  return NULL;
-#endif
-}
-
-/*
-** Binary predicates exposed to MapServer/MapScript
-*/
-
-/*
-** Does shape1 contain shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSContains(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSContains_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSContains()");
-  return -1;
-#endif
-}
-
-/*
-** Does shape1 overlap shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSOverlaps_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSOverlaps()");
-  return -1;
-#endif
-}
-
-/*
-** Is shape1 within shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSWithin(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSWithin_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSWithin()");
-  return -1;
-#endif
-}
-
-/*
-** Does shape1 cross shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSCrosses_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSCrosses()");
-  return -1;
-#endif
-}
-
-/*
-** Does shape1 intersect shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSIntersects_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  if(!shape1 || !shape2)
-    return -1;
-
-  switch(shape1->type) { /* todo: deal with point shapes */
-    case(MS_SHAPE_LINE):
-      switch(shape2->type) {
-        case(MS_SHAPE_LINE):
-          return msIntersectPolylines(shape1, shape2);
-        case(MS_SHAPE_POLYGON):
-          return msIntersectPolylinePolygon(shape1, shape2);
-      }
-      break;
-    case(MS_SHAPE_POLYGON):
-      switch(shape2->type) {
-        case(MS_SHAPE_LINE):
-          return msIntersectPolylinePolygon(shape2, shape1);
-        case(MS_SHAPE_POLYGON):
-          return msIntersectPolygons(shape1, shape2);
-      }
-      break;
-  }
-
-  return -1;
-#endif
-}
-
-/*
-** Does shape1 touch shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSTouches(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSTouches_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSTouches()");
-  return -1;
-#endif
-}
-
-/*
-** Does shape1 equal shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSEquals(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSEquals_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSEquals()");
-  return -1;
-#endif
-}
-
-/*
-** Are shape1 and shape2 disjoint, returns MS_TRUE/MS_FALSE or -1 for an error.
-*/
-int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSDisjoint_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSDisjoint()");
-  return -1;
-#endif
-}
-
-/*
-** Useful misc. functions that return -1 on failure.
-*/
-double msGEOSArea(shapeObj *shape)
-{
-#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) && defined(GEOS_CAPI_VERSION_MINOR) && (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
-  GEOSGeom g;
-  double area;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape) return -1;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g = (GEOSGeom) shape->geometry;
-  if(!g) return -1;
-
-  result = GEOSArea_r(handle,g, &area);
-  return  ((result==0) ? -1 : area);
-#elif defined(USE_GEOS)
-  msSetError(MS_GEOSERR, "GEOS support enabled, but old version lacks GEOSArea().", "msGEOSArea()");
-  return -1;
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSArea()");
-  return -1;
-#endif
-}
-
-double msGEOSLength(shapeObj *shape)
-{
-#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) && defined(GEOS_CAPI_VERSION_MINOR) && (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
-
-  GEOSGeom g;
-  double length;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape) return -1;
-
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g = (GEOSGeom) shape->geometry;
-  if(!g) return -1;
-
-  result = GEOSLength_r(handle,g, &length);
-  return  ((result==0) ? -1 : length);
-#elif defined(USE_GEOS)
-  msSetError(MS_GEOSERR, "GEOS support enabled, but old version lacks GEOSLength().", "msGEOSLength()");
-  return -1;
-#else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSLength()");
-  return -1;
-#endif
-}
-
-double msGEOSDistance(shapeObj *shape1, shapeObj *shape2)
-{
-#ifdef USE_GEOS
-  GEOSGeom g1, g2;
-  double distance;
-  int result;
-  GEOSContextHandle_t handle = msGetGeosContextHandle();
-
-  if(!shape1 || !shape2)
-    return -1;
-
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
-
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
-
-  result = GEOSDistance_r(handle,g1, g2, &distance);
-  return ((result==0) ? -1 : distance);
-#else
-  return msDistanceShapeToShape(shape1, shape2); /* fall back on brute force method (for MapScript) */
-#endif
-}
diff -pruN 8.0.1-5/mapgml.c 8.2.0~beta1-1~exp1/mapgml.c
--- 8.0.1-5/mapgml.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgml.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2255 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  shapeObj to GML output via MapServer queries.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapows.h"
-#include "mapgml.h"
-#include "maptime.h"
-
-
-/* Use only mapgml.c if WMS or WFS is available (with minor exceptions at end) */
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR)
-
-static int msGMLGeometryLookup(gmlGeometryListObj *geometryList, const char *type);
-
-/*
-** Functions that write the feature boundary geometry (i.e. a rectObj).
-*/
-
-/* GML 2.1.2 */
-static int gmlWriteBounds_GML2(FILE *stream, rectObj *rect,
-                               const char *srsname, const char *tab,
-                               const char *pszTopPrefix)
-{
-  char *srsname_encoded;
-
-  if(!stream) return(MS_FAILURE);
-  if(!rect) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
-
-  msIO_fprintf(stream, "%s<%s:boundedBy>\n", tab, pszTopPrefix);
-  if(srsname) {
-    srsname_encoded = msEncodeHTMLEntities(srsname);
-    msIO_fprintf(stream, "%s\t<gml:Box srsName=\"%s\">\n", tab, srsname_encoded);
-    msFree(srsname_encoded);
-  } else
-    msIO_fprintf(stream, "%s\t<gml:Box>\n", tab);
-
-  msIO_fprintf(stream, "%s\t\t<gml:coordinates>", tab);
-  msIO_fprintf(stream, "%.6f,%.6f %.6f,%.6f", rect->minx, rect->miny, rect->maxx, rect->maxy );
-  msIO_fprintf(stream, "</gml:coordinates>\n");
-  msIO_fprintf(stream, "%s\t</gml:Box>\n", tab);
-  msIO_fprintf(stream, "%s</%s:boundedBy>\n", tab, pszTopPrefix);
-
-  return MS_SUCCESS;
-}
-
-/* GML 3.1 or GML 3.2 (MapServer limits GML encoding to the level 0 profile) */
-static int gmlWriteBounds_GML3(FILE *stream, rectObj *rect,
-                               const char *srsname, const char *tab,
-                               const char *pszTopPrefix)
-{
-  char *srsname_encoded;
-
-  if(!stream) return(MS_FAILURE);
-  if(!rect) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
-
-  msIO_fprintf(stream, "%s<%s:boundedBy>\n", tab, pszTopPrefix);
-  if(srsname) {
-    srsname_encoded = msEncodeHTMLEntities(srsname);
-    msIO_fprintf(stream, "%s\t<gml:Envelope srsName=\"%s\">\n", tab, srsname_encoded);
-    msFree(srsname_encoded);
-  } else
-    msIO_fprintf(stream, "%s\t<gml:Envelope>\n", tab);
-
-  msIO_fprintf(stream, "%s\t\t<gml:lowerCorner>%.6f %.6f</gml:lowerCorner>\n", tab, rect->minx, rect->miny);
-  msIO_fprintf(stream, "%s\t\t<gml:upperCorner>%.6f %.6f</gml:upperCorner>\n", tab, rect->maxx, rect->maxy);
-
-  msIO_fprintf(stream, "%s\t</gml:Envelope>\n", tab);
-  msIO_fprintf(stream, "%s</%s:boundedBy>\n", tab, pszTopPrefix);
-
-  return MS_SUCCESS;
-}
-
-static void gmlStartGeometryContainer(FILE *stream, const char *name,
-                                      const char *namespace, const char *tab)
-{
-  const char *tag_name=OWS_GML_DEFAULT_GEOMETRY_NAME;
-
-  if(name) tag_name = name;
-
-  if(namespace)
-    msIO_fprintf(stream, "%s<%s:%s>\n", tab, namespace, tag_name);
-  else
-    msIO_fprintf(stream, "%s<%s>\n", tab, tag_name);
-}
-
-static void gmlEndGeometryContainer(FILE *stream, const char *name,
-                                    const char *namespace, const char *tab)
-{
-  const char *tag_name=OWS_GML_DEFAULT_GEOMETRY_NAME;
-
-  if(name) tag_name = name;
-
-  if(namespace)
-    msIO_fprintf(stream, "%s</%s:%s>\n", tab, namespace, tag_name);
-  else
-    msIO_fprintf(stream, "%s</%s>\n", tab, tag_name);
-}
-
-/* GML 2.1.2 */
-static int gmlWriteGeometry_GML2(FILE *stream, gmlGeometryListObj *geometryList,
-                                 shapeObj *shape, const char *srsname,
-                                 const char *namespace, const char *tab,
-                                 int nSRSDimension, int geometry_precision)
-{
-  int i, j, k;
-  int *innerlist, *outerlist=NULL, numouters;
-  char *srsname_encoded = NULL;
-
-  int geometry_aggregate_index, geometry_simple_index;
-  char *geometry_aggregate_name = NULL, *geometry_simple_name = NULL;
-
-  if(!stream) return(MS_FAILURE);
-  if(!shape) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
-  if(!geometryList) return(MS_FAILURE);
-
-  if(shape->numlines <= 0) return(MS_SUCCESS); /* empty shape, nothing to output */
-
-  if(srsname)
-    srsname_encoded = msEncodeHTMLEntities(srsname);
-
-  /* feature geometry */
-  switch(shape->type) {
-    case(MS_SHAPE_POINT):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->line[0].numpoints == 1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 && shape->numlines == 1)) { /* write a Point(s) */
-
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-            /* Point */
-            if(srsname_encoded)
-              msIO_fprintf(stream, "%s<gml:Point srsName=\"%s\">\n", tab, srsname_encoded);
-            else
-              msIO_fprintf(stream, "%s<gml:Point>\n", tab);
-
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s  <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n",
-                           tab, geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y, geometry_precision,shape->line[i].point[j].z);
-            else
-                /* fall-through */
-
-            msIO_fprintf(stream, "%s  <gml:coordinates>%.*f,%.*f</gml:coordinates>\n", tab, geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y);
-
-            msIO_fprintf(stream, "%s</gml:Point>\n", tab);
-
-            gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-          }
-        }
-      } else if((geometry_aggregate_index != -1) || (geometryList->numgeometries == 0)) { /* write a MultiPoint */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        /* MultiPoint */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s<gml:MultiPoint srsName=\"%s\">\n", tab, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s<gml:MultiPoint>\n", tab);
-
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            msIO_fprintf(stream, "%s  <gml:pointMember>\n", tab);
-            msIO_fprintf(stream, "%s    <gml:Point>\n", tab);
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s      <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n",
-                           tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                           geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%s      <gml:coordinates>%f,%f</gml:coordinates>\n", tab, shape->line[i].point[j].x, shape->line[i].point[j].y);
-            msIO_fprintf(stream, "%s    </gml:Point>\n", tab);
-            msIO_fprintf(stream, "%s  </gml:pointMember>\n", tab);
-          }
-        }
-
-        msIO_fprintf(stream, "%s</gml:MultiPoint>\n", tab);
-
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no point/multipoint geometry defined. -->\n");
-      }
-
-      break;
-    case(MS_SHAPE_LINE):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a LineStrings(s) */
-        for(i=0; i<shape->numlines; i++) {
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-          /* LineString */
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s<gml:LineString srsName=\"%s\">\n", tab, srsname_encoded);
-          else
-            msIO_fprintf(stream, "%s<gml:LineString>\n", tab);
-
-          msIO_fprintf(stream, "%s  <gml:coordinates>", tab);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                           geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
-          msIO_fprintf(stream, "</gml:coordinates>\n");
-
-          msIO_fprintf(stream, "%s</gml:LineString>\n", tab);
-
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiCurve */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        /* MultiLineString */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s<gml:MultiLineString srsName=\"%s\">\n", tab, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s<gml:MultiLineString>\n", tab);
-
-        for(j=0; j<shape->numlines; j++) {
-          msIO_fprintf(stream, "%s  <gml:lineStringMember>\n", tab); /* no srsname at this point */
-          msIO_fprintf(stream, "%s    <gml:LineString>\n", tab); /* no srsname at this point */
-
-          msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
-          for(i=0; i<shape->line[j].numpoints; i++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision, shape->line[j].point[i].x, geometry_precision, shape->line[j].point[i].y,
-                           geometry_precision, shape->line[j].point[i].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[j].point[i].x, geometry_precision, shape->line[j].point[i].y);
-          }
-          msIO_fprintf(stream, "</gml:coordinates>\n");
-          msIO_fprintf(stream, "%s    </gml:LineString>\n", tab);
-          msIO_fprintf(stream, "%s  </gml:lineStringMember>\n", tab);
-        }
-
-        msIO_fprintf(stream, "%s</gml:MultiLineString>\n", tab);
-
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no line/multiline geometry defined. -->\n");
-      }
-
-      break;
-    case(MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipolygon");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      /* get a list of outter rings for this polygon */
-      outerlist = msGetOuterList(shape);
-
-      numouters = 0;
-      for(i=0; i<shape->numlines; i++)
-        if(outerlist[i] == MS_TRUE) numouters++;
-
-      if((geometry_simple_index != -1 && numouters == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a Polygon(s) */
-        for(i=0; i<shape->numlines; i++) {
-          if(outerlist[i] == MS_FALSE) break; /* skip non-outer rings, each outer ring is a new polygon */
-
-          /* get a list of inner rings for this polygon */
-          innerlist = msGetInnerList(shape, i, outerlist);
-
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-          /* Polygon */
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s<gml:Polygon srsName=\"%s\">\n", tab, srsname_encoded);
-          else
-            msIO_fprintf(stream, "%s<gml:Polygon>\n", tab);
-
-          msIO_fprintf(stream, "%s  <gml:outerBoundaryIs>\n", tab);
-          msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
-
-          msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                           geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
-          msIO_fprintf(stream, "</gml:coordinates>\n");
-
-          msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
-          msIO_fprintf(stream, "%s  </gml:outerBoundaryIs>\n", tab);
-
-          for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-            if(innerlist[k] == MS_TRUE) {
-              msIO_fprintf(stream, "%s  <gml:innerBoundaryIs>\n", tab);
-              msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
-
-              msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
-              for(j=0; j<shape->line[k].numpoints; j++)
-              {
-                if( nSRSDimension == 3 )
-                  msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y,
-                           geometry_precision,shape->line[k].point[j].z);
-                else
-                  /* fall-through */
-                msIO_fprintf(stream, "%.*f,%.*f ",geometry_precision, shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
-              }
-              msIO_fprintf(stream, "</gml:coordinates>\n");
-
-              msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
-              msIO_fprintf(stream, "%s  </gml:innerBoundaryIs>\n", tab);
-            }
-          }
-
-          msIO_fprintf(stream, "%s</gml:Polygon>\n", tab);
-          free(innerlist);
-
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-        free(outerlist);
-        outerlist = NULL;
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiPolygon */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        /* MultiPolygon */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s<gml:MultiPolygon srsName=\"%s\">\n", tab, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s<gml:MultiPolygon>\n", tab);
-
-        for(i=0; i<shape->numlines; i++) { /* step through the outer rings */
-          if(outerlist[i] == MS_TRUE) {
-            innerlist = msGetInnerList(shape, i, outerlist);
-
-            msIO_fprintf(stream, "%s<gml:polygonMember>\n", tab);
-            msIO_fprintf(stream, "%s  <gml:Polygon>\n", tab);
-
-            msIO_fprintf(stream, "%s    <gml:outerBoundaryIs>\n", tab);
-            msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
-
-            msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
-            for(j=0; j<shape->line[i].numpoints; j++)
-            {
-              if( nSRSDimension == 3 )
-                msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                             geometry_precision, shape->line[i].point[j].z);
-              else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-            }
-            msIO_fprintf(stream, "</gml:coordinates>\n");
-
-            msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-            msIO_fprintf(stream, "%s    </gml:outerBoundaryIs>\n", tab);
-
-            for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-              if(innerlist[k] == MS_TRUE) {
-                msIO_fprintf(stream, "%s    <gml:innerBoundaryIs>\n", tab);
-                msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
-
-                msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
-                for(j=0; j<shape->line[k].numpoints; j++)
-                {
-                  if( nSRSDimension == 3 )
-                    msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y,
-                                geometry_precision,shape->line[k].point[j].z);
-                  else
-                    /* fall-through */
-                  msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
-                }
-                msIO_fprintf(stream, "</gml:coordinates>\n");
-
-                msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-                msIO_fprintf(stream, "%s    </gml:innerBoundaryIs>\n", tab);
-              }
-            }
-
-            msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
-            msIO_fprintf(stream, "%s</gml:polygonMember>\n", tab);
-
-            free(innerlist);
-          }
-        }
-        msIO_fprintf(stream, "%s</gml:MultiPolygon>\n", tab);
-
-        free(outerlist);
-        outerlist = NULL;
-
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no polygon/multipolygon geometry defined. -->\n");
-      }
-
-      break;
-    default:
-      break;
-  }
-
-  /* clean-up */
-  msFree(srsname_encoded);
-  msFree(outerlist);
-
-  return(MS_SUCCESS);
-}
-
-static char* gmlCreateGeomId(OWSGMLVersion nGMLVersion, const char* pszFID, int* p_id)
-{
-    char* pszGMLId;
-    if( nGMLVersion == OWS_GML32 )
-    {
-        pszGMLId = (char*) msSmallMalloc( strlen(pszFID) + 1 + strlen(" gml:id=\"\"") + 10 );
-        sprintf(pszGMLId, " gml:id=\"%s.%d\"", pszFID, *p_id);
-        (*p_id) ++;
-    }
-    else
-        pszGMLId = msStrdup("");
-    return pszGMLId;
-}
-
-/* GML 3.1 or GML 3.2 (MapServer limits GML encoding to the level 0 profile) */
-static int gmlWriteGeometry_GML3(FILE *stream, gmlGeometryListObj *geometryList, shapeObj *shape,
-                                 const char *srsname, const char *namespace, const char *tab,
-                                 const char *pszFID, OWSGMLVersion nGMLVersion,
-                                 int nSRSDimension, int geometry_precision)
-{
-  int i, j, k, id = 1;
-  int *innerlist, *outerlist=NULL, numouters;
-  char *srsname_encoded = NULL;
-  char* pszGMLId;
-
-  int geometry_aggregate_index, geometry_simple_index;
-  char *geometry_aggregate_name = NULL, *geometry_simple_name = NULL;
-
-  if(!stream) return(MS_FAILURE);
-  if(!shape) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
-  if(!geometryList) return(MS_FAILURE);
-
-  if(shape->numlines <= 0) return(MS_SUCCESS); /* empty shape, nothing to output */
-
-  if(srsname)
-    srsname_encoded = msEncodeHTMLEntities(srsname);
-
-  /* feature geometry */
-  switch(shape->type) {
-    case(MS_SHAPE_POINT):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->line[0].numpoints == 1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 && shape->numlines == 1)) { /* write a Point(s) */
-
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-            /* Point */
-            pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-            if(srsname_encoded)
-              msIO_fprintf(stream, "%s  <gml:Point%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-            else
-              msIO_fprintf(stream, "%s  <gml:Point%s>\n", tab, pszGMLId);
-
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s    <gml:pos srsDimension=\"3\">%.*f %.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%s    <gml:pos>%.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-
-            msIO_fprintf(stream, "%s  </gml:Point>\n", tab);
-
-            gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-            msFree(pszGMLId);
-          }
-        }
-      } else if((geometry_aggregate_index != -1) || (geometryList->numgeometries == 0)) { /* write a MultiPoint */
-        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        /* MultiPoint */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s  <gml:MultiPoint%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s  <gml:MultiPoint%s>\n", tab, pszGMLId);
-
-        msFree(pszGMLId);
-
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            msIO_fprintf(stream, "%s    <gml:pointMember>\n", tab);
-            pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-            msIO_fprintf(stream, "%s      <gml:Point%s>\n", tab, pszGMLId);
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s        <gml:pos srsDimension=\"3\">%.*f %.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%s        <gml:pos>%.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-            msIO_fprintf(stream, "%s      </gml:Point>\n", tab);
-            msFree(pszGMLId);
-            msIO_fprintf(stream, "%s    </gml:pointMember>\n", tab);
-          }
-        }
-
-        msIO_fprintf(stream, "%s  </gml:MultiPoint>\n", tab);
-
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no point/multipoint geometry defined. -->\n");
-      }
-
-      break;
-    case(MS_SHAPE_LINE):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a LineStrings(s) */
-        for(i=0; i<shape->numlines; i++) {
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-          /* LineString (should be Curve?) */
-          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s  <gml:LineString%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-          else
-            msIO_fprintf(stream, "%s  <gml:LineString%s>\n", tab, pszGMLId);
-          msFree(pszGMLId);
-
-          msIO_fprintf(stream, "%s    <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
-          msIO_fprintf(stream, "</gml:posList>\n");
-
-          msIO_fprintf(stream, "%s  </gml:LineString>\n", tab);
-
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiCurve */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        /* MultiCurve */
-        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s  <gml:MultiCurve%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s  <gml:MultiCurve%s>\n", tab, pszGMLId);
-        msFree(pszGMLId);
-
-        for(i=0; i<shape->numlines; i++) {
-          msIO_fprintf(stream, "%s    <gml:curveMember>\n", tab);
-          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-          msIO_fprintf(stream, "%s      <gml:LineString%s>\n", tab, pszGMLId); /* no srsname at this point */
-          msFree(pszGMLId);
-
-          msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
-
-          msIO_fprintf(stream, "</gml:posList>\n");
-          msIO_fprintf(stream, "%s      </gml:LineString>\n", tab);
-          msIO_fprintf(stream, "%s    </gml:curveMember>\n", tab);
-        }
-
-        msIO_fprintf(stream, "%s  </gml:MultiCurve>\n", tab);
-
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no line/multiline geometry defined. -->\n");
-      }
-
-      break;
-    case(MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipolygon");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      /* get a list of outter rings for this polygon */
-      outerlist = msGetOuterList(shape);
-
-      numouters = 0;
-      for(i=0; i<shape->numlines; i++)
-        if(outerlist[i] == MS_TRUE) numouters++;
-
-      if((geometry_simple_index != -1 && numouters == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a Polygon(s) */
-        for(i=0; i<shape->numlines; i++) {
-          if(outerlist[i] == MS_FALSE) break; /* skip non-outer rings, each outer ring is a new polygon */
-
-          /* get a list of inner rings for this polygon */
-          innerlist = msGetInnerList(shape, i, outerlist);
-
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-
-          /* Polygon (should be Surface?) */
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s  <gml:Polygon%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-          else
-            msIO_fprintf(stream, "%s  <gml:Polygon%s>\n", tab, pszGMLId);
-          msFree(pszGMLId);
-
-          msIO_fprintf(stream, "%s    <gml:exterior>\n", tab);
-          msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
-
-          msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
-
-          msIO_fprintf(stream, "</gml:posList>\n");
-
-          msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-          msIO_fprintf(stream, "%s    </gml:exterior>\n", tab);
-
-          for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-            if(innerlist[k] == MS_TRUE) {
-              msIO_fprintf(stream, "%s    <gml:interior>\n", tab);
-              msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
-
-              msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-              for(j=0; j<shape->line[k].numpoints; j++)
-              {
-                if( nSRSDimension == 3 )
-                    msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y, geometry_precision,shape->line[k].point[j].z);
-                else
-                        /* fall-through */
-                msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
-              }
-
-              msIO_fprintf(stream, "</gml:posList>\n");
-
-              msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-              msIO_fprintf(stream, "%s    </gml:interior>\n", tab);
-            }
-          }
-
-          msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
-          free(innerlist);
-
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-        free(outerlist);
-        outerlist = NULL;
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiSurface */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-
-        /* MultiSurface */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s  <gml:MultiSurface%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s  <gml:MultiSurface%s>\n", tab, pszGMLId);
-        msFree(pszGMLId);
-
-        for(i=0; i<shape->numlines; i++) { /* step through the outer rings */
-          if(outerlist[i] == MS_TRUE) {
-            msIO_fprintf(stream, "%s    <gml:surfaceMember>\n", tab);
-
-            /* get a list of inner rings for this polygon */
-            innerlist = msGetInnerList(shape, i, outerlist);
-
-            pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-
-            msIO_fprintf(stream, "%s      <gml:Polygon%s>\n", tab, pszGMLId);
-            msFree(pszGMLId);
-
-            msIO_fprintf(stream, "%s        <gml:exterior>\n", tab);
-            msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
-
-            msIO_fprintf(stream, "%s            <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-            for(j=0; j<shape->line[i].numpoints; j++)
-            {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y, geometry_precision,shape->line[i].point[j].z);
-            else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y);
-            }
-
-            msIO_fprintf(stream, "</gml:posList>\n");
-
-            msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
-            msIO_fprintf(stream, "%s        </gml:exterior>\n", tab);
-
-            for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-              if(innerlist[k] == MS_TRUE) {
-                msIO_fprintf(stream, "%s        <gml:interior>\n", tab);
-                msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
-
-                msIO_fprintf(stream, "%s            <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-                for(j=0; j<shape->line[k].numpoints; j++)
-                {
-                  if( nSRSDimension == 3 )
-                    msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y, geometry_precision,shape->line[k].point[j].z);
-                  else
-                        /* fall-through */
-                  msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
-                }
-                msIO_fprintf(stream, "</gml:posList>\n");
-
-                msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
-                msIO_fprintf(stream, "%s        </gml:interior>\n", tab);
-              }
-            }
-
-            msIO_fprintf(stream, "%s      </gml:Polygon>\n", tab);
-
-            free(innerlist);
-            msIO_fprintf(stream, "%s    </gml:surfaceMember>\n", tab);
-          }
-        }
-        msIO_fprintf(stream, "%s  </gml:MultiSurface>\n", tab);
-
-        free(outerlist);
-        outerlist = NULL;
-
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no polygon/multipolygon geometry defined. -->\n");
-      }
-
-      break;
-    default:
-      break;
-  }
-
-  /* clean-up */
-  msFree(outerlist);
-  msFree(srsname_encoded);
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Wrappers for the format specific encoding functions.
-*/
-static int gmlWriteBounds(FILE *stream, OWSGMLVersion format, rectObj *rect,
-                          const char *srsname, const char *tab,
-                          const char *pszTopPrefix)
-{
-  switch(format) {
-    case(OWS_GML2):
-      return gmlWriteBounds_GML2(stream, rect, srsname, tab, pszTopPrefix);
-      break;
-    case(OWS_GML3):
-    case(OWS_GML32):
-      return gmlWriteBounds_GML3(stream, rect, srsname, tab, pszTopPrefix);
-      break;
-    default:
-      msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteBounds()");
-  }
-
-  return(MS_FAILURE);
-}
-
-static int gmlWriteGeometry(FILE *stream, gmlGeometryListObj *geometryList,
-                            OWSGMLVersion format, shapeObj *shape,
-                            const char *srsname, const char *namespace,
-                            const char *tab, const char* pszFID, int nSRSDimension, int geometry_precision)
-{
-  switch(format) {
-    case(OWS_GML2):
-      return gmlWriteGeometry_GML2(stream, geometryList, shape, srsname, namespace, tab, nSRSDimension, geometry_precision);
-      break;
-    case(OWS_GML3):
-    case(OWS_GML32):
-      return gmlWriteGeometry_GML3(stream, geometryList, shape, srsname, namespace, tab, pszFID, format, nSRSDimension, geometry_precision);
-      break;
-    default:
-      msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteGeometry()");
-  }
-
-  return(MS_FAILURE);
-}
-
-/*
-** GML specific metadata handling functions.
-*/
-
-int msItemInGroups(const char *name, gmlGroupListObj *groupList)
-{
-  int i, j;
-  gmlGroupObj *group;
-
-  if(!groupList) return MS_FALSE; /* no groups */
-
-  for(i=0; i<groupList->numgroups; i++) {
-    group = &(groupList->groups[i]);
-    for(j=0; j<group->numitems; j++) {
-      if(strcasecmp(name, group->items[j]) == 0) return MS_TRUE;
-    }
-  }
-
-  return MS_FALSE;
-}
-
-static int msGMLGeometryLookup(gmlGeometryListObj *geometryList, const char *type)
-{
-  int i;
-
-  if(!geometryList || !type) return -1; /* nothing to look for */
-
-  for(i=0; i<geometryList->numgeometries; i++)
-    if(geometryList->geometries[i].type && (strcasecmp(geometryList->geometries[i].type, type) == 0))
-      return i;
-
-  if( geometryList->numgeometries == 1 && geometryList->geometries[0].type == NULL )
-    return 0;
-
-  return -1; /* not found */
-}
-
-gmlGeometryListObj *msGMLGetGeometries(layerObj *layer, const char *metadata_namespaces, int bWithDefaultGeom)
-{
-  int i;
-
-  const char *value=NULL;
-  char tag[64];
-
-  char **names=NULL;
-  int numnames=0;
-
-  gmlGeometryListObj *geometryList=NULL;
-  gmlGeometryObj *geometry=NULL;
-
-  /* allocate memory and initialize the item collection */
-  geometryList = (gmlGeometryListObj *) malloc(sizeof(gmlGeometryListObj));
-  MS_CHECK_ALLOC(geometryList, sizeof(gmlGeometryListObj), NULL) ;
-  geometryList->geometries = NULL;
-  geometryList->numgeometries = 0;
-
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "geometries")) != NULL) {
-    names = msStringSplit(value, ',', &numnames);
-
-    /* allocation an array of gmlGeometryObj's */
-    geometryList->numgeometries = numnames;
-    geometryList->geometries = (gmlGeometryObj *) malloc(sizeof(gmlGeometryObj)*geometryList->numgeometries);
-    if (geometryList->geometries ==  NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetGeometries()",
-                 (unsigned int)(sizeof(gmlGeometryObj)*geometryList->numgeometries));
-      free(geometryList);
-      return NULL;
-    }
-
-    for(i=0; i<geometryList->numgeometries; i++) {
-      geometry = &(geometryList->geometries[i]);
-
-      geometry->name = msStrdup(names[i]); /* initialize a few things */
-      geometry->type = NULL;
-      geometry->occurmin = 0;
-      geometry->occurmax = 1;
-
-      snprintf(tag, 64, "%s_type", names[i]);
-      if((value =  msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-        geometry->type = msStrdup(value); /* TODO: validate input value */
-
-      snprintf(tag, 64, "%s_occurances", names[i]);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL) {
-        char **occur;
-        int numoccur;
-
-        occur = msStringSplit(value, ',', &numoccur);
-        if(numoccur == 2) { /* continue (TODO: throw an error if != 2) */
-          geometry->occurmin = atof(occur[0]);
-          if(strcasecmp(occur[1], "UNBOUNDED") == 0)
-            geometry->occurmax = OWS_GML_OCCUR_UNBOUNDED;
-          else
-            geometry->occurmax = atof(occur[1]);
-        }
-        msFreeCharArray(occur,numoccur);
-      }
-    }
-
-    msFreeCharArray(names, numnames);
-  }
-  else if( bWithDefaultGeom ) {
-    geometryList->numgeometries = 1;
-    geometryList->geometries = (gmlGeometryObj *) calloc(1, sizeof(gmlGeometryObj));
-    geometryList->geometries[0].name = msStrdup(OWS_GML_DEFAULT_GEOMETRY_NAME);
-    geometryList->geometries[0].type = NULL;
-    geometryList->geometries[0].occurmin = 0;
-    geometryList->geometries[0].occurmax = 1;
-  }
-
-  return geometryList;
-}
-
-void msGMLFreeGeometries(gmlGeometryListObj *geometryList)
-{
-  int i;
-
-  if(!geometryList) return;
-
-  for(i=0; i<geometryList->numgeometries; i++) {
-    msFree(geometryList->geometries[i].name);
-    msFree(geometryList->geometries[i].type);
-  }
-  free(geometryList->geometries);
-
-  free(geometryList);
-}
-
-static void msGMLWriteItem(FILE *stream, gmlItemObj *item,
-                           const char *value, const char *namespace,
-                           const char *tab,
-                           OWSGMLVersion outputformat,
-                           const char *pszFID)
-{
-  char *encoded_value = NULL, *tag_name;
-  int add_namespace = MS_TRUE;
-  char gmlid[256];
-  gmlid[0] = 0;
-
-  if(!stream || !item) return;
-  if(!item->visible) return;
-
-  if(!namespace) add_namespace = MS_FALSE;
-
-  if(item->alias)
-    tag_name = item->alias;
-  else
-    tag_name = item->name;
-  if(strchr(tag_name, ':') != NULL) add_namespace = MS_FALSE;
-
-  if( item->type && (EQUAL(item->type, "Date") ||
-                     EQUAL(item->type, "DateTime") ||
-                     EQUAL(item->type, "Time")) ) {
-      struct tm tm;
-      if( msParseTime(value, &tm) == MS_TRUE ) {
-          const char* pszStartTag = "";
-          const char* pszEndTag = "";
-
-          encoded_value = (char*) msSmallMalloc(256);
-          if( outputformat == OWS_GML32  ) {
-              if( pszFID != NULL )
-                snprintf(gmlid, 256, " gml:id=\"%s.%s\"", pszFID, tag_name);
-              pszStartTag = "<gml:timePosition>";
-              pszEndTag = "</gml:timePosition>";
-          }
-
-          if( EQUAL(item->type, "Date") )
-              snprintf(encoded_value, 256, "%s%04d-%02d-%02d%s",
-                       pszStartTag,
-                       tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
-                       pszEndTag);
-          else if( EQUAL(item->type, "Time") )
-              snprintf(encoded_value, 256, "%s%02d:%02d:%02dZ%s",
-                       pszStartTag,
-                       tm.tm_hour, tm.tm_min, tm.tm_sec,
-                       pszEndTag);
-          else
-          {
-              // Detected date time already formatted as YYYY-MM-DDTHH:mm:SS+ab:cd
-              // because msParseTime() can't handle time zones.
-              if( strlen(value) == 4+1+2+1+2+1+2+1+2+1+2+1+2+1+2 &&
-                  value[4] == '-' && value[7] == '-' && value[10] == 'T' &&
-                  value[13] == ':' && value[16] == ':' &&
-                  (value[19] == '+' || value[19] == '-') &&
-                  value[22] == ':' )
-              {
-                  snprintf(encoded_value, 256, "%s%s%s",
-                           pszStartTag, value, pszEndTag);
-              }
-              else
-              {
-                  snprintf(encoded_value, 256, "%s%04d-%02d-%02dT%02d:%02d:%02dZ%s",
-                           pszStartTag,
-                           tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
-                           tm.tm_hour, tm.tm_min, tm.tm_sec, pszEndTag);
-              }
-          }
-      }
-  }
-
-  if( encoded_value == NULL )
-  {
-    if(item->encode == MS_TRUE)
-      encoded_value = msEncodeHTMLEntities(value);
-    else
-      encoded_value = msStrdup(value);
-  }
-
-  if(!item->template) { /* build the tag from pieces */
-
-    if(add_namespace == MS_TRUE && msIsXMLTagValid(tag_name) == MS_FALSE)
-      msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n", tag_name);
-
-    if(add_namespace == MS_TRUE)
-      msIO_fprintf(stream, "%s<%s:%s%s>%s</%s:%s>\n", tab, namespace, tag_name, gmlid, encoded_value, namespace, tag_name);
-    else
-      msIO_fprintf(stream, "%s<%s%s>%s</%s>\n", tab, tag_name, gmlid, encoded_value, tag_name);
-  } else {
-    char *tag = NULL;
-
-    tag = msStrdup(item->template);
-    tag = msReplaceSubstring(tag, "$value", encoded_value);
-    if(namespace) tag = msReplaceSubstring(tag, "$namespace", namespace);
-    msIO_fprintf(stream, "%s%s\n", tab, tag);
-    free(tag);
-  }
-
-  free( encoded_value );
-
-  return;
-}
-
-gmlNamespaceListObj *msGMLGetNamespaces(webObj *web, const char *metadata_namespaces)
-{
-  int i;
-  const char *value=NULL;
-  char tag[64];
-
-  char **prefixes=NULL;
-  int numprefixes=0;
-
-  gmlNamespaceListObj *namespaceList=NULL;
-  gmlNamespaceObj *namespace=NULL;
-
-  /* allocate the collection */
-  namespaceList = (gmlNamespaceListObj *) malloc(sizeof(gmlNamespaceListObj));
-  MS_CHECK_ALLOC(namespaceList, sizeof(gmlNamespaceListObj), NULL) ;
-  namespaceList->namespaces = NULL;
-  namespaceList->numnamespaces = 0;
-
-  /* list of namespaces (TODO: make this automatic by parsing metadata) */
-  if((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces, "external_namespace_prefixes")) != NULL) {
-    prefixes = msStringSplit(value, ',', &numprefixes);
-
-    /* allocation an array of gmlNamespaceObj's */
-    namespaceList->numnamespaces = numprefixes;
-    namespaceList->namespaces = (gmlNamespaceObj *) malloc(sizeof(gmlNamespaceObj)*namespaceList->numnamespaces);
-    if (namespaceList->namespaces == NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetNamespaces()",
-                 (unsigned int)(sizeof(gmlNamespaceObj)*namespaceList->numnamespaces));
-      free(namespaceList);
-      return NULL;
-    }
-
-    for(i=0; i<namespaceList->numnamespaces; i++) {
-      namespace = &(namespaceList->namespaces[i]);
-
-      namespace->prefix = msStrdup(prefixes[i]); /* initialize a few things */
-      namespace->uri = NULL;
-      namespace->schemalocation = NULL;
-
-      snprintf(tag, 64, "%s_uri", namespace->prefix);
-      if((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces, tag)) != NULL)
-        namespace->uri = msStrdup(value);
-
-      snprintf(tag, 64, "%s_schema_location", namespace->prefix);
-      if((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces, tag)) != NULL)
-        namespace->schemalocation = msStrdup(value);
-    }
-
-    msFreeCharArray(prefixes, numprefixes);
-  }
-
-  return namespaceList;
-}
-
-void msGMLFreeNamespaces(gmlNamespaceListObj *namespaceList)
-{
-  int i;
-
-  if(!namespaceList) return;
-
-  for(i=0; i<namespaceList->numnamespaces; i++) {
-    msFree(namespaceList->namespaces[i].prefix);
-    msFree(namespaceList->namespaces[i].uri);
-    msFree(namespaceList->namespaces[i].schemalocation);
-  }
-
-  free(namespaceList);
-}
-
-gmlConstantListObj *msGMLGetConstants(layerObj *layer, const char *metadata_namespaces)
-{
-  int i;
-  const char *value=NULL;
-  char tag[64];
-
-  char **names=NULL;
-  int numnames=0;
-
-  gmlConstantListObj *constantList=NULL;
-  gmlConstantObj *constant=NULL;
-
-  /* allocate the collection */
-  constantList = (gmlConstantListObj *) malloc(sizeof(gmlConstantListObj));
-  MS_CHECK_ALLOC(constantList, sizeof(gmlConstantListObj), NULL);
-  constantList->constants = NULL;
-  constantList->numconstants = 0;
-
-  /* list of constants (TODO: make this automatic by parsing metadata) */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "constants")) != NULL) {
-    names = msStringSplit(value, ',', &numnames);
-
-    /* allocation an array of gmlConstantObj's */
-    constantList->numconstants = numnames;
-    constantList->constants = (gmlConstantObj *) malloc(sizeof(gmlConstantObj)*constantList->numconstants);
-    if (constantList->constants == NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetConstants()",
-                 (unsigned int)(sizeof(gmlConstantObj)*constantList->numconstants));
-      free(constantList);
-      return NULL;
-    }
-
-
-    for(i=0; i<constantList->numconstants; i++) {
-      constant = &(constantList->constants[i]);
-
-      constant->name = msStrdup(names[i]); /* initialize a few things */
-      constant->value = NULL;
-      constant->type = NULL;
-
-      snprintf(tag, 64, "%s_value", constant->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-        constant->value = msStrdup(value);
-
-      snprintf(tag, 64, "%s_type", constant->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-        constant->type = msStrdup(value);
-    }
-
-    msFreeCharArray(names, numnames);
-  }
-
-  return constantList;
-}
-
-void msGMLFreeConstants(gmlConstantListObj *constantList)
-{
-  int i;
-
-  if(!constantList) return;
-
-  for(i=0; i<constantList->numconstants; i++) {
-    msFree(constantList->constants[i].name);
-    msFree(constantList->constants[i].value);
-    msFree(constantList->constants[i].type);
-  }
-
-  free(constantList);
-}
-
-static void msGMLWriteConstant(FILE *stream, gmlConstantObj *constant, const char *namespace, const char *tab)
-{
-  int add_namespace = MS_TRUE;
-
-  if(!stream || !constant) return;
-  if(!constant->value) return;
-
-  if(!namespace) add_namespace = MS_FALSE;
-  if(strchr(constant->name, ':') != NULL) add_namespace = MS_FALSE;
-
-  if(add_namespace == MS_TRUE && msIsXMLTagValid(constant->name) == MS_FALSE)
-    msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n", constant->name);
-
-  if(add_namespace == MS_TRUE)
-    msIO_fprintf(stream, "%s<%s:%s>%s</%s:%s>\n", tab, namespace, constant->name, constant->value, namespace, constant->name);
-  else
-    msIO_fprintf(stream, "%s<%s>%s</%s>\n", tab, constant->name, constant->value, constant->name);
-
-  return;
-}
-
-static void msGMLWriteGroup(FILE *stream,
-                            gmlGroupObj *group, shapeObj *shape,
-                            gmlItemListObj *itemList,
-                            gmlConstantListObj *constantList,
-                            const char *namespace, const char *tab,
-                            OWSGMLVersion outputformat,
-                            const char *pszFID)
-{
-  int i,j;
-  int add_namespace = MS_TRUE;
-  char *itemtab;
-
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
-
-  if(!stream || !group) return;
-
-  /* setup the item/constant tab */
-  itemtab = (char *) msSmallMalloc(sizeof(char)*strlen(tab)+3);
-
-  sprintf(itemtab, "%s  ", tab);
-
-  if(!namespace || strchr(group->name, ':') != NULL) add_namespace = MS_FALSE;
-
-  /* start the group */
-  if(add_namespace == MS_TRUE)
-    msIO_fprintf(stream, "%s<%s:%s>\n", tab, namespace, group->name);
-  else
-    msIO_fprintf(stream, "%s<%s>\n", tab, group->name);
-
-  /* now the items/constants in the group */
-  for(i=0; i<group->numitems; i++) {
-    for(j=0; j<constantList->numconstants; j++) {
-      constant = &(constantList->constants[j]);
-      if(strcasecmp(constant->name, group->items[i]) == 0) {
-        msGMLWriteConstant(stream, constant, namespace, itemtab);
-        break;
-      }
-    }
-    if(j != constantList->numconstants) continue; /* found this one */
-    for(j=0; j<itemList->numitems; j++) {
-      item = &(itemList->items[j]);
-      if(strcasecmp(item->name, group->items[i]) == 0) {
-        /* the number of items matches the number of values exactly */
-        msGMLWriteItem(stream, item, shape->values[j], namespace, itemtab, outputformat, pszFID);
-        break;
-      }
-    }
-  }
-
-  /* end the group */
-  if(add_namespace == MS_TRUE)
-    msIO_fprintf(stream, "%s</%s:%s>\n", tab, namespace, group->name);
-  else
-    msIO_fprintf(stream, "%s</%s>\n", tab, group->name);
-
-  msFree(itemtab);
-
-  return;
-}
-#endif
-
-gmlGroupListObj *msGMLGetGroups(layerObj *layer, const char *metadata_namespaces)
-{
-  int i;
-  const char *value=NULL;
-  char tag[64];
-
-  char **names=NULL;
-  int numnames=0;
-
-  gmlGroupListObj *groupList=NULL;
-  gmlGroupObj *group=NULL;
-
-  /* allocate the collection */
-  groupList = (gmlGroupListObj *) malloc(sizeof(gmlGroupListObj));
-  MS_CHECK_ALLOC(groupList, sizeof(gmlGroupListObj), NULL) ;
-  groupList->groups = NULL;
-  groupList->numgroups = 0;
-
-  /* list of groups (TODO: make this automatic by parsing metadata) */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "groups")) != NULL &&
-      value[0] != '\0' ) {
-    names = msStringSplit(value, ',', &numnames);
-
-    /* allocation an array of gmlGroupObj's */
-    groupList->numgroups = numnames;
-    groupList->groups = (gmlGroupObj *) malloc(sizeof(gmlGroupObj)*groupList->numgroups);
-    if (groupList->groups == NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetGroups()",
-                 (unsigned int)(sizeof(gmlGroupObj)*groupList->numgroups));
-      free(groupList);
-      return NULL;
-    }
-
-    for(i=0; i<groupList->numgroups; i++) {
-      group = &(groupList->groups[i]);
-
-      group->name = msStrdup(names[i]); /* initialize a few things */
-      group->items = NULL;
-      group->numitems = 0;
-      group->type = NULL;
-
-      snprintf(tag, 64, "%s_group", group->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-        group->items = msStringSplit(value, ',', &group->numitems);
-
-      snprintf(tag, 64, "%s_type", group->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-        group->type = msStrdup(value);
-    }
-
-    msFreeCharArray(names, numnames);
-  }
-
-  return groupList;
-}
-
-void msGMLFreeGroups(gmlGroupListObj *groupList)
-{
-  int i;
-
-  if(!groupList) return;
-
-  for(i=0; i<groupList->numgroups; i++) {
-    msFree(groupList->groups[i].name);
-    msFreeCharArray(groupList->groups[i].items, groupList->groups[i].numitems);
-    msFree(groupList->groups[i].type);
-  }
-  msFree(groupList->groups);
-
-  free(groupList);
-}
-
-/* Dump GML query results for WMS GetFeatureInfo */
-int msGMLWriteQuery(mapObj *map, char *filename, const char *namespaces)
-{
-#if defined(USE_WMS_SVR)
-  int status;
-  int i,j,k;
-  layerObj *lp=NULL;
-  shapeObj shape;
-  FILE *stream_to_free = NULL;
-  FILE *stream=stdout; /* defaults to stdout */
-  char szPath[MS_MAXPATHLEN];
-  char *value;
-  char *pszMapSRS = NULL;
-
-  gmlGroupListObj *groupList=NULL;
-  gmlItemListObj *itemList=NULL;
-  gmlConstantListObj *constantList=NULL;
-  gmlGeometryListObj *geometryList=NULL;
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
-
-  msInitShape(&shape);
-
-  if(filename && strlen(filename) > 0) { /* deal with the filename if present */
-    stream_to_free = fopen(msBuildPath(szPath, map->mappath, filename), "w");
-    if(!stream_to_free) {
-      msSetError(MS_IOERR, "(%s)", "msGMLWriteQuery()", filename);
-      return(MS_FAILURE);
-    }
-    stream = stream_to_free;
-  }
-
-  msIO_fprintf(stream, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");
-  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces, "rootname", OWS_NOERR, "<%s ", "msGMLOutput");
-
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "uri", OWS_NOERR, "xmlns=\"%s\"", NULL);
-  msIO_fprintf(stream, "\n\t xmlns:gml=\"http://www.opengis.net/gml\"" );
-  msIO_fprintf(stream, "\n\t xmlns:xlink=\"http://www.w3.org/1999/xlink\"");
-  msIO_fprintf(stream, "\n\t xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "schema", OWS_NOERR, "\n\t xsi:schemaLocation=\"%s\"", NULL);
-  msIO_fprintf(stream, ">\n");
-
-  /* a schema *should* be required */
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "description", OWS_NOERR, "\t<gml:description>%s</gml:description>\n", NULL);
-
-  /* Look up map SRS. We need an EPSG code for GML, if not then we get null and we'll fall back on the layer's SRS */
-  msOWSGetEPSGProj(&(map->projection), NULL, namespaces, MS_TRUE, &pszMapSRS);
-
-  /* step through the layers looking for query results */
-  for(i=0; i<map->numlayers; i++) {
-    char *pszOutputSRS = NULL;
-    int nSRSDimension = 2;
-    const char* geomtype;
-    lp = (GET_LAYER(map, map->layerorder[i]));
-
-    if(lp->resultcache && lp->resultcache->numresults > 0) { /* found results */
-
-      reprojectionObj* reprojector = NULL;
-
-      /* Determine output SRS, if map has none, then try using layer's native SRS */
-      if ((pszOutputSRS = pszMapSRS) == NULL) {
-        msOWSGetEPSGProj(&(lp->projection), NULL, namespaces, MS_TRUE, &pszOutputSRS);
-        if (pszOutputSRS == NULL) {
-          msSetError(MS_WMSERR, "No valid EPSG code in map or layer projection for GML output", "msGMLWriteQuery()");
-          continue;  /* No EPSG code, cannot output this layer */
-        }
-      }
-
-      /* start this collection (layer) */
-      /* if no layer name provided fall back on the layer name + "_layer" */
-      value = (char*) msSmallMalloc(strlen(lp->name)+7);
-      sprintf(value, "%s_layer", lp->name);
-      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "layername", OWS_NOERR, "\t<%s>\n", value);
-      msFree(value);
-
-      value = (char *) msOWSLookupMetadata(&(lp->metadata), "OM", "title");
-      if (value) {
-        msOWSPrintEncodeMetadata(stream, &(lp->metadata), namespaces, "title", OWS_NOERR, "\t<gml:name>%s</gml:name>\n", value);
-      }
-
-      geomtype = msOWSLookupMetadata(&(lp->metadata), "OFG", "geomtype");
-      if( geomtype != NULL && (strstr(geomtype, "25d") != NULL || strstr(geomtype, "25D") != NULL) ) {
-        nSRSDimension = 3;
-      }
-
-      /* populate item and group metadata structures */
-      itemList = msGMLGetItems(lp, namespaces);
-      constantList = msGMLGetConstants(lp, namespaces);
-      groupList = msGMLGetGroups(lp, namespaces);
-      geometryList = msGMLGetGeometries(lp, namespaces, MS_FALSE);
-      if (itemList == NULL || constantList == NULL || groupList == NULL || geometryList == NULL) {
-        msSetError(MS_MISCERR, "Unable to populate item and group metadata structures", "msGMLWriteQuery()");
-        if(stream_to_free != NULL) fclose(stream_to_free);
-        return MS_FAILURE;
-      }
-
-      if(pszOutputSRS == pszMapSRS && msProjectionsDiffer(&(lp->projection), &(map->projection))) {
-        reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-        if( reprojector == NULL ) {
-          msGMLFreeGroups(groupList);
-          msGMLFreeConstants(constantList);
-          msGMLFreeItems(itemList);
-          msGMLFreeGeometries(geometryList);
-          msFree(pszOutputSRS);
-          if(stream_to_free != NULL) fclose(stream_to_free);
-          return MS_FAILURE;
-        }
-      }
-
-      for(j=0; j<lp->resultcache->numresults; j++) {
-        status = msLayerGetShape(lp, &shape, &(lp->resultcache->results[j]));
-        if(status != MS_SUCCESS) {
-          msGMLFreeGroups(groupList);
-          msGMLFreeConstants(constantList);
-          msGMLFreeItems(itemList);
-          msGMLFreeGeometries(geometryList);
-          msProjectDestroyReprojector(reprojector);
-          msFree(pszOutputSRS);
-          if(stream_to_free != NULL) fclose(stream_to_free);
-          return MS_FAILURE;
-        }
-
-        /* project the shape into the map projection (if necessary), note that this projects the bounds as well */
-        if(reprojector) {
-          status = msProjectShapeEx(reprojector, &shape);
-          if(status != MS_SUCCESS) {
-            msIO_fprintf(stream, "<!-- Warning: Failed to reproject shape: %s -->\n",msGetErrorString(","));
-            msFreeShape(&shape);
-            continue;
-          }
-        }
-
-        /* start this feature */
-        /* specify a feature name, if nothing provided fall back on the layer name + "_feature" */
-        value = (char*) msSmallMalloc(strlen(lp->name)+9);
-        sprintf(value, "%s_feature", lp->name);
-        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "featurename", OWS_NOERR, "\t\t<%s>\n", value);
-        msFree(value);
-
-        /* Write the feature geometry and bounding box unless 'none' was requested. */
-        /* Default to bbox only if nothing specified and output full geometry only if explicitly requested */
-        if(!(geometryList && geometryList->numgeometries == 1 && strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
-          gmlWriteBounds(stream, OWS_GML2, &(shape.bounds), pszOutputSRS, "\t\t\t", "gml");
-          if (geometryList && geometryList->numgeometries > 0 )
-            gmlWriteGeometry(stream, geometryList, OWS_GML2, &(shape), pszOutputSRS, NULL, "\t\t\t", "", nSRSDimension, 6);
-        }
-
-        /* write any item/values */
-        for(k=0; k<itemList->numitems; k++) {
-          item = &(itemList->items[k]);
-          if(msItemInGroups(item->name, groupList) == MS_FALSE)
-            msGMLWriteItem(stream, item, shape.values[k], NULL, "\t\t\t", OWS_GML2, NULL);
-        }
-
-        /* write any constants */
-        for(k=0; k<constantList->numconstants; k++) {
-          constant = &(constantList->constants[k]);
-          if(msItemInGroups(constant->name, groupList) == MS_FALSE)
-            msGMLWriteConstant(stream, constant, NULL, "\t\t\t");
-        }
-
-        /* write any groups */
-        for(k=0; k<groupList->numgroups; k++)
-          msGMLWriteGroup(stream, &(groupList->groups[k]), &shape, itemList, constantList, NULL, "\t\t\t", OWS_GML2, NULL);
-
-        /* end this feature */
-        /* specify a feature name if nothing provided */
-        /* fall back on the layer name + "Feature" */
-        value = (char*) msSmallMalloc(strlen(lp->name)+9);
-        sprintf(value, "%s_feature", lp->name);
-        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "featurename", OWS_NOERR, "\t\t</%s>\n", value);
-        msFree(value);
-
-        msFreeShape(&shape); /* init too */
-      }
-
-      msProjectDestroyReprojector(reprojector);
-
-      /* end this collection (layer) */
-      /* if no layer name provided fall back on the layer name + "_layer" */
-      value = (char*) msSmallMalloc(strlen(lp->name)+7);
-      sprintf(value, "%s_layer", lp->name);
-      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "layername", OWS_NOERR, "\t</%s>\n", value);
-      msFree(value);
-
-      msGMLFreeGroups(groupList);
-      msGMLFreeConstants(constantList);
-      msGMLFreeItems(itemList);
-      msGMLFreeGeometries(geometryList);
-
-      /* msLayerClose(lp); */
-    }
-    if(pszOutputSRS!=pszMapSRS) {
-      msFree(pszOutputSRS);
-    }
-  } /* next layer */
-
-  /* end this document */
-  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces, "rootname", OWS_NOERR, "</%s>\n", "msGMLOutput");
-
-  if(stream_to_free != NULL) fclose(stream_to_free);
-  msFree(pszMapSRS);
-
-  return(MS_SUCCESS);
-
-#else /* Stub for mapscript */
-  msSetError(MS_MISCERR, "WMS server support not enabled", "msGMLWriteQuery()");
-  return MS_FAILURE;
-#endif
-}
-
-#ifdef USE_WFS_SVR
-void msGMLWriteWFSBounds(mapObj *map, FILE *stream, const char *tab,
-                         OWSGMLVersion outputformat, int nWFSVersion, int bUseURN)
-{
-  rectObj  resultBounds = {-1.0,-1.0,-1.0,-1.0};
-
-  /*add a check to see if the map projection is set to be north-east*/
-  int bSwapAxis = msIsAxisInvertedProj(&(map->projection));
-
-  /* Need to start with BBOX of the whole resultset */
-  if (msGetQueryResultBounds(map, &resultBounds) > 0) {
-    char* srs = NULL;
-    if (bSwapAxis) {
-      double tmp;
-
-      tmp = resultBounds.minx;
-      resultBounds.minx =  resultBounds.miny;
-      resultBounds.miny = tmp;
-
-      tmp = resultBounds.maxx;
-      resultBounds.maxx =  resultBounds.maxy;
-      resultBounds.maxy = tmp;
-
-    }
-    if( bUseURN )
-    {
-        srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
-        if (!srs)
-            srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE);
-    }
-    else
-    {
-        msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
-        if (!srs)
-            msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE, &srs);
-    }
-
-    gmlWriteBounds(stream, outputformat, &resultBounds, srs, tab,
-                   (nWFSVersion == OWS_2_0_0) ? "wfs" : "gml");
-    msFree(srs);
-  }
-}
-
-#endif
-
-/*
-** msGMLWriteWFSQuery()
-**
-** Similar to msGMLWriteQuery() but tuned for use with WFS
-*/
-int msGMLWriteWFSQuery(mapObj *map, FILE *stream, const char *default_namespace_prefix,
-                       OWSGMLVersion outputformat, int nWFSVersion, int bUseURN,
-                       int bGetPropertyValueRequest)
-{
-#ifdef USE_WFS_SVR
-  int status;
-  int i,j,k;
-  layerObj *lp=NULL;
-  shapeObj shape;
-
-  gmlGroupListObj *groupList=NULL;
-  gmlItemListObj *itemList=NULL;
-  gmlConstantListObj *constantList=NULL;
-  gmlGeometryListObj *geometryList=NULL;
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
-
-  const char *namespace_prefix=NULL;
-  int bSwapAxis;
-
-  msInitShape(&shape);
-
-  /*add a check to see if the map projection is set to be north-east*/
-  bSwapAxis = msIsAxisInvertedProj(&(map->projection));
-
-  /* Need to start with BBOX of the whole resultset */
-  if (!bGetPropertyValueRequest) {
-    msGMLWriteWFSBounds(map, stream, "      ", outputformat, nWFSVersion, bUseURN);
-  }
-  /* step through the layers looking for query results */
-  for(i=0; i<map->numlayers; i++) {
-
-    lp = GET_LAYER(map, map->layerorder[i]);
-
-    if(lp->resultcache && lp->resultcache->numresults > 0)  { /* found results */
-      char *layerName;
-      const char *value;
-      int featureIdIndex=-1; /* no feature id */
-      char* srs = NULL;
-      int bOutputGMLIdOnly = MS_FALSE;
-      int nSRSDimension = 2;
-      const char* geomtype;
-      reprojectionObj* reprojector = NULL;
-      int geometry_precision = 6;
-
-      /* setup namespace, a layer can override the default */
-      namespace_prefix = msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
-      if(!namespace_prefix) namespace_prefix = default_namespace_prefix;
-
-      geomtype = msOWSLookupMetadata(&(lp->metadata), "OFG", "geomtype");
-      if( geomtype != NULL && (strstr(geomtype, "25d") != NULL || strstr(geomtype, "25D") != NULL) )
-      {
-          nSRSDimension = 3;
-      }
-
-      value = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
-      if(value) { /* find the featureid amongst the items for this layer */
-        for(j=0; j<lp->numitems; j++) {
-          if(strcasecmp(lp->items[j], value) == 0) { /* found it */
-            featureIdIndex = j;
-            break;
-          }
-        }
-
-        /* Produce a warning if a featureid was set but the corresponding item is not found. */
-        if (featureIdIndex == -1)
-          msIO_fprintf(stream, "<!-- WARNING: FeatureId item '%s' not found in typename '%s'. -->\n", value, lp->name);
-      }
-      else if( outputformat == OWS_GML32 )
-          msIO_fprintf(stream, "<!-- WARNING: No featureid defined for typename '%s'. Output will not validate. -->\n", lp->name);
-
-      /* populate item and group metadata structures */
-      itemList = msGMLGetItems(lp, "G");
-      constantList = msGMLGetConstants(lp, "G");
-      groupList = msGMLGetGroups(lp, "G");
-      geometryList = msGMLGetGeometries(lp, "GFO", MS_FALSE);
-      if (itemList == NULL || constantList == NULL || groupList == NULL || geometryList == NULL) {
-        msSetError(MS_MISCERR, "Unable to populate item and group metadata structures", "msGMLWriteWFSQuery()");
-        return MS_FAILURE;
-      }
-
-      if( bGetPropertyValueRequest )
-      {
-        const char* value = msOWSLookupMetadata(&(lp->metadata), "G", "include_items");
-        if( value != NULL && strcmp(value, "@gml:id") == 0 )
-            bOutputGMLIdOnly = MS_TRUE;
-      }
-
-      if (namespace_prefix) {
-        layerName = (char *) msSmallMalloc(strlen(namespace_prefix)+strlen(lp->name)+2);
-        sprintf(layerName, "%s:%s", namespace_prefix, lp->name);
-      } else {
-        layerName = msStrdup(lp->name);
-      }
-
-      if( bUseURN )
-      {
-          srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
-          if (!srs)
-            srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE);
-          if (!srs)
-            srs = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FGO", MS_TRUE);
-      }
-      else
-      {
-          msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
-          if (!srs)
-            msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE, &srs);
-          if (!srs)
-            msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FGO", MS_TRUE, &srs);
-      }
-
-      if(msProjectionsDiffer(&(lp->projection), &(map->projection))) {
-        reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-        if( reprojector == NULL ) {
-           msGMLFreeGroups(groupList);
-           msGMLFreeConstants(constantList);
-           msGMLFreeItems(itemList);
-           msGMLFreeGeometries(geometryList);
-           msFree(layerName);
-           msFree(srs);
-           return MS_FAILURE;
-        }
-      }
-
-      for(j=0; j<lp->resultcache->numresults; j++) {
-        char* pszFID;
-
-        if( lp->resultcache->results[j].shape )
-        {
-            /* msDebug("Using cached shape %ld\n", lp->resultcache->results[j].shapeindex); */
-            msCopyShape(lp->resultcache->results[j].shape, &shape);
-        }
-        else
-        {
-            status = msLayerGetShape(lp, &shape, &(lp->resultcache->results[j]));
-            if(status != MS_SUCCESS) {
-                msGMLFreeGroups(groupList);
-                msGMLFreeConstants(constantList);
-                msGMLFreeItems(itemList);
-                msGMLFreeGeometries(geometryList);
-                msFree(layerName);
-                msProjectDestroyReprojector(reprojector);
-                msFree(srs);
-                return(status);
-            }
-        }
-
-        /* project the shape into the map projection (if necessary), note that this projects the bounds as well */
-        if(reprojector)
-          msProjectShapeEx(reprojector, &shape);
-
-        if(featureIdIndex != -1) {
-            pszFID = (char*) msSmallMalloc( strlen(lp->name) + 1 + strlen(shape.values[featureIdIndex]) + 1 );
-            sprintf(pszFID, "%s.%s", lp->name, shape.values[featureIdIndex]);
-        }
-        else
-            pszFID = msStrdup("");
-
-
-        if( bOutputGMLIdOnly )
-        {
-            msIO_fprintf(stream, "    <wfs:member>%s</wfs:member>\n", pszFID);
-            msFree(pszFID);
-            msFreeShape(&shape); /* init too */
-            continue;
-        }
-
-        /*
-        ** start this feature
-        */
-        if( nWFSVersion == OWS_2_0_0 )
-            msIO_fprintf(stream, "    <wfs:member>\n");
-        else
-            msIO_fprintf(stream, "    <gml:featureMember>\n");
-        if(msIsXMLTagValid(layerName) == MS_FALSE)
-            msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n", layerName);
-        if(featureIdIndex != -1) {
-            if( !bGetPropertyValueRequest )
-            {
-                if(outputformat == OWS_GML2)
-                    msIO_fprintf(stream, "      <%s fid=\"%s\">\n", layerName, pszFID);
-                else  /* OWS_GML3 or OWS_GML32 */
-                    msIO_fprintf(stream, "      <%s gml:id=\"%s\">\n", layerName, pszFID);
-            }
-        } else {
-            if( !bGetPropertyValueRequest )
-                msIO_fprintf(stream, "      <%s>\n", layerName);
-        }
-
-        if (bSwapAxis)
-          msAxisSwapShape(&shape);
-
-        /* write the feature geometry and bounding box */
-        if(!(geometryList && geometryList->numgeometries == 1 &&
-            strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
-          if( !bGetPropertyValueRequest )
-            gmlWriteBounds(stream, outputformat, &(shape.bounds), srs, "        ", "gml");
-        
-          if(msOWSLookupMetadata(&(lp->metadata), "F", "geometry_precision")){
-            geometry_precision=atoi(msOWSLookupMetadata(&(lp->metadata), "F", "geometry_precision"));
-          } else if(msOWSLookupMetadata(&map->web.metadata, "F", "geometry_precision")){
-            geometry_precision=atoi(msOWSLookupMetadata(&map->web.metadata, "F", "geometry_precision"));
-          }
-
-          gmlWriteGeometry(stream, geometryList, outputformat, &(shape), srs,
-                           namespace_prefix, "        ", pszFID, nSRSDimension,geometry_precision);
-        }
-
-        /* write any item/values */
-        for(k=0; k<itemList->numitems; k++) {
-          item = &(itemList->items[k]);
-          if(msItemInGroups(item->name, groupList) == MS_FALSE)
-            msGMLWriteItem(stream, item, shape.values[k], namespace_prefix,
-                           "        ", outputformat, pszFID);
-        }
-
-        /* write any constants */
-        for(k=0; k<constantList->numconstants; k++) {
-          constant = &(constantList->constants[k]);
-          if(msItemInGroups(constant->name, groupList) == MS_FALSE)
-            msGMLWriteConstant(stream, constant, namespace_prefix, "        ");
-        }
-
-        /* write any groups */
-        for(k=0; k<groupList->numgroups; k++)
-          msGMLWriteGroup(stream, &(groupList->groups[k]), &shape, itemList,
-                          constantList, namespace_prefix, "        ", outputformat, pszFID);
-
-        if( !bGetPropertyValueRequest )
-            /* end this feature */
-            msIO_fprintf(stream, "      </%s>\n", layerName);
-
-        if( nWFSVersion == OWS_2_0_0 )
-          msIO_fprintf(stream, "    </wfs:member>\n");
-        else
-          msIO_fprintf(stream, "    </gml:featureMember>\n");
-
-
-        msFree(pszFID);
-        pszFID = NULL;
-        msFreeShape(&shape); /* init too */
-      }
-
-      msProjectDestroyReprojector(reprojector);
-
-      msFree(srs);
-
-      /* done with this layer, do a little clean-up */
-      msFree(layerName);
-
-      msGMLFreeGroups(groupList);
-      msGMLFreeConstants(constantList);
-      msGMLFreeItems(itemList);
-      msGMLFreeGeometries(geometryList);
-
-      /* msLayerClose(lp); */
-    }
-
-  } /* next layer */
-
-  return(MS_SUCCESS);
-
-#else /* Stub for mapscript */
-  msSetError(MS_MISCERR, "WFS server support not enabled", "msGMLWriteWFSQuery()");
-  return MS_FAILURE;
-#endif /* USE_WFS_SVR */
-}
-
-
-#ifdef USE_LIBXML2
-
-/**
- * msGML3BoundedBy()
- *
- * returns an object of BoundedBy as per GML 3
- *
- * @param xmlNsPtr psNs the namespace object
- * @param minx minx
- * @param miny miny
- * @param maxx maxx
- * @param mayy mayy
- * @param psEpsg epsg code
- * @param dimension number of dimensions
- *
- * @return psNode xmlNodePtr of XML construct
- *
- */
-
-xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx, double maxy, const char *psEpsg)
-{
-  xmlNodePtr psNode = NULL, psSubNode = NULL;
-  char *pszTmp = NULL;
-  char *pszTmp2 = NULL;
-  char *pszEpsg = NULL;
-
-  psNode = xmlNewNode(psNs, BAD_CAST "boundedBy");
-  psSubNode = xmlNewChild(psNode, NULL, BAD_CAST "Envelope", NULL);
-
-  if (psEpsg) {
-    const size_t bufferSize = strlen(psEpsg)+1;
-    pszEpsg = (char*) msSmallMalloc(bufferSize);
-    snprintf(pszEpsg, bufferSize, "%s", psEpsg);
-    msStringToLower(pszEpsg);
-    pszTmp = msStringConcatenate(pszTmp, "urn:ogc:crs:");
-    pszTmp = msStringConcatenate(pszTmp, pszEpsg);
-    xmlNewProp(psSubNode, BAD_CAST "srsName", BAD_CAST pszTmp);
-    free(pszEpsg);
-    free(pszTmp);
-    pszTmp = msIntToString(2);
-    xmlNewProp(psSubNode, BAD_CAST "srsDimension", BAD_CAST pszTmp);
-    free(pszTmp);
-  }
-
-  pszTmp = msDoubleToString(minx, MS_TRUE);
-  pszTmp = msStringConcatenate(pszTmp, " ");
-  pszTmp2 = msDoubleToString(miny, MS_TRUE);
-  pszTmp = msStringConcatenate(pszTmp, pszTmp2);
-  xmlNewChild(psSubNode, NULL, BAD_CAST "lowerCorner", BAD_CAST pszTmp);
-  free(pszTmp);
-  free(pszTmp2);
-
-  pszTmp = msDoubleToString(maxx, MS_TRUE);
-  pszTmp = msStringConcatenate(pszTmp, " ");
-  pszTmp2 = msDoubleToString(maxy,MS_TRUE);
-  pszTmp = msStringConcatenate(pszTmp, pszTmp2);
-  xmlNewChild(psSubNode, NULL, BAD_CAST "upperCorner", BAD_CAST pszTmp);
-  free(pszTmp);
-  free(pszTmp2);
-  return psNode;
-}
-
-/**
- *msGML3Point()
- *
- * returns an object of Point as per GML 3
- *
- * @param xmlNsPtr psNs the gml namespace object
- * @param pszSrsName EPSG code of geometry
- * @param id
- * @param x x coordinate
- * @param y y coordinate
- * @param z z coordinate
- *
- * @return psNode xmlNodePtr of XML construct
- *
- */
-
-xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id, double x, double y)
-{
-  
-  xmlNodePtr psNode = xmlNewNode(psNs, BAD_CAST "Point");
-
-  if (id) {
-    xmlNewNsProp(psNode, psNs, BAD_CAST "id", BAD_CAST id);
-  }
-
-  if (psSrsName) {
-    const size_t bufferSize = strlen(psSrsName)+1;
-    char* pszSrsName = (char *) msSmallMalloc(bufferSize);
-    snprintf(pszSrsName, bufferSize, "%s", psSrsName);
-    msStringToLower(pszSrsName);
-    char *pszTmp = NULL;
-    pszTmp = msStringConcatenate(pszTmp, "urn:ogc:crs:");
-    pszTmp = msStringConcatenate(pszTmp, pszSrsName);
-    xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszTmp);
-    free(pszSrsName);
-    free(pszTmp);
-    const int dimension = 2;
-    pszTmp = msIntToString(dimension);
-    xmlNewProp(psNode, BAD_CAST "srsDimension", BAD_CAST pszTmp);
-    free(pszTmp);
-  }
-
-  char* pszTmp = msDoubleToString(x, MS_TRUE);
-  pszTmp = msStringConcatenate(pszTmp, " ");
-  char* pszTmp2 = msDoubleToString(y, MS_TRUE);
-  pszTmp = msStringConcatenate(pszTmp, pszTmp2);
-  xmlNewChild(psNode, NULL, BAD_CAST "pos", BAD_CAST pszTmp);
-
-  free(pszTmp);
-  free(pszTmp2);
-  return psNode;
-}
-
-/**
- * msGML3TimePeriod()
- *
- * returns an object of TimePeriod as per GML 3
- *
- * @param xmlNsPtr psNs the gml namespace object
- * @param pszStart start time
- * @param pszEnd end time
- *
- * @return psNode xmlNodePtr of XML construct
- *
- */
-
-xmlNodePtr msGML3TimePeriod(xmlNsPtr psNs, char *pszStart, char *pszEnd)
-{
-  xmlNodePtr psNode=NULL;
-
-  psNode = xmlNewNode(psNs, BAD_CAST "TimePeriod");
-  xmlNewChild(psNode, NULL, BAD_CAST "beginPosition", BAD_CAST pszStart);
-  if (pszEnd)
-    xmlNewChild(psNode, NULL, BAD_CAST "endPosition", BAD_CAST pszEnd);
-  else {
-    xmlNewChild(psNode, NULL, BAD_CAST "endPosition", NULL);
-    xmlNewProp(psNode, BAD_CAST "indeterminatePosition", BAD_CAST "now");
-  }
-  return psNode;
-}
-
-/**
- * msGML3TimeInstant()
- *
- * returns an object of TimeInstant as per GML 3
- *
- * @param xmlNsPtr psNs the gml namespace object
- * @param timeInstant time instant
- *
- * @return psNode xmlNodePtr of XML construct
- *
- */
-
-xmlNodePtr msGML3TimeInstant(xmlNsPtr psNs, char *pszTime)
-{
-  xmlNodePtr psNode=NULL;
-
-  psNode = xmlNewNode(psNs, BAD_CAST "TimeInstant");
-  xmlNewChild(psNode, NULL, BAD_CAST "timePosition", BAD_CAST pszTime);
-  return psNode;
-}
-
-#endif /* USE_LIBXML2 */
-
-
-/************************************************************************/
-/*      The following functions are enabled in all cases, even if       */
-/*      WMS and WFS are not available.                                  */
-/************************************************************************/
-
-gmlItemListObj *msGMLGetItems(layerObj *layer, const char *metadata_namespaces)
-{
-  int i,j;
-
-  char **xmlitems=NULL;
-  int numxmlitems=0;
-
-  char **incitems=NULL;
-  int numincitems=0;
-
-  char **excitems=NULL;
-  int numexcitems=0;
-
-  char **optionalitems=NULL;
-  int numoptionalitems=0;
-
-  char **mandatoryitems=NULL;
-  int nummandatoryitems=0;
-
-  char **defaultitems=NULL;
-  int numdefaultitems=0;
-
-  const char *value=NULL;
-  char tag[64];
-
-  gmlItemListObj *itemList=NULL;
-  gmlItemObj *item=NULL;
-
-  /* get a list of items that might be included in output */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "include_items")) != NULL)
-    incitems = msStringSplit(value, ',', &numincitems);
-
-  /* get a list of items that should be excluded in output */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "exclude_items")) != NULL)
-    excitems = msStringSplit(value, ',', &numexcitems);
-
-  /* get a list of items that should not be XML encoded */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "xml_items")) != NULL)
-    xmlitems = msStringSplit(value, ',', &numxmlitems);
-
-  /* get a list of items that should be indicated as optional in DescribeFeatureType */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "optional_items")) != NULL)
-    optionalitems = msStringSplit(value, ',', &numoptionalitems);
-
-  /* get a list of items that should be indicated as mandatory in DescribeFeatureType */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "mandatory_items")) != NULL)
-    mandatoryitems = msStringSplit(value, ',', &nummandatoryitems);
-
-  /* get a list of items that should be presented by default in GetFeature */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "default_items")) != NULL)
-    defaultitems = msStringSplit(value, ',', &numdefaultitems);
-
-  /* allocate memory and iinitialize the item collection */
-  itemList = (gmlItemListObj *) malloc(sizeof(gmlItemListObj));
-  if(itemList == NULL) {
-    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.", "msGMLGetItems()");
-    return NULL;
-  }
-
-  itemList->numitems = layer->numitems;
-  itemList->items = (gmlItemObj *) malloc(sizeof(gmlItemObj)*itemList->numitems);
-  if(!itemList->items) {
-    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.", "msGMLGetItems()");
-    free(itemList);
-    return NULL;
-  }
-
-  for(i=0; i<layer->numitems; i++) {
-    item = &(itemList->items[i]);
-
-    item->name = msStrdup(layer->items[i]);  /* initialize the item */
-    item->alias = NULL;
-    item->type = NULL;
-    item->template = NULL;
-    item->encode = MS_TRUE;
-    item->visible = MS_FALSE;
-    item->width = 0;
-    item->precision = 0;
-    item->outputByDefault = (numdefaultitems == 0);
-    item->minOccurs = 0;
-
-    /* check visibility, included items first... */
-    if(numincitems == 1 && strcasecmp("all", incitems[0]) == 0) {
-      item->visible = MS_TRUE;
-    } else {
-      for(j=0; j<numincitems; j++) {
-        if(strcasecmp(layer->items[i], incitems[j]) == 0)
-          item->visible = MS_TRUE;
-      }
-    }
-
-    /* ...and now excluded items */
-    for(j=0; j<numexcitems; j++) {
-      if(strcasecmp(layer->items[i], excitems[j]) == 0)
-        item->visible = MS_FALSE;
-    }
-
-    /* check encoding */
-    for(j=0; j<numxmlitems; j++) {
-      if(strcasecmp(layer->items[i], xmlitems[j]) == 0)
-        item->encode = MS_FALSE;
-    }
-
-    /* check optional */
-    if(numoptionalitems == 1 && strcasecmp("all", optionalitems[0]) == 0) {
-      item->minOccurs = 0;
-    } else if( numoptionalitems > 0) {
-      item->minOccurs = 1;
-      for(j=0; j<numoptionalitems; j++) {
-        if(strcasecmp(layer->items[i], optionalitems[j]) == 0)
-          item->minOccurs = 0;
-      }
-    }
-
-    /* check mandatory */
-    if(nummandatoryitems == 1 && strcasecmp("all", mandatoryitems[0]) == 0) {
-      item->minOccurs = 1;
-    } else if( nummandatoryitems > 0) {
-      item->minOccurs = 0;
-      for(j=0; j<nummandatoryitems; j++) {
-        if(strcasecmp(layer->items[i], mandatoryitems[j]) == 0)
-          item->minOccurs = 1;
-      }
-    }
-
-    /* check default */
-    for(j=0; j<numdefaultitems; j++) {
-      if(strcasecmp(layer->items[i], defaultitems[j]) == 0)
-        item->outputByDefault = 1;
-    }
-
-    snprintf(tag, sizeof(tag), "%s_alias", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-      item->alias = msStrdup(value);
-
-    snprintf(tag, sizeof(tag), "%s_type", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-      item->type = msStrdup(value);
-
-    snprintf(tag, sizeof(tag), "%s_template", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-      item->template = msStrdup(value);
-
-    snprintf(tag, sizeof(tag), "%s_width", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-      item->width = atoi(value);
-
-    snprintf(tag, sizeof(tag), "%s_precision", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
-      item->precision = atoi(value);
-  }
-
-  msFreeCharArray(incitems, numincitems);
-  msFreeCharArray(excitems, numexcitems);
-  msFreeCharArray(xmlitems, numxmlitems);
-  msFreeCharArray(optionalitems, numoptionalitems);
-  msFreeCharArray(mandatoryitems, nummandatoryitems);
-  msFreeCharArray(defaultitems, numdefaultitems);
-
-  return itemList;
-}
-
-void msGMLFreeItems(gmlItemListObj *itemList)
-{
-  int i;
-
-  if(!itemList) return;
-
-  for(i=0; i<itemList->numitems; i++) {
-    msFree(itemList->items[i].name);
-    msFree(itemList->items[i].alias);
-    msFree(itemList->items[i].type);
-    msFree(itemList->items[i].template);
-  }
-
-  if( itemList->items != NULL )
-    free(itemList->items);
-
-  free(itemList);
-}
diff -pruN 8.0.1-5/mapgml.h 8.2.0~beta1-1~exp1/mapgml.h
--- 8.0.1-5/mapgml.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgml.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,46 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Headers for mapgml.c.  shapeObj to GML output via MapServer
- *           queries.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-#ifndef MAPGML_H
-#define MAPGML_H
-
-#ifdef USE_LIBXML2
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-
-xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx, double maxy, const char *psEpsg);
-xmlNodePtr msGML3TimePeriod(xmlNsPtr psNs, char *pszStart, char *pszEnd);
-xmlNodePtr msGML3TimeInstant(xmlNsPtr psNs, char *timeInstant);
-xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id, double x, double y);
-
-#endif /* USE_LIBXML2 */
-
-#endif
diff -pruN 8.0.1-5/mapgraph.cpp 8.2.0~beta1-1~exp1/mapgraph.cpp
--- 8.0.1-5/mapgraph.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgraph.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,369 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Functions for basic undirected, weighted graph support.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapgraph.h"
-#include <algorithm> // for std::swap
-
-graphObj *msCreateGraph(signed int numnodes)
-{
-  graphObj *graph=nullptr;
-
-  if(numnodes <= 0) return nullptr;
-
-  graph = (graphObj *) malloc(sizeof(graphObj));
-  if(!graph) return nullptr;
-
-  graph->head = (graphNodeObj **) calloc(numnodes, sizeof(graphNodeObj*));
-  if(!graph->head) {
-    free(graph);
-    return nullptr;
-  }
-  graph->numnodes = numnodes;
-
-  return graph;
-}
-
-void msFreeGraph(graphObj *graph)
-{
-  if(!graph) return;
-
-  graphNodeObj *tmp=nullptr;
-  
-  for(int i=0; i<graph->numnodes; i++) {
-    while(graph->head[i] != nullptr) {
-      tmp = graph->head[i];
-      graph->head[i] = graph->head[i]->next;
-      free(tmp);
-    }
-  }
-
-  free(graph->head);
-  free(graph);
-}
-
-int msGraphAddEdge(graphObj *graph, int src, int dest, double weight)
-{
-  graphNodeObj *node=nullptr;
-
-  if(!graph) return MS_FAILURE;
-
-  // src -> dest
-  node = (graphNodeObj *) malloc(sizeof(graphNodeObj));
-  if(!node) return MS_FAILURE;
-
-  node->dest = dest;
-  node->weight = weight;
-  node->next = graph->head[src];
-  graph->head[src] = node;
-
-  // dest -> src
-  node = (graphNodeObj *) malloc(sizeof(graphNodeObj));
-  if(!node) return MS_FAILURE;
-
-  node->dest = src;
-  node->weight = weight;
-  node->next = graph->head[dest];
-  graph->head[dest] = node;
-
-  return MS_SUCCESS;
-}
-
-void msPrintGraph(graphObj *graph)
-{
-  int i;
-
-  if(!graph) return;
-
-  for(i=0; i<graph->numnodes; i++) {
-    graphNodeObj *node = graph->head[i];
-    if(node != nullptr) {
-      do {
-        msDebug("%d -> %d (%.6f)\t", i, node->dest, node->weight);
-        node = node->next;
-      } while (node != nullptr);
-      msDebug("\n");
-    }
-  }
-}
-
-/*
-** Derived from an number web resources including:
-**
-**   https://www.geeksforgeeks.org/dijkstras-algorithm-for-adjacency-list-representation-greedy-algo-8/
-**   https://youtube.com/watch?v=pSqmAO-m7Lk
-**   https://en.wikipedia.org/wiki/Dijkstra%27s_algorithm
-**
-** Much of the bulk here is for min-heap (key,value) management.
-*/
-
-typedef struct {
-  int idx;
-  double dist;
-} minHeapNodeObj;
-
-typedef struct {
-  int size;
-  int capacity;
-  int *pos;
-  minHeapNodeObj **nodes;
-} minHeapObj;
-
-static minHeapNodeObj *newMinHeapNode(int idx, double dist)
-{
-  minHeapNodeObj *node = (minHeapNodeObj *) malloc(sizeof(minHeapNodeObj));
-  if(!node) return nullptr;
-  node->idx = idx;
-  node->dist = dist;
-  return node;
-}
-
-static void freeMinHeap(minHeapObj *minHeap)
-{
-  if(!minHeap) return;
-
-  free(minHeap->pos);
-  for(int i=0; i<minHeap->size; i++) {
-    free(minHeap->nodes[i]);
-  }
-  free(minHeap->nodes);
-  free(minHeap);
-}
-
-static minHeapObj *createMinHeap(signed int capacity)
-{
-  minHeapObj *minHeap = (minHeapObj *) malloc(sizeof(minHeapObj));
-  if(!minHeap) return nullptr;
-
-  minHeap->pos = (int *) malloc(capacity * sizeof(int));
-  if(!minHeap->pos) {
-    free(minHeap);
-    return nullptr;
-  }
-  minHeap->size = 0;
-  minHeap->capacity = capacity;
-  minHeap->nodes = (minHeapNodeObj **) malloc(capacity * sizeof(minHeapNodeObj *));
-  if(!minHeap->nodes) {
-    free(minHeap->pos);
-    free(minHeap);
-    return nullptr;
-  }
-  return minHeap;
-}
-
-static void minHeapify(minHeapObj *minHeap, int idx)
-{
-  int smallest = idx;
-  const int left = 2*idx + 1;
-  const int right = 2*idx + 2;
- 
-  if (left < minHeap->size && minHeap->nodes[left]->dist < minHeap->nodes[smallest]->dist)
-    smallest = left;
- 
-  if (right < minHeap->size && minHeap->nodes[right]->dist < minHeap->nodes[smallest]->dist)
-    smallest = right;
- 
-  if (smallest != idx) {
-    minHeapNodeObj *smallestNode = minHeap->nodes[smallest];
-    minHeapNodeObj *idxNode = minHeap->nodes[idx];
- 
-    minHeap->pos[smallestNode->idx] = idx; // swap positions
-    minHeap->pos[idxNode->idx] = smallest;
- 
-    std::swap(minHeap->nodes[smallest], minHeap->nodes[idx]); // swap nodes
-    minHeapify(minHeap, smallest);
-  }
-}
-
-static bool isEmpty(const minHeapObj *minHeap)
-{
-  return minHeap->size == 0;
-}
-
-static minHeapNodeObj *extractMin(minHeapObj *minHeap)
-{
-  if (isEmpty(minHeap)) return nullptr;
- 
-  // store root node
-  minHeapNodeObj *root = minHeap->nodes[0];
- 
-  // replace root node with last node
-  minHeapNodeObj *lastNode = minHeap->nodes[minHeap->size - 1];
-  minHeap->nodes[0] = lastNode;
- 
-  // update position of last node
-  minHeap->pos[root->idx] = minHeap->size - 1;
-  minHeap->pos[lastNode->idx] = 0;
- 
-  // Reduce heap size and heapify root
-  --minHeap->size;
-  minHeapify(minHeap, 0);
- 
-  return root;
-}
-
-static void decreaseKey(minHeapObj *minHeap, int idx, int dist)
-{
-  // get the index of idx in min heap nodes
-  int i = minHeap->pos[idx];
- 
-  // get the node and update its dist value
-  minHeap->nodes[i]->dist = dist;
- 
-  // travel up while the complete tree is not hepified (this is a O(Logn) loop)
-  while (i && minHeap->nodes[i]->dist < minHeap->nodes[(i - 1) / 2]->dist) {
-    // swap this node with its parent
-    minHeap->pos[minHeap->nodes[i]->idx] = (i-1)/2;
-    minHeap->pos[minHeap->nodes[(i-1)/2]->idx] = i;
-    std::swap(minHeap->nodes[i], minHeap->nodes[(i - 1) / 2]);
- 
-    // move to parent index
-    i = (i - 1) / 2;
-  }
-}
-
-static bool isInMinHeap(const minHeapObj *minHeap, int idx)
-{
-  return minHeap->pos[idx] < minHeap->size;
-}
-
-typedef struct {
-  double *dist;
-  int *prev;
-} dijkstraOutputObj;
-
-static dijkstraOutputObj *dijkstra(graphObj *graph, int src)
-{
-  int n = graph->numnodes;
-
-  minHeapObj *minHeap = createMinHeap(n); // priority queue implemented as a min heap structure
-  if(!minHeap) return nullptr;
-
-  dijkstraOutputObj *output = nullptr;
-  output = (dijkstraOutputObj *) malloc(sizeof(dijkstraOutputObj));
-  output->dist = (double *) malloc(n * sizeof(double));
-  output->prev = (int *) malloc(n * sizeof(int));
-  if(!output->dist || !output->prev) {
-    msFree(output->dist);
-    msFree(output->prev);
-    free(output);
-    freeMinHeap(minHeap);
-    return nullptr;
-  }
-
-  // initialize
-  for (int i=0; i<n; i++) {
-    output->dist[i] = HUGE_VAL;
-    output->prev[i] = -1;
-    minHeap->nodes[i] = newMinHeapNode(i, output->dist[i]); // allocate a min heap node for each graph node
-    minHeap->pos[i] = i;
-  }
- 
-  // make dist value of src vertex as 0 so that it is extracted first
-  minHeap->pos[src] = src;
-  output->dist[src] = 0;
-  decreaseKey(minHeap, src, output->dist[src]);
- 
-  // initially size of min heap is equal to graph->numnodes (n)
-  minHeap->size = n;
- 
-  // In the following loop, minHeap contains all nodes
-  // whose shortest distance is not yet finalized.
-  while (!isEmpty(minHeap)) {
-
-    // extract the vertex with minimum distance value and store the node index
-    minHeapNodeObj *minHeapNode = extractMin(minHeap);
-    int u = minHeapNode->idx;
-    free(minHeapNode); // done with this node
-
-    // traverse through all adjacent nodes of u and update their distance values
-    graphNodeObj *node = graph->head[u];
-    while (node != nullptr) {
-      int v = node->dest;
- 
-      // if shortest distance to v is not finalized yet, and distance to v
-      // through u is less than its previously calculated distance
-      if (isInMinHeap(minHeap, v) && output->dist[u] != HUGE_VAL && node->weight + output->dist[u] < output->dist[v]) {
-        output->dist[v] = output->dist[u] + node->weight;
-        output->prev[v] = u;
-        decreaseKey(minHeap, v, output->dist[v]);
-      }
-      node = node->next;
-    }
-  }
- 
-  freeMinHeap(minHeap);
-
-  return output;
-}
-
-int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size, double *path_dist)
-{
-  if(!graph || src < 0 || src > graph->numnodes) return nullptr;
-
-  int* path = (int *) malloc((graph->numnodes)*sizeof(int)); // worst case is path traverses all nodes
-  if(!path) return nullptr;
-
-  dijkstraOutputObj *output = dijkstra(graph, src);
-  if(!output) {
-    free(path);
-    return nullptr; // algorithm failed for some reason
-  }
-
-  // get longest shortest distance from src to another node (our dest)
-  *path_dist = -1;
-  int dest = -1;
-  for(int i=0; i<graph->numnodes; i++) {
-    if(output->dist[i] != HUGE_VAL && *path_dist < output->dist[i]) {
-      *path_dist = output->dist[i];
-      dest = i;
-    }
-  }
-
-  if(dest == -1) { // unable to determine destination node
-    free(path);
-    free(output->dist);
-    free(output->prev);
-    free(output);
-    return nullptr;
-  }
-
-  // construct the path from src to dest
-  int j = 0;
-  for(int i=dest; i!=-1; i=output->prev[i],j++) path[j] = i;
-  std::reverse(path, path + j);
-  *path_size = j;
-
-  // clean up dijkstra output
-  free(output->dist);
-  free(output->prev);
-  free(output);
-
-  return path;
-}
diff -pruN 8.0.1-5/mapgraph.h 8.2.0~beta1-1~exp1/mapgraph.h
--- 8.0.1-5/mapgraph.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgraph.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,59 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Declarations for basic undirected, wighted graph support.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPGRAPH_H
-#define MAPGRAPH_H
-
-#ifdef  __cplusplus
-extern "C" {
-#endif
-
-typedef struct graphNodeObj {
-  int dest;
-  double weight;
-  struct graphNodeObj *next;
-} graphNodeObj;
-
-typedef struct {
-  int numnodes;
-  struct graphNodeObj **head;
-} graphObj;
-
-graphObj *msCreateGraph(int numnodes);
-void msFreeGraph(graphObj *graph);
-int msGraphAddEdge(graphObj *graph, int src, int dest, double weight);
-void msPrintGraph(graphObj *graph);
-
-int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size, double *path_dist);
-
-#ifdef  __cplusplus
-}
-#endif
-
-#endif /* MAPGRAPH_H */
diff -pruN 8.0.1-5/mapgraticule.c 8.2.0~beta1-1~exp1/mapgraticule.c
--- 8.0.1-5/mapgraticule.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapgraticule.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1316 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Graticule Renderer
- * Author:   John Novak, Novacell Technologies (jnovak@novacell.com)
- *
- **********************************************************************
- * Copyright (c) 2003, John Novak, Novacell Technologies
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-#include <assert.h>
-#include "mapproject.h"
-
-
-
-/**********************************************************************************************************************
- *
- */
-typedef enum {
-  posBottom = 1,
-  posTop,
-  posLeft,
-  posRight
-} msGraticulePosition;
-
-typedef enum {
-  lpDefault = 0,
-  lpDDMMSS = 1,
-  lpDDMM,
-  lpDD
-} msLabelProcessingType;
-
-void DefineAxis( int iTickCountTarget, double *Min, double *Max, double *Inc );
-static int _AdjustLabelPosition( layerObj *pLayer, shapeObj *pShape, msGraticulePosition ePosition );
-static void _FormatLabel( layerObj *pLayer, shapeObj *pShape, double dDataToFormat );
-
-int msGraticuleLayerInitItemInfo(layerObj *layer);
-
-#define MAPGRATICULE_ARC_SUBDIVISION_DEFAULT   (256)
-#define MAPGRATICULE_ARC_MINIMUM             (16)
-#define MAPGRATICULE_FORMAT_STRING_DEFAULT      "%5.2g"
-#define MAPGRATICULE_FORMAT_STRING_DDMMSS      "%3d %02d %02d"
-#define MAPGRATICULE_FORMAT_STRING_DDMM         "%3d %02d"
-#define MAPGRATICULE_FORMAT_STRING_DD                   "%3d"
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerOpen(layerObj *layer)
-{
-  graticuleObj *pInfo = layer->grid;
-
-  if( pInfo == NULL )
-    return MS_FAILURE;
-
-  pInfo->dincrementlatitude = 15.0;
-  pInfo->dincrementlongitude = 15.0;
-  pInfo->dwhichlatitude = -90.0;
-  pInfo->dwhichlongitude = -180.0;
-  pInfo->bvertical = 1;
-
-  if( layer->numclasses == 0 )
-    msDebug( "GRID layer has no classes, nothing will be rendered.\n" );
-
-  if( layer->numclasses > 0 && layer->class[0]->numlabels > 0 )
-    pInfo->blabelaxes = 1;
-  else
-    pInfo->blabelaxes = 0;
-
-  if( pInfo->labelformat == NULL ) {
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DEFAULT ) + 1 );
-    pInfo->ilabeltype = (int) lpDefault;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DEFAULT );
-  } else if( strcmp( pInfo->labelformat, "DDMMSS" ) == 0 ) {
-    msFree(pInfo->labelformat);
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DDMMSS ) + 1 );
-    pInfo->ilabeltype = (int) lpDDMMSS;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMMSS );
-  } else if( strcmp( pInfo->labelformat, "DDMM" )   == 0 ) {
-    msFree(pInfo->labelformat);
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DDMM ) + 1 );
-    pInfo->ilabeltype = (int) lpDDMM;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMM );
-  } else if( strcmp( pInfo->labelformat, "DD" )   == 0 ) {
-    msFree(pInfo->labelformat);
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DD ) + 1 );
-    pInfo->ilabeltype = (int) lpDD;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DD );
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- * Return MS_TRUE if layer is open, MS_FALSE otherwise.
- */
-int msGraticuleLayerIsOpen(layerObj *layer)
-{
-  if(layer->grid)
-    return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerClose(layerObj *layer)
-{
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)isQuery;
-  graticuleObj *pInfo = layer->grid;
-  int iAxisTickCount = 0;
-  rectObj rectMapCoordinates;
-
-  if(msCheckParentPointer(layer->map,"map") == MS_FAILURE)
-    return MS_FAILURE;
-
-  pInfo->dstartlatitude = rect.miny;
-  pInfo->dstartlongitude = rect.minx;
-  pInfo->dendlatitude = rect.maxy;
-  pInfo->dendlongitude = rect.maxx;
-  pInfo->bvertical = 1;
-  pInfo->extent   = rect;
-
-  if( pInfo->minincrement > 0.0 ) {
-    pInfo->dincrementlongitude = pInfo->minincrement;
-    pInfo->dincrementlatitude = pInfo->minincrement;
-  } else if( pInfo->maxincrement > 0.0 ) {
-    pInfo->dincrementlongitude = pInfo->maxincrement;
-    pInfo->dincrementlatitude = pInfo->maxincrement;
-  } else {
-    pInfo->dincrementlongitude = 0;
-    pInfo->dincrementlatitude = 0;
-  }
-
-  if( pInfo->maxarcs > 0 )
-    iAxisTickCount = (int) pInfo->maxarcs;
-  else if( pInfo->minarcs > 0 )
-    iAxisTickCount = (int) pInfo->minarcs;
-
-  DefineAxis( iAxisTickCount, &pInfo->dstartlongitude, &pInfo->dendlongitude, &pInfo->dincrementlongitude);
-  DefineAxis( iAxisTickCount, &pInfo->dstartlatitude, &pInfo->dendlatitude, &pInfo->dincrementlatitude);
-
-  pInfo->dwhichlatitude   = pInfo->dstartlatitude;
-  pInfo->dwhichlongitude = pInfo->dstartlongitude;
-
-  if( pInfo->minincrement > 0.0 && pInfo->maxincrement > 0.0 && pInfo->minincrement == pInfo->maxincrement ) {
-    pInfo->dincrementlongitude = pInfo->minincrement;
-    pInfo->dincrementlatitude = pInfo->minincrement;
-  } else if( pInfo->minincrement > 0.0 ) {
-    pInfo->dincrementlongitude = pInfo->minincrement;
-    pInfo->dincrementlatitude = pInfo->minincrement;
-  } else if( pInfo->maxincrement > 0.0 ) {
-    pInfo->dincrementlongitude = pInfo->maxincrement;
-    pInfo->dincrementlatitude = pInfo->maxincrement;
-  }
-
-  /*
-   * If using PROJ, project rect back into map system, and generate rect corner points in native system.
-   * These lines will be used when generating labels to get correct placement at arc/rect edge intersections.
-   */
-  rectMapCoordinates = layer->map->extent;
-
-  layer->project = msProjectionsDiffer(&(layer->projection), &(layer->map->projection));
-  if( layer->project &&
-      strstr(layer->map->projection.args[0], "epsg:3857") &&
-      msProjIsGeographicCRS(&(layer->projection)) )
-  {
-      if( rectMapCoordinates.minx < -20037508)
-          rectMapCoordinates.minx = -20037508;
-      if( rectMapCoordinates.maxx > 20037508 )
-          rectMapCoordinates.maxx = 20037508;
-  }
-
-  msFree(pInfo->pboundinglines);
-  pInfo->pboundinglines   = (lineObj *)  msSmallMalloc( sizeof( lineObj )  * 4 );
-  msFree(pInfo->pboundingpoints);
-  pInfo->pboundingpoints = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 8 );
-
-  {
-
-    /*
-     * top
-     */
-    pInfo->pboundinglines[0].numpoints   = 2;
-    pInfo->pboundinglines[0].point = &pInfo->pboundingpoints[0];
-    pInfo->pboundinglines[0].point[0].x = rectMapCoordinates.minx;
-    pInfo->pboundinglines[0].point[0].y = rectMapCoordinates.maxy;
-    pInfo->pboundinglines[0].point[1].x = rectMapCoordinates.maxx;
-    pInfo->pboundinglines[0].point[1].y = rectMapCoordinates.maxy;
-
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[0]);
-
-    /*
-     * bottom
-     */
-    pInfo->pboundinglines[1].numpoints = 2;
-    pInfo->pboundinglines[1].point = &pInfo->pboundingpoints[2];
-    pInfo->pboundinglines[1].point[0].x = rectMapCoordinates.minx;
-    pInfo->pboundinglines[1].point[0].y   = rectMapCoordinates.miny;
-    pInfo->pboundinglines[1].point[1].x   = rectMapCoordinates.maxx;
-    pInfo->pboundinglines[1].point[1].y = rectMapCoordinates.miny;
-
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[1]);
-
-    /*
-     * left
-     */
-    pInfo->pboundinglines[2].numpoints = 2;
-    pInfo->pboundinglines[2].point = &pInfo->pboundingpoints[4];
-    pInfo->pboundinglines[2].point[0].x   = rectMapCoordinates.minx;
-    pInfo->pboundinglines[2].point[0].y   = rectMapCoordinates.miny;
-    pInfo->pboundinglines[2].point[1].x   = rectMapCoordinates.minx;
-    pInfo->pboundinglines[2].point[1].y   = rectMapCoordinates.maxy;
-
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[2]);
-
-    /*
-     * right
-     */
-    pInfo->pboundinglines[3].numpoints = 2;
-    pInfo->pboundinglines[3].point = &pInfo->pboundingpoints[6];
-    pInfo->pboundinglines[3].point[0].x   = rectMapCoordinates.maxx;
-    pInfo->pboundinglines[3].point[0].y   = rectMapCoordinates.miny;
-    pInfo->pboundinglines[3].point[1].x = rectMapCoordinates.maxx;
-    pInfo->pboundinglines[3].point[1].y = rectMapCoordinates.maxy;
-
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[3]);
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  graticuleObj *pInfo = layer->grid;
-
-  if( pInfo->minsubdivides <= 0.0 || pInfo->maxsubdivides <= 0.0 )
-    pInfo->minsubdivides = pInfo->maxsubdivides = MAPGRATICULE_ARC_SUBDIVISION_DEFAULT;
-
-  shape->numlines = 1;
-  shape->type = MS_SHAPE_LINE;
-  shape->line = (lineObj *) msSmallMalloc(sizeof( lineObj ));
-  shape->line->numpoints = (int) pInfo->maxsubdivides;
-  shape->line->point = NULL;
-
-  /*
-   * Subdivide and draw current arc, rendering the arc labels first
-   */
-  if( pInfo->bvertical ) {
-    int iPointIndex;
-    double dArcDelta = (pInfo->dendlatitude - pInfo->dstartlatitude) / (double) shape->line->numpoints;
-    double dArcPosition  = pInfo->dstartlatitude + dArcDelta;
-    double dStartY, dDeltaX;
-
-    switch( pInfo->ilabelstate ) {
-      case 0:
-        if(!pInfo->blabelaxes)  { /* Bottom */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
-
-        dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[1].point[0].x) / (pInfo->pboundinglines[1].point[1].x - pInfo->pboundinglines[1].point[0].x);
-        if (dDeltaX < 0)
-          dDeltaX=dDeltaX*-1;
-
-        dStartY = (pInfo->pboundinglines[1].point[1].y - pInfo->pboundinglines[1].point[0].y) * dDeltaX + pInfo->pboundinglines[1].point[0].y;
-        shape->line->numpoints = (int) 2;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = pInfo->dwhichlongitude;
-        shape->line->point[0].y = dStartY;
-        shape->line->point[1].x = pInfo->dwhichlongitude;
-        shape->line->point[1].y = dStartY + dArcDelta;
-
-        _FormatLabel( layer, shape, shape->line->point[0].x );
-        if(_AdjustLabelPosition( layer, shape, posBottom ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
-
-        pInfo->ilabelstate++;
-        return MS_SUCCESS;
-
-      case 1:
-        if(!pInfo->blabelaxes) { /* Top */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
-
-        dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[0].point[0].x) / (pInfo->pboundinglines[0].point[1].x - pInfo->pboundinglines[0].point[0].x );
-        if (dDeltaX < 0)
-          dDeltaX=dDeltaX*-1;
-
-        dStartY = (pInfo->pboundinglines[0].point[1].y - pInfo->pboundinglines[0].point[0].y) * dDeltaX + pInfo->pboundinglines[0].point[1].y;
-        shape->line->numpoints = (int) 2;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = pInfo->dwhichlongitude;
-        shape->line->point[0].y = dStartY - dArcDelta;
-        shape->line->point[1].x = pInfo->dwhichlongitude;
-        shape->line->point[1].y = dStartY;
-
-        _FormatLabel( layer, shape, shape->line->point[0].x );
-        if(_AdjustLabelPosition( layer, shape, posTop ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
-
-        pInfo->ilabelstate++;
-        return MS_SUCCESS;
-
-      case 2:
-        shape->line->numpoints = (int) shape->line->numpoints + 1;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * shape->line->numpoints );
-
-        shape->line->point[0].x = pInfo->dwhichlongitude;
-        shape->line->point[0].y = pInfo->dstartlatitude;
-
-        for( iPointIndex = 1; iPointIndex < shape->line->numpoints; iPointIndex++ ) {
-          shape->line->point[iPointIndex].x   = pInfo->dwhichlongitude;
-          shape->line->point[iPointIndex].y   = dArcPosition;
-
-          dArcPosition += dArcDelta;
-        }
-
-        pInfo->ilabelstate = 0;
-
-        pInfo->dwhichlongitude      += pInfo->dincrementlongitude;
-        break;
-
-      default:
-        pInfo->ilabelstate    = 0;
-        break;
-    }
-
-  } else { /*horizontal*/
-    int iPointIndex;
-    double dArcDelta = (pInfo->dendlongitude - pInfo->dstartlongitude) / (double) shape->line->numpoints;
-    double dArcPosition   = pInfo->dstartlongitude + dArcDelta;
-    double dStartX, dDeltaY;
-
-    switch( pInfo->ilabelstate ) {
-      case 0:
-        if(!pInfo->blabelaxes) { /* Left side */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
-
-        dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[2].point[0].y) / (pInfo->pboundinglines[2].point[1].y - pInfo->pboundinglines[2].point[0].y );
-        if (dDeltaY < 0)
-          dDeltaY= dDeltaY*-1;
-
-        dStartX = (pInfo->pboundinglines[2].point[1].x - pInfo->pboundinglines[2].point[0].x) * dDeltaY + pInfo->pboundinglines[2].point[0].x;
-        shape->line->numpoints = (int) 2;
-        shape->line->point    = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = dStartX;
-        shape->line->point[0].y = pInfo->dwhichlatitude;
-        shape->line->point[1].x = dStartX + dArcDelta;
-        shape->line->point[1].y = pInfo->dwhichlatitude;
-
-        _FormatLabel( layer, shape, shape->line->point[0].y );
-        if(_AdjustLabelPosition( layer, shape, posLeft ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
-
-        pInfo->ilabelstate++;
-        return MS_SUCCESS;
-
-      case 1:
-        if(!pInfo->blabelaxes) { /* Right side */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
-
-        dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[3].point[0].y) / (pInfo->pboundinglines[3].point[1].y - pInfo->pboundinglines[3].point[0].y );
-        if (dDeltaY < 0)
-          dDeltaY= dDeltaY*-1;
-
-        dStartX = (pInfo->pboundinglines[3].point[1].x - pInfo->pboundinglines[3].point[0].x) * dDeltaY + pInfo->pboundinglines[3].point[0].x;
-        shape->line->numpoints = (int) 2;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = dStartX - dArcDelta;
-        shape->line->point[0].y = pInfo->dwhichlatitude;
-        shape->line->point[1].x = dStartX;
-        shape->line->point[1].y = pInfo->dwhichlatitude;
-
-        _FormatLabel( layer, shape, shape->line->point[0].y );
-        if(_AdjustLabelPosition( layer, shape, posRight ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
-
-        pInfo->ilabelstate++;
-        return MS_SUCCESS;
-
-      case 2:
-        shape->line->numpoints = (int) shape->line->numpoints + 1;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * shape->line->numpoints );
-
-        shape->line->point[0].x = pInfo->dstartlongitude;
-        shape->line->point[0].y = pInfo->dwhichlatitude;
-
-        for(iPointIndex = 1; iPointIndex < shape->line->numpoints; iPointIndex++) {
-          shape->line->point[iPointIndex].x   = dArcPosition;
-          shape->line->point[iPointIndex].y   = pInfo->dwhichlatitude;
-
-          dArcPosition += dArcDelta;
-        }
-
-        pInfo->ilabelstate    = 0;
-        pInfo->dwhichlatitude += pInfo->dincrementlatitude;
-        break;
-
-      default:
-        pInfo->ilabelstate    = 0;
-        break;
-    }
-  }
-
-  /*
-    * Increment and move to next arc
-    */
-
-  if( pInfo->bvertical && pInfo->dwhichlongitude > pInfo->dendlongitude )   {
-    pInfo->dwhichlatitude   = pInfo->dstartlatitude;
-    pInfo->bvertical   = 0;
-  }
-
-  if (pInfo->dwhichlatitude >  pInfo->dendlatitude) {
-    /* free the lineObj and pointObj that have been erroneously allocated beforehand */
-    msFreeShape(shape);
-    return MS_DONE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerGetItems(layerObj *layer)
-{
-  char **ppItemName   = (char **) msSmallMalloc( sizeof( char * ) );
-
-  *ppItemName = (char *) msSmallMalloc( 64 ); /* why is this necessary? */
-  strcpy( *ppItemName, "Graticule" );
-
-  layer->numitems   = 1;
-  layer->items   = ppItemName;
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerInitItemInfo(layerObj *layer)
-{
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- *
- */
-void msGraticuleLayerFreeItemInfo(layerObj *layer)
-{
-  (void)layer;
-}
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  (void)layer;
-  (void)shape;
-  (void)record;
-  return MS_FAILURE;
-}
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  graticuleObj *pInfo = layer->grid;
-
-  if(pInfo) {
-    *extent = pInfo->extent;
-    return MS_SUCCESS;
-  }
-
-  return MS_FAILURE;
-}
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape)
-{
-  (void)map;
-  (void)layer;
-  (void)c;
-  (void)shape;
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                  msGraticuleLayerFreeIntersectionPoints              */
-/*                                                                      */
-/*      Free intersection object.                                       */
-/************************************************************************/
-void msGraticuleLayerFreeIntersectionPoints( graticuleIntersectionObj *psValue)
-{
-  if (psValue) {
-    for (int i=0; i<psValue->nTop; i++)
-      msFree(psValue->papszTopLabels[i]);
-    msFree(psValue->papszTopLabels);
-    msFree(psValue->pasTop);
-
-    for (int i=0; i<psValue->nBottom; i++)
-      msFree(psValue->papszBottomLabels[i]);
-    msFree(psValue->papszBottomLabels);
-    msFree(psValue->pasBottom);
-
-
-    for (int i=0; i<psValue->nLeft; i++)
-      msFree(psValue->papszLeftLabels[i]);
-    msFree(psValue->papszLeftLabels);
-    msFree(psValue->pasLeft);
-
-    for (int i=0; i<psValue->nRight; i++)
-      msFree(psValue->papszRightLabels[i]);
-    msFree(psValue->papszRightLabels);
-    msFree(psValue->pasRight);
-
-    msFree(psValue);
-  }
-}
-
-
-/************************************************************************/
-/*                  msGraticuleLayerInitIntersectionPoints              */
-/*                                                                      */
-/*      init intersection object.                                       */
-/************************************************************************/
-static void msGraticuleLayerInitIntersectionPoints( graticuleIntersectionObj *psValue)
-{
-  if (psValue) {
-    psValue->nTop = 0;
-    psValue->pasTop = NULL;
-    psValue->papszTopLabels = NULL;
-    psValue->nBottom = 0;
-    psValue->pasBottom = NULL;
-    psValue->papszBottomLabels = NULL;
-    psValue->nLeft = 0;
-    psValue->pasLeft = NULL;
-    psValue->papszLeftLabels = NULL;
-    psValue->nRight = 0;
-    psValue->pasRight = NULL;
-    psValue->papszRightLabels = NULL;
-  }
-}
-
-
-/************************************************************************/
-/*                  msGraticuleLayerGetIntersectionPoints               */
-/*                                                                      */
-/*      Utility function thar returns all intersection positions and    */
-/*      labels (4 sides of the map) for a grid layer.                   */
-/************************************************************************/
-graticuleIntersectionObj *msGraticuleLayerGetIntersectionPoints(mapObj *map,
-    layerObj *layer)
-{
-
-  shapeObj    shapegrid, tmpshape;
-  rectObj     searchrect;
-  int         status;
-  pointObj oFirstPoint;
-  pointObj oLastPoint;
-  lineObj oLineObj;
-  rectObj cliprect;
-  graticuleObj   *pInfo  = NULL;
-  double dfTmp;
-  graticuleIntersectionObj *psValues = NULL;
-  int i=0;
-
-  if (layer->connectiontype != MS_GRATICULE)
-    return NULL;
-
-  pInfo  = layer->grid;
-
-  /*set cellsize if bnot already set*/
-  if (map->cellsize == 0)
-    map->cellsize = msAdjustExtent(&(map->extent),map->width,map->height);
-
-  psValues = (graticuleIntersectionObj *)msSmallMalloc(sizeof(graticuleIntersectionObj));
-
-  msGraticuleLayerInitIntersectionPoints(psValues);
-
-  if(layer->transform == MS_TRUE)
-    searchrect = map->extent;
-  else {
-    searchrect.minx = searchrect.miny = 0;
-    searchrect.maxx = map->width-1;
-    searchrect.maxy = map->height-1;
-  }
-
-  if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-    msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-
- status =  msLayerOpen(layer);
- if(status != MS_SUCCESS)
-   return NULL;
-
-  status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-  if(status == MS_DONE) { /* no overlap */
-    msLayerClose(layer);
-    return NULL;
-  } else if(status != MS_SUCCESS) {
-    msLayerClose(layer);
-    return NULL;
-  }
-
-  /* step through the target shapes */
-  msInitShape(&shapegrid);
-  cliprect.minx = map->extent.minx- map->cellsize;
-  cliprect.miny = map->extent.miny- map->cellsize;
-  cliprect.maxx = map->extent.maxx + map->cellsize;
-  cliprect.maxy = map->extent.maxy + map->cellsize;
-
-  /* clip using the layer projection */
-  /* msProjectRect(&map->projection , &layer->projection,  &cliprect); */
-
-  while((status = msLayerNextShape(layer, &shapegrid)) == MS_SUCCESS) {
-    /*don't really need a class here*/
-    /*
-      shapegrid.classindex = msShapeGetClass(layer, &shapegrid, map->scaledenom, NULL, 0);
-      if((shapegrid.classindex == -1) || (layer->class[shapegrid.classindex]->status == MS_OFF)) {
-    msFreeShape(&shapegrid);
-    continue;
-    }
-    */
-
-    msInitShape(&tmpshape);
-    msCopyShape(&shapegrid, &tmpshape);
-    /* status = msDrawShape(map, layer, &tmpshape, image, -1); */
-
-    if(layer->project) {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-        layer->reprojectorLayerToMap = msProjectCreateReprojector(
-            &layer->projection, &map->projection);
-      }
-      if( layer->reprojectorLayerToMap )
-        msProjectShapeEx(layer->reprojectorLayerToMap, &shapegrid);
-    }
-
-    msClipPolylineRect(&shapegrid, cliprect);
-
-
-    msTransformShapeToPixelRound(&shapegrid, map->extent, map->cellsize);
-
-
-
-    if(shapegrid.numlines <= 0 || shapegrid.line[0].numpoints < 2) { /* once clipped the shape didn't need to be drawn */
-      msFreeShape(&shapegrid);
-      msFreeShape(&tmpshape);
-      continue;
-    }
-
-
-
-    {
-      int iTmpLine = 0;
-      int nNumPoints = 0;
-      /*grid code seems to retunr lines that can double cross the extenst??*/
-      /*creating a more than one clipped shape. Take the shape that has the most
-        points, which should be the most likley to be correct*/
-
-      if (shapegrid.numlines > 1) {
-        for (i=0; i<shapegrid.numlines; i++) {
-          if (shapegrid.line[i].numpoints > nNumPoints) {
-            nNumPoints = shapegrid.line[i].numpoints;
-            iTmpLine = i;
-          }
-        }
-      }
-      /* get the first and last point*/
-      oFirstPoint.x = shapegrid.line[iTmpLine].point[0].x;
-      oFirstPoint.y = shapegrid.line[iTmpLine].point[0].y;
-      oLineObj = shapegrid.line[iTmpLine];
-      oLastPoint.x = oLineObj.point[oLineObj.numpoints-1].x;
-      oLastPoint.y = oLineObj.point[oLineObj.numpoints-1].y;
-
-      if ( pInfo->bvertical) { /*vertical*/
-        /*SHAPES ARE DRAWN FROM BOTTOM TO TOP.*/
-        /*Normally lines are drawn FROM BOTTOM TO TOP but not always for some reason, so
-          make sure that firstpoint < lastpoint in y, We are in pixel coordinates so y increases as we
-        we go down*/
-        if (oFirstPoint.y < oLastPoint.y) {
-          dfTmp = oFirstPoint.x;
-          oFirstPoint.x = oLastPoint.x;
-          oLastPoint.x = dfTmp;
-          dfTmp = oFirstPoint.y;
-          oFirstPoint.y = oLastPoint.y;
-          oLastPoint.y = dfTmp;
-
-        }
-
-        /*first point should cross the BOTTOM base where y== map->height*/
-
-        if (abs ((int)oFirstPoint.y - map->height)  <=1) {
-          char *pszLabel=NULL;
-          oFirstPoint.y = map->height;
-
-          /*validate point is in map width/height*/
-          if (oFirstPoint.x < 0 || oFirstPoint.x > map->width)
-            continue;
-
-          /*validate point is in map width/height*/
-          if (oLastPoint.x < 0 || oLastPoint.x > map->width)
-            continue;
-
-          if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
-          else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].x );
-            if (tmpshape.text)
-              pszLabel = msStrdup(tmpshape.text);
-            else
-              pszLabel = msStrdup("unknown");
-          }
-          /*validate that the  value is not already in the array*/
-          if ( psValues->nBottom > 0) {
-            /* if (psValues->pasBottom[psValues->nBottom-1].x == oFirstPoint.x)
-                 continue; */
-
-            for (i=0; i<psValues->nBottom; i++) {
-              if (psValues->pasBottom[i].x == oFirstPoint.x)
-                break;
-            }
-            if (i  < psValues->nBottom) {
-              msFree(pszLabel);
-              continue;
-            }
-          }
-          if (psValues->pasBottom == NULL) {
-            psValues->pasBottom = (pointObj *)msSmallMalloc(sizeof(pointObj));
-            psValues->papszBottomLabels = (char **)msSmallMalloc(sizeof(char *));
-            psValues->nBottom = 1;
-          } else {
-            psValues->nBottom++;
-            psValues->pasBottom = (pointObj *)msSmallRealloc(psValues->pasBottom, sizeof(pointObj)*psValues->nBottom);
-            psValues->papszBottomLabels = (char **)msSmallRealloc(psValues->papszBottomLabels, sizeof(char *)*psValues->nBottom);
-          }
-
-          psValues->pasBottom[psValues->nBottom-1].x = oFirstPoint.x;
-          psValues->pasBottom[psValues->nBottom-1].y = oFirstPoint.y;
-          psValues->papszBottomLabels[psValues->nBottom-1] = pszLabel;
-
-        }
-        /*first point should cross the TOP base where y==0*/
-        if (abs((int)oLastPoint.y) <=1) {
-          char *pszLabel=NULL;
-          oLastPoint.y = 0;
-
-          /*validate point is in map width/height*/
-          if (oLastPoint.x < 0 || oLastPoint.x > map->width)
-            continue;
-
-          if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
-          else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].x );
-            if (tmpshape.text)
-              pszLabel = msStrdup(tmpshape.text);
-            else
-              pszLabel = msStrdup("unknown");
-          }
-          /*validate if same value is not already there*/
-          if ( psValues->nTop > 0) {
-            /* if (psValues->pasTop[psValues->nTop-1].x == oLastPoint.x)
-                 continue; */
-
-            for (i=0; i<psValues->nTop; i++) {
-              if (psValues->pasTop[i].x == oLastPoint.x ||
-                  strcasecmp(pszLabel, psValues->papszTopLabels[i]) == 0)
-                break;
-            }
-            if (i < psValues->nTop) {
-              msFree(pszLabel);
-              continue;
-            }
-          }
-
-
-          if (psValues->pasTop == NULL) {
-            psValues->pasTop = (pointObj *)msSmallMalloc(sizeof(pointObj));
-            psValues->papszTopLabels = (char **)msSmallMalloc(sizeof(char *));
-            psValues->nTop = 1;
-          } else {
-            psValues->nTop++;
-            psValues->pasTop = (pointObj *)msSmallRealloc(psValues->pasTop, sizeof(pointObj)*psValues->nTop);
-            psValues->papszTopLabels = (char **)msSmallRealloc(psValues->papszTopLabels, sizeof(char *)*psValues->nTop);
-          }
-
-          psValues->pasTop[psValues->nTop-1].x = oLastPoint.x;
-          psValues->pasTop[psValues->nTop-1].y = oLastPoint.y;
-          psValues->papszTopLabels[psValues->nTop-1] = pszLabel;
-        }
-      } else { /*horzontal*/
-        /*Normally lines are drawn from left to right but not always for some reason, so
-          make sure that firstpoint < lastpoint in x*/
-        if (oFirstPoint.x > oLastPoint.x) {
-
-          dfTmp = oFirstPoint.x;
-          oFirstPoint.x = oLastPoint.x;
-          oLastPoint.x = dfTmp;
-          dfTmp = oFirstPoint.y;
-          oFirstPoint.y = oLastPoint.y;
-          oLastPoint.y = dfTmp;
-
-        }
-        /*first point should cross the LEFT base where x=0 axis*/
-        if (abs((int)oFirstPoint.x) <=1) {
-          char *pszLabel=NULL;
-          oFirstPoint.x = 0;
-
-          /*validate point is in map width/height*/
-          if (oFirstPoint.y < 0 || oFirstPoint.y > map->height)
-            continue;
-
-          if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
-          else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].y );
-            if (tmpshape.text)
-              pszLabel = msStrdup(tmpshape.text);
-            else
-              pszLabel = msStrdup("unknown");
-          }
-
-          /*validate that the previous value is not the same*/
-          if ( psValues->nLeft > 0) {
-            /* if (psValues->pasLeft[psValues->nLeft-1].y == oFirstPoint.y)
-                 continue; */
-
-            for (i=0; i<psValues->nLeft; i++) {
-              if (psValues->pasLeft[i].y == oFirstPoint.y)
-                break;
-            }
-            if (i < psValues->nLeft) {
-              msFree(pszLabel);
-              continue;
-            }
-          }
-          if (psValues->pasLeft == NULL) {
-            psValues->pasLeft = (pointObj *)msSmallMalloc(sizeof(pointObj));
-            psValues->papszLeftLabels = (char **)msSmallMalloc(sizeof(char *));
-            psValues->nLeft = 1;
-          } else {
-            psValues->nLeft++;
-            psValues->pasLeft = (pointObj *)msSmallRealloc(psValues->pasLeft, sizeof(pointObj)*psValues->nLeft);
-            psValues->papszLeftLabels = (char **)msSmallRealloc(psValues->papszLeftLabels, sizeof(char *)*psValues->nLeft);
-          }
-
-          psValues->pasLeft[psValues->nLeft-1].x = oFirstPoint.x;
-          psValues->pasLeft[psValues->nLeft-1].y = oFirstPoint.y;
-          psValues->papszLeftLabels[psValues->nLeft-1] = pszLabel; /* takes ownership of allocated pszLabel */
-        }
-        /*first point should cross the RIGHT base where x=map=>width axis*/
-        if (abs((int)oLastPoint.x - map->width) <=1) {
-          char *pszLabel=NULL;
-          oLastPoint.x =  map->width;
-
-          /*validate point is in map width/height*/
-          if (oLastPoint.y < 0 || oLastPoint.y > map->height)
-            continue;
-
-          if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
-          else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].y );
-            if (tmpshape.text)
-              pszLabel = msStrdup(tmpshape.text);
-            else
-              pszLabel = msStrdup("unknown");
-          }
-
-          /*validate that the previous value is not the same*/
-          if ( psValues->nRight > 0) {
-            /* if (psValues->pasRight[psValues->nRight-1].y == oLastPoint.y)
-                 continue; */
-            for (i=0; i<psValues->nRight; i++) {
-              if (psValues->pasRight[i].y == oLastPoint.y)
-                break;
-            }
-            if (i < psValues->nRight) {
-              msFree(pszLabel);
-              continue;
-            }
-          }
-          if (psValues->pasRight == NULL) {
-            psValues->pasRight = (pointObj *)msSmallMalloc(sizeof(pointObj));
-            psValues->papszRightLabels = (char **)msSmallMalloc(sizeof(char *));
-            psValues->nRight = 1;
-          } else {
-            psValues->nRight++;
-            psValues->pasRight = (pointObj *)msSmallRealloc(psValues->pasRight, sizeof(pointObj)*psValues->nRight);
-            psValues->papszRightLabels = (char **)msSmallRealloc(psValues->papszRightLabels, sizeof(char *)*psValues->nRight);
-          }
-
-          psValues->pasRight[psValues->nRight-1].x = oLastPoint.x;
-          psValues->pasRight[psValues->nRight-1].y = oLastPoint.y;
-          psValues->papszRightLabels[psValues->nRight-1] = pszLabel;
-        }
-      }
-      msFreeShape(&shapegrid);
-      msFreeShape(&tmpshape);
-    }
-    msInitShape(&shapegrid);
-
-
-
-  }
-  msLayerClose(layer);
-  return psValues;
-
-}
-
-
-/**********************************************************************************************************************
- *
- */
-int msGraticuleLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerInitItemInfo = msGraticuleLayerInitItemInfo; /* should use defaults for item info functions */
-  layer->vtable->LayerFreeItemInfo = msGraticuleLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msGraticuleLayerOpen;
-  layer->vtable->LayerIsOpen = msGraticuleLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msGraticuleLayerWhichShapes;
-  layer->vtable->LayerNextShape = msGraticuleLayerNextShape;
-  /* layer->vtable->LayerResultsGetShape, use default */
-  layer->vtable->LayerGetShape = msGraticuleLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msGraticuleLayerClose;
-  layer->vtable->LayerGetItems = msGraticuleLayerGetItems;
-  layer->vtable->LayerGetExtent = msGraticuleLayerGetExtent;
-  layer->vtable->LayerGetAutoStyle = msGraticuleLayerGetAutoStyle;
-  /* layer->vtable->LayerCloseConnection, use default */;
-  layer->vtable->LayerSetTimeFilter = msLayerMakePlainTimeFilter;
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- *
- */
-static void _FormatLabel( layerObj *pLayer, shapeObj *pShape, double dDataToFormat )
-{
-  graticuleObj *pInfo = pLayer->grid;
-  char cBuffer[32];
-  int iDegrees, iMinutes;
-
-  switch( pInfo->ilabeltype ) {
-    case lpDDMMSS:
-      iDegrees = (int) dDataToFormat;
-      dDataToFormat = fabs( dDataToFormat - (double) iDegrees );
-      iMinutes = (int) (dDataToFormat * 60.0);
-      dDataToFormat = dDataToFormat - (((double) iMinutes) / 60.0);
-      sprintf( cBuffer, pInfo->labelformat, iDegrees, iMinutes, (int) (dDataToFormat * 3600.0) );
-      break;
-    case lpDDMM:
-      iDegrees = (int) dDataToFormat;
-      dDataToFormat = fabs( dDataToFormat - (double) iDegrees );
-      sprintf( cBuffer, pInfo->labelformat, iDegrees, (int) (dDataToFormat * 60.0) );
-      break;
-    case lpDD:
-      iDegrees = (int) dDataToFormat;
-      sprintf( cBuffer, pInfo->labelformat, iDegrees);
-      break;
-    case lpDefault:
-    default:
-      sprintf( cBuffer, pInfo->labelformat, dDataToFormat );
-  }
-
-  pShape->text = msStrdup( cBuffer );
-}
-
-/**********************************************************************************************************************
- *
- *  Move label position into display area by adjusting underlying shape line.
- */
-static int _AdjustLabelPosition( layerObj *pLayer, shapeObj *pShape, msGraticulePosition ePosition )
-{
-  graticuleObj *pInfo = pLayer->grid;
-  rectObj rectLabel;
-  pointObj ptPoint;
-  double size = -1;
-  char *labeltxt;
-
-  if( pInfo == NULL || pShape == NULL ) {
-    msSetError(MS_MISCERR, "Assertion failed: Null shape or non-configured grid!, ", "_AdjustLabelPosition()");
-    return MS_FAILURE;
-  }
-
-  assert(pLayer->class[0]->numlabels >= 1);
-
-  if(msCheckParentPointer(pLayer->map,"map")==MS_FAILURE)
-    return MS_FAILURE;
-
-  ptPoint = pShape->line->point[0];
-
-  if(pLayer->project)
-  {
-    if( pLayer->reprojectorLayerToMap == NULL )
-    {
-        pLayer->reprojectorLayerToMap = msProjectCreateReprojector(
-            &pLayer->projection, &pLayer->map->projection);
-    }
-    if( pLayer->reprojectorLayerToMap )
-        msProjectShapeEx(pLayer->reprojectorLayerToMap, pShape );
-
-    /* Poor man detection of reprojection failure */
-    if( msProjIsGeographicCRS(&(pLayer->projection)) != 
-        msProjIsGeographicCRS(&(pLayer->map->projection)) )
-    {
-        if( ptPoint.x == pShape->line->point[0].x &&
-            ptPoint.y == pShape->line->point[0].y )
-        {
-            return MS_FAILURE;
-        }
-    }
-  }
-
-  if(pLayer->transform) {
-    msTransformShapeToPixelRound(pShape, pLayer->map->extent, pLayer->map->cellsize);
-  }
-  
-  size = pLayer->class[0]->labels[0]->size; /* TODO someday: adjust minsize/maxsize/resolution*/
-  /* We only use the first label as there's no use (yet) in defining multiple lables for GRID layers,
-   as the only label to represent is the longitude or latitude */
-  labeltxt = msShapeGetLabelAnnotation(pLayer, pShape, pLayer->class[0]->labels[0]);
-  assert(labeltxt);
-  if(msGetStringSize(pLayer->map, pLayer->class[0]->labels[0], size, labeltxt, &rectLabel) != MS_SUCCESS) {
-    free(labeltxt);
-    return MS_FAILURE;  /* msSetError already called */
-  }
-  free(labeltxt);
-
-  switch( ePosition ) {
-    case posBottom:
-      pShape->line->point[1].y = pLayer->map->height;
-      pShape->line->point[0].y = pLayer->map->height - (fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5);
-      break;
-    case posTop:
-      pShape->line->point[1].y = 0;
-      pShape->line->point[0].y = fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5;
-      break;
-    case posLeft:
-      pShape->line->point[0].x = 0;
-      pShape->line->point[1].x = fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5;
-      break;
-    case posRight:
-      pShape->line->point[1].x = pLayer->map->width;
-      pShape->line->point[0].x = pLayer->map->width - (fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5);
-      break;
-  }
-
-  if(pLayer->transform)
-    msTransformPixelToShape( pShape, pLayer->map->extent, pLayer->map->cellsize );
-
-  if(pLayer->project)
-  {
-    /* Clamp coordinates into the validity area of the projection, in the */
-    /* particular case of EPSG:3857 (WebMercator) to longlat reprojection */
-    if( strstr(pLayer->map->projection.args[0], "epsg:3857") &&
-        msProjIsGeographicCRS(&(pLayer->projection)) )
-    {
-        if( !pLayer->map->projection.gt.need_geotransform &&
-            ePosition == posLeft && pShape->line->point[0].x < -20037508)
-        {
-          pShape->line->point[1].x = -20037508 + (pShape->line->point[1].x -
-                                                  pShape->line->point[0].x);
-          pShape->line->point[0].x = -20037508;
-        }
-        else if( pLayer->map->projection.gt.need_geotransform &&
-                 ePosition == posLeft &&
-                 pLayer->map->projection.gt.geotransform[0] +
-                    pShape->line->point[0].x *
-                        pLayer->map->projection.gt.geotransform[1] +
-                    pShape->line->point[0].y *
-                        pLayer->map->projection.gt.geotransform[2] < -20037508)
-        {
-          double y_tmp;
-          double width = pShape->line->point[1].x - pShape->line->point[0].x;
-
-          y_tmp = pLayer->map->projection.gt.geotransform[3] +
-            pShape->line->point[0].x *
-                    pLayer->map->projection.gt.geotransform[4] +
-            pShape->line->point[0].y *
-                    pLayer->map->projection.gt.geotransform[5];
-          pShape->line->point[0].x =
-            pLayer->map->projection.gt.invgeotransform[0] +
-                    -20037508 * pLayer->map->projection.gt.invgeotransform[1] +
-                    y_tmp * pLayer->map->projection.gt.invgeotransform[2];
-          pShape->line->point[1].x = pShape->line->point[0].x + width;
-        }
-
-        if( !pLayer->map->projection.gt.need_geotransform &&
-            ePosition == posRight && pShape->line->point[1].x > 20037508)
-        {
-          pShape->line->point[0].x = 20037508 - (pShape->line->point[1].x -
-                                                 pShape->line->point[0].x);
-          pShape->line->point[1].x = 20037508;
-        }
-        else if( pLayer->map->projection.gt.need_geotransform &&
-                 ePosition == posRight &&
-                 pLayer->map->projection.gt.geotransform[0] +
-                    pShape->line->point[1].x *
-                        pLayer->map->projection.gt.geotransform[1] +
-                    pShape->line->point[1].y *
-                        pLayer->map->projection.gt.geotransform[2] > 20037508)
-        {
-          double y_tmp;
-          double width = pShape->line->point[1].x - pShape->line->point[0].x;
-
-          y_tmp = pLayer->map->projection.gt.geotransform[3] +
-            pShape->line->point[1].x *
-                    pLayer->map->projection.gt.geotransform[4] +
-            pShape->line->point[1].y *
-                    pLayer->map->projection.gt.geotransform[5];
-          pShape->line->point[1].x =
-            pLayer->map->projection.gt.invgeotransform[0] +
-                    20037508 * pLayer->map->projection.gt.invgeotransform[1] +
-                    y_tmp * pLayer->map->projection.gt.invgeotransform[2];
-          pShape->line->point[0].x = pShape->line->point[1].x - width;
-        }
-    }
-
-    if( pLayer->reprojectorMapToLayer == NULL )
-    {
-        pLayer->reprojectorMapToLayer = msProjectCreateReprojector(
-            &pLayer->map->projection, &pLayer->projection);
-    }
-    if( pLayer->reprojectorMapToLayer )
-        msProjectShapeEx(pLayer->reprojectorMapToLayer, pShape );
-  }
-
-  switch( ePosition ) {
-    case posBottom:
-    case posTop:
-      pShape->line->point[1].x = ptPoint.x;
-      pShape->line->point[0].x = ptPoint.x;
-      break;
-    case posLeft:
-    case posRight:
-      pShape->line->point[1].y = ptPoint.y;
-      pShape->line->point[0].y = ptPoint.y;
-      break;
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************************************************************
- **********************************************************************************************************************
- * DefineAxes - Copyright (c) 2000, Michael P.D. Bramley.
- *
- * Permission is granted to use this code without restriction as long as
- * this copyright notice appears in all source files.
- *
- * Minor tweaks to incrment calculations - jnovak
- */
-void DefineAxis( int iTickCountTarget, double *Min, double *Max, double *Inc )
-{
-  /* define local variables... */
-
-  double Test_inc,    /* candidate increment value */
-         Test_min,    /* minimum scale value */
-         Test_max,    /* maximum scale value */
-         Range = *Max - *Min ;  /* range of data */
-
-  int i = 0 ;   /* counter */
-
-  /* don't create problems -- solve them */
-
-  if( Range < 0 )  {
-    *Inc = 0 ;
-    return ;
-  }
-
-  /* handle special case of repeated values */
-
-  else if( Range == 0)  {
-    *Min = ceil(*Max) - 1 ;
-    *Max = *Min + 1 ;
-    *Inc = 1 ;
-    return ;
-  }
-
-  /* compute candidate for increment */
-
-  Test_inc = pow( 10.0, ceil( log10( Range/10 ) ) ) ;
-  if(*Inc > 0 && ( Test_inc < *Inc || Test_inc > *Inc ))
-    Test_inc = *Inc;
-
-  /* establish maximum scale value... */
-  Test_max = ( (long)(*Max / Test_inc)) * Test_inc ;
-
-  if( Test_max < *Max )
-    Test_max += Test_inc ;
-
-  /* establish minimum scale value... */
-  Test_min = Test_max ;
-  do {
-    ++i ;
-    Test_min -= Test_inc ;
-  } while( Test_min > *Min ) ;
-
-  /* subtracting small values can screw up the scale limits, */
-  /* eg: if DefineAxis is called with (min,max)=(0.01, 0.1), */
-  /* then the calculated scale is 1.0408E17 TO 0.05 BY 0.01. */
-  /* the following if statment corrects for this... */
-
-  /* if(fabs(Test_min) < 1E-10) */
-  /* Test_min = 0 ; */
-
-  /* adjust for too few tick marks */
-
-  if(iTickCountTarget <= 0)
-    iTickCountTarget   = MAPGRATICULE_ARC_MINIMUM;
-
-  while(i < iTickCountTarget) {
-    Test_inc /= 2 ;
-    i *= 2 ;
-  }
-
-  if(i < 6 && 0) {
-    Test_inc /= 2 ;
-    if((Test_min + Test_inc) <= *Min)
-      Test_min += Test_inc ;
-    if((Test_max - Test_inc) >= *Max)
-      Test_max -= Test_inc ;
-  }
-
-  /* pass back axis definition to caller */
-
-  *Min = Test_min;
-  *Max = Test_max;
-  *Inc = Test_inc;
-}
-
-/**********************************************************************************************************************
- **********************************************************************************************************************/
diff -pruN 8.0.1-5/maphash.c 8.2.0~beta1-1~exp1/maphash.c
--- 8.0.1-5/maphash.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maphash.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,256 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implement hashTableObj class.
- * Author:   Sean Gillies, sgillies@frii.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <ctype.h>
-
-#include "mapserver.h"
-#include "maphash.h"
-
-
-
-static unsigned hash(const char *key)
-{
-  unsigned hashval;
-
-  for(hashval=0; *key!='\0'; key++)
-    hashval = tolower(*key) + 31 * hashval;
-
-  return(hashval % MS_HASHSIZE);
-}
-
-hashTableObj *msCreateHashTable()
-{
-  int i;
-  hashTableObj *table;
-
-  table = (hashTableObj *) msSmallMalloc(sizeof(hashTableObj));
-  table->items = (struct hashObj **) msSmallMalloc(sizeof(struct hashObj *)*MS_HASHSIZE);
-
-  for (i=0; i<MS_HASHSIZE; i++)
-    table->items[i] = NULL;
-  table->numitems = 0;
-
-  return table;
-}
-
-int initHashTable( hashTableObj *table )
-{
-  int i;
-
-  table->items = (struct hashObj **) malloc(sizeof(struct hashObj *)*MS_HASHSIZE);
-  MS_CHECK_ALLOC(table->items, sizeof(struct hashObj *)*MS_HASHSIZE, MS_FAILURE);
-
-  for (i=0; i<MS_HASHSIZE; i++)
-    table->items[i] = NULL;
-  table->numitems = 0;
-  return MS_SUCCESS;
-}
-
-void msFreeHashTable( hashTableObj *table )
-{
-  if( table != NULL ) {
-    msFreeHashItems(table);
-    free(table);
-  }
-}
-
-int msHashIsEmpty( const hashTableObj *table )
-{
-  if (table->numitems == 0 )
-    return MS_TRUE;
-  else
-    return MS_FALSE;
-}
-
-
-void msFreeHashItems( hashTableObj *table )
-{
-  int i;
-  struct hashObj *tp=NULL;
-  struct hashObj *prev_tp=NULL;
-
-  if (table) {
-    if(table->items) {
-      for (i=0; i<MS_HASHSIZE; i++) {
-        if (table->items[i] != NULL) {
-          for (tp=table->items[i]; tp!=NULL; prev_tp=tp,tp=tp->next,free(prev_tp)) {
-            msFree(tp->key);
-            msFree(tp->data);
-          }
-        }
-      }
-      free(table->items);
-      table->items = NULL;
-    } else {
-      msSetError(MS_HASHERR, "No items allocated.", "msFreeHashItems()");
-    }
-  } else {
-    msSetError(MS_HASHERR, "Can't free NULL table", "msFreeHashItems()");
-  }
-}
-
-struct hashObj *msInsertHashTable(hashTableObj *table,
-                                  const char *key, const char *value) {
-  struct hashObj *tp;
-  unsigned hashval;
-
-  if (!table || !key || !value) {
-    msSetError(MS_HASHERR, "Invalid hash table or key",
-               "msInsertHashTable");
-    return NULL;
-  }
-
-  for (tp=table->items[hash(key)]; tp!=NULL; tp=tp->next)
-    if(strcasecmp(key, tp->key) == 0)
-      break;
-
-  if (tp == NULL) { /* not found */
-    tp = (struct hashObj *) malloc(sizeof(*tp));
-    MS_CHECK_ALLOC(tp, sizeof(*tp), NULL);
-    tp->key = msStrdup(key);
-    hashval = hash(key);
-    tp->next = table->items[hashval];
-    table->items[hashval] = tp;
-    table->numitems++;
-  } else {
-    free(tp->data);
-  }
-
-  if ((tp->data = msStrdup(value)) == NULL)
-    return NULL;
-
-  return tp;
-}
-
-const char *msLookupHashTable(const hashTableObj *table, const char *key)
-{
-  struct hashObj *tp;
-
-  if (!table || !key) {
-    return(NULL);
-  }
-
-  for (tp=table->items[hash(key)]; tp!=NULL; tp=tp->next)
-    if (strcasecmp(key, tp->key) == 0)
-      return(tp->data);
-
-  return NULL;
-}
-
-int msRemoveHashTable(hashTableObj *table, const char *key)
-{
-  struct hashObj *tp;
-  struct hashObj *prev_tp=NULL;
-  int status = MS_FAILURE;
-
-  if (!table || !key) {
-    msSetError(MS_HASHERR, "No hash table", "msRemoveHashTable");
-    return MS_FAILURE;
-  }
-
-  tp=table->items[hash(key)];
-  if (!tp) {
-    msSetError(MS_HASHERR, "No such hash entry", "msRemoveHashTable");
-    return MS_FAILURE;
-  }
-
-  prev_tp = NULL;
-  while (tp != NULL) {
-    if (strcasecmp(key, tp->key) == 0) {
-      status = MS_SUCCESS;
-      if (prev_tp) {
-        prev_tp->next = tp->next;
-        msFree(tp->key);
-        msFree(tp->data);
-        free(tp);
-        break;
-      } else {
-        table->items[hash(key)] = tp->next;
-        msFree(tp->key);
-        msFree(tp->data);
-        free(tp);
-        break;
-      }
-    }
-    prev_tp = tp;
-    tp = tp->next;
-  }
-
-  if (status == MS_SUCCESS)
-    table->numitems--;
-
-  return status;
-}
-
-const char *msFirstKeyFromHashTable( const hashTableObj *table )
-{
-  int hash_index;
-
-  if (!table) {
-    msSetError(MS_HASHERR, "No hash table", "msFirstKeyFromHashTable");
-    return NULL;
-  }
-
-  for (hash_index = 0; hash_index < MS_HASHSIZE; hash_index++ ) {
-    if (table->items[hash_index] != NULL )
-      return table->items[hash_index]->key;
-  }
-
-  return NULL;
-}
-
-const char *msNextKeyFromHashTable( const hashTableObj *table, const char *lastKey )
-{
-  int hash_index;
-  struct hashObj *link;
-
-  if (!table) {
-    msSetError(MS_HASHERR, "No hash table", "msNextKeyFromHashTable");
-    return NULL;
-  }
-
-  if ( lastKey == NULL )
-    return msFirstKeyFromHashTable( table );
-
-  hash_index = hash(lastKey);
-  for ( link = table->items[hash_index];
-        link != NULL && strcasecmp(lastKey,link->key) != 0;
-        link = link->next ) {}
-
-  if ( link != NULL && link->next != NULL )
-    return link->next->key;
-
-  while ( ++hash_index < MS_HASHSIZE ) {
-    if ( table->items[hash_index] != NULL )
-      return table->items[hash_index]->key;
-  }
-
-  return NULL;
-}
-
diff -pruN 8.0.1-5/maphash.h 8.2.0~beta1-1~exp1/maphash.h
--- 8.0.1-5/maphash.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maphash.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,167 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Declarations for the hashTableObj and related stuff.
- * Author:   Sean Gillies, sgillies@frii.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPHASH__H
-#define MAPHASH__H
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
-#else
-#define  MS_DLL_EXPORT
-#endif
-
-#define MS_HASHSIZE 41
-
-  /* =========================================================================
-   * Structs
-   * ========================================================================= */
-
-#ifndef SWIG
-  struct hashObj {
-    struct hashObj *next;  /* pointer to next item */
-    char           *key;   /* string key that is hashed */
-    char           *data;  /* string stored in this item */
-  };
-#endif /*SWIG*/
-
-
-/**
- * An object to store key-value pairs
- *
- */
-  typedef struct {
-#ifndef SWIG
-    struct hashObj **items;  /* the hash table */
-#endif
-#ifdef SWIG
-    %immutable;
-#endif /*SWIG*/
-    int              numitems;  ///< \**immutable** number of items
-#ifdef SWIG
-    %mutable;
-#endif /*SWIG*/
-  } hashTableObj;
-
-  /* =========================================================================
-   * Functions
-   * ========================================================================= */
-
-#ifndef SWIG
-  /* msCreateHashTable - create a hash table
-   * ARGS:
-   *     None
-   * RETURNS:
-   *     New hash table
-   */
-  MS_DLL_EXPORT hashTableObj *msCreateHashTable( void );
-
-  /* For use in mapfile.c with hashTableObj structure members */
-  MS_DLL_EXPORT int initHashTable( hashTableObj *table );
-
-  /* msFreeHashTable - free allocated memory
-   * ARGS:
-   *     table - target hash table
-   * RETURNS:
-   *     None
-   */
-  MS_DLL_EXPORT void msFreeHashTable( hashTableObj *table );
-
-  /* Free only the items for hashTableObj structure members (metadata, &c) */
-  MS_DLL_EXPORT void msFreeHashItems( hashTableObj *table );
-
-  /* msInsertHashTable - insert new item
-   * ARGS:
-   *     table - the target hash table
-   *     key   - key string for new item
-   *     value - data string for new item
-   * RETURNS:
-   *     pointer to the new item or NULL
-   * EXCEPTIONS:
-   *     raise MS_HASHERR on failure
-   */
-  MS_DLL_EXPORT struct hashObj *msInsertHashTable( hashTableObj *table,
-      const char *key,
-      const char *value );
-
-  /* msLookupHashTable - get the value of an item by its key
-   * ARGS:
-   *     table - the target hash table
-   *     key   - key string of item
-   * RETURNS:
-   *     string value of item
-   */
-  MS_DLL_EXPORT const char *msLookupHashTable( const hashTableObj *table, const char *key);
-
-  /* msRemoveHashTable - remove item from table at key
-   * ARGS:
-   *     table - target hash table
-   *     key   - key string
-   * RETURNS:
-   *     MS_SUCCESS or MS_FAILURE
-   */
-  MS_DLL_EXPORT int msRemoveHashTable( hashTableObj *table, const char *key);
-
-  /* msFirstKeyFromHashTable - get key of first item
-   * ARGS:
-   *     table - target hash table
-   * RETURNS:
-   *     first key as a string
-   */
-  MS_DLL_EXPORT const char *msFirstKeyFromHashTable( const hashTableObj *table );
-
-  /* msNextKeyFromHashTable - get next key
-   * ARGS:
-   *     table - target hash table
-   *     prevkey - the previous key
-   * RETURNS:
-   *     the key of the item of following prevkey as a string
-   */
-  MS_DLL_EXPORT const char *msNextKeyFromHashTable( const hashTableObj *table,
-      const char *prevkey );
-
-  /* msHashIsEmpty - get next key
-   * ARGS:
-   *     table - target hash table
-   * RETURNS:
-   *     MS_TRUE if the table is empty and MS_FALSE if the table has items
-   */
-
-  MS_DLL_EXPORT int msHashIsEmpty( const hashTableObj* table );
-
-#endif /*SWIG*/
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPHASH__H */
diff -pruN 8.0.1-5/maphttp.c 8.2.0~beta1-1~exp1/maphttp.c
--- 8.0.1-5/maphttp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maphttp.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,985 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Utility functions to access files via HTTP (requires libcurl)
- * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2001-2003, Daniel Morissette, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#define NEED_IGNORE_RET_VAL
-
-/* For now this code is enabled only when WMS/WFS client is enabled.
- * This should be changed to a test on the presence of libcurl which
- * is really what the real dependency is.
- */
-#include "mapserver-config.h"
-#if defined(USE_CURL)
-
-#include "mapserver.h"
-#include "maphttp.h"
-#include "maperror.h"
-#include "mapthread.h"
-#include "mapows.h"
-
-#include "cpl_conv.h"
-
-#include <time.h>
-#ifndef _WIN32
-#include <sys/time.h>
-#include <unistd.h>
-
-#endif
-
-/*
- * Note: This code uses libcurl to access remote files via the HTTP protocol.
- * Requires libcurl v 7.10 or more recent.
- * See http://curl.haxx.se/libcurl/c/ for the lib source code and docs.
- */
-#include <curl/curl.h>
-
-
-#define unchecked_curl_easy_setopt(handle,opt,param) IGNORE_RET_VAL(curl_easy_setopt(handle,opt,param))
-
-/**********************************************************************
- *                          msHTTPInit()
- *
- * This function is called to init libcurl before the first HTTP request
- * in this process is executed.
- * On further calls (when gbCurlInitialized = MS_TRUE) it simply doest nothing.
- *
- * Returns MS_SUCCESS/MS_FAILURE.
- *
- * msHTTPCleanup() will have to be called in msCleanup() when this process
- * exits.
- **********************************************************************/
-static int gbCurlInitialized = MS_FALSE;
-
-int msHTTPInit()
-{
-  /* curl_global_init() should only be called once (no matter how
-   * many threads or libcurl sessions that'll be used) by every
-   * application that uses libcurl.
-   */
-
-  msAcquireLock(TLOCK_OWS);
-  if (!gbCurlInitialized &&
-      curl_global_init(CURL_GLOBAL_ALL) != 0) {
-    msReleaseLock(TLOCK_OWS);
-    msSetError(MS_HTTPERR, "Libcurl initialization failed.",
-               "msHTTPInit()");
-    return MS_FAILURE;
-  }
-
-  gbCurlInitialized = MS_TRUE;
-
-  msReleaseLock(TLOCK_OWS);
-  return MS_SUCCESS;
-}
-
-
-/**********************************************************************
- *                          msHTTPCleanup()
- *
- **********************************************************************/
-void msHTTPCleanup()
-{
-  msAcquireLock(TLOCK_OWS);
-  if (gbCurlInitialized)
-    curl_global_cleanup();
-
-  gbCurlInitialized = MS_FALSE;
-  msReleaseLock(TLOCK_OWS);
-}
-
-
-/**********************************************************************
- *                          msHTTPInitRequestObj()
- *
- * Should be called on a new array of httpRequestObj to initialize them
- * for use with msHTTPExecuteRequest(), etc.
- *
- **********************************************************************/
-void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests)
-{
-  int i;
-
-  for(i=0; i<numRequests; i++) {
-    pasReqInfo[i].pszGetUrl = NULL;
-    pasReqInfo[i].pszPostRequest = NULL;
-    pasReqInfo[i].pszPostContentType = NULL;
-    pasReqInfo[i].pszOutputFile = NULL;
-    pasReqInfo[i].nLayerId = 0;
-    pasReqInfo[i].nTimeout = 0;
-    pasReqInfo[i].nMaxBytes = 0;
-    pasReqInfo[i].nStatus = 0;
-    pasReqInfo[i].pszContentType = NULL;
-    pasReqInfo[i].pszErrBuf = NULL;
-    pasReqInfo[i].pszUserAgent = NULL;
-    pasReqInfo[i].pszHTTPCookieData = NULL;
-    pasReqInfo[i].pszProxyAddress = NULL;
-    pasReqInfo[i].pszProxyUsername = NULL;
-    pasReqInfo[i].pszProxyPassword = NULL;
-    pasReqInfo[i].pszHttpUsername = NULL;
-    pasReqInfo[i].pszHttpPassword = NULL;
-
-    pasReqInfo[i].debug = MS_FALSE;
-
-    pasReqInfo[i].curl_handle = NULL;
-    pasReqInfo[i].fp = NULL;
-    pasReqInfo[i].result_data = NULL;
-    pasReqInfo[i].result_size = 0;
-    pasReqInfo[i].result_buf_size = 0;
-  }
-}
-
-
-/**********************************************************************
- *                          msHTTPFreeRequestObj()
- *
- **********************************************************************/
-void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests)
-{
-  int i;
-  for(i=0; i<numRequests; i++) {
-    if (pasReqInfo[i].pszGetUrl)
-      free(pasReqInfo[i].pszGetUrl);
-    pasReqInfo[i].pszGetUrl = NULL;
-
-    if (pasReqInfo[i].pszPostRequest)
-      free(pasReqInfo[i].pszPostRequest);
-    pasReqInfo[i].pszPostRequest = NULL;
-
-    if (pasReqInfo[i].pszPostContentType)
-      free(pasReqInfo[i].pszPostContentType);
-    pasReqInfo[i].pszPostContentType = NULL;
-
-    if (pasReqInfo[i].pszOutputFile)
-      free(pasReqInfo[i].pszOutputFile);
-    pasReqInfo[i].pszOutputFile = NULL;
-
-    if (pasReqInfo[i].pszContentType)
-      free(pasReqInfo[i].pszContentType);
-    pasReqInfo[i].pszContentType = NULL;
-
-    if (pasReqInfo[i].pszErrBuf)
-      free(pasReqInfo[i].pszErrBuf);
-    pasReqInfo[i].pszErrBuf = NULL;
-
-    if (pasReqInfo[i].pszUserAgent)
-      free(pasReqInfo[i].pszUserAgent);
-    pasReqInfo[i].pszUserAgent = NULL;
-
-    if (pasReqInfo[i].pszHTTPCookieData)
-      free(pasReqInfo[i].pszHTTPCookieData);
-    pasReqInfo[i].pszHTTPCookieData = NULL;
-
-    pasReqInfo[i].curl_handle = NULL;
-
-    free( pasReqInfo[i].result_data );
-    pasReqInfo[i].result_data = NULL;
-    pasReqInfo[i].result_size = 0;
-    pasReqInfo[i].result_buf_size = 0;
-  }
-}
-
-
-/**********************************************************************
- *                          msHTTPWriteFct()
- *
- * CURL_OPTWRITEFUNCTION, called to write blocks of data to the file we
- * are downloading.  Should return the number of bytes that were taken
- * care of.  If that  amount  differs  from  the  amount passed to it
- * it'll signal an error to the library and it will abort the transfer
- * and produce a CURLE_WRITE_ERROR.
- *
- **********************************************************************/
-static size_t msHTTPWriteFct(void *buffer, size_t size, size_t nmemb,
-                             void *reqInfo)
-{
-  httpRequestObj *psReq;
-
-  psReq = (httpRequestObj *)reqInfo;
-
-  if (psReq->debug) {
-    msDebug("msHTTPWriteFct(id=%d, %d bytes)\n",
-            psReq->nLayerId, (int)(size*nmemb));
-  }
-
-  if(psReq->nMaxBytes > 0 && (psReq->result_size + size*nmemb) > (size_t)psReq->nMaxBytes) {
-      msSetError(MS_HTTPERR, "Requested transfer larger than configured maximum %d.",
-                 "msHTTPWriteFct()",
-                 psReq->nMaxBytes );
-      return -1;
-  }
-  /* Case where we are writing to a disk file. */
-  if( psReq->fp != NULL ) {
-    psReq->result_size += size*nmemb;
-    return fwrite(buffer, size, nmemb, psReq->fp);
-  }
-
-  /* Case where we build up the result in memory */
-  else {
-    if( psReq->result_data == NULL ) {
-      psReq->result_buf_size = size*nmemb + 10000;
-      psReq->result_data = (char *) msSmallMalloc( psReq->result_buf_size );
-    } else if( psReq->result_size + nmemb * size > (size_t)psReq->result_buf_size ) {
-      psReq->result_buf_size = psReq->result_size + nmemb*size + 10000;
-      psReq->result_data = (char *) msSmallRealloc( psReq->result_data,
-                           psReq->result_buf_size );
-    }
-
-    if( psReq->result_data == NULL ) {
-      msSetError(MS_HTTPERR,
-                 "Unable to grow HTTP result buffer to size %d.",
-                 "msHTTPWriteFct()",
-                 psReq->result_buf_size );
-      psReq->result_buf_size = 0;
-      psReq->result_size = 0;
-      return -1;
-    }
-
-    memcpy( psReq->result_data + psReq->result_size,
-            buffer, size*nmemb );
-    psReq->result_size += size*nmemb;
-
-    return size*nmemb;
-  }
-}
-
-/**********************************************************************
- *                          msGetCURLAuthType()
- *
- * Returns the equivalent CURL CURLAUTH_ constant given a
- * MS_HTTP_AUTH_TYPE, or CURLAUTH_BASIC if no match is found.
- **********************************************************************/
-long msGetCURLAuthType(enum MS_HTTP_AUTH_TYPE authType)
-{
-  switch (authType) {
-    case MS_BASIC:
-      return CURLAUTH_BASIC;
-    case MS_DIGEST:
-      return CURLAUTH_DIGEST;
-    case MS_NTLM:
-      return CURLAUTH_NTLM;
-    case MS_ANY:
-      return CURLAUTH_ANY;
-    case MS_ANYSAFE:
-      return CURLAUTH_ANYSAFE;
-    default:
-      return CURLAUTH_BASIC;
-  }
-}
-
-
-/**********************************************************************
- *                          msHTTPAuthProxySetup()
- *
- * Common code used by msPrepareWFSLayerRequest() and
- * msPrepareWMSLayerRequest() to handle proxy / http auth for requests
- *
- * Return value:
- * MS_SUCCESS if all requests completed succesfully.
- * MS_FAILURE if a fatal error happened
- **********************************************************************/
-int msHTTPAuthProxySetup(hashTableObj *mapmd, hashTableObj *lyrmd,
-                         httpRequestObj *pasReqInfo, int numRequests,
-                         mapObj *map, const char* namespaces)
-{
-
-  const char *pszTmp;
-  char    *pszProxyHost=NULL;
-  long     nProxyPort=0;
-  char    *pszProxyUsername=NULL, *pszProxyPassword=NULL;
-  char    *pszHttpAuthUsername=NULL, *pszHttpAuthPassword=NULL;
-  enum MS_HTTP_AUTH_TYPE eHttpAuthType = MS_BASIC;
-  enum MS_HTTP_AUTH_TYPE eProxyAuthType = MS_BASIC;
-  enum MS_HTTP_PROXY_TYPE eProxyType = MS_HTTP;
-
-
-  /* ------------------------------------------------------------------
-   * Check for authentication and proxying metadata. If the metadata is not found
-   * in the layer metadata, check the map-level metadata.
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_host")) != NULL) {
-    pszProxyHost = msStrdup(pszTmp);
-  }
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_port")) != NULL) {
-    nProxyPort = atol(pszTmp);
-  }
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_type")) != NULL) {
-
-    if (strcasecmp(pszTmp, "HTTP") == 0)
-      eProxyType = MS_HTTP;
-    else if (strcasecmp(pszTmp, "SOCKS5") == 0)
-      eProxyType = MS_SOCKS5;
-    else {
-      msSetError(MS_WMSERR, "Invalid proxy_type metadata '%s' specified",
-                 "msHTTPAuthProxySetup()", pszTmp);
-      return MS_FAILURE;
-    }
-  }
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_auth_type")) != NULL) {
-    if (strcasecmp(pszTmp, "BASIC") == 0)
-      eProxyAuthType = MS_BASIC;
-    else if (strcasecmp(pszTmp, "DIGEST") == 0)
-      eProxyAuthType = MS_DIGEST;
-    else if (strcasecmp(pszTmp, "NTLM") == 0)
-      eProxyAuthType = MS_NTLM;
-    else if (strcasecmp(pszTmp, "ANY") == 0)
-      eProxyAuthType = MS_ANY;
-    else if (strcasecmp(pszTmp, "ANYSAFE") == 0)
-      eProxyAuthType = MS_ANYSAFE;
-    else {
-      msSetError(MS_WMSERR, "Invalid proxy_auth_type metadata '%s' specified",
-                 "msHTTPAuthProxySetup()", pszTmp);
-      return MS_FAILURE;
-    }
-  }
-
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_username")) != NULL) {
-    pszProxyUsername = msStrdup(pszTmp);
-  }
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_password")) != NULL) {
-    pszProxyPassword = msDecryptStringTokens(map, pszTmp);
-    if (pszProxyPassword == NULL) {
-      msFree(pszProxyHost);
-      msFree(pszProxyUsername);
-      return(MS_FAILURE);  /* An error should already have been produced */
-    }
-  }
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "auth_type")) != NULL) {
-    if (strcasecmp(pszTmp, "BASIC") == 0)
-      eHttpAuthType = MS_BASIC;
-    else if (strcasecmp(pszTmp, "DIGEST") == 0)
-      eHttpAuthType = MS_DIGEST;
-    else if (strcasecmp(pszTmp, "NTLM") == 0)
-      eHttpAuthType = MS_NTLM;
-    else if (strcasecmp(pszTmp, "ANY") == 0)
-      eHttpAuthType = MS_ANY;
-    else if (strcasecmp(pszTmp, "ANYSAFE") == 0)
-      eHttpAuthType = MS_ANYSAFE;
-    else {
-      msSetError(MS_WMSERR, "Invalid auth_type metadata '%s' specified",
-                 "msHTTPAuthProxySetup()", pszTmp);
-      return MS_FAILURE;
-    }
-  }
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "auth_username")) != NULL) {
-    pszHttpAuthUsername = msStrdup(pszTmp);
-  }
-
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "auth_password")) != NULL) {
-    pszHttpAuthPassword = msDecryptStringTokens(map, pszTmp);
-    if (pszHttpAuthPassword == NULL) {
-      msFree(pszHttpAuthUsername);
-      msFree(pszProxyHost);
-      msFree(pszProxyUsername);
-      msFree(pszProxyPassword);
-      return(MS_FAILURE);  /* An error should already have been produced */
-    }
-  }
-
-  pasReqInfo[numRequests].pszProxyAddress  = pszProxyHost;
-  pasReqInfo[numRequests].nProxyPort       = nProxyPort;
-  pasReqInfo[numRequests].eProxyType       = eProxyType;
-  pasReqInfo[numRequests].eProxyAuthType   = eProxyAuthType;
-  pasReqInfo[numRequests].pszProxyUsername = pszProxyUsername;
-  pasReqInfo[numRequests].pszProxyPassword = pszProxyPassword;
-  pasReqInfo[numRequests].eHttpAuthType    = eHttpAuthType;
-  pasReqInfo[numRequests].pszHttpUsername  = pszHttpAuthUsername;
-  pasReqInfo[numRequests].pszHttpPassword  = pszHttpAuthPassword;
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                          msHTTPExecuteRequests()
- *
- * Fetch a map slide via HTTP request and save to specified temp file.
- *
- * If bCheckLocalCache==MS_TRUE then if the pszOutputfile already exists
- * then is is not downloaded again, and status 242 is returned.
- *
- * Return value:
- * MS_SUCCESS if all requests completed succesfully.
- * MS_FAILURE if a fatal error happened
- * MS_DONE if some requests failed with 40x status for instance (not fatal)
- **********************************************************************/
-int msHTTPExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
-                          int bCheckLocalCache)
-{
-  int     i, nStatus = MS_SUCCESS, nTimeout, still_running=0, num_msgs=0;
-  CURLM   *multi_handle;
-  CURLMsg *curl_msg;
-  char     debug = MS_FALSE;
-  const char *pszCurlCABundle = NULL;
-
-  if (numRequests == 0)
-    return MS_SUCCESS;  /* Nothing to do */
-
-  if (!gbCurlInitialized)
-    msHTTPInit();
-
-  /* Establish the timeout (seconds) for how long we are going to wait
-   * for a response.
-   * We use the longest timeout value in the array of requests
-   */
-  nTimeout = pasReqInfo[0].nTimeout;
-  for (i=0; i<numRequests; i++) {
-    if (pasReqInfo[i].nTimeout > nTimeout)
-      nTimeout = pasReqInfo[i].nTimeout;
-
-    if (pasReqInfo[i].debug)
-      debug = MS_TRUE;  /* For the download loop */
-  }
-
-  if (nTimeout <= 0)
-    nTimeout = 30;
-
-  /* Check if we've got a CURL_CA_BUNDLE env. var.
-   * If set then the value is the full path to the ca-bundle.crt file
-   * e.g. CURL_CA_BUNDLE=/usr/local/share/curl/curl-ca-bundle.crt
-   */
-  pszCurlCABundle = CPLGetConfigOption("CURL_CA_BUNDLE", NULL);
-
-  if (debug) {
-    msDebug("HTTP: Starting to prepare HTTP requests.\n");
-    if (pszCurlCABundle)
-      msDebug("Using CURL_CA_BUNDLE=%s\n", pszCurlCABundle);
-  }
-
-  const char* pszHttpVersion = CPLGetConfigOption("CURL_HTTP_VERSION", NULL);
-
-  /* Alloc a curl-multi handle, and add a curl-easy handle to it for each
-   * file to download.
-   */
-  multi_handle = curl_multi_init();
-  if (multi_handle == NULL) {
-    msSetError(MS_HTTPERR, "curl_multi_init() failed.",
-               "msHTTPExecuteRequests()");
-    return(MS_FAILURE);
-  }
-
-  for (i=0; i<numRequests; i++) {
-    CURL *http_handle;
-    FILE *fp;
-
-    if (pasReqInfo[i].pszGetUrl == NULL ) {
-      msSetError(MS_HTTPERR, "URL or output file parameter missing.",
-                 "msHTTPExecuteRequests()");
-      return(MS_FAILURE);
-    }
-
-    if (pasReqInfo[i].debug) {
-      msDebug("HTTP request: id=%d, %s\n",
-              pasReqInfo[i].nLayerId, pasReqInfo[i].pszGetUrl);
-    }
-
-    /* Reset some members */
-    pasReqInfo[i].nStatus = 0;
-    if (pasReqInfo[i].pszContentType)
-      free(pasReqInfo[i].pszContentType);
-    pasReqInfo[i].pszContentType = NULL;
-
-    /* Check local cache if requested */
-    if (bCheckLocalCache && pasReqInfo[i].pszOutputFile != NULL ) {
-      fp = fopen(pasReqInfo[i].pszOutputFile, "r");
-      if (fp) {
-        /* File already there, don't download again. */
-        if (pasReqInfo[i].debug)
-          msDebug("HTTP request: id=%d, found in cache, skipping.\n",
-                  pasReqInfo[i].nLayerId);
-        fclose(fp);
-        pasReqInfo[i].nStatus = 242;
-        pasReqInfo[i].pszContentType = msStrdup("unknown/cached");
-        continue;
-      }
-    }
-
-    /* Alloc curl handle */
-    http_handle = curl_easy_init();
-    if (http_handle == NULL) {
-      msSetError(MS_HTTPERR, "curl_easy_init() failed.",
-                 "msHTTPExecuteRequests()");
-      return(MS_FAILURE);
-    }
-
-    pasReqInfo[i].curl_handle = http_handle;
-
-    /* set URL, note that curl keeps only a ref to our string buffer */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL, pasReqInfo[i].pszGetUrl );
-
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_PROTOCOLS, CURLPROTO_HTTP|CURLPROTO_HTTPS );
-
-    if (pszHttpVersion && strcmp(pszHttpVersion, "1.0") == 0)
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
-                                   CURL_HTTP_VERSION_1_0);
-    else if (pszHttpVersion && strcmp(pszHttpVersion, "1.1") == 0)
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
-                                   CURL_HTTP_VERSION_1_1);
-
-    /* Set User-Agent (auto-generate if not set by caller */
-    if (pasReqInfo[i].pszUserAgent == NULL) {
-      curl_version_info_data *psCurlVInfo;
-
-      psCurlVInfo = curl_version_info(CURLVERSION_NOW);
-
-      pasReqInfo[i].pszUserAgent = (char*)msSmallMalloc(100*sizeof(char));
-
-      if (pasReqInfo[i].pszUserAgent) {
-        sprintf(pasReqInfo[i].pszUserAgent,
-                "MapServer/%s libcurl/%d.%d.%d",
-                MS_VERSION,
-                psCurlVInfo->version_num/0x10000 & 0xff,
-                psCurlVInfo->version_num/0x100 & 0xff,
-                psCurlVInfo->version_num & 0xff );
-      }
-    }
-    if (pasReqInfo[i].pszUserAgent) {
-      unchecked_curl_easy_setopt(http_handle,
-                       CURLOPT_USERAGENT, pasReqInfo[i].pszUserAgent );
-    }
-
-    /* Enable following redirections.  Requires libcurl 7.10.1 at least */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_FOLLOWLOCATION, 1 );
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_MAXREDIRS, 10 );
-
-    /* Set timeout.*/
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_TIMEOUT, nTimeout );
-
-    /* Pass CURL_CA_BUNDLE if set */
-    if (pszCurlCABundle)
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_CAINFO, pszCurlCABundle );
-
-    /* Set proxying settings */
-    if (pasReqInfo[i].pszProxyAddress != NULL
-        && strlen(pasReqInfo[i].pszProxyAddress) > 0) {
-      long    nProxyType     = CURLPROXY_HTTP;
-
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXY,
-                       pasReqInfo[i].pszProxyAddress);
-
-      if (pasReqInfo[i].nProxyPort > 0
-          && pasReqInfo[i].nProxyPort < 65535) {
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYPORT,
-                         pasReqInfo[i].nProxyPort);
-      }
-
-      switch (pasReqInfo[i].eProxyType) {
-        case MS_HTTP:
-          nProxyType = CURLPROXY_HTTP;
-          break;
-        case MS_SOCKS5:
-          nProxyType = CURLPROXY_SOCKS5;
-          break;
-      }
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYTYPE, nProxyType);
-
-      /* If there is proxy authentication information, set it */
-      if (pasReqInfo[i].pszProxyUsername != NULL
-          && pasReqInfo[i].pszProxyPassword != NULL
-          && strlen(pasReqInfo[i].pszProxyUsername) > 0
-          && strlen(pasReqInfo[i].pszProxyPassword) > 0) {
-        char    szUsernamePasswd[128];
-#if LIBCURL_VERSION_NUM >= 0x070a07
-        long    nProxyAuthType = CURLAUTH_BASIC;
-        /* CURLOPT_PROXYAUTH available only in Curl 7.10.7 and up */
-        nProxyAuthType = msGetCURLAuthType(pasReqInfo[i].eProxyAuthType);
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYAUTH, nProxyAuthType);
-#else
-        /* We log an error but don't abort processing */
-        msSetError(MS_HTTPERR, "CURLOPT_PROXYAUTH not supported. Requires Curl 7.10.7 and up. *_proxy_auth_type setting ignored.",
-                   "msHTTPExecuteRequests()");
-#endif /* LIBCURL_VERSION_NUM */
-
-        snprintf(szUsernamePasswd, 127, "%s:%s",
-                 pasReqInfo[i].pszProxyUsername,
-                 pasReqInfo[i].pszProxyPassword);
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYUSERPWD,
-                         szUsernamePasswd);
-      }
-    }
-
-    /* Set HTTP Authentication settings */
-    if (pasReqInfo[i].pszHttpUsername != NULL
-        && pasReqInfo[i].pszHttpPassword != NULL
-        && strlen(pasReqInfo[i].pszHttpUsername) > 0
-        && strlen(pasReqInfo[i].pszHttpPassword) > 0) {
-      char    szUsernamePasswd[128];
-      long    nHttpAuthType = CURLAUTH_BASIC;
-
-      snprintf(szUsernamePasswd, 127, "%s:%s",
-               pasReqInfo[i].pszHttpUsername,
-               pasReqInfo[i].pszHttpPassword);
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_USERPWD,
-                       szUsernamePasswd);
-
-      nHttpAuthType = msGetCURLAuthType(pasReqInfo[i].eHttpAuthType);
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTPAUTH, nHttpAuthType);
-    }
-
-    /* NOSIGNAL should be set to true for timeout to work in multithread
-     * environments on Unix, requires libcurl 7.10 or more recent.
-     * (this force avoiding the use of sgnal handlers)
-     */
-#ifdef CURLOPT_NOSIGNAL
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_NOSIGNAL, 1 );
-#endif
-
-    /* If we are writing file to disk, open the file now. */
-    if( pasReqInfo[i].pszOutputFile != NULL ) {
-      if ( (fp = fopen(pasReqInfo[i].pszOutputFile, "wb")) == NULL) {
-        msSetError(MS_HTTPERR, "Can't open output file %s.",
-                   "msHTTPExecuteRequests()", pasReqInfo[i].pszOutputFile);
-        return(MS_FAILURE);
-      }
-
-      pasReqInfo[i].fp = fp;
-    }
-
-    /* coverity[bad_sizeof] */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEDATA, &(pasReqInfo[i]));
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEFUNCTION, msHTTPWriteFct);
-
-    /* Provide a buffer where libcurl can write human readable error msgs
-     */
-    if (pasReqInfo[i].pszErrBuf == NULL)
-      pasReqInfo[i].pszErrBuf = (char *)msSmallMalloc((CURL_ERROR_SIZE+1)*
-                                sizeof(char));
-    pasReqInfo[i].pszErrBuf[0] = '\0';
-
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_ERRORBUFFER,
-                     pasReqInfo[i].pszErrBuf);
-
-    if(pasReqInfo[i].pszPostRequest != NULL ) {
-      char szBuf[100];
-
-      struct curl_slist *headers=NULL;
-      snprintf(szBuf, 100,
-               "Content-Type: %s", pasReqInfo[i].pszPostContentType);
-      headers = curl_slist_append(headers, szBuf);
-
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_POST, 1 );
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_POSTFIELDS,
-                       pasReqInfo[i].pszPostRequest);
-      if( debug )
-      {
-          msDebug("HTTP: POST = %s", pasReqInfo[i].pszPostRequest);
-      }
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTPHEADER, headers);
-      /* curl_slist_free_all(headers); */ /* free the header list */
-    }
-
-    /* Added by RFC-42 HTTP Cookie Forwarding */
-    if(pasReqInfo[i].pszHTTPCookieData != NULL) {
-      /* Check if there's no end of line in the Cookie string */
-      /* This could break the HTTP Header */
-      for(size_t nPos=0; nPos<strlen(pasReqInfo[i].pszHTTPCookieData); nPos++) {
-        if(pasReqInfo[i].pszHTTPCookieData[nPos] == '\n') {
-          msSetError(MS_HTTPERR, "Can't use cookie containing a newline character.",
-                     "msHTTPExecuteRequests()");
-          return(MS_FAILURE);
-        }
-      }
-
-      /* Set the Curl option to send Cookie */
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_COOKIE,
-                       pasReqInfo[i].pszHTTPCookieData);
-    }
-
-    /* Add to multi handle */
-    curl_multi_add_handle(multi_handle, http_handle);
-
-  }
-
-  if (debug) {
-    msDebug("HTTP: Before download loop\n");
-  }
-
-  /* DOWNLOAD LOOP ... inspired from multi-double.c example */
-
-  /* we start some action by calling perform right away */
-  while(CURLM_CALL_MULTI_PERFORM ==
-        curl_multi_perform(multi_handle, &still_running));
-
-  while(still_running) {
-    struct timeval timeout;
-    int rc; /* select() return code */
-
-    fd_set fdread;
-    fd_set fdwrite;
-    fd_set fdexcep;
-    int maxfd;
-
-    FD_ZERO(&fdread);
-    FD_ZERO(&fdwrite);
-    FD_ZERO(&fdexcep);
-
-    /* set a suitable timeout to play around with */
-    timeout.tv_sec = 0;
-    timeout.tv_usec = 100000;
-
-    /* get file descriptors from the transfers */
-    curl_multi_fdset(multi_handle, &fdread, &fdwrite, &fdexcep, &maxfd);
-
-    rc = select(maxfd+1, &fdread, &fdwrite, &fdexcep, &timeout);
-
-    switch(rc) {
-      case -1:
-        /* select error */
-
-        /* ==================================================================== */
-        /*      On Windows the select function (just above) returns -1 when     */
-        /*      it is called the second time and all the calls after            */
-        /*      that. This causes an infinite loop.                             */
-        /*      I do not really know why.                                       */
-        /*      To sovle the problem the break frop case -1 has been removed.   */
-        /* ==================================================================== */
-#ifndef _WIN32
-        break;
-#endif
-      case 0:
-      default:
-        /* timeout or readable/writable sockets */
-        curl_multi_perform(multi_handle, &still_running);
-        break;
-    }
-  }
-
-  if (debug)
-    msDebug("HTTP: After download loop\n");
-
-  /* Scan message stack from CURL and report fatal errors*/
-
-  while((curl_msg = curl_multi_info_read( multi_handle, &num_msgs)) != NULL) {
-    httpRequestObj *psReq = NULL;
-
-    if (curl_msg->msg == CURLMSG_DONE &&
-        curl_msg->data.result != CURLE_OK) {
-      /* Something went wrong with this transfer... report error */
-
-      for (i=0; i<numRequests; i++) {
-        if (pasReqInfo[i].curl_handle == curl_msg->easy_handle) {
-          psReq = &(pasReqInfo[i]);
-          break;
-        }
-      }
-
-      if (psReq != NULL) {
-        /* Record error code in nStatus as a negative value */
-        psReq->nStatus = -curl_msg->data.result;
-      }
-    }
-  }
-
-  if (debug) {
-    /* Print a msDebug header for timings reported in the loop below */
-    msDebug("msHTTPExecuteRequests() timing summary per layer (connect_time + time_to_first_packet + download_time = total_time in seconds)\n");
-  }
-
-  /* Check status of all requests, close files, report errors and cleanup
-   * handles
-   */
-  for (i=0; i<numRequests; i++) {
-    httpRequestObj *psReq;
-    CURL *http_handle;
-    long lVal=0;
-
-    psReq = &(pasReqInfo[i]);
-
-    if (psReq->nStatus == 242)
-      continue;  /* Nothing to do here, this file was in cache already */
-
-    if (psReq->fp)
-      fclose(psReq->fp);
-    psReq->fp = NULL;
-
-    http_handle = (CURL*)(psReq->curl_handle);
-
-    if (psReq->nStatus == 0 &&
-        curl_easy_getinfo(http_handle,
-                          CURLINFO_HTTP_CODE, &lVal) == CURLE_OK) {
-      char *pszContentType = NULL;
-
-      psReq->nStatus = lVal;
-
-      /* Fetch content type of response */
-      if (curl_easy_getinfo(http_handle,
-                            CURLINFO_CONTENT_TYPE,
-                            &pszContentType) == CURLE_OK &&
-          pszContentType != NULL) {
-        psReq->pszContentType = msStrdup(pszContentType);
-      }
-    }
-
-    if (!MS_HTTP_SUCCESS(psReq->nStatus)) {
-      /* Set status to MS_DONE to indicate that transfers were  */
-      /* completed but may not be succesfull */
-      nStatus = MS_DONE;
-
-      if (psReq->nStatus == -(CURLE_OPERATION_TIMEOUTED)) {
-        /* Timeout isn't a fatal error */
-        if (psReq->debug)
-          msDebug("HTTP: TIMEOUT of %d seconds exceeded for %s\n",
-                  nTimeout, psReq->pszGetUrl );
-
-        msSetError(MS_HTTPERR,
-                   "HTTP: TIMEOUT of %d seconds exceeded for %s\n",
-                   "msHTTPExecuteRequests()",
-                   nTimeout, psReq->pszGetUrl);
-
-        /* Rewrite error message, the curl timeout message isn't
-         * of much use to our users.
-         */
-        sprintf(psReq->pszErrBuf,
-                "TIMEOUT of %d seconds exceeded.", nTimeout);
-      } else if (psReq->nStatus > 0) {
-        /* Got an HTTP Error, e.g. 404, etc. */
-
-        if (psReq->debug)
-          msDebug("HTTP: HTTP GET request failed with status %d (%s)"
-                  " for %s\n",
-                  psReq->nStatus, psReq->pszErrBuf,
-                  psReq->pszGetUrl);
-
-        msSetError(MS_HTTPERR,
-                   "HTTP GET request failed with status %d (%s) "
-                   "for %s",
-                   "msHTTPExecuteRequests()", psReq->nStatus,
-                   psReq->pszErrBuf, psReq->pszGetUrl);
-      } else {
-        /* Got a curl error */
-
-        errorObj *error = msGetErrorObj();
-        if (psReq->debug)
-          msDebug("HTTP: request failed with curl error "
-                  "code %d (%s) for %s",
-                  -psReq->nStatus, psReq->pszErrBuf,
-                  psReq->pszGetUrl);
-
-        if(!error || error->code == MS_NOERR) /* only set error if one hasn't already been set */
-          msSetError(MS_HTTPERR,
-                   "HTTP: request failed with curl error "
-                   "code %d (%s) for %s",
-                   "msHTTPExecuteRequests()",
-                   -psReq->nStatus, psReq->pszErrBuf,
-                   psReq->pszGetUrl);
-      }
-    }
-
-    /* Report download times foreach handle, in debug mode */
-    if (psReq->debug) {
-      double dConnectTime=0.0, dTotalTime=0.0, dStartTfrTime=0.0;
-
-      curl_easy_getinfo(http_handle,
-                        CURLINFO_CONNECT_TIME, &dConnectTime);
-      curl_easy_getinfo(http_handle,
-                        CURLINFO_STARTTRANSFER_TIME, &dStartTfrTime);
-      curl_easy_getinfo(http_handle,
-                        CURLINFO_TOTAL_TIME, &dTotalTime);
-      /* STARTTRANSFER_TIME includes CONNECT_TIME, but TOTAL_TIME
-       * doesn't, so we need to add it.
-       */
-      dTotalTime += dConnectTime;
-
-      msDebug("Layer %d: %.3f + %.3f + %.3f = %.3fs\n", psReq->nLayerId,
-              dConnectTime, dStartTfrTime-dConnectTime,
-              dTotalTime-dStartTfrTime, dTotalTime);
-    }
-
-    /* Cleanup this handle */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL, "" );
-    curl_multi_remove_handle(multi_handle, http_handle);
-    curl_easy_cleanup(http_handle);
-    psReq->curl_handle = NULL;
-
-  }
-
-  /* Cleanup multi handle, each handle had to be cleaned up individually */
-  curl_multi_cleanup(multi_handle);
-
-  return nStatus;
-}
-
-/**********************************************************************
- *                          msHTTPGetFile()
- *
- * Wrapper to call msHTTPExecuteRequests() for a single file.
- **********************************************************************/
-int msHTTPGetFile(const char *pszGetUrl, const char *pszOutputFile,
-                  int *pnHTTPStatus, int nTimeout, int bCheckLocalCache,
-                  int bDebug, int nMaxBytes)
-{
-  httpRequestObj *pasReqInfo;
-
-  /* Alloc httpRequestInfo structs through which status of each request
-   * will be returned.
-   * We need to alloc 2 instance of requestobj so that the last
-   * object in the array can be set to NULL.
-  */
-  pasReqInfo = (httpRequestObj*)calloc(2, sizeof(httpRequestObj));
-  MS_CHECK_ALLOC(pasReqInfo, 2*sizeof(httpRequestObj), MS_FAILURE);
-
-  msHTTPInitRequestObj(pasReqInfo, 2);
-
-  pasReqInfo[0].pszGetUrl = msStrdup(pszGetUrl);
-  pasReqInfo[0].pszOutputFile = msStrdup(pszOutputFile);
-  pasReqInfo[0].debug = (char)bDebug;
-  pasReqInfo[0].nTimeout = nTimeout;
-  pasReqInfo[0].nMaxBytes = nMaxBytes;
-
-  if (msHTTPExecuteRequests(pasReqInfo, 1, bCheckLocalCache) != MS_SUCCESS) {
-    *pnHTTPStatus = pasReqInfo[0].nStatus;
-    if (pasReqInfo[0].debug)
-      msDebug("HTTP request failed for %s.\n", pszGetUrl);
-    msHTTPFreeRequestObj(pasReqInfo, 2);
-    free(pasReqInfo);
-    return MS_FAILURE;
-  }
-
-  *pnHTTPStatus = pasReqInfo[0].nStatus;
-
-  msHTTPFreeRequestObj(pasReqInfo, 2);
-  free(pasReqInfo);
-
-  return MS_SUCCESS;
-}
-
-
-#endif /* defined(USE_WMS_LYR) || defined(USE_WMS_SVR) */
diff -pruN 8.0.1-5/maphttp.h 8.2.0~beta1-1~exp1/maphttp.h
--- 8.0.1-5/maphttp.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maphttp.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,124 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  http requests related functions
- * Author:   MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPHTTP_H
-#define MAPHTTP_H
-
-
-
-#include "mapprimitive.h"
-#include <stdio.h>
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#define MS_HTTP_SUCCESS(status)  (status == 200 || status == 242)
-
-  enum MS_HTTP_PROXY_TYPE
-  {
-    MS_HTTP,
-    MS_SOCKS5
-  };
-
-  enum MS_HTTP_AUTH_TYPE {
-    MS_BASIC,
-    MS_DIGEST,
-    MS_NTLM,
-    MS_ANY,
-    MS_ANYSAFE
-  };
-
-  typedef struct http_request_info {
-    int     nLayerId;
-    char    *pszGetUrl;
-    char    *pszOutputFile;
-    int     nTimeout;
-    int     nMaxBytes;
-    rectObj bbox;
-    int     width;
-    int     height;
-    int     nStatus;            /* 200=success, value < 0 if request failed */
-    char    *pszContentType;    /* Content-Type of the response */
-    char    *pszErrBuf;         /* Buffer where curl can write errors */
-    char    *pszPostRequest;    /* post request content (NULL for GET) */
-    char    *pszPostContentType;/* post request MIME type */
-    char    *pszUserAgent;      /* User-Agent, auto-generated if not set */
-    char    *pszHTTPCookieData; /* HTTP Cookie data */
-
-    char    *pszProxyAddress;   /* The address (IP or hostname) of proxy svr */
-    long     nProxyPort;        /* The proxy's port                          */
-    enum MS_HTTP_PROXY_TYPE eProxyType; /* The type of proxy                 */
-    enum MS_HTTP_AUTH_TYPE  eProxyAuthType; /* Auth method against proxy     */
-    char    *pszProxyUsername;  /* Proxy authentication username             */
-    char    *pszProxyPassword;  /* Proxy authentication password             */
-
-    enum MS_HTTP_AUTH_TYPE eHttpAuthType; /* HTTP Authentication type        */
-    char    *pszHttpUsername;   /* HTTP Authentication username              */
-    char    *pszHttpPassword;   /* HTTP Authentication password              */
-
-    /* For debugging/profiling */
-    int         debug;         /* Debug mode?  MS_TRUE/MS_FALSE */
-
-    /* Private members */
-    void      * curl_handle;   /* CURLM * handle */
-    FILE      * fp;            /* FILE * used during download */
-
-    char      * result_data;   /* output if pszOutputFile is NULL */
-    int       result_size;
-    int       result_buf_size;
-
-  } httpRequestObj;
-
-#ifdef USE_CURL
-
-  int msHTTPInit(void);
-  void msHTTPCleanup(void);
-
-  void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests);
-  void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests);
-  int  msHTTPExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
-                             int bCheckLocalCache);
-  int  msHTTPGetFile(const char *pszGetUrl, const char *pszOutputFile,
-                     int *pnHTTPStatus, int nTimeout, int bCheckLocalCache,
-                     int bDebug, int nMaxBytes);
-
-  int msHTTPAuthProxySetup(hashTableObj *mapmd, hashTableObj *lyrmd,
-                           httpRequestObj *pasReqInfo, int numRequests,
-                           mapObj *map, const char* namespaces);
-#endif /*USE_CURL*/
-
-#ifdef __cplusplus
-}
-#endif
-
-
-
-
-#endif /* MAPHTTP_H */
diff -pruN 8.0.1-5/mapiconv.c 8.2.0~beta1-1~exp1/mapiconv.c
--- 8.0.1-5/mapiconv.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapiconv.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,36 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Wrapper for iconv functions
- * Author:   Even Rouault
- *
- ******************************************************************************
- * Copyright (c) 2020 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapiconv.h"
-
-size_t msIconv(iconv_t cd,
-               char **inbuf, size_t *inbytesleft,
-               char **outbuf, size_t *outbytesleft)
-{
-    return iconv(cd, inbuf, inbytesleft, outbuf, outbytesleft);
-}
diff -pruN 8.0.1-5/mapiconv.h 8.2.0~beta1-1~exp1/mapiconv.h
--- 8.0.1-5/mapiconv.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapiconv.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,47 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Wrapper for iconv functions
- * Author:   Even Rouault
- *
- ******************************************************************************
- * Copyright (c) 2020 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#ifndef MAPICONV_H
-#define MAPICONV_H
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#include <iconv.h>
-
-/* Wrapper of iconv() to be used from C++ */
-size_t msIconv(iconv_t cd,
-               char **inbuf, size_t *inbytesleft,
-               char **outbuf, size_t *outbytesleft);
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif
diff -pruN 8.0.1-5/mapimageio.c 8.2.0~beta1-1~exp1/mapimageio.c
--- 8.0.1-5/mapimageio.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapimageio.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1124 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Low level PNG/JPEG/GIF image io native functions
- * Author:   Thomas Bonfort (tbonfort)
- *
- ******************************************************************************
- * Copyright (c) 2009 Thomas Bonfort
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include <png.h>
-#include <setjmp.h>
-#include <assert.h>
-#include <jpeglib.h>
-#include <stdlib.h>
-
-#ifdef USE_GIF
-#include <gif_lib.h>
-#endif
-
-
-
-typedef struct _streamInfo {
-  FILE *fp;
-  bufferObj *buffer;
-} streamInfo;
-
-static
-void png_write_data_to_stream(png_structp png_ptr, png_bytep data, png_size_t length)
-{
-  FILE *fp = ((streamInfo*)png_get_io_ptr(png_ptr))->fp;
-  msIO_fwrite(data,length,1,fp);
-}
-
-static
-void png_write_data_to_buffer(png_structp png_ptr, png_bytep data, png_size_t length)
-{
-  bufferObj *buffer = ((streamInfo*)png_get_io_ptr(png_ptr))->buffer;
-  msBufferAppend(buffer,data,length);
-}
-
-static
-void png_flush_data(png_structp png_ptr)
-{
-  (void)png_ptr;
-  /* do nothing */
-}
-
-typedef struct {
-  struct jpeg_destination_mgr pub;
-  unsigned char *data;
-} ms_destination_mgr;
-
-typedef struct {
-  ms_destination_mgr mgr;
-  FILE *stream;
-} ms_stream_destination_mgr;
-
-typedef struct {
-  ms_destination_mgr mgr;
-  bufferObj *buffer;
-} ms_buffer_destination_mgr;
-
-#define OUTPUT_BUF_SIZE 4096
-
-static void
-jpeg_init_destination (j_compress_ptr cinfo)
-{
-  ms_destination_mgr *dest = (ms_destination_mgr*) cinfo->dest;
-
-  /* Allocate the output buffer --- it will be released when done with image */
-  dest->data = (unsigned char *)
-               (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
-                   OUTPUT_BUF_SIZE * sizeof (unsigned char));
-
-  dest->pub.next_output_byte = dest->data;
-  dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
-}
-
-static
-void jpeg_stream_term_destination (j_compress_ptr cinfo)
-{
-  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr*) cinfo->dest;
-  msIO_fwrite(dest->mgr.data, OUTPUT_BUF_SIZE-dest->mgr.pub.free_in_buffer, 1, dest->stream);
-  dest->mgr.pub.next_output_byte = dest->mgr.data;
-  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
-}
-
-static
-void jpeg_buffer_term_destination (j_compress_ptr cinfo)
-{
-  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr*) cinfo->dest;
-  msBufferAppend(dest->buffer, dest->mgr.data, OUTPUT_BUF_SIZE-dest->mgr.pub.free_in_buffer);
-  dest->mgr.pub.next_output_byte = dest->mgr.data;
-  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
-}
-
-static
-boolean jpeg_stream_empty_output_buffer (j_compress_ptr cinfo)
-{
-  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr*) cinfo->dest;
-  msIO_fwrite(dest->mgr.data, OUTPUT_BUF_SIZE, 1, dest->stream);
-  dest->mgr.pub.next_output_byte = dest->mgr.data;
-  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
-  return TRUE;
-}
-
-static
-boolean jpeg_buffer_empty_output_buffer (j_compress_ptr cinfo)
-{
-  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr*) cinfo->dest;
-  msBufferAppend(dest->buffer, dest->mgr.data, OUTPUT_BUF_SIZE);
-  dest->mgr.pub.next_output_byte = dest->mgr.data;
-  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
-  return TRUE;
-}
-
-static void msJPEGErrorExit(j_common_ptr cinfo)
-{
-    jmp_buf* pJmpBuffer = (jmp_buf* ) cinfo->client_data;
-    char buffer[JMSG_LENGTH_MAX];
-
-    /* Create the message */
-    (*cinfo->err->format_message) (cinfo, buffer);
-
-    msSetError(MS_MISCERR,"libjpeg: %s","jpeg_ErrorExit()", buffer);
-
-    /* Return control to the setjmp point */
-    longjmp(*pJmpBuffer, 1);
-}
-
-int saveAsJPEG(mapObj *map, rasterBufferObj *rb, streamInfo *info,
-               outputFormatObj *format)
-{
-  struct jpeg_compress_struct cinfo;
-  struct jpeg_error_mgr jerr;
-  int quality;
-  const char* pszOptimized;
-  int optimized;
-  int arithmetic;
-  ms_destination_mgr *dest;
-  JSAMPLE *rowdata = NULL;
-  unsigned int row;
-  jmp_buf setjmp_buffer;
-  
-  quality = atoi(msGetOutputFormatOption( format, "QUALITY", "75"));
-  pszOptimized = msGetOutputFormatOption( format, "OPTIMIZED", "YES");
-  optimized = EQUAL(pszOptimized, "YES") || EQUAL(pszOptimized, "ON") ||
-              EQUAL(pszOptimized, "TRUE");
-  arithmetic = EQUAL(pszOptimized, "ARITHMETIC");
-
-  if (setjmp(setjmp_buffer)) 
-  {
-     jpeg_destroy_compress(&cinfo);
-     free(rowdata);
-     return MS_FAILURE;
-  }
-
-  cinfo.err = jpeg_std_error(&jerr);
-  jerr.error_exit = msJPEGErrorExit;
-  cinfo.client_data = (void *) &(setjmp_buffer);
-  jpeg_create_compress(&cinfo);
-
-  if (cinfo.dest == NULL) {
-    if(info->fp) {
-      cinfo.dest = (struct jpeg_destination_mgr *)
-                   (*cinfo.mem->alloc_small) ((j_common_ptr) &cinfo, JPOOL_PERMANENT,
-                                              sizeof (ms_stream_destination_mgr));
-      ((ms_stream_destination_mgr*)cinfo.dest)->mgr.pub.empty_output_buffer = jpeg_stream_empty_output_buffer;
-      ((ms_stream_destination_mgr*)cinfo.dest)->mgr.pub.term_destination = jpeg_stream_term_destination;
-      ((ms_stream_destination_mgr*)cinfo.dest)->stream = info->fp;
-    } else {
-
-      cinfo.dest = (struct jpeg_destination_mgr *)
-                   (*cinfo.mem->alloc_small) ((j_common_ptr) &cinfo, JPOOL_PERMANENT,
-                                              sizeof (ms_buffer_destination_mgr));
-      ((ms_buffer_destination_mgr*)cinfo.dest)->mgr.pub.empty_output_buffer = jpeg_buffer_empty_output_buffer;
-      ((ms_buffer_destination_mgr*)cinfo.dest)->mgr.pub.term_destination = jpeg_buffer_term_destination;
-      ((ms_buffer_destination_mgr*)cinfo.dest)->buffer = info->buffer;
-    }
-  }
-  dest = (ms_destination_mgr*) cinfo.dest;
-  dest->pub.init_destination = jpeg_init_destination;
-
-  cinfo.image_width = rb->width;
-  cinfo.image_height = rb->height;
-  cinfo.input_components = 3;
-  cinfo.in_color_space = JCS_RGB;
-  jpeg_set_defaults(&cinfo);
-  jpeg_set_quality(&cinfo, quality, TRUE);
-  if( arithmetic )
-    cinfo.arith_code = TRUE;
-  else if( optimized )
-    cinfo.optimize_coding = TRUE;
-
-  if( arithmetic || optimized ) {
-    /* libjpeg turbo 1.5.2 honours max_memory_to_use, but has no backing */
-    /* store implementation, so better not set max_memory_to_use ourselves. */
-    /* See https://github.com/libjpeg-turbo/libjpeg-turbo/issues/162 */
-    if( cinfo.mem->max_memory_to_use > 0 ) {
-      if (map == NULL || msGetConfigOption(map, "JPEGMEM") == NULL) {
-        /* If the user doesn't provide a value for JPEGMEM, we want to be sure */
-        /* that at least the image size will be used before creating the temporary file */
-        cinfo.mem->max_memory_to_use =
-          MS_MAX(cinfo.mem->max_memory_to_use, cinfo.input_components * rb->width * rb->height);
-      }
-    }
-  }
-
-  jpeg_start_compress(&cinfo, TRUE);
-  rowdata = (JSAMPLE*)malloc(rb->width*cinfo.input_components*sizeof(JSAMPLE));
-
-  for(row=0; row<rb->height; row++) {
-    JSAMPLE *pixptr = rowdata;
-    unsigned char *r,*g,*b;
-    r=rb->data.rgba.r+row*rb->data.rgba.row_step;
-    g=rb->data.rgba.g+row*rb->data.rgba.row_step;
-    b=rb->data.rgba.b+row*rb->data.rgba.row_step;
-    for(unsigned col=0; col<rb->width; col++) {
-      *(pixptr++) = *r;
-      *(pixptr++) = *g;
-      *(pixptr++) = *b;
-      r+=rb->data.rgba.pixel_step;
-      g+=rb->data.rgba.pixel_step;
-      b+=rb->data.rgba.pixel_step;
-    }
-    (void) jpeg_write_scanlines(&cinfo, &rowdata, 1);
-  }
-
-  /* Step 6: Finish compression */
-
-  jpeg_finish_compress(&cinfo);
-  jpeg_destroy_compress(&cinfo);
-  free(rowdata);
-  return MS_SUCCESS;
-}
-
-/*
- * sort a given list of rgba entries so that all the opaque pixels are at the end
- */
-int remapPaletteForPNG(rasterBufferObj *rb, rgbPixel *rgb, unsigned char *a, int *num_a)
-{
-  int bot_idx, top_idx;
-  unsigned x;
-  int remap[256];
-  unsigned int maxval = rb->data.palette.scaling_maxval;
-
-  assert(rb->type == MS_BUFFER_BYTE_PALETTE);
-
-  /*
-  ** remap the palette colors so that all entries with
-  ** the maximal alpha value (i.e., fully opaque) are at the end and can
-  ** therefore be omitted from the tRNS chunk.  Note that the ordering of
-  ** opaque entries is reversed from how they were previously arranged
-  ** --not that this should matter to anyone.
-  */
-
-  for (top_idx = (int)rb->data.palette.num_entries-1, bot_idx = x = 0;  x < rb->data.palette.num_entries;  ++x) {
-    if (rb->data.palette.palette[x].a == maxval)
-      remap[x] = top_idx--;
-    else
-      remap[x] = bot_idx++;
-  }
-  /* sanity check:  top and bottom indices should have just crossed paths */
-  if (bot_idx != top_idx + 1) {
-    msSetError(MS_MISCERR,"quantization sanity check failed","createPNGPalette()");
-    return MS_FAILURE;
-  }
-
-  *num_a = bot_idx;
-
-  for(x=0; x<rb->width*rb->height; x++)
-    rb->data.palette.pixels[x] = remap[rb->data.palette.pixels[x]];
-
-
-  for (x = 0; x < rb->data.palette.num_entries; ++x) {
-    if(maxval == 255) {
-      a[remap[x]] = rb->data.palette.palette[x].a;
-      rgb[remap[x]].r = rb->data.palette.palette[x].r;
-      rgb[remap[x]].g = rb->data.palette.palette[x].g;
-      rgb[remap[x]].b = rb->data.palette.palette[x].b;
-    } else {
-      /* rescale palette */
-      rgb[remap[x]].r = (rb->data.palette.palette[x].r * 255 + (maxval >> 1)) / maxval;
-      rgb[remap[x]].g = (rb->data.palette.palette[x].g * 255 + (maxval >> 1)) / maxval;
-      rgb[remap[x]].b = (rb->data.palette.palette[x].b * 255 + (maxval >> 1)) / maxval;
-      a[remap[x]] = (rb->data.palette.palette[x].a * 255 + (maxval >> 1)) / maxval;
-    }
-    if(a[remap[x]] != 255) {
-      /* un-premultiply pixels */
-      double da = 255.0/a[remap[x]];
-      rgb[remap[x]].r *=  da;
-      rgb[remap[x]].g *=  da;
-      rgb[remap[x]].b *=  da;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-int savePalettePNG(rasterBufferObj *rb, streamInfo *info, int compression)
-{
-  png_infop info_ptr;
-  rgbPixel rgb[256];
-  unsigned char a[256];
-  int num_a;
-  int sample_depth;
-  png_structp png_ptr = png_create_write_struct(
-                          PNG_LIBPNG_VER_STRING, NULL,NULL,NULL);
-
-  assert(rb->type == MS_BUFFER_BYTE_PALETTE);
-
-  if (!png_ptr)
-    return (MS_FAILURE);
-
-  png_set_compression_level(png_ptr, compression);
-  png_set_filter (png_ptr,0, PNG_FILTER_NONE);
-
-  info_ptr = png_create_info_struct(png_ptr);
-  if (!info_ptr) {
-    png_destroy_write_struct(&png_ptr,
-                             (png_infopp)NULL);
-    return (MS_FAILURE);
-  }
-
-  if (setjmp(png_jmpbuf(png_ptr))) {
-    png_destroy_write_struct(&png_ptr, &info_ptr);
-    return (MS_FAILURE);
-  }
-  if(info->fp)
-    png_set_write_fn(png_ptr,info, png_write_data_to_stream, png_flush_data);
-  else
-    png_set_write_fn(png_ptr,info, png_write_data_to_buffer, png_flush_data);
-
-
-  if (rb->data.palette.num_entries <= 2)
-    sample_depth = 1;
-  else if (rb->data.palette.num_entries <= 4)
-    sample_depth = 2;
-  else if (rb->data.palette.num_entries <= 16)
-    sample_depth = 4;
-  else
-    sample_depth = 8;
-
-  png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height,
-               sample_depth, PNG_COLOR_TYPE_PALETTE,
-               0, PNG_COMPRESSION_TYPE_DEFAULT,
-               PNG_FILTER_TYPE_DEFAULT);
-
-  remapPaletteForPNG(rb,rgb,a,&num_a);
-
-  png_set_PLTE(png_ptr, info_ptr, (png_colorp)(rgb),rb->data.palette.num_entries);
-  if(num_a)
-    png_set_tRNS(png_ptr, info_ptr, a,num_a, NULL);
-
-  png_write_info(png_ptr, info_ptr);
-  png_set_packing(png_ptr);
-
-  for(unsigned row=0; row<rb->height; row++) {
-    unsigned char *rowptr = &(rb->data.palette.pixels[row*rb->width]);
-    png_write_row(png_ptr, rowptr);
-  }
-  png_write_end(png_ptr, info_ptr);
-  png_destroy_write_struct(&png_ptr, &info_ptr);
-  return MS_SUCCESS;
-}
-
-int readPalette(const char *palette, rgbaPixel *entries, unsigned int *nEntries, int useAlpha)
-{
-  FILE *stream = NULL;
-  char buffer[MS_BUFFER_LENGTH];
-  *nEntries = 0;
-
-  stream = fopen(palette, "r");
-  if(!stream) {
-    msSetError(MS_IOERR, "Error opening palette file %s.", "readPalette()", palette);
-    return MS_FAILURE;
-  }
-
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) && *nEntries<256) {
-    int r,g,b,a = 0;
-    /* while there are colors to load */
-    if(buffer[0] == '#' || buffer[0] == '\n' || buffer[0] == '\r')
-      continue; /* skip comments and blank lines */
-    if(!useAlpha) {
-      if(3 != sscanf(buffer,"%d,%d,%d\n",&r,&g,&b)) {
-        fclose(stream);
-        msSetError(MS_MISCERR,"failed to parse color %d r,g,b triplet in line \"%s\" from file %s","readPalette()",*nEntries+1,buffer,palette);
-        return MS_FAILURE;
-      }
-    } else {
-      if(4 != sscanf(buffer,"%d,%d,%d,%d\n",&r,&g,&b,&a)) {
-        fclose(stream);
-        msSetError(MS_MISCERR,"failed to parse color %d r,g,b,a quadruplet in line \"%s\" from file %s","readPalette()",*nEntries+1,buffer,palette);
-        return MS_FAILURE;
-      }
-    }
-    if(useAlpha && a != 255) {
-      double da = a/255.0;
-      entries[*nEntries].r = r * da;
-      entries[*nEntries].g = g * da;
-      entries[*nEntries].b = b * da;
-      entries[*nEntries].a = a;
-    } else {
-      entries[*nEntries].r = r;
-      entries[*nEntries].g = g;
-      entries[*nEntries].b = b;
-      entries[*nEntries].a = 255;
-    }
-    (*nEntries)++;
-  }
-  fclose(stream);
-  return MS_SUCCESS;
-}
-
-int saveAsPNG(mapObj *map,rasterBufferObj *rb, streamInfo *info, outputFormatObj *format)
-{
-  int force_pc256 = MS_FALSE;
-  int force_palette = MS_FALSE;
-
-  const char *force_string,*zlib_compression;
-  int compression = -1;
-
-  zlib_compression = msGetOutputFormatOption( format, "COMPRESSION", NULL);
-  if(zlib_compression && *zlib_compression) {
-    char *endptr;
-    compression = strtol(zlib_compression,&endptr,10);
-    if(*endptr || compression<-1 || compression>9) {
-      msSetError(MS_MISCERR,"failed to parse FORMATOPTION \"COMPRESSION=%s\", expecting integer from 0 to 9.","saveAsPNG()",zlib_compression);
-      return MS_FAILURE;
-    }
-  }
-
-
-  force_string = msGetOutputFormatOption( format, "QUANTIZE_FORCE", NULL );
-  if( force_string && (strcasecmp(force_string,"on") == 0  || strcasecmp(force_string,"yes") == 0 || strcasecmp(force_string,"true") == 0) )
-    force_pc256 = MS_TRUE;
-
-  force_string = msGetOutputFormatOption( format, "PALETTE_FORCE", NULL );
-  if( force_string && (strcasecmp(force_string,"on") == 0  || strcasecmp(force_string,"yes") == 0 || strcasecmp(force_string,"true") == 0) )
-    force_palette = MS_TRUE;
-
-  if(force_pc256 || force_palette) {
-    rasterBufferObj qrb;
-    rgbaPixel palette[256], paletteGiven[256];
-    unsigned int numPaletteGivenEntries;
-    memset(&qrb,0,sizeof(rasterBufferObj));
-    qrb.type = MS_BUFFER_BYTE_PALETTE;
-    qrb.width = rb->width;
-    qrb.height = rb->height;
-    qrb.data.palette.pixels = (unsigned char*)malloc(qrb.width*qrb.height*sizeof(unsigned char));
-    qrb.data.palette.scaling_maxval = 255;
-    int ret;
-    if(force_pc256) {
-      qrb.data.palette.palette = palette;
-      qrb.data.palette.num_entries = atoi(msGetOutputFormatOption( format, "QUANTIZE_COLORS", "256"));
-      ret = msQuantizeRasterBuffer(rb,&(qrb.data.palette.num_entries),qrb.data.palette.palette,
-                                   NULL, 0,
-                                   &qrb.data.palette.scaling_maxval);
-    } else {
-      unsigned colorsWanted = (unsigned)atoi(msGetOutputFormatOption( format, "QUANTIZE_COLORS", "0"));
-      const char *palettePath = msGetOutputFormatOption( format, "PALETTE", "palette.txt");
-      char szPath[MS_MAXPATHLEN];
-      if(map) {
-        msBuildPath(szPath, map->mappath, palettePath);
-        palettePath = szPath;
-      }
-      if(readPalette(palettePath,paletteGiven,&numPaletteGivenEntries,format->transparent) != MS_SUCCESS) {
-        return MS_FAILURE;
-      }
-
-      if(numPaletteGivenEntries == 256 || colorsWanted == 0) {
-        qrb.data.palette.palette = paletteGiven;
-        qrb.data.palette.num_entries = numPaletteGivenEntries;
-        ret = MS_SUCCESS;
-
-        /* we have a full palette and don't want an additional quantization step */
-      } else {
-        /* quantize the image, and mix our colours in the resulting palette */
-        qrb.data.palette.palette = palette;
-        qrb.data.palette.num_entries = MS_MAX(colorsWanted,numPaletteGivenEntries);
-        ret = msQuantizeRasterBuffer(rb,&(qrb.data.palette.num_entries),qrb.data.palette.palette,
-                                     paletteGiven,numPaletteGivenEntries,
-                                     &qrb.data.palette.scaling_maxval);
-      }
-    }
-    if(ret != MS_FAILURE) {
-      msClassifyRasterBuffer(rb,&qrb);
-      ret = savePalettePNG(&qrb,info,compression);
-    }
-    msFree(qrb.data.palette.pixels);
-    return ret;
-  } else if(rb->type == MS_BUFFER_BYTE_RGBA) {
-    png_infop info_ptr;
-    int color_type;
-    unsigned int *rowdata;
-    png_structp png_ptr = png_create_write_struct(
-                            PNG_LIBPNG_VER_STRING, NULL,NULL,NULL);
-
-    if (!png_ptr)
-      return (MS_FAILURE);
-
-    png_set_compression_level(png_ptr, compression);
-    png_set_filter (png_ptr,0, PNG_FILTER_NONE);
-
-    info_ptr = png_create_info_struct(png_ptr);
-    if (!info_ptr) {
-      png_destroy_write_struct(&png_ptr,
-                               (png_infopp)NULL);
-      return (MS_FAILURE);
-    }
-
-    if (setjmp(png_jmpbuf(png_ptr))) {
-      png_destroy_write_struct(&png_ptr, &info_ptr);
-      return (MS_FAILURE);
-    }
-    if(info->fp)
-      png_set_write_fn(png_ptr,info, png_write_data_to_stream, png_flush_data);
-    else
-      png_set_write_fn(png_ptr,info, png_write_data_to_buffer, png_flush_data);
-
-    if(rb->data.rgba.a)
-      color_type = PNG_COLOR_TYPE_RGB_ALPHA;
-    else
-      color_type = PNG_COLOR_TYPE_RGB;
-
-    png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height,
-                 8, color_type, PNG_INTERLACE_NONE,
-                 PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
-
-    png_write_info(png_ptr, info_ptr);
-
-    if(!rb->data.rgba.a && rb->data.rgba.pixel_step==4)
-      png_set_filler(png_ptr, 0, PNG_FILLER_AFTER);
-
-    rowdata = (unsigned int*)malloc(rb->width*sizeof(unsigned int));
-    for(unsigned row=0; row<rb->height; row++) {
-      unsigned int *pixptr = rowdata;
-      unsigned char *a,*r,*g,*b;
-      r=rb->data.rgba.r+row*rb->data.rgba.row_step;
-      g=rb->data.rgba.g+row*rb->data.rgba.row_step;
-      b=rb->data.rgba.b+row*rb->data.rgba.row_step;
-      if(rb->data.rgba.a) {
-        a=rb->data.rgba.a+row*rb->data.rgba.row_step;
-        for(unsigned col=0; col<rb->width; col++) {
-          if(*a) {
-            double da = *a/255.0;
-            unsigned char *pix = (unsigned char*)pixptr;
-            pix[0] = *r/da;
-            pix[1] = *g/da;
-            pix[2] = *b/da;
-            pix[3] = *a;
-          } else {
-            *pixptr=0;
-          }
-          pixptr++;
-          a+=rb->data.rgba.pixel_step;
-          r+=rb->data.rgba.pixel_step;
-          g+=rb->data.rgba.pixel_step;
-          b+=rb->data.rgba.pixel_step;
-        }
-      } else {
-        for(unsigned col=0; col<rb->width; col++) {
-          unsigned char *pix = (unsigned char*)pixptr;
-          pix[0] = *r;
-          pix[1] = *g;
-          pix[2] = *b;
-          pixptr++;
-          r+=rb->data.rgba.pixel_step;
-          g+=rb->data.rgba.pixel_step;
-          b+=rb->data.rgba.pixel_step;
-        }
-      }
-
-      png_write_row(png_ptr,(png_bytep)rowdata);
-
-    }
-    png_write_end(png_ptr, info_ptr);
-    free(rowdata);
-    png_destroy_write_struct(&png_ptr, &info_ptr);
-    return MS_SUCCESS;
-  } else {
-    msSetError(MS_MISCERR,"Unknown buffer type","saveAsPNG()");
-    return MS_FAILURE;
-  }
-}
-
-/* For platforms with incomplete ANSI defines. Fortunately,
-   SEEK_SET is defined to be zero by the standard. */
-
-#ifndef SEEK_SET
-#define SEEK_SET 0
-#endif /* SEEK_SET */
-
-
-int readPNG(char *path, rasterBufferObj *rb)
-{
-  png_uint_32 width,height;
-  unsigned char *a,*r,*g,*b;
-  int bit_depth,color_type;
-  unsigned char **row_pointers;
-  png_structp png_ptr = NULL;
-  png_infop info_ptr = NULL;
-
-  FILE *stream = fopen(path,"rb");
-  if(!stream)
-    return MS_FAILURE;
-
-  /* could pass pointers to user-defined error handlers instead of NULLs: */
-  png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
-  if (!png_ptr) {
-    fclose(stream);
-    return MS_FAILURE;   /* out of memory */
-  }
-
-  info_ptr = png_create_info_struct(png_ptr);
-  if (!info_ptr) {
-    png_destroy_read_struct(&png_ptr, NULL, NULL);
-    fclose(stream);
-    return MS_FAILURE;   /* out of memory */
-  }
-
-  if(setjmp(png_jmpbuf(png_ptr))) {
-    png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
-    fclose(stream);
-    return MS_FAILURE;
-  }
-
-  png_init_io(png_ptr,stream);
-  png_read_info(png_ptr,info_ptr);
-  png_get_IHDR(png_ptr, info_ptr, &width, &height,
-               &bit_depth, &color_type,
-               NULL,NULL,NULL);
-
-  rb->width = width;
-  rb->height = height;
-  rb->type = MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.pixels = (unsigned char*)malloc(width*height*4*sizeof(unsigned char));
-  row_pointers = (unsigned char**)malloc(height*sizeof(unsigned char*));
-  rb->data.rgba.pixel_step=4;
-  rb->data.rgba.row_step = width*4;
-  b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
-  g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
-  r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
-  a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
-
-  for(unsigned i=0; i<height; i++) {
-    row_pointers[i] = &(rb->data.rgba.pixels[i*rb->data.rgba.row_step]);
-  }
-
-  if (color_type == PNG_COLOR_TYPE_PALETTE)
-    /* expand palette images to RGB */
-    png_set_expand(png_ptr);
-  if (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8)
-    /* expand low bit-depth grayscale to 8bits */
-    png_set_expand(png_ptr);
-  if (png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS))
-    /* expand transparency chunks to full alpha */
-    png_set_expand(png_ptr);
-  if (bit_depth == 16)
-    /* scale 16bits down to 8 */
-    png_set_strip_16(png_ptr);
-  if (color_type == PNG_COLOR_TYPE_GRAY ||
-      color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
-    /* convert grayscale to rgba */
-    png_set_gray_to_rgb(png_ptr);
-
-  png_set_bgr(png_ptr);
-  if (color_type == PNG_COLOR_TYPE_RGB || color_type == PNG_COLOR_TYPE_GRAY ||
-      color_type == PNG_COLOR_TYPE_PALETTE)
-    png_set_add_alpha(png_ptr, 0xff, PNG_FILLER_AFTER);
-
-  png_read_update_info(png_ptr, info_ptr);
-  assert(png_get_rowbytes(png_ptr, info_ptr) == rb->data.rgba.row_step);
-
-  png_read_image(png_ptr, row_pointers);
-  free(row_pointers);
-  row_pointers=NULL;
-  png_read_end(png_ptr,NULL);
-  png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
-
-  /*premultiply data*/
-  for(unsigned i=0; i<width*height; i++) {
-    if(*a < 255) {
-      if(*a == 0) {
-        *r=*g=*b=0;
-      } else {
-        *r = (*r * *a + 255) >> 8;
-        *g = (*g * *a + 255) >> 8;
-        *b = (*b * *a + 255) >> 8;
-      }
-    }
-    a+=4;
-    b+=4;
-    g+=4;
-    r+=4;
-  }
-
-  fclose(stream);
-  return MS_SUCCESS;
-
-}
-
-int msSaveRasterBuffer(mapObj *map, rasterBufferObj *rb, FILE *stream,
-                       outputFormatObj *format)
-{
-  if(strcasestr(format->driver,"/png")) {
-    streamInfo info;
-    info.fp = stream;
-    info.buffer = NULL;
-
-    return saveAsPNG(map, rb,&info,format);
-  } else if(strcasestr(format->driver,"/jpeg")) {
-    streamInfo info;
-    info.fp = stream;
-    info.buffer=NULL;
-    
-    return saveAsJPEG(map, rb,&info,format);
-  } else {
-    msSetError(MS_MISCERR,"unsupported image format\n", "msSaveRasterBuffer()");
-    return MS_FAILURE;
-  }
-}
-
-int msSaveRasterBufferToBuffer(rasterBufferObj *data, bufferObj *buffer,
-                               outputFormatObj *format)
-{
-  if(strcasestr(format->driver,"/png")) {
-    streamInfo info;
-    info.fp = NULL;
-    info.buffer = buffer;
-    return saveAsPNG(NULL, data,&info,format);
-  } else if(strcasestr(format->driver,"/jpeg")) {
-    streamInfo info;
-    info.fp = NULL;
-    info.buffer=buffer;
-    return saveAsJPEG(NULL, data,&info,format);
-  } else {
-    msSetError(MS_MISCERR,"unsupported image format\n", "msSaveRasterBuffer()");
-    return MS_FAILURE;
-  }
-}
-
-#ifdef USE_GIF
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-static char const *gif_error_msg(int code)
-#else
-static char const *gif_error_msg()
-#endif
-{
-  static char msg[80];
-
-#if (!defined GIFLIB_MAJOR) || (GIFLIB_MAJOR < 5)
-  int code = GifLastError();
-#endif
-  switch (code) {
-    case E_GIF_ERR_OPEN_FAILED: /* should not see this */
-      return "Failed to open given file";
-
-    case E_GIF_ERR_WRITE_FAILED:
-      return "Write failed";
-
-    case E_GIF_ERR_HAS_SCRN_DSCR: /* should not see this */
-      return "Screen descriptor already passed to giflib";
-
-    case E_GIF_ERR_HAS_IMAG_DSCR: /* should not see this */
-      return "Image descriptor already passed to giflib";
-
-    case E_GIF_ERR_NO_COLOR_MAP: /* should not see this */
-      return "Neither global nor local color map set";
-
-    case E_GIF_ERR_DATA_TOO_BIG: /* should not see this */
-      return "Too much pixel data passed to giflib";
-
-    case E_GIF_ERR_NOT_ENOUGH_MEM:
-      return "Out of memory";
-
-    case E_GIF_ERR_DISK_IS_FULL:
-      return "Disk is full";
-
-    case E_GIF_ERR_CLOSE_FAILED: /* should not see this */
-      return "File close failed";
-
-    case E_GIF_ERR_NOT_WRITEABLE: /* should not see this */
-      return "File not writable";
-
-    case D_GIF_ERR_OPEN_FAILED:
-      return "Failed to open file";
-
-    case D_GIF_ERR_READ_FAILED:
-      return "Failed to read from file";
-
-    case D_GIF_ERR_NOT_GIF_FILE:
-      return "File is not a GIF file";
-
-    case D_GIF_ERR_NO_SCRN_DSCR:
-      return "No screen descriptor detected - invalid file";
-
-    case D_GIF_ERR_NO_IMAG_DSCR:
-      return "No image descriptor detected - invalid file";
-
-    case D_GIF_ERR_NO_COLOR_MAP:
-      return "No global or local color map found";
-
-    case D_GIF_ERR_WRONG_RECORD:
-      return "Wrong record type detected - invalid file?";
-
-    case D_GIF_ERR_DATA_TOO_BIG:
-      return "Data in file too big for image";
-
-    case D_GIF_ERR_NOT_ENOUGH_MEM:
-      return "Out of memory";
-
-    case D_GIF_ERR_CLOSE_FAILED:
-      return "Close failed";
-
-    case D_GIF_ERR_NOT_READABLE:
-      return "File not opened for read";
-
-    case D_GIF_ERR_IMAGE_DEFECT:
-      return "Defective image";
-
-    case D_GIF_ERR_EOF_TOO_SOON:
-      return "Unexpected EOF - invalid file";
-
-    default:
-      sprintf(msg, "Unknown giflib error code %d", code);
-      return msg;
-  }
-}
-
-
-/* not fully implemented and tested */
-/* missing: set the first pointer to a,r,g,b */
-int readGIF(char *path, rasterBufferObj *rb)
-{
-  int codeSize, extCode, firstImageRead = MS_FALSE;
-  unsigned char *r,*g,*b,*a;
-  int transIdx = -1;
-  GifFileType *image;
-  GifPixelType *line;
-  GifRecordType recordType;
-  GifByteType *codeBlock, *extension;
-  ColorMapObject *cmap;
-  int interlacedOffsets[] = {0,4,2,1};
-  int interlacedJumps[] = {8,8,4,2};
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-  int errcode;
-#endif
-
-
-  rb->type = MS_BUFFER_BYTE_RGBA;
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-  image =  DGifOpenFileName(path, &errcode);
-  if (image == NULL) {
-    msSetError(MS_MISCERR,"failed to load gif image: %s","readGIF()", gif_error_msg(errcode));
-    return MS_FAILURE;
-  }
-#else
-  image =  DGifOpenFileName(path);
-  if (image == NULL) {
-    msSetError(MS_MISCERR,"failed to load gif image: %s","readGIF()", gif_error_msg());
-    return MS_FAILURE;
-  }
-#endif
-  rb->width = image->SWidth;
-  rb->height = image->SHeight;
-  rb->data.rgba.row_step = rb->width * 4;
-  rb->data.rgba.pixel_step = 4;
-  rb->data.rgba.pixels = (unsigned char*)malloc(rb->width*rb->height*4*sizeof(unsigned char));
-  b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
-  g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
-  r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
-  a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
-
-  cmap = (image->Image.ColorMap)?image->Image.ColorMap:image->SColorMap;
-  for(unsigned i=0; i<rb->width*rb->height; i++) {
-    *a = 255;
-    *r = cmap->Colors[image->SBackGroundColor].Red;
-    *g = cmap->Colors[image->SBackGroundColor].Green;
-    *b = cmap->Colors[image->SBackGroundColor].Blue;
-    a+=rb->data.rgba.pixel_step;
-    r+=rb->data.rgba.pixel_step;
-    g+=rb->data.rgba.pixel_step;
-    b+=rb->data.rgba.pixel_step;
-  }
-
-  do {
-    if (DGifGetRecordType(image, &recordType) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-      msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
-#else
-      msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
-#endif
-      return MS_FAILURE;
-    }
-
-    switch (recordType) {
-      case SCREEN_DESC_RECORD_TYPE:
-        DGifGetScreenDesc(image);
-        break;
-      case IMAGE_DESC_RECORD_TYPE:
-        if (DGifGetImageDesc(image) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
-#else
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
-#endif
-          return MS_FAILURE;
-        }
-        if (!firstImageRead) {
-
-          unsigned row = image->Image.Top;
-          unsigned col = image->Image.Left;
-          unsigned width = image->Image.Width;
-          unsigned height = image->Image.Height;
-
-          /* sanity check: */
-          if(col+width>rb->width || row+height>rb->height) {
-            msSetError(MS_MISCERR,"corrupted gif image, img size exceeds screen size","readGIF()");
-            return MS_FAILURE;
-          }
-
-          line = (GifPixelType *) malloc(width * sizeof(GifPixelType));
-          if(image->Image.Interlace) {
-            int count;
-            for(count=0; count<4; count++) {
-              for(unsigned i=row+interlacedOffsets[count]; i<row+height; i+=interlacedJumps[count]) {
-                int offset = i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
-                a = rb->data.rgba.a + offset;
-                r = rb->data.rgba.r + offset;
-                g = rb->data.rgba.g + offset;
-                b = rb->data.rgba.b + offset;
-                if (DGifGetLine(image, line, width) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-                  msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg(image->Error));
-#else
-                  msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg());
-#endif
-                  return MS_FAILURE;
-                }
-
-                for(unsigned j=0; j<width; j++) {
-                  GifPixelType pix = line[j];
-                  if(transIdx == -1 || pix != transIdx) {
-                    *a = 255;
-                    *r = cmap->Colors[pix].Red;
-                    *g = cmap->Colors[pix].Green;
-                    *b = cmap->Colors[pix].Blue;
-                  } else {
-                    *a = *r = *g = *b = 0;
-                  }
-                  a+=rb->data.rgba.pixel_step;
-                  r+=rb->data.rgba.pixel_step;
-                  g+=rb->data.rgba.pixel_step;
-                  b+=rb->data.rgba.pixel_step;
-                }
-              }
-            }
-          } else {
-            for (unsigned i = 0; i < height; i++) {
-              int offset = i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
-              a = rb->data.rgba.a + offset;
-              r = rb->data.rgba.r + offset;
-              g = rb->data.rgba.g + offset;
-              b = rb->data.rgba.b + offset;
-              if (DGifGetLine(image, line, width) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-                msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg(image->Error));
-#else
-                msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg());
-#endif
-                return MS_FAILURE;
-              }
-              for(unsigned j=0; j<width; j++) {
-                GifPixelType pix = line[j];
-                if(transIdx == -1 || pix != transIdx) {
-                  *a = 255;
-                  *r = cmap->Colors[pix].Red;
-                  *g = cmap->Colors[pix].Green;
-                  *b = cmap->Colors[pix].Blue;
-                } else {
-                  *a = *r = *g = *b = 0;
-                }
-                a+=rb->data.rgba.pixel_step;
-                r+=rb->data.rgba.pixel_step;
-                g+=rb->data.rgba.pixel_step;
-                b+=rb->data.rgba.pixel_step;
-              }
-            }
-          }
-          free((char *) line);
-          firstImageRead = MS_TRUE;
-        } else {
-          /* Skip all next images */
-          if (DGifGetCode(image, &codeSize, &codeBlock) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
-#else
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
-#endif
-            return MS_FAILURE;
-          }
-          while (codeBlock != NULL) {
-            if (DGifGetCodeNext(image, &codeBlock) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-              msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
-#else
-              msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
-#endif
-              return MS_FAILURE;
-            }
-          }
-        }
-        break;
-      case EXTENSION_RECORD_TYPE:
-        /* skip all extension blocks */
-        if (DGifGetExtension(image, &extCode, &extension) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
-#else
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
-#endif
-          return MS_FAILURE;
-        }
-        if(extCode == 249 && (extension[1] & 1))
-          transIdx = extension[4];
-        for (;;) {
-          if (DGifGetExtensionNext(image, &extension) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
-#else
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
-#endif
-            return MS_FAILURE;
-          }
-          if (extension == NULL)
-            break;
-          if(extension[1] & 1)
-            transIdx = extension[4];
-        }
-        break;
-      case UNDEFINED_RECORD_TYPE:
-        break;
-      case TERMINATE_RECORD_TYPE:
-        break;
-      default:
-        break;
-    }
-
-  } while (recordType != TERMINATE_RECORD_TYPE);
-
-
-#if defined GIFLIB_MAJOR && GIFLIB_MINOR && ((GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1) || (GIFLIB_MAJOR > 5))
-  if (DGifCloseFile(image, &errcode) == GIF_ERROR) {
-    msSetError(MS_MISCERR,"failed to close gif after loading: %s","readGIF()", gif_error_msg(errcode));
-    return MS_FAILURE;
-  }
-#else
-  if (DGifCloseFile(image) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-    msSetError(MS_MISCERR,"failed to close gif after loading: %s","readGIF()", gif_error_msg(image->Error));
-#else
-    msSetError(MS_MISCERR,"failed to close gif after loading: %s","readGIF()", gif_error_msg());
-#endif
-    return MS_FAILURE;
-  }
-#endif
-
-  return MS_SUCCESS;
-}
-#endif
-
-int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb)
-{
-  FILE *stream;
-  unsigned char signature[8];
-  int ret = MS_FAILURE;
-  stream = fopen(path,"rb");
-  if(!stream) {
-    msSetError(MS_MISCERR, "unable to open file %s for reading", "msLoadMSRasterBufferFromFile()", path);
-    return MS_FAILURE;
-  }
-  if(1 != fread(signature,8,1,stream)) {
-    fclose(stream);
-    msSetError(MS_MISCERR, "Unable to read header from image file %s", "msLoadMSRasterBufferFromFile()",path);
-    return MS_FAILURE;
-  }
-  fclose(stream);
-  if(png_sig_cmp(signature,0,8) == 0) {
-    ret = readPNG(path,rb);
-  } else if (!strncmp((char*)signature,"GIF",3)) {
-#ifdef USE_GIF
-    ret = readGIF(path,rb);
-#else
-    msSetError(MS_MISCERR,"pixmap %s seems to be GIF formatted, but this server is compiled without GIF support","readImage()",path);
-    return MS_FAILURE;
-#endif
-  } else {
-    msSetError(MS_MISCERR,"unsupported pixmap format","readImage()");
-    return MS_FAILURE;
-  }
-  return ret;
-}
diff -pruN 8.0.1-5/mapimagemap.c 8.2.0~beta1-1~exp1/mapimagemap.c
--- 8.0.1-5/mapimagemap.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapimagemap.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,717 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implements imagemap outputformat support.
- * Author:   Attila Csipa
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "dxfcolor.h"
-
-#include <stdarg.h>
-#include <time.h>
-
-#ifdef _WIN32
-#include <fcntl.h>
-#include <io.h>
-#endif
-
-
-
-#define MYDEBUG 0
-#define DEBUG_IF if (MYDEBUG > 2)
-
-/*
- * Client-side imagemap support was originally written by
- * Attila Csipa (http://prometheus.org.yu/me.php).  C. Scott Ananian
- * (http://cscott.net) cleaned up the code somewhat and made it more flexible:
- * you can now customize the generated HREFs and create mouseover and
- * mouseout attributes.
- *
- * Use
- *   IMAGETYPE imagemap
- * to select this driver.
- *
- * The following FORMATOPTIONs are available. If any are set to the empty
- * string the associated attribute will be suppressed.
- *   POLYHREF   the href string to use for the <area> elements.
- *              use a %s to interpolate the area title.
- *              default:   "javascript:Clicked('%s');"
- *   POLYMOUSEOVER the onMouseOver string to use for the <area> elements.
- *              use a %s to interpolate the area title.
- *              default:   "" (ie the attribute is suppressed)
- *   POLYMOUSEOUT the onMouseOut string to use for the <area> elements.
- *              use a %s to interpolate the area title.
- *              default:   "" (ie the attribute is suppressed)
- *   SYMBOLMOUSEOVER and SYMBOLMOUSEOUT are equivalent properties for
- *              <area> tags representing symbols, with the same defaults.
- *   MAPNAME    the string which will be used in the name attribute
- *              of the <map> tag.  There is no %s interpolation.
- *              default: "map1"
- *   SUPPRESS   if "yes", then we will suppress area declarations with
- *              no title.
- *              default: "NO"
- *
- * For example, http://vevo.verifiedvoting.org/verifier contains this
- * .map file fragment:
- *         OUTPUTFORMAT
- *              NAME imagemap
- *              DRIVER imagemap
- *              FORMATOPTION "POLYHREF=/verifier/map.php?state=%s"
- *              FORMATOPTION "SYMBOLHREF=#"
- *              FORMATOPTION "SUPPRESS=YES"
- *              FORMATOPTION "MAPNAME=map-48"
- *              FORMATOPTION "POLYMOUSEOUT=return nd();"
- *              FORMATOPTION "POLYMOUSEOVER=return overlib('%s');"
- *         END
- */
-
-/*-------------------------------------------------------------------------*/
-
-/* A pString is a variable-length (appendable) string, stored as a triple:
- * character pointer, allocated length, and used length.  The one wrinkle
- * is that we use pointers to the allocated size and character pointer,
- * in order to support refering to fields declared elsewhere (ie in the
- * 'image' data structure) for these.  The 'iprintf' function appends
- * to a pString. */
-typedef struct pString {
-  /* these two fields are somewhere else */
-  char **string;
-  int *alloc_size;
-  /* this field is stored locally. */
-  int string_len;
-} pString;
-/* These are the pStrings we declare statically.  One is the 'output'
- * imagemap/dxf file; parts of this live in another data structure and
- * are only referenced indirectly here.  The other contains layer-specific
- * information for the dxf output. */
-static char *layerlist=NULL;
-static int layersize=0;
-static pString imgStr, layerStr= { &layerlist, &layersize, 0 };
-
-/* Format strings for the various bits of a client-side imagemap. */
-static const char *polyHrefFmt, *polyMOverFmt, *polyMOutFmt;
-static const char *symbolHrefFmt, *symbolMOverFmt, *symbolMOutFmt;
-static const char *mapName;
-/* Should we suppress AREA declarations in imagemaps with no title? */
-static int suppressEmpty=0;
-
-/* Prevent buffer-overrun and format-string attacks by "sanitizing" any
- * provided format string to fit the number of expected string arguments
- * (MAX) exactly. */
-static const char *makeFmtSafe(const char *fmt, int MAX)
-{
-  /* format string should have exactly 'MAX' %s */
-
-  char *result = msSmallMalloc(strlen(fmt)+1+3*MAX), *cp;
-  int numstr=0, saw_percent=0;
-
-  strcpy(result, fmt);
-  for (cp=result; *cp; cp++) {
-    if (saw_percent) {
-      if (*cp=='%') {
-        /* safe */
-      } else if (*cp=='s' && numstr<MAX) {
-        numstr++; /* still safe */
-      } else {
-        /* disable this unsafe format string! */
-        *(cp-1)=' ';
-      }
-      saw_percent=0;
-    } else if (*cp=='%')
-      saw_percent=1;
-  }
-  /* fixup format strings without enough %s in them */
-  while (numstr<MAX) {
-    strcpy(cp, "%.s"); /* print using zero-length precision */
-    cp+=3;
-    numstr++;
-  }
-  return result;
-}
-
-/* Append the given printf-style formatted string to the pString 'ps'.
- * This is much cleaner (and faster) than the technique this file
- * used to use! */
-static void im_iprintf(pString *ps, const char *fmt, ...)
-{
-  int n, remaining;
-  va_list ap;
-  do {
-    remaining = *(ps->alloc_size) - ps->string_len;
-    va_start(ap, fmt);
-#if defined(HAVE_VSNPRINTF)
-    n = vsnprintf((*(ps->string)) + ps->string_len,
-                  remaining, fmt, ap);
-#else
-    /* If vsnprintf() is not available then require a minimum
-     * of 512 bytes of free space to prevent a buffer overflow
-     * This is not fully bulletproof but should help, see bug 1613
-     */
-    if (remaining < 512)
-      n = -1;
-    else
-      n = vsprintf((*(ps->string)) + ps->string_len, fmt, ap);
-#endif
-    va_end(ap);
-    /* if that worked, we're done! */
-    if (-1<n && n<remaining) {
-      ps->string_len += n;
-      return;
-    } else { /* double allocated string size */
-      *(ps->alloc_size) *= 2;/* these keeps realloc linear.*/
-      if (*(ps->alloc_size) < 1024)
-        /* careful: initial size can be 0 */
-        *(ps->alloc_size)=1024;
-      if (n>-1 && *(ps->alloc_size) <= (n + ps->string_len))
-        /* ensure at least as much as what is needed */
-        *(ps->alloc_size) = n+ps->string_len+1;
-      *(ps->string) = (char *) msSmallRealloc
-                      (*(ps->string), *(ps->alloc_size));
-      /* if realloc doesn't work, we're screwed! */
-    }
-  } while (1); /* go back and try again. */
-}
-
-
-
-static int lastcolor=-1;
-static int matchdxfcolor(colorObj col)
-{
-  int best=7;
-  int delta=128*255;
-  int tcolor = 0;
-  if (lastcolor != -1)
-    return lastcolor;
-  while (tcolor < 256 && (ctable[tcolor].r != col.red || ctable[tcolor].g != col.green || ctable[tcolor].b != col.blue)) {
-    const int dr = ctable[tcolor].r - col.red;
-    const int dg = ctable[tcolor].g - col.green;
-    const int db = ctable[tcolor].b - col.blue;
-    const int newdelta = dr * dr + dg * dg + db * db;
-    if (newdelta < delta) {
-      best = tcolor;
-      delta = newdelta;
-    }
-    tcolor++;
-  }
-  if (tcolor >= 256) tcolor = best;
-  /* DEBUG_IF printf("%d/%d/%d (%d/%d - %d), %d : %d/%d/%d<BR>\n", ctable[tcolor].r, ctable[tcolor].g, ctable[tcolor].b, tcolor, best, delta, lastcolor, col.red, col.green, col.blue); */
-  lastcolor = tcolor;
-  return tcolor;
-}
-
-static char* lname;
-static int dxf;
-
-void msImageStartLayerIM(mapObj *map, layerObj *layer, imageObj *image)
-{
-  (void)map;
-  (void)image;
-  DEBUG_IF printf("ImageStartLayerIM\n<BR>");
-  free(lname);
-  if (layer->name)
-    lname = msStrdup(layer->name);
-  else
-    lname = msStrdup("NONE");
-  if (dxf == 2) {
-    im_iprintf(&layerStr, "LAYER\n%s\n", lname);
-  } else if (dxf) {
-    im_iprintf(&layerStr,
-               "  0\nLAYER\n  2\n%s\n"
-               " 70\n  64\n 6\nCONTINUOUS\n", lname);
-  }
-  lastcolor = -1;
-}
-
-/*
- * Utility function to create a IM image. Returns
- * a pointer to an imageObj structure.
- */
-imageObj *msImageCreateIM(int width, int height, outputFormatObj *format,
-                          char *imagepath, char *imageurl, double resolution, double defresolution)
-{
-  imageObj  *image=NULL;
-  if (setvbuf(stdout, NULL, _IONBF , 0)) {
-    printf("Whoops...");
-  };
-  DEBUG_IF printf("msImageCreateIM<BR>\n");
-  if (width > 0 && height > 0) {
-    image = (imageObj *)msSmallCalloc(1,sizeof(imageObj));
-    imgStr.string = &(image->img.imagemap);
-    imgStr.alloc_size = &(image->size);
-
-    image->format = format;
-    format->refcount++;
-
-    image->width = width;
-    image->height = height;
-    image->imagepath = NULL;
-    image->imageurl = NULL;
-    image->resolution = resolution;
-    image->resolutionfactor = resolution/defresolution;
-
-    if( strcasecmp("ON",msGetOutputFormatOption( format, "DXF", "OFF" )) == 0) {
-      dxf = 1;
-      im_iprintf(&layerStr, "  2\nLAYER\n 70\n  10\n");
-    } else
-      dxf = 0;
-
-    if( strcasecmp("ON",msGetOutputFormatOption( format, "SCRIPT", "OFF" )) == 0) {
-      dxf = 2;
-      im_iprintf(&layerStr, "");
-    }
-
-    /* get href formation string options */
-    polyHrefFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "POLYHREF", "javascript:Clicked('%s');"), 1);
-    polyMOverFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "POLYMOUSEOVER", ""), 1);
-    polyMOutFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "POLYMOUSEOUT", ""), 1);
-    symbolHrefFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "SYMBOLHREF", "javascript:SymbolClicked();"), 1);
-    symbolMOverFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "SYMBOLMOUSEOVER", ""), 1);
-    symbolMOutFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "SYMBOLMOUSEOUT", ""), 1);
-    /* get name of client-side image map */
-    mapName = msGetOutputFormatOption
-      ( format, "MAPNAME", "map1" );
-    /* should we suppress area declarations with no title? */
-    if( strcasecmp("YES",msGetOutputFormatOption( format, "SUPPRESS", "NO" )) == 0) {
-      suppressEmpty=1;
-    }
-
-    lname = msStrdup("NONE");
-    *(imgStr.string) = msStrdup("");
-    if (*(imgStr.string)) {
-      *(imgStr.alloc_size) =
-        imgStr.string_len = strlen(*(imgStr.string));
-    } else {
-      *(imgStr.alloc_size) =
-        imgStr.string_len = 0;
-    }
-    if (imagepath) {
-      image->imagepath = msStrdup(imagepath);
-    }
-    if (imageurl) {
-      image->imageurl = msStrdup(imageurl);
-    }
-
-    return image;
-  } else {
-    msSetError(MS_IMGERR,
-               "Cannot create IM image of size %d x %d.",
-               "msImageCreateIM()", width, height );
-  }
-  return image;
-}
-
-/* ------------------------------------------------------------------------- */
-/* Draw a single marker symbol of the specified size and color               */
-/* ------------------------------------------------------------------------- */
-void msDrawMarkerSymbolIM(mapObj *map, imageObj* img, pointObj *p, styleObj *style, double scalefactor)
-{
-  symbolObj *symbol;
-  int ox, oy;
-  double size;
-
-  DEBUG_IF printf("msDrawMarkerSymbolIM\n<BR>");
-
-  /* skip this, we don't do text */
-
-
-
-  if(!p) return;
-
-
-  if(style->symbol > map->symbolset.numsymbols || style->symbol < 0) return; /* no such symbol, 0 is OK */
-  symbol = map->symbolset.symbol[style->symbol];
-  ox = style->offsetx*scalefactor;
-  oy = style->offsety*scalefactor;
-  if(style->size == -1) {
-    size = msSymbolGetDefaultSize( symbol );
-    size = MS_NINT(size*scalefactor);
-  } else
-    size = MS_NINT(style->size*scalefactor);
-  size = MS_MAX(size, style->minsize*img->resolutionfactor);
-  size = MS_MIN(size, style->maxsize*img->resolutionfactor);
-
-  if(size < 1) return; /* size too small */
-
-  /* DEBUG_IF printf(".%d.%d.%d.", symbol->type, style->symbol, fc); */
-  if(style->symbol == 0) { /* simply draw a single pixel of the specified color */
-
-    if (dxf) {
-      if (dxf==2)
-        im_iprintf (&imgStr, "POINT\n%.0f %.0f\n%d\n",
-                    p->x + ox, p->y + oy, matchdxfcolor(style->color));
-      else
-        im_iprintf (&imgStr,
-                    "  0\nPOINT\n 10\n%f\n 20\n%f\n 30\n0.0\n"
-                    " 62\n%6d\n  8\n%s\n",
-                    p->x + ox, p->y + oy, matchdxfcolor(style->color), lname);
-    } else {
-      im_iprintf (&imgStr, "<area ");
-      if (strcmp(symbolHrefFmt,"%.s")!=0) {
-        im_iprintf (&imgStr, "href=\"");
-        im_iprintf (&imgStr, symbolHrefFmt, lname);
-        im_iprintf (&imgStr, "\" ");
-      }
-      if (strcmp(symbolMOverFmt,"%.s")!=0) {
-        im_iprintf (&imgStr, "onMouseOver=\"");
-        im_iprintf (&imgStr, symbolMOverFmt, lname);
-        im_iprintf (&imgStr, "\" ");
-      }
-      if (strcmp(symbolMOutFmt,"%.s")!=0) {
-        im_iprintf (&imgStr, "onMouseOut=\"");
-        im_iprintf (&imgStr, symbolMOutFmt, lname);
-        im_iprintf (&imgStr, "\" ");
-      }
-      im_iprintf (&imgStr, "shape=\"circle\" coords=\"%.0f,%.0f, 3\" />\n",
-                  p->x + ox, p->y + oy);
-    }
-
-    /* point2 = &( p->line[j].point[i] ); */
-    /* if(point1->y == point2->y) {} */
-    return;
-  }
-  DEBUG_IF printf("A");
-  switch(symbol->type) {
-    case(MS_SYMBOL_TRUETYPE):
-      DEBUG_IF printf("T");
-      break;
-    case(MS_SYMBOL_PIXMAP):
-      DEBUG_IF printf("P");
-      break;
-    case(MS_SYMBOL_VECTOR):
-      DEBUG_IF printf("V");
-      {
-        double d, offset_x, offset_y;
-
-        d = size/symbol->sizey;
-        offset_x = MS_NINT(p->x - d*.5*symbol->sizex + ox);
-        offset_y = MS_NINT(p->y - d*.5*symbol->sizey + oy);
-
-        /* For now I only render filled vector symbols in imagemap, and no */
-        /* dxf support available yet.  */
-        if(symbol->filled && !dxf /* && fc >= 0 */ ) {
-          /* char *title=(p->numvalues) ? p->values[0] : ""; */
-          char *title = "";
-          int  j;
-
-          im_iprintf (&imgStr, "<area ");
-          if (strcmp(symbolHrefFmt,"%.s")!=0) {
-            im_iprintf (&imgStr, "href=\"");
-            im_iprintf (&imgStr, symbolHrefFmt, lname);
-            im_iprintf (&imgStr, "\" ");
-          }
-          if (strcmp(symbolMOverFmt,"%.s")!=0) {
-            im_iprintf (&imgStr, "onMouseOver=\"");
-            im_iprintf (&imgStr, symbolMOverFmt, lname);
-            im_iprintf (&imgStr, "\" ");
-          }
-          if (strcmp(symbolMOutFmt,"%.s")!=0) {
-            im_iprintf (&imgStr, "onMouseOut=\"");
-            im_iprintf (&imgStr, symbolMOutFmt, lname);
-            im_iprintf (&imgStr, "\" ");
-          }
-
-          im_iprintf (&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
-
-          for(j=0; j < symbol->numpoints; j++) {
-            im_iprintf (&imgStr, "%s %d,%d", j == 0 ? "": ",",
-                        (int)MS_NINT(d*symbol->points[j].x + offset_x),
-                        (int)MS_NINT(d*symbol->points[j].y + offset_y) );
-          }
-          im_iprintf (&imgStr, "\" />\n");
-        } /* end of imagemap, filled case. */
-      }
-      break;
-
-    default:
-      DEBUG_IF printf("DEF");
-      break;
-  } /* end switch statement */
-
-  return;
-}
-
-/* ------------------------------------------------------------------------- */
-/* Draw a line symbol of the specified size and color                        */
-/* ------------------------------------------------------------------------- */
-void msDrawLineSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor_ignored)
-{
-  (void)img;
-  (void)scalefactor_ignored;
-  symbolObj *symbol;
-  int i,j,l;
-  char first = 1;
-  DEBUG_IF printf("msDrawLineSymbolIM<BR>\n");
-
-
-  if(!p) return;
-  if(p->numlines <= 0) return;
-
-  if(style->symbol > map->symbolset.numsymbols || style->symbol < 0) return; /* no such symbol, 0 is OK */
-  symbol = map->symbolset.symbol[style->symbol];
-
-  if (suppressEmpty && p->numvalues==0) return;/* suppress area with empty title */
-  if(style->symbol == 0) { /* just draw a single width line */
-    for(l=0,j=0; j<p->numlines; j++) {
-      if (dxf == 2) {
-        im_iprintf (&imgStr, "LINE\n%d\n", matchdxfcolor(style->color));
-      } else if (dxf) {
-        im_iprintf (&imgStr, "  0\nPOLYLINE\n 70\n     0\n 62\n%6d\n  8\n%s\n", matchdxfcolor(style->color), lname);
-      } else {
-        char *title;
-
-        first = 1;
-        title=(p->numvalues) ? p->values[0] : "";
-        im_iprintf (&imgStr, "<area ");
-        if (strcmp(polyHrefFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "href=\"");
-          im_iprintf (&imgStr, polyHrefFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOverFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOver=\"");
-          im_iprintf (&imgStr, polyMOverFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOutFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOut=\"");
-          im_iprintf (&imgStr, polyMOutFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        im_iprintf (&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
-      }
-      /* point1 = &( p->line[j].point[p->line[j].numpoints-1] ); */
-      for(i=0; i < p->line[j].numpoints; i++,l++) {
-        if (dxf == 2) {
-          im_iprintf (&imgStr, "%.0f %.0f\n", p->line[j].point[i].x, p->line[j].point[i].y);
-        } else if (dxf) {
-          im_iprintf (&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n", p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
-        } else {
-          im_iprintf (&imgStr, "%s %.0f,%.0f", first ? "": ",", p->line[j].point[i].x, p->line[j].point[i].y);
-        }
-        first = 0;
-
-        /* point2 = &( p->line[j].point[i] ); */
-        /* if(point1->y == point2->y) {} */
-      }
-      im_iprintf (&imgStr, dxf ? (dxf == 2 ? "": "  0\nSEQEND\n") : "\" />\n");
-    }
-
-    /* DEBUG_IF printf ("%d, ",strlen(img->img.imagemap) ); */
-    return;
-  }
-
-  DEBUG_IF printf("-%d-",symbol->type);
-
-  return;
-}
-
-
-/* ------------------------------------------------------------------------- */
-/* Draw a shade symbol of the specified size and color                       */
-/* ------------------------------------------------------------------------- */
-void msDrawShadeSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor_ignored)
-{
-  (void)img;
-  (void)scalefactor_ignored;
-  symbolObj *symbol;
-  int i,j,l;
-  char first = 1;
-
-  DEBUG_IF printf("msDrawShadeSymbolIM\n<BR>");
-  if(!p) return;
-  if(p->numlines <= 0) return;
-
-  symbol = map->symbolset.symbol[style->symbol];
-
-  if (suppressEmpty && p->numvalues==0) return;/* suppress area with empty title */
-  if(style->symbol == 0) { /* simply draw a single pixel of the specified color //     */
-    for(l=0,j=0; j<p->numlines; j++) {
-      if (dxf == 2) {
-        im_iprintf (&imgStr, "POLY\n%d\n", matchdxfcolor(style->color));
-      } else if (dxf) {
-        im_iprintf (&imgStr, "  0\nPOLYLINE\n 73\n     1\n 62\n%6d\n  8\n%s\n", matchdxfcolor(style->color), lname);
-      } else {
-        char *title=(p->numvalues) ? p->values[0] : "";
-        first = 1;
-        im_iprintf (&imgStr, "<area ");
-        if (strcmp(polyHrefFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "href=\"");
-          im_iprintf (&imgStr, polyHrefFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOverFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOver=\"");
-          im_iprintf (&imgStr, polyMOverFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOutFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOut=\"");
-          im_iprintf (&imgStr, polyMOutFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        im_iprintf (&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
-      }
-
-      /* point1 = &( p->line[j].point[p->line[j].numpoints-1] ); */
-      for(i=0; i < p->line[j].numpoints; i++,l++) {
-        if (dxf == 2) {
-          im_iprintf (&imgStr, "%.0f %.0f\n", p->line[j].point[i].x, p->line[j].point[i].y);
-        } else if (dxf) {
-          im_iprintf (&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n", p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
-        } else {
-          im_iprintf (&imgStr, "%s %.0f,%.0f", first ? "": ",", p->line[j].point[i].x, p->line[j].point[i].y);
-        }
-        first = 0;
-
-        /* point2 = &( p->line[j].point[i] ); */
-        /* if(point1->y == point2->y) {} */
-      }
-      im_iprintf (&imgStr, dxf ? (dxf == 2 ? "": "  0\nSEQEND\n") : "\" />\n");
-    }
-
-    return;
-  }
-  /* DEBUG_IF printf ("d"); */
-  DEBUG_IF printf("-%d-",symbol->type);
-  return;
-}
-
-/*
- * Simply draws a label based on the label point and the supplied label object.
- */
-int msDrawTextIM(mapObj *map, imageObj* img, pointObj labelPnt, char *string, labelObj *label, double scalefactor)
-{
-  (void)map;
-  (void)img;
-  DEBUG_IF printf("msDrawText<BR>\n");
-  if(!string) return(0); /* not errors, just don't want to do anything */
-  if(strlen(string) == 0) return(0);
-  if(!dxf) return (0);
-
-  if (dxf == 2) {
-    im_iprintf (&imgStr, "TEXT\n%d\n%s\n%.0f\n%.0f\n%.0f\n" , matchdxfcolor(label->color), string, labelPnt.x, labelPnt.y, -label->angle);
-  } else {
-    im_iprintf (&imgStr, "  0\nTEXT\n  1\n%s\n 10\n%f\n 20\n%f\n 30\n0.0\n 40\n%f\n 50\n%f\n 62\n%6d\n  8\n%s\n 73\n   2\n 72\n   1\n" , string, labelPnt.x, labelPnt.y, label->size * scalefactor *100, -label->angle, matchdxfcolor(label->color), lname);
-  }
-  return(0);
-}
-
-/*
- * Save an image to a file named filename, if filename is NULL it goes to stdout
- */
-
-int msSaveImageIM(imageObj* img, const char *filename, outputFormatObj *format )
-
-{
-  FILE *stream_to_free = NULL;
-  FILE *stream;
-  char workbuffer[5000];
-
-  DEBUG_IF printf("msSaveImageIM\n<BR>");
-
-  if(filename != NULL && strlen(filename) > 0) {
-    stream_to_free = fopen(filename, "wb");
-    if(!stream_to_free) {
-      msSetError(MS_IOERR, "(%s)", "msSaveImage()", filename);
-      return(MS_FAILURE);
-    }
-    stream = stream_to_free;
-  } else { /* use stdout */
-
-#ifdef _WIN32
-    /*
-     * Change stdout mode to binary on win32 platforms
-     */
-    if(_setmode( _fileno(stdout), _O_BINARY) == -1) {
-      msSetError(MS_IOERR, "Unable to change stdout to binary mode.", "msSaveImage()");
-      return(MS_FAILURE);
-    }
-#endif
-    stream = stdout;
-  }
-
-  if( strcasecmp(format->driver,"imagemap") == 0 ) {
-    DEBUG_IF printf("ALLOCD %d<BR>\n", img->size);
-    /* DEBUG_IF printf("F %s<BR>\n", img->img.imagemap); */
-    DEBUG_IF printf("FLEN %d<BR>\n", (int)strlen(img->img.imagemap));
-    if (dxf == 2) {
-      msIO_fprintf(stream, "%s", layerlist);
-    } else if (dxf) {
-      msIO_fprintf(stream, "  0\nSECTION\n  2\nHEADER\n  9\n$ACADVER\n  1\nAC1009\n0\nENDSEC\n  0\nSECTION\n  2\nTABLES\n  0\nTABLE\n%s0\nENDTAB\n0\nENDSEC\n  0\nSECTION\n  2\nBLOCKS\n0\nENDSEC\n  0\nSECTION\n  2\nENTITIES\n", layerlist);
-    } else {
-      msIO_fprintf(stream, "<map name=\"%s\" width=\"%d\" height=\"%d\">\n", mapName, img->width, img->height);
-    }
-    const int nSize = sizeof(workbuffer);
-
-    const int size = strlen(img->img.imagemap);
-    if (size > nSize) {
-      int iIndice = 0;
-      while ((iIndice + nSize) <= size) {
-        snprintf(workbuffer, sizeof(workbuffer), "%s", img->img.imagemap+iIndice );
-        workbuffer[nSize-1] = '\0';
-        msIO_fwrite(workbuffer, strlen(workbuffer), 1, stream);
-        iIndice +=nSize-1;
-      }
-      if (iIndice < size) {
-        sprintf(workbuffer, "%s", img->img.imagemap+iIndice );
-        msIO_fprintf(stream, "%s", workbuffer);
-      }
-    } else
-      msIO_fwrite(img->img.imagemap, size, 1, stream);
-    if( strcasecmp("OFF",msGetOutputFormatOption( format, "SKIPENDTAG", "OFF" )) == 0) {
-      if (dxf == 2)
-        msIO_fprintf(stream, "END");
-      else if (dxf)
-        msIO_fprintf(stream, "0\nENDSEC\n0\nEOF\n");
-      else
-        msIO_fprintf(stream, "</map>");
-    }
-  } else {
-    msSetError(MS_MISCERR, "Unknown output image type driver: %s.",
-               "msSaveImage()", format->driver );
-    if(stream_to_free != NULL) fclose(stream_to_free);
-    return(MS_FAILURE);
-  }
-
-  if(stream_to_free != NULL) fclose(stream_to_free);
-  return(MS_SUCCESS);
-}
-
-
-/*
- * Free gdImagePtr
- */
-void msFreeImageIM(imageObj* img)
-{
-  free(img->img.imagemap);
-}
-
diff -pruN 8.0.1-5/mapio.c 8.2.0~beta1-1~exp1/mapio.c
--- 8.0.1-5/mapio.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapio.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1105 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementations for MapServer IO redirection capability.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 2004, Frank Warmerdam <warmerdam@pobox.com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <stdarg.h>
-
-#include "mapserver.h"
-#include "mapthread.h"
-
-#ifdef _WIN32
-#include <fcntl.h>
-#include <io.h>
-#endif
-
-#ifdef MOD_WMS_ENABLED
-#  include "httpd.h"
-#  include "apr_strings.h"
-#endif
-
-
-
-
-static int is_msIO_initialized = MS_FALSE;
-static int is_msIO_header_enabled = MS_TRUE;
-
-typedef struct msIOContextGroup_t {
-  msIOContext stdin_context;
-  msIOContext stdout_context;
-  msIOContext stderr_context;
-
-  void*    thread_id;
-  struct msIOContextGroup_t *next;
-} msIOContextGroup;
-
-static msIOContextGroup default_contexts;
-static msIOContextGroup *io_context_list = NULL;
-static void msIO_Initialize( void );
-
-#ifdef msIO_printf
-#  undef msIO_printf
-#  undef msIO_fprintf
-#  undef msIO_fwrite
-#  undef msIO_fread
-#  undef msIO_vfprintf
-#endif
-
-/************************************************************************/
-/*                            msIO_Cleanup()                            */
-/************************************************************************/
-
-void msIO_Cleanup()
-
-{
-  if( is_msIO_initialized )
-
-  {
-    is_msIO_initialized = MS_FALSE;
-    while( io_context_list != NULL ) {
-      msIOContextGroup *last = io_context_list;
-      io_context_list = io_context_list->next;
-      free( last );
-    }
-  }
-}
-
-/************************************************************************/
-/*                        msIO_GetContextGroup()                        */
-/************************************************************************/
-
-static msIOContextGroup *msIO_GetContextGroup()
-
-{
-  void* nThreadId = msGetThreadId();
-  msIOContextGroup *prev = NULL, *group = io_context_list;
-
-  if( group != NULL && group->thread_id == nThreadId )
-    return group;
-
-  /* -------------------------------------------------------------------- */
-  /*      Search for group for this thread                                */
-  /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_IOCONTEXT );
-  msIO_Initialize();
-
-  group = io_context_list;
-  while( group != NULL && group->thread_id != nThreadId ) {
-    prev = group;
-    group = group->next;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If we found it, make sure it is pushed to the front of the      */
-  /*      link for faster finding next time, and return it.               */
-  /* -------------------------------------------------------------------- */
-  if( group != NULL ) {
-    if( prev != NULL ) {
-      prev->next = group->next;
-      group->next = io_context_list;
-      io_context_list = group;
-    }
-
-    msReleaseLock( TLOCK_IOCONTEXT );
-    return group;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create a new context group for this thread.                     */
-  /* -------------------------------------------------------------------- */
-  group = (msIOContextGroup *) calloc(sizeof(msIOContextGroup),1);
-
-  group->stdin_context = default_contexts.stdin_context;
-  group->stdout_context = default_contexts.stdout_context;
-  group->stderr_context = default_contexts.stderr_context;
-  group->thread_id = nThreadId;
-
-  group->next = io_context_list;
-  io_context_list = group;
-
-  msReleaseLock( TLOCK_IOCONTEXT );
-
-  return group;
-}
-
-/* returns MS_TRUE if the msIO standard output hasn't been redirected */
-int msIO_isStdContext() {
-  msIOContextGroup *group = io_context_list;
-  void* nThreadId = msGetThreadId();
-  if(!group || group->thread_id != nThreadId) {
-    group = msIO_GetContextGroup();
-    if(!group) {
-      return MS_FALSE; /* probably a bug */
-    }
-  }
-  if(group->stderr_context.cbData == (void*)stderr &&
-      group->stdin_context.cbData == (void*)stdin &&
-      group->stdout_context.cbData == (void*)stdout)
-    return MS_TRUE;
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*                          msIO_getHandler()                           */
-/************************************************************************/
-
-msIOContext *msIO_getHandler( FILE * fp )
-
-{
-  void* nThreadId = msGetThreadId();
-  msIOContextGroup *group = io_context_list;
-
-  msIO_Initialize();
-
-  if( group == NULL || group->thread_id != nThreadId ) {
-    group = msIO_GetContextGroup();
-    if( group == NULL )
-      return NULL;
-  }
-
-  if( fp == stdin || fp == NULL || strcmp((const char *)fp,"stdin") == 0 )
-    return &(group->stdin_context);
-  else if( fp == stdout || strcmp((const char *)fp,"stdout") == 0 )
-    return &(group->stdout_context);
-  else if( fp == stderr || strcmp((const char *)fp,"stderr") == 0 )
-    return &(group->stderr_context);
-  else
-    return NULL;
-}
-
-/************************************************************************/
-/*                      msIO_setHeaderEnabled()                         */
-/************************************************************************/
-
-void msIO_setHeaderEnabled(int bFlag)
-{
-    is_msIO_header_enabled = bFlag;
-}
-
-/************************************************************************/
-/*                           msIO_setHeader()                           */
-/************************************************************************/
-
-void msIO_setHeader (const char *header, const char* value, ...)
-{
-  va_list args;
-  va_start( args, value );
-#ifdef MOD_WMS_ENABLED
-  msIOContext *ioctx = msIO_getHandler (stdout);
-  if(ioctx && !strcmp(ioctx->label,"apache")) {
-
-    request_rec *r = (request_rec*) (ioctx->cbData);
-    char *fullvalue = apr_pvsprintf(r->pool, value,args);
-    if (strcasecmp (header, "Content-Type") == 0) {
-      r->content_type = fullvalue;
-    } else if (strcasecmp (header, "Status") == 0) {
-      r->status = atoi (fullvalue);
-    } else {
-      apr_table_setn (r->headers_out,
-                      apr_pstrdup (r->pool, header),
-                      fullvalue
-                     );
-    }
-  } else {
-#endif // MOD_WMS_ENABLED
-   if( is_msIO_header_enabled ) {
-      msIO_fprintf(stdout,"%s: ",header);
-      msIO_vfprintf(stdout,value,args);
-      msIO_fprintf(stdout,"\r\n");
-   }
-#ifdef MOD_WMS_ENABLED
-  }
-#endif
-  va_end( args );
-}
-
-void msIO_sendHeaders ()
-{
-#ifdef MOD_WMS_ENABLED
-  msIOContext *ioctx = msIO_getHandler (stdout);
-  if(ioctx && !strcmp(ioctx->label,"apache")) return;
-#endif // !MOD_WMS_ENABLED
-  if( is_msIO_header_enabled ) {
-    msIO_printf ("\r\n");
-    fflush (stdout);
-  }
-}
-
-
-/************************************************************************/
-/*                        msIO_installHandlers()                        */
-/************************************************************************/
-
-int msIO_installHandlers( msIOContext *stdin_context,
-                          msIOContext *stdout_context,
-                          msIOContext *stderr_context )
-
-{
-  msIOContextGroup *group;
-
-  msIO_Initialize();
-
-  group = msIO_GetContextGroup();
-
-  if( stdin_context == NULL )
-    group->stdin_context = default_contexts.stdin_context;
-  else if( stdin_context != &group->stdin_context )
-    group->stdin_context = *stdin_context;
-
-  if( stdout_context == NULL )
-    group->stdout_context = default_contexts.stdout_context;
-  else if( stdout_context != &group->stdout_context )
-    group->stdout_context = *stdout_context;
-
-  if( stderr_context == NULL )
-    group->stderr_context = default_contexts.stderr_context;
-  else if( stderr_context != &group->stderr_context )
-    group->stderr_context = *stderr_context;
-
-  return MS_TRUE;
-}
-
-/************************************************************************/
-/*                          msIO_contextRead()                          */
-/************************************************************************/
-
-int msIO_contextRead( msIOContext *context, void *data, int byteCount )
-
-{
-  if( context->write_channel == MS_TRUE )
-    return 0;
-  else
-    return context->readWriteFunc( context->cbData, data, byteCount );
-}
-
-/************************************************************************/
-/*                         msIO_contextWrite()                          */
-/************************************************************************/
-
-int msIO_contextWrite( msIOContext *context, const void *data, int byteCount )
-
-{
-  if( context->write_channel == MS_FALSE )
-    return 0;
-  else
-    return context->readWriteFunc( context->cbData, (void *) data,
-                                   byteCount );
-}
-
-/* ==================================================================== */
-/* ==================================================================== */
-/*      Stdio-like cover functions.                                     */
-/* ==================================================================== */
-/* ==================================================================== */
-
-/************************************************************************/
-/*                            _ms_vsprintf()                            */
-/************************************************************************/
-
-static int _ms_vsprintf(char **workBufPtr, const char *format, va_list ap )
-
-{
-  int     ret_val;
-  int   workBufSize = 16000;
-
-  *workBufPtr = (char*)malloc(workBufSize * sizeof(char));
-  if (*workBufPtr == NULL) {
-    msSetError( MS_MEMERR, NULL, "_ms_vsprintf()");
-    return -1;
-  }
-
-#if defined(HAVE_VSNPRINTF)
-  /* This should grow a big enough buffer to hold any formatted result. */
-  {
-    va_list wrk_args;
-
-#ifdef va_copy
-    va_copy( wrk_args, ap );
-#else
-    wrk_args = ap;
-#endif
-
-    while( (ret_val = vsnprintf( *workBufPtr, workBufSize,
-                                 format, wrk_args)) >= workBufSize-1
-           || ret_val == -1 ) {
-      workBufSize *= 4;
-      *workBufPtr = (char *) realloc(*workBufPtr, workBufSize );
-      if (*workBufPtr == NULL) {
-        msSetError( MS_MEMERR, NULL, "_ms_vsprintf()");
-        va_end( wrk_args );
-        return -1;
-      }
-#ifdef va_copy
-      va_end( wrk_args );
-      va_copy( wrk_args, ap );
-#else
-      wrk_args = ap;
-#endif
-    }
-    va_end( wrk_args );
-  }
-#else
-  /* We do not have vsnprintf()... there is a risk of buffer overrun */
-  ret_val = vsprintf( *workBufPtr, format, ap );
-
-  if( ret_val < 0 || ret_val >= workBufSize ) {
-    msSetError(MS_MISCERR, "Possible buffer overrun.", "_ms_vsprintf()");
-    msFree(*workBufPtr);
-    *workBufPtr = NULL;
-    return -1;
-  }
-#endif
-
-  return ret_val;
-}
-
-
-/************************************************************************/
-/*                            msIO_printf()                             */
-/************************************************************************/
-
-int msIO_printf( const char *format, ... )
-
-{
-  va_list args;
-  int ret;
-  va_start( args, format );
-  ret = msIO_vfprintf(stdout,format,args);
-  va_end(args);
-  return ret;
-}
-
-/************************************************************************/
-/*                            msIO_fprintf()                            */
-/************************************************************************/
-
-int msIO_fprintf( FILE *fp, const char *format, ... )
-
-{
-  va_list args;
-  int ret;
-  va_start( args, format );
-  ret = msIO_vfprintf(fp,format,args);
-  va_end(args);
-  return ret;
-}
-
-/************************************************************************/
-/*                            msIO_vfprintf()                           */
-/************************************************************************/
-
-int msIO_vfprintf( FILE *fp, const char *format, va_list ap )
-
-{
-  int     return_val;
-  msIOContext *context;
-  char workBuf[8000];
-
-#if !defined(HAVE_VSNPRINTF)
-  return_val = vsprintf( workBuf, format, ap);
-
-  if( return_val < 0 || return_val >= sizeof(workBuf) ) {
-    msSetError(MS_MISCERR, "Possible buffer overrun.", "msIO_vfprintf()");
-    return -1;
-  }
-
-  char* outbuf = workBuf;
-
-#else
-
-  va_list args_copy;
-#ifdef va_copy
-  va_copy( args_copy, ap );
-#else
-  args_copy = ap;
-#endif /* va_copy */
-
-  char* largerBuf = NULL;
-  return_val = vsnprintf( workBuf, sizeof(workBuf), format, ap );
-  if (return_val == -1 || return_val >= (int)sizeof(workBuf)-1) {
-    return_val = _ms_vsprintf(&largerBuf, format, args_copy );
-  }
-  va_end(args_copy);
-
-  if (return_val < 0)
-    return -1;
-
-  char* outbuf = largerBuf?largerBuf:workBuf;
-
-#endif /* HAVE_VSNPRINTF */
-
-  context = msIO_getHandler( fp );
-  if( context == NULL )
-    return_val = fwrite(outbuf , 1, return_val, fp );
-  else
-    return_val =  msIO_contextWrite( context,
-                                     outbuf,
-                                     return_val );
-
-#if defined(HAVE_VSNPRINTF)
-  msFree(largerBuf);
-#endif
-
-  return return_val;
-}
-
-/************************************************************************/
-/*                            msIO_fwrite()                             */
-/************************************************************************/
-
-int msIO_fwrite( const void *data, size_t size, size_t nmemb, FILE *fp )
-
-{
-  msIOContext *context;
-
-  if( size == 0 || nmemb == 0 )
-    return 0;
-
-  context = msIO_getHandler( fp );
-  if( context == NULL )
-    return fwrite( data, size, nmemb, fp );
-  else
-    return msIO_contextWrite( context, data, size * nmemb ) / size;
-}
-
-/************************************************************************/
-/*                            msIO_fread()                              */
-/************************************************************************/
-
-int msIO_fread( void *data, size_t size, size_t nmemb, FILE *fp )
-
-{
-  msIOContext *context;
-
-  if( size == 0 || nmemb == 0 )
-    return 0;
-
-  context = msIO_getHandler( fp );
-  if( context == NULL )
-    return fread( data, size, nmemb, fp );
-  else
-    return msIO_contextRead( context, data, size * nmemb ) / size;
-}
-
-/* ==================================================================== */
-/* ==================================================================== */
-/*      Internal default callbacks implementing stdio reading and       */
-/*      writing.                                                        */
-/* ==================================================================== */
-/* ==================================================================== */
-
-/************************************************************************/
-/*                           msIO_stdioRead()                           */
-/*                                                                      */
-/*      This is the default implementation via stdio.                   */
-/************************************************************************/
-
-static int msIO_stdioRead( void *cbData, void *data, int byteCount )
-
-{
-  return fread( data, 1, byteCount, (FILE *) cbData );
-}
-
-/************************************************************************/
-/*                          msIO_stdioWrite()                           */
-/*                                                                      */
-/*      This is the default implementation via stdio.                   */
-/************************************************************************/
-
-static int msIO_stdioWrite( void *cbData, void *data, int byteCount )
-
-{
-  return fwrite( data, 1, byteCount, (FILE *) cbData );
-}
-
-/************************************************************************/
-/*                          msIO_Initialize()                           */
-/************************************************************************/
-
-static void msIO_Initialize( void )
-
-{
-  if( is_msIO_initialized == MS_TRUE )
-    return;
-
-  default_contexts.stdin_context.label = "stdio";
-  default_contexts.stdin_context.write_channel = MS_FALSE;
-  default_contexts.stdin_context.readWriteFunc = msIO_stdioRead;
-  default_contexts.stdin_context.cbData = (void *) stdin;
-
-  default_contexts.stdout_context.label = "stdio";
-  default_contexts.stdout_context.write_channel = MS_TRUE;
-  default_contexts.stdout_context.readWriteFunc = msIO_stdioWrite;
-  default_contexts.stdout_context.cbData = (void *) stdout;
-
-  default_contexts.stderr_context.label = "stdio";
-  default_contexts.stderr_context.write_channel = MS_TRUE;
-  default_contexts.stderr_context.readWriteFunc = msIO_stdioWrite;
-  default_contexts.stderr_context.cbData = (void *) stderr;
-
-  default_contexts.next = NULL;
-  default_contexts.thread_id = 0;
-
-  is_msIO_initialized = MS_TRUE;
-}
-
-
-/* ==================================================================== */
-/* ==================================================================== */
-/*      FastCGI output redirection functions.                           */
-/* ==================================================================== */
-/* ==================================================================== */
-
-
-
-/************************************************************************/
-/*                       msIO_needBinaryStdout()                        */
-/*                                                                      */
-/*      This function is intended to ensure that stdout is in binary    */
-/*      mode.                                                           */
-/*                                                                      */
-/*      But don't do it we are using FastCGI.  We will take care of     */
-/*      doing it in the libfcgi library in that case for the normal     */
-/*      cgi case, and for the fastcgi case the _setmode() call          */
-/*      causes a crash.                                                 */
-/************************************************************************/
-
-int msIO_needBinaryStdout()
-
-{
-#if defined(_WIN32) && !defined(USE_FASTCGI)
-  if(_setmode( _fileno(stdout), _O_BINARY) == -1) {
-    msSetError(MS_IOERR,
-               "Unable to change stdout to binary mode.",
-               "msIO_needBinaryStdout()" );
-    return(MS_FAILURE);
-  }
-#endif
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                        msIO_needBinaryStdin()                        */
-/*                                                                      */
-/*      This function is intended to ensure that stdin is in binary     */
-/*      mode.                                                           */
-/*                                                                      */
-/*      But don't do it we are using FastCGI.  We will take care of     */
-/*      doing it in the libfcgi library in that case for the normal     */
-/*      cgi case, and for the fastcgi case the _setmode() call          */
-/*      causes a crash.                                                 */
-/************************************************************************/
-
-int msIO_needBinaryStdin()
-
-{
-#if defined(_WIN32) && !defined(USE_FASTCGI)
-  if(_setmode( _fileno(stdin), _O_BINARY) == -1) {
-    msSetError(MS_IOERR,
-               "Unable to change stdin to binary mode.",
-               "msIO_needBinaryStdin()" );
-    return(MS_FAILURE);
-  }
-#endif
-
-  return MS_SUCCESS;
-}
-
-/* ==================================================================== */
-/*      memory buffer io handling functions.                            */
-/* ==================================================================== */
-
-/************************************************************************/
-/*                         msIO_resetHandlers()                         */
-/************************************************************************/
-
-void msIO_resetHandlers()
-
-{
-  msIOContextGroup *group = msIO_GetContextGroup();
-
-  if( group == NULL )
-    return;
-
-  if( strcmp(group->stdin_context.label,"buffer") == 0 ) {
-    msIOBuffer *buf = (msIOBuffer *) group->stdin_context.cbData;
-
-    if( buf->data != NULL )
-      free( buf->data );
-    free( buf );
-  }
-
-  if( strcmp(group->stdout_context.label,"buffer") == 0 ) {
-    msIOBuffer *buf = (msIOBuffer *) group->stdout_context.cbData;
-
-    if( buf->data != NULL )
-      free( buf->data );
-    free( buf );
-  }
-
-  if( strcmp(group->stderr_context.label,"buffer") == 0 ) {
-    msIOBuffer *buf = (msIOBuffer *) group->stderr_context.cbData;
-
-    if( buf->data != NULL )
-      free( buf->data );
-    free( buf );
-  }
-
-  msIO_installHandlers( NULL, NULL, NULL );
-}
-
-/************************************************************************/
-/*                     msIO_installStdoutToBuffer()                     */
-/************************************************************************/
-
-void msIO_installStdoutToBuffer()
-
-{
-  msIOContextGroup *group = msIO_GetContextGroup();
-  msIOContext  context;
-
-  context.label = "buffer";
-  context.write_channel = MS_TRUE;
-  context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = calloc(sizeof(msIOBuffer),1);
-
-  msIO_installHandlers( &group->stdin_context,
-                        &context,
-                        &group->stderr_context );
-}
-
-
-/************************************************************************/
-/*               msIO_pushStdoutToBufferAndGetOldContext()              */
-/*                                                                      */
-/* This function installs a temporary buffer I/O context and returns    */
-/* previously installed stdout handler. This previous stdout handler    */
-/* should later be restored with msIO_restoreOldStdoutContext().        */
-/* This function can be for example used when wanting to ingest into    */
-/* libxml objects XML generated by msIO_fprintf()                       */
-/************************************************************************/
-
-msIOContext* msIO_pushStdoutToBufferAndGetOldContext()
-
-{
-  msIOContextGroup *group = msIO_GetContextGroup();
-  msIOContext *old_context;
-
-  /* Backup current context */
-  old_context = (msIOContext*) msSmallMalloc(sizeof(msIOContext));
-  memcpy(old_context, &group->stdout_context, sizeof(msIOContext));
-
-  msIO_installStdoutToBuffer();
-
-  return old_context;
-}
-
-/************************************************************************/
-/*                    msIO_restoreOldStdoutContext()                    */
-/************************************************************************/
-
-void msIO_restoreOldStdoutContext(msIOContext *context_to_restore)
-{
-  msIOContextGroup *group = msIO_GetContextGroup();
-  msIOContext *prev_context = &group->stdout_context;
-  msIOBuffer* buffer;
-  
-  /* Free memory associated to our temporary context */
-  assert( strcmp(prev_context->label, "buffer") == 0 );
-
-  buffer = (msIOBuffer* )prev_context->cbData;
-  msFree(buffer->data);
-  msFree(buffer);
-
-  /* Restore old context */
-  msIO_installHandlers( &group->stdin_context,
-                        context_to_restore,
-                        &group->stderr_context );
-
-  msFree(context_to_restore);
-}
-
-/************************************************************************/
-/*                    msIO_installStdinFromBuffer()                     */
-/************************************************************************/
-
-void msIO_installStdinFromBuffer()
-
-{
-  msIOContextGroup *group = msIO_GetContextGroup();
-  msIOContext  context;
-
-  context.label = "buffer";
-  context.write_channel = MS_FALSE;
-  context.readWriteFunc = msIO_bufferRead;
-  context.cbData = calloc(sizeof(msIOBuffer),1);
-
-  msIO_installHandlers( &context,
-                        &group->stdout_context,
-                        &group->stderr_context );
-}
-
-/************************************************************************/
-/*              msIO_getAndStripStdoutBufferMimeHeaders()               */
-/*                                                                      */
-/************************************************************************/
-
-hashTableObj* msIO_getAndStripStdoutBufferMimeHeaders()
-{
-  /* -------------------------------------------------------------------- */
-  /*      Find stdout buffer.                                             */
-  /* -------------------------------------------------------------------- */
-  msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-  msIOBuffer  *buf;
-  int start_of_mime_header, current_pos;
-  hashTableObj* hashTable;
-
-  if( ctx == NULL || ctx->write_channel == MS_FALSE
-      || strcmp(ctx->label,"buffer") != 0 ) {
-    msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                "msIO_getAndStripStdoutBufferMimeHeaders" );
-    return NULL;
-  }
-
-  buf = (msIOBuffer *) ctx->cbData;
-
-  hashTable = msCreateHashTable();
-
-  /* -------------------------------------------------------------------- */
-  /*      Loop over all headers.                                          */
-  /* -------------------------------------------------------------------- */
-  current_pos = 0;
-  while( MS_TRUE ) {
-    int pos_of_column = -1;
-    char* key, *value;
-
-    start_of_mime_header = current_pos;
-    while( current_pos < buf->data_offset )
-    {
-        if( buf->data[current_pos] == '\r' )
-        {
-            if( current_pos + 1 == buf->data_offset ||
-                buf->data[current_pos + 1] != '\n' )
-            {
-                pos_of_column = -1;
-                break;
-            }
-            break;
-        }
-        if( buf->data[current_pos] == ':' )
-        {
-            pos_of_column = current_pos;
-            if( current_pos + 1 == buf->data_offset ||
-                buf->data[current_pos + 1] != ' ' )
-            {
-                pos_of_column = -1;
-                break;
-            }
-        }
-        current_pos++;
-    }
-
-    if( pos_of_column < 0 || current_pos == buf->data_offset ) {
-      msSetError( MS_MISCERR, "Corrupt mime headers.",
-                  "msIO_getAndStripStdoutBufferMimeHeaders" );
-      msFreeHashTable(hashTable);
-      return NULL;
-    }
-
-    key = (char*) malloc( pos_of_column - start_of_mime_header + 1 );
-    memcpy( key, buf->data+start_of_mime_header, pos_of_column - start_of_mime_header);
-    key[pos_of_column - start_of_mime_header] = '\0';
-
-    value = (char*) malloc( current_pos - (pos_of_column+2) + 1 );
-    memcpy( value, buf->data+pos_of_column+2, current_pos - (pos_of_column+2));
-    value[current_pos - (pos_of_column+2)] = '\0';
-
-    msInsertHashTable( hashTable, key, value );
-
-    msFree( key );
-    msFree( value );
-
-    /* -------------------------------------------------------------------- */
-    /*      Go to next line.                                                */
-    /* -------------------------------------------------------------------- */
-    current_pos += 2;
-    if( current_pos == buf->data_offset )
-    {
-      msSetError( MS_MISCERR, "Corrupt mime headers.",
-                  "msIO_getAndStripStdoutBufferMimeHeaders" );
-      msFreeHashTable(hashTable);
-      return NULL;
-    }
-
-    /* If next line is a '\r', this is the end of mime headers. */
-    if( buf->data[current_pos] == '\r' )
-    {
-        current_pos ++;
-        if( current_pos == buf->data_offset ||
-            buf->data[current_pos] != '\n' )
-        {
-            msSetError( MS_MISCERR, "Corrupt mime headers.",
-                        "msIO_getAndStripStdoutBufferMimeHeaders" );
-            msFreeHashTable(hashTable);
-            return NULL;
-        }
-        current_pos ++;
-        break;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Move data to front of buffer, and reset length.                 */
-  /* -------------------------------------------------------------------- */
-  memmove( buf->data, buf->data+current_pos,
-           buf->data_offset - current_pos );
-  buf->data[buf->data_offset - current_pos] = '\0';
-  buf->data_offset -= current_pos;
-
-  return hashTable;
-}
-
-/************************************************************************/
-/*                 msIO_stripStdoutBufferContentType()                  */
-/*                                                                      */
-/*      Strip off Content-Type header from buffer, and return to        */
-/*      caller.  Returned string is the callers responsibility to       */
-/*      call msFree() on to deallocate.  This function will return      */
-/*      NULL if there is no Content-Type header.                        */
-/************************************************************************/
-
-char *msIO_stripStdoutBufferContentType()
-
-{
-  /* -------------------------------------------------------------------- */
-  /*      Find stdout buffer.                                             */
-  /* -------------------------------------------------------------------- */
-  msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-  msIOBuffer  *buf;
-  char *content_type = NULL;
-  int end_of_ct, start_of_data;
-
-  if( ctx == NULL || ctx->write_channel == MS_FALSE
-      || strcmp(ctx->label,"buffer") != 0 ) {
-    msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                "msIO_stripStdoutBufferContentType" );
-    return NULL;
-  }
-
-  buf = (msIOBuffer *) ctx->cbData;
-
-  /* -------------------------------------------------------------------- */
-  /*      Return NULL if we don't have a Content-Type header.             */
-  /* -------------------------------------------------------------------- */
-  if( buf->data_offset < 14
-      || strncasecmp((const char*) buf->data,"Content-Type: ",14) != 0 )
-    return NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Find newline marker at end of content type argument.            */
-  /* -------------------------------------------------------------------- */
-  end_of_ct = 13;
-  while( end_of_ct+1 < buf->data_offset
-         && buf->data[end_of_ct+1] != '\r' )
-    end_of_ct++;
-
-  if( end_of_ct+1 == buf->data_offset ) {
-    msSetError( MS_MISCERR, "Corrupt Content-Type header.",
-                "msIO_stripStdoutBufferContentType" );
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Continue on to the start of data ...                            */
-  /*      Go to next line and skip if empty.                              */
-  /* -------------------------------------------------------------------- */
-  start_of_data = end_of_ct+3;
-  if( start_of_data  < buf->data_offset
-      && buf->data[start_of_data] == '\r' )
-    start_of_data +=2;
-  
-  if( start_of_data == buf->data_offset ) {
-    msSetError( MS_MISCERR, "Corrupt Content-Type header.",
-                "msIO_stripStdoutBufferContentType" );
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Copy out content type. Note we go against the coding guidelines */
-  /*      here and use strncpy() instead of strlcpy() as the source       */
-  /*      buffer may not be NULL terminated - strlcpy() requires NULL     */
-  /*      terminated sources (see issue #4672).                           */
-  /* -------------------------------------------------------------------- */
-  content_type = (char *) malloc(end_of_ct-14+2);
-  strncpy( content_type, (const char *) buf->data + 14, end_of_ct - 14 + 2);
-  content_type[end_of_ct-14+1] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*      Move data to front of buffer, and reset length.                 */
-  /* -------------------------------------------------------------------- */
-  memmove( buf->data, buf->data+start_of_data,
-           buf->data_offset - start_of_data );
-  buf->data[buf->data_offset - start_of_data] = '\0';
-  buf->data_offset -= start_of_data;
-
-  return content_type;
-}
-
-/************************************************************************/
-/*                 msIO_stripStdoutBufferContentHeaders()               */
-/*                                                                      */
-/*      Strip off Content-* headers from buffer.                        */
-/************************************************************************/
-
-void msIO_stripStdoutBufferContentHeaders()
-{
-  /* -------------------------------------------------------------------- */
-  /*      Find stdout buffer.                                             */
-  /* -------------------------------------------------------------------- */
-  msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-  msIOBuffer  *buf;
-  int start_of_data;
-
-  if( ctx == NULL || ctx->write_channel == MS_FALSE
-      || strcmp(ctx->label,"buffer") != 0 ) {
-    msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                "msIO_stripStdoutBufferContentHeaders" );
-    return;
-  }
-
-  buf = (msIOBuffer *) ctx->cbData;
-
-  /* -------------------------------------------------------------------- */
-  /*      Exit if we don't have any content-* header.                     */
-  /* -------------------------------------------------------------------- */
-  if( buf->data_offset < 8
-      || strncasecmp((const char*) buf->data,"Content-",8) != 0 )
-    return;
-
-  /* -------------------------------------------------------------------- */
-  /*      Loop over all content-* headers.                                */
-  /* -------------------------------------------------------------------- */
-  start_of_data = 0;
-  while( buf->data_offset > start_of_data
-         && strncasecmp((const char*) buf->data+start_of_data,"Content-",8) == 0 ) {
-    /* -------------------------------------------------------------------- */
-    /*      Find newline marker at end of content-* header argument.        */
-    /* -------------------------------------------------------------------- */
-    start_of_data +=7;
-    while( start_of_data+1 < buf->data_offset
-           && buf->data[start_of_data+1] != '\r' )
-      start_of_data++;
-
-    if( start_of_data+1 == buf->data_offset ) {
-      msSetError( MS_MISCERR, "Corrupt Content-* header.",
-                  "msIO_stripStdoutBufferContentHeaders" );
-      return;
-    }
-    /* -------------------------------------------------------------------- */
-    /*      Go to next line.                                                */
-    /* -------------------------------------------------------------------- */
-    start_of_data +=3;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Continue on to the start of data ...                            */
-  /*      Skip next line if empty.                                        */
-  /* -------------------------------------------------------------------- */
-  if( start_of_data  < buf->data_offset
-      && buf->data[start_of_data] == '\r' )
-    start_of_data +=2;
-
-  if( start_of_data == buf->data_offset ) {
-    msSetError( MS_MISCERR, "Corrupt Content-* header.",
-                "msIO_stripStdoutBufferContentHeaders" );
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Move data to front of buffer, and reset length.                 */
-  /* -------------------------------------------------------------------- */
-  memmove( buf->data, buf->data+start_of_data,
-           buf->data_offset - start_of_data );
-  buf->data[buf->data_offset - start_of_data] = '\0';
-  buf->data_offset -= start_of_data;
-
-  return;
-}
-
-/************************************************************************/
-/*                          msIO_bufferWrite()                          */
-/************************************************************************/
-
-int msIO_bufferWrite( void *cbData, void *data, int byteCount )
-
-{
-  msIOBuffer *buf = (msIOBuffer *) cbData;
-
-  /*
-  ** Grow buffer if needed (reserve one extra byte to put nul character)
-  */
-  if( buf->data_offset + byteCount >= buf->data_len ) {
-    buf->data_len = buf->data_len * 2 + byteCount + 100;
-    if( buf->data == NULL )
-      buf->data = (unsigned char *) malloc(buf->data_len);
-    else
-      buf->data = (unsigned char *) realloc(buf->data, buf->data_len);
-
-    if( buf->data == NULL ) {
-      msSetError( MS_MEMERR,
-                  "Failed to allocate %d bytes for capture buffer.",
-                  "msIO_bufferWrite()", buf->data_len );
-      buf->data_len = 0;
-      return 0;
-    }
-  }
-
-  /*
-  ** Copy result into buffer.
-  */
-
-  memcpy( buf->data + buf->data_offset, data, byteCount );
-  buf->data_offset += byteCount;
-  buf->data[buf->data_offset] = '\0';
-
-  return byteCount;
-}
-
-/************************************************************************/
-/*                          msIO_bufferRead()                           */
-/************************************************************************/
-
-int msIO_bufferRead( void *cbData, void *data, int byteCount )
-
-{
-  (void)cbData;
-  (void)data;
-  (void)byteCount;
-  /* not implemented yet. */
-  return 0;
-}
diff -pruN 8.0.1-5/mapio.h 8.2.0~beta1-1~exp1/mapio.h
--- 8.0.1-5/mapio.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapio.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,126 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Definitions for MapServer IO redirection capability.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 2004, Frank Warmerdam <warmerdam@pobox.com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPIO_H
-#define MAPIO_H
-
-/*
-** We deliberately emulate stdio functions in the msIO cover functions.
-** This makes it easy for folks to understand the semantics, and means we
-** can just #define things to use stdio in the simplest case.
-*/
-
-#include <stdarg.h>
-#include "maphash.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#ifndef MS_PRINT_FUNC_FORMAT
-#if defined(__GNUC__) && __GNUC__ >= 3 && !defined(DOXYGEN_SKIP)
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )  __attribute__((__format__ (__printf__, format_idx, arg_idx)))
-#else
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )
-#endif
-#endif
-
-  /* stdio analogs */
-  int MS_DLL_EXPORT msIO_printf( const char *format, ... ) MS_PRINT_FUNC_FORMAT(1,2);
-  int MS_DLL_EXPORT msIO_fprintf( FILE *stream, const char *format, ... ) MS_PRINT_FUNC_FORMAT(2,3);
-  int MS_DLL_EXPORT msIO_fwrite( const void *ptr, size_t size, size_t nmemb, FILE *stream );
-  int MS_DLL_EXPORT msIO_fread( void *ptr, size_t size, size_t nmemb, FILE *stream );
-  int MS_DLL_EXPORT msIO_vfprintf( FILE *fp, const char *format, va_list ap ) MS_PRINT_FUNC_FORMAT(2,0);
-
-  /*
-  ** Definitions for the callback function and the details of the IO
-  ** channel contexts.
-  */
-
-  typedef int (*msIO_llReadWriteFunc)( void *cbData, void *data, int byteCount );
-
-  typedef struct msIOContext_t {
-    const char           *label;
-    int                   write_channel; /* 1 for stdout/stderr, 0 for stdin */
-    msIO_llReadWriteFunc  readWriteFunc;
-    void                  *cbData;
-  } msIOContext;
-
-  int MS_DLL_EXPORT msIO_installHandlers( msIOContext *stdin_context,
-                                          msIOContext *stdout_context,
-                                          msIOContext *stderr_context );
-  msIOContext MS_DLL_EXPORT *msIO_getHandler( FILE * );
-  void MS_DLL_EXPORT msIO_setHeaderEnabled(int bFlag);
-  void msIO_setHeader (const char *header, const char* value, ...) MS_PRINT_FUNC_FORMAT(2,3);
-  void msIO_sendHeaders(void);
-
-  /*
-  ** These can be used instead of the stdio style functions if you have
-  ** msIOContext's for the channel in question.
-  */
-  int msIO_contextRead( msIOContext *context, void *data, int byteCount );
-  int msIO_contextWrite( msIOContext *context, const void *data, int byteCount );
-
-  /*
-  ** For redirecting IO to a memory buffer.
-  */
-
-  typedef struct {
-    unsigned char *data;
-    int            data_len;    /* really buffer length */
-    int            data_offset; /* really buffer used */
-  } msIOBuffer;
-
-  int MS_DLL_EXPORT msIO_bufferRead( void *, void *, int );
-  int MS_DLL_EXPORT msIO_bufferWrite( void *, void *, int );
-
-  void MS_DLL_EXPORT msIO_resetHandlers(void);
-  void MS_DLL_EXPORT msIO_installStdoutToBuffer(void);
-  void MS_DLL_EXPORT msIO_installStdinFromBuffer(void);
-  void MS_DLL_EXPORT msIO_Cleanup(void);
-  char MS_DLL_EXPORT *msIO_stripStdoutBufferContentType(void);
-  void MS_DLL_EXPORT msIO_stripStdoutBufferContentHeaders(void);
-  hashTableObj MS_DLL_EXPORT *msIO_getAndStripStdoutBufferMimeHeaders(void);
-
-  msIOContext *msIO_pushStdoutToBufferAndGetOldContext(void);
-  void msIO_restoreOldStdoutContext(msIOContext *context_to_restore);
-
-  int MS_DLL_EXPORT msIO_isStdContext(void);
-
-
-  /* this is just for setting normal stdout's to binary mode on windows */
-
-  int msIO_needBinaryStdout( void );
-  int msIO_needBinaryStdin( void );
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* nef MAPIO_H */
diff -pruN 8.0.1-5/mapjoin.c 8.2.0~beta1-1~exp1/mapjoin.c
--- 8.0.1-5/mapjoin.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapjoin.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,829 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implements MapServer joins.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-#define ROW_ALLOCATION_SIZE 10
-
-
-/* DBF/XBase function prototypes */
-int msDBFJoinConnect(layerObj *layer, joinObj *join);
-int msDBFJoinPrepare(joinObj *join, shapeObj *shape);
-int msDBFJoinNext(joinObj *join);
-int msDBFJoinClose(joinObj *join);
-int msDBFJoinTable(layerObj *layer, joinObj *join, shapeObj *shape);
-
-/* CSV (comma delimited text file) function prototypes */
-int msCSVJoinConnect(layerObj *layer, joinObj *join);
-int msCSVJoinPrepare(joinObj *join, shapeObj *shape);
-int msCSVJoinNext(joinObj *join);
-int msCSVJoinClose(joinObj *join);
-int msCSVJoinTable(layerObj *layer, joinObj *join, shapeObj *shape);
-
-/* MySQL function prototypes */
-int msMySQLJoinConnect(layerObj *layer, joinObj *join);
-int msMySQLJoinPrepare(joinObj *join, shapeObj *shape);
-int msMySQLJoinNext(joinObj *join);
-int msMySQLJoinClose(joinObj *join);
-int msMySQLJoinTable(layerObj *layer, joinObj *join, shapeObj *shape);
-
-/* PostgreSQL function prototypes */
-int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join);
-int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape);
-int msPOSTGRESQLJoinNext(joinObj *join);
-int msPOSTGRESQLJoinClose(joinObj *join);
-
-/* wrapper function for DB specific join functions */
-int msJoinConnect(layerObj *layer, joinObj *join)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinConnect(layer, join);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinConnect(layer, join);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinConnect(layer, join);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinConnect(layer, join);
-      break;
-    default:
-      break;
-  }
-
-  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinConnect()");
-  return MS_FAILURE;
-}
-
-int msJoinPrepare(joinObj *join, shapeObj *shape)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinPrepare(join, shape);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinPrepare(join, shape);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinPrepare(join, shape);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinPrepare(join, shape);
-      break;
-    default:
-      break;
-  }
-
-  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinPrepare()");
-  return MS_FAILURE;
-}
-
-int msJoinNext(joinObj *join)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinNext(join);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinNext(join);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinNext(join);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinNext(join);
-      break;
-    default:
-      break;
-  }
-
-  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinNext()");
-  return MS_FAILURE;
-}
-
-int msJoinClose(joinObj *join)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinClose(join);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinClose(join);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinClose(join);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinClose(join);
-      break;
-    default:
-      break;
-  }
-
-  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinClose()");
-  return MS_FAILURE;
-}
-
-/*  */
-/* XBASE join functions */
-/*  */
-typedef struct {
-  DBFHandle hDBF;
-  int fromindex, toindex;
-  char *target;
-  int nextrecord;
-} msDBFJoinInfo;
-
-int msDBFJoinConnect(layerObj *layer, joinObj *join)
-{
-  int i;
-  char szPath[MS_MAXPATHLEN];
-  msDBFJoinInfo *joininfo;
-
-  if(join->joininfo) return(MS_SUCCESS); /* already open */
-
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-
-  /* allocate a msDBFJoinInfo struct */
-  joininfo = (msDBFJoinInfo *) malloc(sizeof(msDBFJoinInfo));
-  if(!joininfo) {
-    msSetError(MS_MEMERR, "Error allocating XBase table info structure.", "msDBFJoinConnect()");
-    return(MS_FAILURE);
-  }
-
-  /* initialize any members that won't get set later on in this function */
-  joininfo->target = NULL;
-  joininfo->nextrecord = 0;
-
-  join->joininfo = joininfo;
-
-  /* open the XBase file */
-  if((joininfo->hDBF = msDBFOpen( msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, join->table), "rb" )) == NULL) {
-    if((joininfo->hDBF = msDBFOpen( msBuildPath(szPath, layer->map->mappath, join->table), "rb" )) == NULL) {
-      msSetError(MS_IOERR, "(%s)", "msDBFJoinConnect()", join->table);
-      return(MS_FAILURE);
-    }
-  }
-
-  /* get "to" item index */
-  if((joininfo->toindex = msDBFGetItemIndex(joininfo->hDBF, join->to)) == -1) {
-    msSetError(MS_DBFERR, "Item %s not found in table %s.", "msDBFJoinConnect()", join->to, join->table);
-    return(MS_FAILURE);
-  }
-
-  /* get "from" item index   */
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i],join->from) == 0) { /* found it */
-      joininfo->fromindex = i;
-      break;
-    }
-  }
-
-  if(i == layer->numitems) {
-    msSetError(MS_JOINERR, "Item %s not found in layer %s.", "msDBFJoinConnect()", join->from, layer->name);
-    return(MS_FAILURE);
-  }
-
-  /* finally store away the item names in the XBase table */
-  join->numitems =  msDBFGetFieldCount(joininfo->hDBF);
-  join->items = msDBFGetItems(joininfo->hDBF);
-  if(!join->items) return(MS_FAILURE);
-
-  return(MS_SUCCESS);
-}
-
-int msDBFJoinPrepare(joinObj *join, shapeObj *shape)
-{
-  msDBFJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msDBFJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape) {
-    msSetError(MS_JOINERR, "Shape to be joined is empty.", "msDBFJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape to be joined has no attributes.", "msDBFJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  joininfo->nextrecord = 0; /* starting with the first record */
-
-  if(joininfo->target) free(joininfo->target); /* clear last target */
-  joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
-
-  return(MS_SUCCESS);
-}
-
-int msDBFJoinNext(joinObj *join)
-{
-  int i, n;
-  msDBFJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msDBFJoinNext()");
-    return(MS_FAILURE);
-  }
-
-  if(!joininfo->target) {
-    msSetError(MS_JOINERR, "No target specified, run msDBFJoinPrepare() first.", "msDBFJoinNext()");
-    return(MS_FAILURE);
-  }
-
-  /* clear any old data */
-  if(join->values) {
-    msFreeCharArray(join->values, join->numitems);
-    join->values = NULL;
-  }
-
-  n = msDBFGetRecordCount(joininfo->hDBF);
-
-  for(i=joininfo->nextrecord; i<n; i++) { /* find a match */
-    if(strcmp(joininfo->target, msDBFReadStringAttribute(joininfo->hDBF, i, joininfo->toindex)) == 0) break;
-  }
-
-  if(i == n) { /* unable to do the join */
-    if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
-      msSetError(MS_MEMERR, NULL, "msDBFJoinNext()");
-      return(MS_FAILURE);
-    }
-    for(i=0; i<join->numitems; i++)
-      join->values[i] = msStrdup("\0"); /* intialize to zero length strings */
-
-    joininfo->nextrecord = n;
-    return(MS_DONE);
-  }
-
-  if((join->values = msDBFGetValues(joininfo->hDBF,i)) == NULL)
-    return(MS_FAILURE);
-
-  joininfo->nextrecord = i+1; /* so we know where to start looking next time through */
-
-  return(MS_SUCCESS);
-}
-
-int msDBFJoinClose(joinObj *join)
-{
-  msDBFJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) return(MS_SUCCESS); /* already closed */
-
-  if(joininfo->hDBF) msDBFClose(joininfo->hDBF);
-  if(joininfo->target) free(joininfo->target);
-  free(joininfo);
-  joininfo = NULL;
-
-  return(MS_SUCCESS);
-}
-
-/*  */
-/* CSV (comma separated value) join functions */
-/*  */
-typedef struct {
-  int fromindex, toindex;
-  char *target;
-  char ***rows;
-  int numrows;
-  int nextrow;
-} msCSVJoinInfo;
-
-int msCSVJoinConnect(layerObj *layer, joinObj *join)
-{
-  int i;
-  FILE *stream;
-  char szPath[MS_MAXPATHLEN];
-  msCSVJoinInfo *joininfo;
-  char buffer[MS_BUFFER_LENGTH];
-
-  if(join->joininfo) return(MS_SUCCESS); /* already open */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-
-  /* allocate a msCSVJoinInfo struct */
-  if((joininfo = (msCSVJoinInfo *) malloc(sizeof(msCSVJoinInfo))) == NULL) {
-    msSetError(MS_MEMERR, "Error allocating CSV table info structure.", "msCSVJoinConnect()");
-    return(MS_FAILURE);
-  }
-
-  /* initialize any members that won't get set later on in this function */
-  joininfo->target = NULL;
-  joininfo->nextrow = 0;
-
-  join->joininfo = joininfo;
-
-  /* open the CSV file */
-  if((stream = fopen( msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, join->table), "r" )) == NULL) {
-    if((stream = fopen( msBuildPath(szPath, layer->map->mappath, join->table), "r" )) == NULL) {
-      msSetError(MS_IOERR, "(%s)", "msCSVJoinConnect()", join->table);
-      return(MS_FAILURE);
-    }
-  }
-
-  /* once through to get the number of rows */
-  joininfo->numrows = 0;
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) joininfo->numrows++;
-  rewind(stream);
-
-  if((joininfo->rows = (char ***) malloc(joininfo->numrows*sizeof(char **))) == NULL) {
-    fclose(stream);
-    msSetError(MS_MEMERR, "Error allocating rows.", "msCSVJoinConnect()");
-    return(MS_FAILURE);
-  }
-
-  /* load the rows */
-  i = 0;
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
-    msStringTrimEOL(buffer);
-    joininfo->rows[i] = msStringSplitComplex(buffer, ",", &(join->numitems), MS_ALLOWEMPTYTOKENS);
-    i++;
-  }
-  fclose(stream);
-
-  /* get "from" item index   */
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i],join->from) == 0) { /* found it */
-      joininfo->fromindex = i;
-      break;
-    }
-  }
-
-  if(i == layer->numitems) {
-    msSetError(MS_JOINERR, "Item %s not found in layer %s.", "msCSVJoinConnect()", join->from, layer->name);
-    return(MS_FAILURE);
-  }
-
-  /* get "to" index (for now the user tells us which column, 1..n) */
-  joininfo->toindex = atoi(join->to) - 1;
-  if(joininfo->toindex < 0 || joininfo->toindex > join->numitems) {
-    msSetError(MS_JOINERR, "Invalid column index %s.", "msCSVJoinConnect()", join->to);
-    return(MS_FAILURE);
-  }
-
-  /* store away the column names (1..n) */
-  if((join->items = (char **) malloc(sizeof(char *)*join->numitems)) == NULL) {
-    msSetError(MS_MEMERR, "Error allocating space for join item names.", "msCSVJoinConnect()");
-    return(MS_FAILURE);
-  }
-  for(i=0; i<join->numitems; i++) {
-    join->items[i] = (char *) malloc(12); /* plenty of space */
-    sprintf(join->items[i], "%d", i+1);
-  }
-
-  return(MS_SUCCESS);
-}
-
-int msCSVJoinPrepare(joinObj *join, shapeObj *shape)
-{
-  msCSVJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msCSVJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape) {
-    msSetError(MS_JOINERR, "Shape to be joined is empty.", "msCSVJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape to be joined has no attributes.", "msCSVJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  joininfo->nextrow = 0; /* starting with the first record */
-
-  if(joininfo->target) free(joininfo->target); /* clear last target */
-  joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
-
-  return(MS_SUCCESS);
-}
-
-int msCSVJoinNext(joinObj *join)
-{
-  int i,j;
-  msCSVJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msCSVJoinNext()");
-    return(MS_FAILURE);
-  }
-
-  /* clear any old data */
-  if(join->values) {
-    msFreeCharArray(join->values, join->numitems);
-    join->values = NULL;
-  }
-
-  for(i=joininfo->nextrow; i<joininfo->numrows; i++) { /* find a match     */
-    if(strcmp(joininfo->target, joininfo->rows[i][joininfo->toindex]) == 0) break;
-  }
-
-  if((join->values = (char ** )malloc(sizeof(char *)*join->numitems)) == NULL) {
-    msSetError(MS_MEMERR, NULL, "msCSVJoinNext()");
-    return(MS_FAILURE);
-  }
-
-  if(i == joininfo->numrows) { /* unable to do the join     */
-    for(j=0; j<join->numitems; j++)
-      join->values[j] = msStrdup("\0"); /* intialize to zero length strings */
-
-    joininfo->nextrow = joininfo->numrows;
-    return(MS_DONE);
-  }
-
-  for(j=0; j<join->numitems; j++)
-    join->values[j] = msStrdup(joininfo->rows[i][j]);
-
-  joininfo->nextrow = i+1; /* so we know where to start looking next time through */
-
-  return(MS_SUCCESS);
-}
-
-int msCSVJoinClose(joinObj *join)
-{
-  int i;
-  msCSVJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) return(MS_SUCCESS); /* already closed */
-
-  for(i=0; i<joininfo->numrows; i++)
-    msFreeCharArray(joininfo->rows[i], join->numitems);
-  free(joininfo->rows);
-  if(joininfo->target) free(joininfo->target);
-  free(joininfo);
-  joininfo = NULL;
-
-  return(MS_SUCCESS);
-}
-
-
-#ifdef USE_MYSQL
-
-#ifndef _mysql_h
-#include <mysql/mysql.h>
-#endif
-
-char* DB_HOST = NULL;
-char* DB_USER = NULL;
-char* DB_PASSWD = NULL;
-char* DB_DATABASE = NULL;
-char* delim;
-
-#define MYDEBUG if (0)
-
-MYSQL_RES *msMySQLQuery(char *q, MYSQL *conn)
-{
-  MYSQL_RES *qresult=NULL;
-  if (mysql_query(conn,q) < 0) {
-    mysql_close(conn);
-    msSetError(MS_QUERYERR, "Bad mysql query (%s)", "msMySQLQuery()", q);
-    return qresult;
-  }
-  if (!(qresult=mysql_store_result(conn)))    {
-    mysql_close(conn);
-    msSetError(MS_QUERYERR, "mysql query failed (%s)", "msMySQLQuery()", q);
-    return qresult;
-  }
-  return qresult;
-}
-
-/*  */
-/* mysql join functions */
-/*  */
-typedef struct {
-  MYSQL mysql, *conn;
-  MYSQL_RES *qresult;
-  MYSQL_ROW row;
-  int rows;
-  int fromindex;
-  char *tocolumn;
-  char *target;
-  int nextrecord;
-} msMySQLJoinInfo;
-#endif
-
-
-int msMySQLJoinConnect(layerObj *layer, joinObj *join)
-{
-  (void)layer;
-  (void)join;
-#ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinConnect()");
-  return(MS_FAILURE);
-#else
-  int i;
-  char qbuf[4000];
-  char *conn_decrypted;
-  msMySQLJoinInfo *joininfo;
-
-  MYDEBUG if (setvbuf(stdout, NULL, _IONBF , 0)) {
-    printf("Whoops...");
-  };
-  if(join->joininfo) return(MS_SUCCESS); /* already open */
-
-  /* allocate a msMySQLJoinInfo struct */
-  joininfo = (msMySQLJoinInfo *) malloc(sizeof(msMySQLJoinInfo));
-  if(!joininfo) {
-    msSetError(MS_MEMERR, "Error allocating mysql table info structure.", "msMySQLJoinConnect()");
-    return(MS_FAILURE);
-  }
-
-  /* initialize any members that won't get set later on in this function */
-  joininfo->qresult = NULL;
-  joininfo->target = NULL;
-  joininfo->nextrecord = 0;
-
-  join->joininfo = joininfo;
-
-  /* open the mysql connection */
-
-  if( join->connection == NULL ) {
-    msSetError(MS_QUERYERR, "Error parsing MYSQL JOIN: nothing specified in CONNECTION statement.",
-               "msMySQLJoinConnect()");
-
-    return(MS_FAILURE);
-  }
-
-  conn_decrypted = msDecryptStringTokens(layer->map, join->connection);
-  if (conn_decrypted == NULL) {
-    msSetError(MS_QUERYERR, "Error parsing MYSQL JOIN: unable to decrypt CONNECTION statement.",
-               "msMySQLJoinConnect()");
-    return(MS_FAILURE);
-  }
-
-  delim = msStrdup(":");
-  DB_HOST = msStrdup(strtok(conn_decrypted, delim));
-  DB_USER = msStrdup(strtok(NULL, delim));
-  DB_PASSWD = msStrdup(strtok(NULL, delim));
-  DB_DATABASE = msStrdup(strtok(NULL, delim));
-  free(conn_decrypted);
-
-  if (DB_HOST == NULL || DB_USER == NULL || DB_PASSWD == NULL || DB_DATABASE == NULL) {
-    msSetError(MS_QUERYERR, "DB param error: at least one of HOST, USER, PASSWD or DATABASE is null!", "msMySQLJoinConnect()");
-    return MS_FAILURE;
-  }
-  if (strcmp(DB_PASSWD, "none") == 0) strcpy(DB_PASSWD, "");
-
-#if MYSQL_VERSION_ID >= 40000
-  mysql_init(&(joininfo->mysql));
-  if (!(joininfo->conn = mysql_real_connect(&(joininfo->mysql),DB_HOST,DB_USER,DB_PASSWD,NULL, 0, NULL, 0)))
-#else
-  if (!(joininfo->conn = mysql_connect(&(joininfo->mysql),DB_HOST,DB_USER,DB_PASSWD)))
-#endif
-  {
-    char tmp[4000];
-    snprintf( tmp, sizeof(tmp), "Failed to connect to SQL server: Error: %s\nHost: %s\nUsername:%s\nPassword:%s\n", mysql_error(joininfo->conn), DB_HOST, DB_USER, DB_PASSWD);
-    msSetError(MS_QUERYERR, "%s",
-               "msMYSQLLayerOpen()", tmp);
-    free(joininfo);
-    return MS_FAILURE;
-  }
-
-  MYDEBUG printf("msMYSQLLayerOpen2 called<br>\n");
-  if (mysql_select_db(joininfo->conn,DB_DATABASE) < 0) {
-    mysql_close(joininfo->conn);
-  }
-  MYDEBUG printf("msMYSQLLayerOpen3 called<br>\n");
-  if (joininfo->qresult != NULL) { /* query leftover */
-    MYDEBUG printf("msMYSQLLayerOpen4 called<br>\n");
-    mysql_free_result(joininfo->qresult);
-  }
-  MYDEBUG printf("msMYSQLLayerOpen5 called<br>\n");
-  snprintf(qbuf, sizeof(qbuf), "SELECT count(%s) FROM %s", join->to, join->table);
-  MYDEBUG printf("%s<br>\n", qbuf);
-  if ((joininfo->qresult = msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found, write 'em out for debug */
-    int numrows = mysql_affected_rows(joininfo->conn);
-    MYDEBUG printf("%d rows<br>\n", numrows);
-    for(i=0; i<numrows; i++) {
-      MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
-      MYDEBUG printf("(%s)<BR>\n",row[0]);
-      joininfo->rows = atoi(row[0]);
-    }
-  } else {
-    msSetError(MS_DBFERR, "Item %s not found in table %s.", "msMySQLJoinConnect()", join->to, join->table);
-    return(MS_FAILURE);
-  }
-  snprintf(qbuf, sizeof(qbuf), "EXPLAIN %s", join->table);
-  if ((joininfo->qresult = msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found, write 'em out for debug */
-    join->numitems = mysql_affected_rows(joininfo->conn);
-    if((join->items = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
-      msSetError(MS_MEMERR, NULL, "msMySQLJoinConnect()");
-      return(MS_FAILURE);
-    }
-    MYDEBUG printf("%d rows<br>\n", join->numitems);
-    for(i=0; i<join->numitems; i++) {
-      MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
-      MYDEBUG printf("(%s)<BR>\n",row[0]);
-      join->items[i] = msStrdup(row[0]);
-    }
-  } else {
-    msSetError(MS_DBFERR, "Item %s not found in table %s.", "msMySQLJoinConnect()", join->to, join->table);
-    return(MS_FAILURE);
-  }
-  joininfo->tocolumn = msStrdup(join->to);
-
-
-
-  /* get "from" item index   */
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i],join->from) == 0) { /* found it */
-      joininfo->fromindex = i;
-      break;
-    }
-  }
-
-  if(i == layer->numitems) {
-    msSetError(MS_JOINERR, "Item %s not found in layer %s.", "msMySQLJoinConnect()", join->from, layer->name);
-    return(MS_FAILURE);
-  }
-
-  /* finally store away the item names in the XBase table */
-  if(!join->items) return(MS_FAILURE);
-
-  return(MS_SUCCESS);
-#endif
-}
-
-int msMySQLJoinPrepare(joinObj *join, shapeObj *shape)
-{
-  (void)join;
-  (void)shape;
-#ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinPrepare()");
-  return(MS_FAILURE);
-#else
-  msMySQLJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msMySQLJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape) {
-    msSetError(MS_JOINERR, "Shape to be joined is empty.", "msMySQLJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape to be joined has no attributes.", "msMySQLJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  joininfo->nextrecord = 0; /* starting with the first record */
-
-  if(joininfo->target) free(joininfo->target); /* clear last target */
-  joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
-
-  return(MS_SUCCESS);
-#endif
-}
-
-int msMySQLJoinNext(joinObj *join)
-{
-  (void)join;
-#ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinNext()");
-  return(MS_FAILURE);
-#else
-  int i;
-  char qbuf[4000];
-  msMySQLJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msMySQLJoinNext()");
-    return(MS_FAILURE);
-  }
-
-  if(!joininfo->target) {
-    msSetError(MS_JOINERR, "No target specified, run msMySQLJoinPrepare() first.", "msMySQLJoinNext()");
-    return(MS_FAILURE);
-  }
-
-  /* clear any old data */
-  if(join->values) {
-    msFreeCharArray(join->values, join->numitems);
-    join->values = NULL;
-  }
-
-  /* int n = joininfo->rows; */
-
-  /* for(i=joininfo->nextrecord; i<n; i++) { // find a match */
-  /* if(strcmp(joininfo->target, msMySQLReadStringAttribute(joininfo->conn, i, joininfo->toindex)) == 0) break; */
-  /* }   */
-  snprintf(qbuf, sizeof(qbuf), "SELECT * FROM %s WHERE %s = %s", join->table, joininfo->tocolumn, joininfo->target);
-  MYDEBUG printf("%s<BR>\n", qbuf);
-  if ((joininfo->qresult = msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found, write 'em out for debug */
-    int numrows = mysql_affected_rows(joininfo->conn);
-    int numfields = mysql_field_count(joininfo->conn);
-    MYDEBUG printf("%d rows<br>\n", numrows);
-    if (numrows > 0) {
-      MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
-      for(i=0; i<numfields; i++) {
-        MYDEBUG printf("%s,",row[i]);
-      }
-      MYDEBUG printf("<BR>\n");
-      free(join->values);
-      if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
-        msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
-        return(MS_FAILURE);
-      }
-      for(i=0; i<join->numitems; i++) {
-        /* join->values[i] = msStrdup("\0"); */ /* intialize to zero length strings */
-        join->values[i] = msStrdup(row[i]); /* intialize to zero length strings */
-        /* rows = atoi(row[0]); */
-      }
-    } else {
-      if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
-        msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
-        return(MS_FAILURE);
-      }
-      for(i=0; i<join->numitems; i++)
-        join->values[i] = msStrdup("\0"); /* intialize to zero length strings  */
-
-      return(MS_DONE);
-    }
-  } else {
-    msSetError(MS_QUERYERR, "Query error (%s)", "msMySQLJoinNext()", qbuf);
-    return(MS_FAILURE);
-  }
-
-#ifdef __NOTDEF__
-  if(i == n) { /* unable to do the join */
-    if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
-      msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
-      return(MS_FAILURE);
-    }
-    for(i=0; i<join->numitems; i++)
-      join->values[i] = msStrdup("\0"); /* intialize to zero length strings  */
-
-    joininfo->nextrecord = n;
-    return(MS_DONE);
-  }
-
-  if((join->values = msMySQLGetValues(joininfo->conn,i)) == NULL)
-    return(MS_FAILURE);
-
-  joininfo->nextrecord = i+1; /* so we know where to start looking next time through */
-#endif /* __NOTDEF__ */
-
-  return(MS_SUCCESS);
-#endif
-}
-
-int msMySQLJoinClose(joinObj *join)
-{
-  (void)join;
-#ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinClose()");
-  return(MS_FAILURE);
-#else
-  msMySQLJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) return(MS_SUCCESS); /* already closed */
-
-  mysql_close(joininfo->conn);
-  if(joininfo->target) free(joininfo->target);
-  free(joininfo);
-  joininfo = NULL;
-
-  return(MS_SUCCESS);
-#endif
-}
diff -pruN 8.0.1-5/mapkml.cpp 8.2.0~beta1-1~exp1/mapkml.cpp
--- 8.0.1-5/mapkml.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapkml.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,253 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Headers for mapkml.cpp Google Earth KML output
- * Author:   David Kana and the MapServer team
- *
- ******************************************************************************
- * Copyright (c) 1996-2009 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-#include "mapserver.h"
-
-#ifdef USE_KML
-
-#include "mapkmlrenderer.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-  KmlRenderer* getKmlRenderer(imageObj* img)
-  {
-    return (KmlRenderer*) img->img.plugin;
-  }
-
-  imageObj* msCreateImageKml(int width, int height, outputFormatObj *format, colorObj* bg)
-  {
-    imageObj *image = NULL;
-
-    image = (imageObj*)malloc(sizeof(imageObj));
-    MS_CHECK_ALLOC(image, sizeof(imageObj), NULL);
-    memset(image, 0, sizeof(imageObj));
-
-    KmlRenderer *ren = new KmlRenderer(width, height, format, bg);
-    image->img.plugin = (void *) ren;
-
-    return image;
-  }
-
-  int msSaveImageKml(imageObj *img, mapObj* /*map*/, FILE *fp, outputFormatObj *format)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    return renderer->saveImage(img, fp, format);
-  }
-
-  int msRenderLineKml(imageObj *img, shapeObj *p, strokeStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderLine(img, p, style);
-    return MS_SUCCESS;
-  }
-
-  int msRenderPolygonKml(imageObj *img, shapeObj *p, colorObj *color)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderPolygon(img, p, color);
-    return MS_SUCCESS;
-  }
-
-  int msRenderPolygonTiledKml(imageObj * /*img*/, shapeObj * /*p*/,  imageObj * /*tile*/)
-  {
-    /*KmlRenderer* renderer = getKmlRenderer(img);*/
-    return MS_SUCCESS;
-  }
-
-  int msRenderLineTiledKml(imageObj * /*img*/, shapeObj * /*p*/, imageObj * /*tile*/)
-  {
-    return MS_SUCCESS;
-  }
-
-  int msRenderGlyphsKml(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow, int /*isMarker*/)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderGlyphs(img, ts, c, oc, ow);
-    return MS_SUCCESS;
-  }
-
-  int msRenderVectorSymbolKml(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderVectorSymbol(img, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
-
-  int msRenderPixmapSymbolKml(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderPixmapSymbol(img, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
-
-  int msRenderEllipseSymbolKml(imageObj *image, double x, double y,
-                               symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(image);
-    renderer->renderEllipseSymbol(image, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
-
-  int msRenderTruetypeSymbolKml(imageObj *image, double x, double y,
-                                symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(image);
-    renderer->renderTruetypeSymbol(image, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
-
-
-  int msRenderTileKml(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/, double /*y*/)
-  {
-    return MS_SUCCESS;
-  }
-
-  int msGetRasterBufferKml(imageObj * /*img*/,rasterBufferObj * /*rb*/)
-  {
-    return MS_FAILURE; //not supported for kml
-  }
-
-
-  int msGetTruetypeTextBBoxKml(rendererVTableObj * /*r*/,char** /*fonts*/, int /*numfonts*/, double size, char *string,
-                               rectObj *rect, double **advances, int /*bAdjustBaseline*/)
-  {
-    rect->minx=0.0;
-    rect->maxx=0.0;
-    rect->miny=0.0;
-    rect->maxy=0.0;
-    if (advances) {
-      int numglyphs = msGetNumGlyphs(string);
-      *advances = (double*) msSmallMalloc(numglyphs * sizeof (double));
-      for(int i=0; i<numglyphs; i++) {
-        (*advances)[i] = size;
-      }
-    }
-    return MS_SUCCESS;
-  }
-
-  int msStartNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    return renderer->startNewLayer(img, layer);
-  }
-
-  int msCloseNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    return renderer->closeNewLayer(img, layer);
-  }
-
-  int msFreeImageKml(imageObj *image)
-  {
-    KmlRenderer* renderer = getKmlRenderer(image);
-    if (renderer) {
-      delete renderer;
-    }
-    image->img.plugin=NULL;
-    return MS_SUCCESS;
-  }
-
-  int msFreeSymbolKml(symbolObj * /*symbol*/)
-  {
-    return MS_SUCCESS;
-  }
-
-  int msStartShapeKml(imageObj *img, shapeObj *shape)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->startShape(img, shape);
-    return MS_SUCCESS;
-  }
-
-  int msEndShapeKml(imageObj *img, shapeObj *shape)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->endShape(img, shape);
-    return MS_SUCCESS;
-  }
-
-  int msMergeRasterBufferKml(imageObj *dest, rasterBufferObj *overlay, double /*opacity*/, int /*srcX*/,
-                             int /*srcY*/, int /*dstX*/, int /*dstY*/, int /*width*/, int /*height*/)
-  {
-    KmlRenderer* renderer = getKmlRenderer(dest);
-    return renderer->mergeRasterBuffer(dest,overlay);
-  }
-
-#ifdef __cplusplus
-}
-#endif
-
-
-#endif /*USE_KML*/
-
-int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height, int mode);
-
-int msPopulateRendererVTableKML( rendererVTableObj *renderer )
-{
-#ifdef USE_KML
-  renderer->supports_pixel_buffer = 0;
-  renderer->supports_clipping = 0;
-  renderer->use_imagecache = 0;
-  renderer->default_transform_mode = MS_TRANSFORM_NONE;
-
-  renderer->startLayer = msStartNewLayerKml;
-  renderer->endLayer = msCloseNewLayerKml;
-  renderer->renderLine=&msRenderLineKml;
-  renderer->createImage=&msCreateImageKml;
-  renderer->saveImage=&msSaveImageKml;
-  renderer->renderPolygon=&msRenderPolygonKml;
-  renderer->renderGlyphs=&msRenderGlyphsKml;
-  renderer->renderEllipseSymbol = &msRenderEllipseSymbolKml;
-  renderer->renderVectorSymbol = &msRenderVectorSymbolKml;
-  renderer->renderPixmapSymbol = &msRenderPixmapSymbolKml;
-  renderer->mergeRasterBuffer = &msMergeRasterBufferKml;
-  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
-  renderer->initializeRasterBuffer = aggInitializeRasterBuffer;
-  renderer->renderTile = &msRenderTileKml;
-  renderer->renderPolygonTiled = &msRenderPolygonTiledKml;
-  renderer->renderLineTiled = NULL;
-  renderer->freeSymbol = &msFreeSymbolKml;
-  renderer->freeImage=&msFreeImageKml;
-  renderer->mergeRasterBuffer = msMergeRasterBufferKml;
-  renderer->compositeRasterBuffer = NULL;
-
-  renderer->startShape=&msStartShapeKml;
-  renderer->endShape=&msEndShapeKml;
-
-  return MS_SUCCESS;
-#else
-  msSetError(MS_MISCERR, "KML Driver requested but is not built in",
-             "msPopulateRendererVTableKML()");
-  return MS_FAILURE;
-#endif
-}
-
diff -pruN 8.0.1-5/mapkmlrenderer.cpp 8.2.0~beta1-1~exp1/mapkmlrenderer.cpp
--- 8.0.1-5/mapkmlrenderer.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapkmlrenderer.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1279 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Google Earth KML output
- * Author:   David Kana and the MapServer team
- *
- ******************************************************************************
- * Copyright (c) 1996-2009 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver-config.h"
-#ifdef USE_KML
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapkmlrenderer.h"
-#include "mapio.h"
-#include "mapows.h"
-
-#include "cpl_conv.h"
-#include "cpl_vsi.h"
-
-#define  KML_MAXFEATURES_TODRAW 1000
-
-KmlRenderer::KmlRenderer(int width, int height, outputFormatObj * /*format*/, colorObj* /*color*/)
-  : Width(width), Height(height), MapCellsize(1.0), XmlDoc(NULL), LayerNode(NULL), GroundOverlayNode(NULL),
-    PlacemarkNode(NULL), GeomNode(NULL),
-    Items(NULL), NumItems(0), FirstLayer(MS_TRUE), map(NULL), currentLayer(NULL),
-    mElevationFromAttribute( false ), mElevationAttributeIndex( -1 ), mCurrentElevationValue(0.0)
-
-{
-  /*private variables*/
-  pszLayerDescMetadata = NULL;
-  papszLayerIncludeItems = NULL;
-  nIncludeItems=0;
-  papszLayerExcludeItems = NULL;
-  nExcludeItems=0;
-  pszLayerNameAttributeMetadata = NULL;  /*metadata to use for a name for each feature*/
-
-  LineStyle = NULL;
-  numLineStyle = 0;
-
-  xmlNodePtr styleNode;
-  xmlNodePtr listStyleNode;
-  /*  Create document.*/
-  XmlDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  xmlNodePtr rootNode = xmlNewNode(NULL, BAD_CAST "kml");
-
-  /*  Name spaces*/
-  xmlSetNs(rootNode, xmlNewNs(rootNode, BAD_CAST "http://www.opengis.net/kml/2.2", NULL));
-
-  xmlDocSetRootElement(XmlDoc, rootNode);
-
-  DocNode = xmlNewChild(rootNode, NULL, BAD_CAST "Document", NULL);
-
-  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
-  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_check");
-  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
-  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "check");
-
-  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
-  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_checkHideChildren");
-  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
-  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "checkHideChildren");
-
-  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
-  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_checkOffOnly");
-  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
-  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "checkOffOnly");
-
-  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
-  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_radioFolder");
-  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
-  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "radioFolder");
-
-
-  StyleHashTable = msCreateHashTable();
-
-}
-
-KmlRenderer::~KmlRenderer()
-{
-  if (XmlDoc)
-    xmlFreeDoc(XmlDoc);
-
-  if (StyleHashTable)
-    msFreeHashTable(StyleHashTable);
-
-  if(LineStyle)
-    msFree(LineStyle);
-
-  xmlCleanupParser();
-}
-
-imageObj* KmlRenderer::createImage(int, int, outputFormatObj*, colorObj*)
-{
-  return NULL;
-}
-
-int KmlRenderer::saveImage(imageObj *, FILE *fp, outputFormatObj *format)
-{
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document.                                         */
-  /* -------------------------------------------------------------------- */
-
-  int bufSize = 0;
-  xmlChar *buf = NULL;
-  msIOContext *context = NULL;
-  int chunkSize = 4096;
-  int bZip = MS_FALSE;
-
-  if( msIO_needBinaryStdout() == MS_FAILURE )
-    return MS_FAILURE;
-
-  xmlDocDumpFormatMemoryEnc(XmlDoc, &buf, &bufSize, "UTF-8", 1);
-
-  if (format && format->driver && strcasecmp(format->driver, "kmz") == 0) {
-    bZip = MS_TRUE;
-  }
-
-  if (bZip) {
-    VSILFILE *fpZip;
-    int bytes_read;
-    char buffer[1024];
-    char *zip_filename =NULL;
-    void *hZip=NULL;
-
-    zip_filename = msTmpFile(NULL, NULL, "/vsimem/kmlzip/", "kmz" );
-    hZip = CPLCreateZip( zip_filename, NULL );
-    CPLCreateFileInZip( hZip, "mapserver.kml", NULL );
-    for (int i=0; i<bufSize; i+=chunkSize) {
-      int size = chunkSize;
-      if (i + size > bufSize)
-        size = bufSize - i;
-      CPLWriteFileInZip( hZip,  buf+i, size);
-    }
-    CPLCloseFileInZip( hZip );
-    CPLCloseZip( hZip );
-
-    context = msIO_getHandler(fp);
-    fpZip = VSIFOpenL( zip_filename, "r" );
-
-    while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fpZip )) > 0 ) {
-      if (context)
-        msIO_contextWrite(context, buffer, bytes_read);
-      else
-        msIO_fwrite( buffer, 1, bytes_read, fp );
-    }
-    VSIFCloseL( fpZip );
-    msFree( zip_filename);
-    xmlFree(buf);
-    return(MS_SUCCESS);
-  }
-
-  context = msIO_getHandler(fp);
-
-
-  for (int i=0; i<bufSize; i+=chunkSize) {
-    int size = chunkSize;
-    if (i + size > bufSize)
-      size = bufSize - i;
-
-    if (context)
-      msIO_contextWrite(context, buf+i, size);
-    else
-      msIO_fwrite(buf+i, 1, size, fp);
-  }
-
-  xmlFree(buf);
-
-  return(MS_SUCCESS);
-}
-
-
-/************************************************************************/
-/*                               processLayer                           */
-/*                                                                      */
-/*      Set parameters that make sense to a kml output.                 */
-/************************************************************************/
-void KmlRenderer::processLayer(layerObj *layer, outputFormatObj *format)
-{
-  int i;
-  const char *asRaster = NULL;
-  int nMaxFeatures = -1;
-  const char *pszTmp;
-  char szTmp[10];
-
-  if (!layer)
-    return;
-
-  /*turn of labelcache*/
-  layer->labelcache = MS_OFF;
-
-  /*if there are labels we want the coordinates to
-    be the center of the element.*/
-  for(i=0; i<layer->numclasses; i++)
-    if(layer->_class[i]->numlabels > 0) layer->_class[i]->labels[0]->position = MS_XY;
-
-  /*we do not want to draw multiple styles.
-    the new rendering architecture does not allow
-    to know if we are dealing with a multi-style.
-    So here we remove all styles beside the first one*/
-
-  for(i=0; i<layer->numclasses; i++) {
-    while (layer->_class[i]->numstyles > 1)
-      msDeleteStyle(layer->_class[i], layer->_class[i]->numstyles-1);
-  }
-
-  /*if layer has a metadata KML_OUTPUTASRASTER set to true, add a processing directive
-    to use an agg driver*/
-  asRaster = msLookupHashTable(&layer->metadata, "kml_outputasraster");
-  if (!asRaster)
-    asRaster = msLookupHashTable(&(layer->map->web.metadata), "kml_outputasraster");
-  if (asRaster && (strcasecmp(asRaster, "true") == 0 ||
-                   strcasecmp(asRaster, "yes") == 0))
-    msLayerAddProcessing(layer, "RENDERER=png24");
-
-
-  /*set a maxfeaturestodraw, if not already set*/
-
-  pszTmp = msLookupHashTable(&layer->metadata, "maxfeaturestodraw");
-  if (pszTmp)
-    nMaxFeatures = atoi(pszTmp);
-  else {
-    pszTmp = msLookupHashTable(&layer->map->web.metadata, "maxfeaturestodraw");
-    if (pszTmp)
-      nMaxFeatures = atoi(pszTmp);
-  }
-  if (nMaxFeatures < 0 && format)
-    nMaxFeatures = atoi(msGetOutputFormatOption( format, "maxfeaturestodraw", "-1"));
-
-  if (nMaxFeatures < 0 && format) {
-    snprintf(szTmp, sizeof(szTmp), "%d", KML_MAXFEATURES_TODRAW);
-    msSetOutputFormatOption( format, "maxfeaturestodraw", szTmp);
-  }
-
-}
-
-/************************************************************************/
-/*                               getLayerName                           */
-/*                                                                      */
-/*      Internal utility function to build name used fo rthe layer.     */
-/************************************************************************/
-char* KmlRenderer::getLayerName(layerObj *layer)
-{
-  char stmp[20];
-  const char *name=NULL;;
-
-  if (!layer)
-    return NULL;
-
-
-  name = msLookupHashTable(&layer->metadata, "ows_name");
-  if (name && strlen(name) > 0)
-    return msStrdup(name);
-
-  if (layer->name && strlen(layer->name) > 0)
-    return msStrdup(layer->name);
-
-  sprintf(stmp, "Layer%d",layer->index);
-  return msStrdup(stmp);
-
-}
-
-const char* KmlRenderer::getAliasName(layerObj *lp, char *pszItemName, const char *namespaces)
-{
-  const char *pszAlias = NULL;
-  if (lp && pszItemName && strlen(pszItemName) > 0) {
-    char szTmp[256];
-    snprintf(szTmp, sizeof(szTmp), "%s_alias", pszItemName);
-    pszAlias = msOWSLookupMetadata(&(lp->metadata), namespaces, szTmp);
-  }
-  return pszAlias;
-}
-
-int KmlRenderer::startNewLayer(imageObj *img, layerObj *layer)
-{
-  char *layerName=NULL;
-  const char *value=NULL;
-
-  LayerNode = xmlNewNode(NULL, BAD_CAST "Folder");
-
-  layerName = getLayerName(layer);
-  xmlNewChild(LayerNode, NULL, BAD_CAST "name", BAD_CAST layerName);
-  msFree(layerName);
-
-  const char *layerVisibility = layer->status != MS_OFF ? "1" : "0";
-  xmlNewChild(LayerNode, NULL, BAD_CAST "visibility", BAD_CAST layerVisibility);
-
-  const char *layerDsiplayFolder = msLookupHashTable(&(layer->metadata), "kml_folder_display");
-  if (layerDsiplayFolder == NULL)
-    layerDsiplayFolder = msLookupHashTable(&(layer->map->web.metadata), "kml_folder_display");
-  if (!layerDsiplayFolder || strlen(layerDsiplayFolder)<=0) {
-    xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_check");
-  }
-
-  else {
-    if (strcasecmp(layerDsiplayFolder, "checkHideChildren") == 0)
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_checkHideChildren");
-    else if (strcasecmp(layerDsiplayFolder, "checkOffOnly") == 0)
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_checkOffOnly");
-    else if (strcasecmp(layerDsiplayFolder, "radioFolder") == 0)
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_radioFolder");
-    else
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_check");
-  }
-
-
-  /*Init few things on the first layer*/
-  if (FirstLayer) {
-    FirstLayer = MS_FALSE;
-    map = layer->map;
-
-    if (layer->map->mappath)
-      snprintf(MapPath, sizeof(MapPath), "%s", layer->map->mappath);
-
-    /*First rendered layer - check mapfile projection*/
-    checkProjection(layer->map);
-
-    /*check for image path and image url*/
-    if (layer->map->debug && (layer->map->web.imageurl == NULL ||   layer->map->web.imagepath == NULL))
-      msDebug("KmlRenderer::startNewLayer: imagepath and imageurl should be set in the web object\n");
-
-
-    /*map rect for ground overlay*/
-    MapExtent = layer->map->extent;
-    MapCellsize = layer->map->cellsize;
-    BgColor = layer->map->imagecolor;
-
-    xmlNewChild(DocNode, NULL, BAD_CAST "name", BAD_CAST layer->map->name);
-    aggFormat = msSelectOutputFormat( layer->map, "png24");
-    aggFormat->transparent = MS_TRUE;
-
-  }
-
-  currentLayer = layer;
-
-  if (!msLayerIsOpen(layer)) {
-    if (msLayerOpen(layer) != MS_SUCCESS) {
-      msSetError(MS_MISCERR, "msLayerOpen failed", "KmlRenderer::startNewLayer" );
-      return MS_FAILURE;
-    }
-  }
-
-  /*pre process the layer to set things that make sense for kml output*/
-  if (img)
-    processLayer(layer, img->format);
-  else
-    processLayer(layer, NULL);
-
-  if (msLookupHashTable(&layer->metadata, "kml_description"))
-    pszLayerDescMetadata = msLookupHashTable(&layer->metadata, "kml_description");
-  else if (msLookupHashTable(&layer->metadata, "ows_description"))
-    pszLayerDescMetadata = msLookupHashTable(&layer->metadata, "ows_description");
-
-  value=msLookupHashTable(&layer->metadata, "kml_include_items");
-  if (!value)
-    value=msLookupHashTable(&layer->metadata, "ows_include_items");
-  if (value)
-    papszLayerIncludeItems = msStringSplit(value, ',', &nIncludeItems);
-
-  value=msLookupHashTable(&layer->metadata, "kml_exclude_items");
-  if (!value)
-    value=msLookupHashTable(&layer->metadata, "ows_exclude_items");
-  if (value)
-    papszLayerExcludeItems = msStringSplit(value, ',', &nExcludeItems);
-
-
-  if (msLookupHashTable(&layer->metadata, "kml_name_item"))
-    pszLayerNameAttributeMetadata = msLookupHashTable(&layer->metadata, "kml_name_item");
-
-  /*get all attributes*/
-  if(msLayerWhichItems(layer, MS_TRUE, NULL) != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-
-  NumItems = layer->numitems;
-  if (NumItems) {
-    Items = (char **)msSmallCalloc(NumItems, sizeof(char *));
-    for (int i=0; i<NumItems; i++)
-      Items[i] = msStrdup(layer->items[i]);
-  }
-
-
-  const char* elevationAttribute = msLookupHashTable(&layer->metadata, "kml_elevation_attribute");
-  if( elevationAttribute ) {
-    mElevationFromAttribute = true;
-    for( int i = 0; i < layer->numitems; ++i ) {
-      if( strcasecmp( layer->items[i], elevationAttribute ) == 0 ) {
-        mElevationAttributeIndex = i;
-      }
-    }
-  }
-
-  setupRenderingParams(&layer->metadata);
-  return MS_SUCCESS;
-}
-
-int KmlRenderer::closeNewLayer(imageObj *, layerObj *)
-{
-  flushPlacemark();
-
-  xmlAddChild(DocNode, LayerNode);
-
-  if(Items) {
-    msFreeCharArray(Items, NumItems);
-    Items = NULL;
-    NumItems = 0;
-  }
-
-  if (pszLayerDescMetadata)
-    pszLayerDescMetadata = NULL;
-  if (pszLayerNameAttributeMetadata)
-    pszLayerNameAttributeMetadata = NULL;
-
-  if (papszLayerIncludeItems && nIncludeItems>0)
-    msFreeCharArray(papszLayerIncludeItems, nIncludeItems);
-  papszLayerIncludeItems=NULL;
-
-  if (papszLayerExcludeItems && nExcludeItems>0)
-    msFreeCharArray(papszLayerExcludeItems, nExcludeItems);
-  papszLayerExcludeItems=NULL;
-
-  return MS_SUCCESS;
-}
-
-int KmlRenderer::mergeRasterBuffer(imageObj *image, rasterBufferObj *rb)
-{
-  assert(rb && rb->type == MS_BUFFER_BYTE_RGBA);
-  char *tmpFileName = NULL;
-  char *tmpUrl = NULL;
-  FILE *tmpFile = NULL;
-
-  tmpFileName = msTmpFile(NULL, MapPath, image->imagepath, "png");
-  tmpFile = fopen(tmpFileName,"wb");
-  if (tmpFile) {
-
-    if (!aggFormat->vtable)
-      msInitializeRendererVTable(aggFormat);
-
-    msSaveRasterBuffer(map,rb,tmpFile,aggFormat);
-    tmpUrl = msStrdup( image->imageurl);
-    tmpUrl = msStringConcatenate(tmpUrl, (char *)(msGetBasename(tmpFileName)));
-    tmpUrl = msStringConcatenate(tmpUrl, ".png");
-
-    createGroundOverlayNode(LayerNode, tmpUrl, currentLayer);
-    msFree(tmpFileName);
-    msFree(tmpUrl);
-    fclose(tmpFile);
-    return MS_SUCCESS;
-  } else {
-    msSetError(MS_IOERR,"Failed to create file for kml overlay","KmlRenderer::mergeRasterBuffer()");
-    return MS_FAILURE;
-  }
-}
-
-void KmlRenderer::setupRenderingParams(hashTableObj *layerMetadata)
-{
-  AltitudeMode = 0;
-  Extrude = 0;
-  Tessellate = 0;
-
-  const char *altitudeModeVal = msLookupHashTable(layerMetadata, "kml_altitudeMode");
-  if (altitudeModeVal) {
-    if(strcasecmp(altitudeModeVal, "absolute") == 0)
-      AltitudeMode = absolute;
-    else if(strcasecmp(altitudeModeVal, "relativeToGround") == 0)
-      AltitudeMode = relativeToGround;
-    else if(strcasecmp(altitudeModeVal, "clampToGround") == 0)
-      AltitudeMode = clampToGround;
-  }
-
-  const char *extrudeVal = msLookupHashTable(layerMetadata, "kml_extrude");
-  if (altitudeModeVal) {
-    Extrude = atoi(extrudeVal);
-  }
-
-  const char *tessellateVal = msLookupHashTable(layerMetadata, "kml_tessellate");
-  if (tessellateVal) {
-    Tessellate = atoi(tessellateVal);
-  }
-
-}
-
-int KmlRenderer::checkProjection(mapObj *map)
-{
-  projectionObj *projection= &map->projection;
-  if (projection && projection->numargs > 0 && msProjIsGeographicCRS(projection)) {
-    return MS_SUCCESS;
-  } else {
-    char epsg_string[100];
-    rectObj sRect;
-    projectionObj out;
-
-    /* for layer the do not have any projection set, set them with the current map
-       projection*/
-    if (projection && projection->numargs > 0) {
-      layerObj *lp = NULL;
-      int i =0;
-      char *pszMapProjectString = msGetProjectionString(projection);
-      if (pszMapProjectString) {
-        for(i=0; i<map->numlayers; i++) {
-          lp = GET_LAYER(map, i);
-          if (lp->projection.numargs == 0 && lp->transform == MS_TRUE) {
-            msFreeProjection(&lp->projection);
-            msLoadProjectionString(&lp->projection, pszMapProjectString);
-          }
-        }
-        msFree(pszMapProjectString);
-      }
-    }
-    strcpy(epsg_string, "epsg:4326" );
-    msInitProjection(&out);
-    msProjectionInheritContextFrom(&out, projection);
-    msLoadProjectionString(&out, epsg_string);
-
-    sRect = map->extent;
-    msProjectRect(projection, &out, &sRect);
-    msFreeProjectionExceptContext(projection);
-    msLoadProjectionString(projection, epsg_string);
-
-    /*change also units and extents*/
-    map->extent = sRect;
-    map->units = MS_DD;
-
-
-    if (map->debug)
-      msDebug("KmlRenderer::checkProjection: Mapfile projection set to epsg:4326\n");
-
-    return MS_SUCCESS;
-  }
-}
-
-xmlNodePtr KmlRenderer::createPlacemarkNode(xmlNodePtr parentNode, char *styleUrl)
-{
-  xmlNodePtr placemarkNode = xmlNewChild(parentNode, NULL, BAD_CAST "Placemark", NULL);
-  /*always add a name. It will be replaced by a text value if available*/
-  char tmpid[100];
-  char *stmp=NULL, *layerName=NULL;
-  if (CurrentShapeName && strlen(CurrentShapeName)>0) {
-    xmlNewChild(placemarkNode, NULL, BAD_CAST "name", BAD_CAST CurrentShapeName);
-  } else {
-    sprintf(tmpid, ".%d", CurrentShapeIndex);
-    layerName = getLayerName(currentLayer);
-    stmp = msStringConcatenate(stmp, layerName);
-    stmp = msStringConcatenate(stmp, tmpid);
-    xmlNewChild(placemarkNode, NULL, BAD_CAST "name", BAD_CAST stmp);
-  }
-  msFree(layerName);
-  msFree(stmp);
-  if (styleUrl)
-    xmlNewChild(placemarkNode, NULL, BAD_CAST "styleUrl", BAD_CAST styleUrl);
-
-  return placemarkNode;
-}
-
-void KmlRenderer::renderLine(imageObj*, shapeObj *p, strokeStyleObj *style)
-{
-  if (p->numlines == 0)
-    return;
-
-  if (PlacemarkNode == NULL)
-    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
-
-  if (!PlacemarkNode)
-    return;
-
-  addLineStyleToList(style);
-  SymbologyFlag[Line] = 1;
-
-  /*p->index > CurrentDrawnShapeIndexneed to be reviewd. Added since the hight
-    level code caches shapes when rendering lines*/
-  if (CurrentDrawnShapeIndex == -1 || p->index > CurrentDrawnShapeIndex) {
-    xmlNodePtr geomNode = getGeomParentNode("LineString");
-    addAddRenderingSpecifications(geomNode);
-    addCoordsNode(geomNode, p->line[0].point, p->line[0].numpoints);
-
-    /* more than one line => MultiGeometry*/
-    if (p->numlines > 1) {
-      geomNode = getGeomParentNode("LineString"); // returns MultiGeom Node
-      for (int i=1; i<p->numlines; i++) {
-        xmlNodePtr lineStringNode = xmlNewChild(geomNode, NULL, BAD_CAST "LineString", NULL);
-        addAddRenderingSpecifications(lineStringNode);
-        addCoordsNode(lineStringNode, p->line[i].point, p->line[i].numpoints);
-      }
-    }
-
-    CurrentDrawnShapeIndex = p->index;
-  }
-
-}
-
-void KmlRenderer::renderPolygon(imageObj*, shapeObj *p, colorObj *color)
-{
-  if (PlacemarkNode == NULL)
-    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
-
-  if (!PlacemarkNode)
-    return;
-
-  memcpy(&PolygonColor, color, sizeof(colorObj));
-  SymbologyFlag[Polygon] = 1;
-
-
-  if (p->index != CurrentDrawnShapeIndex) {
-
-    xmlNodePtr geomParentNode = getGeomParentNode("Polygon");
-
-    for (int i=0; i<p->numlines; i++) {
-      xmlNodePtr bdryNode = NULL;
-
-      if (i==0) /* __TODO__ check ring order*/
-        bdryNode = xmlNewChild(geomParentNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
-      else
-        bdryNode = xmlNewChild(geomParentNode, NULL, BAD_CAST "innerBoundaryIs", NULL);
-
-      xmlNodePtr ringNode = xmlNewChild(bdryNode, NULL, BAD_CAST "LinearRing", NULL);
-      addAddRenderingSpecifications(ringNode);
-      addCoordsNode(ringNode, p->line[i].point, p->line[i].numpoints);
-    }
-
-    CurrentDrawnShapeIndex = p->index;
-
-  }
-
-}
-
-void KmlRenderer::addCoordsNode(xmlNodePtr parentNode, pointObj *pts, int numPts)
-{
-  char lineBuf[128];
-
-  xmlNodePtr coordsNode = xmlNewChild(parentNode, NULL, BAD_CAST "coordinates", NULL);
-  xmlNodeAddContent(coordsNode, BAD_CAST "\n");
-
-  for (int i=0; i<numPts; i++) {
-    if( mElevationFromAttribute ) {
-      sprintf(lineBuf, "\t%.8f,%.8f,%.8f\n", pts[i].x, pts[i].y, mCurrentElevationValue);
-    } else if (AltitudeMode == relativeToGround || AltitudeMode == absolute) {
-      sprintf(lineBuf, "\t%.8f,%.8f,%.8f\n", pts[i].x, pts[i].y, pts[i].z);
-    } else
-      sprintf(lineBuf, "\t%.8f,%.8f\n", pts[i].x, pts[i].y);
-
-    xmlNodeAddContent(coordsNode, BAD_CAST lineBuf);
-  }
-  xmlNodeAddContent(coordsNode, BAD_CAST "\t");
-}
-
-void KmlRenderer::renderGlyphs(imageObj *, const textSymbolObj *ts, colorObj *clr, colorObj * /*oc*/, int /*ow*/)
-{
-  if( ts->annotext == NULL || ts->textpath->numglyphs == 0 )
-    return;
-
-  if (PlacemarkNode == NULL)
-    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
-
-  if (!PlacemarkNode)
-    return;
-
-  memcpy(&LabelColor, clr, sizeof(colorObj));
-  SymbologyFlag[Label] = 1;
-
-  /*there is alaws a default name (layer.shapeid). Replace it*/
-  for (xmlNodePtr node = PlacemarkNode->children; node; node = node->next) {
-    if (node->type != XML_ELEMENT_NODE)
-      continue;
-
-    if (strcmp((char *)node->name, "name") == 0) {
-      xmlNodeSetContent(node,  BAD_CAST ts->annotext);
-      break;
-    }
-  }
-
-  /*xmlNewChild(PlacemarkNode, NULL, BAD_CAST "name", BAD_CAST text);*/
-
-  xmlNodePtr geomNode = getGeomParentNode("Point");
-  addAddRenderingSpecifications(geomNode);
-
-  pointObj pt;
-  pt.x = ts->textpath->glyphs[0].pnt.x;
-  pt.y = ts->textpath->glyphs[0].pnt.y;
-  addCoordsNode(geomNode, &pt, 1);
-}
-
-void KmlRenderer::addAddRenderingSpecifications(xmlNodePtr node)
-{
-  /*
-    <extrude>0</extrude>                   <!-- boolean -->
-    <tessellate>0</tessellate>             <!-- boolean -->
-    <altitudeMode>clampToGround</altitudeMode>
-  */
-
-  if (Extrude)
-    xmlNewChild(node, NULL, BAD_CAST "extrude", BAD_CAST "1");
-
-  if (Tessellate)
-    xmlNewChild(node, NULL, BAD_CAST "tessellate", BAD_CAST "1");
-
-  if (AltitudeMode == absolute)
-    xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "absolute");
-  else if (AltitudeMode == relativeToGround)
-    xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "relativeToGround");
-  else if (AltitudeMode == clampToGround)
-    xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "clampToGround");
-}
-
-
-imageObj *agg2CreateImage(int width, int height, outputFormatObj *format, colorObj * bg);
-
-int KmlRenderer::createIconImage(char *fileName, symbolObj *symbol, symbolStyleObj *symstyle)
-{
-  pointObj p;
-  int status;
-
-  imageObj *tmpImg = NULL;
-
-  tmpImg = agg2CreateImage((int)(symbol->sizex*symstyle->scale),
-                           (int)(symbol->sizey*symstyle->scale),
-                           aggFormat, NULL);
-  tmpImg->format = aggFormat;
-  if (!aggFormat->vtable)
-    msInitializeRendererVTable(aggFormat);
-
-  p.x = symbol->sizex * symstyle->scale / 2;
-  p.y = symbol->sizey *symstyle->scale / 2;
-  p.z = 0.0;
-
-  status = msDrawMarkerSymbol(map,tmpImg, &p, symstyle->style, 1);
-  if( status != MS_SUCCESS )
-    return status;
-
-  return msSaveImage(map, tmpImg, fileName);
-}
-
-void KmlRenderer::renderSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style)
-{
-  if (PlacemarkNode == NULL)
-    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
-
-  if (!PlacemarkNode)
-    return;
-
-  snprintf(SymbolUrl, sizeof(SymbolUrl), "%s", lookupSymbolUrl(img, symbol, style));
-  SymbologyFlag[Symbol] = 1;
-
-  xmlNodePtr geomNode = getGeomParentNode("Point");
-  addAddRenderingSpecifications(geomNode);
-
-  pointObj pt;
-  pt.x = x;
-  pt.y = y;
-  addCoordsNode(geomNode, &pt, 1);
-}
-
-void KmlRenderer::renderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                     symbolStyleObj *style)
-{
-  renderSymbol(img, x, y, symbol, style);
-}
-
-void KmlRenderer::renderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                     symbolStyleObj *style)
-{
-  renderSymbol(img, x, y, symbol, style);
-}
-
-void KmlRenderer::renderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                      symbolStyleObj *style)
-{
-  renderSymbol(img, x, y, symbol, style);
-}
-
-void KmlRenderer::renderTruetypeSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                       symbolStyleObj *style)
-{
-  renderSymbol(img, x, y, symbol, style);
-}
-
-xmlNodePtr KmlRenderer::createGroundOverlayNode(xmlNodePtr parentNode, char *imageHref, layerObj *layer)
-{
-  /*
-    <?xml version="1.0" encoding="UTF-8"?>
-    <kml xmlns="http://www.opengis.net/kml/2.2">
-    <GroundOverlay>
-    <name>GroundOverlay.kml</name>
-    <color>7fffffff</color>
-    <drawOrder>1</drawOrder>
-    <Icon>
-    <href>http://www.google.com/intl/en/images/logo.gif</href>
-    <refreshMode>onInterval</refreshMode>
-    <refreshInterval>86400</refreshInterval>
-    <viewBoundScale>0.75</viewBoundScale>
-    </Icon>
-    <LatLonBox>
-    <north>37.83234</north>
-    <south>37.832122</south>
-    <east>-122.373033</east>
-    <west>-122.373724</west>
-    <rotation>45</rotation>
-    </LatLonBox>
-    </GroundOverlay>
-    </kml>
-  */
-  char  layerHexColor[32];
-  xmlNodePtr groundOverlayNode = xmlNewChild(parentNode, NULL, BAD_CAST "GroundOverlay", NULL);
-  char *layerName = getLayerName(layer);
-  xmlNewChild(groundOverlayNode, NULL, BAD_CAST "name", BAD_CAST layerName);
-  if (layer->compositer && layer->compositer->opacity > 0 && layer->compositer->opacity < 100) {
-    sprintf(layerHexColor, "%02xffffff", (unsigned int)MS_NINT(layer->compositer->opacity*2.55));
-    xmlNewChild(groundOverlayNode, NULL, BAD_CAST "color", BAD_CAST layerHexColor);
-  } else
-    xmlNewChild(groundOverlayNode, NULL, BAD_CAST "color", BAD_CAST "ffffffff");
-  char stmp[20];
-  sprintf(stmp, "%d",layer->index);
-  xmlNewChild(groundOverlayNode, NULL, BAD_CAST "drawOrder", BAD_CAST stmp);
-
-  if (imageHref) {
-    xmlNodePtr iconNode = xmlNewChild(groundOverlayNode, NULL, BAD_CAST "Icon", NULL);
-    xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST imageHref);
-  }
-
-  char crdStr[64];
-  rectObj mapextent;
-  if (map->gt.need_geotransform == MS_TRUE)
-    mapextent = currentLayer->map->saved_extent;
-  else
-    mapextent = currentLayer->map->extent;
-
-  xmlNodePtr latLonBoxNode = xmlNewChild(groundOverlayNode, NULL, BAD_CAST "LatLonBox", NULL);
-  sprintf(crdStr, "%.8f", mapextent.maxy);
-  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "north", BAD_CAST crdStr);
-
-  sprintf(crdStr, "%.8f", mapextent.miny);
-  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "south", BAD_CAST crdStr);
-
-  sprintf(crdStr, "%.8f", mapextent.minx);
-  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "west", BAD_CAST crdStr);
-
-  sprintf(crdStr, "%.8f", mapextent.maxx);
-  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "east", BAD_CAST crdStr);
-
-  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "rotation", BAD_CAST "0.0");
-
-  return groundOverlayNode;
-}
-
-void KmlRenderer::startShape(imageObj *, shapeObj *shape)
-{
-  if (PlacemarkNode)
-    flushPlacemark();
-
-  CurrentShapeIndex=-1;
-  CurrentDrawnShapeIndex = -1;
-  CurrentShapeName=NULL;
-
-  /*should be done at endshape but the plugin architecture does not call endshape yet*/
-  if(LineStyle) {
-    msFree(LineStyle);
-
-    LineStyle = NULL;
-    numLineStyle = 0;
-  }
-
-  CurrentShapeIndex = shape->index;
-  if (pszLayerNameAttributeMetadata) {
-    for (int i=0; i<currentLayer->numitems; i++) {
-      if (strcasecmp(currentLayer->items[i], pszLayerNameAttributeMetadata) == 0 && shape->values[i]) {
-        CurrentShapeName = msStrdup(shape->values[i]);
-        break;
-      }
-    }
-  }
-  PlacemarkNode = NULL;
-  GeomNode = NULL;
-
-  DescriptionNode = createDescriptionNode(shape);
-
-  if( mElevationFromAttribute && shape->numvalues > mElevationAttributeIndex &&
-      mElevationAttributeIndex >= 0 && shape->values[mElevationAttributeIndex]) {
-    mCurrentElevationValue = atof( shape->values[mElevationAttributeIndex] );
-  }
-
-
-  memset(SymbologyFlag, 0, NumSymbologyFlag);
-}
-
-void KmlRenderer::endShape(imageObj*, shapeObj*)
-{
-  CurrentShapeIndex = -1;
-  if (CurrentShapeName)
-    msFree(CurrentShapeName);
-  CurrentShapeName = NULL;
-}
-
-xmlNodePtr KmlRenderer::getGeomParentNode(const char *geomName)
-{
-  /*we do not need a multi-geometry for point layers*/
-  if (currentLayer->type != MS_LAYER_POINT && currentLayer->type != MS_LAYER_ANNOTATION && GeomNode) {
-    /*placemark geometry already defined, we need multigeometry node*/
-    xmlNodePtr multiGeomNode = xmlNewNode(NULL, BAD_CAST "MultiGeometry");
-    xmlAddChild(multiGeomNode, GeomNode);
-    GeomNode = multiGeomNode;
-
-    xmlNodePtr geomNode = xmlNewChild(multiGeomNode, NULL, BAD_CAST geomName, NULL);
-    return geomNode;
-  } else {
-    GeomNode = xmlNewNode(NULL, BAD_CAST geomName);
-    return GeomNode;
-  }
-}
-
-const char* KmlRenderer::lookupSymbolUrl(imageObj *img, symbolObj *symbol, symbolStyleObj *symstyle)
-{
-  char  symbolHexColor[32];
-  /*
-      <Style id="randomColorIcon">
-      <IconStyle>
-      <color>ff00ff00</color>
-      <colorMode>random</colorMode>
-      <scale>1.1</scale>
-      <Icon>
-      <href>http://maps.google.com/mapfiles/kml/pal3/icon21.png</href>
-      </Icon>
-      </IconStyle>
-      </Style>
-  */
-
-  sprintf(symbolHexColor,"%02x%02x%02x%02x", symstyle->style->color.alpha, symstyle->style->color.blue,
-          symstyle->style->color.green, symstyle->style->color.red);
-  snprintf(SymbolName, sizeof(SymbolName), "symbol_%s_%.1f_%s", symbol->name, symstyle->scale, symbolHexColor);
-
-  const char *symbolUrl = msLookupHashTable(StyleHashTable, SymbolName);
-  if (!symbolUrl) {
-    char iconFileName[MS_MAXPATHLEN];
-    char iconUrl[MS_MAXPATHLEN];
-
-    if (img->imagepath) {
-      char *tmpFileName = msTmpFile(NULL, MapPath, img->imagepath, "png");
-      snprintf(iconFileName, sizeof(iconFileName), "%s", tmpFileName);
-      msFree(tmpFileName);
-    } else {
-      sprintf(iconFileName, "symbol_%s_%.1f.%s", symbol->name, symstyle->scale, "png");
-    }
-
-    if (createIconImage(iconFileName, symbol, symstyle) != MS_SUCCESS) {
-      msSetError(MS_IOERR, "Error creating icon file '%s'", "KmlRenderer::lookupSymbolStyle()", iconFileName);
-      return NULL;
-    }
-
-    if (img->imageurl)
-      sprintf(iconUrl, "%s%s.%s", img->imageurl, msGetBasename(iconFileName), "png");
-    else
-      snprintf(iconUrl, sizeof(iconUrl), "%s", iconFileName);
-
-    hashObj *hash = msInsertHashTable(StyleHashTable, SymbolName, iconUrl);
-    symbolUrl = hash->data;
-  }
-
-  return symbolUrl;
-}
-
-const char* KmlRenderer::lookupPlacemarkStyle()
-{
-  char  lineHexColor[32];
-  char  polygonHexColor[32];
-  char  labelHexColor[32];
-  char        *styleName=NULL;
-
-  styleName = msStringConcatenate(styleName, "style");
-
-  if (SymbologyFlag[Line]) {
-    /*
-      <LineStyle id="ID">
-      <!-- inherited from ColorStyle -->
-      <color>ffffffff</color>            <!-- kml:color -->
-      <colorMode>normal</colorMode>      <!-- colorModeEnum: normal or random -->
-
-      <!-- specific to LineStyle -->
-      <width>1</width>                   <!-- float -->
-      </LineStyle>
-    */
-
-    for (int i=0; i<numLineStyle; i++) {
-      if (currentLayer && currentLayer->compositer && currentLayer->compositer->opacity > 0 && currentLayer->compositer->opacity < 100 &&
-          LineStyle[i].color->alpha == 255)
-        LineStyle[i].color->alpha = MS_NINT(currentLayer->compositer->opacity*2.55);
-
-      sprintf(lineHexColor,"%02x%02x%02x%02x", LineStyle[i].color->alpha, LineStyle[0].color->blue,
-              LineStyle[i].color->green, LineStyle[i].color->red);
-
-      char lineStyleName[64];
-      snprintf(lineStyleName, sizeof(lineStyleName), "_line_%s_w%.1f", lineHexColor, LineStyle[i].width);
-      styleName = msStringConcatenate(styleName, lineStyleName);
-    }
-  }
-
-  if (SymbologyFlag[Polygon]) {
-    /*
-      <PolyStyle id="ID">
-      <!-- inherited from ColorStyle -->
-      <color>ffffffff</color>            <!-- kml:color -->
-      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or random -->
-
-      <!-- specific to PolyStyle -->
-      <fill>1</fill>                     <!-- boolean -->
-      <outline>1</outline>               <!-- boolean -->
-      </PolyStyle>
-    */
-
-    if (currentLayer && currentLayer->compositer && currentLayer->compositer->opacity > 0 && currentLayer->compositer->opacity < 100 &&
-        PolygonColor.alpha == 255)
-      PolygonColor.alpha = MS_NINT(currentLayer->compositer->opacity*2.55);
-    sprintf(polygonHexColor,"%02x%02x%02x%02x", PolygonColor.alpha, PolygonColor.blue, PolygonColor.green, PolygonColor.red);
-
-    char polygonStyleName[64];
-    sprintf(polygonStyleName, "_polygon_%s", polygonHexColor);
-    styleName = msStringConcatenate(styleName, polygonStyleName);
-  }
-
-  if (SymbologyFlag[Label]) {
-    /*
-      <LabelStyle id="ID">
-      <!-- inherited from ColorStyle -->
-      <color>ffffffff</color>            <!-- kml:color -->
-      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or random -->
-
-      <!-- specific to LabelStyle -->
-      <scale>1</scale>                   <!-- float -->
-      </LabelStyle>
-    */
-
-    if (currentLayer && currentLayer->compositer && currentLayer->compositer->opacity > 0 && currentLayer->compositer->opacity < 100 &&
-        LabelColor.alpha == 255)
-      LabelColor.alpha = MS_NINT(currentLayer->compositer->opacity*2.55);
-    sprintf(labelHexColor,"%02x%02x%02x%02x", LabelColor.alpha, LabelColor.blue, LabelColor.green, LabelColor.red);
-
-    // __TODO__ add label scale
-
-    char labelStyleName[64];
-    sprintf(labelStyleName, "_label_%s", labelHexColor);
-    styleName = msStringConcatenate(styleName, labelStyleName);
-  }
-
-  if (SymbologyFlag[Symbol]) {
-    /*
-    <Style id="randomColorIcon">
-            <IconStyle>
-            <color>ff00ff00</color>
-            <colorMode>random</colorMode>
-            <scale>1.1</scale>
-            <Icon>
-            <href>http://maps.google.com/mapfiles/kml/pal3/icon21.png</href>
-            </Icon>
-            </IconStyle>
-    </Style>
-    */
-
-    /* __TODO__ add label scale */
-
-    styleName = msStringConcatenate(styleName, "_");
-    styleName = msStringConcatenate(styleName, SymbolName);
-  }
-
-  const char *styleUrl = msLookupHashTable(StyleHashTable, styleName);
-  if (!styleUrl) {
-    char *styleValue=NULL;
-    styleValue = msStringConcatenate(styleValue, "#");
-    styleValue = msStringConcatenate(styleValue, styleName);
-    hashObj *hash = msInsertHashTable(StyleHashTable, styleName, styleValue);
-    styleUrl = hash->data;
-    msFree(styleValue);
-
-    /* Insert new Style node into Document node*/
-    xmlNodePtr styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
-    xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST styleName);
-
-    if (SymbologyFlag[Polygon]) {
-      xmlNodePtr polyStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "PolyStyle", NULL);
-      xmlNewChild(polyStyleNode, NULL, BAD_CAST "color", BAD_CAST polygonHexColor);
-    }
-
-    if (SymbologyFlag[Line]) {
-      for (int i=0; i<numLineStyle; i++) {
-        xmlNodePtr lineStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "LineStyle", NULL);
-        sprintf(lineHexColor,"%02x%02x%02x%02x", LineStyle[i].color->alpha, LineStyle[i].color->blue,
-                LineStyle[i].color->green, LineStyle[i].color->red);
-        xmlNewChild(lineStyleNode, NULL, BAD_CAST "color", BAD_CAST lineHexColor);
-
-        char width[16];
-        sprintf(width, "%.1f", LineStyle[i].width);
-        xmlNewChild(lineStyleNode, NULL, BAD_CAST "width", BAD_CAST width);
-      }
-    }
-
-    if (SymbologyFlag[Symbol]) {
-      xmlNodePtr iconStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
-
-      xmlNodePtr iconNode = xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
-      xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST SymbolUrl);
-
-      /*char scale[16];
-        sprintf(scale, "%.1f", style->scale);
-        xmlNewChild(iconStyleNode, NULL, BAD_CAST "scale", BAD_CAST scale);*/
-    } else {
-      const char *value=msLookupHashTable(&currentLayer->metadata, "kml_default_symbol_href");
-      if (value && strlen(value) > 0) {
-        xmlNodePtr iconStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
-
-        xmlNodePtr iconNode = xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
-        xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST value);
-      }
-    }
-
-    if (SymbologyFlag[Label]) {
-      xmlNodePtr labelStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "LabelStyle", NULL);
-      xmlNewChild(labelStyleNode, NULL, BAD_CAST "color", BAD_CAST labelHexColor);
-
-      /*char scale[16];
-        sprintf(scale, "%.1f", style->scale);
-        xmlNewChild(iconStyleNode, NULL, BAD_CAST "scale", BAD_CAST scale);*/
-    }
-  }
-
-  if (styleName)
-    msFree(styleName);
-
-  return styleUrl;
-}
-
-void KmlRenderer::flushPlacemark()
-{
-  if (PlacemarkNode) {
-    const char *styleUrl = lookupPlacemarkStyle();
-    xmlNewChild(PlacemarkNode, NULL, BAD_CAST "styleUrl", BAD_CAST styleUrl);
-
-    if (DescriptionNode)
-      xmlAddChild(PlacemarkNode, DescriptionNode);
-
-    if (GeomNode)
-      xmlAddChild(PlacemarkNode, GeomNode);
-  }
-}
-
-
-xmlNodePtr KmlRenderer::createDescriptionNode(shapeObj *shape)
-{
-  /*
-    <description>
-    <![CDATA[
-    special characters here
-    ]]>
-    <description>
-  */
-
-
-  /*description nodes for vector layers:
-    - if kml_description is set, use it
-    - if not, dump the attributes */
-
-  if (pszLayerDescMetadata) {
-    char *pszTmp=NULL;
-    char *pszTmpDesc = NULL;
-    size_t bufferSize = 0;
-    pszTmpDesc = msStrdup(pszLayerDescMetadata);
-
-    for (int i=0; i<currentLayer->numitems; i++) {
-      bufferSize = strlen(currentLayer->items[i]) + 3;
-      pszTmp = (char *)msSmallMalloc(bufferSize);
-      snprintf(pszTmp, bufferSize, "%%%s%%",currentLayer->items[i]);
-      if (strcasestr(pszTmpDesc, pszTmp))
-        pszTmpDesc = msCaseReplaceSubstring(pszTmpDesc,  pszTmp, shape->values[i]);
-      msFree(pszTmp);
-    }
-    xmlNodePtr descriptionNode = xmlNewNode(NULL, BAD_CAST "description");
-    xmlNodeAddContent(descriptionNode, BAD_CAST pszTmpDesc);
-    msFree(pszTmpDesc);
-    return descriptionNode;
-  } else if ((papszLayerIncludeItems && nIncludeItems > 0) ||
-             (papszLayerExcludeItems && nExcludeItems > 0)) {
-    /* -------------------------------------------------------------------- */
-    /*      preffered way is to use the ExtendedData tag (#3728)            */
-    /*      http://code.google.com/apis/kml/documentation/extendeddata.html */
-    /* -------------------------------------------------------------------- */
-
-    xmlNodePtr extendedDataNode = xmlNewNode(NULL, BAD_CAST "ExtendedData");
-    xmlNodePtr dataNode = NULL;
-    const char*pszAlias=NULL;
-    int bIncludeAll = MS_FALSE;
-
-    if(papszLayerIncludeItems && nIncludeItems == 1 &&
-        strcasecmp(papszLayerIncludeItems[0], "all") == 0)
-      bIncludeAll = MS_TRUE;
-
-    for (int i=0; i<currentLayer->numitems; i++) {
-      int j=0,k=0;
-
-      /*TODO optimize to calculate this only once per layer*/
-      for (j=0; j<nIncludeItems; j++) {
-        if (strcasecmp(currentLayer->items[i], papszLayerIncludeItems[j]) == 0)
-          break;
-      }
-      if (j<nIncludeItems || bIncludeAll) {
-        if (papszLayerExcludeItems && nExcludeItems > 0) {
-          for (k=0; k<nExcludeItems; k++) {
-            if (strcasecmp(currentLayer->items[i], papszLayerExcludeItems[k]) == 0)
-              break;
-          }
-        }
-        if (nExcludeItems == 0 || k == nExcludeItems) {
-          dataNode = xmlNewNode(NULL, BAD_CAST "Data");
-          xmlNewProp(dataNode, BAD_CAST "name", BAD_CAST  currentLayer->items[i]);
-          pszAlias = getAliasName(currentLayer, currentLayer->items[i], "GO");
-          if (pszAlias)
-            xmlNewChild(dataNode, NULL, BAD_CAST "displayName", BAD_CAST  pszAlias);
-          else
-            xmlNewChild(dataNode, NULL, BAD_CAST "displayName", BAD_CAST  currentLayer->items[i]);
-          if (shape->values[i] && strlen(shape->values[i]))
-            xmlNewChild(dataNode, NULL, BAD_CAST "value", BAD_CAST  shape->values[i]);
-          else
-            xmlNewChild(dataNode, NULL, BAD_CAST "value", NULL);
-          xmlAddChild(extendedDataNode, dataNode);
-        }
-      }
-    }
-
-    return extendedDataNode;
-
-
-  }
-
-  return NULL;
-}
-
-void KmlRenderer::addLineStyleToList(strokeStyleObj *style)
-{
-  /*actually this is not necessary. kml only uses the last LineStyle
-    so we should not bother keeping them all*/
-  int i =0;
-  for (i=0; i<numLineStyle; i++) {
-    if (style->width == LineStyle[i].width &&
-        LineStyle[i].color->alpha == style->color->alpha &&
-        LineStyle[i].color->red == style->color->red &&
-        LineStyle[i].color->green == style->color->green &&
-        LineStyle[i].color->blue == style->color->blue)
-      break;
-  }
-  if (i == numLineStyle) {
-    numLineStyle++;
-    if (LineStyle == NULL)
-      LineStyle = (strokeStyleObj *)msSmallMalloc(sizeof(strokeStyleObj));
-    else
-      LineStyle = (strokeStyleObj *)msSmallRealloc(LineStyle, sizeof(strokeStyleObj)*numLineStyle);
-
-    memcpy(&LineStyle[numLineStyle-1], style, sizeof(strokeStyleObj));
-  }
-
-}
-
-#endif
diff -pruN 8.0.1-5/mapkmlrenderer.h 8.2.0~beta1-1~exp1/mapkmlrenderer.h
--- 8.0.1-5/mapkmlrenderer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapkmlrenderer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,175 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Headers for mapkmlrenderer.cpp Google Earth KML output
- * Author:   David Kana and the MapServer team
- *
- ******************************************************************************
- * Copyright (c) 1996-2009 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-
-#ifndef MAPKMLRENDERER_H
-#define MAPKMLRENDERER_H
-
-#include "mapserver-config.h"
-#if defined(USE_KML)
-
-#include "mapserver.h"
-#include "maplibxml2.h"
-
-
-class KmlRenderer
-{
-private:
-  const char *pszLayerDescMetadata = nullptr; /*if the kml_description is set*/
-  char **papszLayerIncludeItems = nullptr;
-  int nIncludeItems = 0;
-  char **papszLayerExcludeItems = nullptr;
-  int nExcludeItems = 0;
-  const char *pszLayerNameAttributeMetadata = nullptr;
-
-protected:
-
-  // map properties
-  int       Width = 0, Height = 0;
-  rectObj     MapExtent = {0,0,0,0};
-  double      MapCellsize = 0;
-  colorObj    BgColor = {0,0,0,0};
-  char      MapPath[MS_MAXPATHLEN] = {0};
-
-  // xml nodes pointers
-  xmlDocPtr XmlDoc = nullptr;
-  xmlNodePtr  DocNode = nullptr;
-  xmlNodePtr  LayerNode = nullptr;
-  xmlNodePtr  GroundOverlayNode = nullptr;
-
-  xmlNodePtr  PlacemarkNode = nullptr;
-  xmlNodePtr  GeomNode = nullptr;
-  xmlNodePtr  DescriptionNode = nullptr;
-
-  int         CurrentShapeIndex = 0;
-  int         CurrentDrawnShapeIndex = 0;
-  char            *CurrentShapeName = nullptr;
-  char    **Items = nullptr;
-  int     NumItems = 0;
-  int     DumpAttributes = 0;
-
-  // placemark symbology
-  hashTableObj  *StyleHashTable = nullptr;
-
-  colorObj                LabelColor = {0,0,0,0};
-  strokeStyleObj          *LineStyle = nullptr;
-  int                     numLineStyle = 0;
-  colorObj    PolygonColor = {0,0,0,0};
-
-  char      SymbolName[128] = {0};
-  char      SymbolUrl[128] = {0};
-
-  enum      { NumSymbologyFlag = 4};
-  char      SymbologyFlag[NumSymbologyFlag] = {0,0,0,0};
-
-  enum      symbFlagsEnum { Label, Line, Polygon, Symbol };
-
-  int       FirstLayer = 0;
-
-  mapObj                  *map = nullptr;
-  layerObj                *currentLayer = nullptr;
-
-  int       AltitudeMode = 0;
-  int       Tessellate = 0;
-  int       Extrude = 0;
-
-  enum altitudeModeEnum { undefined, clampToGround, relativeToGround, absolute };
-  /**True if elevation is taken from a feature attribute*/
-  bool mElevationFromAttribute = false;
-  /**Attribute index of elevation (or -1 if elevation is not attribute driven*/
-  int mElevationAttributeIndex = 0;
-  double mCurrentElevationValue = 0;
-
-
-  outputFormatObj *aggFormat = nullptr;
-
-protected:
-
-  imageObj* createInternalImage();
-  xmlNodePtr createPlacemarkNode(xmlNodePtr parentNode, char *styleUrl);
-  xmlNodePtr createGroundOverlayNode(xmlNodePtr parentNode, char *imageHref, layerObj *layer);
-  xmlNodePtr createDescriptionNode(shapeObj *shape);
-
-  const char* lookupSymbolUrl(imageObj *img, symbolObj *symbol, symbolStyleObj *style);
-
-  void addCoordsNode(xmlNodePtr parentNode, pointObj *pts, int numPts);
-
-  void setupRenderingParams(hashTableObj *layerMetadata);
-  void addAddRenderingSpecifications(xmlNodePtr node);
-
-  int checkProjection(mapObj *map);
-
-  int createIconImage(char *fileName, symbolObj *symbol, symbolStyleObj *style);
-
-  void renderSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-
-  //////////////////////////////////////////////////////////////////////////////
-
-  void renderLineVector(imageObj *img, shapeObj *p, strokeStyleObj *style);
-  void renderPolygonVector(imageObj *img, shapeObj *p, colorObj *color);
-
-  const char* lookupPlacemarkStyle();
-  void flushPlacemark();
-  xmlNodePtr getGeomParentNode(const char *geomName);
-  char* getLayerName(layerObj *layer);
-  void processLayer(layerObj *layer, outputFormatObj *format);
-  void addLineStyleToList(strokeStyleObj *style);
-  const char *getAliasName(layerObj *lp, char *pszItemName, const char *namespaces);
-
-public:
-
-  KmlRenderer(int width, int height, outputFormatObj *format, colorObj* color = NULL);
-  virtual ~KmlRenderer();
-
-  imageObj* createImage(int width, int height, outputFormatObj *format, colorObj* bg);
-  int saveImage(imageObj *img, FILE *fp, outputFormatObj *format);
-
-  int startNewLayer(imageObj *img, layerObj *layer);
-  int closeNewLayer(imageObj *img, layerObj *layer);
-
-  void startShape(imageObj *img, shapeObj *shape);
-  void endShape(imageObj *img, shapeObj *shape);
-
-  void renderLine(imageObj *img, shapeObj *p, strokeStyleObj *style);
-  void renderPolygon(imageObj *img, shapeObj *p, colorObj *color);
-
-  void renderGlyphs(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow);
-
-  // Symbols
-  void renderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-  void renderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-  void renderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-  void renderTruetypeSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-
-  int getTruetypeTextBBox(imageObj *img,char **fonts, int numfonts, double size, char *string, rectObj *rect, double **advances);
-  int mergeRasterBuffer(imageObj *image, rasterBufferObj *rb);
-};
-
-#endif /* USE_KML */
-#endif
diff -pruN 8.0.1-5/maplabel.c 8.2.0~beta1-1~exp1/maplabel.c
--- 8.0.1-5/maplabel.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maplabel.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1242 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Labeling Implementation.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/*
-** maplabel.c: Routines to enable text drawing, BITMAP or TRUETYPE.
-*/
-
-#include <assert.h>
-#include <float.h>
-
-#include "mapserver.h"
-#include "fontcache.h"
-
-#include "cpl_vsi.h"
-#include "cpl_string.h"
-
-
-
-
-
-void initTextPath(textPathObj *ts) {
-  memset(ts,0,sizeof(*ts));
-}
-
-int WARN_UNUSED msLayoutTextSymbol(mapObj *map, textSymbolObj *ts, textPathObj *tgret);
-
-#if defined(USE_EXTENDED_DEBUG) && 0
-static void msDebugTextPath(textSymbolObj *ts) {
-  int i;
-  msDebug("text: %s\n",ts->annotext);
-  if(ts->textpath) {
-    for(i=0;i<ts->textpath->numglyphs; i++) {
-      glyphObj *g = &ts->textpath->glyphs[i];
-      msDebug("glyph %d: pos: %f %f\n",g->glyph->key.codepoint,g->pnt.x,g->pnt.y);
-    }
-  } else {
-    msDebug("no glyphs\n");
-  }
-  msDebug("\n=========================================\n");
-}
-#endif
-
-int msComputeTextPath(mapObj *map, textSymbolObj *ts) {
-  textPathObj *tgret = msSmallMalloc(sizeof(textPathObj));
-  assert(ts->annotext && *ts->annotext);
-  initTextPath(tgret);
-  ts->textpath = tgret;
-  tgret->absolute = 0;
-  tgret->glyph_size = ts->label->size * ts->scalefactor;
-  tgret->glyph_size = MS_MAX(tgret->glyph_size, ts->label->minsize * ts->resolutionfactor);
-  tgret->glyph_size = MS_NINT(MS_MIN(tgret->glyph_size, ts->label->maxsize * ts->resolutionfactor));
-  tgret->line_height = ceil(tgret->glyph_size * 1.33);
-  return msLayoutTextSymbol(map,ts,tgret);
-}
-
-void initTextSymbol(textSymbolObj *ts) {
-  memset(ts,0,sizeof(*ts));
-}
-
-void freeTextPath(textPathObj *tp) {
-  free(tp->glyphs);
-  if(tp->bounds.poly) {
-    free(tp->bounds.poly->point);
-    free(tp->bounds.poly);
-  }
-}
-
-void freeTextSymbol(textSymbolObj *ts) {
-    freeTextSymbolEx(ts, MS_TRUE);
-}
-
-void freeTextSymbolEx(textSymbolObj *ts, int doFreeLabel) {
-  if(ts->textpath) {
-    freeTextPath(ts->textpath);
-    free(ts->textpath);
-  }
-  if(ts->label->numstyles) {
-    if(ts->style_bounds) {
-      int i;
-      for(i=0;i<ts->label->numstyles; i++) {
-        if(ts->style_bounds[i]) {
-          if(ts->style_bounds[i]->poly) {
-            free(ts->style_bounds[i]->poly->point);
-            free(ts->style_bounds[i]->poly);
-          }
-          free(ts->style_bounds[i]);
-        }
-      }
-      free(ts->style_bounds);
-    }
-  }
-  free(ts->annotext);
-  if(doFreeLabel && freeLabel(ts->label) == MS_SUCCESS) {
-    free(ts->label);
-  }
-}
-
-void msCopyTextPath(textPathObj *dst, textPathObj *src) {
-  int i;
-  *dst = *src;
-  if(src->bounds.poly) {
-    dst->bounds.poly = msSmallMalloc(sizeof(lineObj));
-    dst->bounds.poly->numpoints = src->bounds.poly->numpoints;
-    dst->bounds.poly->point = msSmallMalloc(src->bounds.poly->numpoints * sizeof(pointObj));
-    for(i=0; i<src->bounds.poly->numpoints; i++) {
-      dst->bounds.poly->point[i] = src->bounds.poly->point[i];
-    }
-  } else {
-    dst->bounds.poly = NULL;
-  }
-  if(dst->numglyphs > 0) {
-    dst->glyphs = msSmallMalloc(dst->numglyphs * sizeof(glyphObj));
-    for(i=0; i<dst->numglyphs; i++)
-      dst->glyphs[i] = src->glyphs[i];
-  }
-}
-
-void msCopyTextSymbol(textSymbolObj *dst, textSymbolObj *src) {
-  *dst = *src;
-  MS_REFCNT_INCR(src->label);
-  dst->annotext = msStrdup(src->annotext);
-  if(src->textpath) {
-    dst->textpath = msSmallMalloc(sizeof(textPathObj));
-    msCopyTextPath(dst->textpath,src->textpath);
-  }
-  if(src->style_bounds) {
-    int i;
-    dst->style_bounds = msSmallCalloc(src->label->numstyles, sizeof(label_bounds*));
-    for(i=0; i<src->label->numstyles; i++) {
-      if(src->style_bounds[i]) {
-        dst->style_bounds[i] = msSmallMalloc(sizeof(label_bounds));
-        copyLabelBounds(dst->style_bounds[i], src->style_bounds[i]);
-      }
-    }
-  }
-}
-
-static int labelNeedsDeepCopy(labelObj *label) {
-  int i;
-  if(label->numbindings > 0) return MS_TRUE;
-  for(i=0; i<label->numstyles; i++) {
-    if(label->styles[i]->numbindings>0) {
-      return MS_TRUE;
-    }
-  }
-  return MS_FALSE;
-}
-
-void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l, char *string, double scalefactor, double resolutionfactor, label_cache_mode cache) {
-  if(cache == duplicate_always) {
-    ts->label = msSmallMalloc(sizeof(labelObj));
-    initLabel(ts->label);
-    msCopyLabel(ts->label,l);
-  } else if(cache == duplicate_never) {
-    ts->label = l;
-    MS_REFCNT_INCR(l);
-  } else if(cache == duplicate_if_needed && labelNeedsDeepCopy(l)) {
-    ts->label = msSmallMalloc(sizeof(labelObj));
-    initLabel(ts->label);
-    msCopyLabel(ts->label,l);
-  } else {
-    ts->label = l;
-    MS_REFCNT_INCR(l);
-  }
-  ts->resolutionfactor = resolutionfactor;
-  ts->scalefactor = scalefactor;
-  ts->annotext = string; /* we take the ownership of the annotation text */
-  ts->rotation = l->angle * MS_DEG_TO_RAD;
-}
-
-int msAddLabelGroup(mapObj *map, imageObj *image, layerObj* layer, int classindex, shapeObj *shape, pointObj *point, double featuresize)
-{
-  int l,s, priority;
-  labelCacheSlotObj *cacheslot;
-
-  labelCacheMemberObj *cachePtr=NULL;
-  layerObj *layerPtr=NULL;
-  classObj *classPtr=NULL;
-  int numtextsymbols = 0;
-  textSymbolObj **textsymbols, *ts;
-  int layerindex = layer->index;
-
-  // We cannot use GET_LAYER here because in drawQuery the drawing may happen
-  // on a temp layer only.
-  layerPtr = layer;
-  classPtr = layer->class[classindex];
-
-  if(classPtr->numlabels == 0) return MS_SUCCESS; /* not an error just nothing to do */
-
-  /* check that the label intersects the layer mask */
-  if(layerPtr->mask) {
-    int maskLayerIdx = msGetLayerIndex(map,layerPtr->mask);
-    layerObj *maskLayer = GET_LAYER(map,maskLayerIdx);
-    unsigned char *alphapixptr;
-    if(maskLayer->maskimage && MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
-      rasterBufferObj rb;
-      int x,y;
-      memset(&rb,0,sizeof(rasterBufferObj));
-      if(MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,&rb))) {
-        return MS_FAILURE;
-      }
-      x = MS_NINT(point->x);
-      y = MS_NINT(point->y);
-      /* Using label repeatdistance, we might have a point with x/y below 0. See #4764 */
-      if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
-        assert(rb.type == MS_BUFFER_BYTE_RGBA);
-        alphapixptr = rb.data.rgba.a+rb.data.rgba.row_step*y + rb.data.rgba.pixel_step*x;
-        if(!*alphapixptr) {
-          /* label point does not intersect mask */
-          return MS_SUCCESS;
-        }
-      } else {
-        return MS_SUCCESS; /* label point does not intersect image extent, we cannot know if it intersects
-                             mask, so we discard it (#5237)*/
-      }
-    } else {
-      msSetError(MS_MISCERR, "Layer (%s) references references a mask layer, but the selected renderer does not support them", "msAddLabelGroup()", layerPtr->name);
-      return (MS_FAILURE);
-    }
-  }
-
-  textsymbols = msSmallMalloc(classPtr->numlabels * sizeof(textSymbolObj*));
-
-  for(l=0; l<classPtr->numlabels; l++) {
-    labelObj *lbl = classPtr->labels[l];
-    char *annotext;
-    if(msGetLabelStatus(map,layerPtr,shape,lbl) == MS_OFF) {
-      continue;
-    }
-    annotext = msShapeGetLabelAnnotation(layerPtr,shape,lbl);
-    if(!annotext) {
-      for(s=0;s<lbl->numstyles;s++) {
-        if(lbl->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
-          break; /* we have a "symbol only label, so we shouldn't skip this label */
-      }
-      if(s == lbl->numstyles) {
-        continue; /* no anno text, and no label symbols */
-      }
-    }
-    ts = msSmallMalloc(sizeof(textSymbolObj));
-    initTextSymbol(ts);
-    msPopulateTextSymbolForLabelAndString(ts,lbl,annotext,layerPtr->scalefactor,image->resolutionfactor, 1);
-
-    if(annotext && *annotext && lbl->autominfeaturesize && featuresize > 0) {
-      if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
-        freeTextSymbol(ts);
-        free(ts);
-        return MS_FAILURE;
-      }
-      if(featuresize < (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
-        /* feature is too big to be drawn, skip it */
-        freeTextSymbol(ts);
-        free(ts);
-        continue;
-      }
-    }
-    textsymbols[numtextsymbols] = ts;
-    numtextsymbols++;
-  }
-
-  if(numtextsymbols == 0) {
-    free(textsymbols);
-    return MS_SUCCESS;
-  }
-
-  /* Validate label priority value and get ref on label cache for it */
-  priority = classPtr->labels[0]->priority; /* take priority from the first label */
-  if (priority < 1)
-    priority = 1;
-  else if (priority > MS_MAX_LABEL_PRIORITY)
-    priority = MS_MAX_LABEL_PRIORITY;
-
-  cacheslot = &(map->labelcache.slots[priority-1]);
-
-  if(cacheslot->numlabels == cacheslot->cachesize) { /* just add it to the end */
-    cacheslot->labels = (labelCacheMemberObj *) realloc(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-    MS_CHECK_ALLOC(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
-    cacheslot->cachesize += MS_LABELCACHEINCREMENT;
-  }
-
-  cachePtr = &(cacheslot->labels[cacheslot->numlabels]);
-
-  cachePtr->layerindex = layerindex; /* so we can get back to this *raw* data if necessary */
-
-  cachePtr->classindex = classindex;
-
-  cachePtr->point = *point; /* the actual label point */
-
-  cachePtr->leaderline = NULL;
-  cachePtr->leaderbbox = NULL;
-
-  cachePtr->markerid = -1;
-
-  cachePtr->status = MS_FALSE;
-
-  if(layerPtr->type == MS_LAYER_POINT && classPtr->numstyles > 0) {
-    /* cache the marker placement, it's already on the map */
-    /* TO DO: at the moment only checks the bottom style, perhaps should check all of them */
-    /* #2347: after RFC-24 classPtr->styles could be NULL so we check it */
-    double w, h;
-    if(msGetMarkerSize(map, classPtr->styles[0], &w, &h, layerPtr->scalefactor) != MS_SUCCESS)
-      return(MS_FAILURE);
-
-    if(cacheslot->nummarkers == cacheslot->markercachesize) { /* just add it to the end */
-      cacheslot->markers = (markerCacheMemberObj *) realloc(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-      MS_CHECK_ALLOC(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
-      cacheslot->markercachesize+=MS_LABELCACHEINCREMENT;
-    }
-
-    cacheslot->markers[cacheslot->nummarkers].bounds.minx = (point->x - .5 * w);
-    cacheslot->markers[cacheslot->nummarkers].bounds.miny = (point->y - .5 * h);
-    cacheslot->markers[cacheslot->nummarkers].bounds.maxx = cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w-1);
-    cacheslot->markers[cacheslot->nummarkers].bounds.maxy = cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h-1);
-    cacheslot->markers[cacheslot->nummarkers].id = cacheslot->numlabels;
-
-    cachePtr->markerid = cacheslot->nummarkers;
-    cacheslot->nummarkers++;
-  }
-  cachePtr->textsymbols = textsymbols;
-  cachePtr->numtextsymbols = numtextsymbols;
-
-  cacheslot->numlabels++;
-
-  return(MS_SUCCESS);
-}
-
-int msAddLabel(mapObj *map, imageObj *image, labelObj *label, int layerindex, int classindex,
-    shapeObj *shape, pointObj *point, double featuresize, textSymbolObj *ts)
-{
-  int i;
-  labelCacheSlotObj *cacheslot;
-  labelCacheMemberObj *cachePtr=NULL;
-  const char *annotext = NULL;
-  char *annotextToFree = NULL;
-  layerObj *layerPtr;
-  classObj *classPtr;
-
-  layerPtr=GET_LAYER(map,layerindex);
-  assert(layerPtr);
-
-  assert(classindex < layerPtr->numclasses);
-  classPtr = layerPtr->class[classindex];
-
-  assert(label);
-
-  if(ts)
-    annotext = ts->annotext;
-  else if(shape)
-  {
-    annotextToFree = msShapeGetLabelAnnotation(layerPtr,shape,label);
-    annotext = annotextToFree;
-  }
-
-  if(!annotext) {
-    /* check if we have a labelpnt style */
-    for(i=0; i<label->numstyles; i++) {
-      if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
-        break;
-    }
-    if(i==label->numstyles) {
-      /* label has no text or marker symbols */
-      if(ts) {
-        freeTextSymbol(ts);
-        free(ts);
-      }
-      return MS_SUCCESS;
-    }
-  }
-
-  if(classPtr->leader) {
-    if(ts && ts->textpath && ts->textpath->absolute) {
-      msSetError(MS_MISCERR, "LEADERs are not supported on ANGLE FOLLOW labels", "msAddLabel()");
-      return MS_FAILURE;
-    }
-  }
-  /* check that the label intersects the layer mask */
-
-  if (layerPtr->mask) {
-    int maskLayerIdx = msGetLayerIndex(map, layerPtr->mask);
-    layerObj *maskLayer = GET_LAYER(map, maskLayerIdx);
-    unsigned char *alphapixptr;
-    if (maskLayer->maskimage && MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
-      rasterBufferObj rb;
-      memset(&rb, 0, sizeof (rasterBufferObj));
-      if(MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage, &rb))) {
-        msFree(annotextToFree);
-        return MS_FAILURE;
-      }
-      assert(rb.type == MS_BUFFER_BYTE_RGBA);
-      if (point) {
-        int x = MS_NINT(point->x);
-        int y = MS_NINT(point->y);
-        /* Using label repeatdistance, we might have a point with x/y below 0. See #4764 */
-        if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
-          alphapixptr = rb.data.rgba.a+rb.data.rgba.row_step*y + rb.data.rgba.pixel_step*x;
-          if(!*alphapixptr) {
-            /* label point does not intersect mask */
-            if(ts) {
-              freeTextSymbol(ts);
-              free(ts);
-            }
-            msFree(annotextToFree);
-            return MS_SUCCESS;
-          }
-        } else {
-          msFree(annotextToFree);
-          return MS_SUCCESS; /* label point does not intersect image extent, we cannot know if it intersects
-                                mask, so we discard it (#5237)*/
-        }
-      } else if (ts && ts->textpath) {
-        int i = 0;
-        for (i = 0; i < ts->textpath->numglyphs; i++) {
-          int x = MS_NINT(ts->textpath->glyphs[i].pnt.x);
-          int y = MS_NINT(ts->textpath->glyphs[i].pnt.y);
-          if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
-            alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y + rb.data.rgba.pixel_step*x;
-            if (!*alphapixptr) {
-              freeTextSymbol(ts);
-              free(ts);
-              msFree(annotextToFree);
-              return MS_SUCCESS;
-            }
-          } else {
-            freeTextSymbol(ts);
-            free(ts);
-            msFree(annotextToFree);
-            return MS_SUCCESS; /* label point does not intersect image extent, we cannot know if it intersects
-                                  mask, so we discard it (#5237)*/
-          }
-        }
-      }
-    } else {
-      msSetError(MS_MISCERR, "Layer (%s) references references a mask layer, but the selected renderer does not support them", "msAddLabel()", layerPtr->name);
-      msFree(annotextToFree);
-      return (MS_FAILURE);
-    }
-  }
-
-  if(!ts) {
-    ts = msSmallMalloc(sizeof(textSymbolObj));
-    initTextSymbol(ts);
-    msPopulateTextSymbolForLabelAndString(ts,label,annotextToFree,layerPtr->scalefactor,image->resolutionfactor, 1);
-    // annotextToFree = NULL;
-  }
-
-  if(annotext && label->autominfeaturesize && featuresize > 0) {
-    if(!ts->textpath) {
-      if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts)))
-        return MS_FAILURE;
-    }
-    if(!ts->textpath) {
-      return MS_FAILURE;
-    }
-    if(featuresize > (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
-      /* feature is too big to be drawn, skip it */
-      freeTextSymbol(ts);
-      free(ts);
-      return MS_SUCCESS;
-    }
-  }
-
-
-
-  /* Validate label priority value and get ref on label cache for it */
-  if (label->priority < 1)
-    label->priority = 1;
-  else if (label->priority > MS_MAX_LABEL_PRIORITY)
-    label->priority = MS_MAX_LABEL_PRIORITY;
-
-  cacheslot = &(map->labelcache.slots[label->priority-1]);
-
-  if(cacheslot->numlabels == cacheslot->cachesize) { /* just add it to the end */
-    cacheslot->labels = (labelCacheMemberObj *) realloc(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-    MS_CHECK_ALLOC(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
-    cacheslot->cachesize += MS_LABELCACHEINCREMENT;
-  }
-
-  cachePtr = &(cacheslot->labels[cacheslot->numlabels]);
-
-  cachePtr->layerindex = layerindex; /* so we can get back to this *raw* data if necessary */
-  cachePtr->classindex = classindex;
-  cachePtr->leaderline = NULL;
-  cachePtr->leaderbbox = NULL;
-
-  /* Store the label point or the label path (Bug #1620) */
-  if ( point ) {
-    cachePtr->point = *point; /* the actual label point */
-  } else {
-    assert(ts && ts->textpath && ts->textpath->absolute && ts->textpath->numglyphs>0);
-    /* Use the middle point of the labelpath for mindistance calculations */
-    cachePtr->point = ts->textpath->glyphs[ts->textpath->numglyphs/2].pnt;
-  }
-
-  /* copy the label */
-  cachePtr->numtextsymbols = 1;
-  cachePtr->textsymbols = (textSymbolObj **) msSmallMalloc(sizeof(textSymbolObj*));
-  cachePtr->textsymbols[0] = ts;
-  cachePtr->markerid = -1;
-
-  cachePtr->status = MS_FALSE;
-
-  if(layerPtr->type == MS_LAYER_POINT && classPtr->numstyles > 0) { /* cache the marker placement, it's already on the map */
-    double w, h;
-
-    if(cacheslot->nummarkers == cacheslot->markercachesize) { /* just add it to the end */
-      cacheslot->markers = (markerCacheMemberObj *) realloc(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-      MS_CHECK_ALLOC(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
-      cacheslot->markercachesize+=MS_LABELCACHEINCREMENT;
-    }
-
-    i = cacheslot->nummarkers;
-
-    /* TO DO: at the moment only checks the bottom style, perhaps should check all of them */
-    /* #2347: after RFC-24 classPtr->styles could be NULL so we check it */
-    if(classPtr->styles != NULL) {
-      if(msGetMarkerSize(map, classPtr->styles[0], &w, &h, layerPtr->scalefactor) != MS_SUCCESS)
-        return(MS_FAILURE);
-      assert(point);
-      cacheslot->markers[cacheslot->nummarkers].bounds.minx = (point->x - .5 * w);
-      cacheslot->markers[cacheslot->nummarkers].bounds.miny = (point->y - .5 * h);
-      cacheslot->markers[cacheslot->nummarkers].bounds.maxx = cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w-1);
-      cacheslot->markers[cacheslot->nummarkers].bounds.maxy = cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h-1);
-      cacheslot->markers[i].id = cacheslot->numlabels;
-
-      cachePtr->markerid = i;
-
-      cacheslot->nummarkers++;
-    }
-  }
-
-  cacheslot->numlabels++;
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Is a label completely in the image, reserving a gutter (in pixels) inside
-** image for no labels (effectively making image larger. The gutter can be
-** negative in cases where a label has a buffer around it.
-*/
-static int labelInImage(int width, int height, lineObj *lpoly, rectObj *bounds, int gutter)
-{
-  int j;
-
-  /* do a bbox test first */
-  if(bounds->minx >= gutter &&
-      bounds->miny >= gutter &&
-      bounds->maxx < width-gutter &&
-      bounds->maxy < height-gutter) {
-    return MS_TRUE;
-  }
-
-  if(lpoly) {
-    for(j=1; j<lpoly->numpoints; j++) {
-      if(lpoly->point[j].x < gutter) return(MS_FALSE);
-      if(lpoly->point[j].x >= width-gutter) return(MS_FALSE);
-      if(lpoly->point[j].y < gutter) return(MS_FALSE);
-      if(lpoly->point[j].y >= height-gutter) return(MS_FALSE);
-    }
-  } else {
-    /* if no poly, then return false as the boundong box intersected */
-    return MS_FALSE;
-  }
-
-  return(MS_TRUE);
-}
-
-void insertRenderedLabelMember(mapObj *map, labelCacheMemberObj *cachePtr) {
-  if(map->labelcache.num_rendered_members == map->labelcache.num_allocated_rendered_members) {
-    if(map->labelcache.num_rendered_members == 0) {
-      map->labelcache.num_allocated_rendered_members = 50;
-    } else {
-      map->labelcache.num_allocated_rendered_members *= 2;
-    }
-    map->labelcache.rendered_text_symbols = msSmallRealloc(map->labelcache.rendered_text_symbols,
-            map->labelcache.num_allocated_rendered_members * sizeof(labelCacheMemberObj*));
-  }
-  map->labelcache.rendered_text_symbols[map->labelcache.num_rendered_members++] = cachePtr;
-}
-
-static inline int testSegmentLabelBBoxIntersection(const rectObj *leaderbbox, const pointObj *lp1,
-    const pointObj *lp2, const label_bounds *test) {
-  if(msRectOverlap(leaderbbox, &test->bbox)) {
-    if(test->poly) {
-      int pp;
-      for(pp=1; pp<test->poly->numpoints; pp++) {
-        if(msIntersectSegments(
-            &(test->poly->point[pp-1]),
-            &(test->poly->point[pp]),
-            lp1,lp2) ==  MS_TRUE) {
-          return(MS_FALSE);
-        }
-      }
-    } else {
-      pointObj tp1 = {0},tp2 = {0};
-      tp1.x = test->bbox.minx;
-      tp1.y = test->bbox.miny;
-      tp2.x = test->bbox.minx;
-      tp2.y = test->bbox.maxy;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
-        return MS_FALSE;
-      tp2.x = test->bbox.maxx;
-      tp2.y = test->bbox.miny;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
-        return MS_FALSE;
-      tp1.x = test->bbox.maxx;
-      tp1.y = test->bbox.maxy;
-      tp2.x = test->bbox.minx;
-      tp2.y = test->bbox.maxy;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
-        return MS_FALSE;
-      tp2.x = test->bbox.maxx;
-      tp2.y = test->bbox.miny;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
-        return MS_FALSE;
-    }
-  }
-  return MS_TRUE;
-}
-
-int msTestLabelCacheLeaderCollision(mapObj *map, pointObj *lp1, pointObj *lp2) {
-  int p;
-  rectObj leaderbbox;
-  leaderbbox.minx = MS_MIN(lp1->x,lp2->x);
-  leaderbbox.maxx = MS_MAX(lp1->x,lp2->x);
-  leaderbbox.miny = MS_MIN(lp1->y,lp2->y);
-  leaderbbox.maxy = MS_MAX(lp1->y,lp2->y);
-  for(p=0; p<map->labelcache.num_rendered_members; p++) {
-    labelCacheMemberObj *curCachePtr= map->labelcache.rendered_text_symbols[p];
-    if(msRectOverlap(&leaderbbox, &(curCachePtr->bbox))) {
-    /* leaderbbox interesects with the curCachePtr's global bbox */
-      int t;
-      for(t=0; t<curCachePtr->numtextsymbols; t++) {
-        int s;
-        textSymbolObj *ts = curCachePtr->textsymbols[t];
-        /* check for intersect with textpath */
-        if(ts->textpath && testSegmentLabelBBoxIntersection(&leaderbbox, lp1, lp2, &ts->textpath->bounds) == MS_FALSE) {
-          return MS_FALSE;
-        }
-        /* check for intersect with label's labelpnt styles */
-        if(ts->style_bounds) {
-          for(s=0; s<ts->label->numstyles; s++) {
-            if(ts->label->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-              if(testSegmentLabelBBoxIntersection(&leaderbbox, lp1,lp2, ts->style_bounds[s]) == MS_FALSE) {
-                return MS_FALSE;
-              }
-            }
-          }
-        }
-      }
-      if(curCachePtr->leaderbbox) {
-        if(msIntersectSegments(lp1,lp2,&(curCachePtr->leaderline->point[0]), &(curCachePtr->leaderline->point[1])) ==  MS_TRUE) {
-          return MS_FALSE;
-        }
-      }
-    }
-  }
-  return MS_TRUE;
-}
-
-/* msTestLabelCacheCollisions()
-**
-** Compares label bounds (in *bounds) against labels already drawn and markers from cache and
-** returns MS_FALSE if it collides with another label, or collides with a marker.
-**
-** This function is used by the various msDrawLabelCacheXX() implementations.
-
-int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr, label_bounds *bounds,
-              int current_priority, int current_label);
-*/
-int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr, label_bounds *lb,
-        int current_priority, int current_label)
-{
-  labelCacheObj *labelcache = &(map->labelcache);
-  int i, p, ll;
-
-  /*
-   * Check against image bounds first
-   */
-  if(!cachePtr->textsymbols[0]->label->partials) {
-    if(labelInImage(map->width, map->height, lb->poly, &lb->bbox, labelcache->gutter) == MS_FALSE) {
-      return MS_FALSE;
-    }
-  }
-
-  /* Compare against all rendered markers from this priority level and higher.
-  ** Labels can overlap their own marker and markers from lower priority levels
-  */
-  for (p=current_priority; p < MS_MAX_LABEL_PRIORITY; p++) {
-    labelCacheSlotObj *markerslot;
-    markerslot = &(labelcache->slots[p]);
-
-    for ( ll = 0; ll < markerslot->nummarkers; ll++ ) {
-      if ( !(p == current_priority && current_label == markerslot->markers[ll].id ) ) {  /* labels can overlap their own marker */
-        if ( intersectLabelPolygons(NULL, &markerslot->markers[ll].bounds, lb->poly, &lb->bbox ) == MS_TRUE ) {
-          return MS_FALSE;
-        }
-      }
-    }
-  }
-
-  for(p=0; p<labelcache->num_rendered_members; p++) {
-    labelCacheMemberObj *curCachePtr= labelcache->rendered_text_symbols[p];
-    if(msRectOverlap(&curCachePtr->bbox,&lb->bbox)) {
-      for(i=0; i<curCachePtr->numtextsymbols; i++) {
-        int j;
-        textSymbolObj *ts = curCachePtr->textsymbols[i];
-        if(ts->textpath && intersectLabelPolygons(ts->textpath->bounds.poly, &ts->textpath->bounds.bbox, lb->poly, &lb->bbox) == MS_TRUE ) {
-          return MS_FALSE;
-        }
-        if(ts->style_bounds) {
-          for(j=0;j<ts->label->numstyles;j++) {
-            if(ts->style_bounds[j] && ts->label->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-              if(intersectLabelPolygons(ts->style_bounds[j]->poly, &ts->style_bounds[j]->bbox,
-                  lb->poly, &lb->bbox)) {
-                return MS_FALSE;
-              }
-            }
-          }
-        }
-      }
-    }
-    if(curCachePtr->leaderline) {
-      if(testSegmentLabelBBoxIntersection(curCachePtr->leaderbbox, &curCachePtr->leaderline->point[0],
-          &curCachePtr->leaderline->point[1], lb) == MS_FALSE) {
-        return MS_FALSE;
-      }
-    }
-  }
-  return MS_TRUE;
-}
-
-/* utility function to get the rect of a string outside of a rendering loop, i.e.
- without going through textpath layouts */
-int msGetStringSize(mapObj *map, labelObj *label, int size, char *string, rectObj *r) {
-  textSymbolObj ts;
-  double lsize = label->size;
-  initTextSymbol(&ts);
-  label->size = size;
-  msPopulateTextSymbolForLabelAndString(&ts,label,msStrdup(string),1,1,0);
-  if(MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map,&ts,r)))
-    return MS_FAILURE;
-  label->size = lsize;
-  freeTextSymbol(&ts);
-  return MS_SUCCESS;
-}
-
-int msInitFontSet(fontSetObj *fontset)
-{
-  fontset->filename = NULL;
-
-  /* fontset->fonts = NULL; */
-  initHashTable(&(fontset->fonts));
-
-  fontset->numfonts = 0;
-  fontset->map = NULL;
-  return( 0 );
-}
-
-int msFreeFontSet(fontSetObj *fontset)
-{
-  if (fontset->filename)
-    free(fontset->filename);
-  fontset->filename = NULL;
-  if (&(fontset->fonts))
-    msFreeHashItems(&(fontset->fonts));
-  /* fontset->fonts = NULL; */
-  fontset->numfonts = 0;
-
-  return( 0 );
-}
-
-int msLoadFontSet(fontSetObj *fontset, mapObj *map)
-{
-  VSILFILE *stream;
-  const char* line;
-  char *path;
-  char szPath[MS_MAXPATHLEN];
-  int i;
-  int bFullPath = 0;
-  const char* realpath;
-
-  if(fontset->numfonts != 0) /* already initialized */
-    return(0);
-
-  if(!fontset->filename)
-    return(0);
-
-  fontset->map = (mapObj *)map;
-
-  path = msGetPath(fontset->filename);
-
-  /* fontset->fonts = msCreateHashTable(); // create font hash */
-  /* if(!fontset->fonts) { */
-  /* msSetError(MS_HASHERR, "Error initializing font hash.", "msLoadFontSet()"); */
-  /* return(-1); */
-  /* } */
-
-  realpath = msBuildPath(szPath, fontset->map->mappath, fontset->filename);
-  if( !realpath ) {
-    free(path);
-    return -1;
-  }
-  stream = VSIFOpenL( realpath, "rb");
-  if(!stream) {
-    msSetError(MS_IOERR, "Error opening fontset %s.", "msLoadFontset()",
-               fontset->filename);
-    free(path);
-    return(-1);
-  }
-
-  i = 0;
-  while( (line = CPLReadLineL(stream)) != NULL ) { /* while there's something to load */
-
-    if(line[0] == '#' || line[0] == '\n' || line[0] == '\r' || line[0] == ' ')
-      continue; /* skip comments and blank lines */
-
-    char alias[64];
-    snprintf(alias, sizeof(alias), "%s", line);
-    char* ptr = strpbrk(alias, " \t");
-    if( !ptr )
-        continue;
-    *ptr = '\0';
-
-    const char* file1StartPtr = line + (ptr - alias);
-    file1StartPtr ++;
-    /* Skip leading spaces */
-    while( isspace((int)*file1StartPtr) )
-        file1StartPtr ++;
-
-    if (!(*file1StartPtr) || !(*alias))
-      continue;
-
-    char file1[MS_PATH_LENGTH];
-    snprintf(file1, sizeof(file1), "%s", file1StartPtr);
-    /* Remove trailing spaces */
-    ptr = file1 + strlen(file1) - 1;
-    while( ptr >= file1 && isspace((int)*ptr) )
-    {
-        *ptr = '\0';
-        --ptr;
-    }
-
-    bFullPath = 0;
-#if defined(_WIN32) && !defined(__CYGWIN__)
-    if (file1[0] == '\\' || (strlen(file1) > 1 && (file1[1] == ':')))
-      bFullPath = 1;
-#else
-    if(file1[0] == '/')
-      bFullPath = 1;
-#endif
-
-    if(bFullPath) { /* already full path */
-      msInsertHashTable(&(fontset->fonts), alias, file1);
-    } else {
-      char file2[MS_PATH_LENGTH];
-      snprintf(file2, sizeof(file2), "%s%s", path, file1);
-      /* msInsertHashTable(fontset->fonts, alias, file2); */
-
-      /*
-      ** msBuildPath is use here, but if we have to save the fontset file
-      ** the msBuildPath must be done everywhere the fonts are used and
-      ** removed here.
-      */
-      msInsertHashTable(&(fontset->fonts), alias,
-                        msBuildPath(szPath, fontset->map->mappath, file2));
-
-    }
-
-    i++;
-  }
-
-  fontset->numfonts = i;
-  VSIFCloseL(stream); /* close the file */
-  free(path);
-
-  return(0);
-}
-
-
-int msGetTextSymbolSize(mapObj *map, textSymbolObj *ts, rectObj *r) {
-  if(!ts->textpath) {
-    if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts)))
-      return MS_FAILURE;
-  }
-  if(!ts->textpath)
-    return MS_FAILURE;
-  *r = ts->textpath->bounds.bbox;
-  return MS_SUCCESS;
-}
-/*
-** Note: All these routines assume a reference point at the LL corner of the text. GD's
-** bitmapped fonts use UL and this is compensated for. Note the rect is relative to the
-** LL corner of the text to be rendered, this is first line for TrueType fonts.
-*/
-
-#define MARKER_SLOP 2
-
-pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy, double rotation, int buffer, label_bounds *bounds)
-{
-  pointObj q = {0}; // initialize
-  double x1=0, y1=0, x2=0, y2=0;
-  double sin_a,cos_a;
-  double w, h, x, y;
-
-  w = tp->bounds.bbox.maxx - tp->bounds.bbox.minx;
-  h = tp->bounds.bbox.maxy - tp->bounds.bbox.miny;
-
-  switch(position) {
-    case MS_UL:
-      x1 = -w - ox;
-      y1 = -oy;
-      break;
-    case MS_UC:
-      x1 = -(w/2.0);
-      y1 = -oy - MARKER_SLOP;
-      break;
-    case MS_UR:
-      x1 = ox;
-      y1 = -oy;
-      break;
-    case MS_CL:
-      x1 = -w - ox - MARKER_SLOP;
-      if(oy > 0 && tp->numlines == 1)
-        y1 = oy;
-      else
-        y1 = (h/2.0);
-      break;
-    case MS_CC:
-      x1 = -(w/2.0) + ox;
-      y1 = (h/2.0) + oy;
-      break;
-    case MS_CR:
-      x1 = ox + MARKER_SLOP;
-      if(oy > 0 && tp->numlines == 1)
-        y1 = oy;
-      else
-        y1 = (h/2.0);
-      break;
-    case MS_LL:
-      x1 = -w - ox;
-      y1 = h + oy;
-      break;
-    case MS_LC:
-      x1 = -(w/2.0);
-      y1 = h + oy + MARKER_SLOP;
-      break;
-    case MS_LR:
-      x1 = ox;
-      y1 = h + oy;
-      break;
-  }
-
-  if(rotation) {
-    sin_a = sin(rotation);
-    cos_a = cos(rotation);
-
-    x = x1 - tp->bounds.bbox.minx;
-    y = tp->bounds.bbox.maxy - y1;
-    q.x = p->x + (x * cos_a - (y) * sin_a);
-    q.y = p->y - (x * sin_a + (y) * cos_a);
-
-    if(bounds) {
-      x2 = x1 - buffer; /* ll */
-      y2 = y1 + buffer;
-      bounds->poly->point[0].x = p->x + (x2 * cos_a - (-y2) * sin_a);
-      bounds->poly->point[0].y = p->y - (x2 * sin_a + (-y2) * cos_a);
-
-      x2 = x1 - buffer; /* ul */
-      y2 = y1 - h - buffer;
-      bounds->poly->point[1].x = p->x + (x2 * cos_a - (-y2) * sin_a);
-      bounds->poly->point[1].y = p->y - (x2 * sin_a + (-y2) * cos_a);
-
-      x2 = x1 + w + buffer; /* ur */
-      y2 = y1 - h - buffer;
-      bounds->poly->point[2].x = p->x + (x2 * cos_a - (-y2) * sin_a);
-      bounds->poly->point[2].y = p->y - (x2 * sin_a + (-y2) * cos_a);
-
-      x2 = x1 + w + buffer; /* lr */
-      y2 = y1 + buffer;
-      bounds->poly->point[3].x = p->x + (x2 * cos_a - (-y2) * sin_a);
-      bounds->poly->point[3].y = p->y - (x2 * sin_a + (-y2) * cos_a);
-
-      bounds->poly->point[4].x = bounds->poly->point[0].x;
-      bounds->poly->point[4].y = bounds->poly->point[0].y;
-      fastComputeBounds(bounds->poly,&bounds->bbox);
-    }
-  }
-  else {
-    q.x = p->x + x1 - tp->bounds.bbox.minx;
-    q.y = p->y + y1 - tp->bounds.bbox.maxy;
-
-    if(bounds) {
-      /* no rotation, we only need to return a bbox */
-      bounds->poly = NULL;
-
-
-      bounds->bbox.minx = q.x - buffer;
-      bounds->bbox.maxy = q.y + buffer + tp->bounds.bbox.maxy;
-      bounds->bbox.maxx = q.x + w + buffer;
-      bounds->bbox.miny = bounds->bbox.maxy - h - buffer*2;
-    }
-  }
-  return(q);
-}
-
-int intersectTextSymbol(textSymbolObj *ts, label_bounds *lb) {
-  if(ts->textpath && ts->textpath->absolute) {
-    if(intersectLabelPolygons(lb->poly,&lb->bbox,ts->textpath->bounds.poly,&ts->textpath->bounds.bbox))
-      return MS_TRUE;
-  }
-  if(ts->style_bounds) {
-    int s;
-    for(s=0; s<ts->label->numstyles; s++) {
-      if(ts->style_bounds[s] && ts->label->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
-          intersectLabelPolygons(lb->poly,&lb->bbox,ts->style_bounds[s]->poly, &ts->style_bounds[s]->bbox))
-        return MS_TRUE;
-    }
-  }
-  return MS_FALSE;
-}
-
-/*
-** Variation on msIntersectPolygons. Label polygons aren't like shapefile polygons. They
-** have no holes, and often do have overlapping parts (i.e. road symbols).
-*/
-int intersectLabelPolygons(lineObj *l1, rectObj *r1, lineObj *l2, rectObj *r2)
-{
-  int v1,v2;
-  pointObj *point;
-  lineObj *p1,*p2,sp1,sp2;
-  pointObj pnts1[5],pnts2[5];
-
-
-  /* STEP 0: check bounding boxes */
-  if(!msRectOverlap(r1,r2)) { /* from alans@wunderground.com */
-    return(MS_FALSE);
-  }
-  if(!l1 && !l2)
-    return MS_TRUE;
-
-  if(!l1) {
-    p1 = &sp1;
-    p1->numpoints = 5;
-    p1->point = pnts1;
-    pnts1[0].x = pnts1[1].x = pnts1[4].x = r1->minx;
-    pnts1[2].x = pnts1[3].x = r1->maxx;
-    pnts1[0].y = pnts1[3].y = pnts1[4].y = r1->miny;
-    pnts1[1].y = pnts1[2].y = r1->maxy;
-  } else {
-    p1 = l1;
-  }
-  if(!l2) {
-    p2 = &sp2;
-    p2->numpoints = 5;
-    p2->point = pnts2;
-    pnts2[0].x = pnts2[1].x = pnts2[4].x = r2->minx;
-    pnts2[2].x = pnts2[3].x = r2->maxx;
-    pnts2[0].y = pnts2[3].y = pnts2[4].y = r2->miny;
-    pnts2[1].y = pnts2[2].y = r2->maxy;
-  } else {
-    p2 = l2;
-  }
-  (void)pnts1[0].x; (void)pnts1[0].y;
-  (void)pnts1[1].x; (void)pnts1[1].y;
-  (void)pnts1[2].x; (void)pnts1[2].y;
-  (void)pnts1[3].x; (void)pnts1[3].y;
-  (void)pnts1[4].x; (void)pnts1[4].y;
-  (void)pnts2[0].x; (void)pnts2[0].y;
-  (void)pnts2[1].x; (void)pnts2[1].y;
-  (void)pnts2[2].x; (void)pnts2[2].y;
-  (void)pnts2[3].x; (void)pnts2[3].y;
-  (void)pnts2[4].x; (void)pnts2[4].y;
-
-  /* STEP 1: look for intersecting line segments */
-  for(v1=1; v1<p1->numpoints; v1++)
-    for(v2=1; v2<p2->numpoints; v2++)
-      if(msIntersectSegments(&(p1->point[v1-1]), &(p1->point[v1]), &(p2->point[v2-1]), &(p2->point[v2])) ==  MS_TRUE) {
-        return(MS_TRUE);
-    }
-
-  /* STEP 2: polygon one completely contains two (only need to check one point from each part) */
-  point = &(p2->point[0]);
-  if(msPointInPolygon(point, p1) == MS_TRUE) /* ok, the point is in a polygon */
-    return(MS_TRUE);
-
-  /* STEP 3: polygon two completely contains one (only need to check one point from each part) */
-  point = &(p1->point[0]);
-  if(msPointInPolygon(point, p2) == MS_TRUE) /* ok, the point is in a polygon */
-    return(MS_TRUE);
-
-  return(MS_FALSE);
-}
-
-/* For MapScript, exactly the same the msInsertStyle */
-int msInsertLabelStyle(labelObj *label, styleObj *style, int nStyleIndex)
-{
-  if (!style) {
-    msSetError(MS_CHILDERR, "Can't insert a NULL Style", "msInsertLabelStyle()");
-    return -1;
-  }
-
-  /* Ensure there is room for a new style */
-  if (msGrowLabelStyles(label) == NULL) {
-    return -1;
-  }
-  /* Catch attempt to insert past end of styles array */
-  else if (nStyleIndex >= label->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d", "insertLabelStyle()", label->numstyles-1);
-    return -1;
-  } else if (nStyleIndex < 0) { /* Insert at the end by default */
-    label->styles[label->numstyles]=style;
-    MS_REFCNT_INCR(style);
-    label->numstyles++;
-    return label->numstyles-1;
-  } else {
-    /* Move styles existing at the specified nStyleIndex or greater */
-    /* to a higher nStyleIndex */
-    for (int i=label->numstyles-1; i>=nStyleIndex; i--) {
-      label->styles[i+1] = label->styles[i];
-    }
-    label->styles[nStyleIndex]=style;
-    MS_REFCNT_INCR(style);
-    label->numstyles++;
-    return nStyleIndex;
-  }
-}
-
-/**
- * Move the style up inside the array of styles.
- */
-int msMoveLabelStyleUp(labelObj *label, int nStyleIndex)
-{
-  if (label && nStyleIndex < label->numstyles && nStyleIndex >0) {
-    styleObj* psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
-    initStyle(psTmpStyle);
-
-    msCopyStyle(psTmpStyle, label->styles[nStyleIndex]);
-
-    msCopyStyle(label->styles[nStyleIndex],
-                label->styles[nStyleIndex-1]);
-
-    msCopyStyle(label->styles[nStyleIndex-1], psTmpStyle);
-
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLabelStyleUp()",
-             nStyleIndex);
-  return (MS_FAILURE);
-}
-
-
-/**
- * Move the style down inside the array of styles.
- */
-int msMoveLabelStyleDown(labelObj *label, int nStyleIndex)
-{
-  styleObj *psTmpStyle = NULL;
-
-  if (label && nStyleIndex < label->numstyles-1 && nStyleIndex >=0) {
-    psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
-    initStyle(psTmpStyle);
-
-    msCopyStyle(psTmpStyle, label->styles[nStyleIndex]);
-
-    msCopyStyle(label->styles[nStyleIndex],
-                label->styles[nStyleIndex+1]);
-
-    msCopyStyle(label->styles[nStyleIndex+1], psTmpStyle);
-
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLabelStyleDown()",
-             nStyleIndex);
-  return (MS_FAILURE);
-}
-
-/**
- * Delete the style identified by the index and shift
- * styles that follows the deleted style.
- */
-int msDeleteLabelStyle(labelObj *label, int nStyleIndex)
-{
-  if (label && nStyleIndex < label->numstyles && nStyleIndex >=0) {
-    if (freeStyle(label->styles[nStyleIndex]) == MS_SUCCESS)
-      msFree(label->styles[nStyleIndex]);
-    for (int i=nStyleIndex; i< label->numstyles-1; i++) {
-      label->styles[i] = label->styles[i+1];
-    }
-    label->styles[label->numstyles-1] = NULL;
-    label->numstyles--;
-    return(MS_SUCCESS);
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msDeleteLabelStyle()",
-             nStyleIndex);
-  return (MS_FAILURE);
-}
-
-styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex)
-{
-  int i;
-  styleObj *style;
-  if (nStyleIndex < 0 || nStyleIndex >= label->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d", "removeLabelStyle()", nStyleIndex);
-    return NULL;
-  } else {
-    style=label->styles[nStyleIndex];
-    for (i=nStyleIndex; i<label->numstyles-1; i++) {
-      label->styles[i]=label->styles[i+1];
-    }
-    label->styles[label->numstyles-1]=NULL;
-    label->numstyles--;
-    MS_REFCNT_DECR(style);
-    return style;
-  }
-}
diff -pruN 8.0.1-5/maplayer.c 8.2.0~beta1-1~exp1/maplayer.c
--- 8.0.1-5/maplayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maplayer.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2491 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of most layerObj functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maptime.h"
-#include "mapogcfilter.h"
-#include "mapthread.h"
-#include "mapfile.h"
-#include "mapows.h"
-#include "mapparser.h"
-
-#include <assert.h>
-
-#ifndef cppcheck_assert
-#define cppcheck_assert(x) do {} while(0)
-#endif
-
-static int populateVirtualTable(layerVTableObj *vtable);
-
-/*
-** Iteminfo is a layer parameter that holds information necessary to retrieve an individual item for
-** a particular source. It is an array built from a list of items. The type of iteminfo will vary by
-** source. For shapefiles and OGR it is simply an array of integers where each value is an index for
-** the item. For SDE it's a ESRI specific type that contains index and column type information. Two
-** helper functions below initialize and free that structure member which is used locally by layer
-** specific functions.
-*/
-int msLayerInitItemInfo(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerInitItemInfo(layer);
-}
-
-void msLayerFreeItemInfo(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if( rv != MS_SUCCESS )
-      return;
-  }
-  cppcheck_assert(layer->vtable);
-  layer->vtable->LayerFreeItemInfo(layer);
-
-  /*
-   * Layer expressions with attribute binding hold a numeric index pointing
-   * to an iteminfo (node->tokenval.bindval.index). If iteminfo changes,
-   * an expression may be no longer valid. (#5161)
-   */
-  msLayerFreeExpressions(layer);
-}
-
-int msLayerRestoreFromScaletokens(layerObj *layer)
-{
-  if(!layer->scaletokens || !layer->orig_st) {
-    return MS_SUCCESS;
-  }
-  if(layer->orig_st->data) {
-    msFree(layer->data);
-    layer->data = layer->orig_st->data;
-  }
-  if(layer->orig_st->tileindex) {
-    msFree(layer->tileindex);
-    layer->tileindex = layer->orig_st->tileindex;
-  }
-  if(layer->orig_st->tileitem) {
-    msFree(layer->tileitem);
-    layer->tileitem = layer->orig_st->tileitem;
-  }
-  if(layer->orig_st->filter) {
-    msLoadExpressionString(&(layer->filter),layer->orig_st->filter);
-    msFree(layer->orig_st->filter);
-  }
-  if(layer->orig_st->filteritem) {
-    msFree(layer->filteritem);
-    layer->filteritem = layer->orig_st->filteritem;
-  }
-  if(layer->orig_st->n_processing) {
-    int i;
-    for(i=0;i<layer->orig_st->n_processing;i++) {
-      msFree(layer->processing[layer->orig_st->processing_idx[i]]);
-      layer->processing[layer->orig_st->processing_idx[i]] = layer->orig_st->processing[i];
-    }
-    msFree(layer->orig_st->processing);
-    msFree(layer->orig_st->processing_idx);
-  }
-  msFree(layer->orig_st);
-  layer->orig_st = NULL;
-  return MS_SUCCESS; 
-}
-
-#define check_st_alloc(l) if(!l->orig_st) l->orig_st=msSmallCalloc(1,sizeof(originalScaleTokenStrings));
-int msLayerApplyScaletokens(layerObj *layer, double scale)
-{
-  int i,p;
-  if(!layer->scaletokens) {
-    return MS_SUCCESS;
-  }
-  msLayerRestoreFromScaletokens(layer);
-  for(i=0;i<layer->numscaletokens;i++) {
-    scaleTokenObj *st = &layer->scaletokens[i];
-    scaleTokenEntryObj *ste = NULL;
-    if(scale<=0) {
-       ste = &(st->tokens[0]);
-      /* no scale defined, use first entry */
-    } else {
-      int tokenindex=0;
-      while(tokenindex<st->n_entries) {
-        ste = &(st->tokens[tokenindex]);
-        if(scale < ste->maxscale && scale >= ste->minscale) break; /* current token is the correct one */
-        tokenindex++;
-        ste = NULL;
-      }
-    }
-    assert(ste);
-    if(layer->data && strstr(layer->data,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->data (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
-      }
-      check_st_alloc(layer);
-      layer->orig_st->data = layer->data;
-      layer->data = msStrdup(layer->data);
-      layer->data = msReplaceSubstring(layer->data,st->name,ste->value);
-    }
-    if(layer->tileindex && strstr(layer->tileindex,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->tileindex (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
-      }
-      check_st_alloc(layer);
-      layer->orig_st->tileindex = layer->tileindex;
-      layer->tileindex = msStrdup(layer->tileindex);
-      layer->tileindex = msReplaceSubstring(layer->tileindex,st->name,ste->value);
-    }
-    if(layer->tileitem && strstr(layer->tileitem,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->tileitem (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
-      }
-      check_st_alloc(layer);
-      layer->orig_st->tileitem = layer->tileitem;
-      layer->tileitem = msStrdup(layer->tileitem);
-      layer->tileitem = msReplaceSubstring(layer->tileitem,st->name,ste->value);
-    }
-    if(layer->filteritem && strstr(layer->filteritem,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->filteritem (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
-      }
-      check_st_alloc(layer);
-      layer->orig_st->filteritem = layer->filteritem;
-      layer->filteritem = msStrdup(layer->filteritem);
-      layer->filteritem = msReplaceSubstring(layer->filteritem,st->name,ste->value);
-    }
-    if(layer->filter.string && strstr(layer->filter.string,st->name)) {
-      char *tmpval;
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->filter (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
-      }
-      check_st_alloc(layer);
-      layer->orig_st->filter = msStrdup(layer->filter.string);
-      tmpval = msStrdup(layer->filter.string);
-      tmpval = msReplaceSubstring(tmpval,st->name,ste->value);
-      if(msLoadExpressionString(&(layer->filter),tmpval) == -1) return(MS_FAILURE); /* msLoadExpressionString() cleans up previously allocated expression */
-      msFree(tmpval);
-    }
-    for(p=0;p<layer->numprocessing;p++) {
-      if(strstr(layer->processing[p],st->name)) {
-        check_st_alloc(layer);
-        layer->orig_st->n_processing++;
-        layer->orig_st->processing = msSmallRealloc(layer->orig_st->processing, layer->orig_st->n_processing * sizeof(char*));
-        layer->orig_st->processing_idx = msSmallRealloc(layer->orig_st->processing_idx, layer->orig_st->n_processing * sizeof(int));
-        layer->orig_st->processing[layer->orig_st->n_processing-1] = layer->processing[p];
-        layer->orig_st->processing_idx[layer->orig_st->n_processing-1] = p;
-        layer->processing[p] = msStrdup(layer->processing[p]);
-        layer->processing[p] = msReplaceSubstring(layer->processing[p],st->name,ste->value);
-      }
-    }
-
-  }
-  return MS_SUCCESS;
-}
-
-
-/*
-** Does exactly what it implies, readies a layer for processing.
-*/
-int msLayerOpen(layerObj *layer)
-{
-  int rv;
-
-  /* RFC-86 Scale dependant token replacements*/
-  rv = msLayerApplyScaletokens(layer,(layer->map)?layer->map->scaledenom:-1);
-  if (rv != MS_SUCCESS) return rv;
-
-  /* RFC-69 clustering support */
-  if (layer->cluster.region)
-    return msClusterLayerOpen(layer);
-
-  if(layer->features && layer->connectiontype != MS_GRATICULE )
-    layer->connectiontype = MS_INLINE;
-
-  if(layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
-    layer->connectiontype = MS_TILED_SHAPEFILE;
-
-  if(layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS
-      && layer->connectiontype != MS_KERNELDENSITY)
-    layer->connectiontype = MS_RASTER;
-
-  if ( ! layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerOpen(layer);
-}
-
-/*
-** Returns MS_TRUE if layer has been opened using msLayerOpen(), MS_FALSE otherwise
-*/
-int msLayerIsOpen(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerIsOpen(layer);
-}
-
-/*
-** Returns MS_TRUE is a layer supports the common expression/filter syntax (RFC 64) and MS_FALSE otherwise.
-*/
-int msLayerSupportsCommonFilters(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerSupportsCommonFilters(layer);
-}
-
-int msLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-  if (!layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerTranslateFilter(layer, filter, filteritem);
-}
-
-/*
-** Performs a spatial, and optionally an attribute based feature search. The function basically
-** prepares things so that candidate features can be accessed by query or drawing functions. For
-** OGR and shapefiles this sets an internal bit vector that indicates whether a particular feature
-** is to processed. For SDE it executes an SQL statement on the SDE server. Once run the msLayerNextShape
-** function should be called to actually access the shapes.
-**
-** Note that for shapefiles we apply any maxfeatures constraint at this point. That may be the only
-** connection type where this is feasible.
-*/
-int msLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  if(!msLayerSupportsCommonFilters(layer))
-    msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
-
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerWhichShapes(layer, rect, isQuery);
-}
-
-/*
-** Called after msWhichShapes has been called to actually retrieve shapes within a given area
-** and matching a vendor specific filter (i.e. layer FILTER attribute).
-**
-** Shapefiles: NULL shapes (shapes with attributes but NO vertices are skipped)
-*/
-int msLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  int rv, filter_passed;
-  
-  if ( ! layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-
-#ifdef USE_V8_MAPSCRIPT
-  /* we need to force the GetItems for the geomtransform attributes */
-  if(!layer->items &&
-     layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION &&
-     strstr(layer->_geomtransform.string, "javascript"))
-      msLayerGetItems(layer);
-#endif
-
-  /* At the end of switch case (default -> break; -> return MS_FAILURE),
-   * was following TODO ITEM:
-   *
-   * TO DO! This is where dynamic joins will happen. Joined attributes will be
-   * tagged on to the main attributes with the naming scheme [join name].[item name].
-   * We need to leverage the iteminfo (I think) at this point 
-   */
-
-  /* RFC 91: MapServer-based filtering is done at a more general level. */
-  do {
-    rv = layer->vtable->LayerNextShape(layer, shape);
-    if(rv != MS_SUCCESS) return rv;
-
-    /* attributes need to be iconv'd to UTF-8 before any filter logic is applied */
-    if(layer->encoding) {
-      rv = msLayerEncodeShapeAttributes(layer,shape);
-      if(rv != MS_SUCCESS)
-        return rv;
-    }
-
-    filter_passed = msEvalExpression(layer, shape, &(layer->filter), layer->filteritemindex);
-
-    if(!filter_passed) msFreeShape(shape);
-  } while(!filter_passed);
-
-  /* RFC89 Apply Layer GeomTransform */
-  if(layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE && rv == MS_SUCCESS) {
-    rv = msGeomTransformShape(layer->map, layer, shape);      
-    if(rv != MS_SUCCESS)
-      return rv;
-  }
-
-  
-  return rv;
-}
-
-/*
-** Used to retrieve a shape from a result set by index. Result sets are created by the various
-** msQueryBy...() functions. The index is assigned by the data source.
-*/
-/* int msLayerResultsGetShape(layerObj *layer, shapeObj *shape, int tile, long record)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-
-  return layer->vtable->LayerResultsGetShape(layer, shape, tile, record);
-} */
-
-/*
-** Used to retrieve a shape by index. All data sources must be capable of random access using
-** a record number(s) of some sort.
-*/
-int msLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  int rv;
-  
-  if( ! layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
-    if(rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-
-  /*
-  ** TODO: This is where dynamic joins could happen. Joined attributes would be
-  ** tagged on to the main attributes with the naming scheme [join name].[item name].
-  */
-
-  rv = layer->vtable->LayerGetShape(layer, shape, record);
-  if(rv != MS_SUCCESS)
-    return rv;
-
-  /* RFC89 Apply Layer GeomTransform */
-  if(layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
-    rv = msGeomTransformShape(layer->map, layer, shape); 
-    if(rv != MS_SUCCESS)
-      return rv;
-  }
-
-  if(layer->encoding) {
-    rv = msLayerEncodeShapeAttributes(layer,shape);
-    if(rv != MS_SUCCESS)
-      return rv;
-  }
-
-  return rv;
-}
-
-/*
-** Returns the number of shapes that match the potential filter and extent.
- * rectProjection is the projection in which rect is expressed, or can be NULL if
- * rect should be considered in the layer projection.
- * This should be equivalent to calling msLayerWhichShapes() and counting the
- * number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
- * limitation if layer->maxfeatures>=0, and honouring layer->startindex if
- * layer->startindex >= 1 and paging is enabled.
- * Returns -1 in case of failure.
- */
-int msLayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
-  int rv;
-
-  if( ! layer->vtable) {
-    rv = msInitializeVirtualTable(layer);
-    if(rv != MS_SUCCESS)
-      return -1;
-  }
-  cppcheck_assert(layer->vtable);
-
-  return layer->vtable->LayerGetShapeCount(layer, rect, rectProjection);
-}
-
-
-/*
-** Closes resources used by a particular layer.
-*/
-void msLayerClose(layerObj *layer)
-{
-  /* no need for items once the layer is closed */
-  msLayerFreeItemInfo(layer);
-  if(layer->items) {
-    msFreeCharArray(layer->items, layer->numitems);
-    layer->items = NULL;
-    layer->numitems = 0;
-  }
-
-  /* clear out items used as part of expressions (bug #2702) -- what about the layer filter? */
-  msLayerFreeExpressions(layer);
-
-  if (layer->vtable) {
-    layer->vtable->LayerClose(layer);
-  }
-  msLayerRestoreFromScaletokens(layer);
-}
-
-/*
-** Clear out items used as part of expressions.
-*/
-void msLayerFreeExpressions(layerObj *layer)
-{
-  int i,j,k;
-
-  msFreeExpressionTokens(&(layer->filter));
-  msFreeExpressionTokens(&(layer->cluster.group));
-  msFreeExpressionTokens(&(layer->cluster.filter));
-  for(i=0; i<layer->numclasses; i++) {
-    msFreeExpressionTokens(&(layer->class[i]->expression));
-    msFreeExpressionTokens(&(layer->class[i]->text));
-    for(j=0; j<layer->class[i]->numstyles; j++)
-      msFreeExpressionTokens(&(layer->class[i]->styles[j]->_geomtransform));
-    for(k=0; k<layer->class[i]->numlabels; k++) {
-      msFreeExpressionTokens(&(layer->class[i]->labels[k]->expression));
-      msFreeExpressionTokens(&(layer->class[i]->labels[k]->text));
-    }
-  }
-}
-
-/*
-** Retrieves a list of attributes available for this layer. Most sources also set the iteminfo array
-** at this point. This function is used when processing query results to expose attributes to query
-** templates. At that point all attributes are fair game.
-*/
-int msLayerGetItems(layerObj *layer)
-{
-  const char *itemNames;
-  /* clean up any previously allocated instances */
-  msLayerFreeItemInfo(layer);
-  if(layer->items) {
-    msFreeCharArray(layer->items, layer->numitems);
-    layer->items = NULL;
-    layer->numitems = 0;
-  }
-
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-
-  /* At the end of switch case (default -> break; -> return MS_FAILURE),
-   * was following TODO ITEM:
-   */
-  /* TO DO! Need to add any joined itemd on to the core layer items, one long list!  */
-  itemNames = msLayerGetProcessingKey( layer, "ITEMS" );
-  if (itemNames) {
-    layer->items = msStringSplit(itemNames, ',', &layer->numitems);
-    /* populate the iteminfo array */
-    return (msLayerInitItemInfo(layer));
-  } else
-    return layer->vtable->LayerGetItems(layer);
-}
-
-/*
-** Returns extent of spatial coverage for a layer.
-**
-** If layer->extent is set then this value is used, otherwise the
-** driver-specific implementation is called (this can be expensive).
-**
-** If layer is not already opened then it is opened and closed (so this
-** function can be called on both opened or closed layers).
-**
-** Returns MS_SUCCESS/MS_FAILURE.
-*/
-int msLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  int need_to_close = MS_FALSE, status = MS_SUCCESS;
-
-  if (MS_VALID_EXTENT(layer->extent)) {
-    *extent = layer->extent;
-    return MS_SUCCESS;
-  }
-
-  if (!msLayerIsOpen(layer)) {
-    if (msLayerOpen(layer) != MS_SUCCESS)
-      return MS_FAILURE;
-    need_to_close = MS_TRUE;
-  }
-
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS) {
-      if (need_to_close)
-        msLayerClose(layer);
-      return rv;
-    }
-  }
-  cppcheck_assert(layer->vtable);
-  status = layer->vtable->LayerGetExtent(layer, extent);
-
-  if (status == MS_SUCCESS) {
-      layer->extent = *extent;
-  }
-
-  if (need_to_close)
-    msLayerClose(layer);
-
-  return(status);
-}
-
-int msLayerGetItemIndex(layerObj *layer, char *item)
-{
-  int i;
-
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i], item) == 0) return(i);
-  }
-
-  return -1; /* item not found */
-}
-
-static int string2list(char **list, int *listsize, char *string)
-{
-  int i;
-
-  for(i=0; i<(*listsize); i++) {
-    if(strcasecmp(list[i], string) == 0) {
-      /* printf("string2list (duplicate): %s %d\n", string, i); */
-      return(i);
-    }
-  }
-
-  list[i] = msStrdup(string);
-  (*listsize)++;
-
-  /* printf("string2list: %s %d\n", string, i); */
-
-  return(i);
-}
-
-extern int msyylex(void);
-extern int msyylex_destroy(void);
-
-extern int msyystate;
-extern char *msyystring; /* string to tokenize */
-
-extern double msyynumber; /* token containers */
-extern char *msyystring_buffer;
-
-const char *msExpressionTokenToString(int token) {
-  switch(token) {
-    case '(': return "(";          
-    case ')': return ")";
-    case ',': return ",";
-    case '+': return "+";
-    case '-': return "-";
-    case '/': return "/";
-    case '*': return "*";
-    case '%': return "%";
-
-    case MS_TOKEN_LOGICAL_AND: return " and ";
-    case MS_TOKEN_LOGICAL_OR: return " or ";
-    case MS_TOKEN_LOGICAL_NOT: return " not ";
-
-    case MS_TOKEN_COMPARISON_EQ: return " = ";
-    case MS_TOKEN_COMPARISON_NE: return " != ";
-    case MS_TOKEN_COMPARISON_GT: return " > ";
-    case MS_TOKEN_COMPARISON_GE: return " >= ";
-    case MS_TOKEN_COMPARISON_LT: return " < ";
-    case MS_TOKEN_COMPARISON_LE: return " <= ";
-    case MS_TOKEN_COMPARISON_IEQ: return "";
-    case MS_TOKEN_COMPARISON_RE: return " ~ ";
-    case MS_TOKEN_COMPARISON_IRE: return " ~* ";
-    case MS_TOKEN_COMPARISON_IN: return " in ";
-    case MS_TOKEN_COMPARISON_LIKE: return " like ";
-
-    case MS_TOKEN_COMPARISON_INTERSECTS: return "intersects";
-    case MS_TOKEN_COMPARISON_DISJOINT: return "disjoint";
-    case MS_TOKEN_COMPARISON_TOUCHES: return "touches";
-    case MS_TOKEN_COMPARISON_OVERLAPS: return "overlaps";
-    case MS_TOKEN_COMPARISON_CROSSES: return "crosses";
-    case MS_TOKEN_COMPARISON_WITHIN: return "within";
-    case MS_TOKEN_COMPARISON_CONTAINS: return "contains";
-    case MS_TOKEN_COMPARISON_EQUALS: return "equals";
-    case MS_TOKEN_COMPARISON_BEYOND: return "beyond";
-    case MS_TOKEN_COMPARISON_DWITHIN: return "dwithin";
-
-    case MS_TOKEN_FUNCTION_LENGTH: return "length";
-    case MS_TOKEN_FUNCTION_TOSTRING: return "tostring";
-    case MS_TOKEN_FUNCTION_COMMIFY: return "commify";
-    case MS_TOKEN_FUNCTION_AREA: return "area";
-    case MS_TOKEN_FUNCTION_ROUND: return "round";
-    case MS_TOKEN_FUNCTION_BUFFER: return "buffer";
-    case MS_TOKEN_FUNCTION_DIFFERENCE: return "difference";
-    case MS_TOKEN_FUNCTION_SIMPLIFY: return "simplify";
-    // case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-    case MS_TOKEN_FUNCTION_GENERALIZE: return "generalize";
-    default: return NULL;
-  }
-}
-
-int msTokenizeExpression(expressionObj *expression, char **list, int *listsize)
-{
-  tokenListNodeObjPtr node;
-  int token;
-
-  /* TODO: make sure the constants can't somehow reference invalid expression types */
-  /* if(expression->type != MS_EXPRESSION && expression->type != MS_GEOMTRANSFORM_EXPRESSION) return MS_SUCCESS; */
-
-  msAcquireLock(TLOCK_PARSER);
-  msyystate = MS_TOKENIZE_EXPRESSION;
-  msyystring = expression->string; /* the thing we're tokenizing */
-
-  while((token = msyylex()) != 0) { /* keep processing tokens until the end of the string (\0) */
-
-    if((node = (tokenListNodeObjPtr) malloc(sizeof(tokenListNodeObj))) == NULL) {
-      msSetError(MS_MEMERR, NULL, "msTokenizeExpression()");
-      goto parse_error;
-    }
-
-    node->tokensrc = NULL;
-
-    node->tailifhead = NULL;
-    node->next = NULL;
-
-    switch(token) {
-      case MS_TOKEN_LITERAL_BOOLEAN:
-      case MS_TOKEN_LITERAL_NUMBER:
-        node->token = token;
-        node->tokenval.dblval = msyynumber;
-        break;
-      case MS_TOKEN_LITERAL_STRING:
-        node->token = token;
-        node->tokenval.strval = msStrdup(msyystring_buffer);
-        break;
-      case MS_TOKEN_LITERAL_TIME:
-        node->tokensrc = msStrdup(msyystring_buffer);
-        node->token = token;
-        msTimeInit(&(node->tokenval.tmval));
-        if(msParseTime(msyystring_buffer, &(node->tokenval.tmval)) != MS_TRUE) {
-          msSetError(MS_PARSEERR, "Parsing time value failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-        break;
-      case MS_TOKEN_BINDING_DOUBLE: /* we've encountered an attribute (binding) reference */
-      case MS_TOKEN_BINDING_INTEGER:
-      case MS_TOKEN_BINDING_STRING:
-      case MS_TOKEN_BINDING_TIME:
-        node->token = token; /* binding type */
-        node->tokenval.bindval.item = msStrdup(msyystring_buffer);
-        if(list) node->tokenval.bindval.index = string2list(list, listsize, msyystring_buffer);
-        break;
-      case MS_TOKEN_BINDING_SHAPE:
-        node->token = token;
-        break;
-      case MS_TOKEN_BINDING_MAP_CELLSIZE:
-        node->token = token;
-        break;
-      case MS_TOKEN_BINDING_DATA_CELLSIZE:
-        node->token = token;
-        break;        
-      case MS_TOKEN_FUNCTION_FROMTEXT: /* we want to process a shape from WKT once and not for every feature being evaluated */
-        if((token = msyylex()) != 40) { /* ( */
-          msSetError(MS_PARSEERR, "Parsing fromText function failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-
-        if((token = msyylex()) != MS_TOKEN_LITERAL_STRING) {
-          msSetError(MS_PARSEERR, "Parsing fromText function failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-
-        node->token = MS_TOKEN_LITERAL_SHAPE;
-        node->tokenval.shpval = msShapeFromWKT(msyystring_buffer);
-
-        if(!node->tokenval.shpval) {
-          msSetError(MS_PARSEERR, "Parsing fromText function failed, WKT processing failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-
-        /* todo: perhaps process optional args (e.g. projection) */
-
-        if((token = msyylex()) != 41) { /* ) */
-          msSetError(MS_PARSEERR, "Parsing fromText function failed.", "msTokenizeExpression()");
-          msFreeShape(node->tokenval.shpval);
-          free(node->tokenval.shpval);
-          free(node);
-          goto parse_error;
-        }
-        break;
-      default:
-        node->token = token; /* for everything else */
-        break;
-    }
-
-    /* add node to token list */
-    if(expression->tokens == NULL) {
-      expression->tokens = node;
-    } else {
-      if(expression->tokens->tailifhead != NULL) /* this should never be NULL, but just in case */
-        expression->tokens->tailifhead->next = node; /* put the node at the end of the list */
-    }
-
-    /* repoint the head of the list to the end  - our new element
-       this causes a loop if we are at the head, be careful not to
-       walk in a loop */
-    expression->tokens->tailifhead = node;
-  }
-
-  expression->curtoken = expression->tokens; /* point at the first token */
-
-  msReleaseLock(TLOCK_PARSER);
-  return MS_SUCCESS;
-
-parse_error:
-  msReleaseLock(TLOCK_PARSER);
-  return MS_FAILURE;
-}
-
-
-static void buildLayerItemList(layerObj *layer)
-{
-  int i, j, k, l;
-  /*
-  ** build layer item list, compute item indexes for explicity item references (e.g. classitem) or item bindings
-  */
-
-  /* layer items */
-  if(layer->classitem) layer->classitemindex = string2list(layer->items, &(layer->numitems), layer->classitem);
-  if(layer->filteritem) layer->filteritemindex = string2list(layer->items, &(layer->numitems), layer->filteritem);
-  if(layer->styleitem && (strcasecmp(layer->styleitem, "AUTO") != 0) && (strncasecmp(layer->styleitem, "javascript://",13) != 0)) 
-    layer->styleitemindex = string2list(layer->items, &(layer->numitems), layer->styleitem);
-  if(layer->labelitem) layer->labelitemindex = string2list(layer->items, &(layer->numitems), layer->labelitem);
-  if(layer->utfitem) layer->utfitemindex = string2list(layer->items, &(layer->numitems), layer->utfitem);
-
-  /* layer classes */
-  for(i=0; i<layer->numclasses; i++) {
-    
-    if(layer->class[i]->expression.type == MS_EXPRESSION) /* class expression */
-      msTokenizeExpression(&(layer->class[i]->expression), layer->items, &(layer->numitems));
-
-    /* class styles (items, bindings, geomtransform) */
-    for(j=0; j<layer->class[i]->numstyles; j++) {
-      if(layer->class[i]->styles[j]->rangeitem) 
-        layer->class[i]->styles[j]->rangeitemindex = string2list(layer->items, &(layer->numitems), layer->class[i]->styles[j]->rangeitem);
-      for(k=0; k<MS_STYLE_BINDING_LENGTH; k++) {
-        if(layer->class[i]->styles[j]->bindings[k].item) 
-          layer->class[i]->styles[j]->bindings[k].index = string2list(layer->items, &(layer->numitems), layer->class[i]->styles[j]->bindings[k].item);
-        if (layer->class[i]->styles[j]->exprBindings[k].type == MS_EXPRESSION)
-        {
-          msTokenizeExpression(
-              &(layer->class[i]->styles[j]->exprBindings[k]),
-              layer->items, &(layer->numitems));
-        }
-      }
-      if(layer->class[i]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-        msTokenizeExpression(&(layer->class[i]->styles[j]->_geomtransform), layer->items, &(layer->numitems));
-    }
-
-    /* class labels and label styles (items, bindings, geomtransform) */
-    for(l=0; l<layer->class[i]->numlabels; l++) {
-      for(j=0; j<layer->class[i]->labels[l]->numstyles; j++) {
-        if(layer->class[i]->labels[l]->styles[j]->rangeitem) 
-          layer->class[i]->labels[l]->styles[j]->rangeitemindex = string2list(layer->items, &(layer->numitems), layer->class[i]->labels[l]->styles[j]->rangeitem);
-        for(k=0; k<MS_STYLE_BINDING_LENGTH; k++) {
-          if(layer->class[i]->labels[l]->styles[j]->bindings[k].item) 
-            layer->class[i]->labels[l]->styles[j]->bindings[k].index = string2list(layer->items, &(layer->numitems), layer->class[i]->labels[l]->styles[j]->bindings[k].item);
-          if(layer->class[i]->labels[l]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-            msTokenizeExpression(&(layer->class[i]->labels[l]->styles[j]->_geomtransform), layer->items, &(layer->numitems));
-        }
-      }
-      for(k=0; k<MS_LABEL_BINDING_LENGTH; k++) {
-        if(layer->class[i]->labels[l]->bindings[k].item) 
-          layer->class[i]->labels[l]->bindings[k].index = string2list(layer->items, &(layer->numitems), layer->class[i]->labels[l]->bindings[k].item);
-        if (layer->class[i]->labels[l]->exprBindings[k].type == MS_EXPRESSION)
-        {
-          msTokenizeExpression(
-              &(layer->class[i]->labels[l]->exprBindings[k]),
-              layer->items, &(layer->numitems));
-        }
-      }
-
-       /* label expression */
-      if(layer->class[i]->labels[l]->expression.type == MS_EXPRESSION) msTokenizeExpression(&(layer->class[i]->labels[l]->expression), layer->items, &(layer->numitems));
-
-      /* label text */
-      if(layer->class[i]->labels[l]->text.type == MS_EXPRESSION || (layer->class[i]->labels[l]->text.string && strchr(layer->class[i]->labels[l]->text.string,'[') != NULL && strchr(layer->class[i]->labels[l]->text.string,']') != NULL))
-        msTokenizeExpression(&(layer->class[i]->labels[l]->text), layer->items, &(layer->numitems));
-    }
-
-    /* class text */
-    if(layer->class[i]->text.type == MS_EXPRESSION || (layer->class[i]->text.string && strchr(layer->class[i]->text.string,'[') != NULL && strchr(layer->class[i]->text.string,']') != NULL))
-      msTokenizeExpression(&(layer->class[i]->text), layer->items, &(layer->numitems));
-  }
-
-  /* layer filter */
-  if(layer->filter.type == MS_EXPRESSION) msTokenizeExpression(&(layer->filter), layer->items, &(layer->numitems));
-
-  /* cluster expressions */
-  if(layer->cluster.group.type == MS_EXPRESSION) msTokenizeExpression(&(layer->cluster.group), layer->items, &(layer->numitems));
-  if(layer->cluster.filter.type == MS_EXPRESSION) msTokenizeExpression(&(layer->cluster.filter), layer->items, &(layer->numitems));
-
-  /* utfdata */
-  if(layer->utfdata.type == MS_EXPRESSION || (layer->utfdata.string && strchr(layer->utfdata.string,'[') != NULL && strchr(layer->utfdata.string,']') != NULL)) {
-    msTokenizeExpression(&(layer->utfdata), layer->items, &(layer->numitems));
-  }
-}
-
-/*
-** This function builds a list of items necessary to draw or query a particular layer by
-** examining the contents of the various xxxxitem parameters and expressions. That list is
-** then used to set the iteminfo variable.
-*/
-int msLayerWhichItems(layerObj *layer, int get_all, const char *metadata)
-{
-  int i, j, k, l, rv;
-  int nt=0;
-
-  if (!layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS) return rv;
-  }
-  cppcheck_assert(layer->vtable);
-
-  /* Cleanup any previous item selection */
-  msLayerFreeItemInfo(layer);
-  if(layer->items) {
-    msFreeCharArray(layer->items, layer->numitems);
-    layer->items = NULL;
-    layer->numitems = 0;
-  }
-
-  /*
-  ** need a count of potential items/attributes needed
-  */
-
-  /* layer level counts */
-  layer->classitemindex = -1;
-  layer->filteritemindex = -1;
-  layer->styleitemindex = -1;
-  layer->labelitemindex = -1;
-  layer->utfitemindex = -1;
-
-  if(layer->classitem) nt++;
-  if(layer->filteritem) nt++;
-  if(layer->styleitem &&
-     (strcasecmp(layer->styleitem, "AUTO") != 0) &&
-     (strncasecmp(layer->styleitem, "javascript://", 13) != 0)) nt++;
-     
-  if(layer->filter.type == MS_EXPRESSION)
-    nt += msCountChars(layer->filter.string, '[');
-
-  if(layer->cluster.group.type == MS_EXPRESSION)
-    nt += msCountChars(layer->cluster.group.string, '[');
-
-  if(layer->cluster.filter.type == MS_EXPRESSION)
-    nt += msCountChars(layer->cluster.filter.string, '[');
-
-  if(layer->labelitem) nt++;
-  if(layer->utfitem) nt++;
-
-  if(layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-    msTokenizeExpression(&layer->_geomtransform, layer->items, &(layer->numitems));
-
-  /* class level counts */
-  for(i=0; i<layer->numclasses; i++) {
-
-    for(j=0; j<layer->class[i]->numstyles; j++) {
-      if(layer->class[i]->styles[j]->rangeitem) nt++;
-      nt += layer->class[i]->styles[j]->numbindings;
-      if(layer->class[i]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-        nt += msCountChars(layer->class[i]->styles[j]->_geomtransform.string, '[');
-      for(k=0; k<MS_STYLE_BINDING_LENGTH; k++) {
-        if (layer->class[i]->styles[j]->exprBindings[k].type == MS_EXPRESSION)
-        {
-          nt += msCountChars(layer->class[i]->styles[j]->exprBindings[k].string, '[');
-        }
-      }
-    }
-
-    if(layer->class[i]->expression.type == MS_EXPRESSION)
-      nt += msCountChars(layer->class[i]->expression.string, '[');
-
-    for(l=0; l<layer->class[i]->numlabels; l++) {
-      nt += layer->class[i]->labels[l]->numbindings;
-      for(j=0; j<layer->class[i]->labels[l]->numstyles; j++) {
-        if(layer->class[i]->labels[l]->styles[j]->rangeitem) nt++;
-        nt += layer->class[i]->labels[l]->styles[j]->numbindings;
-        if(layer->class[i]->labels[l]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-          nt += msCountChars(layer->class[i]->labels[l]->styles[j]->_geomtransform.string, '[');
-      }
-      for(k=0; k<MS_LABEL_BINDING_LENGTH; k++) {
-        if (layer->class[i]->labels[l]->exprBindings[k].type == MS_EXPRESSION)
-        {
-          nt += msCountChars(layer->class[i]->labels[l]->exprBindings[k].string, '[');
-        }
-      }
-
-      if(layer->class[i]->labels[l]->expression.type == MS_EXPRESSION)
-        nt += msCountChars(layer->class[i]->labels[l]->expression.string, '[');
-      if(layer->class[i]->labels[l]->text.type == MS_EXPRESSION || (layer->class[i]->labels[l]->text.string && strchr(layer->class[i]->labels[l]->text.string,'[') != NULL && strchr(layer->class[i]->labels[l]->text.string,']') != NULL))
-        nt += msCountChars(layer->class[i]->labels[l]->text.string, '[');
-    }
-
-    if(layer->class[i]->text.type == MS_EXPRESSION || (layer->class[i]->text.string && strchr(layer->class[i]->text.string,'[') != NULL && strchr(layer->class[i]->text.string,']') != NULL))
-      nt += msCountChars(layer->class[i]->text.string, '[');
-  }
-
-  /* utfgrid count */
-  if(layer->utfdata.type == MS_EXPRESSION || (layer->utfdata.string && strchr(layer->utfdata.string,'[') != NULL && strchr(layer->utfdata.string,']') != NULL))
-    nt += msCountChars(layer->utfdata.string, '[');
-
-  // if we are using a GetMap request with a WMS filter we don't need to return all items
-  if (msOWSLookupMetadata(&(layer->metadata), "G", "wmsfilter_flag") != NULL) {
-      get_all = MS_FALSE;
-  }
-
-  if(metadata == NULL){
-      // check item set by mapwfs.cpp to restrict the number of columns selected
-      metadata = msOWSLookupMetadata(&(layer->metadata), "G", "select_items");
-      if (metadata) {
-          /* get only selected items */
-          get_all = MS_FALSE;
-      }
-  }
-
-  /* always retrieve all items in some cases */
-  if(layer->connectiontype == MS_INLINE ||
-      (layer->map->outputformat && layer->map->outputformat->renderer == MS_RENDER_WITH_KML)) {
-    get_all = MS_TRUE;
-  }
-
-  /*
-  ** allocate space for the item list (worse case size)
-  */
-  if( get_all ) {
-    rv = msLayerGetItems(layer);
-    if(nt > 0) /* need to realloc the array to accept the possible new items*/
-      layer->items = (char **)msSmallRealloc(layer->items, sizeof(char *)*(layer->numitems + nt));
-  } else {
-    rv = layer->vtable->LayerCreateItems(layer, nt);
-  }
-  if(rv != MS_SUCCESS)
-    return rv;
-
-  buildLayerItemList(layer);
-
-  if(metadata) {
-    char **tokens;
-    int n = 0;
-    int j;
-
-    tokens = msStringSplit(metadata, ',', &n);
-    if(tokens) {
-      for(i=0; i<n; i++) {
-        int bFound = 0;
-        for(j=0; j<layer->numitems; j++) {
-          if(strcasecmp(tokens[i], layer->items[j]) == 0) {
-            bFound = 1;
-            break;
-          }
-        }
-
-        if(!bFound) {
-          layer->numitems++;
-          layer->items =  (char **)msSmallRealloc(layer->items, sizeof(char *)*(layer->numitems));
-          layer->items[layer->numitems-1] = msStrdup(tokens[i]);
-        }
-      }
-      msFreeCharArray(tokens, n);
-    }
-
-    /* If we didn't retrieve all items of the layer, then do it, so that the */
-    /* order of the layer->items array is consistent with it. This is */
-    /* important so that WFS DescribeFeatureType and GetFeature requests */
-    /* return items in the same order */
-    if( !get_all && layer->numitems ) {
-        char** unsorted_items = layer->items;
-        int numitems = layer->numitems;
-
-        /* Retrieve all items */
-        layer->items = NULL;
-        layer->numitems = 0;
-        rv = msLayerGetItems(layer);
-        if( rv != MS_SUCCESS ) {
-            msFreeCharArray(unsorted_items, numitems);
-            return rv;
-        }
-
-        /* Sort unsorted_items in the order of layer->items */
-        char** sorted_items = (char **)msSmallMalloc(sizeof(char*) * numitems);
-        int num_sorted_items = 0;
-        for( i = 0; i < layer->numitems; i++ )
-        {
-            if( layer->items[i] )
-            {
-                for( j = 0; j < numitems; j++ )
-                {
-                    if( unsorted_items[j] &&
-                        strcasecmp(layer->items[i], unsorted_items[j]) == 0 )
-                    {
-                        sorted_items[num_sorted_items] = layer->items[i];
-                        num_sorted_items ++;
-
-                        layer->items[i] = NULL;
-                        msFree(unsorted_items[j]);
-                        unsorted_items[j] = NULL;
-                        break;
-                    }
-                }
-            }
-        }
-
-        /* Add items that are not returned by msLayerGetItems() (not sure if that can happen) */
-        for( j = 0; j < numitems; j++ )
-        {
-            if( unsorted_items[j] )
-            {
-                sorted_items[num_sorted_items] = unsorted_items[j];
-                num_sorted_items ++;
-            }
-        }
-
-        if(layer->numitems > 0) {
-            msFreeCharArray(layer->items, layer->numitems);
-        }
-        msFreeCharArray(unsorted_items, numitems);
-
-        layer->items = sorted_items;
-        layer->numitems = numitems;
-
-        /* Re-run buildLayerItemList() with the now correctly sorted items */
-        buildLayerItemList(layer);
-    }
-
-  }
-
-  /* populate the iteminfo array */
-  if(layer->numitems == 0)
-    return(MS_SUCCESS);
-
-  return(msLayerInitItemInfo(layer));
-}
-
-/*
-** A helper function to set the items to be retrieved with a particular shape. Unused at the moment but will be used
-** from within MapScript. Should not need modification.
-*/
-int msLayerSetItems(layerObj *layer, char **items, int numitems)
-{
-  int i;
-  /* Cleanup any previous item selection */
-  msLayerFreeItemInfo(layer);
-  if(layer->items) {
-    msFreeCharArray(layer->items, layer->numitems);
-    layer->items = NULL;
-    layer->numitems = 0;
-  }
-
-  /* now allocate and set the layer item parameters  */
-  layer->items = (char **)malloc(sizeof(char *)*numitems);
-  MS_CHECK_ALLOC(layer->items, sizeof(char *)*numitems, MS_FAILURE);
-
-  for(i=0; i<numitems; i++)
-    layer->items[i] = msStrdup(items[i]);
-  layer->numitems = numitems;
-
-  /* populate the iteminfo array */
-  return(msLayerInitItemInfo(layer));
-}
-
-/*
-** Fills a classObj with style info from the specified shape.  This is used
-** with STYLEITEM AUTO when rendering shapes.
-** For optimal results, this should be called immediately after
-** GetNextShape() or GetShape() so that the shape doesn't have to be read
-** twice.
-**
-*/
-int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerGetAutoStyle(map, layer, c, shape);
-}
-
-/*
-** Fills a classObj with style info from the specified attribute.  This is used
-** with STYLEITEM "attribute" when rendering shapes.
-**
-*/
-int msLayerGetFeatureStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape)
-{
-  char* stylestring = NULL;
-  if (layer->styleitem && layer->styleitemindex >=0) {
-    stylestring = msStrdup(shape->values[layer->styleitemindex]);
-  }
-  else if (layer->styleitem && strncasecmp(layer->styleitem,"javascript://",13) == 0) {
-#ifdef USE_V8_MAPSCRIPT
-    char *filename = layer->styleitem+13;
-
-    if (!map->v8context) {
-      msV8CreateContext(map);
-      if (!map->v8context)
-      {
-        msSetError(MS_V8ERR, "Unable to create v8 context.", "msLayerGetFeatureStyle()");
-        return MS_FAILURE;
-      }
-    }
-
-    if (*filename == '\0') {
-      msSetError(MS_V8ERR, "Invalid javascript filename: \"%s\".", "msLayerGetFeatureStyle()", layer->styleitem);
-      return MS_FAILURE;
-    }
-    
-    stylestring = msV8GetFeatureStyle(map, filename, layer, shape);
-#else
-      msSetError(MS_V8ERR, "V8 Javascript support is not available.", "msLayerGetFeatureStyle()");
-      return MS_FAILURE;
-#endif
-  }
-  else { /* unknown styleitem */
-    return MS_FAILURE;
-  }
-
-  /* try to find out the current style format */
-  if (!stylestring)
-    return MS_FAILURE;
-
-  if (strncasecmp(stylestring,"style",5) == 0) {
-    resetClassStyle(c);
-    c->layer = layer;
-    if (msMaybeAllocateClassStyle(c, 0)) {
-      free(stylestring);
-      return(MS_FAILURE);
-    }
-
-    msUpdateStyleFromString(c->styles[0], stylestring);
-    if(c->styles[0]->symbolname) {
-      if((c->styles[0]->symbol =  msGetSymbolIndex(&(map->symbolset), c->styles[0]->symbolname, MS_TRUE)) == -1) {
-        msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class of layer %s.", "msLayerGetFeatureStyle()", 
-                   c->styles[0]->symbolname, layer->name);
-        free(stylestring);
-        return MS_FAILURE;
-      }
-    }
-  } else if (strncasecmp(stylestring,"class",5) == 0) {
-    if (strcasestr(stylestring, " style ") != NULL) {
-      /* reset style if stylestring contains style definitions */
-      resetClassStyle(c);
-      c->layer = layer;
-    }
-    msUpdateClassFromString(c, stylestring);
-  } else if (strncasecmp(stylestring,"pen",3) == 0 || strncasecmp(stylestring,"brush",5) == 0 ||
-             strncasecmp(stylestring,"symbol",6) == 0 || strncasecmp(stylestring,"label",5) == 0) {
-    msOGRUpdateStyleFromString(map, layer, c, stylestring);
-  } else {
-    resetClassStyle(c);
-  }
-
-  free(stylestring);
-  return MS_SUCCESS;
-}
-
-
-/*
-Returns the number of inline feature of a layer
-*/
-int msLayerGetNumFeatures(layerObj *layer)
-{
-    int need_to_close = MS_FALSE, result = -1;
-
-    if (!msLayerIsOpen(layer)) {
-        if (msLayerOpen(layer) != MS_SUCCESS)
-            return result;
-        need_to_close = MS_TRUE;
-    }
-
-    if (!layer->vtable) {
-        int rv = msInitializeVirtualTable(layer);
-        if (rv != MS_SUCCESS)
-            return result;
-    }
-    cppcheck_assert(layer->vtable);
-
-    result = layer->vtable->LayerGetNumFeatures(layer);
-
-    if (need_to_close)
-        msLayerClose(layer);
-
-    return(result);
-}
-
-void
-msLayerSetProcessingKey( layerObj *layer, const char *key, const char *value)
-
-{
-  int len = strlen(key);
-  int i;
-  char *directive = NULL;
-
-  if( value != NULL ) {
-    directive = (char *) msSmallMalloc(strlen(key)+strlen(value)+2);
-    sprintf( directive, "%s=%s", key, value );
-  }
-
-  for( i = 0; i < layer->numprocessing; i++ ) {
-    if( strncasecmp( key, layer->processing[i], len ) == 0
-        && layer->processing[i][len] == '=' ) {
-      free( layer->processing[i] );
-
-      /*
-      ** Either replace the existing entry with a new one or
-      ** clear the entry.
-      */
-      if( directive != NULL )
-        layer->processing[i] = directive;
-      else {
-        layer->processing[i] = layer->processing[layer->numprocessing-1];
-        layer->processing[layer->numprocessing-1] = NULL;
-        layer->numprocessing--;
-      }
-      return;
-    }
-  }
-
-  /* otherwise add the directive at the end. */
-
-  if( directive != NULL ) {
-    msLayerAddProcessing( layer, directive );
-    free( directive );
-  }
-}
-
-void msLayerSubstituteProcessing( layerObj *layer, const char *from, const char *to ) {
-  int i;
-  for( i = 0; i < layer->numprocessing; i++ ) {
-    layer->processing[i] = msCaseReplaceSubstring(layer->processing[i], from, to);
-  }
-}
-
-void msLayerAddProcessing( layerObj *layer, const char *directive )
-
-{
-  layer->numprocessing++;
-  if( layer->numprocessing == 1 )
-    layer->processing = (char **) msSmallMalloc(2*sizeof(char *));
-  else
-    layer->processing = (char **) msSmallRealloc(layer->processing, sizeof(char*) * (layer->numprocessing+1) );
-  layer->processing[layer->numprocessing-1] = msStrdup(directive);
-  layer->processing[layer->numprocessing] = NULL;
-}
-
-const char *msLayerGetProcessing( const layerObj *layer, int proc_index)
-{
-  if (proc_index < 0 || proc_index >= layer->numprocessing) {
-    msSetError(MS_CHILDERR, "Invalid processing index.", "msLayerGetProcessing()");
-    return NULL;
-  } else {
-    return layer->processing[proc_index];
-  }
-}
-
-const char *msLayerGetProcessingKey( const layerObj *layer, const char *key )
-{
-  int i, len = strlen(key);
-
-  for( i = 0; i < layer->numprocessing; i++ ) {
-    if( strncasecmp(layer->processing[i],key,len) == 0
-        && layer->processing[i][len] == '=' )
-      return layer->processing[i] + len + 1;
-  }
-
-  return NULL;
-}
-
-
-/************************************************************************/
-/*                       msLayerGetMaxFeaturesToDraw                    */
-/*                                                                      */
-/*      Check to see if maxfeaturestodraw is set as a metadata or an    */
-/*      output format option. Used for vector layers to limit the       */
-/*      number of fatures rendered.                                     */
-/************************************************************************/
-int msLayerGetMaxFeaturesToDraw(layerObj *layer, outputFormatObj *format)
-{
-  int nMaxFeatures = -1;
-  const char *pszTmp = NULL;
-  if (layer) {
-    nMaxFeatures = layer->maxfeatures;
-    pszTmp = msLookupHashTable(&layer->metadata, "maxfeaturestodraw");
-    if (pszTmp)
-      nMaxFeatures = atoi(pszTmp);
-    else {
-      pszTmp = msLookupHashTable(&layer->map->web.metadata, "maxfeaturestodraw");
-      if (pszTmp)
-        nMaxFeatures = atoi(pszTmp);
-    }
-  }
-  if(format) {
-    if (nMaxFeatures < 0)
-      nMaxFeatures = atoi(msGetOutputFormatOption( format, "maxfeaturestodraw", "-1"));
-  }
-
-  return nMaxFeatures;
-
-}
-int msLayerClearProcessing( layerObj *layer )
-{
-  if (layer->numprocessing > 0) {
-    msFreeCharArray( layer->processing, layer->numprocessing );
-    layer->processing = NULL;
-    layer->numprocessing = 0;
-  }
-  return layer->numprocessing;
-}
-
-
-int
-makeTimeFilter(layerObj *lp,
-               const char *timestring,
-               const char *timefield,
-               const int addtimebacktics)
-{
-
-  char **atimes, **tokens = NULL;
-  int numtimes,i, ntmp = 0;
-  char *pszBuffer = NULL;
-  int bOnlyExistingFilter = 0;
-
-  if (!lp || !timestring || !timefield)
-    return MS_FALSE;
-
-  /* parse the time string. We support dicrete times (eg 2004-09-21),  */
-  /* multiple times (2004-09-21, 2004-09-22, ...) */
-  /* and range(s) (2004-09-21/2004-09-25, 2004-09-27/2004-09-29) */
-
-  if (strstr(timestring, ",") == NULL &&
-      strstr(timestring, "/") == NULL) { /* discrete time */
-    /*
-    if(lp->filteritem) free(lp->filteritem);
-    lp->filteritem = msStrdup(timefield);
-    if (&lp->filter)
-      msFreeExpression(&lp->filter);
-    */
-
-    /* if the filter is set and it's a sting type, concatenate it with
-       the time. If not just free it */
-    if (lp->filter.string && lp->filter.type == MS_STRING) {
-     pszBuffer = msStringConcatenate(pszBuffer, "((");
-     pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
-     pszBuffer = msStringConcatenate(pszBuffer, ") and ");
-    } else if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
-     char* pszExpressionString = msGetExpressionString(&(lp->filter));
-     pszBuffer = msStringConcatenate(pszBuffer, "(");
-     pszBuffer = msStringConcatenate(pszBuffer, pszExpressionString);
-     pszBuffer = msStringConcatenate(pszBuffer, " and ");
-     msFree(pszExpressionString);
-    } else {
-     msFreeExpression(&lp->filter);
-    }
-
-    pszBuffer = msStringConcatenate(pszBuffer, "(");
-    if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
-
-    if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer, "[");
-    pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
-    if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer, "]");
-    if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
-
-
-    pszBuffer = msStringConcatenate(pszBuffer, " = ");
-    if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
-    else
-      pszBuffer = msStringConcatenate(pszBuffer,  "'");
-
-    pszBuffer = msStringConcatenate(pszBuffer, (char *)timestring);
-    if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
-    else
-      pszBuffer = msStringConcatenate(pszBuffer,  "'");
-
-    pszBuffer = msStringConcatenate(pszBuffer, ")");
-
-    /* if there was a filter, It was concatenate with an And ans should be closed*/
-    if (lp->filter.string &&
-       (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION))
-      pszBuffer = msStringConcatenate(pszBuffer, ")");
-
-
-    msLoadExpressionString(&lp->filter, pszBuffer);
-
-    if (pszBuffer)
-      msFree(pszBuffer);
-    return MS_TRUE;
-  }
-
-  atimes = msStringSplit(timestring, ',', &numtimes);
-  if (atimes == NULL || numtimes < 1) {
-    msFreeCharArray(atimes,numtimes);
-    return MS_FALSE;
-  }
-
-  if (lp->filter.string && lp->filter.type == MS_STRING) {
-    pszBuffer = msStringConcatenate(pszBuffer, "((");
-    pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
-    pszBuffer = msStringConcatenate(pszBuffer, ") and ");
-    /*this flag is used to indicate that the buffer contains only the
-      existing filter. It is set to 0 when time filter parts are
-      added to the buffer */
-    bOnlyExistingFilter = 1;
-  } else if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
-    char* pszExpressionString = msGetExpressionString(&(lp->filter));
-    pszBuffer = msStringConcatenate(pszBuffer, "(");
-    pszBuffer = msStringConcatenate(pszBuffer, pszExpressionString);
-    pszBuffer = msStringConcatenate(pszBuffer, " and ");
-    msFree(pszExpressionString);
-    bOnlyExistingFilter = 1;
-  } else
-    msFreeExpression(&lp->filter);
-
-  /* check to see if we have ranges by parsing the first entry */
-  tokens = msStringSplit(atimes[0],  '/', &ntmp);
-  if (ntmp == 2) { /* ranges */
-    msFreeCharArray(tokens, ntmp);
-    for (i=0; i<numtimes; i++) {
-      tokens = msStringSplit(atimes[i],  '/', &ntmp);
-      if (ntmp == 2) {
-        if (pszBuffer && strlen(pszBuffer) > 0 && bOnlyExistingFilter == 0)
-          pszBuffer = msStringConcatenate(pszBuffer, " OR ");
-        else
-          pszBuffer = msStringConcatenate(pszBuffer, "(");
-
-        bOnlyExistingFilter = 0;
-
-        pszBuffer = msStringConcatenate(pszBuffer, "(");
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer, "[");
-        pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer, "]");
-
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-
-        pszBuffer = msStringConcatenate(pszBuffer, " >= ");
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-        else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
-
-        pszBuffer = msStringConcatenate(pszBuffer, tokens[0]);
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-        else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
-        pszBuffer = msStringConcatenate(pszBuffer, " AND ");
-
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer, "[");
-        pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer, "]");
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-
-        pszBuffer = msStringConcatenate(pszBuffer, " <= ");
-
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-        else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
-        pszBuffer = msStringConcatenate(pszBuffer, tokens[1]);
-        if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
-        else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
-        pszBuffer = msStringConcatenate(pszBuffer, ")");
-      }
-
-      msFreeCharArray(tokens, ntmp);
-    }
-    if (pszBuffer && strlen(pszBuffer) > 0 && bOnlyExistingFilter == 0)
-      pszBuffer = msStringConcatenate(pszBuffer, ")");
-  } else if (ntmp == 1) { /* multiple times */
-    msFreeCharArray(tokens, ntmp);
-    pszBuffer = msStringConcatenate(pszBuffer, "(");
-    for (i=0; i<numtimes; i++) {
-      if (i > 0)
-        pszBuffer = msStringConcatenate(pszBuffer, " OR ");
-
-      pszBuffer = msStringConcatenate(pszBuffer, "(");
-      if (addtimebacktics)
-        pszBuffer = msStringConcatenate(pszBuffer, "`");
-
-      if (addtimebacktics)
-        pszBuffer = msStringConcatenate(pszBuffer, "[");
-      pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
-      if (addtimebacktics)
-        pszBuffer = msStringConcatenate(pszBuffer, "]");
-
-      if (addtimebacktics)
-        pszBuffer = msStringConcatenate(pszBuffer, "`");
-
-      pszBuffer = msStringConcatenate(pszBuffer, " = ");
-
-      if (addtimebacktics)
-        pszBuffer = msStringConcatenate(pszBuffer, "`");
-      else
-        pszBuffer = msStringConcatenate(pszBuffer,  "'");
-      pszBuffer = msStringConcatenate(pszBuffer, atimes[i]);
-      if (addtimebacktics)
-        pszBuffer = msStringConcatenate(pszBuffer,  "`");
-      else
-        pszBuffer = msStringConcatenate(pszBuffer,  "'");
-      pszBuffer = msStringConcatenate(pszBuffer, ")");
-    }
-    pszBuffer = msStringConcatenate(pszBuffer, ")");
-  } else {
-    msFreeCharArray(tokens, ntmp);
-    msFreeCharArray(atimes, numtimes);
-    msFree(pszBuffer);
-    return MS_FALSE;
-  }
-
-  msFreeCharArray(atimes, numtimes);
-
-  /* load the string to the filter */
-  if (pszBuffer && strlen(pszBuffer) > 0) {
-    if(lp->filter.string && (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION ))
-      pszBuffer = msStringConcatenate(pszBuffer, ")");
-    /*
-    if(lp->filteritem)
-      free(lp->filteritem);
-    lp->filteritem = msStrdup(timefield);
-    */
-
-    msLoadExpressionString(&lp->filter, pszBuffer);
-
-  }
-  msFree(pszBuffer);
-  return MS_TRUE;
-}
-
-/**
-  set the filter parameter for a time filter
-**/
-
-int msLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                         const char *timefield)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerSetTimeFilter(layer, timestring, timefield);
-}
-
-int
-msLayerMakeBackticsTimeFilter(layerObj *lp, const char *timestring,
-                              const char *timefield)
-{
-  return makeTimeFilter(lp, timestring, timefield, MS_TRUE);
-}
-
-int
-msLayerMakePlainTimeFilter(layerObj *lp, const char *timestring,
-                           const char *timefield)
-{
-  return makeTimeFilter(lp, timestring, timefield, MS_FALSE);
-}
-
-
-/*
- * Dummies / default actions for layers
- */
-int LayerDefaultInitItemInfo(layerObj *layer)
-{
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-void LayerDefaultFreeItemInfo(layerObj *layer)
-{
-  (void)layer;
-}
-
-int LayerDefaultOpen(layerObj *layer)
-{
-  (void)layer;
-  return MS_FAILURE;
-}
-
-int LayerDefaultIsOpen(layerObj *layer)
-{
-  (void)layer;
-  return MS_FALSE;
-}
-
-int LayerDefaultWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)layer;
-  (void)rect;
-  (void)isQuery;
-  return MS_SUCCESS;
-}
-
-int LayerDefaultNextShape(layerObj *layer, shapeObj *shape)
-{
-  (void)layer;
-  (void)shape;
-  return MS_FAILURE;
-}
-
-int LayerDefaultGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  (void)layer;
-  (void)shape;
-  (void)record;
-  return MS_FAILURE;
-}
-
-int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
-  int status;
-  shapeObj shape, searchshape;
-  int nShapeCount = 0;
-  rectObj searchrect = rect;
-  reprojectionObj* reprojector = NULL;
-
-  msInitShape(&searchshape);
-  msRectToPolygon(searchrect, &searchshape);
-
-  if( rectProjection != NULL ) 
-  {
-    if(layer->project && msProjectionsDiffer(&(layer->projection), rectProjection))
-      msProjectRect(rectProjection, &(layer->projection), &searchrect); /* project the searchrect to source coords */
-    else
-      layer->project = MS_FALSE;
-  }
-
-  status = msLayerWhichShapes(layer, searchrect, MS_TRUE) ;
-  if( status == MS_FAILURE )
-  {
-    msFreeShape(&searchshape);
-    return -1;
-  }
-  else if( status == MS_DONE )
-  {
-    msFreeShape(&searchshape);
-    return 0;
-  }
-
-  msInitShape(&shape);
-  while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS)
-  {
-    if( rectProjection != NULL ) 
-    {
-      if(layer->project && msProjectionsDiffer(&(layer->projection), rectProjection))
-      {
-        if( reprojector == NULL )
-            reprojector = msProjectCreateReprojector(&(layer->projection), rectProjection);
-        if( reprojector )
-            msProjectShapeEx(reprojector, &shape);
-      }
-      else
-        layer->project = MS_FALSE;
-
-      if(msRectContained(&shape.bounds, &rect) == MS_TRUE) { /* if the whole shape is in, don't intersect */
-        status = MS_TRUE;
-      } else {
-        switch(shape.type) { /* make sure shape actually intersects the qrect (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
-          case MS_SHAPE_POINT:
-            status = msIntersectMultipointPolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_LINE:
-            status = msIntersectPolylinePolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_POLYGON:
-            status = msIntersectPolygons(&shape, &searchshape);
-            break;
-          default:
-            break;
-        }
-      }
-    }
-    else
-      status = MS_TRUE;
-
-    if( status == MS_TRUE )
-      nShapeCount++ ;
-    msFreeShape(&shape);
-    if(layer->maxfeatures > 0 && layer->maxfeatures == nShapeCount)
-      break;
-  }
-
-  msFreeShape(&searchshape);
-  msProjectDestroyReprojector(reprojector);
-
-  return nShapeCount;
-}
-
-int LayerDefaultClose(layerObj *layer)
-{
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-int LayerDefaultGetItems(layerObj *layer)
-{
-  (void)layer;
-  return MS_SUCCESS; /* returning no items is legit */
-}
-
-int
-msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-                                 int iLayerIndex)
-{
-  return FLTLayerApplyCondSQLFilterToLayer(psNode, map, iLayerIndex);
-}
-
-int msLayerSupportsPaging(layerObj *layer)
-{
-  if (layer &&
-      ((layer->connectiontype == MS_ORACLESPATIAL) ||
-       (layer->connectiontype == MS_POSTGIS)) )
-    return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
-
-/*
- * msLayerSupportsSorting()
- *
- * Returns MS_TRUE if the layer supports sorting/ordering.
- */
-int msLayerSupportsSorting(layerObj *layer)
-{
-  if (layer && (
-    (layer->connectiontype == MS_OGR) || (layer->connectiontype == MS_POSTGIS) || (layer->connectiontype == MS_ORACLESPATIAL) || ((layer->connectiontype == MS_PLUGIN) && (strstr(layer->plugin_library,"msplugin_oracle") != NULL)) || ((layer->connectiontype == MS_PLUGIN) && (strstr(layer->plugin_library,"msplugin_mssql2008") != NULL))
-               )
-     )
-    return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-/*
- * msLayerSetSort()
- *
- * Copy the sortBy clause passed as an argument into the layer sortBy member.
- */
-void msLayerSetSort(layerObj *layer, const sortByClause* sortBy)
-{
-  int i;
-  for(i=0;i<layer->sortBy.nProperties;i++)
-    msFree(layer->sortBy.properties[i].item);
-  msFree(layer->sortBy.properties);
-
-  layer->sortBy.nProperties = sortBy->nProperties;
-  layer->sortBy.properties = (sortByProperties*) msSmallMalloc(sortBy->nProperties * sizeof(sortByProperties));
-  for(i=0;i<layer->sortBy.nProperties;i++) {
-    layer->sortBy.properties[i].item = msStrdup(sortBy->properties[i].item);
-    layer->sortBy.properties[i].sortOrder = sortBy->properties[i].sortOrder;
-  }
- }
-
-/*
- * msLayerBuildSQLOrderBy()
- *
- * Returns the content of a SQL ORDER BY clause from the sortBy member of
- * the layer. The string does not contain the "ORDER BY" keywords itself.
- */
-char* msLayerBuildSQLOrderBy(layerObj *layer)
-{
-  char* strOrderBy = NULL;
-  if( layer->sortBy.nProperties > 0 ) {
-    int i;
-    for(i=0;i<layer->sortBy.nProperties;i++) {
-      char* escaped = msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
-      if( i > 0 )
-        strOrderBy = msStringConcatenate(strOrderBy, ", ");
-      strOrderBy = msStringConcatenate(strOrderBy, escaped);
-      if( layer->sortBy.properties[i].sortOrder == SORT_DESC )
-        strOrderBy = msStringConcatenate(strOrderBy, " DESC");
-      msFree(escaped);
-    }
-  }
-  return strOrderBy;
-}
-
-int
-msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
-  return FLTLayerApplyPlainFilterToLayer(psNode, map, iLayerIndex);
-}
-
-int msLayerGetPaging(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS) {
-      msSetError(MS_MISCERR, "Unable to initialize virtual table", "msLayerGetPaging()");
-      return MS_FAILURE;
-    }
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerGetPaging(layer);
-}
-
-void msLayerEnablePaging(layerObj *layer, int value)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS) {
-      msSetError(MS_MISCERR, "Unable to initialize virtual table", "msLayerEnablePaging()");
-      return;
-    }
-  }
-  cppcheck_assert(layer->vtable);
-  layer->vtable->LayerEnablePaging(layer, value);
-}
-
-int LayerDefaultGetExtent(layerObj *layer, rectObj *extent)
-{
-  (void)layer;
-  (void)extent;
-  return MS_FAILURE;
-}
-
-int LayerDefaultGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj *shape)
-{
-  (void)map;
-  (void)layer;
-  (void)c;
-  (void)shape;
-  msSetError(MS_MISCERR, "'STYLEITEM AUTO' not supported for this data source.", "msLayerGetAutoStyle()");
-  return MS_FAILURE;
-}
-
-int LayerDefaultCloseConnection(layerObj *layer)
-{
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-int LayerDefaultCreateItems(layerObj *layer, const int nt)
-{
-  if (nt > 0) {
-    layer->items = (char **)calloc(nt, sizeof(char *)); /* should be more than enough space */
-    MS_CHECK_ALLOC(layer->items, sizeof(char *), MS_FAILURE);
-
-    layer->numitems = 0;
-  }
-  return MS_SUCCESS;
-}
-
-int LayerDefaultGetNumFeatures(layerObj *layer)
-{
-    rectObj extent;
-    int status;
-    int result;
-    shapeObj shape;
-
-    /* calculate layer extent */
-    if (!MS_VALID_EXTENT(layer->extent)) {
-        if (msLayerGetExtent(layer, &extent) != MS_SUCCESS) {
-            msSetError(MS_MISCERR, "Unable to get layer extent", "LayerDefaultGetNumFeatures()");
-            return -1;
-        }
-    }
-    else
-        extent = layer->extent;
-
-    /* Cleanup any previous item selection */
-    msLayerFreeItemInfo(layer);
-    if (layer->items) {
-        msFreeCharArray(layer->items, layer->numitems);
-        layer->items = NULL;
-        layer->numitems = 0;
-    }
-
-    status = msLayerWhichShapes(layer, extent, MS_FALSE);
-    if (status == MS_DONE) { /* no overlap */
-        return 0;
-    }
-    else if (status != MS_SUCCESS) {
-        return -1;
-    }
-
-    result = 0;
-    while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
-        ++result;
-    }
-
-    return result;
-}
-
-int LayerDefaultAutoProjection(layerObj *layer, projectionObj* projection)
-{
-  (void)layer;
-  (void)projection;
-  msSetError(MS_MISCERR, "This data driver does not implement AUTO projection support", "LayerDefaultAutoProjection()");
-  return MS_FAILURE;
-}
-
-int LayerDefaultSupportsCommonFilters(layerObj *layer)
-{
-  (void)layer;
-  return MS_FALSE;
-}
-
-int LayerDefaultTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem) 
-{
-  (void)layer;
-  (void)filteritem;
-  if(!filter->string) return MS_SUCCESS; /* nothing to do, not an error */
-
-  msSetError(MS_MISCERR, "This data driver does not implement filter translation support", "LayerDefaultTranslateFilter()");
-  return MS_FAILURE;
-}
-
-int msLayerDefaultGetPaging(layerObj *layer)
-{
-  (void)layer;
-  return MS_FALSE;
-}
-
-void msLayerDefaultEnablePaging(layerObj *layer, int value)
-{
-  (void)layer;
-  (void)value;
-}
-
-/************************************************************************/
-/*                          LayerDefaultEscapeSQLParam                  */
-/*                                                                      */
-/*      Default function used to escape strings and avoid sql           */
-/*      injection. Specific drivers should redefine if an escaping      */
-/*      function is available in the driver.                            */
-/************************************************************************/
-char *LayerDefaultEscapeSQLParam(layerObj *layer, const char* pszString)
-{
-  (void)layer;
-  char *pszEscapedStr=NULL;
-  if (pszString) {
-    int nSrcLen;
-    char c;
-    int i=0, j=0;
-    nSrcLen = (int)strlen(pszString);
-    pszEscapedStr = (char*) msSmallMalloc( 2 * nSrcLen + 1);
-    for(i = 0, j = 0; i < nSrcLen; i++) {
-      c = pszString[i];
-      if (c == '\'') {
-        pszEscapedStr[j++] = '\'';
-        pszEscapedStr[j++] = '\'';
-      } else if (c == '\\') {
-        pszEscapedStr[j++] = '\\';
-        pszEscapedStr[j++] = '\\';
-      } else
-        pszEscapedStr[j++] = c;
-    }
-    pszEscapedStr[j] = 0;
-  }
-  return pszEscapedStr;
-}
-
-/************************************************************************/
-/*                          LayerDefaultEscapePropertyName              */
-/*                                                                      */
-/*      Return the property name in a properly escaped and quoted form. */
-/************************************************************************/
-char *LayerDefaultEscapePropertyName(layerObj *layer, const char* pszString)
-{
-  char* pszEscapedStr=NULL;
-  int i, j = 0;
-
-  if (layer && pszString && strlen(pszString) > 0) {
-    int nLength = strlen(pszString);
-
-    pszEscapedStr = (char*) msSmallMalloc( 1 + 2 * nLength + 1 + 1);
-    pszEscapedStr[j++] = '"';
-
-    for (i=0; i<nLength; i++) {
-      char c = pszString[i];
-      if (c == '"') {
-        pszEscapedStr[j++] = '"';
-        pszEscapedStr[j++] ='"';
-      } else if (c == '\\') {
-        pszEscapedStr[j++] = '\\';
-        pszEscapedStr[j++] = '\\';
-      } else
-        pszEscapedStr[j++] = c;
-    }
-    pszEscapedStr[j++] = '"';
-    pszEscapedStr[j++] = 0;
-
-  }
-  return pszEscapedStr;
-}
-
-
-/*
- * msConnectLayer
- *
- * This will connect layer object to the new layer type.
- * Caller is responsible to close previous layer correctly.
- * For Internal types the library_str is ignored, for PLUGIN it's
- * define what plugin to use. Returns MS_FAILURE or MS_SUCCESS.
- */
-int msConnectLayer(layerObj *layer,
-                   const int connectiontype,
-                   const char *library_str)
-{
-  layer->connectiontype = connectiontype;
-  /* For internal types, library_str is ignored */
-  if (connectiontype == MS_PLUGIN) {
-    int rv;
-
-    msFree(layer->plugin_library_original);
-    layer->plugin_library_original = msStrdup(library_str);
-
-    rv = msBuildPluginLibraryPath(&layer->plugin_library,
-                                  layer->plugin_library_original,
-                                  layer->map);
-    if (rv != MS_SUCCESS) {
-      return rv;
-    }
-  }
-  return msInitializeVirtualTable(layer) ;
-}
-
-static int populateVirtualTable(layerVTableObj *vtable)
-{
-  assert(vtable != NULL);
-
-  vtable->LayerSupportsCommonFilters = LayerDefaultSupportsCommonFilters;
-  vtable->LayerTranslateFilter = LayerDefaultTranslateFilter;
-
-  vtable->LayerInitItemInfo = LayerDefaultInitItemInfo;
-  vtable->LayerFreeItemInfo = LayerDefaultFreeItemInfo;
-  vtable->LayerOpen = LayerDefaultOpen;
-  vtable->LayerIsOpen = LayerDefaultIsOpen;
-  vtable->LayerWhichShapes = LayerDefaultWhichShapes;
-
-  vtable->LayerNextShape = LayerDefaultNextShape;
-  /* vtable->LayerResultsGetShape = LayerDefaultResultsGetShape; */
-  vtable->LayerGetShape = LayerDefaultGetShape;
-  vtable->LayerGetShapeCount = LayerDefaultGetShapeCount;
-  vtable->LayerClose = LayerDefaultClose;
-  vtable->LayerGetItems = LayerDefaultGetItems;
-  vtable->LayerGetExtent = LayerDefaultGetExtent;
-
-  vtable->LayerGetAutoStyle = LayerDefaultGetAutoStyle;
-  vtable->LayerCloseConnection = LayerDefaultCloseConnection;
-  vtable->LayerSetTimeFilter = msLayerMakePlainTimeFilter;
-
-  vtable->LayerApplyFilterToLayer = msLayerApplyPlainFilterToLayer;
-
-  vtable->LayerCreateItems = LayerDefaultCreateItems;
-
-  vtable->LayerGetNumFeatures = LayerDefaultGetNumFeatures;
-
-  vtable->LayerGetAutoProjection = LayerDefaultAutoProjection;
-
-  vtable->LayerEscapeSQLParam = LayerDefaultEscapeSQLParam;
-
-  vtable->LayerEscapePropertyName = LayerDefaultEscapePropertyName;
-
-  vtable->LayerEnablePaging = msLayerDefaultEnablePaging;
-  vtable->LayerGetPaging = msLayerDefaultGetPaging;
-
-  return MS_SUCCESS;
-}
-
-static int createVirtualTable(layerVTableObj **vtable)
-{
-  *vtable = malloc(sizeof(**vtable));
-  MS_CHECK_ALLOC(*vtable, sizeof(**vtable), MS_FAILURE);
-
-  return populateVirtualTable(*vtable);
-}
-
-static int destroyVirtualTable(layerVTableObj **vtable)
-{
-  memset(*vtable, 0, sizeof(**vtable));
-  msFree(*vtable);
-  *vtable = NULL;
-  return MS_SUCCESS;
-}
-
-int msInitializeVirtualTable(layerObj *layer)
-{
-  if (layer->vtable) {
-    destroyVirtualTable(&layer->vtable);
-  }
-  createVirtualTable(&layer->vtable);
-
-  if(layer->features && layer->connectiontype != MS_GRATICULE )
-    layer->connectiontype = MS_INLINE;
-
-  if(layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
-    layer->connectiontype = MS_TILED_SHAPEFILE;
-
-  if(layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS
-      && layer->connectiontype != MS_KERNELDENSITY)
-    layer->connectiontype = MS_RASTER;
-
-  switch(layer->connectiontype) {
-    case(MS_INLINE):
-      return(msINLINELayerInitializeVirtualTable(layer));
-      break;
-    case(MS_SHAPEFILE):
-      return(msSHPLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_TILED_SHAPEFILE):
-      return(msTiledSHPLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_OGR):
-      return(msOGRLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_FLATGEOBUF):
-      return(msFlatGeobufLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_POSTGIS):
-      return(msPostGISLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_WMS):
-      /* WMS should be treated as a raster layer */
-      return(msRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_KERNELDENSITY):
-      /* KERNELDENSITY should be treated as a raster layer */
-      return(msRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_ORACLESPATIAL):
-      return(msOracleSpatialLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_WFS):
-      return(msWFSLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_GRATICULE):
-      return(msGraticuleLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_RASTER):
-      return(msRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_PLUGIN):
-      return(msPluginLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_UNION):
-      return(msUnionLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_UVRASTER):
-      return(msUVRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_CONTOUR):
-      return(msContourLayerInitializeVirtualTable(layer));
-      break;      
-    default:
-      msSetError(MS_MISCERR, "Unknown connectiontype, it was %d", "msInitializeVirtualTable()", layer->connectiontype);
-      return MS_FAILURE;
-      break;
-  }
-
-  /* not reached */
-  return MS_FAILURE;
-}
-
-/*
- * INLINE: Virtual table functions
- */
-
-typedef struct {
-  rectObj searchrect;
-  int is_relative; /* relative coordinates? */
-}
-msINLINELayerInfo;
-
-int msINLINELayerIsOpen(layerObj *layer)
-{
-  if (layer->layerinfo)
-    return(MS_TRUE);
-  else
-    return(MS_FALSE);
-}
-
-msINLINELayerInfo *msINLINECreateLayerInfo(void)
-{
-  msINLINELayerInfo *layerinfo = msSmallMalloc(sizeof(msINLINELayerInfo));
-  layerinfo->searchrect.minx = -1.0;
-  layerinfo->searchrect.miny = -1.0;
-  layerinfo->searchrect.maxx = -1.0;
-  layerinfo->searchrect.maxy = -1.0;
-  layerinfo->is_relative = MS_FALSE;
-  return layerinfo;  
-}
-
-int msINLINELayerOpen(layerObj *layer)
-{
-  msINLINELayerInfo  *layerinfo;
-
-  if (layer->layerinfo) {
-    if (layer->debug) {
-      msDebug("msINLINELayerOpen: Layer is already open!\n");
-    }
-    return MS_SUCCESS;  /* already open */
-  }
-  
-  /*
-  ** Initialize the layerinfo
-  **/
-  layerinfo = msINLINECreateLayerInfo();
-  
-  layer->currentfeature = layer->features; /* point to the begining of the feature list */
-
-  layer->layerinfo = (void*)layerinfo;
-  
-  return(MS_SUCCESS);
-}
-
-int msINLINELayerClose(layerObj *layer)
-{
-  if (layer->layerinfo) {
-    free(layer->layerinfo);
-    layer->layerinfo = NULL;
-  }
-
-  return MS_SUCCESS;
-}
-
-int msINLINELayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)isQuery;
-  msINLINELayerInfo *layerinfo = NULL;  
-  layerinfo = (msINLINELayerInfo*) layer->layerinfo;
-
-  layerinfo->searchrect = rect;
-  layerinfo->is_relative = (layer->transform != MS_FALSE && layer->transform != MS_TRUE);
-  
-  return MS_SUCCESS;
-}
-
-/* Author: Cristoph Spoerri and Sean Gillies */
-int msINLINELayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  int i=0;
-  featureListNodeObjPtr current;
-
-  int shapeindex = record->shapeindex; /* only index necessary */
-
-  current = layer->features;
-  while (current!=NULL && i!=shapeindex) {
-    i++;
-    current = current->next;
-  }
-  if (current == NULL) {
-    msSetError(MS_SHPERR, "No inline feature with this index.", "msINLINELayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  if (msCopyShape(&(current->shape), shape) != MS_SUCCESS) {
-    msSetError(MS_SHPERR, "Cannot retrieve inline shape. There some problem with the shape", "msINLINELayerGetShape()");
-    return MS_FAILURE;
-  }
-  /* check for the expected size of the values array */
-  if (layer->numitems > shape->numvalues) {
-    shape->values = (char **)msSmallRealloc(shape->values, sizeof(char *)*(layer->numitems));
-    for (i = shape->numvalues; i < layer->numitems; i++)
-      shape->values[i] = msStrdup("");
-  }
-  msComputeBounds(shape);
-  return MS_SUCCESS;
-}
-
-int msINLINELayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  msINLINELayerInfo *layerinfo = NULL;  
-  shapeObj * s;
-  
-  layerinfo = (msINLINELayerInfo*) layer->layerinfo;
-  
-  while (1) {
-
-    if( ! (layer->currentfeature)) {
-      /* out of features */
-      return(MS_DONE);
-    }
-
-    s = &(layer->currentfeature->shape);
-    layer->currentfeature = layer->currentfeature->next;
-    msComputeBounds(s);
-
-    if (layerinfo->is_relative || msRectOverlap(&s->bounds, &layerinfo->searchrect)) {
-   
-      msCopyShape(s, shape);
-
-      /* check for the expected size of the values array */
-      if (layer->numitems > shape->numvalues) {
-        int i;
-        shape->values = (char **)msSmallRealloc(shape->values, sizeof(char *)*(layer->numitems));
-        for (i = shape->numvalues; i < layer->numitems; i++)
-          shape->values[i] = msStrdup("");
-        shape->numvalues = layer->numitems;
-      }
-
-      break;
-    }
-    
-  }
-
-  return(MS_SUCCESS);
-}
-
-int msINLINELayerGetNumFeatures(layerObj *layer)
-{
-  int i = 0;
-  featureListNodeObjPtr current;
-
-  current = layer->features;
-  while (current != NULL) {
-    i++;
-    current = current->next;
-  }
-  return i;
-}
-
-
-
-/*
-Returns an escaped string
-*/
-char  *msLayerEscapeSQLParam(layerObj *layer, const char*pszString)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return "";
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerEscapeSQLParam(layer, pszString);
-}
-
-char  *msLayerEscapePropertyName(layerObj *layer, const char*pszString)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return "";
-  }
-  cppcheck_assert(layer->vtable);
-  return layer->vtable->LayerEscapePropertyName(layer, pszString);
-}
-
-
-int
-msINLINELayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  /* layer->vtable->LayerInitItemInfo, use default */
-  /* layer->vtable->LayerFreeItemInfo, use default */
-  layer->vtable->LayerOpen = msINLINELayerOpen;
-  layer->vtable->LayerIsOpen = msINLINELayerIsOpen;
-  layer->vtable->LayerWhichShapes = msINLINELayerWhichShapes;
-  layer->vtable->LayerNextShape = msINLINELayerNextShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerGetShape = msINLINELayerGetShape;
-  layer->vtable->LayerClose = msINLINELayerClose;
-  /* layer->vtable->LayerGetItems, use default */
-
-  /*
-   * Original code contained following
-   * TODO: need to compute extents
-   */
-  /* layer->vtable->LayerGetExtent, use default */
-
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerCloseConnection, use default */
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-
-  /* layer->vtable->LayerCreateItems, use default */
-  layer->vtable->LayerGetNumFeatures = msINLINELayerGetNumFeatures;
-
-  /*layer->vtable->LayerEscapeSQLParam, use default*/
-  /*layer->vtable->LayerEscapePropertyName, use default*/
-
-  /* layer->vtable->LayerEnablePaging, use default */
-  /* layer->vtable->LayerGetPaging, use default */
-
-  return MS_SUCCESS;
-}
-
-
diff -pruN 8.0.1-5/maplegend.c 8.2.0~beta1-1~exp1/maplegend.c
--- 8.0.1-5/maplegend.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maplegend.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,948 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Legend generation.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-#define PSF .8
-#define VMARGIN 5 /* margin at top and bottom of legend graphic */
-#define HMARGIN 5 /* margin at left and right of legend graphic */
-
-
-static int msDrawGradientSymbol(rendererVTableObj* renderer,
-                                imageObj* image_draw,
-                                double x_center,
-                                double y_center,
-                                int width,
-                                int height,
-                                styleObj* style)
-{
-    unsigned char *r,*g,*b,*a;
-    symbolObj symbol;
-    rasterBufferObj* rb;
-    symbolStyleObj symbolStyle;
-    int ret;
-
-    initSymbol(&symbol);
-    rb = (rasterBufferObj*)calloc(1,sizeof(rasterBufferObj));
-    symbol.pixmap_buffer = rb;
-    rb->type = MS_BUFFER_BYTE_RGBA;
-    rb->width = width;
-    rb->height = height;
-    rb->data.rgba.row_step = rb->width * 4;
-    rb->data.rgba.pixel_step = 4;
-    rb->data.rgba.pixels = (unsigned char*)malloc(
-                                rb->width*rb->height*4*sizeof(unsigned char));
-    b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
-    g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
-    r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
-    a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
-    for( unsigned j = 0; j < rb->height; j++ )
-    {
-        for( unsigned i = 0; i < rb->width; i++ )
-        {
-            msValueToRange(style, style->minvalue +
-                (double)i / rb->width * (style->maxvalue - style->minvalue), MS_COLORSPACE_RGB);
-            b[4*(j * rb->width + i)] = style->color.blue;
-            g[4*(j * rb->width + i)] = style->color.green;
-            r[4*(j * rb->width + i)] = style->color.red;
-            a[4*(j * rb->width + i)] = style->color.alpha;
-        }
-    }
-    INIT_SYMBOL_STYLE(symbolStyle);
-    ret = renderer->renderPixmapSymbol(image_draw, x_center, y_center, &symbol, &symbolStyle);
-    msFreeSymbol(&symbol);
-    return ret;
-}
-
-/*
- * generic function for drawing a legend icon. (added for bug #2348)
- * renderer specific drawing functions shouldn't be called directly, but through
- * this function
- */
-int msDrawLegendIcon(mapObj *map, layerObj *lp, classObj *theclass,
-                     int width, int height, imageObj *image, int dstX, int dstY,
-                     int scale_independant, class_hittest *hittest)
-{
-  int i, type, hasmarkersymbol, ret=MS_SUCCESS;
-  double offset;
-  double polygon_contraction = 0.5; /* used to account for the width of a polygon's outline */
-  shapeObj box, zigzag;
-  lineObj box_line,zigzag_line;
-  pointObj box_point[5], zigzag_point[4];
-  pointObj marker;
-  char szPath[MS_MAXPATHLEN];
-  styleObj outline_style;
-  imageObj *image_draw = image;
-  rendererVTableObj *renderer;
-  outputFormatObj *transFormat = NULL, *altFormat=NULL;
-  const char *alternativeFormatString = NULL;
-
-  if(!MS_RENDERER_PLUGIN(image->format)) {
-    msSetError(MS_MISCERR,"unsupported image format","msDrawLegendIcon()");
-    return MS_FAILURE;
-  }
-
-  alternativeFormatString = msLayerGetProcessingKey(lp, "RENDERER");
-  if (MS_RENDERER_PLUGIN(image_draw->format) && alternativeFormatString!=NULL &&
-      (altFormat=  msSelectOutputFormat(map, alternativeFormatString))) {
-    msInitializeRendererVTable(altFormat);
-
-    image_draw = msImageCreate(image->width, image->height,
-                               altFormat, image->imagepath, image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
-    image_draw->map = map;
-    renderer = MS_IMAGE_RENDERER(image_draw);
-  } else {
-    renderer = MS_IMAGE_RENDERER(image_draw);
-    if (lp->compositer && renderer->compositeRasterBuffer) {
-      image_draw = msImageCreate(image->width, image->height,
-              image->format, image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
-      if (!image_draw) {
-        msSetError(MS_MISCERR, "Unable to initialize temporary transparent image.",
-                "msDrawLegendIcon()");
-        return (MS_FAILURE);
-      }
-      image_draw->map = map;
-    }
-  }
-
-
-  if(renderer->supports_clipping && MS_VALID_COLOR(map->legend.outlinecolor)) {
-    /* keep GD specific code here for now as it supports clipping */
-    rectObj clip;
-    clip.maxx = dstX + width - 1;
-    clip.maxy = dstY + height -1;
-    clip.minx = dstX;
-    clip.miny = dstY;
-    renderer->setClip(image_draw,clip);
-  }
-  
-  /* if the class has a keyimage, treat it as a point layer
-   * (the keyimage will be treated there) */
-  if(theclass->keyimage != NULL) {
-    type = MS_LAYER_POINT;
-  } else {
-    /* some polygon layers may be better drawn using zigzag if there is no fill */
-    type = lp->type;
-    if(type == MS_LAYER_POLYGON) {
-      type = MS_LAYER_LINE;
-      for(i=0; i<theclass->numstyles; i++) {
-        if(MS_VALID_COLOR(theclass->styles[i]->color)) { /* there is a fill */
-          type = MS_LAYER_POLYGON;
-        }
-        if(MS_VALID_COLOR(theclass->styles[i]->outlinecolor)) { /* there is an outline */
-          polygon_contraction = MS_MAX(polygon_contraction, theclass->styles[i]->width / 2.0);
-        }
-      }
-    }
-  }
-
-  /* initialize the box used for polygons and for outlines */
-  msInitShape(&box);
-  box.line = &box_line;
-  box.numlines = 1;
-  box.line[0].point = box_point;
-  box.line[0].numpoints = 5;
-  box.type = MS_SHAPE_POLYGON;
-
-  box.line[0].point[0].x = dstX + polygon_contraction;
-  box.line[0].point[0].y = dstY + polygon_contraction;
-  box.line[0].point[1].x = dstX + width - polygon_contraction;
-  box.line[0].point[1].y = dstY + polygon_contraction;
-  box.line[0].point[2].x = dstX + width - polygon_contraction;
-  box.line[0].point[2].y = dstY + height - polygon_contraction;
-  box.line[0].point[3].x = dstX + polygon_contraction;
-  box.line[0].point[3].y = dstY + height - polygon_contraction;
-  box.line[0].point[4].x = box.line[0].point[0].x;
-  box.line[0].point[4].y = box.line[0].point[0].y;
-
-
-
-  /*
-  ** now draw the appropriate color/symbol/size combination
-  */
-
-  /* Scalefactor will be infinity when SIZEUNITS is set in LAYER */
-  if(lp->sizeunits != MS_PIXELS) {
-    lp->scalefactor = 1.0; 
-  }
-
-  switch(type) {
-    case MS_LAYER_POINT:
-      marker.x = dstX + MS_NINT(width / 2.0);
-      marker.y = dstY + MS_NINT(height / 2.0);
-      if(theclass->keyimage != NULL) {
-        int symbolNum;
-        styleObj imgStyle;
-        symbolObj *symbol=NULL;
-        symbolNum = msAddImageSymbol(&(map->symbolset), msBuildPath(szPath, map->mappath, theclass->keyimage));
-        if(symbolNum == -1) {
-          msSetError(MS_IMGERR, "Failed to open legend key image", "msCreateLegendIcon()");
-          return(MS_FAILURE);
-        }
-
-        symbol = map->symbolset.symbol[symbolNum];
-
-        initStyle(&imgStyle);
-        /*set size so that symbol will be scaled properly #3296*/
-        if (width/symbol->sizex < height/symbol->sizey)
-          imgStyle.size = symbol->sizey*(width/symbol->sizex);
-        else
-          imgStyle.size = symbol->sizey*(height/symbol->sizey);
-
-        if (imgStyle.size > imgStyle.maxsize)
-          imgStyle.maxsize = imgStyle.size;
-
-        imgStyle.symbol = symbolNum;
-        ret = msDrawMarkerSymbol(map ,image_draw,&marker,&imgStyle, 1.0);
-        if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        /* TO DO: we may want to handle this differently depending on the relative size of the keyimage */
-      } else {
-        for(i=0; i<theclass->numstyles; i++) {
-          if(!scale_independant && map->scaledenom > 0) {
-            styleObj *lp = theclass->styles[i];
-            if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-            if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-          }
-          if(hittest && hittest->stylehits[i].status == 0) continue;
-          ret = msDrawMarkerSymbol(map, image_draw, &marker, theclass->styles[i], lp->scalefactor * image->resolutionfactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        }
-      }
-      break;
-    case MS_LAYER_LINE:
-      offset = 1;
-      /* To set the offset, we only check the size/width parameter of the first style */
-      if (theclass->numstyles > 0) {
-        if (theclass->styles[0]->symbol > 0 && theclass->styles[0]->symbol < map->symbolset.numsymbols && 
-              map->symbolset.symbol[theclass->styles[0]->symbol]->type != MS_SYMBOL_SIMPLE)
-            offset = theclass->styles[0]->size/2;
-        else
-            offset = theclass->styles[0]->width/2;
-      }
-      msInitShape(&zigzag);
-      zigzag.line = &zigzag_line;
-      zigzag.numlines = 1;
-      zigzag.line[0].point = zigzag_point;
-      zigzag.line[0].numpoints = 4;
-      zigzag.type = MS_SHAPE_LINE;
-
-      zigzag.line[0].point[0].x = dstX + offset;
-      zigzag.line[0].point[0].y = dstY + height - offset;
-      zigzag.line[0].point[1].x = dstX + MS_NINT(width / 3.0) - 1;
-      zigzag.line[0].point[1].y = dstY + offset;
-      zigzag.line[0].point[2].x = dstX + MS_NINT(2.0 * width / 3.0) - 1;
-      zigzag.line[0].point[2].y = dstY + height - offset;
-      zigzag.line[0].point[3].x = dstX + width - offset;
-      zigzag.line[0].point[3].y = dstY + offset;
-
-      for(i=0; i<theclass->numstyles; i++) {
-        if(!scale_independant && map->scaledenom > 0) {
-          styleObj *lp = theclass->styles[i];
-          if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-          if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-        }
-        if(hittest && hittest->stylehits[i].status == 0) continue;
-        if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-	  if (theclass->styles[i]->outlinewidth > 0) {
-	    /* Swap the style contents to render the outline first,
-	     * and then restore the style to render the interior of the line
-	     */
-	    msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
-	    ret = msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-	    msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-	  }
-          ret = msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        }
-        else {
-	  if (theclass->styles[i]->outlinewidth > 0) {
-	    /* Swap the style contents to render the outline first,
-	     * and then restore the style to render the interior of the line
-	     */
-	    msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
-	    ret = msDrawTransformedShape(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-	    msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-	  }
-          ret = msDrawTransformedShape(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        }
-      }
-
-      break;
-    case MS_LAYER_CIRCLE:
-    case MS_LAYER_RASTER:
-    case MS_LAYER_CHART:
-    case MS_LAYER_POLYGON:
-      for(i=0; i<theclass->numstyles; i++) {
-        if(!scale_independant && map->scaledenom > 0) {
-          styleObj *lp = theclass->styles[i];
-          if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-          if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-        }
-        if(hittest && hittest->stylehits[i].status == 0) continue;
-        if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-
-            if (MS_VALID_COLOR(theclass->styles[i]->mincolor))
-            {
-                ret = msDrawGradientSymbol(renderer,
-                                           image_draw,
-                                           dstX + width / 2.,
-                                           dstY + height / 2.0,
-                                           width - 2 * polygon_contraction,
-                                           height - 2 * polygon_contraction,
-                                           theclass->styles[i]);
-            }
-            else
-            {
-                ret = msDrawShadeSymbol(map, image_draw, &box, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-            }
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        }
-        else {
-          ret = msDrawTransformedShape(map, image_draw, &box,
-                                 theclass->styles[i], lp->scalefactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        }
-      }
-      break;
-    default:
-      return MS_FAILURE;
-      break;
-  } /* end symbol drawing */
-
-  /* handle label styles */
-  for(i=0; i<theclass->numlabels; i++) {
-    labelObj *l = theclass->labels[i];
-    if(!scale_independant && map->scaledenom > 0) {
-      if(msScaleInBounds(map->scaledenom, l->minscaledenom, l->maxscaledenom)) {
-        int j;
-        for(j=0; j<l->numstyles; j++) {
-          styleObj *s = l->styles[j];
-          marker.x = dstX + MS_NINT(width / 2.0);
-          marker.y = dstY + MS_NINT(height / 2.0);
-          if(s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-            ret = msDrawMarkerSymbol(map, image_draw, &marker, s, lp->scalefactor);
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-          }
-        }
-      }
-    }
-  }
-
-  /* handle "pure" text layers, i.e. layers with no symbology */
-  hasmarkersymbol = 0;
-  if(theclass->numstyles == 0) {
-    for(i=0; i<theclass->numlabels; i++) {
-      labelObj *l = theclass->labels[i];
-      if(!scale_independant && map->scaledenom > 0) {
-        if(msScaleInBounds(map->scaledenom, l->minscaledenom, l->maxscaledenom)) {
-          int j;
-          for(j=0; j<l->numstyles; j++) {
-            styleObj *s = l->styles[j];
-            if(s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-              hasmarkersymbol = 1;
-            }
-          }
-        }
-      }
-    }
-  } else {
-    hasmarkersymbol = 1;
-  }
-
-  if(!hasmarkersymbol && theclass->numlabels>0) {
-    textSymbolObj ts;
-    pointObj textstartpt;
-    marker.x = dstX + MS_NINT(width / 2.0);
-    marker.y = dstY + MS_NINT(height / 2.0);
-    initTextSymbol(&ts);
-    msPopulateTextSymbolForLabelAndString(&ts,theclass->labels[0],msStrdup("Az"),lp->scalefactor*image_draw->resolutionfactor,image_draw->resolutionfactor, duplicate_always);
-    ts.label->size = height - 1;
-    ts.rotation = 0;
-    ret = msComputeTextPath(map,&ts);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    textstartpt = get_metrics(&marker,MS_CC,ts.textpath,0,0,0,0,NULL);
-    ret = msDrawTextSymbol(map,image_draw, textstartpt, &ts);
-    freeTextSymbol(&ts);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-
-  }
-
-
-  /* handle an outline if necessary */
-  if(MS_VALID_COLOR(map->legend.outlinecolor)) {
-    initStyle(&outline_style);
-    outline_style.color = map->legend.outlinecolor;
-    ret = msDrawLineSymbol(map, image_draw, &box, &outline_style, image_draw->resolutionfactor);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    /* reset clipping rectangle */
-    if(renderer->supports_clipping)
-      renderer->resetClip(image_draw);
-  }
-
-  if (altFormat) {
-    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-    rendererVTableObj *altrenderer = MS_IMAGE_RENDERER(image_draw);
-    rasterBufferObj rb;
-    memset(&rb,0,sizeof(rasterBufferObj));
-
-    ret = altrenderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    ret = renderer->mergeRasterBuffer(image,&rb,((lp->compositer)?lp->compositer->opacity*0.01:1.0),0,0,0,0,rb.width,rb.height);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    /*
-     * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-     * symbols that reference it. We want to remove those references before the altFormat is destroyed
-     * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-     * it's for him.
-     */
-    for(i=0; i<map->symbolset.numsymbols; i++) {
-      if (map->symbolset.symbol[i]!=NULL) {
-        symbolObj *s = map->symbolset.symbol[i];
-        if(s->renderer == altrenderer) {
-          altrenderer->freeSymbol(s);
-          s->renderer = NULL;
-        }
-      }
-    }
-
-  } else if(image != image_draw) {
-    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
-    rasterBufferObj rb;
-    memset(&rb,0,sizeof(rasterBufferObj));
-
-    ret = renderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    ret = renderer->mergeRasterBuffer(image,&rb,((lp->compositer)?lp->compositer->opacity*0.01:1.0),0,0,0,0,rb.width,rb.height);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-
-    /* deref and possibly free temporary transparent output format.  */
-    msApplyOutputFormat( &transFormat, NULL, MS_NOOVERRIDE);
-
-  }
-
-legend_icon_cleanup:
-  if(image != image_draw) {
-    msFreeImage(image_draw);
-  }
-  return ret;
-}
-
-imageObj *msCreateLegendIcon(mapObj* map, layerObj* lp, classObj* class, int width, int height, int scale_independant)
-{
-  imageObj *image;
-  outputFormatObj *format = NULL;
-
-  rendererVTableObj *renderer = MS_MAP_RENDERER(map);
-
-  if( !renderer ) {
-    msSetError(MS_MISCERR, "invalid map outputformat", "msCreateLegendIcon()");
-    return(NULL);
-  }
-
-  /* ensure we have an image format representing the options for the legend */
-  msApplyOutputFormat(&format, map->outputformat, map->legend.transparent);
-
-  image = msImageCreate(width,height,format,map->web.imagepath, map->web.imageurl,
-                        map->resolution, map->defresolution, &(map->legend.imagecolor));
-
-  /* drop this reference to output format */
-  msApplyOutputFormat( &format, NULL, MS_NOOVERRIDE);
-
-  if(image == NULL) {
-    msSetError(MS_IMGERR, "Unable to initialize image.","msCreateLegendIcon()");
-    return(NULL);
-  }
-  image->map = map;
-
-  /* Call drawLegendIcon with destination (0, 0) */
-  /* Return an empty image if lp==NULL || class=NULL  */
-  /* (If class is NULL draw the legend for all classes. Modifications done */
-  /* Fev 2004 by AY) */
-  if (lp) {
-    if (class) {
-      if(MS_UNLIKELY(MS_FAILURE == msDrawLegendIcon(map, lp, class, width, height, image, 0, 0, scale_independant, NULL))) {
-        msFreeImage(image);
-        return NULL;
-      }
-    } else {
-      for (int i=0; i<lp->numclasses; i++) {
-        if(MS_UNLIKELY(MS_FAILURE == msDrawLegendIcon(map, lp, lp->class[i], width, height, image, 0, 0, scale_independant, NULL))) {
-          msFreeImage(image);
-          return NULL;
-        }
-      }
-    }
-  }
-  return image;
-}
-
-/*
- * Calculates the optimal size for the legend. If the optional layerObj
- * argument is given, the legend size will be calculated for only that
- * layer. Otherwise, the legend size is calculated for all layers that
- * are not MS_OFF or of MS_LAYER_QUERY type.
- *
- * Returns one of:
- *   MS_SUCCESS
- *   MS_FAILURE
- */
-int msLegendCalcSize(mapObj *map, int scale_independent, int *size_x, int *size_y,
-                     int *layer_index, int num_layers, map_hittest *hittest,
-                     double resolutionfactor)
-{
-  int i, j;
-  int status, maxwidth=0, nLegendItems=0;
-  char *text;
-  layerObj *lp;
-  rectObj rect;
-  int current_layers=0;
-
-  /* reset sizes */
-  *size_x = 0;
-  *size_y = 0;
-
-  /* enable scale-dependent calculations */
-  if(!scale_independent) {
-    map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-    status = msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-  }
-
-  /*
-   * step through all map classes, and for each one that will be displayed
-   * calculate the label size
-   */
-  if (layer_index != NULL && num_layers >0)
-    current_layers  = num_layers;
-  else
-    current_layers = map->numlayers;
-
-  for(i=0; i< current_layers; i++) {
-    int layerindex;
-    if (layer_index != NULL && num_layers > 0)
-      layerindex = layer_index[i];
-    else
-      layerindex = map->layerorder[i];
-
-    lp = (GET_LAYER(map, layerindex));
-
-    if((lp->status == MS_OFF && (layer_index == NULL || num_layers <= 0)) || (lp->type == MS_LAYER_QUERY)) /* skip it */
-      continue;
-
-    if(hittest && hittest->layerhits[layerindex].status == 0) continue;
-
-    if(!scale_independent && map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-    }
-
-    for(j=lp->numclasses-1; j>=0; j--) {
-      textSymbolObj ts;
-      text = lp->class[j]->title?lp->class[j]->title:lp->class[j]->name; /* point to the right legend text, title takes precedence */
-      if(!text) continue; /* skip it */
-
-      /* skip the class if the classgroup is defined */
-      if(lp->classgroup && (lp->class[j]->group == NULL || strcasecmp(lp->class[j]->group, lp->classgroup) != 0))
-        continue;
-
-      /* verify class scale */
-      if(!scale_independent && map->scaledenom > 0) {
-        if((lp->class[j]->maxscaledenom > 0) && (map->scaledenom > lp->class[j]->maxscaledenom)) continue;
-        if((lp->class[j]->minscaledenom > 0) && (map->scaledenom <= lp->class[j]->minscaledenom)) continue;
-      }
-      if(hittest && hittest->layerhits[layerindex].classhits[j].status == 0) continue;
-
-      if(*text) {
-        initTextSymbol(&ts);
-        msPopulateTextSymbolForLabelAndString(&ts,&map->legend.label,msStrdup(text),resolutionfactor,resolutionfactor, 0);
-        if(MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map,&ts,&rect))) {
-          freeTextSymbol(&ts);
-          return MS_FAILURE;
-        }
-        freeTextSymbol(&ts);
-
-        maxwidth = MS_MAX(maxwidth, MS_NINT(rect.maxx - rect.minx));
-        *size_y += MS_MAX(MS_NINT(rect.maxy - rect.miny), map->legend.keysizey);
-      } else {
-        *size_y += map->legend.keysizey;
-      }
-      nLegendItems++;
-    }
-  }
-
-  /* Calculate the size of the legend: */
-  /*   - account for the Y keyspacing */
-  *size_y += (2*VMARGIN) + ((nLegendItems-1) * map->legend.keyspacingy);
-  /*   - determine the legend width */
-  *size_x = (2*HMARGIN) + maxwidth + map->legend.keyspacingx + map->legend.keysizex;
-
-  if(*size_y <=0 ||  *size_x <=0)
-    return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-/*
-** Creates a GD image of a legend for a specific map. msDrawLegend()
-** respects the current scale, and classes without a name are not
-** added to the legend.
-**
-** scale_independent is used for WMS GetLegendGraphic. It should be set to
-** MS_FALSE in most cases. If it is set to MS_TRUE then the layers' minscale
-** and maxscale are ignored and layers that are currently out of scale still
-** show up in the legend.
-*/
-imageObj *msDrawLegend(mapObj *map, int scale_independent, map_hittest *hittest)
-{
-  int i,j,ret=MS_SUCCESS; /* loop counters */
-  pointObj pnt;
-  int size_x, size_y=0;
-  layerObj *lp;
-  rectObj rect;
-  imageObj *image = NULL;
-  outputFormatObj *format = NULL;
-  char *text;
-
-  struct legend_struct {
-    int height;
-    textSymbolObj ts;
-    int layerindex, classindex;
-    struct legend_struct* pred;
-  };
-  typedef struct legend_struct legendlabel;
-  legendlabel *head=NULL,*cur=NULL;
-
-  if(!MS_RENDERER_PLUGIN(map->outputformat)) {
-    msSetError(MS_MISCERR,"unsupported output format","msDrawLegend()");
-    return NULL;
-  }
-  if(msValidateContexts(map) != MS_SUCCESS) return NULL; /* make sure there are no recursive REQUIRES or LABELREQUIRES expressions */
-  if(msLegendCalcSize(map, scale_independent, &size_x, &size_y, NULL, 0, hittest, map->resolution/map->defresolution) != MS_SUCCESS) return NULL;
-
-  /*
-   * step through all map classes, and for each one that will be displayed
-   * keep a reference to its label size and text
-   */
-  
-  for(i=0; i<map->numlayers; i++) {
-    lp = (GET_LAYER(map, map->layerorder[i]));
-
-    if((lp->status == MS_OFF) || (lp->type == MS_LAYER_QUERY)) /* skip it */
-      continue;
-
-    if(hittest && hittest->layerhits[map->layerorder[i]].status == 0)
-      continue;
-
-    if(!scale_independent && map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-    }
-
-    if(!scale_independent && lp->maxscaledenom <=0 && lp->minscaledenom <=0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
-    }
-    
-    /* set the scale factor so that scale dependant symbols are drawn in the legend with their default size */
-    if(lp->sizeunits != MS_PIXELS) {
-      map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-      lp->scalefactor = (msInchesPerUnit(lp->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
-    }
-
-    for(j=lp->numclasses-1; j>=0; j--) {
-      text = lp->class[j]->title?lp->class[j]->title:lp->class[j]->name; /* point to the right legend text, title takes precedence */
-      if(!text) continue; /* skip it */
-
-      /* skip the class if the classgroup is defined */
-      if(lp->classgroup && (lp->class[j]->group == NULL || strcasecmp(lp->class[j]->group, lp->classgroup) != 0))
-        continue;
-
-      if(!scale_independent && map->scaledenom > 0) {  /* verify class scale here */
-        if((lp->class[j]->maxscaledenom > 0) && (map->scaledenom > lp->class[j]->maxscaledenom)) continue;
-        if((lp->class[j]->minscaledenom > 0) && (map->scaledenom <= lp->class[j]->minscaledenom)) continue;
-      }
-
-      if(hittest && hittest->layerhits[map->layerorder[i]].classhits[j].status == 0) {
-          continue;
-      }
-
-      cur = (legendlabel*) msSmallMalloc(sizeof(legendlabel));
-      initTextSymbol(&cur->ts);
-      if(*text) {
-        msPopulateTextSymbolForLabelAndString(&cur->ts,&map->legend.label,msStrdup(text),map->resolution/map->defresolution,map->resolution/map->defresolution, 0);
-        if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,&cur->ts))) {
-          ret = MS_FAILURE;
-          goto cleanup;
-        }
-        if(MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map,&cur->ts,&rect))) {
-          ret = MS_FAILURE;
-          goto cleanup;
-        }
-        cur->height = MS_MAX(MS_NINT(rect.maxy - rect.miny), map->legend.keysizey);
-      } else {
-        cur->height = map->legend.keysizey;
-      }
-
-      cur->classindex = j;
-      cur->layerindex = map->layerorder[i];
-      cur->pred = head;
-      head = cur;
-    }
-  }
-
-
-  /* ensure we have an image format representing the options for the legend. */
-  msApplyOutputFormat(&format, map->outputformat, map->legend.transparent);
-
-  /* initialize the legend image */
-  image = msImageCreate(size_x, size_y, format, map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &map->legend.imagecolor);
-  if(!image) {
-    msSetError(MS_MISCERR, "Unable to initialize image.", "msDrawLegend()");
-    return NULL;
-  }
-  image->map = map;
-
-  /* image = renderer->createImage(size_x,size_y,format,&(map->legend.imagecolor)); */
-
-  /* drop this reference to output format */
-  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
-
-  pnt.y = VMARGIN;
-  pnt.x = HMARGIN + map->legend.keysizex + map->legend.keyspacingx;
-
-  while(cur) { /* cur initially points on the last legend item, i.e. the one that should be at the top */
-    class_hittest *ch = NULL;
-
-    /* set the scale factor so that scale dependant symbols are drawn in the legend with their default size */
-    if(map->layers[cur->layerindex]->sizeunits != MS_PIXELS) {
-      map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-      map->layers[cur->layerindex]->scalefactor = (msInchesPerUnit(map->layers[cur->layerindex]->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
-    }
-    if(hittest) {
-      ch = &hittest->layerhits[cur->layerindex].classhits[cur->classindex];
-    }
-    ret = msDrawLegendIcon(map, map->layers[cur->layerindex], map->layers[cur->layerindex]->class[cur->classindex],  map->legend.keysizex,  map->legend.keysizey, image, HMARGIN, (int) pnt.y, scale_independent, ch);
-    if(MS_UNLIKELY(ret != MS_SUCCESS))
-      goto cleanup;
-
-    pnt.y += cur->height;
-
-    if(cur->ts.annotext) {
-      pointObj textPnt = pnt;
-      textPnt.y -= cur->ts.textpath->bounds.bbox.maxy;
-      textPnt.y += map->legend.label.offsety;
-      textPnt.x += map->legend.label.offsetx;
-      ret = msDrawTextSymbol(map,image,textPnt,&cur->ts);
-      if(MS_UNLIKELY(ret == MS_FAILURE))
-        goto cleanup;
-      /* Coverity Scan is confused by label refcount, and wrongly believe we */
-      /* might free &map->legend.label, so make it clear we won't */
-      freeTextSymbolEx(&cur->ts, MS_FALSE);
-      MS_REFCNT_DECR(cur->ts.label);
-    }
-    
-    pnt.y += map->legend.keyspacingy; /* bump y for next label */
-
-    /* clean up */
-    head = cur;
-    cur = cur->pred;
-    free(head);
-  } /* next legend */
-
-cleanup:
-  while(cur) {
-    /* Coverity Scan is confused by label refcount, and wrongly believe we */
-    /* might free &map->legend.label, so make it clear we won't */
-    freeTextSymbolEx(&cur->ts, MS_FALSE);
-    MS_REFCNT_DECR(cur->ts.label);
-    head = cur;
-    cur = cur->pred;
-    free(head);
-  }
-  if(MS_UNLIKELY(ret != MS_SUCCESS)) {
-    if(image) msFreeImage(image);
-    return NULL;
-  }
-  return(image);
-}
-
-/* TODO */
-int msEmbedLegend(mapObj *map, imageObj *img)
-{
-  int s,l;
-  pointObj point;
-  imageObj *image = NULL;
-  symbolObj *legendSymbol;
-  char* imageType = NULL;
-
-  rendererVTableObj *renderer;
-
-  s = msGetSymbolIndex(&(map->symbolset), "legend", MS_FALSE);
-  if(s != -1)
-    msRemoveSymbol(&(map->symbolset), s); /* solves some caching issues in AGG with long-running processes */
-
-  if(msGrowSymbolSet(&map->symbolset) == NULL)
-    return -1;
-  s = map->symbolset.numsymbols;
-  legendSymbol = map->symbolset.symbol[s];
-  map->symbolset.numsymbols++;
-  initSymbol(legendSymbol);
-
-  if(!MS_RENDERER_PLUGIN(map->outputformat) || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
-    imageType = msStrdup(map->imagetype); /* save format */
-    if MS_DRIVER_CAIRO(map->outputformat)
-      map->outputformat = msSelectOutputFormat( map, "cairopng" );
-    else
-      map->outputformat = msSelectOutputFormat( map, "png" );
-    
-    msInitializeRendererVTable(map->outputformat);
-  }
-  renderer = MS_MAP_RENDERER(map);
-
-  /* render the legend. */
-  image = msDrawLegend(map, MS_FALSE, NULL);
-  if( image == NULL ) {
-    msFree(imageType);
-    return MS_FAILURE;
-  }
-
-  if (imageType) {
-    map->outputformat = msSelectOutputFormat( map, imageType ); /* restore format */
-    msFree(imageType);
-  }
-
-  /* copy renderered legend image into symbol */
-  legendSymbol->pixmap_buffer = calloc(1,sizeof(rasterBufferObj));
-  MS_CHECK_ALLOC(legendSymbol->pixmap_buffer, sizeof(rasterBufferObj), MS_FAILURE);
-
-  if(MS_SUCCESS != renderer->getRasterBufferCopy(image,legendSymbol->pixmap_buffer))
-    return MS_FAILURE;
-  legendSymbol->renderer = renderer;
-
-  msFreeImage( image );
-
-  if(!legendSymbol->pixmap_buffer) return(MS_FAILURE); /* something went wrong creating scalebar */
-
-  legendSymbol->type = MS_SYMBOL_PIXMAP; /* intialize a few things */
-  legendSymbol->name = msStrdup("legend");
-  legendSymbol->sizex = legendSymbol->pixmap_buffer->width;
-  legendSymbol->sizey = legendSymbol->pixmap_buffer->height;
-
-  /* I'm not too sure this test is sufficient ... NFW. */
-  /* if(map->legend.transparent == MS_ON) */
-  /*  gdImageColorTransparent(legendSymbol->img_deprecated, 0); */
-
-  switch(map->legend.position) {
-    case(MS_LL):
-      point.x = MS_NINT(legendSymbol->sizex/2.0);
-      point.y = map->height - MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_LR):
-      point.x = map->width - MS_NINT(legendSymbol->sizex/2.0);
-      point.y = map->height - MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_LC):
-      point.x = MS_NINT(map->width/2.0);
-      point.y = map->height - MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_UR):
-      point.x = map->width - MS_NINT(legendSymbol->sizex/2.0);
-      point.y = MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_UL):
-      point.x = MS_NINT(legendSymbol->sizex/2.0);
-      point.y = MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_UC):
-      point.x = MS_NINT(map->width/2.0);
-      point.y = MS_NINT(legendSymbol->sizey/2.0);
-      break;
-  }
-
-  l = msGetLayerIndex(map, "__embed__legend");
-  if(l == -1) {
-    if(msGrowMapLayers(map) == NULL)
-      return(-1);
-    l = map->numlayers;
-    map->numlayers++;
-    if(initLayer((GET_LAYER(map, l)), map) == -1) return(-1);
-    GET_LAYER(map, l)->name = msStrdup("__embed__legend");
-    GET_LAYER(map, l)->type = MS_LAYER_POINT;
-
-    if(msGrowLayerClasses( GET_LAYER(map, l) ) == NULL)
-      return(-1);
-    if(initClass(GET_LAYER(map, l)->class[0]) == -1) return(-1);
-    GET_LAYER(map, l)->numclasses = 1; /* so we make sure to free it */
-
-    /* update the layer order list with the layer's index. */
-    map->layerorder[l] = l;
-  }
-
-  GET_LAYER(map, l)->status = MS_ON;
-
-  if(map->legend.postlabelcache) { /* add it directly to the image */
-    if(MS_UNLIKELY(msMaybeAllocateClassStyle(GET_LAYER(map, l)->class[0], 0)==MS_FAILURE)) return MS_FAILURE;
-    GET_LAYER(map, l)->class[0]->styles[0]->symbol = s;
-    if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, img, &point, GET_LAYER(map, l)->class[0]->styles[0], 1.0)))
-      return MS_FAILURE;
-  } else {
-    if(!GET_LAYER(map, l)->class[0]->labels) {
-      if(msGrowClassLabels(GET_LAYER(map, l)->class[0]) == NULL) return MS_FAILURE;
-      initLabel(GET_LAYER(map, l)->class[0]->labels[0]);
-      GET_LAYER(map, l)->class[0]->numlabels = 1;
-      GET_LAYER(map, l)->class[0]->labels[0]->force = MS_TRUE;
-      GET_LAYER(map, l)->class[0]->labels[0]->size = MS_MEDIUM; /* must set a size to have a valid label definition */
-      GET_LAYER(map, l)->class[0]->labels[0]->priority = MS_MAX_LABEL_PRIORITY;
-    }
-    if(GET_LAYER(map, l)->class[0]->labels[0]->numstyles == 0) {
-      if(msGrowLabelStyles(GET_LAYER(map,l)->class[0]->labels[0]) == NULL)
-        return(MS_FAILURE);
-      GET_LAYER(map,l)->class[0]->labels[0]->numstyles = 1;
-      initStyle(GET_LAYER(map,l)->class[0]->labels[0]->styles[0]);
-      GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
-    }
-    GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->symbol = s;
-    if(MS_UNLIKELY(MS_FAILURE == msAddLabel(map, img, GET_LAYER(map, l)->class[0]->labels[0], l, 0, NULL, &point, -1, NULL)))
-      return MS_FAILURE;
-  }
-
-  /* Mark layer as deleted so that it doesn't interfere with html legends or with saving maps */
-  GET_LAYER(map, l)->status = MS_DELETE;
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/maplexer.c 8.2.0~beta1-1~exp1/maplexer.c
--- 8.0.1-5/maplexer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maplexer.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,5576 +0,0 @@
-#line 2 "/home/even/mapserver/mapserver/maplexer.c"
-
-#line 4 "/home/even/mapserver/mapserver/maplexer.c"
-
-#define  YY_INT_ALIGNED short int
-
-/* A lexical scanner generated by flex */
-
-#define yy_create_buffer msyy_create_buffer
-#define yy_delete_buffer msyy_delete_buffer
-#define yy_scan_buffer msyy_scan_buffer
-#define yy_scan_string msyy_scan_string
-#define yy_scan_bytes msyy_scan_bytes
-#define yy_init_buffer msyy_init_buffer
-#define yy_flush_buffer msyy_flush_buffer
-#define yy_load_buffer_state msyy_load_buffer_state
-#define yy_switch_to_buffer msyy_switch_to_buffer
-#define yypush_buffer_state msyypush_buffer_state
-#define yypop_buffer_state msyypop_buffer_state
-#define yyensure_buffer_stack msyyensure_buffer_stack
-#define yy_flex_debug msyy_flex_debug
-#define yyin msyyin
-#define yyleng msyyleng
-#define yylex msyylex
-#define yylineno msyylineno
-#define yyout msyyout
-#define yyrestart msyyrestart
-#define yytext msyytext
-#define yywrap msyywrap
-#define yyalloc msyyalloc
-#define yyrealloc msyyrealloc
-#define yyfree msyyfree
-
-#define FLEX_SCANNER
-#define YY_FLEX_MAJOR_VERSION 2
-#define YY_FLEX_MINOR_VERSION 6
-#define YY_FLEX_SUBMINOR_VERSION 4
-#if YY_FLEX_SUBMINOR_VERSION > 0
-#define FLEX_BETA
-#endif
-
-#ifdef yy_create_buffer
-#define msyy_create_buffer_ALREADY_DEFINED
-#else
-#define yy_create_buffer msyy_create_buffer
-#endif
-
-#ifdef yy_delete_buffer
-#define msyy_delete_buffer_ALREADY_DEFINED
-#else
-#define yy_delete_buffer msyy_delete_buffer
-#endif
-
-#ifdef yy_scan_buffer
-#define msyy_scan_buffer_ALREADY_DEFINED
-#else
-#define yy_scan_buffer msyy_scan_buffer
-#endif
-
-#ifdef yy_scan_string
-#define msyy_scan_string_ALREADY_DEFINED
-#else
-#define yy_scan_string msyy_scan_string
-#endif
-
-#ifdef yy_scan_bytes
-#define msyy_scan_bytes_ALREADY_DEFINED
-#else
-#define yy_scan_bytes msyy_scan_bytes
-#endif
-
-#ifdef yy_init_buffer
-#define msyy_init_buffer_ALREADY_DEFINED
-#else
-#define yy_init_buffer msyy_init_buffer
-#endif
-
-#ifdef yy_flush_buffer
-#define msyy_flush_buffer_ALREADY_DEFINED
-#else
-#define yy_flush_buffer msyy_flush_buffer
-#endif
-
-#ifdef yy_load_buffer_state
-#define msyy_load_buffer_state_ALREADY_DEFINED
-#else
-#define yy_load_buffer_state msyy_load_buffer_state
-#endif
-
-#ifdef yy_switch_to_buffer
-#define msyy_switch_to_buffer_ALREADY_DEFINED
-#else
-#define yy_switch_to_buffer msyy_switch_to_buffer
-#endif
-
-#ifdef yypush_buffer_state
-#define msyypush_buffer_state_ALREADY_DEFINED
-#else
-#define yypush_buffer_state msyypush_buffer_state
-#endif
-
-#ifdef yypop_buffer_state
-#define msyypop_buffer_state_ALREADY_DEFINED
-#else
-#define yypop_buffer_state msyypop_buffer_state
-#endif
-
-#ifdef yyensure_buffer_stack
-#define msyyensure_buffer_stack_ALREADY_DEFINED
-#else
-#define yyensure_buffer_stack msyyensure_buffer_stack
-#endif
-
-#ifdef yylex
-#define msyylex_ALREADY_DEFINED
-#else
-#define yylex msyylex
-#endif
-
-#ifdef yyrestart
-#define msyyrestart_ALREADY_DEFINED
-#else
-#define yyrestart msyyrestart
-#endif
-
-#ifdef yylex_init
-#define msyylex_init_ALREADY_DEFINED
-#else
-#define yylex_init msyylex_init
-#endif
-
-#ifdef yylex_init_extra
-#define msyylex_init_extra_ALREADY_DEFINED
-#else
-#define yylex_init_extra msyylex_init_extra
-#endif
-
-#ifdef yylex_destroy
-#define msyylex_destroy_ALREADY_DEFINED
-#else
-#define yylex_destroy msyylex_destroy
-#endif
-
-#ifdef yyget_debug
-#define msyyget_debug_ALREADY_DEFINED
-#else
-#define yyget_debug msyyget_debug
-#endif
-
-#ifdef yyset_debug
-#define msyyset_debug_ALREADY_DEFINED
-#else
-#define yyset_debug msyyset_debug
-#endif
-
-#ifdef yyget_extra
-#define msyyget_extra_ALREADY_DEFINED
-#else
-#define yyget_extra msyyget_extra
-#endif
-
-#ifdef yyset_extra
-#define msyyset_extra_ALREADY_DEFINED
-#else
-#define yyset_extra msyyset_extra
-#endif
-
-#ifdef yyget_in
-#define msyyget_in_ALREADY_DEFINED
-#else
-#define yyget_in msyyget_in
-#endif
-
-#ifdef yyset_in
-#define msyyset_in_ALREADY_DEFINED
-#else
-#define yyset_in msyyset_in
-#endif
-
-#ifdef yyget_out
-#define msyyget_out_ALREADY_DEFINED
-#else
-#define yyget_out msyyget_out
-#endif
-
-#ifdef yyset_out
-#define msyyset_out_ALREADY_DEFINED
-#else
-#define yyset_out msyyset_out
-#endif
-
-#ifdef yyget_leng
-#define msyyget_leng_ALREADY_DEFINED
-#else
-#define yyget_leng msyyget_leng
-#endif
-
-#ifdef yyget_text
-#define msyyget_text_ALREADY_DEFINED
-#else
-#define yyget_text msyyget_text
-#endif
-
-#ifdef yyget_lineno
-#define msyyget_lineno_ALREADY_DEFINED
-#else
-#define yyget_lineno msyyget_lineno
-#endif
-
-#ifdef yyset_lineno
-#define msyyset_lineno_ALREADY_DEFINED
-#else
-#define yyset_lineno msyyset_lineno
-#endif
-
-#ifdef yywrap
-#define msyywrap_ALREADY_DEFINED
-#else
-#define yywrap msyywrap
-#endif
-
-#ifdef yyalloc
-#define msyyalloc_ALREADY_DEFINED
-#else
-#define yyalloc msyyalloc
-#endif
-
-#ifdef yyrealloc
-#define msyyrealloc_ALREADY_DEFINED
-#else
-#define yyrealloc msyyrealloc
-#endif
-
-#ifdef yyfree
-#define msyyfree_ALREADY_DEFINED
-#else
-#define yyfree msyyfree
-#endif
-
-#ifdef yytext
-#define msyytext_ALREADY_DEFINED
-#else
-#define yytext msyytext
-#endif
-
-#ifdef yyleng
-#define msyyleng_ALREADY_DEFINED
-#else
-#define yyleng msyyleng
-#endif
-
-#ifdef yyin
-#define msyyin_ALREADY_DEFINED
-#else
-#define yyin msyyin
-#endif
-
-#ifdef yyout
-#define msyyout_ALREADY_DEFINED
-#else
-#define yyout msyyout
-#endif
-
-#ifdef yy_flex_debug
-#define msyy_flex_debug_ALREADY_DEFINED
-#else
-#define yy_flex_debug msyy_flex_debug
-#endif
-
-#ifdef yylineno
-#define msyylineno_ALREADY_DEFINED
-#else
-#define yylineno msyylineno
-#endif
-
-/* First, we deal with  platform-specific or compiler-specific issues. */
-
-/* begin standard C headers. */
-#include <stdio.h>
-#include <string.h>
-#include <errno.h>
-#include <stdlib.h>
-
-/* end standard C headers. */
-
-/* flex integer type definitions */
-
-#ifndef FLEXINT_H
-#define FLEXINT_H
-
-/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */
-
-#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
-
-/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
- * if you want the limit (max/min) macros for int types. 
- */
-#ifndef __STDC_LIMIT_MACROS
-#define __STDC_LIMIT_MACROS 1
-#endif
-
-#include <inttypes.h>
-typedef int8_t flex_int8_t;
-typedef uint8_t flex_uint8_t;
-typedef int16_t flex_int16_t;
-typedef uint16_t flex_uint16_t;
-typedef int32_t flex_int32_t;
-typedef uint32_t flex_uint32_t;
-#else
-typedef signed char flex_int8_t;
-typedef short int flex_int16_t;
-typedef int flex_int32_t;
-typedef unsigned char flex_uint8_t; 
-typedef unsigned short int flex_uint16_t;
-typedef unsigned int flex_uint32_t;
-
-/* Limits of integral types. */
-#ifndef INT8_MIN
-#define INT8_MIN               (-128)
-#endif
-#ifndef INT16_MIN
-#define INT16_MIN              (-32767-1)
-#endif
-#ifndef INT32_MIN
-#define INT32_MIN              (-2147483647-1)
-#endif
-#ifndef INT8_MAX
-#define INT8_MAX               (127)
-#endif
-#ifndef INT16_MAX
-#define INT16_MAX              (32767)
-#endif
-#ifndef INT32_MAX
-#define INT32_MAX              (2147483647)
-#endif
-#ifndef UINT8_MAX
-#define UINT8_MAX              (255U)
-#endif
-#ifndef UINT16_MAX
-#define UINT16_MAX             (65535U)
-#endif
-#ifndef UINT32_MAX
-#define UINT32_MAX             (4294967295U)
-#endif
-
-#ifndef SIZE_MAX
-#define SIZE_MAX               (~(size_t)0)
-#endif
-
-#endif /* ! C99 */
-
-#endif /* ! FLEXINT_H */
-
-/* begin standard C++ headers. */
-
-/* TODO: this is always defined, so inline it */
-#define yyconst const
-
-#if defined(__GNUC__) && __GNUC__ >= 3
-#define yynoreturn __attribute__((__noreturn__))
-#else
-#define yynoreturn
-#endif
-
-/* Returned upon end-of-file. */
-#define YY_NULL 0
-
-/* Promotes a possibly negative, possibly signed char to an
- *   integer in range [0..255] for use as an array index.
- */
-#define YY_SC_TO_UI(c) ((YY_CHAR) (c))
-
-/* Enter a start condition.  This macro really ought to take a parameter,
- * but we do it the disgusting crufty way forced on us by the ()-less
- * definition of BEGIN.
- */
-#define BEGIN (yy_start) = 1 + 2 *
-/* Translate the current start state into a value that can be later handed
- * to BEGIN to return to the state.  The YYSTATE alias is for lex
- * compatibility.
- */
-#define YY_START (((yy_start) - 1) / 2)
-#define YYSTATE YY_START
-/* Action number for EOF rule of a given start state. */
-#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
-/* Special action meaning "start processing a new file". */
-#define YY_NEW_FILE yyrestart( yyin  )
-#define YY_END_OF_BUFFER_CHAR 0
-
-/* Size of default input buffer. */
-#ifndef YY_BUF_SIZE
-#ifdef __ia64__
-/* On IA-64, the buffer size is 16k, not 8k.
- * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
- * Ditto for the __ia64__ case accordingly.
- */
-#define YY_BUF_SIZE 32768
-#else
-#define YY_BUF_SIZE 16384
-#endif /* __ia64__ */
-#endif
-
-/* The state buf must be large enough to hold one state per character in the main buffer.
- */
-#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))
-
-#ifndef YY_TYPEDEF_YY_BUFFER_STATE
-#define YY_TYPEDEF_YY_BUFFER_STATE
-typedef struct yy_buffer_state *YY_BUFFER_STATE;
-#endif
-
-#ifndef YY_TYPEDEF_YY_SIZE_T
-#define YY_TYPEDEF_YY_SIZE_T
-typedef size_t yy_size_t;
-#endif
-
-extern int yyleng;
-
-extern FILE *yyin, *yyout;
-
-#define EOB_ACT_CONTINUE_SCAN 0
-#define EOB_ACT_END_OF_FILE 1
-#define EOB_ACT_LAST_MATCH 2
-    
-    #define YY_LESS_LINENO(n)
-    #define YY_LINENO_REWIND_TO(ptr)
-    
-/* Return all but the first "n" matched characters back to the input stream. */
-#define yyless(n) \
-	do \
-		{ \
-		/* Undo effects of setting up yytext. */ \
-        int yyless_macro_arg = (n); \
-        YY_LESS_LINENO(yyless_macro_arg);\
-		*yy_cp = (yy_hold_char); \
-		YY_RESTORE_YY_MORE_OFFSET \
-		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
-		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
-		} \
-	while ( 0 )
-#define unput(c) yyunput( c, (yytext_ptr)  )
-
-#ifndef YY_STRUCT_YY_BUFFER_STATE
-#define YY_STRUCT_YY_BUFFER_STATE
-struct yy_buffer_state
-	{
-	FILE *yy_input_file;
-
-	char *yy_ch_buf;		/* input buffer */
-	char *yy_buf_pos;		/* current position in input buffer */
-
-	/* Size of input buffer in bytes, not including room for EOB
-	 * characters.
-	 */
-	int yy_buf_size;
-
-	/* Number of characters read into yy_ch_buf, not including EOB
-	 * characters.
-	 */
-	int yy_n_chars;
-
-	/* Whether we "own" the buffer - i.e., we know we created it,
-	 * and can realloc() it to grow it, and should free() it to
-	 * delete it.
-	 */
-	int yy_is_our_buffer;
-
-	/* Whether this is an "interactive" input source; if so, and
-	 * if we're using stdio for input, then we want to use getc()
-	 * instead of fread(), to make sure we stop fetching input after
-	 * each newline.
-	 */
-	int yy_is_interactive;
-
-	/* Whether we're considered to be at the beginning of a line.
-	 * If so, '^' rules will be active on the next match, otherwise
-	 * not.
-	 */
-	int yy_at_bol;
-
-    int yy_bs_lineno; /**< The line count. */
-    int yy_bs_column; /**< The column count. */
-
-	/* Whether to try to fill the input buffer when we reach the
-	 * end of it.
-	 */
-	int yy_fill_buffer;
-
-	int yy_buffer_status;
-
-#define YY_BUFFER_NEW 0
-#define YY_BUFFER_NORMAL 1
-	/* When an EOF's been seen but there's still some text to process
-	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
-	 * shouldn't try reading from the input source any more.  We might
-	 * still have a bunch of tokens to match, though, because of
-	 * possible backing-up.
-	 *
-	 * When we actually see the EOF, we change the status to "new"
-	 * (via yyrestart()), so that the user can continue scanning by
-	 * just pointing yyin at a new input file.
-	 */
-#define YY_BUFFER_EOF_PENDING 2
-
-	};
-#endif /* !YY_STRUCT_YY_BUFFER_STATE */
-
-/* Stack of input buffers. */
-static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
-static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
-static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */
-
-/* We provide macros for accessing buffer states in case in the
- * future we want to put the buffer states in a more general
- * "scanner state".
- *
- * Returns the top of the stack, or NULL.
- */
-#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
-                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
-                          : NULL)
-/* Same as previous macro, but useful when we know that the buffer stack is not
- * NULL or when we need an lvalue. For internal use only.
- */
-#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]
-
-/* yy_hold_char holds the character lost when yytext is formed. */
-static char yy_hold_char;
-static int yy_n_chars;		/* number of characters read into yy_ch_buf */
-int yyleng;
-
-/* Points to current character in buffer. */
-static char *yy_c_buf_p = NULL;
-static int yy_init = 0;		/* whether we need to initialize */
-static int yy_start = 0;	/* start state number */
-
-/* Flag which is used to allow yywrap()'s to do buffer switches
- * instead of setting up a fresh yyin.  A bit of a hack ...
- */
-static int yy_did_buffer_switch_on_eof;
-
-void yyrestart ( FILE *input_file  );
-void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
-YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
-void yy_delete_buffer ( YY_BUFFER_STATE b  );
-void yy_flush_buffer ( YY_BUFFER_STATE b  );
-void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
-void yypop_buffer_state ( void );
-
-static void yyensure_buffer_stack ( void );
-static void yy_load_buffer_state ( void );
-static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
-#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )
-
-YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
-YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
-YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );
-
-void *yyalloc ( yy_size_t  );
-void *yyrealloc ( void *, yy_size_t  );
-void yyfree ( void *  );
-
-#define yy_new_buffer yy_create_buffer
-#define yy_set_interactive(is_interactive) \
-	{ \
-	if ( ! YY_CURRENT_BUFFER ){ \
-        yyensure_buffer_stack (); \
-		YY_CURRENT_BUFFER_LVALUE =    \
-            yy_create_buffer( yyin, YY_BUF_SIZE ); \
-	} \
-	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
-	}
-#define yy_set_bol(at_bol) \
-	{ \
-	if ( ! YY_CURRENT_BUFFER ){\
-        yyensure_buffer_stack (); \
-		YY_CURRENT_BUFFER_LVALUE =    \
-            yy_create_buffer( yyin, YY_BUF_SIZE ); \
-	} \
-	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
-	}
-#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)
-
-/* Begin user sect3 */
-typedef flex_uint8_t YY_CHAR;
-
-FILE *yyin = NULL, *yyout = NULL;
-
-typedef int yy_state_type;
-
-extern int yylineno;
-int yylineno = 1;
-
-extern char *yytext;
-#ifdef yytext_ptr
-#undef yytext_ptr
-#endif
-#define yytext_ptr yytext
-
-static yy_state_type yy_get_previous_state ( void );
-static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
-static int yy_get_next_buffer ( void );
-static void yynoreturn yy_fatal_error ( const char* msg  );
-
-/* Done after the current pattern has been matched and before the
- * corresponding action - sets up yytext.
- */
-#define YY_DO_BEFORE_ACTION \
-	(yytext_ptr) = yy_bp; \
-	yyleng = (int) (yy_cp - yy_bp); \
-	(yy_hold_char) = *yy_cp; \
-	*yy_cp = '\0'; \
-	(yy_c_buf_p) = yy_cp;
-#define YY_NUM_RULES 344
-#define YY_END_OF_BUFFER 345
-/* This struct is not used in this scanner,
-   but its presence is necessary. */
-struct yy_trans_info
-	{
-	flex_int32_t yy_verify;
-	flex_int32_t yy_nxt;
-	};
-static const flex_int16_t yy_accept[1732] =
-    {   0,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,  345,  342,    1,  340,  333,    2,  342,  342,
-      326,  339,  326,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  342,  342,  342,
-      343,    1,  341,    1,   14,  338,  343,  338,  343,  327,
-      327,   18,   15,   17,  343,  343,  343,  343,  343,  343,
-      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
-      343,  343,  343,  341,   21,  341,  344,    1,  344,  344,
-      336,  334,  334,  335,    5,    7,    6,  339,  339,  339,
-
-      339,  339,    1,    2,    0,  331,  326,  326,  339,  326,
-      339,    0,    3,  339,    2,  326,    0,  339,  339,  339,
-      339,  339,  339,  339,  339,  244,  339,  339,  339,  248,
-      339,  249,  339,  339,  254,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  268,  339,  339,  271,  272,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  284,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-
-      339,  339,  339,  339,  223,  339,  339,  310,  311,  339,
-      312,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,    0,  319,    0,  332,    0,   16,    0,   13,    0,
-      327,  327,  327,    0,  327,    0,   20,   22,   15,   19,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-       15,    0,    0,    0,   19,   17,   24,    0,   20,    0,
-       18,    0,   12,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,  323,    0,    0,  328,
-       23,    0,  337,    0,  336,  334,  334,  335,    5,    4,
-        2,  339,  339,  339,  339,  326,    0,    0,  339,  326,
-
-        0,  330,  339,  330,    2,    2,    2,  326,    0,    0,
-      326,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  250,  339,  339,  339,  339,  339,  339,
-      339,  339,   88,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  103,  339,  339,  339,
-      339,  339,  339,  339,  339,  263,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  142,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-
-      281,  282,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  304,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  234,  317,  339,  236,  318,
-      339,   68,    0,    0,    0,    0,    0,  327,  327,    0,
-        0,  327,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,   14,    0,    0,    0,    0,    0,
-
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        2,  339,    9,  339,  339,  326,  329,  329,    2,    2,
-        0,  326,  339,  339,  339,  339,  339,  239,  339,  339,
-      339,  339,  339,  339,  339,  243,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,   83,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      258,  339,  339,  339,  339,   98,  339,  339,  339,  102,
-      339,  339,  339,  105,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  121,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  269,  339,  270,  339,  145,
-
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  175,  339,
-      279,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  207,
-      339,  339,  339,  339,  339,  339,  339,  218,  339,  306,
-      339,  339,  339,  339,  308,  228,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  237,  324,    0,  327,   25,
-
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,    0,    0,    0,    0,   56,    0,
-        0,    0,    0,    0,  325,  339,   10,  339,    2,   61,
-      339,   63,  339,  339,  240,  339,  339,  241,  339,  339,
-      339,  339,  339,  339,  246,  339,   72,  339,   76,  339,
-      339,  339,  339,  339,  339,   84,  339,  339,  339,  339,
-      256,   86,  339,   89,  339,  339,  257,  339,  339,  339,
-      339,  339,  339,  339,  100,  339,  339,  260,  339,  339,
-      108,  261,  339,  339,  110,  339,  339,  118,  339,  339,
-
-      186,  339,  339,  339,  339,  339,  125,  267,  339,  135,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  276,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  277,  339,  252,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  291,  339,  339,  339,  339,  339,  339,  339,
-      339,  295,  339,  339,  339,  339,  339,  339,  339,  339,
-      297,  298,  200,  339,  339,  339,  339,  339,  339,  302,
-      339,  339,  210,  339,  216,  339,  339,  339,  339,  222,
-
-      339,  339,  339,  339,  313,  229,  339,  339,  339,  339,
-      339,  339,  235,    0,    0,    0,    0,    0,    0,    0,
-        0,    0,    0,    0,   57,    0,    0,    0,    0,   43,
-        0,    0,    0,   31,   42,    0,   29,    0,    0,    0,
-        0,   30,    0,    0,    0,    0,  339,  339,  339,  339,
-      339,  339,  339,  339,  242,  339,   70,  245,  339,  247,
-      339,  339,  339,  339,  339,   79,  339,   80,  339,  339,
-      339,  339,  339,   85,  339,  339,  339,  339,   91,  339,
-       94,   95,  339,  259,  339,   97,  339,  339,  339,  339,
-      109,  264,  339,  339,  339,  339,  339,  265,  339,  339,
-
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  134,  136,  137,  339,  339,  143,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      273,  339,  274,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  280,  176,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  290,  289,
-      294,  185,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  296,  339,  195,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  300,  301,  339,
-      303,  209,  339,  212,  339,  339,  339,  339,  339,  339,
-
-      339,  339,  339,  339,  339,  339,  339,  339,  233,  316,
-       53,   34,    0,    0,    0,    0,    0,    0,    0,    0,
-       52,    0,    0,    0,    0,    0,    0,   26,    0,    0,
-        0,    0,    0,   50,    0,    0,    0,    8,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,   75,
-      339,  339,  339,  339,  315,  339,  253,  339,  255,  339,
-      339,  339,   93,  339,  339,   99,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  117,  339,  339,  339,  339,
-      123,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      139,  339,  339,  146,  339,  339,  339,  339,  339,  339,
-
-      339,  339,  155,  339,  339,  339,  339,  339,  161,  339,
-      339,  339,  339,  339,  339,  171,  339,  339,  339,  339,
-      339,  177,  339,  178,  339,  339,  339,  339,  184,  339,
-      339,  292,  339,  293,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  221,  339,  339,  339,  339,  339,  230,  231,  339,
-      339,    0,   28,    0,   49,   41,    0,    0,   54,    0,
-        0,    0,   32,    0,    0,    0,    0,    0,    0,   47,
-        0,    0,  320,   11,  339,  339,  339,  339,  339,   67,
-
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-       87,  339,  339,  339,  339,  339,  339,  339,  106,  339,
-      339,  339,  339,  116,  339,  339,  339,  122,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  140,  339,  339,
-      339,  339,  339,  339,  339,  339,  151,  339,  339,  158,
-      159,  160,  339,  339,  339,  339,  339,  168,  339,  339,
-      174,  278,  339,  339,  339,  339,  339,  339,  339,  183,
-      339,  339,  187,  339,  339,  189,  339,  339,  339,  193,
-      339,  339,  339,  339,  197,  339,  202,  339,  339,  299,
-      339,  339,  339,  339,  339,  339,  339,  217,  115,  339,
-
-      220,  339,  339,  339,  307,  309,  314,  339,    0,   51,
-        0,   46,   33,   55,    0,    0,    0,   48,   36,    0,
-       27,    0,    0,  339,  339,   64,  339,   66,  339,   71,
-      339,   73,  339,  339,   78,  339,   59,  339,  339,   92,
-      339,  339,  339,  339,  107,  339,  113,  114,  112,  339,
-      120,  339,  339,  339,  339,  339,  128,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  154,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
-      339,  339,  339,  339,  339,   60,  194,  339,  339,  339,
-
-      339,  339,  339,  339,  206,  208,  211,  339,  215,  219,
-      224,  227,  339,  339,    0,    0,    0,    0,    0,    0,
-       39,    0,    0,  339,  238,  339,  339,   74,   58,   77,
-       81,  339,   90,   96,  283,  339,  339,  111,  119,  339,
-      124,  266,  126,  339,  339,  339,  339,  339,  339,  144,
-      147,  339,  339,  339,  339,  339,  339,  339,  339,  162,
-      339,  339,  339,  339,  339,  339,  339,  339,  339,  285,
-      339,  339,  339,  339,  339,  339,  251,  339,  190,  191,
-      339,  196,  339,  198,  201,  203,  339,  205,  339,  339,
-      339,  232,   40,   35,   38,   45,   44,   37,    0,    0,
-
-       62,  339,  339,  339,  339,  339,  339,  339,  339,  127,
-      339,  339,  339,  339,  339,  148,  149,  153,  150,  339,
-      339,  339,  157,  163,  339,  170,  167,  339,  339,  173,
-      339,  286,  339,  339,  339,  339,  288,  305,  339,  192,
-      339,  204,  213,  339,  226,    0,    0,  339,   69,  339,
-      339,  339,  101,  339,  339,  339,  339,  339,  138,  339,
-      339,  339,  156,  339,  339,  172,  339,  339,  180,  181,
-      182,  339,  339,  339,  339,    0,    0,  339,  339,  339,
-      199,  104,  262,  129,  131,  133,  339,  339,  152,  339,
-      169,  275,  287,  339,  339,  339,  339,    0,    0,  339,
-
-      339,   82,  339,  339,  339,  339,  166,  188,  164,  339,
-      225,    0,  321,   65,  339,  339,  339,  141,  165,  339,
-      322,  339,  339,  339,  214,  179,  339,  339,  130,  132,
-        0
-    } ;
-
-static const YY_CHAR yy_ec[256] =
-    {   0,
-        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
-        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    2,    5,    6,    7,    1,    1,    8,    9,   10,
-       11,   12,   13,    1,   14,   15,   16,   17,   17,   18,
-       17,   17,   17,   17,   17,   17,   17,    1,    1,   19,
-       20,   21,    1,    1,   22,   23,   24,   25,   26,   27,
-       28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
-       38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
-       48,   49,   50,    1,   51,   52,   53,   54,   55,   56,
-
-       57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
-       67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
-       77,   78,   79,   80,   81,   82,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,   83,    1,    1,    1,
-       84,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,   85,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1
-    } ;
-
-static const YY_CHAR yy_meta[87] =
-    {   0,
-        1,    1,    2,    1,    1,    3,    1,    1,    4,    1,
-        1,    5,    1,    6,    6,    6,    6,    6,    1,    6,
-        1,    6,    6,    6,    6,    6,    6,    6,    6,    6,
-        6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
-        6,    6,    6,    6,    6,    6,    6,    1,    7,    1,
-        6,    1,    6,    6,    6,    6,    6,    6,    6,    6,
-        6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
-        6,    6,    6,    6,    6,    6,    6,    6,    1,    1,
-        1,    1,    1,    1,    1,    1
-    } ;
-
-static const flex_int16_t yy_base[1756] =
-    {   0,
-        0,    0,   86,    0,  171,  172,  173,  177,  181,  182,
-      226,    0, 1024, 3975,  185, 3975, 3975,    0, 1000,  173,
-      296,  353,  310,  304,  353,  416,  359,  354,  421,  436,
-      356,  467,  156,  290,  474,  473,  354,  483,  532,  275,
-      533,  579,  585,  540,  374,  631,    0,  938,  812,  757,
-     3975,  193, 3975,  194,  760,  711,  740,  697,  184,  314,
-      611,  713,  188,  679,  424,  479,  521,  615,  280,  644,
-      575,  284,  299,  628,  624,  636,  306,  637,  355,  343,
-      367,  678,  155,  613,  675, 3975, 3975,  202,  676,  668,
-        0,  411,  418,  475,    0, 3975,  633,  611,  473,  477,
-
-      492,  484,  207,    0,  608,  573,  690,  704,    0,  706,
-      199,  564, 3975,  763,  849,  720,  201,  531,  759,  525,
-      649,  524,  645,  551,  686,    0,  685,  703,  687,  756,
-      755,    0,  686,  690,    0,  727,  725,  758,  769,  771,
-      754,  760,  766,  781,  769,  782,  836,  769,  771,  774,
-      841,  851,  823,  852,  843,  833,  856,  855,  856,  853,
-      845,  853,  897,    0,  897,  855,    0,    0,  900,  901,
-      913,  859,  901,  910,  914,  931,  920,  934,  939,  940,
-      922,  925,  926,  936,  940,  968,  969,  960,  967,  982,
-      959,  958,  981,  971,  984, 1008,  992,  974, 1003,  993,
-
-      989, 1003, 1014, 1025, 1011, 1039, 1025,    0,    0, 1033,
-        0, 1037, 1026, 1034, 1044, 1047, 1031, 1047, 1035, 1037,
-     1056,  524, 3975,  489,  456,  432, 3975,  420, 3975,  417,
-     1087, 1099, 1093,  207, 1103,  316, 3975, 3975, 3975, 3975,
-     1059, 1061, 1060, 1095, 1088, 1092, 1088, 1093, 1103, 1101,
-     1090, 1100, 1095, 1099, 1101, 3975, 1110, 1095, 1104, 1097,
-     3975, 1101, 3975, 1105, 1121, 1106, 1115, 1116, 1144, 1126,
-     1138, 1140,  411, 1163, 1168, 1159, 3975,  401,  274, 3975,
-     3975,  444, 3975,  435,    0, 3975, 3975, 3975,    0, 3975,
-     1221, 1154, 1210, 1156, 1163, 1184,  451,  326,  559,  718,
-
-      392, 1177, 1307, 1178,  627, 1393, 1479, 1226, 1178,  722,
-      724, 1186, 1208, 1213, 1211, 1218, 1213, 1218, 1226, 1228,
-     1230, 1222, 1213, 1231, 1218, 1219, 1222, 1238, 1223, 1224,
-     1229, 1230, 1294,    0, 1277, 1280, 1305, 1288, 1302, 1307,
-     1293, 1300,    0, 1301, 1299, 1313, 1300, 1300, 1301, 1310,
-     1304, 1313, 1306, 1307, 1383, 1315,    0, 1316, 1319, 1343,
-     1383, 1371, 1392, 1393, 1389,    0, 1392, 1392, 1396, 1382,
-     1398, 1392, 1392, 1393, 1400, 1393, 1405, 1404, 1400, 1408,
-     1410, 1395, 1411, 1444,    0, 1450, 1461, 1544, 1464, 1473,
-     1476, 1477, 1598, 1478, 1464, 1468, 1481, 1467, 1484, 1477,
-
-     1472,    0,  390, 1490, 1491, 1483, 1476, 1477, 1495, 1518,
-     1494, 1488, 1533, 1540, 1520, 1575, 1534, 1548, 1537, 1556,
-     1561, 1571, 1570, 1572, 1581, 1589, 1594, 1598, 1606, 1609,
-     1596, 1607, 1610, 1607, 1619, 1602, 1611,    0, 1624, 1617,
-     1616, 1614, 1632, 1615, 1635, 1650, 1644, 1658, 1656, 1657,
-     1649, 1663, 1665, 1661, 1653,    0,    0, 1654,    0,    0,
-     1659, 3975,  295,  522,  291,  573,  735,  799, 1680, 1687,
-      849,  871, 1680, 1672, 1682, 1671, 1681, 1676, 1680, 1683,
-     1701, 1698, 1689, 1709, 1692, 1695, 1702, 1712, 1700, 1716,
-     1718, 1723, 1719, 1723, 3975, 1724, 1713, 1718, 1718, 1720,
-
-     1716, 1734, 1738, 1739, 1739, 1729, 1740, 1752,  583, 1033,
-     1752, 1758,    0, 1751, 1764, 1010, 3975,    0, 1763, 1764,
-     1180, 1186, 1762, 1762, 1774, 1762, 1782,  320, 1778, 1767,
-     1776, 1767, 1789, 1772, 1788,    0, 1789, 1795, 1785, 1779,
-     1779, 1782, 1803, 1796, 1801, 1796, 1794, 1816, 1805, 1827,
-     1828, 1818, 1831, 1813, 1835, 1823, 1839, 1831, 1842, 1827,
-        0, 1845, 1846, 1845, 1838, 1836, 1851, 1853, 1858,    0,
-     1840, 1841, 1853, 1848, 1852, 1863, 1868, 1854, 1872, 1875,
-     1864, 1864, 1885, 1877, 1877,    0, 1892, 1887, 1894, 1888,
-     1894, 1902, 1894, 1894, 1908,    0, 1900, 1912, 1912,    0,
-
-     1900, 1905, 1912, 1918, 1919, 1915, 1925, 1911, 1947, 1930,
-     1927, 1918, 1938, 1929, 1938, 1938, 1941, 1947, 1954, 1960,
-     1964, 1957, 1971, 1967, 1966, 1958, 1968, 1967,    0, 1973,
-        0, 1982, 1986, 1964, 1976, 1974, 1988, 1977, 1992, 1999,
-     2004, 2000, 2017, 2010, 2000, 2003, 2017, 2005, 2024, 2009,
-     2025, 2028, 2009, 2032, 2033, 2021, 2026, 2022, 2043, 2036,
-     2034, 2027, 2044, 2048, 2051, 2042, 2054, 2048, 2051, 2045,
-     2059, 2056, 2059, 2076, 2067, 2078, 2077,    0, 2077,    0,
-     2082, 2074, 2076, 2084, 2079,    0, 2086, 2082, 2102, 2084,
-     2087, 2103, 2103, 2094, 2102,    0, 3975, 1257, 1307, 3975,
-
-     2101, 2111, 2114, 2112, 2121, 2106, 2119, 2128, 2121, 2134,
-     2131, 2139, 2125, 2128, 2131, 2148, 2136, 2137, 2138, 2138,
-     2142, 2143, 2150, 2159, 2153, 2146, 2150, 2161, 3975, 2152,
-     2162, 2176, 1360, 2174, 3975, 2169,    0, 2172,    0,    0,
-     2165,    0, 2183, 2175,    0, 2177, 2189,    0, 2203, 2190,
-     2202, 2192, 2193, 2210,    0, 2211, 2210, 2215, 2204, 2214,
-     2208, 2218, 2225, 2209, 2230,    0, 2220, 2214, 2216, 2217,
-        0,    0, 2230,    0, 2221, 2226,    0, 2225, 2245, 2234,
-     2252, 2237, 2261, 2250,    0, 2249, 2254,    0, 2270, 2255,
-        0,    0, 2260, 2274, 2292, 2265, 2281,    0, 2285, 2265,
-
-        0, 2277, 2289, 2266, 2292, 2289, 2324,    0, 2284,    0,
-     2283, 2303, 2313, 2304, 2304, 2325, 2307, 2315, 2334, 2325,
-     2321, 2332, 2342, 2347, 2323, 2349, 2339, 2350, 2342, 2355,
-     2338,    0, 2335, 2360, 2343, 2350, 2369, 2359, 2355, 2375,
-     2355, 2382, 2376, 2386,    0, 2376,    0, 2390, 2383, 2376,
-     2377, 2384, 2382, 2398, 2390, 2388, 2408, 2392, 2397, 2394,
-     2398, 2402, 2398, 2403, 2404, 2413, 2420, 2424, 2422, 2413,
-     2433, 2445, 2428, 2425, 2441, 2438, 2445, 2435, 2439, 2438,
-        0,    0, 2471, 2441, 2441, 2449, 2461, 2465, 2457,    0,
-     2467, 2457, 2469, 2467,    0, 2479, 2480, 2473, 2466,    0,
-
-     2493, 2492, 2492, 2475,    0,    0, 2485, 2508, 2494, 2515,
-     2498, 2501,    0, 2516, 2503, 2505, 2520, 2518, 2523, 2526,
-     2515, 2525, 2526, 2518, 3975, 2535, 2535, 2540, 2541, 3975,
-     2524, 2543, 2541, 3975, 3975, 2552, 3975, 2546, 2548, 2551,
-     2556, 3975, 2548, 1446, 2567, 2570, 2560, 2562, 2562, 2559,
-     2572, 2567, 2563, 2573,    0, 2582,    0,    0, 2569,    0,
-     2572, 2574, 2577, 2596, 2588,    0, 2593,    0, 2583, 2586,
-     2591, 2588, 2596,    0, 2610, 2603, 2599, 2613,    0, 2618,
-        0, 2615, 2612,    0, 2609,    0, 2615, 2631, 2616, 2633,
-        0,    0, 2625, 2626, 2642, 2619, 2627,    0, 2642, 2638,
-
-     2650, 2648, 2649, 2652, 2656, 2642, 2663, 2650, 2646, 2676,
-     2662,    0,    0, 2664, 2657, 2670, 2661, 2665, 2667, 2669,
-     2671, 2669, 2689, 2692, 2682, 2690, 2698, 2701, 2690, 2687,
-        0, 2689,    0, 2696, 2694, 2695, 2698, 2699, 2698, 2719,
-     2714, 2722, 2724, 2713, 2712, 2723, 2738,    0,    0, 2736,
-      321, 2717, 2727, 2742, 2742, 2739, 2739, 2734,    0,    0,
-        0,    0, 2750, 2747, 2747, 2745, 2760, 2765, 2748, 2750,
-     2751, 2759, 2774, 2756,    0, 2766,    0, 2759, 2779, 2781,
-     2768, 2788, 2785, 2776, 2789, 2794, 2800,    0,    0, 2794,
-        0,    0, 2784, 2789, 2789, 2790, 2811, 2811, 2799, 2809,
-
-     2809, 2825, 2815, 2813, 2829, 2818, 2828, 2816,    0,    0,
-     3975, 3975, 2825, 2813, 2828, 2824, 2820, 2843, 2836, 2837,
-     3975, 2851, 2829, 2844, 2843, 2858, 2847, 3975, 2850, 2864,
-     2852, 2858, 2856, 3975, 2875, 2881,  273,    0, 2858, 2865,
-     2876, 2887, 2868, 2886, 2873, 2878, 2890, 2883, 2894,    0,
-     2886, 2885, 2887, 2903,    0, 2906,    0, 2902,    0, 2908,
-     2909, 2906,    0, 2905, 2925,    0, 2912, 2918, 2921, 2918,
-     2923, 2933, 2919, 2924, 2929,    0, 2935, 2935, 2943, 2945,
-        0, 2942, 2948, 2951, 2937, 2952, 2936, 2947, 2945, 2952,
-        0, 2955, 2965,    0, 2966, 2975, 2956, 2971, 2965, 2967,
-
-     2977, 2985,    0, 2985, 2983, 2988, 2996, 2994,    0, 2992,
-     3001, 2982, 2995, 2991, 3005,    0, 3003, 3001, 3007, 3011,
-     3005,    0, 3009,    0, 3003, 3026, 3008, 3012,    0, 3035,
-     3031,    0, 3024,    0, 3020, 3037, 3020, 3042, 3043, 3038,
-     3041, 3053, 3056, 3056, 3054, 3045, 3056, 3048, 3057, 3061,
-     3070, 3060, 3068, 3058, 3059, 3076, 3081, 3080, 3083, 3088,
-     3085,    0, 3096, 3082, 3083, 3099, 3102,    0,    0, 3093,
-     3104, 3105, 3975, 3099, 3975, 3975, 3105, 3100, 3975, 3105,
-     3103, 3116, 3975, 3123, 3118, 3109, 3108, 3125, 3129, 3975,
-     3132, 3131, 3975,    0, 3130, 3125, 3122, 3132, 3134,    0,
-
-     3130, 3135, 3134, 3149, 3156, 3161, 3164, 3158, 3170, 3155,
-        0, 3165, 3167, 3177, 3162, 3165, 3168, 3183,    0, 3174,
-     3185, 3183, 3187,    0, 3194, 3177, 3184,    0, 3185, 3183,
-     3194, 3190, 3192, 3189, 3190, 3189, 3197, 3204, 3198, 3199,
-     3214, 3213, 3231, 3215, 3230, 3241, 3239, 3222, 3244,    0,
-        0,    0, 3221, 3235, 3232, 3247, 3230, 3249, 3232, 3256,
-        0,    0, 3245, 3259, 3247, 3262, 3249, 3256, 3249,    0,
-     3263, 3252,    0, 3255, 3265,    0, 3265, 3271, 3274,    0,
-     3277, 3288, 3277, 3280,    0, 3285,    0, 3289, 3300,    0,
-     3294, 3281, 3301, 3292, 3299, 3312, 3294,    0,    0, 3291,
-
-        0, 3311, 3306, 3315,    0,    0,    0, 3307, 3309, 3975,
-     3322, 3975, 3975, 3975, 3300, 3307, 3313, 3975, 3316, 3332,
-     3975, 3336, 3337, 3325, 3327,    0, 3348,    0, 3342,    0,
-     3343,    0, 3356, 3344,    0, 3353,    0, 3348, 3355,    0,
-     3358, 3367, 3365, 3369,    0, 3358,    0,    0,    0, 3361,
-        0, 3359, 3374, 3363, 3379, 3384,    0, 3384, 3385, 3380,
-     3378, 3393, 3390, 3391, 3394, 3396, 3383, 3409,    0, 3395,
-     3409, 3408, 3401, 3418, 3421, 3424, 3410, 3430, 3428, 3426,
-     3416, 3428, 3424, 3434, 3420, 3431, 3440, 3433, 3442, 3444,
-     3438, 3448, 3446, 3442, 3456,    0,    0, 3443, 3439, 3449,
-
-     3452, 3458, 3458, 3471,    0,    0,    0, 3467,    0,    0,
-     3462,    0, 3471, 3472, 3486, 3487, 3488, 3476, 3477, 3478,
-     3975, 3489, 3480, 3480,    0, 3499, 3504,    0,    0,    0,
-     3491, 3499,    0,    0,    0, 3497, 3498,    0,    0, 3506,
-        0,    0,    0, 3499, 3519, 3520, 3507, 3526, 3510,    0,
-        0, 3530, 3519, 3532, 3529, 3544, 3533, 3544, 3544,    0,
-     3548, 3535, 3547, 3545, 3545, 3556, 3556, 3550, 3538,    0,
-     3555, 3552, 3548, 3569, 3554, 3554,    0, 3574,    0,    0,
-     3557,    0, 3580,    0,    0,    0, 3564,    0, 3578, 3573,
-     3569,    0, 3975, 3975, 3975, 3975, 3975, 3975, 3578, 3587,
-
-        0, 3585, 3582, 3587, 3584, 3595, 3597, 3597, 3597,    0,
-     3607, 3609, 3617, 3603, 3605,    0,    0,    0,    0, 3611,
-     3611, 3624,    0,    0, 3621,    0,    0, 3617, 3630,    0,
-     3631,    0, 3636, 3620, 3631, 3623,    0,    0, 3641,    0,
-     3631,    0, 3643, 3640,    0, 3642, 3633, 3646,    0, 3644,
-     3649, 3658,    0, 3660, 3652, 3674, 3676, 3664,    0, 3675,
-     3678, 3673,    0, 3661, 3675,    0, 3672, 3680,    0,    0,
-        0, 3685, 3691, 3692, 3678, 3673, 3702, 3686, 3696, 3701,
-        0,    0,    0, 3705, 3707,    0, 3687, 3708,    0, 3716,
-        0,    0,    0, 3721, 3722, 3719, 3715, 3730,  265, 3721,
-
-     3726,    0, 3738, 3740, 3741, 3742,    0,    0,    0, 3733,
-        0,  160, 3975,    0, 3735, 3736, 3739,    0,    0, 3741,
-     3975, 3736, 3741, 3745,    0,    0, 3748, 3749,    0,    0,
-     3975, 3814, 3821, 3828, 3835, 3842,  199, 3849, 3856, 3863,
-     3870, 3877, 3884, 3891, 3898, 3904, 3911, 3918, 3925, 3932,
-     3939, 3946, 3953, 3960, 3967
-    } ;
-
-static const flex_int16_t yy_def[1756] =
-    {   0,
-     1731,    1, 1731,    3, 1732, 1732, 1733, 1733, 1734, 1734,
-     1731,   11, 1731, 1731, 1731, 1731, 1731, 1735, 1736, 1731,
-     1737, 1738, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1739, 1740, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1741, 1742, 1731, 1731, 1731, 1731, 1731, 1743, 1744,
-     1745, 1731, 1731, 1731, 1746, 1731, 1731, 1737, 1737, 1737,
-
-     1737, 1737, 1731, 1735, 1736, 1736, 1731, 1731, 1737, 1737,
-     1737, 1747, 1731, 1748, 1749, 1731, 1731, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1739, 1731, 1740, 1740, 1731, 1731, 1750, 1731, 1751,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1741, 1741, 1741, 1741, 1731, 1742, 1752, 1731,
-     1731, 1743, 1731, 1744, 1745, 1731, 1731, 1731, 1746, 1731,
-     1753, 1737, 1737, 1737, 1737, 1731, 1731, 1731, 1737, 1737,
-
-     1747, 1731, 1748, 1737, 1754, 1749, 1753, 1731, 1731, 1731,
-     1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1731, 1750, 1750, 1751, 1751, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-
-     1731, 1731, 1731, 1731, 1731, 1741, 1741, 1741, 1752, 1752,
-      307, 1737, 1737, 1737, 1737, 1731, 1731, 1737, 1755,  307,
-     1731, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1731, 1731, 1731, 1731,
-
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1741, 1741, 1741, 1731, 1737, 1737, 1737, 1755, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1741, 1741, 1741, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1741, 1741, 1741, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1741, 1741, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1741, 1741, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1741, 1741, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1731, 1731, 1731, 1731, 1731, 1731, 1741, 1741,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1741, 1741, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1741, 1741, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1741, 1741, 1737,
-
-     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1737, 1741, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-     1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
-        0, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731
-    } ;
-
-static const flex_int16_t yy_nxt[4062] =
-    {   0,
-       14,   15,   16,   15,   14,   17,   18,   14,   17,   19,
-       14,   14,   14,   20,   21,   22,   23,   23,   14,   14,
-       14,   24,   25,   26,   27,   28,   29,   30,   31,   32,
-       33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
-       43,   44,   45,   46,   47,   47,   47,   48,   14,   14,
-       14,   14,   24,   25,   26,   27,   28,   29,   30,   31,
-       32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
-       42,   43,   44,   45,   46,   47,   47,   47,   49,   14,
-       14,   14,   14,   14,   50,   14,   51,   52,   53,   54,
-       55,   56,   51,   57,   58,   51,   51,   51,   51,   59,
-
-       60,   51,   61,   61,   62,   63,   64,   65,   66,   67,
-       68,   69,   70,   71,   51,   72,   73,   51,   74,   51,
-       75,   76,   51,   51,   77,   78,   79,   80,   51,   81,
-       51,   51,   51,   82,   51,   51,   51,   83,   65,   66,
-       67,   68,   69,   70,   71,   51,   72,   73,   51,   74,
-       51,   75,   76,   51,   51,   77,   78,   79,   80,   51,
-       81,   51,   51,   51,   51,   84,   51,   85,   51,   51,
-       51,   86,   88,   88,   88,   88,   89,   89,   92,   90,
-       90,   93,   92,   96,   96,   93,  103,  107,  103,  108,
-      108,  160,   97,   97,  103,  103,  103,  103,  231,  238,
-
-      232,  232,  279,  103,  109,  103,  280,  239,  103, 1721,
-      103,  298,  299,  310,  310,  300,  300,  311,  311,  467,
-      467,   94,  160,  468,  468,   94,   14,   15,   16,   15,
-       14,   17,   18,   14,   17,   14,   14,   14,   14,   14,
-       47,   98,   14,   14,   14,   14,   14,   47,   47,   99,
-       47,  100,   47,   47,   47,   47,   47,   47,   47,  101,
-       47,   47,  102,   47,   47,   47,   47,   47,   47,   47,
-       47,   47,   47,   14,   14,   14,   14,   14,   47,   47,
-       99,   47,  100,   47,   47,   47,   47,   47,   47,   47,
-      101,   47,   47,  102,   47,   47,   47,   47,   47,   47,
-
-       47,   47,   47,   47,   14,   14,   14,   14,   14,   14,
-       14,   14,  110,  110, 1713,  161,  188,  251,  257,  162,
-      258,  111, 1293,  510,  116,  280,  108,  108,  471,  471,
-      233,  233,  472,  472, 1223,  117,  118,  745,  119,  234,
-      466,  266,  516,  516,  464,  120,  161,  188,  251,  257,
-      162,  258,  111,  112,  112,  112,  112,  112,  112,  112,
-      112,  112,  112,  112,  113,  112,  117,  118,  115,  119,
-      234,  112,  266,  112,  121,  174,  120,  153,  122,  271,
-      134,  154,  123,  135,  136,  155,  138,  139,  140,  175,
-      269,  124,  141,  270,  125,  214,  272,  137,  142,  215,
-
-      112,  112,  112,  634,  112,  121,  174,  302,  153,  122,
-      271,  134,  154,  123,  135,  136,  155,  138,  139,  140,
-      175,  269,  124,  141,  270,  125,  214,  272,  137,  142,
-      215,  112,  112,  112,  112,  112,  112,  112,  112,  126,
-      286,  127,  143,  283,  128,  129,  144,  287,  130,  283,
-      145,  131,  280,  146,  132,  133,  147,  149,  241,  148,
-      277,  150,  242,  298,  298,  151,  466,  516,  516,  464,
-      126,  286,  127,  143,  152,  128,  129,  144,  287,  130,
-      288,  145,  131,  288,  146,  132,  133,  147,  149,  241,
-      148,  156,  150,  242,  169,  163,  151,  164,  170,  165,
-
-      157,  158,  171,  166,  243,  152,  167,  159,  292,  176,
-      177,  293,  168,  294,  172,  462,  295,  178,  173,  179,
-      244,  180,  156,  288,  181,  169,  163,  697,  164,  170,
-      165,  157,  158,  171,  166,  243,  225,  167,  159,  292,
-      176,  177,  293,  168,  294,  172,  245,  295,  178,  173,
-      179,  244,  180,  182,  189,  181,  246,  183,  190,  247,
-      312,  184,  191,  208,  185,  317,  320,  186,  192,  225,
-      187,  464,  209,  223,  210,  300,  300,  245,  211,  302,
-      212,  697,  213,  106,  182,  189,  323,  246,  183,  190,
-      247,  312,  184,  191,  208,  185,  317,  320,  186,  192,
-
-      255,  187,  193,  209,  194,  210,  202,  195,  196,  211,
-      203,  212,  197,  213,  204,  256,  198,  323,  106,  199,
-      205,  200,  466,  206,  201,  235,  291,  232,  232,  301,
-      207,  255,  510,  193,  280,  194,  236,  202,  195,  196,
-      248,  203,  519,  197,  249,  204,  256,  198,  290,  227,
-      199,  205,  200,  259,  206,  201,  216,  217,  250,  262,
-      218,  207,  219,  260,  220,  252,  267,  236,  261,  221,
-      268,  248,  318,  253,  263,  249,  283,  264,  265,  321,
-      227,  283,  254,  319,  259,  322,  281,  216,  217,  250,
-      262,  218,  263,  219,  260,  220,  252,  267,  240,  261,
-
-      221,  268,  274,  318,  253,  263,  296,  296,  264,  265,
-      321,  275,  324,  254,  319,  297,  322,  276,  116,  326,
-      108,  108,  110,  110,  327,  328,  325,  277,  334,  117,
-      335,  111,  237,  274,  300,  300,  308,  308,  311,  311,
-      311,  311,  275,  324,  230,  309,  297,  229,  276,  336,
-      326,  468,  468,  337,  338,  327,  328,  325,  228,  334,
-      117,  335,  111,  301,  301,  301,  301,  301,  301,  301,
-      301,  301,  301,  301,  301,  301,  309,  329,  304,  227,
-      336,  301,  313,  301,  337,  338,  314,  331,  332,  333,
-      339,  340,  344,  315,  342,  343,  345,  330,  347,  316,
-
-      346,  350,  348,  351,  356,  341,  349,  357,  329,  358,
-      301,  301,  301,  313,  301,  468,  468,  314,  331,  332,
-      333,  339,  340,  344,  315,  342,  343,  345,  330,  347,
-      316,  346,  350,  348,  351,  356,  341,  349,  357,  226,
-      358,  301,  301,  301,  301,  301,  301,  301,  301,  305,
-      305,  301,  305,  305,  305,  305,  305,  305,  305,  305,
-      305,  305,  359,  363,  307,  472,  472,  305,  352,  305,
-      353,  354,  360,  364,  355,  365,  366,  367,  368,  369,
-      361,  372,  373,  374,  370,  376,  362,  472,  472,  384,
-      375,  395,  225,  359,  363,  371,  305,  305,  305,  352,
-
-      305,  353,  354,  360,  364,  355,  365,  366,  367,  368,
-      369,  361,  372,  373,  374,  370,  376,  362,  381,  377,
-      384,  375,  395,  382,  383,  389,  371,  305,  305,  305,
-      305,  305,  305,  305,  305,  378,  385,  379,  386,  387,
-      396,  390,  380,  397,  388,  391,  392,  393,  399,  381,
-      377,  398,  400,  394,  382,  383,  389,  401,  402,  403,
-      404,  405,  406,  407,  409,  408,  378,  385,  379,  386,
-      387,  396,  390,  380,  397,  388,  391,  392,  393,  399,
-      410,  411,  398,  400,  394,  417,  426,  223,  401,  402,
-      403,  404,  405,  406,  407,  409,  408,  412,  415,  427,
-
-      413,  418,  428,  429,  416,  430,  419,  414,  420,  421,
-      106,  410,  411,  434,  422,  435,  417,  426,  423,  424,
-      438,  425,  439, 1731,  436,  440,  516,  516,  412,  415,
-      427,  413,  418,  428,  429,  416,  430,  419,  414,  420,
-      421,  431,  432,  446,  434,  422,  435,  441,  437,  423,
-      424,  438,  425,  439,  433,  436,  440,  443,  442,  444,
-      447,  450,  451,  452,  453,  445,  454,  455,  448,  456,
-      457,  458,  431,  432,  446,  459,  460,  461,  441,  437,
-      449, 1731,  510,  229,  735,  433,  473, 1731,  443,  442,
-      444,  447,  450,  451,  452,  453,  445,  454,  455,  448,
-
-      456,  457,  458,  233,  233,  474,  459,  460,  461,  233,
-      233,  449,  234,  235,  229,  232,  232,  473,  234,  469,
-      469,  475,  476,  479,  236,  477,  478,  480,  470,  481,
-      483,  484,  485,  486,  487,  488,  474,  492,  493,  489,
-      494,  495,  482,  234,  490,  496,  497,  498,  499,  234,
-      491,  500,  475,  476,  479,  236,  477,  478,  480,  470,
-      481,  483,  484,  485,  486,  487,  488,  503,  492,  493,
-      489,  494,  495,  482,  504,  490,  496,  497,  498,  499,
-      505,  491,  500,  501,  506,  502, 1731,  508,  512,  507,
-      521,  521,  514, 1731,  522,  522,  522,  522,  503, 1731,
-
-      296,  296,  522,  522,  515,  504,  517,  518,  277,  297,
-     1731,  505,  277,  523,  501,  506,  502,  277,  508,  512,
-      507,  104,  104,  514,  104,  104,  104,  104,  104,  104,
-      104,  104,  104,  104,  343,  515,  524,  517,  518,  104,
-      297,  104,  308,  308,  523,  525,  526,  527,  528,  529,
-      530,  309,  513,  531,  532,  533,  534,  535,  536,  537,
-      538,  539,  540,  541,  542,  343,  543,  524,  104,  104,
-      104, 1731,  104,  699,  699, 1731,  525,  526,  527,  528,
-      529,  530,  309,  513,  531,  532,  533,  534,  535,  536,
-      537,  538,  539,  540,  541,  542, 1731,  543,  547,  104,
-
-      104,  104,  104,  104,  104,  104,  104,  301,  301,  301,
-      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
-      544,  548,  304,  699,  699,  301,  549,  301,  545,  547,
-      551,  552,  553,  554,  546,  555,  556,  557,  558,  559,
-      560,  561,  562,  550,  564,  565,  566,  567,  570,  571,
-      563,  544,  548,  572,  301,  301,  301,  549,  301,  545,
-     1731,  551,  552,  553,  554,  546,  555,  556,  557,  558,
-      559,  560,  561,  562,  550,  564,  565,  566,  567,  570,
-      571,  563, 1731,  573,  572,  301,  301,  301,  301,  301,
-      301,  301,  301,  305,  305,  301,  305,  305,  305,  305,
-
-      305,  305,  305,  305,  305,  305,  568,  574,  307,  277,
-      945,  305,  575,  305,  573,  576,  569,  577,  578,  579,
-      580,  582,  583,  584,  581,  585,  586,  587,  590,  588,
-      591,  592,  593,  594,  595,  596,  597,  568,  574,  589,
-      305,  305,  305,  575,  305, 1731,  576,  569,  577,  578,
-      579,  580,  582,  583,  584,  581,  585,  586,  587,  590,
-      588,  591,  592,  593,  594,  595,  596,  597, 1731,  598,
-      589,  305,  305,  305,  305,  305,  305,  305,  305,  104,
-      104,  599,  104,  104,  104,  104,  104,  104,  104,  104,
-      104,  104,  600,  612,  613,  277, 1135,  104,  614,  104,
-
-      598,  615,  616,  626,  627,  628,  629,  630,  520,  631,
-      632,  633,  599,  635,  636,  637,  639,  640,  641,  638,
-     1731,  644,  645,  600,  612,  613,  104,  104,  104,  614,
-      104, 1731,  615,  616,  626,  627,  628,  629,  630,  520,
-      631,  632,  633,  642,  635,  636,  637,  639,  640,  641,
-      638,  643,  644,  645,  646,  650, 1731,  104,  104,  104,
-      104,  104,  104,  104,  104,  601,  602, 1731,  603,  648,
-      604,  605,  653,  606,  642,  654,  607,  655,  647,  608,
-      649,  656,  643,  609,  610,  646,  650,  611, 1731, 1731,
-      657, 1731,  658, 1731, 1731,  659,  601,  602,  651,  603,
-
-      648,  604,  605,  653,  606,  652,  654,  607,  655,  647,
-      608,  649,  656,  660,  609,  610,  661,  662,  611,  617,
-      618,  657,  619,  658,  620,  621,  659,  622,  663,  651,
-      664,  665,  668,  666,  669,  670,  652,  623,  624,  671,
-      672,  625,  673,  674,  660,  667,  675,  661,  662,  676,
-      617,  618,  677,  619,  678,  620,  621,  679,  622,  663,
-      680,  664,  665,  668,  666,  669,  670,  681,  623,  624,
-      671,  672,  625,  673,  674,  682,  667,  675,  683,  684,
-      676,  685,  686,  677,  687,  678,  691,  689,  679,  688,
-      692,  680,  690,  694,  695,  696,  469,  469,  681,  698,
-
-      698,  700,  693,  699,  699,  470,  682,  701,  702,  683,
-      684,  703,  685,  686,  704,  687,  705,  691,  689,  706,
-      688,  692,  707,  690,  694,  695,  696,  708,  709,  710,
-      711,  712,  700,  693,  713,  714,  470,  715,  701,  702,
-      716,  717,  703,  718,  719,  704,  720,  705,  721,  722,
-      706,  723,  724,  707,  725,  726,  727,  728,  708,  709,
-      710,  711,  712,  729,  730,  713,  714,  731,  715,  732,
-     1731,  716,  717,  734,  718,  719,  733,  720,  277,  721,
-      722,  511,  723,  724,  736,  725,  726,  727,  728,  277,
-      737,  738,  739,  511,  729,  730,  740,  741,  731,  742,
-
-      732,  277,  743,  744,  734,  746,  747,  733,  748,  749,
-      750,  751,  511,  752,  753,  736,  754,  756,  757,  758,
-      759,  737,  738,  739,  511,  762,  763,  740,  741,  760,
-      742,  764,  765,  743,  744,  755,  746,  747,  761,  748,
-      749,  750,  751,  766,  752,  753,  767,  754,  756,  757,
-      758,  759,  768,  769,  770,  771,  762,  763,  772,  773,
-      760,  774,  764,  765,  775,  776,  755,  777,  778,  761,
-      779,  780,  781,  782,  766,  783,  784,  767,  785,  786,
-      787,  788,  789,  768,  769,  770,  771,  790,  791,  772,
-      773,  792,  774,  793,  794,  775,  776,  795,  777,  778,
-
-      796,  779,  780,  781,  782,  797,  783,  784,  798,  785,
-      786,  787,  788,  789,  799,  800,  801,  802,  790,  791,
-      803,  806,  792,  804,  793,  794,  807,  808,  795,  809,
-      805,  796,  810,  811,  812,  813,  797,  815,  816,  798,
-      817,  818,  814,  819,  820,  799,  800,  801,  802,  821,
-      822,  803,  806,  823,  804,  827,  828,  807,  808,  829,
-      809,  805,  830,  810,  811,  812,  813,  831,  815,  816,
-      824,  817,  818,  814,  819,  820,  825,  832,  833,  834,
-      821,  822,  835,  836,  823,  837,  827,  828,  826,  838,
-      829,  839,  843,  830,  840,  844,  845,  846,  831,  847,
-
-      841,  824,  848,  849,  852,  853,  854,  825,  832,  833,
-      834,  850,  842,  835,  836,  851,  837,  855,  856,  826,
-      838,  857,  839,  843,  858,  840,  844,  845,  846,  859,
-      847,  841,  860,  848,  849,  852,  853,  854,  861,  862,
-      863,  864,  850,  842,  865,  866,  851,  869,  855,  856,
-      870,  867,  857,  871,  872,  858,  868,  873,  874,  875,
-      859,  876,  877,  860,  878,  879,  880,  881,  882,  861,
-      862,  863,  864,  883,  884,  865,  866,  885,  869,  886,
-      887,  870,  867,  888,  871,  872,  889,  868,  873,  874,
-      875,  890,  876,  877,  891,  878,  879,  880,  881,  882,
-
-      892,  893,  894,  895,  883,  884,  898,  900,  885,  896,
-      886,  887,  901,  897,  888,  902,  899,  889,  903,  904,
-      905,  906,  890,  907,  908,  891,  909,  910,  911,  912,
-      913,  892,  893,  894,  895,  914,  915,  898,  900,  916,
-      896,  917,  918,  901,  897,  919,  902,  899,  920,  903,
-      904,  905,  906,  921,  907,  908,  922,  909,  910,  911,
-      912,  913,  923,  924,  925,  926,  914,  915,  927,  928,
-      916,  929,  917,  918,  930,  931,  919,  932,  933,  920,
-      934,  935,  936,  937,  921,  938,  939,  922,  940,  941,
-      942,  943, 1731,  923,  924,  925,  926,  944,  947,  927,
-
-      928,  948,  929,  949,  950,  930,  931,  951,  932,  933,
-      946,  934,  935,  936,  937,  952,  938,  939,  953,  940,
-      941,  942,  943,  277,  954,  277,  955,  956,  944,  947,
-      957,  958,  948,  959,  949,  950,  960,  961,  951,  962,
-      963,  946,  964,  965,  966,  968,  952,  967,  969,  953,
-      970,  971,  972,  973,  974,  954,  975,  955,  956,  976,
-      977,  957,  958,  980,  959,  978,  979,  960,  961,  981,
-      962,  963,  982,  964,  965,  966,  968,  983,  967,  969,
-      984,  970,  971,  972,  973,  974,  985,  975,  986,  987,
-      976,  977,  988,  989,  980,  990,  978,  979,  991,  992,
-
-      981, 1731, 1731,  982,  998,  999, 1000, 1001,  983, 1002,
-     1003,  984, 1004, 1005, 1006,  993, 1731,  985, 1012,  986,
-      987, 1013, 1731,  988,  989,  994,  990, 1014,  995,  991,
-      992, 1731,  996,  997, 1015,  998,  999, 1000, 1001, 1016,
-     1002, 1003, 1017, 1004, 1005, 1006,  993, 1007, 1018, 1012,
-     1008, 1019, 1013, 1009, 1020, 1021,  994, 1010, 1014,  995,
-     1022, 1023, 1011,  996,  997, 1015, 1024, 1025, 1026, 1027,
-     1016, 1028, 1029, 1017, 1030, 1031, 1032, 1033, 1007, 1018,
-     1034, 1008, 1019, 1035, 1009, 1020, 1021, 1036, 1010, 1037,
-     1038, 1022, 1023, 1011, 1039, 1040, 1041, 1024, 1025, 1026,
-
-     1027, 1042, 1028, 1029, 1043, 1030, 1031, 1032, 1033, 1044,
-     1045, 1034, 1046, 1047, 1035, 1048, 1049, 1050, 1036, 1051,
-     1037, 1038, 1052, 1053, 1054, 1039, 1040, 1041, 1055, 1056,
-     1057, 1058, 1042, 1059, 1060, 1043, 1061, 1062, 1063, 1064,
-     1044, 1045, 1065, 1046, 1047, 1068, 1048, 1049, 1050, 1066,
-     1051, 1069, 1070, 1052, 1053, 1054, 1071, 1074, 1067, 1055,
-     1056, 1057, 1058, 1075, 1059, 1060, 1076, 1061, 1062, 1063,
-     1064, 1072, 1077, 1065, 1078, 1079, 1068, 1080, 1073, 1081,
-     1066, 1085, 1069, 1070, 1086, 1087, 1088, 1071, 1074, 1067,
-     1089, 1090, 1091, 1082, 1075, 1083, 1092, 1076, 1093, 1094,
-
-     1095, 1096, 1072, 1077, 1099, 1078, 1079, 1097, 1080, 1073,
-     1081, 1084, 1085, 1098, 1100, 1086, 1087, 1088, 1101, 1103,
-     1104, 1089, 1090, 1091, 1082, 1105, 1083, 1092, 1102, 1093,
-     1094, 1095, 1096, 1106, 1107, 1099, 1108, 1109, 1097, 1110,
-     1111, 1112, 1084, 1113, 1098, 1100, 1114, 1115, 1116, 1101,
-     1103, 1104, 1117, 1118, 1119, 1120, 1105, 1121, 1122, 1102,
-     1123, 1124, 1125, 1126, 1106, 1107, 1127, 1108, 1109, 1128,
-     1110, 1111, 1112, 1129, 1113, 1130, 1131, 1114, 1115, 1116,
-     1132, 1133, 1134, 1117, 1118, 1119, 1120, 1138, 1121, 1122,
-     1136, 1123, 1124, 1125, 1126, 1137, 1139, 1127, 1140, 1141,
-
-     1128, 1142, 1143, 1144, 1129, 1145, 1130, 1131, 1146, 1147,
-     1148, 1132, 1133, 1134, 1149, 1150,  277, 1151, 1138,  277,
-     1152, 1136, 1153, 1154, 1155, 1156, 1137, 1139, 1157, 1140,
-     1141, 1158, 1142, 1143, 1144, 1159, 1145, 1160, 1161, 1146,
-     1147, 1148, 1162, 1163, 1164, 1149, 1150, 1165, 1151, 1166,
-     1167, 1152, 1168, 1153, 1154, 1155, 1156, 1169, 1170, 1157,
-     1171, 1172, 1158, 1173, 1174, 1175, 1159, 1176, 1160, 1161,
-     1177, 1178, 1179, 1162, 1163, 1164, 1180, 1181, 1165, 1182,
-     1166, 1167, 1183, 1168, 1184, 1185, 1186, 1189, 1169, 1170,
-     1190, 1171, 1172, 1191, 1173, 1174, 1175, 1187, 1176, 1192,
-
-     1193, 1177, 1178, 1179, 1194, 1188, 1195, 1180, 1181, 1196,
-     1182, 1197, 1198, 1183, 1199, 1184, 1185, 1186, 1189, 1200,
-     1201, 1190, 1202, 1203, 1191, 1204, 1205, 1206, 1187, 1207,
-     1192, 1193, 1208, 1209, 1210, 1194, 1188, 1195, 1211, 1212,
-     1196, 1213, 1197, 1198, 1214, 1199, 1215, 1216, 1217, 1218,
-     1200, 1201, 1219, 1202, 1203, 1220, 1204, 1205, 1206, 1221,
-     1207, 1222, 1224, 1208, 1209, 1210, 1225, 1226, 1227, 1211,
-     1212, 1228, 1213, 1229, 1230, 1214, 1231, 1215, 1216, 1217,
-     1218, 1232, 1233, 1219, 1234, 1235, 1220, 1236, 1237, 1238,
-     1221, 1239, 1222, 1224, 1240, 1241, 1242, 1225, 1226, 1227,
-
-     1243, 1244, 1228, 1245, 1229, 1230, 1246, 1231, 1247, 1248,
-     1249, 1250, 1232, 1233, 1251, 1234, 1235, 1252, 1236, 1237,
-     1238, 1254, 1239, 1255, 1256, 1240, 1241, 1242, 1257, 1258,
-     1259, 1243, 1244, 1253, 1245, 1260, 1261, 1246, 1262, 1247,
-     1248, 1249, 1250, 1263, 1264, 1251, 1265, 1266, 1252, 1267,
-     1268, 1269, 1254, 1270, 1255, 1256, 1271, 1272, 1273, 1257,
-     1258, 1259, 1274, 1275, 1253, 1276, 1260, 1261, 1277, 1262,
-     1278, 1279, 1280, 1281, 1263, 1264, 1282, 1265, 1266, 1283,
-     1267, 1268, 1269, 1284, 1270, 1285, 1286, 1271, 1272, 1273,
-     1287, 1288, 1289, 1274, 1275, 1290, 1276, 1294, 1291, 1277,
-
-     1295, 1278, 1279, 1280, 1281, 1296, 1292, 1282, 1297, 1298,
-     1283, 1299, 1300, 1301, 1284, 1302, 1285, 1286, 1303, 1304,
-     1305, 1287, 1288, 1289,  277, 1306, 1290, 1307, 1294, 1291,
-      277, 1295, 1308, 1309, 1310, 1311, 1296, 1292, 1312, 1297,
-     1298, 1313, 1299, 1300, 1301, 1314, 1302, 1315, 1316, 1303,
-     1304, 1305, 1317, 1318, 1319, 1320, 1306, 1321, 1307, 1322,
-     1323, 1324, 1325, 1308, 1309, 1310, 1311, 1326, 1327, 1312,
-     1328, 1329, 1313, 1330, 1331, 1332, 1314, 1333, 1315, 1316,
-     1334, 1335, 1336, 1317, 1318, 1319, 1320, 1337, 1321, 1338,
-     1322, 1323, 1324, 1325, 1339, 1340, 1341, 1342, 1326, 1327,
-
-     1343, 1328, 1329, 1344, 1330, 1331, 1332, 1345, 1333, 1346,
-     1347, 1334, 1335, 1336, 1348, 1349, 1350, 1351, 1337, 1352,
-     1338, 1353, 1354, 1355, 1356, 1339, 1340, 1341, 1342, 1357,
-     1358, 1343, 1359, 1360, 1344, 1361, 1362, 1363, 1345, 1366,
-     1346, 1347, 1364, 1369, 1365, 1348, 1349, 1350, 1351, 1367,
-     1352, 1370, 1353, 1354, 1355, 1356, 1371, 1372, 1373, 1374,
-     1357, 1358, 1375, 1359, 1360, 1376, 1361, 1362, 1363, 1368,
-     1366, 1377, 1378, 1364, 1369, 1365, 1379, 1380, 1381, 1382,
-     1367, 1383, 1370, 1384, 1385, 1386, 1387, 1371, 1372, 1373,
-     1374, 1388, 1389, 1375, 1390, 1391, 1376, 1392, 1393, 1394,
-
-     1368, 1395, 1377, 1378, 1396, 1398, 1397, 1379, 1380, 1381,
-     1382, 1399, 1383, 1400, 1384, 1385, 1386, 1387, 1401, 1402,
-     1403, 1404, 1388, 1389, 1405, 1390, 1391, 1406, 1392, 1393,
-     1394, 1407, 1395, 1408, 1409, 1396, 1398, 1397, 1410, 1411,
-     1412, 1413, 1399, 1414, 1400, 1415, 1416, 1417, 1418, 1401,
-     1402, 1403, 1404, 1419, 1420, 1405, 1421, 1422, 1406, 1424,
-     1425, 1426, 1407, 1423, 1408, 1409, 1427, 1428, 1429, 1410,
-     1411, 1412, 1413, 1430, 1414, 1431, 1415, 1416, 1417, 1418,
-      277,  277, 1432, 1433, 1419, 1420, 1434, 1421, 1422, 1435,
-     1424, 1425, 1426, 1436, 1423, 1437, 1438, 1427, 1428, 1429,
-
-     1439, 1440, 1441, 1442, 1430, 1443, 1431, 1444, 1445, 1446,
-     1447, 1448, 1449, 1432, 1433, 1450, 1451, 1434, 1452, 1453,
-     1435, 1454, 1455, 1456, 1436, 1457, 1437, 1438, 1458, 1459,
-     1460, 1439, 1440, 1441, 1442, 1461, 1443, 1462, 1444, 1445,
-     1446, 1447, 1448, 1449, 1463, 1464, 1450, 1451, 1465, 1452,
-     1453, 1466, 1454, 1455, 1456, 1467, 1457, 1468, 1469, 1458,
-     1459, 1460, 1470, 1471, 1472, 1473, 1461, 1474, 1462, 1475,
-     1476, 1477, 1478, 1479, 1480, 1463, 1464, 1481, 1482, 1465,
-     1483, 1484, 1466, 1485, 1486, 1487, 1467, 1488, 1468, 1469,
-     1489, 1490, 1491, 1470, 1471, 1472, 1473, 1492, 1474, 1493,
-
-     1475, 1476, 1477, 1478, 1479, 1480, 1494, 1495, 1481, 1482,
-     1496, 1483, 1484, 1497, 1485, 1486, 1487, 1498, 1488, 1499,
-     1500, 1489, 1490, 1491, 1501, 1502, 1503, 1504, 1492, 1505,
-     1493, 1506, 1507, 1508, 1509, 1510, 1511, 1494, 1495, 1512,
-     1513, 1496, 1514, 1515, 1497, 1516, 1517, 1518, 1498, 1519,
-     1499, 1500, 1520, 1521, 1731, 1501, 1502, 1503, 1504, 1524,
-     1505, 1525, 1506, 1507, 1508, 1509, 1510, 1511, 1522, 1523,
-     1512, 1513, 1526, 1514, 1515, 1527, 1516, 1517, 1518, 1528,
-     1519, 1529, 1530, 1520, 1521,  277,  277, 1531, 1532, 1533,
-     1524, 1534, 1525, 1535, 1536, 1537, 1538, 1539, 1540, 1522,
-
-     1523, 1541, 1542, 1526, 1543, 1544, 1527, 1545, 1546, 1547,
-     1528, 1548, 1529, 1530, 1549, 1550, 1551, 1552, 1531, 1532,
-     1533, 1553, 1534, 1554, 1535, 1536, 1537, 1538, 1539, 1540,
-     1555, 1556, 1541, 1542, 1557, 1543, 1544, 1558, 1545, 1546,
-     1547, 1559, 1548, 1560, 1561, 1549, 1550, 1551, 1552, 1562,
-     1563, 1564, 1553, 1565, 1554, 1566, 1567, 1568, 1569, 1570,
-     1571, 1555, 1556, 1572, 1573, 1557, 1574, 1575, 1558, 1576,
-     1577, 1578, 1559, 1579, 1560, 1561, 1580, 1581, 1582, 1583,
-     1562, 1563, 1564, 1584, 1565, 1585, 1566, 1567, 1568, 1569,
-     1570, 1571, 1586, 1587, 1572, 1573, 1588, 1574, 1575, 1589,
-
-     1576, 1577, 1578, 1590, 1579, 1591, 1592, 1580, 1581, 1582,
-     1583, 1593, 1594, 1595, 1584, 1596, 1585, 1597, 1598, 1600,
-     1601, 1599, 1602, 1586, 1587, 1603, 1604, 1588, 1606,  277,
-     1589, 1605, 1607, 1608, 1590, 1609, 1591, 1592,  277, 1610,
-     1611, 1612, 1593, 1594, 1595, 1613, 1596, 1614, 1597, 1598,
-     1600, 1601, 1599, 1602, 1615, 1616, 1603, 1604, 1617, 1606,
-     1618, 1619, 1605, 1607, 1608, 1620, 1609, 1621, 1622, 1623,
-     1610, 1611, 1612, 1624, 1625, 1626, 1613, 1627, 1614, 1628,
-     1629, 1630, 1631, 1632, 1633, 1615, 1616, 1634, 1635, 1617,
-     1636, 1618, 1619, 1637, 1638, 1639, 1620, 1640, 1621, 1622,
-
-     1623, 1641, 1642, 1643, 1624, 1625, 1626, 1644, 1627, 1645,
-     1628, 1629, 1630, 1631, 1632, 1633, 1647, 1646, 1634, 1635,
-     1648, 1636, 1649, 1650, 1637, 1638, 1639,  277, 1640, 1651,
-     1652, 1653, 1641, 1642, 1643, 1654,  277, 1655, 1644, 1656,
-     1645, 1657, 1658, 1659, 1660, 1661, 1662, 1647, 1646, 1663,
-     1664, 1648, 1665, 1649, 1650, 1666, 1667, 1668, 1669, 1670,
-     1651, 1652, 1653, 1671, 1672, 1673, 1654, 1674, 1655, 1675,
-     1656, 1676, 1657, 1658, 1659, 1660, 1661, 1662, 1678, 1677,
-     1663, 1664,  277, 1665, 1679, 1680, 1666, 1667, 1668, 1669,
-     1670,  277, 1681, 1682, 1671, 1672, 1673, 1683, 1674, 1684,
-
-     1675, 1685, 1676, 1686, 1687, 1688, 1689, 1690, 1691, 1678,
-     1677, 1692, 1693, 1694, 1695, 1679, 1680, 1696, 1697, 1698,
-     1731, 1700,  277, 1681, 1682, 1701, 1702, 1699, 1683, 1703,
-     1684, 1704, 1685, 1705, 1686, 1687, 1688, 1689, 1690, 1691,
-     1706, 1707, 1692, 1693, 1694, 1695, 1708, 1709, 1696, 1697,
-     1698,  277, 1700, 1710, 1711, 1712, 1701, 1702, 1699, 1714,
-     1703, 1715, 1704, 1716, 1705, 1717, 1718, 1719, 1720, 1722,
-     1723, 1706, 1707, 1724, 1725, 1726, 1727, 1708, 1709,  277,
-     1728, 1729, 1730, 1731, 1710, 1711, 1712, 1731, 1731, 1731,
-     1714, 1731, 1715, 1731, 1716, 1731, 1717, 1718, 1719, 1720,
-
-     1722, 1723, 1731, 1731, 1724, 1725, 1726, 1727, 1731, 1731,
-     1731, 1728, 1729, 1730,   87,   87,   87,   87,   87,   87,
-       87,   91,   91,   91,   91,   91,   91,   91,   95,   95,
-       95,   95,   95,   95,   95,  104, 1731,  104,  104,  104,
-      104,  104,  105, 1731,  105,  105,  105,  105,  105,  114,
-      114,  114,  114,  114,  114,  114,  222,  222,  222,  222,
-      222,  222,  222,  224, 1731,  224,  224,  224,  224,  224,
-      273,  273,  273,  273,  273,  273,  273,  278,  278,  278,
-      278,  278,  278,  278,  282,  282,  282,  282,  282,  282,
-      282,  284,  284,  284,  284,  284,  284,  284,  285,  285,
-
-     1731, 1731,  285,  285,  289, 1731,  289,  289, 1731,  289,
-      289,  301,  301,  301,  301,  301,  301,  301,  303,  303,
-      303,  303,  303,  303,  303,  306,  306,  306,  306,  306,
-      306,  306,  463,  463, 1731,  463,  463,  463,  463,  465,
-      465,  465, 1731,  465,  465,  465,  509,  509,  509,  509,
-      509,  509,  509,  511, 1731,  511,  511,  511,  511,  511,
-      305,  305,  305,  305,  305,  305,  305,  104, 1731,  104,
-      104,  104,  104,  104,   13, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731
-    } ;
-
-static const flex_int16_t yy_chk[4062] =
-    {   0,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    1,    3,    3,    3,    3,
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
-        3,    3,    5,    6,    5,    6,    5,    6,    7,    5,
-        6,    7,    8,    9,   10,    8,   15,   20,   15,   20,
-       20,   33,    9,   10,   52,   54,   52,   54,   59,   63,
-
-       59,   59,   83,   88, 1737,   88,   83,   63,  103, 1712,
-      103,  111,  111,  117,  117,  111,  111,  117,  117,  234,
-      234,    7,   33,  234,  234,    8,   11,   11,   11,   11,
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-
-       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
-       11,   11,   21,   21, 1699,   34,   40,   69,   72,   34,
-       73,   21, 1137,  279,   23,  279,   23,   23,  236,  236,
-       60,   60,  236,  236, 1051,   23,   24,  528,   24,   60,
-      465,   77,  298,  298,  463,   24,   34,   40,   69,   72,
-       34,   73,   21,   22,   22,   22,   22,   22,   22,   22,
-       22,   22,   22,   22,   22,   22,   23,   24,   22,   24,
-       60,   22,   77,   22,   25,   37,   24,   31,   25,   80,
-       27,   31,   25,   27,   27,   31,   28,   28,   28,   37,
-       79,   25,   28,   79,   25,   45,   81,   27,   28,   45,
-
-       22,   22,   22,  403,   22,   25,   37,  301,   31,   25,
-       80,   27,   31,   25,   27,   27,   31,   28,   28,   28,
-       37,   79,   25,   28,   79,   25,   45,   81,   27,   28,
-       45,   22,   22,   22,   22,   22,   22,   22,   22,   26,
-       92,   26,   29,  284,   26,   26,   29,   93,   26,  282,
-       29,   26,  278,   29,   26,   26,   29,   30,   65,   29,
-      273,   30,   65,  297,  297,   30,  230,  297,  297,  228,
-       26,   92,   26,   29,   30,   26,   26,   29,   93,   26,
-       94,   29,   26,   94,   29,   26,   26,   29,   30,   65,
-       29,   32,   30,   65,   36,   35,   30,   35,   36,   35,
-
-       32,   32,   36,   35,   66,   30,   35,   32,   99,   38,
-       38,  100,   35,  101,   36,  226,  102,   38,   36,   38,
-       66,   38,   32,   94,   38,   36,   35,  464,   35,   36,
-       35,   32,   32,   36,   35,   66,  225,   35,   32,   99,
-       38,   38,  100,   35,  101,   36,   67,  102,   38,   36,
-       38,   66,   38,   39,   41,   38,   67,   39,   41,   67,
-      118,   39,   41,   44,   39,  120,  122,   39,   41,  224,
-       39,  464,   44,  222,   44,  299,  299,   67,   44,  112,
-       44,  466,   44,  106,   39,   41,  124,   67,   39,   41,
-       67,  118,   39,   41,   44,   39,  120,  122,   39,   41,
-
-       71,   39,   42,   44,   42,   44,   43,   42,   42,   44,
-       43,   44,   42,   44,   43,   71,   42,  124,  105,   42,
-       43,   42,  466,   43,   42,   61,   98,   61,   61,  305,
-       43,   71,  509,   42,  509,   42,   61,   43,   42,   42,
-       68,   43,  305,   42,   68,   43,   71,   42,   97,   75,
-       42,   43,   42,   74,   43,   42,   46,   46,   68,   75,
-       46,   43,   46,   74,   46,   70,   78,   61,   74,   46,
-       78,   68,  121,   70,   76,   68,   90,   76,   76,  123,
-       75,   89,   70,  121,   74,  123,   85,   46,   46,   68,
-       75,   46,   84,   46,   74,   46,   70,   78,   64,   74,
-
-       46,   78,   82,  121,   70,   76,  107,  107,   76,   76,
-      123,   82,  125,   70,  121,  107,  123,   82,  108,  127,
-      108,  108,  110,  110,  128,  129,  125,   82,  133,  108,
-      134,  110,   62,   82,  300,  300,  116,  116,  310,  310,
-      311,  311,   82,  125,   58,  116,  107,   57,   82,  136,
-      127,  467,  467,  136,  137,  128,  129,  125,   56,  133,
-      108,  134,  110,  114,  114,  114,  114,  114,  114,  114,
-      114,  114,  114,  114,  114,  114,  116,  130,  114,   55,
-      136,  114,  119,  114,  136,  137,  119,  131,  131,  131,
-      138,  139,  141,  119,  140,  140,  142,  130,  143,  119,
-
-      142,  145,  144,  146,  148,  139,  144,  149,  130,  150,
-      114,  114,  114,  119,  114,  468,  468,  119,  131,  131,
-      131,  138,  139,  141,  119,  140,  140,  142,  130,  143,
-      119,  142,  145,  144,  146,  148,  139,  144,  149,   50,
-      150,  114,  114,  114,  114,  114,  114,  114,  114,  115,
-      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
-      115,  115,  151,  153,  115,  471,  471,  115,  147,  115,
-      147,  147,  152,  154,  147,  155,  156,  157,  158,  158,
-      152,  159,  160,  161,  158,  162,  152,  472,  472,  166,
-      161,  172,   49,  151,  153,  158,  115,  115,  115,  147,
-
-      115,  147,  147,  152,  154,  147,  155,  156,  157,  158,
-      158,  152,  159,  160,  161,  158,  162,  152,  165,  163,
-      166,  161,  172,  165,  165,  170,  158,  115,  115,  115,
-      115,  115,  115,  115,  115,  163,  169,  163,  169,  169,
-      173,  170,  163,  174,  169,  171,  171,  171,  175,  165,
-      163,  174,  175,  171,  165,  165,  170,  176,  177,  178,
-      179,  180,  181,  182,  183,  182,  163,  169,  163,  169,
-      169,  173,  170,  163,  174,  169,  171,  171,  171,  175,
-      184,  185,  174,  175,  171,  188,  191,   48,  176,  177,
-      178,  179,  180,  181,  182,  183,  182,  186,  187,  192,
-
-      186,  189,  193,  194,  187,  195,  189,  186,  190,  190,
-       19,  184,  185,  197,  190,  198,  188,  191,  190,  190,
-      200,  190,  201,   13,  199,  202,  516,  516,  186,  187,
-      192,  186,  189,  193,  194,  187,  195,  189,  186,  190,
-      190,  196,  196,  205,  197,  190,  198,  203,  199,  190,
-      190,  200,  190,  201,  196,  199,  202,  204,  203,  204,
-      206,  207,  210,  212,  213,  204,  214,  215,  206,  216,
-      217,  218,  196,  196,  205,  219,  220,  221,  203,  199,
-      206,    0,  510,  241,  510,  196,  242,    0,  204,  203,
-      204,  206,  207,  210,  212,  213,  204,  214,  215,  206,
-
-      216,  217,  218,  231,  231,  243,  219,  220,  221,  233,
-      233,  206,  231,  232,  241,  232,  232,  242,  233,  235,
-      235,  244,  245,  247,  232,  246,  246,  248,  235,  249,
-      250,  251,  252,  253,  254,  255,  243,  258,  259,  257,
-      260,  262,  249,  231,  257,  264,  265,  266,  267,  233,
-      257,  268,  244,  245,  247,  232,  246,  246,  248,  235,
-      249,  250,  251,  252,  253,  254,  255,  270,  258,  259,
-      257,  260,  262,  249,  271,  257,  264,  265,  266,  267,
-      272,  257,  268,  269,  274,  269,    0,  276,  292,  275,
-      309,  309,  294,    0,  309,  309,  521,  521,  270,    0,
-
-      296,  296,  522,  522,  295,  271,  302,  304,  276,  296,
-        0,  272,  274,  312,  269,  274,  269,  275,  276,  292,
-      275,  291,  291,  294,  291,  291,  291,  291,  291,  291,
-      291,  291,  291,  291,  293,  295,  313,  302,  304,  291,
-      296,  291,  308,  308,  312,  314,  315,  316,  317,  318,
-      319,  308,  293,  320,  321,  322,  323,  324,  325,  326,
-      327,  328,  329,  330,  331,  293,  332,  313,  291,  291,
-      291,    0,  291,  698,  698,    0,  314,  315,  316,  317,
-      318,  319,  308,  293,  320,  321,  322,  323,  324,  325,
-      326,  327,  328,  329,  330,  331,    0,  332,  335,  291,
-
-      291,  291,  291,  291,  291,  291,  291,  303,  303,  303,
-      303,  303,  303,  303,  303,  303,  303,  303,  303,  303,
-      333,  336,  303,  699,  699,  303,  337,  303,  333,  335,
-      338,  339,  340,  341,  333,  342,  344,  345,  346,  347,
-      348,  349,  350,  337,  351,  352,  353,  354,  356,  358,
-      350,  333,  336,  359,  303,  303,  303,  337,  303,  333,
-        0,  338,  339,  340,  341,  333,  342,  344,  345,  346,
-      347,  348,  349,  350,  337,  351,  352,  353,  354,  356,
-      358,  350,    0,  360,  359,  303,  303,  303,  303,  303,
-      303,  303,  303,  306,  306,  306,  306,  306,  306,  306,
-
-      306,  306,  306,  306,  306,  306,  355,  361,  306,  733,
-      733,  306,  362,  306,  360,  363,  355,  364,  365,  367,
-      368,  369,  370,  371,  368,  372,  373,  374,  376,  375,
-      377,  378,  379,  380,  381,  382,  383,  355,  361,  375,
-      306,  306,  306,  362,  306,    0,  363,  355,  364,  365,
-      367,  368,  369,  370,  371,  368,  372,  373,  374,  376,
-      375,  377,  378,  379,  380,  381,  382,  383,    0,  384,
-      375,  306,  306,  306,  306,  306,  306,  306,  306,  307,
-      307,  386,  307,  307,  307,  307,  307,  307,  307,  307,
-      307,  307,  387,  389,  390,  944,  944,  307,  390,  307,
-
-      384,  391,  392,  394,  395,  396,  397,  398,  307,  399,
-      400,  401,  386,  404,  405,  406,  407,  408,  409,  406,
-        0,  411,  412,  387,  389,  390,  307,  307,  307,  390,
-      307,    0,  391,  392,  394,  395,  396,  397,  398,  307,
-      399,  400,  401,  410,  404,  405,  406,  407,  408,  409,
-      406,  410,  411,  412,  413,  415,    0,  307,  307,  307,
-      307,  307,  307,  307,  307,  388,  388,    0,  388,  414,
-      388,  388,  417,  388,  410,  418,  388,  419,  413,  388,
-      414,  420,  410,  388,  388,  413,  415,  388,    0,    0,
-      421,    0,  422,    0,    0,  423,  388,  388,  416,  388,
-
-      414,  388,  388,  417,  388,  416,  418,  388,  419,  413,
-      388,  414,  420,  424,  388,  388,  425,  426,  388,  393,
-      393,  421,  393,  422,  393,  393,  423,  393,  427,  416,
-      428,  429,  431,  430,  432,  433,  416,  393,  393,  434,
-      435,  393,  436,  437,  424,  430,  439,  425,  426,  440,
-      393,  393,  441,  393,  442,  393,  393,  443,  393,  427,
-      444,  428,  429,  431,  430,  432,  433,  445,  393,  393,
-      434,  435,  393,  436,  437,  446,  430,  439,  447,  448,
-      440,  449,  450,  441,  451,  442,  453,  452,  443,  451,
-      454,  444,  452,  455,  458,  461,  469,  469,  445,  470,
-
-      470,  473,  454,  470,  470,  469,  446,  474,  475,  447,
-      448,  476,  449,  450,  477,  451,  478,  453,  452,  479,
-      451,  454,  480,  452,  455,  458,  461,  481,  482,  483,
-      484,  485,  473,  454,  486,  487,  469,  488,  474,  475,
-      489,  490,  476,  491,  492,  477,  493,  478,  494,  496,
-      479,  497,  498,  480,  499,  500,  501,  502,  481,  482,
-      483,  484,  485,  503,  504,  486,  487,  505,  488,  506,
-        0,  489,  490,  508,  491,  492,  507,  493,  506,  494,
-      496,  511,  497,  498,  512,  499,  500,  501,  502,  507,
-      514,  515,  519,  520,  503,  504,  523,  524,  505,  525,
-
-      506,  508,  526,  527,  508,  529,  530,  507,  531,  532,
-      533,  534,  511,  535,  537,  512,  538,  539,  540,  541,
-      542,  514,  515,  519,  520,  544,  545,  523,  524,  543,
-      525,  546,  547,  526,  527,  538,  529,  530,  543,  531,
-      532,  533,  534,  548,  535,  537,  549,  538,  539,  540,
-      541,  542,  550,  551,  552,  553,  544,  545,  554,  555,
-      543,  556,  546,  547,  557,  558,  538,  559,  560,  543,
-      562,  563,  564,  565,  548,  566,  567,  549,  568,  569,
-      571,  572,  573,  550,  551,  552,  553,  574,  575,  554,
-      555,  576,  556,  577,  578,  557,  558,  579,  559,  560,
-
-      580,  562,  563,  564,  565,  581,  566,  567,  582,  568,
-      569,  571,  572,  573,  583,  584,  585,  587,  574,  575,
-      588,  590,  576,  589,  577,  578,  591,  592,  579,  593,
-      589,  580,  594,  595,  597,  598,  581,  599,  601,  582,
-      602,  603,  598,  604,  605,  583,  584,  585,  587,  606,
-      607,  588,  590,  608,  589,  610,  611,  591,  592,  612,
-      593,  589,  613,  594,  595,  597,  598,  614,  599,  601,
-      609,  602,  603,  598,  604,  605,  609,  615,  616,  617,
-      606,  607,  618,  619,  608,  620,  610,  611,  609,  621,
-      612,  622,  624,  613,  623,  625,  626,  627,  614,  628,
-
-      623,  609,  630,  632,  634,  635,  636,  609,  615,  616,
-      617,  633,  623,  618,  619,  633,  620,  637,  638,  609,
-      621,  639,  622,  624,  640,  623,  625,  626,  627,  641,
-      628,  623,  642,  630,  632,  634,  635,  636,  643,  644,
-      645,  646,  633,  623,  647,  648,  633,  650,  637,  638,
-      651,  649,  639,  652,  653,  640,  649,  654,  655,  656,
-      641,  657,  658,  642,  659,  660,  661,  662,  663,  643,
-      644,  645,  646,  664,  665,  647,  648,  666,  650,  667,
-      668,  651,  649,  669,  652,  653,  670,  649,  654,  655,
-      656,  671,  657,  658,  672,  659,  660,  661,  662,  663,
-
-      673,  674,  675,  676,  664,  665,  679,  681,  666,  677,
-      667,  668,  682,  677,  669,  683,  679,  670,  684,  685,
-      687,  688,  671,  689,  690,  672,  691,  692,  693,  694,
-      695,  673,  674,  675,  676,  701,  702,  679,  681,  703,
-      677,  704,  705,  682,  677,  706,  683,  679,  707,  684,
-      685,  687,  688,  708,  689,  690,  709,  691,  692,  693,
-      694,  695,  710,  711,  712,  713,  701,  702,  714,  715,
-      703,  716,  704,  705,  717,  718,  706,  719,  720,  707,
-      721,  722,  723,  724,  708,  725,  726,  709,  727,  728,
-      730,  731,    0,  710,  711,  712,  713,  732,  736,  714,
-
-      715,  738,  716,  741,  743,  717,  718,  744,  719,  720,
-      734,  721,  722,  723,  724,  746,  725,  726,  747,  727,
-      728,  730,  731,  734,  749,  732,  750,  751,  732,  736,
-      752,  753,  738,  754,  741,  743,  756,  757,  744,  757,
-      758,  734,  759,  760,  761,  762,  746,  761,  763,  747,
-      764,  765,  767,  768,  769,  749,  770,  750,  751,  773,
-      775,  752,  753,  778,  754,  776,  776,  756,  757,  779,
-      757,  758,  780,  759,  760,  761,  762,  781,  761,  763,
-      782,  764,  765,  767,  768,  769,  783,  770,  784,  786,
-      773,  775,  787,  789,  778,  790,  776,  776,  793,  794,
-
-      779,    0,    0,  780,  796,  797,  799,  800,  781,  802,
-      803,  782,  804,  805,  806,  795,    0,  783,  809,  784,
-      786,  811,    0,  787,  789,  795,  790,  812,  795,  793,
-      794,    0,  795,  795,  813,  796,  797,  799,  800,  814,
-      802,  803,  815,  804,  805,  806,  795,  807,  816,  809,
-      807,  817,  811,  807,  818,  819,  795,  807,  812,  795,
-      820,  821,  807,  795,  795,  813,  822,  823,  824,  825,
-      814,  826,  827,  815,  828,  829,  830,  831,  807,  816,
-      833,  807,  817,  834,  807,  818,  819,  835,  807,  836,
-      837,  820,  821,  807,  838,  839,  840,  822,  823,  824,
-
-      825,  841,  826,  827,  842,  828,  829,  830,  831,  843,
-      844,  833,  846,  848,  834,  849,  850,  851,  835,  852,
-      836,  837,  853,  854,  855,  838,  839,  840,  856,  857,
-      858,  859,  841,  860,  861,  842,  862,  863,  864,  865,
-      843,  844,  866,  846,  848,  868,  849,  850,  851,  867,
-      852,  869,  870,  853,  854,  855,  871,  873,  867,  856,
-      857,  858,  859,  874,  860,  861,  875,  862,  863,  864,
-      865,  872,  876,  866,  877,  878,  868,  879,  872,  880,
-      867,  884,  869,  870,  885,  886,  887,  871,  873,  867,
-      888,  889,  891,  883,  874,  883,  892,  875,  893,  894,
-
-      896,  897,  872,  876,  899,  877,  878,  898,  879,  872,
-      880,  883,  884,  898,  901,  885,  886,  887,  902,  903,
-      904,  888,  889,  891,  883,  907,  883,  892,  902,  893,
-      894,  896,  897,  908,  909,  899,  910,  911,  898,  912,
-      914,  915,  883,  916,  898,  901,  917,  918,  919,  902,
-      903,  904,  920,  921,  922,  923,  907,  924,  926,  902,
-      927,  928,  929,  931,  908,  909,  932,  910,  911,  933,
-      912,  914,  915,  936,  916,  938,  939,  917,  918,  919,
-      940,  941,  943,  920,  921,  922,  923,  947,  924,  926,
-      945,  927,  928,  929,  931,  946,  948,  932,  949,  950,
-
-      933,  951,  952,  953,  936,  954,  938,  939,  956,  959,
-      961,  940,  941,  943,  962,  963,  945,  964,  947,  946,
-      965,  945,  967,  969,  970,  971,  946,  948,  972,  949,
-      950,  973,  951,  952,  953,  975,  954,  976,  977,  956,
-      959,  961,  978,  980,  982,  962,  963,  983,  964,  985,
-      987,  965,  988,  967,  969,  970,  971,  989,  990,  972,
-      993,  994,  973,  995,  996,  997,  975,  999,  976,  977,
-     1000, 1001, 1002,  978,  980,  982, 1003, 1004,  983, 1005,
-      985,  987, 1006,  988, 1007, 1008, 1009, 1011,  989,  990,
-     1014,  993,  994, 1015,  995,  996,  997, 1010,  999, 1016,
-
-     1017, 1000, 1001, 1002, 1018, 1010, 1019, 1003, 1004, 1020,
-     1005, 1021, 1022, 1006, 1023, 1007, 1008, 1009, 1011, 1024,
-     1025, 1014, 1026, 1027, 1015, 1028, 1029, 1030, 1010, 1032,
-     1016, 1017, 1034, 1035, 1036, 1018, 1010, 1019, 1037, 1038,
-     1020, 1039, 1021, 1022, 1040, 1023, 1041, 1042, 1043, 1044,
-     1024, 1025, 1045, 1026, 1027, 1046, 1028, 1029, 1030, 1047,
-     1032, 1050, 1052, 1034, 1035, 1036, 1053, 1054, 1055, 1037,
-     1038, 1056, 1039, 1057, 1058, 1040, 1063, 1041, 1042, 1043,
-     1044, 1064, 1065, 1045, 1066, 1067, 1046, 1068, 1069, 1070,
-     1047, 1071, 1050, 1052, 1072, 1073, 1074, 1053, 1054, 1055,
-
-     1076, 1078, 1056, 1079, 1057, 1058, 1080, 1063, 1081, 1082,
-     1083, 1084, 1064, 1065, 1085, 1066, 1067, 1086, 1068, 1069,
-     1070, 1087, 1071, 1090, 1093, 1072, 1073, 1074, 1094, 1095,
-     1096, 1076, 1078, 1086, 1079, 1097, 1098, 1080, 1099, 1081,
-     1082, 1083, 1084, 1100, 1101, 1085, 1102, 1103, 1086, 1104,
-     1105, 1106, 1087, 1107, 1090, 1093, 1108, 1113, 1114, 1094,
-     1095, 1096, 1115, 1116, 1086, 1117, 1097, 1098, 1118, 1099,
-     1119, 1120, 1122, 1123, 1100, 1101, 1124, 1102, 1103, 1125,
-     1104, 1105, 1106, 1126, 1107, 1127, 1129, 1108, 1113, 1114,
-     1130, 1131, 1132, 1115, 1116, 1133, 1117, 1139, 1135, 1118,
-
-     1140, 1119, 1120, 1122, 1123, 1141, 1136, 1124, 1142, 1143,
-     1125, 1144, 1145, 1146, 1126, 1147, 1127, 1129, 1148, 1149,
-     1151, 1130, 1131, 1132, 1135, 1152, 1133, 1153, 1139, 1135,
-     1136, 1140, 1154, 1156, 1158, 1160, 1141, 1136, 1161, 1142,
-     1143, 1162, 1144, 1145, 1146, 1164, 1147, 1165, 1167, 1148,
-     1149, 1151, 1168, 1169, 1170, 1171, 1152, 1172, 1153, 1173,
-     1174, 1175, 1177, 1154, 1156, 1158, 1160, 1178, 1179, 1161,
-     1180, 1182, 1162, 1183, 1184, 1185, 1164, 1186, 1165, 1167,
-     1187, 1188, 1189, 1168, 1169, 1170, 1171, 1190, 1172, 1192,
-     1173, 1174, 1175, 1177, 1193, 1195, 1196, 1197, 1178, 1179,
-
-     1198, 1180, 1182, 1199, 1183, 1184, 1185, 1200, 1186, 1201,
-     1202, 1187, 1188, 1189, 1204, 1205, 1206, 1207, 1190, 1208,
-     1192, 1210, 1211, 1212, 1213, 1193, 1195, 1196, 1197, 1214,
-     1215, 1198, 1217, 1218, 1199, 1219, 1220, 1221, 1200, 1225,
-     1201, 1202, 1223, 1227, 1223, 1204, 1205, 1206, 1207, 1226,
-     1208, 1228, 1210, 1211, 1212, 1213, 1230, 1231, 1233, 1235,
-     1214, 1215, 1236, 1217, 1218, 1237, 1219, 1220, 1221, 1226,
-     1225, 1238, 1239, 1223, 1227, 1223, 1240, 1241, 1242, 1243,
-     1226, 1244, 1228, 1245, 1246, 1247, 1248, 1230, 1231, 1233,
-     1235, 1249, 1250, 1236, 1251, 1252, 1237, 1253, 1254, 1255,
-
-     1226, 1256, 1238, 1239, 1257, 1258, 1257, 1240, 1241, 1242,
-     1243, 1259, 1244, 1260, 1245, 1246, 1247, 1248, 1261, 1263,
-     1264, 1265, 1249, 1250, 1266, 1251, 1252, 1267, 1253, 1254,
-     1255, 1270, 1256, 1271, 1272, 1257, 1258, 1257, 1274, 1277,
-     1278, 1280, 1259, 1281, 1260, 1282, 1284, 1285, 1286, 1261,
-     1263, 1264, 1265, 1287, 1288, 1266, 1289, 1291, 1267, 1295,
-     1296, 1297, 1270, 1292, 1271, 1272, 1298, 1299, 1301, 1274,
-     1277, 1278, 1280, 1302, 1281, 1303, 1282, 1284, 1285, 1286,
-     1292, 1291, 1304, 1305, 1287, 1288, 1306, 1289, 1291, 1307,
-     1295, 1296, 1297, 1308, 1292, 1309, 1310, 1298, 1299, 1301,
-
-     1312, 1313, 1314, 1315, 1302, 1316, 1303, 1317, 1318, 1320,
-     1321, 1322, 1323, 1304, 1305, 1325, 1326, 1306, 1327, 1329,
-     1307, 1330, 1331, 1332, 1308, 1333, 1309, 1310, 1334, 1335,
-     1336, 1312, 1313, 1314, 1315, 1337, 1316, 1338, 1317, 1318,
-     1320, 1321, 1322, 1323, 1339, 1340, 1325, 1326, 1341, 1327,
-     1329, 1342, 1330, 1331, 1332, 1343, 1333, 1344, 1345, 1334,
-     1335, 1336, 1346, 1347, 1348, 1349, 1337, 1353, 1338, 1354,
-     1355, 1356, 1357, 1358, 1359, 1339, 1340, 1360, 1363, 1341,
-     1364, 1365, 1342, 1366, 1367, 1368, 1343, 1369, 1344, 1345,
-     1371, 1372, 1374, 1346, 1347, 1348, 1349, 1375, 1353, 1377,
-
-     1354, 1355, 1356, 1357, 1358, 1359, 1378, 1379, 1360, 1363,
-     1381, 1364, 1365, 1382, 1366, 1367, 1368, 1383, 1369, 1384,
-     1386, 1371, 1372, 1374, 1388, 1389, 1391, 1392, 1375, 1393,
-     1377, 1394, 1395, 1396, 1397, 1400, 1402, 1378, 1379, 1403,
-     1404, 1381, 1408, 1409, 1382, 1411, 1415, 1416, 1383, 1417,
-     1384, 1386, 1419, 1420,    0, 1388, 1389, 1391, 1392, 1424,
-     1393, 1425, 1394, 1395, 1396, 1397, 1400, 1402, 1422, 1423,
-     1403, 1404, 1427, 1408, 1409, 1429, 1411, 1415, 1416, 1431,
-     1417, 1433, 1434, 1419, 1420, 1422, 1423, 1436, 1438, 1439,
-     1424, 1441, 1425, 1442, 1443, 1444, 1446, 1450, 1452, 1422,
-
-     1423, 1453, 1454, 1427, 1455, 1456, 1429, 1458, 1459, 1460,
-     1431, 1461, 1433, 1434, 1462, 1463, 1464, 1465, 1436, 1438,
-     1439, 1466, 1441, 1467, 1442, 1443, 1444, 1446, 1450, 1452,
-     1468, 1470, 1453, 1454, 1471, 1455, 1456, 1472, 1458, 1459,
-     1460, 1473, 1461, 1474, 1475, 1462, 1463, 1464, 1465, 1476,
-     1477, 1478, 1466, 1479, 1467, 1480, 1481, 1482, 1483, 1484,
-     1485, 1468, 1470, 1486, 1487, 1471, 1488, 1489, 1472, 1490,
-     1491, 1492, 1473, 1493, 1474, 1475, 1494, 1495, 1498, 1499,
-     1476, 1477, 1478, 1500, 1479, 1501, 1480, 1481, 1482, 1483,
-     1484, 1485, 1502, 1503, 1486, 1487, 1504, 1488, 1489, 1508,
-
-     1490, 1491, 1492, 1511, 1493, 1513, 1514, 1494, 1495, 1498,
-     1499, 1515, 1516, 1517, 1500, 1518, 1501, 1519, 1520, 1523,
-     1524, 1522, 1526, 1502, 1503, 1527, 1531, 1504, 1532, 1523,
-     1508, 1531, 1536, 1537, 1511, 1540, 1513, 1514, 1522, 1544,
-     1545, 1546, 1515, 1516, 1517, 1547, 1518, 1548, 1519, 1520,
-     1523, 1524, 1522, 1526, 1549, 1552, 1527, 1531, 1553, 1532,
-     1554, 1555, 1531, 1536, 1537, 1556, 1540, 1557, 1558, 1559,
-     1544, 1545, 1546, 1561, 1562, 1563, 1547, 1564, 1548, 1565,
-     1566, 1567, 1568, 1569, 1571, 1549, 1552, 1572, 1573, 1553,
-     1574, 1554, 1555, 1575, 1576, 1578, 1556, 1581, 1557, 1558,
-
-     1559, 1583, 1587, 1589, 1561, 1562, 1563, 1590, 1564, 1591,
-     1565, 1566, 1567, 1568, 1569, 1571, 1600, 1599, 1572, 1573,
-     1602, 1574, 1603, 1604, 1575, 1576, 1578, 1599, 1581, 1605,
-     1606, 1607, 1583, 1587, 1589, 1608, 1600, 1609, 1590, 1611,
-     1591, 1612, 1613, 1614, 1615, 1620, 1621, 1600, 1599, 1622,
-     1625, 1602, 1628, 1603, 1604, 1629, 1631, 1633, 1634, 1635,
-     1605, 1606, 1607, 1636, 1639, 1641, 1608, 1643, 1609, 1644,
-     1611, 1646, 1612, 1613, 1614, 1615, 1620, 1621, 1648, 1647,
-     1622, 1625, 1647, 1628, 1650, 1651, 1629, 1631, 1633, 1634,
-     1635, 1646, 1652, 1654, 1636, 1639, 1641, 1655, 1643, 1656,
-
-     1644, 1657, 1646, 1658, 1660, 1661, 1662, 1664, 1665, 1648,
-     1647, 1667, 1668, 1672, 1673, 1650, 1651, 1674, 1675, 1676,
-        0, 1678, 1676, 1652, 1654, 1679, 1680, 1677, 1655, 1684,
-     1656, 1685, 1657, 1687, 1658, 1660, 1661, 1662, 1664, 1665,
-     1688, 1690, 1667, 1668, 1672, 1673, 1694, 1695, 1674, 1675,
-     1676, 1677, 1678, 1696, 1697, 1698, 1679, 1680, 1677, 1700,
-     1684, 1701, 1685, 1703, 1687, 1704, 1705, 1706, 1710, 1715,
-     1716, 1688, 1690, 1717, 1720, 1722, 1723, 1694, 1695, 1698,
-     1724, 1727, 1728,    0, 1696, 1697, 1698,    0,    0,    0,
-     1700,    0, 1701,    0, 1703,    0, 1704, 1705, 1706, 1710,
-
-     1715, 1716,    0,    0, 1717, 1720, 1722, 1723,    0,    0,
-        0, 1724, 1727, 1728, 1732, 1732, 1732, 1732, 1732, 1732,
-     1732, 1733, 1733, 1733, 1733, 1733, 1733, 1733, 1734, 1734,
-     1734, 1734, 1734, 1734, 1734, 1735,    0, 1735, 1735, 1735,
-     1735, 1735, 1736,    0, 1736, 1736, 1736, 1736, 1736, 1738,
-     1738, 1738, 1738, 1738, 1738, 1738, 1739, 1739, 1739, 1739,
-     1739, 1739, 1739, 1740,    0, 1740, 1740, 1740, 1740, 1740,
-     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1742, 1742, 1742,
-     1742, 1742, 1742, 1742, 1743, 1743, 1743, 1743, 1743, 1743,
-     1743, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1745, 1745,
-
-        0,    0, 1745, 1745, 1746,    0, 1746, 1746,    0, 1746,
-     1746, 1747, 1747, 1747, 1747, 1747, 1747, 1747, 1748, 1748,
-     1748, 1748, 1748, 1748, 1748, 1749, 1749, 1749, 1749, 1749,
-     1749, 1749, 1750, 1750,    0, 1750, 1750, 1750, 1750, 1751,
-     1751, 1751,    0, 1751, 1751, 1751, 1752, 1752, 1752, 1752,
-     1752, 1752, 1752, 1753,    0, 1753, 1753, 1753, 1753, 1753,
-     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1755,    0, 1755,
-     1755, 1755, 1755, 1755, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
-     1731
-    } ;
-
-static yy_state_type yy_last_accepting_state;
-static char *yy_last_accepting_cpos;
-
-extern int yy_flex_debug;
-int yy_flex_debug = 0;
-
-/* The intent behind this definition is that it'll catch
- * any uses of REJECT which flex missed.
- */
-#define REJECT reject_used_but_not_detected
-#define yymore() yymore_used_but_not_detected
-#define YY_MORE_ADJ 0
-#define YY_RESTORE_YY_MORE_OFFSET
-char *yytext;
-#line 1 "maplexer.l"
-#line 4 "maplexer.l"
-/*
-** READ ME FIRST!
-**
-** When this file is altered, it is necessary to do "make lexer".  Due to
-** problems detailed in #2310 the lexer is no longer automatically rebuilt
-** when maplexer.l is altered.
-*/
-
-#define YY_NO_INPUT
-
-/* C declarations */
-#include <stdlib.h>
-#include <stdio.h>
-#include <string.h>
-#include <math.h>
-
-#include <time.h>
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapfile.h"
-#include "maptime.h"
-#include "mapsymbol.h"
-#include "mapparser.h"
-#include "mapprimitive.h"
-
-/* msyylineno is required for flex 2.5.4 and older, but is already defined by
- * flex 2.5.31 (bug 975).
- * Unfortunately there is no clean way to differenciate the two versions,
- * so we use the symbol YY_CURRENT_BUFFER_LVALUE to base our test since it
- * was not present in 2.5.4 and is present in 2.5.31. Hopefully that won't
- * put us in trouble with other versions. If that happens then we can
- * switch to using autoconf to detect the version.
- */
-#ifndef YY_CURRENT_BUFFER_LVALUE
-int msyylineno = 1;
-#endif
-
-#define YY_NO_INPUT
-
-/* Below is a redefinition of the default YY_INPUT() macro but replacing the
- * YY_FATAL_ERROR() macro with a call to msSetError().
- */
-/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
- * is returned in "result".
- */
-#define YY_INPUT(buf,result,max_size) \
-	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
-		{ \
-		int c = '*'; \
-		int n; \
-		for ( n = 0; n < max_size && \
-			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
-			buf[n] = (char) c; \
-		if ( c == '\n' ) \
-			buf[n++] = (char) c; \
-		if ( c == EOF && ferror( yyin ) ) \
-            msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
-		result = n; \
-		} \
-	else \
-		{ \
-		errno=0; \
-		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
-			{ \
-			if( errno != EINTR) \
-				{ \
-                msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
-				break; \
-				} \
-			errno=0; \
-			clearerr(yyin); \
-			} \
-		}
-
-int msyysource=MS_STRING_TOKENS;
-double msyynumber;
-int msyystate=MS_TOKENIZE_DEFAULT;
-char *msyystring=NULL;
-char *msyybasepath=NULL;
-int  msyystring_buffer_size = 0;
-int  msyystring_size;
-char msyystring_begin;
-char *msyystring_buffer = NULL;
-int  msyystring_icase = MS_FALSE;
-int  msyystring_return_state;
-int  msyystring_begin_state;
-
-int msyyreturncomments = 0;
-
-#define MS_LEXER_STRING_REALLOC(string, string_size, max_size)   \
-  do { \
-   const int string_size_macro = (int)(string_size); \
-   if (string_size_macro >= (int)(max_size)) {         \
-       max_size = (((int)(max_size)*2) > string_size_macro) ? ((int)(max_size))*2 : string_size_macro+1;   \
-       string = (char *) msSmallRealloc(string, sizeof(char *) * (max_size));  \
-   } \
-  } while(0)
-
-#define MS_LEXER_RETURN_TOKEN(token) \
-   MS_LEXER_STRING_REALLOC(msyystring_buffer, strlen(msyytext),  \
-                           msyystring_buffer_size); \
-   strcpy(msyystring_buffer, msyytext); \
-   return(token); 
-
-#define MAX_INCLUDE_DEPTH 5
-YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
-int include_lineno[MAX_INCLUDE_DEPTH];
-int include_stack_ptr = 0;
-char path[MS_MAXPATHLEN];
-
-#line 2287 "/home/even/mapserver/mapserver/maplexer.c"
-
-#line 2289 "/home/even/mapserver/mapserver/maplexer.c"
-
-#define INITIAL 0
-#define EXPRESSION_STRING 1
-#define INCLUDE 2
-#define MSSTRING 3
-#define MULTILINE_COMMENT 4
-#define CONFIG_FILE 5
-
-#ifndef YY_EXTRA_TYPE
-#define YY_EXTRA_TYPE void *
-#endif
-
-static int yy_init_globals ( void );
-
-/* Accessor methods to globals.
-   These are made visible to non-reentrant scanners for convenience. */
-
-int yylex_destroy ( void );
-
-int yyget_debug ( void );
-
-void yyset_debug ( int debug_flag  );
-
-YY_EXTRA_TYPE yyget_extra ( void );
-
-void yyset_extra ( YY_EXTRA_TYPE user_defined  );
-
-FILE *yyget_in ( void );
-
-void yyset_in  ( FILE * _in_str  );
-
-FILE *yyget_out ( void );
-
-void yyset_out  ( FILE * _out_str  );
-
-			int yyget_leng ( void );
-
-char *yyget_text ( void );
-
-int yyget_lineno ( void );
-
-void yyset_lineno ( int _line_number  );
-
-/* Macros after this point can all be overridden by user definitions in
- * section 1.
- */
-
-#ifndef YY_SKIP_YYWRAP
-#ifdef __cplusplus
-extern "C" int yywrap ( void );
-#else
-extern int yywrap ( void );
-#endif
-#endif
-
-#ifndef YY_NO_UNPUT
-    
-    static void yyunput ( int c, char *buf_ptr  );
-    
-#endif
-
-#ifndef yytext_ptr
-static void yy_flex_strncpy ( char *, const char *, int );
-#endif
-
-#ifdef YY_NEED_STRLEN
-static int yy_flex_strlen ( const char * );
-#endif
-
-#ifndef YY_NO_INPUT
-#ifdef __cplusplus
-static int yyinput ( void );
-#else
-static int input ( void );
-#endif
-
-#endif
-
-/* Amount of stuff to slurp up with each read. */
-#ifndef YY_READ_BUF_SIZE
-#ifdef __ia64__
-/* On IA-64, the buffer size is 16k, not 8k */
-#define YY_READ_BUF_SIZE 16384
-#else
-#define YY_READ_BUF_SIZE 8192
-#endif /* __ia64__ */
-#endif
-
-/* Copy whatever the last rule matched to the standard output. */
-#ifndef ECHO
-/* This used to be an fputs(), but since the string might contain NUL's,
- * we now use fwrite().
- */
-#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
-#endif
-
-/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
- * is returned in "result".
- */
-#ifndef YY_INPUT
-#define YY_INPUT(buf,result,max_size) \
-	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
-		{ \
-		int c = '*'; \
-		int n; \
-		for ( n = 0; n < max_size && \
-			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
-			buf[n] = (char) c; \
-		if ( c == '\n' ) \
-			buf[n++] = (char) c; \
-		if ( c == EOF && ferror( yyin ) ) \
-			YY_FATAL_ERROR( "input in flex scanner failed" ); \
-		result = n; \
-		} \
-	else \
-		{ \
-		errno=0; \
-		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
-			{ \
-			if( errno != EINTR) \
-				{ \
-				YY_FATAL_ERROR( "input in flex scanner failed" ); \
-				break; \
-				} \
-			errno=0; \
-			clearerr(yyin); \
-			} \
-		}\
-\
-
-#endif
-
-/* No semi-colon after return; correct usage is to write "yyterminate();" -
- * we don't want an extra ';' after the "return" because that will cause
- * some compilers to complain about unreachable statements.
- */
-#ifndef yyterminate
-#define yyterminate() return YY_NULL
-#endif
-
-/* Number of entries by which start-condition stack grows. */
-#ifndef YY_START_STACK_INCR
-#define YY_START_STACK_INCR 25
-#endif
-
-/* Report a fatal error. */
-#ifndef YY_FATAL_ERROR
-#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
-#endif
-
-/* end tables serialization structures and prototypes */
-
-/* Default declaration of generated scanner - a define so the user can
- * easily add parameters.
- */
-#ifndef YY_DECL
-#define YY_DECL_IS_OURS 1
-
-extern int yylex (void);
-
-#define YY_DECL int yylex (void)
-#endif /* !YY_DECL */
-
-/* Code executed at the beginning of each rule, after yytext and yyleng
- * have been set up.
- */
-#ifndef YY_USER_ACTION
-#define YY_USER_ACTION
-#endif
-
-/* Code executed at the end of each rule. */
-#ifndef YY_BREAK
-#define YY_BREAK /*LINTED*/break;
-#endif
-
-#define YY_RULE_SETUP \
-	YY_USER_ACTION
-
-/** The main scanner function which does all the work.
- */
-YY_DECL
-{
-	yy_state_type yy_current_state;
-	char *yy_cp, *yy_bp;
-	int yy_act;
-    
-	if ( !(yy_init) )
-		{
-		(yy_init) = 1;
-
-#ifdef YY_USER_INIT
-		YY_USER_INIT;
-#endif
-
-		if ( ! (yy_start) )
-			(yy_start) = 1;	/* first start state */
-
-		if ( ! yyin )
-			yyin = stdin;
-
-		if ( ! yyout )
-			yyout = stdout;
-
-		if ( ! YY_CURRENT_BUFFER ) {
-			yyensure_buffer_stack ();
-			YY_CURRENT_BUFFER_LVALUE =
-				yy_create_buffer( yyin, YY_BUF_SIZE );
-		}
-
-		yy_load_buffer_state(  );
-		}
-
-	{
-#line 123 "maplexer.l"
-
-#line 125 "maplexer.l"
-       if (msyystring_buffer == NULL)
-       {
-           msyystring_buffer_size = 256;
-           msyystring_buffer = (char*) msSmallMalloc(sizeof(char) * msyystring_buffer_size);
-       }
-
-       msyystring_buffer[0] = '\0';
-       switch(msyystate) {
-       case(MS_TOKENIZE_DEFAULT):
-         (void) yyunput; /* just to avoid warning about it being unrefed */ 
-         break;
-       case(MS_TOKENIZE_FILE):
-         BEGIN(INITIAL);
-         msyystring_begin_state = INITIAL;
-         msyysource=MS_FILE_TOKENS;
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyystring=NULL;
-         msyyreturncomments=0;
-         include_stack_ptr=0;
-         return(0);
-         break;
-       case(MS_TOKENIZE_STRING):
-         BEGIN(INITIAL);
-         msyystring_begin_state = INITIAL;
-         msyy_delete_buffer(YY_CURRENT_BUFFER);
-         msyy_scan_string(msyystring);
-         msyysource=MS_STRING_TOKENS;
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyyin=NULL;
-         msyyreturncomments=0;
-         include_stack_ptr=0;
-         return(0);
-         break;
-       case(MS_TOKENIZE_EXPRESSION):
-         BEGIN(EXPRESSION_STRING);
-         msyystring_begin_state = EXPRESSION_STRING;
-         msyy_delete_buffer(YY_CURRENT_BUFFER);
-         msyy_scan_string(msyystring);
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyyreturncomments=0;
-         break;
-       case(MS_TOKENIZE_CONFIG):
-         BEGIN(CONFIG_FILE);
-         msyystring_begin_state = CONFIG_FILE;
-         msyysource=MS_FILE_TOKENS;
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyystring=NULL;
-         msyyreturncomments=0;
-         return(0);
-         break;
-       case(99):
-         BEGIN(INITIAL); /* may not need this one */
-         msyystring_begin_state = INITIAL;
-         msyy_delete_buffer(YY_CURRENT_BUFFER);
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyystring=NULL;
-         msyyreturncomments=0; 
-         return(0);
-         break;
-       default:
-         break;
-       }
-
-#line 2569 "/home/even/mapserver/mapserver/maplexer.c"
-
-	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
-		{
-		yy_cp = (yy_c_buf_p);
-
-		/* Support of yytext. */
-		*yy_cp = (yy_hold_char);
-
-		/* yy_bp points to the position in yy_ch_buf of the start of
-		 * the current run.
-		 */
-		yy_bp = yy_cp;
-
-		yy_current_state = (yy_start);
-yy_match:
-		do
-			{
-			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
-			if ( yy_accept[yy_current_state] )
-				{
-				(yy_last_accepting_state) = yy_current_state;
-				(yy_last_accepting_cpos) = yy_cp;
-				}
-			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
-				{
-				yy_current_state = (int) yy_def[yy_current_state];
-				if ( yy_current_state >= 1732 )
-					yy_c = yy_meta[yy_c];
-				}
-			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
-			++yy_cp;
-			}
-		while ( yy_current_state != 1731 );
-		yy_cp = (yy_last_accepting_cpos);
-		yy_current_state = (yy_last_accepting_state);
-
-yy_find_action:
-		yy_act = yy_accept[yy_current_state];
-
-		YY_DO_BEFORE_ACTION;
-
-do_action:	/* This label is used only to access EOF actions. */
-
-		switch ( yy_act )
-	{ /* beginning of action switch */
-			case 0: /* must back up */
-			/* undo the effects of YY_DO_BEFORE_ACTION */
-			*yy_cp = (yy_hold_char);
-			yy_cp = (yy_last_accepting_cpos);
-			yy_current_state = (yy_last_accepting_state);
-			goto yy_find_action;
-
-case 1:
-YY_RULE_SETUP
-#line 188 "maplexer.l"
-;
-	YY_BREAK
-case 2:
-YY_RULE_SETUP
-#line 190 "maplexer.l"
-{ if (msyyreturncomments) return(MS_COMMENT); }
-	YY_BREAK
-case 3:
-YY_RULE_SETUP
-#line 192 "maplexer.l"
-{ BEGIN(MULTILINE_COMMENT); }
-	YY_BREAK
-case 4:
-YY_RULE_SETUP
-#line 193 "maplexer.l"
-{ BEGIN(INITIAL); }
-	YY_BREAK
-case 5:
-YY_RULE_SETUP
-#line 194 "maplexer.l"
-;
-	YY_BREAK
-case 6:
-YY_RULE_SETUP
-#line 195 "maplexer.l"
-;
-	YY_BREAK
-case 7:
-/* rule 7 can match eol */
-YY_RULE_SETUP
-#line 196 "maplexer.l"
-{ msyylineno++; }
-	YY_BREAK
-case 8:
-YY_RULE_SETUP
-#line 198 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION); }
-	YY_BREAK
-case 9:
-YY_RULE_SETUP
-#line 199 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_ENV); }
-	YY_BREAK
-case 10:
-YY_RULE_SETUP
-#line 200 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_MAPS); }
-	YY_BREAK
-case 11:
-YY_RULE_SETUP
-#line 201 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_PLUGINS) }
-	YY_BREAK
-case 12:
-YY_RULE_SETUP
-#line 203 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_OR); }
-	YY_BREAK
-case 13:
-YY_RULE_SETUP
-#line 204 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_AND); }
-	YY_BREAK
-case 14:
-YY_RULE_SETUP
-#line 205 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_NOT); }
-	YY_BREAK
-case 15:
-YY_RULE_SETUP
-#line 206 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQ); }
-	YY_BREAK
-case 16:
-YY_RULE_SETUP
-#line 207 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_NE); }
-	YY_BREAK
-case 17:
-YY_RULE_SETUP
-#line 208 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GT); }
-	YY_BREAK
-case 18:
-YY_RULE_SETUP
-#line 209 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LT); }
-	YY_BREAK
-case 19:
-YY_RULE_SETUP
-#line 210 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GE); }
-	YY_BREAK
-case 20:
-YY_RULE_SETUP
-#line 211 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LE); }
-	YY_BREAK
-case 21:
-YY_RULE_SETUP
-#line 212 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_RE); }
-	YY_BREAK
-case 22:
-YY_RULE_SETUP
-#line 214 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IEQ); }
-	YY_BREAK
-case 23:
-YY_RULE_SETUP
-#line 215 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IRE); }
-	YY_BREAK
-case 24:
-YY_RULE_SETUP
-#line 217 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IN); /* was IN */ }
-	YY_BREAK
-case 25:
-YY_RULE_SETUP
-#line 219 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_AREA); }
-	YY_BREAK
-case 26:
-YY_RULE_SETUP
-#line 220 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LENGTH); }
-	YY_BREAK
-case 27:
-YY_RULE_SETUP
-#line 221 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_TOSTRING); }
-	YY_BREAK
-case 28:
-YY_RULE_SETUP
-#line 222 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_COMMIFY); }
-	YY_BREAK
-case 29:
-YY_RULE_SETUP
-#line 223 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_ROUND); }
-	YY_BREAK
-case 30:
-YY_RULE_SETUP
-#line 224 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_UPPER); }
-	YY_BREAK
-case 31:
-YY_RULE_SETUP
-#line 225 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LOWER); }
-	YY_BREAK
-case 32:
-YY_RULE_SETUP
-#line 226 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INITCAP); }
-	YY_BREAK
-case 33:
-YY_RULE_SETUP
-#line 227 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FIRSTCAP); }
-	YY_BREAK
-case 34:
-YY_RULE_SETUP
-#line 229 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_BUFFER); }
-	YY_BREAK
-case 35:
-YY_RULE_SETUP
-#line 230 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DIFFERENCE); }
-	YY_BREAK
-case 36:
-YY_RULE_SETUP
-#line 231 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFY); }
-	YY_BREAK
-case 37:
-YY_RULE_SETUP
-#line 232 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFYPT); }
-	YY_BREAK
-case 38:
-YY_RULE_SETUP
-#line 233 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_GENERALIZE); }
-	YY_BREAK
-case 39:
-YY_RULE_SETUP
-#line 234 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SMOOTHSIA); }
-	YY_BREAK
-case 40:
-YY_RULE_SETUP
-#line 235 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_CENTERLINE); }
-	YY_BREAK
-case 41:
-YY_RULE_SETUP
-#line 236 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DENSIFY); }
-	YY_BREAK
-case 42:
-YY_RULE_SETUP
-#line 237 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_OUTER); }
-	YY_BREAK
-case 43:
-YY_RULE_SETUP
-#line 238 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INNER); } 
-	YY_BREAK
-case 44:
-YY_RULE_SETUP
-#line 239 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_JAVASCRIPT); }
-	YY_BREAK
-case 45:
-YY_RULE_SETUP
-#line 241 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_INTERSECTS); }
-	YY_BREAK
-case 46:
-YY_RULE_SETUP
-#line 242 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DISJOINT); }
-	YY_BREAK
-case 47:
-YY_RULE_SETUP
-#line 243 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_TOUCHES); }
-	YY_BREAK
-case 48:
-YY_RULE_SETUP
-#line 244 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_OVERLAPS); }
-	YY_BREAK
-case 49:
-YY_RULE_SETUP
-#line 245 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CROSSES); }
-	YY_BREAK
-case 50:
-YY_RULE_SETUP
-#line 246 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_WITHIN); }
-	YY_BREAK
-case 51:
-YY_RULE_SETUP
-#line 247 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CONTAINS); }
-	YY_BREAK
-case 52:
-YY_RULE_SETUP
-#line 248 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQUALS); }
-	YY_BREAK
-case 53:
-YY_RULE_SETUP
-#line 249 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_BEYOND); }
-	YY_BREAK
-case 54:
-YY_RULE_SETUP
-#line 250 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DWITHIN); }
-	YY_BREAK
-case 55:
-YY_RULE_SETUP
-#line 252 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FROMTEXT); }
-	YY_BREAK
-case 56:
-YY_RULE_SETUP
-#line 254 "maplexer.l"
-{ msyynumber=MS_TRUE; return(MS_TOKEN_LITERAL_BOOLEAN); }
-	YY_BREAK
-case 57:
-YY_RULE_SETUP
-#line 255 "maplexer.l"
-{ msyynumber=MS_FALSE; return(MS_TOKEN_LITERAL_BOOLEAN); }
-	YY_BREAK
-case 58:
-YY_RULE_SETUP
-#line 257 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(COLORRANGE); }
-	YY_BREAK
-case 59:
-YY_RULE_SETUP
-#line 258 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(DATARANGE); }
-	YY_BREAK
-case 60:
-YY_RULE_SETUP
-#line 259 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(RANGEITEM); }
-	YY_BREAK
-case 61:
-YY_RULE_SETUP
-#line 261 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(ALIGN); }
-	YY_BREAK
-case 62:
-YY_RULE_SETUP
-#line 262 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(ANCHORPOINT); }
-	YY_BREAK
-case 63:
-YY_RULE_SETUP
-#line 263 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(ANGLE); }
-	YY_BREAK
-case 64:
-YY_RULE_SETUP
-#line 264 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(ANTIALIAS); }
-	YY_BREAK
-case 65:
-YY_RULE_SETUP
-#line 265 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(BACKGROUNDCOLOR); }
-	YY_BREAK
-case 66:
-YY_RULE_SETUP
-#line 266 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(BANDSITEM); }
-	YY_BREAK
-case 67:
-YY_RULE_SETUP
-#line 267 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(BINDVALS); }
-	YY_BREAK
-case 68:
-YY_RULE_SETUP
-#line 268 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(BOM); }
-	YY_BREAK
-case 69:
-YY_RULE_SETUP
-#line 269 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(BROWSEFORMAT); }
-	YY_BREAK
-case 70:
-YY_RULE_SETUP
-#line 270 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(BUFFER); }
-	YY_BREAK
-case 71:
-YY_RULE_SETUP
-#line 271 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CHARACTER); }
-	YY_BREAK
-case 72:
-YY_RULE_SETUP
-#line 272 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CLASS); }
-	YY_BREAK
-case 73:
-YY_RULE_SETUP
-#line 273 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CLASSITEM); }
-	YY_BREAK
-case 74:
-YY_RULE_SETUP
-#line 274 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CLASSGROUP); }
-	YY_BREAK
-case 75:
-YY_RULE_SETUP
-#line 275 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CLUSTER); }
-	YY_BREAK
-case 76:
-YY_RULE_SETUP
-#line 276 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(COLOR); }
-	YY_BREAK
-case 77:
-YY_RULE_SETUP
-#line 277 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(COMPFILTER); }
-	YY_BREAK
-case 78:
-YY_RULE_SETUP
-#line 278 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(COMPOSITE); }
-	YY_BREAK
-case 79:
-YY_RULE_SETUP
-#line 279 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(COMPOP); }
-	YY_BREAK
-case 80:
-YY_RULE_SETUP
-#line 280 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CONFIG); }
-	YY_BREAK
-case 81:
-YY_RULE_SETUP
-#line 281 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CONNECTION); }
-	YY_BREAK
-case 82:
-YY_RULE_SETUP
-#line 282 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CONNECTIONTYPE); }
-	YY_BREAK
-case 83:
-YY_RULE_SETUP
-#line 283 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(DATA); }
-	YY_BREAK
-case 84:
-YY_RULE_SETUP
-#line 284 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(DEBUG); }
-	YY_BREAK
-case 85:
-YY_RULE_SETUP
-#line 285 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(DRIVER); }
-	YY_BREAK
-case 86:
-YY_RULE_SETUP
-#line 286 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(EMPTY); }
-	YY_BREAK
-case 87:
-YY_RULE_SETUP
-#line 287 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(ENCODING); }
-	YY_BREAK
-case 88:
-YY_RULE_SETUP
-#line 288 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(END); }
-	YY_BREAK
-case 89:
-YY_RULE_SETUP
-#line 289 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(ERROR); }
-	YY_BREAK
-case 90:
-YY_RULE_SETUP
-#line 290 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(EXPRESSION); }
-	YY_BREAK
-case 91:
-YY_RULE_SETUP
-#line 291 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(EXTENT); }
-	YY_BREAK
-case 92:
-YY_RULE_SETUP
-#line 292 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(EXTENSION); }
-	YY_BREAK
-case 93:
-YY_RULE_SETUP
-#line 293 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FEATURE); }
-	YY_BREAK
-case 94:
-YY_RULE_SETUP
-#line 294 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FILLED); }
-	YY_BREAK
-case 95:
-YY_RULE_SETUP
-#line 295 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FILTER); }
-	YY_BREAK
-case 96:
-YY_RULE_SETUP
-#line 296 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FILTERITEM); }
-	YY_BREAK
-case 97:
-YY_RULE_SETUP
-#line 297 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FOOTER); }
-	YY_BREAK
-case 98:
-YY_RULE_SETUP
-#line 298 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FONT); }
-	YY_BREAK
-case 99:
-YY_RULE_SETUP
-#line 299 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FONTSET); }
-	YY_BREAK
-case 100:
-YY_RULE_SETUP
-#line 300 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FORCE); }
-	YY_BREAK
-case 101:
-YY_RULE_SETUP
-#line 301 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FORMATOPTION); }
-	YY_BREAK
-case 102:
-YY_RULE_SETUP
-#line 302 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(FROM); }
-	YY_BREAK
-case 103:
-YY_RULE_SETUP
-#line 303 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(GAP); }
-	YY_BREAK
-case 104:
-YY_RULE_SETUP
-#line 304 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(GEOMTRANSFORM); }
-	YY_BREAK
-case 105:
-YY_RULE_SETUP
-#line 305 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(GRID); }
-	YY_BREAK
-case 106:
-YY_RULE_SETUP
-#line 306 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(GRIDSTEP); }
-	YY_BREAK
-case 107:
-YY_RULE_SETUP
-#line 307 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(GRATICULE); }
-	YY_BREAK
-case 108:
-YY_RULE_SETUP
-#line 308 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(GROUP); }
-	YY_BREAK
-case 109:
-YY_RULE_SETUP
-#line 309 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(HEADER); }
-	YY_BREAK
-case 110:
-YY_RULE_SETUP
-#line 310 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(IMAGE); }
-	YY_BREAK
-case 111:
-YY_RULE_SETUP
-#line 311 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(IMAGECOLOR); }
-	YY_BREAK
-case 112:
-YY_RULE_SETUP
-#line 312 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(IMAGETYPE); }
-	YY_BREAK
-case 113:
-YY_RULE_SETUP
-#line 313 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(IMAGEMODE); }
-	YY_BREAK
-case 114:
-YY_RULE_SETUP
-#line 314 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(IMAGEPATH); }
-	YY_BREAK
-case 115:
-YY_RULE_SETUP
-#line 315 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TEMPPATH); }
-	YY_BREAK
-case 116:
-YY_RULE_SETUP
-#line 316 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(IMAGEURL); }
-	YY_BREAK
-case 117:
-YY_RULE_SETUP
-#line 317 "maplexer.l"
-{ BEGIN(INCLUDE); }
-	YY_BREAK
-case 118:
-YY_RULE_SETUP
-#line 318 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(INDEX); }
-	YY_BREAK
-case 119:
-YY_RULE_SETUP
-#line 319 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(INITIALGAP); }
-	YY_BREAK
-case 120:
-YY_RULE_SETUP
-#line 320 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(INTERVALS); } 
-	YY_BREAK
-case 121:
-YY_RULE_SETUP
-#line 321 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(JOIN); }
-	YY_BREAK
-case 122:
-YY_RULE_SETUP
-#line 322 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(KEYIMAGE); }
-	YY_BREAK
-case 123:
-YY_RULE_SETUP
-#line 323 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(KEYSIZE); }
-	YY_BREAK
-case 124:
-YY_RULE_SETUP
-#line 324 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(KEYSPACING); }
-	YY_BREAK
-case 125:
-YY_RULE_SETUP
-#line 325 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABEL); }
-	YY_BREAK
-case 126:
-YY_RULE_SETUP
-#line 326 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELCACHE); }
-	YY_BREAK
-case 127:
-YY_RULE_SETUP
-#line 327 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELFORMAT); }
-	YY_BREAK
-case 128:
-YY_RULE_SETUP
-#line 328 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELITEM); }
-	YY_BREAK
-case 129:
-YY_RULE_SETUP
-#line 329 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELMAXSCALE); }
-	YY_BREAK
-case 130:
-YY_RULE_SETUP
-#line 330 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELMAXSCALEDENOM); }
-	YY_BREAK
-case 131:
-YY_RULE_SETUP
-#line 331 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELMINSCALE); }
-	YY_BREAK
-case 132:
-YY_RULE_SETUP
-#line 332 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELMINSCALEDENOM); }
-	YY_BREAK
-case 133:
-YY_RULE_SETUP
-#line 333 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LABELREQUIRES); }
-	YY_BREAK
-case 134:
-YY_RULE_SETUP
-#line 334 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LATLON); }
-	YY_BREAK
-case 135:
-YY_RULE_SETUP
-#line 335 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LAYER); }
-	YY_BREAK
-case 136:
-YY_RULE_SETUP
-#line 336 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LEADER); }
-	YY_BREAK
-case 137:
-YY_RULE_SETUP
-#line 337 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LEGEND); }
-	YY_BREAK
-case 138:
-YY_RULE_SETUP
-#line 338 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LEGENDFORMAT); }
-	YY_BREAK
-case 139:
-YY_RULE_SETUP
-#line 339 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LINECAP); }
-	YY_BREAK
-case 140:
-YY_RULE_SETUP
-#line 340 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LINEJOIN); }
-	YY_BREAK
-case 141:
-YY_RULE_SETUP
-#line 341 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(LINEJOINMAXSIZE); }
-	YY_BREAK
-case 142:
-YY_RULE_SETUP
-#line 342 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAP); }
-	YY_BREAK
-case 143:
-YY_RULE_SETUP
-#line 343 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MARKER); }
-	YY_BREAK
-case 144:
-YY_RULE_SETUP
-#line 344 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MARKERSIZE); }
-	YY_BREAK
-case 145:
-YY_RULE_SETUP
-#line 345 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MASK); }
-	YY_BREAK
-case 146:
-YY_RULE_SETUP
-#line 346 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXARCS); }
-	YY_BREAK
-case 147:
-YY_RULE_SETUP
-#line 347 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXBOXSIZE); }
-	YY_BREAK
-case 148:
-YY_RULE_SETUP
-#line 348 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXDISTANCE); }
-	YY_BREAK
-case 149:
-YY_RULE_SETUP
-#line 349 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXFEATURES); }
-	YY_BREAK
-case 150:
-YY_RULE_SETUP
-#line 350 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXINTERVAL); }
-	YY_BREAK
-case 151:
-YY_RULE_SETUP
-#line 351 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXSCALE); }
-	YY_BREAK
-case 152:
-YY_RULE_SETUP
-#line 352 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXSCALEDENOM); }
-	YY_BREAK
-case 153:
-YY_RULE_SETUP
-#line 353 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXGEOWIDTH); }
-	YY_BREAK
-case 154:
-YY_RULE_SETUP
-#line 354 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXLENGTH); }
-	YY_BREAK
-case 155:
-YY_RULE_SETUP
-#line 355 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXSIZE); }
-	YY_BREAK
-case 156:
-YY_RULE_SETUP
-#line 356 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXSUBDIVIDE); }
-	YY_BREAK
-case 157:
-YY_RULE_SETUP
-#line 357 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXTEMPLATE); }
-	YY_BREAK
-case 158:
-YY_RULE_SETUP
-#line 358 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXWIDTH); }
-	YY_BREAK
-case 159:
-YY_RULE_SETUP
-#line 359 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(METADATA); }
-	YY_BREAK
-case 160:
-YY_RULE_SETUP
-#line 360 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MIMETYPE); }
-	YY_BREAK
-case 161:
-YY_RULE_SETUP
-#line 361 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINARCS); }
-	YY_BREAK
-case 162:
-YY_RULE_SETUP
-#line 362 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINBOXSIZE); }
-	YY_BREAK
-case 163:
-YY_RULE_SETUP
-#line 363 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINDISTANCE); }
-	YY_BREAK
-case 164:
-YY_RULE_SETUP
-#line 364 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(REPEATDISTANCE); }
-	YY_BREAK
-case 165:
-YY_RULE_SETUP
-#line 365 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MAXOVERLAPANGLE); } 
-	YY_BREAK
-case 166:
-YY_RULE_SETUP
-#line 366 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINFEATURESIZE); }
-	YY_BREAK
-case 167:
-YY_RULE_SETUP
-#line 367 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MININTERVAL); }
-	YY_BREAK
-case 168:
-YY_RULE_SETUP
-#line 368 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINSCALE); }
-	YY_BREAK
-case 169:
-YY_RULE_SETUP
-#line 369 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINSCALEDENOM); }
-	YY_BREAK
-case 170:
-YY_RULE_SETUP
-#line 370 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINGEOWIDTH); }
-	YY_BREAK
-case 171:
-YY_RULE_SETUP
-#line 371 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINSIZE); }
-	YY_BREAK
-case 172:
-YY_RULE_SETUP
-#line 372 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINSUBDIVIDE); }
-	YY_BREAK
-case 173:
-YY_RULE_SETUP
-#line 373 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINTEMPLATE); }
-	YY_BREAK
-case 174:
-YY_RULE_SETUP
-#line 374 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MINWIDTH); }
-	YY_BREAK
-case 175:
-YY_RULE_SETUP
-#line 375 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(NAME); }
-	YY_BREAK
-case 176:
-YY_RULE_SETUP
-#line 376 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(OFFSET); }
-	YY_BREAK
-case 177:
-YY_RULE_SETUP
-#line 377 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(OFFSITE); }
-	YY_BREAK
-case 178:
-YY_RULE_SETUP
-#line 378 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(OPACITY); }
-	YY_BREAK
-case 179:
-YY_RULE_SETUP
-#line 379 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(CONNECTIONOPTIONS); }
-	YY_BREAK
-case 180:
-YY_RULE_SETUP
-#line 380 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(OUTLINECOLOR); }
-	YY_BREAK
-case 181:
-YY_RULE_SETUP
-#line 381 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(OUTLINEWIDTH); }
-	YY_BREAK
-case 182:
-YY_RULE_SETUP
-#line 382 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(OUTPUTFORMAT); }
-	YY_BREAK
-case 183:
-YY_RULE_SETUP
-#line 383 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(PARTIALS); }
-	YY_BREAK
-case 184:
-YY_RULE_SETUP
-#line 384 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(PATTERN); }
-	YY_BREAK
-case 185:
-YY_RULE_SETUP
-#line 385 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(POINTS); }
-	YY_BREAK
-case 186:
-YY_RULE_SETUP
-#line 386 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(ITEMS); }
-	YY_BREAK
-case 187:
-YY_RULE_SETUP
-#line 387 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(POSITION); }
-	YY_BREAK
-case 188:
-YY_RULE_SETUP
-#line 388 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(POSTLABELCACHE); }
-	YY_BREAK
-case 189:
-YY_RULE_SETUP
-#line 389 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(PRIORITY); }
-	YY_BREAK
-case 190:
-YY_RULE_SETUP
-#line 390 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(PROCESSING); }
-	YY_BREAK
-case 191:
-YY_RULE_SETUP
-#line 391 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(PROJECTION); }
-	YY_BREAK
-case 192:
-YY_RULE_SETUP
-#line 392 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(QUERYFORMAT); }
-	YY_BREAK
-case 193:
-YY_RULE_SETUP
-#line 393 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(QUERYMAP); }
-	YY_BREAK
-case 194:
-YY_RULE_SETUP
-#line 394 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(REFERENCE); }
-	YY_BREAK
-case 195:
-YY_RULE_SETUP
-#line 395 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(REGION); }
-	YY_BREAK
-case 196:
-YY_RULE_SETUP
-#line 396 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(RELATIVETO); }
-	YY_BREAK
-case 197:
-YY_RULE_SETUP
-#line 397 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(REQUIRES); }
-	YY_BREAK
-case 198:
-YY_RULE_SETUP
-#line 398 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(RESOLUTION); }
-	YY_BREAK
-case 199:
-YY_RULE_SETUP
-#line 399 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(DEFRESOLUTION); }
-	YY_BREAK
-case 200:
-YY_RULE_SETUP
-#line 400 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SCALE); }
-	YY_BREAK
-case 201:
-YY_RULE_SETUP
-#line 401 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SCALEDENOM); }
-	YY_BREAK
-case 202:
-YY_RULE_SETUP
-#line 402 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SCALEBAR); }
-	YY_BREAK
-case 203:
-YY_RULE_SETUP
-#line 403 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SCALETOKEN); }
-	YY_BREAK
-case 204:
-YY_RULE_SETUP
-#line 404 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SHADOWCOLOR); }
-	YY_BREAK
-case 205:
-YY_RULE_SETUP
-#line 405 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SHADOWSIZE); }
-	YY_BREAK
-case 206:
-YY_RULE_SETUP
-#line 406 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SHAPEPATH); }
-	YY_BREAK
-case 207:
-YY_RULE_SETUP
-#line 407 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SIZE); }
-	YY_BREAK
-case 208:
-YY_RULE_SETUP
-#line 408 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SIZEUNITS); }
-	YY_BREAK
-case 209:
-YY_RULE_SETUP
-#line 409 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(STATUS); }
-	YY_BREAK
-case 210:
-YY_RULE_SETUP
-#line 410 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(STYLE); }
-	YY_BREAK
-case 211:
-YY_RULE_SETUP
-#line 411 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(STYLEITEM); }
-	YY_BREAK
-case 212:
-YY_RULE_SETUP
-#line 412 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SYMBOL); }
-	YY_BREAK
-case 213:
-YY_RULE_SETUP
-#line 413 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SYMBOLSCALE); }
-	YY_BREAK
-case 214:
-YY_RULE_SETUP
-#line 414 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SYMBOLSCALEDENOM); }
-	YY_BREAK
-case 215:
-YY_RULE_SETUP
-#line 415 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(SYMBOLSET); }
-	YY_BREAK
-case 216:
-YY_RULE_SETUP
-#line 416 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TABLE); }
-	YY_BREAK
-case 217:
-YY_RULE_SETUP
-#line 417 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TEMPLATE); }
-	YY_BREAK
-case 218:
-YY_RULE_SETUP
-#line 418 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TEXT); }
-	YY_BREAK
-case 219:
-YY_RULE_SETUP
-#line 419 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TILEINDEX); }
-	YY_BREAK
-case 220:
-YY_RULE_SETUP
-#line 420 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TILEITEM); }
-	YY_BREAK
-case 221:
-YY_RULE_SETUP
-#line 421 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TILESRS); }
-	YY_BREAK
-case 222:
-YY_RULE_SETUP
-#line 422 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TITLE); }
-	YY_BREAK
-case 223:
-YY_RULE_SETUP
-#line 423 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TO); }
-	YY_BREAK
-case 224:
-YY_RULE_SETUP
-#line 424 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TOLERANCE); }
-	YY_BREAK
-case 225:
-YY_RULE_SETUP
-#line 425 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TOLERANCEUNITS); }
-	YY_BREAK
-case 226:
-YY_RULE_SETUP
-#line 426 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TRANSPARENT); }
-	YY_BREAK
-case 227:
-YY_RULE_SETUP
-#line 427 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TRANSFORM); }
-	YY_BREAK
-case 228:
-YY_RULE_SETUP
-#line 428 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(TYPE); }
-	YY_BREAK
-case 229:
-YY_RULE_SETUP
-#line 429 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(UNITS); }
-	YY_BREAK
-case 230:
-YY_RULE_SETUP
-#line 430 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(UTFDATA); }
-	YY_BREAK
-case 231:
-YY_RULE_SETUP
-#line 431 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(UTFITEM); }
-	YY_BREAK
-case 232:
-YY_RULE_SETUP
-#line 432 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(VALIDATION); }
-	YY_BREAK
-case 233:
-YY_RULE_SETUP
-#line 433 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(VALUES); }
-	YY_BREAK
-case 234:
-YY_RULE_SETUP
-#line 434 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(WEB); }
-	YY_BREAK
-case 235:
-YY_RULE_SETUP
-#line 435 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(WIDTH); }
-	YY_BREAK
-case 236:
-YY_RULE_SETUP
-#line 436 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(WKT); }
-	YY_BREAK
-case 237:
-YY_RULE_SETUP
-#line 437 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(WRAP); }
-	YY_BREAK
-case 238:
-YY_RULE_SETUP
-#line 439 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_ANNOTATION); }
-	YY_BREAK
-case 239:
-YY_RULE_SETUP
-#line 440 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_AUTO); }
-	YY_BREAK
-case 240:
-YY_RULE_SETUP
-#line 441 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_AUTO2); }
-	YY_BREAK
-case 241:
-YY_RULE_SETUP
-#line 442 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CJC_BEVEL); }
-	YY_BREAK
-case 242:
-YY_RULE_SETUP
-#line 443 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_BITMAP); }
-	YY_BREAK
-case 243:
-YY_RULE_SETUP
-#line 444 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CJC_BUTT); }
-	YY_BREAK
-case 244:
-YY_RULE_SETUP
-#line 445 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CC); }
-	YY_BREAK
-case 245:
-YY_RULE_SETUP
-#line 446 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_ALIGN_CENTER); }
-	YY_BREAK
-case 246:
-YY_RULE_SETUP
-#line 447 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_CHART); }
-	YY_BREAK
-case 247:
-YY_RULE_SETUP
-#line 448 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_CIRCLE); }
-	YY_BREAK
-case 248:
-YY_RULE_SETUP
-#line 449 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CL); }
-	YY_BREAK
-case 249:
-YY_RULE_SETUP
-#line 450 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CR); }
-	YY_BREAK
-case 250:
-YY_RULE_SETUP
-#line 451 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_DB_CSV); }
-	YY_BREAK
-case 251:
-YY_RULE_SETUP
-#line 452 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_DB_POSTGRES); }
-	YY_BREAK
-case 252:
-YY_RULE_SETUP
-#line 453 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_DB_MYSQL); }
-	YY_BREAK
-case 253:
-YY_RULE_SETUP
-#line 454 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_DEFAULT); }
-	YY_BREAK
-case 254:
-YY_RULE_SETUP
-#line 455 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_DD); }
-	YY_BREAK
-case 255:
-YY_RULE_SETUP
-#line 456 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_ELLIPSE); }
-	YY_BREAK
-case 256:
-YY_RULE_SETUP
-#line 457 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_EMBED); }
-	YY_BREAK
-case 257:
-YY_RULE_SETUP
-#line 458 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_FALSE); }
-	YY_BREAK
-case 258:
-YY_RULE_SETUP
-#line 459 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_FEET); }
-	YY_BREAK
-case 259:
-YY_RULE_SETUP
-#line 460 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_FOLLOW); }
-	YY_BREAK
-case 260:
-YY_RULE_SETUP
-#line 461 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_GIANT); }
-	YY_BREAK
-case 261:
-YY_RULE_SETUP
-#line 462 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_HATCH); }
-	YY_BREAK
-case 262:
-YY_RULE_SETUP
-#line 463 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_KERNELDENSITY); }
-	YY_BREAK
-case 263:
-YY_RULE_SETUP
-#line 464 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_IDW); }
-	YY_BREAK
-case 264:
-YY_RULE_SETUP
-#line 465 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_HILITE); }
-	YY_BREAK
-case 265:
-YY_RULE_SETUP
-#line 466 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_INCHES); }
-	YY_BREAK
-case 266:
-YY_RULE_SETUP
-#line 467 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_KILOMETERS); }
-	YY_BREAK
-case 267:
-YY_RULE_SETUP
-#line 468 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LARGE); }
-	YY_BREAK
-case 268:
-YY_RULE_SETUP
-#line 469 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LC); }
-	YY_BREAK
-case 269:
-YY_RULE_SETUP
-#line 470 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_ALIGN_LEFT); }
-	YY_BREAK
-case 270:
-YY_RULE_SETUP
-#line 471 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_LINE); }
-	YY_BREAK
-case 271:
-YY_RULE_SETUP
-#line 472 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LL); }
-	YY_BREAK
-case 272:
-YY_RULE_SETUP
-#line 473 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LR); }
-	YY_BREAK
-case 273:
-YY_RULE_SETUP
-#line 474 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_MEDIUM); }
-	YY_BREAK
-case 274:
-YY_RULE_SETUP
-#line 475 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_METERS); }
-	YY_BREAK
-case 275:
-YY_RULE_SETUP
-#line 476 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_NAUTICALMILES); }
-	YY_BREAK
-case 276:
-YY_RULE_SETUP
-#line 477 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_MILES); }
-	YY_BREAK
-case 277:
-YY_RULE_SETUP
-#line 478 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CJC_MITER); }
-	YY_BREAK
-case 278:
-YY_RULE_SETUP
-#line 479 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_MULTIPLE); }
-	YY_BREAK
-case 279:
-YY_RULE_SETUP
-#line 480 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CJC_NONE); }
-	YY_BREAK
-case 280:
-YY_RULE_SETUP
-#line 481 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_NORMAL); }
-	YY_BREAK
-case 281:
-YY_RULE_SETUP
-#line 482 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_OFF); }
-	YY_BREAK
-case 282:
-YY_RULE_SETUP
-#line 483 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_OGR); }
-	YY_BREAK
-case 283:
-YY_RULE_SETUP
-#line 484 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_FLATGEOBUF); }
-	YY_BREAK
-case 284:
-YY_RULE_SETUP
-#line 485 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_ON); }
-	YY_BREAK
-case 285:
-YY_RULE_SETUP
-#line 486 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_ONE); }
-	YY_BREAK
-case 286:
-YY_RULE_SETUP
-#line 487 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_MANY); }
-	YY_BREAK
-case 287:
-YY_RULE_SETUP
-#line 488 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_ORACLESPATIAL); }
-	YY_BREAK
-case 288:
-YY_RULE_SETUP
-#line 489 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_PERCENTAGES); }
-	YY_BREAK
-case 289:
-YY_RULE_SETUP
-#line 490 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_PIXMAP); }
-	YY_BREAK
-case 290:
-YY_RULE_SETUP
-#line 491 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_PIXELS); }
-	YY_BREAK
-case 291:
-YY_RULE_SETUP
-#line 492 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_POINT); }
-	YY_BREAK
-case 292:
-YY_RULE_SETUP
-#line 493 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_POLYGON); }
-	YY_BREAK
-case 293:
-YY_RULE_SETUP
-#line 494 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_POSTGIS); }
-	YY_BREAK
-case 294:
-YY_RULE_SETUP
-#line 495 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_PLUGIN); }
-	YY_BREAK
-case 295:
-YY_RULE_SETUP
-#line 496 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_QUERY); }
-	YY_BREAK
-case 296:
-YY_RULE_SETUP
-#line 497 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_LAYER_RASTER); }
-	YY_BREAK
-case 297:
-YY_RULE_SETUP
-#line 498 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_ALIGN_RIGHT); }
-	YY_BREAK
-case 298:
-YY_RULE_SETUP
-#line 499 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CJC_ROUND); }
-	YY_BREAK
-case 299:
-YY_RULE_SETUP
-#line 500 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SELECTED); }
-	YY_BREAK
-case 300:
-YY_RULE_SETUP
-#line 501 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SIMPLE); }
-	YY_BREAK
-case 301:
-YY_RULE_SETUP
-#line 502 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SINGLE); }
-	YY_BREAK
-case 302:
-YY_RULE_SETUP
-#line 503 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SMALL); }
-	YY_BREAK
-case 303:
-YY_RULE_SETUP
-#line 504 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CJC_SQUARE); }
-	YY_BREAK
-case 304:
-YY_RULE_SETUP
-#line 505 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SVG); }
-	YY_BREAK
-case 305:
-YY_RULE_SETUP
-#line 506 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(POLAROFFSET); }
-	YY_BREAK
-case 306:
-YY_RULE_SETUP
-#line 507 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TINY); }
-	YY_BREAK
-case 307:
-YY_RULE_SETUP
-#line 508 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CJC_TRIANGLE); }
-	YY_BREAK
-case 308:
-YY_RULE_SETUP
-#line 509 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TRUE); }
-	YY_BREAK
-case 309:
-YY_RULE_SETUP
-#line 510 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_TRUETYPE); }
-	YY_BREAK
-case 310:
-YY_RULE_SETUP
-#line 511 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_UC); }
-	YY_BREAK
-case 311:
-YY_RULE_SETUP
-#line 512 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_UL); }
-	YY_BREAK
-case 312:
-YY_RULE_SETUP
-#line 513 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_UR); }
-	YY_BREAK
-case 313:
-YY_RULE_SETUP
-#line 514 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_UNION); }
-	YY_BREAK
-case 314:
-YY_RULE_SETUP
-#line 515 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_UVRASTER); }
-	YY_BREAK
-case 315:
-YY_RULE_SETUP
-#line 516 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_CONTOUR); }
-	YY_BREAK
-case 316:
-YY_RULE_SETUP
-#line 517 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_VECTOR); }
-	YY_BREAK
-case 317:
-YY_RULE_SETUP
-#line 518 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_WFS); }
-	YY_BREAK
-case 318:
-YY_RULE_SETUP
-#line 519 "maplexer.l"
-{ MS_LEXER_RETURN_TOKEN(MS_WMS); }
-	YY_BREAK
-case 319:
-/* rule 319 can match eol */
-YY_RULE_SETUP
-#line 521 "maplexer.l"
-{
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer,msyytext);
-                                                 return(MS_BINDING);
-                                               }
-	YY_BREAK
-case 320:
-YY_RULE_SETUP
-#line 530 "maplexer.l"
-{ 
-  /* attribute binding - shape (fixed value) */
-  return(MS_TOKEN_BINDING_SHAPE);
-}
-	YY_BREAK
-case 321:
-YY_RULE_SETUP
-#line 534 "maplexer.l"
-{ 
-  /* attribute binding - map cellsize */
-  return(MS_TOKEN_BINDING_MAP_CELLSIZE);
-}
-	YY_BREAK
-case 322:
-YY_RULE_SETUP
-#line 538 "maplexer.l"
-{ 
-  /* attribute binding - data cellsize */
-  return(MS_TOKEN_BINDING_DATA_CELLSIZE);
-}
-	YY_BREAK
-case 323:
-/* rule 323 can match eol */
-YY_RULE_SETUP
-#line 542 "maplexer.l"
-{
-  /* attribute binding - numeric (no quotes) */
-  msyytext++;
-  msyytext[msyyleng-1-1] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_BINDING_DOUBLE);
-}
-	YY_BREAK
-case 324:
-/* rule 324 can match eol */
-YY_RULE_SETUP
-#line 551 "maplexer.l"
-{
-  /* attribute binding - string (single or double quotes) */
-  msyytext+=2;
-  msyytext[msyyleng-2-2] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_BINDING_STRING);
-}
-	YY_BREAK
-case 325:
-/* rule 325 can match eol */
-YY_RULE_SETUP
-#line 560 "maplexer.l"
-{
-  /* attribute binding - time */
-  msyytext+=2;
-  msyytext[msyyleng-2-2] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng,
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_BINDING_TIME);
-}
-	YY_BREAK
-case 326:
-YY_RULE_SETUP
-#line 570 "maplexer.l"
-{
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer,msyytext);
-  msyynumber = atof(msyytext);
-  return(MS_NUMBER); 
-}
-	YY_BREAK
-case 327:
-YY_RULE_SETUP
-#line 578 "maplexer.l"
-{
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer,msyytext);
-  msyynumber = atof(msyytext);
-  return(MS_TOKEN_LITERAL_NUMBER);
-}
-	YY_BREAK
-case 328:
-/* rule 328 can match eol */
-YY_RULE_SETUP
-#line 586 "maplexer.l"
-{
-  msyytext++;
-  msyytext[msyyleng-1-1] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_LITERAL_TIME);
-}
-	YY_BREAK
-case 329:
-/* rule 329 can match eol */
-YY_RULE_SETUP
-#line 595 "maplexer.l"
-{
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-2] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_IREGEX);
-                                               }
-	YY_BREAK
-case 330:
-/* rule 330 can match eol */
-YY_RULE_SETUP
-#line 604 "maplexer.l"
-{
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_REGEX);
-                                               }
-	YY_BREAK
-case 331:
-YY_RULE_SETUP
-#line 613 "maplexer.l"
-{
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_EXPRESSION);
-                                               }
-	YY_BREAK
-case 332:
-YY_RULE_SETUP
-#line 622 "maplexer.l"
-{
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_LIST);
-                                               }
-	YY_BREAK
-case 333:
-YY_RULE_SETUP
-#line 631 "maplexer.l"
-{
-                                                 msyystring_return_state = MS_STRING;
-                                                 msyystring_begin = msyytext[0]; 
-                                                 msyystring_size = 0;
-                                                 msyystring_buffer[0] = '\0';
-                                                 BEGIN(MSSTRING);
-                                              }
-	YY_BREAK
-case 334:
-YY_RULE_SETUP
-#line 639 "maplexer.l"
-{
-                                                if (msyystring_begin == msyytext[0]) {
-                                                   BEGIN(msyystring_begin_state);
-                                                   if (msyystring_return_state == MS_STRING) {
-                                                      if (msyystring_icase && msyyleng==2) {
-                                                         msyystring_icase = MS_FALSE; // reset
-                                                         return MS_ISTRING;
-                                                      } else
-                                                        return MS_STRING;
-                                                   }
-                                                   return msyystring_return_state;
-
-                                                }
-                                                else {
-                                                  int old_size = msyystring_size;
-                                                  msyystring_size += (msyyleng==2) ? 2 : 1;
-                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
-                                                                          msyystring_buffer_size);
-                                                  msyystring_buffer[old_size] = *msyytext;
-                                                  if (msyyleng==2) {
-                                                     msyystring_buffer[old_size+1] = msyytext[1];
-                                                  }
-                                                  msyystring_buffer[msyystring_size] = '\0';
-                                                }
-                                              }
-	YY_BREAK
-case 335:
-YY_RULE_SETUP
-#line 665 "maplexer.l"
-{ 
-                                                ++msyystring_size;
-                                                MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
-                                                                        msyystring_buffer_size);
-
-                                                if (msyyleng == 2)
-                                                    msyystring_buffer[msyystring_size-1] = msyytext[1]; 
-                                                else
-                                                    msyystring_buffer[msyystring_size-1] = msyytext[0];
-                                                msyystring_buffer[msyystring_size] = '\0';
-                                             }
-	YY_BREAK
-case 336:
-/* rule 336 can match eol */
-YY_RULE_SETUP
-#line 677 "maplexer.l"
-{
-                                                 int old_size = msyystring_size;
-                                                 msyystring_size += msyyleng;
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
-                                                                         msyystring_buffer_size);
-                                                 memcpy(msyystring_buffer + old_size, msyytext, msyyleng + 1);
-                                             }
-	YY_BREAK
-case 337:
-/* rule 337 can match eol */
-YY_RULE_SETUP
-#line 685 "maplexer.l"
-{
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-
-                                                 if(include_stack_ptr >= MAX_INCLUDE_DEPTH) {
-                                                   msSetError(MS_IOERR, "Includes nested to deeply.", "msyylex()");
-                                                   return(-1);
-                                                 }
-
-                                                 msyyin = fopen(msBuildPath(path, msyybasepath, msyytext), "r");
-                                                 if(!msyyin) {
-                                                   msSetError(MS_IOERR, "Error opening included file \"%s\".", "msyylex()", msyytext);
-                                                   msyyin = YY_CURRENT_BUFFER->yy_input_file;
-                                                   return(-1);
-                                                 }
-
-                                                 include_stack[include_stack_ptr] = YY_CURRENT_BUFFER; /* save state */
-                                                 include_lineno[include_stack_ptr] = msyylineno;
-                                                 include_stack_ptr++;
-
-                                                 msyy_switch_to_buffer( msyy_create_buffer(msyyin, YY_BUF_SIZE) );
-                                                 msyylineno = 1;
-
-                                                 BEGIN(INITIAL);
-                                               }
-	YY_BREAK
-case 338:
-YY_RULE_SETUP
-#line 711 "maplexer.l"
-{
-                                                 msyystring_return_state = MS_TOKEN_LITERAL_STRING;
-                                                 msyystring_begin = msyytext[0]; 
-                                                 msyystring_size = 0;
-                                                 msyystring_buffer[0] = '\0';
-                                                 BEGIN(MSSTRING);
-                                              }
-	YY_BREAK
-case 339:
-YY_RULE_SETUP
-#line 719 "maplexer.l"
-{ 
-                                                    MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                            msyystring_buffer_size);
-                                                    strcpy(msyystring_buffer, msyytext); 
-                                                    return(MS_STRING); 
-                                                }
-	YY_BREAK
-case 340:
-/* rule 340 can match eol */
-YY_RULE_SETUP
-#line 726 "maplexer.l"
-{ msyylineno++; }
-	YY_BREAK
-case YY_STATE_EOF(INITIAL):
-case YY_STATE_EOF(CONFIG_FILE):
-#line 728 "maplexer.l"
-{
-                                                  if( --include_stack_ptr < 0 )
-                                                    return(EOF); /* end of main file */
-                                                  else {
-                                                    fclose(YY_CURRENT_BUFFER->yy_input_file);
-                                                    msyy_delete_buffer( YY_CURRENT_BUFFER );
-                                                    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
-                                                    msyylineno = include_lineno[include_stack_ptr];
-                                                  }
-                                                }
-	YY_BREAK
-case 341:
-/* rule 341 can match eol */
-YY_RULE_SETUP
-#line 739 "maplexer.l"
-{
-  return(0); 
-}
-	YY_BREAK
-case 342:
-YY_RULE_SETUP
-#line 743 "maplexer.l"
-{ 
-                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                          msyystring_buffer_size);
-                                                  strcpy(msyystring_buffer, msyytext); 
-                                                  return(0); 
-                                                }
-	YY_BREAK
-case 343:
-YY_RULE_SETUP
-#line 749 "maplexer.l"
-{ return(msyytext[0]); }
-	YY_BREAK
-case 344:
-YY_RULE_SETUP
-#line 750 "maplexer.l"
-ECHO;
-	YY_BREAK
-#line 4543 "/home/even/mapserver/mapserver/maplexer.c"
-case YY_STATE_EOF(EXPRESSION_STRING):
-case YY_STATE_EOF(INCLUDE):
-case YY_STATE_EOF(MSSTRING):
-case YY_STATE_EOF(MULTILINE_COMMENT):
-	yyterminate();
-
-	case YY_END_OF_BUFFER:
-		{
-		/* Amount of text matched not including the EOB char. */
-		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;
-
-		/* Undo the effects of YY_DO_BEFORE_ACTION. */
-		*yy_cp = (yy_hold_char);
-		YY_RESTORE_YY_MORE_OFFSET
-
-		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
-			{
-			/* We're scanning a new file or input source.  It's
-			 * possible that this happened because the user
-			 * just pointed yyin at a new source and called
-			 * yylex().  If so, then we have to assure
-			 * consistency between YY_CURRENT_BUFFER and our
-			 * globals.  Here is the right place to do so, because
-			 * this is the first action (other than possibly a
-			 * back-up) that will match for the new input source.
-			 */
-			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
-			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
-			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
-			}
-
-		/* Note that here we test for yy_c_buf_p "<=" to the position
-		 * of the first EOB in the buffer, since yy_c_buf_p will
-		 * already have been incremented past the NUL character
-		 * (since all states make transitions on EOB to the
-		 * end-of-buffer state).  Contrast this with the test
-		 * in input().
-		 */
-		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
-			{ /* This was really a NUL. */
-			yy_state_type yy_next_state;
-
-			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;
-
-			yy_current_state = yy_get_previous_state(  );
-
-			/* Okay, we're now positioned to make the NUL
-			 * transition.  We couldn't have
-			 * yy_get_previous_state() go ahead and do it
-			 * for us because it doesn't know how to deal
-			 * with the possibility of jamming (and we don't
-			 * want to build jamming into it because then it
-			 * will run more slowly).
-			 */
-
-			yy_next_state = yy_try_NUL_trans( yy_current_state );
-
-			yy_bp = (yytext_ptr) + YY_MORE_ADJ;
-
-			if ( yy_next_state )
-				{
-				/* Consume the NUL. */
-				yy_cp = ++(yy_c_buf_p);
-				yy_current_state = yy_next_state;
-				goto yy_match;
-				}
-
-			else
-				{
-				yy_cp = (yy_last_accepting_cpos);
-				yy_current_state = (yy_last_accepting_state);
-				goto yy_find_action;
-				}
-			}
-
-		else switch ( yy_get_next_buffer(  ) )
-			{
-			case EOB_ACT_END_OF_FILE:
-				{
-				(yy_did_buffer_switch_on_eof) = 0;
-
-				if ( yywrap(  ) )
-					{
-					/* Note: because we've taken care in
-					 * yy_get_next_buffer() to have set up
-					 * yytext, we can now set up
-					 * yy_c_buf_p so that if some total
-					 * hoser (like flex itself) wants to
-					 * call the scanner after we return the
-					 * YY_NULL, it'll still work - another
-					 * YY_NULL will get returned.
-					 */
-					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;
-
-					yy_act = YY_STATE_EOF(YY_START);
-					goto do_action;
-					}
-
-				else
-					{
-					if ( ! (yy_did_buffer_switch_on_eof) )
-						YY_NEW_FILE;
-					}
-				break;
-				}
-
-			case EOB_ACT_CONTINUE_SCAN:
-				(yy_c_buf_p) =
-					(yytext_ptr) + yy_amount_of_matched_text;
-
-				yy_current_state = yy_get_previous_state(  );
-
-				yy_cp = (yy_c_buf_p);
-				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
-				goto yy_match;
-
-			case EOB_ACT_LAST_MATCH:
-				(yy_c_buf_p) =
-				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];
-
-				yy_current_state = yy_get_previous_state(  );
-
-				yy_cp = (yy_c_buf_p);
-				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
-				goto yy_find_action;
-			}
-		break;
-		}
-
-	default:
-		YY_FATAL_ERROR(
-			"fatal flex scanner internal error--no action found" );
-	} /* end of action switch */
-		} /* end of scanning one token */
-	} /* end of user's declarations */
-} /* end of yylex */
-
-/* yy_get_next_buffer - try to read in a new buffer
- *
- * Returns a code representing an action:
- *	EOB_ACT_LAST_MATCH -
- *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
- *	EOB_ACT_END_OF_FILE - end of file
- */
-static int yy_get_next_buffer (void)
-{
-    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
-	char *source = (yytext_ptr);
-	int number_to_move, i;
-	int ret_val;
-
-	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
-		YY_FATAL_ERROR(
-		"fatal flex scanner internal error--end of buffer missed" );
-
-	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
-		{ /* Don't try to fill the buffer, so this is an EOF. */
-		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
-			{
-			/* We matched a single character, the EOB, so
-			 * treat this as a final EOF.
-			 */
-			return EOB_ACT_END_OF_FILE;
-			}
-
-		else
-			{
-			/* We matched some text prior to the EOB, first
-			 * process it.
-			 */
-			return EOB_ACT_LAST_MATCH;
-			}
-		}
-
-	/* Try to read more data. */
-
-	/* First move last chars to start of buffer. */
-	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);
-
-	for ( i = 0; i < number_to_move; ++i )
-		*(dest++) = *(source++);
-
-	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
-		/* don't do the read, it's not guaranteed to return an EOF,
-		 * just force an EOF
-		 */
-		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;
-
-	else
-		{
-			int num_to_read =
-			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;
-
-		while ( num_to_read <= 0 )
-			{ /* Not enough room in the buffer - grow it. */
-
-			/* just a shorter name for the current buffer */
-			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;
-
-			int yy_c_buf_p_offset =
-				(int) ((yy_c_buf_p) - b->yy_ch_buf);
-
-			if ( b->yy_is_our_buffer )
-				{
-				int new_size = b->yy_buf_size * 2;
-
-				if ( new_size <= 0 )
-					b->yy_buf_size += b->yy_buf_size / 8;
-				else
-					b->yy_buf_size *= 2;
-
-				b->yy_ch_buf = (char *)
-					/* Include room in for 2 EOB chars. */
-					yyrealloc( (void *) b->yy_ch_buf,
-							 (yy_size_t) (b->yy_buf_size + 2)  );
-				}
-			else
-				/* Can't grow it, we don't own it. */
-				b->yy_ch_buf = NULL;
-
-			if ( ! b->yy_ch_buf )
-				YY_FATAL_ERROR(
-				"fatal error - scanner input buffer overflow" );
-
-			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];
-
-			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
-						number_to_move - 1;
-
-			}
-
-		if ( num_to_read > YY_READ_BUF_SIZE )
-			num_to_read = YY_READ_BUF_SIZE;
-
-		/* Read in more data. */
-		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
-			(yy_n_chars), num_to_read );
-
-		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
-		}
-
-	if ( (yy_n_chars) == 0 )
-		{
-		if ( number_to_move == YY_MORE_ADJ )
-			{
-			ret_val = EOB_ACT_END_OF_FILE;
-			yyrestart( yyin  );
-			}
-
-		else
-			{
-			ret_val = EOB_ACT_LAST_MATCH;
-			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
-				YY_BUFFER_EOF_PENDING;
-			}
-		}
-
-	else
-		ret_val = EOB_ACT_CONTINUE_SCAN;
-
-	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
-		/* Extend the array by 50%, plus the number we really need. */
-		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
-		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
-			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
-		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
-			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
-		/* "- 2" to take care of EOB's */
-		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
-	}
-
-	(yy_n_chars) += number_to_move;
-	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
-	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;
-
-	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];
-
-	return ret_val;
-}
-
-/* yy_get_previous_state - get the state just before the EOB char was reached */
-
-    static yy_state_type yy_get_previous_state (void)
-{
-	yy_state_type yy_current_state;
-	char *yy_cp;
-    
-	yy_current_state = (yy_start);
-
-	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
-		{
-		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 86);
-		if ( yy_accept[yy_current_state] )
-			{
-			(yy_last_accepting_state) = yy_current_state;
-			(yy_last_accepting_cpos) = yy_cp;
-			}
-		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
-			{
-			yy_current_state = (int) yy_def[yy_current_state];
-			if ( yy_current_state >= 1732 )
-				yy_c = yy_meta[yy_c];
-			}
-		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
-		}
-
-	return yy_current_state;
-}
-
-/* yy_try_NUL_trans - try to make a transition on the NUL character
- *
- * synopsis
- *	next_state = yy_try_NUL_trans( current_state );
- */
-    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
-{
-	int yy_is_jam;
-    	char *yy_cp = (yy_c_buf_p);
-
-	YY_CHAR yy_c = 86;
-	if ( yy_accept[yy_current_state] )
-		{
-		(yy_last_accepting_state) = yy_current_state;
-		(yy_last_accepting_cpos) = yy_cp;
-		}
-	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
-		{
-		yy_current_state = (int) yy_def[yy_current_state];
-		if ( yy_current_state >= 1732 )
-			yy_c = yy_meta[yy_c];
-		}
-	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
-	yy_is_jam = (yy_current_state == 1731);
-
-		return yy_is_jam ? 0 : yy_current_state;
-}
-
-#ifndef YY_NO_UNPUT
-
-    static void yyunput (int c, char * yy_bp )
-{
-	char *yy_cp;
-    
-    yy_cp = (yy_c_buf_p);
-
-	/* undo effects of setting up yytext */
-	*yy_cp = (yy_hold_char);
-
-	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
-		{ /* need to shift things up to make room */
-		/* +2 for EOB chars. */
-		int number_to_move = (yy_n_chars) + 2;
-		char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
-					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
-		char *source =
-				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];
-
-		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
-			*--dest = *--source;
-
-		yy_cp += (int) (dest - source);
-		yy_bp += (int) (dest - source);
-		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
-			(yy_n_chars) = (int) YY_CURRENT_BUFFER_LVALUE->yy_buf_size;
-
-		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
-			YY_FATAL_ERROR( "flex scanner push-back overflow" );
-		}
-
-	*--yy_cp = (char) c;
-
-	(yytext_ptr) = yy_bp;
-	(yy_hold_char) = *yy_cp;
-	(yy_c_buf_p) = yy_cp;
-}
-
-#endif
-
-#ifndef YY_NO_INPUT
-#ifdef __cplusplus
-    static int yyinput (void)
-#else
-    static int input  (void)
-#endif
-
-{
-	int c;
-    
-	*(yy_c_buf_p) = (yy_hold_char);
-
-	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
-		{
-		/* yy_c_buf_p now points to the character we want to return.
-		 * If this occurs *before* the EOB characters, then it's a
-		 * valid NUL; if not, then we've hit the end of the buffer.
-		 */
-		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
-			/* This was really a NUL. */
-			*(yy_c_buf_p) = '\0';
-
-		else
-			{ /* need more input */
-			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
-			++(yy_c_buf_p);
-
-			switch ( yy_get_next_buffer(  ) )
-				{
-				case EOB_ACT_LAST_MATCH:
-					/* This happens because yy_g_n_b()
-					 * sees that we've accumulated a
-					 * token and flags that we need to
-					 * try matching the token before
-					 * proceeding.  But for input(),
-					 * there's no matching to consider.
-					 * So convert the EOB_ACT_LAST_MATCH
-					 * to EOB_ACT_END_OF_FILE.
-					 */
-
-					/* Reset buffer status. */
-					yyrestart( yyin );
-
-					/*FALLTHROUGH*/
-
-				case EOB_ACT_END_OF_FILE:
-					{
-					if ( yywrap(  ) )
-						return 0;
-
-					if ( ! (yy_did_buffer_switch_on_eof) )
-						YY_NEW_FILE;
-#ifdef __cplusplus
-					return yyinput();
-#else
-					return input();
-#endif
-					}
-
-				case EOB_ACT_CONTINUE_SCAN:
-					(yy_c_buf_p) = (yytext_ptr) + offset;
-					break;
-				}
-			}
-		}
-
-	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
-	*(yy_c_buf_p) = '\0';	/* preserve yytext */
-	(yy_hold_char) = *++(yy_c_buf_p);
-
-	return c;
-}
-#endif	/* ifndef YY_NO_INPUT */
-
-/** Immediately switch to a different input stream.
- * @param input_file A readable stream.
- * 
- * @note This function does not reset the start condition to @c INITIAL .
- */
-    void yyrestart  (FILE * input_file )
-{
-    
-	if ( ! YY_CURRENT_BUFFER ){
-        yyensure_buffer_stack ();
-		YY_CURRENT_BUFFER_LVALUE =
-            yy_create_buffer( yyin, YY_BUF_SIZE );
-	}
-
-	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
-	yy_load_buffer_state(  );
-}
-
-/** Switch to a different input buffer.
- * @param new_buffer The new input buffer.
- * 
- */
-    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
-{
-    
-	/* TODO. We should be able to replace this entire function body
-	 * with
-	 *		yypop_buffer_state();
-	 *		yypush_buffer_state(new_buffer);
-     */
-	yyensure_buffer_stack ();
-	if ( YY_CURRENT_BUFFER == new_buffer )
-		return;
-
-	if ( YY_CURRENT_BUFFER )
-		{
-		/* Flush out information for old buffer. */
-		*(yy_c_buf_p) = (yy_hold_char);
-		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
-		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
-		}
-
-	YY_CURRENT_BUFFER_LVALUE = new_buffer;
-	yy_load_buffer_state(  );
-
-	/* We don't actually know whether we did this switch during
-	 * EOF (yywrap()) processing, but the only time this flag
-	 * is looked at is after yywrap() is called, so it's safe
-	 * to go ahead and always set it.
-	 */
-	(yy_did_buffer_switch_on_eof) = 1;
-}
-
-static void yy_load_buffer_state  (void)
-{
-    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
-	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
-	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
-	(yy_hold_char) = *(yy_c_buf_p);
-}
-
-/** Allocate and initialize an input buffer state.
- * @param file A readable stream.
- * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
- * 
- * @return the allocated buffer state.
- */
-    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
-{
-	YY_BUFFER_STATE b;
-    
-	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
-	if ( ! b )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );
-
-	b->yy_buf_size = size;
-
-	/* yy_ch_buf has to be 2 characters longer than the size given because
-	 * we need to put in 2 end-of-buffer characters.
-	 */
-	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
-	if ( ! b->yy_ch_buf )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );
-
-	b->yy_is_our_buffer = 1;
-
-	yy_init_buffer( b, file );
-
-	return b;
-}
-
-/** Destroy the buffer.
- * @param b a buffer created with yy_create_buffer()
- * 
- */
-    void yy_delete_buffer (YY_BUFFER_STATE  b )
-{
-    
-	if ( ! b )
-		return;
-
-	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
-		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;
-
-	if ( b->yy_is_our_buffer )
-		yyfree( (void *) b->yy_ch_buf  );
-
-	yyfree( (void *) b  );
-}
-
-/* Initializes or reinitializes a buffer.
- * This function is sometimes called more than once on the same buffer,
- * such as during a yyrestart() or at EOF.
- */
-    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )
-
-{
-	int oerrno = errno;
-    
-	yy_flush_buffer( b );
-
-	b->yy_input_file = file;
-	b->yy_fill_buffer = 1;
-
-    /* If b is the current buffer, then yy_init_buffer was _probably_
-     * called from yyrestart() or through yy_get_next_buffer.
-     * In that case, we don't want to reset the lineno or column.
-     */
-    if (b != YY_CURRENT_BUFFER){
-        b->yy_bs_lineno = 1;
-        b->yy_bs_column = 0;
-    }
-
-        b->yy_is_interactive = 0;
-    
-	errno = oerrno;
-}
-
-/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
- * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
- * 
- */
-    void yy_flush_buffer (YY_BUFFER_STATE  b )
-{
-    	if ( ! b )
-		return;
-
-	b->yy_n_chars = 0;
-
-	/* We always need two end-of-buffer characters.  The first causes
-	 * a transition to the end-of-buffer state.  The second causes
-	 * a jam in that state.
-	 */
-	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
-	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;
-
-	b->yy_buf_pos = &b->yy_ch_buf[0];
-
-	b->yy_at_bol = 1;
-	b->yy_buffer_status = YY_BUFFER_NEW;
-
-	if ( b == YY_CURRENT_BUFFER )
-		yy_load_buffer_state(  );
-}
-
-/** Pushes the new state onto the stack. The new state becomes
- *  the current state. This function will allocate the stack
- *  if necessary.
- *  @param new_buffer The new state.
- *  
- */
-void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
-{
-    	if (new_buffer == NULL)
-		return;
-
-	yyensure_buffer_stack();
-
-	/* This block is copied from yy_switch_to_buffer. */
-	if ( YY_CURRENT_BUFFER )
-		{
-		/* Flush out information for old buffer. */
-		*(yy_c_buf_p) = (yy_hold_char);
-		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
-		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
-		}
-
-	/* Only push if top exists. Otherwise, replace top. */
-	if (YY_CURRENT_BUFFER)
-		(yy_buffer_stack_top)++;
-	YY_CURRENT_BUFFER_LVALUE = new_buffer;
-
-	/* copied from yy_switch_to_buffer. */
-	yy_load_buffer_state(  );
-	(yy_did_buffer_switch_on_eof) = 1;
-}
-
-/** Removes and deletes the top of the stack, if present.
- *  The next element becomes the new top.
- *  
- */
-void yypop_buffer_state (void)
-{
-    	if (!YY_CURRENT_BUFFER)
-		return;
-
-	yy_delete_buffer(YY_CURRENT_BUFFER );
-	YY_CURRENT_BUFFER_LVALUE = NULL;
-	if ((yy_buffer_stack_top) > 0)
-		--(yy_buffer_stack_top);
-
-	if (YY_CURRENT_BUFFER) {
-		yy_load_buffer_state(  );
-		(yy_did_buffer_switch_on_eof) = 1;
-	}
-}
-
-/* Allocates the stack if it does not exist.
- *  Guarantees space for at least one push.
- */
-static void yyensure_buffer_stack (void)
-{
-	yy_size_t num_to_alloc;
-    
-	if (!(yy_buffer_stack)) {
-
-		/* First allocation is just for 2 elements, since we don't know if this
-		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
-		 * immediate realloc on the next call.
-         */
-      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
-		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
-								(num_to_alloc * sizeof(struct yy_buffer_state*)
-								);
-		if ( ! (yy_buffer_stack) )
-			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
-
-		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
-
-		(yy_buffer_stack_max) = num_to_alloc;
-		(yy_buffer_stack_top) = 0;
-		return;
-	}
-
-	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){
-
-		/* Increase the buffer to prepare for a possible push. */
-		yy_size_t grow_size = 8 /* arbitrary grow size */;
-
-		num_to_alloc = (yy_buffer_stack_max) + grow_size;
-		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
-								((yy_buffer_stack),
-								num_to_alloc * sizeof(struct yy_buffer_state*)
-								);
-		if ( ! (yy_buffer_stack) )
-			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
-
-		/* zero only the new slots.*/
-		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
-		(yy_buffer_stack_max) = num_to_alloc;
-	}
-}
-
-/** Setup the input buffer state to scan directly from a user-specified character buffer.
- * @param base the character buffer
- * @param size the size in bytes of the character buffer
- * 
- * @return the newly allocated buffer state object.
- */
-YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
-{
-	YY_BUFFER_STATE b;
-    
-	if ( size < 2 ||
-	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
-	     base[size-1] != YY_END_OF_BUFFER_CHAR )
-		/* They forgot to leave room for the EOB's. */
-		return NULL;
-
-	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
-	if ( ! b )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );
-
-	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
-	b->yy_buf_pos = b->yy_ch_buf = base;
-	b->yy_is_our_buffer = 0;
-	b->yy_input_file = NULL;
-	b->yy_n_chars = b->yy_buf_size;
-	b->yy_is_interactive = 0;
-	b->yy_at_bol = 1;
-	b->yy_fill_buffer = 0;
-	b->yy_buffer_status = YY_BUFFER_NEW;
-
-	yy_switch_to_buffer( b  );
-
-	return b;
-}
-
-/** Setup the input buffer state to scan a string. The next call to yylex() will
- * scan from a @e copy of @a str.
- * @param yystr a NUL-terminated string to scan
- * 
- * @return the newly allocated buffer state object.
- * @note If you want to scan bytes that may contain NUL values, then use
- *       yy_scan_bytes() instead.
- */
-YY_BUFFER_STATE yy_scan_string (const char * yystr )
-{
-    
-	return yy_scan_bytes( yystr, (int) strlen(yystr) );
-}
-
-/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
- * scan from a @e copy of @a bytes.
- * @param yybytes the byte buffer to scan
- * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
- * 
- * @return the newly allocated buffer state object.
- */
-YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
-{
-	YY_BUFFER_STATE b;
-	char *buf;
-	yy_size_t n;
-	int i;
-    
-	/* Get memory for full buffer, including space for trailing EOB's. */
-	n = (yy_size_t) (_yybytes_len + 2);
-	buf = (char *) yyalloc( n  );
-	if ( ! buf )
-		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );
-
-	for ( i = 0; i < _yybytes_len; ++i )
-		buf[i] = yybytes[i];
-
-	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;
-
-	b = yy_scan_buffer( buf, n );
-	if ( ! b )
-		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );
-
-	/* It's okay to grow etc. this buffer, and we should throw it
-	 * away when we're done.
-	 */
-	b->yy_is_our_buffer = 1;
-
-	return b;
-}
-
-#ifndef YY_EXIT_FAILURE
-#define YY_EXIT_FAILURE 2
-#endif
-
-static void yynoreturn yy_fatal_error (const char* msg )
-{
-			fprintf( stderr, "%s\n", msg );
-	exit( YY_EXIT_FAILURE );
-}
-
-/* Redefine yyless() so it works in section 3 code. */
-
-#undef yyless
-#define yyless(n) \
-	do \
-		{ \
-		/* Undo effects of setting up yytext. */ \
-        int yyless_macro_arg = (n); \
-        YY_LESS_LINENO(yyless_macro_arg);\
-		yytext[yyleng] = (yy_hold_char); \
-		(yy_c_buf_p) = yytext + yyless_macro_arg; \
-		(yy_hold_char) = *(yy_c_buf_p); \
-		*(yy_c_buf_p) = '\0'; \
-		yyleng = yyless_macro_arg; \
-		} \
-	while ( 0 )
-
-/* Accessor  methods (get/set functions) to struct members. */
-
-/** Get the current line number.
- * 
- */
-int yyget_lineno  (void)
-{
-    
-    return yylineno;
-}
-
-/** Get the input stream.
- * 
- */
-FILE *yyget_in  (void)
-{
-        return yyin;
-}
-
-/** Get the output stream.
- * 
- */
-FILE *yyget_out  (void)
-{
-        return yyout;
-}
-
-/** Get the length of the current token.
- * 
- */
-int yyget_leng  (void)
-{
-        return yyleng;
-}
-
-/** Get the current token.
- * 
- */
-
-char *yyget_text  (void)
-{
-        return yytext;
-}
-
-/** Set the current line number.
- * @param _line_number line number
- * 
- */
-void yyset_lineno (int  _line_number )
-{
-    
-    yylineno = _line_number;
-}
-
-/** Set the input stream. This does not discard the current
- * input buffer.
- * @param _in_str A readable stream.
- * 
- * @see yy_switch_to_buffer
- */
-void yyset_in (FILE *  _in_str )
-{
-        yyin = _in_str ;
-}
-
-void yyset_out (FILE *  _out_str )
-{
-        yyout = _out_str ;
-}
-
-int yyget_debug  (void)
-{
-        return yy_flex_debug;
-}
-
-void yyset_debug (int  _bdebug )
-{
-        yy_flex_debug = _bdebug ;
-}
-
-static int yy_init_globals (void)
-{
-        /* Initialization is the same as for the non-reentrant scanner.
-     * This function is called from yylex_destroy(), so don't allocate here.
-     */
-
-    (yy_buffer_stack) = NULL;
-    (yy_buffer_stack_top) = 0;
-    (yy_buffer_stack_max) = 0;
-    (yy_c_buf_p) = NULL;
-    (yy_init) = 0;
-    (yy_start) = 0;
-
-/* Defined in main.c */
-#ifdef YY_STDINIT
-    yyin = stdin;
-    yyout = stdout;
-#else
-    yyin = NULL;
-    yyout = NULL;
-#endif
-
-    /* For future reference: Set errno on error, since we are called by
-     * yylex_init()
-     */
-    return 0;
-}
-
-/* yylex_destroy is for both reentrant and non-reentrant scanners. */
-int yylex_destroy  (void)
-{
-    
-    /* Pop the buffer stack, destroying each element. */
-	while(YY_CURRENT_BUFFER){
-		yy_delete_buffer( YY_CURRENT_BUFFER  );
-		YY_CURRENT_BUFFER_LVALUE = NULL;
-		yypop_buffer_state();
-	}
-
-	/* Destroy the stack itself. */
-	yyfree((yy_buffer_stack) );
-	(yy_buffer_stack) = NULL;
-
-    /* Reset the globals. This is important in a non-reentrant scanner so the next time
-     * yylex() is called, initialization will occur. */
-    yy_init_globals( );
-
-    return 0;
-}
-
-/*
- * Internal utility routines.
- */
-
-#ifndef yytext_ptr
-static void yy_flex_strncpy (char* s1, const char * s2, int n )
-{
-		
-	int i;
-	for ( i = 0; i < n; ++i )
-		s1[i] = s2[i];
-}
-#endif
-
-#ifdef YY_NEED_STRLEN
-static int yy_flex_strlen (const char * s )
-{
-	int n;
-	for ( n = 0; s[n]; ++n )
-		;
-
-	return n;
-}
-#endif
-
-void *yyalloc (yy_size_t  size )
-{
-			return malloc(size);
-}
-
-void *yyrealloc  (void * ptr, yy_size_t  size )
-{
-		
-	/* The cast to (char *) in the following accommodates both
-	 * implementations that use char* generic pointers, and those
-	 * that use void* generic pointers.  It works with the latter
-	 * because both ANSI C and C++ allow castless assignment from
-	 * any pointer type to void*, and deal with argument conversions
-	 * as though doing an assignment.
-	 */
-	return realloc(ptr, size);
-}
-
-void yyfree (void * ptr )
-{
-			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
-}
-
-#define YYTABLES_NAME "yytables"
-
-#line 750 "maplexer.l"
-
-
-/*
-** Any extra C functions
-*/
-
-int msyywrap() /* override */
-{
-  return(1);
-}
-
-int msyyerror(char *s) {
-  msSetError(MS_PARSEERR, "%s", "msyyparse()", s);
-  return(0);
-}
-
-/* cleanup any open includes */
-void msyycleanup_includes() {
-  while( --include_stack_ptr >= 0 ) {
-    fclose(YY_CURRENT_BUFFER->yy_input_file);
-    msyy_delete_buffer( YY_CURRENT_BUFFER );
-    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
-  }
-}
-
diff -pruN 8.0.1-5/maplexer.l 8.2.0~beta1-1~exp1/maplexer.l
--- 8.0.1-5/maplexer.l	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maplexer.l	1970-01-01 00:00:00.000000000 +0000
@@ -1,772 +0,0 @@
-%option never-interactive
-
-%{
-/*
-** READ ME FIRST!
-**
-** When this file is altered, it is necessary to do "make lexer".  Due to
-** problems detailed in #2310 the lexer is no longer automatically rebuilt
-** when maplexer.l is altered.
-*/
-
-#define YY_NO_INPUT
-
-/* C declarations */
-#include <stdlib.h>
-#include <stdio.h>
-#include <string.h>
-#include <math.h>
-
-#include <time.h>
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapfile.h"
-#include "maptime.h"
-#include "mapsymbol.h"
-#include "mapparser.h"
-#include "mapprimitive.h"
-
-/* msyylineno is required for flex 2.5.4 and older, but is already defined by
- * flex 2.5.31 (bug 975).
- * Unfortunately there is no clean way to differenciate the two versions,
- * so we use the symbol YY_CURRENT_BUFFER_LVALUE to base our test since it
- * was not present in 2.5.4 and is present in 2.5.31. Hopefully that won't
- * put us in trouble with other versions. If that happens then we can
- * switch to using autoconf to detect the version.
- */
-#ifndef YY_CURRENT_BUFFER_LVALUE
-int msyylineno = 1;
-#endif
-
-#define YY_NO_INPUT
-
-/* Below is a redefinition of the default YY_INPUT() macro but replacing the
- * YY_FATAL_ERROR() macro with a call to msSetError().
- */
-/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
- * is returned in "result".
- */
-#define YY_INPUT(buf,result,max_size) \
-	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
-		{ \
-		int c = '*'; \
-		int n; \
-		for ( n = 0; n < max_size && \
-			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
-			buf[n] = (char) c; \
-		if ( c == '\n' ) \
-			buf[n++] = (char) c; \
-		if ( c == EOF && ferror( yyin ) ) \
-            msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
-		result = n; \
-		} \
-	else \
-		{ \
-		errno=0; \
-		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
-			{ \
-			if( errno != EINTR) \
-				{ \
-                msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
-				break; \
-				} \
-			errno=0; \
-			clearerr(yyin); \
-			} \
-		}
-
-int msyysource=MS_STRING_TOKENS;
-double msyynumber;
-int msyystate=MS_TOKENIZE_DEFAULT;
-char *msyystring=NULL;
-char *msyybasepath=NULL;
-int  msyystring_buffer_size = 0;
-int  msyystring_size;
-char msyystring_begin;
-char *msyystring_buffer = NULL;
-int  msyystring_icase = MS_FALSE;
-int  msyystring_return_state;
-int  msyystring_begin_state;
-
-int msyyreturncomments = 0;
-
-#define MS_LEXER_STRING_REALLOC(string, string_size, max_size)   \
-  do { \
-   const int string_size_macro = (int)(string_size); \
-   if (string_size_macro >= (int)(max_size)) {         \
-       max_size = (((int)(max_size)*2) > string_size_macro) ? ((int)(max_size))*2 : string_size_macro+1;   \
-       string = (char *) msSmallRealloc(string, sizeof(char *) * (max_size));  \
-   } \
-  } while(0)
-
-#define MS_LEXER_RETURN_TOKEN(token) \
-   MS_LEXER_STRING_REALLOC(msyystring_buffer, strlen(msyytext),  \
-                           msyystring_buffer_size); \
-   strcpy(msyystring_buffer, msyytext); \
-   return(token); 
-
-#define MAX_INCLUDE_DEPTH 5
-YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
-int include_lineno[MAX_INCLUDE_DEPTH];
-int include_stack_ptr = 0;
-char path[MS_MAXPATHLEN];
-
-%}
-
-%s EXPRESSION_STRING
-%s INCLUDE
-%s MSSTRING
-%s MULTILINE_COMMENT
-%s CONFIG_FILE
-
-%%
-       if (msyystring_buffer == NULL)
-       {
-           msyystring_buffer_size = 256;
-           msyystring_buffer = (char*) msSmallMalloc(sizeof(char) * msyystring_buffer_size);
-       }
-
-       msyystring_buffer[0] = '\0';
-       switch(msyystate) {
-       case(MS_TOKENIZE_DEFAULT):
-         (void) yyunput; /* just to avoid warning about it being unrefed */ 
-         break;
-       case(MS_TOKENIZE_FILE):
-         BEGIN(INITIAL);
-         msyystring_begin_state = INITIAL;
-         msyysource=MS_FILE_TOKENS;
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyystring=NULL;
-         msyyreturncomments=0;
-         include_stack_ptr=0;
-         return(0);
-         break;
-       case(MS_TOKENIZE_STRING):
-         BEGIN(INITIAL);
-         msyystring_begin_state = INITIAL;
-         msyy_delete_buffer(YY_CURRENT_BUFFER);
-         msyy_scan_string(msyystring);
-         msyysource=MS_STRING_TOKENS;
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyyin=NULL;
-         msyyreturncomments=0;
-         include_stack_ptr=0;
-         return(0);
-         break;
-       case(MS_TOKENIZE_EXPRESSION):
-         BEGIN(EXPRESSION_STRING);
-         msyystring_begin_state = EXPRESSION_STRING;
-         msyy_delete_buffer(YY_CURRENT_BUFFER);
-         msyy_scan_string(msyystring);
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyyreturncomments=0;
-         break;
-       case(MS_TOKENIZE_CONFIG):
-         BEGIN(CONFIG_FILE);
-         msyystring_begin_state = CONFIG_FILE;
-         msyysource=MS_FILE_TOKENS;
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyystring=NULL;
-         msyyreturncomments=0;
-         return(0);
-         break;
-       case(99):
-         BEGIN(INITIAL); /* may not need this one */
-         msyystring_begin_state = INITIAL;
-         msyy_delete_buffer(YY_CURRENT_BUFFER);
-         msyystate=MS_TOKENIZE_DEFAULT;
-         msyystring=NULL;
-         msyyreturncomments=0; 
-         return(0);
-         break;
-       default:
-         break;
-       }
-
-<INITIAL,EXPRESSION_STRING,INCLUDE,CONFIG_FILE>[ \t\r]+             ;
-
-<INITIAL,CONFIG_FILE>(\/\/|#).*                { if (msyyreturncomments) return(MS_COMMENT); }
-
-<INITIAL>\/\*                                  { BEGIN(MULTILINE_COMMENT); }
-<MULTILINE_COMMENT>\*\/                        { BEGIN(INITIAL); }
-<MULTILINE_COMMENT>[^*\n]+                     ;
-<MULTILINE_COMMENT>\*                          ;
-<MULTILINE_COMMENT>\n                          { msyylineno++; }
-
-<CONFIG_FILE>config                            { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION); }
-<CONFIG_FILE>env                               { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_ENV); }
-<CONFIG_FILE>maps                              { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_MAPS); }
-<CONFIG_FILE>plugins                           { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_PLUGINS) }
-
-<EXPRESSION_STRING>or|\|\|                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_OR); }
-<EXPRESSION_STRING>and|&&                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_AND); }
-<EXPRESSION_STRING>not|!                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_NOT); }
-<EXPRESSION_STRING>eq|=|==                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQ); }
-<EXPRESSION_STRING>ne|!=                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_NE); }
-<EXPRESSION_STRING>gt|>                        { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GT); }
-<EXPRESSION_STRING>lt|<                        { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LT); }
-<EXPRESSION_STRING>ge|>=                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GE); }
-<EXPRESSION_STRING>le|<=                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LE); }
-<EXPRESSION_STRING>~                           { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_RE); }
-
-<EXPRESSION_STRING>=\*                         { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IEQ); }
-<EXPRESSION_STRING>~\*                         { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IRE); }
-
-<EXPRESSION_STRING>in                          { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IN); /* was IN */ }
-
-<EXPRESSION_STRING>area                        { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_AREA); }
-<EXPRESSION_STRING>length                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LENGTH); }
-<EXPRESSION_STRING>tostring                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_TOSTRING); }
-<EXPRESSION_STRING>commify                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_COMMIFY); }
-<EXPRESSION_STRING>round                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_ROUND); }
-<EXPRESSION_STRING>upper                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_UPPER); }
-<EXPRESSION_STRING>lower                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LOWER); }
-<EXPRESSION_STRING>initcap                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INITCAP); }
-<EXPRESSION_STRING>firstcap                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FIRSTCAP); }
-
-<EXPRESSION_STRING>buffer                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_BUFFER); }
-<EXPRESSION_STRING>difference                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DIFFERENCE); }
-<EXPRESSION_STRING>simplify                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFY); }
-<EXPRESSION_STRING>simplifypt                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFYPT); }
-<EXPRESSION_STRING>generalize                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_GENERALIZE); }
-<EXPRESSION_STRING>smoothsia                   { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SMOOTHSIA); }
-<EXPRESSION_STRING>centerline                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_CENTERLINE); }
-<EXPRESSION_STRING>densify                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DENSIFY); }
-<EXPRESSION_STRING>outer                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_OUTER); }
-<EXPRESSION_STRING>inner                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INNER); } 
-<EXPRESSION_STRING>javascript                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_JAVASCRIPT); }
-
-<EXPRESSION_STRING>intersects                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_INTERSECTS); }
-<EXPRESSION_STRING>disjoint                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DISJOINT); }
-<EXPRESSION_STRING>touches                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_TOUCHES); }
-<EXPRESSION_STRING>overlaps                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_OVERLAPS); }
-<EXPRESSION_STRING>crosses                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CROSSES); }
-<EXPRESSION_STRING>within                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_WITHIN); }
-<EXPRESSION_STRING>contains                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CONTAINS); }
-<EXPRESSION_STRING>equals                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQUALS); }
-<EXPRESSION_STRING>beyond                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_BEYOND); }
-<EXPRESSION_STRING>dwithin                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DWITHIN); }
-
-<EXPRESSION_STRING>fromtext                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FROMTEXT); }
-
-<EXPRESSION_STRING>true                        { msyynumber=MS_TRUE; return(MS_TOKEN_LITERAL_BOOLEAN); }
-<EXPRESSION_STRING>false                       { msyynumber=MS_FALSE; return(MS_TOKEN_LITERAL_BOOLEAN); }
-
-<INITIAL>colorrange                            { MS_LEXER_RETURN_TOKEN(COLORRANGE); }
-<INITIAL>datarange                             { MS_LEXER_RETURN_TOKEN(DATARANGE); }
-<INITIAL>rangeitem                             { MS_LEXER_RETURN_TOKEN(RANGEITEM); }
-
-<INITIAL>align                                 { MS_LEXER_RETURN_TOKEN(ALIGN); }
-<INITIAL>anchorpoint                           { MS_LEXER_RETURN_TOKEN(ANCHORPOINT); }
-<INITIAL>angle                                 { MS_LEXER_RETURN_TOKEN(ANGLE); }
-<INITIAL>antialias                             { MS_LEXER_RETURN_TOKEN(ANTIALIAS); }
-<INITIAL>backgroundcolor                       { MS_LEXER_RETURN_TOKEN(BACKGROUNDCOLOR); }
-<INITIAL>bandsitem                             { MS_LEXER_RETURN_TOKEN(BANDSITEM); }
-<INITIAL>bindvals                              { MS_LEXER_RETURN_TOKEN(BINDVALS); }
-<INITIAL>\xEF\xBB\xBF                          { MS_LEXER_RETURN_TOKEN(BOM); }
-<INITIAL>browseformat                          { MS_LEXER_RETURN_TOKEN(BROWSEFORMAT); }
-<INITIAL>buffer                                { MS_LEXER_RETURN_TOKEN(BUFFER); }
-<INITIAL>character                             { MS_LEXER_RETURN_TOKEN(CHARACTER); }
-<INITIAL>class                                 { MS_LEXER_RETURN_TOKEN(CLASS); }
-<INITIAL>classitem                             { MS_LEXER_RETURN_TOKEN(CLASSITEM); }
-<INITIAL>classgroup                            { MS_LEXER_RETURN_TOKEN(CLASSGROUP); }
-<INITIAL>cluster                               { MS_LEXER_RETURN_TOKEN(CLUSTER); }
-<INITIAL>color                                 { MS_LEXER_RETURN_TOKEN(COLOR); }
-<INITIAL>compfilter                            { MS_LEXER_RETURN_TOKEN(COMPFILTER); }
-<INITIAL>composite                             { MS_LEXER_RETURN_TOKEN(COMPOSITE); }
-<INITIAL>compop                                { MS_LEXER_RETURN_TOKEN(COMPOP); }
-<INITIAL>config                                { MS_LEXER_RETURN_TOKEN(CONFIG); }
-<INITIAL>connection                            { MS_LEXER_RETURN_TOKEN(CONNECTION); }
-<INITIAL>connectiontype                        { MS_LEXER_RETURN_TOKEN(CONNECTIONTYPE); }
-<INITIAL>data                                  { MS_LEXER_RETURN_TOKEN(DATA); }
-<INITIAL>debug                                 { MS_LEXER_RETURN_TOKEN(DEBUG); }
-<INITIAL>driver                                { MS_LEXER_RETURN_TOKEN(DRIVER); }
-<INITIAL>empty                                 { MS_LEXER_RETURN_TOKEN(EMPTY); }
-<INITIAL>encoding                              { MS_LEXER_RETURN_TOKEN(ENCODING); }
-<INITIAL,CONFIG_FILE>end                       { MS_LEXER_RETURN_TOKEN(END); }
-<INITIAL>error                                 { MS_LEXER_RETURN_TOKEN(ERROR); }
-<INITIAL>expression                            { MS_LEXER_RETURN_TOKEN(EXPRESSION); }
-<INITIAL>extent                                { MS_LEXER_RETURN_TOKEN(EXTENT); }
-<INITIAL>extension                             { MS_LEXER_RETURN_TOKEN(EXTENSION); }
-<INITIAL>feature                               { MS_LEXER_RETURN_TOKEN(FEATURE); }
-<INITIAL>filled                                { MS_LEXER_RETURN_TOKEN(FILLED); }
-<INITIAL>filter                                { MS_LEXER_RETURN_TOKEN(FILTER); }
-<INITIAL>filteritem                            { MS_LEXER_RETURN_TOKEN(FILTERITEM); }
-<INITIAL>footer                                { MS_LEXER_RETURN_TOKEN(FOOTER); }
-<INITIAL>font                                  { MS_LEXER_RETURN_TOKEN(FONT); }
-<INITIAL>fontset                               { MS_LEXER_RETURN_TOKEN(FONTSET); }
-<INITIAL>force                                 { MS_LEXER_RETURN_TOKEN(FORCE); }
-<INITIAL>formatoption                          { MS_LEXER_RETURN_TOKEN(FORMATOPTION); }
-<INITIAL>from                                  { MS_LEXER_RETURN_TOKEN(FROM); }
-<INITIAL>gap                                   { MS_LEXER_RETURN_TOKEN(GAP); }
-<INITIAL>geomtransform                         { MS_LEXER_RETURN_TOKEN(GEOMTRANSFORM); }
-<INITIAL>grid                                  { MS_LEXER_RETURN_TOKEN(GRID); }
-<INITIAL>gridstep                              { MS_LEXER_RETURN_TOKEN(GRIDSTEP); }
-<INITIAL>graticule                             { MS_LEXER_RETURN_TOKEN(GRATICULE); }
-<INITIAL>group                                 { MS_LEXER_RETURN_TOKEN(GROUP); }
-<INITIAL>header                                { MS_LEXER_RETURN_TOKEN(HEADER); }
-<INITIAL>image                                 { MS_LEXER_RETURN_TOKEN(IMAGE); }
-<INITIAL>imagecolor                            { MS_LEXER_RETURN_TOKEN(IMAGECOLOR); }
-<INITIAL>imagetype                             { MS_LEXER_RETURN_TOKEN(IMAGETYPE); }
-<INITIAL>imagemode                             { MS_LEXER_RETURN_TOKEN(IMAGEMODE); }
-<INITIAL>imagepath                             { MS_LEXER_RETURN_TOKEN(IMAGEPATH); }
-<INITIAL>temppath                              { MS_LEXER_RETURN_TOKEN(TEMPPATH); }
-<INITIAL>imageurl                              { MS_LEXER_RETURN_TOKEN(IMAGEURL); }
-<INITIAL>include                               { BEGIN(INCLUDE); }
-<INITIAL>index                                 { MS_LEXER_RETURN_TOKEN(INDEX); }
-<INITIAL>initialgap                            { MS_LEXER_RETURN_TOKEN(INITIALGAP); }
-<INITIAL>intervals                             { MS_LEXER_RETURN_TOKEN(INTERVALS); } 
-<INITIAL>join                                  { MS_LEXER_RETURN_TOKEN(JOIN); }
-<INITIAL>keyimage                              { MS_LEXER_RETURN_TOKEN(KEYIMAGE); }
-<INITIAL>keysize                               { MS_LEXER_RETURN_TOKEN(KEYSIZE); }
-<INITIAL>keyspacing                            { MS_LEXER_RETURN_TOKEN(KEYSPACING); }
-<INITIAL>label                                 { MS_LEXER_RETURN_TOKEN(LABEL); }
-<INITIAL>labelcache                            { MS_LEXER_RETURN_TOKEN(LABELCACHE); }
-<INITIAL>labelformat                           { MS_LEXER_RETURN_TOKEN(LABELFORMAT); }
-<INITIAL>labelitem                             { MS_LEXER_RETURN_TOKEN(LABELITEM); }
-<INITIAL>labelmaxscale                         { MS_LEXER_RETURN_TOKEN(LABELMAXSCALE); }
-<INITIAL>labelmaxscaledenom                    { MS_LEXER_RETURN_TOKEN(LABELMAXSCALEDENOM); }
-<INITIAL>labelminscale                         { MS_LEXER_RETURN_TOKEN(LABELMINSCALE); }
-<INITIAL>labelminscaledenom                    { MS_LEXER_RETURN_TOKEN(LABELMINSCALEDENOM); }
-<INITIAL>labelrequires                         { MS_LEXER_RETURN_TOKEN(LABELREQUIRES); }
-<INITIAL>latlon                                { MS_LEXER_RETURN_TOKEN(LATLON); }
-<INITIAL>layer                                 { MS_LEXER_RETURN_TOKEN(LAYER); }
-<INITIAL>leader                                { MS_LEXER_RETURN_TOKEN(LEADER); }
-<INITIAL>legend                                { MS_LEXER_RETURN_TOKEN(LEGEND); }
-<INITIAL>legendformat                          { MS_LEXER_RETURN_TOKEN(LEGENDFORMAT); }
-<INITIAL>linecap                               { MS_LEXER_RETURN_TOKEN(LINECAP); }
-<INITIAL>linejoin                              { MS_LEXER_RETURN_TOKEN(LINEJOIN); }
-<INITIAL>linejoinmaxsize                       { MS_LEXER_RETURN_TOKEN(LINEJOINMAXSIZE); }
-<INITIAL>map                                   { MS_LEXER_RETURN_TOKEN(MAP); }
-<INITIAL>marker                                { MS_LEXER_RETURN_TOKEN(MARKER); }
-<INITIAL>markersize                            { MS_LEXER_RETURN_TOKEN(MARKERSIZE); }
-<INITIAL>mask                                  { MS_LEXER_RETURN_TOKEN(MASK); }
-<INITIAL>maxarcs                               { MS_LEXER_RETURN_TOKEN(MAXARCS); }
-<INITIAL>maxboxsize                            { MS_LEXER_RETURN_TOKEN(MAXBOXSIZE); }
-<INITIAL>maxdistance                           { MS_LEXER_RETURN_TOKEN(MAXDISTANCE); }
-<INITIAL>maxfeatures                           { MS_LEXER_RETURN_TOKEN(MAXFEATURES); }
-<INITIAL>maxinterval                           { MS_LEXER_RETURN_TOKEN(MAXINTERVAL); }
-<INITIAL>maxscale                              { MS_LEXER_RETURN_TOKEN(MAXSCALE); }
-<INITIAL>maxscaledenom                         { MS_LEXER_RETURN_TOKEN(MAXSCALEDENOM); }
-<INITIAL>maxgeowidth                           { MS_LEXER_RETURN_TOKEN(MAXGEOWIDTH); }
-<INITIAL>maxlength                             { MS_LEXER_RETURN_TOKEN(MAXLENGTH); }
-<INITIAL>maxsize                               { MS_LEXER_RETURN_TOKEN(MAXSIZE); }
-<INITIAL>maxsubdivide                          { MS_LEXER_RETURN_TOKEN(MAXSUBDIVIDE); }
-<INITIAL>maxtemplate                           { MS_LEXER_RETURN_TOKEN(MAXTEMPLATE); }
-<INITIAL>maxwidth                              { MS_LEXER_RETURN_TOKEN(MAXWIDTH); }
-<INITIAL>metadata                              { MS_LEXER_RETURN_TOKEN(METADATA); }
-<INITIAL>mimetype                              { MS_LEXER_RETURN_TOKEN(MIMETYPE); }
-<INITIAL>minarcs                               { MS_LEXER_RETURN_TOKEN(MINARCS); }
-<INITIAL>minboxsize                            { MS_LEXER_RETURN_TOKEN(MINBOXSIZE); }
-<INITIAL>mindistance                           { MS_LEXER_RETURN_TOKEN(MINDISTANCE); }
-<INITIAL>repeatdistance                        { MS_LEXER_RETURN_TOKEN(REPEATDISTANCE); }
-<INITIAL>maxoverlapangle                       { MS_LEXER_RETURN_TOKEN(MAXOVERLAPANGLE); } 
-<INITIAL>minfeaturesize                        { MS_LEXER_RETURN_TOKEN(MINFEATURESIZE); }
-<INITIAL>mininterval                           { MS_LEXER_RETURN_TOKEN(MININTERVAL); }
-<INITIAL>minscale                              { MS_LEXER_RETURN_TOKEN(MINSCALE); }
-<INITIAL>minscaledenom                         { MS_LEXER_RETURN_TOKEN(MINSCALEDENOM); }
-<INITIAL>mingeowidth                           { MS_LEXER_RETURN_TOKEN(MINGEOWIDTH); }
-<INITIAL>minsize                               { MS_LEXER_RETURN_TOKEN(MINSIZE); }
-<INITIAL>minsubdivide                          { MS_LEXER_RETURN_TOKEN(MINSUBDIVIDE); }
-<INITIAL>mintemplate                           { MS_LEXER_RETURN_TOKEN(MINTEMPLATE); }
-<INITIAL>minwidth                              { MS_LEXER_RETURN_TOKEN(MINWIDTH); }
-<INITIAL>name                                  { MS_LEXER_RETURN_TOKEN(NAME); }
-<INITIAL>offset                                { MS_LEXER_RETURN_TOKEN(OFFSET); }
-<INITIAL>offsite                               { MS_LEXER_RETURN_TOKEN(OFFSITE); }
-<INITIAL>opacity                               { MS_LEXER_RETURN_TOKEN(OPACITY); }
-<INITIAL>connectionoptions                     { MS_LEXER_RETURN_TOKEN(CONNECTIONOPTIONS); }
-<INITIAL>outlinecolor                          { MS_LEXER_RETURN_TOKEN(OUTLINECOLOR); }
-<INITIAL>outlinewidth                          { MS_LEXER_RETURN_TOKEN(OUTLINEWIDTH); }
-<INITIAL>outputformat                          { MS_LEXER_RETURN_TOKEN(OUTPUTFORMAT); }
-<INITIAL>partials                              { MS_LEXER_RETURN_TOKEN(PARTIALS); }
-<INITIAL>pattern                               { MS_LEXER_RETURN_TOKEN(PATTERN); }
-<INITIAL>points                                { MS_LEXER_RETURN_TOKEN(POINTS); }
-<INITIAL>items                                 { MS_LEXER_RETURN_TOKEN(ITEMS); }
-<INITIAL>position                              { MS_LEXER_RETURN_TOKEN(POSITION); }
-<INITIAL>postlabelcache                        { MS_LEXER_RETURN_TOKEN(POSTLABELCACHE); }
-<INITIAL>priority                              { MS_LEXER_RETURN_TOKEN(PRIORITY); }
-<INITIAL>processing                            { MS_LEXER_RETURN_TOKEN(PROCESSING); }
-<INITIAL>projection                            { MS_LEXER_RETURN_TOKEN(PROJECTION); }
-<INITIAL>queryformat                           { MS_LEXER_RETURN_TOKEN(QUERYFORMAT); }
-<INITIAL>querymap                              { MS_LEXER_RETURN_TOKEN(QUERYMAP); }
-<INITIAL>reference                             { MS_LEXER_RETURN_TOKEN(REFERENCE); }
-<INITIAL>region                                { MS_LEXER_RETURN_TOKEN(REGION); }
-<INITIAL>relativeto                            { MS_LEXER_RETURN_TOKEN(RELATIVETO); }
-<INITIAL>requires                              { MS_LEXER_RETURN_TOKEN(REQUIRES); }
-<INITIAL>resolution                            { MS_LEXER_RETURN_TOKEN(RESOLUTION); }
-<INITIAL>defresolution                         { MS_LEXER_RETURN_TOKEN(DEFRESOLUTION); }
-<INITIAL>scale                                 { MS_LEXER_RETURN_TOKEN(SCALE); }
-<INITIAL>scaledenom                            { MS_LEXER_RETURN_TOKEN(SCALEDENOM); }
-<INITIAL>scalebar                              { MS_LEXER_RETURN_TOKEN(SCALEBAR); }
-<INITIAL>scaletoken                            { MS_LEXER_RETURN_TOKEN(SCALETOKEN); }
-<INITIAL>shadowcolor                           { MS_LEXER_RETURN_TOKEN(SHADOWCOLOR); }
-<INITIAL>shadowsize                            { MS_LEXER_RETURN_TOKEN(SHADOWSIZE); }
-<INITIAL>shapepath                             { MS_LEXER_RETURN_TOKEN(SHAPEPATH); }
-<INITIAL>size                                  { MS_LEXER_RETURN_TOKEN(SIZE); }
-<INITIAL>sizeunits                             { MS_LEXER_RETURN_TOKEN(SIZEUNITS); }
-<INITIAL>status                                { MS_LEXER_RETURN_TOKEN(STATUS); }
-<INITIAL>style                                 { MS_LEXER_RETURN_TOKEN(STYLE); }
-<INITIAL>styleitem                             { MS_LEXER_RETURN_TOKEN(STYLEITEM); }
-<INITIAL>symbol                                { MS_LEXER_RETURN_TOKEN(SYMBOL); }
-<INITIAL>symbolscale                           { MS_LEXER_RETURN_TOKEN(SYMBOLSCALE); }
-<INITIAL>symbolscaledenom                      { MS_LEXER_RETURN_TOKEN(SYMBOLSCALEDENOM); }
-<INITIAL>symbolset                             { MS_LEXER_RETURN_TOKEN(SYMBOLSET); }
-<INITIAL>table                                 { MS_LEXER_RETURN_TOKEN(TABLE); }
-<INITIAL>template                              { MS_LEXER_RETURN_TOKEN(TEMPLATE); }
-<INITIAL>text                                  { MS_LEXER_RETURN_TOKEN(TEXT); }
-<INITIAL>tileindex                             { MS_LEXER_RETURN_TOKEN(TILEINDEX); }
-<INITIAL>tileitem                              { MS_LEXER_RETURN_TOKEN(TILEITEM); }
-<INITIAL>tilesrs                               { MS_LEXER_RETURN_TOKEN(TILESRS); }
-<INITIAL>title                                 { MS_LEXER_RETURN_TOKEN(TITLE); }
-<INITIAL>to                                    { MS_LEXER_RETURN_TOKEN(TO); }
-<INITIAL>tolerance                             { MS_LEXER_RETURN_TOKEN(TOLERANCE); }
-<INITIAL>toleranceunits                        { MS_LEXER_RETURN_TOKEN(TOLERANCEUNITS); }
-<INITIAL>transparent                           { MS_LEXER_RETURN_TOKEN(TRANSPARENT); }
-<INITIAL>transform                             { MS_LEXER_RETURN_TOKEN(TRANSFORM); }
-<INITIAL>type                                  { MS_LEXER_RETURN_TOKEN(TYPE); }
-<INITIAL>units                                 { MS_LEXER_RETURN_TOKEN(UNITS); }
-<INITIAL>utfdata                               { MS_LEXER_RETURN_TOKEN(UTFDATA); }
-<INITIAL>utfitem                               { MS_LEXER_RETURN_TOKEN(UTFITEM); }
-<INITIAL>validation                            { MS_LEXER_RETURN_TOKEN(VALIDATION); }
-<INITIAL>values                                { MS_LEXER_RETURN_TOKEN(VALUES); }
-<INITIAL>web                                   { MS_LEXER_RETURN_TOKEN(WEB); }
-<INITIAL>width                                 { MS_LEXER_RETURN_TOKEN(WIDTH); }
-<INITIAL>wkt                                   { MS_LEXER_RETURN_TOKEN(WKT); }
-<INITIAL>wrap                                  { MS_LEXER_RETURN_TOKEN(WRAP); }
-
-<INITIAL>annotation                            { MS_LEXER_RETURN_TOKEN(MS_LAYER_ANNOTATION); }
-<INITIAL>auto                                  { MS_LEXER_RETURN_TOKEN(MS_AUTO); }
-<INITIAL>auto2                                 { MS_LEXER_RETURN_TOKEN(MS_AUTO2); }
-<INITIAL>bevel                                 { MS_LEXER_RETURN_TOKEN(MS_CJC_BEVEL); }
-<INITIAL>bitmap                                { MS_LEXER_RETURN_TOKEN(MS_BITMAP); }
-<INITIAL>butt                                  { MS_LEXER_RETURN_TOKEN(MS_CJC_BUTT); }
-<INITIAL>cc                                    { MS_LEXER_RETURN_TOKEN(MS_CC); }
-<INITIAL>center                                { MS_LEXER_RETURN_TOKEN(MS_ALIGN_CENTER); }
-<INITIAL>chart                                 { MS_LEXER_RETURN_TOKEN(MS_LAYER_CHART); }
-<INITIAL>circle                                { MS_LEXER_RETURN_TOKEN(MS_LAYER_CIRCLE); }
-<INITIAL>cl                                    { MS_LEXER_RETURN_TOKEN(MS_CL); }
-<INITIAL>cr                                    { MS_LEXER_RETURN_TOKEN(MS_CR); }
-<INITIAL>csv                                   { MS_LEXER_RETURN_TOKEN(MS_DB_CSV); }
-<INITIAL>postgresql                            { MS_LEXER_RETURN_TOKEN(MS_DB_POSTGRES); }
-<INITIAL>mysql                                 { MS_LEXER_RETURN_TOKEN(MS_DB_MYSQL); }
-<INITIAL>default                               { MS_LEXER_RETURN_TOKEN(MS_DEFAULT); }
-<INITIAL>dd                                    { MS_LEXER_RETURN_TOKEN(MS_DD); }
-<INITIAL>ellipse                               { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_ELLIPSE); }
-<INITIAL>embed                                 { MS_LEXER_RETURN_TOKEN(MS_EMBED); }
-<INITIAL>false                                 { MS_LEXER_RETURN_TOKEN(MS_FALSE); }
-<INITIAL>feet                                  { MS_LEXER_RETURN_TOKEN(MS_FEET); }
-<INITIAL>follow                                { MS_LEXER_RETURN_TOKEN(MS_FOLLOW); }
-<INITIAL>giant                                 { MS_LEXER_RETURN_TOKEN(MS_GIANT); }
-<INITIAL>hatch                                 { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_HATCH); }
-<INITIAL>kerneldensity                         { MS_LEXER_RETURN_TOKEN(MS_KERNELDENSITY); }
-<INITIAL>idw                                   { MS_LEXER_RETURN_TOKEN(MS_IDW); }
-<INITIAL>hilite                                { MS_LEXER_RETURN_TOKEN(MS_HILITE); }
-<INITIAL>inches                                { MS_LEXER_RETURN_TOKEN(MS_INCHES); }
-<INITIAL>kilometers                            { MS_LEXER_RETURN_TOKEN(MS_KILOMETERS); }
-<INITIAL>large                                 { MS_LEXER_RETURN_TOKEN(MS_LARGE); }
-<INITIAL>lc                                    { MS_LEXER_RETURN_TOKEN(MS_LC); }
-<INITIAL>left                                  { MS_LEXER_RETURN_TOKEN(MS_ALIGN_LEFT); }
-<INITIAL>line                                  { MS_LEXER_RETURN_TOKEN(MS_LAYER_LINE); }
-<INITIAL>ll                                    { MS_LEXER_RETURN_TOKEN(MS_LL); }
-<INITIAL>lr                                    { MS_LEXER_RETURN_TOKEN(MS_LR); }
-<INITIAL>medium                                { MS_LEXER_RETURN_TOKEN(MS_MEDIUM); }
-<INITIAL>meters                                { MS_LEXER_RETURN_TOKEN(MS_METERS); }
-<INITIAL>nauticalmiles                         { MS_LEXER_RETURN_TOKEN(MS_NAUTICALMILES); }
-<INITIAL>miles                                 { MS_LEXER_RETURN_TOKEN(MS_MILES); }
-<INITIAL>miter                                 { MS_LEXER_RETURN_TOKEN(MS_CJC_MITER); }
-<INITIAL>multiple                              { MS_LEXER_RETURN_TOKEN(MS_MULTIPLE); }
-<INITIAL>none                                  { MS_LEXER_RETURN_TOKEN(MS_CJC_NONE); }
-<INITIAL>normal                                { MS_LEXER_RETURN_TOKEN(MS_NORMAL); }
-<INITIAL>off                                   { MS_LEXER_RETURN_TOKEN(MS_OFF); }
-<INITIAL>ogr                                   { MS_LEXER_RETURN_TOKEN(MS_OGR); }
-<INITIAL>flatgeobuf                            { MS_LEXER_RETURN_TOKEN(MS_FLATGEOBUF); }
-<INITIAL>on                                    { MS_LEXER_RETURN_TOKEN(MS_ON); }
-<INITIAL>one-to-one                            { MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_ONE); }
-<INITIAL>one-to-many                           { MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_MANY); }
-<INITIAL>oraclespatial                         { MS_LEXER_RETURN_TOKEN(MS_ORACLESPATIAL); }
-<INITIAL>percentages                           { MS_LEXER_RETURN_TOKEN(MS_PERCENTAGES); }
-<INITIAL>pixmap                                { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_PIXMAP); }
-<INITIAL>pixels                                { MS_LEXER_RETURN_TOKEN(MS_PIXELS); }
-<INITIAL>point                                 { MS_LEXER_RETURN_TOKEN(MS_LAYER_POINT); }
-<INITIAL>polygon                               { MS_LEXER_RETURN_TOKEN(MS_LAYER_POLYGON); }
-<INITIAL>postgis                               { MS_LEXER_RETURN_TOKEN(MS_POSTGIS); }
-<INITIAL>plugin                                { MS_LEXER_RETURN_TOKEN(MS_PLUGIN); }
-<INITIAL>query                                 { MS_LEXER_RETURN_TOKEN(MS_LAYER_QUERY); }
-<INITIAL>raster                                { MS_LEXER_RETURN_TOKEN(MS_LAYER_RASTER); }
-<INITIAL>right                                 { MS_LEXER_RETURN_TOKEN(MS_ALIGN_RIGHT); }
-<INITIAL>round                                 { MS_LEXER_RETURN_TOKEN(MS_CJC_ROUND); }
-<INITIAL>selected                              { MS_LEXER_RETURN_TOKEN(MS_SELECTED); }
-<INITIAL>simple                                { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SIMPLE); }
-<INITIAL>single                                { MS_LEXER_RETURN_TOKEN(MS_SINGLE); }
-<INITIAL>small                                 { MS_LEXER_RETURN_TOKEN(MS_SMALL); }
-<INITIAL>square                                { MS_LEXER_RETURN_TOKEN(MS_CJC_SQUARE); }
-<INITIAL>svg                                   { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SVG); }
-<INITIAL>polaroffset                           { MS_LEXER_RETURN_TOKEN(POLAROFFSET); }
-<INITIAL>tiny                                  { MS_LEXER_RETURN_TOKEN(MS_TINY); }
-<INITIAL>triangle                              { MS_LEXER_RETURN_TOKEN(MS_CJC_TRIANGLE); }
-<INITIAL>true                                  { MS_LEXER_RETURN_TOKEN(MS_TRUE); }
-<INITIAL>truetype                              { MS_LEXER_RETURN_TOKEN(MS_TRUETYPE); }
-<INITIAL>uc                                    { MS_LEXER_RETURN_TOKEN(MS_UC); }
-<INITIAL>ul                                    { MS_LEXER_RETURN_TOKEN(MS_UL); }
-<INITIAL>ur                                    { MS_LEXER_RETURN_TOKEN(MS_UR); }
-<INITIAL>union                                 { MS_LEXER_RETURN_TOKEN(MS_UNION); }
-<INITIAL>uvraster                              { MS_LEXER_RETURN_TOKEN(MS_UVRASTER); }
-<INITIAL>contour                               { MS_LEXER_RETURN_TOKEN(MS_CONTOUR); }
-<INITIAL>vector                                { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_VECTOR); }
-<INITIAL>wfs                                   { MS_LEXER_RETURN_TOKEN(MS_WFS); }
-<INITIAL>wms                                   { MS_LEXER_RETURN_TOKEN(MS_WMS); }
-
-<INITIAL>\[[^\]]*\]                            {
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer,msyytext);
-                                                 return(MS_BINDING);
-                                               }
-
-<EXPRESSION_STRING>\[shape\] { 
-  /* attribute binding - shape (fixed value) */
-  return(MS_TOKEN_BINDING_SHAPE);
-}
-<EXPRESSION_STRING>\[map_cellsize\] { 
-  /* attribute binding - map cellsize */
-  return(MS_TOKEN_BINDING_MAP_CELLSIZE);
-}
-<EXPRESSION_STRING>\[data_cellsize\] { 
-  /* attribute binding - data cellsize */
-  return(MS_TOKEN_BINDING_DATA_CELLSIZE);
-}
-<EXPRESSION_STRING>\[[^\]]*\] {
-  /* attribute binding - numeric (no quotes) */
-  msyytext++;
-  msyytext[msyyleng-1-1] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_BINDING_DOUBLE);
-}
-<EXPRESSION_STRING>\"\[[^\"]*\]\"|\'\[[^\']*\]\' {
-  /* attribute binding - string (single or double quotes) */
-  msyytext+=2;
-  msyytext[msyyleng-2-2] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_BINDING_STRING);
-}
-<EXPRESSION_STRING>\`\[[^\`]*\]\` {
-  /* attribute binding - time */
-  msyytext+=2;
-  msyytext[msyyleng-2-2] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng,
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_BINDING_TIME);
-}
-
-<INITIAL>-?[0-9]+|-?[0-9]+\.[0-9]*|-?\.[0-9]*|-?[0-9]+[eE][+-]?[0-9]+|-?[0-9]+\.[0-9]*[eE][+-]?[0-9]+|-?\.[0-9]*[eE][+-]?[0-9]+ {
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer,msyytext);
-  msyynumber = atof(msyytext);
-  return(MS_NUMBER); 
-}
-
-<EXPRESSION_STRING>-?[0-9]+|-?[0-9]+\.[0-9]*|-?\.[0-9]*|-?[0-9]+[eE][+-]?[0-9]+|-?[0-9]+\.[0-9]*[eE][+-]?[0-9]+|-?\.[0-9]*[eE][+-]?[0-9]+ {
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer,msyytext);
-  msyynumber = atof(msyytext);
-  return(MS_TOKEN_LITERAL_NUMBER);
-}
-
-<EXPRESSION_STRING>\`[^\`]*\` {
-  msyytext++;
-  msyytext[msyyleng-1-1] = '\0';
-  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                          msyystring_buffer_size);
-  strcpy(msyystring_buffer, msyytext);
-  return(MS_TOKEN_LITERAL_TIME);
-}
-
-<INITIAL>\/[^*]{1}[^\/]*\/i         {
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-2] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_IREGEX);
-                                               }
-
-<INITIAL>\/[^*]{1}[^\/]*\/          {
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_REGEX);
-                                               }
-
-<INITIAL>\(.*\)                     {
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_EXPRESSION);
-                                               }
-
-<INITIAL>\{.*\}                     {
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                         msyystring_buffer_size);
-                                                 strcpy(msyystring_buffer, msyytext);
-                                                 return(MS_LIST);
-                                               }
-
-<INITIAL,CONFIG_FILE>\'|\"         {
-                                                 msyystring_return_state = MS_STRING;
-                                                 msyystring_begin = msyytext[0]; 
-                                                 msyystring_size = 0;
-                                                 msyystring_buffer[0] = '\0';
-                                                 BEGIN(MSSTRING);
-                                              }
-
-<MSSTRING>\'|\"|\"i|\'i                       {
-                                                if (msyystring_begin == msyytext[0]) {
-                                                   BEGIN(msyystring_begin_state);
-                                                   if (msyystring_return_state == MS_STRING) {
-                                                      if (msyystring_icase && msyyleng==2) {
-                                                         msyystring_icase = MS_FALSE; // reset
-                                                         return MS_ISTRING;
-                                                      } else
-                                                        return MS_STRING;
-                                                   }
-                                                   return msyystring_return_state;
-
-                                                }
-                                                else {
-                                                  int old_size = msyystring_size;
-                                                  msyystring_size += (msyyleng==2) ? 2 : 1;
-                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
-                                                                          msyystring_buffer_size);
-                                                  msyystring_buffer[old_size] = *msyytext;
-                                                  if (msyyleng==2) {
-                                                     msyystring_buffer[old_size+1] = msyytext[1];
-                                                  }
-                                                  msyystring_buffer[msyystring_size] = '\0';
-                                                }
-                                              }
-
-<MSSTRING>\\\'|\\\"|\\\\|\\                  { 
-                                                ++msyystring_size;
-                                                MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
-                                                                        msyystring_buffer_size);
-
-                                                if (msyyleng == 2)
-                                                    msyystring_buffer[msyystring_size-1] = msyytext[1]; 
-                                                else
-                                                    msyystring_buffer[msyystring_size-1] = msyytext[0];
-                                                msyystring_buffer[msyystring_size] = '\0';
-                                             }
-
-<MSSTRING>[^\\\'\\\"]+                       {
-                                                 int old_size = msyystring_size;
-                                                 msyystring_size += msyyleng;
-                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
-                                                                         msyystring_buffer_size);
-                                                 memcpy(msyystring_buffer + old_size, msyytext, msyyleng + 1);
-                                             }
-
-<INCLUDE>\"[^\"]*\"|\'[^\']*\'                 {
-                                                 msyytext++;
-                                                 msyytext[msyyleng-1-1] = '\0';
-
-                                                 if(include_stack_ptr >= MAX_INCLUDE_DEPTH) {
-                                                   msSetError(MS_IOERR, "Includes nested to deeply.", "msyylex()");
-                                                   return(-1);
-                                                 }
-
-                                                 msyyin = fopen(msBuildPath(path, msyybasepath, msyytext), "r");
-                                                 if(!msyyin) {
-                                                   msSetError(MS_IOERR, "Error opening included file \"%s\".", "msyylex()", msyytext);
-                                                   msyyin = YY_CURRENT_BUFFER->yy_input_file;
-                                                   return(-1);
-                                                 }
-
-                                                 include_stack[include_stack_ptr] = YY_CURRENT_BUFFER; /* save state */
-                                                 include_lineno[include_stack_ptr] = msyylineno;
-                                                 include_stack_ptr++;
-
-                                                 msyy_switch_to_buffer( msyy_create_buffer(msyyin, YY_BUF_SIZE) );
-                                                 msyylineno = 1;
-
-                                                 BEGIN(INITIAL);
-                                               }
-
-<EXPRESSION_STRING>\'|\"                      {
-                                                 msyystring_return_state = MS_TOKEN_LITERAL_STRING;
-                                                 msyystring_begin = msyytext[0]; 
-                                                 msyystring_size = 0;
-                                                 msyystring_buffer[0] = '\0';
-                                                 BEGIN(MSSTRING);
-                                              }
-
-<INITIAL,CONFIG_FILE>[a-z/\.][a-z0-9/\._\-\=]*   { 
-                                                    MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                            msyystring_buffer_size);
-                                                    strcpy(msyystring_buffer, msyytext); 
-                                                    return(MS_STRING); 
-                                                }
-
-<INITIAL,CONFIG_FILE>\n                        { msyylineno++; }
-
-<INITIAL,CONFIG_FILE><<EOF>>                    {
-                                                  if( --include_stack_ptr < 0 )
-                                                    return(EOF); /* end of main file */
-                                                  else {
-                                                    fclose(YY_CURRENT_BUFFER->yy_input_file);
-                                                    msyy_delete_buffer( YY_CURRENT_BUFFER );
-                                                    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
-                                                    msyylineno = include_lineno[include_stack_ptr];
-                                                  }
-                                                }
-
-<EXPRESSION_STRING>[\r|\n|\0] {
-  return(0); 
-}
-
-<INITIAL,CONFIG_FILE>.                          { 
-                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
-                                                                          msyystring_buffer_size);
-                                                  strcpy(msyystring_buffer, msyytext); 
-                                                  return(0); 
-                                                }
-<EXPRESSION_STRING>.                            { return(msyytext[0]); }
-%%
-
-/*
-** Any extra C functions
-*/
-
-int msyywrap() /* override */
-{
-  return(1);
-}
-
-int msyyerror(char *s) {
-  msSetError(MS_PARSEERR, "%s", "msyyparse()", s);
-  return(0);
-}
-
-/* cleanup any open includes */
-void msyycleanup_includes() {
-  while( --include_stack_ptr >= 0 ) {
-    fclose(YY_CURRENT_BUFFER->yy_input_file);
-    msyy_delete_buffer( YY_CURRENT_BUFFER );
-    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
-  }
-}
diff -pruN 8.0.1-5/maplibxml2.c 8.2.0~beta1-1~exp1/maplibxml2.c
--- 8.0.1-5/maplibxml2.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maplibxml2.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,128 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  libxml2 convenience wrapper functions
- * Author:   Tom Kralidis (tomkralidis@gmail.com)
- *
- ******************************************************************************
- * Copyright (c) 2007, Tom Kralidis
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-#ifdef USE_LIBXML2
-
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-#include<libxml/xpath.h>
-#include<libxml/xpathInternals.h>
-
-
-
-/**
- * msLibXml2GenerateList()
- *
- * Convenience function to produce a series of XML elements from a delimited list
- *
- * @param xmlNodePtr psParent the encompassing node
- * @param xmlNsPtr psNs the namespace object
- * @param const char *elname the list member element name
- * @param const char *values the list member element values
- * @param char delim the delimiter
- *
- */
-
-void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs, const char *elname, const char *values, char delim)
-{
-  char **tokens = NULL;
-  int n = 0;
-  int i = 0;
-  tokens = msStringSplit(values, delim, &n);
-  for (i=0; i<n; i++) {
-    // Not sure we really need to distinguish empty vs non-empty case, but
-    // this does change the result of msautotest/wxs/expected/wcs_empty_cap111.xml otherwise
-    if( tokens[i] && tokens[i][0] != '\0' )
-      xmlNewTextChild(psParent, psNs, BAD_CAST elname, BAD_CAST tokens[i]);
-    else
-      xmlNewChild(psParent, psNs, BAD_CAST elname, BAD_CAST tokens[i]);
-  }
-  msFreeCharArray(tokens, n);
-}
-
-/**
- * msLibXml2GetXPath()
- *
- * Convenience function to fetch an XPath
- *
- * @param xmlDocPtr doc the XML doc pointer
- * @param xmlXPathContextPtr the context pointer
- * @param xmlChar *xpath the xpath value
- *
- * @return result xmlXPathObjectPtr pointer
- *
- */
-
-xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context, xmlChar *xpath)
-{
-  (void)doc;
-  xmlXPathObjectPtr result;
-  result = xmlXPathEval(xpath, context);
-  if (result == NULL) {
-    return NULL;
-  }
-  if(xmlXPathNodeSetIsEmpty(result->nodesetval)) {
-    xmlXPathFreeObject(result);
-    return NULL;
-  }
-  return result;
-}
-
-/**
- * msLibXml2GetXPathTree
- *
- * Convenience function to fetch an XPath and children
- *
- * @param xmlDocPtr doc the XML doc pointer
- * @param xmlXPathObjectPtr the xpath object
- *
- * @return result string
- *
- */
-
-char *msLibXml2GetXPathTree(xmlDocPtr doc, xmlXPathObjectPtr xpath)
-{
-  xmlBufferPtr xbuf;
-  char *result = NULL;
-
-  xbuf = xmlBufferCreate();
-
-  if (xpath) {
-    if (xmlNodeDump(xbuf, doc, xpath->nodesetval->nodeTab[0], 0, 0) == -1) {
-      return NULL;
-    }
-    result = msStrdup((char *)xbuf->content);
-  }
-  xmlBufferFree(xbuf);
-  return result;
-}
-
-#endif /* defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/maplibxml2.h 8.2.0~beta1-1~exp1/maplibxml2.h
--- 8.0.1-5/maplibxml2.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maplibxml2.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,58 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  libxml2 convenience wrapper functions include file
- * Author:   Tom Kralidis (tomkralidis@gmail.com)
- *
- ******************************************************************************
- * Copyright (c) 2007, Tom Kralidis
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPLIBXML2_H
-#define MAPLIBXML2_H
-
-#ifdef USE_LIBXML2
-
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-#include<libxml/xpath.h>
-#include<libxml/xpathInternals.h>
-#include <libxml/xmlschemas.h>
-#include <libxml/xmlschemastypes.h>
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context, xmlChar *xpath);
-
-void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs, const char *elname, const char *values, char delim);
-
-char *msLibXml2GetXPathTree(xmlDocPtr doc, xmlXPathObjectPtr xpath);
-
-#ifdef __cplusplus
-} /* extern C */
-#endif
-
-#endif /* defined(USE_LIBXML2) */
-
-#endif /* MAPLIBXML2_H */
diff -pruN 8.0.1-5/mapmetadata.c 8.2.0~beta1-1~exp1/mapmetadata.c
--- 8.0.1-5/mapmetadata.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapmetadata.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,938 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Metadata implementation
- * Author:   Tom Kralidis (tomkralidis@gmail.com)
- *
- **********************************************************************
- * Copyright (c) 2017, Tom Kralidis
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-#include "mapowscommon.h"
-#include "maplibxml2.h"
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-
-#ifdef USE_LIBXML2
-
-static
-int msMetadataParseRequest(cgiRequestObj *request,
-                      metadataParamsObj *metadataparams);
-
-/************************************************************************/
-/*                   _msMetadataGetCharacterString                      */
-/*                                                                      */
-/*      Create a gmd:name/gmd:CharacterString element pattern           */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetCharacterString(xmlNsPtr namespace, const char *name, const char *value, xmlNsPtr* ppsNsGco) {
-  xmlNodePtr psNode = NULL;
-
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
-
-  psNode = xmlNewNode(namespace, BAD_CAST name);
-
-  if (!value)
-    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
-  else
-    xmlNewChild(psNode, *ppsNsGco, BAD_CAST "CharacterString", BAD_CAST value);
-  return psNode;
-
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetURL                                  */
-/*                                                                      */
-/*      Create a gmd:name/gmd:URL element pattern                       */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetURL(xmlNsPtr namespace, const char *name, const char *value, xmlNsPtr* ppsNsGco) {
-  xmlNodePtr psNode = NULL;
-
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
-
-  psNode = xmlNewNode(namespace, BAD_CAST name);
-
-  if (!value)
-    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
-  else
-    xmlNewChild(psNode, namespace, BAD_CAST "URL", BAD_CAST value);
-  return psNode;
-
-}
-
-/************************************************************************/
-/*                   _msMetadataGetOnline                               */
-/*                                                                      */
-/*               Create a gmd:onLine element pattern                    */
-/************************************************************************/
-
-static char* _stringConcatenateAndEncodeHTML(char* str, const char* appendStr)
-{
-  char* pszTmp = msEncodeHTMLEntities(appendStr);
-  str = msStringConcatenate(str, pszTmp);
-  msFree(pszTmp);
-  return str;
-}
-
-static
-xmlNodePtr _msMetadataGetOnline(xmlNsPtr namespace, layerObj *layer, const char *service, const char *format, const char *desc, const char *url_in, xmlNsPtr* ppsNsGco) {
-
-  int status;
-  char *url = NULL;
-  char buffer[32];
-  const char *link_protocol = "unknown protocol";
-
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psORNode = NULL;
-
-  rectObj rect;
-
-  psNode = xmlNewNode(namespace, BAD_CAST "onLine");
-  psORNode = xmlNewChild(psNode, namespace, BAD_CAST "CI_OnlineResource", NULL);
-
-  url = msStrdup(url_in);
-
-  if (strcasecmp(service, "M") == 0) {
-    url = _stringConcatenateAndEncodeHTML(url, "service=WMS&version=1.3.0&request=GetMap&width=500&height=300&styles=&layers=");
-    url = _stringConcatenateAndEncodeHTML(url, layer->name);
-    url = _stringConcatenateAndEncodeHTML(url, "&format=");
-    url = _stringConcatenateAndEncodeHTML(url, format);
-    url = _stringConcatenateAndEncodeHTML(url, "&crs=");
-    {
-        char* epsg_str = NULL;
-        msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO", MS_TRUE, &epsg_str);
-        url = _stringConcatenateAndEncodeHTML(url, epsg_str);
-        msFree(epsg_str);
-    }
-    link_protocol = "WWW:DOWNLOAD-1.0-http-get-map";
-
-    status = msLayerGetExtent(layer, &rect);
-
-    if (status == 0) {
-      url = _stringConcatenateAndEncodeHTML(url, "&bbox=");
-      sprintf(buffer, "%f", rect.miny);
-      url = msStringConcatenate(url, buffer);
-      url = msStringConcatenate(url, ",");
-      sprintf(buffer, "%f", rect.minx);
-      url = msStringConcatenate(url, buffer);
-      url = msStringConcatenate(url, ",");
-      sprintf(buffer, "%f", rect.maxy);
-      url = msStringConcatenate(url, buffer);
-      url = msStringConcatenate(url, ",");
-      sprintf(buffer, "%f", rect.maxx);
-      url = msStringConcatenate(url, buffer);
-    }
-  }
-  else if (strcasecmp(service, "F") == 0) {
-    link_protocol = "WWW:DOWNLOAD-1.0-http--download";
-    url = _stringConcatenateAndEncodeHTML(url, "service=WFS&version=1.1.0&request=GetFeature&typename=");
-    url = _stringConcatenateAndEncodeHTML(url, layer->name);
-    url = _stringConcatenateAndEncodeHTML(url, "&outputformat=");
-    url = _stringConcatenateAndEncodeHTML(url, format);
-  }
-  else if (strcasecmp(service, "C") == 0) {
-    link_protocol = "WWW:DOWNLOAD-1.0-http--download";
-    url = _stringConcatenateAndEncodeHTML(url, "service=WCS&version=2.0.1&request=GetCoverage&coverageid=");
-    url = _stringConcatenateAndEncodeHTML(url, layer->name);
-    url = _stringConcatenateAndEncodeHTML(url, "&format=");
-    url = _stringConcatenateAndEncodeHTML(url, format);
-  }
-
-  xmlAddChild(psORNode, _msMetadataGetURL(namespace, "linkage", url, ppsNsGco));
-  msFree(url);
-
-  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "protocol", link_protocol, ppsNsGco));
-  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "name", layer->name, ppsNsGco));
-
-  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "description", desc, ppsNsGco));
-
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetInteger                              */
-/*                                                                      */
-/*      Create a gmd:name/gmd:Integer element pattern                   */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetInteger(xmlNsPtr namespace, const char *name, int value, xmlNsPtr* ppsNsGco) {
-  char buffer[8];
-
-  xmlNodePtr psNode = NULL;
-
-  sprintf(buffer, "%d", value);
-
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
-
-  psNode = xmlNewNode(namespace, BAD_CAST name);
-
-  if (!value)
-    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
-  else
-    xmlNewChild(psNode, *ppsNsGco, BAD_CAST "Integer", BAD_CAST buffer);
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetDecimal                              */
-/*                                                                      */
-/*      Create a gmd:name/gmd:Decimal element pattern                   */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetDecimal(xmlNsPtr namespace, const char *name, double value, xmlNsPtr* ppsNsGco) {
-  char buffer[32];
-
-  xmlNodePtr psNode = NULL;
-
-  snprintf(buffer, sizeof(buffer), "%.6f", value);
-
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
-
-  psNode = xmlNewNode(namespace, BAD_CAST name);
-
-  if (!value)
-    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
-  else
-    xmlNewChild(psNode, *ppsNsGco, BAD_CAST "Decimal", BAD_CAST buffer);
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetCodeList                             */
-/*                                                                      */
-/*      Create a gmd:name/gmd:* code list element pattern               */
-/************************************************************************/
-
-xmlNodePtr _msMetadataGetCodeList(xmlNsPtr namespace, const char *parent_element, const char *name, const char *value) {
-  char *codelist = NULL;
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psCodeNode = NULL;
-
-  codelist = msStrdup("http://www.isotc211.org/2005/resources/Codelist/gmxCodelists.xml#");
-  codelist = msStringConcatenate(codelist, name);
-
-  psNode = xmlNewNode(namespace, BAD_CAST parent_element);
-  psCodeNode = xmlNewChild(psNode, namespace, BAD_CAST name, BAD_CAST value);
-  xmlNewProp(psCodeNode, BAD_CAST "codeSpace", BAD_CAST "ISOTC211/19115");
-  xmlNewProp(psCodeNode, BAD_CAST "codeList", BAD_CAST codelist);
-  xmlNewProp(psCodeNode, BAD_CAST "codeListValue", BAD_CAST value);
-  msFree(codelist);
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetGMLTimePeriod                        */
-/*                                                                      */
-/*      Create a gml:TimePeriod element pattern                         */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetGMLTimePeriod(char **temporal)
-{
-  xmlNsPtr psNsGml = NULL;
-  xmlNodePtr psNode = NULL;
-
-  psNsGml = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
-  psNode = xmlNewNode(psNsGml, BAD_CAST "TimePeriod");
-  xmlNewNsProp(psNode, psNsGml, BAD_CAST "id", BAD_CAST "T001");
-  xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
-  xmlSetNs(psNode, psNsGml);
-  xmlNewChild(psNode, psNsGml, BAD_CAST "beginPosition", BAD_CAST temporal[0]);
-  xmlNewChild(psNode, psNsGml, BAD_CAST "endPosition", BAD_CAST temporal[1]);
-
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetExtent                               */
-/*                                                                      */
-/*            Create a gmd:extent element pattern                       */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetExtent(xmlNsPtr namespace, layerObj *layer, xmlNsPtr *ppsNsGco)
-{
-  int n = 0;
-  int status;
-  char *value = NULL;
-  char **temporal = NULL;
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psEXNode = NULL;
-  xmlNodePtr psGNode = NULL;
-  xmlNodePtr psGNode2 = NULL;
-  xmlNodePtr psTNode = NULL;
-  xmlNodePtr psTNode2 = NULL;
-  xmlNodePtr psENode = NULL;
-
-  rectObj rect;
-
-  psNode = xmlNewNode(namespace, BAD_CAST "extent");
-  psEXNode = xmlNewChild(psNode, namespace, BAD_CAST "EX_Extent", NULL);
-
-  /* scan for geospatial extent */
-  status = msLayerGetExtent(layer, &rect); 
-
-  if (status == 0) {
-    /* always project to lat long */
-    msOWSProjectToWGS84(&layer->projection, &rect);
-
-    psGNode = xmlNewChild(psEXNode, namespace, BAD_CAST "geographicElement", NULL);
-    psGNode2 = xmlNewChild(psGNode, namespace, BAD_CAST "EX_GeographicBoundingBox", NULL);
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "westBoundLongitude", rect.minx, ppsNsGco));
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "eastBoundLongitude", rect.maxx, ppsNsGco));
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "southBoundLatitude", rect.miny, ppsNsGco));
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "northBoundLatitude", rect.maxy, ppsNsGco));
-  }
-
-  /* scan for temporal extent */
-  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MO", "timeextent");
-  if (value) { /* WMS */
-    temporal = msStringSplit(value, '/', &n);
-  }
-  else { /* WCS */
-    value = (char *)msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition");
-    if (value) {
-      /* split extent */
-      temporal = msStringSplit(value, ',', &n);
-    }
-  }
-  if (!value) { /* SOS */
-      value = (char *)msOWSLookupMetadata(&(layer->metadata), "SO", "offering_timeextent");
-      if (value)
-        temporal = msStringSplit(value, '/', &n);
-  }
-  if (value) { 
-    if (temporal && n > 0) {
-      psTNode = xmlNewChild(psEXNode, namespace, BAD_CAST "temporalElement", NULL);
-      psTNode2 = xmlNewChild(psTNode, namespace, BAD_CAST "EX_TemporalExtent", NULL);
-      psENode = xmlNewChild(psTNode2, namespace, BAD_CAST "extent", NULL);
-      xmlAddChild(psENode, _msMetadataGetGMLTimePeriod(temporal));
-    }
-  }
-  msFreeCharArray(temporal, n);
-
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetReferenceSystemInfo                  */
-/*                                                                      */
-/*      Create a gmd:referenceSystemInfo element pattern                */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetReferenceSystemInfo(xmlNsPtr namespace, layerObj *layer, xmlNsPtr* ppsNsGco)
-{
-  char *epsg_str = NULL;
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psRSNode = NULL;
-  xmlNodePtr psRSINode = NULL;
-  xmlNodePtr psRSINode2 = NULL;
-
-  psNode = xmlNewNode(namespace, BAD_CAST "referenceSystemInfo");
-  psRSNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_ReferenceSystem", NULL);
-  psRSINode = xmlNewChild(psRSNode, namespace, BAD_CAST "referenceSystemIdentifier", NULL);
-  psRSINode2 = xmlNewChild(psRSINode, namespace, BAD_CAST "RS_Identifier", NULL);
-
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO", MS_TRUE, &epsg_str);
-  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "code", epsg_str, ppsNsGco));
-  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "codeSpace", "http://www.epsg-registry.org", ppsNsGco));
-  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "version", "6.14", ppsNsGco));
-  msFree(epsg_str);
-
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetContact                              */
-/*                                                                      */
-/*      Create a gmd:contact element pattern                            */
-/************************************************************************/
-
-xmlNodePtr _msMetadataGetContact(xmlNsPtr namespace, char *contact_element, mapObj *map, xmlNsPtr* ppsNsGco)
-{
-  char *value = NULL;
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psCNode = NULL;
-  xmlNodePtr psCINode = NULL;
-  xmlNodePtr psCINode2 = NULL;
-  xmlNodePtr psPhoneNode = NULL;
-  xmlNodePtr psCIPhoneNode = NULL;
-  xmlNodePtr psAddressNode = NULL;
-  xmlNodePtr psCIAddressNode = NULL;
-  xmlNodePtr psORNode = NULL;
-  xmlNodePtr psORNode2 = NULL;
-
-  psNode = xmlNewNode(namespace, BAD_CAST contact_element);
-  psCNode = xmlNewChild(psNode, namespace, BAD_CAST "CI_ResponsibleParty", NULL);
-  xmlNewProp(psCNode, BAD_CAST "id", BAD_CAST contact_element);
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactperson");
-  if (value)
-    xmlAddChild(psCNode, _msMetadataGetCharacterString(namespace, "individualName", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactorganization");
-  if (value)
-    xmlAddChild(psCNode, _msMetadataGetCharacterString(namespace, "organisationName", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactposition");
-  if (value)
-    xmlAddChild(psCNode, _msMetadataGetCharacterString(namespace, "positionName", value, ppsNsGco));
-
-  psCINode = xmlNewChild(psCNode, namespace, BAD_CAST "contactInfo", NULL);
-  psCINode2 = xmlNewChild(psCINode, namespace, BAD_CAST "CI_Contact", NULL);
-  psPhoneNode = xmlNewChild(psCINode2, namespace, BAD_CAST "phone", NULL);
-  psCIPhoneNode = xmlNewChild(psPhoneNode, namespace, BAD_CAST "CI_Telephone", NULL);
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactvoicetelephone");
-  if (value)
-    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(namespace, "voice", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactfacsimiletelephone");
-  if (value)
-    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(namespace, "facsimile", value, ppsNsGco));
-
-  psAddressNode = xmlNewChild(psCINode2, namespace, BAD_CAST "address", NULL);
-  psCIAddressNode = xmlNewChild(psAddressNode, namespace, BAD_CAST "CI_Address", NULL);
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "address");
-  if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "deliveryPoint", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "city");
-  if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "city", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "stateorprovince");
-  if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "administrativeArea", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "postcode");
-  if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "postalCode", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "country");
-  if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "country", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactelectronicmailaddress");
-  if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "electronicMailAddress", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "onlineresource");
-  if (value) {
-    psORNode = xmlNewChild(psCINode2, namespace, BAD_CAST "onlineResource", NULL);
-    psORNode2 = xmlNewChild(psORNode, namespace, BAD_CAST "CI_OnlineResource", NULL);
-    xmlAddChild(psORNode2, _msMetadataGetURL(namespace, "linkage", value, ppsNsGco));
-  }
-
-  xmlAddChild(psCNode, _msMetadataGetCodeList(namespace, "role", "CI_RoleCode", "pointOfContact"));
-
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetIdentificationInfo                   */
-/*                                                                      */
-/*      Create a gmd:identificationInfo element pattern                 */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetIdentificationInfo(xmlNsPtr namespace, mapObj *map, layerObj *layer, xmlNsPtr *ppsNsGco)
-{
-  char *value;
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psDINode = NULL;
-  xmlNodePtr psCNode = NULL;
-  xmlNodePtr psCINode = NULL;
-  xmlNodePtr psDNode = NULL;
-  xmlNodePtr psKWNode = NULL;
-  xmlNodePtr psMDKNode = NULL;
-
-  psNode = xmlNewNode(namespace, BAD_CAST "identificationInfo");
-
-  psDINode = xmlNewChild(psNode, namespace, BAD_CAST "MD_DataIdentification", NULL);
-  xmlNewProp(psDINode, BAD_CAST "id", BAD_CAST layer->name);
-  psCNode = xmlNewChild(psDINode, namespace, BAD_CAST "citation", NULL);
-  psCINode = xmlNewChild(psCNode, namespace, BAD_CAST "CI_Citation", NULL);
-
-  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFGO", "title");
-  if (!value)
-      value = (char *)msOWSLookupMetadata(&(layer->metadata), "S", "offering_name");
-  xmlAddChild(psCINode, _msMetadataGetCharacterString(namespace, "title", value, ppsNsGco));
-
-  psDNode = xmlNewChild(psCINode, namespace, BAD_CAST "date", NULL);
-  xmlNewNsProp(psDNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
-
-  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFGO", "attribution_title");
-  if (value) {
-      xmlAddChild(psCINode, _msMetadataGetCharacterString(namespace, "otherCitationDetails", value, ppsNsGco));
-  }
-
-  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFGO", "abstract");
-  if (!value)
-      value = (char *)msOWSLookupMetadata(&(layer->metadata), "S", "offering_description");
-  xmlAddChild(psDINode, _msMetadataGetCharacterString(namespace, "abstract", value, ppsNsGco));
-
-  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFSGO", "keywordlist");
-
-  if (value) {
-    psKWNode = xmlNewChild(psDINode, namespace, BAD_CAST "descriptiveKeywords", NULL);
-    psMDKNode = xmlNewChild(psKWNode, namespace, BAD_CAST "MD_Keywords", NULL);
-
-    int n = 0;
-    char** tokens = msStringSplit(value, ',', &n);
-    if (tokens && n > 0) {
-      for (int i=0; i<n; i++) {
-        xmlAddChild(psMDKNode, _msMetadataGetCharacterString(namespace, "keyword", tokens[i], ppsNsGco));
-      }
-    }
-    msFreeCharArray(tokens, n);
-  }
-
-  xmlAddChild(psDINode, _msMetadataGetCharacterString(namespace, "language", (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
-  xmlAddChild(psDINode, _msMetadataGetExtent(namespace, layer, ppsNsGco));
-
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetSpatialRepresentationInfo            */
-/*                                                                      */
-/*      Create a gmd:spatialRepresentationInfo element pattern          */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetSpatialRepresentationInfo(xmlNsPtr namespace, layerObj *layer, xmlNsPtr* ppsNsGco)
-{
-  char *value;
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psSRNode = NULL;
-  xmlNodePtr psGONode = NULL;
-  xmlNodePtr psGONode2 = NULL;
-
-  psNode = xmlNewNode(namespace, BAD_CAST "spatialRepresentationInfo");
-
-  if (layer->type == MS_LAYER_RASTER) {
-    psSRNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_GridSpatialRepresentation", NULL);
-    xmlAddChild(psSRNode, _msMetadataGetInteger(namespace, "numberOfDimensions", 2, ppsNsGco));
-    xmlAddChild(psSRNode, _msMetadataGetCodeList(namespace, "cellGeometry", "MD_CellGeometryCode", "area"));
-  }
-  else {
-    psSRNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_VectorSpatialRepresentation", NULL);
-    xmlAddChild(psSRNode, _msMetadataGetCodeList(namespace, "topologyLevel", "MD_TopologyLevelCode", "geometryOnly"));
-    psGONode = xmlNewChild(psSRNode, namespace, BAD_CAST "geometricObjects", NULL);
-    psGONode2 = xmlNewChild(psGONode, namespace, BAD_CAST "MD_GeometricObjects", NULL);
-    if (layer->type == MS_LAYER_POINT)
-      value = "point";
-    else if (layer->type == MS_LAYER_LINE)
-      value = "curve";
-    else if (layer->type == MS_LAYER_POLYGON)
-      value = "surface";
-    else
-      value = "complex";
-    xmlAddChild(psGONode2, _msMetadataGetCodeList(namespace, "geometricObjectType", "MD_GeometricObjectTypeCode", value));
-    // TODO: find way to get feature count in a fast way
-    /* xmlAddChild(psGONode2, _msMetadataGetInteger(namespace, "geometricObjectCount", msLayerGetNumFeatures(layer))); */
-  }
-
-  return psNode;
-}
-
-
-/************************************************************************/
-/*                   _msMetadataGetDistributionInfo                     */
-/*                                                                      */
-/*      Create a gmd:identificationInfo element pattern                 */
-/************************************************************************/
-
-static
-xmlNodePtr _msMetadataGetDistributionInfo(xmlNsPtr namespace, mapObj *map, layerObj *layer, cgiRequestObj *cgi_request, xmlNsPtr* ppsNsGco)
-{
-  char *url = NULL;
-  xmlNodePtr psNode = NULL;
-  xmlNodePtr psMDNode = NULL;
-  xmlNodePtr psTONode = NULL;
-  xmlNodePtr psDTONode = NULL;
-  xmlNodePtr psDNode = NULL;
-  xmlNodePtr psDNode2 = NULL;
-
-  psNode = xmlNewNode(namespace, BAD_CAST "distributionInfo");
-  psMDNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_Distribution", NULL);
-
-  {
-      char* pszTmp = msOWSGetOnlineResource(map, "MFCSGO", "onlineresource", cgi_request);
-      url = msEncodeHTMLEntities(pszTmp);
-      msFree(pszTmp);
-  }
-
-  /* gmd:distributor */
-  psDNode = xmlNewChild(psMDNode, namespace, BAD_CAST "distributor", NULL);
-  psDNode2 = xmlNewChild(psDNode, namespace, BAD_CAST "MD_Distributor", NULL);
-  xmlAddChild(psDNode2, _msMetadataGetContact(namespace, "distributorContact", map, ppsNsGco));
-
-  /* gmd:transferOptions */
-  psTONode = xmlNewChild(psMDNode, namespace, BAD_CAST "transferOptions", NULL);
-  psDTONode = xmlNewChild(psTONode, namespace, BAD_CAST "MD_DigitalTransferOptions", NULL);
-  xmlAddChild(psDTONode, _msMetadataGetCharacterString(namespace, "unitsOfDistribution", "KB", ppsNsGco));
-
-  /* links */
-
-  /* WMS */
-  xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "M", "image/png", "PNG Format", url, ppsNsGco));
-  xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "M", "image/jpeg", "JPEG Format", url, ppsNsGco));
-
-  /* WCS */
-  if (layer->type == MS_LAYER_RASTER) {
-    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "C", "image/tiff", "GeoTIFF Format", url, ppsNsGco));
-  }
-  /* WFS */
-  else {
-    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML2", "GML2 Format", url, ppsNsGco));
-    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML3", "GML3 Format", url, ppsNsGco));
-  }
-
-  msFree(url);
-
-  return psNode;
-}
-
-/************************************************************************/
-/*                   msMetadataGetExceptionReport                       */
-/*                                                                      */
-/*              Generate an OWS Common Exception Report                 */
-/************************************************************************/
-
-static
-xmlNodePtr msMetadataGetExceptionReport(mapObj *map, char *code, char *locator, char *message, xmlNsPtr* ppsNsOws)
-{
-  char *schemas_location = NULL;
-
-  xmlNodePtr psRootNode = NULL;
-
-  schemas_location = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-  *ppsNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-
-  psRootNode = msOWSCommonExceptionReport(*ppsNsOws,
-                                          OWS_1_1_0,
-                                          schemas_location,
-                                          "1.1.0",
-                                          msOWSGetLanguage(map, "exception"),
-                                          code, locator, message);
-  msFree(schemas_location);
-
-  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-
-  return psRootNode;
-
-}
-
-/************************************************************************/
-/*                   msMetadataGetLayerMetadata                         */
-/*                                                                      */
-/*      Generate an ISO 19139-1:2019 representation of layer metadata   */
-/************************************************************************/
-
-static
-xmlNodePtr msMetadataGetLayerMetadata(mapObj *map, metadataParamsObj *paramsObj, cgiRequestObj *cgi_request, xmlNsPtr* ppsNsOws, xmlNsPtr* ppsNsXsi, xmlNsPtr* ppsNsGmd, xmlNsPtr* ppsNsGco)
-{
-  int i;
-  int layer_found = MS_FALSE;
-
-  xmlNodePtr psRootNode = NULL;
-
-  layerObj *layer = NULL;
-
-  /* Check that layer requested exists in mapfile */ 
-  for (i=0; i<map->numlayers; i++) {
-    if(strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
-        layer_found = MS_TRUE;
-        layer = GET_LAYER(map, i);
-        // when checking a layer with clustering msLayerGetExtent does not have access
-        // to the source layer, so remove clustering first
-        if (layer->cluster.region) {
-            layer->cluster.region = NULL;
-        }
-        break;
-    }
-  }
-
-  if (layer_found == MS_FALSE) {
-    psRootNode = msMetadataGetExceptionReport(map, "InvalidParameterValue", "layer", "Layer not found", ppsNsOws);
-  }
-
-  /* Check that outputschema is valid */
-  else if (paramsObj->pszOutputSchema && strcasecmp(paramsObj->pszOutputSchema, "http://www.isotc211.org/2005/gmd") != 0) {
-    psRootNode = msMetadataGetExceptionReport(map, "InvalidParameterValue", "outputschema", "OUTPUTSCHEMA must be \"http://www.isotc211.org/2005/gmd\"", ppsNsOws);
-  }
-
-  else {
-    *ppsNsXsi = xmlNewNs(NULL, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance", BAD_CAST "xsi");
-    *ppsNsGmd = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gmd");
-    /* root element */
-    psRootNode = xmlNewNode(NULL, BAD_CAST "MD_Metadata");
-    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gmd");
-    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gco", BAD_CAST "gco");
-    xmlNewNs(psRootNode, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance", BAD_CAST "xsi");
-    xmlSetNs(psRootNode, *ppsNsGmd);
-
-    xmlNewNsProp(psRootNode, *ppsNsXsi, BAD_CAST "schemaLocation", BAD_CAST "http://www.isotc211.org/2005/gmd http://www.isotc211.org/2005/gmd/gmd.xsd");
-
-    /* gmd:identifier */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "fileIdentifier", layer->name, ppsNsGco));
-
-    /* gmd:language */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "language", (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
-
-    /* gmd:hierarchyLevel */
-    xmlAddChild(psRootNode, _msMetadataGetCodeList(*ppsNsGmd, "hierarchyLevel", "MD_ScopeCode", "dataset"));
-
-    /* gmd:contact */
-    xmlAddChild(psRootNode, _msMetadataGetContact(*ppsNsGmd, "contact", map, ppsNsGco));
-
-    /* gmd:dateStamp */
-    /* TODO: nil for now, find way to derive this automagically */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "dateStamp", NULL, ppsNsGco));
-
-    /* gmd:metadataStandardName */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "metadataStandardName", "ISO 19115:2003 - Geographic information - Metadata", ppsNsGco));
-
-    /* gmd:metadataStandardVersion */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "metadataStandardVersion", "ISO 19115:2003", ppsNsGco));
-
-    /* gmd:spatialRepresentationInfo */
-    xmlAddChild(psRootNode, _msMetadataGetSpatialRepresentationInfo(*ppsNsGmd, layer, ppsNsGco));
-
-    /* gmd:referenceSystemInfo */
-    xmlAddChild(psRootNode, _msMetadataGetReferenceSystemInfo(*ppsNsGmd, layer, ppsNsGco));
-
-    /* gmd:identificationInfo */
-    xmlAddChild(psRootNode, _msMetadataGetIdentificationInfo(*ppsNsGmd, map, layer, ppsNsGco));
-
-    /* gmd:distributionInfo */
-    xmlAddChild(psRootNode, _msMetadataGetDistributionInfo(*ppsNsGmd, map, layer, cgi_request, ppsNsGco));
-  }
-
-  return psRootNode;
-}
-
-/************************************************************************/
-/*                  msMetadataDispatch                                  */
-/*                                                                      */
-/* Entry point for metadata requests.                                   */
-/*                                                                      */
-/* - If this is a valid request then it is processed and MS_SUCCESS     */
-/*   is returned on success, or MS_FAILURE on failure.                  */ 
-/*                                                                      */
-/* - If this does not appear to be a valid WFS request then MS_DONE     */
-/*   is returned and MapServer is expected to process this as a regular */
-/*   MapServer request.                                                 */
-/************************************************************************/
-
-int msMetadataDispatch(mapObj *map, cgiRequestObj *cgi_request)
-{
-  int i;
-  int status = MS_SUCCESS;
-  xmlNodePtr psRootNode = NULL;
-  xmlDocPtr xml_document;
-  metadataParamsObj *paramsObj;
-  layerObj *layer = NULL;
-  xmlNsPtr psNsOws = NULL;
-  xmlNsPtr psNsXsi = NULL;
-  xmlNsPtr psNsGmd = NULL;
-  xmlNsPtr psNsGco = NULL;
-
-  /* Populate the Params object based on the request */
-
-  paramsObj = msMetadataCreateParamsObj();
-
-  xml_document = xmlNewDoc(BAD_CAST "1.0");
-
-  if (msMetadataParseRequest(cgi_request, paramsObj) == MS_FAILURE) {
-    psRootNode = msMetadataGetExceptionReport(map, "InvalidRequest", "layer", "Request parsing failed", &psNsOws);
-    status = MS_FAILURE;
-  }
-
-  /* if layer= is not specified, */
-  if (paramsObj->pszLayer==NULL || strlen(paramsObj->pszLayer)==0) {
-    psRootNode = msMetadataGetExceptionReport(map, "MissingParameterValue", "layer", "Missing layer parameter", &psNsOws);
-    status = MS_FAILURE;
-  }
-
-  if (status == MS_SUCCESS) { /* Start dispatching request */
-    /* Check that layer requested exists in mapfile */
-    for (i=0; i<map->numlayers; i++) {
-      if(strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
-        layer = GET_LAYER(map, i);
-        break;
-      }
-    }
-    if (layer != NULL && msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href")) {
-      msIO_setHeader("Status", "301 Moved Permanently");
-      msIO_setHeader("Location", "%s", msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href"));
-      msIO_sendHeaders();
-    }
-    else {
-      psRootNode = msMetadataGetLayerMetadata(map, paramsObj, cgi_request, &psNsOws, &psNsXsi, &psNsGmd, &psNsGco);
-    }
-  }
-
-  if (psRootNode != NULL) {
-    xmlChar *xml_buffer = NULL;
-    int buffersize = 0;
-    xmlDocSetRootElement(xml_document, psRootNode);
-
-    msIO_setHeader("Content-type", "text/xml; charset=UTF-8");
-    msIO_sendHeaders();
-
-    msIOContext* context = NULL;
-
-    context = msIO_getHandler(stdout);
-
-    xmlDocDumpFormatMemoryEnc(xml_document, &xml_buffer, &buffersize, "UTF-8", 1);
-    msIO_contextWrite(context, xml_buffer, buffersize);
-
-    xmlFree(xml_buffer);
-  }
-  xmlFreeDoc(xml_document);
-  if( psNsOws )
-      xmlFreeNs(psNsOws);
-  if( psNsXsi )
-      xmlFreeNs(psNsXsi);
-  if( psNsGmd )
-      xmlFreeNs(psNsGmd);
-  if( psNsGco )
-      xmlFreeNs(psNsGco);
-
-  msMetadataFreeParamsObj(paramsObj);
-
-  return status;
-}
-
-#endif /* USE_LIBXML2 */
-
-/************************************************************************/
-/*                           msMetadataCreateParamsObj                  */
-/*                                                                      */
-/*   Create a parameter object, initialize it.                          */
-/*   The caller should free the object using msMetadataFreeParamsObj.   */
-/************************************************************************/
-
-metadataParamsObj *msMetadataCreateParamsObj()
-{
-  metadataParamsObj *paramsObj = (metadataParamsObj *)calloc(1, sizeof(metadataParamsObj));
-  MS_CHECK_ALLOC(paramsObj, sizeof(metadataParamsObj), NULL);
-
-  paramsObj->pszLayer = NULL;
-  paramsObj->pszOutputSchema = NULL;
-  return paramsObj;
-}
-
-
-/************************************************************************/
-/*                            msMetadataFreeParmsObj                    */
-/*                                                                      */
-/*      Free params object.                                             */
-/************************************************************************/
-
-void msMetadataFreeParamsObj(metadataParamsObj *metadataparams)
-{
-  if (metadataparams) {
-    free(metadataparams->pszRequest);
-    free(metadataparams->pszLayer);
-    free(metadataparams->pszOutputSchema);
-    free(metadataparams);
-  }
-}
-
-
-/************************************************************************/
-/*                            msMetadataParseRequest                    */
-/*                                                                      */
-/*      Parse request into the params object.                           */
-/************************************************************************/
-
-static
-int msMetadataParseRequest(cgiRequestObj *request,
-                      metadataParamsObj *metadataparams)
-{
-  if (!request || !metadataparams)
-    return MS_FAILURE;
-
-  if (request->NumParams > 0) {
-    for(int i=0; i<request->NumParams; i++) {
-      if (request->ParamNames[i] && request->ParamValues[i]) {
-        if (strcasecmp(request->ParamNames[i], "LAYER") == 0)
-          metadataparams->pszLayer = msStrdup(request->ParamValues[i]);
-        if (strcasecmp(request->ParamNames[i], "OUTPUTSCHEMA") == 0)
-          metadataparams->pszOutputSchema = msStrdup(request->ParamValues[i]);
-      }
-    }
-  }
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                            msMetadataSetGetMetadataURL               */
-/*                                                                      */
-/*      Parse request into the params object.                           */
-/************************************************************************/
-
-void msMetadataSetGetMetadataURL(layerObj *lp, const char *url)
-{
-  char *pszMetadataURL=NULL;
-
-  pszMetadataURL = msStrdup(url);
-  msDecodeHTMLEntities(pszMetadataURL);
-  pszMetadataURL = msStringConcatenate(pszMetadataURL, "request=GetMetadata&layer=");
-  pszMetadataURL = msStringConcatenate(pszMetadataURL, lp->name);
-
-  msInsertHashTable(&(lp->metadata), "ows_metadataurl_href", pszMetadataURL);
-  msInsertHashTable(&(lp->metadata), "ows_metadataurl_type", "TC211");
-  msInsertHashTable(&(lp->metadata), "ows_metadataurl_format", "text/xml");
-  msInsertHashTable(&(lp->metadata), "ows_metadatalink_href", pszMetadataURL);
-  msInsertHashTable(&(lp->metadata), "ows_metadatalink_type", "TC211");
-  msInsertHashTable(&(lp->metadata), "ows_metadatalink_format", "text/xml");
-  msFree(pszMetadataURL);
-}
-
-#endif
diff -pruN 8.0.1-5/mapmssql2008.c 8.2.0~beta1-1~exp1/mapmssql2008.c
--- 8.0.1-5/mapmssql2008.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapmssql2008.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,3825 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  MS SQL Server Layer Connector
- * Author:   Richard Hillman - based on PostGIS and SpatialDB connectors
- *           Tamas Szekeres - maintenance
- *
- ******************************************************************************
- * Copyright (c) 2007 IS Consulting (www.mapdotnet.com)
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ******************************************************************************
- *
- * Revision 1.0  2007/7/1
- * Created.
- *
- */
-#ifndef _WIN32
-#define _GNU_SOURCE
-#endif
-
-#define _CRT_SECURE_NO_WARNINGS 1
-
-/* $Id$ */
-#include <assert.h>
-#include "mapserver.h"
-#include "maptime.h"
-#include "mapows.h"
-
-#ifdef USE_MSSQL2008
-
-#ifdef _WIN32
-#include <windows.h>
-#endif
-#include <sql.h>
-#include <sqlext.h>
-#include <sqltypes.h>
-
-#include <string.h>
-#include <ctype.h> /* tolower() */
-
-/*   SqlGeometry/SqlGeography serialization format
-
-Simple Point (SerializationProps & IsSinglePoint)
-  [SRID][0x01][SerializationProps][Point][z][m]
-
-Simple Line Segment (SerializationProps & IsSingleLineSegment)
-  [SRID][0x01][SerializationProps][Point1][Point2][z1][z2][m1][m2]
-
-Complex Geometries
-  [SRID][VersionAttribute][SerializationProps][NumPoints][Point1]..[PointN][z1]..[zN][m1]..[mN]
-  [NumFigures][Figure]..[Figure][NumShapes][Shape]..[Shape]
-
-Complex Geometries (FigureAttribute == Curve)
-  [SRID][VersionAttribute][SerializationProps][NumPoints][Point1]..[PointN][z1]..[zN][m1]..[mN]
-  [NumFigures][Figure]..[Figure][NumShapes][Shape]..[Shape][NumSegments][SegmentType]..[SegmentType]
-
-VersionAttribute (1 byte)
-  0x01 = Katmai (MSSQL2008+)
-  0x02 = Denali (MSSQL2012+)
-
-SRID
-  Spatial Reference Id (4 bytes)
-
-SerializationProps (bitmask) 1 byte
-  0x01 = HasZValues
-  0x02 = HasMValues
-  0x04 = IsValid
-  0x08 = IsSinglePoint
-  0x10 = IsSingleLineSegment
-  0x20 = IsLargerThanAHemisphere
-
-Point (2-4)x8 bytes, size depends on SerializationProps & HasZValues & HasMValues
-  [x][y]                  - SqlGeometry
-  [latitude][longitude]   - SqlGeography
-
-Figure
-  [FigureAttribute][PointOffset]
-
-FigureAttribute - Katmai (1 byte)
-  0x00 = Interior Ring
-  0x01 = Stroke
-  0x02 = Exterior Ring
-
-FigureAttribute - Denali (1 byte)
-  0x00 = None
-  0x01 = Line
-  0x02 = Arc
-  0x03 = Curve
-
-Shape
-  [ParentFigureOffset][FigureOffset][ShapeType]
-
-ShapeType (1 byte)
-  0x00 = Unknown
-  0x01 = Point
-  0x02 = LineString
-  0x03 = Polygon
-  0x04 = MultiPoint
-  0x05 = MultiLineString
-  0x06 = MultiPolygon
-  0x07 = GeometryCollection
-  -- Denali
-  0x08 = CircularString
-  0x09 = CompoundCurve
-  0x0A = CurvePolygon
-  0x0B = FullGlobe
-
-SegmentType (1 byte)
-  0x00 = Line
-  0x01 = Arc
-  0x02 = FirstLine
-  0x03 = FirstArc
-
-*/
-
-/* Native geometry parser macros */
-
-/* parser error codes */
-#define NOERROR 0
-#define NOT_ENOUGH_DATA 1
-#define CORRUPT_DATA 2
-#define UNSUPPORTED_GEOMETRY_TYPE 3
-
-/* geometry format to transfer geometry column */
-#define MSSQLGEOMETRY_NATIVE 0
-#define MSSQLGEOMETRY_WKB 1
-#define MSSQLGEOMETRY_WKT 2
-
-/* geometry column types */
-#define MSSQLCOLTYPE_GEOMETRY  0
-#define MSSQLCOLTYPE_GEOGRAPHY 1
-#define MSSQLCOLTYPE_BINARY 2
-#define MSSQLCOLTYPE_TEXT 3
-
-#define SP_NONE 0
-#define SP_HASZVALUES 1
-#define SP_HASMVALUES 2
-#define SP_ISVALID 4
-#define SP_ISSINGLEPOINT 8
-#define SP_ISSINGLELINESEGMENT 0x10
-#define SP_ISLARGERTHANAHEMISPHERE 0x20
-
-#define ST_UNKNOWN 0
-#define ST_POINT 1
-#define ST_LINESTRING 2
-#define ST_POLYGON 3
-#define ST_MULTIPOINT 4
-#define ST_MULTILINESTRING 5
-#define ST_MULTIPOLYGON 6
-#define ST_GEOMETRYCOLLECTION 7
-#define ST_CIRCULARSTRING 8
-#define ST_COMPOUNDCURVE 9
-#define ST_CURVEPOLYGON 10
-#define ST_FULLGLOBE 11
-
-#define SMT_LINE 0
-#define SMT_ARC 1
-#define SMT_FIRSTLINE 2
-#define SMT_FIRSTARC 3
-
-#define ReadInt32(nPos) (*((unsigned int*)(gpi->pszData + (nPos))))
-
-#define ReadByte(nPos) (gpi->pszData[nPos])
-
-#define ReadDouble(nPos) (*((double*)(gpi->pszData + (nPos))))
-
-#define ParentOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape) * 9 ))
-#define FigureOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape) * 9 + 4))
-#define ShapeType(iShape) (ReadByte(gpi->nShapePos + (iShape) * 9 + 8))
-#define SegmentType(iSegment) (ReadByte(gpi->nSegmentPos + (iSegment)))
-
-#define NextFigureOffset(iShape) (iShape + 1 < gpi->nNumShapes? FigureOffset((iShape) +1) : gpi->nNumFigures)
-
-#define FigureAttribute(iFigure) (ReadByte(gpi->nFigurePos + (iFigure) * 5))
-#define PointOffset(iFigure) (ReadInt32(gpi->nFigurePos + (iFigure) * 5 + 1))
-#define NextPointOffset(iFigure) (iFigure + 1 < gpi->nNumFigures? PointOffset((iFigure) +1) : (unsigned)gpi->nNumPoints)
-
-#define ReadX(iPoint) (ReadDouble(gpi->nPointPos + 16 * (iPoint)))
-#define ReadY(iPoint) (ReadDouble(gpi->nPointPos + 16 * (iPoint) + 8))
-#define ReadZ(iPoint) (ReadDouble(gpi->nPointPos + 16 * gpi->nNumPoints + 8 * (iPoint)))
-#define ReadM(iPoint) (ReadDouble(gpi->nPointPos + 24 * gpi->nNumPoints + 8 * (iPoint)))
-
-#define FP_EPSILON 1e-12
-#define SEGMENT_ANGLE 5.0
-#define SEGMENT_MINPOINTS 10
-
-/* Native geometry parser struct */
-typedef struct msGeometryParserInfo_t {
-  unsigned char* pszData;
-  int nLen;
-  /* version */
-  char chVersion;
-  /* serialization properties */
-  char chProps;
-  /* point array */
-  int nPointSize;
-  int nPointPos;
-  int nNumPoints;
-  int nNumPointsRead;
-  /* figure array */
-  int nFigurePos;
-  int nNumFigures;
-  /* shape array */
-  int nShapePos;
-  int nNumShapes;
-  int nSRSId;
-  /* segment array */
-  int nSegmentPos;
-  int nNumSegments;
-  /* geometry or geography */
-  int nColType;
-  /* bounds */
-  double minx;
-  double miny;
-  double maxx;
-  double maxy;
-} msGeometryParserInfo;
-
-/* Structure for connection to an ODBC database (Microsoft preferred way to connect to SQL Server 2005 from c/c++) */
-typedef struct msODBCconn_t {
-  SQLHENV     henv;               /* ODBC HENV */
-  SQLHDBC     hdbc;               /* ODBC HDBC */
-  SQLHSTMT    hstmt;              /* ODBC HSTMNT */
-  char        errorMessage[1024]; /* Last error message if any */
-} msODBCconn;
-
-typedef struct ms_MSSQL2008_layer_info_t {
-  char *sql;           /* sql query to send to DB */
-  long row_num;        /* what row is the NEXT to be read (for random access) */
-  char *geom_column; /* name of the actual geometry column parsed from the LAYER's DATA field */
-  char *geom_column_type;  /* the type of the geometry column */
-  char *geom_table;  /* the table name or sub-select decalred in the LAYER's DATA field */
-  char *urid_name;     /* name of user-specified unique identifier or OID */
-  char *user_srid;     /* zero length = calculate, non-zero means using this value! */
-  char *index_name;  /* hopefully this isn't necessary - but if the optimizer ain't cuttin' it... */
-  char *sort_spec;  /* the sort by specification which should be applied to the generated select statement */
-  int mssqlversion_major; /* the sql server major version number */
-  int paging;           /* Driver handling of pagination, enabled by default */
-  SQLSMALLINT *itemtypes; /* storing the sql field types for further reference */
-
-  msODBCconn * conn;          /* Connection to db */
-  msGeometryParserInfo gpi;   /* struct for the geometry parser */
-  int geometry_format;        /* Geometry format to be retrieved from the database */
-  tokenListNodeObjPtr current_node; /* filter expression translation */
-} msMSSQL2008LayerInfo;
-
-#define SQL_COLUMN_NAME_MAX_LENGTH 128
-#define SQL_TABLE_NAME_MAX_LENGTH 128
-
-#define DATA_ERROR_MESSAGE \
-    "%s" \
-    "Error with MSSQL2008 data variable. You specified '%s'.<br>\n" \
-    "Standard ways of specifiying are : <br>\n(1) 'geometry_column from geometry_table' <br>\n(2) 'geometry_column from (&lt;sub query&gt;) as foo using unique &lt;column name&gt; using SRID=&lt;srid#&gt;' <br><br>\n\n" \
-    "Make sure you utilize the 'using unique  &lt;column name&gt;' and 'using with &lt;index name&gt;' clauses in.\n\n<br><br>" \
-    "For more help, please see http://www.mapdotnet.com \n\n<br><br>" \
-    "mapmssql2008.c - version of 2007/7/1.\n"
-
-/* Native geometry parser code */
-void ReadPoint(msGeometryParserInfo* gpi, pointObj* p, int iPoint)
-{
-  if (gpi->nColType == MSSQLCOLTYPE_GEOGRAPHY) {
-    p->x = ReadY(iPoint);
-    p->y = ReadX(iPoint);
-  } else {
-    p->x = ReadX(iPoint);
-    p->y = ReadY(iPoint);
-  }
-  /* calculate bounds */
-  if (gpi->nNumPointsRead++ == 0) {
-    gpi->minx = gpi->maxx = p->x;
-    gpi->miny = gpi->maxy = p->y;
-  } else {
-    if (gpi->minx > p->x) gpi->minx = p->x;
-    else if (gpi->maxx < p->x) gpi->maxx = p->x;
-    if (gpi->miny > p->y) gpi->miny = p->y;
-    else if (gpi->maxy < p->y) gpi->maxy = p->y;
-  }
-
-  if ((gpi->chProps & SP_HASZVALUES) && (gpi->chProps & SP_HASMVALUES))
-  {
-    p->z = ReadZ(iPoint);
-    p->m = ReadM(iPoint);
-  }
-  else if (gpi->chProps & SP_HASZVALUES)
-  {
-      p->z = ReadZ(iPoint);
-      p->m = 0.0;
-  }
-  else if (gpi->chProps & SP_HASMVALUES)
-  {
-      p->z = 0.0;
-      p->m = ReadZ(iPoint);
-  }
-  else
-  {
-      p->z = 0.0;
-      p->m = 0.0;
-  }
-}
-
-int StrokeArcToLine(msGeometryParserInfo* gpi, lineObj* line, int index)
-{
-    if (index > 1) {
-        double x, y, x1, y1, x2, y2, x3, y3, dxa, dya, sxa, sya, dxb, dyb;
-        double d, sxb, syb, ox, oy, a1, a3, sa, da, a, radius;
-        int numpoints;
-        double z;
-        z = line->point[index].z; /* must be equal for arc segments */
-        /* first point */
-        x1 = line->point[index - 2].x;
-        y1 = line->point[index - 2].y;
-        /* second point */
-        x2 = line->point[index - 1].x;
-        y2 = line->point[index - 1].y;
-        /* third point */
-        x3 = line->point[index].x;
-        y3 = line->point[index].y;
-
-        sxa = (x1 + x2);
-        sya = (y1 + y2);
-        dxa = x2 - x1;
-        dya = y2 - y1;
-
-        sxb = (x2 + x3);
-        syb = (y2 + y3);
-        dxb = x3 - x2;
-        dyb = y3 - y2;
-
-        d = (dxa * dyb - dya * dxb) * 2;
-
-        if (fabs(d) < FP_EPSILON) {
-            /* points are colinear, nothing to do here */
-            return index;
-        }
-
-        /* calculating the center of circle */
-        ox = ((sya - syb) * dya * dyb + sxa * dyb * dxa - sxb * dya * dxb) / d;
-        oy = ((sxb - sxa) * dxa * dxb + syb * dyb * dxa - sya * dya * dxb) / d;
-
-        radius = sqrt((x1 - ox) * (x1 - ox) + (y1 - oy) * (y1 - oy));
-
-        /* calculating the angle to be used */
-        a1 = atan2(y1 - oy, x1 - ox);
-        a3 = atan2(y3 - oy, x3 - ox);
-
-        if (d > 0) {
-            /* draw counterclockwise */
-            if (a3 > a1) /* Wrapping past 180? */
-                sa = a3 - a1;
-            else
-                sa = a3 - a1 + 2.0 * M_PI ;
-        }
-        else {
-            if (a3 > a1) /* Wrapping past 180? */
-                sa = a3 - a1 + 2.0 * M_PI;
-            else
-                sa = a3 - a1;
-        }
-
-        numpoints = (int)floor(fabs(sa) * 180 / SEGMENT_ANGLE / M_PI);
-        if (numpoints < SEGMENT_MINPOINTS)
-            numpoints = SEGMENT_MINPOINTS;
-
-        da = sa / numpoints;
-
-        /* extend the point array */
-        line->numpoints += numpoints - 2;
-        line->point = msSmallRealloc(line->point, sizeof(pointObj) * line->numpoints);
-        --index;
-
-        a = a1 + da;
-        while (numpoints > 1) {
-            line->point[index].x = x = ox + radius * cos(a);
-            line->point[index].y = y = oy + radius * sin(a);
-            line->point[index].z = z;
-
-            /* calculate bounds */
-            if (gpi->minx > x) gpi->minx = x;
-            else if (gpi->maxx < x) gpi->maxx = x;
-            if (gpi->miny > y) gpi->miny = y;
-            else if (gpi->maxy < y) gpi->maxy = y;
-
-            a += da;
-            ++index;
-            --numpoints;
-        }
-        /* set last point */
-        line->point[index].x = x3;
-        line->point[index].y = y3;
-        line->point[index].z = z;
-    }
-    return index;
-}
-
-int ParseSqlGeometry(msMSSQL2008LayerInfo* layerinfo, shapeObj *shape)
-{
-  msGeometryParserInfo* gpi = &layerinfo->gpi;
-
-  gpi->nNumPointsRead = 0;
-
-  if (gpi->nLen < 10) {
-    msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-    return NOT_ENOUGH_DATA;
-  }
-
-  /* store the SRS id for further use */
-  gpi->nSRSId = ReadInt32(0);
-
-  gpi->chVersion = ReadByte(4);
-
-  if (gpi->chVersion > 2) {
-    msDebug("ParseSqlGeometry CORRUPT_DATA\n");
-    return CORRUPT_DATA;
-  }
-
-  gpi->chProps = ReadByte(5);
-
-  gpi->nPointSize = 16;
-
-  if ( gpi->chProps & SP_HASMVALUES )
-    gpi->nPointSize += 8;
-
-  if ( gpi->chProps & SP_HASZVALUES )
-    gpi->nPointSize += 8;
-
-  if ( gpi->chProps & SP_ISSINGLEPOINT ) {
-    // single point geometry
-    gpi->nNumPoints = 1;
-    if (gpi->nLen < 6 + gpi->nPointSize) {
-      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-      return NOT_ENOUGH_DATA;
-    }
-
-    shape->type = MS_SHAPE_POINT;
-    shape->line = (lineObj *) msSmallMalloc(sizeof(lineObj));
-    shape->numlines = 1;
-    shape->line[0].point = (pointObj *) msSmallMalloc(sizeof(pointObj));
-    shape->line[0].numpoints = 1;
-    gpi->nPointPos = 6;
-
-    ReadPoint(gpi, &shape->line[0].point[0], 0);
-  } else if ( gpi->chProps & SP_ISSINGLELINESEGMENT ) {
-    // single line segment with 2 points
-    gpi->nNumPoints = 2;
-    if (gpi->nLen < 6 + 2 * gpi->nPointSize) {
-      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-      return NOT_ENOUGH_DATA;
-    }
-
-    shape->type = MS_SHAPE_LINE;
-    shape->line = (lineObj *) msSmallMalloc(sizeof(lineObj));
-    shape->numlines = 1;
-    shape->line[0].point = (pointObj *) msSmallMalloc(sizeof(pointObj) * 2);
-    shape->line[0].numpoints = 2;
-    gpi->nPointPos = 6;
-
-    ReadPoint(gpi, &shape->line[0].point[0], 0);
-    ReadPoint(gpi, &shape->line[0].point[1], 1);
-  } else {
-    int iShape, iFigure, iSegment = 0;
-    // complex geometries
-    gpi->nNumPoints = ReadInt32(6);
-
-    if ( gpi->nNumPoints <= 0 ) {
-      return NOERROR;
-    }
-
-    // position of the point array
-    gpi->nPointPos = 10;
-
-    // position of the figures
-    gpi->nFigurePos = gpi->nPointPos + gpi->nPointSize * gpi->nNumPoints + 4;
-
-    if (gpi->nLen < gpi->nFigurePos) {
-      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-      return NOT_ENOUGH_DATA;
-    }
-
-    gpi->nNumFigures = ReadInt32(gpi->nFigurePos - 4);
-
-    if ( gpi->nNumFigures <= 0 ) {
-      return NOERROR;
-    }
-
-    // position of the shapes
-    gpi->nShapePos = gpi->nFigurePos + 5 * gpi->nNumFigures + 4;
-
-    if (gpi->nLen < gpi->nShapePos) {
-      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-      return NOT_ENOUGH_DATA;
-    }
-
-    gpi->nNumShapes = ReadInt32(gpi->nShapePos - 4);
-
-    if (gpi->nLen < gpi->nShapePos + 9 * gpi->nNumShapes) {
-      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-      return NOT_ENOUGH_DATA;
-    }
-
-    if ( gpi->nNumShapes <= 0 ) {
-      return NOERROR;
-    }
-
-    // pick up the root shape
-    if ( ParentOffset(0) != 0xFFFFFFFF) {
-      msDebug("ParseSqlGeometry CORRUPT_DATA\n");
-      return CORRUPT_DATA;
-    }
-
-    // determine the shape type
-    for (iShape = 0; iShape < gpi->nNumShapes; iShape++) {
-      unsigned char shapeType = ShapeType(iShape);
-      if (shapeType == ST_POINT || shapeType == ST_MULTIPOINT) {
-        shape->type = MS_SHAPE_POINT;
-        break;
-      } else if (shapeType == ST_LINESTRING || shapeType == ST_MULTILINESTRING || 
-                 shapeType == ST_CIRCULARSTRING || shapeType == ST_COMPOUNDCURVE) {
-        shape->type = MS_SHAPE_LINE;
-        break;
-      } else if (shapeType == ST_POLYGON || shapeType == ST_MULTIPOLYGON || 
-                 shapeType == ST_CURVEPOLYGON)
-      {
-        shape->type = MS_SHAPE_POLYGON;
-        break;
-      }
-    }
-
-    shape->line = (lineObj *) msSmallMalloc(sizeof(lineObj) * gpi->nNumFigures);
-    shape->numlines = gpi->nNumFigures;
-    gpi->nNumSegments = 0;
-
-    // read figures
-    for (iFigure = 0; iFigure < gpi->nNumFigures; iFigure++) {
-      int iPoint, iNextPoint, i;
-      iPoint = PointOffset(iFigure);
-      iNextPoint = NextPointOffset(iFigure);
-
-      shape->line[iFigure].point = (pointObj *) msSmallMalloc(sizeof(pointObj)*(iNextPoint - iPoint));
-      shape->line[iFigure].numpoints = iNextPoint - iPoint;
-      i = 0;
-
-      if (gpi->chVersion == 0x02 && FigureAttribute(iFigure) >= 0x02) {
-          int nPointPrepared = 0;
-          lineObj* line = &shape->line[iFigure];
-          if (FigureAttribute(iFigure) == 0x03) {
-              if (gpi->nNumSegments == 0) {
-                  /* position of the segment types */
-                  gpi->nSegmentPos = gpi->nShapePos + 9 * gpi->nNumShapes + 4;
-                  gpi->nNumSegments = ReadInt32(gpi->nSegmentPos - 4);
-                  if (gpi->nLen < gpi->nSegmentPos + gpi->nNumSegments) {
-                      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-                      return NOT_ENOUGH_DATA;
-                  }
-                  iSegment = 0;
-              }             
-             
-              while (iPoint < iNextPoint && iSegment < gpi->nNumSegments) {
-                  ReadPoint(gpi, &line->point[i], iPoint);
-                  ++iPoint;
-                  ++nPointPrepared;
-
-                  if (nPointPrepared == 2 && (SegmentType(iSegment) == SMT_FIRSTLINE || SegmentType(iSegment) == SMT_LINE)) {
-                      ++iSegment;
-                      nPointPrepared = 1;
-                  }
-                  else if (nPointPrepared == 3 && (SegmentType(iSegment) == SMT_FIRSTARC || SegmentType(iSegment) == SMT_ARC)) {
-                      i = StrokeArcToLine(gpi, line, i);
-                      ++iSegment;
-                      nPointPrepared = 1;
-                  }
-                  ++i;
-              }
-          }
-          else {
-              while (iPoint < iNextPoint) {
-                  ReadPoint(gpi, &line->point[i], iPoint);
-                  ++iPoint;
-                  ++nPointPrepared;
-                  if (nPointPrepared == 3) {
-                      i = StrokeArcToLine(gpi, line, i);
-                      nPointPrepared = 1;
-                  }
-                  ++i;
-              }
-          }
-      }
-      else {
-          while (iPoint < iNextPoint) {
-              ReadPoint(gpi, &shape->line[iFigure].point[i], iPoint);
-              ++iPoint;
-              ++i;
-          }
-      }
-    }
-  }
-
-  /* set bounds */
-  shape->bounds.minx = gpi->minx;
-  shape->bounds.miny = gpi->miny;
-  shape->bounds.maxx = gpi->maxx;
-  shape->bounds.maxy = gpi->maxy;
-
-  return NOERROR;
-}
-
-/* MS SQL driver code*/
-
-msMSSQL2008LayerInfo *getMSSQL2008LayerInfo(const layerObj *layer)
-{
-  return layer->layerinfo;
-}
-
-void setMSSQL2008LayerInfo(layerObj *layer, msMSSQL2008LayerInfo *MSSQL2008layerinfo)
-{
-  layer->layerinfo = (void*) MSSQL2008layerinfo;
-}
-
-void handleSQLError(layerObj *layer)
-{
-  SQLCHAR       SqlState[6], Msg[SQL_MAX_MESSAGE_LENGTH];
-  SQLINTEGER     NativeError;
-  SQLSMALLINT   i, MsgLen;
-  SQLRETURN  rc;
-  msMSSQL2008LayerInfo *layerinfo = getMSSQL2008LayerInfo(layer);
-
-  if (layerinfo == NULL)
-    return;
-
-  // Get the status records.
-  i = 1;
-  while ((rc = SQLGetDiagRec(SQL_HANDLE_STMT, layerinfo->conn->hstmt, i, SqlState, &NativeError,
-                             Msg, sizeof(Msg), &MsgLen)) != SQL_NO_DATA) {
-    if(layer->debug) {
-      msDebug("SQLError: %s\n", Msg);
-    }
-    i++;
-  }
-}
-
-/* TODO Take a look at glibc's strcasestr */
-static char *strstrIgnoreCase(const char *haystack, const char *needle)
-{
-  char    *hay_lower;
-  char    *needle_lower;
-  size_t  len_hay,len_need, match;
-  int    found = MS_FALSE;
-  char    *loc;
-
-  len_hay = strlen(haystack);
-  len_need = strlen(needle);
-
-  hay_lower = (char*) msSmallMalloc(len_hay + 1);
-  needle_lower =(char*) msSmallMalloc(len_need + 1);
-
-  size_t t;
-  for(t = 0; t < len_hay; t++) {
-    hay_lower[t] = (char)tolower(haystack[t]);
-  }
-  hay_lower[t] = 0;
-
-  for(t = 0; t < len_need; t++) {
-    needle_lower[t] = (char)tolower(needle[t]);
-  }
-  needle_lower[t] = 0;
-
-  loc = strstr(hay_lower, needle_lower);
-  if(loc) {
-    match = loc - hay_lower;
-    found = MS_TRUE;
-  }
-
-  msFree(hay_lower);
-  msFree(needle_lower);
-
-  return (char *) (found == MS_FALSE ? NULL : haystack + match);
-}
-
-static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name, char **geom_column_type, char **table_name, char **urid_name, char **user_srid, char **index_name, char **sort_spec, int debug);
-
-/* Close connection and handles */
-static void msMSSQL2008CloseConnection(void *conn_handle)
-{
-  msODBCconn * conn = (msODBCconn *) conn_handle;
-
-  if (!conn) {
-    return;
-  }
-
-  if (conn->hstmt) {
-    SQLFreeHandle(SQL_HANDLE_STMT, conn->hstmt);
-  }
-  if (conn->hdbc) {
-    SQLDisconnect(conn->hdbc);
-    SQLFreeHandle(SQL_HANDLE_DBC, conn->hdbc);
-  }
-  if (conn->henv) {
-    SQLFreeHandle(SQL_HANDLE_ENV, conn->henv);
-  }
-
-  msFree(conn);
-}
-
-/* Set the error string for the connection */
-static void setConnError(msODBCconn *conn)
-{
-  SQLSMALLINT len;
-
-  SQLGetDiagField(SQL_HANDLE_DBC, conn->hdbc, 1, SQL_DIAG_MESSAGE_TEXT, (SQLPOINTER) conn->errorMessage, sizeof(conn->errorMessage), &len);
-
-  conn->errorMessage[len] = 0;
-}
-
-#ifdef USE_ICONV
-static SQLWCHAR* convertCwchartToSQLWCHAR(const wchar_t* inStr)
-{
-    SQLWCHAR* outStr;
-    int i, len;
-    for( len = 0; inStr[len] != 0; ++len )
-    {
-        /* do nothing */
-    }
-    outStr = (SQLWCHAR*)msSmallMalloc(sizeof(SQLWCHAR) * (len + 1));
-    for( i = 0; i <= len; i++ )
-    {
-        outStr[i] = (SQLWCHAR)inStr[i];
-    }
-    return outStr;
-}
-#endif
-
-/* Connect to db */
-static msODBCconn * mssql2008Connect(const char * connString)
-{
-  SQLSMALLINT outConnStringLen;
-  SQLRETURN rc;
-  msODBCconn * conn = msSmallMalloc(sizeof(msODBCconn));
-  char fullConnString[1024];
-
-  memset(conn, 0, sizeof(*conn));
-
-  SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &conn->henv);
-
-  SQLSetEnvAttr(conn->henv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) SQL_OV_ODBC3, 0);
-
-  SQLAllocHandle(SQL_HANDLE_DBC, conn->henv, &conn->hdbc);
-
-  if (strcasestr(connString, "DRIVER=") == 0)
-  {
-      snprintf(fullConnString, sizeof(fullConnString), "DRIVER={SQL Server};%s", connString);
-
-      connString = fullConnString;
-  }
-
-  {
-#ifdef USE_ICONV
-      wchar_t *decodedConnString = msConvertWideStringFromUTF8(connString, "UCS-2LE");
-      SQLWCHAR outConnString[1024];
-      SQLWCHAR* decodedConnStringSQLWCHAR = convertCwchartToSQLWCHAR(decodedConnString);
-      rc = SQLDriverConnectW(conn->hdbc, NULL, decodedConnStringSQLWCHAR, SQL_NTS, outConnString, 1024, &outConnStringLen, SQL_DRIVER_NOPROMPT);
-      msFree(decodedConnString);
-      msFree(decodedConnStringSQLWCHAR);
-#else
-      SQLCHAR outConnString[1024];
-      rc = SQLDriverConnect(conn->hdbc, NULL, (SQLCHAR*)connString, SQL_NTS, outConnString, 1024, &outConnStringLen, SQL_DRIVER_NOPROMPT);
-#endif
-  }  
-
-  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-    setConnError(conn);
-
-    return conn;
-  }
-
-  SQLAllocHandle(SQL_HANDLE_STMT, conn->hdbc, &conn->hstmt);
-
-  return conn;
-}
-
-/* Set the error string for the statement execution */
-static void setStmntError(msODBCconn *conn)
-{
-  SQLSMALLINT len;
-
-  SQLGetDiagField(SQL_HANDLE_STMT, conn->hstmt, 1, SQL_DIAG_MESSAGE_TEXT, (SQLPOINTER) conn->errorMessage, sizeof(conn->errorMessage), &len);
-
-  conn->errorMessage[len] = 0;
-}
-
-/* Execute SQL against connection. Set error string  if failed */
-static int executeSQL(msODBCconn *conn, const char * sql)
-{
-  SQLRETURN rc;
-
-  SQLCloseCursor(conn->hstmt);
-
-#ifdef USE_ICONV
-  {
-    wchar_t *decodedSql = msConvertWideStringFromUTF8(sql, "UCS-2LE");
-    SQLWCHAR* decodedSqlSQLWCHAR = convertCwchartToSQLWCHAR(decodedSql);
-    rc = SQLExecDirectW(conn->hstmt, decodedSqlSQLWCHAR, SQL_NTS);
-    msFree(decodedSql);
-    msFree(decodedSqlSQLWCHAR);
-  }
-#else
-  rc = SQLExecDirect(conn->hstmt, (SQLCHAR *) sql, SQL_NTS);
-#endif
-
-  if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
-    return 1;
-  } else {
-    setStmntError(conn);
-    return 0;
-  }
-}
-
-/* Get columns name from query results */
-static int columnName(msODBCconn *conn, int index, char *buffer, int bufferLength, layerObj *layer, char pass_field_def, SQLSMALLINT *itemType)
-{
-  SQLRETURN rc;
-
-  SQLCHAR columnName[SQL_COLUMN_NAME_MAX_LENGTH + 1];
-  SQLSMALLINT columnNameLen;
-  SQLSMALLINT dataType;
-  SQLULEN columnSize;
-  SQLSMALLINT decimalDigits;
-  SQLSMALLINT nullable;
-
-  rc = SQLDescribeCol(
-         conn->hstmt,
-         (SQLUSMALLINT)index,
-         columnName,
-         SQL_COLUMN_NAME_MAX_LENGTH,
-         &columnNameLen,
-         &dataType,
-         &columnSize,
-         &decimalDigits,
-         &nullable);
-
-  if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
-    if (bufferLength < SQL_COLUMN_NAME_MAX_LENGTH + 1)
-      strlcpy(buffer, (const char *)columnName, bufferLength);
-    else
-      strlcpy(buffer, (const char *)columnName, SQL_COLUMN_NAME_MAX_LENGTH + 1);
-
-    *itemType = dataType;
-
-    if (pass_field_def) {
-      char gml_width[32], gml_precision[32];
-      const char *gml_type = NULL;
-
-      gml_width[0] = '\0';
-      gml_precision[0] = '\0';
-
-      switch( dataType ) {
-        case SQL_INTEGER:
-        case SQL_SMALLINT:
-        case SQL_TINYINT:
-          gml_type = "Integer";
-          break;
-
-        case SQL_BIGINT:
-          gml_type = "Long";
-          break;
-
-        case SQL_REAL:
-        case SQL_FLOAT:
-        case SQL_DOUBLE:
-        case SQL_DECIMAL:
-        case SQL_NUMERIC:
-          gml_type = "Real";
-          if( decimalDigits > 0 )
-            sprintf( gml_precision, "%d", decimalDigits );
-          break;
-
-        case SQL_TYPE_DATE:
-          gml_type = "Date";
-          break;
-        case SQL_TYPE_TIME:
-          gml_type = "Time";
-          break;
-        case SQL_TYPE_TIMESTAMP:
-          gml_type = "DateTime";
-          break;
-
-        case SQL_BIT:
-          gml_type = "Boolean";
-          break;
-
-        default:
-          gml_type = "Character";
-          break;
-      }
-
-      if( columnSize > 0 )
-            sprintf( gml_width, "%u", (unsigned int)columnSize );
-
-      msUpdateGMLFieldMetadata(layer, buffer, gml_type, gml_width, gml_precision, (const short) nullable);
-    }
-    return 1;
-  } else {
-    setStmntError(conn);
-    return 0;
-  }
-}
-
-/* open up a connection to the MS SQL 2008 database using the connection string in layer->connection */
-/* ie. "driver=<driver>;server=<server>;database=<database>;integrated security=?;user id=<username>;password=<password>" */
-int msMSSQL2008LayerOpen(layerObj *layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
-  char *conn_decrypted = NULL;
-
-  if(layer->debug) {
-    msDebug("msMSSQL2008LayerOpen called datastatement: %s\n", layer->data);
-  }
-
-  if(getMSSQL2008LayerInfo(layer)) {
-    if(layer->debug) {
-      msDebug("msMSSQL2008LayerOpen :: layer is already open!!\n");
-    }
-    return MS_SUCCESS;  /* already open */
-  }
-
-  if(!layer->data) {
-    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerOpen()", "", "Error parsing MSSQL2008 data variable: nothing specified in DATA statement.<br><br>\n\nMore Help:<br><br>\n\n");
-
-    return MS_FAILURE;
-  }
-
-  if(!layer->connection) {
-    msSetError( MS_QUERYERR, "MSSQL connection parameter not specified.", "msMSSQL2008LayerOpen()");
-    return MS_FAILURE;
-  }
-
-  /* have to setup a connection to the database */
-
-  layerinfo = (msMSSQL2008LayerInfo*) msSmallMalloc(sizeof(msMSSQL2008LayerInfo));
-
-  layerinfo->sql = NULL; /* calc later */
-  layerinfo->row_num = 0;
-  layerinfo->geom_column = NULL;
-  layerinfo->geom_column_type = NULL;
-  layerinfo->geom_table = NULL;
-  layerinfo->urid_name = NULL;
-  layerinfo->user_srid = NULL;
-  layerinfo->index_name = NULL;
-  layerinfo->sort_spec = NULL;
-  layerinfo->conn = NULL;
-  layerinfo->itemtypes = NULL;
-  layerinfo->mssqlversion_major = 0;
-  layerinfo->paging = MS_TRUE;
-
-  layerinfo->conn = (msODBCconn *) msConnPoolRequest(layer);
-
-  if(!layerinfo->conn) {
-    if(layer->debug) {
-      msDebug("MSMSSQL2008LayerOpen -- shared connection not available.\n");
-    }
-
-    /* Decrypt any encrypted token in connection and attempt to connect */
-    conn_decrypted = msDecryptStringTokens(layer->map, layer->connection);
-    if (conn_decrypted == NULL) {
-      return(MS_FAILURE);  /* An error should already have been produced */
-    }
-
-    layerinfo->conn = mssql2008Connect(conn_decrypted);
-
-    msFree(conn_decrypted);
-    conn_decrypted = NULL;
-
-    if(!layerinfo->conn || layerinfo->conn->errorMessage[0]) {
-      char *errMess = "Out of memory";
-
-      if (layer->debug)
-          msDebug("MSMSSQL2008LayerOpen: Connection failure.\n");
-
-      if (layerinfo->conn) {
-        errMess = layerinfo->conn->errorMessage;
-      }
-
-      msDebug("Couldn't make connection to MS SQL Server with connect string '%s'.\n"
-                 "Error reported was '%s'.\n\n"
-                 "This error occured when trying to make a connection to the specified SQL server.\n"
-                 "Most commonly this is caused by: \n"
-                 "(1) incorrect connection string \n"
-                 "(2) you didn't specify a 'user id=...' in your connection string \n"
-                 "(3) SQL server isnt running \n"
-                 "(4) TCPIP not enabled for SQL Client or server \n\n",
-                 layer->connection, errMess);
-      msSetError(MS_QUERYERR, "Database connection failed. Check server logs for more details. Is SQL Server running? Is it allowing connections? Does the specified user exist? Is the password valid? Is the database on the standard port?", "MSMSSQL2008LayerOpen()");
-
-      msMSSQL2008CloseConnection(layerinfo->conn);
-      msFree(layerinfo);
-      return MS_FAILURE;
-    }
-
-    msConnPoolRegister(layer, layerinfo->conn, msMSSQL2008CloseConnection);
-  }
-
-  setMSSQL2008LayerInfo(layer, layerinfo);
-
-  if (msMSSQL2008LayerParseData(layer, &layerinfo->geom_column, &layerinfo->geom_column_type, &layerinfo->geom_table, &layerinfo->urid_name, &layerinfo->user_srid, &layerinfo->index_name, &layerinfo->sort_spec, layer->debug) != MS_SUCCESS) {
-    msSetError( MS_QUERYERR, "Could not parse the layer data", "msMSSQL2008LayerOpen()");
-    return MS_FAILURE;
-  }
-
-  /* identify the geometry transfer type */
-  if (msLayerGetProcessingKey( layer, "MSSQL_READ_WKB" ) != NULL)
-    layerinfo->geometry_format = MSSQLGEOMETRY_WKB;
-  else {
-    layerinfo->geometry_format = MSSQLGEOMETRY_NATIVE;
-    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
-      layerinfo->gpi.nColType = MSSQLCOLTYPE_GEOGRAPHY;
-    else
-      layerinfo->gpi.nColType = MSSQLCOLTYPE_GEOMETRY;
-  }
-
-  return MS_SUCCESS;
-}
-
-/* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
-int msMSSQL2008LayerIsOpen(layerObj *layer)
-{
-  return getMSSQL2008LayerInfo(layer) ? MS_TRUE : MS_FALSE;
-}
-
-
-/* Free the itemindexes array in a layer. */
-void msMSSQL2008LayerFreeItemInfo(layerObj *layer)
-{
-  if(layer->debug) {
-    msDebug("msMSSQL2008LayerFreeItemInfo called\n");
-  }
-
-  if(layer->iteminfo) {
-    msFree(layer->iteminfo);
-  }
-
-  layer->iteminfo = NULL;
-}
-
-
-/* allocate the iteminfo index array - same order as the item list */
-int msMSSQL2008LayerInitItemInfo(layerObj *layer)
-{
-  int     i;
-  int     *itemindexes ;
-
-  if (layer->debug) {
-    msDebug("msMSSQL2008LayerInitItemInfo called\n");
-  }
-
-  if(layer->numitems == 0) {
-    return MS_SUCCESS;
-  }
-
-  msFree(layer->iteminfo);
-
-  layer->iteminfo = (int *) msSmallMalloc(sizeof(int) * layer->numitems);
-
-  itemindexes = (int*)layer->iteminfo;
-
-  for(i = 0; i < layer->numitems; i++) {
-    itemindexes[i] = i; /* last one is always the geometry one - the rest are non-geom */
-  }
-
-  return MS_SUCCESS;
-}
-
-static int getMSSQLMajorVersion(layerObj* layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo = getMSSQL2008LayerInfo(layer);
-  if (layerinfo == NULL)
-    return 0;
-
-  if (layerinfo->mssqlversion_major == 0) {
-    const char* mssqlversion_major = msLayerGetProcessingKey(layer, "MSSQL_VERSION_MAJOR");
-    if (mssqlversion_major != NULL) {
-      layerinfo->mssqlversion_major = atoi(mssqlversion_major);
-    }
-    else {
-      /* need to query from database */
-      if (executeSQL(layerinfo->conn, "SELECT SERVERPROPERTY('ProductVersion')")) {
-        SQLRETURN rc = SQLFetch(layerinfo->conn->hstmt);
-        if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
-          /* process results */
-          char result_data[256];
-          SQLLEN retLen = 0;
-
-          rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-
-          if (rc != SQL_ERROR) {
-            result_data[retLen] = 0;
-            layerinfo->mssqlversion_major = atoi(result_data);
-          }
-        }
-      }
-    }
-  }
-
-  return layerinfo->mssqlversion_major;
-}
-
-static int addFilter(layerObj *layer, char **query)
-{
-  if (layer->filter.native_string) {
-    (*query) = msStringConcatenate(*query, " WHERE (");
-    (*query) = msStringConcatenate(*query, layer->filter.native_string);
-    (*query) = msStringConcatenate(*query, ")");
-    return MS_TRUE;
-  }
-  else if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
-    (*query) = msStringConcatenate(*query, " WHERE (");
-    (*query) = msStringConcatenate(*query, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
-    (*query) = msStringConcatenate(*query, ")");
-    return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/* Get the layer extent as specified in the mapfile or a largest area */
-/* covering all features */
-int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent)
-{
-    msMSSQL2008LayerInfo *layerinfo;
-    char *query = 0;
-    char result_data[256];
-    SQLLEN retLen;
-    SQLRETURN rc;
-    
-    if(layer->debug) {
-      msDebug("msMSSQL2008LayerGetExtent called\n");
-    }
-
-    if (!(layer->extent.minx == -1.0 && layer->extent.miny == -1.0 && 
-        layer->extent.maxx == -1.0 && layer->extent.maxy == -1.0)) {
-      /* extent was already set */
-      extent->minx = layer->extent.minx;
-      extent->miny = layer->extent.miny;
-      extent->maxx = layer->extent.maxx;
-      extent->maxy = layer->extent.maxy;
-    }
-
-    layerinfo = getMSSQL2008LayerInfo(layer);
-
-    if (!layerinfo) {
-        msSetError(MS_QUERYERR, "GetExtent called with layerinfo = NULL", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
-
-    /* set up statement */
-    if (getMSSQLMajorVersion(layer) >= 11) {
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
-        query = msStringConcatenate(query, "WITH extent(extentcol) AS (SELECT geometry::EnvelopeAggregate(geometry::STGeomFromWKB(");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STAsBinary(), ");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STSrid)");
-      }
-      else {
-        query = msStringConcatenate(query, "WITH extent(extentcol) AS (SELECT geometry::EnvelopeAggregate(");
-        query = msStringConcatenate(query, layerinfo->geom_column);        
-      }
-      query = msStringConcatenate(query, ") AS extentcol FROM ");
-      query = msStringConcatenate(query, layerinfo->geom_table);
-
-      /* adding attribute filter */
-      addFilter(layer, &query);
-
-      query = msStringConcatenate(query, ") SELECT extentcol.STPointN(1).STX, extentcol.STPointN(1).STY, extentcol.STPointN(3).STX, extentcol.STPointN(3).STY FROM extent");
-    }
-    else {
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
-        query = msStringConcatenate(query, "WITH ENVELOPE as (SELECT geometry::STGeomFromWKB(");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STAsBinary(), ");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STSrid)");
-      }
-      else {
-        query = msStringConcatenate(query, "WITH ENVELOPE as (SELECT ");
-        query = msStringConcatenate(query, layerinfo->geom_column);      
-      }
-      query = msStringConcatenate(query, ".STEnvelope() as envelope from ");
-      query = msStringConcatenate(query, layerinfo->geom_table);
-
-      /* adding attribute filter */
-      addFilter(layer, &query);
-
-      query = msStringConcatenate(query, "), CORNERS as (SELECT envelope.STPointN(1) as point from ENVELOPE UNION ALL select envelope.STPointN(3) from ENVELOPE) SELECT MIN(point.STX), MIN(point.STY), MAX(point.STX), MAX(point.STY) FROM CORNERS");
-    }
-
-    if (!executeSQL(layerinfo->conn, query)) {
-        msFree(query);
-        return MS_FAILURE;
-    }
-
-    msFree(query);
-
-    /* process results */
-    rc = SQLFetch(layerinfo->conn->hstmt);
-
-    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-        if (layer->debug) {
-            msDebug("msMSSQL2008LayerGetExtent: No results found.\n");
-        }
-        return MS_FAILURE;
-    }
-
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MinX value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
-
-    result_data[retLen] = 0;
-
-    extent->minx = atof(result_data);
-
-    rc = SQLGetData(layerinfo->conn->hstmt, 2, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MinY value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
-
-    result_data[retLen] = 0;
-
-    extent->miny = atof(result_data);
-
-    rc = SQLGetData(layerinfo->conn->hstmt, 3, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MaxX value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
-
-    result_data[retLen] = 0;
-
-    extent->maxx = atof(result_data);
-
-    rc = SQLGetData(layerinfo->conn->hstmt, 4, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MaxY value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
-
-    result_data[retLen] = 0;
-
-    extent->maxy = atof(result_data);
-
-    return MS_SUCCESS;
-}
-
-/* Get the layer feature count */
-int msMSSQL2008LayerGetNumFeatures(layerObj *layer)
-{
-    msMSSQL2008LayerInfo *layerinfo;
-    char *query = 0;
-    char result_data[256];
-    SQLLEN retLen;
-    SQLRETURN rc;
-
-    if (layer->debug) {
-        msDebug("msMSSQL2008LayerGetNumFeatures called\n");
-    }
-
-    layerinfo = getMSSQL2008LayerInfo(layer);
-
-    if (!layerinfo) {
-        msSetError(MS_QUERYERR, "GetNumFeatures called with layerinfo = NULL", "msMSSQL2008LayerGetNumFeatures()");
-        return -1;
-    }
-
-    /* set up statement */
-    query = msStringConcatenate(query, "SELECT count(*) FROM ");
-    query = msStringConcatenate(query, layerinfo->geom_table);
-
-    /* adding attribute filter */
-    addFilter(layer, &query);
-
-    if (!executeSQL(layerinfo->conn, query)) {
-        msFree(query);
-        return -1;
-    }
-
-    msFree(query);
-
-    rc = SQLFetch(layerinfo->conn->hstmt);
-
-    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-        if (layer->debug) {
-            msDebug("msMSSQL2008LayerGetNumFeatures: No results found.\n");
-        }
-
-        return -1;
-    }
-
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-
-    if (rc == SQL_ERROR) {
-        msSetError(MS_QUERYERR, "Failed to get feature count", "msMSSQL2008LayerGetNumFeatures()");
-        return -1;
-    }
-
-    result_data[retLen] = 0;
-
-    return atoi(result_data);
-}
-
-/* Prepare and execute the SQL statement for this layer */
-static int prepare_database(layerObj *layer, rectObj rect, char **query_string, int isQuery)
-{
-  msMSSQL2008LayerInfo *layerinfo;
-  char *query = 0;
-  char *data_source = 0;
-  char *f_table_name = 0;
-  char *geom_table = 0;
-  char *tmp = 0;
-  char *paging_query = 0;
-  /*
-    "Geometry::STGeomFromText('POLYGON(())',)" + terminator = 40 chars
-    Plus 10 formatted doubles (15 digits of precision, a decimal point, a space/comma delimiter each = 17 chars each)
-    Plus SRID + comma - if SRID is a long...we'll be safe with 10 chars
-
-  	or for geography columns
-	
-    "Geography::STGeomFromText('CURVEPOLYGON(())',)" + terminator = 46 chars
-    Plus 18 formatted doubles (15 digits of precision, a decimal point, a space/comma delimiter each = 17 chars each)
-    Plus SRID + comma - if SRID is a long...we'll be safe with 10 chars
-  */
-  char        box3d[46 + 18 * 22 + 11];
-  int         t;
-
-  char        *pos_from, *pos_ftab, *pos_space, *pos_paren;
-  int hasFilter = MS_FALSE;
-  const rectObj rectInvalid = MS_INIT_INVALID_RECT;
-  const int bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
-
-  layerinfo =  getMSSQL2008LayerInfo(layer);
-
-  /* Extract the proper f_table_name from the geom_table string.
-   * We are expecting the geom_table to be either a single word
-   * or a sub-select clause that possibly includes a join --
-   *
-   * (select column[,column[,...]] from ftab[ natural join table2]) as foo
-   *
-   * We are expecting whitespace or a ')' after the ftab name.
-   *
-   */
-
-  geom_table = msStrdup(layerinfo->geom_table);
-  pos_from = strstrIgnoreCase(geom_table, " from ");
-
-  if(!pos_from) {
-    f_table_name = (char *) msSmallMalloc(strlen(geom_table) + 1);
-    strcpy(f_table_name, geom_table);
-  } else { /* geom_table is a sub-select clause */
-    pos_ftab = pos_from + 6; /* This should be the start of the ftab name */
-    pos_space = strstr(pos_ftab, " "); /* First space */
-
-    /* TODO strrchr is POSIX and C99, rindex is neither */
-#if defined(_WIN32) && !defined(__CYGWIN__)
-    pos_paren = strrchr(pos_ftab, ')');
-#else
-    pos_paren = rindex(pos_ftab, ')');
-#endif
-
-    if(!pos_space || !pos_paren) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "prepare_database()", geom_table, "Error parsing MSSQL2008 data variable: Something is wrong with your subselect statement.<br><br>\n\nMore Help:<br><br>\n\n");
-
-      return MS_FAILURE;
-    }
-
-    if (pos_paren < pos_space) { /* closing parenthesis preceeds any space */
-      f_table_name = (char *) msSmallMalloc(pos_paren - pos_ftab + 1);
-      strlcpy(f_table_name, pos_ftab, pos_paren - pos_ftab + 1);
-    } else {
-      f_table_name = (char *) msSmallMalloc(pos_space - pos_ftab + 1);
-      strlcpy(f_table_name, pos_ftab, pos_space - pos_ftab + 1);
-    }
-  }
-
-  if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
-      /* create point shape for rectangles with zero area */
-      sprintf(box3d, "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
-          layerinfo->geom_column_type, rect.minx, rect.miny, layerinfo->user_srid);
-  } else if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
-	  /* SQL Server has a problem when x is -180 or 180 */  
-	  double minx = rect.minx <= -180? -179.999: rect.minx;
-	  double maxx = rect.maxx >= 180? 179.999: rect.maxx;
-	  double miny = rect.miny < -90? -90: rect.miny;
-	  double maxy = rect.maxy > 90? 90: rect.maxy;
-	  sprintf(box3d, "Geography::STGeomFromText('CURVEPOLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
-          minx, miny,
-          minx + (maxx - minx) / 2, miny,
-          maxx, miny,
-          maxx, miny + (maxy - miny) / 2,
-          maxx, maxy,
-          minx + (maxx - minx) / 2, maxy,
-          minx, maxy,
-          minx, miny + (maxy - miny) / 2,
-          minx, miny,
-          layerinfo->user_srid);  
-  } else {
-      sprintf(box3d, "Geometry::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
-          rect.minx, rect.miny,
-          rect.maxx, rect.miny,
-          rect.maxx, rect.maxy,
-          rect.minx, rect.maxy,
-          rect.minx, rect.miny,
-          layerinfo->user_srid
-      );
-  }
-
-  /* substitute token '!BOX!' in geom_table with the box3d - do an unlimited # of subs */
-  /* to not undo the work here, we need to make sure that data_source is malloc'd here */
-
-  if (!strstr(geom_table, "!BOX!")) {
-      data_source = (char *)msSmallMalloc(strlen(geom_table) + 1);
-      strcpy(data_source, geom_table);
-  }
-  else {
-      char* result = NULL;
-
-      while (strstr(geom_table, "!BOX!")) {
-          /* need to do a substition */
-          char    *start, *end;
-          char    *oldresult = result;
-          start = strstr(geom_table, "!BOX!");
-          end = start + 5;
-
-          result = (char *)msSmallMalloc((start - geom_table) + strlen(box3d) + strlen(end) + 1);
-
-          strlcpy(result, geom_table, start - geom_table + 1);
-          strcpy(result + (start - geom_table), box3d);
-          strcat(result, end);
-
-          geom_table = result;
-          msFree(oldresult);
-      }
-
-      /* if we're here, this will be a malloc'd string, so no need to copy it */
-      data_source = (char *)geom_table;
-  }
-
-  /* start creating the query */
-
-  query = msStringConcatenate(query, "SELECT ");
-  if (layerinfo->paging && (layer->maxfeatures >= 0 || layer->startindex > 0))
-    paging_query = msStringConcatenate(paging_query, "SELECT ");
-
-  /* adding items to the select list */
-  for (t = 0; t < layer->numitems; t++) {
-#ifdef USE_ICONV
-      query = msStringConcatenate(query, "convert(nvarchar(max), [");     
-#else
-      query = msStringConcatenate(query, "convert(varchar(max), [");
-#endif
-      query = msStringConcatenate(query, layer->items[t]);
-      query = msStringConcatenate(query, "]) '");
-      tmp = msIntToString(t);
-      query = msStringConcatenate(query, tmp);
-      if (paging_query) {
-          paging_query = msStringConcatenate(paging_query, "[");
-          paging_query = msStringConcatenate(paging_query, tmp);
-          paging_query = msStringConcatenate(paging_query, "], ");
-      }
-      msFree(tmp);
-      query = msStringConcatenate(query, "',");
-  }
-
-  /* adding geometry column */
-  query = msStringConcatenate(query, "[");
-  query = msStringConcatenate(query, layerinfo->geom_column);
-  if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
-      query = msStringConcatenate(query, "] 'geom',");
-  else {
-      query = msStringConcatenate(query, "].STAsBinary() 'geom',");
-  }
-
-  /* adding id column */
-  query = msStringConcatenate(query, "convert(varchar(36), [");
-  query = msStringConcatenate(query, layerinfo->urid_name);
-  if (paging_query) {
-      paging_query = msStringConcatenate(paging_query, "[geom], [id] FROM (");
-      query = msStringConcatenate(query, "]) 'id', row_number() over (");
-      if (layerinfo->sort_spec) {
-          query = msStringConcatenate(query, layerinfo->sort_spec);
-      }
-
-      if (layer->sortBy.nProperties > 0) {
-          tmp = msLayerBuildSQLOrderBy(layer);
-          if (layerinfo->sort_spec) {
-              query = msStringConcatenate(query, ", ");
-          }
-          else {
-              query = msStringConcatenate(query, " ORDER BY ");
-          }
-          query = msStringConcatenate(query, tmp);
-          msFree(tmp);
-      }
-      else {
-          if (!layerinfo->sort_spec) {
-              // use the unique Id as the default sort for paging
-              query = msStringConcatenate(query, "ORDER BY ");
-              query = msStringConcatenate(query, layerinfo->urid_name);
-          }
-      }
-      query = msStringConcatenate(query, ") 'rownum' FROM ");
-  }
-  else {
-      query = msStringConcatenate(query, "]) 'id' FROM ");
-  }
-
-  /* adding the source */
-  query = msStringConcatenate(query, data_source);
-  msFree(data_source);
-  msFree(f_table_name);
-
-  /* use the index hint if provided */
-  if (layerinfo->index_name) {
-      query = msStringConcatenate(query, " WITH (INDEX(");
-      query = msStringConcatenate(query, layerinfo->index_name);
-      query = msStringConcatenate(query, "))");
-  }
-
-  /* adding attribute filter */
-  hasFilter = addFilter(layer, &query);
-
-  if( bIsValidRect ) {
-    /* adding spatial filter */
-    if (hasFilter == MS_FALSE)
-        query = msStringConcatenate(query, " WHERE ");
-    else
-        query = msStringConcatenate(query, " AND ");
-
-    query = msStringConcatenate(query, layerinfo->geom_column);
-    query = msStringConcatenate(query, ".STIntersects(");
-    query = msStringConcatenate(query, box3d);
-    query = msStringConcatenate(query, ") = 1 ");
-  }
-
-  if (paging_query) {
-      paging_query = msStringConcatenate(paging_query, query);
-      paging_query = msStringConcatenate(paging_query, ") tbl where [rownum] ");
-      if (layer->startindex > 0) {
-          tmp = msIntToString(layer->startindex);
-          paging_query = msStringConcatenate(paging_query, ">= ");
-          paging_query = msStringConcatenate(paging_query, tmp);
-          if (layer->maxfeatures >= 0) {
-              msFree(tmp);
-              tmp = msIntToString(layer->startindex + layer->maxfeatures);
-              paging_query = msStringConcatenate(paging_query, " and [rownum] < ");
-              paging_query = msStringConcatenate(paging_query, tmp);
-          }
-      }
-      else {
-          tmp = msIntToString(layer->maxfeatures);
-          paging_query = msStringConcatenate(paging_query, "< ");
-          paging_query = msStringConcatenate(paging_query, tmp);
-      }
-      msFree(tmp);
-      msFree(query);
-      query = paging_query;
-  } 
-  else {
-      if (layerinfo->sort_spec) {
-          query = msStringConcatenate(query, layerinfo->sort_spec);
-      }
-
-      /* Add extra sort by */
-      if (layer->sortBy.nProperties > 0) {
-          char* pszTmp = msLayerBuildSQLOrderBy(layer);
-          if (layerinfo->sort_spec)
-              query = msStringConcatenate(query, ", ");
-          else
-              query = msStringConcatenate(query, " ORDER BY ");
-          query = msStringConcatenate(query, pszTmp);
-          msFree(pszTmp);
-      }
-      else if (isQuery && !layerinfo->sort_spec) {
-          /* Add orderby to make the result set order deterministic */
-          query = msStringConcatenate(query, " ORDER BY [");
-          query = msStringConcatenate(query, layerinfo->urid_name);
-          query = msStringConcatenate(query, "]");
-      }
-  }
-
-
-  if (layer->debug) {
-      msDebug("query:%s\n", query);
-  }
-
-  if (executeSQL(layerinfo->conn, query)) {
-      char pass_field_def = 0;
-      int t;
-      const char *value;
-      *query_string = query;
-      /* collect result information */
-      if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-          && strcasecmp(value, "auto") == 0)
-          pass_field_def = 1;
-
-      msFree(layerinfo->itemtypes);
-      layerinfo->itemtypes = msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
-      for (t = 0; t < layer->numitems; t++) {
-          char colBuff[256];
-          SQLSMALLINT itemType = 0;
-
-          columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer, pass_field_def, &itemType);
-          layerinfo->itemtypes[t] = itemType;
-      }
-
-      return MS_SUCCESS;
-  }
-  else {
-      msSetError(MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n", "msMSSQL2008LayerGetShape()", query, layerinfo->conn->errorMessage);
-
-      msFree(query);
-
-      return MS_FAILURE;
-  }
-}
-
-/* Execute SQL query for this layer */
-int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)isQuery;
-  msMSSQL2008LayerInfo  *layerinfo = 0;
-  char    *query_str = 0;
-  int     set_up_result;
-
-  if(layer->debug) {
-    msDebug("msMSSQL2008LayerWhichShapes called\n");
-  }
-
-  layerinfo = getMSSQL2008LayerInfo(layer);
-
-  if(!layerinfo) {
-    /* layer not opened yet */
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerWhichShapes called on unopened layer (layerinfo = NULL)", "msMSSQL2008LayerWhichShapes()");
-
-    return MS_FAILURE;
-  }
-
-  if(!layer->data) {
-    msSetError(MS_QUERYERR, "Missing DATA clause in MSSQL2008 Layer definition.  DATA statement must contain 'geometry_column from table_name' or 'geometry_column from (sub-query) as foo'.", "msMSSQL2008LayerWhichShapes()");
-
-    return MS_FAILURE;
-  }
-
-  set_up_result = prepare_database(layer, rect, &query_str, isQuery);
-
-  if(set_up_result != MS_SUCCESS) {
-    msFree(query_str);
-
-    return set_up_result; /* relay error */
-  }
-
-  msFree(layerinfo->sql);
-  layerinfo->sql = query_str;
-  layerinfo->row_num = 0;
-
-  return MS_SUCCESS;
-}
-
-/* Close the MSSQL2008 record set and connection */
-int msMSSQL2008LayerClose(layerObj *layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
-
-  layerinfo = getMSSQL2008LayerInfo(layer);
-
-  if(layer->debug) {
-    char *data = "";
-
-    if (layer->data) {
-      data = layer->data;
-    }
-
-    msDebug("msMSSQL2008LayerClose datastatement: %s\n", data);
-  }
-
-  if(layer->debug && !layerinfo) {
-    msDebug("msMSSQL2008LayerClose -- layerinfo is  NULL\n");
-  }
-
-  if(layerinfo) {
-    msConnPoolRelease(layer, layerinfo->conn);
-
-    layerinfo->conn = NULL;
-
-    if(layerinfo->user_srid) {
-      msFree(layerinfo->user_srid);
-      layerinfo->user_srid = NULL;
-    }
-
-    if(layerinfo->urid_name) {
-      msFree(layerinfo->urid_name);
-      layerinfo->urid_name = NULL;
-    }
-
-    if(layerinfo->index_name) {
-      msFree(layerinfo->index_name);
-      layerinfo->index_name = NULL;
-    }
-
-    if(layerinfo->sort_spec) {
-      msFree(layerinfo->sort_spec);
-      layerinfo->sort_spec = NULL;
-    }
-
-    if(layerinfo->sql) {
-      msFree(layerinfo->sql);
-      layerinfo->sql = NULL;
-    }
-
-    if(layerinfo->geom_column) {
-      msFree(layerinfo->geom_column);
-      layerinfo->geom_column = NULL;
-    }
-
-    if(layerinfo->geom_column_type) {
-      msFree(layerinfo->geom_column_type);
-      layerinfo->geom_column_type = NULL;
-    }
-
-    if(layerinfo->geom_table) {
-      msFree(layerinfo->geom_table);
-      layerinfo->geom_table = NULL;
-    }
-
-    if(layerinfo->itemtypes) {
-      msFree(layerinfo->itemtypes);
-      layerinfo->itemtypes = NULL;
-    }
-
-    setMSSQL2008LayerInfo(layer, NULL);
-    msFree(layerinfo);
-  }
-
-  return MS_SUCCESS;
-}
-
-/* ******************************************************* */
-/* wkb is assumed to be 2d (force_2d) */
-/* and wkb is a GEOMETRYCOLLECTION (force_collection) */
-/* and wkb is in the endian of this computer (asbinary(...,'[XN]DR')) */
-/* each of the sub-geom inside the collection are point,linestring, or polygon */
-/*  */
-/* also, int is 32bits long */
-/* double is 64bits long */
-/* ******************************************************* */
-
-
-/* convert the wkb into points */
-/* points -> pass through */
-/* lines->   constituent points */
-/* polys->   treat ring like line and pull out the consituent points */
-
-static int  force_to_points(char *wkb, shapeObj *shape)
-{
-  /* we're going to make a 'line' for each entity (point, line or ring) in the geom collection */
-
-  int     offset = 0;
-  int     ngeoms;
-  int     t, u, v;
-  int     type, nrings, npoints;
-  lineObj line = {0, NULL};
-
-  shape->type = MS_SHAPE_NULL;  /* nothing in it */
-
-  memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t=0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
-
-    if(type == 1) {
-      /* Point */
-      shape->type = MS_SHAPE_POINT;
-      line.numpoints = 1;
-      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj));
-
-      memcpy(&line.point[0].x, &wkb[offset + 5], 8);
-      memcpy(&line.point[0].y, &wkb[offset + 5 + 8], 8);
-      offset += 5 + 16;
-      msAddLine(shape, &line);
-      msFree(line.point);
-    } else if(type == 2) {
-      /* Linestring */
-      shape->type = MS_SHAPE_POINT;
-
-      memcpy(&line.numpoints, &wkb[offset+5], 4); /* num points */
-      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj) * line.numpoints);
-      for(u = 0; u < line.numpoints; u++) {
-        memcpy( &line.point[u].x, &wkb[offset+9 + (16 * u)], 8);
-        memcpy( &line.point[u].y, &wkb[offset+9 + (16 * u)+8], 8);
-      }
-      offset += 9 + 16 * line.numpoints;  /* length of object */
-      msAddLine(shape, &line);
-      msFree(line.point);
-    } else if(type == 3) {
-      /* Polygon */
-      shape->type = MS_SHAPE_POINT;
-
-      memcpy(&nrings, &wkb[offset+5],4); /* num rings */
-      /* add a line for each polygon ring */
-      offset += 9; /* now points at 1st linear ring */
-      for(u = 0; u < nrings; u++) {
-        /* for each ring, make a line */
-        memcpy(&npoints, &wkb[offset], 4); /* num points */
-        line.numpoints = npoints;
-        line.point = (pointObj *) msSmallMalloc(sizeof(pointObj)* npoints);
-        /* point struct */
-        for(v = 0; v < npoints; v++) {
-          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
-          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
-        }
-        /* make offset point to next linear ring */
-        msAddLine(shape, &line);
-        msFree(line.point);
-        offset += 4 + 16 *npoints;
-      }
-    }
-
-  }
-
-  return MS_SUCCESS;
-}
-
-/* convert the wkb into lines */
-/* points-> remove */
-/* lines -> pass through */
-/* polys -> treat rings as lines */
-
-static int  force_to_lines(char *wkb, shapeObj *shape)
-{
-  int     offset = 0;
-  int     ngeoms;
-  int     t, u, v;
-  int     type, nrings, npoints;
-  lineObj line = {0, NULL};
-
-  shape->type = MS_SHAPE_NULL;  /* nothing in it */
-
-  memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t=0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
-
-    /* cannot do anything with a point */
-
-    if(type == 2) {
-      /* Linestring */
-      shape->type = MS_SHAPE_LINE;
-
-      memcpy(&line.numpoints, &wkb[offset + 5], 4);
-      line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * line.numpoints );
-      for(u=0; u < line.numpoints; u++) {
-        memcpy(&line.point[u].x, &wkb[offset + 9 + (16 * u)], 8);
-        memcpy(&line.point[u].y, &wkb[offset + 9 + (16 * u)+8], 8);
-      }
-      offset += 9 + 16 * line.numpoints;  /* length of object */
-      msAddLine(shape, &line);
-      msFree(line.point);
-    } else if(type == 3) {
-      /* polygon */
-      shape->type = MS_SHAPE_LINE;
-
-      memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
-      /* add a line for each polygon ring */
-      offset += 9; /* now points at 1st linear ring */
-      for(u = 0; u < nrings; u++) {
-        /* for each ring, make a line */
-        memcpy(&npoints, &wkb[offset], 4);
-        line.numpoints = npoints;
-        line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * npoints);
-        /* point struct */
-        for(v = 0; v < npoints; v++) {
-          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
-          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
-        }
-        /* make offset point to next linear ring */
-        msAddLine(shape, &line);
-        msFree(line.point);
-        offset += 4 + 16 * npoints;
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/* point   -> reject */
-/* line    -> reject */
-/* polygon -> lines of linear rings */
-static int  force_to_polygons(char  *wkb, shapeObj *shape)
-{
-  int     offset = 0;
-  int     ngeoms;
-  int     t, u, v;
-  int     type, nrings, npoints;
-  lineObj line = {0, NULL};
-
-  shape->type = MS_SHAPE_NULL;  /* nothing in it */
-
-  memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t = 0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
-
-    if(type == 3) {
-      /* polygon */
-      shape->type = MS_SHAPE_POLYGON;
-
-      memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
-      /* add a line for each polygon ring */
-      offset += 9; /* now points at 1st linear ring */
-      for(u=0; u < nrings; u++) {
-        /* for each ring, make a line */
-        memcpy(&npoints, &wkb[offset], 4); /* num points */
-        line.numpoints = npoints;
-        line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * npoints);
-        for(v=0; v < npoints; v++) {
-          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
-          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
-        }
-        /* make offset point to next linear ring */
-        msAddLine(shape, &line);
-        msFree(line.point);
-        offset += 4 + 16 * npoints;
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/* if there is any polygon in wkb, return force_polygon */
-/* if there is any line in wkb, return force_line */
-/* otherwise return force_point */
-
-static int  dont_force(char *wkb, shapeObj *shape)
-{
-  int     offset =0;
-  int     ngeoms;
-  int     type, t;
-  int     best_type;
-
-  best_type = MS_SHAPE_NULL;  /* nothing in it */
-
-  memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t = 0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
-
-    if(type == 3) {
-      best_type = MS_SHAPE_POLYGON;
-    } else if(type ==2 && best_type != MS_SHAPE_POLYGON) {
-      best_type = MS_SHAPE_LINE;
-    } else if(type == 1 && best_type == MS_SHAPE_NULL) {
-      best_type = MS_SHAPE_POINT;
-    }
-  }
-
-  if(best_type == MS_SHAPE_POINT) {
-    return force_to_points(wkb, shape);
-  }
-  if(best_type == MS_SHAPE_LINE) {
-    return force_to_lines(wkb, shape);
-  }
-  if(best_type == MS_SHAPE_POLYGON) {
-    return force_to_polygons(wkb, shape);
-  }
-
-  return MS_FAILURE; /* unknown type */
-}
-
-#if 0
-/* ******************************************************* */
-/* wkb assumed to be same endian as this machine.  */
-/* Should be in little endian (default if created by Microsoft platforms) */
-/* ******************************************************* */
-/* convert the wkb into points */
-/* points -> pass through */
-/* lines->   constituent points */
-/* polys->   treat ring like line and pull out the consituent points */
-static int  force_to_shapeType(char *wkb, shapeObj *shape, int msShapeType)
-{
-  int     offset = 0;
-  int     ngeoms = 1;
-  int     u, v;
-  int     type, nrings, npoints;
-  lineObj line = {0, NULL};
-
-  shape->type = MS_SHAPE_NULL;  /* nothing in it */
-
-  do {
-    ngeoms--;
-
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
-
-    if (type == 1) {
-      /* Point */
-      shape->type = msShapeType;
-      line.numpoints = 1;
-      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj));
-
-      memcpy(&line.point[0].x, &wkb[offset + 5], 8);
-      memcpy(&line.point[0].y, &wkb[offset + 5 + 8], 8);
-      offset += 5 + 16;
-
-      if (msShapeType == MS_SHAPE_POINT) {
-        msAddLine(shape, &line);
-      }
-
-      msFree(line.point);
-    } else if(type == 2) {
-      /* Linestring */
-      shape->type = msShapeType;
-
-      memcpy(&line.numpoints, &wkb[offset+5], 4); /* num points */
-      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj) * line.numpoints);
-      for(u = 0; u < line.numpoints; u++) {
-        memcpy( &line.point[u].x, &wkb[offset+9 + (16 * u)], 8);
-        memcpy( &line.point[u].y, &wkb[offset+9 + (16 * u)+8], 8);
-      }
-      offset += 9 + 16 * line.numpoints;  /* length of object */
-
-      if ((msShapeType == MS_SHAPE_POINT) || (msShapeType == MS_SHAPE_LINE)) {
-        msAddLine(shape, &line);
-      }
-
-      msFree(line.point);
-    } else if(type == 3) {
-      /* Polygon */
-      shape->type = msShapeType;
-
-      memcpy(&nrings, &wkb[offset+5],4); /* num rings */
-      /* add a line for each polygon ring */
-      offset += 9; /* now points at 1st linear ring */
-      for(u = 0; u < nrings; u++) {
-        /* for each ring, make a line */
-        memcpy(&npoints, &wkb[offset], 4); /* num points */
-        line.numpoints = npoints;
-        line.point = (pointObj *) msSmallMalloc(sizeof(pointObj)* npoints);
-        /* point struct */
-        for(v = 0; v < npoints; v++) {
-          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
-          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
-        }
-        /* make offset point to next linear ring */
-        msAddLine(shape, &line);
-        msFree(line.point);
-        offset += 4 + 16 *npoints;
-      }
-    } else if(type >= 4 && type <= 7) {
-      int cnt = 0;
-
-      offset += 5;
-
-      memcpy(&cnt, &wkb[offset], 4);
-      offset += 4;  /* were the first geometry is */
-
-      ngeoms += cnt;
-    }
-  } while (ngeoms > 0);
-
-  return MS_SUCCESS;
-}
-#endif
-
-///* if there is any polygon in wkb, return force_polygon */
-///* if there is any line in wkb, return force_line */
-///* otherwise return force_point */
-//static int  dont_force(char *wkb, shapeObj *shape)
-//{
-//    int     offset =0;
-//    int     ngeoms = 1;
-//    int     type;
-//    int     best_type;
-//    int     u;
-//    int     nrings, npoints;
-//
-//    best_type = MS_SHAPE_NULL;  /* nothing in it */
-//
-//    do
-//    {
-//        ngeoms--;
-//
-//        memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
-//
-//        if(type == 3) {
-//            best_type = MS_SHAPE_POLYGON;
-//        } else if(type ==2 && best_type != MS_SHAPE_POLYGON) {
-//            best_type = MS_SHAPE_LINE;
-//        } else if(type == 1 && best_type == MS_SHAPE_NULL) {
-//            best_type = MS_SHAPE_POINT;
-//        }
-//
-//        if (type == 1)
-//        {
-//            /* Point */
-//            offset += 5 + 16;
-//        }
-//        else if(type == 2)
-//        {
-//            int numPoints;
-//
-//            memcpy(&numPoints, &wkb[offset+5], 4); /* num points */
-//            /* Linestring */
-//            offset += 9 + 16 * numPoints;  /* length of object */
-//        }
-//        else if(type == 3)
-//        {
-//            /* Polygon */
-//            memcpy(&nrings, &wkb[offset+5],4); /* num rings */
-//            offset += 9; /* now points at 1st linear ring */
-//            for(u = 0; u < nrings; u++) {
-//                /* for each ring, make a line */
-//                memcpy(&npoints, &wkb[offset], 4); /* num points */
-//                offset += 4 + 16 *npoints;
-//            }
-//        }
-//        else if(type >= 4 && type <= 7)
-//        {
-//            int cnt = 0;
-//
-//            offset += 5;
-//
-//            memcpy(&cnt, &wkb[offset], 4);
-//            offset += 4;  /* were the first geometry is */
-//
-//            ngeoms += cnt;
-//        }
-//    }
-//    while (ngeoms > 0);
-//
-//    return force_to_shapeType(wkb, shape, best_type);
-//}
-//
-/* find the bounds of the shape */
-static void find_bounds(shapeObj *shape)
-{
-  int     t, u;
-  int     first_one = 1;
-
-  for(t = 0; t < shape->numlines; t++) {
-    for(u = 0; u < shape->line[t].numpoints; u++) {
-      if(first_one) {
-        shape->bounds.minx = shape->line[t].point[u].x;
-        shape->bounds.maxx = shape->line[t].point[u].x;
-
-        shape->bounds.miny = shape->line[t].point[u].y;
-        shape->bounds.maxy = shape->line[t].point[u].y;
-        first_one = 0;
-      } else {
-        if(shape->line[t].point[u].x < shape->bounds.minx) {
-          shape->bounds.minx = shape->line[t].point[u].x;
-        }
-        if(shape->line[t].point[u].x > shape->bounds.maxx) {
-          shape->bounds.maxx = shape->line[t].point[u].x;
-        }
-
-        if(shape->line[t].point[u].y < shape->bounds.miny) {
-          shape->bounds.miny = shape->line[t].point[u].y;
-        }
-        if(shape->line[t].point[u].y > shape->bounds.maxy) {
-          shape->bounds.maxy = shape->line[t].point[u].y;
-        }
-      }
-    }
-  }
-}
-
-/* Used by NextShape() to access a shape in the query set */
-int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape, long *record)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
-  SQLLEN needLen = 0;
-  SQLLEN retLen = 0;
-  char dummyBuffer[1];
-  char *wkbBuffer;
-  char *valueBuffer;
-  char oidBuffer[ 16 ];   /* assuming the OID will always be a long this should be enough */
-  long record_oid;
-  int t;
-
-  /* for coercing single types into geometry collections */
-  char *wkbTemp;
-  int geomType;
-
-  layerinfo = getMSSQL2008LayerInfo(layer);
-
-  if(!layerinfo) {
-    msSetError(MS_QUERYERR, "GetShape called with layerinfo = NULL", "msMSSQL2008LayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  if(!layerinfo->conn) {
-    msSetError(MS_QUERYERR, "NextShape called on MSSQL2008 layer with no connection to DB.", "msMSSQL2008LayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  shape->type = MS_SHAPE_NULL;
-
-  while(shape->type == MS_SHAPE_NULL) {
-    /* SQLRETURN rc = SQLFetchScroll(layerinfo->conn->hstmt, SQL_FETCH_ABSOLUTE, (SQLLEN) (*record) + 1); */
-
-    /* We only do forward fetches. the parameter 'record' is ignored, but is incremented */
-    SQLRETURN rc = SQLFetch(layerinfo->conn->hstmt);
-
-    /* Any error assume out of recordset bounds */
-    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-      handleSQLError(layer);
-      return MS_DONE;
-    }
-
-    /* retreive an item */
-
-    {
-      /* have to retrieve shape attributes */
-      shape->values = (char **) msSmallMalloc(sizeof(char *) * layer->numitems);
-      shape->numvalues = layer->numitems;
-
-      for(t=0; t < layer->numitems; t++) {
-        /* Startwith a 64 character long buffer. This may need to be increased after calling SQLGetData. */
-        SQLLEN emptyLen = 64;
-        valueBuffer = (char*) msSmallMalloc(emptyLen);
-        if ( valueBuffer == NULL ) {
-          msSetError( MS_QUERYERR, "Could not allocate value buffer.", "msMSSQL2008LayerGetShapeRandom()" );
-          return MS_FAILURE;
-        }
-
-#ifdef USE_ICONV
-        SQLSMALLINT targetType = SQL_WCHAR;
-#else
-        SQLSMALLINT targetType = SQL_CHAR;
-#endif
-        SQLLEN totalLen = 0;
-        char *bufferLocation = valueBuffer;
-        int r = 0;
-        while (r < 20) {
-          rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(t + 1), targetType, bufferLocation, emptyLen, &retLen);
-
-          if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO)
-            totalLen += retLen > emptyLen || retLen == SQL_NO_TOTAL ? emptyLen : retLen;
-
-          if (rc == SQL_SUCCESS_WITH_INFO && rc != SQL_NO_DATA) {
-            /* We must compensate for the last null termination that SQLGetData include */
-            /* If we get SQL_NO_TOTAL we do not know how big buffer we need so we increase it with 512. */
-#ifdef USE_ICONV
-            totalLen -= sizeof(wchar_t);
-            emptyLen = retLen != SQL_NO_TOTAL? retLen - emptyLen + 2 * sizeof(wchar_t): 512;
-#else
-            totalLen -= sizeof(char);
-            emptyLen = retLen != SQL_NO_TOTAL? retLen - emptyLen + 2 * sizeof(char): 512;
-#endif
-
-            valueBuffer = (char *)msSmallRealloc(valueBuffer, totalLen + emptyLen);
-            bufferLocation = valueBuffer + totalLen;
-          } else
-            break;
-          
-          r++;
-        }
-
-        if (rc == SQL_ERROR)
-          handleSQLError(layer);
-
-        if (totalLen > 0) {
-          /* Pop the value into the shape's value array */
-#ifdef USE_ICONV
-          shape->values[t] = msConvertWideStringToUTF8((wchar_t*)valueBuffer, "UCS-2LE");
-          msFree(valueBuffer);
-#else
-          shape->values[t] = valueBuffer;
-#endif
-        } else {
-          /* Copy empty sting for NULL values */
-          shape->values[t] = msStrdup("");
-          msFree(valueBuffer);
-        }
-      }
-
-      /* Get shape geometry */
-      {
-        /* Set up to request the size of the buffer needed */
-        rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY, dummyBuffer, 0, &needLen);
-        if (rc == SQL_ERROR)
-          handleSQLError(layer);
-
-        /* allow space for coercion to geometry collection if needed*/
-        wkbTemp = (char*)msSmallMalloc(needLen+9);
-
-        /* write data above space allocated for geometry collection coercion */
-        wkbBuffer = wkbTemp + 9;
-
-        if ( wkbBuffer == NULL ) {
-          msSetError( MS_QUERYERR, "Could not allocate value buffer.", "msMSSQL2008LayerGetShapeRandom()" );
-          return MS_FAILURE;
-        }
-
-        /* Grab the WKB */
-        rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY, wkbBuffer, needLen, &retLen);
-        if (rc == SQL_ERROR || rc == SQL_SUCCESS_WITH_INFO)
-          handleSQLError(layer);
-
-        if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE) {
-          layerinfo->gpi.pszData = (unsigned char*)wkbBuffer;
-          layerinfo->gpi.nLen = (int)retLen;
-
-          if (!ParseSqlGeometry(layerinfo, shape)) {
-            switch(layer->type) {
-              case MS_LAYER_POINT:
-                shape->type = MS_SHAPE_POINT;
-                break;
-
-              case MS_LAYER_LINE:
-                shape->type = MS_SHAPE_LINE;
-                break;
-
-              case MS_LAYER_POLYGON:
-                shape->type = MS_SHAPE_POLYGON;
-                break;
-
-              default:
-                break;
-            }
-          }
-        } else {
-          memcpy(&geomType, wkbBuffer + 1, 4);
-
-          /* is this a single type? */
-          if (geomType < 4) {
-            /* copy byte order marker (although we don't check it) */
-            wkbTemp[0] = wkbBuffer[0];
-            wkbBuffer = wkbTemp;
-
-            /* indicate type is geometry collection (although geomType + 3 would also work) */
-            wkbBuffer[1] = (char)7;
-            wkbBuffer[2] = (char)0;
-            wkbBuffer[3] = (char)0;
-            wkbBuffer[4] = (char)0;
-
-            /* indicate 1 shape */
-            wkbBuffer[5] = (char)1;
-            wkbBuffer[6] = (char)0;
-            wkbBuffer[7] = (char)0;
-            wkbBuffer[8] = (char)0;
-          }
-
-          switch(layer->type) {
-            case MS_LAYER_POINT:
-              /*result =*/ force_to_points(wkbBuffer, shape);
-              break;
-
-            case MS_LAYER_LINE:
-              /*result =*/ force_to_lines(wkbBuffer, shape);
-              break;
-
-            case MS_LAYER_POLYGON:
-              /*result =*/ force_to_polygons(wkbBuffer, shape);
-              break;
-
-            case MS_LAYER_QUERY:
-            case MS_LAYER_CHART:
-              /*result =*/ dont_force(wkbBuffer, shape);
-              break;
-
-            case MS_LAYER_RASTER:
-              msDebug( "Ignoring MS_LAYER_RASTER in mapMSSQL2008.c\n" );
-              break;
-
-            case MS_LAYER_CIRCLE:
-              msDebug( "Ignoring MS_LAYER_CIRCLE in mapMSSQL2008.c\n" );
-              break;
-
-            default:
-              msDebug( "Unsupported layer type in msMSSQL2008LayerNextShape()!" );
-              break;
-          }
-          find_bounds(shape);
-        }
-
-        //free(wkbBuffer);
-        msFree(wkbTemp);
-      }
-
-      /* Next get unique id for row - since the OID shouldn't be larger than a long we'll assume billions as a limit */
-      rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(layer->numitems + 2), SQL_C_BINARY, oidBuffer, sizeof(oidBuffer) - 1, &retLen);
-      if (rc == SQL_ERROR || rc == SQL_SUCCESS_WITH_INFO)
-        handleSQLError(layer);
-
-      if (retLen < (int)sizeof(oidBuffer))
-	  {
-		oidBuffer[retLen] = 0;
-		record_oid = strtol(oidBuffer, NULL, 10);
-		shape->index = record_oid;
-	  }
-	  else
-	  {
-		/* non integer fid column, use single pass */
-		shape->index = -1;
-	  }
-
-      shape->resultindex = (*record);
-
-      (*record)++;        /* move to next shape */
-
-      if(shape->type != MS_SHAPE_NULL) {
-        return MS_SUCCESS;
-      } else {
-        msDebug("msMSSQL2008LayerGetShapeRandom bad shape: %ld\n", *record);
-      }
-      /* if (layer->type == MS_LAYER_POINT) {return MS_DONE;} */
-    }
-  }
-
-  msFreeShape(shape);
-
-  return MS_FAILURE;
-}
-
-/* find the next shape with the appropriate shape type (convert it if necessary) */
-/* also, load in the attribute data */
-/* MS_DONE => no more data */
-int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  int     result;
-
-  msMSSQL2008LayerInfo  *layerinfo;
-
-  layerinfo = getMSSQL2008LayerInfo(layer);
-
-  if(!layerinfo) {
-    msSetError(MS_QUERYERR, "NextShape called with layerinfo = NULL", "msMSSQL2008LayerNextShape()");
-    return MS_FAILURE;
-  }
-
-  result = msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num));
-  /* getshaperandom will increment the row_num */
-  /* layerinfo->row_num   ++; */
-
-  return result;
-}
-
-/* Execute a query on the DB based on the query result. */
-int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  char    *query_str;
-  char    *columns_wanted = 0;
-
-  msMSSQL2008LayerInfo  *layerinfo;
-  int                 t;
-  char buffer[32000] = "";
-  long shapeindex = record->shapeindex;
-  long resultindex = record->resultindex;
-
-  if(layer->debug) {
-    msDebug("msMSSQL2008LayerGetShape called for shapeindex = %ld\n", shapeindex);
-  }
-
-  layerinfo = getMSSQL2008LayerInfo(layer);
-
-  if(!layerinfo) {
-    /* Layer not open */
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShape called on unopened layer (layerinfo = NULL)", "msMSSQL2008LayerGetShape()");
-
-    return MS_FAILURE;
-  }
-
-  if (resultindex >= 0 && layerinfo->sql) {
-    /* trying to provide the result from the current resultset (single-pass query) */
-    if( resultindex < layerinfo->row_num) {
-      /* re-issue the query */
-      if (!executeSQL(layerinfo->conn, layerinfo->sql)) {
-        msSetError(MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n", "msMSSQL2008LayerGetShape()", layerinfo->sql, layerinfo->conn->errorMessage);
-
-        return MS_FAILURE;
-      }
-      layerinfo->row_num = 0;
-    }
-    while( layerinfo->row_num < resultindex ) {
-      /* move forward until we reach the desired index */
-      if (msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num)) != MS_SUCCESS)
-        return MS_FAILURE;
-    }
-
-    return msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num));
-  }
-
-  /* non single-pass case, fetch the record from the database */
-
-  if(layer->numitems == 0) {
-    if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
-      snprintf(buffer, sizeof(buffer), "%s, convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
-    else
-      snprintf(buffer, sizeof(buffer), "%s.STAsBinary(), convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
-    columns_wanted = msStrdup(buffer);
-  } else {
-    for(t = 0; t < layer->numitems; t++) {
-      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer), "convert(varchar(max), %s),", layer->items[t]);
-    }
-
-    if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
-      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer), "%s, convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
-    else
-      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer), "%s.STAsBinary(), convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
-
-    columns_wanted = msStrdup(buffer);
-  }
-
-  /* index_name is ignored here since the hint should be for the spatial index, not the PK index */
-  snprintf(buffer, sizeof(buffer), "select %s from %s where %s = %ld", columns_wanted, layerinfo->geom_table, layerinfo->urid_name, shapeindex);
-
-  query_str = msStrdup(buffer);
-
-  if(layer->debug) {
-    msDebug("msMSSQL2008LayerGetShape: %s \n", query_str);
-  }
-
-  msFree(columns_wanted);
-
-  if (!executeSQL(layerinfo->conn, query_str)) {
-    msSetError(MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n", "msMSSQL2008LayerGetShape()",
-               query_str, layerinfo->conn->errorMessage);
-
-    msFree(query_str);
-
-    return MS_FAILURE;
-  }
-
-  /* we don't preserve the query string in this case (cannot be re-used) */
-  msFree(query_str);
-  layerinfo->row_num = 0;
-
-  return msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num));
-}
-
-/*
-** Returns the number of shapes that match the potential filter and extent.
- * rectProjection is the projection in which rect is expressed, or can be NULL if
- * rect should be considered in the layer projection.
- * This should be equivalent to calling msLayerWhichShapes() and counting the
- * number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
- * limitation if layer->maxfeatures>=0, and honouring layer->startindex if
- * layer->startindex >= 1 and paging is enabled.
- * Returns -1 in case of failure.
- */
-int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
-    msMSSQL2008LayerInfo *layerinfo;
-    char *query = 0;
-    char result_data[256];
-    char box3d[40 + 10 * 22 + 11];
-    SQLLEN retLen;
-    SQLRETURN rc;
-    int hasFilter = MS_FALSE;
-    const rectObj rectInvalid = MS_INIT_INVALID_RECT;
-    const int bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
-
-    rectObj searchrectInLayerProj = rect;
-
-    if (layer->debug) {
-        msDebug("msMSSQL2008LayerGetShapeCount called.\n");
-    }
-
-    layerinfo = getMSSQL2008LayerInfo(layer);
-
-    if (!layerinfo) {
-        /* Layer not open */
-        msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShapeCount called on unopened layer (layerinfo = NULL)", "msMSSQL2008LayerGetShapeCount()");
-
-        return MS_FAILURE;
-    }
-
-    // Special processing if the specified projection for the rect is different from the layer projection
-    // We want to issue a WHERE that includes
-    // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
-    if (rectProjection != NULL && layer->project &&
-        msProjectionsDiffer(&(layer->projection), rectProjection))
-    {
-        // If we cannot guess the EPSG code of the rectProjection, fallback on slow implementation
-        if (rectProjection->numargs < 1 ||
-            strncasecmp(rectProjection->args[0], "init=epsg:", (int)strlen("init=epsg:")) != 0)
-        {
-            if (layer->debug) {
-                msDebug("msMSSQL2008LayerGetShapeCount(): cannot find EPSG code of rectProjection. Falling back on client-side feature count.\n");
-            }
-            return LayerDefaultGetShapeCount(layer, rect, rectProjection);
-        }
-
-        // Reproject the passed rect into the layer projection and get
-        // the SRID from the rectProjection
-        msProjectRect(rectProjection, &(layer->projection), &searchrectInLayerProj); /* project the searchrect to source coords */
-    }
-
-    if (searchrectInLayerProj.minx == searchrectInLayerProj.maxx || 
-        searchrectInLayerProj.miny == searchrectInLayerProj.maxy) {
-        /* create point shape for rectangles with zero area */
-        snprintf(box3d, sizeof(box3d), "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
-            layerinfo->geom_column_type, searchrectInLayerProj.minx, searchrectInLayerProj.miny, layerinfo->user_srid);
-    }
-    else {
-         snprintf(box3d, sizeof(box3d), "%s::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
-            layerinfo->geom_column_type,
-            searchrectInLayerProj.minx, searchrectInLayerProj.miny,
-            searchrectInLayerProj.maxx, searchrectInLayerProj.miny,
-            searchrectInLayerProj.maxx, searchrectInLayerProj.maxy,
-            searchrectInLayerProj.minx, searchrectInLayerProj.maxy,
-            searchrectInLayerProj.minx, searchrectInLayerProj.miny,
-            layerinfo->user_srid
-        );
-    }
-
-    msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
-
-    /* set up statement */
-    query = msStringConcatenate(query, "SELECT count(*) FROM ");
-    query = msStringConcatenate(query, layerinfo->geom_table);
-
-    /* adding attribute filter */
-    hasFilter = addFilter(layer, &query);
-
-    if( bIsValidRect ) {
-        /* adding spatial filter */
-        if (hasFilter == MS_FALSE)
-            query = msStringConcatenate(query, " WHERE ");
-        else
-            query = msStringConcatenate(query, " AND ");
-
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STIntersects(");
-        query = msStringConcatenate(query, box3d);
-        query = msStringConcatenate(query, ") = 1 ");
-    }
-
-    if (layer->debug) {
-      msDebug("query:%s\n", query);
-    }
-
-    if (!executeSQL(layerinfo->conn, query)) {
-        msFree(query);
-        return -1;
-    }
-
-    msFree(query);
-
-    rc = SQLFetch(layerinfo->conn->hstmt);
-
-    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-        if (layer->debug) {
-            msDebug("msMSSQL2008LayerGetShapeCount: No results found.\n");
-        }
-
-        return -1;
-    }
-
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-
-    if (rc == SQL_ERROR) {
-        msSetError(MS_QUERYERR, "Failed to get feature count", "msMSSQL2008LayerGetShapeCount()");
-        return -1;
-    }
-
-    result_data[retLen] = 0;
-
-    return atoi(result_data);
-}
-
-/* Query the DB for info about the requested table */
-int msMSSQL2008LayerGetItems(layerObj *layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
-  char                *sql = NULL;
-  size_t              sqlSize;
-  char                found_geom = 0;
-  int                 t, item_num;
-  SQLSMALLINT cols = 0;
-  const char *value;
-  /*
-  * Pass the field definitions through to the layer metadata in the
-  * "gml_[item]_{type,width,precision}" set of metadata items for
-  * defining fields.
-  */
-  char                pass_field_def = 0;
-
-  if(layer->debug) {
-    msDebug("in msMSSQL2008LayerGetItems  (find column names)\n");
-  }
-
-  layerinfo = getMSSQL2008LayerInfo(layer);
-
-  if(!layerinfo) {
-    /* layer not opened yet */
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called on unopened layer", "msMSSQL2008LayerGetItems()");
-
-    return MS_FAILURE;
-  }
-
-  if(!layerinfo->conn) {
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called on MSSQL2008 layer with no connection to DB.", "msMSSQL2008LayerGetItems()");
-
-    return MS_FAILURE;
-  }
-
-  sqlSize = strlen(layerinfo->geom_table) + 30;
-  sql = msSmallMalloc(sizeof(char *) * sqlSize);
-
-  snprintf(sql, sqlSize, "SELECT top 0 * FROM %s", layerinfo->geom_table);
-
-  if (!executeSQL(layerinfo->conn, sql)) {
-    msFree(sql);
-    return MS_FAILURE;
-  }
-
-  msFree(sql);
-
-  SQLNumResultCols (layerinfo->conn->hstmt, &cols);
-
-  layer->numitems = cols - 1; /* dont include the geometry column */
-
-  layer->items = msSmallMalloc(sizeof(char *) * (layer->numitems + 1)); /* +1 in case there is a problem finding goeometry column */
-  layerinfo->itemtypes = msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
-  /* it will return an error if there is no geometry column found, */
-  /* so this isnt a problem */
-
-  found_geom = 0; /* havent found the geom field */
-  item_num = 0;
-
-  /* consider populating the field definitions in metadata */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    pass_field_def = 1;
-
-  for(t = 0; t < cols; t++) {
-    char colBuff[256];
-    SQLSMALLINT itemType = 0;
-
-    columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer, pass_field_def, &itemType);
-
-    if(strcmp(colBuff, layerinfo->geom_column) != 0) {
-      /* this isnt the geometry column */
-      layer->items[item_num] = (char *) msSmallMalloc(strlen(colBuff) + 1);
-      strcpy(layer->items[item_num], colBuff);
-      layerinfo->itemtypes[item_num] = itemType;
-      item_num++;
-    } else {
-      found_geom = 1;
-    }
-  }
-
-  if(!found_geom) {
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems: tried to find the geometry column in the results from the database, but couldnt find it.  Is it miss-capitialized? '%s'", "msMSSQL2008LayerGetItems()", layerinfo->geom_column);
-    return MS_FAILURE;
-  }
-
-  return msMSSQL2008LayerInitItemInfo(layer);
-}
-
-/* Get primary key column of table */
-int msMSSQL2008LayerRetrievePK(layerObj *layer, char **urid_name, char* table_name, int debug)
-{
-
-  char        sql[1024];
-  msMSSQL2008LayerInfo *layerinfo = 0;
-  SQLRETURN rc;
-
-  snprintf(sql, sizeof(sql),
-           "SELECT     convert(varchar(50), sys.columns.name) AS ColumnName, sys.indexes.name "
-           "FROM         sys.columns INNER JOIN "
-           "                     sys.indexes INNER JOIN "
-           "                     sys.tables ON sys.indexes.object_id = sys.tables.object_id INNER JOIN "
-           "                     sys.index_columns ON sys.indexes.object_id = sys.index_columns.object_id AND sys.indexes.index_id = sys.index_columns.index_id ON "
-           "                     sys.columns.object_id = sys.index_columns.object_id AND sys.columns.column_id = sys.index_columns.column_id "
-           "WHERE     (sys.indexes.is_primary_key = 1) AND (sys.tables.name = N'%s') ",
-           table_name);
-
-  if (debug) {
-    msDebug("msMSSQL2008LayerRetrievePK: query = %s\n", sql);
-  }
-
-  layerinfo = (msMSSQL2008LayerInfo *) layer->layerinfo;
-
-  if(layerinfo->conn == NULL) {
-
-    msSetError(MS_QUERYERR, "Layer does not have a MSSQL2008 connection.", "msMSSQL2008LayerRetrievePK()");
-
-    return(MS_FAILURE);
-  }
-
-  /* error somewhere above here in this method */
-
-  if(!executeSQL(layerinfo->conn, sql)) {
-    char *tmp1;
-    char *tmp2 = NULL;
-
-    tmp1 = "Error executing MSSQL2008 statement (msMSSQL2008LayerRetrievePK():";
-    tmp2 = (char *)msSmallMalloc(sizeof(char)*(strlen(tmp1) + strlen(sql) + 1));
-    strcpy(tmp2, tmp1);
-    strcat(tmp2, sql);
-    msSetError(MS_QUERYERR, "%s", "msMSSQL2008LayerRetrievePK()", tmp2);
-    msFree(tmp2);
-    return(MS_FAILURE);
-  }
-
-  rc = SQLFetch(layerinfo->conn->hstmt);
-
-  if(rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-    if(debug) {
-      msDebug("msMSSQL2008LayerRetrievePK: No results found.\n");
-    }
-
-    return MS_FAILURE;
-  }
-
-  {
-    char buff[100];
-    SQLLEN retLen;
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_BINARY, buff, sizeof(buff), &retLen);
-
-    rc = SQLFetch(layerinfo->conn->hstmt);
-
-    if(rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
-      if(debug) {
-        msDebug("msMSSQL2008LayerRetrievePK: Multiple primary key columns are not supported in MapServer\n");
-      }
-
-      return MS_FAILURE;
-    }
-
-    buff[retLen] = 0;
-
-    *urid_name = msStrdup(buff);
-  }
-
-  return MS_SUCCESS;
-}
-
-/* Function to parse the Mapserver DATA parameter for geometry
- * column name, table name and name of a column to serve as a
- * unique record id
- */
-static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name, char **geom_column_type, char **table_name, char **urid_name, char **user_srid, char **index_name, char **sort_spec, int debug)
-{
-  char    *pos_opt, *pos_scn, *tmp, *pos_srid, *pos_urid, *pos_geomtype, *pos_geomtype2, *pos_indexHint, *data, *pos_order;
-  size_t     slength;
-
-  data = msStrdup(layer->data);
-  /* replace tabs with spaces */
-  msReplaceChar(data, '\t', ' ');
-
-  /* given a string of the from 'geom from ctivalues' or 'geom from () as foo'
-   * return geom_column_name as 'geom'
-   * and table name as 'ctivalues' or 'geom from () as foo'
-   */
-
-  /* First look for the optional ' using unique ID' string */
-  pos_urid = strstrIgnoreCase(data, " using unique ");
-
-  if(pos_urid) {
-    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id using srid=33' */
-    tmp = strstr(pos_urid + 14, " ");
-    if(!tmp) {
-      tmp = pos_urid + strlen(pos_urid);
-    }
-    *urid_name = (char *) msSmallMalloc((tmp - (pos_urid + 14)) + 1);
-    strlcpy(*urid_name, pos_urid + 14, (tmp - (pos_urid + 14)) + 1);
-  }
-
-  /* Find the srid */
-  pos_srid = strstrIgnoreCase(data, " using SRID=");
-  if(!pos_srid) {
-    *user_srid = (char *) msSmallMalloc(2);
-    (*user_srid)[0] = '0';
-    (*user_srid)[1] = 0;
-  } else {
-    slength = strspn(pos_srid + 12, "-0123456789");
-    if(!slength) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable: You specified 'using SRID=#' but didn't have any numbers!<br><br>\n\nMore Help:<br><br>\n\n", data);
-
-      msFree(data);
-      return MS_FAILURE;
-    } else {
-      *user_srid = (char *) msSmallMalloc(slength + 1);
-      strlcpy(*user_srid, pos_srid + 12, slength+1);
-    }
-  }
-
-  pos_indexHint = strstrIgnoreCase(data, " using index ");
-  if(pos_indexHint) {
-    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id using srid=33' */
-    tmp = strstr(pos_indexHint + 13, " ");
-    if(!tmp) {
-      tmp = pos_indexHint + strlen(pos_indexHint);
-    }
-    *index_name = (char *) msSmallMalloc((tmp - (pos_indexHint + 13)) + 1);
-    strlcpy(*index_name, pos_indexHint + 13, tmp - (pos_indexHint + 13)+1);
-  }
-
-  /* this is a little hack so the rest of the code works.  If the ' using SRID=' comes before */
-  /* the ' using unique ', then make sure pos_opt points to where the ' using SRID' starts! */
-  pos_opt = pos_urid;
-  if ( !pos_opt || ( pos_srid && pos_srid < pos_opt ) ) pos_opt = pos_srid;
-  if ( !pos_opt || ( pos_indexHint && pos_indexHint < pos_opt ) ) pos_opt = pos_indexHint;
-  if ( !pos_opt ) pos_opt = data + strlen(data);
-
-  /* Scan for the table or sub-select clause */
-  pos_scn = strstrIgnoreCase(data, " from ");
-  if(!pos_scn) {
-    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable.  Must contain 'geometry_column from table_name' or 'geom from (subselect) as foo' (couldn't find ' from ').  More help: <br><br>\n\n", data);
-
-    msFree(data);
-    return MS_FAILURE;
-  }
-
-  /* Scanning the geometry column type */
-  pos_geomtype = data;
-  while (pos_geomtype < pos_scn && *pos_geomtype != '(' && *pos_geomtype != 0)
-    ++pos_geomtype;
-
-  if(*pos_geomtype == '(') {
-    pos_geomtype2 = pos_geomtype;
-    while (pos_geomtype2 < pos_scn && *pos_geomtype2 != ')' && *pos_geomtype2 != 0)
-      ++pos_geomtype2;
-    if (*pos_geomtype2 != ')' || pos_geomtype2 == pos_geomtype) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable.  Invalid syntax near geometry column type.", data);
-      msFree(data);
-      return MS_FAILURE;
-    }
-
-    *geom_column_name = (char *) msSmallMalloc((pos_geomtype - data) + 1);
-    strlcpy(*geom_column_name, data, pos_geomtype - data + 1);
-
-    *geom_column_type = (char *) msSmallMalloc(pos_geomtype2 - pos_geomtype);
-    strlcpy(*geom_column_type, pos_geomtype + 1, pos_geomtype2 - pos_geomtype);
-  } else {
-    /* Copy the geometry column name */
-    *geom_column_name = (char *) msSmallMalloc((pos_scn - data) + 1);
-    strlcpy(*geom_column_name, data, pos_scn - data + 1);
-    *geom_column_type = msStrdup("geometry");
-  }
-
-  /* Copy out the table name or sub-select clause */
-  *table_name = (char *) msSmallMalloc((pos_opt - (pos_scn + 6)) + 1);
-  strlcpy(*table_name, pos_scn + 6, pos_opt - (pos_scn + 6) + 1);
-
-  if(strlen(*table_name) < 1 || strlen(*geom_column_name) < 1) {
-    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable.  Must contain 'geometry_column from table_name' or 'geom from (subselect) as foo' (couldnt find a geometry_column or table/subselect).  More help: <br><br>\n\n", data);
-
-    msFree(data);
-    return MS_FAILURE;
-  }
-
-  if( !pos_urid ) {
-    if( msMSSQL2008LayerRetrievePK(layer, urid_name, *table_name, debug) != MS_SUCCESS ) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "No primary key defined for table, or primary key contains more that one column\n\n",
-                 *table_name);
-
-      msFree(data);
-      return MS_FAILURE;
-    }
-  }
-
-  /* Find the order by */
-  pos_order = strstrIgnoreCase(pos_opt, " order by ");
-  
-  if (pos_order) {
-    *sort_spec = msStrdup(pos_order);
-  }
-
-  if(debug) {
-    msDebug("msMSSQL2008LayerParseData: unique column = %s, srid='%s', geom_column_name = %s, table_name=%s\n", *urid_name, *user_srid, *geom_column_name, *table_name);
-  }
-
-  msFree(data);
-  return MS_SUCCESS;
-}
-
-char *msMSSQL2008LayerEscapePropertyName(layerObj *layer, const char* pszString)
-{
-  (void)layer;
-  char* pszEscapedStr=NULL;
-  int j = 0;
-
-  if (pszString && strlen(pszString) > 0) {
-    size_t nLength = strlen(pszString);
-
-    pszEscapedStr = (char*) msSmallMalloc( 1 + nLength + 1 + 1);
-    pszEscapedStr[j++] = '[';
-
-    for (size_t i=0; i<nLength; i++)
-      pszEscapedStr[j++] = pszString[i];
-
-    pszEscapedStr[j++] = ']';
-    pszEscapedStr[j++] = 0;
-  }
-  return pszEscapedStr;
-}
-
-char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString)
-{
-  (void)layer;
-  char *pszEscapedStr=NULL;
-  if (pszString) {
-    int nSrcLen;
-    char c;
-    int i=0, j=0;
-    nSrcLen = (int)strlen(pszString);
-    pszEscapedStr = (char*) msSmallMalloc( 2 * nSrcLen + 1);
-    for(i = 0, j = 0; i < nSrcLen; i++) {
-      c = pszString[i];
-      if (c == '\'') {
-        pszEscapedStr[j++] = '\'';
-        pszEscapedStr[j++] = '\'';
-      } else
-        pszEscapedStr[j++] = c;
-    }
-    pszEscapedStr[j] = 0;
-  }
-  return pszEscapedStr;
-}
-
-int msMSSQL2008GetPaging(layerObj *layer)
-{
-    msMSSQL2008LayerInfo *layerinfo = NULL;
-
-    if (!msMSSQL2008LayerIsOpen(layer))
-        return MS_TRUE;
-
-    assert(layer->layerinfo != NULL);
-    layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
-
-    return layerinfo->paging;
-}
-
-void msMSSQL2008EnablePaging(layerObj *layer, int value)
-{
-    msMSSQL2008LayerInfo *layerinfo = NULL;
-
-    if (!msMSSQL2008LayerIsOpen(layer))
-    {
-      if(msMSSQL2008LayerOpen(layer) != MS_SUCCESS)
-      {
-        return;
-      }
-    }
-
-    assert(layer->layerinfo != NULL);
-    layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
-
-    layerinfo->paging = value;
-}
-
-int process_node(layerObj* layer, expressionObj *filter)
-{
-  char *snippet = NULL;
-  char *strtmpl = NULL;
-  char *stresc = NULL;
-  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *) layer->layerinfo;
-
-  if (!layerinfo->current_node)
-  {
-    msSetError(MS_MISCERR, "Unecpected end of expression", "msMSSQL2008LayerTranslateFilter()");
-    return 0;
-  }
-
-  switch(layerinfo->current_node->token) {
-    case '(':
-       filter->native_string = msStringConcatenate(filter->native_string, "(");
-       /* process subexpression */
-       layerinfo->current_node = layerinfo->current_node->next;
-       while (layerinfo->current_node != NULL) { 
-         if (!process_node(layer, filter))
-           return 0;
-         if (!layerinfo->current_node)
-           break;
-         if (layerinfo->current_node->token == ')')
-           break;
-         layerinfo->current_node = layerinfo->current_node->next;
-       }
-       break;
-    case ')':
-       filter->native_string = msStringConcatenate(filter->native_string, ")");
-       break;
-    /* argument separator */
-    case ',':
-       break;
-    /* literal tokens */
-    case MS_TOKEN_LITERAL_BOOLEAN:
-      if(layerinfo->current_node->tokenval.dblval == MS_TRUE)
-        filter->native_string = msStringConcatenate(filter->native_string, "1");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, "0");
-      break;
-    case MS_TOKEN_LITERAL_NUMBER:
-    {
-      char buffer[32];
-      snprintf(buffer, sizeof(buffer), "%.18g", layerinfo->current_node->tokenval.dblval);
-      filter->native_string = msStringConcatenate(filter->native_string, buffer);
-      break;
-    }
-    case MS_TOKEN_LITERAL_STRING:
-      strtmpl = "'%s'";
-      stresc = msMSSQL2008LayerEscapeSQLParam(layer, layerinfo->current_node->tokenval.strval);
-      snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(stresc));
-      sprintf(snippet, strtmpl, stresc);
-      filter->native_string = msStringConcatenate(filter->native_string, snippet);
-      msFree(snippet);
-      msFree(stresc);
-      break;
-    case MS_TOKEN_LITERAL_TIME:
-      {
-        int resolution = msTimeGetResolution(layerinfo->current_node->tokensrc);
-        snippet = (char *) msSmallMalloc(128);
-        switch(resolution) {
-          case TIME_RESOLUTION_YEAR:
-            sprintf(snippet, "'%d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900));
-            break;
-          case TIME_RESOLUTION_MONTH:
-            sprintf(snippet, "'%d-%02d-01'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                    (layerinfo->current_node->tokenval.tmval.tm_mon+1));
-            break;
-          case TIME_RESOLUTION_DAY:
-            sprintf(snippet, "'%d-%02d-%02d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                    (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                    layerinfo->current_node->tokenval.tmval.tm_mday);
-            break;
-          case TIME_RESOLUTION_HOUR:
-            sprintf(snippet, "'%d-%02d-%02d %02d:00'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                layerinfo->current_node->tokenval.tmval.tm_mday, 
-                layerinfo->current_node->tokenval.tmval.tm_hour);
-            break;
-          case TIME_RESOLUTION_MINUTE:
-            sprintf(snippet, "%d-%02d-%02d %02d:%02d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                layerinfo->current_node->tokenval.tmval.tm_mday, 
-                layerinfo->current_node->tokenval.tmval.tm_hour, 
-                layerinfo->current_node->tokenval.tmval.tm_min);
-            break;
-          case TIME_RESOLUTION_SECOND:
-            sprintf(snippet, "'%d-%02d-%02d %02d:%02d:%02d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900),
-                (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                layerinfo->current_node->tokenval.tmval.tm_mday, 
-                layerinfo->current_node->tokenval.tmval.tm_hour, 
-                layerinfo->current_node->tokenval.tmval.tm_min, 
-                layerinfo->current_node->tokenval.tmval.tm_sec);
-            break;
-        }    
-        filter->native_string = msStringConcatenate(filter->native_string, snippet);
-        msFree(snippet);
-      }
-      break;
-    case MS_TOKEN_LITERAL_SHAPE:
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
-        filter->native_string = msStringConcatenate(filter->native_string, "geography::STGeomFromText('");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, "geometry::STGeomFromText('");
-      filter->native_string = msStringConcatenate(filter->native_string, msShapeToWKT(layerinfo->current_node->tokenval.shpval));
-      filter->native_string = msStringConcatenate(filter->native_string, "'");
-      if(layerinfo->user_srid && strcmp(layerinfo->user_srid, "") != 0) {
-        filter->native_string = msStringConcatenate(filter->native_string, ", ");
-        filter->native_string = msStringConcatenate(filter->native_string, layerinfo->user_srid);
-      }
-      filter->native_string = msStringConcatenate(filter->native_string, ")");
-      break;
-    case MS_TOKEN_BINDING_TIME:
-    case MS_TOKEN_BINDING_DOUBLE:
-    case MS_TOKEN_BINDING_INTEGER:
-    case MS_TOKEN_BINDING_STRING:
-      if(layerinfo->current_node->next->token == MS_TOKEN_COMPARISON_IRE)
-        strtmpl = "LOWER(%s)";
-      else
-        strtmpl = "%s";
-
-      stresc = msMSSQL2008LayerEscapePropertyName(layer, layerinfo->current_node->tokenval.bindval.item);
-      snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(stresc));
-      sprintf(snippet, strtmpl, stresc);
-      filter->native_string = msStringConcatenate(filter->native_string, snippet);
-      msFree(snippet);
-      msFree(stresc);
-      break;
-    case MS_TOKEN_BINDING_SHAPE:
-      filter->native_string = msStringConcatenate(filter->native_string, layerinfo->geom_column);
-      break;
-    case MS_TOKEN_BINDING_MAP_CELLSIZE:
-    {
-      char buffer[32];
-      snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
-      filter->native_string = msStringConcatenate(filter->native_string, buffer);
-      break;
-    }
-
-    /* comparisons */
-    case MS_TOKEN_COMPARISON_IN:
-      filter->native_string = msStringConcatenate(filter->native_string, " IN ");
-      break;
-    case MS_TOKEN_COMPARISON_RE: 
-    case MS_TOKEN_COMPARISON_IRE: 
-    case MS_TOKEN_COMPARISON_LIKE: {
-      /* process regexp */
-      size_t i = 0, j = 0;
-      char c;
-      char c_next;
-      int bCaseInsensitive = (layerinfo->current_node->token == MS_TOKEN_COMPARISON_IRE);
-      int nEscapeLen = 0;
-      if (bCaseInsensitive)
-        filter->native_string = msStringConcatenate(filter->native_string, " LIKE LOWER(");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, " LIKE ");
-
-      layerinfo->current_node = layerinfo->current_node->next;
-      if (layerinfo->current_node->token != MS_TOKEN_LITERAL_STRING) return 0;
-
-      strtmpl = msStrdup(layerinfo->current_node->tokenval.strval);
-      if (strtmpl[0] == '/') {
-        stresc = strtmpl + 1;
-        strtmpl[strlen(strtmpl) - 1] = '\0';
-      }
-      else if (strtmpl[0] == '^')
-        stresc = strtmpl + 1;
-      else
-        stresc = strtmpl;
-
-      while (*stresc) {
-        c = stresc[i];
-        if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
-           nEscapeLen++;
-        }
-        stresc++;
-      }
-      snippet = (char *)msSmallMalloc(strlen(strtmpl) + nEscapeLen + 3);
-      snippet[j++] = '\'';
-      while (i < strlen(strtmpl)) {
-        c = strtmpl[i];
-        c_next = strtmpl[i+1];
-
-        if (i == 0 && c == '^') {
-          i++;
-          continue;
-        }
-        if( c == '$' && c_next == 0 && strtmpl[0] == '^' )
-          break;
-
-        if (c == '\\') {
-          i++;
-          c = c_next;
-        }
-         
-        if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
-           snippet[j++] = '\\';
-        }
-        
-        if (c == '.' && c_next == '*') {
-          i++;
-          c = '%';
-        }
-        else if (c == '.')
-          c = '_';
-
-        
-        snippet[j++] = c;
-        i++;          
-      }
-      snippet[j++] = '\'';
-      snippet[j] = '\0';
-
-      filter->native_string = msStringConcatenate(filter->native_string, snippet);
-      msFree(strtmpl);
-      msFree(snippet);
-
-      if (bCaseInsensitive)
-        filter->native_string = msStringConcatenate(filter->native_string, ")");
-
-      if (nEscapeLen > 0)
-        filter->native_string = msStringConcatenate(filter->native_string, " ESCAPE '\\'");
-    }
-    break;
-    case MS_TOKEN_COMPARISON_EQ:
-      filter->native_string = msStringConcatenate(filter->native_string, " = ");
-      break;
-    case MS_TOKEN_COMPARISON_NE: 
-      filter->native_string = msStringConcatenate(filter->native_string, " != ");
-      break;
-    case MS_TOKEN_COMPARISON_GT: 
-      filter->native_string = msStringConcatenate(filter->native_string, " > ");
-      break;
-    case MS_TOKEN_COMPARISON_GE:
-      filter->native_string = msStringConcatenate(filter->native_string, " >= ");
-      break;
-    case MS_TOKEN_COMPARISON_LT:
-      filter->native_string = msStringConcatenate(filter->native_string, " < ");
-      break;
-    case MS_TOKEN_COMPARISON_LE:
-      filter->native_string = msStringConcatenate(filter->native_string, " <= ");
-      break;
-
-    /* logical ops */
-    case MS_TOKEN_LOGICAL_AND:
-      filter->native_string = msStringConcatenate(filter->native_string, " AND ");
-      break;
-    case MS_TOKEN_LOGICAL_OR:
-      filter->native_string = msStringConcatenate(filter->native_string, " OR ");
-      break;
-    case MS_TOKEN_LOGICAL_NOT:
-      filter->native_string = msStringConcatenate(filter->native_string, " NOT ");
-      break;
-
-    /* spatial comparison tokens */
-    case MS_TOKEN_COMPARISON_INTERSECTS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STIntersects(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_DISJOINT:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STDisjoint(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_TOUCHES:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STTouches(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_OVERLAPS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STOverlaps(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_CROSSES:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STCrosses(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_WITHIN:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STWithin(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_CONTAINS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STContains(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_EQUALS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STEquals(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
-
-    case MS_TOKEN_COMPARISON_BEYOND:
-      msSetError(MS_MISCERR, "Beyond operator is unsupported.", "msMSSQL2008LayerTranslateFilter()");
-      return 0;
-
-    case MS_TOKEN_COMPARISON_DWITHIN:
-      msSetError(MS_MISCERR, "DWithin operator is unsupported.", "msMSSQL2008LayerTranslateFilter()");
-      return 0;
-
-    /* spatial functions */
-    case MS_TOKEN_FUNCTION_AREA:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STArea()");
-      break;
-
-    case MS_TOKEN_FUNCTION_BUFFER:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STBuffer(");
-      if (!process_node(layer, filter))
-        return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ")");
-      break;
-
-    case MS_TOKEN_FUNCTION_DIFFERENCE:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STDifference(");
-      if (!process_node(layer, filter))
-        return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ")");
-      break;
-
-    case MS_TOKEN_FUNCTION_FROMTEXT:
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
-        filter->native_string = msStringConcatenate(filter->native_string, "geography::STGeomFromText");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, "geometry::STGeomFromText");          
-      break;
-
-    case MS_TOKEN_FUNCTION_LENGTH:
-      filter->native_string = msStringConcatenate(filter->native_string, "len");
-      break;
-
-    case MS_TOKEN_FUNCTION_ROUND:
-      filter->native_string = msStringConcatenate(filter->native_string, "round");
-      break;
-    
-    case MS_TOKEN_FUNCTION_TOSTRING:
-      break;
-
-    case MS_TOKEN_FUNCTION_COMMIFY:
-      break;
-
-    case MS_TOKEN_FUNCTION_SIMPLIFY:
-      filter->native_string = msStringConcatenate(filter->native_string, ".Reduce"); 
-      break;
-    case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-      break;
-    case MS_TOKEN_FUNCTION_GENERALIZE:
-      filter->native_string = msStringConcatenate(filter->native_string, ".Reduce"); 
-      break;
-
-    default:
-      msSetError(MS_MISCERR, "Translation to native SQL failed.","msMSSQL2008LayerTranslateFilter()");
-      if (layer->debug) {
-        msDebug("Token not caught, exiting: Token is %i\n", layerinfo->current_node->token);
-      }
-      return 0;
-  }
-  return 1;
-}
-
-/* Translate filter expression to native msssql filter */
-int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-  char *snippet = NULL;
-  char *strtmpl = NULL;
-  char *stresc = NULL;
-  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *) layer->layerinfo;
-
-  if(!filter->string) return MS_SUCCESS;
-
-  msFree(filter->native_string);
-  filter->native_string = NULL;
-
-  if(filter->type == MS_STRING && filter->string && filteritem) { /* item/value pair */
-    stresc = msMSSQL2008LayerEscapePropertyName(layer, filteritem);
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      filter->native_string = msStringConcatenate(filter->native_string, "upper(");
-      filter->native_string = msStringConcatenate(filter->native_string, stresc);
-      filter->native_string = msStringConcatenate(filter->native_string, ") = upper(");
-    } else {
-      filter->native_string = msStringConcatenate(filter->native_string, stresc);
-      filter->native_string = msStringConcatenate(filter->native_string, " = ");
-    }
-    msFree(stresc);
-
-    strtmpl = "'%s'";  /* don't have a type for the righthand literal so assume it's a string and we quote */
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
-    sprintf(snippet, strtmpl, filter->string);  // TODO: escape filter->string
-    filter->native_string = msStringConcatenate(filter->native_string, snippet);
-    free(snippet);
-
-    if(filter->flags & MS_EXP_INSENSITIVE) 
-        filter->native_string = msStringConcatenate(filter->native_string, ")");
-    
-  } else if(filter->type == MS_REGEX && filter->string && filteritem) { /* item/regex pair */
-    /* NOTE: regex is not supported by MSSQL natively. We should install it in CLR UDF 
-       according to https://msdn.microsoft.com/en-us/magazine/cc163473.aspx*/
-    filter->native_string = msStringConcatenate(filter->native_string, "dbo.RegexMatch(");
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      filter->native_string = msStringConcatenate(filter->native_string, "'(?i)");
-    }
-    filter->native_string = msStrdup(filteritem);
-    filter->native_string = msStringConcatenate(filter->native_string, ", ");
-    strtmpl = "'%s'";
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
-    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
-    filter->native_string = msStringConcatenate(filter->native_string, snippet);
-
-    filter->native_string = msStringConcatenate(filter->native_string, "')");
-    free(snippet);
-  } else if(filter->type == MS_EXPRESSION) {
-    
-      if(layer->debug >= 2) 
-      msDebug("msMSSQL2008LayerTranslateFilter. String: %s.\n", filter->string);
-
-    if(!filter->tokens) {
-      if(layer->debug >= 2) 
-        msDebug("msMSSQL2008LayerTranslateFilter. There are tokens to process... \n");
-      return MS_SUCCESS;
-    }
-
-    /* start processing nodes */
-    layerinfo->current_node = filter->tokens;
-    while (layerinfo->current_node != NULL) {
-      if (!process_node(layer, filter))
-      {
-        msFree(filter->native_string);
-        filter->native_string = 0;
-        return MS_FAILURE;
-      }
-
-      if (!layerinfo->current_node)
-        break;
-
-      layerinfo->current_node = layerinfo->current_node->next;
-    }   
-  }
-
-  return MS_SUCCESS;
-}
-
-#else
-
-/* prototypes if MSSQL2008 isnt supposed to be compiled */
-
-int msMSSQL2008LayerOpen(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerOpen called but unimplemented!  (mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerOpen()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerIsOpen(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008IsLayerOpen called but unimplemented!  (mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerIsOpen()");
-  return MS_FALSE;
-}
-
-void msMSSQL2008LayerFreeItemInfo(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerFreeItemInfo called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerFreeItemInfo()");
-}
-
-int msMSSQL2008LayerInitItemInfo(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerInitItemInfo called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerInitItemInfo()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerWhichShapes called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerWhichShapes()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerClose(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerClose called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerClose()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerNextShape called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerNextShape()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape, long record)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShape called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetShape()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShapeCount called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetShapeCount()");
-    return MS_FAILURE;
-}
-
-int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetExtent called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetExtent()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerGetNumFeatures(layerObj *layer)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetNumFeatures called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetNumFeatures()");
-    return -1;
-}
-
-int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape, long *record)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShapeRandom called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetShapeRandom()");
-  return MS_FAILURE;
-}
-
-int msMSSQL2008LayerGetItems(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetItems()");
-  return MS_FAILURE;
-}
-
-void msMSSQL2008EnablePaging(layerObj *layer, int value)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008EnablePaging called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008EnablePaging()");
-    return;
-}
-
-int msMSSQL2008GetPaging(layerObj *layer)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008GetPaging called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008GetPaging()");
-    return MS_FAILURE;
-}
-
-int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerTranslateFilter called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerTranslateFilter()");
-  return MS_FAILURE;
-}
-
-char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008EscapeSQLParam called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerEscapeSQLParam()");
-  return NULL;
-}
-
-char *msMSSQL2008LayerEscapePropertyName(layerObj *layer, const char *pszString)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerEscapePropertyName called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerEscapePropertyName()");
-  return NULL;
-}
-
-/* end above's #ifdef USE_MSSQL2008 */
-#endif
-
-#ifdef USE_MSSQL2008_PLUGIN
-
-MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj* vtable, layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(vtable != NULL);
-
-  vtable->LayerEnablePaging = msMSSQL2008EnablePaging;
-  vtable->LayerGetPaging = msMSSQL2008GetPaging;
-  vtable->LayerTranslateFilter = msMSSQL2008LayerTranslateFilter;
-  vtable->LayerEscapeSQLParam = msMSSQL2008LayerEscapeSQLParam;
-  vtable->LayerEscapePropertyName = msMSSQL2008LayerEscapePropertyName;
-
-  vtable->LayerInitItemInfo = msMSSQL2008LayerInitItemInfo;
-  vtable->LayerFreeItemInfo = msMSSQL2008LayerFreeItemInfo;
-  vtable->LayerOpen = msMSSQL2008LayerOpen;
-  vtable->LayerIsOpen = msMSSQL2008LayerIsOpen;
-  vtable->LayerWhichShapes = msMSSQL2008LayerWhichShapes;
-  vtable->LayerNextShape = msMSSQL2008LayerNextShape;
-  vtable->LayerGetShape = msMSSQL2008LayerGetShape;
-  vtable->LayerGetShapeCount = msMSSQL2008LayerGetShapeCount;
-
-  vtable->LayerClose = msMSSQL2008LayerClose;
-
-  vtable->LayerGetItems = msMSSQL2008LayerGetItems;
-  vtable->LayerGetExtent = msMSSQL2008LayerGetExtent;
-
-  vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
-
-  /* vtable->LayerGetAutoStyle, not supported for this layer */
-  vtable->LayerCloseConnection = msMSSQL2008LayerClose;
-
-  vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  /* vtable->LayerCreateItems, use default */
-  vtable->LayerGetNumFeatures = msMSSQL2008LayerGetNumFeatures;
-  /* layer->vtable->LayerGetAutoProjection, use defaut*/
-
-  return MS_SUCCESS;
-}
-
-#endif
-
-int
-msMSSQL2008LayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerEnablePaging = msMSSQL2008EnablePaging;
-  layer->vtable->LayerGetPaging = msMSSQL2008GetPaging;
-  layer->vtable->LayerTranslateFilter = msMSSQL2008LayerTranslateFilter;
-  layer->vtable->LayerEscapeSQLParam = msMSSQL2008LayerEscapeSQLParam;
-  layer->vtable->LayerEscapePropertyName = msMSSQL2008LayerEscapePropertyName;
-
-  layer->vtable->LayerInitItemInfo = msMSSQL2008LayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msMSSQL2008LayerFreeItemInfo;
-  layer->vtable->LayerOpen = msMSSQL2008LayerOpen;
-  layer->vtable->LayerIsOpen = msMSSQL2008LayerIsOpen;
-  layer->vtable->LayerWhichShapes = msMSSQL2008LayerWhichShapes;
-  layer->vtable->LayerNextShape = msMSSQL2008LayerNextShape;
-  layer->vtable->LayerGetShape = msMSSQL2008LayerGetShape;
-  layer->vtable->LayerGetShapeCount = msMSSQL2008LayerGetShapeCount;
-
-  layer->vtable->LayerClose = msMSSQL2008LayerClose;
-
-  layer->vtable->LayerGetItems = msMSSQL2008LayerGetItems;
-  layer->vtable->LayerGetExtent = msMSSQL2008LayerGetExtent;
-
-  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
-
-  /* layer->vtable->LayerGetAutoStyle, not supported for this layer */
-  layer->vtable->LayerCloseConnection = msMSSQL2008LayerClose;
-
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  layer->vtable->LayerGetNumFeatures = msMSSQL2008LayerGetNumFeatures;
-
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapmvt.c 8.2.0~beta1-1~exp1/mapmvt.c
--- 8.0.1-5/mapmvt.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapmvt.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,573 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  MapBox Vector Tile rendering.
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2015 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "maptile.h"
-
-#ifdef USE_PBF
-#include "vector_tile.pb-c.h"
-#include "mapows.h"
-#include "uthash.h"
-#include <float.h>
-
-#define MOVETO 1
-#define LINETO 2
-#define CLOSEPATH 7
-
-#define FEATURES_INCREMENT_SIZE 5
-
-enum MS_RING_DIRECTION { MS_DIRECTION_INVALID_RING, MS_DIRECTION_CLOCKWISE, MS_DIRECTION_COUNTERCLOCKWISE };
-
-typedef struct {
-  char *value;
-  unsigned int index;
-  UT_hash_handle hh;
-} value_lookup;
-
-typedef struct {
-  value_lookup *cache;
-} value_lookup_table;
-
-#define COMMAND(id, count) (((id) & 0x7) | ((count) << 3))
-#define PARAMETER(n) (((n) << 1) ^ ((n) >> 31))
-
-static double getTriangleHeight(lineObj *ring)
-{
-  int i;
-  double s=0, b=0;
-
-  if(ring->numpoints != 4) return -1; /* not a triangle */
-
-  for(i=0; i<ring->numpoints-1; i++) {
-    s += (ring->point[i].x*ring->point[i+1].y - ring->point[i+1].x*ring->point[i].y);
-    b = MS_MAX(b, msDistancePointToPoint(&ring->point[i], &ring->point[i+1]));
-  }
-
-  return (MS_ABS(s/b));
-}
-
-static enum MS_RING_DIRECTION mvtGetRingDirection(lineObj *ring) {
-  int i, sum=0;
-
-  if(ring->numpoints < 4) return MS_DIRECTION_INVALID_RING;
-
-  /* step throught the edges */
-  for(i=0; i<ring->numpoints-1; i++) {
-    sum += ring->point[i].x * ring->point[i+1].y - ring->point[i+1].x * ring->point[i].y;
-  }
-
-  return sum > 0 ? MS_DIRECTION_CLOCKWISE :
-         sum < 0 ? MS_DIRECTION_COUNTERCLOCKWISE : MS_DIRECTION_INVALID_RING;
-}
-
-static void mvtReverseRingDirection(lineObj *ring) {
-  pointObj temp;
-  int start=1, end=ring->numpoints-2; /* first and last points are the same so skip 'em */
-
-  while (start < end) {
-    temp.x = ring->point[start].x; temp.y = ring->point[start].y;
-    ring->point[start].x = ring->point[end].x; ring->point[start].y = ring->point[end].y;
-    ring->point[end].x = temp.x; ring->point[end].y = temp.y;
-    start++;
-    end--;
-  }
-}
-
-static void mvtReorderRings(shapeObj *shape, int *outers) {
-  int i, j;
-  int t1;
-  lineObj t2; 
-
-  for(i=0; i<(shape->numlines-1); i++) {
-    for(j=0; j<(shape->numlines-i-1); j++) {
-      if(outers[j] < outers[j+1]) {
-        /* swap */
-	t1 = outers[j];
-        outers[j] = outers[j+1];
-	outers[j+1] = t1;
-
-	t2 = shape->line[j];
-        shape->line[j] = shape->line[j+1];
-	shape->line[j+1] = t2;
-      }
-    }
-  }
-}
-
-static int mvtTransformShape(shapeObj *shape, rectObj *extent, int layer_type, int mvt_layer_extent) {
-  double scale_x,scale_y;
-  int i,j,outj;
-
-  int *outers=NULL, ring_direction;
-
-  scale_x = (double)mvt_layer_extent/(extent->maxx - extent->minx);
-  scale_y = (double)mvt_layer_extent/(extent->maxy - extent->miny);
-
-  if(layer_type == MS_LAYER_POLYGON) {
-    outers = msGetOuterList(shape); /* compute before we muck with the shape */
-    if(outers[0] == 0) /* first ring must be an outer */
-      mvtReorderRings(shape, outers);
-  }
-
-  for(i=0;i<shape->numlines;i++) {
-    for(j=0,outj=0;j<shape->line[i].numpoints;j++) {
-
-      shape->line[i].point[outj].x = (int)((shape->line[i].point[j].x - extent->minx)*scale_x);
-      shape->line[i].point[outj].y = mvt_layer_extent - (int)((shape->line[i].point[j].y - extent->miny)*scale_y);
-
-      if(!outj || shape->line[i].point[outj].x != shape->line[i].point[outj-1].x || shape->line[i].point[outj].y != shape->line[i].point[outj-1].y)
-        outj++; /* add the point to the shape only if it's the first one or if it's different than the previous one */
-    }
-    shape->line[i].numpoints = outj;
-
-    if(layer_type == MS_LAYER_POLYGON) {
-      if(shape->line[i].numpoints == 4 && getTriangleHeight(&shape->line[i]) < 1) {        
-        shape->line[i].numpoints = 0; /* so it's not considered anymore */
-        continue; /* next ring */
-      }
-
-      ring_direction = mvtGetRingDirection(&shape->line[i]);
-      if(ring_direction == MS_DIRECTION_INVALID_RING)
-        shape->line[i].numpoints = 0; /* so it's not considered anymore */
-      else if((outers[i] && ring_direction != MS_DIRECTION_CLOCKWISE) || (!outers[i] && ring_direction != MS_DIRECTION_COUNTERCLOCKWISE))
-        mvtReverseRingDirection(&shape->line[i]);
-    }
-  }
-
-  msComputeBounds(shape); /* TODO: might need to limit this to just valid parts... */
-  msFree(outers);
-
-  return (shape->numlines == 0)?MS_FAILURE:MS_SUCCESS; /* sucess if at least one line */
-}
-
-static int mvtClipShape(shapeObj *shape, int layer_type, int buffer, int mvt_layer_extent) {
-  rectObj tile_rect;
-  tile_rect.minx = tile_rect.miny=-buffer*16;
-  tile_rect.maxx = tile_rect.maxy=mvt_layer_extent + buffer*16;
-
-  if(layer_type == MS_LAYER_POLYGON) {
-    msClipPolygonRect(shape, tile_rect);
-  } else if(layer_type == MS_LAYER_LINE) {
-    msClipPolylineRect(shape, tile_rect);
-  }
-
-  /* success if at least one line and not a degenerate bounding box */
-  if(shape->numlines > 0 && (layer_type == MS_LAYER_POINT || (shape->bounds.minx != shape->bounds.maxx || shape->bounds.miny != shape->bounds.maxy)))
-    return MS_SUCCESS;
-  else
-    return MS_FAILURE;
-}
-
-static void freeMvtFeature( VectorTile__Tile__Feature *mvt_feature ) {
-  if(mvt_feature->tags)
-    msFree(mvt_feature->tags);
-  if(mvt_feature->geometry)
-    msFree(mvt_feature->geometry);
-}
-
-static void freeMvtValue( VectorTile__Tile__Value *mvt_value ) {
-  if(mvt_value->string_value)
-    msFree(mvt_value->string_value);
-}
-
-static void freeMvtLayer( VectorTile__Tile__Layer *mvt_layer ) {
-  if(mvt_layer->keys) {
-    for(unsigned i=0;i<mvt_layer->n_keys; i++) {
-      msFree(mvt_layer->keys[i]);
-    }
-    msFree(mvt_layer->keys);
-  }
-  if(mvt_layer->values) {
-    for(unsigned i=0;i<mvt_layer->n_values; i++) {
-        freeMvtValue(mvt_layer->values[i]);
-        msFree(mvt_layer->values[i]);
-    }
-    msFree(mvt_layer->values);
-  }
-  if(mvt_layer->features) {
-    for(unsigned i=0;i<mvt_layer->n_features; i++) {
-        freeMvtFeature(mvt_layer->features[i]);
-        msFree(mvt_layer->features[i]);
-    }
-    msFree(mvt_layer->features);
-  }
-}
-
-int mvtWriteShape( layerObj *layer, shapeObj *shape, VectorTile__Tile__Layer *mvt_layer,
-                   gmlItemListObj *item_list, value_lookup_table *value_lookup_cache,
-                   rectObj *unbuffered_bbox, int buffer) {
-  VectorTile__Tile__Feature *mvt_feature;
-  int i,j,iout;
-  value_lookup *value;
-  long int n_geometry;
-
-  /* could consider an intersection test here */
-
-  if(mvtTransformShape(shape, unbuffered_bbox, layer->type, mvt_layer->extent) != MS_SUCCESS) {
-    return MS_SUCCESS; /* degenerate shape */
-  }
-  if(mvtClipShape(shape, layer->type, buffer, mvt_layer->extent) != MS_SUCCESS) {
-    return MS_SUCCESS; /* no features left after clipping */
-  }
-
-  n_geometry = 0;
-  if(layer->type == MS_LAYER_POINT) {
-    for(i=0;i<shape->numlines;i++)
-      n_geometry += shape->line[i].numpoints * 2;
-    if(n_geometry)
-      n_geometry++; /* one MOVETO */
-  } else if(layer->type == MS_LAYER_LINE) {
-    for(i=0;i<shape->numlines;i++)
-      if(shape->line[i].numpoints >= 2) n_geometry += 2 + shape->line[i].numpoints * 2; /* one MOVETO, one LINETO */
-  } else { /* MS_LAYER_POLYGON */
-    for(i=0;i<shape->numlines;i++)
-      if(shape->line[i].numpoints >= 4) n_geometry += 3 + (shape->line[i].numpoints-1) * 2; /* one MOVETO, one LINETO, one CLOSEPATH (don't consider last duplicate point) */
-  }
-
-  if(n_geometry == 0) return MS_SUCCESS;
-
-  mvt_layer->features[mvt_layer->n_features++] = msSmallMalloc(sizeof(VectorTile__Tile__Feature));
-  mvt_feature = mvt_layer->features[mvt_layer->n_features-1];
-  vector_tile__tile__feature__init(mvt_feature);
-  mvt_feature->n_tags = mvt_layer->n_keys * 2;
-  mvt_feature->tags = msSmallMalloc(mvt_feature->n_tags * sizeof(uint32_t));
-  mvt_feature->id = shape->index;
-  mvt_feature->has_id = 1;
-
-  if(layer->type == MS_LAYER_POLYGON)
-    mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__POLYGON;
-  else if(layer->type == MS_LAYER_LINE)
-    mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__LINESTRING;
-  else
-    mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__POINT;
-  mvt_feature->has_type = 1;
-
-  /* output values */
-  for( i = 0, iout = 0; i < item_list->numitems; i++ ) {
-    gmlItemObj *item = item_list->items + i;
-
-    if( !item->visible )
-      continue;
-
-    UT_HASH_FIND_STR(value_lookup_cache->cache, shape->values[i], value);
-    if(!value) {
-      VectorTile__Tile__Value *mvt_value;
-      value = msSmallMalloc(sizeof(value_lookup));
-      value->value = msStrdup(shape->values[i]);
-      value->index = mvt_layer->n_values;
-      mvt_layer->values = msSmallRealloc(mvt_layer->values,(++mvt_layer->n_values)*sizeof(VectorTile__Tile__Value*));
-      mvt_layer->values[mvt_layer->n_values-1] = msSmallMalloc(sizeof(VectorTile__Tile__Value));
-      mvt_value = mvt_layer->values[mvt_layer->n_values-1];
-      vector_tile__tile__value__init(mvt_value);
-
-      if( item->type && EQUAL(item->type,"Integer")) {
-        mvt_value->int_value = atoi(value->value);
-        mvt_value->has_int_value = 1;
-      } else if( item->type && EQUAL(item->type,"Long")) { /* signed */
-	mvt_value->sint_value = atol(value->value);
-	mvt_value->has_sint_value = 1;
-      } else if( item->type && EQUAL(item->type,"Real")) {
-        mvt_value->float_value = atof(value->value);
-        mvt_value->has_float_value = 1;
-      } else if( item->type && EQUAL(item->type,"Boolean") ) {
-        if(EQUAL(value->value,"0") || EQUAL(value->value,"false"))
-          mvt_value->bool_value = 0;
-        else
-          mvt_value->bool_value = 1;
-        mvt_value->has_bool_value = 1;
-      } else {
-        mvt_value->string_value = msStrdup(value->value);
-      }
-      UT_HASH_ADD_KEYPTR(hh,value_lookup_cache->cache,value->value, strlen(value->value), value);
-    }
-    mvt_feature->tags[iout*2] = iout;
-    mvt_feature->tags[iout*2+1] = value->index;
-
-    iout++;
-  }
-
-  /* output geom */
-  mvt_feature->n_geometry = n_geometry;
-  mvt_feature->geometry = msSmallMalloc(mvt_feature->n_geometry * sizeof(uint32_t));
-
-  if(layer->type == MS_LAYER_POINT) {
-    int idx=0, lastx=0, lasty=0;
-    mvt_feature->geometry[idx++] = COMMAND(MOVETO, (mvt_feature->n_geometry-1) / 2);
-    for(i=0;i<shape->numlines;i++) {
-      for(j=0;j<shape->line[i].numpoints;j++) {
-        mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].x)-lastx);
-        mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].y)-lasty);
-        lastx = MS_NINT(shape->line[i].point[j].x);
-        lasty = MS_NINT(shape->line[i].point[j].y);
-      }
-    }
-  } else { /* MS_LAYER_LINE or MS_LAYER_POLYGON */
-    int numpoints;
-    int idx=0, lastx=0, lasty=0;
-    for(i=0;i<shape->numlines;i++) {
-
-      if((layer->type == MS_LAYER_LINE && !(shape->line[i].numpoints >= 2)) || 
-         (layer->type == MS_LAYER_POLYGON && !(shape->line[i].numpoints >= 4))) {        
-        continue; /* skip malformed parts */
-      }
-
-      numpoints = (layer->type == MS_LAYER_LINE)?shape->line[i].numpoints:(shape->line[i].numpoints-1); /* don't consider last point for polygons */
-      for(j=0;j<numpoints;j++) {
-        if(j==0) {
-          mvt_feature->geometry[idx++] = COMMAND(MOVETO, 1);
-        } else if(j==1) {
-          mvt_feature->geometry[idx++] = COMMAND(LINETO, numpoints-1);
-        }
-        mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].x)-lastx);
-	mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].y)-lasty);
-	lastx = MS_NINT(shape->line[i].point[j].x);
-	lasty = MS_NINT(shape->line[i].point[j].y);
-      }
-      if(layer->type == MS_LAYER_POLYGON) {
-        mvt_feature->geometry[idx++] = COMMAND(CLOSEPATH, 1);
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-static void freeMvtTile( VectorTile__Tile *mvt_tile ) {
-  for(unsigned iLayer=0;iLayer<mvt_tile->n_layers;iLayer++) {
-    freeMvtLayer(mvt_tile->layers[iLayer]);
-    msFree(mvt_tile->layers[iLayer]);
-  }
-  msFree(mvt_tile->layers);
-}
-
-int msMVTWriteTile( mapObj *map, int sendheaders ) {
-  int iLayer,retcode=MS_SUCCESS;
-  unsigned len;
-  void *buf;
-  const char *mvt_extent = msGetOutputFormatOption(map->outputformat, "EXTENT", "4096");
-  const char *mvt_buffer = msGetOutputFormatOption(map->outputformat, "EDGE_BUFFER", "10");
-  int buffer = MS_ABS(atoi(mvt_buffer));
-  VectorTile__Tile mvt_tile = VECTOR_TILE__TILE__INIT;
-  mvt_tile.layers = msSmallCalloc(map->numlayers, sizeof(VectorTile__Tile__Layer*));
-
-  /* make sure we have a scale and cellsize computed */
-  map->cellsize = MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width);
-  msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
-
-  /* expand the map->extent so it goes from pixel center (MapServer) to pixel edge (OWS) */
-  map->extent.minx -= map->cellsize * 0.5;
-  map->extent.maxx += map->cellsize * 0.5;
-  map->extent.miny -= map->cellsize * 0.5;
-  map->extent.maxy += map->cellsize * 0.5;
-
-  for( iLayer = 0; iLayer < map->numlayers; iLayer++ ) {
-    int status=MS_SUCCESS;
-    layerObj *layer = GET_LAYER(map, iLayer);
-    int i;
-    shapeObj shape;
-    gmlItemListObj *item_list = NULL;
-    VectorTile__Tile__Layer *mvt_layer;
-    value_lookup_table value_lookup_cache = {NULL};
-    value_lookup *cur_value_lookup, *tmp_value_lookup;
-    rectObj rect;
-
-    unsigned features_size = 0;
-
-    if(!msLayerIsVisible(map, layer)) continue;
-
-    if(layer->type != MS_LAYER_POINT && layer->type != MS_LAYER_POLYGON && layer->type != MS_LAYER_LINE)
-      continue;
-
-    status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) {
-      retcode = status;
-      goto layer_cleanup;
-    }
-
-    status = msLayerWhichItems(layer, MS_TRUE, NULL); /* we want all items - behaves like a query in that sense */
-    if(status != MS_SUCCESS) {
-      retcode = status;
-      goto layer_cleanup;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Will we need to reproject?                                      */
-    /* -------------------------------------------------------------------- */
-    layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
-
-    rect = map->extent;
-    if(layer->project) msProjectRect(&(map->projection), &(layer->projection), &rect);
-
-    status = msLayerWhichShapes(layer, rect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap - that's ok */
-      retcode = MS_SUCCESS;
-      goto layer_cleanup;
-    } else if(status != MS_SUCCESS) {
-      retcode = status;
-      goto layer_cleanup;
-    }
-
-    mvt_tile.layers[mvt_tile.n_layers++] = msSmallMalloc(sizeof(VectorTile__Tile__Layer));
-    mvt_layer = mvt_tile.layers[mvt_tile.n_layers-1];
-    vector_tile__tile__layer__init(mvt_layer);
-    mvt_layer->version = 2;
-    mvt_layer->name = layer->name;
-
-    mvt_layer->extent = MS_ABS(atoi(mvt_extent));
-    mvt_layer->has_extent = 1;
-
-    /* -------------------------------------------------------------------- */
-    /*      Create appropriate attributes on this layer.                    */
-    /* -------------------------------------------------------------------- */
-    item_list = msGMLGetItems( layer, "G" );
-    assert( item_list->numitems == layer->numitems );
-
-    mvt_layer->keys = msSmallMalloc(layer->numitems * sizeof(char*));
-
-    for( i = 0; i < layer->numitems; i++ ) {
-      gmlItemObj *item = item_list->items + i;
-
-      if( !item->visible )
-        continue;
-
-      if( item->alias )
-        mvt_layer->keys[mvt_layer->n_keys++] = msStrdup(item->alias);
-      else
-        mvt_layer->keys[mvt_layer->n_keys++] = msStrdup(item->name);
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Setup joins if needed.  This is likely untested.                */
-    /* -------------------------------------------------------------------- */
-    if(layer->numjoins > 0) {
-      int j;
-      for(j=0; j<layer->numjoins; j++) {
-        status = msJoinConnect(layer, &(layer->joins[j]));
-        if(status != MS_SUCCESS) {
-          retcode = status;
-          goto layer_cleanup;
-        }
-      }
-    }
-
-    mvt_layer->features = msSmallCalloc(FEATURES_INCREMENT_SIZE, sizeof(VectorTile__Tile__Feature*));
-    features_size = FEATURES_INCREMENT_SIZE;
-
-    msInitShape(&shape);
-    while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
-      
-      if(layer->numclasses > 0) {
-        shape.classindex = msShapeGetClass(layer, map, &shape, NULL, -1); /* Perform classification, and some annotation related magic. */
-        if(shape.classindex < 0)
-          goto feature_cleanup; /* no matching CLASS found, skip this feature */
-      }
-
-      /*
-      ** prepare any necessary JOINs here (one-to-one only)
-      */
-      if( layer->numjoins > 0) {
-        int j;
-
-        for(j=0; j < layer->numjoins; j++) {
-          if(layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
-            msJoinPrepare(&(layer->joins[j]), &shape);
-            msJoinNext(&(layer->joins[j])); /* fetch the first row */
-          }
-        }
-      }
-
-      if(mvt_layer->n_features == features_size) { /* need to allocate more space */
-        features_size += FEATURES_INCREMENT_SIZE;
-        mvt_layer->features = msSmallRealloc(mvt_layer->features, sizeof(VectorTile__Tile__Feature*)*(features_size));
-      }
-
-      if( layer->project ) {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &map->projection);
-        }
-        if( layer->reprojectorLayerToMap )
-            status = msProjectShapeEx(layer->reprojectorLayerToMap, &shape);
-        else
-            status = MS_FAILURE;
-      }
-      if( status == MS_SUCCESS ) {
-        status = mvtWriteShape( layer, &shape, mvt_layer, item_list, &value_lookup_cache, &map->extent, buffer );
-      }
-
-      feature_cleanup:
-      msFreeShape(&shape);
-      if(status != MS_SUCCESS) goto layer_cleanup;
-    } /* next shape */
-layer_cleanup:
-    msLayerClose(layer);
-    msGMLFreeItems(item_list);
-    UT_HASH_ITER(hh, value_lookup_cache.cache, cur_value_lookup, tmp_value_lookup) {
-      msFree(cur_value_lookup->value);
-      UT_HASH_DEL(value_lookup_cache.cache,cur_value_lookup);
-      msFree(cur_value_lookup);
-    }
-    if(retcode != MS_SUCCESS) goto cleanup;
-  } /* next layer */
-
-  len = vector_tile__tile__get_packed_size(&mvt_tile); // This is the calculated packing length
-
-  buf = msSmallMalloc(len); // Allocate memory
-  vector_tile__tile__pack(&mvt_tile, buf);
-  if( sendheaders ) {
-    msIO_fprintf( stdout,
-		  "Content-Length: %d\r\n"
-		  "Content-Type: %s\r\n\r\n",
-                  len, MS_IMAGE_MIME_TYPE(map->outputformat));
-  }
-  msIO_fwrite(buf,len,1,stdout);
-  msFree(buf);
-
-  cleanup:
-  freeMvtTile(&mvt_tile);
-
-  return retcode;
-}
-
-int msPopulateRendererVTableMVT(rendererVTableObj * renderer) {
-  (void)renderer;
-  return MS_SUCCESS;
-}
-#else
-int msPopulateRendererVTableMVT(rendererVTableObj * renderer) {
-  msSetError(MS_MISCERR, "Vector Tile Driver requested but support is not compiled in", "msPopulateRendererVTableMVT()");
-  return MS_FAILURE;
-}
-
-int msMVTWriteTile( mapObj *map, int sendheaders ) {
-  msSetError(MS_MISCERR, "Vector Tile support is not available.", "msMVTWriteTile()");
-  return MS_FAILURE;
-}
-#endif
diff -pruN 8.0.1-5/mapobject.c 8.2.0~beta1-1~exp1/mapobject.c
--- 8.0.1-5/mapobject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapobject.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,802 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Functions for operating on a mapObj that don't belong in a
- *           more specific file such as mapfile.c, or mapdraw.c.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 2004, Frank Warmerdam
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#include "gdal.h"
-#include "cpl_conv.h"
-
-void freeWeb(webObj *web);
-void freeScalebar(scalebarObj *scalebar);
-void freeReferenceMap(referenceMapObj *ref);
-void freeLegend(legendObj *legend);
-
-/************************************************************************/
-/*                            msNewMapObj()                             */
-/*                                                                      */
-/*      Create a new initialized map object.                            */
-/************************************************************************/
-
-mapObj *msNewMapObj()
-{
-  mapObj *map = NULL;
-
-  /* create an empty map, no layers etc... */
-  map = (mapObj *)calloc(sizeof(mapObj),1);
-
-  if(!map) {
-    msSetError(MS_MEMERR, NULL, "msCreateMap()");
-    return NULL;
-  }
-
-  if( initMap( map ) == -1 ) {
-    msFreeMap(map);
-    return NULL;
-  }
-
-  if( msPostMapParseOutputFormatSetup( map ) == MS_FAILURE ) {
-    msFreeMap(map);
-    return NULL;
-  }
-
-  return map;
-}
-
-/************************************************************************/
-/*                             msFreeMap()                              */
-/************************************************************************/
-
-void msFreeMap(mapObj *map)
-{
-  int i;
-
-  if(!map) return;
-
-  /* printf("msFreeMap(): maybe freeing map at %p count=%d.\n",map, map->refcount); */
-  if(MS_REFCNT_DECR_IS_NOT_ZERO(map)) {
-    return;
-  }
-  if(map->debug >= MS_DEBUGLEVEL_VV)
-    msDebug("msFreeMap(): freeing map at %p.\n",map);
-
-  msCloseConnections(map);
-
-  msFree(map->name);
-  msFree(map->shapepath);
-  msFree(map->mappath);
-
-  msFreeProjection(&(map->projection));
-  msFreeProjection(&(map->latlon));
-  msProjectionContextReleaseToPool(map->projContext);
-
-  msFreeLabelCache(&(map->labelcache));
-
-  msFree(map->imagetype);
-
-  msFreeFontSet(&(map->fontset));
-
-  msFreeSymbolSet(&map->symbolset); /* free symbols */
-  msFree(map->symbolset.filename);
-
-  freeWeb(&(map->web));
-
-  freeScalebar(&(map->scalebar));
-  freeReferenceMap(&(map->reference));
-  freeLegend(&(map->legend));
-
-  for(i=0; i<map->maxlayers; i++) {
-    if(GET_LAYER(map, i) != NULL) {
-      GET_LAYER(map, i)->map = NULL;
-      if(freeLayer((GET_LAYER(map, i))) == MS_SUCCESS)
-        free(GET_LAYER(map, i));
-    }
-  }
-  msFree(map->layers);
-
-  if(map->layerorder)
-    free(map->layerorder);
-
-  msFree(map->templatepattern);
-  msFree(map->datapattern);
-  msFreeHashItems(&(map->configoptions));
-  if(map->outputformat && map->outputformat->refcount > 0 && --map->outputformat->refcount < 1)
-    msFreeOutputFormat(map->outputformat);
-
-  for(i=0; i<map->numoutputformats; i++ ) {
-    if(map->outputformatlist[i]->refcount > 0 && --map->outputformatlist[i]->refcount < 1)
-      msFreeOutputFormat(map->outputformatlist[i]);
-  }
-  if(map->outputformatlist != NULL)
-    msFree(map->outputformatlist);
-
-  msFreeQuery(&(map->query));
-
-#ifdef USE_V8_MAPSCRIPT
-  if (map->v8context)
-    msV8FreeContext(map);
-#endif
-
-  msFree(map);
-}
-
-/************************************************************************/
-/*                         msGetConfigOption()                          */
-/************************************************************************/
-
-const char *msGetConfigOption( mapObj *map, const char *key)
-
-{
-  return msLookupHashTable( &(map->configoptions), key );
-}
-
-/************************************************************************/
-/*                         msSetConfigOption()                          */
-/************************************************************************/
-
-int msSetConfigOption( mapObj *map, const char *key, const char *value)
-
-{
-  /* We have special "early" handling of this so that it will be */
-  /* in effect when the projection blocks are parsed and pj_init is called. */
-  if( strcasecmp(key,"PROJ_DATA") == 0 || strcasecmp(key,"PROJ_LIB") == 0 ) {
-    /* value may be relative to map path */
-    msSetPROJ_DATA( value, map->mappath );
-  }
-
-  /* Same for MS_ERRORFILE, we want it to kick in as early as possible
-   * to catch parsing errors.
-   * Value can be relative to mapfile, unless it's already absolute
-   */
-  if( strcasecmp(key,"MS_ERRORFILE") == 0 ) {
-    if (msSetErrorFile( value, map->mappath ) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-
-  if( msLookupHashTable( &(map->configoptions), key ) != NULL )
-    msRemoveHashTable( &(map->configoptions), key );
-  msInsertHashTable( &(map->configoptions), key, value );
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                         msTestConfigOption()                         */
-/************************************************************************/
-
-int msTestConfigOption( mapObj *map, const char *key, int default_result )
-
-{
-  const char *result = msGetConfigOption( map, key );
-
-  if( result == NULL )
-    return default_result;
-
-  if( strcasecmp(result,"YES") == 0
-      || strcasecmp(result,"ON") == 0
-      || strcasecmp(result,"TRUE") == 0 )
-    return MS_TRUE;
-  else
-    return MS_FALSE;
-}
-
-/************************************************************************/
-/*                      msApplyMapConfigOptions()                       */
-/************************************************************************/
-
-void msApplyMapConfigOptions( mapObj *map )
-
-{
-  const char *key;
-
-  for( key = msFirstKeyFromHashTable( &(map->configoptions) );
-       key != NULL;
-       key = msNextKeyFromHashTable( &(map->configoptions), key ) ) {
-    const char *value = msLookupHashTable( &(map->configoptions), key );
-    if( strcasecmp(key,"PROJ_DATA") == 0 ||
-        strcasecmp(key,"PROJ_LIB") == 0 ) {
-      msSetPROJ_DATA( value, map->mappath );
-    } else if( strcasecmp(key,"MS_ERRORFILE") == 0 ) {
-      msSetErrorFile( value, map->mappath );
-    } else {
-      CPLSetConfigOption( key, value );
-    }
-  }
-}
-
-/************************************************************************/
-/*                         msMapIgnoreMissingData()                               */
-/************************************************************************/
-
-int msMapIgnoreMissingData( mapObj *map )
-{
-  const char *result = msGetConfigOption( map, "ON_MISSING_DATA" );
-  const int default_result =
-#ifndef IGNORE_MISSING_DATA
-    MS_MISSING_DATA_FAIL;
-#else
-    MS_MISSING_DATA_LOG;
-#endif
-
-  if( result == NULL )
-    return default_result;
-
-  if( strcasecmp(result,"FAIL") == 0 )
-    return MS_MISSING_DATA_FAIL;
-  else if( strcasecmp(result,"LOG") == 0 )
-    return MS_MISSING_DATA_LOG;
-  else if( strcasecmp(result,"IGNORE") == 0 )
-    return MS_MISSING_DATA_IGNORE;
-
-  return default_result;
-}
-
-/************************************************************************/
-/*                           msMapSetExtent()                           */
-/************************************************************************/
-
-int msMapSetExtent( mapObj *map,
-                    double minx, double miny, double maxx, double maxy)
-{
-
-  map->extent.minx = minx;
-  map->extent.miny = miny;
-  map->extent.maxx = maxx;
-  map->extent.maxy = maxy;
-
-  if (!MS_VALID_EXTENT(map->extent)) {
-    msSetError(MS_MISCERR, "Given map extent is invalid. Check that it " \
-               "is in the form: minx, miny, maxx, maxy", "setExtent()");
-    return MS_FAILURE;
-  }
-
-  map->cellsize = msAdjustExtent(&(map->extent), map->width,
-                                 map->height);
-
-  /* if the map size is also set, recompute scale, ignore errors? */
-  if( map->width != -1 || map->height != -1 )
-    msCalculateScale(map->extent, map->units, map->width, map->height,
-                     map->resolution, &(map->scaledenom));
-
-  return msMapComputeGeotransform( map );
-}
-
-/************************************************************************/
-/*                           msMapOffsetExtent()                        */
-/************************************************************************/
-
-int msMapOffsetExtent( mapObj *map, double x, double y)
-{
-  return msMapSetExtent( map,
-                         map->extent.minx + x, map->extent.miny + y,
-                         map->extent.maxx + x, map->extent.maxy + y);
-}
-
-/************************************************************************/
-/*                           msMapScaleExtent()                         */
-/************************************************************************/
-
-int msMapScaleExtent( mapObj *map, double zoomfactor,
-                      double minscaledenom, double maxscaledenom)
-{
-  double geo_width, geo_height, center_x, center_y, md;
-
-  if (zoomfactor <= 0.0) {
-    msSetError(MS_MISCERR, "The given zoomfactor is invalid", "msMapScaleExtent()");
-  }
-
-  geo_width = map->extent.maxx - map->extent.minx;
-  geo_height = map->extent.maxy - map->extent.miny;
-
-  center_x = map->extent.minx + geo_width * 0.5;
-  center_y = map->extent.miny + geo_height * 0.5;
-
-  geo_width *= zoomfactor;
-
-  if (minscaledenom > 0 || maxscaledenom > 0) {
-    /* ensure we are within the valid scale domain */
-    md = (map->width-1)/(map->resolution * msInchesPerUnit(map->units, center_y));
-    if (minscaledenom > 0 && geo_width < minscaledenom * md)
-      geo_width = minscaledenom * md;
-    if (maxscaledenom > 0 && geo_width > maxscaledenom * md)
-      geo_width = maxscaledenom * md;
-  }
-
-  geo_width *= 0.5;
-  geo_height = geo_width * map->height / map->width;
-
-  return msMapSetExtent( map,
-                         center_x - geo_width, center_y - geo_height,
-                         center_x + geo_width, center_y + geo_height);
-}
-
-/************************************************************************/
-/*                           msMapSetCenter()                           */
-/************************************************************************/
-
-int msMapSetCenter( mapObj *map, pointObj *center)
-{
-  return msMapOffsetExtent(map, center->x - (map->extent.minx + map->extent.maxx) * 0.5,
-                           center->y - (map->extent.miny + map->extent.maxy) * 0.5);
-}
-
-/************************************************************************/
-/*                           msMapSetRotation()                         */
-/************************************************************************/
-
-int msMapSetRotation( mapObj *map, double rotation_angle )
-
-{
-  map->gt.rotation_angle = rotation_angle;
-  if( map->gt.rotation_angle != 0.0 )
-    map->gt.need_geotransform = MS_TRUE;
-  else
-    map->gt.need_geotransform = MS_FALSE;
-
-  return msMapComputeGeotransform( map );
-}
-
-/************************************************************************/
-/*                             msMapSetSize()                           */
-/************************************************************************/
-
-int msMapSetSize( mapObj *map, int width, int height )
-
-{
-  map->width = width;
-  map->height = height;
-
-  return msMapComputeGeotransform( map ); /* like SetRotation -- sean */
-}
-
-/************************************************************************/
-/*                      msMapComputeGeotransform()                      */
-/************************************************************************/
-
-extern int InvGeoTransform( double *gt_in, double *gt_out );
-
-int msMapComputeGeotransformEx( mapObj * map, double resolutionX, double resolutionY )
-
-{
-  double rot_angle;
-  double geo_width, geo_height, center_x, center_y;
-
-  map->saved_extent = map->extent;
-
-  rot_angle = map->gt.rotation_angle * MS_PI / 180.0;
-
-  geo_width = map->extent.maxx - map->extent.minx;
-  geo_height = map->extent.maxy - map->extent.miny;
-
-  center_x = map->extent.minx + geo_width*0.5;
-  center_y = map->extent.miny + geo_height*0.5;
-
-  /*
-  ** Per bug 1916 we have to adjust for the fact that map extents
-  ** are based on the center of the edge pixels, not the outer
-  ** edges as is expected in a geotransform.
-  */
-  map->gt.geotransform[1] =
-    cos(rot_angle) * resolutionX;
-  map->gt.geotransform[2] =
-    sin(rot_angle) * resolutionY;
-  map->gt.geotransform[0] = center_x
-                            - (map->width * 0.5) * map->gt.geotransform[1]
-                            - (map->height * 0.5) * map->gt.geotransform[2];
-
-  map->gt.geotransform[4] =
-    sin(rot_angle) * resolutionX;
-  map->gt.geotransform[5] =
-    - cos(rot_angle) * resolutionY;
-  map->gt.geotransform[3] = center_y
-                            - (map->width * 0.5) * map->gt.geotransform[4]
-                            - (map->height * 0.5) * map->gt.geotransform[5];
-
-  if( InvGeoTransform( map->gt.geotransform,
-                       map->gt.invgeotransform ) )
-    return MS_SUCCESS;
-  else
-    return MS_FAILURE;
-}
-
-int msMapComputeGeotransform( mapObj * map )
-
-{
-  /* Do we have all required parameters? */
-  if( map->extent.minx == map->extent.maxx
-      || map->width <= 1 || map->height <= 1 )
-    return MS_FAILURE;
-
-  const double geo_width = map->extent.maxx - map->extent.minx;
-  const double geo_height = map->extent.maxy - map->extent.miny;
-  return msMapComputeGeotransformEx(map,
-                                    geo_width / (map->width-1),
-                                    geo_height / (map->height-1));
-}
-
-/************************************************************************/
-/*                         msMapPixelToGeoref()                         */
-/************************************************************************/
-
-void msMapPixelToGeoref( mapObj *map, double *x, double *y )
-
-{
-  (void)map;
-  (void)x;
-  (void)y;
-  msSetError(MS_MISCERR, NULL, "msMapPixelToGeoref() not yet implemented");
-}
-
-/************************************************************************/
-/*                         msMapGeorefToPixel()                         */
-/************************************************************************/
-
-void msMapGeorefToPixel( mapObj *map, double *x, double *y )
-
-{
-  (void)map;
-  (void)x;
-  (void)y;
-  msSetError(MS_MISCERR, NULL, "msMapGeorefToPixel() not yet implemented");
-}
-
-/************************************************************************/
-/*                        msMapSetFakedExtent()                         */
-/************************************************************************/
-
-int msMapSetFakedExtent( mapObj *map )
-
-{
-  int i;
-  /* -------------------------------------------------------------------- */
-  /*      Remember the original map extents so we can restore them        */
-  /*      later.                                                          */
-  /* -------------------------------------------------------------------- */
-  map->saved_extent = map->extent;
-
-  /* -------------------------------------------------------------------- */
-  /*      Set extents such that the bottom left corner is 0,0 and the     */
-  /*      top right is width,height.  Note this is upside down from       */
-  /*      the normal sense of pixel/line coordiantes, but we do this      */
-  /*      so that the normal "extent" concept of coordinates              */
-  /*      increasing to the right, and up is maintained (like in          */
-  /*      georeferenced coordinate systems).                              */
-  /* -------------------------------------------------------------------- */
-  map->extent.minx = 0;
-  map->extent.maxx = map->width;
-  map->extent.miny = 0;
-  map->extent.maxy = map->height;
-  map->cellsize = 1.0;
-
-  /* -------------------------------------------------------------------- */
-  /*      When we copy the geotransform into the projection object we     */
-  /*      have to flip it to account for the preceeding upside-down       */
-  /*      coordinate system.                                              */
-  /* -------------------------------------------------------------------- */
-  map->projection.gt = map->gt;
-
-  map->projection.gt.geotransform[0]
-  += map->height * map->gt.geotransform[2];
-  map->projection.gt.geotransform[3]
-  += map->height * map->gt.geotransform[5];
-
-  map->projection.gt.geotransform[2] *= -1;
-  map->projection.gt.geotransform[5] *= -1;
-
-  for(i=0; i<map->numlayers; i++)
-    GET_LAYER(map, i)->project = MS_TRUE;
-
-  return InvGeoTransform( map->projection.gt.geotransform,
-                          map->projection.gt.invgeotransform );
-}
-
-/************************************************************************/
-/*                      msMapRestoreRealExtent()                        */
-/************************************************************************/
-
-int msMapRestoreRealExtent( mapObj *map )
-
-{
-  map->projection.gt.need_geotransform = MS_FALSE;
-  map->extent = map->saved_extent;
-  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                      msInsertLayer()                                 */
-/************************************************************************/
-/* Returns the index at which the layer was inserted
- */
-
-int msInsertLayer(mapObj *map, layerObj *layer, int nIndex)
-{
-  if (!layer) {
-    msSetError(MS_CHILDERR, "Can't insert a NULL Layer", "msInsertLayer()");
-    return -1;
-  }
-
-  /* Ensure there is room for a new layer */
-  if (map->numlayers == map->maxlayers) {
-    if (msGrowMapLayers(map) == NULL)
-      return -1;
-  }
-
-  /* msGrowMapLayers allocates the new layer which we don't need to do since we have 1 that we are inserting
-                  not sure if it is possible for this to be non null otherwise, but better to check since this function
-                  replaces the value */
-  if (map->layers[map->numlayers]!=NULL)
-    free(map->layers[map->numlayers]);
-
-  /* Catch attempt to insert past end of layers array */
-  if (nIndex >= map->numlayers) {
-    msSetError(MS_CHILDERR, "Cannot insert layer beyond index %d",
-               "msInsertLayer()", map->numlayers-1);
-    return -1;
-  } else if (nIndex < 0) { /* Insert at the end by default */
-    map->layerorder[map->numlayers] = map->numlayers;
-    GET_LAYER(map, map->numlayers) = layer;
-    GET_LAYER(map, map->numlayers)->index = map->numlayers;
-    GET_LAYER(map, map->numlayers)->map = map;
-    MS_REFCNT_INCR(layer);
-    map->numlayers++;
-    return map->numlayers-1;
-  } else  {
-    /* Move existing layers at the specified nIndex or greater */
-    /* to an index one higher */
-    int i;
-    for (i=map->numlayers; i>nIndex; i--) {
-      GET_LAYER(map, i)=GET_LAYER(map, i-1);
-      GET_LAYER(map, i)->index = i;
-    }
-
-    /* assign new layer to specified index */
-    GET_LAYER(map, nIndex)=layer;
-    GET_LAYER(map, nIndex)->index = nIndex;
-    GET_LAYER(map, nIndex)->map = map;
-
-    /* adjust layers drawing order */
-    for (i=map->numlayers; i>nIndex; i--) {
-      map->layerorder[i] = map->layerorder[i-1];
-      if (map->layerorder[i] >= nIndex) map->layerorder[i]++;
-    }
-    for (i=0; i<nIndex; i++) {
-      if (map->layerorder[i] >= nIndex) map->layerorder[i]++;
-    }
-    map->layerorder[nIndex] = nIndex;
-
-    /* increment number of layers and return */
-    MS_REFCNT_INCR(layer);
-    map->numlayers++;
-    return nIndex;
-  }
-}
-
-/************************************************************************/
-/*                           msRemoveLayer()                            */
-/************************************************************************/
-layerObj *msRemoveLayer(mapObj *map, int nIndex)
-{
-  int i;
-  int order_index;
-  layerObj *layer;
-
-  if (nIndex < 0 || nIndex >= map->numlayers) {
-    msSetError(MS_CHILDERR, "Cannot remove Layer, invalid index %d",
-               "msRemoveLayer()", nIndex);
-    return NULL;
-  } else {
-    layer=GET_LAYER(map, nIndex);
-    /* msCopyLayer(layer, (GET_LAYER(map, nIndex))); */
-
-    /* Iteratively copy the higher index layers down one index */
-    for (i=nIndex; i<map->numlayers-1; i++) {
-      /* freeLayer((GET_LAYER(map, i))); */
-      /* initLayer((GET_LAYER(map, i)), map); */
-      /* msCopyLayer(GET_LAYER(map, i), GET_LAYER(map, i+1)); */
-      GET_LAYER(map, i)=GET_LAYER(map, i+1);
-      GET_LAYER(map, i)->index = i;
-    }
-    /* Free the extra layer at the end */
-    /* freeLayer((GET_LAYER(map, map->numlayers-1))); */
-    GET_LAYER(map, map->numlayers-1)=NULL;
-
-    /* Adjust drawing order */
-    order_index = 0;
-    for (i=0; i<map->numlayers; i++) {
-      if (map->layerorder[i] > nIndex) map->layerorder[i]--;
-      if (map->layerorder[i] == nIndex) {
-        order_index = i;
-        break;
-      }
-    }
-    for (i=order_index; i<map->numlayers-1; i++) {
-      map->layerorder[i] = map->layerorder[i+1];
-      if (map->layerorder[i] > nIndex) map->layerorder[i]--;
-    }
-
-    /* decrement number of layers and return copy of removed layer */
-    map->numlayers--;
-    layer->map=NULL;
-    MS_REFCNT_DECR(layer);
-    return layer;
-  }
-}
-
-/*
-** Move the layer's order for drawing purpose. Moving it up here
-** will have the effect of drawing the layer earlier.
-*/
-int msMoveLayerUp(mapObj *map, int nLayerIndex)
-{
-  int iCurrentIndex = -1;
-  if (map && nLayerIndex < map->numlayers && nLayerIndex >=0) {
-    for (int i=0; i<map->numlayers; i++) {
-      if ( map->layerorder[i] == nLayerIndex) {
-        iCurrentIndex = i;
-        break;
-      }
-    }
-    if (iCurrentIndex >=0) {
-      /* we do not need to promote if it is the first one. */
-      if (iCurrentIndex == 0)
-        return MS_FAILURE;
-
-      map->layerorder[iCurrentIndex] =
-        map->layerorder[iCurrentIndex-1];
-      map->layerorder[iCurrentIndex-1] = nLayerIndex;
-
-      return MS_SUCCESS;
-    }
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLayerUp()",
-             nLayerIndex);
-  return MS_FAILURE;
-}
-
-/*
-** Move the layer's order for drawing purpose. Moving it down here
-** will have the effect of drawing the layer later.
-*/
-int msMoveLayerDown(mapObj *map, int nLayerIndex)
-{
-  int iCurrentIndex = -1;
-  if (map && nLayerIndex < map->numlayers && nLayerIndex >=0) {
-    for (int i=0; i<map->numlayers; i++) {
-      if ( map->layerorder[i] == nLayerIndex) {
-        iCurrentIndex = i;
-        break;
-      }
-    }
-    if (iCurrentIndex >=0) {
-      /* we do not need to demote if it is the last one. */
-      if (iCurrentIndex == map->numlayers-1)
-        return MS_FAILURE;
-
-      map->layerorder[iCurrentIndex] =
-        map->layerorder[iCurrentIndex+1];
-      map->layerorder[iCurrentIndex+1] = nLayerIndex;
-
-      return MS_SUCCESS;
-    }
-  }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLayerDown()",
-             nLayerIndex);
-  return MS_FAILURE;
-}
-
-
-/*
-** Set the array used for the drawing order. The array passed must contain
-** all the layer's index ordered by the drawing priority.
-** Ex : for 3 layers in the map file, if
-**                          panIndexes[0] = 2
-**                          panIndexes[1] = 0
-**                          panIndexes[2] = 1
-**                          will set the darwing order to layer 2, layer 0,
-**                          and then layer 1.
-**
-** Note : It is assumed that the index panIndexes has the same number of
-**        of elements as the number of layers in the map.
-** Return TRUE on success else FALSE.
-*/
-int msSetLayersdrawingOrder(mapObj *self, int *panIndexes)
-{
-  if (self && panIndexes) {
-    const int nElements = self->numlayers;
-    for (int i=0; i<nElements; i++) {
-      int bFound = 0;
-      for (int j=0; j<nElements; j++) {
-        if (panIndexes[j] == i) {
-          bFound = 1;
-          break;
-        }
-      }
-      if (!bFound)
-        return 0;
-    }
-    /* -------------------------------------------------------------------- */
-    /*    At this point the array is valid so update the layers order array.*/
-    /* -------------------------------------------------------------------- */
-    for (int i=0; i<nElements; i++) {
-      self->layerorder[i] = panIndexes[i];
-    }
-    return 1;
-  }
-  return 0;
-}
-
-
-/* =========================================================================
-   msMapLoadOWSParameters
-
-   Function to support mapscript mapObj::loadOWSParameters
-   ========================================================================= */
-
-int msMapLoadOWSParameters(mapObj *map, cgiRequestObj *request,
-                           const char *wmtver)
-{
-#ifdef USE_WMS_SVR
-  int version;
-  char *wms_exception_format = NULL;
-  const char *wms_request= NULL;
-  int result, i = 0;
-  owsRequestObj ows_request;
-
-  msOWSInitRequestObj(&ows_request);
-
-
-  version = msOWSParseVersionString(wmtver);
-  for(i=0; i<request->NumParams; i++) {
-    if (strcasecmp(request->ParamNames[i], "EXCEPTIONS") == 0)
-      wms_exception_format = request->ParamValues[i];
-    else if (strcasecmp(request->ParamNames[i], "REQUEST") == 0)
-      wms_request = request->ParamValues[i];
-
-  }
-
-  msOWSRequestLayersEnabled(map, "M", wms_request, &ows_request);
-
-  result = msWMSLoadGetMapParams(map, version, request->ParamNames,
-                                 request->ParamValues, request->NumParams,  wms_exception_format,
-                                 wms_request, &ows_request);
-
-  msOWSClearRequestObj(&ows_request);
-
-  return result;
-
-#else
-  msSetError(MS_WMSERR, "WMS server support is not available.",
-             "msMapLoadOWSParameters()");
-  return MS_FAILURE;
-#endif
-}
-
diff -pruN 8.0.1-5/mapogcapi.cpp 8.2.0~beta1-1~exp1/mapogcapi.cpp
--- 8.0.1-5/mapogcapi.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcapi.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1720 +0,0 @@
-/**********************************************************************
- * $id$
- *
- * Project:  MapServer
- * Purpose:  OGCAPI Implementation
- * Author:   Steve Lime and the MapServer team.
- *
- **********************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota. 
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-#include "mapserver.h"
-#include "mapogcapi.h"
-#include "mapows.h"
-#include "mapgml.h"
-#include "maptime.h"
-
-#include "cpl_conv.h"
-
-#include "third-party/include_nlohmann_json.hpp"
-#include "third-party/include_pantor_inja.hpp"
-
-#include <string>
-#include <iostream>
-
-using namespace inja;
-using json = nlohmann::json;
-
-#define OGCAPI_DEFAULT_TITLE "MapServer OGC API"
-
-/*
-** HTML Templates
-*/
-#define OGCAPI_TEMPLATE_HTML_LANDING "landing.html"
-#define OGCAPI_TEMPLATE_HTML_CONFORMANCE "conformance.html"
-#define OGCAPI_TEMPLATE_HTML_COLLECTION "collection.html"
-#define OGCAPI_TEMPLATE_HTML_COLLECTIONS "collections.html"
-#define OGCAPI_TEMPLATE_HTML_COLLECTION_ITEMS "collection-items.html"
-#define OGCAPI_TEMPLATE_HTML_COLLECTION_ITEM "collection-item.html"
-#define OGCAPI_TEMPLATE_HTML_OPENAPI "openapi.html"
-
-enum class OGCAPIFormat
-{
-    JSON,
-    GeoJSON,
-    OpenAPI_V3,
-    HTML
-};
-
-#define OGCAPI_MIMETYPE_JSON "application/json"
-#define OGCAPI_MIMETYPE_GEOJSON "application/geo+json"
-#define OGCAPI_MIMETYPE_OPENAPI_V3 "application/vnd.oai.openapi+json;version=3.0"
-#define OGCAPI_MIMETYPE_HTML "text/html"
-
-#define OGCAPI_DEFAULT_LIMIT 10 // by specification
-#define OGCAPI_MAX_LIMIT 10000
-
-#define OGCAPI_DEFAULT_GEOMETRY_PRECISION 6
-
-#ifdef USE_OGCAPI_SVR
-
-#define OGCAPI_SERVER_ERROR 0 // error codes
-#define OGCAPI_CONFIG_ERROR 1
-#define OGCAPI_PARAM_ERROR 2
-#define OGCAPI_NOT_FOUND_ERROR 3
-#define OGCAPI_NUM_ERROR_CODES 4
-
-/*
-** Returns a JSON object using and a description.
-*/
-static void outputError(int code, const std::string& description)
-{
-  if(code < 0 || code >= OGCAPI_NUM_ERROR_CODES) code = 0;
-
-  json error_codes = {
-    { {"text", "ServerError"}, {"status", "500"} },
-    { {"text", "ConfigError"}, {"status", "500"} },
-    { {"text", "InvalidParamterValue"}, {"status", "400"} },
-    { {"text", "NotFound"}, {"status", "404"} }
-  };
-
-  json j = {
-    { "code", error_codes[code]["text"] },
-    { "description", description }
-  };
-
-  std::string status = error_codes[code]["status"];
-
-  msIO_setHeader("Content-Type", "%s", OGCAPI_MIMETYPE_JSON);
-  msIO_setHeader("Status", "%s", status.c_str());
-  msIO_sendHeaders();
-  msIO_printf("%s\n", j.dump().c_str());
-}
-
-static int includeLayer(mapObj *map, layerObj *layer) {
-  if(!msOWSRequestIsEnabled(map, layer, "AO", "OGCAPI", MS_FALSE) || 
-     !msWFSIsLayerSupported(layer) || 
-     !msIsLayerQueryable(layer)) {
-    return MS_FALSE;
-  } else {
-    return MS_TRUE;
-  }
-}
-
-/*
-** Get stuff...
-*/
-
-/*
-** Returns the value associated with an item from the request's query string and NULL if the item was not found.
-*/
-static const char *getRequestParameter(cgiRequestObj *request, const char *item)
-{
-  int i;
-
-  for(i=0; i<request->NumParams; i++) {
-    if(strcmp(item, request->ParamNames[i]) == 0)
-      return request->ParamValues[i];
-  }
-
-  return NULL;
-}
-
-static int getMaxLimit(mapObj *map, layerObj *layer)
-{
-  int max_limit = OGCAPI_MAX_LIMIT;
-  const char *value;  
-
-  // check metadata, layer then map
-  value = msOWSLookupMetadata(&(layer->metadata), "A", "max_limit");
-  if(value == NULL) value = msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
-
-  if(value != NULL) {
-    int status = msStringToInt(value, &max_limit, 10);
-    if(status != MS_SUCCESS) max_limit = OGCAPI_MAX_LIMIT; // conversion failed
-  }
-
-  return max_limit;
-}
-
-static int getDefaultLimit(mapObj *map, layerObj *layer)
-{
-  int default_limit = OGCAPI_DEFAULT_LIMIT;
-
-  // check metadata, layer then map
-  const char* value = msOWSLookupMetadata(&(layer->metadata), "A", "default_limit");
-  if(value == NULL) value = msOWSLookupMetadata(&(map->web.metadata), "A", "default_limit");
-
-  if(value != NULL) {
-    int status = msStringToInt(value, &default_limit, 10);
-    if(status != MS_SUCCESS) default_limit = OGCAPI_DEFAULT_LIMIT; // conversion failed
-  }
-
-  return default_limit;
-}
-
-/*
-** Returns the limit as an int - between 1 and getMaxLimit(). We always return a valid value...
-*/
-static int getLimit(mapObj *map, cgiRequestObj *request, layerObj *layer, int *limit)
-{
-  int status;
-  const char *p;
-
-  int max_limit;
-  max_limit = getMaxLimit(map, layer);
-
-  p = getRequestParameter(request, "limit");
-  if(!p || (p && strlen(p) == 0)) { // missing or empty
-    *limit = MS_MIN(getDefaultLimit(map, layer), max_limit); // max could be smaller than the default
-  } else {
-    status = msStringToInt(p, limit, 10);
-    if(status != MS_SUCCESS)
-      return MS_FAILURE;
-
-    if(*limit <= 0) {
-      *limit = MS_MIN(getDefaultLimit(map, layer), max_limit); // max could be smaller than the default
-    } else {
-      *limit = MS_MIN(*limit, max_limit);
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Returns the bbox in SRS of the map.
-*/
-static bool getBbox(mapObj *map, cgiRequestObj *request, rectObj *bbox)
-{
-  int status;
-  const char *p;
-
-  p = getRequestParameter(request, "bbox");
-  if(!p || (p && strlen(p) == 0)) { // missing or empty - assign map->extent (no projection necessary)
-    bbox->minx = map->extent.minx;
-    bbox->miny = map->extent.miny;
-    bbox->maxx = map->extent.maxx;
-    bbox->maxy = map->extent.maxy;
-  } else {
-    const auto tokens = msStringSplit(p, ',');
-    if(tokens.size() != 4) {
-      return false;
-    }
-
-    double values[4];
-    for(int i=0; i<4; i++) {
-      status = msStringToDouble(tokens[i].c_str(), &values[i]);
-      if(status != MS_SUCCESS) {
-        return false;
-      }
-    }
-
-    bbox->minx = values[0]; // assign
-    bbox->miny = values[1];
-    bbox->maxx = values[2];
-    bbox->maxy = values[3];
-
-    // validate bbox is well-formed (degenerate is ok)
-    if(MS_VALID_SEARCH_EXTENT(*bbox) != MS_TRUE) return false;
-
-    // at the moment we are assuming the bbox is given in lat/lon
-    status = msProjectRect(&map->latlon, &map->projection, bbox);
-    if(status != MS_SUCCESS) return false;
-  }
-
-  return true;
-}
-
-/*
-** Returns the template directory location or NULL if it isn't set.
-*/
-static const char *getTemplateDirectory(mapObj *map, const char *key, const char *envvar)
-{
-  const char *directory;
-
-  // TODO: if directory is provided then perhaps we need to check for a trailing slash
-
-  if((directory = msOWSLookupMetadata(&(map->web.metadata), "A", key)) != NULL) 
-    return directory;
-  else if((directory = CPLGetConfigOption(envvar, NULL)) != NULL)
-    return directory;
-  else
-    return NULL;
-}
-
-/*
-** Returns the service title from oga_{key} and/or ows_{key} or a default value if not set.
-*/
-static const char *getWebMetadata(mapObj *map, const char* domain, const char* key, const char* defaultVal)
-{
-  const char *value;
-
-  if((value = msOWSLookupMetadata(&(map->web.metadata), domain, key)) != NULL)
-    return value;
-  else
-    return defaultVal;
-}
-
-/*
-** Returns the service title from oga|ows_title or a default value if not set.
-*/
-static const char *getTitle(mapObj *map)
-{
-  return getWebMetadata(map, "OA", "title", OGCAPI_DEFAULT_TITLE);
-}
-
-/*
-** Returns the API root URL from oga_onlineresource or builds a value if not set.
-*/
-static std::string getApiRootUrl(mapObj *map)
-{
-  const char *root;
-
-  if((root = msOWSLookupMetadata(&(map->web.metadata), "A", "onlineresource")) != NULL)
-    return std::string(root);
-  else
-    return "http://" + std::string(getenv("SERVER_NAME")) + ":" + std::string(getenv("SERVER_PORT")) + std::string(getenv("SCRIPT_NAME")) + std::string(getenv("PATH_INFO"));
-}
-
-static json getFeatureConstant(const gmlConstantObj *constant)
-{
-  json j; // empty (null)
-
-  if(!constant) throw std::runtime_error("Null constant metadata.");
-  if(!constant->value) return j;
-  
-  // initialize
-  j = { { constant->name, constant->value } };  
-
-  return j;
-}
-
-static json getFeatureItem(const gmlItemObj *item, const char *value)
-{
-  json j; // empty (null)
-  const char *key;
-
-  if(!item) throw std::runtime_error("Null item metadata.");
-  if(!item->visible) return j;
-
-  if(item->alias)
-    key = item->alias;
-  else
-    key = item->name;
-
-  // initialize
-  j = { { key, value } };
-
-  if( item->type && (EQUAL(item->type, "Date") ||
-                     EQUAL(item->type, "DateTime") ||
-                     EQUAL(item->type, "Time")) ) {
-      struct tm tm;
-      if( msParseTime(value, &tm) == MS_TRUE ) {
-          char tmpValue[64];
-          if( EQUAL(item->type, "Date") )
-              snprintf(tmpValue, sizeof(tmpValue),
-                       "%04d-%02d-%02d",
-                       tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday);
-          else if( EQUAL(item->type, "Time") )
-              snprintf(tmpValue, sizeof(tmpValue),
-                       "%02d:%02d:%02dZ",
-                       tm.tm_hour, tm.tm_min, tm.tm_sec);
-          else
-              snprintf(tmpValue, sizeof(tmpValue),
-                       "%04d-%02d-%02dT%02d:%02d:%02dZ",
-                       tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
-                       tm.tm_hour, tm.tm_min, tm.tm_sec);
-
-          j = { { key, tmpValue } };
-      }
-  }
-  else if( item->type && (EQUAL(item->type, "Integer") ||
-                          EQUAL(item->type, "Long")) )
-  {
-      try
-      {
-          j = { { key, std::stoll(value) } };
-      }
-      catch( const std::exception& )
-      {
-      }
-  }
-  else if( item->type && EQUAL(item->type, "Real"))
-  {
-      try
-      {
-          j = { { key, std::stod(value) } };
-      }
-      catch( const std::exception& )
-      {
-      }
-  }
-  else if( item->type && EQUAL(item->type, "Boolean"))
-  {
-      if( EQUAL(value,"0") || EQUAL(value,"false") )
-      {
-          j = { { key, false } };
-      }
-      else
-      {
-          j = { { key, true } };
-      }
-  }
-
-  return j;
-}
-
-static double round_down(double value, int decimal_places) {
-  const double multiplier = std::pow(10.0, decimal_places);
-  return std::floor(value * multiplier) / multiplier;
-}
-// https://stackoverflow.com/questions/25925290/c-round-a-double-up-to-2-decimal-places
-static double round_up(double value, int decimal_places) {
-  const double multiplier = std::pow(10.0, decimal_places);
-  return std::ceil(value * multiplier) / multiplier;
-}
-
-static json getFeatureGeometry(shapeObj *shape, int precision)
-{
-  json geometry; // empty (null)
-  int *outerList=NULL, numOuterRings=0;
-
-  if(!shape) throw std::runtime_error("Null shape.");
-
-  switch(shape->type) {
-  case(MS_SHAPE_POINT):
-    if(shape->numlines == 0 || shape->line[0].numpoints == 0) // not enough info for a point
-      return geometry;
-
-    if(shape->line[0].numpoints == 1) {
-      geometry["type"] = "Point";
-      geometry["coordinates"] = { round_up(shape->line[0].point[0].x, precision), round_up(shape->line[0].point[0].y, precision) };
-    } else {
-      geometry["type"] = "MultiPoint";
-      geometry["coordinates"] = json::array();
-      for(int j=0; j<shape->line[0].numpoints; j++) {
-        geometry["coordinates"].push_back( { round_up(shape->line[0].point[j].x, precision), round_up(shape->line[0].point[j].y, precision) } );
-      }
-    }
-    break;
-  case(MS_SHAPE_LINE):
-    if(shape->numlines == 0 || shape->line[0].numpoints < 2) // not enough info for a line
-      return geometry;
-
-    if(shape->numlines == 1) {
-      geometry["type"] = "LineString";
-      geometry["coordinates"] = json::array();
-      for(int j=0; j<shape->line[0].numpoints; j++) {
-	geometry["coordinates"].push_back( { round_up(shape->line[0].point[j].x, precision), round_up(shape->line[0].point[j].y, precision) } );
-      }
-    } else {
-      geometry["type"] = "MultiLineString";
-      geometry["coordinates"] = json::array();
-      for(int i=0; i<shape->numlines; i++) {
-        json part = json::array();
-        for(int j=0; j<shape->line[i].numpoints; j++) {
-          part.push_back( { round_up(shape->line[i].point[j].x, precision), round_up(shape->line[i].point[j].y, precision) } );
-        }
-        geometry["coordinates"].push_back(part);
-      }
-    }
-    break;
-  case(MS_SHAPE_POLYGON):
-    if(shape->numlines == 0 || shape->line[0].numpoints < 4) // not enough info for a polygon (first=last)
-      return geometry;
-
-    outerList = msGetOuterList(shape);
-    if(outerList == NULL) throw std::runtime_error("Unable to allocate list of outer rings.");
-    for(int k=0; k<shape->numlines; k++) {
-      if(outerList[k] == MS_TRUE)
-	numOuterRings++;
-    }
-
-    if(numOuterRings == 1) {
-      geometry["type"] = "Polygon";
-      geometry["coordinates"] = json::array();
-      for(int i=0; i<shape->numlines; i++) {
-        json part = json::array();
-        for(int j=0; j<shape->line[i].numpoints; j++) {
-          part.push_back( { round_up(shape->line[i].point[j].x, precision), round_up(shape->line[i].point[j].y, precision) } );
-        }
-        geometry["coordinates"].push_back(part);
-      }
-    } else {
-      geometry["type"] = "MultiPolygon";
-      geometry["coordinates"] = json::array();
-
-      for(int k=0; k<shape->numlines; k++) {
-        if(outerList[k] == MS_TRUE) { // outer ring: generate polygon and add to coordinates
-          int *innerList = msGetInnerList(shape, k, outerList);
-          if(innerList == NULL) {
-            msFree(outerList);
-            throw std::runtime_error("Unable to allocate list of inner rings.");
-          }
-
-          json polygon = json::array();
-          for(int i=0; i<shape->numlines; i++) {
-            if(i == k || outerList[i] == MS_TRUE) { // add outer ring (k) and any inner rings
-              json part = json::array();
-              for(int j=0; j<shape->line[i].numpoints; j++) {
-                part.push_back( { round_up(shape->line[i].point[j].x, precision), round_up(shape->line[i].point[j].y, precision) } );
-              }
-              polygon.push_back(part);
-            }
-          }
-
-          msFree(innerList);
-          geometry["coordinates"].push_back(polygon);
-        }
-      }
-    }
-    msFree(outerList);
-    break;
-  default:
-    throw std::runtime_error("Invalid shape type.");
-    break;
-  }
-
-  return geometry;
-}
-
-/*
-** Return a GeoJSON representation of a shape.
-*/
-static json getFeature(layerObj *layer, shapeObj *shape, gmlItemListObj *items, gmlConstantListObj *constants, int geometry_precision)
-{
-  int i;
-  json feature; // empty (null)
-
-  if(!layer || !shape) throw std::runtime_error("Null arguments.");
-
-  // initialize
-  feature = {
-    { "type", "Feature" },
-    { "properties", json::object() }
-  };
-
-  // id
-  const char *featureIdItem = msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
-  if(featureIdItem == NULL) throw std::runtime_error("Missing required featureid metadata."); // should have been trapped earlier
-  for(i=0; i<items->numitems; i++) {
-    if(strcasecmp(featureIdItem, items->items[i].name) == 0) {
-      feature["id"] = shape->values[i];
-      break;
-    }
-  }
-
-  if(i == items->numitems) throw std::runtime_error("Feature id not found.");
-
-  // properties - build from items and constants, no group support for now
-
-  for(int i=0; i<items->numitems; i++) {    
-    try {
-      json item = getFeatureItem(&(items->items[i]), shape->values[i]);
-      if(!item.is_null()) feature["properties"].insert(item.begin(), item.end());
-    } catch (const std::runtime_error &) {
-      throw std::runtime_error("Error fetching item.");
-    }
-  }
-
-  for(int i=0; i<constants->numconstants; i++) {
-    try {
-      json constant = getFeatureConstant(&(constants->constants[i]));
-      if(!constant.is_null()) feature["properties"].insert(constant.begin(), constant.end());
-    } catch (const std::runtime_error &) {
-      throw std::runtime_error("Error fetching constant.");  
-    }
-  }
-
-  // geometry
-  try {
-    json geometry = getFeatureGeometry(shape, geometry_precision);
-    if(!geometry.is_null()) feature["geometry"] = geometry;
-  } catch (const std::runtime_error &) {
-    throw std::runtime_error("Error fetching geometry.");
-  }
-
-  return feature;
-}
-
-static json getLink(hashTableObj *metadata, const std::string& name)
-{
-  json link;
-
-  const char *href = msOWSLookupMetadata(metadata, "A", (name + "_href").c_str());
-  if(!href) throw std::runtime_error("Missing required link href property.");
-
-  const char *title = msOWSLookupMetadata(metadata, "A", (name + "_title").c_str());
-  const char *type = msOWSLookupMetadata(metadata, "A", (name + "_type").c_str());
-
-  link = {
-    { "href", href },
-    { "title", title?title:href },
-    { "type", type?type:"text/html" }
-  };
-
-  return link;
-}
-
-static const char* getCollectionDescription(layerObj* layer)
-{
-  const char *description = msOWSLookupMetadata(&(layer->metadata), "A", "description");
-  if(!description) description = msOWSLookupMetadata(&(layer->metadata), "OF", "abstract"); // fallback on abstract
-  if(!description) description = "<!-- Warning: unable to set the collection description. -->"; // finally a warning...
-  return description;
-}
-
-static const char* getCollectionTitle(layerObj* layer)
-{
-    const char* title = msOWSLookupMetadata(&(layer->metadata), "AOF", "title");
-    if(!title) title = layer->name; // revert to layer name if no title found
-    return title;
-}
-
-static int getGeometryPrecision(mapObj *map, layerObj *layer)
-{
-    int geometry_precision = OGCAPI_DEFAULT_GEOMETRY_PRECISION;
-    if(msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision")) {
-      geometry_precision = atoi(msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision"));
-    } else if(msOWSLookupMetadata(&map->web.metadata, "AF", "geometry_precision")) {
-      geometry_precision = atoi(msOWSLookupMetadata(&map->web.metadata, "AF", "geometry_precision"));
-    }
-    return geometry_precision;
-}
-
-static json getCollection(mapObj *map, layerObj *layer, OGCAPIFormat format)
-{
-  json collection; // empty (null)
-  rectObj bbox;
-
-  if(!map || !layer) return collection;
-
-  if(!includeLayer(map, layer)) return collection;
-
-  // initialize some things
-  std::string api_root = getApiRootUrl(map);
-
-  if(msOWSGetLayerExtent(map, layer, "AOF", &bbox) == MS_SUCCESS) {
-    if (layer->projection.numargs > 0)
-      msOWSProjectToWGS84(&layer->projection, &bbox);
-    else if (map->projection.numargs > 0)
-      msOWSProjectToWGS84(&map->projection, &bbox);
-    else
-      throw std::runtime_error("Unable to transform bounding box, no projection defined.");
-  } else {
-    throw std::runtime_error("Unable to get collection bounding box."); // might be too harsh since extent is optional
-  }
-
-  const char *description = getCollectionDescription(layer);
-  const char *title = getCollectionTitle(layer);
-
-  const char *id = layer->name;
-  char *id_encoded = msEncodeUrl(id); // free after use
-
-  const int geometry_precision = getGeometryPrecision(map, layer);
-
-  // build collection object
-  collection = {
-    { "id", id },
-    { "description", description },
-    { "title", title },
-    { "extent", {
-        { "spatial", {
-            { "bbox", {{ round_down(bbox.minx, geometry_precision),
-                         round_down(bbox.miny, geometry_precision),
-                         round_up(bbox.maxx, geometry_precision),
-                         round_up(bbox.maxy, geometry_precision) }}},
-            { "crs", "http://www.opengis.net/def/crs/OGC/1.3/CRS84" }
-          }
-        }
-      }
-    },
-    { "links", {
-        {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This collection as JSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=json" }
-        },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This collection as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=html" }
-        },{
-          { "rel", "items" },
-          { "type", OGCAPI_MIMETYPE_GEOJSON },
-          { "title", "Items for this collection as GeoJSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=json" }
-        },{
-          { "rel", "items" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "Items for this collection as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=html" }
-        }
-
-      }
-    },
-    { "itemType", "feature" }
-  };
-
-  msFree(id_encoded); // done
-
-  // handle optional configuration (keywords and links)
-  const char *value = msOWSLookupMetadata(&(layer->metadata), "A", "keywords");
-  if(!value) value = msOWSLookupMetadata(&(layer->metadata), "OF", "keywordlist"); // fallback on keywordlist
-  if(value) {
-    std::vector<std::string> keywords = msStringSplit(value, ',');
-    for(std::string keyword : keywords) {
-      collection["keywords"].push_back(keyword);
-    }
-  }
-
-  value = msOWSLookupMetadata(&(layer->metadata), "A", "links");
-  if(value) {
-    std::vector<std::string> names = msStringSplit(value, ',');
-    for(std::string name : names) {
-      try {
-        json link = getLink(&(layer->metadata), name);
-        collection["links"].push_back(link);
-      } catch(const std::runtime_error &e) {
-        throw e;
-      }
-    }
-  }
-
-  return collection;
-}
-
-/*
-** Output stuff...
-*/
-
-static void outputJson(const json& j, const char *mimetype)
-{
-  std::string js;
-
-  try {
-    js = j.dump();
-  } catch (...) {
-    outputError(OGCAPI_CONFIG_ERROR, "Invalid UTF-8 data, check encoding.");
-    return;
-  }
-
-  msIO_setHeader("Content-Type", "%s", mimetype);
-  msIO_sendHeaders();
-  msIO_printf("%s\n", js.c_str());
-}
-
-static void outputTemplate(const char *directory, const char *filename, const json& j, const char *mimetype)
-{
-  std::string _directory(directory);
-  std::string _filename(filename);
-  Environment env {_directory}; // catch
-
-  // ERB-style instead of Mustache (we'll see)
-  // env.set_expression("<%=", "%>");
-  // env.set_statement("<%", "%>");
-
-  // callbacks, need:
-  //   - match (regex)
-  //   - contains (substring)
-  //   - URL encode
-
-  try {
-    std::string js = j.dump();
-  } catch (...) {
-    outputError(OGCAPI_CONFIG_ERROR, "Invalid UTF-8 data, check encoding.");
-    return;
-  }
-
-  try {
-    Template t = env.parse_template(_filename); // catch
-    std::string result = env.render(t, j);
-
-    msIO_setHeader("Content-Type", "%s", mimetype);
-    msIO_sendHeaders();
-    msIO_printf("%s\n", result.c_str()); 
-  } catch(const inja::RenderError &e) {
-    outputError(OGCAPI_CONFIG_ERROR, "Template rendering error. " + std::string(e.what()) + " (" + std::string(filename) + ").");
-    return;
-  }
-    catch (const inja::InjaError& e) {
-        outputError(OGCAPI_CONFIG_ERROR, "InjaError error. " + std::string(e.what()) + " (" + std::string(filename) + ")."
-            + " (" + std::string(directory) + ").");
-        return;
-  } catch(...) {
-    outputError(OGCAPI_SERVER_ERROR, "General template handling error.");
-    return;
-  }
-}
-
-/*
-** Generic response outputr.
-*/
-static void outputResponse(mapObj *map, cgiRequestObj *request, OGCAPIFormat format, const char *filename, const json& response)
-{
-  const char *path = NULL;
-  char fullpath[MS_MAXPATHLEN];
-
-  if(format == OGCAPIFormat::JSON) {
-    outputJson(response, OGCAPI_MIMETYPE_JSON);
-  } else if(format == OGCAPIFormat::GeoJSON) {
-    outputJson(response, OGCAPI_MIMETYPE_GEOJSON);
-  } else if(format == OGCAPIFormat::OpenAPI_V3) {
-    outputJson(response, OGCAPI_MIMETYPE_OPENAPI_V3);
-  } else if(format == OGCAPIFormat::HTML) {
-    if((path = getTemplateDirectory(map, "html_template_directory", "OGCAPI_HTML_TEMPLATE_DIRECTORY")) == NULL) {
-      outputError(OGCAPI_CONFIG_ERROR, "Template directory not set.");
-      return; // bail
-    }
-    msBuildPath(fullpath, map->mappath, path);
-
-    json j;
-
-    j["response"] = response; // nest the response so we could write the whole object in the template
-
-    // extend the JSON with a few things that we need for templating
-    j["template"] = {
-      { "path", json::array() },
-      { "params", json::object() },
-      { "api_root", getApiRootUrl(map) },
-      { "title", getTitle(map) },
-      { "tags", json::object() }
-    };
-
-    // api path
-    for( int i=0; i<request->api_path_length; i++ )
-      j["template"]["path"].push_back(request->api_path[i]);
-
-    // parameters (optional)
-    for( int i=0; i<request->NumParams; i++) {
-      if(request->ParamValues[i] && strlen(request->ParamValues[i]) > 0) { // skip empty params
-        j["template"]["params"].update({{ request->ParamNames[i], request->ParamValues[i] }});
-      }
-    }
-
-    // add custom tags (optional)
-    const char *tags = msOWSLookupMetadata(&(map->web.metadata), "A", "html_tags");
-    if(tags) {
-      std::vector<std::string> names = msStringSplit(tags, ',');
-      for(std::string name : names) {
-        const char *value = msOWSLookupMetadata(&(map->web.metadata), "A", ("tag_" + name).c_str());
-        if(value) {
-              j["template"]["tags"].update({{ name, value }}); // add object
-        }
-      }
-    }
-
-    outputTemplate(fullpath, filename, j, OGCAPI_MIMETYPE_HTML);
-  } else {
-    outputError(OGCAPI_PARAM_ERROR, "Unsupported format requested.");
-  }
-}
-
-/*
-** Process stuff...
-*/
-static int processLandingRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
-  json response;
-
-  // define ambiguous elements
-  const char *description = msOWSLookupMetadata(&(map->web.metadata), "A", "description");
-  if(!description) description = msOWSLookupMetadata(&(map->web.metadata), "OF", "abstract"); // fallback on abstract if necessary
-
-  // define api root url
-  std::string api_root = getApiRootUrl(map);
-
-  // build response object
-  //   - consider conditionally excluding links for HTML format
-  response =  {
-    { "title", getTitle(map) },
-    { "description", description?description:"" },
-    { "links", {
-        {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This document as JSON" },
-          { "href", api_root + "?f=json" }
-        },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This document as HTML" },
-          { "href", api_root + "?f=html" }
-        },{
-          { "rel", "conformance" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "OCG API conformance classes implemented by this server (JSON)" },
-          { "href", api_root + "/conformance?f=json" }
-        },{
-          { "rel", "conformance" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "OCG API conformance classes implemented by this server" },
-          { "href", api_root + "/conformance?f=html" }
-        },{
-          { "rel", "data" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "Information about feature collections available from this server (JSON)" },
-          { "href", api_root + "/collections?f=json" }
-        },{
-          { "rel", "data" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "Information about feature collections available from this server" },
-          { "href", api_root + "/collections?f=html" }
-        },{
-          { "rel", "service-desc" },
-          { "type", OGCAPI_MIMETYPE_OPENAPI_V3 },
-          { "title", "OpenAPI document" },
-          { "href", api_root + "/api?f=json" }
-        },{
-          { "rel", "service-doc" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "API documentation" },
-          { "href", api_root + "/api?f=html" }
-        }
-      }
-    }
-  };
-
-  // handle custom links (optional)
-  const char *links = msOWSLookupMetadata(&(map->web.metadata), "A", "links");
-  if(links) {
-    std::vector<std::string> names = msStringSplit(links, ',');
-    for(std::string name : names) {
-      try {
-        json link = getLink(&(map->web.metadata), name);
-        response["links"].push_back(link);
-      } catch(const std::runtime_error &e) {
-        outputError(OGCAPI_CONFIG_ERROR, std::string(e.what()));
-        return MS_SUCCESS;
-      }
-    }
-  }
-
-  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_LANDING, response);
-  return MS_SUCCESS;
-}
-
-static int processConformanceRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
-  json response;
- 
-  // build response object
-  response = {
-    { "conformsTo", {
-        "http://www.opengis.net/spec/ogcapi-common-1/1.0/conf/core",
-        "http://www.opengis.net/spec/ogcapi-common-2/1.0/conf/collections",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/core",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/oas30",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/html",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/geojson",
-      }
-    }
-  };
-
-  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_CONFORMANCE, response);
-  return MS_SUCCESS;
-}
-
-static int processCollectionItemsRequest(mapObj *map, cgiRequestObj *request, const char *collectionId, const char *featureId, OGCAPIFormat format)
-{
-  json response;
-  int i;
-  layerObj *layer;
-
-  int limit;
-  rectObj bbox;
-
-  int numberMatched = 0;
-
-  // find the right layer
-  for(i=0; i<map->numlayers; i++) {
-    if(strcmp(map->layers[i]->name, collectionId) == 0) break; // match
-  }
-
-  if(i == map->numlayers) { // invalid collectionId
-    outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
-    return MS_SUCCESS;
-  }
-
-  layer = map->layers[i]; // for convenience
-  layer->status = MS_ON; // force on (do we need to save and reset?)
-
-  if(!includeLayer(map, layer)) {
-    outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
-    return MS_SUCCESS;
-  }
-
-  //
-  // handle parameters specific to this endpoint
-  //
-  if(getLimit(map, request, layer, &limit) != MS_SUCCESS) {
-    outputError(OGCAPI_PARAM_ERROR, "Bad value for limit.");
-    return MS_SUCCESS;
-  }
-
-  if(!getBbox(map, request, &bbox)) {
-    outputError(OGCAPI_PARAM_ERROR, "Bad value for bbox.");
-    return MS_SUCCESS;
-  }
-
-  int offset = 0;
-  if(featureId) {
-    const char *featureIdItem = msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
-    if(featureIdItem == NULL) {
-      outputError(OGCAPI_CONFIG_ERROR, "Missing required featureid metadata.");
-      return MS_SUCCESS;
-    }
-
-    // TODO: does featureIdItem exist in the data?
-
-    // optional validation
-    const char *featureIdValidation = msLookupHashTable(&(layer->validation), featureIdItem);
-    if(featureIdValidation && msValidateParameter(featureId, featureIdValidation, NULL, NULL, NULL) != MS_SUCCESS) {
-      outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid feature id.");
-      return MS_SUCCESS;
-    }
-
-    map->query.type = MS_QUERY_BY_FILTER;
-    map->query.mode = MS_QUERY_SINGLE;
-    map->query.layer = i;
-    map->query.rect = bbox;
-    map->query.filteritem = strdup(featureIdItem);
-
-    msInitExpression(&map->query.filter);
-    map->query.filter.type = MS_STRING;
-    map->query.filter.string = strdup(featureId);
-
-    if(msExecuteQuery(map) != MS_SUCCESS) {
-      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items id query failed.");
-      return MS_SUCCESS;
-    }
-
-    if(!layer->resultcache || layer->resultcache->numresults != 1) {
-      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items id query failed.");
-      return MS_SUCCESS;
-    }
-  } else { // bbox query
-
-    const char *compliance_mode = msOWSLookupMetadata(&(map->web.metadata), "A", "compliance_mode");
-    if(compliance_mode != NULL && strcasecmp(compliance_mode, "true") == 0) {
-      for(int j=0; j<request->NumParams; j++) {
-        const char* paramName = request->ParamNames[j];
-        if (strcmp(paramName, "f") == 0 ||
-            strcmp(paramName, "bbox") == 0 ||
-            strcmp(paramName, "datetime") == 0 ||
-            strcmp(paramName, "limit") == 0 ||
-            strcmp(paramName, "offset") == 0)
-        {
-          // ok
-        }
-        else
-        {
-          outputError(OGCAPI_PARAM_ERROR,
-              (std::string("Unknown query parameter: ") + paramName).c_str());
-          return MS_SUCCESS;
-        }
-      }
-    }
-
-    map->query.type = MS_QUERY_BY_RECT;
-    map->query.mode = MS_QUERY_MULTIPLE;
-    map->query.layer = i;
-    map->query.rect = bbox;
-    map->query.only_cache_result_count = MS_TRUE;
-
-    // get number matched
-    if(msExecuteQuery(map) != MS_SUCCESS) {
-      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
-      return MS_SUCCESS;
-    }
-
-    if(!layer->resultcache) {
-      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
-      return MS_SUCCESS;
-    }
-
-    numberMatched = layer->resultcache->numresults;
-
-    if( numberMatched > 0 ) {
-        map->query.only_cache_result_count = MS_FALSE;
-        map->query.maxfeatures = limit;
-
-        const char* offsetStr = getRequestParameter(request, "offset");
-        if( offsetStr )
-        {
-            if( msStringToInt(offsetStr, &offset, 10) != MS_SUCCESS )
-            {
-              outputError(OGCAPI_PARAM_ERROR, "Bad value for offset.");
-              return MS_SUCCESS;
-            }
-
-            if(offset < 0 || offset >= numberMatched) {
-              outputError(OGCAPI_PARAM_ERROR, "Offset out of range.");
-              return MS_SUCCESS;
-            }
-
-            // msExecuteQuery() use a 1-based offset convention, whereas the API
-            // uses a 0-based offset convention.
-            map->query.startindex = 1 + offset;
-            layer->startindex = 1 + offset;
-        }
-
-        if(msExecuteQuery(map) != MS_SUCCESS) {
-          outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
-          return MS_SUCCESS;
-        }
-    }
-  }
-
-  // build response object
-  if(!featureId) {
-    std::string api_root = getApiRootUrl(map);
-    const char *id = layer->name;
-    char *id_encoded = msEncodeUrl(id); // free after use
-
-    std::string extra_kvp = "&limit=" + std::to_string(limit);
-    extra_kvp += "&offset=" + std::to_string(offset);
-
-    response = {
-      { "type", "FeatureCollection" },
-      { "numberMatched", numberMatched },
-      { "numberReturned", layer->resultcache->numresults },
-      { "features", json::array() },
-      { "links", {
-          {
-              { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-              { "type", OGCAPI_MIMETYPE_GEOJSON },
-              { "title", "Items for this collection as GeoJSON" },
-              { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=json" + extra_kvp }
-          },{
-              { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-              { "type", OGCAPI_MIMETYPE_HTML },
-              { "title", "Items for this collection as HTML" },
-              { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=html" + extra_kvp }
-          }
-      }}
-    };
-
-    if( offset + layer->resultcache->numresults < numberMatched )
-    {
-        response["links"].push_back({
-            { "rel", "next" },
-            { "type", format==OGCAPIFormat::JSON? OGCAPI_MIMETYPE_GEOJSON : OGCAPI_MIMETYPE_HTML },
-            { "title", "next page" },
-            { "href", api_root + "/collections/" + std::string(id_encoded) +
-                      "/items?f=" + (format==OGCAPIFormat::JSON? "json" : "html") +
-                      "&limit=" + std::to_string(limit) +
-                      "&offset=" + std::to_string(offset + limit) }
-        });
-    }
-
-    if( offset > 0 ) 
-    {
-        response["links"].push_back({
-	    { "rel", "prev" },
-            { "type", format==OGCAPIFormat::JSON? OGCAPI_MIMETYPE_GEOJSON : OGCAPI_MIMETYPE_HTML },
-	    { "title", "previous page" },
-	    { "href", api_root + "/collections/" + std::string(id_encoded) +
-	              "/items?f=" + (format==OGCAPIFormat::JSON? "json" : "html") +
-		      "&limit=" + std::to_string(limit) +
-		      "&offset=" + std::to_string(MS_MAX(0, (offset - limit))) }
-	});
-    }
-
-    msFree(id_encoded); // done
-  }
-
-  // features (items)
-  {
-    shapeObj shape;
-    msInitShape(&shape);
-
-    // we piggyback on GML configuration
-    gmlItemListObj *items = msGMLGetItems(layer, "AG");
-    gmlConstantListObj *constants = msGMLGetConstants(layer, "AG");
-
-    if(!items || !constants) {
-      msGMLFreeItems(items);
-      msGMLFreeConstants(constants);
-      outputError(OGCAPI_SERVER_ERROR, "Error fetching layer attribute metadata.");
-      return MS_SUCCESS;
-    }
-
-    const int geometry_precision = getGeometryPrecision(map, layer);
-
-    // reprojection to EPSG:4326 (if necessary)
-    reprojectionObj *reprojector = NULL;
-    if(layer->projection.numargs > 0) { 
-      if(msProjectionsDiffer(&(layer->projection), &(map->latlon))) {
-        reprojector = msProjectCreateReprojector(&(layer->projection), &(map->latlon));
-        if(reprojector == NULL) {
-          msGMLFreeItems(items);
-          msGMLFreeConstants(constants);
-          outputError(OGCAPI_SERVER_ERROR, "Error creating re-projector.");
-          return MS_SUCCESS;
-        }
-      }
-    } else if(map->projection.numargs > 0) {
-      if(msProjectionsDiffer(&(map->projection), &(map->latlon))) {
-        reprojector = msProjectCreateReprojector(&(map->projection), &(map->latlon));
-        if(reprojector == NULL) {
-	  msGMLFreeItems(items);
-          msGMLFreeConstants(constants);
-	  outputError(OGCAPI_SERVER_ERROR, "Error creating re-projector.");
-          return MS_SUCCESS;
-        }
-      }
-    } else {
-      outputError(OGCAPI_CONFIG_ERROR, "Unable to transform geometries, no projection defined.");
-      return MS_SUCCESS;
-    }
-
-    for(i=0; i<layer->resultcache->numresults; i++) {
-      int status = msLayerGetShape(layer, &shape, &(layer->resultcache->results[i]));
-      if(status != MS_SUCCESS) {
-        msGMLFreeItems(items);
-        msGMLFreeConstants(constants);
-        msProjectDestroyReprojector(reprojector);
-        outputError(OGCAPI_SERVER_ERROR, "Error fetching feature.");
-        return MS_SUCCESS;
-      }
-
-      if(reprojector) {
-        status = msProjectShapeEx(reprojector, &shape);
-        if(status != MS_SUCCESS) {
-          msGMLFreeItems(items);
-          msGMLFreeConstants(constants);
-          msProjectDestroyReprojector(reprojector);
-          msFreeShape(&shape);
-          outputError(OGCAPI_SERVER_ERROR, "Error reprojecting feature.");
-          return MS_SUCCESS;
-        }
-      }
-
-      try {
-        json feature = getFeature(layer, &shape, items, constants, geometry_precision);
-        if(featureId) {
-          response = feature;
-        } else {
-          response["features"].push_back(feature);
-        }
-      } catch (const std::runtime_error &e) {
-        msGMLFreeItems(items);
-        msGMLFreeConstants(constants);
-        msProjectDestroyReprojector(reprojector);
-        msFreeShape(&shape);
-        outputError(OGCAPI_SERVER_ERROR, "Error getting feature. " + std::string(e.what()));
-        return MS_SUCCESS;
-      }
-
-      msFreeShape(&shape); // next
-    }
-
-    msGMLFreeItems(items); // clean up
-    msGMLFreeConstants(constants);
-    msProjectDestroyReprojector(reprojector);
-  }
-
-  // extend the response a bit for templating (HERE)
-  if(format == OGCAPIFormat::HTML) {
-    const char *title = getCollectionTitle(layer);
-    const char *id = layer->name;
-    response["collection"] = {
-      { "id", id },
-      { "title", title?title:"" }
-    };
-  }
-
-  if(featureId)
-  {
-    std::string api_root = getApiRootUrl(map);
-    const char *id = layer->name;
-    char *id_encoded = msEncodeUrl(id); // free after use
-
-    response["links"] = {
-      {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_GEOJSON },
-          { "title", "This document as GeoJSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) +
-              "/items/" + featureId + "?f=json" }
-      },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This document as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) +
-              "/items/" + featureId + "?f=html" }
-      },{
-          { "rel", "collection" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This collection as JSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=json" }
-      },{
-          { "rel", "collection" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This collection as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=html" }
-      }
-    };
-
-    msFree(id_encoded);
-
-    outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION_ITEM, response);
-  }
-  else
-    outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION_ITEMS, response);
-  return MS_SUCCESS;
-}
-
-static int processCollectionRequest(mapObj *map, cgiRequestObj *request, const char *collectionId, OGCAPIFormat format)
-{
-  json response;
-  int l;
-
-  for(l=0; l<map->numlayers; l++) {
-    if(strcmp(map->layers[l]->name, collectionId) == 0) break; // match
-  }
-
-  if(l == map->numlayers) { // invalid collectionId
-    outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
-    return MS_SUCCESS;
-  }
-
-  try {
-    response = getCollection(map, map->layers[l], format);
-    if(response.is_null()) { // same as not found
-      outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
-      return MS_SUCCESS;
-    }
-  } catch (const std::runtime_error &e) {
-    outputError(OGCAPI_CONFIG_ERROR, "Error getting collection. " + std::string(e.what()));
-    return MS_SUCCESS;
-  }
-
-  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION, response);
-  return MS_SUCCESS;
-}
-
-static int processCollectionsRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
-  json response;
-  int i;
-
-  // define api root url
-  std::string api_root = getApiRootUrl(map);
-
-  // build response object
-  response = {
-    { "links", {
-        {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This document as JSON" },
-          { "href", api_root + "/collections?f=json" }
-        },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This document as HTML" },
-          { "href", api_root + "/collections?f=html" }
-        }
-      }
-    },{
-      "collections", json::array()
-    }
-  };
-
-  for(i=0; i<map->numlayers; i++) {
-    try {
-      json collection = getCollection(map, map->layers[i], format);
-      if(!collection.is_null()) response["collections"].push_back(collection);
-    } catch (const std::runtime_error &e) {
-      outputError(OGCAPI_CONFIG_ERROR, "Error getting collection." + std::string(e.what()));
-      return MS_SUCCESS;
-    }
-  }
-
-  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTIONS, response);
-  return MS_SUCCESS;
-}
-
-static int processApiRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
-  // Strongly inspired from https://github.com/geopython/pygeoapi/blob/master/pygeoapi/openapi.py
-
-  json response;
-
-  response = {
-      { "openapi", "3.0.2" },
-      { "tags", json::array() },
-  };
-
-  response["info"] = {
-      { "title", getTitle(map) },
-      { "version", getWebMetadata(map, "A", "version", "1.0.0") },
-  };
-
-  for( const char* item: { "description", "termsOfService" }) {
-      const char* value = getWebMetadata(map, "AO", item, nullptr);
-      if( value ) {
-          response["info"][item] = value;
-      }
-  }
-
-  for( const auto& pair: {
-          std::make_pair("name", "contactperson"),
-          std::make_pair("url", "contacturl"),
-          std::make_pair("email", "contactelectronicmailaddress"),
-        }) {
-      const char* value = getWebMetadata(map, "AO", pair.second, nullptr);
-      if( value ) {
-          response["info"]["contact"][pair.first] = value;
-      }
-  }
-
-  for( const auto& pair: {
-          std::make_pair("name", "licensename"),
-          std::make_pair("url", "licenseurl"),
-        }) {
-      const char* value = getWebMetadata(map, "AO", pair.second, nullptr);
-      if( value ) {
-          response["info"]["license"][pair.first] = value;
-      }
-  }
-
-  {
-      const char* value = getWebMetadata(map, "AO", "keywords", nullptr);
-      if( value ) {
-          response["info"]["x-keywords"] = value;
-      }
-  }
-
-  json server;
-  server["url"] = getApiRootUrl(map);
-  {
-      const char* value = getWebMetadata(map, "AO", "server_description", nullptr);
-      if( value ) {
-          server["description"] = value;
-      }
-  }
-  response["servers"].push_back(server);
-
-  const std::string oapif_yaml_url = "http://schemas.opengis.net/ogcapi/features/part1/1.0/openapi/ogcapi-features-1.yaml";
-
-  json paths;
-
-  paths["/"]["get"] = {
-      { "summary", "Landing page" },
-      { "description", "Landing page" },
-      { "tags", { "server" } },
-      { "operationId", "getLandingPage" },
-        { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", oapif_yaml_url + "#/components/responses/LandingPage"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-      }}
-  };
-
-  paths["/api"]["get"] = {
-      { "summary", "API documentation" },
-      { "description", "API documentation" },
-      { "tags", { "server" } },
-      { "operationId", "getOpenapi" },
-      { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", "#/components/responses/200"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "default", {{"$ref", "#/components/responses/default"}} }
-      }}
-  };
-
-  paths["/conformance"]["get"] = {
-      { "summary", "API conformance definition" },
-      { "description", "API conformance definition" },
-      { "tags", { "server" } },
-      { "operationId", "getConformanceDeclaration" },
-      { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", oapif_yaml_url + "#/components/responses/ConformanceDeclaration"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-      }}
-  };
-
-  paths["/collections"]["get"] = {
-      { "summary", "Collections" },
-      { "description", "Collections" },
-      { "tags", { "server" } },
-      { "operationId", "getCollections" },
-      { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Collections"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-      }}
-  };
-
-  for(int i=0; i<map->numlayers; i++) {
-      layerObj* layer = map->layers[i];
-      if(!includeLayer(map, layer)) {
-          continue;
-      }
-
-      json collection_get = {
-          { "summary", std::string("Get ") + getCollectionTitle(layer) + " metadata" },
-          { "description", getCollectionDescription(layer) },
-          { "tags", { layer->name } },
-          { "operationId", "describe" + std::string(layer->name) + "Collection" },
-          { "parameters", {
-              {{ "$ref", "#/components/parameters/f"}},
-          }},
-          { "responses", {
-              { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Collection"}} },
-              { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-              { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-          }}
-      };
-
-      std::string collectionNamePath("/collections/");
-      collectionNamePath += layer->name;
-      paths[collectionNamePath]["get"] = collection_get;
-
-      // check metadata, layer then map
-      const char* max_limit_str = msOWSLookupMetadata(&(layer->metadata), "A", "max_limit");
-      if(max_limit_str == nullptr)
-          max_limit_str = msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
-      const int max_limit = max_limit_str ? atoi(max_limit_str) : OGCAPI_MAX_LIMIT;
-      const int default_limit = getDefaultLimit(map, layer);
-
-      json items_get = {
-          { "summary", std::string("Get ") + getCollectionTitle(layer) + " items" },
-          { "description", getCollectionDescription(layer) },
-          { "tags", { layer->name } },
-          { "operationId", "get" + std::string(layer->name) + "Features" },
-          { "parameters", {
-              {{ "$ref", "#/components/parameters/f"}},
-              {{ "$ref", oapif_yaml_url + "#/components/parameters/bbox"}},
-              {{ "$ref", oapif_yaml_url + "#/components/parameters/datetime"}},
-              {{ "$ref", "#/components/parameters/offset"}},
-          }},
-          { "responses", {
-              { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Features"}} },
-              { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-              { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-          }}
-      };
-
-      json param_limit = {
-        { "name", "limit"},
-        { "in", "query"},
-        { "description", "The optional limit parameter limits the number of items that are presented in the response document."},
-        { "required", false},
-        { "schema", {
-            { "type", "integer"},
-            { "minimum", 1},
-            { "maximum", max_limit},
-            { "default", default_limit},
-        }},
-        { "style", "form" },
-        { "explode", false },
-      };
-      items_get["parameters"].emplace_back(param_limit);
-
-      std::string itemsPath(collectionNamePath + "/items");
-      paths[itemsPath]["get"] = items_get;
-
-      json feature_id_get = {
-          { "summary", std::string("Get ") + getCollectionTitle(layer) + " item by id" },
-          { "description", getCollectionDescription(layer) },
-          { "tags", { layer->name } },
-          { "operationId", "get" + std::string(layer->name) + "Feature" },
-          { "parameters", {
-              {{ "$ref", "#/components/parameters/f"}},
-              {{ "$ref", oapif_yaml_url + "#/components/parameters/featureId"}},
-          }},
-          { "responses", {
-              { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Feature"}} },
-              { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-              { "404", {{"$ref", oapif_yaml_url + "#/components/responses/NotFound"}} },
-              { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-          }}
-      };
-      std::string itemsFeatureIdPath(collectionNamePath + "/items/{featureId}");
-      paths[itemsFeatureIdPath]["get"] = feature_id_get;
-  }
-
-  response["paths"] = paths;
-
-  json components;
-  components["responses"]["200"] = {
-      { "description", "successful operation" }
-  };
-  components["responses"]["default"] = {
-      { "description", "unexpected error" },
-      { "content", {
-          { "application/json", {
-              { "schema", {
-                  { "$ref", "https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/exception.yaml" }
-              }}
-          }}
-      }}
-  };
-
-  json parameters;
-  parameters["f"] = {
-    { "name", "f"},
-    { "in", "query"},
-    { "description", "The optional f parameter indicates the output format which the server shall provide as part of the response document.  The default format is GeoJSON."},
-    { "required", false},
-    { "schema", {
-        { "type", "string"},
-            {"enum", {"json", "html"}},
-            {"default", "json"}
-    }},
-    { "style", "form" },
-    { "explode", false },
-  };
-
-  parameters["offset"] = {
-    { "name", "offset"},
-    { "in", "query"},
-    { "description", "The optional offset parameter indicates the index within the result set from which the server shall begin presenting results in the response document.  The first element has an index of 0 (default)."},
-    { "required", false},
-    { "schema", {
-        { "type", "integer"},
-        { "minimum", 0},
-        { "default", 0},
-    }},
-    { "style", "form" },
-    { "explode", false },
-  };
-
-  components["parameters"] = parameters;
-
-  response["components"] = components;
-
-  // TODO: "tags" array ?
-
-  outputResponse(map, request,
-                 format == OGCAPIFormat::JSON ? OGCAPIFormat::OpenAPI_V3 : format,
-                 OGCAPI_TEMPLATE_HTML_OPENAPI, response);
-  return MS_SUCCESS;
-}
-
-#endif
-
-int msOGCAPIDispatchRequest(mapObj *map, cgiRequestObj *request)
-{
-#ifdef USE_OGCAPI_SVR
-
-  // make sure ogcapi requests are enabled for this map
-  int status = msOWSRequestIsEnabled(map, NULL, "AO", "OGCAPI", MS_FALSE);
-  if(status != MS_TRUE) {
-    msSetError(MS_OGCAPIERR, "OGC API requests are not enabled.", "msCGIDispatchAPIRequest()");
-    return MS_FAILURE; // let normal error handling take over
-  }
-
-  OGCAPIFormat format; // all endpoints need a format
-  const char *p = getRequestParameter(request, "f");
-
-  // if f= query parameter is not specified, use HTTP Accept header if available
-  if( p == nullptr )
-  {
-      const char* accept = getenv("HTTP_ACCEPT");
-      if( accept )
-      {
-          if( strcmp(accept, "*/*") == 0 )
-              p = OGCAPI_MIMETYPE_JSON;
-          else
-              p = accept;
-      }
-  }
-
-  if(p && (strcmp(p, "json") == 0 ||
-           strstr(p, OGCAPI_MIMETYPE_JSON) != nullptr ||
-           strstr(p, OGCAPI_MIMETYPE_GEOJSON) != nullptr ||
-           strstr(p, OGCAPI_MIMETYPE_OPENAPI_V3) != nullptr)) {
-    format = OGCAPIFormat::JSON;
-  } else if(p && (strcmp(p, "html") == 0 ||
-                  strstr(p, OGCAPI_MIMETYPE_HTML) != nullptr)) {
-    format = OGCAPIFormat::HTML;
-  } else if(p) {
-    std::string errorMsg("Unsupported format requested: ");
-    errorMsg += p;
-    outputError(OGCAPI_PARAM_ERROR, errorMsg.c_str());
-    return MS_SUCCESS; // avoid any downstream MapServer processing
-  } else {
-    format = OGCAPIFormat::HTML; // default for now
-  }
-
-  if(request->api_path_length == 2) {
-
-    return processLandingRequest(map, request, format);
-
-  } else if(request->api_path_length == 3) {
-
-    if(strcmp(request->api_path[2], "conformance") == 0) {
-      return processConformanceRequest(map, request, format);
-    } else if(strcmp(request->api_path[2], "conformance.html") == 0) {
-      return processConformanceRequest(map, request, OGCAPIFormat::HTML);
-    } else if(strcmp(request->api_path[2], "collections") == 0) {
-      return processCollectionsRequest(map, request, format);
-    } else if(strcmp(request->api_path[2], "collections.html") == 0) {
-      return processCollectionsRequest(map, request, OGCAPIFormat::HTML);
-    } else if(strcmp(request->api_path[2], "api") == 0) {
-      return processApiRequest(map, request, format);
-    }
-
-  } else if(request->api_path_length == 4) {
-
-    if(strcmp(request->api_path[2], "collections") == 0) { // next argument (3) is collectionId
-      return processCollectionRequest(map, request, request->api_path[3], format);
-    }
-
-  } else if(request->api_path_length == 5) {
-
-    if(strcmp(request->api_path[2], "collections") == 0 && strcmp(request->api_path[4], "items") == 0)  { // middle argument (3) is the collectionId
-      return processCollectionItemsRequest(map, request, request->api_path[3], NULL, format);
-    }
-
-  } else if(request->api_path_length == 6) {
-
-    if(strcmp(request->api_path[2], "collections") == 0 && strcmp(request->api_path[4], "items") == 0)  { // middle argument (3) is the collectionId, last argument (5) is featureId
-      return processCollectionItemsRequest(map, request, request->api_path[3], request->api_path[5], format);
-    }
-  }
-
-  outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid API path.");
-  return MS_SUCCESS; // avoid any downstream MapServer processing
-#else
-  msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.", "msOGCAPIDispatchRequest()");
-  return MS_FAILURE;
-#endif
-}
diff -pruN 8.0.1-5/mapogcapi.h 8.2.0~beta1-1~exp1/mapogcapi.h
--- 8.0.1-5/mapogcapi.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcapi.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,42 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGCAPI Implementation
- * Author:   Steve Lime and the MapServer team.
- *
- **********************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota. 
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#ifndef MAPOGCAPI_H
-#define MAPOGCAPI_H
-
-#ifdef  __cplusplus
-extern "C" {
-#endif
-
-int msOGCAPIDispatchRequest(mapObj *map, cgiRequestObj *request);
-
-#ifdef  __cplusplus
-}
-#endif
-
-#endif
diff -pruN 8.0.1-5/mapogcfilter.cpp 8.2.0~beta1-1~exp1/mapogcfilter.cpp
--- 8.0.1-5/mapogcfilter.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcfilter.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,3511 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC Filter Encoding implementation
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver-config.h"
-
-#include "cpl_minixml.h"
-#include "cpl_string.h"
-
-#include "mapogcfilter.h"
-#include "mapserver.h"
-#include "mapowscommon.h"
-#include "maptime.h"
-#include "mapows.h"
-#include <ctype.h>
-
-#if 0
-static int FLTHasUniqueTopLevelDuringFilter(FilterEncodingNode *psFilterNode);
-#endif
-
-#if !(defined(_WIN32) && !defined(__CYGWIN__))
-static inline void IGUR_double(double ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
-#endif
-
-int FLTIsNumeric(const char *pszValue)
-{
-  if (pszValue != NULL && *pszValue != '\0' && !isspace(*pszValue)) {
-    /*the regex seems to have a problem on windows when mapserver is built using
-      PHP regex*/
-#if defined(_WIN32) && !defined(__CYGWIN__)
-    int i = 0, nLength=0, bString=0;
-
-    nLength = strlen(pszValue);
-    for (i=0; i<nLength; i++) {
-      if (i == 0) {
-        if (!isdigit(pszValue[i]) &&  pszValue[i] != '-') {
-          bString = 1;
-          break;
-        }
-      } else if (!isdigit(pszValue[i]) &&  pszValue[i] != '.') {
-        bString = 1;
-        break;
-      }
-    }
-    if (!bString)
-      return MS_TRUE;
-#else
-    char * p;
-    IGUR_double(strtod(pszValue, &p));
-    if ( p != pszValue && *p == '\0') return MS_TRUE;
-#endif
-  }
-
-  return MS_FALSE;
-}
-
-/*
-** Apply an expression to the layer's filter element.
-**
-*/
-int FLTApplyExpressionToLayer(layerObj *lp, const char *pszExpression)
-{
-  char *pszFinalExpression=NULL, *pszBuffer = NULL;
-  /*char *escapedTextString=NULL;*/
-  int bConcatWhere=0, bHasAWhere=0;
-
-  if (lp && pszExpression) {
-    if (lp->connectiontype == MS_POSTGIS || lp->connectiontype ==  MS_ORACLESPATIAL ||
-        lp->connectiontype == MS_PLUGIN) {
-      pszFinalExpression = msStrdup("(");
-      pszFinalExpression = msStringConcatenate(pszFinalExpression, pszExpression);
-      pszFinalExpression = msStringConcatenate(pszFinalExpression, ")");
-    } else if (lp->connectiontype == MS_OGR) {
-      pszFinalExpression = msStrdup(pszExpression);
-      if (lp->filter.type != MS_EXPRESSION) {
-        bConcatWhere = 1;
-      } else {
-        if (lp->filter.string && EQUALN(lp->filter.string,"WHERE ",6)) {
-          bHasAWhere = 1;
-          bConcatWhere =1;
-        }
-      }
-
-    } else
-      pszFinalExpression = msStrdup(pszExpression);
-
-    if (bConcatWhere)
-      pszBuffer = msStringConcatenate(pszBuffer, "WHERE ");
-    /* if the filter is set and it's an expression type, concatenate it with
-                this filter. If not just free it */
-    if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
-      pszBuffer = msStringConcatenate(pszBuffer, "((");
-      if (bHasAWhere)
-        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string+6);
-      else
-        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
-      pszBuffer = msStringConcatenate(pszBuffer, ") and ");
-    } else if (lp->filter.string)
-      msFreeExpression(&lp->filter);
-
-    pszBuffer = msStringConcatenate(pszBuffer, pszFinalExpression);
-
-    if(lp->filter.string && lp->filter.type == MS_EXPRESSION)
-      pszBuffer = msStringConcatenate(pszBuffer, ")");
-
-    /*assuming that expression was properly escaped
-          escapedTextString = msStringEscape(pszBuffer);
-          msLoadExpressionString(&lp->filter,
-                                 (char*)CPLSPrintf("%s", escapedTextString));
-          msFree(escapedTextString);
-    */
-    msLoadExpressionString(&lp->filter, pszBuffer);
-
-
-    msFree(pszFinalExpression);
-
-    if (pszBuffer)
-      msFree(pszBuffer);
-
-    return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-char *FLTGetExpressionForValuesRanges(layerObj *lp, const char *item, const char *value,  int forcecharcter)
-{
-  int bIscharacter;
-  char *pszExpression = NULL, *pszEscapedStr=NULL, *pszTmpExpression=NULL;
-  char **paszElements = NULL, **papszRangeElements=NULL;
-  int numelements,i,nrangeelements;
-
-  /* double minval, maxval; */
-  if (lp && item && value) {
-    if (strstr(value, "/") == NULL) {
-      /*value(s)*/
-      paszElements = msStringSplit (value, ',', &numelements);
-      if (paszElements && numelements > 0) {
-        if (forcecharcter)
-          bIscharacter = MS_TRUE;
-        else
-          bIscharacter= !FLTIsNumeric(paszElements[0]);
-
-        pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
-        for (i=0; i<numelements; i++) {
-          pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
-          {
-            if (bIscharacter)
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
-            pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
-            pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
-            pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
-            if (bIscharacter)
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
-          }
-          if (bIscharacter) {
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, " = \"");
-          } else
-            pszTmpExpression = msStringConcatenate(pszTmpExpression, " = ");
-
-          pszEscapedStr = msLayerEscapeSQLParam(lp, paszElements[i]);
-          pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
-
-          if (bIscharacter) {
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
-          }
-          pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
-
-          msFree(pszEscapedStr);
-          pszEscapedStr=NULL;
-
-          if (pszExpression != NULL)
-            pszExpression = msStringConcatenate(pszExpression, " OR ");
-
-          pszExpression =  msStringConcatenate(pszExpression, pszTmpExpression);
-
-          msFree(pszTmpExpression);
-          pszTmpExpression = NULL;
-        }
-        pszExpression = msStringConcatenate(pszExpression, ")");
-      }
-      msFreeCharArray(paszElements, numelements);
-    } else {
-      /*range(s)*/
-      paszElements = msStringSplit (value, ',', &numelements);
-      if (paszElements && numelements > 0) {
-        pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
-        for (i=0; i<numelements; i++) {
-          papszRangeElements = msStringSplit (paszElements[i], '/', &nrangeelements);
-          if (papszRangeElements && nrangeelements > 0) {
-            pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
-            if (nrangeelements == 2 || nrangeelements == 3) {
-              /*
-              minval = atof(papszRangeElements[0]);
-              maxval = atof(papszRangeElements[1]);
-              */
-              {
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
-              }
-
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, " >= ");
-
-              pszEscapedStr = msLayerEscapeSQLParam(lp, papszRangeElements[0]);
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
-              msFree(pszEscapedStr);
-              pszEscapedStr=NULL;
-
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, " AND ");
-
-              {
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
-              }
-
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, " <= ");
-
-              pszEscapedStr = msLayerEscapeSQLParam(lp, papszRangeElements[1]);
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
-              msFree(pszEscapedStr);
-              pszEscapedStr=NULL;
-
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
-            } else if (nrangeelements == 1) {
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
-              {
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
-                pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
-              }
-
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, " = ");
-
-              pszEscapedStr = msLayerEscapeSQLParam(lp, papszRangeElements[0]);
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
-              msFree(pszEscapedStr);
-              pszEscapedStr=NULL;
-
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
-            }
-
-            if (pszExpression != NULL)
-              pszExpression = msStringConcatenate(pszExpression, " OR ");
-
-            pszExpression =  msStringConcatenate(pszExpression, pszTmpExpression);
-            msFree(pszTmpExpression);
-            pszTmpExpression = NULL;
-
-          }
-          msFreeCharArray(papszRangeElements, nrangeelements);
-        }
-        pszExpression = msStringConcatenate(pszExpression, ")");
-      }
-      msFreeCharArray(paszElements, numelements);
-    }
-  }
-  msFree(pszTmpExpression);
-  return pszExpression;
-}
-
-int FLTogrConvertGeometry(OGRGeometryH hGeometry, shapeObj *psShape,
-                          OGRwkbGeometryType nType)
-{
-  return msOGRGeometryToShape(hGeometry, psShape, nType);
-}
-
-static
-int FLTShapeFromGMLTree(CPLXMLNode *psTree, shapeObj *psShape , char **ppszSRS)
-{
-  const char *pszSRS = NULL;
-  if (psTree && psShape) {
-    CPLXMLNode *psNext = psTree->psNext;
-    OGRGeometryH hGeometry = NULL;
-
-    psTree->psNext = NULL;
-    hGeometry = OGR_G_CreateFromGMLTree(psTree );
-    psTree->psNext = psNext;
-
-    if (hGeometry) {
-      OGRwkbGeometryType nType;
-      nType = OGR_G_GetGeometryType(hGeometry);
-      if (nType == wkbPolygon25D || nType == wkbMultiPolygon25D)
-        nType = wkbPolygon;
-      else if (nType == wkbLineString25D || nType == wkbMultiLineString25D)
-        nType = wkbLineString;
-      else if (nType == wkbPoint25D  || nType ==  wkbMultiPoint25D)
-        nType = wkbPoint;
-      FLTogrConvertGeometry(hGeometry, psShape, nType);
-
-      OGR_G_DestroyGeometry(hGeometry);
-
-      pszSRS = CPLGetXMLValue(psTree, "srsName", NULL);
-      if (ppszSRS && pszSRS)
-        *ppszSRS = msStrdup(pszSRS);
-
-      return MS_TRUE;
-    }
-  }
-
-  return MS_FALSE;
-}
-
-int FLTGetGeosOperator(char *pszValue)
-{
-  if (!pszValue)
-    return -1;
-
-  if (strcasecmp(pszValue, "Equals") == 0)
-    return MS_GEOS_EQUALS;
-  else if (strcasecmp(pszValue, "Intersect") == 0 ||
-           strcasecmp(pszValue, "Intersects") == 0)
-    return MS_GEOS_INTERSECTS;
-  else if (strcasecmp(pszValue, "Disjoint") == 0)
-    return MS_GEOS_DISJOINT;
-  else if (strcasecmp(pszValue, "Touches") == 0)
-    return MS_GEOS_TOUCHES;
-  else if (strcasecmp(pszValue, "Crosses") == 0)
-    return MS_GEOS_CROSSES;
-  else if (strcasecmp(pszValue, "Within") == 0)
-    return MS_GEOS_WITHIN;
-  else if (strcasecmp(pszValue, "Contains") == 0)
-    return MS_GEOS_CONTAINS;
-  else if (strcasecmp(pszValue, "Overlaps") == 0)
-    return MS_GEOS_OVERLAPS;
-  else if (strcasecmp(pszValue, "Beyond") == 0)
-    return MS_GEOS_BEYOND;
-  else if (strcasecmp(pszValue, "DWithin") == 0)
-    return MS_GEOS_DWITHIN;
-
-  return -1;
-}
-
-int FLTIsGeosNode(char *pszValue)
-{
-  if (FLTGetGeosOperator(pszValue) == -1)
-    return MS_FALSE;
-
-  return MS_TRUE;
-}
-
-/************************************************************************/
-/*                        FLTIsSimpleFilterNoSpatial                    */
-/*                                                                      */
-/*      Filter encoding with only attribute queries                     */
-/************************************************************************/
-int FLTIsSimpleFilterNoSpatial(FilterEncodingNode *psNode)
-{
-  if (FLTIsSimpleFilter(psNode) && FLTNumberOfFilterType(psNode, "BBOX") == 0)
-    return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*                      FLTApplySimpleSQLFilter()                       */
-/************************************************************************/
-
-int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
-  layerObj *lp = NULL;
-  char *szExpression = NULL;
-  rectObj sQueryRect = map->extent;
-  const char *szEPSG = NULL;
-  projectionObj sProjTmp;
-  char *pszBuffer = NULL;
-  int bConcatWhere = 0;
-  int bHasAWhere =0;
-  char *pszTmp = NULL, *pszTmp2 = NULL;
-  char *tmpfilename = NULL;
-  const char* pszTimeField = NULL;
-  const char* pszTimeValue = NULL;
-
-  lp = (GET_LAYER(map, iLayerIndex));
-
-  /* if there is a bbox use it */
-  szEPSG = FLTGetBBOX(psNode, &sQueryRect);
-  if(szEPSG && map->projection.numargs > 0) {
-    msInitProjection(&sProjTmp);
-    msProjectionInheritContextFrom(&sProjTmp, &map->projection);
-    /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
-    if (msLoadProjectionString(&sProjTmp, szEPSG) == 0) {
-      msProjectRect(&sProjTmp, &map->projection, &sQueryRect);
-    }
-    msFreeProjection(&sProjTmp);
-  }
-  
-  if( lp->connectiontype == MS_OGR ) {
-    pszTimeValue = FLTGetDuring(psNode, &pszTimeField);
-  }
-
-  /* make sure that the layer can be queried*/
-  if (!lp->_template) lp->_template = msStrdup("ttt.html");
-
-  /* if there is no class, create at least one, so that query by rect would work */
-  if (lp->numclasses == 0) {
-    if (msGrowLayerClasses(lp) == NULL)
-      return MS_FAILURE;
-    initClass(lp->_class[0]);
-  }
-
-  bConcatWhere = 0;
-  bHasAWhere = 0;
-  if (lp->connectiontype == MS_POSTGIS || lp->connectiontype ==  MS_ORACLESPATIAL ||
-      lp->connectiontype == MS_PLUGIN) {
-    szExpression = FLTGetSQLExpression(psNode, lp);
-    if (szExpression) {
-      pszTmp = msStrdup("(");
-      pszTmp = msStringConcatenate(pszTmp, szExpression);
-      pszTmp = msStringConcatenate(pszTmp, ")");
-      msFree(szExpression);
-      szExpression = pszTmp;
-    }
-  }
-  /* concatenates the WHERE clause for OGR layers. This only applies if
-     the expression was empty or not of an expression string. If there
-     is an sql type expression, it is assumed to have the WHERE clause.
-     If it is an expression and does not have a WHERE it is assumed to be a mapserver
-     type expression*/
-  else if (lp->connectiontype == MS_OGR) {
-    if (lp->filter.type != MS_EXPRESSION) {
-      szExpression = FLTGetSQLExpression(psNode, lp);
-      bConcatWhere = 1;
-    } else {
-      if (lp->filter.string && EQUALN(lp->filter.string,"WHERE ",6)) {
-        szExpression = FLTGetSQLExpression(psNode, lp);
-        bHasAWhere = 1;
-        bConcatWhere =1;
-      } else {
-        szExpression = FLTGetCommonExpression(psNode, lp);
-      }
-    }
-  } else {
-    szExpression = FLTGetCommonExpression(psNode, lp);
-
-  }
-
-  if (szExpression) {
-    if (bConcatWhere)
-      pszBuffer = msStringConcatenate(pszBuffer, "WHERE ");
-
-    /* if the filter is set and it's an expression type, concatenate it with
-                 this filter. If not just free it */
-    if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
-      pszBuffer = msStringConcatenate(pszBuffer, "((");
-      if (bHasAWhere)
-        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string+6);
-      else
-        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
-      pszBuffer = msStringConcatenate(pszBuffer, ") and ");
-    } else if (lp->filter.string)
-      msFreeExpression(&lp->filter);
-
-    pszBuffer = msStringConcatenate(pszBuffer, szExpression);
-
-    if(lp->filter.string && lp->filter.type == MS_EXPRESSION)
-      pszBuffer = msStringConcatenate(pszBuffer, ")");
-
-    msLoadExpressionString(&lp->filter, pszBuffer);
-    free(szExpression);
-  }
-  
-  if (pszTimeField && pszTimeValue)
-      msLayerSetTimeFilter(lp, pszTimeValue, pszTimeField);
-
-  if (pszBuffer)
-    free(pszBuffer);
-
-  map->query.type = MS_QUERY_BY_RECT;
-  map->query.mode = MS_QUERY_MULTIPLE;
-  map->query.layer = lp->index;
-  map->query.rect = sQueryRect;
-
-  if(map->debug == MS_DEBUGLEVEL_VVV) {
-    tmpfilename = msTmpFile(map, map->mappath, NULL, "_filter.map");
-    if (tmpfilename == NULL) {
-      tmpfilename = msTmpFile(map, NULL, NULL, "_filter.map" );
-    }
-    if (tmpfilename) {
-      msSaveMap(map,tmpfilename);
-      msDebug("FLTApplySimpleSQLFilter(): Map file after Filter was applied %s\n", tmpfilename);
-      msFree(tmpfilename);
-    }
-  }
-
-  /*for oracle connection, if we have a simple filter with no spatial constraints
-    we should set the connection function to NONE to have a better performance
-    (#2725)*/
-
-  if (lp->connectiontype ==  MS_ORACLESPATIAL && FLTIsSimpleFilterNoSpatial(psNode)) {
-    if (strcasestr(lp->data, "USING") == 0)
-      lp->data = msStringConcatenate(lp->data, " USING NONE");
-    else if (strcasestr(lp->data, "NONE") == 0) {
-      /*if one of the functions is used, just replace it with NONE*/
-      if (strcasestr(lp->data, "FILTER"))
-        lp->data = msCaseReplaceSubstring(lp->data, "FILTER", "NONE");
-      else if (strcasestr(lp->data, "GEOMRELATE"))
-        lp->data = msCaseReplaceSubstring(lp->data, "GEOMRELATE", "NONE");
-      else if (strcasestr(lp->data, "RELATE"))
-        lp->data = msCaseReplaceSubstring(lp->data, "RELATE", "NONE");
-      else if (strcasestr(lp->data, "VERSION")) {
-        /*should add NONE just before the VERSION. Cases are:
-          DATA "ORA_GEOMETRY FROM data USING VERSION 10g
-          DATA "ORA_GEOMETRY FROM data  USING UNIQUE FID VERSION 10g"
-         */
-        pszTmp = (char *)strcasestr(lp->data, "VERSION");
-        pszTmp2 = msStringConcatenate(pszTmp2, " NONE ");
-        pszTmp2 = msStringConcatenate(pszTmp2, pszTmp);
-
-        lp->data = msCaseReplaceSubstring(lp->data, pszTmp, pszTmp2);
-
-        msFree(pszTmp2);
-
-      } else if (strcasestr(lp->data, "SRID")) {
-        lp->data = msStringConcatenate(lp->data, " NONE");
-      }
-    }
-  }
-
-  return msQueryByRect(map);
-
-  /* return MS_SUCCESS; */
-}
-
-/************************************************************************/
-/*                            FLTSplitFilters                           */
-/*                                                                      */
-/*    Split filters separated by parentheses into an array of strings.  */
-/************************************************************************/
-char** FLTSplitFilters(const char* pszStr, int* pnTokens)
-{
-    const char* pszTokenBegin;
-    char** papszRet = NULL;
-    int nTokens = 0;
-    char chStringQuote = '\0';
-    int nXMLIndent = 0;
-    int bInBracket = FALSE;
-
-    if( *pszStr != '(' )
-    {
-        *pnTokens = 0;
-        return NULL;
-    }
-    pszStr ++;
-    pszTokenBegin = pszStr;
-    while( *pszStr != '\0' )
-    {
-        /* Ignore any character until end of quoted string */
-        if( chStringQuote != '\0' )
-        {
-            if( *pszStr == chStringQuote )
-                chStringQuote = 0;
-        }
-        /* Detect begin of quoted string only for an XML attribute, i.e. between < and > */
-        else if( bInBracket && (*pszStr == '\'' || *pszStr == '"') )
-        {
-            chStringQuote = *pszStr;
-        }
-        /* Begin of XML element */
-        else if( *pszStr == '<' )
-        {
-            bInBracket = TRUE;
-            if( pszStr[1] == '/' )
-                nXMLIndent --;
-            else if( pszStr[1] != '!' )
-                nXMLIndent ++;
-        }
-        /* <something /> case */
-        else if (*pszStr == '/' && pszStr[1] == '>' )
-        {
-            bInBracket = FALSE;
-            nXMLIndent --;
-            pszStr ++;
-        }
-        /* End of XML element */
-        else if( *pszStr == '>' )
-        {
-            bInBracket = FALSE;
-        }
-        /* Only detect and of filter when XML indentation goes back to zero */
-        else if( nXMLIndent == 0 && *pszStr == ')' )
-        {
-            papszRet = (char**) msSmallRealloc(papszRet, sizeof(char*) * (nTokens + 1));
-            papszRet[nTokens] = msStrdup(pszTokenBegin);
-            papszRet[nTokens][pszStr - pszTokenBegin] = '\0';
-            nTokens ++;
-            if( pszStr[1] != '(' )
-            {
-                break;
-            }
-            pszStr ++;
-            pszTokenBegin = pszStr + 1;
-        }
-        pszStr ++;
-    }
-    *pnTokens = nTokens;
-    return papszRet;
-}
-
-/************************************************************************/
-/*                            FLTIsSimpleFilter                         */
-/*                                                                      */
-/*      Filter encoding with only attribute queries and only one bbox.  */
-/************************************************************************/
-int FLTIsSimpleFilter(FilterEncodingNode *psNode)
-{
-  if (FLTValidForBBoxFilter(psNode)) {
-    if (FLTNumberOfFilterType(psNode, "DWithin") == 0 &&
-        FLTNumberOfFilterType(psNode, "Intersect") == 0 &&
-        FLTNumberOfFilterType(psNode, "Intersects") == 0 &&
-        FLTNumberOfFilterType(psNode, "Equals") == 0 &&
-        FLTNumberOfFilterType(psNode, "Disjoint") == 0 &&
-        FLTNumberOfFilterType(psNode, "Touches") == 0 &&
-        FLTNumberOfFilterType(psNode, "Crosses") == 0 &&
-        FLTNumberOfFilterType(psNode, "Within") == 0 &&
-        FLTNumberOfFilterType(psNode, "Contains") == 0 &&
-        FLTNumberOfFilterType(psNode, "Overlaps") == 0 &&
-        FLTNumberOfFilterType(psNode, "Beyond") == 0)
-      return TRUE;
-  }
-
-  return FALSE;
-}
-
-/************************************************************************/
-/*                          FLTApplyFilterToLayer                       */
-/*                                                                      */
-/*      Use the filter encoding node to create mapserver expressions    */
-/*      and apply it to the layer.                                      */
-/************************************************************************/
-int FLTApplyFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
-  layerObj *layer = GET_LAYER(map, iLayerIndex);
-
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS)
-      return rv;
-  }
-  if( !layer->vtable )
-      return MS_FAILURE;
-  return layer->vtable->LayerApplyFilterToLayer(psNode, map,  iLayerIndex);
-}
-
-/************************************************************************/
-/*               FLTLayerApplyCondSQLFilterToLayer                       */
-/*                                                                      */
-/* Helper function for layer virtual table architecture                 */
-/************************************************************************/
-int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
-  return FLTLayerApplyPlainFilterToLayer(psNode, map, iLayerIndex);
-}
-
-
-/************************************************************************/
-/*                           FLTGetTopBBOX                              */
-/*                                                                      */
-/* Return the "top" BBOX if there's a unique one.                       */
-/************************************************************************/
-static int FLTGetTopBBOXInternal(FilterEncodingNode *psNode, FilterEncodingNode** ppsTopBBOX, int *pnCount)
-{
-  if (psNode->pszValue && strcasecmp(psNode->pszValue, "BBOX") == 0) {
-    (*pnCount) ++;
-    if( *pnCount == 1 )
-    {
-      *ppsTopBBOX = psNode;
-      return TRUE;
-    }
-    *ppsTopBBOX = NULL;
-    return FALSE;
-  }
-  else if (psNode->pszValue && strcasecmp(psNode->pszValue, "AND") == 0) {
-    return FLTGetTopBBOXInternal(psNode->psLeftNode, ppsTopBBOX, pnCount) &&
-           FLTGetTopBBOXInternal(psNode->psRightNode, ppsTopBBOX, pnCount);
-  }
-  else
-  {
-    return TRUE;
-  }
-}
-
-static FilterEncodingNode* FLTGetTopBBOX(FilterEncodingNode *psNode)
-{
-  int nCount = 0;
-  FilterEncodingNode* psTopBBOX = NULL;
-  FLTGetTopBBOXInternal(psNode, &psTopBBOX, &nCount);
-  return psTopBBOX;
-}
-
-/************************************************************************/
-/*                   FLTLayerSetInvalidRectIfSupported                  */
-/*                                                                      */
-/*  This function will set in *rect a very huge extent if the layer     */
-/*  wfs_use_default_extent_for_getfeature metadata item is set to false */
-/*  and the layer supports such degenerate rectangle, as a hint that    */
-/*  they should not issue a spatial filter.                             */
-/************************************************************************/
-
-int FLTLayerSetInvalidRectIfSupported(layerObj* lp,
-                                      rectObj* rect)
-{
-    const char* pszUseDefaultExtent = msOWSLookupMetadata(&(lp->metadata), "F",
-                                              "use_default_extent_for_getfeature");
-    if( pszUseDefaultExtent && !CSLTestBoolean(pszUseDefaultExtent) &&
-        (lp->connectiontype == MS_OGR ||
-        ((lp->connectiontype == MS_PLUGIN) && (strstr(lp->plugin_library,"msplugin_mssql2008") != NULL))) )
-    {
-        const rectObj rectInvalid = MS_INIT_INVALID_RECT;
-        *rect = rectInvalid;
-        return MS_TRUE;
-    }
-    return MS_FALSE;
-}
-
-/************************************************************************/
-/*                   FLTLayerApplyPlainFilterToLayer                    */
-/*                                                                      */
-/* Helper function for layer virtual table architecture                 */
-/************************************************************************/
-int FLTLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-                                    int iLayerIndex)
-{
-  char *pszExpression  =NULL;
-  int status =MS_FALSE;
-  layerObj* lp = GET_LAYER(map, iLayerIndex);
-
-  pszExpression = FLTGetCommonExpression(psNode,  lp);
-  if (pszExpression) {
-    FilterEncodingNode* psTopBBOX;
-    rectObj rect = map->extent;
-
-    FLTLayerSetInvalidRectIfSupported(lp, &rect);
-
-    psTopBBOX = FLTGetTopBBOX(psNode);
-    if( psTopBBOX )
-    {
-      int can_remove_expression = MS_TRUE;
-      const char* pszEPSG = FLTGetBBOX(psNode, &rect);
-      if(pszEPSG && map->projection.numargs > 0) {
-        projectionObj sProjTmp;
-        msInitProjection(&sProjTmp);
-        msProjectionInheritContextFrom(&sProjTmp, &map->projection);
-        /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
-        if (msLoadProjectionString(&sProjTmp, pszEPSG) == 0) {
-          rectObj oldRect = rect;
-          msProjectRect(&sProjTmp, &map->projection, &rect);
-          /* If reprojection is involved, do not remove the expression */
-          if( rect.minx != oldRect.minx ||
-              rect.miny != oldRect.miny ||
-              rect.maxx != oldRect.maxx ||
-              rect.maxy != oldRect.maxy )
-          {
-            can_remove_expression = MS_FALSE;
-          }
-        }
-        msFreeProjection(&sProjTmp);
-      }
-
-      /* Small optimization: if the query is just a BBOX, then do a */
-      /* msQueryByRect() */
-      if( psTopBBOX == psNode && can_remove_expression )
-      {
-        msFree(pszExpression);
-        pszExpression = NULL;
-      }
-    }
-
-    if(map->debug == MS_DEBUGLEVEL_VVV)
-    {
-      if( pszExpression )
-        msDebug("FLTLayerApplyPlainFilterToLayer(): %s, rect=%.15g,%.15g,%.15g,%.15g\n", pszExpression, rect.minx, rect.miny, rect.maxx, rect.maxy);
-      else
-        msDebug("FLTLayerApplyPlainFilterToLayer(): rect=%.15g,%.15g,%.15g,%.15g\n", rect.minx, rect.miny, rect.maxx, rect.maxy);
-    }
-
-    status = FLTApplyFilterToLayerCommonExpressionWithRect(map, iLayerIndex,
-                                                           pszExpression, rect);
-    msFree(pszExpression);
-  }
-
-  return status;
-}
-
-
-
-/************************************************************************/
-/*            FilterNode *FLTPaserFilterEncoding(char *szXMLString)     */
-/*                                                                      */
-/*      Parses an Filter Encoding XML string and creates a              */
-/*      FilterEncodingNodes corresponding to the string.                */
-/*      Returns a pointer to the first node or NULL if                  */
-/*      unsuccessfull.                                                  */
-/*      Calling function should use FreeFilterEncodingNode function     */
-/*      to free memeory.                                                */
-/************************************************************************/
-FilterEncodingNode *FLTParseFilterEncoding(const char *szXMLString)
-{
-  CPLXMLNode *psRoot = NULL, *psChild=NULL, *psFilter=NULL;
-  FilterEncodingNode *psFilterNode = NULL;
-
-  if (szXMLString == NULL || strlen(szXMLString) == 0 ||
-      (strstr(szXMLString, "Filter") == NULL))
-    return NULL;
-
-  psRoot = CPLParseXMLString(szXMLString);
-
-  if( psRoot == NULL)
-    return NULL;
-
-  /* strip namespaces. We srtip all name spaces (#1350)*/
-  CPLStripXMLNamespace(psRoot, NULL, 1);
-
-  /* -------------------------------------------------------------------- */
-  /*      get the root element (Filter).                                  */
-  /* -------------------------------------------------------------------- */
-  psFilter = CPLGetXMLNode(psRoot, "=Filter");
-  if (!psFilter)
-  {
-    CPLDestroyXMLNode( psRoot );
-    return NULL;
-  }
-
-  psChild = psFilter->psChild;
-  while (psChild) {
-    if (FLTIsSupportedFilterType(psChild)) {
-      psFilterNode = FLTCreateFilterEncodingNode();
-      FLTInsertElementInNode(psFilterNode, psChild);
-      break;
-    } else
-      psChild = psChild->psNext;
-  }
-
-  CPLDestroyXMLNode( psRoot );
-
-  /* -------------------------------------------------------------------- */
-  /*      validate the node tree to make sure that all the nodes are valid.*/
-  /* -------------------------------------------------------------------- */
-  if (!FLTValidFilterNode(psFilterNode)) {
-    FLTFreeFilterEncodingNode(psFilterNode);
-    return NULL;
-  }
-
-
-  return psFilterNode;
-}
-
-
-/************************************************************************/
-/*      int FLTValidFilterNode(FilterEncodingNode *psFilterNode)        */
-/*                                                                      */
-/*      Validate that all the nodes are filled properly. We could       */
-/*      have parts of the nodes that are correct and part which         */
-/*      could be incorrect if the filter string sent is corrupted       */
-/*      (eg missing a value :<PropertyName><PropertyName>)              */
-/************************************************************************/
-int FLTValidFilterNode(FilterEncodingNode *psFilterNode)
-{
-  if (!psFilterNode)
-    return 0;
-
-  if (psFilterNode->eType == FILTER_NODE_TYPE_UNDEFINED)
-    return 0;
-
-  if (psFilterNode->psLeftNode) {
-    const int bReturn = FLTValidFilterNode(psFilterNode->psLeftNode);
-    if (bReturn == 0)
-      return 0;
-    else if (psFilterNode->psRightNode)
-      return FLTValidFilterNode(psFilterNode->psRightNode);
-  }
-
-  return 1;
-}
-
-/************************************************************************/
-/*                       FLTIsGeometryFilterNodeType                    */
-/************************************************************************/
-
-static int FLTIsGeometryFilterNodeType(int eType)
-{
-    return (eType == FILTER_NODE_TYPE_GEOMETRY_POINT ||
-            eType == FILTER_NODE_TYPE_GEOMETRY_LINE ||
-            eType == FILTER_NODE_TYPE_GEOMETRY_POLYGON);
-}
-
-/************************************************************************/
-/*                          FLTFreeFilterEncodingNode                   */
-/*                                                                      */
-/*      recursive freeing of Filter Encoding nodes.                      */
-/************************************************************************/
-void FLTFreeFilterEncodingNode(FilterEncodingNode *psFilterNode)
-{
-  if (psFilterNode) {
-    if (psFilterNode->psLeftNode) {
-      FLTFreeFilterEncodingNode(psFilterNode->psLeftNode);
-      psFilterNode->psLeftNode = NULL;
-    }
-    if (psFilterNode->psRightNode) {
-      FLTFreeFilterEncodingNode(psFilterNode->psRightNode);
-      psFilterNode->psRightNode = NULL;
-    }
-
-    if (psFilterNode->pszSRS)
-      free( psFilterNode->pszSRS);
-
-    if( psFilterNode->pOther ) {
-      if (psFilterNode->pszValue != NULL &&
-          strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0) {
-        FEPropertyIsLike* propIsLike = (FEPropertyIsLike *)psFilterNode->pOther;
-        if( propIsLike->pszWildCard )
-          free( propIsLike->pszWildCard );
-        if( propIsLike->pszSingleChar )
-          free( propIsLike->pszSingleChar );
-        if( propIsLike->pszEscapeChar )
-          free( propIsLike->pszEscapeChar );
-      } else if (FLTIsGeometryFilterNodeType(psFilterNode->eType)) {
-        msFreeShape((shapeObj *)(psFilterNode->pOther));
-      }
-      /* else */
-      /* TODO free pOther special fields */
-      free( psFilterNode->pOther );
-    }
-
-    /* Cannot free pszValue before, 'cause we are testing it above */
-    if( psFilterNode->pszValue )
-      free( psFilterNode->pszValue );
-
-    free(psFilterNode);
-  }
-}
-
-
-/************************************************************************/
-/*                         FLTCreateFilterEncodingNode                  */
-/*                                                                      */
-/*      return a FilterEncoding node.                                    */
-/************************************************************************/
-FilterEncodingNode *FLTCreateFilterEncodingNode(void)
-{
-  FilterEncodingNode *psFilterNode = NULL;
-
-  psFilterNode =
-  (FilterEncodingNode *)malloc(sizeof (FilterEncodingNode));
-  psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-  psFilterNode->pszValue = NULL;
-  psFilterNode->pOther = NULL;
-  psFilterNode->pszSRS = NULL;
-  psFilterNode->psLeftNode = NULL;
-  psFilterNode->psRightNode = NULL;
-
-  return psFilterNode;
-}
-
-FilterEncodingNode *FLTCreateBinaryCompFilterEncodingNode(void)
-{
-  FilterEncodingNode *psFilterNode = NULL;
-
-  psFilterNode = FLTCreateFilterEncodingNode();
-  /* used to store case sensitivity flag. Default is 0 meaning the
-     comparing is case sensititive */
-  psFilterNode->pOther = (int *)malloc(sizeof(int));
-  (*(int *)(psFilterNode->pOther)) = 0;
-
-  return psFilterNode;
-}
-
-
-/************************************************************************/
-/*                           FLTFindGeometryNode                        */
-/*                                                                      */
-/************************************************************************/
-
-static CPLXMLNode* FLTFindGeometryNode(CPLXMLNode* psXMLNode,
-                                       int* pbPoint,
-                                       int* pbLine,
-                                       int* pbPolygon)
-{
-    CPLXMLNode *psGMLElement = NULL;
-
-    psGMLElement = CPLGetXMLNode(psXMLNode, "Point");
-    if (!psGMLElement)
-        psGMLElement =  CPLGetXMLNode(psXMLNode, "PointType");
-    if (psGMLElement)
-        *pbPoint =1;
-    else {
-      psGMLElement= CPLGetXMLNode(psXMLNode, "Polygon");
-      if (psGMLElement)
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiPolygon")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Surface")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiSurface")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Box")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Envelope")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "LineString")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiLineString")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Curve")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiCurve")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiPoint")))
-        *pbPoint = 1;
-    }
-    return psGMLElement;
-}
-
-/************************************************************************/
-/*                           FLTGetPropertyName                         */
-/************************************************************************/
-static const char* FLTGetPropertyName(CPLXMLNode* psXMLNode)
-{
-    const char* pszPropertyName;
-
-    pszPropertyName = CPLGetXMLValue(psXMLNode, "PropertyName", NULL);
-    if( pszPropertyName == NULL ) /* FE 2.0 ? */
-        pszPropertyName = CPLGetXMLValue(psXMLNode, "ValueReference", NULL);
-    return pszPropertyName;
-}
-
-/************************************************************************/
-/*                          FLTGetFirstChildNode                        */
-/************************************************************************/
-static CPLXMLNode* FLTGetFirstChildNode(CPLXMLNode* psXMLNode)
-{
-    if( psXMLNode == NULL )
-        return NULL;
-    psXMLNode = psXMLNode->psChild;
-    while( psXMLNode != NULL )
-    {
-        if( psXMLNode->eType == CXT_Element )
-            return psXMLNode;
-        psXMLNode = psXMLNode->psNext;
-    }
-    return NULL;
-}
-
-/************************************************************************/
-/*                        FLTGetNextSibblingNode                        */
-/************************************************************************/
-static CPLXMLNode* FLTGetNextSibblingNode(CPLXMLNode* psXMLNode)
-{
-    if( psXMLNode == NULL )
-        return NULL;
-    psXMLNode = psXMLNode->psNext;
-    while( psXMLNode != NULL )
-    {
-        if( psXMLNode->eType == CXT_Element )
-            return psXMLNode;
-        psXMLNode = psXMLNode->psNext;
-    }
-    return NULL;
-}
-
-/************************************************************************/
-/*                           FLTInsertElementInNode                     */
-/*                                                                      */
-/*      Utility function to parse an XML node and transfer the          */
-/*      contents into the Filter Encoding node structure.               */
-/************************************************************************/
-void FLTInsertElementInNode(FilterEncodingNode *psFilterNode,
-                            CPLXMLNode *psXMLNode)
-{
-  char *pszTmp = NULL;
-  FilterEncodingNode *psCurFilNode= NULL;
-  CPLXMLNode *psCurXMLNode = NULL;
-  CPLXMLNode *psTmpNode = NULL;
-  CPLXMLNode *psFeatureIdNode = NULL;
-  const char *pszFeatureId=NULL;
-  char *pszFeatureIdList=NULL;
-
-  if (psFilterNode && psXMLNode && psXMLNode->pszValue) {
-    psFilterNode->pszValue = msStrdup(psXMLNode->pszValue);
-    psFilterNode->psLeftNode = NULL;
-    psFilterNode->psRightNode = NULL;
-
-    /* -------------------------------------------------------------------- */
-    /*      Logical filter. AND, OR and NOT are supported. Example of       */
-    /*      filer using logical filters :                                   */
-    /*      <Filter>                                                        */
-    /*        <And>                                                         */
-    /*          <PropertyIsGreaterThan>                                     */
-    /*            <PropertyName>Person/Age</PropertyName>                   */
-    /*            <Literal>50</Literal>                                     */
-    /*          </PropertyIsGreaterThan>                                    */
-    /*          <PropertyIsEqualTo>                                         */
-    /*             <PropertyName>Person/Address/City</PropertyName>         */
-    /*             <Literal>Toronto</Literal>                               */
-    /*          </PropertyIsEqualTo>                                        */
-    /*        </And>                                                        */
-    /*      </Filter>                                                       */
-    /* -------------------------------------------------------------------- */
-    if (FLTIsLogicalFilterType(psXMLNode->pszValue)) {
-      psFilterNode->eType = FILTER_NODE_TYPE_LOGICAL;
-      if (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
-          strcasecmp(psFilterNode->pszValue, "OR") == 0) {
-        CPLXMLNode* psFirstNode = FLTGetFirstChildNode(psXMLNode);
-        CPLXMLNode* psSecondNode = FLTGetNextSibblingNode(psFirstNode);
-        if (psFirstNode && psSecondNode) {
-          /*2 operators */
-          CPLXMLNode* psNextNode = FLTGetNextSibblingNode(psSecondNode);
-          if (psNextNode == NULL) {
-            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-            FLTInsertElementInNode(psFilterNode->psLeftNode, psFirstNode);
-            psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
-            FLTInsertElementInNode(psFilterNode->psRightNode, psSecondNode);
-          } else {
-            psCurXMLNode = psFirstNode;
-            psCurFilNode = psFilterNode;
-            while(psCurXMLNode) {
-              psNextNode = FLTGetNextSibblingNode(psCurXMLNode);
-              if (FLTGetNextSibblingNode(psNextNode)) {
-                psCurFilNode->psLeftNode = FLTCreateFilterEncodingNode();
-                FLTInsertElementInNode(psCurFilNode->psLeftNode, psCurXMLNode);
-                psCurFilNode->psRightNode = FLTCreateFilterEncodingNode();
-                psCurFilNode->psRightNode->eType = FILTER_NODE_TYPE_LOGICAL;
-                psCurFilNode->psRightNode->pszValue = msStrdup(psFilterNode->pszValue);
-
-                psCurFilNode = psCurFilNode->psRightNode;
-                psCurXMLNode = psNextNode;
-              } else { /*last 2 operators*/
-                psCurFilNode->psLeftNode = FLTCreateFilterEncodingNode();
-                FLTInsertElementInNode(psCurFilNode->psLeftNode, psCurXMLNode);
-
-                psCurFilNode->psRightNode = FLTCreateFilterEncodingNode();
-                FLTInsertElementInNode(psCurFilNode->psRightNode, psNextNode);
-                break;
-              }
-            }
-          }
-        }
-        else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      } else if (strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
-        CPLXMLNode* psFirstNode = FLTGetFirstChildNode(psXMLNode);
-        if (psFirstNode) {
-          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-          FLTInsertElementInNode(psFilterNode->psLeftNode,
-                                 psFirstNode);
-        }
-        else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      } else
-        psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-    }/* end if is logical */
-    /* -------------------------------------------------------------------- */
-    /*      Spatial Filter.                                                 */
-    /*      BBOX :                                                          */
-    /*      <Filter>                                                        */
-    /*       <BBOX>                                                         */
-    /*        <PropertyName>Geometry</PropertyName>                         */
-    /*        <gml:Box srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
-    /*          <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
-    /*        </gml:Box>                                                    */
-    /*       </BBOX>                                                        */
-    /*      </Filter>                                                       */
-    /*                                                                      */
-    /*       DWithin                                                        */
-    /*                                                                      */
-    /*      <xsd:element name="DWithin"                                     */
-    /*      type="ogc:DistanceBufferType"                                   */
-    /*      substitutionGroup="ogc:spatialOps"/>                            */
-    /*                                                                      */
-    /*      <xsd:complexType name="DistanceBufferType">                     */
-    /*         <xsd:complexContent>                                         */
-    /*            <xsd:extension base="ogc:SpatialOpsType">                 */
-    /*               <xsd:sequence>                                         */
-    /*                  <xsd:element ref="ogc:PropertyName"/>               */
-    /*                  <xsd:element ref="gml:_Geometry"/>                  */
-    /*                  <xsd:element name="Distance" type="ogc:DistanceType"/>*/
-    /*               </xsd:sequence>                                        */
-    /*            </xsd:extension>                                          */
-    /*         </xsd:complexContent>                                        */
-    /*      </xsd:complexType>                                              */
-    /*                                                                      */
-    /*                                                                      */
-    /*       <Filter>                                                       */
-    /*       <DWithin>                                                      */
-    /*        <PropertyName>Geometry</PropertyName>                         */
-    /*        <gml:Point>                                                   */
-    /*          <gml:coordinates>13.0983,31.5899</gml:coordinates>          */
-    /*        </gml:Point>                                                  */
-    /*        <Distance units="url#m">10</Distance>                         */
-    /*       </DWithin>                                                     */
-    /*      </Filter>                                                       */
-    /*                                                                      */
-    /*       Intersect                                                      */
-    /*                                                                      */
-    /*       type="ogc:BinarySpatialOpType" substitutionGroup="ogc:spatialOps"/>*/
-    /*      <xsd:element name="Intersects"                                  */
-    /*      type="ogc:BinarySpatialOpType"                                  */
-    /*      substitutionGroup="ogc:spatialOps"/>                            */
-    /*                                                                      */
-    /*      <xsd:complexType name="BinarySpatialOpType">                    */
-    /*      <xsd:complexContent>                                            */
-    /*      <xsd:extension base="ogc:SpatialOpsType">                       */
-    /*      <xsd:sequence>                                                  */
-    /*      <xsd:element ref="ogc:PropertyName"/>                           */
-    /*      <xsd:choice>                                                    */
-    /*      <xsd:element ref="gml:_Geometry"/>                              */
-    /*      <xsd:element ref="gml:Box"/>                                    */
-    /*      </xsd:sequence>                                                 */
-    /*      </xsd:extension>                                                */
-    /*      </xsd:complexContent>                                           */
-    /*      </xsd:complexType>                                              */
-    /* -------------------------------------------------------------------- */
-    else if (FLTIsSpatialFilterType(psXMLNode->pszValue)) {
-      psFilterNode->eType = FILTER_NODE_TYPE_SPATIAL;
-
-      if (strcasecmp(psXMLNode->pszValue, "BBOX") == 0) {
-        char *pszSRS = NULL;
-        const char* pszPropertyName = NULL;
-        CPLXMLNode *psBox = NULL, *psEnvelope=NULL;
-        rectObj sBox = {0,0,0,0};
-
-        int bCoordinatesValid = 0;
-
-        pszPropertyName = FLTGetPropertyName(psXMLNode);
-        psBox = CPLGetXMLNode(psXMLNode, "Box");
-        if (!psBox)
-          psBox = CPLGetXMLNode(psXMLNode, "BoxType");
-
-        /*FE 1.0 used box FE1.1 uses envelop*/
-        if (psBox)
-          bCoordinatesValid = FLTParseGMLBox(psBox, &sBox, &pszSRS);
-        else if ((psEnvelope = CPLGetXMLNode(psXMLNode, "Envelope")))
-          bCoordinatesValid = FLTParseGMLEnvelope(psEnvelope, &sBox, &pszSRS);
-
-        if (bCoordinatesValid) {
-          /*set the srs if available*/
-          if (pszSRS)
-            psFilterNode->pszSRS = pszSRS;
-
-          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psLeftNode->eType =  FILTER_NODE_TYPE_PROPERTYNAME;
-          /* PropertyName is optional since FE 1.1.0, in which case */
-          /* the BBOX must apply to all geometry fields. As we support */
-          /* currently only one geometry field, this doesn't make much */
-          /* difference to further processing. */
-          if( pszPropertyName != NULL ) {
-            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-          }
-
-          /* coordinates */
-          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_BBOX;
-          psFilterNode->psRightNode->pOther =
-          (rectObj *)msSmallMalloc(sizeof(rectObj));
-          ((rectObj *)psFilterNode->psRightNode->pOther)->minx = sBox.minx;
-          ((rectObj *)psFilterNode->psRightNode->pOther)->miny = sBox.miny;
-          ((rectObj *)psFilterNode->psRightNode->pOther)->maxx = sBox.maxx;
-          ((rectObj *)psFilterNode->psRightNode->pOther)->maxy =  sBox.maxy;
-        } else {
-          msFree(pszSRS);
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-        }
-      } else if (strcasecmp(psXMLNode->pszValue, "DWithin") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Beyond") == 0)
-
-      {
-        shapeObj *psShape = NULL;
-        int bPoint = 0, bLine = 0, bPolygon = 0;
-        const char *pszUnits = NULL;
-        const char* pszDistance = NULL;
-        const char* pszPropertyName;
-        char *pszSRS = NULL;
-
-        CPLXMLNode *psGMLElement = NULL, *psDistance=NULL;
-
-        pszPropertyName = FLTGetPropertyName(psXMLNode);
-
-        psGMLElement = FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
-
-        psDistance = CPLGetXMLNode(psXMLNode, "Distance");
-        if( psDistance != NULL )
-            pszDistance = CPLGetXMLValue(psDistance, NULL, NULL );
-        if (pszPropertyName != NULL && psGMLElement && psDistance != NULL ) {
-          pszUnits = CPLGetXMLValue(psDistance, "units", NULL);
-          if( pszUnits == NULL ) /* FE 2.0 */
-              pszUnits = CPLGetXMLValue(psDistance, "uom", NULL);
-          psShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
-          msInitShape(psShape);
-          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS))
-          {
-            /*set the srs if available*/
-            if (pszSRS)
-              psFilterNode->pszSRS = pszSRS;
-
-            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-
-            psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
-            if (bPoint)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POINT;
-            else if (bLine)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_LINE;
-            else if (bPolygon)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POLYGON;
-            psFilterNode->psRightNode->pOther = (shapeObj *)psShape;
-            /*the value will be distance;units*/
-            psFilterNode->psRightNode->pszValue = msStrdup(pszDistance);
-            if (pszUnits) {
-              psFilterNode->psRightNode->pszValue= msStringConcatenate(psFilterNode->psRightNode->pszValue, ";");
-              psFilterNode->psRightNode->pszValue= msStringConcatenate(psFilterNode->psRightNode->pszValue, pszUnits);
-            }
-          }
-          else
-          {
-              free(psShape);
-              msFree(pszSRS);
-              psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-          }
-        } else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      } else if (strcasecmp(psXMLNode->pszValue, "Intersect") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Intersects") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Equals") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Disjoint") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Touches") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Crosses") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Within") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Contains") == 0 ||
-                 strcasecmp(psXMLNode->pszValue, "Overlaps") == 0) {
-        shapeObj *psShape = NULL;
-        int  bLine = 0, bPolygon = 0, bPoint=0;
-        char *pszSRS = NULL;
-        const char* pszPropertyName;
-
-        CPLXMLNode *psGMLElement = NULL;
-
-        pszPropertyName = FLTGetPropertyName(psXMLNode);
-
-        psGMLElement = FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
-
-        if (pszPropertyName != NULL && psGMLElement) {
-          psShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
-          msInitShape(psShape);
-          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS))
-          {
-            /*set the srs if available*/
-            if (pszSRS)
-              psFilterNode->pszSRS = pszSRS;
-
-            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-
-            psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
-            if (bPoint)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POINT;
-            else if (bLine)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_LINE;
-            else if (bPolygon)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POLYGON;
-            psFilterNode->psRightNode->pOther = (shapeObj *)psShape;
-
-          }
-          else
-          {
-              free(psShape);
-              msFree(pszSRS);
-              psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-          }
-        } else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      }
-
-
-    }/* end of is spatial */
-
-
-    /* -------------------------------------------------------------------- */
-    /*      Comparison Filter                                               */
-    /* -------------------------------------------------------------------- */
-    else if (FLTIsComparisonFilterType(psXMLNode->pszValue)) {
-      psFilterNode->eType = FILTER_NODE_TYPE_COMPARISON;
-      /* -------------------------------------------------------------------- */
-      /*      binary comaparison types. Example :                             */
-      /*                                                                      */
-      /*      <Filter>                                                        */
-      /*        <PropertyIsEqualTo>                                           */
-      /*          <PropertyName>SomeProperty</PropertyName>                   */
-      /*          <Literal>100</Literal>                                      */
-      /*        </PropertyIsEqualTo>                                          */
-      /*      </Filter>                                                       */
-      /* -------------------------------------------------------------------- */
-      if (FLTIsBinaryComparisonFilterType(psXMLNode->pszValue)) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        if (pszPropertyName != NULL ) {
-
-          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-
-          psTmpNode = CPLSearchXMLNode(psXMLNode,  "Literal");
-          if (psTmpNode) {
-            const char* pszLiteral = CPLGetXMLValue(psTmpNode, NULL, NULL);
-
-            psFilterNode->psRightNode = FLTCreateBinaryCompFilterEncodingNode();
-            psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
-
-            if (pszLiteral != NULL) {
-              const char* pszMatchCase;
-
-              psFilterNode->psRightNode->pszValue = msStrdup(pszLiteral);
-              
-              pszMatchCase = CPLGetXMLValue(psXMLNode, "matchCase", NULL);
-
-              /*check if the matchCase attribute is set*/
-              if( pszMatchCase != NULL && strcasecmp( pszMatchCase, "false") == 0) {
-                (*(int *)psFilterNode->psRightNode->pOther) = 1;
-              }
-
-            }
-            /* special case where the user puts an empty value */
-            /* for the Literal so it can end up as an empty  */
-            /* string query in the expression */
-            else
-              psFilterNode->psRightNode->pszValue = NULL;
-          }
-        }
-        if (psFilterNode->psLeftNode == NULL || psFilterNode->psRightNode == NULL)
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      }
-
-      /* -------------------------------------------------------------------- */
-      /*      PropertyIsBetween filter : extract property name and boudary    */
-      /*      values. The boundary  values are stored in the right            */
-      /*      node. The values are separated by a semi-column (;)             */
-      /*      Eg of Filter :                                                  */
-      /*      <PropertyIsBetween>                                             */
-      /*         <PropertyName>DEPTH</PropertyName>                           */
-      /*         <LowerBoundary><Literal>400</Literal></LowerBoundary>        */
-      /*         <UpperBoundary><Literal>800</Literal></UpperBoundary>        */
-      /*      </PropertyIsBetween>                                            */
-      /*                                                                      */
-      /*      Or                                                              */
-      /*      <PropertyIsBetween>                                             */
-      /*         <PropertyName>DEPTH</PropertyName>                           */
-      /*         <LowerBoundary>400</LowerBoundary>                           */
-      /*         <UpperBoundary>800</UpperBoundary>                           */
-      /*      </PropertyIsBetween>                                            */
-      /* -------------------------------------------------------------------- */
-      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsBetween") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        CPLXMLNode* psLowerBoundary = CPLGetXMLNode(psXMLNode, "LowerBoundary");
-        CPLXMLNode* psUpperBoundary = CPLGetXMLNode(psXMLNode, "UpperBoundary");
-        const char* pszLowerNode = NULL;
-        const char* pszUpperNode = NULL;
-        if( psLowerBoundary != NULL )
-        {
-          /* check if the <Literal> is there */
-          if (CPLGetXMLNode(psLowerBoundary, "Literal") != NULL)
-            pszLowerNode = CPLGetXMLValue(psLowerBoundary, "Literal", NULL);
-          else
-            pszLowerNode = CPLGetXMLValue(psLowerBoundary, NULL, NULL);
-        }
-        if( psUpperBoundary != NULL )
-        {
-           if (CPLGetXMLNode(psUpperBoundary, "Literal") != NULL)
-            pszUpperNode = CPLGetXMLValue(psUpperBoundary, "Literal", NULL);
-          else
-            pszUpperNode = CPLGetXMLValue(psUpperBoundary, NULL, NULL);
-        }
-        if (pszPropertyName != NULL && pszLowerNode != NULL && pszUpperNode != NULL) {
-          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-
-          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-
-          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_BOUNDARY;
-
-          /* adding a ; between bounary values */
-          const int nStrLength = strlen(pszLowerNode) + strlen(pszUpperNode) + 2;
-
-          psFilterNode->psRightNode->pszValue =
-              (char *)malloc(sizeof(char)*(nStrLength));
-          strcpy( psFilterNode->psRightNode->pszValue, pszLowerNode);
-          strlcat(psFilterNode->psRightNode->pszValue, ";", nStrLength);
-          strlcat(psFilterNode->psRightNode->pszValue, pszUpperNode, nStrLength);
-
-
-        } else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-
-      }/* end of PropertyIsBetween  */
-      /* -------------------------------------------------------------------- */
-      /*      PropertyIsLike                                                  */
-      /*                                                                      */
-      /*      <Filter>                                                        */
-      /*      <PropertyIsLike wildCard="*" singleChar="#" escape="!">         */
-      /*      <PropertyName>LAST_NAME</PropertyName>                          */
-      /*      <Literal>JOHN*</Literal>                                        */
-      /*      </PropertyIsLike>                                               */
-      /*      </Filter>                                                       */
-      /* -------------------------------------------------------------------- */
-      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsLike") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        const char* pszLiteral = CPLGetXMLValue(psXMLNode, "Literal", NULL);
-        const char* pszWildCard = CPLGetXMLValue(psXMLNode, "wildCard", NULL);
-        const char* pszSingleChar = CPLGetXMLValue(psXMLNode, "singleChar", NULL);
-        const char* pszEscapeChar = CPLGetXMLValue(psXMLNode, "escape", NULL);
-        if( pszEscapeChar == NULL )
-            pszEscapeChar = CPLGetXMLValue(psXMLNode, "escapeChar", NULL);
-        if (pszPropertyName != NULL && pszLiteral != NULL &&
-            pszWildCard != NULL && pszSingleChar != NULL && pszEscapeChar != NULL)
-        {
-          FEPropertyIsLike* propIsLike;
-
-          propIsLike = (FEPropertyIsLike *)malloc(sizeof(FEPropertyIsLike));
-
-          psFilterNode->pOther = propIsLike;
-          propIsLike->bCaseInsensitive = 0;
-          propIsLike->pszWildCard = msStrdup(pszWildCard);
-          propIsLike->pszSingleChar = msStrdup(pszSingleChar);
-          propIsLike->pszEscapeChar = msStrdup(pszEscapeChar);
-
-          pszTmp = (char *)CPLGetXMLValue(psXMLNode, "matchCase", NULL);
-          if (pszTmp && strcasecmp(pszTmp, "false") == 0) {
-            propIsLike->bCaseInsensitive =1;
-          }
-          /* -------------------------------------------------------------------- */
-          /*      Create left and right node for the attribute and the value.     */
-          /* -------------------------------------------------------------------- */
-          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-
-          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-
-          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
-
-          psFilterNode->psRightNode->pszValue = msStrdup(pszLiteral);
-
-          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
-        } else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-
-      }
-
-      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsNull") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        if( pszPropertyName != NULL )
-        {
-            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-        }  else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      }
-
-      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsNil") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        if( pszPropertyName != NULL )
-        {
-            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-        }  else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      }
-    }
-    /* -------------------------------------------------------------------- */
-    /*      FeatureId Filter                                                */
-    /*                                                                      */
-    /*      <ogc:Filter>                                                    */
-    /*      <ogc:FeatureId fid="INWATERA_1M.1013"/>                         */
-    /*      <ogc:FeatureId fid="INWATERA_1M.10"/>                           */
-    /*      <ogc:FeatureId fid="INWATERA_1M.13"/>                           */
-    /*      <ogc:FeatureId fid="INWATERA_1M.140"/>                          */
-    /*      <ogc:FeatureId fid="INWATERA_1M.5001"/>                         */
-    /*      <ogc:FeatureId fid="INWATERA_1M.2001"/>                         */
-    /*      </ogc:Filter>                                                   */
-    /*                                                                      */
-    /*                                                                      */
-    /*      Note that for FES1.1.0 the featureid has been depricated in     */
-    /*      favor of GmlObjectId                                            */
-    /*      <GmlObjectId gml:id="TREESA_1M.1234"/>                          */
-    /*                                                                      */
-    /*      And in FES 2.0, in favor of <fes:ResourceId rid="foo.1234"/>    */
-    /* -------------------------------------------------------------------- */
-    else if (FLTIsFeatureIdFilterType(psXMLNode->pszValue)) {
-      psFilterNode->eType = FILTER_NODE_TYPE_FEATUREID;
-      pszFeatureIdList = NULL;
-
-      psFeatureIdNode = psXMLNode;
-      while (psFeatureIdNode) {
-        pszFeatureId = CPLGetXMLValue(psFeatureIdNode, "fid", NULL);
-        if (!pszFeatureId)
-          pszFeatureId = CPLGetXMLValue(psFeatureIdNode, "id", NULL);
-        if (!pszFeatureId)
-          pszFeatureId = CPLGetXMLValue(psFeatureIdNode, "rid", NULL);
-
-        if (pszFeatureId) {
-          if (pszFeatureIdList)
-            pszFeatureIdList = msStringConcatenate(pszFeatureIdList, ",");
-
-          pszFeatureIdList = msStringConcatenate(pszFeatureIdList, pszFeatureId);
-        }
-        psFeatureIdNode = psFeatureIdNode->psNext;
-      }
-
-      if (pszFeatureIdList) {
-        msFree(psFilterNode->pszValue);
-        psFilterNode->pszValue =  msStrdup(pszFeatureIdList);
-        msFree(pszFeatureIdList);
-      } else
-        psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-    }
-    
-    /* -------------------------------------------------------------------- */
-    /*      Temporal Filter.                                                */
-    /*
-    <fes:During>
-    <fes:ValueReference>gml:TimeInstant</fes:ValueReference>
-    <gml:TimePeriod gml:id="TP1">
-    <gml:begin>
-    <gml:TimeInstant gml:id="TI1">
-    <gml:timePosition>2005-05-17T00:00:00Z</gml:timePosition>
-    </gml:TimeInstant>
-    </gml:begin>
-    <gml:end>
-    <gml:TimeInstant gml:id="TI2">
-    <gml:timePosition>2005-05-23T00:00:00Z</gml:timePosition>
-    </gml:TimeInstant>
-    </gml:end>
-    </gml:TimePeriod>
-    </fes:During>
-    */
-    /* -------------------------------------------------------------------- */
-    else if (FLTIsTemporalFilterType(psXMLNode->pszValue)) {
-      psFilterNode->eType = FILTER_NODE_TYPE_TEMPORAL;
-
-      if (strcasecmp(psXMLNode->pszValue, "During") == 0) {
-        const char* pszPropertyName = NULL;
-        const char* pszBeginTime;
-        const char* pszEndTime;
-
-        pszPropertyName = FLTGetPropertyName(psXMLNode);
-        pszBeginTime = CPLGetXMLValue(psXMLNode, "TimePeriod.begin.TimeInstant.timePosition", NULL);
-        if( pszBeginTime == NULL )
-            pszBeginTime = CPLGetXMLValue(psXMLNode, "TimePeriod.beginPosition", NULL);
-        pszEndTime = CPLGetXMLValue(psXMLNode, "TimePeriod.end.TimeInstant.timePosition", NULL);
-        if( pszEndTime == NULL )
-            pszEndTime = CPLGetXMLValue(psXMLNode, "TimePeriod.endPosition", NULL);
-
-        if (pszPropertyName && pszBeginTime && pszEndTime &&
-            strchr(pszBeginTime, '\'') == NULL && strchr(pszBeginTime, '\\') == NULL &&
-            strchr(pszEndTime, '\'') == NULL && strchr(pszEndTime, '\\') == NULL &&
-            msTimeGetResolution(pszBeginTime) >= 0 &&
-            msTimeGetResolution(pszEndTime) >= 0) {
-
-          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psLeftNode->eType =  FILTER_NODE_TYPE_PROPERTYNAME;
-          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-
-          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_TIME_PERIOD;
-          psFilterNode->psRightNode->pszValue = static_cast<char*>(msSmallMalloc( strlen(pszBeginTime) + strlen(pszEndTime) + 2 ));
-          sprintf(psFilterNode->psRightNode->pszValue, "%s/%s", pszBeginTime, pszEndTime);
-        }
-        else
-          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      } else {
-        psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-      }
-
-    }/* end of is temporal */
-
-
-
-  }
-}
-
-
-/************************************************************************/
-/*            int FLTIsLogicalFilterType((char *pszValue)                  */
-/*                                                                      */
-/*      return TRUE if the value of the node is of logical filter       */
-/*       encoding type.                                                 */
-/************************************************************************/
-int FLTIsLogicalFilterType(const char *pszValue)
-{
-  if (pszValue) {
-    if (strcasecmp(pszValue, "AND") == 0 ||
-        strcasecmp(pszValue, "OR") == 0 ||
-        strcasecmp(pszValue, "NOT") == 0)
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*         int FLTIsBinaryComparisonFilterType(char *pszValue)             */
-/*                                                                      */
-/*      Binary comparison filter type.                                  */
-/************************************************************************/
-int FLTIsBinaryComparisonFilterType(const char *pszValue)
-{
-  if (pszValue) {
-    if (strcasecmp(pszValue, "PropertyIsEqualTo") == 0 ||
-        strcasecmp(pszValue, "PropertyIsNotEqualTo") == 0 ||
-        strcasecmp(pszValue, "PropertyIsLessThan") == 0 ||
-        strcasecmp(pszValue, "PropertyIsGreaterThan") == 0 ||
-        strcasecmp(pszValue, "PropertyIsLessThanOrEqualTo") == 0 ||
-        strcasecmp(pszValue, "PropertyIsGreaterThanOrEqualTo") == 0)
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*            int FLTIsComparisonFilterType(char *pszValue)                */
-/*                                                                      */
-/*      return TRUE if the value of the node is of comparison filter    */
-/*      encoding type.                                                  */
-/************************************************************************/
-int FLTIsComparisonFilterType(const char *pszValue)
-{
-  if (pszValue) {
-    if (FLTIsBinaryComparisonFilterType(pszValue) ||
-        strcasecmp(pszValue, "PropertyIsLike") == 0 ||
-        strcasecmp(pszValue, "PropertyIsBetween") == 0 ||
-        strcasecmp(pszValue, "PropertyIsNull") == 0 ||
-        strcasecmp(pszValue, "PropertyIsNil") == 0)
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*            int FLTIsFeatureIdFilterType(char *pszValue)              */
-/*                                                                      */
-/*      return TRUE if the value of the node is of featureid filter     */
-/*      encoding type.                                                  */
-/************************************************************************/
-int FLTIsFeatureIdFilterType(const char *pszValue)
-{
-  if (pszValue && (strcasecmp(pszValue, "FeatureId") == 0 ||
-                   strcasecmp(pszValue, "GmlObjectId") == 0 ||
-                   strcasecmp(pszValue, "ResourceId") == 0))
-
-    return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*            int FLTIsSpatialFilterType(char *pszValue)                */
-/*                                                                      */
-/*      return TRUE if the value of the node is of spatial filter       */
-/*      encoding type.                                                  */
-/************************************************************************/
-int FLTIsSpatialFilterType(const char *pszValue)
-{
-  if (pszValue) {
-    if ( strcasecmp(pszValue, "BBOX") == 0 ||
-         strcasecmp(pszValue, "DWithin") == 0 ||
-         strcasecmp(pszValue, "Intersect") == 0 ||
-         strcasecmp(pszValue, "Intersects") == 0 ||
-         strcasecmp(pszValue, "Equals") == 0 ||
-         strcasecmp(pszValue, "Disjoint") == 0 ||
-         strcasecmp(pszValue, "Touches") == 0 ||
-         strcasecmp(pszValue, "Crosses") == 0 ||
-         strcasecmp(pszValue, "Within") == 0 ||
-         strcasecmp(pszValue, "Contains") == 0 ||
-         strcasecmp(pszValue, "Overlaps") == 0 ||
-         strcasecmp(pszValue, "Beyond") == 0)
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*            int FLTIsTemportalFilterType(char *pszValue)              */
-/*                                                                      */
-/*      return TRUE if the value of the node is of temporal filter      */
-/*      encoding type.                                                  */
-/************************************************************************/
-int FLTIsTemporalFilterType(const char *pszValue)
-{
-  if (pszValue) {
-    if ( strcasecmp(pszValue, "During") == 0 )
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*           int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode)           */
-/*                                                                      */
-/*      Verfify if the value of the node is one of the supported        */
-/*      filter type.                                                    */
-/************************************************************************/
-int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode)
-{
-  if (psXMLNode) {
-    if (FLTIsLogicalFilterType(psXMLNode->pszValue) ||
-        FLTIsSpatialFilterType(psXMLNode->pszValue) ||
-        FLTIsComparisonFilterType(psXMLNode->pszValue) ||
-        FLTIsFeatureIdFilterType(psXMLNode->pszValue) ||
-        FLTIsTemporalFilterType(psXMLNode->pszValue))
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*                          FLTNumberOfFilterType                       */
-/*                                                                      */
-/*      Loop trhough the nodes and return the number of nodes of        */
-/*      specified value.                                                */
-/************************************************************************/
-int FLTNumberOfFilterType(FilterEncodingNode *psFilterNode, const char *szType)
-{
-  int nCount = 0;
-  int nLeftNode=0 , nRightNode = 0;
-
-  if (!psFilterNode || !szType || !psFilterNode->pszValue)
-    return 0;
-
-  if (strcasecmp(psFilterNode->pszValue, (char*)szType) == 0)
-    nCount++;
-
-  if (psFilterNode->psLeftNode)
-    nLeftNode = FLTNumberOfFilterType(psFilterNode->psLeftNode, szType);
-
-  nCount += nLeftNode;
-
-  if (psFilterNode->psRightNode)
-    nRightNode = FLTNumberOfFilterType(psFilterNode->psRightNode, szType);
-  nCount += nRightNode;
-
-  return nCount;
-}
-
-
-
-
-/************************************************************************/
-/*                          FLTValidForBBoxFilter                       */
-/*                                                                      */
-/*      Validate if there is only one BBOX filter node. Here is waht    */
-/*      is supported (is valid) :                                       */
-/*        - one node which is a BBOX                                    */
-/*        - a logical AND with a valid BBOX                             */
-/*                                                                      */
-/*      eg 1: <Filter>                                                  */
-/*            <BBOX>                                                    */
-/*              <PropertyName>Geometry</PropertyName>                   */
-/*              <gml:Box srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
-/*                <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
-/*              </gml:Box>                                              */
-/*            </BBOX>                                                   */
-/*          </Filter>                                                   */
-/*                                                                      */
-/*      eg 2 :<Filter>                                                  */
-/*              <AND>                                                   */
-/*               <BBOX>                                                 */
-/*                <PropertyName>Geometry</PropertyName>                  */
-/*                <gml:Box srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
-/*                  <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
-/*                </gml:Box>                                            */
-/*               </BBOX>                                                */
-/*               <PropertyIsEqualTo>                                    */
-/*               <PropertyName>SomeProperty</PropertyName>              */
-/*                <Literal>100</Literal>                                */
-/*              </PropertyIsEqualTo>                                    */
-/*             </AND>                                                   */
-/*           </Filter>                                                  */
-/*                                                                      */
-/************************************************************************/
-int FLTValidForBBoxFilter(FilterEncodingNode *psFilterNode)
-{
-  int nCount = 0;
-
-  if (!psFilterNode || !psFilterNode->pszValue)
-    return 1;
-
-  nCount = FLTNumberOfFilterType(psFilterNode, "BBOX");
-
-  if (nCount > 1)
-    return 0;
-  else if (nCount == 0)
-    return 1;
-
-  /* nCount ==1  */
-  if (strcasecmp(psFilterNode->pszValue, "BBOX") == 0)
-    return 1;
-
-  if (strcasecmp(psFilterNode->pszValue, "AND") == 0) {
-    return FLTValidForBBoxFilter(psFilterNode->psLeftNode) &&
-           FLTValidForBBoxFilter(psFilterNode->psRightNode);
-  }
-
-  return 0;
-}
-
-#if 0
-static int FLTHasUniqueTopLevelDuringFilter(FilterEncodingNode *psFilterNode)
-{
-  int nCount = 0;
-
-  if (!psFilterNode || !psFilterNode->pszValue)
-    return 1;
-
-  nCount = FLTNumberOfFilterType(psFilterNode, "During");
-
-  if (nCount > 1)
-    return 0;
-  else if (nCount == 0)
-    return 1;
-
-  /* nCount ==1  */
-  if (strcasecmp(psFilterNode->pszValue, "During") == 0)
-    return 1;
-
-  if (strcasecmp(psFilterNode->pszValue, "AND") == 0) {
-    return FLTHasUniqueTopLevelDuringFilter(psFilterNode->psLeftNode) &&
-           FLTHasUniqueTopLevelDuringFilter(psFilterNode->psRightNode);
-  }
-
-  return 0;
-}
-#endif
-
-int FLTIsLineFilter(FilterEncodingNode *psFilterNode)
-{
-  if (!psFilterNode || !psFilterNode->pszValue)
-    return 0;
-
-  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
-      psFilterNode->psRightNode &&
-      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_GEOMETRY_LINE)
-    return 1;
-
-  return 0;
-}
-
-int FLTIsPolygonFilter(FilterEncodingNode *psFilterNode)
-{
-  if (!psFilterNode || !psFilterNode->pszValue)
-    return 0;
-
-  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
-      psFilterNode->psRightNode &&
-      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_GEOMETRY_POLYGON)
-    return 1;
-
-  return 0;
-}
-
-int FLTIsPointFilter(FilterEncodingNode *psFilterNode)
-{
-  if (!psFilterNode || !psFilterNode->pszValue)
-    return 0;
-
-  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
-      psFilterNode->psRightNode &&
-      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_GEOMETRY_POINT)
-    return 1;
-
-  return 0;
-}
-
-int FLTIsBBoxFilter(FilterEncodingNode *psFilterNode)
-{
-  if (!psFilterNode || !psFilterNode->pszValue)
-    return 0;
-
-  if (strcasecmp(psFilterNode->pszValue, "BBOX") == 0)
-    return 1;
-
-  return 0;
-}
-
-shapeObj *FLTGetShape(FilterEncodingNode *psFilterNode, double *pdfDistance,
-                      int *pnUnit)
-{
-  char **tokens = NULL;
-  int nTokens = 0;
-  FilterEncodingNode *psNode = psFilterNode;
-  char *szUnitStr = NULL;
-  char *szUnit = NULL;
-
-  if (psNode) {
-    if (psNode->eType == FILTER_NODE_TYPE_SPATIAL && psNode->psRightNode)
-      psNode = psNode->psRightNode;
-
-    if (FLTIsGeometryFilterNodeType(psNode->eType)) {
-
-      if (psNode->pszValue && pdfDistance) {
-        /*
-        sytnax expected is "distance;unit" or just "distance"
-        if unit is there syntax is "URI#unit" (eg http://..../#m)
-        or just "unit"
-        */
-        tokens = msStringSplit(psNode->pszValue,';', &nTokens);
-        if (tokens && nTokens >= 1) {
-          *pdfDistance = atof(tokens[0]);
-
-          if (nTokens == 2 && pnUnit) {
-            szUnitStr = msStrdup(tokens[1]);
-            msFreeCharArray(tokens, nTokens);
-            nTokens = 0;
-            tokens = msStringSplit(szUnitStr,'#', &nTokens);
-            msFree(szUnitStr);
-            if (tokens && nTokens >= 1) {
-              if (nTokens ==1)
-                szUnit = tokens[0];
-              else
-                szUnit = tokens[1];
-
-              if (strcasecmp(szUnit,"m") == 0 ||
-                  strcasecmp(szUnit,"meters") == 0 )
-                *pnUnit = MS_METERS;
-              else if (strcasecmp(szUnit,"km") == 0 ||
-                       strcasecmp(szUnit,"kilometers") == 0)
-                *pnUnit = MS_KILOMETERS;
-              else if (strcasecmp(szUnit,"NM") == 0 ||
-                       strcasecmp(szUnit,"nauticalmiles") == 0)
-                *pnUnit = MS_NAUTICALMILES;
-              else if (strcasecmp(szUnit,"mi") == 0 ||
-                       strcasecmp(szUnit,"miles") == 0)
-                *pnUnit = MS_MILES;
-              else if (strcasecmp(szUnit,"in") == 0 ||
-                       strcasecmp(szUnit,"inches") == 0)
-                *pnUnit = MS_INCHES;
-              else if (strcasecmp(szUnit,"ft") == 0 ||
-                       strcasecmp(szUnit,"feet") == 0)
-                *pnUnit = MS_FEET;
-              else if (strcasecmp(szUnit,"deg") == 0 ||
-                       strcasecmp(szUnit,"dd") == 0)
-                *pnUnit = MS_DD;
-              else if (strcasecmp(szUnit,"px") == 0)
-                *pnUnit = MS_PIXELS;
-
-            }
-          }
-        } 
-        msFreeCharArray(tokens, nTokens);
-      }
-
-      return (shapeObj *)psNode->pOther;
-    }
-  }
-  return NULL;
-}
-
-/************************************************************************/
-/*                                FLTGetBBOX                            */
-/*                                                                      */
-/*      Loop through the nodes are return the coordinates of the        */
-/*      first bbox node found. The retrun value is the epsg code of     */
-/*      the bbox.                                                       */
-/************************************************************************/
-const char *FLTGetBBOX(FilterEncodingNode *psFilterNode, rectObj *psRect)
-{
-  const char *pszReturn = NULL;
-
-  if (!psFilterNode || !psRect)
-    return NULL;
-
-  if (psFilterNode->pszValue && strcasecmp(psFilterNode->pszValue, "BBOX") == 0) {
-    if (psFilterNode->psRightNode && psFilterNode->psRightNode->pOther) {
-      rectObj* pRect= (rectObj *)psFilterNode->psRightNode->pOther;
-      psRect->minx = pRect->minx;
-      psRect->miny = pRect->miny;
-      psRect->maxx = pRect->maxx;
-      psRect->maxy = pRect->maxy;
-
-      return psFilterNode->pszSRS;
-
-    }
-  } else {
-    pszReturn = FLTGetBBOX(psFilterNode->psLeftNode, psRect);
-    if (pszReturn)
-      return pszReturn;
-    else
-      return  FLTGetBBOX(psFilterNode->psRightNode, psRect);
-  }
-
-  return pszReturn;
-}
-
-const char* FLTGetDuring(FilterEncodingNode *psFilterNode, const char** ppszTimeField)
-{
-  const char *pszReturn = NULL;
-
-  if (!psFilterNode || !ppszTimeField)
-    return NULL;
-
-  if (psFilterNode->pszValue && strcasecmp(psFilterNode->pszValue, "During") == 0) {
-    *ppszTimeField = psFilterNode->psLeftNode->pszValue;
-    return psFilterNode->psRightNode->pszValue;
-  } else {
-    pszReturn = FLTGetDuring(psFilterNode->psLeftNode, ppszTimeField);
-    if (pszReturn)
-      return pszReturn;
-    else
-      return  FLTGetDuring(psFilterNode->psRightNode, ppszTimeField);
-  }
-
-  return pszReturn;
-}
-
-/************************************************************************/
-/*                           FLTGetSQLExpression                        */
-/*                                                                      */
-/*      Build SQL expressions from the mapserver nodes.                 */
-/************************************************************************/
-char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  char *pszExpression = NULL;
-
-  if (psFilterNode == NULL || lp == NULL)
-    return NULL;
-
-  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON) {
-    if ( psFilterNode->psLeftNode && psFilterNode->psRightNode) {
-      if (FLTIsBinaryComparisonFilterType(psFilterNode->pszValue)) {
-        pszExpression =
-          FLTGetBinaryComparisonSQLExpresssion(psFilterNode, lp);
-      } else if (strcasecmp(psFilterNode->pszValue,
-                            "PropertyIsBetween") == 0) {
-        pszExpression =
-          FLTGetIsBetweenComparisonSQLExpresssion(psFilterNode, lp);
-      } else if (strcasecmp(psFilterNode->pszValue,
-                            "PropertyIsLike") == 0) {
-        pszExpression =
-          FLTGetIsLikeComparisonSQLExpression(psFilterNode, lp);
-
-      }
-    }
-  } else if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL) {
-    if (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
-        strcasecmp(psFilterNode->pszValue, "OR") == 0) {
-      pszExpression =
-        FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
-
-    } else if (strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
-      pszExpression =
-        FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
-
-    }
-  }
-
-  else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL) {
-    /* TODO */
-  } else if (psFilterNode->eType == FILTER_NODE_TYPE_FEATUREID) {
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-    if (psFilterNode->pszValue) {
-      const char *pszAttribute = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
-      if (pszAttribute) {
-        int nTokens = 0;
-        char **tokens = msStringSplit(psFilterNode->pszValue,',', &nTokens);
-        int bString = 0;
-        if (tokens && nTokens > 0) {
-          for (int i=0; i<nTokens; i++) {
-            char *pszEscapedStr = NULL;
-            const char* pszId = tokens[i];
-            const char* pszDot = strchr(pszId, '.');
-            if( pszDot )
-                pszId = pszDot + 1;
-
-            if (strlen(pszId) <= 0)
-              continue;
-
-            if (FLTIsNumeric(pszId) == MS_FALSE)
-              bString = 1;
-
-            pszEscapedStr = msLayerEscapeSQLParam(lp, pszId);
-            char szTmp[256];
-            if (bString)
-            {
-              if( lp->connectiontype == MS_OGR || lp->connectiontype == MS_POSTGIS )
-                snprintf(szTmp, sizeof(szTmp), "(CAST(%s AS CHARACTER(255)) = '%s')" , pszAttribute, pszEscapedStr);
-              else
-                snprintf(szTmp, sizeof(szTmp), "(%s = '%s')" , pszAttribute, pszEscapedStr);
-            }
-            else
-              snprintf(szTmp, sizeof(szTmp), "(%s = %s)" , pszAttribute, pszEscapedStr);
-
-            msFree(pszEscapedStr);
-            pszEscapedStr=NULL;
-
-            if (pszExpression != NULL)
-              pszExpression = msStringConcatenate(pszExpression, " OR ");
-            else
-              /*opening and closing brackets*/
-              pszExpression = msStringConcatenate(pszExpression, "(");
-
-            pszExpression = msStringConcatenate(pszExpression, szTmp);
-          }
-        }
-        msFreeCharArray(tokens, nTokens);
-      }
-      /*opening and closing brackets*/
-      if (pszExpression)
-        pszExpression = msStringConcatenate(pszExpression, ")");
-    }
-#else
-    msSetError(MS_MISCERR, "OWS support is not available.",
-               "FLTGetSQLExpression()");
-    return NULL;
-#endif
-
-  }
-  else if ( lp->connectiontype != MS_OGR &&
-            psFilterNode->eType == FILTER_NODE_TYPE_TEMPORAL )
-    pszExpression = msStrdup(FLTGetTimeExpression(psFilterNode, lp).c_str());
-
-  return pszExpression;
-}
-
-/************************************************************************/
-/*                     FLTGetLogicalComparisonSQLExpresssion            */
-/*                                                                      */
-/*      Return the expression for logical comparison expression.        */
-/************************************************************************/
-char *FLTGetLogicalComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
-  char *pszBuffer = NULL;
-  char *pszTmp = NULL;
-
-  if (lp == NULL)
-    return NULL;
-
-  /* ==================================================================== */
-  /*      special case for BBOX node.                                     */
-  /* ==================================================================== */
-  if (psFilterNode->psLeftNode && psFilterNode->psRightNode &&
-      ((strcasecmp(psFilterNode->psLeftNode->pszValue, "BBOX") == 0) ||
-       (strcasecmp(psFilterNode->psRightNode->pszValue, "BBOX") == 0))) {
-    if (strcasecmp(psFilterNode->psLeftNode->pszValue, "BBOX") != 0)
-      pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
-    else
-      pszTmp = FLTGetSQLExpression(psFilterNode->psRightNode, lp);
-
-    if (!pszTmp)
-      return NULL;
-
-    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) + 1));
-    sprintf(pszBuffer, "%s", pszTmp);
-  }
-
-  /* ==================================================================== */
-  /*      special case for temporal filter node (OGR layer only)          */
-  /* ==================================================================== */
-  else if (lp->connectiontype == MS_OGR &&
-      psFilterNode->psLeftNode && psFilterNode->psRightNode &&
-      (psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_TEMPORAL ||
-       psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_TEMPORAL) ) {
-    if (psFilterNode->psLeftNode->eType != FILTER_NODE_TYPE_TEMPORAL)
-      pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
-    else
-      pszTmp = FLTGetSQLExpression(psFilterNode->psRightNode, lp);
-
-    if (!pszTmp)
-      return NULL;
-
-    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) + 1));
-    sprintf(pszBuffer, "%s", pszTmp);
-  }
-  
-  /* -------------------------------------------------------------------- */
-  /*      OR and AND                                                      */
-  /* -------------------------------------------------------------------- */
-  else if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
-    pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
-    if (!pszTmp)
-      return NULL;
-
-    pszBuffer = (char *)malloc(sizeof(char) *
-                               (strlen(pszTmp) +
-                                strlen(psFilterNode->pszValue) + 5));
-    pszBuffer[0] = '\0';
-    strcat(pszBuffer, " (");
-    strcat(pszBuffer, pszTmp);
-    strcat(pszBuffer, " ");
-    strcat(pszBuffer, psFilterNode->pszValue);
-    strcat(pszBuffer, " ");
-
-    free( pszTmp );
-
-    const size_t nTmp = strlen(pszBuffer);
-    pszTmp = FLTGetSQLExpression(psFilterNode->psRightNode, lp);
-    if (!pszTmp) {
-      free(pszBuffer);
-      return NULL;
-    }
-
-    pszBuffer = (char *)msSmallRealloc(pszBuffer,
-                                sizeof(char) * (strlen(pszTmp) + nTmp +3));
-    strcat(pszBuffer, pszTmp);
-    strcat(pszBuffer, ") ");
-  }
-  /* -------------------------------------------------------------------- */
-  /*      NOT                                                             */
-  /* -------------------------------------------------------------------- */
-  else if (psFilterNode->psLeftNode &&
-           strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
-    pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
-    if (!pszTmp)
-      return NULL;
-
-    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) +  9));
-    pszBuffer[0] = '\0';
-
-    strcat(pszBuffer, " (NOT ");
-    strcat(pszBuffer, pszTmp);
-    strcat(pszBuffer, ") ");
-  } else
-    return NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Cleanup.                                                        */
-  /* -------------------------------------------------------------------- */
-  if( pszTmp != NULL )
-    free( pszTmp );
-  return pszBuffer;
-
-}
-
-
-/************************************************************************/
-/*                      FLTGetBinaryComparisonSQLExpresssion            */
-/*                                                                      */
-/*      Return the expression for a binary comparison filter node.      */
-/************************************************************************/
-char *FLTGetBinaryComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
-  const size_t bufferSize = 1024;
-  char szBuffer[1024];
-  int bString=0;
-  char szTmp[256];
-  char* pszEscapedStr = NULL;
-
-  szBuffer[0] = '\0';
-  if (!psFilterNode || !
-      FLTIsBinaryComparisonFilterType(psFilterNode->pszValue))
-    return NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      check if the value is a numeric value or alphanumeric. If it    */
-  /*      is alphanumeric, add quotes around attribute and values.        */
-  /* -------------------------------------------------------------------- */
-  bString = 0;
-  if (psFilterNode->psRightNode->pszValue) {
-    const char* pszOFGType;
-    snprintf(szTmp, sizeof(szTmp), "%s_type",  psFilterNode->psLeftNode->pszValue);
-    pszOFGType = msOWSLookupMetadata(&(lp->metadata), "OFG", szTmp);
-    if (pszOFGType!= NULL && strcasecmp(pszOFGType, "Character") == 0)
-      bString = 1;
-
-    else if (FLTIsNumeric(psFilterNode->psRightNode->pszValue) == MS_FALSE)
-      bString = 1;
-  }
-
-  /* specical case to be able to have empty strings in the expression. */
-  if (psFilterNode->psRightNode->pszValue == NULL)
-    bString = 1;
-
-
-  /*opening bracket*/
-  strlcat(szBuffer, " (", bufferSize);
-
-  pszEscapedStr = msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
-
-
-  /* attribute */
-  /*case insensitive set ? */
-  if (bString &&
-      strcasecmp(psFilterNode->pszValue,
-                 "PropertyIsEqualTo") == 0 &&
-      psFilterNode->psRightNode->pOther &&
-      (*(int *)psFilterNode->psRightNode->pOther) == 1) {
-    snprintf(szTmp, sizeof(szTmp), "lower(%s) ",  pszEscapedStr);
-    strlcat(szBuffer, szTmp, bufferSize);
-  } else
-    strlcat(szBuffer, pszEscapedStr, bufferSize);
-
-  msFree(pszEscapedStr);
-  pszEscapedStr = NULL;
-
-
-  /* logical operator */
-  if (strcasecmp(psFilterNode->pszValue,
-                 "PropertyIsEqualTo") == 0)
-    strlcat(szBuffer, "=", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsNotEqualTo") == 0)
-    strlcat(szBuffer, "<>", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsLessThan") == 0)
-    strlcat(szBuffer, "<", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsGreaterThan") == 0)
-    strlcat(szBuffer, ">", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsLessThanOrEqualTo") == 0)
-    strlcat(szBuffer, "<=", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsGreaterThanOrEqualTo") == 0)
-    strlcat(szBuffer, ">=", bufferSize);
-
-  strlcat(szBuffer, " ", bufferSize);
-
-  /* value */
-
-  if (bString &&
-      psFilterNode->psRightNode->pszValue &&
-      strcasecmp(psFilterNode->pszValue,
-                 "PropertyIsEqualTo") == 0 &&
-      psFilterNode->psRightNode->pOther &&
-      (*(int *)psFilterNode->psRightNode->pOther) == 1) {
-    char* pszEscapedStr;
-    pszEscapedStr = msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
-    snprintf(szTmp, sizeof(szTmp), "lower('%s') ", pszEscapedStr);
-    msFree(pszEscapedStr);
-    strlcat(szBuffer, szTmp, bufferSize);
-  } else {
-    if (bString)
-      strlcat(szBuffer, "'", bufferSize);
-
-    if (psFilterNode->psRightNode->pszValue) {
-      if (bString) {
-        char* pszEscapedStr;
-        pszEscapedStr = msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
-        strlcat(szBuffer, pszEscapedStr, bufferSize);
-        msFree(pszEscapedStr);
-        pszEscapedStr=NULL;
-      } else
-        strlcat(szBuffer, psFilterNode->psRightNode->pszValue, bufferSize);
-    }
-
-    if (bString)
-      strlcat(szBuffer, "'", bufferSize);
-
-  }
-  /*closing bracket*/
-  strlcat(szBuffer, ") ", bufferSize);
-
-  return msStrdup(szBuffer);
-}
-
-
-/************************************************************************/
-/*                    FLTGetIsBetweenComparisonSQLExpresssion           */
-/*                                                                      */
-/*      Build an SQL expresssion for IsBteween Filter.                  */
-/************************************************************************/
-char *FLTGetIsBetweenComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
-  const size_t bufferSize = 1024;
-  char szBuffer[1024];
-  char **aszBounds = NULL;
-  int nBounds = 0;
-  int bString=0;
-  char szTmp[256];
-  char* pszEscapedStr;
-
-  szBuffer[0] = '\0';
-  if (!psFilterNode ||
-      !(strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0))
-    return NULL;
-
-  if (!psFilterNode->psLeftNode || !psFilterNode->psRightNode )
-    return NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Get the bounds value which are stored like boundmin;boundmax    */
-  /* -------------------------------------------------------------------- */
-  aszBounds = msStringSplit(psFilterNode->psRightNode->pszValue, ';', &nBounds);
-  if (nBounds != 2) {
-    msFreeCharArray(aszBounds, nBounds);
-    return NULL;
-  }
-  /* -------------------------------------------------------------------- */
-  /*      check if the value is a numeric value or alphanumeric. If it    */
-  /*      is alphanumeric, add quotes around attribute and values.        */
-  /* -------------------------------------------------------------------- */
-  bString = 0;
-  if (aszBounds[0]) {
-    const char* pszOFGType;
-    snprintf(szTmp, sizeof(szTmp), "%s_type",  psFilterNode->psLeftNode->pszValue);
-    pszOFGType = msOWSLookupMetadata(&(lp->metadata), "OFG", szTmp);
-    if (pszOFGType!= NULL && strcasecmp(pszOFGType, "Character") == 0)
-      bString = 1;
-    else if (FLTIsNumeric(aszBounds[0]) == MS_FALSE)
-      bString = 1;
-  }
-  if (!bString) {
-    if (aszBounds[1]) {
-      if (FLTIsNumeric(aszBounds[1]) == MS_FALSE)
-        bString = 1;
-    }
-  }
-
-
-  /* -------------------------------------------------------------------- */
-  /*      build expresssion.                                              */
-  /* -------------------------------------------------------------------- */
-  /*opening paranthesis */
-  strlcat(szBuffer, " (", bufferSize);
-
-  /* attribute */
-  pszEscapedStr = msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
-
-  strlcat(szBuffer, pszEscapedStr, bufferSize);
-  msFree(pszEscapedStr);
-  pszEscapedStr = NULL;
-
-  /*between*/
-  strlcat(szBuffer, " BETWEEN ", bufferSize);
-
-  /*bound 1*/
-  if (bString)
-    strlcat(szBuffer,"'", bufferSize);
-  pszEscapedStr = msLayerEscapeSQLParam( lp, aszBounds[0]);
-  strlcat(szBuffer, pszEscapedStr, bufferSize);
-  msFree(pszEscapedStr);
-  pszEscapedStr=NULL;
-
-  if (bString)
-    strlcat(szBuffer,"'", bufferSize);
-
-  strlcat(szBuffer, " AND ", bufferSize);
-
-  /*bound 2*/
-  if (bString)
-    strlcat(szBuffer, "'", bufferSize);
-  pszEscapedStr = msLayerEscapeSQLParam( lp, aszBounds[1]);
-  strlcat(szBuffer, pszEscapedStr, bufferSize);
-  msFree(pszEscapedStr);
-  pszEscapedStr=NULL;
-
-  if (bString)
-    strlcat(szBuffer,"'", bufferSize);
-
-  /*closing paranthesis*/
-  strlcat(szBuffer, ")", bufferSize);
-
-  msFreeCharArray(aszBounds, nBounds);
-
-  return msStrdup(szBuffer);
-}
-
-/************************************************************************/
-/*                      FLTGetIsLikeComparisonSQLExpression             */
-/*                                                                      */
-/*      Build an sql expression for IsLike filter.                      */
-/************************************************************************/
-char *FLTGetIsLikeComparisonSQLExpression(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
-  const size_t bufferSize = 1024;
-  char szBuffer[1024];
-  char *pszValue = NULL;
-
-  const char *pszWild = NULL;
-  const char *pszSingle = NULL;
-  const char *pszEscape = NULL;
-  char szTmp[4];
-
-  int nLength=0, i=0, j=0;
-  int  bCaseInsensitive = 0;
-
-  char *pszEscapedStr = NULL;
-  FEPropertyIsLike* propIsLike;
-
-  if (!psFilterNode || !psFilterNode->pOther || !psFilterNode->psLeftNode ||
-      !psFilterNode->psRightNode || !psFilterNode->psRightNode->pszValue)
-    return NULL;
-
-  propIsLike = (FEPropertyIsLike *)psFilterNode->pOther;
-  pszWild = propIsLike->pszWildCard;
-  pszSingle = propIsLike->pszSingleChar;
-  pszEscape = propIsLike->pszEscapeChar;
-  bCaseInsensitive = propIsLike->bCaseInsensitive;
-
-  if (!pszWild || strlen(pszWild) == 0 ||
-      !pszSingle || strlen(pszSingle) == 0 ||
-      !pszEscape || strlen(pszEscape) == 0)
-    return NULL;
-
-  if (pszEscape[0] == '\'') {
-    /* This might be valid, but the risk of SQL injection is too high */
-    /* and the below code is not ready for that */
-    /* Someone who does this has clearly suspect intentions ! */
-    msSetError(MS_MISCERR, "Single quote character is not allowed as an escaping character.",
-               "FLTGetIsLikeComparisonSQLExpression()");
-    return NULL;
-  }
-
-
-  szBuffer[0] = '\0';
-  /*opening bracket*/
-  strlcat(szBuffer, " (", bufferSize);
-
-  /* attribute name */
-  pszEscapedStr = msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
-
-  strlcat(szBuffer, pszEscapedStr, bufferSize);
-  msFree(pszEscapedStr);
-  pszEscapedStr = NULL;
-
-  if (lp->connectiontype == MS_POSTGIS) {
-    if (bCaseInsensitive == 1)
-      strlcat(szBuffer, "::text ilike '", bufferSize);
-    else
-      strlcat(szBuffer, "::text like '", bufferSize);
-  } else
-    strlcat(szBuffer, " like '", bufferSize);
-
-  pszValue = psFilterNode->psRightNode->pszValue;
-  nLength = strlen(pszValue);
-
-  pszEscapedStr = (char*) msSmallMalloc( 3 * nLength + 1);
-
-  for (i=0, j=0; i<nLength; i++) {
-    char c = pszValue[i];
-    if (c != pszWild[0] &&
-        c != pszSingle[0] &&
-        c != pszEscape[0]) {
-      if (c == '\'') {
-        pszEscapedStr[j++] = '\'';
-        pszEscapedStr[j++] = '\'';
-      } else if (c == '\\') {
-        pszEscapedStr[j++] = '\\';
-        pszEscapedStr[j++] = '\\';
-      } else
-        pszEscapedStr[j++] = c;
-    } else if  (c == pszSingle[0]) {
-      pszEscapedStr[j++] = '_';
-    } else if  (c == pszEscape[0]) {
-      pszEscapedStr[j++] = pszEscape[0];
-      if (i+1<nLength) {
-        char nextC = pszValue[i+1];
-        i++;
-        if (nextC == '\'') {
-          pszEscapedStr[j++] = '\'';
-          pszEscapedStr[j++] = '\'';
-        } else
-          pszEscapedStr[j++] = nextC;
-      }
-    } else if (c == pszWild[0]) {
-      pszEscapedStr[j++] = '%';
-    }
-  }
-  pszEscapedStr[j++] = 0;
-  strlcat(szBuffer, pszEscapedStr, bufferSize);
-  msFree(pszEscapedStr);
-
-  strlcat(szBuffer, "'", bufferSize);
-  if (lp->connectiontype != MS_OGR) {
-    if (lp->connectiontype == MS_POSTGIS && pszEscape[0] == '\\')
-        strlcat(szBuffer, " escape E'", bufferSize);
-    else
-        strlcat(szBuffer, " escape '", bufferSize);
-    szTmp[0] = pszEscape[0];
-    if (pszEscape[0] == '\\') {
-      szTmp[1] = '\\';
-      szTmp[2] = '\'';
-      szTmp[3] = '\0';
-    } else {
-      szTmp[1] = '\'';
-      szTmp[2] = '\0';
-    }
-
-    strlcat(szBuffer,  szTmp, bufferSize);
-  }
-  strlcat(szBuffer,  ") ", bufferSize);
-
-  return msStrdup(szBuffer);
-}
-
-/************************************************************************/
-/*                           FLTHasSpatialFilter                        */
-/*                                                                      */
-/*      Utility function to see if a spatial filter is included in      */
-/*      the node.                                                       */
-/************************************************************************/
-int FLTHasSpatialFilter(FilterEncodingNode *psNode)
-{
-  int bResult = MS_FALSE;
-
-  if (!psNode)
-    return MS_FALSE;
-
-  if (psNode->eType == FILTER_NODE_TYPE_LOGICAL) {
-    if (psNode->psLeftNode)
-      bResult = FLTHasSpatialFilter(psNode->psLeftNode);
-
-    if (bResult)
-      return MS_TRUE;
-
-    if (psNode->psRightNode)
-      bResult = FLTHasSpatialFilter(psNode->psRightNode);
-
-    if (bResult)
-      return MS_TRUE;
-  } else if (FLTIsBBoxFilter(psNode) || FLTIsPointFilter(psNode) ||
-             FLTIsLineFilter(psNode) || FLTIsPolygonFilter(psNode))
-    return MS_TRUE;
-
-
-  return MS_FALSE;
-}
-
-
-/************************************************************************/
-/*                     FLTCreateFeatureIdFilterEncoding                 */
-/*                                                                      */
-/*      Utility function to create a filter node of FeatureId type.     */
-/************************************************************************/
-FilterEncodingNode *FLTCreateFeatureIdFilterEncoding(const char *pszString)
-{
-  FilterEncodingNode *psFilterNode = NULL;
-
-  if (pszString) {
-    psFilterNode = FLTCreateFilterEncodingNode();
-    psFilterNode->eType = FILTER_NODE_TYPE_FEATUREID;
-    psFilterNode->pszValue =  msStrdup(pszString);
-    return psFilterNode;
-  }
-  return NULL;
-}
-
-
-/************************************************************************/
-/*                              FLTParseGMLBox                          */
-/*                                                                      */
-/*      Parse gml box. Used for FE 1.0                                  */
-/************************************************************************/
-int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox, char **ppszSRS)
-{
-  int bCoordinatesValid = 0;
-  CPLXMLNode *psCoordinates = NULL;
-  CPLXMLNode *psCoord1 = NULL, *psCoord2 = NULL;
-  char **papszCoords=NULL, **papszMin=NULL, **papszMax = NULL;
-  int nCoords = 0, nCoordsMin = 0, nCoordsMax = 0;
-  const char *pszTmpCoord = NULL;
-  const char *pszSRS = NULL;
-  const char *pszTS = NULL;
-  const char *pszCS = NULL;
-  double minx = 0.0, miny = 0.0, maxx = 0.0, maxy = 0.0;
-
-  if (psBox) {
-    pszSRS = CPLGetXMLValue(psBox, "srsName", NULL);
-    if (ppszSRS && pszSRS)
-      *ppszSRS = msStrdup(pszSRS);
-
-    psCoordinates = CPLGetXMLNode(psBox, "coordinates");
-    pszTS = CPLGetXMLValue(psCoordinates, "ts", NULL);
-    if( pszTS == NULL )
-        pszTS = " ";
-    pszCS = CPLGetXMLValue(psCoordinates, "cs", NULL);
-    if( pszCS == NULL )
-        pszCS = ",";
-    pszTmpCoord = CPLGetXMLValue(psCoordinates, NULL, NULL);
-
-    if (pszTmpCoord) {
-      papszCoords = msStringSplit(pszTmpCoord, pszTS[0], &nCoords);
-      if (papszCoords && nCoords == 2) {
-        papszMin = msStringSplit(papszCoords[0], pszCS[0], &nCoordsMin);
-        if (papszMin && nCoordsMin == 2) {
-          papszMax = msStringSplit(papszCoords[1], pszCS[0], &nCoordsMax);
-        }
-        if (papszMax && nCoordsMax == 2) {
-          bCoordinatesValid =1;
-          minx =  atof(papszMin[0]);
-          miny =  atof(papszMin[1]);
-          maxx =  atof(papszMax[0]);
-          maxy =  atof(papszMax[1]);
-        }
-
-        msFreeCharArray(papszMin, nCoordsMin);
-        msFreeCharArray(papszMax, nCoordsMax);
-      }
-
-      msFreeCharArray(papszCoords, nCoords);
-    } else {
-      psCoord1 = CPLGetXMLNode(psBox, "coord");
-      psCoord2 = FLTGetNextSibblingNode(psCoord1);
-      if (psCoord1 && psCoord2 && strcmp(psCoord2->pszValue, "coord") == 0) {
-        const char* pszX = CPLGetXMLValue(psCoord1, "X", NULL);
-        const char* pszY = CPLGetXMLValue(psCoord1, "Y", NULL);
-        if (pszX && pszY) {
-          minx = atof(pszX);
-          miny = atof(pszY);
-
-          pszX = CPLGetXMLValue(psCoord2, "X", NULL);
-          pszY = CPLGetXMLValue(psCoord2, "Y", NULL);
-          if (pszX && pszY) {
-            maxx = atof(pszX);
-            maxy = atof(pszY);
-            bCoordinatesValid = 1;
-          }
-        }
-      }
-
-    }
-  }
-
-  if (bCoordinatesValid) {
-    psBbox->minx =  minx;
-    psBbox->miny =  miny;
-
-    psBbox->maxx =  maxx;
-    psBbox->maxy =  maxy;
-  }
-
-  return bCoordinatesValid;
-}
-/************************************************************************/
-/*                           FLTParseGMLEnvelope                        */
-/*                                                                      */
-/*      Utility function to parse a gml:Envelope (used for SOS and FE1.1)*/
-/************************************************************************/
-int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox, char **ppszSRS)
-{
-  CPLXMLNode *psUpperCorner=NULL, *psLowerCorner=NULL;
-  const char *pszLowerCorner=NULL, *pszUpperCorner=NULL;
-  int bValid = 0;
-  char **tokens;
-  int n;
-
-  if (psRoot && psBbox && psRoot->eType == CXT_Element &&
-      EQUAL(psRoot->pszValue,"Envelope")) {
-    /*Get the srs if available*/
-    if (ppszSRS) {
-      const char* pszSRS = CPLGetXMLValue(psRoot, "srsName", NULL);
-      if( pszSRS != NULL )
-          *ppszSRS = msStrdup(pszSRS);
-    }
-    psLowerCorner = CPLSearchXMLNode(psRoot, "lowerCorner");
-    psUpperCorner = CPLSearchXMLNode(psRoot, "upperCorner");
-
-    if (psLowerCorner && psUpperCorner) {
-      pszLowerCorner = CPLGetXMLValue(psLowerCorner, NULL, NULL);
-      pszUpperCorner = CPLGetXMLValue(psUpperCorner, NULL, NULL);
-
-      if (pszLowerCorner && pszUpperCorner) {
-        tokens = msStringSplit(pszLowerCorner, ' ', &n);
-        if (tokens && n >= 2) {
-          psBbox->minx = atof(tokens[0]);
-          psBbox->miny = atof(tokens[1]);
-
-          msFreeCharArray(tokens, n);
-
-          tokens = msStringSplit(pszUpperCorner, ' ', &n);
-          if (tokens && n >= 2) {
-            psBbox->maxx = atof(tokens[0]);
-            psBbox->maxy = atof(tokens[1]);
-            bValid = 1;
-          }
-        }
-        msFreeCharArray(tokens, n);
-      }
-    }
-  }
-
-  return bValid;
-}
-
-/************************************************************************/
-/*                        FLTNeedSRSSwapping                            */
-/************************************************************************/
-
-static int FLTNeedSRSSwapping( mapObj *map, const char* pszSRS )
-{
-    int bNeedSwapping = MS_FALSE;
-    projectionObj sProjTmp;
-    msInitProjection(&sProjTmp);
-    if( map )
-    {
-        msProjectionInheritContextFrom(&sProjTmp, &map->projection);
-    }
-    if (msLoadProjectionStringEPSG(&sProjTmp, pszSRS) == 0) {
-        bNeedSwapping = msIsAxisInvertedProj(&sProjTmp);
-    }
-    msFreeProjection(&sProjTmp);
-    return bNeedSwapping;
-}
-
-/************************************************************************/
-/*                      FLTDoAxisSwappingIfNecessary                    */
-/*                                                                      */
-/*      Explore all geometries and BBOX to do axis swapping when the    */
-/*      SRS requires it. If no explicit SRS is attached to the geometry */
-/*      the bDefaultSRSNeedsAxisSwapping is taken into account. The     */
-/*      caller will have to determine its value from a more general     */
-/*      context.                                                        */
-/************************************************************************/
-void FLTDoAxisSwappingIfNecessary(mapObj *map, 
-                                  FilterEncodingNode *psFilterNode,
-                                  int bDefaultSRSNeedsAxisSwapping)
-{
-    if( psFilterNode == NULL )
-        return;
-
-    if( psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
-        psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_BBOX )
-    {
-        rectObj* rect = (rectObj *)psFilterNode->psRightNode->pOther;
-        const char* pszSRS = psFilterNode->pszSRS;
-        if( (pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
-            (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping) )
-        {
-            double tmp;
-
-            tmp = rect->minx;
-            rect->minx = rect->miny;
-            rect->miny = tmp;
-
-            tmp = rect->maxx;
-            rect->maxx = rect->maxy;
-            rect->maxy = tmp;
-        }
-    }
-    else if( psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
-             FLTIsGeometryFilterNodeType(psFilterNode->psRightNode->eType) )
-    {
-        shapeObj* shape = (shapeObj *)(psFilterNode->psRightNode->pOther);
-        const char* pszSRS = psFilterNode->pszSRS;
-        if( (pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
-            (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping) )
-        {
-            msAxisSwapShape(shape);
-        }
-    }
-    else
-    {
-        FLTDoAxisSwappingIfNecessary(map, psFilterNode->psLeftNode, bDefaultSRSNeedsAxisSwapping);
-        FLTDoAxisSwappingIfNecessary(map, psFilterNode->psRightNode, bDefaultSRSNeedsAxisSwapping);
-    }
-}
-
-
-static void FLTReplacePropertyName(FilterEncodingNode *psFilterNode,
-                                   const char *pszOldName,
-                                   const char *pszNewName)
-{
-  if (psFilterNode && pszOldName && pszNewName) {
-    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
-      if (psFilterNode->pszValue &&
-          strcasecmp(psFilterNode->pszValue, pszOldName) == 0) {
-        msFree(psFilterNode->pszValue);
-        psFilterNode->pszValue = msStrdup(pszNewName);
-      }
-    }
-    if (psFilterNode->psLeftNode)
-      FLTReplacePropertyName(psFilterNode->psLeftNode, pszOldName,
-                             pszNewName);
-    if (psFilterNode->psRightNode)
-      FLTReplacePropertyName(psFilterNode->psRightNode, pszOldName,
-                             pszNewName);
-  }
-}
-
-
-static int FLTIsGMLDefaultProperty(const char* pszName)
-{
-    return (strcmp(pszName, "gml:name") == 0 ||
-            strcmp(pszName, "gml:description") == 0 ||
-            strcmp(pszName, "gml:descriptionReference") == 0 ||
-            strcmp(pszName, "gml:identifier") == 0 ||
-            strcmp(pszName, "gml:boundedBy") == 0 ||
-            strcmp(pszName, "@gml:id") == 0);
-}
-
-static void FLTStripNameSpacesFromPropertyName(FilterEncodingNode *psFilterNode)
-{
-  char **tokens=NULL;
-  int n=0;
-
-  if (psFilterNode) {
-
-    if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME &&
-        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) )
-    {
-        return;
-    }
-
-    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
-      if (psFilterNode->pszValue &&
-          strstr(psFilterNode->pszValue, ":")) {
-        tokens = msStringSplit(psFilterNode->pszValue, ':', &n);
-        if (tokens && n==2) {
-          msFree(psFilterNode->pszValue);
-          psFilterNode->pszValue = msStrdup(tokens[1]);
-        }
-        msFreeCharArray(tokens, n);
-      }
-    }
-    if (psFilterNode->psLeftNode)
-      FLTStripNameSpacesFromPropertyName(psFilterNode->psLeftNode);
-    if (psFilterNode->psRightNode)
-      FLTStripNameSpacesFromPropertyName(psFilterNode->psRightNode);
-  }
-
-}
-
-static void FLTRemoveGroupName(FilterEncodingNode *psFilterNode,
-                               gmlGroupListObj* groupList)
-{
-  int i;
-
-  if (psFilterNode) {
-
-    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
-      if( psFilterNode->pszValue != NULL )
-      {
-        const char* pszPropertyName = psFilterNode->pszValue;
-        const char* pszSlash = strchr(pszPropertyName, '/');
-        if( pszSlash != NULL ) {
-          const char* pszColon = strchr(pszPropertyName, ':');
-          if( pszColon != NULL && pszColon < pszSlash )
-              pszPropertyName = pszColon + 1;
-          for(i=0;i<groupList->numgroups;i++) {
-            const char* pszGroupName = groupList->groups[i].name;
-            size_t nGroupNameLen = strlen(pszGroupName);
-            if(strncasecmp(pszPropertyName, pszGroupName, nGroupNameLen) == 0 &&
-                            pszPropertyName[nGroupNameLen] == '/') {
-              char* pszTmp;
-              pszPropertyName = pszPropertyName + nGroupNameLen + 1;
-              pszColon = strchr(pszPropertyName, ':');
-              if( pszColon != NULL )
-                pszPropertyName = pszColon + 1;
-              pszTmp = msStrdup(pszPropertyName);
-              msFree(psFilterNode->pszValue);
-              psFilterNode->pszValue = pszTmp;
-              break;
-            }
-          }
-        }
-      }
-    }
-
-    if (psFilterNode->psLeftNode)
-      FLTRemoveGroupName(psFilterNode->psLeftNode, groupList);
-    if (psFilterNode->psRightNode)
-      FLTRemoveGroupName(psFilterNode->psRightNode, groupList);
-  }
-
-}
-
-/************************************************************************/
-/*                    FLTPreParseFilterForAliasAndGroup                 */
-/*                                                                      */
-/*      Utility function to replace aliased' and grouped attributes     */
-/*      with their internal name.                                       */
-/************************************************************************/
-void FLTPreParseFilterForAliasAndGroup(FilterEncodingNode *psFilterNode,
-                               mapObj *map, int i, const char *namespaces)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-  if (psFilterNode && map && i>=0 && i<map->numlayers) {
-    /*strip name spaces before hand*/
-    FLTStripNameSpacesFromPropertyName(psFilterNode);
-
-    layerObj *lp = GET_LAYER(map, i);
-    int layerWasOpened = msLayerIsOpen(lp);
-    if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-
-      /* Remove group names from property names if using groupname/itemname syntax */
-      gmlGroupListObj* groupList = msGMLGetGroups(lp, namespaces);
-      if( groupList && groupList->numgroups > 0 )
-        FLTRemoveGroupName(psFilterNode, groupList);
-      msGMLFreeGroups(groupList);
-
-      for(i=0; i<lp->numitems; i++) {
-        if (!lp->items[i] || strlen(lp->items[i]) <= 0)
-          continue;
-        char szTmp[256];
-        snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
-        const char *pszFullName = msOWSLookupMetadata(&(lp->metadata), namespaces, szTmp);
-        if (pszFullName) {
-          FLTReplacePropertyName(psFilterNode, pszFullName,
-                                 lp->items[i]);
-        }
-      }
-      if (!layerWasOpened) /* do not close the layer if it has been opened somewhere else (paging?) */
-        msLayerClose(lp);
-    }
-  }
-#else
-  msSetError(MS_MISCERR, "OWS support is not available.",
-             "FLTPreParseFilterForAlias()");
-
-#endif
-}
-
-/************************************************************************/
-/*                        FLTCheckFeatureIdFilters                      */
-/*                                                                      */
-/*      Check that FeatureId filters match features in the active       */
-/*      layer.                                                          */
-/************************************************************************/
-int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode,
-                             mapObj *map, int i)
-{
-    int status = MS_SUCCESS;
-    
-    if (psFilterNode->eType ==  FILTER_NODE_TYPE_FEATUREID)
-    {
-        char** tokens;
-        int nTokens = 0;
-        layerObj* lp;
-        int j;
-
-        lp = GET_LAYER(map, i);
-        tokens = msStringSplit(psFilterNode->pszValue,',', &nTokens);
-        for (j=0; j<nTokens; j++) {
-            const char* pszId = tokens[j];
-            const char* pszDot = strrchr(pszId, '.');
-            if( pszDot )
-            {
-                if( static_cast<size_t>(pszDot - pszId) != strlen(lp->name) ||
-                    strncasecmp(pszId, lp->name, strlen(lp->name)) != 0 )
-                {
-                    msSetError(MS_MISCERR, "Feature id %s not consistent with feature type name %s.",
-                               "FLTPreParseFilterForAlias()", pszId, lp->name);
-                    status = MS_FAILURE;
-                    break;
-                }
-            }
-        }
-        msFreeCharArray(tokens, nTokens);
-    }
-
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTCheckFeatureIdFilters(psFilterNode->psLeftNode, map, i);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTCheckFeatureIdFilters(psFilterNode->psRightNode, map, i);
-      }
-    }
-    return status;
-}
-
-/************************************************************************/
-/*                        FLTCheckInvalidOperand                        */
-/*                                                                      */
-/*      Check that the operand of a comparison operator is valid        */
-/*      Currently only detects use of boundedBy in a binary comparison  */
-/************************************************************************/
-int FLTCheckInvalidOperand(FilterEncodingNode *psFilterNode)
-{
-    int status = MS_SUCCESS;
-
-    if (psFilterNode->eType ==  FILTER_NODE_TYPE_COMPARISON &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME)
-    {
-        if( strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") == 0 &&
-            strcmp(psFilterNode->pszValue, "PropertyIsNull") != 0 &&
-            strcmp(psFilterNode->pszValue, "PropertyIsNil") != 0 )
-        {
-            msSetError(MS_MISCERR, "Operand '%s' is invalid in comparison.",
-                       "FLTCheckInvalidOperand()", psFilterNode->psLeftNode->pszValue);
-            return MS_FAILURE;
-        }
-    }
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTCheckInvalidOperand(psFilterNode->psLeftNode);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTCheckInvalidOperand(psFilterNode->psRightNode);
-      }
-    }
-    return status;
-}
-
-/************************************************************************/
-/*                       FLTProcessPropertyIsNull                       */
-/*                                                                      */
-/*      HACK for PropertyIsNull processing. PostGIS & Spatialite only   */
-/*      for now.                                                        */
-/************************************************************************/
-int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i)
-{
-    int status = MS_SUCCESS;
-
-    if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME &&
-        strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
-        !FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) )
-    {
-        layerObj* lp;
-        int layerWasOpened;
-
-        lp = GET_LAYER(map, i);
-        layerWasOpened = msLayerIsOpen(lp);
-
-        /* Horrible HACK to compensate for the lack of null testing in MapServer */
-        if( (lp->connectiontype == MS_POSTGIS ||
-             (lp->connectiontype == MS_OGR && msOGRSupportsIsNull(lp))) &&
-            strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 )
-        {
-            msFree(psFilterNode->pszValue);
-            psFilterNode->pszValue = msStrdup("PropertyIsEqualTo");
-            psFilterNode->psRightNode = FLTCreateBinaryCompFilterEncodingNode();
-            psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
-            psFilterNode->psRightNode->pszValue = msStrdup("_MAPSERVER_NULL_");
-        }
-
-        if (!layerWasOpened) /* do not close the layer if it has been opened somewhere else (paging?) */
-          msLayerClose(lp);
-    }
-
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTProcessPropertyIsNull(psFilterNode->psLeftNode, map, i);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTProcessPropertyIsNull(psFilterNode->psRightNode, map, i);
-      }
-    }
-    return status;
-}
-
-/************************************************************************/
-/*                        FLTCheckInvalidProperty                       */
-/*                                                                      */
-/*      Check that property names are known                             */
-/************************************************************************/
-int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i)
-{
-    int status = MS_SUCCESS;
-
-    if (psFilterNode->eType ==  FILTER_NODE_TYPE_COMPARISON &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME)
-    {
-        layerObj* lp;
-        int layerWasOpened;
-        int bFound = MS_FALSE;
-
-        if ((strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
-             strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0) && 
-             FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) )
-        {
-            return MS_SUCCESS;
-        }
-
-        lp = GET_LAYER(map, i);
-        layerWasOpened = msLayerIsOpen(lp);
-        if ((layerWasOpened || msLayerOpen(lp) == MS_SUCCESS) 
-             && msLayerGetItems(lp) == MS_SUCCESS) {
-          int i;
-          gmlItemListObj* items = msGMLGetItems(lp, "G");
-          for(i=0; i<items->numitems; i++) {
-            if (!items->items[i].name || strlen(items->items[i].name) == 0 ||
-                !items->items[i].visible)
-              continue;
-            if (strcasecmp(items->items[i].name, psFilterNode->psLeftNode->pszValue) == 0) {
-                bFound = MS_TRUE;
-                break;
-            }
-          }
-          msGMLFreeItems(items);
-        }
-
-        if (!layerWasOpened) /* do not close the layer if it has been opened somewhere else (paging?) */
-          msLayerClose(lp);
-
-        if( !bFound )
-        {
-            msSetError(MS_MISCERR, "Property '%s' is unknown.",
-                       "FLTCheckInvalidProperty()", psFilterNode->psLeftNode->pszValue);
-            return MS_FAILURE;
-        }
-    }
-
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTCheckInvalidProperty(psFilterNode->psLeftNode, map, i);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTCheckInvalidProperty(psFilterNode->psRightNode, map, i);
-      }
-    }
-    return status;
-}
-
-/************************************************************************/
-/*                           FLTSimplify                                */
-/*                                                                      */
-/*      Simplify the expression by removing parts that evaluate to      */
-/*      constants.                                                      */
-/*      The passed psFilterNode is potentially consumed by the function */
-/*      and replaced by the returned value.                             */
-/*      If the function returns NULL, *pnEvaluation = MS_FALSE means    */
-/*      that  the filter evaluates to FALSE, or MS_TRUE that it         */
-/*      evaluates to TRUE                                               */
-/************************************************************************/
-FilterEncodingNode* FLTSimplify(FilterEncodingNode *psFilterNode,
-                                int* pnEvaluation)
-{
-    *pnEvaluation = -1;
-
-    /* There are no nullable or nillable property in WFS currently */
-    /* except gml:name or gml:description that are null */
-    if( psFilterNode->eType ==  FILTER_NODE_TYPE_COMPARISON &&
-        (strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
-         strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0 ) &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME )
-    {
-        if( strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
-            FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) &&
-            strcmp(psFilterNode->psLeftNode->pszValue, "@gml:id") != 0  &&
-            strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") != 0)
-            *pnEvaluation = MS_TRUE;
-        else
-            *pnEvaluation = MS_FALSE;
-        FLTFreeFilterEncodingNode(psFilterNode);
-        return NULL;
-    }
-
-    if( psFilterNode->eType ==  FILTER_NODE_TYPE_LOGICAL &&
-        strcasecmp(psFilterNode->pszValue, "NOT") == 0 &&
-        psFilterNode->psLeftNode != NULL )
-    {
-        int nEvaluation;
-        psFilterNode->psLeftNode = FLTSimplify(psFilterNode->psLeftNode,
-                                               &nEvaluation);
-        if( psFilterNode->psLeftNode == NULL )
-        {
-            *pnEvaluation = 1 - nEvaluation;
-            FLTFreeFilterEncodingNode(psFilterNode);
-            return NULL;
-        }
-    }
-
-    if( psFilterNode->eType ==  FILTER_NODE_TYPE_LOGICAL &&
-        (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
-         strcasecmp(psFilterNode->pszValue, "OR") == 0) &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psRightNode != NULL )
-    {
-        FilterEncodingNode* psOtherNode;
-        int nEvaluation;
-        int nExpectedValForFastExit;
-        psFilterNode->psLeftNode = FLTSimplify(psFilterNode->psLeftNode,
-                                               &nEvaluation);
-
-        if( strcasecmp(psFilterNode->pszValue, "AND") == 0 )
-            nExpectedValForFastExit = MS_FALSE;
-        else
-            nExpectedValForFastExit = MS_TRUE;
-
-        if( psFilterNode->psLeftNode == NULL )
-        {
-            if( nEvaluation == nExpectedValForFastExit )
-            {
-                *pnEvaluation = nEvaluation;
-                FLTFreeFilterEncodingNode(psFilterNode);
-                return NULL;
-            }
-            psOtherNode = psFilterNode->psRightNode;
-            psFilterNode->psRightNode = NULL;
-            FLTFreeFilterEncodingNode(psFilterNode);
-            return FLTSimplify(psOtherNode, pnEvaluation);
-        }
- 
-        psFilterNode->psRightNode = FLTSimplify(psFilterNode->psRightNode,
-                                                &nEvaluation);
-        if( psFilterNode->psRightNode == NULL )
-        {
-            if( nEvaluation == nExpectedValForFastExit )
-            {
-                *pnEvaluation = nEvaluation;
-                FLTFreeFilterEncodingNode(psFilterNode);
-                return NULL;
-            }
-            psOtherNode = psFilterNode->psLeftNode;
-            psFilterNode->psLeftNode = NULL;
-            FLTFreeFilterEncodingNode(psFilterNode);
-            return FLTSimplify(psOtherNode, pnEvaluation);
-        }
-    }
-
-    return psFilterNode;
-}
-
-
-#ifdef USE_LIBXML2
-
-xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent, xmlNsPtr psNsOgc, int bTemporal)
-{
-  xmlNodePtr psRootNode = NULL, psNode = NULL, psSubNode = NULL, psSubSubNode = NULL;
-
-  psRootNode = xmlNewNode(psNsParent, BAD_CAST "Filter_Capabilities");
-
-  psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Spatial_Capabilities", NULL);
-
-  psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "GeometryOperands", NULL);
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:Point");
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:LineString");
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:Polygon");
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:Envelope");
-
-  psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "SpatialOperators", NULL);
-#ifdef USE_GEOS
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Equals");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Disjoint");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Touches");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Within");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Overlaps");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Crosses");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Intersects");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Contains");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "DWithin");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Beyond");
-#endif
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
-  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "BBOX");
-
-  if (bTemporal) {
-    psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Temporal_Capabilities", NULL);
-    psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "TemporalOperands", NULL);
-    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand", BAD_CAST "gml:TimePeriod");
-    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand", BAD_CAST "gml:TimeInstant");
-
-    psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "TemporalOperators", NULL);
-    psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperator", NULL);
-    xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "TM_Equals");
-  }
-  psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Scalar_Capabilities", NULL);
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "LogicalOperators", NULL);
-  psNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperators", NULL);
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "LessThan");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "GreaterThan");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "LessThanEqualTo");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "GreaterThanEqualTo");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "EqualTo");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "NotEqualTo");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "Like");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "Between");
-
-  psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Id_Capabilities", NULL);
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "EID", NULL);
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "FID", NULL);
-  return psRootNode;
-}
-#endif
diff -pruN 8.0.1-5/mapogcfilter.h 8.2.0~beta1-1~exp1/mapogcfilter.h
--- 8.0.1-5/mapogcfilter.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcfilter.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,153 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC Filter Encoding implementation
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#ifndef MAPOGCFILTER_H
-#define MAPOGCFILTER_H
-
-#include "mapserver.h"
-
-/* There is a dependency to OGR for the MiniXML parser */
-#include "cpl_minixml.h"
-
-#ifdef USE_LIBXML2
-
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-#endif
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-typedef struct {
-  char *pszWildCard;
-  char *pszSingleChar;
-  char *pszEscapeChar;
-  int  bCaseInsensitive;
-} FEPropertyIsLike;
-
-/* -------------------------------------------------------------------- */
-/*      prototypes.                                                     */
-/* -------------------------------------------------------------------- */
-MS_DLL_EXPORT int FLTIsNumeric(const char *pszValue);
-MS_DLL_EXPORT int FLTApplyExpressionToLayer(layerObj *lp, const char *pszExpression);
-MS_DLL_EXPORT  char *FLTGetExpressionForValuesRanges(layerObj *lp, const char *item, const char *value,  int forcecharcter);
-
-MS_DLL_EXPORT FilterEncodingNode *FLTParseFilterEncoding(const char *szXMLString);
-MS_DLL_EXPORT FilterEncodingNode *FLTCreateFilterEncodingNode(void);
-MS_DLL_EXPORT char** FLTSplitFilters(const char* pszStr, int* pnTokens);
-MS_DLL_EXPORT int FLTApplyFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-                                        int iLayerIndex);
-
-MS_DLL_EXPORT int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-    int iLayerIndex);
-MS_DLL_EXPORT int FLTLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-    int iLayerIndex);
-
-MS_DLL_EXPORT void FLTFreeFilterEncodingNode(FilterEncodingNode *psFilterNode);
-
-MS_DLL_EXPORT int FLTValidFilterNode(FilterEncodingNode *psFilterNode);
-MS_DLL_EXPORT int FLTValidForBBoxFilter(FilterEncodingNode *psFilterNode);
-MS_DLL_EXPORT int FLTNumberOfFilterType(FilterEncodingNode *psFilterNode,
-                                        const char *szType);
-MS_DLL_EXPORT int FLTIsBBoxFilter(FilterEncodingNode *psFilterNode);
-MS_DLL_EXPORT int FLTIsPointFilter(FilterEncodingNode *psFilterNode);
-MS_DLL_EXPORT int FLTIsLineFilter(FilterEncodingNode *psFilterNode);
-MS_DLL_EXPORT int FLTIsPolygonFilter(FilterEncodingNode *psFilterNode);
-
-MS_DLL_EXPORT int FLTValidForPropertyIsLikeFilter(FilterEncodingNode *psFilterNode);
-MS_DLL_EXPORT int FLTIsOnlyPropertyIsLike(FilterEncodingNode *psFilterNode);
-
-MS_DLL_EXPORT void FLTInsertElementInNode(FilterEncodingNode *psFilterNode,
-    CPLXMLNode *psXMLNode);
-MS_DLL_EXPORT int FLTIsLogicalFilterType(const char *pszValue);
-MS_DLL_EXPORT int FLTIsBinaryComparisonFilterType(const char *pszValue);
-MS_DLL_EXPORT int FLTIsComparisonFilterType(const char *pszValue);
-MS_DLL_EXPORT int FLTIsFeatureIdFilterType(const char *pszValue);
-MS_DLL_EXPORT int FLTIsSpatialFilterType(const char *pszValue);
-MS_DLL_EXPORT int FLTIsTemporalFilterType(const char *pszValue);
-MS_DLL_EXPORT int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode);
-
-MS_DLL_EXPORT const char *FLTGetBBOX(FilterEncodingNode *psFilterNode, rectObj *psRect);
-const char* FLTGetDuring(FilterEncodingNode *psFilterNode, const char** ppszTimeField);
-
-MS_DLL_EXPORT shapeObj *FLTGetShape(FilterEncodingNode *psFilterNode, double *pdfDistance,
-                                    int *pnUnit);
-
-MS_DLL_EXPORT int FLTHasSpatialFilter(FilterEncodingNode *psFilterNode);
-
-
-/*SQL expressions related functions.*/
-MS_DLL_EXPORT int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode, mapObj *map,
-    int iLayerIndex);
-
-MS_DLL_EXPORT char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode,layerObj *lp);
-MS_DLL_EXPORT char *FLTGetBinaryComparisonSQLExpresssion(FilterEncodingNode *psFilterNode, layerObj *lp);
-MS_DLL_EXPORT char *FLTGetIsBetweenComparisonSQLExpresssion(FilterEncodingNode *psFilterNode, layerObj *lp);
-MS_DLL_EXPORT char *FLTGetIsLikeComparisonSQLExpression(FilterEncodingNode *psFilterNode, layerObj *lp);
-
-MS_DLL_EXPORT char *FLTGetLogicalComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp);
-MS_DLL_EXPORT int FLTIsSimpleFilter(FilterEncodingNode *psFilterNode);
-
-MS_DLL_EXPORT FilterEncodingNode *FLTCreateFeatureIdFilterEncoding(const char *pszString);
-
-MS_DLL_EXPORT int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox, char **ppszSRS);
-MS_DLL_EXPORT  int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox, char **ppszSRS);
-
-/*common-expressions*/
-MS_DLL_EXPORT  char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp);
-MS_DLL_EXPORT int FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex, const char *pszExpression);
-
-#ifdef USE_LIBXML2
-MS_DLL_EXPORT xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent, xmlNsPtr psNsOgc, int bTemporal);
-#endif
-
-void FLTDoAxisSwappingIfNecessary(mapObj *map, FilterEncodingNode *psFilterNode, int bDefaultSRSNeedsAxisSwapping);
-
-void FLTPreParseFilterForAliasAndGroup(FilterEncodingNode *psFilterNode,
-                                       mapObj *map, int i, const char *namespaces);
-int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode,
-                             mapObj *map, int i);
-int FLTCheckInvalidOperand(FilterEncodingNode *psFilterNode);
-int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i);
-FilterEncodingNode* FLTSimplify(FilterEncodingNode *psFilterNode,
-                                int* pnEvaluation);
-int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex, const char *pszExpression, rectObj rect);
-int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i);
-int FLTLayerSetInvalidRectIfSupported(layerObj* lp, rectObj* rect);
-
-#ifdef __cplusplus
-}
-std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode, layerObj *lp);
-
-#endif
-
-#endif
diff -pruN 8.0.1-5/mapogcfiltercommon.cpp 8.2.0~beta1-1~exp1/mapogcfiltercommon.cpp
--- 8.0.1-5/mapogcfiltercommon.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcfiltercommon.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,666 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC Filter Encoding implementation
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapogcfilter.h"
-#include "mapserver.h"
-#include "mapows.h"
-#include "mapowscommon.h"
-#include "cpl_minixml.h"
-
-#include <string>
-
-static std::string FLTGetIsLikeComparisonCommonExpression(FilterEncodingNode *psFilterNode)
-{
-  /* From http://pubs.opengroup.org/onlinepubs/009695399/basedefs/xbd_chap09.html#tag_09_04 */
-  /* also add double quote because we are within a string */
-  const char* pszRegexSpecialCharsAndDoubleQuote = "\\^${[().*+?|\"";
-
-  if (!psFilterNode || !psFilterNode->pOther || !psFilterNode->psLeftNode || !psFilterNode->psRightNode || !psFilterNode->psRightNode->pszValue)
-    return std::string();
-
-  const FEPropertyIsLike* propIsLike = (const FEPropertyIsLike *)psFilterNode->pOther;
-  const char* pszWild = propIsLike->pszWildCard;
-  const char* pszSingle = propIsLike->pszSingleChar;
-  const char* pszEscape = propIsLike->pszEscapeChar;
-  const bool bCaseInsensitive = propIsLike->bCaseInsensitive != 0;
-
-  if (!pszWild || strlen(pszWild) == 0 || !pszSingle || strlen(pszSingle) == 0 || !pszEscape || strlen(pszEscape) == 0)
-    return std::string();
-
-  /* -------------------------------------------------------------------- */
-  /*      Use operand with regular expressions.                           */
-  /* -------------------------------------------------------------------- */
-  std::string expr("(\"[");
-
-  /* attribute */
-  expr += psFilterNode->psLeftNode->pszValue;
-
-  /* #3521 */
-  if (bCaseInsensitive )
-    expr += "]\" ~* \"";
-  else
-    expr += "]\" ~ \"";
-
-  const char* pszValue = psFilterNode->psRightNode->pszValue;
-  const size_t nLength = strlen(pszValue);
-
-  if (nLength > 0) {
-    expr += '^';
-  }
-  for (size_t i=0; i<nLength; i++) {
-    if (pszValue[i] == pszSingle[0]) {
-      expr += '.';
-    /* The Filter escape character is supposed to only escape the single, wildcard and escape character */
-    } else if (pszValue[i] == pszEscape[0] && (
-                    pszValue[i+1] == pszSingle[0] ||
-                    pszValue[i+1] == pszWild[0] ||
-                    pszValue[i+1] == pszEscape[0])) {
-      if( pszValue[i+1] == '\\' )
-      {
-          /* Tricky case: \ must be escaped ncce in the regular expression context
-             so that the regexp matches it as an ordinary character.
-             But as \ is also the escape character for MapServer string, we
-             must escape it again. */
-          expr += "\\" "\\" "\\" "\\";
-      }
-      else
-      {
-        /* If the escaped character is itself a regular expression special character */
-        /* we need to regular-expression-escape-it ! */
-        if( strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i+1]) )
-        {
-            expr += '\\';
-        }
-        expr += pszValue[i+1];
-      }
-      i++;
-    } else if (pszValue[i] == pszWild[0]) {
-      expr += ".*";
-    }
-    /* Escape regular expressions special characters and double quote */
-    else if (strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i]))
-    {
-      if( pszValue[i] == '\\' )
-      {
-          /* See above explantation */
-          expr += "\\" "\\" "\\" "\\";
-      }
-      else
-      {
-        expr += '\\';
-        expr += pszValue[i];
-      }
-    }
-    else {
-      expr += pszValue[i];
-    }
-  }
-  if (nLength > 0) {
-    expr += '$';
-  }
-  expr += "\")";
-  return expr;
-}
-
-static std::string FLTGetIsBetweenComparisonCommonExpresssion(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  if (psFilterNode->psLeftNode == NULL || psFilterNode->psRightNode == NULL )
-    return std::string();
-
-  /* -------------------------------------------------------------------- */
-  /*      Get the bounds value which are stored like boundmin;boundmax    */
-  /* -------------------------------------------------------------------- */
-  const auto bounds = msStringSplit(psFilterNode->psRightNode->pszValue, ';');
-  if (bounds.size() != 2) {
-    return std::string();
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      check if the value is a numeric value or alphanumeric. If it    */
-  /*      is alphanumeric, add quotes around attribute and values.        */
-  /* -------------------------------------------------------------------- */
-  bool bString = false;
-  bool bDateTime = false;
-
-  const char* pszType = msOWSLookupMetadata(&(lp->metadata), "OFG",
-    (std::string(psFilterNode->psLeftNode->pszValue)+ "_type").c_str());
-  if (pszType != NULL && (strcasecmp(pszType, "Character") == 0))
-    bString = true;
-  else if (pszType != NULL && (strcasecmp(pszType, "Date") == 0))
-    bDateTime = true;
-  else if (FLTIsNumeric(bounds[0].c_str()) == MS_FALSE)
-    bString = true;
-
-  if (!bString && !bDateTime) {
-      if (FLTIsNumeric(bounds[1].c_str()) == MS_FALSE)
-        bString = true;
-  }
-
-  std::string expr;
-  /* -------------------------------------------------------------------- */
-  /*      build expresssion.                                              */
-  /* -------------------------------------------------------------------- */
-  /* attribute */
-  if (bString)
-    expr += "(\"[";
-  else
-    expr += "([";
-
-  expr += psFilterNode->psLeftNode->pszValue;
-
-  if (bString)
-    expr += "]\" ";
-  else
-    expr += "] ";
-
-  expr += " >= ";
-
-  if (bString) {
-    expr += '\"';
-  }
-  else if (bDateTime) {
-    expr += '`';
-  }
-
-  expr += msStdStringEscape(bounds[0].c_str());
-
-  if (bString) {
-    expr += '\"';
-  }
-  else if (bDateTime) {
-    expr += '`';
-  }
-
-  expr += " AND ";
-
-  if (bString)
-    expr += " \"[";
-  else
-    expr += " [";
-
-  /* attribute */
-  expr += psFilterNode->psLeftNode->pszValue;
-
-  if (bString)
-    expr += "]\" ";
-  else
-    expr += "] ";
-
-  expr += " <= ";
-
-  if (bString) {
-    expr += '\"';
-  }
-  else if (bDateTime) {
-    expr += '`';
-  }
-
-  expr += msStdStringEscape(bounds[1].c_str());
-
-  if (bString) {
-    expr += '\"';
-  }
-  else if (bDateTime) {
-    expr += '`';
-  }
-  expr += ')';
-
-  return expr;
-}
-
-static
-std::string FLTGetBinaryComparisonCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  /* -------------------------------------------------------------------- */
-  /*      check if the value is a numeric value or alphanumeric. If it    */
-  /*      is alphanumeric, add quotes around attribute and values.        */
-  /* -------------------------------------------------------------------- */
-  bool bString = false;
-  bool bDateTime = false;
-  if (psFilterNode->psRightNode->pszValue) {
-    const char* pszType = msOWSLookupMetadata(&(lp->metadata), "OFG",
-        (std::string(psFilterNode->psLeftNode->pszValue) + "_type").c_str());
-    if (pszType!= NULL && (strcasecmp(pszType, "Character") == 0))
-      bString = true;
-    else if (pszType!= NULL && (strcasecmp(pszType, "Date") == 0))
-      bDateTime = true;
-    else if (FLTIsNumeric(psFilterNode->psRightNode->pszValue) == MS_FALSE)
-      bString = true;
-  }
-
-  /* specical case to be able to have empty strings in the expression. */
-  /* propertyislike is always treated as string */
-  if (psFilterNode->psRightNode->pszValue == NULL || strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
-    bString = true;
-
-  /* attribute */
-  std::string expr;
-  if (bString)
-    expr = "(\"[";
-  else
-    expr = "([";
-  expr += psFilterNode->psLeftNode->pszValue;
-  
-  if (bString)
-    expr += "]\" ";
-  else
-    expr += "] ";
-
-  if (strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0) {
-    /* case insensitive set ? */
-    if (psFilterNode->psRightNode->pOther && (*(int *)psFilterNode->psRightNode->pOther) == 1)
-      expr += "=*";
-    else
-      expr += "=";
-  } else if (strcasecmp(psFilterNode->pszValue, "PropertyIsNotEqualTo") == 0)
-    expr += "!=";
-  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThan") == 0)
-    expr += "<";
-  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsGreaterThan") == 0)
-    expr += ">";
-  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThanOrEqualTo") == 0)
-    expr += "<=";
-  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsGreaterThanOrEqualTo") == 0)
-    expr += ">=";
-  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
-    expr += "~";
-  expr += ' ';
-
-  /* value */
-  if (bString) {
-    expr += "\"";
-  }
-  else if (bDateTime) {
-    expr += "`";
-  }
-
-  if (psFilterNode->psRightNode->pszValue) {
-    expr += msStdStringEscape(psFilterNode->psRightNode->pszValue);
-  }
-
-  if (bString) {
-    expr += "\"";
-  }
-  else if (bDateTime) {
-    expr += "`";
-  }
-
-  expr += ")";
-
-  return expr;
-}
-
-static
-std::string FLTGetLogicalComparisonCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  std::string expr;
-  /* -------------------------------------------------------------------- */
-  /*      OR and AND                                                      */
-  /* -------------------------------------------------------------------- */
-  if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
-    char* pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
-    if (!pszTmp)
-      return std::string();
-
-    expr = '(';
-    expr += pszTmp;
-    msFree(pszTmp);
-    expr += ' ';
-    expr += psFilterNode->pszValue;
-    expr += ' ';
-
-    pszTmp = FLTGetCommonExpression(psFilterNode->psRightNode, lp);
-    if (!pszTmp) {
-      return std::string();
-    }
-
-    expr += pszTmp;
-    msFree(pszTmp);
-    expr += ')';
-  }
-  /* -------------------------------------------------------------------- */
-  /*      NOT                                                             */
-  /* -------------------------------------------------------------------- */
-  else if (psFilterNode->psLeftNode && strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
-    char* pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
-    if (!pszTmp)
-      return std::string();
-
-    expr = "(NOT ";
-    expr += pszTmp;
-    msFree(pszTmp);
-    expr += ')';
-  }
-
-  return expr;
-}
-
-static
-std::string FLTGetSpatialComparisonCommonExpression(FilterEncodingNode *psNode, layerObj *lp)
-{
-  std::string expr;
-  double dfDistance = -1;
-  shapeObj *psTmpShape=NULL;
-  bool bBBoxQuery = false;
-  bool bAlreadyReprojected = false;
-
-  if (lp == NULL)
-    return std::string();
-
-  /* get the shape */
-  if (FLTIsBBoxFilter(psNode)) {
-    rectObj sQueryRect;
-    FLTGetBBOX(psNode, &sQueryRect);
-
-    char szPolygon[512];
-    snprintf(szPolygon, sizeof(szPolygon),
-             "POLYGON((%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f %.18f))",
-             sQueryRect.minx, sQueryRect.miny,
-             sQueryRect.minx, sQueryRect.maxy,
-             sQueryRect.maxx, sQueryRect.maxy,
-             sQueryRect.maxx, sQueryRect.miny,
-             sQueryRect.minx, sQueryRect.miny);
-
-    psTmpShape = msShapeFromWKT(szPolygon);
-
-    /* 
-    ** This is a horrible hack to deal with world-extent requests and
-    ** reprojection. msProjectRect() detects if reprojection from longlat to 
-    ** projected SRS, and in that case it transforms the bbox to -1e-15,-1e-15,1e15,1e15
-    ** to ensure that all features are returned.
-    **
-    ** Make wfs_200_cite_filter_bbox_world.xml and wfs_200_cite_postgis_bbox_world.xml pass
-    */
-    if (fabs(sQueryRect.minx - -180.0) < 1e-5 &&
-        fabs(sQueryRect.miny - -90.0) < 1e-5 &&
-        fabs(sQueryRect.maxx - 180.0) < 1e-5 &&
-        fabs(sQueryRect.maxy - 90.0) < 1e-5)
-    {
-      if (lp->projection.numargs > 0) {
-        projectionObj sProjTmp;
-        if (psNode->pszSRS) {
-          msInitProjection(&sProjTmp);
-          msProjectionInheritContextFrom(&sProjTmp, &lp->projection);
-        }
-        if (psNode->pszSRS) {
-          /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
-          if (msLoadProjectionString(&sProjTmp, psNode->pszSRS) == 0) {
-            msProjectRect(&sProjTmp, &lp->projection, &sQueryRect);
-          }
-        } else if (lp->map->projection.numargs > 0)
-          msProjectRect(&lp->map->projection, &lp->projection, &sQueryRect);
-        if (psNode->pszSRS)
-          msFreeProjection(&sProjTmp);
-      }
-      if (sQueryRect.minx <= -1e14) {
-        msFreeShape(psTmpShape);
-        msFree(psTmpShape);
-        psTmpShape = (shapeObj*) msSmallMalloc(sizeof(shapeObj));
-        msInitShape(psTmpShape);
-        msRectToPolygon(sQueryRect, psTmpShape);
-        bAlreadyReprojected = true;
-      }
-    }
-
-    bBBoxQuery = true;
-  } else {
-    /* other geos type operations */
-
-    /* project shape to layer projection. If the proj is not part of the filter query,
-      assume that the cooredinates are in the map projection */
-
-    int nUnit = -1;
-    shapeObj* psQueryShape = FLTGetShape(psNode, &dfDistance, &nUnit);
-
-    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 || strcasecmp(psNode->pszValue, "Beyond") == 0 ) && dfDistance > 0) {
-      int nLayerUnit = lp->units;
-      if(nLayerUnit == -1) nLayerUnit = GetMapserverUnitUsingProj(&lp->projection);
-      if(nLayerUnit == -1) nLayerUnit = lp->map->units;
-      if(nLayerUnit == -1) nLayerUnit = GetMapserverUnitUsingProj(&lp->map->projection);
-
-      if (nUnit >= 0 && nUnit != nLayerUnit)
-        dfDistance *= msInchesPerUnit(nUnit,0)/msInchesPerUnit(nLayerUnit,0); /* target is layer units */
-    }
-
-    psTmpShape = psQueryShape;
-  }
-
-  if (psTmpShape) {
-
-    /*
-    ** target is layer projection
-    */
-    if (!bAlreadyReprojected && lp->projection.numargs > 0) {
-      projectionObj sProjTmp;
-      if (psNode->pszSRS) {
-        msInitProjection(&sProjTmp);
-        msProjectionInheritContextFrom(&sProjTmp, &lp->projection);
-      }
-      if (psNode->pszSRS) {
-        /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
-        if (msLoadProjectionString(&sProjTmp, psNode->pszSRS) == 0) {
-          msProjectShape(&sProjTmp, &lp->projection, psTmpShape);
-        }
-      } else if (lp->map->projection.numargs > 0)
-        msProjectShape(&lp->map->projection, &lp->projection, psTmpShape);
-      if (psNode->pszSRS)
-        msFreeProjection(&sProjTmp);
-    }
-
-    /* function name */
-    if (bBBoxQuery) {
-      expr = "intersects";
-    } else {
-      if (strncasecmp(psNode->pszValue, "intersect", 9) == 0)
-        expr = "intersects";
-      else {
-        expr = msStringToLower(std::string(psNode->pszValue));
-      }
-    }
-    /* geometry binding */
-    expr += "([shape],fromText('";
-
-    /* filter geometry */
-    char* pszWktText = msGEOSShapeToWKT(psTmpShape);
-    expr += pszWktText ? pszWktText : "Cannot translate shape to WKT";
-    expr += "')";
-    msGEOSFreeWKT(pszWktText);
-
-    /* (optional) beyond/dwithin distance, always 0.0 since we apply the distance as a buffer earlier */
-    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 || strcasecmp(psNode->pszValue, "Beyond") == 0)) {
-      char szBuffer[256];
-      sprintf(szBuffer, ",%g", dfDistance);
-      expr += szBuffer;
-    }
-
-    /* terminate the function */
-    expr += ") = TRUE";
-  }
-
-  /*
-  ** Cleanup
-  */
-  if (bBBoxQuery) {
-    msFreeShape(psTmpShape);
-    msFree(psTmpShape);
-  }
-
-  return expr;
-}
-
-static std::string FLTGetFeatureIdCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  std::string expr;
-
-#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) || defined(USE_SOS_SVR)
-  if (psFilterNode->pszValue) {
-    const char* pszAttribute = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
-    if (pszAttribute) {
-      const auto tokens = msStringSplit(psFilterNode->pszValue,',');
-      if (!tokens.empty()) {
-        for (size_t i=0; i < tokens.size(); i++) {
-          const char* pszId = tokens[i].c_str();
-          const char* pszDot = strrchr(pszId, '.');
-          if( pszDot )
-            pszId = pszDot + 1;
-
-          bool bString = false;
-          if (i == 0) {
-            if(FLTIsNumeric(pszId) == MS_FALSE)
-              bString = true;
-          }
-
-         if (!expr.empty())
-            expr += " OR ";
-          else
-            expr = '(';
-
-          if (bString) {
-            expr += "(\"[";
-            expr += pszAttribute;
-            expr += "]\" == \"";
-            expr += pszId;
-            expr += "\")";
-          } else {
-            expr += "([";
-            expr += pszAttribute;
-            expr += "] == ";
-            expr += pszId;
-            expr += ")";
-          }
-        }
-      }
-    }
-
-    /* opening and closing brackets are needed for mapserver expressions */
-    if (!expr.empty())
-      expr += ')';
-  }
-#endif
-
-  return expr;
-}
-
-std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  if (lp == NULL)
-    return std::string();
-
-  std::string expr;
-  const char* pszTimeField = nullptr;
-  const char* pszTimeValue = FLTGetDuring(psFilterNode, &pszTimeField);
-  if (pszTimeField && pszTimeValue) {
-    expressionObj old_filter;
-    msInitExpression(&old_filter);
-    msCopyExpression(&old_filter, &lp->filter); /* save existing filter */
-    msFreeExpression(&lp->filter);
-    if (msLayerSetTimeFilter(lp, pszTimeValue, pszTimeField) == MS_TRUE &&
-        lp->filter.string) {
-      expr = lp->filter.string;
-    }
-    msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
-    msFreeExpression(&old_filter);
-  }
-  return expr;
-}
-
-char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  char *pszExpression = NULL;
-
-  if (!psFilterNode)
-    return NULL;
-
-  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON) {
-    if ( psFilterNode->psLeftNode && psFilterNode->psRightNode) {
-      if (FLTIsBinaryComparisonFilterType(psFilterNode->pszValue))
-        pszExpression = msStrdup(FLTGetBinaryComparisonCommonExpression(psFilterNode, lp).c_str());
-      else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
-        pszExpression = msStrdup(FLTGetIsLikeComparisonCommonExpression(psFilterNode).c_str());
-      else if (strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0)
-        pszExpression = msStrdup(FLTGetIsBetweenComparisonCommonExpresssion(psFilterNode, lp).c_str());
-    }
-  } else if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL) {
-    pszExpression = msStrdup(FLTGetLogicalComparisonCommonExpression(psFilterNode, lp).c_str());
-  } else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL) {
-    pszExpression = msStrdup(FLTGetSpatialComparisonCommonExpression(psFilterNode, lp).c_str());
-  } else if (psFilterNode->eType ==  FILTER_NODE_TYPE_FEATUREID) {
-    pszExpression = msStrdup(FLTGetFeatureIdCommonExpression(psFilterNode, lp).c_str());
-  } else if (psFilterNode->eType == FILTER_NODE_TYPE_TEMPORAL) {
-    pszExpression = msStrdup(FLTGetTimeExpression(psFilterNode, lp).c_str());
-  }
-
-  return pszExpression;
-}
-
-int FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex, const char *pszExpression)
-{
-  return FLTApplyFilterToLayerCommonExpressionWithRect(map, iLayerIndex, pszExpression, map->extent);
-}
-
-/* rect must be in map->projection */
-int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex, const char *pszExpression, rectObj rect)
-{
-  int retval;
-
-  const int save_startindex = map->query.startindex;
-  const int save_maxfeatures = map->query.maxfeatures;
-  const int save_only_cache_result_count = map->query.only_cache_result_count;
-  const int save_cache_shapes = map->query.cache_shapes;
-  const int save_max_cached_shape_count = map->query.max_cached_shape_count;
-  const int save_max_cached_shape_ram_amount = map->query.max_cached_shape_ram_amount;
-  msInitQuery(&(map->query));
-  map->query.startindex = save_startindex;
-  map->query.maxfeatures = save_maxfeatures;
-  map->query.only_cache_result_count = save_only_cache_result_count;
-  map->query.cache_shapes = save_cache_shapes;
-  map->query.max_cached_shape_count = save_max_cached_shape_count;
-  map->query.max_cached_shape_ram_amount = save_max_cached_shape_ram_amount;
-
-  map->query.mode = MS_QUERY_MULTIPLE;
-  map->query.layer = iLayerIndex;
-
-  map->query.rect = rect;
-
-  if( pszExpression )
-  {
-    map->query.type = MS_QUERY_BY_FILTER;
-    msInitExpression(&map->query.filter);
-    map->query.filter.string = msStrdup(pszExpression);
-    map->query.filter.type = MS_EXPRESSION; /* a logical expression */
-
-    retval = msQueryByFilter(map);
-  }
-  else
-  {
-    map->query.type = MS_QUERY_BY_RECT;
-    retval = msQueryByRect(map);
-  }
-
-  return retval;
-}
diff -pruN 8.0.1-5/mapogcsld.c 8.2.0~beta1-1~exp1/mapogcsld.c
--- 8.0.1-5/mapogcsld.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcsld.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,5590 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC SLD implementation
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapogcsld.h"
-#include "mapogcfilter.h"
-#include "mapserver.h"
-#include "mapows.h"
-#include "mapcopy.h"
-#include "cpl_string.h"
-
-extern int yyparse(parseObj *);
-
-#if defined(USE_CURL)
-static inline void IGUR_sizet(size_t ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
-#endif
-
-#define SLD_LINE_SYMBOL_NAME "sld_line_symbol"
-#define SLD_LINE_SYMBOL_DASH_NAME "sld_line_symbol_dash"
-#define SLD_MARK_SYMBOL_SQUARE "sld_mark_symbol_square"
-#define SLD_MARK_SYMBOL_SQUARE_FILLED "sld_mark_symbol_square_filled"
-#define SLD_MARK_SYMBOL_CIRCLE "sld_mark_symbol_circle"
-#define SLD_MARK_SYMBOL_CIRCLE_FILLED "sld_mark_symbol_circle_filled"
-#define SLD_MARK_SYMBOL_TRIANGLE "sld_mark_symbol_triangle"
-#define SLD_MARK_SYMBOL_TRIANGLE_FILLED "sld_mark_symbol_triangle_filled"
-#define SLD_MARK_SYMBOL_STAR "sld_mark_symbol_star"
-#define SLD_MARK_SYMBOL_STAR_FILLED "sld_mark_symbol_star_filled"
-#define SLD_MARK_SYMBOL_CROSS "sld_mark_symbol_cross"
-#define SLD_MARK_SYMBOL_CROSS_FILLED "sld_mark_symbol_cross_filled"
-#define SLD_MARK_SYMBOL_X "sld_mark_symbol_x"
-#define SLD_MARK_SYMBOL_X_FILLED "sld_mark_symbol_x_filled"
-
-/************************************************************************/
-/*                             msSLDApplySLDURL                         */
-/*                                                                      */
-/*      Use the SLD document given through a URL and apply the SLD      */
-/*      on the map. Layer name and Named Layer's name parameter are     */
-/*      used to do the match.                                           */
-/************************************************************************/
-int msSLDApplySLDURL(mapObj *map, const char *szURL, int iLayer,
-                     const char *pszStyleLayerName,  char **ppszLayerNames)
-{
-  /* needed for libcurl function msHTTPGetFile in maphttp.c */
-#if defined(USE_CURL)
-
-  char *pszSLDTmpFile = NULL;
-  int status = 0;
-  char *pszSLDbuf=NULL;
-  FILE *fp = NULL;
-  int nStatus = MS_FAILURE;
-
-  if (map && szURL) {
-    map->sldurl = (char*)szURL;
-    pszSLDTmpFile = msTmpFile(map, map->mappath, NULL, "sld.xml");
-    if (pszSLDTmpFile == NULL) {
-      pszSLDTmpFile = msTmpFile(map, NULL, NULL, "sld.xml" );
-    }
-    if (pszSLDTmpFile == NULL) {
-      msSetError(MS_WMSERR, "Could not determine temporary file. Please make sure that the temporary path is set. The temporary path can be defined for example by setting TEMPPATH in the map file. Please check the MapServer documentation on temporary path settings.", "msSLDApplySLDURL()");
-    } else {
-      int nMaxRemoteSLDBytes;
-      const char *pszMaxRemoteSLDBytes = msOWSLookupMetadata(&(map->web.metadata), "MO", "remote_sld_max_bytes");
-      if(!pszMaxRemoteSLDBytes) {
-        nMaxRemoteSLDBytes = 1024*1024; /* 1 megaByte */
-      } else {
-        nMaxRemoteSLDBytes = atoi(pszMaxRemoteSLDBytes);
-      }
-      if (msHTTPGetFile(szURL, pszSLDTmpFile, &status,-1, 0, 0, nMaxRemoteSLDBytes) ==  MS_SUCCESS) {
-        if ((fp = fopen(pszSLDTmpFile, "rb")) != NULL) {
-          int   nBufsize=0;
-          fseek(fp, 0, SEEK_END);
-          nBufsize = ftell(fp);
-          if(nBufsize > 0) {
-            rewind(fp);
-            pszSLDbuf = (char*)malloc((nBufsize+1)*sizeof(char));
-            IGUR_sizet(fread(pszSLDbuf, 1, nBufsize, fp));
-            pszSLDbuf[nBufsize] = '\0';
-          } else {
-            msSetError(MS_WMSERR, "Could not open SLD %s as it appears empty", "msSLDApplySLDURL", szURL);
-          }
-          fclose(fp);
-          unlink(pszSLDTmpFile);
-        }
-      } else {
-        unlink(pszSLDTmpFile);
-        msSetError(MS_WMSERR, "Could not open SLD %s and save it in a temporary file. Please make sure that the sld url is valid and that the temporary path is set. The temporary path can be defined for example by setting TEMPPATH in the map file. Please check the MapServer documentation on temporary path settings.", "msSLDApplySLDURL", szURL);
-      }
-      msFree(pszSLDTmpFile);
-      if (pszSLDbuf)
-        nStatus = msSLDApplySLD(map, pszSLDbuf, iLayer, pszStyleLayerName, ppszLayerNames);
-    }
-    map->sldurl = NULL;
-  }
-
-  msFree(pszSLDbuf);
-
-  return nStatus;
-
-#else
-  msSetError(MS_MISCERR, "WMS/WFS client support is not enabled .", "msSLDApplySLDURL()");
-  return(MS_FAILURE);
-#endif
-}
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-/* -------------------------------------------------------------------- */
-/*      If the same layer is given more that once, we need to           */
-/*      duplicate it.                                                   */
-/* -------------------------------------------------------------------- */
-static void msSLDApplySLD_DuplicateLayers(mapObj *map, int nSLDLayers, layerObj *pasSLDLayers)
-{
-    int m;
-    for (m=0; m<nSLDLayers; m++) {
-      int l;
-      int nIndex = msGetLayerIndex(map, pasSLDLayers[m].name);
-      if(pasSLDLayers[m].name == NULL) continue;
-      if( nIndex < 0 ) continue;
-      for (l=m+1; l<nSLDLayers; l++) {
-        if(pasSLDLayers[l].name == NULL)
-          continue;
-        if (strcasecmp(pasSLDLayers[m].name, pasSLDLayers[l].name)== 0) {
-          layerObj* psTmpLayer = (layerObj *) malloc(sizeof(layerObj));
-          char tmpId[128];
-
-          initLayer(psTmpLayer, map);
-          msCopyLayer(psTmpLayer, GET_LAYER(map,nIndex));
-          /* open the source layer */
-          if ( !psTmpLayer->vtable) {
-            if( msInitializeVirtualTable(psTmpLayer) != MS_SUCCESS ) {
-                MS_REFCNT_DECR(psTmpLayer);
-                continue;
-            }
-          }
-
-          /*make the name unique*/
-          snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d",(long)time(NULL),(int)getpid(),
-                   map->numlayers);
-          if (psTmpLayer->name)
-            msFree(psTmpLayer->name);
-          psTmpLayer->name = msStrdup(tmpId);
-          msFree(pasSLDLayers[l].name);
-          pasSLDLayers[l].name = msStrdup(tmpId);
-          msInsertLayer(map, psTmpLayer, -1);
-          MS_REFCNT_DECR(psTmpLayer);
-        }
-      }
-    }
-}
-#endif
-
-/************************************************************************/
-/*                              msSLDApplySLD                           */
-/*                                                                      */
-/*      Parses the SLD into array of layers. Go through the map and     */
-/*      compare the SLD layers and the map layers using the name. If    */
-/*      they have the same name, copy the classes associated with       */
-/*      the SLD layers onto the map layers.                             */
-/************************************************************************/
-int msSLDApplySLD(mapObj *map, const char *psSLDXML, int iLayer, const char *pszStyleLayerName, char **ppszLayerNames)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-  int nSLDLayers = 0;
-  layerObj *pasSLDLayers = NULL;
-  int nStatus = MS_SUCCESS;
-  /*const char *pszSLDNotSupported = NULL;*/
-
-  pasSLDLayers = msSLDParseSLD(map, psSLDXML, &nSLDLayers);
-  if( pasSLDLayers == NULL ) {
-    errorObj* psError = msGetErrorObj();
-    if( psError && psError->code != MS_NOERR )
-      return MS_FAILURE;
-  }
-
-  if (pasSLDLayers && nSLDLayers>0) {
-    int i;
-
-    msSLDApplySLD_DuplicateLayers(map, nSLDLayers, pasSLDLayers);
-
-    for (i=0; i<map->numlayers; i++) {
-      layerObj *lp = NULL;
-      const char *pszWMSLayerName = NULL;
-      int j;
-      int bUseSpecificLayer = 0;
-
-      if (iLayer >=0 && iLayer< map->numlayers) {
-        i = iLayer;
-        bUseSpecificLayer = 1;
-      }
-
-      lp = GET_LAYER(map, i);
-
-      /* compare layer name to wms_name as well */
-      pszWMSLayerName = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
-
-      for (j=0; j<nSLDLayers; j++) {
-        layerObj* sldLayer = &pasSLDLayers[j];
-
-        /* -------------------------------------------------------------------- */
-        /*      copy :  - class                                                 */
-        /*              - layer's labelitem                                     */
-        /* -------------------------------------------------------------------- */
-        if ((sldLayer->name && pszStyleLayerName == NULL &&
-             ((strcasecmp(lp->name, sldLayer->name) == 0 ||
-               (pszWMSLayerName && strcasecmp(pszWMSLayerName, sldLayer->name) == 0))||
-              (lp->group &&
-               strcasecmp(lp->group, sldLayer->name) == 0))) ||
-            (bUseSpecificLayer && pszStyleLayerName && sldLayer->name &&
-             strcasecmp(sldLayer->name, pszStyleLayerName) == 0)) {
-#ifdef notdef
-          /*this is a test code if we decide to flag some layers as not supporting SLD*/
-          pszSLDNotSupported = msOWSLookupMetadata(&(lp->metadata), "M", "SLD_NOT_SUPPORTED");
-          if (pszSLDNotSupported) {
-            msSetError(MS_WMSERR, "Layer %s does not support SLD", "msSLDApplySLD", sldLayer->name);
-            nsStatus = MS_FAILURE;
-            goto sld_cleanup;
-          }
-#endif
-
-          if ( sldLayer->numclasses > 0) {
-            int iClass = 0;
-            int k;
-            int bSLDHasNamedClass = MS_FALSE;
-
-            lp->type = sldLayer->type;
-            lp->rendermode = MS_ALL_MATCHING_CLASSES;
-
-            for (k=0; k < sldLayer->numclasses; k++) {
-                if( sldLayer->class[k]->group ) {
-                    bSLDHasNamedClass = MS_TRUE;
-                    break;
-                }
-            }
-
-            for(k=0; k<lp->numclasses; k++) {
-              if (lp->class[k] != NULL) {
-                lp->class[k]->layer=NULL;
-                if (freeClass(lp->class[k]) == MS_SUCCESS ) {
-                  msFree(lp->class[k]);
-                  lp->class[k] = NULL;
-                }
-              }
-            }
-            lp->numclasses = 0;
-
-            if( bSLDHasNamedClass && sldLayer->classgroup ) {
-                /* Set the class group to the class that has UserStyle.IsDefault */
-                msFree( lp->classgroup);
-                lp->classgroup = msStrdup(sldLayer->classgroup);
-            }
-            else {
-                /*unset the classgroup on the layer if it was set. This allows the layer to render
-                with all the classes defined in the SLD*/
-                msFree(lp->classgroup);
-                lp->classgroup = NULL;
-            }
-
-            for (k=0; k < sldLayer->numclasses; k++) {
-              if (msGrowLayerClasses(lp) == NULL)
-                return MS_FAILURE;
-
-              initClass(lp->class[iClass]);
-              msCopyClass(lp->class[iClass],
-                          sldLayer->class[k], NULL);
-              lp->class[iClass]->layer = lp;
-              lp->numclasses++;
-
-              /*aliases may have been used as part of the sld text symbolizer for
-                label element. Try to process it if that is the case #3114*/
-              if (msLayerOpen(lp) == MS_SUCCESS) {
-                if (msLayerGetItems(lp) == MS_SUCCESS &&
-                    lp->class[iClass]->text.string) {
-                  int z;
-                  for(z=0; z<lp->numitems; z++) {
-                    const char* pszFullName;
-                    char szTmp[512];
-                    char* pszTmp1;
-                    if (!lp->items[z] || strlen(lp->items[z]) == 0)
-                      continue;
-                    snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[z]);
-                    pszFullName = msOWSLookupMetadata(&(lp->metadata), "G", szTmp);
-                    pszTmp1 = msStrdup( lp->class[iClass]->text.string);
-                    if (pszFullName != NULL && (strstr(pszTmp1, pszFullName) != NULL)) {
-                      char *tmpstr1= msReplaceSubstring(pszTmp1, pszFullName, lp->items[z]);
-                      char* pszTmp2 = (char *)malloc(sizeof(char)*(strlen(tmpstr1)+3));
-                      sprintf(pszTmp2,"(%s)",tmpstr1);
-                      msLoadExpressionString(&(lp->class[iClass]->text), pszTmp2);
-                      msFree(pszTmp2);
-                    }
-                    msFree(pszTmp1);
-                  }
-                }
-                msLayerClose(lp);
-              }
-
-              iClass++;
-            }
-          } else {
-            /*this is probably an SLD that uses Named styles*/
-            if (sldLayer->classgroup) {
-              int k;
-              for (k=0; k<lp->numclasses; k++) {
-                if (lp->class[k]->group &&
-                    strcasecmp(lp->class[k]->group,
-                               sldLayer->classgroup) == 0)
-                  break;
-              }
-              if (k < lp->numclasses) {
-                msFree( lp->classgroup);
-                lp->classgroup = msStrdup(sldLayer->classgroup);
-              } else {
-                /* TODO  we throw an exception ?*/
-              }
-            }
-          }
-          if (sldLayer->labelitem) {
-            if (lp->labelitem)
-              free(lp->labelitem);
-
-            lp->labelitem = msStrdup(sldLayer->labelitem);
-          }
-
-          if (sldLayer->classitem) {
-            if (lp->classitem)
-              free(lp->classitem);
-
-            lp->classitem = msStrdup(sldLayer->classitem);
-          }
-
-          /* opacity for sld raster */
-          if (lp->type == MS_LAYER_RASTER &&
-              sldLayer->compositer && sldLayer->compositer->opacity != 100)
-            msSetLayerOpacity(lp, sldLayer->compositer->opacity);
-
-          /* mark as auto-generate SLD */
-          if (lp->connectiontype == MS_WMS)
-            msInsertHashTable(&(lp->metadata),
-                              "wms_sld_body", "auto" );
-
-          /* The SLD might have a FeatureTypeConstraint */
-          if( sldLayer->filter.type == MS_EXPRESSION )
-          {
-                if( lp->filter.string && lp->filter.type == MS_EXPRESSION )
-                {
-                    char* pszBuffer = msStringConcatenate(NULL, "((");
-                    pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
-                    pszBuffer = msStringConcatenate(pszBuffer, ") AND (");
-                    pszBuffer = msStringConcatenate(pszBuffer, sldLayer->filter.string);
-                    pszBuffer = msStringConcatenate(pszBuffer, "))");
-                    msFreeExpression(&lp->filter);
-                    msInitExpression(&lp->filter);
-                    lp->filter.string = pszBuffer;
-                    lp->filter.type = MS_EXPRESSION;
-                }
-                else
-                {
-                    msFreeExpression(&lp->filter);
-                    msInitExpression(&lp->filter);
-                    lp->filter.string = msStrdup(sldLayer->filter.string);
-                    lp->filter.type = MS_EXPRESSION;
-                }
-          }
-
-
-          /*in some cases it would make sense to concatenate all the class
-            expressions and use it to set the filter on the layer. This
-            could increase performance. Will do it for db types layers #2840*/
-          if (lp->filter.string == NULL || (lp->filter.string && lp->filter.type == MS_STRING && !lp->filteritem)) {
-              if (lp->connectiontype == MS_POSTGIS || lp->connectiontype ==  MS_ORACLESPATIAL || lp->connectiontype == MS_PLUGIN) {
-                if (lp->numclasses > 0) {
-                  /* check first that all classes have an expression type. That is
-                    the only way we can concatenate them and set the filter
-                    expression */
-                  int k;
-                  for (k=0; k<lp->numclasses; k++) {
-                    if (lp->class[k]->expression.type != MS_EXPRESSION)
-                      break;
-                  }
-                  if (k == lp->numclasses) {
-                    char szTmp[512];
-                    char* pszBuffer = NULL;
-                    for (k=0; k<lp->numclasses; k++) {
-                      if (pszBuffer == NULL)
-                        snprintf(szTmp, sizeof(szTmp), "%s", "(("); /* we a building a string expression, explicitly set type below */
-                      else
-                        snprintf(szTmp, sizeof(szTmp), "%s", " OR ");
-
-                      pszBuffer = msStringConcatenate(pszBuffer, szTmp);
-                      pszBuffer = msStringConcatenate(pszBuffer, lp->class[k]->expression.string);
-                    }
-
-                    snprintf(szTmp, sizeof(szTmp), "%s", "))");
-                    pszBuffer =msStringConcatenate(pszBuffer, szTmp);
-
-                    msFreeExpression(&lp->filter);
-                    msInitExpression(&lp->filter);
-                    lp->filter.string = msStrdup(pszBuffer);
-                    lp->filter.type = MS_EXPRESSION;
-
-                    msFree(pszBuffer);
-                  }
-                }
-              }
-          }
-          break;
-        }
-      }
-      if (bUseSpecificLayer)
-        break;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      if needed return a comma separated list of the layers found     */
-    /*      in the sld.                                                     */
-    /* -------------------------------------------------------------------- */
-    if (ppszLayerNames) {
-      char *pszTmp = NULL;
-      for (i=0; i<nSLDLayers; i++) {
-        if (pasSLDLayers[i].name) {
-          if (pszTmp !=NULL)
-            pszTmp = msStringConcatenate(pszTmp, ",");
-          pszTmp = msStringConcatenate(pszTmp, pasSLDLayers[i].name);
-
-        }
-      }
-      *ppszLayerNames = pszTmp;
-
-    }
-  }
-
-  nStatus = MS_SUCCESS;
-
-#ifdef notdef
-sld_cleanup:
-#endif
-  {
-    int i;
-    for (i=0; i<nSLDLayers; i++)
-        freeLayer(&pasSLDLayers[i]);
-    msFree(pasSLDLayers);
-  }
-
-  if(map->debug == MS_DEBUGLEVEL_VVV) {
-    char* tmpfilename = msTmpFile(map, map->mappath, NULL, "_sld.map");
-    if (tmpfilename == NULL) {
-      tmpfilename = msTmpFile(map, NULL, NULL, "_sld.map" );
-    }
-    if (tmpfilename) {
-      msSaveMap(map,tmpfilename);
-      msDebug("msApplySLD(): Map file after SLD was applied %s", tmpfilename);
-      msFree(tmpfilename);
-    }
-  }
-  return nStatus;
-
-#else
-  msSetError(MS_MISCERR, "OWS support is not available.",
-             "msSLDApplySLD()");
-  return(MS_FAILURE);
-#endif
-}
-
-
-
-static CPLXMLNode* FindNextChild(CPLXMLNode* psNode, const char* pszChildName)
-{
-    while( psNode )
-    {
-        if( psNode->eType == CXT_Element &&
-            strcasecmp(psNode->pszValue, pszChildName) == 0 )
-        {
-            return psNode;
-        }
-        psNode = psNode->psNext;
-    }
-    return NULL;
-}
-
-#define LOOP_ON_CHILD_ELEMENT(psParent_, psChild_, pszChildName_) \
-    for( psChild_ = FindNextChild(psParent_->psChild, pszChildName_); \
-         psChild_ != NULL; \
-         psChild_ = FindNextChild(psChild_->psNext, pszChildName_) )
-
-/************************************************************************/
-/*                              msSLDParseSLD                           */
-/*                                                                      */
-/*      Parse the sld document into layers : for each named layer       */
-/*      there is one mapserver layer created with appropriate           */
-/*      classes and styles.                                             */
-/*      Returns an array of mapserver layers. The pnLayres if           */
-/*      provided will indicate the size of the returned array.          */
-/************************************************************************/
-layerObj  *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers)
-{
-  CPLXMLNode *psRoot = NULL;
-  CPLXMLNode *psSLD, *psNamedLayer;
-  layerObj *pasLayers = NULL;
-  int iLayer = 0;
-  int nLayers = 0;
-
-
-  if (map == NULL || psSLDXML == NULL || strlen(psSLDXML) == 0 ||
-      (strstr(psSLDXML, "StyledLayerDescriptor") == NULL)) {
-    msSetError(MS_WMSERR, "Invalid SLD document", "");
-    return NULL;
-  }
-
-  psRoot = CPLParseXMLString(psSLDXML);
-  if( psRoot == NULL) {
-    msSetError(MS_WMSERR, "Invalid SLD document : %s", "", psSLDXML);
-    return NULL;
-  }
-
-  /* strip namespaces ogc and sld and gml */
-  CPLStripXMLNamespace(psRoot, "ogc", 1);
-  CPLStripXMLNamespace(psRoot, "sld", 1);
-  CPLStripXMLNamespace(psRoot, "gml", 1);
-  CPLStripXMLNamespace(psRoot, "se", 1);
-
-
-  /* -------------------------------------------------------------------- */
-  /*      get the root element (StyledLayerDescriptor).                   */
-  /* -------------------------------------------------------------------- */
-  psSLD = CPLGetXMLNode(psRoot, "=StyledLayerDescriptor");
-  if (!psSLD) {
-    msSetError(MS_WMSERR, "Invalid SLD document : %s", "", psSLDXML);
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse the named layers.                                         */
-  /* -------------------------------------------------------------------- */
-  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer")
-  {
-    nLayers++;
-  }
-
-  if (nLayers > 0)
-    pasLayers = (layerObj *)malloc(sizeof(layerObj)*nLayers);
-  else
-    return NULL;
-
-  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer")
-  {
-      CPLXMLNode* psName = CPLGetXMLNode(psNamedLayer, "Name");
-      initLayer(&pasLayers[iLayer], map);
-
-      if (psName && psName->psChild &&  psName->psChild->pszValue)
-        pasLayers[iLayer].name = msStrdup(psName->psChild->pszValue);
-
-      if( msSLDParseNamedLayer(psNamedLayer, &pasLayers[iLayer]) != MS_SUCCESS ) {
-        int i;
-        for (i=0; i<=iLayer; i++)
-            freeLayer(&pasLayers[i]);
-        msFree(pasLayers);
-        nLayers = 0;
-        pasLayers = NULL;
-        break;
-      }
-
-      iLayer++;
-  }
-
-  if (pnLayers)
-    *pnLayers = nLayers;
-
-  if (psRoot)
-    CPLDestroyXMLNode(psRoot);
-
-  return pasLayers;
-}
-
-
-/************************************************************************/
-/*                           _SLDApplyRuleValues                        */
-/*                                                                      */
-/*      Utility function to set the scale, title/name for the          */
-/*      classes created by a Rule.                                      */
-/************************************************************************/
-void  _SLDApplyRuleValues(CPLXMLNode *psRule, layerObj *psLayer,
-                          int nNewClasses)
-{
-  CPLXMLNode *psMinScale=NULL, *psMaxScale=NULL;
-  CPLXMLNode *psName=NULL, *psTitle=NULL;
-  double dfMinScale=0, dfMaxScale=0;
-  char *pszName=NULL, *pszTitle=NULL;
-
-  if (psRule && psLayer && nNewClasses > 0) {
-    /* -------------------------------------------------------------------- */
-    /*      parse minscale and maxscale.                                    */
-    /* -------------------------------------------------------------------- */
-    psMinScale = CPLGetXMLNode(psRule,
-                               "MinScaleDenominator");
-    if (psMinScale && psMinScale->psChild &&
-        psMinScale->psChild->pszValue)
-      dfMinScale = atof(psMinScale->psChild->pszValue);
-
-    psMaxScale = CPLGetXMLNode(psRule,
-                               "MaxScaleDenominator");
-    if (psMaxScale && psMaxScale->psChild &&
-        psMaxScale->psChild->pszValue)
-      dfMaxScale = atof(psMaxScale->psChild->pszValue);
-
-    /* -------------------------------------------------------------------- */
-    /*      parse name and title.                                           */
-    /* -------------------------------------------------------------------- */
-    psName = CPLGetXMLNode(psRule, "Name");
-    if (psName && psName->psChild &&
-        psName->psChild->pszValue)
-      pszName = psName->psChild->pszValue;
-
-    psTitle = CPLGetXMLNode(psRule, "Title");
-    if (psTitle && psTitle->psChild &&
-        psTitle->psChild->pszValue)
-      pszTitle = psTitle->psChild->pszValue;
-
-    /* -------------------------------------------------------------------- */
-    /*      set the scale to all the classes created by the rule.           */
-    /* -------------------------------------------------------------------- */
-    if (dfMinScale > 0 || dfMaxScale > 0) {
-      for (int i=0; i<nNewClasses; i++) {
-        if (dfMinScale > 0)
-          psLayer->class[psLayer->numclasses-1-i]->minscaledenom = dfMinScale;
-        if (dfMaxScale)
-          psLayer->class[psLayer->numclasses-1-i]->maxscaledenom = dfMaxScale;
-      }
-    }
-    /* -------------------------------------------------------------------- */
-    /*      set name and title to the classes created by the rule.          */
-    /* -------------------------------------------------------------------- */
-    for (int i=0; i<nNewClasses; i++) {
-      if (!psLayer->class[psLayer->numclasses-1-i]->name) {
-        if (pszName)
-          psLayer->class[psLayer->numclasses-1-i]->name = msStrdup(pszName);
-        else if (pszTitle)
-          psLayer->class[psLayer->numclasses-1-i]->name = msStrdup(pszTitle);
-        else
-        {
-          // Build a name from layer and class info
-          char szTmp[256];
-          snprintf(szTmp, sizeof(szTmp), "%s#%d", psLayer->name,
-              psLayer->numclasses-1-i);
-          psLayer->class[psLayer->numclasses-1-i]->name = msStrdup(szTmp);
-        }
-      }
-    }
-    if (pszTitle) {
-      for (int i=0; i<nNewClasses; i++) {
-        psLayer->class[psLayer->numclasses-1-i]->title =
-              msStrdup(pszTitle);
-      }
-    }
-
-  }
-
-}
-
-/************************************************************************/
-/*                     msSLDGetCommonExpressionFromFilter               */
-/*                                                                      */
-/*      Get a common expression valid from the filter valid for the    */
-/*      temporary layer.                                                */
-/************************************************************************/
-static char* msSLDGetCommonExpressionFromFilter(CPLXMLNode* psFilter,
-                                                layerObj *psLayer)
-{
-    char *pszExpression = NULL;
-    CPLXMLNode *psTmpNextNode = NULL;
-    CPLXMLNode *psTmpNode = NULL;
-    FilterEncodingNode *psNode = NULL;
-    char *pszTmpFilter = NULL;
-    layerObj *psCurrentLayer = NULL;
-    const char *pszWmsName=NULL;
-    const char *key=NULL;
-
-    /* clone the tree and set the next node to null */
-    /* so we only have the Filter node */
-    psTmpNode = CPLCloneXMLTree(psFilter);
-    psTmpNextNode = psTmpNode->psNext;
-    psTmpNode->psNext = NULL;
-    pszTmpFilter = CPLSerializeXMLTree(psTmpNode);
-    psTmpNode->psNext = psTmpNextNode;
-    CPLDestroyXMLNode(psTmpNode);
-
-    if (pszTmpFilter) {
-        psNode = FLTParseFilterEncoding(pszTmpFilter);
-
-        CPLFree(pszTmpFilter);
-    }
-
-    if (psNode) {
-        int j;
-
-        /*preparse the filter for possible gml aliases set on the layer's metadata:
-        "gml_NA3DESC_alias" "alias_name" and filter could be
-        <ogc:PropertyName>alias_name</ogc:PropertyName> #3079*/
-        for (j=0; j<psLayer->map->numlayers; j++) {
-            psCurrentLayer = GET_LAYER(psLayer->map, j);
-
-            pszWmsName = msOWSLookupMetadata(&(psCurrentLayer->metadata), "MO", "name");
-
-            if ((psCurrentLayer->name && psLayer->name &&
-                    strcasecmp(psCurrentLayer->name, psLayer->name) == 0) ||
-                (psCurrentLayer->group && psLayer->name &&
-                    strcasecmp(psCurrentLayer->group, psLayer->name) == 0) ||
-                (psLayer->name && pszWmsName &&
-                    strcasecmp(pszWmsName, psLayer->name) == 0))
-                break;
-        }
-        if (j < psLayer->map->numlayers) {
-            /*make sure that the tmp layer has all the metadata that
-            the original layer has, allowing to do parsing for
-            such things as gml_attribute_type #3052*/
-            while (1) {
-                key = msNextKeyFromHashTable(&psCurrentLayer->metadata, key);
-                if (!key)
-                    break;
-                else
-                    msInsertHashTable(&psLayer->metadata, key,
-                                    msLookupHashTable(&psCurrentLayer->metadata, key));
-            }
-            FLTPreParseFilterForAliasAndGroup(psNode, psLayer->map, j, "G");
-        }
-
-        pszExpression = FLTGetCommonExpression(psNode, psLayer);
-        FLTFreeFilterEncodingNode(psNode);
-    }
-
-    return pszExpression;
-}
-
-/************************************************************************/
-/*                          msSLDParseUserStyle                         */
-/*                                                                      */
-/*      Parse UserStyle node.                                           */
-/************************************************************************/
-
-static void msSLDParseUserStyle(CPLXMLNode* psUserStyle, layerObj *psLayer)
-{
-    CPLXMLNode *psFeatureTypeStyle;
-    const char* pszUserStyleName = CPLGetXMLValue(psUserStyle, "Name", NULL);
-    if( pszUserStyleName )
-    {
-        const char* pszIsDefault = CPLGetXMLValue(psUserStyle, "IsDefault", "0");
-        if( EQUAL(pszIsDefault, "true") || EQUAL(pszIsDefault, "1") )
-        {
-            msFree(psLayer->classgroup);
-            psLayer->classgroup = msStrdup(pszUserStyleName);
-        }
-    }
-
-    LOOP_ON_CHILD_ELEMENT(psUserStyle, psFeatureTypeStyle,
-                          "FeatureTypeStyle")
-    {
-        CPLXMLNode* psRule;
-
-        /* -------------------------------------------------------------------- */
-        /*      Parse rules with no Else filter.                                */
-        /* -------------------------------------------------------------------- */
-        LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule")
-        {
-          CPLXMLNode *psFilter = NULL;
-          CPLXMLNode *psElseFilter = NULL;
-          int nNewClasses=0, nClassBeforeFilter=0, nClassAfterFilter=0;
-          int nClassAfterRule=0, nClassBeforeRule=0;
-
-          /* used for scale setting */
-          nClassBeforeRule = psLayer->numclasses;
-
-          psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
-          nClassBeforeFilter = psLayer->numclasses;
-          if (psElseFilter == NULL)
-            msSLDParseRule(psRule, psLayer, pszUserStyleName);
-          nClassAfterFilter = psLayer->numclasses;
-
-          /* -------------------------------------------------------------------- */
-          /*      Parse the filter and apply it to the latest class created by    */
-          /*      the rule.                                                       */
-          /*      NOTE : Spatial Filter is not supported.                         */
-          /* -------------------------------------------------------------------- */
-          psFilter = CPLGetXMLNode(psRule, "Filter");
-          if (psFilter && psFilter->psChild && psFilter->psChild->pszValue) {
-            char* pszExpression = msSLDGetCommonExpressionFromFilter(psFilter,
-                                                                     psLayer);
-            if (pszExpression) {
-                int i;
-                nNewClasses =
-                  nClassAfterFilter - nClassBeforeFilter;
-                for (i=0; i<nNewClasses; i++) {
-                  expressionObj* exp = &(psLayer->
-                                         class[psLayer->numclasses-1-i]->
-                                         expression);
-                  msFreeExpression(exp);
-                  msInitExpression(exp);
-                  exp->string = msStrdup(pszExpression);
-                  exp->type = MS_EXPRESSION;
-                }
-                msFree(pszExpression);
-                pszExpression = NULL;
-            }
-          }
-          nClassAfterRule = psLayer->numclasses;
-          nNewClasses = nClassAfterRule - nClassBeforeRule;
-
-          /* apply scale and title to newly created classes */
-          _SLDApplyRuleValues(psRule, psLayer, nNewClasses);
-
-          /* TODO : parse legendgraphic */
-        }
-        /* -------------------------------------------------------------------- */
-        /*      First parse rules with the else filter. These rules will        */
-        /*      create the classes that are placed at the end of class          */
-        /*      list. (See how classes are applied to layers in function        */
-        /*      msSLDApplySLD).                                                 */
-        /* -------------------------------------------------------------------- */
-        LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule")
-        {
-          CPLXMLNode* psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
-          if (psElseFilter) {
-            msSLDParseRule(psRule, psLayer, pszUserStyleName);
-            _SLDApplyRuleValues(psRule, psLayer, 1);
-            psLayer->class[psLayer->numclasses-1]->isfallback = TRUE;
-          }
-        }
-    }
-}
-
-/************************************************************************/
-/*                           msSLDParseNamedLayer                       */
-/*                                                                      */
-/*      Parse NamedLayer root.                                          */
-/************************************************************************/
-int msSLDParseNamedLayer(CPLXMLNode *psRoot, layerObj *psLayer)
-{
-  CPLXMLNode *psLayerFeatureConstraints = NULL;
-
-  if (!psRoot || !psLayer)
-    return MS_FAILURE;
-
-  if (CPLGetXMLNode(psRoot, "UserStyle")) {
-    CPLXMLNode *psUserStyle;
-    LOOP_ON_CHILD_ELEMENT(psRoot, psUserStyle, "UserStyle")
-    {
-        msSLDParseUserStyle(psUserStyle, psLayer);
-    }
-  }
-  /* check for Named styles*/
-  else {
-    CPLXMLNode* psNamedStyle = CPLGetXMLNode(psRoot, "NamedStyle");
-    if (psNamedStyle) {
-      CPLXMLNode* psSLDName = CPLGetXMLNode(psNamedStyle, "Name");
-      if (psSLDName && psSLDName->psChild &&  psSLDName->psChild->pszValue) {
-        msFree(psLayer->classgroup);
-        psLayer->classgroup = msStrdup(psSLDName->psChild->pszValue);
-      }
-    }
-  }
-
-  /* Deal with LayerFeatureConstraints */
-  psLayerFeatureConstraints = CPLGetXMLNode(psRoot, "LayerFeatureConstraints");
-  if( psLayerFeatureConstraints != NULL ) {
-    CPLXMLNode* psIter = psLayerFeatureConstraints->psChild;
-    CPLXMLNode* psFeatureTypeConstraint = NULL;
-    for(; psIter != NULL; psIter = psIter->psNext ) {
-      if( psIter->eType == CXT_Element &&
-            strcmp(psIter->pszValue, "FeatureTypeConstraint") == 0 )  {
-        if( psFeatureTypeConstraint == NULL ) {
-          psFeatureTypeConstraint = psIter;
-        } else {
-          msSetError(MS_WMSERR, "Only one single FeatureTypeConstraint element "
-                    "per LayerFeatureConstraints is supported", "");
-          return MS_FAILURE;
-        }
-      }
-    }
-    if( psFeatureTypeConstraint != NULL ) {
-      CPLXMLNode* psFilter;
-      if( CPLGetXMLNode(psFeatureTypeConstraint, "FeatureTypeName") != NULL ) {
-        msSetError(MS_WMSERR, "FeatureTypeName element is not "
-                    "supported in FeatureTypeConstraint", "");
-        return MS_FAILURE;
-      }
-      if( CPLGetXMLNode(psFeatureTypeConstraint, "Extent") != NULL ) {
-        msSetError(MS_WMSERR, "Extent element is not "
-                    "supported in FeatureTypeConstraint", "");
-        return MS_FAILURE;
-      }
-      psFilter = CPLGetXMLNode(psFeatureTypeConstraint, "Filter");
-      if (psFilter && psFilter->psChild && psFilter->psChild->pszValue) {
-        char* pszExpression = msSLDGetCommonExpressionFromFilter(psFilter,
-                                                                    psLayer);
-        if (pszExpression) {
-            msFreeExpression(&psLayer->filter);
-            msInitExpression(&psLayer->filter);
-            psLayer->filter.string = pszExpression;
-            psLayer->filter.type = MS_EXPRESSION;
-        }
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                      msSLDParseRule()                                */
-/*                                                                      */
-/*      Parse a Rule node into classes for a specific layer.            */
-/************************************************************************/
-int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer, const char* pszUserStyleName)
-{
-  CPLXMLNode *psLineSymbolizer = NULL;
-  CPLXMLNode *psPolygonSymbolizer = NULL;
-  CPLXMLNode *psPointSymbolizer = NULL;
-  CPLXMLNode *psTextSymbolizer = NULL;
-  CPLXMLNode *psRasterSymbolizer = NULL;
-
-  int nSymbolizer=0;
-
-  if (!psRoot || !psLayer)
-    return MS_FAILURE;
-
-  /* TODO : parse name of the rule */
-  /* ==================================================================== */
-  /*      For each rule a new class is created. If there are more than    */
-  /*      one symbolizer, a style is added in the same class.             */
-  /* ==================================================================== */
-
-  /* Raster symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psRasterSymbolizer, "RasterSymbolizer")
-  {
-    msSLDParseRasterSymbolizer(psRasterSymbolizer, psLayer, pszUserStyleName);
-    /* cppcheck-suppress knownConditionTrueFalse */
-    if (nSymbolizer == 0)
-    {
-      psLayer->type = MS_LAYER_RASTER;
-    }
-  }
-
-  /* Polygon symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psPolygonSymbolizer, "PolygonSymbolizer")
-  {
-    /* cppcheck-suppress knownConditionTrueFalse */
-    const int bNewClass = (nSymbolizer == 0);
-    msSLDParsePolygonSymbolizer(psPolygonSymbolizer, psLayer,
-                                bNewClass, pszUserStyleName);
-    psLayer->type = MS_LAYER_POLYGON;
-    nSymbolizer++;
-  }
-
-  /* line symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psLineSymbolizer, "LineSymbolizer")
-  {
-    const int bNewClass = (nSymbolizer == 0);
-    msSLDParseLineSymbolizer(psLineSymbolizer, psLayer, bNewClass,
-                             pszUserStyleName);
-    if (bNewClass)
-    {
-      psLayer->type = MS_LAYER_LINE;
-    }
-    if (psLayer->type == MS_LAYER_POLYGON)
-    {
-      const int nClassId = psLayer->numclasses - 1;
-      if (nClassId >= 0)
-      {
-        const int nStyleId = psLayer->class[nClassId]->numstyles - 1;
-        if (nStyleId >= 0)
-        {
-          styleObj * psStyle = psLayer->class[nClassId]->styles[nStyleId];
-          psStyle->outlinecolor = psStyle->color;
-          MS_INIT_COLOR(psStyle->color,-1,-1,-1,255);
-          MS_COPYSTRING(psStyle->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].string,
-              psStyle->exprBindings[MS_STYLE_BINDING_COLOR].string);
-          psStyle->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].type =
-            psStyle->exprBindings[MS_STYLE_BINDING_COLOR].type;
-          msFreeExpression(&(psStyle->exprBindings[MS_STYLE_BINDING_COLOR]));
-          msInitExpression(&(psStyle->exprBindings[MS_STYLE_BINDING_COLOR]));
-        }
-      }
-    }
-    nSymbolizer++;
-  }
-
-  /* Point Symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psPointSymbolizer, "PointSymbolizer")
-  {
-    const int bNewClass = (nSymbolizer == 0);
-    msSLDParsePointSymbolizer(psPointSymbolizer, psLayer, bNewClass,
-                              pszUserStyleName);
-    if (bNewClass)
-    {
-      psLayer->type = MS_LAYER_POINT;
-    }
-    if (psLayer->type == MS_LAYER_POLYGON
-        || psLayer->type == MS_LAYER_LINE
-        || psLayer->type == MS_LAYER_RASTER)
-    {
-      const int nClassId = psLayer->numclasses - 1;
-      if (nClassId >= 0)
-      {
-        const int nStyleId = psLayer->class[nClassId]->numstyles - 1;
-        if (nStyleId >= 0)
-        {
-          styleObj * psStyle = psLayer->class[nClassId]->styles[nStyleId];
-          msStyleSetGeomTransform(psStyle, "centroid");
-        }
-      }
-    }
-    nSymbolizer++;
-  }
-
-  /* Text symbolizer */
-  /* ==================================================================== */
-  /*      For text symbolizer, here is how it is translated into          */
-  /*      mapserver classes :                                             */
-  /*        - If there are other symbolizers(line, polygon, symbol),      */
-  /*      the label object created will be created in the same class      */
-  /*      (the last class) as the  symbolizer. This allows to have for    */
-  /*      example of point layer with labels.                             */
-  /*        - If there are no other symbolizers, a new class will be      */
-  /*      created to contain the label object.                            */
-  /* ==================================================================== */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psTextSymbolizer, "TextSymbolizer")
-  {
-    if (nSymbolizer == 0)
-      psLayer->type = MS_LAYER_POINT;
-    msSLDParseTextSymbolizer(psTextSymbolizer, psLayer, nSymbolizer > 0, pszUserStyleName);
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                            getClassId()                              */
-/************************************************************************/
-
-static int getClassId(layerObj *psLayer,
-                      int bNewClass,
-                      const char* pszUserStyleName)
-{
-    int nClassId;
-    if (bNewClass || psLayer->numclasses <= 0) {
-      if (msGrowLayerClasses(psLayer) == NULL)
-        return -1;
-      initClass(psLayer->class[psLayer->numclasses]);
-      nClassId = psLayer->numclasses;
-      if( pszUserStyleName )
-        psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
-      psLayer->numclasses++;
-    } else {
-      nClassId = psLayer->numclasses-1;
-    }
-    return nClassId;
-}
-
-/************************************************************************/
-/*                      msSLDParseUomAttribute()                        */
-/************************************************************************/
-
-int msSLDParseUomAttribute(CPLXMLNode *node, enum MS_UNITS * sizeunits)
-{
-  const struct
-  {
-    enum MS_UNITS unit;
-    char * values[10];
-  } known_uoms[] =
-  {
-    { MS_INCHES, { "inch", "inches", NULL } },
-    { MS_FEET, { "foot", "feet", "http://www.opengeospatial.org/se/units/foot", NULL } },
-    { MS_MILES, { "mile", "miles", NULL } },
-    { MS_METERS, { "meter", "meters", "metre", "metres", "http://www.opengeospatial.org/se/units/metre", NULL } },
-    { MS_KILOMETERS, { "kilometer", "kilometers", "kilometre", "kilometres", NULL } },
-    { MS_DD, { "dd", NULL } },
-    { MS_PIXELS, { "pixel", "pixels", "px", "http://www.opengeospatial.org/se/units/pixel", NULL } },
-    { MS_PERCENTAGES, { "percent", "percents", "percentage", "percentages", NULL } },
-    { MS_NAUTICALMILES, { "nauticalmile", "nauticalmiles", "nautical_mile", "nautical_miles", NULL } },
-    { 0, { NULL } }
-  };
-
-  const char * uom = CPLGetXMLValue(node, "uom", NULL);
-  if (uom)
-  {
-    for (int i=0 ; known_uoms[i].values[0] ; i++)
-      for (int j=0 ; known_uoms[i].values[j] ; j++)
-        if (strcmp(uom,known_uoms[i].values[j]) == 0)
-        {
-          // Match found
-          *sizeunits = known_uoms[i].unit;
-          return MS_SUCCESS;
-        }
-    // No match was found
-    return MS_FAILURE;
-  }
-  // No uom was found
-  *sizeunits = MS_PIXELS;
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                 msSLDParseLineSymbolizer()                           */
-/*                                                                      */
-/*      Parses the LineSymbolizer rule and creates a class in the       */
-/*      layer.                                                          */
-/*                                                                      */
-/*      <xs:element name="LineSymbolizer">                              */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
-/*      <xs:element ref="sld:Stroke" minOccurs="0"/>                    */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      <xs:element name="Stroke">                                      */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:choice minOccurs="0">                                       */
-/*      <xs:element ref="sld:GraphicFill"/>                             */
-/*      <xs:element ref="sld:GraphicStroke"/>                           */
-/*      </xs:choice>                                                    */
-/*      <xs:element ref="sld:CssParameter" minOccurs="0"                */
-/*      maxOccurs="unbounded"/>                                         */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      Example of a rule :                                             */
-/*      ...                                                             */
-/*      <Rule>                                                          */
-/*      <LineSymbolizer>                                                */
-/*      <Geometry>                                                      */
-/*      <ogc:PropertyName>center-line</ogc:PropertyName>                */
-/*      </Geometry>                                                     */
-/*      <Stroke>                                                        */
-/*      <CssParameter name="stroke">#0000ff</CssParameter>              */
-/*      <CssParameter name="stroke-width">5.0</CssParameter>            */
-/*      <CssParameter name="stroke-dasharray">10.0 5 5 10</CssParameter>*/
-/*      </Stroke>                                                       */
-/*      </LineSymbolizer>                                               */
-/*      </Rule>                                                         */
-/*       ...                                                            */
-/************************************************************************/
-int msSLDParseLineSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bNewClass, const char* pszUserStyleName)
-{
-  CPLXMLNode *psStroke=NULL, *psOffset=NULL;
-
-  if (!psRoot || !psLayer)
-    return MS_FAILURE;
-
-  // Get uom if any, defaults to MS_PIXELS
-  enum MS_UNITS sizeunits = MS_PIXELS;
-  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS)
-  {
-    msSetError(MS_WMSERR, "Invalid uom attribute value.", "msSLDParsePolygonSymbolizer()");
-    return MS_FAILURE;
-  }
-
-  psStroke =  CPLGetXMLNode(psRoot, "Stroke");
-  if (psStroke) {
-    int nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-    if( nClassId < 0 )
-        return MS_FAILURE;
-
-    const int iStyle = psLayer->class[nClassId]->numstyles;
-    msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
-    psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
-
-    msSLDParseStroke(psStroke, psLayer->class[nClassId]->styles[iStyle],
-                     psLayer->map, 0);
-
-    /*parse PerpendicularOffset SLD 1.1.10*/
-    psOffset = CPLGetXMLNode(psRoot, "PerpendicularOffset");
-    if (psOffset && psOffset->psChild && psOffset->psChild->pszValue) {
-      psLayer->class[nClassId]->styles[iStyle]->offsetx = atoi(psOffset->psChild->pszValue);
-      psLayer->class[nClassId]->styles[iStyle]->offsety = MS_STYLE_SINGLE_SIDED_OFFSET;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-
-
-/************************************************************************/
-/*           void msSLDParseStroke(CPLXMLNode *psStroke, styleObj       */
-/*      *psStyle, int iColorParam)                                      */
-/*                                                                      */
-/*      Parse Stroke content into a style object.                       */
-/*      The iColorParm is used to indicate which color object to use    */
-/*      :                                                               */
-/*        0 : for color                                                 */
-/*        1 : outlinecolor                                              */
-/************************************************************************/
-int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle,
-                     mapObj *map, int iColorParam)
-{
-  CPLXMLNode *psCssParam = NULL, *psGraphicFill=NULL;
-  char *psStrkName = NULL;
-  char *pszDashValue = NULL;
-
-  if (!psStroke || !psStyle)
-    return MS_FAILURE;
-
-  /* parse css parameters */
-  psCssParam =  CPLGetXMLNode(psStroke, "CssParameter");
-  /*sld 1.1 used SvgParameter*/
-  if (psCssParam == NULL)
-    psCssParam =  CPLGetXMLNode(psStroke, "SvgParameter");
-
-  while (psCssParam && psCssParam->pszValue &&
-         (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
-          strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-    psStrkName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-
-    if (psStrkName) {
-      if (strcasecmp(psStrkName, "stroke") == 0) {
-        if(psCssParam->psChild && psCssParam->psChild->psNext)
-        {
-          switch (iColorParam) {
-            case 0:
-              msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                  psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
-              break;
-            case 1:
-              msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                  psStyle, MS_STYLE_BINDING_OUTLINECOLOR, MS_OBJ_STYLE);
-              break;
-          }
-        }
-      } else if (strcasecmp(psStrkName, "stroke-width") == 0) {
-        if(psCssParam->psChild &&  psCssParam->psChild->psNext)
-        {
-          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
-                                  MS_STYLE_BINDING_WIDTH, MS_OBJ_STYLE);
-        }
-      } else if (strcasecmp(psStrkName, "stroke-dasharray") == 0) {
-        if(psCssParam->psChild && psCssParam->psChild->psNext &&
-            psCssParam->psChild->psNext->pszValue) {
-          int nDash = 0, i;
-          char **aszValues = NULL;
-          int nMaxDash;
-          if(pszDashValue) free(pszDashValue); /* free previous if multiple stroke-dasharray attributes were found */
-          pszDashValue =
-            msStrdup(psCssParam->psChild->psNext->pszValue);
-          aszValues = msStringSplit(pszDashValue, ' ', &nDash);
-          if (nDash > 0) {
-            nMaxDash = nDash;
-            if (nDash > MS_MAXPATTERNLENGTH)
-              nMaxDash =  MS_MAXPATTERNLENGTH;
-
-            psStyle->patternlength = nMaxDash;
-            for (i=0; i<nMaxDash; i++)
-              psStyle->pattern[i] = atof(aszValues[i]);
-
-            psStyle->linecap = MS_CJC_BUTT;
-          }
-          msFreeCharArray(aszValues, nDash);
-        }
-      } else if (strcasecmp(psStrkName, "stroke-opacity") == 0) {
-        if(psCssParam->psChild &&  psCssParam->psChild->psNext)
-        {
-          msSLDParseOgcExpression(psCssParam->psChild->psNext,
-              psStyle, MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
-        }
-      }
-    }
-    psCssParam = psCssParam->psNext;
-  }
-
-  /* parse graphic fill or stroke */
-  /* graphic fill and graphic stroke pare parsed the same way :  */
-  /* TODO : It seems inconsistent to me since the only difference */
-  /* between them seems to be fill (fill) or not fill (stroke). And */
-  /* then again the fill parameter can be used inside both elements. */
-  psGraphicFill =  CPLGetXMLNode(psStroke, "GraphicFill");
-  if (psGraphicFill)
-    msSLDParseGraphicFillOrStroke(psGraphicFill, pszDashValue, psStyle, map);
-  psGraphicFill =  CPLGetXMLNode(psStroke, "GraphicStroke");
-  if (psGraphicFill)
-    msSLDParseGraphicFillOrStroke(psGraphicFill, pszDashValue, psStyle, map);
-
-  if (pszDashValue)
-    free(pszDashValue);
-
-  return MS_SUCCESS;
-}
-
-
-
-/************************************************************************/
-/*  int msSLDParseOgcExpression(CPLXMLNode *psRoot, styleObj *psStyle,  */
-/*                              enum MS_STYLE_BINDING_ENUM binding)     */
-/*                                                                      */
-/*              Parse an OGC expression in a <SvgParameter>             */
-/************************************************************************/
-int msSLDParseOgcExpression(CPLXMLNode *psRoot, void *psObj, int binding,
-                            enum objType objtype)
-{
-  int status = MS_FAILURE;
-  const char * ops = "Add+Sub-Mul*Div/";
-  styleObj * psStyle = psObj;
-  labelObj * psLabel = psObj;
-  int lbinding;
-  expressionObj *exprBindings;
-  int *nexprbindings;
-  enum { MS_STYLE_BASE = 0, MS_LABEL_BASE = 100 };
-
-  switch (objtype)
-  {
-    case MS_OBJ_STYLE:
-      lbinding = binding + MS_STYLE_BASE;
-      exprBindings = psStyle->exprBindings;
-      nexprbindings = &psStyle->nexprbindings;
-      break;
-    case MS_OBJ_LABEL:
-      lbinding = binding + MS_LABEL_BASE;
-      exprBindings = psLabel->exprBindings;
-      nexprbindings = &psLabel->nexprbindings;
-      break;
-    default:
-      return MS_FAILURE;
-      break;
-  }
-
-  switch (psRoot->eType)
-  {
-    case CXT_Text:
-      // Parse a raw value
-      {
-        msStringBuffer * literal = msStringBufferAlloc();
-        msStringBufferAppend(literal, "(");
-        msStringBufferAppend(literal, psRoot->pszValue);
-        msStringBufferAppend(literal, ")");
-        msFreeExpression(&(exprBindings[binding]));
-        msInitExpression(&(exprBindings[binding]));
-        exprBindings[binding].string =
-            msStringBufferReleaseStringAndFree(literal);
-        exprBindings[binding].type = MS_STRING;
-      }
-      switch (lbinding)
-      {
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_X:
-          psStyle->offsetx = atoi(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_Y:
-          psStyle->offsety = atoi(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_ANGLE:
-          psStyle->angle = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_SIZE:
-          psStyle->size = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_WIDTH:
-          psStyle->width = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OPACITY:
-          psStyle->opacity = atof(psRoot->pszValue)*100;
-          status = MS_SUCCESS;
-          // Apply opacity as the alpha channel color(s)
-          if(psStyle->opacity < 100)
-          {
-            int alpha = MS_NINT(psStyle->opacity*2.55);
-            psStyle->color.alpha = alpha;
-            psStyle->outlinecolor.alpha = alpha;
-            psStyle->mincolor.alpha = alpha;
-            psStyle->maxcolor.alpha = alpha;
-          }
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psStyle->color.red = msHexToInt(psRoot->pszValue+1);
-            psStyle->color.green = msHexToInt(psRoot->pszValue+3);
-            psStyle->color.blue = msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psStyle->outlinecolor.red = msHexToInt(psRoot->pszValue+1);
-            psStyle->outlinecolor.green = msHexToInt(psRoot->pszValue+3);
-            psStyle->outlinecolor.blue = msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-
-        case MS_LABEL_BASE + MS_LABEL_BINDING_SIZE:
-          psLabel->size = atof(psRoot->pszValue);
-          if (psLabel->size <= 0.0)
-          {
-            psLabel->size = 10.0;
-          }
-          status = MS_SUCCESS;
-          break;
-        case MS_LABEL_BASE + MS_LABEL_BINDING_ANGLE:
-          psLabel->angle = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psLabel->color.red = msHexToInt(psRoot->pszValue+1);
-            psLabel->color.green = msHexToInt(psRoot->pszValue+3);
-            psLabel->color.blue= msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-        case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psLabel->outlinecolor.red = msHexToInt(psRoot->pszValue+1);
-            psLabel->outlinecolor.green = msHexToInt(psRoot->pszValue+3);
-            psLabel->outlinecolor.blue= msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-        default:
-          break;
-      }
-      break;
-    case CXT_Element:
-      if (strcasecmp(psRoot->pszValue,"Literal") == 0 && psRoot->psChild)
-      {
-        // Parse a <ogc:Literal> element
-        status = msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
-      }
-      else if (strcasecmp(psRoot->pszValue,"PropertyName") == 0
-          && psRoot->psChild)
-      {
-        // Parse a <ogc:PropertyName> element
-        msStringBuffer * property = msStringBufferAlloc();
-        const char * strDelim = "";
-
-        switch (lbinding)
-        {
-          case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
-          case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
-          case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
-          case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
-            strDelim = "\"";
-            /* FALLTHROUGH */
-          default:
-            msStringBufferAppend(property, strDelim);
-            msStringBufferAppend(property, "[");
-            msStringBufferAppend(property, psRoot->psChild->pszValue);
-            msStringBufferAppend(property, "]");
-            msStringBufferAppend(property, strDelim);
-            msInitExpression(&(exprBindings[binding]));
-            exprBindings[binding].string =
-            msStringBufferReleaseStringAndFree(property);
-            exprBindings[binding].type = MS_EXPRESSION;
-            (*nexprbindings)++;
-            break;
-        }
-        status = MS_SUCCESS;
-      }
-      else if (strcasecmp(psRoot->pszValue,"Function") == 0
-          && psRoot->psChild
-          && CPLGetXMLValue(psRoot,"name",NULL)
-          && psRoot->psChild->psNext)
-      {
-        // Parse a <ogc:Function> element
-        msStringBuffer * function = msStringBufferAlloc();
-
-        // Parse function name
-        const char * funcname = CPLGetXMLValue(psRoot,"name",NULL);
-        msStringBufferAppend(function, funcname);
-        msStringBufferAppend(function, "(");
-        msInitExpression(&(exprBindings[binding]));
-
-        // Parse arguments
-        char * sep ="";
-        for (CPLXMLNode * argument = psRoot->psChild->psNext ; argument ; argument = argument->psNext)
-        {
-          status = msSLDParseOgcExpression(argument, psObj, binding, objtype);
-          if (status != MS_SUCCESS)
-            break;
-          msStringBufferAppend(function, sep);
-          msStringBufferAppend(function, exprBindings[binding].string);
-          msFree(exprBindings[binding].string);
-          msInitExpression(&(exprBindings[binding]));
-          sep = ",";
-        }
-        msStringBufferAppend(function, ")");
-        exprBindings[binding].string =
-            msStringBufferReleaseStringAndFree(function);
-        exprBindings[binding].type = MS_EXPRESSION;
-        (*nexprbindings)++;
-        status = MS_SUCCESS;
-      }
-      else if (strstr(ops, psRoot->pszValue)
-          && psRoot->psChild && psRoot->psChild->psNext)
-      {
-        // Parse an arithmetic element <ogc:Add>, <ogc:Sub>, <ogc:Mul>, <ogc:Div>
-        const char operator[2] = { *(strstr(ops, psRoot->pszValue)+3), '\0' };
-        msStringBuffer * expression = msStringBufferAlloc();
-
-        // Parse first operand
-        msStringBufferAppend(expression, "(");
-        msInitExpression(&(exprBindings[binding]));
-        status = msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
-
-        // Parse second operand
-        if (status == MS_SUCCESS)
-        {
-          msStringBufferAppend(expression, exprBindings[binding].string);
-          msStringBufferAppend(expression, operator);
-          msFree(exprBindings[binding].string);
-          msInitExpression(&(exprBindings[binding]));
-          status = msSLDParseOgcExpression(psRoot->psChild->psNext,
-              psObj, binding, objtype);
-          if (status == MS_SUCCESS)
-          {
-            msStringBufferAppend(expression, exprBindings[binding].string);
-            msStringBufferAppend(expression, ")");
-            msFree(exprBindings[binding].string);
-            exprBindings[binding].string =
-                msStringBufferReleaseStringAndFree(expression);
-            expression = NULL;
-            exprBindings[binding].type = MS_EXPRESSION;
-            (*nexprbindings)++;
-          }
-        }
-        if (expression != NULL)
-        {
-          msStringBufferFree(expression);
-          msInitExpression(&(exprBindings[binding]));
-        }
-      }
-      break;
-    default:
-      break;
-  }
-
-  return status;
-}
-
-
-/************************************************************************/
-/*                      msSLDParsePolygonSymbolizer()                   */
-/*                                                                      */
-/*      <xs:element name="PolygonSymbolizer">                           */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
-/*      <xs:element ref="sld:Fill" minOccurs="0"/>                      */
-/*      <xs:element ref="sld:Stroke" minOccurs="0"/>                    */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*                                                                      */
-/*      <xs:element name="Fill">                                        */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:GraphicFill" minOccurs="0"/>               */
-/*      <xs:element ref="sld:CssParameter" minOccurs="0"                */
-/*      maxOccurs="unbounded"/>                                         */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      Here, the CssParameter names are fill instead of stroke and     */
-/*      fill-opacity instead of stroke-opacity. None of the other CssParameters*/
-/*      in Stroke are available for filling and the default value for the fill color in this context is 50% gray (value #808080).*/
-/*                                                                      */
-/*                                                                      */
-/*      <xs:element name="GraphicFill">                                 */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:Graphic"/>                                 */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*                                                                      */
-/*      <xs:element name="Graphic">                                     */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:choice minOccurs="0" maxOccurs="unbounded">                 */
-/*      <xs:element ref="sld:ExternalGraphic"/>                         */
-/*      <xs:element ref="sld:Mark"/>                                    */
-/*      </xs:choice>                                                    */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:Opacity" minOccurs="0"/>                   */
-/*      <xs:element ref="sld:Size" minOccurs="0"/>                      */
-/*      <xs:element ref="sld:Rotation" minOccurs="0"/>                  */
-/*      </xs:sequence>                                                  */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      The default if neither an ExternalGraphic nor a Mark is specified is to use the default*/
-/*      mark of a square with a 50%-gray fill and a black outline, with a size of 6 pixels.*/
-/*                                                                      */
-/*                                                                      */
-/*      <xs:element name="Mark">                                        */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:WellKnownName" minOccurs="0"/>             */
-/*      <xs:element ref="sld:Fill" minOccurs="0"/>                      */
-/*      <xs:element ref="sld:Stroke" minOccurs="0"/>                    */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      <xs:element name="WellKnownName" type="xs:string"/>             */
-/*                                                                      */
-/*      The WellKnownName element gives the well-known name of the shape of the mark.*/
-/*      Allowed values include at least square, circle, triangle, star, cross,*/
-/*      and x, though map servers may draw a different symbol instead if they don't have a*/
-/*      shape for all of these. The default WellKnownName is square. Renderings of these*/
-/*      marks may be made solid or hollow depending on Fill and Stroke elements.*/
-/*                                                                      */
-/************************************************************************/
-int msSLDParsePolygonSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                                int bNewClass, const char* pszUserStyleName)
-{
-  CPLXMLNode *psFill, *psStroke;
-  CPLXMLNode *psDisplacement=NULL, *psDisplacementX=NULL, *psDisplacementY=NULL;
-  int nOffsetX=-1, nOffsetY=-1;
-
-  if (!psRoot || !psLayer)
-    return MS_FAILURE;
-
-  // Get uom if any, defaults to MS_PIXELS
-  enum MS_UNITS sizeunits = MS_PIXELS;
-  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS)
-  {
-    msSetError(MS_WMSERR, "Invalid uom attribute value.", "msSLDParsePolygonSymbolizer()");
-    return MS_FAILURE;
-  }
-
-  /*parse displacement for SLD 1.1.0*/
-  psDisplacement = CPLGetXMLNode(psRoot, "Displacement");
-  if (psDisplacement) {
-    psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
-    psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
-    /* psCssParam->psChild->psNext->pszValue) */
-    if (psDisplacementX &&
-        psDisplacementX->psChild &&
-        psDisplacementX->psChild->pszValue &&
-        psDisplacementY &&
-        psDisplacementY->psChild &&
-        psDisplacementY->psChild->pszValue) {
-      nOffsetX = atoi(psDisplacementX->psChild->pszValue);
-      nOffsetY = atoi(psDisplacementY->psChild->pszValue);
-    }
-  }
-
-  psFill =  CPLGetXMLNode(psRoot, "Fill");
-  if (psFill) {
-    const int nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-    if( nClassId < 0 )
-        return MS_FAILURE;
-
-    const int iStyle = psLayer->class[nClassId]->numstyles;
-    msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
-    psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
-
-    msSLDParsePolygonFill(psFill, psLayer->class[nClassId]->styles[iStyle],
-                          psLayer->map);
-
-    if (nOffsetX > 0 && nOffsetY > 0) {
-      psLayer->class[nClassId]->styles[iStyle]->offsetx = nOffsetX;
-      psLayer->class[nClassId]->styles[iStyle]->offsety = nOffsetY;
-    }
-  }
-  /* stroke which corresponds to the outline in mapserver */
-  /* is drawn after the fill */
-  psStroke =  CPLGetXMLNode(psRoot, "Stroke");
-  if (psStroke) {
-    /* -------------------------------------------------------------------- */
-    /*      there was a fill so add a style to the last class created       */
-    /*      by the fill                                                     */
-    /* -------------------------------------------------------------------- */
-    int nClassId;
-    int iStyle;
-    if (psFill && psLayer->numclasses > 0) {
-      nClassId =psLayer->numclasses-1;
-      iStyle = psLayer->class[nClassId]->numstyles;
-      msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
-      psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
-    } else {
-      nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-      if( nClassId < 0 )
-        return MS_FAILURE;
-
-      iStyle = psLayer->class[nClassId]->numstyles;
-      msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
-      psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
-
-    }
-    msSLDParseStroke(psStroke, psLayer->class[nClassId]->styles[iStyle],
-                     psLayer->map, 1);
-
-    if (nOffsetX > 0 && nOffsetY > 0) {
-      psLayer->class[nClassId]->styles[iStyle]->offsetx = nOffsetX;
-      psLayer->class[nClassId]->styles[iStyle]->offsety = nOffsetY;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*    void msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle, */
-/*                                 mapObj *map)                         */
-/*                                                                      */
-/*      Parse the Fill node for a polygon into a style.                 */
-/************************************************************************/
-int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle,
-                          mapObj *map)
-{
-  CPLXMLNode *psCssParam, *psGraphicFill;
-  char *psFillName=NULL;
-
-  if (!psFill || !psStyle || !map)
-    return MS_FAILURE;
-
-  /* sets the default fill color defined in the spec #808080 */
-  psStyle->color.red = 128;
-  psStyle->color.green = 128;
-  psStyle->color.blue = 128;
-
-  psCssParam =  CPLGetXMLNode(psFill, "CssParameter");
-  /*sld 1.1 used SvgParameter*/
-  if (psCssParam == NULL)
-    psCssParam =  CPLGetXMLNode(psFill, "SvgParameter");
-
-  while (psCssParam && psCssParam->pszValue &&
-         (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
-          strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-    psFillName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-    if (psFillName) {
-      if (strcasecmp(psFillName, "fill") == 0) {
-        if(psCssParam->psChild && psCssParam->psChild->psNext)
-        {
-          msSLDParseOgcExpression(psCssParam->psChild->psNext,
-              psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
-        }
-      } else if (strcasecmp(psFillName, "fill-opacity") == 0) {
-        if(psCssParam->psChild &&  psCssParam->psChild->psNext)
-        {
-          msSLDParseOgcExpression(psCssParam->psChild->psNext,
-              psStyle, MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
-        }
-      }
-    }
-    psCssParam = psCssParam->psNext;
-  }
-
-  /* graphic fill and graphic stroke pare parsed the same way :  */
-  /* TODO : It seems inconsistent to me since the only diffrence */
-  /* between them seems to be fill (fill) or not fill (stroke). And */
-  /* then again the fill parameter can be used inside both elements. */
-  psGraphicFill =  CPLGetXMLNode(psFill, "GraphicFill");
-  if (psGraphicFill)
-    msSLDParseGraphicFillOrStroke(psGraphicFill, NULL, psStyle, map);
-  psGraphicFill =  CPLGetXMLNode(psFill, "GraphicStroke");
-  if (psGraphicFill)
-    msSLDParseGraphicFillOrStroke(psGraphicFill, NULL, psStyle, map);
-
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                      msSLDParseGraphicFillOrStroke                   */
-/*                                                                      */
-/*      Parse the GraphicFill Or GraphicStroke node : look for a        */
-/*      Marker symbol and set the style for that symbol.                */
-/************************************************************************/
-int msSLDParseGraphicFillOrStroke(CPLXMLNode *psRoot,
-                                  char *pszDashValue_unused,
-                                  styleObj *psStyle, mapObj *map)
-{
-  (void)pszDashValue_unused;
-  CPLXMLNode  *psCssParam, *psGraphic, *psExternalGraphic, *psMark, *psSize, *psGap, *psInitialGap;
-  CPLXMLNode *psWellKnownName, *psStroke, *psFill;
-  CPLXMLNode *psDisplacement=NULL, *psDisplacementX=NULL, *psDisplacementY=NULL;
-  CPLXMLNode *psOpacity=NULL, *psRotation=NULL;
-  char *psName=NULL, *psValue = NULL;
-  char *pszSymbolName = NULL;
-  int bFilled = 0;
-
-  if (!psRoot || !psStyle || !map)
-    return MS_FAILURE;
-  /* ==================================================================== */
-  /*      This a definition taken from the specification (11.3.2) :       */
-  /*      Graphics can either be referenced from an external URL in a common format (such as*/
-  /*      GIF or SVG) or may be derived from a Mark. Multiple external URLs and marks may be*/
-  /*      referenced with the semantic that they all provide the equivalent graphic in different*/
-  /*      formats.                                                        */
-  /*                                                                      */
-  /*      For this reason, we only need to support one Mark and one       */
-  /*      ExtrnalGraphic ????                                             */
-  /* ==================================================================== */
-  psGraphic =  CPLGetXMLNode(psRoot, "Graphic");
-  if (psGraphic) {
-    /* extract symbol size */
-    psSize = CPLGetXMLNode(psGraphic, "Size");
-    if (psSize && psSize->psChild)
-    {
-      msSLDParseOgcExpression(psSize->psChild,
-          psStyle, MS_STYLE_BINDING_SIZE, MS_OBJ_STYLE);
-    }
-    else {
-      /*do not set a default for external symbols #2305*/
-      psExternalGraphic =  CPLGetXMLNode(psGraphic, "ExternalGraphic");
-      if (!psExternalGraphic)
-        psStyle->size = 6; /* default value */
-    }
-
-    /*SLD 1.1.0 extract opacity, rotation, displacement*/
-    psOpacity = CPLGetXMLNode(psGraphic, "Opacity");
-    if (psOpacity && psOpacity->psChild)
-    {
-      msSLDParseOgcExpression(psOpacity->psChild,
-          psStyle, MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
-    }
-
-    psRotation = CPLGetXMLNode(psGraphic, "Rotation");
-    if (psRotation && psRotation->psChild)
-    {
-      msSLDParseOgcExpression(psRotation->psChild,
-          psStyle, MS_STYLE_BINDING_ANGLE, MS_OBJ_STYLE);
-    }
-    psDisplacement = CPLGetXMLNode(psGraphic, "Displacement");
-    if (psDisplacement && psDisplacement->psChild)
-    {
-      psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
-      if (psDisplacementX && psDisplacementX->psChild)
-      {
-        msSLDParseOgcExpression(psDisplacementX->psChild,
-            psStyle, MS_STYLE_BINDING_OFFSET_X, MS_OBJ_STYLE);
-      }
-      psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
-      if (psDisplacementY && psDisplacementY->psChild)
-      {
-        msSLDParseOgcExpression(psDisplacementY->psChild,
-            psStyle, MS_STYLE_BINDING_OFFSET_Y, MS_OBJ_STYLE);
-      }
-    }
-    /* extract symbol */
-    psMark =  CPLGetXMLNode(psGraphic, "Mark");
-    if (psMark) {
-      pszSymbolName = NULL;
-      psWellKnownName =  CPLGetXMLNode(psMark, "WellKnownName");
-      if (psWellKnownName && psWellKnownName->psChild &&
-          psWellKnownName->psChild->pszValue)
-        pszSymbolName =
-          msStrdup(psWellKnownName->psChild->pszValue);
-
-      /* default symbol is square */
-
-      if (!pszSymbolName || !*pszSymbolName ||
-          (strcasecmp(pszSymbolName, "square") != 0 &&
-           strcasecmp(pszSymbolName, "circle") != 0 &&
-           strcasecmp(pszSymbolName, "triangle") != 0 &&
-           strcasecmp(pszSymbolName, "star") != 0 &&
-           strcasecmp(pszSymbolName, "cross") != 0 &&
-           strcasecmp(pszSymbolName, "x") != 0)) {
-        if (!pszSymbolName || !*pszSymbolName || msGetSymbolIndex(&map->symbolset, pszSymbolName,  MS_FALSE) < 0) {
-          msFree(pszSymbolName);
-          pszSymbolName = msStrdup("square");
-        }
-      }
-
-
-      /* check if the symbol should be filled or not */
-      psFill = CPLGetXMLNode(psMark, "Fill");
-      psStroke = CPLGetXMLNode(psMark, "Stroke");
-
-      if (psFill || psStroke) {
-        if (psFill)
-          bFilled = 1;
-        else
-          bFilled = 0;
-
-        if (psFill) {
-          psCssParam =  CPLGetXMLNode(psFill, "CssParameter");
-          /*sld 1.1 used SvgParameter*/
-          if (psCssParam == NULL)
-            psCssParam =  CPLGetXMLNode(psFill, "SvgParameter");
-
-          while (psCssParam && psCssParam->pszValue &&
-                 (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
-                  strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-            psName =
-              (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-            if (psName &&
-                strcasecmp(psName, "fill") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                    psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
-              }
-            } else if (psName &&
-                       strcasecmp(psName, "fill-opacity") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                psValue = psCssParam->psChild->psNext->pszValue;
-                if (psValue) {
-                  psStyle->color.alpha = (int)(atof(psValue)*255);
-                }
-              }
-            }
-
-            psCssParam = psCssParam->psNext;
-          }
-        }
-        if (psStroke) {
-          psCssParam =  CPLGetXMLNode(psStroke, "CssParameter");
-          /*sld 1.1 used SvgParameter*/
-          if (psCssParam == NULL)
-            psCssParam =  CPLGetXMLNode(psStroke, "SvgParameter");
-
-          while (psCssParam && psCssParam->pszValue &&
-                 (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
-                  strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-            psName =
-              (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-            if (psName &&
-                strcasecmp(psName, "stroke") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                if (bFilled) {
-                  msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                      psStyle, MS_STYLE_BINDING_OUTLINECOLOR, MS_OBJ_STYLE);
-                } else {
-                  msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                      psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
-                }
-              }
-            } else if (psName &&
-                       strcasecmp(psName, "stroke-opacity") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                psValue = psCssParam->psChild->psNext->pszValue;
-                if (psValue) {
-                  if (bFilled) {
-                    psStyle->outlinecolor.alpha = (int)(atof(psValue)*255);
-                  } else {
-                    psStyle->color.alpha = (int)(atof(psValue)*255);
-                  }
-                }
-              }
-            } else if (psName &&
-                       strcasecmp(psName, "stroke-width") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                    psStyle, MS_STYLE_BINDING_WIDTH, MS_OBJ_STYLE);
-              }
-            }
-
-            psCssParam = psCssParam->psNext;
-          }
-        }
-
-      }
-      /* set the default color if color is not not already set */
-      if ((psStyle->color.red < 0 ||
-           psStyle->color.green == -1 ||
-           psStyle->color.blue == -1) &&
-          (psStyle->outlinecolor.red == -1 ||
-           psStyle->outlinecolor.green == -1 ||
-           psStyle->outlinecolor.blue == -1)) {
-        psStyle->color.red = 128;
-        psStyle->color.green = 128;
-        psStyle->color.blue = 128;
-      }
-
-
-      /* Get the corresponding symbol id  */
-      psStyle->symbol = msSLDGetMarkSymbol(map, pszSymbolName, bFilled);
-      if (psStyle->symbol > 0 &&
-          psStyle->symbol < map->symbolset.numsymbols)
-        psStyle->symbolname =
-          msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
-
-    } else {
-      psExternalGraphic =  CPLGetXMLNode(psGraphic, "ExternalGraphic");
-      if (psExternalGraphic)
-        msSLDParseExternalGraphic(psExternalGraphic, psStyle, map);
-    }
-    msFree(pszSymbolName);
-  }
-  psGap =  CPLGetXMLNode(psRoot, "Gap");
-  if (psGap && psGap->psChild && psGap->psChild->pszValue) {
-    psStyle->gap = atof(psGap->psChild->pszValue);
-  }
-  psInitialGap =  CPLGetXMLNode(psRoot, "InitialGap");
-  if (psInitialGap && psInitialGap->psChild && psInitialGap->psChild->pszValue) {
-    psStyle->initialgap = atof(psInitialGap->psChild->pszValue);
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                            msSLDGetMarkSymbol                        */
-/*                                                                      */
-/*      Get a Mark symbol using the name. Mark symbols can be           */
-/*      square, circle, triangle, star, cross, x.                       */
-/*      If the symbol does not exist add it to the symbol list.        */
-/************************************************************************/
-int msSLDGetMarkSymbol(mapObj *map, char *pszSymbolName, int bFilled)
-{
-  int nSymbolId = 0;
-  symbolObj *psSymbol = NULL;
-
-  if (!map || !pszSymbolName)
-    return 0;
-
-  if (strcasecmp(pszSymbolName, "square") == 0) {
-    if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_SQUARE_FILLED,
-                                   MS_FALSE);
-    else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_SQUARE,
-                                   MS_FALSE);
-  } else if (strcasecmp(pszSymbolName, "circle") == 0) {
-
-    if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CIRCLE_FILLED,
-                                   MS_FALSE);
-    else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CIRCLE,
-                                   MS_FALSE);
-  } else if (strcasecmp(pszSymbolName, "triangle") == 0) {
-
-    if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_TRIANGLE_FILLED,
-                                   MS_FALSE);
-    else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_TRIANGLE,
-                                   MS_FALSE);
-  } else if (strcasecmp(pszSymbolName, "star") == 0) {
-
-    if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_STAR_FILLED,
-                                   MS_FALSE);
-    else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_STAR,
-                                   MS_FALSE);
-  } else if (strcasecmp(pszSymbolName, "cross") == 0) {
-
-    if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CROSS_FILLED,
-                                   MS_FALSE);
-    else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CROSS,
-                                   MS_FALSE);
-  } else if (strcasecmp(pszSymbolName, "x") == 0) {
-
-    if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_X_FILLED,
-                                   MS_FALSE);
-    else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_X,
-                                   MS_FALSE);
-  } else {
-    nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                 pszSymbolName,
-                                 MS_FALSE);
-  }
-
-  if (nSymbolId <= 0) {
-    if( (psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
-      return 0; /* returns 0 for no symbol */
-
-    nSymbolId = map->symbolset.numsymbols;
-    map->symbolset.numsymbols++;
-    initSymbol(psSymbol);
-    psSymbol->inmapfile = MS_TRUE;
-    psSymbol->sizex = 1;
-    psSymbol->sizey = 1;
-
-    if (strcasecmp(pszSymbolName, "square") == 0) {
-      if (bFilled)
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_SQUARE_FILLED);
-      else
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_SQUARE);
-
-      psSymbol->type = MS_SYMBOL_VECTOR;
-      if (bFilled)
-        psSymbol->filled = MS_TRUE;
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 0;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 0;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-    } else if (strcasecmp(pszSymbolName, "circle") == 0) {
-      if (bFilled)
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CIRCLE_FILLED);
-      else
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CIRCLE);
-
-      psSymbol->type = MS_SYMBOL_ELLIPSE;
-      if (bFilled)
-        psSymbol->filled = MS_TRUE;
-
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->sizex = 1;
-      psSymbol->sizey = 1;
-      psSymbol->numpoints++;
-    } else if (strcasecmp(pszSymbolName, "triangle") == 0) {
-      if (bFilled)
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_TRIANGLE_FILLED);
-      else
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_TRIANGLE);
-
-      psSymbol->type = MS_SYMBOL_VECTOR;
-      if (bFilled)
-        psSymbol->filled = MS_TRUE;
-
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.5;
-      psSymbol->points[psSymbol->numpoints].y = 0;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-
-    } else if (strcasecmp(pszSymbolName, "star") == 0) {
-      if (bFilled)
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_STAR_FILLED);
-      else
-        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_STAR);
-
-      psSymbol->type = MS_SYMBOL_VECTOR;
-      if (bFilled)
-        psSymbol->filled = MS_TRUE;
-
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 0.375;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.35;
-      psSymbol->points[psSymbol->numpoints].y = 0.375;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.5;
-      psSymbol->points[psSymbol->numpoints].y = 0;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.65;
-      psSymbol->points[psSymbol->numpoints].y = 0.375;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 0.375;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.75;
-      psSymbol->points[psSymbol->numpoints].y = 0.625;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.875;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.5;
-      psSymbol->points[psSymbol->numpoints].y = 0.75;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.125;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.25;
-      psSymbol->points[psSymbol->numpoints].y = 0.625;
-      psSymbol->numpoints++;
-    }
-    /* cross is like plus (+) since there is also X symbol ?? */
-    else if (strcasecmp(pszSymbolName, "cross") == 0) {
-      /* NEVER FILL CROSS */
-      /* if (bFilled) */
-      /* psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CROSS_FILLED); */
-      /* else */
-      psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CROSS);
-
-      psSymbol->type = MS_SYMBOL_VECTOR;
-      /* if (bFilled) */
-      /* psSymbol->filled = MS_TRUE; */
-
-      psSymbol->points[psSymbol->numpoints].x = 0.5;
-      psSymbol->points[psSymbol->numpoints].y = 0;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0.5;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = -99;
-      psSymbol->points[psSymbol->numpoints].y = -99;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 0.5;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 0.5;
-      psSymbol->numpoints++;
-    } else if (strcasecmp(pszSymbolName, "x") == 0) {
-      /* NEVER FILL X */
-      /* if (bFilled) */
-      /* psSymbol->name = msStrdup(SLD_MARK_SYMBOL_X_FILLED); */
-      /* else */
-      psSymbol->name = msStrdup(SLD_MARK_SYMBOL_X);
-
-      psSymbol->type = MS_SYMBOL_VECTOR;
-      /* if (bFilled) */
-      /* psSymbol->filled = MS_TRUE; */
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 0;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = -99;
-      psSymbol->points[psSymbol->numpoints].y = -99;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 0;
-      psSymbol->points[psSymbol->numpoints].y = 1;
-      psSymbol->numpoints++;
-      psSymbol->points[psSymbol->numpoints].x = 1;
-      psSymbol->points[psSymbol->numpoints].y = 0;
-      psSymbol->numpoints++;
-    }
-
-  }
-
-  return nSymbolId;
-}
-
-/************************************************************************/
-/*                          msSLDGetGraphicSymbol                       */
-/*                                                                      */
-/*      Create a symbol entry for an inmap pixmap symbol. Returns       */
-/*      the symbol id.                                                  */
-/************************************************************************/
-int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName,  char* extGraphicName,
-                          int nGap_ignored)
-{
-  (void)nGap_ignored;
-  int nSymbolId = 0;
-  symbolObj *psSymbol = NULL;
-
-
-  if (map && pszFileName) {
-    if( (psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
-      return 0; /* returns 0 for no symbol */
-    nSymbolId = map->symbolset.numsymbols;
-    map->symbolset.numsymbols++;
-    initSymbol(psSymbol);
-    psSymbol->inmapfile = MS_TRUE;
-    psSymbol->type = MS_SYMBOL_PIXMAP;
-    psSymbol->name = msStrdup(extGraphicName);
-    psSymbol->imagepath = msStrdup(pszFileName);
-    psSymbol->full_pixmap_path = msStrdup(pszFileName);
-  }
-  return nSymbolId;
-}
-
-
-/************************************************************************/
-/*      msSLDParsePointSymbolizer                                       */
-/*                                                                      */
-/*      Parse point symbolizer.                                         */
-/*                                                                      */
-/*      <xs:element name="PointSymbolizer">                             */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
-/*      <xs:element ref="sld:Graphic" minOccurs="0"/>                   */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/************************************************************************/
-int msSLDParsePointSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                              int bNewClass, const char* pszUserStyleName)
-{
-  int nClassId = 0;
-  int iStyle = 0;
-
-  if (!psRoot || !psLayer)
-    return MS_FAILURE;
-
-  nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-  if( nClassId < 0 )
-    return MS_FAILURE;
-
-  // Get uom if any, defaults to MS_PIXELS
-  enum MS_UNITS sizeunits = MS_PIXELS;
-  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS)
-  {
-    msSetError(MS_WMSERR, "Invalid uom attribute value.", "msSLDParsePolygonSymbolizer()");
-    return MS_FAILURE;
-  }
-
-  iStyle = psLayer->class[nClassId]->numstyles;
-  msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
-  psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
-
-  msSLDParseGraphicFillOrStroke(psRoot, NULL,
-                                psLayer->class[nClassId]->styles[iStyle],
-                                psLayer->map);
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                        msSLDParseExternalGraphic                     */
-/*                                                                      */
-/*      Parse external graphic node : download the symbol referenced    */
-/*      by the URL and create a PIXMAP inmap symbol. Only GIF and       */
-/*      PNG are supported.                                              */
-/************************************************************************/
-int msSLDParseExternalGraphic(CPLXMLNode *psExternalGraphic,
-                              styleObj *psStyle,  mapObj *map)
-{
-  char *pszFormat = NULL;
-  CPLXMLNode *psURL=NULL, *psFormat=NULL, *psTmp=NULL;
-  char *pszURL=NULL;
-
-  if (!psExternalGraphic || !psStyle || !map)
-    return MS_FAILURE;
-
-  psFormat = CPLGetXMLNode(psExternalGraphic, "Format");
-  if (psFormat && psFormat->psChild && psFormat->psChild->pszValue)
-    pszFormat = psFormat->psChild->pszValue;
-
-  /* supports GIF and PNG and SVG */
-  if (pszFormat &&
-      (strcasecmp(pszFormat, "GIF") == 0 ||
-       strcasecmp(pszFormat, "image/gif") == 0 ||
-       strcasecmp(pszFormat, "PNG") == 0 ||
-       strcasecmp(pszFormat, "image/png") == 0 ||
-       strcasecmp(pszFormat, "image/svg+xml") == 0)) {
-
-    /* <OnlineResource xmlns:xlink="http://www.w3.org/1999/xlink" xlink:type="simple" xlink:href="http://www.vendor.com/geosym/2267.svg"/> */
-    psURL = CPLGetXMLNode(psExternalGraphic, "OnlineResource");
-    if (psURL && psURL->psChild) {
-      psTmp =  psURL->psChild;
-      while (psTmp != NULL &&
-             psTmp->pszValue &&
-             strcasecmp(psTmp->pszValue, "xlink:href") != 0) {
-        psTmp = psTmp->psNext;
-      }
-      if (psTmp && psTmp->psChild) {
-        pszURL = (char*)psTmp->psChild->pszValue;
-
-        char *symbolurl = NULL;
-        // Handle relative URL for ExternalGraphic
-        if (map->sldurl && !strstr(pszURL,"://"))
-        {
-          char *baseurl = NULL;
-          char *relpath = NULL;
-          symbolurl = malloc(sizeof(char)*MS_MAXPATHLEN);
-          if (pszURL[0] != '/') {
-            // Symbol file is relative to SLD file
-            // e.g. SLD   : http://example.com/path/to/sld.xml
-            //  and symbol: assets/symbol.svg
-            //     lead to: http://example.com/path/to/assets/symbol.svg
-            baseurl = msGetPath(map->sldurl);
-            relpath = pszURL;
-          }
-          else
-          {
-            // Symbol file is relative to the root of SLD server
-            // e.g. SLD   : http://example.com/path/to/sld.xml
-            //  and symbol: /path/to/assets/symbol.svg
-            //     lead to: http://example.com/path/to/assets/symbol.svg
-            baseurl = msStrdup(map->sldurl);
-            relpath = pszURL+1;
-            char * sep = strstr(baseurl,"://");
-            if (sep)
-              sep += 3;
-            else
-              sep = baseurl;
-            sep = strchr(sep,'/');
-            if (!sep)
-              sep = baseurl + strlen(baseurl);
-            sep[1] = '\0';
-          }
-          msBuildPath(symbolurl,baseurl,relpath);
-          msFree(baseurl);
-        }
-        else
-        {
-          // Absolute URL
-          // e.g. symbol: http://example.com/path/to/assets/symbol.svg
-          symbolurl = msStrdup(pszURL);
-        }
-
-        /* validate the ExternalGraphic parameter */
-        if(msValidateParameter(symbolurl, msLookupHashTable(&(map->web.validation), "sld_external_graphic"),
-                               NULL, NULL, NULL) != MS_SUCCESS) {
-          msSetError(MS_WEBERR, "SLD ExternalGraphic OnlineResource value fails to validate against sld_external_graphic VALIDATION", "mapserv()");
-          msFree(symbolurl);
-          return MS_FAILURE;
-        }
-
-
-        /*external symbols using http will be automaticallly downloaded. The file should be
-          saved in a temporary directory (msAddImageSymbol) #2305*/
-        psStyle->symbol = msGetSymbolIndex(&map->symbolset,
-                                           symbolurl,
-                                           MS_TRUE);
-        msFree(symbolurl);
-
-        if (psStyle->symbol > 0 && psStyle->symbol < map->symbolset.numsymbols)
-          psStyle->symbolname = msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
-
-        /* set the color parameter if not set. Does not make sense */
-        /* for pixmap but mapserver needs it. */
-        if (psStyle->color.red == -1 || psStyle->color.green || psStyle->color.blue) {
-          psStyle->color.red = 0;
-          psStyle->color.green = 0;
-          psStyle->color.blue = 0;
-        }
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                         msSLDParseTextSymbolizer                     */
-/*                                                                      */
-/*      Parse text symbolizer.                                          */
-/*                                                                      */
-/*      <xs:element name="TextSymbolizer">                              */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
-/*      <xs:element ref="sld:Label" minOccurs="0"/>                     */
-/*      <xs:element ref="sld:Font" minOccurs="0"/>                      */
-/*      <xs:element ref="sld:LabelPlacement" minOccurs="0"/>            */
-/*      <xs:element ref="sld:Halo" minOccurs="0"/>                      */
-/*      <xs:element ref="sld:Fill" minOccurs="0"/>                      */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      <xs:element name="Label" type="sld:ParameterValueType"/         */
-/*                                                                      */
-/*      <xs:element name="Font">                                        */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:CssParameter" minOccurs="0"                */
-/*      maxOccurs="unbounded"/>                                         */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      Four types of CssParameter are allowed, font-family, font-style,*/
-/*      fontweight,and font-size.                                       */
-/*                                                                      */
-/*      <xs:element name="LabelPlacement">                              */
-/*      <xs:complexType>                                                */
-/*      <xs:choice>                                                     */
-/*      <xs:element ref="sld:PointPlacement"/>                          */
-/*      <xs:element ref="sld:LinePlacement"/>                           */
-/*      </xs:choice>                                                    */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      <xs:element name="PointPlacement">                              */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:AnchorPoint" minOccurs="0"/>               */
-/*      <xs:element ref="sld:Displacement" minOccurs="0"/>              */
-/*      <xs:element ref="sld:Rotation" minOccurs="0"/>                  */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      <xs:element name="AnchorPoint">                                 */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:AnchorPointX"/>                            */
-/*      <xs:element ref="sld:AnchorPointY"/>                            */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*      <xs:element name="AnchorPointX" type="sld:ParameterValueType"/> */
-/*      <xs:element name="AnchorPointY"                                 */
-/*      type="sld:ParameterValueType"/>                                 */
-/*                                                                      */
-/*      The coordinates are given as two floating-point numbers in      */
-/*      the AnchorPointX and AnchorPointY elements each with values     */
-/*      between 0.0 and 1.0 inclusive. The bounding box of the label    */
-/*      to be rendered is considered to be in a coorindate space        */
-/*      from 0.0 (lowerleft corner) to 1.0 (upper-right corner), and    */
-/*      the anchor position is specified as a point in  this            */
-/*      space. The default point is X=0, Y=0.5, which is at the         */
-/*      middle height of the lefthand side of the label.                */
-/*                                                                      */
-/*      <xs:element name="Displacement">                                */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:DisplacementX"/>                           */
-/*      <xs:element ref="sld:DisplacementY"/>                           */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*      <xs:element name="DisplacementX" type="sld:ParameterValueType"/>*/
-/*      <xs:element name="DisplacementY"                                */
-/*      type="sld:ParameterValueType"/>                                 */
-/*                                                                      */
-/*      <xs:element name="LinePlacement">                               */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:PerpendicularOffset" minOccurs="0"/>       */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/************************************************************************/
-int msSLDParseTextSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bOtherSymboliser, const char* pszUserStyleName)
-{
-  int nStyleId=0, nClassId=0;
-
-  if (!psRoot || !psLayer)
-    return MS_FAILURE;
-
-  if (!bOtherSymboliser) {
-    if (msGrowLayerClasses(psLayer) == NULL)
-      return MS_FAILURE;
-    initClass(psLayer->class[psLayer->numclasses]);
-    nClassId = psLayer->numclasses;
-    if( pszUserStyleName )
-        psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
-    psLayer->numclasses++;
-    msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
-    nStyleId = 0;
-  } else {
-    nClassId = psLayer->numclasses - 1;
-    if (nClassId >= 0)/* should always be true */
-      nStyleId = psLayer->class[nClassId]->numstyles -1;
-  }
-
-  if (nStyleId >= 0 && nClassId >= 0) /* should always be true */
-    msSLDParseTextParams(psRoot, psLayer,
-                         psLayer->class[nClassId]);
-
-  return MS_SUCCESS;
-}
-
-
-
-/************************************************************************/
-/*                        msSLDParseRasterSymbolizer                    */
-/*                                                                      */
-/*      Supports the ColorMap parameter in a Raster Symbolizer. In      */
-/*      the ColorMap, only color and quantity are used here.            */
-/*                                                                      */
-/*      <xs:element name="RasterSymbolizer">                            */
-/*      <xs:complexType>                                                */
-/*      <xs:sequence>                                                   */
-/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
-/*      <xs:element ref="sld:Opacity" minOccurs="0"/>                   */
-/*      <xs:element ref="sld:ChannelSelection" minOccurs="0"/>          */
-/*      <xs:element ref="sld:OverlapBehavior" minOccurs="0"/>           */
-/*      <xs:element ref="sld:ColorMap" minOccurs="0"/>                  */
-/*      <xs:element ref="sld:ContrastEnhancement" minOccurs="0"/>       */
-/*      <xs:element ref="sld:ShadedRelief" minOccurs="0"/>              */
-/*      <xs:element ref="sld:ImageOutline" minOccurs="0"/>              */
-/*      </xs:sequence>                                                  */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      <xs:element name="ColorMap">                                    */
-/*      <xs:complexType>                                                */
-/*      <xs:choice minOccurs="0" maxOccurs="unbounded">                 */
-/*      <xs:element ref="sld:ColorMapEntry"/>                           */
-/*      </xs:choice>                                                    */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*      <xs:element name="ColorMapEntry">                               */
-/*      <xs:complexType>                                                */
-/*      <xs:attribute name="color" type="xs:string" use="required"/>    */
-/*      <xs:attribute name="opacity" type="xs:double"/>                 */
-/*      <xs:attribute name="quantity" type="xs:double"/>                */
-/*      <xs:attribute name="label" type="xs:string"/>                   */
-/*      </xs:complexType>                                               */
-/*      </xs:element>                                                   */
-/*                                                                      */
-/*      SLD 1.1                                                         */
-/*                                                                      */
-/*      <xsd:element name="RasterSymbolizer" type="se:RasterSymbolizerType" substitutionGroup="se:Symbolizer"/>*/
-/*      <xsd:complexType name="RasterSymbolizerType">                   */
-/*      <xsd:complexContent>                                            */
-/*      <xsd:extension base="se:SymbolizerType">                        */
-/*      <xsd:sequence>                                                  */
-/*      <xsd:element ref="se:Geometry" minOccurs="0"/>                  */
-/*      <xsd:element ref="se:Opacity" minOccurs="0"/>                   */
-/*      <xsd:element ref="se:ChannelSelection" minOccurs="0"/>          */
-/*      <xsd:element ref="se:OverlapBehavior" minOccurs="0"/>           */
-/*      <xsd:element ref="se:ColorMap" minOccurs="0"/>                  */
-/*      <xsd:element ref="se:ContrastEnhancement" minOccurs="0"/>       */
-/*      <xsd:element ref="se:ShadedRelief" minOccurs="0"/>              */
-/*      <xsd:element ref="se:ImageOutline" minOccurs="0"/>              */
-/*      </xsd:sequence>                                                 */
-/*      </xsd:extension>                                                */
-/*      </xsd:complexContent>                                           */
-/*      </xsd:complexType>                                              */
-/*                                                                      */
-/*      <xsd:element name="ColorMap" type="se:ColorMapType"/>           */
-/*      <xsd:complexType name="ColorMapType">                           */
-/*      <xsd:choice>                                                    */
-/*      <xsd:element ref="se:Categorize"/>                              */
-/*      <xsd:element ref="se:Interpolate"/>                             */
-/*      </xsd:choice>                                                   */
-/*      </xsd:complexType>                                              */
-/*                                                                      */
-/*      <xsd:element name="Categorize" type="se:CategorizeType" substitutionGroup="se:Function"/>*/
-/*      <xsd:complexType name="CategorizeType">                         */
-/*      <xsd:complexContent>                                            */
-/*      <xsd:extension base="se:FunctionType">                          */
-/*      <xsd:sequence>                                                  */
-/*      <xsd:element ref="se:LookupValue"/>                             */
-/*      <xsd:element ref="se:Value"/>                                   */
-/*      <xsd:sequence minOccurs="0" maxOccurs="unbounded">              */
-/*      <xsd:element ref="se:Threshold"/>                               */
-/*      <xsd:element ref="se:Value"/>                                   */
-/*      </xsd:sequence>                                                 */
-/*      </xsd:sequence>                                                 */
-/*      <xsd:attribute name="threshholdsBelongTo" type="se:ThreshholdsBelongToType" use="optional"/>*/
-/*      </xsd:extension>                                                */
-/*      </xsd:complexContent>                                           */
-/*      </xsd:complexType>                                              */
-/*      <xsd:element name="LookupValue" type="se:ParameterValueType"/>  */
-/*      <xsd:element name="Value" type=" se:ParameterValueType"/>       */
-/*      <xsd:element name="Threshold" type=" se:ParameterValueType"/>   */
-/*      <xsd:simpleType name="ThreshholdsBelongToType">                 */
-/*      <xsd:restriction base="xsd:token">                              */
-/*      <xsd:enumeration value="succeeding"/>                           */
-/*      <xsd:enumeration value="preceding"/>                            */
-/*      </xsd:restriction>                                              */
-/*      </xsd:simpleType>                                               */
-/*                                                                      */
-/************************************************************************/
-int msSLDParseRasterSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                               const char* pszUserStyleName)
-{
-  CPLXMLNode  *psColorMap = NULL, *psColorEntry = NULL, *psOpacity=NULL;
-  char *pszColor=NULL, *pszQuantity=NULL;
-  char *pszPreviousColor=NULL, *pszPreviousQuality=NULL;
-  colorObj sColor;
-  char szExpression[100];
-  double dfOpacity = 1.0;
-  char *pszLabel = NULL,  *pszPreviousLabel = NULL;
-  char *pch = NULL, *pchPrevious=NULL;
-
-  CPLXMLNode  *psNode=NULL, *psCategorize=NULL;
-  char *pszTmp = NULL;
-  int nValues=0, nThresholds=0;
-  int i,nMaxValues= 100, nMaxThreshold=100;
-
-  if (!psRoot || !psLayer)
-    return MS_FAILURE;
-
-  psOpacity = CPLGetXMLNode(psRoot, "Opacity");
-  if (psOpacity) {
-    if (psOpacity->psChild && psOpacity->psChild->pszValue)
-      dfOpacity = atof(psOpacity->psChild->pszValue);
-
-    /* values in sld goes from 0.0 (for transparent) to 1.0 (for full opacity); */
-    if (dfOpacity >=0.0 && dfOpacity <=1.0)
-      msSetLayerOpacity(psLayer,(int)(dfOpacity * 100));
-    else {
-      msSetError(MS_WMSERR, "Invalid opacity value. Values should be between 0.0 and 1.0", "msSLDParseRasterSymbolizer()");
-      return MS_FAILURE;
-    }
-  }
-  psColorMap = CPLGetXMLNode(psRoot, "ColorMap");
-  if (psColorMap) {
-    psColorEntry = CPLGetXMLNode(psColorMap, "ColorMapEntry");
-
-    if (psColorEntry) { /*SLD 1.0*/
-      while (psColorEntry && psColorEntry->pszValue &&
-             strcasecmp(psColorEntry->pszValue, "ColorMapEntry") == 0) {
-        pszColor = (char *)CPLGetXMLValue(psColorEntry, "color", NULL);
-        pszQuantity = (char *)CPLGetXMLValue(psColorEntry, "quantity", NULL);
-        pszLabel = (char *)CPLGetXMLValue(psColorEntry, "label", NULL);
-
-        if (pszColor && pszQuantity) {
-          if (pszPreviousColor && pszPreviousQuality) {
-            if (strlen(pszPreviousColor) == 7 &&
-                pszPreviousColor[0] == '#' &&
-                strlen(pszColor) == 7 && pszColor[0] == '#') {
-              sColor.red = msHexToInt(pszPreviousColor+1);
-              sColor.green= msHexToInt(pszPreviousColor+3);
-              sColor.blue = msHexToInt(pszPreviousColor+5);
-
-              /* pszQuantity and pszPreviousQuality may be integer or float */
-              pchPrevious=strchr(pszPreviousQuality,'.');
-              pch=strchr(pszQuantity,'.');
-              if (pchPrevious==NULL && pch==NULL) {
-                snprintf(szExpression, sizeof(szExpression),
-                         "([pixel] >= %d AND [pixel] < %d)",
-                         atoi(pszPreviousQuality),
-                         atoi(pszQuantity));
-              } else if (pchPrevious != NULL && pch==NULL) {
-                snprintf(szExpression, sizeof(szExpression),
-                         "([pixel] >= %f AND [pixel] < %d)",
-                         atof(pszPreviousQuality),
-                         atoi(pszQuantity));
-              } else if (pchPrevious == NULL && pch != NULL) {
-                snprintf(szExpression, sizeof(szExpression),
-                         "([pixel] >= %d AND [pixel] < %f)",
-                         atoi(pszPreviousQuality),
-                         atof(pszQuantity));
-              } else {
-                snprintf(szExpression, sizeof(szExpression),
-                         "([pixel] >= %f AND [pixel] < %f)",
-                         atof(pszPreviousQuality),
-                         atof(pszQuantity));
-              }
-
-
-              if (msGrowLayerClasses(psLayer) == NULL)
-                return MS_FAILURE;
-              else {
-                initClass(psLayer->class[psLayer->numclasses]);
-                psLayer->numclasses++;
-                const int nClassId = psLayer->numclasses-1;
-                if( pszUserStyleName )
-                    psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
-
-                /*set the class name using the label. If label not defined
-                  set it with the quantity*/
-                if (pszPreviousLabel)
-                  psLayer->class[nClassId]->name = msStrdup(pszPreviousLabel);
-                else
-                  psLayer->class[nClassId]->name = msStrdup(pszPreviousQuality);
-
-                msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
-
-                psLayer->class[nClassId]->styles[0]->color.red =
-                      sColor.red;
-              psLayer->class[nClassId]->styles[0]->color.green =
-                      sColor.green;
-              psLayer->class[nClassId]->styles[0]->color.blue =
-                      sColor.blue;
-
-                if (psLayer->classitem &&
-                    strcasecmp(psLayer->classitem, "[pixel]") != 0)
-                  free(psLayer->classitem);
-                psLayer->classitem = msStrdup("[pixel]");
-
-                msLoadExpressionString(&psLayer->class[nClassId]->expression,
-                                       szExpression);
-
-
-              }
-            } else {
-              msSetError(MS_WMSERR,
-                         "Invalid ColorMap Entry.",
-                         "msSLDParseRasterSymbolizer()");
-              return MS_FAILURE;
-            }
-
-          }
-
-          pszPreviousColor = pszColor;
-          pszPreviousQuality = pszQuantity;
-          pszPreviousLabel = pszLabel;
-
-        }
-        psColorEntry = psColorEntry->psNext;
-      }
-      /* do the last Color Map Entry */
-      if (pszColor && pszQuantity) {
-        if (strlen(pszColor) == 7 && pszColor[0] == '#') {
-          sColor.red = msHexToInt(pszColor+1);
-          sColor.green= msHexToInt(pszColor+3);
-          sColor.blue = msHexToInt(pszColor+5);
-
-          /* pszQuantity may be integer or float */
-          pch=strchr(pszQuantity,'.');
-          if (pch==NULL) {
-            snprintf(szExpression, sizeof(szExpression), "([pixel] = %d)", atoi(pszQuantity));
-          } else {
-            snprintf(szExpression, sizeof(szExpression), "([pixel] = %f)", atof(pszQuantity));
-          }
-
-          if (msGrowLayerClasses(psLayer) == NULL)
-            return MS_FAILURE;
-          else {
-            initClass(psLayer->class[psLayer->numclasses]);
-            psLayer->numclasses++;
-            const int nClassId = psLayer->numclasses-1;
-            if( pszUserStyleName )
-                psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
-
-            msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
-            if (pszLabel)
-              psLayer->class[nClassId]->name = msStrdup(pszLabel);
-            else
-              psLayer->class[nClassId]->name = msStrdup(pszQuantity);
-            psLayer->class[nClassId]->numstyles = 1;
-            psLayer->class[nClassId]->styles[0]->color.red =
-                  sColor.red;
-            psLayer->class[nClassId]->styles[0]->color.green =
-                  sColor.green;
-            psLayer->class[nClassId]->styles[0]->color.blue =
-                  sColor.blue;
-
-            if (psLayer->classitem &&
-                strcasecmp(psLayer->classitem, "[pixel]") != 0)
-              free(psLayer->classitem);
-            psLayer->classitem = msStrdup("[pixel]");
-
-            msLoadExpressionString(&psLayer->class[nClassId]->expression,
-                                   szExpression);
-          }
-        }
-      }
-    } else if ((psCategorize = CPLGetXMLNode(psColorMap, "Categorize"))) {
-      char** papszValues = (char **)msSmallMalloc(sizeof(char*)*nMaxValues);
-      char** papszThresholds = (char **)msSmallMalloc(sizeof(char*)*nMaxThreshold);
-      psNode =  CPLGetXMLNode(psCategorize, "Value");
-      while (psNode && psNode->pszValue &&
-             psNode->psChild && psNode->psChild->pszValue)
-
-      {
-        if (strcasecmp(psNode->pszValue, "Value") == 0) {
-          papszValues[nValues] =  psNode->psChild->pszValue;
-          nValues++;
-          if (nValues == nMaxValues) {
-            nMaxValues +=100;
-            papszValues = (char **)msSmallRealloc(papszValues, sizeof(char*)*nMaxValues);
-          }
-        } else if (strcasecmp(psNode->pszValue, "Threshold") == 0) {
-          papszThresholds[nThresholds] =  psNode->psChild->pszValue;
-          nThresholds++;
-          if (nValues == nMaxThreshold) {
-            nMaxThreshold += 100;
-            papszThresholds = (char **)msSmallRealloc(papszThresholds, sizeof(char*)*nMaxThreshold);
-          }
-        }
-        psNode = psNode->psNext;
-      }
-
-      if (nThresholds > 0 && nValues == nThresholds+1) {
-        /*free existing classes*/
-        for(i=0; i<psLayer->numclasses; i++) {
-          if (psLayer->class[i] != NULL) {
-            psLayer->class[i]->layer=NULL;
-            if ( freeClass(psLayer->class[i]) == MS_SUCCESS ) {
-              msFree(psLayer->class[i]);
-              psLayer->class[i]=NULL;
-            }
-          }
-        }
-        psLayer->numclasses=0;
-        for (i=0; i<nValues; i++) {
-          pszTmp = (papszValues[i]);
-          if (pszTmp && strlen(pszTmp) == 7 && pszTmp[0] == '#') {
-            sColor.red = msHexToInt(pszTmp+1);
-            sColor.green= msHexToInt(pszTmp+3);
-            sColor.blue = msHexToInt(pszTmp+5);
-            if (i == 0) {
-              if (strchr(papszThresholds[i],'.'))
-                snprintf(szExpression, sizeof(szExpression), "([pixel] < %f)", atof(papszThresholds[i]));
-              else
-                snprintf(szExpression, sizeof(szExpression), "([pixel] < %d)", atoi(papszThresholds[i]));
-
-            } else if (i < nValues-1) {
-              if (strchr(papszThresholds[i],'.'))
-                snprintf(szExpression,  sizeof(szExpression),
-                         "([pixel] >= %f AND [pixel] < %f)",
-                         atof(papszThresholds[i-1]),
-                         atof(papszThresholds[i]));
-              else
-                snprintf(szExpression, sizeof(szExpression),
-                         "([pixel] >= %d AND [pixel] < %d)",
-                         atoi(papszThresholds[i-1]),
-                         atoi(papszThresholds[i]));
-            } else {
-              if (strchr(papszThresholds[i-1],'.'))
-                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %f)", atof(papszThresholds[i-1]));
-              else
-                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %d)", atoi(papszThresholds[i-1]));
-            }
-            if (msGrowLayerClasses(psLayer)) {
-              initClass(psLayer->class[psLayer->numclasses]);
-              psLayer->numclasses++;
-              const int nClassId = psLayer->numclasses-1;
-              if( pszUserStyleName )
-                psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
-              msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
-              psLayer->class[nClassId]->numstyles = 1;
-              psLayer->class[nClassId]->styles[0]->color.red =
-                    sColor.red;
-              psLayer->class[nClassId]->styles[0]->color.green =
-                    sColor.green;
-              psLayer->class[nClassId]->styles[0]->color.blue =
-                    sColor.blue;
-              if (psLayer->classitem &&
-                  strcasecmp(psLayer->classitem, "[pixel]") != 0)
-                free(psLayer->classitem);
-              psLayer->classitem = msStrdup("[pixel]");
-              msLoadExpressionString(&psLayer->class[nClassId]->expression,
-                                     szExpression);
-            }
-
-          }
-        }
-      }
-      msFree(papszValues);
-      msFree(papszThresholds);
-
-
-    } else {
-      msSetError(MS_WMSERR, "Invalid SLD document. msSLDParseRaster", "");
-      return MS_FAILURE;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-/************************************************************************/
-/*                           msSLDParseTextParams                       */
-/*                                                                      */
-/*      Parse text parameters like font, placement and color.           */
-/************************************************************************/
-int msSLDParseTextParams(CPLXMLNode *psRoot, layerObj *psLayer,
-                         classObj *psClass)
-{
-  char szFontName[100];
-
-  CPLXMLNode *psLabel=NULL, *psFont=NULL;
-  CPLXMLNode *psCssParam = NULL;
-  char *pszName=NULL, *pszFontFamily=NULL, *pszFontStyle=NULL;
-  char *pszFontWeight=NULL;
-  CPLXMLNode *psLabelPlacement=NULL, *psPointPlacement=NULL, *psLinePlacement=NULL;
-  CPLXMLNode *psFill = NULL, *psHalo=NULL, *psHaloRadius=NULL, *psHaloFill=NULL;
-  labelObj *psLabelObj = NULL;
-  szFontName[0]='\0';
-
-  if (!psRoot || !psClass || !psLayer)
-    return MS_FAILURE;
-
-  if(psClass->numlabels == 0) {
-    if(msGrowClassLabels(psClass) == NULL) return(MS_FAILURE);
-    initLabel(psClass->labels[0]);
-    psClass->numlabels++;
-  }
-  psLabelObj = psClass->labels[0];
-
-  /*set the angle by default to auto. the angle can be
-    modified Label Placement #2806*/
-  psLabelObj->anglemode = MS_AUTO;
-
-
-  /* label  */
-  /* support literal expression  and  propertyname
-   - <TextSymbolizer><Label>MY_COLUMN</Label>
-   - <TextSymbolizer><Label><ogc:PropertyName>MY_COLUMN</ogc:PropertyName></Label>
-  Bug 1857 */
-  psLabel = CPLGetXMLNode(psRoot, "Label");
-  if (psLabel)
-  {
-    char * sep = "";
-    msStringBuffer * classtext = msStringBufferAlloc();
-    msStringBufferAppend(classtext, "(");
-    for (CPLXMLNode * psTmpNode = psLabel->psChild ; psTmpNode ; psTmpNode = psTmpNode->psNext)
-    {
-      if (psTmpNode->eType == CXT_Text && psTmpNode->pszValue)
-      {
-        msStringBufferAppend(classtext, sep);
-        msStringBufferAppend(classtext, "\"");
-        msStringBufferAppend(classtext, psTmpNode->pszValue);
-        msStringBufferAppend(classtext, "\"");
-        sep = "+";
-      }
-      else if (psTmpNode->eType == CXT_Element
-               && strcasecmp(psTmpNode->pszValue,"Literal") == 0
-               && psTmpNode->psChild)
-      {
-        msStringBufferAppend(classtext, sep);
-        msStringBufferAppend(classtext, "\"");
-        msStringBufferAppend(classtext, psTmpNode->psChild->pszValue);
-        msStringBufferAppend(classtext, "\"");
-        sep = "+";
-      }
-      else if (psTmpNode->eType == CXT_Element
-               && strcasecmp(psTmpNode->pszValue,"PropertyName") == 0
-               && psTmpNode->psChild)
-      {
-        msStringBufferAppend(classtext, sep);
-        msStringBufferAppend(classtext, "\"[");
-        msStringBufferAppend(classtext, psTmpNode->psChild->pszValue);
-        msStringBufferAppend(classtext, "]\"");
-        sep = "+";
-      }
-      else if (psTmpNode->eType == CXT_Element
-               && strcasecmp(psTmpNode->pszValue,"Function") == 0
-               && psTmpNode->psChild)
-      {
-        msStringBufferAppend(classtext, sep);
-        msStringBufferAppend(classtext, "tostring(");
-
-        labelObj tempExpressionCollector;
-        initLabel(&tempExpressionCollector);
-        msSLDParseOgcExpression(psTmpNode,&tempExpressionCollector,MS_LABEL_BINDING_SIZE,MS_OBJ_LABEL);
-        msStringBufferAppend(classtext,tempExpressionCollector.exprBindings[MS_LABEL_BINDING_SIZE].string);
-        freeLabel(&tempExpressionCollector);
-
-        msStringBufferAppend(classtext, ",\"%g\")");
-        sep = "+";
-      }
-    }
-    msStringBufferAppend(classtext, ")");
-    const char * expressionstring = msStringBufferGetString(classtext);
-    if (strlen(expressionstring) > 2)
-    {
-      msLoadExpressionString(&psClass->text, (char*)expressionstring);
-    }
-    msStringBufferFree(classtext);
-
-    {
-      /* font */
-      psFont = CPLGetXMLNode(psRoot, "Font");
-      if (psFont) {
-        psCssParam =  CPLGetXMLNode(psFont, "CssParameter");
-        /*sld 1.1 used SvgParameter*/
-        if (psCssParam == NULL)
-          psCssParam =  CPLGetXMLNode(psFont, "SvgParameter");
-
-        while (psCssParam && psCssParam->pszValue &&
-               (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
-                strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-          pszName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-          if (pszName) {
-            if (strcasecmp(pszName, "font-family") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext &&
-                  psCssParam->psChild->psNext->pszValue)
-                pszFontFamily = psCssParam->psChild->psNext->pszValue;
-            }
-            /* normal, italic, oblique */
-            else if (strcasecmp(pszName, "font-style") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext &&
-                  psCssParam->psChild->psNext->pszValue)
-                pszFontStyle = psCssParam->psChild->psNext->pszValue;
-            }
-            /* normal or bold */
-            else if (strcasecmp(pszName, "font-weight") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext &&
-                  psCssParam->psChild->psNext->pszValue)
-                pszFontWeight = psCssParam->psChild->psNext->pszValue;
-            }
-            /* default is 10 pix */
-            else if (strcasecmp(pszName, "font-size") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                    psLabelObj, MS_LABEL_BINDING_SIZE, MS_OBJ_LABEL);
-              }
-            }
-          }
-          psCssParam = psCssParam->psNext;
-        }
-      }
-
-      /* -------------------------------------------------------------------- */
-      /*      parse the label placement.                                      */
-      /* -------------------------------------------------------------------- */
-      psLabelPlacement = CPLGetXMLNode(psRoot, "LabelPlacement");
-      if (psLabelPlacement) {
-        psPointPlacement = CPLGetXMLNode(psLabelPlacement,
-                                         "PointPlacement");
-        psLinePlacement = CPLGetXMLNode(psLabelPlacement,
-                                        "LinePlacement");
-        if (psPointPlacement)
-          ParseTextPointPlacement(psPointPlacement, psClass);
-        if (psLinePlacement)
-          ParseTextLinePlacement(psLinePlacement, psClass);
-      }
-
-      /* -------------------------------------------------------------------- */
-      /*      build the font name using the font font-family, font-style      */
-      /*      and font-weight. The name building uses a - between these       */
-      /*      parameters and the resulting name is compared to the list of    */
-      /*      available fonts. If the name exists, it will be used else we    */
-      /*      go to the bitmap fonts.                                         */
-      /* -------------------------------------------------------------------- */
-      if (pszFontFamily) {
-        snprintf(szFontName, sizeof(szFontName), "%s", pszFontFamily);
-        if (pszFontWeight && strcasecmp(pszFontWeight, "normal") != 0) {
-          strlcat(szFontName, "-", sizeof(szFontName));
-          strlcat(szFontName, pszFontWeight, sizeof(szFontName));
-        }
-        if (pszFontStyle && strcasecmp(pszFontStyle, "normal") != 0) {
-          strlcat(szFontName, "-", sizeof(szFontName));
-          strlcat(szFontName, pszFontStyle, sizeof(szFontName));
-        }
-
-        if ((msLookupHashTable(&(psLayer->map->fontset.fonts), szFontName) !=NULL)) {
-          psLabelObj->font = msStrdup(szFontName);
-        }
-      }
-
-      /* -------------------------------------------------------------------- */
-      /*      parse the halo parameter.                                       */
-      /* -------------------------------------------------------------------- */
-      psHalo = CPLGetXMLNode(psRoot, "Halo");
-      if (psHalo) {
-        psHaloRadius =  CPLGetXMLNode(psHalo, "Radius");
-        if (psHaloRadius && psHaloRadius->psChild && psHaloRadius->psChild->pszValue)
-          psLabelObj->outlinewidth = atoi(psHaloRadius->psChild->pszValue);
-
-        psHaloFill =  CPLGetXMLNode(psHalo, "Fill");
-        if (psHaloFill) {
-          psCssParam =  CPLGetXMLNode(psHaloFill, "CssParameter");
-          /*sld 1.1 used SvgParameter*/
-          if (psCssParam == NULL)
-            psCssParam =  CPLGetXMLNode(psHaloFill, "SvgParameter");
-
-          while (psCssParam && psCssParam->pszValue &&
-                 (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
-                  strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-            pszName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-            if (pszName) {
-              if (strcasecmp(pszName, "fill") == 0) {
-                if(psCssParam->psChild && psCssParam->psChild->psNext)
-                {
-                  msSLDParseOgcExpression(psCssParam->psChild->psNext, psLabelObj,
-                      MS_LABEL_BINDING_OUTLINECOLOR, MS_OBJ_LABEL);
-                }
-              }
-            }
-            psCssParam = psCssParam->psNext;
-          }
-
-        }
-
-      }
-      /* -------------------------------------------------------------------- */
-      /*      Parse the color                                                 */
-      /* -------------------------------------------------------------------- */
-      psFill = CPLGetXMLNode(psRoot, "Fill");
-      if (psFill) {
-        psCssParam =  CPLGetXMLNode(psFill, "CssParameter");
-        /*sld 1.1 used SvgParameter*/
-        if (psCssParam == NULL)
-          psCssParam =  CPLGetXMLNode(psFill, "SvgParameter");
-
-        while (psCssParam && psCssParam->pszValue &&
-               (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
-                strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-          pszName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-          if (pszName) {
-            if (strcasecmp(pszName, "fill") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                msSLDParseOgcExpression(psCssParam->psChild->psNext, psLabelObj,
-                    MS_LABEL_BINDING_COLOR, MS_OBJ_LABEL);
-              }
-            }
-          }
-          psCssParam = psCssParam->psNext;
-        }
-      }
-
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                         ParseTextPointPlacement                      */
-/*                                                                      */
-/*      point placement node for the text symbolizer.                  */
-/************************************************************************/
-int ParseTextPointPlacement(CPLXMLNode *psRoot, classObj *psClass)
-{
-  CPLXMLNode *psAnchor, *psAnchorX, *psAnchorY;
-  CPLXMLNode *psDisplacement, *psDisplacementX, *psDisplacementY;
-  CPLXMLNode *psRotation=NULL;
-  labelObj *psLabelObj = NULL;
-
-  if (!psRoot || !psClass)
-    return MS_FAILURE;
-  if(psClass->numlabels == 0) {
-    if(msGrowClassLabels(psClass) == NULL) return(MS_FAILURE);
-    initLabel(psClass->labels[0]);
-    psClass->numlabels++;
-  }
-  psLabelObj = psClass->labels[0];
-
-  /* init the label with the default position */
-  psLabelObj->position = MS_CL;
-
-  /* -------------------------------------------------------------------- */
-  /*      parse anchor point. see function msSLDParseTextSymbolizer       */
-  /*      for documentation.                                              */
-  /* -------------------------------------------------------------------- */
-  psAnchor = CPLGetXMLNode(psRoot, "AnchorPoint");
-  if (psAnchor) {
-    psAnchorX = CPLGetXMLNode(psAnchor, "AnchorPointX");
-    psAnchorY = CPLGetXMLNode(psAnchor, "AnchorPointY");
-    /* psCssParam->psChild->psNext->pszValue) */
-    if (psAnchorX &&
-        psAnchorX->psChild &&
-        psAnchorX->psChild->pszValue &&
-        psAnchorY &&
-        psAnchorY->psChild &&
-        psAnchorY->psChild->pszValue) {
-      const double dfAnchorX = atof(psAnchorX->psChild->pszValue);
-      const double dfAnchorY = atof(psAnchorY->psChild->pszValue);
-
-      if ((dfAnchorX == 0 || dfAnchorX == 0.5 || dfAnchorX == 1) &&
-          (dfAnchorY == 0 || dfAnchorY == 0.5 || dfAnchorY == 1)) {
-        if (dfAnchorX == 0 && dfAnchorY == 0)
-          psLabelObj->position = MS_LL;
-        if (dfAnchorX == 0 && dfAnchorY == 0.5)
-          psLabelObj->position = MS_CL;
-        if (dfAnchorX == 0 && dfAnchorY == 1)
-          psLabelObj->position = MS_UL;
-
-        if (dfAnchorX == 0.5 && dfAnchorY == 0)
-          psLabelObj->position = MS_LC;
-        if (dfAnchorX == 0.5 && dfAnchorY == 0.5)
-          psLabelObj->position = MS_CC;
-        if (dfAnchorX == 0.5 && dfAnchorY == 1)
-          psLabelObj->position = MS_UC;
-
-        if (dfAnchorX == 1 && dfAnchorY == 0)
-          psLabelObj->position = MS_LR;
-        if (dfAnchorX == 1 && dfAnchorY == 0.5)
-          psLabelObj->position = MS_CR;
-        if (dfAnchorX == 1 && dfAnchorY == 1)
-          psLabelObj->position = MS_UR;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse displacement                                              */
-  /* -------------------------------------------------------------------- */
-  psDisplacement = CPLGetXMLNode(psRoot, "Displacement");
-  if (psDisplacement) {
-    psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
-    psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
-    /* psCssParam->psChild->psNext->pszValue) */
-    if (psDisplacementX &&
-        psDisplacementX->psChild &&
-        psDisplacementX->psChild->pszValue &&
-        psDisplacementY &&
-        psDisplacementY->psChild &&
-        psDisplacementY->psChild->pszValue) {
-      psLabelObj->offsetx = atoi(psDisplacementX->psChild->pszValue);
-      psLabelObj->offsety = atoi(psDisplacementY->psChild->pszValue);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      parse rotation.                                                 */
-  /* -------------------------------------------------------------------- */
-  psRotation = CPLGetXMLNode(psRoot, "Rotation");
-  if (psRotation && psRotation->psChild)
-  {
-    msSLDParseOgcExpression(psRotation->psChild, psLabelObj,
-        MS_LABEL_BINDING_ANGLE, MS_OBJ_LABEL);
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                          ParseTextLinePlacement                      */
-/*                                                                      */
-/*      Lineplacement node fro the text symbolizer.                     */
-/************************************************************************/
-int ParseTextLinePlacement(CPLXMLNode *psRoot, classObj *psClass)
-{
-  CPLXMLNode *psOffset = NULL, *psAligned=NULL;
-  labelObj *psLabelObj = NULL;
-
-  if (!psRoot || !psClass)
-    return MS_FAILURE;
-
-  if(psClass->numlabels == 0) {
-    if(msGrowClassLabels(psClass) == NULL) return(MS_FAILURE);
-    initLabel(psClass->labels[0]);
-    psClass->numlabels++;
-  }
-  psLabelObj = psClass->labels[0];
-
-  /*if there is a line placement, we will assume that the
-    best setting for mapserver would be for the text to follow
-    the line #2806*/
-  psLabelObj->anglemode = MS_FOLLOW;
-
-  /*sld 1.1.0 has a parameter IsAligned. default value is true*/
-  psAligned = CPLGetXMLNode(psRoot, "IsAligned");
-  if (psAligned && psAligned->psChild && psAligned->psChild->pszValue &&
-      strcasecmp(psAligned->psChild->pszValue, "false") == 0) {
-    psLabelObj->anglemode = MS_NONE;
-  }
-  psOffset = CPLGetXMLNode(psRoot, "PerpendicularOffset");
-  if (psOffset && psOffset->psChild && psOffset->psChild->pszValue) {
-    psLabelObj->offsetx = atoi(psOffset->psChild->pszValue);
-    psLabelObj->offsety = MS_LABEL_PERPENDICULAR_OFFSET;
-
-    /*if there is a PerpendicularOffset, we will assume that the
-      best setting for mapserver would be to use angle=0 and the
-      the offset #2806*/
-    /* since sld 1.1.0 introduces the IsAligned parameter, only
-       set the angles if the parameter is not set*/
-    if (!psAligned) {
-      psLabelObj->anglemode = MS_NONE;
-      psLabelObj->offsety = psLabelObj->offsetx;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*           void msSLDSetColorObject(char *psHexColor, colorObj        */
-/*      *psColor)                                                       */
-/*                                                                      */
-/*      Utility function to extract rgb values from an hexadecimal     */
-/*      color string (format is : #aaff08) and set it in the color      */
-/*      object.                                                         */
-/************************************************************************/
-int msSLDSetColorObject(char *psHexColor, colorObj *psColor)
-{
-  if (psHexColor && psColor && strlen(psHexColor)== 7 &&
-      psHexColor[0] == '#') {
-
-    psColor->red = msHexToInt(psHexColor+1);
-    psColor->green = msHexToInt(psHexColor+3);
-    psColor->blue= msHexToInt(psHexColor+5);
-  }
-
-  return MS_SUCCESS;
-}
-
-/* -------------------------------------------------------------------- */
-/*      client sld support functions                                    */
-/* -------------------------------------------------------------------- */
-
-/************************************************************************/
-/*                msSLDGenerateSLD(mapObj *map, int iLayer)             */
-/*                                                                      */
-/*      Return an SLD document for all layers that are on or            */
-/*      default. The second argument should be set to -1 to generate    */
-/*      on all layers. Or set to the layer index to generate an SLD     */
-/*      for a specific layer.                                           */
-/*                                                                      */
-/*      The caller should free the returned string.                     */
-/************************************************************************/
-char *msSLDGenerateSLD(mapObj *map, int iLayer, const char *pszVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-
-  char szTmp[500];
-  int i = 0;
-  char *pszTmp = NULL;
-  char *pszSLD = NULL;
-  char *schemalocation = NULL;
-  int sld_version = OWS_VERSION_NOTSET;
-
-  sld_version = msOWSParseVersionString(pszVersion);
-
-  if (sld_version == OWS_VERSION_NOTSET ||
-      (sld_version!= OWS_1_0_0 && sld_version!= OWS_1_1_0))
-    sld_version = OWS_1_0_0;
-
-  if (map) {
-    schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    if (sld_version ==  OWS_1_0_0)
-      snprintf(szTmp, sizeof(szTmp), "<StyledLayerDescriptor version=\"1.0.0\" xmlns=\"http://www.opengis.net/sld\" xmlns:gml=\"http://www.opengis.net/gml\" xmlns:ogc=\"http://www.opengis.net/ogc\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.opengis.net/sld %s/sld/1.0.0/StyledLayerDescriptor.xsd\">\n",schemalocation );
-    else
-      snprintf(szTmp, sizeof(szTmp), "<StyledLayerDescriptor version=\"1.1.0\" xsi:schemaLocation=\"http://www.opengis.net/sld %s/sld/1.1.0/StyledLayerDescriptor.xsd\" xmlns=\"http://www.opengis.net/sld\" xmlns:ogc=\"http://www.opengis.net/ogc\" xmlns:se=\"http://www.opengis.net/se\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">\n", schemalocation);
-
-    free(schemalocation);
-
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-    if (iLayer < 0 || iLayer > map->numlayers -1) {
-      for (i=0; i<map->numlayers; i++) {
-        pszTmp = msSLDGenerateSLDLayer(GET_LAYER(map, i), sld_version);
-        if (pszTmp) {
-          pszSLD= msStringConcatenate(pszSLD, pszTmp);
-          free(pszTmp);
-        }
-      }
-    } else {
-      pszTmp = msSLDGenerateSLDLayer(GET_LAYER(map, iLayer), sld_version);
-      if (pszTmp) {
-        pszSLD = msStringConcatenate(pszSLD, pszTmp);
-        free(pszTmp);
-      }
-    }
-    snprintf(szTmp, sizeof(szTmp), "%s", "</StyledLayerDescriptor>\n");
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-  }
-
-  return pszSLD;
-
-#else
-  msSetError(MS_MISCERR, "OWS support is not available.",
-             "msSLDGenerateSLDLayer()");
-  return NULL;
-
-#endif
-}
-
-
-
-/************************************************************************/
-/*                            msSLDGetGraphicSLD                        */
-/*                                                                      */
-/*      Get an SLD for a style containing a symbol (Mark or external).  */
-/************************************************************************/
-char *msSLDGetGraphicSLD(styleObj *psStyle, layerObj *psLayer,
-                         int bNeedMarkSybol, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-
-  msStringBuffer * sldString = msStringBufferAlloc();
-  int nSymbol = -1;
-  symbolObj *psSymbol = NULL;
-  char szTmp[512];
-  char szFormat[4];
-  int i = 0, nLength = 0;
-  int bColorAvailable=0;
-  int bGenerateDefaultSymbol = 0;
-  char *pszSymbolName= NULL;
-  char sNameSpace[10];
-  char sCssParam[30];
-
-  sCssParam[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sCssParam, "se:SvgParameter");
-  else
-    strcpy(sCssParam, "CssParameter");
-
-  sNameSpace[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sNameSpace, "se:");
-
-  if (psStyle && psLayer && psLayer->map) {
-    nSymbol = -1;
-    if (psStyle->symbol > 0)
-      nSymbol = psStyle->symbol;
-    else if (psStyle->symbolname)
-      nSymbol = msGetSymbolIndex(&psLayer->map->symbolset,
-                                 psStyle->symbolname, MS_FALSE);
-
-    bGenerateDefaultSymbol = 0;
-
-    if (bNeedMarkSybol &&
-        (nSymbol <=0 || nSymbol >=  psLayer->map->symbolset.numsymbols))
-      bGenerateDefaultSymbol = 1;
-
-    if (nSymbol > 0 && nSymbol < psLayer->map->symbolset.numsymbols) {
-      psSymbol =  psLayer->map->symbolset.symbol[nSymbol];
-      if (psSymbol->type == MS_SYMBOL_VECTOR ||
-          psSymbol->type == MS_SYMBOL_ELLIPSE) {
-        /* Mark symbol */
-        if (psSymbol->name)
-
-        {
-          if (strcasecmp(psSymbol->name, "square") == 0 ||
-              strcasecmp(psSymbol->name, "circle") == 0 ||
-              strcasecmp(psSymbol->name, "triangle") == 0 ||
-              strcasecmp(psSymbol->name, "star") == 0 ||
-              strcasecmp(psSymbol->name, "cross") == 0 ||
-              strcasecmp(psSymbol->name, "x") == 0)
-            pszSymbolName = msStrdup(psSymbol->name);
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_square", 22) == 0)
-            pszSymbolName = msStrdup("square");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_triangle", 24) == 0)
-            pszSymbolName = msStrdup("triangle");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_circle", 22) == 0)
-            pszSymbolName = msStrdup("circle");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_star", 20) == 0)
-            pszSymbolName = msStrdup("star");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_cross", 21) == 0)
-            pszSymbolName = msStrdup("cross");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_x", 17) == 0)
-            pszSymbolName = msStrdup("X");
-
-
-
-          if (pszSymbolName) {
-            colorObj sTmpFillColor = { 128, 128, 128, 255 };
-            colorObj sTmpStrokeColor = { 0, 0, 0, 255 };
-            int hasFillColor = 0;
-            int hasStrokeColor = 0;
-
-            snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            snprintf(szTmp, sizeof(szTmp), "<%sMark>\n", sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            snprintf(szTmp, sizeof(szTmp), "<%sWellKnownName>%s</%sWellKnownName>\n",
-                sNameSpace, pszSymbolName, sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            if (psStyle->color.red != -1 &&
-                psStyle->color.green != -1 &&
-                psStyle->color.blue != -1)
-            {
-              sTmpFillColor.red = psStyle->color.red;
-              sTmpFillColor.green = psStyle->color.green;
-              sTmpFillColor.blue = psStyle->color.blue;
-              sTmpFillColor.alpha = psStyle->color.alpha;
-              hasFillColor = 1;
-            }
-            if (psStyle->outlinecolor.red != -1 &&
-                psStyle->outlinecolor.green != -1 &&
-                psStyle->outlinecolor.blue != -1)
-            {
-              sTmpStrokeColor.red = psStyle->outlinecolor.red;
-              sTmpStrokeColor.green = psStyle->outlinecolor.green;
-              sTmpStrokeColor.blue = psStyle->outlinecolor.blue;
-              sTmpStrokeColor.alpha = psStyle->outlinecolor.alpha;
-              hasStrokeColor = 1;
-              // Make defaults implicit
-              if (sTmpStrokeColor.red == 0 &&
-                  sTmpStrokeColor.green == 0 &&
-                  sTmpStrokeColor.blue == 0 &&
-                  sTmpStrokeColor.alpha == 255 &&
-                  psStyle->width == 1)
-              {
-                hasStrokeColor = 0;
-              }
-            }
-            if (!hasFillColor && !hasStrokeColor)
-            {
-              sTmpFillColor.red = 128;
-              sTmpFillColor.green = 128;
-              sTmpFillColor.blue = 128;
-              sTmpFillColor.alpha = 255;
-              hasFillColor = 1;
-            }
-
-            if (hasFillColor) {
-              snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
-                  sCssParam,
-                  sTmpFillColor.red,
-                  sTmpFillColor.green,
-                  sTmpFillColor.blue,
-                  sCssParam);
-              msStringBufferAppend(sldString, szTmp);
-              if (sTmpFillColor.alpha != 255 && sTmpFillColor.alpha != -1)
-              {
-                snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill-opacity\">%.2f</%s>\n",
-                    sCssParam,
-                    (float)sTmpFillColor.alpha/255.0,
-                    sCssParam);
-                msStringBufferAppend(sldString, szTmp);
-              }
-              snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-            }
-            if (hasStrokeColor) {
-              snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke\">#%02x%02x%02x</%s>\n",
-                  sCssParam,
-                  sTmpStrokeColor.red,
-                  sTmpStrokeColor.green,
-                  sTmpStrokeColor.blue,
-                  sCssParam);
-              msStringBufferAppend(sldString, szTmp);
-              if (psStyle->width > 0)
-              {
-                snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-width\">%g</%s>\n",
-                    sCssParam,
-                    psStyle->width,
-                    sCssParam);
-                msStringBufferAppend(sldString, szTmp);
-              }
-              if (sTmpStrokeColor.alpha != 255 && sTmpStrokeColor.alpha != -1)
-              {
-                snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-opacity\">%.2f</%s>\n",
-                    sCssParam,
-                    (float)sTmpStrokeColor.alpha/255.0,
-                    sCssParam);
-                msStringBufferAppend(sldString, szTmp);
-              }
-              snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-            }
-
-            snprintf(szTmp, sizeof(szTmp), "</%sMark>\n", sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            if (psStyle->size > 0) {
-              snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n",
-                  sNameSpace, psStyle->size, sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-            }
-
-            if (fmod(psStyle->angle, 360))
-            {
-              snprintf(szTmp, sizeof(szTmp), "<%sRotation>%g</%sRotation>\n",
-                  sNameSpace, psStyle->angle, sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-            }
-         // Style opacity is already reported to alpha channel of color and outlinecolor
-         // if (psStyle->opacity < 100)
-         // {
-         //   snprintf(szTmp, sizeof(szTmp), "<%sOpacity>%g</%sOpacity>\n",
-         //       sNameSpace, psStyle->opacity/100.0, sNameSpace);
-         //   pszSLD = msStringConcatenate(pszSLD, szTmp);
-         // }
-
-            if (psStyle->offsetx != 0 || psStyle->offsety != 0)
-            {
-              snprintf(szTmp, sizeof(szTmp), "<%sDisplacement>\n", sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%sDisplacementX>%g</%sDisplacementX>\n",
-                  sNameSpace, psStyle->offsetx, sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%sDisplacementY>%g</%sDisplacementY>\n",
-                  sNameSpace, psStyle->offsety, sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "</%sDisplacement>\n", sNameSpace);
-              msStringBufferAppend(sldString, szTmp);
-            }
-
-            snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            if (pszSymbolName)
-              free(pszSymbolName);
-          }
-        } else
-          bGenerateDefaultSymbol =1;
-      } else if (psSymbol->type == MS_SYMBOL_PIXMAP || psSymbol->type == MS_SYMBOL_SVG) {
-        if (psSymbol->name) {
-          const char *pszURL = msLookupHashTable(&(psLayer->metadata), "WMS_SLD_SYMBOL_URL");
-          if (!pszURL)
-            pszURL = msLookupHashTable(&(psLayer->map->web.metadata), "WMS_SLD_SYMBOL_URL");
-
-          if (pszURL) {
-            snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-
-
-            snprintf(szTmp, sizeof(szTmp), "<%sExternalGraphic>\n", sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            snprintf(szTmp, sizeof(szTmp), "<%sOnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:type=\"simple\" xlink:href=\"%s%s\"/>\n", sNameSpace,
-                     pszURL,psSymbol->imagepath);
-            msStringBufferAppend(sldString, szTmp);
-            /* TODO : extract format from symbol */
-
-            szFormat[0] = '\0';
-            nLength = strlen(psSymbol->imagepath);
-            if (nLength > 3) {
-              for (i=0; i<=2; i++)
-                szFormat[2-i] = psSymbol->imagepath[nLength-1-i];
-              szFormat[3] = '\0';
-            }
-            if (strlen(szFormat) > 0 &&
-                ((strcasecmp (szFormat, "GIF") == 0) ||
-                 (strcasecmp (szFormat, "PNG") == 0))) {
-              if (strcasecmp (szFormat, "GIF") == 0)
-                snprintf(szTmp, sizeof(szTmp), "<%sFormat>image/gif</%sFormat>\n",
-                         sNameSpace, sNameSpace);
-              else
-                snprintf(szTmp, sizeof(szTmp), "<%sFormat>image/png</%sFormat>\n",
-                         sNameSpace, sNameSpace);
-            } else
-              snprintf(szTmp, sizeof(szTmp), "<%sFormat>%s</%sFormat>\n", sNameSpace,
-                            (psSymbol->type ==MS_SYMBOL_SVG)?"image/svg+xml":"image/gif",sNameSpace);
-
-            msStringBufferAppend(sldString, szTmp);
-
-            snprintf(szTmp, sizeof(szTmp), "</%sExternalGraphic>\n",  sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            if (psStyle->size > 0)
-              snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n", sNameSpace, psStyle->size,
-                       sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-            snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
-            msStringBufferAppend(sldString, szTmp);
-
-          }
-        }
-
-      }
-    }
-    if (bGenerateDefaultSymbol) { /* generate a default square symbol */
-      snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
-      msStringBufferAppend(sldString, szTmp);
-
-
-
-      snprintf(szTmp, sizeof(szTmp), "<%sMark>\n", sNameSpace);
-      msStringBufferAppend(sldString, szTmp);
-
-      snprintf(szTmp, sizeof(szTmp), "<%sWellKnownName>%s</%sWellKnownName>\n",
-               sNameSpace, "square", sNameSpace);
-      msStringBufferAppend(sldString, szTmp);
-
-      bColorAvailable = 0;
-      if (psStyle->color.red != -1 &&
-          psStyle->color.green != -1 &&
-          psStyle->color.blue != -1) {
-        snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
-        msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
-                 sCssParam,
-                 psStyle->color.red,
-                 psStyle->color.green,
-                 psStyle->color.blue,
-                 sCssParam);
-        msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
-        msStringBufferAppend(sldString, szTmp);
-        bColorAvailable = 1;
-      }
-      if (psStyle->outlinecolor.red != -1 &&
-          psStyle->outlinecolor.green != -1 &&
-          psStyle->outlinecolor.blue != -1) {
-        snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
-        msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp), "<%s name=\"Stroke\">#%02x%02x%02x</%s>\n",
-                 sCssParam,
-                 psStyle->outlinecolor.red,
-                 psStyle->outlinecolor.green,
-                 psStyle->outlinecolor.blue,
-                 sCssParam);
-        msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
-        msStringBufferAppend(sldString, szTmp);
-        bColorAvailable = 1;
-      }
-      if (!bColorAvailable) {
-        /* default color */
-        snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
-        msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp),
-                 "<%s name=\"fill\">%s</%s>\n",
-                 sCssParam, "#808080", sCssParam);
-        msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
-        msStringBufferAppend(sldString, szTmp);
-      }
-
-      snprintf(szTmp, sizeof(szTmp), "</%sMark>\n", sNameSpace);
-      msStringBufferAppend(sldString, szTmp);
-
-      if (psStyle->size > 0)
-        snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n", sNameSpace,
-                 psStyle->size, sNameSpace);
-      else
-        snprintf(szTmp,  sizeof(szTmp), "<%sSize>%d</%sSize>\n", sNameSpace,1,sNameSpace);
-      msStringBufferAppend(sldString, szTmp);
-
-      snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
-      msStringBufferAppend(sldString, szTmp);
-
-
-    }
-  }
-
-  return msStringBufferReleaseStringAndFree(sldString);
-
-#else
-  return NULL;
-
-#endif
-
-}
-
-
-
-
-/************************************************************************/
-/*                           msSLDGenerateLineSLD                       */
-/*                                                                      */
-/*      Generate SLD for a Line layer.                                  */
-/************************************************************************/
-char *msSLDGenerateLineSLD(styleObj *psStyle, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-
-  char *pszSLD = NULL;
-  char szTmp[100];
-  char szHexColor[7];
-  int nSymbol = -1;
-  int i = 0;
-  double dfSize = 1.0;
-  char *pszDashArray = NULL;
-  char *pszGraphicSLD = NULL;
-  char sCssParam[30];
-  char sNameSpace[10];
-
-  if ( msCheckParentPointer(psLayer->map,"map")==MS_FAILURE )
-    return NULL;
-
-  sCssParam[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy( sCssParam, "se:SvgParameter");
-  else
-    strcpy( sCssParam, "CssParameter");
-
-  sNameSpace[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sNameSpace, "se:");
-
-  snprintf(szTmp, sizeof(szTmp), "<%sLineSymbolizer>\n",  sNameSpace);
-
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n",  sNameSpace);
-
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
-  if (pszGraphicSLD) {
-    snprintf(szTmp, sizeof(szTmp), "<%sGraphicStroke>\n",  sNameSpace);
-
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
-
-    if(nVersion >= OWS_1_1_0) {
-      if(psStyle->gap > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sGap>%.2f</%sGap>\n",  sNameSpace,psStyle->gap,sNameSpace);
-      }
-      if(psStyle->initialgap > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sInitialGap>%.2f</%sInitialGap>\n",  sNameSpace,psStyle->initialgap,sNameSpace);
-      }
-    }
-
-    snprintf(szTmp, sizeof(szTmp), "</%sGraphicStroke>\n",  sNameSpace);
-
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    free(pszGraphicSLD);
-    pszGraphicSLD = NULL;
-  }
-
-  if (psStyle->color.red != -1 &&
-      psStyle->color.green != -1 &&
-      psStyle->color.blue != -1)
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->color.red,
-            psStyle->color.green,psStyle->color.blue);
-  else
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->outlinecolor.red,
-            psStyle->outlinecolor.green,psStyle->outlinecolor.blue);
-
-  snprintf(szTmp,  sizeof(szTmp),
-           "<%s name=\"stroke\">#%s</%s>\n",
-           sCssParam, szHexColor, sCssParam);
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  if(psStyle->color.alpha != 255 && psStyle->color.alpha!=-1) {
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke-opacity\">%.2f</%s>\n",
-             sCssParam, (float)psStyle->color.alpha/255.0, sCssParam);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-  }
-
-
-  nSymbol = -1;
-
-  if (psStyle->symbol >= 0)
-    nSymbol = psStyle->symbol;
-  else if (psStyle->symbolname)
-    nSymbol = msGetSymbolIndex(&psLayer->map->symbolset,
-                               psStyle->symbolname, MS_FALSE);
-
-  if (nSymbol <0)
-    dfSize = 1.0;
-  else {
-    if (psStyle->size > 0)
-      dfSize = psStyle->size;
-    else if (psStyle->width > 0)
-      dfSize = psStyle->width;
-    else
-      dfSize = 1;
-  }
-
-  snprintf(szTmp, sizeof(szTmp),
-           "<%s name=\"stroke-width\">%.2f</%s>\n",
-           sCssParam, dfSize, sCssParam);
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  /* -------------------------------------------------------------------- */
-  /*      dash array                                                      */
-  /* -------------------------------------------------------------------- */
-
-
-  if (psStyle->patternlength > 0) {
-    for (i=0; i<psStyle->patternlength; i++) {
-      snprintf(szTmp, sizeof(szTmp), "%.2f ", psStyle->pattern[i]);
-      pszDashArray = msStringConcatenate(pszDashArray, szTmp);
-    }
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke-dasharray\">%s</%s>\n",
-             sCssParam, pszDashArray, sCssParam);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-    msFree(pszDashArray);
-  }
-
-  snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n",  sNameSpace);
-
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  snprintf(szTmp, sizeof(szTmp), "</%sLineSymbolizer>\n",  sNameSpace);
-
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  return pszSLD;
-
-#else
-  return NULL;
-#endif
-}
-
-
-/************************************************************************/
-/*                         msSLDGeneratePolygonSLD                      */
-/*                                                                      */
-/*       Generate SLD for a Polygon layer.                              */
-/************************************************************************/
-char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-
-  char szTmp[100];
-  char *pszSLD = NULL;
-  char szHexColor[7];
-  char *pszGraphicSLD = NULL;
-  double dfSize;
-  char sCssParam[30];
-  char sNameSpace[10];
-
-  sCssParam[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sCssParam, "se:SvgParameter");
-  else
-    strcpy(sCssParam, "CssParameter");
-
-  sNameSpace[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sNameSpace, "se:");
-
-  snprintf(szTmp, sizeof(szTmp), "<%sPolygonSymbolizer>\n",  sNameSpace);
-
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-  /* fill */
-  if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
-      psStyle->color.blue != -1) {
-
-    snprintf(szTmp, sizeof(szTmp), "<%sFill>\n",  sNameSpace);
-
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
-    if (pszGraphicSLD) {
-      snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n",  sNameSpace);
-
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-      pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
-
-      snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n",  sNameSpace);
-
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-      free(pszGraphicSLD);
-      pszGraphicSLD = NULL;
-    }
-
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->color.red,
-            psStyle->color.green,psStyle->color.blue);
-
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"fill\">#%s</%s>\n",
-             sCssParam, szHexColor, sCssParam);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    if(psStyle->color.alpha != 255 && psStyle->color.alpha!=-1) {
-      snprintf(szTmp, sizeof(szTmp),
-               "<%s name=\"fill-opacity\">%.2f</%s>\n",
-               sCssParam, (float)psStyle->color.alpha/255, sCssParam);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-    }
-
-
-    snprintf(szTmp, sizeof(szTmp), "</%sFill>\n",  sNameSpace);
-
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-  }
-  /* stroke */
-  if (psStyle->outlinecolor.red != -1 &&
-      psStyle->outlinecolor.green != -1 &&
-      psStyle->outlinecolor.blue != -1) {
-    snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n",  sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-
-
-    /* If there is a symbol to be used for stroke, the color in the */
-    /* style should be set to -1. Else It won't apply here. */
-    if (psStyle->color.red == -1 && psStyle->color.green == -1 &&
-        psStyle->color.blue == -1) {
-      pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
-      if (pszGraphicSLD) {
-        snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n",  sNameSpace);
-        pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-        pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
-        snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n",  sNameSpace);
-        pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-        free(pszGraphicSLD);
-        pszGraphicSLD = NULL;
-      }
-    }
-
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->outlinecolor.red,
-            psStyle->outlinecolor.green,
-            psStyle->outlinecolor.blue);
-
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke\">#%s</%s>\n",
-             sCssParam, szHexColor, sCssParam);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    dfSize = 1.0;
-    if (psStyle->size > 0)
-      dfSize = psStyle->size;
-    else if (psStyle->width > 0)
-      dfSize = psStyle->width;
-
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke-width\">%.2f</%s>\n",
-             sCssParam,dfSize,sCssParam);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    if(psStyle->outlinecolor.alpha != 255 && psStyle->outlinecolor.alpha != -1)
-    {
-      snprintf(szTmp, sizeof(szTmp),
-          "<%s name=\"stroke-opacity\">%.2f</%s>\n",
-          sCssParam, psStyle->outlinecolor.alpha/255.0, sCssParam);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-    }
-
-    snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n",  sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-  }
-
-  snprintf(szTmp, sizeof(szTmp), "</%sPolygonSymbolizer>\n", sNameSpace);
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  return pszSLD;
-
-#else
-  return NULL;
-#endif
-}
-
-/************************************************************************/
-/*                          msSLDGeneratePointSLD                       */
-/*                                                                      */
-/*      Generate SLD for a Point layer.                                 */
-/************************************************************************/
-char *msSLDGeneratePointSLD(styleObj *psStyle, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-  char *pszSLD = NULL;
-  char *pszGraphicSLD = NULL;
-  char szTmp[100];
-  char sNameSpace[10];
-
-  sNameSpace[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sNameSpace, "se:");
-
-  snprintf(szTmp, sizeof(szTmp), "<%sPointSymbolizer>\n",  sNameSpace);
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 1, nVersion);
-  if (pszGraphicSLD) {
-    pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
-    free(pszGraphicSLD);
-  }
-
-  snprintf(szTmp, sizeof(szTmp), "</%sPointSymbolizer>\n",  sNameSpace);
-  pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-  return pszSLD;
-
-#else
-  return NULL;
-
-#endif
-}
-
-
-
-/************************************************************************/
-/*                           msSLDGenerateTextSLD                       */
-/*                                                                      */
-/*      Generate a TextSymboliser SLD xml based on the class's label    */
-/*      object.                                                         */
-/************************************************************************/
-char *msSLDGenerateTextSLD(classObj *psClass, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-  char *pszSLD = NULL;
-
-  char szTmp[1000];
-  char **aszFontsParts = NULL;
-  int nFontParts = 0;
-  char szHexColor[7];
-  double dfAnchorX = 0.5, dfAnchorY = 0.5;
-  int i = 0;
-  int lid;
-  char sCssParam[30];
-  char sNameSpace[10];
-  labelObj *psLabelObj = NULL;
-
-  sCssParam[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sCssParam, "se:SvgParameter");
-  else
-    strcpy(sCssParam, "CssParameter");
-
-  sNameSpace[0] = '\0';
-  if (nVersion > OWS_1_0_0)
-    strcpy(sNameSpace, "se:");
-
-
-  if (!psLayer || !psClass) return pszSLD;
-
-  for (lid=0 ; lid < psClass->numlabels ; lid++)
-  {
-    char * psLabelText;
-    expressionObj psLabelExpr;
-    parseObj p;
-
-    msInitExpression(&psLabelExpr);
-    psLabelObj = psClass->labels[lid];
-
-    if (psLabelObj->text.string)
-    {
-      psLabelExpr.string = msStrdup(psLabelObj->text.string);
-      psLabelExpr.type = psLabelObj->text.type;
-    }
-    else if (psClass->text.string)
-    {
-      psLabelExpr.string = msStrdup(psClass->text.string);
-      psLabelExpr.type = psClass->text.type;
-    }
-    else if (psLayer->labelitem)
-    {
-      psLabelExpr.string = msStrdup(psLayer->labelitem);
-      psLabelExpr.type = MS_STRING;
-    }
-    else
-    {
-      msFreeExpression(&psLabelExpr);
-      continue; // Can't find text content for this <Label>
-    }
-
-    if (psLabelExpr.type == MS_STRING)
-    {
-      // Rewrite string to an expression so that literal strings and attributes
-      // are explicitely concatenated, e.g.:
-      //   "area is: [area]" becomes ("area is: "+"[area]"+"")
-      //             ^^^^^^                     ^^^^^^^^^^^^
-      char *result;
-      result = msStrdup("\"");
-      result = msStringConcatenate(result, psLabelExpr.string);
-      result = msStringConcatenate(result, "\"");
-      msTokenizeExpression(&psLabelExpr, NULL, NULL);
-      for (tokenListNodeObjPtr t = psLabelExpr.tokens ; t ; t=t->next)
-      {
-        if (t->token == MS_TOKEN_BINDING_DOUBLE ||
-            t->token == MS_TOKEN_BINDING_INTEGER ||
-            t->token == MS_TOKEN_BINDING_STRING)
-        {
-          char * target = msSmallMalloc(strlen(t->tokenval.bindval.item) + 3);
-          char * replacement = msSmallMalloc(strlen(t->tokenval.bindval.item) + 9);
-          sprintf(target, "[%s]", t->tokenval.bindval.item);
-          sprintf(replacement, "\"+\"[%s]\"+\"", t->tokenval.bindval.item);
-          result = msReplaceSubstring(result,target,replacement);
-          msFree(target);
-          msFree(replacement);
-        }
-      }
-      msFreeExpression(&psLabelExpr);
-      psLabelExpr.string = msStrdup(result);
-      psLabelExpr.type = MS_EXPRESSION;
-      msFree(result);
-    }
-
-    // Parse label expression to generate SLD tags from MapFile syntax
-    msTokenizeExpression(&psLabelExpr, NULL, NULL);
-    p.expr = &psLabelExpr;
-    p.shape = NULL;
-    p.type = MS_PARSE_TYPE_SLD;
-    yyparse(&p);
-    psLabelText = msStrdup(p.result.strval);
-    msFree(p.result.strval);
-    msFreeExpression(&psLabelExpr);
-
-    snprintf(szTmp, sizeof(szTmp), "<%sTextSymbolizer>\n",  sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    snprintf(szTmp, sizeof(szTmp), "<%sLabel>\n%s</%sLabel>\n",
-        sNameSpace, psLabelText, sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    /* -------------------------------------------------------------------- */
-    /*      only true type fonts are exported. Font name should be          */
-    /*      something like arial-bold-italic. There are 3 parts to the      */
-    /*      name font-family, font-style (italic, oblique, normal),         */
-    /*      font-weight (bold, normal). These 3 elements are separated      */
-    /*      with -.                                                         */
-    /* -------------------------------------------------------------------- */
-    if (psLabelObj->font) {
-      aszFontsParts = msStringSplit(psLabelObj->font, '-', &nFontParts);
-      if (nFontParts > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sFont>\n",  sNameSpace);
-        pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-        /* assuming first one is font-family */
-        snprintf(szTmp, sizeof(szTmp),
-            "<%s name=\"font-family\">%s</%s>\n",
-            sCssParam, aszFontsParts[0], sCssParam);
-        pszSLD = msStringConcatenate(pszSLD, szTmp);
-        for (i=1; i<nFontParts; i++) {
-          if (strcasecmp(aszFontsParts[i], "italic") == 0 ||
-              strcasecmp(aszFontsParts[i], "oblique") == 0) {
-            snprintf(szTmp, sizeof(szTmp),
-                "<%s name=\"font-style\">%s</%s>\n",
-                sCssParam, aszFontsParts[i], sCssParam);
-            pszSLD = msStringConcatenate(pszSLD, szTmp);
-          } else if (strcasecmp(aszFontsParts[i], "bold") == 0) {
-            snprintf(szTmp, sizeof(szTmp),
-                "<%s name=\"font-weight\">%s</%s>\n",
-                sCssParam,
-                aszFontsParts[i], sCssParam);
-            pszSLD = msStringConcatenate(pszSLD, szTmp);
-          }
-        }
-        /* size */
-        if (psLabelObj->size > 0) {
-          snprintf(szTmp, sizeof(szTmp),
-              "<%s name=\"font-size\">%d</%s>\n",
-              sCssParam, psLabelObj->size, sCssParam);
-          pszSLD = msStringConcatenate(pszSLD, szTmp);
-        }
-        snprintf(szTmp, sizeof(szTmp), "</%sFont>\n",  sNameSpace);
-        pszSLD = msStringConcatenate(pszSLD, szTmp);
-      }
-      msFreeCharArray(aszFontsParts, nFontParts);
-    }
-
-
-    /* label placement */
-    snprintf(szTmp, sizeof(szTmp), "<%sLabelPlacement>\n<%sPointPlacement>\n",
-        sNameSpace, sNameSpace  );
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPoint>\n", sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    if (psLabelObj->position == MS_LL) {
-      dfAnchorX =0;
-      dfAnchorY = 0;
-    } else if (psLabelObj->position == MS_CL) {
-      dfAnchorX =0;
-      dfAnchorY = 0.5;
-    } else if (psLabelObj->position == MS_UL) {
-      dfAnchorX =0;
-      dfAnchorY = 1;
-    }
-
-    else if (psLabelObj->position == MS_LC) {
-      dfAnchorX =0.5;
-      dfAnchorY = 0;
-    } else if (psLabelObj->position == MS_CC) {
-      dfAnchorX =0.5;
-      dfAnchorY = 0.5;
-    } else if (psLabelObj->position == MS_UC) {
-      dfAnchorX =0.5;
-      dfAnchorY = 1;
-    }
-
-    else if (psLabelObj->position == MS_LR) {
-      dfAnchorX =1;
-      dfAnchorY = 0;
-    } else if (psLabelObj->position == MS_CR) {
-      dfAnchorX =1;
-      dfAnchorY = 0.5;
-    } else if (psLabelObj->position == MS_UR) {
-      dfAnchorX =1;
-      dfAnchorY = 1;
-    }
-    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPointX>%.1f</%sAnchorPointX>\n",
-        sNameSpace, dfAnchorX, sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPointY>%.1f</%sAnchorPointY>\n", sNameSpace,
-        dfAnchorY, sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    snprintf(szTmp, sizeof(szTmp), "</%sAnchorPoint>\n",  sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    /* displacement */
-    if (psLabelObj->offsetx > 0 || psLabelObj->offsety > 0) {
-      snprintf(szTmp, sizeof(szTmp), "<%sDisplacement>\n",  sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-      if (psLabelObj->offsetx > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sDisplacementX>%d</%sDisplacementX>\n",
-            sNameSpace, psLabelObj->offsetx, sNameSpace);
-        pszSLD = msStringConcatenate(pszSLD, szTmp);
-      }
-      if (psLabelObj->offsety > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sDisplacementY>%d</%sDisplacementY>\n",
-            sNameSpace, psLabelObj->offsety, sNameSpace);
-        pszSLD = msStringConcatenate(pszSLD, szTmp);
-      }
-
-      snprintf(szTmp,  sizeof(szTmp), "</%sDisplacement>\n",  sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-    }
-
-    /* rotation */
-    if (psLabelObj->angle > 0) {
-      snprintf(szTmp, sizeof(szTmp), "<%sRotation>%.2f</%sRotation>\n",
-          sNameSpace, psLabelObj->angle, sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-    }
-
-    snprintf(szTmp, sizeof(szTmp), "</%sPointPlacement>\n</%sLabelPlacement>\n",
-        sNameSpace, sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    if (psLabelObj->outlinecolor.red != -1 &&
-        psLabelObj->outlinecolor.green != -1 &&
-        psLabelObj->outlinecolor.blue != -1)
-    {
-      snprintf(szTmp, sizeof(szTmp), "<%sHalo>\n", sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-      snprintf(szTmp, sizeof(szTmp), "<%sRadius>%d</%sRadius>\n",
-          sNameSpace, psLabelObj->outlinewidth, sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-      snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-      snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
-          sCssParam,
-          psLabelObj->outlinecolor.red,
-          psLabelObj->outlinecolor.green,
-          psLabelObj->outlinecolor.blue,
-          sCssParam);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-      snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-      snprintf(szTmp, sizeof(szTmp), "</%sHalo>\n", sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-    }
-
-    /* color */
-    if (psLabelObj->color.red != -1 &&
-        psLabelObj->color.green != -1 &&
-        psLabelObj->color.blue != -1)
-    {
-      snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace );
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-      sprintf(szHexColor,"%02hhx%02hhx%02hhx",
-          (unsigned char)psLabelObj->color.red,
-          (unsigned char)psLabelObj->color.green,
-          (unsigned char)psLabelObj->color.blue);
-
-      snprintf(szTmp, sizeof(szTmp),
-          "<%s name=\"fill\">#%s</%s>\n",
-          sCssParam, szHexColor, sCssParam);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-      snprintf(szTmp, sizeof(szTmp), "</%sFill>\n",  sNameSpace);
-      pszSLD = msStringConcatenate(pszSLD, szTmp);
-    }
-
-    snprintf(szTmp, sizeof(szTmp), "</%sTextSymbolizer>\n",  sNameSpace);
-    pszSLD = msStringConcatenate(pszSLD, szTmp);
-
-    msFree(psLabelText);
-  }
-  return pszSLD;
-
-#else
-  return NULL;
-#endif
-}
-
-#if (defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR))
-
-static void msSLDAppendName(msStringBuffer* sb, const char* pszName, int nVersion)
-{
-    char* pszEncoded = msEncodeHTMLEntities(pszName);
-    msStringBufferAppend(sb, (nVersion > OWS_1_0_0) ? "<se:Name>" : "<Name>");
-    msStringBufferAppend(sb, pszEncoded);
-    msStringBufferAppend(sb, (nVersion > OWS_1_0_0) ? "</se:Name>\n" : "</Name>\n");
-    msFree(pszEncoded);
-}
-
-static void msSLDGenerateUserStyle(msStringBuffer* sb, layerObj *psLayer, int nVersion,
-                                   const char* pszTargetGroup)
-{
-    const char* pszWfsFilter;
-
-    msStringBufferAppend(sb, "<UserStyle>\n");
-
-    if( pszTargetGroup )
-    {
-        msSLDAppendName(sb, pszTargetGroup, nVersion);
-        if( psLayer->classgroup &&
-            strcmp(psLayer->classgroup, pszTargetGroup) == 0 )
-        {
-            msStringBufferAppend(sb, nVersion > OWS_1_0_0 ?
-                                        "<se:IsDefault>true</se:IsDefault>\n" :
-                                        "<IsDefault>true</IsDefault>\n");
-        }
-    }
-
-    msStringBufferAppend(sb, nVersion > OWS_1_0_0 ?
-        "<se:FeatureTypeStyle>\n" : "<FeatureTypeStyle>\n");
-
-    pszWfsFilter = msLookupHashTable(&(psLayer->metadata), "wfs_filter");
-    if (psLayer->numclasses > 0) {
-      int i;
-      for (i=0; i<psLayer->numclasses; i++) {
-        char* pszFilter;
-        double dfMinScale =-1, dfMaxScale = -1;
-
-        /* Only write down classes that match the group of interest */
-        if( psLayer->class[i]->group )
-        {
-            if( pszTargetGroup == NULL ||
-                strcmp(psLayer->class[i]->group, pszTargetGroup) != 0 )
-            {
-                continue;
-            }
-        }
-        else if( pszTargetGroup != NULL )
-        {
-            continue;
-        }
-
-        msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "<se:Rule>\n" : "<Rule>\n" );
-
-        /* if class has a name, use it as the RULE name */
-        if (psLayer->class[i]->name) {
-          msSLDAppendName(sb, psLayer->class[i]->name, nVersion);
-        }
-        /* -------------------------------------------------------------------- */
-        /*      get the Filter if there is a class expression.                  */
-        /* -------------------------------------------------------------------- */
-        pszFilter = msSLDGetFilter(psLayer->class[i] ,
-                                   pszWfsFilter);
-
-        if (pszFilter) {
-          msStringBufferAppend(sb, pszFilter);
-          free(pszFilter);
-        }
-        /* -------------------------------------------------------------------- */
-        /*      generate the min/max scale.                                     */
-        /* -------------------------------------------------------------------- */
-        dfMinScale = -1.0;
-        if (psLayer->class[i]->minscaledenom > 0)
-          dfMinScale = psLayer->class[i]->minscaledenom;
-        else if (psLayer->minscaledenom > 0)
-          dfMinScale = psLayer->minscaledenom;
-        else if (psLayer->map && psLayer->map->web.minscaledenom > 0)
-          dfMinScale = psLayer->map->web.minscaledenom;
-        if (dfMinScale > 0) {
-          char szTmp[100];
-          if (nVersion > OWS_1_0_0)
-            snprintf(szTmp, sizeof(szTmp), "<se:MinScaleDenominator>%f</se:MinScaleDenominator>\n",
-                     dfMinScale);
-          else
-            snprintf(szTmp, sizeof(szTmp), "<MinScaleDenominator>%f</MinScaleDenominator>\n",
-                     dfMinScale);
-
-          msStringBufferAppend(sb, szTmp);
-        }
-
-        dfMaxScale = -1.0;
-        if (psLayer->class[i]->maxscaledenom > 0)
-          dfMaxScale = psLayer->class[i]->maxscaledenom;
-        else if (psLayer->maxscaledenom > 0)
-          dfMaxScale = psLayer->maxscaledenom;
-        else if (psLayer->map && psLayer->map->web.maxscaledenom > 0)
-          dfMaxScale = psLayer->map->web.maxscaledenom;
-        if (dfMaxScale > 0) {
-          char szTmp[100];
-          if (nVersion > OWS_1_0_0)
-            snprintf(szTmp, sizeof(szTmp), "<se:MaxScaleDenominator>%f</se:MaxScaleDenominator>\n",
-                     dfMaxScale);
-          else
-            snprintf(szTmp, sizeof(szTmp), "<MaxScaleDenominator>%f</MaxScaleDenominator>\n",
-                     dfMaxScale);
-
-          msStringBufferAppend(sb, szTmp);
-        }
-
-
-
-        /* -------------------------------------------------------------------- */
-        /*      Line symbolizer.                                                */
-        /*                                                                      */
-        /*      Right now only generates a stroke element containing css        */
-        /*      parameters.                                                     */
-        /*      Lines using symbols TODO (specially for dash lines)             */
-        /* -------------------------------------------------------------------- */
-        if (psLayer->type == MS_LAYER_LINE) {
-          int j;
-          for (j=0; j<psLayer->class[i]->numstyles; j++) {
-            styleObj* psStyle = psLayer->class[i]->styles[j];
-            char* pszSLD = msSLDGenerateLineSLD(psStyle, psLayer, nVersion);
-            if (pszSLD) {
-              msStringBufferAppend(sb, pszSLD);
-              free(pszSLD);
-            }
-          }
-
-        } else if (psLayer->type == MS_LAYER_POLYGON) {
-          int j;
-          for (j=0; j<psLayer->class[i]->numstyles; j++) {
-            styleObj* psStyle = psLayer->class[i]->styles[j];
-            char* pszSLD = msSLDGeneratePolygonSLD(psStyle, psLayer, nVersion);
-            if (pszSLD) {
-              msStringBufferAppend(sb, pszSLD);
-              free(pszSLD);
-            }
-          }
-
-        } else if (psLayer->type == MS_LAYER_POINT) {
-          int j;
-          for (j=0; j<psLayer->class[i]->numstyles; j++) {
-            styleObj* psStyle = psLayer->class[i]->styles[j];
-            char* pszSLD = msSLDGeneratePointSLD(psStyle, psLayer, nVersion);
-            if (pszSLD) {
-              msStringBufferAppend(sb, pszSLD);
-              free(pszSLD);
-            }
-          }
-
-        }
-        {
-          /* label if it exists */
-          char* pszSLD = msSLDGenerateTextSLD(psLayer->class[i], psLayer, nVersion);
-          if (pszSLD) {
-            msStringBufferAppend(sb, pszSLD);
-            free(pszSLD);
-          }
-        }
-        msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "</se:Rule>\n" : "</Rule>\n");
-      }
-    }
-
-    msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "</se:FeatureTypeStyle>\n" : "</FeatureTypeStyle>\n");
-    msStringBufferAppend(sb, "</UserStyle>\n");
-}
-
-#endif
-
-/************************************************************************/
-/*                          msSLDGenerateSLDLayer                       */
-/*                                                                      */
-/*      Generate an SLD XML string based on the layer's classes.        */
-/************************************************************************/
-char *msSLDGenerateSLDLayer(layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-
-  const char *pszWMSLayerName = NULL;
-  msStringBuffer* sb = msStringBufferAlloc();
-
-  if (psLayer &&
-      (psLayer->status == MS_ON || psLayer->status == MS_DEFAULT) &&
-      (psLayer->type == MS_LAYER_POINT ||
-       psLayer->type == MS_LAYER_LINE ||
-       psLayer->type == MS_LAYER_POLYGON )) {
-
-    int i;
-    int numClassGroupNames = 0;
-    char** papszClassGroupNames =
-                (char**) msSmallMalloc(sizeof(char*) * psLayer->numclasses);
-    for (i=0; i<psLayer->numclasses; i++) {
-        const char* group = psLayer->class[i]->group;
-        int j;
-        for( j = 0; j < numClassGroupNames; j++ )
-        {
-            if( group == NULL )
-            {
-                if( papszClassGroupNames[j] == NULL )
-                    break;
-            }
-            else if( papszClassGroupNames[j] != NULL &&
-                     strcmp(papszClassGroupNames[j], group) == 0 )
-            {
-                break;
-            }
-        }
-        if( j >= numClassGroupNames )
-        {
-            papszClassGroupNames[numClassGroupNames] = group ? msStrdup(group) : NULL;
-            numClassGroupNames ++;
-        }
-    }
-
-    msStringBufferAppend(sb, "<NamedLayer>\n");
-
-    pszWMSLayerName = msOWSLookupMetadata(&(psLayer->metadata), "MO", "name");
-    msSLDAppendName(sb,
-                    pszWMSLayerName ? pszWMSLayerName :
-                    psLayer->name ? psLayer->name :
-                    "NamedLayer",
-                    nVersion);
-
-    for (i=0; i<numClassGroupNames; i++) {
-        msSLDGenerateUserStyle(sb, psLayer, nVersion, papszClassGroupNames[i]);
-        msFree(papszClassGroupNames[i]);
-    }
-    msFree(papszClassGroupNames);
-
-    msStringBufferAppend(sb, "</NamedLayer>\n");
-  }
-  return msStringBufferReleaseStringAndFree(sb);
-
-#else
-  msSetError(MS_MISCERR, "OWS support is not available.",
-             "msSLDGenerateSLDLayer()");
-  return NULL;
-#endif
-}
-
-
-char *msSLDGetComparisonValue(char *pszExpression)
-{
-  char *pszValue = NULL;
-  if (!pszExpression)
-    return NULL;
-
-  if (strstr(pszExpression, "<=") || strstr(pszExpression, " le "))
-    pszValue = msStrdup("PropertyIsLessThanOrEqualTo");
-  else if (strstr(pszExpression, "=~"))
-    pszValue = msStrdup("PropertyIsLike");
-  else if (strstr(pszExpression, "~*"))
-    pszValue = msStrdup("PropertyIsLike");
-  else if (strstr(pszExpression, ">=") || strstr(pszExpression, " ge "))
-    pszValue = msStrdup("PropertyIsGreaterThanOrEqualTo");
-  else if (strstr(pszExpression, "!=") || strstr(pszExpression, " ne "))
-    pszValue = msStrdup("PropertyIsNotEqualTo");
-  else if (strstr(pszExpression, "=") || strstr(pszExpression, " eq "))
-    pszValue = msStrdup("PropertyIsEqualTo");
-  else if (strstr(pszExpression, "<") || strstr(pszExpression, " lt "))
-    pszValue = msStrdup("PropertyIsLessThan");
-  else if (strstr(pszExpression, ">") || strstr(pszExpression, " gt "))
-    pszValue = msStrdup("PropertyIsGreaterThan");
-
-
-  return pszValue;
-}
-
-char *msSLDGetLogicalOperator(char *pszExpression)
-{
-
-  if (!pszExpression)
-    return NULL;
-
-  if(strcasestr(pszExpression, " AND ") || strcasestr(pszExpression, "AND("))
-    return msStrdup("And");
-
-  if(strcasestr(pszExpression, " OR ") || strcasestr(pszExpression, "OR("))
-    return msStrdup("Or");
-
-  if(strcasestr(pszExpression, "NOT ") || strcasestr(pszExpression, "NOT("))
-    return msStrdup("Not");
-
-  return NULL;
-}
-
-char *msSLDGetRightExpressionOfOperator(char *pszExpression)
-{
-  char *pszAnd = NULL, *pszOr = NULL, *pszNot=NULL;
-
-  pszAnd = strcasestr(pszExpression, " AND ");
-
-  if (!pszAnd){
-      pszAnd = strcasestr(pszExpression, "AND(");
-  }
-
-  if (pszAnd)
-    return msStrdup(pszAnd+4);
-  else {
-    pszOr = strcasestr(pszExpression, " OR ");
-
-    if (!pszOr){
-        pszOr = strcasestr(pszExpression, "OR(");
-    }
-
-    if (pszOr)
-      return msStrdup(pszOr+3);
-    else {
-      pszNot = strcasestr(pszExpression, "NOT ");
-
-      if (!pszNot)
-        pszNot = strcasestr(pszExpression, "NOT(");
-
-      if (pszNot)
-        return msStrdup(pszNot+4);
-    }
-  }
-  return NULL;
-
-}
-
-char *msSLDGetLeftExpressionOfOperator(char *pszExpression)
-{
-  char *pszReturn = NULL;
-  int nLength = 0, iReturn=0;
-
-  if (!pszExpression || (nLength = strlen(pszExpression)) <=0)
-    return NULL;
-
-  pszReturn = (char *)malloc(sizeof(char)*(nLength+1));
-  pszReturn[0] = '\0';
-  if (strcasestr(pszExpression, " AND ")) {
-    for (int i=0; i<nLength-5; i++) {
-      if (pszExpression[i] == ' ' &&
-          (toupper(pszExpression[i+1]) == 'A') &&
-          (toupper(pszExpression[i+2]) == 'N') &&
-          (toupper(pszExpression[i+3]) == 'D') &&
-          (pszExpression[i+4] == ' '))
-        break;
-      else {
-        pszReturn[iReturn++] = pszExpression[i];
-      }
-      pszReturn[iReturn] = '\0';
-    }
-  } else if (strcasestr(pszExpression, "AND(")) {
-    for (int i=0; i<nLength-4; i++) {
-      if ((toupper(pszExpression[i]) == 'A') &&
-          (toupper(pszExpression[i+1]) == 'N') &&
-          (toupper(pszExpression[i+2]) == 'D') &&
-          (pszExpression[i+3] == '('))
-        break;
-      else {
-        pszReturn[iReturn++] = pszExpression[i];
-      }
-      pszReturn[iReturn] = '\0';
-    }
-  } else if (strcasestr(pszExpression, " OR ")) {
-    for (int i=0; i<nLength-4; i++) {
-      if (pszExpression[i] == ' ' &&
-          (toupper(pszExpression[i+1]) == 'O') &&
-          (toupper(pszExpression[i+2]) == 'R') &&
-          pszExpression[i+3] == ' ')
-        break;
-      else {
-        pszReturn[iReturn++] = pszExpression[i];
-      }
-      pszReturn[iReturn] = '\0';
-    }
-  } else if (strcasestr(pszExpression, "OR(")) {
-    for (int i=0; i<nLength-3; i++) {
-      if ((toupper(pszExpression[i]) == 'O') &&
-          (toupper(pszExpression[i+1]) == 'R') &&
-          pszExpression[i+2] == '(')
-        break;
-      else {
-        pszReturn[iReturn++] = pszExpression[i];
-      }
-      pszReturn[iReturn] = '\0';
-    }
-  } else {
-    msFree(pszReturn);
-    return NULL;
-  }
-
-  return pszReturn;
-}
-
-
-int msSLDNumberOfLogicalOperators(char *pszExpression)
-{
-  char *pszAnd = NULL;
-  char *pszOr = NULL;
-  char *pszNot = NULL;
-  char *pszSecondAnd=NULL, *pszSecondOr=NULL;
-  if (!pszExpression)
-    return 0;
-
-  /* -------------------------------------------------------------------- */
-  /*      tests here are minimal to be able to parse simple expression    */
-  /*      like A AND B, A OR B, NOT A.                                    */
-  /* -------------------------------------------------------------------- */
-  pszAnd = strcasestr(pszExpression, " AND ");
-  pszOr = strcasestr(pszExpression, " OR ");
-  pszNot = strcasestr(pszExpression, "NOT ");
-
-  if (!pszAnd && !pszOr) {
-    pszAnd = strcasestr(pszExpression, "AND(");
-    pszOr = strcasestr(pszExpression, "OR(");
-  }
-
-  if (!pszNot) {
-    pszNot = strcasestr(pszExpression, "NOT(");
-  }
-
-  if (!pszAnd && !pszOr && !pszNot)
-    return 0;
-
-  /* doen not matter how many exactly if there are 2 or more */
-  if ((pszAnd && pszOr) || (pszAnd && pszNot) || (pszOr && pszNot))
-    return 2;
-
-  if (pszAnd) {
-    pszSecondAnd = strcasestr(pszAnd+3, " AND ");
-    pszSecondOr = strcasestr(pszAnd+3, " OR ");
-  } else if (pszOr) {
-    pszSecondAnd = strcasestr(pszOr+2, " AND ");
-    pszSecondOr = strcasestr(pszOr+2, " OR ");
-  }
-
-  if (!pszSecondAnd && !pszSecondOr)
-    return 1;
-  else
-    return 2;
-}
-
-
-char *msSLDGetAttributeNameOrValue(char *pszExpression,
-                                   char *pszComparionValue,
-                                   int bReturnName)
-{
-  char **aszValues = NULL;
-  char *pszAttributeName = NULL;
-  char *pszAttributeValue = NULL;
-  char cCompare = '=';
-  char szCompare[3] = {0};
-  char szCompare2[3] = {0};
-  int bOneCharCompare = -1, nTokens = 0, nLength =0;
-  int iValue=0, i=0, iValueIndex =0;
-  int bStartCopy=0, iAtt=0;
-  char *pszFinalAttributeName=NULL, *pszFinalAttributeValue=NULL;
-  int bSingleQuote = 0, bDoubleQuote = 0;
-
-  if (!pszExpression || !pszComparionValue || strlen(pszExpression) ==0)
-    return NULL;
-
-  szCompare[0] = '\0';
-  szCompare2[0] = '\0';
-
-
-  if (strcasecmp(pszComparionValue, "PropertyIsEqualTo") == 0) {
-    cCompare = '=';
-    szCompare[0] = 'e';
-    szCompare[1] = 'q';
-    szCompare[2] = '\0';
-
-    bOneCharCompare =1;
-  }
-  if (strcasecmp(pszComparionValue, "PropertyIsNotEqualTo") == 0) {
-    szCompare[0] = 'n';
-    szCompare[1] = 'e';
-    szCompare[2] = '\0';
-
-    szCompare2[0] = '!';
-    szCompare2[1] = '=';
-    szCompare2[2] = '\0';
-
-    bOneCharCompare =0;
-  } else if (strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
-    szCompare[0] = '=';
-    szCompare[1] = '~';
-    szCompare[2] = '\0';
-
-    szCompare2[0] = '~';
-    szCompare2[1] = '*';
-    szCompare2[2] = '\0';
-
-    bOneCharCompare =0;
-  } else if (strcasecmp(pszComparionValue, "PropertyIsLessThan") == 0) {
-    cCompare = '<';
-    szCompare[0] = 'l';
-    szCompare[1] = 't';
-    szCompare[2] = '\0';
-    bOneCharCompare =1;
-  } else if (strcasecmp(pszComparionValue, "PropertyIsLessThanOrEqualTo") == 0) {
-    szCompare[0] = 'l';
-    szCompare[1] = 'e';
-    szCompare[2] = '\0';
-
-    szCompare2[0] = '<';
-    szCompare2[1] = '=';
-    szCompare2[2] = '\0';
-
-    bOneCharCompare =0;
-  } else if (strcasecmp(pszComparionValue, "PropertyIsGreaterThan") == 0) {
-    cCompare = '>';
-    szCompare[0] = 'g';
-    szCompare[1] = 't';
-    szCompare[2] = '\0';
-    bOneCharCompare =1;
-  } else if (strcasecmp(pszComparionValue, "PropertyIsGreaterThanOrEqualTo") == 0) {
-    szCompare[0] = 'g';
-    szCompare[1] = 'e';
-    szCompare[2] = '\0';
-
-    szCompare2[0] = '>';
-    szCompare2[1] = '=';
-    szCompare2[2] = '\0';
-
-    bOneCharCompare =0;
-  }
-
-  if (bOneCharCompare == 1) {
-    aszValues= msStringSplit (pszExpression, cCompare, &nTokens);
-    if (nTokens > 1) {
-      pszAttributeName = msStrdup(aszValues[0]);
-      pszAttributeValue =  msStrdup(aszValues[1]);
-    } else {
-      nLength = strlen(pszExpression);
-      pszAttributeName = (char *)malloc(sizeof(char)*(nLength+1));
-      iValue = 0;
-      for (i=0; i<nLength-2; i++) {
-        if (pszExpression[i] != szCompare[0] &&
-            pszExpression[i] != toupper(szCompare[0])) {
-          pszAttributeName[iValue++] = pszExpression[i];
-        } else {
-          if ((pszExpression[i+1] == szCompare[1] ||
-               pszExpression[i+1] == toupper(szCompare[1])) &&
-              (pszExpression[i+2] == ' ')) {
-            iValueIndex = i+3;
-            pszAttributeValue = msStrdup(pszExpression+iValueIndex);
-            break;
-          } else
-            pszAttributeName[iValue++] = pszExpression[i];
-        }
-      }
-      pszAttributeName[iValue] = '\0';
-    }
-    msFreeCharArray(aszValues, nTokens);
-  } else if (bOneCharCompare == 0) {
-    nLength = strlen(pszExpression);
-    pszAttributeName = (char *)malloc(sizeof(char)*(nLength+1));
-    iValue = 0;
-    for (i=0; i<nLength-2; i++) {
-      if ((pszExpression[i] != szCompare[0] ||
-           pszExpression[i] != toupper(szCompare[0])) &&
-          (pszExpression[i] != szCompare2[0] ||
-           pszExpression[i] != toupper(szCompare2[0])))
-
-      {
-        pszAttributeName[iValue++] = pszExpression[i];
-      } else {
-        if (((pszExpression[i+1] == szCompare[1] ||
-              pszExpression[i+1] == toupper(szCompare[1])) ||
-             (pszExpression[i+1] == szCompare2[1] ||
-              pszExpression[i+1] == toupper(szCompare2[1]))) &&
-            (pszExpression[i+2] == ' ')) {
-          iValueIndex = i+3;
-          pszAttributeValue = msStrdup(pszExpression+iValueIndex);
-          break;
-        } else
-          pszAttributeName[iValue++] = pszExpression[i];
-      }
-    }
-    pszAttributeName[iValue] = '\0';
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Return the name of the attribute : It is supposed to be         */
-  /*      inside []                                                       */
-  /* -------------------------------------------------------------------- */
-  if (bReturnName) {
-    if (!pszAttributeName) {
-      msFree(pszAttributeValue);
-      return NULL;
-    }
-
-    nLength = strlen(pszAttributeName);
-    pszFinalAttributeName = (char *)malloc(sizeof(char)*(nLength+1));
-    bStartCopy= 0;
-    iAtt = 0;
-    for (i=0; i<nLength; i++) {
-      if (pszAttributeName[i] == ' ' && bStartCopy == 0)
-        continue;
-
-      if (pszAttributeName[i] == '[') {
-        bStartCopy = 1;
-        continue;
-      }
-      if (pszAttributeName[i] == ']')
-        break;
-      if (bStartCopy) {
-        pszFinalAttributeName[iAtt++] = pszAttributeName[i];
-      }
-      pszFinalAttributeName[iAtt] = '\0';
-    }
-
-    msFree(pszAttributeName);
-    msFree(pszAttributeValue);
-    return pszFinalAttributeName;
-  } else {
-
-    if (!pszAttributeValue) {
-      msFree(pszAttributeName);
-      return NULL;
-    }
-    nLength = strlen(pszAttributeValue);
-    pszFinalAttributeValue = (char *)malloc(sizeof(char)*(nLength+1));
-    pszFinalAttributeValue[0] = '\0';
-    bStartCopy= 0;
-    iAtt = 0;
-    for (i=0; i<nLength; i++) {
-      if (pszAttributeValue[i] == ' ' && bStartCopy == 0)
-        continue;
-
-      if (pszAttributeValue[i] == '\'' && bStartCopy == 0) {
-        bSingleQuote = 1;
-        bStartCopy = 1;
-        continue;
-      } else if (pszAttributeValue[i] == '"' && bStartCopy == 0) {
-        bDoubleQuote = 1;
-        bStartCopy = 1;
-        continue;
-      } else
-        bStartCopy =1;
-
-      if (bStartCopy) {
-        if (pszAttributeValue[i] == '\'' && bSingleQuote)
-          break;
-        else if (pszAttributeValue[i] == '"' && bDoubleQuote)
-          break;
-        else if (pszAttributeValue[i] == ')')
-          break;
-        pszFinalAttributeValue[iAtt++] = pszAttributeValue[i];
-      }
-      pszFinalAttributeValue[iAtt] = '\0';
-    }
-
-    /*trim  for regular expressions*/
-    if (strlen(pszFinalAttributeValue) > 2 && strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
-      int len = strlen(pszFinalAttributeValue);
-      msStringTrimBlanks(pszFinalAttributeValue);
-      if (pszFinalAttributeValue[0] == '/' &&
-          (pszFinalAttributeValue[len-1] == '/' ||
-           (pszFinalAttributeValue[len-1] == 'i' &&
-            pszFinalAttributeValue[len-2] == '/'))) {
-        if (pszFinalAttributeValue[len-1] == '/')
-          pszFinalAttributeValue[len-1] = '\0';
-        else
-          pszFinalAttributeValue[len-2] = '\0';
-
-        memmove(pszFinalAttributeValue, pszFinalAttributeValue +
-                ((pszFinalAttributeValue[1] == '^') ? 2 : 1), len-1);
-
-        /*replace wild card string .* with * */
-        pszFinalAttributeValue = msReplaceSubstring(pszFinalAttributeValue, ".*", "*");
-      }
-    }
-    msFree(pszAttributeName);
-    msFree(pszAttributeValue);
-    return pszFinalAttributeValue;
-  }
-}
-
-
-char *msSLDGetAttributeName(char *pszExpression,
-                            char *pszComparionValue)
-{
-  return msSLDGetAttributeNameOrValue(pszExpression, pszComparionValue, 1);
-}
-
-char *msSLDGetAttributeValue(char *pszExpression,
-                             char *pszComparionValue)
-{
-  return msSLDGetAttributeNameOrValue(pszExpression, pszComparionValue, 0);
-}
-
-
-
-/************************************************************************/
-/*                           BuildExpressionTree                        */
-/*                                                                      */
-/*      Build a filter expression node based on mapserver's class       */
-/*      expression. This is limited to simple expressions like :        */
-/*        A = B, A < B, A <= B, A > B, A >= B, A != B                   */
-/*       It also handles one level of logical expressions :             */
-/*        A AND B                                                       */
-/*        A OR B                                                        */
-/*        NOT A                                                         */
-/************************************************************************/
-FilterEncodingNode *BuildExpressionTree(char *pszExpression,
-                                        FilterEncodingNode *psNode)
-{
-  int nOperators=0;
-  char *pszComparionValue=NULL, *pszAttibuteName=NULL;
-  char *pszAttibuteValue=NULL;
-  char *pszLeftExpression=NULL, *pszRightExpression=NULL, *pszOperator=NULL;
-
-  if (!pszExpression || strlen(pszExpression) == 0)
-    return NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      First we check how many logical operators are there :           */
-  /*       - if none : It means It is a comparison operator (like =,      */
-  /*      >, >= .... We get the comparison value as well as the           */
-  /*      attribute and the attribute's value and assign it to the node   */
-  /*      passed in argument.                                             */
-  /*       - if there is one operator, we assign the operator to the      */
-  /*      node and adds the expressions into the left and right nodes.    */
-  /* -------------------------------------------------------------------- */
-  nOperators = msSLDNumberOfLogicalOperators(pszExpression);
-  if (nOperators == 0) {
-    if (!psNode)
-      psNode = FLTCreateFilterEncodingNode();
-
-    pszComparionValue = msSLDGetComparisonValue(pszExpression);
-    pszAttibuteName = msSLDGetAttributeName(pszExpression, pszComparionValue);
-    pszAttibuteValue = msSLDGetAttributeValue(pszExpression, pszComparionValue);
-    if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
-      psNode->eType = FILTER_NODE_TYPE_COMPARISON;
-      psNode->pszValue = msStrdup(pszComparionValue);
-
-      psNode->psLeftNode = FLTCreateFilterEncodingNode();
-      psNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-      psNode->psLeftNode->pszValue = msStrdup(pszAttibuteName);
-
-      psNode->psRightNode = FLTCreateFilterEncodingNode();
-      psNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
-      psNode->psRightNode->pszValue = msStrdup(pszAttibuteValue);
-
-      if (strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
-        psNode->pOther = (FEPropertyIsLike *)malloc(sizeof(FEPropertyIsLike));
-        ((FEPropertyIsLike *)psNode->pOther)->bCaseInsensitive = 0;
-        ((FEPropertyIsLike *)psNode->pOther)->pszWildCard = msStrdup("*");
-        ((FEPropertyIsLike *)psNode->pOther)->pszSingleChar = msStrdup("#");
-        ((FEPropertyIsLike *)psNode->pOther)->pszEscapeChar = msStrdup("!");
-      }
-      free(pszComparionValue);
-      free(pszAttibuteName);
-      free(pszAttibuteValue);
-    }
-    return psNode;
-
-  } else if (nOperators == 1) {
-    pszOperator = msSLDGetLogicalOperator(pszExpression);
-    if (pszOperator) {
-      if (!psNode)
-        psNode = FLTCreateFilterEncodingNode();
-
-      psNode->eType = FILTER_NODE_TYPE_LOGICAL;
-      psNode->pszValue = msStrdup(pszOperator);
-      free(pszOperator);
-
-      pszLeftExpression = msSLDGetLeftExpressionOfOperator(pszExpression);
-      pszRightExpression = msSLDGetRightExpressionOfOperator(pszExpression);
-
-      if (pszLeftExpression || pszRightExpression) {
-        if (pszLeftExpression) {
-          pszComparionValue = msSLDGetComparisonValue(pszLeftExpression);
-          pszAttibuteName = msSLDGetAttributeName(pszLeftExpression,
-                                                  pszComparionValue);
-          pszAttibuteValue = msSLDGetAttributeValue(pszLeftExpression,
-                             pszComparionValue);
-
-          if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
-            psNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psNode->psLeftNode->eType = FILTER_NODE_TYPE_COMPARISON;
-            psNode->psLeftNode->pszValue = msStrdup(pszComparionValue);
-
-            psNode->psLeftNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psNode->psLeftNode->psLeftNode->eType =
-              FILTER_NODE_TYPE_PROPERTYNAME;
-            psNode->psLeftNode->psLeftNode->pszValue = msStrdup(pszAttibuteName);
-
-            psNode->psLeftNode->psRightNode = FLTCreateFilterEncodingNode();
-            psNode->psLeftNode->psRightNode->eType =
-              FILTER_NODE_TYPE_LITERAL;
-            psNode->psLeftNode->psRightNode->pszValue =
-              msStrdup(pszAttibuteValue);
-
-            free(pszComparionValue);
-            free(pszAttibuteName);
-            free(pszAttibuteValue);
-            free(pszLeftExpression);
-          }
-        }
-        if (pszRightExpression) {
-          pszComparionValue = msSLDGetComparisonValue(pszRightExpression);
-          pszAttibuteName = msSLDGetAttributeName(pszRightExpression,
-                                                  pszComparionValue);
-          pszAttibuteValue = msSLDGetAttributeValue(pszRightExpression,
-                             pszComparionValue);
-
-          if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
-            psNode->psRightNode = FLTCreateFilterEncodingNode();
-            psNode->psRightNode->eType = FILTER_NODE_TYPE_COMPARISON;
-            psNode->psRightNode->pszValue = msStrdup(pszComparionValue);
-
-            psNode->psRightNode->psLeftNode =
-              FLTCreateFilterEncodingNode();
-            psNode->psRightNode->psLeftNode->eType =
-              FILTER_NODE_TYPE_PROPERTYNAME;
-            psNode->psRightNode->psLeftNode->pszValue =
-              msStrdup(pszAttibuteName);
-
-            psNode->psRightNode->psRightNode =
-              FLTCreateFilterEncodingNode();
-            psNode->psRightNode->psRightNode->eType =
-              FILTER_NODE_TYPE_LITERAL;
-            psNode->psRightNode->psRightNode->pszValue =
-              msStrdup(pszAttibuteValue);
-
-            free(pszComparionValue);
-            free(pszAttibuteName);
-            free(pszAttibuteValue);
-            free(pszRightExpression);
-          }
-        }
-      }
-    }
-
-    return psNode;
-  } else {
-    return NULL;
-  }
-}
-
-char *msSLDBuildFilterEncoding(FilterEncodingNode *psNode)
-{
-  char *pszTmp = NULL;
-  char szTmp[200];
-  char *pszExpression = NULL;
-
-  if (!psNode)
-    return NULL;
-
-  if (psNode->eType == FILTER_NODE_TYPE_COMPARISON &&
-      psNode->pszValue && psNode->psLeftNode && psNode->psLeftNode->pszValue &&
-      psNode->psRightNode && psNode->psRightNode->pszValue) {
-    snprintf(szTmp, sizeof(szTmp), "<ogc:%s><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:%s>",
-             psNode->pszValue, psNode->psLeftNode->pszValue,
-             psNode->psRightNode->pszValue, psNode->pszValue);
-    pszExpression = msStrdup(szTmp);
-  } else if (psNode->eType == FILTER_NODE_TYPE_LOGICAL &&
-             psNode->pszValue &&
-             ((psNode->psLeftNode && psNode->psLeftNode->pszValue) ||
-              (psNode->psRightNode && psNode->psRightNode->pszValue))) {
-    snprintf(szTmp, sizeof(szTmp), "<ogc:%s>", psNode->pszValue);
-    pszExpression = msStringConcatenate(pszExpression, szTmp);
-    if (psNode->psLeftNode) {
-      pszTmp = msSLDBuildFilterEncoding(psNode->psLeftNode);
-      if (pszTmp) {
-        pszExpression = msStringConcatenate(pszExpression, pszTmp);
-        free(pszTmp);
-      }
-    }
-    if (psNode->psRightNode) {
-      pszTmp = msSLDBuildFilterEncoding(psNode->psRightNode);
-      if (pszTmp) {
-        pszExpression = msStringConcatenate(pszExpression, pszTmp);
-        free(pszTmp);
-      }
-    }
-    snprintf(szTmp,  sizeof(szTmp), "</ogc:%s>", psNode->pszValue);
-    pszExpression = msStringConcatenate(pszExpression, szTmp);
-  }
-  return pszExpression;
-}
-
-
-
-char *msSLDParseLogicalExpression(char *pszExpression, const char *pszWfsFilter)
-{
-  FilterEncodingNode *psNode = NULL;
-  char *pszFLTExpression = NULL;
-  char *pszTmp = NULL;
-
-  if (!pszExpression || strlen(pszExpression) ==0)
-    return NULL;
-
-  psNode = BuildExpressionTree(pszExpression, NULL);
-
-  if (psNode) {
-    pszFLTExpression = msSLDBuildFilterEncoding(psNode);
-    if (pszFLTExpression) {
-      pszTmp = msStringConcatenate(pszTmp, "<ogc:Filter>");
-      if (pszWfsFilter) {
-        pszTmp = msStringConcatenate(pszTmp, "<ogc:And>");
-        pszTmp = msStringConcatenate(pszTmp, (char *)pszWfsFilter);
-      }
-      pszTmp = msStringConcatenate(pszTmp, pszFLTExpression);
-
-      if (pszWfsFilter)
-        pszTmp = msStringConcatenate(pszTmp, "</ogc:And>");
-
-      pszTmp = msStringConcatenate(pszTmp, "</ogc:Filter>\n");
-
-      free(pszFLTExpression);
-      pszFLTExpression = pszTmp;
-    }
-    FLTFreeFilterEncodingNode(psNode);
-  }
-
-  return pszFLTExpression;
-}
-
-/************************************************************************/
-/*             char *msSLDParseExpression(char *pszExpression)          */
-/*                                                                      */
-/*      Return an OGC filter for a mapserver logical expression.        */
-/*      TODO : move function to mapogcfilter.c                          */
-/************************************************************************/
-char *msSLDParseExpression(char *pszExpression)
-{
-  int nElements = 0;
-  char **aszElements = NULL;
-  char szBuffer[500];
-  char szFinalAtt[40];
-  char szFinalValue[40];
-  char szAttribute[40];
-  char szValue[40];
-  int iVal=0;
-  int bStartCopy=0, bSinglequote=0, bDoublequote=0;
-  char *pszFilter = NULL;
-
-  if (!pszExpression)
-    return NULL;
-
-  aszElements = msStringSplit(pszExpression, ' ', &nElements);
-
-  szFinalAtt[0] = '\0';
-  szFinalValue[0] = '\0';
-  for (int i=0; i<nElements; i++) {
-    if (strcasecmp(aszElements[i], "=") == 0 ||
-        strcasecmp(aszElements[i], "eq") == 0) {
-      if (i > 0 && i < nElements-1) {
-        snprintf(szAttribute, sizeof(szAttribute), "%s", aszElements[i-1]);
-        snprintf(szValue, sizeof(szValue), "%s", aszElements[i+1]);
-
-        /* parse attribute */
-        int nLength = strlen(szAttribute);
-        if (nLength > 0) {
-          int iAtt = 0;
-          for (i=0; i<nLength; i++) {
-            if (szAttribute[i] == '[') {
-              bStartCopy = 1;
-              continue;
-            }
-            if (szAttribute[i] == ']')
-              break;
-            if (bStartCopy) {
-              szFinalAtt[iAtt] = szAttribute[i];
-              iAtt++;
-            }
-            szFinalAtt[iAtt] = '\0';
-          }
-        }
-
-        /* parse value */
-        nLength = strlen(szValue);
-        if (nLength > 0) {
-          if (szValue[0] == '\'')
-            bSinglequote = 1;
-          else if (szValue[0] == '\"')
-            bDoublequote = 1;
-          else
-            snprintf(szFinalValue, sizeof(szFinalValue), "%s", szValue);
-
-          iVal = 0;
-          if (bSinglequote || bDoublequote) {
-            for (i=1; i<nLength-1; i++)
-              szFinalValue[iVal++] = szValue[i];
-
-            szFinalValue[iVal] = '\0';
-          }
-        }
-      }
-      if (strlen(szFinalAtt) > 0 && strlen(szFinalValue) >0) {
-        snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:PropertyIsEqualTo><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsEqualTo></ogc:Filter>",
-                 szFinalAtt, szFinalValue);
-        msFree(pszFilter); /*FIXME: we are possibly discarding a previously set pszFilter */
-        pszFilter = msStrdup(szBuffer);
-      }
-    }
-  }
-  msFreeCharArray(aszElements, nElements);
-
-  return pszFilter;
-}
-
-
-/************************************************************************/
-/*                     msSLDConvertRegexExpToOgcIsLike                  */
-/*                                                                      */
-/*      Convert mapserver regex expression to ogc is like property      */
-/*      expression.                                                     */
-/*                                                                      */
-/*      Review bug 1644 for details. Here are the current rules:        */
-/*                                                                      */
-/*       The filter encoding property like is more limited compared     */
-/*      to regular expression that can be built in mapserver. I         */
-/*      think we should define what is possible to convert properly     */
-/*      and do those, and also identify potential problems.  Example :  */
-/*        - any time there is a .* in the expression it will be         */
-/*      converted to *                                                  */
-/*        - any other character plus all the metacharacters . ^ $ * +   */
-/*      ? { [ ] \ | ( ) would be outputted as is. (In case of           */
-/*      mapserver, when we read the the ogc filter expression, we       */
-/*      convert the wild card character to .*, and we convert the       */
-/*      single character to .  and the escape character to \ all        */
-/*      other are outputted as is)                                      */
-/*        - the  ogc tag would look like <ogc:PropertyIsLike            */
-/*      wildCard="*"  singleChar="." escape="\">                        */
-/*                                                                      */
-/*        - type of potential problem :                                 */
-/*           * if an expression is like /T (star)/ it will be           */
-/*      converted to T* which is not correct.                           */
-/*                                                                      */
-/************************************************************************/
-char *msSLDConvertRegexExpToOgcIsLike(char *pszRegex)
-{
-  char szBuffer[1024];
-  int iBuffer = 0, i=0;
-  int nLength = 0;
-
-  if (!pszRegex || strlen(pszRegex) == 0)
-    return NULL;
-
-  szBuffer[0] = '\0';
-  nLength = strlen(pszRegex);
-
-  while (i < nLength) {
-    if (pszRegex[i] != '.') {
-      szBuffer[iBuffer++] = pszRegex[i];
-      i++;
-    } else {
-      if (i<nLength-1 && pszRegex[i+1] == '*') {
-        szBuffer[iBuffer++] = '*';
-        i = i+2;
-      } else {
-        szBuffer[iBuffer++] =  pszRegex[i];
-        i++;
-      }
-    }
-  }
-  szBuffer[iBuffer] = '\0';
-
-  return msStrdup(szBuffer);
-}
-
-/************************************************************************/
-/*                              msSLDGetFilter                          */
-/*                                                                      */
-/*      Get the corresponding ogc Filter based on the class             */
-/*      expression. TODO : move function to mapogcfilter.c when         */
-/*      finished.                                                       */
-/************************************************************************/
-char *msSLDGetFilter(classObj *psClass, const char *pszWfsFilter)
-{
-  char *pszFilter = NULL;
-  char szBuffer[500];
-  char *pszOgcFilter = NULL;
-
-  if (psClass && psClass->expression.string) {
-    /* string expression */
-    if (psClass->expression.type == MS_STRING) {
-      if (psClass->layer && psClass->layer->classitem) {
-        if (pszWfsFilter)
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:And>%s<ogc:PropertyIsEqualTo><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsEqualTo></ogc:And></ogc:Filter>\n",
-                   pszWfsFilter, psClass->layer->classitem, psClass->expression.string);
-        else
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:PropertyIsEqualTo><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsEqualTo></ogc:Filter>\n",
-                   psClass->layer->classitem, psClass->expression.string);
-        pszFilter = msStrdup(szBuffer);
-      }
-    } else if (psClass->expression.type == MS_EXPRESSION) {
-      pszFilter = msSLDParseLogicalExpression(psClass->expression.string, pszWfsFilter);
-    } else if (psClass->expression.type == MS_REGEX) {
-      if (psClass->layer && psClass->layer->classitem && psClass->expression.string) {
-        pszOgcFilter = msSLDConvertRegexExpToOgcIsLike(psClass->expression.string);
-
-        if (pszWfsFilter)
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:And>%s<ogc:PropertyIsLike wildCard=\"*\" singleChar=\".\" escape=\"\\\"><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsLike></ogc:And></ogc:Filter>\n",
-                   pszWfsFilter, psClass->layer->classitem, pszOgcFilter);
-        else
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:PropertyIsLike wildCard=\"*\" singleChar=\".\" escape=\"\\\"><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsLike></ogc:Filter>\n",
-                   psClass->layer->classitem, pszOgcFilter);
-
-        free(pszOgcFilter);
-
-        pszFilter = msStrdup(szBuffer);
-      }
-    }
-  } else if (pszWfsFilter) {
-    snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter>%s</ogc:Filter>\n", pszWfsFilter);
-    pszFilter = msStrdup(szBuffer);
-  }
-  return pszFilter;
-}
diff -pruN 8.0.1-5/mapogcsld.h 8.2.0~beta1-1~exp1/mapogcsld.h
--- 8.0.1-5/mapogcsld.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcsld.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,97 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC SLD implementation
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-MS_DLL_EXPORT char *msSLDGenerateSLD(mapObj *map, int iLayer, const char *pszVersion);
-MS_DLL_EXPORT int msSLDApplySLDURL(mapObj *map, const char *szURL, int iLayer,
-                                   const char *pszStyleLayerName, char **ppszLayerNames);
-MS_DLL_EXPORT int msSLDApplySLD(mapObj *map, const char *psSLDXML, int iLayer,
-                                const char *pszStyleLayerName, char **ppszLayerNames);
-
-/* There is a dependency to OGR for the MiniXML parser */
-#include "cpl_minixml.h"
-
-enum objType { MS_OBJ_STYLE, MS_OBJ_LABEL };
-
-/* -------------------------------------------------------------------- */
-/*      prototypes.                                                     */
-/* -------------------------------------------------------------------- */
-layerObj  *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers);
-int msSLDParseNamedLayer(CPLXMLNode *psRoot, layerObj *layer);
-int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer, const char* pszUserStyleName);
-int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle,
-                     mapObj *map, int iColorParam);
-int msSLDParseOgcExpression(CPLXMLNode *psRoot, void *psObj, int binding,
-                            enum objType objtype);
-int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle,
-                          mapObj *map);
-
-int msSLDParseLineSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bNewClass, const char* pszUserStyleName);
-int msSLDParsePolygonSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                                int bNewClass, const char* pszUserStyleName);
-int msSLDParsePointSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                              int bNewClass, const char* pszUserStyleName);
-int msSLDParseTextSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bOtherSymboliser, const char* pszUserStyleName);
-int msSLDParseRasterSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer, const char* pszUserStyleName);
-
-int msSLDParseGraphicFillOrStroke(CPLXMLNode *psGraphicFill,
-                                  char *pszDashValue,
-                                  styleObj *psStyle, mapObj *map);
-int msSLDParseExternalGraphic(CPLXMLNode *psExternalGraphic, styleObj *psStyle,
-                              mapObj *map);
-
-int msSLDGetLineSymbol(mapObj *map);
-int msSLDGetDashLineSymbol(mapObj *map, char *pszDashArray);
-int msSLDGetMarkSymbol(mapObj *map, char *pszSymbolName, int bFilled);
-int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName, char *extGraphicName, int nGap);
-
-int msSLDSetColorObject(char *psHexColor, colorObj *psColor);
-
-int msSLDParseTextParams(CPLXMLNode *psRoot, layerObj *psLayer, classObj *psClass);
-int ParseTextPointPlacement(CPLXMLNode *psRoot, classObj *psClass);
-int ParseTextLinePlacement(CPLXMLNode *psRoot, classObj *psClass);
-
-char *msSLDGenerateSLDLayer(layerObj *psLayer, int nVersion);
-
-char *msSLDGetFilter(classObj *psClass, const char *pszWfsFilter);
-char *msSLDGenerateLineSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
-char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
-char *msSLDGeneratePointSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
-char *msSLDGenerateTextSLD(classObj *psClass, layerObj *psLayer, int nVersion);
-FilterEncodingNode *BuildExpressionTree(char *pszExpression, FilterEncodingNode *psNode);
-
-#ifdef __cplusplus
-} /* extern C */
-#endif
diff -pruN 8.0.1-5/mapogcsos.c 8.2.0~beta1-1~exp1/mapogcsos.c
--- 8.0.1-5/mapogcsos.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogcsos.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,3132 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC SOS implementation
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2006, Y. Assefa, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#define _GNU_SOURCE
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
-
-#include "maperror.h"
-#include "mapthread.h"
-#include "mapows.h"
-#include "maptime.h"
-#include "mapgml.h"
-#include "mapogcfilter.h"
-
-#include "mapowscommon.h"
-#include "maplibxml2.h"
-
-#include "libxml/parser.h"
-#include "libxml/tree.h"
-#include "libxml/xpath.h"
-#include "libxml/xpathInternals.h"
-
-const char *pszSOSVersion                = "1.0.0";
-const char *pszSOSNamespaceUri           = "http://www.opengis.net/sos/1.0";
-const char *pszSOSNamespacePrefix        = "sos";
-const char *pszOMNamespaceUri            = "http://www.opengis.net/om/1.0";
-const char *pszOMNamespacePrefix         = "om";
-const char *pszSOSDescribeSensorMimeType = "text/xml; subtype=\"sensorML/1.0.0\"";
-const char *pszSOSGetObservationMimeType = "text/xml; subtype=\"om/1.0.0\"";
-
-typedef struct {
-  char *pszProcedure;
-  xmlNodePtr psResultNode;
-} SOSProcedureNode;
-
-int msSOSParseRequest(mapObj *map, cgiRequestObj *request, sosParamsObj *sosparams);
-void msSOSFreeParamsObj(sosParamsObj *sosparams);
-
-/*
-** msSOSException()
-**
-** Report current MapServer error in XML exception format.
-** Wrapper function around msOWSCommonExceptionReport. Merely
-** passes SOS specific info.
-**
-*/
-
-static int msSOSException(mapObj *map, char *locator, char *exceptionCode)
-{
-  int size = 0;
-  char *errorString     = NULL;
-  char *schemasLocation = NULL;
-
-  xmlDocPtr  psDoc      = NULL;
-  xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
-
-  psNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-
-  errorString = msGetErrorString("\n");
-  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_1_0, schemasLocation, pszSOSVersion, msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-
-  msIO_printf("%s", buffer);
-
-  /*free buffer and the document */
-  free(errorString);
-  free(schemasLocation);
-  xmlFree(buffer);
-  xmlFreeDoc(psDoc);
-  xmlFreeNs(psNsOws);
-
-  /*
-  ** The typical pattern is to call msSOSException() right after
-  ** msSetError().  In order to prevent mapserv.c from re-reporting this
-  ** error at a higher level, we mark it as reported here. #3571
-  */
-  {
-    errorObj *err = msGetErrorObj();
-    if( err != NULL && err->code != MS_NOERR )
-      err->isreported = MS_TRUE;
-  }
-
-  return MS_FAILURE;
-}
-
-static int _IsInList(char **papsProcedures, int nDistinctProcedures, char *pszProcedure)
-{
-  int i = 0;
-  if (papsProcedures && nDistinctProcedures > 0 && pszProcedure) {
-    for (i=0; i<nDistinctProcedures; i++) {
-      if (papsProcedures[i] && strcmp(papsProcedures[i], pszProcedure) == 0)
-        return 1;
-    }
-  }
-  return 0;
-}
-
-/************************************************************************/
-/*                           msSOSValidateFilter                        */
-/*                                                                      */
-/*      Look if the filter's property names have an equivalent          */
-/*      layre's attribute.                                              */
-/************************************************************************/
-static int msSOSValidateFilter(FilterEncodingNode *psFilterNode,
-                               layerObj *lp)
-{
-  int i=0, bFound =0;
-  /* assuming here that the layer is opened*/
-  if (psFilterNode && lp) {
-    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
-      for (i=0; i<lp->numitems; i++) {
-        if (strcasecmp(lp->items[i], psFilterNode->pszValue) == 0) {
-          bFound = 1;
-          break;
-        }
-      }
-      if (!bFound)
-        return MS_FALSE;
-    }
-    if (psFilterNode->psLeftNode && psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
-      if (msSOSValidateFilter(psFilterNode->psLeftNode, lp) == MS_FALSE)
-        return MS_FALSE;
-    }
-    if (psFilterNode->psRightNode && psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
-      if (msSOSValidateFilter(psFilterNode->psRightNode, lp) == MS_FALSE)
-        return MS_FALSE;
-    }
-  }
-
-  return MS_TRUE;
-}
-
-
-
-/************************************************************************/
-/*                        msSOSAddMetadataChildNode                     */
-/*                                                                      */
-/*      Utility function to add a metadata node.                        */
-/************************************************************************/
-void msSOSAddMetadataChildNode(xmlNodePtr psParent, const char *psNodeName,
-                               xmlNsPtr psNs, hashTableObj *metadata,
-                               const char *psNamespaces,
-                               const char *psMetadataName,
-                               const char *psDefaultValue)
-{
-  xmlNodePtr psNode = NULL;
-  char *psValue = NULL;
-
-  if (psParent && psNodeName) {
-    psValue = msOWSGetEncodeMetadata(metadata, psNamespaces, psMetadataName,
-                                     psDefaultValue);
-    if (psValue) {
-      psNode = xmlNewChild(psParent, NULL, BAD_CAST psNodeName, BAD_CAST psValue);
-      if (psNs)
-        xmlSetNs(psNode,  psNs);
-      free(psValue);
-    }
-  }
-}
-
-
-/************************************************************************/
-/*                      msSOSGetFirstLayerForOffering                   */
-/*                                                                      */
-/*      return the first layer for the offering.                        */
-/************************************************************************/
-layerObj *msSOSGetFirstLayerForOffering(mapObj *map, const char *pszOffering,
-                                        const char *pszProperty)
-{
-  layerObj *lp = NULL;
-  const char *pszTmp = NULL;
-  int i = 0;
-
-  if (pszOffering && map) {
-    for (i=0; i<map->numlayers; i++) {
-      pszTmp =
-        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
-      if (pszTmp && (strcasecmp(pszTmp, pszOffering) == 0)) {
-        if (pszProperty) {
-          pszTmp =
-            msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
-                                "observedproperty_id");
-          if (pszTmp && (strcasecmp(pszTmp, pszProperty) == 0)) {
-            lp = (GET_LAYER(map, i));
-            break;
-          }
-        } else {
-          lp = (GET_LAYER(map, i));
-          break;
-        }
-      }
-    }
-  }
-  return lp;
-}
-
-xmlNodePtr msSOSAddTimeNode(xmlNsPtr psNs, xmlNsPtr psNsGml, char *pszStart, char *pszEnd)
-{
-  xmlNodePtr psNode=NULL;
-
-  char *timeel= NULL;
-
-  if (strcmp((char *)psNs->prefix,"sos") == 0)
-    timeel = "time";
-  if (strcmp((char *)psNs->prefix,"om") == 0)
-    timeel = "samplingTime";
-  else
-    timeel = "time";
-
-  psNode = xmlNewNode(psNs, BAD_CAST timeel);
-  xmlAddChild(psNode, msGML3TimePeriod(psNsGml, pszStart, pszEnd));
-  return psNode;
-}
-
-void msSOSAddPropertyNode(xmlNsPtr psNsSwe, xmlNsPtr psNsXLink, xmlNodePtr psParent, layerObj *lp, xmlNsPtr psNsGml, char *pszCompositePhenomenonId)
-{
-  const char *pszValue = NULL;
-  char *pszTmpVal = NULL, *pszFullName = NULL;
-  xmlNodePtr psCompNode, psNode;
-  int i, j=0;
-  char szTmp[256];
-  const char *pszComponentBase = "urn:ogc:def:property:";
-
-  if (psParent && lp) {
-    psNode = xmlNewChild(psParent, NULL, BAD_CAST "observedProperty", NULL);
-    psCompNode = xmlNewChild(psNode, psNsSwe, BAD_CAST "CompositePhenomenon", NULL);
-    pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
-                                   "observedproperty_id");
-    pszTmpVal = msStrdup(pszValue);
-
-    if (pszCompositePhenomenonId != NULL) { /* unique value needs to be constructed */
-      pszTmpVal = msStringConcatenate(pszTmpVal, "_");
-      pszTmpVal = msStringConcatenate(pszTmpVal, pszCompositePhenomenonId);
-    }
-
-    if (pszTmpVal) { /*should always be true */
-      xmlNewNsProp(psCompNode, psNsGml, BAD_CAST "id", BAD_CAST pszTmpVal);
-      msFree(pszTmpVal);
-    }
-
-    pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
-                                   "observedproperty_name");
-    if (pszValue)
-      (void) xmlNewTextChild(psCompNode, psNsGml,
-                           BAD_CAST "name", BAD_CAST pszValue);
-
-    /* add components */
-
-    /*assuming that the layer is opened and msLayerGetItems called*/
-    for(i=0; i<lp->numitems; i++) {
-      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_authority");
-
-      if (pszValue)
-        pszTmpVal = msStrdup(pszValue);
-      else
-        pszTmpVal = msStrdup("OGC-SWE");
-
-      pszFullName = msStrdup(pszComponentBase);
-
-      pszFullName = msStringConcatenate(pszFullName, pszTmpVal);
-
-      free(pszTmpVal);
-
-      pszFullName = msStringConcatenate(pszFullName, ":");
-
-      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_version");
-
-      if (pszValue)
-        pszTmpVal = msStrdup(pszValue);
-      else
-        pszTmpVal = msStrdup("1");
-
-      pszFullName = msStringConcatenate(pszFullName, pszTmpVal);
-
-      free(pszTmpVal);
-
-      pszFullName = msStringConcatenate(pszFullName, ":");
-
-      snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
-      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
-
-      if (pszValue)
-        pszTmpVal = msStrdup(pszValue);
-      else
-        pszTmpVal = msStrdup(lp->items[i]);
-
-      pszFullName = msStringConcatenate(pszFullName, pszTmpVal);
-
-      psNode = xmlNewChild(psCompNode, psNsSwe, BAD_CAST "component", NULL);
-
-      xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszFullName);
-      free(pszFullName);
-      free(pszTmpVal);
-      j++;
-    }
-    pszTmpVal = msIntToString(j);
-    xmlNewNsProp(psCompNode, NULL, BAD_CAST "dimension", BAD_CAST pszTmpVal);
-    free(pszTmpVal);
-  }
-}
-
-/************************************************************************/
-/*                           msSOSAddGeometryNode                       */
-/*                                                                      */
-/*      Outout gml 2 gemptry nodes based on a shape. All logic comes    */
-/*      from gmlWriteGeometry_GML2. Should be merged at one point if    */
-/*      possible.                                                       */
-/************************************************************************/
-void  msSOSAddGeometryNode(xmlNsPtr psNsGml, xmlNsPtr psNsMs, xmlNodePtr psParent, mapObj *map, layerObj *lp, shapeObj *psShape,
-                           const char *pszEpsg_in)
-{
-  char *pszTmp = NULL;
-  int i,j = 0;
-  xmlNodePtr psPointNode, psNode, psLineNode, psPolygonNode;
-  int *panOuterList = NULL, *panInnerList = NULL;
-  const char *pszEpsg = pszEpsg_in;
-  char *pszEpsg_buf = NULL;
-  
-
-  if (psParent && psShape) {
-    if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
-      if( lp->reprojectorLayerToMap == NULL )
-      {
-        lp->reprojectorLayerToMap = msProjectCreateReprojector(
-            &lp->projection, &map->projection);
-      }
-      if( lp->reprojectorLayerToMap )
-      {
-        msProjectShapeEx(lp->reprojectorLayerToMap, psShape);
-      }
-      msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE, &pszEpsg_buf);
-      pszEpsg = pszEpsg_buf;
-    }
-    switch(psShape->type) {
-      case(MS_SHAPE_POINT):
-        psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
-        xmlSetNs(psNode, psNsMs);
-        if (psShape->line[0].numpoints > 1) {
-          psPointNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiPoint", NULL);
-          xmlSetNs(psPointNode, psNsGml);
-
-          if (pszEpsg)
-            xmlNewProp(psPointNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-        } else
-          psPointNode= psNode;
-
-        /*add all points */
-        for(i=0; i<psShape->line[0].numpoints; i++) {
-          psNode = xmlAddChild(psPointNode, msGML3Point(psNsGml, pszEpsg, NULL, psShape->line[0].point[i].x, psShape->line[0].point[i].y));
-        }
-        break;
-
-      case(MS_SHAPE_LINE):
-        psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
-        xmlSetNs(psNode,xmlNewNs(psNode, NULL,  NULL));
-        if (psShape->numlines > 1) {
-          psLineNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiLineString", NULL);
-          xmlSetNs(psLineNode,xmlNewNs(psLineNode,
-                                       BAD_CAST "http://www.opengis.net/gml",
-                                       BAD_CAST "gml"));
-
-          if (pszEpsg)
-            xmlNewProp(psLineNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-        } else
-          psLineNode= psNode;
-
-        for(i=0; i<psShape->numlines; i++) {
-          if (psShape->numlines > 1) {
-            psNode = xmlNewChild(psLineNode, NULL, BAD_CAST "lineStringMember", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode,
-                                     BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-            psNode = xmlNewChild(psNode, NULL, BAD_CAST "LineString", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode,
-                                     BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          } else {
-            psNode = xmlNewChild(psLineNode, NULL, BAD_CAST "LineString", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode,
-                                     BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          }
-          if (pszEpsg)
-            xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-
-          pszTmp = NULL;
-          for(j=0; j<psShape->line[i].numpoints; j++) {
-            char *doubleTmp = msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, ",");
-            free(doubleTmp);
-            doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, ",");
-            free(doubleTmp);
-          }
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
-          xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-          free(pszTmp);
-        }
-
-        break;
-
-      case(MS_SHAPE_POLYGON):
-        psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
-        xmlSetNs(psNode,xmlNewNs(psNode, NULL,  NULL));
-        if (psShape->numlines > 1) {
-          psPolygonNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiPolygon", NULL);
-          xmlSetNs(psPolygonNode,
-                   xmlNewNs(psPolygonNode, BAD_CAST "http://www.opengis.net/gml",
-                            BAD_CAST "gml"));
-
-          if (pszEpsg)
-            xmlNewProp(psPolygonNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-        } else
-          psPolygonNode= psNode;
-
-        panOuterList = msGetOuterList(psShape);
-
-        for(i=0; i<psShape->numlines; i++) {
-          if(panOuterList[i] != MS_TRUE)
-            continue;
-
-          panInnerList = msGetInnerList(psShape, i, panOuterList);
-
-          if (psShape->numlines > 1) {
-            psNode = xmlNewChild(psPolygonNode, NULL, BAD_CAST "polygonMember", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-            psNode = xmlNewChild(psNode, NULL, BAD_CAST "Polygon", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          } else {
-            psNode = xmlNewChild(psPolygonNode, NULL, BAD_CAST "Polygon", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          }
-          if (pszEpsg)
-            xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
-          xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                   BAD_CAST "gml"));
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "LinearRing", NULL);
-          xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                   BAD_CAST "gml"));
-
-          pszTmp = NULL;
-          for(j=0; j<psShape->line[i].numpoints; j++) {
-            char *doubleTmp;
-            doubleTmp = msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, ",");
-            free(doubleTmp);
-            doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, " ");
-            free(doubleTmp);
-          }
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
-          xmlSetNs(psNode,xmlNewNs(psNode,
-                                   BAD_CAST "http://www.opengis.net/gml",
-                                   BAD_CAST "gml"));
-          free(pszTmp);
-
-          if (panInnerList)
-            free(panInnerList);
-        }
-
-        if (panOuterList)
-          free(panOuterList);
-
-        break;
-
-      default:
-        break;
-    }
-
-  }
-  msFree(pszEpsg_buf);
-
-}
-
-/************************************************************************/
-/*          void msSOSAddDataBlockDefinition(xmlNodePtr psParent,       */
-/*      layerObj *lp)                                                   */
-/*                                                                      */
-/*      Add a databalock used for GetObservation request.               */
-/************************************************************************/
-void msSOSAddDataBlockDefinition(xmlNsPtr psNsSwe, xmlNodePtr psParent, layerObj *lp)
-{
-  xmlNodePtr psNode, psRecordNode, psCompNode, psSubNode, psEncNode;
-  const char *pszDefinition = NULL, *pszUom=NULL, *pszValue=NULL, *pszName=NULL;
-  char szTmp[100];
-  int i=0;
-  char *pszTokenValue = NULL;
-  char *pszBlockValue = NULL;
-  const char *pszBlockSep=NULL, *pszTokenSep=NULL;
-
-  if (psParent) {
-    psNode = xmlNewChild(psParent, NULL, BAD_CAST "DataBlockDefinition", NULL);
-    xmlSetNs(psNode, psNsSwe);
-
-    /* -------------------------------------------------------------------- */
-    /*      Add components.                                                 */
-    /* -------------------------------------------------------------------- */
-    psCompNode = xmlNewChild(psNode, NULL, BAD_CAST "components", NULL);
-    psEncNode = xmlNewChild(psNode, NULL, BAD_CAST "encoding", NULL);
-    psRecordNode = xmlNewChild(psCompNode, NULL, BAD_CAST "DataRecord", NULL);
-
-    /*always add a time field if timeitem is defined*/
-    if (msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem")) {
-      psNode = xmlNewChild(psRecordNode, NULL, BAD_CAST "field", NULL);
-      xmlNewNsProp(psNode, NULL, BAD_CAST "name", BAD_CAST "time");
-      psNode = xmlNewChild(psNode, NULL, BAD_CAST "Time", NULL);
-      xmlNewNsProp(psNode, NULL, BAD_CAST "definition", BAD_CAST "urn:ogc:phenomenon:time:iso8601");
-    }
-    /*add all other fields*/
-    /*assuming that the layer is open */
-    for(i=0; i<lp->numitems; i++) {
-      snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
-      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
-      if (pszValue) {
-        psNode = xmlNewChild(psRecordNode, NULL, BAD_CAST "field", NULL);
-
-        /* check if there is an alias/full name used */
-        snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
-        pszName = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
-        if (!pszName)
-          pszName = lp->items[i];
-
-        xmlNewNsProp(psNode, NULL, BAD_CAST "name", BAD_CAST pszName);
-
-        psNode = xmlNewChild(psNode, NULL, BAD_CAST "Quantity", NULL);
-
-        /* get definition and uom */
-        snprintf(szTmp, sizeof(szTmp), "%s_definition", lp->items[i]);
-        pszDefinition =  msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
-
-        if (pszDefinition == NULL)
-          pszDefinition = "urn:ogc:object:definition";
-
-        xmlNewNsProp(psNode, NULL, BAD_CAST "definition", BAD_CAST pszDefinition);
-
-        snprintf(szTmp, sizeof(szTmp), "%s_uom", lp->items[i]);
-        pszUom =  msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
-
-        if (pszUom == NULL)
-          pszUom = "urn:ogc:object:uom";
-
-        psNode = xmlNewChild(psNode, NULL, BAD_CAST "uom", NULL);
-        xmlNewNsProp(psNode, NULL, BAD_CAST "code", BAD_CAST pszUom);
-
-      }
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Add encoding block.                                             */
-    /* -------------------------------------------------------------------- */
-    pszBlockSep = msOWSLookupMetadata(&(lp->map->web.metadata), "S",
-                                      "encoding_blockSeparator");
-    pszTokenSep = msOWSLookupMetadata(&(lp->map->web.metadata), "S",
-                                      "encoding_tokenSeparator");
-
-    psSubNode = xmlNewChild(psEncNode, NULL, BAD_CAST "TextBlock", NULL);
-
-    if (pszTokenSep)
-      pszTokenValue = msStringConcatenate(pszTokenValue, (char *)pszTokenSep);
-    else
-      pszTokenValue = msStringConcatenate(pszTokenValue, ",");
-
-    xmlNewNsProp(psSubNode, NULL, BAD_CAST "tokenSeparator", BAD_CAST pszTokenValue);
-
-    if (pszBlockSep)
-      pszBlockValue = msStringConcatenate(pszBlockValue, (char *)pszBlockSep);
-    else
-      pszBlockValue = msStringConcatenate(pszBlockValue, "\n");
-
-    xmlNewNsProp(psSubNode, NULL, BAD_CAST "blockSeparator", BAD_CAST pszBlockValue);
-
-    xmlNewNsProp(psSubNode, NULL, BAD_CAST "decimalSeparator", BAD_CAST ".");
-
-    msFree(pszTokenValue);
-    msFree(pszBlockValue);
-  }
-}
-
-/************************************************************************/
-/*                            msSOSAddMemberNode                        */
-/*                                                                      */
-/*      Add a memeber node corresponding to a feature.                  */
-/*      Assuming that the layer is opened and msLayerGetItems is        */
-/*      called on it.                                                   */
-/************************************************************************/
-void msSOSAddMemberNode(xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe, xmlNsPtr psNsXLink, xmlNsPtr psNsMs, xmlNodePtr psParent, mapObj *map, layerObj *lp,
-                        int iFeatureId, const char *script_url, const char *opLayerName)
-{
-  xmlNodePtr psObsNode, psNode, psLayerNode = NULL;
-  const char *pszValue = NULL;
-  char *pszEpsg = NULL;
-  int status,i,j;
-  shapeObj sShape;
-  char szTmp[256];
-  layerObj *lpfirst = NULL;
-  const char *pszTimeField = NULL;
-  char *pszTmp = NULL;
-  char *pszOid = NULL;
-  char *pszTime = NULL;
-  char *pszValueShape = NULL;
-  const char *pszFeatureId  = NULL;
-
-  if (psParent) {
-    msInitShape(&sShape);
-
-    status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
-    if(status != MS_SUCCESS) {
-      xmlFreeNs(psNsOm);
-      return;
-    }
-
-    psNode = xmlNewChild(psParent, NULL, BAD_CAST "member", NULL);
-
-    psObsNode = xmlNewChild(psNode, NULL, BAD_CAST "Observation", BAD_CAST pszValue);
-
-    pszFeatureId = msOWSLookupMetadata(&(lp->metadata), "OSG", "featureid");
-
-    if(pszFeatureId && msLayerGetItems(lp) == MS_SUCCESS) {
-      /* find the featureid amongst the items for this layer */
-      for(j=0; j<lp->numitems; j++) {
-        if(strcasecmp(lp->items[j], pszFeatureId) == 0) { /* found it  */
-          break;
-        }
-      }
-      if (j<lp->numitems) {
-        pszOid = msStringConcatenate(pszOid, "o_");
-        pszOid = msStringConcatenate(pszOid, sShape.values[j]);
-        xmlNewNsProp(psObsNode, psNsGml, BAD_CAST "id", BAD_CAST pszOid);
-      }
-    }
-
-    /* order of elements is time, location, procedure, observedproperty
-     featureofinterest, result */
-
-    /* time*/
-    pszTimeField =  msOWSLookupMetadata(&(lp->metadata), "SO",
-                                        "timeitem");
-    if (pszTimeField && sShape.values) {
-      for(i=0; i<lp->numitems; i++) {
-        if (strcasecmp(lp->items[i], pszTimeField) == 0) {
-          if (sShape.values[i] && strlen(sShape.values[i]) > 0) {
-            pszTime = msStringConcatenate(pszTime, sShape.values[i]);
-            psNode = xmlNewChild(psObsNode, psNsOm, BAD_CAST "samplingTime", NULL);
-            xmlAddChild(psNode, msGML3TimeInstant(psNsGml, pszTime));
-            msFree(pszTime);
-          }
-          break;
-        }
-      }
-    }
-    /*TODO add location*/
-
-    /*procedure*/
-    /* if a procedure_item is defined, we should extract the value for the
-       attributes. If not dump what is found in the procedure metadata bug 2054*/
-    if ((pszValue =  msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))) {
-      lpfirst = msSOSGetFirstLayerForOffering(map,
-                                              msOWSLookupMetadata(&(lp->metadata), "S",
-                                                  "offering_id"),
-                                              msOWSLookupMetadata(&(lp->metadata), "S",
-                                                  "observedproperty_id"));
-
-      if (lp != lpfirst)
-        status = msLayerOpen(lpfirst);
-      if (status == MS_SUCCESS && msLayerGetItems(lpfirst) == MS_SUCCESS) {
-        for(i=0; i<lpfirst->numitems; i++) {
-          if (strcasecmp(lpfirst->items[i], pszValue) == 0) {
-            break;
-          }
-        }
-        if (i < lpfirst->numitems) {
-          snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
-          pszTmp = msStringConcatenate(pszTmp, szTmp);
-          pszValueShape = msEncodeHTMLEntities(sShape.values[i]);
-          pszTmp = msStringConcatenate(pszTmp, pszValueShape);
-
-          psNode =  xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
-          xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
-          msFree(pszTmp);
-          pszTmp = NULL;
-          msFree(pszValueShape);
-        }
-        /*else should we generate a warning !*/
-        if (lp != lpfirst)
-          msLayerClose(lpfirst);
-      }
-
-    } else if ((pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))) {
-      if (! msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))
-        xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_procedure_item\" missing for sos:procedure.  If you have more than 1 procedures, sos:procedure will output them incorrectly."));
-
-      snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
-      pszTmp = msStringConcatenate(pszTmp, szTmp);
-      pszTmp = msStringConcatenate(pszTmp, (char *)pszValue);
-
-      psNode =  xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
-      xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
-      msFree(pszTmp);
-      pszTmp = NULL;
-    }
-
-    /*observed property*/
-    pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
-                                   "observedproperty_id");
-    if (pszValue)
-      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lp, psNsGml, pszOid);
-    msFree(pszOid);
-    pszOid = NULL;
-
-    /*TODO add featureofinterest*/
-
-    pszTmp = msStringConcatenate(pszTmp, (char *) script_url);
-    pszTmp = msStringConcatenate(pszTmp, "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
-    pszTmp = msStringConcatenate(pszTmp, (char *) opLayerName);
-
-    psNode =  xmlNewChild(psObsNode, psNsOm, BAD_CAST "featureOfInterest", NULL);
-    xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
-
-    msFree(pszTmp);
-    pszTmp=NULL;
-
-    /* add result : gml:featureMember of all selected elements */
-    psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "result", NULL);
-
-    /*TODO should we add soemwhere the units of the value :
-      <om:result uom="units.xml#cm">29.00</om:result> */
-
-
-    if(msProjectionsDiffer(&(lp->projection), &(map->projection)))
-    {
-      if( lp->reprojectorLayerToMap == NULL )
-      {
-        lp->reprojectorLayerToMap = msProjectCreateReprojector(
-            &lp->projection, &map->projection);
-      }
-      if( lp->reprojectorLayerToMap )
-      {
-        msProjectShapeEx(lp->reprojectorLayerToMap, &sShape);
-      }
-    }
-
-    psNode = xmlNewChild(psNode, psNsGml, BAD_CAST "featureMember", NULL);
-    /* xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml")); */
-
-    /*TODO : add namespaces like wfs " ms and a url to mapserve ? */
-    psLayerNode = xmlNewChild(psNode, psNsMs, BAD_CAST lp->name, NULL);
-
-    /* fetch gml:id */
-
-    pszFeatureId = msOWSLookupMetadata(&(lp->metadata), "OSG", "featureid");
-
-    if(pszFeatureId && msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS)
-
-      xmlSetNs(psLayerNode,psNsMs);
-
-    /*bbox*/
-
-    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE, &pszEpsg);
-    if (!pszEpsg)
-      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "SO", MS_TRUE, &pszEpsg);
-
-    if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE)
-      msProjectRect(&lp->projection, &map->projection, &sShape.bounds);
-
-    psNode = xmlAddChild(psLayerNode, msGML3BoundedBy(psNsGml, sShape.bounds.minx, sShape.bounds.miny, sShape.bounds.maxx, sShape.bounds.maxy, pszEpsg));
-
-    /*geometry*/
-    msSOSAddGeometryNode(psNsGml, psNsMs, psLayerNode, map, lp, &sShape, pszEpsg);
-    msFree(pszEpsg);
-
-    /*attributes */
-    /* TODO only output attributes where there is a sos_%s_alias (to be discussed)*/
-    /* the first layer is the one that has to have all the metadata defined */
-    lpfirst = msSOSGetFirstLayerForOffering(map,
-                                            msOWSLookupMetadata(&(lp->metadata), "S",
-                                                "offering_id"),
-                                            msOWSLookupMetadata(&(lp->metadata), "S",
-                                                "observedproperty_id"));
-
-    if (lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
-        msLayerGetItems(lpfirst) == MS_SUCCESS) {
-      for(i=0; i<lpfirst->numitems; i++) {
-        snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
-        pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
-        if (pszValue) {
-          for (j=0; j<lp->numitems; j++) {
-            if (strcasecmp(lpfirst->items[i],  lpfirst->items[j]) == 0) {
-              /*if there is an alias used, use it to output the
-                parameter name : eg "sos_AMMON_DIS_alias" "Amonia"  */
-              snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
-              pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
-              pszValueShape = msEncodeHTMLEntities(sShape.values[j]);
-
-              if (pszValue) {
-                pszTmp = msEncodeHTMLEntities(pszValue);
-                psNode = xmlNewChild(psLayerNode, psNsMs, BAD_CAST pszValue,
-                                     BAD_CAST pszValueShape);
-                free(pszTmp);
-              } else {
-                pszTmp = msEncodeHTMLEntities(lpfirst->items[i]);
-                psNode = xmlNewChild(psLayerNode, psNsMs,
-                                     BAD_CAST lpfirst->items[i],
-                                     BAD_CAST pszValueShape);
-                free(pszTmp);
-              }
-
-              free(pszValueShape);
-              xmlSetNs(psNode,psNsMs);
-              break;
-            }
-          }
-        }
-      }
-      if (lp->index != lpfirst->index)
-        msLayerClose(lpfirst);
-    }
-    msFreeShape(&sShape);
-  }
-}
-
-/************************************************************************/
-/*                           msSOSReturnMemberResult                    */
-/*                                                                      */
-/*      Add a result string to the result node (used for                */
-/*      GetObservation using "observation" as the response output.      */
-/*      Assuming here that the layer is already opened.                 */
-/************************************************************************/
-char* msSOSReturnMemberResult(layerObj *lp, int iFeatureId, char **ppszProcedure)
-{
-  char *pszFinalValue = NULL;
-  shapeObj sShape;
-  int i, j, status;
-  layerObj *lpfirst;
-  const char *pszTimeField = NULL, *pszValue=NULL, *pszProcedureField=NULL;
-  char *pszValueShape = NULL;
-  char szTmp[100];
-  const char *pszSep=NULL;
-
-  msInitShape(&sShape);
-  status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
-  if(status != MS_SUCCESS)
-    return NULL;
-
-  pszTimeField =  msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem");
-  if (pszTimeField && sShape.values) {
-    for(i=0; i<lp->numitems; i++) {
-      if (strcasecmp(lp->items[i], pszTimeField) == 0) {
-        pszFinalValue = msStringConcatenate(pszFinalValue,  sShape.values[i]);
-        break;
-      }
-    }
-  }
-  if (ppszProcedure && sShape.values) {
-    pszProcedureField = msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item");
-    for(i=0; i<lp->numitems; i++) {
-      if (strcasecmp(lp->items[i], pszProcedureField) == 0) {
-        (*ppszProcedure) = msStrdup( sShape.values[i]);
-        break;
-      }
-    }
-  }
-
-  /* the first layer is the one that has to have all the metadata defined */
-  lpfirst = msSOSGetFirstLayerForOffering(lp->map,
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "offering_id"),
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "observedproperty_id"));
-
-
-  if (sShape.values &&
-      (lp == lpfirst || (lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
-                        msLayerGetItems(lpfirst) == MS_SUCCESS))) {
-    pszSep = msOWSLookupMetadata(&(lp->map->web.metadata), "S",
-                                 "encoding_tokenSeparator");
-    for(i=0; i<lpfirst->numitems; i++) {
-      snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
-      pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
-      if (pszValue) {
-        for (j=0; j<lp->numitems; j++) {
-          if (strcasecmp(lpfirst->items[i],  lpfirst->items[j]) == 0) {
-            pszValueShape = msEncodeHTMLEntities(sShape.values[j]);
-
-
-            if (pszFinalValue) {
-              if (pszSep)
-                pszFinalValue = msStringConcatenate(pszFinalValue, (char *)pszSep);
-              else
-                pszFinalValue = msStringConcatenate(pszFinalValue, ",");
-            }
-            pszFinalValue = msStringConcatenate(pszFinalValue,  pszValueShape);
-
-            msFree(pszValueShape);
-          }
-        }
-      }
-    }
-  }
-  msFreeShape(&sShape);
-  return pszFinalValue;
-}
-
-/************************************************************************/
-/*                      msSOSAddMemberNodeObservation                   */
-/*                                                                      */
-/*      Add a member node used for getObservation request using         */
-/*      Observation as the result format.                               */
-/************************************************************************/
-static
-xmlNodePtr msSOSAddMemberNodeObservation(xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe, xmlNsPtr psNsXLink, xmlNodePtr psParent, mapObj *map, layerObj *lp, const char *pszProcedure)
-{
-  char *pszTmp = NULL;
-  xmlNodePtr psNode=NULL, psObsNode=NULL, psMemberNode=NULL;
-  layerObj *lpfirst;
-  const char *value = NULL;
-
-  /*always featch the first layer that has the same offering id and observered propery.
-   This allows to only define all the attributes and components on the first layer if the user
-  wants to present several mapserver layers as the same offering.*/
-  lpfirst = msSOSGetFirstLayerForOffering(map,
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "offering_id"),
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "observedproperty_id"));
-  if (psParent) {
-    psMemberNode = xmlNewChild(psParent, NULL, BAD_CAST "member", NULL);
-    psObsNode = xmlNewChild(psMemberNode, NULL, BAD_CAST "Observation", NULL);
-
-    /*time*/
-    /* ??TODO : sampling time is a manadatory element but uses a non mandatory metadata sos_offering_timeextent */
-    value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_timeextent");
-    if (value) {
-      char **tokens;
-      int n;
-      char *pszEndTime = NULL;
-      tokens = msStringSplit(value, '/', &n);
-      if (tokens==NULL || (n != 1 && n!=2)) {
-        msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_timeextent.",
-                   "msSOSGetObservation()");
-        msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
-        return NULL;
-      }
-
-      if (n == 2) /* end time is empty. It is going to be set as "now*/
-        pszEndTime = tokens[1];
-
-      psNode = xmlAddChild(psObsNode, msSOSAddTimeNode(psNsOm, psNsGml, tokens[0], pszEndTime));
-      msFreeCharArray(tokens, n);
-
-    }
-
-    /* procedure */
-    if (pszProcedure) { /*this should always be true since procedure is a manadtory element*/
-      if (! msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item") && msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))
-        xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_procedure_item\" missing for sos:procedure.  If you have more than 1 procedures, sos:procedure will output them incorrectly."));
-
-      pszTmp = msStringConcatenate(pszTmp, "urn:ogc:def:procedure:");
-      pszTmp = msStringConcatenate(pszTmp, (char *)pszProcedure);
-      psNode =  xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
-      /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST "href", BAD_CAST pszTmp); */
-      xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
-      msFree(pszTmp);
-      pszTmp = NULL;
-    }
-
-    /*observed propery and components*/
-    if (lp != lpfirst &&
-        msLayerOpen(lpfirst) == MS_SUCCESS && msLayerGetItems(lpfirst) == MS_SUCCESS) {
-      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml, NULL);
-      msLayerClose(lpfirst);
-    } else
-      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml, NULL);
-
-    /* result definition*/
-    psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "resultDefinition", NULL);
-    msSOSAddDataBlockDefinition(psNsSwe, psNode, lpfirst);
-
-  }
-
-  return psObsNode;
-}
-
-/************************************************************************/
-/*                            msSOSParseTimeGML                         */
-/*                                                                      */
-/*      Utility function to convert a gml time value to a               */
-/*      string. Supported gml times are :                               */
-/*                                                                      */
-/*       -  <gml:TimePeriod>                                            */
-/*           <gml:beginPosition>2005-09-01T11:54:32</gml:beginPosition> */
-/*            <gml:endPosition>2005-09-02T14:54:32</gml:endPosition>    */
-/*          </gml:TimePeriod>                                           */
-/*        This will be converted to startime/endtime                    */
-/*                                                                      */
-/*       - <gml:TimeInstant>                                            */
-/*           <gml:timePosition>2003-02-13T12:28-08:00</gml:timePosition>*/
-/*           </gml:TimeInstant>                                         */
-/*       This will retunr the timevalue as a string.                    */
-/*                                                                      */
-/*       The caller of the function should free the return value.       */
-/************************************************************************/
-char *msSOSParseTimeGML(char *pszGmlTime)
-{
-  char *pszReturn = NULL, *pszBegin = NULL, *pszEnd = NULL;
-  CPLXMLNode *psRoot=NULL, *psChild=NULL;
-  CPLXMLNode *psTime=NULL, *psBegin=NULL, *psEnd=NULL;
-  struct tm tm_struct;
-
-  if (pszGmlTime) {
-    psRoot = CPLParseXMLString(pszGmlTime);
-    if(!psRoot)
-      return NULL;
-    CPLStripXMLNamespace(psRoot, "gml", 1);
-
-    if (psRoot->eType == CXT_Element &&
-        (EQUAL(psRoot->pszValue,"TimePeriod") ||
-         EQUAL(psRoot->pszValue,"TimeInstant"))) {
-      if (EQUAL(psRoot->pszValue,"TimeInstant")) {
-        psChild = psRoot->psChild;
-        if (psChild && EQUAL(psChild->pszValue,"timePosition")) {
-          psTime = psChild->psNext;
-          if (psTime && psTime->pszValue && psTime->eType == CXT_Text) {
-            if (msParseTime(psTime->pszValue, &tm_struct) == MS_TRUE)
-              pszReturn = msStrdup(psTime->pszValue);
-          }
-        }
-      } else {
-        psBegin = psRoot->psChild;
-        if (psBegin)
-          psEnd = psBegin->psNext;
-
-        if (psBegin && EQUAL(psBegin->pszValue, "beginPosition") &&
-            psEnd && EQUAL(psEnd->pszValue, "endPosition")) {
-          if (psBegin->psChild && psBegin->psChild->pszValue &&
-              psBegin->psChild->eType == CXT_Text)
-            pszBegin = msStrdup( psBegin->psChild->pszValue);
-
-          if (psEnd->psChild && psEnd->psChild->pszValue &&
-              psEnd->psChild->eType == CXT_Text)
-            pszEnd = msStrdup(psEnd->psChild->pszValue);
-
-          if (pszBegin && pszEnd) {
-            if (msParseTime(pszBegin, &tm_struct) == MS_TRUE &&
-                msParseTime(pszEnd, &tm_struct) == MS_TRUE) {
-              pszReturn = msStrdup(pszBegin);
-              pszReturn = msStringConcatenate(pszReturn, "/");
-              pszReturn = msStringConcatenate(pszReturn, pszEnd);
-            }
-          }
-          msFree(pszBegin);
-          msFree(pszEnd);
-        }
-      }
-    }
-  }
-  CPLDestroyXMLNode(psRoot);
-  return pszReturn;
-}
-
-
-/************************************************************************/
-/*                           msSOSGetCapabilities                       */
-/*                                                                      */
-/*      getCapabilities request handler.                                */
-/************************************************************************/
-int msSOSGetCapabilities(mapObj *map, sosParamsObj *sosparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
-  xmlNodePtr psRootNode, psMainNode, psNode;
-  xmlNodePtr psOfferingNode;
-
-  char *schemalocation = NULL;
-  char *xsi_schemaLocation = NULL;
-  char *script_url=NULL;
-  const char *updatesequence=NULL;
-
-  int i,j,k;
-  layerObj *lp = NULL, *lpTmp = NULL;
-  const char *value = NULL;
-  char *pszTmp = NULL;
-  char *pszProcedure = NULL;
-  char szTmp[256];
-
-  /* array of offering */
-  char **papsOfferings = NULL;
-  int nOfferings  =0, nCurrentOff = -1;
-  int nProperties = 0;
-  char **papszProperties = NULL;
-
-  int iItemPosition = -1;
-  shapeObj sShape;
-  int status;
-
-  /* for each layer it indicates the indice to be used in papsOfferings
-     (to associate it with the offering) */
-  int *panOfferingLayers = NULL;
-
-  char **papsProcedures = NULL;
-  int nDistinctProcedures =0;
-
-  xmlNsPtr psNsGml = NULL;
-  xmlNsPtr psNsSos = NULL;
-  xmlNsPtr psNsOws = NULL;
-  xmlNsPtr psNsOgc = NULL;
-  xmlNsPtr psNsXLink = NULL;
-  xmlNsPtr psNsSwe = NULL;
-
-  xmlChar *buffer = NULL;
-  int size = 0;
-  msIOContext *context = NULL;
-
-  int ows_version = OWS_1_1_0;
-
-  int sosSupportedVersions[] = {OWS_1_0_0};
-  int sosNumSupportedVersions = 1;
-
-  /* acceptversions: do OWS Common style of version negotiation */
-  if (sosparams->pszAcceptVersions) {
-    char **tokens;
-    int i, j, k=-1;
-
-    tokens = msStringSplit(sosparams->pszAcceptVersions, ',', &j);
-
-    for (i=0; i<j; i++) {
-      int iVersion = 0;
-
-      iVersion = msOWSParseVersionString(tokens[i]);
-
-      if (iVersion == -1) {
-        msSetError(MS_SOSERR, "Invalid version format : %s.", "msSOSGetCapabilities()", tokens[i]);
-        msFreeCharArray(tokens, j);
-        return msSOSException(map, "acceptversions", "VersionNegotiationFailed");
-      }
-
-      /* negotiate version */
-      k = msOWSCommonNegotiateVersion(iVersion, sosSupportedVersions, sosNumSupportedVersions);
-
-      if (k != -1)
-        break;
-    }
-    msFreeCharArray(tokens, j);
-
-    if(k == -1) {
-      msSetError(MS_SOSERR, "ACCEPTVERSIONS list (%s) does not match supported versions (%s)", "msSOSGetCapabilities()", sosparams->pszAcceptVersions, pszSOSVersion);
-      return msSOSException(map, "acceptversions", "VersionNegotiationFailed");
-    }
-  }
-
-  /* updateSequence */
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "SO", "updatesequence");
-
-  if (sosparams->pszUpdateSequence != NULL) {
-    i = msOWSNegotiateUpdateSequence(sosparams->pszUpdateSequence, updatesequence);
-    if (i == 0) { /* current */
-      msSetError(MS_SOSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msSOSGetCapabilities()", sosparams->pszUpdateSequence, updatesequence);
-      return msSOSException(map, "updatesequence", "CurrentUpdateSequence");
-    }
-    if (i > 0) { /* invalid */
-      msSetError(MS_SOSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msSOSGetCapabilities()", sosparams->pszUpdateSequence, updatesequence);
-      return msSOSException(map, "updatesequence", "InvalidUpdateSequence");
-    }
-  }
-
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "Capabilities");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  psNsGml = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
-  psNsSos = xmlNewNs(NULL, BAD_CAST pszSOSNamespaceUri, BAD_CAST pszSOSNamespacePrefix);
-  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
-  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe");
-
-  /* name spaces */
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0", BAD_CAST "om"));
-
-  psNsOws = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-  xmlSetNs(psRootNode, psNsOws );
-
-  xmlSetNs(psRootNode,xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe"));
-
-  psNsXLink = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlSetNs(psRootNode, psNsXLink );
-
-  xmlSetNs(psRootNode,xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri, BAD_CAST pszSOSNamespacePrefix));
-
-  /*version fixed for now*/
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST pszSOSVersion);
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "SO", "updatesequence");
-
-  if (value)
-    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST value);
-
-  /*schema fixed*/
-  schemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-  xsi_schemaLocation = msStrdup(pszSOSNamespaceUri);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/sos/");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)pszSOSVersion);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/sosGetCapabilities.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-
-  /*service identification*/
-  xmlAddChild(psRootNode, msOWSCommonServiceIdentification(psNsOws, map, "SOS", pszSOSVersion, "SO", NULL));
-
-  /*service provider*/
-  xmlAddChild(psRootNode, msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "SO", NULL));
-
-  /*operation metadata */
-
-  if ((script_url=msOWSGetOnlineResource(map, "SO", "onlineresource", req)) == NULL)
-  {
-    free(xsi_schemaLocation);
-    free(schemalocation);
-    return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
-  }
-
-  psMainNode = xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psNsOws));
-
-  psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetCapabilities", OWS_METHOD_GETPOST, (char *) script_url));
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
-
-  if (msOWSRequestIsEnabled(map, NULL, "S", "DescribeSensor", MS_TRUE)) {
-    psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeSensor", OWS_METHOD_GETPOST, (char *) script_url));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "sensorid", "urn:ogc:object:procedure"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "outputFormat", (char *)pszSOSDescribeSensorMimeType));
-  }
-
-  if (msOWSRequestIsEnabled(map, NULL, "S", "DescribeObservationType", MS_TRUE)) {
-    psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeObservationType", OWS_METHOD_GETPOST, (char *) script_url));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "observedproperty", "urn:ogc:object:observedproperty"));
-  }
-
-  if (msOWSRequestIsEnabled(map, NULL, "S", "GetObservation", MS_TRUE)) {
-    psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetObservation", OWS_METHOD_GETPOST, (char *) script_url));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "offering", "urn:ogc:object:offering"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "observedproperty", "urn:ogc:object:observedproperty"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "eventtime", "sos:time"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "procedure", "urn:ogc:object:sensor"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "featureofinterest", "gml:location"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "result", "ogc:Filter"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "responseFormat", (char *)pszSOSGetObservationMimeType));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "resultModel", "Observation,Measurement"));
-  }
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "SO", "maxfeatures");
-
-  if (value) {
-    psNode  = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Constraint", "DefaultMaxFeatures", (char *)value));
-  }
-
-  /*<ogc:Filter_Capabilities> */
-  xmlAddChild(psRootNode, FLTGetCapabilities(psNsSos, psNsOgc, MS_TRUE));
-
-  /*Offerings */
-  psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Contents", NULL);
-  psMainNode = xmlNewChild(psNode, NULL, BAD_CAST "ObservationOfferingList", NULL);
-
-  /*go through the layers and check for metadata sos_offering_id.
-    One or more layers could have the same offering id. In that case they
-    are adverized as the same offering. The first layer that has*/
-
-  if (map->numlayers) {
-    papsOfferings = (char **)malloc(sizeof(char *)*map->numlayers);
-    panOfferingLayers = (int *)malloc(sizeof(int)*map->numlayers);
-    for (i=0; i<map->numlayers; i++)
-      panOfferingLayers[i] = -1;
-
-    for (i=0; i<map->numlayers; i++) {
-      lp = (GET_LAYER(map, i));
-
-      if (lp->status == MS_DELETE)
-        continue;
-
-      value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_id");
-      if (value && (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers))) {
-        nCurrentOff = -1;
-        for (j=0; j<nOfferings; j++) {
-          if (strcasecmp(value, papsOfferings[j]) == 0) {
-            nCurrentOff = j;
-            break;
-          }
-        }
-        if (nCurrentOff >= 0) /* existing offering */
-          panOfferingLayers[i] = nCurrentOff;
-        else { /*new offering */
-          papsOfferings[nOfferings] = msStrdup(value);
-          panOfferingLayers[i] = nOfferings;
-          nOfferings++;
-        }
-      }
-    }
-
-    if (nOfferings > 0) {
-      for (i=0; i<nOfferings; i++) {
-        psOfferingNode =
-          xmlNewChild(psMainNode, NULL,BAD_CAST "ObservationOffering", NULL);
-        xmlNewNsProp(psOfferingNode, psNsGml,
-                     BAD_CAST "id", BAD_CAST papsOfferings[i]);
-        for (j=0; j<map->numlayers; j++) {
-          if (panOfferingLayers[j] == i) /*first layer of the offering */
-            break;
-        }
-
-        lp = (GET_LAYER(map, j));
-
-        /*description*/
-        value = msOWSLookupMetadata(&(lp->metadata), "S",
-                                    "offering_description");
-        if (value)
-          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "description", BAD_CAST value);
-        else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_offering_description\" missing for gml:description"));
-
-        /*name*/
-        value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_name");
-        if (value)
-          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "name", BAD_CAST value);
-        else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_offering_name\" missing for gml:name"));
-
-        /* srsName */
-        value = msOWSLookupMetadata(&(map->web.metadata), "SO", "srs");
-
-        if (value)
-          msLibXml2GenerateList(psOfferingNode, psNsGml, "srsName", value, ' ');
-        else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Required metadata \"sos_srs\" missing for gml:srsName"));
-
-        /*bounding box */
-        /*TODO : if sos_offering_extent does not exist compute extents
-                 Check also what happen if epsg not present */
-        value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_extent");
-        if (value) {
-          char **tokens,*pszLayerEPSG;
-          int n;
-          tokens = msStringSplit(value, ',', &n);
-          if (tokens==NULL || n != 4) {
-            msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_extent.",
-                       "msSOSGetCapabilities()");
-            return msSOSException(map, "sos_offering_extent", "InvalidParameterValue");
-          }
-          msOWSGetEPSGProj(&(lp->projection),&(lp->metadata), "SO", MS_TRUE,&pszLayerEPSG);
-          if (pszLayerEPSG) {
-            psNode = xmlAddChild(psOfferingNode, msGML3BoundedBy(psNsGml, atof(tokens[0]), atof(tokens[1]), atof(tokens[2]), atof(tokens[3]), pszLayerEPSG));
-            msFree(pszLayerEPSG);
-          }
-          msFreeCharArray(tokens, n);
-
-        }
-
-        /* intended application */
-
-        value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_intendedapplication");
-
-        if (value)
-          psNode = xmlNewChild(psOfferingNode, psNsSos, BAD_CAST "intendedApplication", BAD_CAST value);
-        else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_offering_intendedapplication\" missing for sos:intendedApplication"));
-
-        /*time*/
-        value = msOWSLookupMetadata(&(lp->metadata), "S",
-                                    "offering_timeextent");
-        if (value) {
-          char **tokens;
-          int n;
-          char *pszEndTime = NULL;
-          tokens = msStringSplit(value, '/', &n);
-          if (tokens==NULL || (n != 1 && n!=2)) {
-            msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_timeextent.",
-                       "msSOSGetCapabilities()");
-            return msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
-          }
-
-          if (n == 2) /* end time is empty. It is going to be set as "now*/
-            pszEndTime = tokens[1];
-
-          psNode = xmlAddChild(psOfferingNode, msSOSAddTimeNode(psNsSos, psNsGml, tokens[0], pszEndTime));
-          msFreeCharArray(tokens, n);
-
-        }
-
-        /*procedure : output all procedure links for the offering */
-        for (j=0; j<map->numlayers; j++) {
-          if (panOfferingLayers[j] == i) {
-            value = msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata), "S",
-                                        "procedure");
-            if (value && strlen(value) > 0) {
-              /*value could be a list of procedure*/
-              char **tokens;
-              int n = 0;
-              tokens = msStringSplit(value, ' ', &n);
-              for (k=0; k<n; k++) {
-                /*TODO review the urn output */
-                snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
-                pszTmp = msStringConcatenate(pszTmp, szTmp);
-                pszTmp = msStringConcatenate(pszTmp, tokens[k]);
-
-                psNode =
-                  xmlNewChild(psOfferingNode, NULL, BAD_CAST "procedure", NULL);
-                /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST "href", BAD_CAST pszTmp); */
-                xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
-                msFree(pszTmp);
-                pszTmp = NULL;
-              }
-              msFreeCharArray(tokens, n);
-            } else if ((value = msOWSLookupMetadata(&(GET_LAYER(map,j)->metadata), "S",
-                                                    "procedure_item"))) {
-              /* if a procedure_item is used, it means that the procedure
-                 (or sensor) need to be extracted from the data. Thus we need to
-                 query the layer and get the values from each feature */
-
-
-              lpTmp = GET_LAYER(map,j);
-              if (lpTmp->template == NULL)
-                lpTmp->template = msStrdup("ttt");
-
-              map->query.type = MS_QUERY_BY_RECT;
-              map->query.mode = MS_QUERY_MULTIPLE;
-              map->query.layer = j;
-              map->query.rect = map->extent;
-              msQueryByRect(map);
-
-              /*check if the attribute specified in the procedure_item is available
-                on the layer*/
-              iItemPosition = -1;
-              if (msLayerGetItems(lpTmp) == MS_SUCCESS &&
-                  lpTmp->resultcache && lpTmp->resultcache->numresults > 0) {
-                for(k=0; k<lpTmp->numitems; k++) {
-                  if (strcasecmp(lpTmp->items[k], value) == 0) {
-                    iItemPosition = k;
-                    break;
-                  }
-                }
-                if (iItemPosition == -1) {
-                  msSetError(MS_SOSERR, "procedure_item %s could not be found on the layer %s",
-                             "msSOSGetCapabilities()", value, lpTmp->name);
-                  return msSOSException(map, "mapserv", "NoApplicableCode");
-                }
-
-                /*for each selected feature, grab the value of the prodedire_item*/
-                /* do not duplicate sensor ids if they are the same */
-
-                /*keep list of distinct procedures*/
-                papsProcedures =
-                  (char **)malloc(sizeof(char *) * lpTmp->resultcache->numresults);
-                nDistinctProcedures = 0;
-                for(k=0; k<lpTmp->resultcache->numresults; k++)
-                  papsProcedures[k] = NULL;
-
-
-                for(k=0; k<lpTmp->resultcache->numresults; k++) {
-                  msInitShape(&sShape);
-                  status = msLayerGetShape(lp, &sShape, &(lpTmp->resultcache->results[k]));
-                  if(status != MS_SUCCESS)
-                    continue;
-
-                  if (sShape.values[iItemPosition]) {
-                    pszProcedure = msStringConcatenate(pszProcedure, sShape.values[iItemPosition]);
-                    if (!_IsInList(papsProcedures, nDistinctProcedures, pszProcedure)) {
-                      papsProcedures[nDistinctProcedures] = msStrdup(pszProcedure);
-                      nDistinctProcedures++;
-                      snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
-                      pszTmp = msStringConcatenate(pszTmp, szTmp);
-                      pszTmp = msStringConcatenate(pszTmp, pszProcedure);
-
-                      psNode =
-                        xmlNewChild(psOfferingNode, NULL, BAD_CAST "procedure", NULL);
-                      xmlNewNsProp(psNode,
-                                   xmlNewNs(NULL, BAD_CAST "http://www.w3.org/1999/xlink",
-                                            BAD_CAST "xlink"), BAD_CAST "href", BAD_CAST pszTmp);
-                      msFree(pszTmp);
-                      pszTmp = NULL;
-
-                    }
-                    msFree(pszProcedure);
-                    pszProcedure = NULL;
-                  }
-                }
-                for(k=0; k<lpTmp->resultcache->numresults; k++)
-                  if (papsProcedures[k] != NULL)
-                    msFree(papsProcedures[k]);
-                msFree(papsProcedures);
-
-              } else {
-                msSetError(MS_SOSERR, "Invalid procedure %s", "msSOSGetCapabilities()", value);
-                return msSOSException(map, "procedure", "InvalidParameterValue");
-              }
-            } else {
-              msSetError(MS_SOSERR, "Mandatory metadata procedure_item could not be found on the layer %s",
-                         "msSOSGetCapabilities()", GET_LAYER(map,j)->name);
-              return msSOSException(map, "mapserv", "NoApplicableCode");
-            }
-
-          }
-        }
-        /*observed property */
-        /* observed property are equivalent to layers. We can group
-           sevaral layers using the same sos_observedproperty_id. The
-           components are the attributes. Components are exposed
-           using the metadata sos_%s_aliasl */
-
-        nProperties = 0;
-        papszProperties =
-          (char **)malloc(sizeof(char *)*map->numlayers);
-
-        for (j=0; j<map->numlayers; j++) {
-          if (panOfferingLayers[j] == i) {
-            if ((value =
-                   msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata), "S",
-                                       "observedproperty_id"))) {
-              for (k=0; k<nProperties; k++) {
-                if (strcasecmp(value, papszProperties[k]) == 0)
-                  break;
-              }
-              if (k == nProperties) { /*not found*/
-                papszProperties[nProperties] = msStrdup(value);
-                nProperties++;
-                lpTmp = GET_LAYER(map, j);
-                if (msLayerOpen(lpTmp) == MS_SUCCESS && msLayerGetItems(lpTmp) == MS_SUCCESS) {
-                  msSOSAddPropertyNode(psNsSwe, psNsXLink, psOfferingNode,
-                                       lpTmp, psNsGml, NULL);
-                  msLayerClose(lpTmp);
-                }
-              }
-            }
-          }
-        }
-        for (j=0; j<nProperties; j++)
-          free(papszProperties[j]);
-        free(papszProperties);
-
-        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "featureOfInterest", NULL);
-        xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST "urn:ogc:def:feature:OGC-SWE:3:transient");
-
-        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "responseFormat",
-                             BAD_CAST pszSOSGetObservationMimeType);
-        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "resultModel",
-                             BAD_CAST "om:Observation");
-        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "resultModel",
-                             BAD_CAST "om:Measurement");
-        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "responseMode",
-                             BAD_CAST "inline");
-
-      }/*end of offerings*/
-    }
-
-    if (papsOfferings && nOfferings > 0) {
-      for (i=0; i<nOfferings; i++)
-        msFree(papsOfferings[i]);
-    }
-    msFree(papsOfferings);
-    if(panOfferingLayers)
-      msFree(panOfferingLayers);
-
-  }/* end of offerings */
-
-  if ( msIO_needBinaryStdout() == MS_FAILURE )
-    return MS_FAILURE;
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  /*TODO* : check the encoding validity. Internally libxml2 uses UTF-8
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
-                           "SO", "encoding", OWS_NOERR,
-                           "<?xml version='1.0' encoding=\"%s\" standalone=\"no\" ?>\n",
-                           "ISO-8859-1");
-  */
-  /*xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, (encoding ? encoding : "ISO-8859-1"), 1);*/
-
-  /* xmlDocDump crashs withe the prebuild windows binaries distibutes at the libxml site???.
-   It works with locally build binaries*/
-
-  context = msIO_getHandler(stdout);
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-  msIO_contextWrite(context, buffer, size);
-  xmlFree(buffer);
-
-  /*free buffer and the document */
-  /*xmlFree(buffer);*/
-  xmlFreeDoc(psDoc);
-  xmlFreeNs(psNsGml);
-  xmlFreeNs(psNsSos);
-  xmlFreeNs(psNsOgc);
-  xmlFreeNs(psNsSwe);
-
-  free(xsi_schemaLocation);
-  free(schemalocation);
-  msFree(script_url);
-
-  /*
-   *Free the global variables that may
-   *have been allocated by the parser.
-   */
-  xmlCleanupParser();
-
-
-  return(MS_SUCCESS);
-
-
-  /*
-  nSize = sizeof(workbuffer);
-  nSize = nSize-1;*/ /* the last character for the '\0' */
-
-  /*
-  if (size > nSize)
-  {
-       iIndice = 0;
-       while ((iIndice + nSize) <= size)
-       {
-           snprintf(workbuffer, (sizeof(workbuffer)-1), "%s", buffer+iIndice );
-           workbuffer[sizeof(workbuffer)-1] = '\0';
-           msIO_printf("%s", workbuffer);
-
-           iIndice +=nSize;
-       }
-       if (iIndice < size)
-       {
-            sprintf(workbuffer, "%s", buffer+iIndice );
-            msIO_printf("%s", workbuffer);
-       }
-   }
-  else
-  {
-      msIO_printf("%s", buffer);
-  }
-  */
-}
-
-/************************************************************************/
-/*                           msSOSGetObservation                        */
-/*                                                                      */
-/*      GetObservation request handler                                  */
-/************************************************************************/
-int msSOSGetObservation(mapObj *map, sosParamsObj *sosparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  char *schemalocation = NULL;
-  char *xsi_schemaLocation = NULL;
-  const char *pszTmp = NULL, *pszTmp2 = NULL;
-  const char *user_namespace_uri = "http://mapserver.gis.umn.edu/mapserver";
-  const char *user_namespace_prefix = "ms";
-  char *script_url=NULL;
-  int i, j, k, bLayerFound = 0;
-  layerObj *lp = NULL, *lpfirst = NULL;
-  const char *pszTimeExtent=NULL, *pszTimeField=NULL, *pszValue=NULL;
-  FilterEncodingNode *psFilterNode = NULL;
-  rectObj sBbox;
-
-  xmlDocPtr psDoc = NULL;
-  xmlNodePtr psRootNode,  psNode;
-  char **tokens=NULL, **tokens1;
-  int n=0, n1=0;
-  xmlNsPtr psNsGml = NULL;
-  xmlNsPtr psNsOm = NULL;
-  xmlNsPtr psNsSwe = NULL;
-  xmlNsPtr psNsXLink = NULL;
-  xmlNsPtr psNsSos = NULL;
-  xmlNsPtr psNsMs = NULL;
-  const char *opLayerName = NULL;
-  char *pszBuffer = NULL;
-  const char *pszProcedureItem = NULL;
-  int bSpatialDB = 0;
-  xmlChar *buffer = NULL;
-  int size = 0;
-  msIOContext *context = NULL;
-  xmlNodePtr psObservationNode = NULL, psResultNode=NULL;
-  const char *pszProcedure = NULL;
-  const char *pszBlockSep=NULL;
-  int nDiffrentProc = 0;
-  SOSProcedureNode *paDiffrentProc = NULL;
-  int iItemPosition, status;
-  shapeObj sShape;
-  char* pszEscapedStr = NULL;
-
-  sBbox = map->extent;
-
-  /* establish local namespace */
-  pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SFO", "namespace_uri");
-
-  if(pszTmp) user_namespace_uri = pszTmp;
-
-  pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SFO", "namespace_prefix");
-  if(pszTmp) user_namespace_prefix = pszTmp;
-
-  /* validates mandatory request elements */
-  if (!sosparams->pszOffering) {
-    msSetError(MS_SOSERR, "Missing OFFERING parameter.", "msSOSGetObservation()");
-    return msSOSException(map, "offering", "MissingParameterValue");
-  }
-
-  if (!sosparams->pszObservedProperty) {
-    msSetError(MS_SOSERR, "Missing OBSERVEDPROPERTY parameter.", "msSOSGetObservation()");
-    return msSOSException(map, "observedproperty", "MissingParameterValue");
-  }
-
-  if (!sosparams->pszResponseFormat) {
-    msSetError(MS_SOSERR, "Missing RESPONSEFORMAT parameter.", "msSOSGetObservation()");
-    return msSOSException(map, "responseformat", "MissingParameterValue");
-  }
-
-  if (strcasecmp(sosparams->pszResponseFormat, pszSOSGetObservationMimeType) != 0) {
-    msSetError(MS_SOSERR, "Invalid RESPONSEFORMAT parameter %s.  Allowable values are: %s", "msSOSGetObservation()", sosparams->pszResponseFormat, pszSOSGetObservationMimeType);
-    return msSOSException(map, "responseformat", "InvalidParameterValue");
-  }
-
-  if (sosparams->pszResponseMode && strcasecmp(sosparams->pszResponseMode, "inline") != 0) {
-    msSetError(MS_SOSERR, "Invalid RESPONSEMODE parameter %s.  Allowable values are: \"inline\"", "msSOSGetObservation()", sosparams->pszResponseMode);
-    return msSOSException(map, "responsemode", "InvalidParameterValue");
-  }
-
-  /*validate if offering exists*/
-  for (i=0; i<map->numlayers; i++) {
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
-    if (pszTmp && (strcasecmp(pszTmp, sosparams->pszOffering) == 0) &&
-        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)))
-      break;
-  }
-
-  if (i==map->numlayers) {
-    msSetError(MS_SOSERR, "Offering %s not found. A layer might be disabled for \
-this request. Check sos/ows_enable_request settings.", "msSOSGetObservation()", sosparams->pszOffering);
-    return msSOSException(map, "offering", "InvalidParameterValue");
-  }
-
-  /*validate if observed property exist*/
-  /* Allow more the 1 oberved property comma separated (specs is unclear on it). If we
-     do it, we need to see if other parameters like result (filter encoding)
-     should be given for each property too) */
-
-  bLayerFound = 0;
-  tokens = msStringSplit(sosparams->pszObservedProperty, ',', &n);
-
-  for (i=0; i<map->numlayers; i++) {
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
-    pszTmp2 = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "observedproperty_id");
-
-    GET_LAYER(map, i)->status = MS_OFF;
-
-    if (pszTmp && pszTmp2) {
-      if (strcasecmp(pszTmp, sosparams->pszOffering) == 0) {
-        if (tokens && n > 0) {
-          for (j=0; j<n; j++) {
-            if(strcasecmp(pszTmp2, tokens[j]) == 0) {
-              GET_LAYER(map, i)->status = MS_ON;
-              /* opLayerName = msStrdup(GET_LAYER(map, i)->name); */
-              opLayerName = GET_LAYER(map, i)->name;
-              /* Force setting a template to enable query. */
-              if (!GET_LAYER(map, i)->template)
-                GET_LAYER(map, i)->template = msStrdup("ttt.html");
-              bLayerFound = 1;
-              break;
-            }
-          }
-        }
-      }
-    }
-  }
-  if (tokens && n > 0)
-    msFreeCharArray(tokens, n);
-
-  if (bLayerFound == 0) {
-    msSetError(MS_SOSERR, "ObservedProperty %s not found.", "msSOSGetObservation()", sosparams->pszObservedProperty);
-    return msSOSException(map, "observedproperty", "InvalidParameterValue");
-  }
-
-  /* apply procedure : could be a comma separated list.
-     set status to on those layers that have the sos_procedure metadata
-     equals to this parameter. Note that the layer should already have it's status at ON
-     by the  offering,observedproperty filter done above */
-
-  if (sosparams->pszProcedure) {
-    bLayerFound = 0;
-    tokens = msStringSplit(sosparams->pszProcedure, ',', &n);
-
-    if (tokens && n > 0) {
-      for (i=0; i<map->numlayers; i++) {
-        if(GET_LAYER(map, i)->status == MS_ON) {
-          pszValue =  msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "procedure");
-
-          if (pszValue) {
-            /* the procedure metadata can be a list "sensor1 sensor2..."*/
-            tokens1 = msStringSplit(pszValue, ' ', &n1);
-
-            for (j=0; j<n; j++) {
-              for (k=0; k<n1; k++) {
-                if (strcasecmp(tokens1[k], tokens[j]) == 0) { /* found */
-                  bLayerFound = 1;
-                  break;
-                }
-              }
-              if (k<n1)
-                break;
-            }
-            if (j == n) /*not found*/
-              GET_LAYER(map, i)->status = MS_OFF;
-
-            if (tokens1)
-              msFreeCharArray(tokens1, n1);
-
-            if (bLayerFound == 0) {
-              msSetError(MS_SOSERR, "Procedure %s not found.", "msSOSGetObservation()", sosparams->pszProcedure);
-              msFreeCharArray(tokens, n);
-              return msSOSException(map, "procedure", "InvalidParameterValue");
-            }
-          }
-
-          /* if there is a procedure_item defined on the layer, we will */
-          /* use it to set the filter parameter of the layer */
-
-          if ((GET_LAYER(map, i)->status == MS_ON) && (pszProcedureItem =  msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "procedure_item"))) {
-
-            lp = GET_LAYER(map, i);
-
-            /* HACK BEGIN */
-
-            if (msOWSLookupMetadata(&(GET_LAYER(map,i)->metadata), "S", "procedure") == NULL) {
-              /* if sos_procedure_item is used, and sos_procedure is not, it means that */
-              /* the procedure or sensor) need to be extracted from the data. Thus we */
-              /* need to query the layer and get the values from each feature */
-
-              if (lp->template == NULL)
-                lp->template = msStrdup("ttt");
-
-              map->query.type = MS_QUERY_BY_RECT;
-              map->query.mode = MS_QUERY_MULTIPLE;
-              map->query.layer = i;
-              map->query.rect = map->extent;
-              msQueryByRect(map);
-
-              /*check if the attribute specified in the procedure_item is available */
-              /*on the layer*/
-              iItemPosition = -1;
-              if (msLayerGetItems(lp) == MS_SUCCESS && lp->resultcache && lp->resultcache->numresults > 0) {
-                for(k=0; k<lp->numitems; k++) {
-                  if (strcasecmp(lp->items[k], pszProcedureItem) == 0) {
-                    iItemPosition = k;
-                    break;
-                  }
-                }
-                if (iItemPosition == -1) {
-                  msSetError(MS_SOSERR, "sos_procedure_item %s could not be found on the layer %s",
-                             "msSOSGetCapabilities()", pszProcedureItem, lp->name);
-                  return msSOSException(map, "mapserv", "NoApplicableCode");
-                }
-
-                /*for each selected feature, grab the value of the procedure_item*/
-                bLayerFound = 0;
-
-                for(k=0; k<lp->resultcache->numresults; k++) {
-                  msInitShape(&sShape);
-                  status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[k]));
-                  if(status != MS_SUCCESS)
-                    continue;
-
-                  if (sShape.values[iItemPosition]) {
-                    tokens = msStringSplit(sosparams->pszProcedure, ',', &n);
-                    for (j=0; j<n; j++) {
-                      if (strcasecmp(sShape.values[iItemPosition], tokens[j]) == 0) { /* found */
-                        bLayerFound = 1;
-                        break;
-                      }
-                    }
-                  }
-
-                  if (bLayerFound)
-                    break;
-                }
-
-                if (bLayerFound == 0) {
-                  msSetError(MS_SOSERR, "Invalid procedure value %s", "msSOSGetCapabilities()", sosparams->pszProcedure);
-                  return msSOSException(map, "procedure", "InvalidParameterValue");
-                }
-              }
-            }
-            /* HACK END */
-
-            pszBuffer = NULL;
-            if (lp->filter.string && strlen(lp->filter.string) > 0)
-              msFreeExpression(&lp->filter);
-
-            /*The filter should reflect the underlying db*/
-            /*for ogr add a where clause */
-            bSpatialDB = 0;
-            if (lp->connectiontype == MS_POSTGIS ||  lp->connectiontype == MS_ORACLESPATIAL || lp->connectiontype == MS_OGR)
-              bSpatialDB = 1;
-
-
-            if (bSpatialDB) {
-              if (lp->connectiontype != MS_OGR)
-                pszBuffer = msStringConcatenate(pszBuffer, "(");
-              else
-                pszBuffer = msStringConcatenate(pszBuffer, "WHERE ");
-            } else
-              pszBuffer = msStringConcatenate(pszBuffer, "(");
-
-            for (j=0; j<n; j++) {
-              if (j > 0)
-                pszBuffer = msStringConcatenate(pszBuffer, " OR ");
-
-              pszBuffer = msStringConcatenate(pszBuffer, "(");
-
-              if (!bSpatialDB) {
-                pszBuffer = msStringConcatenate(pszBuffer, "'[");
-                pszBuffer = msStringConcatenate(pszBuffer, (char *)pszProcedureItem);
-              } else {
-                pszEscapedStr = msLayerEscapePropertyName(lp, (char *)pszProcedureItem);
-                pszBuffer = msStringConcatenate(pszBuffer, pszEscapedStr);
-                msFree(pszEscapedStr);
-                pszEscapedStr = NULL;
-              }
-
-              if (!bSpatialDB)
-                pszBuffer = msStringConcatenate(pszBuffer, "]'");
-
-              pszBuffer = msStringConcatenate(pszBuffer, " = '");
-              pszEscapedStr = msLayerEscapeSQLParam(lp, tokens[j]);
-              pszBuffer = msStringConcatenate(pszBuffer,  pszEscapedStr);
-              msFree(pszEscapedStr);
-              pszBuffer = msStringConcatenate(pszBuffer,  "')");
-            }
-
-            if (!bSpatialDB || lp->connectiontype != MS_OGR)
-              pszBuffer = msStringConcatenate(pszBuffer, ")");
-
-            msLoadExpressionString(&lp->filter, pszBuffer);
-            if (pszBuffer)
-              msFree(pszBuffer);
-          }
-        }
-      }
-      msFreeCharArray(tokens, n);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      supports 2 types of gml:Time : TimePeriod and TimeInstant :     */
-  /*      - <gml:TimePeriod>                                              */
-  /*          <gml:beginPosition>2005-09-01T11:54:32</gml:beginPosition>  */
-  /*         <gml:endPosition>2005-09-02T14:54:32</gml:endPosition>       */
-  /*       </gml:TimePeriod>                                              */
-  /*                                                                      */
-  /*      - <gml:TimeInstant>                                             */
-  /*           <gml:timePosition>2003-02-13T12:28-08:00</gml:timePosition>*/
-  /*         </gml:TimeInstant>                                           */
-  /*                                                                      */
-  /*       The user can specify mutilple times separated by commas.       */
-  /*                                                                      */
-  /*       The gml will be parsed and trasformed into a sting tah         */
-  /*      looks like timestart/timeend,...                                */
-  /* -------------------------------------------------------------------- */
-
-  /*apply time filter if available */
-  if (sosparams->pszEventTime) {
-    char **apszTimes = NULL;
-    int numtimes = 0;
-    char *pszTimeString = NULL, *pszTmp = NULL;
-
-    /* Because SOS has specific TemporalOperator which extends FES 1.1, the time filter  */
-    /* passed is different than what mapogcfilter (per 1.0.0) supports.                  */
-    /*                                                                                   */
-    /* Because, in XML POST mode, we traverse directly to gml:TimePeriod|gml:TimeInstant */
-    /* this is passed directly to mapogcfilter.                                          */
-    /* for GET requests, we strip the parent element before passing                      */
-
-    pszTmp = msStrdup(sosparams->pszEventTime);
-
-    pszTmp = msCaseReplaceSubstring(pszTmp, "<ogc:TM_Equals>", "");
-    pszTmp = msCaseReplaceSubstring(pszTmp, "<TM_Equals>", "");
-    pszTmp = msCaseReplaceSubstring(pszTmp, "</ogc:TM_Equals>", "");
-    pszTmp = msCaseReplaceSubstring(pszTmp, "</TM_Equals>", "");
-
-    apszTimes = msStringSplit (pszTmp, ',', &numtimes);
-    msFree(pszTmp);
-
-    if (numtimes >=1) {
-      for (i=0; i<numtimes; i++) {
-        pszTmp = msSOSParseTimeGML(apszTimes[i]);
-        if (pszTmp) {
-          if (pszTimeString)
-            pszTimeString = msStringConcatenate(pszTimeString, ",");
-          pszTimeString = msStringConcatenate(pszTimeString, pszTmp);
-          msFree(pszTmp);
-        }
-      }
-      msFreeCharArray(apszTimes, numtimes);
-    }
-    if (!pszTimeString) {
-      msSetError(MS_SOSERR, "Invalid time value given for the eventTime parameter %s", "msSOSGetObservation()", sosparams->pszEventTime);
-      return msSOSException(map, "eventtime", "InvalidParameterValue");
-    }
-    for (i=0; i<map->numlayers; i++) {
-      if (GET_LAYER(map, i)->status == MS_ON) {
-        /* the sos_offering_timeextent should be used for time validation*/
-        /*TODO : too documented  ?*/
-        lpfirst = msSOSGetFirstLayerForOffering(map, msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id"), NULL);
-        if (lpfirst)
-          pszTimeExtent = msOWSLookupMetadata(&lpfirst->metadata, "S", "offering_timeextent");
-
-        pszTimeField =  msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "SO", "timeitem");
-
-        if (pszTimeField) {
-          /*validate only if time extent is set.*/
-          if (pszTimeExtent) {
-            if (msValidateTimeValue(pszTimeString, pszTimeExtent) == MS_TRUE)
-              msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString, pszTimeField);
-            else {
-              /*we should turn the layer off since the eventTime is not in the time extent*/
-              GET_LAYER(map, i)->status = MS_OFF;
-            }
-          } else
-            msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString, pszTimeField);
-        }
-      }
-    }
-    if (pszTimeString)
-      msFree(pszTimeString);
-  }
-
-  /*bbox*/
-  /* this is a gml feature
-  <gml:Envelope xmlns:gml="http://www.opengis.net/gml">
-  <gml:lowerCorner srsName="EPSG:4326">-66 43</gml:lowerCorner>
-  <upperCorner srsName="EPSG:4326">-62 45</upperCorner>
-  </gml:Envelope>
-  */
-
-  if (sosparams->pszFeatureOfInterest) {
-    int bValid = 0;
-    CPLXMLNode *psRoot=NULL;
-    char *pszSRS = NULL;
-
-    psRoot = CPLParseXMLString(sosparams->pszFeatureOfInterest);
-    if(!psRoot) {
-      msSetError(MS_SOSERR, "Invalid gml:Envelope value given for featureOfInterest.", "msSOSGetObservation()");
-      return msSOSException(map, "featureofinterest", "InvalidParameterValue");
-    }
-
-    CPLStripXMLNamespace(psRoot, "gml", 1);
-    bValid = FLTParseGMLEnvelope(psRoot, &sBbox, &pszSRS);
-
-    /* TODO we should reproject the bbox to the map projection if there is an srs defined */
-    if (!bValid) {
-      msSetError(MS_SOSERR, "Invalid gml:Envelope value given for featureOfInterest %s.", "msSOSGetObservation()", sosparams->pszEventTime);
-      return msSOSException(map, "featureofinterest", "InvalidParameterValue");
-    }
-    map->extent.minx = sBbox.minx;
-    map->extent.miny = sBbox.miny;
-    map->extent.maxx = sBbox.maxx;
-    map->extent.maxy = sBbox.maxy;
-
-    CPLDestroyXMLNode(psRoot);
-    msFree(pszSRS);
-  }
-
-  if (sosparams->pszSrsName) { /* validate against MAP.WEB.METADATA.sos_srs */
-    int iUnits = -1;
-    char **tokens = NULL;
-    const char *pszSRSList = NULL;
-    int n = 0;
-    int bFound = 0;
-    int k;
-    char srsbuffer[100];
-    projectionObj po;
-
-    pszSRSList = msOWSLookupMetadata(&(map->web.metadata), "SO", "srs");
-
-    if (pszSRSList) {
-      tokens = msStringSplit(pszSRSList, ' ', &n);
-
-      if (tokens && n > 0) {
-        for (k=0; k<n; k++) {
-          if (strncasecmp(tokens[k], "EPSG:", strlen("EPSG:")) == 0 &&
-              strcasecmp(sosparams->pszSrsName, tokens[k]) == 0) { /* match */
-            bFound = 1;
-
-            /* project MAP.EXTENT to this SRS */
-            msInitProjection(&po);
-            msProjectionInheritContextFrom(&po, &map->projection);
-
-            snprintf(srsbuffer, sizeof(srsbuffer), "+init=epsg:%.20s", sosparams->pszSrsName+strlen("EPSG:"));
-
-            if (msLoadProjectionString(&po, srsbuffer) != 0) {
-              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"", "msSOSGetObservation()", sosparams->pszSrsName);
-              return msSOSException(map, "mapserv", "NoApplicableCode");
-            }
-
-            if (msProjectionsDiffer(&map->projection, &po) == MS_TRUE) {
-              msProjectRect(&map->projection, &po, &map->extent);
-              sBbox = map->extent;
-            }
-
-            /* set map->projection to this SRS */
-            if (msLoadProjectionString(&(map->projection), srsbuffer) != 0) {
-              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"", "msSOSGetObservation()", sosparams->pszSrsName);
-              return msSOSException(map, "mapserv", "NoApplicableCode");
-            }
-
-            iUnits = GetMapserverUnitUsingProj(&(map->projection));
-            if (iUnits != -1)
-              map->units = iUnits;
-
-            msFreeProjection(&po);
-            break;
-          }
-        }
-        msFreeCharArray(tokens, n);
-      }
-      if (bFound == 0) {
-        msSetError(MS_SOSERR, "srsName value \"%s\" unsupported / invalid", "msSOSGetObservation()", sosparams->pszSrsName);
-        return msSOSException(map, "srsName", "InvalidParameterValue");
-      }
-    } else {
-      msSetError(MS_SOSERR, "MAP.WEB.METADATA.sos_srs not set", "msSOSGetObservation()");
-      return msSOSException(map, "mapserv", "NoApplicableCode");
-    }
-  }
-
-  /* apply filter */
-  if (sosparams->pszResult) {
-    psFilterNode = FLTParseFilterEncoding(sosparams->pszResult);
-
-    if (!psFilterNode) {
-      msSetError(MS_SOSERR, "Invalid or Unsupported RESULT in GetObservation: %s", "msSOSGetObservation()", sosparams->pszResult);
-      return msSOSException(map, "result", "InvalidParameterValue");
-    }
-    /* apply the filter to all layers that are on */
-    for (i=0; i<map->numlayers; i++) {
-      lp = GET_LAYER(map, i);
-      if (lp->status == MS_ON) {
-        /* preparse parser so that alias for fields can be used */
-        FLTPreParseFilterForAliasAndGroup(psFilterNode, map, i, "S");
-        /* validate that the property names used are valid
-          (there is a corresponding layer attribute) */
-        if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-          if (msSOSValidateFilter(psFilterNode, lp)== MS_FALSE) {
-            msSetError(MS_SOSERR, "Invalid component name in RESULT statement", "msSOSGetObservation()");
-            return msSOSException(map, "result", "InvalidParameterValue");
-          }
-          msLayerClose(lp);
-        }
-        FLTApplyFilterToLayer(psFilterNode, map, i);
-      }
-    }
-
-    FLTFreeFilterEncodingNode(psFilterNode);
-  }
-
-
-
-  /* this is just a fall back if bbox is enetered. The bbox parameter is not supported
-     by the sos specs */
-  if (sosparams->pszBBox && !sosparams->pszFeatureOfInterest) {
-    char **tokens;
-    int n;
-
-    tokens = msStringSplit(sosparams->pszBBox, ',', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_SOSERR, "Wrong number of arguments for bounding box.", "msSOSGetObservation()");
-      return msSOSException(map, "bbox", "InvalidParameterValue");
-    }
-    sBbox.minx = atof(tokens[0]);
-    sBbox.miny = atof(tokens[1]);
-    sBbox.maxx = atof(tokens[2]);
-    sBbox.maxy = atof(tokens[3]);
-    msFreeCharArray(tokens, n);
-  }
-
-  /* do the query if the filter encoding (pszResult) is not part of the request.
-     If pszResult is available, the query on the layers will be done when the filter
-     is parsed*/
-  if (!sosparams->pszResult) {
-    map->query.type = MS_QUERY_BY_RECT;
-    map->query.mode = MS_QUERY_MULTIPLE;
-    map->query.layer = -1;
-    map->query.rect = sBbox;
-    msQueryByRect(map);
-  }
-
-  /*get the first layers of the offering*/
-  for (i=0; i<map->numlayers; i++) {
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
-    if (pszTmp && (strcasecmp(pszTmp, sosparams->pszOffering) == 0)) {
-      lp = (GET_LAYER(map, i));
-      break;
-    }
-  }
-
-  /* build xml return tree*/
-
-  psNsSos = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/sos/1.0", BAD_CAST "sos");
-  psNsGml = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
-  psNsOm = xmlNewNs(NULL, BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix);
-  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe");
-  psNsXLink = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  psNsMs = xmlNewNs(NULL, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
-
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-  psRootNode = xmlNewNode(NULL, BAD_CAST "ObservationCollection");
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri, BAD_CAST pszSOSNamespacePrefix));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0", BAD_CAST "om"));
-
-  xmlNewNsProp(psRootNode, psNsGml, BAD_CAST "id", BAD_CAST sosparams->pszOffering);
-
-  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-
-  if ((script_url=msOWSGetOnlineResource(map, "SO", "onlineresource", req)) == NULL)
-  {
-    free(schemalocation);
-    return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
-  }
-
-  xsi_schemaLocation = msStrdup("http://www.opengis.net/om/1.0 ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/om/1.0.0/om.xsd ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *) user_namespace_uri);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *) script_url);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *) opLayerName);
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-
-  /* description */
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_description");
-  if (pszTmp) {
-    psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "description", BAD_CAST pszTmp);
-    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  }
-
-  /* name */
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_name");
-  if (pszTmp) {
-    psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "name", BAD_CAST pszTmp);
-    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  }
-
-  /* extent */
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_extent");
-
-  if (pszTmp) {
-    char **tokens;
-    char *pszMapEpsg;
-    int n;
-    rectObj envelope;
-
-    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE, &pszMapEpsg);
-
-    tokens = msStringSplit(pszTmp, ',', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_extent.",
-                 "msSOSGetCapabilities()");
-      msFree(script_url);
-      return msSOSException(map, "sos_offering_extent", "InvalidParameterValue");
-    }
-
-    envelope.minx = atof(tokens[0]);
-    envelope.miny = atof(tokens[1]);
-    envelope.maxx = atof(tokens[2]);
-    envelope.maxy = atof(tokens[3]);
-
-    if (map && msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
-      if (msProjectRect(&lp->projection, &map->projection, &envelope) == MS_FAILURE) {
-        msSetError(MS_SOSERR, "Coordinates transformation failed.  Raised in msProjectRect() of file %s line %d", "msSOSGetCapabilities()", __FILE__, __LINE__);
-        msFree(script_url);
-        return msSOSException(map, "sos_offering_extent", "InvalidParameterValue");
-      }
-    }
-
-    psNode = xmlAddChild(psRootNode, msGML3BoundedBy(psNsGml, envelope.minx, envelope.miny, envelope.maxx, envelope.maxy, pszMapEpsg));
-    msFreeCharArray(tokens, n);
-    msFree(pszMapEpsg);
-  }
-
-  /* time
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S","offering_timeextent");
-  if (pszTmp)
-  {
-      char **tokens;
-      int n;
-      char *pszEndTime = NULL;
-      tokens = msStringSplit(pszTmp, '/', &n);
-      if (tokens==NULL || (n != 1 && n!=2)) {
-          msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_timeextent.",
-                     "msSOSGetCapabilities()");
-          return msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
-      }
-  */
-  /*    if (n == 2) */ /* end time is empty. It is going to be set as "now" */
-  /*      pszEndTime = tokens[1];
-
-        psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(xmlNewNs(NULL, BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix), tokens[0], pszEndTime));
-      psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(psNsOm, psNsGml, tokens[0], pszEndTime));
-      msFreeCharArray(tokens, n);
-
-  }
-  */
-
-  if (sosparams->pszResultModel && strcasecmp(sosparams->pszResultModel, "om:Measurement") != 0 &&
-      strcasecmp(sosparams->pszResultModel, "om:Observation") != 0) {
-    msSetError(MS_SOSERR, "resultModel should be om:Measurement or om:Observation", "msSOSGetObservation()");
-    free(xsi_schemaLocation);
-    free(schemalocation);
-    msFree(script_url);
-    xmlFreeNs(psNsSos);
-    xmlFreeNs(psNsGml);
-    xmlFreeNs(psNsOm);
-    xmlFreeNs(psNsSwe);
-    xmlFreeNs(psNsXLink);
-    xmlFreeNs(psNsMs);
-    xmlFreeDoc(psDoc);
-    return msSOSException(map, "resultModel", "InvalidParameterValue");
-  }
-
-  else {
-    /* output result members */
-    for (i=0; i<map->numlayers; i++) {
-      if (GET_LAYER(map, i)->resultcache && GET_LAYER(map, i)->resultcache->numresults > 0) {
-        msLayerGetItems((GET_LAYER(map, i)));
-        pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SO", "maxfeatures");
-        if (pszTmp != NULL)
-          n1 = atoi(pszTmp);
-        else
-          n1 = 0;
-
-        if (sosparams->pszResultModel == NULL || strcasecmp(sosparams->pszResultModel, "om:Measurement") == 0) {
-          for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++) {
-            msSOSAddMemberNode(psNsGml, psNsOm, psNsSwe, psNsXLink, psNsMs, psRootNode, map, (GET_LAYER(map, i)), j, script_url, opLayerName);
-            if (j == n1-1)
-              break;
-          }
-        } else { /*assuming here that pszResultModel = observation */
-          /*layer does not define a procedure_item: this means one procedure per
-            layer defined using sos_procedure)*/
-          if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "procedure_item") == NULL) {
-            pszProcedure = msOWSLookupMetadata(&(lp->metadata), "S", "procedure");
-            psObservationNode = msSOSAddMemberNodeObservation(psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map, (GET_LAYER(map, i)),
-                                pszProcedure);
-            /*add a result node*/
-            psResultNode = xmlNewChild(psObservationNode, NULL, BAD_CAST "result", NULL);
-            for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++) {
-              /*add a block separator*/
-              if (j > 0) {
-                pszBlockSep = msOWSLookupMetadata(&(map->web.metadata), "S",
-                                                  "encoding_blockSeparator");
-                if (pszBlockSep)
-                  xmlNodeAddContent(psResultNode, BAD_CAST pszBlockSep);
-                else
-                  xmlNodeAddContent(psResultNode, BAD_CAST "\n");
-              }
-              {
-                char* pszResult = msSOSReturnMemberResult((GET_LAYER(map, i)), j, NULL);
-                if (pszResult) {
-                  xmlNodeAddContent(psResultNode, BAD_CAST pszResult);
-                  msFree(pszResult);
-                }
-              }
-            }
-          }
-          /*this is the case where procedure_item is used. Needs more management since
-            the same data on a layer contains different procedures (procedures are
-            one of the fields of the record)*/
-          else {
-
-            for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++) {
-              char* pszProcedureValue = NULL;
-              char* pszResult = msSOSReturnMemberResult((GET_LAYER(map, i)), j, &pszProcedureValue);
-              if (!pszProcedureValue || !pszResult)
-              {
-                msFree(pszProcedureValue);
-                msFree(pszResult);
-                continue;
-              }
-              for (k=0; k<nDiffrentProc; k++) {
-                if (strcasecmp(paDiffrentProc[k].pszProcedure, pszProcedureValue) == 0) {
-                  pszBlockSep = msOWSLookupMetadata(&(map->web.metadata), "S",
-                                                    "encoding_blockSeparator");
-                  if (pszBlockSep)
-                    xmlNodeAddContent(paDiffrentProc[k].psResultNode, BAD_CAST pszBlockSep);
-                  else
-                    xmlNodeAddContent(paDiffrentProc[k].psResultNode, BAD_CAST "\n");
-                  xmlNodeAddContent(paDiffrentProc[k].psResultNode, BAD_CAST pszResult);
-                  break;
-                }
-              }
-              if (k == nDiffrentProc) { /*a new procedure*/
-                nDiffrentProc++;
-                if (paDiffrentProc == NULL)
-                  paDiffrentProc = (SOSProcedureNode *)malloc(sizeof(SOSProcedureNode));
-                else
-                  paDiffrentProc = (SOSProcedureNode *)realloc(paDiffrentProc,
-                                   sizeof(SOSProcedureNode)
-                                   *nDiffrentProc);
-
-                paDiffrentProc[nDiffrentProc-1].pszProcedure = msStrdup(pszProcedureValue);
-                psObservationNode = msSOSAddMemberNodeObservation(psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map,
-                                    (GET_LAYER(map, i)),
-                                    pszProcedureValue);
-
-                paDiffrentProc[nDiffrentProc-1].psResultNode =
-                  xmlNewChild(psObservationNode, NULL, BAD_CAST "result", NULL);
-
-                xmlNodeAddContent(paDiffrentProc[nDiffrentProc-1].psResultNode, BAD_CAST pszResult);
-              }
-              msFree(pszProcedureValue);
-              msFree(pszResult);
-            }
-            if (paDiffrentProc) {
-              for (k=0; k<nDiffrentProc; k++)
-                msFree(paDiffrentProc[k].pszProcedure);
-              free(paDiffrentProc);
-            }
-          }
-        }
-      }
-    }
-  }
-
-  /* output results */
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  context = msIO_getHandler(stdout);
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-  msIO_contextWrite(context, buffer, size);
-  free(schemalocation);
-  free(xsi_schemaLocation);
-  xmlFreeNs(psNsSos);
-  xmlFreeNs(psNsGml);
-  xmlFreeNs(psNsOm);
-  xmlFreeNs(psNsSwe);
-  xmlFreeNs(psNsXLink);
-  xmlFreeNs(psNsMs);
-  xmlFree(buffer);
-  msFree(script_url);
-
-  /*free  document */
-  xmlFreeDoc(psDoc);
-  /*
-  *Free the global variables that may
-  *have been allocated by the parser.
-  */
-  xmlCleanupParser();
-
-
-  return(MS_SUCCESS);
-}
-
-
-
-/************************************************************************/
-/*                           msSOSDescribeSensor                        */
-/*                                                                      */
-/*      Describe sensor request handler.                               */
-/************************************************************************/
-int msSOSDescribeSensor(mapObj *map, sosParamsObj *sosparams, owsRequestObj *ows_request)
-{
-  char *pszEncodedUrl = NULL;
-  const char *pszId = NULL, *pszUrl = NULL;
-  int i = 0, j=0, k=0;
-  layerObj *lp = NULL;
-  int iItemPosition = -1;
-  shapeObj sShape;
-  int status;
-  char *tmpstr = NULL, *pszTmp = NULL, *pszProcedureURI = NULL, *pszProcedureId = NULL;
-
-  if (!sosparams->pszOutputFormat) {
-    msSetError(MS_SOSERR, "Missing mandatory parameter outputFormat.", "msSOSDescribeSensor()");
-    return msSOSException(map, "outputformat", "MissingParameterValue");
-  }
-
-  if (strcasecmp(sosparams->pszOutputFormat, pszSOSDescribeSensorMimeType) != 0) {
-    msSetError(MS_SOSERR, "Invalid outputformat parameter %s.  Allowable values are: %s", "msSOSDescribeSensor()", sosparams->pszOutputFormat, pszSOSDescribeSensorMimeType);
-    return msSOSException(map, "outputformat", "InvalidParameterValue");
-  }
-
-  if (!sosparams->pszProcedure) {
-    msSetError(MS_SOSERR, "Missing mandatory parameter procedure", "msSOSDescribeSensor()");
-    return msSOSException(map, "procedure", "MissingParameterValue");
-  }
-
-  for (i=0; i<map->numlayers; i++) {
-    lp = GET_LAYER(map, i);
-    pszId = msOWSLookupMetadata(&(lp->metadata), "S", "procedure");
-    if (pszId && strlen(pszId) > 0) {
-      /*procedure could be a list*/
-      char **tokens = NULL;
-      int n=0;
-      int bFound = 0;
-      tokens = msStringSplit(pszId, ' ', &n);
-      for (k=0; k<n; k++) {
-        if (tokens[k] && strlen(tokens[k]) > 0) {
-          pszProcedureURI = msStrdup("urn:ogc:def:procedure:");
-          pszProcedureURI = msStringConcatenate(pszProcedureURI, tokens[k]);
-          if ( (pszProcedureURI && strcasecmp(pszProcedureURI, sosparams->pszProcedure) == 0) &&
-               (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-            bFound = 1;
-            pszProcedureId = msStrdup(tokens[k]);
-            msFree(pszProcedureURI);
-            break;
-          }
-          msFree(pszProcedureURI);
-        }
-      }
-      msFreeCharArray(tokens, n);
-      if (bFound) {
-        pszUrl = msOWSLookupMetadata(&(lp->metadata), "S", "describesensor_url");
-        if (pszUrl) {
-          pszTmp = msStrdup(pszUrl);
-
-          /* %procedure% is the hardcoded variable name to use
-             within sos_describesensor_url */
-          tmpstr = (char *)malloc(sizeof(char)*strlen("procedure") + 3);
-          sprintf(tmpstr,"%%%s%%", "procedure");
-          if (strcasestr(pszUrl, tmpstr) != NULL)
-            pszTmp = msCaseReplaceSubstring(pszTmp, tmpstr, pszProcedureId);
-          msFree(tmpstr);
-
-          pszEncodedUrl = msEncodeHTMLEntities(pszTmp);
-          msIO_printf("Location: %s\n\n", pszEncodedUrl);
-          msFree(pszTmp);
-          msFree(pszEncodedUrl);
-          msFree(pszProcedureId);
-          return(MS_SUCCESS);
-        } else {
-          msSetError(MS_SOSERR, "Missing mandatory metadata sos_describesensor_url on layer %s", "msSOSDescribeSensor()", lp->name);
-          return msSOSException(map, "sos_describesensor_url", "MissingParameterValue");
-        }
-      }
-    } else if ((pszId = msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))) {
-      iItemPosition = -1;
-      if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-        for(j=0; j<lp->numitems; j++) {
-          if (strcasecmp(lp->items[j], pszId) == 0) {
-            iItemPosition = j;
-            break;
-          }
-        }
-        msLayerClose(lp);
-      }
-      if (iItemPosition >=0) {
-        if (lp->template == NULL)
-          lp->template = msStrdup("ttt");
-
-        map->query.type = MS_QUERY_BY_RECT;
-        map->query.mode = MS_QUERY_MULTIPLE;
-        map->query.layer = i;
-        map->query.rect = map->extent;
-        msQueryByRect(map);
-
-        msLayerGetItems(lp);
-
-        if (lp->resultcache && lp->resultcache->numresults > 0) {
-          for(j=0; j<lp->resultcache->numresults; j++) {
-            msInitShape(&sShape);
-            status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[j]));
-            if(status != MS_SUCCESS)
-              continue;
-
-            if (sShape.values[iItemPosition]) {
-              pszProcedureURI = msStrdup("urn:ogc:def:procedure:");
-              pszProcedureURI = msStringConcatenate(pszProcedureURI, sShape.values[iItemPosition]);
-              if (strcasecmp(pszProcedureURI, sosparams->pszProcedure) == 0) {
-                pszUrl = msOWSLookupMetadata(&(lp->metadata), "S", "describesensor_url");
-                pszProcedureId = msStrdup(sShape.values[iItemPosition]);
-                if (pszUrl) {
-                  pszTmp = msStrdup(pszUrl);
-
-                  /* %procedure% is the hardcoded variable names to use
-                     within sos_describesensor_url */
-                  tmpstr = (char *)malloc(sizeof(char)*strlen("procedure") + 3);
-                  sprintf(tmpstr,"%%%s%%", "procedure");
-                  if (strcasestr(pszUrl, tmpstr) != NULL)
-                    pszTmp = msCaseReplaceSubstring(pszTmp, tmpstr, pszProcedureId);
-                  msFree(tmpstr);
-
-                  pszEncodedUrl = msEncodeHTMLEntities(pszTmp);
-                  msIO_printf("Location: %s\n\n", pszEncodedUrl);
-                  msFree(pszTmp);
-                  return(MS_SUCCESS);
-                } else {
-                  msSetError(MS_SOSERR, "Missing mandatory metadata sos_describesensor_url on layer %s", "msSOSDescribeSensor()", lp->name);
-                  return msSOSException(map, "mapserv", "NoApplicableCode");
-                }
-              }
-            }
-          }
-        }
-      }
-    }
-  }
-  msSetError(MS_SOSERR, "procedure %s not found.", "msSOSDescribeSensor()", sosparams->pszProcedure);
-  return msSOSException(map, "procedure", "InvalidParameterValue");
-}
-
-/************************************************************************/
-/*                           msSOSDescribeObservationType               */
-/*                                                                      */
-/*      DescribeObserrvationType request handler                        */
-/************************************************************************/
-int msSOSDescribeObservationType(mapObj *map, sosParamsObj *sosparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  int i, j, n = 0, bLayerFound = 0;
-  char **tokens = NULL;
-  char *script_url=NULL;
-  const char *pszTmp = NULL;
-  char *pszTmp2=NULL;
-  const char *opLayerName = NULL;
-
-  if (!sosparams->pszObservedProperty) {
-    msSetError(MS_SOSERR, "Missing mandatory parameter observedproperty", "msSOSDescribeObservationType()");
-    return msSOSException(map, "observedproperty", "MissingParameterValue");
-  }
-
-  tokens = msStringSplit(sosparams->pszObservedProperty, ',', &n);
-
-  for (i=0; i<map->numlayers; i++) {
-    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-      continue;
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "observedproperty_id");
-    if (pszTmp) {
-      if (strcasecmp(pszTmp, sosparams->pszObservedProperty) == 0) {
-        if (tokens && n > 0) {
-          for (j=0; j<n; j++) {
-            if(strcasecmp(pszTmp, tokens[j]) == 0) {
-              opLayerName = GET_LAYER(map, i)->name;
-              bLayerFound = 1;
-              break;
-            }
-          }
-        }
-      }
-    }
-  }
-  if (tokens && n > 0)
-    msFreeCharArray(tokens, n);
-
-  if (bLayerFound == 0) {
-    msSetError(MS_SOSERR, "ObservedProperty %s not found.", "msSOSGetObservation()", sosparams->pszObservedProperty);
-    return msSOSException(map, "observedproperty", "InvalidParameterValue");
-  }
-
-  if ((script_url=msOWSGetOnlineResource(map, "SO", "onlineresource", req)) == NULL)
-    return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
-
-  pszTmp2 = msStringConcatenate(pszTmp2, (char *) script_url);
-  pszTmp2 = msStringConcatenate(pszTmp2, "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
-  pszTmp2 = msStringConcatenate(pszTmp2, (char *) opLayerName);
-
-  msIO_printf("Location: %s\n\n", pszTmp2);
-  msFree(pszTmp2);
-  msFree(script_url);
-  return(MS_SUCCESS);
-}
-
-
-#endif /* defined(USE_WCS_SVR) && defined(USE_LIBXML2) */
-
-/*
-** msSOSDispatch() is the entry point for SOS requests.
-** - If this is a valid request then it is processed and MS_SUCCESS is returned
-**   on success, or MS_FAILURE on failure.
-*/
-int msSOSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-#if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
-  int returnvalue = MS_DONE;
-  sosParamsObj *paramsObj = (sosParamsObj *)calloc(1, sizeof(sosParamsObj));
-
-  if (msSOSParseRequest(map, req, paramsObj) == MS_FAILURE) {
-    msSOSFreeParamsObj(paramsObj);
-    free(paramsObj);
-    return MS_FAILURE;
-  }
-
-  /* SERVICE must be specified and be SOS */
-  if (paramsObj->pszService && strcasecmp(paramsObj->pszService, "SOS") == 0) { /* this is an SOS request */
-    if (!paramsObj->pszRequest) {
-      msSetError(MS_SOSERR, "Missing REQUEST Parameter", "msSOSDispatch()");
-      msSOSFreeParamsObj(paramsObj);
-      free(paramsObj);
-      paramsObj = NULL;
-      return msSOSException(map, "request", "MissingParameterValue");
-    }
-
-    msOWSRequestLayersEnabled(map, "S", paramsObj->pszRequest, ows_request);
-    if (ows_request->numlayers == 0) {
-      msSetError(MS_SOSERR, "SOS request not enabled. Check sos/ows_enable_request settings.", "msSOSDispatch()");
-      msSOSFreeParamsObj(paramsObj);
-      free(paramsObj);
-      paramsObj = NULL;
-      return msSOSException(map, "request", "InvalidParameterValue");
-    }
-
-    if (strcasecmp(paramsObj->pszRequest, "GetCapabilities") == 0) {
-      returnvalue = msSOSGetCapabilities(map, paramsObj, req, ows_request);
-      msSOSFreeParamsObj(paramsObj);
-      free(paramsObj);
-      paramsObj = NULL;
-      return returnvalue;
-    }
-
-    else if (strcasecmp(paramsObj->pszRequest, "DescribeSensor") == 0 ||
-             strcasecmp(paramsObj->pszRequest, "GetObservation") == 0 ||
-             strcasecmp(paramsObj->pszRequest, "DescribeObservationType") == 0
-            ) {
-      /* check version */
-      if (!paramsObj->pszVersion) {
-        msSetError(MS_SOSERR, "Missing VERSION parameter", "msSOSDispatch()");
-        msSOSFreeParamsObj(paramsObj);
-        free(paramsObj);
-        paramsObj = NULL;
-        return msSOSException(map, "version", "MissingParameterValue");
-      }
-
-      if (msOWSParseVersionString(paramsObj->pszVersion) != OWS_1_0_0) {
-        msSetError(MS_SOSERR, "VERSION %s not supported.  Supported versions are: %s.", "msSOSDispatch()", paramsObj->pszVersion, pszSOSVersion);
-        msSOSFreeParamsObj(paramsObj);
-        free(paramsObj);
-        paramsObj = NULL;
-        return msSOSException(map, "version", "InvalidParameterValue");
-      }
-
-      if (strcasecmp(paramsObj->pszRequest, "DescribeSensor") == 0)
-        returnvalue = msSOSDescribeSensor(map, paramsObj, ows_request);
-
-      else if (strcasecmp(paramsObj->pszRequest, "GetObservation") == 0)
-        returnvalue = msSOSGetObservation(map, paramsObj, req, ows_request);
-
-      else if (strcasecmp(paramsObj->pszRequest, "DescribeObservationType") == 0)
-        returnvalue = msSOSDescribeObservationType(map, paramsObj, req, ows_request);
-
-      msSOSFreeParamsObj(paramsObj);
-      free(paramsObj);
-      paramsObj = NULL;
-      return returnvalue;
-    } else {
-      msSetError(MS_SOSERR, "Invalid REQUEST parameter: %s", "msSOSDispatch()", paramsObj->pszRequest);
-      msSOSFreeParamsObj(paramsObj);
-      free(paramsObj);
-      paramsObj = NULL;
-      return msSOSException(map, "request", "InvalidParameterValue");
-    }
-  } else {
-    msSOSFreeParamsObj(paramsObj);
-    free(paramsObj);
-    return MS_DONE;  /* Not an SOS request */
-  }
-#else
-  msSetError(MS_SOSERR, "SOS support is not available.", "msSOSDispatch()");
-  return(MS_FAILURE);
-#endif
-}
-
-#if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
-
-int msSOSParseRequest(mapObj *map, cgiRequestObj *request, sosParamsObj *sosparams)
-{
-  int i;
-  xmlDocPtr doc;
-  xmlXPathContextPtr context;
-  xmlNodeSetPtr nodeset;
-  xmlXPathObjectPtr psXPathTmp;
-  char *pszTmp = NULL;
-
-  if (request->NumParams) { /* this is a GET request */
-    for(i=0; i<request->NumParams; i++) {
-      if (strcasecmp(request->ParamNames[i], "SERVICE") == 0)
-        sosparams->pszService = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "VERSION") == 0)
-        sosparams->pszVersion = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "ACCEPTVERSIONS") == 0)
-        sosparams->pszAcceptVersions = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "REQUEST") == 0)
-        sosparams->pszRequest = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "UPDATESEQUENCE") == 0)
-        sosparams->pszUpdateSequence = msStrdup(request->ParamValues[i]);
-      else  if (strcasecmp(request->ParamNames[i], "SENSORID") == 0)
-        sosparams->pszSensorId = msStrdup(request->ParamValues[i]);
-      else  if (strcasecmp(request->ParamNames[i], "PROCEDURE") == 0)
-        sosparams->pszProcedure = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "OUTPUTFORMAT") == 0)
-        sosparams->pszOutputFormat = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "OFFERING") == 0)
-        sosparams->pszOffering = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "OBSERVEDPROPERTY") == 0)
-        sosparams->pszObservedProperty = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "EVENTTIME") == 0)
-        sosparams->pszEventTime = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "RESULT") == 0)
-        sosparams->pszResult = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "RESULTMODEL") == 0)
-        sosparams->pszResultModel = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "RESPONSEFORMAT") == 0)
-        sosparams->pszResponseFormat = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "RESPONSEMODE") == 0)
-        sosparams->pszResponseMode = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "BBOX") == 0)
-        sosparams->pszBBox = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "SRSNAME") == 0)
-        sosparams->pszSrsName = msStrdup(request->ParamValues[i]);
-      else if (strcasecmp(request->ParamNames[i], "FEATUREOFINTEREST") == 0)
-        sosparams->pszFeatureOfInterest = msStrdup(request->ParamValues[i]);
-    }
-  }
-
-  if (request->postrequest) { /* this a POST request */
-    /* load document */
-    doc = xmlParseDoc((xmlChar *)request->postrequest);
-    if (doc == NULL ) {
-      msSetError(MS_SOSERR, "Invalid POST request.  XML is not well-formed", "msSOSParseRequest()");
-      return msSOSException(map, "request", "InvalidRequest");
-    }
-
-    /* load context */
-    context = xmlXPathNewContext(doc);
-    if (context == NULL) {
-      msSetError(MS_SOSERR, "Could not create context (xmlXPathNewContext)", "msSOSParseRequest()");
-      return msSOSException(map, "request", "NoApplicableCode");
-    }
-
-    /* register namespaces */
-    if(xmlXPathRegisterNs(context, (xmlChar *)"sos", (xmlChar *)"http://www.opengis.net/sos/1.0") != 0 ||
-        xmlXPathRegisterNs(context, (xmlChar *)"ows", (xmlChar *)"http://www.opengis.net/ows/1.1") != 0 ||
-        xmlXPathRegisterNs(context, (xmlChar *)"ogc", (xmlChar *)"http://www.opengis.net/ogc") != 0 ||
-        xmlXPathRegisterNs(context, (xmlChar *)"gml", (xmlChar *)"http://www.opengis.net/gml") != 0) {
-      msSetError(MS_SOSERR, "Could not register namespaces (xmlXPathRegisterNs)", "msSOSParseRequest()");
-      return msSOSException(map, "request", "NoApplicableCode");
-    }
-
-    /* check for service */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/*/@service");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszService = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for updateSequence*/
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/*/@updateSequence");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszUpdateSequence = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for version */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/*/ows:AcceptVersions/ows:Version|/*/@version");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszVersion = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for request */
-
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetCapabilities");
-
-    if (psXPathTmp)
-      sosparams->pszRequest = msStrdup("GetCapabilities");
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor");
-
-    if (psXPathTmp)
-      sosparams->pszRequest = msStrdup("DescribeSensor");
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation");
-
-    if (psXPathTmp)
-      sosparams->pszRequest = msStrdup("GetObservation");
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeObservationType");
-
-    if (psXPathTmp)
-      sosparams->pszRequest = msStrdup("DescribeObservationType");
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for outputformat */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor/@outputFormat");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszOutputFormat = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for Procedure */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor/sos:procedure");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszProcedure = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for offering */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:offering");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszOffering = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for observedproperty */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:observedProperty");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszObservedProperty = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for procedure */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:procedure");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszProcedure = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for responseFormat */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:responseFormat");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszResponseFormat = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for resultModel */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:resultModel");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszResultModel = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for responseMode */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:responseMode");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszResponseMode = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for srsName */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/@srsName");
-
-    if (psXPathTmp) {
-      nodeset = psXPathTmp->nodesetval;
-      sosparams->pszSrsName = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for result (chunk of XML) */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:result/child::*");
-
-    if (psXPathTmp) {
-      sosparams->pszResult = msLibXml2GetXPathTree(doc, psXPathTmp);
-      pszTmp = msStringConcatenate(pszTmp, "<ogc:Filter>");
-      pszTmp = msStringConcatenate(pszTmp, sosparams->pszResult);
-      pszTmp = msStringConcatenate(pszTmp, "</ogc:Filter>");
-      msFree(sosparams->pszResult);
-      sosparams->pszResult = msStrdup(pszTmp);
-      msFree(pszTmp);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for featureOfInterest (chunk of XML) */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:featureOfInterest/ogc:BBOX/gml:Envelope");
-
-    if (psXPathTmp) {
-      sosparams->pszFeatureOfInterest = (char *)msLibXml2GetXPathTree(doc, psXPathTmp);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-
-    /* check for eventTime (chunk of XML) */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:eventTime/*/gml:TimeInstant|/sos:GetObservation/sos:eventTime/*/gml:TimePeriod");
-
-    if (psXPathTmp) {
-      sosparams->pszEventTime = (char *)msLibXml2GetXPathTree(doc, psXPathTmp);
-    }
-
-    xmlXPathFreeObject(psXPathTmp);
-    xmlXPathFreeContext(context);
-    xmlFreeDoc(doc);
-    xmlCleanupParser();
-  }
-  return MS_SUCCESS;
-}
-
-void msSOSFreeParamsObj(sosParamsObj *sosparams)
-{
-  if (sosparams) {
-    if (sosparams->pszService)
-      free(sosparams->pszService);
-    if (sosparams->pszVersion)
-      free(sosparams->pszVersion);
-    if (sosparams->pszAcceptVersions)
-      free(sosparams->pszAcceptVersions);
-    if (sosparams->pszUpdateSequence)
-      free(sosparams->pszUpdateSequence);
-    if (sosparams->pszRequest)
-      free(sosparams->pszRequest);
-    if (sosparams->pszOutputFormat)
-      free(sosparams->pszOutputFormat);
-    if (sosparams->pszSensorId)
-      free(sosparams->pszSensorId);
-    if (sosparams->pszProcedure)
-      free(sosparams->pszProcedure);
-    if (sosparams->pszOffering)
-      free(sosparams->pszOffering);
-    if (sosparams->pszObservedProperty)
-      free(sosparams->pszObservedProperty);
-    if (sosparams->pszEventTime)
-      free(sosparams->pszEventTime);
-    if (sosparams->pszResult)
-      free(sosparams->pszResult);
-    if (sosparams->pszResponseFormat)
-      free(sosparams->pszResponseFormat);
-    if (sosparams->pszResultModel)
-      free(sosparams->pszResultModel);
-    if (sosparams->pszResponseMode)
-      free(sosparams->pszResponseMode);
-    if (sosparams->pszSrsName)
-      free(sosparams->pszSrsName);
-    if (sosparams->pszFeatureOfInterest)
-      free(sosparams->pszFeatureOfInterest);
-  }
-}
-#endif /* defined(USE_SOS_SVR) && defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/mapogl.cpp 8.2.0~beta1-1~exp1/mapogl.cpp
--- 8.0.1-5/mapogl.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogl.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,270 +0,0 @@
-/******************************************************************************
- * $id: mapogl.cpp 7725 2011-04-09 15:56:58Z toby $
- *
- * Project:  MapServer
- * Purpose:  Various template processing functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-#ifdef USE_OGL
-#include <stdio.h>
-#include <assert.h>
-#include "mapoglrenderer.h"
-#include "mapoglcontext.h"
-
-
-
-imageObj* createImageObjOgl(OglRenderer* renderer)
-{
-  if (!renderer->isValid()) return NULL;
-  imageObj* pNewImage = (imageObj*)calloc(1, sizeof(imageObj));
-  if (!pNewImage)
-    return pNewImage;
-  pNewImage->img.plugin = (void *) renderer;
-  return pNewImage;
-}
-
-OglRenderer* getOglRenderer(imageObj* img)
-{
-  return (OglRenderer*) img->img.plugin;
-}
-
-int msSaveImageOgl(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format)
-{
-  rasterBufferObj data;
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->readRasterBuffer(&data);
-  return msSaveRasterBuffer(NULL,&data,fp,img->format );
-}
-
-int msDrawLineOgl(imageObj *img, shapeObj *p, strokeStyleObj *style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderPolyline(p, style->color, style->width, style->patternlength, style->pattern);
-  return MS_SUCCESS;
-}
-
-int msDrawPolygonOgl(imageObj *img, shapeObj *p, colorObj *color)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderPolygon(p, color, NULL, 0);
-  return MS_SUCCESS;
-}
-
-//void msFreeTileOgl(imageObj *tile)
-//{
-//    delete (OglCache*)tile;
-//}
-
-int msDrawLineTiledOgl(imageObj *img, shapeObj *p, imageObj *tile)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderPolylineTile(p, getOglRenderer(tile)->getTexture());
-  return MS_SUCCESS;
-}
-
-int msDrawPolygonTiledOgl(imageObj *img, shapeObj *p, imageObj *tile)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderPolygon(p, NULL, NULL, 0.0, getOglRenderer(tile)->getTexture());
-  return MS_SUCCESS;
-}
-
-int msRenderPixmapOgl(imageObj *img, double x, double y,
-                      symbolObj *symbol, symbolStyleObj *style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderPixmap(symbol, x, y, style->rotation, style->scale);
-  return MS_SUCCESS;
-}
-
-int msRenderVectorSymbolOgl
-(imageObj *img, double x, double y,
- symbolObj *symbol, symbolStyleObj *style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderVectorSymbol(x, y, symbol, style->scale, style->rotation, style->color, style->outlinecolor, style->outlinewidth);
-  return MS_SUCCESS;
-}
-
-int msRenderTruetypeSymbolOgl(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj * style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  double size = style->scale*72.0;
-  renderer->renderGlyphs(0, 0, style->color, style->outlinecolor, size, symbol->font, symbol->character, style->rotation, NULL, 0, 0);
-  return MS_SUCCESS;
-}
-
-int msRenderTileOgl(imageObj *img, imageObj *tile, double x, double y)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderTile(getOglRenderer(tile)->getTexture(), x, y, 0.0);
-  return MS_SUCCESS;
-}
-
-int msGetTruetypeTextBBoxOgl(rendererVTableObj *renderer, char **fonts, int numfonts, double size, char *string, rectObj *rect, double **advances, int bAdjustBaseline)
-{
-  if (OglRenderer::getStringBBox(fonts[0], size, string, rect, advances)) {
-    return MS_SUCCESS;
-  } else {
-    return MS_FAILURE;
-  }
-}
-
-int msRenderGlyphsOgl(imageObj *img, double x, double y,
-                      labelStyleObj *style, char *text)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderGlyphs(x, y, style->color, style->outlinecolor, style->size, style->fonts[0], text, style->rotation, NULL, 0.0, 0.0);
-  return MS_SUCCESS;
-}
-
-int msMergeRasterBufferOgl(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height)
-{
-  OglRenderer* renderer = getOglRenderer(dest);
-  renderer->drawRasterBuffer(overlay, opacity, srcX, srcY, dstX, dstY, width, height);
-  return MS_SUCCESS;
-}
-
-imageObj* msImageCreateOgl(int width, int height, outputFormatObj *format, colorObj* bg)
-{
-  imageObj *pNewImage = NULL;
-
-  if (format->imagemode != MS_IMAGEMODE_RGB && format->imagemode
-      != MS_IMAGEMODE_RGBA) {
-    msSetError(
-      MS_OGLERR, "OpenGL driver only supports RGB or RGBA pixel models.",
-      "msImageCreateOGL()");
-    return NULL;
-  }
-  return createImageObjOgl(new OglRenderer(width, height, bg));
-}
-
-int msRenderEllipseOgl(imageObj *image, double x, double y,
-                       symbolObj *symbol, symbolStyleObj *style)
-{
-
-  OglRenderer* renderer = getOglRenderer(image);
-  renderer->renderEllipse(x, y, style->rotation, symbol->sizex, symbol->sizey, style->color, style->outlinecolor, style->outlinewidth);
-  return MS_SUCCESS;
-}
-
-int msFreeImageOgl(imageObj *img)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  if (renderer) {
-    delete renderer;
-  }
-  img->img.plugin=NULL;
-  return MS_SUCCESS;
-}
-
-int msStartLayerOgl(imageObj *img, mapObj *map, layerObj *layer)
-{
-  getOglRenderer(img)->setTransparency((double)layer->opacity/100);
-  return MS_SUCCESS;
-}
-
-int msEndLayerOgl(imageObj *img, mapObj *map, layerObj *layer)
-{
-  getOglRenderer(img)->setTransparency(1.0);
-  return MS_SUCCESS;
-}
-
-int msFreeSymbolOgl(symbolObj *s)
-{
-  return MS_SUCCESS;
-}
-
-int msGetRasterBufferCopyOgl(imageObj *img, rasterBufferObj *rb)
-{
-  getOglRenderer(img)->readRasterBuffer(rb);
-  return MS_SUCCESS;
-}
-
-int msGetRasterBufferHandleOgl(imageObj *img, rasterBufferObj * rb)
-{
-  getOglRenderer(img)->readRasterBuffer(rb);
-  return MS_SUCCESS;
-}
-
-int msInitializeRasterBufferOgl(rasterBufferObj *rb, int width, int height, int mode)
-{
-  OglRenderer::initializeRasterBuffer(rb, width, height, mode==MS_IMAGEMODE_RGBA);
-  return MS_SUCCESS;
-}
-
-#endif /* USE_OGL */
-
-int msPopulateRendererVTableOGL(rendererVTableObj *renderer)
-{
-#ifdef USE_OGL
-  renderer->supports_transparent_layers = 1;
-  renderer->supports_pixel_buffer = 1;
-  renderer->supports_clipping = 0;
-  renderer->use_imagecache = 0;
-  renderer->supports_bitmap_fonts = 0;
-  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
-  renderer->startLayer = msStartLayerOgl;
-  renderer->endLayer = msEndLayerOgl;
-
-  renderer->createImage=&msImageCreateOgl;
-  renderer->saveImage=&msSaveImageOgl;
-
-
-  renderer->renderLine=&msDrawLineOgl;
-  renderer->renderPolygon=&msDrawPolygonOgl;
-  renderer->renderGlyphs=&msRenderGlyphsOgl;
-  renderer->renderEllipseSymbol = &msRenderEllipseOgl;
-  renderer->renderVectorSymbol = &msRenderVectorSymbolOgl;
-  renderer->renderPixmapSymbol = &msRenderPixmapOgl;
-  renderer->renderTruetypeSymbol = &msRenderTruetypeSymbolOgl;
-
-  renderer->renderTile = &msRenderTileOgl;
-  renderer->renderPolygonTiled = &msDrawPolygonTiledOgl;
-  renderer->renderLineTiled = &msDrawLineTiledOgl;
-
-  renderer->getTruetypeTextBBox = &msGetTruetypeTextBBoxOgl;
-
-  renderer->getRasterBufferHandle = msGetRasterBufferHandleOgl;
-  renderer->getRasterBufferCopy = msGetRasterBufferCopyOgl;
-  renderer->initializeRasterBuffer = msInitializeRasterBufferOgl;
-  renderer->mergeRasterBuffer = msMergeRasterBufferOgl;
-  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
-
-  renderer->freeSymbol = &msFreeSymbolOgl;
-  renderer->freeImage=&msFreeImageOgl;
-
-  return MS_SUCCESS;
-#else
-  msSetError(MS_MISCERR,"OGL driver requested but it is not compiled in this release",
-             "msPopulateRendererVTableOGL()");
-  return MS_FAILURE;
-#endif
-
-}
-
diff -pruN 8.0.1-5/mapoglcontext.cpp 8.2.0~beta1-1~exp1/mapoglcontext.cpp
--- 8.0.1-5/mapoglcontext.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapoglcontext.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,472 +0,0 @@
-/******************************************************************************
- * $id: mapoglcontext.cpp 7725 2011-04-09 15:56:58Z toby $
- *
- * Project:  MapServer
- * Purpose:  Various template processing functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifdef USE_OGL
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapoglcontext.h"
-
-
-
-#define _T(x) __TEXT(x)
-
-ms_uint32 OglContext::MAX_MULTISAMPLE_SAMPLES = 16;
-ms_uint32 OglContext::MAX_ANISOTROPY = 0;
-ms_uint32 OglContext::MAX_TEXTURE_SIZE = 0;
-ms_uint32 OglContext::MIN_TEXTURE_SIZE = 0;
-OglContext* OglContext::current = NULL;
-
-OglContext::OglContext(ms_uint32 width, ms_uint32 height)
-  : valid(false)
-{
-  if (!window && !initWindow()) return;
-  if (!sharingContext && !initSharingContext()) return;
-
-  if (!(this->width = getTextureSize(GL_TEXTURE_WIDTH, width))) return;
-  if (!(this->height = getTextureSize(GL_TEXTURE_HEIGHT, height))) return;
-
-  if (!createPBuffer(this->width, this->height)) return;
-  if (!makeCurrent()) return;
-  valid = true;
-}
-
-ms_uint32 OglContext::getTextureSize(GLuint dimension, ms_uint32 value)
-{
-  glTexImage2D(GL_PROXY_TEXTURE_2D, 0, GL_RGBA,  value, value, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);
-  GLint check = 0;
-  glGetTexLevelParameteriv(GL_PROXY_TEXTURE_2D, 0, dimension, &check);
-
-  if (glGetError() != GL_NO_ERROR) {
-    msSetError(MS_OGLERR, "glGetTexLevelParameteriv failed. glError: %d", "OglContext::getTextureSize()", glGetError());
-  }
-
-  if (check == 0) {
-    return MS_MAX(MS_MIN(NextPowerOf2(value), OglContext::MAX_TEXTURE_SIZE), OglContext::MIN_TEXTURE_SIZE);
-  } else {
-    msSetError(MS_OGLERR, "Unable to create opengl texture of map size", "OglContext::getTextureSize()");
-    return value;
-  }
-}
-
-GLuint OglContext::NextPowerOf2(GLuint in)
-{
-  in -= 1;
-
-  in |= in >> 16;
-  in |= in >> 8;
-  in |= in >> 4;
-  in |= in >> 2;
-  in |= in >> 1;
-
-  return in + 1;
-}
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-
-HDC OglContext::window = NULL;
-HGLRC OglContext::sharingContext = NULL;
-
-LRESULT CALLBACK WndProc(HWND hWnd,
-                         UINT message,
-                         WPARAM wParam,
-                         LPARAM lParam)
-{
-  return(1L);
-}
-
-OglContext::~OglContext()
-{
-  //TODO
-}
-
-bool OglContext::makeCurrent()
-{
-  if (current != this) {
-    current = this;
-    if (!wglMakeContextCurrentARB(hPBufferDC, hPBufferDC, hPBufferRC)) {
-      msSetError(MS_OGLERR, "Can't Activate The GL Rendering pbuffer.", "OglContext::makeCurrent()");
-      return FALSE;
-    }
-  }
-  return true;
-}
-
-bool OglContext::initWindow()
-{
-  int windowPixelFormat;
-  WNDCLASS wc;
-  DWORD dwExStyle;
-  DWORD dwStyle;
-  RECT WindowRect;
-  HMODULE hInstance = NULL;
-  HWND hWnd = NULL;
-  WindowRect.left=(long)0;
-  WindowRect.right=(long)0;
-  WindowRect.top=(long)0;
-  WindowRect.bottom=(long)0;
-  hInstance = GetModuleHandle(NULL);
-  wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
-  wc.cbClsExtra = 0;
-  wc.cbWndExtra = 0;
-  wc.lpfnWndProc = (WNDPROC) WndProc;
-  wc.hInstance = hInstance;
-  wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
-  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
-  wc.hbrBackground = NULL;
-  wc.lpszMenuName = NULL;
-  wc.lpszClassName = _T("OpenGL");
-
-  if (!RegisterClass(&wc)) {
-    msSetError(MS_OGLERR, "Failed To Register The Window Class.", "OglContext::initWindow()");
-    return FALSE;
-  }
-  dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
-  dwStyle=WS_OVERLAPPEDWINDOW;
-
-  AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);
-
-  if (!(hWnd=CreateWindowEx( dwExStyle,
-                             _T("OpenGL"),
-                             _T("temp"),
-                             dwStyle |
-                             WS_CLIPSIBLINGS |
-                             WS_CLIPCHILDREN,
-                             0, 0,
-                             WindowRect.right-WindowRect.left,
-                             WindowRect.bottom-WindowRect.top,
-                             NULL,
-                             NULL,
-                             hInstance,
-                             NULL))) {
-    msSetError(MS_OGLERR, "Window Creation Error.", "OglContext::initWindow()");
-    return FALSE;
-  }
-
-  static PIXELFORMATDESCRIPTOR pfd= {
-    sizeof(PIXELFORMATDESCRIPTOR),
-    1,
-    PFD_DRAW_TO_WINDOW |
-    PFD_SUPPORT_OPENGL |
-    PFD_DOUBLEBUFFER,
-    PFD_TYPE_RGBA,
-    24, // Select Our Color Depth
-    0, 0, 0, 0, 0, 0, // Color Bits Ignored
-    8, // Alpha Buffer
-    0, // Shift Bit Ignored
-    0, // No Accumulation Buffer
-    0, 0, 0, 0, // Accumulation Bits Ignored
-    16, // 16Bit Z-Buffer (Depth Buffer)
-    0, // No Stencil Buffer
-    0, // No Auxiliary Buffer
-    PFD_MAIN_PLANE, // Main Drawing Layer
-    0, // Reserved
-    0, 0, 0 // Layer Masks Ignored
-  };
-
-  if (!(window=GetDC(hWnd))) {
-    msSetError(MS_OGLERR, "Can't Create A GL Device Context.. Last Error: %d", "OglContext::initWindow()", GetLastError());
-    return FALSE;
-  }
-
-  if (!(windowPixelFormat=ChoosePixelFormat(window,&pfd))) {
-    msSetError(MS_OGLERR, "Can't Find A Suitable windowPixelFormat. Last Error: %d", "OglContext::initWindow()", GetLastError());
-    return FALSE;
-  }
-
-  if(!SetPixelFormat(window,windowPixelFormat,&pfd)) {
-    msSetError(MS_OGLERR, "Can't Set The windowPixelFormat. Last Error: %d", "OglContext::initWindow()", GetLastError());
-    return FALSE;
-  }
-  return TRUE;
-}
-
-bool OglContext::initSharingContext()
-{
-  if (!(sharingContext=wglCreateContext(window))) {
-    msSetError(MS_OGLERR, "Can't Create A GL Rendering Context.", "OglContext::createContext()");
-    return FALSE;
-  }
-
-  if(!wglMakeCurrent(window,sharingContext)) {
-    msSetError(MS_OGLERR, "Can't Activate The GL Rendering Context.", "OglContext::createContext()");
-    return FALSE;
-  }
-
-  if (!(wglChoosePixelFormatARB = (PFNWGLCHOOSEPIXELFORMATARBPROC)wglGetProcAddress("wglChoosePixelFormatARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglChoosePixelFormatARB method.", "OglContext::createContext()");
-    return FALSE;
-  }
-
-  if (!(wglCreatePbufferARB = (PFNWGLCREATEPBUFFERARBPROC)wglGetProcAddress("wglCreatePbufferARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglCreatePbufferARB method.", "OglContext::createContext()");
-    return FALSE;
-  }
-
-  if (!(wglGetPbufferDCARB = (PFNWGLGETPBUFFERDCARBPROC)wglGetProcAddress("wglGetPbufferDCARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglGetPbufferDCARB method.", "OglContext::createContext()");
-    return FALSE;
-  }
-
-  if (!(wglReleasePbufferDCARB = (PFNWGLRELEASEPBUFFERDCARBPROC)wglGetProcAddress("wglReleasePbufferDCARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglReleasePbufferDCARB method.", "OglContext::createContext()");
-    return FALSE;
-  }
-
-  if (!(wglMakeContextCurrentARB = (PFNWGLMAKECONTEXTCURRENTARBPROC)wglGetProcAddress("wglMakeContextCurrentARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglMakeContextCurrentARB method.", "OglContext::createContext()");
-    return FALSE;
-  }
-
-  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint*) &MAX_ANISOTROPY);
-  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint*)&MAX_TEXTURE_SIZE);
-
-  MIN_TEXTURE_SIZE = 8;
-
-
-  return TRUE;
-}
-
-bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height)
-{
-  HPBUFFERARB hPBuffer = NULL;
-  hPBufferDC = NULL;
-  hPBufferRC = NULL;
-
-  int pixelFormat;
-  int valid = false;
-  UINT numFormats = 0;
-  float fAttributes[] = {0,0};
-  int samples = MAX_MULTISAMPLE_SAMPLES;
-
-  while ((!valid || numFormats == 0) && samples >= 0) {
-    int iAttributes[] = {
-      WGL_SAMPLES_ARB,samples,
-      WGL_DRAW_TO_PBUFFER_ARB,GL_TRUE,
-      WGL_SUPPORT_OPENGL_ARB,GL_TRUE,
-      WGL_ACCELERATION_ARB,WGL_FULL_ACCELERATION_ARB,
-      WGL_COLOR_BITS_ARB,24,
-      WGL_ALPHA_BITS_ARB,8,
-      WGL_DEPTH_BITS_ARB,16,
-      WGL_STENCIL_BITS_ARB,0,
-      WGL_SAMPLE_BUFFERS_ARB,GL_TRUE,
-      WGL_PIXEL_TYPE_ARB, WGL_TYPE_RGBA_ARB,
-      0,0
-    };
-
-    valid = wglChoosePixelFormatARB(window,iAttributes,fAttributes,1,&pixelFormat,&numFormats);
-    if (!valid || numFormats == 0) samples -= 2;
-  }
-
-  if(numFormats == 0) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to find an acceptable pixel format.", "OglContext::createPBuffer()");
-    return FALSE;
-  }
-
-  if (!(hPBuffer = wglCreatePbufferARB(window, pixelFormat, width, height, 0))) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to create P-buffer. glError: %d", "OglContext::createPBuffer()", glGetError());
-    return FALSE;
-  }
-  if (!(hPBufferDC = wglGetPbufferDCARB(hPBuffer))) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to get P-buffer DC. glError: %d", "OglContext::createPBuffer()", glGetError());
-    return FALSE;
-  }
-  if (!(hPBufferRC = wglCreateContext(hPBufferDC))) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to get P-buffer DC. glError: %d", "OglContext::createPBuffer()", glGetError());
-    return FALSE;
-  }
-
-  if (wglShareLists(sharingContext,hPBufferRC) == FALSE) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to share display lists. glError: %d", "OglContext::createPBuffer()", glGetError());
-    return FALSE;
-  }
-
-  return TRUE;
-}
-
-PFNWGLCHOOSEPIXELFORMATARBPROC OglContext::wglChoosePixelFormatARB = NULL;
-PFNWGLCREATEPBUFFERARBPROC OglContext::wglCreatePbufferARB = NULL;
-PFNWGLGETPBUFFERDCARBPROC OglContext::wglGetPbufferDCARB = NULL;
-PFNWGLRELEASEPBUFFERDCARBPROC OglContext::wglReleasePbufferDCARB = NULL;
-PFNWGLMAKECONTEXTCURRENTARBPROC OglContext::wglMakeContextCurrentARB = NULL;
-
-#else /* UNIX */
-
-Display* OglContext::window = NULL;
-GLXContext OglContext::sharingContext = NULL;
-GLXFBConfig* OglContext::configs = NULL;
-
-OglContext::~OglContext()
-{
-  //TODO
-}
-
-
-bool OglContext::makeCurrent()
-{
-  if (current != this) {
-    current = this;
-    if (!glXMakeCurrent(window, pbuffer, sharingContext)) {
-      msSetError(MS_OGLERR, "glXMakeCurrent failed. glError: %d", "OglContext::makeCurrent()", glGetError());
-      return false;
-    }
-  }
-  return true;
-}
-
-bool OglContext::initSharingContext()
-{
-  int fb_attributes[] = {
-    GLX_SAMPLES_ARB, MAX_MULTISAMPLE_SAMPLES,
-    GLX_RENDER_TYPE, GLX_RGBA_BIT,
-    GLX_DRAWABLE_TYPE, GLX_PBUFFER_BIT,
-    GLX_RED_SIZE, 8,
-    GLX_GREEN_SIZE, 8,
-    GLX_BLUE_SIZE, 8,
-    GLX_ALPHA_SIZE, 8,
-    GLX_DEPTH_SIZE, 16,
-    GLX_DOUBLEBUFFER, 0,
-    GLX_SAMPLE_BUFFERS_ARB, 1,
-    0
-  };
-
-  int num_configs = 0;
-  while (num_configs == 0 && fb_attributes[1] >= 0) {
-    configs = glXChooseFBConfig(window, DefaultScreen(window), fb_attributes, &num_configs);
-    fb_attributes[1] -= 2;
-  }
-
-  if (configs == NULL || num_configs == 0) {
-    msSetError(MS_OGLERR, "glXChooseFBConfig could not find any configs. Likely your video card or drivers are not supported. glError: %d", "OglContext::init()", glGetError());
-    return false;
-  }
-
-  sharingContext = glXCreateNewContext(window, *configs, GLX_RGBA_TYPE, NULL, 1);
-  if (sharingContext == NULL) {
-    msSetError(MS_OGLERR, "glXCreateNewContext failed. glError: %d", "OglContext::initSharingContext()", glGetError());
-    return false;
-  }
-
-  return true;
-}
-
-bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height)
-{
-  int maxHeight, maxWidth;
-
-  glXGetFBConfigAttrib(window, *configs, GLX_MAX_PBUFFER_WIDTH, &maxWidth);
-  glXGetFBConfigAttrib(window, *configs, GLX_MAX_PBUFFER_HEIGHT, &maxHeight);
-
-  ms_uint32 uMaxHeight = maxHeight, uMaxWidth = maxWidth;
-
-  this->width = MS_MIN(width, uMaxWidth);
-  this->height = MS_MIN(height, uMaxHeight);
-
-  int iPbufferAttributes[] = {
-    GLX_PBUFFER_WIDTH, this->width,
-    GLX_PBUFFER_HEIGHT, this->height,
-    GLX_LARGEST_PBUFFER, false,
-    0, 0
-  };
-
-  pbuffer = glXCreatePbuffer(window, *configs, iPbufferAttributes);
-  if (pbuffer == 0) {
-    msSetError(MS_OGLERR, "glXCreatePbuffer failed. glError: %d", "OglContext::init()", glGetError());
-    return false;
-  }
-
-  return true;
-}
-
-bool OglContext::initWindow()
-{
-  const char* const display_name = getenv("DISPLAY");
-  if (!display_name) {
-    msSetError(MS_OGLERR, "DISPLAY environment variable not set", "OglContext::init()");
-    return false;
-  }
-
-  window = XOpenDisplay(display_name);
-  if (!window) {
-    msSetError(MS_OGLERR, "XOpenDisplay() failed.", "OglContext::init()");
-    return false;
-  }
-
-  const int fb_attributes[] = {
-    GLX_RENDER_TYPE, GLX_RGBA_BIT,
-    GLX_DRAWABLE_TYPE, GLX_PBUFFER_BIT,
-    GLX_RED_SIZE, 8,
-    GLX_GREEN_SIZE, 8,
-    GLX_BLUE_SIZE, 8,
-    GLX_ALPHA_SIZE, 8,
-    GLX_DEPTH_SIZE, 16,
-    GLX_DOUBLEBUFFER, 0,
-    GLX_SAMPLE_BUFFERS_ARB, 1,
-    0
-  };
-
-  int num_configs = 0;
-  GLXFBConfig* tempConfigs = glXChooseFBConfig(window, DefaultScreen(window), fb_attributes, &num_configs);
-
-  if (tempConfigs == NULL || num_configs == 0) {
-    msSetError(MS_OGLERR, "glXChooseFBConfig could not find any configs. Likely your video card or drivers are not supported.", "OglContext::initWindow()");
-    return false;
-  }
-
-  GLXContext tempContext = glXCreateNewContext(window, *tempConfigs, GLX_RGBA_TYPE, NULL, 1);
-  if (tempContext == NULL) {
-    msSetError(MS_OGLERR, "glXCreateNewContext failed.", "OglContext::initWindow()");
-    return false;
-  }
-
-  int iPbufferAttributes[] =    {0, 0};
-
-  GLXPbuffer tempBuffer = glXCreatePbuffer(window, *tempConfigs, iPbufferAttributes);
-  if (tempBuffer == 0) {
-    msSetError(MS_OGLERR, "glXCreatePbuffer failed.", "OglContext::initWindow()");
-    return false;
-  }
-
-  if (!glXMakeCurrent(window, tempBuffer, tempContext)) {
-    msSetError(MS_OGLERR, "glXMakeCurrent failed.", "OglContext::initWindow()");
-    return false;
-  }
-
-  glGetIntegerv(GL_MAX_SAMPLES_EXT, (GLint*)&MAX_MULTISAMPLE_SAMPLES);
-  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint*) &MAX_ANISOTROPY);
-  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint*)&MAX_TEXTURE_SIZE);
-
-  MIN_TEXTURE_SIZE = 8;
-
-  return true;
-}
-
-#endif /* UNIX */
-
-#endif /* USE_OGL */
diff -pruN 8.0.1-5/mapoglcontext.h 8.2.0~beta1-1~exp1/mapoglcontext.h
--- 8.0.1-5/mapoglcontext.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapoglcontext.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,124 +0,0 @@
-/******************************************************************************
- * $id: mapoglcontext.h 7725 2011-04-09 15:56:58Z toby $
- *
- * Project:  MapServer
- * Purpose:  Various template processing functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPOGLCONTEXT_H_
-#define MAPOGLCONTEXT_H_
-
-#ifdef USE_OGL
-
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-
-#include <windows.h>
-#include<GL/gl.h>
-#include<GL/glu.h>
-
-#include "opengl/glext.h"
-#include "opengl/wglext.h"
-
-typedef HDC OGL_WINDOW;
-typedef HGLRC OGL_CONTEXT;
-typedef HGLRC OGL_PBUFFER;
-
-#define CALLBACK __stdcall
-
-#else
-
-#include<GL/gl.h>
-#include<GL/glx.h>
-#include<GL/glu.h>
-
-typedef Display* OGL_WINDOW;
-typedef GLXContext OGL_CONTEXT;
-typedef GLXPbuffer OGL_PBUFFER;
-
-#define CALLBACK
-
-#endif
-
-class OglRenderer;
-
-class OglContext
-{
-private:
-  static OglContext* current;
-  static bool initWindow();
-  static bool initSharingContext();
-  static ms_uint32 getTextureSize(GLuint dimension, ms_uint32 value);
-  static GLuint NextPowerOf2(GLuint in);
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-  static HDC window;
-  static HGLRC sharingContext;
-  HDC hPBufferDC;
-  HGLRC hPBufferRC;
-#else
-  static Display* window;
-  static GLXContext sharingContext;
-  static GLXFBConfig* configs;
-  GLXPbuffer pbuffer;
-#endif
-
-public:
-  static ms_uint32 MAX_MULTISAMPLE_SAMPLES;
-  static ms_uint32 MAX_ANISOTROPY;
-  static ms_uint32 MAX_TEXTURE_SIZE;
-  static ms_uint32 MIN_TEXTURE_SIZE;
-
-  OglContext(ms_uint32 width, ms_uint32 height);
-  ~OglContext();
-  int getHeight() const {
-    return height;
-  }
-  int getWidth() const {
-    return width;
-  }
-  bool isValid() const {
-    return valid;
-  }
-  bool makeCurrent();
-  void bindPBufferToTexture();
-private:
-  bool createPBuffer(ms_uint32 width, ms_uint32 height);
-  ms_uint32 width;
-  ms_uint32 height;
-  bool valid;
-  int windowPixelFormat;
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-  static PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB;
-  static PFNWGLCREATEPBUFFERARBPROC wglCreatePbufferARB;
-  static PFNWGLGETPBUFFERDCARBPROC wglGetPbufferDCARB;
-  static PFNWGLRELEASEPBUFFERDCARBPROC wglReleasePbufferDCARB;
-  static PFNWGLMAKECONTEXTCURRENTARBPROC wglMakeContextCurrentARB;
-#endif
-};
-
-#endif /* USE_OGL */
-#endif /* MAPOGLCONTEXT_H_ */
diff -pruN 8.0.1-5/mapoglrenderer.cpp 8.2.0~beta1-1~exp1/mapoglrenderer.cpp
--- 8.0.1-5/mapoglrenderer.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapoglrenderer.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,758 +0,0 @@
-/******************************************************************************
- * $id: mapoglrenderer.cpp 7725 2011-04-09 15:56:58Z toby $
- *
- * Project:  MapServer
- * Purpose:  Various template processing functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifdef USE_OGL
-
-#include <algorithm>
-#include <fstream>
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapoglrenderer.h"
-
-
-
-using namespace std;
-
-double OglRenderer::SIZE_RES = 100.0 / 72.0;
-ms_uint32 OglRenderer::OUTLINE_WIDTH = 2;
-ms_uint32 OglRenderer::FONT_SIZE = 20;
-ms_uint32 OglRenderer::FONT_RES = 200;
-double OglRenderer::OGL_PI = 3.14159265;
-ms_uint32 OglRenderer::SHAPE_CIRCLE_RES = 10;
-double OglRenderer::SHAPE_CIRCLE_RADIUS = 10.0;
-
-OglRenderer::fontCache_t OglRenderer::fontCache = OglRenderer::fontCache_t();
-OglRenderer::dashCache_t OglRenderer::dashCache = OglRenderer::dashCache_t();
-std::vector<GLuint> OglRenderer::shapes = std::vector<GLuint>();
-
-GLvoid CALLBACK beginCallback(GLenum which);
-GLvoid CALLBACK errorCallback(GLenum errorCode);
-GLvoid CALLBACK endCallback(void);
-GLvoid CALLBACK combineDataCallback(GLdouble coords[3], GLdouble* vertex_data[4], GLfloat weight[4], void** dataOut, void* polygon_data);
-GLvoid CALLBACK vertexCallback(GLdouble *vertex);
-
-OglRenderer::OglRenderer(ms_uint32 width, ms_uint32 height, colorObj* color)
-  : width(width), height(height), texture(NULL), transparency(1.0), valid(false)
-{
-  context = new OglContext(width, height);
-  if (!context->isValid()) return;
-  if (!context->makeCurrent()) return;
-
-  int viewPort[4];
-  glGetIntegerv(GL_VIEWPORT ,viewPort);
-  viewportX = viewPort[0];
-  viewportY = viewPort[1];
-  viewportWidth = viewPort[2];
-  viewportHeight = viewPort[3];
-
-  glPushMatrix();
-
-  // set read/write context to pbuffer
-  glEnable(GL_MULTISAMPLE_ARB);
-  glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);
-
-  glEnable(GL_TEXTURE_2D);
-  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE );
-  glEnable(GL_BLEND);
-  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
-
-  glDisable(GL_DEPTH_TEST);
-  glDepthFunc(GL_LEQUAL);
-
-  // draw & read the front buffer of pbuffer
-  glDrawBuffer(GL_FRONT);
-  glReadBuffer(GL_FRONT);
-
-  if (!(tess = gluNewTess())) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to create tessalotor",
-               "OglRenderer");
-    return;
-  }
-
-  gluTessCallback(tess, GLU_TESS_VERTEX, (void (CALLBACK*)(void)) vertexCallback);
-  gluTessCallback(tess, GLU_TESS_BEGIN, (void(CALLBACK*)(void)) beginCallback);
-  gluTessCallback(tess, GLU_TESS_END, (void(CALLBACK*)(void)) endCallback);
-  gluTessCallback(tess, GLU_TESS_ERROR, (void(CALLBACK*)(void)) errorCallback);
-  gluTessCallback(tess, GLU_TESS_COMBINE_DATA, (void(CALLBACK*)(void)) combineDataCallback);
-
-  if (color) {
-    glClearColor((double) color->red / 255,
-                 (double) color->green / 255,
-                 (double) color->blue / 255,
-                 (double)color->alpha / 100);
-  } else {
-    glClearColor(0.0, 0.0, 0.0, 0.0);
-  }
-  glClear(GL_COLOR_BUFFER_BIT);
-
-  glViewport(0, 0, width, height);
-  glMatrixMode(GL_PROJECTION);
-  glLoadIdentity();
-  glOrtho(0.0, width, 0.0, height, -3.0, 3.0);
-
-  createShapes();
-  valid = true;
-}
-
-OglRenderer::~OglRenderer()
-{
-  makeCurrent();
-  glViewport(viewportX, viewportY, viewportWidth, viewportHeight);
-  glPopMatrix();
-  delete context;
-}
-
-OglCachePtr OglRenderer::getTexture()
-{
-  if (!texture) {
-    makeCurrent();
-    texture = new OglCache();
-    texture->texture = createTexture(0,0);//TEXTURE_BORDER/2, TEXTURE_BORDER/2);
-    texture->width = this->width;
-    texture->height = this->height;
-  }
-  return texture;
-}
-
-GLuint OglRenderer::createTexture(ms_uint32 offsetX, ms_uint32 offsetY)
-{
-  GLuint texture = 0;
-  glGenTextures(1, &texture);
-  glBindTexture(GL_TEXTURE_2D, texture);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
-  glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_NEAREST);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_NEAREST);
-  if (OglContext::MAX_ANISOTROPY != 0) {
-    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, OglContext::MAX_ANISOTROPY);
-  }
-  glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, offsetX, offsetY, context->getWidth(), context->getHeight(), 0);
-  glBindTexture(GL_TEXTURE_2D,0);
-  return texture;
-}
-
-bool OglRenderer::getStringBBox(char *font, double size, char *string, rectObj *rect, double** advances)
-{
-  FTFont* face = getFTFont(font, size);
-  if (!face) {
-    msSetError(MS_OGLERR, "Failed to load font (%s).", "OglRenderer::getStringBBox()", font);
-    return false;
-  }
-
-  float llx =0.0f, lly=0.0f, llz=0.0f, urx=0.0f, ury=0.0f, urz=0.0f;
-  glPushAttrib( GL_ALL_ATTRIB_BITS );
-  FTBBox boundingBox = face->BBox(string);
-  glPopAttrib();
-
-  rect->minx = boundingBox.Lower().X();
-  rect->maxx = boundingBox.Upper().X();
-  rect->miny = -boundingBox.Upper().Y();
-  rect->maxy = -boundingBox.Lower().Y();
-
-  if (advances) {
-    int length = strlen(string);
-    *advances = new double[length];
-    for (int i = 0; i < length; ++i) {
-      (*advances)[i] = face->Advance(&string[i], 1);
-    }
-  }
-
-  return true;
-}
-
-void OglRenderer::initializeRasterBuffer(rasterBufferObj * rb, int width, int height, bool useAlpha)
-{
-  unsigned char* buffer = new unsigned char[4 * width * height];
-  rb->data.rgba.pixels = buffer;
-  rb->data.rgba.r = &buffer[2];
-  rb->data.rgba.g = &buffer[1];
-  rb->data.rgba.b = &buffer[0];
-  if (useAlpha) rb->data.rgba.a = &buffer[3];
-
-  rb->type =MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.row_step = 4*width;
-  rb->data.rgba.pixel_step = 4;
-  rb->width = width;
-  rb->height = height;
-}
-
-void OglRenderer::readRasterBuffer(rasterBufferObj * rb)
-{
-  makeCurrent();
-  unsigned char* buffer = new unsigned char[4 * width * height];
-  glReadPixels(0, 0, width, height, GL_BGRA, GL_UNSIGNED_BYTE, buffer);
-
-  rb->type =MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.pixels = buffer;
-  rb->data.rgba.row_step = 4*width;
-  rb->data.rgba.pixel_step = 4;
-  rb->width = width;
-  rb->height = height;
-  rb->data.rgba.r = &buffer[2];
-  rb->data.rgba.g = &buffer[1];
-  rb->data.rgba.b = &buffer[0];
-  rb->data.rgba.a = NULL;
-}
-
-void OglRenderer::drawRasterBuffer(rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height)
-{
-  // todo to support all alpha and srcx/y this needs to be done by creating a texture
-  makeCurrent();
-  glDrawPixels(width, height, GL_BGRA, GL_UNSIGNED_BYTE, overlay->data.rgba.pixels);
-}
-
-void OglRenderer::setTransparency(double transparency)
-{
-  this->transparency = transparency;
-}
-
-void OglRenderer::setColor(colorObj *color)
-{
-  if (color && MS_VALID_COLOR(*color)) {
-    glColor4d((double) color->red / 255, (double) color->green / 255, (double) color->blue / 255, transparency);
-  } else {
-    glColor4d(0.0, 0.0, 0.0, 1.0);
-  }
-}
-
-void OglRenderer::drawVectorLineStrip(symbolObj *symbol, double width)
-{
-  glPushMatrix();
-  glLineWidth(width);
-  glBegin(GL_LINE_STRIP);
-  for (int i = 0; i < symbol->numpoints; i++) {
-    if (symbol->points[i].x < 0 && symbol->points[i].y < 0) {
-      glEnd();
-      glBegin(GL_LINE_STRIP);
-    } else {
-      glVertex2d(symbol->points[i].x, symbol->points[i].y);
-    }
-  }
-  glEnd();
-
-  glPopMatrix();
-}
-
-double OglRenderer::drawTriangles(pointObj* p1, pointObj* p2, double width, double tilelength, double textureStart)
-{
-  double dx = p1->x - p2->x;
-  double dy = p1->y - p2->y;
-  double dist = sqrt(dx * dx + dy * dy);
-  double theta;
-  if (dx != 0)
-    theta = atan(dy / dx);
-  else
-    theta = (dy > 0 ? 1 : -1) * OGL_PI / 2;
-
-  double xw = sin(theta) * width / 2;
-  double yw = cos(theta) * width / 2;
-
-  double textureEnd = dist / tilelength;
-
-  glTexCoord2d(textureStart, 1);
-  glVertex2d(p1->x + xw, p1->y - yw); // Bottom Left Of The Texture and Quad
-  glTexCoord2d(textureStart, 0);
-  glVertex2d(p1->x - xw, p1->y + yw); // Bottom Right Of The Texture and Quad
-  glTexCoord2d(textureStart + textureEnd, 1);
-  glVertex2d(p2->x + xw, p2->y - yw); // Top Right Of The Texture and Quad
-  glTexCoord2d(textureStart + textureEnd, 0);
-  glVertex2d(p2->x - xw, p2->y + yw); // Top Left Of The Texture and Quad
-
-  return dist;
-}
-
-double OglRenderer::drawQuad(pointObj* p1, pointObj* p2, double width, double tilelength, double textureStart)
-{
-  double dx = p1->x - p2->x;
-  double dy = p1->y - p2->y;
-  double dist = sqrt(dx * dx + dy * dy);
-  double theta;
-  if (dx)
-    theta = atan(dy / dx);
-  else
-    theta = (dy > 0 ? 1 : -1) * OGL_PI / 2;
-
-  glPushMatrix();
-  glTranslated(p1->x, p1->y, 0);
-  glRotated((p1->x < p2->x ? 0 : 180) + theta * (180 / OGL_PI), 0, 0, 1);
-  glTranslated(-p1->x, -p1->y, 0);
-
-  glBegin(GL_QUADS);
-  glTexCoord2d(textureStart, 1);
-  glVertex2d(p1->x, p1->y - width / 2); // Bottom Left Of The Texture and Quad
-  glTexCoord2d(textureStart + (dist / tilelength), 1);
-  glVertex2d(p1->x + dist, p1->y - width / 2); // Bottom Right Of The Texture and Quad
-  glTexCoord2d(textureStart + (dist / tilelength), 0);
-  glVertex2d(p1->x + dist, p1->y + width / 2); // Top Right Of The Texture and Quad
-  glTexCoord2d(textureStart, 0);
-  glVertex2d(p1->x, p1->y + width / 2); // Top Left Of The Texture and Quad
-  glEnd();
-
-  glPopMatrix();
-
-  return dist;
-}
-
-void OglRenderer::renderTile(const OglCachePtr& tile, double x, double y, double angle)
-{
-  makeCurrent();
-  glEnable(GL_SAMPLE_ALPHA_TO_COVERAGE_ARB);
-  glBindTexture(GL_TEXTURE_2D, tile->texture);
-  glPushMatrix();
-  glTranslated(x, y, 0);
-  if (angle) {
-    glRotated(angle, 0, 0, 1);
-  }
-  glTranslated(-x, -y, 0);
-  glBegin(GL_QUADS);
-  glTexCoord2d(0, 1);
-  glVertex2d( x-(tile->width/2), y+(tile->height/2));    // Bottom Left Of The Texture and Quad
-  glTexCoord2d(1, 1);
-  glVertex2d( x+(tile->width/2), y+(tile->height/2));    // Bottom Right Of The Texture and Quad
-  glTexCoord2d(1, 0);
-  glVertex2d( x+(tile->width/2), y-(tile->height/2));    // Top Right Of The Texture and Quad
-  glTexCoord2d(0, 0);
-  glVertex2d( x-(tile->width/2), y-(tile->height/2));    // Top Left Of The Texture and Quad
-  glEnd();
-
-  glPopMatrix();
-  glBindTexture(GL_TEXTURE_2D, 0);
-  glDisable(GL_SAMPLE_ALPHA_TO_COVERAGE_ARB);
-}
-
-void OglRenderer::renderPolylineTile(shapeObj *shape, const OglCachePtr& tile)
-{
-  makeCurrent();
-  glBindTexture(GL_TEXTURE_2D, tile->texture); // Select Our Texture
-  glBegin(GL_TRIANGLE_STRIP);
-
-  double place = 0.0;
-  for (int i = 0; i < shape->numlines; i++) {
-    for (int j = 0; j < shape->line[i].numpoints - 1; j++) {
-      double dist = drawTriangles(&shape->line[i].point[j], &shape->line[i].point[j + 1], tile->height, tile->width, place / tile->width);
-      place = (place + dist);
-      while (place >= tile->width) place -= tile->width;
-    }
-  }
-  glEnd();
-  glBindTexture(GL_TEXTURE_2D, 0);
-}
-
-
-void OglRenderer::renderVectorSymbol(double x, double y, symbolObj *symbol, double scale, double angle, colorObj *c, colorObj *oc, double ow)
-{
-  makeCurrent();
-  glPushMatrix();
-  glTranslated(x, y, 0);
-  glRotated(angle, 0, 0, 1);
-  glScaled(scale, scale, 0);
-
-  glTranslated(-symbol->sizex/2, -symbol->sizey/2, 0.0);
-
-  if (oc != NULL && MS_VALID_COLOR(*oc) && ow > 0) {
-    setColor(oc);
-    drawVectorLineStrip(symbol, ow);
-  }
-
-  if (c != NULL && MS_VALID_COLOR(*c) && ow > 0) {
-    setColor(c);
-    drawVectorLineStrip(symbol, ow);
-  }
-
-  glPopMatrix();
-}
-
-void OglRenderer::renderPolyline(shapeObj *p, colorObj *c, double width,
-                                 int patternlength, double* pattern, int lineCap, int joinStyle,
-                                 colorObj *outlinecolor, double outlinewidth)
-{
-  makeCurrent();
-  if (outlinecolor) {
-    glEnable(GL_DEPTH_TEST);
-    glPushMatrix();
-    glTranslated(0, 0, 1);
-  }
-
-  setColor(c);
-
-  if (patternlength > 0) {
-    if (p->renderer_cache == NULL) {
-      loadLine(p, width, patternlength, pattern);
-    }
-    /* FIXME */
-    if (p->renderer_cache == NULL)
-      return;
-    OglCache* cache = (OglCache*) p->renderer_cache;
-    GLuint texture = cache->texture;
-    if (cache->patternDistance > 0) {
-      glBindTexture(GL_TEXTURE_2D, texture);
-      double place = 0;
-      glBegin(GL_TRIANGLE_STRIP);
-      for (int j = 0; j < p->numlines; j++) {
-        for (int i = 0; i < p->line[j].numpoints - 1; i++) {
-          double dist = drawTriangles(&p->line[j].point[i],
-                                      &p->line[j].point[i + 1], width,
-                                      cache->patternDistance, place
-                                      / cache->patternDistance);
-          place = (place + dist);
-          while (place >= cache->patternDistance)
-            place -= cache->patternDistance; // better than mod, no rounding
-        }
-      }
-      glEnd();
-      glBindTexture(GL_TEXTURE_2D, 0);
-    }
-  } else {
-    float widthRange[2];
-    glGetFloatv(GL_LINE_WIDTH_RANGE, widthRange);
-    bool quads = !(width >= widthRange[0] && width <= widthRange[1]);
-    double circleScale = width / SHAPE_CIRCLE_RADIUS / 2;
-    glLineWidth(width);
-    if (quads || (width > 1.0 && (lineCap == MS_CJC_ROUND || joinStyle == MS_CJC_ROUND))) {
-      for (int j = 0; j < p->numlines; j++) {
-        for (int i = 0; i < p->line[j].numpoints; i++) {
-          if (i != p->line[j].numpoints - 1) {
-            if (quads) {
-              drawQuad(&p->line[j].point[i], &p->line[j].point[i
-                       + 1], width);
-            } else {
-              glBegin(GL_LINES);
-              glVertex2f(p->line[j].point[i].x, p->line[j].point[i].y);
-              glVertex2f(p->line[j].point[i + 1].x,p->line[j].point[i + 1].y);
-              glEnd();
-            }
-          }
-          if ((lineCap == MS_CJC_ROUND && (i == 0 || i == p->line[j].numpoints - 1)) ||
-              (joinStyle == MS_CJC_ROUND && (i > 0 && i < p->line[j].numpoints - 1))) {
-            glPushMatrix();
-            glTranslated(p->line[j].point[i].x, p->line[j].point[i].y, 0);
-            glScaled(circleScale, circleScale, 0);
-            glCallList(shapes[circle]);
-            glPopMatrix();
-          }
-        }
-      }
-    } else {
-      for (int j = 0; j < p->numlines; j++) {
-        glBegin(GL_LINE_STRIP);
-        for (int i = 0; i < p->line[j].numpoints; i++) {
-          glVertex2f(p->line[j].point[i].x, p->line[j].point[i].y);
-        }
-        glEnd();
-
-      }
-    }
-  }
-
-  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor)) {
-    glPopMatrix();
-    double owidth = MS_MAX(width + OUTLINE_WIDTH, outlinewidth);
-    glPushMatrix();
-    glTranslated(0, 0, -1);
-    renderPolyline(p, outlinecolor, owidth, patternlength, pattern, lineCap, joinStyle);
-    glPopMatrix();
-    glDisable(GL_DEPTH_TEST);
-  }
-
-}
-
-void OglRenderer::renderPolygon(shapeObj *p, colorObj *color, colorObj *outlinecolor, double outlinewidth, const OglCachePtr& tile, int lineCap, int joinStyle)
-{
-  /*
-   OpenGL cannot draw complex polygons so we need to use a Tessallator to draw the polygon using a GL_TRIANGLE_FAN
-
-   ISSUE: There's a problem here. It would seem that changing the dimensions or bounding box area breaks the code.
-   Reports need for a combine callback.
-   */
-  makeCurrent();
-  std::vector<GLdouble*> pointers;
-  double texWidth = 0;
-  double texHeight = 0;
-
-  if (tile) {
-    glBindTexture(GL_TEXTURE_2D, tile->texture); // Select Our Texture
-    texWidth = tile->width;
-    texHeight = tile->height;
-  }
-  setColor(color);
-  gluTessBeginPolygon(tess, NULL );
-  for (int j = 0; j < p->numlines; j++) {
-    gluTessBeginContour(tess);
-    for (int i = 0; i < p->line[j].numpoints; i++) {
-      // create temp array and place
-      GLdouble* dbls = new GLdouble[5];
-      pointers.push_back(dbls);
-      dbls[0] = p->line[j].point[i].x;
-      dbls[1] = p->line[j].point[i].y;
-      dbls[2] = 0.0;
-      dbls[3] = texWidth;
-      dbls[4] = texHeight;
-      gluTessVertex(tess, dbls, dbls);
-    }
-    gluTessEndContour(tess);
-
-  }
-  gluTessEndPolygon(tess);
-
-  // destroy temp arrays
-  for (std::vector<GLdouble*>::iterator iter = pointers.begin(); iter
-       != pointers.end(); iter++) {
-    delete[] *iter;
-  }
-
-  glBindTexture(GL_TEXTURE_2D, 0); // Select Our Texture
-
-  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor) && outlinewidth > 0) {
-    renderPolyline(p, outlinecolor, outlinewidth, 0, NULL, lineCap,
-                   joinStyle);
-  }
-}
-
-void OglRenderer::renderGlyphs(double x, double y, colorObj *color,
-                               colorObj *outlinecolor, double size, const char* font, char *thechars, double angle,
-                               colorObj *shadowcolor, double shdx, double shdy)
-{
-  makeCurrent();
-  FTFont* face = getFTFont(font, size);
-  if (!face) {
-    msSetError(MS_OGLERR, "Failed to load font (%s).", "OglRenderer::renderGlyphs()", font);
-    return;
-  }
-
-  glPushAttrib(GL_ALL_ATTRIB_BITS);
-  glPushMatrix();
-
-  glTranslated(floor(x), floor(y), 0);
-  glScaled(1.0, -1.0, 1);
-  glRotated(angle * (180 / OGL_PI), 0, 0, 1);
-
-  if (outlinecolor && MS_VALID_COLOR(*outlinecolor)) {
-    setColor(outlinecolor);
-    for (int i = -1; i <= 1; i++) {
-      for (int j = -1; j <= 1; j++) {
-        if (i || j) {
-          glPushMatrix();
-          glTranslated(i, j, 0);
-          face->Render(thechars);
-          glPopMatrix();
-        }
-      }
-    }
-  }
-  if (color != NULL && MS_VALID_COLOR(*color)) {
-    setColor(color);
-    face->Render(thechars);
-  }
-
-  glPopMatrix();
-  glPopAttrib();
-}
-
-void OglRenderer::renderPixmap(symbolObj *symbol, double x, double y,
-                               double angle, double scale)
-{
-  makeCurrent();
-
-  float zoomX, zoomY;
-  glGetFloatv(GL_ZOOM_X, &zoomX);
-  glGetFloatv(GL_ZOOM_Y, &zoomY);
-
-
-  GLubyte* imgdata = symbol->pixmap_buffer->data.rgba.pixels;
-  glPixelZoom(zoomX*scale, zoomY*scale);
-  glRasterPos2d(x-symbol->pixmap_buffer->width/2, y-symbol->pixmap_buffer->height/2);
-  glDrawPixels(symbol->pixmap_buffer->width, symbol->pixmap_buffer->height, GL_BGRA, GL_UNSIGNED_BYTE, imgdata);
-  glPixelZoom(zoomX, zoomY);
-}
-
-void OglRenderer::renderEllipse(double x, double y, double angle, double width, double height,
-                                colorObj *color, colorObj *outlinecolor, double outlinewidth = 1.0)
-{
-  makeCurrent();
-  if (outlinecolor && MS_VALID_COLOR(*outlinecolor)) {
-    glEnable(GL_DEPTH_TEST);
-    glPushMatrix();
-    glTranslated(0, 0, 1);
-  }
-
-  setColor(color);
-
-  glPushMatrix();
-  if (angle) {
-    glRotated(angle, 0, 0, 1);
-  }
-  glTranslated(x, y, 0);
-  glScaled(width / SHAPE_CIRCLE_RADIUS / 2, height / SHAPE_CIRCLE_RADIUS / 2, 1);
-  glCallList(shapes[circle]);
-  glPopMatrix();
-
-  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor)) {
-    glPopMatrix();
-    glPushMatrix();
-    glTranslated(0, 0, -1);
-    renderEllipse(x, y, angle, width + outlinewidth, height, outlinecolor, NULL, 0);
-    glPopMatrix();
-    glDisable(GL_DEPTH_TEST);
-  }
-
-}
-
-bool OglRenderer::loadLine(shapeObj* shape, double width, int patternlength,
-                           double* pattern)
-{
-  /*    OglCache* cache = (OglCache*) shape->renderer_cache;
-
-      if (cache->patternDistance == 0)
-      {
-          for (int i = 0; i < patternlength; i++)
-          {
-              cache->patternDistance += pattern[i];
-          }
-      }
-      GLubyte imgdata[TEX_SIZE * TEX_SIZE * 4];
-      int pow2length = min(max(NextPowerOf2(cache->patternDistance), MIN_TEX_SIZE), TEX_SIZE);
-      int pow2width = min(max(NextPowerOf2(width), MIN_TEX_SIZE), TEX_SIZE);
-
-      double lengthScale = (double) pow2length / cache->patternDistance;
-      glColor3d(0, 0, 0);
-      double place = 0;
-      double xRadii = width / 2 * lengthScale;
-      double yRadii = pow2width / 2;
-      for (int i = 0; i < patternlength; i++)
-      {
-          double next = pattern[i] * lengthScale;
-          if (i % 2 == 0)
-          {
-
-              glPushMatrix();
-              glTranslated(place + xRadii, yRadii, 0);
-              glScaled(xRadii / SHAPE_CIRCLE_RADIUS,
-                      yRadii / SHAPE_CIRCLE_RADIUS, 0);
-              glCallList(shapes[circle]);
-              glPopMatrix();
-
-              glBegin(GL_QUADS);
-              glVertex2d(place + pow2width / 2, 0);
-              glVertex2d(place + next - pow2width / 2, 0);
-              glVertex2d(place + next - pow2width / 2, pow2width);
-              glVertex2d(place + pow2width / 2, pow2width);
-              glEnd();
-
-              glPushMatrix();
-              glTranslated(place + next - xRadii, yRadii, 0);
-              glScaled(xRadii / SHAPE_CIRCLE_RADIUS,
-                      yRadii / SHAPE_CIRCLE_RADIUS, 0);
-              glCallList(shapes[circle]);
-              glPopMatrix();
-
-          }
-          place += next;
-      }
-
-      glReadPixels(0, 0, pow2length, pow2width, GL_RGBA, GL_UNSIGNED_BYTE,
-              imgdata);
-      //createTexture(pow2length, pow2width, GL_ALPHA, imgdata);*/
-  return true;
-}
-
-FTFont* OglRenderer::getFTFont(const char* font, double size)
-{
-  FTFont** face = &fontCache[font][size];
-  if (*face == NULL && ifstream(font)) {
-    *face = new FTGLTextureFont( font );
-    if (*face) {
-      (*face)->UseDisplayList(true);
-      (*face)->FaceSize(size*SIZE_RES);
-    }
-  }
-  return *face;
-}
-
-GLvoid CALLBACK beginCallback(GLenum which)
-{
-  glBegin(which);
-}
-
-GLvoid CALLBACK errorCallback(GLenum errorCode)
-{
-  const GLubyte *estring;
-  estring = gluErrorString(errorCode);
-  fprintf(stderr, "Tessellation Error: %d %s\n", errorCode, estring);
-  exit(0);
-}
-
-GLvoid CALLBACK endCallback(void)
-{
-  glEnd();
-}
-
-GLvoid CALLBACK combineDataCallback(GLdouble coords[3], GLdouble* vertex_data[4],
-                                    GLfloat weight[4], void** dataOut, void* polygon_data)
-{
-  GLdouble *vertex;
-  vertex = (GLdouble *) malloc(5 * sizeof(GLdouble));
-  vertex[0] = coords[0];
-  vertex[1] = coords[1];
-  vertex[2] = coords[2];
-  vertex[3] = vertex_data[0][3];
-  vertex[4] = vertex_data[0][4];
-  *dataOut = vertex;
-}
-
-GLvoid CALLBACK vertexCallback(GLdouble *vertex)
-{
-  if (vertex[3] > 0) glTexCoord2d(vertex[0]/vertex[3], vertex[1]/vertex[4]);
-  glVertex3dv(vertex);
-}
-
-void OglRenderer::createShapes()
-{
-  double da = MS_MIN(OGL_PI / 2, OGL_PI / SHAPE_CIRCLE_RES);
-  GLuint circle = glGenLists(1);
-  glNewList(circle, GL_COMPILE);
-  glBegin(GL_TRIANGLE_FAN);
-  glVertex2d(0, 0);
-  for (double a = 0.0; a <= 2 * OGL_PI; a += da) {
-    glVertex2d(0 + cos(a) * SHAPE_CIRCLE_RADIUS, 0 + sin(a) * SHAPE_CIRCLE_RADIUS);
-  }
-  glVertex2d(0 + SHAPE_CIRCLE_RADIUS, 0);
-  glEnd();
-
-  glEndList();
-  shapes.push_back(circle);
-}
-
-void OglRenderer::makeCurrent()
-{
-  context->makeCurrent();
-}
-
-#endif
diff -pruN 8.0.1-5/mapoglrenderer.h 8.2.0~beta1-1~exp1/mapoglrenderer.h
--- 8.0.1-5/mapoglrenderer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapoglrenderer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,141 +0,0 @@
-/******************************************************************************
- * $id: mapoglrenderer.h 7725 2011-04-09 15:56:58Z toby $
- *
- * Project:  MapServer
- * Purpose:  Various template processing functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef OGL_H
-#define OGL_H
-
-#ifdef USE_OGL
-
-#include "mapoglcontext.h"
-#include "mapserver.h"
-
-#include <vector>
-#include <map>
-#include <memory>
-
-#include <FTGL/ftgl.h>
-#include <FTGL/FTGLTextureFont.h>
-
-
-class OglCache
-{
-public:
-  ~OglCache() {
-    glDeleteTextures(1, &texture);
-  }
-  GLuint texture;
-  ms_uint32 width;
-  ms_uint32 height;
-  ms_uint32 patternDistance;
-};
-
-typedef OglCache* OglCachePtr;
-
-class OglRenderer
-{
-public:
-  OglRenderer(ms_uint32 width, ms_uint32 height, colorObj* color = NULL);
-  virtual ~OglRenderer();
-
-  void renderPolyline(shapeObj *p, colorObj *c, double width, int patternlength, double* pattern, int lineCap = MS_CJC_ROUND, int joinStyle = MS_CJC_ROUND, colorObj *outlinecolor = NULL, double outlinewidth = 0);
-  void renderPolygon(shapeObj*, colorObj *color, colorObj *outlinecolor, double outlinewidth, const OglCachePtr& tile = OglCachePtr(), int lineCap=MS_CJC_ROUND, int joinStyle=MS_CJC_ROUND);
-  void renderGlyphs(double x, double y, colorObj *color, colorObj *outlinecolor, double size, const char* font, char *thechars, double angle, colorObj *shadowcolor, double shdx, double shdy);
-  void renderPixmap(symbolObj *symbol, double x, double y, double angle, double scale);
-  void renderEllipse(double x, double y, double angle, double w, double h, colorObj *color, colorObj *outlinecolor, double outlinewidth);
-  void renderVectorSymbol(double x, double y, symbolObj *symbol, double scale, double angle, colorObj *c, colorObj *oc, double ow);
-  void renderTile(const OglCachePtr& tile, double x, double y, double angle);
-  void renderPolylineTile(shapeObj *p, const OglCachePtr& tile);
-
-  static bool getStringBBox(char *font, double size, char *string, rectObj *rect, double** advances);
-  void setTransparency(double transparency);
-
-  void readRasterBuffer(rasterBufferObj * rb);
-  void drawRasterBuffer(rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height);
-  static void initializeRasterBuffer(rasterBufferObj * rb, int width, int height, bool useAlpha);
-
-  OglCachePtr getTexture();
-  int getWidth() const {
-    return width;
-  }
-  int getHeight() const {
-    return height;
-  }
-  bool isValid() const {
-    return valid && context->isValid();
-  }
-protected:
-  OglCachePtr texture;
-
-  ms_uint32 width;
-  ms_uint32 height;
-  double transparency;
-  bool valid;
-
-  GLint viewportX;
-  GLint viewportY;
-  GLsizei viewportWidth;
-  GLsizei viewportHeight;
-
-  typedef std::map<const char*,std::map<double,FTFont*> > fontCache_t;
-  typedef std::map<symbolObj*,std::map<double,GLuint> > dashCache_t;
-
-  static FTFont* getFTFont(const char* font, double size);
-  bool loadLine(shapeObj* shape, double width, int patternlength, double *pattern);
-  double drawQuad(pointObj *p1, pointObj *p2, double width, double tilelength = 0.0, double textureStart = 0.0);
-  double drawTriangles(pointObj *p1, pointObj *p2, double width, double tilelength = 0.0, double textureStart = 0.0);
-  void drawVectorLineStrip(symbolObj *symbol, double width);
-  void drawFan(pointObj* center, pointObj* from, pointObj* to, int resolution);
-  void createShapes();
-
-  GLuint createTexture(ms_uint32 x, ms_uint32 y);
-
-  void makeCurrent();
-  void setColor(colorObj *color);
-
-  GLUtesselator *tess;
-  enum shapes_t { circle = 0};
-
-  OglContext* context;
-
-  static dashCache_t dashCache;
-  static fontCache_t fontCache;
-  static std::vector<GLuint> shapes;
-  static std::vector<symbolObj*> testSymbols;
-  static ms_uint32 OUTLINE_WIDTH;
-  static ms_uint32 FONT_SIZE;
-  static ms_uint32 FONT_RES;
-  static double OGL_PI;
-  static ms_uint32 SHAPE_CIRCLE_RES;
-  static double SHAPE_CIRCLE_RADIUS;
-  static double SIZE_RES;
-};
-
-#endif /* USE_OGL */
-#endif
-
diff -pruN 8.0.1-5/mapogr.cpp 8.2.0~beta1-1~exp1/mapogr.cpp
--- 8.0.1-5/mapogr.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogr.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,5644 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGR Link
- * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
- *           Frank Warmerdam (warmerdam@pobox.com)
- *
- **********************************************************************
- * Copyright (c) 2000-2005, Daniel Morissette, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include <assert.h>
-#include "mapserver.h"
-#include "mapproject.h"
-#include "mapthread.h"
-#include "mapows.h"
-#include <string>
-#include <vector>
-
-#include "gdal.h"
-#include "cpl_conv.h"
-#include "cpl_string.h"
-#include "ogr_srs_api.h"
-
-#include <memory>
-
-#define ACQUIRE_OGR_LOCK       msAcquireLock( TLOCK_OGR )
-#define RELEASE_OGR_LOCK       msReleaseLock( TLOCK_OGR )
-
-// GDAL 1.x API
-#include "ogr_api.h"
-
-typedef struct ms_ogr_file_info_t {
-  char        *pszFname;
-  char        *pszLayerDef;
-  int         nLayerIndex;
-  OGRDataSourceH hDS;
-  OGRLayerH   hLayer;
-  OGRFeatureH hLastFeature;
-
-  int         nTileId;                  /* applies on the tiles themselves. */
-  projectionObj sTileProj;              /* applies on the tiles themselves. */
-
-  struct ms_ogr_file_info_t *poCurTile; /* exists on tile index, -> tiles */
-  bool        rect_is_defined;
-  rectObj     rect;                     /* set by TranslateMsExpression (possibly) and WhichShapes */
-
-  int         last_record_index_read;
-
-  const char* dialect; /* NULL, Spatialite or PostgreSQL */
-  char *pszSelect;
-  char *pszSpatialFilterTableName;
-  char *pszSpatialFilterGeometryColumn;
-  char *pszMainTableName;
-  char *pszRowId;
-  int   bIsOKForSQLCompose;
-  bool  bHasSpatialIndex; // used only for spatialite for now
-  char* pszTablePrefix; // prefix to qualify field names. used only for spatialite & gpkg for now when a join is done for spatial filtering.
-
-  int   bPaging;
-
-  char* pszWHERE;
-
-} msOGRFileInfo;
-
-static int msOGRLayerIsOpen(layerObj *layer);
-static int msOGRLayerInitItemInfo(layerObj *layer);
-static int msOGRLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
-                                  shapeObj* shape);
-static void msOGRCloseConnection( void *conn_handle );
-
-/* ==================================================================
- * Geometry conversion functions
- * ================================================================== */
-
-/**********************************************************************
- *                     ogrPointsAddPoint()
- *
- * NOTE: This function assumes the line->point array already has been
- * allocated large enough for the point to be added, but that numpoints
- * does not include this new point.
- **********************************************************************/
-static void ogrPointsAddPoint(lineObj *line, double dX, double dY, double dZ, int lineindex, rectObj *bounds)
-{
-  /* Keep track of shape bounds */
-  if (line->numpoints == 0 && lineindex == 0) {
-    bounds->minx = bounds->maxx = dX;
-    bounds->miny = bounds->maxy = dY;
-  } else {
-    if (dX < bounds->minx)  bounds->minx = dX;
-    if (dX > bounds->maxx)  bounds->maxx = dX;
-    if (dY < bounds->miny)  bounds->miny = dY;
-    if (dY > bounds->maxy)  bounds->maxy = dY;
-  }
-
-  line->point[line->numpoints].x = dX;
-  line->point[line->numpoints].y = dY;
-  line->point[line->numpoints].z = dZ;
-  line->point[line->numpoints].m = 0.0;
-  line->numpoints++;
-}
-
-/**********************************************************************
- *                     ogrGeomPoints()
- **********************************************************************/
-static int ogrGeomPoints(OGRGeometryH hGeom, shapeObj *outshp)
-{
-  int   i;
-  int   numpoints;
-
-  if (hGeom == NULL)
-    return 0;
-
-  OGRwkbGeometryType eGType =  wkbFlatten( OGR_G_GetGeometryType( hGeom ) );
-
-  /* -------------------------------------------------------------------- */
-  /*      Container types result in recursive invocation on each          */
-  /*      subobject to add a set of points to the current list.           */
-  /* -------------------------------------------------------------------- */
-  switch( eGType ) {
-    case wkbGeometryCollection:
-    case wkbMultiLineString:
-    case wkbMultiPolygon:
-    case wkbPolygon: {
-      /* Treat it as GeometryCollection */
-      for (int iGeom=0; iGeom < OGR_G_GetGeometryCount( hGeom ); iGeom++ ) {
-        if( ogrGeomPoints( OGR_G_GetGeometryRef( hGeom, iGeom ),
-                           outshp ) == -1 )
-          return -1;
-      }
-
-      return 0;
-    }
-    break;
-
-    case wkbPoint:
-    case wkbMultiPoint:
-    case wkbLineString:
-    case wkbLinearRing:
-      /* We will handle these directly */
-      break;
-
-    default:
-      /* There shouldn't be any more cases should there? */
-      msSetError(MS_OGRERR,
-                 "OGRGeometry type `%s' not supported yet.",
-                 "ogrGeomPoints()",
-                 OGR_G_GetGeometryName( hGeom ) );
-      return(-1);
-  }
-
-
-  /* ------------------------------------------------------------------
-   * Count total number of points
-   * ------------------------------------------------------------------ */
-  if ( eGType == wkbPoint ) {
-    numpoints = 1;
-  } else if ( eGType == wkbLineString
-              ||  eGType == wkbLinearRing ) {
-    numpoints = OGR_G_GetPointCount( hGeom );
-  } else if ( eGType == wkbMultiPoint ) {
-    numpoints = OGR_G_GetGeometryCount( hGeom );
-  } else {
-    msSetError(MS_OGRERR,
-               "OGRGeometry type `%s' not supported yet.",
-               "ogrGeomPoints()",
-               OGR_G_GetGeometryName( hGeom ) );
-    return(-1);
-  }
-
-  /* ------------------------------------------------------------------
-   * Do we need to allocate a line object to contain all our points?
-   * ------------------------------------------------------------------ */
-  if( outshp->numlines == 0 ) {
-    lineObj newline;
-
-    newline.numpoints = 0;
-    newline.point = NULL;
-    msAddLine(outshp, &newline);
-  }
-
-  /* ------------------------------------------------------------------
-   * Extend the point array for the new of points to add from the
-   * current geometry.
-   * ------------------------------------------------------------------ */
-  lineObj *line = outshp->line + outshp->numlines-1;
-
-  if( line->point == NULL )
-    line->point = (pointObj *) malloc(sizeof(pointObj) * numpoints);
-  else
-    line->point = (pointObj *)
-                  realloc(line->point,sizeof(pointObj) * (numpoints+line->numpoints));
-
-  if(!line->point) {
-    msSetError(MS_MEMERR, "Unable to allocate temporary point cache.",
-               "ogrGeomPoints()");
-    return(-1);
-  }
-
-  /* ------------------------------------------------------------------
-   * alloc buffer and filter/transform points
-   * ------------------------------------------------------------------ */
-  if( eGType == wkbPoint ) {
-    ogrPointsAddPoint(line, OGR_G_GetX(hGeom, 0), OGR_G_GetY(hGeom, 0), OGR_G_GetZ(hGeom, 0),
-                      outshp->numlines-1, &(outshp->bounds));
-  } else if( eGType == wkbLineString
-             || eGType == wkbLinearRing ) {
-    for(i=0; i<numpoints; i++)
-      ogrPointsAddPoint(line, OGR_G_GetX(hGeom, i), OGR_G_GetY(hGeom, i), OGR_G_GetZ(hGeom, i),
-                        outshp->numlines-1, &(outshp->bounds));
-  } else if( eGType == wkbMultiPoint ) {
-    for(i=0; i<numpoints; i++) {
-      OGRGeometryH hPoint = OGR_G_GetGeometryRef( hGeom, i );
-      ogrPointsAddPoint(line, OGR_G_GetX(hPoint, 0), OGR_G_GetY(hPoint, 0), OGR_G_GetZ(hPoint, 0),
-                        outshp->numlines-1, &(outshp->bounds));
-    }
-  }
-
-  outshp->type = MS_SHAPE_POINT;
-
-  return(0);
-}
-
-
-/**********************************************************************
- *                     ogrGeomLine()
- *
- * Recursively convert any OGRGeometry into a shapeObj.  Each part becomes
- * a line in the overall shapeObj.
- **********************************************************************/
-static int ogrGeomLine(OGRGeometryH hGeom, shapeObj *outshp,
-                       int bCloseRings)
-{
-  if (hGeom == NULL)
-    return 0;
-
-  /* ------------------------------------------------------------------
-   * Use recursive calls for complex geometries
-   * ------------------------------------------------------------------ */
-  OGRwkbGeometryType eGType =  wkbFlatten( OGR_G_GetGeometryType( hGeom ) );
-
-
-  if ( eGType == wkbPolygon
-       || eGType == wkbGeometryCollection
-       || eGType == wkbMultiLineString
-       || eGType == wkbMultiPolygon ) {
-    if (eGType == wkbPolygon && outshp->type == MS_SHAPE_NULL)
-      outshp->type = MS_SHAPE_POLYGON;
-
-    /* Treat it as GeometryCollection */
-    for (int iGeom=0; iGeom < OGR_G_GetGeometryCount( hGeom ); iGeom++ ) {
-      if( ogrGeomLine( OGR_G_GetGeometryRef( hGeom, iGeom ),
-                       outshp, bCloseRings ) == -1 )
-        return -1;
-    }
-  }
-  /* ------------------------------------------------------------------
-   * OGRPoint and OGRMultiPoint
-   * ------------------------------------------------------------------ */
-  else if ( eGType == wkbPoint || eGType == wkbMultiPoint ) {
-    /* Hummmm a point when we're drawing lines/polygons... just drop it! */
-  }
-  /* ------------------------------------------------------------------
-   * OGRLinearRing/OGRLineString ... both are of type wkbLineString
-   * ------------------------------------------------------------------ */
-  else if ( eGType == wkbLineString ) {
-    int       j, numpoints;
-    lineObj   line= {0,NULL};
-    double    dX, dY;
-
-    if ((numpoints = OGR_G_GetPointCount( hGeom )) < 2)
-      return 0;
-
-    if (outshp->type == MS_SHAPE_NULL)
-      outshp->type = MS_SHAPE_LINE;
-
-    line.numpoints = 0;
-    line.point = (pointObj *)malloc(sizeof(pointObj)*(numpoints+1));
-    if(!line.point) {
-      msSetError(MS_MEMERR, "Unable to allocate temporary point cache.",
-                 "ogrGeomLine");
-      return(-1);
-    }
-
-    OGR_G_GetPoints(hGeom,
-                    &(line.point[0].x), sizeof(pointObj),
-                    &(line.point[0].y), sizeof(pointObj),
-                    &(line.point[0].z), sizeof(pointObj));
-
-    for(j=0; j<numpoints; j++) {
-      dX = line.point[j].x = OGR_G_GetX( hGeom, j);
-      dY = line.point[j].y = OGR_G_GetY( hGeom, j);
-
-      /* Keep track of shape bounds */
-      if (j == 0 && outshp->numlines == 0) {
-        outshp->bounds.minx = outshp->bounds.maxx = dX;
-        outshp->bounds.miny = outshp->bounds.maxy = dY;
-      } else {
-        if (dX < outshp->bounds.minx)  outshp->bounds.minx = dX;
-        if (dX > outshp->bounds.maxx)  outshp->bounds.maxx = dX;
-        if (dY < outshp->bounds.miny)  outshp->bounds.miny = dY;
-        if (dY > outshp->bounds.maxy)  outshp->bounds.maxy = dY;
-      }
-
-    }
-    line.numpoints = numpoints;
-
-    if (bCloseRings &&
-        ( line.point[line.numpoints-1].x != line.point[0].x ||
-          line.point[line.numpoints-1].y != line.point[0].y  ) ) {
-      line.point[line.numpoints].x = line.point[0].x;
-      line.point[line.numpoints].y = line.point[0].y;
-      line.point[line.numpoints].z = line.point[0].z;
-      line.numpoints++;
-    }
-
-    msAddLineDirectly(outshp, &line);
-  } else {
-    msSetError(MS_OGRERR,
-               "OGRGeometry type `%s' not supported.",
-               "ogrGeomLine()",
-               OGR_G_GetGeometryName( hGeom ) );
-    return(-1);
-  }
-
-  return(0);
-}
-
-/**********************************************************************
- *                     ogrGetLinearGeometry()
- *
- * Fetch geometry from OGR feature. If using GDAL 2.0 or later, the geometry
- * might be of curve type, so linearize it.
- **********************************************************************/
-static OGRGeometryH ogrGetLinearGeometry(OGRFeatureH hFeature)
-{
-#if GDAL_VERSION_MAJOR >= 2
-    /* Convert in place and reassign to the feature */
-    OGRGeometryH hGeom = OGR_F_StealGeometry(hFeature);
-    if( hGeom != NULL )
-    {
-        hGeom = OGR_G_ForceTo(hGeom, OGR_GT_GetLinear(OGR_G_GetGeometryType(hGeom)), NULL);
-        OGR_F_SetGeometryDirectly(hFeature, hGeom);
-    }
-    return hGeom;
-#else
-    return OGR_F_GetGeometryRef( hFeature );
-#endif
-}
-
-/**********************************************************************
- *                     ogrConvertGeometry()
- *
- * Convert OGR geometry into a shape object doing the best possible
- * job to match OGR Geometry type and layer type.
- *
- * If layer type is incompatible with geometry, then shape is returned with
- * shape->type = MS_SHAPE_NULL
- **********************************************************************/
-static int ogrConvertGeometry(OGRGeometryH hGeom, shapeObj *outshp,
-                              enum MS_LAYER_TYPE layertype)
-{
-  /* ------------------------------------------------------------------
-   * Process geometry according to layer type
-   * ------------------------------------------------------------------ */
-  int nStatus = MS_SUCCESS;
-
-  if (hGeom == NULL) {
-    // Empty geometry... this is not an error... we'll just skip it
-    return MS_SUCCESS;
-  }
-
-  switch(layertype) {
-      /* ------------------------------------------------------------------
-       *      POINT layer - Any geometry can be converted to point/multipoint
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_POINT:
-      if(ogrGeomPoints(hGeom, outshp) == -1) {
-        nStatus = MS_FAILURE; // Error message already produced.
-      }
-      break;
-      /* ------------------------------------------------------------------
-       *      LINE layer
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_LINE:
-      if(ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
-        nStatus = MS_FAILURE; // Error message already produced.
-      }
-      if (outshp->type != MS_SHAPE_LINE && outshp->type != MS_SHAPE_POLYGON)
-        outshp->type = MS_SHAPE_NULL;  // Incompatible type for this layer
-      break;
-      /* ------------------------------------------------------------------
-       *      POLYGON layer
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_POLYGON:
-      if(ogrGeomLine(hGeom, outshp, MS_TRUE) == -1) {
-        nStatus = MS_FAILURE; // Error message already produced.
-      }
-      if (outshp->type != MS_SHAPE_POLYGON)
-        outshp->type = MS_SHAPE_NULL;  // Incompatible type for this layer
-      break;
-      /* ------------------------------------------------------------------
-       *      Chart or Query layers - return real feature type
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_CHART:
-    case MS_LAYER_QUERY:
-      switch( OGR_G_GetGeometryType( hGeom ) ) {
-        case wkbPoint:
-        case wkbPoint25D:
-        case wkbMultiPoint:
-        case wkbMultiPoint25D:
-          if(ogrGeomPoints(hGeom, outshp) == -1) {
-            nStatus = MS_FAILURE; // Error message already produced.
-          }
-          break;
-        default:
-          // Handle any non-point types as lines/polygons ... ogrGeomLine()
-          // will decide the shape type
-          if(ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
-            nStatus = MS_FAILURE; // Error message already produced.
-          }
-      }
-      break;
-
-    default:
-      msSetError(MS_MISCERR, "Unknown or unsupported layer type.",
-                 "msOGRLayerNextShape()");
-      nStatus = MS_FAILURE;
-  } /* switch layertype */
-
-  return nStatus;
-}
-
-/**********************************************************************
- *                     msOGRGeometryToShape()
- *
- * Utility function to convert from OGR geometry to a mapserver shape
- * object.
- **********************************************************************/
-int msOGRGeometryToShape(OGRGeometryH hGeometry, shapeObj *psShape,
-                         OGRwkbGeometryType nType)
-{
-  if (hGeometry && psShape && nType > 0) {
-    if (nType == wkbPoint || nType == wkbMultiPoint )
-      return ogrConvertGeometry(hGeometry, psShape,  MS_LAYER_POINT);
-    else if (nType == wkbLineString || nType == wkbMultiLineString)
-      return ogrConvertGeometry(hGeometry, psShape,  MS_LAYER_LINE);
-    else if (nType == wkbPolygon || nType == wkbMultiPolygon)
-      return ogrConvertGeometry(hGeometry, psShape,  MS_LAYER_POLYGON);
-    else
-      return MS_FAILURE;
-  } else
-    return MS_FAILURE;
-}
-
-
-/* ==================================================================
- * Attributes handling functions
- * ================================================================== */
-
-// Special field index codes for handling text string and angle coming from
-// OGR style strings.
-
-#define MSOGR_FID_INDEX            -99
-
-#define MSOGR_LABELNUMITEMS        21
-#define MSOGR_LABELFONTNAMENAME    "OGR:LabelFont"
-#define MSOGR_LABELFONTNAMEINDEX   -100
-#define MSOGR_LABELSIZENAME        "OGR:LabelSize"
-#define MSOGR_LABELSIZEINDEX       -101
-#define MSOGR_LABELTEXTNAME        "OGR:LabelText"
-#define MSOGR_LABELTEXTINDEX       -102
-#define MSOGR_LABELANGLENAME       "OGR:LabelAngle"
-#define MSOGR_LABELANGLEINDEX      -103
-#define MSOGR_LABELFCOLORNAME      "OGR:LabelFColor"
-#define MSOGR_LABELFCOLORINDEX     -104
-#define MSOGR_LABELBCOLORNAME      "OGR:LabelBColor"
-#define MSOGR_LABELBCOLORINDEX     -105
-#define MSOGR_LABELPLACEMENTNAME   "OGR:LabelPlacement"
-#define MSOGR_LABELPLACEMENTINDEX  -106
-#define MSOGR_LABELANCHORNAME      "OGR:LabelAnchor"
-#define MSOGR_LABELANCHORINDEX     -107
-#define MSOGR_LABELDXNAME          "OGR:LabelDx"
-#define MSOGR_LABELDXINDEX         -108
-#define MSOGR_LABELDYNAME          "OGR:LabelDy"
-#define MSOGR_LABELDYINDEX         -109
-#define MSOGR_LABELPERPNAME        "OGR:LabelPerp"
-#define MSOGR_LABELPERPINDEX       -110
-#define MSOGR_LABELBOLDNAME        "OGR:LabelBold"
-#define MSOGR_LABELBOLDINDEX       -111
-#define MSOGR_LABELITALICNAME      "OGR:LabelItalic"
-#define MSOGR_LABELITALICINDEX     -112
-#define MSOGR_LABELUNDERLINENAME   "OGR:LabelUnderline"
-#define MSOGR_LABELUNDERLINEINDEX  -113
-#define MSOGR_LABELPRIORITYNAME    "OGR:LabelPriority"
-#define MSOGR_LABELPRIORITYINDEX   -114
-#define MSOGR_LABELSTRIKEOUTNAME   "OGR:LabelStrikeout"
-#define MSOGR_LABELSTRIKEOUTINDEX  -115
-#define MSOGR_LABELSTRETCHNAME     "OGR:LabelStretch"
-#define MSOGR_LABELSTRETCHINDEX    -116
-#define MSOGR_LABELADJHORNAME      "OGR:LabelAdjHor"
-#define MSOGR_LABELADJHORINDEX     -117
-#define MSOGR_LABELADJVERTNAME     "OGR:LabelAdjVert"
-#define MSOGR_LABELADJVERTINDEX    -118
-#define MSOGR_LABELHCOLORNAME      "OGR:LabelHColor"
-#define MSOGR_LABELHCOLORINDEX     -119
-#define MSOGR_LABELOCOLORNAME      "OGR:LabelOColor"
-#define MSOGR_LABELOCOLORINDEX     -120
-// Special codes for the OGR style parameters
-#define MSOGR_LABELPARAMNAME       "OGR:LabelParam"
-#define MSOGR_LABELPARAMNAMELEN    14
-#define MSOGR_LABELPARAMINDEX      -500
-#define MSOGR_BRUSHPARAMNAME       "OGR:BrushParam"
-#define MSOGR_BRUSHPARAMNAMELEN    14
-#define MSOGR_BRUSHPARAMINDEX      -600
-#define MSOGR_PENPARAMNAME         "OGR:PenParam"
-#define MSOGR_PENPARAMNAMELEN      12
-#define MSOGR_PENPARAMINDEX        -700
-#define MSOGR_SYMBOLPARAMNAME      "OGR:SymbolParam"
-#define MSOGR_SYMBOLPARAMNAMELEN   15
-#define MSOGR_SYMBOLPARAMINDEX     -800
-
-/**********************************************************************
- *                     msOGRGetValues()
- *
- * Load selected item (i.e. field) values into a char array
- *
- * Some special attribute names are used to return some OGRFeature params
- * like for instance stuff encoded in the OGRStyleString.
- * For now the following pseudo-attribute names are supported:
- *  "OGR:TextString"  OGRFeatureStyle's text string if present
- *  "OGR:TextAngle"   OGRFeatureStyle's text angle, or 0 if not set
- **********************************************************************/
-static char **msOGRGetValues(layerObj *layer, OGRFeatureH hFeature)
-{
-  char **values;
-  const char *pszValue = NULL;
-  int i;
-
-  if(layer->numitems == 0)
-    return(NULL);
-
-  if(!layer->iteminfo)  // Should not happen... but just in case!
-    if (msOGRLayerInitItemInfo(layer) != MS_SUCCESS)
-      return NULL;
-
-  if((values = (char **)malloc(sizeof(char *)*layer->numitems)) == NULL) {
-    msSetError(MS_MEMERR, NULL, "msOGRGetValues()");
-    return(NULL);
-  }
-
-  OGRStyleMgrH  hStyleMgr = NULL;
-  OGRStyleToolH hLabelStyle = NULL;
-  OGRStyleToolH hPenStyle = NULL;
-  OGRStyleToolH hBrushStyle = NULL;
-  OGRStyleToolH hSymbolStyle = NULL;
-
-  int *itemindexes = (int*)layer->iteminfo;
-
-  int nYear;
-  int nMonth;
-  int nDay;
-  int nHour;
-  int nMinute;
-  int nSecond;
-  int nTZFlag;
-
-  for(i=0; i<layer->numitems; i++) {
-    if (itemindexes[i] >= 0) {
-      // Extract regular attributes
-      const char* pszValue = OGR_F_GetFieldAsString(hFeature, itemindexes[i]);
-      if( pszValue[0] == 0 )
-      {
-          values[i] = msStrdup("");
-      }
-      else
-      {
-          OGRFieldDefnH hFieldDefnRef = OGR_F_GetFieldDefnRef(hFeature, itemindexes[i]);
-          switch(OGR_Fld_GetType(hFieldDefnRef)) {
-          case OFTTime:
-              OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth, &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
-              switch(nTZFlag) {
-              case 0: // Unknown time zone
-              case 1: // Local time zone (not specified)
-                values[i] = msStrdup(CPLSPrintf("%02d:%02d:%02d", nHour, nMinute, nSecond));
-                break;
-              case 100: // GMT
-                values[i] = msStrdup(CPLSPrintf("%02d:%02d:%02dZ", nHour, nMinute, nSecond));
-                break;
-              default: // Offset (in quarter-hour units) from GMT
-                const int TZOffset = std::abs(nTZFlag - 100) * 15;
-                const int TZHour = TZOffset / 60;
-                const int TZMinute = TZOffset % 60;
-                const char TZSign = (nTZFlag > 100) ? '+' : '-';
-                values[i] = msStrdup(CPLSPrintf("%02d:%02d:%02d%c%02d:%02d", nHour, nMinute,
-                  nSecond, TZSign, TZHour, TZMinute));
-              }
-              break;
-          case OFTDate:
-              OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth, &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
-              values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02d", nYear, nMonth, nDay));
-              break;
-          case OFTDateTime:
-              OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth, &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
-              switch(nTZFlag) {
-              case 0: // Unknown time zone
-              case 1: // Local time zone (not specified)
-                values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02d", nYear, nMonth, nDay, nHour, nMinute, nSecond));
-                break;
-              case 100: // GMT
-                values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02dZ", nYear, nMonth, nDay, nHour, nMinute, nSecond));
-                break;
-              default: // Offset (in quarter-hour units) from GMT
-                const int TZOffset = std::abs(nTZFlag - 100) * 15;
-                const int TZHour = TZOffset / 60;
-                const int TZMinute = TZOffset % 60;
-                const char TZSign = (nTZFlag > 100) ? '+' : '-';
-                values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02d%c%02d:%02d", nYear, nMonth, nDay, nHour, nMinute, 
-                  nSecond, TZSign, TZHour, TZMinute));
-              }
-              break;
-          default:
-              values[i] = msStrdup(pszValue);
-              break;
-          }
-      }
-    } else if (itemindexes[i] == MSOGR_FID_INDEX ) {
-      values[i] = msStrdup(CPLSPrintf(CPL_FRMT_GIB,
-                                      (GIntBig) OGR_F_GetFID(hFeature)));
-    } else {
-      // Handle special OGR attributes coming from StyleString
-      if (!hStyleMgr) {
-        hStyleMgr = OGR_SM_Create(NULL);
-        OGR_SM_InitFromFeature(hStyleMgr, hFeature);
-        int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
-        for(int i=0; i<numParts; i++) {
-          OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
-          if (hStylePart) {
-            if (OGR_ST_GetType(hStylePart) == OGRSTCLabel && !hLabelStyle)
-              hLabelStyle = hStylePart;
-            else if (OGR_ST_GetType(hStylePart) == OGRSTCPen && !hPenStyle)
-              hPenStyle = hStylePart;
-            else if (OGR_ST_GetType(hStylePart) == OGRSTCBrush && !hBrushStyle)
-              hBrushStyle = hStylePart;
-            else if (OGR_ST_GetType(hStylePart) == OGRSTCSymbol && !hSymbolStyle)
-              hSymbolStyle = hStylePart;
-            else {
-              OGR_ST_Destroy(hStylePart);
-              hStylePart =  NULL;
-            }
-          }
-          /* Setting up the size units according to msOGRLayerGetAutoStyle*/
-          if (hStylePart && layer->map)
-            OGR_ST_SetUnit(hStylePart, OGRSTUPixel, 
-              layer->map->cellsize*layer->map->resolution/layer->map->defresolution*72.0*39.37);
-        }
-      }
-      int bDefault;
-      if (itemindexes[i] == MSOGR_LABELTEXTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelTextString,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELTEXTNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELANGLEINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAngle,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELANGLENAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELSIZEINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelSize,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELSIZENAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELFCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelFColor,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("#000000");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELFCOLORNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELFONTNAMEINDEX ) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelFontName,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("Arial");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELFONTNAMENAME " =       \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELBCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelBColor,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("#000000");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELBCOLORNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELPLACEMENTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelPlacement,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELPLACEMENTNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELANCHORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAnchor,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELANCHORNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELDXINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelDx,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELDXNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELDYINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelDy,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELDYNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELPERPINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelPerp,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELPERPNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELBOLDINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelBold,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELBOLDNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELITALICINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelItalic,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELITALICNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELUNDERLINEINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelUnderline,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELUNDERLINENAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELPRIORITYINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelPriority,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELPRIORITYNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELSTRIKEOUTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelStrikeout,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELSTRIKEOUTNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELSTRETCHINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelStretch,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("0");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELSTRETCHNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELADJHORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAdjHor,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELADJHORNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELADJVERTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAdjVert,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELADJVERTNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELHCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelHColor,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELHCOLORNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] == MSOGR_LABELOCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelOColor,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELOCOLORNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_LABELPARAMINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               itemindexes[i] - MSOGR_LABELPARAMINDEX,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_LABELPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_BRUSHPARAMINDEX) {
-        if (hBrushStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hBrushStyle,
-                                               itemindexes[i] - MSOGR_BRUSHPARAMINDEX,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_BRUSHPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_PENPARAMINDEX) {
-        if (hPenStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hPenStyle,
-                                               itemindexes[i] - MSOGR_PENPARAMINDEX,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_PENPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_SYMBOLPARAMINDEX) {
-        if (hSymbolStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hSymbolStyle,
-                                               itemindexes[i] - MSOGR_SYMBOLPARAMINDEX,
-                                               &bDefault)) == NULL))
-          values[i] = msStrdup("");
-        else
-          values[i] = msStrdup(pszValue);
-
-        if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          msDebug(MSOGR_SYMBOLPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else {
-        msFreeCharArray(values,i);
-
-        OGR_SM_Destroy(hStyleMgr);
-        OGR_ST_Destroy(hLabelStyle);
-        OGR_ST_Destroy(hPenStyle);
-        OGR_ST_Destroy(hBrushStyle);
-        OGR_ST_Destroy(hSymbolStyle);
-
-        msSetError(MS_OGRERR,"Invalid field index!?!","msOGRGetValues()");
-        return(NULL);
-      }
-    }
-  }
-
-  OGR_SM_Destroy(hStyleMgr);
-  OGR_ST_Destroy(hLabelStyle);
-  OGR_ST_Destroy(hPenStyle);
-  OGR_ST_Destroy(hBrushStyle);
-  OGR_ST_Destroy(hSymbolStyle);
-
-  return(values);
-}
-
-/**********************************************************************
- *                     msOGRSpatialRef2ProjectionObj()
- *
- * Init a MapServer projectionObj using an OGRSpatialRef
- * Works only with PROJECTION AUTO
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-static int msOGRSpatialRef2ProjectionObj(OGRSpatialReferenceH hSRS,
-    projectionObj *proj, int debug_flag )
-{
-  // First flush the "auto" name from the projargs[]...
-  msFreeProjectionExceptContext( proj );
-
-  if (hSRS == NULL || OSRIsLocal( hSRS ) ) {
-    // Dataset had no set projection or is NonEarth (LOCAL_CS)...
-    // Nothing else to do. Leave proj empty and no reprojection will happen!
-    return MS_SUCCESS;
-  }
-
-#if PROJ_VERSION_MAJOR >= 6
-  // This could be done also in the < 6 case, but would be useless.
-  // Here this helps avoiding going through potentially lossy PROJ4 strings
-  const char* pszAuthName = OSRGetAuthorityName(hSRS, NULL);
-  if( pszAuthName && EQUAL(pszAuthName, "EPSG") )
-  {
-    const char* pszAuthCode = OSRGetAuthorityCode(hSRS, NULL);
-    if( pszAuthCode )
-    {
-        char szInitStr[32];
-        sprintf(szInitStr, "init=epsg:%d", atoi(pszAuthCode));
-
-        if( debug_flag )
-            msDebug( "AUTO = %s\n", szInitStr );
-
-        return msLoadProjectionString(proj, szInitStr) == 0 ? MS_SUCCESS : MS_FAILURE;
-    }
-  }
-#endif
-
-  // Export OGR SRS to a PROJ4 string
-  char *pszProj = NULL;
-
-  if (OSRExportToProj4( hSRS, &pszProj ) != OGRERR_NONE ||
-      pszProj == NULL || strlen(pszProj) == 0) {
-    msSetError(MS_OGRERR, "Conversion from OGR SRS to PROJ4 failed.",
-               "msOGRSpatialRef2ProjectionObj()");
-    CPLFree(pszProj);
-    return(MS_FAILURE);
-  }
-
-  if( debug_flag )
-    msDebug( "AUTO = %s\n", pszProj );
-
-  if( msLoadProjectionString( proj, pszProj ) != 0 )
-    return MS_FAILURE;
-
-  CPLFree(pszProj);
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                     msOGCWKT2ProjectionObj()
- *
- * Init a MapServer projectionObj using an OGC WKT definition.
- * Works only with PROJECTION AUTO
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-
-int msOGCWKT2ProjectionObj( const char *pszWKT,
-                            projectionObj *proj,
-                            int debug_flag )
-
-{
-  OGRSpatialReferenceH        hSRS;
-  char      *pszAltWKT = (char *) pszWKT;
-  OGRErr  eErr;
-  int     ms_result;
-
-  hSRS = OSRNewSpatialReference( NULL );
-
-  if( !EQUALN(pszWKT,"GEOGCS",6)
-      && !EQUALN(pszWKT,"PROJCS",6)
-      && !EQUALN(pszWKT,"LOCAL_CS",8) )
-    eErr = OSRSetFromUserInput( hSRS, pszWKT );
-  else
-    eErr = OSRImportFromWkt( hSRS, &pszAltWKT );
-
-  if( eErr != OGRERR_NONE ) {
-    OSRDestroySpatialReference( hSRS );
-    msSetError(MS_OGRERR,
-               "Ingestion of WKT string '%s' failed.",
-               "msOGCWKT2ProjectionObj()",
-               pszWKT );
-    return MS_FAILURE;
-  }
-
-  ms_result = msOGRSpatialRef2ProjectionObj( hSRS, proj, debug_flag );
-
-  OSRDestroySpatialReference( hSRS );
-  return ms_result;
-}
-
-/**********************************************************************
- *                     msOGRFileOpen()
- *
- * Open an OGR connection, and initialize a msOGRFileInfo.
- **********************************************************************/
-
-static int bOGRDriversRegistered = MS_FALSE;
-
-void msOGRInitialize(void)
-
-{
-  /* ------------------------------------------------------------------
-   * Register OGR Drivers, only once per execution
-   * ------------------------------------------------------------------ */
-  if (!bOGRDriversRegistered) {
-    ACQUIRE_OGR_LOCK;
-
-    OGRRegisterAll();
-    CPLPushErrorHandler( CPLQuietErrorHandler );
-
-    /* ------------------------------------------------------------------
-     * Pass config option GML_FIELDTYPES=ALWAYS_STRING to OGR so that all
-     * GML attributes are returned as strings to MapServer. This is most efficient
-     * and prevents problems with autodetection of some attribute types.
-     * ------------------------------------------------------------------ */
-    CPLSetConfigOption("GML_FIELDTYPES","ALWAYS_STRING");
-
-    bOGRDriversRegistered = MS_TRUE;
-
-    RELEASE_OGR_LOCK;
-  }
-}
-
-/* ==================================================================
- * The following functions closely relate to the API called from
- * maplayer.c, but are intended to be used for the tileindex or direct
- * layer access.
- * ================================================================== */
-
-static void msOGRFileOpenSpatialite( layerObj *layer, 
-                                     const char *pszLayerDef,
-                                     msOGRFileInfo *psInfo );
-
-/**********************************************************************
- *                     msOGRFileOpen()
- *
- * Open an OGR connection, and initialize a msOGRFileInfo.
- **********************************************************************/
-
-static msOGRFileInfo *
-msOGRFileOpen(layerObj *layer, const char *connection )
-
-{
-  char *conn_decrypted = NULL;
-
-  msOGRInitialize();
-
-  /* ------------------------------------------------------------------
-   * Make sure any encrypted token in the connection string are decrypted
-   * ------------------------------------------------------------------ */
-  if (connection) {
-    conn_decrypted = msDecryptStringTokens(layer->map, connection);
-    if (conn_decrypted == NULL)
-      return NULL;  /* An error should already have been reported */
-  }
-
-  /* ------------------------------------------------------------------
-   * Parse connection string into dataset name, and layer name.
-   * ------------------------------------------------------------------ */
-  char *pszDSName = NULL, *pszLayerDef = NULL;
-
-  if( conn_decrypted == NULL ) {
-    /* we don't have anything */
-  } else if( layer->data != NULL ) {
-    pszDSName = CPLStrdup(conn_decrypted);
-    pszLayerDef = CPLStrdup(layer->data);
-  } else {
-    char **papszTokens = NULL;
-
-    papszTokens = CSLTokenizeStringComplex( conn_decrypted, ",", TRUE, FALSE );
-
-    if( CSLCount(papszTokens) > 0 )
-      pszDSName = CPLStrdup( papszTokens[0] );
-    if( CSLCount(papszTokens) > 1 )
-      pszLayerDef = CPLStrdup( papszTokens[1] );
-
-    CSLDestroy(papszTokens);
-  }
-
-  /* Get rid of decrypted connection string. We'll use the original (not
-   * decrypted) string for debug and error messages in the rest of the code.
-   */
-  msFree(conn_decrypted);
-  conn_decrypted = NULL;
-
-  if( pszDSName == NULL ) {
-    msSetError(MS_OGRERR,
-               "Error parsing OGR connection information in layer `%s'",
-               "msOGRFileOpen()",
-               layer->name?layer->name:"(null)" );
-    return NULL;
-  }
-
-  if( pszLayerDef == NULL )
-    pszLayerDef = CPLStrdup("0");
-
-  /* -------------------------------------------------------------------- */
-  /*      Can we get an existing connection for this layer?               */
-  /* -------------------------------------------------------------------- */
-  OGRDataSourceH hDS;
-
-  hDS = (OGRDataSourceH) msConnPoolRequest( layer );
-
-  /* -------------------------------------------------------------------- */
-  /*      If not, open now, and register this connection with the         */
-  /*      pool.                                                           */
-  /* -------------------------------------------------------------------- */
-  if( hDS == NULL ) {
-    char szPath[MS_MAXPATHLEN] = "";
-    const char *pszDSSelectedName = pszDSName;
-
-    if( layer->debug )
-      msDebug("msOGRFileOpen(%s)...\n", connection);
-
-    CPLErrorReset();
-    if (msTryBuildPath3(szPath, layer->map->mappath,
-                        layer->map->shapepath, pszDSName) != NULL ||
-        msTryBuildPath(szPath, layer->map->mappath, pszDSName) != NULL) {
-      /* Use relative path */
-      pszDSSelectedName = szPath;
-    }
-
-    if( layer->debug )
-      msDebug("OGROPen(%s)\n", pszDSSelectedName);
-
-    ACQUIRE_OGR_LOCK;
-    char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-    hDS = (OGRDataSourceH) GDALOpenEx(pszDSSelectedName,
-                                GDAL_OF_VECTOR,
-                                NULL,
-                                (const char* const*)connectionoptions,
-                                NULL);
-    CSLDestroy(connectionoptions);
-    RELEASE_OGR_LOCK;
-
-    if( hDS == NULL ) {
-      msSetError(MS_OGRERR,
-                   "Open failed for OGR connection in layer `%s'.  "
-                   "File not found or unsupported format. Check server logs.",
-                   "msOGRFileOpen()",
-                   layer->name?layer->name:"(null)" );
-      if( strlen(CPLGetLastErrorMsg()) == 0 )
-        msDebug("Open failed for OGR connection in layer `%s'.\n%s\n",
-                   layer->name?layer->name:"(null)",
-                   CPLGetLastErrorMsg() );
-      CPLFree( pszDSName );
-      CPLFree( pszLayerDef );
-      return NULL;
-    }
-
-    msConnPoolRegister( layer, hDS, msOGRCloseConnection );
-  }
-
-  CPLFree( pszDSName );
-  pszDSName = NULL;
-
-  /* ------------------------------------------------------------------
-   * Find the layer selected.
-   * ------------------------------------------------------------------ */
-
-  int   nLayerIndex = 0;
-  OGRLayerH     hLayer = NULL;
-
-  int  iLayer;
-
-  if( EQUALN(pszLayerDef,"SELECT ",7) ) {
-    ACQUIRE_OGR_LOCK;
-    hLayer = OGR_DS_ExecuteSQL( hDS, pszLayerDef, NULL, NULL );
-    if( hLayer == NULL ) {
-      msSetError(MS_OGRERR,
-                 "ExecuteSQL() failed. Check server logs.",
-                 "msOGRFileOpen()");
-      if( strlen(CPLGetLastErrorMsg()) == 0 )
-        msDebug("ExecuteSQL(%s) failed.\n%s\n",
-                pszLayerDef, CPLGetLastErrorMsg() );
-      RELEASE_OGR_LOCK;
-      msConnPoolRelease( layer, hDS );
-      CPLFree( pszLayerDef );
-      return NULL;
-    }
-    RELEASE_OGR_LOCK;
-    nLayerIndex = -1;
-  }
-
-  for( iLayer = 0; hLayer == NULL && iLayer < OGR_DS_GetLayerCount(hDS); iLayer++ ) {
-    hLayer = OGR_DS_GetLayer( hDS, iLayer );
-    if( hLayer != NULL
-        && EQUAL(OGR_L_GetName(hLayer),pszLayerDef) )
-    {
-      nLayerIndex = iLayer;
-      break;
-    } else
-      hLayer = NULL;
-  }
-
-  if( hLayer == NULL && (atoi(pszLayerDef) > 0 || EQUAL(pszLayerDef,"0")) ) {
-    nLayerIndex = atoi(pszLayerDef);
-    if( nLayerIndex <  OGR_DS_GetLayerCount(hDS) )
-      hLayer = OGR_DS_GetLayer( hDS, nLayerIndex );
-  }
-
-  if (hLayer == NULL) {
-    msSetError(MS_OGRERR, "GetLayer(%s) failed for OGR connection. Check logs.",
-               "msOGRFileOpen()",
-               pszLayerDef);
-    msDebug("GetLayer(%s) failed for OGR connection `%s'.\n",
-            pszLayerDef, connection );
-    CPLFree( pszLayerDef );
-    msConnPoolRelease( layer, hDS );
-    return NULL;
-  }
-
-  /* ------------------------------------------------------------------
-   * OK... open succeded... alloc and fill msOGRFileInfo inside layer obj
-   * ------------------------------------------------------------------ */
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)CPLCalloc(1,sizeof(msOGRFileInfo));
-
-  psInfo->pszFname = CPLStrdup(OGR_DS_GetName( hDS ));
-  psInfo->pszLayerDef = pszLayerDef;
-  psInfo->nLayerIndex = nLayerIndex;
-  psInfo->hDS = hDS;
-  psInfo->hLayer = hLayer;
-
-  psInfo->nTileId = 0;
-  msInitProjection(&(psInfo->sTileProj));
-  msProjectionInheritContextFrom(&(psInfo->sTileProj),&(layer->projection));
-  psInfo->poCurTile = NULL;
-  psInfo->rect_is_defined = false;
-  psInfo->rect.minx = psInfo->rect.maxx = 0;
-  psInfo->rect.miny = psInfo->rect.maxy = 0;
-  psInfo->last_record_index_read = -1;
-  psInfo->dialect = NULL;
-
-  psInfo->pszSelect = NULL;
-  psInfo->pszSpatialFilterTableName = NULL;
-  psInfo->pszSpatialFilterGeometryColumn = NULL;
-  psInfo->pszMainTableName = NULL;
-  psInfo->pszRowId = NULL;
-  psInfo->bIsOKForSQLCompose = true;
-  psInfo->bPaging = false;
-  psInfo->bHasSpatialIndex = false;
-  psInfo->pszTablePrefix = NULL;
-  psInfo->pszWHERE = NULL;
-
-    // GDAL 1.x API
-  OGRSFDriverH dr = OGR_DS_GetDriver(hDS);
-  const char *name = OGR_Dr_GetName(dr);
-  if (strcmp(name, "SQLite") == 0) {
-    bool have_spatialite = false;
-
-    CPLPushErrorHandler(CPLQuietErrorHandler);
-
-    // test for Spatialite support in driver
-    const char *test_spatialite = "SELECT spatialite_version()";
-    OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_spatialite, NULL, NULL);
-    if (l) {
-        OGR_DS_ReleaseResultSet(hDS, l);
-        have_spatialite = true;
-    }
-
-    // test for Spatialite enabled db
-    if (have_spatialite) {
-        have_spatialite = false;
-        const char *test_sql = "select 1 from sqlite_master where name = 'geometry_columns' and sql LIKE '%spatial_index_enabled%'";
-        OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_sql, NULL, NULL);
-        if (l) {
-            if (OGR_L_GetFeatureCount(l, TRUE) == 1)
-                have_spatialite = true;
-            OGR_DS_ReleaseResultSet(hDS, l);
-        }
-    }
-
-    CPLPopErrorHandler();
-    CPLErrorReset();
-
-    if (have_spatialite)
-        psInfo->dialect = "Spatialite";
-    else
-        msDebug("msOGRFileOpen: Native SQL not available, no Spatialite support and/or not a Spatialite enabled db\n");
-  } else if (strcmp(name, "PostgreSQL") == 0) {
-    psInfo->dialect = "PostgreSQL";
-    // todo: PostgreSQL not yet tested
-
-  } else if (strcmp(name, "GPKG") == 0 && nLayerIndex >= 0 &&
-             atoi(GDALVersionInfo("VERSION_NUM")) >= 2000000) {
-
-    bool has_rtree = false;
-    const char* test_rtree =
-        CPLSPrintf("SELECT 1 FROM sqlite_master WHERE name = 'rtree_%s_%s'",
-                   OGR_L_GetName(hLayer), OGR_L_GetGeometryColumn(hLayer));
-    OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_rtree, NULL, NULL);
-    if( l )
-    {
-        if( OGR_L_GetFeatureCount(l, TRUE) == 1 )
-        {
-            has_rtree = true;
-        }
-        OGR_DS_ReleaseResultSet(hDS, l);
-    }
-    if( has_rtree )
-    {
-        bool have_gpkg_spatialite = false;
-
-        CPLPushErrorHandler(CPLQuietErrorHandler);
-
-        // test for Spatialite >= 4.3 support in driver
-        const char *test_spatialite = "SELECT spatialite_version()";
-        l = OGR_DS_ExecuteSQL(hDS, test_spatialite, NULL, NULL);
-        if (l) {
-            OGRFeatureH hFeat = OGR_L_GetNextFeature(l);
-            if( hFeat )
-            {
-                const char* pszVersion = OGR_F_GetFieldAsString(hFeat, 0);
-                have_gpkg_spatialite = atof(pszVersion) >= 4.3;
-                OGR_F_Destroy(hFeat);
-            }
-            OGR_DS_ReleaseResultSet(hDS, l);
-        }
-        CPLPopErrorHandler();
-        CPLErrorReset();
-
-        if( have_gpkg_spatialite )
-        {
-            psInfo->pszMainTableName = msStrdup( OGR_L_GetName(hLayer) );
-            psInfo->pszTablePrefix = msStrdup( psInfo->pszMainTableName );
-            psInfo->pszSpatialFilterTableName = msStrdup( OGR_L_GetName(hLayer) );
-            psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_L_GetGeometryColumn(hLayer) );
-            psInfo->dialect = "GPKG";
-            psInfo->bPaging = true;
-            psInfo->bHasSpatialIndex = true;
-        }
-        else
-            msDebug("msOGRFileOpen: Spatialite support in GPKG not enabled\n");
-    }
-    else
-    {
-        msDebug("msOGRFileOpen: RTree index not available\n");
-    }
-  }
-
-  if( psInfo->dialect != NULL && EQUAL(psInfo->dialect, "Spatialite") )
-    msOGRFileOpenSpatialite(layer, pszLayerDef, psInfo);
-
-  return psInfo;
-}
-
-/************************************************************************/
-/*                      msOGRFileOpenSpatialite()                       */
-/************************************************************************/
-
-static void msOGRFileOpenSpatialite( layerObj *layer, 
-                                     const char* pszLayerDef,
-                                     msOGRFileInfo *psInfo )
-{
-  // In the case of a SQLite DB, check that we can identify the
-  // underlying table
-  if( psInfo->nLayerIndex == -1 )
-  {
-      psInfo->bIsOKForSQLCompose = false;
-
-      const char* from = strstr( psInfo->pszLayerDef, " from ");
-      if( from == NULL )
-        from = strstr( psInfo->pszLayerDef, " FROM ");
-      if( from )
-      {
-        const char* pszBeginningOfTable = from + strlen(" FROM ");
-        const char* pszIter = pszBeginningOfTable;
-        while( *pszIter && *pszIter != ' ' )
-          pszIter ++;
-        if( strchr(pszIter, ',') == NULL &&
-            strstr(pszIter, " where ") == NULL && strstr(pszIter, " WHERE ") == NULL &&
-            strstr(pszIter, " join ") == NULL && strstr(pszIter, " JOIN ") == NULL &&
-            strstr(pszIter, " order by ") == NULL && strstr(pszIter, " ORDER BY ") == NULL)
-        {
-          psInfo->bIsOKForSQLCompose = true;
-          psInfo->pszMainTableName = msStrdup(pszBeginningOfTable);
-          psInfo->pszMainTableName[pszIter - pszBeginningOfTable] = '\0';
-          psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
-          psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_L_GetGeometryColumn(psInfo->hLayer) );
-
-          char* pszRequest = NULL;
-          pszRequest = msStringConcatenate(pszRequest,
-              "SELECT name FROM sqlite_master WHERE type = 'table' AND name = lower('");
-          pszRequest = msStringConcatenate(pszRequest, psInfo->pszMainTableName);
-          pszRequest = msStringConcatenate(pszRequest, "')");
-          OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-          msFree(pszRequest);
-
-          if( hLayer )
-          {
-              OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-              psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-              if( hFeature )
-              {
-                msFree(psInfo->pszMainTableName);
-                msFree(psInfo->pszSpatialFilterTableName);
-                psInfo->pszMainTableName = msStrdup( OGR_F_GetFieldAsString( hFeature, 0) );
-                psInfo->pszSpatialFilterTableName = msStrdup( psInfo->pszMainTableName );
-                OGR_F_Destroy(hFeature);
-              }
-              OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-          }
-          if( psInfo->bIsOKForSQLCompose )
-          {
-            psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
-          }
-          else
-          {
-            // Test if it is a spatial view
-            pszRequest = msStringConcatenate(NULL,
-              "SELECT f_table_name, f_geometry_column, view_rowid FROM views_geometry_columns WHERE view_name = lower('");
-            pszRequest = msStringConcatenate(pszRequest, psInfo->pszMainTableName);
-            pszRequest = msStringConcatenate(pszRequest, "')");
-            CPLPushErrorHandler(CPLQuietErrorHandler);
-            OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-            CPLPopErrorHandler();
-            msFree(pszRequest);
-
-            if( hLayer )
-            {
-                OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-                psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-                if( hFeature )
-                {
-                  psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
-                  msFree(psInfo->pszSpatialFilterTableName);
-                  psInfo->pszSpatialFilterTableName = msStrdup( OGR_F_GetFieldAsString( hFeature, 0 ) );
-                  CPLFree( psInfo->pszSpatialFilterGeometryColumn );
-                  psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_F_GetFieldAsString( hFeature, 1 ) );
-                  psInfo->pszRowId = msStrdup( OGR_F_GetFieldAsString( hFeature, 2 ) );
-                  OGR_F_Destroy(hFeature);
-                }
-                OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-            }
-          }
-        }
-      }
-  }
-  else
-  {
-      psInfo->bIsOKForSQLCompose = false;
-
-      char* pszRequest = NULL;
-      pszRequest = msStringConcatenate(pszRequest,
-          "SELECT * FROM sqlite_master WHERE type = 'table' AND name = lower('");
-      pszRequest = msStringConcatenate(pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-      pszRequest = msStringConcatenate(pszRequest, "')");
-      OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-      msFree(pszRequest);
-
-      if( hLayer )
-      {
-          OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-          psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-          if( hFeature )
-            OGR_F_Destroy(hFeature);
-          OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-      }
-      if( psInfo->bIsOKForSQLCompose )
-      {
-        psInfo->pszMainTableName = msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-        psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
-        psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_L_GetGeometryColumn(psInfo->hLayer) );
-      }
-      else
-      {
-        // Test if it is a spatial view
-        pszRequest = msStringConcatenate(NULL,
-          "SELECT f_table_name, f_geometry_column, view_rowid FROM views_geometry_columns WHERE view_name = lower('");
-        pszRequest = msStringConcatenate(pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-        pszRequest = msStringConcatenate(pszRequest, "')");
-        CPLPushErrorHandler(CPLQuietErrorHandler);
-        OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-        CPLPopErrorHandler();
-        msFree(pszRequest);
-
-        if( hLayer )
-        {
-            OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-            psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-            if( hFeature )
-            {
-              psInfo->pszMainTableName = msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-              psInfo->pszSpatialFilterTableName = msStrdup( OGR_F_GetFieldAsString( hFeature, 0 ) );
-              psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_F_GetFieldAsString( hFeature, 1 ) );
-              psInfo->pszRowId = msStrdup( OGR_F_GetFieldAsString( hFeature, 2 ) );
-              OGR_F_Destroy(hFeature);
-            }
-            OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-        }
-      }
-  }
-
-  // in the case we cannot handle the native string, go back to the client
-  // side evaluation by unsetting it.
-  if( !psInfo->bIsOKForSQLCompose && psInfo->dialect != NULL )
-  {
-      if (layer->debug >= MS_DEBUGLEVEL_VVV)
-      {
-        msDebug("msOGRFileOpen(): Falling back to MapServer only evaluation\n");
-      }
-      psInfo->dialect = NULL;
-  }
-
-  // Check if spatial index has been disabled (testing purposes)
-  if (msLayerGetProcessingKey(layer, "USE_SPATIAL_INDEX") != NULL &&
-      !CSLTestBoolean(msLayerGetProcessingKey(layer, "USE_SPATIAL_INDEX")) )
-  {
-      if (layer->debug >= MS_DEBUGLEVEL_VVV)
-      {
-        msDebug("msOGRFileOpen(): Layer %s has spatial index disabled by processing option\n",
-                pszLayerDef);
-      }
-  }
-  // Test if spatial index is available
-  else if( psInfo->dialect != NULL )
-  {
-      char* pszRequest = NULL;
-      pszRequest = msStringConcatenate(pszRequest,
-          "SELECT * FROM sqlite_master WHERE type = 'table' AND name = 'idx_");
-      pszRequest = msStringConcatenate(pszRequest,
-                                       psInfo->pszSpatialFilterTableName);
-      pszRequest = msStringConcatenate(pszRequest, "_");
-      pszRequest = msStringConcatenate(pszRequest,
-                                    OGR_L_GetGeometryColumn(psInfo->hLayer));
-      pszRequest = msStringConcatenate(pszRequest, "'");
-
-      psInfo->bHasSpatialIndex = false;
-      //msDebug("msOGRFileOpen(): %s", pszRequest);
-
-      OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-      if( hLayer )
-      {
-        OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-        if( hFeature )
-        {
-            psInfo->bHasSpatialIndex = true;
-            OGR_F_Destroy(hFeature);
-        }
-        OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-      }
-      msFree(pszRequest);
-      pszRequest = NULL;
-
-      if( !psInfo->bHasSpatialIndex )
-      {
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          {
-            msDebug("msOGRFileOpen(): Layer %s has no spatial index table\n",
-                    pszLayerDef);
-          }
-      }
-      else
-      {
-          pszRequest = msStringConcatenate(pszRequest,
-            "SELECT * FROM geometry_columns WHERE f_table_name = lower('");
-          pszRequest = msStringConcatenate(pszRequest,
-                                       psInfo->pszSpatialFilterTableName);
-          pszRequest = msStringConcatenate(pszRequest, "') AND f_geometry_column = lower('");
-          pszRequest = msStringConcatenate(pszRequest,
-                                       psInfo->pszSpatialFilterGeometryColumn);
-          pszRequest = msStringConcatenate(pszRequest, "') AND spatial_index_enabled = 1");
-
-          psInfo->bHasSpatialIndex = false;
-
-          OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-          if( hLayer )
-          {
-            OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-            if( hFeature )
-            {
-                psInfo->bHasSpatialIndex = true;
-                OGR_F_Destroy(hFeature);
-            }
-            OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-          }
-          msFree(pszRequest);
-          pszRequest = NULL;
-
-          if( !psInfo->bHasSpatialIndex )
-          {
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-              msDebug("msOGRFileOpen(): Layer %s has spatial index disabled\n",
-                      pszLayerDef);
-            }
-          }
-          else
-          {
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-              msDebug("msOGRFileOpen(): Layer %s has spatial index enabled\n",
-                      pszLayerDef);
-            }
-
-            psInfo->pszTablePrefix = msStrdup( psInfo->pszMainTableName );
-          }
-      }
-  }
-
-  psInfo->bPaging = (psInfo->dialect != NULL);
-}
-
-/************************************************************************/
-/*                        msOGRCloseConnection()                        */
-/*                                                                      */
-/*      Callback for thread pool to actually release an OGR             */
-/*      connection.                                                     */
-/************************************************************************/
-
-static void msOGRCloseConnection( void *conn_handle )
-
-{
-  OGRDataSourceH hDS = (OGRDataSourceH) conn_handle;
-
-  ACQUIRE_OGR_LOCK;
-  OGR_DS_Destroy( hDS );
-  RELEASE_OGR_LOCK;
-}
-
-/**********************************************************************
- *                     msOGRFileClose()
- **********************************************************************/
-static int msOGRFileClose(layerObj *layer, msOGRFileInfo *psInfo )
-{
-  if (!psInfo)
-    return MS_SUCCESS;
-
-  if( layer->debug )
-    msDebug("msOGRFileClose(%s,%d).\n",
-            psInfo->pszFname, psInfo->nLayerIndex);
-
-  CPLFree(psInfo->pszFname);
-  CPLFree(psInfo->pszLayerDef);
-
-  ACQUIRE_OGR_LOCK;
-  if (psInfo->hLastFeature)
-    OGR_F_Destroy( psInfo->hLastFeature );
-
-  /* If nLayerIndex == -1 then the layer is an SQL result ... free it */
-  if( psInfo->nLayerIndex == -1 )
-    OGR_DS_ReleaseResultSet( psInfo->hDS, psInfo->hLayer );
-
-  // Release (potentially close) the datasource connection.
-  // Make sure we aren't holding the lock when the callback may need it.
-  RELEASE_OGR_LOCK;
-  msConnPoolRelease( layer, psInfo->hDS );
-
-  // Free current tile if there is one.
-  if( psInfo->poCurTile != NULL )
-    msOGRFileClose( layer, psInfo->poCurTile );
-
-  msFreeProjection(&(psInfo->sTileProj));
-  msFree(psInfo->pszSelect);
-  msFree(psInfo->pszSpatialFilterTableName);
-  msFree(psInfo->pszSpatialFilterGeometryColumn);
-  msFree(psInfo->pszMainTableName);
-  msFree(psInfo->pszRowId);
-  msFree(psInfo->pszTablePrefix);
-  msFree(psInfo->pszWHERE);
-
-  CPLFree(psInfo);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                           msOGREscapeSQLParam                        */
-/************************************************************************/
-static char *msOGREscapeSQLParam(layerObj *layer, const char *pszString)
-{
-  char* pszEscapedStr =NULL;
-  if(layer && pszString) {
-    char* pszEscapedOGRStr =  CPLEscapeString(pszString, strlen(pszString),
-                              CPLES_SQL );
-    pszEscapedStr = msStrdup(pszEscapedOGRStr);
-    CPLFree(pszEscapedOGRStr);
-  }
-  return pszEscapedStr;
-}
-
-// http://www.sqlite.org/lang_expr.html
-// http://www.gaia-gis.it/gaia-sins/spatialite-sql-4.3.0.html
-
-static char* msOGRGetQuotedItem(layerObj* layer, const char* pszItem )
-{
-    msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
-    char* ret = NULL;
-    char* escapedItem = msLayerEscapePropertyName(layer, pszItem);
-    if( psInfo->pszTablePrefix)
-    {
-        char* escapedTable = msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
-        ret = msStringConcatenate(ret, "\"");
-        ret = msStringConcatenate(ret, escapedTable);
-        ret = msStringConcatenate(ret, "\".\"");
-        ret = msStringConcatenate(ret, escapedItem);
-        ret = msStringConcatenate(ret, "\"");
-        msFree(escapedTable);
-    }
-    else
-    {
-        ret = msStringConcatenate(ret, "\"");
-        ret = msStringConcatenate(ret, escapedItem);
-        ret = msStringConcatenate(ret, "\"");
-    }
-    msFree(escapedItem);
-    return ret;
-}
-
-static
-char *msOGRGetToken(layerObj* layer, tokenListNodeObjPtr *node) {
-    msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
-    tokenListNodeObjPtr n = *node;
-    if (!n) return NULL;
-    char *out = NULL;
-    size_t nOutSize;
-
-    switch(n->token) {
-    case MS_TOKEN_LOGICAL_AND:
-        out = msStrdup(" AND ");
-        break;
-    case MS_TOKEN_LOGICAL_OR:
-        out = msStrdup(" OR ");
-        break;
-    case MS_TOKEN_LOGICAL_NOT:
-        out = msStrdup(" NOT ");
-        break;
-    case MS_TOKEN_LITERAL_NUMBER:
-        nOutSize = 32;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "%.18g", n->tokenval.dblval);
-        break;
-    case MS_TOKEN_LITERAL_STRING: {
-        char *stresc = msOGREscapeSQLParam(layer, n->tokenval.strval);
-        nOutSize = strlen(stresc)+3;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "'%s'", stresc);
-        msFree(stresc);
-        break;
-    }
-    case MS_TOKEN_LITERAL_TIME:
-        // seems to require METADATA gml_types => auto
-        nOutSize = 80;
-        out = (char *)msSmallMalloc(nOutSize);
-#if 0
-        // FIXME? or perhaps just remove me. tm_zone is not supported on Windows, and not used anywhere else in the code base
-        if (n->tokenval.tmval.tm_zone)
-            snprintf(out, nOutSize, "'%d-%02d-%02dT%02d:%02d:%02d%s'",
-                     n->tokenval.tmval.tm_year+1900, n->tokenval.tmval.tm_mon+1, n->tokenval.tmval.tm_mday,
-                     n->tokenval.tmval.tm_hour, n->tokenval.tmval.tm_min, n->tokenval.tmval.tm_sec,
-                     n->tokenval.tmval.tm_zone);
-        else
-#endif
-            snprintf(out, nOutSize, "'%d-%02d-%02dT%02d:%02d:%02d'",  
-                     n->tokenval.tmval.tm_year+1900, n->tokenval.tmval.tm_mon+1, n->tokenval.tmval.tm_mday,
-                     n->tokenval.tmval.tm_hour, n->tokenval.tmval.tm_min, n->tokenval.tmval.tm_sec);
-        break;
-    case MS_TOKEN_LITERAL_SHAPE: {
-        // assumed to be in right srs after FLTGetSpatialComparisonCommonExpression
-        char *wkt = msShapeToWKT(n->tokenval.shpval);
-        char *stresc = msOGRGetQuotedItem(layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
-        nOutSize = strlen(wkt)+strlen(stresc)+35;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "ST_GeomFromText('%s',ST_SRID(%s))", wkt, stresc);
-        msFree(wkt);
-        msFree(stresc);
-        break;
-    }
-    case MS_TOKEN_LITERAL_BOOLEAN:
-        out = msStrdup(n->tokenval.dblval == 0 ? "FALSE" : "TRUE");
-        break;
-    case MS_TOKEN_COMPARISON_EQ:
-        if(n->next != NULL && n->next->token == MS_TOKEN_LITERAL_STRING &&
-           strcmp(n->next->tokenval.strval, "_MAPSERVER_NULL_") == 0 )
-        {
-            out = msStrdup(" IS NULL");
-            n = n->next;
-            break;
-        }
-
-        out = msStrdup(" = ");
-        break;
-    case MS_TOKEN_COMPARISON_NE:
-        out = msStrdup(" != ");
-        break;
-    case MS_TOKEN_COMPARISON_GT:
-        out = msStrdup(" > ");
-        break;
-    case MS_TOKEN_COMPARISON_LT:
-        out = msStrdup(" < ");
-        break;
-    case MS_TOKEN_COMPARISON_LE:
-        out = msStrdup(" <= ");
-        break;
-    case MS_TOKEN_COMPARISON_GE:
-        out = msStrdup(" >= ");
-        break;
-    case MS_TOKEN_COMPARISON_IEQ:
-        out = msStrdup(" = ");
-        break;
-    case MS_TOKEN_COMPARISON_IN:
-        out = msStrdup(" IN ");
-        break;
-    // the origin may be mapfile (complex regexes, layer->map.query.filter.string == NULL, regex may have //) or 
-    // OGC Filter (simple patterns only, layer->map.query.filter.string != NULL)
-    case MS_TOKEN_COMPARISON_RE: 
-    case MS_TOKEN_COMPARISON_IRE: 
-    case MS_TOKEN_COMPARISON_LIKE: {
-        int case_sensitive = n->token == MS_TOKEN_COMPARISON_RE || n->token == MS_TOKEN_COMPARISON_LIKE;
-        // in PostgreSQL and OGR: LIKE (case sensitive) and ILIKE (case insensitive)
-        // in SQLite: LIKE (case insensitive) and GLOB (case sensitive)
-        const char *op = case_sensitive ? "LIKE" : "ILIKE";
-        char wild_any =  '%';
-        char wild_one = '_';
-
-        if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG")) {
-            if (case_sensitive) {
-                op = "GLOB";
-                wild_any = '*';
-                wild_one = '?';
-            } else {
-                op = "LIKE";
-            }
-        }
-
-        n = n->next;
-        if (n->token != MS_TOKEN_LITERAL_STRING) return NULL;
-
-        char *regex = msStrdup(n->tokenval.strval);
-        int complex_regex = *n->tokenval.strval == '/'; // could be non-complex but that is soo corner case
-
-        // PostgreSQL has POSIX regexes, SQLite does not by default, OGR does not
-        if (complex_regex) {
-            if (!EQUAL(info->dialect, "PostgreSQL")) {
-                msFree(regex);
-                return NULL;
-            }
-            // remove //
-            regex++;
-            regex[strlen(regex) - 1] = '\0';
-            if (case_sensitive)
-                op = "~";
-            else
-                op = "~*";
-        }
-
-        const size_t regex_len = strlen(regex);
-        char *re = (char *) msSmallMalloc(2 * regex_len+3);
-        size_t i = 0, j = 0;
-        re[j++] = '\'';
-        while (i < regex_len) {
-            char c = regex[i];
-            char c_next = regex[i+1];
-                
-            if (c == '.' && c_next == '*') {
-                i++;
-                c = wild_any;
-            }
-            else if (c == '.')
-                c = wild_one;
-            else if (i == 0 && c == '^') {
-                i++;
-                continue;
-            }
-            else if( c == '$' && c_next == 0 ) {
-                break;
-            }
-            else if( c == '\'' )
-            {
-                re[j++] = '\'';
-            }
-            else if( c == '\\' )
-            {
-                if( c_next == 0 ) {
-                    break;
-                }
-                i++;
-                c = c_next;
-            }
-
-            re[j++] = c;
-            i++;
-                
-        }
-        re[j++] = '\'';
-        re[j] = '\0';
-
-        nOutSize = 1 + strlen(op)+ 1 + strlen(re) + 1;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, " %s %s", op, re);
-        msFree(re);
-        msFree(regex);
-        break;
-    }
-    case MS_TOKEN_COMPARISON_INTERSECTS:
-        out = msStrdup("ST_Intersects");
-        break;
-    case MS_TOKEN_COMPARISON_DISJOINT:
-        out = msStrdup("ST_Disjoint");
-        break;
-    case MS_TOKEN_COMPARISON_TOUCHES:
-        out = msStrdup("ST_Touches");
-        break;
-    case MS_TOKEN_COMPARISON_OVERLAPS:
-        out = msStrdup("ST_Overlaps");
-        break;
-    case MS_TOKEN_COMPARISON_CROSSES:
-        out = msStrdup("ST_Crosses");
-        break;
-    case MS_TOKEN_COMPARISON_WITHIN:
-        out = msStrdup("ST_Within");
-        break;
-    case MS_TOKEN_COMPARISON_DWITHIN:
-        out = msStrdup("ST_Distance");
-        break;
-    case MS_TOKEN_COMPARISON_BEYOND:
-        out = msStrdup("ST_Distance");
-        break;
-    case MS_TOKEN_COMPARISON_CONTAINS:
-        out = msStrdup("ST_Contains");
-        break;
-    case MS_TOKEN_COMPARISON_EQUALS:
-        out = msStrdup("ST_Equals");
-        break;
-    case MS_TOKEN_FUNCTION_LENGTH:
-        out = msStrdup("ST_Length");
-        break;
-    case MS_TOKEN_FUNCTION_AREA:
-        out = msStrdup("ST_Area");
-        break;
-    case MS_TOKEN_BINDING_DOUBLE: {
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc)+ + 30;
-        out = (char *)msSmallMalloc(nOutSize);
-
-        char md_item_name[256];
-        snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                  n->tokenval.bindval.item );
-        const char* type = msLookupHashTable(&(layer->metadata), md_item_name);
-        // Do not cast if the variable is of the appropriate type as it can
-        // prevent using database indexes, such as for SQlite
-        if( type != NULL && (EQUAL(type, "Integer") ||
-                             EQUAL(type, "Long") ||
-                             EQUAL(type, "Real")) )
-        {
-             snprintf(out, nOutSize, "%s", stresc);
-        }
-        else
-        {
-            const char *SQLtype = "float(16)";
-            if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG"))
-                SQLtype = "REAL";
-            else if (EQUAL(info->dialect, "PostgreSQL"))
-                SQLtype = "double precision";
-            snprintf(out, nOutSize, "CAST(%s AS %s)", stresc, SQLtype);
-        }
-        msFree(stresc);
-        break;
-    }
-    case MS_TOKEN_BINDING_INTEGER: {
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc)+ 20;
-        out = (char *)msSmallMalloc(nOutSize);
-
-        char md_item_name[256];
-        snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                  n->tokenval.bindval.item );
-        const char* type = msLookupHashTable(&(layer->metadata), md_item_name);
-        // Do not cast if the variable is of the appropriate type as it can
-        // prevent using database indexes, such as for SQlite
-        if( type != NULL && (EQUAL(type, "Integer") ||
-                             EQUAL(type, "Long") ||
-                             EQUAL(type, "Real")) )
-        {
-            snprintf(out, nOutSize, "%s", stresc);
-        }
-        else
-        {
-            snprintf(out, nOutSize, "CAST(%s AS integer)", stresc);
-        }
-        msFree(stresc);
-        break;
-    }
-    case MS_TOKEN_BINDING_STRING: {
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc) + 30;
-        out = (char *)msSmallMalloc(nOutSize);
-
-        char md_item_name[256];
-        snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                  n->tokenval.bindval.item );
-        const char* type = msLookupHashTable(&(layer->metadata), md_item_name);
-        // Do not cast if the variable is of the appropriate type as it can
-        // prevent using database indexes, such as for SQlite
-        if( type != NULL && EQUAL(type, "Character") )
-        {
-            snprintf(out, nOutSize, "%s", stresc);
-        }
-        else
-        {
-            snprintf(out, nOutSize, "CAST(%s AS text)", stresc);
-        }
-        msFree(stresc);
-        break;
-    }
-    case MS_TOKEN_BINDING_TIME: {
-        // won't get here unless col is parsed as time and they are not
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc)+ 10;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "%s", stresc);
-        msFree(stresc);
-        break;
-    }
-    case MS_TOKEN_BINDING_SHAPE: {
-        char *stresc = msOGRGetQuotedItem(layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
-        nOutSize = strlen(stresc)+ 10;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "%s", stresc);
-        msFree(stresc);
-        break;
-    }
-
-    // unhandled below until default
-
-    case MS_TOKEN_FUNCTION_TOSTRING:
-    case MS_TOKEN_FUNCTION_COMMIFY:
-    case MS_TOKEN_FUNCTION_ROUND:
-    case MS_TOKEN_FUNCTION_FROMTEXT:
-    case MS_TOKEN_FUNCTION_BUFFER:
-    case MS_TOKEN_FUNCTION_DIFFERENCE:
-    case MS_TOKEN_FUNCTION_SIMPLIFY:
-    case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-    case MS_TOKEN_FUNCTION_GENERALIZE:
-    case MS_TOKEN_FUNCTION_SMOOTHSIA:
-    case MS_TOKEN_FUNCTION_JAVASCRIPT:
-    case MS_TOKEN_FUNCTION_UPPER:
-    case MS_TOKEN_FUNCTION_LOWER:
-    case MS_TOKEN_FUNCTION_INITCAP:
-    case MS_TOKEN_FUNCTION_FIRSTCAP:
-    case MS_TOKEN_BINDING_MAP_CELLSIZE:
-    case MS_TOKEN_BINDING_DATA_CELLSIZE:
-    case MS_PARSE_TYPE_BOOLEAN:
-    case MS_PARSE_TYPE_STRING:
-    case MS_PARSE_TYPE_SHAPE:
-        break;
-
-    default:
-        if (n->token < 128) {
-            char c = n->token;
-            out = (char *)msSmallMalloc(2);
-            sprintf(out, "%c", c);
-        }
-        break;
-    }
-
-    n = n->next;
-    *node = n;
-    return out;
-}
-
-/*
- * msOGRLayerBuildSQLOrderBy()
- *
- * Returns the content of a SQL ORDER BY clause from the sortBy member of
- * the layer. The string does not contain the "ORDER BY" keywords itself.
- */
-static char* msOGRLayerBuildSQLOrderBy(layerObj *layer, msOGRFileInfo *psInfo)
-{
-  char* strOrderBy = NULL;
-  if( layer->sortBy.nProperties > 0 ) {
-    int i;
-    for(i=0;i<layer->sortBy.nProperties;i++) {
-      if( i > 0 )
-        strOrderBy = msStringConcatenate(strOrderBy, ", ");
-      char* escapedItem = msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
-      if( psInfo->pszTablePrefix)
-      {
-          char* escapedTable = msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
-          strOrderBy = msStringConcatenate(strOrderBy, escapedTable);
-          strOrderBy = msStringConcatenate(strOrderBy, "\".\"");
-          strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
-          msFree(escapedTable);
-      }
-      else
-      {
-#if GDAL_VERSION_MAJOR < 2
-          // Old GDAL don't like quoted identifiers in ORDER BY
-          strOrderBy = msStringConcatenate(strOrderBy,
-                                           layer->sortBy.properties[i].item);
-#else
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
-          strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
-#endif
-      }
-      msFree(escapedItem);
-      if( layer->sortBy.properties[i].sortOrder == SORT_DESC )
-        strOrderBy = msStringConcatenate(strOrderBy, " DESC");
-    }
-  }
-  return strOrderBy;
-}
-
-/**********************************************************************
- *                     msOGRFileWhichShapes()
- *
- * Init OGR layer structs ready for calls to msOGRFileNextShape().
- *
- * Returns MS_SUCCESS/MS_FAILURE, or MS_DONE if no shape matching the
- * layer's FILTER overlaps the selected region.
- **********************************************************************/
-static int msOGRFileWhichShapes(layerObj *layer, rectObj rect, msOGRFileInfo *psInfo)
-{
-    // rect is from BBOX parameter in query (In lieu of a FEATUREID or FILTER) or mapfile somehow
-    if (psInfo == NULL || psInfo->hLayer == NULL) {
-        msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!", "msOGRFileWhichShapes()");
-        return(MS_FAILURE);
-    }
-
-    char *select = (psInfo->pszSelect) ? msStrdup(psInfo->pszSelect) : NULL;
-    const rectObj rectInvalid = MS_INIT_INVALID_RECT;
-    bool bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
-
-    // we'll go strictly two possible ways: 
-    // 1) GetLayer + SetFilter
-    // 2) ExecuteSQL (psInfo->hLayer is an SQL result OR sortBy was requested OR have native_string
-    // and start from the second
-
-    if ( psInfo->bIsOKForSQLCompose && (psInfo->nLayerIndex == -1 ||
-                                        layer->sortBy.nProperties > 0 ||
-                                        layer->filter.native_string ||
-                                        (psInfo->bPaging && layer->maxfeatures > 0)) ) {
-
-        const bool bHasGeometry = 
-                                OGR_L_GetGeomType( psInfo->hLayer ) != wkbNone;
-
-        if( psInfo->nLayerIndex == -1 && select == NULL ) {
-            select = msStrdup(psInfo->pszLayerDef);
-            /* If nLayerIndex == -1 then the layer is an SQL result ... free it */
-            OGR_DS_ReleaseResultSet( psInfo->hDS, psInfo->hLayer );
-            psInfo->hLayer = NULL;
-        }
-        else if( select == NULL ) {
-            const char* pszGeometryColumn;
-            int i;
-            select = msStringConcatenate(select, "SELECT ");
-            for(i = 0; i < layer->numitems; i++) {
-                if( i > 0 )
-                    select = msStringConcatenate(select, ", ");
-                char* escaped = msOGRGetQuotedItem(layer, layer->items[i]);
-                select = msStringConcatenate(select, escaped);
-                msFree(escaped);
-                if( psInfo->pszTablePrefix )
-                {
-                    select = msStringConcatenate(select, " AS \"");
-                    escaped = msLayerEscapePropertyName(layer, layer->items[i]);
-                    select = msStringConcatenate(select, escaped);
-                    msFree(escaped);
-                    select = msStringConcatenate(select, "\"");
-                }
-            }
-            if( layer->numitems > 0 )
-                select = msStringConcatenate(select, ", ");
-            pszGeometryColumn = OGR_L_GetGeometryColumn(psInfo->hLayer);
-            if( pszGeometryColumn != NULL && pszGeometryColumn[0] != '\0' ) {
-                char* escaped = msOGRGetQuotedItem(layer, pszGeometryColumn);
-                select = msStringConcatenate(select, escaped);
-                msFree(escaped);
-                if( psInfo->pszTablePrefix )
-                {
-                    select = msStringConcatenate(select, " AS \"");
-                    escaped = msLayerEscapePropertyName(layer, pszGeometryColumn);
-                    select = msStringConcatenate(select, escaped);
-                    msFree(escaped);
-                    select = msStringConcatenate(select, "\"");
-                }
-            } else {
-                /* Add ", *" so that we still have an hope to get the geometry */
-                if( psInfo->pszTablePrefix )
-                {
-                    select = msStringConcatenate(select, "\"");
-                    char* escaped = msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
-                    select = msStringConcatenate(select, escaped);
-                    msFree(escaped);
-                    select = msStringConcatenate(select, "\".");
-                }
-                select = msStringConcatenate(select, "*");
-            }
-            select = msStringConcatenate(select, " FROM ");
-            if( psInfo->nLayerIndex == -1 )
-            {
-              select = msStringConcatenate(select, "(");
-              select = msStringConcatenate(select, psInfo->pszLayerDef);
-              select = msStringConcatenate(select, ") MSSUBSELECT");
-            }
-            else
-            {
-              select = msStringConcatenate(select, "\"");
-              char* escaped = msLayerEscapePropertyName(layer, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-              select = msStringConcatenate(select, escaped);
-              msFree(escaped);
-              select = msStringConcatenate(select, "\"");
-            }
-        }
-
-        char *filter = NULL;
-        if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
-            filter = msStringConcatenate(filter, "(");
-            filter = msStringConcatenate(filter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
-            filter = msStringConcatenate(filter, ")");
-        }
-
-        /* ------------------------------------------------------------------
-         * Set Spatial filter... this may result in no features being returned
-         * if layer does not overlap current view.
-         *
-         * __TODO__ We should return MS_DONE if no shape overlaps the selected
-         * region and matches the layer's FILTER expression, but there is currently
-         * no _efficient_ way to do that with OGR.
-         * ------------------------------------------------------------------ */
-        if (psInfo->rect_is_defined) {
-            rect.minx = MAX(psInfo->rect.minx, rect.minx);
-            rect.miny = MAX(psInfo->rect.miny, rect.miny);
-            rect.maxx = MIN(psInfo->rect.maxx, rect.maxx);
-            rect.maxy = MIN(psInfo->rect.maxy, rect.maxy);
-            bIsValidRect = true;
-        }
-        psInfo->rect = rect;
-
-        bool bSpatialiteOrGPKGAddOrderByFID = false;
-
-        const char *sql = layer->filter.native_string;
-        if (psInfo->dialect && sql && *sql != '\0' &&
-            (EQUAL(psInfo->dialect, "Spatialite") ||
-             EQUAL(psInfo->dialect, "GPKG") ||
-             EQUAL(psInfo->dialect, "PostgreSQL")) )
-        {
-            if (filter) filter = msStringConcatenate(filter, " AND ");
-            filter = msStringConcatenate(filter, "(");
-            filter = msStringConcatenate(filter, sql);
-            filter = msStringConcatenate(filter, ")");
-        }
-        else if( psInfo->pszWHERE )
-        {
-            if (filter) filter = msStringConcatenate(filter, " AND ");
-            filter = msStringConcatenate(filter, "(");
-            filter = msStringConcatenate(filter, psInfo->pszWHERE);
-            filter = msStringConcatenate(filter, ")");
-        }
-
-        // use spatial index
-        if (psInfo->dialect && bIsValidRect ) {
-            if (EQUAL(psInfo->dialect, "PostgreSQL")) {
-                if (filter) filter = msStringConcatenate(filter, " AND");
-                const char *col = OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
-                filter = msStringConcatenate(filter, " (\"");
-                char* escaped = msLayerEscapePropertyName(layer, col);
-                filter = msStringConcatenate(filter, escaped);
-                msFree(escaped);
-                filter = msStringConcatenate(filter, "\" && ST_MakeEnvelope(");
-                char *points = (char *)msSmallMalloc(30*2*5);
-                snprintf(points, 30*4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny, rect.maxx, rect.maxy);
-                filter = msStringConcatenate(filter, points);
-                msFree(points);
-                filter = msStringConcatenate(filter, "))");
-            }
-            else if( psInfo->dialect &&
-                     (EQUAL(psInfo->dialect, "Spatialite") ||
-                      EQUAL(psInfo->dialect, "GPKG")) &&
-                     psInfo->pszMainTableName != NULL )
-            {
-                if( (EQUAL(psInfo->dialect, "Spatialite") && psInfo->bHasSpatialIndex)
-                      || EQUAL(psInfo->dialect, "GPKG") )
-                {
-                    if (filter) filter = msStringConcatenate(filter, " AND ");
-                    char* pszEscapedMainTableName = msLayerEscapePropertyName(
-                                                    layer, psInfo->pszMainTableName);
-                    filter = msStringConcatenate(filter, "\"");
-                    filter = msStringConcatenate(filter, pszEscapedMainTableName);
-                    msFree(pszEscapedMainTableName);
-                    filter = msStringConcatenate(filter, "\".");
-                    if( psInfo->pszRowId )
-                    {
-                        char* pszEscapedRowId = msLayerEscapePropertyName(
-                                                            layer, psInfo->pszRowId);
-                        filter = msStringConcatenate(filter, "\"");
-                        filter = msStringConcatenate(filter, pszEscapedRowId);
-                        filter = msStringConcatenate(filter, "\"");
-                        msFree(pszEscapedRowId);
-                    }
-                    else
-                        filter = msStringConcatenate(filter, "ROWID");
-                    
-                    filter = msStringConcatenate(filter, " IN ");
-                    filter = msStringConcatenate(filter, "(");
-                    filter = msStringConcatenate(filter, "SELECT ");
-
-                    if( EQUAL(psInfo->dialect, "Spatialite") )
-                        filter = msStringConcatenate(filter, "ms_spat_idx.pkid");
-                    else
-                        filter = msStringConcatenate(filter, "ms_spat_idx.id");
-
-                    filter = msStringConcatenate(filter, " FROM ");
-
-                    char szSpatialIndexName[256];
-                    snprintf( szSpatialIndexName, sizeof(szSpatialIndexName),
-                                "%s_%s_%s",
-                                EQUAL(psInfo->dialect, "Spatialite") ? "idx" : "rtree",
-                                psInfo->pszSpatialFilterTableName,
-                                psInfo->pszSpatialFilterGeometryColumn );
-                    char* pszEscapedSpatialIndexName = msLayerEscapePropertyName(
-                                                    layer, szSpatialIndexName);
-
-                    filter = msStringConcatenate(filter, "\"");
-                    filter = msStringConcatenate(filter, pszEscapedSpatialIndexName);
-                    msFree(pszEscapedSpatialIndexName);
-                    
-                    filter = msStringConcatenate(filter, "\" ms_spat_idx WHERE ");
-
-                    char szCond[256];
-                    if( EQUAL(psInfo->dialect, "Spatialite") )
-                    {
-                        snprintf(szCond, sizeof(szCond),
-                                "ms_spat_idx.xmin <= %.15g AND ms_spat_idx.xmax >= %.15g AND "
-                                "ms_spat_idx.ymin <= %.15g AND ms_spat_idx.ymax >= %.15g",
-                                rect.maxx, rect.minx, rect.maxy, rect.miny);
-                    }
-                    else
-                    {
-                        snprintf(szCond, sizeof(szCond),
-                                "ms_spat_idx.minx <= %.15g AND ms_spat_idx.maxx >= %.15g AND "
-                                "ms_spat_idx.miny <= %.15g AND ms_spat_idx.maxy >= %.15g",
-                                rect.maxx, rect.minx, rect.maxy, rect.miny);
-                    }
-                    filter = msStringConcatenate(filter, szCond);
-        
-                    filter = msStringConcatenate(filter, ")");
-
-                    bSpatialiteOrGPKGAddOrderByFID = true;
-                }
-
-                const bool isGPKG = EQUAL(psInfo->dialect, "GPKG");
-                if (filter) filter = msStringConcatenate(filter, " AND");
-                const char *col = OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
-                filter = msStringConcatenate(filter, " Intersects(");
-                if( isGPKG )
-                {
-                    // Casting GeoPackage geometries to spatialie ones is done
-                    // automatically normally, since GDAL enables the
-                    // "amphibious" mode, but without it
-                    // explicilty specified, spatialite 4.3.0a does an
-                    // out-of-bounds access.
-                    filter = msStringConcatenate(filter, "GeomFromGPB(");
-                }
-                filter = msStringConcatenate(filter, "\"");
-                char* escaped = msLayerEscapePropertyName(layer, col);
-                filter = msStringConcatenate(filter, escaped);
-                msFree(escaped);
-                filter = msStringConcatenate(filter, "\"");
-                if( isGPKG )
-                    filter = msStringConcatenate(filter, ")");
-                char *points = (char *)msSmallMalloc(30*2*5);
-                if( rect.minx == rect.maxx && rect.miny == rect.maxy ) {
-                  filter = msStringConcatenate(filter, ",  ST_GeomFromText(");
-                  snprintf(points, 30*4, "'POINT(%lf %lf)'", rect.minx, rect.miny);
-                } else {
-                  filter = msStringConcatenate(filter, ", BuildMbr(");
-                  snprintf(points, 30*4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny, rect.maxx, rect.maxy);
-                }
-                filter = msStringConcatenate(filter, points);
-                msFree(points);
-                filter = msStringConcatenate(filter, "))");
-            }
-        }
-
-        /* get sortBy */
-        char *sort = NULL;
-        if( layer->sortBy.nProperties > 0) {
-
-            char *strOrderBy = msOGRLayerBuildSQLOrderBy(layer, psInfo);
-            if (strOrderBy) {
-                if( psInfo->nLayerIndex == -1 ) {
-                    if( strcasestr(psInfo->pszLayerDef, " ORDER BY ") == NULL )
-                        sort = msStringConcatenate(sort, " ORDER BY ");
-                    else
-                        sort = msStringConcatenate(sort, ", ");
-                } else {
-                    sort = msStringConcatenate(sort, " ORDER BY ");
-                }
-                sort = msStringConcatenate(sort, strOrderBy);
-                msFree(strOrderBy);
-            }
-        }
-
-        if( bSpatialiteOrGPKGAddOrderByFID )
-        {
-            if( sort == NULL )
-                sort = msStringConcatenate(NULL, " ORDER BY ");
-            else
-                sort = msStringConcatenate(sort, ", ");
-            char* pszEscapedMainTableName = msLayerEscapePropertyName(
-                                            layer, psInfo->pszMainTableName);
-            sort = msStringConcatenate(sort, "\"");
-            sort = msStringConcatenate(sort, pszEscapedMainTableName);
-            sort = msStringConcatenate(sort, "\".");
-            msFree(pszEscapedMainTableName);
-            if( psInfo->pszRowId )
-            {
-                char* pszEscapedRowId = msLayerEscapePropertyName(
-                                                    layer, psInfo->pszRowId);
-                sort = msStringConcatenate(sort, "\"");
-                sort = msStringConcatenate(sort, pszEscapedRowId);
-                sort = msStringConcatenate(sort, "\"");
-                msFree(pszEscapedRowId);
-            }
-            else
-                sort = msStringConcatenate(sort, "ROWID");
-        }
-
-        // compose SQL
-        if (filter) {
-            select = msStringConcatenate(select, " WHERE ");
-            select = msStringConcatenate(select, filter);
-            msFree(filter);
-        }
-        if (sort) {
-            select = msStringConcatenate(select, " ");
-            select = msStringConcatenate(select, sort);
-            msFree(sort);
-        }
-
-        if ( psInfo->bPaging && layer->maxfeatures >= 0 ) {
-            char szLimit[50];
-            snprintf(szLimit, sizeof(szLimit), " LIMIT %d", layer->maxfeatures);
-            select = msStringConcatenate(select, szLimit);
-        }
-
-        if ( psInfo->bPaging && layer->startindex > 0 ) {
-            char szOffset[50];
-            snprintf(szOffset, sizeof(szOffset), " OFFSET %d", layer->startindex-1);
-            select = msStringConcatenate(select, szOffset);
-        }
-
-        if( layer->debug )
-            msDebug("msOGRFileWhichShapes: SQL = %s.\n", select);
-
-        ACQUIRE_OGR_LOCK;
-        if( psInfo->nLayerIndex == -1 && psInfo->hLayer != NULL )
-        {
-          OGR_DS_ReleaseResultSet( psInfo->hDS, psInfo->hLayer );
-        }
-
-        OGRGeometryH hGeom = NULL;
-        if( psInfo->dialect == NULL &&
-            bHasGeometry && bIsValidRect ) {
-            if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
-                hGeom = OGR_G_CreateGeometry( wkbPoint );
-                OGR_G_SetPoint_2D( hGeom, 0, rect.minx, rect.miny );
-            } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
-                hGeom = OGR_G_CreateGeometry( wkbLineString );
-                OGR_G_AddPoint_2D( hGeom, rect.minx, rect.miny );
-                OGR_G_AddPoint_2D( hGeom, rect.maxx, rect.maxy );
-            } else {
-                hGeom = OGR_G_CreateGeometry( wkbPolygon );
-                OGRGeometryH hRing = OGR_G_CreateGeometry( wkbLinearRing );
-
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddGeometryDirectly( hGeom, hRing );
-            }
-
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-                msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g %.15g %.15g\n",
-                        rect.minx, rect.miny, rect.maxx, rect.maxy );
-            }
-        }
-
-        psInfo->hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, select, hGeom, NULL );
-        psInfo->nLayerIndex = -1;
-        if( hGeom != NULL )
-            OGR_G_DestroyGeometry(hGeom);
-
-        if( psInfo->hLayer == NULL ) {
-            RELEASE_OGR_LOCK;
-            msSetError(MS_OGRERR, "ExecuteSQL() failed. Check logs.", "msOGRFileWhichShapes()");
-            msDebug("ExecuteSQL(%s) failed.\n%s\n", select, CPLGetLastErrorMsg());
-            msFree(select);
-            return MS_FAILURE;
-        }
-
-        // Update itemindexes / layer->iteminfo
-        msOGRLayerInitItemInfo(layer);
-    } 
-    else {
-
-        // case of 1) GetLayer + SetFilter
-
-        char *pszOGRFilter = NULL;
-        if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
-            pszOGRFilter = msStringConcatenate(pszOGRFilter, "(");
-            pszOGRFilter = msStringConcatenate(pszOGRFilter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
-            pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
-        }
-
-        if( psInfo->pszWHERE )
-        {
-            if( pszOGRFilter )
-            {
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, " AND (");
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
-            }
-            else
-            {
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
-            }
-        }
-
-        ACQUIRE_OGR_LOCK;
-
-        if( OGR_L_GetGeomType( psInfo->hLayer ) != wkbNone && bIsValidRect ) {
-            if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
-                OGRGeometryH hSpatialFilterPoint = OGR_G_CreateGeometry( wkbPoint );
-
-                OGR_G_SetPoint_2D( hSpatialFilterPoint, 0, rect.minx, rect.miny );    
-                OGR_L_SetSpatialFilter( psInfo->hLayer, hSpatialFilterPoint );
-                OGR_G_DestroyGeometry( hSpatialFilterPoint );
-            } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
-                OGRGeometryH hSpatialFilterLine = OGR_G_CreateGeometry( wkbLineString );
-
-                OGR_G_AddPoint_2D( hSpatialFilterLine, rect.minx, rect.miny );
-                OGR_G_AddPoint_2D( hSpatialFilterLine, rect.maxx, rect.maxy );
-                OGR_L_SetSpatialFilter( psInfo->hLayer, hSpatialFilterLine );
-                OGR_G_DestroyGeometry( hSpatialFilterLine );
-            } else {
-                OGRGeometryH hSpatialFilterPolygon = OGR_G_CreateGeometry( wkbPolygon );
-                OGRGeometryH hRing = OGR_G_CreateGeometry( wkbLinearRing );
-
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddGeometryDirectly( hSpatialFilterPolygon, hRing );
-                OGR_L_SetSpatialFilter( psInfo->hLayer, hSpatialFilterPolygon );
-                OGR_G_DestroyGeometry( hSpatialFilterPolygon );
-            }
-
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-                msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g %.15g %.15g\n", rect.minx, rect.miny, rect.maxx, rect.maxy );
-            }
-        }
-
-        psInfo->rect = rect;
-
-        /* ------------------------------------------------------------------
-         * Apply an attribute filter if we have one prefixed with a WHERE
-         * keyword in the filter string.  Otherwise, ensure the attribute
-         * filter is clear.
-         * ------------------------------------------------------------------ */
-        if( pszOGRFilter != NULL ) {
-
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-                msDebug("msOGRFileWhichShapes: Setting attribute filter to %s\n", pszOGRFilter );
-
-            CPLErrorReset();
-            if( OGR_L_SetAttributeFilter( psInfo->hLayer, pszOGRFilter ) != OGRERR_NONE ) {
-                msSetError(MS_OGRERR, "SetAttributeFilter() failed on layer %s. Check logs.", "msOGRFileWhichShapes()", layer->name?layer->name:"(null)");
-                msDebug("SetAttributeFilter(%s) failed on layer %s.\n%s\n", pszOGRFilter, layer->name?layer->name:"(null)", CPLGetLastErrorMsg() );
-                RELEASE_OGR_LOCK;
-                msFree(pszOGRFilter);
-                msFree(select);
-                return MS_FAILURE;
-            }
-            msFree(pszOGRFilter);
-        } else
-            OGR_L_SetAttributeFilter( psInfo->hLayer, NULL );
-        
-    }
-
-    msFree(select);
-
-    /* ------------------------------------------------------------------
-     * Reset current feature pointer
-     * ------------------------------------------------------------------ */
-    OGR_L_ResetReading( psInfo->hLayer );
-    psInfo->last_record_index_read = -1;
-    
-    RELEASE_OGR_LOCK;
-  
-    return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                     msOGRPassThroughFieldDefinitions()
- *
- * Pass the field definitions through to the layer metadata in the
- * "gml_[item]_{type,width,precision}" set of metadata items for
- * defining fields.
- **********************************************************************/
-
-static void
-msOGRPassThroughFieldDefinitions( layerObj *layer, msOGRFileInfo *psInfo )
-
-{
-  OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn( psInfo->hLayer );
-  int numitems, i;
-
-  numitems = OGR_FD_GetFieldCount( hDefn );
-
-  for(i=0; i<numitems; i++) {
-    OGRFieldDefnH hField = OGR_FD_GetFieldDefn( hDefn, i );
-    char gml_width[32], gml_precision[32];
-    const char *gml_type = NULL;
-    const char *item = OGR_Fld_GetNameRef( hField );
-
-    gml_width[0] = '\0';
-    gml_precision[0] = '\0';
-
-    switch( OGR_Fld_GetType( hField ) ) {
-      case OFTInteger:
-        gml_type = "Integer";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        break;
-
-#if GDAL_VERSION_MAJOR >= 2
-      case OFTInteger64:
-        gml_type = "Long";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        break;
-#endif
-
-      case OFTReal:
-        gml_type = "Real";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        if( OGR_Fld_GetPrecision( hField ) > 0 )
-          sprintf( gml_precision, "%d", OGR_Fld_GetPrecision( hField) );
-        break;
-
-      case OFTString:
-        gml_type = "Character";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        break;
-
-      case OFTDate:
-        gml_type = "Date";
-        break;
-      case OFTTime:
-        gml_type = "Time";
-        break;
-      case OFTDateTime:
-        gml_type = "DateTime";
-        break;
-
-      default:
-        gml_type = "Character";
-        break;
-    }
-
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
-  }
-
-  /* Should we try to address style items, or other special items? */
-}
-
-/**********************************************************************
- *                     msOGRFileGetItems()
- *
- * Returns a list of field names in a NULL terminated list of strings.
- **********************************************************************/
-static char **msOGRFileGetItems(layerObj *layer, msOGRFileInfo *psInfo )
-{
-  OGRFeatureDefnH hDefn;
-  int i, numitems,totalnumitems;
-  int numStyleItems = MSOGR_LABELNUMITEMS;
-  char **items;
-  const char *getShapeStyleItems, *value;
-
-  if((hDefn = OGR_L_GetLayerDefn( psInfo->hLayer )) == NULL) {
-    msSetError(MS_OGRERR,
-               "OGR Connection for layer `%s' contains no field definition.",
-               "msOGRFileGetItems()",
-               layer->name?layer->name:"(null)" );
-    return NULL;
-  }
-
-  totalnumitems = numitems = OGR_FD_GetFieldCount( hDefn );
-
-  getShapeStyleItems = msLayerGetProcessingKey( layer, "GETSHAPE_STYLE_ITEMS" );
-  if (getShapeStyleItems && EQUAL(getShapeStyleItems, "all"))
-    totalnumitems += numStyleItems;
-
-  if((items = (char**)malloc(sizeof(char *)*(totalnumitems+1))) == NULL) {
-    msSetError(MS_MEMERR, NULL, "msOGRFileGetItems()");
-    return NULL;
-  }
-
-  for(i=0; i<numitems; i++) {
-    OGRFieldDefnH hField = OGR_FD_GetFieldDefn( hDefn, i );
-    items[i] = msStrdup( OGR_Fld_GetNameRef( hField ));
-  }
-
-  if (getShapeStyleItems && EQUAL(getShapeStyleItems, "all")) {
-    assert(numStyleItems == 21);
-    items[i++] = msStrdup( MSOGR_LABELFONTNAMENAME );
-    items[i++] = msStrdup( MSOGR_LABELSIZENAME );
-    items[i++] = msStrdup( MSOGR_LABELTEXTNAME );
-    items[i++] = msStrdup( MSOGR_LABELANGLENAME );
-    items[i++] = msStrdup( MSOGR_LABELFCOLORNAME );
-    items[i++] = msStrdup( MSOGR_LABELBCOLORNAME );
-    items[i++] = msStrdup( MSOGR_LABELPLACEMENTNAME );
-    items[i++] = msStrdup( MSOGR_LABELANCHORNAME );
-    items[i++] = msStrdup( MSOGR_LABELDXNAME );
-    items[i++] = msStrdup( MSOGR_LABELDYNAME );
-    items[i++] = msStrdup( MSOGR_LABELPERPNAME );
-    items[i++] = msStrdup( MSOGR_LABELBOLDNAME );
-    items[i++] = msStrdup( MSOGR_LABELITALICNAME );
-    items[i++] = msStrdup( MSOGR_LABELUNDERLINENAME );
-    items[i++] = msStrdup( MSOGR_LABELPRIORITYNAME );
-    items[i++] = msStrdup( MSOGR_LABELSTRIKEOUTNAME );
-    items[i++] = msStrdup( MSOGR_LABELSTRETCHNAME );
-    items[i++] = msStrdup( MSOGR_LABELADJHORNAME );
-    items[i++] = msStrdup( MSOGR_LABELADJVERTNAME );
-    items[i++] = msStrdup( MSOGR_LABELHCOLORNAME );
-    items[i++] = msStrdup( MSOGR_LABELOCOLORNAME );
-  }
-  items[i++] = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      consider populating the field definitions in metadata.          */
-  /* -------------------------------------------------------------------- */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    msOGRPassThroughFieldDefinitions( layer, psInfo );
-
-  return items;
-}
-
-/**********************************************************************
- *                     msOGRFileNextShape()
- *
- * Returns shape sequentially from OGR data source.
- * msOGRLayerWhichShape() must have been called first.
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-static int
-msOGRFileNextShape(layerObj *layer, shapeObj *shape,
-                   msOGRFileInfo *psInfo )
-{
-  OGRFeatureH hFeature = NULL;
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRFileNextShape()");
-    return(MS_FAILURE);
-  }
-
-  /* ------------------------------------------------------------------
-   * Read until we find a feature that matches attribute filter and
-   * whose geometry is compatible with current layer type.
-   * ------------------------------------------------------------------ */
-  msFreeShape(shape);
-  shape->type = MS_SHAPE_NULL;
-
-  ACQUIRE_OGR_LOCK;
-  while (shape->type == MS_SHAPE_NULL) {
-    if( hFeature )
-      OGR_F_Destroy( hFeature );
-
-    if( (hFeature = OGR_L_GetNextFeature( psInfo->hLayer )) == NULL ) {
-      psInfo->last_record_index_read = -1;
-      if( CPLGetLastErrorType() == CE_Failure ) {
-        msSetError(MS_OGRERR, "OGR GetNextFeature() error'd. Check logs.",
-                   "msOGRFileNextShape()");
-        msDebug("msOGRFileNextShape(): %s\n",
-                CPLGetLastErrorMsg() );
-        RELEASE_OGR_LOCK;
-        return MS_FAILURE;
-      } else {
-        RELEASE_OGR_LOCK;
-        if (layer->debug >= MS_DEBUGLEVEL_VV)
-          msDebug("msOGRFileNextShape: Returning MS_DONE (no more shapes)\n" );
-        return MS_DONE;  // No more features to read
-      }
-    }
-
-    psInfo->last_record_index_read++;
-
-    if(layer->numitems > 0) {
-      if (shape->values) msFreeCharArray(shape->values, shape->numvalues);
-      shape->values = msOGRGetValues(layer, hFeature);
-      shape->numvalues = layer->numitems;
-      if(!shape->values) {
-        OGR_F_Destroy( hFeature );
-        RELEASE_OGR_LOCK;
-        return(MS_FAILURE);
-      }
-    }
-
-    // Feature matched filter expression... process geometry
-    // shape->type will be set if geom is compatible with layer type
-    if (ogrConvertGeometry(ogrGetLinearGeometry( hFeature ), shape,
-                           layer->type) == MS_SUCCESS) {
-      if (shape->type != MS_SHAPE_NULL)
-        break; // Shape is ready to be returned!
-
-      if (layer->debug >= MS_DEBUGLEVEL_VVV)
-        msDebug("msOGRFileNextShape: Rejecting feature (shapeid = " CPL_FRMT_GIB ", tileid=%d) of incompatible type for this layer (feature wkbType %d, layer type %d)\n",
-                (GIntBig)OGR_F_GetFID( hFeature ), psInfo->nTileId,
-                OGR_F_GetGeometryRef( hFeature )==NULL ? wkbFlatten(wkbUnknown):wkbFlatten( OGR_G_GetGeometryType( OGR_F_GetGeometryRef( hFeature ) ) ),
-                layer->type);
-
-    } else {
-      msFreeShape(shape);
-      OGR_F_Destroy( hFeature );
-      RELEASE_OGR_LOCK;
-      return MS_FAILURE; // Error message already produced.
-    }
-
-    // Feature rejected... free shape to clear attributes values.
-    msFreeShape(shape);
-    shape->type = MS_SHAPE_NULL;
-  }
-
-  shape->index =  (int)OGR_F_GetFID( hFeature ); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
-  shape->resultindex = psInfo->last_record_index_read;
-  shape->tileindex = psInfo->nTileId;
-
-  if (layer->debug >= MS_DEBUGLEVEL_VVV)
-    msDebug("msOGRFileNextShape: Returning shape=%ld, tile=%d\n",
-            shape->index, shape->tileindex );
-
-  // Keep ref. to last feature read in case we need style info.
-  if (psInfo->hLastFeature)
-    OGR_F_Destroy( psInfo->hLastFeature );
-  psInfo->hLastFeature = hFeature;
-
-  RELEASE_OGR_LOCK;
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                     msOGRFileGetShape()
- *
- * Returns shape from OGR data source by id.
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-static int
-msOGRFileGetShape(layerObj *layer, shapeObj *shape, long record,
-                  msOGRFileInfo *psInfo, int record_is_fid )
-{
-  OGRFeatureH hFeature;
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRFileNextShape()");
-    return(MS_FAILURE);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Clear previously loaded shape.                                  */
-  /* -------------------------------------------------------------------- */
-  msFreeShape(shape);
-  shape->type = MS_SHAPE_NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Support reading feature by fid.                                 */
-  /* -------------------------------------------------------------------- */
-  if( record_is_fid ) {
-    ACQUIRE_OGR_LOCK;
-    if( (hFeature = OGR_L_GetFeature( psInfo->hLayer, record )) == NULL ) {
-      RELEASE_OGR_LOCK;
-      return MS_FAILURE;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Support reading shape by offset within the current              */
-  /*      resultset.                                                      */
-  /* -------------------------------------------------------------------- */
-  else {
-    ACQUIRE_OGR_LOCK;
-    if( record <= psInfo->last_record_index_read
-        || psInfo->last_record_index_read == -1 ) {
-      OGR_L_ResetReading( psInfo->hLayer );
-      psInfo->last_record_index_read = -1;
-    }
-
-    hFeature = NULL;
-    while( psInfo->last_record_index_read < record ) {
-      if( hFeature != NULL ) {
-        OGR_F_Destroy( hFeature );
-        hFeature = NULL;
-      }
-      if( (hFeature = OGR_L_GetNextFeature( psInfo->hLayer )) == NULL ) {
-        RELEASE_OGR_LOCK;
-        return MS_FAILURE;
-      }
-      psInfo->last_record_index_read++;
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * Handle shape geometry...
-   * ------------------------------------------------------------------ */
-  // shape->type will be set if geom is compatible with layer type
-  if (ogrConvertGeometry(ogrGetLinearGeometry( hFeature ), shape,
-                         layer->type) != MS_SUCCESS) {
-    RELEASE_OGR_LOCK;
-    return MS_FAILURE; // Error message already produced.
-  }
-
-  if (shape->type == MS_SHAPE_NULL) {
-    msSetError(MS_OGRERR,
-               "Requested feature is incompatible with layer type",
-               "msOGRLayerGetShape()");
-    RELEASE_OGR_LOCK;
-    return MS_FAILURE;
-  }
-
-  /* ------------------------------------------------------------------
-   * Process shape attributes
-   * ------------------------------------------------------------------ */
-  if(layer->numitems > 0) {
-    shape->values = msOGRGetValues(layer, hFeature);
-    shape->numvalues = layer->numitems;
-    if(!shape->values) {
-      RELEASE_OGR_LOCK;
-      return(MS_FAILURE);
-    }
-
-  }
-
-  if (record_is_fid) {
-    shape->index = record;
-    shape->resultindex = -1;
-  } else {
-    shape->index = (int)OGR_F_GetFID( hFeature ); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
-    shape->resultindex = record;
-  }
-
-  shape->tileindex = psInfo->nTileId;
-
-  // Keep ref. to last feature read in case we need style info.
-  if (psInfo->hLastFeature)
-    OGR_F_Destroy( psInfo->hLastFeature );
-  psInfo->hLastFeature = hFeature;
-
-  RELEASE_OGR_LOCK;
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                         msOGRFileReadTile()                          */
-/*                                                                      */
-/*      Advance to the next tile (or if targetTile is not -1 advance    */
-/*      to that tile), causing the tile to become the poCurTile in      */
-/*      the tileindexes psInfo structure.  Returns MS_DONE if there     */
-/*      are no more available tiles.                                    */
-/*                                                                      */
-/*      Newly loaded tiles are automatically "WhichShaped" based on     */
-/*      the current rectangle.                                          */
-/************************************************************************/
-
-int msOGRFileReadTile( layerObj *layer, msOGRFileInfo *psInfo,
-                       int targetTile = -1 )
-
-{
-  int nFeatureId;
-
-  /* -------------------------------------------------------------------- */
-  /*      Close old tile if one is open.                                  */
-  /* -------------------------------------------------------------------- */
-  if( psInfo->poCurTile != NULL ) {
-    msOGRFileClose( layer, psInfo->poCurTile );
-    psInfo->poCurTile = NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If -2 is passed, then seek reset reading of the tileindex.      */
-  /*      We want to start from the beginning even if this file is        */
-  /*      shared between layers or renders.                               */
-  /* -------------------------------------------------------------------- */
-  ACQUIRE_OGR_LOCK;
-  if( targetTile == -2 ) {
-    OGR_L_ResetReading( psInfo->hLayer );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Get the name (connection string really) of the next tile.       */
-  /* -------------------------------------------------------------------- */
-  OGRFeatureH hFeature;
-  char       *connection = NULL;
-  msOGRFileInfo *psTileInfo = NULL;
-  int status;
-
-#ifndef IGNORE_MISSING_DATA
-NextFile:
-#endif
-
-  if( targetTile < 0 )
-    hFeature = OGR_L_GetNextFeature( psInfo->hLayer );
-
-  else
-    hFeature = OGR_L_GetFeature( psInfo->hLayer, targetTile );
-
-  if( hFeature == NULL ) {
-    RELEASE_OGR_LOCK;
-    if( targetTile == -1 )
-      return MS_DONE;
-    else
-      return MS_FAILURE;
-
-  }
-
-  connection = msStrdup( OGR_F_GetFieldAsString( hFeature,
-                         layer->tileitemindex ));
-
-  char* pszSRS = NULL;
-  if( layer->tilesrs != NULL )
-  {
-      int idx = OGR_F_GetFieldIndex( hFeature, layer->tilesrs);
-      if( idx >= 0 )
-      {
-          pszSRS = msStrdup( OGR_F_GetFieldAsString( hFeature, idx ));
-      }
-  }
-
-  nFeatureId = (int)OGR_F_GetFID( hFeature ); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
-
-  OGR_F_Destroy( hFeature );
-
-  RELEASE_OGR_LOCK;
-
-  /* -------------------------------------------------------------------- */
-  /*      Open the new tile file.                                         */
-  /* -------------------------------------------------------------------- */
-  psTileInfo = msOGRFileOpen( layer, connection );
-
-  free( connection );
-
-#ifndef IGNORE_MISSING_DATA
-  if( psTileInfo == NULL && targetTile == -1 )
-  {
-    msFree(pszSRS);
-    goto NextFile;
-  }
-#endif
-
-  if( psTileInfo == NULL )
-  {
-    msFree(pszSRS);
-    return MS_FAILURE;
-  }
-  
-  if( pszSRS != NULL )
-  {
-    if( msOGCWKT2ProjectionObj( pszSRS, &(psInfo->sTileProj),
-                                layer->debug ) != MS_SUCCESS )
-    {
-        msFree(pszSRS);
-        return MS_FAILURE;
-    }
-    msFree(pszSRS);
-  }
-
-  psTileInfo->nTileId = nFeatureId;
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize the spatial query on this file.                      */
-  /* -------------------------------------------------------------------- */
-  if( psInfo->rect.minx != 0 || psInfo->rect.maxx != 0 ) {
-    rectObj rect = psInfo->rect;
-
-    if( layer->tileindex != NULL && psInfo->sTileProj.numargs > 0 )
-    {
-      msProjectRect(&(layer->projection), &(psInfo->sTileProj), &rect);
-    }
-
-    status = msOGRFileWhichShapes( layer, rect, psTileInfo );
-    if( status != MS_SUCCESS )
-      return status;
-  }
-
-  psInfo->poCurTile = psTileInfo;
-
-  /* -------------------------------------------------------------------- */
-  /*      Update the iteminfo in case this layer has a different field    */
-  /*      list.                                                           */
-  /* -------------------------------------------------------------------- */
-  msOGRLayerInitItemInfo( layer );
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                               msExprNode                             */
-/************************************************************************/
-
-class msExprNode
-{
-    public:
-        std::vector<std::unique_ptr<msExprNode>> m_aoChildren{};
-        int         m_nToken = 0;
-        std::string m_osVal{};
-        double      m_dfVal = 0;
-        struct tm   m_tmVal{};
-};
-
-
-/************************************************************************/
-/*                        exprGetPriority()                             */
-/************************************************************************/
-
-static int exprGetPriority(int token)
-{
-    if (token == MS_TOKEN_LOGICAL_NOT)
-        return 9;
-    else if (token == '*' || token == '/' || token == '%' )
-        return 8;
-    else if (token == '+' || token == '-' )
-        return 7;
-    else if (token == MS_TOKEN_COMPARISON_GE ||
-             token == MS_TOKEN_COMPARISON_GT ||
-             token == MS_TOKEN_COMPARISON_LE ||
-             token == MS_TOKEN_COMPARISON_LT ||
-             token == MS_TOKEN_COMPARISON_IN)
-        return 6;
-    else if (token == MS_TOKEN_COMPARISON_EQ ||
-             token == MS_TOKEN_COMPARISON_IEQ ||
-             token == MS_TOKEN_COMPARISON_LIKE ||
-             token == MS_TOKEN_COMPARISON_RE ||
-             token == MS_TOKEN_COMPARISON_IRE ||
-             token == MS_TOKEN_COMPARISON_NE)
-        return 5;
-    else if (token == MS_TOKEN_LOGICAL_AND)
-        return 4;
-    else if (token == MS_TOKEN_LOGICAL_OR)
-        return 3;
-    else
-        return 0;
-}
-
-/************************************************************************/
-/*                           BuildExprTree()                            */
-/************************************************************************/
-
-static std::unique_ptr<msExprNode> BuildExprTree(tokenListNodeObjPtr node,
-                                 tokenListNodeObjPtr* pNodeNext,
-                                 int nParenthesisLevel)
-{
-    std::vector<std::unique_ptr<msExprNode>> aoStackOp, aoStackVal;
-    while( node != NULL )
-    {
-        if( node->token == '(' )
-        {
-            auto subExpr = BuildExprTree(node->next, &node,
-                                                nParenthesisLevel + 1);
-            if( subExpr == NULL )
-            {
-                return nullptr;
-            }
-            aoStackVal.emplace_back(std::move(subExpr));
-            continue;
-        }
-        else if( node->token == ')' )
-        {
-            if( nParenthesisLevel > 0 )
-            {
-                break;
-            }
-            return nullptr;
-        }
-        else if( node->token == '+' ||
-                 node->token == '-' ||
-                 node->token == '*' ||
-                 node->token == '/' ||
-                 node->token == '%' ||
-                 node->token == MS_TOKEN_LOGICAL_NOT ||
-                 node->token == MS_TOKEN_LOGICAL_AND ||
-                 node->token == MS_TOKEN_LOGICAL_OR  ||
-                 node->token == MS_TOKEN_COMPARISON_GE ||
-                 node->token == MS_TOKEN_COMPARISON_GT ||
-                 node->token == MS_TOKEN_COMPARISON_LE ||
-                 node->token == MS_TOKEN_COMPARISON_LT ||
-                 node->token == MS_TOKEN_COMPARISON_EQ ||
-                 node->token == MS_TOKEN_COMPARISON_IEQ ||
-                 node->token == MS_TOKEN_COMPARISON_LIKE ||
-                 node->token == MS_TOKEN_COMPARISON_NE ||
-                 node->token == MS_TOKEN_COMPARISON_RE ||
-                 node->token == MS_TOKEN_COMPARISON_IRE ||
-                 node->token == MS_TOKEN_COMPARISON_IN )
-        {
-            while( !aoStackOp.empty() &&
-                   exprGetPriority(node->token) <=
-                        exprGetPriority(aoStackOp.back()->m_nToken))
-            {
-                std::unique_ptr<msExprNode> val1;
-                std::unique_ptr<msExprNode> val2;
-                if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT)
-                {
-                    if( aoStackVal.empty() )
-                        return nullptr;
-                    val2.reset(aoStackVal.back().release());
-                    aoStackVal.pop_back();
-                }
-                if( aoStackVal.empty() )
-                    return nullptr;
-                val1.reset(aoStackVal.back().release());
-                aoStackVal.pop_back();
-
-                std::unique_ptr<msExprNode> newNode(new msExprNode);
-                newNode->m_nToken = aoStackOp.back()->m_nToken;
-                newNode->m_aoChildren.emplace_back(std::move(val1));
-                if( val2 )
-                    newNode->m_aoChildren.emplace_back(std::move(val2));
-                aoStackVal.emplace_back(std::move(newNode));
-                aoStackOp.pop_back();
-            }
-
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            aoStackOp.emplace_back(std::move(newNode));
-        }
-        else if( node->token == ',' )
-        {
-        }
-        else if( node->token == MS_TOKEN_COMPARISON_INTERSECTS ||
-                 node->token == MS_TOKEN_COMPARISON_DISJOINT ||
-                 node->token == MS_TOKEN_COMPARISON_TOUCHES ||
-                 node->token == MS_TOKEN_COMPARISON_OVERLAPS ||
-                 node->token == MS_TOKEN_COMPARISON_CROSSES ||
-                 node->token == MS_TOKEN_COMPARISON_DWITHIN ||
-                 node->token == MS_TOKEN_COMPARISON_BEYOND ||
-                 node->token == MS_TOKEN_COMPARISON_WITHIN ||
-                 node->token == MS_TOKEN_COMPARISON_CONTAINS ||
-                 node->token == MS_TOKEN_COMPARISON_EQUALS ||
-                 node->token == MS_TOKEN_FUNCTION_LENGTH ||
-                 node->token == MS_TOKEN_FUNCTION_TOSTRING ||
-                 node->token == MS_TOKEN_FUNCTION_COMMIFY ||
-                 node->token == MS_TOKEN_FUNCTION_AREA ||
-                 node->token == MS_TOKEN_FUNCTION_ROUND ||
-                 node->token == MS_TOKEN_FUNCTION_FROMTEXT ||
-                 node->token == MS_TOKEN_FUNCTION_BUFFER ||
-                 node->token == MS_TOKEN_FUNCTION_DIFFERENCE ||
-                 node->token == MS_TOKEN_FUNCTION_SIMPLIFY ||
-                 node->token == MS_TOKEN_FUNCTION_SIMPLIFYPT ||
-                 node->token == MS_TOKEN_FUNCTION_GENERALIZE ||
-                 node->token == MS_TOKEN_FUNCTION_SMOOTHSIA ||
-                 node->token == MS_TOKEN_FUNCTION_JAVASCRIPT ||
-                 node->token == MS_TOKEN_FUNCTION_UPPER ||
-                 node->token == MS_TOKEN_FUNCTION_LOWER ||
-                 node->token == MS_TOKEN_FUNCTION_INITCAP ||
-                 node->token == MS_TOKEN_FUNCTION_FIRSTCAP )
-        {
-            if( node->next && node->next->token == '(' )
-            {
-                int node_token = node->token;
-                auto subExpr = BuildExprTree(node->next->next, &node,
-                                                    nParenthesisLevel + 1);
-                if( subExpr == NULL )
-                {
-                    return nullptr;
-                }
-                std::unique_ptr<msExprNode> newNode(new msExprNode);
-                newNode->m_nToken = node_token;
-                if( subExpr->m_nToken == 0 )
-                {
-                    newNode->m_aoChildren = std::move(subExpr->m_aoChildren);
-                }
-                else
-                {
-                    newNode->m_aoChildren.emplace_back(std::move(subExpr));
-                }
-                aoStackVal.emplace_back(std::move(newNode));
-                continue;
-            }
-            else
-                return nullptr;
-        }
-        else if( node->token == MS_TOKEN_LITERAL_NUMBER ||
-                 node->token == MS_TOKEN_LITERAL_BOOLEAN )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_dfVal = node->tokenval.dblval;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_LITERAL_STRING )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_osVal = node->tokenval.strval;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_LITERAL_TIME )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_tmVal = node->tokenval.tmval;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_LITERAL_SHAPE )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            char *wkt = msShapeToWKT(node->tokenval.shpval);
-            newNode->m_osVal = wkt;
-            msFree(wkt);
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_BINDING_DOUBLE ||
-                 node->token == MS_TOKEN_BINDING_INTEGER ||
-                 node->token == MS_TOKEN_BINDING_STRING ||
-                 node->token == MS_TOKEN_BINDING_TIME )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_osVal = node->tokenval.bindval.item;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-
-        node = node->next;
-    }
-
-    while( !aoStackOp.empty() )
-    {
-        std::unique_ptr<msExprNode> val1 = NULL;
-        std::unique_ptr<msExprNode> val2 = NULL;
-        if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT)
-        {
-            if( aoStackVal.empty() )
-                return nullptr;
-            val2.reset(aoStackVal.back().release());
-            aoStackVal.pop_back();
-        }
-        if( aoStackVal.empty() )
-            return nullptr;
-        val1.reset(aoStackVal.back().release());
-        aoStackVal.pop_back();
-
-        std::unique_ptr<msExprNode> newNode(new msExprNode);
-        newNode->m_nToken = aoStackOp.back()->m_nToken;
-        newNode->m_aoChildren.emplace_back(std::move(val1));
-        if( val2 )
-            newNode->m_aoChildren.emplace_back(std::move(val2));
-        aoStackVal.emplace_back(std::move(newNode));
-        aoStackOp.pop_back();
-    }
-
-    std::unique_ptr<msExprNode> poRet;
-    if( aoStackVal.size() == 1 )
-        poRet.reset(aoStackVal.back().release());
-    else if( aoStackVal.size() > 1 )
-    {
-        poRet.reset(new msExprNode);
-        poRet->m_aoChildren = std::move(aoStackVal);
-    }
-
-    if( pNodeNext )
-        *pNodeNext = node ? node->next : NULL;
-
-    return poRet;
-}
-
-/**********************************************************************
- *                 msOGRExtractTopSpatialFilter()
- * 
- * Recognize expressions like "Intersects([shape], wkt) == TRUE [AND ....]"
- **********************************************************************/
-static int  msOGRExtractTopSpatialFilter( msOGRFileInfo *info,
-                                          const msExprNode* expr,
-                                          const msExprNode** pSpatialFilterNode )
-{
-  if( expr == NULL )
-      return MS_FALSE;
-
-  if( expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
-      expr->m_aoChildren.size() == 2 &&
-      expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_BOOLEAN &&
-      expr->m_aoChildren[1]->m_dfVal == 1.0 )
-  {
-      return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
-                                          pSpatialFilterNode);
-  }
-
-  if( (((expr->m_nToken == MS_TOKEN_COMPARISON_INTERSECTS ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_OVERLAPS ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_CROSSES ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_WITHIN ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_CONTAINS) &&
-      expr->m_aoChildren.size() == 2) ||
-      (expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN && expr->m_aoChildren.size() == 3)) &&
-      expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_SHAPE )
-  {
-        if( info->rect_is_defined )
-        {
-            // Several intersects...
-            *pSpatialFilterNode = NULL;
-            info->rect_is_defined = MS_FALSE;
-            return MS_FALSE;
-        }
-        OGRGeometryH hSpatialFilter = NULL;
-        char* wkt = const_cast<char*>(expr->m_aoChildren[1]->m_osVal.c_str());
-        OGRErr e = OGR_G_CreateFromWkt(&wkt, NULL, &hSpatialFilter);
-        if (e == OGRERR_NONE) {
-            OGREnvelope env;
-            if( expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN ) {
-                OGRGeometryH hBuffer = OGR_G_Buffer(hSpatialFilter, expr->m_aoChildren[2]->m_dfVal, 30);
-                OGR_G_GetEnvelope(hBuffer ? hBuffer : hSpatialFilter, &env);
-                OGR_G_DestroyGeometry(hBuffer);
-            } else {
-                OGR_G_GetEnvelope(hSpatialFilter, &env);
-            }
-            info->rect.minx = env.MinX;
-            info->rect.miny = env.MinY;
-            info->rect.maxx = env.MaxX;
-            info->rect.maxy = env.MaxY;
-            info->rect_is_defined = true;
-            *pSpatialFilterNode = expr;
-            OGR_G_DestroyGeometry(hSpatialFilter);
-            return MS_TRUE;
-        }
-        return MS_FALSE;
-  }
-
-  if( expr->m_nToken == MS_TOKEN_LOGICAL_AND &&
-      expr->m_aoChildren.size() == 2 )
-  {
-      return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
-                                          pSpatialFilterNode) &&
-             msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[1].get(),
-                                          pSpatialFilterNode);
-  }
-
-  return MS_TRUE;
-}
-
-/**********************************************************************
- *                 msOGRTranslatePartialMSExpressionToOGRSQL()
- *
- * Tries to partially translate a mapserver expression to SQL
- **********************************************************************/
-
-static std::string msOGRGetTokenText(int nToken)
-{
-    switch( nToken )
-    {
-        case '*':
-        case '+':
-        case '-':
-        case '/':
-        case '%':
-            return std::string(1, static_cast<char>(nToken));
-
-        case MS_TOKEN_COMPARISON_GE: return ">=";
-        case MS_TOKEN_COMPARISON_GT: return ">";
-        case MS_TOKEN_COMPARISON_LE: return "<=";
-        case MS_TOKEN_COMPARISON_LT: return "<";
-        case MS_TOKEN_COMPARISON_EQ: return "=";
-        case MS_TOKEN_COMPARISON_NE: return "!=";
-        case MS_TOKEN_COMPARISON_LIKE: return "LIKE";
-
-        default:
-            return std::string();
-    }
-}
-
-static std::string msOGRTranslatePartialInternal(layerObj* layer,
-                                                 const msExprNode* expr,
-                                                 const msExprNode* spatialFilterNode,
-                                                 bool& bPartialFilter)
-{
-    switch( expr->m_nToken )
-    {
-        case MS_TOKEN_LOGICAL_NOT:
-        {
-            std::string osTmp(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            if( osTmp.empty() )
-                return std::string();
-            return "(NOT " + osTmp + ")";
-        }
-
-        case MS_TOKEN_LOGICAL_AND:
-        {
-            // We can deal with partially translated children
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osTmp2(msOGRTranslatePartialInternal( 
-                layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter ));
-            if( !osTmp1.empty() && !osTmp2.empty() )
-            {
-                return "(" + osTmp1 + " AND " + osTmp2 + ")";
-            }
-            else if( !osTmp1.empty() )
-                return osTmp1;
-            else
-                return osTmp2;
-        }
-
-        case MS_TOKEN_LOGICAL_OR:
-        {
-            // We can NOT deal with partially translated children
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osTmp2(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter ));
-            if( !osTmp1.empty() && !osTmp2.empty() )
-            {
-                return "(" + osTmp1 + " OR " + osTmp2 + ")";
-            }
-            else
-                return std::string();
-        }
-
-        case '*':
-        case '+':
-        case '-':
-        case '/':
-        case '%':
-        case MS_TOKEN_COMPARISON_GE:
-        case MS_TOKEN_COMPARISON_GT:
-        case MS_TOKEN_COMPARISON_LE:
-        case MS_TOKEN_COMPARISON_LT:
-        case MS_TOKEN_COMPARISON_EQ:
-        case MS_TOKEN_COMPARISON_NE:
-        {
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osTmp2(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter ));
-            if( !osTmp1.empty() && !osTmp2.empty() )
-            {
-                if( expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
-                    osTmp2 == "'_MAPSERVER_NULL_'" )
-                {
-                    return "(" + osTmp1 + " IS NULL )";
-                }
-                if( expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_STRING )
-                {
-                    char md_item_name[256];
-                    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                              expr->m_aoChildren[0]->m_osVal.c_str() );
-                    const char* type =
-                        msLookupHashTable(&(layer->metadata), md_item_name);
-                    // Cast if needed (or unsure)
-                    if( type == NULL || !EQUAL(type, "Character") )
-                    {
-                        osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
-                    }
-                }
-                return "(" + osTmp1 + " " + msOGRGetTokenText(expr->m_nToken) +
-                       " " + osTmp2 + ")";
-            }
-            else
-                return std::string();
-        }
-
-        case MS_TOKEN_COMPARISON_RE:
-        {
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            if( expr->m_aoChildren[1]->m_nToken != MS_TOKEN_LITERAL_STRING )
-            {
-                return std::string();
-            }
-            std::string osRE("'");
-            const size_t nSize = expr->m_aoChildren[1]->m_osVal.size();
-            bool bHasUsedEscape = false;
-            for( size_t i=0; i<nSize;i++ )
-            {
-                if( i == 0 && expr->m_aoChildren[1]->m_osVal[i] == '^' )
-                    continue;
-                if( i == nSize-1 && expr->m_aoChildren[1]->m_osVal[i] == '$' )
-                    break;
-                if( expr->m_aoChildren[1]->m_osVal[i] == '.' )
-                {
-                    if( i+1<nSize &&
-                        expr->m_aoChildren[1]->m_osVal[i+1] == '*' )
-                    {
-                        osRE += "%";
-                        i++;
-                    }
-                    else
-                    {
-                        osRE += "_";
-                    }
-                }
-                else if( expr->m_aoChildren[1]->m_osVal[i] == '\\' &&
-                         i+1<nSize )
-                {
-                    bHasUsedEscape = true;
-                    osRE += 'X';
-                    osRE += expr->m_aoChildren[1]->m_osVal[i+1];
-                    i++;
-                }
-                else if( expr->m_aoChildren[1]->m_osVal[i] == 'X' ||
-                         expr->m_aoChildren[1]->m_osVal[i] == '%' ||
-                         expr->m_aoChildren[1]->m_osVal[i] == '_' )
-                {
-                    bHasUsedEscape = true;
-                    osRE += 'X';
-                    osRE += expr->m_aoChildren[1]->m_osVal[i];
-                }
-                else
-                {
-                    osRE += expr->m_aoChildren[1]->m_osVal[i];
-                }
-            }
-            osRE += "'";
-            char md_item_name[256];
-            snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                        expr->m_aoChildren[0]->m_osVal.c_str() );
-            const char* type =
-                        msLookupHashTable(&(layer->metadata), md_item_name);
-            // Cast if needed (or unsure)
-            if( type == NULL || !EQUAL(type, "Character") )
-            {
-                osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
-            }
-            std::string osRet( "(" + osTmp1 + " LIKE " + osRE );
-            if( bHasUsedEscape )
-                osRet += " ESCAPE 'X'";
-            osRet += ")";
-            return osRet;
-        }
-
-        case MS_TOKEN_COMPARISON_IN:
-        {
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osRet = "(" + osTmp1 + " IN (";
-            for( size_t i=0; i< expr->m_aoChildren[1]->m_aoChildren.size(); ++i )
-            {
-                if( i > 0 )
-                    osRet += ", ";
-                osRet += msOGRTranslatePartialInternal(
-                            layer, expr->m_aoChildren[1]->m_aoChildren[i].get(),
-                            spatialFilterNode, bPartialFilter );
-            }
-            osRet += ")";
-            return osRet;
-        }
-
-        case MS_TOKEN_LITERAL_NUMBER:
-        case MS_TOKEN_LITERAL_BOOLEAN:
-        {
-            return std::string(CPLSPrintf("%.18g", expr->m_dfVal));
-        }
-
-        case MS_TOKEN_LITERAL_STRING:
-        {
-            char *stresc = msOGREscapeSQLParam(layer, expr->m_osVal.c_str());
-            std::string osRet("'" + std::string(stresc) + "'");
-            msFree(stresc);
-            return osRet;
-        }
-
-        case MS_TOKEN_LITERAL_TIME:
-        {
-#ifdef notdef
-            // Breaks tests in msautotest/wxs/wfs_time_ogr.map
-            return std::string(CPLSPrintf("'%04d/%02d/%02d %02d:%02d:%02d'",
-                     expr->m_tmVal.tm_year+1900,
-                     expr->m_tmVal.tm_mon+1,
-                     expr->m_tmVal.tm_mday,
-                     expr->m_tmVal.tm_hour,
-                     expr->m_tmVal.tm_min,
-                     expr->m_tmVal.tm_sec));
-#endif
-            return std::string();
-        }
-
-        case MS_TOKEN_BINDING_DOUBLE:
-        case MS_TOKEN_BINDING_INTEGER:
-        case MS_TOKEN_BINDING_STRING:
-        case MS_TOKEN_BINDING_TIME:
-        {
-            char* pszTmp = msOGRGetQuotedItem(layer, expr->m_osVal.c_str());
-            std::string osRet(pszTmp);
-            msFree(pszTmp);
-            return osRet;
-        }
-
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-        {
-            if( expr != spatialFilterNode )
-                bPartialFilter = true;
-            return std::string();
-        }
-
-        default:
-        {
-            bPartialFilter = true;
-            return std::string();
-        }
-    }
-}
-
-/* ==================================================================
- * Here comes the REAL stuff... the functions below are called by maplayer.c
- * ================================================================== */
-
-/**********************************************************************
- *                     msOGRTranslateMsExpressionToOGRSQL()
- *
- * Tries to translate a mapserver expression to OGR or driver native SQL
- **********************************************************************/
-static int msOGRTranslateMsExpressionToOGRSQL(layerObj* layer,
-                                              expressionObj* psFilter,
-                                              char *filteritem)
-{
-    msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
-
-    msFree(layer->filter.native_string);
-    layer->filter.native_string = NULL;
-
-    msFree(info->pszWHERE);
-    info->pszWHERE = NULL;
-
-    // reasons to not produce native string: not simple layer, or an explicit deny
-    const char *do_this = msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
-    if (do_this && strcmp(do_this, "NO") == 0) {
-        return MS_SUCCESS;
-    }
-
-    tokenListNodeObjPtr node = psFilter->tokens;
-    auto expr = BuildExprTree(node, NULL, 0);
-    info->rect_is_defined = MS_FALSE;
-    const msExprNode* spatialFilterNode = NULL;
-    if( expr )
-        msOGRExtractTopSpatialFilter( info, expr.get(), &spatialFilterNode );
-
-    // more reasons to not produce native string: not a recognized driver
-    if (!info->dialect)
-    {
-        // in which case we might still want to try to get a partial WHERE clause
-        if( filteritem == NULL && expr )
-        {
-            bool bPartialFilter = false;
-            std::string osSQL( msOGRTranslatePartialInternal(layer, expr.get(),
-                                                             spatialFilterNode,
-                                                             bPartialFilter) );
-            if( !osSQL.empty() )
-            {
-                info->pszWHERE = msStrdup(osSQL.c_str());
-                if( bPartialFilter )
-                {
-                    msDebug("Full filter has only been partially "
-                            "translated to OGR filter %s\n",
-                            info->pszWHERE);
-                }
-            }
-            else if( bPartialFilter )
-            {
-                msDebug("Filter could not be translated to OGR filter\n");
-            }
-        }
-        return MS_SUCCESS;
-    }
-
-    char *sql = NULL;
-
-    // node may be NULL if layer->filter.string != NULL and filteritem != NULL
-    // this is simple filter but string is regex
-    if (node == NULL && filteritem != NULL && layer->filter.string != NULL) {
-        sql = msStringConcatenate(sql, "\"");
-        sql = msStringConcatenate(sql, filteritem);
-        sql = msStringConcatenate(sql, "\"");
-        if (EQUAL(info->dialect, "PostgreSQL") ) {
-            sql = msStringConcatenate(sql, " ~ ");
-        } else {
-            sql = msStringConcatenate(sql, " LIKE ");
-        }
-        sql = msStringConcatenate(sql, "'");
-        sql = msStringConcatenate(sql, layer->filter.string);
-        sql = msStringConcatenate(sql, "'");
-    }
-
-    while (node != NULL) {
-
-        if (node->next && node->next->token == MS_TOKEN_COMPARISON_IEQ) {
-            char *left = msOGRGetToken(layer, &node);
-            node = node->next; // skip =
-            char *right = msOGRGetToken(layer, &node);
-            sql = msStringConcatenate(sql, "upper(");
-            sql = msStringConcatenate(sql, left);
-            sql = msStringConcatenate(sql, ")");
-            sql = msStringConcatenate(sql, "=");
-            sql = msStringConcatenate(sql, "upper(");
-            sql = msStringConcatenate(sql, right);
-            sql = msStringConcatenate(sql, ")");
-            int ok = left && right;
-            msFree(left);
-            msFree(right);
-            if (!ok) {
-                goto fail;
-            }
-            continue;
-        }
-
-        switch(node->token) {
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-        case MS_TOKEN_COMPARISON_DISJOINT:
-        case MS_TOKEN_COMPARISON_TOUCHES:
-        case MS_TOKEN_COMPARISON_OVERLAPS:
-        case MS_TOKEN_COMPARISON_CROSSES:
-        case MS_TOKEN_COMPARISON_DWITHIN:
-        case MS_TOKEN_COMPARISON_BEYOND:
-        case MS_TOKEN_COMPARISON_WITHIN:
-        case MS_TOKEN_COMPARISON_CONTAINS:
-        case MS_TOKEN_COMPARISON_EQUALS:{
-            int token = node->token;
-            char *fct = msOGRGetToken(layer, &node);
-            node = node->next; // skip (
-            char *a1 = msOGRGetToken(layer, &node);
-            node = node->next; // skip ,
-            char *a2 = msOGRGetToken(layer, &node);
-            char *a3 = NULL;
-            if (token == MS_TOKEN_COMPARISON_DWITHIN || token == MS_TOKEN_COMPARISON_BEYOND) {
-                node = node->next; // skip ,
-                a3 = msOGRGetToken(layer, &node);
-            }
-            node = node->next; // skip )
-            char *eq = msOGRGetToken(layer, &node);
-            char *rval = msOGRGetToken(layer, &node);
-            if ((eq && strcmp(eq, " != ") == 0) || (rval && strcmp(rval, "FALSE") == 0)) {
-                sql = msStringConcatenate(sql, "NOT ");
-            }
-            // FIXME: case rval is more complex
-            sql = msStringConcatenate(sql, fct);
-            sql = msStringConcatenate(sql, "(");
-            sql = msStringConcatenate(sql, a1);
-            sql = msStringConcatenate(sql, ",");
-            sql = msStringConcatenate(sql, a2);
-            if (token == MS_TOKEN_COMPARISON_DWITHIN || token == MS_TOKEN_COMPARISON_BEYOND) {
-                sql = msStringConcatenate(sql, ")");
-                if (token == MS_TOKEN_COMPARISON_DWITHIN)
-                    sql = msStringConcatenate(sql, "<=");
-                else 
-                    sql = msStringConcatenate(sql, ">");
-                sql = msStringConcatenate(sql, a3);
-            } else {
-                sql = msStringConcatenate(sql, ")");
-            }
-            int ok = fct && a1 && a2 && eq && rval;
-            if (token == MS_TOKEN_COMPARISON_DWITHIN) {
-                ok = ok && a3;
-            }
-            msFree(fct);
-            msFree(a1);
-            msFree(a2);
-            msFree(a3);
-            msFree(eq);
-            msFree(rval);
-            if (!ok) {
-                goto fail;
-            }
-            break;
-        }
-        default: {
-            char *token = msOGRGetToken(layer, &node);
-            if (!token) {
-                goto fail;
-            }
-            sql = msStringConcatenate(sql, token);
-            msFree(token);
-        }
-        }
-    }
-
-    layer->filter.native_string = sql;
-    return MS_SUCCESS;
-fail:
-    // error producing native string
-    msDebug("Note: Error parsing token list, could produce only: %s. Trying in partial mode\n", sql);
-    msFree(sql);
-
-    // in which case we might still want to try to get a partial WHERE clause
-    if( expr )
-    {
-        bool bPartialFilter = false;
-        std::string osSQL( msOGRTranslatePartialInternal(layer, expr.get(),
-                                                            spatialFilterNode,
-                                                            bPartialFilter) );
-        if( !osSQL.empty() )
-        {
-            info->pszWHERE = msStrdup(osSQL.c_str());
-            if( bPartialFilter )
-            {
-                msDebug("Full filter has only been partially "
-                        "translated to OGR filter %s\n",
-                        info->pszWHERE);
-            }
-        }
-        else if( bPartialFilter )
-        {
-            msDebug("Filter could not be translated to OGR filter\n");
-        }
-    }
-
-    return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                     msOGRLayerOpen()
- *
- * Open OGR data source for the specified map layer.
- *
- * If pszOverrideConnection != NULL then this value is used as the connection
- * string instead of lp->connection.  This is used for instance to open
- * a WFS layer, in this case lp->connection is the WFS url, but we want
- * OGR to open the local file on disk that was previously downloaded.
- *
- * An OGR connection string is:   <dataset_filename>[,<layer_index>]
- *  <dataset_filename>   is file format specific
- *  <layer_index>        (optional) is the OGR layer index
- *                       default is 0, the first layer.
- *
- * One can use the "ogrinfo" program to find out the layer indices in a dataset
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-int msOGRLayerOpen(layerObj *layer, const char *pszOverrideConnection)
-{
-  msOGRFileInfo *psInfo;
-
-  if (layer->layerinfo != NULL) {
-    return MS_SUCCESS;  // Nothing to do... layer is already opened
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If this is not a tiled layer, just directly open the target.    */
-  /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL ) {
-    psInfo = msOGRFileOpen( layer,
-                            (pszOverrideConnection ? pszOverrideConnection:
-                             layer->connection) );
-    layer->layerinfo = psInfo;
-    layer->tileitemindex = -1;
-
-    if( layer->layerinfo == NULL )
-      return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise we open the tile index, identify the tile item        */
-  /*      index and try to select the first file matching our query       */
-  /*      region.                                                         */
-  /* -------------------------------------------------------------------- */
-  else {
-    // Open tile index
-
-    psInfo = msOGRFileOpen( layer, layer->tileindex );
-    layer->layerinfo = psInfo;
-
-    if( layer->layerinfo == NULL )
-      return MS_FAILURE;
-
-    // Identify TILEITEM
-    OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn( psInfo->hLayer );
-    layer->tileitemindex = OGR_FD_GetFieldIndex(hDefn, layer->tileitem);
-    if( layer->tileitemindex < 0 ) {
-      msSetError(MS_OGRERR,
-                 "Can't identify TILEITEM %s field in TILEINDEX `%s'.",
-                 "msOGRLayerOpen()",
-                 layer->tileitem, layer->tileindex );
-      msOGRFileClose( layer, psInfo );
-      layer->layerinfo = NULL;
-      return MS_FAILURE;
-    }
-
-    // Identify TILESRS
-    if( layer->tilesrs != NULL &&
-        OGR_FD_GetFieldIndex(hDefn, layer->tilesrs) < 0 ) {
-      msSetError(MS_OGRERR,
-                 "Can't identify TILESRS %s field in TILEINDEX `%s'.",
-                 "msOGRLayerOpen()",
-                 layer->tilesrs, layer->tileindex );
-      msOGRFileClose( layer, psInfo );
-      layer->layerinfo = NULL;
-      return MS_FAILURE;
-    }
-    if( layer->tilesrs != NULL && layer->projection.numargs == 0 )
-    {
-        msSetError(MS_OGRERR,
-                 "A layer with TILESRS set in TILEINDEX `%s' must have a "
-                 "projection set on itself.",
-                 "msOGRLayerOpen()",
-                 layer->tileindex );
-        msOGRFileClose( layer, psInfo );
-        layer->layerinfo = NULL;
-        return MS_FAILURE;
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * If projection was "auto" then set proj to the dataset's projection.
-   * For a tile index, it is assume the tile index has the projection.
-   * ------------------------------------------------------------------ */
-  if (layer->projection.numargs > 0 &&
-      EQUAL(layer->projection.args[0], "auto")) {
-    ACQUIRE_OGR_LOCK;
-    OGRSpatialReferenceH hSRS = OGR_L_GetSpatialRef( psInfo->hLayer );
-
-    if (msOGRSpatialRef2ProjectionObj(hSRS,
-                                      &(layer->projection),
-                                      layer->debug ) != MS_SUCCESS) {
-      errorObj *ms_error = msGetErrorObj();
-
-      RELEASE_OGR_LOCK;
-      msSetError(MS_OGRERR,
-                 "%s  "
-                 "PROJECTION AUTO cannot be used for this "
-                 "OGR connection (in layer `%s').",
-                 "msOGRLayerOpen()",
-                 ms_error->message,
-                 layer->name?layer->name:"(null)" );
-      msOGRFileClose( layer, psInfo );
-      layer->layerinfo = NULL;
-      return(MS_FAILURE);
-    }
-    RELEASE_OGR_LOCK;
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                     msOGRLayerOpenVT()
- *
- * Overloaded version of msOGRLayerOpen for virtual table architecture
- **********************************************************************/
-static int msOGRLayerOpenVT(layerObj *layer)
-{
-  return msOGRLayerOpen(layer, NULL);
-}
-
-/**********************************************************************
- *                     msOGRLayerClose()
- **********************************************************************/
-int msOGRLayerClose(layerObj *layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-
-  if (psInfo) {
-    if( layer->debug )
-      msDebug("msOGRLayerClose(%s).\n", layer->connection);
-
-    msOGRFileClose( layer, psInfo );
-    layer->layerinfo = NULL;
-  }
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                     msOGRLayerIsOpen()
- **********************************************************************/
-static int msOGRLayerIsOpen(layerObj *layer)
-{
-  if (layer->layerinfo)
-    return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-int msOGRSupportsIsNull(layerObj* layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  if (psInfo && psInfo->dialect &&
-      (EQUAL(psInfo->dialect, "Spatialite") || EQUAL(psInfo->dialect, "GPKG")))
-  {
-    // reasons to not produce native string: not simple layer, or an explicit deny
-    const char *do_this = msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
-    if (do_this && strcmp(do_this, "NO") == 0) {
-        return MS_FALSE;
-    }
-    return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-
-/**********************************************************************
- *                     msOGRLayerWhichShapes()
- *
- * Init OGR layer structs ready for calls to msOGRLayerNextShape().
- *
- * Returns MS_SUCCESS/MS_FAILURE, or MS_DONE if no shape matching the
- * layer's FILTER overlaps the selected region.
- **********************************************************************/
-int msOGRLayerWhichShapes(layerObj *layer, rectObj rect, int /*isQuery*/)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  int   status;
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRLayerWhichShapes()");
-    return(MS_FAILURE);
-  }
-
-  status = msOGRFileWhichShapes( layer, rect, psInfo );
-
-  if( status != MS_SUCCESS || layer->tileindex == NULL )
-    return status;
-
-  // If we are using a tile index, we need to advance to the first
-  // tile matching the spatial query, and load it.
-
-  return msOGRFileReadTile( layer, psInfo );
-}
-
-/**********************************************************************
- *                     msOGRLayerGetItems()
- *
- * Load item (i.e. field) names in a char array.  If we are working
- * with a tiled layer, ensure a tile is loaded and use it for the items.
- * It is implicitly assumed that the schemas will match on all tiles.
- **********************************************************************/
-int msOGRLayerGetItems(layerObj *layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRLayerGetItems()");
-    return(MS_FAILURE);
-  }
-
-  if( layer->tileindex != NULL ) {
-    if( psInfo->poCurTile == NULL
-        && msOGRFileReadTile( layer, psInfo ) != MS_SUCCESS )
-      return MS_FAILURE;
-
-    psInfo = psInfo->poCurTile;
-  }
-
-  layer->numitems = 0;
-  layer->items = msOGRFileGetItems(layer, psInfo);
-  if( layer->items == NULL )
-    return MS_FAILURE;
-
-  while( layer->items[layer->numitems] != NULL )
-    layer->numitems++;
-
-  return msOGRLayerInitItemInfo(layer);
-}
-
-/**********************************************************************
- *                     msOGRLayerInitItemInfo()
- *
- * Init the itemindexes array after items[] has been reset in a layer.
- **********************************************************************/
-static int msOGRLayerInitItemInfo(layerObj *layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  int   i;
-  OGRFeatureDefnH hDefn;
-
-  if (layer->numitems == 0)
-    return MS_SUCCESS;
-
-  if( layer->tileindex != NULL ) {
-    if( psInfo->poCurTile == NULL
-        && msOGRFileReadTile( layer, psInfo, -2 ) != MS_SUCCESS )
-      return MS_FAILURE;
-
-    psInfo = psInfo->poCurTile;
-  }
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRLayerInitItemInfo()");
-    return(MS_FAILURE);
-  }
-
-  if((hDefn = OGR_L_GetLayerDefn( psInfo->hLayer )) == NULL) {
-    msSetError(MS_OGRERR, "Layer contains no fields.",
-               "msOGRLayerInitItemInfo()");
-    return(MS_FAILURE);
-  }
-
-  if (layer->iteminfo)
-    free(layer->iteminfo);
-  if((layer->iteminfo = (int *)malloc(sizeof(int)*layer->numitems))== NULL) {
-    msSetError(MS_MEMERR, NULL, "msOGRLayerInitItemInfo()");
-    return(MS_FAILURE);
-  }
-
-  int *itemindexes = (int*)layer->iteminfo;
-  for(i=0; i<layer->numitems; i++) {
-    // Special case for handling text string and angle coming from
-    // OGR style strings.  We use special attribute snames.
-    if (EQUAL(layer->items[i], MSOGR_LABELFONTNAMENAME))
-      itemindexes[i] = MSOGR_LABELFONTNAMEINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELSIZENAME))
-      itemindexes[i] = MSOGR_LABELSIZEINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELTEXTNAME))
-      itemindexes[i] = MSOGR_LABELTEXTINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELANGLENAME))
-      itemindexes[i] = MSOGR_LABELANGLEINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELFCOLORNAME))
-      itemindexes[i] = MSOGR_LABELFCOLORINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELBCOLORNAME))
-      itemindexes[i] = MSOGR_LABELBCOLORINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELPLACEMENTNAME))
-      itemindexes[i] = MSOGR_LABELPLACEMENTINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELANCHORNAME))
-      itemindexes[i] = MSOGR_LABELANCHORINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELDXNAME))
-      itemindexes[i] = MSOGR_LABELDXINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELDYNAME))
-      itemindexes[i] = MSOGR_LABELDYINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELPERPNAME))
-      itemindexes[i] = MSOGR_LABELPERPINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELBOLDNAME))
-      itemindexes[i] = MSOGR_LABELBOLDINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELITALICNAME))
-      itemindexes[i] = MSOGR_LABELITALICINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELUNDERLINENAME))
-      itemindexes[i] = MSOGR_LABELUNDERLINEINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELPRIORITYNAME))
-      itemindexes[i] = MSOGR_LABELPRIORITYINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELSTRIKEOUTNAME))
-      itemindexes[i] = MSOGR_LABELSTRIKEOUTINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELSTRETCHNAME))
-      itemindexes[i] = MSOGR_LABELSTRETCHINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELADJHORNAME))
-      itemindexes[i] = MSOGR_LABELADJHORINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELADJVERTNAME))
-      itemindexes[i] = MSOGR_LABELADJVERTINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELHCOLORNAME))
-      itemindexes[i] = MSOGR_LABELHCOLORINDEX;
-    else if (EQUAL(layer->items[i], MSOGR_LABELOCOLORNAME))
-      itemindexes[i] = MSOGR_LABELOCOLORINDEX;
-    else if (EQUALN(layer->items[i], MSOGR_LABELPARAMNAME, MSOGR_LABELPARAMNAMELEN))
-        itemindexes[i] = MSOGR_LABELPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_LABELPARAMNAMELEN);
-    else if (EQUALN(layer->items[i], MSOGR_BRUSHPARAMNAME, MSOGR_BRUSHPARAMNAMELEN))
-        itemindexes[i] = MSOGR_BRUSHPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_BRUSHPARAMNAMELEN);
-    else if (EQUALN(layer->items[i], MSOGR_PENPARAMNAME, MSOGR_PENPARAMNAMELEN))
-        itemindexes[i] = MSOGR_PENPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_PENPARAMNAMELEN);
-    else if (EQUALN(layer->items[i], MSOGR_SYMBOLPARAMNAME, MSOGR_SYMBOLPARAMNAMELEN))
-        itemindexes[i] = MSOGR_SYMBOLPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_SYMBOLPARAMNAMELEN);
-    else
-    {
-      itemindexes[i] = OGR_FD_GetFieldIndex( hDefn, layer->items[i] );
-      if( itemindexes[i] == -1 )
-      {
-          if( EQUAL( layer->items[i], OGR_L_GetFIDColumn( psInfo->hLayer ) ) )
-          {
-              itemindexes[i] = MSOGR_FID_INDEX;
-          }
-      }
-    }
-    if(itemindexes[i] == -1) {
-      msSetError(MS_OGRERR,
-                 "Invalid Field name: %s in layer `%s'",
-                 "msOGRLayerInitItemInfo()",
-                 layer->items[i], layer->name ? layer->name : "(null)");
-      return(MS_FAILURE);
-    }
-  }
-
-  return(MS_SUCCESS);
-}
-
-/**********************************************************************
- *                     msOGRLayerFreeItemInfo()
- *
- * Free the itemindexes array in a layer.
- **********************************************************************/
-void msOGRLayerFreeItemInfo(layerObj *layer)
-{
-
-  if (layer->iteminfo)
-    free(layer->iteminfo);
-  layer->iteminfo = NULL;
-}
-
-
-/**********************************************************************
- *                     msOGRLayerNextShape()
- *
- * Returns shape sequentially from OGR data source.
- * msOGRLayerWhichShape() must have been called first.
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-int msOGRLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  int  status;
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRLayerNextShape()");
-    return(MS_FAILURE);
-  }
-
-  if( layer->tileindex == NULL )
-    return msOGRFileNextShape( layer, shape, psInfo );
-
-  // Do we need to load the first tile?
-  if( psInfo->poCurTile == NULL ) {
-    status = msOGRFileReadTile( layer, psInfo );
-    if( status != MS_SUCCESS )
-      return status;
-  }
-
-  do {
-    // Try getting a shape from this tile.
-    status = msOGRFileNextShape( layer, shape, psInfo->poCurTile );
-    if( status != MS_DONE )
-    {
-      if( psInfo->sTileProj.numargs > 0 )
-      {
-        msProjectShape(&(psInfo->sTileProj), &(layer->projection), shape);
-      }
-
-      return status;
-    }
-
-    // try next tile.
-    status = msOGRFileReadTile( layer, psInfo );
-    if( status != MS_SUCCESS )
-      return status;
-  } while( status == MS_SUCCESS );
-  return status; //make compiler happy. this is never reached however
-}
-
-/**********************************************************************
- *                     msOGRLayerGetShape()
- *
- * Returns shape from OGR data source by fid.
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-
-  long shapeindex = record->shapeindex;
-  int tileindex = record->tileindex;
-  int resultindex = record->resultindex;
-  int record_is_fid = TRUE;
-
-  /* set the resultindex as shapeindex if available */
-  if (resultindex >= 0) {
-    record_is_fid = FALSE;
-    shapeindex = resultindex;
-  }
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!", "msOGRLayerGetShape()");
-    return(MS_FAILURE);
-  }
-
-  if( layer->tileindex == NULL )
-    return msOGRFileGetShape(layer, shape, shapeindex, psInfo, record_is_fid );
-  else {
-    if( psInfo->poCurTile == NULL
-        || psInfo->poCurTile->nTileId != tileindex ) {
-      if( msOGRFileReadTile( layer, psInfo, tileindex ) != MS_SUCCESS )
-        return MS_FAILURE;
-    }
-
-    int status = msOGRFileGetShape(layer, shape, shapeindex, psInfo->poCurTile, record_is_fid );
-    if( status == MS_SUCCESS && psInfo->sTileProj.numargs > 0 )
-    {
-      msProjectShape(&(psInfo->sTileProj), &(layer->projection), shape);
-    }
-    return status;
-  }
-}
-
-/**********************************************************************
- *                     msOGRLayerGetExtent()
- *
- * Returns the layer extents.
- *
- * Returns MS_SUCCESS/MS_FAILURE
- **********************************************************************/
-int msOGRLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  OGREnvelope oExtent;
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRLayerGetExtent()");
-    return(MS_FAILURE);
-  }
-
-  /* ------------------------------------------------------------------
-   * Call OGR's GetExtent()... note that for some formats this will
-   * result in a scan of the whole layer and can be an expensive call.
-   *
-   * For tile indexes layers we assume it is sufficient to get the
-   * extents of the tile index.
-   * ------------------------------------------------------------------ */
-  ACQUIRE_OGR_LOCK;
-  if (OGR_L_GetExtent( psInfo->hLayer, &oExtent, TRUE) != OGRERR_NONE) {
-    RELEASE_OGR_LOCK;
-    msSetError(MS_MISCERR, "Unable to get extents for this layer.",
-               "msOGRLayerGetExtent()");
-    return(MS_FAILURE);
-  }
-  RELEASE_OGR_LOCK;
-
-  extent->minx = oExtent.MinX;
-  extent->miny = oExtent.MinY;
-  extent->maxx = oExtent.MaxX;
-  extent->maxy = oExtent.MaxY;
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
-*                     msOGRLayerGetNumFeatures()
-*
-* Returns the layer feature count.
-*
-* Returns the number of features on success, -1 on error
-**********************************************************************/
-int msOGRLayerGetNumFeatures(layerObj *layer)
-{
-    msOGRFileInfo *psInfo = (msOGRFileInfo*)layer->layerinfo;
-    int result;
-
-    if (psInfo == NULL || psInfo->hLayer == NULL) {
-        msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-            "msOGRLayerGetNumFeatures()");
-        return -1;
-    }
-
-    /* ------------------------------------------------------------------
-    * Call OGR's GetFeatureCount()... note that for some formats this will
-    * result in a scan of the whole layer and can be an expensive call.
-    * ------------------------------------------------------------------ */
-    ACQUIRE_OGR_LOCK;
-    result = (int)OGR_L_GetFeatureCount(psInfo->hLayer, TRUE);
-    RELEASE_OGR_LOCK;
-
-    return result;
-}
-
-/**********************************************************************
- *                     msOGRGetSymbolId()
- *
- * Returns a MapServer symbol number matching one of the symbols from
- * the OGR symbol id string.  If not found then try to locate the
- * default symbol name, and if not found return 0.
- **********************************************************************/
-static int msOGRGetSymbolId(symbolSetObj *symbolset, const char *pszSymbolId,
-                            const char *pszDefaultSymbol, int try_addimage_if_notfound)
-{
-  // Symbol name mapping:
-  // First look for the native symbol name, then the ogr-...
-  // generic name, and in last resort try pszDefaultSymbol if
-  // provided by user.
-  char  **params;
-  int   numparams;
-  int   nSymbol = -1;
-
-  if (pszSymbolId && pszSymbolId[0] != '\0') {
-    params = msStringSplit(pszSymbolId, ',', &numparams);
-    if (params != NULL) {
-      for(int j=0; j<numparams && nSymbol == -1; j++) {
-        nSymbol = msGetSymbolIndex(symbolset, params[j],
-                                   try_addimage_if_notfound);
-      }
-      msFreeCharArray(params, numparams);
-    }
-  }
-  if (nSymbol == -1 && pszDefaultSymbol) {
-    nSymbol = msGetSymbolIndex(symbolset,(char*)pszDefaultSymbol,
-                               try_addimage_if_notfound);
-  }
-  if (nSymbol == -1)
-    nSymbol = 0;
-
-  return nSymbol;
-}
-
-static int msOGRUpdateStyleParseLabel(mapObj *map, layerObj *layer, classObj *c,
-                                      OGRStyleToolH hLabelStyle);
-static int msOGRUpdateStyleParsePen(mapObj *map, layerObj *layer, styleObj *s,
-                                    OGRStyleToolH hPenStyle, int bIsBrush, int* pbPriority);
-static int msOGRUpdateStyleParseBrush(mapObj *map, layerObj *layer, styleObj *s,
-                                      OGRStyleToolH hBrushStyle, int* pbIsBrush, int* pbPriority);
-static int msOGRUpdateStyleParseSymbol(mapObj *map, styleObj *s,
-                                       OGRStyleToolH hSymbolStyle, int* pbPriority);
-static int msOGRAddBgColorStyleParseBrush(styleObj* s, OGRStyleToolH hSymbolStyle);
-
-static int msOGRUpdateStyleCheckPenBrushOnly(OGRStyleMgrH hStyleMgr)
-{
-  int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
-  int countPen = 0, countBrush = 0;
-  int bIsNull;
-
-  for(int i=0; i<numParts; i++) {
-    OGRSTClassId eStylePartType;
-    OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
-    if (!hStylePart)
-      continue;
-
-    eStylePartType = OGR_ST_GetType(hStylePart);
-    if (eStylePartType == OGRSTCPen) {
-      countPen ++;
-      OGR_ST_GetParamNum(hStylePart, OGRSTPenPriority, &bIsNull);
-      if( !bIsNull ) {
-        OGR_ST_Destroy(hStylePart);
-        return MS_FALSE;
-      }
-    }
-    else if (eStylePartType == OGRSTCBrush) {
-      countBrush ++;
-      OGR_ST_GetParamNum(hStylePart, OGRSTBrushPriority, &bIsNull);
-      if( !bIsNull ) {
-        OGR_ST_Destroy(hStylePart);
-        return MS_FALSE;
-      }
-    }
-    else if (eStylePartType == OGRSTCSymbol) {
-      OGR_ST_Destroy(hStylePart);
-      return MS_FALSE;
-    }
-    OGR_ST_Destroy(hStylePart);
-  }
-  return (countPen == 1 && countBrush == 1);
-}
-
-/**********************************************************************
- *                     msOGRUpdateStyle()
- *
- * Update the mapserver style according to the ogr style.
- * The function is called by msOGRGetAutoStyle and
- * msOGRUpdateStyleFromString
- **********************************************************************/
-
-typedef struct
-{
-    int nPriority; /* the explicit priority as specified by the 'l' option of PEN, BRUSH and SYMBOL tools */
-    int nApparitionIndex; /* the index of the tool as parsed from the OGR feature style string */
-} StyleSortStruct;
-
-static int msOGRUpdateStyleSortFct(const void* pA, const void* pB)
-{
-    StyleSortStruct* sssa = (StyleSortStruct*)pA;
-    StyleSortStruct* sssb = (StyleSortStruct*)pB;
-    if( sssa->nPriority < sssb->nPriority )
-        return -1;
-    else if( sssa->nPriority > sssb->nPriority )
-        return 1;
-    else if( sssa->nApparitionIndex < sssb->nApparitionIndex )
-        return -1;
-    else
-        return 1;
-}
-
-static int msOGRUpdateStyle(OGRStyleMgrH hStyleMgr, mapObj *map, layerObj *layer, classObj *c)
-{
-  GBool bIsBrush=MS_FALSE;
-  int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
-  int nPriority;
-  int bIsPenBrushOnly = msOGRUpdateStyleCheckPenBrushOnly(hStyleMgr);
-  StyleSortStruct* pasSortStruct = (StyleSortStruct*) msSmallMalloc(sizeof(StyleSortStruct) * numParts);
-  int iSortStruct = 0;
-  int iBaseStyleIndex = c->numstyles;
-  int i;
-
-  /* ------------------------------------------------------------------
-   * Handle each part
-   * ------------------------------------------------------------------ */
-
-  for(i=0; i<numParts; i++) {
-    OGRSTClassId eStylePartType;
-    OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
-    if (!hStylePart)
-      continue;
-    eStylePartType = OGR_ST_GetType(hStylePart);
-    nPriority = INT_MIN;
-
-    // We want all size values returned in pixels.
-    //
-    // The scale factor that OGR expect is the ground/paper scale
-    // e.g. if 1 ground unit = 0.01 paper unit then scale=1/0.01=100
-    // cellsize if number of ground units/pixel, and OGR assumes that
-    // there is 72*39.37 pixels/ground units (since meter is assumed
-    // for ground... but what ground units we have does not matter
-    // as long as use the same assumptions everywhere)
-    // That gives scale = cellsize*72*39.37
-
-    OGR_ST_SetUnit(hStylePart, OGRSTUPixel, 
-      map->cellsize*map->resolution/map->defresolution*72.0*39.37);
-
-    if (eStylePartType == OGRSTCLabel) {
-      int ret = msOGRUpdateStyleParseLabel(map, layer, c, hStylePart);
-      if( ret != MS_SUCCESS ) {
-        OGR_ST_Destroy(hStylePart);
-        msFree(pasSortStruct);
-        return ret;
-      }
-    } else if (eStylePartType == OGRSTCPen) {
-      styleObj* s;
-      int nIndex;
-      if( bIsPenBrushOnly ) {
-        /* Historic behaviour when there is a PEN and BRUSH only */
-        if (bIsBrush || layer->type == MS_LAYER_POLYGON)
-            // This is a multipart symbology, so pen defn goes in the
-            // overlaysymbol params
-            nIndex = c->numstyles + 1;
-        else
-            nIndex = c->numstyles;
-      }
-      else
-        nIndex = c->numstyles;
-
-      if (msMaybeAllocateClassStyle(c, nIndex)) {
-        OGR_ST_Destroy(hStylePart);
-        msFree(pasSortStruct);
-        return(MS_FAILURE);
-      }
-      s = c->styles[nIndex];
-
-      msOGRUpdateStyleParsePen(map, layer, s, hStylePart, bIsBrush, &nPriority);
-
-    } else if (eStylePartType == OGRSTCBrush) {
-
-      styleObj* s;
-      int nIndex = 0;
-
-      GBool bBgColorIsNull = MS_TRUE;
-      OGR_ST_GetParamStr(hStylePart, OGRSTBrushBColor, &bBgColorIsNull);
-
-      if (!bBgColorIsNull) {
-
-       if (msMaybeAllocateClassStyle(c, nIndex)) {
-            OGR_ST_Destroy(hStylePart);
-            msFree(pasSortStruct);
-            return(MS_FAILURE);
-        }
-
-        // add a backgroundcolor as a separate style
-        s = c->styles[nIndex];
-        msOGRAddBgColorStyleParseBrush(s, hStylePart);
-      }
-
-
-      nIndex = ( bIsPenBrushOnly ) ? nIndex : c->numstyles;
-
-      if (!bBgColorIsNull) {
-          // if we have a bgcolor style we need to increase the index
-          nIndex += 1;
-      }
-
-      /* We need 1 style */
-      if (msMaybeAllocateClassStyle(c, nIndex)) {
-        OGR_ST_Destroy(hStylePart);
-        msFree(pasSortStruct);
-        return(MS_FAILURE);
-      }
-      s = c->styles[nIndex];
-
-      msOGRUpdateStyleParseBrush(map, layer, s, hStylePart, &bIsBrush, &nPriority);
-
-    } else if (eStylePartType == OGRSTCSymbol) {
-      styleObj* s;
-      /* We need 1 style */
-      int nIndex = c->numstyles;
-      if (msMaybeAllocateClassStyle(c, nIndex)) {
-        OGR_ST_Destroy(hStylePart);
-        msFree(pasSortStruct);
-        return(MS_FAILURE);
-      }
-      s = c->styles[nIndex];
-
-      msOGRUpdateStyleParseSymbol(map, s, hStylePart, &nPriority);
-    }
-
-    /* Memorize the explicit priority and apparition order of the parsed tool/style */
-    if( !bIsPenBrushOnly &&
-        (eStylePartType == OGRSTCPen || eStylePartType == OGRSTCBrush ||
-         eStylePartType == OGRSTCSymbol) ) {
-        pasSortStruct[iSortStruct].nPriority = nPriority;
-        pasSortStruct[iSortStruct].nApparitionIndex = iSortStruct;
-        iSortStruct++;
-    }
-
-    OGR_ST_Destroy(hStylePart);
-
-  }
-
-  if( iSortStruct > 1 && !bIsPenBrushOnly ) {
-      /* Compute style order based on their explicit priority and apparition order */
-      qsort(pasSortStruct, iSortStruct, sizeof(StyleSortStruct), msOGRUpdateStyleSortFct);
-
-      /* Now reorder styles in c->styles */
-      styleObj** ppsStyleTmp = (styleObj**)msSmallMalloc( iSortStruct * sizeof(styleObj*) );
-      memcpy( ppsStyleTmp, c->styles + iBaseStyleIndex, iSortStruct * sizeof(styleObj*) );
-      for( i = 0; i < iSortStruct; i++)
-      {
-          c->styles[iBaseStyleIndex + i] = ppsStyleTmp[pasSortStruct[i].nApparitionIndex];
-      }
-      msFree(ppsStyleTmp);
-  }
-  
-  msFree(pasSortStruct);
-  
-  return MS_SUCCESS;
-}
-
-static int msOGRUpdateStyleParseLabel(mapObj *map, layerObj *layer, classObj *c,
-                                      OGRStyleToolH hLabelStyle)
-{
-  GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
-
-      // Enclose the text string inside quotes to make sure it is seen
-      // as a string by the parser inside loadExpression(). (bug185)
-      /* See bug 3481 about the isalnum hack */
-      const char *labelTextString = OGR_ST_GetParamStr(hLabelStyle,
-                                    OGRSTLabelTextString,
-                                    &bIsNull);
-
-      if (c->numlabels == 0) {
-        /* allocate a new label object */
-        if(msGrowClassLabels(c) == NULL) 
-          return MS_FAILURE;
-        c->numlabels++;
-        initLabel(c->labels[0]);
-      }
-      msFreeExpression(&c->labels[0]->text);
-      c->labels[0]->text.type = MS_STRING;
-      c->labels[0]->text.string = msStrdup(labelTextString);
-
-      c->labels[0]->angle = OGR_ST_GetParamDbl(hLabelStyle,
-                            OGRSTLabelAngle, &bIsNull);
-
-      c->labels[0]->size = OGR_ST_GetParamDbl(hLabelStyle,
-                                              OGRSTLabelSize, &bIsNull);
-      if( c->labels[0]->size < 1 ) /* no point dropping to zero size */
-        c->labels[0]->size = 1;
-
-      // OGR default is anchor point = LL, so label is at UR of anchor
-      c->labels[0]->position = MS_UR;
-
-      int nPosition = OGR_ST_GetParamNum(hLabelStyle,
-                                         OGRSTLabelAnchor,
-                                         &bIsNull);
-      if( !bIsNull ) {
-        switch( nPosition ) {
-          case 1:
-            c->labels[0]->position = MS_UR;
-            break;
-          case 2:
-            c->labels[0]->position = MS_UC;
-            break;
-          case 3:
-            c->labels[0]->position = MS_UL;
-            break;
-          case 4:
-            c->labels[0]->position = MS_CR;
-            break;
-          case 5:
-            c->labels[0]->position = MS_CC;
-            break;
-          case 6:
-            c->labels[0]->position = MS_CL;
-            break;
-          case 7:
-            c->labels[0]->position = MS_LR;
-            break;
-          case 8:
-            c->labels[0]->position = MS_LC;
-            break;
-          case 9:
-            c->labels[0]->position = MS_LL;
-            break;
-          case 10:
-            c->labels[0]->position = MS_UR;
-            break; /*approximate*/
-          case 11:
-            c->labels[0]->position = MS_UC;
-            break;
-          case 12:
-            c->labels[0]->position = MS_UL;
-            break;
-          default:
-            break;
-        }
-      }
-
-      const char *pszColor = OGR_ST_GetParamStr(hLabelStyle,
-                             OGRSTLabelFColor,
-                             &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hLabelStyle, pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(c->labels[0]->color, r, g, b, t);
-      }
-
-      pszColor = OGR_ST_GetParamStr(hLabelStyle,
-                                    OGRSTLabelHColor,
-                                    &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hLabelStyle, pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(c->labels[0]->shadowcolor, r, g, b, t);
-      }
-
-      pszColor = OGR_ST_GetParamStr(hLabelStyle,
-                                    OGRSTLabelOColor,
-                                    &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hLabelStyle, pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(c->labels[0]->outlinecolor, r, g, b, t);
-      }
-
-      const char *pszBold = OGR_ST_GetParamNum(hLabelStyle,
-                            OGRSTLabelBold,
-                            &bIsNull) ? "-bold" : "";
-      const char *pszItalic = OGR_ST_GetParamNum(hLabelStyle,
-                              OGRSTLabelItalic,
-                              &bIsNull) ? "-italic" : "";
-      const char *pszFontName = OGR_ST_GetParamStr(hLabelStyle,
-                                OGRSTLabelFontName,
-                                &bIsNull);
-      /* replace spaces with hyphens to allow mapping to a valid hashtable entry*/
-      char* pszFontNameEscaped = NULL;
-      if (pszFontName != NULL) {
-          pszFontNameEscaped = msStrdup(pszFontName);
-          msReplaceChar(pszFontNameEscaped, ' ', '-');
-      }
-
-      bool bFont = true;
-
-      if (pszFontNameEscaped != NULL && !bIsNull && pszFontNameEscaped[0] != '\0') {
-        const char *pszName = CPLSPrintf("%s%s%s", pszFontNameEscaped, pszBold, pszItalic);
-        if (msLookupHashTable(&(map->fontset.fonts), (char*)pszName) != NULL) {
-          c->labels[0]->font = msStrdup(pszName);
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** Using '%s' TTF font **\n", pszName);
-        } else if ( (strcmp(pszFontNameEscaped,pszName) != 0) &&
-                    msLookupHashTable(&(map->fontset.fonts), (char*)pszFontNameEscaped) != NULL) {
-          c->labels[0]->font = msStrdup(pszFontNameEscaped);
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** Using '%s' TTF font **\n", pszFontNameEscaped);
-        } else if (msLookupHashTable(&(map->fontset.fonts),"default") != NULL) {
-          c->labels[0]->font = msStrdup("default");
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** Using 'default' TTF font **\n");
-        } else
-          bFont = false;
-      }
-
-      msFree(pszFontNameEscaped);
-
-      if (!bFont) {
-        c->labels[0]->size = MS_MEDIUM;
-      }
-
-      return MS_SUCCESS;
-}
-
-static int msOGRUpdateStyleParsePen(mapObj *map, layerObj *layer, styleObj *s,
-                                    OGRStyleToolH hPenStyle, int bIsBrush,
-                                    int* pbPriority)
-{
-  GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
-
-      const char *pszPenName, *pszPattern, *pszCap, *pszJoin;
-      colorObj oPenColor;
-      int nPenSymbol = 0;
-      int nPenSize = 1;
-      t =-1;
-      double pattern[MS_MAXPATTERNLENGTH];
-      int patternlength = 0;
-      int linecap = MS_CJC_DEFAULT_CAPS;
-      int linejoin = MS_CJC_DEFAULT_JOINS;
-      double offsetx = 0.0;
-      double offsety = 0.0;
-
-      // Make sure pen is always initialized
-      MS_INIT_COLOR(oPenColor, -1, -1, -1,255);
-
-      pszPenName = OGR_ST_GetParamStr(hPenStyle,
-                               OGRSTPenId,
-                               &bIsNull);
-      if (bIsNull) pszPenName = NULL;
-      // Check for Pen Pattern "ogr-pen-1": the invisible pen
-      // If that's what we have then set pen color to -1
-      if (pszPenName && strstr(pszPenName, "ogr-pen-1") != NULL) {
-        MS_INIT_COLOR(oPenColor, -1, -1, -1,255);
-      } else {
-        const char *pszColor = OGR_ST_GetParamStr(hPenStyle,
-                               OGRSTPenColor,
-                               &bIsNull);
-        if (!bIsNull && OGR_ST_GetRGBFromString(hPenStyle, pszColor,
-                                                &r, &g, &b, &t)) {
-          MS_INIT_COLOR(oPenColor, r, g, b, t);
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** PEN COLOR = %d %d %d **\n", r,g,b);
-        }
-
-        nPenSize = OGR_ST_GetParamNum(hPenStyle,
-                                      OGRSTPenWidth, &bIsNull);
-        if (bIsNull)
-          nPenSize = 1;
-        if (pszPenName!=NULL) {
-          // Try to match pen name in symbol file
-          nPenSymbol = msOGRGetSymbolId(&(map->symbolset),
-                                        pszPenName, NULL, MS_FALSE);
-        }
-      }
-
-      if (layer->debug >= MS_DEBUGLEVEL_VVV)
-        msDebug("** PEN COLOR = %d %d %d **\n", oPenColor.red,oPenColor.green,oPenColor.blue);
-
-      pszPattern = OGR_ST_GetParamStr(hPenStyle, OGRSTPenPattern, &bIsNull);
-      if (bIsNull) pszPattern = NULL;
-      if( pszPattern != NULL )
-      {
-          char** papszTokens = CSLTokenizeStringComplex(pszPattern, " ", FALSE, FALSE);
-          int nTokenCount = CSLCount(papszTokens);
-          int bValidFormat = TRUE;
-          if( nTokenCount >= 2 && nTokenCount <= MS_MAXPATTERNLENGTH)
-          {
-              for(int i=0;i<nTokenCount;i++)
-              {
-                  if( strlen(papszTokens[i]) > 2 &&
-                      strcmp(papszTokens[i] + strlen(papszTokens[i]) - 2, "px") == 0 )
-                  {
-                      pattern[patternlength++] = CPLAtof(papszTokens[i]);
-                  }
-                  else
-                  {
-                      bValidFormat = FALSE;
-                      patternlength = 0;
-                      break;
-                  }
-              }
-          }
-          else
-              bValidFormat = FALSE;
-          if( !bValidFormat && layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("Invalid/unhandled pen pattern format = %s\n", pszPattern);
-          CSLDestroy(papszTokens);
-      }
-      
-      pszCap = OGR_ST_GetParamStr(hPenStyle, OGRSTPenCap, &bIsNull);
-      if (bIsNull) pszCap = NULL;
-      if( pszCap != NULL )
-      {
-          /* Note: the default in OGR Feature style is BUTT, but the MapServer */
-          /* default is ROUND. Currently use MapServer default. */
-          if( strcmp(pszCap, "b") == 0 ) /* BUTT */
-              linecap = MS_CJC_BUTT;
-          else if( strcmp(pszCap, "r") == 0 ) /* ROUND */
-              linecap = MS_CJC_ROUND;
-          else if( strcmp(pszCap, "p") == 0 ) /* PROJECTING */
-              linecap = MS_CJC_SQUARE;
-          else if( layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("Invalid/unhandled pen cap = %s\n", pszCap);
-      }
-      
-      pszJoin = OGR_ST_GetParamStr(hPenStyle, OGRSTPenJoin, &bIsNull);
-      if (bIsNull) pszJoin = NULL;
-      if( pszJoin != NULL )
-      {
-          /* Note: the default in OGR Feature style is MITER, but the MapServer */
-          /* default is NONE. Currently use MapServer default. */
-          if( strcmp(pszJoin, "m") == 0 ) /* MITTER */
-              linejoin = MS_CJC_MITER;
-          else if( strcmp(pszJoin, "r") == 0 ) /* ROUND */
-              linejoin = MS_CJC_ROUND;
-          else if( strcmp(pszJoin, "b") == 0 ) /* BEVEL */
-              linejoin = MS_CJC_BEVEL;
-          else if( layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("Invalid/unhandled pen join = %s\n", pszJoin);
-      }
-
-      offsetx = OGR_ST_GetParamDbl(hPenStyle, OGRSTPenPerOffset, &bIsNull);
-      if( bIsNull ) offsetx = 0;
-      if( offsetx != 0.0 )
-      {
-          /* OGR feature style and MapServer conventions related to offset */
-          /* sign are the same : negative values for left of line, positive for */
-          /* right of line */
-          offsety = MS_STYLE_SINGLE_SIDED_OFFSET;
-      }
-
-      if (bIsBrush || layer->type == MS_LAYER_POLYGON) {
-        // This is a multipart symbology, so pen defn goes in the
-        // overlaysymbol params
-        s->outlinecolor = oPenColor;
-      } else {
-        // Single part symbology
-        s->color = oPenColor;
-      }
-
-      s->symbol = nPenSymbol;
-      s->size = nPenSize;
-      s->width = nPenSize;
-      s->linecap = linecap;
-      s->linejoin = linejoin;
-      s->offsetx = offsetx;
-      s->offsety = offsety;
-      s->patternlength = patternlength;
-      if( patternlength > 0 )
-          memcpy(s->pattern, pattern, sizeof(double) * patternlength);
-
-      int nPriority = OGR_ST_GetParamNum(hPenStyle, OGRSTPenPriority, &bIsNull);
-      if( !bIsNull )
-          *pbPriority = nPriority;
-
-      return MS_SUCCESS;
-}
-
-static int msOGRAddBgColorStyleParseBrush(styleObj* s, OGRStyleToolH hBrushStyle)
-{
-    GBool bIsNull;
-    int r = 0, g = 0, b = 0, t = 0;
-    const char* pszColor = OGR_ST_GetParamStr(hBrushStyle,
-        OGRSTBrushBColor, &bIsNull);
-
-    if (!bIsNull && OGR_ST_GetRGBFromString(hBrushStyle,
-        pszColor,
-        &r, &g, &b, &t)) {
-        MS_INIT_COLOR(s->color, r, g, b, t);
-    }
-    return MS_SUCCESS;
-}
-
-static int msOGRUpdateStyleParseBrush(mapObj *map, layerObj *layer, styleObj *s,
-                                      OGRStyleToolH hBrushStyle, int* pbIsBrush,
-                                      int* pbPriority)
-{
-  GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
-
-      const char *pszBrushName = OGR_ST_GetParamStr(hBrushStyle,
-                                 OGRSTBrushId,
-                                 &bIsNull);
-      if (bIsNull) pszBrushName = NULL;
-
-      // Check for Brush Pattern "ogr-brush-1": the invisible fill
-      // If that's what we have then set fill color to -1
-      if (pszBrushName && strstr(pszBrushName, "ogr-brush-1") != NULL) {
-        MS_INIT_COLOR(s->color, -1, -1, -1, 255);
-      } else {
-        *pbIsBrush = TRUE;
-        const char *pszColor = OGR_ST_GetParamStr(hBrushStyle,
-                               OGRSTBrushFColor,
-                               &bIsNull);
-        if (!bIsNull && OGR_ST_GetRGBFromString(hBrushStyle,
-                                                pszColor,
-                                                &r, &g, &b, &t)) {
-          MS_INIT_COLOR(s->color, r, g, b, t);
-
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** BRUSH COLOR = %d %d %d **\n", r,g,b);
-        }
-
-        // Symbol name mapping:
-        // First look for the native symbol name, then the ogr-...
-        // generic name.
-        // If none provided or found then use 0: solid fill
-
-        const char *pszName = OGR_ST_GetParamStr(hBrushStyle,
-                              OGRSTBrushId,
-                              &bIsNull);
-        s->symbol = msOGRGetSymbolId(&(map->symbolset),
-                                                pszName, NULL, MS_FALSE);
-
-        double angle = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushAngle, &bIsNull);
-        if( !bIsNull )
-            s->angle = angle;
-        
-        double size = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushSize, &bIsNull);
-        if( !bIsNull )
-            s->size = size;
-        
-        double spacingx = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDx, &bIsNull);
-        if( !bIsNull )
-        {
-            double spacingy = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDy, &bIsNull);
-            if( !bIsNull )
-            {
-                if( spacingx == spacingy )
-                    s->gap = spacingx;
-                else if( layer->debug >= MS_DEBUGLEVEL_VVV )
-                    msDebug("Ignoring brush dx and dy since they don't have the same value\n");
-            }
-        }
-      }
-
-      int nPriority = OGR_ST_GetParamNum(hBrushStyle, OGRSTBrushPriority, &bIsNull);
-      if( !bIsNull )
-          *pbPriority = nPriority;
-
-      return MS_SUCCESS;
-}
-
-static int msOGRUpdateStyleParseSymbol(mapObj *map, styleObj *s,
-                                       OGRStyleToolH hSymbolStyle,
-                                       int* pbPriority)
-{
-  GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
-
-      const char *pszColor = OGR_ST_GetParamStr(hSymbolStyle,
-                             OGRSTSymbolColor,
-                             &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hSymbolStyle,
-                                              pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(s->color, r, g, b, t);
-      }
-
-      pszColor = OGR_ST_GetParamStr(hSymbolStyle,
-                                    OGRSTSymbolOColor,
-                                    &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hSymbolStyle,
-                                              pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(s->outlinecolor, r, g, b, t);
-      }
-
-      s->angle = OGR_ST_GetParamNum(hSymbolStyle,
-                            OGRSTSymbolAngle,
-                            &bIsNull);
-      double dfTmp = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolSize, &bIsNull);
-      if (!bIsNull)
-        s->size = dfTmp;
-
-      // Symbol name mapping:
-      // First look for the native symbol name, then the ogr-...
-      // generic name, and in last resort try "default-marker" if
-      // provided by user.
-      const char *pszName = OGR_ST_GetParamStr(hSymbolStyle,
-                            OGRSTSymbolId,
-                            &bIsNull);
-      if (bIsNull)
-        pszName = NULL;
-
-      int try_addimage_if_notfound = MS_FALSE;
-#ifdef USE_CURL
-      if (pszName && strncasecmp(pszName, "http", 4) == 0)
-        try_addimage_if_notfound =MS_TRUE;
-#endif
-      if (!s->symbolname)
-        s->symbol = msOGRGetSymbolId(&(map->symbolset),
-                                                pszName,
-                                                "default-marker",  try_addimage_if_notfound);
-
-      int nPriority = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolPriority, &bIsNull);
-      if( !bIsNull )
-          *pbPriority = nPriority;
-
-      return MS_SUCCESS;
-}
-
-
-/**********************************************************************
- *                     msOGRLayerGetAutoStyle()
- *
- * Fills a classObj with style info from the specified shape.
- * For optimal results, this should be called immediately after
- * GetNextShape() or GetShape() so that the shape doesn't have to be read
- * twice.
- *
- * The returned classObj is a ref. to a static structure valid only until
- * the next call and that shouldn't be freed by the caller.
- **********************************************************************/
-static int msOGRLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
-                                  shapeObj* shape)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-
-  if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-               "msOGRLayerGetAutoStyle()");
-    return(MS_FAILURE);
-  }
-
-  if( layer->tileindex != NULL ) {
-    if( (psInfo->poCurTile == NULL || shape->tileindex != psInfo->poCurTile->nTileId)
-        && msOGRFileReadTile( layer, psInfo ) != MS_SUCCESS )
-      return MS_FAILURE;
-
-    psInfo = psInfo->poCurTile;
-  }
-
-  /* ------------------------------------------------------------------
-   * Read shape or reuse ref. to last shape read.
-   * ------------------------------------------------------------------ */
-  ACQUIRE_OGR_LOCK;
-  if (psInfo->hLastFeature == NULL ||
-      psInfo->last_record_index_read != shape->resultindex) {
-    RELEASE_OGR_LOCK;
-    msSetError(MS_MISCERR,
-               "Assertion failed: AutoStyle not requested on loaded shape.",
-               "msOGRLayerGetAutoStyle()");
-    return(MS_FAILURE);
-  }
-
-  /* ------------------------------------------------------------------
-   * Reset style info in the class to defaults
-   * the only members we don't touch are name, expression, and join/query stuff
-   * ------------------------------------------------------------------ */
-  resetClassStyle(c);
-  if (msMaybeAllocateClassStyle(c, 0)) {
-    RELEASE_OGR_LOCK;
-    return(MS_FAILURE);
-  }
-
-  // __TODO__ label cache incompatible with styleitem feature.
-  layer->labelcache = MS_OFF;
-
-  int nRetVal = MS_SUCCESS;
-  if (psInfo->hLastFeature) {
-    OGRStyleMgrH hStyleMgr = OGR_SM_Create(NULL);
-    OGR_SM_InitFromFeature(hStyleMgr, psInfo->hLastFeature);
-    nRetVal = msOGRUpdateStyle(hStyleMgr, map, layer, c);
-    OGR_SM_Destroy(hStyleMgr);
-  }
-
-  RELEASE_OGR_LOCK;
-  return nRetVal;
-}
-
-
-/**********************************************************************
- *                     msOGRUpdateStyleFromString()
- *
- * Fills a classObj with style info from the specified style string.
- * For optimal results, this should be called immediately after
- * GetNextShape() or GetShape() so that the shape doesn't have to be read
- * twice.
- *
- * The returned classObj is a ref. to a static structure valid only until
- * the next call and that shouldn't be freed by the caller.
- **********************************************************************/
-int msOGRUpdateStyleFromString(mapObj *map, layerObj *layer, classObj *c,
-                               const char *stylestring)
-{
-  /* ------------------------------------------------------------------
-   * Reset style info in the class to defaults
-   * the only members we don't touch are name, expression, and join/query stuff
-   * ------------------------------------------------------------------ */
-  resetClassStyle(c);
-  if (msMaybeAllocateClassStyle(c, 0)) {
-    return(MS_FAILURE);
-  }
-
-  // __TODO__ label cache incompatible with styleitem feature.
-  layer->labelcache = MS_OFF;
-
-  int nRetVal = MS_SUCCESS;
-
-  ACQUIRE_OGR_LOCK;
-
-  OGRStyleMgrH hStyleMgr = OGR_SM_Create(NULL);
-  OGR_SM_InitStyleString(hStyleMgr, stylestring);
-  nRetVal = msOGRUpdateStyle(hStyleMgr, map, layer, c);
-  OGR_SM_Destroy(hStyleMgr);
-
-  RELEASE_OGR_LOCK;
-  return nRetVal;
-}
-
-/************************************************************************/
-/*                           msOGRLCleanup()                            */
-/************************************************************************/
-
-void msOGRCleanup( void )
-
-{
-  ACQUIRE_OGR_LOCK;
-  if( bOGRDriversRegistered == MS_TRUE ) {
-    CPLPopErrorHandler();
-    bOGRDriversRegistered = MS_FALSE;
-  }
-  RELEASE_OGR_LOCK;
-}
-
-/************************************************************************/
-/*                           msOGREscapeSQLParam                        */
-/************************************************************************/
-char *msOGREscapePropertyName(layerObj *layer, const char *pszString)
-{
-  char* pszEscapedStr =NULL;
-  if(layer && pszString && strlen(pszString) > 0) {
-    pszEscapedStr = (char*) msSmallMalloc( strlen(pszString) * 2 + 1 );
-    int j = 0;
-    for( int i = 0; pszString[i] != '\0'; ++i )
-    {
-        if( pszString[i] == '"' )
-        {
-            pszEscapedStr[j++] = '"';
-            pszEscapedStr[j++] = '"';
-        }
-        else
-            pszEscapedStr[j++] = pszString[i];
-    }
-    pszEscapedStr[j] = 0;
-  }
-  return pszEscapedStr;
-}
-
-static int msOGRLayerSupportsCommonFilters(layerObj *)
-{
-  return MS_FALSE;
-}
-
-static void msOGREnablePaging(layerObj *layer, int value)
-{
-  msOGRFileInfo *layerinfo = NULL;
-
-  if (layer->debug) {
-    msDebug("msOGREnablePaging(%d) called.\n", value);
-  }
-
-  if(!msOGRLayerIsOpen(layer))
-  {
-    if(msOGRLayerOpenVT(layer) != MS_SUCCESS)
-    {
-      return;
-    }
-  }
-
-  assert( layer->layerinfo != NULL);
-
-  layerinfo = (msOGRFileInfo *)layer->layerinfo;
-  layerinfo->bPaging = value;
-}
-
-static int msOGRGetPaging(layerObj *layer)
-{
-  msOGRFileInfo *layerinfo = NULL;
-
-  if (layer->debug) {
-    msDebug("msOGRGetPaging called.\n");
-  }
-
-  if(!msOGRLayerIsOpen(layer))
-  {
-    if(msOGRLayerOpenVT(layer) != MS_SUCCESS)
-    {
-      return FALSE;
-    }
-  }
-
-  assert( layer->layerinfo != NULL);
-
-  layerinfo = (msOGRFileInfo *)layer->layerinfo;
-  return layerinfo->bPaging;
-}
-
-/************************************************************************/
-/*                  msOGRLayerInitializeVirtualTable()                  */
-/************************************************************************/
-int msOGRLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerTranslateFilter = msOGRTranslateMsExpressionToOGRSQL;
-
-  layer->vtable->LayerSupportsCommonFilters = msOGRLayerSupportsCommonFilters;
-  layer->vtable->LayerInitItemInfo = msOGRLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msOGRLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msOGRLayerOpenVT;
-  layer->vtable->LayerIsOpen = msOGRLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msOGRLayerWhichShapes;
-  layer->vtable->LayerNextShape = msOGRLayerNextShape;
-  layer->vtable->LayerGetShape = msOGRLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msOGRLayerClose;
-  layer->vtable->LayerGetItems = msOGRLayerGetItems;
-  layer->vtable->LayerGetExtent = msOGRLayerGetExtent;
-  layer->vtable->LayerGetAutoStyle = msOGRLayerGetAutoStyle;
-  /* layer->vtable->LayerCloseConnection, use default */
-  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  layer->vtable->LayerGetNumFeatures = msOGRLayerGetNumFeatures;
-  /* layer->vtable->LayerGetAutoProjection, use defaut*/
-
-  layer->vtable->LayerEscapeSQLParam = msOGREscapeSQLParam;
-  layer->vtable->LayerEscapePropertyName = msOGREscapePropertyName;
-  layer->vtable->LayerEnablePaging = msOGREnablePaging;
-  layer->vtable->LayerGetPaging = msOGRGetPaging;
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                         msOGRShapeFromWKT()                          */
-/************************************************************************/
-shapeObj *msOGRShapeFromWKT(const char *string)
-{
-
-  OGRGeometryH hGeom = NULL;
-  shapeObj *shape=NULL;
-
-  if(!string)
-    return NULL;
-
-  if( OGR_G_CreateFromWkt( (char **)&string, NULL, &hGeom ) != OGRERR_NONE ) {
-    msSetError(MS_OGRERR, "Failed to parse WKT string.",
-               "msOGRShapeFromWKT()" );
-    return NULL;
-  }
-
-  /* Initialize a corresponding shapeObj */
-
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
-  msInitShape(shape);
-
-  /* translate WKT into an OGRGeometry. */
-
-  if( msOGRGeometryToShape( hGeom, shape,
-                            wkbFlatten(OGR_G_GetGeometryType(hGeom)) )
-      == MS_FAILURE ) {
-    msFreeShape(shape);
-    free( shape );
-    shape = NULL;
-  }
-
-  OGR_G_DestroyGeometry( hGeom );
-
-  return shape;
-}
-
-/************************************************************************/
-/*                          msOGRShapeToWKT()                           */
-/************************************************************************/
-char *msOGRShapeToWKT(shapeObj *shape)
-{
-  OGRGeometryH hGeom = NULL;
-  int          i;
-  char        *wkt = NULL;
-
-  if(!shape)
-    return NULL;
-
-  if( shape->type == MS_SHAPE_POINT && shape->numlines == 1
-      && shape->line[0].numpoints == 1 ) {
-    hGeom = OGR_G_CreateGeometry( wkbPoint );
-    OGR_G_SetPoint_2D( hGeom, 0,
-                       shape->line[0].point[0].x,
-                       shape->line[0].point[0].y );
-  } else if( shape->type == MS_SHAPE_POINT && shape->numlines == 1
-             && shape->line[0].numpoints > 1 ) {
-    hGeom = OGR_G_CreateGeometry( wkbMultiPoint );
-    for( i = 0; i < shape->line[0].numpoints; i++ ) {
-      OGRGeometryH hPoint;
-
-      hPoint = OGR_G_CreateGeometry( wkbPoint );
-      OGR_G_SetPoint_2D( hPoint, 0,
-                         shape->line[0].point[i].x,
-                         shape->line[0].point[i].y );
-      OGR_G_AddGeometryDirectly( hGeom, hPoint );
-    }
-  } else if( shape->type == MS_SHAPE_LINE && shape->numlines == 1 ) {
-    hGeom = OGR_G_CreateGeometry( wkbLineString );
-    for( i = 0; i < shape->line[0].numpoints; i++ ) {
-      OGR_G_AddPoint_2D( hGeom,
-                         shape->line[0].point[i].x,
-                         shape->line[0].point[i].y );
-    }
-  } else if( shape->type == MS_SHAPE_LINE && shape->numlines > 1 ) {
-    OGRGeometryH hMultiLine = OGR_G_CreateGeometry( wkbMultiLineString );
-    int iLine;
-
-    for( iLine = 0; iLine < shape->numlines; iLine++ ) {
-      hGeom = OGR_G_CreateGeometry( wkbLineString );
-      for( i = 0; i < shape->line[iLine].numpoints; i++ ) {
-        OGR_G_AddPoint_2D( hGeom,
-                           shape->line[iLine].point[i].x,
-                           shape->line[iLine].point[i].y );
-      }
-
-      OGR_G_AddGeometryDirectly( hMultiLine, hGeom );
-    }
-
-    hGeom = hMultiLine;
-  } else if( shape->type == MS_SHAPE_POLYGON ) {
-    int iLine;
-
-    /* actually, it is pretty hard to be sure rings 1+ are interior */
-    hGeom = OGR_G_CreateGeometry( wkbPolygon );
-    for( iLine = 0; iLine < shape->numlines; iLine++ ) {
-      OGRGeometryH hRing;
-      hRing = OGR_G_CreateGeometry( wkbLinearRing );
-
-      for( i = 0; i < shape->line[iLine].numpoints; i++ ) {
-        OGR_G_AddPoint_2D( hRing,
-                           shape->line[iLine].point[i].x,
-                           shape->line[iLine].point[i].y );
-      }
-      OGR_G_AddGeometryDirectly( hGeom, hRing );
-    }
-  } else {
-    msSetError(MS_OGRERR, "OGR support is not available.", "msOGRShapeToWKT()");
-  }
-
-  if( hGeom != NULL ) {
-    char *pszOGRWkt;
-
-    OGR_G_ExportToWkt( hGeom, &pszOGRWkt );
-    wkt = msStrdup( pszOGRWkt );
-    CPLFree( pszOGRWkt );
-  }
-
-  return wkt;
-}
diff -pruN 8.0.1-5/mapogroutput.cpp 8.2.0~beta1-1~exp1/mapogroutput.cpp
--- 8.0.1-5/mapogroutput.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapogroutput.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1388 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGR Output (for WFS)
- * Author:   Frank Warmerdam (warmerdam@pobox.com)
- *
- **********************************************************************
- * Copyright (c) 2010, Frank Warmerdam <warmerdam@pobox.com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include <assert.h>
-#include "mapserver.h"
-#include "mapproject.h"
-#include "mapthread.h"
-#include "mapows.h"
-
-#include "ogr_api.h"
-#include "ogr_srs_api.h"
-#include "cpl_conv.h"
-#include "cpl_vsi.h"
-#include "cpl_string.h"
-
-#include <string>
-
-/************************************************************************/
-/*                   msInitDefaultOGROutputFormat()                     */
-/************************************************************************/
-
-int msInitDefaultOGROutputFormat( outputFormatObj *format )
-
-{
-  OGRSFDriverH   hDriver;
-
-  msOGRInitialize();
-
-  /* -------------------------------------------------------------------- */
-  /*      check that this driver exists.  Note visiting drivers should    */
-  /*      be pretty threadsafe so don't bother acquiring the GDAL         */
-  /*      lock.                                                           */
-  /* -------------------------------------------------------------------- */
-  hDriver = OGRGetDriverByName( format->driver+4 );
-  if( hDriver == NULL ) {
-    msSetError( MS_MISCERR, "No OGR driver named `%s' available.",
-                "msInitDefaultOGROutputFormat()", format->driver+4 );
-    return MS_FAILURE;
-  }
-
-  if( !OGR_Dr_TestCapability( hDriver, ODrCCreateDataSource ) ) {
-    msSetError( MS_MISCERR, "OGR `%s' driver does not support output.",
-                "msInitDefaultOGROutputFormat()", format->driver+4 );
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize the object.                                          */
-  /* -------------------------------------------------------------------- */
-  format->imagemode = MS_IMAGEMODE_FEATURE;
-  format->renderer = MS_RENDER_WITH_OGR;
-
-  /* perhaps we should eventually hardcode mimetypes and extensions
-     for some formats? */
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                        msCSLConcatenate()                            */
-/************************************************************************/
-
-static char** msCSLConcatenate( char** papszResult, char** papszToBeAdded )
-{
-    char** papszIter = papszToBeAdded;
-    while( papszIter && *papszIter )
-    {
-        papszResult = CSLAddString(papszResult, *papszIter);
-        papszIter ++;
-    }
-    return papszResult;
-}
-
-/************************************************************************/
-/*                       msOGRRecursiveFileList()                       */
-/*                                                                      */
-/*      Collect a list of all files under the named directory,          */
-/*      including those in subdirectories.                              */
-/************************************************************************/
-
-char **msOGRRecursiveFileList( const char *path )
-{
-  char **file_list;
-  char **result_list = NULL;
-  int i, count, change;
-
-  file_list = CPLReadDir( path );
-  count = CSLCount(file_list);
-
-  /* -------------------------------------------------------------------- */
-  /*      Sort the file list so we always get them back in the same       */
-  /*      order - it makes autotests more stable.                         */
-  /* -------------------------------------------------------------------- */
-  do {
-    change = 0;
-    for( i = 0; i < count-1; i++ ) {
-      if( strcasecmp(file_list[i],file_list[i+1]) > 0 ) {
-        char *temp = file_list[i];
-        file_list[i] = file_list[i+1];
-        file_list[i+1] = temp;
-        change = 1;
-      }
-    }
-  } while( change );
-
-  /* -------------------------------------------------------------------- */
-  /*      collect names we want and process subdirectories.               */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < count; i++ ) {
-    char full_filename[MS_MAXPATHLEN];
-    VSIStatBufL  sStatBuf;
-
-    if( EQUAL(file_list[i],".") || EQUAL(file_list[i],"..") )
-      continue;
-
-    strlcpy( full_filename,
-             CPLFormFilename( path, file_list[i], NULL ),
-             sizeof(full_filename) );
-
-    if( VSIStatL( full_filename, &sStatBuf ) != 0 )
-        continue;
-
-    if( VSI_ISREG( sStatBuf.st_mode ) ) {
-      result_list = CSLAddString( result_list, full_filename );
-    } else if( VSI_ISDIR( sStatBuf.st_mode ) ) {
-      char **subfiles = msOGRRecursiveFileList( full_filename );
-
-      result_list = msCSLConcatenate( result_list, subfiles );
-
-      CSLDestroy( subfiles );
-    }
-  }
-
-  CSLDestroy( file_list );
-
-  return result_list;
-}
-
-/************************************************************************/
-/*                           msOGRCleanupDS()                           */
-/************************************************************************/
-static void msOGRCleanupDS( const char *datasource_name )
-
-{
-  char **file_list;
-  char path[MS_MAXPATHLEN];
-  int i;
-  VSIStatBufL sStatBuf;
-  
-  if( VSIStatL( datasource_name, &sStatBuf ) != 0 )
-    return;
-  if( VSI_ISDIR( sStatBuf.st_mode ) )
-    strlcpy( path, datasource_name, sizeof(path) );
-  else
-    strlcpy( path, CPLGetPath( datasource_name ), sizeof(path) );
-
-  file_list = CPLReadDir( path );
-
-  for( i = 0; file_list != NULL && file_list[i] != NULL; i++ ) {
-    char full_filename[MS_MAXPATHLEN];
-    VSIStatBufL  sStatBuf;
-
-    if( EQUAL(file_list[i],".") || EQUAL(file_list[i],"..") )
-      continue;
-
-    strlcpy( full_filename,
-             CPLFormFilename( path, file_list[i], NULL ),
-             sizeof(full_filename) );
-
-    if( VSIStatL( full_filename, &sStatBuf ) != 0 )
-      continue;
-
-    if( VSI_ISREG( sStatBuf.st_mode ) ) {
-      VSIUnlink( full_filename );
-    } else if( VSI_ISDIR( sStatBuf.st_mode ) ) {
-      msOGRCleanupDS( full_filename );
-    }
-  }
-
-  CSLDestroy( file_list );
-
-  VSIRmdir( path );
-}
-
-/************************************************************************/
-/*                          msOGRSetPoints()                            */
-/************************************************************************/
-
-static void msOGRSetPoints( OGRGeometryH hGeom, lineObj *line, int bWant2DOutput)
-{
-    int i;
-    if( bWant2DOutput )
-    {
-      for( i = 0; i < line->numpoints; i++ ) {
-        OGR_G_SetPoint_2D( hGeom, i,
-                           line->point[i].x,
-                           line->point[i].y );
-      }
-    }
-    else {
-      for( i = 0; i < line->numpoints; i++ ) {
-        OGR_G_SetPoint( hGeom, i,
-                        line->point[i].x,
-                        line->point[i].y,
-                        line->point[i].z
-                      );
-      }
-    }
-}
-
-/************************************************************************/
-/*                          msOGRWriteShape()                           */
-/************************************************************************/
-
-static int msOGRWriteShape( OGRLayerH hOGRLayer,
-                            shapeObj *shape, gmlItemListObj *item_list,
-                            int nFirstOGRFieldIndex, const char *pszFeatureid,
-                            bool geomTypeForced )
-
-{
-  OGRGeometryH hGeom = NULL;
-  OGRFeatureH hFeat;
-  OGRErr eErr;
-  int i, out_field;
-  OGRwkbGeometryType eLayerGType, eFlattenLayerGType;
-  OGRFeatureDefnH hLayerDefn;
-  int bWant2DOutput;
-
-  hLayerDefn = OGR_L_GetLayerDefn( hOGRLayer );
-  eLayerGType = OGR_FD_GetGeomType(hLayerDefn);
-  eFlattenLayerGType = wkbFlatten(eLayerGType);
-  bWant2DOutput = (eLayerGType == eFlattenLayerGType);
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform point geometry.                                       */
-  /* -------------------------------------------------------------------- */
-  if( shape->type == MS_SHAPE_POINT ) {
-    OGRGeometryH hMP = NULL;
-    int j;
-
-    if( shape->numlines == 1 && shape->line[0].numpoints > 1 )
-    {
-      hGeom = OGR_G_CreateGeometry( wkbMultiPoint );
-      for( j = 0; j < shape->line[0].numpoints; j++ ) {
-        OGRGeometryH hPoint = OGR_G_CreateGeometry( wkbPoint );
-        if( bWant2DOutput ) {
-            OGR_G_SetPoint_2D( hPoint, 0,
-                            shape->line[0].point[j].x,
-                            shape->line[0].point[j].y );
-        }
-        else {
-            OGR_G_SetPoint( hPoint, 0,
-                            shape->line[0].point[j].x,
-                            shape->line[0].point[j].y,
-                            shape->line[0].point[j].z
-                            );
-        }
-
-        OGR_G_AddGeometryDirectly( hGeom, hPoint );
-      }
-    }
-    else
-    {
-      if( shape->numlines > 1 )
-        hMP = OGR_G_CreateGeometry( wkbMultiPoint );
-
-      for( j = 0; j < shape->numlines; j++ ) {
-        if( shape->line[j].numpoints != 1 ) {
-          msSetError(MS_MISCERR,
-                    "Failed on odd point geometry.",
-                    "msOGRWriteShape()");
-          return MS_FAILURE;
-        }
-
-        hGeom = OGR_G_CreateGeometry( wkbPoint );
-        if( bWant2DOutput ) {
-            OGR_G_SetPoint_2D( hGeom, 0,
-                            shape->line[j].point[0].x,
-                            shape->line[j].point[0].y );
-        }
-        else {
-            OGR_G_SetPoint( hGeom, 0,
-                            shape->line[j].point[0].x,
-                            shape->line[j].point[0].y,
-                            shape->line[j].point[0].z
-                            );
-        }
-
-        if( hMP != NULL ) {
-            OGR_G_AddGeometryDirectly( hMP, hGeom );
-        }
-      }
-      
-      if( hMP != NULL )
-        hGeom = hMP;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform line geometry.                                        */
-  /* -------------------------------------------------------------------- */
-  else if(  shape->type == MS_SHAPE_LINE ) {
-    OGRGeometryH hML = NULL;
-    int j;
-
-    if( shape->numlines > 1 )
-      hML = OGR_G_CreateGeometry( wkbMultiLineString );
-
-    for( j = 0; j < shape->numlines; j++ ) {
-
-      if( shape->line[j].numpoints < 2 ) {
-        msSetError(MS_MISCERR,
-                   "Failed on odd line geometry.",
-                   "msOGRWriteShape()");
-        return MS_FAILURE;
-      }
-
-      hGeom = OGR_G_CreateGeometry( wkbLineString );
-
-      msOGRSetPoints( hGeom, &(shape->line[j]), bWant2DOutput);
-
-      if( hML != NULL ) {
-        OGR_G_AddGeometryDirectly( hML, hGeom );
-        hGeom = hML;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform polygon geometry.                                     */
-  /* -------------------------------------------------------------------- */
-  else if( shape->type == MS_SHAPE_POLYGON ) {
-    int iRing, iOuter;
-    int *outer_flags;
-    OGRGeometryH hMP = NULL;
-
-    outer_flags = msGetOuterList( shape );
-
-    for( iOuter = 0; iOuter < shape->numlines; iOuter++ ) {
-      int *inner_flags;
-      OGRGeometryH hRing;
-
-      if( !outer_flags[iOuter] )
-        continue;
-
-      if( hGeom != nullptr )
-      {
-          assert( hMP == nullptr );
-          hMP = OGR_G_CreateGeometry( wkbMultiPolygon );
-          OGR_G_AddGeometryDirectly( hMP, hGeom );
-      }
-      hGeom = OGR_G_CreateGeometry( wkbPolygon );
-
-      /* handle outer ring */
-
-      hRing = OGR_G_CreateGeometry( wkbLinearRing );
-
-      msOGRSetPoints( hRing, &(shape->line[iOuter]), bWant2DOutput);
-
-      OGR_G_AddGeometryDirectly( hGeom, hRing );
-
-
-      /* handle inner rings (holes) */
-      inner_flags = msGetInnerList( shape, iOuter, outer_flags );
-
-      for( iRing = 0; iRing < shape->numlines; iRing++ ) {
-        if( !inner_flags[iRing] )
-          continue;
-
-        hRing = OGR_G_CreateGeometry( wkbLinearRing );
-
-        msOGRSetPoints( hRing, &(shape->line[iRing]), bWant2DOutput);
-
-        OGR_G_AddGeometryDirectly( hGeom, hRing );
-      }
-
-      free(inner_flags);
-
-      if( hMP )
-      {
-          OGR_G_AddGeometryDirectly( hMP, hGeom );
-          hGeom = nullptr;
-      }
-    }
-
-    free(outer_flags);
-
-    if( hMP != nullptr )
-    {
-        assert( hGeom == nullptr );
-        hGeom = hMP;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Consider trying to force the geometry to a new type if it       */
-  /*      doesn't match the layer.                                        */
-  /* -------------------------------------------------------------------- */
-  if( hGeom != NULL ) {
-    OGRwkbGeometryType eFlattenFeatureGType =
-        wkbFlatten(OGR_G_GetGeometryType( hGeom ));
-
-    if( eFlattenFeatureGType != eFlattenLayerGType ) {
-      if( eFlattenLayerGType == wkbPolygon && geomTypeForced )
-        hGeom = OGR_G_ForceToPolygon( hGeom );
-
-      else if( eFlattenLayerGType == wkbMultiPolygon )
-        hGeom = OGR_G_ForceToMultiPolygon( hGeom );
-
-      else if( eFlattenLayerGType == wkbMultiPoint )
-        hGeom = OGR_G_ForceToMultiPoint( hGeom );
-
-      else if( eFlattenLayerGType == wkbMultiLineString )
-        hGeom = OGR_G_ForceToMultiLineString( hGeom );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Consider flattening the geometry to 2D if we want 2D            */
-  /*      output.                                                         */
-  /*      Note: this shouldn't be called in recent OGR versions where     */
-  /*      OGR_G_SetPoint_2D is properly honoured.                         */
-  /* -------------------------------------------------------------------- */
-
-  if( bWant2DOutput && hGeom != NULL ) {
-    OGRwkbGeometryType eFeatureGType = OGR_G_GetGeometryType( hGeom );
-    if( eFeatureGType != wkbFlatten(eFeatureGType) )
-      OGR_G_FlattenTo2D( hGeom );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create the feature, and attach the geometry.                    */
-  /* -------------------------------------------------------------------- */
-  hFeat = OGR_F_Create( hLayerDefn );
-
-  OGR_F_SetGeometryDirectly( hFeat, hGeom );
-
-  /* -------------------------------------------------------------------- */
-  /*      Set attributes.                                                 */
-  /* -------------------------------------------------------------------- */
-  out_field = nFirstOGRFieldIndex;
-  for( i = 0; i < item_list->numitems; i++ ) {
-    gmlItemObj *item = item_list->items + i;
-
-    if(pszFeatureid && !strcmp(pszFeatureid, item->name)) {
-      char *endptr;
-      long feature_id = strtol(shape->values[i],&endptr,10);
-      if(endptr && *endptr==0) {
-        /* only set the featureid if it is numeric */
-        OGR_F_SetFID(hFeat, feature_id);
-      }
-    }
-
-    if( !item->visible )
-      continue;
-
-    /* Avoid setting empty strings for numeric fields, so that OGR */
-    /* doesn't take them as 0. (#4633) */
-    if( shape->values[i][0] == '\0' ) {
-      OGRFieldDefnH hFieldDefn = OGR_FD_GetFieldDefn(hLayerDefn, out_field);
-      OGRFieldType eFieldType = OGR_Fld_GetType(hFieldDefn);
-      if( eFieldType == OFTInteger || eFieldType == OFTReal
-          || eFieldType == OFTInteger64
-          )
-      {
-        out_field++;
-        continue;
-      }
-    }
-
-    OGR_F_SetFieldString( hFeat, out_field++, shape->values[i] );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out and cleanup.                                          */
-  /* -------------------------------------------------------------------- */
-  eErr = OGR_L_CreateFeature( hOGRLayer, hFeat );
-
-  OGR_F_Destroy( hFeat );
-
-  if( eErr != OGRERR_NONE ) {
-    msSetError( MS_OGRERR,
-                "Attempt to write feature failed (code=%d):\n%s",
-                "msOGRWriteShape()",
-                (int) eErr,
-                CPLGetLastErrorMsg() );
-  }
-
-  if( eErr == OGRERR_NONE )
-    return MS_SUCCESS;
-  else
-    return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                        msOGRStdoutWriteFunction()                    */
-/************************************************************************/
-
-/* Used by /vsistdout/ */
-static size_t msOGRStdoutWriteFunction(const void* ptr, size_t size, size_t nmemb, FILE* stream)
-{
-    msIOContext *ioctx = (msIOContext*) stream;
-    return msIO_contextWrite(ioctx, ptr, size * nmemb ) / size;
-}
-
-/************************************************************************/
-/*                      msOGROutputGetAdditonalFiles()                  */
-/*                                                                      */
-/*  Collect additional files specified in                               */
-/*  wfs/ows_additional_files_in_output of WEB.METADATA and LAYER.METADATA */
-/************************************************************************/
-
-/* Result to be freed with CSLDestroy() */
-static char** msOGROutputGetAdditonalFiles( mapObj *map )
-{
-    int i;
-    hashTableObj* hSetAdditionalFiles;
-    char** papszFiles = NULL;
-
-    hSetAdditionalFiles = msCreateHashTable();
-
-    for( i = -1; i < map->numlayers; i++ )
-    {
-        const char* value;
-        if( i < 0 )
-        {
-            value = msOWSLookupMetadata(&(map->web.metadata), "FO", "additional_files_in_output");
-        }
-        else
-        {
-            layerObj *layer = GET_LAYER(map, i);
-            if( !layer->resultcache || layer->resultcache->numresults == 0 )
-                continue;
-            value = msOWSLookupMetadata(&(layer->metadata), "FO", "additional_files_in_output");
-        }
-
-        if( value != NULL )
-        {
-            char** papszList = CSLTokenizeString2( value, ",", CSLT_HONOURSTRINGS );
-            char** papszListIter = papszList;
-            while( papszListIter && *papszListIter )
-            {
-                const char* file = *papszListIter;
-                VSIStatBufL sStat;
-
-                if( strncmp(file, "http://", strlen("http://")) == 0 ||
-                    strncmp(file, "https://", strlen("https://")) == 0 )
-                {
-                    /* Remote file ? We will use /vsicurl_streaming/ to read it */
-                    if( msLookupHashTable(hSetAdditionalFiles, file) == NULL )
-                    {
-                        msInsertHashTable(hSetAdditionalFiles, file, "YES");
-                        papszFiles = CSLAddString(papszFiles, CPLSPrintf("/vsicurl_streaming/%s", file));
-                    }
-                }
-                else
-                {
-                    int nLen = (int)strlen(file);
-                    char filename[MS_MAXPATHLEN];
-
-                    if( CPLIsFilenameRelative(file) )
-                    {
-                        if( !map->shapepath )
-                            msTryBuildPath(filename, map->mappath, file);
-                        else
-                            msTryBuildPath3(filename, map->mappath, map->shapepath, file);
-                    }
-                    else
-                        strlcpy(filename, file, MS_MAXPATHLEN);
-
-                    if( nLen > 2 && (
-                            strcmp(file + nLen - 1, "/") == 0 ||
-                            strcmp(file + nLen - 2, "/*") == 0 ) )
-                    {
-                        *strrchr(filename, '/') = '\0';
-                    }
-                    else if( nLen > 2 && (
-                            strcmp(file + nLen - 1, "\\") == 0 ||
-                            strcmp(file + nLen - 2, "\\*") == 0 ) )
-                    {
-                        *strrchr(filename, '\\') = '\0';
-                    }
-
-                    if( msLookupHashTable(hSetAdditionalFiles, filename) == NULL )
-                    {
-                        msInsertHashTable(hSetAdditionalFiles, filename, "YES");
-                        if( VSIStatL( filename, &sStat ) == 0 )
-                        {
-                            if( VSI_ISDIR( sStat.st_mode ) )
-                            {
-                                char** papszDirContent = msOGRRecursiveFileList(filename);
-                                papszFiles = msCSLConcatenate(papszFiles, papszDirContent);
-                                CSLDestroy(papszDirContent);
-                            }
-                            else
-                            {
-                                papszFiles = CSLAddString(papszFiles, filename);
-                            }
-                        }
-                        else
-                        {
-                            msDebug("File %s does not exist.\n", filename);
-                        }
-                    }
-                }
-
-                papszListIter ++;
-            }
-            CSLDestroy(papszList);
-        }
-    }
-    
-    msFreeHashTable(hSetAdditionalFiles);
-    
-    return papszFiles;
-}
-
-/************************************************************************/
-/*                        msOGRWriteFromQuery()                         */
-/************************************************************************/
-
-int msOGRWriteFromQuery( mapObj *map, outputFormatObj *format, int sendheaders )
-
-{
-  /* -------------------------------------------------------------------- */
-  /*      Variable declarations.                                          */
-  /* -------------------------------------------------------------------- */
-  OGRSFDriverH hDriver;
-  OGRDataSourceH hDS;
-  const char *storage;
-  const char *fo_filename;
-  const char *form;
-  char datasource_name[MS_MAXPATHLEN];
-  char base_dir[MS_MAXPATHLEN];
-  char *request_dir = NULL;
-  char **ds_options = NULL;
-  char **layer_options = NULL;
-  char **file_list = NULL;
-  int iLayer, i;
-  int bDataSourceNameIsRequestDir = FALSE;
-  int bUseFeatureId = MS_FALSE;
-  const char* pszMatchingFeatures;
-  int nMatchingFeatures = -1;
-  const char* pszFormatName = format->driver+4;
-  
-  pszMatchingFeatures = msGetOutputFormatOption(format, "_matching_features_", "");
-  if( pszMatchingFeatures[0] != '\0' )
-      nMatchingFeatures = atoi(pszMatchingFeatures);
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch the output format driver.                                 */
-  /* -------------------------------------------------------------------- */
-  msOGRInitialize();
-
-  hDriver = OGRGetDriverByName( pszFormatName );
-  if( hDriver == NULL ) {
-    msSetError( MS_MISCERR, "No OGR driver named `%s' available.",
-                "msOGRWriteFromQuery()", pszFormatName );
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Capture datasource and layer creation options.                  */
-  /* -------------------------------------------------------------------- */
-  for( i=0; i < format->numformatoptions; i++ ) {
-    if( strncasecmp(format->formatoptions[i],"LCO:",4) == 0 )
-      layer_options = CSLAddString( layer_options,
-                                    format->formatoptions[i] + 4 );
-    if( strncasecmp(format->formatoptions[i],"DSCO:",5) == 0 )
-      ds_options = CSLAddString( ds_options,
-                                 format->formatoptions[i] + 5 );
-  }
-  if( EQUAL(pszFormatName, "GeoJSON") && nMatchingFeatures >= 0 )
-  {
-      const char* pszNativeData =
-        CSLFetchNameValueDef(layer_options, "NATIVE_DATA", "{}");
-      if( pszNativeData[strlen(pszNativeData)-1] == '}' )
-      {
-          std::string tmpl(pszNativeData);
-          tmpl.resize(tmpl.size() - 1);
-          if( strlen(pszNativeData) > 2 )
-              tmpl += ',';
-          tmpl += "\"numberMatched\":";
-          tmpl += std::to_string(nMatchingFeatures);
-          tmpl += '}';
-          layer_options = CSLSetNameValue(layer_options,
-                                          "NATIVE_MEDIA_TYPE",
-                                          "application/vnd.geo+json");
-          layer_options = CSLSetNameValue(layer_options,
-                                          "NATIVE_DATA",
-                                          tmpl.c_str());
-      }
-  }
-  if(!strcasecmp("true",msGetOutputFormatOption(format,"USE_FEATUREID","false"))) {
-    bUseFeatureId = MS_TRUE;
-  }
-
-  /* ==================================================================== */
-  /*      Determine the output datasource name to use.                    */
-  /* ==================================================================== */
-  storage = msGetOutputFormatOption( format, "STORAGE", "filesystem" );
-  if( EQUAL(storage,"stream") && !msIO_isStdContext() ) {
-    msIOContext *ioctx = msIO_getHandler (stdout);
-    if( ioctx != NULL )
-        VSIStdoutSetRedirection( msOGRStdoutWriteFunction, (FILE*)ioctx );
-    else
-    /* bug #4858, streaming output won't work if standard output has been
-     * redirected, we switch to memory output in this case
-     */
-    storage = "memory";
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Where are we putting stuff?                                     */
-  /* -------------------------------------------------------------------- */
-  if( EQUAL(storage,"filesystem") ) {
-    base_dir[0] = '\0' ;
-  } else if( EQUAL(storage,"memory") ) {
-    strcpy( base_dir, "/vsimem/ogr_out/" );
-  } else if( EQUAL(storage,"stream") ) {
-    /* handled later */
-  } else {
-    msSetError( MS_MISCERR,
-                "STORAGE=%s value not supported.",
-                "msOGRWriteFromQuery()",
-                storage );
-    CSLDestroy(layer_options);
-    CSLDestroy(ds_options);
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create a subdirectory to handle this request.                   */
-  /* -------------------------------------------------------------------- */
-  if( !EQUAL(storage,"stream") ) {
-    const char* dir_to_create;
-    if (strlen(base_dir) > 0)
-      request_dir = msTmpFile(map, NULL, base_dir, "" );
-    else
-      request_dir = msTmpFile(map, NULL, NULL, "" );
-
-    if( request_dir[strlen(request_dir)-1] == '.' )
-      request_dir[strlen(request_dir)-1] = '\0';
-
-    dir_to_create = request_dir;
-    /* Workaround issue in GDAL versions released at this time :
-     * GDAL issue fixed per https://trac.osgeo.org/gdal/ticket/6991 */
-    if( EQUAL(storage,"memory") && EQUAL(format->driver+4, "ESRI Shapefile") )
-    {
-        dir_to_create = base_dir;
-    }
-
-    if( VSIMkdir( dir_to_create, 0777 ) != 0 ) {
-      msSetError( MS_MISCERR,
-                  "Attempt to create directory '%s' failed.",
-                  "msOGRWriteFromQuery()",
-                  dir_to_create );
-      msFree(request_dir);
-      CSLDestroy(layer_options);
-      CSLDestroy(ds_options);
-      return MS_FAILURE;
-    }
-  }
-  /*  else handled later */
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup the full datasource name.                                 */
-  /* -------------------------------------------------------------------- */
-  form = msGetOutputFormatOption( format, "FORM", "zip" );
-
-  if( EQUAL(form,"zip") )
-    fo_filename = msGetOutputFormatOption( format, "FILENAME", "result.zip" );
-  else
-    fo_filename = msGetOutputFormatOption( format, "FILENAME", "result.dat" );
-
-  /* Validate that the filename does not contain any directory */
-  /* information, which might lead to removal of unwanted files. (#4086) */
-  if( strchr(fo_filename, '/') != NULL || strchr(fo_filename, ':') != NULL ||
-        strchr(fo_filename, '\\') != NULL ) {
-    msSetError( MS_MISCERR,
-           "Invalid value for FILENAME option. "
-           "It must not contain any directory information.",
-           "msOGRWriteFromQuery()" );
-    msFree(request_dir);
-    CSLDestroy(layer_options);
-    CSLDestroy(ds_options);
-    return MS_FAILURE;
-  }
-
-  if( !EQUAL(storage,"stream") )
-  {
-    msBuildPath( datasource_name, request_dir, fo_filename );
-
-    if( EQUAL(form,"zip") )
-    {
-      /* if generating a zip file, remove the zip extension for the internal */
-      /* filename */
-      if( EQUAL(CPLGetExtension(datasource_name), "zip") ) {
-        *strrchr(datasource_name, '.') = '\0';
-      }
-
-      /* and add .dat extension if user didn't provide another extension */
-      if( EQUAL(CPLGetExtension(datasource_name), "") ) {
-        strcat(datasource_name, ".dat");
-      }
-    }
-
-    /* Shapefile and MapInfo driver only properly work with multiple layers */
-    /* if the output dataset name is a directory */
-    if( EQUAL(format->driver+4, "ESRI Shapefile") ||
-        EQUAL(format->driver+4, "MapInfo File") )
-    {
-        bDataSourceNameIsRequestDir = TRUE;
-        strcpy(datasource_name, request_dir);
-    }
-  }
-  else
-    strcpy( datasource_name, "/vsistdout/" );
-
-  msFree( request_dir );
-  request_dir = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Emit content type headers for stream output now.                */
-  /* -------------------------------------------------------------------- */
-  if( EQUAL(storage,"stream") ) {
-    if( sendheaders && format->mimetype ) {
-      msIO_setHeader("Content-Type","%s",format->mimetype);
-      msIO_sendHeaders();
-    } else
-      msIO_fprintf( stdout, "%c", 10 );
-  }
-
-  /* ==================================================================== */
-  /*      Create the datasource.                                          */
-  /* ==================================================================== */
-  hDS = OGR_Dr_CreateDataSource( hDriver,  datasource_name, ds_options );
-  CSLDestroy( ds_options );
-
-  if( hDS == NULL ) {
-    msOGRCleanupDS( datasource_name );
-    msSetError( MS_MISCERR,
-                "OGR CreateDataSource failed for '%s' with driver '%s'.",
-                "msOGRWriteFromQuery()",
-                datasource_name,
-                format->driver+4 );
-    CSLDestroy(layer_options);
-    return MS_FAILURE;
-  }
-
-  /* ==================================================================== */
-  /*      Process each layer with a resultset.                            */
-  /* ==================================================================== */
-  for( iLayer = 0; iLayer < map->numlayers; iLayer++ ) {
-    int status = 0;
-    layerObj *layer = GET_LAYER(map, iLayer);
-    shapeObj resultshape;
-    OGRLayerH hOGRLayer;
-    OGRwkbGeometryType eGeomType;
-    OGRSpatialReferenceH srs = NULL;
-    gmlItemListObj *item_list = NULL;
-    const char *value;
-    char *pszWKT;
-    int  nFirstOGRFieldIndex = -1;
-    const char *pszFeatureid = NULL;
-
-    if( !layer->resultcache )
-      continue;
-
-    /* -------------------------------------------------------------------- */
-    /*      Will we need to reproject?                                      */
-    /* -------------------------------------------------------------------- */
-    if(layer->transform == MS_TRUE)
-        layer->project = msProjectionsDiffer(&(layer->projection),
-                               &(layer->map->projection));
-
-    /* -------------------------------------------------------------------- */
-    /*      Establish the geometry type to use for the created layer.       */
-    /*      First we consult the wfs_geomtype field and fallback to         */
-    /*      deriving something from the type of the mapserver layer.        */
-    /* -------------------------------------------------------------------- */
-    value = msOWSLookupMetadata(&(layer->metadata), "FOG", "geomtype");
-    bool geomTypeForced = true;
-    if( value == NULL ) {
-      geomTypeForced = false;
-      if( layer->type == MS_LAYER_POINT )
-        value = "Point";
-      else if( layer->type == MS_LAYER_LINE )
-        value = "LineString";
-      else if( layer->type == MS_LAYER_POLYGON )
-        value = "Polygon";
-      else
-        value = "Geometry";
-    }
-
-    if(bUseFeatureId)
-      pszFeatureid = msOWSLookupMetadata(&(layer->metadata), "FOG", "featureid");
-
-    if( strcasecmp(value,"Point") == 0 )
-      eGeomType = wkbPoint;
-    else if( strcasecmp(value,"LineString") == 0 )
-      eGeomType = wkbLineString;
-    else if( strcasecmp(value,"Polygon") == 0 )
-      eGeomType = wkbPolygon;
-    else if( strcasecmp(value,"MultiPoint") == 0 )
-      eGeomType = wkbMultiPoint;
-    else if( strcasecmp(value,"MultiLineString") == 0 )
-      eGeomType = wkbMultiLineString;
-    else if( strcasecmp(value,"MultiPolygon") == 0 )
-      eGeomType = wkbMultiPolygon;
-    else if( strcasecmp(value,"GeometryCollection") == 0 )
-      eGeomType = wkbGeometryCollection;
-    else if( strcasecmp(value,"Point25D") == 0 )
-      eGeomType = wkbPoint25D;
-    else if( strcasecmp(value,"LineString25D") == 0 )
-      eGeomType = wkbLineString25D;
-    else if( strcasecmp(value,"Polygon25D") == 0 )
-      eGeomType = wkbPolygon25D;
-    else if( strcasecmp(value,"MultiPoint25D") == 0 )
-      eGeomType = wkbMultiPoint25D;
-    else if( strcasecmp(value,"MultiLineString25D") == 0 )
-      eGeomType = wkbMultiLineString25D;
-    else if( strcasecmp(value,"MultiPolygon25D") == 0 )
-      eGeomType = wkbMultiPolygon25D;
-    else if( strcasecmp(value,"GeometryCollection25D") == 0 )
-      eGeomType = wkbGeometryCollection25D;
-    else if( strcasecmp(value,"Unknown") == 0
-             || strcasecmp(value,"Geometry") == 0 )
-      eGeomType = wkbUnknown;
-    else if( strcasecmp(value,"None") == 0 )
-      eGeomType = wkbNone;
-    else
-      eGeomType = wkbUnknown;
-
-    /* -------------------------------------------------------------------- */
-    /*      Create a spatial reference.                                     */
-    /* -------------------------------------------------------------------- */
-    pszWKT = msProjectionObj2OGCWKT( &(map->projection) );
-    if( pszWKT != NULL ) {
-      srs = OSRNewSpatialReference( pszWKT );
-      msFree( pszWKT );
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Create the corresponding OGR Layer.                             */
-    /* -------------------------------------------------------------------- */
-    hOGRLayer = OGR_DS_CreateLayer( hDS, layer->name, srs, eGeomType,
-                                    layer_options );
-    if( hOGRLayer == NULL ) {
-      OGR_DS_Destroy( hDS );
-      msOGRCleanupDS( datasource_name );
-      msSetError( MS_MISCERR,
-                  "OGR OGR_DS_CreateLayer failed for layer '%s' with driver '%s'.",
-                  "msOGRWriteFromQuery()",
-                  layer->name,
-                  format->driver+4 );
-      CSLDestroy(layer_options);
-      return MS_FAILURE;
-    }
-
-    if( srs != NULL )
-      OSRRelease( srs );
-
-    /* -------------------------------------------------------------------- */
-    /*      Create appropriate attributes on this layer.                    */
-    /* -------------------------------------------------------------------- */
-    item_list = msGMLGetItems( layer, "G" );
-    assert( item_list->numitems == layer->numitems );
-
-    for( i = 0; i < layer->numitems; i++ ) {
-      OGRFieldDefnH hFldDefn;
-      OGRErr eErr;
-      const char *name;
-      gmlItemObj *item = item_list->items + i;
-      OGRFieldType eType;
-
-      if( !item->visible )
-        continue;
-
-      if( item->alias )
-        name = item->alias;
-      else
-        name = item->name;
-
-      if( item->type == NULL )
-        eType = OFTString;
-      else if( EQUAL(item->type,"Integer") )
-        eType = OFTInteger;
-      else if( EQUAL(item->type,"Long") )
-        eType = OFTInteger64;
-      else if( EQUAL(item->type,"Real") )
-        eType = OFTReal;
-      else if( EQUAL(item->type,"Character") )
-        eType = OFTString;
-      else if( EQUAL(item->type,"Date") )
-        eType = OFTDate;
-      else if( EQUAL(item->type,"Time") )
-        eType = OFTTime;
-      else if( EQUAL(item->type,"DateTime") )
-        eType = OFTDateTime;
-      else if( EQUAL(item->type,"Boolean") )
-        eType = OFTInteger;
-      else
-        eType = OFTString;
-
-      hFldDefn = OGR_Fld_Create( name, eType );
-
-      if( item->width != 0 )
-        OGR_Fld_SetWidth( hFldDefn, item->width );
-      if( item->precision != 0 )
-        OGR_Fld_SetPrecision( hFldDefn, item->precision );
-
-      eErr = OGR_L_CreateField( hOGRLayer, hFldDefn, TRUE );
-      OGR_Fld_Destroy( hFldDefn );
-
-      if( eErr != OGRERR_NONE ) {
-        msSetError( MS_OGRERR,
-                    "Failed to create field '%s' in output feature schema:\n%s",
-                    "msOGRWriteFromQuery()",
-                    layer->items[i],
-                    CPLGetLastErrorMsg() );
-
-        OGR_DS_Destroy( hDS );
-        msOGRCleanupDS( datasource_name );
-        msGMLFreeItems(item_list);
-        CSLDestroy(layer_options);
-        return MS_FAILURE;
-      }
-
-      /* The index of the first field we create is not necessarily 0 */
-      if( nFirstOGRFieldIndex < 0 )
-          nFirstOGRFieldIndex = OGR_FD_GetFieldCount(
-                                        OGR_L_GetLayerDefn( hOGRLayer ) ) - 1;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Setup joins if needed.  This is likely untested.                */
-    /* -------------------------------------------------------------------- */
-    if(layer->numjoins > 0) {
-      int j;
-      for(j=0; j<layer->numjoins; j++) {
-        status = msJoinConnect(layer, &(layer->joins[j]));
-        if(status != MS_SUCCESS) {
-          OGR_DS_Destroy( hDS );
-          msOGRCleanupDS( datasource_name );
-          msGMLFreeItems(item_list);
-          CSLDestroy(layer_options);
-          return status;
-        }
-      }
-    }
-
-    msInitShape( &resultshape );
-
-    /* -------------------------------------------------------------------- */
-    /*      Loop over all the shapes in the resultcache.                    */
-    /* -------------------------------------------------------------------- */
-    for(i=0; i < layer->resultcache->numresults; i++) {
-
-      msFreeShape(&resultshape); /* init too */
-
-      /*
-      ** Read the shape.
-      */
-      if( layer->resultcache->results[i].shape )
-      {
-          /* msDebug("Using cached shape %ld\n", layer->resultcache->results[i].shapeindex); */
-          status = msCopyShape(layer->resultcache->results[i].shape, &resultshape);
-      }
-      else
-      {
-          status = msLayerGetShape(layer, &resultshape, &(layer->resultcache->results[i]));
-      }
-      
-      if(status != MS_SUCCESS) {
-          OGR_DS_Destroy( hDS );
-          msOGRCleanupDS( datasource_name );
-          msGMLFreeItems(item_list);
-          msFreeShape(&resultshape);
-          CSLDestroy(layer_options);
-          return status;
-      }      
-
-      /*
-      ** Perform classification, and some annotation related magic.
-      */
-      resultshape.classindex =
-        msShapeGetClass(layer, map, &resultshape, NULL, -1);
-
-      if( resultshape.classindex >= 0
-          && (layer->_class[resultshape.classindex]->text.string
-              || layer->labelitem)
-          && layer->_class[resultshape.classindex]->numlabels > 0
-          && layer->_class[resultshape.classindex]->labels[0]->size != -1 ) {
-        resultshape.text = msShapeGetLabelAnnotation(layer,&resultshape,layer->_class[resultshape.classindex]->labels[0]);
-      }
-
-      /*
-      ** prepare any necessary JOINs here (one-to-one only)
-      */
-      if( layer->numjoins > 0) {
-        int j;
-
-        for(j=0; j < layer->numjoins; j++) {
-          if(layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
-            msJoinPrepare(&(layer->joins[j]), &resultshape);
-            msJoinNext(&(layer->joins[j])); /* fetch the first row */
-          }
-        }
-      }
-
-      if( layer->project && resultshape.type != MS_SHAPE_NULL) {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &layer->map->projection);
-        }
-        if( layer->reprojectorLayerToMap )
-            status = msProjectShapeEx(layer->reprojectorLayerToMap, &resultshape);
-        else
-            status = MS_FAILURE;
-      }
-
-      /*
-      ** Write out the feature to OGR.
-      */
-
-      if( status == MS_SUCCESS )
-        status = msOGRWriteShape( hOGRLayer, &resultshape,
-                                  item_list, nFirstOGRFieldIndex, pszFeatureid,
-                                  geomTypeForced );
-
-      if(status != MS_SUCCESS) {
-        OGR_DS_Destroy( hDS );
-        msOGRCleanupDS( datasource_name );
-        msGMLFreeItems(item_list);
-        msFreeShape(&resultshape);
-        CSLDestroy(layer_options);
-        return status;
-      }
-    }
-
-    msGMLFreeItems(item_list);
-    msFreeShape(&resultshape); /* init too */
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Close the datasource.                                           */
-  /* -------------------------------------------------------------------- */
-  OGR_DS_Destroy( hDS );
-
-  CSLDestroy( layer_options );
-
-  /* -------------------------------------------------------------------- */
-  /*      Get list of resulting files.                                    */
-  /* -------------------------------------------------------------------- */
-
-  if( EQUAL(form,"simple") ) {
-    file_list = CSLAddString( NULL, datasource_name );
-  } else {
-    char datasource_path[MS_MAXPATHLEN];
-
-    if( bDataSourceNameIsRequestDir )
-        file_list = msOGRRecursiveFileList( datasource_name );
-    else
-    {
-        strncpy( datasource_path, CPLGetPath( datasource_name ), MS_MAXPATHLEN-1 );
-        file_list = msOGRRecursiveFileList( datasource_path );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If our "storage" is stream then the output has already been     */
-  /*      sent back to the client and we don't need to copy it now.       */
-  /* -------------------------------------------------------------------- */
-  if( EQUAL(storage,"stream") ) {
-    /* already done */
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle case of simple file written to stdout.                   */
-  /* -------------------------------------------------------------------- */
-  else if( EQUAL(form,"simple") ) {
-    char buffer[1024];
-    int  bytes_read;
-    VSILFILE *fp;
-    const char *jsonp;
-
-    jsonp = msGetOutputFormatOption( format, "JSONP", NULL );
-    if( sendheaders ) {
-      if( !jsonp )
-      msIO_setHeader("Content-Disposition","attachment; filename=%s",
-                     CPLGetFilename( file_list[0] ) );
-      if( format->mimetype )
-        msIO_setHeader("Content-Type","%s",format->mimetype);
-      msIO_sendHeaders();
-    } else
-      msIO_fprintf( stdout, "%c", 10 );
-
-    fp = VSIFOpenL( file_list[0], "r" );
-    if( fp == NULL ) {
-      msSetError( MS_MISCERR,
-                  "Failed to open result file '%s'.",
-                  "msOGRWriteFromQuery()",
-                  file_list[0] );
-      msOGRCleanupDS( datasource_name );
-      return MS_FAILURE;
-    }
-
-    if( jsonp != NULL ) msIO_fprintf( stdout, "%s(", jsonp );
-
-    while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 )
-      msIO_fwrite( buffer, 1, bytes_read, stdout );
-    VSIFCloseL( fp );
-
-    if (jsonp != NULL) msIO_fprintf( stdout, ");\n" );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle the case of a multi-part result.                         */
-  /* -------------------------------------------------------------------- */
-  else if( EQUAL(form,"multipart") ) {
-    char **papszAdditionalFiles;
-    static const char *boundary = "xxOGRBoundaryxx";
-    msIO_setHeader("Content-Type","multipart/mixed; boundary=%s",boundary);
-    msIO_sendHeaders();
-    msIO_fprintf(stdout,"--%s\r\n",boundary );
-
-    papszAdditionalFiles = msOGROutputGetAdditonalFiles(map);
-    file_list = msCSLConcatenate(file_list, papszAdditionalFiles);
-    CSLDestroy(papszAdditionalFiles);
-
-    for( i = 0; file_list != NULL && file_list[i] != NULL; i++ ) {
-      VSILFILE *fp;
-      int bytes_read;
-      char buffer[1024];
-
-      if( sendheaders )
-        msIO_fprintf( stdout,
-                      "Content-Disposition: attachment; filename=%s\r\n"
-                      "Content-Type: application/binary\r\n"
-                      "Content-Transfer-Encoding: binary\r\n\r\n",
-                      CPLGetFilename( file_list[i] ));
-
-
-      fp = VSIFOpenL( file_list[i], "r" );
-      if( fp == NULL ) {
-        msSetError( MS_MISCERR,
-                    "Failed to open result file '%s'.",
-                    "msOGRWriteFromQuery()",
-                    file_list[0] );
-        msOGRCleanupDS( datasource_name );
-        return MS_FAILURE;
-      }
-
-      while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 )
-        msIO_fwrite( buffer, 1, bytes_read, stdout );
-      VSIFCloseL( fp );
-
-      if (file_list[i+1] == NULL)
-        msIO_fprintf( stdout, "\r\n--%s--\r\n", boundary );
-      else
-        msIO_fprintf( stdout, "\r\n--%s\r\n", boundary );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle the case of a zip file result.                           */
-  /* -------------------------------------------------------------------- */
-  else if( EQUAL(form,"zip") ) {
-    VSILFILE *fp;
-    char *zip_filename = msTmpFile(map, NULL, "/vsimem/ogrzip/", "zip" );
-    void *hZip;
-    int bytes_read;
-    char buffer[1024];
-    char **papszAdditionalFiles;
-
-    hZip = CPLCreateZip( zip_filename, NULL );
-
-    papszAdditionalFiles = msOGROutputGetAdditonalFiles(map);
-    file_list = msCSLConcatenate(file_list, papszAdditionalFiles);
-    CSLDestroy(papszAdditionalFiles);
-
-    for( i = 0; file_list != NULL && file_list[i] != NULL; i++ ) {
-
-      CPLCreateFileInZip( hZip, CPLGetFilename(file_list[i]), NULL );
-
-      fp = VSIFOpenL( file_list[i], "r" );
-      if( fp == NULL ) {
-        CPLCloseZip( hZip );
-        msSetError( MS_MISCERR,
-                    "Failed to open result file '%s'.",
-                    "msOGRWriteFromQuery()",
-                    file_list[0] );
-        msOGRCleanupDS( datasource_name );
-        return MS_FAILURE;
-      }
-
-      while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 ) {
-        CPLWriteFileInZip( hZip, buffer, bytes_read );
-      }
-      VSIFCloseL( fp );
-
-      CPLCloseFileInZip( hZip );
-    }
-    CPLCloseZip( hZip );
-
-    if( sendheaders ) {
-      const char* zip_filename = fo_filename;
-      /* Make sure the filename is ended by .zip */
-      if( !EQUAL(CPLGetExtension(zip_filename), "zip") &&
-          !EQUAL(CPLGetExtension(zip_filename), "kmz") )
-          zip_filename = CPLFormFilename(NULL, fo_filename, "zip");
-      msIO_setHeader("Content-Disposition","attachment; filename=%s",zip_filename);
-      msIO_setHeader("Content-Type","application/zip");
-      msIO_sendHeaders();
-    }
-
-    fp = VSIFOpenL( zip_filename, "r" );
-    if( fp == NULL ) {
-      msSetError( MS_MISCERR,
-                  "Failed to open zip file '%s'.",
-                  "msOGRWriteFromQuery()",
-                  file_list[0] );
-      msOGRCleanupDS( datasource_name );
-      return MS_FAILURE;
-    }
-
-    while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 )
-      msIO_fwrite( buffer, 1, bytes_read, stdout );
-    VSIFCloseL( fp );
-
-    msFree( zip_filename );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle illegal form value.                                      */
-  /* -------------------------------------------------------------------- */
-  else {
-    msSetError( MS_MISCERR, "Unsupported FORM=%s value.",
-                "msOGRWriteFromQuery()", form );
-    msOGRCleanupDS( datasource_name );
-    return MS_FAILURE;
-  }
-
-  msOGRCleanupDS( datasource_name );
-
-  CSLDestroy( file_list );
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                     msPopulateRenderVTableOGR()                      */
-/************************************************************************/
-
-int msPopulateRendererVTableOGR( rendererVTableObj *renderer )
-{
-  (void)renderer;
-  /* we aren't really a normal renderer so we leave everything default */
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/maporaclespatial.c 8.2.0~beta1-1~exp1/maporaclespatial.c
--- 8.0.1-5/maporaclespatial.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maporaclespatial.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,4094 +0,0 @@
-/******************************************************************************
- * Project: MapServer
- * Purpose: Native access to Oracle Spatial (SDO) data.
- * Author:  Fernando Simon (fsimon@univali.br)
- *          Rodrigo Becke Cabral
- *          Adriana Gomes Alves
- *
- * Notes: Developed under several funding agreements:
- *
- *   1) n.45/00 between CTTMAR/UNIVALI (www.cttmar.univali.br)
- *      and CEPSUL/IBAMA (www.ibama.gov.br)
- *
- *   2) CNPq (www.cnpq.br) under process 401263.03-7
- *
- *   3) FUNCITEC (www.funcitec.rct-sc.br) under process FCTP1523-031
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "maptime.h"
-#include "mapows.h"
-#include <assert.h>
-
-
-
-#if defined(USE_ORACLESPATIAL) || defined(USE_ORACLE_PLUGIN)
-
-#include <oci.h>
-#include <ctype.h>
-
-#define ARRAY_SIZE                 1024
-#define QUERY_SIZE                 1
-#define TEXT_SIZE                  4000 /* ticket #2260 */
-#define TYPE_OWNER                 "MDSYS"
-#define SDO_GEOMETRY               TYPE_OWNER".SDO_GEOMETRY"
-#define SDO_ORDINATE_ARRAY         TYPE_OWNER".SDO_ORDINATE_ARRAY"
-#define SDO_GEOMETRY_LEN           strlen( SDO_GEOMETRY )
-#define FUNCTION_FILTER            1
-#define FUNCTION_RELATE            2
-#define FUNCTION_GEOMRELATE        3
-#define FUNCTION_NONE              4
-#define VERSION_8i                 1
-#define VERSION_9i                 2
-#define VERSION_10g                3
-#define TOLERANCE                  0.001
-#define NULLERRCODE                1405
-#define TABLE_NAME_SIZE            2000
-
-typedef
-struct {
-  OCINumber x;
-  OCINumber y;
-  OCINumber z;
-} SDOPointObj;
-
-typedef
-struct {
-  OCINumber gtype;
-  OCINumber srid;
-  SDOPointObj point;
-  OCIArray *elem_info;
-  OCIArray *ordinates;
-} SDOGeometryObj;
-
-typedef
-struct {
-  OCIInd _atomic;
-  OCIInd x;
-  OCIInd y;
-  OCIInd z;
-} SDOPointInd;
-
-typedef
-struct {
-  OCIInd _atomic;
-  OCIInd gtype;
-  OCIInd srid;
-  SDOPointInd point;
-  OCIInd elem_info;
-  OCIInd ordinates;
-} SDOGeometryInd;
-
-typedef
-text item_text[TEXT_SIZE];
-
-typedef
-item_text item_text_array[ARRAY_SIZE];
-
-typedef
-item_text item_text_array_query[QUERY_SIZE];
-
-typedef
-ub2 query_dtype[ARRAY_SIZE];
-
-typedef
-struct {
-  /*Oracle handlers (global to connection)*/
-  OCIEnv *envhp;
-  OCIError *errhp;
-  OCISvcCtx *svchp;
-  int last_oci_status;
-  text last_oci_error[2048];
-  /* This references counter is to avoid the cache freed if there are other layers that could use it */
-  int ref_count;
-} msOracleSpatialHandler;
-
-typedef
-struct {
-  /* Oracle data handlers (global to connection) */
-  OCIDescribe *dschp;
-  OCIType *tdo;
-} msOracleSpatialDataHandler;
-
-typedef
-struct {
-  OCIStmt *stmthp;
-
-  /* fetch data buffer */
-  ub4 rows_count; /* total number of rows (so far) within cursor */
-  ub4 row_num; /* current row index within cursor results */
-  ub4 rows_fetched; /* total number of rows fetched into our buffer */
-  ub4 row; /* current row index within our buffer */
-
-  item_text_array *items; /* items buffer */
-  item_text_array_query *items_query; /* items buffer */
-  SDOGeometryObj *obj[ARRAY_SIZE]; /* spatial object buffer */
-  SDOGeometryInd *ind[ARRAY_SIZE]; /* object indicator (null) buffer */
-
-  int uniqueidindex; /*allows to keep which attribute id index is used as unique id*/
-
-
-} msOracleSpatialStatement;
-
-typedef
-struct {
-  /* oracle handlers */
-  msOracleSpatialHandler *orahandlers;
-
-  /* oracle data handlers */
-  msOracleSpatialDataHandler *oradatahandlers;
-  msOracleSpatialStatement *orastmt;
-
-  /* Following items are setup by WhichShapes
-   * used by NextShape, ResultGetShape
-   * disposed by CloseLayer (if set)
-   */
-  msOracleSpatialStatement *orastmt2;
-  /* Driver handling of pagination, enabled by default */
-  int paging;
-
-} msOracleSpatialLayerInfo;
-
-static OCIType  *ordinates_tdo = NULL;
-static OCIArray *ordinates;
-
-
-
-
-
-/* local prototypes */
-static int TRY( msOracleSpatialHandler *hand, sword status );
-static int ERROR( char *routine, msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand );
-static void msSplitLogin( char *connection, mapObj *map, char **username, char **password, char **dblink );
-static int msSplitData( char *data, char **geometry_column_name, char **table_name, char **unique, char **srid, char **indexfield, int *function, int * version);
-static void msOCICloseConnection( void *layerinfo );
-static msOracleSpatialHandler *msOCISetHandlers( char *username, char *password, char *dblink );
-static int msOCISetDataHandlers( msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand );
-static void msOCICloseDataHandlers ( msOracleSpatialDataHandler *dthand );
-static void msOCICloseHandlers( msOracleSpatialHandler *hand );
-static void msOCIClearLayerInfo( msOracleSpatialLayerInfo *layerinfo );
-static int msOCIOpenStatement( msOracleSpatialHandler *hand, msOracleSpatialStatement *sthand );
-static void msOCIFinishStatement( msOracleSpatialStatement *sthand );
-static int msOCIGet2DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt );
-static int msOCIGet3DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt );
-static int msOCIGet4DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt );
-static int msOCIConvertCircle( pointObj *pt );
-static char * osFilteritem(layerObj *layer, int function, char *query_str, int mode);
-static char * osAggrGetExtent(layerObj *layer, char *query_str, char *geom_column_name, char *table_name);
-static char * osGeodeticData(int function, char *query_str, char *geom_column_name, char *index_column_name);
-static char * osNoGeodeticData(int function, int version, char *query_str, char *geom_column_name, char *index_column_name);
-static double osCalculateArcRadius(pointObj *pnt);
-static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius, double npoints, int side, lineObj arcline, shapeObj *shape);
-static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points, int i, int data3d, int data4d);
-static void osShapeBounds ( shapeObj *shp );
-static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d, int data4d);
-static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int interpretation, int data3d, int data4d);
-static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d);
-static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int elem_type, int data3d, int data4d);
-static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d);
-static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d);
-static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj arcpoints,int elem_type,int data3d, int data4d);
-static int osGetOrdinates(msOracleSpatialDataHandler *dthand, msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, SDOGeometryInd *ind);
-static int osCheck2DGtype(int pIntGtype);
-static int osCheck3DGtype(int pIntGtype);
-static int osCheck4DGtype(int pIntGtype);
-
-
-
-/******************************************************************************
- *                          Local Helper Functions                            *
- ******************************************************************************/
-
-
-/* if an error ocurred call msSetError, sets last_oci_status to MS_FAILURE and return 0;
- * otherwise returns 1 */
-static int TRY( msOracleSpatialHandler *hand, sword status )
-{
-  sb4 errcode = 0;
-
-  if (hand->last_oci_status == MS_FAILURE)
-    return 0; /* error from previous call */
-
-  switch (status) {
-    case OCI_SUCCESS_WITH_INFO:
-    case OCI_ERROR:
-      OCIErrorGet((dvoid *)hand->errhp, (ub4)1, (text *)NULL, &errcode, hand->last_oci_error, (ub4)sizeof(hand->last_oci_error), OCI_HTYPE_ERROR );
-      if (errcode == NULLERRCODE) {
-        hand->last_oci_error[0] = (text)'\0';
-        return 1;
-      }
-      hand->last_oci_error[sizeof(hand->last_oci_error)-1] = 0; /* terminate string!? */
-      break;
-    case OCI_NEED_DATA:
-      strlcpy( (char *)hand->last_oci_error, "OCI_NEED_DATA", sizeof(hand->last_oci_error));
-      break;
-    case OCI_INVALID_HANDLE:
-      strlcpy( (char *)hand->last_oci_error, "OCI_INVALID_HANDLE", sizeof(hand->last_oci_error));
-      break;
-    case OCI_STILL_EXECUTING:
-      ((char*)hand->last_oci_error)[sizeof(hand->last_oci_error)-1] = 0;
-      break;
-    case OCI_CONTINUE:
-      strlcpy( (char *)hand->last_oci_error, "OCI_CONTINUE", sizeof(hand->last_oci_error));
-      break;
-    default:
-      return 1; /* no error */
-  }
-
-  /* if I got here, there was an error */
-  hand->last_oci_status = MS_FAILURE;
-
-  return 0; /* error! */
-}
-
-OCIType *get_tdo(char *typename, msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand )
-{
-  OCIParam *paramp = NULL;
-  OCIRef *type_ref = NULL;
-  OCIType *tdoe = NULL;
-  int success = 0;
-
-
-  success = TRY( hand, OCIDescribeAny(hand->svchp, hand->errhp, (text *)typename,  (ub4)strlen((char *)typename), OCI_OTYPE_NAME, (ub1)1, (ub1)OCI_PTYPE_TYPE, dthand->dschp))
-            &&TRY( hand, OCIAttrGet((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE, (dvoid *)&paramp, (ub4 *)0, (ub4)OCI_ATTR_PARAM, hand->errhp))
-            &&TRY( hand, OCIAttrGet((dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref, (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp))
-            &&TRY( hand, OCIObjectPin(hand->envhp, hand->errhp, type_ref, (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION, OCI_LOCK_NONE, (dvoid **)&tdoe));
-  if (success)
-    return tdoe;
-
-  /* if failure, return NULL*/
-  return NULL;
-}
-
-
-/* check last_oci_status for MS_FAILURE (set by TRY()) if an error ocurred return 1;
- * otherwise, returns 0 */
-static int ERROR( char *routine, msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand )
-{
-  (void)dthand;
-  if (hand->last_oci_status == MS_FAILURE) {
-    /* there was an error */
-    msSetError( MS_ORACLESPATIALERR, "OracleSpatial server returned an error, check logs for more details", routine );
-    msDebug("OracleSpatial server returned an error in funtion (%s): %s.\n", routine, (char*)hand->last_oci_error );
-
-    /* reset error flag */
-    hand->last_oci_status = MS_SUCCESS;
-
-    return 1; /* error processed */
-  } else
-    return 0; /* no error */
-}
-
-/* break layer->connection (username/password@dblink) into username, password and dblink */
-static void msSplitLogin( char *connection, mapObj *map, char **username, char **password, char **dblink )
-{
-  char *src, *tgt, *conn_decrypted;
-  size_t buffer_size = 0;
-
-  /* bad 'connection' */
-  if (connection == NULL) return;
-
-  buffer_size = strlen(connection)+1;
-  *username = (char*)malloc(buffer_size);
-  *password = (char*)malloc(buffer_size);
-  *dblink = (char*)malloc(buffer_size);
-
-  /* clearup */
-  **username = **password = **dblink = 0;
-
-  /* Decrypt any encrypted token */
-  conn_decrypted = msDecryptStringTokens(map, connection);
-  if (conn_decrypted == NULL) return;
-
-  /* ok, split connection */
-  for( tgt=*username, src=conn_decrypted; *src; src++, tgt++ )
-    if (*src=='/' || *src=='@')
-      break;
-    else
-      *tgt = *src;
-  *tgt = 0;
-  if (*src == '/') {
-    for( tgt=*password, ++src; *src; src++, tgt++ )
-      if (*src == '@')
-        break;
-      else
-        *tgt = *src;
-    *tgt = 0;
-  }
-  if (*src == '@') {
-    strlcpy( *dblink, ++src, buffer_size);
-  }
-
-  msFree(conn_decrypted);
-}
-
-/* break layer->data into geometry_column_name, table_name and srid */
-static int msSplitData( char *data, char **geometry_column_name, char **table_name, char **unique, char **srid, char **indexfield, int *function, int *version )
-{
-  char *tok_from = "from";
-  char *tok_using = "using";
-  char *tok_unique = "unique";
-  char *tok_srid = "srid";
-  char *tok_indexfield="indexfield";
-  char *tok_version = "version";
-  char data_version[4] = "";
-  char tok_function[11] = "";
-  int parenthesis, i;
-  char *src = data, *tgt;
-  int table_name_size = TABLE_NAME_SIZE;
-  size_t buffer_size = 0;
-
-  /* bad 'data' */
-  if (data == NULL)
-    return 0;
-
-  buffer_size = strlen(data)+1;
-  *geometry_column_name = (char*)malloc(buffer_size);
-  *unique = (char*)malloc(buffer_size);
-  *srid = (char*)malloc(buffer_size);
-  *indexfield=(char*)malloc(buffer_size);
-
-
-  /* clearup */
-  **geometry_column_name = **table_name = 0;
-
-  /* parsing 'geometry_column_name' */
-  for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-  for( tgt=*geometry_column_name; *src; src++, tgt++ )
-    if (isspace( *src ))
-      break;
-    else
-      *tgt = *src;
-  *tgt = 0;
-
-  /* parsing 'from' */
-  for( ; *src && isspace( *src ); src++ ) ; /* skip blanks */
-  for( ; *src && *tok_from && tolower(*src)==*tok_from; src++, tok_from++ );
-  if (*tok_from != '\0')
-    return 0;
-
-  /* parsing 'table_name' or '(SELECT stmt)' */
-  i = 0;
-  for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-  for( tgt=*table_name, parenthesis=0; *src; src++, tgt++, ++i ) {
-    if (*src == '(')
-      parenthesis++;
-    else if (*src == ')')
-      parenthesis--;
-    else if (parenthesis==0 && isspace( *src ))
-      break; /* stop on spaces */
-    /* double the size of the table_name array if necessary */
-    if (i == table_name_size) {
-      size_t tgt_offset = tgt - *table_name;
-      table_name_size *= 2;
-      *table_name = (char *) realloc(*table_name,sizeof(char *) * table_name_size);
-      tgt = *table_name + tgt_offset;
-    }
-    *tgt = *src;
-  }
-  *tgt = 0;
-
-  strlcpy( *unique, "", buffer_size);
-  strlcpy( *srid, "NULL", buffer_size);
-  strlcpy( *indexfield, "", buffer_size);
-
-  *function = -1;
-  *version = -1;
-
-  /* parsing 'unique' */
-  for( ; *src && isspace( *src ); src++ ) ; /* skip blanks */
-  if (*src != '\0') {
-    /* parse 'using' */
-    for( ; *src && *tok_using && tolower(*src)==*tok_using; src++, tok_using++ );
-    if (*tok_using != '\0')
-      return 0;
-
-    /* parsing 'unique' */
-    for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-    for( ; *src && *tok_unique && tolower(*src)==*tok_unique; src++, tok_unique++ );
-
-    if (*tok_unique == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-      if (*src == '\0')
-        return 0;
-      for( tgt=*unique; *src; src++, tgt++ )
-        if (isspace( *src ))
-          break;
-        else
-          *tgt = *src;
-      *tgt = 0;
-
-      if (*tok_unique != '\0')
-        return 0;
-    }
-
-    /* parsing 'srid' */
-    for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-    for( ; *src && *tok_srid && tolower(*src)==*tok_srid; src++, tok_srid++ );
-    if (*tok_srid == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-      if (*src == '\0')
-        return 0;
-      for( tgt=*srid; *src; src++, tgt++ )
-        if (isspace( *src ))
-          break;
-        else
-          *tgt = *src;
-      *tgt = 0;
-
-      if (*tok_srid != '\0')
-        return 0;
-    }
-
-    /* parsing 'indexfield' */
-    for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-    for( ; *src && *tok_indexfield && tolower(*src)==*tok_indexfield; src++, tok_indexfield++ );
-
-    if (*tok_indexfield == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-      if (*src == '\0')
-        return 0;
-      for( tgt=*indexfield; *src; src++, tgt++ )
-        if (isspace( *src ))
-          break;
-        else
-          *tgt = *src;
-      *tgt = 0;
-
-      if (*tok_indexfield != '\0')
-        return 0;
-    }
-
-    /*parsing function/version */
-    for( ; *src && isspace( *src ); src++ );
-    if (*src != '\0') {
-      for( tgt=tok_function; *src; src++, tgt++ )
-        if (isspace( *src ))
-          break;
-        else
-          *tgt = *src;
-      *tgt = 0;
-    }
-
-    /*Upcase conversion for the FUNCTION/VERSION token*/
-    for (i=0; tok_function[i] != '\0'; i++)
-      tok_function[i] = toupper(tok_function[i]);
-
-    if (strcmp(tok_function, "VERSION")) {
-      if (!strcmp(tok_function, "FILTER") || !strcmp(tok_function, ""))
-        *function = FUNCTION_FILTER;
-      else if(!strcmp(tok_function, "RELATE"))
-        *function = FUNCTION_RELATE;
-      else if (!strcmp(tok_function,"GEOMRELATE"))
-        *function = FUNCTION_GEOMRELATE;
-      else if (!strcmp(tok_function,"NONE"))
-        *function = FUNCTION_NONE;
-      else {
-        *function = -1;
-        return 0;
-      }
-
-      /*parsing VERSION token when user defined one function*/
-      for( ; *src && isspace( *src ); src++ );
-      for( ; *src && *tok_version && tolower(*src)==*tok_version; src++, tok_version++ );
-    } else {
-      for(tgt = "VERSION"; *tgt && *tok_version && toupper(*tgt)==toupper(*tok_version); tgt++, tok_version++ );
-      *function = FUNCTION_FILTER;
-    }
-
-    /*parsing version*/
-    if (*tok_version == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-      for( tgt=data_version; *src; src++, tgt++ )
-        if (isspace( *src ))
-          break;
-        else
-          *tgt = *src;
-      *tgt = 0;
-
-      for (i=0; data_version[i] != '\0'; i++)
-        data_version[i] = tolower(data_version[i]);
-
-      if (!strcmp(data_version, "8i"))
-        *version = VERSION_8i;
-      else if(!strcmp(data_version, "9i"))
-        *version = VERSION_9i;
-      else if (!strcmp(data_version, "10g"))
-        *version = VERSION_10g;
-      else
-        return 0;
-
-    }
-
-  }
-  /* finish parsing */
-  for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-
-  return (*src == '\0');
-}
-
-
-/******************************************************************************
- *                          OCI Helper Functions                              *
- ******************************************************************************/
-
-/* create statement handle from database connection */
-static int msOCIOpenStatement( msOracleSpatialHandler *hand, msOracleSpatialStatement *sthand)
-{
-  int success = 0;
-  char * cmd  = "";
-
-  /* allocate stmthp */
-  success = TRY( hand, OCIHandleAlloc( (dvoid *)hand->envhp, (dvoid **)&sthand->stmthp, (ub4)OCI_HTYPE_STMT, (size_t)0, (dvoid **)0 ) );
-
-  sthand->rows_count = 0;
-  sthand->row_num = 0;
-  sthand->rows_fetched = 0;
-  sthand->row = 0;
-  sthand->items = NULL;
-  sthand->items_query = NULL;
-
-  /* setting environment values to enable time parsing */
-
-  cmd = "alter session set NLS_DATE_FORMAT='yyyy-mm-dd hh24:mi:ss'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
-
-  cmd = "alter session set NLS_TIMESTAMP_TZ_FORMAT='yyyy-mm-dd hh24:mi:ss'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
-
-  cmd = "alter session set NLS_TIMESTAMP_FORMAT = 'yyyy-mm-dd hh24:mi:ss'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
-
-  cmd = "alter session set time_zone = 'GMT'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
-
-
-  /* fprintf(stderr, "Creating statement handle at %p\n", sthand->stmthp); */
-
-  return success;
-}
-
-/* create statement handle from database connection */
-static void msOCIFinishStatement( msOracleSpatialStatement *sthand )
-{
-  if(sthand != NULL) {
-    /* fprintf(stderr, "Freeing statement handle at %p\n", sthand->stmthp); */
-
-    if (sthand->stmthp != NULL)
-      OCIHandleFree( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT );
-    if (sthand->items != NULL)
-      free( sthand->items );
-    if (sthand->items_query != NULL)
-      free( sthand->items_query );
-    memset(sthand, 0, sizeof( msOracleSpatialStatement ) );
-    free(sthand);
-  }
-}
-
-static int msOCISetDataHandlers(msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand)
-{
-  int success = 0;
-  OCIParam *paramp = NULL;
-  OCIRef *type_ref = NULL;
-
-  success = TRY( hand,
-                 /* allocate dschp */
-                 OCIHandleAlloc( hand->envhp, (dvoid **)&dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE, (size_t)0, (dvoid **)0 ) )
-            && TRY( hand,
-                    /* describe SDO_GEOMETRY in svchp (dschp) */
-                    OCIDescribeAny( hand->svchp, hand->errhp, (text *)SDO_GEOMETRY, (ub4)SDO_GEOMETRY_LEN, OCI_OTYPE_NAME, (ub1)1, (ub1)OCI_PTYPE_TYPE, dthand->dschp ) )
-            && TRY( hand,
-                    /* get param for SDO_GEOMETRY */
-                    OCIAttrGet( (dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE, (dvoid *)&paramp, (ub4 *)0,  (ub4)OCI_ATTR_PARAM, hand->errhp ) )
-            && TRY( hand,
-                    /* get type_ref for SDO_GEOMETRY */
-                    OCIAttrGet( (dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref, (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp ) )
-            && TRY( hand,
-                    /* get TDO for SDO_GEOMETRY */
-                    OCIObjectPin( hand->envhp, hand->errhp, type_ref, (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION, OCI_LOCK_NONE, (dvoid **)&dthand->tdo ) );
-
-  return success;
-}
-
-/* connect to database */
-static msOracleSpatialHandler *msOCISetHandlers( char *username, char *password, char *dblink )
-{
-  int success;
-
-  msOracleSpatialHandler *hand = NULL;
-
-  hand = (msOracleSpatialHandler *) malloc( sizeof(msOracleSpatialHandler));
-  if (hand == NULL) {
-    msSetError(MS_MEMERR, NULL, "msOCISetHandlers()");
-    return NULL;
-  }
-  memset( hand, 0, sizeof(msOracleSpatialHandler) );
-
-  hand->ref_count = 1;
-  hand->last_oci_status = MS_SUCCESS;
-  hand->last_oci_error[0] = (text)'\0';
-
-  success = TRY( hand,
-                 /* allocate envhp */
-#ifdef USE_THREAD
-                 OCIEnvCreate( &hand->envhp, OCI_OBJECT|OCI_THREADED, (dvoid *)0, 0, 0, 0, (size_t) 0, (dvoid **)0 ) )
-#else
-                 OCIEnvCreate( &hand->envhp, OCI_OBJECT, (dvoid *)0, 0, 0, 0, (size_t) 0, (dvoid **)0 ) )
-#endif
-            && TRY( hand,
-                    /* allocate errhp */
-                    OCIHandleAlloc( (dvoid *)hand->envhp, (dvoid **)&hand->errhp, (ub4)OCI_HTYPE_ERROR, (size_t)0, (dvoid **)0 ) )
-            && TRY( hand,
-                    /* logon */
-                    OCILogon( hand->envhp, hand->errhp, &hand->svchp, (text *)username, strlen(username), (text *)password, strlen(password), (text *)dblink, strlen(dblink) ) );
-
-  if ( !success ) {
-    msDebug(   "Cannot create OCI Handlers. "
-                "Connection failure."
-                "Error: %s."
-                "msOracleSpatialLayerOpen()\n", hand->last_oci_error);
-    msSetError( MS_ORACLESPATIALERR,
-                "Cannot create OCI Handlers. "
-                "Connection failure. Check your logs and the connection string. ",
-                "msOracleSpatialLayerOpen()");
-
-    msOCICloseHandlers(hand);
-    return NULL;
-  }
-
-  return hand;
-
-}
-
-/* disconnect from database */
-static void msOCICloseHandlers( msOracleSpatialHandler *hand )
-{
-  if (hand->svchp != NULL)
-    OCILogoff( hand->svchp, hand->errhp );
-  if (hand->errhp != NULL)
-    OCIHandleFree( (dvoid *)hand->errhp, (ub4)OCI_HTYPE_ERROR );
-  if (hand->envhp != NULL)
-    OCIHandleFree( (dvoid *)hand->envhp, (ub4)OCI_HTYPE_ENV );
-  if (hand != NULL)
-    memset( hand, 0, sizeof (msOracleSpatialHandler));
-  free(hand);
-}
-
-static void msOCICloseDataHandlers( msOracleSpatialDataHandler *dthand )
-{
-  if (dthand->dschp != NULL)
-    OCIHandleFree( (dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE );
-  if (dthand != NULL)
-    memset( dthand, 0, sizeof (msOracleSpatialDataHandler));
-  free(dthand);
-}
-
-static void msOCIClearLayerInfo( msOracleSpatialLayerInfo *layerinfo )
-{
-  if (layerinfo != NULL) {
-    memset( layerinfo, 0, sizeof( msOracleSpatialLayerInfo ) );
-    free(layerinfo);
-  }
-}
-
-/*function that creates the correct sql for geoditical srid for version 9i*/
-static char * osGeodeticData(int function, char *query_str, char *geom_column_name, char *index_column_name)
-{
-  char *filter_field=index_column_name[0]=='\0' ? geom_column_name : index_column_name;
-  switch (function) {
-    case FUNCTION_FILTER: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates ), :srid),"
-                "'querytype=window') = 'TRUE'");
-      break;
-    }
-    case FUNCTION_RELATE: {
-      query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates ), :srid),"
-                "'mask=anyinteract querytype=window') = 'TRUE'");
-      break;
-    }
-    case FUNCTION_GEOMRELATE: {
-      char tmpFloat[256];
-      snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
-
-      query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates), :srid),");
-      query_str = msStringConcatenate(query_str, tmpFloat);
-      query_str = msStringConcatenate(query_str,  ") = 'TRUE' AND ");
-      query_str = msStringConcatenate(query_str, geom_column_name);
-      query_str = msStringConcatenate(query_str,  " IS NOT NULL");
-      break;
-    }
-    case FUNCTION_NONE: {
-      break;
-    }
-    default: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates), :srid),"
-                "'querytype=window') = 'TRUE'");
-    }
-  }
-  return query_str;
-}
-
-/*function that generate the correct sql for no geoditic srid's*/
-static char * osNoGeodeticData(int function, int version, char *query_str, char *geom_column_name, char *index_column_name)
-{
-   char *filter_field= index_column_name[0]=='\0' ? geom_column_name : index_column_name;
-   switch (function) {
-    case FUNCTION_FILTER: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                "2003, :srid, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                /*   "MDSYS.SDO_ORDINATE_ARRAY(%.9g,%.9g,%.9g,%.9g)" */
-                ":ordinates"
-                " ),'querytype=window') = 'TRUE'");
-      break;
-    }
-    case FUNCTION_RELATE: {
-      if (version == VERSION_10g) {
-        query_str = msStringConcatenate(query_str, "SDO_ANYINTERACT( ");
-        query_str = msStringConcatenate(query_str, filter_field);
-        query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                  "2003, :srid, NULL,"
-                  "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                  ":ordinates)) = 'TRUE'");
-      } else {
-
-        query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
-        query_str = msStringConcatenate(query_str, geom_column_name);
-        query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                  "2003, :srid, NULL,"
-                  "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                  ":ordinates),"
-                  "'mask=anyinteract querytype=window') = 'TRUE'");
-      }
-      break;
-    }
-    case FUNCTION_GEOMRELATE: {
-      char tmpFloat[256];
-      snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
-
-      query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
-      query_str = msStringConcatenate(query_str, index_column_name);
-      query_str = msStringConcatenate(query_str, ", 'anyinteract', MDSYS.SDO_GEOMETRY("
-                "2003, :srid, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates),");
-      query_str = msStringConcatenate(query_str, tmpFloat);
-      query_str = msStringConcatenate(query_str, ") = 'TRUE' AND ");
-      query_str = msStringConcatenate(query_str, geom_column_name);
-      query_str = msStringConcatenate(query_str, " IS NOT NULL");
-      break;
-    }
-    case FUNCTION_NONE: {
-      break;
-    }
-    default: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                "2003, :srid, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates),"
-                "'querytype=window') = 'TRUE'");
-    }
-  }
-  return query_str;
-}
-
-/* get ordinates from SDO buffer */
-static int msOCIGet2DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt )
-{
-  double x, y;
-  int i, n, success = 1;
-  boolean exists;
-  OCINumber *oci_number;
-
-  for( i=s, n=0; i < e && success; i+=2, n++ ) {
-    success = TRY( hand,
-                   OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&x ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&y ) );
-
-    if (success) {
-      pt[n].x = x;
-      pt[n].y = y;
-    }
-  }
-
-  return success ? n : 0;
-}
-
-static int msOCIGet3DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt )
-{
-  double x, y;
-  int i, n, success = 1;
-  boolean exists;
-  double z;
-  boolean numnull;
-  OCINumber *oci_number;
-
-  for( i=s, n=0; i < e && success; i+=3, n++ ) {
-    success = TRY( hand,
-                   OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&x ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&y ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+2, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              ;
-    if (success) {
-      success = TRY(hand, OCINumberIsZero( hand->errhp, oci_number, (boolean *)&numnull));
-      if (success) {
-        success = TRY( hand, OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&z ) );
-      } else {
-        hand->last_oci_status = MS_SUCCESS;
-        strlcpy( (char *)hand->last_oci_error, "Retrieve z value, but NULL value for z. Setting z to 0.", sizeof(hand->last_oci_error));
-        z = 0;
-        success = 1;
-      }
-    }
-    if (success) {
-      pt[n].x = x;
-      pt[n].y = y;
-      pt[n].z = z;
-    }
-  }
-
-  return success ? n : 0;
-}
-
-static int msOCIGet4DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt )
-{
-  double x, y;
-  int i, n, success = 1;
-  boolean exists;
-  double z;
-  boolean numnull;
-  OCINumber *oci_number;
-
-  for( i=s, n=0; i < e && success; i+=4, n++ ) {
-    success = TRY( hand,
-                   OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&x ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&y ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+2, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              ;
-
-    if (success) {
-      success = TRY(hand, OCINumberIsZero( hand->errhp, oci_number, (boolean *)&numnull));
-      if (success) {
-        success = TRY( hand, OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&z ) );
-      } else {
-        hand->last_oci_status = MS_SUCCESS;
-        strlcpy( (char *)hand->last_oci_error, "Retrieve z value, but NULL value for z. Setting z to 0.", sizeof(hand->last_oci_error));
-        z = 0;
-        success = 1;
-      }
-    }
-
-    if (success) {
-      pt[n].x = x;
-      pt[n].y = y;
-      pt[n].z = z;
-    }
-  }
-  return success ? n : 0;
-}
-
-/* convert three-point circle to two-point rectangular bounds */
-static int msOCIConvertCircle( pointObj *pt )
-{
-  pointObj ptaux;
-  double dXa, dXb;
-  double ma, mb;
-  double cx, cy, r;
-  int success;
-
-  dXa = pt[1].x - pt[0].x;
-  success = (fabs( dXa ) > 1e-8);
-  if (!success) {
-    /* switch points 1 & 2 */
-    ptaux = pt[1];
-    pt[1] = pt[2];
-    pt[2] = ptaux;
-    dXa = pt[1].x - pt[0].x;
-    success = (fabs( dXa ) > 1e-8);
-  }
-  if (success) {
-    dXb = pt[2].x - pt[1].x;
-    success = (fabs( dXb ) > 1e-8);
-    if (!success) {
-      /* insert point 2 before point 0 */
-      ptaux = pt[2];
-      pt[2] = pt[1];
-      pt[1] = pt[0];
-      pt[0] = ptaux;
-      dXb = dXa; /* segment A has become B */
-      dXa = pt[1].x - pt[0].x; /* recalculate new segment A */
-      success = (fabs( dXa ) > 1e-8);
-    }
-  }
-  if (success) {
-    ma = (pt[1].y - pt[0].y)/dXa;
-    mb = (pt[2].y - pt[1].y)/dXb;
-    success = (fabs( mb - ma ) > 1e-8);
-  }
-  if (!success)
-    return 0;
-
-  /* calculate center and radius */
-  cx = (ma*mb*(pt[0].y - pt[2].y) + mb*(pt[0].x + pt[1].x) - ma*(pt[1].x + pt[2].x))/(2*(mb - ma));
-  cy = (fabs( ma ) > 1e-8)
-       ? ((pt[0].y + pt[1].y)/2 - (cx - (pt[0].x + pt[1].x)/2)/ma)
-       : ((pt[1].y + pt[2].y)/2 - (cx - (pt[1].x + pt[2].x)/2)/mb);
-
-  r  = sqrt( pow( pt[0].x - cx, 2 ) + pow( pt[0].y - cy, 2 ) );
-
-  /* update pt buffer with rectangular bounds */
-  pt[0].x = cx - r;
-  pt[0].y = cy - r;
-  pt[1].x = cx + r;
-  pt[1].y = cy + r;
-
-  return 1;
-}
-
-/*function that creates the correct sql for filter and filteritem*/
-static char * osFilteritem(layerObj *layer, int function, char *query_str, int mode)
-{
-  if (layer->filter.native_string != NULL) {
-    if (mode == 1) {
-      query_str = msStringConcatenate(query_str, " WHERE ");
-    } else {
-      query_str = msStringConcatenate(query_str, " AND ");
-    }
-    size_t tmpBufSize = (strlen(layer->filter.native_string) + 3) * sizeof(char);
-    char * tmpBuf = (char *) msSmallMalloc(tmpBufSize);
-    snprintf(tmpBuf, tmpBufSize, " %s ", layer->filter.native_string);
-
-    query_str = msStringConcatenate(query_str, tmpBuf);
-    msFree(tmpBuf);
-
-    if (function != FUNCTION_NONE) {
-      query_str = msStringConcatenate(query_str, " AND ");
-    }
-  } else {
-    if (function != FUNCTION_NONE) {
-      query_str = msStringConcatenate(query_str, " WHERE ");
-    }
-  }
-
-  /* Handle a native filter set as a PROCESSING option (#5001). */
-  if ( msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL ) {
-     if ((function == FUNCTION_NONE)&&(layer->filter.native_string == NULL)) {
-        query_str = msStringConcatenate(query_str, " WHERE ");
-     }
-     if ((function == FUNCTION_NONE)&&(layer->filter.native_string != NULL)) {
-        query_str = msStringConcatenate(query_str, " AND ");
-     }
-     size_t tmpSz;
-
-     const char * native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
-     char * tmpBuf = NULL;
-
-     tmpSz = sizeof(char) * (strlen(native_filter) + 2 + 1);
-     tmpBuf = msSmallMalloc(tmpSz);
-
-     snprintf(tmpBuf, tmpSz, " %s ", native_filter);
-     query_str = msStringConcatenate(query_str, tmpBuf);
-     msFree(tmpBuf);
-
-     if (function != FUNCTION_NONE) {
-      query_str = msStringConcatenate(query_str, " AND ");
-     }
-  }
-  return query_str;
-}
-
-static char * osAggrGetExtent(layerObj *layer, char *query_str, char *geom_column_name, char *table_name)
-{
-  char * query_str2 = NULL;
-  int i = 0;
-
-  query_str2 = msStringConcatenate(query_str2, "(SELECT");
-
-  for (i = 0; i < layer->numitems; ++i) {
-      size_t tmpSize = sizeof(char) * (strlen(layer->items[i]) + 1 /* '\0' */ + 2 /* " ", "," */);
-      char * tmpItem = (char *) msSmallMalloc(tmpSize);
-      snprintf(tmpItem, tmpSize, " %s,", layer->items[i]);
-
-      query_str2 = msStringConcatenate(query_str2, tmpItem);
-
-      msFree(tmpItem);
-  }
-
-  size_t tmpFromSize = sizeof(char) * (7 + strlen(geom_column_name) + strlen(table_name) + 1);
-  char * tmpFrom = msSmallMalloc(tmpFromSize);
-  snprintf(tmpFrom, tmpFromSize, "%s FROM %s", geom_column_name, table_name);
-
-  query_str2 = msStringConcatenate(query_str2, tmpFrom);
-
-  msFree(tmpFrom);
-
-  query_str2 = osFilteritem(layer, FUNCTION_NONE, query_str2, 1);
-
-  query_str = msStringConcatenate(query_str, "SELECT SDO_AGGR_MBR(");
-  query_str = msStringConcatenate(query_str, geom_column_name);
-  query_str = msStringConcatenate(query_str, ") AS GEOM from ");
-  query_str = msStringConcatenate(query_str, query_str2);
-  query_str = msStringConcatenate(query_str, ")");
-
-  msFree(query_str2);
-
-  if (layer->debug)
-    msDebug("osAggrGetExtent was called: %s.\n", query_str);
-
-  return query_str;
-}
-
-static double osCalculateArcRadius(pointObj *pnt)
-{
-  double rc;
-  double r1, r2, r3;
-
-  r1 = sqrt( pow(pnt[0].x-pnt[1].x,2) + pow(pnt[0].y-pnt[1].y,2) );
-  r2 = sqrt( pow(pnt[1].x-pnt[2].x,2) + pow(pnt[1].y-pnt[2].y,2) );
-  r3 = sqrt( pow(pnt[2].x-pnt[0].x,2) + pow(pnt[2].y-pnt[0].y,2) );
-  rc = ( r1+r2+r3 )/2;
-
-  return ( ( r1*r2*r3 )/( 4*sqrt( rc * (rc-r1) * (rc-r2) * (rc-r3) ) ) );
-}
-
-static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius, double npoints, int side, lineObj arcline, shapeObj *shape)
-{
-  double length, ctrl, angle;
-  double divbas, plusbas, cosbas, sinbas = 0;
-  double zrange = 0;
-  int i = 0;
-
-  if ( npoints > 0 ) {
-    length = sqrt(((pnt[1].x-pnt[0].x)*(pnt[1].x-pnt[0].x))+((pnt[1].y-pnt[0].y)*(pnt[1].y-pnt[0].y)));
-    ctrl = length/(2*radius);
-
-    if (data3d||data4d) {
-      /* is this cast (long) legit... ? */
-      zrange = labs((long)(pnt[0].z-pnt[1].z))/npoints;
-      if ((pnt[0].z > pnt[1].z) && side == 1)
-        zrange *= -1;
-      else if ((pnt[0].z < pnt[1].z) && side == 1)
-        zrange = zrange;
-      else if ((pnt[0].z > pnt[1].z) && side != 1)
-        zrange *= -1;
-      else if ((pnt[0].z < pnt[1].z) && side != 1)
-        zrange = zrange;
-    }
-
-    if( ctrl <= 1 ) {
-      divbas = 2 * asin(ctrl);
-      plusbas = divbas/(npoints);
-      cosbas = (pnt[0].x-pnt[3].x)/radius;
-      sinbas = (pnt[0].y-pnt[3].y)/radius;
-      angle = plusbas;
-
-      arcline.point = (pointObj *)malloc(sizeof(pointObj)*(npoints+1));
-      arcline.point[0].x = pnt[0].x;
-      arcline.point[0].y = pnt[0].y;
-      if (data3d||data4d)
-        arcline.point[0].z = pnt[0].z;
-
-      for (i = 1; i <= npoints; i++) {
-        if( side == 1) {
-          arcline.point[i].x = pnt[3].x + radius * ((cosbas*cos(angle))-(sinbas*sin(angle)));
-          arcline.point[i].y = pnt[3].y + radius * ((sinbas*cos(angle))+(cosbas*sin(angle)));
-          if (data3d||data4d)
-            arcline.point[i].z = pnt[0].z + (zrange*i);
-        } else {
-          if ( side == -1) {
-            arcline.point[i].x = pnt[3].x + radius * ((cosbas*cos(angle))+(sinbas*sin(angle)));
-            arcline.point[i].y = pnt[3].y + radius * ((sinbas*cos(angle))-(cosbas*sin(angle)));
-            if (data3d||data4d)
-              arcline.point[i].z = pnt[0].z + (zrange*i);
-          } else {
-            arcline.point[i].x = pnt[0].x;
-            arcline.point[i].y = pnt[0].y;
-            if (data3d||data4d)
-              arcline.point[i].z = pnt[0].z;
-          }
-        }
-        angle += plusbas;
-      }
-
-      arcline.numpoints = npoints+1;
-      msAddLine( shape, &arcline );
-      free (arcline.point);
-    }
-  } else {
-    arcline.point = (pointObj *)malloc(sizeof(pointObj)*(2));
-    arcline.point[0].x = pnt[0].x;
-    arcline.point[0].y = pnt[0].y;
-    arcline.point[1].x = pnt[1].x;
-    arcline.point[1].y = pnt[1].y;
-
-    if(data3d||data4d) {
-      arcline.point[0].z = pnt[0].z;
-      arcline.point[1].z = pnt[1].z;
-    }
-
-    arcline.numpoints = 2;
-
-    msAddLine( shape, &arcline );
-    free (arcline.point);
-  }
-}
-
-/* Part of this function was based on Terralib function TeGenerateArc
- * found in TeGeometryAlgorith.cpp (www.terralib.org).
- * Part of this function was based on Dr. Ialo (Univali/Cttmar) functions. */
-static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points, int i, int data3d, int data4d)
-{
-  double mult, plus1, plus2, plus3, bpoint;
-  double cx, cy;
-  double radius, side, area, npoints;
-  double dist1 = 0;
-  double dist2 = 0;
-  pointObj point5[4];
-
-  mult = ( points.point[i+1].x - points.point[i].x )
-         * ( points.point[i+2].y - points.point[i].y )
-         - ( points.point[i+1].y - points.point[i].y )
-         * ( points.point[i+2].x - points.point[i].x );
-
-  if (mult) {
-    /*point5 = (pointObj *)malloc(sizeof(pointObj)*(4));*/
-
-    plus1 = points.point[i].x * points.point[i].x + points.point[i].y * points.point[i].y;
-    plus2 = points.point[i+1].x * points.point[i+1].x + points.point[i+1].y * points.point[i+1].y;
-    plus3 = points.point[i+2].x * points.point[i+2].x + points.point[i+2].y * points.point[i+2].y;
-
-    bpoint = plus1 * ( points.point[i+1].y - points.point[i+2].y )
-             + plus2 * ( points.point[i+2].y - points.point[i].y )
-             + plus3 * ( points.point[i].y - points.point[i+1].y );
-
-    cx = bpoint / (2.0 * mult);
-
-    bpoint = plus1 * ( points.point[i+2].x - points.point[i+1].x )
-             + plus2 * ( points.point[i].x - points.point[i+2].x )
-             + plus3 * ( points.point[i+1].x - points.point[i].x );
-
-    cy = bpoint / (2.0 * mult);
-
-    dist1 = (points.point[i+1].x - points.point[i].x) * (cy - points.point[i].y);
-    dist2 = (points.point[i+1].y - points.point[i].y) * (cx - points.point[i].x);
-    side = 0;
-
-    if((dist1-dist2) > 0)
-      side = 1;
-    else {
-      if((dist1-dist2) < 0)
-        side = -1;
-    }
-
-    point5[0] = points.point[i];
-    point5[1] = points.point[i+1];
-    point5[2] = points.point[i+2];
-    point5[3].x = cx;
-    point5[3].y = cy;
-
-    radius = osCalculateArcRadius(point5);
-
-    area = ((points.point[i].x + points.point[i+1].x) * (points.point[i+1].y - points.point[i].y))
-           + ((points.point[i+1].x + points.point[i+2].x) * (points.point[i+2].y - points.point[i+1].y));
-
-    npoints = labs((long)(area/radius));
-
-    point5[0] = points.point[i];
-    point5[1] = points.point[i+1];
-    osCalculateArc(point5, data3d, data4d, radius, (npoints>1000)?1000:npoints, side, arcline, shape);
-
-    point5[0] = points.point[i+1];
-    point5[1] = points.point[i+2];
-    osCalculateArc(point5, data3d, data4d, radius, (npoints>1000)?1000:npoints, side, arcline, shape);
-
-  } else {
-    arcline.point = (pointObj *)malloc(sizeof(pointObj)*(2));
-    arcline.point[0].x = points.point[i].x;
-    arcline.point[0].y = points.point[i].y;
-    arcline.point[1].x = points.point[i+2].x;
-    arcline.point[1].y = points.point[i+2].y;
-
-    if (data3d||data4d) {
-      arcline.point[0].z = points.point[i].z;
-      arcline.point[1].z = points.point[i+2].z;
-    }
-
-    arcline.numpoints = 2;
-
-    msAddLine( shape, &arcline );
-    free (arcline.point);
-  }
-}
-
-static void osShapeBounds ( shapeObj *shp )
-{
-  int i, f;
-
-  if ( (shp->numlines > 0) && (shp->line[0].numpoints > 0) ) {
-    shp->bounds.minx = shp->line[0].point[0].x;
-    shp->bounds.maxx = shp->line[0].point[0].x;
-    shp->bounds.miny = shp->line[0].point[0].y;
-    shp->bounds.maxy = shp->line[0].point[0].y;
-  }
-
-  for ( i = 0 ; i < shp->numlines; i++) {
-    for( f = 0; f < shp->line[i].numpoints; f++) {
-      if (shp->line[i].point[f].x < shp->bounds.minx)
-        shp->bounds.minx = shp->line[i].point[f].x;
-      if (shp->line[i].point[f].x > shp->bounds.maxx)
-        shp->bounds.maxx = shp->line[i].point[f].x;
-      if (shp->line[i].point[f].y < shp->bounds.miny)
-        shp->bounds.miny = shp->line[i].point[f].y;
-      if (shp->line[i].point[f].y > shp->bounds.maxy)
-        shp->bounds.maxy = shp->line[i].point[f].y;
-    }
-  }
-}
-
-static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d, int data4d)
-{
-  int max_points = 0;
-  int i,f,g;
-  lineObj shapeline = {0, NULL};
-
-  for (i = 0; i < shape->numlines; i++)
-    max_points += shape->line[i].numpoints;
-
-  if (max_points > 0)
-    shapeline.point = (pointObj *)malloc( sizeof(pointObj)*max_points );
-
-  g = 0;
-  for ( i = 0 ; i < shape->numlines; i++) {
-    for( f = 0; f < shape->line[i].numpoints && g <= max_points; f++, g++) {
-      shapeline.point[g].x = shape->line[i].point[f].x;
-      shapeline.point[g].y = shape->line[i].point[f].y;
-      if (data3d||data4d)
-        shapeline.point[g].z = shape->line[i].point[f].z;
-    }
-  }
-
-  if (g) {
-    shapeline.numpoints = g;
-    newshape->type = shape->type; /* jimk: 2009/09/23 Fixes compound linestrings being converted to polygons */
-    msAddLine( newshape, &shapeline );
-  }
-}
-
-static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int interpretation, int data3d, int data4d)
-{
-  int n;
-
-  n = (end - start)/2;
-  /* n = interpretation; */
-
-  /* if (n == interpretation) { */
-  points.point = (pointObj *)malloc( sizeof(pointObj)*n );
-
-  if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, points.point );
-  else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, points.point );
-  else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, points.point );
-
-  if (n == interpretation && n>0) {
-    shape->type = MS_SHAPE_POINT;
-    points.numpoints = n;
-    msAddLine( shape, &points );
-  }
-  free( points.point );
-  /* } */
-}
-
-static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d)
-{
-  int n;
-
-  if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, pnt );
-  else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end,  pnt );
-  else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
-
-  if (n == 1) {
-    shape->type = MS_SHAPE_POINT;
-    points.numpoints = 1;
-    points.point = pnt;
-    msAddLine( shape, &points );
-  }
-}
-
-static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int elem_type, int data3d, int data4d)
-{
-  int n;
-
-  n = (end - start)/2;
-  points.point = (pointObj *)malloc( sizeof(pointObj)*n );
-
-  if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, points.point );
-  else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, points.point );
-  else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, points.point );
-
-  if (n > 0) {
-    shape->type = (elem_type==21) ? MS_SHAPE_LINE : MS_SHAPE_POLYGON;
-    points.numpoints = n;
-    msAddLine( shape, &points );
-  }
-  free( points.point );
-}
-
-static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d)
-{
-  int n;
-
-  if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
-  else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
-  else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
-
-  if (n == 2) {
-    shape->type = MS_SHAPE_POLYGON;
-    points.numpoints = 5;
-    points.point = pnt;
-
-    /* point5 [0] & [1] contains the lower-left and upper-right points of the rectangle */
-    pnt[2] = pnt[1];
-    pnt[1].x = pnt[0].x;
-    pnt[3].x = pnt[2].x;
-    pnt[3].y = pnt[0].y;
-    pnt[4] = pnt[0];
-    if (data3d||data4d) {
-      pnt[1].z = pnt[0].z;
-      pnt[3].z = pnt[2].z;
-    }
-
-    msAddLine( shape, &points );
-  }
-}
-
-static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d)
-{
-  int n;
-
-  if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
-  else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
-  else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
-
-  if (n == 3) {
-    if (msOCIConvertCircle( pnt )) {
-      shape->type = MS_SHAPE_POINT;
-      points.numpoints = 2;
-      points.point = pnt;
-      msAddLine( shape, &points );
-    } else {
-      strlcpy( (char *)hand->last_oci_error, "Points in circle object are colinear", sizeof(hand->last_oci_error));
-      hand->last_oci_status = MS_FAILURE;
-    }
-  }
-}
-
-static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj arcpoints, int elem_type, int data3d, int data4d)
-{
-  int n, i;
-  lineObj points = {0, NULL};
-
-  n = (end - start)/2;
-  points.point = (pointObj *)malloc( sizeof(pointObj)*n );
-
-  if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, points.point );
-  else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, points.point );
-  else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, points.point );
-
-  if (n > 2) {
-    shape->type = (elem_type==32) ? MS_SHAPE_POLYGON : MS_SHAPE_LINE;
-    points.numpoints = n;
-
-    for (i = 0; i < n-2; i = i+2)
-      osGenerateArc(shape, arcpoints, points, i, data3d, data4d);
-  }
-  free (points.point);
-}
-
-static int osCheck2DGtype(int pIntGtype)
-{
-  if (pIntGtype > 2000 && pIntGtype < 2008) {
-    if (pIntGtype != 2004)
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-static int osCheck3DGtype(int pIntGtype)
-{
-  if (pIntGtype > 3000 && pIntGtype < 3308) {
-    if (pIntGtype > 3007)
-      pIntGtype-= 300;
-
-    if (pIntGtype <= 3007 && pIntGtype != 3004)
-      return MS_TRUE;
-  }
-  /*
-  * Future version, untested
-  * return (pIntGtype & 2208 && (pIntGtype & 3000 || pIntGtype & 3296) && pIntGtype & 3);
-  */
-  return MS_FALSE;
-}
-
-static int osCheck4DGtype(int pIntGtype)
-{
-
-  if (pIntGtype > 4000 && pIntGtype < 4408) {
-    if (pIntGtype > 4007)
-      pIntGtype-= 400;
-
-    if (pIntGtype <= 4007 && pIntGtype != 4004)
-      return MS_TRUE;
-
-
-  }
-
-  return MS_FALSE;
-}
-
-
-
-static int osGetOrdinates(msOracleSpatialDataHandler *dthand, msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, SDOGeometryInd *ind)
-{
-  int gtype, elem_type, compound_type;
-  float compound_lenght, compound_count;
-  ub4 etype;
-  ub4 interpretation;
-  int nelems, nords, data3d, data4d;
-  int elem, ord_start, ord_end;
-  boolean exists;
-  OCINumber *oci_number;
-  double x, y;
-  double z;
-  int success;
-  lineObj points = {0, NULL};
-  pointObj point5[5]; /* for quick access */
-  shapeObj newshape; /* for compound polygons */
-
-  /*stat the variables for compound polygons*/
-  compound_lenght = 0;
-  compound_type = 0;
-  compound_count = -1;
-  data3d = 0;
-  data4d = 0;
-
-  if (ind->_atomic != OCI_IND_NULL) { /* not a null object */
-    nelems = nords = 0;
-    success = TRY( hand, OCICollSize( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, &nelems ) )
-              && TRY( hand, OCICollSize( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, &nords ) )
-              && TRY( hand, OCINumberToInt( hand->errhp, &(obj->gtype), (uword)sizeof(int), OCI_NUMBER_SIGNED, (dvoid *)&gtype ) );
-    /*&& (nords%2==0 && nelems%3==0);*/ /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
-
-    if (success && osCheck2DGtype(gtype)) {
-      success = (nords%2==0 && nelems%3==0)?1:0; /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
-    } else if (success && osCheck3DGtype(gtype)) {
-      success = (nords%3==0 && nelems%3==0)?1:0; /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
-      data3d = 1;
-
-    } else if (success && osCheck4DGtype(gtype)) {
-      success = (nords%4==0 && nelems%3==0)?1:0; /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
-      data4d = 1;
-    }
-
-
-    if (success) {
-      /* reading SDO_POINT from SDO_GEOMETRY for a 2D/3D point geometry */
-      if ((gtype==2001 || gtype==3001 || gtype==4001 ) && ind->point._atomic == OCI_IND_NOTNULL && ind->point.x == OCI_IND_NOTNULL && ind->point.y == OCI_IND_NOTNULL) {
-
-
-        success = TRY( hand, OCINumberToReal( hand->errhp, &(obj->point.x), (uword)sizeof(double), (dvoid *)&x ) )
-                  && TRY( hand, OCINumberToReal( hand->errhp, &(obj->point.y), (uword)sizeof(double), (dvoid *)&y ) );
-
-        if (ERROR( "osGetOrdinates()", hand, dthand ))
-          return MS_FAILURE;
-
-        shape->type = MS_SHAPE_POINT;
-
-        points.numpoints = 1;
-        points.point = point5;
-        point5[0].x = x;
-        point5[0].y = y;
-        if (data3d || data4d) {
-          if (ind->point.z == OCI_IND_NOTNULL) {
-            success = TRY( hand, OCINumberToReal( hand->errhp, &(obj->point.z), (uword)sizeof(double), (dvoid *)&z ));
-            if (ERROR( "osGetOrdinates()", hand, dthand ))
-              return MS_FAILURE;
-            else
-              point5[0].z = z;
-          } else
-            point5[0].z = z;
-        }
-        msAddLine( shape, &points );
-        return MS_SUCCESS;
-      }
-      /* if SDO_POINT not fetched, proceed reading elements (element info/ordinates) */
-      success = TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info,(sb4)0, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-                && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_SIGNED, (dvoid *)&ord_end ) );
-
-      elem = 0;
-      ord_end--; /* shifts offset from 1..n to 0..n-1 */
-
-      do {
-        ord_start = ord_end;
-        if (elem+3 >= nelems) { /* processing last element */
-          ord_end = nords;
-          success = 1;
-        } else { /* get start ordinate position for next element which is ord_end for this element */
-          success = TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, (sb4)elem+3, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-                    && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_SIGNED, (dvoid *)&ord_end ) );
-
-          ord_end--; /* shifts offset from 1..n to 0..n-1 */
-        }
-        success = (success
-                   && TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, (sb4)elem+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0) )
-                   && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_UNSIGNED, (dvoid *)&etype ) )
-                   && TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, (sb4)elem+2, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-                   && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_UNSIGNED, (dvoid *)&interpretation ) ));
-
-        if (ERROR( "osGetOrdinates()", hand, dthand ))
-          return MS_FAILURE;
-
-        if ( etype == 1005 || etype == 2005  || etype == 4 ) {
-          compound_type = 1;
-          compound_lenght = interpretation;
-          compound_count = 0;
-          msInitShape(&newshape);
-        }
-
-        elem_type = (etype == 1 && interpretation > 1) ? 10 : ((etype%10)*10 + interpretation);
-
-
-        /* msDebug("osGetOrdinates shape->index = %ld\telem_type =  %d\n",shape->index, elem_type); */
-
-        switch (elem_type) {
-          case 10: /* point cluster with 'interpretation'-points */
-            osPointCluster (hand, shape, obj, ord_start, ord_end, points, interpretation, data3d, data4d);
-            break;
-          case 11: /* point type */
-            osPoint(hand, shape, obj, ord_start, ord_end, points, point5, data3d, data4d);
-            break;
-          case 21: /* line string whose vertices are connected by straight line segments */
-            if (compound_type)
-              osClosedPolygon(hand, &newshape, obj, ord_start, (compound_count<compound_lenght)?ord_end+2:ord_end, points, elem_type, data3d, data4d);
-            else
-              osClosedPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 22: /* compound type */
-            if (compound_type)
-              osArcPolygon(hand, &newshape, obj, ord_start, (compound_count<compound_lenght)?ord_end+2:ord_end , points, elem_type, data3d, data4d);
-            else
-              osArcPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 31: /* simple polygon with n points, last point equals the first one */
-            osClosedPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 32: /* Polygon with arcs */
-            osArcPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 33: /* rectangle defined by 2 points */
-            osRectangle(hand, shape, obj, ord_start, ord_end, points, point5, data3d, data4d);
-            break;
-          case 34: /* circle defined by 3 points */
-            osCircle(hand, shape, obj, ord_start, ord_end, points, point5, data3d, data4d);
-            break;
-        }
-
-        if (compound_count >= compound_lenght) {
-          osCloneShape(&newshape, shape, data3d, data4d);
-          msFreeShape(&newshape);
-        }
-
-        if (ERROR( "osGetOrdinates()", hand, dthand ))
-          return MS_FAILURE;
-
-        /* prepare for next cycle */
-        ord_start = ord_end;
-        elem += 3;
-
-        if (compound_type)
-          compound_count++;
-
-      } while (elem < nelems); /* end of element loop */
-    } /* end of gtype big-if */
-  } /* end of not-null-object if */
-
-  if (compound_type){
-    if (gtype == 2003 || gtype == 2007)
-      shape->type = MS_SHAPE_POLYGON;
-    msFreeShape(&newshape);
-  }
-
-  return MS_SUCCESS;
-}
-
-static void msOCICloseConnection( void *hand )
-{
-  msOCICloseHandlers( (msOracleSpatialHandler *)hand );
-}
-
-/* opens a layer by connecting to db with username/password@database stored in layer->connection */
-int msOracleSpatialLayerOpen( layerObj *layer )
-{
-  char *username = NULL, *password = NULL, *dblink =  NULL;
-
-  msOracleSpatialLayerInfo *layerinfo = NULL;
-  msOracleSpatialDataHandler *dthand = NULL;
-  msOracleSpatialStatement *sthand = NULL, *sthand2 = NULL;
-  msOracleSpatialHandler *hand = NULL;
-
-  if (layer->debug >=2)
-    msDebug("msOracleSpatialLayerOpen called with: %s (Layer pointer %p)\n",layer->data, layer);
-
-  if (layer->layerinfo != NULL) /* Skip if layer is already open */
-    return MS_SUCCESS;
-
-  if (layer->data == NULL) {
-    msDebug(    "Error parsing OracleSpatial DATA variable. Must be:"
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'."
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE.\n");
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. More info in server logs", "msOracleSpatialLayerOpen()");
-
-    return MS_FAILURE;
-  }
-
-  layerinfo = (msOracleSpatialLayerInfo *)malloc(sizeof(msOracleSpatialLayerInfo));
-  dthand = (msOracleSpatialDataHandler *)malloc(sizeof(msOracleSpatialDataHandler));
-  sthand = (msOracleSpatialStatement *)malloc(sizeof(msOracleSpatialStatement));
-  sthand2 = (msOracleSpatialStatement *)malloc(sizeof(msOracleSpatialStatement));
-
-  if ((dthand == NULL) || (layerinfo == NULL)) {
-    msSetError(MS_MEMERR, NULL, "msOracleSpatialLayerOpen()");
-    return MS_FAILURE;
-  }
-
-  memset( dthand, 0, sizeof(msOracleSpatialDataHandler) );
-  memset( sthand, 0, sizeof(msOracleSpatialStatement) );
-  memset( sthand2, 0, sizeof(msOracleSpatialStatement) );
-  memset( layerinfo, 0, sizeof(msOracleSpatialLayerInfo) );
-  layerinfo->paging = MS_TRUE;
-
-  msSplitLogin( layer->connection, layer->map, &username, &password, &dblink );
-
-  hand = (msOracleSpatialHandler *) msConnPoolRequest( layer );
-
-  if( hand == NULL ) {
-
-    hand = msOCISetHandlers( username, password, dblink );
-
-    if (hand == NULL) {
-      msOCICloseDataHandlers( dthand );
-      msOCIFinishStatement( sthand );
-      msOCIFinishStatement( sthand2 );
-      msOCIClearLayerInfo( layerinfo );
-
-      if (username) free(username);
-      if (password) free(password);
-      if (dblink) free(dblink);
-
-      return MS_FAILURE;
-    }
-
-    if ( layer->debug >=2)
-      msDebug("msOracleSpatialLayerOpen. Shared connection not available. Creating one.\n");
-
-    msConnPoolRegister( layer, hand, msOCICloseConnection );
-  } else {
-    hand->ref_count++;
-    hand->last_oci_status = MS_SUCCESS;
-    hand->last_oci_error[0] = (text)'\0';
-  }
-
-  if (!(msOCISetDataHandlers(hand, dthand) & msOCIOpenStatement(hand, sthand) & msOCIOpenStatement(hand, sthand2))) {
-    msSetError( MS_ORACLESPATIALERR,
-                "Cannot create OCI LayerInfo. "
-                "Connection failure.",
-                "msOracleSpatialLayerOpen()");
-
-    if (layer->debug>=2)
-      msDebug("msOracleSpatialLayerOpen. Cannot create OCI LayerInfo. Connection failure.\n");
-
-    msOCICloseDataHandlers ( dthand );
-    msOCICloseHandlers( hand );
-    msOCIClearLayerInfo( layerinfo );
-  }
-  layerinfo->orahandlers = hand;
-  layerinfo->oradatahandlers = dthand;
-  layerinfo->orastmt = sthand;
-  layerinfo->orastmt2 = sthand2;
-  layer->layerinfo = layerinfo;
-
-  if (username) free(username);
-  if (password) free(password);
-  if (dblink) free(dblink);
-
-  return layer->layerinfo != NULL ? MS_SUCCESS : MS_FAILURE;
-}
-
-/* return MS_TRUE if layer is open, MS_FALSE otherwise.*/
-int msOracleSpatialLayerIsOpen(layerObj *layer)
-{
-  if (layer->layerinfo != NULL)
-    return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-/* closes the layer, disconnecting from db if connected. layer->layerinfo is freed */
-int msOracleSpatialLayerClose( layerObj *layer )
-{
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-  /*int lIntSuccessFree = 0;*/
-
-  if (layer->debug>=2)
-    msDebug("msOracleSpatialLayerClose was called. Layer: %p, Layer name: %s\n", layer, layer->name);
-
-  if (layerinfo != NULL) {
-
-    /*
-     * Some errors with the OCIObjectFree with query function
-     * If uncomment draw mode will work but no query modes
-     * Need to investigate the error cause
-     */
-    /*lIntSuccessFree = TRY (layerinfo->orahandlers, OCIObjectFree(layerinfo->orahandlers->envhp, layerinfo->orahandlers->errhp, (dvoid *)layerinfo->obj, (ub2)OCI_OBJECTFREE_FORCE));
-     *if (!lIntSuccessFree)
-     *  msDebug("Error: %s\n", layerinfo->orahandlers->last_oci_error);
-     */
-    /* Release Statement Handles */
-    if (layerinfo->orastmt != NULL) {
-      msOCIFinishStatement(layerinfo->orastmt);
-      layerinfo->orastmt = NULL;
-    }
-    if (layerinfo->orastmt2 != NULL) {
-      msOCIFinishStatement(layerinfo->orastmt2);
-      layerinfo->orastmt2 = NULL;
-    }
-
-    /* Release Datahandlers */
-    if (layer->debug>=4)
-      msDebug("msOracleSpatialLayerClose. Cleaning layerinfo handlers.\n");
-    msOCICloseDataHandlers( layerinfo->oradatahandlers );
-    layerinfo->oradatahandlers = NULL;
-
-    /* Free the OCI cache only if there is no more layer that could use it */
-    layerinfo->orahandlers->ref_count--;
-    if (layerinfo->orahandlers->ref_count == 0)
-      OCICacheFree (layerinfo->orahandlers->envhp, layerinfo->orahandlers->errhp, layerinfo->orahandlers->svchp);
-
-    /* Release Mapserver Pool */
-    if (layer->debug>=4)
-      msDebug("msOracleSpatialLayerClose. Release the Oracle Pool.\n");
-    msConnPoolRelease( layer, layerinfo->orahandlers );
-
-    /* Release Layerinfo */
-    layerinfo->orahandlers = NULL;
-
-    msOCIClearLayerInfo( layerinfo );
-    layer->layerinfo = NULL;
-  }
-
-  return MS_SUCCESS;
-}
-
-/* create SQL statement for retrieving shapes */
-/* Sets up cursor for use in *NextShape and *GetShape */
-int msOracleSpatialLayerWhichShapes( layerObj *layer, rectObj rect, int isQuery)
-{
-  int success, i;
-  int function = 0;
-  int version = 0;
-  char * query_str = NULL;
-  char query_str2[256];
-  char *tmp_str=NULL, *tmp1_str=NULL;
-  char *table_name;
-  char *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
-  OCIDefine *adtp = NULL;
-  OCIDefine **items = NULL;
-  OCINumber oci_number;
-  OCIBind *bnd1p = NULL,  *bnd2p = NULL;
-
-  int existunique = MS_FALSE;
-  int rownumisuniquekey = MS_FALSE;
-  int numitemsinselect = 0;
-
-  /* get layerinfo */
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-  msOracleSpatialDataHandler *dthand = NULL;
-  msOracleSpatialHandler *hand = NULL;
-  msOracleSpatialStatement *sthand = NULL;
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerWhichShapes was called.\n");
-
-  if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR,
-                "msOracleSpatialLayerWhichShapes called on unopened layer",
-                "msOracleSpatialLayerWhichShapes()" );
-
-    return MS_FAILURE;
-  } else {
-    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
-    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *)layerinfo->orastmt2;
-  }
-
-  /*init uniqueindex field*/
-  sthand->uniqueidindex=0;
-
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  /* parse geom_column_name and table_name */
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version)) {
-    msDebug( "Error parsing OracleSpatial DATA variable. Must be:"
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'."
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE."
-                "Your data statement: (%s)"
-                "in msOracleSpatialLayerWhichShapes()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. More info in server logs",
-                "msOracleSpatialLayerWhichShapes()" );
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    free(table_name);
-    return MS_FAILURE;
-  }
-
-  /*rownum will be the first in the select if no UNIQUE key is defined or
-    will be added at the end of the select*/
-  rownumisuniquekey = MS_TRUE;
-  /*Define the unique*/
-  if (unique[0] == '\0')
-    strcpy( unique, "rownum" );
-  else
-    rownumisuniquekey = MS_FALSE;
-
-  /* Check if the unique field is already in the items list */
-  existunique = MS_FALSE;
-  if (unique) {
-    for( i=0; i < layer->numitems; ++i ) {
-      if (strcasecmp(unique, layer->items[i])==0) {
-        sthand->uniqueidindex = i;
-        existunique = MS_TRUE;
-        break;
-      }
-    }
-  }
-
-  /* If no SRID is provided, set it to -1 (NULL) for binding */
-  if (strcmp(srid,"NULL") == 0)
-    strcpy(srid,"-1");
-
-  query_str = msStringConcatenate(query_str, "SELECT ");
-  numitemsinselect = layer->numitems;
-  /* allocate enough space for items */
-  if (layer->numitems >= 0) {
-    /*we will always add a rownumber in the selection*/
-    numitemsinselect++;
-
-    /*if unique key in the data is specfied and is not part of the current item lists,
-      we should add it to the select*/
-    if(existunique == MS_FALSE && rownumisuniquekey == MS_FALSE)
-      numitemsinselect++;
-
-    /*the usinque index is there was no uniqueid given or the uniqueid given was not part of the items lists*/
-    if (existunique == MS_FALSE)
-      sthand->uniqueidindex = layer->numitems;
-
-    sthand->items = (item_text_array *)malloc( sizeof(item_text_array) * (numitemsinselect) );
-    if (sthand->items == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate layerinfo->items buffer","msOracleSpatialLayerWhichShapes()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if(indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-      return MS_FAILURE;
-    }
-
-    items = (OCIDefine **)malloc(sizeof(OCIDefine *)*(numitemsinselect));
-    if (items == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer","msOracleSpatialLayerWhichShapes()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if(indexfield) free(indexfield);
-      free(table_name);
-      if (query_str) free(query_str);
-      return MS_FAILURE;
-    }
-    memset(items ,0,sizeof(OCIDefine *)*(numitemsinselect));
-  }
-
-  /* define SQL query */
-  for( i=0; i < layer->numitems; ++i ) {
-      query_str = msStringConcatenate(query_str, "\"");
-      query_str = msStringConcatenate(query_str, layer->items[i]);
-      query_str = msStringConcatenate(query_str, "\", ");
-  }
-
-  /*we add the uniqueid if it was not part of the current item list*/
-  if(existunique == MS_FALSE && rownumisuniquekey == MS_FALSE) {
-    query_str = msStringConcatenate(query_str, unique);
-    query_str = msStringConcatenate(query_str, ",");
-  }
-
-  /*we always want to add rownum in the selection to allow paging to work*/
-  query_str = msStringConcatenate(query_str, "rownum, ");
-
-  query_str = msStringConcatenate(query_str, geom_column_name);
-  query_str = msStringConcatenate(query_str, " FROM ");
-  query_str = msStringConcatenate(query_str, table_name);
-
-  query_str = osFilteritem(layer, function, query_str, 1);
-
-  if (layerinfo->paging && layer->maxfeatures > 0 && layer->startindex < 0) {
-    if (function == FUNCTION_NONE && layer->filter.native_string == NULL) {
-      query_str = msStringConcatenate(query_str, " WHERE ");
-    } else if (function == FUNCTION_NONE && layer->filter.native_string != NULL) {
-      query_str = msStringConcatenate(query_str, " AND ");
-    }
-    // avoiding an allocation on the heap here sounds acceptable
-    char tmpBuf[256];
-    snprintf(tmpBuf, sizeof(tmpBuf), " ROWNUM<=%d ", layer->maxfeatures);
-    query_str = msStringConcatenate(query_str, tmpBuf);
-
-    if (function != FUNCTION_NONE) {
-      query_str = msStringConcatenate(query_str, " AND ");
-    }
-  }
-
-  if ((((atol(srid) >= 8192) && (atol(srid) <= 8330))
-   || (atol(srid) == 2) || (atol(srid) == 5242888)
-    || (atol(srid) == 2000001)) && (version == VERSION_9i)) {
-    query_str = osGeodeticData(function, query_str, geom_column_name, indexfield);
-  }
-  else {
-    query_str = osNoGeodeticData(function, version, query_str, geom_column_name, indexfield);
-  }
-
-  if( layer->sortBy.nProperties > 0 ) {
-      msDebug("Layer sorting is requested\n");
-      tmp1_str = msLayerBuildSQLOrderBy(layer);
-      query_str = msStringConcatenate(query_str, " ORDER BY ");
-      query_str = msStringConcatenate(query_str, tmp1_str);
-      query_str = msStringConcatenate(query_str, "  ");
-      msFree(tmp1_str);
-    }
-
-  /*assuming startindex starts at 1*/
-  if (layerinfo->paging && layer->startindex > 0) {
-    tmp1_str = msStrdup("SELECT * from (SELECT atmp.*, ROWNUM rnum from (");
-    tmp_str = msStringConcatenate(tmp_str,  tmp1_str);
-    msFree(tmp1_str);
-    tmp_str = msStringConcatenate(tmp_str, query_str);
-    /*oder by rowid does not seem to work with function using the spatial filter, at least
-      on layers loaded using ogr in a 11g database*/
-    if (function == FUNCTION_NONE  || function == FUNCTION_RELATE || function == FUNCTION_GEOMRELATE)
-      tmp1_str = msStrdup( "order by rowid");
-    /* Populate strOrderBy, if necessary */
-    else
-      tmp1_str = msStrdup("");
-
-    if (layer->maxfeatures > 0) {
-      snprintf(query_str2, sizeof(query_str2),  " %s) atmp where ROWNUM<=%d) where rnum >=%d",   tmp1_str,
-               layer->maxfeatures+layer->startindex-1,  layer->startindex);
-    } else {
-      snprintf( query_str2, sizeof(query_str2),  " %s) atmp) where rnum >=%d",  tmp1_str, layer->startindex);
-    }
-    msFree(tmp1_str);
-
-    tmp_str = msStringConcatenate(tmp_str,  query_str2);
-    memset(query_str,0,strlen(query_str));
-    query_str = msStringConcatenate(query_str, tmp_str);
-    msFree(tmp_str);
-  }
-
-
-  if (layer->debug)
-    msDebug("msOracleSpatialLayerWhichShapes. Using this Sql to retrieve the data: %s\n", query_str);
-
-  if (layer->debug)
-    msDebug("msOracleSpatialLayerWhichShapes. Bind values: srid:%s   minx:%f   miny:%f  maxx:%f   maxy:%f \n", srid, rect.minx, rect.miny, rect.maxx, rect.maxy);
-
-  /* prepare */
-  success = TRY( hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT) );
-
-  if (layer->debug>=4)
-    msDebug("msOracleSpatialLayerWhichShapes getting ordinate definition.\n");
-
-  /* get the object definition of the ordinate array */
-  ordinates_tdo = get_tdo(SDO_ORDINATE_ARRAY, hand, dthand );
-
-  if (layer->debug>=4)
-    msDebug("msOracleSpatialLayerWhichShapes converting to OCIColl.\n");
-
-  /* initialized the collection array */
-  success = TRY( hand, OCIObjectNew(hand->envhp, hand->errhp, hand->svchp, OCI_TYPECODE_VARRAY, ordinates_tdo, (dvoid *)NULL, OCI_DURATION_SESSION, FALSE, (dvoid **)&ordinates) );
-
-  /* convert it to a OCI number and then append minx...maxy to the collection */
-  success = TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.minx), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates))
-            &&TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.miny), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates))
-            &&TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxx), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates))
-            &&TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxy), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates));
-
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerWhichShapes bind by name and object.\n");
-
-  /* do the actual binding */
-
-  if (success && function != FUNCTION_NONE) {
-    success = TRY( hand,
-                   /* bind in srid */
-                   OCIBindByName( sthand->stmthp, &bnd2p,  hand->errhp, (text *) ":srid", strlen(":srid"),(ub1 *) srid,  strlen(srid)+1, SQLT_STR,
-                                  (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT) )
-              && TRY(hand,
-                     /* bind in rect by name */
-                     OCIBindByName( sthand->stmthp, &bnd1p,  hand->errhp,  (text *)":ordinates", -1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0,(ub2 *)0, (ub4)0, (ub4 *)0, (ub4)OCI_DEFAULT))
-              && TRY(hand,
-                     /* bind in rect object */
-                     OCIBindObject(bnd1p, hand->errhp, ordinates_tdo, (dvoid **)&ordinates, (ub4 *)0, (dvoid **)0, (ub4 *)0));
-
-    /* bind the variables from the bindvals hash */
-    const char* bind_key = msFirstKeyFromHashTable(&layer->bindvals);
-    while(bind_key != NULL) {
-      const char* bind_value = msLookupHashTable(&layer->bindvals, bind_key);
-      char* bind_tag = (char*)malloc(sizeof(char) * strlen(bind_key) + 2);
-      sprintf(bind_tag, ":%s", bind_key);
-
-      success = success && TRY(hand, OCIBindByName( sthand->stmthp, &bnd2p,  hand->errhp, (text *)bind_tag, strlen(bind_tag),(ub1 *) bind_value,  strlen(bind_value)+1, SQLT_STR,
-                               (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT));
-      bind_key = msNextKeyFromHashTable(&layer->bindvals, bind_key);
-    }
-  }
-
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerWhichShapes name and object now bound.\n");
-
-
-  if (success && layer->numitems >= 0) {
-    for( i=0; i < numitemsinselect && success; ++i ){
-      if (i< numitemsinselect -1) {
-        //msDebug("Defining by POS, for %s\n", layer->items[i]);
-        //msDebug("datatype retrieved is %i\n", layer->iteminfo);
-      }
-      success = TRY( hand, OCIDefineByPos( sthand->stmthp, &items[i], hand->errhp, (ub4)i+1, (dvoid *)sthand->items[i], (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) );
-    }
-  }
-
-
-  if (success) {
-    int cursor_type = OCI_DEFAULT;
-    if(isQuery) cursor_type =OCI_STMT_SCROLLABLE_READONLY;
-
-    success = TRY( hand,
-                   /* define spatial position adtp ADT object */
-                   OCIDefineByPos( sthand->stmthp, &adtp, hand->errhp, (ub4)numitemsinselect+1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT) )
-              && TRY( hand,
-                      /* define object tdo from adtp */
-                      OCIDefineObject( adtp, hand->errhp, dthand->tdo, (dvoid **)sthand->obj, (ub4 *)0, (dvoid **)sthand->ind, (ub4 *)0 ) )
-              && TRY(hand,
-                     /* execute */
-                     OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)cursor_type ) )
-              &&  TRY( hand,
-                       /* get rows fetched */
-                       OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) )
-              && TRY( hand,
-                      /* get rows count */
-                      OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_count, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ) );
-  }
-
-  if (!success) {
-    msDebug( "Error: %s . "
-                "Query statement: %s . "
-                "Check your data statement."
-                "msOracleSpatialLayerWhichShapes()\n", hand->last_oci_error, query_str );
-    msSetError( MS_ORACLESPATIALERR,
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerWhichShapes()");
-
-    /* clean items */
-    free(items);
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
-    free(table_name);
-
-    return MS_FAILURE;
-  }
-
-  /* should begin processing first row */
-  sthand->row_num = sthand->row = 0;
-
-  /* clean items */
-  free(items);
-  // TODO why not msFree() instead to avoid if statements ?
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (query_str) free(query_str);
-  free(table_name);
-
-  return MS_SUCCESS;
-}
-
-/* fetch next shape from previous SELECT stmt (see *WhichShape()) */
-int msOracleSpatialLayerNextShape( layerObj *layer, shapeObj *shape )
-{
-  SDOGeometryObj *obj;
-  SDOGeometryInd *ind;
-  int success, /*lIntSuccessFree,*/ i;
-
-  /* get layerinfo */
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-  msOracleSpatialDataHandler *dthand = NULL;
-  msOracleSpatialHandler *hand = NULL;
-  msOracleSpatialStatement *sthand = NULL;
-
-
-  if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerWhichShapes called on unopened layer", "msOracleSpatialLayerNextShape()" );
-    return MS_FAILURE;
-  } else {
-    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
-    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *)layerinfo->orastmt2;
-  }
-
-  /* no rows fetched */
-  if (sthand->rows_fetched == 0)
-    return MS_DONE;
-
-  if(layer->debug >=5 )
-    msDebug("msOracleSpatialLayerNextShape on layer %p, row_num: %d\n", layer, sthand->row_num);
-
-  do {
-    /* is buffer empty? */
-    if (sthand->row >= sthand->rows_fetched) {
-      /* fetch more */
-      success = TRY( hand, OCIStmtFetch2( sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub2)OCI_FETCH_NEXT, (sb4)0, (ub4)OCI_DEFAULT ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_count, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ) );
-
-
-      if (!success || sthand->rows_fetched == 0 || sthand->row_num >= sthand->rows_count) {
-        hand->last_oci_status=MS_SUCCESS;
-        return MS_DONE;
-      }
-      if(layer->debug >= 4 )
-        msDebug("msOracleSpatialLayerNextShape on layer %p, Fetched %d more rows (%d total)\n", layer, sthand->rows_fetched, sthand->rows_count);
-
-      sthand->row = 0; /* reset buffer row index */
-    }
-
-    /* set obj & ind for current row */
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
-
-    /* get the items for the shape */
-    shape->index = atol( (char *)(sthand->items[sthand->uniqueidindex][ sthand->row ])); /* Primary Key */
-    shape->resultindex = sthand->row_num;
-    shape->numvalues = layer->numitems;
-
-    shape->values = (char **)malloc( sizeof(char*) * shape->numvalues );
-    if (shape->values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values", "msOracleSpatialLayerNextShape()" );
-      return MS_FAILURE;
-    }
-
-    for( i=0; i < shape->numvalues; ++i ) {
-      shape->values[i] = (char *)malloc(strlen((char *)sthand->items[i][ sthand->row ])+1);
-      if (shape->values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items", "msOracleSpatialLayerNextShape()" );
-        return MS_FAILURE;
-      } else {
-        strcpy(shape->values[i], (char *)sthand->items[i][ sthand->row ]);
-        shape->values[i][strlen((char *)sthand->items[i][ sthand->row ])] = '\0';
-      }
-    }
-
-    /* fetch a layer->type object */
-    success = osGetOrdinates(dthand, hand, shape, obj, ind);
-
-    /* increment for next row */
-    sthand->row_num++;
-    sthand->row++;
-
-    if (success != MS_SUCCESS) {
-      return MS_FAILURE;
-    }
-
-    osShapeBounds(shape);
-  } while(shape->type == MS_SHAPE_NULL);
-
-  return MS_SUCCESS;
-}
-
-int msOracleSpatialLayerGetShape( layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  int success, i;
-  SDOGeometryObj *obj;
-  SDOGeometryInd *ind;
-  msOracleSpatialDataHandler *dthand = NULL;
-  msOracleSpatialHandler *hand = NULL;
-  msOracleSpatialLayerInfo *layerinfo;
-  msOracleSpatialStatement *sthand = NULL;
-
-  long shapeindex = record->shapeindex;
-  int resultindex = record->resultindex;
-
-  if(layer == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape called on unopened layer","msOracleSpatialLayerGetShape()" );
-    return MS_FAILURE;
-  }
-
-  layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-
-  if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape called on unopened layer (layerinfo)","msOracleSpatialLayerGetShape()" );
-    return MS_FAILURE;
-  }
-
-  /* If resultindex is set, fetch the shape from the resultcache, otherwise fetch it from the DB  */
-  if (resultindex >= 0) {
-    long buffer_first_row_num, buffer_last_row_num;
-
-    /* get layerinfo */
-    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
-    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *)layerinfo->orastmt2;
-
-    if (layer->resultcache == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape called before msOracleSpatialLayerWhichShapes()","msOracleSpatialLayerGetShape()" );
-      return MS_FAILURE;
-    }
-
-    if ((unsigned)resultindex >= sthand->rows_count) {
-      if (layer->debug >= 5)
-               msDebug("msOracleSpatialLayerGetShape problem with cursor. Trying to fetch record = %d of %d, falling back to GetShape\n", resultindex, sthand->rows_count);
-
-      msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape record out of range","msOracleSpatialLayerGetShape()" );
-      return MS_FAILURE;
-    }
-
-    if (layer->debug >= 5)
-      msDebug("msOracleSpatialLayerGetShape was called. Using the record = %d of %d. (shape: %ld should equal pkey: %ld)\n",
-              resultindex, layer->resultcache->numresults, layer->resultcache->results[resultindex].shapeindex, shapeindex);
-
-    /* NOTE: with the way the resultcache works, we should see items in increasing order, but some may have been filtered out. */
-    /* Best case: item in buffer */
-    /* Next best case: item is in next fetch block */
-    /* Worst case: item is random access */
-    buffer_first_row_num = sthand->row_num - sthand->row; /* cursor id of first item in buffer */
-    buffer_last_row_num  = buffer_first_row_num + sthand->rows_fetched - 1; /* cursor id of last item in buffer */
-    if(resultindex >= buffer_first_row_num && resultindex <= buffer_last_row_num) { /* Item is in buffer. Calculate position in buffer */
-      sthand->row += resultindex - sthand->row_num; /* move sthand row an row_num by offset from last call */
-      sthand->row_num += resultindex - sthand->row_num;
-    } else { /* Item is not in buffer. Fetch item from Oracle */
-      if (layer->debug >= 4)
-        msDebug("msOracleSpatialLayerGetShape: Fetching result from DB start: %ld end:%ld record: %d\n", buffer_first_row_num, buffer_last_row_num, resultindex);
-
-      success = TRY( hand, OCIStmtFetch2( sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub2)OCI_FETCH_ABSOLUTE, (sb4)resultindex+1, (ub4)OCI_DEFAULT ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) );
-
-      sthand->row_num = resultindex;
-      sthand->row = 0; /* reset row index */
-
-      if(ERROR("msOracleSpatialLayerGetShape", hand, dthand))
-          return MS_FAILURE;
-
-      if (!success || sthand->rows_fetched == 0) {
-        msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape could not fetch specified record.", "msOracleSpatialLayerGetShape()" );
-        return MS_FAILURE;
-      }
-    }
-
-    /* set obj & ind for current row */
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
-
-    /* get the items for the shape */
-    shape->index = shapeindex; /* By definition this is what we asked for */
-    shape->numvalues = layer->numitems;
-
-    shape->values = (char **)malloc( sizeof(char*) * shape->numvalues );
-    if (shape->values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values", "msOracleSpatialLayerNextShape()" );
-      return MS_FAILURE;
-    }
-
-    for( i=0; i < shape->numvalues; ++i ) {
-      shape->values[i] = (char *)malloc(strlen((char *)sthand->items[i][ sthand->row ])+1);
-      if (shape->values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items", "msOracleSpatialLayerNextShape()" );
-        return MS_FAILURE;
-      } else {
-        strcpy(shape->values[i], (char *)sthand->items[i][ sthand->row ]);
-        shape->values[i][strlen((char *)sthand->items[i][ sthand->row ])] = '\0';
-      }
-    }
-
-    /* fetch a layer->type object */
-    success = osGetOrdinates(dthand, hand, shape, obj, ind);
-
-    if (success != MS_SUCCESS) {
-      msSetError( MS_ORACLESPATIALERR, "Call to osGetOrdinates failed.", "msOracleSpatialLayerGetShape()" );
-      return MS_FAILURE;
-    }
-
-    osShapeBounds(shape);
-    if(shape->type == MS_SHAPE_NULL)  {
-      msSetError( MS_ORACLESPATIALERR, "Shape type is null... this probably means a record number was requested that could not have beeen in a result set (as returned by NextShape).", "msOracleSpatialLayerGetShape()" );
-      return MS_FAILURE;
-    }
-
-    return (MS_SUCCESS);
-  } else { /* no resultindex, fetch the shape from the DB */
-    char *table_name;
-    char *query_str = NULL, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield = NULL;
-    int function = 0;
-    int version = 0;
-    sb2 *nullind = NULL;
-    /*OCIDefine *adtp = NULL, *items[QUERY_SIZE] = { NULL };*/
-    OCIDefine *adtp = NULL;
-    OCIDefine  **items = NULL;
-
-    if (layer->debug>=4)
-      msDebug("msOracleSpatialLayerGetShape was called. Using the record = %ld.\n", shapeindex);
-
-    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
-    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
-
-    /* allocate enough space for items */
-    if (layer->numitems > 0) {
-      if (sthand->items_query == NULL)
-        sthand->items_query = (item_text_array_query *)malloc( sizeof(item_text_array_query) * (layer->numitems) );
-
-      if (sthand->items_query == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items_query buffer", "msOracleSpatialLayerGetShape()" );
-        return MS_FAILURE;
-      }
-
-      nullind = (sb2 *)malloc( sizeof(sb2) * (layer->numitems) );
-      if (nullind == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "Cannot allocate nullind buffer", "msOracleSpatialLayerGetShape()" );
-        return MS_FAILURE;
-      }
-      memset(nullind ,0, sizeof(sb2) * (layer->numitems) );
-
-      items = (OCIDefine **)malloc(sizeof(OCIDefine *)*layer->numitems);
-      if (items == NULL) {
-        msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer","msOracleSpatialLayerWhichShapes()" );
-
-        /* clean nullind  */
-        free(nullind);
-
-        return MS_FAILURE;
-      }
-      memset(items ,0,sizeof(OCIDefine *)*layer->numitems);
-    }
-
-    table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-    if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-      msDebug( "Error parsing OracleSpatial DATA variable. Must be: "
-                  "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                  "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                  "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                  "Your data statement: (%s) msOracleSpatialLayerGetShape()\n", layer->data );
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                  "msOracleSpatialLayerGetShape()");
-
-      /* clean nullind  */
-      free(nullind);
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      free(table_name);
-
-      return MS_FAILURE;
-    }
-
-    /*Define the first query to retrive itens*/
-    if (unique[0] == '\0') {
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error parsing OracleSpatial DATA variable for query. To execute "
-                  "query functions you need to define one "
-                  "unique column [USING UNIQUE <#column>]",
-                  "msOracleSpatialLayerGetShape()" );
-
-      /* clean nullind  */
-      free(nullind);
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      free(table_name);
-
-      return MS_FAILURE;
-    } else {
-      query_str = msStringConcatenate(query_str, "SELECT");
-    }
-    /*Define the query*/
-    for( i = 0; i < layer->numitems; ++i ) {
-      msStringConcatenate(query_str, " ");
-      msStringConcatenate(query_str, layer->items[i]);
-      msStringConcatenate(query_str, ",");
-    }
-    char tmpBuf[256];
-    snprintf(tmpBuf, sizeof(tmpBuf), "%ld", shapeindex);
-    query_str = msStringConcatenate(query_str, " ");
-    query_str = msStringConcatenate(query_str, geom_column_name);
-    query_str = msStringConcatenate(query_str, " FROM ");
-    query_str = msStringConcatenate(query_str, table_name);
-    query_str = msStringConcatenate(query_str, " WHERE ");
-    query_str = msStringConcatenate(query_str, unique);
-    query_str = msStringConcatenate(query_str, " = ");
-    query_str = msStringConcatenate(query_str, tmpBuf);
-
-    /*if (layer->filter.native_string != NULL)
-      sprintf( query_str + strlen(query_str), " AND %s", (layer->filter.string));*/
-    query_str = osFilteritem(layer, FUNCTION_NONE, query_str, 2);
-
-
-    if (layer->debug)
-      msDebug("msOracleSpatialLayerGetShape. Sql: %s\n", query_str);
-
-    /*Prepare the handlers to the query*/
-    success = TRY( hand,OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT) );
-
-    if (success && layer->numitems > 0) {
-      for( i = 0; i < layer->numitems && success; i++ )
-        success = TRY( hand, OCIDefineByPos( sthand->stmthp, &items[i], hand->errhp, (ub4)i+1, (dvoid *)sthand->items_query[i], (sb4)TEXT_SIZE, SQLT_STR, (sb2 *)&nullind[i], (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) );
-    }
-
-    if(!success) {
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error: %s . "
-                  "Query statement: %s . "
-                  "Check your data statement.",
-                  "msOracleSpatialLayerGetShape()\n", hand->last_oci_error, query_str );
-
-      /* clean nullind  */
-      free(nullind);
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-
-      return MS_FAILURE;
-    }
-
-    if (success) {
-      success = TRY( hand, OCIDefineByPos( sthand->stmthp, &adtp, hand->errhp, (ub4)layer->numitems+1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT) )
-                && TRY( hand, OCIDefineObject( adtp, hand->errhp, dthand->tdo, (dvoid **)sthand->obj, (ub4 *)0, (dvoid **)sthand->ind, (ub4 *)0 ) )
-                && TRY (hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ))
-                && TRY (hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ));
-
-    }
-
-    if(!success) {
-      msDebug( "Error: %s . "
-                  "Query statement: %s ."
-                  "Check your data statement."
-                  "in msOracleSpatialLayerGetShape()\n", hand->last_oci_error, query_str );
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error in Query statement. Check your server logs","msOracleSpatialLayerGetShape()");
-
-      /* clean nullind  */
-      free(nullind);
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-
-      return MS_FAILURE;
-    }
-
-    shape->type = MS_SHAPE_NULL;
-
-    /* no rows fetched */
-    if (sthand->rows_fetched == 0) {
-      /* clean nullind  */
-      free(nullind);
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-
-      return (MS_DONE);
-    }
-
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
-
-    /* get the items for the shape */
-    shape->numvalues = layer->numitems;
-    shape->values = (char **) malloc(sizeof(char *) * layer->numitems);
-    if (shape->values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values.", "msOracleSpatialLayerGetShape()" );
-
-      /* clean nullind  */
-      free(nullind);
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-
-      return MS_FAILURE;
-    }
-
-    shape->index = shapeindex;
-
-    for( i = 0; i < layer->numitems; ++i ) {
-      shape->values[i] = (char *)malloc(strlen((char *)sthand->items_query[sthand->row][i])+1);
-
-      if (shape->values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items buffer.", "msOracleSpatialLayerGetShape()" );
-
-        /* clean nullind  */
-        free(nullind);
-
-        /* clean items */
-        free(items);
-
-        if (geom_column_name) free(geom_column_name);
-        if (srid) free(srid);
-        if (unique) free(unique);
-        if (indexfield) free(indexfield);
-        if (query_str) free(query_str);
-        free(table_name);
-
-        return MS_FAILURE;
-      } else {
-        if (nullind[i] != OCI_IND_NULL) {
-          strcpy(shape->values[i], (char *)sthand->items_query[sthand->row][i]);
-          shape->values[i][strlen((char *)sthand->items_query[sthand->row][i])] = '\0';
-        } else {
-          shape->values[i][0] = '\0';
-        }
-      }
-    }
-
-    /* increment for next row */
-    sthand->row_num++;
-    sthand->row++;
-
-    /* fetch a layer->type object */
-    success = osGetOrdinates(dthand, hand, shape, obj, ind);
-    if (success != MS_SUCCESS) {
-      msSetError( MS_ORACLESPATIALERR, "Cannot execute query", "msOracleSpatialLayerGetShape()" );
-
-      /* clean nullind  */
-      free(nullind);
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-
-      return MS_FAILURE;
-    }
-    osShapeBounds(shape);
-    sthand->row = sthand->row_num = 0;
-
-    /* clean nullind  */
-    free(nullind);
-
-    /* clean items */
-    free(items);
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
-    free(table_name);
-
-    return (MS_SUCCESS);
-  }
-}
-
-int msOracleSpatialLayerInitItemInfo( layerObj *layer )
-{
-  int i;
-  int *itemindexes ;
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerInitItemInfo was called.\n");
-
-  if (layer->numitems == 0)
-    return MS_SUCCESS;
-
-  if (layer->iteminfo)
-    free( layer->iteminfo );
-
-  if ((layer->iteminfo = (long *)malloc(sizeof(int)*layer->numitems))== NULL) {
-    msSetError(MS_MEMERR, NULL, "msOracleSpatialLayerInitItemInfo()");
-    return MS_FAILURE;
-  }
-
-  itemindexes = (int*)layer->iteminfo;
-
-
-
-  for(i=0; i < layer->numitems; i++){
-    itemindexes[i] = i;  /*last one is always the geometry one - the rest are non-geom*/
-  }
-
-  return MS_SUCCESS;
-}
-
-/* AutoProjection Support for RFC 37 #3333
- * TODO: Needs testing
- */
-int msOracleSpatialLayerGetAutoProjection( layerObj *layer, projectionObj *projection )
-{
-  char *table_name;
-  char *query_str, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
-  int success;
-  int function = 0;
-  int version = 0;
-  char wktext[4000];
-
-  OCIDefine *def1p = NULL;
-  OCIBind *bnd1p = NULL,  *bnd2p = NULL;
-
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-  msOracleSpatialHandler *hand = NULL;
-  msOracleSpatialStatement *sthand = NULL;
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerGetAutoProjection was called.\n");
-
-  if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetAutoProjection called on unopened layer","msOracleSpatialLayerGetAutoProjection()");
-    return MS_FAILURE;
-  } else {
-    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
-  }
-
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-    msDebug(  "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s) "
-                "in msOracleSpatialLayerGetAutoProjection()\n", layer->data );
-
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable",
-                "msOracleSpatialLayerGetAutoProjection()");
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    free(table_name);
-
-    return MS_FAILURE;
-  }
-
-  query_str = "SELECT wktext FROM mdsys.all_sdo_geom_metadata m, mdsys.cs_srs c WHERE c.srid = m.srid and m.owner||'.'||m.table_name = :table_name and m.column_name = :geo_col_name "
-              "UNION SELECT wktext from mdsys.user_sdo_geom_metadata m, mdsys.cs_srs c WHERE c.srid = m.srid and m.table_name = :table_name and m.column_name = :geo_col_name";
-
-  if (layer->debug>=2)
-    msDebug("msOracleSpatialLayerGetAutoProjection. Using this Sql to retrieve the projection: %s.\n", query_str);
-
-  /*Prepare the handlers to the query*/
-  success = TRY( hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT ) )
-            && TRY( hand, OCIBindByName( sthand->stmthp, &bnd2p, hand->errhp, (text *) ":table_name", strlen(":table_name"), (ub1*) table_name, strlen(table_name)+1, SQLT_STR, (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT ) )
-            && TRY( hand, OCIBindByName( sthand->stmthp, &bnd1p, hand->errhp, (text *) ":geo_col_name", strlen(":geo_col_name"), (ub1*) geom_column_name, strlen(geom_column_name)+1, SQLT_STR, (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT ) )
-            && TRY( hand, OCIDefineByPos( sthand->stmthp, &def1p, hand->errhp, (ub4)1, (dvoid *)wktext, (sb4)4000, SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) )
-            && TRY( hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)0, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) )
-            && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) );
-
-  if(!success) {
-    msDebug( "Error: %s . "
-                "Query statement: %s . "
-                "Check your data statement."
-                "in msOracleSpatialLayerGetAutoProjection()\n", hand->last_oci_error, query_str );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error "
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerGetAutoProjection()" );
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    free(table_name);
-    return MS_FAILURE;
-  }
-  do {
-    success = TRY( hand, OCIStmtFetch( sthand->stmthp, hand->errhp, (ub4)1, (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT ) )
-              && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) );
-    if (success && sthand->rows_fetched > 0) {
-
-      if( layer->debug )
-        msDebug("Found WKT projection for table %s: %s\n", table_name, wktext);
-
-      if(wktext != NULL && projection != NULL)
-        if(msOGCWKT2ProjectionObj(wktext, projection, layer->debug) == MS_FAILURE)
-          return(MS_FAILURE);
-    }
-  } while (sthand->rows_fetched > 0);
-
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  free(table_name);
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *             msOracleSpatialGetFieldDefn()
- *
- * Pass the field definitions through to the layer metadata in the
- * "gml_[item]_{type,width,precision}" set of metadata items for
- * defining fields.
- **********************************************************************/
-static void
-msOracleSpatialGetFieldDefn( layerObj *layer,
-                             msOracleSpatialHandler *hand,
-                             const char *item,
-                             OCIParam *pard )
-
-{
-  const char *gml_type = "Character";
-  char gml_width[32], gml_precision[32];
-  int success;
-  ub2 rzttype, nOCILen;
-
-  gml_width[0] = '\0';
-  gml_precision[0] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*      Get basic parameter details.                                    */
-  /* -------------------------------------------------------------------- */
-  success =
-    TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                           (dvoid*)&rzttype,(ub4 *)0,
-                           (ub4) OCI_ATTR_DATA_TYPE, hand->errhp ))
-    && TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                              (dvoid*)&nOCILen ,(ub4 *)0,
-                              (ub4) OCI_ATTR_DATA_SIZE, hand->errhp ));
-
-  if( !success )
-    return;
-
-  switch( rzttype ) {
-    case SQLT_CHR:
-    case SQLT_AFC:
-      gml_type = "Character";
-      if( nOCILen <= 4000 )
-        sprintf( gml_width, "%d", nOCILen );
-      break;
-
-    case SQLT_NUM: {
-      /* NOTE: OCI docs say this should be ub1 type, but we have
-         determined that oracle is actually returning a short so we
-         use that type and try to compensate for possible problems by
-         initializing, and dividing by 256 if it is large. */
-      unsigned short byPrecision = 0;
-      sb1 nScale = 0;
-
-      if( !TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                                  (dvoid*)&byPrecision ,(ub4 *)0,
-                                  (ub4) OCI_ATTR_PRECISION,
-                                  hand->errhp ))
-          || !TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                                     (dvoid*)&nScale,(ub4 *)0,
-                                     (ub4) OCI_ATTR_SCALE,
-                                     hand->errhp )) )
-        return;
-      if( byPrecision > 255 )
-        byPrecision = byPrecision / 256;
-
-      if( nScale > 0 ) {
-        gml_type = "Real";
-        sprintf( gml_width, "%d", byPrecision );
-        sprintf( gml_precision, "%d", nScale );
-      } else if( nScale < 0 )
-        gml_type = "Real";
-      else {
-        gml_type = "Integer";
-        if( byPrecision < 38 )
-          sprintf( gml_width, "%d", byPrecision );
-      }
-    }
-    break;
-
-    case SQLT_DAT:
-    case SQLT_DATE:
-      gml_type = "Date";
-      break;
-    case SQLT_TIMESTAMP:
-    case SQLT_TIMESTAMP_TZ:
-    case SQLT_TIMESTAMP_LTZ:
-      gml_type = "DateTime";
-      break;
-    case SQLT_TIME:
-    case SQLT_TIME_TZ:
-      gml_type = "Time";
-      break;
-
-    default:
-      gml_type = "Character";
-  }
-
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
-}
-
-int msOracleSpatialLayerGetItems( layerObj *layer )
-{
-  char *rzt = "";
-  ub2 rzttype = 0;
-  char *flk = "";
-  int function = 0;
-  int version = 0;
-  int existgeom;
-  int count_item, flk_len, success, i;
-  char *table_name;
-  char * query_str = NULL, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
-  OCIParam *pard = (OCIParam *) 0;
-
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *) layer->layerinfo;
-  msOracleSpatialHandler *hand = NULL;
-  msOracleSpatialStatement *sthand = NULL;
-  int get_field_details = 0;
-  const char *value;
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerGetItems was called.\n");
-
-  if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetItems called on unopened layer", "msOracleSpatialLayerGetItems()" );
-    return MS_FAILURE;
-  } else {
-    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
-  }
-
-  /* Will we want to capture the field details? */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    get_field_details = 1;
-
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version)) {
-    msDebug(   "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s)"
-                "in msOracleSpatialLayerGetItems()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                "msOracleSpatialLayerGetItems()");
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    free(table_name);
-    return MS_FAILURE;
-  }
-  query_str = msStringConcatenate(query_str, "SELECT * FROM ");
-  query_str = msStringConcatenate(query_str, table_name);
-
-  success =  TRY( hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DESCRIBE_ONLY) )
-             && TRY( hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DESCRIBE_ONLY ) )
-             && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&layer->numitems, (ub4 *)0, OCI_ATTR_PARAM_COUNT, hand->errhp) );
-
-
-  if (!success) {
-    msSetError( MS_QUERYERR, "Cannot retrieve column list", "msOracleSpatialLayerGetItems()" );
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
-    free(table_name);
-    return MS_FAILURE;
-  }
-
-  sthand->row_num = sthand->row = 0;
-  layer->numitems = layer->numitems-1;
-
-  layer->items = malloc (sizeof(char *) * (layer->numitems));
-  if (layer->items == NULL) {
-    msSetError( MS_ORACLESPATIALERR,"Cannot allocate items", "msOracleSpatialLayerGetItems()" );
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
-    free(table_name);
-    return MS_FAILURE;
-  }
-
-  if (layer->numitems > 0) {
-    if (sthand->items_query == NULL)
-      sthand->items_query = (item_text_array_query *)malloc( sizeof(item_text_array_query) * (layer->numitems) );
-
-    if (sthand->items_query == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer", "msOracleSpatialLayerGetItems()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-      return MS_FAILURE;
-    }
-  }
-
-  count_item = 0;
-  existgeom = 0;
-
-  /*Upcase conversion for the geom_column_name*/
-  for (i=0; geom_column_name[i] != '\0'; i++)
-    geom_column_name[i] = toupper(geom_column_name[i]);
-
-  /*Retrive columns name from the user table*/
-  for (i = 0; i <= layer->numitems; i++) {
-
-    success = TRY( hand, OCIParamGet ((dvoid*) sthand->stmthp, (ub4)OCI_HTYPE_STMT,hand->errhp,(dvoid*)&pard, (ub4)i+1))
-              && TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,(dvoid*)&rzttype,(ub4 *)0, (ub4) OCI_ATTR_DATA_TYPE, hand->errhp ))
-              && TRY( hand, OCIParamGet ((dvoid*) sthand->stmthp, (ub4)OCI_HTYPE_STMT,hand->errhp,(dvoid*)&pard, (ub4)i+1))
-              && TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,(dvoid*)&rzt,(ub4 *)&flk_len, (ub4) OCI_ATTR_NAME, hand->errhp ));
-
-     /*  if (layer->debug)
-            msDebug("msOracleSpatialLayerGetItems checking type. Column = %s Type = %d\n", rzt, rzttype);  */
-    flk = (char *)malloc(sizeof(char*) * flk_len+1);
-    if (flk == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items", "msOracleSpatialLayerGetItems()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (query_str) free(query_str);
-      free(table_name);
-      return MS_FAILURE;
-    } else {
-      //layer->iteminfo->dtype[i]= 1;
-      strlcpy(flk, rzt, flk_len+1);
-    }
-
-    /*Comapre the column name (flk) with geom_column_name and ignore with true*/
-    if (strcmp(flk, geom_column_name) != 0) {
-      if (rzttype!=OCI_TYPECODE_BLOB) {
-        layer->items[count_item] = (char *)malloc(sizeof(char) * flk_len+1);
-        if (layer->items[count_item] == NULL) {
-          msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items buffer", "msOracleSpatialLayerGetItems()" );
-          if (geom_column_name) free(geom_column_name);
-          if (srid) free(srid);
-          if (unique) free(unique);
-          if (query_str) free(query_str);
-          free(table_name);
-          return MS_FAILURE;
-        }
-
-        strcpy(layer->items[count_item], flk);
-        count_item++;
-
-       if( get_field_details )
-          msOracleSpatialGetFieldDefn( layer, hand,
-                                       layer->items[count_item-1],
-                                       pard );
-      }
-    } else
-      existgeom = 1;
-
-    strcpy( rzt, "" );
-    free(flk); /* Better?!*/
-    flk_len = 0;
-  }
-
-  layer->numitems = count_item;
-
-  if (!(existgeom)) {
-    msSetError (MS_ORACLESPATIALERR, "No geometry column, check stmt", "msOracleSpatialLayerGetItems()" );
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
-    free(table_name);
-    return MS_FAILURE;
-  }
-
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (query_str) free(query_str);
-  free(table_name);
-  return msOracleSpatialLayerInitItemInfo( layer );
-}
-
-int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  char *table_name;
-  char * query_str = NULL, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
-  int success, i;
-  int function = 0;
-  int version = 0;
-  SDOGeometryObj *obj = NULL;
-  SDOGeometryInd *ind = NULL;
-  shapeObj shape;
-  rectObj bounds;
-  /*OCIDefine *adtp = NULL, *items[QUERY_SIZE] = { NULL };*/
-  OCIDefine *adtp = NULL;
-  OCIDefine **items = NULL;
-
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-  msOracleSpatialDataHandler *dthand = NULL;
-  msOracleSpatialHandler *hand = NULL;
-  msOracleSpatialStatement *sthand = NULL;
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerGetExtent was called.\n");
-
-  if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetExtent called on unopened layer","msOracleSpatialLayerGetExtent()");
-    return MS_FAILURE;
-  } else {
-    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
-    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
-  }
-
-  /* allocate enough space for items */
-  if (layer->numitems > 0) {
-    sthand->items_query = (item_text_array_query *)malloc( sizeof(item_text_array_query) * (layer->numitems) );
-    if (sthand->items_query == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items buffer", "msOracleSpatialLayerGetExtent()" );
-      return MS_FAILURE;
-    }
-    items = (OCIDefine **)malloc(sizeof(OCIDefine *)*layer->numitems);
-    if (items == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer","msOracleSpatialLayerWhichShapes()" );
-      return MS_FAILURE;
-    }
-    memset(items ,0,sizeof(OCIDefine *)*layer->numitems);
-  }
-
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-    msDebug(   "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s) "
-                "in msOracleSpatialLayerGetExtent()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                "msOracleSpatialLayerGetExtent()");
-    /* clean items */
-    free(items);
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    free(table_name);
-
-    return MS_FAILURE;
-  }
-
-  query_str = osAggrGetExtent(layer, query_str, geom_column_name, table_name);
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerGetExtent. Using this Sql to retrieve the extent: %s.\n", query_str);
-
-  /*Prepare the handlers to the query*/
-  success = TRY( hand,OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT) );
-
-  if (success && layer->numitems > 0) {
-    for( i = 0; i < layer->numitems && success; ++i )
-      success = TRY( hand, OCIDefineByPos( sthand->stmthp, &items[i], hand->errhp, (ub4)i+1, (dvoid *)sthand->items_query[i], (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) );
-  }
-
-  if(!success) {
-    msDebug(   "Error: %s . "
-                "Query statement: %s . "
-                "Check your data statement."
-                "in msOracleSpatialLayerGetExtent()\n", hand->last_oci_error, query_str );
-
-    msSetError( MS_ORACLESPATIALERR,
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerGetExtent()" );
-
-    /* clean items */
-    free(items);
-
-    if (query_str) free(query_str);
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    free(table_name);
-
-    return MS_FAILURE;
-  }
-
-  if (success) {
-    success = TRY( hand, OCIDefineByPos( sthand->stmthp, &adtp, hand->errhp, (ub4)layer->numitems+1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT) )
-              && TRY( hand, OCIDefineObject( adtp, hand->errhp, dthand->tdo, (dvoid **)sthand->obj, (ub4 *)0, (dvoid **)sthand->ind, (ub4 *)0 ) )
-              && TRY (hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ))
-              && TRY (hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ));
-
-  }
-
-  if(!success) {
-    msDebug(    "Error: %s . "
-                "Query statement: %s ."
-                "Check your data statement."
-                "in msOracleSpatialLayerGetExtent()\n", hand->last_oci_error, query_str );
-    msSetError( MS_ORACLESPATIALERR,
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerGetExtent()" );
-
-    /* clean items */
-    free(items);
-    if (query_str) free(query_str);
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    free(table_name);
-
-    return MS_FAILURE;
-  }
-
-  /* should begin processing first row */
-  sthand->row_num = sthand->row = 0;
-  msInitShape( &shape );
-  do {
-    /* is buffer empty? */
-    if (sthand->row_num >= sthand->rows_fetched) {
-      /* fetch more */
-      success = TRY( hand, OCIStmtFetch( sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ) );
-
-      if (!success || sthand->rows_fetched == 0 || sthand->row_num >= sthand->rows_fetched) {
-        hand->last_oci_status=MS_SUCCESS;
-        break;
-      }
-
-      sthand->row = 0; /* reset row index */
-    }
-
-    /* no rows fetched */
-    if (sthand->rows_fetched == 0)
-      break;
-
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
-
-    /* get the items for the shape */
-    shape.numvalues = layer->numitems;
-    shape.values = (char **) malloc(sizeof(char *) * layer->numitems);
-    if (shape.values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values.", "msOracleSpatialLayerGetExtent()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-      return MS_FAILURE;
-    }
-
-    shape.index = sthand->row_num;
-
-    for( i = 0; i < layer->numitems; ++i ) {
-      shape.values[i] = (char *)malloc(strlen((char *)sthand->items_query[sthand->row][i])+1);
-
-      if (shape.values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items buffer.", "msOracleSpatialLayerGetExtent()" );
-
-        /* clean items */
-        free(items);
-
-        if (geom_column_name) free(geom_column_name);
-        if (srid) free(srid);
-        if (unique) free(unique);
-        if (indexfield) free(indexfield);
-        if (query_str) free(query_str);
-        free(table_name);
-
-        return MS_FAILURE;
-      } else {
-        strcpy(shape.values[i], (char *)sthand->items_query[sthand->row][i]);
-        shape.values[i][strlen((char *)sthand->items_query[sthand->row][i])] = '\0';
-      }
-    }
-
-    /* increment for next row */
-    sthand->row_num++;
-    sthand->row++;
-
-    /* fetch a layer->type object */
-    success = osGetOrdinates(dthand, hand, &shape, obj, ind);
-    if (success != MS_SUCCESS) {
-      msSetError( MS_ORACLESPATIALERR, "Cannot execute query", "msOracleSpatialLayerGetExtent()" );
-
-      /* clean items */
-      free(items);
-
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
-      free(table_name);
-
-      return MS_FAILURE;
-    }
-
-  } while(sthand->row <= sthand->rows_fetched);
-
-  sthand->row = sthand->row_num = 0;
-
-  osShapeBounds(&shape);
-  bounds = shape.bounds;
-
-  extent->minx = bounds.minx;
-  extent->miny = bounds.miny;
-  extent->maxx = bounds.maxx;
-  extent->maxy = bounds.maxy;
-
-  msFreeShape(&shape);
-
-  /* clean items */
-  free(items);
-
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (query_str) free(query_str);
-  free(table_name);
-
-  return(MS_SUCCESS);
-}
-
-void msOracleSpatialLayerFreeItemInfo( layerObj *layer )
-{
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerFreeItemInfo was called.\n");
-
-  if (layer->iteminfo)
-    free(layer->iteminfo);
-
-  layer->iteminfo = NULL;
-  /* nothing to do */
-}
-
-int msOracleSpatialLayerGetAutoStyle( mapObj *map, layerObj *layer, classObj *c, shapeObj *shape )
-{
-  (void)map;
-  (void)layer;
-  (void)c;
-  (void)shape;
-  msSetError( MS_ORACLESPATIALERR, "Function not implemented yet", "msLayerGetAutoStyle()" );
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                       msOracleSpatialEscapePropertyName              */
-/*                                                                      */
-/*      Return the property name in a properly escaped and quoted form. */
-/************************************************************************/
-char *msOracleSpatialEscapePropertyName(layerObj *layer, const char* pszString)
-{
-  char* pszEscapedStr=NULL;
-  int i, j = 0;
-
-  if (layer && pszString && strlen(pszString) > 0) {
-    int nLength = strlen(pszString);
-
-    pszEscapedStr = (char*) msSmallMalloc( 1 + 2 * nLength + 1 + 1);
-    //pszEscapedStr[j++] = '';
-
-    for (i=0; i<nLength; i++) {
-      char c = pszString[i];
-      if (c == '"') {
-        pszEscapedStr[j++] = '"';
-        pszEscapedStr[j++] ='"';
-      } else if (c == '\\') {
-        pszEscapedStr[j++] = '\\';
-        pszEscapedStr[j++] = '\\';
-      } else
-        pszEscapedStr[j++] = c;
-    }
-    //pszEscapedStr[j++] = '';
-    pszEscapedStr[j++] = 0;
-
-  }
-  return pszEscapedStr;
-}
-
-int msOracleSpatialGetPaging(layerObj *layer)
-{
-  msOracleSpatialLayerInfo *layerinfo = NULL;
-
-  //if (layer->debug)
-  //  msDebug("msOracleSpatialLayerGetPaging was called.\n");
-
-  if(!msOracleSpatialLayerIsOpen(layer))
-    return MS_TRUE;
-
-  assert( layer->layerinfo != NULL);
-  layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-
-  return layerinfo->paging;
-}
-
-void msOracleSpatialEnablePaging(layerObj *layer, int value)
-{
-  msOracleSpatialLayerInfo *layerinfo = NULL;
-
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerEnablePaging was called.\n");
-
-  if(!msOracleSpatialLayerIsOpen(layer))
-  {
-    if(msOracleSpatialLayerOpen(layer) != MS_SUCCESS)
-    {
-      return;
-    }
-  }
-
-  assert( layer->layerinfo != NULL);
-  layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
-
-  layerinfo->paging = value;
-
-  return;
-}
-
-int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-  char *native_string = NULL;
-
-  int nodeCount = 0;
-
-  int function = 0, version = 0, dwithin = 0, regexp_like = 0, case_ins = 0, ieq = 0;
-  char *table_name = NULL;
-  char *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
-  char *snippet = NULL;
-  char *strtmpl = NULL;
-  double dfDistance = -1;
-
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-    msDebug(   "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s)"
-                "in msOracleSpatialLayerGetExtent()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                "msOracleSpatialLayerGetExtent()");
-    /* clean items */
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (table_name) free(table_name);
-
-    return MS_FAILURE;
-  }
-
-  //msDebug("filter.string was set: %s\n",filter->string);
-  if(!filter->string) {
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (table_name) free(table_name);
-
-    return MS_SUCCESS;
-  }
-  /* for backwards compatibility we continue to allow SQL snippets as a string */
-
- if(filter->type == MS_STRING && filter->string && filteritem) { /* item/value pair */
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      native_string = msStringConcatenate(native_string, "upper(");
-      native_string = msStringConcatenate(native_string, filteritem);
-      native_string = msStringConcatenate(native_string, ") = upper(");
-    } else {
-      native_string = msStringConcatenate(native_string, filteritem);
-      native_string = msStringConcatenate(native_string, " = ");
-    }
-
-    strtmpl = "'%s'";  /* don't have a type for the righthand literal so assume it's a string and we quote */
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
-    sprintf(snippet, strtmpl, filter->string);  // TODO: escape filter->string (msPostGISEscapeSQLParam)
-    native_string = msStringConcatenate(native_string, snippet);
-    free(snippet);
-
-    if(filter->flags & MS_EXP_INSENSITIVE) native_string = msStringConcatenate(native_string, ")");
-
-    if (layer->debug>=2) msDebug("msOracleSpatialLayerTranslateFilter: **item/value combo: %s\n", native_string);
-  } else if(filter->type == MS_REGEX && filter->string && filteritem) { /* item/regex pair */
-    native_string = msStringConcatenate(native_string, "REGEXP_LIKE (");
-    native_string = msStrdup(filteritem);
-    native_string = msStringConcatenate(native_string, ", ");
-    strtmpl = "'%s'";
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
-    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string (msPostGISEscapeSQLParam)
-    native_string = msStringConcatenate(native_string, snippet);
-
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      native_string = msStringConcatenate(native_string, ",i ");
-    }
-    native_string = msStringConcatenate(native_string, " )");
-    free(snippet);
-  } else if(filter->type == MS_EXPRESSION) {
-
-    tokenListNodeObjPtr node = NULL;
-    //tokenListNodeObjPtr nextNode = NULL;
-
-    if (layer->debug>2)
-      msDebug("msOracleSpatialLayerTranslateFilter. String: %s \n", filter->string);
-    if (layer->debug>2 && !filter->tokens)
-      msDebug("msOracleSpatialLayerTranslateFilter. No tokens to process\n");
-
-    if(!filter->tokens) return MS_SUCCESS; /* nothing to work from */
-
-    if (layer->debug>2)
-      msDebug("msOracleSpatialLayerTranslateFilter. There are tokens to process \n");
-
-    /* try to convert tokens */
-    node = filter->tokens;
-    while (node != NULL) {
-      //msDebug("token count :%i, token is %i\n", nodeCount, node->token);
-      switch(node->token) {
-        case '(':
-          // if (buffer == MS_FALSE)
-           native_string = msStringConcatenate(native_string, "( ");
-           break;
-        case ')':
-           if (regexp_like == MS_TRUE) {
-            if (case_ins == MS_TRUE) {
-              native_string = msStringConcatenate(native_string, ",'i' ");
-              case_ins = MS_FALSE;
-            }
-           regexp_like = MS_FALSE;
-           native_string = msStringConcatenate(native_string, " )");
-           msDebug("closing RE comparison\n");
-           }
-           native_string = msStringConcatenate(native_string, " )");
-           break;
-        case MS_TOKEN_LITERAL_NUMBER:
-        {
-          char buffer[32];
-          if (dwithin == MS_TRUE) {
-            dfDistance = node->tokenval.dblval;
-            if (layer->units == MS_DD){
-              dfDistance *= msInchesPerUnit(MS_DD,0)/msInchesPerUnit(MS_METERS,0);
-              //msDebug("Converted Distance value is %lf\n", dfDistance);
-            }
-            snprintf(buffer, sizeof(buffer), "%.18g", dfDistance);
-            native_string = msStringConcatenate(native_string, "'distance=");
-            native_string = msStringConcatenate(native_string, buffer);
-            native_string = msStringConcatenate(native_string, "'");
-          } else {
-            snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
-            native_string = msStringConcatenate(native_string, buffer);
-          }
-          break;
-        }
-        case MS_TOKEN_LITERAL_STRING:
-          strtmpl = "%s";
-          snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(node->tokenval.strval));
-          sprintf(snippet, strtmpl, node->tokenval.strval);  // TODO: escape strval
-          snippet = msReplaceSubstring(snippet,"'","''");
-          native_string = msStringConcatenate(native_string, "'");
-          if (ieq == MS_TRUE) {
-            native_string = msStringConcatenate(native_string, "^");
-          }
-          native_string = msStringConcatenate(native_string, snippet);
-          if (ieq == MS_TRUE) {
-            native_string = msStringConcatenate(native_string, "$");
-            ieq = MS_FALSE;
-          }
-          native_string = msStringConcatenate(native_string, "'");
-          msFree(snippet);
-           break;
-        case MS_TOKEN_LITERAL_BOOLEAN:
-          if(node->tokenval.dblval == MS_TRUE)
-            native_string = msStringConcatenate(native_string, "'TRUE'");
-          else
-             native_string = msStringConcatenate(native_string, "'FALSE'");
-           break;
-        case MS_TOKEN_LITERAL_TIME:
-        {
-          int resolution = msTimeGetResolution(node->tokensrc);
-          snippet = (char *) msSmallMalloc(128);
-          switch(resolution) {
-            case TIME_RESOLUTION_YEAR:
-              strtmpl = "to_date('%d-01','YYYY-MM')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900));
-              break;
-            case TIME_RESOLUTION_MONTH:
-              strtmpl = "to_date('%d-%02d','YYYY-MM')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1));
-              break;
-            case TIME_RESOLUTION_DAY:
-              strtmpl = "to_date('%d-%02d-%02d','YYYY-MM-DD') ";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday);
-              break;
-            case TIME_RESOLUTION_HOUR:
-              strtmpl = "to_timestamp('%d-%02d-%02d %02d','YYYY-MM-DD hh24')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour);
-              break;
-            case TIME_RESOLUTION_MINUTE:
-              strtmpl = "to_timestamp('%d-%02d-%02d %02d:%02d','YYYY-MM-DD hh24:mi')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour, node->tokenval.tmval.tm_min);
-              break;
-            case TIME_RESOLUTION_SECOND:
-              strtmpl = "to_timestamp('%d-%02d-%02d %02d:%02d:%02d','YYYY-MM-DD hh24:mi:ss')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour, node->tokenval.tmval.tm_min, node->tokenval.tmval.tm_sec);
-              break;
-          }
-          native_string = msStringConcatenate(native_string, snippet);
-          msFree(snippet);
-          break;
-        }
-        case MS_TOKEN_LITERAL_SHAPE:
-          native_string = msStringConcatenate(native_string, " SDO_GEOMETRY('");
-          native_string = msStringConcatenate(native_string, msShapeToWKT(node->tokenval.shpval));
-          native_string = msStringConcatenate(native_string, "'");
-          if(srid && strcmp(srid, "") != 0) {
-            native_string = msStringConcatenate(native_string, ", ");
-            native_string = msStringConcatenate(native_string, srid);
-          }
-          native_string = msStringConcatenate(native_string, ") ");
-          //msDebug("------> srid node value: %s", node->tokenval.shpval);
-          break;
-        case MS_TOKEN_BINDING_DOUBLE:
-          native_string = msStringConcatenate(native_string, node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_BINDING_INTEGER:
-          native_string = msStringConcatenate(native_string, node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_BINDING_STRING:
-         if (node->next->token == MS_TOKEN_COMPARISON_RE || node->next->token == MS_TOKEN_COMPARISON_IRE
-          || node->next->token == MS_TOKEN_COMPARISON_IEQ ) {
-              native_string = msStringConcatenate(native_string, "REGEXP_LIKE( ");
-          }
-          strtmpl = "%s";
-          snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(node->tokenval.strval));
-          sprintf(snippet, strtmpl, node->tokenval.strval);  // TODO: escape strval (msPostGISEscapeSQLParam)
-          native_string = msStringConcatenate(native_string, snippet);
-          free(snippet);
-          break;
-        case MS_TOKEN_BINDING_TIME:
-          native_string = msStringConcatenate(native_string, node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_BINDING_SHAPE:
-          native_string = msStringConcatenate(native_string, geom_column_name);
-          break;
-        case MS_TOKEN_BINDING_MAP_CELLSIZE:
-        {
-          char buffer[32];
-          snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
-          native_string = msStringConcatenate(native_string, buffer);
-          break;
-        }
-        case MS_TOKEN_LOGICAL_AND:
-          native_string = msStringConcatenate(native_string, " AND ");
-          break;
-        case MS_TOKEN_LOGICAL_OR:
-          native_string = msStringConcatenate(native_string, " OR ");
-          break;
-        case MS_TOKEN_LOGICAL_NOT:
-          native_string = msStringConcatenate(native_string, " NOT ");
-          break;
-        case MS_TOKEN_COMPARISON_EQ:
-          native_string = msStringConcatenate(native_string, " = ");
-          break;
-        case MS_TOKEN_COMPARISON_NE:
-          native_string = msStringConcatenate(native_string, " != ");
-          break;
-        case MS_TOKEN_COMPARISON_GT:
-          native_string = msStringConcatenate(native_string, " > ");
-          break;
-        case MS_TOKEN_COMPARISON_GE:
-          native_string = msStringConcatenate(native_string, " >= ");
-          break;
-        case MS_TOKEN_COMPARISON_LT:
-          native_string = msStringConcatenate(native_string, " < ");
-          break;
-        case MS_TOKEN_COMPARISON_LE:
-          native_string = msStringConcatenate(native_string, " <= ");
-          break;
-        case MS_TOKEN_COMPARISON_IEQ:
-          // this is for  case insensitve equals check
-          msDebug("got a IEQ comparison\n");
-          regexp_like = MS_TRUE;
-          case_ins = MS_TRUE;
-          ieq = MS_TRUE;
-          native_string = msStringConcatenate(native_string, ", ");
-          break;
-        case MS_TOKEN_COMPARISON_RE:
-          // the regex formats that MS uses as Oracle users are different so just return and eval the regex's in MS
-          //return MS_SUCCESS;
-          msDebug("got a RE comparison\n");
-          regexp_like = MS_TRUE;
-          native_string = msStringConcatenate(native_string, ", ");
-          break;
-        case MS_TOKEN_COMPARISON_IRE:
-          // the regex formats that MS uses as Oracle users are different so just return and eval the regex's in MS
-          regexp_like = MS_TRUE;
-          case_ins = MS_TRUE;
-          native_string = msStringConcatenate(native_string, ", ");
-          break;
-        case MS_TOKEN_COMPARISON_IN:
-          native_string = msStringConcatenate(native_string, " IN ");
-          break;
-        case MS_TOKEN_COMPARISON_LIKE:
-          native_string = msStringConcatenate(native_string, " LIKE ");
-          break;
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-          native_string = msStringConcatenate(native_string, " ST_INTERSECTS ");
-          break;
-        case MS_TOKEN_COMPARISON_DISJOINT:
-          native_string = msStringConcatenate(native_string, " NOT ST_INTERSECTS ");
-          break;
-        case MS_TOKEN_COMPARISON_TOUCHES:
-          native_string = msStringConcatenate(native_string, " ST_TOUCH ");
-          break;
-        case MS_TOKEN_COMPARISON_OVERLAPS:
-          native_string = msStringConcatenate(native_string, " ST_OVERLAPS ");
-          break;
-        case MS_TOKEN_COMPARISON_CROSSES:
-          native_string = msStringConcatenate(native_string, " SDO_OVERLAPBDYDISJOINT ");
-          break;
-        case MS_TOKEN_COMPARISON_WITHIN:
-          native_string = msStringConcatenate(native_string, " ST_INSIDE ");
-          break;
-        case MS_TOKEN_COMPARISON_CONTAINS:
-          native_string = msStringConcatenate(native_string, " SDO_CONTAINS ");
-          break;
-        case MS_TOKEN_COMPARISON_EQUALS:
-          native_string = msStringConcatenate(native_string, " SDO_EQUAL ");
-          break;
-        case MS_TOKEN_COMPARISON_BEYOND:
-          //support for the wfs case
-          dwithin = MS_TRUE;
-          native_string = msStringConcatenate(native_string, "NOT SDO_WITHIN_DISTANCE ");
-          break;
-        case MS_TOKEN_COMPARISON_DWITHIN:
-          dwithin = MS_TRUE;
-          native_string = msStringConcatenate(native_string, "SDO_WITHIN_DISTANCE ");
-          break;
-        case MS_TOKEN_FUNCTION_LENGTH:
-          break;
-        case MS_TOKEN_FUNCTION_TOSTRING:
-          break;
-        case MS_TOKEN_FUNCTION_COMMIFY:
-          break;
-        case MS_TOKEN_FUNCTION_AREA:
-          native_string = msStringConcatenate(native_string, "SDO_GEOM.SDO_AREA ");
-          break;
-        case MS_TOKEN_FUNCTION_ROUND:
-          native_string = msStringConcatenate(native_string, "ROUND ");
-          break;
-        case MS_TOKEN_FUNCTION_FROMTEXT:
-          native_string = msStringConcatenate(native_string, "SDO_GEOMETRY ");
-          break;
-        case MS_TOKEN_FUNCTION_BUFFER:
-           // native_string = msStringConcatenate(native_string, " SDO_BUFFER ");
-           //buffer = MS_TRUE;
-          break;
-        case MS_TOKEN_FUNCTION_DIFFERENCE:
-          native_string = msStringConcatenate(native_string, "ST_DIFFERENCE ");
-          break;
-        case MS_TOKEN_FUNCTION_SIMPLIFY:
-          native_string = msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
-          break;
-        case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-          break;
-        case MS_TOKEN_FUNCTION_GENERALIZE:
-          native_string = msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
-          break;
-        case ',':
-          native_string = msStringConcatenate(native_string, ",");
-          break;
-        case '~':
-          break;
-        default:
-          fprintf(stderr, "Translation to native SQL failed.\n");
-          msFree(native_string);
-          if (layer->debug) {
-            msDebug("Token not caught, exiting: Token is %i\n", node->token);
-          }
-
-          if (geom_column_name) free(geom_column_name);
-          if (srid) free(srid);
-          if (unique) free(unique);
-          if (indexfield) free(indexfield);
-          if (table_name) free(table_name);
-
-          return MS_SUCCESS; /* not an error */
-        }
-      nodeCount++;
-      node = node->next;
-
-      //fprintf(stderr, "native filter: %s\n", native_string);
-    }
-
-    filter->native_string = msStrdup(native_string);
-    if (layer->debug>=4)
-      msDebug("total filter tokens are %i\n,", nodeCount);
-    msFree(native_string);
-  }
-
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (table_name) free(table_name);
-  
-  return MS_SUCCESS;
-}
-
-
-#else
-/* OracleSpatial "not-supported" procedures */
-
-int msOracleSpatialLayerOpen(layerObj *layer)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerOpen()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerIsOpen(layerObj *layer)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerIsOpen()" );
-  return MS_FALSE;
-}
-
-int msOracleSpatialLayerClose(layerObj *layer)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerClose()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)layer;
-  (void)rect;
-  (void)isQuery;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerWhichShapes()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  (void)layer;
-  (void)shape;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerNextShape()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerGetItems(layerObj *layer)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerGetItems()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerGetShape( layerObj *layer, shapeObj *shape, resultObj *record )
-{
-  (void)layer;
-  (void)shape;
-  (void)record;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerGetShape()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  (void)layer;
-  (void)extent;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerGetExtent()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerInitItemInfo(layerObj *layer)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerInitItemInfo()" );
-  return MS_FAILURE;
-}
-
-void msOracleSpatialLayerFreeItemInfo(layerObj *layer)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerFreeItemInfo()" );
-}
-
-int msOracleSpatialLayerGetAutoStyle( mapObj *map, layerObj *layer, classObj *c, shapeObj *shape )
-{
-  (void)map;
-  (void)layer;
-  (void)c;
-  (void)shape;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerGetAutoStyle()" );
-  return MS_FAILURE;
-}
-
-void msOracleSpatialEnablePaging(layerObj *layer, int value)
-{
-  (void)layer;
-  (void)value;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerEnablePaging()" );
-  return;
-}
-
-int msOracleSpatialGetPaging(layerObj *layer)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerGetPaging()" );
-  return MS_FAILURE;
-}
-
-int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-  (void)layer;
-  (void)filter;
-  (void)filteritem;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerTranslateFilter()" );
-  return MS_FAILURE;
-}
-
-char *msOracleSpatialEscapePropertyName(layerObj *layer, const char* pszString)
-{
-  (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerEscapePropertyName()" );
-  return msStrdup(pszString);
-}
-#endif
-
-#if defined USE_ORACLE_PLUGIN
-MS_DLL_EXPORT  int
-PluginInitializeVirtualTable(layerVTableObj* vtable, layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(vtable != NULL);
-
-  vtable->LayerTranslateFilter = msOracleSpatialLayerTranslateFilter;
-
-
-  vtable->LayerInitItemInfo = msOracleSpatialLayerInitItemInfo;
-  vtable->LayerFreeItemInfo = msOracleSpatialLayerFreeItemInfo;
-  vtable->LayerOpen = msOracleSpatialLayerOpen;
-  vtable->LayerIsOpen = msOracleSpatialLayerIsOpen;
-  vtable->LayerWhichShapes = msOracleSpatialLayerWhichShapes;
-  vtable->LayerNextShape = msOracleSpatialLayerNextShape;
-  vtable->LayerGetShape = msOracleSpatialLayerGetShape;
-  vtable->LayerClose = msOracleSpatialLayerClose;
-  vtable->LayerGetItems = msOracleSpatialLayerGetItems;
-  vtable->LayerGetExtent = msOracleSpatialLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  vtable->LayerCloseConnection = msOracleSpatialLayerClose;
-  vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
-  vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  //vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
-  //vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
-  /* layer->vtable->LayerGetNumFeatures, use default */
-  /* layer->vtable->LayerGetAutoProjection = msOracleSpatialLayerGetAutoProjection; Disabled until tested */
-  vtable->LayerEnablePaging = msOracleSpatialEnablePaging;
-  vtable->LayerGetPaging = msOracleSpatialGetPaging;
-
-  return MS_SUCCESS;
-}
-
-#else /*if ORACLE_PLUGIN is defined, then this file is not used by libmapserver
-        and therefre there is no need to include this function */
-int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerTranslateFilter = msOracleSpatialLayerTranslateFilter;
-
-
-  layer->vtable->LayerInitItemInfo = msOracleSpatialLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msOracleSpatialLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msOracleSpatialLayerOpen;
-  layer->vtable->LayerIsOpen = msOracleSpatialLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msOracleSpatialLayerWhichShapes;
-  layer->vtable->LayerNextShape = msOracleSpatialLayerNextShape;
-  layer->vtable->LayerGetShape = msOracleSpatialLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msOracleSpatialLayerClose;
-  layer->vtable->LayerGetItems = msOracleSpatialLayerGetItems;
-  layer->vtable->LayerGetExtent = msOracleSpatialLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  layer->vtable->LayerCloseConnection = msOracleSpatialLayerClose;
-  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  //layer->vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
-  //layer->vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-  /* layer->vtable->LayerGetAutoProjection = msOracleSpatialLayerGetAutoProjection; Disabled until tested */
-  layer->vtable->LayerEnablePaging = msOracleSpatialEnablePaging;
-  layer->vtable->LayerGetPaging = msOracleSpatialGetPaging;
-
-  return MS_SUCCESS;
-}
-#endif
diff -pruN 8.0.1-5/mapoutput.c 8.2.0~beta1-1~exp1/mapoutput.c
--- 8.0.1-5/mapoutput.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapoutput.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1197 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Various support code related to the outputFormatObj.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 2002, Frank Warmerdam
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <assert.h>
-#include "mapserver.h"
-#include "mapows.h"
-
-
-
-static outputFormatObj *msAllocOutputFormat( mapObj *map, const char *name,
-    const char *driver );
-
-/*************************************************************************
-
-NOTES on outputFormatObj:
-
-typedef struct {
-  char *name;
-  char *mimetype;
-  char *driver;
-  int  imagemode; // MS_IMAGEMODE_* value.
-  int  transparent;
-  int  numformatoptions;
-  char **formatoptions;
-} outputFormatObj;
-
- NAME - Associates an internal name with the declaration.  The value used
-        has not intrinsic meaning and is just used to associate with the
-        MAP level IMAGETYPE.  It is also the "name" used for the format
-        in WMS capabilities documents, and FORMAT= requests. (required)
-
- MIMETYPE - The mime type to use for this format.  If omitted, the value
-            will be derived from the DRIVER or default to the value for
-            untyped binary data will be used.  (optional - may be NULL)
-
- DRIVER - This indicates which internal driver mechanism is to be used.
-          Anything prefixed by "GDAL/" will be handled by the GDAL driver, with
-          the remainder taken as the GDAL format name. (required)
-
- IMAGEMODE - Has one of "PC256", "RGB", or "RGBA" indicating whether
-             the imaging should be done to a 256 pseudo-colored, 24bit RGB, or
-             32bit RGBA (A=alpha/transparency) result image.  Note that the
-             IMAGEMODE actually affects how all the rendering for the map is
-             done, long before it is output to a particular output format.
-             The default value is the traditional "PC256".  Some output
-             formats can only support some IMAGEMODE values. (optional)
-
-             Translate as MS_IMAGEMODE_PC256, MS_IMAGEMODE_RGB and
-             MS_IMAGEMODE_RGBA.
-
-             For "GDAL/" drivers, the following extra imagemodes are supported:
-                "BYTE" / MS_IMAGEMODE_BYTE
-                "INT16" / MS_IMAGEMODE_INT16
-                "FLOAT32" / MS_IMAGEMODE_FLOAT32
-
-             Not too sure what this should be set to for output formats like
-             flash and SVG.
-
- TRANSPARENT - A value of "ON" or "OFF" indicating whether transparency
-               support should be enabled.  Same as the old TRANSPARENT flag
-               at the MAP level.
-
- FORMATOPTION - Contains an argument for the specific driver used.  There may
-                be any number of format options for a given OUTPUTFORMAT
-                declaration.  FORMATOPTION will be used to encode the older
-                INTERLACE, and QUALITY values.
-
-                Handled as a MapServer style CharArray.
-
- *************************************************************************/
-
-
-struct defaultOutputFormatEntry {
-  const char *name;
-  const char *driver;
-  const char *mimetype;
-} ;
-
-struct defaultOutputFormatEntry defaultoutputformats[] = {
-  {"png","AGG/PNG","image/png"},
-  {"jpeg","AGG/JPEG","image/jpeg"},
-  {"png8","AGG/PNG8","image/png; mode=8bit"},
-  {"png24","AGG/PNG","image/png; mode=24bit"},
-  {"jpegpng", "AGG/MIXED", "image/vnd.jpeg-png"},
-  {"jpegpng8", "AGG/MIXED", "image/vnd.jpeg-png8"},
-#ifdef USE_CAIRO
-  {"pdf","CAIRO/PDF","application/x-pdf"},
-  {"svg","CAIRO/SVG","image/svg+xml"},
-  {"cairopng","CAIRO/PNG","image/png"},
-#endif
-  {"GTiff","GDAL/GTiff","image/tiff"},
-#ifdef USE_KML
-  {"kml","KML","application/vnd.google-earth.kml+xml"},
-  {"kmz","KMZ","application/vnd.google-earth.kmz"},
-#endif
-#ifdef USE_PBF
-  {"mvt","MVT","application/vnd.mapbox-vector-tile"},
-  // The following format is added to keep backward compatibility
-  // for the application/x-protobuf media type
-  {"mvtxprotobuf","MVT","application/x-protobuf"},
-#endif
-  {"json","UTFGrid","application/json"},
-  {NULL,NULL,NULL}
-};
-
-/************************************************************************/
-/*                  msPostMapParseOutputFormatSetup()                   */
-/************************************************************************/
-
-int msPostMapParseOutputFormatSetup( mapObj *map )
-
-{
-  outputFormatObj *format;
-
-  /* If IMAGETYPE not set use the first user defined OUTPUTFORMAT.
-     If none, use the first default format. */
-  if( map->imagetype == NULL && map->numoutputformats > 0 )
-    map->imagetype = msStrdup(map->outputformatlist[0]->name);
-  if( map->imagetype == NULL)
-    map->imagetype = msStrdup(defaultoutputformats[0].name);
-
-  /* select the current outputformat into map->outputformat */
-  format = msSelectOutputFormat( map, map->imagetype );
-  if( format == NULL ) {
-    msSetError(MS_MISCERR,
-               "Unable to select IMAGETYPE `%s'.",
-               "msPostMapParseOutputFormatSetup()",
-               map->imagetype ? map->imagetype : "(null)" );
-    return MS_FAILURE;
-  }
-
-  msApplyOutputFormat( &(map->outputformat), format, MS_NOOVERRIDE);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                    msCreateDefaultOutputFormat()                     */
-/************************************************************************/
-
-outputFormatObj *msCreateDefaultOutputFormat( mapObj *map,
-    const char *driver,
-    const char *name,
-    const char *mimetype )
-
-{
-
-  outputFormatObj *format = NULL;
-  if( strncasecmp(driver,"GD/",3) == 0 ) {
-    return msCreateDefaultOutputFormat( map, "AGG/PNG8", name, mimetype );
-  }
-
-  if( strcasecmp(driver,"UTFGRID") == 0 ) {
-    if(!name) name="utfgrid";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("application/json");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("json");
-    format->renderer = MS_RENDER_WITH_UTFGRID;
-  }
-
-  else if( strcasecmp(driver,"AGG/PNG") == 0 ) {
-    if(!name) name="png";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/png");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("png");
-    format->renderer = MS_RENDER_WITH_AGG;
-  }
-
-  else if( strcasecmp(driver,"AGG/PNG8") == 0 ) {
-    if(!name) name="png8";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/png; mode=8bit");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("png");
-    format->renderer = MS_RENDER_WITH_AGG;
-    msSetOutputFormatOption( format, "QUANTIZE_FORCE", "on");
-    msSetOutputFormatOption( format, "QUANTIZE_COLORS", "256");
-  }
-
-  else if( strcasecmp(driver,"AGG/JPEG") == 0 ) {
-    if(!name) name="jpeg";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/jpeg");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("jpg");
-    format->renderer = MS_RENDER_WITH_AGG;
-  }
-#if defined(USE_PBF)
-  else if( strcasecmp(driver,"MVT") == 0 ) {
-    if(!name) name="mvt";
-    format = msAllocOutputFormat( map, name, driver );
-    if (mimetype) {
-      format->mimetype = msStrdup(mimetype);
-    } else {
-      format->mimetype = msStrdup("application/vnd.mapbox-vector-tile");
-    }
-
-    format->imagemode = MS_IMAGEMODE_FEATURE;
-    format->extension = msStrdup("pbf");
-    format->renderer = MS_RENDER_WITH_MVT;
-  }
-#endif
-
-  else if( strcasecmp(driver,"AGG/MIXED") == 0 &&
-           name != NULL && strcasecmp(name,"jpegpng") == 0 ) {
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/vnd.jpeg-png");
-    format->imagemode = MS_IMAGEMODE_RGBA;
-    format->extension = msStrdup("XXX");
-    format->renderer = MS_RENDER_WITH_AGG;
-    msSetOutputFormatOption( format, "OPAQUE_FORMAT", "jpeg");
-    msSetOutputFormatOption( format, "TRANSPARENT_FORMAT", "png24");
-  }
-
-  else if( strcasecmp(driver,"AGG/MIXED") == 0 &&
-           name != NULL && strcasecmp(name,"jpegpng8") == 0 ) {
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/vnd.jpeg-png8");
-    format->imagemode = MS_IMAGEMODE_RGBA;
-    format->extension = msStrdup("XXX");
-    format->renderer = MS_RENDER_WITH_AGG;
-    msSetOutputFormatOption( format, "OPAQUE_FORMAT", "jpeg");
-    msSetOutputFormatOption( format, "TRANSPARENT_FORMAT", "png8");
-  }
-
-  else if( strcasecmp(driver,"AGG/MIXED") == 0 ) {
-    if(!name) name="mixed";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/mixed");
-    format->imagemode = MS_IMAGEMODE_RGBA;
-    format->extension = msStrdup("XXX");
-    format->renderer = MS_RENDER_WITH_AGG;
-  }
-
-#if defined(USE_CAIRO)
-  else if( strcasecmp(driver,"CAIRO/PNG") == 0 ) {
-    if(!name) name="cairopng";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/png; mode=24bit");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("png");
-    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
-  }
-  else if( strcasecmp(driver,"CAIRO/JPEG") == 0 ) {
-    if(!name) name="cairojpeg";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/jpeg");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("jpg");
-    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
-  }
-  else if( strcasecmp(driver,"CAIRO/PDF") == 0 ) {
-    if(!name) name="pdf";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("application/x-pdf");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("pdf");
-    format->renderer = MS_RENDER_WITH_CAIRO_PDF;
-  }
-  else if( strcasecmp(driver,"CAIRO/SVG") == 0 ) {
-    if(!name) name="svg";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/svg+xml");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("svg");
-    format->renderer = MS_RENDER_WITH_CAIRO_SVG;
-  }
-#ifdef _WIN32
-  else if( strcasecmp(driver,"CAIRO/WINGDI") == 0 ) {
-    if(!name) name="cairowinGDI";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("");
-    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
-  }
-  else if( strcasecmp(driver,"CAIRO/WINGDIPRINT") == 0 ) {
-    if(!name) name="cairowinGDIPrint";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("");
-    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
-  }
-#endif
-#endif
-
-#if defined(USE_OGL)
-  else if( strcasecmp(driver,"OGL/PNG") == 0 ) {
-    if(!name) name="oglpng24";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("image/png; mode=24bit");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("png");
-    format->renderer = MS_RENDER_WITH_OGL;
-  }
-#endif
-
-#if defined(USE_KML)
-  else if( strcasecmp(driver,"KML") == 0 ) {
-    if(!name) name="kml";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("application/vnd.google-earth.kml+xml");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("kml");
-    format->renderer = MS_RENDER_WITH_KML;
-    msSetOutputFormatOption( format, "ATTACHMENT", "mapserver.kml");
-  }
-  else if( strcasecmp(driver,"KMZ") == 0 ) {
-    if(!name) name="kmz";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("application/vnd.google-earth.kmz");
-    format->imagemode = MS_IMAGEMODE_RGB;
-    format->extension = msStrdup("kmz");
-    format->renderer = MS_RENDER_WITH_KML;
-    msSetOutputFormatOption( format, "ATTACHMENT", "mapserver.kmz");
-  }
-#endif
-
-
-
-  else if( strncasecmp(driver,"gdal/",5) == 0 ) {
-    if(!name) name=driver+5;
-    format = msAllocOutputFormat( map, name, driver );
-    if( msInitDefaultGDALOutputFormat( format ) == MS_FAILURE ) {
-      if( map != NULL ) {
-        map->numoutputformats--;
-        map->outputformatlist[map->numoutputformats] = NULL;
-      }
-
-      msFreeOutputFormat( format );
-      format = NULL;
-    }
-  }
-
-  else if( strncasecmp(driver,"ogr/",4) == 0 ) {
-    if(!name) name=driver+4;
-    format = msAllocOutputFormat( map, name, driver );
-    if( msInitDefaultOGROutputFormat( format ) == MS_FAILURE ) {
-      if( map != NULL ) {
-        map->numoutputformats--;
-        map->outputformatlist[map->numoutputformats] = NULL;
-      }
-
-      msFreeOutputFormat( format );
-      format = NULL;
-    }
-  }
-
-  else if( strcasecmp(driver,"imagemap") == 0 ) {
-    if(!name) name="imagemap";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("text/html; driver=imagemap");
-    format->extension = msStrdup("html");
-    format->imagemode = MS_IMAGEMODE_NULL;
-    format->renderer = MS_RENDER_WITH_IMAGEMAP;
-  }
-
-  else if( strcasecmp(driver,"template") == 0 ) {
-    if(!name) name="template";
-    format = msAllocOutputFormat( map, name, driver );
-    format->mimetype = msStrdup("text/html");
-    format->extension = msStrdup("html");
-    format->imagemode = MS_IMAGEMODE_FEATURE;
-    format->renderer = MS_RENDER_WITH_TEMPLATE;
-  }
-
-  if( format != NULL )
-    format->inmapfile = MS_FALSE;
-
-
-  return format;
-}
-
-/************************************************************************/
-/*                    msApplyDefaultOutputFormats()                     */
-/************************************************************************/
-
-
-void msApplyDefaultOutputFormats( mapObj *map )
-{
-  char *saved_imagetype;
-  struct defaultOutputFormatEntry *defEntry;
-
-  if( map->imagetype == NULL )
-    saved_imagetype = NULL;
-  else
-    saved_imagetype = msStrdup(map->imagetype);
-
-  defEntry = defaultoutputformats;
-  while(defEntry->name) {
-    if( msSelectOutputFormat( map, defEntry->name ) == NULL )
-      msCreateDefaultOutputFormat( map, defEntry->driver, defEntry->name, defEntry->mimetype );
-    defEntry++;
-  }
-  if( map->imagetype != NULL )
-    free( map->imagetype );
-  map->imagetype = saved_imagetype;
-}
-
-/************************************************************************/
-/*                         msFreeOutputFormat()                         */
-/************************************************************************/
-
-void msFreeOutputFormat( outputFormatObj *format )
-
-{
-  if( format == NULL )
-    return;
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(format) ) {
-    return;
-  }
-
-  if(MS_RENDERER_PLUGIN(format) && format->vtable) {
-    format->vtable->cleanup(MS_RENDERER_CACHE(format->vtable));
-    free( format->vtable );
-  }
-  msFree( format->name );
-  msFree( format->mimetype );
-  msFree( format->driver );
-  msFree( format->extension );
-  msFreeCharArray( format->formatoptions, format->numformatoptions );
-  msFree( format );
-}
-
-/************************************************************************/
-/*                        msAllocOutputFormat()                         */
-/************************************************************************/
-
-static outputFormatObj *msAllocOutputFormat( mapObj *map, const char *name,
-    const char *driver )
-
-{
-  outputFormatObj *format;
-
-  /* -------------------------------------------------------------------- */
-  /*      Allocate the format object.                                     */
-  /* -------------------------------------------------------------------- */
-  format = (outputFormatObj *) calloc(1,sizeof(outputFormatObj));
-  if( format == NULL ) {
-    msSetError( MS_MEMERR, NULL, "msAllocOutputFormat()" );
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize various fields.                                      */
-  /* -------------------------------------------------------------------- */
-  format->bands = 1;
-  format->name = msStrdup(name);
-  format->driver = msStrdup(driver);
-  format->refcount = 0;
-  format->vtable = NULL;
-  format->device = NULL;
-  format->imagemode = MS_IMAGEMODE_RGB;
-
-  /* -------------------------------------------------------------------- */
-  /*      Attach to map.                                                  */
-  /* -------------------------------------------------------------------- */
-  if( map != NULL ) {
-    map->numoutputformats++;
-    if( map->outputformatlist == NULL )
-      map->outputformatlist = (outputFormatObj **) malloc(sizeof(void*));
-    else
-      map->outputformatlist = (outputFormatObj **)
-                              realloc(map->outputformatlist,
-                                      sizeof(void*) * map->numoutputformats );
-
-    map->outputformatlist[map->numoutputformats-1] = format;
-    format->refcount++;
-  }
-
-  return format;
-}
-
-/************************************************************************/
-/*                        msAppendOutputFormat()                        */
-/*                                                                      */
-/*      Add an output format  .                                         */
-/*      http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511           */
-/************************************************************************/
-int msAppendOutputFormat(mapObj *map, outputFormatObj *format)
-{
-  /* -------------------------------------------------------------------- */
-  /*      Attach to map.                                                  */
-  /* -------------------------------------------------------------------- */
-  assert(map);
-  map->numoutputformats++;
-  if (map->outputformatlist == NULL)
-    map->outputformatlist = (outputFormatObj **) malloc(sizeof(void*));
-  else
-    map->outputformatlist = (outputFormatObj **)
-                            realloc(map->outputformatlist,
-                                    sizeof(void*) * map->numoutputformats );
-
-  map->outputformatlist[map->numoutputformats-1] = format;
-  MS_REFCNT_INCR(format);
-
-  return map->numoutputformats;
-}
-
-/************************************************************************/
-/*                        msRemoveOutputFormat()                        */
-/*                                                                      */
-/*      Remove an output format (by name).                              */
-/*      http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511           */
-/************************************************************************/
-int msRemoveOutputFormat(mapObj *map, const char *name)
-{
-  int i, j;
-  /* -------------------------------------------------------------------- */
-  /*      Detach from map.                                                */
-  /* -------------------------------------------------------------------- */
-  if (map != NULL) {
-    if (map->outputformatlist == NULL) {
-      msSetError(MS_CHILDERR, "Can't remove format from empty outputformatlist", "msRemoveOutputFormat()");
-      return MS_FAILURE;
-    } else {
-      i = msGetOutputFormatIndex(map, name);
-      if (i >= 0) {
-        map->numoutputformats--;
-	if(MS_REFCNT_DECR_IS_ZERO(map->outputformatlist[i]))
-           msFreeOutputFormat( map->outputformatlist[i] );
-
-        for (j=i; j<map->numoutputformats-1; j++) {
-          map->outputformatlist[j] = map->outputformatlist[j+1];
-        }
-      }
-      map->outputformatlist = (outputFormatObj **)
-                              realloc(map->outputformatlist,
-                                      sizeof(void*) * (map->numoutputformats) );
-      return MS_SUCCESS;
-    }
-  }
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                       msGetOutputFormatIndex()                       */
-/*                                                                      */
-/*      Pulled this out of msSelectOutputFormat for use in other cases. */
-/************************************************************************/
-
-int msGetOutputFormatIndex(mapObj *map, const char *imagetype)
-{
-  int i;
-  /* -------------------------------------------------------------------- */
-  /*      Try to find the format in the maps list of formats, first by    */
-  /*      mime type, and then by output format name.                      */
-  /* -------------------------------------------------------------------- */
-  for (i = 0; i < map->numoutputformats; i++) {
-    if (map->outputformatlist[i]->mimetype != NULL
-        && strcasecmp(imagetype,
-                      map->outputformatlist[i]->mimetype) == 0 )
-      return i;
-  }
-
-  for( i = 0; i < map->numoutputformats; i++ ) {
-    if( strcasecmp(imagetype,map->outputformatlist[i]->name) == 0 )
-      return i;
-  }
-
-  return -1;
-}
-
-/************************************************************************/
-/*                        msSelectOutputFormat()                        */
-/************************************************************************/
-
-
-
-outputFormatObj *msSelectOutputFormat( mapObj *map,
-                                       const char *imagetype )
-
-{
-  int index;
-  outputFormatObj *format = NULL;
-
-  if( map == NULL || imagetype == NULL || strlen(imagetype) == 0 )
-    return NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Try to find the format in the maps list of formats, first by    */
-  /*      mime type, and then by output format name.                      */
-  /* -------------------------------------------------------------------- */
-  index = msGetOutputFormatIndex(map, imagetype);
-  if (index >= 0) {
-    format = map->outputformatlist[index];
-  } else {
-    struct defaultOutputFormatEntry *formatEntry = defaultoutputformats;
-    while(formatEntry->name) {
-      if(!strcasecmp(imagetype,formatEntry->name) || !strcasecmp(imagetype,formatEntry->mimetype)) {
-        format = msCreateDefaultOutputFormat( map, formatEntry->driver, formatEntry->name, formatEntry->mimetype );
-        break;
-      }
-      formatEntry++;
-    }
-
-  }
-
-  if (format) {
-    if (map->imagetype)
-      free(map->imagetype);
-    map->imagetype = msStrdup(format->name);
-  }
-
-  if( format != NULL )
-    msOutputFormatValidate( format, MS_FALSE );
-
-  return format;
-}
-
-/************************************************************************/
-/*                        msApplyOutputFormat()                         */
-/************************************************************************/
-
-void msApplyOutputFormat( outputFormatObj **target,
-                          outputFormatObj *format,
-                          int transparent)
-
-{
-  int       change_needed = MS_FALSE;
-  outputFormatObj *formatToFree = NULL;
-
-  assert( target != NULL );
-
-  if( *target != NULL && MS_REFCNT_DECR_IS_ZERO( (*target) ) ) {
-    formatToFree = *target;
-    *target = NULL;
-  }
-
-  if( format == NULL ) {
-    if( formatToFree )
-      msFreeOutputFormat( formatToFree );
-    *target = NULL;
-    return;
-  }
-
-  msOutputFormatValidate( format, MS_FALSE );
-
-  /* -------------------------------------------------------------------- */
-  /*      Do we need to change any values?  If not, then just apply       */
-  /*      and return.                                                     */
-  /* -------------------------------------------------------------------- */
-  if( transparent != MS_NOOVERRIDE && !format->transparent != !transparent )
-      change_needed = MS_TRUE;
-
-  if( change_needed ) {
-
-    if( format->refcount > 0 )
-      format = msCloneOutputFormat( format );
-
-    if( transparent != MS_NOOVERRIDE ) {
-        format->transparent = transparent;
-        if( format->imagemode == MS_IMAGEMODE_RGB )
-            format->imagemode = MS_IMAGEMODE_RGBA;
-    }
-  }
-
-  *target = format;
-  format->refcount++;
-  if( MS_RENDERER_PLUGIN(format) ) {
-    msInitializeRendererVTable(format);
-  }
-
-
-  if( formatToFree )
-    msFreeOutputFormat( formatToFree );
-}
-
-/************************************************************************/
-/*                        msCloneOutputFormat()                         */
-/************************************************************************/
-
-outputFormatObj *msCloneOutputFormat( outputFormatObj *src )
-
-{
-  outputFormatObj *dst;
-  int             i;
-
-  dst = msAllocOutputFormat( NULL, src->name, src->driver );
-
-  msFree( dst->mimetype );
-  if( src->mimetype )
-    dst->mimetype = msStrdup( src->mimetype );
-  else
-    dst->mimetype = NULL;
-
-  msFree( dst->extension );
-  if( src->extension )
-    dst->extension = msStrdup( src->extension );
-  else
-    dst->extension = NULL;
-
-  dst->imagemode = src->imagemode;
-  dst->renderer = src->renderer;
-
-  dst->transparent = src->transparent;
-  dst->bands = src->bands;
-
-  dst->numformatoptions = src->numformatoptions;
-  dst->formatoptions = (char **)
-                       malloc(sizeof(char *) * src->numformatoptions );
-
-  for( i = 0; i < src->numformatoptions; i++ )
-    dst->formatoptions[i] = msStrdup(src->formatoptions[i]);
-
-  dst->inmapfile = src->inmapfile;
-
-  return dst;
-}
-
-/************************************************************************/
-/*                      msGetOutputFormatOption()                       */
-/*                                                                      */
-/*      Fetch the value of a particular option.  It is assumed the      */
-/*      options are in "KEY=VALUE" format.                              */
-/************************************************************************/
-
-const char *msGetOutputFormatOption( outputFormatObj *format,
-                                     const char *optionkey,
-                                     const char *defaultresult )
-
-{
-  int    i, len = strlen(optionkey);
-
-  for( i = 0; i < format->numformatoptions; i++ ) {
-    if( strncasecmp(format->formatoptions[i],optionkey,len) == 0
-        && format->formatoptions[i][len] == '=' )
-      return format->formatoptions[i] + len + 1;
-  }
-
-  return defaultresult;
-}
-
-/************************************************************************/
-/*                      msSetOutputFormatOption()                       */
-/************************************************************************/
-
-void msSetOutputFormatOption( outputFormatObj *format,
-                              const char *key, const char *value )
-
-{
-  char *newline;
-  int   i, len;
-
-  if( value == NULL )
-    return;
-
-  /* -------------------------------------------------------------------- */
-  /*      Format the name=value pair into a newly allocated string.       */
-  /* -------------------------------------------------------------------- */
-  newline = (char *) malloc(strlen(key)+strlen(value)+2);
-  if( newline == NULL ) {
-    assert( newline != NULL );
-    return;
-  }
-
-  sprintf( newline, "%s=%s", key, value );
-
-  /* -------------------------------------------------------------------- */
-  /*      Does this key already occur?  If so replace it.                 */
-  /* -------------------------------------------------------------------- */
-  len = strlen(key);
-
-  for( i = 0; i < format->numformatoptions; i++ ) {
-    if( strncasecmp(format->formatoptions[i],key,len) == 0
-        && format->formatoptions[i][len] == '=' ) {
-      free( format->formatoptions[i] );
-      format->formatoptions[i] = newline;
-      return;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      otherwise, we need to grow the list.                            */
-  /* -------------------------------------------------------------------- */
-  format->numformatoptions++;
-  format->formatoptions = (char **)
-                          realloc( format->formatoptions,
-                                   sizeof(char*) * format->numformatoptions );
-
-  format->formatoptions[format->numformatoptions-1] = newline;
-
-  /* -------------------------------------------------------------------- */
-  /*      Capture generic value(s) we are interested in.                  */
-  /* -------------------------------------------------------------------- */
-  if( strcasecmp(key,"BAND_COUNT") == 0 )
-    format->bands = atoi(value);
-}
-
-/************************************************************************/
-/*                     msGetOutputFormatMimeList()                      */
-/************************************************************************/
-
-void msGetOutputFormatMimeList( mapObj *map, char **mime_list, int max_mime )
-
-{
-  int mime_count = 0, i;
-
-  msApplyDefaultOutputFormats(map);
-  for( i = 0; i < map->numoutputformats && mime_count < max_mime; i++ ) {
-    int  j;
-
-    if( map->outputformatlist[i]->mimetype == NULL )
-      continue;
-
-    for( j = 0; j < mime_count; j++ ) {
-      if( strcasecmp(mime_list[j],
-                     map->outputformatlist[i]->mimetype) == 0 )
-        break;
-    }
-
-    if( j == mime_count )
-      mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
-  }
-
-  if( mime_count < max_mime )
-    mime_list[mime_count] = NULL;
-}
-
-/************************************************************************/
-/*                     msGetOutputFormatMimeList()                      */
-/************************************************************************/
-void msGetOutputFormatMimeListImg( mapObj *map, const char **mime_list, int max_mime )
-
-{
-  int mime_count = 0, i,j;
-  const char *format_list = NULL;
-  char **tokens = NULL;
-  int numtokens = 0;
-  outputFormatObj *format;
-
-  msApplyDefaultOutputFormats(map);
-  format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getlegendgraphic_formatlist");
-  if ( format_list && strlen(format_list) > 0)
-    tokens = msStringSplit(format_list,  ',', &numtokens);
-
-  if (tokens && numtokens > 0) {
-    for(j = 0; j < numtokens; j++ ) {
-      format = msSelectOutputFormat(map, tokens[j]);
-      if (format != NULL) {
-        mime_list[mime_count++] = format->mimetype;
-      }
-    }
-  } else
-    for( i = 0; i < map->numoutputformats && mime_count < max_mime; i++ ) {
-      int  j;
-
-      if( map->outputformatlist[i]->mimetype == NULL )
-        continue;
-
-      for( j = 0; j < mime_count; j++ ) {
-        if( strcasecmp(mime_list[j],
-                       map->outputformatlist[i]->mimetype) == 0 )
-          break;
-      }
-
-      if( j == mime_count && map->outputformatlist[i]->driver &&
-          strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4)==0)
-        mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
-    }
-
-  if( mime_count < max_mime )
-    mime_list[mime_count] = NULL;
-  if(tokens)
-    msFreeCharArray(tokens, numtokens);
-}
-
-/************************************************************************/
-/*                  msGetOutputFormatMimeListWMS()                      */
-/************************************************************************/
-
-void msGetOutputFormatMimeListWMS( mapObj *map, const char **mime_list, int max_mime )
-{
-  int mime_count = 0, i,j;
-  const char *format_list = NULL;
-  char **tokens = NULL;
-  int numtokens = 0;
-  outputFormatObj *format;
-  msApplyDefaultOutputFormats(map);
-  format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getmap_formatlist");
-  if ( format_list && strlen(format_list) > 0)
-    tokens = msStringSplit(format_list,  ',', &numtokens);
-
-  if (tokens && numtokens > 0) {
-    for(j = 0; j < numtokens; j++ ) {
-      format = msSelectOutputFormat(map, tokens[j]);
-      if (format != NULL) {
-        mime_list[mime_count++] = format->mimetype;
-      }
-    }
-  } else {
-    for( i = 0; i < map->numoutputformats && mime_count < max_mime; i++ ) {
-      int  j;
-
-      if( map->outputformatlist[i]->mimetype == NULL )
-        continue;
-
-      for( j = 0; j < mime_count; j++ ) {
-        if( strcasecmp(mime_list[j],
-                       map->outputformatlist[i]->mimetype) == 0 )
-          break;
-      }
-
-      if( j == mime_count && map->outputformatlist[i]->driver &&
-          (
-            strncasecmp(map->outputformatlist[i]->driver, "GDAL/", 5)==0 ||
-            strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4)==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "CAIRO/SVG")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "CAIRO/PDF")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "kml")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "kmz")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "mvt")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "UTFGRID")==0))
-        mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
-    }
-  }
-  if( mime_count < max_mime )
-    mime_list[mime_count] = NULL;
-  if(tokens)
-    msFreeCharArray(tokens, numtokens);
-}
-
-
-/************************************************************************/
-/*                       msOutputFormatValidate()                       */
-/*                                                                      */
-/*      Do some validation of the output format, and report to debug    */
-/*      output if it doesn't seem valid.  Fixup in place as best as     */
-/*      possible.                                                       */
-/************************************************************************/
-
-int msOutputFormatValidate( outputFormatObj *format, int issue_error )
-
-{
-  int result = MS_TRUE;
-  char *driver_ext;
-
-  format->bands = atoi(msGetOutputFormatOption( format, "BAND_COUNT", "1" ));
-
-  /* Enforce the requirement that JPEG be RGB and TRANSPARENT=OFF */
-  driver_ext = strstr(format->driver,"/");
-  if( driver_ext && ++driver_ext && !strcasecmp(driver_ext,"JPEG")) {
-    if( format->transparent ) {
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is not supported.\n"
-                    "It has been disabled.\n",
-                    "msOutputFormatValidate()", format->name );
-      else
-        msDebug( "JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is not supported.\n"
-                 "It has been disabled.\n",
-                 format->name );
-
-      format->transparent = MS_FALSE;
-      result = MS_FALSE;
-    }
-    if( format->imagemode == MS_IMAGEMODE_RGBA ) {
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not supported.\n"
-                    "IMAGEMODE forced to RGB.\n",
-                    "msOutputFormatValidate()", format->name );
-      else
-        msDebug( "JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not supported.\n"
-                 "IMAGEMODE forced to RGB.\n",
-                 format->name );
-
-      format->imagemode = MS_IMAGEMODE_RGB;
-      result = MS_FALSE;
-    }
-  }
-
-  if( format->transparent && format->imagemode == MS_IMAGEMODE_RGB ) {
-    if( issue_error )
-      msSetError( MS_MISCERR,
-                  "OUTPUTFORMAT %s has TRANSPARENT set ON, but an IMAGEMODE\n"
-                  "of RGB instead of RGBA.  Changing imagemode to RGBA.\n",
-                  "msOutputFormatValidate()", format->name );
-    else
-      msDebug("OUTPUTFORMAT %s has TRANSPARENT set ON, but an IMAGEMODE\n"
-              "of RGB instead of RGBA.  Changing imagemode to RGBA.\n",
-              format->name );
-
-    format->imagemode = MS_IMAGEMODE_RGBA;
-    result = MS_FALSE;
-  }
-
-  /* Special checking around RAWMODE image modes. */
-  if( format->imagemode == MS_IMAGEMODE_INT16
-      || format->imagemode == MS_IMAGEMODE_FLOAT32
-      || format->imagemode == MS_IMAGEMODE_BYTE ) {
-    if( strncmp(format->driver,"GDAL/",5) != 0 ) {
-      result = MS_FALSE;
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this is only supported for GDAL drivers.",
-                    "msOutputFormatValidate()", format->name );
-      else
-        msDebug( "OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this is only supported for GDAL drivers.",
-                 format->name );
-    }
-
-    if( format->renderer != MS_RENDER_WITH_RAWDATA ) /* see bug 724 */
-      format->renderer = MS_RENDER_WITH_RAWDATA;
-  }
-
-  if( !strcasecmp(format->driver,"AGG/MIXED") )
-  {
-    if( !msGetOutputFormatOption(format, "TRANSPARENT_FORMAT", NULL) )
-    {
-      result = MS_FALSE;
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
-                    "msOutputFormatValidate()", format->name );
-      else
-        msDebug( "OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
-                 format->name );
-    }
-    if( !msGetOutputFormatOption(format, "OPAQUE_FORMAT", NULL) )
-    {
-      result = MS_FALSE;
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
-                    "msOutputFormatValidate()", format->name );
-      else
-        msDebug( "OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
-                 format->name );
-    }
-  }
-
-  return result;
-}
-
-/************************************************************************/
-/*                     msInitializeRendererVTable()                     */
-/************************************************************************/
-
-int msInitializeRendererVTable(outputFormatObj *format)
-{
-  assert(format);
-  if(format->vtable) {
-    return MS_SUCCESS;
-  }
-  format->vtable = (rendererVTableObj*)calloc(1,sizeof(rendererVTableObj));
-
-  msInitializeDummyRenderer(format->vtable);
-
-  switch(format->renderer) {
-    case MS_RENDER_WITH_AGG:
-      return msPopulateRendererVTableAGG(format->vtable);
-    case MS_RENDER_WITH_UTFGRID:
-      return msPopulateRendererVTableUTFGrid(format->vtable);
-#ifdef USE_PBF
-    case MS_RENDER_WITH_MVT:
-      return msPopulateRendererVTableMVT(format->vtable);
-#endif
-#ifdef USE_CAIRO
-    case MS_RENDER_WITH_CAIRO_RASTER:
-      return msPopulateRendererVTableCairoRaster(format->vtable);
-    case MS_RENDER_WITH_CAIRO_PDF:
-      return msPopulateRendererVTableCairoPDF(format->vtable);
-    case MS_RENDER_WITH_CAIRO_SVG:
-      return msPopulateRendererVTableCairoSVG(format->vtable);
-#endif
-#ifdef USE_OGL
-    case MS_RENDER_WITH_OGL:
-      return msPopulateRendererVTableOGL(format->vtable);
-#endif
-#ifdef USE_KML
-    case MS_RENDER_WITH_KML:
-      return msPopulateRendererVTableKML(format->vtable);
-#endif
-
-    case MS_RENDER_WITH_OGR:
-      return msPopulateRendererVTableOGR(format->vtable);
-
-    default:
-      msSetError(MS_MISCERR, "unsupported RendererVtable renderer %d",
-                 "msInitializeRendererVTable()",format->renderer);
-      return MS_FAILURE;
-  }
-  /* this code should never be executed */
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                    msOutputFormatResolveFromImage()                  */
-/************************************************************************/
-
-void msOutputFormatResolveFromImage( mapObj *map, imageObj* img )
-{
-  outputFormatObj* format = map->outputformat;
-  assert( img->format == format );
-  assert( img->format->refcount >= 2 );
-
-  if( format->renderer == MS_RENDER_WITH_AGG &&
-      strcmp(format->driver, "AGG/MIXED") == 0 &&
-      (format->imagemode == MS_IMAGEMODE_RGB ||
-       format->imagemode == MS_IMAGEMODE_RGBA) )
-  {
-    outputFormatObj * new_format;
-    int has_non_opaque_pixels = MS_FALSE;
-    const char* underlying_driver_type = NULL;
-    const char* underlying_driver_name = NULL;
-
-    // Check if the image has non opaque pixels
-    if( format->imagemode == MS_IMAGEMODE_RGBA )
-    {
-      rasterBufferObj rb;
-      int ret;
-
-      ret = format->vtable->getRasterBufferHandle(img,&rb);
-      assert( ret == MS_SUCCESS );
-      (void)ret;
-      if( rb.data.rgba.a )
-      {
-        for(unsigned row=0; row<rb.height && !has_non_opaque_pixels; row++) {
-          unsigned char *a;
-          a=rb.data.rgba.a+row*rb.data.rgba.row_step;
-          for(unsigned col=0; col<rb.width && !has_non_opaque_pixels; col++) {
-            if(*a < 255) {
-              has_non_opaque_pixels = MS_TRUE;
-            }
-            a+=rb.data.rgba.pixel_step;
-          }
-        }
-      }
-    }
-
-    underlying_driver_type = ( has_non_opaque_pixels ) ?
-                                    "TRANSPARENT_FORMAT" : "OPAQUE_FORMAT";
-    underlying_driver_name = msGetOutputFormatOption(format, underlying_driver_type,
-                                                NULL);
-    if( underlying_driver_name == NULL ) {
-      msSetError(MS_MISCERR,
-                 "Missing %s format option on %s.",
-                 "msOutputFormatResolveFromImage()",
-                 underlying_driver_type, format->name );
-      return;
-    }
-    new_format = msSelectOutputFormat( map, underlying_driver_name );
-    if( new_format == NULL ) {
-      msSetError(MS_MISCERR,
-                 "Cannot find %s output format.",
-                 "msOutputFormatResolveFromImage()",
-                 underlying_driver_name );
-      return;
-    }
-    if( new_format->renderer != MS_RENDER_WITH_AGG )
-    {
-      msSetError(MS_MISCERR,
-                 "%s cannot be used as the %s format of %s since it is not AGG based.",
-                 "msOutputFormatResolveFromImage()",
-                 underlying_driver_name, underlying_driver_type, format->name );
-      return;
-    }
-
-    msApplyOutputFormat( &(map->outputformat),
-                         new_format,
-                         has_non_opaque_pixels);
-
-    msFreeOutputFormat( format );
-    img->format = map->outputformat;
-    img->format->refcount ++;
-  }
-}
diff -pruN 8.0.1-5/mapows.c 8.2.0~beta1-1~exp1/mapows.c
--- 8.0.1-5/mapows.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapows.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,3001 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC Web Services (WMS, WFS) support functions
- * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maptime.h"
-#include "maptemplate.h"
-#include "mapows.h"
-
-#if defined(USE_LIBXML2)
-#include "maplibxml2.h"
-#else
-#include "cpl_minixml.h"
-#include "cpl_error.h"
-#endif
-#include "mapowscommon.h"
-
-#include <ctype.h> /* isalnum() */
-#include <stdarg.h>
-#include <assert.h>
-
-
-
-/*
-** msOWSInitRequestObj() initializes an owsRequestObj; i.e: sets
-** all internal pointers to NULL.
-*/
-void msOWSInitRequestObj(owsRequestObj *ows_request)
-{
-  ows_request->numlayers = 0;
-  ows_request->numwmslayerargs = 0;
-  ows_request->enabled_layers = NULL;
-  ows_request->layerwmsfilterindex = NULL;
-
-  ows_request->service = NULL;
-  ows_request->version = NULL;
-  ows_request->request = NULL;
-  ows_request->document = NULL;
-}
-
-/*
-** msOWSClearRequestObj() releases all resources associated with an
-** owsRequestObj.
-*/
-void msOWSClearRequestObj(owsRequestObj *ows_request)
-{
-  msFree(ows_request->enabled_layers);
-  msFree(ows_request->layerwmsfilterindex);
-  msFree(ows_request->service);
-  msFree(ows_request->version);
-  msFree(ows_request->request);
-  if(ows_request->document) {
-#if defined(USE_LIBXML2)
-    xmlFreeDoc(ows_request->document);
-    xmlCleanupParser();
-#else
-    CPLDestroyXMLNode(ows_request->document);
-#endif
-  }
-}
-
-#if defined(USE_LIBXML2) && LIBXML_VERSION < 20900
-static int bExternalEntityAsked = MS_FALSE;
-static xmlParserInputPtr  dummyEntityLoader(const char * URL, 
-                                           const char * ID, 
-                                           xmlParserCtxtPtr context )
-{
-    bExternalEntityAsked = MS_TRUE;
-    return NULL;
-}
-#endif
-
-/*
-** msOWSPreParseRequest() parses a cgiRequestObj either with GET/KVP
-** or with POST/XML. Only SERVICE, VERSION (or WMTVER) and REQUEST are
-** being determined, all WxS (or SOS) specific parameters are parsed
-** within the according handler.
-** The results are saved within an owsRequestObj. If the request was
-** transmitted with POST/XML, either the document (if compiled with
-** libxml2) or the root CPLXMLNode is saved to the ows_request->document
-** field.
-** Returns MS_SUCCESS upon success, MS_FAILURE if severe errors occurred
-** or MS_DONE, if the service could not be determined.
-*/
-static int msOWSPreParseRequest(cgiRequestObj *request,
-                                owsRequestObj *ows_request)
-{
-  /* decide if KVP or XML */
-  if (request->type == MS_GET_REQUEST || (request->type == MS_POST_REQUEST 
-    && request->contenttype && strncmp(request->contenttype, "application/x-www-form-urlencoded", strlen("application/x-www-form-urlencoded")) == 0)) {
-    int i;
-    /* parse KVP parameters service, version and request */
-    for (i = 0; i < request->NumParams; ++i) {
-      if (ows_request->service == NULL &&
-          EQUAL(request->ParamNames[i], "SERVICE")) {
-        ows_request->service = msStrdup(request->ParamValues[i]);
-      } else if (ows_request->version == NULL &&
-                 (EQUAL(request->ParamNames[i], "VERSION")
-                 || EQUAL(request->ParamNames[i], "WMTVER"))) { /* for WMS */
-        ows_request->version = msStrdup(request->ParamValues[i]);
-      } else if (ows_request->request == NULL &&
-                 EQUAL(request->ParamNames[i], "REQUEST")) {
-        ows_request->request = msStrdup(request->ParamValues[i]);
-      }
-
-      /* stop if we have all necessary parameters */
-      if(ows_request->service && ows_request->version && ows_request->request) {
-        break;
-      }
-    }
-  } else if (request->type == MS_POST_REQUEST) {
-#if defined(USE_LIBXML2)
-    xmlNodePtr root = NULL;
-#if LIBXML_VERSION < 20900
-    xmlExternalEntityLoader oldExternalEntityLoader;
-#endif
-#else
-    CPLXMLNode *temp;
-#endif
-    if (!request->postrequest || !strlen(request->postrequest)) {
-      msSetError(MS_OWSERR, "POST request is empty.",
-                 "msOWSPreParseRequest()");
-      return MS_FAILURE;
-    }
-#if defined(USE_LIBXML2)
-#if LIBXML_VERSION < 20900
-    oldExternalEntityLoader = xmlGetExternalEntityLoader();
-    /* to avoid  XML External Entity vulnerability with libxml2 < 2.9 */
-    xmlSetExternalEntityLoader (dummyEntityLoader); 
-    bExternalEntityAsked = MS_FALSE;
-#endif
-    /* parse to DOM-Structure with libxml2 and get the root element */
-    ows_request->document = xmlParseMemory(request->postrequest,
-                                           strlen(request->postrequest));
-#if LIBXML_VERSION < 20900
-    xmlSetExternalEntityLoader (oldExternalEntityLoader); 
-    if( bExternalEntityAsked )
-    {
-        msSetError(MS_OWSERR, "XML parsing error: %s",
-                 "msOWSPreParseRequest()", "External entity fetch");
-        return MS_FAILURE;
-    }
-#endif
-    if (ows_request->document == NULL
-        || (root = xmlDocGetRootElement(ows_request->document)) == NULL) {
-      xmlErrorPtr error = xmlGetLastError();
-      msSetError(MS_OWSERR, "XML parsing error: %s",
-                 "msOWSPreParseRequest()", error->message);
-      return MS_FAILURE;
-    }
-
-    /* Get service, version and request from root */
-    xmlChar* serviceTmp = xmlGetProp(root, BAD_CAST "service");
-    if (serviceTmp != NULL) {
-        ows_request->service = msStrdup((char *) serviceTmp);
-        xmlFree(serviceTmp);
-    }
-
-    xmlChar* versionTmp = xmlGetProp(root, BAD_CAST "version");
-    if (versionTmp != NULL) {
-        ows_request->version = msStrdup((char *) versionTmp);
-        xmlFree(versionTmp);
-    }
-
-    ows_request->request = msStrdup((char *) root->name);
-
-#else
-    /* parse with CPLXML */
-    ows_request->document = CPLParseXMLString(request->postrequest);
-    if (ows_request->document == NULL) {
-      msSetError(MS_OWSERR, "XML parsing error: %s",
-                 "msOWSPreParseRequest()", CPLGetLastErrorMsg());
-      return MS_FAILURE;
-    }
-
-    /* remove all namespaces */
-    CPLStripXMLNamespace(ows_request->document, NULL, 1);
-    for (temp = ows_request->document;
-         temp != NULL;
-         temp = temp->psNext) {
-
-      if (temp->eType == CXT_Element) {
-        const char *service, *version;
-        ows_request->request = msStrdup(temp->pszValue);
-
-        if ((service = CPLGetXMLValue(temp, "service", NULL)) != NULL) {
-          ows_request->service = msStrdup(service);
-        }
-        if ((version = CPLGetXMLValue(temp, "version", NULL)) != NULL) {
-          ows_request->version = msStrdup(version);
-        }
-        continue;
-      }
-    }
-#endif /* defined(USE_LIBXML2) */
-  } else {
-    msSetError(MS_OWSERR, "Unknown request method. Use either GET or POST.",
-               "msOWSPreParseRequest()");
-    return MS_FAILURE;
-  }
-
-  /* certain WMS requests do not require the service parameter */
-  /* see: http://trac.osgeo.org/mapserver/ticket/2531          */
-  if (ows_request->service == NULL
-      && ows_request->request != NULL) {
-    if (EQUAL(ows_request->request, "GetMap")
-        || EQUAL(ows_request->request, "GetFeatureInfo")) {
-      ows_request->service = msStrdup("WMS");
-    } else { /* service could not be determined */
-      return MS_DONE;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** msOWSDispatch() is the entry point for any OWS request (WMS, WFS, ...)
-** - If this is a valid request then it is processed and MS_SUCCESS is returned
-**   on success, or MS_FAILURE on failure.
-** - If force_ows_mode is true then an exception will be produced if the
-**   request is not recognized as a valid request.
-** - If force_ows_mode is false and this does not appear to be a valid OWS
-**   request then MS_DONE is returned and MapServer is expected to process
-**   this as a regular MapServer (traditional CGI) request.
-*/
-int msOWSDispatch(mapObj *map, cgiRequestObj *request, int ows_mode)
-{
-  int status = MS_DONE, force_ows_mode = 0;
-  owsRequestObj ows_request;
-
-  if (!request) {
-    return status;
-  }
-
-  force_ows_mode = (ows_mode == OWS || ows_mode == WFS);
-
-  msOWSInitRequestObj(&ows_request);
-  switch(msOWSPreParseRequest(request, &ows_request)) {
-    case MS_FAILURE: /* a severe error occurred */
-      return MS_FAILURE;
-    case MS_DONE:
-      /* OWS Service could not be determined              */
-      /* continue for now                                 */
-      status = MS_DONE;
-  }
-
-  if (ows_request.service == NULL) {
-#ifdef USE_LIBXML2
-    if (ows_request.request && EQUAL(ows_request.request, "GetMetadata")) {
-      status = msMetadataDispatch(map, request);
-      msOWSClearRequestObj(&ows_request);
-      return status;
-    }
-#endif
-#ifdef USE_WFS_SVR
-    if( msOWSLookupMetadata(&(map->web.metadata), "FO", "cite_wfs2") != NULL ) {
-      status = msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, NULL );
-    }
-    else
-#endif
-
-    /* exit if service is not set */
-    if(force_ows_mode) {
-      msSetError( MS_MISCERR,
-                  "OWS Common exception: exceptionCode=MissingParameterValue, locator=SERVICE, ExceptionText=SERVICE parameter missing.",
-                  "msOWSDispatch()");
-      status = MS_FAILURE;
-    } else {
-      status = MS_DONE;
-    }
-  } else if (EQUAL(ows_request.service, "WMS")) {
-#ifdef USE_WMS_SVR
-    status = msWMSDispatch(map, request, &ows_request, MS_FALSE);
-#else
-    msSetError( MS_WMSERR,
-                "SERVICE=WMS requested, but WMS support not configured in MapServer.",
-                "msOWSDispatch()" );
-#endif
-  } else if (EQUAL(ows_request.service, "WFS")) {
-#ifdef USE_WFS_SVR
-    status = msWFSDispatch(map, request, &ows_request, (ows_mode == WFS));
-#else
-    msSetError( MS_WFSERR,
-                "SERVICE=WFS requested, but WFS support not configured in MapServer.",
-                "msOWSDispatch()" );
-#endif
-  } else if (EQUAL(ows_request.service, "WCS")) {
-#ifdef USE_WCS_SVR
-    status = msWCSDispatch(map, request, &ows_request);
-#else
-    msSetError( MS_WCSERR,
-                "SERVICE=WCS requested, but WCS support not configured in MapServer.",
-                "msOWSDispatch()" );
-#endif
-  } else if (EQUAL(ows_request.service, "SOS")) {
-#ifdef USE_SOS_SVR
-    status = msSOSDispatch(map, request, &ows_request);
-#else
-    msSetError( MS_SOSERR,
-                "SERVICE=SOS requested, but SOS support not configured in MapServer.",
-                "msOWSDispatch()" );
-#endif
-  } else if(force_ows_mode) {
-    msSetError( MS_MISCERR,
-                "OWS Common exception: exceptionCode=InvalidParameterValue, locator=SERVICE, ExceptionText=SERVICE parameter value invalid.",
-                "msOWSDispatch()");
-    status = MS_FAILURE;
-  }
-
-  msOWSClearRequestObj(&ows_request);
-  return status;
-}
-
-/*
-** msOWSIpParse()
-**
-** Parse the IP address or range into a binary array.
-** Supports ipv4 and ipv6 addresses
-** Ranges can be specified using the CIDR notation (ie: 192.100.100.0/24)
-**
-** Returns the parsed of the IP (4 or 16).
-*/
-int msOWSIpParse(const char* ip, unsigned char* ip1, unsigned char* mask)
-{
-  int len = 0, masklen, seps;
-  
-  if (msCountChars((char*)ip, '.') == 3) {
-    /* ipv4 */
-    unsigned char* val = ip1;
-    len = 1;
-    masklen = 32;
-    *val = 0;
-    while (*ip) {
-      if (*ip >= '0' && *ip <= '9')
-        (*val) = 10 * (*val) + (*ip - '0');
-      else if (*ip == '.') {
-        ++val;
-        *val = 0;
-        ++len;
-      }
-      else if (*ip == '/')
-      {
-        masklen = atoi(ip+1);
-        if (masklen > 32)
-          masklen = 32;
-        break;
-      }
-      else 
-        break;
-      ++ip;
-    }
-    if (len != 4)
-      return 0;
-    /* write mask */
-    if (mask) {
-      memset(mask, 0, len);
-      val = mask;
-      while (masklen) {
-        if (masklen >= 8) {
-          *val = 0xff;
-          masklen -= 8;
-        }
-        else {
-          *val = - ((unsigned char)pow(2, 8 - masklen));
-          break;
-        }
-        ++val;
-      }
-    }
-  }
-  else if ((seps = msCountChars((char*)ip, ':')) > 1 && seps < 8) {
-    /* ipv6 */
-    unsigned short* val = (unsigned short*)ip1;
-    len = 2;
-    masklen = 128;
-    *val = 0;
-    while (*ip) {
-      if (*ip >= '0' && *ip <= '9')
-        (*val) = 16 * (*val) + (*ip - '0');
-      else if (*ip >= 'a' && *ip <= 'f')
-        (*val) = 16 * (*val) + (*ip - 'a' + 10);
-      else if (*ip >= 'A' && *ip <= 'F')
-        (*val) = 16 * (*val) + (*ip - 'A' + 10);
-      else if (*ip == ':') {
-        ++ip;
-        ++val;
-        len += 2;
-        *val = 0;
-        if (*ip == ':') {
-          /* insert 0 values */
-          while (seps <= 7) {
-            ++val;
-            len += 2;
-            *val = 0;
-            ++seps;
-          }
-        }
-        else
-          continue;
-      }
-      else if (*ip == '/')
-      {
-        masklen = atoi(ip+1);
-        if (masklen > 128)
-          masklen = 128;
-        break;
-      }
-      else
-        break;
-      ++ip;
-    }
-    if (len != 16)
-      return 0;
-    /* write mask */
-    if (mask) {
-      memset(mask, 0, len);
-      val = (unsigned short*)mask;
-      while (masklen) {
-        if (masklen >= 16) {
-          *val = 0xffff;
-          masklen -= 16;
-        }
-        else {
-          *val = - ((unsigned short)pow(2, 16 - masklen));
-          break;
-        }
-        ++val;
-      }
-    }
-  }
-
-  return len;
-}
-
-/*
-** msOWSIpInList()
-**
-** Check if an ip is in a space separated list of IP addresses/ranges.
-** Supports ipv4 and ipv6 addresses
-** Ranges can be specified using the CIDR notation (ie: 192.100.100.0/24)
-**
-** Returns MS_TRUE if the IP is found.
-*/
-int msOWSIpInList(const char *ip_list, const char* ip)
-{
-  int i, j, numips, iplen;
-  unsigned char ip1[16];
-  unsigned char ip2[16];
-  unsigned char mask[16];
-  char** ips;
-
-  /* Parse input IP */
-  iplen = msOWSIpParse(ip, (unsigned char*)&ip1, NULL);
-  if (iplen != 4 && iplen != 16) /* ipv4 or ipv6 */
-    return MS_FALSE;
-
-  ips = msStringSplit(ip_list, ' ', &numips);
-  if (ips) {
-    for (i = 0; i < numips; i++) {
-      if (msOWSIpParse(ips[i], (unsigned char*)&ip2, (unsigned char*)&mask) == iplen)
-      {
-        for (j = 0; j < iplen; j++) {
-          if ((ip1[j] & mask[j]) != (ip2[j] & mask[j]))
-            break;
-        }
-        if (j == iplen) {
-          msFreeCharArray(ips, numips);
-          return MS_TRUE; /* match found */
-        }
-      }
-    }
-    msFreeCharArray(ips, numips);
-  }
-
-  return MS_FALSE;
-}
-
-/*
-** msOWSIpDisabled()
-**
-** Check if an ip is in a list specified in the metadata section.
-**
-** Returns MS_TRUE if the IP is found.
-*/
-int msOWSIpInMetadata(const char *ip_list, const char* ip)
-{
-  FILE *stream;
-  char buffer[MS_BUFFER_LENGTH];
-  int found = MS_FALSE;
-  
-  if (strncasecmp(ip_list, "file:", 5) == 0) {
-    stream = fopen(ip_list + 5, "r");
-    if(stream) {
-      found = MS_FALSE;
-      while(fgets(buffer, MS_BUFFER_LENGTH, stream)) {
-        if(msOWSIpInList(buffer, ip)) {
-          found = MS_TRUE;
-          break;
-        }
-      }
-      fclose(stream);
-    }  
-  }
-  else {
-    if(msOWSIpInList(ip_list, ip))
-      found = MS_TRUE;
-  }  
-  return found;
-}
-
-/*
-** msOWSIpDisabled()
-**
-** Check if the layers are enabled or disabled by IP list.
-**
-** 'namespaces' is a string with a letter for each namespace to lookup
-** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
-** If namespaces is NULL then this function just does a regular metadata
-** lookup.
-**
-** Returns the disabled flag.
-*/
-int msOWSIpDisabled(hashTableObj *metadata, const char *namespaces, const char* ip)
-{
-  const char *ip_list;
-  int disabled = MS_FALSE;
-
-  if (!ip)
-    return MS_FALSE; /* no endpoint ip */
-
-  ip_list = msOWSLookupMetadata(metadata, namespaces, "allowed_ip_list");
-  if (!ip_list)
-    ip_list = msOWSLookupMetadata(metadata, "O", "allowed_ip_list");
-
-  if (ip_list) {
-    disabled = MS_TRUE;
-    if (msOWSIpInMetadata(ip_list, ip))
-      disabled = MS_FALSE;
-  }
-
-  ip_list = msOWSLookupMetadata(metadata, namespaces, "denied_ip_list");
-  if (!ip_list)
-    ip_list = msOWSLookupMetadata(metadata, "O", "denied_ip_list");
-
-  if (ip_list && msOWSIpInMetadata(ip_list, ip))
-    disabled = MS_TRUE;
-
-  return disabled;
-}
-
-/*
-** msOWSRequestIsEnabled()
-**
-** Check if a layer is visible for a specific OWS request.
-**
-** 'namespaces' is a string with a letter for each namespace to lookup in
-** the order they should be looked up. e.g. "MO" to lookup wms_ and ows_ If
-** namespaces is NULL then this function just does a regular metadata
-** lookup. If check_all_layers is set to MS_TRUE, the function will check
-** all layers to see if the request is enable. (returns as soon as one is found) */
-int msOWSRequestIsEnabled(mapObj *map, layerObj *layer,
-                          const char *namespaces, const char *request, int check_all_layers)
-{
-  int disabled = MS_FALSE; /* explicitly disabled flag */
-  const char *enable_request;
-  const char *remote_ip;
-
-  if (request == NULL)
-    return MS_FALSE;
-
-  remote_ip = getenv("REMOTE_ADDR");
-
-  /* First, we check in the layer metadata */
-  if (layer && check_all_layers == MS_FALSE) {
-    enable_request = msOWSLookupMetadata(&layer->metadata, namespaces, "enable_request");
-    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
-      return MS_TRUE;
-    if (disabled) return MS_FALSE;
-
-    enable_request = msOWSLookupMetadata(&layer->metadata, "O", "enable_request");
-    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
-      return MS_TRUE;
-    if (disabled) return MS_FALSE;
-
-    if (msOWSIpDisabled(&layer->metadata, namespaces, remote_ip))
-      return MS_FALSE;
-  }
-
-  if (map && (check_all_layers == MS_FALSE || map->numlayers == 0)) {
-    /* then we check in the map metadata */
-    enable_request = msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
-    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
-      return MS_TRUE;
-    if (disabled) return MS_FALSE;
-
-    enable_request = msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
-    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
-      return MS_TRUE;
-    if (disabled) return MS_FALSE;
-
-    if (msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
-      return MS_FALSE;
-  }
-
-  if (map && check_all_layers == MS_TRUE) {
-    int i, globally_enabled = MS_FALSE;
-    enable_request = msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
-    globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
-
-    if (!globally_enabled && !disabled) {
-      enable_request = msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
-      globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
-    }
-
-    if (globally_enabled && msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
-      globally_enabled = MS_FALSE;
-
-    /* Check all layers */
-    for(i=0; i<map->numlayers; i++) {
-      int result = MS_FALSE;
-      layerObj *lp;
-      lp = (GET_LAYER(map, i));
-
-      enable_request = msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
-      result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-      if (!result && disabled) continue; /* if the request has been explicitly set to disabled, continue */
-
-      if (!result && !disabled) { /* if the request has not been found in the wms metadata, */
-        /* check the ows namespace  */
-
-        enable_request = msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
-        result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-        if (!result && disabled) continue;
-      }
-
-      if (msOWSIpDisabled(&lp->metadata, namespaces, remote_ip))
-        continue;
-
-      if (result || (!disabled && globally_enabled))
-        return MS_TRUE;
-    }
-
-    if (!disabled && globally_enabled)
-        return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-/*
-** msOWSRequestLayersEnabled()
-**
-** Check if the layers are visible for a specific OWS request.
-**
-** 'namespaces' is a string with a letter for each namespace to lookup
-** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
-** If namespaces is NULL then this function just does a regular metadata
-** lookup.
-**
-** Generates an array of the layer ids enabled.
-*/
-void msOWSRequestLayersEnabled(mapObj *map, const char *namespaces,
-                               const char *request, owsRequestObj *ows_request)
-{
-  int disabled = MS_FALSE; /* explicitly disabled flag */
-  int globally_enabled = MS_FALSE;
-  const char *enable_request;
-  const char *remote_ip;
-
-  if (ows_request->numlayers > 0)
-    msFree(ows_request->enabled_layers);
-
-  ows_request->numlayers = 0;
-  ows_request->enabled_layers = NULL;
-
-  if (request == NULL || (map == NULL) || (map->numlayers <= 0))
-    return;
-
-  remote_ip = getenv("REMOTE_ADDR");
-
-  enable_request = msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
-  globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
-
-  if (!globally_enabled && !disabled) {
-    enable_request = msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
-    globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
-  }
-
-  if (globally_enabled && msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
-      globally_enabled = MS_FALSE;
-
-  if (map->numlayers) {
-    int i, layers_size = map->numlayers; /* for most of cases, this will be relatively small */
-
-    ows_request->enabled_layers = (int*)msSmallMalloc(sizeof(int)*layers_size);
-
-    for(i=0; i<map->numlayers; i++) {
-      int result = MS_FALSE;
-      layerObj *lp;
-      lp = (GET_LAYER(map, i));
-
-      enable_request = msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
-      result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-      if (!result && disabled) continue; /* if the request has been explicitly set to disabled, continue */
-
-      if (!result && !disabled) { /* if the request has not been found in the wms metadata, */
-        /* check the ows namespace  */
-
-        enable_request = msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
-        result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-        if (!result && disabled) continue;
-      }
-
-      if (msOWSIpDisabled(&lp->metadata, namespaces, remote_ip))
-          continue;
-
-      if (result || (!disabled && globally_enabled)) {
-        ows_request->enabled_layers[ows_request->numlayers] = lp->index;
-        ows_request->numlayers++;
-      }
-    }
-
-    if (ows_request->numlayers == 0) {
-      msFree(ows_request->enabled_layers);
-      ows_request->enabled_layers = NULL;
-    }
-  }
-}
-
-/* msOWSParseRequestMetadata
- *
- * This function parse a enable_request metadata string and check if the
- * given request is present and enabled.
- */
-int msOWSParseRequestMetadata(const char *metadata, const char *request, int *disabled)
-{
-  char requestBuffer[32];
-  int wordFlag = MS_FALSE;
-  int disableFlag = MS_FALSE;
-  int allFlag = MS_FALSE;
-  char *bufferPtr, *ptr = NULL;
-
-  *disabled = MS_FALSE;
-
-  if (metadata == NULL)
-    return MS_FALSE;
-
-  ptr = (char*)metadata;
-  const size_t len = strlen(ptr);
-  requestBuffer[0] = '\0';
-  bufferPtr = requestBuffer;
-
-  for (size_t i=0; i<=len; ++i,++ptr) {
-
-    if (!wordFlag && isspace(*ptr))
-      continue;
-
-    wordFlag = MS_TRUE;
-
-    if (*ptr == '!') {
-      disableFlag = MS_TRUE;
-      continue;
-    } else if ( (*ptr == ' ') || (*ptr != '\0' && ptr[1] == '\0')) { /* end of word */
-      if (ptr[1] == '\0' && *ptr != ' ') {
-        *bufferPtr = *ptr;
-        ++bufferPtr;
-      }
-
-      *bufferPtr = '\0';
-      if (strcasecmp(request, requestBuffer) == 0) {
-        *disabled =  MS_TRUE; /* explicitly found, will stop the process in msOWSRequestIsEnabled() */
-        return (disableFlag ? MS_FALSE:MS_TRUE);
-      } else {
-        if (strcmp("*", requestBuffer) == 0) { /* check if we read the all flag */
-          if (disableFlag)
-            *disabled =  MS_TRUE;
-          allFlag = disableFlag ? MS_FALSE:MS_TRUE;
-        }
-        /* reset flags */
-        wordFlag = MS_FALSE;
-        disableFlag = MS_FALSE;
-        bufferPtr = requestBuffer;
-      }
-    } else {
-      *bufferPtr = *ptr;
-      ++bufferPtr;
-    }
-  }
-
-  return allFlag;
-}
-
-/*
-** msOWSGetPrefixFromNamespace()
-**
-** Return the metadata name prefix from a character identifying the OWS
-** namespace.
-*/
-static
-const char* msOWSGetPrefixFromNamespace(char chNamespace)
-{
-    // Return should be a 3 character string, otherwise breaks assumption
-    // in msOWSLookupMetadata()
-    switch( chNamespace )
-    {
-        case 'O': return "ows";
-        case 'A': return "oga"; /* oga_... (OGC Geospatial API) */
-        case 'M': return "wms";
-        case 'F': return "wfs";
-        case 'C': return "wcs";
-        case 'G': return "gml";
-        case 'S': return "sos";
-        default:
-          /* We should never get here unless an invalid code (typo) is */
-          /* present in the code, but since this happened before... */
-          msSetError(MS_WMSERR,
-                     "Unsupported metadata namespace code (%c).",
-                     "msOWSGetPrefixFromNamespace()", chNamespace );
-          assert(MS_FALSE);
-          return NULL;
-    }
-}
-
-/*
-** msOWSLookupMetadata()
-**
-** Attempts to lookup a given metadata name in multiple OWS namespaces.
-**
-** 'namespaces' is a string with a letter for each namespace to lookup
-** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
-** If namespaces is NULL then this function just does a regular metadata
-** lookup.
-*/
-const char *msOWSLookupMetadata(hashTableObj *metadata,
-                                const char *namespaces, const char *name)
-{
-  const char *value = NULL;
-
-  if (namespaces == NULL) {
-    value = msLookupHashTable(metadata, (char*)name);
-  } else {
-    char buf[100] = "ows_";
-
-    strlcpy(buf+4, name, 96);
-
-    while (value == NULL && *namespaces != '\0') {
-      const char* prefix = msOWSGetPrefixFromNamespace(*namespaces);
-      if( prefix == NULL )
-          return NULL;
-      assert(strlen(prefix) == 3);
-      memcpy(buf, prefix, 3);
-      value = msLookupHashTable(metadata, buf);
-      namespaces++;
-    }
-  }
-
-  return value;
-}
-
-
-/*
-** msOWSLookupMetadataWithLanguage()
-**
-** Attempts to lookup a given metadata name in multiple OWS namespaces
-** for a specific language.
-*/
-const char *msOWSLookupMetadataWithLanguage(hashTableObj *metadata,
-    const char *namespaces, const char *name, const char* validated_language)
-{
-  const char *value = NULL;
-
-  if ( name && validated_language && validated_language[0] ) {
-    size_t bufferSize = strlen(name)+strlen(validated_language)+2;
-    char *name2 = (char *) msSmallMalloc( bufferSize );
-    snprintf(name2, bufferSize, "%s.%s", name, validated_language);
-    value = msOWSLookupMetadata(metadata, namespaces, name2);
-    free(name2);
-  }
-
-  if ( name && !value ) {
-    value = msOWSLookupMetadata(metadata, namespaces, name);
-  }
-
-
-  return value;
-}
-
-/*
-** msOWSLookupMetadata2()
-**
-** Attempts to lookup a given metadata name in multiple hashTables, and
-** in multiple OWS namespaces within each. First searches the primary
-** table and if no result is found, attempts the search using the
-** secondary (fallback) table.
-**
-** 'namespaces' is a string with a letter for each namespace to lookup
-** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
-** If namespaces is NULL then this function just does a regular metadata
-** lookup.
-*/
-const char *msOWSLookupMetadata2(hashTableObj *pri,
-                                 hashTableObj *sec,
-                                 const char *namespaces,
-                                 const char *name)
-{
-  const char *result;
-
-  if ((result = msOWSLookupMetadata(pri, namespaces, name)) == NULL) {
-    /* Try the secondary table */
-    result = msOWSLookupMetadata(sec, namespaces, name);
-  }
-
-  return result;
-}
-
-
-/* msOWSParseVersionString()
-**
-** Parse a version string in the format "a.b.c" or "a.b" and return an
-** integer in the format 0x0a0b0c suitable for regular integer comparisons.
-**
-** Returns one of OWS_VERSION_NOTSET or OWS_VERSION_BADFORMAT if version
-** could not be parsed.
-*/
-int msOWSParseVersionString(const char *pszVersion)
-{
-  char **digits = NULL;
-  int numDigits = 0;
-
-  if (pszVersion) {
-    int nVersion = 0;
-    digits = msStringSplit(pszVersion, '.', &numDigits);
-    if (digits == NULL || numDigits < 2 || numDigits > 3) {
-      msSetError(MS_OWSERR,
-                 "Invalid version (%s). Version must be in the "
-                 "format 'x.y' or 'x.y.z'",
-                 "msOWSParseVersionString()", pszVersion);
-      if (digits)
-        msFreeCharArray(digits, numDigits);
-      return OWS_VERSION_BADFORMAT;
-    }
-
-    nVersion = atoi(digits[0])*0x010000;
-    nVersion += atoi(digits[1])*0x0100;
-    if (numDigits > 2)
-      nVersion += atoi(digits[2]);
-
-    msFreeCharArray(digits, numDigits);
-
-    return nVersion;
-  }
-
-  return OWS_VERSION_NOTSET;
-}
-
-/* msOWSGetVersionString()
-**
-** Returns a OWS version string in the format a.b.c from the integer
-** version value passed as argument (0x0a0b0c)
-**
-** Fills in the pszBuffer and returns a reference to it. Recommended buffer
-** size is OWS_VERSION_MAXLEN chars.
-*/
-const char *msOWSGetVersionString(int nVersion, char *pszBuffer)
-{
-
-  if (pszBuffer)
-    snprintf(pszBuffer, OWS_VERSION_MAXLEN-1, "%d.%d.%d",
-             (nVersion/0x10000)%0x100, (nVersion/0x100)%0x100, nVersion%0x100);
-
-  return pszBuffer;
-}
-
-
-/*
-** msOWSGetEPSGProj()
-**
-** Extract projection code for this layer/map.
-**
-** First look for a xxx_srs metadata. If not found then look for an EPSG
-** code in projectionObj, and if not found then return NULL.
-**
-** If bReturnOnlyFirstOne=TRUE and metadata contains multiple EPSG codes
-** then only the first one (which is assumed to be the layer's default
-** projection) is returned.
-*/
-void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne, char **epsgCode)
-{
-  const char *value;
-  *epsgCode = NULL;
-
-  /* metadata value should already be in format "EPSG:n" or "AUTO:..." */
-  if (metadata && ((value = msOWSLookupMetadata(metadata, namespaces, "srs")) != NULL)) {
-    const char *space_ptr;
-    if (!bReturnOnlyFirstOne || (space_ptr = strchr(value,' ')) == NULL) {
-      *epsgCode = msStrdup(value);
-      return;
-    }
-    
-
-    *epsgCode = msSmallMalloc((space_ptr - value + 1)*sizeof(char));
-    /* caller requested only first projection code, copy up to the first space character*/
-    strlcpy(*epsgCode, value, space_ptr - value + 1) ;
-    return;
-  } else if (proj && proj->numargs > 0 && (value = strstr(proj->args[0], "init=epsg:")) != NULL) {
-    *epsgCode = msSmallMalloc((strlen("EPSG:")+strlen(value+10)+1)*sizeof(char));
-    sprintf(*epsgCode, "EPSG:%s", value+10);
-    return;
-  } else if (proj && proj->numargs > 0 && (value = strstr(proj->args[0], "init=crs:")) != NULL) {
-    *epsgCode = msSmallMalloc((strlen("CRS:")+strlen(value+9)+1)*sizeof(char));
-    sprintf(*epsgCode, "CRS:%s", value+9);
-    return;
-  } else if (proj && proj->numargs > 0 && (strncasecmp(proj->args[0], "AUTO:", 5) == 0 ||
-             strncasecmp(proj->args[0], "AUTO2:", 6) == 0)) {
-    *epsgCode = msStrdup(proj->args[0]);
-    return;
-  }
-}
-
-/*
-** msOWSProjectToWGS84()
-**
-** Reprojects the extent to WGS84.
-**
-*/
-void msOWSProjectToWGS84(projectionObj *srcproj, rectObj *ext)
-{
-  if (srcproj->proj && !msProjIsGeographicCRS(srcproj)) {
-    projectionObj wgs84;
-    msInitProjection(&wgs84);
-    msProjectionInheritContextFrom(&wgs84, srcproj);
-    msLoadProjectionString(&wgs84, "+proj=longlat +ellps=WGS84 +datum=WGS84");
-    msProjectRect(srcproj, &wgs84, ext);
-    msFreeProjection(&wgs84);
-  }
-}
-
-/* msOWSGetLanguage()
-**
-** returns the language via MAP/WEB/METADATA/ows_language
-**
-** Use value of "ows_language" metadata, if not set then
-** return "undefined" as a default
-*/
-const char *msOWSGetLanguage(mapObj *map, const char *context)
-{
-  const char *language;
-
-  /* if this is an exception, MapServer always returns Exception
-     messages in en-US
-  */
-  if (strcmp(context,"exception") == 0) {
-    language = MS_ERROR_LANGUAGE;
-  }
-  /* if not, fetch language from mapfile metadata */
-  else {
-    language = msLookupHashTable(&(map->web.metadata), "ows_language");
-
-    if (language == NULL) {
-      language = "undefined";
-    }
-  }
-  return language;
-}
-
-/* msOWSGetSchemasLocation()
-**
-** schemas location is the root of the web tree where all WFS-related
-** schemas can be found on this server.  These URLs must exist in order
-** to validate xml.
-**
-** Use value of "ows_schemas_location" metadata, if not set then
-** return ".." as a default
-*/
-const char *msOWSGetSchemasLocation(mapObj *map)
-{
-  const char *schemas_location;
-
-  schemas_location = msLookupHashTable(&(map->web.metadata),
-                                       "ows_schemas_location");
-  if (schemas_location == NULL)
-    schemas_location = OWS_DEFAULT_SCHEMAS_LOCATION;
-
-  return schemas_location;
-}
-
-/*
-** msOWSGetExpandedMetadataKey()
-*/
-static
-char* msOWSGetExpandedMetadataKey(const char *namespaces, const char *metadata_name)
-{
-  char* pszRet = msStringConcatenate(NULL, "");
-  for( int i = 0; namespaces[i] != '\0'; ++i )
-  {
-      if( i > 0 )
-          pszRet = msStringConcatenate(pszRet, " or ");
-      pszRet = msStringConcatenate(pszRet, "\"");
-      pszRet = msStringConcatenate(pszRet, msOWSGetPrefixFromNamespace(namespaces[i]));
-      pszRet = msStringConcatenate(pszRet, "_");
-      pszRet = msStringConcatenate(pszRet, metadata_name);
-      pszRet = msStringConcatenate(pszRet, "\"");
-  }
-  return pszRet;
-}
-
-/*
-** msOWSGetOnlineResource()
-**
-** Return the online resource for this service.  First try to lookup
-** specified metadata, and if not found then try to build the URL ourselves.
-**
-** Returns a newly allocated string that should be freed by the caller or
-** NULL in case of error.
-*/
-char * msOWSGetOnlineResource(mapObj *map, const char *namespaces, const char *metadata_name,
-                              cgiRequestObj *req)
-{
-  const char *value;
-  char *online_resource = NULL;
-
-  /* We need this script's URL, including hostname. */
-  /* Default to use the value of the "onlineresource" metadata, and if not */
-  /* set then build it: "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?" */
-  /* (+append the map=... param if it was explicitly passed in QUERY_STRING) */
-  /*  */
-  if ((value = msOWSLookupMetadata(&(map->web.metadata), namespaces, metadata_name))) {
-    online_resource = msOWSTerminateOnlineResource(value);
-  } else {
-    if ((online_resource = msBuildOnlineResource(map, req)) == NULL) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, metadata_name);
-      msSetError(MS_CGIERR, "Please set %s metadata.", "msOWSGetOnlineResource()", pszExpandedMetadataKey);
-      msFree(pszExpandedMetadataKey);
-      return NULL;
-    }
-  }
-
-  return online_resource;
-}
-
-/*
-** msOWSTerminateOnlineResource()
-**
-** Append trailing "?" or "&" to an onlineresource URL if it doesn't have
-** one already. The returned string is then ready to append GET parameters
-** to it.
-**
-** Returns a newly allocated string that should be freed by the caller or
-** NULL in case of error.
-*/
-char * msOWSTerminateOnlineResource(const char *src_url)
-{
-  char *online_resource = NULL;
-  size_t buffer_size = 0;
-
-  if (src_url == NULL)
-    return NULL;
-
-  buffer_size = strlen(src_url)+2;
-  online_resource = (char*) malloc(buffer_size);
-
-  if (online_resource == NULL) {
-    msSetError(MS_MEMERR, NULL, "msOWSTerminateOnlineResource()");
-    return NULL;
-  }
-
-  strlcpy(online_resource, src_url, buffer_size);
-
-  /* Append trailing '?' or '&' if missing. */
-  if (strchr(online_resource, '?') == NULL)
-    strlcat(online_resource, "?", buffer_size);
-  else {
-    char *c;
-    c = online_resource+strlen(online_resource)-1;
-    if (*c != '?' && *c != '&')
-      strlcpy(c+1, "&", buffer_size-strlen(online_resource));
-  }
-
-  return online_resource;
-}
-
-/************************************************************************/
-/*                         msUpdateGMLFieldMetadata                     */
-/*                                                                      */
-/*      Updates a fields GML metadata if it has not already             */
-/*      been set. Nullable is not implemented for all drivers           */
-/*      and can be set to 0 if unknown                                  */
-/************************************************************************/
-int msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name, const char *gml_type,
-                             const char *gml_width, const char *gml_precision, const short nullable)
-{
-
-    char md_item_name[256];
-
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type", field_name );
-    if( msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, gml_type );
-
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_width", field_name );
-    if( strlen(gml_width) > 0
-        && msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, gml_width );
-
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_precision", field_name );
-    if( strlen(gml_precision) > 0
-        && msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, gml_precision );
-
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_nillable", field_name );
-    if( nullable > 0 
-        && msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, "true" );
-
-    return MS_TRUE;
-}
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-
-/*
-** msRenameLayer()
-*/
-static int msRenameLayer(layerObj *lp, int count)
-{
-  char *newname;
-  newname = (char*)malloc((strlen(lp->name)+5)*sizeof(char));
-  if (!newname) {
-    msSetError(MS_MEMERR, NULL, "msRenameLayer()");
-    return MS_FAILURE;
-  }
-  sprintf(newname, "%s_%2.2d", lp->name, count);
-  free(lp->name);
-  lp->name = newname;
-
-  return MS_SUCCESS;
-}
-
-/*
-** msOWSMakeAllLayersUnique()
-*/
-int msOWSMakeAllLayersUnique(mapObj *map)
-{
-  int i, j;
-
-  /* Make sure all layers in the map file have valid and unique names */
-  for(i=0; i<map->numlayers; i++) {
-    int count=1;
-    for(j=i+1; j<map->numlayers; j++) {
-      if (GET_LAYER(map, i)->name == NULL || GET_LAYER(map, j)->name == NULL) {
-        continue;
-      }
-      if (strcasecmp(GET_LAYER(map, i)->name, GET_LAYER(map, j)->name) == 0 &&
-          msRenameLayer((GET_LAYER(map, j)), ++count) != MS_SUCCESS) {
-        return MS_FAILURE;
-      }
-    }
-
-    /* Don't forget to rename the first layer if duplicates were found */
-    if (count > 1 && msRenameLayer((GET_LAYER(map, i)), 1) != MS_SUCCESS) {
-      return MS_FAILURE;
-    }
-  }
-  return MS_SUCCESS;
-}
-
-/*
-** msOWSNegotiateVersion()
-**
-** returns the most suitable version an OWS is to support given a client
-** version parameter.
-**
-** supported_versions must be ordered from highest to lowest
-**
-** Returns a version integer of the supported version
-**
-*/
-
-int msOWSNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions)
-{
-  int i;
-
-  /* if version is not set return highest version */
-  if (! requested_version)
-    return supported_versions[0];
-
-  /* if the requested version is lower than the lowest version return the lowest version  */
-  if (requested_version < supported_versions[num_supported_versions-1])
-    return supported_versions[num_supported_versions-1];
-
-  /* return the first entry that's lower than or equal to the requested version */
-  for (i = 0; i < num_supported_versions; i++) {
-    if (supported_versions[i] <= requested_version)
-      return supported_versions[i];
-  }
-
-  return requested_version;
-}
-
-/*
-** msOWSGetOnlineResource()
-**
-** Return the online resource for this service and add language parameter.
-**
-** Returns a newly allocated string that should be freed by the caller or
-** NULL in case of error.
-*/
-char * msOWSGetOnlineResource2(mapObj *map, const char *namespaces, const char *metadata_name,
-                               cgiRequestObj *req, const char* validated_language)
-{
-  char *online_resource = msOWSGetOnlineResource(map, namespaces, metadata_name, req);
-
-  if ( online_resource && validated_language && validated_language[0] ) {
-    /* online_resource is already terminated, so we can simply add language=...& */
-    /* but first we need to make sure that online_resource has enough capacity */
-    online_resource = (char *)msSmallRealloc(online_resource, strlen(online_resource) + strlen(validated_language) +  11);
-    strcat(online_resource, "language=");
-    strcat(online_resource, validated_language);
-    strcat(online_resource, "&");
-  }
-
-  return online_resource;
-}
-
-/* msOWSGetInspireSchemasLocation()
-**
-** schemas location is the root of the web tree where all Inspire-related
-** schemas can be found on this server.  These URLs must exist in order
-** to validate xml.
-**
-** Use value of "inspire_schemas_location" metadata
-*/
-const char *msOWSGetInspireSchemasLocation(mapObj *map)
-{
-  const char *schemas_location;
-
-  schemas_location = msLookupHashTable(&(map->web.metadata),
-                                       "inspire_schemas_location");
-  if (schemas_location == NULL)
-    schemas_location = "http://inspire.ec.europa.eu/schemas";
-
-  return schemas_location;
-}
-
-/* msOWSGetLanguageList
-**
-** Returns the list of languages that this service supports
-**
-** Use value of "languages" metadata (comma-separated list), or NULL if not set
-**
-** Returns a malloced char** of length numitems which must be freed
-** by the caller, or NULL (with numitems = 0)
-*/
-char **msOWSGetLanguageList(mapObj *map, const char *namespaces, int *numitems)
-{
-
-  const char *languages = NULL;
-
-  languages = msOWSLookupMetadata(&(map->web.metadata), namespaces, "languages");
-  if (languages && strlen(languages) > 0) {
-    return msStringSplit(languages, ',', numitems);
-  } else {
-    *numitems = 0;
-    return NULL;
-  }
-}
-
-/* msOWSGetLanguageFromList
-**
-** Returns a language according to the language requested by the client
-**
-** If the requested language is in the languages metadata then use it,
-** otherwise ignore it and use the defaul language, which is the first entry in
-** the languages metadata list. Calling with a NULL requested_langauge
-** therefore returns this default language. If the language metadata list is
-** not defined then the language is set to NULL.
-**
-** Returns a malloced char* which must be freed by the caller, or NULL
-*/
-char *msOWSGetLanguageFromList(mapObj *map, const char *namespaces, const char *requested_language)
-{
-  int num_items = 0;
-  char **languages = msOWSGetLanguageList(map, namespaces, &num_items);
-  char *language = NULL;
-
-  if( languages && num_items > 0 ) {
-    if ( !requested_language || !msStringInArray( requested_language, languages, num_items) ) {
-      language = msStrdup(languages[0]);
-    } else {
-      language = msStrdup(requested_language);
-    }
-  }
-  msFreeCharArray(languages, num_items);
-
-  return language;
-}
-
-
-/* msOWSLanguageNegotiation
-**
-** Returns a language according to the accepted languages requested by the client
-**
-** Returns a malloced char* which must be freed by the caller, or NULL
-*/
-char *msOWSLanguageNegotiation(mapObj *map, const char *namespaces, char **accept_languages, int num_accept_languages)
-{
-  int num_languages = 0;
-  char **languages = NULL;
-  char *result_language = NULL;
-
-  languages = msOWSGetLanguageList(map, namespaces, &num_languages);
-
-  if (languages && num_languages > 0) {
-    int i;
-    for (i = 0; i < num_accept_languages; ++i) {
-      const char *accept_language = accept_languages[i];
-
-      /* '*' means any language */
-      if (EQUAL(accept_language, "*")) {
-        result_language = msStrdup(languages[0]);
-        break;
-      } else if (msStringInArray(accept_language, languages, num_languages)) {
-        result_language = msStrdup(accept_language);
-        break;
-      }
-    }
-
-    if (result_language == NULL) {
-      result_language = msStrdup(languages[0]);
-    }
-  }
-
-  msFreeCharArray(languages, num_languages);
-  return result_language;
-}
-
-
-/* msOWSPrintInspireCommonExtendedCapabilities
-**
-** Output INSPIRE common extended capabilities items to stream
-** The currently supported items are metadata and languages
-**
-** tag_name is the name (including ns prefix) of the tag to include the whole
-** extended capabilities block in
-**
-** service is currently included for future compatibility when differing
-** extended capabilities elements are included for different service types
-**
-** Returns a status code; MS_NOERR if all ok, action_if_not_found otherwise
-*/
-int msOWSPrintInspireCommonExtendedCapabilities(FILE *stream, mapObj *map, const char *namespaces,
-    int action_if_not_found, const char *tag_name, const char* tag_ns,
-    const char *validated_language, const OWSServiceType service)
-{
-
-  int metadataStatus = 0;
-  int languageStatus = 0;
-
-  if( tag_ns )
-    msIO_fprintf(stream, "  <%s %s>\n", tag_name, tag_ns);
-  else
-    msIO_fprintf(stream, "  <%s>\n", tag_name);
-
-  metadataStatus = msOWSPrintInspireCommonMetadata(stream, map, namespaces, action_if_not_found, service);
-  languageStatus = msOWSPrintInspireCommonLanguages(stream, map, namespaces, action_if_not_found, validated_language);
-
-  msIO_fprintf(stream, "  </%s>\n", tag_name);
-
-  return (metadataStatus != MS_NOERR) ? metadataStatus : languageStatus;
-}
-
-/* msOWSPrintInspireCommonMetadata
-**
-** Output INSPIRE common metadata items to a stream
-**
-** Returns a status code; MS_NOERR if all OK, action_if_not_found otherwise
-*/
-int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map, const char *namespaces,
-                                    int action_if_not_found, const OWSServiceType service)
-{
-
-  int status = MS_NOERR;
-  const char *inspire_capabilities = NULL;
-
-  inspire_capabilities = msOWSLookupMetadata(&(map->web.metadata), namespaces, "inspire_capabilities");
-
-  if(!inspire_capabilities) {
-    if (OWS_WARN == action_if_not_found) {
-      msIO_fprintf(stream, "<!-- WARNING: missing metadata entry for 'inspire_capabilities', one of 'embed' and 'url' must be supplied. -->\n");
-    }
-    return action_if_not_found;
-  }
-  if (strcasecmp("url",inspire_capabilities) == 0) {
-    if ( msOWSLookupMetadata(&(map->web.metadata), namespaces, "inspire_metadataurl_href") != NULL ) {
-      msIO_fprintf(stream, "    <inspire_common:MetadataUrl xsi:type=\"inspire_common:resourceLocatorType\">\n");
-      msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_metadataurl_href", OWS_WARN, "      <inspire_common:URL>%s</inspire_common:URL>\n", "");
-      msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_metadataurl_format", OWS_WARN, "      <inspire_common:MediaType>%s</inspire_common:MediaType>\n", "");
-      msIO_fprintf(stream, "    </inspire_common:MetadataUrl>\n");
-    } else {
-      status = action_if_not_found;
-      if (OWS_WARN == action_if_not_found) {
-        char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, "inspire_metadataurl_href");
-        msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-        msFree(pszExpandedMetadataKey);
-      }
-    }
-  } else if (strcasecmp("embed",inspire_capabilities) == 0) {
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_resourcelocator", OWS_WARN, "    <inspire_common:ResourceLocator>\n      <inspire_common:URL>%s</inspire_common:URL>\n    </inspire_common:ResourceLocator>\n", NULL);
-    msIO_fprintf(stream,"    <inspire_common:ResourceType>service</inspire_common:ResourceType>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_temporal_reference", OWS_WARN, "    <inspire_common:TemporalReference>\n      <inspire_common:DateOfLastRevision>%s</inspire_common:DateOfLastRevision>\n    </inspire_common:TemporalReference>\n", "");
-    msIO_fprintf(stream, "    <inspire_common:Conformity>\n");
-    msIO_fprintf(stream, "      <inspire_common:Specification>\n");
-    msIO_fprintf(stream, "        <inspire_common:Title>-</inspire_common:Title>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_temporal_reference", OWS_NOERR, "        <inspire_common:DateOfLastRevision>%s</inspire_common:DateOfLastRevision>\n", "");
-    msIO_fprintf(stream, "      </inspire_common:Specification>\n");
-    msIO_fprintf(stream, "      <inspire_common:Degree>notEvaluated</inspire_common:Degree>\n");
-    msIO_fprintf(stream, "    </inspire_common:Conformity>\n");
-    msIO_fprintf(stream, "    <inspire_common:MetadataPointOfContact>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_mpoc_name", OWS_WARN, "      <inspire_common:OrganisationName>%s</inspire_common:OrganisationName>\n", "");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_mpoc_email", OWS_WARN, "      <inspire_common:EmailAddress>%s</inspire_common:EmailAddress>\n", "");
-    msIO_fprintf(stream, "    </inspire_common:MetadataPointOfContact>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_metadatadate", OWS_WARN, "      <inspire_common:MetadataDate>%s</inspire_common:MetadataDate>\n", "");
-    if( service == OWS_WFS || service == OWS_WCS )
-        msIO_fprintf(stream,"    <inspire_common:SpatialDataServiceType>download</inspire_common:SpatialDataServiceType>\n");
-    else
-        msIO_fprintf(stream,"    <inspire_common:SpatialDataServiceType>view</inspire_common:SpatialDataServiceType>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_keyword", OWS_WARN, "    <inspire_common:MandatoryKeyword>\n      <inspire_common:KeywordValue>%s</inspire_common:KeywordValue>\n    </inspire_common:MandatoryKeyword>\n", "");
-  } else {
-    status = action_if_not_found;
-    if (OWS_WARN == action_if_not_found) {
-      msIO_fprintf(stream, "<!-- WARNING: invalid value '%s' for 'inspire_capabilities', only 'embed' and 'url' are supported. -->\n", inspire_capabilities);
-    }
-  }
-
-  return status;
-}
-
-/* msOWSPrintInspireCommonLanguages
-**
-** Output INSPIRE supported languages block to stream
-**
-** Returns a status code; MS_NOERR if all OK; action_if_not_found otherwise
-*/
-int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map, const char *namespaces,
-                                     int action_if_not_found, const char *validated_language)
-{
-  char *buffer = NULL; /* temp variable for malloced strings that will need freeing */
-  int status = MS_NOERR;
-
-  char *default_language = msOWSGetLanguageFromList(map, namespaces, NULL);
-
-  if(validated_language && validated_language[0] && default_language) {
-    msIO_fprintf(stream, "    <inspire_common:SupportedLanguages>\n");
-    msIO_fprintf(stream, "      <inspire_common:DefaultLanguage><inspire_common:Language>%s"
-                 "</inspire_common:Language></inspire_common:DefaultLanguage>\n",
-                 buffer = msEncodeHTMLEntities(default_language));
-    msFree(buffer);
-    
-    /* append _exclude to our default_language*/
-    default_language = msSmallRealloc(default_language,strlen(default_language)+strlen("_exclude")+1);
-    strcat(default_language,"_exclude");
-
-    msOWSPrintEncodeMetadataList(stream, &(map->web.metadata), namespaces, "languages", NULL, NULL,
-                                 "      <inspire_common:SupportedLanguage><inspire_common:Language>%s"
-                                 "</inspire_common:Language></inspire_common:SupportedLanguage>\n", default_language);
-    msIO_fprintf(stream, "    </inspire_common:SupportedLanguages>\n");
-    msIO_fprintf(stream, "    <inspire_common:ResponseLanguage><inspire_common:Language>%s"
-                 "</inspire_common:Language></inspire_common:ResponseLanguage>\n", validated_language);
-  } else {
-    status = action_if_not_found;
-    if (OWS_WARN == action_if_not_found) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, "languages");
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-      msFree(pszExpandedMetadataKey);
-    }
-  }
-
-  msFree(default_language);
-
-  return status;
-}
-
-/*
-** msOWSPrintMetadata()
-**
-** Attempt to output a capability item.  If corresponding metadata is not
-** found then one of a number of predefined actions will be taken.
-** If a default value is provided and metadata is absent then the
-** default will be used.
-*/
-
-int msOWSPrintMetadata(FILE *stream, hashTableObj *metadata,
-                       const char *namespaces, const char *name,
-                       int action_if_not_found, const char *format,
-                       const char *default_value)
-{
-  const char *value = NULL;
-  int status = MS_NOERR;
-
-  if((value = msOWSLookupMetadata(metadata, namespaces, name)) != NULL) {
-    msIO_fprintf(stream, format, value);
-  } else {
-    if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-      msFree(pszExpandedMetadataKey);
-      status = action_if_not_found;
-    }
-
-    if (default_value)
-      msIO_fprintf(stream, format, default_value);
-  }
-
-  return status;
-}
-
-
-/*
-** msOWSPrintEncodeMetadata()
-**
-** Attempt to output a capability item.  If corresponding metadata is not
-** found then one of a number of predefined actions will be taken.
-** If a default value is provided and metadata is absent then the
-** default will be used.
-** Also encode the value with msEncodeHTMLEntities.
-*/
-
-int msOWSPrintEncodeMetadata(FILE *stream, hashTableObj *metadata,
-                             const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value)
-{
-  return msOWSPrintEncodeMetadata2(stream, metadata, namespaces, name, action_if_not_found, format, default_value, NULL);
-}
-
-
-/*
-** msOWSPrintEncodeMetadata2()
-**
-** Attempt to output a capability item in the requested language.
-** Fallback using no language parameter.
-*/
-int msOWSPrintEncodeMetadata2(FILE *stream, hashTableObj *metadata,
-                              const char *namespaces, const char *name,
-                              int action_if_not_found,
-                              const char *format, const char *default_value,
-                              const char *validated_language)
-{
-  const char *value;
-  char * pszEncodedValue=NULL;
-  int status = MS_NOERR;
-
-  if((value = msOWSLookupMetadataWithLanguage(metadata, namespaces, name, validated_language))) {
-    pszEncodedValue = msEncodeHTMLEntities(value);
-    msIO_fprintf(stream, format, pszEncodedValue);
-    free(pszEncodedValue);
-  } else {
-    if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedName = msStringConcatenate(NULL, name);
-      if( validated_language && validated_language[0] )
-      {
-          pszExpandedName = msStringConcatenate(pszExpandedName, ".");
-          pszExpandedName = msStringConcatenate(pszExpandedName, validated_language);
-      }
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, pszExpandedName);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-      msFree(pszExpandedName);
-      msFree(pszExpandedMetadataKey);
-      status = action_if_not_found;
-    }
-
-    if (default_value) {
-      pszEncodedValue = msEncodeHTMLEntities(default_value);
-      msIO_fprintf(stream, format, default_value);
-      free(pszEncodedValue);
-    }
-  }
-
-  return status;
-}
-
-
-/*
-** msOWSGetEncodeMetadata()
-**
-** Equivalent to msOWSPrintEncodeMetadata. Returns en encoded value of the
-** metadata or the default value.
-** Caller should free the returned string.
-*/
-char *msOWSGetEncodeMetadata(hashTableObj *metadata,
-                             const char *namespaces, const char *name,
-                             const char *default_value)
-{
-  const char *value;
-  char * pszEncodedValue=NULL;
-  if((value = msOWSLookupMetadata(metadata, namespaces, name)))
-    pszEncodedValue = msEncodeHTMLEntities(value);
-  else if (default_value)
-    pszEncodedValue = msEncodeHTMLEntities(default_value);
-
-  return pszEncodedValue;
-}
-
-
-/*
-** msOWSPrintValidateMetadata()
-**
-** Attempt to output a capability item.  If corresponding metadata is not
-** found then one of a number of predefined actions will be taken.
-** If a default value is provided and metadata is absent then the
-** default will be used.
-** Also validate the value with msIsXMLTagValid.
-*/
-
-int msOWSPrintValidateMetadata(FILE *stream, hashTableObj *metadata,
-                               const char *namespaces, const char *name,
-                               int action_if_not_found,
-                               const char *format, const char *default_value)
-{
-  const char *value;
-  int status = MS_NOERR;
-
-  if((value = msOWSLookupMetadata(metadata, namespaces, name))) {
-    if(msIsXMLTagValid(value) == MS_FALSE)
-      msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a "
-                   "XML tag context. -->\n", value);
-    msIO_fprintf(stream, format, value);
-  } else {
-    if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-      msFree(pszExpandedMetadataKey);
-      status = action_if_not_found;
-    }
-
-    if (default_value) {
-      if(msIsXMLTagValid(default_value) == MS_FALSE)
-        msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid "
-                     "in a XML tag context. -->\n", default_value);
-      msIO_fprintf(stream, format, default_value);
-    }
-  }
-
-  return status;
-}
-
-/*
-** msOWSPrintGroupMetadata()
-**
-** Attempt to output a capability item.  If corresponding metadata is not
-** found then one of a number of predefined actions will be taken.
-** If a default value is provided and metadata is absent then the
-** default will be used.
-*/
-int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char* pszGroupName,
-                            const char *namespaces, const char *name,
-                            int action_if_not_found,
-                            const char *format, const char *default_value)
-{
-  return msOWSPrintGroupMetadata2(stream, map, pszGroupName, namespaces, name, action_if_not_found, format, default_value, NULL);
-}
-
-/*
-** msOWSPrintGroupMetadata2()
-**
-** Attempt to output a capability item in the requested language.
-** Fallback using no language parameter.
-*/
-int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char* pszGroupName,
-                             const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value,
-                             const char *validated_language)
-{
-  const char *value;
-  char *encoded;
-  int status = MS_NOERR;
-  int i;
-
-  for (i=0; i<map->numlayers; i++) {
-    if (GET_LAYER(map, i)->group && (strcmp(GET_LAYER(map, i)->group, pszGroupName) == 0) && &(GET_LAYER(map, i)->metadata)) {
-      if((value = msOWSLookupMetadataWithLanguage(&(GET_LAYER(map, i)->metadata), namespaces, name, validated_language))) {
-        encoded = msEncodeHTMLEntities(value);
-        msIO_fprintf(stream, format, encoded);
-        msFree(encoded);
-        return status;
-      }
-    }
-  }
-
-  if (action_if_not_found == OWS_WARN) {
-    char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-    msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-    msFree(pszExpandedMetadataKey);
-    status = action_if_not_found;
-  }
-
-  if (default_value) {
-    encoded = msEncodeHTMLEntities(default_value);
-    msIO_fprintf(stream, format, encoded);
-    msFree(encoded);
-  }
-
-  return status;
-}
-
-/* msOWSPrintURLType()
-**
-** Attempt to output a URL item in capabilties.  If corresponding metadata
-** is not found then one of a number of predefined actions will be taken.
-** Since it's a capability item, five metadata will be used to populate the
-** XML elements.
-**
-** The 'name' argument is the basename of the metadata items relating to this
-** URL type and the suffixes _type, _width, _height, _format and _href will
-** be appended to the name in the metadata search.
-** e.g. passing name=metadataurl will result in the following medata entries
-** being used:
-**    ows_metadataurl_type
-**    ows_metadataurl_format
-**    ows_metadataurl_href
-**    ... (width and height are unused for metadata)
-**
-** As for all the msOWSPrint*() functions, the namespace argument specifies
-** which prefix (ows_, wms_, wcs_, etc.) is used for the metadata names above.
-**
-** Then the final string will be built from
-** the tag_name and the five metadata. The template is:
-** <tag_name%type%width%height%format>%href</tag_name>
-**
-** For example the width format will usually be " width=\"%s\"".
-** An extern format will be "> <Format>%s</Format"
-**
-** Another template template may be used, but it needs to contains 5 %s,
-** otherwise leave it to NULL. If tag_format is used then you don't need the
-** tag_name and the tabspace.
-**
-** Note that all values will be HTML-encoded.
-**/
-int msOWSPrintURLType(FILE *stream, hashTableObj *metadata,
-                      const char *namespaces, const char *name,
-                      int action_if_not_found, const char *tag_format,
-                      const char *tag_name, const char *type_format,
-                      const char *width_format, const char *height_format,
-                      const char *urlfrmt_format, const char *href_format,
-                      int type_is_mandatory, int width_is_mandatory,
-                      int height_is_mandatory, int format_is_mandatory,
-                      int href_is_mandatory, const char *default_type,
-                      const char *default_width, const char *default_height,
-                      const char *default_urlfrmt, const char *default_href,
-                      const char *tabspace)
-{
-  const char *value;
-  char *metadata_name;
-  char *encoded;
-  int status = MS_NOERR;
-  char *type=NULL, *width=NULL, *height=NULL, *urlfrmt=NULL, *href=NULL;
-
-  const size_t buffer_size = strlen(name)+10;
-  metadata_name = (char*)malloc(buffer_size);
-
-  /* Get type */
-  if(type_format != NULL) {
-    snprintf(metadata_name, buffer_size, "%s_type", name);
-    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
-      encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(type_format)+strlen(encoded)+1;
-      type = (char*)malloc(buffer_size_tmp);
-      snprintf(type, buffer_size_tmp, type_format, encoded);
-      msFree(encoded);
-    }
-  }
-
-  /* Get width */
-  if(width_format != NULL) {
-    snprintf(metadata_name, buffer_size, "%s_width", name);
-    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
-      encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(width_format)+strlen(encoded)+1;
-      width = (char*)malloc(buffer_size_tmp);
-      snprintf(width, buffer_size_tmp, width_format, encoded);
-      msFree(encoded);
-    }
-  }
-
-  /* Get height */
-  if(height_format != NULL) {
-    snprintf(metadata_name, buffer_size, "%s_height", name);
-    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
-      encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(height_format)+strlen(encoded)+1;
-      height = (char*)malloc(buffer_size_tmp);
-      snprintf(height, buffer_size_tmp, height_format, encoded);
-      msFree(encoded);
-    }
-  }
-
-  /* Get format */
-  if(urlfrmt_format != NULL) {
-    snprintf(metadata_name, buffer_size, "%s_format", name);
-    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
-      encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(urlfrmt_format)+strlen(encoded)+1;
-      urlfrmt = (char*)malloc(buffer_size_tmp);
-      snprintf(urlfrmt, buffer_size_tmp, urlfrmt_format, encoded);
-      msFree(encoded);
-    }
-  }
-
-  /* Get href */
-  if(href_format != NULL) {
-    snprintf(metadata_name, buffer_size, "%s_href", name);
-    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
-      encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(href_format)+strlen(encoded)+1;
-      href = (char*)malloc(buffer_size_tmp);
-      snprintf(href, buffer_size_tmp, href_format, encoded);
-      msFree(encoded);
-    }
-  }
-
-  msFree(metadata_name);
-
-  if(type || width || height || urlfrmt || href ||
-      (!metadata && (default_type || default_width || default_height ||
-                     default_urlfrmt || default_href))) {
-    if((!type && type_is_mandatory) || (!width && width_is_mandatory) ||
-        (!height && height_is_mandatory) ||
-        (!urlfrmt && format_is_mandatory) || (!href && href_is_mandatory)) {
-      msIO_fprintf(stream, "<!-- WARNING: Some mandatory elements for '%s' are missing in this context. -->\n", tag_name);
-      if (action_if_not_found == OWS_WARN) {
-        char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-        msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-        msFree(pszExpandedMetadataKey);
-        status = action_if_not_found;
-      }
-    } else {
-      if(!type && type_format && default_type) {
-        const size_t buffer_size_tmp = strlen(type_format) + strlen(default_type) + 2;
-        type = (char*) malloc(buffer_size_tmp);
-        snprintf(type, buffer_size_tmp, type_format, default_type);
-      } else if(!type)
-        type = msStrdup("");
-      if(!width && width_format && default_width) {
-        const size_t buffer_size_tmp = strlen(width_format) + strlen(default_width) + 2;
-        width = (char*) malloc(buffer_size_tmp);
-        snprintf(width, buffer_size_tmp, width_format, default_width);
-      } else if(!width)
-        width = msStrdup("");
-      if(!height && height_format && default_height) {
-        const size_t buffer_size_tmp =  strlen(height_format) + strlen(default_height) + 2;
-        height = (char*) malloc(buffer_size_tmp);
-        snprintf(height, buffer_size_tmp, height_format, default_height);
-      } else if(!height)
-        height = msStrdup("");
-      if(!urlfrmt && urlfrmt_format && default_urlfrmt) {
-        const size_t buffer_size_tmp = strlen(urlfrmt_format) + strlen(default_urlfrmt) + 2;
-        urlfrmt = (char*) malloc(buffer_size_tmp);
-        snprintf(urlfrmt, buffer_size_tmp, urlfrmt_format, default_urlfrmt);
-      } else if(!urlfrmt)
-        urlfrmt = msStrdup("");
-      if(!href && href_format && default_href) {
-        const size_t buffer_size_tmp = strlen(href_format) + strlen(default_href) + 2;
-        href = (char*) malloc(buffer_size_tmp);
-        snprintf(href, buffer_size_tmp, href_format, default_href);
-      } else if(!href)
-        href = msStrdup("");
-
-      if(tag_format == NULL)
-        msIO_fprintf(stream, "%s<%s%s%s%s%s>%s</%s>\n", tabspace,
-                     tag_name, type, width, height, urlfrmt, href,
-                     tag_name);
-      else
-        msIO_fprintf(stream, tag_format,
-                     type, width, height, urlfrmt, href);
-    }
-
-    msFree(type);
-    msFree(width);
-    msFree(height);
-    msFree(urlfrmt);
-    msFree(href);
-  } else {
-    if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
-      msFree(pszExpandedMetadataKey);
-      status = action_if_not_found;
-    }
-  }
-
-  return status;
-}
-
-/* msOWSPrintParam()
-**
-** Same as printMetadata() but applied to mapfile parameters.
-**/
-int msOWSPrintParam(FILE *stream, const char *name, const char *value,
-                    int action_if_not_found, const char *format,
-                    const char *default_value)
-{
-  int status = MS_NOERR;
-
-  if(value && strlen(value) > 0) {
-    msIO_fprintf(stream, format, value);
-  } else {
-    if (action_if_not_found == OWS_WARN) {
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory mapfile parameter '%s' was missing in this context. -->\n", name);
-      status = action_if_not_found;
-    }
-
-    if (default_value)
-      msIO_fprintf(stream, format, default_value);
-  }
-
-  return status;
-}
-
-/* msOWSPrintEncodeParam()
-**
-** Same as printEncodeMetadata() but applied to mapfile parameters.
-**/
-int msOWSPrintEncodeParam(FILE *stream, const char *name, const char *value,
-                          int action_if_not_found, const char *format,
-                          const char *default_value)
-{
-  int status = MS_NOERR;
-  char *encode;
-
-  if(value && strlen(value) > 0) {
-    encode = msEncodeHTMLEntities(value);
-    msIO_fprintf(stream, format, encode);
-    msFree(encode);
-  } else {
-    if (action_if_not_found == OWS_WARN) {
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory mapfile parameter '%s' was missing in this context. -->\n", name);
-      status = action_if_not_found;
-    }
-
-    if (default_value) {
-      encode = msEncodeHTMLEntities(default_value);
-      msIO_fprintf(stream, format, encode);
-      msFree(encode);
-    }
-  }
-
-  return status;
-}
-
-/* msOWSPrintMetadataList()
-**
-** Prints comma-separated lists metadata.  (e.g. keywordList)
-** default_value serves 2 purposes if specified:
-** - won't be printed if part of MetadataList (default_value == key"_exclude")
-**  (exclusion)
-** - will be printed if MetadataList is empty (fallback)
-**/
-int msOWSPrintMetadataList(FILE *stream, hashTableObj *metadata,
-                           const char *namespaces, const char *name,
-                           const char *startTag,
-                           const char *endTag, const char *itemFormat,
-                           const char *default_value)
-{
-  const char *value;
-
-  value = msOWSLookupMetadata(metadata, namespaces, name);
-
-  if(value == NULL) {
-    value = default_value;
-    default_value = NULL;
-  }
-
-  if(value != NULL) {
-    char **keywords;
-    int numkeywords;
-
-    keywords = msStringSplit(value, ',', &numkeywords);
-    if(keywords && numkeywords > 0) {
-      int kw;
-      if(startTag) msIO_fprintf(stream, "%s", startTag);
-      for(kw=0; kw<numkeywords; kw++) {
-        if (default_value != NULL
-            && strncasecmp(keywords[kw],default_value,strlen(keywords[kw])) == 0
-            && strncasecmp("_exclude",default_value+strlen(default_value)-8,8) == 0)
-          continue;
-
-        msIO_fprintf(stream, itemFormat, keywords[kw]);
-      }
-      if(endTag) msIO_fprintf(stream, "%s", endTag);
-    }
-    msFreeCharArray(keywords, numkeywords);
-    return MS_TRUE;
-  }
-  return MS_FALSE;
-}
-
-/* msOWSPrintEncodeMetadataList()
-**
-** Prints comma-separated lists metadata.  (e.g. keywordList)
-** This will print HTML encoded values.
-** default_value serves 2 purposes if specified:
-** - won't be printed if part of MetadataList (default_value == key"_exclude")
-**  (exclusion)
-** - will be printed if MetadataList is empty (fallback)
-**/
-int msOWSPrintEncodeMetadataList(FILE *stream, hashTableObj *metadata,
-                                 const char *namespaces, const char *name,
-                                 const char *startTag,
-                                 const char *endTag, const char *itemFormat,
-                                 const char *default_value)
-{
-  const char *value;
-  char *encoded;
-  size_t default_value_len = 0;
-
-  value = msOWSLookupMetadata(metadata, namespaces, name);
-
-  if(value == NULL) {
-    value = default_value;
-    default_value = NULL;
-  }
-  if( default_value )
-      default_value_len = strlen(default_value);
-
-  if(value != NULL) {
-    char **keywords;
-    int numkeywords;
-
-    keywords = msStringSplit(value, ',', &numkeywords);
-    if(keywords && numkeywords > 0) {
-      int kw;
-      if(startTag) msIO_fprintf(stream, "%s", startTag);
-      for(kw=0; kw<numkeywords; kw++) {
-        if (default_value != NULL
-            && default_value_len > 8
-            && strncasecmp(keywords[kw],default_value,strlen(keywords[kw])) == 0
-            && strncasecmp("_exclude",default_value+default_value_len-8,8) == 0)
-          continue;
-
-        encoded = msEncodeHTMLEntities(keywords[kw]);
-        msIO_fprintf(stream, itemFormat, encoded);
-        msFree(encoded);
-      }
-      if(endTag) msIO_fprintf(stream, "%s", endTag);
-    }
-    msFreeCharArray(keywords, numkeywords);
-    return MS_TRUE;
-  }
-  return MS_FALSE;
-}
-
-/* msOWSPrintEncodeParamList()
-**
-** Same as msOWSPrintEncodeMetadataList() but applied to mapfile parameters.
-**/
-int msOWSPrintEncodeParamList(FILE *stream, const char *name,
-                              const char *value, int action_if_not_found,
-                              char delimiter, const char *startTag,
-                              const char *endTag, const char *format,
-                              const char *default_value)
-{
-  int status = MS_NOERR;
-  char *encoded;
-  char **items = NULL;
-  int numitems = 0, i;
-
-  if(value && strlen(value) > 0)
-    items = msStringSplit(value, delimiter, &numitems);
-  else {
-    if (action_if_not_found == OWS_WARN) {
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory mapfile parameter '%s' was missing in this context. -->\n", name);
-      status = action_if_not_found;
-    }
-
-    if (default_value)
-      items = msStringSplit(default_value, delimiter, &numitems);
-  }
-
-  if(items && numitems > 0) {
-    if(startTag) msIO_fprintf(stream, "%s", startTag);
-    for(i=0; i<numitems; i++) {
-      encoded = msEncodeHTMLEntities(items[i]);
-      msIO_fprintf(stream, format, encoded);
-      msFree(encoded);
-    }
-    if(endTag) msIO_fprintf(stream, "%s", endTag);
-  }
-  msFreeCharArray(items, numitems);
-
-  return status;
-}
-
-
-/*
-** msOWSPrintEX_GeographicBoundingBox()
-**
-** Print a EX_GeographicBoundingBox tag for WMS1.3.0
-**
-*/
-void msOWSPrintEX_GeographicBoundingBox(FILE *stream, const char *tabspace,
-                                        rectObj *extent, projectionObj *srcproj)
-
-{
-  const char *pszTag = "EX_GeographicBoundingBox";  /* The default for WMS */
-  rectObj ext;
-
-  ext = *extent;
-
-  /* always project to lat long */
-  msOWSProjectToWGS84(srcproj, &ext);
-
-  msIO_fprintf(stream, "%s<%s>\n", tabspace, pszTag);
-  msIO_fprintf(stream, "%s    <westBoundLongitude>%.6f</westBoundLongitude>\n", tabspace, ext.minx);
-  msIO_fprintf(stream, "%s    <eastBoundLongitude>%.6f</eastBoundLongitude>\n", tabspace, ext.maxx);
-  msIO_fprintf(stream, "%s    <southBoundLatitude>%.6f</southBoundLatitude>\n", tabspace, ext.miny);
-  msIO_fprintf(stream, "%s    <northBoundLatitude>%.6f</northBoundLatitude>\n", tabspace, ext.maxy);
-  msIO_fprintf(stream, "%s</%s>\n", tabspace, pszTag);
-
-  /* msIO_fprintf(stream, "%s<%s minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\" />\n",
-                  tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy); */
-}
-
-/*
-** msOWSPrintLatLonBoundingBox()
-**
-** Print a LatLonBoundingBox tag for WMS, or LatLongBoundingBox for WFS
-** ... yes, the tag name differs between WMS and WFS, yuck!
-**
-*/
-void msOWSPrintLatLonBoundingBox(FILE *stream, const char *tabspace,
-                                 rectObj *extent, projectionObj *srcproj,
-                                 projectionObj *wfsproj, OWSServiceType nService)
-{
-  const char *pszTag = "LatLonBoundingBox";  /* The default for WMS */
-  rectObj ext;
-
-  ext = *extent;
-
-  if (nService == OWS_WMS) { /* always project to lat long */
-    msOWSProjectToWGS84(srcproj, &ext);
-  } else if (nService == OWS_WFS) { /* called from wfs 1.0.0 only: project to map srs, if set */
-    pszTag = "LatLongBoundingBox";
-    if (wfsproj) {
-      if (msProjectionsDiffer(srcproj, wfsproj) == MS_TRUE)
-        msProjectRect(srcproj, wfsproj, &ext);
-    }
-  }
-
-  msIO_fprintf(stream, "%s<%s minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" maxy=\"%.6f\" />\n",
-               tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy);
-}
-
-/*
-** Emit a bounding box if we can find projection information.
-** If <namespaces>_bbox_extended is not set, emit a single bounding box
-** using the layer's native SRS (ignoring any <namespaces>_srs metadata).
-**
-** If <namespaces>_bbox_extended is set to true, emit a bounding box
-** for every projection listed in the <namespaces>_srs list.
-** Check the map level metadata for both _bbox_extended and _srs,
-** if there is no such metadata at the layer level.
-** (These settings make more sense at the global/map level anyways)
-*/
-void msOWSPrintBoundingBox(FILE *stream, const char *tabspace,
-                           rectObj *extent,
-                           projectionObj *srcproj,
-                           hashTableObj *layer_meta,
-                           hashTableObj *map_meta,
-                           const char *namespaces,
-                           int wms_version)
-{
-  const char    *value, *resx, *resy, *wms_bbox_extended;
-  char *encoded, *encoded_resx, *encoded_resy, *epsg_str;
-  char **epsgs;
-  int i, num_epsgs;
-  projectionObj proj;
-  rectObj ext;
-
-  wms_bbox_extended = msOWSLookupMetadata2(layer_meta, map_meta, namespaces, "bbox_extended");
-  if( wms_bbox_extended && strncasecmp(wms_bbox_extended, "true", 5) == 0 ) {
-    /* get a list of all projections from the metadata
-       try the layer metadata first, otherwise use the map's */
-    if( msOWSLookupMetadata(layer_meta, namespaces, "srs") ) {
-      msOWSGetEPSGProj(srcproj, layer_meta, namespaces, MS_FALSE, &epsg_str);
-    } else {
-      msOWSGetEPSGProj(srcproj, map_meta, namespaces, MS_FALSE, &epsg_str);
-    }
-    epsgs = msStringSplit(epsg_str, ' ', &num_epsgs);
-    msFree(epsg_str);
-  } else {
-    /* Look for EPSG code in PROJECTION block only.  "wms_srs" metadata cannot be
-     * used to establish the native projection of a layer for BoundingBox purposes.
-     */
-    epsgs = (char **) msSmallMalloc(sizeof(char *));
-    num_epsgs = 1;
-    msOWSGetEPSGProj(srcproj, layer_meta, namespaces, MS_TRUE, &(epsgs[0]));
-  }
-
-  for( i = 0; i < num_epsgs; i++) {
-    value = epsgs[i];
-    if( value && *value) {
-      memcpy(&ext, extent, sizeof(rectObj));
-
-      /* reproject the extents for each SRS's bounding box */
-      msInitProjection(&proj);
-      msProjectionInheritContextFrom(&proj, srcproj);
-      if (msLoadProjectionStringEPSG(&proj, (char *)value) == 0) {
-        if (msProjectionsDiffer(srcproj, &proj) == MS_TRUE) {
-          msProjectRect(srcproj, &proj, &ext);
-        }
-        /*for wms 1.3.0 we need to make sure that we present the BBOX with
-          a reversed axes for some espg codes*/
-        if (wms_version >= OWS_1_3_0 && strncasecmp(value, "EPSG:", 5) == 0) {
-          msAxisNormalizePoints( &proj, 1, &(ext.minx), &(ext.miny) );
-          msAxisNormalizePoints( &proj, 1, &(ext.maxx), &(ext.maxy) );
-        }
-      }
-
-      encoded = msEncodeHTMLEntities(value);
-      if (msProjIsGeographicCRS(&proj) )
-        msIO_fprintf(stream, "%s<BoundingBox %s=\"%s\"\n"
-                     "%s            minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" maxy=\"%.6f\"",
-                     tabspace,
-                     (wms_version >= OWS_1_3_0) ? "CRS" : "SRS",
-                     encoded,
-                     tabspace, ext.minx, ext.miny,
-                     ext.maxx, ext.maxy);
-      else
-        msIO_fprintf(stream, "%s<BoundingBox %s=\"%s\"\n"
-                     "%s            minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\"",
-                     tabspace,
-                     (wms_version >= OWS_1_3_0) ? "CRS" : "SRS",
-                     encoded,
-                     tabspace, ext.minx, ext.miny,
-                     ext.maxx, ext.maxy);
-
-      msFree(encoded);
-      msFreeProjection( &proj );
-
-      if( (resx = msOWSLookupMetadata2( layer_meta, map_meta, "MFO", "resx" )) != NULL &&
-          (resy = msOWSLookupMetadata2( layer_meta, map_meta, "MFO", "resy" )) != NULL ) {
-        encoded_resx = msEncodeHTMLEntities(resx);
-        encoded_resy = msEncodeHTMLEntities(resy);
-        msIO_fprintf( stream, "\n%s            resx=\"%s\" resy=\"%s\"",
-                      tabspace, encoded_resx, encoded_resy );
-        msFree(encoded_resx);
-        msFree(encoded_resy);
-      }
-
-      msIO_fprintf( stream, " />\n" );
-    }
-  }
-  msFreeCharArray(epsgs, num_epsgs);
-}
-
-
-/*
-** Print the contact information
-*/
-void msOWSPrintContactInfo( FILE *stream, const char *tabspace,
-                            int nVersion, hashTableObj *metadata,
-                            const char *namespaces )
-{
-  /* contact information is a required element in 1.0.7 but the */
-  /* sub-elements such as ContactPersonPrimary, etc. are not! */
-  /* In 1.1.0, ContactInformation becomes optional. */
-  if (nVersion > OWS_1_0_0) {
-    msIO_fprintf(stream, "%s<ContactInformation>\n", tabspace);
-
-    /* ContactPersonPrimary is optional, but when present then all its  */
-    /* sub-elements are mandatory */
-
-    if(msOWSLookupMetadata(metadata, namespaces, "contactperson") ||
-        msOWSLookupMetadata(metadata, namespaces, "contactorganization")) {
-      msIO_fprintf(stream, "%s  <ContactPersonPrimary>\n", tabspace);
-
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "contactperson",
-                               OWS_WARN, "      <ContactPerson>%s</ContactPerson>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "contactorganization",
-                               OWS_WARN, "      <ContactOrganization>%s</ContactOrganization>\n",
-                               NULL);
-      msIO_fprintf(stream, "%s  </ContactPersonPrimary>\n", tabspace);
-    }
-
-    if(msOWSLookupMetadata(metadata, namespaces, "contactposition")) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "contactposition",
-                               OWS_NOERR, "      <ContactPosition>%s</ContactPosition>\n",
-                               NULL);
-    }
-
-    /* ContactAdress is optional, but when present then all its  */
-    /* sub-elements are mandatory */
-    if(msOWSLookupMetadata( metadata, namespaces, "addresstype" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "address" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "city" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "stateorprovince" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "postcode" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "country" )) {
-      msIO_fprintf(stream, "%s  <ContactAddress>\n", tabspace);
-
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces,"addresstype", OWS_WARN,
-                               "        <AddressType>%s</AddressType>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "address", OWS_WARN,
-                               "        <Address>%s</Address>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "city", OWS_WARN,
-                               "        <City>%s</City>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "stateorprovince",
-                               OWS_WARN,"        <StateOrProvince>%s</StateOrProvince>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "postcode", OWS_WARN,
-                               "        <PostCode>%s</PostCode>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "country", OWS_WARN,
-                               "        <Country>%s</Country>\n", NULL);
-      msIO_fprintf(stream, "%s  </ContactAddress>\n", tabspace);
-    }
-
-    if(msOWSLookupMetadata(metadata, namespaces, "contactvoicetelephone")) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces,
-                               "contactvoicetelephone", OWS_NOERR,
-                               "      <ContactVoiceTelephone>%s</ContactVoiceTelephone>\n",
-                               NULL);
-    }
-
-    if(msOWSLookupMetadata(metadata, namespaces, "contactfacsimiletelephone")) {
-      msOWSPrintEncodeMetadata(stream, metadata,
-                               namespaces, "contactfacsimiletelephone", OWS_NOERR,
-                               "      <ContactFacsimileTelephone>%s</ContactFacsimileTelephone>\n",
-                               NULL);
-    }
-
-    if(msOWSLookupMetadata(metadata, namespaces, "contactelectronicmailaddress")) {
-      msOWSPrintEncodeMetadata(stream, metadata,
-                               namespaces, "contactelectronicmailaddress", OWS_NOERR,
-                               "  <ContactElectronicMailAddress>%s</ContactElectronicMailAddress>\n",
-                               NULL);
-    }
-    msIO_fprintf(stream, "%s</ContactInformation>\n", tabspace);
-  }
-}
-
-/*
-** msOWSGetLayerExtent()
-**
-** Try to establish layer extent, first looking for "ows_extent" metadata, and
-** if not found then call msLayerGetExtent() which will lookup the
-** layer->extent member, and if not found will open layer to read extent.
-**
-*/
-int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces, rectObj *ext)
-{
-  (void)map;
-  const char *value;
-
-  if ((value = msOWSLookupMetadata(&(lp->metadata), namespaces, "extent")) != NULL) {
-    char **tokens;
-    int n;
-
-    tokens = msStringSplit(value, ' ', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_WMSERR, "Wrong number of arguments for EXTENT metadata.",
-                 "msOWSGetLayerExtent()");
-      return MS_FAILURE;
-    }
-    ext->minx = atof(tokens[0]);
-    ext->miny = atof(tokens[1]);
-    ext->maxx = atof(tokens[2]);
-    ext->maxy = atof(tokens[3]);
-
-    msFreeCharArray(tokens, n);
-    return MS_SUCCESS;
-  } else {
-    return msLayerGetExtent(lp, ext);
-  }
-
-  return MS_FAILURE;
-}
-
-
-/**********************************************************************
- *                          msOWSExecuteRequests()
- *
- * Execute a number of WFS/WMS HTTP requests in parallel, and then
- * update layerObj information with the result of the requests.
- **********************************************************************/
-int msOWSExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
-                         mapObj *map, int bCheckLocalCache)
-{
-  int nStatus, iReq;
-
-  /* Execute requests */
-#if defined(USE_CURL)
-  nStatus = msHTTPExecuteRequests(pasReqInfo, numRequests, bCheckLocalCache);
-#else
-  msSetError(MS_WMSERR, "msOWSExecuteRequests() called apparently without libcurl configured, msHTTPExecuteRequests() not available.",
-             "msOWSExecuteRequests()");
-  return MS_FAILURE;
-#endif
-
-  /* Scan list of layers and call the handler for each layer type to */
-  /* pass them the request results. */
-  for(iReq=0; iReq<numRequests; iReq++) {
-    if (pasReqInfo[iReq].nLayerId >= 0 &&
-        pasReqInfo[iReq].nLayerId < map->numlayers) {
-      layerObj *lp;
-
-      lp = GET_LAYER(map, pasReqInfo[iReq].nLayerId);
-
-      if (lp->connectiontype == MS_WFS)
-        msWFSUpdateRequestInfo(lp, &(pasReqInfo[iReq]));
-    }
-  }
-
-  return nStatus;
-}
-
-/**********************************************************************
- *                          msOWSProcessException()
- *
- **********************************************************************/
-void msOWSProcessException(layerObj *lp, const char *pszFname,
-                           int nErrorCode, const char *pszFuncName)
-{
-  FILE *fp;
-
-  if ((fp = fopen(pszFname, "r")) != NULL) {
-    char *pszBuf=NULL;
-    int   nBufSize=0;
-    char *pszStart, *pszEnd;
-
-    fseek(fp, 0, SEEK_END);
-    nBufSize = ftell(fp);
-    if(nBufSize < 0) {
-      msSetError(MS_IOERR, NULL, "msOWSProcessException()");
-      fclose(fp);
-      return;
-    }
-    rewind(fp);
-    pszBuf = (char*)malloc((nBufSize+1)*sizeof(char));
-    if (pszBuf == NULL) {
-      msSetError(MS_MEMERR, NULL, "msOWSProcessException()");
-      fclose(fp);
-      return;
-    }
-
-    if ((int) fread(pszBuf, 1, nBufSize, fp) != nBufSize) {
-      msSetError(MS_IOERR, NULL, "msOWSProcessException()");
-      free(pszBuf);
-      fclose(fp);
-      return;
-    }
-
-    pszBuf[nBufSize] = '\0';
-
-
-    /* OK, got the data in the buffer.  Look for the <Message> tags */
-    if ((strstr(pszBuf, "<WFS_Exception>") &&            /* WFS style */
-         (pszStart = strstr(pszBuf, "<Message>")) &&
-         (pszEnd = strstr(pszStart, "</Message>")) ) ||
-        (strstr(pszBuf, "<ServiceExceptionReport>") &&   /* WMS style */
-         (pszStart = strstr(pszBuf, "<ServiceException>")) &&
-         (pszEnd = strstr(pszStart, "</ServiceException>")) )) {
-      pszStart = strchr(pszStart, '>')+1;
-      *pszEnd = '\0';
-      msSetError(nErrorCode, "Got Remote Server Exception for layer %s: %s",
-                 pszFuncName, lp->name?lp->name:"(null)", pszStart);
-    } else {
-      msSetError(MS_WFSCONNERR, "Unable to parse Remote Server Exception Message for layer %s.",
-                 pszFuncName, lp->name?lp->name:"(null)");
-    }
-
-    free(pszBuf);
-    fclose(fp);
-  }
-}
-
-/**********************************************************************
- *                          msOWSBuildURLFilename()
- *
- * Build a unique filename for this URL to use in caching remote server
- * requests.  Slashes and illegal characters will be turned into '_'
- *
- * Returns a newly allocated buffer that should be freed by the caller or
- * NULL in case of error.
- **********************************************************************/
-char *msOWSBuildURLFilename(const char *pszPath, const char *pszURL,
-                            const char *pszExt)
-{
-  char *pszBuf, *pszPtr;
-  int  i;
-  size_t nBufLen = 0;
-
-
-  nBufLen = strlen(pszURL) + strlen(pszExt) +2;
-  if (pszPath)
-    nBufLen += (strlen(pszPath)+1);
-
-  pszBuf = (char*)malloc(nBufLen);
-  if (pszBuf == NULL) {
-    msSetError(MS_MEMERR, NULL, "msOWSBuildURLFilename()");
-    return NULL;
-  }
-  pszBuf[0] = '\0';
-
-  if (pszPath) {
-#ifdef _WIN32
-    if (pszPath[strlen(pszPath) -1] != '/' &&
-        pszPath[strlen(pszPath) -1] != '\\')
-      snprintf(pszBuf, nBufLen, "%s\\", pszPath);
-    else
-      snprintf(pszBuf, nBufLen, "%s", pszPath);
-#else
-    if (pszPath[strlen(pszPath) -1] != '/')
-      snprintf(pszBuf, nBufLen, "%s/", pszPath);
-    else
-      snprintf(pszBuf, nBufLen, "%s", pszPath);
-#endif
-  }
-
-  pszPtr = pszBuf + strlen(pszBuf);
-
-  for(i=0; pszURL[i] != '\0'; i++) {
-    if (isalnum(pszURL[i]))
-      *pszPtr = pszURL[i];
-    else
-      *pszPtr = '_';
-    pszPtr++;
-  }
-
-  strlcpy(pszPtr, pszExt, nBufLen);
-
-  return pszBuf;
-}
-
-/*
-** msOWSGetProjURN()
-**
-** Fetch an OGC URN for this layer or map.  Similar to msOWSGetEPSGProj()
-** but returns the result in the form "urn:ogc:def:crs:EPSG::27700".
-** The returned buffer is dynamically allocated, and must be freed by the
-** caller.
-*/
-char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne)
-{
-  char *result;
-  char **tokens;
-  int numtokens, i;
-  char *oldStyle = NULL;
-  
-  msOWSGetEPSGProj( proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle );
-
-  if( oldStyle == NULL ||
-      strncmp(oldStyle,"CRS:",4) == 0 ||
-      strncmp(oldStyle,"AUTO:",5) == 0 ||
-      strncmp(oldStyle,"AUTO2:",6) == 0 ) {
-    msFree(oldStyle);
-    return NULL;
-  }
-
-  result = msStrdup("");
-
-  tokens = msStringSplit(oldStyle, ' ', &numtokens);
-  msFree(oldStyle);
-  for(i=0; tokens != NULL && i<numtokens; i++) {
-    char urn[100];
-    char* colon = strchr(tokens[i], ':');
-
-    if( colon != NULL && strchr(colon + 1, ':') == NULL ) {
-      *colon = 0;
-      snprintf( urn, sizeof(urn), "urn:ogc:def:crs:%s::%s", tokens[i], colon + 1 );
-    }
-    else if( strcasecmp(tokens[i],"imageCRS") == 0 )
-      snprintf( urn, sizeof(urn), "urn:ogc:def:crs:OGC::imageCRS" );
-    else if( strncmp(tokens[i],"urn:ogc:def:crs:",16) == 0 ) {
-      strlcpy( urn, tokens[i], sizeof(urn));
-    } else {
-      strlcpy( urn, "", sizeof(urn));
-    }
-
-    if( strlen(urn) > 0 ) {
-      const size_t bufferSize = strlen(result)+strlen(urn)+2;
-      result = (char *) msSmallRealloc(result, bufferSize);
-
-      if( strlen(result) > 0 )
-        strlcat( result, " ", bufferSize);
-      strlcat( result, urn , bufferSize);
-    } else {
-      msDebug( "msOWSGetProjURN(): Failed to process SRS '%s', ignored.",
-               tokens[i] );
-    }
-  }
-
-  msFreeCharArray(tokens, numtokens);
-
-  if( strlen(result) == 0 ) {
-    msFree( result );
-    return NULL;
-  } else
-    return result;
-}
-
-/*
-** msOWSGetProjURI()
-**
-** Fetch an OGC URI for this layer or map.  Similar to msOWSGetEPSGProj()
-** but returns the result in the form "http://www.opengis.net/def/crs/EPSG/0/27700".
-** The returned buffer is dynamically allocated, and must be freed by the
-** caller.
-*/
-char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne)
-{
-  char *result;
-  char **tokens;
-  int numtokens, i;
-  char *oldStyle = NULL;
-  
-  msOWSGetEPSGProj( proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle);
-
-  if( oldStyle == NULL || !EQUALN(oldStyle,"EPSG:",5) ) {
-    msFree(oldStyle); // avoid leak
-    return NULL;
-  }
-
-  result = msStrdup("");
-
-  tokens = msStringSplit(oldStyle, ' ', &numtokens);
-  msFree(oldStyle);
-  for(i=0; tokens != NULL && i<numtokens; i++) {
-    char urn[100];
-
-    if( strncmp(tokens[i],"EPSG:",5) == 0 )
-      snprintf( urn, sizeof(urn), "http://www.opengis.net/def/crs/EPSG/0/%s", tokens[i]+5 );
-    else if( strcasecmp(tokens[i],"imageCRS") == 0 )
-      snprintf( urn, sizeof(urn), "http://www.opengis.net/def/crs/OGC/0/imageCRS" );
-    else if( strncmp(tokens[i],"http://www.opengis.net/def/crs/",16) == 0 )
-      snprintf( urn, sizeof(urn), "%s", tokens[i] );
-    else
-      strlcpy( urn, "", sizeof(urn) );
-
-    if( strlen(urn) > 0 ) {
-      result = (char *) msSmallRealloc(result,strlen(result)+strlen(urn)+2);
-
-      if( strlen(result) > 0 )
-        strcat( result, " " );
-      strcat( result, urn );
-    } else {
-      msDebug( "msOWSGetProjURI(): Failed to process SRS '%s', ignored.",
-               tokens[i] );
-    }
-  }
-
-  msFreeCharArray(tokens, numtokens);
-
-  if( strlen(result) == 0 ) {
-    msFree( result );
-    return NULL;
-  } else
-    return result;
-}
-
-
-/*
-** msOWSGetDimensionInfo()
-**
-** Extract dimension information from a layer's metadata
-**
-** Before 4.9, only the time dimension was support. With the addition of
-** Web Map Context 1.1.0, we need to support every dimension types.
-** This function get the dimension information from special metadata in
-** the layer, but can also return default values for the time dimension.
-**
-*/
-void msOWSGetDimensionInfo(layerObj *layer, const char *pszDimension,
-                           const char **papszDimUserValue,
-                           const char **papszDimUnits,
-                           const char **papszDimDefault,
-                           const char **papszDimNearValue,
-                           const char **papszDimUnitSymbol,
-                           const char **papszDimMultiValue)
-{
-  char *pszDimensionItem;
-  size_t bufferSize = 0;
-
-  if(pszDimension == NULL || layer == NULL)
-    return;
-
-  bufferSize = strlen(pszDimension)+50;
-  pszDimensionItem = (char*)malloc(bufferSize);
-
-  /* units (mandatory in map context) */
-  if(papszDimUnits != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_units",          pszDimension);
-    *papszDimUnits = msOWSLookupMetadata(&(layer->metadata), "MO",
-                                         pszDimensionItem);
-  }
-  /* unitSymbol (mandatory in map context) */
-  if(papszDimUnitSymbol != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_unitsymbol",     pszDimension);
-    *papszDimUnitSymbol = msOWSLookupMetadata(&(layer->metadata), "MO",
-                          pszDimensionItem);
-  }
-  /* userValue (mandatory in map context) */
-  if(papszDimUserValue != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_uservalue",      pszDimension);
-    *papszDimUserValue = msOWSLookupMetadata(&(layer->metadata), "MO",
-                         pszDimensionItem);
-  }
-  /* default */
-  if(papszDimDefault != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_default",        pszDimension);
-    *papszDimDefault = msOWSLookupMetadata(&(layer->metadata), "MO",
-                                           pszDimensionItem);
-  }
-  /* multipleValues */
-  if(papszDimMultiValue != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_multiplevalues", pszDimension);
-    *papszDimMultiValue = msOWSLookupMetadata(&(layer->metadata), "MO",
-                          pszDimensionItem);
-  }
-  /* nearestValue */
-  if(papszDimNearValue != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_nearestvalue",   pszDimension);
-    *papszDimNearValue = msOWSLookupMetadata(&(layer->metadata), "MO",
-                         pszDimensionItem);
-  }
-
-  /* Use default time value if necessary */
-  if(strcasecmp(pszDimension, "time") == 0) {
-    if(papszDimUserValue != NULL && *papszDimUserValue == NULL)
-      *papszDimUserValue = msOWSLookupMetadata(&(layer->metadata),
-                           "MO", "time");
-    if(papszDimDefault != NULL && *papszDimDefault == NULL)
-      *papszDimDefault = msOWSLookupMetadata(&(layer->metadata),
-                                             "MO", "timedefault");
-    if(papszDimUnits != NULL && *papszDimUnits == NULL)
-      *papszDimUnits = "ISO8601";
-    if(papszDimUnitSymbol != NULL && *papszDimUnitSymbol == NULL)
-      *papszDimUnitSymbol = "t";
-    if(papszDimNearValue != NULL && *papszDimNearValue == NULL)
-      *papszDimNearValue = "0";
-  }
-
-  free(pszDimensionItem);
-
-  return;
-}
-
-/**
- * msOWSNegotiateUpdateSequence()
- *
- * returns the updateSequence value for an OWS
- *
- * @param requested_updatesequence the updatesequence passed by the client
- * @param updatesequence the updatesequence set by the server
- *
- * @return result of comparison (-1, 0, 1)
- * -1: lower / higher OR values not set by client or server
- *  1: higher / lower
- *  0: equal
- */
-
-int msOWSNegotiateUpdateSequence(const char *requested_updatesequence, const char *updatesequence)
-{
-  int i;
-  int valtype1 = 1; /* default datatype for updatesequence passed by client */
-  int valtype2 = 1; /* default datatype for updatesequence set by server */
-  struct tm tm_requested_updatesequence, tm_updatesequence;
-
-  /* if not specified by client, or set by server,
-     server responds with latest Capabilities XML */
-  if (! requested_updatesequence || ! updatesequence)
-    return -1;
-
-  /* test to see if server value is an integer (1), string (2) or timestamp (3) */
-  if (msStringIsInteger(updatesequence) == MS_FAILURE)
-    valtype1 = 2;
-
-  if (valtype1 == 2) { /* test if timestamp */
-    msTimeInit(&tm_updatesequence);
-    if (msParseTime(updatesequence, &tm_updatesequence) == MS_TRUE)
-      valtype1 = 3;
-    msResetErrorList();
-  }
-
-  /* test to see if client value is an integer (1), string (2) or timestamp (3) */
-  if (msStringIsInteger(requested_updatesequence) == MS_FAILURE)
-    valtype2 = 2;
-
-  if (valtype2 == 2) { /* test if timestamp */
-    msTimeInit(&tm_requested_updatesequence);
-    if (msParseTime(requested_updatesequence, &tm_requested_updatesequence) == MS_TRUE)
-      valtype2 = 3;
-    msResetErrorList();
-  }
-
-  /* if the datatypes do not match, do not compare, */
-  if (valtype1 != valtype2)
-    return -1;
-
-  if (valtype1 == 1) { /* integer */
-    if (atoi(requested_updatesequence) < atoi(updatesequence))
-      return -1;
-
-    if (atoi(requested_updatesequence) > atoi(updatesequence))
-      return 1;
-
-    if (atoi(requested_updatesequence) == atoi(updatesequence))
-      return 0;
-  }
-
-  if (valtype1 == 2) /* string */
-    return strcasecmp(requested_updatesequence, updatesequence);
-
-  if (valtype1 == 3) { /* timestamp */
-    /* compare timestamps */
-    i = msDateCompare(&tm_requested_updatesequence, &tm_updatesequence) +
-        msTimeCompare(&tm_requested_updatesequence, &tm_updatesequence);
-    return i;
-  }
-
-  /* return default -1 */
-  return -1;
-}
-
-
-/************************************************************************/
-/*                         msOwsIsOutputFormatValid                     */
-/*                                                                      */
-/*      Utlity function to parse a comma separated list in a            */
-/*      metedata object and select and outputformat.                    */
-/************************************************************************/
-outputFormatObj* msOwsIsOutputFormatValid(mapObj *map, const char *format,
-    hashTableObj *metadata,
-    const char *namespaces, const char *name)
-{
-  char **tokens=NULL;
-  int i,n;
-  outputFormatObj *psFormat = NULL;
-  const char * format_list=NULL;
-
-  if (map && format && metadata && namespaces && name) {
-    msApplyDefaultOutputFormats(map);
-    format_list = msOWSLookupMetadata(metadata, namespaces, name);
-    n = 0;
-    if ( format_list)
-      tokens = msStringSplit(format_list,  ',', &n);
-
-    if (tokens && n > 0) {
-      for (i=0; i<n; i++) {
-        int iFormat = msGetOutputFormatIndex( map, tokens[i]);
-        const char *mimetype;
-        if( iFormat == -1 )
-          continue;
-
-        mimetype =  map->outputformatlist[iFormat]->mimetype;
-
-        msStringTrim(tokens[i]);
-        if (strcasecmp(tokens[i], format) == 0)
-          break;
-        if (mimetype && strcasecmp(mimetype, format) == 0)
-          break;
-      }
-      if (i < n)
-        psFormat = msSelectOutputFormat( map, format);
-    }
-    if(tokens)
-      msFreeCharArray(tokens, n);
-  }
-
-  return psFormat;
-}
-
-#endif /* defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR) */
diff -pruN 8.0.1-5/mapows.h 8.2.0~beta1-1~exp1/mapows.h
--- 8.0.1-5/mapows.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapows.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,579 +0,0 @@
-/*****************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC Web Services (WMS, WFS, WCS) support function definitions
- * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-#ifndef MAPOWS_H
-#define MAPOWS_H
-
-#include "maphttp.h"
-#include <time.h>
-
-/* This is the URL to the official OGC Schema Repository. We use it by
- * default for OGC services unless the ows_schemas_lcoation web metadata
- * is set in the mapfile.
- */
-#define OWS_DEFAULT_SCHEMAS_LOCATION   "http://schemas.opengis.net"
-
-#if defined USE_LIBXML2 && defined USE_WFS_SVR
-#include<libxml/tree.h>
-#endif
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-
-/*====================================================================
- *   mapows.c
- *====================================================================*/
-
-typedef struct {
-  char *pszVersion;
-  char *pszUpdateSequence;
-  char *pszRequest;
-  char *pszService;
-  char *pszTypeName;
-  char *pszFilter;
-  char *pszFilterLanguage;
-  char *pszGeometryName;
-  int nMaxFeatures;
-  char *pszBbox; /* only used with a Get Request */
-  char *pszOutputFormat;
-  char *pszFeatureId;
-  char *pszSrs;
-  char *pszResultType;
-  char *pszPropertyName;
-  int nStartIndex;
-  char *pszAcceptVersions;
-  char *pszSections;
-  char *pszSortBy; /* Not implemented yet */
-  char *pszLanguage; /* Inspire extension */
-  char *pszValueReference; /* For GetValueReference */
-  char *pszStoredQueryId; /* For DescribeStoredQueries */
-  int   countGetFeatureById; /* Number of urn:ogc:def:query:OGC-WFS::GetFeatureById GetFeature requests */
-  int   bHasPostStoredQuery; /* TRUE if a XML GetFeature StoredQuery is present */
-} wfsParamsObj;
-
-/*
- * sosParamsObj
- * Used to preprocess SOS request parameters
- *
- */
-
-typedef struct {
-  char *pszVersion;
-  char *pszAcceptVersions;
-  char *pszUpdateSequence;
-  char *pszRequest;
-  char *pszService;
-  char *pszOutputFormat;
-  char *pszSensorId;
-  char *pszProcedure;
-  char *pszOffering;
-  char *pszObservedProperty;
-  char *pszEventTime;
-  char *pszResult;
-  char *pszResponseFormat;
-  char *pszResultModel;
-  char *pszResponseMode;
-  char *pszBBox;
-  char *pszFeatureOfInterest;
-  char *pszSrsName;
-} sosParamsObj;
-
-/* wmsParamsObj
- *
- * Used to preprocess WMS request parameters and combine layers that can
- * be comined in a GetMap request.
- */
-typedef  struct {
-  char        *onlineresource;
-  hashTableObj *params;
-  int          numparams;
-  char         *httpcookiedata;
-} wmsParamsObj;
-
-/* metadataParamsObj: Represent a metadata specific request with its enabled layers */
-typedef struct {
-  char *pszRequest;
-  char *pszLayer;
-  char *pszOutputSchema;
-} metadataParamsObj;
-
-/* owsRequestObj: Represent a OWS specific request with its enabled layers */
-typedef struct {
-  int numlayers;
-  int numwmslayerargs;
-  int *enabled_layers;
-  int *layerwmsfilterindex;
-
-  char *service;
-  char *version;
-  char *request;
-  void *document; /* xmlDocPtr or CPLXMLNode* */
-} owsRequestObj;
-
-MS_DLL_EXPORT int msOWSDispatch(mapObj *map, cgiRequestObj *request, int ows_mode);
-
-MS_DLL_EXPORT const char * msOWSLookupMetadata(hashTableObj *metadata,
-    const char *namespaces, const char *name);
-MS_DLL_EXPORT const char * msOWSLookupMetadataWithLanguage(hashTableObj *metadata,
-    const char *namespaces, const char *name, const char *validated_language);
-MS_DLL_EXPORT const char * msOWSLookupMetadata2(hashTableObj *pri,
-    hashTableObj *sec,
-    const char *namespaces,
-    const char *name);
-
-MS_DLL_EXPORT int msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name,
-    const char *gml_type, const char *gml_width, const char *gml_precision, const short nullable);
-
-void msOWSInitRequestObj(owsRequestObj *ows_request);
-void msOWSClearRequestObj(owsRequestObj *ows_request);
-
-MS_DLL_EXPORT int msOWSRequestIsEnabled(mapObj *map, layerObj *layer,
-                                        const char *namespaces, const char *name, int check_all_layers);
-MS_DLL_EXPORT void msOWSRequestLayersEnabled(mapObj *map, const char *namespaces,
-    const char *request, owsRequestObj *request_layers);
-MS_DLL_EXPORT int msOWSParseRequestMetadata(const char *metadata, const char *request,
-    int *disabled);
-
-/* Constants for OWS Service version numbers */
-#define OWS_0_1_2   0x000102
-#define OWS_0_1_4   0x000104
-#define OWS_0_1_6   0x000106
-#define OWS_0_1_7   0x000107
-#define OWS_1_0_0   0x010000
-#define OWS_1_0_1   0x010001
-#define OWS_1_0_6   0x010006
-#define OWS_1_0_7   0x010007
-#define OWS_1_0_8   0x010008
-#define OWS_1_1_0   0x010100
-#define OWS_1_1_1   0x010101
-#define OWS_1_1_2   0x010102
-#define OWS_1_3_0   0x010300
-#define OWS_2_0_0   0x020000
-#define OWS_2_0_1   0x020001
-#define OWS_VERSION_MAXLEN   20  /* Buffer size for msOWSGetVersionString() */
-#define OWS_VERSION_NOTSET    -1
-#define OWS_VERSION_BADFORMAT -2
-
-MS_DLL_EXPORT int msOWSParseVersionString(const char *pszVersion);
-MS_DLL_EXPORT const char *msOWSGetVersionString(int nVersion, char *pszBuffer);
-
-MS_DLL_EXPORT const char *msOWSGetLanguage(mapObj *map, const char *context);
-MS_DLL_EXPORT char *msOWSGetOnlineResource(mapObj *map, const char *namespaces, const char *metadata_name, cgiRequestObj *req);
-MS_DLL_EXPORT const char *msOWSGetSchemasLocation(mapObj *map);
-MS_DLL_EXPORT char *msOWSTerminateOnlineResource(const char *src_url);
-
-void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne, char **epsgProj);
-void msOWSProjectToWGS84(projectionObj *srcproj, rectObj *ext);
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-
-MS_DLL_EXPORT int msOWSMakeAllLayersUnique(mapObj *map);
-MS_DLL_EXPORT int msOWSNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions);
-MS_DLL_EXPORT char *msOWSGetOnlineResource2(mapObj *map, const char *namespaces, const char *metadata_name, cgiRequestObj *req, const char *validated_language);
-MS_DLL_EXPORT const char *msOWSGetInspireSchemasLocation(mapObj *map);
-MS_DLL_EXPORT char **msOWSGetLanguageList(mapObj *map, const char *namespaces, int *numitems);
-MS_DLL_EXPORT char *msOWSGetLanguageFromList(mapObj *map, const char *namespaces, const char *requested_language);
-MS_DLL_EXPORT char *msOWSLanguageNegotiation(mapObj *map, const char *namespaces, char **accept_languages, int num_accept_languages);
-
-
-/* OWS_NOERR and OWS_WARN passed as action_if_not_found to printMetadata() */
-#define OWS_NOERR   0
-#define OWS_WARN    1
-
-/* OWS_WMS and OWS_WFS used for functions that differ in behavior between */
-/* WMS and WFS services (e.g. msOWSPrintLatLonBoundingBox()) */
-typedef enum
-{
-    OWS_WMS = 1,
-    OWS_WFS = 2,
-    OWS_WCS = 3
-} OWSServiceType;
-
-MS_DLL_EXPORT int msOWSPrintInspireCommonExtendedCapabilities(FILE *stream, mapObj *map, const char *namespaces,
-    int action_if_not_found, const char *tag_name, const char* tag_ns,
-    const char *validated_language, const OWSServiceType service);
-int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map, const char *namespaces,
-                                    int action_if_not_found, const OWSServiceType service);
-int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map, const char *namespaces,
-                                     int action_if_not_found, const char *validated_language);
-
-MS_DLL_EXPORT int msOWSPrintMetadata(FILE *stream, hashTableObj *metadata,
-                                     const char *namespaces, const char *name,
-                                     int action_if_not_found, const char *format,
-                                     const char *default_value);
-int msOWSPrintEncodeMetadata(FILE *stream, hashTableObj *metadata,
-                             const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value) ;
-int msOWSPrintEncodeMetadata2(FILE *stream, hashTableObj *metadata,
-                              const char *namespaces, const char *name,
-                              int action_if_not_found,
-                              const char *format, const char *default_value,
-                              const char *validated_language);
-char *msOWSGetEncodeMetadata(hashTableObj *metadata,
-                             const char *namespaces, const char *name,
-                             const char *default_value);
-
-int msOWSPrintValidateMetadata(FILE *stream, hashTableObj *metadata,
-                               const char *namespaces, const char *name,
-                               int action_if_not_found,
-                               const char *format, const char *default_value);
-int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char* pszGroupName,
-                            const char *namespaces, const char *name,
-                            int action_if_not_found,
-                            const char *format, const char *default_value);
-int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char* pszGroupName,
-                             const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value,
-                             const char *validated_language);
-int msOWSPrintURLType(FILE *stream, hashTableObj *metadata,
-                      const char *namespaces, const char *name,
-                      int action_if_not_found, const char *tag_format,
-                      const char *tag_name, const char *type_format,
-                      const char *width_format, const char *height_format,
-                      const char *urlfrmt_format, const char *href_format,
-                      int type_is_mandatory, int width_is_mandatory,
-                      int height_is_mandatory, int format_is_mandatory,
-                      int href_is_mandatory, const char *default_type,
-                      const char *default_width, const char *default_height,
-                      const char *default_urlfrmt, const char *default_href,
-                      const char *tabspace);
-int msOWSPrintParam(FILE *stream, const char *name, const char *value,
-                    int action_if_not_found, const char *format,
-                    const char *default_value);
-int msOWSPrintEncodeParam(FILE *stream, const char *name, const char *value,
-                          int action_if_not_found, const char *format,
-                          const char *default_value);
-int msOWSPrintMetadataList(FILE *stream, hashTableObj *metadata,
-                           const char *namespaces, const char *name,
-                           const char *startTag,
-                           const char *endTag, const char *itemFormat,
-                           const char *default_value);
-int msOWSPrintEncodeMetadataList(FILE *stream, hashTableObj *metadata,
-                                 const char *namespaces, const char *name,
-                                 const char *startTag,
-                                 const char *endTag, const char *itemFormat,
-                                 const char *default_value);
-int msOWSPrintEncodeParamList(FILE *stream, const char *name,
-                              const char *value, int action_if_not_found,
-                              char delimiter, const char *startTag,
-                              const char *endTag, const char *format,
-                              const char *default_value);
-void msOWSPrintLatLonBoundingBox(FILE *stream, const char *tabspace,
-                                 rectObj *extent, projectionObj *srcproj,
-                                 projectionObj *wfsproj, OWSServiceType nService);
-void msOWSPrintEX_GeographicBoundingBox(FILE *stream, const char *tabspace,
-                                        rectObj *extent, projectionObj *srcproj);
-
-void msOWSPrintBoundingBox(FILE *stream, const char *tabspace,
-                           rectObj *extent,
-                           projectionObj *srcproj,
-                           hashTableObj *layer_meta,
-                           hashTableObj *map_meta,
-                           const char *namespaces,
-                           int wms_version);
-void msOWSPrintContactInfo( FILE *stream, const char *tabspace,
-                            int nVersion, hashTableObj *metadata,
-                            const char *namespaces  );
-int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces, rectObj *ext);
-
-int msOWSExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
-                         mapObj *map, int bCheckLocalCache);
-
-void msOWSProcessException(layerObj *lp, const char *pszFname,
-                           int nErrorCode, const char *pszFuncName);
-char *msOWSBuildURLFilename(const char *pszPath, const char *pszURL,
-                            const char *pszExt);
-char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne);
-char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne);
-
-void msOWSGetDimensionInfo(layerObj *layer, const char *pszDimension,
-                           const char **pszDimUserValue,
-                           const char **pszDimUnits,
-                           const char **pszDimDefault,
-                           const char **pszDimNearValue,
-                           const char **pszDimUnitSymbol,
-                           const char **pszDimMultiValue);
-
-int msOWSNegotiateUpdateSequence(const char *requested_updateSequence, const char *updatesequence);
-
-outputFormatObj *msOwsIsOutputFormatValid(mapObj *map, const char *format, hashTableObj *metadata,
-    const char *namespaces, const char *name);
-#endif /* #if any wxs service enabled */
-
-/*====================================================================
- *   mapgml.c
- *====================================================================*/
-
-typedef enum
-{
-    OWS_GML2, /* 2.1.2 */
-    OWS_GML3, /* 3.1.1 */
-    OWS_GML32 /* 3.2.1 */
-} OWSGMLVersion;
-
-#define OWS_WFS_FEATURE_COLLECTION_NAME "msFeatureCollection"
-#define OWS_GML_DEFAULT_GEOMETRY_NAME "msGeometry"
-#define OWS_GML_OCCUR_UNBOUNDED -1
-
-/* TODO, there must be a better way to generalize these lists of objects... */
-
-typedef struct {
-  char *name;     /* name of the item */
-  char *alias;    /* is the item aliased for presentation? (NULL if not) */
-  char *type;     /* raw type for this item (NULL for a "string") (TODO: should this be a lookup table instead?) */
-#ifndef __cplusplus
-  char *template;  /* presentation string for this item, needs to be a complete XML tag */
-#else
-  char *_template;  /* presentation string for this item, needs to be a complete XML tag */
-#endif
-  int encode;     /* should the value be HTML encoded? Default is MS_TRUE */
-  int visible;    /* should this item be output, default is MS_FALSE */
-  int width;      /* field width, zero if unknown */
-  int precision;  /* field precision (decimal places), zero if unknown or N/A */
-  int outputByDefault; /* whether this should be output in a GetFeature without PropertyName. MS_TRUE by default, unless gml_default_items is specified and the item name is not in it */
-  int minOccurs;  /* 0 by default. Can be set to 1 by specifying item name in gml_mandatory_items */
-} gmlItemObj;
-
-typedef struct {
-  gmlItemObj *items;
-  int numitems;
-} gmlItemListObj;
-
-typedef struct {
-  char *name;     /* name of the constant */
-  char *type;     /* raw type for this item (NULL for a "string") */
-  char *value;    /* output value for this constant (output will look like: <name>value</name>) */
-} gmlConstantObj;
-
-typedef struct {
-  gmlConstantObj *constants;
-  int numconstants;
-} gmlConstantListObj;
-
-typedef struct {
-  char *name;     /* name of the geometry (type of GML property) */
-  char *type;     /* raw type for these geometries (point|multipoint|line|multiline|polygon|multipolygon */
-  int occurmin, occurmax;   /* number of occurances (default 0,1) */
-} gmlGeometryObj;
-
-typedef struct {
-  gmlGeometryObj *geometries;
-  int numgeometries;
-} gmlGeometryListObj;
-
-typedef struct {
-  char *name;     /* name of the group */
-  char **items;   /* list of items in the group */
-  int numitems;   /* number of items */
-  char *type;     /* name of the complex type */
-} gmlGroupObj;
-
-typedef struct {
-  gmlGroupObj *groups;
-  int numgroups;
-} gmlGroupListObj;
-
-typedef struct {
-  char *prefix;
-  char *uri;
-  char *schemalocation;
-} gmlNamespaceObj;
-
-typedef struct {
-  gmlNamespaceObj *namespaces;
-  int numnamespaces;
-} gmlNamespaceListObj;
-
-MS_DLL_EXPORT gmlItemListObj *msGMLGetItems(layerObj *layer, const char *metadata_namespaces);
-MS_DLL_EXPORT void msGMLFreeItems(gmlItemListObj *itemList);
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR)
-
-MS_DLL_EXPORT int msItemInGroups(const char *name, gmlGroupListObj *groupList);
-MS_DLL_EXPORT gmlConstantListObj *msGMLGetConstants(layerObj *layer, const char *metadata_namespaces);
-MS_DLL_EXPORT void msGMLFreeConstants(gmlConstantListObj *constantList);
-MS_DLL_EXPORT gmlGeometryListObj *msGMLGetGeometries(layerObj *layer, const char *metadata_namespaces, int bWithDefaultGeom);
-MS_DLL_EXPORT void msGMLFreeGeometries(gmlGeometryListObj *geometryList);
-MS_DLL_EXPORT gmlNamespaceListObj *msGMLGetNamespaces(webObj *web, const char *metadata_namespaces);
-MS_DLL_EXPORT void msGMLFreeNamespaces(gmlNamespaceListObj *namespaceList);
-#endif
-
-MS_DLL_EXPORT gmlGroupListObj *msGMLGetGroups(layerObj *layer, const char *metadata_namespaces);
-MS_DLL_EXPORT void msGMLFreeGroups(gmlGroupListObj *groupList);
-
-/* export to fix bug 851 */
-MS_DLL_EXPORT int msGMLWriteQuery(mapObj *map, char *filename, const char *namespaces);
-
-
-#ifdef USE_WFS_SVR
-
-void msGMLWriteWFSBounds(mapObj *map, FILE *stream, const char *tab,
-                         OWSGMLVersion outputformat, int nWFSVersion, int bUseURN);
-
-MS_DLL_EXPORT int msGMLWriteWFSQuery(mapObj *map, FILE *stream, const char *wfs_namespace,
-                                     OWSGMLVersion outputformat, int nWFSVersion, int bUseURN,
-                                     int bGetPropertyValueRequest);
-#endif
-
-
-/*====================================================================
- *   mapwms.c
- *====================================================================*/
-int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request, int force_wms_mode);
-MS_DLL_EXPORT int msWMSLoadGetMapParams(mapObj *map, int nVersion,
-                                        char **names, char **values, int numentries,
-                                        const char *wms_exception_format, const char *wms_request, owsRequestObj *ows_request);
-
-
-/*====================================================================
- *   mapwmslayer.c
- *====================================================================*/
-
-#define WMS_GETMAP         1
-#define WMS_GETFEATUREINFO 2
-#define WMS_GETLEGENDGRAPHIC 3
-
-int msInitWmsParamsObj(wmsParamsObj *wmsparams);
-void msFreeWmsParamsObj(wmsParamsObj *wmsparams);
-
-int msPrepareWMSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
-                             int nRequestType, enum MS_CONNECTION_TYPE lastconnectiontype,
-                             wmsParamsObj *psLastWMSParams,
-                             int nClickX, int nClickY, int nFeatureCount, const char *pszInfoFormat,
-                             httpRequestObj *pasReqInfo, int *numRequests);
-int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo,
-                      int numRequests, mapObj *map, layerObj *lp,
-                      imageObj *img);
-MS_DLL_EXPORT char *msWMSGetFeatureInfoURL(mapObj *map, layerObj *lp,
-    int nClickX, int nClickY, int nFeatureCount,
-    const char *pszInfoFormat);
-int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX, int nClickY,
-                             int nFeatureCount, const char *pszInfoFormat, int type);
-
-/*====================================================================
- *   mapmetadata.c
- *====================================================================*/
-
-metadataParamsObj *msMetadataCreateParamsObj(void);
-void msMetadataFreeParamsObj(metadataParamsObj *metadataparams);
-int msMetadataDispatch(mapObj *map, cgiRequestObj *requestobj);
-void msMetadataSetGetMetadataURL(layerObj *lp, const char *url);
-
-/*====================================================================
- *   mapwfs.c
- *====================================================================*/
-
-MS_DLL_EXPORT int msWFSDispatch(mapObj *map, cgiRequestObj *requestobj,
-                                owsRequestObj *ows_request, int force_wfs_mode);
-wfsParamsObj *msWFSCreateParamsObj(void);
-int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *wfsparams, const char* pszFunction);
-void msWFSFreeParamsObj(wfsParamsObj *wfsparams);
-int msWFSIsLayerSupported(layerObj *lp);
-int msWFSException(mapObj *map, const char *locator, const char *code,
-                   const char *version);
-
-#ifdef USE_WFS_SVR
-const char *msWFSGetGeomElementName(mapObj *map, layerObj *lp);
-
-int msWFSException11(mapObj *map, const char *locator,
-                     const char *exceptionCode, const char *version);
-int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *wfsparams,
-                           cgiRequestObj *req, owsRequestObj *ows_request);
-#ifdef USE_LIBXML2
-xmlNodePtr msWFSDumpLayer11(mapObj *map, layerObj *lp, xmlNsPtr psNsOws,
-                            int nWFSVersion, const char* validate_language,
-                            char *script_url);
-#endif
-char *msWFSGetOutputFormatList(mapObj *map, layerObj *layer, int nWFSVersion);
-
-int msWFSException20(mapObj *map, const char *locator,
-                     const char *exceptionCode);
-int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request);
-int msWFSListStoredQueries20(mapObj *map, owsRequestObj *ows_request);
-int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
-                                 owsRequestObj *ows_request);
-char* msWFSGetResolvedStoredQuery20(mapObj *map,
-                                    wfsParamsObj *wfsparams,
-                                    const char* id,
-                                    hashTableObj* hashTable);
-
-#endif
-
-/*====================================================================
- *   mapwfslayer.c
- *====================================================================*/
-
-int msPrepareWFSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
-                             httpRequestObj *pasReqInfo, int *numRequests);
-void msWFSUpdateRequestInfo(layerObj *lp, httpRequestObj *pasReqInfo);
-int msWFSLayerOpen(layerObj *lp,
-                   const char *pszGMLFilename, rectObj *defaultBBOX);
-int msWFSLayerIsOpen(layerObj *lp);
-int msWFSLayerInitItemInfo(layerObj *layer);
-int msWFSLayerGetItems(layerObj *layer);
-int msWFSLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery);
-int msWFSLayerClose(layerObj *lp);
-MS_DLL_EXPORT char *msWFSExecuteGetFeature(layerObj *lp);
-
-/*====================================================================
- *   mapcontext.c
- *====================================================================*/
-
-MS_DLL_EXPORT int msWriteMapContext(mapObj *map, FILE *stream);
-MS_DLL_EXPORT int msSaveMapContext(mapObj *map, char *filename);
-MS_DLL_EXPORT int msLoadMapContext(mapObj *map, const char *filename, int unique_layer_names);
-MS_DLL_EXPORT int msLoadMapContextURL(mapObj *map, char *urlfilename, int unique_layer_names);
-
-
-/*====================================================================
- *   mapwcs.c
- *====================================================================*/
-
-int msWCSDispatch(mapObj *map, cgiRequestObj *requestobj, owsRequestObj *ows_request); /* only 1 public function */
-
-
-
-/*====================================================================
- *   mapogsos.c
- *====================================================================*/
-
-int msSOSDispatch(mapObj *map, cgiRequestObj *requestobj, owsRequestObj *ows_request); /* only 1 public function */
-
-#ifdef __cplusplus
-} /* extern "C" */
-#endif
-
-#endif /* MAPOWS_H */
-
diff -pruN 8.0.1-5/mapowscommon.c 8.2.0~beta1-1~exp1/mapowscommon.c
--- 8.0.1-5/mapowscommon.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapowscommon.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,780 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC OWS Common Implementation for use by MapServer OGC code
- *           versions:
- *           1.0.0 (OGC Document 05-008c1)
- *           1.1.0 (OGC document 06-121r3)
- *
- * Author:   Tom Kralidis (tomkralidis@gmail.com)
- *
- ******************************************************************************
- * Copyright (c) 2006, Tom Kralidis
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#ifdef USE_LIBXML2
-
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-
-#include "mapowscommon.h"
-#include "maplibxml2.h"
-
-
-
-
-
-/**
- * msOWSCommonServiceIdentification()
- *
- * returns an object of ServiceIdentification as per:
- *
- * 1.0.0 subclause 7.4.3
- * 1.1.1 subclause 7.4.4
- *
- * @param map mapObj used to fetch WEB/METADATA
- * @param servicetype the OWS type
- * @param supported_versions the supported version(s) of the OWS
- *
- * @return psRootNode xmlNodePtr of XML construct
- *
- */
-
-xmlNodePtr msOWSCommonServiceIdentification(xmlNsPtr psNsOws, mapObj *map,
-                                            const char *servicetype,
-                                            const char *supported_versions,
-                                            const char *namespaces,
-                                            const char *validated_language)
-{
-  const char *value    = NULL;
-
-  xmlNodePtr   psRootNode = NULL;
-  xmlNodePtr   psNode     = NULL;
-
-  if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
-  /* create element name */
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST "ServiceIdentification");
-
-  /* add child elements */
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "title", validated_language);
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Title", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_title\" missing for ows:Title"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "abstract", validated_language);
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Abstract", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_abstract\" was missing for ows:Abstract"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "keywordlist", validated_language);
-
-  if (value) {
-    psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Keywords", NULL);
-    msLibXml2GenerateList(psNode, psNsOws, "Keyword", value, ',');
-  }
-
-  else {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_keywordlist\" was missing for ows:KeywordList"));
-  }
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceType", BAD_CAST servicetype);
-
-  xmlNewProp(psNode, BAD_CAST "codeSpace", BAD_CAST MS_OWSCOMMON_OGC_CODESPACE);
-
-  msLibXml2GenerateList(psRootNode, psNsOws, "ServiceTypeVersion", supported_versions, ',');
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "fees", validated_language);
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Fees", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_fees\" was missing for ows:Fees"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "accessconstraints", validated_language);
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "AccessConstraints", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_accessconstraints\" was missing for ows:AccessConstraints"));
-  }
-
-  return psRootNode;
-}
-
-/**
- * msOWSCommonServiceProvider()
- *
- * returns an object of ServiceProvider as per:
- *
- *
- * 1.0.0 subclause 7.4.4
- * 1.1.0 subclause 7.4.5
- *
- * @param map mapObj to fetch MAP/WEB/METADATA
- *
- * @return psRootNode xmlNodePtr pointer of XML construct
- *
- */
-
-xmlNodePtr msOWSCommonServiceProvider(xmlNsPtr psNsOws, xmlNsPtr psNsXLink,
-                                      mapObj *map, const char *namespaces,
-                                      const char *validated_language)
-{
-  const char *value = NULL;
-
-  xmlNodePtr   psNode          = NULL;
-  xmlNodePtr   psRootNode      = NULL;
-  xmlNodePtr   psSubNode       = NULL;
-  xmlNodePtr   psSubSubNode    = NULL;
-  xmlNodePtr   psSubSubSubNode = NULL;
-
-  if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST "ServiceProvider");
-
-  /* add child elements */
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactorganization", validated_language);
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ProviderName", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Mandatory metadata \"ows_contactorganization\" was missing for ows:ProviderName"));
-  }
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ProviderSite", NULL);
-
-  xmlNewNsProp(psNode, psNsXLink, BAD_CAST "type", BAD_CAST "simple");
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "service_onlineresource", validated_language);
-
-  xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_service_onlineresource\" was missing for ows:ProviderSite/@xlink:href"));
-  }
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceContact", NULL);
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactperson", validated_language);
-
-  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "IndividualName", BAD_CAST  value);
-
-  if (!value) {
-    xmlAddSibling(psSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactperson\" was missing for ows:IndividualName"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactposition", validated_language);
-
-  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "PositionName", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactposition\" was missing for ows:PositionName"));
-  }
-
-  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "ContactInfo", NULL);
-
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "Phone", NULL);
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactvoicetelephone", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Voice", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactvoicetelephone\" was missing for ows:Voice"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactfacsimiletelephone", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Facsimile", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactfacsimiletelephone\" was missing for ows:Facsimile"));
-  }
-
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "Address", NULL);
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "address", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "DeliveryPoint", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_address\" was missing for ows:DeliveryPoint"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "city", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "City", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_city\" was missing for ows:City"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "stateorprovince", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "AdministrativeArea", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_stateorprovince\" was missing for ows:AdministrativeArea"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "postcode", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "PostalCode", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_postcode\" was missing for ows:PostalCode"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "country", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Country", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_country\" was missing for ows:Country"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactelectronicmailaddress", validated_language);
-
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "ElectronicMailAddress", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactelectronicmailaddress\" was missing for ows:ElectronicMailAddress"));
-  }
-
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "OnlineResource", NULL);
-
-  xmlNewNsProp(psSubSubNode, psNsXLink, BAD_CAST "type", BAD_CAST "simple");
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "service_onlineresource", validated_language);
-
-  xmlNewNsProp(psSubSubNode, psNsXLink, BAD_CAST "href", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_service_onlineresource\" was missing for ows:OnlineResource/@xlink:href"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "hoursofservice", validated_language);
-
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "HoursOfService", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_hoursofservice\" was missing for ows:HoursOfService"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactinstructions", validated_language);
-
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "ContactInstructions", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactinstructions\" was missing for ows:ContactInstructions"));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "role", validated_language);
-
-  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "Role", BAD_CAST value);
-
-  if (!value) {
-    xmlAddSibling(psSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_role\" was missing for ows:Role"));
-  }
-
-  return psRootNode;
-
-}
-
-/**
- * msOWSCommonOperationsMetadata()
- *
- * returns the root element of OperationsMetadata as per:
- *
- * 1.0.0 subclause 7.4.5
- * 1.1.0 subclause 7.4.6
- *
- * @return psRootNode xmlNodePtr pointer of XML construct
- *
- */
-
-xmlNodePtr msOWSCommonOperationsMetadata(xmlNsPtr psNsOws)
-{
-  xmlNodePtr psRootNode = NULL;
-
-  if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST "OperationsMetadata");
-  return psRootNode;
-}
-
-/**
- * msOWSCommonOperationsMetadataOperation()
- *
- * returns an Operation element of OperationsMetadata as per:
- *
- * 1.0.0 subclause 7.4.5
- * 1.1.0 subclause 7.4.6
- *
- * @param name name of the Operation
- * @param method HTTP method: OWS_METHOD_GET, OWS_METHOD_POST or OWS_METHOD_GETPOST)
- * @param url online resource URL
- *
- * @return psRootNode xmlNodePtr pointer of XML construct
- */
-
-xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws, xmlNsPtr psXLinkNs, const char *name, int method, const char *url)
-{
-  xmlNodePtr psRootNode      = NULL;
-  xmlNodePtr psNode          = NULL;
-  xmlNodePtr psSubNode       = NULL;
-  xmlNodePtr psSubSubNode    = NULL;
-
-  if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
-
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST "Operation");
-
-  xmlNewProp(psRootNode, BAD_CAST "name", BAD_CAST name);
-
-  psNode = xmlNewChild(psRootNode, psNsOws, BAD_CAST "DCP", NULL);
-
-  psSubNode = xmlNewChild(psNode, psNsOws, BAD_CAST "HTTP", NULL);
-
-  if (method  == OWS_METHOD_GET || method == OWS_METHOD_GETPOST ) {
-    psSubSubNode = xmlNewChild(psSubNode, psNsOws, BAD_CAST "Get", NULL);
-    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "type", BAD_CAST "simple");
-    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "href", BAD_CAST url);
-  }
-
-  if (method == OWS_METHOD_POST || method == OWS_METHOD_GETPOST ) {
-    psSubSubNode = xmlNewChild(psSubNode, psNsOws, BAD_CAST "Post", NULL);
-    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "type", BAD_CAST "simple");
-    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "href", BAD_CAST url);
-  }
-
-  return psRootNode;
-}
-
-/**
- * msOWSCommonOperationsMetadataDomainType()
- *
- * returns a Parameter or Constraint element (which are of type ows:DomainType)
- * of OperationsMetadata as per:
- *
- * 1.0.0 subclause 7.4.5
- * 1.1.0 subclause 7.4.6
- *
- * @param version the integerized x.y.z version of OWS Common to use
- * @param elname name of the element (Parameter | Constraint)
- * @param name name of the Parameter
- * @param values list of values (comma separated list) or NULL if none
- *
- * @return psRootNode xmlNodePtr pointer of XML construct
- *
- */
-
-xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version, xmlNsPtr psNsOws, const char *elname, const char *name, const char *values)
-{
-  xmlNodePtr psRootNode = NULL;
-  xmlNodePtr psNode = NULL;
-
-  if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST elname);
-
-  xmlNewProp(psRootNode, BAD_CAST "name", BAD_CAST name);
-
-  if (version == OWS_1_0_0) {
-    msLibXml2GenerateList(psRootNode, psNsOws, "Value", values, ',');
-  }
-  if (version == OWS_1_1_0 || version == OWS_2_0_0) {
-    psNode = xmlNewChild(psRootNode, psNsOws, BAD_CAST "AllowedValues", NULL);
-    msLibXml2GenerateList(psNode, psNsOws, "Value", values, ',');
-  }
-
-  return psRootNode;
-}
-
-/**
- * msOWSCommonExceptionReport()
- *
- * returns an object of ExceptionReport as per clause 8
- *
- * @param ows_version the version of OWS Common to use
- * @param schemas_location URL to OGC Schemas Location base
- * @param version the version of the calling specification
- * @param language ISO3166 code of language
- * @param exceptionCode a code from the calling specification's list of exceptions, or from OWS Common
- * @param locator where the exception was encountered (i.e. "layers" keyword)
- * @param ExceptionText the actual error message
- *
- * @return psRootNode xmlNodePtr pointer of XML construct
- *
- */
-
-xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version, const char *schemas_location, const char *version, const char *language, const char *exceptionCode, const char *locator, const char *ExceptionText)
-{
-  char *xsi_schemaLocation = NULL;
-  char szVersionBuf[OWS_VERSION_MAXLEN];
-
-  xmlNsPtr     psNsXsi     = NULL;
-  xmlNodePtr   psRootNode  = NULL;
-  xmlNodePtr   psMainNode  = NULL;
-
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST "ExceptionReport");
-
-  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-
-  /* add attributes to root element */
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST version);
-
-  if (ows_version == OWS_1_0_0) {
-    xmlNewProp(psRootNode, BAD_CAST "language", BAD_CAST language);
-  }
-  if (ows_version == OWS_1_1_0) {
-    xmlNewProp(psRootNode, BAD_CAST "xml:lang", BAD_CAST language);
-  }
-
-  xsi_schemaLocation = msStrdup((char *)psNsOws->href);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)schemas_location);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)msOWSGetVersionString(ows_version, szVersionBuf));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
-
-  /* add namespace'd attributes to root element */
-  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation", BAD_CAST xsi_schemaLocation);
-
-  /* add child element */
-  psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Exception", NULL);
-
-  /* add attributes to child */
-  xmlNewProp(psMainNode, BAD_CAST "exceptionCode", BAD_CAST exceptionCode);
-
-  if (locator != NULL) {
-    xmlNewProp(psMainNode, BAD_CAST "locator", BAD_CAST locator);
-  }
-
-  if (ExceptionText != NULL) {
-    xmlNewTextChild(psMainNode, NULL, BAD_CAST "ExceptionText", BAD_CAST ExceptionText);
-  }
-
-  free(xsi_schemaLocation);
-  return psRootNode;
-}
-
-/**
- * msOWSCommonBoundingBox()
- *
- * returns an object of BoundingBox as per subclause 10.2.1
- *
- * If necessary (ie. an EPSG URN GCS such as 4326) the tuple axes will be
- * reoriented to match the EPSG coordinate system expectations.
- *
- * @param psNsOws OWS namespace object
- * @param crs the CRS / EPSG code
- * @param dimensions number of dimensions of the coordinates
- * @param minx minx
- * @param miny miny
- * @param maxx maxx
- * @param maxy maxy
- *
- * @return psRootNode xmlNodePtr pointer of XML construct
- */
-
-xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs, int dimensions, double minx, double miny, double maxx, double maxy)
-{
-  char LowerCorner[100];
-  char UpperCorner[100];
-  char dim_string[100];
-  xmlNodePtr psRootNode = NULL;
-
-  /* Do we need to reorient tuple axes? */
-  if(crs && strstr(crs, "imageCRS") == NULL) {
-    projectionObj proj;
-
-    msInitProjection( &proj );
-    if( msLoadProjectionString( &proj, (char *) crs ) == 0 ) {
-      msAxisNormalizePoints( &proj, 1, &minx, &miny );
-      msAxisNormalizePoints( &proj, 1, &maxx, &maxy );
-    }
-    msFreeProjection( &proj );
-  }
-
-
-  if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
-  /* create element name */
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST "BoundingBox");
-
-  /* add attributes to the root element */
-  xmlNewProp(psRootNode, BAD_CAST "crs", BAD_CAST crs);
-
-  snprintf( dim_string, sizeof(dim_string), "%d", dimensions );
-  xmlNewProp(psRootNode, BAD_CAST "dimensions", BAD_CAST dim_string);
-
-  snprintf(LowerCorner, sizeof(LowerCorner), "%.15g %.15g", minx, miny);
-  snprintf(UpperCorner, sizeof(UpperCorner), "%.15g %.15g", maxx, maxy);
-
-  /* add child elements */
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "LowerCorner",BAD_CAST LowerCorner);
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "UpperCorner",BAD_CAST UpperCorner);
-
-  return psRootNode;
-}
-
-/**
- * msOWSCommonWGS84BoundingBox()
- *
- * returns an object of WGS84BoundingBox as per subclause 10.2.2
- *
- * @param psNsOws OWS namespace object
- * @param dimensions number of dimensions of the coordinates
- * @param minx minx
- * @param miny miny
- * @param maxx maxx
- * @param maxy maxy
- *
- * @return psRootNode xmlNodePtr pointer of XML construct
- */
-
-xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions, double minx, double miny, double maxx, double maxy)
-{
-  char LowerCorner[100];
-  char UpperCorner[100];
-  char dim_string[100];
-
-  xmlNodePtr psRootNode = NULL;
-
-  if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
-  /* create element name */
-  psRootNode = xmlNewNode(psNsOws, BAD_CAST "WGS84BoundingBox");
-
-  snprintf( dim_string, sizeof(dim_string), "%d", dimensions );
-  xmlNewProp(psRootNode, BAD_CAST "dimensions", BAD_CAST dim_string);
-
-  snprintf(LowerCorner, sizeof(LowerCorner), "%.6f %.6f", minx, miny);
-  snprintf(UpperCorner, sizeof(UpperCorner), "%.6f %.6f", maxx, maxy);
-
-  /* add child elements */
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "LowerCorner",BAD_CAST LowerCorner);
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "UpperCorner",BAD_CAST UpperCorner);
-
-  return psRootNode;
-}
-
-/**
- * _validateNamespace()
- *
- * validates the namespace passed to this module's functions
- *
- * @param psNsOws namespace object
- *
- * @return MS_SUCCESS or MS_FAILURE
- *
- */
-
-int _validateNamespace(xmlNsPtr psNsOws)
-{
-  char namespace_prefix[10];
-  snprintf(namespace_prefix, sizeof(namespace_prefix), "%s", psNsOws->prefix);
-  if (strcmp(namespace_prefix, MS_OWSCOMMON_OWS_NAMESPACE_PREFIX) == 0)
-    return MS_SUCCESS;
-  else
-    return MS_FAILURE;
-}
-
-/*
- * Valid an xml string against an XML schema
- * Inpired from: http://xml.developpez.com/sources/?page=validation#validate_XSD_CppCLI_2
- * taken from tinyows.org
- */
-int msOWSSchemaValidation(const char* xml_schema, const char* xml)
-{
-  xmlSchemaPtr schema;
-  xmlSchemaParserCtxtPtr ctxt;
-  xmlSchemaValidCtxtPtr validctxt;
-  int ret;
-  xmlDocPtr doc;
-
-  if (!xml_schema || !xml)
-    return MS_FAILURE;
-
-  xmlInitParser();
-  schema = NULL;
-  ret = -1;
-
-  /* To valide WFS 2.0 requests, we might need to explicitely import */
-  /* GML and FES 2.0 */
-  if( strlen(xml_schema) > strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) &&
-      strcmp(xml_schema + strlen(xml_schema) -
-            strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION), MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) == 0 )
-  {
-    const size_t nLenBaseLocation = strlen(xml_schema) - strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-    char* pszInMemSchema = NULL;
-    char* pszBaseLocation = (char*)msSmallMalloc(nLenBaseLocation + 1);
-    memcpy(pszBaseLocation, xml_schema, nLenBaseLocation);
-    pszBaseLocation[nLenBaseLocation] = '\0';
-
-    pszInMemSchema = msStringConcatenate(pszInMemSchema,
-        "<schema elementFormDefault=\"qualified\" version=\"1.0.0\" "
-        "xmlns=\"http://www.w3.org/2001/XMLSchema\">\n");
-
-    pszInMemSchema = msStringConcatenate(pszInMemSchema,
-        "<import namespace=\"" MS_OWSCOMMON_WFS_20_NAMESPACE_URI "\" schemaLocation=\"");
-    pszInMemSchema = msStringConcatenate(pszInMemSchema, xml_schema);
-    pszInMemSchema = msStringConcatenate(pszInMemSchema, "\" />\n");
-
-    if( strstr(xml, MS_OWSCOMMON_FES_20_NAMESPACE_URI) != NULL )
-    {
-        pszInMemSchema = msStringConcatenate(pszInMemSchema,
-            "<import namespace=\"" MS_OWSCOMMON_FES_20_NAMESPACE_URI "\" schemaLocation=\"");
-        pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-        pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_FES_20_SCHEMA_LOCATION "\" />\n");
-    }
-
-    if( strstr(xml, MS_OWSCOMMON_GML_32_NAMESPACE_URI) != NULL )
-    {
-        pszInMemSchema = msStringConcatenate(pszInMemSchema,
-            "<import namespace=\"" MS_OWSCOMMON_GML_32_NAMESPACE_URI "\" schemaLocation=\"");
-        pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-        pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_GML_321_SCHEMA_LOCATION "\" />\n");
-
-    }
-    else if( strstr(xml, MS_OWSCOMMON_GML_NAMESPACE_URI) != NULL )
-    {
-        if( strstr(xml, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION) != NULL )
-        {
-            pszInMemSchema = msStringConcatenate(pszInMemSchema,
-                "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI "\" schemaLocation=\"");
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION "\" />\n");
-        }
-        else if( strstr(xml, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION) != NULL )
-        {
-            pszInMemSchema = msStringConcatenate(pszInMemSchema,
-                "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI "\" schemaLocation=\"");
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION "\" />\n");
-        }
-    }
-
-    pszInMemSchema = msStringConcatenate(pszInMemSchema, "</schema>\n");
-
-    ctxt = xmlSchemaNewMemParserCtxt(pszInMemSchema, strlen(pszInMemSchema));
-    msFree(pszInMemSchema);
-    msFree(pszBaseLocation);
-  }
-  else
-  {
-    /* Open XML Schema File */
-    ctxt = xmlSchemaNewParserCtxt(xml_schema);
-  }
-
-  /*
-  xmlSchemaSetParserErrors(ctxt,
-                           (xmlSchemaValidityErrorFunc) libxml2_callback,
-                           (xmlSchemaValidityWarningFunc) libxml2_callback, stderr);
-  */
-
-  schema = xmlSchemaParse(ctxt);
-  xmlSchemaFreeParserCtxt(ctxt);
-
-  /* If XML Schema hasn't been rightly loaded */
-  if (schema == NULL) {
-    xmlMemoryDump();
-    xmlCleanupParser();
-    return ret;
-  }
-
-  doc = xmlParseDoc((xmlChar *)xml);
-
-  if (doc != NULL) {
-    /* Loading XML Schema content */
-    validctxt = xmlSchemaNewValidCtxt(schema);
-    /*
-    xmlSchemaSetValidErrors(validctxt,
-                            (xmlSchemaValidityErrorFunc) libxml2_callback,
-                            (xmlSchemaValidityWarningFunc) libxml2_callback, stderr);
-    */
-    /* validation */
-    ret = xmlSchemaValidateDoc(validctxt, doc);
-    xmlSchemaFreeValidCtxt(validctxt);
-  }
-
-  xmlSchemaFree(schema);
-  xmlFreeDoc(doc);
-  xmlCleanupParser();
-
-  return ret;
-}
-
-#endif /* defined(USE_LIBXML2) */
-
-
-/**
- * msOWSCommonNegotiateVersion()
- *
- * returns a supported version as per subclause 7.3.2
- *
- * @param requested_version the version passed by the client
- * @param supported_versions an array of supported versions
- * @param num_supported_versions size of supported_versions
- *
- * @return supported version integer, or -1 on error
- *
- */
-
-int msOWSCommonNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions)
-{
-  int i;
-
-  /* if version is not set return error */
-  if (! requested_version)
-    return -1;
-
-  /* return the first entry that's equal to the requested version */
-  for (i = 0; i < num_supported_versions; i++) {
-    if (supported_versions[i] == requested_version)
-      return supported_versions[i];
-  }
-
-  /* no match; calling code should throw an exception */
-  return -1;
-}
diff -pruN 8.0.1-5/mapowscommon.h 8.2.0~beta1-1~exp1/mapowscommon.h
--- 8.0.1-5/mapowscommon.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapowscommon.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,203 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC OWS Common Implementation include file
- * Author:   Tom Kralidis (tomkralidis@gmail.com)
- *
- ******************************************************************************
- * Copyright (c) 2006, Tom Kralidis
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPOWSCOMMON_H
-#define MAPOWSCOMMON_H
-
-#ifdef USE_LIBXML2
-
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-
-#endif
-
-/* W3C namespaces */
-
-#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI      "http://www.w3.org/1999/xlink"
-#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX   "xlink"
-
-#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI        "http://www.w3.org/2001/XMLSchema-instance"
-#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX     "xsi"
-
-#define MS_OWSCOMMON_W3C_XS_NAMESPACE_URI         "http://www.w3.org/2001/XMLSchema"
-#define MS_OWSCOMMON_W3C_XS_NAMESPACE_PREFIX      "xs"
-
-/* OGC namespaces */
-
-#define MS_OWSCOMMON_OGC_NAMESPACE_URI      "http://www.opengis.net/ogc"
-#define MS_OWSCOMMON_OGC_NAMESPACE_PREFIX   "ogc"
-
-#define MS_OWSCOMMON_OWS_NAMESPACE_URI      "http://www.opengis.net/ows"
-#define MS_OWSCOMMON_OWS_NAMESPACE_PREFIX   "ows"
-
-#define MS_OWSCOMMON_OWS_110_NAMESPACE_URI      "http://www.opengis.net/ows/1.1"
-
-#define MS_OWSCOMMON_OWS_20_NAMESPACE_URI   "http://www.opengis.net/ows/2.0"
-#define MS_OWSCOMMON_OWS_20_SCHEMAS_LOCATION    "/ows/2.0/owsAll.xsd"
-
-/* OGC URNs */
-
-#define MS_OWSCOMMON_URN_OGC_CRS_4326 "urn:opengis:def:crs:OGC:2:84"
-
-/* default OGC Schemas Location */
-
-#define MS_OWSCOMMON_SCHEMAS_LOCATION "http://schemas.opengis.net"
-
-/* OGC codespace */
-
-#define MS_OWSCOMMON_OGC_CODESPACE "OGC"
-
-/* WCS namespaces */
-
-#define MS_OWSCOMMON_WCS_20_NAMESPACE_URI   "http://www.opengis.net/wcs/2.0"
-#define MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION    "/wcs/2.0/wcsAll.xsd"
-#define MS_OWSCOMMON_WCS_NAMESPACE_PREFIX   "wcs"
-
-/* GML namespaces */
-
-#define MS_OWSCOMMON_GML_NAMESPACE_URI      "http://www.opengis.net/gml"
-#define MS_OWSCOMMON_GML_NAMESPACE_PREFIX   "gml"
-
-#define MS_OWSCOMMON_GML_32_NAMESPACE_URI   "http://www.opengis.net/gml/3.2"
-
-#define MS_OWSCOMMON_GML_212_SCHEMA_LOCATION       "/gml/2.1.2/feature.xsd"
-#define MS_OWSCOMMON_GML_311_SCHEMA_LOCATION       "/gml/3.1.1/base/gml.xsd"
-#define MS_OWSCOMMON_GML_321_SCHEMA_LOCATION       "/gml/3.2.1/gml.xsd"
-
-/* WFS namespaces */
-
-#define MS_OWSCOMMON_WFS_NAMESPACE_PREFIX          "wfs"
-#define MS_OWSCOMMON_WFS_NAMESPACE_URI             "http://www.opengis.net/wfs"
-#define MS_OWSCOMMON_WFS_20_NAMESPACE_URI          "http://www.opengis.net/wfs/2.0"
-
-#define MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION        "/wfs/1.0.0/WFS-basic.xsd"
-#define MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION        "/wfs/1.1.0/wfs.xsd"
-#define MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION        "/wfs/2.0/wfs.xsd"
-
-/* FES namespaces */
-
-#define MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX       "fes"
-#define MS_OWSCOMMON_FES_20_NAMESPACE_URI          "http://www.opengis.net/fes/2.0"
-
-#define MS_OWSCOMMON_FES_20_SCHEMA_LOCATION        "/filter/2.0/filterAll.xsd"
-
-/* GMLCov namespaces */
-
-#define MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI    "http://www.opengis.net/gmlcov/1.0"
-#define MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX    "gmlcov"
-
-/* SWE namespaces */
-#define MS_OWSCOMMON_SWE_20_NAMESPACE_URI   "http://www.opengis.net/swe/2.0"
-#define MS_OWSCOMMON_SWE_NAMESPACE_PREFIX   "swe"
-
-/* Inspire namespaces */
-
-#define MS_INSPIRE_COMMON_NAMESPACE_URI     "http://inspire.ec.europa.eu/schemas/common/1.0"
-#define MS_INSPIRE_COMMON_NAMESPACE_PREFIX  "inspire_common"
-#define MS_INSPIRE_COMMON_SCHEMA_LOCATION   "/common/1.0/common.xsd"
-
-#define MS_INSPIRE_VS_NAMESPACE_URI         "http://inspire.ec.europa.eu/schemas/inspire_vs/1.0"
-#define MS_INSPIRE_VS_NAMESPACE_PREFIX      "inspire_vs"
-#define MS_INSPIRE_VS_SCHEMA_LOCATION       "/inspire_vs/1.0/inspire_vs.xsd"
-
-#define MS_INSPIRE_DLS_NAMESPACE_URI        "http://inspire.ec.europa.eu/schemas/inspire_dls/1.0"
-#define MS_INSPIRE_DLS_NAMESPACE_PREFIX     "inspire_dls"
-#define MS_INSPIRE_DLS_SCHEMA_LOCATION      "/inspire_dls/1.0/inspire_dls.xsd"
-
-
-/* MapServer namespaces */
-#define MS_DEFAULT_NAMESPACE_PREFIX         "ms"
-#define MS_DEFAULT_NAMESPACE_URI            "http://mapserver.gis.umn.edu/mapserver"
-
-
-/* OWS errors */
-
-/* OWS 1.1.0 Table 25 */
-#define MS_OWS_ERROR_OPERATION_NOT_SUPPORTED    "OperationNotSupported"
-#define MS_OWS_ERROR_MISSING_PARAMETER_VALUE    "MissingParameterValue"
-#define MS_OWS_ERROR_INVALID_PARAMETER_VALUE    "InvalidParameterValue"
-#define MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED "VersionNegotiationFailed"
-#define MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE    "InvalidUpdateSequence"
-#define MS_OWS_ERROR_OPTION_NOT_SUPPORTED       "OptionNotSupported"
-#define MS_OWS_ERROR_NO_APPLICABLE_CODE         "NoApplicableCode"
-
-#define MS_OWS_ERROR_NOT_FOUND                  "NotFound"
-
-#define MS_WFS_ERROR_OPERATION_PROCESSING_FAILED "OperationProcessingFailed"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#ifdef USE_LIBXML2
-
-/* function prototypes */
-
-
-xmlNodePtr msOWSCommonServiceIdentification(xmlNsPtr psNsOws, mapObj *map,
-                                            const char *servicetype,
-                                            const char *version,
-                                            const char *namespaces,
-                                            const char *validated_language);
-
-xmlNodePtr msOWSCommonServiceProvider(xmlNsPtr psNsOws,
-                                      xmlNsPtr psXLinkNs,
-                                      mapObj *map,
-                                      const char *namespaces,
-                                      const char *validated_language);
-
-xmlNodePtr msOWSCommonOperationsMetadata(xmlNsPtr psNsOws);
-
-#define OWS_METHOD_GET     1
-#define OWS_METHOD_POST    2
-#define OWS_METHOD_GETPOST 3
-
-xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws, xmlNsPtr psXLinkNs, const char *name, int method, const char *url);
-
-xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version, xmlNsPtr psNsOws, const char *elname, const char *name, const char *values);
-
-xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version, const char *schemas_location, const char *version, const char *language, const char *exceptionCode, const char *locator, const char *ExceptionText);
-
-xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs, int dimensions, double minx, double miny, double maxx, double maxy);
-
-xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions, double minx, double miny, double maxx, double maxy);
-
-int _validateNamespace(xmlNsPtr psNsOws);
-
-int msOWSSchemaValidation(const char* xml_schema, const char* xml);
-
-#endif /* defined(USE_LIBXML2) */
-
-int msOWSCommonNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions);
-
-#ifdef __cplusplus
-} /* extern C */
-#endif
-
-#endif /* MAPOWSCOMMON_H */
diff -pruN 8.0.1-5/mapparser.c 8.2.0~beta1-1~exp1/mapparser.c
--- 8.0.1-5/mapparser.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapparser.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,3349 +0,0 @@
-/* A Bison parser, made by GNU Bison 3.0.4.  */
-
-/* Bison implementation for Yacc-like parsers in C
-
-   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.
-
-   This program is free software: you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation, either version 3 of the License, or
-   (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
-
-/* As a special exception, you may create a larger work that contains
-   part or all of the Bison parser skeleton and distribute that work
-   under terms of your choice, so long as that work isn't itself a
-   parser generator using the skeleton or a modified version thereof
-   as a parser skeleton.  Alternatively, if you modify or redistribute
-   the parser skeleton itself, you may (at your option) remove this
-   special exception, which will cause the skeleton and the resulting
-   Bison output files to be licensed under the GNU General Public
-   License without this special exception.
-
-   This special exception was added by the Free Software Foundation in
-   version 2.2 of Bison.  */
-
-/* C LALR(1) parser skeleton written by Richard Stallman, by
-   simplifying the original so-called "semantic" parser.  */
-
-/* All symbols defined below should begin with yy or YY, to avoid
-   infringing on user name space.  This should be done even for local
-   variables, as they might otherwise be expanded by user macros.
-   There are some unavoidable exceptions within include files to
-   define necessary library symbols; they are noted "INFRINGES ON
-   USER NAME SPACE" below.  */
-
-/* Identify Bison output.  */
-#define YYBISON 1
-
-/* Bison version.  */
-#define YYBISON_VERSION "3.0.4"
-
-/* Skeleton name.  */
-#define YYSKELETON_NAME "yacc.c"
-
-/* Pure parsers.  */
-#define YYPURE 1
-
-/* Push parsers.  */
-#define YYPUSH 0
-
-/* Pull parsers.  */
-#define YYPULL 1
-
-
-
-
-/* Copy the first part of user declarations.  */
-#line 5 "mapparser.y" /* yacc.c:339  */
-
-/* C declarations */
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <math.h>
-#include <time.h>
-
-#include "mapserver.h" /* for TRUE/FALSE and REGEX includes */
-#include "maptime.h" /* for time comparison routines */
-#include "mapprimitive.h" /* for shapeObj */
-
-#include "mapparser.h" /* for YYSTYPE in the function prototype for yylex() */
-
-int yylex(YYSTYPE *, parseObj *); /* prototype functions, defined after the grammar */
-int yyerror(parseObj *, const char *);
-
-#line 84 "/vagrant/mapparser.c" /* yacc.c:339  */
-
-# ifndef YY_NULLPTR
-#  if defined __cplusplus && 201103L <= __cplusplus
-#   define YY_NULLPTR nullptr
-#  else
-#   define YY_NULLPTR 0
-#  endif
-# endif
-
-/* Enabling verbose error messages.  */
-#ifdef YYERROR_VERBOSE
-# undef YYERROR_VERBOSE
-# define YYERROR_VERBOSE 1
-#else
-# define YYERROR_VERBOSE 0
-#endif
-
-/* In a future release of Bison, this section will be replaced
-   by #include "mapparser.h".  */
-#ifndef YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
-# define YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
-/* Debug traces.  */
-#ifndef YYDEBUG
-# define YYDEBUG 0
-#endif
-#if YYDEBUG
-extern int yydebug;
-#endif
-
-/* Token type.  */
-#ifndef YYTOKENTYPE
-# define YYTOKENTYPE
-  enum yytokentype
-  {
-    BOOLEAN = 258,
-    NUMBER = 259,
-    STRING = 260,
-    TIME = 261,
-    SHAPE = 262,
-    OR = 263,
-    AND = 264,
-    NOT = 265,
-    RE = 266,
-    EQ = 267,
-    NE = 268,
-    LT = 269,
-    GT = 270,
-    LE = 271,
-    GE = 272,
-    IN = 273,
-    IEQ = 274,
-    IRE = 275,
-    INTERSECTS = 276,
-    DISJOINT = 277,
-    TOUCHES = 278,
-    OVERLAPS = 279,
-    CROSSES = 280,
-    WITHIN = 281,
-    CONTAINS = 282,
-    EQUALS = 283,
-    BEYOND = 284,
-    DWITHIN = 285,
-    AREA = 286,
-    LENGTH = 287,
-    COMMIFY = 288,
-    ROUND = 289,
-    UPPER = 290,
-    LOWER = 291,
-    INITCAP = 292,
-    FIRSTCAP = 293,
-    TOSTRING = 294,
-    YYBUFFER = 295,
-    INNER = 296,
-    OUTER = 297,
-    DIFFERENCE = 298,
-    DENSIFY = 299,
-    SIMPLIFY = 300,
-    SIMPLIFYPT = 301,
-    GENERALIZE = 302,
-    SMOOTHSIA = 303,
-    CENTERLINE = 304,
-    JAVASCRIPT = 305,
-    NEG = 306
-  };
-#endif
-/* Tokens.  */
-#define BOOLEAN 258
-#define NUMBER 259
-#define STRING 260
-#define TIME 261
-#define SHAPE 262
-#define OR 263
-#define AND 264
-#define NOT 265
-#define RE 266
-#define EQ 267
-#define NE 268
-#define LT 269
-#define GT 270
-#define LE 271
-#define GE 272
-#define IN 273
-#define IEQ 274
-#define IRE 275
-#define INTERSECTS 276
-#define DISJOINT 277
-#define TOUCHES 278
-#define OVERLAPS 279
-#define CROSSES 280
-#define WITHIN 281
-#define CONTAINS 282
-#define EQUALS 283
-#define BEYOND 284
-#define DWITHIN 285
-#define AREA 286
-#define LENGTH 287
-#define COMMIFY 288
-#define ROUND 289
-#define UPPER 290
-#define LOWER 291
-#define INITCAP 292
-#define FIRSTCAP 293
-#define TOSTRING 294
-#define YYBUFFER 295
-#define INNER 296
-#define OUTER 297
-#define DIFFERENCE 298
-#define DENSIFY 299
-#define SIMPLIFY 300
-#define SIMPLIFYPT 301
-#define GENERALIZE 302
-#define SMOOTHSIA 303
-#define CENTERLINE 304
-#define JAVASCRIPT 305
-#define NEG 306
-
-/* Value type.  */
-#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
-
-union YYSTYPE
-{
-#line 30 "mapparser.y" /* yacc.c:355  */
-
-  double dblval;
-  int intval;  
-  char *strval;  
-  struct tm tmval;
-  shapeObj *shpval;
-
-#line 234 "/vagrant/mapparser.c" /* yacc.c:355  */
-};
-
-typedef union YYSTYPE YYSTYPE;
-# define YYSTYPE_IS_TRIVIAL 1
-# define YYSTYPE_IS_DECLARED 1
-#endif
-
-
-
-int yyparse (parseObj *p);
-
-#endif /* !YY_YY_VAGRANT_MAPPARSER_H_INCLUDED  */
-
-/* Copy the second part of user declarations.  */
-
-#line 250 "/vagrant/mapparser.c" /* yacc.c:358  */
-
-#ifdef short
-# undef short
-#endif
-
-#ifdef YYTYPE_UINT8
-typedef YYTYPE_UINT8 yytype_uint8;
-#else
-typedef unsigned char yytype_uint8;
-#endif
-
-#ifdef YYTYPE_INT8
-typedef YYTYPE_INT8 yytype_int8;
-#else
-typedef signed char yytype_int8;
-#endif
-
-#ifdef YYTYPE_UINT16
-typedef YYTYPE_UINT16 yytype_uint16;
-#else
-typedef unsigned short int yytype_uint16;
-#endif
-
-#ifdef YYTYPE_INT16
-typedef YYTYPE_INT16 yytype_int16;
-#else
-typedef short int yytype_int16;
-#endif
-
-#ifndef YYSIZE_T
-# ifdef __SIZE_TYPE__
-#  define YYSIZE_T __SIZE_TYPE__
-# elif defined size_t
-#  define YYSIZE_T size_t
-# elif ! defined YYSIZE_T
-#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
-#  define YYSIZE_T size_t
-# else
-#  define YYSIZE_T unsigned int
-# endif
-#endif
-
-#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)
-
-#ifndef YY_
-# if defined YYENABLE_NLS && YYENABLE_NLS
-#  if ENABLE_NLS
-#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
-#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
-#  endif
-# endif
-# ifndef YY_
-#  define YY_(Msgid) Msgid
-# endif
-#endif
-
-#ifndef YY_ATTRIBUTE
-# if (defined __GNUC__                                               \
-      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
-     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
-#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
-# else
-#  define YY_ATTRIBUTE(Spec) /* empty */
-# endif
-#endif
-
-#ifndef YY_ATTRIBUTE_PURE
-# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
-#endif
-
-#ifndef YY_ATTRIBUTE_UNUSED
-# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
-#endif
-
-#if !defined _Noreturn \
-     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
-# if defined _MSC_VER && 1200 <= _MSC_VER
-#  define _Noreturn __declspec (noreturn)
-# else
-#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
-# endif
-#endif
-
-/* Suppress unused-variable warnings by "using" E.  */
-#if ! defined lint || defined __GNUC__
-# define YYUSE(E) ((void) (E))
-#else
-# define YYUSE(E) /* empty */
-#endif
-
-#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
-/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
-# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
-    _Pragma ("GCC diagnostic push") \
-    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
-    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
-# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
-    _Pragma ("GCC diagnostic pop")
-#else
-# define YY_INITIAL_VALUE(Value) Value
-#endif
-#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
-# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
-# define YY_IGNORE_MAYBE_UNINITIALIZED_END
-#endif
-#ifndef YY_INITIAL_VALUE
-# define YY_INITIAL_VALUE(Value) /* Nothing. */
-#endif
-
-
-#if ! defined yyoverflow || YYERROR_VERBOSE
-
-/* The parser invokes alloca or malloc; define the necessary symbols.  */
-
-# ifdef YYSTACK_USE_ALLOCA
-#  if YYSTACK_USE_ALLOCA
-#   ifdef __GNUC__
-#    define YYSTACK_ALLOC __builtin_alloca
-#   elif defined __BUILTIN_VA_ARG_INCR
-#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
-#   elif defined _AIX
-#    define YYSTACK_ALLOC __alloca
-#   elif defined _MSC_VER
-#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
-#    define alloca _alloca
-#   else
-#    define YYSTACK_ALLOC alloca
-#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
-#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
-      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
-#     ifndef EXIT_SUCCESS
-#      define EXIT_SUCCESS 0
-#     endif
-#    endif
-#   endif
-#  endif
-# endif
-
-# ifdef YYSTACK_ALLOC
-   /* Pacify GCC's 'empty if-body' warning.  */
-#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
-#  ifndef YYSTACK_ALLOC_MAXIMUM
-    /* The OS might guarantee only one guard page at the bottom of the stack,
-       and a page size can be as small as 4096 bytes.  So we cannot safely
-       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
-       to allow for a few compiler-allocated temporary stack slots.  */
-#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
-#  endif
-# else
-#  define YYSTACK_ALLOC YYMALLOC
-#  define YYSTACK_FREE YYFREE
-#  ifndef YYSTACK_ALLOC_MAXIMUM
-#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
-#  endif
-#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
-       && ! ((defined YYMALLOC || defined malloc) \
-             && (defined YYFREE || defined free)))
-#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
-#   ifndef EXIT_SUCCESS
-#    define EXIT_SUCCESS 0
-#   endif
-#  endif
-#  ifndef YYMALLOC
-#   define YYMALLOC malloc
-#   if ! defined malloc && ! defined EXIT_SUCCESS
-void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
-#   endif
-#  endif
-#  ifndef YYFREE
-#   define YYFREE free
-#   if ! defined free && ! defined EXIT_SUCCESS
-void free (void *); /* INFRINGES ON USER NAME SPACE */
-#   endif
-#  endif
-# endif
-#endif /* ! defined yyoverflow || YYERROR_VERBOSE */
-
-
-#if (! defined yyoverflow \
-     && (! defined __cplusplus \
-         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))
-
-/* A type that is properly aligned for any stack member.  */
-union yyalloc
-{
-  yytype_int16 yyss_alloc;
-  YYSTYPE yyvs_alloc;
-};
-
-/* The size of the maximum gap between one aligned stack and the next.  */
-# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)
-
-/* The size of an array large to enough to hold all stacks, each with
-   N elements.  */
-# define YYSTACK_BYTES(N) \
-     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
-      + YYSTACK_GAP_MAXIMUM)
-
-# define YYCOPY_NEEDED 1
-
-/* Relocate STACK from its old location to the new one.  The
-   local variables YYSIZE and YYSTACKSIZE give the old and new number of
-   elements in the stack, and YYPTR gives the new location of the
-   stack.  Advance YYPTR to a properly aligned location for the next
-   stack.  */
-# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
-    do                                                                  \
-      {                                                                 \
-        YYSIZE_T yynewbytes;                                            \
-        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
-        Stack = &yyptr->Stack_alloc;                                    \
-        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
-        yyptr += yynewbytes / sizeof (*yyptr);                          \
-      }                                                                 \
-    while (0)
-
-#endif
-
-#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
-/* Copy COUNT objects from SRC to DST.  The source and destination do
-   not overlap.  */
-# ifndef YYCOPY
-#  if defined __GNUC__ && 1 < __GNUC__
-#   define YYCOPY(Dst, Src, Count) \
-      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
-#  else
-#   define YYCOPY(Dst, Src, Count)              \
-      do                                        \
-        {                                       \
-          YYSIZE_T yyi;                         \
-          for (yyi = 0; yyi < (Count); yyi++)   \
-            (Dst)[yyi] = (Src)[yyi];            \
-        }                                       \
-      while (0)
-#  endif
-# endif
-#endif /* !YYCOPY_NEEDED */
-
-/* YYFINAL -- State number of the termination state.  */
-#define YYFINAL  86
-/* YYLAST -- Last index in YYTABLE.  */
-#define YYLAST   540
-
-/* YYNTOKENS -- Number of terminals.  */
-#define YYNTOKENS  61
-/* YYNNTS -- Number of nonterminals.  */
-#define YYNNTS  7
-/* YYNRULES -- Number of rules.  */
-#define YYNRULES  102
-/* YYNSTATES -- Number of states.  */
-#define YYNSTATES  306
-
-/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
-   by yylex, with out-of-bounds checking.  */
-#define YYUNDEFTOK  2
-#define YYMAXUTOK   306
-
-#define YYTRANSLATE(YYX)                                                \
-  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)
-
-/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
-   as returned by yylex, without out-of-bounds checking.  */
-static const yytype_uint8 yytranslate[] =
-{
-       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,    55,     2,     2,
-      58,    59,    53,    51,    60,    52,     2,    54,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,    57,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
-       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
-      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
-      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
-      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
-      45,    46,    47,    48,    49,    50,    56
-};
-
-#if YYDEBUG
-  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
-static const yytype_uint16 yyrline[] =
-{
-       0,    68,    68,    69,    82,    96,   110,   120,   121,   122,
-     126,   134,   143,   151,   160,   168,   177,   185,   194,   195,
-     196,   216,   236,   242,   248,   254,   260,   266,   272,   280,
-     288,   296,   304,   312,   320,   326,   332,   338,   344,   350,
-     356,   377,   397,   403,   411,   417,   434,   451,   468,   485,
-     502,   519,   536,   553,   570,   587,   604,   621,   638,   655,
-     672,   689,   705,   723,   724,   725,   726,   727,   728,   729,
-     736,   737,   738,   739,   750,   751,   754,   755,   756,   770,
-     784,   798,   812,   826,   840,   854,   868,   882,   896,   910,
-     924,   939,   961,   962,   963,   967,   972,   976,   980,   984,
-     988,   994,   995
-};
-#endif
-
-#if YYDEBUG || YYERROR_VERBOSE || 0
-/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
-   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
-static const char *const yytname[] =
-{
-  "$end", "error", "$undefined", "BOOLEAN", "NUMBER", "STRING", "TIME",
-  "SHAPE", "OR", "AND", "NOT", "RE", "EQ", "NE", "LT", "GT", "LE", "GE",
-  "IN", "IEQ", "IRE", "INTERSECTS", "DISJOINT", "TOUCHES", "OVERLAPS",
-  "CROSSES", "WITHIN", "CONTAINS", "EQUALS", "BEYOND", "DWITHIN", "AREA",
-  "LENGTH", "COMMIFY", "ROUND", "UPPER", "LOWER", "INITCAP", "FIRSTCAP",
-  "TOSTRING", "YYBUFFER", "INNER", "OUTER", "DIFFERENCE", "DENSIFY",
-  "SIMPLIFY", "SIMPLIFYPT", "GENERALIZE", "SMOOTHSIA", "CENTERLINE",
-  "JAVASCRIPT", "'+'", "'-'", "'*'", "'/'", "'%'", "NEG", "'^'", "'('",
-  "')'", "','", "$accept", "input", "logical_exp", "math_exp", "shape_exp",
-  "string_exp", "time_exp", YY_NULLPTR
-};
-#endif
-
-# ifdef YYPRINT
-/* YYTOKNUM[NUM] -- (External) token number corresponding to the
-   (internal) symbol number NUM (which must be that of a token).  */
-static const yytype_uint16 yytoknum[] =
-{
-       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
-     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
-     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
-     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
-     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
-     305,    43,    45,    42,    47,    37,   306,    94,    40,    41,
-      44
-};
-# endif
-
-#define YYPACT_NINF -56
-
-#define yypact_value_is_default(Yystate) \
-  (!!((Yystate) == (-56)))
-
-#define YYTABLE_NINF -1
-
-#define yytable_value_is_error(Yytable_value) \
-  0
-
-  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
-     STATE-NUM.  */
-static const yytype_int16 yypact[] =
-{
-     355,   -56,   -56,   -56,   -56,   -56,   355,   -55,   -48,   -35,
-     -33,     1,    19,    39,    48,    53,    54,    71,    72,    74,
-     116,   128,   130,   131,   132,   133,   134,   135,   157,   158,
-     159,   160,   173,   182,   183,   197,   198,    -3,   355,    51,
-     119,   211,    69,    56,   521,    44,   412,    69,    56,   203,
-     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
-       4,     4,    -3,     4,     4,     4,     4,    -3,   203,   203,
-     203,   203,   203,   203,   203,   203,   203,   203,   203,    -3,
-     102,    -1,   154,    -6,   403,   304,   -56,   355,   355,   355,
-     355,   355,    -3,    -3,    -3,    -3,    -3,    -3,     4,    -3,
-      -3,    -3,    -3,    -3,    -3,    -3,   203,   203,   203,   203,
-     203,   203,   203,   203,     4,     4,     4,     4,     4,     4,
-       4,     4,     4,     4,     4,    -4,    -4,    -4,    -4,    -4,
-      -4,    -4,   203,   152,   161,   199,   200,   209,   225,   228,
-     230,   242,   244,   247,     4,   -46,   -37,   101,   -27,   -25,
-     -24,   106,   381,   248,   255,   263,   264,   265,   266,   267,
-     268,    50,   270,   272,   316,   -56,   -56,   -56,   -56,   -56,
-      21,   258,    44,   412,   -56,   211,    21,   258,    44,   412,
-      -7,    -7,    -7,    -7,    -7,    -7,     6,    -7,    25,    25,
-     102,   102,   102,   102,   -56,   -56,   -56,   -56,   -56,   -56,
-     -56,   -56,     6,     6,     6,     6,     6,     6,     6,     6,
-       6,     6,   -56,    -4,   -56,   -56,   -56,   -56,   -56,   -56,
-     -56,   274,   203,   203,   203,   203,   203,   203,   203,   203,
-     203,   203,   -56,   163,   -56,   -56,   -56,    -3,   -56,   -56,
-     -56,   -56,     4,    -3,   -56,   -56,   203,    -3,    -3,    -3,
-      -3,   -56,    -3,   -56,     4,   280,   285,   286,   287,   288,
-     305,   307,   315,   347,   348,   349,   391,   240,   419,   351,
-     428,   437,   446,   455,   227,   241,   -56,   -56,   -56,   -56,
-     -56,   -56,   -56,   -56,    -3,    -3,   -56,   -56,   -56,   -56,
-     -56,   -56,   -56,   -56,   -56,    -3,   -56,   464,   473,   283,
-     -56,   -56,   -56,     4,   246,   -56
-};
-
-  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
-     Performed when YYTABLE does not specify something else to do.  Zero
-     means the default is an error.  */
-static const yytype_uint8 yydefact[] =
-{
-       2,     7,    63,    92,   101,    76,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       3,     4,     6,     5,     0,    18,    19,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-      70,     0,     0,     0,     0,     0,     1,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     8,    64,    77,    93,   102,
-      10,    12,    11,    13,     9,     0,    14,    16,    15,    17,
-      22,    23,    25,    24,    27,    26,    41,    42,    65,    66,
-      67,    69,    68,    71,    45,    48,    50,    52,    54,    56,
-      58,    60,    20,    28,    29,    31,    30,    33,    32,    40,
-      43,    21,    94,     0,    34,    35,    37,    36,    39,    38,
-      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,    73,     0,    72,    96,    75,     0,    97,    98,
-      99,   100,     0,     0,    79,    80,     0,     0,     0,     0,
-       0,    87,     0,    81,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
-       0,     0,     0,     0,     0,     0,    47,    49,    51,    53,
-      55,    57,    59,    46,     0,     0,    74,    95,    78,    82,
-      83,    84,    85,    86,    88,     0,    91,     0,     0,     0,
-      62,    61,    89,     0,     0,    90
-};
-
-  /* YYPGOTO[NTERM-NUM].  */
-static const yytype_int8 yypgoto[] =
-{
-     -56,   -56,    -2,    46,   126,     0,   -26
-};
-
-  /* YYDEFGOTO[NTERM-NUM].  */
-static const yytype_int8 yydefgoto[] =
-{
-      -1,    39,    40,    41,    47,    48,    44
-};
-
-  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
-     positive, shift that token.  If negative, reduce the rule whose
-     number is the opposite.  If YYTABLE_NINF, syntax error.  */
-static const yytype_uint16 yytable[] =
-{
-      43,     2,     4,    49,    45,   124,   106,    87,    88,     3,
-      50,    89,    85,   234,   124,   107,   108,   109,   110,   111,
-     112,   113,   235,    51,   124,    52,   124,   124,    17,    18,
-      88,    20,   238,    89,   239,   240,    81,    19,    84,    21,
-      22,    23,    24,    25,   100,   101,   102,   103,   104,    37,
-     105,    86,    46,   167,   213,    79,    89,   124,   165,    53,
-     145,   146,   144,   148,   149,   150,   151,   114,   115,   116,
-     117,   118,   119,   120,   121,   122,   123,    54,   102,   103,
-     104,   106,   105,    80,    82,   170,   172,   174,   176,   178,
-     107,   108,   109,   110,   111,   112,   113,    55,   186,   214,
-     215,   216,   217,   218,   219,   220,    56,   124,   147,   251,
-     252,    57,    58,   152,   202,   203,   204,   205,   206,   207,
-     208,   209,   210,   211,   212,   164,    42,    87,    88,    59,
-      60,    89,    61,   171,   173,   175,   177,   179,   180,   181,
-     182,   183,   184,   185,   233,   187,   188,   189,   190,   191,
-     192,   193,   100,   101,   102,   103,   104,   124,   105,   105,
-     236,   237,    90,    91,    83,   241,    92,    93,    94,    95,
-      96,    97,    98,    99,    62,   133,   134,   135,   136,   137,
-     138,   139,   140,   141,   142,   143,    63,   255,    64,    65,
-      66,    67,    68,    69,   153,   154,   155,   156,   157,   158,
-     159,   160,   161,   162,   163,   100,   101,   102,   103,   104,
-       5,   105,   222,   166,   124,    70,    71,    72,    73,    90,
-      91,   223,   168,    92,    93,    94,    95,    96,    97,    98,
-      99,    74,   194,   195,   196,   197,   198,   199,   200,   201,
-      75,    76,   267,    26,    27,    28,    29,    30,    31,    32,
-      33,    34,    35,    36,   275,    77,    78,     0,   221,   224,
-     225,   132,   100,   101,   102,   103,   104,    91,   105,   226,
-      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
-     102,   103,   104,   266,   105,   227,   294,   295,   228,   268,
-     229,   124,   124,   270,   271,   272,   273,   124,   274,   287,
-     296,     0,   230,   304,   231,   305,   232,     0,   243,   100,
-     101,   102,   103,   104,   244,   105,   125,   126,   127,   128,
-     129,   130,   245,   131,   246,   247,   248,   249,   250,   253,
-     297,   298,   254,   167,   100,   101,   102,   103,   104,   169,
-     105,   299,   302,   303,   276,   277,   278,   279,   256,   257,
-     258,   259,   260,   261,   262,   263,   264,   265,     1,     2,
-       3,     4,     5,   169,   280,     6,   281,   100,   101,   102,
-     103,   104,   269,   105,   282,   166,     7,     8,     9,    10,
-      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
-      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
-      31,    32,    33,    34,    35,    36,   283,    37,   284,   285,
-     289,     0,     0,    38,   114,   115,   116,   117,   118,   119,
-     120,   121,   122,   123,    92,    93,    94,    95,    96,    97,
-      98,    99,   100,   101,   102,   103,   104,     0,   105,     0,
-       0,   242,   100,   101,   102,   103,   104,     0,   105,     0,
-     286,     0,     0,     0,   124,     0,     0,     0,     0,     0,
-       0,     0,   168,   100,   101,   102,   103,   104,     0,   105,
-     100,   101,   102,   103,   104,     0,   105,     0,   288,   100,
-     101,   102,   103,   104,     0,   105,     0,   290,   100,   101,
-     102,   103,   104,     0,   105,     0,   291,   100,   101,   102,
-     103,   104,     0,   105,     0,   292,   100,   101,   102,   103,
-     104,     0,   105,     0,   293,   100,   101,   102,   103,   104,
-       0,   105,     0,   300,   100,   101,   102,   103,   104,     0,
-     105,     0,   301,   125,   126,   127,   128,   129,   130,     0,
-     131
-};
-
-static const yytype_int16 yycheck[] =
-{
-       0,     4,     6,    58,     6,    51,    12,     8,     9,     5,
-      58,    12,    38,    59,    51,    21,    22,    23,    24,    25,
-      26,    27,    59,    58,    51,    58,    51,    51,    31,    32,
-       9,    34,    59,    12,    59,    59,    38,    33,    38,    35,
-      36,    37,    38,    39,    51,    52,    53,    54,    55,    52,
-      57,     0,     6,    59,    58,    58,    12,    51,    59,    58,
-      60,    61,    58,    63,    64,    65,    66,    11,    12,    13,
-      14,    15,    16,    17,    18,    19,    20,    58,    53,    54,
-      55,    12,    57,    37,    38,    87,    88,    89,    90,    91,
-      21,    22,    23,    24,    25,    26,    27,    58,    98,   125,
-     126,   127,   128,   129,   130,   131,    58,    51,    62,    59,
-      60,    58,    58,    67,   114,   115,   116,   117,   118,   119,
-     120,   121,   122,   123,   124,    79,     0,     8,     9,    58,
-      58,    12,    58,    87,    88,    89,    90,    91,    92,    93,
-      94,    95,    96,    97,   144,    99,   100,   101,   102,   103,
-     104,   105,    51,    52,    53,    54,    55,    51,    57,    57,
-      59,    60,     8,     9,    38,    59,    12,    13,    14,    15,
-      16,    17,    18,    19,    58,    49,    50,    51,    52,    53,
-      54,    55,    56,    57,    58,    59,    58,   213,    58,    58,
-      58,    58,    58,    58,    68,    69,    70,    71,    72,    73,
-      74,    75,    76,    77,    78,    51,    52,    53,    54,    55,
-       7,    57,    60,    59,    51,    58,    58,    58,    58,     8,
-       9,    60,    59,    12,    13,    14,    15,    16,    17,    18,
-      19,    58,   106,   107,   108,   109,   110,   111,   112,   113,
-      58,    58,   242,    40,    41,    42,    43,    44,    45,    46,
-      47,    48,    49,    50,   254,    58,    58,    -1,   132,    60,
-      60,    58,    51,    52,    53,    54,    55,     9,    57,    60,
-      12,    13,    14,    15,    16,    17,    18,    19,    51,    52,
-      53,    54,    55,   237,    57,    60,    59,    60,    60,   243,
-      60,    51,    51,   247,   248,   249,   250,    51,   252,    59,
-      59,    -1,    60,   303,    60,    59,    59,    -1,    60,    51,
-      52,    53,    54,    55,    59,    57,    12,    13,    14,    15,
-      16,    17,    59,    19,    60,    60,    60,    60,    60,    59,
-     284,   285,    60,    59,    51,    52,    53,    54,    55,    59,
-      57,   295,    59,    60,    59,    59,    59,    59,   222,   223,
-     224,   225,   226,   227,   228,   229,   230,   231,     3,     4,
-       5,     6,     7,    59,    59,    10,    59,    51,    52,    53,
-      54,    55,   246,    57,    59,    59,    21,    22,    23,    24,
-      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
-      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
-      45,    46,    47,    48,    49,    50,    59,    52,    60,    60,
-      59,    -1,    -1,    58,    11,    12,    13,    14,    15,    16,
-      17,    18,    19,    20,    12,    13,    14,    15,    16,    17,
-      18,    19,    51,    52,    53,    54,    55,    -1,    57,    -1,
-      -1,    60,    51,    52,    53,    54,    55,    -1,    57,    -1,
-      59,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
-      -1,    -1,    59,    51,    52,    53,    54,    55,    -1,    57,
-      51,    52,    53,    54,    55,    -1,    57,    -1,    59,    51,
-      52,    53,    54,    55,    -1,    57,    -1,    59,    51,    52,
-      53,    54,    55,    -1,    57,    -1,    59,    51,    52,    53,
-      54,    55,    -1,    57,    -1,    59,    51,    52,    53,    54,
-      55,    -1,    57,    -1,    59,    51,    52,    53,    54,    55,
-      -1,    57,    -1,    59,    51,    52,    53,    54,    55,    -1,
-      57,    -1,    59,    12,    13,    14,    15,    16,    17,    -1,
-      19
-};
-
-  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
-     symbol of state STATE-NUM.  */
-static const yytype_uint8 yystos[] =
-{
-       0,     3,     4,     5,     6,     7,    10,    21,    22,    23,
-      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
-      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
-      44,    45,    46,    47,    48,    49,    50,    52,    58,    62,
-      63,    64,    65,    66,    67,    63,    64,    65,    66,    58,
-      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
-      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
-      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
-      64,    63,    64,    65,    66,    67,     0,     8,     9,    12,
-       8,     9,    12,    13,    14,    15,    16,    17,    18,    19,
-      51,    52,    53,    54,    55,    57,    12,    21,    22,    23,
-      24,    25,    26,    27,    11,    12,    13,    14,    15,    16,
-      17,    18,    19,    20,    51,    12,    13,    14,    15,    16,
-      17,    19,    58,    65,    65,    65,    65,    65,    65,    65,
-      65,    65,    65,    65,    58,    66,    66,    64,    66,    66,
-      66,    66,    64,    65,    65,    65,    65,    65,    65,    65,
-      65,    65,    65,    65,    64,    59,    59,    59,    59,    59,
-      63,    64,    63,    64,    63,    64,    63,    64,    63,    64,
-      64,    64,    64,    64,    64,    64,    66,    64,    64,    64,
-      64,    64,    64,    64,    65,    65,    65,    65,    65,    65,
-      65,    65,    66,    66,    66,    66,    66,    66,    66,    66,
-      66,    66,    66,    58,    67,    67,    67,    67,    67,    67,
-      67,    65,    60,    60,    60,    60,    60,    60,    60,    60,
-      60,    60,    59,    66,    59,    59,    59,    60,    59,    59,
-      59,    59,    60,    60,    59,    59,    60,    60,    60,    60,
-      60,    59,    60,    59,    60,    67,    65,    65,    65,    65,
-      65,    65,    65,    65,    65,    65,    64,    66,    64,    65,
-      64,    64,    64,    64,    64,    66,    59,    59,    59,    59,
-      59,    59,    59,    59,    60,    60,    59,    59,    59,    59,
-      59,    59,    59,    59,    59,    60,    59,    64,    64,    64,
-      59,    59,    59,    60,    66,    59
-};
-
-  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
-static const yytype_uint8 yyr1[] =
-{
-       0,    61,    62,    62,    62,    62,    62,    63,    63,    63,
-      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
-      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
-      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
-      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
-      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
-      63,    63,    63,    64,    64,    64,    64,    64,    64,    64,
-      64,    64,    64,    64,    64,    64,    65,    65,    65,    65,
-      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
-      65,    65,    66,    66,    66,    66,    66,    66,    66,    66,
-      66,    67,    67
-};
-
-  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
-static const yytype_uint8 yyr2[] =
-{
-       0,     2,     0,     1,     1,     1,     1,     1,     3,     3,
-       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
-       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
-       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
-       3,     3,     3,     3,     3,     3,     6,     6,     3,     6,
-       3,     6,     3,     6,     3,     6,     3,     6,     3,     6,
-       3,     8,     8,     1,     3,     3,     3,     3,     3,     3,
-       2,     3,     4,     4,     6,     4,     1,     3,     6,     4,
-       4,     4,     6,     6,     6,     6,     6,     4,     6,     8,
-      10,     6,     1,     3,     3,     6,     4,     4,     4,     4,
-       4,     1,     3
-};
-
-
-#define yyerrok         (yyerrstatus = 0)
-#define yyclearin       (yychar = YYEMPTY)
-#define YYEMPTY         (-2)
-#define YYEOF           0
-
-#define YYACCEPT        goto yyacceptlab
-#define YYABORT         goto yyabortlab
-#define YYERROR         goto yyerrorlab
-
-
-#define YYRECOVERING()  (!!yyerrstatus)
-
-#define YYBACKUP(Token, Value)                                  \
-do                                                              \
-  if (yychar == YYEMPTY)                                        \
-    {                                                           \
-      yychar = (Token);                                         \
-      yylval = (Value);                                         \
-      YYPOPSTACK (yylen);                                       \
-      yystate = *yyssp;                                         \
-      goto yybackup;                                            \
-    }                                                           \
-  else                                                          \
-    {                                                           \
-      yyerror (p, YY_("syntax error: cannot back up")); \
-      YYERROR;                                                  \
-    }                                                           \
-while (0)
-
-/* Error token number */
-#define YYTERROR        1
-#define YYERRCODE       256
-
-
-
-/* Enable debugging if requested.  */
-#if YYDEBUG
-
-# ifndef YYFPRINTF
-#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
-#  define YYFPRINTF fprintf
-# endif
-
-# define YYDPRINTF(Args)                        \
-do {                                            \
-  if (yydebug)                                  \
-    YYFPRINTF Args;                             \
-} while (0)
-
-/* This macro is provided for backward compatibility. */
-#ifndef YY_LOCATION_PRINT
-# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
-#endif
-
-
-# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
-do {                                                                      \
-  if (yydebug)                                                            \
-    {                                                                     \
-      YYFPRINTF (stderr, "%s ", Title);                                   \
-      yy_symbol_print (stderr,                                            \
-                  Type, Value, p); \
-      YYFPRINTF (stderr, "\n");                                           \
-    }                                                                     \
-} while (0)
-
-
-/*----------------------------------------.
-| Print this symbol's value on YYOUTPUT.  |
-`----------------------------------------*/
-
-static void
-yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parseObj *p)
-{
-  FILE *yyo = yyoutput;
-  YYUSE (yyo);
-  YYUSE (p);
-  if (!yyvaluep)
-    return;
-# ifdef YYPRINT
-  if (yytype < YYNTOKENS)
-    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
-# endif
-  YYUSE (yytype);
-}
-
-
-/*--------------------------------.
-| Print this symbol on YYOUTPUT.  |
-`--------------------------------*/
-
-static void
-yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parseObj *p)
-{
-  YYFPRINTF (yyoutput, "%s %s (",
-             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);
-
-  yy_symbol_value_print (yyoutput, yytype, yyvaluep, p);
-  YYFPRINTF (yyoutput, ")");
-}
-
-/*------------------------------------------------------------------.
-| yy_stack_print -- Print the state stack from its BOTTOM up to its |
-| TOP (included).                                                   |
-`------------------------------------------------------------------*/
-
-static void
-yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
-{
-  YYFPRINTF (stderr, "Stack now");
-  for (; yybottom <= yytop; yybottom++)
-    {
-      int yybot = *yybottom;
-      YYFPRINTF (stderr, " %d", yybot);
-    }
-  YYFPRINTF (stderr, "\n");
-}
-
-# define YY_STACK_PRINT(Bottom, Top)                            \
-do {                                                            \
-  if (yydebug)                                                  \
-    yy_stack_print ((Bottom), (Top));                           \
-} while (0)
-
-
-/*------------------------------------------------.
-| Report that the YYRULE is going to be reduced.  |
-`------------------------------------------------*/
-
-static void
-yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, parseObj *p)
-{
-  unsigned long int yylno = yyrline[yyrule];
-  int yynrhs = yyr2[yyrule];
-  int yyi;
-  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
-             yyrule - 1, yylno);
-  /* The symbols being reduced.  */
-  for (yyi = 0; yyi < yynrhs; yyi++)
-    {
-      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
-      yy_symbol_print (stderr,
-                       yystos[yyssp[yyi + 1 - yynrhs]],
-                       &(yyvsp[(yyi + 1) - (yynrhs)])
-                                              , p);
-      YYFPRINTF (stderr, "\n");
-    }
-}
-
-# define YY_REDUCE_PRINT(Rule)          \
-do {                                    \
-  if (yydebug)                          \
-    yy_reduce_print (yyssp, yyvsp, Rule, p); \
-} while (0)
-
-/* Nonzero means print parse trace.  It is left uninitialized so that
-   multiple parsers can coexist.  */
-int yydebug;
-#else /* !YYDEBUG */
-# define YYDPRINTF(Args)
-# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
-# define YY_STACK_PRINT(Bottom, Top)
-# define YY_REDUCE_PRINT(Rule)
-#endif /* !YYDEBUG */
-
-
-/* YYINITDEPTH -- initial size of the parser's stacks.  */
-#ifndef YYINITDEPTH
-# define YYINITDEPTH 200
-#endif
-
-/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
-   if the built-in stack extension method is used).
-
-   Do not make this value too large; the results are undefined if
-   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
-   evaluated with infinite-precision integer arithmetic.  */
-
-#ifndef YYMAXDEPTH
-# define YYMAXDEPTH 10000
-#endif
-
-
-#if YYERROR_VERBOSE
-
-# ifndef yystrlen
-#  if defined __GLIBC__ && defined _STRING_H
-#   define yystrlen strlen
-#  else
-/* Return the length of YYSTR.  */
-static YYSIZE_T
-yystrlen (const char *yystr)
-{
-  YYSIZE_T yylen;
-  for (yylen = 0; yystr[yylen]; yylen++)
-    continue;
-  return yylen;
-}
-#  endif
-# endif
-
-# ifndef yystpcpy
-#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
-#   define yystpcpy stpcpy
-#  else
-/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
-   YYDEST.  */
-static char *
-yystpcpy (char *yydest, const char *yysrc)
-{
-  char *yyd = yydest;
-  const char *yys = yysrc;
-
-  while ((*yyd++ = *yys++) != '\0')
-    continue;
-
-  return yyd - 1;
-}
-#  endif
-# endif
-
-# ifndef yytnamerr
-/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
-   quotes and backslashes, so that it's suitable for yyerror.  The
-   heuristic is that double-quoting is unnecessary unless the string
-   contains an apostrophe, a comma, or backslash (other than
-   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
-   null, do not copy; instead, return the length of what the result
-   would have been.  */
-static YYSIZE_T
-yytnamerr (char *yyres, const char *yystr)
-{
-  if (*yystr == '"')
-    {
-      YYSIZE_T yyn = 0;
-      char const *yyp = yystr;
-
-      for (;;)
-        switch (*++yyp)
-          {
-          case '\'':
-          case ',':
-            goto do_not_strip_quotes;
-
-          case '\\':
-            if (*++yyp != '\\')
-              goto do_not_strip_quotes;
-            /* Fall through.  */
-          default:
-            if (yyres)
-              yyres[yyn] = *yyp;
-            yyn++;
-            break;
-
-          case '"':
-            if (yyres)
-              yyres[yyn] = '\0';
-            return yyn;
-          }
-    do_not_strip_quotes: ;
-    }
-
-  if (! yyres)
-    return yystrlen (yystr);
-
-  return yystpcpy (yyres, yystr) - yyres;
-}
-# endif
-
-/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
-   about the unexpected token YYTOKEN for the state stack whose top is
-   YYSSP.
-
-   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
-   not large enough to hold the message.  In that case, also set
-   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
-   required number of bytes is too large to store.  */
-static int
-yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
-                yytype_int16 *yyssp, int yytoken)
-{
-  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
-  YYSIZE_T yysize = yysize0;
-  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
-  /* Internationalized format string. */
-  const char *yyformat = YY_NULLPTR;
-  /* Arguments of yyformat. */
-  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
-  /* Number of reported tokens (one for the "unexpected", one per
-     "expected"). */
-  int yycount = 0;
-
-  /* There are many possibilities here to consider:
-     - If this state is a consistent state with a default action, then
-       the only way this function was invoked is if the default action
-       is an error action.  In that case, don't check for expected
-       tokens because there are none.
-     - The only way there can be no lookahead present (in yychar) is if
-       this state is a consistent state with a default action.  Thus,
-       detecting the absence of a lookahead is sufficient to determine
-       that there is no unexpected or expected token to report.  In that
-       case, just report a simple "syntax error".
-     - Don't assume there isn't a lookahead just because this state is a
-       consistent state with a default action.  There might have been a
-       previous inconsistent state, consistent state with a non-default
-       action, or user semantic action that manipulated yychar.
-     - Of course, the expected token list depends on states to have
-       correct lookahead information, and it depends on the parser not
-       to perform extra reductions after fetching a lookahead from the
-       scanner and before detecting a syntax error.  Thus, state merging
-       (from LALR or IELR) and default reductions corrupt the expected
-       token list.  However, the list is correct for canonical LR with
-       one exception: it will still contain any token that will not be
-       accepted due to an error action in a later state.
-  */
-  if (yytoken != YYEMPTY)
-    {
-      int yyn = yypact[*yyssp];
-      yyarg[yycount++] = yytname[yytoken];
-      if (!yypact_value_is_default (yyn))
-        {
-          /* Start YYX at -YYN if negative to avoid negative indexes in
-             YYCHECK.  In other words, skip the first -YYN actions for
-             this state because they are default actions.  */
-          int yyxbegin = yyn < 0 ? -yyn : 0;
-          /* Stay within bounds of both yycheck and yytname.  */
-          int yychecklim = YYLAST - yyn + 1;
-          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
-          int yyx;
-
-          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
-            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
-                && !yytable_value_is_error (yytable[yyx + yyn]))
-              {
-                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
-                  {
-                    yycount = 1;
-                    yysize = yysize0;
-                    break;
-                  }
-                yyarg[yycount++] = yytname[yyx];
-                {
-                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
-                  if (! (yysize <= yysize1
-                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
-                    return 2;
-                  yysize = yysize1;
-                }
-              }
-        }
-    }
-
-  switch (yycount)
-    {
-# define YYCASE_(N, S)                      \
-      case N:                               \
-        yyformat = S;                       \
-      break
-      YYCASE_(0, YY_("syntax error"));
-      YYCASE_(1, YY_("syntax error, unexpected %s"));
-      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
-      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
-      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
-      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
-# undef YYCASE_
-    }
-
-  {
-    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
-    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
-      return 2;
-    yysize = yysize1;
-  }
-
-  if (*yymsg_alloc < yysize)
-    {
-      *yymsg_alloc = 2 * yysize;
-      if (! (yysize <= *yymsg_alloc
-             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
-        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
-      return 1;
-    }
-
-  /* Avoid sprintf, as that infringes on the user's name space.
-     Don't have undefined behavior even if the translation
-     produced a string with the wrong number of "%s"s.  */
-  {
-    char *yyp = *yymsg;
-    int yyi = 0;
-    while ((*yyp = *yyformat) != '\0')
-      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
-        {
-          yyp += yytnamerr (yyp, yyarg[yyi++]);
-          yyformat += 2;
-        }
-      else
-        {
-          yyp++;
-          yyformat++;
-        }
-  }
-  return 0;
-}
-#endif /* YYERROR_VERBOSE */
-
-/*-----------------------------------------------.
-| Release the memory associated to this symbol.  |
-`-----------------------------------------------*/
-
-static void
-yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parseObj *p)
-{
-  YYUSE (yyvaluep);
-  YYUSE (p);
-  if (!yymsg)
-    yymsg = "Deleting";
-  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);
-
-  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
-  YYUSE (yytype);
-  YY_IGNORE_MAYBE_UNINITIALIZED_END
-}
-
-
-
-
-/*----------.
-| yyparse.  |
-`----------*/
-
-int
-yyparse (parseObj *p)
-{
-/* The lookahead symbol.  */
-int yychar;
-
-
-/* The semantic value of the lookahead symbol.  */
-/* Default value used for initialization, for pacifying older GCCs
-   or non-GCC compilers.  */
-YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
-YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);
-
-    /* Number of syntax errors so far.  */
-    int yynerrs;
-
-    int yystate;
-    /* Number of tokens to shift before error messages enabled.  */
-    int yyerrstatus;
-
-    /* The stacks and their tools:
-       'yyss': related to states.
-       'yyvs': related to semantic values.
-
-       Refer to the stacks through separate pointers, to allow yyoverflow
-       to reallocate them elsewhere.  */
-
-    /* The state stack.  */
-    yytype_int16 yyssa[YYINITDEPTH];
-    yytype_int16 *yyss;
-    yytype_int16 *yyssp;
-
-    /* The semantic value stack.  */
-    YYSTYPE yyvsa[YYINITDEPTH];
-    YYSTYPE *yyvs;
-    YYSTYPE *yyvsp;
-
-    YYSIZE_T yystacksize;
-
-  int yyn;
-  int yyresult;
-  /* Lookahead token as an internal (translated) token number.  */
-  int yytoken = 0;
-  /* The variables used to return semantic value and location from the
-     action routines.  */
-  YYSTYPE yyval;
-
-#if YYERROR_VERBOSE
-  /* Buffer for error messages, and its allocated size.  */
-  char yymsgbuf[128];
-  char *yymsg = yymsgbuf;
-  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
-#endif
-
-#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))
-
-  /* The number of symbols on the RHS of the reduced rule.
-     Keep to zero when no symbol should be popped.  */
-  int yylen = 0;
-
-  yyssp = yyss = yyssa;
-  yyvsp = yyvs = yyvsa;
-  yystacksize = YYINITDEPTH;
-
-  YYDPRINTF ((stderr, "Starting parse\n"));
-
-  yystate = 0;
-  yyerrstatus = 0;
-  yynerrs = 0;
-  yychar = YYEMPTY; /* Cause a token to be read.  */
-  goto yysetstate;
-
-/*------------------------------------------------------------.
-| yynewstate -- Push a new state, which is found in yystate.  |
-`------------------------------------------------------------*/
- yynewstate:
-  /* In all cases, when you get here, the value and location stacks
-     have just been pushed.  So pushing a state here evens the stacks.  */
-  yyssp++;
-
- yysetstate:
-  *yyssp = yystate;
-
-  if (yyss + yystacksize - 1 <= yyssp)
-    {
-      /* Get the current used size of the three stacks, in elements.  */
-      YYSIZE_T yysize = yyssp - yyss + 1;
-
-#ifdef yyoverflow
-      {
-        /* Give user a chance to reallocate the stack.  Use copies of
-           these so that the &'s don't force the real ones into
-           memory.  */
-        YYSTYPE *yyvs1 = yyvs;
-        yytype_int16 *yyss1 = yyss;
-
-        /* Each stack pointer address is followed by the size of the
-           data in use in that stack, in bytes.  This used to be a
-           conditional around just the two extra args, but that might
-           be undefined if yyoverflow is a macro.  */
-        yyoverflow (YY_("memory exhausted"),
-                    &yyss1, yysize * sizeof (*yyssp),
-                    &yyvs1, yysize * sizeof (*yyvsp),
-                    &yystacksize);
-
-        yyss = yyss1;
-        yyvs = yyvs1;
-      }
-#else /* no yyoverflow */
-# ifndef YYSTACK_RELOCATE
-      goto yyexhaustedlab;
-# else
-      /* Extend the stack our own way.  */
-      if (YYMAXDEPTH <= yystacksize)
-        goto yyexhaustedlab;
-      yystacksize *= 2;
-      if (YYMAXDEPTH < yystacksize)
-        yystacksize = YYMAXDEPTH;
-
-      {
-        yytype_int16 *yyss1 = yyss;
-        union yyalloc *yyptr =
-          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
-        if (! yyptr)
-          goto yyexhaustedlab;
-        YYSTACK_RELOCATE (yyss_alloc, yyss);
-        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
-#  undef YYSTACK_RELOCATE
-        if (yyss1 != yyssa)
-          YYSTACK_FREE (yyss1);
-      }
-# endif
-#endif /* no yyoverflow */
-
-      yyssp = yyss + yysize - 1;
-      yyvsp = yyvs + yysize - 1;
-
-      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
-                  (unsigned long int) yystacksize));
-
-      if (yyss + yystacksize - 1 <= yyssp)
-        YYABORT;
-    }
-
-  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
-
-  if (yystate == YYFINAL)
-    YYACCEPT;
-
-  goto yybackup;
-
-/*-----------.
-| yybackup.  |
-`-----------*/
-yybackup:
-
-  /* Do appropriate processing given the current state.  Read a
-     lookahead token if we need one and don't already have one.  */
-
-  /* First try to decide what to do without reference to lookahead token.  */
-  yyn = yypact[yystate];
-  if (yypact_value_is_default (yyn))
-    goto yydefault;
-
-  /* Not known => get a lookahead token if don't already have one.  */
-
-  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
-  if (yychar == YYEMPTY)
-    {
-      YYDPRINTF ((stderr, "Reading a token: "));
-      yychar = yylex (&yylval, p);
-    }
-
-  if (yychar <= YYEOF)
-    {
-      yychar = yytoken = YYEOF;
-      YYDPRINTF ((stderr, "Now at end of input.\n"));
-    }
-  else
-    {
-      yytoken = YYTRANSLATE (yychar);
-      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
-    }
-
-  /* If the proper action on seeing token YYTOKEN is to reduce or to
-     detect an error, take that action.  */
-  yyn += yytoken;
-  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
-    goto yydefault;
-  yyn = yytable[yyn];
-  if (yyn <= 0)
-    {
-      if (yytable_value_is_error (yyn))
-        goto yyerrlab;
-      yyn = -yyn;
-      goto yyreduce;
-    }
-
-  /* Count tokens shifted since error; after three, turn off error
-     status.  */
-  if (yyerrstatus)
-    yyerrstatus--;
-
-  /* Shift the lookahead token.  */
-  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
-
-  /* Discard the shifted token.  */
-  yychar = YYEMPTY;
-
-  yystate = yyn;
-  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
-  *++yyvsp = yylval;
-  YY_IGNORE_MAYBE_UNINITIALIZED_END
-
-  goto yynewstate;
-
-
-/*-----------------------------------------------------------.
-| yydefault -- do the default action for the current state.  |
-`-----------------------------------------------------------*/
-yydefault:
-  yyn = yydefact[yystate];
-  if (yyn == 0)
-    goto yyerrlab;
-  goto yyreduce;
-
-
-/*-----------------------------.
-| yyreduce -- Do a reduction.  |
-`-----------------------------*/
-yyreduce:
-  /* yyn is the number of a rule to reduce with.  */
-  yylen = yyr2[yyn];
-
-  /* If YYLEN is nonzero, implement the default value of the action:
-     '$$ = $1'.
-
-     Otherwise, the following line sets YYVAL to garbage.
-     This behavior is undocumented and Bison
-     users should not rely upon it.  Assigning to YYVAL
-     unconditionally makes the parser a bit smaller, and it avoids a
-     GCC warning that YYVAL may be used uninitialized.  */
-  yyval = yyvsp[1-yylen];
-
-
-  YY_REDUCE_PRINT (yyn);
-  switch (yyn)
-    {
-        case 3:
-#line 69 "mapparser.y" /* yacc.c:1646  */
-    {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_BOOLEAN):
-      p->result.intval = (yyvsp[0].intval); 
-      break;
-    case(MS_PARSE_TYPE_STRING):
-      if((yyvsp[0].intval)) 
-        p->result.strval = msStrdup("true");
-      else
-        p->result.strval = msStrdup("false");
-      break;
-    }
-  }
-#line 1580 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 4:
-#line 82 "mapparser.y" /* yacc.c:1646  */
-    {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_BOOLEAN):
-      if((yyvsp[0].dblval) != 0)
-        p->result.intval = MS_TRUE;
-      else
-        p->result.intval = MS_FALSE;			    
-      break;
-    case(MS_PARSE_TYPE_STRING):
-      p->result.strval = (char *)malloc(64); /* large enough for a double */
-      snprintf(p->result.strval, 64, "%g", (yyvsp[0].dblval));
-      break;
-    }
-  }
-#line 1599 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 5:
-#line 96 "mapparser.y" /* yacc.c:1646  */
-    {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_BOOLEAN):
-      if((yyvsp[0].strval)) /* string is not NULL */
-        p->result.intval = MS_TRUE;
-      else
-        p->result.intval = MS_FALSE;
-      break;
-    case(MS_PARSE_TYPE_SLD):
-    case(MS_PARSE_TYPE_STRING):
-      p->result.strval = (yyvsp[0].strval); // msStrdup($1);
-      break;
-    }
-  }
-#line 1618 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 6:
-#line 110 "mapparser.y" /* yacc.c:1646  */
-    {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_SHAPE):
-      p->result.shpval = (yyvsp[0].shpval);
-      p->result.shpval->scratch = MS_FALSE;
-      break;
-    }
-  }
-#line 1631 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 8:
-#line 121 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.intval) = (yyvsp[-1].intval); }
-#line 1637 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 9:
-#line 122 "mapparser.y" /* yacc.c:1646  */
-    {
-    (yyval.intval) = MS_FALSE;
-    if((yyvsp[-2].intval) == (yyvsp[0].intval)) (yyval.intval) = MS_TRUE;
-  }
-#line 1646 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 10:
-#line 126 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].intval) == MS_TRUE)
-      (yyval.intval) = MS_TRUE;
-    else if((yyvsp[0].intval) == MS_TRUE)          
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1659 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 11:
-#line 134 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].intval) == MS_TRUE) {
-      if((yyvsp[0].intval) == MS_TRUE)
-        (yyval.intval) = MS_TRUE;
-      else
-        (yyval.intval) = MS_FALSE;
-    } else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1673 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 12:
-#line 143 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].intval) == MS_TRUE)
-      (yyval.intval) = MS_TRUE;
-    else if((yyvsp[0].dblval) != 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1686 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 13:
-#line 151 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].intval) == MS_TRUE) {
-      if((yyvsp[0].dblval) != 0)
-        (yyval.intval) = MS_TRUE;
-      else
-        (yyval.intval) = MS_FALSE;
-    } else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1700 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 14:
-#line 160 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) != 0)
-      (yyval.intval) = MS_TRUE;
-    else if((yyvsp[0].intval) == MS_TRUE)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1713 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 15:
-#line 168 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) != 0) {
-      if((yyvsp[0].intval) == MS_TRUE)
-        (yyval.intval) = MS_TRUE;
-      else
-        (yyval.intval) = MS_FALSE;
-    } else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1727 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 16:
-#line 177 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) != 0)
-      (yyval.intval) = MS_TRUE;
-    else if((yyvsp[0].dblval) != 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1740 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 17:
-#line 185 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) != 0) {
-      if((yyvsp[0].dblval) != 0)
-        (yyval.intval) = MS_TRUE;
-      else
-	(yyval.intval) = MS_FALSE;
-    } else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1754 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 18:
-#line 194 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.intval) = !(yyvsp[0].intval); }
-#line 1760 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 19:
-#line 195 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.intval) = !(yyvsp[0].dblval); }
-#line 1766 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 20:
-#line 196 "mapparser.y" /* yacc.c:1646  */
-    {
-    ms_regex_t re;
-
-    if(MS_STRING_IS_NULL_OR_EMPTY((yyvsp[-2].strval)) == MS_TRUE) {
-      (yyval.intval) = MS_FALSE;
-    } else {
-      if(ms_regcomp(&re, (yyvsp[0].strval), MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {      
-        (yyval.intval) = MS_FALSE;
-      } else {
-        if(ms_regexec(&re, (yyvsp[-2].strval), 0, NULL, 0) == 0)
-          (yyval.intval) = MS_TRUE;
-        else
-          (yyval.intval) = MS_FALSE;
-        ms_regfree(&re);
-      }
-    }
-
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1791 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 21:
-#line 216 "mapparser.y" /* yacc.c:1646  */
-    {
-    ms_regex_t re;
-
-    if(MS_STRING_IS_NULL_OR_EMPTY((yyvsp[-2].strval)) == MS_TRUE) {
-      (yyval.intval) = MS_FALSE;
-    } else {
-      if(ms_regcomp(&re, (yyvsp[0].strval), MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
-        (yyval.intval) = MS_FALSE;
-      } else {
-        if(ms_regexec(&re, (yyvsp[-2].strval), 0, NULL, 0) == 0)
-          (yyval.intval) = MS_TRUE;
-        else
-          (yyval.intval) = MS_FALSE;
-        ms_regfree(&re);
-      }
-    }
-
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1816 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 22:
-#line 236 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) == (yyvsp[0].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1827 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 23:
-#line 242 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) != (yyvsp[0].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1838 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 24:
-#line 248 "mapparser.y" /* yacc.c:1646  */
-    {    
-    if((yyvsp[-2].dblval) > (yyvsp[0].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1849 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 25:
-#line 254 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) < (yyvsp[0].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1860 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 26:
-#line 260 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) >= (yyvsp[0].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1871 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 27:
-#line 266 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) <= (yyvsp[0].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1882 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 28:
-#line 272 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) == 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1895 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 29:
-#line 280 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) != 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1908 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 30:
-#line 288 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) > 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1921 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 31:
-#line 296 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) < 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1934 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 32:
-#line 304 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) >= 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1947 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 33:
-#line 312 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) <= 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 1960 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 34:
-#line 320 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) == 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1971 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 35:
-#line 326 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) != 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1982 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 36:
-#line 332 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) > 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 1993 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 37:
-#line 338 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) < 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 2004 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 38:
-#line 344 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) >= 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 2015 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 39:
-#line 350 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) <= 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 2026 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 40:
-#line 356 "mapparser.y" /* yacc.c:1646  */
-    {
-    char *delim, *bufferp;
-
-    (yyval.intval) = MS_FALSE;
-    bufferp=(yyvsp[0].strval);
-
-    while((delim=strchr(bufferp,',')) != NULL) {
-      *delim='\0';
-      if(strcmp((yyvsp[-2].strval),bufferp) == 0) {
-        (yyval.intval) = MS_TRUE;
-        break;
-      } 
-      *delim=',';
-      bufferp=delim+1;
-    }
-
-    if((yyval.intval) == MS_FALSE && strcmp((yyvsp[-2].strval),bufferp) == 0) // test for last (or only) item
-      (yyval.intval) = MS_TRUE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 2052 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 41:
-#line 377 "mapparser.y" /* yacc.c:1646  */
-    {
-    char *delim,*bufferp;
-
-    (yyval.intval) = MS_FALSE;
-    bufferp=(yyvsp[0].strval);
-
-    while((delim=strchr(bufferp,',')) != NULL) {
-      *delim='\0';
-      if((yyvsp[-2].dblval) == atof(bufferp)) {
-        (yyval.intval) = MS_TRUE;
-        break;
-      } 
-      *delim=',';
-      bufferp=delim+1;
-    }
-
-    if((yyvsp[-2].dblval) == atof(bufferp)) // is this test necessary?
-      (yyval.intval) = MS_TRUE;  
-    free((yyvsp[0].strval));
-  }
-#line 2077 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 42:
-#line 397 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-2].dblval) == (yyvsp[0].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 2088 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 43:
-#line 403 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(strcasecmp((yyvsp[-2].strval), (yyvsp[0].strval)) == 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-    free((yyvsp[-2].strval));
-    free((yyvsp[0].strval));
-  }
-#line 2101 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 44:
-#line 411 "mapparser.y" /* yacc.c:1646  */
-    {
-    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) == 0)
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 2112 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 45:
-#line 417 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSEquals((yyvsp[-2].shpval), (yyvsp[0].shpval));
-    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-2].shpval));
-      free((yyvsp[-2].shpval));
-    }
-    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[0].shpval));
-      free((yyvsp[0].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Equals (EQ or ==) operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2134 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 46:
-#line 434 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSEquals((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Equals function failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2156 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 47:
-#line 451 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSIntersects((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Intersects function failed.");
-      return(-1);
-    } else
-    (yyval.intval) = rval;
-  }
-#line 2178 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 48:
-#line 468 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSIntersects((yyvsp[-2].shpval), (yyvsp[0].shpval));
-    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-2].shpval));
-      free((yyvsp[-2].shpval));
-    }
-    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[0].shpval));
-      free((yyvsp[0].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Intersects operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2200 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 49:
-#line 485 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSDisjoint((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Disjoint function failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2222 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 50:
-#line 502 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSDisjoint((yyvsp[-2].shpval), (yyvsp[0].shpval));
-    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-2].shpval));
-      free((yyvsp[-2].shpval));
-    }
-    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[0].shpval));
-      free((yyvsp[0].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Disjoint operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2244 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 51:
-#line 519 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSTouches((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Touches function failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2266 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 52:
-#line 536 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSTouches((yyvsp[-2].shpval), (yyvsp[0].shpval));
-    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-2].shpval));
-      free((yyvsp[-2].shpval));
-    }
-    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[0].shpval));
-      free((yyvsp[0].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Touches operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2288 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 53:
-#line 553 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSOverlaps((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Overlaps function failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2310 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 54:
-#line 570 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-     rval = msGEOSOverlaps((yyvsp[-2].shpval), (yyvsp[0].shpval));
-     if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-       msFreeShape((yyvsp[-2].shpval));
-       free((yyvsp[-2].shpval));
-     }
-     if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-       msFreeShape((yyvsp[0].shpval));
-       free((yyvsp[0].shpval));
-     }
-    if(rval == -1) {
-      yyerror(p, "Overlaps operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2332 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 55:
-#line 587 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSCrosses((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Crosses function failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2354 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 56:
-#line 604 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSCrosses((yyvsp[-2].shpval), (yyvsp[0].shpval));
-    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-2].shpval));
-      free((yyvsp[-2].shpval));
-    }
-    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[0].shpval));
-      free((yyvsp[0].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Crosses operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2376 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 57:
-#line 621 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSWithin((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Within function failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2398 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 58:
-#line 638 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSWithin((yyvsp[-2].shpval), (yyvsp[0].shpval));
-    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-2].shpval));
-      free((yyvsp[-2].shpval));
-    }
-    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[0].shpval));
-      free((yyvsp[0].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Within operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2420 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 59:
-#line 655 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSContains((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Contains function failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2442 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 60:
-#line 672 "mapparser.y" /* yacc.c:1646  */
-    {
-    int rval;
-    rval = msGEOSContains((yyvsp[-2].shpval), (yyvsp[0].shpval));
-    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-2].shpval));
-      free((yyvsp[-2].shpval));
-    }
-    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[0].shpval));
-      free((yyvsp[0].shpval));
-    }
-    if(rval == -1) {
-      yyerror(p, "Contains operator failed.");
-      return(-1);
-    } else
-      (yyval.intval) = rval;
-  }
-#line 2464 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 61:
-#line 689 "mapparser.y" /* yacc.c:1646  */
-    {
-    double d;
-    d = msGEOSDistance((yyvsp[-5].shpval), (yyvsp[-3].shpval));
-    if((yyvsp[-5].shpval) && (yyvsp[-5].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-5].shpval));
-      free((yyvsp[-5].shpval));
-    }
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(d <= (yyvsp[-1].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 2485 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 62:
-#line 705 "mapparser.y" /* yacc.c:1646  */
-    {
-    double d;
-    d = msGEOSDistance((yyvsp[-5].shpval), (yyvsp[-3].shpval));
-    if((yyvsp[-5].shpval) && (yyvsp[-5].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-5].shpval));
-      free((yyvsp[-5].shpval));
-    }
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(d > (yyvsp[-1].dblval))
-      (yyval.intval) = MS_TRUE;
-    else
-      (yyval.intval) = MS_FALSE;
-  }
-#line 2506 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 64:
-#line 724 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (yyvsp[-1].dblval); }
-#line 2512 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 65:
-#line 725 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (yyvsp[-2].dblval) + (yyvsp[0].dblval); }
-#line 2518 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 66:
-#line 726 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (yyvsp[-2].dblval) - (yyvsp[0].dblval); }
-#line 2524 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 67:
-#line 727 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (yyvsp[-2].dblval) * (yyvsp[0].dblval); }
-#line 2530 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 68:
-#line 728 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (int)(yyvsp[-2].dblval) % (int)(yyvsp[0].dblval); }
-#line 2536 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 69:
-#line 729 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[0].dblval) == 0.0) {
-      yyerror(p, "Division by zero.");
-      return(-1);
-    } else
-      (yyval.dblval) = (yyvsp[-2].dblval) / (yyvsp[0].dblval); 
-  }
-#line 2548 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 70:
-#line 736 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (yyvsp[0].dblval); }
-#line 2554 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 71:
-#line 737 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = pow((yyvsp[-2].dblval), (yyvsp[0].dblval)); }
-#line 2560 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 72:
-#line 738 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = strlen((yyvsp[-1].strval)); }
-#line 2566 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 73:
-#line 739 "mapparser.y" /* yacc.c:1646  */
-    {
-    if((yyvsp[-1].shpval)->type != MS_SHAPE_POLYGON) {
-      yyerror(p, "Area can only be computed for polygon shapes.");
-      return(-1);
-    }
-    (yyval.dblval) = msGetPolygonArea((yyvsp[-1].shpval));
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-  }
-#line 2582 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 74:
-#line 750 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (MS_NINT((yyvsp[-3].dblval)/(yyvsp[-1].dblval)))*(yyvsp[-1].dblval); }
-#line 2588 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 75:
-#line 751 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.dblval) = (MS_NINT((yyvsp[-1].dblval))); }
-#line 2594 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 77:
-#line 755 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.shpval) = (yyvsp[-1].shpval); }
-#line 2600 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 78:
-#line 756 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msGEOSBuffer((yyvsp[-3].shpval), (yyvsp[-1].dblval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing buffer failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2619 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 79:
-#line 770 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msRings2Shape((yyvsp[-1].shpval), MS_FALSE);
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing inner failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2638 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 80:
-#line 784 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msRings2Shape((yyvsp[-1].shpval), MS_TRUE);
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing outer failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2657 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 81:
-#line 798 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msGEOSCenterline((yyvsp[-1].shpval));
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing centerline failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2676 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 82:
-#line 812 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msGEOSDifference((yyvsp[-3].shpval), (yyvsp[-1].shpval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing difference failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2695 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 83:
-#line 826 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msDensify((yyvsp[-3].shpval), (yyvsp[-1].dblval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing densify failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2714 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 84:
-#line 840 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msGEOSSimplify((yyvsp[-3].shpval), (yyvsp[-1].dblval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing simplify failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2733 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 85:
-#line 854 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msGEOSTopologyPreservingSimplify((yyvsp[-3].shpval), (yyvsp[-1].dblval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing simplifypt failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2752 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 86:
-#line 868 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msGeneralize((yyvsp[-3].shpval), (yyvsp[-1].dblval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing generalize failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2771 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 87:
-#line 882 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msSmoothShapeSIA((yyvsp[-1].shpval), 3, 1, NULL);
-    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-1].shpval));
-      free((yyvsp[-1].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2790 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 88:
-#line 896 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msSmoothShapeSIA((yyvsp[-3].shpval), (yyvsp[-1].dblval), 1, NULL);
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2809 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 89:
-#line 910 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msSmoothShapeSIA((yyvsp[-5].shpval), (yyvsp[-3].dblval), (yyvsp[-1].dblval), NULL);
-    if((yyvsp[-5].shpval) && (yyvsp[-5].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-5].shpval));
-      free((yyvsp[-5].shpval));
-    }
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2828 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 90:
-#line 924 "mapparser.y" /* yacc.c:1646  */
-    {
-    shapeObj *s;
-    s = msSmoothShapeSIA((yyvsp[-7].shpval), (yyvsp[-5].dblval), (yyvsp[-3].dblval), (yyvsp[-1].strval));
-    if((yyvsp[-7].shpval) && (yyvsp[-7].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-7].shpval));
-      free((yyvsp[-7].shpval));
-    }
-    free((yyvsp[-1].strval));
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-  }
-#line 2848 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 91:
-#line 939 "mapparser.y" /* yacc.c:1646  */
-    {
-#ifdef USE_V8_MAPSCRIPT
-    shapeObj *s;
-    s = msV8TransformShape((yyvsp[-3].shpval), (yyvsp[-1].strval));
-    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
-      msFreeShape((yyvsp[-3].shpval));
-      free((yyvsp[-3].shpval));
-    }
-    free((yyvsp[-1].strval));
-    if(!s) {
-      yyerror(p, "Executing javascript failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    (yyval.shpval) = s;
-#else
-    yyerror(p, "Javascript support not compiled in");
-    return(-1);
-#endif
-  }
-#line 2873 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 93:
-#line 962 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.strval) = (yyvsp[-1].strval); }
-#line 2879 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 94:
-#line 963 "mapparser.y" /* yacc.c:1646  */
-    { 
-    (yyval.strval) = (char *)malloc(strlen((yyvsp[-2].strval)) + strlen((yyvsp[0].strval)) + 1);
-    sprintf((yyval.strval), "%s%s", (yyvsp[-2].strval), (yyvsp[0].strval)); free((yyvsp[-2].strval)); free((yyvsp[0].strval)); 
-  }
-#line 2888 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 95:
-#line 967 "mapparser.y" /* yacc.c:1646  */
-    {
-    (yyval.strval) = (char *) malloc(strlen((yyvsp[-1].strval)) + 64); /* Plenty big? Should use snprintf below... */
-    sprintf((yyval.strval), (yyvsp[-1].strval), (yyvsp[-3].dblval));
-    free((yyvsp[-1].strval));
-  }
-#line 2898 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 96:
-#line 972 "mapparser.y" /* yacc.c:1646  */
-    {  
-    (yyvsp[-1].strval) = msCommifyString((yyvsp[-1].strval)); 
-    (yyval.strval) = (yyvsp[-1].strval); 
-  }
-#line 2907 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 97:
-#line 976 "mapparser.y" /* yacc.c:1646  */
-    {  
-    msStringToUpper((yyvsp[-1].strval)); 
-    (yyval.strval) = (yyvsp[-1].strval); 
-  }
-#line 2916 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 98:
-#line 980 "mapparser.y" /* yacc.c:1646  */
-    {  
-    msStringToLower((yyvsp[-1].strval)); 
-    (yyval.strval) = (yyvsp[-1].strval); 
-  }
-#line 2925 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 99:
-#line 984 "mapparser.y" /* yacc.c:1646  */
-    {  
-    msStringInitCap((yyvsp[-1].strval)); 
-    (yyval.strval) = (yyvsp[-1].strval); 
-  }
-#line 2934 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 100:
-#line 988 "mapparser.y" /* yacc.c:1646  */
-    {  
-    msStringFirstCap((yyvsp[-1].strval)); 
-    (yyval.strval) = (yyvsp[-1].strval); 
-  }
-#line 2943 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-  case 102:
-#line 995 "mapparser.y" /* yacc.c:1646  */
-    { (yyval.tmval) = (yyvsp[-1].tmval); }
-#line 2949 "/vagrant/mapparser.c" /* yacc.c:1646  */
-    break;
-
-
-#line 2953 "/vagrant/mapparser.c" /* yacc.c:1646  */
-      default: break;
-    }
-  /* User semantic actions sometimes alter yychar, and that requires
-     that yytoken be updated with the new translation.  We take the
-     approach of translating immediately before every use of yytoken.
-     One alternative is translating here after every semantic action,
-     but that translation would be missed if the semantic action invokes
-     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
-     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
-     incorrect destructor might then be invoked immediately.  In the
-     case of YYERROR or YYBACKUP, subsequent parser actions might lead
-     to an incorrect destructor call or verbose syntax error message
-     before the lookahead is translated.  */
-  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);
-
-  YYPOPSTACK (yylen);
-  yylen = 0;
-  YY_STACK_PRINT (yyss, yyssp);
-
-  *++yyvsp = yyval;
-
-  /* Now 'shift' the result of the reduction.  Determine what state
-     that goes to, based on the state we popped back to and the rule
-     number reduced by.  */
-
-  yyn = yyr1[yyn];
-
-  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
-  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
-    yystate = yytable[yystate];
-  else
-    yystate = yydefgoto[yyn - YYNTOKENS];
-
-  goto yynewstate;
-
-
-/*--------------------------------------.
-| yyerrlab -- here on detecting error.  |
-`--------------------------------------*/
-yyerrlab:
-  /* Make sure we have latest lookahead translation.  See comments at
-     user semantic actions for why this is necessary.  */
-  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);
-
-  /* If not already recovering from an error, report this error.  */
-  if (!yyerrstatus)
-    {
-      ++yynerrs;
-#if ! YYERROR_VERBOSE
-      yyerror (p, YY_("syntax error"));
-#else
-# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
-                                        yyssp, yytoken)
-      {
-        char const *yymsgp = YY_("syntax error");
-        int yysyntax_error_status;
-        yysyntax_error_status = YYSYNTAX_ERROR;
-        if (yysyntax_error_status == 0)
-          yymsgp = yymsg;
-        else if (yysyntax_error_status == 1)
-          {
-            if (yymsg != yymsgbuf)
-              YYSTACK_FREE (yymsg);
-            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
-            if (!yymsg)
-              {
-                yymsg = yymsgbuf;
-                yymsg_alloc = sizeof yymsgbuf;
-                yysyntax_error_status = 2;
-              }
-            else
-              {
-                yysyntax_error_status = YYSYNTAX_ERROR;
-                yymsgp = yymsg;
-              }
-          }
-        yyerror (p, yymsgp);
-        if (yysyntax_error_status == 2)
-          goto yyexhaustedlab;
-      }
-# undef YYSYNTAX_ERROR
-#endif
-    }
-
-
-
-  if (yyerrstatus == 3)
-    {
-      /* If just tried and failed to reuse lookahead token after an
-         error, discard it.  */
-
-      if (yychar <= YYEOF)
-        {
-          /* Return failure if at end of input.  */
-          if (yychar == YYEOF)
-            YYABORT;
-        }
-      else
-        {
-          yydestruct ("Error: discarding",
-                      yytoken, &yylval, p);
-          yychar = YYEMPTY;
-        }
-    }
-
-  /* Else will try to reuse lookahead token after shifting the error
-     token.  */
-  goto yyerrlab1;
-
-
-/*---------------------------------------------------.
-| yyerrorlab -- error raised explicitly by YYERROR.  |
-`---------------------------------------------------*/
-yyerrorlab:
-
-  /* Pacify compilers like GCC when the user code never invokes
-     YYERROR and the label yyerrorlab therefore never appears in user
-     code.  */
-  if (/*CONSTCOND*/ 0)
-     goto yyerrorlab;
-
-  /* Do not reclaim the symbols of the rule whose action triggered
-     this YYERROR.  */
-  YYPOPSTACK (yylen);
-  yylen = 0;
-  YY_STACK_PRINT (yyss, yyssp);
-  yystate = *yyssp;
-  goto yyerrlab1;
-
-
-/*-------------------------------------------------------------.
-| yyerrlab1 -- common code for both syntax error and YYERROR.  |
-`-------------------------------------------------------------*/
-yyerrlab1:
-  yyerrstatus = 3;      /* Each real token shifted decrements this.  */
-
-  for (;;)
-    {
-      yyn = yypact[yystate];
-      if (!yypact_value_is_default (yyn))
-        {
-          yyn += YYTERROR;
-          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
-            {
-              yyn = yytable[yyn];
-              if (0 < yyn)
-                break;
-            }
-        }
-
-      /* Pop the current state because it cannot handle the error token.  */
-      if (yyssp == yyss)
-        YYABORT;
-
-
-      yydestruct ("Error: popping",
-                  yystos[yystate], yyvsp, p);
-      YYPOPSTACK (1);
-      yystate = *yyssp;
-      YY_STACK_PRINT (yyss, yyssp);
-    }
-
-  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
-  *++yyvsp = yylval;
-  YY_IGNORE_MAYBE_UNINITIALIZED_END
-
-
-  /* Shift the error token.  */
-  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);
-
-  yystate = yyn;
-  goto yynewstate;
-
-
-/*-------------------------------------.
-| yyacceptlab -- YYACCEPT comes here.  |
-`-------------------------------------*/
-yyacceptlab:
-  yyresult = 0;
-  goto yyreturn;
-
-/*-----------------------------------.
-| yyabortlab -- YYABORT comes here.  |
-`-----------------------------------*/
-yyabortlab:
-  yyresult = 1;
-  goto yyreturn;
-
-#if !defined yyoverflow || YYERROR_VERBOSE
-/*-------------------------------------------------.
-| yyexhaustedlab -- memory exhaustion comes here.  |
-`-------------------------------------------------*/
-yyexhaustedlab:
-  yyerror (p, YY_("memory exhausted"));
-  yyresult = 2;
-  /* Fall through.  */
-#endif
-
-yyreturn:
-  if (yychar != YYEMPTY)
-    {
-      /* Make sure we have latest lookahead translation.  See comments at
-         user semantic actions for why this is necessary.  */
-      yytoken = YYTRANSLATE (yychar);
-      yydestruct ("Cleanup: discarding lookahead",
-                  yytoken, &yylval, p);
-    }
-  /* Do not reclaim the symbols of the rule whose action triggered
-     this YYABORT or YYACCEPT.  */
-  YYPOPSTACK (yylen);
-  YY_STACK_PRINT (yyss, yyssp);
-  while (yyssp != yyss)
-    {
-      yydestruct ("Cleanup: popping",
-                  yystos[*yyssp], yyvsp, p);
-      YYPOPSTACK (1);
-    }
-#ifndef yyoverflow
-  if (yyss != yyssa)
-    YYSTACK_FREE (yyss);
-#endif
-#if YYERROR_VERBOSE
-  if (yymsg != yymsgbuf)
-    YYSTACK_FREE (yymsg);
-#endif
-  return yyresult;
-}
-#line 998 "mapparser.y" /* yacc.c:1906  */
-
-
-/*
-** Any extra C functions
-*/
-
-int yylex(YYSTYPE *lvalp, parseObj *p) 
-{
-  int token;
-  
-  if(p->expr->curtoken == NULL) return(0); /* done */
-
-  // fprintf(stderr, "in yylex() - curtoken=%d...\n", p->expr->curtoken->token);
-
-  token = p->expr->curtoken->token; /* may override */
-  switch(p->expr->curtoken->token) {
-  case MS_TOKEN_LITERAL_BOOLEAN:
-    token = BOOLEAN;
-    (*lvalp).intval = p->expr->curtoken->tokenval.dblval;
-    break;
-  case MS_TOKEN_LITERAL_NUMBER:
-    token = NUMBER;
-    (*lvalp).dblval = p->expr->curtoken->tokenval.dblval;
-    break;
-  case MS_TOKEN_LITERAL_SHAPE:
-    token = SHAPE;
-    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->expr->curtoken->tokenval.shpval));
-    (*lvalp).shpval = p->expr->curtoken->tokenval.shpval;
-    break;
-  case MS_TOKEN_LITERAL_STRING:
-    // printf("token value = %s\n", p->expr->curtoken->tokenval.strval); 
-    if (p->type == MS_PARSE_TYPE_SLD)
-    {
-      token = STRING;
-      if (*(p->expr->curtoken->tokenval.strval))
-      {
-        (*lvalp).strval = msStrdup("<![CDATA[");
-        (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.strval);
-        (*lvalp).strval = msStringConcatenate((*lvalp).strval,"]]>\n");
-      }
-      else
-      {
-        (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);
-      }
-    }
-    else
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);    
-    }
-    break;
-  case MS_TOKEN_LITERAL_TIME:
-    token = TIME;
-    (*lvalp).tmval = p->expr->curtoken->tokenval.tmval;
-    break;
-
-  case MS_TOKEN_COMPARISON_EQ: token = EQ; break;
-  case MS_TOKEN_COMPARISON_IEQ: token = IEQ; break;
-  case MS_TOKEN_COMPARISON_NE: token = NE; break;
-  case MS_TOKEN_COMPARISON_LT: token = LT; break;
-  case MS_TOKEN_COMPARISON_GT: token = GT; break;
-  case MS_TOKEN_COMPARISON_LE: token = LE; break;
-  case MS_TOKEN_COMPARISON_GE: token = GE; break;
-  case MS_TOKEN_COMPARISON_RE: token = RE; break;
-  case MS_TOKEN_COMPARISON_IRE: token = IRE; break;
-
-  case MS_TOKEN_COMPARISON_IN: token = IN; break;
-
-  case MS_TOKEN_COMPARISON_INTERSECTS: token = INTERSECTS; break;
-  case MS_TOKEN_COMPARISON_DISJOINT: token = DISJOINT; break;
-  case MS_TOKEN_COMPARISON_TOUCHES: token = TOUCHES; break;
-  case MS_TOKEN_COMPARISON_OVERLAPS: token = OVERLAPS; break; 
-  case MS_TOKEN_COMPARISON_CROSSES: token = CROSSES; break;
-  case MS_TOKEN_COMPARISON_WITHIN: token = WITHIN; break; 
-  case MS_TOKEN_COMPARISON_CONTAINS: token = CONTAINS; break;
-  case MS_TOKEN_COMPARISON_EQUALS: token = EQUALS; break;
-  case MS_TOKEN_COMPARISON_BEYOND: token = BEYOND; break;
-  case MS_TOKEN_COMPARISON_DWITHIN: token = DWITHIN; break;
-
-  case MS_TOKEN_LOGICAL_AND: token = AND; break;
-  case MS_TOKEN_LOGICAL_OR: token = OR; break;
-  case MS_TOKEN_LOGICAL_NOT: token = NOT; break;
-
-  case MS_TOKEN_BINDING_DOUBLE:
-  case MS_TOKEN_BINDING_INTEGER:
-    if (p->type == MS_PARSE_TYPE_SLD)
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
-    }
-    else
-    {
-      token = NUMBER;
-      (*lvalp).dblval = atof(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
-    }
-    break;
-  case MS_TOKEN_BINDING_STRING:
-    if (p->type == MS_PARSE_TYPE_SLD)
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
-    }
-    else
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
-    }
-    break;
-  case MS_TOKEN_BINDING_SHAPE:
-    token = SHAPE;
-    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->shape));
-    (*lvalp).shpval = p->shape;
-    break;
-  case MS_TOKEN_BINDING_MAP_CELLSIZE:
-    token = NUMBER;
-    (*lvalp).dblval = p->dblval;
-    break;
-  case MS_TOKEN_BINDING_DATA_CELLSIZE:
-    token = NUMBER;
-    (*lvalp).dblval = p->dblval2;
-    break;    
-  case MS_TOKEN_BINDING_TIME:
-    token = TIME;
-    msTimeInit(&((*lvalp).tmval));
-    if(msParseTime(p->shape->values[p->expr->curtoken->tokenval.bindval.index], &((*lvalp).tmval)) != MS_TRUE) {
-      yyerror(p, "Parsing time value failed.");
-      return(-1);
-    }
-    break;
-
-  case MS_TOKEN_FUNCTION_AREA: token = AREA; break;
-  case MS_TOKEN_FUNCTION_LENGTH: token = LENGTH; break;
-  case MS_TOKEN_FUNCTION_TOSTRING: token = TOSTRING; break;
-  case MS_TOKEN_FUNCTION_COMMIFY: token = COMMIFY; break;
-  case MS_TOKEN_FUNCTION_UPPER: token = UPPER; break;
-  case MS_TOKEN_FUNCTION_LOWER: token = LOWER; break;
-  case MS_TOKEN_FUNCTION_INITCAP: token = INITCAP; break;
-  case MS_TOKEN_FUNCTION_FIRSTCAP: token = FIRSTCAP; break;
-  case MS_TOKEN_FUNCTION_ROUND: token = ROUND; break;
-
-  case MS_TOKEN_FUNCTION_BUFFER: token = YYBUFFER; break;
-  case MS_TOKEN_FUNCTION_DIFFERENCE: token = DIFFERENCE; break;
-  case MS_TOKEN_FUNCTION_SIMPLIFY: token = SIMPLIFY; break;
-  case MS_TOKEN_FUNCTION_SIMPLIFYPT: token = SIMPLIFYPT; break;
-  case MS_TOKEN_FUNCTION_GENERALIZE: token = GENERALIZE; break;
-  case MS_TOKEN_FUNCTION_SMOOTHSIA: token = SMOOTHSIA; break;
-  case MS_TOKEN_FUNCTION_CENTERLINE: token = CENTERLINE; break;
-  case MS_TOKEN_FUNCTION_DENSIFY: token = DENSIFY; break;
-  case MS_TOKEN_FUNCTION_INNER: token = INNER; break;
-  case MS_TOKEN_FUNCTION_OUTER: token = OUTER; break;
-  case MS_TOKEN_FUNCTION_JAVASCRIPT: token = JAVASCRIPT; break;
-
-  default:
-    break;
-  }
-
-  p->expr->curtoken = p->expr->curtoken->next; /* re-position */ 
-  return(token);
-}
-
-int yyerror(parseObj *p, const char *s) {
-  (void)p;
-  msSetError(MS_PARSEERR, "%s", "yyparse()", s);
-  return(0);
-}
diff -pruN 8.0.1-5/mapparser.h 8.2.0~beta1-1~exp1/mapparser.h
--- 8.0.1-5/mapparser.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapparser.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,175 +0,0 @@
-/* A Bison parser, made by GNU Bison 3.0.4.  */
-
-/* Bison interface for Yacc-like parsers in C
-
-   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.
-
-   This program is free software: you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation, either version 3 of the License, or
-   (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
-
-/* As a special exception, you may create a larger work that contains
-   part or all of the Bison parser skeleton and distribute that work
-   under terms of your choice, so long as that work isn't itself a
-   parser generator using the skeleton or a modified version thereof
-   as a parser skeleton.  Alternatively, if you modify or redistribute
-   the parser skeleton itself, you may (at your option) remove this
-   special exception, which will cause the skeleton and the resulting
-   Bison output files to be licensed under the GNU General Public
-   License without this special exception.
-
-   This special exception was added by the Free Software Foundation in
-   version 2.2 of Bison.  */
-
-#ifndef YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
-# define YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
-/* Debug traces.  */
-#ifndef YYDEBUG
-# define YYDEBUG 0
-#endif
-#if YYDEBUG
-extern int yydebug;
-#endif
-
-/* Token type.  */
-#ifndef YYTOKENTYPE
-# define YYTOKENTYPE
-  enum yytokentype
-  {
-    BOOLEAN = 258,
-    NUMBER = 259,
-    STRING = 260,
-    TIME = 261,
-    SHAPE = 262,
-    OR = 263,
-    AND = 264,
-    NOT = 265,
-    RE = 266,
-    EQ = 267,
-    NE = 268,
-    LT = 269,
-    GT = 270,
-    LE = 271,
-    GE = 272,
-    IN = 273,
-    IEQ = 274,
-    IRE = 275,
-    INTERSECTS = 276,
-    DISJOINT = 277,
-    TOUCHES = 278,
-    OVERLAPS = 279,
-    CROSSES = 280,
-    WITHIN = 281,
-    CONTAINS = 282,
-    EQUALS = 283,
-    BEYOND = 284,
-    DWITHIN = 285,
-    AREA = 286,
-    LENGTH = 287,
-    COMMIFY = 288,
-    ROUND = 289,
-    UPPER = 290,
-    LOWER = 291,
-    INITCAP = 292,
-    FIRSTCAP = 293,
-    TOSTRING = 294,
-    YYBUFFER = 295,
-    INNER = 296,
-    OUTER = 297,
-    DIFFERENCE = 298,
-    DENSIFY = 299,
-    SIMPLIFY = 300,
-    SIMPLIFYPT = 301,
-    GENERALIZE = 302,
-    SMOOTHSIA = 303,
-    CENTERLINE = 304,
-    JAVASCRIPT = 305,
-    NEG = 306
-  };
-#endif
-/* Tokens.  */
-#define BOOLEAN 258
-#define NUMBER 259
-#define STRING 260
-#define TIME 261
-#define SHAPE 262
-#define OR 263
-#define AND 264
-#define NOT 265
-#define RE 266
-#define EQ 267
-#define NE 268
-#define LT 269
-#define GT 270
-#define LE 271
-#define GE 272
-#define IN 273
-#define IEQ 274
-#define IRE 275
-#define INTERSECTS 276
-#define DISJOINT 277
-#define TOUCHES 278
-#define OVERLAPS 279
-#define CROSSES 280
-#define WITHIN 281
-#define CONTAINS 282
-#define EQUALS 283
-#define BEYOND 284
-#define DWITHIN 285
-#define AREA 286
-#define LENGTH 287
-#define COMMIFY 288
-#define ROUND 289
-#define UPPER 290
-#define LOWER 291
-#define INITCAP 292
-#define FIRSTCAP 293
-#define TOSTRING 294
-#define YYBUFFER 295
-#define INNER 296
-#define OUTER 297
-#define DIFFERENCE 298
-#define DENSIFY 299
-#define SIMPLIFY 300
-#define SIMPLIFYPT 301
-#define GENERALIZE 302
-#define SMOOTHSIA 303
-#define CENTERLINE 304
-#define JAVASCRIPT 305
-#define NEG 306
-
-/* Value type.  */
-#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
-
-union YYSTYPE
-{
-#line 30 "mapparser.y" /* yacc.c:1909  */
-
-  double dblval;
-  int intval;  
-  char *strval;  
-  struct tm tmval;
-  shapeObj *shpval;
-
-#line 164 "/vagrant/mapparser.h" /* yacc.c:1909  */
-};
-
-typedef union YYSTYPE YYSTYPE;
-# define YYSTYPE_IS_TRIVIAL 1
-# define YYSTYPE_IS_DECLARED 1
-#endif
-
-
-
-int yyparse (parseObj *p);
-
-#endif /* !YY_YY_VAGRANT_MAPPARSER_H_INCLUDED  */
diff -pruN 8.0.1-5/mapparser.y 8.2.0~beta1-1~exp1/mapparser.y
--- 8.0.1-5/mapparser.y	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapparser.y	1970-01-01 00:00:00.000000000 +0000
@@ -1,1166 +0,0 @@
-/*
-** Parser for the mapserver
-*/
-
-%{
-/* C declarations */
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <math.h>
-#include <time.h>
-
-#include "mapserver.h" /* for TRUE/FALSE and REGEX includes */
-#include "maptime.h" /* for time comparison routines */
-#include "mapprimitive.h" /* for shapeObj */
-
-#include "mapparser.h" /* for YYSTYPE in the function prototype for yylex() */
-
-int yylex(YYSTYPE *, parseObj *); /* prototype functions, defined after the grammar */
-int yyerror(parseObj *, const char *);
-%}
-
-/* Bison/Yacc declarations */
-
-/* %define api.pure */
-%pure-parser
-%parse-param {parseObj *p}
-%lex-param {parseObj *p}
-
-%union {
-  double dblval;
-  int intval;  
-  char *strval;  
-  struct tm tmval;
-  shapeObj *shpval;
-}
-
-%token <intval> BOOLEAN
-%token <dblval> NUMBER
-%token <strval> STRING
-%token <tmval> TIME
-%token <shpval> SHAPE
-
-%left OR
-%left AND
-%left NOT
-%left RE EQ NE LT GT LE GE IN IEQ IRE
-%left INTERSECTS DISJOINT TOUCHES OVERLAPS CROSSES WITHIN CONTAINS EQUALS BEYOND DWITHIN
-%left AREA LENGTH COMMIFY ROUND
-%left UPPER LOWER INITCAP FIRSTCAP
-%left TOSTRING
-%left YYBUFFER INNER OUTER DIFFERENCE DENSIFY SIMPLIFY SIMPLIFYPT GENERALIZE SMOOTHSIA CENTERLINE JAVASCRIPT
-%left '+' '-'
-%left '*' '/' '%'
-%left NEG
-%right '^'
-
-%type <intval> logical_exp
-%type <dblval> math_exp
-%type <strval> string_exp
-%type <tmval> time_exp
-%type <shpval> shape_exp
-
-/* Bison/Yacc grammar */
-
-%%
-
-input: /* empty string */
-  | logical_exp {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_BOOLEAN):
-      p->result.intval = $1; 
-      break;
-    case(MS_PARSE_TYPE_STRING):
-      if($1) 
-        p->result.strval = msStrdup("true");
-      else
-        p->result.strval = msStrdup("false");
-      break;
-    }
-  }
-  | math_exp {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_BOOLEAN):
-      if($1 != 0)
-        p->result.intval = MS_TRUE;
-      else
-        p->result.intval = MS_FALSE;			    
-      break;
-    case(MS_PARSE_TYPE_STRING):
-      p->result.strval = (char *)malloc(64); /* large enough for a double */
-      snprintf(p->result.strval, 64, "%g", $1);
-      break;
-    }
-  }
-  | string_exp {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_BOOLEAN):
-      if($1) /* string is not NULL */
-        p->result.intval = MS_TRUE;
-      else
-        p->result.intval = MS_FALSE;
-      break;
-    case(MS_PARSE_TYPE_SLD):
-    case(MS_PARSE_TYPE_STRING):
-      p->result.strval = $1; // msStrdup($1);
-      break;
-    }
-  }
-  | shape_exp {
-    switch(p->type) {
-    case(MS_PARSE_TYPE_SHAPE):
-      p->result.shpval = $1;
-      p->result.shpval->scratch = MS_FALSE;
-      break;
-    }
-  }
-;
-
-logical_exp: BOOLEAN
-  | '(' logical_exp ')' { $$ = $2; }
-  | logical_exp EQ logical_exp {
-    $$ = MS_FALSE;
-    if($1 == $3) $$ = MS_TRUE;
-  }
-  | logical_exp OR logical_exp {
-    if($1 == MS_TRUE)
-      $$ = MS_TRUE;
-    else if($3 == MS_TRUE)          
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | logical_exp AND logical_exp {
-    if($1 == MS_TRUE) {
-      if($3 == MS_TRUE)
-        $$ = MS_TRUE;
-      else
-        $$ = MS_FALSE;
-    } else
-      $$ = MS_FALSE;
-  }
-  | logical_exp OR math_exp {
-    if($1 == MS_TRUE)
-      $$ = MS_TRUE;
-    else if($3 != 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | logical_exp AND math_exp {
-    if($1 == MS_TRUE) {
-      if($3 != 0)
-        $$ = MS_TRUE;
-      else
-        $$ = MS_FALSE;
-    } else
-      $$ = MS_FALSE;
-  }
-  | math_exp OR logical_exp {
-    if($1 != 0)
-      $$ = MS_TRUE;
-    else if($3 == MS_TRUE)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | math_exp AND logical_exp {
-    if($1 != 0) {
-      if($3 == MS_TRUE)
-        $$ = MS_TRUE;
-      else
-        $$ = MS_FALSE;
-    } else
-      $$ = MS_FALSE;
-  }
-  | math_exp OR math_exp {
-    if($1 != 0)
-      $$ = MS_TRUE;
-    else if($3 != 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | math_exp AND math_exp      {
-    if($1 != 0) {
-      if($3 != 0)
-        $$ = MS_TRUE;
-      else
-	$$ = MS_FALSE;
-    } else
-      $$ = MS_FALSE;
-  }
-  | NOT logical_exp { $$ = !$2; }
-  | NOT math_exp { $$ = !$2; }
-  | string_exp RE string_exp {
-    ms_regex_t re;
-
-    if(MS_STRING_IS_NULL_OR_EMPTY($1) == MS_TRUE) {
-      $$ = MS_FALSE;
-    } else {
-      if(ms_regcomp(&re, $3, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {      
-        $$ = MS_FALSE;
-      } else {
-        if(ms_regexec(&re, $1, 0, NULL, 0) == 0)
-          $$ = MS_TRUE;
-        else
-          $$ = MS_FALSE;
-        ms_regfree(&re);
-      }
-    }
-
-    free($1);
-    free($3);
-  }
-  | string_exp IRE string_exp {
-    ms_regex_t re;
-
-    if(MS_STRING_IS_NULL_OR_EMPTY($1) == MS_TRUE) {
-      $$ = MS_FALSE;
-    } else {
-      if(ms_regcomp(&re, $3, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
-        $$ = MS_FALSE;
-      } else {
-        if(ms_regexec(&re, $1, 0, NULL, 0) == 0)
-          $$ = MS_TRUE;
-        else
-          $$ = MS_FALSE;
-        ms_regfree(&re);
-      }
-    }
-
-    free($1);
-    free($3);
-  }
-  | math_exp EQ math_exp {
-    if($1 == $3)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | math_exp NE math_exp {
-    if($1 != $3)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  } 
-  | math_exp GT math_exp {    
-    if($1 > $3)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | math_exp LT math_exp {
-    if($1 < $3)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | math_exp GE math_exp {
-    if($1 >= $3)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | math_exp LE math_exp {
-    if($1 <= $3)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | string_exp EQ string_exp {
-    if(strcmp($1, $3) == 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-    free($1);
-    free($3);
-  }
-  | string_exp NE string_exp {
-    if(strcmp($1, $3) != 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-    free($1);
-    free($3);
-  }
-  | string_exp GT string_exp {
-    if(strcmp($1, $3) > 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-    free($1);
-    free($3);
-  }
-  | string_exp LT string_exp {
-    if(strcmp($1, $3) < 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-    free($1);
-    free($3);
-  }
-  | string_exp GE string_exp {
-    if(strcmp($1, $3) >= 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-    free($1);
-    free($3);
-  }
-  | string_exp LE string_exp {
-    if(strcmp($1, $3) <= 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-    free($1);
-    free($3);
-  }
-  | time_exp EQ time_exp {
-    if(msTimeCompare(&($1), &($3)) == 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | time_exp NE time_exp {
-    if(msTimeCompare(&($1), &($3)) != 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | time_exp GT time_exp {
-    if(msTimeCompare(&($1), &($3)) > 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | time_exp LT time_exp {
-    if(msTimeCompare(&($1), &($3)) < 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | time_exp GE time_exp {
-    if(msTimeCompare(&($1), &($3)) >= 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | time_exp LE time_exp {
-    if(msTimeCompare(&($1), &($3)) <= 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | string_exp IN string_exp {
-    char *delim, *bufferp;
-
-    $$ = MS_FALSE;
-    bufferp=$3;
-
-    while((delim=strchr(bufferp,',')) != NULL) {
-      *delim='\0';
-      if(strcmp($1,bufferp) == 0) {
-        $$ = MS_TRUE;
-        break;
-      } 
-      *delim=',';
-      bufferp=delim+1;
-    }
-
-    if($$ == MS_FALSE && strcmp($1,bufferp) == 0) // test for last (or only) item
-      $$ = MS_TRUE;
-    free($1);
-    free($3);
-  }
-  | math_exp IN string_exp {
-    char *delim,*bufferp;
-
-    $$ = MS_FALSE;
-    bufferp=$3;
-
-    while((delim=strchr(bufferp,',')) != NULL) {
-      *delim='\0';
-      if($1 == atof(bufferp)) {
-        $$ = MS_TRUE;
-        break;
-      } 
-      *delim=',';
-      bufferp=delim+1;
-    }
-
-    if($1 == atof(bufferp)) // is this test necessary?
-      $$ = MS_TRUE;  
-    free($3);
-  }
-  | math_exp IEQ math_exp {
-    if($1 == $3)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | string_exp IEQ string_exp {
-    if(strcasecmp($1, $3) == 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-    free($1);
-    free($3);
-  }
-  | time_exp IEQ time_exp {
-    if(msTimeCompare(&($1), &($3)) == 0)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | shape_exp EQ shape_exp {
-    int rval;
-    rval = msGEOSEquals($1, $3);
-    if($1 && $1->scratch == MS_TRUE) {
-      msFreeShape($1);
-      free($1);
-    }
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(rval == -1) {
-      yyerror(p, "Equals (EQ or ==) operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | EQUALS '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSEquals($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Equals function failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | INTERSECTS '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSIntersects($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Intersects function failed.");
-      return(-1);
-    } else
-    $$ = rval;
-  }
-  | shape_exp INTERSECTS shape_exp {
-    int rval;
-    rval = msGEOSIntersects($1, $3);
-    if($1 && $1->scratch == MS_TRUE) {
-      msFreeShape($1);
-      free($1);
-    }
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(rval == -1) {
-      yyerror(p, "Intersects operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | DISJOINT '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSDisjoint($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Disjoint function failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | shape_exp DISJOINT shape_exp {
-    int rval;
-    rval = msGEOSDisjoint($1, $3);
-    if($1 && $1->scratch == MS_TRUE) {
-      msFreeShape($1);
-      free($1);
-    }
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(rval == -1) {
-      yyerror(p, "Disjoint operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | TOUCHES '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSTouches($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Touches function failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | shape_exp TOUCHES shape_exp {
-    int rval;
-    rval = msGEOSTouches($1, $3);
-    if($1 && $1->scratch == MS_TRUE) {
-      msFreeShape($1);
-      free($1);
-    }
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(rval == -1) {
-      yyerror(p, "Touches operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | OVERLAPS '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSOverlaps($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Overlaps function failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | shape_exp OVERLAPS shape_exp {
-    int rval;
-     rval = msGEOSOverlaps($1, $3);
-     if($1 && $1->scratch == MS_TRUE) {
-       msFreeShape($1);
-       free($1);
-     }
-     if($3 && $3->scratch == MS_TRUE) {
-       msFreeShape($3);
-       free($3);
-     }
-    if(rval == -1) {
-      yyerror(p, "Overlaps operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | CROSSES '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSCrosses($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Crosses function failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | shape_exp CROSSES shape_exp {
-    int rval;
-    rval = msGEOSCrosses($1, $3);
-    if($1 && $1->scratch == MS_TRUE) {
-      msFreeShape($1);
-      free($1);
-    }
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(rval == -1) {
-      yyerror(p, "Crosses operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | WITHIN '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSWithin($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Within function failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | shape_exp WITHIN shape_exp {
-    int rval;
-    rval = msGEOSWithin($1, $3);
-    if($1 && $1->scratch == MS_TRUE) {
-      msFreeShape($1);
-      free($1);
-    }
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(rval == -1) {
-      yyerror(p, "Within operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | CONTAINS '(' shape_exp ',' shape_exp ')' {
-    int rval;
-    rval = msGEOSContains($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(rval == -1) {
-      yyerror(p, "Contains function failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | shape_exp CONTAINS shape_exp {
-    int rval;
-    rval = msGEOSContains($1, $3);
-    if($1 && $1->scratch == MS_TRUE) {
-      msFreeShape($1);
-      free($1);
-    }
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(rval == -1) {
-      yyerror(p, "Contains operator failed.");
-      return(-1);
-    } else
-      $$ = rval;
-  }
-  | DWITHIN '(' shape_exp ',' shape_exp ',' math_exp ')' {
-    double d;
-    d = msGEOSDistance($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(d <= $7)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-  | BEYOND '(' shape_exp ',' shape_exp ',' math_exp ')' {
-    double d;
-    d = msGEOSDistance($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if($5 && $5->scratch == MS_TRUE) {
-      msFreeShape($5);
-      free($5);
-    }
-    if(d > $7)
-      $$ = MS_TRUE;
-    else
-      $$ = MS_FALSE;
-  }
-;
-
-math_exp: NUMBER
-  | '(' math_exp ')' { $$ = $2; }
-  | math_exp '+' math_exp { $$ = $1 + $3; }
-  | math_exp '-' math_exp { $$ = $1 - $3; }
-  | math_exp '*' math_exp { $$ = $1 * $3; }
-  | math_exp '%' math_exp { $$ = (int)$1 % (int)$3; }
-  | math_exp '/' math_exp {
-    if($3 == 0.0) {
-      yyerror(p, "Division by zero.");
-      return(-1);
-    } else
-      $$ = $1 / $3; 
-  }
-  | '-' math_exp %prec NEG { $$ = $2; }
-  | math_exp '^' math_exp { $$ = pow($1, $3); }
-  | LENGTH '(' string_exp ')' { $$ = strlen($3); }
-  | AREA '(' shape_exp ')' {
-    if($3->type != MS_SHAPE_POLYGON) {
-      yyerror(p, "Area can only be computed for polygon shapes.");
-      return(-1);
-    }
-    $$ = msGetPolygonArea($3);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-  }
-  | ROUND '(' math_exp ',' math_exp ')' { $$ = (MS_NINT($3/$5))*$5; }
-  | ROUND '(' math_exp ')' { $$ = (MS_NINT($3)); }
-;
-
-shape_exp: SHAPE 
-  | '(' shape_exp ')' { $$ = $2; }
-  | YYBUFFER '(' shape_exp ',' math_exp ')' {
-    shapeObj *s;
-    s = msGEOSBuffer($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing buffer failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | INNER '(' shape_exp ')' {
-    shapeObj *s;
-    s = msRings2Shape($3, MS_FALSE);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing inner failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | OUTER '(' shape_exp ')' {
-    shapeObj *s;
-    s = msRings2Shape($3, MS_TRUE);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing outer failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | CENTERLINE '(' shape_exp ')' {
-    shapeObj *s;
-    s = msGEOSCenterline($3);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing centerline failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | DIFFERENCE '(' shape_exp ',' shape_exp ')' {
-    shapeObj *s;
-    s = msGEOSDifference($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing difference failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | DENSIFY '(' shape_exp ',' math_exp ')' {
-    shapeObj *s;
-    s = msDensify($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing densify failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | SIMPLIFY '(' shape_exp ',' math_exp ')' {
-    shapeObj *s;
-    s = msGEOSSimplify($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing simplify failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | SIMPLIFYPT '(' shape_exp ',' math_exp ')' {
-    shapeObj *s;
-    s = msGEOSTopologyPreservingSimplify($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing simplifypt failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | GENERALIZE '(' shape_exp ',' math_exp ')' {
-    shapeObj *s;
-    s = msGeneralize($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing generalize failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | SMOOTHSIA '(' shape_exp ')' {
-    shapeObj *s;
-    s = msSmoothShapeSIA($3, 3, 1, NULL);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | SMOOTHSIA '(' shape_exp ',' math_exp ')' {
-    shapeObj *s;
-    s = msSmoothShapeSIA($3, $5, 1, NULL);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | SMOOTHSIA '(' shape_exp ',' math_exp ',' math_exp ')' {
-    shapeObj *s;
-    s = msSmoothShapeSIA($3, $5, $7, NULL);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | SMOOTHSIA '(' shape_exp ',' math_exp ',' math_exp ',' string_exp ')' {
-    shapeObj *s;
-    s = msSmoothShapeSIA($3, $5, $7, $9);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    free($9);
-    if(!s) {
-      yyerror(p, "Executing smoothsia failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-  }
-  | JAVASCRIPT '(' shape_exp ',' string_exp ')' {
-#ifdef USE_V8_MAPSCRIPT
-    shapeObj *s;
-    s = msV8TransformShape($3, $5);
-    if($3 && $3->scratch == MS_TRUE) {
-      msFreeShape($3);
-      free($3);
-    }
-    free($5);
-    if(!s) {
-      yyerror(p, "Executing javascript failed.");
-      return(-1);
-    }
-    s->scratch = MS_TRUE;
-    $$ = s;
-#else
-    yyerror(p, "Javascript support not compiled in");
-    return(-1);
-#endif
-  }
-;
-
-string_exp: STRING
-  | '(' string_exp ')' { $$ = $2; }
-  | string_exp '+' string_exp { 
-    $$ = (char *)malloc(strlen($1) + strlen($3) + 1);
-    sprintf($$, "%s%s", $1, $3); free($1); free($3); 
-  }
-  | TOSTRING '(' math_exp ',' string_exp ')' {
-    $$ = (char *) malloc(strlen($5) + 64); /* Plenty big? Should use snprintf below... */
-    sprintf($$, $5, $3);
-    free($5);
-  }
-  | COMMIFY '(' string_exp ')' {  
-    $3 = msCommifyString($3); 
-    $$ = $3; 
-  }
-  | UPPER '(' string_exp ')' {  
-    msStringToUpper($3); 
-    $$ = $3; 
-  }
-  | LOWER '(' string_exp ')' {  
-    msStringToLower($3); 
-    $$ = $3; 
-  }
-  | INITCAP '(' string_exp ')' {  
-    msStringInitCap($3); 
-    $$ = $3; 
-  }
-  | FIRSTCAP '(' string_exp ')' {  
-    msStringFirstCap($3); 
-    $$ = $3; 
-  }
-;
-
-time_exp: TIME
-  | '(' time_exp ')' { $$ = $2; }
-;
-
-%%
-
-/*
-** Any extra C functions
-*/
-
-int yylex(YYSTYPE *lvalp, parseObj *p) 
-{
-  int token;
-  
-  if(p->expr->curtoken == NULL) return(0); /* done */
-
-  // fprintf(stderr, "in yylex() - curtoken=%d...\n", p->expr->curtoken->token);
-
-  token = p->expr->curtoken->token; /* may override */
-  switch(p->expr->curtoken->token) {
-  case MS_TOKEN_LITERAL_BOOLEAN:
-    token = BOOLEAN;
-    (*lvalp).intval = p->expr->curtoken->tokenval.dblval;
-    break;
-  case MS_TOKEN_LITERAL_NUMBER:
-    token = NUMBER;
-    (*lvalp).dblval = p->expr->curtoken->tokenval.dblval;
-    break;
-  case MS_TOKEN_LITERAL_SHAPE:
-    token = SHAPE;
-    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->expr->curtoken->tokenval.shpval));
-    (*lvalp).shpval = p->expr->curtoken->tokenval.shpval;
-    break;
-  case MS_TOKEN_LITERAL_STRING:
-    // printf("token value = %s\n", p->expr->curtoken->tokenval.strval); 
-    if (p->type == MS_PARSE_TYPE_SLD)
-    {
-      token = STRING;
-      if (*(p->expr->curtoken->tokenval.strval))
-      {
-        (*lvalp).strval = msStrdup("<![CDATA[");
-        (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.strval);
-        (*lvalp).strval = msStringConcatenate((*lvalp).strval,"]]>\n");
-      }
-      else
-      {
-        (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);
-      }
-    }
-    else
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);    
-    }
-    break;
-  case MS_TOKEN_LITERAL_TIME:
-    token = TIME;
-    (*lvalp).tmval = p->expr->curtoken->tokenval.tmval;
-    break;
-
-  case MS_TOKEN_COMPARISON_EQ: token = EQ; break;
-  case MS_TOKEN_COMPARISON_IEQ: token = IEQ; break;
-  case MS_TOKEN_COMPARISON_NE: token = NE; break;
-  case MS_TOKEN_COMPARISON_LT: token = LT; break;
-  case MS_TOKEN_COMPARISON_GT: token = GT; break;
-  case MS_TOKEN_COMPARISON_LE: token = LE; break;
-  case MS_TOKEN_COMPARISON_GE: token = GE; break;
-  case MS_TOKEN_COMPARISON_RE: token = RE; break;
-  case MS_TOKEN_COMPARISON_IRE: token = IRE; break;
-
-  case MS_TOKEN_COMPARISON_IN: token = IN; break;
-
-  case MS_TOKEN_COMPARISON_INTERSECTS: token = INTERSECTS; break;
-  case MS_TOKEN_COMPARISON_DISJOINT: token = DISJOINT; break;
-  case MS_TOKEN_COMPARISON_TOUCHES: token = TOUCHES; break;
-  case MS_TOKEN_COMPARISON_OVERLAPS: token = OVERLAPS; break; 
-  case MS_TOKEN_COMPARISON_CROSSES: token = CROSSES; break;
-  case MS_TOKEN_COMPARISON_WITHIN: token = WITHIN; break; 
-  case MS_TOKEN_COMPARISON_CONTAINS: token = CONTAINS; break;
-  case MS_TOKEN_COMPARISON_EQUALS: token = EQUALS; break;
-  case MS_TOKEN_COMPARISON_BEYOND: token = BEYOND; break;
-  case MS_TOKEN_COMPARISON_DWITHIN: token = DWITHIN; break;
-
-  case MS_TOKEN_LOGICAL_AND: token = AND; break;
-  case MS_TOKEN_LOGICAL_OR: token = OR; break;
-  case MS_TOKEN_LOGICAL_NOT: token = NOT; break;
-
-  case MS_TOKEN_BINDING_DOUBLE:
-  case MS_TOKEN_BINDING_INTEGER:
-    if (p->type == MS_PARSE_TYPE_SLD)
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
-    }
-    else
-    {
-      token = NUMBER;
-      (*lvalp).dblval = atof(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
-    }
-    break;
-  case MS_TOKEN_BINDING_STRING:
-    if (p->type == MS_PARSE_TYPE_SLD)
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
-      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
-    }
-    else
-    {
-      token = STRING;
-      (*lvalp).strval = msStrdup(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
-    }
-    break;
-  case MS_TOKEN_BINDING_SHAPE:
-    token = SHAPE;
-    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->shape));
-    (*lvalp).shpval = p->shape;
-    break;
-  case MS_TOKEN_BINDING_MAP_CELLSIZE:
-    token = NUMBER;
-    (*lvalp).dblval = p->dblval;
-    break;
-  case MS_TOKEN_BINDING_DATA_CELLSIZE:
-    token = NUMBER;
-    (*lvalp).dblval = p->dblval2;
-    break;    
-  case MS_TOKEN_BINDING_TIME:
-    token = TIME;
-    msTimeInit(&((*lvalp).tmval));
-    if(msParseTime(p->shape->values[p->expr->curtoken->tokenval.bindval.index], &((*lvalp).tmval)) != MS_TRUE) {
-      yyerror(p, "Parsing time value failed.");
-      return(-1);
-    }
-    break;
-
-  case MS_TOKEN_FUNCTION_AREA: token = AREA; break;
-  case MS_TOKEN_FUNCTION_LENGTH: token = LENGTH; break;
-  case MS_TOKEN_FUNCTION_TOSTRING: token = TOSTRING; break;
-  case MS_TOKEN_FUNCTION_COMMIFY: token = COMMIFY; break;
-  case MS_TOKEN_FUNCTION_UPPER: token = UPPER; break;
-  case MS_TOKEN_FUNCTION_LOWER: token = LOWER; break;
-  case MS_TOKEN_FUNCTION_INITCAP: token = INITCAP; break;
-  case MS_TOKEN_FUNCTION_FIRSTCAP: token = FIRSTCAP; break;
-  case MS_TOKEN_FUNCTION_ROUND: token = ROUND; break;
-
-  case MS_TOKEN_FUNCTION_BUFFER: token = YYBUFFER; break;
-  case MS_TOKEN_FUNCTION_DIFFERENCE: token = DIFFERENCE; break;
-  case MS_TOKEN_FUNCTION_SIMPLIFY: token = SIMPLIFY; break;
-  case MS_TOKEN_FUNCTION_SIMPLIFYPT: token = SIMPLIFYPT; break;
-  case MS_TOKEN_FUNCTION_GENERALIZE: token = GENERALIZE; break;
-  case MS_TOKEN_FUNCTION_SMOOTHSIA: token = SMOOTHSIA; break;
-  case MS_TOKEN_FUNCTION_CENTERLINE: token = CENTERLINE; break;
-  case MS_TOKEN_FUNCTION_DENSIFY: token = DENSIFY; break;
-  case MS_TOKEN_FUNCTION_INNER: token = INNER; break;
-  case MS_TOKEN_FUNCTION_OUTER: token = OUTER; break;
-  case MS_TOKEN_FUNCTION_JAVASCRIPT: token = JAVASCRIPT; break;
-
-  default:
-    break;
-  }
-
-  p->expr->curtoken = p->expr->curtoken->next; /* re-position */ 
-  return(token);
-}
-
-int yyerror(parseObj *p, const char *s) {
-  (void)p;
-  msSetError(MS_PARSEERR, "%s", "yyparse()", s);
-  return(0);
-}
diff -pruN 8.0.1-5/mappluginlayer.c 8.2.0~beta1-1~exp1/mappluginlayer.c
--- 8.0.1-5/mappluginlayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mappluginlayer.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,232 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of plug-in layer functionality
- * Author:   Jani Averbach, SRC,LLC  <javerbach@extendthereach.com>
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "mapthread.h"
-
-
-
-typedef struct {
-  char *name;
-  layerVTableObj vtable;
-} VTFactoryItemObj;
-
-typedef struct {
-  unsigned int size;
-  unsigned int first_free;
-  VTFactoryItemObj ** vtItems;
-} VTFactoryObj;
-
-static VTFactoryObj gVirtualTableFactory = {0, 0, NULL};
-
-
-static VTFactoryItemObj *
-createVTFItem(const char *name)
-{
-  VTFactoryItemObj *pVTFI;
-
-  pVTFI = (VTFactoryItemObj *)malloc(sizeof(VTFactoryItemObj));
-  MS_CHECK_ALLOC(pVTFI, sizeof(VTFactoryItemObj), NULL);
-
-  pVTFI->name = msStrdup(name);
-  memset(&pVTFI->vtable, 0, sizeof(layerVTableObj));
-
-  return pVTFI;
-}
-
-static void
-destroyVTFItem(VTFactoryItemObj **pVTFI)
-{
-  free((*pVTFI)->name);
-  (*pVTFI)->name = NULL;
-  memset(&(*pVTFI)->vtable, 0, sizeof(layerVTableObj));
-  free(*pVTFI);
-  *pVTFI = NULL;
-}
-
-
-static VTFactoryItemObj *
-lookupVTFItem(VTFactoryObj *VTFactory,
-              const char *key)
-{
-  unsigned int i;
-  for (i=0; i < VTFactory->size && VTFactory->vtItems[i]; ++i) {
-    if (0 == strcasecmp(key, VTFactory->vtItems[i]->name)) {
-      return VTFactory->vtItems[i];
-    }
-  }
-  return NULL;
-}
-
-static int
-insertNewVTFItem(VTFactoryObj *pVTFactory,
-                 VTFactoryItemObj *pVTFI)
-{
-  /* Ensure there is room for one more item in the array
-   * (safe to use for initial alloc of the array as well)
-   */
-  if (pVTFactory->first_free == pVTFactory->size) {
-    VTFactoryItemObj **vtItemPtr;
-    vtItemPtr = (VTFactoryItemObj**)realloc(pVTFactory->vtItems,
-                                            (pVTFactory->size+MS_LAYER_ALLOCSIZE)*sizeof(VTFactoryItemObj*));
-    MS_CHECK_ALLOC(vtItemPtr, (pVTFactory->size+MS_LAYER_ALLOCSIZE)*sizeof(VTFactoryItemObj*), MS_FAILURE);
-
-
-    pVTFactory->size += MS_LAYER_ALLOCSIZE;
-    pVTFactory->vtItems = vtItemPtr;
-
-    for (unsigned i=pVTFactory->first_free; i<pVTFactory->size; i++)
-      pVTFactory->vtItems[i] = NULL;
-  }
-
-  /* Insert item */
-  pVTFactory->vtItems[pVTFactory->first_free] = pVTFI;
-  pVTFactory->first_free++;
-
-  return MS_SUCCESS;
-}
-
-static VTFactoryItemObj *
-loadCustomLayerDLL(layerObj *layer, const char *library_path)
-{
-  int (*pfnPluginInitVTable)(layerVTableObj *, layerObj *);
-
-  VTFactoryItemObj *pVTFI;
-
-  pfnPluginInitVTable = msGetSymbol(library_path, "PluginInitializeVirtualTable");
-  if ( ! pfnPluginInitVTable) {
-    msSetError(MS_MISCERR, "Failed to load dynamic Layer LIB: %s", "loadCustomLayerDLL", library_path);
-    return NULL;
-  }
-
-  pVTFI = createVTFItem(library_path);
-  if ( ! pVTFI) {
-    return NULL;
-  }
-
-  if (pfnPluginInitVTable(&pVTFI->vtable, layer)) {
-    destroyVTFItem(&pVTFI);
-    msSetError(MS_MISCERR, "Failed to initialize dynamic Layer: %s", "loadCustomLayerDLL", library_path);
-    return NULL;
-  }
-  return pVTFI;
-}
-
-/*
- * copyVirtualTable
- *
- * copy one virtual table from dest to src. Both of dest and src
- * have to be allocated already.
- *
- * If src contains NULL fields, those are NOT copied over.
- *
- * Because of that, it is possible for plugin layer to use default
- * layer API default functions,  just leave those function pointers to NULL.
- */
-static void
-copyVirtualTable(layerVTableObj *dest,
-                 const layerVTableObj *src)
-{
-  dest->LayerTranslateFilter = src->LayerTranslateFilter ? src->LayerTranslateFilter : dest->LayerTranslateFilter;
-  dest->LayerSupportsCommonFilters = src->LayerSupportsCommonFilters ? src->LayerSupportsCommonFilters : dest->LayerSupportsCommonFilters;
-  dest->LayerInitItemInfo = src->LayerInitItemInfo ? src->LayerInitItemInfo : dest->LayerInitItemInfo;
-  dest->LayerFreeItemInfo = src->LayerFreeItemInfo ? src->LayerFreeItemInfo : dest->LayerFreeItemInfo;
-  dest->LayerOpen = src->LayerOpen ? src->LayerOpen : dest->LayerOpen;
-  dest->LayerIsOpen = src->LayerIsOpen ? src->LayerIsOpen : dest->LayerIsOpen;
-  dest->LayerWhichShapes = src->LayerWhichShapes ? src->LayerWhichShapes : dest->LayerWhichShapes;
-  dest->LayerNextShape = src->LayerNextShape ? src->LayerNextShape : dest->LayerNextShape;
-  dest->LayerGetShape = src->LayerGetShape ? src->LayerGetShape : dest->LayerGetShape;
-  /* dest->LayerResultsGetShape = src->LayerResultsGetShape ? src->LayerResultsGetShape : dest->LayerResultsGetShape; */
-  dest->LayerGetShapeCount = src->LayerGetShapeCount ? src->LayerGetShapeCount : dest->LayerGetShapeCount;
-  dest->LayerClose = src->LayerClose ? src->LayerClose : dest->LayerClose;
-  dest->LayerGetItems = src->LayerGetItems ? src->LayerGetItems : dest->LayerGetItems;
-  dest->LayerGetExtent = src->LayerGetExtent ? src->LayerGetExtent : dest->LayerGetExtent;
-  dest->LayerGetAutoStyle = src->LayerGetAutoStyle ? src->LayerGetAutoStyle : dest->LayerGetAutoStyle;
-  dest->LayerCloseConnection = src->LayerCloseConnection ? src->LayerCloseConnection : dest->LayerCloseConnection;
-  dest->LayerSetTimeFilter = src->LayerSetTimeFilter ? src->LayerSetTimeFilter : dest->LayerSetTimeFilter;
-  dest->LayerApplyFilterToLayer = src->LayerApplyFilterToLayer ? src->LayerApplyFilterToLayer : dest->LayerApplyFilterToLayer;
-  dest->LayerCreateItems = src->LayerCreateItems ? src->LayerCreateItems : dest->LayerCreateItems;
-  dest->LayerGetNumFeatures = src->LayerGetNumFeatures ? src->LayerGetNumFeatures : dest->LayerGetNumFeatures;
-  dest->LayerGetAutoProjection = src->LayerGetAutoProjection ? src->LayerGetAutoProjection: dest->LayerGetAutoProjection;
-  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam ? src->LayerEscapeSQLParam: dest->LayerEscapeSQLParam;
-  dest->LayerEscapePropertyName = src->LayerEscapePropertyName ? src->LayerEscapePropertyName: dest->LayerEscapePropertyName;
-  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam ? src->LayerEscapeSQLParam: dest->LayerEscapeSQLParam;
-  dest->LayerEnablePaging = src->LayerEnablePaging ? src->LayerEnablePaging: dest->LayerEnablePaging;
-  dest->LayerGetPaging = src->LayerGetPaging ? src->LayerGetPaging: dest->LayerGetPaging;
-}
-
-int
-msPluginLayerInitializeVirtualTable(layerObj *layer)
-{
-  VTFactoryItemObj *pVTFI;
-
-  if (!layer->plugin_library){
-      return MS_FAILURE;
-  }
-
-  msAcquireLock(TLOCK_LAYER_VTABLE);
-
-  pVTFI = lookupVTFItem(&gVirtualTableFactory, layer->plugin_library);
-  if ( ! pVTFI) {
-    pVTFI = loadCustomLayerDLL(layer, layer->plugin_library);
-    if ( ! pVTFI) {
-      msReleaseLock(TLOCK_LAYER_VTABLE);
-      return MS_FAILURE;
-    }
-    if (insertNewVTFItem(&gVirtualTableFactory, pVTFI) != MS_SUCCESS) {
-      destroyVTFItem(&pVTFI);
-      msReleaseLock(TLOCK_LAYER_VTABLE);
-      return MS_FAILURE;
-    }
-  }
-  msReleaseLock(TLOCK_LAYER_VTABLE);
-
-  copyVirtualTable(layer->vtable, &pVTFI->vtable);
-  return MS_SUCCESS;
-}
-
-/* msPluginFreeVirtualTableFactory()
-** Called by msCleanup() to free the virtual table factory
-*/
-void
-msPluginFreeVirtualTableFactory()
-{
-  msAcquireLock(TLOCK_LAYER_VTABLE);
-
-  for (unsigned i=0; i<gVirtualTableFactory.size; i++) {
-    if (gVirtualTableFactory.vtItems[i])
-      destroyVTFItem(&(gVirtualTableFactory.vtItems[i]));
-  }
-  free(gVirtualTableFactory.vtItems);
-  gVirtualTableFactory.vtItems = NULL;
-  gVirtualTableFactory.size = 0;
-  gVirtualTableFactory.first_free = 0;
-
-  msReleaseLock(TLOCK_LAYER_VTABLE);
-}
diff -pruN 8.0.1-5/mappool.c 8.2.0~beta1-1~exp1/mappool.c
--- 8.0.1-5/mappool.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mappool.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,475 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implement new style connection pooling.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ******************************************************************************
-
-             New MapServer Connection Pooling
-             ================================
-
-This attempts to describe how the new connection pooling support (introduced
-Sept/2004) works and what the maintainer of a connection type needs to do
-to take advantage of it.
-
-First, the new connection pooling support makes the assumption that
-a connection can be abstracted as a void pointer.  Further it assumes that
-the connection identify is unique defined by the connection string and
-the connection type on layers.  So if two layers have the same connection
-type and connection string that they can share a connection handle.
-
-The old connection sharing was based on searching previous layers in the
-same map for a layer to copy an existing connection from.  That was ok for
-sharing connection between layers in the same map, but didn't address the
-need to share connections over a longer term as is the case in a FastCGI
-situation where the cgi is long running and handles many CGI requests.
-
-The mapool.c code essentially maintains a cache of open connections with the
-following information for each:
-  - connectiontype / connection
-  - connection handle
-  - reference count
-  - life span indicator
-  - callback function to close the connection.
-
-The life span indicator is controlled by the CLOSE_CONNECTION PROCESSING
-option on the layer(s).  If this is set to NORMAL (or not set at all) the
-connection will be closed as soon as the reference count drops to zero.  This
-is MS_LIFE_ZEROREF, and in normal use results in connections only be shared
-between layers in a given map as the connection will be closed when no layers
-are open against it anymore.  The other possible value for the CLOSE_CONNECTION
-option is DEFER which basically results in the connection being kept open
-till the application closes (msCleanup() will ensure the connection is closed
-on exit if called).  This case is called MS_LIFE_FOREVER.
-The CLOSE_CONNECTION=ALWAYS setting provides to suppress the connection pooling
-for a particular layer. In this case the MS_LIFE_SINGLE setting is used, which
-ensures that a new connection is created for each request and it is always
-closed when the connection is released. This kind of connection cannot be reused.
-
-The callback is a function provided with the connection handle when it is
-registered.  It takes a single "void *" argument which is the connection
-handle.
-
-Updating a Driver
------------------
-
-The following are the steps to ensure a particular format/database supports
-connection pooling (ie. mappostgis.c, maporacle.c, mapogr.cpp, etc)
-We will use POSTGIS names for convenience.
-
-1) in msPOSTGISLayerOpen() call msConnPoolRequest(layer) in order to get
-   a database connection.
-
-        layerinfo->conn = (PGconn *) msConnPoolRequest( layer );
-
-2) In msPOSTGISLayerOpen(): if msConnPoolRequest() returned NULL then
-   manually open a connection to the database (ie. PQconnectcb()) and then
-   register this handle with the pool API by calling msmsConnPoolRegister().
-
-      layerinfo->conn = PQconnectdb( layer->connection );
-
-            if (PQstatus(layerinfo->conn) == CONNECTION_BAD)
-               <report error>
-            else
-                msConnPoolRegister( layer, layerinfo->conn,
-                                    msPOSTGISCloseConnection );
-
-3) Implement a callback function (msPOSTGISCloseConnection) that the
-   connection pooling API can call when it wants to close the connection.
-
-   static void msPOSTGISCloseConnection( void *conn_handle )
-
-   {
-       PQfinish( (PGconn*) conn_handle );
-   }
-
-4) In msPOSTGISLayerClose() release the connection handle instead of
-   directly closing it.
-
-            msConnPoolRelease( layer, layerinfo->conn );
-            layerinfo->conn = NULL;
-
-5) If there was any use of msCheckConnection() or the "sameconnection"
-   member of the layerObj, then old style connection pooling is already
-   present.  Remove it.
-
-Thats it!
-
-Other Notes
------------
-
-o The connection pooling API will report details about connection
-  registrations, requests, releases and closes if the layer debug flag is
-  on for the layers in question.
-
-o The connection pooling API will let a connection be used/referenced multiple
-  times from a single thread, but will not allow a connection to be shared
-  between different threads concurrently.  But if a connection is released
-  by one thread, it is available for use by another thread.
-
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapthread.h"
-
-
-
-/* defines for lifetime.
-   A positive number is a time-from-last use in seconds */
-
-#define MS_LIFE_FOREVER       -1
-#define MS_LIFE_ZEROREF       -2
-#define MS_LIFE_SINGLE        -3
-
-typedef struct {
-  enum MS_CONNECTION_TYPE connectiontype;
-  char *connection;
-
-  int   lifespan;
-  int   ref_count;
-  void*   thread_id;
-  int   debug;
-
-  time_t last_used;
-
-  void  *conn_handle;
-
-  void  (*close)( void * );
-} connectionObj;
-
-/*
-** These static structures are protected by the TLOCK_POOL mutex.
-*/
-
-static int connectionCount = 0;
-static int connectionMax = 0;
-static connectionObj *connections = NULL;
-
-/************************************************************************/
-/*                         msConnPoolRegister()                         */
-/*                                                                      */
-/*      Register a new connection with the connection pool tracker.     */
-/************************************************************************/
-
-void msConnPoolRegister( layerObj *layer,
-                         void *conn_handle,
-                         void (*close_func)( void * ) )
-
-{
-  const char *close_connection = NULL;
-  connectionObj *conn = NULL;
-
-  if( layer->debug )
-    msDebug( "msConnPoolRegister(%s,%s,%p)\n",
-             layer->name, layer->connection, conn_handle );
-
-  /* -------------------------------------------------------------------- */
-  /*      We can't meaningful keep a connection with no connection or     */
-  /*      connection type string on the layer.                            */
-  /* -------------------------------------------------------------------- */
-  if( layer->connection == NULL ) {
-    if( layer->tileindex != NULL
-        && layer->connectiontype == MS_OGR ) {
-      /* this is ok, no need to make a fuss */
-    } else {
-      msDebug( "%s: Missing CONNECTION on layer %s.\n",
-               "msConnPoolRegister()",
-               layer->name );
-
-      msSetError( MS_MISCERR,
-                  "Missing CONNECTION on layer %s.",
-                  "msConnPoolRegister()",
-                  layer->name );
-    }
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Grow the array of connection information objects if needed.     */
-  /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_POOL );
-
-  if( connectionCount == connectionMax ) {
-    connectionMax += 10;
-    connectionObj* newConnections = (connectionObj *)
-                  realloc(connections,
-                          sizeof(connectionObj) * connectionMax );
-    if( newConnections == NULL ) {
-      msSetError(MS_MEMERR, NULL, "msConnPoolRegister()");
-      msReleaseLock( TLOCK_POOL );
-      return;
-    }
-    connections = newConnections;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Set the new connection information.                             */
-  /* -------------------------------------------------------------------- */
-  conn = connections + connectionCount;
-
-  connectionCount++;
-
-  conn->connectiontype = layer->connectiontype;
-  conn->connection = msStrdup( layer->connection );
-  conn->close = close_func;
-  conn->ref_count = 1;
-  conn->thread_id = msGetThreadId();
-  conn->last_used = time(NULL);
-  conn->conn_handle = conn_handle;
-  conn->debug = layer->debug;
-
-  /* -------------------------------------------------------------------- */
-  /*      Categorize the connection handling information.                 */
-  /* -------------------------------------------------------------------- */
-  close_connection =
-    msLayerGetProcessingKey( layer, "CLOSE_CONNECTION" );
-
-  if( close_connection == NULL )
-    close_connection = "NORMAL";
-
-  if( strcasecmp(close_connection,"NORMAL") == 0 )
-    conn->lifespan = MS_LIFE_ZEROREF;
-  else if( strcasecmp(close_connection,"DEFER") == 0 )
-    conn->lifespan = MS_LIFE_FOREVER;
-  else if( strcasecmp(close_connection,"ALWAYS") == 0 )
-    conn->lifespan = MS_LIFE_SINGLE;
-  else {
-    msDebug("msConnPoolRegister(): "
-            "Unrecognised CLOSE_CONNECTION value '%s'\n",
-            close_connection );
-
-    msSetError( MS_MISCERR, "Unrecognised CLOSE_CONNECTION value '%s'",
-                "msConnPoolRegister()",
-                close_connection );
-    conn->lifespan = MS_LIFE_ZEROREF;
-  }
-
-  msReleaseLock( TLOCK_POOL );
-}
-
-/************************************************************************/
-/*                          msConnPoolClose()                           */
-/*                                                                      */
-/*      Close the indicated connection.  The index in the connection    */
-/*      table is passed.  Remove the connection from the table as       */
-/*      well.                                                           */
-/************************************************************************/
-
-static void msConnPoolClose( int conn_index )
-
-{
-  connectionObj *conn = connections + conn_index;
-
-  if( conn->ref_count > 0 ) {
-    if( conn->debug )
-      msDebug( "msConnPoolClose(): "
-               "Closing connection %s even though ref_count=%d.\n",
-               conn->connection, conn->ref_count );
-
-    msSetError( MS_MISCERR,
-                "Closing connection %s even though ref_count=%d.",
-                "msConnPoolClose()",
-                conn->connection,
-                conn->ref_count );
-  }
-
-  if( conn->debug )
-    msDebug( "msConnPoolClose(%s,%p)\n",
-             conn->connection, conn->conn_handle );
-
-  if( conn->close != NULL )
-    conn->close( conn->conn_handle );
-
-  /* free malloced() stuff in this connection */
-  free( conn->connection );
-
-  connectionCount--;
-  if( connectionCount == 0 ) {
-    /* if there are no connections left we will "cleanup".  */
-    connectionMax = 0;
-    free( connections );
-    connections = NULL;
-  } else {
-    /* move the last connection in place of our now closed one */
-    memcpy( connections + conn_index,
-            connections + connectionCount,
-            sizeof(connectionObj) );
-  }
-}
-
-/************************************************************************/
-/*                         msConnPoolRequest()                          */
-/*                                                                      */
-/*      Ask for a connection from the connection pool for use with      */
-/*      the current layer.  If found (CONNECTION and CONNECTIONTYPE     */
-/*      match) then return it and up the ref count.  Otherwise          */
-/*      return NULL.                                                    */
-/************************************************************************/
-
-void *msConnPoolRequest( layerObj *layer )
-
-{
-  int  i;
-  const char* close_connection;
-
-  if( layer->connection == NULL )
-    return NULL;
-
-  /* check if we must always create a new connection */
-  close_connection = msLayerGetProcessingKey( layer, "CLOSE_CONNECTION" );
-  if( close_connection && strcasecmp(close_connection,"ALWAYS") == 0 )
-    return NULL;
-
-  msAcquireLock( TLOCK_POOL );
-  for( i = 0; i < connectionCount; i++ ) {
-    connectionObj *conn = connections + i;
-
-    if( layer->connectiontype == conn->connectiontype
-        && strcasecmp( layer->connection, conn->connection ) == 0
-        && (conn->ref_count == 0 || conn->thread_id == msGetThreadId())
-        && conn->lifespan != MS_LIFE_SINGLE) {
-      void *conn_handle = NULL;
-
-      conn->ref_count++;
-      conn->thread_id = msGetThreadId();
-      conn->last_used = time(NULL);
-
-      if( layer->debug ) {
-        msDebug( "msConnPoolRequest(%s,%s) -> got %p\n",
-                 layer->name, layer->connection, conn->conn_handle );
-        conn->debug = layer->debug;
-      }
-
-      conn_handle = conn->conn_handle;
-
-      msReleaseLock( TLOCK_POOL );
-      return conn_handle;
-    }
-  }
-
-  msReleaseLock( TLOCK_POOL );
-
-  return NULL;
-}
-
-/************************************************************************/
-/*                         msConnPoolRelease()                          */
-/*                                                                      */
-/*      Release the passed connection for the given layer.              */
-/*      Internally the reference count is dropped, and the              */
-/*      connection may be closed.  We assume the caller has already     */
-/*      acquired the pool lock.                                         */
-/************************************************************************/
-
-void msConnPoolRelease( layerObj *layer, void *conn_handle )
-
-{
-  int  i;
-
-  if( layer->debug )
-    msDebug( "msConnPoolRelease(%s,%s,%p)\n",
-             layer->name, layer->connection, conn_handle );
-
-  if( layer->connection == NULL )
-    return;
-
-  msAcquireLock( TLOCK_POOL );
-  for( i = 0; i < connectionCount; i++ ) {
-    connectionObj *conn = connections + i;
-
-    if( layer->connectiontype == conn->connectiontype
-        && strcasecmp( layer->connection, conn->connection ) == 0
-        && conn->conn_handle == conn_handle ) {
-      conn->ref_count--;
-      conn->last_used = time(NULL);
-
-      if( conn->ref_count == 0 )
-        conn->thread_id = 0;
-
-      if( conn->ref_count == 0 && (conn->lifespan == MS_LIFE_ZEROREF || conn->lifespan == MS_LIFE_SINGLE) )
-        msConnPoolClose( i );
-
-      msReleaseLock( TLOCK_POOL );
-      return;
-    }
-  }
-
-  msReleaseLock( TLOCK_POOL );
-
-  msDebug( "%s: Unable to find handle for layer '%s'.\n",
-           "msConnPoolRelease()",
-           layer->name );
-
-  msSetError( MS_MISCERR,
-              "Unable to find handle for layer '%s'.",
-              "msConnPoolRelease()",
-              layer->name );
-}
-
-/************************************************************************/
-/*                   msConnPoolMapCloseUnreferenced()                   */
-/*                                                                      */
-/*      Close any unreferenced connections.                             */
-/************************************************************************/
-
-void msConnPoolCloseUnreferenced()
-
-{
-  int  i;
-
-  /* this really needs to be commented out before commiting.  */
-  /* msDebug( "msConnPoolCloseUnreferenced()\n" ); */
-
-  msAcquireLock( TLOCK_POOL );
-  for( i = connectionCount - 1; i >= 0; i-- ) {
-    connectionObj *conn = connections + i;
-
-    if( conn->ref_count == 0 ) {
-      /* for now we don't assume the locks are re-entrant, so release */
-      /* it so msConnPoolClose() can get it.  */
-      msConnPoolClose( i );
-    }
-  }
-  msReleaseLock( TLOCK_POOL );
-}
-
-/************************************************************************/
-/*                       msConnPoolFinalCleanup()                       */
-/*                                                                      */
-/*      Close any remaining open connections.   This is normally        */
-/*      called just before (voluntary) application termination.         */
-/************************************************************************/
-
-void msConnPoolFinalCleanup()
-
-{
-  /* this really needs to be commented out before commiting.  */
-  /* msDebug( "msConnPoolFinalCleanup()\n" ); */
-
-  msAcquireLock( TLOCK_POOL );
-  while( connectionCount > 0 )
-    msConnPoolClose( 0 );
-  msReleaseLock( TLOCK_POOL );
-}
diff -pruN 8.0.1-5/mappostgis.cpp 8.2.0~beta1-1~exp1/mappostgis.cpp
--- 8.0.1-5/mappostgis.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mappostgis.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,3930 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  PostGIS CONNECTIONTYPE support.
- * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
- *           Dave Blasby <dblasby@gmail.com>
- *
- ******************************************************************************
- * Copyright (c) 2010 Paul Ramsey
- * Copyright (c) 2002 Refractions Research
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/*
-** Some theory of operation:
-**
-** Build SQL from DATA statement and LAYER state. SQL is always of the form:
-**
-**    SELECT [this, that, other], geometry, uid
-**      FROM [table|(subquery) as sub]
-**      WHERE [box] AND [filter]
-**
-** So the geometry always resides at layer->numitems and the uid always
-** resides at layer->numitems + 1
-**
-** Geometry is requested as Hex encoded WKB. The endian is always requested
-** as the client endianness.
-**
-** msPostGISLayerWhichShapes creates SQL based on DATA and LAYER state,
-** executes it, and places the un-read PGresult handle in the layerinfo->pgresult,
-** setting the layerinfo->rownum to 0.
-**
-** msPostGISNextShape reads a row, increments layerinfo->rownum, and returns
-** MS_SUCCESS, until rownum reaches ntuples, and it returns MS_DONE instead.
-**
-*/
-
-/* required for MSVC */
-#define _USE_MATH_DEFINES
-
-#include <assert.h>
-#include <string.h>
-#include <math.h>
-#include "mapserver.h"
-#include "maptime.h"
-#include "mappostgis.h"
-#include "mapows.h"
-
-#include <vector>
-
-#define FP_EPSILON 1e-12
-#define FP_EQ(a, b) (fabs((a)-(b)) < FP_EPSILON)
-#define FP_LEFT -1
-#define FP_RIGHT 1
-#define FP_COLINEAR 0
-
-#define SEGMENT_ANGLE 10.0
-#define SEGMENT_MINPOINTS 10
-
-#define WKBZOFFSET_NONISO 0x80000000
-#define WKBMOFFSET_NONISO 0x40000000
-
-#define HAS_Z   0x1
-#define HAS_M   0x2
-
-#if TRANSFER_ENCODING == 256
-#define RESULTSET_TYPE 1
-#else
-#define RESULTSET_TYPE 0
-#endif
-
-/* These are the OIDs for some builtin types, as returned by PQftype(). */
-/* They were copied from pg_type.h in src/include/catalog/pg_type.h */
-
-#ifndef BOOLOID
-#define BOOLOID                 16
-#define BYTEAOID                17
-#define CHAROID                 18
-#define NAMEOID                 19
-#define INT8OID                 20
-#define INT2OID                 21
-#define INT2VECTOROID           22
-#define INT4OID                 23
-#define REGPROCOID              24
-#define TEXTOID                 25
-#define OIDOID                  26
-#define TIDOID                  27
-#define XIDOID                  28
-#define CIDOID                  29
-#define OIDVECTOROID            30
-#define FLOAT4OID               700
-#define FLOAT8OID               701
-#define INT4ARRAYOID            1007
-#define TEXTARRAYOID            1009
-#define BPCHARARRAYOID          1014
-#define VARCHARARRAYOID         1015
-#define FLOAT4ARRAYOID          1021
-#define FLOAT8ARRAYOID          1022
-#define BPCHAROID   1042
-#define VARCHAROID    1043
-#define DATEOID     1082
-#define TIMEOID     1083
-#define TIMETZOID     1266
-#define TIMESTAMPOID          1114
-#define TIMESTAMPTZOID          1184
-#define NUMERICOID              1700
-#endif
-
-#ifdef USE_POSTGIS
-
-static int wkbConvGeometryToShape(wkbObj *w, shapeObj *shape);
-static int arcStrokeCircularString(wkbObj *w, double segment_angle, lineObj *line, int nZMFlag);
-
-/*
-** msPostGISCloseConnection()
-**
-** Handler registered witih msConnPoolRegister so that Mapserver
-** can clean up open connections during a shutdown.
-*/
-static void msPostGISCloseConnection(void *pgconn)
-{
-  PQfinish((PGconn*)pgconn);
-}
-
-/*
-** msPostGISCreateLayerInfo()
-*/
-static msPostGISLayerInfo *msPostGISCreateLayerInfo(void)
-{
-  msPostGISLayerInfo *layerinfo = new msPostGISLayerInfo;
-  layerinfo->paging = MS_TRUE;
-  layerinfo->force2d = MS_FALSE;
-  return layerinfo;
-}
-
-/*
-** msPostGISFreeLayerInfo()
-*/
-static void msPostGISFreeLayerInfo(layerObj *layer)
-{
-  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo*)layer->layerinfo;
-  if ( layerinfo->pgresult ) PQclear(layerinfo->pgresult);
-  if ( layerinfo->pgconn ) msConnPoolRelease(layer, layerinfo->pgconn);
-  delete layerinfo;
-  layer->layerinfo = nullptr;
-}
-
-
-/*
-** postgresqlNoticeHandler()
-**
-** Propagate messages from the database to the Mapserver log,
-** set in PQsetNoticeProcessor during layer open.
-*/
-static void postresqlNoticeHandler(void *arg, const char *message)
-{
-  layerObj *lp = (layerObj*)arg;
-
-  if (lp->debug) {
-    msDebug("%s\n", message);
-  }
-}
-
-
-/*
-** Expandable pointObj array. The lineObj unfortunately
-** is not useful for this purpose, so we have this one.
-*/
-static std::vector<pointObj> pointArrayNew(int maxpoints)
-{
-  auto v = std::vector<pointObj>();
-  v.reserve(maxpoints);
-  return v;
-}
-
-/*
-** Add a pointObj to the pointObjArray.
-*/
-static void
-pointArrayAddPoint(std::vector<pointObj>& v, const pointObj& p)
-{
-  v.push_back(p);
-}
-
-/*
-** Pass an input type number through the PostGIS version
-** type map array to handle the pre-2.0 incorrect WKB types
-*/
-
-static int
-wkbTypeMap(wkbObj *w, int type, int* pnZMFlag)
-{
-  *pnZMFlag = 0;
-  /* PostGIS >= 2 : ISO SQL/MM style Z types ? */
-  if( type >= 1000 && type < 2000 )
-  {
-    type -= 1000;
-    *pnZMFlag = HAS_Z;
-  }
-  /* PostGIS >= 2 : ISO SQL/MM style M types ? */
-  else if( type >= 2000 && type < 3000 )
-  {
-    type -= 2000;
-    *pnZMFlag = HAS_M;
-  }
-  /* PostGIS >= 2 : ISO SQL/MM style ZM types ? */
-  else if( type >= 3000 && type < 4000 )
-  {
-    type -= 3000;
-    *pnZMFlag = HAS_Z | HAS_M;
-  }
-  /* PostGIS 1.X EWKB : Extended WKB Z or ZM ? */
-  else if( (type & WKBZOFFSET_NONISO) != 0 )
-  {
-    if( (type & WKBMOFFSET_NONISO) != 0 )
-        *pnZMFlag = HAS_Z | HAS_M;
-    else
-        *pnZMFlag = HAS_Z;
-    type &= 0x00FFFFFF;
-  }
-  /* PostGIS 1.X EWKB: Extended WKB M ? */
-  else if( (type & WKBMOFFSET_NONISO) != 0 )
-  {
-    *pnZMFlag = HAS_M;
-    type &= 0x00FFFFFF;
-  }
-  if ( type >= 0 && type < WKB_TYPE_COUNT )
-    return w->typemap[type];
-  else
-    return 0;
-}
-
-/*
-** Read the WKB type number from a wkbObj without
-** advancing the read pointer.
-*/
-static int
-wkbType(wkbObj *w, int* pnZMFlag)
-{
-  int t;
-  memcpy(&t, (w->ptr + 1), sizeof(int));
-  return wkbTypeMap(w,t, pnZMFlag);
-}
-
-/*
-** Read the type number of the first element of a
-** collection without advancing the read pointer.
-*/
-static int
-wkbCollectionSubType(wkbObj *w, int* pnZMFlag)
-{
-  int t;
-  memcpy(&t, (w->ptr + 1 + 4 + 4 + 1), sizeof(int));
-  return wkbTypeMap(w,t, pnZMFlag);
-}
-
-/*
-** Read one byte from the WKB and advance the read pointer
-*/
-static char
-wkbReadChar(wkbObj *w)
-{
-  char c;
-  memcpy(&c, w->ptr, sizeof(char));
-  w->ptr += sizeof(char);
-  return c;
-}
-
-/*
-** Read one integer from the WKB and advance the read pointer.
-** We assume the endianess of the WKB is the same as this machine.
-*/
-static inline int
-wkbReadInt(wkbObj *w)
-{
-  int i;
-  memcpy(&i, w->ptr, sizeof(int));
-  w->ptr += sizeof(int);
-  return i;
-}
-
-/*
-** Read one pointObj (two doubles) from the WKB and advance the read pointer.
-** We assume the endianess of the WKB is the same as this machine.
-*/
-static inline void
-wkbReadPointP(wkbObj *w, pointObj *p, int nZMFlag)
-{
-  memcpy(&(p->x), w->ptr, sizeof(double));
-  w->ptr += sizeof(double);
-  memcpy(&(p->y), w->ptr, sizeof(double));
-  w->ptr += sizeof(double);
-  if( nZMFlag & HAS_Z )
-  {
-      memcpy(&(p->z), w->ptr, sizeof(double));
-      w->ptr += sizeof(double);
-  }
-  else
-  {
-      p->z = 0;
-  }
-  if( nZMFlag & HAS_M )
-  {
-      memcpy(&(p->m), w->ptr, sizeof(double));
-      w->ptr += sizeof(double);
-  }
-  else
-  {
-      p->m = 0;
-  }
-}
-
-/*
-** Read one pointObj (two doubles) from the WKB and advance the read pointer.
-** We assume the endianess of the WKB is the same as this machine.
-*/
-static inline pointObj
-wkbReadPoint(wkbObj *w, int nZMFlag)
-{
-  pointObj p;
-  wkbReadPointP(w, &p, nZMFlag);
-  return p;
-}
-
-/*
-** Read a "point array" and return an allocated lineObj.
-** A point array is a WKB fragment that starts with a
-** point count, which is followed by that number of doubles * 2.
-** Linestrings, circular strings, polygon rings, all show this
-** form.
-*/
-static void
-wkbReadLine(wkbObj *w, lineObj *line, int nZMFlag)
-{
-  pointObj p;
-  const int npoints = wkbReadInt(w);
-  if( npoints > (int)((w->size - (w->ptr - w->wkb)) / 16) )
-    return;
-
-  line->numpoints = npoints;
-  line->point =(pointObj*) msSmallMalloc(npoints * sizeof(pointObj));
-  for ( int i = 0; i < npoints; i++ ) {
-    wkbReadPointP(w, &p, nZMFlag);
-    line->point[i] = p;
-  }
-}
-
-/*
-** Advance the read pointer past a geometry without returning any
-** values. Used for skipping un-drawable elements in a collection.
-*/
-static void
-wkbSkipGeometry(wkbObj *w)
-{
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-  const int nCoordDim = 2 + (((nZMFlag & HAS_Z) != 0) ? 1 : 0) + (((nZMFlag & HAS_M) != 0) ? 1 : 0);
-  switch(type) {
-    case WKB_POINT:
-      w->ptr += nCoordDim * sizeof(double);
-      break;
-    case WKB_CIRCULARSTRING:
-    case WKB_LINESTRING: {
-      const int npoints = wkbReadInt(w);
-      w->ptr += npoints * nCoordDim * sizeof(double);
-      break;
-    }
-    case WKB_POLYGON: {
-      const int nrings = wkbReadInt(w);
-      if( nrings > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-        return;
-      for ( int i = 0; i < nrings; i++ ) {
-        const int npoints = wkbReadInt(w);
-        w->ptr += npoints * nCoordDim * sizeof(double);
-      }
-      break;
-    }
-    case WKB_MULTIPOINT:
-    case WKB_MULTILINESTRING:
-    case WKB_MULTIPOLYGON:
-    case WKB_GEOMETRYCOLLECTION:
-    case WKB_COMPOUNDCURVE:
-    case WKB_CURVEPOLYGON:
-    case WKB_MULTICURVE:
-    case WKB_MULTISURFACE: {
-      const int ngeoms = wkbReadInt(w);
-      if( ngeoms > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-        return;
-      for ( int i = 0; i < ngeoms; i++ ) {
-        wkbSkipGeometry(w);
-      }
-      break;
-    }
-  }
-}
-
-/*
-** Convert a WKB point to a shapeObj, advancing the read pointer as we go.
-*/
-static int
-wkbConvPointToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w),&nZMFlag);
-
-  if( type != WKB_POINT ) return MS_FAILURE;
-
-  if( ! (shape->type == MS_SHAPE_POINT) ) return MS_FAILURE;
-  lineObj line;
-  line.numpoints = 1;
-  line.point = (pointObj*) msSmallMalloc(sizeof(pointObj));
-  line.point[0] = wkbReadPoint(w, nZMFlag);
-  msAddLineDirectly(shape, &line);
-  return MS_SUCCESS;
-}
-
-/*
-** Convert a WKB line string to a shapeObj, advancing the read pointer as we go.
-*/
-static int
-wkbConvLineStringToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-
-  if( type != WKB_LINESTRING ) return MS_FAILURE;
-
-  lineObj line;
-  wkbReadLine(w,&line, nZMFlag);
-  msAddLineDirectly(shape, &line);
-
-  return MS_SUCCESS;
-}
-
-/*
-** Convert a WKB polygon to a shapeObj, advancing the read pointer as we go.
-*/
-static int
-wkbConvPolygonToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-
-  if( type != WKB_POLYGON ) return MS_FAILURE;
-
-  /* How many rings? */
-  const int nrings = wkbReadInt(w);
-  if( nrings > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-    return MS_FAILURE;
-
-  /* Add each ring to the shape */
-  lineObj line;
-  for( int i = 0; i < nrings; i++ ) {
-    wkbReadLine(w,&line, nZMFlag);
-    msAddLineDirectly(shape, &line);
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Convert a WKB curve polygon to a shapeObj, advancing the read pointer as we go.
-** The arc portions of the rings will be stroked to linestrings as they
-** are read by the underlying circular string handling.
-*/
-static int
-wkbConvCurvePolygonToShape(wkbObj *w, shapeObj *shape)
-{
-  const int was_poly = ( shape->type == MS_SHAPE_POLYGON );
-
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-  if( type != WKB_CURVEPOLYGON ) return MS_FAILURE;
-
-  const int ncomponents = wkbReadInt(w);
-  if( ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-    return MS_FAILURE;
-
-  /* Lower the allowed dimensionality so we can
-  *  catch the linear ring components */
-  shape->type = MS_SHAPE_LINE;
-
-  int failures = 0;
-  for ( int i = 0; i < ncomponents; i++ ) {
-    if ( wkbConvGeometryToShape(w, shape) == MS_FAILURE ) {
-      wkbSkipGeometry(w);
-      failures++;
-    }
-  }
-
-  /* Go back to expected dimensionality */
-  if ( was_poly) shape->type = MS_SHAPE_POLYGON;
-
-  if ( failures == ncomponents )
-    return MS_FAILURE;
-  else
-    return MS_SUCCESS;
-}
-
-/*
-** Convert a WKB circular string to a shapeObj, advancing the read pointer as we go.
-** Arcs will be stroked to linestrings.
-*/
-static int
-wkbConvCircularStringToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-
-  if( type != WKB_CIRCULARSTRING ) return MS_FAILURE;
-
-  lineObj line = {0, nullptr};
-  /* Stroke the string into a point array */
-  if ( arcStrokeCircularString(w, SEGMENT_ANGLE, &line, nZMFlag) == MS_FAILURE ) {
-    if(line.point) free(line.point);
-    return MS_FAILURE;
-  }
-
-  /* Fill in the lineObj */
-  if ( line.numpoints > 0 ) {
-    msAddLine(shape, &line);
-    if(line.point) free(line.point);
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Compound curves need special handling. First we load
-** each component of the curve on the a lineObj in a shape.
-** Then we merge those lineObjs into a single lineObj. This
-** allows compound curves to serve as closed rings in
-** curve polygons.
-*/
-static int
-wkbConvCompoundCurveToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-
-  /* Init our shape buffer */
-  shapeObj shapebuf;
-  msInitShape(&shapebuf);
-
-  if( type != WKB_COMPOUNDCURVE ) return MS_FAILURE;
-
-  /* How many components in the compound curve? */
-  const int ncomponents = wkbReadInt(w);
-  if( ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-    return MS_FAILURE;
-
-  /* We'll load each component onto a line in a shape */
-  for( int i = 0; i < ncomponents; i++ )
-    wkbConvGeometryToShape(w, &shapebuf);
-
-  /* Do nothing on empty */
-  if ( shapebuf.numlines == 0 )
-    return MS_FAILURE;
-
-  /* Count the total number of points */
-  int npoints = 0;
-  for( int i = 0; i < shapebuf.numlines; i++ )
-    npoints += shapebuf.line[i].numpoints;
-
-  /* Do nothing on empty */
-  if ( npoints == 0 )
-    return MS_FAILURE;
-
-  lineObj line;
-  line.numpoints = npoints;
-  line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * npoints);
-
-  /* Copy in the points */
-  npoints = 0;
-  for ( int i = 0; i < shapebuf.numlines; i++ ) {
-    for ( int j = 0; j < shapebuf.line[i].numpoints; j++ ) {
-      /* Don't add a start point that duplicates an endpoint */
-      if( j == 0 && i > 0 &&
-          memcmp(&(line.point[npoints - 1]),&(shapebuf.line[i].point[j]),sizeof(pointObj)) == 0 ) {
-        continue;
-      }
-      line.point[npoints++] = shapebuf.line[i].point[j];
-    }
-  }
-  line.numpoints = npoints;
-
-  /* Clean up */
-  msFreeShape(&shapebuf);
-
-  /* Fill in the lineObj */
-  msAddLineDirectly(shape, &line);
-
-  return MS_SUCCESS;
-}
-
-/*
-** Convert a WKB collection string to a shapeObj, advancing the read pointer as we go.
-** Many WKB types (MultiPoint, MultiLineString, MultiPolygon, MultiSurface,
-** MultiCurve, GeometryCollection) can be treated identically as collections
-** (they start with endian, type number and count of sub-elements, then provide the
-** subelements as WKB) so are handled with this one function.
-*/
-static int
-wkbConvCollectionToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
-  int nZMFlag;
-  /*type = */wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-  const int ncomponents = wkbReadInt(w);
-  if( ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-    return MS_FAILURE;
-
-  /*
-  * If we can draw any portion of the collection, we will,
-  * but if all the components fail, we will draw nothing.
-  */
-  int failures = 0;
-  for ( int i = 0; i < ncomponents; i++ ) {
-    if ( wkbConvGeometryToShape(w, shape) == MS_FAILURE ) {
-      wkbSkipGeometry(w);
-      failures++;
-    }
-  }
-  if ( failures == ncomponents || ncomponents == 0)
-    return MS_FAILURE;
-  else
-    return MS_SUCCESS;
-}
-
-/*
-** Generic handler to switch to the appropriate function for the WKB type.
-** Note that we also handle switching here to avoid processing shapes
-** we will be unable to draw. Example: we can't draw point features as
-** a MS_SHAPE_LINE layer, so if the type is WKB_POINT and the layer is
-** MS_SHAPE_LINE, we exit before converting.
-*/
-static int
-wkbConvGeometryToShape(wkbObj *w, shapeObj *shape)
-{
-  int nZMFlag;
-  const int wkbtype = wkbType(w, &nZMFlag); /* Peak at the type number */
-
-  switch(wkbtype) {
-      /* Recurse into anonymous collections */
-    case WKB_GEOMETRYCOLLECTION:
-      return wkbConvCollectionToShape(w, shape);
-      /* Handle area types */
-    case WKB_POLYGON:
-      return wkbConvPolygonToShape(w, shape);
-    case WKB_MULTIPOLYGON:
-      return wkbConvCollectionToShape(w, shape);
-    case WKB_CURVEPOLYGON:
-      return wkbConvCurvePolygonToShape(w, shape);
-    case WKB_MULTISURFACE:
-      return wkbConvCollectionToShape(w, shape);
-  }
-
-  /* We can't convert any of the following types into polygons */
-  if ( shape->type == MS_SHAPE_POLYGON ) return MS_FAILURE;
-
-  /* Handle linear types */
-  switch(wkbtype) {
-    case WKB_LINESTRING:
-      return wkbConvLineStringToShape(w, shape);
-    case WKB_CIRCULARSTRING:
-      return wkbConvCircularStringToShape(w, shape);
-    case WKB_COMPOUNDCURVE:
-      return wkbConvCompoundCurveToShape(w, shape);
-    case WKB_MULTILINESTRING:
-      return wkbConvCollectionToShape(w, shape);
-    case WKB_MULTICURVE:
-      return wkbConvCollectionToShape(w, shape);
-  }
-
-  /* We can't convert any of the following types into lines */
-  if ( shape->type == MS_SHAPE_LINE ) return MS_FAILURE;
-
-  /* Handle point types */
-  switch(wkbtype) {
-    case WKB_POINT:
-      return wkbConvPointToShape(w, shape);
-    case WKB_MULTIPOINT:
-      return wkbConvCollectionToShape(w, shape);
-  }
-
-  /* This is a WKB type we don't know about! */
-  return MS_FAILURE;
-}
-
-
-/*
-** What side of p1->p2 is q on?
-*/
-static inline int
-arcSegmentSide(const pointObj &p1, const pointObj &p2, const pointObj &q)
-{
-  double side = ( (q.x - p1.x) * (p2.y - p1.y) - (p2.x - p1.x) * (q.y - p1.y) );
-  if ( FP_EQ(side,0.0) ) {
-    return FP_COLINEAR;
-  } else {
-    if ( side < 0.0 )
-      return FP_LEFT;
-    else
-      return FP_RIGHT;
-  }
-}
-
-/*
-** Calculate the center of the circle defined by three points.
-** Using matrix approach from http://mathforum.org/library/drmath/view/55239.html
-*/
-static int
-arcCircleCenter(const pointObj& p1, const pointObj& p2, const pointObj& p3, pointObj *center, double *radius)
-{
-  pointObj c{}; // initialize
-  double r;
-
-  /* Circle is closed, so p2 must be opposite p1 & p3. */
-  if ((fabs(p1.x - p3.x) < FP_EPSILON) && (fabs(p1.y-p3.y) < FP_EPSILON)) {
-    c.x = p1.x + (p2.x - p1.x) / 2.0;
-    c.y = p1.y + (p2.y - p1.y) / 2.0;
-    r = sqrt(pow(c.x - p1.x, 2.0) + pow(c.y - p1.y, 2.0));
-  }
-  /* There is no circle here, the points are actually co-linear */
-  else if ( arcSegmentSide(p1, p3, p2) == FP_COLINEAR ) {
-    return MS_FAILURE;
-  }
-  /* Calculate the center and radius. */
-  else {
-
-    /* Radius */
-    const double dx21 = p2.x - p1.x;
-    const double dy21 = p2.y - p1.y;
-    const double dx31 = p3.x - p1.x;
-    const double dy31 = p3.y - p1.y;
-
-    const double h21 = pow(dx21, 2.0) + pow(dy21, 2.0);
-    const double h31 = pow(dx31, 2.0) + pow(dy31, 2.0);
-
-    /* 2 * |Cross product|, d<0 means clockwise and d>0 counterclockwise sweeping angle */
-    const double d = 2 * (dx21 * dy31 - dx31 * dy21);
-
-    c.x = p1.x + (h21 * dy31 - h31 * dy21) / d;
-    c.y = p1.y - (h21 * dx31 - h31 * dx21) / d;
-    r = sqrt(pow(c.x - p1.x, 2) + pow(c.y - p1.y, 2));
-  }
-
-  if ( radius ) *radius = r;
-  if ( center ) *center = c;
-
-  return MS_SUCCESS;
-}
-
-/*
-** Write a stroked version of the circle defined by three points into a
-** point buffer. The segment_angle (degrees) is the coverage of each stroke segment,
-** and depending on whether this is the first arc in a circularstring,
-** you might want to include_first
-*/
-static int
-arcStrokeCircle(const pointObj& p1, const pointObj& p2, const pointObj& p3,
-                double segment_angle, int include_first, std::vector<pointObj>& pa)
-{
-  const int side = arcSegmentSide(p1, p3, p2); /* What side of p1,p3 is the middle point? */
-  int is_closed = MS_FALSE;
-
-  /* We need to know if we're dealing with a circle early */
-  if ( FP_EQ(p1.x, p3.x) && FP_EQ(p1.y, p3.y) )
-    is_closed = MS_TRUE;
-
-  /* Check if the "arc" is actually straight */
-  if ( ! is_closed && side == FP_COLINEAR ) {
-    /* We just need to write in the end points */
-    if ( include_first )
-      pointArrayAddPoint(pa, p1);
-    pointArrayAddPoint(pa, p3);
-    return MS_SUCCESS;
-  }
-
-  /* We should always be able to find the center of a non-linear arc */
-  pointObj center; /* Center of our circular arc */
-  double radius; /* Radius of our circular arc */
-  if ( arcCircleCenter(p1, p2, p3, &center, &radius) == MS_FAILURE )
-    return MS_FAILURE;
-
-  /* Calculate the angles relative to center that our three points represent */
-  const double a1 = atan2(p1.y - center.y, p1.x - center.x);
-  /* UNUSED
-  a2 = atan2(p2.y - center.y, p2.x - center.x);
-   */
-  const double a3 = atan2(p3.y - center.y, p3.x - center.x);
-  double segment_angle_r = M_PI * segment_angle / 180.0; /* Segment angle in radians */
-
-  double sweep_angle_r; /* Total angular size of our circular arc in radians */
-  /* Closed-circle case, we sweep the whole circle! */
-  if ( is_closed ) {
-    sweep_angle_r = 2.0 * M_PI;
-  }
-  /* Clockwise sweep direction */
-  else if ( side == FP_LEFT ) {
-    if ( a3 > a1 ) /* Wrapping past 180? */
-      sweep_angle_r = a1 + (2.0 * M_PI - a3);
-    else
-      sweep_angle_r = a1 - a3;
-  }
-  /* Counter-clockwise sweep direction */
-  else if ( side == FP_RIGHT ) {
-    if ( a3 > a1 ) /* Wrapping past 180? */
-      sweep_angle_r = a3 - a1;
-    else
-      sweep_angle_r = a3 + (2.0 * M_PI - a1);
-  } else
-    sweep_angle_r = 0.0;
-
-  /* We don't have enough resolution, let's invert our strategy. */
-  if ( (sweep_angle_r / segment_angle_r) < SEGMENT_MINPOINTS ) {
-    segment_angle_r = sweep_angle_r / (SEGMENT_MINPOINTS + 1);
-  }
-
-  /* We don't have enough resolution to stroke this arc,
-  *  so just join the start to the end. */
-  if ( sweep_angle_r < segment_angle_r ) {
-    if ( include_first )
-      pointArrayAddPoint(pa, p1);
-    pointArrayAddPoint(pa, p3);
-    return MS_SUCCESS;
-  }
-
-  /* How many edges to generate (we add the final edge
-  *  by sticking on the last point */
-  int num_edges = floor(sweep_angle_r / fabs(segment_angle_r));
-
-  /* Go backwards (negative angular steps) if we are stroking clockwise */
-  if ( side == FP_LEFT )
-    segment_angle_r *= -1;
-
-  /* What point should we start with? */
-  double current_angle_r; /* What angle are we generating now (radians)? */
-  if( include_first ) {
-    current_angle_r = a1;
-  } else {
-    current_angle_r = a1 + segment_angle_r;
-    num_edges--;
-  }
-
-  /* For each edge, increment or decrement by our segment angle */
-  for( int i = 0; i < num_edges; i++ ) {
-    if (segment_angle_r > 0.0 && current_angle_r > M_PI)
-      current_angle_r -= 2*M_PI;
-    if (segment_angle_r < 0.0 && current_angle_r < -1*M_PI)
-      current_angle_r -= 2*M_PI;
-    pointObj p;
-    p.x = center.x + radius*cos(current_angle_r);
-    p.y = center.y + radius*sin(current_angle_r);
-    pointArrayAddPoint(pa, p);
-    current_angle_r += segment_angle_r;
-  }
-
-  /* Add the last point */
-  pointArrayAddPoint(pa, p3);
-  return MS_SUCCESS;
-}
-
-/*
-** This function does not actually take WKB as input, it takes the
-** WKB starting from the numpoints integer. Each three-point edge
-** is stroked into a linestring and appended into the lineObj
-** argument.
-*/
-static int
-arcStrokeCircularString(wkbObj *w, double segment_angle, lineObj *line, int nZMFlag)
-{
-  if ( ! w || ! line ) return MS_FAILURE;
-
-  const int npoints = wkbReadInt(w);
-  const int nedges = npoints / 2;
-
-  /* All CircularStrings have an odd number of points */
-  if ( npoints < 3 || npoints % 2 != 1 )
-    return MS_FAILURE;
-
-  /* Make a large guess at how much space we'll need */
-  auto pa = pointArrayNew(nedges * 180 / segment_angle);
-
-  pointObj p1, p2, p3;
-  wkbReadPointP(w,&p3,nZMFlag);
-
-  /* Fill out the point array with stroked arcs */
-  int edge = 0;
-  while( edge < nedges ) {
-    p1 = p3;
-    wkbReadPointP(w,&p2,nZMFlag);
-    wkbReadPointP(w,&p3,nZMFlag);
-    if ( arcStrokeCircle(p1, p2, p3, segment_angle, edge ? 0 : 1, pa) == MS_FAILURE ) {
-      return MS_FAILURE;
-    }
-    edge++;
-  }
-
-  /* Copy the point array into the line */
-  line->numpoints = static_cast<int>(pa.size());
-  line->point = (pointObj*) msSmallMalloc(line->numpoints * sizeof(pointObj));
-  memcpy(line->point, pa.data(), line->numpoints * sizeof(pointObj));
-
-  return MS_SUCCESS;
-}
-
-
-/*
-** For LAYER types that are not the usual ones (charts,
-** annotations, etc) we will convert to a shape type
-** that "makes sense" given the WKB input. We do this
-** by peaking at the type number of the first collection
-** sub-element.
-*/
-static int
-msPostGISFindBestType(wkbObj *w, shapeObj *shape)
-{
-  /* What kind of geometry is this? */
-  int nZMFlag;
-  int wkbtype = wkbType(w, &nZMFlag);
-
-  /* Generic collection, we need to look a little deeper. */
-  if ( wkbtype == WKB_GEOMETRYCOLLECTION )
-    wkbtype = wkbCollectionSubType(w, &nZMFlag);
-
-  switch ( wkbtype ) {
-    case WKB_POLYGON:
-    case WKB_CURVEPOLYGON:
-    case WKB_MULTIPOLYGON:
-      shape->type = MS_SHAPE_POLYGON;
-      break;
-    case WKB_LINESTRING:
-    case WKB_CIRCULARSTRING:
-    case WKB_COMPOUNDCURVE:
-    case WKB_MULTICURVE:
-    case WKB_MULTILINESTRING:
-      shape->type = MS_SHAPE_LINE;
-      break;
-    case WKB_POINT:
-    case WKB_MULTIPOINT:
-      shape->type = MS_SHAPE_POINT;
-      break;
-    default:
-      return MS_FAILURE;
-  }
-
-  return wkbConvGeometryToShape(w, shape);
-}
-
-/*
-** Get the PostGIS version number from the database as integer.
-** Versions are multiplied out as with PgSQL: 1.5.2 -> 10502, 2.0.0 -> 20000.
-*/
-static int
-msPostGISRetrieveVersion(PGconn *pgconn)
-{
-  static const char* sql = "SELECT postgis_version()";
-  if ( ! pgconn ) {
-    msSetError(MS_QUERYERR, "No open connection.", "msPostGISRetrieveVersion()");
-    return MS_FAILURE;
-  }
-
-  PGresult* pgresult = PQexecParams(pgconn, sql,0, nullptr, nullptr, nullptr, nullptr, 0);
-
-  if ( !pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
-    msDebug("Error executing SQL: (%s) in msPostGISRetrieveVersion()", sql);
-    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.", "msPostGISRetrieveVersion()");
-    return MS_FAILURE;
-  }
-
-  if (PQgetisnull(pgresult, 0, 0)) {
-    PQclear(pgresult);
-    msSetError(MS_QUERYERR,"Null result returned.","msPostGISRetrieveVersion()");
-    return MS_FAILURE;
-  }
-
-  std::string strVersion = PQgetvalue(pgresult, 0, 0);
-  PQclear(pgresult);
-
-  char* ptr = &strVersion[0];
-  char *strParts[3] = { nullptr, nullptr, nullptr };
-  int j = 0;
-  strParts[j++] = &strVersion[0];
-  while( *ptr != '\0' && j < 3 ) {
-    if ( *ptr == '.' ) {
-      *ptr = '\0';
-      strParts[j++] = ptr + 1;
-    }
-    if ( *ptr == ' ' ) {
-      *ptr = '\0';
-      break;
-    }
-    ptr++;
-  }
-
-  int version = 0;
-  int factor = 10000;
-  for( int i = 0; i < j; i++ ) {
-    version += factor * atoi(strParts[i]);
-    factor = factor / 100;
-  }
-
-  return version;
-}
-
-/*
-** Get the PostgreSQL server version number from the database as integer.
-** 12.7.1 ==> 120701
-*/
-static int
-msPostGISRetrievePostgreSQLVersion(PGconn *pgconn)
-{
-  static const char* sql = "SELECT version()";
-  if ( ! pgconn ) {
-    msSetError(MS_QUERYERR, "No open connection.", "msPostGISRetrievePostgreSQLVersion()");
-    return MS_FAILURE;
-  }
-
-  PGresult* pgresult = PQexecParams(pgconn, sql,0, nullptr, nullptr, nullptr, nullptr, 0);
-
-  if ( !pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
-    msDebug("Error executing SQL: (%s) in msPostGISRetrievePostgreSQLVersion()", sql);
-    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.", "msPostGISRetrievePostgreSQLVersion()");
-    return MS_FAILURE;
-  }
-
-  if (PQgetisnull(pgresult, 0, 0)) {
-    PQclear(pgresult);
-    msSetError(MS_QUERYERR,"Null result returned.","msPostGISRetrievePostgreSQLVersion()");
-    return MS_FAILURE;
-  }
-
-  std::string strVersion = PQgetvalue(pgresult, 0, 0);
-  PQclear(pgresult);
-
-  // Skip leading "PostgreSQL " (or other vendorized name)
-  auto nPos = strVersion.find(' ');
-  if( nPos == std::string::npos )
-      return 0;
-
-  char* ptr = &strVersion[nPos + 1];
-  char *strParts[3] = { nullptr, nullptr, nullptr };
-  int j = 0;
-  strParts[j++] = ptr;
-  while( *ptr != '\0' && j < 3 ) {
-    if ( *ptr == '.' ) {
-      *ptr = '\0';
-      strParts[j++] = ptr + 1;
-    }
-    if ( *ptr == ' ' ) {
-      *ptr = '\0';
-      break;
-    }
-    ptr++;
-  }
-
-  int version = 0;
-  int factor = 10000;
-  for( int i = 0; i < j; i++ ) {
-    version += factor * atoi(strParts[i]);
-    factor = factor / 100;
-  }
-
-  return version;
-}
-
-/*
-** msPostGISRetrievePK()
-**
-** Find out that the primary key is for this layer.
-** The layerinfo->fromsource must already be populated and
-** must not be a subquery.
-*/
-static int
-msPostGISRetrievePK(layerObj *layer)
-{
-  char *sql = nullptr;
-
-  if (layer->debug) {
-    msDebug("msPostGISRetrievePK called.\n");
-  }
-
-  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *) layer->layerinfo;
-
-
-  if (layerinfo->pgconn == nullptr) {
-    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.", "msPostGISRetrievePK()");
-    return MS_FAILURE;
-  }
-
-  {
-    /* Attempt to separate fromsource into schema.table */
-    std::string schema;
-    std::string table;
-    const auto pos_sep = layerinfo->fromsource.find('.');
-    if (pos_sep != std::string::npos) {
-      schema = layerinfo->fromsource.substr(0, pos_sep);
-      table = layerinfo->fromsource.substr(pos_sep + 1);
-
-      if (layer->debug) {
-        msDebug("msPostGISRetrievePK(): Found schema %s, table %s.\n", schema.c_str(), table.c_str());
-      }
-    }
-    /*
-    ** PostgreSQL v7.3 and later treat primary keys as constraints.
-    ** We only support single column primary keys, so multicolumn
-    ** pks are explicitly excluded from the query.
-    */
-    if (!schema.empty()) {
-      static const char *v73sql = "select attname from pg_attribute, pg_constraint, pg_class, pg_namespace where pg_constraint.conrelid = pg_class.oid and pg_class.oid = pg_attribute.attrelid and pg_constraint.contype = 'p' and pg_constraint.conkey[1] = pg_attribute.attnum and pg_class.relname = '%s' and pg_class.relnamespace = pg_namespace.oid and pg_namespace.nspname = '%s' and pg_constraint.conkey[2] is null";
-      sql = (char*) msSmallMalloc(schema.size() + table.size() + strlen(v73sql) + 1);
-      sprintf(sql, v73sql, table.c_str(), schema.c_str());
-    } else {
-      static const char *v73sql = "select attname from pg_attribute, pg_constraint, pg_class where pg_constraint.conrelid = pg_class.oid and pg_class.oid = pg_attribute.attrelid and pg_constraint.contype = 'p' and pg_constraint.conkey[1] = pg_attribute.attnum and pg_class.relname = '%s' and pg_table_is_visible(pg_class.oid) and pg_constraint.conkey[2] is null";
-      sql = (char*) msSmallMalloc(layerinfo->fromsource.size() + strlen(v73sql) + 1);
-      sprintf(sql, v73sql, layerinfo->fromsource.c_str());
-    }
-  }
-
-  if (layer->debug > 1) {
-    msDebug("msPostGISRetrievePK: %s\n", sql);
-  }
-
-  layerinfo = (msPostGISLayerInfo *) layer->layerinfo;
-
-  if (layerinfo->pgconn == nullptr) {
-    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.", "msPostGISRetrievePK()");
-    free(sql);
-    return MS_FAILURE;
-  }
-
-  PGresult *pgresult = PQexecParams(layerinfo->pgconn, sql, 0, nullptr, nullptr, nullptr, nullptr, 0);
-  if ( !pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
-    msSetError(MS_QUERYERR, "%s", "msPostGISRetrievePK()",
-               (std::string("Error executing SQL: ") + sql).c_str());
-    return MS_FAILURE;
-  }
-
-  if (PQntuples(pgresult) < 1) {
-    if (layer->debug) {
-      msDebug("msPostGISRetrievePK: No results found.\n");
-    }
-    PQclear(pgresult);
-    free(sql);
-    return MS_FAILURE;
-  }
-  if (PQntuples(pgresult) > 1) {
-    if (layer->debug) {
-      msDebug("msPostGISRetrievePK: Multiple results found.\n");
-    }
-    PQclear(pgresult);
-    free(sql);
-    return MS_FAILURE;
-  }
-
-  if (PQgetisnull(pgresult, 0, 0)) {
-    if (layer->debug) {
-      msDebug("msPostGISRetrievePK: Null result returned.\n");
-    }
-    PQclear(pgresult);
-    free(sql);
-    return MS_FAILURE;
-  }
-
-  layerinfo->uid = PQgetvalue(pgresult, 0, 0);
-
-  PQclear(pgresult);
-  free(sql);
-  return MS_SUCCESS;
-}
-
-
-/*
-** msPostGISParseData()
-**
-** Parse the DATA string for geometry column name, table name,
-** unique id column, srid, and SQL string.
-*/
-static int msPostGISParseData(layerObj *layer)
-{
-  assert(layer != nullptr);
-  assert(layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*)(layer->layerinfo);
-
-  if (layer->debug) {
-    msDebug("msPostGISParseData called.\n");
-  }
-
-  if (!layer->data) {
-    msSetError(MS_QUERYERR, "Missing DATA clause. DATA statement must contain 'geometry_column from table_name' or 'geometry_column from (sub-query) as sub'.", "msPostGISParseData()");
-    return MS_FAILURE;
-  }
-
-  std::string data(layer->data);
-  for( char& ch: data ) {
-    if( ch == '\t' || ch == '\r' || ch == '\n' ) {
-      ch = ' ';
-    }
-  }
-
-  /*
-  ** Clean up any existing strings first, as we will be populating these fields.
-  */
-  layerinfo->srid.clear();
-  layerinfo->uid.clear();
-  layerinfo->geomcolumn.clear();
-  layerinfo->fromsource.clear();
-
-  /*
-  ** Look for the optional ' using ' clauses.
-  */
-  const char* pos_srid = nullptr;
-  const char* pos_uid = nullptr;
-  const char* pos_use_1st = nullptr;
-  const char* pos_use_2nd = nullptr;
-  {
-    const char* tmp = strcasestr(data.c_str(), " using ");
-    while ( tmp )
-    {
-      pos_use_1st = pos_use_2nd;
-      pos_use_2nd = tmp + 1;
-      tmp = strcasestr(tmp+1, " using ");
-    }
-  }
-
-  /*
-  ** What clause appear after 2nd 'using', if set?
-  */
-  if ( pos_use_2nd )
-  {
-    const char* tmp;
-    for ( tmp = pos_use_2nd + 5; *tmp == ' '; tmp++ );
-    if ( strncasecmp ( tmp, "unique ", 7 ) == 0 )
-      for ( pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++ );
-    if ( strncasecmp ( tmp, "srid=", 5 ) == 0 ) pos_srid = tmp + 5;
-  };
-
-  /*
-  ** What clause appear after 1st 'using', if set?
-  */
-  if ( pos_use_1st )
-  {
-    const char* tmp;
-    for ( tmp = pos_use_1st + 5; *tmp == ' '; tmp++ );
-    if ( strncasecmp ( tmp, "unique ", 7 ) == 0 )
-    {
-      if ( pos_uid )
-      {
-        msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. Too many 'USING UNIQUE' found! %s", "msPostGISParseData()", layer->data);
-        return MS_FAILURE;
-      };
-      for ( pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++ );
-    };
-    if ( strncasecmp ( tmp, "srid=", 5 ) == 0 )
-    {
-      if ( pos_srid )
-      {
-        msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. Too many 'USING SRID' found! %s", "msPostGISParseData()", layer->data);
-        return MS_FAILURE;
-      }
-      pos_srid = tmp + 5;
-    }
-  }
-
-  /*
-  ** Look for the optional ' using unique ID' string first.
-  */
-  if (pos_uid) {
-    /* Find the end of this case 'using unique ftab_id using srid=33' */
-    const char* tmp = strstr(pos_uid, " ");
-    /* Find the end of this case 'using srid=33 using unique ftab_id' */
-    if (!tmp) {
-      tmp = pos_uid + strlen(pos_uid);
-    }
-    layerinfo->uid.assign(pos_uid, tmp - pos_uid);
-    msStringTrim(layerinfo->uid);
-  }
-
-  /*
-  ** Look for the optional ' using srid=333 ' string next.
-  */
-  if (pos_srid) {
-    const int slength = strspn(pos_srid, "-0123456789");
-    if (!slength) {
-      msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. You specified 'USING SRID' but didn't have any numbers! %s", "msPostGISParseData()", layer->data);
-      return MS_FAILURE;
-    } else {
-      layerinfo->srid.assign(pos_srid, slength);
-      msStringTrim(layerinfo->srid);
-    }
-  }
-
-  /*
-  * This is a little hack so the rest of the code works.
-  * pos_opt should point to the start of the optional blocks.
-  *
-  * If they are both set, return the smaller one.
-  * If pos_use_1st set, then it smaller.
-  * If one or none is set, return the larger one.
-  */
-  const char* pos_opt = pos_use_1st ? pos_use_1st : pos_use_2nd;
-  /* No pos_opt? Move it to the end of the string. */
-  if (!pos_opt) {
-    pos_opt = data.c_str() + data.size();
-  }
-  /* Back after the last non-space character. */
-  while( ( pos_opt > data.c_str() ) && ( *(pos_opt-1) == ' ' ) )
-  {
-    --pos_opt;
-  }
-
-  /*
-  ** Scan for the 'geometry from table' or 'geometry from () as foo' clause.
-  */
-
-  /* Find the first non-white character to start from */
-  const char* pos_geom;
-  for ( pos_geom = data.c_str(); *pos_geom == ' '; pos_geom++ )
-  {
-  }
-
-  /* Find the end of the geom column name */
-  const char* pos_scn = strcasestr(data.c_str(), " from ");
-  if (!pos_scn) {
-    msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. Must contain 'geometry from table' or 'geometry from (subselect) as foo'. %s", "msPostGISParseData()", layer->data);
-    return MS_FAILURE;
-  }
-
-  /* Copy the geometry column name */
-  layerinfo->geomcolumn.assign(pos_geom, pos_scn - pos_geom);
-  msStringTrim(layerinfo->geomcolumn);
-
-  /* Copy the table name or sub-select clause */
-  for ( pos_scn += 6; *pos_scn == ' '; pos_scn++ );
-  if ( pos_opt - pos_scn < 1 )
-  {
-    msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable.  Must contain 'geometry from table' or 'geometry from (subselect) as foo'. %s", "msPostGISParseData()", layer->data);
-    return MS_FAILURE;
-  };
-  layerinfo->fromsource.assign(layer->data + (pos_scn - data.c_str()), pos_opt - pos_scn);
-  msStringTrim(layerinfo->fromsource);
-
-  /* Something is wrong, our goemetry column and table references are not there. */
-  if (layerinfo->fromsource.empty() || layerinfo->geomcolumn.empty()) {
-    msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable.  Must contain 'geometry from table' or 'geometry from (subselect) as foo'. %s", "msPostGISParseData()", layer->data);
-    return MS_FAILURE;
-  }
-
-  /*
-  ** We didn't find a ' using unique ' in the DATA string so try and find a
-  ** primary key on the table.
-  */
-  if ( layerinfo->uid.empty() ) {
-    if ( strstr(layerinfo->fromsource.c_str(), " ") ) {
-      msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable.  You must specify 'using unique' when supplying a subselect in the data definition.", "msPostGISParseData()");
-      return MS_FAILURE;
-    }
-    if ( msPostGISRetrievePK(layer) != MS_SUCCESS ) {
-      if( layerinfo->pgconn && msPostGISRetrievePostgreSQLVersion(layerinfo->pgconn) < 120000 ) {
-        /* For PostgreSQL < 12: No user specified unique id so we will use the PostgreSQL oid */
-        layerinfo->uid = "oid";
-      } else {
-        msSetError(MS_QUERYERR,
-                   "Error parsing PostGIS DATA variable. "
-                   "No primary key was found. "
-                   "You must specify 'using unique'.",
-                   "msPostGISParseData()");
-        return MS_FAILURE;
-      }
-    }
-  }
-
-  if (layer->debug) {
-    msDebug("msPostGISParseData: unique_column=%s, srid=%s, geom_column_name=%s, table_name=%s\n", layerinfo->uid.c_str(), layerinfo->srid.c_str(), layerinfo->geomcolumn.c_str(), layerinfo->fromsource.c_str());
-  }
-  return MS_SUCCESS;
-}
-
-#if TRANSFER_ENCODING == 16
-
-// This is dead code given current settings in mappostgis.h
-
-/*
-** Decode a hex character.
-*/
-static const unsigned char msPostGISHexDecodeChar[256] = {
-  /* not Hex characters */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  /* 0-9 */
-  0,1,2,3,4,5,6,7,8,9,
-  /* not Hex characters */
-  64,64,64,64,64,64,64,
-  /* A-F */
-  10,11,12,13,14,15,
-  /* not Hex characters */
-  64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,
-  /* a-f */
-  10,11,12,13,14,15,
-  64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  /* not Hex characters (upper 128 characters) */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64
-};
-
-/*
-** Decode hex string "src" (null terminated)
-** into "dest" (not null terminated).
-** Returns length of decoded array or 0 on failure.
-*/
-static int msPostGISHexDecode(unsigned char *dest, const char *src, int srclen)
-{
-
-  if (src && *src && (srclen % 2 == 0) ) {
-
-    unsigned char *p = dest;
-    int i;
-
-    for ( i=0; i<srclen; i+=2 ) {
-      const unsigned char c1 = src[i];
-      const unsigned char c2 = src[i + 1];
-      const unsigned char b1 = msPostGISHexDecodeChar[c1];
-      const unsigned char b2 = msPostGISHexDecodeChar[c2];
-
-      *p++ = (b1 << 4) | b2;
-
-    }
-    return(p-dest);
-  }
-  return 0;
-}
-
-/*
-** Decode a base64 character.
-*/
-static const unsigned char msPostGISBase64DecodeChar[256] = {
-  /* not Base64 characters */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,
-  /*  +  */
-  62,
-  /* not Base64 characters */
-  64,64,64,
-  /*  /  */
-  63,
-  /* 0-9 */
-  52,53,54,55,56,57,58,59,60,61,
-  /* not Base64 characters */
-  64,64,64,64,64,64,64,
-  /* A-Z */
-  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
-  /* not Base64 characters */
-  64,64,64,64,64,64,
-  /* a-z */
-  26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,
-  /* not Base64 characters */
-  64,64,64,64,64,
-  /* not Base64 characters (upper 128 characters) */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64
-};
-
-/*
-** Decode base64 string "src" (null terminated)
-** into "dest" (not null terminated).
-** Returns length of decoded array or 0 on failure.
-*/
-static int msPostGISBase64Decode(unsigned char *dest, const char *src, int srclen)
-{
-
-  if (src && *src) {
-
-    unsigned char *p = dest;
-    int i, j, k;
-    unsigned char *buf = (unsigned char*) calloc(srclen + 1, sizeof(unsigned char));
-
-    /* Drop illegal chars first */
-    for (i=0, j=0; src[i]; i++) {
-      unsigned char c = src[i];
-      if ( (msPostGISBase64DecodeChar[c] != 64) || (c == '=') ) {
-        buf[j++] = c;
-      }
-    }
-
-    for (k=0; k<j; k+=4) {
-      unsigned char c1='A', c2='A', c3='A', c4='A';
-      unsigned char b1=0, b2=0, b3=0, b4=0;
-
-      c1 = buf[k];
-
-      if (k+1<j) {
-        c2 = buf[k+1];
-      }
-      if (k+2<j) {
-        c3 = buf[k+2];
-      }
-      if (k+3<j) {
-        c4 = buf[k+3];
-      }
-
-      b1 = msPostGISBase64DecodeChar[c1];
-      b2 = msPostGISBase64DecodeChar[c2];
-      b3 = msPostGISBase64DecodeChar[c3];
-      b4 = msPostGISBase64DecodeChar[c4];
-
-      *p++=((b1<<2)|(b2>>4) );
-      if (c3 != '=') {
-        *p++=(((b2&0xf)<<4)|(b3>>2) );
-      }
-      if (c4 != '=') {
-        *p++=(((b3&0x3)<<6)|b4 );
-      }
-    }
-    free(buf);
-    return(p-dest);
-  }
-  return 0;
-}
-
-#endif
-
-/*
-** msPostGISBuildSQLBox()
-**
-** Returns malloc'ed char* that must be freed by caller.
-*/
-static char *msPostGISBuildSQLBox(layerObj *layer, const rectObj *rect, const char *strSRID)
-{
-
-  char *strBox = nullptr;
-  size_t sz;
-
-  if (layer->debug) {
-    msDebug("msPostGISBuildSQLBox called.\n");
-  }
-
-  const bool bIsPoint = rect->minx == rect->maxx && rect->miny == rect->maxy;
-
-  if ( strSRID ) {
-    static const char *strBoxTemplate = "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)";
-    static const char *strBoxTemplatePoint = "ST_GeomFromText('POINT(%.15g %.15g)',%s)";
-    /* 10 doubles + 1 integer + template characters */
-    sz = 10 * 22 + strlen(strSRID) + strlen(strBoxTemplate);
-    strBox = (char*)msSmallMalloc(sz+1); /* add space for terminating NULL */
-    if ( (bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplatePoint,
-                        rect->minx, rect->miny, strSRID))) ||
-         (!bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplate,
-                        rect->minx, rect->miny,
-                        rect->minx, rect->maxy,
-                        rect->maxx, rect->maxy,
-                        rect->maxx, rect->miny,
-                        rect->minx, rect->miny,
-                        strSRID))) ) {
-      msSetError(MS_MISCERR,"Bounding box digits truncated.","msPostGISBuildSQLBox");
-      return nullptr;
-    }
-  } else {
-    static const char *strBoxTemplate = "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))')";
-    static const char *strBoxTemplatePoint = "ST_GeomFromText('POINT(%.15g %.15g)')";
-    /* 10 doubles + template characters */
-    sz = 10 * 22 + strlen(strBoxTemplate);
-    strBox = (char*)msSmallMalloc(sz+1); /* add space for terminating NULL */
-    if ( (bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplatePoint,
-                        rect->minx, rect->miny))) ||
-         (!bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplate,
-                        rect->minx, rect->miny,
-                        rect->minx, rect->maxy,
-                        rect->maxx, rect->maxy,
-                        rect->maxx, rect->miny,
-                        rect->minx, rect->miny))) ) {
-      msSetError(MS_MISCERR,"Bounding box digits truncated.","msPostGISBuildSQLBox");
-      return nullptr;
-    }
-  }
-
-  return strBox;
-
-}
-
-
-/*
-** msPostGISBuildSQLItems()
-**
-** Returns malloc'ed char* that must be freed by caller.
-*/
-static std::string msPostGISBuildSQLItems(layerObj *layer)
-{
-
-  const char *strEndian = nullptr;
-  if (layer->debug) {
-    msDebug("msPostGISBuildSQLItems called.\n");
-  }
-
-  assert( layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-
-  if ( layerinfo->geomcolumn.empty() ) {
-    msSetError(MS_MISCERR, "layerinfo->geomcolumn is not initialized.", "msPostGISBuildSQLItems()");
-    return std::string();
-  }
-
-  /*
-  ** Get the server to transform the geometry into our
-  ** native endian before transmitting it to us..
-  */
-  if (layerinfo->endian == LITTLE_ENDIAN) {
-    strEndian = "NDR";
-  } else {
-    strEndian = "XDR";
-  }
-
-  std::string strGeom;
-  {
-    /*
-    ** We transfer the geometry from server to client as a
-    ** hex or base64 encoded WKB byte-array. We will have to decode this
-    ** data once we get it. Forcing to 2D (via the AsBinary function
-    ** which includes a 2D force in it) removes ordinates we don't
-    ** need, saving transfer and encode/decode time.
-    */
-    const char *force2d = "";
-#if TRANSFER_ENCODING == 64
-    const char *strGeomTemplate = "encode(ST_AsBinary(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
-#elif TRANSFER_ENCODING == 256
-    const char *strGeomTemplate = "ST_AsBinary(%s(\"%s\"),'%s') as geom,\"%s\"::text";
-#else
-    const char *strGeomTemplate = "encode(ST_AsBinary(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
-#endif
-    if( layerinfo->force2d ) {
-      if( layerinfo->version >= 20100 )
-        force2d = "ST_Force2D";
-      else
-        force2d = "ST_Force_2D";
-    }
-    else if( layerinfo->version < 20000 )
-    {
-        /* Use AsEWKB() to get 3D */
-#if TRANSFER_ENCODING == 64
-        strGeomTemplate = "encode(AsEWKB(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
-#elif TRANSFER_ENCODING == 256
-        strGeomTemplate = "AsEWKB(%s(\"%s\"),'%s') as geom,\"%s\"::text";
-#else
-        strGeomTemplate = "encode(AsEWKB(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
-#endif
-    }
-    strGeom.resize(strlen(strGeomTemplate) + strlen(force2d) + strlen(strEndian) + layerinfo->geomcolumn.size() + layerinfo->uid.size());
-    snprintf(&strGeom[0], strGeom.size(), strGeomTemplate, force2d, layerinfo->geomcolumn.c_str(), strEndian, layerinfo->uid.c_str());
-    strGeom.resize(strlen(strGeom.data()));
-  }
-
-  if( layer->debug > 1 ) {
-    msDebug("msPostGISBuildSQLItems: %d items requested.\n",layer->numitems);
-  }
-
-  /*
-  ** Not requesting items? We just need geometry and unique id.
-  */
-  std::string strItems;
-  /*
-  ** Build SQL to pull all the items.
-  */
-  for ( int t = 0; t < layer->numitems; t++ ) {
-      strItems +=  "\"";
-      strItems += layer->items[t];
-#if TRANSFER_ENCODING == 256
-      strItems += "\"::text,";
-#else
-      strItems += "\",";
-#endif
-  }
-  strItems += strGeom;
-
-  return strItems;
-}
-
-
-/*
-** msPostGISFindTableName()
-*/
-static std::string msPostGISFindTableName(const char* fromsource)
-{
-  std::string f_table_name;
-  const char *pos = strchr(fromsource, ' ');
- 
-  if ( ! pos ) {
-    /* target table is one word */
-    f_table_name = fromsource;
-  } else {
-    /* target table is hiding in sub-select clause */
-    pos = strcasestr(fromsource, " from ");
-    if ( pos ) {
-      pos += 6; /* should be start of table name */
-      const char* pos_paren = strstr(pos, ")"); /* first ) after table name */
-      const char* pos_space = strstr(pos, " "); /* first space after table name */
-      if ( pos_space < pos_paren ) {
-        /* found space first */
-        f_table_name.assign(pos, pos_space - pos);
-      } else {
-        /* found ) first */
-        f_table_name.assign( pos, pos_paren - pos);
-      }
-    }
-  }
-  return f_table_name;
-}
-
-
-/*
-** msPostGISBuildSQLSRID()
-*/
-static std::string msPostGISBuildSQLSRID(layerObj *layer)
-{
-
-  std::string strSRID;
-
-  if (layer->debug) {
-    msDebug("msPostGISBuildSQLSRID called.\n");
-  }
-
-  assert( layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-
-  /* An SRID was already provided in the DATA line. */
-  if ( !layerinfo->srid.empty() ) {
-    strSRID = layerinfo->srid;
-    if( layer->debug > 1 ) {
-      msDebug("msPostGISBuildSQLSRID: SRID provided (%s)\n", strSRID.c_str());
-    }
-  }
-  /*
-  ** No SRID in data line, so extract target table from the 'fromsource'.
-  ** Either of form "thetable" (one word) or "(select ... from thetable)"
-  ** or "(select ... from thetable where ...)".
-  */
-  else {
-    if( layer->debug > 1 ) {
-      msDebug("msPostGISBuildSQLSRID: Building find_srid line.\n");
-    }
-
-    strSRID = "find_srid('','";
-    strSRID += msPostGISFindTableName(layerinfo->fromsource.c_str());
-    strSRID += "','";
-    strSRID += layerinfo->geomcolumn;
-    strSRID += "')";
-  }
-  return strSRID;
-}
-
-
-/*
-** msPostGISReplaceBoxToken()
-**
-** Convert a fromsource data statement into something usable by replacing the !BOX! token.
-*/
-static std::string msPostGISReplaceBoxToken(layerObj *layer, const rectObj *rect, const char *fromsource)
-{
-  std::string result(fromsource);
-  
-  if( layer->debug > 1 ) {
-    msDebug("msPostGISReplaceBoxToken called.\n");
-  }  
-
-  if ( strstr(fromsource, BOXTOKEN) && rect ) {
-    char *strBox = nullptr;
-
-    /* We see to set the SRID on the box, but to what SRID? */
-    const std::string strSRID = msPostGISBuildSQLSRID(layer);
-    if ( strSRID.empty() ) {
-      return std::string();
-    }
-
-    /* Create a suitable SQL string from the rectangle and SRID. */
-    strBox = msPostGISBuildSQLBox(layer, rect, strSRID.c_str());
-    if ( ! strBox ) {
-      msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISReplaceBoxToken()");
-      return std::string();
-    }
-
-    /* Do the substitution. */
-    size_t pos = 0;
-    while( true ) {
-        pos = result.find(BOXTOKEN, pos);
-        if( pos == std::string::npos ) {
-            break;
-        }
-        const auto resultAfter(result.substr(pos + BOXTOKENLENGTH));
-        result.resize(pos);
-        result += strBox;
-        result += resultAfter;
-    }
-
-    free(strBox);
-  }
-  return result;
-
-}
-
-/*
-** msPostGISBuildSQLFrom()
-*/
-static std::string msPostGISBuildSQLFrom(layerObj *layer, const rectObj *rect)
-{
-  if (layer->debug) {
-    msDebug("msPostGISBuildSQLFrom called.\n");
-  }
-
-  assert( layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-
-  if ( layerinfo->fromsource.empty() ) {
-    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.", "msPostGISBuildSQLFrom()");
-    return std::string();
-  }
-
-  /*
-  ** If there's a '!BOX!' in our source we need to substitute the
-  ** current rectangle for it...
-  */
-  return msPostGISReplaceBoxToken(layer, rect, layerinfo->fromsource.c_str());
-}
-
-/*
-** msPostGISBuildSQLWhere()
-*/
-static std::string msPostGISBuildSQLWhere(layerObj *layer, const rectObj *rect, const long *uid, const rectObj *rectInOtherSRID, int otherSRID)
-{
-  if (layer->debug) {
-    msDebug("msPostGISBuildSQLWhere called.\n");
-  }
-
-  assert( layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-
-  if ( layerinfo->fromsource.empty() ) {
-    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.", "msPostGISBuildSQLWhere()");
-    return std::string();
-  }
-
-  /* Populate strRect, if necessary. */
-  std::string strRect;
-  if ( rect && !layerinfo->geomcolumn.empty() ) {
-    /* We see to set the SRID on the box, but to what SRID? */
-    const std::string strSRID = msPostGISBuildSQLSRID(layer);
-    if ( strSRID.empty() ) {
-      return std::string();
-    }
-
-    char* strBox = msPostGISBuildSQLBox(layer, rect, strSRID.c_str());
-
-    if ( !strBox ) {
-      msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISBuildSQLWhere()");
-      return std::string();
-    }
-
-    if( strSRID.find("find_srid(") == std::string::npos )
-    {
-        // If the SRID is known, we can safely use ST_Intersects()
-        // otherwise if find_srid() would return 0, ST_Intersects() would not
-        // work at all, which breaks the msautotest/query/query_postgis.map
-        // tests, related to bdry_counpy2 layer that has no SRID
-        if( layerinfo->version >= 20500 )
-        {
-            strRect = "ST_Intersects(\"";
-            strRect += layerinfo->geomcolumn;
-            strRect += "\", ";
-            strRect += strBox;
-            strRect += ')';
-        }
-        else
-        {
-            // ST_Intersects() before PostGIS 2.5 doesn't support collections
-            // See https://github.com/MapServer/MapServer/pull/6355#issuecomment-877355007
-            strRect = "(\"";
-            strRect += layerinfo->geomcolumn;
-            strRect += "\" && ";
-            strRect += strBox;
-            strRect += ") AND ST_Distance(\"";
-            strRect += layerinfo->geomcolumn;
-            strRect += "\", ";
-            strRect += strBox;
-            strRect += ") = 0";
-        }
-    }
-    else
-    {
-        strRect = '"';
-        strRect += layerinfo->geomcolumn;
-        strRect += "\" && ";
-        strRect += strBox;
-    }
-    free(strBox);
-
-    /* Combine with other rectangle  expressed in another SRS */
-    /* (generally equivalent to the above in current code paths) */
-    if( rectInOtherSRID != nullptr && otherSRID > 0 )
-    {
-      strBox = msPostGISBuildSQLBox(layer, rectInOtherSRID, std::to_string(otherSRID).c_str());
-      if ( !strBox ) {
-        msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISBuildSQLWhere()");
-        return std::string();
-      }
-
-      std::string strRectOtherSRID = "ST_Intersects(ST_Transform(";
-      strRectOtherSRID += layerinfo->geomcolumn;
-      strRectOtherSRID += ',';
-      strRectOtherSRID += std::to_string(otherSRID);
-      strRectOtherSRID += "),";
-      strRectOtherSRID += strBox;
-      strRectOtherSRID += ')';
-
-      free(strBox);
-
-      std::string strTmp = "((";
-      strTmp += strRect;
-      strTmp += ") AND ";
-      strTmp += strRectOtherSRID;
-      strTmp += ')';
-
-      strRect = std::move(strTmp);
-    }
-    else if( rectInOtherSRID != nullptr && otherSRID < 0 )
-    {
-      const std::string strSRID = msPostGISBuildSQLSRID(layer);
-      if ( strSRID.empty() ) {
-        return std::string();
-      }
-      char* strBox = msPostGISBuildSQLBox(layer, rectInOtherSRID, strSRID.c_str());
-
-      if ( !strBox ) {
-        msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISBuildSQLWhere()");
-        return std::string();
-      }
-
-      std::string strRectOtherSRID = "ST_Intersects(";
-      strRectOtherSRID += layerinfo->geomcolumn;
-      strRectOtherSRID += ',';
-      strRectOtherSRID += strBox;
-      strRectOtherSRID += ')';
-
-      free(strBox);
-
-      std::string strTmp = "((";
-      strTmp += strRect;
-      strTmp += ") AND ";
-      strTmp += strRectOtherSRID;
-      strTmp += ')';
-
-      strRect = std::move(strTmp);
-    }
-  }
-
-  bool insert_and = false;
-  std::string strWhere;
-  if ( !strRect.empty() ) {
-    strWhere += strRect;
-    insert_and = true;
-  }
-
-  /* Handle a translated filter (RFC91). */
-  if ( layer->filter.native_string ) {
-    if ( insert_and ) {
-      strWhere += " AND ";
-      insert_and = true;
-    }
-    strWhere += '(';
-    strWhere += layer->filter.native_string;
-    strWhere += ')';
-  }
-
-  /* Handle a native filter set as a PROCESSING option (#5001). */
-  const char *native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
-  if ( native_filter ) {
-    if ( insert_and ) {
-      strWhere += " AND ";
-      insert_and = true;
-    }
-    strWhere += '(';
-    strWhere += native_filter;
-    strWhere += ')';
-  }
-
-  if ( uid ) {
-    if ( insert_and ) {
-      strWhere += " AND ";
-    }
-    strWhere += '"';
-    strWhere += layerinfo->uid;
-    strWhere += "\" = ";
-    strWhere += std::to_string(*uid);
-  }
-
-  if( layer->sortBy.nProperties > 0 ) {
-    char* pszTmp = msLayerBuildSQLOrderBy(layer);
-    strWhere += " ORDER BY ";
-    strWhere += pszTmp;
-    msFree(pszTmp);
-  }
-
-  if ( layerinfo->paging && layer->maxfeatures >= 0 ) {
-    strWhere += " LIMIT ";
-    strWhere += std::to_string(layer->maxfeatures);
-  }
-
-  /* Populate strOffset, if necessary. */
-  if ( layerinfo->paging && layer->startindex > 0 ) {
-    strWhere += " OFFSET ";
-    strWhere += std::to_string(layer->startindex-1);
-  }
-
-  if (strWhere.empty()) {
-      // return all records
-      strWhere = "true";
-  }
-
-  return strWhere;
-}
-
-/*
-** msPostGISBuildSQL()
-**
-** rect is the search rectangle in layer SRS. It can be set to NULL
-** uid can be set to NULL
-** rectInOtherSRID is an additional rectangle potentially in another SRS. It can be set to NULL.
-** Only used if rect != NULL
-** otherSRID is the SRID of the additional rectangle. It can be set to -1 if
-** rectInOtherSRID is in the SRID of the layer.
-*/
-static std::string msPostGISBuildSQL(layerObj *layer, const rectObj *rect, const long *uid, const rectObj *rectInOtherSRID, int otherSRID)
-{
-  if (layer->debug) {
-    msDebug("msPostGISBuildSQL called.\n");
-  }
-
-  assert( layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-
-  const std::string strItems = msPostGISBuildSQLItems(layer);
-  if ( strItems.empty() ) {
-    msSetError(MS_MISCERR, "Failed to build SQL items.", "msPostGISBuildSQL()");
-    return std::string();
-  }
-
-  const std::string strFrom = msPostGISBuildSQLFrom(layer, rect);
-  if ( strFrom.empty() ) {
-    msSetError(MS_MISCERR, "Failed to build SQL 'from'.", "msPostGISBuildSQL()");
-    return std::string();
-  }
-
-  /* If there's BOX hackery going on, we don't want to append a box index test at
-     the end of the query, the user is going to be responsible for making things
-     work with their hackery. */
-  std::string strWhere;
-  if ( strstr(layerinfo->fromsource.c_str(), BOXTOKEN) )
-    strWhere = msPostGISBuildSQLWhere(layer, nullptr, uid, rectInOtherSRID, otherSRID);
-  else
-    strWhere = msPostGISBuildSQLWhere(layer, rect, uid, rectInOtherSRID, otherSRID);
-
-  if ( strWhere.empty() ) {
-    msSetError(MS_MISCERR, "Failed to build SQL 'where'.", "msPostGISBuildSQL()");
-    return std::string();
-  }
-
-  std::string sql("SELECT ");
-  sql += strItems;
-  sql += " FROM ";
-  sql += strFrom;
-  sql += " WHERE ";
-  sql += strWhere;
-
-  return sql;
-}
-
-#define wkbstaticsize 4096
-static int msPostGISReadShape(layerObj *layer, shapeObj *shape)
-{
-  if (layer->debug) {
-    msDebug("msPostGISReadShape called.\n");
-  }
-
-  assert(layer->layerinfo != nullptr);
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-  /* Retrieve the geometry. */
-  const char* wkbstr = PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems );
-  const int wkbstrlen = PQgetlength(layerinfo->pgresult, layerinfo->rownum, layer->numitems);
-
-  if ( ! wkbstr ) {
-    msSetError(MS_QUERYERR, "WKB returned is null!", "msPostGISReadShape()");
-    return MS_FAILURE;
-  }
-
-  unsigned char wkbstatic[wkbstaticsize];
-  unsigned char *wkb = nullptr;
-  if(wkbstrlen > wkbstaticsize) {
-    wkb = static_cast<unsigned char*>(calloc(wkbstrlen, sizeof(unsigned char)));
-  } else {
-    wkb = wkbstatic;
-  }
-
-  wkbObj w;
-  int result = 0;
-#if TRANSFER_ENCODING == 64
-  result = msPostGISBase64Decode(wkb, wkbstr, wkbstrlen - 1);
-  w.size = (wkbstrlen - 1)/2;
-  if( ! result ) {
-    if(wkb!=wkbstatic) free(wkb);
-    return MS_FAILURE;
-  }
-#elif TRANSFER_ENCODING == 256
-  memcpy(wkb, wkbstr, wkbstrlen);
-  w.size = wkbstrlen;
-#else
-  result = msPostGISHexDecode(wkb, wkbstr, wkbstrlen);
-  w.size = (wkbstrlen - 1)/2;
-  if( ! result ) {
-    if(wkb!=wkbstatic) free(wkb);
-    return MS_FAILURE;
-  }
-#endif
-
-  /* Initialize our wkbObj */
-  w.wkb = (char*)wkb;
-  w.ptr = w.wkb;
-
-  /* Set the type map according to what version of PostGIS we are dealing with */
-  if( layerinfo->version >= 20000 ) /* PostGIS 2.0+ */
-    w.typemap = wkb_postgis20;
-  else
-  {
-    w.typemap = wkb_postgis15;
-    if( layerinfo->force2d == MS_FALSE )
-    {
-        /* Is there SRID ? Skip it */
-        if( w.size >= 9 && (w.ptr[4] & 0x20) != 0 )
-        {
-            w.ptr[5] = w.ptr[1];
-            w.ptr[6] = w.ptr[2];
-            w.ptr[7] = w.ptr[3];
-            w.ptr[8] = w.ptr[4] & ~(0x20);
-            w.ptr[4] = 1;
-            w.ptr += 4;
-            w.size -= 4;
-        }
-    }
-  }
-
-  switch (layer->type) {
-
-    case MS_LAYER_POINT:
-      shape->type = MS_SHAPE_POINT;
-      result = wkbConvGeometryToShape(&w, shape);
-      break;
-
-    case MS_LAYER_LINE:
-      shape->type = MS_SHAPE_LINE;
-      result = wkbConvGeometryToShape(&w, shape);
-      break;
-
-    case MS_LAYER_POLYGON:
-      shape->type = MS_SHAPE_POLYGON;
-      result = wkbConvGeometryToShape(&w, shape);
-      break;
-
-    case MS_LAYER_QUERY:
-    case MS_LAYER_CHART:
-      result = msPostGISFindBestType(&w, shape);
-      break;
-
-    case MS_LAYER_RASTER:
-      msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
-      break;
-
-    case MS_LAYER_CIRCLE:
-      msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
-      break;
-
-    default:
-      msDebug("Unsupported layer type in msPostGISReadShape()!\n");
-      break;
-  }
-
-  /* All done with WKB geometry, free it! */
-  if(wkb!=wkbstatic) free(wkb);
-
-  if (result != MS_FAILURE) {
-    /* Found a drawable shape, so now retreive the attributes. */
-
-    shape->values = (char**) msSmallMalloc(sizeof(char*) * layer->numitems);
-    for ( int t = 0; t < layer->numitems; t++) {
-      const int size = PQgetlength(layerinfo->pgresult, layerinfo->rownum, t);
-      const char *val = PQgetvalue(layerinfo->pgresult, layerinfo->rownum, t);
-      const int isnull = PQgetisnull(layerinfo->pgresult, layerinfo->rownum, t);
-      if ( isnull ) {
-        shape->values[t] = msStrdup("");
-      } else {
-        shape->values[t] = (char*) msSmallMalloc(size + 1);
-        memcpy(shape->values[t], val, size);
-        shape->values[t][size] = '\0'; /* null terminate it */
-
-        // From https://www.postgresql.org/docs/9.0/datatype-character.html
-        // fields of type Char are blank padded, but this blank is semantically
-        // insignificant, so let's trim it
-        if( PQftype(layerinfo->pgresult, t) == CHAROID )
-            msStringTrimBlanks(shape->values[t]);
-      }
-      if( layer->debug > 4 ) {
-        msDebug("msPostGISReadShape: PQgetlength = %d\n", size);
-      }
-      if( layer->debug > 1 ) {
-        msDebug("msPostGISReadShape: [%s] \"%s\"\n", layer->items[t], shape->values[t]);
-      }
-    }
-
-    /* layer->numitems is the geometry, layer->numitems+1 is the uid */
-    const char* tmp = PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems + 1);
-    long uid = 0;
-    if( tmp ) {
-      uid = strtol( tmp, nullptr, 10 );
-    }
-    if( layer->debug > 4 ) {
-      msDebug("msPostGISReadShape: Setting shape->index = %ld\n", uid);
-      msDebug("msPostGISReadShape: Setting shape->resultindex = %ld\n", layerinfo->rownum);
-    }
-    shape->index = uid;
-    shape->resultindex = layerinfo->rownum;
-
-    if( layer->debug > 2 ) {
-      msDebug("msPostGISReadShape: [index] %ld\n",  shape->index);
-    }
-
-    shape->numvalues = layer->numitems;
-
-    msComputeBounds(shape);
-  } else {
-     shape->type = MS_SHAPE_NULL;
-  }
-
-  if( layer->debug > 2 ) {
-    char *tmp = msShapeToWKT(shape);
-    msDebug("msPostGISReadShape: [shape] %s\n", tmp);
-    free(tmp);
-  }
-
-  return MS_SUCCESS;
-}
-
-#endif /* USE_POSTGIS */
-
-
-/*
-** msPostGISLayerOpen()
-**
-** Registered vtable->LayerOpen function.
-*/
-static int msPostGISLayerOpen(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-  assert(layer != nullptr);
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerOpen called: %s\n", layer->data);
-  }
-
-  if (layer->layerinfo) {
-    if (layer->debug) {
-      msDebug("msPostGISLayerOpen: Layer is already open!\n");
-    }
-    return MS_SUCCESS;  /* already open */
-  }
-
-  if (!layer->data) {
-    msSetError(MS_QUERYERR, "Nothing specified in DATA statement.", "msPostGISLayerOpen()");
-    return MS_FAILURE;
-  }
-
-  /*
-  ** Initialize the layerinfo
-  **/
-  msPostGISLayerInfo* layerinfo = msPostGISCreateLayerInfo();
-
-  int order_test = 1;
-  if (((char*) &order_test)[0] == 1) {
-    layerinfo->endian = LITTLE_ENDIAN;
-  } else {
-    layerinfo->endian = BIG_ENDIAN;
-  }
-
-  /*
-  ** Get a database connection from the pool.
-  */
-  layerinfo->pgconn = (PGconn *) msConnPoolRequest(layer);
-
-  /* No connection in the pool, so set one up. */
-  if (!layerinfo->pgconn) {
-    if (layer->debug) {
-      msDebug("msPostGISLayerOpen: No connection in pool, creating a fresh one.\n");
-    }
-
-    if (!layer->connection) {
-      msSetError(MS_MISCERR, "Missing CONNECTION keyword.", "msPostGISLayerOpen()");
-      delete layerinfo;
-      return MS_FAILURE;
-    }
-
-    /*
-    ** Decrypt any encrypted token in connection string and attempt to connect.
-    */
-    char* conn_decrypted = msDecryptStringTokens(layer->map, layer->connection);
-    if (conn_decrypted == nullptr) {
-      delete layerinfo;
-      return MS_FAILURE;  /* An error should already have been produced */
-    }
-    layerinfo->pgconn = PQconnectdb(conn_decrypted);
-    msFree(conn_decrypted);
-    conn_decrypted = nullptr;
-
-    /*
-    ** Connection failed, return error message with passwords ***ed out.
-    */
-    if (!layerinfo->pgconn || PQstatus(layerinfo->pgconn) == CONNECTION_BAD) {
-      if (layer->debug)
-        msDebug("msPostGISLayerOpen: Connection failure.\n");
-
-      msDebug( "Database connection failed (%s) with connect string '%s'\nIs the database running? Is it allowing connections? Does the specified user exist? Is the password valid? Is the database on the standard port? in msPostGISLayerOpen()", PQerrorMessage(layerinfo->pgconn), layer->connection);
-      msSetError(MS_QUERYERR, "Database connection failed. Check server logs for more details.Is the database running? Is it allowing connections? Does the specified user exist? Is the password valid? Is the database on the standard port?", "msPostGISLayerOpen()");
-
-      if(layerinfo->pgconn) PQfinish(layerinfo->pgconn);
-      delete layerinfo;
-      return MS_FAILURE;
-    }
-
-    /* Register to receive notifications from the database. */
-    PQsetNoticeProcessor(layerinfo->pgconn, postresqlNoticeHandler, (void *) layer);
-
-    /* Save this connection in the pool for later. */
-    msConnPoolRegister(layer, layerinfo->pgconn, msPostGISCloseConnection);
-  } else {
-    /* Connection in the pool should be tested to see if backend is alive. */
-    if( PQstatus(layerinfo->pgconn) != CONNECTION_OK ) {
-      /* Uh oh, bad connection. Can we reset it? */
-      PQreset(layerinfo->pgconn);
-      if( PQstatus(layerinfo->pgconn) != CONNECTION_OK ) {
-        /* Nope, time to bail out. */
-        msSetError(MS_QUERYERR, "PostgreSQL database connection. Check server logs for more details", "msPostGISLayerOpen()");
-        msDebug( "PostgreSQL database connection gone bad (%s) in msPostGISLayerOpen()", PQerrorMessage(layerinfo->pgconn));
-        delete layerinfo;
-        /* FIXME: we should also release the connection from the pool in this case, but it is stale...
-         * for the time being we do not release it so it can never be used again. If this happens multiple
-         * times there will be a leak... */
-        return MS_FAILURE;
-      }
-    }
-  }
-
-  /* Get the PostGIS version number from the database */
-  layerinfo->version = msPostGISRetrieveVersion(layerinfo->pgconn);
-  if( layerinfo->version == MS_FAILURE ) {
-    msConnPoolRelease(layer, layerinfo->pgconn);
-    delete layerinfo;
-    return MS_FAILURE;
-  }
-  if (layer->debug)
-    msDebug("msPostGISLayerOpen: Got PostGIS version %d.\n", layerinfo->version);
-
-  const char* force2d_processing = msLayerGetProcessingKey( layer, "FORCE2D" );
-  if(force2d_processing && !strcasecmp(force2d_processing,"no")) {
-    layerinfo->force2d = MS_FALSE;
-  }
-  else if(force2d_processing && !strcasecmp(force2d_processing,"yes")) {
-    layerinfo->force2d = MS_TRUE;
-  }
-  if (layer->debug)
-    msDebug("msPostGISLayerOpen: Forcing 2D geometries: %s.\n", (layerinfo->force2d)?"yes":"no");
-
-  /* Save the layerinfo in the layerObj. */
-  layer->layerinfo = (void*)layerinfo;
-
-  return MS_SUCCESS;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerOpen()");
-  return MS_FAILURE;
-#endif
-}
-
-/*
-** msPostGISLayerClose()
-**
-** Registered vtable->LayerClose function.
-*/
-static int msPostGISLayerClose(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerClose called: %s\n", layer->data);
-  }
-
-  if( layer->layerinfo ) {
-    msPostGISFreeLayerInfo(layer);
-  }
-
-  return MS_SUCCESS;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerClose()");
-  return MS_FAILURE;
-#endif
-}
-
-
-/*
-** msPostGISLayerIsOpen()
-**
-** Registered vtable->LayerIsOpen function.
-*/
-static int msPostGISLayerIsOpen(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerIsOpen called.\n");
-  }
-
-  if (layer->layerinfo)
-    return MS_TRUE;
-  else
-    return MS_FALSE;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerIsOpen()");
-  return MS_FAILURE;
-#endif
-}
-
-
-/*
-** msPostGISLayerFreeItemInfo()
-**
-** Registered vtable->LayerFreeItemInfo function.
-*/
-static void msPostGISLayerFreeItemInfo(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-  if (layer->debug) {
-    msDebug("msPostGISLayerFreeItemInfo called.\n");
-  }
-
-  if (layer->iteminfo) {
-    free(layer->iteminfo);
-  }
-  layer->iteminfo = nullptr;
-#endif
-}
-
-/*
-** msPostGISLayerInitItemInfo()
-**
-** Registered vtable->LayerInitItemInfo function.
-** Our iteminfo is list of indexes from 1..numitems.
-*/
-static int msPostGISLayerInitItemInfo(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-  if (layer->debug) {
-    msDebug("msPostGISLayerInitItemInfo called.\n");
-  }
-
-  if (layer->numitems == 0) {
-    return MS_SUCCESS;
-  }
-
-  if (layer->iteminfo) {
-    free(layer->iteminfo);
-  }
-
-  layer->iteminfo = msSmallMalloc(sizeof(int) * layer->numitems);
-  if (!layer->iteminfo) {
-    msSetError(MS_MEMERR, "Out of memory.", "msPostGISLayerInitItemInfo()");
-    return MS_FAILURE;
-  }
-
-  int* itemindexes = (int*)layer->iteminfo;
-  for (int i = 0; i < layer->numitems; i++) {
-    itemindexes[i] = i; /* Last item is always the geometry. The rest are non-geometry. */
-  }
-
-  return MS_SUCCESS;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerInitItemInfo()");
-  return MS_FAILURE;
-#endif
-}
-
-#ifdef USE_POSTGIS
-static std::vector<const char*> buildBindValues(layerObj *layer)
-{
-  /* try to get the first bind value */
-  const char* bind_value = msLookupHashTable(&layer->bindvals, "1");
-  std::vector<const char*> layer_bind_values;
-  while(bind_value != nullptr) {
-    /* put the bind value on the stack */
-    layer_bind_values.push_back(bind_value);
-    /* get the bind_value */
-    bind_value = msLookupHashTable(&layer->bindvals,
-        std::to_string(static_cast<size_t>(layer_bind_values.size())+1).c_str());
-  }
-  return layer_bind_values;
-}
-
-static PGresult* runPQexecParamsWithBindSubstitution(layerObj *layer, const char* strSQL, int binary)
-{
-  PGresult *pgresult = nullptr;
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-  const auto layer_bind_values = buildBindValues(layer);
-
-  if( !layer_bind_values.empty() ) {
-    pgresult = PQexecParams(layerinfo->pgconn, strSQL, static_cast<int>(layer_bind_values.size()), nullptr, layer_bind_values.data(), nullptr, nullptr, binary);
-  } else {
-    pgresult = PQexecParams(layerinfo->pgconn, strSQL, 0, nullptr, nullptr, nullptr, nullptr, binary);
-  }
-
-  return pgresult;
-}
-#endif
-
-/*
-** msPostGISLayerWhichShapes()
-**
-** Registered vtable->LayerWhichShapes function.
-*/
-// cppcheck-suppress passedByValue
-static int msPostGISLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)isQuery;
-#ifdef USE_POSTGIS
-  assert(layer != nullptr);
-  assert(layer->layerinfo != nullptr);
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerWhichShapes called.\n");
-  }
-
-  /* Fill out layerinfo with our current DATA state. */
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-  /*
-  ** This comes *after* parsedata, because parsedata fills in
-  ** layer->layerinfo.
-  */
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-  /* Build a SQL query based on our current state. */
-  const std::string strSQL = msPostGISBuildSQL(layer, &rect, nullptr, nullptr, -1);
-  if ( strSQL.empty() ) {
-    msSetError(MS_QUERYERR, "Failed to build query SQL.", "msPostGISLayerWhichShapes()");
-    return MS_FAILURE;
-  }
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerWhichShapes query: %s\n", strSQL.c_str());
-  }
-
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), RESULTSET_TYPE);
-
-  if ( layer->debug > 1 ) {
-    msDebug("msPostGISLayerWhichShapes query status: %s (%d)\n", PQresStatus(PQresultStatus(pgresult)), PQresultStatus(pgresult));
-  }
-
-  /* Something went wrong. */
-  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
-    msDebug("msPostGISLayerWhichShapes(): Error (%s) executing query: %s\n", PQerrorMessage(layerinfo->pgconn), strSQL.c_str());
-    msSetError(MS_QUERYERR, "Error executing query. Check server logs","msPostGISLayerWhichShapes()");
-    if (pgresult) {
-      PQclear(pgresult);
-    }
-    return MS_FAILURE;
-  }
-
-  if ( layer->debug ) {
-    msDebug("msPostGISLayerWhichShapes got %d records in result.\n", PQntuples(pgresult));
-  }
-
-  /* Clean any existing pgresult before storing current one. */
-  if(layerinfo->pgresult) PQclear(layerinfo->pgresult);
-  layerinfo->pgresult = pgresult;
-
-  layerinfo->sql = strSQL;
-
-  layerinfo->rownum = 0;
-
-  return MS_SUCCESS;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerWhichShapes()");
-  return MS_FAILURE;
-#endif
-}
-
-/*
-** msPostGISLayerNextShape()
-**
-** Registered vtable->LayerNextShape function.
-*/
-static int msPostGISLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-#ifdef USE_POSTGIS
-  if (layer->debug) {
-    msDebug("msPostGISLayerNextShape called.\n");
-  }
-
-  assert(layer != nullptr);
-  assert(layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-  shape->type = MS_SHAPE_NULL;
-
-  /*
-  ** Roll through pgresult until we hit non-null shape (usually right away).
-  */
-  while (shape->type == MS_SHAPE_NULL) {
-    if (layerinfo->rownum < PQntuples(layerinfo->pgresult)) {
-      /* Retrieve this shape, cursor access mode. */
-      msPostGISReadShape(layer, shape);
-      if( shape->type != MS_SHAPE_NULL ) {
-        (layerinfo->rownum)++; /* move to next shape */
-        return MS_SUCCESS;
-      } else {
-        (layerinfo->rownum)++; /* move to next shape */
-      }
-    } else {
-      return MS_DONE;
-    }
-  }
-
-  /* Found nothing, clean up and exit. */
-  msFreeShape(shape);
-
-  return MS_FAILURE;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerNextShape()");
-  return MS_FAILURE;
-#endif
-}
-
-/*
-** msPostGISLayerGetShape()
-**
- */
-// cppcheck-suppress passedByValue
-static int msPostGISLayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
-#ifdef USE_POSTGIS
-  int rectSRID = -1;
-  rectObj searchrectInLayerProj = rect;
-
-  assert(layer != nullptr);
-  assert(layer->layerinfo != nullptr);
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerGetShapeCount called.\n");
-  }
-
-
-  // Special processing if the specified projection for the rect is different from the layer projection
-  // We want to issue a WHERE that includes
-  // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
-  if( rectProjection != NULL && layer->project &&
-      msProjectionsDiffer(&(layer->projection), rectProjection) )
-  {
-    // If we cannot guess the EPSG code of the rectProjection, we cannot
-    // use ST_Transform, so fallback on slow implementation
-    if( rectProjection->numargs < 1 ||
-        strncasecmp(rectProjection->args[0], "init=epsg:", strlen("init=epsg:")) != 0 )
-    {
-      if (layer->debug) {
-        msDebug("msPostGISLayerGetShapeCount(): cannot find EPSG code of rectProjection. Falling back on client-side feature count.\n");
-      }
-      return LayerDefaultGetShapeCount(layer, rect, rectProjection);
-    }
-
-    // Reproject the passed rect into the layer projection and get
-    // the SRID from the rectProjection
-    msProjectRect(rectProjection, &(layer->projection), &searchrectInLayerProj); /* project the searchrect to source coords */
-    rectSRID = atoi(rectProjection->args[0] + strlen("init=epsg:"));
-  }
-
-  msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
-
-  /* Fill out layerinfo with our current DATA state. */
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
-    return -1;
-  }
-
-  /*
-  ** This comes *after* parsedata, because parsedata fills in
-  ** layer->layerinfo.
-  */
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-  /* Build a SQL query based on our current state. */
-  const std::string strSQL = msPostGISBuildSQL(layer, &searchrectInLayerProj, nullptr,
-                             &rect, rectSRID);
-  if ( strSQL.empty() ) {
-    msSetError(MS_QUERYERR, "Failed to build query SQL.", "msPostGISLayerGetShapeCount()");
-    return -1;
-  }
-
-  std::string strSQLCount = "SELECT COUNT(*) FROM (";
-  strSQLCount += strSQL;
-  strSQLCount += ") msQuery";
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerGetShapeCount query: %s\n", strSQLCount.c_str());
-  }
-
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQLCount.c_str(), 0);
-
-  if ( layer->debug > 1 ) {
-    msDebug("msPostGISLayerWhichShapes query status: %s (%d)\n",
-            PQresStatus(PQresultStatus(pgresult)), PQresultStatus(pgresult));
-  }
-
-  /* Something went wrong. */
-  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
-    msDebug("msPostGISLayerGetShapeCount(): Error (%s) executing query: %s. "
-            "Falling back to client-side evaluation\n",
-            PQerrorMessage(layerinfo->pgconn), strSQLCount.c_str());
-    if (pgresult) {
-      PQclear(pgresult);
-    }
-    return LayerDefaultGetShapeCount(layer, rect, rectProjection);
-  }
-
-  const int nCount = atoi(PQgetvalue(pgresult, 0, 0 ));
-
-  if ( layer->debug ) {
-    msDebug("msPostGISLayerWhichShapes return: %d.\n", nCount);
-  }
-  PQclear(pgresult);
-
-  return nCount;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerGetShapeCount()");
-  return -1;
-#endif
-}
-
-
-/*
-** msPostGISLayerGetShape()
-**
-** Registered vtable->LayerGetShape function. For pulling from a prepared and
-** undisposed result set.
-*/
-static int msPostGISLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-#ifdef USE_POSTGIS
-
-  long shapeindex = record->shapeindex;
-  int resultindex = record->resultindex;
-
-  assert(layer != nullptr);
-  assert(layer->layerinfo != nullptr);
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerGetShape called for record = %i\n", resultindex);
-  }
-
-  /* If resultindex is set, fetch the shape from the resultcache, otherwise fetch it from the DB  */
-  if (resultindex >= 0) {
-    msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-    /* Check the validity of the open result. */
-    PGresult* pgresult = layerinfo->pgresult;
-    if ( ! pgresult ) {
-      msSetError( MS_MISCERR,
-                  "PostgreSQL result set is null.",
-                  "msPostGISLayerGetShape()");
-      return MS_FAILURE;
-    }
-    ExecStatusType status = PQresultStatus(pgresult);
-    if ( layer->debug > 1 ) {
-      msDebug("msPostGISLayerGetShape query status: %s (%d)\n", PQresStatus(status), (int)status);
-    }
-    if( ! ( status == PGRES_COMMAND_OK || status == PGRES_TUPLES_OK) ) {
-      msSetError( MS_MISCERR,
-                  "PostgreSQL result set is not ready.",
-                  "msPostGISLayerGetShape()");
-      return MS_FAILURE;
-    }
-
-    /* Check the validity of the requested record number. */
-    if( resultindex >= PQntuples(pgresult) ) {
-      msDebug("msPostGISLayerGetShape got request for (%d) but only has %d tuples.\n", resultindex, PQntuples(pgresult));
-      msSetError( MS_MISCERR,
-                  "Got request larger than result set.",
-                  "msPostGISLayerGetShape()");
-      return MS_FAILURE;
-    }
-
-    layerinfo->rownum = resultindex; /* Only return one result. */
-
-    /* We don't know the shape type until we read the geometry. */
-    shape->type = MS_SHAPE_NULL;
-
-    /* Return the shape, cursor access mode. */
-    msPostGISReadShape(layer, shape);
-
-    return (shape->type == MS_SHAPE_NULL) ? MS_FAILURE : MS_SUCCESS;
-  } else { /* no resultindex, fetch the shape from the DB */
-    int num_tuples;
-
-    /* Fill out layerinfo with our current DATA state. */
-    if ( msPostGISParseData(layer) != MS_SUCCESS) {
-      return MS_FAILURE;
-    }
-
-    /*
-    ** This comes *after* parsedata, because parsedata fills in
-    ** layer->layerinfo.
-    */
-    msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-    /* Build a SQL query based on our current state. */
-    const std::string strSQL = msPostGISBuildSQL(layer, nullptr, &shapeindex, nullptr, -1);
-    if ( strSQL.empty() ) {
-      msSetError(MS_QUERYERR, "Failed to build query SQL.", "msPostGISLayerGetShape()");
-      return MS_FAILURE;
-    }
-
-    if (layer->debug) {
-      msDebug("msPostGISLayerGetShape query: %s\n", strSQL.c_str());
-    }
-
-    PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), RESULTSET_TYPE);
-
-    /* Something went wrong. */
-    if ( (!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK) ) {
-      msDebug("msPostGISLayerGetShape(): Error (%s) executing SQL: %s\n", PQerrorMessage(layerinfo->pgconn), strSQL.c_str() );
-      msSetError(MS_QUERYERR, "Error executing SQL. Check server logs.","msPostGISLayerGetShape()");
-
-      if (pgresult) {
-        PQclear(pgresult);
-      }
-      return MS_FAILURE;
-    }
-
-    /* Clean any existing pgresult before storing current one. */
-    if(layerinfo->pgresult) PQclear(layerinfo->pgresult);
-    layerinfo->pgresult = pgresult;
-
-    /* Clean any existing SQL before storing current. */
-    layerinfo->sql = strSQL;
-
-    layerinfo->rownum = 0; /* Only return one result. */
-
-    /* We don't know the shape type until we read the geometry. */
-    shape->type = MS_SHAPE_NULL;
-
-    num_tuples = PQntuples(pgresult);
-    if (layer->debug) {
-      msDebug("msPostGISLayerGetShape number of records: %d\n", num_tuples);
-    }
-
-    if (num_tuples > 0) {
-      /* Get shape in random access mode. */
-      msPostGISReadShape(layer, shape);
-    }
-
-    return (shape->type == MS_SHAPE_NULL) ? MS_FAILURE : ( (num_tuples > 0) ? MS_SUCCESS : MS_DONE );
-  }
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerGetShape()");
-  return MS_FAILURE;
-#endif
-}
-
-/**********************************************************************
- *                     msPostGISPassThroughFieldDefinitions()
- *
- * Pass the field definitions through to the layer metadata in the
- * "gml_[item]_{type,width,precision}" set of metadata items for
- * defining fields.
- **********************************************************************/
-
-#ifdef USE_POSTGIS
-static void
-msPostGISPassThroughFieldDefinitions( layerObj *layer,
-                                      PGresult *pgresult )
-
-{
-  const int numitems = PQnfields(pgresult);
-  msPostGISLayerInfo *layerinfo = static_cast<msPostGISLayerInfo*>(layer->layerinfo);
-
-  for(int i=0; i<numitems; i++) {
-    const char *gml_type = "Character";
-    const char *item = PQfname(pgresult,i);
-    std::string gml_width;
-    std::string gml_precision;
-
-    /* skip geometry column */
-    if( item == layerinfo->geomcolumn )
-      continue;
-
-    const int oid = PQftype(pgresult,i);
-    const int fmod = PQfmod(pgresult,i);
-
-    if( (oid == BPCHAROID || oid == VARCHAROID) && fmod >= 4 ) {
-      gml_width = std::to_string( fmod-4 );
-
-    } else if( oid == BOOLOID ) {
-      gml_type = "Boolean";
-
-    } else if( oid == INT2OID ) {
-      gml_type = "Integer";
-      gml_width = '5';
-
-    } else if( oid == INT4OID ) {
-      gml_type = "Integer";
-
-    } else if( oid == INT8OID ) {
-      gml_type = "Long";
-
-    } else if( oid == FLOAT4OID || oid == FLOAT8OID ) {
-      gml_type = "Real";
-
-    } else if( oid == NUMERICOID ) {
-      gml_type = "Real";
-
-      if( fmod >= 4 && ((fmod - 4) & 0xFFFF) == 0 ) {
-        gml_type = "Integer";
-        gml_width = std::to_string( (fmod - 4) >> 16 );
-      } else if( fmod >= 4 ) {
-        gml_width = std::to_string( (fmod - 4) >> 16 );
-        gml_precision = std::to_string( (fmod-4) & 0xFFFF );
-      }
-    } else if( oid == DATEOID ) {
-      gml_type = "Date";
-    } else if( oid == TIMEOID || oid == TIMETZOID ) {
-      gml_type = "Time";
-    } else if( oid == TIMESTAMPOID || oid == TIMESTAMPTZOID ) {
-      gml_type = "DateTime";
-    }
-
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width.c_str(), gml_precision.c_str(), 0);
-
-  }
-}
-#endif /* defined(USE_POSTGIS) */
-
-/*
-** msPostGISLayerGetItems()
-**
-** Registered vtable->LayerGetItems function. Query the database for
-** column information about the requested layer. Rather than look in
-** system tables, we just run a zero-cost query and read out of the
-** result header.
-*/
-static int msPostGISLayerGetItems(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-  rectObj rect;
-
-  /* A useless rectangle for our useless query */
-  rect.minx = rect.miny = rect.maxx = rect.maxy = 0.0;
-
-  assert(layer != nullptr);
-  assert(layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-  assert(layerinfo->pgconn);
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerGetItems called.\n");
-  }
-
-  /* Fill out layerinfo with our current DATA state. */
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-  layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
-
-  /*
-  ** Both the "table" and "(select ...) as sub" cases can be handled with the
-  ** same SQL.
-  */
-  std::string sql("select * from ");
-  sql += msPostGISReplaceBoxToken(layer, &rect, layerinfo->fromsource.c_str());
-  sql += " where false limit 0";
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerGetItems executing SQL: %s\n", sql.c_str());
-  }
-
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, sql.c_str(), 0);
-
-  if ( (!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK) ) {
-    msDebug("msPostGISLayerGetItems(): Error (%s) executing SQL: %s\n", PQerrorMessage(layerinfo->pgconn), sql.c_str());
-    msSetError(MS_QUERYERR, "Error executing SQL. Check server logs","msPostGISLayerGetItems()");
-    if (pgresult) {
-      PQclear(pgresult);
-    }
-    return MS_FAILURE;
-  }
-
-  layer->numitems = PQnfields(pgresult) - 1; /* dont include the geometry column (last entry)*/
-  layer->items = static_cast<char**>(msSmallMalloc(sizeof(char*) * (layer->numitems + 1))); /* +1 in case there is a problem finding geometry column */
-
-  bool found_geom = false; /* havent found the geom field */
-  int item_num = 0;
-
-  for (int t = 0; t < PQnfields(pgresult); t++) {
-    const char* col = PQfname(pgresult, t);
-    if ( col != layerinfo->geomcolumn) {
-      /* this isnt the geometry column */
-      layer->items[item_num] = msStrdup(col);
-      item_num++;
-    } else {
-      found_geom = true;
-    }
-  }
-
-  /*
-  ** consider populating the field definitions in metadata.
-  */
-  const char* value =  msOWSLookupMetadata(&(layer->metadata), "G", "types");
-  if(value != nullptr && strcasecmp(value,"auto") == 0 )
-    msPostGISPassThroughFieldDefinitions( layer, pgresult );
-
-  /*
-  ** Cleanup
-  */
-  PQclear(pgresult);
-
-  if (!found_geom) {
-    msSetError(MS_QUERYERR, "Tried to find the geometry column in the database, but couldn't find it.  Is it mis-capitalized? '%s'", "msPostGISLayerGetItems()", layerinfo->geomcolumn.c_str());
-    return MS_FAILURE;
-  }
-
-  return msPostGISLayerInitItemInfo(layer);
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerGetItems()");
-  return MS_FAILURE;
-#endif
-}
-
-#ifdef USE_POSTGIS
-static std::string addTableNameAndFilterToSelectFrom(layerObj *layer,
-                                            const std::string& selectFrom)
-{
-    auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-    /* if we have !BOX! substitution then we use just the table name */
-    std::string f_table_name;
-    if (strstr(layerinfo->fromsource.c_str(), BOXTOKEN))
-        f_table_name = msPostGISFindTableName(layerinfo->fromsource.c_str());
-    else
-        f_table_name = layerinfo->fromsource;
-
-    std::string strSQL = selectFrom;
-    strSQL += f_table_name;
-
-    /* Handle a translated filter (RFC91). */
-    if (layer->filter.native_string) {
-        strSQL += " WHERE (";
-        strSQL += layer->filter.native_string;
-        strSQL += ')';
-    }
-
-    /* Handle a native filter set as a PROCESSING option (#5001). */
-    const char* native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
-    if (native_filter) {
-        if( layer->filter.native_string )
-            strSQL += " AND (";
-        else
-            strSQL += " WHERE (";
-        strSQL += native_filter;
-        strSQL += ')';
-    }
-    return strSQL;
-}
-#endif
-
-/*
-** msPostGISLayerGetExtent()
-**
-** Registered vtable->LayerGetExtent function. Query the database for
-** the extent of the requested layer.
-*/
-static int msPostGISLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-#ifdef USE_POSTGIS
-  if (layer->debug) {
-    msDebug("msPostGISLayerGetExtent called.\n");
-  }
-
-  assert( layer->layerinfo != nullptr);
-
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-  auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-  const std::string strSQL(addTableNameAndFilterToSelectFrom(layer,
-    "SELECT ST_Extent(" + layerinfo->geomcolumn + ") FROM "));
-
-  if (layer->debug) {
-    msDebug("msPostGISLayerGetExtent executing SQL: %s\n", strSQL.c_str());
-  }
-
-  /* executing the query */
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
-
-  if ( (!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK) ) {
-    msDebug("Error executing SQL: (%s) in msPostGISLayerGetExtent()", PQerrorMessage(layerinfo->pgconn));
-    msSetError(MS_MISCERR, "Error executing SQL. Check server logs.","msPostGISLayerGetExtent()");
-    if (pgresult)
-      PQclear(pgresult);
-
-    return MS_FAILURE;
-  }
-
-  /* process results */
-  if (PQntuples(pgresult) < 1) {
-    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: No results found.", 
-        "msPostGISLayerGetExtent()");
-    PQclear(pgresult);
-    return MS_FAILURE;
-  }
-  
-  if (PQgetisnull(pgresult, 0, 0)) {
-    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: Null result returned.", 
-        "msPostGISLayerGetExtent()");
-    PQclear(pgresult);
-    return MS_FAILURE;
-  }
-
-  if (sscanf(PQgetvalue(pgresult, 0, 0), "BOX(%lf %lf,%lf %lf)", 
-         &extent->minx, &extent->miny, &extent->maxx, &extent->maxy) != 4) {
-    msSetError(MS_MISCERR, "Failed to process result data.", "msPostGISLayerGetExtent()");
-    PQclear(pgresult);
-    return MS_FAILURE;
-  }
-
-  /* cleanup */
-  PQclear(pgresult);
-
-  return MS_SUCCESS;
-#else
-  msSetError( MS_MISCERR, "PostGIS support is not available.", "msPostGISLayerGetExtent()");
-  return MS_FAILURE;
-#endif
-}
-
-/*
-** msPostGISLayerGetNumFeatures()
-**
-** Registered vtable->LayerGetNumFeatures function. Query the database for
-** the feature count of the requested layer.
-*/
-static int msPostGISLayerGetNumFeatures(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-    if (layer->debug) {
-        msDebug("msPostGISLayerGetNumFeatures called.\n");
-    }
-
-    assert(layer->layerinfo != nullptr);
-
-    if (msPostGISParseData(layer) != MS_SUCCESS) {
-        return -1;
-    }
-
-    auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-    const std::string strSQL(addTableNameAndFilterToSelectFrom(
-        layer, "SELECT count(*) FROM "));
-    if (layer->debug) {
-        msDebug("msPostGISLayerGetNumFeatures executing SQL: %s\n", strSQL.c_str());
-    }
-
-    /* executing the query */
-    PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
-
-    if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
-        msDebug("Error executing SQL: (%s) in msPostGISLayerGetNumFeatures()", PQerrorMessage(layerinfo->pgconn));
-        msSetError(MS_MISCERR, "Error executing SQL. Check server logs.", "msPostGISLayerGetNumFeatures()");
-        if (pgresult)
-            PQclear(pgresult);
-
-        return -1;
-    }
-
-    /* process results */
-    if (PQntuples(pgresult) < 1) {
-        msSetError(MS_MISCERR, "msPostGISLayerGetNumFeatures: No results found.",
-            "msPostGISLayerGetNumFeatures()");
-        PQclear(pgresult);
-        return -1;
-    }
-
-    if (PQgetisnull(pgresult, 0, 0)) {
-        msSetError(MS_MISCERR, "msPostGISLayerGetNumFeatures: Null result returned.",
-            "msPostGISLayerGetNumFeatures()");
-        PQclear(pgresult);
-        return -1;
-    }
-
-    const char* tmp = PQgetvalue(pgresult, 0, 0);
-    int result = 0;
-    if (tmp) {
-        result = strtol(tmp, nullptr, 10);
-    }
-
-    /* cleanup */
-    PQclear(pgresult);
-
-    return result;
-#else
-    msSetError(MS_MISCERR, "PostGIS support is not available.", "msPostGISLayerGetNumFeatures()");
-    return -1;
-#endif
-}
-
-#ifdef USE_POSTGIS
-/*
- * make sure that the timestring is complete and acceptable
- * to the date_trunc function :
- * - if the resolution is year (2004) or month (2004-01),
- * a complete string for time would be 2004-01-01
- * - if the resolluion is hour or minute (2004-01-01 15), a
- * complete time is 2004-01-01 15:00:00
- */
-static int postgresTimeStampForTimeString(const char *timestring, char *dest, size_t destsize)
-{
-  int nlength = strlen(timestring);
-  int timeresolution = msTimeGetResolution(timestring);
-  int bNoDate = (*timestring == 'T');
-  if (timeresolution < 0)
-    return MS_FALSE;
- 
-  switch(timeresolution) {
-    case TIME_RESOLUTION_YEAR:
-      if (timestring[nlength-1] != '-') {
-        snprintf(dest, destsize,"date '%s-01-01'",timestring);
-      } else {
-        snprintf(dest, destsize,"date '%s01-01'",timestring);
-      }
-      break;
-    case TIME_RESOLUTION_MONTH:
-      if (timestring[nlength-1] != '-') {
-        snprintf(dest, destsize,"date '%s-01'",timestring);
-      } else {
-        snprintf(dest, destsize,"date '%s01'",timestring);
-      }
-      break;
-    case TIME_RESOLUTION_DAY:
-      snprintf(dest, destsize,"date '%s'",timestring);
-      break;
-    case TIME_RESOLUTION_HOUR:
-      if (timestring[nlength-1] != ':') {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s:00:00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s:00:00'", timestring);
-      } else {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s00:00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s00:00'", timestring);
-      }
-      break;
-    case TIME_RESOLUTION_MINUTE:
-      if (timestring[nlength-1] != ':') {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s:00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s:00'", timestring);
-      } else {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s00'", timestring);
-      }
-      break;
-    case TIME_RESOLUTION_SECOND:
-      if(bNoDate)
-         snprintf(dest, destsize,"time '%s'", timestring);
-      else
-         snprintf(dest, destsize,"timestamp '%s'", timestring);
-      break;
-    default:
-      return MS_FAILURE;
-  }
-  return MS_SUCCESS;
-
-}
-
-/*
- * create a postgresql where clause for the given timestring, taking into account
- * the resolution (e.g. second, day, month...) of the given timestring
- * we apply the date_trunc function on the given timestring and not on the time
- * column in order for postgres to take advantage of an eventual index on the
- * time column
- *
- * the generated sql is
- *
- * (
- *    timecol >= date_trunc(timestring,resolution)
- *      and
- *    timecol < date_trunc(timestring,resolution) + interval '1 resolution'
- * )
- */
-static int createPostgresTimeCompareEquals(const char *timestring, char *dest, size_t destsize)
-{
-  int timeresolution = msTimeGetResolution(timestring);
-  char timeStamp[100];
-  const char *interval;
-  if (timeresolution < 0) return MS_FALSE;
-
-  postgresTimeStampForTimeString(timestring,timeStamp,100);
-
-  switch(timeresolution) {
-    case TIME_RESOLUTION_YEAR:
-      interval = "year";
-      break;
-    case TIME_RESOLUTION_MONTH:
-      interval = "month";
-      break;
-    case TIME_RESOLUTION_DAY:
-      interval = "day";
-      break;
-    case TIME_RESOLUTION_HOUR:
-      interval = "hour";
-      break;
-    case TIME_RESOLUTION_MINUTE:
-      interval = "minute";
-      break;
-    case TIME_RESOLUTION_SECOND:
-      interval = "second";
-      break;
-    default:
-      return MS_FAILURE;
-  }
-  snprintf(dest, destsize, " between date_trunc('%s',%s) and date_trunc('%s',%s) + interval '1 %s' - interval '1 second'", interval, timeStamp, interval, timeStamp, interval);
-  return MS_SUCCESS;
-}
-
-static int createPostgresTimeCompareGreaterThan(const char *timestring, char *dest, size_t destsize)
-{
-  int timeresolution = msTimeGetResolution(timestring);
-  char timestamp[100];
-  const char *interval;
-  if (timeresolution < 0) return MS_FALSE;
- 
-  postgresTimeStampForTimeString(timestring,timestamp,100);
-
-  switch(timeresolution) {
-  case TIME_RESOLUTION_YEAR:
-    interval = "year";
-    break;
-  case TIME_RESOLUTION_MONTH:
-    interval = "month";
-    break;
-  case TIME_RESOLUTION_DAY:
-    interval = "day";
-    break;
-  case TIME_RESOLUTION_HOUR:
-    interval = "hour";
-    break;
-  case TIME_RESOLUTION_MINUTE:
-    interval = "minute";
-    break;
-  case TIME_RESOLUTION_SECOND:
-    interval = "second";
-    break;
-  default:
-    return MS_FAILURE;
-  }
-
-  snprintf(dest, destsize,"date_trunc('%s',%s)", interval, timestamp);
-  return MS_SUCCESS;
-}
-
-/*
- * create a postgresql where clause for the range given by the two input timestring,
- * taking into account the resolution (e.g. second, day, month...) of each of the
- * given timestrings (both timestrings can have different resolutions, although I don't
- * know if that's a valid TIME range
- * we apply the date_trunc function on the given timestrings and not on the time
- * column in order for postgres to take advantage of an eventual index on the
- * time column
- *
- * the generated sql is
- *
- * (
- *    timecol >= date_trunc(mintimestring,minresolution)
- *      and
- *    timecol < date_trunc(maxtimestring,maxresolution) + interval '1 maxresolution'
- * )
- */
-static int createPostgresTimeCompareLessThan(const char *timestring, char *dest, size_t destsize)
-{
-  int timeresolution = msTimeGetResolution(timestring);
-  char timestamp[100];
-  const char *interval;
-  if (timeresolution < 0)return MS_FALSE;
-
-  postgresTimeStampForTimeString(timestring,timestamp,100);
-
-  switch(timeresolution) {
-    case TIME_RESOLUTION_YEAR:
-      interval = "year";
-      break;
-    case TIME_RESOLUTION_MONTH:
-      interval = "month";
-      break;
-    case TIME_RESOLUTION_DAY:
-      interval = "day";
-      break;
-    case TIME_RESOLUTION_HOUR:
-      interval = "hour";
-      break;
-    case TIME_RESOLUTION_MINUTE:
-      interval = "minute";
-      break;
-    case TIME_RESOLUTION_SECOND:
-      interval = "second";
-      break;
-    default:
-      return MS_FAILURE;
-  }
-  snprintf(dest, destsize,"(date_trunc('%s',%s) + interval '1 %s' - interval '1 second')", interval, timestamp, interval);
-  return MS_SUCCESS;
-}
-#endif
-
-static char *msPostGISEscapeSQLParam(layerObj *layer, const char *pszString)
-{
-#ifdef USE_POSTGIS
-  char* pszEscapedStr =nullptr;
-
-  if (layer && pszString) {
-    if(!msPostGISLayerIsOpen(layer))
-      msPostGISLayerOpen(layer);
-
-    assert(layer->layerinfo != nullptr);
-
-    msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *) layer->layerinfo;
-    size_t nSrcLen = strlen(pszString);
-    pszEscapedStr = (char*) msSmallMalloc( 2 * nSrcLen + 1);
-    int nError = 0;
-      PQescapeStringConn (layerinfo->pgconn, pszEscapedStr, pszString, nSrcLen, &nError);
-    if (nError != 0) {
-      free(pszEscapedStr);
-      pszEscapedStr = nullptr;
-    }
-  }
-  return pszEscapedStr;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISEscapeSQLParam()");
-  return NULL;
-#endif
-}
-
-static void msPostGISEnablePaging(layerObj *layer, int value)
-{
-#ifdef USE_POSTGIS
-  if (layer->debug) {
-    msDebug("msPostGISEnablePaging called.\n");
-  }
-
-  if(!msPostGISLayerIsOpen(layer))
-  {
-    if(msPostGISLayerOpen(layer) != MS_SUCCESS)
-    {
-      return;
-    }
-  }
-
-  assert( layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-  layerinfo->paging = value;
-
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISEnablePaging()");
-#endif
-  return;
-}
-
-static int msPostGISGetPaging(layerObj *layer)
-{
-#ifdef USE_POSTGIS
-  if (layer->debug) {
-    msDebug("msPostGISGetPaging called.\n");
-  }
-
-  if(!msPostGISLayerIsOpen(layer))
-    return MS_TRUE;
-
-  assert( layer->layerinfo != nullptr);
-
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-  return layerinfo->paging;
-#else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISEnablePaging()");
-  return MS_FAILURE;
-#endif
-}
-
-/*
-** msPostGISLayerTranslateFilter()
-**
-** Registered vtable->LayerTranslateFilter function.
-*/
-static int msPostGISLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-#ifdef USE_POSTGIS
-  tokenListNodeObjPtr node = nullptr;
-
-  std::string native_string;
-
-  int comparisonToken = -1;
-  int bindingToken = -1;
-
-  msPostGISLayerInfo *layerinfo = static_cast<msPostGISLayerInfo*>(layer->layerinfo);
-
-  if(!filter->string) return MS_SUCCESS; /* not an error, just nothing to do */
-
-  // fprintf(stderr, "input: %s, %s, %d\n", filter->string, filteritem, filter->type);
-
-  /*
-  ** FILTERs use MapServer syntax *only* (#5001).
-  */
-  if(filter->type == MS_STRING && filter->string && filteritem) { /* item/value pair - add escaping */
-
-    char* stresc = msLayerEscapePropertyName(layer, filteritem);
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      native_string += "upper(";
-      native_string += stresc;
-      native_string += "::text) = upper(";
-    } else {
-      native_string += stresc;
-      native_string += "::text = ";
-    }
-    msFree(stresc);
-
-    /* don't have a type for the righthand literal so assume it's a string and we quote */
-    stresc = msPostGISEscapeSQLParam(layer, filter->string);
-    native_string += '\'';
-    native_string += stresc;
-    native_string += '\'';
-    msFree(stresc);
-
-    if(filter->flags & MS_EXP_INSENSITIVE) native_string += ")";
-  } else if(filter->type == MS_REGEX && filter->string && filteritem) { /* item/regex pair  - add escaping */
-
-    char* stresc = msLayerEscapePropertyName(layer, filteritem);
-    native_string += stresc;
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      native_string += "::text ~* ";
-    } else {
-      native_string += "::text ~ ";
-    }
-    msFree(stresc);
-
-    stresc = msPostGISEscapeSQLParam(layer, filter->string);
-    native_string += '\'';
-    native_string += stresc;
-    native_string += '\'';
-    msFree(stresc);
-  } else if(filter->type == MS_EXPRESSION) {
-    int ieq_expected = MS_FALSE;
-
-    if(msPostGISParseData(layer) != MS_SUCCESS) return MS_FAILURE;
-
-    if(layer->debug >= 2) msDebug("msPostGISLayerTranslateFilter. String: %s.\n", filter->string);
-    if(!filter->tokens) return MS_SUCCESS;
-    if(layer->debug >= 2) msDebug("msPostGISLayerTranslateFilter. There are tokens to process... \n");
-
-    node = filter->tokens;
-    while (node != nullptr) {
-
-      /*
-      ** Do any token caching/tracking here, easier to have it in one place.
-      */
-      if(node->token == MS_TOKEN_BINDING_TIME) {
-        bindingToken = node->token;
-      } else if(node->token == MS_TOKEN_COMPARISON_EQ ||
-         node->token == MS_TOKEN_COMPARISON_IEQ ||
-         node->token == MS_TOKEN_COMPARISON_NE ||
-         node->token == MS_TOKEN_COMPARISON_GT || node->token == MS_TOKEN_COMPARISON_GE ||
-         node->token == MS_TOKEN_COMPARISON_LT || node->token == MS_TOKEN_COMPARISON_LE ||
-         node->token == MS_TOKEN_COMPARISON_IN) {
-        comparisonToken = node->token;
-      }
-
-      switch(node->token) {
-
-        /* literal tokens */
-        case MS_TOKEN_LITERAL_BOOLEAN:
-          if(node->tokenval.dblval == MS_TRUE)
-            native_string += "TRUE";
-          else
-            native_string += "FALSE";
-          break;
-        case MS_TOKEN_LITERAL_NUMBER:
-        {
-          if( node->tokenval.dblval >= INT_MIN &&
-              node->tokenval.dblval <= INT_MAX &&
-              node->tokenval.dblval == (int)node->tokenval.dblval )
-              native_string += std::to_string((int)node->tokenval.dblval);
-          else {
-              char buffer[32];
-              snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
-              native_string += buffer;
-          }
-          break;
-        }
-        case MS_TOKEN_LITERAL_STRING:
-
-          if(comparisonToken == MS_TOKEN_COMPARISON_IN) { /* issue 5490 */
-            int nstrings=0;
-	    char** strings = msStringSplit(node->tokenval.strval, ',', &nstrings);
-            if(nstrings > 0) {
-	      native_string += "(";
-              for(int i=0; i<nstrings; i++) {
-                if(i != 0) native_string += ",";
-                char* stresc = msPostGISEscapeSQLParam(layer, strings[i]);
-                native_string += '\'';
-                native_string += stresc;
-                native_string += '\'';
-                msFree(stresc);
-              }
-              native_string += ")";
-            }
-
-            msFreeCharArray(strings, nstrings);
-          } else {
-            const char* strbegin;
-            const char* strend;
-            if(comparisonToken == MS_TOKEN_COMPARISON_IEQ) {
-                strbegin = "lower('";
-                strend = "')";
-            }
-            else {
-                strbegin = "'";
-                strend = "'";
-            }
-            char* stresc = msPostGISEscapeSQLParam(layer, node->tokenval.strval);
-            native_string += strbegin;
-            native_string += stresc;
-            native_string += strend;
-            msFree(stresc);
-          }
-
-          break;
-        case MS_TOKEN_LITERAL_TIME: {
-          char* snippet = (char *) msSmallMalloc(512);
-          if(comparisonToken == MS_TOKEN_COMPARISON_EQ) { // TODO: support !=
-            createPostgresTimeCompareEquals(node->tokensrc, snippet, 512);
-          } else if(comparisonToken == MS_TOKEN_COMPARISON_GT || comparisonToken == MS_TOKEN_COMPARISON_GE) {
-            createPostgresTimeCompareGreaterThan(node->tokensrc, snippet, 512);
-          } else if(comparisonToken == MS_TOKEN_COMPARISON_LT || comparisonToken == MS_TOKEN_COMPARISON_LE) {
-            createPostgresTimeCompareLessThan(node->tokensrc, snippet, 512);
-          } else {
-            msFree(snippet);
-            goto cleanup;
-          }
-
-          comparisonToken = -1; bindingToken = -1; /* reset */
-          native_string += snippet;
-          msFree(snippet);
-          break;
-  	}
-        case MS_TOKEN_LITERAL_SHAPE:
-        {
-          char* wkt = msShapeToWKT(node->tokenval.shpval);
-          native_string += "ST_GeomFromText('";
-          native_string += wkt;
-          msFree(wkt);
-          native_string += "'";
-          if( !layerinfo->srid.empty() ) {
-            native_string += ",";
-            native_string += layerinfo->srid;
-          }
-          native_string += ")";
-          break;
-        }
-
-	/* data binding tokens */
-        case MS_TOKEN_BINDING_TIME:
-        case MS_TOKEN_BINDING_DOUBLE:
-        case MS_TOKEN_BINDING_INTEGER:
-        case MS_TOKEN_BINDING_STRING:
-        {
-          const char* strbegin = "";
-          const char* strend = "";
-          if (node->token == MS_TOKEN_BINDING_STRING && node->next->token == MS_TOKEN_COMPARISON_IEQ ) {
-            strbegin = "lower(";
-            strend = "::text)";
-            ieq_expected = MS_TRUE;
-          }
-          else if(node->token == MS_TOKEN_BINDING_STRING || node->next->token == MS_TOKEN_COMPARISON_RE || node->next->token == MS_TOKEN_COMPARISON_IRE)
-            strend = "::text"; /* explicit cast necessary for certain operators */
-
-          char* stresc = msLayerEscapePropertyName(layer, node->tokenval.bindval.item);
-          native_string += strbegin;
-          native_string += stresc;
-          native_string += strend;
-          msFree(stresc);
-          break;
-        }
-        case MS_TOKEN_BINDING_SHAPE:
-          native_string += layerinfo->geomcolumn;
-          break;
-        case MS_TOKEN_BINDING_MAP_CELLSIZE:
-        {
-          char buffer[32];
-          snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
-          native_string += buffer;
-	  break;
-        }
-
-	/* spatial comparison tokens */
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-        case MS_TOKEN_COMPARISON_DISJOINT:
-        case MS_TOKEN_COMPARISON_TOUCHES:
-        case MS_TOKEN_COMPARISON_OVERLAPS:
-        case MS_TOKEN_COMPARISON_CROSSES:
-        case MS_TOKEN_COMPARISON_WITHIN:
-        case MS_TOKEN_COMPARISON_CONTAINS:
-        case MS_TOKEN_COMPARISON_EQUALS:
-        case MS_TOKEN_COMPARISON_DWITHIN:
-        {
-          if(node->next->token != '(') goto cleanup;
-          native_string += "st_";
-          const char* str = msExpressionTokenToString(node->token);
-          if( str == nullptr )
-              goto cleanup;
-          native_string += str;
-          break;
-        }
-
-	/* functions */
-        case MS_TOKEN_FUNCTION_LENGTH:
-        case MS_TOKEN_FUNCTION_AREA:
-        case MS_TOKEN_FUNCTION_BUFFER:
-        case MS_TOKEN_FUNCTION_DIFFERENCE:
-        {
-          native_string += "st_";
-          const char* str = msExpressionTokenToString(node->token);
-          if( str == nullptr )
-              goto cleanup;
-          native_string += str;
-          break;
-        }
-
-	case MS_TOKEN_COMPARISON_IEQ:
-            if( ieq_expected )
-            {
-                native_string += "=";
-                ieq_expected = MS_FALSE;
-            }
-            else
-            {
-                goto cleanup;
-            }
-            break;
-
-	/* unsupported tokens */
-        case MS_TOKEN_COMPARISON_BEYOND:
-	case MS_TOKEN_FUNCTION_TOSTRING:
-	case MS_TOKEN_FUNCTION_ROUND:
-	case MS_TOKEN_FUNCTION_SIMPLIFY:
-        case MS_TOKEN_FUNCTION_SIMPLIFYPT:        
-        case MS_TOKEN_FUNCTION_GENERALIZE:
-          goto cleanup;
-          break;
-
-        default:
-        {
-          /* by default accept the general token to string conversion */
-
-          if(node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr && node->next->token == MS_TOKEN_LITERAL_TIME) break; /* skip, handled with the next token */
-          if(bindingToken == MS_TOKEN_BINDING_TIME && (node->token == MS_TOKEN_COMPARISON_EQ || node->token == MS_TOKEN_COMPARISON_NE)) break; /* skip, handled elsewhere */
-          if(node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr && node->next->token == MS_TOKEN_LITERAL_STRING &&
-             strcmp(node->next->tokenval.strval, "_MAPSERVER_NULL_") == 0 )
-          {
-              native_string += " IS NULL";
-              node = node->next;
-              break;
-          }
-
-          const char* str = msExpressionTokenToString(node->token);
-          if( str == nullptr )
-              goto cleanup;
-          native_string += str;
-          break;
-        }
-        }
-
-      node = node->next;
-    }
-  }
-
-  filter->native_string = msStrdup(native_string.c_str());
-
-  // fprintf(stderr, "output: %s\n", filter->native_string); 
-
-  return MS_SUCCESS;
-
-cleanup:
-  msSetError(MS_MISCERR, "Translation to native SQL failed.", "msPostGISLayerTranslateFilter()");
-  return MS_FAILURE;
-#else
-  msSetError(MS_MISCERR, "PostGIS support is not available.", "msPostGISLayerTranslateFilter()");
-  return MS_FAILURE;
-#endif
-}
-
-int msPostGISLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != nullptr);
-  assert(layer->vtable != nullptr);
-
-  layer->vtable->LayerTranslateFilter = msPostGISLayerTranslateFilter;
-
-  layer->vtable->LayerInitItemInfo = msPostGISLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msPostGISLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msPostGISLayerOpen;
-  layer->vtable->LayerIsOpen = msPostGISLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msPostGISLayerWhichShapes;
-  layer->vtable->LayerNextShape = msPostGISLayerNextShape;
-  layer->vtable->LayerGetShape = msPostGISLayerGetShape;
-  layer->vtable->LayerGetShapeCount = msPostGISLayerGetShapeCount;
-  layer->vtable->LayerClose = msPostGISLayerClose;
-  layer->vtable->LayerGetItems = msPostGISLayerGetItems;
-  layer->vtable->LayerGetExtent = msPostGISLayerGetExtent;
-  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
-  /* layer->vtable->LayerGetAutoStyle, not supported for this layer */
-  /* layer->vtable->LayerCloseConnection = msPostGISLayerClose; */
-  // layer->vtable->LayerSetTimeFilter = msPostGISLayerSetTimeFilter;
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  layer->vtable->LayerGetNumFeatures = msPostGISLayerGetNumFeatures;
-
-  /* layer->vtable->LayerGetAutoProjection, use defaut*/
-
-  layer->vtable->LayerEscapeSQLParam = msPostGISEscapeSQLParam;
-  layer->vtable->LayerEnablePaging = msPostGISEnablePaging;
-  layer->vtable->LayerGetPaging = msPostGISGetPaging;
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mappostgis.h 8.2.0~beta1-1~exp1/mappostgis.h
--- 8.0.1-5/mappostgis.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mappostgis.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,150 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  PostGIS CONNECTIONTYPE support.
- * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
- *           Dave Blasby <dblasby@gmail.com>
- *
- ******************************************************************************
- * Copyright (c) 2010 Paul Ramsey
- * Copyright (c) 2002 Refractions Research
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifdef USE_POSTGIS
-
-#include "libpq-fe.h"
-#include <string>
-
-#ifndef LITTLE_ENDIAN
-#define LITTLE_ENDIAN 1
-#endif
-#ifndef BIG_ENDIAN
-#define BIG_ENDIAN 2
-#endif
-
-/* HEX = 16, BASE64 = 64, RAW = 256*/
-#define TRANSFER_ENCODING 256
-
-/* Substitution token for box hackery */
-#define BOXTOKEN "!BOX!"
-#define BOXTOKENLENGTH 5
-
-/*
-** msPostGISLayerInfo
-**
-** Specific information needed for managing this layer.
-*/
-typedef struct {
-  std::string sql{};                 /* SQL query to send to database */
-  PGconn      *pgconn = nullptr;     /* Connection to database */
-  long        rownum = 0;            /* What row is the next to be read (for random access) */
-  PGresult    *pgresult = nullptr;   /* For fetching rows from the database */
-  std::string uid{};                 /* Name of user-specified unique identifier, if set */
-  std::string srid{};                /* Name of user-specified SRID: zero-length => calculate; non-zero => use this value! */
-  std::string geomcolumn{};          /* Specified geometry column, eg "THEGEOM from thetable" */
-  std::string fromsource{};          /* Specified record source, ed "thegeom from THETABLE" or "thegeom from (SELECT..) AS FOO" */
-  int         endian = 0;            /* Endianness of the mapserver host */
-  int         version = 0;           /* PostGIS version of the database */
-  int         paging = 0;            /* Driver handling of pagination, enabled by default */
-  int         force2d = 0;           /* Pass geometry through ST_Force2D */
-}
-msPostGISLayerInfo;
-
-
-/*
-** Utility structure for handling the WKB returned by the database while
-** reading.
-*/
-typedef struct {
-  char *wkb; /* Pointer to front of WKB */
-  char *ptr; /* Pointer to current write point */
-  size_t size; /* Size of allocated space */
-  const int *typemap; /* Look-up array to valid OGC types */
-} wkbObj;
-
-/*
-** All the WKB type numbers from the OGC
-*/
-typedef enum {
-  WKB_POINT=1,
-  WKB_LINESTRING=2,
-  WKB_POLYGON=3,
-  WKB_MULTIPOINT=4,
-  WKB_MULTILINESTRING=5,
-  WKB_MULTIPOLYGON=6,
-  WKB_GEOMETRYCOLLECTION=7,
-  WKB_CIRCULARSTRING=8,
-  WKB_COMPOUNDCURVE=9,
-  WKB_CURVEPOLYGON=10,
-  WKB_MULTICURVE=11,
-  WKB_MULTISURFACE=12
-} wkb_typenum;
-
-/*
-** See below.
-*/
-#define WKB_TYPE_COUNT 16
-
-/*
-** Map the WKB type numbers returned by PostGIS < 2.0 to the
-** valid OGC numbers
-*/
-static const int wkb_postgis15[WKB_TYPE_COUNT] = {
-  0,
-  WKB_POINT,
-  WKB_LINESTRING,
-  WKB_POLYGON,
-  WKB_MULTIPOINT,
-  WKB_MULTILINESTRING,
-  WKB_MULTIPOLYGON,
-  WKB_GEOMETRYCOLLECTION,
-  WKB_CIRCULARSTRING,
-  WKB_COMPOUNDCURVE,
-  0,0,0,
-  WKB_CURVEPOLYGON,
-  WKB_MULTICURVE,
-  WKB_MULTISURFACE
-};
-
-/*
-** Map the WKB type numbers returned by PostGIS >= 2.0 to the
-** valid OGC numbers
-*/
-static const int wkb_postgis20[WKB_TYPE_COUNT] = {
-  0,
-  WKB_POINT,
-  WKB_LINESTRING,
-  WKB_POLYGON,
-  WKB_MULTIPOINT,
-  WKB_MULTILINESTRING,
-  WKB_MULTIPOLYGON,
-  WKB_GEOMETRYCOLLECTION,
-  WKB_CIRCULARSTRING,
-  WKB_COMPOUNDCURVE,
-  WKB_CURVEPOLYGON,
-  WKB_MULTICURVE,
-  WKB_MULTISURFACE,
-  0,0,0
-};
-
-#endif /* USE_POSTGIS */
-
diff -pruN 8.0.1-5/mappostgresql.c 8.2.0~beta1-1~exp1/mappostgresql.c
--- 8.0.1-5/mappostgresql.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mappostgresql.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,450 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Postgres CONNECTIONTYPE support.
- * Author:   Mark Leslie, Refractions Research
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-/* $Id$ */
-#include <assert.h>
-#include "mapserver.h"
-#include "maptime.h"
-
-#ifndef FLT_MAX
-#define FLT_MAX 25000000.0
-#endif
-
-#ifdef USE_POSTGIS
-
-#ifndef LITTLE_ENDIAN
-#define LITTLE_ENDIAN 1
-#endif
-#ifndef BIG_ENDIAN
-#define BIG_ENDIAN 2
-#endif
-
-#include "libpq-fe.h"
-#include <string.h>
-#include <ctype.h> /* tolower() */
-
-
-
-
-typedef struct {
-  PGconn      *conn;          /* connection to db */
-  long        row_num;        /* what row is the NEXT to be read (for random access) */
-  PGresult    *query_result;  /* for fetching rows from the db */
-  int         from_index;
-  char        *to_column;
-  char        *from_value;
-  int         layer_debug;    /* there's no debug on the join, so use the layer */
-} msPOSTGRESQLJoinInfo;
-
-/************************************************************************/
-/*                      msPOSTGRESQLJoinConnect()                       */
-/*                                                                      */
-/* Creates and populates the joininfo struct, including establishing    */
-/* a connection to the database.  Since the join and layer won't always */
-/* share connection details, there is currently no mechanism to use     */
-/* pooled connections with joins.                                       */
-/************************************************************************/
-
-int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join)
-{
-  char *maskeddata, *temp, *sql, *column;
-  char *conn_decrypted;
-  int i, test;
-  PGresult *query_result;
-  msPOSTGRESQLJoinInfo *joininfo;
-
-  if(join->joininfo)
-    return MS_SUCCESS;
-
-  joininfo = (msPOSTGRESQLJoinInfo *)malloc(sizeof(msPOSTGRESQLJoinInfo));
-  if(!joininfo) {
-    msSetError(MS_MEMERR, "Error allocating join info struct.",
-               "msPOSTGRESQLJoinConnect()");
-    return MS_FAILURE;
-  }
-  joininfo->conn = NULL;
-  joininfo->row_num = 0;
-  joininfo->query_result = NULL;
-  joininfo->from_index = 0;
-  joininfo->to_column = join->to;
-  joininfo->from_value = NULL;
-  joininfo->layer_debug = layer->debug;
-  join->joininfo = joininfo;
-
-  /*
-   * We need three things at a minimum, the connection string, a table
-   * name, and a column to join on.
-   */
-  if(!join->connection) {
-    msSetError(MS_QUERYERR, "No connection information provided.",
-               "MSPOSTGRESQLJoinConnect()");
-    return MS_FAILURE;
-  }
-  if(!join->table) {
-    msSetError(MS_QUERYERR, "No join table name found.",
-               "msPOSTGRESQLJoinConnect()");
-    return MS_FAILURE;
-  }
-  if(!joininfo->to_column) {
-    msSetError(MS_QUERYERR, "No join to column name found.",
-               "msPOSTGRESQLJoinConnect()");
-    return MS_FAILURE;
-  }
-
-  /* Establish database connection */
-  conn_decrypted = msDecryptStringTokens(layer->map, join->connection);
-  if (conn_decrypted != NULL) {
-    joininfo->conn = PQconnectdb(conn_decrypted);
-    free(conn_decrypted);
-  }
-  if(!joininfo->conn || PQstatus(joininfo->conn) == CONNECTION_BAD) {
-    maskeddata = (char *)malloc(strlen(layer->connection) + 1);
-    strcpy(maskeddata, join->connection);
-    temp = strstr(maskeddata, "password=");
-    if(temp) {
-      temp = (char *)(temp + 9);
-      while (*temp != '\0' && *temp != ' ') {
-        *temp = '*';
-        temp++;
-      }
-    }
-    msSetError(MS_QUERYERR,
-               "Unable to connect to PostgreSQL using the string %s.\n  Error reported: %s\n",
-               "msPOSTGRESQLJoinConnect()",
-               maskeddata, PQerrorMessage(joininfo->conn));
-    free(maskeddata);
-    if(!joininfo->conn) {
-      free(joininfo->conn);
-    }
-    free(joininfo);
-    join->joininfo = NULL;
-    return MS_FAILURE;
-  }
-
-  /* Determine the number and names of columns in the join table. */
-  sql = (char *)malloc(36 + strlen(join->table) + 1);
-  sprintf(sql, "SELECT * FROM %s WHERE false LIMIT 0", join->table);
-
-  if(joininfo->layer_debug) {
-    msDebug("msPOSTGRESQLJoinConnect(): executing %s.\n", sql);
-  }
-
-  query_result = PQexec(joininfo->conn, sql);
-  if(!query_result || PQresultStatus(query_result) != PGRES_TUPLES_OK) {
-    msSetError(MS_QUERYERR, "Error determining join items: %s.",
-               "msPOSTGRESQLJoinConnect()", PQerrorMessage(joininfo->conn));
-    if(query_result) {
-      PQclear(query_result);
-      query_result = NULL;
-    }
-    free(sql);
-    return MS_FAILURE;
-  }
-  free(sql);
-  join->numitems = PQnfields(query_result);
-  join->items = malloc(sizeof(char *) * (join->numitems));
-
-  /* We want the join-to column to be first in the list. */
-  test = 1;
-  for(i = 0; i < join->numitems; i++) {
-    column = PQfname(query_result, i);
-    if(strcmp(column, joininfo->to_column) != 0) {
-      join->items[i + test] = (char *)malloc(strlen(column) + 1);
-      strcpy(join->items[i + test], column);
-    } else {
-      test = 0;
-      join->items[0] = (char *)malloc(strlen(column) + 1);
-      strcpy(join->items[0], column);
-    }
-  }
-  PQclear(query_result);
-  query_result = NULL;
-  if(test == 1) {
-    msSetError(MS_QUERYERR, "Unable to find join to column: %s",
-               "msPOSTGRESQLJoinConnect()", joininfo->to_column);
-    return MS_FAILURE;
-  }
-
-  if(joininfo->layer_debug) {
-    for(i = 0; i < join->numitems; i++) {
-      msDebug("msPOSTGRESQLJoinConnect(): Column %d named %s\n", i, join->items[i]);
-    }
-  }
-
-  /* Determine the index of the join from column. */
-  for(i = 0; i < layer->numitems; i++) {
-    if(strcasecmp(layer->items[i], join->from) == 0) {
-      joininfo->from_index = i;
-      break;
-    }
-  }
-
-  if(i == layer->numitems) {
-    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
-               "msPOSTGRESQLJoinConnect()", join->from, layer->name);
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                                                                      */
-/*                       msPOSTGRESQLJoinPrepare()                      */
-/* Sets up the joininfo to be ready to join against the given shape.    */
-/* There's not much involved here, just freeing previous results and    */
-/* resources, and setting the next value to join to.                    */
-/************************************************************************/
-
-int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape)
-{
-
-  /* We need a connection, and a shape with values to join to. */
-  msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join has not been connected.", "msPOSTGRESQLJoinPrepare()");
-    return MS_FAILURE;
-  }
-
-  if(!shape) {
-    msSetError(MS_JOINERR, "Null shape provided for join.", "msPOSTGRESQLJoinPrepare()");
-    return MS_FAILURE;
-  }
-
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape has no attributes.  Kinda hard to join against.", "msPOSTGRESQLJoinPrepare()");
-    return MS_FAILURE;
-  }
-  joininfo->row_num = 0;
-
-  /* Free the previous join value, if any. */
-  if(joininfo->from_value) {
-    free(joininfo->from_value);
-  }
-
-  /* Free the previous results, if any. */
-  if(joininfo->query_result) {
-    PQclear(joininfo->query_result);
-    joininfo->query_result = NULL;
-  }
-
-  /* Copy the next join value from the shape. */
-  joininfo->from_value = msStrdup(shape->values[joininfo->from_index]);
-
-  if(joininfo->layer_debug) {
-    msDebug("msPOSTGRESQLJoinPrepare() preping for value %s.\n",
-            joininfo->from_value);
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msPOSTGRESQLJoinNext()                         */
-/*                                                                      */
-/* The goal here is to populate join->values with the detail of the     */
-/* join against the previously prepared shapeObj.  This will be called  */
-/* only once for a one-to-one join, with msPOSTGRESQLJoinPrepare()      */
-/* being called before each.  It will be called repeatedly for          */
-/* one-to-many joins, until in returns MS_DONE.  To accomodate this,    */
-/* we store the next row number and query results in the joininfo and   */
-/* process the next tuple on each call.                                 */
-/************************************************************************/
-int msPOSTGRESQLJoinNext(joinObj *join)
-{
-  msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
-  int i, length, row_count;
-  char *sql, *columns;
-
-  /* We need a connection, and a join value. */
-  if(!joininfo || !joininfo->conn) {
-    msSetError(MS_JOINERR, "Join has not been connected.\n",
-               "msPOSTGRESQLJoinNext()");
-    return MS_FAILURE;
-  }
-
-  if(!joininfo->from_value) {
-    msSetError(MS_JOINERR, "Join has not been prepared.\n",
-               "msPOSTGRESQLJoinNext()");
-    return MS_FAILURE;
-  }
-
-  /* Free the previous results. */
-  if(join->values) {
-    msFreeCharArray(join->values, join->numitems);
-    join->values = NULL;
-  }
-
-  /* We only need to execute the query if no results exist. */
-  if(!joininfo->query_result) {
-    /* Write the list of column names. */
-    length = 0;
-    for(i = 0; i < join->numitems; i++) {
-      length += 8 + strlen(join->items[i]) + 2;
-    }
-
-    columns = (char *)malloc(length);
-    if(!columns) {
-      msSetError(MS_MEMERR, "Failure to malloc.\n",
-                 "msPOSTGRESQLJoinNext()");
-      return MS_FAILURE;
-    }
-
-    strcpy(columns, "");
-    for(i = 0; i < join->numitems; i++) {
-      strcat(columns, "\"");
-      strcat(columns, join->items[i]);
-      strcat(columns, "\"::text");
-      if(i != join->numitems - 1) {
-        strcat(columns, ", ");
-      }
-    }
-
-    /* Create the query string. */
-    sql = (char *)malloc(26 + strlen(columns) + strlen(join->table) +
-                         strlen(join->to) + strlen(joininfo->from_value));
-    if(!sql) {
-      msSetError(MS_MEMERR, "Failure to malloc.\n",
-                 "msPOSTGRESQLJoinNext()");
-      return MS_FAILURE;
-    }
-    sprintf(sql, "SELECT %s FROM %s WHERE %s = '%s'", columns, join->table, join->to, joininfo->from_value);
-    if(joininfo->layer_debug) {
-      msDebug("msPOSTGRESQLJoinNext(): executing %s.\n", sql);
-    }
-
-    free(columns);
-
-    joininfo->query_result = PQexec(joininfo->conn, sql);
-
-    if(!joininfo->query_result ||
-        PQresultStatus(joininfo->query_result) != PGRES_TUPLES_OK) {
-      msSetError(MS_QUERYERR, "Error executing queri %s: %s\n",
-                 "msPOSTGRESQLJoinNext()", sql,
-                 PQerrorMessage(joininfo->conn));
-      if(joininfo->query_result) {
-        PQclear(joininfo->query_result);
-        joininfo->query_result = NULL;
-      }
-      free(sql);
-      return MS_FAILURE;
-    }
-    free(sql);
-  }
-  row_count = PQntuples(joininfo->query_result);
-
-  /* see if we're done processing this set */
-  if(joininfo->row_num >= row_count) {
-    return(MS_DONE);
-  }
-  if(joininfo->layer_debug) {
-    msDebug("msPOSTGRESQLJoinNext(): fetching row %ld.\n",
-            joininfo->row_num);
-  }
-
-  /* Copy the resulting values into the joinObj. */
-  join->values = (char **)malloc(sizeof(char *) * join->numitems);
-  for(i = 0; i < join->numitems; i++) {
-    join->values[i] = msStrdup(PQgetvalue(
-                                 joininfo->query_result, joininfo->row_num, i));
-  }
-
-  joininfo->row_num++;
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msPOSTGRESQLJoinClose()                        */
-/*                                                                      */
-/* Closes the connection and frees the resources used by the joininfo.  */
-/************************************************************************/
-
-int msPOSTGRESQLJoinClose(joinObj *join)
-{
-  msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
-
-  if(!joininfo) {
-    msDebug("msPOSTGRESQLJoinClose() already close or never opened.\n");
-    return MS_SUCCESS;
-  }
-
-  if(joininfo->query_result) {
-    msDebug("msPOSTGRESQLJoinClose(): clearing query_result.\n");
-    PQclear(joininfo->query_result);
-    joininfo->query_result = NULL;
-  }
-
-  if(joininfo->conn) {
-    msDebug("msPOSTGRESQLJoinClose(): closing connection.\n");
-    PQfinish(joininfo->conn);
-    joininfo->conn = NULL;
-  }
-
-  /* removed free(joininfo->to_column), see bug #2936 */
-
-  if(joininfo->from_value) {
-    free(joininfo->from_value);
-  }
-
-  free(joininfo);
-  join->joininfo = NULL;
-
-  return MS_SUCCESS;
-}
-
-#else  /* not USE_POSTGIS */
-int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinConnect()");
-  return MS_FAILURE;
-}
-
-int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinPrepare()");
-  return MS_FAILURE;
-
-}
-
-int msPOSTGRESQLJoinNext(joinObj *join)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinNext()");
-  return MS_FAILURE;
-
-}
-
-int msPOSTGRESQLJoinClose(joinObj *join)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinClose()");
-  return MS_FAILURE;
-
-}
-#endif
diff -pruN 8.0.1-5/mapprimitive.c 8.2.0~beta1-1~exp1/mapprimitive.c
--- 8.0.1-5/mapprimitive.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapprimitive.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2435 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementations for rectObj, pointObj, lineObj, shapeObj, etc.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-#include "mapserver.h"
-#include "mapprimitive.h"
-#include <assert.h>
-#include <locale.h>
-#include "fontcache.h"
-
-
-typedef enum {CLIP_LEFT, CLIP_MIDDLE, CLIP_RIGHT} CLIP_STATE;
-
-#define CLIP_CHECK(min, a, max) ((a) < (min) ? CLIP_LEFT : ((a) > (max) ? CLIP_RIGHT : CLIP_MIDDLE));
-#define ROUND(a)       ( (a) + 0.5 )
-#define SWAP( a, b, t) ( (t) = (a), (a) = (b), (b) = (t) )
-#define EDGE_CHECK( x0, x, x1) ((x) < MS_MIN( (x0), (x1)) ? CLIP_LEFT : ((x) > MS_MAX( (x0), (x1)) ? CLIP_RIGHT : CLIP_MIDDLE ))
-
-#ifndef INFINITY
-#define INFINITY (1.0e+30)
-#endif
-#define NEARZERO (1.0e-30) /* 1/INFINITY */
-
-void msPrintShape(shapeObj *p)
-{
-  int i,j;
-
-  msDebug("Shape contains %d parts.\n",  p->numlines);
-  for (i=0; i<p->numlines; i++) {
-    msDebug("\tPart %d contains %d points.\n", i, p->line[i].numpoints);
-    for (j=0; j<p->line[i].numpoints; j++) {
-      msDebug("\t\t%d: (%f, %f)\n", j, p->line[i].point[j].x, p->line[i].point[j].y);
-    }
-  }
-}
-
-shapeObj *msShapeFromWKT(const char *string)
-{
-#ifdef USE_GEOS
-  return msGEOSShapeFromWKT(string);
-#else
-  return msOGRShapeFromWKT(string);
-#endif
-}
-
-char *msShapeToWKT(shapeObj *shape)
-{
-#ifdef USE_GEOS
-  char* pszGEOSStr;
-  char* pszStr;
-  pszGEOSStr = msGEOSShapeToWKT(shape);
-  pszStr = (pszGEOSStr) ? msStrdup(pszGEOSStr) : NULL;
-  msGEOSFreeWKT(pszGEOSStr);
-  return pszStr;
-#else
-  return msOGRShapeToWKT(shape);
-#endif
-}
-
-void msInitShape(shapeObj *shape)
-{
-  /* spatial component */
-  shape->line = NULL;
-  shape->numlines = 0;
-  shape->type = MS_SHAPE_NULL;
-  shape->bounds.minx = shape->bounds.miny = -1;
-  shape->bounds.maxx = shape->bounds.maxy = -1;
-
-  /* attribute component */
-  shape->values = NULL;
-  shape->numvalues = 0;
-
-  shape->geometry = NULL;
-  shape->renderer_cache = NULL;
-
-  /* annotation component */
-  shape->text = NULL;
-
-  /* bookkeeping component */
-  shape->classindex = 0; /* default class */
-  shape->tileindex = shape->index = shape->resultindex = -1;
-
-  shape->scratch = MS_FALSE; /* not a temporary/scratch shape */
-}
-
-int msCopyShape(const shapeObj *from, shapeObj *to)
-{
-  int i;
-
-  if(!from || !to) return(-1);
-
-  for(i=0; i<from->numlines; i++)
-    msAddLine(to, &(from->line[i])); /* copy each line */
-
-  to->type = from->type;
-
-  to->bounds.minx = from->bounds.minx;
-  to->bounds.miny = from->bounds.miny;
-  to->bounds.maxx = from->bounds.maxx;
-  to->bounds.maxy = from->bounds.maxy;
-
-  if(from->text) to->text = msStrdup(from->text);
-
-  to->classindex = from->classindex;
-  to->index = from->index;
-  to->tileindex = from->tileindex;
-  to->resultindex = from->resultindex;
-
-  if(from->values) {
-    if (to->values) msFreeCharArray(to->values, to->numvalues);
-    to->values = (char **)msSmallMalloc(sizeof(char *)*from->numvalues);
-    for(i=0; i<from->numvalues; i++)
-      to->values[i] = msStrdup(from->values[i]);
-    to->numvalues = from->numvalues;
-  }
-
-  to->geometry = NULL; /* GEOS code will build automatically if necessary */
-  to->scratch = from->scratch;
-
-  return(0);
-}
-
-void msFreeShape(shapeObj *shape)
-{
-  int c;
-
-  if(!shape) return; /* for safety */
-
-  for (c= 0; c < shape->numlines; c++)
-    free(shape->line[c].point);
-
-  if (shape->line) free(shape->line);
-  if(shape->values) msFreeCharArray(shape->values, shape->numvalues);
-  if(shape->text) free(shape->text);
-
-#ifdef USE_GEOS
-  msGEOSFreeGeometry(shape);
-#endif
-
-  msInitShape(shape); /* now reset */
-}
-
-int msGetShapeRAMSize(shapeObj* shape)
-{
-    int i;
-    int size = 0;
-    size += sizeof(shapeObj);
-    size += shape->numlines * sizeof(lineObj);
-    for (i = 0; i < shape->numlines; i++)
-    {
-        size += shape->line[i].numpoints * sizeof(pointObj);
-    }
-    size += shape->numvalues * sizeof(char*);
-    for( i = 0; i < shape->numvalues; i++ )
-    {
-        if( shape->values[i] )
-            size += strlen( shape->values[i] ) + 1;
-    }
-    if( shape->text )
-        size += strlen( shape->text ) + 1;
-    return size;
-}
-
-void msFreeLabelPathObj(labelPathObj *path)
-{
-  msFreeShape(&(path->bounds));
-  msFree(path->path.point);
-  msFree(path->angles);
-  msFree(path);
-}
-
-void msShapeDeleteLine( shapeObj *shape, int line )
-{
-  if( line < 0 || line >= shape->numlines ) {
-    assert( 0 );
-    return;
-  }
-
-  free( shape->line[line].point );
-  if( line < shape->numlines - 1 ) {
-    memmove( shape->line + line,
-             shape->line + line + 1,
-             sizeof(lineObj) * (shape->numlines - line - 1) );
-  }
-  shape->numlines--;
-}
-
-void msComputeBounds(shapeObj *shape)
-{
-  int i, j;
-  if(shape->numlines <= 0) return;
-  for(i=0; i<shape->numlines; i++) {
-    if(shape->line[i].numpoints > 0) {
-      shape->bounds.minx = shape->bounds.maxx = shape->line[i].point[0].x;
-      shape->bounds.miny = shape->bounds.maxy = shape->line[i].point[0].y;
-      break;
-    }
-  }
-  if(i == shape->numlines) return;
-
-  for( i=0; i<shape->numlines; i++ ) {
-    for( j=0; j<shape->line[i].numpoints; j++ ) {
-      shape->bounds.minx = MS_MIN(shape->bounds.minx, shape->line[i].point[j].x);
-      shape->bounds.maxx = MS_MAX(shape->bounds.maxx, shape->line[i].point[j].x);
-      shape->bounds.miny = MS_MIN(shape->bounds.miny, shape->line[i].point[j].y);
-      shape->bounds.maxy = MS_MAX(shape->bounds.maxy, shape->line[i].point[j].y);
-    }
-  }
-}
-
-/* checks to see if ring r is an outer ring of shape */
-int msIsOuterRing(shapeObj *shape, int r)
-{
-  int i, status=MS_TRUE;
-  int result1, result2;
-
-  if(!shape) return MS_FALSE ;
-  if(shape->numlines == 1) return MS_TRUE;
-  if(r < 0 || r >= shape->numlines) return MS_FALSE; /* bad ring index */
-
-  for(i=0; i<shape->numlines; i++) {
-    if(i == r) continue;
-
-    /*
-    ** We have to test 2, or perhaps 3 points on the shape against the ring because
-    ** it is possible that at most one point could touch the ring and the function
-    ** msPointInPolygon() is indeterminite in that case. (bug #2434)
-    */
-    result1 = msPointInPolygon(&(shape->line[r].point[0]), &(shape->line[i]));
-    result2 = msPointInPolygon(&(shape->line[r].point[1]), &(shape->line[i]));
-    if(result1 == result2) { /* same result twice, neither point was on the edge */
-      if(result1 == MS_TRUE) status = !status;
-    } else { /* one of the first 2 points were on the edge of the ring, the next one isn't */
-      if(msPointInPolygon(&(shape->line[r].point[2]), &(shape->line[i])) == MS_TRUE)
-        status = !status;
-    }
-
-  }
-
-  return(status);
-}
-
-/*
-** Returns a list of outer rings for shape (the list has one entry for each ring,
-** MS_TRUE for outer rings).
-*/
-int *msGetOuterList(shapeObj *shape)
-{
-  int i;
-  int *list;
-
-  if(!shape) return NULL;
-
-  list = (int *)malloc(sizeof(int)*shape->numlines);
-  MS_CHECK_ALLOC(list, sizeof(int)*shape->numlines, NULL);
-
-  for(i=0; i<shape->numlines; i++)
-    list[i] = msIsOuterRing(shape, i);
-
-  return list;
-}
-
-/*
-** Returns a list of inner rings for ring r in shape (given a list of outer rings).
-*/
-int *msGetInnerList(shapeObj *shape, int r, int *outerlist)
-{
-  int i;
-  int *list;
-
-  if(!shape || !outerlist) return NULL;
-  if(r < 0 || r >= shape->numlines) return NULL; /* bad ring index */
-
-  list = (int *)malloc(sizeof(int)*shape->numlines);
-  MS_CHECK_ALLOC(list, sizeof(int)*shape->numlines, NULL);
-
-  for(i=0; i<shape->numlines; i++) { /* test all rings against the ring */
-
-    if(outerlist[i] == MS_TRUE) { /* ring is an outer and can't be an inner */
-      list[i] = MS_FALSE;
-      continue;
-    }
-
-    /* A valid inner ring may touch its outer ring at most one point. */
-    /* In the case the first point matches a vertex of an outer ring, */
-    /* msPointInPolygon() might return 0 or 1 (depending on coordinate values, */
-    /* see msGetOuterList()), so test a second point if the first test */
-    /* returned that the point is not inside the outer ring. */
-    /* Fixes #5299 */
-    /* Of course all of this assumes that the geometries are indeed valid in */
-    /* OGC terms, otherwise all logic of msIsOuterRing(), msGetOuterList(), */
-    /* and msGetInnerList() has undefined behaviour. */
-    list[i] = msPointInPolygon(&(shape->line[i].point[0]), &(shape->line[r])) ||
-              msPointInPolygon(&(shape->line[i].point[1]), &(shape->line[r]));
-  }
-
-  return(list);
-}
-
-/*
-** Add point to a line object.
-**
-** Note that reallocating the point array larger for each point can
-** be pretty inefficient, so use this function sparingly.  Mostly
-** geometries creators should create their own working lineObj and
-** then call msAddLine() to add it to a shape.
-*/
-
-int msAddPointToLine(lineObj *line, pointObj *point )
-{
-  line->numpoints += 1;
-
-  line->point = (pointObj *) msSmallRealloc(line->point, sizeof(pointObj) * line->numpoints);
-  line->point[line->numpoints-1] = *point;
-
-  return MS_SUCCESS;
-}
-
-int msAddLine(shapeObj *p, const lineObj *new_line)
-{
-  lineObj lineCopy;
-
-  lineCopy.numpoints = new_line->numpoints;
-  lineCopy.point = (pointObj *) malloc(new_line->numpoints*sizeof(pointObj));
-  MS_CHECK_ALLOC(lineCopy.point, new_line->numpoints*sizeof(pointObj), MS_FAILURE);
-
-  if( new_line->point )
-      memcpy( lineCopy.point, new_line->point, sizeof(pointObj) * new_line->numpoints );
-
-  // cppcheck-suppress memleak
-  return msAddLineDirectly( p, &lineCopy );
-}
-
-/*
-** Same as msAddLine(), except that this version "seizes" the points
-** array from the passed in line and uses it instead of copying it.
-*/
-int msAddLineDirectly(shapeObj *p, lineObj *new_line)
-{
-  int c;
-
-  if( p->numlines == 0 ) {
-    p->line = (lineObj *) malloc(sizeof(lineObj));
-  } else {
-    lineObj* newline = (lineObj *) realloc(p->line, (p->numlines+1)*sizeof(lineObj));
-    if( !newline ) {
-        free(p->line);
-    }
-    p->line = newline;
-  }
-  if( !p->line )
-  {
-    free(new_line->point );
-    new_line->point = NULL;
-    new_line->numpoints = 0;
-  }
-  MS_CHECK_ALLOC(p->line, (p->numlines+1)*sizeof(lineObj), MS_FAILURE);
-
-  /* Copy the new line onto the end of the extended line array */
-  c= p->numlines;
-  p->line[c].numpoints = new_line->numpoints;
-  p->line[c].point = new_line->point;
-
-  /* strip points reference off the passed in lineObj */
-  new_line->point = NULL;
-  new_line->numpoints = 0;
-
-  /* Update the polygon information */
-  p->numlines++;
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Converts a rect array to a shapeObj structure. Note order is CW assuming y origin
-** is in the lower left corner (normal cartesian coordinate system). Also polygon is
-** is closed (i.e. first=last). This conforms to the shapefile specification. For image
-** coordinate systems (i.e. GD) this is back-ass-ward, which is fine cause the function
-** that calculates direction assumes min y = lower left, this way it'll still work. Drawing
-** functions are independent of direction. Orientation problems can cause some nasty bugs.
-*/
-void msRectToPolygon(rectObj rect, shapeObj *poly)
-{
-  lineObj line= {0,NULL};
-
-  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*5);
-
-  line.point[0].x = rect.minx;
-  line.point[0].y = rect.miny;
-  line.point[1].x = rect.minx;
-  line.point[1].y = rect.maxy;
-  line.point[2].x = rect.maxx;
-  line.point[2].y = rect.maxy;
-  line.point[3].x = rect.maxx;
-  line.point[3].y = rect.miny;
-  line.point[4].x = line.point[0].x;
-  line.point[4].y = line.point[0].y;
-
-  line.numpoints = 5;
-
-  msAddLine(poly, &line);
-  if(poly->numlines == 1) { /* poly was empty to begin with */
-    poly->type = MS_SHAPE_POLYGON;
-    poly->bounds = rect;
-  } else
-    msMergeRect(&poly->bounds, &rect);
-  free(line.point);
-}
-
-/*
-** Private implementation of the Sutherland-Cohen algorithm. Inspired by
-** "Getting Graphic: Programming Fundamentals in C and C++" by Mark Finlay
-** and John Petritis. (pages 179-182)
-*/
-static int clipLine(double *x1, double *y1, double *x2, double *y2, rectObj rect)
-{
-  double x, y;
-  double slope;
-  CLIP_STATE check1, check2;
-
-  if(*x1 < rect.minx && *x2 < rect.minx)
-    return(MS_FALSE);
-  if(*x1 > rect.maxx && *x2 > rect.maxx)
-    return(MS_FALSE);
-
-  check1 = CLIP_CHECK(rect.minx, *x1, rect.maxx);
-  check2 = CLIP_CHECK(rect.minx, *x2, rect.maxx);
-  if(check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
-    slope = (*y2 - *y1)/(*x2 - *x1);
-    y = *y1 + (rect.minx - *x1)*slope;
-    if(check1 == CLIP_LEFT) {
-      *x1 = rect.minx;
-      *y1 = y;
-    } else {
-      *x2 = rect.minx;
-      *y2 = y;
-    }
-  }
-  if(check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
-    slope = (*y2 - *y1)/(*x2 - *x1);
-    y = *y1 + (rect.maxx - *x1)*slope;
-    if(check1 == CLIP_RIGHT) {
-      *x1 = rect.maxx;
-      *y1 = y;
-    } else {
-      *x2 = rect.maxx;
-      *y2 = y;
-    }
-  }
-
-  if(*y1 < rect.miny && *y2 < rect.miny)
-    return(MS_FALSE);
-  if(*y1 > rect.maxy && *y2 > rect.maxy)
-    return(MS_FALSE);
-
-  check1 = CLIP_CHECK(rect.miny, *y1, rect.maxy);
-  check2 = CLIP_CHECK(rect.miny, *y2, rect.maxy);
-  if(check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
-    slope = (*x2 - *x1)/(*y2 - *y1);
-    x = *x1 + (rect.miny - *y1)*slope;
-    if(check1 == CLIP_LEFT) {
-      *x1 = x;
-      *y1 = rect.miny;
-    } else {
-      *x2 = x;
-      *y2 = rect.miny;
-    }
-  }
-  if(check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
-    slope = (*x2 - *x1)/(*y2 - *y1);
-    x = *x1 + (rect.maxy - *y1)*slope;
-    if(check1 == CLIP_RIGHT) {
-      *x1 = x;
-      *y1 = rect.maxy;
-    } else {
-      *x2 = x;
-      *y2 = rect.maxy;
-    }
-  }
-
-  return(MS_TRUE);
-}
-
-/*
-** Routine for clipping a polyline, stored in a shapeObj struct, to a
-** rectangle. Uses clipLine() function to create a new shapeObj.
-*/
-void msClipPolylineRect(shapeObj *shape, rectObj rect)
-{
-  int i,j;
-  lineObj line= {0,NULL};
-  double x1, x2, y1, y2;
-  shapeObj tmp;
-
-  if(!shape || shape->numlines == 0) /* nothing to clip */
-    return;
-
-  memset( &tmp, 0, sizeof(shapeObj) );
-
-  /*
-  ** Don't do any clip processing of shapes completely within the
-  ** clip rectangle based on a comparison of bounds.   We could do
-  ** something similar for completely outside, but that rarely occurs
-  ** since the spatial query at the layer read level has generally already
-  ** discarded all shapes completely outside the rect.
-  */
-  if( shape->bounds.maxx <= rect.maxx
-      && shape->bounds.minx >= rect.minx
-      && shape->bounds.maxy <= rect.maxy
-      && shape->bounds.miny >= rect.miny ) {
-    return;
-  }
-
-  for(i=0; i<shape->numlines; i++) {
-
-    line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*shape->line[i].numpoints);
-    line.numpoints = 0;
-
-    x1 = shape->line[i].point[0].x;
-    y1 = shape->line[i].point[0].y;
-    for(j=1; j<shape->line[i].numpoints; j++) {
-      x2 = shape->line[i].point[j].x;
-      y2 = shape->line[i].point[j].y;
-
-      if(clipLine(&x1,&y1,&x2,&y2,rect) == MS_TRUE) {
-        if(line.numpoints == 0) { /* first segment, add both points */
-          line.point[0].x = x1;
-          line.point[0].y = y1;
-          line.point[1].x = x2;
-          line.point[1].y = y2;
-          line.numpoints = 2;
-        } else { /* add just the last point */
-          line.point[line.numpoints].x = x2;
-          line.point[line.numpoints].y = y2;
-          line.numpoints++;
-        }
-
-        if((x2 != shape->line[i].point[j].x) || (y2 != shape->line[i].point[j].y)) {
-          msAddLine(&tmp, &line);
-          line.numpoints = 0; /* new line */
-        }
-      }
-
-      x1 = shape->line[i].point[j].x;
-      y1 = shape->line[i].point[j].y;
-    }
-
-    if(line.numpoints > 0) {
-      msAddLineDirectly(&tmp, &line);
-    } else {
-      free(line.point);
-      line.numpoints = 0; /* new line */
-    }
-  }
-
-  for (i=0; i<shape->numlines; i++) free(shape->line[i].point);
-  free(shape->line);
-
-  shape->line = tmp.line;
-  shape->numlines = tmp.numlines;
-  msComputeBounds(shape);
-}
-
-/*
-** Slightly modified version of the Liang-Barsky polygon clipping algorithm
-*/
-void msClipPolygonRect(shapeObj *shape, rectObj rect)
-{
-  int i, j;
-  double deltax, deltay, xin,xout,  yin,yout;
-  double tinx,tiny,  toutx,touty,  tin1, tin2,  tout;
-  double x1,y1, x2,y2;
-
-  shapeObj tmp;
-  lineObj line= {0,NULL};
-
-  if(!shape || shape->numlines == 0) /* nothing to clip */
-    return;
-
-  msInitShape(&tmp);
-
-  /*
-  ** Don't do any clip processing of shapes completely within the
-  ** clip rectangle based on a comparison of bounds.   We could do
-  ** something similar for completely outside, but that rarely occurs
-  ** since the spatial query at the layer read level has generally already
-  ** discarded all shapes completely outside the rect.
-  */
-  if( shape->bounds.maxx <= rect.maxx
-      && shape->bounds.minx >= rect.minx
-      && shape->bounds.maxy <= rect.maxy
-      && shape->bounds.miny >= rect.miny ) {
-    return;
-  }
-
-  for(j=0; j<shape->numlines; j++) {
-
-    line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*2*shape->line[j].numpoints+1); /* worst case scenario, +1 allows us to duplicate the 1st and last point */
-    line.numpoints = 0;
-
-    for (i = 0; i < shape->line[j].numpoints-1; i++) {
-
-      x1 = shape->line[j].point[i].x;
-      y1 = shape->line[j].point[i].y;
-      x2 = shape->line[j].point[i+1].x;
-      y2 = shape->line[j].point[i+1].y;
-
-      deltax = x2-x1;
-      if (deltax == 0) { /* bump off of the vertical */
-        deltax = (x1 > rect.minx) ? -NEARZERO : NEARZERO ;
-      }
-      deltay = y2-y1;
-      if (deltay == 0) { /* bump off of the horizontal */
-        deltay = (y1 > rect.miny) ? -NEARZERO : NEARZERO ;
-      }
-
-      if (deltax > 0) { /*  points to right */
-        xin = rect.minx;
-        xout = rect.maxx;
-      } else {
-        xin = rect.maxx;
-        xout = rect.minx;
-      }
-      if (deltay > 0) { /*  points up */
-        yin = rect.miny;
-        yout = rect.maxy;
-      } else {
-        yin = rect.maxy;
-        yout = rect.miny;
-      }
-
-      tinx = (xin - x1)/deltax;
-      tiny = (yin - y1)/deltay;
-
-      if (tinx < tiny) { /* hits x first */
-        tin1 = tinx;
-        tin2 = tiny;
-      } else {            /* hits y first */
-        tin1 = tiny;
-        tin2 = tinx;
-      }
-
-      if (1 >= tin1) {
-        if (0 < tin1) {
-          line.point[line.numpoints].x = xin;
-          line.point[line.numpoints].y = yin;
-          line.numpoints++;
-        }
-        if (1 >= tin2) {
-          toutx = (xout - x1)/deltax;
-          touty = (yout - y1)/deltay;
-
-          tout = (toutx < touty) ? toutx : touty ;
-
-          if (0 < tin2 || 0 < tout) {
-            if (tin2 <= tout) {
-              if (0 < tin2) {
-                if (tinx > tiny) {
-                  line.point[line.numpoints].x = xin;
-                  line.point[line.numpoints].y = y1 + tinx*deltay;
-                  line.numpoints++;
-                } else {
-                  line.point[line.numpoints].x = x1 + tiny*deltax;
-                  line.point[line.numpoints].y = yin;
-                  line.numpoints++;
-                }
-              }
-              if (1 > tout) {
-                if (toutx < touty) {
-                  line.point[line.numpoints].x = xout;
-                  line.point[line.numpoints].y = y1 + toutx*deltay;
-                  line.numpoints++;
-                } else {
-                  line.point[line.numpoints].x = x1 + touty*deltax;
-                  line.point[line.numpoints].y = yout;
-                  line.numpoints++;
-                }
-              } else {
-                line.point[line.numpoints].x = x2;
-                line.point[line.numpoints].y = y2;
-                line.numpoints++;
-              }
-            } else {
-              if (tinx > tiny) {
-                line.point[line.numpoints].x = xin;
-                line.point[line.numpoints].y = yout;
-                line.numpoints++;
-              } else {
-                line.point[line.numpoints].x = xout;
-                line.point[line.numpoints].y = yin;
-                line.numpoints++;
-              }
-            }
-          }
-        }
-      }
-    }
-
-    if(line.numpoints > 0) {
-      line.point[line.numpoints].x = line.point[0].x; /* force closure */
-      line.point[line.numpoints].y = line.point[0].y;
-      line.numpoints++;
-      msAddLineDirectly(&tmp, &line);
-    } else {
-      free(line.point);
-    }
-  } /* next line */
-
-  for (i=0; i<shape->numlines; i++) free(shape->line[i].point);
-  free(shape->line);
-
-  shape->line = tmp.line;
-  shape->numlines = tmp.numlines;
-  msComputeBounds(shape);
-
-  return;
-}
-
-/*
-** offsets a point relative to an image position
-*/
-void msOffsetPointRelativeTo(pointObj *point, layerObj *layer)
-{
-  double x=0, y=0;
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return;
-
-
-  if(layer->transform == MS_TRUE) return; /* nothing to do */
-
-  if(layer->units == MS_PERCENTAGES) {
-    point->x *= (layer->map->width-1);
-    point->y *= (layer->map->height-1);
-  }
-
-  if(layer->transform == MS_FALSE || layer->transform == MS_UL) return; /* done */
-
-  switch(layer->transform) {
-    case MS_UC:
-      x = (layer->map->width-1)/2;
-      y = 0;
-      break;
-    case MS_UR:
-      x = layer->map->width-1;
-      y = 0;
-      break;
-    case MS_CL:
-      x = 0;
-      y = layer->map->height/2;
-      break;
-    case MS_CC:
-      x = layer->map->width/2;
-      y = layer->map->height/2;
-      break;
-    case MS_CR:
-      x = layer->map->width-1;
-      y = layer->map->height/2;
-      break;
-    case MS_LL:
-      x = 0;
-      y = layer->map->height-1;
-      break;
-    case MS_LC:
-      x = layer->map->width/2;
-      y = layer->map->height-1;
-      break;
-    case MS_LR:
-      x = layer->map->width-1;
-      y = layer->map->height-1;
-      break;
-  }
-
-  point->x += x;
-  point->y += y;
-
-  return;
-}
-
-/*
-** offsets a shape relative to an image position
-*/
-void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer)
-{
-  int i, j;
-  double x=0, y=0;
-
-  if(layer->transform == MS_TRUE) return; /* nothing to do */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return;
-
-
-  if(layer->units == MS_PERCENTAGES) {
-    for (i=0; i<shape->numlines; i++) {
-      for (j=0; j<shape->line[i].numpoints; j++) {
-        shape->line[i].point[j].x *= (layer->map->width-1);
-        shape->line[i].point[j].y *= (layer->map->height-1);
-      }
-    }
-  }
-
-  if(layer->transform == MS_FALSE || layer->transform == MS_UL) return; /* done */
-
-  switch(layer->transform) {
-    case MS_UC:
-      x = (layer->map->width-1)/2;
-      y = 0;
-      break;
-    case MS_UR:
-      x = layer->map->width-1;
-      y = 0;
-      break;
-    case MS_CL:
-      x = 0;
-      y = layer->map->height/2;
-      break;
-    case MS_CC:
-      x = layer->map->width/2;
-      y = layer->map->height/2;
-      break;
-    case MS_CR:
-      x = layer->map->width-1;
-      y = layer->map->height/2;
-      break;
-    case MS_LL:
-      x = 0;
-      y = layer->map->height-1;
-      break;
-    case MS_LC:
-      x = layer->map->width/2;
-      y = layer->map->height-1;
-      break;
-    case MS_LR:
-      x = layer->map->width-1;
-      y = layer->map->height-1;
-      break;
-  }
-
-  for (i=0; i<shape->numlines; i++) {
-    for (j=0; j<shape->line[i].numpoints; j++) {
-      shape->line[i].point[j].x += x;
-      shape->line[i].point[j].y += y;
-    }
-  }
-
-  return;
-}
-
-void msTransformShapeSimplify(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j,k,beforelast; /* loop counters */
-  double dx,dy;
-  pointObj *point;
-  double inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
-  int ok = 0;
-  if(shape->numlines == 0) return; /* nothing to transform */
-
-  if(shape->type == MS_SHAPE_LINE) {
-    /*
-     * loop through the shape's lines, and do naive simplification
-     * to discard the points that are too close to one another.
-     * currently the threshold is to discard points if they fall
-     * less than a pixel away from their predecessor.
-     * the simplified line is guaranteed to contain at
-     * least its first and last point
-     */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      if(shape->line[i].numpoints<2) {
-        shape->line[i].numpoints=0;
-        continue; /*skip degenerate lines*/
-      }
-      point=shape->line[i].point;
-      /*always keep first point*/
-      point[0].x = MS_MAP2IMAGE_X_IC_DBL(point[0].x, extent.minx, inv_cs);
-      point[0].y = MS_MAP2IMAGE_Y_IC_DBL(point[0].y, extent.maxy, inv_cs);
-      beforelast=shape->line[i].numpoints-1;
-      for(j=1,k=1; j < beforelast; j++ ) { /*loop from second point to first-before-last point*/
-        point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
-        point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-        dx=(point[k].x-point[k-1].x);
-        dy=(point[k].y-point[k-1].y);
-        if(dx*dx+dy*dy>1)
-          k++;
-      }
-      /* try to keep last point */
-      point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
-      point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-      /* discard last point if equal to the one before it */
-      if(point[k].x!=point[k-1].x || point[k].y!=point[k-1].y) {
-        shape->line[i].numpoints=k+1;
-      } else {
-        shape->line[i].numpoints=k;
-      }
-      /* skip degenerate line once more */
-      if(shape->line[i].numpoints<2) {
-        shape->line[i].numpoints=0;
-      } else {
-        ok = 1; /* we have at least one line with more than two points */
-      }
-    }
-  } else if(shape->type == MS_SHAPE_POLYGON) {
-    /*
-     * loop through the shape's lines, and do naive simplification
-     * to discard the points that are too close to one another.
-     * currently the threshold is to discard points if they fall
-     * less than a pixel away from their predecessor.
-     * the simplified polygon is guaranteed to contain at
-     * least its first, second and last point
-     */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      if(shape->line[i].numpoints<4) {
-        shape->line[i].numpoints=0;
-        continue; /*skip degenerate lines*/
-      }
-      point=shape->line[i].point;
-      /*always keep first and second point*/
-      point[0].x = MS_MAP2IMAGE_X_IC_DBL(point[0].x, extent.minx, inv_cs);
-      point[0].y = MS_MAP2IMAGE_Y_IC_DBL(point[0].y, extent.maxy, inv_cs);
-      point[1].x = MS_MAP2IMAGE_X_IC_DBL(point[1].x, extent.minx, inv_cs);
-      point[1].y = MS_MAP2IMAGE_Y_IC_DBL(point[1].y, extent.maxy, inv_cs);
-      beforelast=shape->line[i].numpoints-2;
-      for(j=2,k=2; j < beforelast; j++ ) { /*loop from second point to second-before-last point*/
-        point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
-        point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-        dx=(point[k].x-point[k-1].x);
-        dy=(point[k].y-point[k-1].y);
-        if(dx*dx+dy*dy>1)
-          k++;
-      }
-      /*always keep last two points (the last point is the repetition of the
-       * first one */
-      point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
-      point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-      point[k+1].x = MS_MAP2IMAGE_X_IC_DBL(point[j+1].x, extent.minx, inv_cs);
-      point[k+1].y = MS_MAP2IMAGE_Y_IC_DBL(point[j+1].y, extent.maxy, inv_cs);
-      shape->line[i].numpoints = k+2;
-      ok = 1;
-    }
-  } else { /* only for untyped shapes, as point layers don't go through this function */
-    for(i=0; i<shape->numlines; i++) {
-      point=shape->line[i].point;
-      for(j=0; j<shape->line[i].numpoints; j++) {
-        point[j].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
-        point[j].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-      }
-    }
-    ok = 1;
-  }
-  if(!ok) {
-    for(i=0; i<shape->numlines; i++) {
-      free(shape->line[i].point);
-    }
-    shape->numlines = 0 ;
-  }
-}
-
-/**
- * Generic function to transorm the shape coordinates to output coordinates
- */
-void  msTransformShape(shapeObj *shape, rectObj extent, double cellsize, imageObj *image)
-{
-  if (image != NULL && MS_RENDERER_PLUGIN(image->format)) {
-    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-    if(renderer->transform_mode == MS_TRANSFORM_SNAPTOGRID) {
-      msTransformShapeToPixelSnapToGrid(shape, extent, cellsize, renderer->approximation_scale);
-    } else if(renderer->transform_mode == MS_TRANSFORM_SIMPLIFY) {
-      msTransformShapeSimplify(shape, extent, cellsize);
-    } else if(renderer->transform_mode == MS_TRANSFORM_ROUND) {
-      msTransformShapeToPixelRound(shape, extent, cellsize);
-    } else if(renderer->transform_mode == MS_TRANSFORM_FULLRESOLUTION) {
-      msTransformShapeToPixelDoublePrecision(shape,extent,cellsize);
-    } else if(renderer->transform_mode == MS_TRANSFORM_NONE) {
-      /* nothing to do */
-      return;
-    }
-    /* unknown, do nothing */
-    return;
-  }
-  msTransformShapeToPixelRound(shape, extent, cellsize);
-}
-
-void msTransformShapeToPixelSnapToGrid(shapeObj *shape, rectObj extent, double cellsize, double grid_resolution)
-{
-  int i,j,k; /* loop counters */
-  double inv_cs;
-  if(shape->numlines == 0) return;
-  inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
-
-
-  if(shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) { /* remove duplicate vertices */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      int snap = 1;
-      const double x0 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[0].x, extent.minx, inv_cs, grid_resolution);
-      const double y0 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[0].y, extent.maxy, inv_cs, grid_resolution);
-
-      /*do a quick heuristic: will we risk having a degenerate shape*/
-      if(shape->type == MS_SHAPE_LINE) {
-        /*a line is degenerate if it has a single pixel. we check that the first and last pixel are different*/
-        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[shape->line[i].numpoints-1].x, extent.minx, inv_cs, grid_resolution);
-        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[shape->line[i].numpoints-1].y, extent.maxy, inv_cs, grid_resolution);
-        if(x0 == x1 && y0 == y1) {
-          snap = 0;
-        }
-      } else /* if(shape->type == MS_SHAPE_POLYGON) */ {
-        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3].x, extent.minx, inv_cs, grid_resolution);
-        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3].y, extent.maxy, inv_cs, grid_resolution);
-        const double x2 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3*2].x, extent.minx, inv_cs, grid_resolution);
-        const double y2 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3*2].y, extent.maxy, inv_cs, grid_resolution);
-        if((x0 == x1 && y0 == y1) ||
-            (x0 == x2 && y0 == y2) ||
-            (x1 == x2 && y1 == y2)) {
-          snap = 0;
-        }
-      }
-
-      if(snap) {
-        shape->line[i].point[0].x = x0;
-        shape->line[i].point[0].y = y0;
-        for(j=1, k=1; j < shape->line[i].numpoints; j++ ) {
-          shape->line[i].point[k].x = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[j].x, extent.minx, inv_cs, grid_resolution);
-          shape->line[i].point[k].y = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[j].y, extent.maxy, inv_cs, grid_resolution);
-          if(shape->line[i].point[k].x!=shape->line[i].point[k-1].x || shape->line[i].point[k].y!=shape->line[i].point[k-1].y)
-            k++;
-        }
-        shape->line[i].numpoints=k;
-      } else {
-        if(shape->type == MS_SHAPE_LINE) {
-          shape->line[i].point[0].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[0].x, extent.minx, inv_cs);
-          shape->line[i].point[0].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[0].y, extent.maxy, inv_cs);
-          shape->line[i].point[1].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[shape->line[i].numpoints-1].x, extent.minx, inv_cs);
-          shape->line[i].point[1].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[shape->line[i].numpoints-1].y, extent.maxy, inv_cs);
-          shape->line[i].numpoints = 2;
-        } else {
-          for(j=0; j < shape->line[i].numpoints; j++ ) {
-            shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
-            shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
-          }
-        }
-      }
-    }
-  } else { /* points or untyped shapes */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=1; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
-        shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
-      }
-    }
-  }
-
-}
-
-void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j,k; /* loop counters */
-  double inv_cs;
-  if(shape->numlines == 0) return;
-  inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
-  if(shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) { /* remove duplicate vertices */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      shape->line[i].point[0].x = MS_MAP2IMAGE_X_IC(shape->line[i].point[0].x, extent.minx, inv_cs);;
-      shape->line[i].point[0].y = MS_MAP2IMAGE_Y_IC(shape->line[i].point[0].y, extent.maxy, inv_cs);
-      for(j=1, k=1; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[k].x = MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
-        shape->line[i].point[k].y = MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
-        if(shape->line[i].point[k].x!=shape->line[i].point[k-1].x || shape->line[i].point[k].y!=shape->line[i].point[k-1].y)
-          k++;
-      }
-      shape->line[i].numpoints=k;
-    }
-  } else { /* points or untyped shapes */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=0; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
-        shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
-      }
-    }
-  }
-
-}
-
-void msTransformShapeToPixelDoublePrecision(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j; /* loop counters */
-  double inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
-  for(i=0; i<shape->numlines; i++) {
-    for(j=0; j<shape->line[i].numpoints; j++) {
-      shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
-      shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
-    }
-  }
-}
-
-
-
-/*
-** Converts from map coordinates to image coordinates
-*/
-void msTransformPixelToShape(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j; /* loop counters */
-
-  if(shape->numlines == 0) return; /* nothing to transform */
-
-  if(shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) { /* remove co-linear vertices */
-
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=0; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
-        shape->line[i].point[j].y = MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
-      }
-    }
-  } else { /* points or untyped shapes */
-
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=1; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
-        shape->line[i].point[j].y = MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
-      }
-    }
-  }
-
-  return;
-}
-
-/*
-** Not a generic intersection test, we KNOW the lines aren't parallel or coincident. To be used with the next
-** buffering code only. See code in mapsearch.c for a boolean test for intersection.
-*/
-static pointObj generateLineIntersection(pointObj a, pointObj b, pointObj c, pointObj d)
-{
-  pointObj p = {0}; // initialize
-  double r;
-  double denominator, numerator;
-
-  if(b.x == c.x && b.y == c.y) return(b);
-
-  numerator = ((a.y-c.y)*(d.x-c.x) - (a.x-c.x)*(d.y-c.y));
-  denominator = ((b.x-a.x)*(d.y-c.y) - (b.y-a.y)*(d.x-c.x));
-
-  r = numerator/denominator;
-
-  p.x = MS_NINT(a.x + r*(b.x-a.x));
-  p.y = MS_NINT(a.y + r*(b.y-a.y));
-
-  return(p);
-}
-
-void bufferPolyline(shapeObj *p, shapeObj *op, int w)
-{
-  int i, j;
-  pointObj a = {0};
-  lineObj inside, outside;
-  double angle;
-  double dx, dy;
-
-  for (i = 0; i < p->numlines; i++) {
-
-    inside.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*p->line[i].numpoints);
-    outside.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*p->line[i].numpoints);
-    inside.numpoints = outside.numpoints = p->line[i].numpoints;
-
-    angle = asin(MS_ABS(p->line[i].point[1].x - p->line[i].point[0].x)/sqrt((((p->line[i].point[1].x - p->line[i].point[0].x)*(p->line[i].point[1].x - p->line[i].point[0].x)) + ((p->line[i].point[1].y - p->line[i].point[0].y)*(p->line[i].point[1].y - p->line[i].point[0].y)))));
-    if(p->line[i].point[0].x < p->line[i].point[1].x)
-      dy = sin(angle) * (w/2);
-    else
-      dy = -sin(angle) * (w/2);
-    if(p->line[i].point[0].y < p->line[i].point[1].y)
-      dx = -cos(angle) * (w/2);
-    else
-      dx = cos(angle) * (w/2);
-
-    inside.point[0].x = p->line[i].point[0].x + dx;
-    inside.point[1].x = p->line[i].point[1].x + dx;
-    inside.point[0].y = p->line[i].point[0].y + dy;
-    inside.point[1].y = p->line[i].point[1].y + dy;
-
-    outside.point[0].x = p->line[i].point[0].x - dx;
-    outside.point[1].x = p->line[i].point[1].x - dx;
-    outside.point[0].y = p->line[i].point[0].y - dy;
-    outside.point[1].y = p->line[i].point[1].y - dy;
-
-    for(j=2; j<p->line[i].numpoints; j++) {
-
-      angle = asin(MS_ABS(p->line[i].point[j].x - p->line[i].point[j-1].x)/sqrt((((p->line[i].point[j].x - p->line[i].point[j-1].x)*(p->line[i].point[j].x - p->line[i].point[j-1].x)) + ((p->line[i].point[j].y - p->line[i].point[j-1].y)*(p->line[i].point[j].y - p->line[i].point[j-1].y)))));
-      if(p->line[i].point[j-1].x < p->line[i].point[j].x)
-        dy = sin(angle) * (w/2);
-      else
-        dy = -sin(angle) * (w/2);
-      if(p->line[i].point[j-1].y < p->line[i].point[j].y)
-        dx = -cos(angle) * (w/2);
-      else
-        dx = cos(angle) * (w/2);
-
-      a.x = p->line[i].point[j-1].x + dx;
-      inside.point[j].x = p->line[i].point[j].x + dx;
-      a.y = p->line[i].point[j-1].y + dy;
-      inside.point[j].y = p->line[i].point[j].y + dy;
-      inside.point[j-1] = generateLineIntersection(inside.point[j-2], inside.point[j-1], a, inside.point[j]);
-
-      a.x = p->line[i].point[j-1].x - dx;
-      outside.point[j].x = p->line[i].point[j].x - dx;
-      a.y = p->line[i].point[j-1].y - dy;
-      outside.point[j].y = p->line[i].point[j].y - dy;
-      outside.point[j-1] = generateLineIntersection(outside.point[j-2], outside.point[j-1], a, outside.point[j]);
-    }
-
-    /* need a touch of code if 1st point equals last point in p (find intersection) */
-
-    msAddLine(op, &inside);
-    msAddLine(op, &outside);
-
-    free(inside.point);
-    free(outside.point);
-  }
-
-  return;
-}
-
-static double getRingArea(lineObj *ring)
-{
-  int i;
-  double s=0;
-
-  for(i=0; i<ring->numpoints-1; i++)
-    s += (ring->point[i].x*ring->point[i+1].y - ring->point[i+1].x*ring->point[i].y);
-
-  return (MS_ABS(s/2));
-}
-
-double msGetPolygonArea(shapeObj *p)
-{
-  int i;
-  double area=0;
-
-  if(!p) return 0;
-
-  for(i=0; i<p->numlines; i++) {
-    if(msIsOuterRing(p, i))
-      area += getRingArea(&(p->line[i]));
-    else
-      area -= getRingArea(&(p->line[i])); /* hole */
-  }
-
-  return area;
-}
-
-/*
-** Computes the center of gravity for a polygon based on it's largest outer ring only.
-*/
-static int getPolygonCenterOfGravity(shapeObj *p, pointObj *lp)
-{
-  double sx=0, sy=0; /* sums */
-  double largestArea=0;
-
-  for(int i=0; i<p->numlines; i++) {
-    double tsx = 0;
-    double tsy = 0;
-    double s = 0; /* reset the ring sums */
-    for(int j=0; j<p->line[i].numpoints-1; j++) {
-      double a = p->line[i].point[j].x*p->line[i].point[j+1].y - p->line[i].point[j+1].x*p->line[i].point[j].y;
-      s += a;
-      tsx += (p->line[i].point[j].x + p->line[i].point[j+1].x)*a;
-      tsy += (p->line[i].point[j].y + p->line[i].point[j+1].y)*a;
-    }
-    double area = MS_ABS(s/2);
-
-    if(area > largestArea) {
-      largestArea = area;
-      sx = s>0?tsx:-tsx;
-      sy = s>0?tsy:-tsy;
-    }
-  }
-  if(largestArea == 0) /*degenerate polygon*/
-    return MS_FAILURE;
-
-  lp->x = sx/(6*largestArea);
-  lp->y = sy/(6*largestArea);
-
-  return MS_SUCCESS;
-}
-
-int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny, double *maxy)
-{
-  int i,j;
-  double cent_weight_x=0.0, cent_weight_y=0.0;
-  double len, total_len=0;
-
-  *miny = *maxy = p->line[0].point[0].y;
-  for(i=0; i<p->numlines; i++) {
-    for(j=1; j<p->line[i].numpoints; j++) {
-      *miny = MS_MIN(*miny, p->line[i].point[j].y);
-      *maxy = MS_MAX(*maxy, p->line[i].point[j].y);
-      len = msDistancePointToPoint(&(p->line[i].point[j-1]), &(p->line[i].point[j]));
-      cent_weight_x += len * ((p->line[i].point[j-1].x + p->line[i].point[j].x)/2);
-      cent_weight_y += len * ((p->line[i].point[j-1].y + p->line[i].point[j].y)/2);
-      total_len += len;
-    }
-  }
-
-  if(total_len == 0)
-    return(MS_FAILURE);
-
-  lp->x = cent_weight_x / total_len;
-  lp->y = cent_weight_y / total_len;
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Find a label point in a polygon.
-*/
-int msPolygonLabelPoint(shapeObj *p, pointObj *lp, double min_dimension)
-{
-  double slope;
-  pointObj *point1=NULL, *point2=NULL, cp;
-  int i, j, nfound;
-  double x, y, *intersect, temp;
-  double min, max;
-  int wrong_order, n;
-  double len, max_len=0;
-  double minx, maxx, maxy, miny;
-
-#ifdef notdef
-  int method = 2;
-#endif
-
-  msComputeBounds(p);
-  minx = p->bounds.minx;
-  miny = p->bounds.miny;
-  maxx = p->bounds.maxx;
-  maxy = p->bounds.maxy;
-
-  if(min_dimension > 0)
-    if(MS_MIN(maxx-minx,maxy-miny) < min_dimension) return(MS_FAILURE);
-
-  cp.x = (maxx+minx)/2.0;
-  cp.y = (maxy+miny)/2.0;
-
-#ifdef notdef
-  switch (method) {
-    case 0: /* MBR */
-      lp->x = cp.x;
-      lp->y = cp.y;
-      break;
-    case 1: /* centroid */
-      if(msGetPolygonCentroid(p, lp, &miny, &maxy) != MS_SUCCESS) return(MS_FAILURE);
-      break;
-    case 2: /* center of gravity */
-      if(getPolygonCenterOfGravity(p, lp) != MS_SUCCESS) return(MS_FAILURE);
-      break;
-  }
-#else
-  if(getPolygonCenterOfGravity(p, lp) != MS_SUCCESS) return(MS_FAILURE);
-#endif
-
-  if(msIntersectPointPolygon(lp, p) == MS_TRUE) {
-    double dist, min_dist=-1;
-
-    /* compute a distance to the polygon */
-    for(j=0; j<p->numlines; j++) {
-      for(i=1; i<p->line[j].numpoints; i++) {
-        dist = msSquareDistancePointToSegment(lp, &(p->line[j].point[i-1]), &(p->line[j].point[i]));
-        if((dist < min_dist) || (min_dist < 0)) min_dist = dist;
-      }
-    }
-    min_dist = sqrt(min_dist);
-
-    if(min_dist > .1*MS_MAX(maxx-minx, maxy-miny))
-      return(MS_SUCCESS); /* point is not too close to the edge */
-  }
-
-  /* printf("label: %s\n", p->text);
-     printf("    bbox: %g %g %g %g\n",minx, miny, maxx, maxy);
-     printf("    center: %g %g\n", cp.x, cp.y);
-     printf("    center of gravity: %g %g\n", lp->x, lp->y);
-     printf("    dx: %g, dy: %g\n", lp->x-cp.x, lp->y-cp.y);
-     printf("    distance to parent shape: %g\n", min_dist);
-     return MS_SUCCESS; */
-
-  n=0;
-  for(j=0; j<p->numlines; j++) /* count total number of points */
-    n += p->line[j].numpoints;
-  intersect = (double *) calloc(n, sizeof(double));
-  MS_CHECK_ALLOC(intersect, n*sizeof(double), MS_FAILURE);
-
-
-  if(MS_ABS((int)lp->x - (int)cp.x) > MS_ABS((int)lp->y - (int)cp.y)) { /* center horizontally, fix y */
-
-    y = lp->y;
-
-    /* need to find a y that won't intersect any vertices exactly */
-    max = y - 1; /* first initializing min, max to be any 2 pnts on either side of y */
-    min = y + 1;
-    for(j=0; j<p->numlines; j++) {
-      if((min < y) && (max >= y))  break;
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((min < y) && (max >= y))  break;
-        if(p->line[j].point[i].y < y)
-          min = p->line[j].point[i].y;
-        if(p->line[j].point[i].y >= y)
-          max = p->line[j].point[i].y;
-      }
-    }
-
-    n=0;
-    for(j=0; j<p->numlines; j++) {
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((p->line[j].point[i].y < y) && ((y - p->line[j].point[i].y) < (y - min)))
-          min = p->line[j].point[i].y;
-        if((p->line[j].point[i].y >= y) && ((p->line[j].point[i].y - y) < (max - y)))
-          max = p->line[j].point[i].y;
-      }
-    }
-
-    if(min == max) { 
-      msFree(intersect);
-      return (MS_FAILURE);
-    }
-    else
-      y = (max + min)/2.0;
-
-    nfound = 0;
-    for(j=0; j<p->numlines; j++) { /* for each line */
-
-      point1 = &( p->line[j].point[p->line[j].numpoints-1] );
-      for(i=0; i < p->line[j].numpoints; i++) {
-        point2 = &( p->line[j].point[i] );
-
-        if(EDGE_CHECK(point1->y, y, point2->y) == CLIP_MIDDLE) {
-
-          if(point1->y == point2->y)
-            continue; /* ignore horizontal edges */
-          else
-            slope = (point2->x - point1->x) / (point2->y - point1->y);
-
-          x = point1->x + (y - point1->y)*slope;
-          intersect[nfound++] = x;
-        } /* end checking this edge */
-
-        point1 = point2; /* next edge */
-      }
-    } /* finished line */
-
-    /* sort the intersections */
-    do {
-      wrong_order = 0;
-      for(i=0; i < nfound-1; i++) {
-        if(intersect[i] > intersect[i+1]) {
-          wrong_order = 1;
-          SWAP(intersect[i], intersect[i+1], temp);
-        }
-      }
-    } while(wrong_order);
-
-    /* find longest span */
-    for(i=0; i < nfound; i += 2) {
-      len = fabs(intersect[i] - intersect[i+1]);
-      if(len > max_len) {
-        max_len = len;
-        lp->x = (intersect[i] + intersect[i+1])/2;
-        lp->y = y;
-      }
-    }
-  } else { /* center vertically, fix x */
-    x = lp->x;
-
-    /* need to find a x that won't intersect any vertices exactly */
-    max = x - 1; /* first initializing min, max to be any 2 pnts on either side of x */
-    min = x + 1;
-    for(j=0; j<p->numlines; j++) {
-      if((min < x) && (max >= x))  break;
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((min < x) && (max >= x))  break;
-        if(p->line[j].point[i].x < x)
-          min = p->line[j].point[i].x;
-        if(p->line[j].point[i].x >= x)
-          max = p->line[j].point[i].x;
-      }
-    }
-
-    n=0;
-    for(j=0; j<p->numlines; j++) {
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((p->line[j].point[i].x < x) && ((x - p->line[j].point[i].x) < (x - min)))
-          min = p->line[j].point[i].x;
-        if((p->line[j].point[i].x >= x) && ((p->line[j].point[i].x - x) < (max - x)))
-          max = p->line[j].point[i].x;
-      }
-    }
-
-    if(min == max) {
-      msFree(intersect);
-      return (MS_FAILURE);
-    }
-    else
-      x = (max + min)/2.0;
-
-    nfound = 0;
-    for(j=0; j<p->numlines; j++) { /* for each line */
-
-      point1 = &( p->line[j].point[p->line[j].numpoints-1] );
-      for(i=0; i < p->line[j].numpoints; i++) {
-        point2 = &( p->line[j].point[i] );
-
-        if(EDGE_CHECK(point1->x, x, point2->x) == CLIP_MIDDLE) {
-
-          if(point1->x == point2->x)
-            continue; /* ignore vertical edges */
-          else if(point1->y == point2->y)
-            y = point1->y; /* for a horizontal edge we know y */
-          else {
-            slope = (point2->x - point1->x) / (point2->y - point1->y);
-            y = (x - point1->x)/slope + point1->y;
-          }
-
-          intersect[nfound++] = y;
-        } /* end checking this edge */
-
-        point1 = point2; /* next edge */
-      }
-    } /* finished line */
-
-    /* sort the intersections */
-    do {
-      wrong_order = 0;
-      for(i=0; i < nfound-1; i++) {
-        if(intersect[i] > intersect[i+1]) {
-          wrong_order = 1;
-          SWAP(intersect[i], intersect[i+1], temp);
-        }
-      }
-    } while(wrong_order);
-
-    /* find longest span */
-    for(i=0; i < nfound; i += 2) {
-      len = fabs(intersect[i] - intersect[i+1]);
-      if(len > max_len) {
-        max_len = len;
-        lp->y = (intersect[i] + intersect[i+1])/2;
-        lp->x = x;
-      }
-    }
-  }
-
-  free(intersect);
-
-  if(max_len > 0)
-    return(MS_SUCCESS);
-  else
-    return(MS_FAILURE);
-}
-
-/* Compute all the lineString/segment lengths and determine the longest lineString of a multiLineString
- * shape: in paramater, the multiLineString to compute.
- * struct polyline_lengths pll: out parameter, all line and segment lengths
-*/
-void msPolylineComputeLineSegments(shapeObj *shape, struct polyline_lengths *pll)
-{
-  int i, j;
-  double max_line_length=-1, max_segment_length=-1, segment_length;
-
-  pll->ll = msSmallMalloc(shape->numlines * sizeof(struct line_lengths));
-  pll->total_length = 0;
-  pll->longest_line_index = 0;
-
-
-  for(i=0; i<shape->numlines; i++) {
-    struct line_lengths *ll = &pll->ll[i];
-    double max_subline_segment_length = -1;
-    
-    if(shape->line[i].numpoints > 1) {
-      ll->segment_lengths = (double*) msSmallMalloc(sizeof(double) * (shape->line[i].numpoints - 1));
-    } else {
-      ll->segment_lengths = NULL;
-    }
-    ll->total_length = 0;
-    
-    for(j=1; j<shape->line[i].numpoints; j++) {
-      segment_length = sqrt((((shape->line[i].point[j].x-shape->line[i].point[j-1].x)*(shape->line[i].point[j].x-shape->line[i].point[j-1].x)) + ((shape->line[i].point[j].y-shape->line[i].point[j-1].y)*(shape->line[i].point[j].y-shape->line[i].point[j-1].y))));
-      ll->total_length += segment_length;
-      ll->segment_lengths[j-1] = segment_length;
-      if(segment_length > max_subline_segment_length) {
-        max_subline_segment_length = segment_length;
-        ll->longest_segment_index = j;
-      }
-      if(segment_length > max_segment_length) {
-        max_segment_length = segment_length;
-        pll->longest_segment_line_index = i;
-        pll->longest_segment_point_index = j;
-      }
-    }
-    pll->total_length += ll->total_length;
-
-    if(ll->total_length > max_line_length) {
-      max_line_length = ll->total_length;
-      pll->longest_line_index = i;
-    }
-  }
-}
-
-/*
-** If no repeatdistance, find center of longest segment in polyline p. The polyline must have been converted
-** to image coordinates before calling this function.
-*/
-int msPolylineLabelPoint(mapObj *map, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_auto_result *lar, double resolutionfactor)
-{
-  struct polyline_lengths pll;
-  int i, ret = MS_SUCCESS;
-  double minfeaturesize = -1;
-  assert(ts == NULL || ts->annotext);
-
-
-  if(label && ts) {
-    if(label->autominfeaturesize) {
-      if(!ts->textpath) {
-        if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts)))
-          return MS_FAILURE;
-      }
-      if(!ts->textpath)
-        return MS_FAILURE;
-      minfeaturesize = ts->textpath->bounds.bbox.maxx;
-    } else if(label->minfeaturesize) {
-      minfeaturesize = label->minfeaturesize * resolutionfactor;
-    }
-  }
-
-  /* compute line lengths, in order to:
-    - extract the longest line if we're not repeating
-    - check that each line is longer than the text length if using minfeaturesize auto
-    - check that each line is long enough if using minfeaturesize
-   */
-  msPolylineComputeLineSegments(p, &pll);
-
-  if(label && label->repeatdistance > 0) {
-    for(i=0; i<p->numlines; i++) {
-      if(pll.ll[i].total_length > minfeaturesize) {
-        ret = msLineLabelPoint(map,&p->line[i], ts, &pll.ll[i],lar, label, resolutionfactor);
-      }
-    }
-  } else {
-    i = pll.longest_line_index;
-    if(pll.ll[i].total_length > minfeaturesize) {
-      ret = msLineLabelPoint(map,&p->line[i], ts, &pll.ll[i],lar, label, resolutionfactor);
-    }
-  }
-
-  /* freeing memory: allocated by msPolylineComputeLineSegments */
-  for ( i = 0; i < p->numlines; i++ ) {
-    free(pll.ll[i].segment_lengths);
-  }
-  free(pll.ll);
-  
-  return ret;
-}
-
-int msLineLabelPoint(mapObj *map, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_auto_result *lar, labelObj *label, double resolutionfactor)
-{
-  (void)map;
-  int j, l, n, point_repeat;
-  double t, theta, fwd_length, point_distance;
-  double center_point_position, left_point_position, right_point_position, point_position;
-  double repeat_distance = -1;
-  if(label) {
-    repeat_distance = label->repeatdistance * resolutionfactor;
-  }
-
-  if(MS_UNLIKELY(p->numpoints < 2))
-    return MS_FAILURE;
-  point_distance = 0;
-  point_repeat = 1;
-  left_point_position = right_point_position = center_point_position = ll->total_length / 2.0;
-
-  if (repeat_distance > 0) {
-    point_repeat = ll->total_length / repeat_distance;
-
-    if (point_repeat > 1) {
-      if (point_repeat % 2 == 0)
-        point_repeat -= 1;
-      point_distance = (ll->total_length / point_repeat); /* buffer allowed per point */
-
-      /* initial point position */
-      left_point_position -= ((point_repeat-1)/2 * point_distance);
-      right_point_position += ((point_repeat-1)/2 * point_distance);
-
-      point_repeat = (point_repeat-1)/2+1;
-    } else
-      point_repeat = 1;
-  }
-
-  for (l=0; l < point_repeat; ++l) {
-    if (l == point_repeat-1) { /* last point to place is always the center point */
-      point_position = center_point_position;
-      n = 1;
-    } else {
-      point_position = right_point_position;
-      n = 0;
-    }
-
-    do {
-      lar->angles = msSmallRealloc(lar->angles, (lar->num_label_points+1)*sizeof(double));
-      lar->label_points = msSmallRealloc(lar->label_points, (lar->num_label_points+1)*sizeof(pointObj));
-
-      /* if there is only 1 label to place... put it in the middle of the current segment (as old behavior) */
-      if ( point_repeat == 1 ) {
-        j = ll->longest_segment_index;
-        lar->label_points[lar->num_label_points].x = (p->point[j-1].x + p->point[j].x)/2.0;
-        lar->label_points[lar->num_label_points].y = (p->point[j-1].y + p->point[j].y)/2.0;
-      } else {
-        j=0;
-        fwd_length = 0;
-        while (fwd_length < point_position) {
-          fwd_length += ll->segment_lengths[j++];
-        }
-        assert(j>0);
-
-        t = 1 - (fwd_length - point_position) / ll->segment_lengths[j-1];
-        lar->label_points[lar->num_label_points].x = t * (p->point[j].x - p->point[j-1].x) + p->point[j-1].x;
-        lar->label_points[lar->num_label_points].y = t * (p->point[j].y - p->point[j-1].y) + p->point[j-1].y;
-      }
-
-      if(label && ts) {
-        if(label->anglemode != MS_NONE) {
-          theta = atan2(p->point[j].x - p->point[j-1].x, p->point[j].y - p->point[j-1].y);
-          if(label->anglemode == MS_AUTO2) {
-            theta -= MS_PI2;
-          } else { /* AUTO, FOLLOW */
-            if(p->point[j-1].x < p->point[j].x) { /* i.e. to the left */
-              theta -= MS_PI2;
-            } else {
-              theta += MS_PI2;
-            }
-          }
-          lar->angles[lar->num_label_points] = theta;
-        } else {
-          lar->angles[lar->num_label_points] = MS_DEG_TO_RAD * ts->label->angle;
-        }
-      } else {
-        lar->angles[lar->num_label_points] = 0;
-      }
-      lar->num_label_points++;
-
-      point_position = left_point_position;
-      n++;
-    } while (n<2); /* we place the right point then the left point. */
-
-    right_point_position -= point_distance;
-    left_point_position += point_distance;
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/* Calculate the labelpath for each line if repeatdistance is enabled, else the labelpath of the longest line segment */
-int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_follow_result *lfr)
-{
-  struct polyline_lengths pll;
-  int i,ret = MS_SUCCESS;
-  double minfeaturesize = -1;
-  assert(ts->annotext);
-  lfr->num_follow_labels = lfr->lar.num_label_points = 0;
-
-  /* we first offset the line if we want an offsetted label */
-  if(label->offsetx != 0 && IS_PERPENDICULAR_OFFSET(label->offsety)) {
-    double offset;
-    if(label->offsetx > 0) {
-      offset = label->offsetx + label->size/2;
-    } else {
-      offset = label->offsetx - label->size/2;
-    }
-    if(label->offsety == MS_LABEL_PERPENDICULAR_TOP_OFFSET && p->numlines>0 && p->line[0].numpoints > 0) {
-      /* is the line mostly left-to-right or right-to-left ?
-       * FIXME this should be done line by line, by stepping through shape->lines, however
-       * the OffsetPolyline function works on shapeObjs, not lineObjs
-       * we only check the first line
-       */
-      if(p->line[0].point[0].x < p->line[0].point[p->line[0].numpoints-1].x) {
-        /* line is left to right */
-          offset = -offset;
-      }
-    }
-    p = msOffsetPolyline(p,offset, MS_STYLE_SINGLE_SIDED_OFFSET);
-    if(!p) return MS_FAILURE;
-  }
-
-  /* compute line lengths, in order to:
-    - extract the longest line if we're not repeating
-    - check that each line is longer than the text length if using minfeaturesize auto
-    - check that each line is long enough if using minfeaturesize
-   */
-  msPolylineComputeLineSegments(p, &pll);
- 
-  if(label->autominfeaturesize) {
-    if(!ts->textpath) {
-      if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
-        return MS_FAILURE;
-      }
-    }
-    if(!ts->textpath)
-      return MS_FAILURE;
-    minfeaturesize = ts->textpath->bounds.bbox.maxx;
-  } else if(label->minfeaturesize) {
-    minfeaturesize = label->minfeaturesize * image->resolutionfactor;
-  }
-
-  if(label->repeatdistance > 0) {
-    for(i=0; i<p->numlines; i++) {
-      if(pll.ll[i].total_length > minfeaturesize) {
-        ret = msLineLabelPath(map,image,&p->line[i], ts, &pll.ll[i],lfr, label);
-      }
-    }
-  } else {
-    i = pll.longest_line_index;
-    if(pll.ll[i].total_length > minfeaturesize) {
-      ret = msLineLabelPath(map,image,&p->line[i], ts, &pll.ll[i],lfr, label);
-    }
-  }
-
-  /* freeing memory: allocated by msPolylineComputeLineSegments */
-  for ( i = 0; i < p->numlines; i++ ) {
-    free(pll.ll[i].segment_lengths);
-  }
-  free(pll.ll);
-  
-  if(IS_PERPENDICULAR_OFFSET(label->offsety) && label->offsetx != 0) {
-     msFreeShape(p);
-     msFree(p);
-  }
-  return ret;
-}
-
-static double compute_retry_offset(textSymbolObj *ts, int fail_idx, double retried_offset, double max_dec_offset, double max_inc_offset) {
-/* fail_idx: the glyph index in the textpath that originally failed (i.e. before any displacement was tested */
-/* retried_offset: the last offset that was tried and is failing, so we can return the next one (or 0 if none left)*/
-  int inc = 1,dec_found=0, inc_found=0;
-  double inc_offset = 0, dec_offset = 0;
-
-  retried_offset = fabs(retried_offset);
-  do {
-    if(fail_idx - inc - 1 >= 0) {
-      dec_offset += ts->textpath->glyphs[fail_idx - inc].glyph->metrics.advance;
-      if(dec_offset > max_dec_offset)
-        break;
-      if(dec_offset > retried_offset && msIsGlyphASpace(&ts->textpath->glyphs[fail_idx - inc - 1])) {
-        dec_found = 1;
-        dec_offset += ts->textpath->glyphs[fail_idx - inc -1].glyph->metrics.advance / 2.0;
-        break;
-      }
-    }
-    inc++;
-  } while(dec_offset<max_dec_offset && fail_idx-inc>0);
-  
-  if(!dec_found) {
-    /* try the starting position */
-    dec_offset += ts->textpath->glyphs[0].glyph->metrics.advance;
-    if(dec_offset > retried_offset && dec_offset<max_dec_offset) {
-      dec_found = 1;
-    }
-  }
-  
-  inc = 1;
-  inc_offset = ts->textpath->glyphs[fail_idx].glyph->metrics.advance;
-  do{
-    if(fail_idx + inc < ts->textpath->numglyphs - 1) {
-      if(inc_offset > retried_offset && msIsGlyphASpace(&ts->textpath->glyphs[fail_idx + inc])) {
-        inc_offset += ts->textpath->glyphs[fail_idx + inc].glyph->metrics.advance / 2;
-        if(inc_offset < max_inc_offset)
-          inc_found = 1;
-        break;
-      }
-      inc_offset += ts->textpath->glyphs[fail_idx + inc].glyph->metrics.advance;
-    }
-    inc++;
-  } while(inc_offset<max_inc_offset && fail_idx+inc<ts->textpath->numglyphs-1);
-  if(!inc_found) {
-    inc_offset += ts->textpath->glyphs[ts->textpath->numglyphs-1].glyph->metrics.advance;
-    if(inc_offset > retried_offset && inc_offset<max_inc_offset) {
-      inc_found = 1;
-    }
-  }
-  
-  if(!inc_found && !dec_found)
-    return 0.0;
-  if(inc_found && dec_found) {
-    if(inc_offset<dec_offset)
-      return -inc_offset;
-    else
-      return dec_offset;
-  }
-  if(inc_found)
-    return -inc_offset;
-  else
-    return dec_offset;
-            
-}
-/*
- * Calculate a series of label points for each character in the label for a
- * given line. The resultant series of points is stored in *labelpath,
- * which is added to the labelpaths array. Note that the points and bounds
- * are allocated in this function.  The polyline must be converted to image
- * coordinates before calling this function.
- */
-int msLineLabelPath(mapObj *map, imageObj *img, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_follow_result *lfr, labelObj *label)
-{
-  double distance_along_segment;
-  double repeat_distance = label->repeatdistance * ts->resolutionfactor;
-  double segment_length, fwd_line_length, rev_line_length, text_length, text_start_length, label_buffer, text_end_length, cur_label_position, first_label_position;
-  double max_retry_offset;
-
-  int j,k,l,inc, final_j, label_repeat;
-  double direction;
-  rectObj bbox;
-  lineObj *bounds;
-  double t;
-  double cx, cy; /* centre of a character, x & y values. */
-
-  double theta;
-  double dx, dy, w, cos_t, sin_t;
-
-  const double letterspacing = 1.00;
-  /* As per RFC 60, if label->maxoverlapangle == 0 then fall back on pre-6.0 behavior
-     which was to use maxoverlapangle = 0.4*MS_PI ( 40% of 180 degrees ) */
-  double maxoverlapangle = 0.4 * MS_PI;
-
-  if(p->numpoints < 2) { /* degenerate */
-    return MS_FAILURE;
-  }
-  if(p->numpoints == 2) /* use the regular angled text algorithm */
-    return msLineLabelPoint(map,p,ts,ll,&lfr->lar,label, img->resolutionfactor);
-  
-  if(!ts->textpath) {
-    if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
-      return MS_FAILURE;
-    }
-  }
-  if(!ts->textpath) {
-    return MS_FAILURE;
-  }
-  
-  /* skip the label and use the normal algorithm if it has fewer than 2 characters */
-  if(ts->textpath->numglyphs < 2)
-    return msLineLabelPoint(map,p,ts,ll,&lfr->lar,label, img->resolutionfactor);
-
-
-  text_length = letterspacing * ts->textpath->bounds.bbox.maxx;
-
-  /*
-  ** if the text length is way longer than the line, skip adding the
-  ** label if it isn't forced (long extrapolated labels tend to be ugly)
-  */
-  if ( text_length > 1.5 * ll->total_length ) {
-    if(ts->label->force == MS_FALSE ) {
-      return MS_SUCCESS;
-    } else {
-      repeat_distance = 0; /* disable repetition */
-    }
-  }
-
-  /* We compute the number of labels we can repeat in the line:
-     - space occupied by one label
-     - plus N times space occupied by one label + repeat_distance interspacing
-   */
-  label_buffer = text_length + repeat_distance; /* distance occupied by one label + inter-repeat spacing */
-  if( repeat_distance > 0 && ll->total_length > text_length) {
-    label_repeat = 1 + (int)((ll->total_length - text_length) / label_buffer);
-    max_retry_offset = repeat_distance / 2.1;
-  } else {
-    label_repeat = 1;
-    max_retry_offset = (ll->total_length - text_length) / 2.1;
-  }
-  /* compute the starting point of where we'll be placing the first label */
-  if(label_repeat % 2) {
-    /* odd number of labels: account for the center label that will be centered on the line
-     * ----llll_____llll_____llll----
-     */
-    first_label_position = (ll->total_length - text_length) / 2.0 - (label_repeat / 2) * label_buffer;
-  } else {
-    /* even number of labels:
-     * repeat_distance is centered on the line
-     * space for one label
-     * eventually space for label_repeat*2-1 labels+spacing
-     * ----llll_____llll----
-     * --llll_____llll_____llll_____llll--
-     */
-    first_label_position = (ll->total_length - repeat_distance) / 2.0 - text_length - (label_repeat/2 - 1) * label_buffer;
-  }
-  if(label->maxoverlapangle > 0)
-    maxoverlapangle = label->maxoverlapangle * MS_DEG_TO_RAD; /* radian */
-  
-  cur_label_position = first_label_position;
-  for (l=0; l < label_repeat; l++) {
-    
-    double retry_offset = 0.0;
-    int first_retry_idx = 0;
-    //max_dec_retry_offset = max_inc_retry_offset = max_retry_offset;
-    textPathObj *tp = msSmallCalloc(1,sizeof(textPathObj));
-    /* copy the textPath, we will be overriding the copy's positions and angles */
-    msCopyTextPath(tp,ts->textpath);
-    tp->bounds.poly = msSmallMalloc(sizeof(lineObj));
-    bounds = tp->bounds.poly;
-
-
-    /*
-    ** The bounds will have two points for each character plus an endpoint:
-    ** the UL corners of each bbox will be tied together and the LL corners
-    ** will be tied together.
-    */
-    bounds->numpoints = 2*tp->numglyphs + 1;
-    bounds->point = (pointObj *) msSmallMalloc(sizeof(pointObj) * bounds->numpoints);
-
-    do {
-      int overlap_collision_detected = 0;
-      text_start_length = cur_label_position + retry_offset;
-      text_end_length = 0;
-      
-      for(k=0;k<tp->numglyphs;k++) {
-        tp->glyphs[k].pnt.x = 0;
-        tp->glyphs[k].pnt.y = 0;
-      }
-      
-      /* the points start at (line_length - text_length) / 2 in order to be centred */
-      /* text_start_length = (line_length - text_length) / 2.0; */
-      
-      j = 0;
-      fwd_line_length = 0;
-      if(text_start_length >= 0.0) {
-        while ( fwd_line_length < text_start_length )
-          fwd_line_length += ll->segment_lengths[j++];
-        
-        j--;
-      }
-      final_j = p->numpoints - 1;
-      rev_line_length = 0;
-      if(text_start_length+text_length <= ll->total_length) {
-        text_end_length = ll->total_length - (text_start_length + text_length);
-        while(rev_line_length < text_end_length) {
-          rev_line_length += ll->segment_lengths[final_j - 1];
-          final_j--;
-        }
-        final_j++;
-      }
-      
-      if(final_j == 0)
-        final_j = 1;
-      
-      /* determine if the line is mostly left to right or right to left,
-       see bug 1620 discussion by Steve Woodbridge */
-      direction = p->point[final_j].x - p->point[j].x;
-      
-      if(direction > 0) {
-        inc = 1; /* j is already correct */
-        
-        /* length of the segment containing the starting point */
-        segment_length = ll->segment_lengths[j];
-        
-        /* determine how far along the segment we need to go */
-        if(text_start_length < 0.0)
-          t = text_start_length / segment_length;
-        else
-          t = 1 - (fwd_line_length - text_start_length) / segment_length;
-      } else {
-        j = final_j;
-        inc = -1;
-        
-        /* length of the segment containing the starting point */
-        segment_length = ll->segment_lengths[j-1];
-        if(text_start_length < 0.0)
-          t = text_start_length / segment_length;
-        else
-          t = 1 - (rev_line_length - text_end_length) / segment_length;
-      }
-      
-      distance_along_segment = t * segment_length; /* starting point */
-      
-      theta = 0;
-      k = 0;
-      w = 0;
-      while ( k < tp->numglyphs ) {
-        double x,y;
-        
-        x = t * (p->point[j+inc].x - p->point[j].x) + p->point[j].x;
-        y = t * (p->point[j+inc].y - p->point[j].y) + p->point[j].y;
-        tp->glyphs[k].pnt.x = x;
-        tp->glyphs[k].pnt.y = y;
-        
-        
-        w = letterspacing*tp->glyphs[k].glyph->metrics.advance;
-        
-        /* add the character's width to the distance along the line */
-        distance_along_segment += w;
-        
-        /* if we still have segments left and we've past the current segment, move to the next one */
-        if(inc == 1 && j < p->numpoints - 2) {
-          
-          while ( j < p->numpoints - 2 && distance_along_segment > ll->segment_lengths[j] ) {
-            distance_along_segment -= ll->segment_lengths[j];
-            j += inc; /* move to next segment */
-          }
-          
-          segment_length = ll->segment_lengths[j];
-          
-        } else if( inc == -1 && j > 1 ) {
-          
-          while ( j > 1 && distance_along_segment > ll->segment_lengths[j-1] ) {
-            distance_along_segment -= ll->segment_lengths[j-1];
-            j += inc; /* move to next segment */
-          }
-          
-          segment_length = ll->segment_lengths[j-1];
-        }
-        
-        /* Recalculate interpolation parameter */
-        t = distance_along_segment / segment_length;
-        
-        k++;
-      }
-      
-      /* pre-calc the character's centre y value.  Used for rotation adjustment. */
-      cy = -ts->textpath->glyph_size / 2.0;
-#ifdef USE_KERNEL
-      tp->glyphs[0].pnt.x /= kernel_normal;
-      tp->glyphs[0].pnt.y /= kernel_normal;
-#endif
-      
-      /* Average the points and calculate each angle */
-      overlap_collision_detected = 0;
-      for (k = 1; k <= tp->numglyphs; k++) {
-        double anglediff;
-        if ( k < tp->numglyphs ) {
-#ifdef USE_KERNEL
-          tp->glyphs[k].pnt.x /= kernel_normal;
-          tp->glyphs[k].pnt.y /= kernel_normal;
-#endif
-          dx = tp->glyphs[k].pnt.x - tp->glyphs[k-1].pnt.x;
-          dy = tp->glyphs[k].pnt.y - tp->glyphs[k-1].pnt.y;
-        } else {
-          /* Handle the last character */
-          dx = t * (p->point[j+inc].x - p->point[j].x) + p->point[j].x - tp->glyphs[k-1].pnt.x;
-          dy = t * (p->point[j+inc].y - p->point[j].y) + p->point[j].y - tp->glyphs[k-1].pnt.y;
-        }
-        
-        
-        if(dx || dy || k==1) {
-          
-          theta = -atan2(dy,dx);
-          
-          if (maxoverlapangle > 0 && k > 1) {
-            /* no use testing for overlap if glyph or previous glyph is a space */
-            if(!msIsGlyphASpace(&tp->glyphs[k-1]) && !msIsGlyphASpace(&tp->glyphs[k-2])) {
-              /* If the difference between the last char angle and the current one
-               is greater than the MAXOVERLAPANGLE value (set at 80% of 180deg by default)
-               , bail the label */
-              anglediff = fabs(theta - tp->glyphs[k-2].rot);
-              anglediff = MS_MIN(anglediff, MS_2PI - anglediff);
-              if(anglediff > maxoverlapangle ) {
-                double max_dec_retry_offset;
-                double max_inc_retry_offset;
-                if(label_repeat == 1) {
-                  max_dec_retry_offset = max_inc_retry_offset = first_label_position;
-                } else if(l==0) {
-                  if(direction>0) {
-                    max_inc_retry_offset = MS_MIN(first_label_position, max_retry_offset);
-                    max_dec_retry_offset = max_retry_offset;
-                  } else {
-                    max_inc_retry_offset = max_retry_offset;
-                    max_dec_retry_offset = MS_MIN(first_label_position, max_retry_offset);
-                  }
-                } else if(l == label_repeat-1) {
-                  if(direction>0) {
-                    max_dec_retry_offset = MS_MIN(first_label_position, max_retry_offset);
-                    max_inc_retry_offset = max_retry_offset;
-                  } else {
-                    max_dec_retry_offset = max_retry_offset;
-                    max_inc_retry_offset = MS_MIN(first_label_position, max_retry_offset);
-                  }
-                } else {
-                  max_dec_retry_offset = max_inc_retry_offset = max_retry_offset;
-                }
-
-                overlap_collision_detected = 1;
-                if(retry_offset == 0.0) {
-                  first_retry_idx = k-1;
-                }
-                retry_offset = compute_retry_offset(ts, first_retry_idx, retry_offset, max_dec_retry_offset, max_inc_retry_offset);
-                if(retry_offset == 0.0) { /* no offsetted position to try */
-                  freeTextPath(tp);
-                  free(tp);
-                } else {
-                  if(direction<0) {
-                    retry_offset = -retry_offset;
-                  }
-                }
-                break;
-              }
-            }
-          }
-        } else {
-          /*
-           * handle the 0-advance case, as the complex text shaping may have placed multiple
-           * glyphs at the same position
-           */
-          theta = tp->glyphs[k-2].rot;
-        }
-        
-        /* msDebug("s: %c (x,y): (%0.2f,%0.2f) t: %0.2f\n", string[k-1], labelpath->path.point[k-1].x, labelpath->path.point[k-1].y, theta); */
-        
-        tp->glyphs[k-1].rot = theta;
-        
-        
-        /* Move the previous point so that when the character is rotated and
-         placed it is centred on the line */
-        cos_t = cos(theta);
-        sin_t = sin(theta);
-        
-        w = letterspacing*tp->glyphs[k-1].glyph->metrics.advance;
-        
-        cx = 0; /* Center the character vertically only */
-        
-        dx = - (cx * cos_t + cy * sin_t);
-        dy = - (cy * cos_t - cx * sin_t);
-        
-        tp->glyphs[k-1].pnt.x += dx;
-        tp->glyphs[k-1].pnt.y += dy;
-        
-        /* Calculate the bounds */
-        bbox.minx = 0;
-        bbox.maxx = w;
-        bbox.maxy = 0;
-        bbox.miny = -ts->textpath->glyph_size;
-        
-        /* Add the label buffer to the bounds */
-        bbox.maxx += ts->label->buffer * ts->resolutionfactor;
-        bbox.maxy += ts->label->buffer * ts->resolutionfactor;
-        bbox.minx -= ts->label->buffer * ts->resolutionfactor;
-        bbox.miny -= ts->label->buffer * ts->resolutionfactor;
-        
-        if ( k < tp->numglyphs ) {
-          /* Transform the bbox too.  We take the UL and LL corners and rotate
-           then translate them. */
-          bounds->point[k-1].x = (bbox.minx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[k-1].y = (bbox.maxy * cos_t - bbox.minx * sin_t) + tp->glyphs[k-1].pnt.y;
-          
-          /* Start at end and work towards the half way point */
-          bounds->point[bounds->numpoints - k - 1].x = (bbox.minx * cos_t + bbox.miny * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[bounds->numpoints - k - 1].y = (bbox.miny * cos_t - bbox.minx * sin_t) + tp->glyphs[k-1].pnt.y;
-          
-        } else {
-          
-          /* This is the last character in the string so we take the UR and LR
-           corners of the bbox */
-          bounds->point[k-1].x = (bbox.maxx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[k-1].y = (bbox.maxy * cos_t - bbox.maxx * sin_t) + tp->glyphs[k-1].pnt.y;
-          
-          bounds->point[bounds->numpoints - k - 1].x = (bbox.maxx * cos_t + bbox.miny * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[bounds->numpoints - k - 1].y = (bbox.miny * cos_t - bbox.maxx * sin_t) + tp->glyphs[k-1].pnt.y;
-        }
-      }
-      if(overlap_collision_detected) {
-        continue;
-      }
-      
-      
-      /* Close the bounds */
-      bounds->point[bounds->numpoints - 1].x = bounds->point[0].x;
-      bounds->point[bounds->numpoints - 1].y = bounds->point[0].y;
-      
-      /* compute the bounds */
-      fastComputeBounds(bounds,&tp->bounds.bbox);
-      
-      
-      {
-        textPathObj *tmptp;
-        textSymbolObj *tsnew;
-        lfr->num_follow_labels++;
-        lfr->follow_labels = msSmallRealloc(lfr->follow_labels,lfr->num_follow_labels * sizeof(textSymbolObj*));
-        tmptp = ts->textpath;
-        ts->textpath = NULL;
-        lfr->follow_labels[lfr->num_follow_labels - 1] = msSmallMalloc(sizeof(textSymbolObj));
-        tsnew = lfr->follow_labels[lfr->num_follow_labels - 1];
-        initTextSymbol(tsnew);
-        msCopyTextSymbol(tsnew,ts);
-        ts->textpath = tmptp;
-        tsnew->textpath = tp;
-        tsnew->textpath->absolute = 1;
-      }
-      
-      cur_label_position += label_buffer;
-      retry_offset = 0;
-    } while(retry_offset);
-  }
-  return MS_SUCCESS;
-
-
-}
-
-/* ===========================================================================
-   Pretty printing of primitive objects
-   ======================================================================== */
-
-void msRectToFormattedString(rectObj *rect, char *format, char *buffer, int buffer_length)
-{
-  snprintf(buffer, buffer_length, format, rect->minx, rect->miny, rect->maxx, rect->maxy);
-}
-
-void msPointToFormattedString(pointObj *point, const char *format, char *buffer, int buffer_length)
-{
-  snprintf(buffer, buffer_length, format, point->x, point->y, point->z, point->m);
-}
-
-/* Returns true if a shape contains only degenerate parts */
-int msIsDegenerateShape(shapeObj *shape)
-{
-  int i;
-  int non_degenerate_parts = 0;
-  for(i=0; i<shape->numlines; i++) { /* e.g. part */
-
-    /* skip degenerate parts, really should only happen with pixel output */
-    if((shape->type == MS_SHAPE_LINE && shape->line[i].numpoints < 2) ||
-        (shape->type == MS_SHAPE_POLYGON && shape->line[i].numpoints < 3))
-      continue;
-
-    non_degenerate_parts++;
-  }
-  return( non_degenerate_parts == 0 );
-}
-
-shapeObj *msRings2Shape(shapeObj *shape, int outer) {
-  shapeObj *shape2;
-  int i, rv, *outerList=NULL;
-
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_POLYGON) return NULL;
-
-  outer = (outer)?1:0; // set explicitly to 1 or 0
-
-  shape2 = (shapeObj *) malloc(sizeof(shapeObj));
-  MS_CHECK_ALLOC(shape2, sizeof(shapeObj), NULL);
-  msInitShape(shape2);
-  shape2->type = shape->type;
-
-  outerList = msGetOuterList(shape);
-  if(!outerList) {
-    msFreeShape(shape2);
-    free(shape2);
-    return NULL;
-  }
-
-  for(i=0; i<shape->numlines; i++) {
-    if(outerList[i] == outer) { // else inner
-      rv = msAddLine(shape2, &(shape->line[i]));
-      if(rv != MS_SUCCESS) {
-        msFreeShape(shape2);
-        free(shape2);
-        free(outerList);
-        return NULL;
-      }
-    }
-  }
-
-  free(outerList); // clean up
-  return shape2;
-}
-
-shapeObj *msDensify(shapeObj *shape, double tolerance) {
-  int i, j, k, l; // counters                                                                                                                                                
-  int n;
-  shapeObj *shape2;
-  lineObj line;
-  double distance, length, c;
-
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_POLYGON && shape->type != MS_SHAPE_LINE) return NULL;
-  if(tolerance <= 0) return NULL; // must be positive
-
-  shape2 = (shapeObj *) malloc(sizeof(shapeObj));
-  MS_CHECK_ALLOC(shape2, sizeof(shapeObj), NULL);
-  msInitShape(shape2);
-  shape2->type = shape->type; // POLGYON or LINE
-
-  for(i=0; i<shape->numlines; i++) {
-
-    line.numpoints = shape->line[i].numpoints;
-    line.point = (pointObj *) malloc(sizeof(pointObj)*line.numpoints); // best case we don't have to add any points
-    MS_CHECK_ALLOC(line.point, sizeof(pointObj)*line.numpoints, NULL);
-
-    for(j=0, l=0; j<shape->line[i].numpoints-1; j++, l++) {
-      line.point[l] = shape->line[i].point[j];
-
-      distance = msDistancePointToPoint(&(shape->line[i].point[j]), &(shape->line[i].point[j+1]));
-      if(distance > tolerance) {
-        n = (int) floor(distance/tolerance); // number of new points, n+1 is the number of new segments
-        length = distance/(n+1); // segment length
-
-        line.numpoints += n;
-        line.point = (pointObj *) realloc(line.point, sizeof(pointObj)*line.numpoints);
-        MS_CHECK_ALLOC(line.point, sizeof(pointObj)*line.numpoints, NULL);
-
-        for(k=0; k<n; k++) {
-          c = (k+1)*length/distance;
-          l++;
-          line.point[l].x = shape->line[i].point[j].x + c*(shape->line[i].point[j+1].x - shape->line[i].point[j].x);
-          line.point[l].y = shape->line[i].point[j].y + c*(shape->line[i].point[j+1].y - shape->line[i].point[j].y);
-        }
-      }
-    }
-    line.point[l] = shape->line[i].point[j];
-
-    msAddLineDirectly(shape2, &line);
-  }
-
-  return shape2;
-}
diff -pruN 8.0.1-5/mapprimitive.h 8.2.0~beta1-1~exp1/mapprimitive.h
--- 8.0.1-5/mapprimitive.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapprimitive.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,133 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Declarations for rectObj, pointObj, lineObj, shapeObj, etc.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPPRIMITIVE_H
-#define MAPPRIMITIVE_H
-
- /**
- A rectObj represents a rectangle or bounding box.
- A rectObj may be a lone object or an attribute of another object and has no other associations.
- */
-typedef struct {
-  double minx; ///< Minimum easting
-  double miny; ///< Minimum northing
-  double maxx; ///< Maximum easting
-  double maxy; ///< Maximum northing
-} rectObj;
-
-#ifndef SWIG
-typedef struct {
-  double x;
-  double y;
-} vectorObj;
-#endif /*SWIG*/
-
-/**
-A :class:`pointObj` has an x, y, z and m values.
-A :class:`pointObj` instance may be associated with a :class:`lineObj`.
-*/
-typedef struct {
-  double x; ///< The x coordinate of the point
-  double y; ///< The y coordinate of the point
-  double z; ///< The z (height) coordinate of the point
-  double m; ///< The m (measure) of the point, used for linear referencing
-} pointObj;
-
-/**
-A :class:`lineObj` is composed of one or more :class:`pointObj` instances
-*/
-typedef struct {
-#ifdef SWIG
-  %immutable;
-#endif
-  int numpoints; ///< Number of points in the line
-#ifndef SWIG
-  pointObj *point;
-#endif
-#ifdef SWIG
-  %mutable;
-#endif
-} lineObj;
-
-/**
-Each feature of a layer's data is a :class:`shapeObj`. Each part of the shape is a closed :class:`lineObj`.
-*/
-typedef struct {
-
-#ifndef SWIG
-    lineObj *line;
-    char **values;
-    void *geometry;
-    void *renderer_cache;
-#endif
-
-#ifdef SWIG
-  %immutable;
-#endif
-  int numlines; ///< Number of parts
-  int numvalues; ///< Number of shape attributes
-
-#ifdef SWIG
-  %mutable;
-#endif
-
-  rectObj bounds; ///< Bounding box of shape
-  int type; ///< MS_SHAPE_POINT, MS_SHAPE_LINE, MS_SHAPE_POLYGON, or MS_SHAPE_NULL
-  long index; ///< Feature index within the layer
-  int tileindex; ///< Index of tiled file for tile-indexed layers
-  int classindex; ///< The class index for features of a classified layer
-  char *text; ///< Shape annotation
-
-  int scratch;
-  int resultindex; ///< Index within a query result set
-} shapeObj;
-
-typedef lineObj multipointObj;
-
-#ifndef SWIG
-/* attribute primitives */
-typedef struct {
-  char *name;
-  long type;
-  int index;
-  int size;
-  short numdecimals;
-} itemObj;
-#endif
-
-#ifndef SWIG
-typedef struct {
-  int  need_geotransform;
-  double rotation_angle;
-  double geotransform[6];    /* Pixel/line to georef. */
-  double invgeotransform[6]; /* georef to pixel/line */
-} geotransformObj;
-#endif
-
-#endif /* MAPPRIMITIVE_H */
diff -pruN 8.0.1-5/mapproject.c 8.2.0~beta1-1~exp1/mapproject.c
--- 8.0.1-5/mapproject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapproject.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,3001 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  projectionObj / PROJ.4 interface.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapproject.h"
-#include "mapthread.h"
-#include <assert.h>
-#include <float.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include "mapaxisorder.h"
-
-#include "cpl_conv.h"
-#include "cpl_string.h"
-#include "ogr_srs_api.h"
-
-static char *ms_proj_data = NULL;
-#if PROJ_VERSION_MAJOR >= 6
-static unsigned ms_proj_data_change_counter = 0;
-#endif
-
-typedef struct LinkedListOfProjContext LinkedListOfProjContext;
-struct LinkedListOfProjContext
-{
-    LinkedListOfProjContext* next;
-    projectionContext* context;
-};
-
-static LinkedListOfProjContext* headOfLinkedListOfProjContext = NULL;
-
-static int msTestNeedWrap( pointObj pt1, pointObj pt2, pointObj pt2_geo,
-                           reprojectionObj* reprojector );
-
-
-static projectionContext* msProjectionContextCreate(void);
-static void msProjectionContextUnref(projectionContext* ctx);
-
-#if PROJ_VERSION_MAJOR >= 6
-
-#include "proj_experimental.h"
-
-/* Helps considerably for use cases like msautotest/wxs/wms_inspire.map */
-/* which involve a number of layers with same SRS, and a number of exposed */
-/* output SRS */
-#define PJ_CACHE_ENTRY_SIZE 32
-
-typedef struct
-{
-    char* inStr;
-    char* outStr;
-    PJ* pj;
-} pjCacheEntry;
-
-struct projectionContext
-{
-    PJ_CONTEXT* proj_ctx;
-    unsigned ms_proj_data_change_counter;
-    int ref_count;
-    pjCacheEntry pj_cache[PJ_CACHE_ENTRY_SIZE];
-    int pj_cache_size;
-};
-
-/************************************************************************/
-/*                  msProjectHasLonWrapOrOver()                         */
-/************************************************************************/
-
-static int msProjectHasLonWrapOrOver(projectionObj *in) {
-    int i;
-    for( i = 0; i < in->numargs; i++ )
-    {
-        if( strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 ||
-            strcmp(in->args[i], "+over") == 0 ||
-            strcmp(in->args[i], "over") == 0 )
-        {
-            return MS_TRUE;
-        }
-    }
-    return MS_FALSE;
-}
-
-static char* getStringFromArgv(int argc, char** args)
-{
-    int i;
-    int len = 0;
-    for( i = 0; i < argc; i++ )
-    {
-        len += strlen(args[i]) + 1;
-    }
-    char* str = msSmallMalloc(len + 1);
-    len = 0;
-    for( i = 0; i < argc; i++ )
-    {
-        size_t arglen = strlen(args[i]);
-        memcpy(str + len, args[i], arglen);
-        len += arglen;
-        str[len] = ' ';
-        len ++;
-    }
-    str[len] = 0;
-    return str;
-}
-
-/************************************************************************/
-/*                         createNormalizedPJ()                         */
-/************************************************************************/
-
-/* Return to be freed with proj_destroy() if *pbFreePJ = TRUE */
-static PJ* createNormalizedPJ(projectionObj *in, projectionObj *out, int* pbFreePJ)
-{
-    if( in->proj == out->proj )
-    {
-        /* Special case to avoid out_str below to cause in_str to become invalid */
-        *pbFreePJ = TRUE;
-#if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR == 0
-        /* 6.0 didn't support proj=noop */
-        return proj_create(in->proj_ctx->proj_ctx, "+proj=affine");
-#else
-        return proj_create(in->proj_ctx->proj_ctx, "+proj=noop");
-#endif
-    }
-
-    const char* const wkt_options[] = { "MULTILINE=NO", NULL };
-    const char* in_str = msProjectHasLonWrapOrOver(in) ?
-        proj_as_proj_string(in->proj_ctx->proj_ctx, in->proj, PJ_PROJ_4, NULL) :
-        proj_as_wkt(in->proj_ctx->proj_ctx, in->proj, PJ_WKT2_2018, wkt_options);
-    const char* out_str = msProjectHasLonWrapOrOver(out) ?
-        proj_as_proj_string(out->proj_ctx->proj_ctx, out->proj, PJ_PROJ_4, NULL) :
-        proj_as_wkt(out->proj_ctx->proj_ctx, out->proj, PJ_WKT2_2018, wkt_options);
-    PJ* pj_raw;
-    PJ* pj_normalized;
-    if( !in_str || !out_str )
-        return NULL;
-    char* in_str_for_cache = getStringFromArgv(in->numargs, in->args);
-    char* out_str_for_cache = getStringFromArgv(out->numargs, out->args);
-
-    if( in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx )
-    {
-        int i;
-        pjCacheEntry* pj_cache = in->proj_ctx->pj_cache;
-        for( i = 0; i < in->proj_ctx->pj_cache_size; i++ )
-        {
-            if (strcmp(pj_cache[i].inStr, in_str_for_cache) == 0 &&
-                strcmp(pj_cache[i].outStr, out_str_for_cache) == 0 )
-            {
-                PJ* ret = pj_cache[i].pj;
-                if( i != 0 )
-                {
-                    /* Move entry to top */
-                    pjCacheEntry tmp;
-                    memcpy(&tmp, &pj_cache[i], sizeof(pjCacheEntry));
-                    memmove(&pj_cache[1], &pj_cache[0], i * sizeof(pjCacheEntry));
-                    memcpy(&pj_cache[0], &tmp, sizeof(pjCacheEntry));
-                }
-#ifdef notdef
-                fprintf(stderr, "cache hit!\n");
-#endif
-                *pbFreePJ = FALSE;
-                msFree(in_str_for_cache);
-                msFree(out_str_for_cache);
-                return ret;
-            }
-        }
-    }
-
-#ifdef notdef
-    fprintf(stderr, "%s -> %s\n", in_str, out_str);
-    fprintf(stderr, "%p -> %p\n", in->proj_ctx->proj_ctx, out->proj_ctx->proj_ctx);
-    fprintf(stderr, "cache miss!\n");
-#endif
-
-#if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR < 2
-    if( strstr(in_str, "+proj=") && strstr(in_str, "+over") &&
-        strstr(out_str, "+proj=") && strstr(out_str, "+over") &&
-        strlen(in_str) < 400 && strlen(out_str) < 400 )
-    {
-        // Fixed per PROJ commit
-        // https://github.com/OSGeo/PROJ/commit/78302efb70eb4b49610cda6a60bf9ce39b82264f
-        // and
-        // https://github.com/OSGeo/PROJ/commit/ae70b26b9cbae85a38d5b26533ba06da0ea13940
-        // Fix for wcs_get_capabilities_tileindexmixedsrs_26711.xml and wcs_20_getcov_bands_name_new_reproject.dat
-        char szPipeline[1024];
-        strcpy(szPipeline, "+proj=pipeline");
-        if( msProjIsGeographicCRS(in) )
-        {
-            strcat(szPipeline, " +step +proj=unitconvert +xy_in=deg +xy_out=rad");
-        }
-        strcat(szPipeline, " +step +inv ");
-        strcat(szPipeline, in_str);
-        strcat(szPipeline, " +step ");
-        strcat(szPipeline, out_str);
-        if( msProjIsGeographicCRS(out) )
-        {
-            strcat(szPipeline, " +step +proj=unitconvert +xy_in=rad +xy_out=deg");
-        }
-        /* We do not want datum=NAD83 to imply a transformation with towgs84=0,0,0 */
-        {
-            char* ptr = szPipeline;
-            while(1)
-            {
-                ptr = strstr(ptr, " +datum=NAD83");
-                if( !ptr )
-                    break;
-                memcpy(ptr, " +ellps=GRS80", 13);
-            }
-        }
-
-        /* Remove +nadgrids=@null as it doesn't work if going outside of [-180,180] */
-        /* Fixed per https://github.com/OSGeo/PROJ/commit/10a30bb539be1afb25952b19af8bbe72e1b13b56 */
-        {
-            char* ptr = strstr(szPipeline, " +nadgrids=@null");
-            if( ptr )
-                memcpy(ptr, "                ", 16);
-        }
-
-        pj_normalized = proj_create(in->proj_ctx->proj_ctx, szPipeline);
-    }
-    else
-#endif
-    {
-#if PROJ_VERSION_MAJOR > 6 || (PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR >= 2)
-        pj_raw = proj_create_crs_to_crs_from_pj(in->proj_ctx->proj_ctx, in->proj, out->proj, NULL, NULL);
-#else
-        pj_raw = proj_create_crs_to_crs(in->proj_ctx->proj_ctx, in_str, out_str, NULL);
-#endif
-        if( !pj_raw )
-        {
-            msFree(in_str_for_cache);
-            msFree(out_str_for_cache);
-            return NULL;
-        }
-        pj_normalized = proj_normalize_for_visualization(in->proj_ctx->proj_ctx, pj_raw);
-        proj_destroy(pj_raw);
-    }
-    if( !pj_normalized )
-    {
-        msFree(in_str_for_cache);
-        msFree(out_str_for_cache);
-        return NULL;
-    }
-
-    if( in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx )
-    {
-        /* Insert entry into cache */
-        int i;
-        pjCacheEntry* pj_cache = in->proj_ctx->pj_cache;
-        if( in->proj_ctx->pj_cache_size < PJ_CACHE_ENTRY_SIZE )
-        {
-            i = in->proj_ctx->pj_cache_size;
-            assert ( pj_cache[i].inStr == NULL );
-            in->proj_ctx->pj_cache_size ++;
-        }
-        else
-        {
-            i = 0;
-            /* Evict oldest entry */
-            msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].inStr);
-            msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].outStr);
-            proj_destroy(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].pj);
-            memmove(&pj_cache[1], &pj_cache[0],
-                    (PJ_CACHE_ENTRY_SIZE - 1) * sizeof(pjCacheEntry));
-        }
-        pj_cache[i].inStr = msStrdup(in_str_for_cache);
-        pj_cache[i].outStr = msStrdup(out_str_for_cache);
-        pj_cache[i].pj = pj_normalized;
-        *pbFreePJ = FALSE;
-    }
-    else
-    {
-        *pbFreePJ = TRUE;
-    }
-
-    msFree(in_str_for_cache);
-    msFree(out_str_for_cache);
-
-    return pj_normalized;
-}
-
-/************************************************************************/
-/*                        getBaseGeographicCRS()                        */
-/************************************************************************/
-
-/* Return to be freed with proj_destroy() */
-static PJ* getBaseGeographicCRS(projectionObj* in)
-{
-    PJ_CONTEXT* ctxt;
-    PJ_TYPE type;
-    assert(in && in->proj);
-    ctxt = in->proj_ctx->proj_ctx;
-    type = proj_get_type(in->proj);
-    if( type == PJ_TYPE_PROJECTED_CRS )
-    {
-        return proj_get_source_crs(ctxt, in->proj);
-    }
-    if( type == PJ_TYPE_BOUND_CRS )
-    {
-        /* If it is a boundCRS of a projectedCRS, extract the geographicCRS
-         * from the projectedCRS, and rewrap it in a boundCRS */
-        PJ* source_crs = proj_get_source_crs(ctxt, in->proj);
-        PJ* geog_source_crs;
-        PJ* hub_crs;
-        PJ* transf;
-        PJ* ret;
-        if( proj_get_type(source_crs) != PJ_TYPE_PROJECTED_CRS )
-        {
-            proj_destroy(source_crs);
-            return NULL;
-        }
-        geog_source_crs = proj_get_source_crs(ctxt, source_crs);
-        proj_destroy(source_crs);
-        hub_crs = proj_get_target_crs(ctxt, in->proj);
-        transf = proj_crs_get_coordoperation(ctxt, in->proj);
-        ret = proj_crs_create_bound_crs(ctxt, geog_source_crs,
-                                        hub_crs, transf);
-        proj_destroy(geog_source_crs);
-        proj_destroy(hub_crs);
-        proj_destroy(transf);
-        return ret;
-
-    }
-    return NULL;
-}
-
-/************************************************************************/
-/*                          msProjErrorLogger()                         */
-/************************************************************************/
-
-static void msProjErrorLogger(void * user_data,
-                             int level, const char * message)
-{
-    (void)user_data;
-#if PROJ_VERSION_MAJOR >= 6    
-    if( level == PJ_LOG_ERROR && msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_VV )
-#else
-    if( level == PJ_LOG_ERROR )
-#endif
-    {
-        msDebug( "PROJ: Error: %s\n", message );
-    }
-    else if( level == PJ_LOG_DEBUG )
-    {
-        msDebug( "PROJ: Debug: %s\n", message );
-    }
-}
-
-/************************************************************************/
-/*                        msProjectionContextCreate()                   */
-/************************************************************************/
-
-projectionContext* msProjectionContextCreate(void)
-{
-    projectionContext* ctx = (projectionContext*)msSmallCalloc(1, sizeof(projectionContext));
-    ctx->proj_ctx = proj_context_create();
-    if( ctx->proj_ctx == NULL )
-    {
-        msFree(ctx);
-        return NULL;
-    }
-    ctx->ref_count = 1;
-    proj_context_use_proj4_init_rules(ctx->proj_ctx, TRUE);
-    proj_log_func (ctx->proj_ctx, NULL, msProjErrorLogger);
-    return ctx;
-}
-
-/************************************************************************/
-/*                        msProjectionContextUnref()                    */
-/************************************************************************/
-
-void msProjectionContextUnref(projectionContext* ctx)
-{
-    if( !ctx )
-        return;
-    --ctx->ref_count;
-    if( ctx->ref_count == 0 )
-    {
-        int i;
-        for( i = 0; i < ctx->pj_cache_size; i++ )
-        {
-            msFree(ctx->pj_cache[i].inStr);
-            msFree(ctx->pj_cache[i].outStr);
-            proj_destroy(ctx->pj_cache[i].pj);
-        }
-        proj_context_destroy(ctx->proj_ctx);
-        msFree(ctx);
-    }
-}
-
-/************************************************************************/
-/*                        msProjectCreateReprojector()                  */
-/************************************************************************/
-
-reprojectionObj* msProjectCreateReprojector(projectionObj* in, projectionObj* out)
-{
-    reprojectionObj* obj = (reprojectionObj*)msSmallCalloc(1, sizeof(reprojectionObj));
-    obj->in = in;
-    obj->out = out;
-    obj->lineCuttingCase = LINE_CUTTING_UNKNOWN;
-
-    /* -------------------------------------------------------------------- */
-    /*      If the source and destination are simple and equal, then do     */
-    /*      nothing.                                                        */
-    /* -------------------------------------------------------------------- */
-    if( in && in->numargs == 1 && out && out->numargs == 1
-        && strcmp(in->args[0],out->args[0]) == 0 ) {
-        /* do nothing, no transformation required */
-    }
-    /* -------------------------------------------------------------------- */
-    /*      If we have a fully defined input coordinate system and          */
-    /*      output coordinate system, then we will use createNormalizedPJ   */
-    /* -------------------------------------------------------------------- */
-    else if( in && in->proj && out && out->proj ) {
-        PJ* pj = createNormalizedPJ(in, out, &(obj->bFreePJ));
-        if( !pj )
-        {
-            msFree(obj);
-            return NULL;
-        }
-        obj->pj = pj;
-    }
-
-    /* nothing to do if the other coordinate system is also lat/long */
-    else if( (in == NULL || in->proj == NULL) &&
-             (out == NULL || out->proj == NULL || msProjIsGeographicCRS(out) ))
-    {
-        /* do nothing */
-    }
-    else if( out == NULL && in != NULL && msProjIsGeographicCRS(in) )
-    {
-        /* do nothing */
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Otherwise we assume that the NULL projectionObj is supposed to be */
-    /*      lat/long in the same datum as the other projectionObj.  This    */
-    /*      is essentially a backwards compatibility mode.                  */
-    /* -------------------------------------------------------------------- */
-    else {
-        PJ* pj = NULL;
-
-        if( (in==NULL || in->proj==NULL) && out && out->proj) { /* input coordinates are lat/lon */
-            PJ* source_crs = getBaseGeographicCRS(out);
-            projectionObj in_modified;
-            memset(&in_modified, 0, sizeof(in_modified));
-
-            in_modified.proj_ctx = out->proj_ctx;
-            in_modified.proj = source_crs;
-            pj = createNormalizedPJ(&in_modified, out, &(obj->bFreePJ));
-            proj_destroy(source_crs);
-        } else if( /* (out==NULL || out->proj==NULL) && */ in && in->proj )  {
-            PJ* target_crs = getBaseGeographicCRS(in);
-            projectionObj out_modified;
-            memset(&out_modified, 0, sizeof(out_modified));
-
-            out_modified.proj_ctx = in->proj_ctx;
-            out_modified.proj = target_crs;
-            pj = createNormalizedPJ(in, &out_modified, &(obj->bFreePJ));
-            proj_destroy(target_crs);
-        }
-        if( !pj )
-        {
-            msFree(obj);
-            return NULL;
-        }
-        obj->pj = pj;
-    }
-
-    return obj;
-}
-
-/************************************************************************/
-/*                      msProjectDestroyReprojector()                   */
-/************************************************************************/
-
-void msProjectDestroyReprojector(reprojectionObj* reprojector)
-{
-    if( !reprojector )
-        return;
-    if( reprojector->bFreePJ )
-        proj_destroy(reprojector->pj);
-    msFreeShape(&(reprojector->splitShape));
-    msFree(reprojector);
-}
-
-/************************************************************************/
-/*                       msProjectTransformPoints()                     */
-/************************************************************************/
-
-int msProjectTransformPoints( reprojectionObj* reprojector,
-                              int npoints, double* x, double* y )
-{
-    proj_trans_generic (reprojector->pj, PJ_FWD,
-                        x, sizeof(double), npoints,
-                        y, sizeof(double), npoints,
-                        NULL, 0, 0,
-                        NULL, 0, 0 );
-    return MS_SUCCESS;
-}
-
-#else
-
-/************************************************************************/
-/*                        msProjectionContextCreate()                   */
-/************************************************************************/
-
-projectionContext* msProjectionContextCreate(void)
-{
-    return NULL;
-}
-
-/************************************************************************/
-/*                        msProjectionContextUnref()                    */
-/************************************************************************/
-
-void msProjectionContextUnref(projectionContext* ctx)
-{
-    (void)ctx;
-}
-
-/************************************************************************/
-/*                        msProjectCreateReprojector()                  */
-/************************************************************************/
-
-reprojectionObj* msProjectCreateReprojector(projectionObj* in, projectionObj* out)
-{
-    reprojectionObj* obj;
-    obj = (reprojectionObj*)msSmallCalloc(1, sizeof(reprojectionObj));
-    obj->in = in;
-    obj->out = out;
-    obj->lineCuttingCase = LINE_CUTTING_UNKNOWN;
-
-    /* -------------------------------------------------------------------- */
-    /*      If the source and destination are equal, then do nothing.       */
-    /* -------------------------------------------------------------------- */
-    if( in && out && in->numargs == out->numargs && in->numargs > 0
-        && strcmp(in->args[0],out->args[0]) == 0 )
-    {
-        int i;
-        obj->no_op = MS_TRUE;
-        for( i = 1; i < in->numargs; i++ )
-        {
-            if( strcmp(in->args[i],out->args[i]) != 0 ) {
-                obj->no_op = MS_FALSE;
-                break;
-            }
-        }
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      If we have a fully defined input coordinate system and          */
-    /*      output coordinate system, then we will use pj_transform         */
-    /* -------------------------------------------------------------------- */
-    else if( in && in->proj && out && out->proj ) {
-        /* do nothing for now */
-    }
-    /* nothing to do if the other coordinate system is also lat/long */
-    else if( in == NULL && (out == NULL || msProjIsGeographicCRS(out) ))
-    {
-        obj->no_op = MS_TRUE;
-    }
-    else if( out == NULL && in != NULL && msProjIsGeographicCRS(in) )
-    {
-        obj->no_op = MS_TRUE;
-    }
-    else if( (in == NULL || in->proj == NULL) &&
-             (out == NULL || out->proj == NULL) )
-    {
-        msProjectDestroyReprojector(obj);
-        return NULL;
-    }
-    return obj;
-}
-
-/************************************************************************/
-/*                      msProjectDestroyReprojector()                   */
-/************************************************************************/
-
-void msProjectDestroyReprojector(reprojectionObj* reprojector)
-{
-    if( !reprojector )
-        return;
-    msFreeShape(&(reprojector->splitShape));
-    msFree(reprojector);
-}
-
-#endif
-
-/*
-** Initialize, load and free a projectionObj structure
-*/
-int msInitProjection(projectionObj *p)
-{
-  p->gt.need_geotransform = MS_FALSE;
-  p->numargs = 0;
-  p->args = NULL;
-  p->wellknownprojection = wkp_none;
-  p->proj = NULL;
-  p->args = (char **)malloc(MS_MAXPROJARGS*sizeof(char *));
-  MS_CHECK_ALLOC(p->args, MS_MAXPROJARGS*sizeof(char *), -1);
-#if PROJ_VERSION_MAJOR >= 6
-  p->proj_ctx = NULL;
-#elif PJ_VERSION >= 480
-  p->proj_ctx = NULL;
-#endif
-  return(0);
-}
-
-void msFreeProjection(projectionObj *p)
-{
-#if PROJ_VERSION_MAJOR >= 6
-  proj_destroy(p->proj);
-  p->proj = NULL;
-  msProjectionContextUnref(p->proj_ctx);
-  p->proj_ctx = NULL;
-#else
-  if(p->proj) {
-    pj_free(p->proj);
-    p->proj = NULL;
-  }
-#if PJ_VERSION >= 480
-  if(p->proj_ctx) {
-    pj_ctx_free(p->proj_ctx);
-    p->proj_ctx = NULL;
-  }
-#endif
-#endif
-
-  p->gt.need_geotransform = MS_FALSE;
-  p->wellknownprojection = wkp_none;
-  msFreeCharArray(p->args, p->numargs);
-  p->args = NULL;
-  p->numargs = 0;
-}
-
-void msFreeProjectionExceptContext(projectionObj *p)
-{
-#if PROJ_VERSION_MAJOR >= 6
-  projectionContext* ctx = p->proj_ctx;
-  p->proj_ctx = NULL;
-  msFreeProjection(p);
-  p->proj_ctx = ctx;
-#else
-  msFreeProjection(p);
-#endif
-}
-
-/************************************************************************/
-/*                 msProjectionInheritContextFrom()                     */
-/************************************************************************/
-
-void msProjectionInheritContextFrom(projectionObj *pDst, const projectionObj* pSrc)
-{
-#if PROJ_VERSION_MAJOR >= 6
-    if( pDst->proj_ctx == NULL && pSrc->proj_ctx != NULL)
-    {
-        pDst->proj_ctx = pSrc->proj_ctx;
-        pDst->proj_ctx->ref_count ++;
-    }
-#else
-    (void)pDst;
-    (void)pSrc;
-#endif
-}
-
-/************************************************************************/
-/*                      msProjectionSetContext()                        */
-/************************************************************************/
-
-void msProjectionSetContext(projectionObj *p, projectionContext* ctx)
-{
-#if PROJ_VERSION_MAJOR >= 6
-    if( p->proj_ctx == NULL && ctx != NULL)
-    {
-        p->proj_ctx = ctx;
-        p->proj_ctx->ref_count ++;
-    }
-#else
-    (void)p;
-    (void)ctx;
-#endif
-}
-
-/*
-** Handle OGC WMS/WFS AUTO projection in the format:
-**    "AUTO:proj_id,units_id,lon0,lat0"
-*/
-
-static int _msProcessAutoProjection(projectionObj *p)
-{
-  char **args;
-  int numargs, nProjId, nUnitsId, nZone;
-  double dLat0, dLon0;
-  const char *pszUnits = "m";
-  char szProjBuf[512]="";
-
-  /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
-  args = msStringSplit(p->args[0], ',', &numargs);
-  if (numargs != 4 ||
-      (strncasecmp(args[0], "AUTO:", 5) != 0 &&
-       strncasecmp(args[0], "AUTO2:", 6) != 0)) {
-    msSetError(MS_PROJERR,
-               "WMS/WFS AUTO/AUTO2 PROJECTION must be in the format "
-               "'AUTO:proj_id,units_id,lon0,lat0' or 'AUTO2:crs_id,factor,lon0,lat0'(got '%s').\n",
-               "_msProcessAutoProjection()", p->args[0]);
-    msFreeCharArray(args, numargs);
-    return -1;
-  }
-
-  if (strncasecmp(args[0], "AUTO:", 5)==0)
-    nProjId = atoi(args[0]+5);
-  else
-    nProjId = atoi(args[0]+6);
-
-  nUnitsId = atoi(args[1]);
-  dLon0 = atof(args[2]);
-  dLat0 = atof(args[3]);
-
-
-  /*There is no unit parameter for AUTO2. The 2nd parameter is
-   factor. Set the units to always be meter*/
-  if (strncasecmp(args[0], "AUTO2:", 6) == 0)
-    nUnitsId = 9001;
-
-  msFreeCharArray(args, numargs);
-
-  /* Handle EPSG Units.  Only meters for now. */
-  switch(nUnitsId) {
-    case 9001:  /* Meters */
-      pszUnits = "m";
-      break;
-    default:
-      msSetError(MS_PROJERR,
-                 "WMS/WFS AUTO PROJECTION: EPSG Units %d not supported.\n",
-                 "_msProcessAutoProjection()", nUnitsId);
-      return -1;
-  }
-
-  /* Build PROJ4 definition.
-   * This is based on the definitions found in annex E of the WMS 1.1.1
-   * spec and online at http://www.digitalearth.org/wmt/auto.html
-   * The conversion from the original WKT definitions to PROJ4 format was
-   * done using the MapScript setWKTProjection() function (based on OGR).
-   */
-  switch(nProjId) {
-    case 42001: /** WGS 84 / Auto UTM **/
-      nZone = (int) floor( (dLon0 + 180.0) / 6.0 ) + 1;
-      sprintf( szProjBuf,
-               "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
-               "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               -183.0 + nZone * 6.0,
-               (dLat0 >= 0.0) ? 0.0 : 10000000.0,
-               pszUnits);
-      break;
-    case 42002: /** WGS 84 / Auto Tr. Mercator **/
-      sprintf( szProjBuf,
-               "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
-               "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               dLon0,
-               (dLat0 >= 0.0) ? 0.0 : 10000000.0,
-               pszUnits);
-      break;
-    case 42003: /** WGS 84 / Auto Orthographic **/
-      sprintf( szProjBuf,
-               "+proj=ortho+lon_0=%.16g+lat_0=%.16g+x_0=0+y_0=0"
-               "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               dLon0, dLat0, pszUnits );
-      break;
-    case 42004: /** WGS 84 / Auto Equirectangular **/
-      /* Note that we have to pass lon_0 as lon_ts for this one to */
-      /* work.  Either a PROJ4 bug or a PROJ4 documentation issue. */
-      sprintf( szProjBuf,
-               "+proj=eqc+lon_ts=%.16g+lat_ts=%.16g+x_0=0+y_0=0"
-               "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               dLon0, dLat0, pszUnits);
-      break;
-    case 42005: /** WGS 84 / Auto Mollweide **/
-      sprintf( szProjBuf,
-               "+proj=moll+lon_0=%.16g+x_0=0+y_0=0+ellps=WGS84"
-               "+datum=WGS84+units=%s+type=crs",
-               dLon0, pszUnits);
-      break;
-    default:
-      msSetError(MS_PROJERR,
-                 "WMS/WFS AUTO PROJECTION %d not supported.\n",
-                 "_msProcessAutoProjection()", nProjId);
-      return -1;
-  }
-
-  /* msDebug("%s = %s\n", p->args[0], szProjBuf); */
-
-  /* OK, pass the definition to pj_init() */
-  args = msStringSplit(szProjBuf, '+', &numargs);
-
-#if PROJ_VERSION_MAJOR >= 6
-  if( !(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, numargs, args)) ) {
-    int l_pj_errno = proj_context_errno (p->proj_ctx->proj_ctx);
-    msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-               "msProcessProjection()", proj_errno_string(l_pj_errno), szProjBuf) ;
-    msFreeCharArray(args, numargs);
-    return(-1);
-  }
-#else
-  msAcquireLock( TLOCK_PROJ );
-  if( !(p->proj = pj_init(numargs, args)) ) {
-    int *pj_errno_ref = pj_get_errno_ref();
-    msReleaseLock( TLOCK_PROJ );
-    msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-               "msProcessProjection()", pj_strerrno(*pj_errno_ref), szProjBuf) ;
-    msFreeCharArray(args, numargs);
-    return(-1);
-  }
-  msReleaseLock( TLOCK_PROJ );
-#endif
-
-  msFreeCharArray(args, numargs);
-
-  return(0);
-}
-
-int msProcessProjection(projectionObj *p)
-{
-  assert( p->proj == NULL );
-
-  if( strcasecmp(p->args[0],"GEOGRAPHIC") == 0 ) {
-    msSetError(MS_PROJERR,
-               "PROJECTION 'GEOGRAPHIC' no longer supported.\n"
-               "Provide explicit definition.\n"
-               "ie. proj=latlong\n"
-               "    ellps=clrk66\n",
-               "msProcessProjection()");
-    return(-1);
-  }
-
-  if (strcasecmp(p->args[0], "AUTO") == 0) {
-    p->proj = NULL;
-    return 0;
-  }
-
-#if PROJ_VERSION_MAJOR >= 6
-  if( p->proj_ctx == NULL )
-  {
-    p->proj_ctx = msProjectionContextCreate();
-    if( p->proj_ctx == NULL )
-    {
-        return -1;
-    }
-  }
-  if( p->proj_ctx->ms_proj_data_change_counter != ms_proj_data_change_counter )
-  {
-    msAcquireLock( TLOCK_PROJ );
-    p->proj_ctx->ms_proj_data_change_counter = ms_proj_data_change_counter;
-    {
-        if( ms_proj_data )
-        {
-            int num_tokens = 0;
-#ifdef _WIN32
-            char sep = ';';
-#else
-            char sep = ':';
-#endif
-            char** paths = msStringSplit(ms_proj_data, sep, &num_tokens);
-            proj_context_set_search_paths(p->proj_ctx->proj_ctx, num_tokens,
-                                          (const char* const*)paths);
-            msFreeCharArray(paths, num_tokens);
-        }
-        else
-        {
-            proj_context_set_search_paths(p->proj_ctx->proj_ctx, 0, NULL);
-        }
-    }
-    msReleaseLock( TLOCK_PROJ );
-  }
-#endif
-
-  if (strncasecmp(p->args[0], "AUTO:", 5) == 0 ||
-      strncasecmp(p->args[0], "AUTO2:", 6) == 0) {
-    /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
-    /*WMS 1.3.0: AUTO2:auto_crs_id,factor,lon0,lat0*/
-    return _msProcessAutoProjection(p);
-  }
-
-#if PROJ_VERSION_MAJOR >= 6
-  if( p->numargs == 1 && strncmp(p->args[0], "init=", 5) != 0 )
-  {
-      /* Deal e.g. with EPSG:XXXX or ESRI:XXXX */
-      if( !(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, p->numargs, p->args)) ) {
-          int l_pj_errno = proj_context_errno (p->proj_ctx->proj_ctx);
-          msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-                     "msProcessProjection()", proj_errno_string(l_pj_errno), p->args[0]) ;
-          return(-1);
-      }
-  }
-  else
-  {
-      char** args = (char**)msSmallMalloc(sizeof(char*) * (p->numargs+1));
-      memcpy(args, p->args, sizeof(char*) * p->numargs);
-
-#if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR < 2
-      /* PROJ lookups are faster with EPSG in uppercase. Fixed in PROJ 6.2 */
-      /* Do that only for those versions, as it can create confusion if using */
-      /* a real old-style 'epsg' file... */
-      char szTemp[24];
-      if( p->numargs && strncmp(args[0], "init=epsg:", strlen("init=epsg:")) == 0 &&
-          strlen(args[0]) < 24)
-      {
-          strcpy(szTemp, "init=EPSG:");
-          strcat(szTemp, args[0] + strlen("init=epsg:"));
-          args[0] = szTemp;
-      }
-#endif
-
-      args[p->numargs] = (char*) "type=crs";
-#if 0
-      for( int i = 0; i <  p->numargs + 1; i++ )
-          fprintf(stderr, "%s ", args[i]);
-      fprintf(stderr, "\n");
-#endif
-      if( !(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, p->numargs + 1, args)) ) {
-          int l_pj_errno = proj_context_errno (p->proj_ctx->proj_ctx);
-          if(p->numargs>1) {
-            msSetError(MS_PROJERR, "proj error \"%s\" for \"%s:%s\"",
-                        "msProcessProjection()", proj_errno_string(l_pj_errno), p->args[0],p->args[1]) ;
-          } else {
-            msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-                        "msProcessProjection()", proj_errno_string(l_pj_errno), p->args[0]) ;
-          }
-          free(args);
-          return(-1);
-      }
-      free(args);
-  }
-#else
-  msAcquireLock( TLOCK_PROJ );
-#if PJ_VERSION < 480
-  if( !(p->proj = pj_init(p->numargs, p->args)) ) {
-#else
-  p->proj_ctx = pj_ctx_alloc();
-  if( !(p->proj=pj_init_ctx(p->proj_ctx, p->numargs, p->args)) ) {
-#endif
-
-    int *pj_errno_ref = pj_get_errno_ref();
-    msReleaseLock( TLOCK_PROJ );
-    if(p->numargs>1) {
-      msSetError(MS_PROJERR, "proj error \"%s\" for \"%s:%s\"",
-                 "msProcessProjection()", pj_strerrno(*pj_errno_ref), p->args[0],p->args[1]) ;
-    } else {
-      msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-                 "msProcessProjection()", pj_strerrno(*pj_errno_ref), p->args[0]) ;
-    }
-    return(-1);
-  }
-
-  msReleaseLock( TLOCK_PROJ );
-#endif
-
-#ifdef USE_PROJ_FASTPATHS
-  if(strcasestr(p->args[0],"epsg:4326")) {
-    p->wellknownprojection = wkp_lonlat;
-  } else if(strcasestr(p->args[0],"epsg:3857")) {
-    p->wellknownprojection = wkp_gmerc;
-  } else {
-    p->wellknownprojection = wkp_none;
-  }
-#endif
-
-
-  return(0);
-}
-
-/************************************************************************/
-/*                           int msIsAxisInverted                       */
-/*      Check to see if we should invert the axis.                       */
-/*                                                                      */
-/************************************************************************/
-int msIsAxisInverted(int epsg_code)
-{
-  if( epsg_code < 0 )
-    return MS_FALSE;
-  const unsigned int row = epsg_code / 8;
-  const unsigned char index = epsg_code % 8;
-
-  /*check the static table*/
-  if ((row < sizeof(axisOrientationEpsgCodes)) && (axisOrientationEpsgCodes[row] & (1 << index)))
-    return MS_TRUE;
-  else
-    return MS_FALSE;
-}
-
-/************************************************************************/
-/*                           msProjectPoint()                           */
-/************************************************************************/
-int msProjectPoint(projectionObj *in, projectionObj *out, pointObj *point)
-{
-    int ret;
-    reprojectionObj* reprojector = msProjectCreateReprojector(in, out);
-    if( !reprojector )
-        return MS_FAILURE;
-    ret = msProjectPointEx(reprojector, point);
-    msProjectDestroyReprojector(reprojector);
-    return ret;
-}
-
-/************************************************************************/
-/*                           msProjectPointEx()                         */
-/************************************************************************/
-int msProjectPointEx(reprojectionObj* reprojector, pointObj *point)
-{
-  projectionObj* in = reprojector->in;
-  projectionObj* out = reprojector->out;
-
-  if( in && in->gt.need_geotransform ) {
-    double x_out, y_out;
-
-    x_out = in->gt.geotransform[0]
-            + in->gt.geotransform[1] * point->x
-            + in->gt.geotransform[2] * point->y;
-    y_out = in->gt.geotransform[3]
-            + in->gt.geotransform[4] * point->x
-            + in->gt.geotransform[5] * point->y;
-
-    point->x = x_out;
-    point->y = y_out;
-  }
-
-#if PROJ_VERSION_MAJOR >= 6
-  if( reprojector->pj ) {
-    PJ_COORD c;
-    c.xyzt.x = point->x;
-    c.xyzt.y = point->y;
-    c.xyzt.z = 0;
-    c.xyzt.t = 0;
-    c = proj_trans (reprojector->pj, PJ_FWD, c);
-    if( c.xyzt.x == HUGE_VAL || c.xyzt.y == HUGE_VAL ) {
-      return MS_FAILURE;
-    }
-    point->x = c.xyzt.x;
-    point->y = c.xyzt.y;
-  }
-#else
-  if( reprojector->no_op ) {
-    /* do nothing, no transformation required */
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If we have a fully defined input coordinate system and          */
-  /*      output coordinate system, then we will use pj_transform.        */
-  /* -------------------------------------------------------------------- */
-  else if( in && in->proj && out && out->proj ) {
-    int error;
-    double  z = 0.0;
-
-    if( pj_is_latlong(in->proj) ) {
-      point->x *= DEG_TO_RAD;
-      point->y *= DEG_TO_RAD;
-    }
-
-#if PJ_VERSION < 480
-    msAcquireLock( TLOCK_PROJ );
-#endif
-    error = pj_transform( in->proj, out->proj, 1, 0,
-                          &(point->x), &(point->y), &z );
-#if PJ_VERSION < 480
-    msReleaseLock( TLOCK_PROJ );
-#endif
-
-    if( error || point->x == HUGE_VAL || point->y == HUGE_VAL ) {
-//      msSetError(MS_PROJERR,"proj says: %s","msProjectPoint()",pj_strerrno(error));
-      return MS_FAILURE;
-    }
-
-    if( pj_is_latlong(out->proj) ) {
-      point->x *= RAD_TO_DEG;
-      point->y *= RAD_TO_DEG;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise we fallback to using pj_fwd() or pj_inv() and         */
-  /*      assuming that the NULL projectionObj is supposed to be          */
-  /*      lat/long in the same datum as the other projectionObj.  This    */
-  /*      is essentially a backwards compatibility mode.                  */
-  /* -------------------------------------------------------------------- */
-  else {
-    projUV p;
-
-    p.u = point->x;
-    p.v = point->y;
-
-    if(in==NULL || in->proj==NULL) { /* input coordinates are lat/lon */
-      p.u *= DEG_TO_RAD; /* convert to radians */
-      p.v *= DEG_TO_RAD;
-      p = pj_fwd(p, out->proj);
-    } else /* if(out==NULL || out->proj==NULL) */ { /* output coordinates are lat/lon */
-      p = pj_inv(p, in->proj);
-      p.u *= RAD_TO_DEG; /* convert to decimal degrees */
-      p.v *= RAD_TO_DEG;
-    }
-
-    point->x = p.u;
-    point->y = p.v;
-    if( point->x == HUGE_VAL || point->y == HUGE_VAL ) {
-      return MS_FAILURE;
-    }
-  }
-#endif
-
-  if( out && out->gt.need_geotransform ) {
-    double x_out, y_out;
-
-    x_out = out->gt.invgeotransform[0]
-            + out->gt.invgeotransform[1] * point->x
-            + out->gt.invgeotransform[2] * point->y;
-    y_out = out->gt.invgeotransform[3]
-            + out->gt.invgeotransform[4] * point->x
-            + out->gt.invgeotransform[5] * point->y;
-
-    point->x = x_out;
-    point->y = y_out;
-  }
-
-  return(MS_SUCCESS);
-}
-
-/************************************************************************/
-/*                         msProjectGrowRect()                          */
-/************************************************************************/
-static void msProjectGrowRect(reprojectionObj* reprojector,
-                              rectObj *prj_rect,
-                              pointObj *prj_point, int *failure )
-
-{
-  if( msProjectPointEx(reprojector, prj_point) == MS_SUCCESS ) {
-      prj_rect->miny = MS_MIN(prj_rect->miny, prj_point->y);
-      prj_rect->maxy = MS_MAX(prj_rect->maxy, prj_point->y);
-      prj_rect->minx = MS_MIN(prj_rect->minx, prj_point->x);
-      prj_rect->maxx = MS_MAX(prj_rect->maxx, prj_point->x);
-  } else
-    (*failure)++;
-}
-
-/************************************************************************/
-/*                          msProjectSegment()                          */
-/*                                                                      */
-/*      Interpolate along a line segment for which one end              */
-/*      reprojects and the other end does not.  Finds the horizon.      */
-/************************************************************************/
-static int msProjectSegment( reprojectionObj* reprojector,
-                             pointObj *start, pointObj *end )
-
-{
-  pointObj testPoint, subStart, subEnd;
-
-  /* -------------------------------------------------------------------- */
-  /*      Without loss of generality we assume the first point            */
-  /*      reprojects, and the second doesn't.  If that is not the case    */
-  /*      then re-call with the points reversed.                          */
-  /* -------------------------------------------------------------------- */
-  testPoint = *start;
-  if( msProjectPointEx( reprojector, &testPoint ) == MS_FAILURE ) {
-    testPoint = *end;
-    if( msProjectPointEx( reprojector, &testPoint ) == MS_FAILURE )
-      return MS_FAILURE;
-    else
-      return msProjectSegment( reprojector, end, start );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      We will apply a binary search till we are within out            */
-  /*      tolerance.                                                      */
-  /* -------------------------------------------------------------------- */
-  subStart = *start;
-  subEnd = *end;
-
-#define TOLERANCE 0.01
-
-  while( fabs(subStart.x - subEnd.x)
-         + fabs(subStart.y - subEnd.y) > TOLERANCE ) {
-    pointObj midPoint = {0};
-
-    midPoint.x = (subStart.x + subEnd.x) * 0.5;
-    midPoint.y = (subStart.y + subEnd.y) * 0.5;
-
-    testPoint = midPoint;
-
-    if( msProjectPointEx( reprojector, &testPoint ) == MS_FAILURE ) {
-      if (midPoint.x == subEnd.x && midPoint.y == subEnd.y)
-        return MS_FAILURE; /* break infinite loop */
-
-      subEnd = midPoint;
-    }
-    else {
-      if (midPoint.x == subStart.x && midPoint.y == subStart.y)
-        return MS_FAILURE; /* break infinite loop */
-
-      subStart = midPoint;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Now reproject the end points and return.                        */
-  /* -------------------------------------------------------------------- */
-  *end = subStart;
-
-  if( msProjectPointEx( reprojector, end ) == MS_FAILURE
-      || msProjectPointEx( reprojector, start ) == MS_FAILURE )
-    return MS_FAILURE;
-  else
-    return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msProjectGetLineCuttingCase()                      */
-/************************************************************************/
-
-/* Detect projecting from north polar stereographic to longlat or EPSG:3857 */
-/* or from lonlat lon_wrap = 0 */
-#ifdef USE_GEOS
-static msLineCuttingCase msProjectGetLineCuttingCase(reprojectionObj* reprojector)
-{
-    if( reprojector->lineCuttingCase != LINE_CUTTING_UNKNOWN)
-        return reprojector->lineCuttingCase;
-
-    projectionObj *in = reprojector->in;
-    projectionObj *out = reprojector->out;
-    const double EPS = 1e-10;
-
-    if( !in->gt.need_geotransform && msProjIsGeographicCRS(in) )
-    {
-        int i;
-        for( i = 0; i < in->numargs; i++ )
-        {
-            if( strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 &&
-                atof(in->args[i] + strlen("lon_wrap=")) == 0.0 )
-            {
-                reprojector->lineCuttingCase = LINE_CUTTING_FROM_LONGLAT_WRAP0;
-
-                msInitShape(&(reprojector->splitShape));
-                reprojector->splitShape.type = MS_SHAPE_POLYGON;
-                int j;
-                for( j = -1; j <= 1; j += 2 )
-                {
-                    const double x = j * 180;
-                    pointObj p = {0}; // initialize
-                    lineObj newLine = {0,NULL};
-                    p.x = x - EPS;
-                    p.y = 90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x + EPS;
-                    p.y = 90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x + EPS;
-                    p.y = -90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x - EPS;
-                    p.y = -90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x - EPS;
-                    p.y = 90;
-                    msAddPointToLine(&newLine, &p );
-                    msAddLineDirectly(&(reprojector->splitShape), &newLine);
-                }
-
-                return reprojector->lineCuttingCase;
-            }
-        }
-    }
-
-    if( !(!in->gt.need_geotransform && !msProjIsGeographicCRS(in) &&
-            (msProjIsGeographicCRS(out) ||
-            (out->numargs == 1 && strcmp(out->args[0], "init=epsg:3857") == 0))) )
-    {
-        reprojector->lineCuttingCase = LINE_CUTTING_NONE;
-        return reprojector->lineCuttingCase;
-    }
-
-    int srcIsPolar;
-    double extremeLongEasting;
-    if( msProjIsGeographicCRS(out) )
-    {
-        pointObj p;
-        double gt3 = out->gt.need_geotransform ? out->gt.geotransform[3] : 0.0;
-        double gt4 = out->gt.need_geotransform ? out->gt.geotransform[4] : 0.0;
-        double gt5 = out->gt.need_geotransform ? out->gt.geotransform[5] : 1.0;
-        p.x = 0.0;
-        p.y = 0.0;
-        srcIsPolar =  msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
-                        fabs(gt3 + p.x * gt4 + p.y * gt5 - 90) < 1e-8;
-        extremeLongEasting = 180;
-    }
-    else
-    {
-        pointObj p1;
-        pointObj p2;
-        double gt1 = out->gt.need_geotransform ? out->gt.geotransform[1] : 1.0;
-        p1.x = 0.0;
-        p1.y = -0.1;
-        p2.x = 0.0;
-        p2.y = 0.1;
-        srcIsPolar =  msProjectPointEx(reprojector, &p1) == MS_SUCCESS &&
-                      msProjectPointEx(reprojector, &p2) == MS_SUCCESS &&
-                     fabs((p1.x - p2.x) * gt1) > 20e6;
-        extremeLongEasting = 20037508.3427892;
-    }
-    if( !srcIsPolar )
-    {
-        reprojector->lineCuttingCase = LINE_CUTTING_NONE;
-        return reprojector->lineCuttingCase;
-    }
-
-    pointObj p = {0}; // initialize
-    double invgt0 = out->gt.need_geotransform ? out->gt.invgeotransform[0] : 0.0;
-    double invgt1 = out->gt.need_geotransform ? out->gt.invgeotransform[1] : 1.0;
-    double invgt3 = out->gt.need_geotransform ? out->gt.invgeotransform[3] : 0.0;
-    double invgt4 = out->gt.need_geotransform ? out->gt.invgeotransform[4] : 0.0;
-
-    lineObj newLine = {0,NULL};
-
-    p.x = invgt0 + -extremeLongEasting * (1 - EPS) * invgt1;
-    p.y = invgt3 + -extremeLongEasting * (1 - EPS) * invgt4;
-    /* coverity[swapped_arguments] */
-    msProjectPoint(out, in, &p);
-    pointObj first = p;
-    msAddPointToLine(&newLine, &p );
-
-    p.x = invgt0 + extremeLongEasting * (1 - EPS) * invgt1;
-    p.y = invgt3 + extremeLongEasting * (1 - EPS) * invgt4;
-    /* coverity[swapped_arguments] */
-    msProjectPoint(out, in, &p);
-    msAddPointToLine(&newLine, &p );
-
-    p.x = 0;
-    p.y = 0;
-    msAddPointToLine(&newLine, &p );
-
-    msAddPointToLine(&newLine, &first );
-
-    msInitShape(&(reprojector->splitShape));
-    reprojector->splitShape.type = MS_SHAPE_POLYGON;
-    msAddLineDirectly(&(reprojector->splitShape), &newLine);
-
-    reprojector->lineCuttingCase = LINE_CUTTING_FROM_POLAR;
-    return reprojector->lineCuttingCase;
-}
-#endif
-
-/************************************************************************/
-/*                         msProjectShapeLine()                         */
-/*                                                                      */
-/*      Reproject a single linestring, potentially splitting into       */
-/*      more than one line string if there are over the horizon         */
-/*      portions.                                                       */
-/*                                                                      */
-/*      For polygons, no splitting takes place, but over the horizon    */
-/*      points are clipped, and one segment is run from the fall        */
-/*      over the horizon point to the come back over the horizon point. */
-/************************************************************************/
-
-static int
-msProjectShapeLine(reprojectionObj* reprojector,
-                   shapeObj *shape, int line_index)
-
-{
-  int i;
-  pointObj  lastPoint, thisPoint, wrkPoint;
-  lineObj *line = shape->line + line_index;
-  lineObj *line_out = line;
-  int valid_flag = 0; /* 1=true, -1=false, 0=unknown */
-  int numpoints_in = line->numpoints;
-  int line_alloc = numpoints_in;
-  int wrap_test;
-  projectionObj *in = reprojector->in;
-  projectionObj *out = reprojector->out;
-
-#ifdef USE_PROJ_FASTPATHS
-#define MAXEXTENT 20037508.34
-#define M_PIby360 .0087266462599716479
-#define MAXEXTENTby180 111319.4907777777777777777
-#define p_x line->point[i].x
-#define p_y line->point[i].y
-  if(in->wellknownprojection == wkp_lonlat && out->wellknownprojection == wkp_gmerc) {
-    for( i = line->numpoints-1; i >= 0; i-- ) {
-      p_x *= MAXEXTENTby180;
-      p_y = log(tan((90 + p_y) * M_PIby360)) * MS_RAD_TO_DEG;
-      p_y *= MAXEXTENTby180;
-      if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-      if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-      if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-      if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
-    }
-    return MS_SUCCESS;
-  }
-  if(in->wellknownprojection == wkp_gmerc && out->wellknownprojection == wkp_lonlat) {
-    for( i = line->numpoints-1; i >= 0; i-- ) {
-      if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-      else if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-      if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-      else if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
-      p_x = (p_x / MAXEXTENT) * 180;
-      p_y = (p_y / MAXEXTENT) * 180;
-      p_y = MS_RAD_TO_DEG * (2 * atan(exp(p_y * MS_DEG_TO_RAD)) - MS_PI2);
-    }
-    msComputeBounds( shape ); /* fixes bug 1586 */
-    return MS_SUCCESS;
-  }
-#undef p_x
-#undef p_y
-#endif
-
-#ifdef USE_GEOS
-  int use_splitShape = MS_FALSE;
-  int use_splitShape_check_intersects = MS_FALSE;
-  if( shape->type == MS_SHAPE_LINE &&
-      msProjectGetLineCuttingCase(reprojector) == LINE_CUTTING_FROM_POLAR )
-  {
-    use_splitShape = MS_TRUE;
-    use_splitShape_check_intersects = MS_TRUE;
-  }
-  else if( shape->type == MS_SHAPE_LINE &&
-           msProjectGetLineCuttingCase(reprojector) == LINE_CUTTING_FROM_LONGLAT_WRAP0 )
-  {
-      for( i=0; i < numpoints_in; i++ )
-      {
-          if( fabs(line->point[i].x) > 180 )
-          {
-              use_splitShape = MS_TRUE;
-              break;
-          }
-      }
-  }
-
-  if( use_splitShape )
-  {
-    shapeObj tmpShapeInputLine;
-    msInitShape(&tmpShapeInputLine);
-    tmpShapeInputLine.type = MS_SHAPE_LINE;
-    tmpShapeInputLine.numlines = 1;
-    tmpShapeInputLine.line = line;
-
-    shapeObj* diff = NULL;
-    if( use_splitShape_check_intersects == MS_FALSE ||
-        msGEOSIntersects(&tmpShapeInputLine, &(reprojector->splitShape)) )
-    {
-        diff = msGEOSDifference(&tmpShapeInputLine, &(reprojector->splitShape));
-    }
-
-    tmpShapeInputLine.numlines = 0;
-    tmpShapeInputLine.line = NULL;
-    msFreeShape(&tmpShapeInputLine);
-
-    if( diff )
-    {
-        for(int j = 0; j < diff->numlines; j++ )
-        {
-            for( i=0; i < diff->line[j].numpoints; i++ ) {
-                msProjectPointEx(reprojector, &(diff->line[j].point[i]));
-            }
-            if( j == 0 )
-            {
-                line_out->numpoints = diff->line[j].numpoints;
-                memcpy(line_out->point, diff->line[0].point, sizeof(pointObj) * line_out->numpoints);
-            }
-            else
-            {
-                msAddLineDirectly(shape, &(diff->line[j]));
-            }
-        }
-        msFreeShape(diff);
-        msFree(diff);
-        return MS_SUCCESS;
-    }
-  }
-#endif
-
-  wrap_test = out != NULL && out->proj != NULL && msProjIsGeographicCRS(out)
-              && !msProjIsGeographicCRS(in);
-
-  line->numpoints = 0;
-
-  memset( &lastPoint, 0, sizeof(lastPoint) );
-
-  /* -------------------------------------------------------------------- */
-  /*      Loop over all input points in linestring.                       */
-  /* -------------------------------------------------------------------- */
-  for( i=0; i < numpoints_in; i++ ) {
-    int ms_err;
-    wrkPoint = thisPoint = line->point[i];
-
-    ms_err = msProjectPointEx(reprojector, &wrkPoint );
-
-    /* -------------------------------------------------------------------- */
-    /*      Apply wrap logic.                                               */
-    /* -------------------------------------------------------------------- */
-    if( wrap_test && i > 0 && ms_err != MS_FAILURE ) {
-      double dist;
-      pointObj pt1Geo;
-
-      if( line_out->numpoints > 0 )
-        pt1Geo = line_out->point[line_out->numpoints-1];
-      else
-        pt1Geo = wrkPoint; /* this is a cop out */
-
-      if( out->gt.need_geotransform && out->gt.geotransform[2] == 0 ) {
-        dist = out->gt.geotransform[1] * (wrkPoint.x - pt1Geo.x);
-      } else {
-        dist = wrkPoint.x - pt1Geo.x;
-      }
-
-      if( fabs(dist) > 180.0
-          && msTestNeedWrap( thisPoint, lastPoint,
-                             pt1Geo, reprojector ) ) {
-        if( out->gt.need_geotransform && out->gt.geotransform[2] == 0 ) {
-          if( dist > 0.0 )
-            wrkPoint.x -= 360.0 * out->gt.invgeotransform[1];
-          else if( dist < 0.0 )
-            wrkPoint.x += 360.0 * out->gt.invgeotransform[1];
-        }
-        else {
-          if( dist > 0.0 )
-            wrkPoint.x -= 360.0;
-          else if( dist < 0.0 )
-            wrkPoint.x += 360.0;
-        }
-      }
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Put result into output line with appropriate logic for          */
-    /*      failure breaking lines, etc.                                    */
-    /* -------------------------------------------------------------------- */
-    if( ms_err == MS_FAILURE ) {
-      /* We have started out invalid */
-      if( i == 0 ) {
-        valid_flag = -1;
-      }
-
-      /* valid data has ended, we need to work out the horizon */
-      else if( valid_flag == 1 ) {
-        pointObj startPoint, endPoint;
-
-        startPoint = lastPoint;
-        endPoint = thisPoint;
-        if( msProjectSegment( reprojector, &startPoint, &endPoint )
-            == MS_SUCCESS ) {
-          line_out->point[line_out->numpoints++] = endPoint;
-        }
-        valid_flag = -1;
-      }
-
-      /* Still invalid ... */
-      else if( valid_flag == -1 ) {
-        /* do nothing */
-      }
-    }
-
-    else {
-      /* starting out valid. */
-      if( i == 0 ) {
-        line_out->point[line_out->numpoints++] = wrkPoint;
-        valid_flag = 1;
-      }
-
-      /* Still valid, nothing special */
-      else if( valid_flag == 1 ) {
-        line_out->point[line_out->numpoints++] = wrkPoint;
-      }
-
-      /* we have come over the horizon, figure out where, start newline*/
-      else {
-        pointObj startPoint, endPoint;
-
-        startPoint = lastPoint;
-        endPoint = thisPoint;
-        if( msProjectSegment( reprojector, &endPoint, &startPoint )
-            == MS_SUCCESS ) {
-          lineObj newLine;
-
-          /* force pre-allocation of lots of points room */
-          if( line_out->numpoints > 0
-              && shape->type == MS_SHAPE_LINE ) {
-            newLine.numpoints = numpoints_in - i + 1;
-            newLine.point = line->point;
-            msAddLine( shape, &newLine );
-
-            /* new line is now lineout, but start without any points */
-            line_out = shape->line + shape->numlines-1;
-
-            line_out->numpoints = 0;
-
-            /* the shape->line array is realloc, refetch "line" */
-            line = shape->line + line_index;
-          } else if( line_out == line
-                     && line->numpoints >= i-2 ) {
-            newLine.numpoints = numpoints_in;
-            newLine.point = line->point;
-            msAddLine( shape, &newLine );
-
-            line = shape->line + line_index;
-
-            line_out = shape->line + shape->numlines-1;
-            line_out->numpoints = line->numpoints;
-            line->numpoints = 0;
-
-            /*
-             * Now realloc this array large enough to hold all
-             * the points we could possibly need to add.
-             */
-            line_alloc = line_alloc * 2;
-
-            line_out->point = (pointObj *)
-                              realloc(line_out->point,
-                                      sizeof(pointObj) * line_alloc);
-          }
-
-          line_out->point[line_out->numpoints++] = startPoint;
-        }
-        line_out->point[line_out->numpoints++] = wrkPoint;
-        valid_flag = 1;
-      }
-    }
-
-    lastPoint = thisPoint;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Make sure that polygons are closed, even if the trip over       */
-  /*      the horizon left them unclosed.                                 */
-  /* -------------------------------------------------------------------- */
-  if( shape->type == MS_SHAPE_POLYGON
-      && line_out->numpoints > 2
-      && (line_out->point[0].x != line_out->point[line_out->numpoints-1].x
-          || line_out->point[0].y != line_out->point[line_out->numpoints-1].y) ) {
-    /* make a copy because msAddPointToLine can realloc the array */
-    pointObj sFirstPoint = line_out->point[0];
-    msAddPointToLine( line_out, &sFirstPoint );
-  }
-
-  return(MS_SUCCESS);
-}
-
-/************************************************************************/
-/*                           msProjectShape()                           */
-/************************************************************************/
-int msProjectShape(projectionObj *in, projectionObj *out, shapeObj *shape)
-{
-    int ret;
-    reprojectionObj* reprojector = msProjectCreateReprojector(in, out);
-    if( !reprojector )
-        return MS_FAILURE;
-    ret = msProjectShapeEx(reprojector, shape);
-    msProjectDestroyReprojector(reprojector);
-    return ret;
-}
-
-/************************************************************************/
-/*                          msProjectShapeEx()                          */
-/************************************************************************/
-int msProjectShapeEx(reprojectionObj* reprojector, shapeObj *shape)
-{
-  int i;
-#ifdef USE_PROJ_FASTPATHS
-  int j;
-
-#define p_x shape->line[i].point[j].x
-#define p_y shape->line[i].point[j].y
-  if(in->wellknownprojection == wkp_lonlat && out->wellknownprojection == wkp_gmerc) {
-    for( i = shape->numlines-1; i >= 0; i-- ) {
-      for( j = shape->line[i].numpoints-1; j >= 0; j-- ) {
-        p_x *= MAXEXTENTby180;
-        p_y = log(tan((90 + p_y) * M_PIby360)) * MS_RAD_TO_DEG;
-        p_y *= MAXEXTENTby180;
-        if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-        else if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-        if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-        else if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
-      }
-    }
-    msComputeBounds( shape ); /* fixes bug 1586 */
-    return MS_SUCCESS;
-  }
-  if(in->wellknownprojection == wkp_gmerc && out->wellknownprojection == wkp_lonlat) {
-    for( i = shape->numlines-1; i >= 0; i-- ) {
-      for( j = shape->line[i].numpoints-1; j >= 0; j-- ) {
-        if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-        else if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-        if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-        else if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
-        p_x = (p_x / MAXEXTENT) * 180;
-        p_y = (p_y / MAXEXTENT) * 180;
-        p_y = MS_RAD_TO_DEG * (2 * atan(exp(p_y * MS_DEG_TO_RAD)) - MS_PI2);
-      }
-    }
-    msComputeBounds( shape ); /* fixes bug 1586 */
-    return MS_SUCCESS;
-  }
-#undef p_x
-#undef p_y
-#endif
-
-  if (shape->numlines == 0) {
-      // don't attempt to project any NULL geometries
-      // but if we want to return the record's attributes we won't free the shape
-      // and throw an error
-      shape->type = MS_SHAPE_NULL;
-      return MS_SUCCESS;
-  } else {
-    for( i = shape->numlines-1; i >= 0; i-- ) {
-      if( shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON ) {
-        if( msProjectShapeLine( reprojector, shape, i ) == MS_FAILURE )
-          msShapeDeleteLine( shape, i );
-      } else if( msProjectLineEx(reprojector, shape->line+i ) == MS_FAILURE ) {
-        msShapeDeleteLine( shape, i );
-      }
-    }
-
-    if ( shape->numlines == 0 ) {
-        msFreeShape(shape);
-        return MS_FAILURE;
-    }
-    else {
-        msComputeBounds(shape); /* fixes bug 1586 */
-        return(MS_SUCCESS);
-    }
-  }
-}
-
-/************************************************************************/
-/*                           msProjectLine()                            */
-/************************************************************************/
-int msProjectLine(projectionObj *in, projectionObj *out, lineObj *line)
-{
-    int ret;
-    reprojectionObj* reprojector = msProjectCreateReprojector(in, out);
-    if( !reprojector )
-        return MS_FAILURE;
-    ret = msProjectLineEx(reprojector, line);
-    msProjectDestroyReprojector(reprojector);
-    return ret;
-}
-
-/************************************************************************/
-/*                         msProjectLineEx()                            */
-/*                                                                      */
-/*      This function is now normally only used for point data.         */
-/*      msProjectShapeLine() is used for lines and polygons and has     */
-/*      lots of logic to handle horizon crossing.                       */
-/************************************************************************/
-
-int msProjectLineEx(reprojectionObj* reprojector, lineObj *line)
-{
-  int be_careful = reprojector->out->proj != NULL &&
-                 msProjIsGeographicCRS(reprojector->out)
-                 && !msProjIsGeographicCRS(reprojector->in);
-
-  if( be_careful ) {
-    pointObj  startPoint, thisPoint; /* locations in projected space */
-
-    startPoint = line->point[0];
-
-    for(int i=0; i<line->numpoints; i++) {
-      double  dist;
-
-      thisPoint = line->point[i];
-
-      /*
-      ** Read comments before msTestNeedWrap() to better understand
-      ** this dateline wrapping logic.
-      */
-      msProjectPointEx(reprojector, &(line->point[i]));
-      if( i > 0 ) {
-        dist = line->point[i].x - line->point[0].x;
-        if( fabs(dist) > 180.0 ) {
-          if( msTestNeedWrap( thisPoint, startPoint,
-                              line->point[0], reprojector ) ) {
-            if( dist > 0.0 ) {
-              line->point[i].x -= 360.0;
-            } else if( dist < 0.0 ) {
-              line->point[i].x += 360.0;
-            }
-          }
-        }
-
-      }
-    }
-  } else {
-    for(int i=0; i<line->numpoints; i++) {
-      if( msProjectPointEx(reprojector, &(line->point[i])) == MS_FAILURE )
-        return MS_FAILURE;
-    }
-  }
-
-  return(MS_SUCCESS);
-}
-
-/************************************************************************/
-/*                           msProjectRectGrid()                        */
-/************************************************************************/
-
-#define NUMBER_OF_SAMPLE_POINTS 100
-
-static
-int msProjectRectGrid(reprojectionObj* reprojector, rectObj *rect)
-{
-  pointObj prj_point;
-  rectObj prj_rect;
-  int     failure=0;
-  int     ix, iy;
-
-  double dx, dy;
-  double x, y;
-
-  prj_rect.minx = DBL_MAX;
-  prj_rect.miny = DBL_MAX;
-  prj_rect.maxx = -DBL_MAX;
-  prj_rect.maxy = -DBL_MAX;
-
-  dx = (rect->maxx - rect->minx)/NUMBER_OF_SAMPLE_POINTS;
-  dy = (rect->maxy - rect->miny)/NUMBER_OF_SAMPLE_POINTS;
-
-  /* first ensure the top left corner is processed, even if the rect
-     turns out to be degenerate. */
-
-  prj_point.x = rect->minx;
-  prj_point.y = rect->miny;
-  prj_point.z = 0.0;
-  prj_point.m = 0.0;
-
-  msProjectGrowRect(reprojector,&prj_rect,&prj_point,
-                    &failure);
-
-  failure = 0;
-  for(ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++ ) {
-    x = rect->minx + ix * dx;
-
-    for(iy = 0; iy <= NUMBER_OF_SAMPLE_POINTS; iy++ ) {
-      y = rect->miny + iy * dy;
-
-      prj_point.x = x;
-      prj_point.y = y;
-      msProjectGrowRect(reprojector,&prj_rect,&prj_point,
-                        &failure);
-    }
-  }
-
-  if( prj_rect.minx > prj_rect.maxx ) {
-    rect->minx = 0;
-    rect->maxx = 0;
-    rect->miny = 0;
-    rect->maxy = 0;
-
-    msSetError(MS_PROJERR, "All points failed to reproject.", "msProjectRect()");
-    return MS_FAILURE;
-  }
-
-  if( failure ) {
-      msDebug( "msProjectRect(): some points failed to reproject, doing internal sampling.\n" );
-  }
-
-  rect->minx = prj_rect.minx;
-  rect->miny = prj_rect.miny;
-  rect->maxx = prj_rect.maxx;
-  rect->maxy = prj_rect.maxy;
-
-  return(MS_SUCCESS);
-}
-
-/************************************************************************/
-/*                       msProjectRectAsPolygon()                       */
-/************************************************************************/
-
-int msProjectRectAsPolygon(reprojectionObj* reprojector, rectObj *rect)
-{
-  shapeObj polygonObj;
-  lineObj  ring;
-  /*  pointObj ringPoints[NUMBER_OF_SAMPLE_POINTS*4+4]; */
-  pointObj *ringPoints;
-  int     ix, iy, ixy;
-
-  double dx, dy;
-
-  /* If projecting from longlat to projected */
-  /* This hack was introduced for WFS 2.0 compliance testing, but is far */
-  /* from being perfect */
-  if( reprojector->out && !msProjIsGeographicCRS(reprojector->out) &&
-      reprojector->in && msProjIsGeographicCRS(reprojector->in) &&
-      fabs(rect->minx - -180.0) < 1e-5 && fabs(rect->miny - -90.0) < 1e-5 &&
-      fabs(rect->maxx - 180.0) < 1e-5 && fabs(rect->maxy - 90.0) < 1e-5) {
-    pointObj pointTest;
-    pointTest.x = -180;
-    pointTest.y = 85;
-    msProjectPointEx(reprojector, &pointTest);
-    /* Detect if we are reprojecting from EPSG:4326 to EPSG:3857 */
-    /* and if so use more plausible bounds to avoid issues with computed */
-    /* resolution for WCS */
-    if (fabs(pointTest.x - -20037508.3427892) < 1e-5 && fabs(pointTest.y - 19971868.8804086) )
-    {
-        rect->minx = -20037508.3427892;
-        rect->miny = -20037508.3427892;
-        rect->maxx = 20037508.3427892;
-        rect->maxy = 20037508.3427892;
-    }
-    else
-    {
-        rect->minx = -1e15;
-        rect->miny = -1e15;
-        rect->maxx = 1e15;
-        rect->maxy = 1e15;
-    }
-    return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Build polygon as steps around the source rectangle              */
-  /*      and possibly its diagonal.                                      */
-  /* -------------------------------------------------------------------- */
-  dx = (rect->maxx - rect->minx)/NUMBER_OF_SAMPLE_POINTS;
-  dy = (rect->maxy - rect->miny)/NUMBER_OF_SAMPLE_POINTS;
-
-  if(dx==0 && dy==0) {
-    pointObj foo;
-    msDebug( "msProjectRect(): Warning: degenerate rect {%f,%f,%f,%f}\n",rect->minx,rect->miny,rect->minx,rect->miny );
-    foo.x = rect->minx;
-    foo.y = rect->miny;
-    msProjectPointEx(reprojector,&foo);
-    rect->minx=rect->maxx=foo.x;
-    rect->miny=rect->maxy=foo.y;
-    return MS_SUCCESS;
-  }
-  
-  /* If there is more than two sample points we will also get samples from the diagonal line */
-  ringPoints = (pointObj*) calloc(sizeof(pointObj),NUMBER_OF_SAMPLE_POINTS*5+3);
-  ring.point = ringPoints;
-  ring.numpoints = 0;
-
-  msInitShape( &polygonObj );
-  polygonObj.type = MS_SHAPE_POLYGON;
-
-  /* sample along top */
-  if(dx != 0) {
-    for(ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++ ) {
-      ringPoints[ring.numpoints].x = rect->minx + ix * dx;
-      ringPoints[ring.numpoints++].y = rect->miny;
-    }
-  }
-
-  /* sample along right side */
-  if(dy != 0) {
-    for(iy = 1; iy <= NUMBER_OF_SAMPLE_POINTS; iy++ ) {
-      ringPoints[ring.numpoints].x = rect->maxx;
-      ringPoints[ring.numpoints++].y = rect->miny + iy * dy;
-    }
-  }
-
-  /* sample along bottom */
-  if(dx != 0) {
-    for(ix = NUMBER_OF_SAMPLE_POINTS-1; ix >= 0; ix-- ) {
-      ringPoints[ring.numpoints].x = rect->minx + ix * dx;
-      ringPoints[ring.numpoints++].y = rect->maxy;
-    }
-  }
-
-  /* sample along left side */
-  if(dy != 0) {
-    for(iy = NUMBER_OF_SAMPLE_POINTS-1; iy >= 0; iy-- ) {
-      ringPoints[ring.numpoints].x = rect->minx;
-      ringPoints[ring.numpoints++].y = rect->miny + iy * dy;
-    }
-  }
-
-  /* sample along diagonal line */
-  /* This is done to handle cases where reprojection from world covering projection to one */
-  /* which isn't could cause min and max values of the projected rectangle to be invalid */
-  if(dy != 0 && dx != 0) {
-    /* No need to compute corners as they've already been computed */
-    for(ixy = NUMBER_OF_SAMPLE_POINTS-2; ixy >= 1; ixy-- ) {
-      ringPoints[ring.numpoints].x = rect->minx + ixy * dx;
-      ringPoints[ring.numpoints++].y = rect->miny + ixy * dy;
-    }
-  }
-
-  msAddLineDirectly( &polygonObj, &ring );
-
-#ifdef notdef
-  FILE *wkt = fopen("/tmp/www-before.wkt","w");
-  char *tmp = msShapeToWKT(&polygonObj);
-  fprintf(wkt,"%s\n", tmp);
-  free(tmp);
-  fclose(wkt);
-#endif
-
-  /* -------------------------------------------------------------------- */
-  /*      Attempt to reproject.                                           */
-  /* -------------------------------------------------------------------- */
-  msProjectShapeLine( reprojector, &polygonObj, 0 );
-
-  /* If no points reprojected, try a grid sampling */
-  if( polygonObj.numlines == 0 || polygonObj.line[0].numpoints == 0 ) {
-    msFreeShape( &polygonObj );
-    return msProjectRectGrid( reprojector, rect );
-  }
-
-#ifdef notdef
-  wkt = fopen("/tmp/www-after.wkt","w");
-  tmp = msShapeToWKT(&polygonObj);
-  fprintf(wkt,"%s\n", tmp);
-  free(tmp);
-  fclose(wkt);
-#endif
-
-  /* -------------------------------------------------------------------- */
-  /*      Collect bounds.                                                 */
-  /* -------------------------------------------------------------------- */
-  rect->minx = rect->maxx = polygonObj.line[0].point[0].x;
-  rect->miny = rect->maxy = polygonObj.line[0].point[0].y;
-
-  for( ix = 1; ix < polygonObj.line[0].numpoints; ix++ ) {
-    pointObj  *pnt = polygonObj.line[0].point + ix;
-
-    rect->minx = MS_MIN(rect->minx,pnt->x);
-    rect->maxx = MS_MAX(rect->maxx,pnt->x);
-    rect->miny = MS_MIN(rect->miny,pnt->y);
-    rect->maxy = MS_MAX(rect->maxy,pnt->y);
-  }
-
-  msFreeShape( &polygonObj );
-
-  /* -------------------------------------------------------------------- */
-  /*      Special case to handle reprojection from "more than the         */
-  /*      whole world" projected coordinates that sometimes produce a     */
-  /*      region greater than 360 degrees wide due to various wrapping    */
-  /*      logic.                                                          */
-  /* -------------------------------------------------------------------- */
-  if( reprojector->out && msProjIsGeographicCRS(reprojector->out) &&
-      reprojector->in && !msProjIsGeographicCRS(reprojector->in)
-      && rect->maxx - rect->minx > 360.0 &&
-      !reprojector->out->gt.need_geotransform ) {
-    rect->maxx = 180;
-    rect->minx = -180;
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                        msProjectHasLonWrap()                         */
-/************************************************************************/
-
-int msProjectHasLonWrap(projectionObj *in, double* pdfLonWrap)
-{
-    int i;
-    if( pdfLonWrap )
-        *pdfLonWrap = 0;
-
-    if( !msProjIsGeographicCRS(in) )
-        return MS_FALSE;
-
-    for( i = 0; i < in->numargs; i++ )
-    {
-        if( strncmp(in->args[i], "lon_wrap=",
-                    strlen("lon_wrap=")) == 0 )
-        {
-            if( pdfLonWrap )
-                *pdfLonWrap = atof(in->args[i] + strlen("lon_wrap="));
-            return MS_TRUE;
-        }
-    }
-    return MS_FALSE;
-}
-
-/************************************************************************/
-/*                           msProjectRect()                            */
-/************************************************************************/
-
-int msProjectRect(projectionObj *in, projectionObj *out, rectObj *rect)
-{
-  char *over = "+over";
-  int ret;
-  int bFreeInOver = MS_FALSE;
-  int bFreeOutOver = MS_FALSE;
-  projectionObj in_over,out_over,*inp,*outp;
-  double dfLonWrap = 0.0;
-  reprojectionObj* reprojector = NULL;
-
-  /* Detect projecting from polar stereographic to longlat */
-  if( in && !in->gt.need_geotransform &&
-      out && !out->gt.need_geotransform &&
-      !msProjIsGeographicCRS(in) && msProjIsGeographicCRS(out) )
-  {
-      reprojector = msProjectCreateReprojector(in, out);
-      for( int sign = 1; sign >= -1; sign -= 2 )
-      {
-          pointObj p;
-          p.x = 0.0;
-          p.y = 0.0;
-          if( reprojector &&
-              msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
-              fabs(p.y - sign * 90) < 1e-8 )
-          {
-            /* Is the pole in the rectangle ? */
-            if( 0 >= rect->minx && 0 >= rect->miny &&
-                0 <= rect->maxx && 0 <= rect->maxy )
-            {
-                if( msProjectRectAsPolygon(reprojector, rect ) == MS_SUCCESS )
-                {
-                    rect->minx = -180.0;
-                    rect->maxx = 180.0;
-                    rect->maxy = sign * 90.0;
-                    msProjectDestroyReprojector(reprojector);
-                    return MS_SUCCESS;
-                }
-            }
-            /* Are we sure the dateline is not enclosed ? */
-            else if( rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0 )
-            {
-                ret = msProjectRectAsPolygon(reprojector, rect );
-                msProjectDestroyReprojector(reprojector);
-                return ret;
-            }
-          }
-      }
-  }
-
-  /* Detect projecting from polar stereographic to another projected system */
-  else if( in && !in->gt.need_geotransform &&
-      out && !out->gt.need_geotransform &&
-      !msProjIsGeographicCRS(in) && !msProjIsGeographicCRS(out) )
-  {
-      reprojectionObj* reprojectorToLongLat = msProjectCreateReprojector(in, NULL);
-      for( int sign = 1; sign >= -1; sign -= 2 )
-      {
-          pointObj p;
-          p.x = 0.0;
-          p.y = 0.0;
-          if( reprojectorToLongLat &&
-              msProjectPointEx(reprojectorToLongLat, &p) == MS_SUCCESS &&
-              fabs(p.y - 90) < 1e-8 )
-          {
-            reprojector = msProjectCreateReprojector(in, out);
-            /* Is the pole in the rectangle ? */
-            if( 0 >= rect->minx && 0 >= rect->miny &&
-                0 <= rect->maxx && 0 <= rect->maxy )
-            {
-                if( msProjectRectAsPolygon(reprojector, rect ) == MS_SUCCESS )
-                {
-                    msProjectDestroyReprojector(reprojector);
-                    msProjectDestroyReprojector(reprojectorToLongLat);
-                    return MS_SUCCESS;
-                }
-            }
-            /* Are we sure the dateline is not enclosed ? */
-            else if( rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0 )
-            {
-                ret = msProjectRectAsPolygon(reprojector, rect );
-                msProjectDestroyReprojector(reprojector);
-                msProjectDestroyReprojector(reprojectorToLongLat);
-                return ret;
-            }
-          }
-      }
-      msProjectDestroyReprojector(reprojectorToLongLat);
-  }
-
-
-  if(in && msProjectHasLonWrap(in, &dfLonWrap) && dfLonWrap == 180.0) {
-    inp = in;
-    outp = out;
-    if( rect->maxx > 180.0 ) {
-      rect->minx = -180.0;
-      rect->maxx = 180.0;
-    }
-  }
-  /* 
-   * Issue #4892: When projecting a rectangle we do not want proj to wrap resulting
-   * coordinates around the dateline, as in practice a requested bounding box of
-   * -22.000.000, -YYY, 22.000.000, YYY should be projected as
-   * -190,-YYY,190,YYY rather than 170,-YYY,-170,YYY as would happen when wrapping (and
-   *  vice-versa when projecting from lonlat to metric).
-   *  To enforce this, we clone the input projections and add the "+over" proj 
-   *  parameter in order to disable dateline wrapping.
-   */ 
-  else {
-    int apply_over = MS_TRUE;
-#if PROJ_VERSION_MAJOR >= 6 && PROJ_VERSION_MAJOR < 9
-    // Workaround PROJ [6,9[ bug (fixed per https://github.com/OSGeo/PROJ/pull/3055)
-    // that prevents datum shifts from being applied when +over is added to +init=epsg:XXXX
-    // This is far from being bullet proof but it should work for most common use cases
-    if(in && in->proj)
-    {
-        if( in->numargs == 1 && EQUAL(in->args[0], "init=epsg:4326") &&
-            rect->minx >= -180 && rect->maxx <= 180 )
-        {
-            apply_over = MS_FALSE;
-        }
-        else if( in->numargs == 1 && EQUAL(in->args[0], "init=epsg:3857") &&
-                 rect->minx >= -20037508.3427892 && rect->maxx <= 20037508.3427892 )
-        {
-            apply_over = MS_FALSE;
-        }
-    }
-#endif
-    if(out && apply_over && out->numargs > 0 &&
-        (strncmp(out->args[0], "init=", 5) == 0 || strncmp(out->args[0], "proj=", 5) == 0)) {
-      bFreeOutOver = MS_TRUE;
-      msInitProjection(&out_over);
-      msCopyProjectionExtended(&out_over,out,&over,1);
-      outp = &out_over;
-      if( reprojector ) {
-          msProjectDestroyReprojector(reprojector);
-          reprojector = NULL;
-      }
-    } else {
-      outp = out;
-    }
-    if(in && apply_over && in->numargs > 0 &&
-        (strncmp(in->args[0], "init=", 5) == 0 || strncmp(in->args[0], "proj=", 5) == 0)) {
-      bFreeInOver = MS_TRUE;
-      msInitProjection(&in_over);
-      msCopyProjectionExtended(&in_over,in,&over,1);
-      inp = &in_over;
-      /* coverity[dead_error_begin] */
-      if( reprojector ) {
-          msProjectDestroyReprojector(reprojector);
-          reprojector = NULL;
-      }
-    } else {
-      inp = in;
-    }
-  }
-  if( reprojector == NULL )
-  {
-     reprojector = msProjectCreateReprojector(inp, outp);
-  }
-  ret = reprojector ? msProjectRectAsPolygon(reprojector, rect ) : MS_FAILURE;
-  msProjectDestroyReprojector(reprojector);
-  if(bFreeInOver)
-    msFreeProjection(&in_over);
-  if(bFreeOutOver)
-    msFreeProjection(&out_over);
-  return ret;
-}
-
-#if PROJ_VERSION_MAJOR < 6
-
-static int msProjectSortString(const void* firstelt, const void* secondelt)
-{
-    char* firststr = *(char**)firstelt;
-    char* secondstr = *(char**)secondelt;
-    return strcmp(firststr, secondstr);
-}
-
-/************************************************************************/
-/*                        msGetProjectNormalized()                      */
-/************************************************************************/
-
-static projectionObj* msGetProjectNormalized( const projectionObj* p )
-{
-  int i;
-#if PROJ_VERSION_MAJOR >= 6
-  const char* pszNewProj4Def;
-#else
-  char* pszNewProj4Def;
-#endif
-  projectionObj* pnew;
-
-  pnew = (projectionObj*)msSmallMalloc(sizeof(projectionObj));
-  msInitProjection(pnew);
-  msCopyProjection(pnew, (projectionObj*)p);
-
-  if(p->proj == NULL )
-      return pnew;
-
-  /* Normalize definition so that msProjectDiffers() works better */
-#if PROJ_VERSION_MAJOR >= 6
-  pszNewProj4Def = proj_as_proj_string(p->proj_ctx->proj_ctx, p->proj, PJ_PROJ_4, NULL);
-#else
-  pszNewProj4Def = pj_get_def( p->proj, 0 );
-#endif
-  msFreeCharArray(pnew->args, pnew->numargs);
-  pnew->args = msStringSplit(pszNewProj4Def,'+', &pnew->numargs);
-  for(i = 0; i < pnew->numargs; i++)
-  {
-      /* Remove trailing space */
-      if( strlen(pnew->args[i]) > 0 && pnew->args[i][strlen(pnew->args[i])-1] == ' ' )
-          pnew->args[i][strlen(pnew->args[i])-1] = '\0';
-      /* Remove spurious no_defs or init= */
-      if( strcmp(pnew->args[i], "no_defs") == 0 ||
-          strncmp(pnew->args[i], "init=", 5) == 0 )
-      {
-          if( i < pnew->numargs - 1 )
-          {
-              msFree(pnew->args[i]);
-              memmove(pnew->args + i, pnew->args + i + 1,
-                      sizeof(char*) * (pnew->numargs - 1 -i ));
-          }
-          else 
-          {
-              msFree(pnew->args[i]);
-          }
-          pnew->numargs --;
-          i --;
-          continue;
-      }
-  }
-  /* Sort the strings so they can be compared */
-  qsort(pnew->args, pnew->numargs, sizeof(char*), msProjectSortString);
-  /*{
-      fprintf(stderr, "'%s' =\n", pszNewProj4Def);
-      for(i = 0; i < p->numargs; i++)
-          fprintf(stderr, "'%s' ", p->args[i]);
-      fprintf(stderr, "\n");
-  }*/
-#if PROJ_VERSION_MAJOR < 6
-  pj_dalloc(pszNewProj4Def);
-#endif
-
-  return pnew;
-}
-#endif
-
-/************************************************************************/
-/*                        msProjectionsDiffer()                         */
-/************************************************************************/
-
-/*
-** Compare two projections, and return MS_TRUE if they differ.
-**
-** For now this is implemented by exact comparison of the projection
-** arguments, but eventually this should call a PROJ.4 function with
-** more awareness of the issues.
-**
-** NOTE: MS_FALSE is returned if either of the projection objects
-** has no arguments, since reprojection won't work anyways.
-*/
-
-static int msProjectionsDifferInternal( projectionObj *proj1, projectionObj *proj2 )
-
-{
-  int   i;
-
-  if( proj1->numargs == 0 || proj2->numargs == 0 )
-    return MS_FALSE;
-
-  if( proj1->numargs != proj2->numargs )
-    return MS_TRUE;
-
-  /* This test should be more rigerous. */
-  if( proj1->gt.need_geotransform
-      || proj2->gt.need_geotransform )
-    return MS_TRUE;
-
-  for( i = 0; i < proj1->numargs; i++ ) {
-    if( strcmp(proj1->args[i],proj2->args[i]) != 0 )
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-int msProjectionsDiffer( projectionObj *proj1, projectionObj *proj2 )
-{
-    int ret;
-
-    ret = msProjectionsDifferInternal(proj1, proj2);
-#if PROJ_VERSION_MAJOR < 6
-    if( ret &&
-        /* to speed up things, do normalization only if one proj is */
-        /* likely of the form init=epsg:XXX and the other proj=XXX datum=YYY... */
-        ( (proj1->numargs == 1 && proj2->numargs > 1) ||
-          (proj1->numargs > 1 && proj2->numargs == 1) ) )
-    {
-        projectionObj* p1normalized;
-        projectionObj* p2normalized;
-
-        p1normalized = msGetProjectNormalized( proj1 );
-        p2normalized = msGetProjectNormalized( proj2 );
-        ret = msProjectionsDifferInternal(p1normalized, p2normalized);
-        msFreeProjection(p1normalized);
-        msFree(p1normalized);
-        msFreeProjection(p2normalized);
-        msFree(p2normalized);
-    }
-#endif
-    return ret;
-}
-
-/************************************************************************/
-/*                           msTestNeedWrap()                           */
-/************************************************************************/
-/*
-
-Frank Warmerdam, Nov, 2001.
-
-See Also:
-
-http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=15
-
-Proposal:
-
-Modify msProjectLine() so that it "dateline wraps" objects when necessary
-in order to preserve their shape when reprojecting to lat/long.  This
-will be accomplished by:
-
-1) As each vertex is reprojected, compare the X distance between that
-   vertex and the previous vertex.  If it is less than 180 then proceed to
-   the next vertex without any special logic, otherwise:
-
-2) Reproject the center point of the line segment from the last vertex to
-   the current vertex into lat/long.  Does it's longitude lie between the
-   longitudes of the start and end point.  If yes, return to step 1) for
-   the next vertex ... everything is fine.
-
-3) We have determined that this line segment is suffering from 360 degree
-   wrap to keep in the -180 to +180 range.  Now add or subtract 360 degrees
-   as determined from the original sign of the distances.
-
-This is similar to the code there now (though disabled in CVS); however,
-it will ensure that big boxes will remain big, and not get dateline wrapped
-because of the extra test in step 2).  However step 2 is invoked only very
-rarely so this process takes little more than the normal process.  In fact,
-if we were sufficiently concerned about performance we could do a test on the
-shape MBR in lat/long space, and if the width is less than 180 we know we never
-need to even do test 1).
-
-What doesn't this resolve:
-
-This ensures that individual lines are kept in the proper shape when
-reprojected to geographic space.  However, it does not:
-
- o Ensure that all rings of a polygon will get transformed to the same "side"
-   of the world.  Depending on starting points of the different rings it is
-   entirely possible for one ring to end up in the -180 area and another ring
-   from the same polygon to end up in the +180 area.  We might possibly be
-   able to achieve this though, by treating the multi-ring polygon as a whole
-   and testing the first point of each additional ring against the last
-   vertex of the previous ring (or any previous vertex for that matter).
-
- o It does not address the need to cut up lines and polygons into distinct
-   chunks to preserve the correct semantics.  Really a polygon that
-   spaces the dateline in a -180 to 180 view should get split into two
-   polygons.  We haven't addressed that, though if it were to be addressed,
-   it could be done as a followon and distinct step from what we are doing
-   above.  In fact this sort of improvement (split polygons based on dateline
-   or view window) should be done for all lat/long shapes regardless of
-   whether they are being reprojected from another projection.
-
- o It does not address issues related to viewing rectangles that go outside
-   the -180 to 180 longitude range.  For instance, it is entirely reasonable
-   to want a 160 to 200 longitude view to see an area on the dateline clearly.
-   Currently shapes in the -180 to -160 range which should be displayed in the
-   180 to 200 portion of that view will not be because there is no recogition
-   that they belong there.
-
-
-*/
-
-static int msTestNeedWrap( pointObj pt1, pointObj pt2, pointObj pt2_geo,
-                           reprojectionObj* reprojector )
-
-{
-  pointObj  middle;
-  projectionObj* out = reprojector->out;
-
-  middle.x = (pt1.x + pt2.x) * 0.5;
-  middle.y = (pt1.y + pt2.y) * 0.5;
-
-  if( msProjectPointEx( reprojector, &pt1 ) == MS_FAILURE
-      || msProjectPointEx( reprojector, &pt2 ) == MS_FAILURE
-      || msProjectPointEx( reprojector, &middle ) == MS_FAILURE )
-    return 0;
-
-  /*
-   * If the last point was moved, then we are considered due for a
-   * move to.
-   */
-  if( out->gt.need_geotransform && out->gt.geotransform[2] == 0 ) {
-    if( fabs( (pt2_geo.x-pt2.x) * out->gt.geotransform[1] ) > 180.0 )
-      return 1;
-  } else {
-    if( fabs(pt2_geo.x-pt2.x) > 180.0 )
-      return 1;
-  }
-
-  /*
-   * Otherwise, test to see if the middle point transforms
-   * to be between the end points. If yes, no wrapping is needed.
-   * Otherwise wrapping is needed.
-   */
-  if( (middle.x < pt1.x && middle.x < pt2_geo.x)
-      || (middle.x > pt1.x && middle.x > pt2_geo.x) )
-    return 1;
-  else
-    return 0;
-}
-
-/************************************************************************/
-/*                            msProjFinder()                            */
-/************************************************************************/
-
-#if PROJ_VERSION_MAJOR < 6
-static char *last_filename = NULL;
-
-static const char *msProjFinder( const char *filename)
-
-{
-  if( last_filename != NULL )
-    free( last_filename );
-
-  if( filename == NULL )
-    return NULL;
-
-  if( ms_proj_data == NULL )
-    return filename;
-
-  last_filename = (char *) malloc(strlen(filename)+strlen(ms_proj_data)+2);
-  sprintf( last_filename, "%s/%s", ms_proj_data, filename );
-
-  return last_filename;
-}
-#endif
-
-/************************************************************************/
-/*                       msProjDataInitFromEnv()                        */
-/************************************************************************/
-void msProjDataInitFromEnv()
-{
-  const char *val;
-
-  if( (val=CPLGetConfigOption( "PROJ_DATA", NULL )) != NULL ||
-      (val=CPLGetConfigOption( "PROJ_LIB", NULL )) != NULL ) {
-    msSetPROJ_DATA(val, NULL);
-  }
-}
-
-/************************************************************************/
-/*                           msSetPROJ_DATA()                           */
-/************************************************************************/
-void msSetPROJ_DATA( const char *proj_data, const char *pszRelToPath )
-
-{
-  char *extended_path = NULL;
-
-  /* Handle relative path if applicable */
-  if( proj_data && pszRelToPath
-      && proj_data[0] != '/'
-      && proj_data[0] != '\\'
-      && !(proj_data[0] != '\0' && proj_data[1] == ':') ) {
-    struct stat stat_buf;
-    extended_path = (char*) msSmallMalloc(strlen(pszRelToPath)
-                                          + strlen(proj_data) + 10);
-    sprintf( extended_path, "%s/%s", pszRelToPath, proj_data );
-
-#ifndef S_ISDIR
-#  define S_ISDIR(x) ((x) & S_IFDIR)
-#endif
-
-    if( stat( extended_path, &stat_buf ) == 0
-        && S_ISDIR(stat_buf.st_mode) )
-      proj_data = extended_path;
-  }
-
-
-  msAcquireLock( TLOCK_PROJ );
-#if PROJ_VERSION_MAJOR >= 6
-  if( proj_data == NULL && ms_proj_data == NULL )
-  {
-     /* do nothing */
-  }
-  else if( proj_data != NULL && ms_proj_data != NULL &&
-           strcmp(proj_data, ms_proj_data) == 0 )
-  {
-    /* do nothing */
-  }
-  else
-  {
-    ms_proj_data_change_counter++;
-    free( ms_proj_data );
-    ms_proj_data = proj_data ? msStrdup(proj_data) : NULL;
-  }
-#else
-  {
-    static int finder_installed = 0;
-    if( finder_installed == 0 && proj_data != NULL) {
-      finder_installed = 1;
-      pj_set_finder( msProjFinder );
-    }
-  }
-
-  if (proj_data == NULL) pj_set_finder(NULL);
-
-  if( ms_proj_data != NULL ) {
-    free( ms_proj_data );
-    ms_proj_data = NULL;
-  }
-
-  if( last_filename != NULL ) {
-    free( last_filename );
-    last_filename = NULL;
-  }
-
-  if( proj_data != NULL )
-    ms_proj_data = msStrdup( proj_data );
-#endif
-  msReleaseLock( TLOCK_PROJ );
-
-#if GDAL_VERSION_MAJOR >= 3
-  if( ms_proj_data != NULL )
-  {
-#ifdef _WIN32
-    const char* sep = ";";
-#else
-    const char* sep = ":";
-#endif
-    char** papszPaths = CSLTokenizeString2(ms_proj_data, sep, 0);
-    OSRSetPROJSearchPaths((const char* const *)papszPaths);
-    CSLDestroy(papszPaths);
-  }
-#endif
-
-  if ( extended_path )
-    msFree( extended_path );
-}
-
-/************************************************************************/
-/*                       msGetProjectionString()                        */
-/*                                                                      */
-/*      Return the projection string.                                   */
-/************************************************************************/
-
-char *msGetProjectionString(projectionObj *proj)
-{
-  char        *pszProjString = NULL;
-  int         nLen = 0;
-
-  if (proj) {
-    /* -------------------------------------------------------------------- */
-    /*      Alloc buffer large enough to hold the whole projection defn     */
-    /* -------------------------------------------------------------------- */
-    for (int i=0; i<proj->numargs; i++) {
-      if (proj->args[i])
-        nLen += (strlen(proj->args[i]) + 2);
-    }
-
-    pszProjString = (char*)malloc(sizeof(char) * nLen+1);
-    pszProjString[0] = '\0';
-
-    /* -------------------------------------------------------------------- */
-    /*      Plug each arg into the string with a '+' prefix                 */
-    /* -------------------------------------------------------------------- */
-    for (int i=0; i<proj->numargs; i++) {
-      if (!proj->args[i] || strlen(proj->args[i]) == 0)
-        continue;
-      if (pszProjString[0] == '\0') {
-        /* no space at beginning of line */
-        if (proj->args[i][0] != '+')
-          strcat(pszProjString, "+");
-      } else {
-        if (proj->args[i][0] != '+')
-          strcat(pszProjString, " +");
-        else
-          strcat(pszProjString, " ");
-      }
-      strcat(pszProjString, proj->args[i]);
-    }
-  }
-
-  return pszProjString;
-}
-
-/************************************************************************/
-/*                       msIsAxisInvertedProj()                         */
-/*                                                                      */
-/*      Return MS_TRUE is the proj object has epgsaxis=ne               */
-/************************************************************************/
-
-int msIsAxisInvertedProj( projectionObj *proj )
-{
-  int i;
-  const char *axis = NULL;
-
-  for( i = 0; i < proj->numargs; i++ ) {
-    if( strstr(proj->args[i],"epsgaxis=") != NULL ) {
-      axis = strstr(proj->args[i],"=") + 1;
-      break;
-    }
-  }
-
-  if( axis == NULL )
-    return MS_FALSE;
-
-  if( strcasecmp(axis,"en") == 0 )
-    return MS_FALSE;
-
-  if( strcasecmp(axis,"ne") != 0 ) {
-    msDebug( "msIsAxisInvertedProj(): odd +epsgaxis= value: '%s'.",
-             axis );
-    return MS_FALSE;
-  }
-  
-  return MS_TRUE;
-}
-
-/************************************************************************/
-/*                       msAxisNormalizePoints()                        */
-/*                                                                      */
-/*      Convert the passed points to "easting, northing" axis           */
-/*      orientation if they are not already.                            */
-/************************************************************************/
-
-void msAxisNormalizePoints( projectionObj *proj, int count,
-                            double *x, double *y )
-
-{
-  int i;
-  if( !msIsAxisInvertedProj(proj ) )
-      return;
-
-  /* Switch axes */
-  for( i = 0; i < count; i++ ) {
-    double tmp;
-
-    tmp = x[i];
-    x[i] = y[i];
-    y[i] = tmp;
-  }
-}
-
-
-
-/************************************************************************/
-/*                             msAxisSwapShape                          */
-/*                                                                      */
-/*      Utility function to swap x and y coordiatesn Use for now for    */
-/*      WFS 1.1.x                                                       */
-/************************************************************************/
-void msAxisSwapShape(shapeObj *shape)
-{
-  double tmp;
-  int i,j;
-
-  if (shape) {
-    for(i=0; i<shape->numlines; i++) {
-      for( j=0; j<shape->line[i].numpoints; j++ ) {
-        tmp = shape->line[i].point[j].x;
-        shape->line[i].point[j].x = shape->line[i].point[j].y;
-        shape->line[i].point[j].y = tmp;
-      }
-    }
-
-    /*swap bounds*/
-    tmp = shape->bounds.minx;
-    shape->bounds.minx = shape->bounds.miny;
-    shape->bounds.miny = tmp;
-
-    tmp = shape->bounds.maxx;
-    shape->bounds.maxx = shape->bounds.maxy;
-    shape->bounds.maxy = tmp;
-  }
-}
-
-/************************************************************************/
-/*                      msAxisDenormalizePoints()                       */
-/*                                                                      */
-/*      Convert points from easting,northing orientation to the         */
-/*      preferred epsg orientation of this projectionObj.               */
-/************************************************************************/
-
-void msAxisDenormalizePoints( projectionObj *proj, int count,
-                              double *x, double *y )
-
-{
-  /* For how this is essentially identical to normalizing */
-  msAxisNormalizePoints( proj, count, x, y );
-}
-
-/************************************************************************/
-/*                        msProjIsGeographicCRS()                       */
-/*                                                                      */
-/*      Returns whether a CRS is a geographic one.                      */
-/************************************************************************/
-
-int msProjIsGeographicCRS(projectionObj* proj)
-{
-#if PROJ_VERSION_MAJOR >= 6
-    PJ_TYPE type;
-    if( !proj->proj )
-        return FALSE;
-    type = proj_get_type(proj->proj);
-    if( type == PJ_TYPE_GEOGRAPHIC_2D_CRS || type == PJ_TYPE_GEOGRAPHIC_3D_CRS )
-        return TRUE;
-    if( type == PJ_TYPE_BOUND_CRS )
-    {
-        PJ* base_crs = proj_get_source_crs(proj->proj_ctx->proj_ctx, proj->proj);
-        type = proj_get_type(base_crs);
-        proj_destroy(base_crs);
-        return type == PJ_TYPE_GEOGRAPHIC_2D_CRS || type == PJ_TYPE_GEOGRAPHIC_3D_CRS;
-    }
-    return FALSE;
-#else
-    return proj->proj != NULL && pj_is_latlong(proj->proj);
-#endif
-}
-
-/************************************************************************/
-/*                        ConvertProjUnitStringToMS                     */
-/*                                                                      */
-/*       Returns mapserver's unit code corresponding to the proj        */
-/*      unit passed as argument.                                        */
-/*       Please refer to ./src/pj_units.c file in the Proj.4 module.    */
-/************************************************************************/
-static int ConvertProjUnitStringToMS(const char *pszProjUnit)
-{
-  if (strcmp(pszProjUnit, "m") ==0) {
-    return MS_METERS;
-  } else if (strcmp(pszProjUnit, "km") ==0) {
-    return MS_KILOMETERS;
-  } else if (strcmp(pszProjUnit, "mi") ==0 || strcmp(pszProjUnit, "us-mi") ==0) {
-    return MS_MILES;
-  } else if (strcmp(pszProjUnit, "in") ==0 || strcmp(pszProjUnit, "us-in") ==0 ) {
-    return MS_INCHES;
-  } else if (strcmp(pszProjUnit, "ft") ==0 || strcmp(pszProjUnit, "us-ft") ==0) {
-    return MS_FEET;
-  } else if (strcmp(pszProjUnit, "kmi") == 0) {
-    return MS_NAUTICALMILES;
-  }
-
-  return -1;
-}
-
-/************************************************************************/
-/*           int GetMapserverUnitUsingProj(projectionObj *psProj)       */
-/*                                                                      */
-/*      Return a mapserver unit corresponding to the projection         */
-/*      passed. Retunr -1 on failure                                    */
-/************************************************************************/
-int GetMapserverUnitUsingProj(projectionObj *psProj)
-{
-#if PROJ_VERSION_MAJOR >= 6
-  const char *proj_str;
-#else
-  char *proj_str;
-#endif
-
-  if( msProjIsGeographicCRS( psProj ) )
-    return MS_DD;
-
-#if PROJ_VERSION_MAJOR >= 6
-  proj_str = proj_as_proj_string(psProj->proj_ctx->proj_ctx, psProj->proj, PJ_PROJ_4, NULL);
-#else
-  proj_str = pj_get_def( psProj->proj, 0 );
-#endif
-  if( proj_str == NULL )
-    return -1;
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle case of named units.                                     */
-  /* -------------------------------------------------------------------- */
-  if( strstr(proj_str,"units=") != NULL ) {
-    char units[32];
-    char *blank;
-
-    strlcpy( units, (strstr(proj_str,"units=")+6), sizeof(units) );
-#if PROJ_VERSION_MAJOR < 6
-    pj_dalloc( proj_str );
-#endif
-
-    blank = strchr(units, ' ');
-    if( blank != NULL )
-      *blank = '\0';
-
-    return ConvertProjUnitStringToMS( units );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle case of to_meter value.                                  */
-  /* -------------------------------------------------------------------- */
-  if( strstr(proj_str,"to_meter=") != NULL ) {
-    char to_meter_str[32];
-    char *blank;
-    double to_meter;
-
-    strlcpy(to_meter_str,(strstr(proj_str,"to_meter=")+9),
-            sizeof(to_meter_str));
-#if PROJ_VERSION_MAJOR < 6
-    pj_dalloc( proj_str );
-#endif
-
-    blank = strchr(to_meter_str, ' ');
-    if( blank != NULL )
-      *blank = '\0';
-
-    to_meter = atof(to_meter_str);
-
-    if( fabs(to_meter-1.0) < 0.0000001 )
-      return MS_METERS;
-    else if( fabs(to_meter-1000.0) < 0.00001 )
-      return MS_KILOMETERS;
-    else if( fabs(to_meter-0.3048) < 0.0001 )
-      return MS_FEET;
-    else if( fabs(to_meter-0.0254) < 0.0001 )
-      return MS_INCHES;
-    else if( fabs(to_meter-1609.344) < 0.001 )
-      return MS_MILES;
-    else if( fabs(to_meter-1852.0) < 0.1 )
-      return MS_NAUTICALMILES;
-    else
-      return -1;
-  }
-
-#if PROJ_VERSION_MAJOR < 6
-  pj_dalloc( proj_str );
-#endif
-  return -1;
-}
-
-/************************************************************************/
-/*                   msProjectionContextGetFromPool()                   */
-/*                                                                      */
-/*       Returns a projection context from the pool, or create a new    */
-/*       one if the pool is empty.                                      */
-/*       After use, it should normally be returned with                 */
-/*       msProjectionContextReleaseToPool()                             */
-/************************************************************************/
-
-projectionContext* msProjectionContextGetFromPool()
-{
-    projectionContext* context;
-    msAcquireLock( TLOCK_PROJ );
-
-    if( headOfLinkedListOfProjContext )
-    {
-        LinkedListOfProjContext* next = headOfLinkedListOfProjContext->next;
-        context = headOfLinkedListOfProjContext->context;
-        msFree(headOfLinkedListOfProjContext);
-        headOfLinkedListOfProjContext = next;
-    }
-    else
-    {
-        context = msProjectionContextCreate();
-    }
-
-    msReleaseLock( TLOCK_PROJ );
-    return context;
-}
-
-/************************************************************************/
-/*                  msProjectionContextReleaseToPool()                  */
-/************************************************************************/
-
-void msProjectionContextReleaseToPool(projectionContext* ctx)
-{
-    LinkedListOfProjContext* link =
-        (LinkedListOfProjContext*)msSmallMalloc(sizeof(LinkedListOfProjContext));
-    link->context = ctx;
-    msAcquireLock( TLOCK_PROJ );
-    link->next = headOfLinkedListOfProjContext;
-    headOfLinkedListOfProjContext = link;
-    msReleaseLock( TLOCK_PROJ );
-}
-
-/************************************************************************/
-/*                   msProjectionContextPoolCleanup()                   */
-/************************************************************************/
-
-void msProjectionContextPoolCleanup()
-{
-    LinkedListOfProjContext* link;
-    msAcquireLock( TLOCK_PROJ );
-    link = headOfLinkedListOfProjContext;
-    while( link )
-    {
-        LinkedListOfProjContext* next = link->next;
-        msProjectionContextUnref(link->context);
-        msFree(link);
-        link = next;
-    }
-    headOfLinkedListOfProjContext = NULL;
-    msReleaseLock( TLOCK_PROJ );
-}
diff -pruN 8.0.1-5/mapproject.h 8.2.0~beta1-1~exp1/mapproject.h
--- 8.0.1-5/mapproject.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapproject.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,178 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Declarations of the projectionObj and related functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPPROJECT_H
-#define MAPPROJECT_H
-
-#include "mapprimitive.h"
-#include "maphash.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#if PROJ_VERSION_MAJOR >= 6
-#  include <proj.h>
-#if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR == 0
-#error "PROJ 6.0 is not supported. Use PROJ 6.1 or later"
-#endif
-#else
-#  include <proj_api.h>
-#if PJ_VERSION >= 470 && PJ_VERSION < 480
-   void pj_clear_initcache();
-#endif
-#endif
-
-#define wkp_none 0
-#define wkp_lonlat 1
-#define wkp_gmerc 2
-
-typedef struct projectionContext projectionContext;
-
-#ifndef SWIG
-typedef enum
-{
-    LINE_CUTTING_UNKNOWN = -1,
-    LINE_CUTTING_NONE = 0,
-    LINE_CUTTING_FROM_POLAR = 1,
-    LINE_CUTTING_FROM_LONGLAT_WRAP0 = 2
-} msLineCuttingCase;
-#endif
-
-/**
-The :ref:`PROJECTION <projection>` object
-MapServer's Maps and Layers have Projection attributes, and these are C projectionObj structures, 
-but are not directly exposed by the mapscript module
-*/
-  typedef struct {
-#ifndef SWIG
-      char **args; /* variable number of projection args */
-#if PROJ_VERSION_MAJOR >= 6
-      PJ* proj;
-      projectionContext* proj_ctx;
-#else
-      projPJ proj; /* a projection structure for the PROJ package */
-#if PJ_VERSION >= 480
-      projCtx proj_ctx;
-#endif
-#endif
-      geotransformObj gt; /* extra transformation to apply */
-#endif
-
-#ifdef SWIG
-    %immutable;
-#endif
-    int numargs; ///< Actual number of projection args
-    int automatic; ///< Projection object was to fetched from the layer
-#ifdef SWIG
-    %mutable;
-#endif
-
-    int wellknownprojection; ///< One of ``wkp_none 0``, ``wkp_lonlat 1``, or ``wkp_gmerc 2``
-  } projectionObj;
-
-  typedef struct {
-#if PROJ_VERSION_MAJOR >= 6
-#ifndef SWIG
-    projectionObj* in;
-    projectionObj* out;
-    PJ* pj;
-    msLineCuttingCase lineCuttingCase;
-    shapeObj splitShape;
-    int bFreePJ;
-#endif
-#else
-#ifndef SWIG
-    projectionObj* in;
-    projectionObj* out;
-    msLineCuttingCase lineCuttingCase;
-    shapeObj splitShape;
-    int no_op;
-#endif
-#endif
-  } reprojectionObj;
-
-#ifndef SWIG
-
-  MS_DLL_EXPORT reprojectionObj* msProjectCreateReprojector(projectionObj* in, projectionObj* out);
-  MS_DLL_EXPORT void msProjectDestroyReprojector(reprojectionObj* reprojector);
-
-  MS_DLL_EXPORT projectionContext* msProjectionContextGetFromPool(void);
-  MS_DLL_EXPORT void msProjectionContextReleaseToPool(projectionContext* ctx);
-  MS_DLL_EXPORT void msProjectionContextPoolCleanup(void);
-
-  MS_DLL_EXPORT int msIsAxisInverted(int epsg_code);
-  MS_DLL_EXPORT int msProjectPoint(projectionObj *in, projectionObj *out, pointObj *point); /* legacy interface */
-  MS_DLL_EXPORT int msProjectPointEx(reprojectionObj* reprojector, pointObj *point);
-  MS_DLL_EXPORT int msProjectShape(projectionObj *in, projectionObj *out, shapeObj *shape); /* legacy interface */
-  MS_DLL_EXPORT int msProjectShapeEx(reprojectionObj* reprojector, shapeObj *shape);
-  MS_DLL_EXPORT int msProjectLine(projectionObj *in, projectionObj *out, lineObj *line); /* legacy interface */
-  MS_DLL_EXPORT int msProjectLineEx(reprojectionObj* reprojector, lineObj *line);
-  MS_DLL_EXPORT int msProjectRect(projectionObj *in, projectionObj *out, rectObj *rect); /* legacy interface */
-  MS_DLL_EXPORT int msProjectRectAsPolygon(reprojectionObj* reprojector, rectObj *rect);
-  MS_DLL_EXPORT int msProjectionsDiffer(projectionObj *, projectionObj *);
-  MS_DLL_EXPORT int msOGCWKT2ProjectionObj( const char *pszWKT, projectionObj *proj, int debug_flag );
-  MS_DLL_EXPORT char *msProjectionObj2OGCWKT( projectionObj *proj );
-
-  MS_DLL_EXPORT void msFreeProjection(projectionObj *p);
-  MS_DLL_EXPORT void msFreeProjectionExceptContext(projectionObj *p);
-  MS_DLL_EXPORT int msInitProjection(projectionObj *p);
-  MS_DLL_EXPORT void msProjectionInheritContextFrom(projectionObj *pDst, const projectionObj* pSrc);
-  MS_DLL_EXPORT void msProjectionSetContext(projectionObj *p, projectionContext* ctx);
-  MS_DLL_EXPORT int msProcessProjection(projectionObj *p);
-  MS_DLL_EXPORT int msLoadProjectionString(projectionObj *p, const char *value);
-  MS_DLL_EXPORT int msLoadProjectionStringEPSG(projectionObj *p, const char *value);
-  MS_DLL_EXPORT char *msGetProjectionString(projectionObj *proj);
-  int msIsAxisInvertedProj( projectionObj *proj );
-  void msAxisSwapShape(shapeObj *shape);
-  MS_DLL_EXPORT void msAxisNormalizePoints( projectionObj *proj, int count,
-      double *x, double *y );
-  MS_DLL_EXPORT void msAxisDenormalizePoints( projectionObj *proj, int count,
-      double *x, double *y );
-
-  MS_DLL_EXPORT void msSetPROJ_DATA( const char *, const char * );
-  MS_DLL_EXPORT void msProjDataInitFromEnv();
-
-  int msProjIsGeographicCRS(projectionObj* proj);
-#if PROJ_VERSION_MAJOR >= 6
-  int msProjectTransformPoints( reprojectionObj* reprojector,
-                                int npoints, double* x, double* y );
-#endif
-
-  /*utility functions */
-  MS_DLL_EXPORT int GetMapserverUnitUsingProj(projectionObj *psProj);
-
-  int msProjectHasLonWrap(projectionObj *in, double* pdfLonWrap);
-#endif
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPPROJECT_H */
diff -pruN 8.0.1-5/mapquantization.c 8.2.0~beta1-1~exp1/mapquantization.c
--- 8.0.1-5/mapquantization.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapquantization.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,775 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  RGB(A) to Palette Support Functions
- * Author:   Thomas Bonfort
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ******************************************************************************
- */
-/*
- * derivations from pngquant and ppmquant
- *
- ** pngquant.c - quantize the colors in an alphamap down to a specified number
- **
- ** Copyright (C) 1989, 1991 by Jef Poskanzer.
- ** Copyright (C) 1997, 2000, 2002 by Greg Roelofs; based on an idea by
- **                                Stefan Schneider.
- **
- ** Permission to use, copy, modify, and distribute this software and its
- ** documentation for any purpose and without fee is hereby granted, provided
- ** that the above copyright notice appear in all copies and that both that
- ** copyright notice and this permission notice appear in supporting
- ** documentation.  This software is provided "as is" without express or
- ** implied warranty.
- */
-
-#include "mapserver.h"
-#include <stdlib.h>
-
-#define PAM_GETR(p) ((p).r)
-#define PAM_GETG(p) ((p).g)
-#define PAM_GETB(p) ((p).b)
-#define PAM_GETA(p) ((p).a)
-#define PAM_ASSIGN(p,red,grn,blu,alf) \
-    do { (p).r = (red); (p).g = (grn); (p).b = (blu); (p).a = (alf); } while (0)
-#define PAM_EQUAL(p,q) \
-    ((p).r == (q).r && (p).g == (q).g && (p).b == (q).b && (p).a == (q).a)
-#define PAM_DEPTH(newp,p,oldmaxval,newmaxval) \
-    PAM_ASSIGN( (newp), \
-            ( (int) PAM_GETR(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval), \
-            ( (int) PAM_GETG(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval), \
-            ( (int) PAM_GETB(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval), \
-            ( (int) PAM_GETA(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval) )
-
-
-/* from pamcmap.h */
-
-typedef struct acolorhist_item *acolorhist_vector;
-struct acolorhist_item {
-  rgbaPixel acolor;
-  int value;
-};
-
-typedef struct acolorhist_list_item *acolorhist_list;
-struct acolorhist_list_item {
-  struct acolorhist_item ch;
-  acolorhist_list next;
-};
-
-typedef acolorhist_list *acolorhash_table;
-
-#define MAXCOLORS  32767
-
-#define LARGE_NORM
-#define REP_AVERAGE_PIXELS
-
-typedef struct box *box_vector;
-struct box {
-  int ind;
-  int colors;
-  int sum;
-};
-
-static acolorhist_vector mediancut
-(acolorhist_vector achv, int colors, int sum, unsigned char maxval, int newcolors);
-static int redcompare (const void *ch1, const void *ch2);
-static int greencompare (const void *ch1, const void *ch2);
-static int bluecompare (const void *ch1, const void *ch2);
-static int alphacompare (const void *ch1, const void *ch2);
-static int sumcompare (const void *b1, const void *b2);
-
-static acolorhist_vector pam_acolorhashtoacolorhist
-(acolorhash_table acht, int maxacolors);
-static acolorhist_vector pam_computeacolorhist
-(rgbaPixel **apixels, int cols, int rows, int maxacolors, int* acolorsP);
-static acolorhash_table pam_computeacolorhash
-(rgbaPixel** apixels, int cols, int rows, int maxacolors, int* acolorsP);
-static acolorhash_table pam_allocacolorhash (void);
-static int pam_addtoacolorhash
-(acolorhash_table acht, rgbaPixel *acolorP, int value);
-static int pam_lookupacolor (acolorhash_table acht, rgbaPixel* acolorP);
-static void pam_freeacolorhist (acolorhist_vector achv);
-static void pam_freeacolorhash (acolorhash_table acht);
-
-
-/**
- * Compute a palette for the given RGBA rasterBuffer using a median cut quantization.
- * - rb: the rasterBuffer to quantize
- * - reqcolors: the desired number of colors the palette should contain. will be set
- *   with the actual number of entries in the computed palette
- * - forced_palette: entries that should appear in the computed palette
- * - num_forced_palette_entries: number of entries contained in "force_palette". if 0,
- *   "force_palette" can be NULL
- * - palette_scaling_maxval: the quantization process may have to reduce the image depth
- *   by iteratively dividing the pixels by 2. In case palette_scaling_maxval is set to
- *   something different than 255, the returned palette colors have to be scaled back up to
- *   255, and rb's pixels will have been scaled down to maxsize (see bug #3848)
- */
-int msQuantizeRasterBuffer(rasterBufferObj *rb,
-                           unsigned int *reqcolors, rgbaPixel *palette,
-                           rgbaPixel *forced_palette_ignored, int num_forced_palette_entries_ignored,
-                           unsigned int *palette_scaling_maxval)
-{
-  (void)forced_palette_ignored;
-  (void)num_forced_palette_entries_ignored;
-  rgbaPixel **apixels=NULL; /* pointer to the start rows of truecolor pixels */
-
-  register rgbaPixel *pP;
-
-  unsigned char newmaxval;
-  acolorhist_vector achv, acolormap=NULL;
-
-  int colors;
-  int newcolors = 0;
-
-  int x;
-  /*  int channels;  */
-
-  assert(rb->type == MS_BUFFER_BYTE_RGBA);
-
-  *palette_scaling_maxval = 255;
-
-  apixels=(rgbaPixel**)msSmallMalloc(rb->height*sizeof(rgbaPixel*));
-
-  for(unsigned row=0; row<rb->height; row++) {
-    apixels[row]=(rgbaPixel*)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));
-  }
-
-  /*
-   ** Step 2: attempt to make a histogram of the colors, unclustered.
-   ** If at first we don't succeed, lower maxval to increase color
-   ** coherence and try again.  This will eventually terminate, with
-   ** maxval at worst 15, since 32^3 is approximately MAXCOLORS.
-                [GRR POSSIBLE BUG:  what about 32^4 ?]
-   */
-  for ( ; ; ) {
-    achv = pam_computeacolorhist(
-             apixels, rb->width, rb->height, MAXCOLORS, &colors );
-    if ( achv != (acolorhist_vector) 0 )
-      break;
-    newmaxval = *palette_scaling_maxval / 2;
-    for ( unsigned row = 0; row < rb->height; ++row )
-    {
-      pP = apixels[row];
-      for (unsigned col = 0 ; col < rb->width; ++col, ++pP )
-        PAM_DEPTH( *pP, *pP, *palette_scaling_maxval, newmaxval );
-    }
-    *palette_scaling_maxval = newmaxval;
-  }
-  newcolors = MS_MIN(colors, (int)*reqcolors);
-  acolormap = mediancut(achv, colors, rb->width*rb->height, *palette_scaling_maxval, newcolors);
-  pam_freeacolorhist(achv);
-
-
-  *reqcolors = newcolors;
-
-
-  for (x = 0; x < newcolors; ++x) {
-    palette[x].r = acolormap[x].acolor.r;
-    palette[x].g = acolormap[x].acolor.g;
-    palette[x].b = acolormap[x].acolor.b;
-    palette[x].a = acolormap[x].acolor.a;
-  }
-
-  free(acolormap);
-  free(apixels);
-  return MS_SUCCESS;
-}
-
-
-int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb)
-{
-  register int ind;
-  unsigned char *outrow,*pQ;
-  register rgbaPixel *pP;
-  acolorhash_table acht;
-  int usehash;
-  /*
-   ** Step 4: map the colors in the image to their closest match in the
-   ** new colormap, and write 'em out.
-   */
-  acht = pam_allocacolorhash( );
-  usehash = 1;
-
-  for ( unsigned row = 0; row < qrb->height; ++row ) {
-    outrow = &(qrb->data.palette.pixels[row*qrb->width]);
-    unsigned col = 0;
-    pP = (rgbaPixel*)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));;
-    pQ = outrow;
-    do {
-      /* Check hash table to see if we have already matched this color. */
-      ind = pam_lookupacolor( acht, pP );
-      if ( ind == -1 ) {
-        /* No; search acolormap for closest match. */
-        register int r1, g1, b1, a1, r2, g2, b2, a2;
-        register long dist, newdist;
-
-        r1 = PAM_GETR( *pP );
-        g1 = PAM_GETG( *pP );
-        b1 = PAM_GETB( *pP );
-        a1 = PAM_GETA( *pP );
-        dist = 2000000000;
-        for ( unsigned i = 0; i < qrb->data.palette.num_entries; ++i ) {
-          r2 = PAM_GETR( qrb->data.palette.palette[i] );
-          g2 = PAM_GETG( qrb->data.palette.palette[i] );
-          b2 = PAM_GETB( qrb->data.palette.palette[i] );
-          a2 = PAM_GETA( qrb->data.palette.palette[i] );
-          /* GRR POSSIBLE BUG */
-          newdist = ( r1 - r2 ) * ( r1 - r2 ) +  /* may overflow? */
-                    ( g1 - g2 ) * ( g1 - g2 ) +
-                    ( b1 - b2 ) * ( b1 - b2 ) +
-                    ( a1 - a2 ) * ( a1 - a2 );
-          if ( newdist < dist ) {
-            ind = i;
-            dist = newdist;
-          }
-        }
-        if ( usehash ) {
-          if ( pam_addtoacolorhash( acht, pP, ind ) < 0 ) {
-            usehash = 0;
-          }
-        }
-      }
-
-      /*          *pP = acolormap[ind].acolor;  */
-      *pQ = (unsigned char)ind;
-
-      ++col;
-      ++pP;
-      ++pQ;
-
-    } while ( col != rb->width );
-  }
-  pam_freeacolorhash(acht);
-
-  return MS_SUCCESS;
-}
-
-
-
-/*
- ** Here is the fun part, the median-cut colormap generator.  This is based
- ** on Paul Heckbert's paper, "Color Image Quantization for Frame Buffer
- ** Display," SIGGRAPH 1982 Proceedings, page 297.
- */
-
-static acolorhist_vector
-mediancut( acolorhist_vector achv, int colors, int sum, unsigned char maxval, int newcolors )
-{
-  acolorhist_vector acolormap;
-  box_vector bv;
-  register int bi, i;
-  int boxes;
-
-  bv = (box_vector) malloc( sizeof(struct box) * newcolors );
-  acolormap =
-    (acolorhist_vector) malloc( sizeof(struct acolorhist_item) * newcolors);
-  if ( bv == (box_vector) 0 || acolormap == (acolorhist_vector) 0 ) {
-    fprintf( stderr, "  out of memory allocating box vector\n" );
-    fflush(stderr);
-    exit(6);
-  }
-  for ( i = 0; i < newcolors; ++i )
-    PAM_ASSIGN( acolormap[i].acolor, 0, 0, 0, 0 );
-
-  /*
-   ** Set up the initial box.
-   */
-  bv[0].ind = 0;
-  bv[0].colors = colors;
-  bv[0].sum = sum;
-  boxes = 1;
-
-  /*
-   ** Main loop: split boxes until we have enough.
-   */
-  while ( boxes < newcolors ) {
-    register int indx, clrs;
-    int sm;
-    register int minr, maxr, ming, mina, maxg, minb, maxb, maxa, v;
-    int halfsum, lowersum;
-
-    /*
-     ** Find the first splittable box.
-     */
-    for ( bi = 0; bi < boxes; ++bi )
-      if ( bv[bi].colors >= 2 )
-        break;
-    if ( bi == boxes )
-      break;        /* ran out of colors! */
-    indx = bv[bi].ind;
-    clrs = bv[bi].colors;
-    sm = bv[bi].sum;
-
-    /*
-     ** Go through the box finding the minimum and maximum of each
-     ** component - the boundaries of the box.
-     */
-    minr = maxr = PAM_GETR( achv[indx].acolor );
-    ming = maxg = PAM_GETG( achv[indx].acolor );
-    minb = maxb = PAM_GETB( achv[indx].acolor );
-    mina = maxa = PAM_GETA( achv[indx].acolor );
-    for ( i = 1; i < clrs; ++i ) {
-      v = PAM_GETR( achv[indx + i].acolor );
-      if ( v < minr ) minr = v;
-      if ( v > maxr ) maxr = v;
-      v = PAM_GETG( achv[indx + i].acolor );
-      if ( v < ming ) ming = v;
-      if ( v > maxg ) maxg = v;
-      v = PAM_GETB( achv[indx + i].acolor );
-      if ( v < minb ) minb = v;
-      if ( v > maxb ) maxb = v;
-      v = PAM_GETA( achv[indx + i].acolor );
-      if ( v < mina ) mina = v;
-      if ( v > maxa ) maxa = v;
-    }
-
-    /*
-     ** Find the largest dimension, and sort by that component.  I have
-     ** included two methods for determining the "largest" dimension;
-     ** first by simply comparing the range in RGB space, and second
-     ** by transforming into luminosities before the comparison.  You
-     ** can switch which method is used by switching the commenting on
-     ** the LARGE_ defines at the beginning of this source file.
-     */
-#ifdef LARGE_NORM
-    if ( maxa - mina >= maxr - minr && maxa - mina >= maxg - ming && maxa - mina >= maxb - minb )
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        alphacompare );
-    else if ( maxr - minr >= maxg - ming && maxr - minr >= maxb - minb )
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        redcompare );
-    else if ( maxg - ming >= maxb - minb )
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        greencompare );
-    else
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        bluecompare );
-#endif /*LARGE_NORM*/
-#ifdef LARGE_LUM
-    {
-      apixel p;
-      float rl, gl, bl, al;
-
-      PAM_ASSIGN(p, maxr - minr, 0, 0, 0);
-      rl = PPM_LUMIN(p);
-      PAM_ASSIGN(p, 0, maxg - ming, 0, 0);
-      gl = PPM_LUMIN(p);
-      PAM_ASSIGN(p, 0, 0, maxb - minb, 0);
-      bl = PPM_LUMIN(p);
-
-      /*
-      GRR: treat alpha as grayscale and assign (maxa - mina) to each of R, G, B?
-      assign (maxa - mina)/3 to each?
-      use alpha-fractional luminosity?  (normalized_alpha * lum(r,g,b))
-      al = dunno ...
-      [probably should read Heckbert's paper to decide]
-       */
-
-      if ( al >= rl && al >= gl && al >= bl )
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          alphacompare );
-      else if ( rl >= gl && rl >= bl )
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          redcompare );
-      else if ( gl >= bl )
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          greencompare );
-      else
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          bluecompare );
-    }
-#endif /*LARGE_LUM*/
-
-    /*
-     ** Now find the median based on the counts, so that about half the
-     ** pixels (not colors, pixels) are in each subdivision.
-     */
-    lowersum = achv[indx].value;
-    halfsum = sm / 2;
-    for ( i = 1; i < clrs - 1; ++i ) {
-      if ( lowersum >= halfsum )
-        break;
-      lowersum += achv[indx + i].value;
-    }
-
-    /*
-     ** Split the box, and sort to bring the biggest boxes to the top.
-     */
-    bv[bi].colors = i;
-    bv[bi].sum = lowersum;
-    bv[boxes].ind = indx + i;
-    bv[boxes].colors = clrs - i;
-    bv[boxes].sum = sm - lowersum;
-    ++boxes;
-    qsort( (char*) bv, boxes, sizeof(struct box), sumcompare );
-  }
-
-  /*
-   ** Ok, we've got enough boxes.  Now choose a representative color for
-   ** each box.  There are a number of possible ways to make this choice.
-   ** One would be to choose the center of the box; this ignores any structure
-   ** within the boxes.  Another method would be to average all the colors in
-   ** the box - this is the method specified in Heckbert's paper.  A third
-   ** method is to average all the pixels in the box.  You can switch which
-   ** method is used by switching the commenting on the REP_ defines at
-   ** the beginning of this source file.
-   */
-  for ( bi = 0; bi < boxes; ++bi ) {
-#ifdef REP_CENTER_BOX
-    register int indx = bv[bi].ind;
-    register int clrs = bv[bi].colors;
-    register int minr, maxr, ming, maxg, minb, maxb, mina, maxa, v;
-
-    minr = maxr = PAM_GETR( achv[indx].acolor );
-    ming = maxg = PAM_GETG( achv[indx].acolor );
-    minb = maxb = PAM_GETB( achv[indx].acolor );
-    mina = maxa = PAM_GETA( achv[indx].acolor );
-    for ( i = 1; i < clrs; ++i ) {
-      v = PAM_GETR( achv[indx + i].acolor );
-      minr = min( minr, v );
-      maxr = max( maxr, v );
-      v = PAM_GETG( achv[indx + i].acolor );
-      ming = min( ming, v );
-      maxg = max( maxg, v );
-      v = PAM_GETB( achv[indx + i].acolor );
-      minb = min( minb, v );
-      maxb = max( maxb, v );
-      v = PAM_GETA( achv[indx + i].acolor );
-      mina = min( mina, v );
-      maxa = max( maxa, v );
-    }
-    PAM_ASSIGN(
-      acolormap[bi].acolor, ( minr + maxr ) / 2, ( ming + maxg ) / 2,
-      ( minb + maxb ) / 2, ( mina + maxa ) / 2 );
-#endif /*REP_CENTER_BOX*/
-#ifdef REP_AVERAGE_COLORS
-    register int indx = bv[bi].ind;
-    register int clrs = bv[bi].colors;
-    register long r = 0, g = 0, b = 0, a = 0;
-
-    for ( i = 0; i < clrs; ++i ) {
-      r += PAM_GETR( achv[indx + i].acolor );
-      g += PAM_GETG( achv[indx + i].acolor );
-      b += PAM_GETB( achv[indx + i].acolor );
-      a += PAM_GETA( achv[indx + i].acolor );
-    }
-    r = r / clrs;
-    g = g / clrs;
-    b = b / clrs;
-    a = a / clrs;
-    PAM_ASSIGN( acolormap[bi].acolor, r, g, b, a );
-#endif /*REP_AVERAGE_COLORS*/
-#ifdef REP_AVERAGE_PIXELS
-    register int indx = bv[bi].ind;
-    register int clrs = bv[bi].colors;
-    register long r = 0, g = 0, b = 0, a = 0, sum = 0;
-
-    for ( i = 0; i < clrs; ++i ) {
-      r += (long)PAM_GETR( achv[indx + i].acolor ) * achv[indx + i].value;
-      g += (long)PAM_GETG( achv[indx + i].acolor ) * achv[indx + i].value;
-      b += (long)PAM_GETB( achv[indx + i].acolor ) * achv[indx + i].value;
-      a += (long)PAM_GETA( achv[indx + i].acolor ) * achv[indx + i].value;
-      sum += achv[indx + i].value;
-    }
-    if(sum>0) {
-      r = r / sum;
-      if ( r > maxval ) r = maxval;        /* avoid math errors */
-      g = g / sum;
-      if ( g > maxval ) g = maxval;
-      b = b / sum;
-      if ( b > maxval ) b = maxval;
-      a = a / sum;
-      if ( a > maxval ) a = maxval;
-    } else {
-      r = g = b = a = maxval;
-    }
-    /* GRR 20001228:  added casts to quiet warnings; 255 DEPENDENCY */
-    PAM_ASSIGN( acolormap[bi].acolor, (unsigned char)r, (unsigned char)g, (unsigned char)b, (unsigned char)a );
-#endif /*REP_AVERAGE_PIXELS*/
-  }
-
-  /*
-   ** All done.
-   */
-  free(bv);
-  return acolormap;
-}
-
-static int
-redcompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETR( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETR( ((acolorhist_vector)ch2)->acolor );
-}
-
-static int
-greencompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETG( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETG( ((acolorhist_vector)ch2)->acolor );
-}
-
-static int
-bluecompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETB( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETB( ((acolorhist_vector)ch2)->acolor );
-}
-
-static int
-alphacompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETA( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETA( ((acolorhist_vector)ch2)->acolor );
-}
-
-static int
-sumcompare( const void *b1, const void *b2 )
-{
-  return ((box_vector)b2)->sum -
-         ((box_vector)b1)->sum;
-}
-
-
-/*===========================================================================*/
-
-
-/* libpam3.c - pam (portable alpha map) utility library part 3
- **
- ** Colormap routines.
- **
- ** Copyright (C) 1989, 1991 by Jef Poskanzer.
- ** Copyright (C) 1997 by Greg Roelofs.
- **
- ** Permission to use, copy, modify, and distribute this software and its
- ** documentation for any purpose and without fee is hereby granted, provided
- ** that the above copyright notice appear in all copies and that both that
- ** copyright notice and this permission notice appear in supporting
- ** documentation.  This software is provided "as is" without express or
- ** implied warranty.
- */
-
-/*
-#include "pam.h"
-#include "pamcmap.h"
- */
-
-#define HASH_SIZE 20023
-
-#define pam_hashapixel(p) ( ( ( (long) PAM_GETR(p) * 33023 + \
-    (long) PAM_GETG(p) * 30013 + \
-    (long) PAM_GETB(p) * 27011 + \
-    (long) PAM_GETA(p) * 24007 ) \
-    & 0x7fffffff ) % HASH_SIZE )
-
-static acolorhist_vector
-pam_computeacolorhist( apixels, cols, rows, maxacolors, acolorsP )
-rgbaPixel** apixels;
-int cols, rows, maxacolors;
-int* acolorsP;
-{
-  acolorhash_table acht;
-  acolorhist_vector achv;
-
-  acht = pam_computeacolorhash( apixels, cols, rows, maxacolors, acolorsP );
-  if ( acht == (acolorhash_table) 0 )
-    return (acolorhist_vector) 0;
-  achv = pam_acolorhashtoacolorhist( acht, maxacolors );
-  pam_freeacolorhash( acht );
-  return achv;
-}
-
-
-
-static acolorhash_table
-pam_computeacolorhash( apixels, cols, rows, maxacolors, acolorsP )
-rgbaPixel** apixels;
-int cols, rows, maxacolors;
-int* acolorsP;
-{
-  acolorhash_table acht;
-  register rgbaPixel* pP;
-  acolorhist_list achl;
-  int col, row, hash;
-
-  acht = pam_allocacolorhash( );
-  *acolorsP = 0;
-
-  /* Go through the entire image, building a hash table of colors. */
-  for ( row = 0; row < rows; ++row )
-    for ( col = 0, pP = apixels[row]; col < cols; ++col, ++pP ) {
-      hash = pam_hashapixel( *pP );
-      for ( achl = acht[hash]; achl != (acolorhist_list) 0; achl = achl->next )
-        if ( PAM_EQUAL( achl->ch.acolor, *pP ) )
-          break;
-      if ( achl != (acolorhist_list) 0 )
-        ++(achl->ch.value);
-      else {
-        if ( ++(*acolorsP) > maxacolors ) {
-          pam_freeacolorhash( acht );
-          return (acolorhash_table) 0;
-        }
-        achl = (acolorhist_list) malloc( sizeof(struct acolorhist_list_item) );
-        if ( achl == 0 ) {
-          fprintf( stderr, "  out of memory computing hash table\n" );
-          exit(7);
-        }
-        achl->ch.acolor = *pP;
-        achl->ch.value = 1;
-        achl->next = acht[hash];
-        acht[hash] = achl;
-      }
-    }
-
-  return acht;
-}
-
-
-
-static acolorhash_table
-pam_allocacolorhash( )
-{
-  acolorhash_table acht;
-  int i;
-
-  acht = (acolorhash_table) malloc( HASH_SIZE * sizeof(acolorhist_list) );
-  if ( acht == 0 ) {
-    fprintf( stderr, "  out of memory allocating hash table\n" );
-    exit(8);
-  }
-
-  for ( i = 0; i < HASH_SIZE; ++i )
-    acht[i] = (acolorhist_list) 0;
-
-  return acht;
-}
-
-
-
-static int
-pam_addtoacolorhash( acht, acolorP, value )
-acolorhash_table acht;
-rgbaPixel* acolorP;
-int value;
-{
-  register int hash;
-  register acolorhist_list achl;
-
-  achl = (acolorhist_list) msSmallMalloc( sizeof(struct acolorhist_list_item) );
-
-  hash = pam_hashapixel( *acolorP );
-  achl->ch.acolor = *acolorP;
-  achl->ch.value = value;
-  achl->next = acht[hash];
-  acht[hash] = achl;
-  return 0;
-}
-
-
-
-static acolorhist_vector
-pam_acolorhashtoacolorhist( acht, maxacolors )
-acolorhash_table acht;
-int maxacolors;
-{
-  acolorhist_vector achv;
-  acolorhist_list achl;
-  int i, j;
-
-  /* Now collate the hash table into a simple acolorhist array. */
-  achv = (acolorhist_vector) malloc( maxacolors * sizeof(struct acolorhist_item) );
-  /* (Leave room for expansion by caller.) */
-  if ( achv == (acolorhist_vector) 0 ) {
-    fprintf( stderr, "  out of memory generating histogram\n" );
-    exit(9);
-  }
-
-  /* Loop through the hash table. */
-  j = 0;
-  for ( i = 0; i < HASH_SIZE; ++i )
-    for ( achl = acht[i]; achl != (acolorhist_list) 0; achl = achl->next ) {
-      /* Add the new entry. */
-      achv[j] = achl->ch;
-      ++j;
-    }
-
-  /* All done. */
-  return achv;
-}
-
-
-
-static int
-pam_lookupacolor( acht, acolorP )
-acolorhash_table acht;
-rgbaPixel* acolorP;
-{
-  int hash;
-  acolorhist_list achl;
-
-  hash = pam_hashapixel( *acolorP );
-  for ( achl = acht[hash]; achl != (acolorhist_list) 0; achl = achl->next )
-    if ( PAM_EQUAL( achl->ch.acolor, *acolorP ) )
-      return achl->ch.value;
-
-  return -1;
-}
-
-
-
-static void
-pam_freeacolorhist( achv )
-acolorhist_vector achv;
-{
-  free( (char*) achv );
-}
-
-
-
-static void
-pam_freeacolorhash( acht )
-acolorhash_table acht;
-{
-  int i;
-  acolorhist_list achl, achlnext;
-
-  for ( i = 0; i < HASH_SIZE; ++i )
-    for ( achl = acht[i]; achl != (acolorhist_list) 0; achl = achlnext ) {
-      achlnext = achl->next;
-      free( (char*) achl );
-    }
-  free( (char*) acht );
-}
-
-
-
diff -pruN 8.0.1-5/mapquery.c 8.2.0~beta1-1~exp1/mapquery.c
--- 8.0.1-5/mapquery.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapquery.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2249 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Layer query support.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#include "limits.h"
-
-/* This object is used by the various mapQueryXXXXX() functions. It stores
- * the total amount of shapes and their RAM footprint, when they are cached
- * in the resultCacheObj* of layers. This is the total number accross all queried
- * layers. However this is isn't persistant accross several calls to
- * mapQueryXXXXX(), if the resultCacheObj* objects weren't cleaned up. This
- * is not needed in the context of WFS, for which this is used for now.
- */
-typedef struct
-{
-    int cachedShapeCountWarningEmitted;
-    int cachedShapeCount;
-    int cachedShapeRAMWarningEmitted;
-    int cachedShapeRAM;
-} queryCacheObj;
-
-int msInitQuery(queryObj *query) {
-  if(!query) return MS_FAILURE;
-
-  msFreeQuery(query); /* clean up anything previously allocated */
-
-  query->type = MS_QUERY_IS_NULL; /* nothing defined */
-  query->mode = MS_QUERY_SINGLE;
-
-  query->layer = query->slayer = -1;
-
-  query->point.x = query->point.y = -1;
-  query->buffer = 0.0;
-  query->maxresults = 0; /* only used by msQueryByPoint() apparently */
-
-  query->rect.minx = query->rect.miny = query->rect.maxx = query->rect.maxy = -1;
-  query->shape = NULL;
-
-  query->shapeindex = query->tileindex = -1;
-  query->clear_resultcache = MS_TRUE; /* index queries allow the old results to persist */
-
-  query->maxfeatures = -1;
-  query->startindex = -1;
-  query->only_cache_result_count = 0;
-  
-  query->filteritem = NULL;
-  msInitExpression(&query->filter);
-  
-  query->cache_shapes = MS_FALSE;
-  query->max_cached_shape_count = 0;
-  query->max_cached_shape_ram_amount = 0;
-
-  return MS_SUCCESS;
-}
-
-void msFreeQuery(queryObj *query)
-{
-  if(query->shape) {
-    msFreeShape(query->shape);
-    free(query->shape);
-  }
-
-  if(query->filteritem) free(query->filteritem);
-  msFreeExpression(&query->filter);
-}
-
-/*
-** Wrapper for all query functions, just feed is a mapObj with a populated queryObj...
-*/
-int msExecuteQuery(mapObj *map)
-{
-  int tmp=-1, status;
-
-  /* handle slayer/qlayer management for feature queries */
-  if(map->query.slayer >= 0) {
-    tmp = map->query.layer;
-    map->query.layer = map->query.slayer;
-  }
-
-  switch(map->query.type) {
-    case MS_QUERY_BY_POINT:
-      status = msQueryByPoint(map);
-      break;
-    case MS_QUERY_BY_RECT:
-      status = msQueryByRect(map);
-      break;
-    case MS_QUERY_BY_FILTER:
-      status = msQueryByFilter(map);
-      break;
-    case MS_QUERY_BY_SHAPE:
-      status = msQueryByShape(map);
-      break;
-    case MS_QUERY_BY_INDEX:
-      status = msQueryByIndex(map);
-      break;
-    default:
-      msSetError(MS_QUERYERR, "Malformed queryObj.", "msExecuteQuery()");
-      return(MS_FAILURE);
-  }
-
-  if(map->query.slayer >= 0) {
-    map->query.layer = tmp; /* restore layer */
-    if(status == MS_SUCCESS) status = msQueryByFeatures(map);
-  }
-
-  return status;
-}
-
-/*
-** msIsLayerQueryable()  returns MS_TRUE/MS_FALSE
-*/
-int msIsLayerQueryable(layerObj *lp)
-{
-  int i;
-
-  if ( lp->type == MS_LAYER_TILEINDEX )
-    return MS_FALSE;
-
-  if(lp->template && strlen(lp->template) > 0) return MS_TRUE;
-
-  for(i=0; i<lp->numclasses; i++) {
-    if(lp->class[i]->template && strlen(lp->class[i]->template) > 0)
-      return MS_TRUE;
-  }
-
-  return MS_FALSE;
-}
-
-static void initQueryCache(queryCacheObj* queryCache)
-{
-    queryCache->cachedShapeCountWarningEmitted = MS_FALSE;
-    queryCache->cachedShapeCount = 0;
-    queryCache->cachedShapeRAMWarningEmitted = MS_FALSE;
-    queryCache->cachedShapeRAM = 0;
-}
-
-/** Check whether we should store the shape in resultCacheObj* given the
- * limits allowed in map->query.max_cached_shape_count and
- * map->query.max_cached_shape_ram_amount.
- */
-static int canCacheShape(mapObj* map, queryCacheObj *queryCache, int shape_ram_size)
-{
-  if( !map->query.cache_shapes )
-      return MS_FALSE;
-  if( queryCache->cachedShapeCountWarningEmitted ||
-      (map->query.max_cached_shape_count > 0 &&
-      queryCache->cachedShapeCount >= map->query.max_cached_shape_count) )
-  {
-      if( !queryCache->cachedShapeCountWarningEmitted )
-      {
-          queryCache->cachedShapeCountWarningEmitted = MS_TRUE;
-          if (map->debug >= MS_DEBUGLEVEL_V) {
-              msDebug("map->query.max_cached_shape_count = %d reached. "
-                  "Next features will not be cached.\n",
-                  map->query.max_cached_shape_count);
-          }
-      }
-      return MS_FALSE;
-  }
-  if( queryCache->cachedShapeRAMWarningEmitted ||
-      (map->query.max_cached_shape_ram_amount > 0 &&
-       queryCache->cachedShapeRAM + shape_ram_size > map->query.max_cached_shape_ram_amount) )
-  {
-      if( !queryCache->cachedShapeRAMWarningEmitted )
-      {
-          queryCache->cachedShapeRAMWarningEmitted = MS_TRUE;
-          if (map->debug >= MS_DEBUGLEVEL_V) {
-              msDebug("map->query.max_cached_shape_ram_amount = %d reached after %d cached features. "
-                  "Next features will not be cached.\n",
-                  map->query.max_cached_shape_ram_amount,
-                  queryCache->cachedShapeCount);
-          }
-      }
-      return MS_FALSE;
-  }
-  return MS_TRUE;
-}
-
-static int addResult(mapObj* map, resultCacheObj *cache,
-                     queryCacheObj* queryCache, shapeObj *shape)
-{
-  int i;
-  int shape_ram_size = (map->query.max_cached_shape_ram_amount > 0) ? 
-                                            msGetShapeRAMSize( shape ) : 0;
-  int store_shape = canCacheShape (map, queryCache, shape_ram_size);
-
-  if(cache->numresults == cache->cachesize) { /* just add it to the end */
-    if(cache->cachesize == 0)
-      cache->results = (resultObj *) malloc(sizeof(resultObj)*MS_RESULTCACHEINCREMENT);
-    else
-      cache->results = (resultObj *) realloc(cache->results, sizeof(resultObj)*(cache->cachesize+MS_RESULTCACHEINCREMENT));
-    if(!cache->results) {
-      msSetError(MS_MEMERR, "Realloc() error.", "addResult()");
-      return(MS_FAILURE);
-    }
-    cache->cachesize += MS_RESULTCACHEINCREMENT;
-  }
-
-  i = cache->numresults;
-
-  cache->results[i].classindex = shape->classindex;
-  cache->results[i].tileindex = shape->tileindex;
-  cache->results[i].shapeindex = shape->index;
-  cache->results[i].resultindex = shape->resultindex;
-  if( store_shape )
-  {
-      cache->results[i].shape = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
-      msInitShape(cache->results[i].shape);
-      msCopyShape(shape, cache->results[i].shape);
-      queryCache->cachedShapeCount ++;
-      queryCache->cachedShapeRAM += shape_ram_size;
-  }
-  else
-      cache->results[i].shape = NULL;
-  cache->numresults++;
-
-  cache->previousBounds = cache->bounds;
-  if(cache->numresults == 1)
-    cache->bounds = shape->bounds;
-  else
-    msMergeRect(&(cache->bounds), &(shape->bounds));
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Serialize a query result set to disk.
-*/
-static int saveQueryResults(mapObj *map, char *filename)
-{
-  FILE *stream;
-  int i, j, n=0;
-
-  if(!filename) {
-    msSetError(MS_MISCERR, "No filename provided to save query results to.", "saveQueryResults()");
-    return MS_FAILURE;
-  }
-
-  stream = fopen(filename, "w");
-  if(!stream) {
-    msSetError(MS_IOERR, "(%s)", "saveQueryResults()", filename);
-    return MS_FAILURE;
-  }
-
-  fprintf(stream, "%s - Generated by msSaveQuery()\n", MS_QUERY_RESULTS_MAGIC_STRING);
-
-  /* count the number of layers with results */
-  for(i=0; i<map->numlayers; i++)
-    if(GET_LAYER(map, i)->resultcache) n++;
-  fwrite(&n, sizeof(int), 1, stream);
-
-  /* now write the result set for each layer */
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->resultcache) {
-      fwrite(&i, sizeof(int), 1, stream); /* layer index */
-      fwrite(&(GET_LAYER(map, i)->resultcache->numresults), sizeof(int), 1, stream); /* number of results */
-      fwrite(&(GET_LAYER(map, i)->resultcache->bounds), sizeof(rectObj), 1, stream); /* bounding box */
-      for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++)
-        fwrite(&(GET_LAYER(map, i)->resultcache->results[j]), sizeof(resultObj), 1, stream); /* each result */
-    }
-  }
-
-  fclose(stream);
-  return MS_SUCCESS;
-}
-
-static int loadQueryResults(mapObj *map, FILE *stream)
-{
-  int i, j, k, n=0;
-
-  if(1 != fread(&n, sizeof(int), 1, stream) || n > INT_MAX - 1) {
-    msSetError(MS_MISCERR,"failed to read query count from query file stream", "loadQueryResults()");
-    return MS_FAILURE;
-  }
-
-  /* now load the result set for each layer found in the query file */
-  for(i=0; i<n; i++) {
-    if(1 != fread(&j, sizeof(int), 1, stream)) { /* layer index */
-      msSetError(MS_MISCERR,"failed to read layer index from query file stream", "loadQueryResults()");
-      return MS_FAILURE;
-    }
-
-    if(j<0 || j>map->numlayers) {
-      msSetError(MS_MISCERR, "Invalid layer index loaded from query file.", "loadQueryResults()");
-      return MS_FAILURE;
-    }
-
-    /* inialize the results for this layer */
-    GET_LAYER(map, j)->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    MS_CHECK_ALLOC(GET_LAYER(map, j)->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-
-    if(1 != fread(&(GET_LAYER(map, j)->resultcache->numresults), sizeof(int), 1, stream) || (GET_LAYER(map, j)->resultcache->numresults < 0)) { /* number of results */
-      msSetError(MS_MISCERR,"failed to read number of results from query file stream", "loadQueryResults()");
-      free(GET_LAYER(map, j)->resultcache);
-      GET_LAYER(map, j)->resultcache = NULL;
-      return MS_FAILURE;
-    }
-    GET_LAYER(map, j)->resultcache->cachesize = GET_LAYER(map, j)->resultcache->numresults;
-
-    if(1 != fread(&(GET_LAYER(map, j)->resultcache->bounds), sizeof(rectObj), 1, stream)) { /* bounding box */
-      msSetError(MS_MISCERR,"failed to read bounds from query file stream", "loadQueryResults()");
-      free(GET_LAYER(map, j)->resultcache);
-      GET_LAYER(map, j)->resultcache = NULL;
-      return MS_FAILURE;
-    }
-
-    GET_LAYER(map, j)->resultcache->results = (resultObj *) malloc(sizeof(resultObj)*GET_LAYER(map, j)->resultcache->numresults);
-    if (GET_LAYER(map, j)->resultcache->results == NULL) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "loadQueryResults()",
-                 __FILE__, __LINE__, (unsigned int)(sizeof(resultObj)*GET_LAYER(map, j)->resultcache->numresults));
-      free(GET_LAYER(map, j)->resultcache);
-      GET_LAYER(map, j)->resultcache = NULL;
-      return MS_FAILURE;
-    }
-
-    for(k=0; k<GET_LAYER(map, j)->resultcache->numresults; k++) {
-      if(1 != fread(&(GET_LAYER(map, j)->resultcache->results[k]), sizeof(resultObj), 1, stream)) { /* each result */
-        msSetError(MS_MISCERR,"failed to read result %d from query file stream", "loadQueryResults()", k);
-        free(GET_LAYER(map, j)->resultcache->results);
-        free(GET_LAYER(map, j)->resultcache);
-        GET_LAYER(map, j)->resultcache = NULL;
-        return MS_FAILURE;
-      }
-      if(!GET_LAYER(map, j)->tileindex) GET_LAYER(map, j)->resultcache->results[k].tileindex = -1; /* reset the tile index for non-tiled layers */
-      GET_LAYER(map, j)->resultcache->results[k].resultindex = -1; /* all results loaded this way have a -1 result (set) index */
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Serialize the parameters necessary to duplicate a query to disk. (TODO: add filter query...)
-*/
-static int saveQueryParams(mapObj *map, char *filename)
-{
-  FILE *stream;
-
-  if(!filename) {
-    msSetError(MS_MISCERR, "No filename provided to save query to.", "saveQueryParams()");
-    return MS_FAILURE;
-  }
-
-  stream = fopen(filename, "w");
-  if(!stream) {
-    msSetError(MS_IOERR, "(%s)", "saveQueryParams()", filename);
-    return MS_FAILURE;
-  }
-
-  fprintf(stream, "%s - Generated by msSaveQuery()\n", MS_QUERY_PARAMS_MAGIC_STRING);
-
-  fprintf(stream, "%d %d %d %d\n", map->query.mode, map->query.type, map->query.layer, map->query.slayer); /* all queries */
-  fprintf(stream, "%.15g %.15g %g %d\n", map->query.point.x, map->query.point.y, map->query.buffer, map->query.maxresults); /* by point */
-  fprintf(stream, "%.15g %.15g %.15g %.15g\n", map->query.rect.minx, map->query.rect.miny, map->query.rect.maxx, map->query.rect.maxy); /* by rect */
-  fprintf(stream, "%ld %ld %d\n", map->query.shapeindex, map->query.tileindex, map->query.clear_resultcache); /* by index */
-
-  fprintf(stream, "%s\n", (map->query.filteritem)?map->query.filteritem:"NULL"); /* by filter */
-  fprintf(stream, "%s\n", (map->query.filter.string)?map->query.filter.string:"NULL");
-
-  if(map->query.shape) { /* by shape */
-    int i, j;
-    shapeObj *s = map->query.shape;
-
-    fprintf(stream, "%d\n", s->type);
-    fprintf(stream, "%d\n", s->numlines);
-    for(i=0; i<s->numlines; i++) {
-      fprintf(stream, "%d\n", s->line[i].numpoints);
-      for(j=0; j<s->line[i].numpoints; j++)
-        fprintf(stream, "%.15g %.15g\n", s->line[i].point[j].x, s->line[i].point[j].y);
-    }
-  } else {
-    fprintf(stream, "%d\n", MS_SHAPE_NULL); /* NULL shape */
-  }
-
-  fclose(stream);
-  return MS_SUCCESS;
-}
-
-static int loadQueryParams(mapObj *map, FILE *stream)
-{
-  char buffer[MS_BUFFER_LENGTH];
-  int lineno;
-
-  int shapetype, numlines, numpoints;
-
-  msInitQuery(&(map->query)); /* this will free any previous query as well */
-
-  lineno = 2; /* line 1 is the magic string */
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
-    switch(lineno) {
-      case 2:
-        if(sscanf(buffer, "%d %d %d %d\n", &(map->query.mode), &(map->query.type), &(map->query.layer), &(map->query.slayer)) != 4) goto parse_error;
-        break;
-      case 3:
-        if(sscanf(buffer, "%lf %lf %lf %d\n", &map->query.point.x, &map->query.point.y, &map->query.buffer, &map->query.maxresults) != 4) goto parse_error;
-        break;
-      case 4:
-        if(sscanf(buffer, "%lf %lf %lf %lf\n", &map->query.rect.minx, &map->query.rect.miny, &map->query.rect.maxx, &map->query.rect.maxy) != 4) goto parse_error;
-        break;
-      case 5:
-        if(sscanf(buffer, "%ld %ld %d\n", &map->query.shapeindex, &map->query.tileindex, &map->query.clear_resultcache) != 3) goto parse_error;
-        break;
-      case 6:
-        if(strncmp(buffer, "NULL", 4) != 0) {
-          map->query.filteritem = msStrdup(buffer);
-          msStringChop(map->query.filteritem);
-        }
-        break;
-      case 7:
-        if(strncmp(buffer, "NULL", 4) != 0)
-	  msLoadExpressionString(&map->query.filter, buffer); /* chop buffer */
-        break;
-      case 8:
-        if(sscanf(buffer, "%d\n", &shapetype) != 1) goto parse_error;
-
-        if(shapetype != MS_SHAPE_NULL) { /* load the rest of the shape */
-          int i, j;
-          lineObj line;
-
-          map->query.shape = (shapeObj *) msSmallMalloc(sizeof(shapeObj));
-          msInitShape(map->query.shape);
-          map->query.shape->type = shapetype;
-
-          if(fscanf(stream, "%d\n", &numlines) != 1) goto parse_error;
-          if( numlines > INT_MAX - 1 ) goto parse_error;
-          for(i=0; i<numlines; i++) {
-            if(fscanf(stream, "%d\n", &numpoints) != 1 || numpoints<0 ||
-                numpoints > INT_MAX / (int)sizeof(pointObj)) goto parse_error;
-
-            line.numpoints = numpoints;
-            line.point = (pointObj *) msSmallMalloc(line.numpoints*sizeof(pointObj));
-
-            for(j=0; j<numpoints; j++)
-              if(fscanf(stream, "%lf %lf\n", &line.point[j].x, &line.point[j].y) != 2) goto parse_error;
-
-            msAddLine(map->query.shape, &line);
-            free(line.point);
-          }
-        }
-        break;
-      default:
-        break;
-    }
-
-    lineno++;
-  }
-
-  /* TODO: should we throw an error if lineno != 10? */
-
-  /* force layer and slayer on */
-  if(map->query.layer >= 0 && map->query.layer < map->numlayers) GET_LAYER(map, map->query.layer)->status = MS_ON;
-  if(map->query.slayer >= 0 && map->query.slayer < map->numlayers) GET_LAYER(map, map->query.slayer)->status = MS_ON;
-
-  /* now execute the query */
-  return msExecuteQuery(map);
-
-parse_error:
-  msSetError(MS_MISCERR, "Parse error line %d.", "loadQueryParameters()", lineno);
-  return MS_FAILURE;
-}
-
-/*
-** Save (serialize) a query to disk. There are two methods, one saves the query parameters and the other saves
-** all the shape indexes. Note the latter can be very slow against certain data sources but has a certain usefulness
-** on occation.
-*/
-int msSaveQuery(mapObj *map, char *filename, int results)
-{
-  if(results)
-    return saveQueryResults(map, filename);
-  else
-    return saveQueryParams(map, filename);
-}
-
-/*
-** Loads a query file contained either serialized 1) query parameters or 2) query results (e.g. indexes).
-*/
-int msLoadQuery(mapObj *map, char *filename)
-{
-  FILE *stream;
-  char buffer[MS_BUFFER_LENGTH];
-  int retval=MS_FAILURE;
-
-  if(!filename) {
-    msSetError(MS_MISCERR, "No filename provided to load query from.", "msLoadQuery()");
-    return MS_FAILURE;
-  }
-
-  /*
-  ** Make sure the file at least has the right extension.
-  */
-  if(msEvalRegex("\\.qy$", filename) != MS_TRUE) {
-    msSetError(MS_MISCERR, "Queryfile %s has incorrect file extension.",  "msLoadQuery()", filename);
-    return MS_FAILURE;
-  }
-
-  /*
-  ** Open the file and inspect the first line.
-  */
-  stream = fopen(filename, "r");
-  if(!stream) {
-    msSetError(MS_IOERR, "(%s)", "msLoadQuery()", filename);
-    return MS_FAILURE;
-  }
-
-  if(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
-    /*
-    ** Call correct reader based on the magic string.
-    */
-    if(strncasecmp(buffer, MS_QUERY_RESULTS_MAGIC_STRING, strlen(MS_QUERY_RESULTS_MAGIC_STRING)) == 0) {
-      retval = loadQueryResults(map, stream);
-    } else if(strncasecmp(buffer, MS_QUERY_PARAMS_MAGIC_STRING, strlen(MS_QUERY_PARAMS_MAGIC_STRING)) == 0) {
-      retval = loadQueryParams(map, stream);
-    } else {
-      msSetError(MS_WEBERR, "Missing magic string, %s doesn't look like a MapServer query file.", "msLoadQuery()", filename);
-      retval = MS_FAILURE;
-    }
-  } else {
-    msSetError(MS_WEBERR, "Empty file or failed read for %s.", "msLoadQuery()", filename);
-    retval = MS_FAILURE;
-  }
-
-  fclose(stream);
-  return retval;
-}
-
-int msQueryByIndex(mapObj *map)
-{
-  layerObj *lp;
-  int status;
-
-  resultObj record;
-  queryCacheObj queryCache;
-
-  shapeObj shape;
-  double minfeaturesize = -1;
-
-  initQueryCache(&queryCache);
-
-  if(map->query.type != MS_QUERY_BY_INDEX) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByIndex()");
-    return(MS_FAILURE);
-  }
-
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers) {
-    msSetError(MS_QUERYERR, "No query layer defined.", "msQueryByIndex()");
-    return(MS_FAILURE);
-  }
-
-  lp = (GET_LAYER(map, map->query.layer));
-
-  if(!msIsLayerQueryable(lp)) {
-    msSetError(MS_QUERYERR, "Requested layer has no templates defined.", "msQueryByIndex()");
-    return(MS_FAILURE);
-  }
-
-  if(map->query.clear_resultcache) {
-    if(lp->resultcache) {
-      cleanupResultCache(lp->resultcache);
-      free(lp->resultcache);
-      lp->resultcache = NULL;
-    }
-  }
-
-  msLayerClose(lp); /* reset */
-  status = msLayerOpen(lp);
-  if(status != MS_SUCCESS) return(MS_FAILURE);
-  /* disable driver paging */
-  msLayerEnablePaging(lp, MS_FALSE);
-
-  /* build item list, we want *all* items */
-  status = msLayerWhichItems(lp, MS_TRUE, NULL);
-  if(status != MS_SUCCESS) return(MS_FAILURE);
-
-  if(map->query.clear_resultcache || lp->resultcache == NULL) {
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
-  }
-
-  msInitShape(&shape);
-
-  record.resultindex = -1;
-  record.shapeindex = map->query.shapeindex;
-  record.tileindex = map->query.tileindex;
-
-  status = msLayerGetShape(lp, &shape, &record);
-  if(status != MS_SUCCESS) {
-    msSetError(MS_NOTFOUND, "Not valid record request.", "msQueryByIndex()");
-    return(MS_FAILURE);
-  }
-
-  /*
-   * The resultindex is used to retrieve a specific item from the result cache.
-   * Usually, the row number will be used as resultindex. But when working with
-   * databases and querying a single result, the row number is typically 0 and
-   * thus useless as the index in the result cache. See #4926 #4076. Only shape
-   * files and flatgeobuf are considered to have consistent row numbers.
-   */
-  if ( !(lp->connectiontype == MS_SHAPEFILE || lp->connectiontype == MS_TILED_SHAPEFILE || lp->connectiontype == MS_FLATGEOBUF) ) {
-    shape.resultindex = -1;
-  }
-
-  if (lp->minfeaturesize > 0)
-    minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
-
-  /* Check if the shape size is ok to be drawn */
-  if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
-
-    if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-      msSetError(MS_NOTFOUND, "Requested shape not valid against layer minfeaturesize.", "msQueryByIndex()");
-      msFreeShape(&shape);
-      msLayerClose(lp);
-      return(MS_FAILURE);
-    }
-  }
-
-  shape.classindex = msShapeGetClass(lp, map, &shape, NULL, 0);
-  if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
-    msSetError(MS_NOTFOUND, "Requested shape not valid against layer classification scheme.", "msQueryByIndex()");
-    msFreeShape(&shape);
-    msLayerClose(lp);
-    return(MS_FAILURE);
-  }
-
-  if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
-    msSetError(MS_NOTFOUND, "Requested shape does not have a valid template, no way to present results.", "msQueryByIndex()");
-    msFreeShape(&shape);
-    msLayerClose(lp);
-    return(MS_FAILURE);
-  }
-  
-  addResult(map, lp->resultcache, &queryCache, &shape);
-
-  msFreeShape(&shape);
-  /* msLayerClose(lp); */
-
-  return(MS_SUCCESS);
-}
-
-static char *filterTranslateToLogical(expressionObj *filter, char *filteritem) {
-  char *string = NULL;
-
-  if(filter->type == MS_STRING && filteritem) {
-    string = msStrdup("'[");
-    string = msStringConcatenate(string, filteritem);
-    string = msStringConcatenate(string, "]'");
-    if(filter->flags & MS_EXP_INSENSITIVE)
-      string = msStringConcatenate(string, " =* '");
-    else
-      string = msStringConcatenate(string, " = '");
-    string = msStringConcatenate(string, filter->string);
-    string = msStringConcatenate(string, "'");
-  } else if(filter->type == MS_REGEX && filteritem) {
-    string = msStrdup("'[");
-    string = msStringConcatenate(string, filteritem);
-    string = msStringConcatenate(string, "]'");
-    if(filter->flags & MS_EXP_INSENSITIVE)
-      string = msStringConcatenate(string, " ~* '");
-    else
-      string = msStringConcatenate(string, " ~ '");
-    string = msStringConcatenate(string, filter->string);
-    string = msStringConcatenate(string, "'");
-  } else if(filter->type == MS_EXPRESSION) {
-    string = msStrdup(filter->string);
-  } else {
-    /* native expression, nothing we can do - sigh */
-  }
-
-  return string;
-}
-
-static expressionObj mergeFilters(expressionObj *filter1, char *filteritem1, expressionObj *filter2, char *filteritem2) {
-  expressionObj filter;
-
-  char *tmpstr1=NULL;
-  char *tmpstr2=NULL;
-
-  msInitExpression(&filter);
-  filter.type = MS_EXPRESSION; /* we're building a logical expression */
-
-  tmpstr1 = filterTranslateToLogical(filter1, filteritem1);
-  if(!tmpstr1) return filter; /* should only happen if the filter was a native filter */  
-
-  tmpstr2 = filterTranslateToLogical(filter2, filteritem2);
-  if(!tmpstr2) {
-    msFree(tmpstr1);
-    return filter; /* should only happen if the filter was a native filter */
-  }
-
-  filter.string = msStrdup(tmpstr1);
-  filter.string = msStringConcatenate(filter.string, " AND ");
-  filter.string = msStringConcatenate(filter.string, tmpstr2);
-
-  msFree(tmpstr1);
-  msFree(tmpstr2);
-
-  return filter;
-}
-
-/*
-** Query using common expression syntax.
-*/
-int msQueryByFilter(mapObj *map)
-{
-  int l;
-  int start, stop=0;
-
-  layerObj *lp;
-
-  char status;
-
-  char *old_filteritem=NULL;
-  expressionObj old_filter;
-
-  rectObj search_rect;
-  const rectObj invalid_rect = MS_INIT_INVALID_RECT;
-
-  shapeObj shape;
-  int paging;
-
-  int nclasses = 0;
-  int *classgroup = NULL;
-  double minfeaturesize = -1;
-  queryCacheObj queryCache;
-
-  initQueryCache(&queryCache);
-
-  if(map->query.type != MS_QUERY_BY_FILTER) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByFilter()");
-    return(MS_FAILURE);
-  }
-  if(!map->query.filter.string) {
-    msSetError(MS_QUERYERR, "Filter is not set.", "msQueryByFilter()");
-    return(MS_FAILURE);
-  }
-
-  // fprintf(stderr, "in msQueryByFilter: filter=%s, filteritem=%s\n", map->query.filter.string, map->query.filteritem);
-
-  msInitShape(&shape);
-
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
-  else
-    start = stop = map->query.layer;
-
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
-
-    lp = (GET_LAYER(map, l));
-    if (map->query.maxfeatures == 0)
-      break; /* nothing else to do */
-    else if (map->query.maxfeatures > 0)
-      lp->maxfeatures = map->query.maxfeatures;
-
-    /* using mapscript, the map->query.startindex will be unset... */
-    if (lp->startindex > 1 && map->query.startindex < 0)
-      map->query.startindex = lp->startindex;
-    
-    /* conditions may have changed since this layer last drawn, so set
-       layer->project true to recheck projection needs (Bug #673) */
-    lp->project = MS_TRUE;
-
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
-      free(lp->resultcache);
-      lp->resultcache = NULL;
-    }
-
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
-    if(lp->type == MS_LAYER_RASTER) continue; /* ok to skip? */
-
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-    }
-
-    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
-    }
-
-    paging = msLayerGetPaging(lp);
-    msLayerClose(lp); /* reset */
-    status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-    msLayerEnablePaging(lp, paging);
-
-    /* disable driver paging */
-    // msLayerEnablePaging(lp, MS_FALSE);
-        
-    old_filteritem = lp->filteritem; /* cache the existing filter/filteritem */
-    msInitExpression(&old_filter);
-    msCopyExpression(&old_filter, &lp->filter);
-        
-    /*
-    ** Set the lp->filter and lp->filteritem (may need to merge). Remember filters are *always* MapServer syntax.
-    */
-    lp->filteritem = map->query.filteritem; /* re-point lp->filteritem */
-    if(old_filter.string != NULL) { /* need to merge filters to create one logical expression */
-      msFreeExpression(&lp->filter);
-      lp->filter = mergeFilters(&map->query.filter, map->query.filteritem, &old_filter, old_filteritem);      
-      if(!lp->filter.string) {
-	msSetError(MS_MISCERR, "Filter merge failed, able to process query.", "msQueryByFilter()");
-        goto restore_old_filter;
-      }      
-    } else {
-      msCopyExpression(&lp->filter, &map->query.filter); /* apply new filter */
-    }
-
-    /* build item list, we want *all* items, note this *also* build tokens for the layer filter */
-    status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) goto restore_old_filter;
-
-    search_rect = map->query.rect;
-
-    /* If only result count is needed, we can use msLayerGetShapeCount() */
-    /* that has optimizations to avoid retrieving individual features */
-    if( map->query.only_cache_result_count &&
-        lp->template != NULL && /* always TRUE for WFS case */
-        lp->minfeaturesize <= 0 )
-    {
-      int bUseLayerSRS = MS_FALSE;
-      int numFeatures = -1;
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-      /* Optimization to detect the case where a WFS query uses in fact the */
-      /* whole layer extent, but expressed in a map SRS different from the layer SRS */
-      /* In the case, we can directly request against the layer extent in its native SRS */
-      if( lp->project &&
-          memcmp( &search_rect, &invalid_rect, sizeof(search_rect) ) != 0 &&
-          msProjectionsDiffer(&(lp->projection), &(map->projection)) )
-      {
-        rectObj layerExtent;
-        if ( msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS)
-        {
-            rectObj ext = layerExtent;
-            ext.minx -= 1e-5;
-            ext.miny -= 1e-5;
-            ext.maxx += 1e-5;
-            ext.maxy += 1e-5;
-            msProjectRect(&(lp->projection), &(map->projection), &ext);
-            if( fabs(ext.minx - search_rect.minx) <= 2e-5 &&
-                fabs(ext.miny - search_rect.miny) <= 2e-5 &&
-                fabs(ext.maxx - search_rect.maxx) <= 2e-5 &&
-                fabs(ext.maxy - search_rect.maxy) <= 2e-5 )
-            {
-              bUseLayerSRS = MS_TRUE;
-              numFeatures = msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
-            }
-        }
-      }
-#endif
-
-      if( !bUseLayerSRS )
-          numFeatures = msLayerGetShapeCount(lp, search_rect, &(map->projection));
-      if( numFeatures >= 0 )
-      {
-        lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-        MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-        initResultCache( lp->resultcache);
-        lp->resultcache->numresults = numFeatures;
-        if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
-           lp->resultcache->numresults -= (map->query.startindex-1);
-        }
-
-        lp->filteritem = old_filteritem; /* point back to original value */
-        msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
-        msFreeExpression(&old_filter);
-
-        continue;
-      }
-      // Fallback in case of error (should not happen normally)
-    }
-
-    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project && memcmp( &search_rect, &invalid_rect, sizeof(search_rect) ) != 0 )
-      msProjectRect(&(map->projection), &(lp->projection), &search_rect); /* project the searchrect to source coords */
-
-    status = msLayerWhichShapes(lp, search_rect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
-      lp->filteritem = old_filteritem; /* point back to original value */
-      msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
-      msFreeExpression(&old_filter);
-      msLayerClose(lp);
-      continue;
-    } else if(status != MS_SUCCESS) goto restore_old_filter;
-
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    initResultCache( lp->resultcache);
-
-    nclasses = 0;
-    classgroup = NULL;
-    if (lp->classgroup && lp->numclasses > 0)
-      classgroup = msAllocateValidClassGroups(lp, &nclasses);
-
-    if (lp->minfeaturesize > 0)
-      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
-
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes - if necessary the filter is applied in msLayerNextShape(...) */
-
-       /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
-        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByFilter(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
-          msFreeShape(&shape);
-          continue;
-        }
-      }
-
-      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
-        }
-        msProjectShapeEx(reprojector, &shape);
-      }
-
-      /* Should we skip this feature? */
-      if (!paging && map->query.startindex > 1) {
-        --map->query.startindex;
-        msFreeShape(&shape);
-        continue;
-      }
-    
-      if( map->query.only_cache_result_count )
-        lp->resultcache->numresults ++;
-      else
-        addResult(map, lp->resultcache, &queryCache, &shape);
-      msFreeShape(&shape);
-
-      if(map->query.mode == MS_QUERY_SINGLE) { /* no need to look any further */
-	status = MS_DONE;
-	break;
-      }
-
-      /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
-        status = MS_DONE;
-        break;
-      }
-    } /* next shape */
-
-    if(classgroup) msFree(classgroup);
-
-    lp->filteritem = old_filteritem; /* point back to original value */
-    msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
-    msFreeExpression(&old_filter);
-
-    msProjectDestroyReprojector(reprojector);
-
-    if(status != MS_DONE) return MS_FAILURE;
-    if(!map->query.only_cache_result_count && lp->resultcache->numresults == 0) 
-      msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
-
-  /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
-      return MS_SUCCESS;
-  }
-
-  if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByFilter(): No matching record(s) found.");
-  }
-  return(MS_SUCCESS);
-
-restore_old_filter:
-  lp->filteritem = old_filteritem;
-  msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
-  msFreeExpression(&old_filter);
-  msLayerClose(lp);
-  return MS_FAILURE;
-}
-
-int msQueryByRect(mapObj *map)
-{
-  int l; /* counters */
-  int start, stop=0;
-
-  layerObj *lp;
-
-  char status;
-  shapeObj shape, searchshape;
-  rectObj searchrect, searchrectInMapProj;
-  const rectObj invalid_rect = MS_INIT_INVALID_RECT;
-  double layer_tolerance = 0, tolerance = 0;
-
-  int paging;
-  int nclasses = 0;
-  int *classgroup = NULL;
-  double minfeaturesize = -1;
-  queryCacheObj queryCache;
-
-  initQueryCache(&queryCache);
-
-  if(map->query.type != MS_QUERY_BY_RECT) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByRect()");
-    return(MS_FAILURE);
-  }
-
-  msInitShape(&shape);
-  msInitShape(&searchshape);
-
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
-  else
-    start = stop = map->query.layer;
-
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
-    lp = (GET_LAYER(map, l));
-    /* Set the global maxfeatures */
-    if (map->query.maxfeatures == 0)
-      break; /* nothing else to do */
-    else if (map->query.maxfeatures > 0)
-      lp->maxfeatures = map->query.maxfeatures;
-
-    /* using mapscript, the map->query.startindex will be unset... */
-    if (lp->startindex > 1 && map->query.startindex < 0)
-      map->query.startindex = lp->startindex;
-    
-    /* conditions may have changed since this layer last drawn, so set
-       layer->project true to recheck projection needs (Bug #673) */
-    lp->project = MS_TRUE;
-
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
-      free(lp->resultcache);
-      lp->resultcache = NULL;
-    }
-
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
-
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-    }
-
-    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
-    }
-
-    searchrect = map->query.rect;
-    if(lp->tolerance > 0) {
-      layer_tolerance = lp->tolerance;
-
-      if(lp->toleranceunits == MS_PIXELS)
-        tolerance = layer_tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
-      else
-        tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
-
-      searchrect.minx -= tolerance;
-      searchrect.maxx += tolerance;
-      searchrect.miny -= tolerance;
-      searchrect.maxy += tolerance;
-    }
-    searchrectInMapProj = searchrect;
-
-    msRectToPolygon(searchrect, &searchshape);
-
-    /* Raster layers are handled specially. */
-    if( lp->type == MS_LAYER_RASTER ) {
-      if( msRasterQueryByRect( map, lp, searchrect ) == MS_FAILURE)
-        return MS_FAILURE;
-
-      continue;
-    }
-
-    /* Paging could have been disabled before */
-    paging = msLayerGetPaging(lp);
-    msLayerClose(lp); /* reset */
-    status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) {
-      msFreeShape(&searchshape);
-      return(MS_FAILURE);
-    }
-    msLayerEnablePaging(lp, paging);
-
-    /* build item list, we want *all* items */
-    status = msLayerWhichItems(lp, MS_TRUE, NULL);
-
-    if(status != MS_SUCCESS) {
-      msFreeShape(&searchshape);
-      return(MS_FAILURE);
-    }
-
-    /* If only result count is needed, we can use msLayerGetShapeCount() */
-    /* that has optimizations to avoid retrieving individual features */
-    if( map->query.only_cache_result_count &&
-        lp->template != NULL && /* always TRUE for WFS case */
-        lp->minfeaturesize <= 0 )
-    {
-      int bUseLayerSRS = MS_FALSE;
-      int numFeatures = -1;
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-      /* Optimization to detect the case where a WFS query uses in fact the */
-      /* whole layer extent, but expressed in a map SRS different from the layer SRS */
-      /* In the case, we can directly request against the layer extent in its native SRS */
-      if( lp->project &&
-          memcmp( &searchrect, &invalid_rect, sizeof(searchrect) ) != 0 &&
-          msProjectionsDiffer(&(lp->projection), &(map->projection)) )
-      {
-        rectObj layerExtent;
-        if ( msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS)
-        {
-            rectObj ext = layerExtent;
-            ext.minx -= 1e-5;
-            ext.miny -= 1e-5;
-            ext.maxx += 1e-5;
-            ext.maxy += 1e-5;
-            msProjectRect(&(lp->projection), &(map->projection), &ext);
-            if( fabs(ext.minx - searchrect.minx) <= 2e-5 &&
-                fabs(ext.miny - searchrect.miny) <= 2e-5 &&
-                fabs(ext.maxx - searchrect.maxx) <= 2e-5 &&
-                fabs(ext.maxy - searchrect.maxy) <= 2e-5 )
-            {
-              bUseLayerSRS = MS_TRUE;
-              numFeatures = msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
-            }
-        }
-      }
-#endif
-
-      if( !bUseLayerSRS )
-          numFeatures = msLayerGetShapeCount(lp, searchrect, &(map->projection));
-      if( numFeatures >= 0 )
-      {
-        lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-        MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-        initResultCache( lp->resultcache);
-        lp->resultcache->numresults = numFeatures;
-        if (!paging && map->query.startindex > 1) {
-           lp->resultcache->numresults -= (map->query.startindex-1);
-        }
-        msFreeShape(&searchshape);
-        continue;
-      }
-      // Fallback in case of error (should not happen normally)
-    }
-
-    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project &&
-       memcmp( &searchrect, &invalid_rect, sizeof(searchrect) ) != 0 )
-      msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
-
-    status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
-      msLayerClose(lp);
-      continue;
-    } else if(status != MS_SUCCESS) {
-      msLayerClose(lp);
-      msFreeShape(&searchshape);
-      return(MS_FAILURE);
-    }
-
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
-
-    nclasses = 0;
-    classgroup = NULL;
-    if (lp->classgroup && lp->numclasses > 0)
-      classgroup = msAllocateValidClassGroups(lp, &nclasses);
-
-    if (lp->minfeaturesize > 0)
-      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
-
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
-
-      /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
-        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByRect(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
-          msFreeShape(&shape);
-          continue;
-        }
-      }
-
-      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
-        }
-        if( msProjectShapeEx(reprojector, &shape) != MS_SUCCESS ) {
-            // msProjectShapeEx() calls msFreeShape() on error
-            continue;
-        }
-      }
-
-      if(msRectContained(&shape.bounds, &searchrectInMapProj) == MS_TRUE) { /* if the whole shape is in, don't intersect */
-        status = MS_TRUE;
-      } else {
-        switch(shape.type) { /* make sure shape actually intersects the qrect (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
-          case MS_SHAPE_POINT:
-            status = msIntersectMultipointPolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_LINE:
-            status = msIntersectPolylinePolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_POLYGON:
-            status = msIntersectPolygons(&shape, &searchshape);
-            break;
-          case MS_SHAPE_NULL:
-              status = MS_TRUE;
-              break;
-          default:
-            break;
-        }
-      }
-
-      if(status == MS_TRUE) {
-        /* Should we skip this feature? */
-        if (!paging && map->query.startindex > 1) {
-          --map->query.startindex;
-          msFreeShape(&shape);
-          continue;
-        }
-        if( map->query.only_cache_result_count )
-            lp->resultcache->numresults ++;
-        else
-            addResult(map, lp->resultcache, &queryCache, &shape);
-        --map->query.maxfeatures;
-      }
-      msFreeShape(&shape);
-
-      /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
-        status = MS_DONE;
-        break;
-      }
-      
-    } /* next shape */
-
-    if (classgroup)
-      msFree(classgroup);
-
-    msProjectDestroyReprojector(reprojector);
-
-    if(status != MS_DONE) {
-        msFreeShape(&searchshape);
-        return(MS_FAILURE);
-    }
-
-    if( !map->query.only_cache_result_count &&
-        lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
-
-  msFreeShape(&searchshape);
-
-  /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
-      return(MS_SUCCESS);
-  }
-
-  if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByRect(): No matching record(s) found.");
-  }
-  return(MS_SUCCESS);
-}
-
-static int is_duplicate(resultCacheObj *resultcache, int shapeindex, int tileindex)
-{
-  int i;
-
-  for(i=0; i<resultcache->numresults; i++)
-    if(resultcache->results[i].shapeindex == shapeindex && resultcache->results[i].tileindex == tileindex) return(MS_TRUE);
-
-  return(MS_FALSE);
-}
-
-int msQueryByFeatures(mapObj *map)
-{
-  int i, l;
-  int start, stop=0;
-  layerObj *lp, *slp;
-  char status;
-
-  double distance, tolerance, layer_tolerance;
-
-  rectObj searchrect;
-  shapeObj shape, selectshape;
-  int nclasses = 0;
-  int *classgroup = NULL;
-  double minfeaturesize = -1;
-
-  queryCacheObj queryCache;
-
-  initQueryCache(&queryCache);
-
-  if(map->debug) msDebug("in msQueryByFeatures()\n");
-
-  /* is the selection layer valid and has it been queried */
-  if(map->query.slayer < 0 || map->query.slayer >= map->numlayers) {
-    msSetError(MS_QUERYERR, "Invalid selection layer index.", "msQueryByFeatures()");
-    return(MS_FAILURE);
-  }
-  slp = (GET_LAYER(map, map->query.slayer));
-  if(!slp->resultcache) {
-    msSetError(MS_QUERYERR, "Selection layer has not been queried.", "msQueryByFeatures()");
-    return(MS_FAILURE);
-  }
-
-  /* conditions may have changed since this layer last drawn, so set
-     layer->project true to recheck projection needs (Bug #673) */
-  slp->project = msProjectionsDiffer(&(slp->projection), &(map->projection));
-
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
-  else
-    start = stop = map->query.layer;
-
-  /* selection layers should already be open */
-  /* status = msLayerOpen(slp);
-  if(status != MS_SUCCESS) return(MS_FAILURE); */
-
-  msInitShape(&shape); /* initialize a few things */
-  msInitShape(&selectshape);
-
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
-    if(l == map->query.slayer) continue; /* skip the selection layer */
-
-    lp = (GET_LAYER(map, l));
-    if (map->query.maxfeatures == 0)
-      break; /* nothing else to do */
-    else if (map->query.maxfeatures > 0)
-      lp->maxfeatures = map->query.maxfeatures;
-
-    /* using mapscript, the map->query.startindex will be unset... */
-    if (lp->startindex > 1 && map->query.startindex < 0)
-      map->query.startindex = lp->startindex;
-
-    /* conditions may have changed since this layer last drawn, so set
-       layer->project true to recheck projection needs (Bug #673) */
-    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
-      free(lp->resultcache);
-      lp->resultcache = NULL;
-    }
-
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
-
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-    }
-
-    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
-    }
-
-    /* Get the layer tolerance default is 3 for point and line layers, 0 for others */
-    if(lp->tolerance == -1) {
-      if(lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
-        layer_tolerance = 3;
-      else
-        layer_tolerance = 0;
-    } else
-      layer_tolerance = lp->tolerance;
-
-    if(lp->toleranceunits == MS_PIXELS)
-      tolerance = layer_tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
-    else
-      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
-
-    msLayerClose(lp); /* reset */
-    status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-    msLayerEnablePaging(lp, MS_FALSE);
-
-    /* build item list, we want *all* items */
-    status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-
-    /* for each selection shape */
-    for(i=0; i<slp->resultcache->numresults; i++) {
-
-      status = msLayerGetShape(slp, &selectshape, &(slp->resultcache->results[i]));
-      if(status != MS_SUCCESS) {
-        msLayerClose(lp);
-        msLayerClose(slp);
-        return(MS_FAILURE);
-      }
-
-      if(selectshape.type != MS_SHAPE_POLYGON && selectshape.type != MS_SHAPE_LINE) {
-        msLayerClose(lp);
-        msLayerClose(slp);
-        msSetError(MS_QUERYERR, "Selection features MUST be polygons or lines.", "msQueryByFeatures()");
-        return(MS_FAILURE);
-      }
-
-      if(slp->project)
-        msProjectShape(&(slp->projection), &(map->projection), &selectshape);
-
-      /* identify target shapes */
-      searchrect = selectshape.bounds;
-
-      searchrect.minx -= tolerance; /* expand the search box to account for layer tolerances (e.g. buffered searches) */
-      searchrect.maxx += tolerance;
-      searchrect.miny -= tolerance;
-      searchrect.maxy += tolerance;
-
-      if(lp->project)
-        msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
-
-      status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-      if(status == MS_DONE) { /* no overlap */
-        msLayerClose(lp);
-        break; /* next layer */
-      } else if(status != MS_SUCCESS) {
-        msLayerClose(lp);
-        msLayerClose(slp);
-        return(MS_FAILURE);
-      }
-
-      if(i == 0) {
-        lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-        MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-        initResultCache( lp->resultcache);
-
-      }
-
-      nclasses = 0;
-      classgroup = NULL;
-      if (lp->classgroup && lp->numclasses > 0)
-        classgroup = msAllocateValidClassGroups(lp, &nclasses);
-
-      if (lp->minfeaturesize > 0)
-        minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
-
-      while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
-
-        /* check for dups when there are multiple selection shapes */
-        if(i > 0 && is_duplicate(lp->resultcache, shape.index, shape.tileindex)) continue;
-
-
-        /* Check if the shape size is ok to be drawn */
-        if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
-          if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-            if( lp->debug >= MS_DEBUGLEVEL_V )
-              msDebug("msQueryByFeature(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
-            msFreeShape(&shape);
-            continue;
-          }
-        }
-
-        shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-        if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
-          msFreeShape(&shape);
-          continue;
-        }
-
-        if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
-          msFreeShape(&shape);
-          continue;
-        }
-
-        if(lp->project) {
-            if( reprojector == NULL ) {
-                reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-                if( reprojector == NULL ) {
-                    msFreeShape(&shape);
-                    status = MS_FAILURE;
-                    break;
-                }
-            }
-            msProjectShapeEx(reprojector, &shape);
-        }
-
-        switch(selectshape.type) { /* may eventually support types other than polygon on line */
-          case MS_SHAPE_POLYGON:
-            switch(shape.type) { /* make sure shape actually intersects the selectshape */
-              case MS_SHAPE_POINT:
-                if(tolerance == 0) /* just test for intersection */
-                  status = msIntersectMultipointPolygon(&shape, &selectshape);
-                else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_LINE:
-                if(tolerance == 0) { /* just test for intersection */
-                  status = msIntersectPolylinePolygon(&shape, &selectshape);
-                } else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_POLYGON:
-                if(tolerance == 0) /* just test for intersection */
-                  status = msIntersectPolygons(&shape, &selectshape);
-                else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              default:
-                status = MS_FALSE;
-                break;
-            }
-            break;
-          case MS_SHAPE_LINE:
-            switch(shape.type) { /* make sure shape actually intersects the selectshape */
-              case MS_SHAPE_POINT:
-                if(tolerance == 0) { /* just test for intersection */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance == 0) status = MS_TRUE;
-                } else {
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_LINE:
-                if(tolerance == 0) { /* just test for intersection */
-                  status = msIntersectPolylines(&shape, &selectshape);
-                } else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_POLYGON:
-                if(tolerance == 0) /* just test for intersection */
-                  status = msIntersectPolylinePolygon(&selectshape, &shape);
-                else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              default:
-                status = MS_FALSE;
-                break;
-            }
-            break;
-          default:
-            break; /* should never get here as we test for selection shape type explicitly earlier */
-        }
-
-        if(status == MS_TRUE) {
-          /* Should we skip this feature? */
-          if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
-            --map->query.startindex;
-            msFreeShape(&shape);
-            continue;
-          }
-          addResult(map, lp->resultcache, &queryCache, &shape);
-        }
-        msFreeShape(&shape);
-
-        /* check shape count */
-        if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
-          status = MS_DONE;
-          break;
-        }
-      } /* next shape */
-
-      if (classgroup)
-        msFree(classgroup);
-
-      msProjectDestroyReprojector(reprojector);
-
-      msFreeShape(&selectshape);
-
-      if(status != MS_DONE) return(MS_FAILURE);
-
-    } /* next selection shape */
-
-    if(lp->resultcache == NULL || lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
-
-  /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(l == map->query.slayer) continue; /* skip the selection layer */
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0) return(MS_SUCCESS);
-  }
-
-  if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByFeatures(): No matching record(s) found.");
-  }
-  return(MS_SUCCESS);
-}
-
-/* msQueryByPoint()
- *
- * With mode=MS_QUERY_SINGLE:
- *   Set maxresults = 0 to have a single result across all layers (the closest
- *     shape from the first layer that finds a match).
- *   Set maxresults = 1 to have up to one result per layer (the closest shape
- *     from each layer).
- *
- * With mode=MS_QUERY_MULTIPLE:
- *   Set maxresults = 0 to have an unlimited number of results.
- *   Set maxresults > 0 to limit the number of results per layer (the shapes
- *     returned are the first ones found in each layer and are not necessarily
- *     the closest ones).
- */
-int msQueryByPoint(mapObj *map)
-{
-  int l;
-  int start, stop=0;
-
-  double d, t;
-  double layer_tolerance;
-
-  layerObj *lp;
-
-  int paging;
-  char status;
-  rectObj rect, searchrect;
-  shapeObj shape;
-  int nclasses = 0;
-  int *classgroup = NULL;
-  double minfeaturesize = -1;
-
-  queryCacheObj queryCache;
-
-  initQueryCache(&queryCache);
-
-  if(map->query.type != MS_QUERY_BY_POINT) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByPoint()");
-    return(MS_FAILURE);
-  }
-
-  msInitShape(&shape);
-
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
-  else
-    start = stop = map->query.layer;
-
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
-    lp = (GET_LAYER(map, l));
-    if (map->query.maxfeatures == 0)
-      break; /* nothing else to do */
-    else if (map->query.maxfeatures > 0)
-      lp->maxfeatures = map->query.maxfeatures;
-
-    /* using mapscript, the map->query.startindex will be unset... */
-    if (lp->startindex > 1 && map->query.startindex < 0)
-      map->query.startindex = lp->startindex;
-    
-    /* conditions may have changed since this layer last drawn, so set
-       layer->project true to recheck projection needs (Bug #673) */
-    lp->project = MS_TRUE;
-
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
-      free(lp->resultcache);
-      lp->resultcache = NULL;
-    }
-
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
-
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-    }
-
-    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
-    }
-
-    /* Raster layers are handled specially.  */
-    if( lp->type == MS_LAYER_RASTER ) {
-      if( msRasterQueryByPoint( map, lp, map->query.mode, map->query.point, map->query.buffer, map->query.maxresults ) == MS_FAILURE )
-        return MS_FAILURE;
-      continue;
-    }
-
-    /* Get the layer tolerance default is 3 for point and line layers, 0 for others */
-    if(lp->tolerance == -1) {
-      if(lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
-        layer_tolerance = 3;
-      else
-        layer_tolerance = 0;
-    } else
-      layer_tolerance = lp->tolerance;
-
-    if(map->query.buffer <= 0) { /* use layer tolerance */
-      if(lp->toleranceunits == MS_PIXELS)
-        t = layer_tolerance * MS_MAX(MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
-                                     MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
-      else
-        t = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
-    } else /* use buffer distance */
-      t = map->query.buffer;
-
-    rect.minx = map->query.point.x - t;
-    rect.maxx = map->query.point.x + t;
-    rect.miny = map->query.point.y - t;
-    rect.maxy = map->query.point.y + t;
-
-    /* Paging could have been disabled before */
-    paging = msLayerGetPaging(lp);
-    msLayerClose(lp); /* reset */
-    status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-    msLayerEnablePaging(lp, paging);
-
-    /* build item list, we want *all* items */
-    status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-
-    /* identify target shapes */
-    searchrect = rect;
-    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project)
-      msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
-
-    status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
-      msLayerClose(lp);
-      continue;
-    } else if(status != MS_SUCCESS) {
-      msLayerClose(lp);
-      return(MS_FAILURE);
-    }
-
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
-
-    nclasses = 0;
-    classgroup = NULL;
-    if (lp->classgroup && lp->numclasses > 0)
-      classgroup = msAllocateValidClassGroups(lp, &nclasses);
-
-    if (lp->minfeaturesize > 0)
-      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
-
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
-
-      /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
-        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByPoint(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
-          msFreeShape(&shape);
-          continue;
-        }
-      }
-
-      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
-        }
-        msProjectShapeEx(reprojector, &shape);
-      }
-
-      d = msDistancePointToShape(&(map->query.point), &shape);
-      if( d <= t ) { /* found one */
-
-        /* Should we skip this feature? */
-        if (!paging && map->query.startindex > 1) {
-          --map->query.startindex;
-          msFreeShape(&shape);
-          continue;
-        }
-
-        if(map->query.mode == MS_QUERY_SINGLE) {
-          cleanupResultCache(lp->resultcache);
-          initQueryCache(&queryCache);
-          addResult(map, lp->resultcache, &queryCache, &shape);
-          t = d; /* next one must be closer */
-        } else {
-          addResult(map, lp->resultcache, &queryCache, &shape);
-        }
-      }
-
-      msFreeShape(&shape);
-
-      if(map->query.mode == MS_QUERY_MULTIPLE && map->query.maxresults > 0 && lp->resultcache->numresults == map->query.maxresults) {
-        status = MS_DONE;   /* got enough results for this layer */
-        break;
-      }
-
-      /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
-        status = MS_DONE;
-        break;
-      }
-    } /* next shape */
-
-    if (classgroup)
-      msFree(classgroup);
-
-    msProjectDestroyReprojector(reprojector);
-
-    if(status != MS_DONE) return(MS_FAILURE);
-
-    if(lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
-
-    if((lp->resultcache->numresults > 0) && (map->query.mode == MS_QUERY_SINGLE) && (map->query.maxresults == 0))
-      break;   /* no need to search any further */
-  } /* next layer */
-
-  /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
-      return(MS_SUCCESS);
-  }
-
-  if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByPoint(): No matching record(s) found.");
-  }
-  return(MS_SUCCESS);
-}
-
-int msQueryByShape(mapObj *map)
-{
-  int start, stop=0, l;
-  shapeObj shape, *qshape=NULL;
-  layerObj *lp;
-  char status;
-  double distance, tolerance, layer_tolerance;
-  rectObj searchrect;
-
-  int nclasses = 0;
-  int *classgroup = NULL;
-  double minfeaturesize = -1;
-  queryCacheObj queryCache;
-
-  initQueryCache(&queryCache);
-
-  if(map->query.type != MS_QUERY_BY_SHAPE) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByShape()");
-    return(MS_FAILURE);
-  }
-
-  if(!(map->query.shape)) {
-    msSetError(MS_QUERYERR, "Query shape is not defined.", "msQueryByShape()");
-    return(MS_FAILURE);
-  }
-  if(map->query.shape->type != MS_SHAPE_POLYGON && map->query.shape->type != MS_SHAPE_LINE && map->query.shape->type != MS_SHAPE_POINT) {
-    msSetError(MS_QUERYERR, "Query shape MUST be a polygon, line or point.", "msQueryByShape()");
-    return(MS_FAILURE);
-  }
-
-  msInitShape(&shape);
-  qshape = map->query.shape; /* for brevity */
-
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
-  else
-    start = stop = map->query.layer;
-
-  msComputeBounds(qshape); /* make sure an accurate extent exists */
-
-  for(l=start; l>=stop; l--) { /* each layer */
-    reprojectionObj* reprojector = NULL;
-    lp = (GET_LAYER(map, l));
-    if (map->query.maxfeatures == 0)
-      break; /* nothing else to do */
-    else if (map->query.maxfeatures > 0)
-      lp->maxfeatures = map->query.maxfeatures;
-
-    /* using mapscript, the map->query.startindex will be unset... */
-    if (lp->startindex > 1 && map->query.startindex < 0)
-      map->query.startindex = lp->startindex;
-
-    /* conditions may have changed since this layer last drawn, so set
-       layer->project true to recheck projection needs (Bug #673) */
-    lp->project = MS_TRUE;
-
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
-      free(lp->resultcache);
-      lp->resultcache = NULL;
-    }
-
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
-
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-    }
-
-    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
-    }
-
-    /* Raster layers are handled specially. */
-    if( lp->type == MS_LAYER_RASTER ) {
-      if( msRasterQueryByShape(map, lp, qshape) == MS_FAILURE )
-        return MS_FAILURE;
-      continue;
-    }
-
-    /* Get the layer tolerance default is 3 for point and line layers, 0 for others */
-    if(lp->tolerance == -1) {
-      if(lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
-        layer_tolerance = 3;
-      else
-        layer_tolerance = 0;
-    } else
-      layer_tolerance = lp->tolerance;
-
-    if(lp->toleranceunits == MS_PIXELS)
-      tolerance = layer_tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
-    else
-      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
-
-    msLayerClose(lp); /* reset */
-    status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-    /* disable driver paging */
-    msLayerEnablePaging(lp, MS_FALSE);
-
-    /* build item list, we want *all* items */
-    status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-
-    /* identify target shapes */
-    searchrect = qshape->bounds;
-
-    searchrect.minx -= tolerance; /* expand the search box to account for layer tolerances (e.g. buffered searches) */
-    searchrect.maxx += tolerance;
-    searchrect.miny -= tolerance;
-    searchrect.maxy += tolerance;
-
-    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project)
-      msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
-
-    status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
-      msLayerClose(lp);
-      continue;
-    } else if(status != MS_SUCCESS) {
-      msLayerClose(lp);
-      return(MS_FAILURE);
-    }
-
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
-
-    nclasses = 0;
-    if (lp->classgroup && lp->numclasses > 0)
-      classgroup = msAllocateValidClassGroups(lp, &nclasses);
-
-    if (lp->minfeaturesize > 0)
-      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
-
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
-
-      /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
-        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByShape(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
-          msFreeShape(&shape);
-          continue;
-        }
-      }
-
-      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
-        msFreeShape(&shape);
-        continue;
-      }
-
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
-        }
-        msProjectShapeEx(reprojector, &shape);
-      }
-
-      switch(qshape->type) { /* may eventually support types other than polygon or line */
-        case MS_SHAPE_POLYGON:
-          switch(shape.type) { /* make sure shape actually intersects the shape */
-            case MS_SHAPE_POINT:
-              if(tolerance == 0) /* just test for intersection */
-                status = msIntersectMultipointPolygon(&shape, qshape);
-              else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_LINE:
-              if(tolerance == 0) { /* just test for intersection */
-                status = msIntersectPolylinePolygon(&shape, qshape);
-              } else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_POLYGON:
-              if(tolerance == 0) /* just test for intersection */
-                status = msIntersectPolygons(&shape, qshape);
-              else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            default:
-              break;
-          }
-          break;
-        case MS_SHAPE_LINE:
-          switch(shape.type) { /* make sure shape actually intersects the selectshape */
-            case MS_SHAPE_POINT:
-              if(tolerance == 0) { /* just test for intersection */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance == 0) status = MS_TRUE;
-              } else {
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_LINE:
-              if(tolerance == 0) { /* just test for intersection */
-                status = msIntersectPolylines(&shape, qshape);
-              } else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_POLYGON:
-              if(tolerance == 0) /* just test for intersection */
-                status = msIntersectPolylinePolygon(qshape, &shape);
-              else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            default:
-              status = MS_FALSE;
-              break;
-          }
-          break;
-        case MS_SHAPE_POINT:
-          distance = msDistanceShapeToShape(qshape, &shape);
-          status = MS_FALSE;
-          if(tolerance == 0 && distance == 0) status = MS_TRUE; /* shapes intersect */
-          else if(distance < tolerance) status = MS_TRUE; /* shapes are close enough */
-          break;
-        default:
-          break; /* should never get here as we test for selection shape type explicitly earlier */
-      }
-
-      if(status == MS_TRUE) {
-        /* Should we skip this feature? */
-        if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
-          --map->query.startindex;
-          msFreeShape(&shape);
-          continue;
-        }
-        addResult(map, lp->resultcache, &queryCache, &shape);
-      }
-      msFreeShape(&shape);
-
-      /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
-        status = MS_DONE;
-        break;
-      }
-    } /* next shape */
-
-    free(classgroup);
-    classgroup = NULL;
-
-    msProjectDestroyReprojector(reprojector);
-
-    if(status != MS_DONE) {
-      return(MS_FAILURE);
-    }
-
-    if(lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
-
-  /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
-      return(MS_SUCCESS);
-  }
-
-  if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByShape(): No matching record(s) found.");
-  }
-  return(MS_SUCCESS);
-}
-
-/* msGetQueryResultBounds()
- *
- * Compute the BBOX of all query results, returns the number of layers found
- * that contained query results and were included in the BBOX.
- * i.e. if we return 0 then the value in bounds is invalid.
- */
-int msGetQueryResultBounds(mapObj *map, rectObj *bounds)
-{
-  int i, found=0;
-  rectObj tmpBounds;
-
-  for(i=0; i<map->numlayers; i++) {
-
-    layerObj *lp;
-    lp = (GET_LAYER(map, i));
-
-    if(!lp->resultcache) continue;
-    if(lp->resultcache->numresults <= 0) continue;
-
-    tmpBounds = lp->resultcache->bounds;
-
-    if(found == 0) {
-      *bounds = tmpBounds;
-    } else {
-      msMergeRect(bounds, &tmpBounds);
-    }
-
-    found++;
-  }
-
-  return found;
-}
-
-/* TODO: Rename this msFreeResultSet() or something along those lines... */
-/* msQueryFree()
- *
- * Free layer's query results. If qlayer == -1, all layers will be treated.
- */
-void msQueryFree(mapObj *map, int qlayer)
-{
-  int l; /* counters */
-  int start, stop=0;
-  layerObj *lp;
-
-  if(qlayer < 0 || qlayer >= map->numlayers)
-    start = map->numlayers-1;
-  else
-    start = stop = qlayer;
-
-  for(l=start; l>=stop; l--) {
-    lp = (GET_LAYER(map, l));
-
-    if(lp->resultcache) {
-      if(lp->resultcache->results)
-        free(lp->resultcache->results);
-      free(lp->resultcache);
-      lp->resultcache = NULL;
-    }
-  }
-}
diff -pruN 8.0.1-5/mapraster.c 8.2.0~beta1-1~exp1/mapraster.c
--- 8.0.1-5/mapraster.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapraster.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1138 +0,0 @@
-/******************************************************************************
- * $id: mapraster.c 10772 2010-11-29 18:27:02Z aboudreault $
- *
- * Project:  MapServer
- * Purpose:  msDrawRasterLayer(): generic raster layer drawing.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *           Pete Olson (LMIC)
- *           Steve Lime
- *
- ******************************************************************************
- * Copyright (c) 1996-2010 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <assert.h>
-#include "mapserver.h"
-#include "mapfile.h"
-#include "mapresample.h"
-#include "mapthread.h"
-
-
-
-extern int msyylex_destroy(void);
-extern int yyparse(parseObj *);
-
-extern parseResultObj yypresult; /* result of parsing, true/false */
-
-#include "gdal.h"
-#include "cpl_string.h"
-#include "mapraster.h"
-
-#define MAXCOLORS 256
-#define BUFLEN 1024
-#define HDRLEN 8
-
-#define CVT(x) ((x) >> 8) /* converts to 8-bit color value */
-
-#define NUMGRAYS 16
-
-/************************************************************************/
-/*                         msGetClass_String()                          */
-/************************************************************************/
-
-static int msGetClass_String( layerObj *layer, colorObj *color, const char *pixel_value, int firstClassToTry )
-
-{
-  int i;
-  const char *tmpstr1=NULL;
-  int numitems;
-  char *item_names[4] = { "pixel", "red", "green", "blue" };
-  char *item_values[4];
-  char red_value[8], green_value[8], blue_value[8];
-
-  /* -------------------------------------------------------------------- */
-  /*      No need to do a lookup in the case of one default class.        */
-  /* -------------------------------------------------------------------- */
-  if((layer->numclasses == 1) && !(layer->class[0]->expression.string)) /* no need to do lookup */
-    return(0);
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup values list for expressions.                              */
-  /* -------------------------------------------------------------------- */
-  numitems = 4;
-  if( color->red == -1 && color->green == -1 && color->blue == -1 )
-  {
-    strcpy(red_value, "-1");
-    strcpy(green_value, "-1");
-    strcpy(blue_value, "-1");
-  }
-  else
-  {
-    sprintf( red_value, "%d", color->red );
-    sprintf( green_value, "%d", color->green );
-    sprintf( blue_value, "%d", color->blue );
-  }
-
-  item_values[0] = (char *)pixel_value;
-  item_values[1] = red_value;
-  item_values[2] = green_value;
-  item_values[3] = blue_value;
-
-  /* -------------------------------------------------------------------- */
-  /*      Loop over classes till we find a match.                         */
-  /* -------------------------------------------------------------------- */
-  if( firstClassToTry >= layer->numclasses )
-      firstClassToTry = -1;
-  for(i=0; i<layer->numclasses; i++) {
-
-    const int idx = firstClassToTry < 0 ? i :
-                    i == 0 ? firstClassToTry :
-                    i <= firstClassToTry ? i - 1:
-                    i;
-
-    /* check for correct classgroup, if set */
-    if ( layer->class[idx]->group && layer->classgroup &&
-         strcasecmp(layer->class[idx]->group, layer->classgroup) != 0 )
-      continue;
-
-    /* Empty expression - always matches */
-    if (layer->class[idx]->expression.string == NULL)
-      return(i);
-
-    switch(layer->class[idx]->expression.type) {
-
-        /* -------------------------------------------------------------------- */
-        /*      Simple string match                                             */
-        /* -------------------------------------------------------------------- */
-      case(MS_STRING):
-        /* trim junk white space */
-        tmpstr1= pixel_value;
-        while( *tmpstr1 == ' ' )
-          tmpstr1++;
-
-        if(strcmp(layer->class[idx]->expression.string, tmpstr1) == 0) return(idx); /* matched */
-        break;
-
-        /* -------------------------------------------------------------------- */
-        /*      Regular expression.  Rarely used for raster.                    */
-        /* -------------------------------------------------------------------- */
-      case(MS_REGEX):
-        if(!layer->class[idx]->expression.compiled) {
-          if(ms_regcomp(&(layer->class[idx]->expression.regex), layer->class[idx]->expression.string, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) { /* compile the expression  */
-            msSetError(MS_REGEXERR, "Invalid regular expression.", "msGetClass()");
-            return(-1);
-          }
-          layer->class[idx]->expression.compiled = MS_TRUE;
-        }
-
-        if(ms_regexec(&(layer->class[idx]->expression.regex), pixel_value, 0, NULL, 0) == 0) return(idx); /* got a match */
-        break;
-
-        /* -------------------------------------------------------------------- */
-        /*      Parsed expression.                                              */
-        /* -------------------------------------------------------------------- */
-      case(MS_EXPRESSION): {
-        int status;
-        parseObj p;
-        shapeObj dummy_shape;
-        expressionObj *expression = &(layer->class[idx]->expression);
-
-        dummy_shape.numvalues = numitems;
-        dummy_shape.values = item_values;
-
-        if( expression->tokens == NULL )
-          msTokenizeExpression( expression, item_names, &numitems );
-
-        p.shape = &dummy_shape;
-        p.expr = expression;
-        p.expr->curtoken = p.expr->tokens; /* reset */
-        p.type = MS_PARSE_TYPE_BOOLEAN;
-
-        status = yyparse(&p);
-
-        if (status != 0) {
-          msSetError(MS_PARSEERR, "Failed to parse expression: %s", "msGetClass_FloatRGB", expression->string);
-          return -1;
-        }
-
-        if( p.result.intval )
-          return idx;
-        break;
-      }
-    }
-  }
-
-  return(-1); /* not found */
-}
-
-/************************************************************************/
-/*                             msGetClass()                             */
-/************************************************************************/
-
-int msGetClass(layerObj *layer, colorObj *color, int colormap_index)
-{
-  char pixel_value[12];
-
-  snprintf( pixel_value, sizeof(pixel_value), "%d", colormap_index );
-
-  return msGetClass_String( layer, color, pixel_value, -1 );
-}
-
-/************************************************************************/
-/*                          msGetClass_FloatRGB()                       */
-/*                                                                      */
-/*      Returns the class based on classification of a floating         */
-/*      pixel value.                                                    */
-/************************************************************************/
-
-int msGetClass_FloatRGB(layerObj *layer, float fValue, int red, int green, int blue )
-{
-    return msGetClass_FloatRGB_WithFirstClassToTry(
-                layer, fValue, red, green, blue, -1);
-}
-
-
-int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue, int red, int green, int blue, int firstClassToTry )
-{
-  char pixel_value[100];
-  colorObj color;
-
-  color.red = red;
-  color.green = green;
-  color.blue = blue;
-
-  snprintf( pixel_value, sizeof(pixel_value), "%18g", fValue );
-
-  return msGetClass_String( layer, &color, pixel_value, firstClassToTry );
-}
-
-/************************************************************************/
-/*                      msRasterSetupTileLayer()                        */
-/*                                                                      */
-/*      Setup the tile layer.                                           */
-/************************************************************************/
-
-int msDrawRasterSetupTileLayer(mapObj *map, layerObj *layer,
-                               rectObj* psearchrect,
-                               int is_query,
-                               int* ptilelayerindex, /* output */
-                               int* ptileitemindex, /* output */
-                               int* ptilesrsindex, /* output */
-                               layerObj **ptlp  /* output */ )
-{
-    int i;
-    char* requested_fields;
-    int status;
-    layerObj* tlp = NULL;
-
-    *ptilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
-    if(*ptilelayerindex == -1) { /* the tileindex references a file, not a layer */
-
-      /* so we create a temporary layer */
-      tlp = (layerObj *) malloc(sizeof(layerObj));
-      MS_CHECK_ALLOC(tlp, sizeof(layerObj), MS_FAILURE);
-
-      initLayer(tlp, map);
-      *ptlp = tlp;
-
-      /* set a few parameters for a very basic shapefile-based layer */
-      tlp->name = msStrdup("TILE");
-      tlp->type = MS_LAYER_TILEINDEX;
-      tlp->data = msStrdup(layer->tileindex);
-
-      if( is_query )
-      {
-        tlp->map = map;  /*needed when scaletokens are applied, to extract current map scale */
-        for(i = 0; i < layer->numscaletokens; i++) {
-          if(msGrowLayerScaletokens(tlp) == NULL) {
-            return MS_FAILURE;
-          }
-          initScaleToken(&tlp->scaletokens[i]);
-          msCopyScaleToken(&layer->scaletokens[i],&tlp->scaletokens[i]);
-          tlp->numscaletokens++;
-        }
-      }
-
-      if (layer->projection.numargs > 0 &&
-        EQUAL(layer->projection.args[0], "auto"))
-      {
-          tlp->projection.numargs = 1;
-          tlp->projection.args[0] = msStrdup("auto");
-      }
-
-      if (layer->filteritem)
-        tlp->filteritem = msStrdup(layer->filteritem);
-      if (layer->filter.string) {
-        if (layer->filter.type == MS_EXPRESSION) {
-          char* pszTmp =
-            (char *)msSmallMalloc(sizeof(char)*(strlen(layer->filter.string)+3));
-          sprintf(pszTmp,"(%s)",layer->filter.string);
-          msLoadExpressionString(&tlp->filter, pszTmp);
-          free(pszTmp);
-        } else if (layer->filter.type == MS_REGEX ||
-                   layer->filter.type == MS_IREGEX) {
-          char* pszTmp =
-            (char *)msSmallMalloc(sizeof(char)*(strlen(layer->filter.string)+3));
-          sprintf(pszTmp,"/%s/",layer->filter.string);
-          msLoadExpressionString(&tlp->filter, pszTmp);
-          free(pszTmp);
-        } else
-          msLoadExpressionString(&tlp->filter, layer->filter.string);
-
-        tlp->filter.type = layer->filter.type;
-      }
-
-    } else {
-      if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-        return MS_FAILURE;
-      tlp = (GET_LAYER(layer->map, *ptilelayerindex));
-      *ptlp = tlp;
-    }
-    status = msLayerOpen(tlp);
-    if(status != MS_SUCCESS) {
-      return status;
-    }
-
-    /* fetch tileitem and tilesrs fields */
-    requested_fields = (char*) msSmallMalloc(sizeof(char)*(strlen(layer->tileitem)+1+
-                                    (layer->tilesrs ? strlen(layer->tilesrs) : 0) + 1));
-    if( layer->tilesrs != NULL )
-        sprintf(requested_fields, "%s,%s", layer->tileitem, layer->tilesrs);
-    else
-        strcpy(requested_fields, layer->tileitem);
-    status = msLayerWhichItems(tlp, MS_FALSE, requested_fields);
-    msFree(requested_fields);
-    if(status != MS_SUCCESS) {
-      return status;
-    }
-
-    /* get the tileitem and tilesrs index */
-    for(i=0; i<tlp->numitems; i++) {
-      if(strcasecmp(tlp->items[i], layer->tileitem) == 0) {
-        *ptileitemindex = i;
-      }
-      if(layer->tilesrs != NULL &&
-         strcasecmp(tlp->items[i], layer->tilesrs) == 0) {
-        *ptilesrsindex = i;
-      }
-    }
-    if(*ptileitemindex < 0) { /* didn't find it */
-      msSetError(MS_MEMERR,
-                 "Could not find attribute %s in tileindex.",
-                 "msDrawRasterLayerLow()",
-                 layer->tileitem);
-      return MS_FAILURE;
-    }
-    if(layer->tilesrs != NULL && *ptilesrsindex < 0) { /* didn't find it */
-      msSetError(MS_MEMERR,
-                 "Could not find attribute %s in tileindex.",
-                 "msDrawRasterLayerLow()",
-                 layer->tilesrs);
-      return MS_FAILURE;
-    }
-
-    /* if necessary, project the searchrect to source coords */
-    if((map->projection.numargs > 0) && (layer->projection.numargs > 0) &&
-        !EQUAL(layer->projection.args[0], "auto")) {
-      if( msProjectRect(&map->projection, &layer->projection, psearchrect)
-          != MS_SUCCESS ) {
-        msDebug( "msDrawRasterLayerLow(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name );
-        return MS_FAILURE;
-      }
-    }
-    else if((map->projection.numargs > 0) && (tlp->projection.numargs > 0) &&
-        !EQUAL(tlp->projection.args[0], "auto")) {
-      if( msProjectRect(&map->projection, &tlp->projection, psearchrect)
-          != MS_SUCCESS ) {
-        msDebug( "msDrawRasterLayerLow(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name );
-        return MS_FAILURE;
-      }
-    }
-    return msLayerWhichShapes(tlp, *psearchrect, MS_FALSE);
-}
-
-/************************************************************************/
-/*                msDrawRasterCleanupTileLayer()                        */
-/*                                                                      */
-/*      Cleanup the tile layer.                                         */
-/************************************************************************/
-
-void msDrawRasterCleanupTileLayer(layerObj* tlp,
-                                  int tilelayerindex)
-{
-    msLayerClose(tlp);
-    if(tilelayerindex == -1) {
-      freeLayer(tlp);
-      free(tlp);
-    }
-}
-
-/************************************************************************/
-/*                   msDrawRasterIterateTileIndex()                     */
-/*                                                                      */
-/*      Iterate over the tile layer.                                    */
-/************************************************************************/
-
-int msDrawRasterIterateTileIndex(layerObj *layer,
-                                 layerObj* tlp,
-                                 shapeObj* ptshp, /* input-output */
-                                 int tileitemindex,
-                                 int tilesrsindex,
-                                 char* tilename, /* output */
-                                 size_t sizeof_tilename,
-                                 char* tilesrsname, /* output */
-                                 size_t sizeof_tilesrsname)
-{
-      int status;
-
-      status = msLayerNextShape(tlp, ptshp);
-      if( status == MS_FAILURE || status == MS_DONE ) {
-        return status;
-      }
-
-      if(layer->data == NULL || strlen(layer->data) == 0 ) { /* assume whole filename is in attribute field */
-        strlcpy( tilename, ptshp->values[tileitemindex], sizeof_tilename);
-      } else
-        snprintf(tilename, sizeof_tilename, "%s/%s", ptshp->values[tileitemindex], layer->data);
-
-      tilesrsname[0] = '\0';
-
-      if( tilesrsindex >= 0 )
-      {
-        if(ptshp->values[tilesrsindex] != NULL )
-          strlcpy( tilesrsname, ptshp->values[tilesrsindex], sizeof_tilesrsname );
-      }
-
-      msFreeShape(ptshp); /* done with the shape */
-
-      return status;
-}
-
-/************************************************************************/
-/*                   msDrawRasterBuildRasterPath()                      */
-/*                                                                      */
-/*      Build the path of the raster to open.                           */
-/************************************************************************/
-
-int msDrawRasterBuildRasterPath(mapObj *map, layerObj *layer,
-                                const char* filename,
-                                char szPath[MS_MAXPATHLEN] /* output */)
-{
-    /*
-    ** If using a tileindex then build the path relative to that file if SHAPEPATH is not set.
-    */
-    if(layer->tileindex && !map->shapepath) {
-      char tiAbsFilePath[MS_MAXPATHLEN];
-      char *tiAbsDirPath = NULL;
-
-      msTryBuildPath(tiAbsFilePath, map->mappath, layer->tileindex); /* absolute path to tileindex file */
-      tiAbsDirPath = msGetPath(tiAbsFilePath); /* tileindex file's directory */
-      msBuildPath(szPath, tiAbsDirPath, filename);
-      free(tiAbsDirPath);
-    } else {
-      msTryBuildPath3(szPath, map->mappath, map->shapepath, filename);
-    }
-
-    return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msDrawRasterGetCPLErrorMsg()                       */
-/*                                                                      */
-/*      Return the CPL error message, and filter out sensitive info.    */
-/************************************************************************/
-
-const char* msDrawRasterGetCPLErrorMsg(const char* decrypted_path,
-                                       const char* szPath)
-{
-      const char *cpl_error_msg = CPLGetLastErrorMsg();
-
-      /* we wish to avoid reporting decrypted paths */
-      if( cpl_error_msg != NULL
-          && strstr(cpl_error_msg,decrypted_path) != NULL
-          && strcmp(decrypted_path,szPath) != 0 )
-        cpl_error_msg = NULL;
-
-      /* we wish to avoid reporting the stock GDALOpen error messages */
-      if( cpl_error_msg != NULL
-          && (strstr(cpl_error_msg,"not recognised as a supported") != NULL
-              || strstr(cpl_error_msg,"does not exist") != NULL) )
-        cpl_error_msg = NULL;
-
-      if( cpl_error_msg == NULL )
-        cpl_error_msg = "";
-
-      return cpl_error_msg;
-}
-
-/************************************************************************/
-/*                   msDrawRasterLoadProjection()                       */
-/*                                                                      */
-/*      Handle TILESRS or PROJECTION AUTO for each tile.                */
-/************************************************************************/
-
-int msDrawRasterLoadProjection(layerObj *layer,
-                               GDALDatasetH hDS,
-                               const char* filename,
-                               int tilesrsindex,
-                               const char* tilesrsname)
-{
-    /*
-    ** Generate the projection information if using TILESRS.
-    */
-    if( tilesrsindex >= 0 )
-    {
-        const char *pszWKT;
-        if( tilesrsname[0] != '\0' )
-            pszWKT = tilesrsname;
-        else
-            pszWKT = GDALGetProjectionRef( hDS );
-        if( pszWKT != NULL && strlen(pszWKT) > 0 ) {
-          if( msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
-                                    layer->debug ) != MS_SUCCESS ) {
-          char  szLongMsg[MESSAGELENGTH*2];
-          errorObj *ms_error = msGetErrorObj();
-
-          snprintf( szLongMsg, sizeof(szLongMsg),
-                    "%s\n"
-                    "PROJECTION '%s' cannot be used for this "
-                    "GDAL raster (`%s').",
-                    ms_error->message, pszWKT, filename);
-          szLongMsg[MESSAGELENGTH-1] = '\0';
-
-          msSetError(MS_OGRERR, "%s","msDrawRasterLayer()",
-                     szLongMsg);
-
-          return MS_FAILURE;
-        }
-      }
-    }
-    /*
-    ** Generate the projection information if using AUTO.
-    */
-    else if (layer->projection.numargs > 0 &&
-        EQUAL(layer->projection.args[0], "auto")) {
-      const char *pszWKT;
-
-      pszWKT = GDALGetProjectionRef( hDS );
-
-      if( pszWKT != NULL && strlen(pszWKT) > 0 ) {
-        if( msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
-                                   layer->debug ) != MS_SUCCESS ) {
-          char  szLongMsg[MESSAGELENGTH*2];
-          errorObj *ms_error = msGetErrorObj();
-
-          snprintf( szLongMsg, sizeof(szLongMsg),
-                    "%s\n"
-                    "PROJECTION AUTO cannot be used for this "
-                    "GDAL raster (`%s').",
-                    ms_error->message, filename);
-          szLongMsg[MESSAGELENGTH-1] = '\0';
-
-          msSetError(MS_OGRERR, "%s","msDrawRasterLayer()",
-                     szLongMsg);
-
-          return MS_FAILURE;
-        }
-      }
-    }
-
-    return MS_SUCCESS;
-}
-
-typedef enum
-{
-    CDRT_OK,
-    CDRT_RETURN_MS_FAILURE,
-    CDRT_CONTINUE_NEXT_TILE
-} CheckDatasetReturnType;
-
-/************************************************************************/
-/*              msDrawRasterLayerLowCheckDataset()                      */
-/************************************************************************/
-
-static
-CheckDatasetReturnType msDrawRasterLayerLowCheckDataset(mapObj *map,
-                                     layerObj *layer,
-                                     GDALDatasetH hDS,
-                                     const char* decrypted_path,
-                                     const char* szPath)
-{
-    /*
-    ** If GDAL doesn't recognise it, and it wasn't successfully opened
-    ** Generate an error.
-    */
-    if(hDS == NULL) {
-      int ignore_missing = msMapIgnoreMissingData(map);
-      const char *cpl_error_msg = msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
-
-      if(ignore_missing == MS_MISSING_DATA_FAIL) {
-        msSetError(MS_IOERR, "Corrupt, empty or missing file '%s' for layer '%s'. %s", "msDrawRasterLayerLow()", szPath, layer->name, cpl_error_msg );
-        return(CDRT_RETURN_MS_FAILURE);
-      } else if( ignore_missing == MS_MISSING_DATA_LOG ) {
-        if( layer->debug || layer->map->debug ) {
-          msDebug( "Corrupt, empty or missing file '%s' for layer '%s' ... ignoring this missing data.  %s\n", szPath, layer->name, cpl_error_msg );
-        }
-        return(CDRT_CONTINUE_NEXT_TILE);
-      } else if( ignore_missing == MS_MISSING_DATA_IGNORE ) {
-        return(CDRT_CONTINUE_NEXT_TILE);
-      } else {
-        /* never get here */
-        msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.", "msDrawRasterLayerLow()");
-        return(CDRT_RETURN_MS_FAILURE);
-      }
-    }
-
-    return CDRT_OK;
-}
-
-/************************************************************************/
-/*              msDrawRasterLayerLowOpenDataset()                       */
-/************************************************************************/
-
-void* msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
-                                      const char* filename,
-                                      char szPath[MS_MAXPATHLEN],
-                                      char** p_decrypted_path)
-{
-  const char* pszPath;
-
-  msGDALInitialize();
-
-  if(layer->debug)
-    msDebug( "msDrawRasterLayerLow(%s): Filename is: %s\n", layer->name, filename);
-
-  if( strncmp(filename, "<VRTDataset", strlen("<VRTDataset")) == 0 )
-  {
-    pszPath = filename;
-  }
-  else
-  {
-    msDrawRasterBuildRasterPath(map, layer, filename, szPath);
-    pszPath = szPath;
-  }
-  if(layer->debug)
-    msDebug("msDrawRasterLayerLow(%s): Path is: %s\n", layer->name, pszPath);
-
-    /*
-    ** Note: because we do decryption after the above path expansion
-    ** which depends on actually finding a file, it essentially means that
-    ** fancy path manipulation is essentially disabled when using encrypted
-    ** components. But that is mostly ok, since stuff like sde,postgres and
-    ** oracle georaster do not use real paths.
-    */
-  *p_decrypted_path = msDecryptStringTokens( map, pszPath );
-  if( *p_decrypted_path == NULL )
-    return NULL;
-
-  msAcquireLock( TLOCK_GDAL );
-  if( !layer->tileindex )
-  {
-    char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-    GDALDatasetH hDS = GDALOpenEx( *p_decrypted_path,
-                                   GDAL_OF_RASTER | GDAL_OF_SHARED,
-                                   NULL,
-                                   (const char* const*)connectionoptions,
-                                   NULL);
-    CSLDestroy(connectionoptions);
-    return hDS;
-  }
-  else
-  {
-    return GDALOpenShared( *p_decrypted_path, GA_ReadOnly );
-  }
-}
-
-/************************************************************************/
-/*                msDrawRasterLayerLowCloseDataset()                    */
-/************************************************************************/
-
-void msDrawRasterLayerLowCloseDataset(layerObj *layer, void* hDS)
-{
-    if( hDS )
-    {
-      const char *close_connection;
-      close_connection = msLayerGetProcessingKey( layer,
-                       "CLOSE_CONNECTION" );
-
-      if( close_connection == NULL && layer->tileindex == NULL )
-        close_connection = "DEFER";
-
-      {
-        /* Due to how GDAL processes OVERVIEW_LEVEL, datasets returned are */
-        /* not shared, despite being asked to, so close them for real */
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        if( CSLFetchNameValue(connectionoptions, "OVERVIEW_LEVEL") )
-            close_connection = NULL;
-        CSLDestroy(connectionoptions);
-      }
-
-      if( close_connection != NULL
-          && strcasecmp(close_connection,"DEFER") == 0 ) {
-        GDALDereferenceDataset( (GDALDatasetH)hDS );
-      } else {
-        GDALClose( (GDALDatasetH)hDS );
-      }
-      msReleaseLock( TLOCK_GDAL );
-    }
-}
-
-
-/************************************************************************/
-/*                msDrawRasterLayerLowCheckIfMustDraw()                 */
-/*                                                                      */
-/*      Return 1 if the layer should be drawn.                          */
-/************************************************************************/
-
-int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer)
-{
-  if(!layer->data && !layer->tileindex && !(layer->connectiontype==MS_KERNELDENSITY || layer->connectiontype==MS_IDW)) {
-    if(layer->debug)
-      msDebug( "msDrawRasterLayerLow(%s): layer data and tileindex NULL ... doing nothing.", layer->name );
-    return(0);
-  }
-
-  if((layer->status != MS_ON) && (layer->status != MS_DEFAULT)) {
-    if(layer->debug)
-      msDebug( "msDrawRasterLayerLow(%s): not status ON or DEFAULT, doing nothing.", layer->name );
-    return(0);
-  }
-
-  if(map->scaledenom > 0) {
-    if((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map scale %.2g > MAXSCALEDENOM=%g\n",
-                 layer->name, map->scaledenom, layer->maxscaledenom );
-      return(0);
-    }
-    if((layer->minscaledenom > 0) && (map->scaledenom <= layer->minscaledenom)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map scale %.2g < MINSCALEDENOM=%g\n",
-                 layer->name, map->scaledenom, layer->minscaledenom );
-      return(0);
-    }
-  }
-
-  if(layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
-    if((layer->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map width %.2g > MAXSCALEDENOM=%g\n", layer->name,
-                 (map->extent.maxx - map->extent.minx), layer->maxgeowidth );
-      return(0);
-    }
-    if((layer->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map width %.2g < MINSCALEDENOM=%g\n", layer->name,
-                 (map->extent.maxx - map->extent.minx), layer->mingeowidth );
-      return(0);
-    }
-  }
-
-  return 1;
-}
-
-/************************************************************************/
-/*                        msDrawRasterLayerLow()                        */
-/*                                                                      */
-/*      Check for various file types and act appropriately.  Handle     */
-/*      tile indexing.                                                  */
-/************************************************************************/
-
-int msDrawRasterLayerLow(mapObj *map, layerObj *layer, imageObj *image,
-                         rasterBufferObj *rb )
-{
-    return msDrawRasterLayerLowWithDataset(map, layer, image, rb, NULL);
-}
-
-int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer, imageObj *image,
-                                    rasterBufferObj *rb, void* hDatasetIn )
-{
-  /* -------------------------------------------------------------------- */
-  /*      As of MapServer 6.0 GDAL is required for rendering raster       */
-  /*      imagery.                                                        */
-  /* -------------------------------------------------------------------- */
-  int status, done;
-  char *filename=NULL, tilename[MS_MAXPATHLEN], tilesrsname[1024];
-
-  layerObj *tlp=NULL; /* pointer to the tile layer either real or temporary */
-  int tileitemindex=-1, tilelayerindex=-1, tilesrsindex=-1;
-  shapeObj tshp;
-
-  char szPath[MS_MAXPATHLEN] = { 0 };
-  char *decrypted_path = NULL;
-  int final_status = MS_SUCCESS;
-
-  rectObj searchrect;
-  GDALDatasetH  hDS;
-  double  adfGeoTransform[6];
-  void *kernel_density_cleanup_ptr = NULL;
-
-  if(layer->debug > 0 || map->debug > 1)
-    msDebug( "msDrawRasterLayerLow(%s): entering.\n", layer->name );
-
-  if( hDatasetIn == NULL &&
-      !msDrawRasterLayerLowCheckIfMustDraw(map, layer) ) {
-    return MS_SUCCESS;
-  }
-
-  msGDALInitialize();
-
-  if(layer->tileindex) { /* we have an index file */
-    msInitShape(&tshp);
-    searchrect = map->extent;
-
-    status = msDrawRasterSetupTileLayer(map, layer,
-                           &searchrect,
-                           MS_FALSE,
-                           &tilelayerindex,
-                           &tileitemindex,
-                           &tilesrsindex,
-                           &tlp);
-    if(status != MS_SUCCESS) {
-      if (status != MS_DONE)
-        final_status = status;
-      goto cleanup;
-    }
-  }
-
-  done = MS_FALSE;
-  while(done != MS_TRUE) {
-
-    if(layer->tileindex) {
-      status = msDrawRasterIterateTileIndex(layer, tlp, &tshp,
-                                            tileitemindex, tilesrsindex,
-                                            tilename, sizeof(tilename),
-                                            tilesrsname, sizeof(tilesrsname));
-      if( status == MS_FAILURE) {
-        final_status = MS_FAILURE;
-        break;
-      }
-
-      if(status == MS_DONE) break; /* no more tiles/images */
-      filename = tilename;
-    } else {
-      filename = layer->data;
-      done = MS_TRUE; /* only one image so we're done after this */
-    }
-    
-    if(layer->connectiontype == MS_KERNELDENSITY || layer->connectiontype == MS_IDW) {
-      msAcquireLock( TLOCK_GDAL );
-      status = msInterpolationDataset(map, image, layer, &hDS, &kernel_density_cleanup_ptr);
-      if(status != MS_SUCCESS) {
-        msReleaseLock( TLOCK_GDAL );
-        final_status = status;
-        goto cleanup;
-      }
-      done = MS_TRUE;
-      if(msProjectionsDiffer(&map->projection,&layer->projection)) {
-        char *mapProjStr = msGetProjectionString(&(map->projection));
-
-        /* Set the projection to the map file projection */
-        if (msLoadProjectionString(&(layer->projection), mapProjStr) != 0) {
-          GDALClose( hDS );
-          msReleaseLock( TLOCK_GDAL );
-          msSetError(MS_CGIERR, "Unable to set projection on interpolation layer.", "msDrawRasterLayerLow()");
-          return(MS_FAILURE);
-        }
-        free(mapProjStr);
-      }
-    } else {
-      if(strlen(filename) == 0) continue;
-      if( hDatasetIn )
-      {
-        hDS = (GDALDatasetH)hDatasetIn;
-      }
-      else
-      {
-        hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
-                                map, layer, filename, szPath, &decrypted_path);
-      }
-    }
-
-    if( hDatasetIn == NULL )
-    {
-        CheckDatasetReturnType eRet =
-            msDrawRasterLayerLowCheckDataset(map,layer,hDS,decrypted_path,szPath);
-
-        msFree( decrypted_path );
-        decrypted_path = NULL;
-
-        if( eRet == CDRT_CONTINUE_NEXT_TILE )
-        {
-            msReleaseLock( TLOCK_GDAL );
-            continue;
-        }
-        if( eRet == CDRT_RETURN_MS_FAILURE )
-        {
-            msReleaseLock( TLOCK_GDAL );
-            return MS_FAILURE;
-        }
-    }
-
-    if( msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex, tilesrsname) != MS_SUCCESS )
-    {
-        if( hDatasetIn == NULL )
-        {
-          GDALClose( hDS );
-          msReleaseLock( TLOCK_GDAL );
-        }
-        final_status = MS_FAILURE;
-        break;
-    }
-
-    msGetGDALGeoTransform( hDS, map, layer, adfGeoTransform );
-
-    /*
-    ** We want to resample if the source image is rotated, if
-    ** the projections differ or if resampling has been explicitly
-    ** requested, or if the image has north-down instead of north-up.
-    */
-
-    if( ((adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0
-          || adfGeoTransform[5] > 0.0 || adfGeoTransform[1] < 0.0 )
-         && layer->transform )
-        || msProjectionsDiffer( &(map->projection),
-                                &(layer->projection) )
-        || CSLFetchNameValue( layer->processing, "RESAMPLE" ) != NULL ) {
-      status = msResampleGDALToMap( map, layer, image, rb, hDS );
-    }
-    else
-    {
-      if( adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0 ) {
-        if( layer->debug || map->debug )
-          msDebug(
-            "Layer %s has rotational coefficients but we\n"
-            "are unable to use them, projections support\n"
-            "needs to be built in.",
-            layer->name );
-
-      }
-      status = msDrawRasterLayerGDAL(map, layer, image, rb, hDS );
-    }
-
-    if( status == -1 ) {
-      if( hDatasetIn == NULL )
-      {
-        GDALClose( hDS );
-        msReleaseLock( TLOCK_GDAL );
-      }
-      final_status = MS_FAILURE;
-      break;
-    }
-
-    /*
-    ** Should we keep this file open for future use?
-    ** default to keeping open for single data files, and
-    ** to closing for tile indexes
-    */
-    if(layer->connectiontype == MS_KERNELDENSITY || layer->connectiontype == MS_IDW) {
-      /*
-      ** Fix issue #5330
-      ** The in-memory kernel density heatmap gdal dataset handle (hDS) gets re-used
-      ** but the associated rasterband cache doesn't get flushed, which causes old data
-      ** to be rendered instead of the newly generated imagery. To fix, simply close the
-      ** the handle and prevent further re-use.
-      ** Note that instead of this workaround, we could explicitely set 
-      ** CLOSE_CONNECTION=ALWAYS on the kerneldensity layer.
-      */
-      GDALClose( hDS );
-      msReleaseLock( TLOCK_GDAL );
-    }
-    else {
-      if( hDatasetIn == NULL)
-        msDrawRasterLayerLowCloseDataset(layer, hDS);
-    }
-
-  } /* next tile */
-
-cleanup:
-  if(layer->tileindex) { /* tiling clean-up */
-    msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
-  }
-  if(kernel_density_cleanup_ptr) {
-    msCleanupInterpolationDataset(map, image, layer, kernel_density_cleanup_ptr);
-  }
-
-  return final_status;
-}
-
-/************************************************************************/
-/*                         msDrawReferenceMap()                         */
-/************************************************************************/
-
-imageObj *msDrawReferenceMap(mapObj *map)
-{
-  double cellsize;
-  int x1,y1,x2,y2;
-  char szPath[MS_MAXPATHLEN];
-  int status = MS_SUCCESS;
-
-  imageObj *image = NULL;
-  styleObj style;
-
-  /* check to see if we have enough information to actually proceed */
-  if(!map->reference.image || map->reference.height == 0 || map->reference.width == 0) {
-    msSetError(MS_MISCERR, "Reference map configuration error.", "msDrawReferenceMap()");
-    return NULL;
-  }
-
-  rendererVTableObj *renderer = MS_MAP_RENDERER(map);
-  rasterBufferObj *refImage = (rasterBufferObj*)calloc(1,sizeof(rasterBufferObj));
-  MS_CHECK_ALLOC(refImage, sizeof(rasterBufferObj), NULL);
-
-  if(MS_SUCCESS != renderer->loadImageFromFile(msBuildPath(szPath, map->mappath, map->reference.image),refImage)) {
-    msSetError(MS_MISCERR,"Error loading reference image %s.","msDrawReferenceMap()",szPath);
-    free(refImage);
-    return NULL;
-  }
-
-  image = msImageCreate(refImage->width, refImage->height, map->outputformat,
-                        map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &(map->reference.color));
-  if(!image)
-  {
-      free(refImage);
-      return NULL;
-  }
-
-  status = renderer->mergeRasterBuffer(image,refImage,1.0,0,0,0,0,refImage->width, refImage->height);
-  msFreeRasterBuffer(refImage);
-  free(refImage);
-  if(MS_UNLIKELY(status == MS_FAILURE))
-    return NULL;
-
-  /* make sure the extent given in mapfile fits the image */
-  cellsize = msAdjustExtent(&(map->reference.extent),
-                            image->width, image->height);
-
-  /* convert map extent to reference image coordinates */
-  x1 = MS_MAP2IMAGE_X(map->extent.minx,  map->reference.extent.minx, cellsize);
-  x2 = MS_MAP2IMAGE_X(map->extent.maxx,  map->reference.extent.minx, cellsize);
-  y1 = MS_MAP2IMAGE_Y(map->extent.maxy,  map->reference.extent.maxy, cellsize);
-  y2 = MS_MAP2IMAGE_Y(map->extent.miny,  map->reference.extent.maxy, cellsize);
-
-  initStyle(&style);
-  style.color = map->reference.color;
-  style.outlinecolor = map->reference.outlinecolor;
-
-  /* if extent are smaller than minbox size */
-  /* draw that extent on the reference image */
-  if( (abs(x2 - x1) > map->reference.minboxsize) ||
-      (abs(y2 - y1) > map->reference.minboxsize) ) {
-    shapeObj rect;
-    lineObj line;
-    pointObj points[5];
-    msInitShape(&rect);
-
-    line.point = points;
-    line.numpoints = 5;
-    rect.line = &line;
-    rect.numlines = 1;
-    rect.type = MS_SHAPE_POLYGON;
-
-    line.point[0].x = x1;
-    line.point[0].y = y1;
-    line.point[1].x = x1;
-    line.point[1].y = y2;
-    line.point[2].x = x2;
-    line.point[2].y = y2;
-    line.point[3].x = x2;
-    line.point[3].y = y1;
-    line.point[4].x = line.point[0].x;
-    line.point[4].y = line.point[0].y;
-
-    line.numpoints = 5;
-
-    if( map->reference.maxboxsize == 0 ||
-        ((abs(x2 - x1) < map->reference.maxboxsize) &&
-         (abs(y2 - y1) < map->reference.maxboxsize)) ) {
-      if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, &rect, &style, 1.0))) {
-        msFreeImage(image);
-        return NULL;
-      }
-    }
-
-  } else { /* else draw the marker symbol */
-    if( map->reference.maxboxsize == 0 ||
-        ((abs(x2 - x1) < map->reference.maxboxsize) &&
-         (abs(y2 - y1) < map->reference.maxboxsize)) ) {
-      style.size = map->reference.markersize;
-
-      /* if the marker symbol is specify draw this symbol else draw a cross */
-      if(map->reference.marker || map->reference.markername) {
-        pointObj point;
-        point.x = (double)(x1 + x2)/2;
-        point.y = (double)(y1 + y2)/2;
-
-        if(map->reference.marker) {
-          style.symbol = map->reference.marker;
-        } else {
-          style.symbol = msGetSymbolIndex(&map->symbolset,  map->reference.markername, MS_TRUE);
-        }
-
-        if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &point, &style, 1.0))) {
-          msFreeImage(image);
-          return NULL;
-        }
-      } else {
-        int x21, y21;
-        shapeObj cross;
-        lineObj lines[4];
-        pointObj point[8];
-        int i;
-        /* determine the center point */
-        x21 = MS_NINT((x1 + x2)/2);
-        y21 = MS_NINT((y1 + y2)/2);
-
-        msInitShape(&cross);
-        cross.numlines = 4;
-        cross.line = lines;
-        for(i=0; i<4; i++) {
-          cross.line[i].numpoints = 2;
-          cross.line[i].point = &(point[2*i]);
-        }
-        /* draw a cross */
-        cross.line[0].point[0].x = x21-8;
-        cross.line[0].point[0].y = y21;
-        cross.line[0].point[1].x = x21-3;
-        cross.line[0].point[1].y = y21;
-        cross.line[1].point[0].x = x21;
-        cross.line[1].point[0].y = y21-8;
-        cross.line[1].point[1].x = x21;
-        cross.line[1].point[1].y = y21-3;
-        cross.line[2].point[0].x = x21;
-        cross.line[2].point[0].y = y21+3;
-        cross.line[2].point[1].x = x21;
-        cross.line[2].point[1].y = y21+8;
-        cross.line[3].point[0].x = x21+3;
-        cross.line[3].point[0].y = y21;
-        cross.line[3].point[1].x = x21+8;
-        cross.line[3].point[1].y = y21;
-
-        if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map,image,&cross,&style,1.0))) {
-          msFreeImage(image);
-          return NULL;
-        }
-      }
-    }
-  }
-
-  return(image);
-}
diff -pruN 8.0.1-5/mapraster.h 8.2.0~beta1-1~exp1/mapraster.h
--- 8.0.1-5/mapraster.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapraster.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,67 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Private include file used by mapraster.c and maprasterquery.c
- * Author:   Even Rouault
- *
- ******************************************************************************
- * Copyright (c) 2013 Regents of the University of Minnesota.
- *
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#ifndef MAPRASTER_H
-#define MAPRASTER_H
-
-
-  int msDrawRasterSetupTileLayer(mapObj *map, layerObj *layer,
-                                 rectObj* psearchrect,
-                                 int is_query,
-                                 int* ptilelayerindex, /* output */
-                                 int* ptileitemindex, /* output */
-                                 int* ptilesrsindex, /* output */
-                                 layerObj **ptlp  /* output */ );
-
-  void msDrawRasterCleanupTileLayer(layerObj* tlp,
-                                    int tilelayerindex);
-
-  int msDrawRasterIterateTileIndex(layerObj *layer,
-                                   layerObj* tlp,
-                                   shapeObj* ptshp, /* input-output */
-                                   int tileitemindex,
-                                   int tilesrsindex,
-                                   char* tilename, /* output */
-                                   size_t sizeof_tilename,
-                                   char* tilesrsname, /* output */
-                                   size_t sizeof_tilesrsname);
-
-  int msDrawRasterBuildRasterPath(mapObj *map, layerObj *layer,
-                                  const char* filename,
-                                  char szPath[MS_MAXPATHLEN]);
-
-  const char* msDrawRasterGetCPLErrorMsg(const char* decrypted_path,
-                                         const char* szPath);
-
-  int msDrawRasterLoadProjection(layerObj *layer,
-                                 GDALDatasetH hDS,
-                                 const char* filename,
-                                 int tilesrsindex,
-                                 const char* tilesrsname);
-
-#endif /* MAPRASTER_H */
diff -pruN 8.0.1-5/maprasterquery.c 8.2.0~beta1-1~exp1/maprasterquery.c
--- 8.0.1-5/maprasterquery.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maprasterquery.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1479 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of query operations on rasters.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <assert.h>
-#include "mapserver.h"
-#include "mapresample.h"
-#include "mapthread.h"
-#include "mapraster.h"
-
-
-int msRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
-int msRASTERLayerGetItems(layerObj *layer);
-
-/* ==================================================================== */
-/*      For now the rasterLayerInfo lives here since it is just used    */
-/*      to hold information related to queries.                         */
-/* ==================================================================== */
-typedef struct {
-
-  /* query cache results */
-  int query_results;
-  int query_alloc_max;
-  int query_request_max;
-  int query_result_hard_max;
-  int raster_query_mode;
-  int band_count;
-
-  int refcount;
-
-  rectObj which_rect;
-  int     next_shape;
-
-  double *qc_x;
-  double *qc_y;
-  double *qc_x_reproj;
-  double *qc_y_reproj;
-  float *qc_values;
-  int    *qc_class;
-  int    *qc_red;
-  int    *qc_green;
-  int    *qc_blue;
-  int    *qc_count;
-  int    *qc_tileindex;
-
-  /* query bound in force */
-  shapeObj *searchshape;
-
-  /* Only nearest result to this point. */
-  int      range_mode; /* MS_QUERY_SINGLE, MS_QUERY_MULTIPLE or -1 (skip test) */
-  double   range_dist;
-  pointObj target_point;
-
-  GDALColorTableH hCT;
-
-  double   shape_tolerance;
-
-} rasterLayerInfo;
-
-#define RQM_UNKNOWN               0
-#define RQM_ENTRY_PER_PIXEL       1
-#define RQM_HIST_ON_CLASS         2
-#define RQM_HIST_ON_VALUE         3
-
-extern int InvGeoTransform( double *gt_in, double *gt_out );
-#define GEO_TRANS(tr,x,y)  ((tr)[0]+(tr)[1]*(x)+(tr)[2]*(y))
-
-/************************************************************************/
-/*                             addResult()                              */
-/*                                                                      */
-/*      this is a copy of the code in mapquery.c.  Should we prepare    */
-/*      a small public API for managing results caches?                 */
-/************************************************************************/
-
-static int addResult(resultCacheObj *cache, int classindex, int shapeindex, int tileindex)
-{
-  int i;
-
-  if(cache->numresults == cache->cachesize) { /* just add it to the end */
-    if(cache->cachesize == 0)
-      cache->results = (resultObj *) malloc(sizeof(resultObj)*MS_RESULTCACHEINCREMENT);
-    else
-      cache->results = (resultObj *) realloc(cache->results, sizeof(resultObj)*(cache->cachesize+MS_RESULTCACHEINCREMENT));
-    if(!cache->results) {
-      msSetError(MS_MEMERR, "Realloc() error.", "addResult()");
-      return(MS_FAILURE);
-    }
-    cache->cachesize += MS_RESULTCACHEINCREMENT;
-  }
-
-  i = cache->numresults;
-
-  cache->results[i].classindex = classindex;
-  cache->results[i].tileindex = tileindex;
-  cache->results[i].shapeindex = shapeindex;
-  cache->results[i].resultindex = -1; /* unused */
-  cache->results[i].shape = NULL;
-  cache->numresults++;
-
-  return(MS_SUCCESS);
-}
-
-/************************************************************************/
-/*                       msRasterLayerInfoFree()                        */
-/************************************************************************/
-
-static void msRasterLayerInfoFree( layerObj *layer )
-
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  if( rlinfo == NULL )
-    return;
-
-  if( rlinfo->qc_x != NULL ) {
-    free( rlinfo->qc_x );
-    free( rlinfo->qc_y );
-    free( rlinfo->qc_x_reproj );
-    free( rlinfo->qc_y_reproj );
-  }
-
-  if( rlinfo->qc_values )
-    free( rlinfo->qc_values );
-
-  if( rlinfo->qc_class ) {
-    free( rlinfo->qc_class );
-  }
-
-  if( rlinfo->qc_red ) {
-    free( rlinfo->qc_red );
-    free( rlinfo->qc_green );
-    free( rlinfo->qc_blue );
-  }
-
-  if( rlinfo->qc_count != NULL )
-    free( rlinfo->qc_count );
-
-  if( rlinfo->qc_tileindex != NULL )
-    free( rlinfo->qc_tileindex );
-
-  free( rlinfo );
-
-  layer->layerinfo = NULL;
-}
-
-/************************************************************************/
-/*                    msRasterLayerInfoInitialize()                     */
-/************************************************************************/
-
-static void msRasterLayerInfoInitialize( layerObj *layer )
-
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  if( rlinfo != NULL )
-    return;
-
-  rlinfo = (rasterLayerInfo *) msSmallCalloc(1,sizeof(rasterLayerInfo));
-  layer->layerinfo = rlinfo;
-
-  rlinfo->band_count = -1;
-  rlinfo->raster_query_mode = RQM_ENTRY_PER_PIXEL;
-  rlinfo->range_mode = -1; /* inactive */
-  rlinfo->refcount = 0;
-  rlinfo->shape_tolerance = 0.0;
-
-  /* We need to do this or the layer->layerinfo will be interpreted */
-  /* as shapefile access info because the default connectiontype is */
-  /* MS_SHAPEFILE. */
-  if (layer->connectiontype != MS_WMS && layer->connectiontype != MS_KERNELDENSITY)
-    layer->connectiontype = MS_RASTER;
-
-  rlinfo->query_result_hard_max = 1000000;
-
-  if( CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" )
-      != NULL ) {
-    rlinfo->query_result_hard_max =
-      atoi(CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" ));
-  }
-}
-
-/************************************************************************/
-/*                       msRasterQueryAddPixel()                        */
-/************************************************************************/
-
-static void msRasterQueryAddPixel( layerObj *layer, pointObj *location,
-                                   pointObj *reprojectedLocation,
-                                   float *values )
-
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-  int red = 0, green = 0, blue = 0, nodata = FALSE;
-  int p_class = -1;
-
-  if( rlinfo->query_results == rlinfo->query_result_hard_max )
-    return;
-
-  /* -------------------------------------------------------------------- */
-  /*      Is this our first time in?  If so, do an initial allocation     */
-  /*      for the data arrays suitable to our purposes.                   */
-  /* -------------------------------------------------------------------- */
-  if( rlinfo->query_alloc_max == 0 ) {
-    rlinfo->query_alloc_max = 2;
-
-    switch( rlinfo->raster_query_mode ) {
-      case RQM_ENTRY_PER_PIXEL:
-        rlinfo->qc_x = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_y = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_x_reproj = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_y_reproj = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_values = (float *)
-                            msSmallCalloc(sizeof(float),
-                                          rlinfo->query_alloc_max*rlinfo->band_count);
-        rlinfo->qc_red = (int *)
-                         msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        rlinfo->qc_green = (int *)
-                           msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        rlinfo->qc_blue = (int *)
-                          msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        if( layer->numclasses > 0 )
-          rlinfo->qc_class = (int *)
-                             msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        break;
-
-      case RQM_HIST_ON_CLASS:
-        break;
-
-      case RQM_HIST_ON_VALUE:
-        break;
-
-      default:
-        assert( FALSE );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Reallocate the data arrays larger if they are near the max      */
-  /*      now.                                                            */
-  /* -------------------------------------------------------------------- */
-  if( rlinfo->query_results == rlinfo->query_alloc_max ) {
-    rlinfo->query_alloc_max = rlinfo->query_alloc_max * 2 + 100;
-
-    if( rlinfo->qc_x != NULL )
-      rlinfo->qc_x = msSmallRealloc(rlinfo->qc_x,
-                                    sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_y != NULL )
-      rlinfo->qc_y = msSmallRealloc(rlinfo->qc_y,
-                                    sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_x_reproj != NULL )
-      rlinfo->qc_x_reproj = msSmallRealloc(rlinfo->qc_x_reproj,
-                                    sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_y_reproj != NULL )
-      rlinfo->qc_y_reproj = msSmallRealloc(rlinfo->qc_y_reproj,
-                                    sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_values != NULL )
-      rlinfo->qc_values =
-        msSmallRealloc(rlinfo->qc_values,
-                       sizeof(float) * rlinfo->query_alloc_max
-                       * rlinfo->band_count );
-    if( rlinfo->qc_class != NULL )
-      rlinfo->qc_class = msSmallRealloc(rlinfo->qc_class,
-                                        sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_red != NULL )
-      rlinfo->qc_red = msSmallRealloc(rlinfo->qc_red,
-                                      sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_green != NULL )
-      rlinfo->qc_green = msSmallRealloc(rlinfo->qc_green,
-                                        sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_blue != NULL )
-      rlinfo->qc_blue = msSmallRealloc(rlinfo->qc_blue,
-                                       sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_count != NULL )
-      rlinfo->qc_count = msSmallRealloc(rlinfo->qc_count,
-                                        sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_tileindex != NULL )
-      rlinfo->qc_tileindex = msSmallRealloc(rlinfo->qc_tileindex,
-                                            sizeof(int) * rlinfo->query_alloc_max);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle colormap                                                 */
-  /* -------------------------------------------------------------------- */
-  if( rlinfo->hCT != NULL ) {
-    int pct_index = (int) floor(values[0]);
-    GDALColorEntry sEntry;
-
-    if( GDALGetColorEntryAsRGB( rlinfo->hCT, pct_index, &sEntry ) ) {
-      red = sEntry.c1;
-      green = sEntry.c2;
-      blue = sEntry.c3;
-
-      if( sEntry.c4 == 0 )
-        nodata = TRUE;
-    } else
-      nodata = TRUE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Color derived from greyscale value.                             */
-  /* -------------------------------------------------------------------- */
-  else {
-    if( rlinfo->band_count >= 3 ) {
-      red = (int) MS_MAX(0,MS_MIN(255,values[0]));
-      green = (int) MS_MAX(0,MS_MIN(255,values[1]));
-      blue = (int) MS_MAX(0,MS_MIN(255,values[2]));
-    } else {
-      red = green = blue = (int) MS_MAX(0,MS_MIN(255,values[0]));
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle classification.                                          */
-  /*                                                                      */
-  /*      NOTE: The following is really quite inadequate to deal with     */
-  /*      classifications based on [red], [green] and [blue] as           */
-  /*      described in:                                                   */
-  /*       http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1021         */
-  /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_class != NULL ) {
-    p_class = msGetClass_FloatRGB(layer, values[0],
-                                  red, green, blue );
-
-    if( p_class == -1 )
-      nodata = TRUE;
-    else {
-      nodata = FALSE;
-      rlinfo->qc_class[rlinfo->query_results] = p_class;
-      if( layer->class[p_class]->numstyles > 0 ) {
-        red   = layer->class[p_class]->styles[0]->color.red;
-        green = layer->class[p_class]->styles[0]->color.green;
-        blue  = layer->class[p_class]->styles[0]->color.blue;
-      } else {
-        red = green = blue = 0;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Record the color.                                               */
-  /* -------------------------------------------------------------------- */
-  rlinfo->qc_red[rlinfo->query_results] = red;
-  rlinfo->qc_green[rlinfo->query_results] = green;
-  rlinfo->qc_blue[rlinfo->query_results] = blue;
-
-  /* -------------------------------------------------------------------- */
-  /*      Record spatial location.                                        */
-  /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_x != NULL ) {
-    rlinfo->qc_x[rlinfo->query_results] = location->x;
-    rlinfo->qc_y[rlinfo->query_results] = location->y;
-    rlinfo->qc_x_reproj[rlinfo->query_results] = reprojectedLocation->x;
-    rlinfo->qc_y_reproj[rlinfo->query_results] = reprojectedLocation->y;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Record actual pixel value(s).                                   */
-  /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_values != NULL )
-    memcpy( rlinfo->qc_values + rlinfo->query_results * rlinfo->band_count,
-            values, sizeof(float) * rlinfo->band_count );
-
-  /* -------------------------------------------------------------------- */
-  /*      Add to the results cache.                                       */
-  /* -------------------------------------------------------------------- */
-  if( ! nodata ) {
-    addResult( layer->resultcache, p_class, rlinfo->query_results, 0 );
-    rlinfo->query_results++;
-  }
-}
-
-/************************************************************************/
-/*                       msRasterQueryByRectLow()                       */
-/************************************************************************/
-
-static int
-msRasterQueryByRectLow(mapObj *map, layerObj *layer, GDALDatasetH hDS,
-                       rectObj queryRect)
-
-{
-  double  adfGeoTransform[6], adfInvGeoTransform[6];
-  double      dfXMin, dfYMin, dfXMax, dfYMax, dfX, dfY, dfAdjustedRange;
-  int         nWinXOff, nWinYOff, nWinXSize, nWinYSize;
-  int         nRXSize, nRYSize;
-  float       *pafRaster;
-  int         nBandCount, *panBandMap, iPixel, iLine;
-  CPLErr      eErr;
-  rasterLayerInfo *rlinfo;
-  rectObj     searchrect;
-#if PROJ_VERSION_MAJOR < 6
-  int         mayNeedLonWrapAdjustment = MS_FALSE;
-#endif
-
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  /* -------------------------------------------------------------------- */
-  /*      Reproject the search rect into the projection of this           */
-  /*      layer/file if needed.                                           */
-  /* -------------------------------------------------------------------- */
-  searchrect = queryRect;
-  layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
-  if(layer->project)
-    msProjectRect(&(map->projection), &(layer->projection), &searchrect);
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform the rectangle in target ground coordinates to         */
-  /*      pixel/line extents on the file.  Process all 4 corners, to      */
-  /*      build extents.                                                  */
-  /* -------------------------------------------------------------------- */
-  nRXSize = GDALGetRasterXSize( hDS );
-  nRYSize = GDALGetRasterYSize( hDS );
-
-  msGetGDALGeoTransform( hDS, map, layer, adfGeoTransform );
-  InvGeoTransform( adfGeoTransform, adfInvGeoTransform );
-
-  /* top left */
-  dfXMin = dfXMax = GEO_TRANS(adfInvGeoTransform,
-                              searchrect.minx, searchrect.maxy);
-  dfYMin = dfYMax = GEO_TRANS(adfInvGeoTransform+3,
-                              searchrect.minx, searchrect.maxy);
-
-  /* top right */
-  dfX = GEO_TRANS(adfInvGeoTransform  , searchrect.maxx, searchrect.maxy);
-  dfY = GEO_TRANS(adfInvGeoTransform+3, searchrect.maxx, searchrect.maxy);
-  dfXMin = MS_MIN(dfXMin,dfX);
-  dfXMax = MS_MAX(dfXMax,dfX);
-  dfYMin = MS_MIN(dfYMin,dfY);
-  dfYMax = MS_MAX(dfYMax,dfY);
-
-  /* bottom left */
-  dfX = GEO_TRANS(adfInvGeoTransform  , searchrect.minx, searchrect.miny);
-  dfY = GEO_TRANS(adfInvGeoTransform+3, searchrect.minx, searchrect.miny);
-  dfXMin = MS_MIN(dfXMin,dfX);
-  dfXMax = MS_MAX(dfXMax,dfX);
-  dfYMin = MS_MIN(dfYMin,dfY);
-  dfYMax = MS_MAX(dfYMax,dfY);
-
-  /* bottom right */
-  dfX = GEO_TRANS(adfInvGeoTransform  , searchrect.maxx, searchrect.miny);
-  dfY = GEO_TRANS(adfInvGeoTransform+3, searchrect.maxx, searchrect.miny);
-  dfXMin = MS_MIN(dfXMin,dfX);
-  dfXMax = MS_MAX(dfXMax,dfX);
-  dfYMin = MS_MIN(dfYMin,dfY);
-  dfYMax = MS_MAX(dfYMax,dfY);
-
-  /* -------------------------------------------------------------------- */
-  /*      Trim the rectangle to the area of the file itself, but out      */
-  /*      to the edges of the touched edge pixels.                        */
-  /* -------------------------------------------------------------------- */
-  dfXMin = MS_MAX(0.0,MS_MIN(nRXSize,floor(dfXMin)));
-  dfYMin = MS_MAX(0.0,MS_MIN(nRYSize,floor(dfYMin)));
-  dfXMax = MS_MAX(0.0,MS_MIN(nRXSize,ceil(dfXMax)));
-  dfYMax = MS_MAX(0.0,MS_MIN(nRYSize,ceil(dfYMax)));
-
-  /* -------------------------------------------------------------------- */
-  /*      Convert to integer offset/size values.                          */
-  /* -------------------------------------------------------------------- */
-  nWinXOff = (int) dfXMin;
-  nWinYOff = (int) dfYMin;
-  nWinXSize = (int) (dfXMax - dfXMin);
-  nWinYSize = (int) (dfYMax - dfYMin);
-
-  /* -------------------------------------------------------------------- */
-  /*      What bands are we operating on?                                 */
-  /* -------------------------------------------------------------------- */
-  panBandMap = msGetGDALBandList( layer, hDS, 0, &nBandCount );
-
-  if( rlinfo->band_count == -1 )
-    rlinfo->band_count = nBandCount;
-
-  if( nBandCount != rlinfo->band_count ) {
-    msSetError( MS_IMGERR,
-                "Got %d bands, but expected %d bands.",
-                "msRasterQueryByRectLow()",
-                nBandCount, rlinfo->band_count );
-
-    return -1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Try to load the raster data.  For now we just load the first    */
-  /*      band in the file.  Later we will deal with the various band     */
-  /*      selection criteria.                                             */
-  /* -------------------------------------------------------------------- */
-  pafRaster = (float *)
-              calloc(sizeof(float),nWinXSize*nWinYSize*nBandCount);
-  MS_CHECK_ALLOC(pafRaster, sizeof(float)*nWinXSize*nWinYSize*nBandCount, -1);
-
-  eErr = GDALDatasetRasterIO( hDS, GF_Read,
-                              nWinXOff, nWinYOff, nWinXSize, nWinYSize,
-                              pafRaster, nWinXSize, nWinYSize, GDT_Float32,
-                              nBandCount, panBandMap,
-                              4 * nBandCount,
-                              4 * nBandCount * nWinXSize,
-                              4 );
-
-  if( eErr != CE_None ) {
-    msSetError( MS_IOERR, "GDALDatasetRasterIO() failed: %s",
-                "msRasterQueryByRectLow()", CPLGetLastErrorMsg() );
-
-    free( pafRaster );
-    return -1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch color table for intepreting colors if needed.             */
-  /* -------------------------------------------------------------------- */
-  rlinfo->hCT = GDALGetRasterColorTable(
-                  GDALGetRasterBand( hDS, panBandMap[0] ) );
-
-  free( panBandMap );
-
-  /* -------------------------------------------------------------------- */
-  /*      When computing whether pixels are within range we do it         */
-  /*      based on the center of the pixel to the target point but        */
-  /*      really it ought to be the nearest point on the pixel.  It       */
-  /*      would be too much trouble to do this rigerously, so we just     */
-  /*      add a fudge factor so that a range of zero will find the        */
-  /*      pixel the target falls in at least.                             */
-  /* -------------------------------------------------------------------- */
-  dfAdjustedRange =
-    sqrt(adfGeoTransform[1] * adfGeoTransform[1]
-         + adfGeoTransform[2] * adfGeoTransform[2]
-         + adfGeoTransform[4] * adfGeoTransform[4]
-         + adfGeoTransform[5] * adfGeoTransform[5]) * 0.5 * 1.41421356237
-    + sqrt( rlinfo->range_dist );
-  dfAdjustedRange = dfAdjustedRange * dfAdjustedRange;
-
-#if PROJ_VERSION_MAJOR < 6
-    if( layer->project &&
-        msProjIsGeographicCRS(&(layer->projection)) &&
-        msProjIsGeographicCRS(&(map->projection)) )
-    {
-        double dfLonWrap = 0;
-        mayNeedLonWrapAdjustment = msProjectHasLonWrap(&(layer->projection), &dfLonWrap);
-    }
-#endif
-
-  reprojectionObj* reprojector = NULL;
-  if( layer->project )
-  {
-      reprojector = msProjectCreateReprojector(&(layer->projection), &(map->projection));
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Loop over all pixels determining which are "in".                */
-  /* -------------------------------------------------------------------- */
-  for( iLine = 0; iLine < nWinYSize; iLine++ ) {
-    for( iPixel = 0; iPixel < nWinXSize; iPixel++ ) {
-      pointObj  sPixelLocation = {0};
-
-      if( rlinfo->query_results == rlinfo->query_result_hard_max )
-        break;
-
-      /* transform pixel/line to georeferenced */
-      sPixelLocation.x =
-        GEO_TRANS(adfGeoTransform,
-                  iPixel + nWinXOff + 0.5, iLine + nWinYOff + 0.5 );
-      sPixelLocation.y =
-        GEO_TRANS(adfGeoTransform+3,
-                  iPixel + nWinXOff + 0.5, iLine + nWinYOff + 0.5 );
-
-      /* If projections differ, convert this back into the map  */
-      /* projection for distance testing, and comprison to the  */
-      /* search shape.  Save the original pixel location coordinates */
-      /* in sPixelLocationInLayerSRS, so that we can return those */
-      /* coordinates if we have a hit */
-      pointObj sReprojectedPixelLocation = sPixelLocation;
-      if( reprojector )
-      {
-#if PROJ_VERSION_MAJOR < 6
-        /* Works around a bug in PROJ < 6 when reprojecting from a lon_wrap */
-        /* geogCRS to a geogCRS, and the input abs(longitude) is > 180. Then */
-        /* lon_wrap was ignored and the output longitude remained as the source */
-        if( mayNeedLonWrapAdjustment )
-        {
-            if( rlinfo->target_point.x < sReprojectedPixelLocation.x - 180 )
-                sReprojectedPixelLocation.x -= 360;
-            else if( rlinfo->target_point.x > sReprojectedPixelLocation.x + 180 )
-                sReprojectedPixelLocation.x += 360;
-        }
-#endif
-
-        msProjectPointEx( reprojector, &sReprojectedPixelLocation);
-      }
-
-      /* If we are doing QueryByShape, check against the shape now */
-      if( rlinfo->searchshape != NULL ) {
-        if( rlinfo->shape_tolerance == 0.0
-            && rlinfo->searchshape->type == MS_SHAPE_POLYGON ) {
-          if( msIntersectPointPolygon(
-                &sReprojectedPixelLocation, rlinfo->searchshape ) == MS_FALSE )
-            continue;
-        } else {
-          shapeObj  tempShape;
-          lineObj   tempLine;
-
-          memset( &tempShape, 0, sizeof(shapeObj) );
-          tempShape.type = MS_SHAPE_POINT;
-          tempShape.numlines = 1;
-          tempShape.line = &tempLine;
-          tempLine.numpoints = 1;
-          tempLine.point = &sReprojectedPixelLocation;
-
-          if( msDistanceShapeToShape(rlinfo->searchshape, &tempShape)
-              > rlinfo->shape_tolerance )
-            continue;
-        }
-      }
-
-      if( rlinfo->range_mode >= 0 ) {
-        double dist;
-
-        dist = (rlinfo->target_point.x - sReprojectedPixelLocation.x)
-               * (rlinfo->target_point.x - sReprojectedPixelLocation.x)
-               + (rlinfo->target_point.y - sReprojectedPixelLocation.y)
-               * (rlinfo->target_point.y - sReprojectedPixelLocation.y);
-
-        if( dist >= dfAdjustedRange )
-          continue;
-
-        /* If we can only have one feature, trim range and clear */
-        /* previous result.  */
-        if( rlinfo->range_mode == MS_QUERY_SINGLE ) {
-          rlinfo->range_dist = dist;
-          rlinfo->query_results = 0;
-        }
-      }
-
-      msRasterQueryAddPixel( layer,
-			                       &sPixelLocation, // return coords in layer SRS
-                             &sReprojectedPixelLocation,
-                             pafRaster
-                             + (iLine*nWinXSize + iPixel) * nBandCount );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Cleanup.                                                        */
-  /* -------------------------------------------------------------------- */
-  free( pafRaster );
-  msProjectDestroyReprojector( reprojector );
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                        msRasterQueryByRect()                         */
-/************************************************************************/
-
-int msRasterQueryByRect(mapObj *map, layerObj *layer, rectObj queryRect)
-
-{
-  int status = MS_SUCCESS;
-  char *filename=NULL;
-
-  layerObj *tlp=NULL; /* pointer to the tile layer either real or temporary */
-  int tileitemindex=-1, tilelayerindex=-1, tilesrsindex=-1;
-  shapeObj tshp;
-  char tilename[MS_PATH_LENGTH], tilesrsname[1024];
-  int  done, destroy_on_failure;
-
-  char szPath[MS_MAXPATHLEN];
-  rectObj searchrect;
-  rasterLayerInfo *rlinfo = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Get the layer info.                                             */
-  /* -------------------------------------------------------------------- */
-  if(!layer->layerinfo) {
-    msRasterLayerInfoInitialize( layer );
-    destroy_on_failure = 1;
-  } else {
-    destroy_on_failure = 0;
-  }
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  /* -------------------------------------------------------------------- */
-  /*      Clear old results cache.                                        */
-  /* -------------------------------------------------------------------- */
-  if(layer->resultcache) {
-    if(layer->resultcache->results) free(layer->resultcache->results);
-    free(layer->resultcache);
-    layer->resultcache = NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize the results cache.                                   */
-  /* -------------------------------------------------------------------- */
-  layer->resultcache = (resultCacheObj *)msSmallMalloc(sizeof(resultCacheObj));
-  layer->resultcache->results = NULL;
-  layer->resultcache->numresults = layer->resultcache->cachesize = 0;
-  layer->resultcache->bounds.minx =
-    layer->resultcache->bounds.miny =
-      layer->resultcache->bounds.maxx =
-        layer->resultcache->bounds.maxy = -1;
-
-  /* -------------------------------------------------------------------- */
-  /*      Check if we should really be acting on this layer and           */
-  /*      provide debug info in various cases.                            */
-  /* -------------------------------------------------------------------- */
-  if(layer->debug > 0 || map->debug > 1)
-    msDebug( "msRasterQueryByRect(%s): entering.\n", layer->name );
-
-  if(!layer->data && !layer->tileindex) {
-    if(layer->debug > 0 || map->debug > 0 )
-      msDebug( "msRasterQueryByRect(%s): layer data and tileindex NULL ... doing nothing.", layer->name );
-    return MS_SUCCESS;
-  }
-
-  if((layer->status != MS_ON) && layer->status != MS_DEFAULT ) {
-    if(layer->debug > 0 )
-      msDebug( "msRasterQueryByRect(%s): not status ON or DEFAULT, doing nothing.", layer->name );
-    return MS_SUCCESS;
-  }
-
-  /* ==================================================================== */
-  /*      Handle setting up tileindex layer.                              */
-  /* ==================================================================== */
-  if(layer->tileindex) { /* we have an index file */
-    msInitShape(&tshp);
-    searchrect = queryRect;
-
-    status = msDrawRasterSetupTileLayer(map, layer,
-                           &searchrect,
-                           MS_TRUE,
-                           &tilelayerindex,
-                           &tileitemindex,
-                           &tilesrsindex,
-                           &tlp);
-    if (status != MS_SUCCESS) {
-      goto cleanup;
-    }
-  } else {
-    /* we have to manually apply to scaletoken logic as we're not going through msLayerOpen() */
-    status = msLayerApplyScaletokens(layer,map->scaledenom);
-    if (status != MS_SUCCESS) {
-      goto cleanup;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Iterate over all tiles (just one in untiled case).              */
-  /* -------------------------------------------------------------------- */
-  done = MS_FALSE;
-  while( done == MS_FALSE && status == MS_SUCCESS ) {
-
-    GDALDatasetH  hDS;
-    char *decrypted_path = NULL;
-
-    /* -------------------------------------------------------------------- */
-    /*      Get filename.                                                   */
-    /* -------------------------------------------------------------------- */
-    if(layer->tileindex) {
-      status = msDrawRasterIterateTileIndex(layer, tlp, &tshp,
-                                            tileitemindex, tilesrsindex,
-                                            tilename, sizeof(tilename),
-                                            tilesrsname, sizeof(tilesrsname));
-      if( status == MS_FAILURE) {
-        break;
-      }
-
-      if(status == MS_DONE) break; /* no more tiles/images */
-      filename = tilename;
-    } else {
-      filename = layer->data;
-      done = MS_TRUE; /* only one image so we're done after this */
-    }
-
-    if(strlen(filename) == 0) continue;
-
-    /* -------------------------------------------------------------------- */
-    /*      Open the file.                                                  */
-    /* -------------------------------------------------------------------- */
-    msGDALInitialize();
-
-    msDrawRasterBuildRasterPath(map, layer, filename, szPath);
-
-    decrypted_path = msDecryptStringTokens( map, szPath );
-    if( !decrypted_path ) {
-      status = MS_FAILURE;
-      goto cleanup;
-    }
-
-    msAcquireLock( TLOCK_GDAL );
-    if( !layer->tileindex )
-    {
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        hDS = GDALOpenEx(decrypted_path,
-                                    GDAL_OF_RASTER,
-                                    NULL,
-                                    (const char* const*)connectionoptions,
-                                    NULL);
-        CSLDestroy(connectionoptions);
-    }
-    else
-    {
-        hDS = GDALOpen(decrypted_path, GA_ReadOnly );
-    }
-
-    if( hDS == NULL ) {
-      int ignore_missing = msMapIgnoreMissingData( map );
-      const char *cpl_error_msg = msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
-
-      msFree( decrypted_path );
-      decrypted_path = NULL;
-
-      msReleaseLock( TLOCK_GDAL );
-
-      if ( ignore_missing == MS_MISSING_DATA_FAIL ) {
-        if( layer->debug || map->debug )
-          msSetError( MS_IMGERR,
-                      "Unable to open file %s for layer %s ... fatal error.\n%s",
-                      "msRasterQueryByRect()",
-                      szPath, layer->name, cpl_error_msg);
-        status = MS_FAILURE;
-        goto cleanup;
-      }
-      if( ignore_missing == MS_MISSING_DATA_LOG ) {
-        if( layer->debug || map->debug )
-          msDebug( "Unable to open file %s for layer %s ... ignoring this missing data.\n%s",
-                   filename, layer->name, cpl_error_msg );
-      }
-      continue;
-    }
-
-    msFree( decrypted_path );
-    decrypted_path = NULL;
-
-    if( msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex, tilesrsname) != MS_SUCCESS )
-    {
-        msReleaseLock( TLOCK_GDAL );
-        status = MS_FAILURE;
-        goto cleanup;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Perform actual query on this file.                              */
-    /* -------------------------------------------------------------------- */
-    if( status == MS_SUCCESS )
-      status = msRasterQueryByRectLow( map, layer, hDS, queryRect );
-
-    GDALClose( hDS );
-    msReleaseLock( TLOCK_GDAL );
-
-  } /* next tile */
-
-  /* -------------------------------------------------------------------- */
-  /*      Cleanup tileindex if it is open.                                */
-  /* -------------------------------------------------------------------- */
-cleanup:
-  if(layer->tileindex) { /* tiling clean-up */
-    msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
-  } else {
-    msLayerRestoreFromScaletokens(layer);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      On failure, or empty result set, cleanup the rlinfo since we    */
-  /*      likely won't ever have it accessed or cleaned up later.         */
-  /* -------------------------------------------------------------------- */
-  if( status == MS_FAILURE || rlinfo->query_results == 0 ) {
-    if(destroy_on_failure) {
-      msRasterLayerInfoFree( layer );
-    }
-  } else {
-    /* populate the items/numitems layer-level values */
-    msRASTERLayerGetItems(layer);
-  }
-
-  return status;
-}
-
-/************************************************************************/
-/*                        msRasterQueryByShape()                        */
-/************************************************************************/
-
-int msRasterQueryByShape(mapObj *map, layerObj *layer, shapeObj *selectshape)
-
-{
-  rasterLayerInfo *rlinfo = NULL;
-  int status;
-  double tolerance;
-  rectObj searchrect;
-
-  msRasterLayerInfoInitialize( layer );
-
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  /* If the selection shape is point or line we use the default tolerance of
-     3, but for polygons we require an exact hit. */
-  if(layer->tolerance == -1) {
-    if(selectshape->type == MS_SHAPE_POINT ||
-        selectshape->type == MS_SHAPE_LINE)
-      tolerance = 3;
-    else
-      tolerance = 0;
-  } else
-    tolerance = layer->tolerance;
-
-  if(layer->toleranceunits == MS_PIXELS)
-    tolerance = tolerance
-                * msAdjustExtent(&(map->extent), map->width, map->height);
-  else
-    tolerance = tolerance
-                * (msInchesPerUnit(layer->toleranceunits,0)
-                   / msInchesPerUnit(map->units,0));
-
-  rlinfo->searchshape = selectshape;
-  rlinfo->shape_tolerance = tolerance;
-
-  msComputeBounds( selectshape );
-  searchrect = selectshape->bounds;
-
-  searchrect.minx -= tolerance; /* expand the search box to account for layer tolerances (e.g. buffered searches) */
-  searchrect.maxx += tolerance;
-  searchrect.miny -= tolerance;
-  searchrect.maxy += tolerance;
-
-  status = msRasterQueryByRect( map, layer, searchrect );
-
-  rlinfo->searchshape = NULL;
-
-  return status;
-}
-
-/************************************************************************/
-/*                        msRasterQueryByPoint()                        */
-/************************************************************************/
-
-int msRasterQueryByPoint(mapObj *map, layerObj *layer, int mode, pointObj p,
-                         double buffer, int maxresults)
-{
-  int result;
-  double layer_tolerance;
-  rectObj bufferRect;
-  rasterLayerInfo *rlinfo = NULL;
-
-  msRasterLayerInfoInitialize( layer );
-
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  /* -------------------------------------------------------------------- */
-  /*      If the buffer is not set, then use layer tolerances             */
-  /*      instead.   The "buffer" distince is now in georeferenced        */
-  /*      units.  Note that tolerances in pixels are basically map        */
-  /*      display pixels, not underlying raster pixels.  It isn't         */
-  /*      clear that there is any way of requesting a buffer size in      */
-  /*      underlying pixels.                                              */
-  /* -------------------------------------------------------------------- */
-  if(buffer <= 0) { /* use layer tolerance */
-    if(layer->tolerance == -1)
-      layer_tolerance = 3;
-    else
-      layer_tolerance = layer->tolerance;
-
-    if(layer->toleranceunits == MS_PIXELS)
-      buffer = layer_tolerance
-               * msAdjustExtent(&(map->extent), map->width, map->height);
-    else
-      buffer = layer_tolerance
-               * (msInchesPerUnit(layer->toleranceunits,0)
-                  / msInchesPerUnit(map->units,0));
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup target point information, at this point they are in       */
-  /*      map coordinates.                                                */
-  /* -------------------------------------------------------------------- */
-  rlinfo->range_dist = buffer * buffer;
-  rlinfo->target_point = p;
-
-  /* -------------------------------------------------------------------- */
-  /*      if we are in the MS_QUERY_SINGLE mode, first try a query with   */
-  /*      zero tolerance.  If this gets a raster pixel then we can be     */
-  /*      reasonably assured that it is the closest to the query          */
-  /*      point.  This will potentially be must more efficient than       */
-  /*      processing all pixels within the tolerance.                     */
-  /* -------------------------------------------------------------------- */
-  if( mode == MS_QUERY_SINGLE ) {
-    rectObj pointRect;
-
-    pointRect.minx = p.x;
-    pointRect.maxx = p.x;
-    pointRect.miny = p.y;
-    pointRect.maxy = p.y;
-
-    rlinfo->range_mode = MS_QUERY_SINGLE;
-    result = msRasterQueryByRect( map, layer, pointRect );
-    if( rlinfo->query_results > 0 )
-      return result;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup a rectangle that is everything within the designated      */
-  /*      range and do a search against that.                             */
-  /* -------------------------------------------------------------------- */
-  bufferRect.minx = p.x - buffer;
-  bufferRect.maxx = p.x + buffer;
-  bufferRect.miny = p.y - buffer;
-  bufferRect.maxy = p.y + buffer;
-
-  rlinfo->range_mode = mode;
-
-  if( maxresults != 0 ) {
-    const int previous_maxresults = rlinfo->query_result_hard_max;
-    rlinfo->query_result_hard_max = maxresults;
-    result = msRasterQueryByRect( map, layer, bufferRect );
-    rlinfo->query_result_hard_max = previous_maxresults;
-  } else {
-    result = msRasterQueryByRect( map, layer, bufferRect );
-  }
-
-  return result;
-}
-
-/************************************************************************/
-/* ==================================================================== */
-/*                          RASTER Query Layer                          */
-/*                                                                      */
-/*      The results of a raster query are treated as a set of shapes    */
-/*      that can be accessed using the normal layer semantics.          */
-/* ==================================================================== */
-/************************************************************************/
-
-/************************************************************************/
-/*                         msRASTERLayerOpen()                          */
-/************************************************************************/
-
-int msRASTERLayerOpen(layerObj *layer)
-{
-  rasterLayerInfo *rlinfo;
-
-  /* If we don't have info, initialize an empty one now */
-  if( layer->layerinfo == NULL )
-    msRasterLayerInfoInitialize( layer );
-  if( layer->layerinfo == NULL )
-    return MS_FAILURE;
-
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  rlinfo->refcount = rlinfo->refcount + 1;
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                         msRASTERIsLayerOpen()                        */
-/************************************************************************/
-
-int msRASTERLayerIsOpen(layerObj *layer)
-{
-  if (layer->layerinfo)
-    return MS_TRUE;
-  return MS_FALSE;
-}
-
-
-/************************************************************************/
-/*                     msRASTERLayerFreeItemInfo()                      */
-/************************************************************************/
-void msRASTERLayerFreeItemInfo(layerObj *layer)
-{
-  (void)layer;
-}
-
-/************************************************************************/
-/*                     msRASTERLayerInitItemInfo()                      */
-/*                                                                      */
-/*      Perhaps we should be validating the requested items here?       */
-/************************************************************************/
-
-int msRASTERLayerInitItemInfo(layerObj *layer)
-{
-  (void)layer;
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                      msRASTERLayerWhichShapes()                      */
-/************************************************************************/
-int msRASTERLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-
-{
-  (void)isQuery;
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  rlinfo->which_rect = rect;
-  rlinfo->next_shape = 0;
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                         msRASTERLayerClose()                         */
-/************************************************************************/
-
-int msRASTERLayerClose(layerObj *layer)
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  if( rlinfo != NULL ) {
-    rlinfo->refcount--;
-
-    if( rlinfo->refcount < 0 )
-      msRasterLayerInfoFree( layer );
-  }
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msRASTERLayerNextShape()                       */
-/************************************************************************/
-
-int msRASTERLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  if( rlinfo->next_shape < 0
-      || rlinfo->next_shape >= rlinfo->query_results ) {
-    msFreeShape(shape);
-    shape->type = MS_SHAPE_NULL;
-    return MS_DONE;
-  } else {
-    resultObj record;
-
-    record.shapeindex = rlinfo->next_shape++;
-    record.tileindex = 0;
-    record.classindex = record.resultindex = -1;
-
-    return msRASTERLayerGetShape( layer, shape, &record);
-  }
-}
-
-/************************************************************************/
-/*                       msRASTERLayerGetShape()                        */
-/************************************************************************/
-
-int msRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-  int i;
-
-  long shapeindex = record->shapeindex;
-
-  msFreeShape(shape);
-  shape->type = MS_SHAPE_NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Validate requested record id.                                   */
-  /* -------------------------------------------------------------------- */
-  if( shapeindex < 0 || shapeindex >= rlinfo->query_results ) {
-    msSetError(MS_MISCERR,
-               "Out of range shape index requested.  Requested %ld\n"
-               "but only %d shapes available.",
-               "msRASTERLayerGetShape()",
-               shapeindex, rlinfo->query_results );
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Apply the geometry.                                             */
-  /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_x != NULL ) {
-    lineObj line;
-    pointObj point;
-
-    shape->type = MS_SHAPE_POINT;
-
-    line.numpoints = 1;
-    line.point = &point;
-
-    point.x = rlinfo->qc_x[shapeindex];
-    point.y = rlinfo->qc_y[shapeindex];
-    point.m = 0.0;
-
-    msAddLine( shape, &line );
-    msComputeBounds( shape );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Apply the requested items.                                      */
-  /* -------------------------------------------------------------------- */
-  if( layer->numitems > 0 ) {
-    shape->values = (char **) msSmallMalloc(sizeof(char *) * layer->numitems);
-    shape->numvalues = layer->numitems;
-
-    for( i = 0; i < layer->numitems; i++ ) {
-      const size_t bufferSize = 1000;
-      char szWork[1000];
-
-      szWork[0] = '\0';
-      if( EQUAL(layer->items[i],"x") && rlinfo->qc_x_reproj )
-        snprintf( szWork, bufferSize, "%.8g", rlinfo->qc_x_reproj[shapeindex] );
-      else if( EQUAL(layer->items[i],"y") && rlinfo->qc_y_reproj )
-        snprintf( szWork, bufferSize, "%.8g", rlinfo->qc_y_reproj[shapeindex] );
-
-      else if( EQUAL(layer->items[i],"value_list") && rlinfo->qc_values ) {
-        int iValue;
-
-        for( iValue = 0; iValue < rlinfo->band_count; iValue++ ) {
-          if( iValue != 0 )
-            strlcat( szWork, ",", bufferSize);
-
-          snprintf( szWork+strlen(szWork), bufferSize-strlen(szWork), "%.8g",
-                    rlinfo->qc_values[shapeindex * rlinfo->band_count
-                                      + iValue] );
-        }
-      } else if( EQUALN(layer->items[i],"value_",6) && rlinfo->qc_values ) {
-        int iValue = atoi(layer->items[i]+6);
-        snprintf( szWork, bufferSize, "%.8g",
-                  rlinfo->qc_values[shapeindex*rlinfo->band_count+iValue] );
-      } else if( EQUAL(layer->items[i],"class") && rlinfo->qc_class ) {
-        int p_class = rlinfo->qc_class[shapeindex];
-        if( layer->class[p_class]->name != NULL )
-          snprintf( szWork, bufferSize, "%.999s", layer->class[p_class]->name );
-        else
-          snprintf( szWork, bufferSize, "%d", p_class );
-      } else if( EQUAL(layer->items[i],"red") && rlinfo->qc_red )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_red[shapeindex] );
-      else if( EQUAL(layer->items[i],"green") && rlinfo->qc_green )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_green[shapeindex] );
-      else if( EQUAL(layer->items[i],"blue") && rlinfo->qc_blue )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_blue[shapeindex] );
-      else if( EQUAL(layer->items[i],"count") && rlinfo->qc_count )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_count[shapeindex] );
-
-      shape->values[i] = msStrdup(szWork);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Eventually we should likey apply the geometry properly but      */
-  /*      we don't really care about the geometry for query purposes.     */
-  /* -------------------------------------------------------------------- */
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msRASTERLayerGetItems()                        */
-/************************************************************************/
-
-int msRASTERLayerGetItems(layerObj *layer)
-{
-  int maxnumitems = 0;
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
-
-  if( rlinfo == NULL )
-    return MS_FAILURE;
-
-  maxnumitems = 8 + (rlinfo->qc_values?rlinfo->band_count:0);
-  layer->items = (char **) msSmallCalloc(sizeof(char *),maxnumitems);
-
-  layer->numitems = 0;
-  if( rlinfo->qc_x_reproj )
-    layer->items[layer->numitems++] = msStrdup("x");
-  if( rlinfo->qc_y_reproj )
-    layer->items[layer->numitems++] = msStrdup("y");
-  if( rlinfo->qc_values ) {
-    int i;
-    for( i = 0; i < rlinfo->band_count; i++ ) {
-      char szName[100];
-      snprintf( szName, sizeof(szName), "value_%d", i );
-      layer->items[layer->numitems++] = msStrdup(szName);
-    }
-    layer->items[layer->numitems++] = msStrdup("value_list");
-  }
-  if( rlinfo->qc_class )
-    layer->items[layer->numitems++] = msStrdup("class");
-  if( rlinfo->qc_red )
-    layer->items[layer->numitems++] = msStrdup("red");
-  if( rlinfo->qc_green )
-    layer->items[layer->numitems++] = msStrdup("green");
-  if( rlinfo->qc_blue )
-    layer->items[layer->numitems++] = msStrdup("blue");
-  if( rlinfo->qc_count )
-    layer->items[layer->numitems++] = msStrdup("count");
-
-  assert(layer->numitems <= maxnumitems);
-
-  return msRASTERLayerInitItemInfo(layer);
-}
-
-/************************************************************************/
-/*                       msRASTERLayerGetExtent()                       */
-/************************************************************************/
-
-int msRASTERLayerGetExtent(layerObj *layer, rectObj *extent)
-
-{
-  char szPath[MS_MAXPATHLEN];
-  mapObj *map = layer->map;
-  shapefileObj *tileshpfile;
-
-  if( (!layer->data || strlen(layer->data) == 0)
-      && layer->tileindex == NULL) {
-    /* should we be issuing a specific error about not supporting
-       extents for tileindexed raster layers? */
-    return MS_FAILURE;
-  }
-
-  if( map == NULL )
-    return MS_FAILURE;
-
-  /* If the layer use a tileindex, return the extent of the tileindex shapefile/referenced layer */
-  if (layer->tileindex) {
-    const int tilelayerindex = msGetLayerIndex(map, layer->tileindex);
-    if(tilelayerindex != -1) /* does the tileindex reference another layer */
-      return msLayerGetExtent(GET_LAYER(map, tilelayerindex), extent);
-    else {
-      tileshpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
-      MS_CHECK_ALLOC(tileshpfile, sizeof(shapefileObj), MS_FAILURE);
-
-      if(msShapefileOpen(tileshpfile, "rb", msBuildPath3(szPath, map->mappath, map->shapepath, layer->tileindex), MS_TRUE) == -1)
-        if(msShapefileOpen(tileshpfile, "rb", msBuildPath(szPath, map->mappath, layer->tileindex), MS_TRUE) == -1)
-          return MS_FAILURE;
-
-      *extent = tileshpfile->bounds;
-      msShapefileClose(tileshpfile);
-      free(tileshpfile);
-      return MS_SUCCESS;
-    }
-  }
-
-  msTryBuildPath3(szPath, map->mappath, map->shapepath, layer->data);
-  char* decrypted_path = msDecryptStringTokens( map, szPath );
-  if( !decrypted_path )
-      return MS_FAILURE;
-
-  char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-  GDALDatasetH hDS = GDALOpenEx(decrypted_path,
-                                GDAL_OF_RASTER,
-                                NULL,
-                                (const char* const*)connectionoptions,
-                                NULL);
-  CSLDestroy(connectionoptions);
-  msFree( decrypted_path );
-  if( hDS == NULL ) {
-    return MS_FAILURE;
-  }
-
-  const int nXSize = GDALGetRasterXSize( hDS );
-  const int nYSize = GDALGetRasterYSize( hDS );
-  double adfGeoTransform[6] = {0};
-  const CPLErr eErr = GDALGetGeoTransform( hDS, adfGeoTransform );
-  if( eErr != CE_None ) {
-    GDALClose( hDS );
-    return MS_FAILURE;
-  }
-
-  /* If this appears to be an ungeoreferenced raster than flip it for
-     mapservers purposes. */
-  if( adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0 ) {
-    adfGeoTransform[5] = -1.0;
-    adfGeoTransform[3] = nYSize;
-  }
-
-  extent->minx = adfGeoTransform[0];
-  extent->maxy = adfGeoTransform[3];
-
-  extent->maxx = adfGeoTransform[0] + nXSize * adfGeoTransform[1];
-  extent->miny = adfGeoTransform[3] + nYSize * adfGeoTransform[5];
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                     msRASTERLayerSetTimeFilter()                     */
-/*                                                                      */
-/*      This function is actually just used in the context of           */
-/*      setting a filter on the tileindex for time based queries.       */
-/*      For instance via WMS requests.  So it isn't really related      */
-/*      to the "raster query" support at all.                           */
-/*                                                                      */
-/*      If a local shapefile tileindex is in use, we will set a         */
-/*      backtics filter (shapefile compatible).  If another layer is    */
-/*      being used as the tileindex then we will forward the            */
-/*      SetTimeFilter call to it.  If there is no tileindex in          */
-/*      place, we do nothing.                                           */
-/************************************************************************/
-
-int msRASTERLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                               const char *timefield)
-{
-  int tilelayerindex;
-
-  /* -------------------------------------------------------------------- */
-  /*      If we don't have a tileindex the time filter has no effect.     */
-  /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL )
-    return MS_SUCCESS;
-
-  /* -------------------------------------------------------------------- */
-  /*      Find the tileindex layer.                                       */
-  /* -------------------------------------------------------------------- */
-  tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
-
-  /* -------------------------------------------------------------------- */
-  /*      If we are using a local shapefile as our tileindex (that is     */
-  /*      to say, the tileindex name is not of another layer), then we    */
-  /*      just install a backtics style filter on the raster layer.       */
-  /*      This is propogated to the "working layer" created for the       */
-  /*      tileindex by code in mapraster.c.                               */
-  /* -------------------------------------------------------------------- */
-  if( tilelayerindex == -1 )
-    return msLayerMakeBackticsTimeFilter( layer, timestring, timefield );
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
-  /*      method.                                                         */
-  /* -------------------------------------------------------------------- */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-  return msLayerSetTimeFilter( layer->GET_LAYER(map,tilelayerindex),
-                               timestring, timefield );
-}
-
-/************************************************************************/
-/*                msRASTERLayerInitializeVirtualTable()                 */
-/************************************************************************/
-
-int
-msRASTERLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerInitItemInfo = msRASTERLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msRASTERLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msRASTERLayerOpen;
-  layer->vtable->LayerIsOpen = msRASTERLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msRASTERLayerWhichShapes;
-  layer->vtable->LayerNextShape = msRASTERLayerNextShape;
-  layer->vtable->LayerGetShape = msRASTERLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msRASTERLayerClose;
-  layer->vtable->LayerGetItems = msRASTERLayerGetItems;
-  layer->vtable->LayerGetExtent = msRASTERLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /* layer->vtable->LayerCloseConnection = msRASTERLayerClose; */
-  /* we use backtics for proper tileindex shapefile functioning */
-  layer->vtable->LayerSetTimeFilter = msRASTERLayerSetTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-
-  return MS_SUCCESS;
-}
-
diff -pruN 8.0.1-5/mapregex.c 8.2.0~beta1-1~exp1/mapregex.c
--- 8.0.1-5/mapregex.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapregex.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Regex wrapper
- * Author:   Bill Binko
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/* we can't include mapserver.h, so we need our own basics */
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <math.h>
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#include <direct.h>
-#include <memory.h>
-#include <malloc.h>
-#else
-#include <unistd.h>
-#endif
-
-/*Need to specify this so that mapregex.h doesn't defined constants and
-  doesn't #define away our ms_*/
-
-#if defined(_WIN32) && !defined(__CYGWIN__) && _MSC_VER < 1900
-#define off_t  long
-#endif
-
-#include "mapserver.h"
-#include "mapregex.h"
-#include <regex.h>
-
-MS_API_EXPORT(int) ms_regcomp(ms_regex_t *regex, const char *expr, int cflags)
-{
-  /* Must free in regfree() */
-  regex_t* sys_regex = (regex_t*) msSmallMalloc(sizeof(regex_t));
-  regex->sys_regex = (void*) sys_regex;
-  return regcomp(sys_regex, expr, cflags);
-}
-
-MS_API_EXPORT(size_t) ms_regerror(int errcode, const ms_regex_t *regex, char *errbuf, size_t errbuf_size)
-{
-  return regerror(errcode, (regex_t*)(regex->sys_regex), errbuf, errbuf_size);
-}
-
-MS_API_EXPORT(int) ms_regexec(const ms_regex_t *regex, const char *string, size_t nmatch, ms_regmatch_t pmatch[], int eflags)
-{
-  /*This next line only works because we know that regmatch_t
-    and ms_regmatch_t are exactly alike (POSIX STANDARD)*/
-  return regexec((const regex_t*)(regex->sys_regex),
-                 string, nmatch,
-                 (regmatch_t*) pmatch, eflags);
-}
-
-MS_API_EXPORT(void) ms_regfree(ms_regex_t *regex)
-{
-  regfree((regex_t*)(regex->sys_regex));
-  free(regex->sys_regex);
-  return;
-}
diff -pruN 8.0.1-5/mapregex.h 8.2.0~beta1-1~exp1/mapregex.h
--- 8.0.1-5/mapregex.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapregex.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,112 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Regex wrapper
- * Author:   Bill Binko
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAP_REGEX_H
-#define MAP_REGEX_H
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-  /* We want these to match the POSIX standard, so we need these*/
-  /* === regex2.h === */
-#ifdef _WIN32
-#define MS_API_EXPORT(type)  __declspec(dllexport) type __stdcall
-#elif defined(__GNUC__) && __GNUC__ >= 4
-#define MS_API_EXPORT(type)  __attribute__ ((visibility("default"))) type
-#else
-#define MS_API_EXPORT(type)  type
-#endif
-
-  typedef struct {
-    void* sys_regex;
-  } ms_regex_t;
-
-  typedef int ms_regoff_t;
-  typedef struct {
-    ms_regoff_t rm_so;  /* Byte offset from string's start to substring's start.  */
-    ms_regoff_t rm_eo;  /* Byte offset from string's start to substring's end.  */
-  } ms_regmatch_t;
-
-  MS_API_EXPORT(int) ms_regcomp(ms_regex_t *, const char *, int);
-  MS_API_EXPORT(size_t) ms_regerror(int, const ms_regex_t *, char *, size_t);
-  MS_API_EXPORT(int) ms_regexec(const ms_regex_t *, const char *, size_t, ms_regmatch_t [], int);
-  MS_API_EXPORT(void) ms_regfree(ms_regex_t *);
-
-#ifndef BUILDING_REGEX_PROXY
-
-  /* === regcomp.c === */
-#define MS_REG_BASIC  0000
-#define MS_REG_EXTENDED 0001
-#define MS_REG_ICASE  0002
-#define MS_REG_NOSUB  0004
-#define MS_REG_NEWLINE  0010
-#define MS_REG_NOSPEC 0020
-#define MS_REG_PEND 0040
-#define MS_REG_DUMP 0200
-
-
-  /* === regerror.c === */
-#define MS_REG_OKAY  0
-#define MS_REG_NOMATCH   1
-#define MS_REG_BADPAT  2
-#define MS_REG_ECOLLATE  3
-#define MS_REG_ECTYPE  4
-#define MS_REG_EESCAPE   5
-#define MS_REG_ESUBREG   6
-#define MS_REG_EBRACK  7
-#define MS_REG_EPAREN  8
-#define MS_REG_EBRACE  9
-#define MS_REG_BADBR  10
-#define MS_REG_ERANGE 11
-#define MS_REG_ESPACE 12
-#define MS_REG_BADRPT 13
-#define MS_REG_EMPTY  14
-#define MS_REG_ASSERT 15
-#define MS_REG_INVARG 16
-#define MS_REG_ATOI 255 /* convert name to number (!) */
-#define MS_REG_ITOA 0400  /* convert number to name (!) */
-
-
-  /* === regexec.c === */
-#define MS_REG_NOTBOL 00001
-#define MS_REG_NOTEOL 00002
-#define MS_REG_STARTEND 00004
-#define MS_REG_TRACE  00400 /* tracing of execution */
-#define MS_REG_LARGE  01000 /* force large representation */
-#define MS_REG_BACKR  02000 /* force use of backref code */
-
-#endif
-
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif
diff -pruN 8.0.1-5/maprendering.c 8.2.0~beta1-1~exp1/maprendering.c
--- 8.0.1-5/maprendering.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maprendering.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1165 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Rendering utility functions
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2011 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <assert.h>
-
-#include "mapserver.h"
-#include "mapcopy.h"
-#include "fontcache.h"
-
-void computeSymbolStyle(symbolStyleObj *s, styleObj *src, symbolObj *symbol, double scalefactor,
-    double resolutionfactor)
-{
-  double default_size;
-  double target_size;
-  double style_size;
-
-  default_size = msSymbolGetDefaultSize(symbol);
-  style_size = (src->size==-1)?default_size:src->size;
-
-  INIT_SYMBOL_STYLE(*s);
-  if(symbol->type == MS_SYMBOL_PIXMAP) {
-    s->color = s->outlinecolor = NULL;
-  } else if(symbol->filled || symbol->type == MS_SYMBOL_TRUETYPE) {
-    if(MS_VALID_COLOR(src->color))
-      s->color = &src->color;
-    if(MS_VALID_COLOR(src->outlinecolor))
-      s->outlinecolor = &src->outlinecolor;
-  } else {
-    if(MS_VALID_COLOR(src->color))
-      s->outlinecolor = &(src->color);
-    else if(MS_VALID_COLOR(src->outlinecolor))
-      s->outlinecolor = &(src->outlinecolor);
-    s->color = NULL;
-  }
-
-  target_size = style_size * scalefactor;
-  target_size = MS_MAX(target_size, src->minsize*resolutionfactor);
-  target_size = MS_MIN(target_size, src->maxsize*resolutionfactor);
-  s->scale = target_size / default_size;
-  s->gap = src->gap * target_size / style_size;
-
-  if(s->outlinecolor) {
-    s->outlinewidth =  src->width * scalefactor;
-    s->outlinewidth = MS_MAX(s->outlinewidth, src->minwidth*resolutionfactor);
-    s->outlinewidth = MS_MIN(s->outlinewidth, src->maxwidth*resolutionfactor);
-  } else {
-    s->outlinewidth = 0;
-  }
-
-  s->rotation = src->angle * MS_DEG_TO_RAD;
-}
-
-
-#define COMPARE_COLORS(a,b) (\
-    ((a).red==(b).red) && \
-    ((a).green==(b).green) && \
-    ((a).blue==(b).blue) && \
-    ((a).alpha==(b).alpha))
-
-tileCacheObj *searchTileCache(imageObj *img, symbolObj *symbol, symbolStyleObj *s, int width, int height)
-{
-  tileCacheObj *cur = img->tilecache;
-  while(cur != NULL) {
-    if( cur->width == width
-        && cur->height == height
-        && cur->symbol == symbol
-        && cur->outlinewidth == s->outlinewidth
-        && cur->rotation == s->rotation
-        && cur->scale == s->scale
-        && (!s->color || COMPARE_COLORS(cur->color,*s->color))
-        && (!s->backgroundcolor || COMPARE_COLORS(cur->backgroundcolor,*s->backgroundcolor))
-        && (!s->outlinecolor || COMPARE_COLORS(cur->outlinecolor,*s->outlinecolor)))
-      return cur;
-    cur = cur->next;
-  }
-  return NULL;
-}
-
-int preloadSymbol(symbolSetObj *symbolset, symbolObj *symbol, rendererVTableObj *renderer) {
-  (void)symbolset;
-  switch(symbol->type) {
-  case MS_SYMBOL_VECTOR:
-  case MS_SYMBOL_ELLIPSE:
-  case MS_SYMBOL_SIMPLE:
-  case (MS_SYMBOL_TRUETYPE):
-    break;
-  case (MS_SYMBOL_SVG):
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-    return msPreloadSVGSymbol(symbol);
-#else
-    msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "preloadSymbol()");
-    return MS_FAILURE;
-#endif
-    break;
-  case (MS_SYMBOL_PIXMAP): {
-    if(!symbol->pixmap_buffer) {
-      if(MS_SUCCESS != msPreloadImageSymbol(renderer,symbol))
-        return MS_FAILURE;
-    }
-  }
-  break;
-  default:
-    msSetError(MS_MISCERR,"unsupported symbol type %d", "preloadSymbol()", symbol->type);
-    return MS_FAILURE;
-  }
-  return MS_SUCCESS;
-}
-
-/* add a cached tile to the current image's cache */
-tileCacheObj *addTileCache(imageObj *img,
-                           imageObj *tile, symbolObj *symbol, symbolStyleObj *style, int width, int height)
-{
-  tileCacheObj *cachep;
-
-  if(img->ntiles >= MS_IMAGECACHESIZE) { /* remove last element, size stays the same */
-    cachep = img->tilecache;
-
-    /*go to the before last cache object*/
-    while(cachep->next && cachep->next->next) cachep = cachep->next;
-    assert( cachep->next );
-
-    /*free the last tile's data*/
-    msFreeImage(cachep->next->image);
-
-    /*reuse the last tile object*/
-    /* make the cache point to the start of the list*/
-    cachep->next->next = img->tilecache;
-    /* point the global cache to the new first */
-    img->tilecache = cachep->next;
-    /* the before last cache is now last, so it has no successor*/
-    cachep->next = NULL;
-
-  } else {
-    img->ntiles += 1;
-    cachep = (tileCacheObj*)malloc(sizeof(tileCacheObj));
-    MS_CHECK_ALLOC(cachep, sizeof(tileCacheObj), NULL);
-    cachep->next = img->tilecache;
-    img->tilecache = cachep;
-  }
-
-  cachep = img->tilecache;
-
-  cachep->image = tile;
-  cachep->outlinewidth = style->outlinewidth;
-  cachep->scale = style->scale;
-  cachep->rotation = style->rotation;
-  if(style->color) MS_COPYCOLOR(&cachep->color,style->color);
-  if(style->outlinecolor) MS_COPYCOLOR(&cachep->outlinecolor,style->outlinecolor);
-  cachep->width = width;
-  cachep->height = height;
-  cachep->symbol = symbol;
-  return(cachep);
-}
-
-/* helper function to center glyph on the desired point */
-static int drawGlyphMarker(imageObj *img, face_element *face, glyph_element *glyphc, double px, double py, int size, double rotation,
-    colorObj *clr, colorObj *oclr, int olwidth)
-{
-  double ox, oy;
-  textPathObj path;
-  glyphObj glyph;
-  rendererVTableObj *renderer = img->format->vtable;
-  if(!renderer->renderGlyphs) return MS_FAILURE;
-  path.numglyphs = 1;
-  glyph.glyph = glyphc;
-  glyph.face = face;
-  path.glyphs = &glyph;
-  path.glyph_size = size;
-  glyph.rot = rotation;
-  ox = (glyphc->metrics.maxx + glyphc->metrics.minx) / 2.0;
-  oy = (glyphc->metrics.maxy + glyphc->metrics.miny) / 2.0;
-  if(rotation != 0) {
-    double sina, cosa;
-    double rox,roy;
-    sina = sin(rotation);
-    cosa = cos(rotation);
-    rox = ox * cosa - oy * sina;
-    roy = ox * sina + oy * cosa;
-    px -= rox;
-    py += roy;
-    glyph.pnt.x = px;
-    glyph.pnt.y = py;
-  } else {
-    glyph.pnt.x = px - ox;
-    glyph.pnt.y = py + oy;
-  }
-  textSymbolObj ts;
-  memset(&ts, 0, sizeof(ts));
-  ts.textpath = &path;
-  return renderer->renderGlyphs(img, &ts, clr, oclr, olwidth, MS_TRUE);
-}
-
-
-imageObj *getTile(imageObj *img, symbolObj *symbol,  symbolStyleObj *s, int width, int height,
-                  int seamlessmode)
-{
-  tileCacheObj *tile;
-  int status = MS_SUCCESS;
-  rendererVTableObj *renderer = img->format->vtable;
-  if(width==-1 || height == -1) {
-    width=height=MS_MAX(symbol->sizex,symbol->sizey);
-  }
-  tile = searchTileCache(img,symbol,s,width,height);
-
-  if(tile==NULL) {
-    imageObj *tileimg;
-    double p_x,p_y;
-    tileimg = msImageCreate(width,height,img->format,NULL,NULL,img->resolution, img->resolution, NULL);
-    if(MS_UNLIKELY(!tileimg)) {
-      return NULL;
-    }
-    if(!seamlessmode) {
-      p_x = width/2.0;
-      p_y = height/2.0;
-      switch(symbol->type) {
-        case (MS_SYMBOL_TRUETYPE):
-        {
-          unsigned int unicode;
-          glyph_element *glyphc;
-          face_element *face = msGetFontFace(symbol->font, &img->map->fontset);
-          if(MS_UNLIKELY(!face)) { status = MS_FAILURE; break; }
-          msUTF8ToUniChar(symbol->character, &unicode);
-          unicode = msGetGlyphIndex(face,unicode);
-          glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale),1), unicode);
-          if(MS_UNLIKELY(!glyphc)) { status = MS_FAILURE; break; }
-          status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale, s->rotation,
-                s->color, s->outlinecolor, s->outlinewidth);
-        }
-          break;
-        case (MS_SYMBOL_PIXMAP):
-          status = msPreloadImageSymbol(renderer,symbol);
-          if(MS_UNLIKELY(status == MS_FAILURE)) { break; }
-          status = renderer->renderPixmapSymbol(tileimg, p_x, p_y, symbol, s);
-          break;
-        case (MS_SYMBOL_ELLIPSE):
-          status = renderer->renderEllipseSymbol(tileimg, p_x, p_y,symbol, s);
-          break;
-        case (MS_SYMBOL_VECTOR):
-          status = renderer->renderVectorSymbol(tileimg, p_x, p_y, symbol, s);
-          break;
-
-        case (MS_SYMBOL_SVG):
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-          status = msPreloadSVGSymbol(symbol);
-          if(MS_LIKELY(status == MS_SUCCESS)) {
-            if (renderer->supports_svg) {
-              status = renderer->renderSVGSymbol(tileimg, p_x, p_y, symbol, s);
-            } else {
-              status = msRenderRasterizedSVGSymbol(tileimg,p_x,p_y,symbol, s);
-            }
-          }
-#else
-          msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "getTile()");
-          status = MS_FAILURE;
-#endif
-          break;
-        default:
-          msSetError(MS_SYMERR, "Unknown symbol type %d", "getTile()", symbol->type);
-          status = MS_FAILURE;
-          break;
-      }
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
-        msFreeImage(tileimg);
-        return NULL;
-      }
-    } else {
-      /*
-       * in seamless mode, we render the the symbol 9 times on a 3x3 grid to account for
-       * antialiasing blending from one tile to the next. We finally keep the center tile
-       */
-      imageObj *tile3img = msImageCreate(width*3,height*3,img->format,NULL,NULL,
-                                         img->resolution, img->resolution, NULL);
-      int i,j;
-      rasterBufferObj tmpraster;
-      for(i=1; i<=3; i++) {
-        p_x = (i+0.5)*width;
-        for(j=1; j<=3; j++) {
-          p_y = (j+0.5) * height;
-          switch(symbol->type) {
-            case (MS_SYMBOL_TRUETYPE):
-            {
-              unsigned int unicode;
-              glyph_element *glyphc;
-              face_element *face = msGetFontFace(symbol->font, &img->map->fontset);
-              if(MS_UNLIKELY(!face)) { status = MS_FAILURE; break; }
-              msUTF8ToUniChar(symbol->character, &unicode);
-              unicode = msGetGlyphIndex(face,unicode);
-              glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale),1), unicode);
-              if(MS_UNLIKELY(!glyphc)) { status = MS_FAILURE; break; }
-              status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale, s->rotation,
-                    s->color, s->outlinecolor, s->outlinewidth);
-            }
-              break;
-            case (MS_SYMBOL_PIXMAP):
-              status = msPreloadImageSymbol(renderer,symbol);
-              if(MS_UNLIKELY(status == MS_FAILURE)) { break; }
-              status = renderer->renderPixmapSymbol(tile3img, p_x, p_y, symbol, s);
-              break;
-            case (MS_SYMBOL_ELLIPSE):
-              status = renderer->renderEllipseSymbol(tile3img, p_x, p_y,symbol, s);
-              break;
-            case (MS_SYMBOL_VECTOR):
-              status = renderer->renderVectorSymbol(tile3img, p_x, p_y, symbol, s);
-              break;
-            default:
-              msSetError(MS_SYMERR, "BUG: Seamless mode is only for vector symbols", "getTile()");
-              return NULL;
-          }
-          if(MS_UNLIKELY(status == MS_FAILURE)) {
-            msFreeImage(tile3img);
-            return NULL;
-          }
-        }
-      }
-
-      status = MS_IMAGE_RENDERER(tile3img)->getRasterBufferHandle(tile3img,&tmpraster);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
-        msFreeImage(tile3img);
-        return NULL;
-      }
-      status = renderer->mergeRasterBuffer(tileimg,
-                                  &tmpraster,
-                                  1.0,width,height,0,0,width,height
-                                 );
-      msFreeImage(tile3img);
-    }
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
-      msFreeImage(tileimg);
-      return NULL;
-    }
-    tile = addTileCache(img,tileimg,symbol,s,width,height);
-  }
-  return tile->image;
-}
-
-int msImagePolylineMarkers(imageObj *image, shapeObj *p, symbolObj *symbol,
-                           symbolStyleObj *style, double spacing,
-                           double initialgap, int auto_angle)
-{
-  rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-  int i,j;
-  pointObj point;
-  double original_rotation = style->rotation;
-  double symbol_width,symbol_height;
-  glyph_element *glyphc = NULL;
-  face_element *face = NULL;
-  int ret = MS_SUCCESS;
-  if(symbol->type != MS_SYMBOL_TRUETYPE) {
-    symbol_width = MS_MAX(1,symbol->sizex*style->scale);
-    symbol_height = MS_MAX(1,symbol->sizey*style->scale);
-  } else {
-    unsigned int unicode;
-    msUTF8ToUniChar(symbol->character, &unicode);
-    face = msGetFontFace(symbol->font, &image->map->fontset);
-    if(MS_UNLIKELY(!face)) return MS_FAILURE;
-    unicode = msGetGlyphIndex(face,unicode);
-    glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(style->scale),1), unicode);
-    if(MS_UNLIKELY(!glyphc)) return MS_FAILURE;
-    symbol_width = glyphc->metrics.maxx - glyphc->metrics.minx;
-    symbol_height = glyphc->metrics.maxy - glyphc->metrics.miny;
-  }
-  for(i=0; i<p->numlines; i++) {
-    int line_in = 0;
-    double line_length=0;
-    double current_length;
-    if(initialgap < 0) {
-      current_length = spacing/2.0; /* initial padding for each line */
-    } else {
-      current_length = initialgap; /* initial padding for each line */
-    }
-    for(j=1; j<p->line[i].numpoints; j++) {
-      double rx,ry,theta,length;
-      length = sqrt((pow((p->line[i].point[j].x - p->line[i].point[j-1].x),2) + pow((p->line[i].point[j].y - p->line[i].point[j-1].y),2)));
-      line_length += length;
-      if(length==0)continue;
-      rx = (p->line[i].point[j].x - p->line[i].point[j-1].x)/length;
-      ry = (p->line[i].point[j].y - p->line[i].point[j-1].y)/length;
-
-      if (auto_angle) {
-        theta = asin(ry);
-        if(rx < 0) {
-          theta += MS_PI;
-        } else theta = -theta;
-        style->rotation = original_rotation + theta;
-      }
-      while (current_length <= length) {
-
-        point.x = p->line[i].point[j - 1].x + current_length * rx;
-        point.y = p->line[i].point[j - 1].y + current_length * ry;
-        if(symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
-          double ox, oy;
-          ox = (0.5 - symbol->anchorpoint_x) * symbol_width;
-          oy = (0.5 - symbol->anchorpoint_y) * symbol_height;
-          if(style->rotation != 0) {
-            double sina,cosa;
-            double rox,roy;
-            sina = sin(-style->rotation);
-            cosa = cos(-style->rotation);
-            rox = ox * cosa - oy * sina;
-            roy = ox * sina + oy * cosa;
-            point.x += rox;
-            point.y += roy;
-          } else {
-            point.x += ox;
-            point.y += oy;
-          }
-        }
-
-        /* if the point is not in the map extent, skip it. (POLYLINE_NO_CLIP) */
-        if ( (point.x < -(symbol_width) || point.x > (image->width+symbol_width)) ||
-             (point.y < -(symbol_height) || point.y > (image->height+symbol_height)) ) {
-          current_length += spacing;
-          line_in=1;          
-          continue;
-        }
-          
-        switch (symbol->type) {
-          case MS_SYMBOL_PIXMAP:
-            ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol, style);
-            break;
-          case MS_SYMBOL_ELLIPSE:
-            ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol, style);
-            break;
-          case MS_SYMBOL_VECTOR:
-            ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol, style);
-            break;
-          case MS_SYMBOL_TRUETYPE:
-            ret = drawGlyphMarker(image, face, glyphc, point.x, point.y, style->scale, style->rotation,
-                style->color, style->outlinecolor, style->outlinewidth);
-            break;
-          case (MS_SYMBOL_SVG):
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-              if (renderer->supports_svg) {
-                ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol, style);
-              } else {
-                ret = msRenderRasterizedSVGSymbol(image,point.x,point.y,symbol, style);
-              }
-#else
-              msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msImagePolylineMarkers()()");
-              ret = MS_FAILURE;
-#endif
-              break;
-        }
-        if( ret != MS_SUCCESS)
-          return ret;
-        current_length += spacing;
-        line_in=1;
-      }
-
-      current_length -= length;
-    }
-
-    /*
-     * if we couldn't place a symbol on the line and no initialgap was
-     * specified,  add one now we don't add the symbol if the line is shorter
-     * than the length of the symbol itself
-     */
-    if(initialgap < 0 && !line_in && line_length>symbol_width) {
-
-      /* total lengths of beginnning and end of current segment */
-      double before_length=0,after_length=0;
-
-      /*optimize*/
-      line_length /= 2.0;
-
-      for(j=1; j<p->line[i].numpoints; j++) {
-        double length;
-        length = sqrt((pow((p->line[i].point[j].x - p->line[i].point[j-1].x),2) + pow((p->line[i].point[j].y - p->line[i].point[j-1].y),2)));
-        after_length += length;
-        if(after_length>line_length) {
-          double rx,ry,theta;
-          /* offset where the symbol should be drawn on the current
-           * segment */
-          double offset = line_length - before_length;
-
-          rx = (p->line[i].point[j].x - p->line[i].point[j-1].x)/length;
-          ry = (p->line[i].point[j].y - p->line[i].point[j-1].y)/length;
-          if (auto_angle) {
-            theta = asin(ry);
-            if(rx < 0) {
-              theta += MS_PI;
-            } else theta = -theta;
-            style->rotation = original_rotation + theta;
-          }
-
-          point.x = p->line[i].point[j - 1].x + offset * rx;
-          point.y = p->line[i].point[j - 1].y + offset * ry;
-          switch (symbol->type) {
-            case MS_SYMBOL_PIXMAP:
-              ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol, style);
-              break;
-            case MS_SYMBOL_ELLIPSE:
-              ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol, style);
-              break;
-            case MS_SYMBOL_VECTOR:
-              ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol, style);
-              break;
-            case MS_SYMBOL_TRUETYPE:
-              ret = drawGlyphMarker(image, face, glyphc, point.x, point.y, style->scale, style->rotation,
-                  style->color, style->outlinecolor, style->outlinewidth);
-              break;
-            case (MS_SYMBOL_SVG):
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-              if (renderer->supports_svg) {
-                ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol, style);
-              } else {
-                ret = msRenderRasterizedSVGSymbol(image,point.x,point.y,symbol, style);
-              }
-#else
-              msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msImagePolylineMarkers()()");
-              ret = MS_FAILURE;
-#endif
-              break;
-          }
-          break; /* we have rendered the single marker for this line */
-        }
-        before_length += length;
-      }
-    }
-
-  }
-  return ret;
-}
-
-int msDrawLineSymbol(mapObj *map, imageObj *image, shapeObj *p,
-                     styleObj *style, double scalefactor)
-{
-  int status = MS_SUCCESS;
-  if (image) {
-    if (MS_RENDERER_PLUGIN(image->format)) {
-      rendererVTableObj *renderer = image->format->vtable;
-      symbolObj *symbol;
-      shapeObj *offsetLine = p;
-      int i;
-      double width;
-      double finalscalefactor;
-
-      if (p->numlines == 0)
-        return MS_SUCCESS;
-
-      if (style->symbol >= map->symbolset.numsymbols || style->symbol < 0)
-        return MS_SUCCESS; /* no such symbol, 0 is OK   */
-
-      symbol = map->symbolset.symbol[style->symbol];
-      /* store a reference to the renderer to be used for freeing */
-      symbol->renderer = renderer;
-
-      width = style->width * scalefactor;
-      width = MS_MIN(width,style->maxwidth*image->resolutionfactor);
-      width = MS_MAX(width,style->minwidth*image->resolutionfactor);
-      if(style->width != 0) {
-        finalscalefactor = width / style->width;
-      } else {
-        finalscalefactor = 1.0;
-      }
-
-      if(style->offsety==MS_STYLE_SINGLE_SIDED_OFFSET) {
-        offsetLine = msOffsetPolyline(p,style->offsetx * finalscalefactor ,MS_STYLE_SINGLE_SIDED_OFFSET);
-      } else if(style->offsety==MS_STYLE_DOUBLE_SIDED_OFFSET) {
-        offsetLine = msOffsetPolyline(p,style->offsetx * finalscalefactor ,MS_STYLE_DOUBLE_SIDED_OFFSET);
-      } else if(style->offsetx!=0 || style->offsety!=0) {
-        offsetLine = msOffsetPolyline(p, style->offsetx * finalscalefactor,
-                                      style->offsety * finalscalefactor);
-      }
-      if(style->symbol == 0 || (symbol->type==MS_SYMBOL_SIMPLE)) {
-        strokeStyleObj s;
-        s.linecap = style->linecap;
-        s.linejoin = style->linejoin;
-        s.linejoinmaxsize = style->linejoinmaxsize;
-        s.antialiased = style->antialiased;
-        s.width = width;
-        s.patternlength = style->patternlength;
-        for(i=0; i<s.patternlength; i++)
-          s.pattern[i] = style->pattern[i] * finalscalefactor;
-        s.patternoffset = (style->initialgap<=0) ? 0 : (style->initialgap * finalscalefactor);
-
-        if(MS_VALID_COLOR(style->color))
-          s.color = &style->color;
-        else if(MS_VALID_COLOR(style->outlinecolor))
-          s.color = &style->outlinecolor;
-        else {
-          /* msSetError(MS_MISCERR,"no color defined for line styling","msDrawLineSymbol()");
-           * not really an error */
-          status = MS_SUCCESS;
-          goto line_cleanup;
-        }
-        status = renderer->renderLine(image,offsetLine,&s);
-      } else {
-        symbolStyleObj s;
-        if(preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
-          status = MS_FAILURE;
-          goto line_cleanup;
-        }
-
-        INIT_SYMBOL_STYLE(s);
-        computeSymbolStyle(&s,style,symbol,scalefactor,image->resolutionfactor);
-        s.style = style;
-
-        /* compute a markerStyle and use it on the line */
-        if(style->gap<0) {
-          /* special function that treats any other symbol used as a marker, not a brush */
-          status = msImagePolylineMarkers(image,offsetLine,symbol,&s,-s.gap,
-                                 style->initialgap * finalscalefactor, 1);
-        } else if(style->gap>0) {
-          status = msImagePolylineMarkers(image,offsetLine,symbol,&s,s.gap,
-                                 style->initialgap * finalscalefactor,0);
-        } else {
-          if(renderer->renderLineTiled != NULL) {
-            int pw,ph;
-            imageObj* tile=NULL;
-            if(s.scale != 1) {
-              pw = MS_NINT(symbol->sizex * s.scale);
-              ph = MS_NINT(symbol->sizey * s.scale);
-            } else {
-              pw = symbol->sizex;
-              ph = symbol->sizey;
-            }
-            if(pw<1) pw=1;
-            if(ph<1) ph=1;
-            tile = getTile(image, symbol,&s,pw,ph,0);
-            status = renderer->renderLineTiled(image, offsetLine, tile);
-          } else {
-            msSetError(MS_RENDERERERR, "renderer does not support brushed lines", "msDrawLineSymbol()");
-            status = MS_FAILURE;
-          }
-        }
-      }
-
-line_cleanup:
-      if(offsetLine!=p) {
-        msFreeShape(offsetLine);
-        msFree(offsetLine);
-      }
-      return status;
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
-      msDrawLineSymbolIM(map, image, p, style, scalefactor);
-    else {
-      msSetError(MS_RENDERERERR, "unsupported renderer", "msDrawShadeSymbol()");
-      status = MS_FAILURE;
-    }
-  } else {
-    status = MS_FAILURE;
-  }
-  return status;
-}
-
-int msDrawShadeSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style, double scalefactor)
-{
-  int ret = MS_SUCCESS;
-  symbolObj *symbol;
-  if (!p)
-    return MS_SUCCESS;
-  if (p->numlines <= 0)
-    return MS_SUCCESS;
-
-  if (style->symbol >= map->symbolset.numsymbols || style->symbol < 0)
-    return MS_SUCCESS; /* no such symbol, 0 is OK */
-  symbol = map->symbolset.symbol[style->symbol];
-
-  /*
-   * if only an outlinecolor was defined, and not a color,
-   * switch to the line drawing function
-   *
-   * this behavior is kind of a mapfile hack, and must be
-   * kept for backwards compatibility
-   */
-  if (symbol->type != MS_SYMBOL_PIXMAP && symbol->type != MS_SYMBOL_SVG ) {
-    if (!MS_VALID_COLOR(style->color)) {
-      if(MS_VALID_COLOR(style->outlinecolor))
-        return msDrawLineSymbol(map, image, p, style, scalefactor);
-      else {
-        /* just do nothing if no color has been set */
-        return MS_SUCCESS;
-      }
-    }
-  }
-  if (image) {
-    if (MS_RENDERER_PLUGIN(image->format)) {
-      rendererVTableObj *renderer = image->format->vtable;
-      shapeObj *offsetPolygon = NULL;
-      /* store a reference to the renderer to be used for freeing */
-      if(style->symbol)
-        symbol->renderer = renderer;
-
-      if (style->offsetx != 0 || style->offsety != 0) {
-        if(style->offsety==MS_STYLE_SINGLE_SIDED_OFFSET) {
-          offsetPolygon = msOffsetPolyline(p, style->offsetx*scalefactor, MS_STYLE_SINGLE_SIDED_OFFSET);
-        } else if(style->offsety==MS_STYLE_DOUBLE_SIDED_OFFSET) {
-          offsetPolygon = msOffsetPolyline(p,style->offsetx * scalefactor ,MS_STYLE_DOUBLE_SIDED_OFFSET);
-        } else {
-          offsetPolygon = msOffsetPolyline(p, style->offsetx*scalefactor,style->offsety*scalefactor);
-        }
-      } else {
-        offsetPolygon=p;
-      }
-      /* simple polygon drawing, without any specific symbol.
-       * also draws an optional outline */
-      if(style->symbol == 0 || symbol->type == MS_SYMBOL_SIMPLE) {
-        ret = renderer->renderPolygon(image,offsetPolygon,&style->color);
-        if(ret != MS_SUCCESS) goto cleanup;
-        if(MS_VALID_COLOR(style->outlinecolor)) {
-          strokeStyleObj s;
-          INIT_STROKE_STYLE(s);
-          s.color = &style->outlinecolor;
-          s.color->alpha = style->color.alpha;
-          s.width = (style->width == 0)?scalefactor:style->width*scalefactor;
-          s.width = MS_MIN(s.width, style->maxwidth);
-          s.width = MS_MAX(s.width, style->minwidth);
-          ret = renderer->renderLine(image,offsetPolygon,&s);
-        }
-        goto cleanup; /*finished plain polygon*/
-      } else if(symbol->type == MS_SYMBOL_HATCH) {
-        double width, spacing;
-        double pattern[MS_MAXPATTERNLENGTH];
-        int i;
-
-        width = (style->width <= 0)?scalefactor:style->width*scalefactor;
-        width = MS_MIN(width, style->maxwidth*image->resolutionfactor);
-        width = MS_MAX(width, style->minwidth*image->resolutionfactor);
-        spacing = (style->size <= 0)?scalefactor:style->size*scalefactor;
-        spacing = MS_MIN(spacing, style->maxsize*image->resolutionfactor);
-        spacing = MS_MAX(spacing, style->minsize*image->resolutionfactor);
-
-        /* scale the pattern by the factor applied to the width */
-        for(i=0; i<style->patternlength; i++) {
-          pattern[i] = style->pattern[i]*width/style->width;
-        }
-
-        ret = msHatchPolygon(image,offsetPolygon,spacing,width,pattern,style->patternlength,style->angle, &style->color);
-        goto cleanup;
-      } else {
-        symbolStyleObj s;
-        int pw,ph;
-        imageObj *tile;
-        int seamless = 0;
-
-        if(preloadSymbol(&map->symbolset,symbol,renderer) != MS_SUCCESS) {
-          ret = MS_FAILURE;
-          goto cleanup;
-        }
-
-        INIT_SYMBOL_STYLE(s);
-        computeSymbolStyle(&s,style,symbol,scalefactor,image->resolutionfactor);
-        s.style = style;
-
-        if (!s.color && !s.outlinecolor && symbol->type != MS_SYMBOL_PIXMAP && symbol->type != MS_SYMBOL_SVG) {
-          ret = MS_SUCCESS; /* nothing to do (colors are required except for PIXMAP symbols */
-          goto cleanup;
-        }
-
-        if(s.backgroundcolor) {
-          ret = renderer->renderPolygon(image,offsetPolygon, s.backgroundcolor);
-          if(ret != MS_SUCCESS) goto cleanup;
-        }
-
-        if(s.scale != 1) {
-          if (s.gap > 0) {
-            pw = MS_MAX(MS_NINT(s.gap),symbol->sizex * s.scale);
-            ph = MS_MAX(MS_NINT(s.gap),symbol->sizey * s.scale);
-          } else {
-            pw = MS_NINT(symbol->sizex * s.scale);
-            ph = MS_NINT(symbol->sizey * s.scale);
-          }
-        } else {
-          if (s.gap > 0) {
-            pw = MS_MAX(s.gap,symbol->sizex);
-            ph = MS_MAX(s.gap,symbol->sizey);
-          } else {
-            pw = symbol->sizex;
-            ph = symbol->sizey;
-          }
-        }
-        if(pw<1) pw=1;
-        if(ph<1) ph=1;
-
-        /* if we're doing vector symbols with an antialiased pixel rendererer, we want to enable
-         * seamless mode, i.e. comute a tile that accounts for the blending of neighbouring
-         * tiles at the tile border
-         */
-        if(symbol->type == MS_SYMBOL_VECTOR && style->gap == 0 &&
-            (image->format->renderer == MS_RENDER_WITH_AGG ||
-             image->format->renderer == MS_RENDER_WITH_CAIRO_RASTER)) {
-          seamless = 1;
-        }
-        tile = getTile(image,symbol,&s,pw,ph,seamless);
-        ret = renderer->renderPolygonTiled(image,offsetPolygon, tile);
-      }
-
-cleanup:
-      if (offsetPolygon != p) {
-        msFreeShape(offsetPolygon);
-        msFree(offsetPolygon);
-      }
-      return ret;
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
-      msDrawShadeSymbolIM(map, image, p, style, scalefactor);
-  }
-  return ret;
-}
-
-int msDrawMarkerSymbol(mapObj *map, imageObj *image, pointObj *p, styleObj *style,
-                       double scalefactor)
-{
-  int ret = MS_SUCCESS;
-  if (!p)
-    return MS_SUCCESS;
-  if (style->symbol >= map->symbolset.numsymbols || style->symbol <= 0)
-    return MS_SUCCESS; /* no such symbol, 0 is OK   */
-
-  if (image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
-      rendererVTableObj *renderer = image->format->vtable;
-      symbolStyleObj s;
-      double p_x,p_y;
-      symbolObj *symbol = map->symbolset.symbol[style->symbol];
-      /* store a reference to the renderer to be used for freeing */
-      symbol->renderer = renderer;
-      if(preloadSymbol(&map->symbolset,symbol,renderer) != MS_SUCCESS) {
-        return MS_FAILURE;
-      }
-
-      computeSymbolStyle(&s,style,symbol,scalefactor,image->resolutionfactor);
-      s.style = style;
-      if (!s.color && !s.outlinecolor && symbol->type != MS_SYMBOL_PIXMAP &&
-          symbol->type != MS_SYMBOL_SVG) {
-        return MS_SUCCESS; // nothing to do if no color, except for pixmap symbols
-      }
-      if(s.scale == 0) {
-        return MS_SUCCESS;
-      }
-
-
-
-      /* TODO: skip the drawing of the symbol if it's smaller than a pixel ?
-      if (s.size < 1)
-       return; // size too small
-       */
-
-      p_x = p->x;
-      p_y = p->y;
-
-      if (style->polaroffsetpixel != 0 ||
-          style->polaroffsetangle != 0) {
-        double angle = style->polaroffsetangle * MS_DEG_TO_RAD;
-        p_x +=  (style->polaroffsetpixel * cos(-angle)) * scalefactor;
-        p_y +=  (style->polaroffsetpixel * sin(-angle)) * scalefactor;
-      }
-
-      p_x +=  style->offsetx * scalefactor;
-      p_y +=  style->offsety * scalefactor;
-
-      if(symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
-        double sx,sy;
-        double ox, oy;
-        if(MS_UNLIKELY(MS_FAILURE == msGetMarkerSize(map, style, &sx, &sy, scalefactor))) {
-          return MS_FAILURE;
-        }
-        ox = (0.5 - symbol->anchorpoint_x) * sx;
-        oy = (0.5 - symbol->anchorpoint_y) * sy;
-        if(s.rotation != 0) {
-          double sina, cosa;
-          double rox,roy;
-          sina = sin(-s.rotation);
-          cosa = cos(-s.rotation);
-          rox = ox * cosa - oy * sina;
-          roy = ox * sina + oy * cosa;
-          p_x += rox;
-          p_y += roy;
-        } else {
-          p_x += ox;
-          p_y += oy;
-        }
-      }
-
-      if(renderer->use_imagecache) {
-        imageObj *tile = getTile(image, symbol, &s, -1, -1,0);
-        if(tile!=NULL)
-          return renderer->renderTile(image, tile, p_x, p_y);
-        else {
-          msSetError(MS_RENDERERERR, "problem creating cached tile", "msDrawMarkerSymbol()");
-          return MS_FAILURE;
-        }
-      }
-      switch (symbol->type) {
-        case (MS_SYMBOL_TRUETYPE): {
-          unsigned int unicode;
-          glyph_element *glyphc;
-          face_element *face = msGetFontFace(symbol->font, &map->fontset);
-          if(MS_UNLIKELY(!face)) return MS_FAILURE;
-          msUTF8ToUniChar(symbol->character,&unicode);
-          unicode = msGetGlyphIndex(face,unicode);
-          glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s.scale),1), unicode);
-          if(MS_UNLIKELY(!glyphc)) return MS_FAILURE;
-          ret = drawGlyphMarker(image, face, glyphc, p_x, p_y, s.scale, s.rotation, s.color, s.outlinecolor, s.outlinewidth);
-        }
-        break;
-        case (MS_SYMBOL_PIXMAP): {
-          assert(symbol->pixmap_buffer);
-          ret = renderer->renderPixmapSymbol(image,p_x,p_y,symbol,&s);
-        }
-        break;
-        case (MS_SYMBOL_ELLIPSE): {
-          ret = renderer->renderEllipseSymbol(image, p_x, p_y,symbol, &s);
-        }
-        break;
-        case (MS_SYMBOL_VECTOR): {
-          ret = renderer->renderVectorSymbol(image, p_x, p_y, symbol, &s);
-        }
-        break;
-        case (MS_SYMBOL_SVG): {
-          if (renderer->supports_svg) {
-            ret = renderer->renderSVGSymbol(image, p_x, p_y, symbol, &s);
-          } else {
-#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-            ret = msRenderRasterizedSVGSymbol(image, p_x,p_y, symbol, &s);
-#else
-            msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msDrawMarkerSymbol()");
-            return MS_FAILURE;
-#endif
-          }
-        }
-        break;
-        default:
-          break;
-      }
-      return ret;
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
-      msDrawMarkerSymbolIM(map, image, p, style, scalefactor);
-
-  }
-  return ret;
-}
-
-
-int msDrawLabelBounds(mapObj *map, imageObj *image, label_bounds *bnds, styleObj *style, double scalefactor)
-{
-  /*
-   * helper function to draw label bounds, where we might have only a rectObj and not
-   * a lineObj/shapeObj
-   */
-  shapeObj shape;
-  shape.numlines = 1;
-  if(bnds->poly) {
-    shape.line = bnds->poly;
-    return msDrawShadeSymbol(map,image,&shape,style,scalefactor);
-  } else {
-    pointObj pnts1[5];
-    lineObj l;
-    l.point = pnts1;
-    l.numpoints = 5;
-    pnts1[0].x = pnts1[1].x = pnts1[4].x = bnds->bbox.minx;
-    pnts1[2].x = pnts1[3].x = bnds->bbox.maxx;
-    pnts1[0].y = pnts1[3].y = pnts1[4].y = bnds->bbox.miny;
-    pnts1[1].y = pnts1[2].y = bnds->bbox.maxy;
-    (void)pnts1[0].x; (void)pnts1[0].y;
-    (void)pnts1[1].x; (void)pnts1[1].y;
-    (void)pnts1[2].x; (void)pnts1[2].y;
-    (void)pnts1[3].x; (void)pnts1[3].y;
-    (void)pnts1[4].x; (void)pnts1[4].y;
-    shape.line = &l; // must return from this block
-    return msDrawShadeSymbol(map,image,&shape,style,scalefactor);
-  }
-}
-
-int msDrawTextSymbol(mapObj *map, imageObj *image, pointObj labelPnt, textSymbolObj *ts)
-{
-  (void)map;
-  rendererVTableObj *renderer = image->format->vtable;
-  colorObj *c = NULL, *oc = NULL;
-  int ow;
-  assert(ts->textpath);
-  if(!renderer->renderGlyphs) return MS_FAILURE;
-
-  if(!ts->textpath->absolute) {
-    int g;
-    double cosa,sina;
-    double x = labelPnt.x;
-    double y = labelPnt.y;
-    if(ts->rotation != 0) {
-      cosa = cos(ts->rotation);
-      sina = sin(ts->rotation);
-      for(g=0;g<ts->textpath->numglyphs;g++) {
-        double ox = ts->textpath->glyphs[g].pnt.x;
-        double oy = ts->textpath->glyphs[g].pnt.y;
-        ts->textpath->glyphs[g].pnt.x = ox * cosa + oy * sina + x;
-        ts->textpath->glyphs[g].pnt.y = -ox * sina + oy * cosa + y;
-        ts->textpath->glyphs[g].rot = ts->rotation;
-      }
-    } else {
-      for(g=0;g<ts->textpath->numglyphs;g++) {
-        ts->textpath->glyphs[g].pnt.x += x;
-        ts->textpath->glyphs[g].pnt.y += y;
-      }
-    }
-  }
-
-  if(MS_VALID_COLOR(ts->label->shadowcolor)) {
-    textSymbolObj *ts_shadow;
-    int g;
-    double ox, oy;
-    double cosa,sina;
-    int ret;
-    if(ts->rotation != 0) {
-      cosa = cos(ts->rotation);
-      sina = sin(ts->rotation);
-      ox = ts->scalefactor * (cosa * ts->label->shadowsizex + 
-          sina * ts->label->shadowsizey);
-      oy = ts->scalefactor * (-sina * ts->label->shadowsizex + 
-          cosa * ts->label->shadowsizey);
-    }
-    else {
-      ox = ts->scalefactor * ts->label->shadowsizex;
-      oy = ts->scalefactor * ts->label->shadowsizey;
-    }
-
-    ts_shadow = msSmallMalloc(sizeof(textSymbolObj));
-    initTextSymbol(ts_shadow);
-    msCopyTextSymbol(ts_shadow,ts);
-
-    for(g=0;g<ts_shadow->textpath->numglyphs;g++) {
-      ts_shadow->textpath->glyphs[g].pnt.x += ox;
-      ts_shadow->textpath->glyphs[g].pnt.y += oy;
-    }
-
-    ret = renderer->renderGlyphs(image,ts_shadow,&ts->label->shadowcolor,NULL,0, MS_FALSE);
-    freeTextSymbol(ts_shadow);
-    msFree(ts_shadow);
-    if( ret != MS_SUCCESS )
-      return ret;
-  }
-
-  if(MS_VALID_COLOR(ts->label->color))
-    c = &ts->label->color;
-  if(MS_VALID_COLOR(ts->label->outlinecolor))
-    oc = &ts->label->outlinecolor;
-  ow = MS_NINT((double)ts->label->outlinewidth * ((double)ts->textpath->glyph_size / (double)ts->label->size));
-  return renderer->renderGlyphs(image,ts,c,oc,ow, MS_FALSE);
-  
-}
-
-/************************************************************************/
-/*                          msCircleDrawLineSymbol                      */
-/*                                                                      */
-/************************************************************************/
-int msCircleDrawLineSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor)
-{
-  shapeObj *circle;
-  int status;
-  if (!image) return MS_FAILURE;
-  circle = msRasterizeArc(p->x, p->y, r, 0, 360, 0);
-  if (!circle) return MS_FAILURE;
-  status = msDrawLineSymbol(map, image, circle, style, scalefactor);
-  msFreeShape(circle);
-  msFree(circle);
-  return status;
-}
-
-int msCircleDrawShadeSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor)
-{
-  shapeObj *circle;
-  int status;
-  if (!image) return MS_FAILURE;
-  circle = msRasterizeArc(p->x, p->y, r, 0, 360, 0);
-  if (!circle) return MS_FAILURE;
-  status = msDrawShadeSymbol(map, image, circle, style, scalefactor);
-  msFreeShape(circle);
-  msFree(circle);
-  return status;
-}
-
-int msDrawPieSlice(mapObj *map, imageObj *image, pointObj *p, styleObj *style, double radius, double start, double end)
-{
-  int status;
-  shapeObj *circle;
-  double center_x = p->x;
-  double center_y = p->y;
-  if (!image) return MS_FAILURE;
-  if(style->offsetx>0) {
-    center_x+=style->offsetx*cos(((-start-end)*MS_PI/360.));
-    center_y-=style->offsetx*sin(((-start-end)*MS_PI/360.));
-  }
-  circle = msRasterizeArc(center_x, center_y, radius, start, end, 1);
-  if (!circle) return MS_FAILURE;
-  status = msDrawShadeSymbol(map, image, circle, style, 1.0);
-  msFreeShape(circle);
-  msFree(circle);
-  return status;
-}
-
-/*
- * RFC 49 implementation
- * if an outlinewidth is used:
- *  - augment the style's width to account for the outline width
- *  - swap the style color and outlinecolor
- *  - draw the shape (the outline) in the first pass of the
- *    caching mechanism
- */
-
-void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image)
-{
-  colorObj tmp;
-
-  if (pStyle->outlinewidth > 0) {
-    /* adapt width (must take scalefactor into account) */
-    pStyle->width += (pStyle->outlinewidth / (layer->scalefactor/image->resolutionfactor)) * 2;
-    pStyle->minwidth += pStyle->outlinewidth * 2;
-    pStyle->maxwidth += pStyle->outlinewidth * 2;
-    pStyle->size += (pStyle->outlinewidth/layer->scalefactor*(map->resolution/map->defresolution));
-
-    /*swap color and outlinecolor*/
-    tmp = pStyle->color;
-    pStyle->color = pStyle->outlinecolor;
-    pStyle->outlinecolor = tmp;
-  }
-}
-
-/*
- * RFC 49 implementation: switch back the styleobj to its
- * original state, so the line fill will be drawn in the
- * second pass of the caching mechanism
- */
-
-void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image)
-{
-  colorObj tmp;
-
-  if (pStyle->outlinewidth > 0) {
-    /* reset widths to original state */
-    pStyle->width -= (pStyle->outlinewidth / (layer->scalefactor/image->resolutionfactor)) * 2;
-    pStyle->minwidth -= pStyle->outlinewidth * 2;
-    pStyle->maxwidth -= pStyle->outlinewidth * 2;
-    pStyle->size -= (pStyle->outlinewidth/layer->scalefactor*(map->resolution/map->defresolution));
-
-    /*reswap colors to original state*/
-    tmp = pStyle->color;
-    pStyle->color = pStyle->outlinecolor;
-    pStyle->outlinecolor = tmp;
-  }
-}
diff -pruN 8.0.1-5/mapresample.c 8.2.0~beta1-1~exp1/mapresample.c
--- 8.0.1-5/mapresample.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapresample.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1807 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Assorted code related to resampling rasters.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <assert.h>
-#include "mapresample.h"
-#include "mapthread.h"
-
-
-
-#define SKIP_MASK(x,y) (mask_rb && !*(mask_rb->data.rgba.a+(y)*mask_rb->data.rgba.row_step+(x)*mask_rb->data.rgba.pixel_step))
-
-/************************************************************************/
-/*                          InvGeoTransform()                           */
-/*                                                                      */
-/*      Invert a standard 3x2 "GeoTransform" style matrix with an       */
-/*      implicit [1 0 0] final row.                                     */
-/************************************************************************/
-
-int InvGeoTransform( double *gt_in, double *gt_out )
-
-{
-  double  det, inv_det;
-
-  /* we assume a 3rd row that is [1 0 0] */
-
-  /* Compute determinate */
-
-  det = gt_in[1] * gt_in[5] - gt_in[2] * gt_in[4];
-
-  if( fabs(det) < 0.000000000000001 )
-    return 0;
-
-  inv_det = 1.0 / det;
-
-  /* compute adjoint, and devide by determinate */
-
-  gt_out[1] =  gt_in[5] * inv_det;
-  gt_out[4] = -gt_in[4] * inv_det;
-
-  gt_out[2] = -gt_in[2] * inv_det;
-  gt_out[5] =  gt_in[1] * inv_det;
-
-  gt_out[0] = ( gt_in[2] * gt_in[3] - gt_in[0] * gt_in[5]) * inv_det;
-  gt_out[3] = (-gt_in[1] * gt_in[3] + gt_in[0] * gt_in[4]) * inv_det;
-
-  return 1;
-}
-
-/************************************************************************/
-/*                      msNearestRasterResample()                       */
-/************************************************************************/
-
-static int
-msNearestRasterResampler( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                          imageObj *psDstImage, rasterBufferObj *dst_rb,
-                          SimpleTransformer pfnTransform, void *pCBData,
-                          int debug, rasterBufferObj *mask_rb,
-                          int bWrapAtLeftRight )
-
-{
-  double  *x, *y;
-  int   nDstX, nDstY;
-  int         *panSuccess;
-  int   nDstXSize = psDstImage->width;
-  int   nDstYSize = psDstImage->height;
-  int   nSrcXSize = psSrcImage->width;
-  int   nSrcYSize = psSrcImage->height;
-  int   nFailedPoints = 0, nSetPoints = 0;
-  assert(!MS_RENDERER_PLUGIN(psSrcImage->format) || src_rb->type == MS_BUFFER_BYTE_RGBA);
-
-
-  x = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  y = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  panSuccess = (int *) msSmallMalloc( sizeof(int) * nDstXSize );
-
-  for( nDstY = 0; nDstY < nDstYSize; nDstY++ ) {
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      x[nDstX] = nDstX + 0.5;
-      y[nDstX] = nDstY + 0.5;
-    }
-
-    pfnTransform( pCBData, nDstXSize, x, y, panSuccess );
-
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      int   nSrcX, nSrcY;
-      if(SKIP_MASK(nDstX,nDstY))
-        continue;
-
-      if( !panSuccess[nDstX] ) {
-        nFailedPoints++;
-        continue;
-      }
-
-      nSrcX = (int) x[nDstX];
-      nSrcY = (int) y[nDstX];
-
-      if( bWrapAtLeftRight && nSrcX >= nSrcXSize && nSrcX < 2 * nSrcXSize )
-          nSrcX -= nSrcXSize;
-
-      /*
-       * We test the original floating point values to
-       * avoid errors related to asymmetric rounding around zero.
-       * (Also note bug #3120 regarding nearly redundent x/y < 0 checks).
-       */
-      if( x[nDstX] < 0.0 || y[nDstX] < 0.0
-          || nSrcX < 0 || nSrcY < 0
-          || nSrcX >= nSrcXSize || nSrcY >= nSrcYSize ) {
-        continue;
-      }
-
-      if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
-        int src_rb_off;
-        rgbaArrayObj *src,*dst;
-        assert( src_rb && dst_rb );
-        assert( src_rb->type == MS_BUFFER_BYTE_RGBA );
-        src = &src_rb->data.rgba;
-        dst = &dst_rb->data.rgba;
-        src_rb_off = nSrcX * src->pixel_step
-                      + nSrcY * src->row_step;
-
-        if( src->a == NULL || src->a[src_rb_off] == 255 ) {
-          int dst_rb_off;
-
-          dst_rb_off = nDstX * dst->pixel_step
-                        + nDstY * dst->row_step;
-
-          nSetPoints++;
-
-          dst->r[dst_rb_off] = src->r[src_rb_off];
-          dst->g[dst_rb_off] = src->g[src_rb_off];
-          dst->b[dst_rb_off] = src->b[src_rb_off];
-          if( dst->a )
-            dst->a[dst_rb_off] = 255;
-        } else if( src->a[src_rb_off] != 0 ) {
-          int dst_rb_off;
-
-          dst_rb_off = nDstX * dst->pixel_step
-                        + nDstY * dst->row_step;
-
-          nSetPoints++;
-
-          /* actual alpha blending is required */
-          msAlphaBlendPM( src->r[src_rb_off],
-                          src->g[src_rb_off],
-                          src->b[src_rb_off],
-                          src->a[src_rb_off],
-                          dst->r + dst_rb_off,
-                          dst->g + dst_rb_off,
-                          dst->b + dst_rb_off,
-                          dst->a ? dst->a + dst_rb_off : NULL  );
-
-        }
-      } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
-        int band, src_off, dst_off;
-
-        src_off = nSrcX + nSrcY * psSrcImage->width;
-
-        if( !MS_GET_BIT(psSrcImage->img_mask,src_off) )
-          continue;
-
-        nSetPoints++;
-
-        dst_off = nDstX + nDstY * psDstImage->width;
-
-        MS_SET_BIT(psDstImage->img_mask,dst_off);
-
-        for( band = 0; band < psSrcImage->format->bands; band++ ) {
-          if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
-            psDstImage->img.raw_16bit[dst_off]
-              = psSrcImage->img.raw_16bit[src_off];
-          } else if( psSrcImage->format->imagemode
-                     == MS_IMAGEMODE_FLOAT32) {
-            psDstImage->img.raw_float[dst_off]
-              = psSrcImage->img.raw_float[src_off];
-          } else if(psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
-            psDstImage->img.raw_byte[dst_off]
-              = psSrcImage->img.raw_byte[src_off];
-          } else {
-            assert( 0 );
-          }
-          src_off += psSrcImage->width * psSrcImage->height;
-          dst_off += psDstImage->width * psDstImage->height;
-        }
-      }
-    }
-  }
-
-  free( panSuccess );
-  free( x );
-  free( y );
-
-  /* -------------------------------------------------------------------- */
-  /*      Some debugging output.                                          */
-  /* -------------------------------------------------------------------- */
-  if( nFailedPoints > 0 && debug ) {
-    msDebug( "msNearestRasterResampler: "
-             "%d failed to transform, %d actually set.\n",
-             nFailedPoints, nSetPoints );
-  }
-
-  return 0;
-}
-
-/************************************************************************/
-/*                            msSourceSample()                          */
-/************************************************************************/
-
-static void msSourceSample( imageObj *psSrcImage, rasterBufferObj *rb,
-                            int iSrcX, int iSrcY, double *padfPixelSum,
-                            double dfWeight, double *pdfWeightSum )
-
-{
-  if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
-    rgbaArrayObj *rgba;
-    int rb_off;
-    assert(rb && rb->type == MS_BUFFER_BYTE_RGBA);
-    rgba = &(rb->data.rgba);
-    rb_off = iSrcX * rgba->pixel_step + iSrcY * rgba->row_step;
-
-    if( rgba->a == NULL || rgba->a[rb_off] > 1 ) {
-      padfPixelSum[0] += rgba->r[rb_off] * dfWeight;
-      padfPixelSum[1] += rgba->g[rb_off] * dfWeight;
-      padfPixelSum[2] += rgba->b[rb_off] * dfWeight;
-
-      if( rgba->a == NULL )
-        *pdfWeightSum += dfWeight;
-      else
-        *pdfWeightSum += dfWeight * (rgba->a[rb_off] / 255.0);
-    }
-  } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
-    int band;
-    int src_off;
-
-    src_off = iSrcX + iSrcY * psSrcImage->width;
-
-    if( !MS_GET_BIT(psSrcImage->img_mask,src_off) )
-      return;
-
-    for( band = 0; band < psSrcImage->format->bands; band++ ) {
-      if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
-        int nValue;
-
-        nValue = psSrcImage->img.raw_16bit[src_off];
-
-        padfPixelSum[band] += dfWeight * nValue;
-      } else if( psSrcImage->format->imagemode
-                 == MS_IMAGEMODE_FLOAT32) {
-        float fValue;
-
-        fValue = psSrcImage->img.raw_float[src_off];
-
-        padfPixelSum[band] += fValue * dfWeight;
-      } else if(psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
-        int nValue;
-
-        nValue = psSrcImage->img.raw_byte[src_off];
-
-        padfPixelSum[band] += nValue * dfWeight;
-      } else {
-        assert( 0 );
-        return;
-      }
-
-      src_off += psSrcImage->width * psSrcImage->height;
-    }
-    *pdfWeightSum += dfWeight;
-  }
-}
-
-/************************************************************************/
-/*                      msBilinearRasterResample()                      */
-/************************************************************************/
-
-static int
-msBilinearRasterResampler( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                           imageObj *psDstImage, rasterBufferObj *dst_rb,
-                           SimpleTransformer pfnTransform, void *pCBData,
-                           int debug, rasterBufferObj *mask_rb,
-                           int bWrapAtLeftRight )
-
-{
-  double  *x, *y;
-  int   nDstX, nDstY, i;
-  int         *panSuccess;
-  int   nDstXSize = psDstImage->width;
-  int   nDstYSize = psDstImage->height;
-  int   nSrcXSize = psSrcImage->width;
-  int   nSrcYSize = psSrcImage->height;
-  int   nFailedPoints = 0, nSetPoints = 0;
-  double     *padfPixelSum;
-  int         bandCount = MS_MAX(4,psSrcImage->format->bands);
-
-  padfPixelSum = (double *) msSmallMalloc(sizeof(double) * bandCount);
-
-
-
-  x = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  y = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  panSuccess = (int *) msSmallMalloc( sizeof(int) * nDstXSize );
-
-  for( nDstY = 0; nDstY < nDstYSize; nDstY++ ) {
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      x[nDstX] = nDstX + 0.5;
-      y[nDstX] = nDstY + 0.5;
-    }
-
-    pfnTransform( pCBData, nDstXSize, x, y, panSuccess );
-
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      int   nSrcX, nSrcY, nSrcX2, nSrcY2;
-      double      dfRatioX2, dfRatioY2, dfWeightSum = 0.0;
-      if(SKIP_MASK(nDstX,nDstY)) continue;
-
-      if( !panSuccess[nDstX] ) {
-        nFailedPoints++;
-        continue;
-      }
-
-      /* If we are right off the source, skip this pixel */
-      nSrcX = (int) floor(x[nDstX]);
-      nSrcY = (int) floor(y[nDstX]);
-      if( nSrcX < 0 || (!bWrapAtLeftRight && nSrcX >= nSrcXSize)
-          || nSrcY  < 0 || nSrcY >= nSrcYSize )
-        continue;
-
-      /*
-      ** Offset to treat TL pixel corners as pixel location instead
-      ** of the center.
-      */
-      x[nDstX] -= 0.5;
-      y[nDstX] -= 0.5;
-
-      nSrcX = (int) floor(x[nDstX]);
-      nSrcY = (int) floor(y[nDstX]);
-
-      nSrcX2 = nSrcX+1;
-      nSrcY2 = nSrcY+1;
-
-      dfRatioX2 = x[nDstX] - nSrcX;
-      dfRatioY2 = y[nDstX] - nSrcY;
-
-      /* Trim in stuff one pixel off the edge */
-      nSrcX = MS_MAX(nSrcX,0);
-      nSrcY = MS_MAX(nSrcY,0);
-      if( !bWrapAtLeftRight )
-        nSrcX2 = MS_MIN(nSrcX2,nSrcXSize-1);
-      nSrcY2 = MS_MIN(nSrcY2,nSrcYSize-1);
-
-      memset( padfPixelSum, 0, sizeof(double) * bandCount);
-
-      msSourceSample( psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY, padfPixelSum,
-                      (1.0 - dfRatioX2) * (1.0 - dfRatioY2),
-                      &dfWeightSum );
-
-      msSourceSample( psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY, padfPixelSum,
-                      (dfRatioX2) * (1.0 - dfRatioY2),
-                      &dfWeightSum );
-
-      msSourceSample( psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY2, padfPixelSum,
-                      (1.0 - dfRatioX2) * (dfRatioY2),
-                      &dfWeightSum );
-
-      msSourceSample( psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY2, padfPixelSum,
-                      (dfRatioX2) * (dfRatioY2),
-                      &dfWeightSum );
-
-      if( dfWeightSum == 0.0 )
-        continue;
-
-      if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
-        assert(src_rb && dst_rb);
-        assert( src_rb->type == MS_BUFFER_BYTE_RGBA );
-        assert( src_rb->type == dst_rb->type );
-
-
-        nSetPoints++;
-
-        if( dfWeightSum > 0.001 ) {
-          int dst_rb_off = nDstX * dst_rb->data.rgba.pixel_step + nDstY * dst_rb->data.rgba.row_step;
-          unsigned char red, green, blue, alpha;
-
-          red   = (unsigned char) MS_MAX(0,MS_MIN(255,padfPixelSum[0]));
-          green = (unsigned char) MS_MAX(0,MS_MIN(255,padfPixelSum[1]));
-          blue  = (unsigned char) MS_MAX(0,MS_MIN(255,padfPixelSum[2]));
-          alpha = (unsigned char)MS_MAX(0,MS_MIN(255,255.5*dfWeightSum));
-
-          msAlphaBlendPM( red, green, blue, alpha,
-                          dst_rb->data.rgba.r + dst_rb_off,
-                          dst_rb->data.rgba.g + dst_rb_off,
-                          dst_rb->data.rgba.b + dst_rb_off,
-                          (dst_rb->data.rgba.a == NULL) ? NULL : dst_rb->data.rgba.a + dst_rb_off );
-        }
-      } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
-        int band;
-        int dst_off = nDstX + nDstY * psDstImage->width;
-
-        for( i = 0; i < bandCount; i++ )
-            padfPixelSum[i] /= dfWeightSum;
-
-        MS_SET_BIT(psDstImage->img_mask,dst_off);
-
-        for( band = 0; band < psSrcImage->format->bands; band++ ) {
-          if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
-            psDstImage->img.raw_16bit[dst_off]
-              = (short) padfPixelSum[band];
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
-            psDstImage->img.raw_float[dst_off]
-              = (float) padfPixelSum[band];
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE ) {
-            psDstImage->img.raw_byte[dst_off]
-              = (unsigned char)MS_MAX(0,MS_MIN(255,padfPixelSum[band]));
-          }
-
-          dst_off += psDstImage->width*psDstImage->height;
-        }
-      }
-    }
-  }
-
-  free( padfPixelSum );
-  free( panSuccess );
-  free( x );
-  free( y );
-
-  /* -------------------------------------------------------------------- */
-  /*      Some debugging output.                                          */
-  /* -------------------------------------------------------------------- */
-  if( nFailedPoints > 0 && debug )
-  {
-    msDebug( "msBilinearRasterResampler: "
-             "%d failed to transform, %d actually set.\n",
-             nFailedPoints, nSetPoints );
-  }
-
-  return 0;
-}
-
-/************************************************************************/
-/*                          msAverageSample()                           */
-/************************************************************************/
-
-static int
-msAverageSample( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                 double dfXMin, double dfYMin, double dfXMax, double dfYMax,
-                 double *padfPixelSum,
-                 double *pdfAlpha01 )
-
-{
-  int nXMin, nXMax, nYMin, nYMax, iX, iY;
-  double dfWeightSum = 0.0;
-  double dfMaxWeight = 0.0;
-
-  nXMin = (int) dfXMin;
-  nYMin = (int) dfYMin;
-  nXMax = (int) ceil(dfXMax);
-  nYMax = (int) ceil(dfYMax);
-
-  *pdfAlpha01 = 0.0;
-
-  for( iY = nYMin; iY < nYMax; iY++ ) {
-    double dfYCellMin, dfYCellMax;
-
-    dfYCellMin = MS_MAX(iY,dfYMin);
-    dfYCellMax = MS_MIN(iY+1,dfYMax);
-
-    for( iX = nXMin; iX < nXMax; iX++ ) {
-      double dfXCellMin, dfXCellMax, dfWeight;
-
-      dfXCellMin = MS_MAX(iX,dfXMin);
-      dfXCellMax = MS_MIN(iX+1,dfXMax);
-
-      dfWeight = (dfXCellMax-dfXCellMin) * (dfYCellMax-dfYCellMin);
-
-      msSourceSample( psSrcImage, src_rb, iX, iY, padfPixelSum,
-                      dfWeight, &dfWeightSum );
-      dfMaxWeight += dfWeight;
-    }
-  }
-
-  if( dfWeightSum == 0.0 )
-    return MS_FALSE;
-
-  for( iX = 0; iX < 4; iX++ )
-    padfPixelSum[iX] /= dfWeightSum;
-
-  *pdfAlpha01 = dfWeightSum / dfMaxWeight;
-
-  return MS_TRUE;
-}
-
-/************************************************************************/
-/*                      msAverageRasterResample()                       */
-/************************************************************************/
-
-static int
-msAverageRasterResampler( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                          imageObj *psDstImage, rasterBufferObj *dst_rb,
-                          SimpleTransformer pfnTransform, void *pCBData,
-                          int debug, rasterBufferObj *mask_rb )
-
-{
-  double  *x1, *y1, *x2, *y2;
-  int   nDstX, nDstY;
-  int         *panSuccess1, *panSuccess2;
-  int   nDstXSize = psDstImage->width;
-  int   nDstYSize = psDstImage->height;
-  int   nFailedPoints = 0, nSetPoints = 0;
-  double     *padfPixelSum;
-
-  int         bandCount = MS_MAX(4,psSrcImage->format->bands);
-
-  padfPixelSum = (double *) msSmallMalloc(sizeof(double) * bandCount);
-
-
-
-  x1 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  y1 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  x2 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  y2 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  panSuccess1 = (int *) msSmallMalloc( sizeof(int) * (nDstXSize+1) );
-  panSuccess2 = (int *) msSmallMalloc( sizeof(int) * (nDstXSize+1) );
-
-  for( nDstY = 0; nDstY < nDstYSize; nDstY++ ) {
-    for( nDstX = 0; nDstX <= nDstXSize; nDstX++ ) {
-      x1[nDstX] = nDstX;
-      y1[nDstX] = nDstY;
-      x2[nDstX] = nDstX;
-      y2[nDstX] = nDstY+1;
-    }
-
-    pfnTransform( pCBData, nDstXSize+1, x1, y1, panSuccess1 );
-    pfnTransform( pCBData, nDstXSize+1, x2, y2, panSuccess2 );
-
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      double  dfXMin, dfYMin, dfXMax, dfYMax;
-      double  dfAlpha01;
-      if(SKIP_MASK(nDstX,nDstY)) continue;
-
-      /* Do not generate a pixel unless all four corners transformed */
-      if( !panSuccess1[nDstX] || !panSuccess1[nDstX+1]
-          || !panSuccess2[nDstX] || !panSuccess2[nDstX+1] ) {
-        nFailedPoints++;
-        continue;
-      }
-
-      dfXMin = MS_MIN(MS_MIN(x1[nDstX],x1[nDstX+1]),
-                   MS_MIN(x2[nDstX],x2[nDstX+1]));
-      dfYMin = MS_MIN(MS_MIN(y1[nDstX],y1[nDstX+1]),
-                   MS_MIN(y2[nDstX],y2[nDstX+1]));
-      dfXMax = MS_MAX(MS_MAX(x1[nDstX],x1[nDstX+1]),
-                   MS_MAX(x2[nDstX],x2[nDstX+1]));
-      dfYMax = MS_MAX(MS_MAX(y1[nDstX],y1[nDstX+1]),
-                   MS_MAX(y2[nDstX],y2[nDstX+1]));
-
-      dfXMin = MS_MIN(MS_MAX(dfXMin,0),psSrcImage->width+1);
-      dfYMin = MS_MIN(MS_MAX(dfYMin,0),psSrcImage->height+1);
-      dfXMax = MS_MIN(MS_MAX(-1,dfXMax),psSrcImage->width);
-      dfYMax = MS_MIN(MS_MAX(-1,dfYMax),psSrcImage->height);
-
-      memset( padfPixelSum, 0, sizeof(double)*bandCount );
-
-      if( !msAverageSample( psSrcImage, src_rb,
-                            dfXMin, dfYMin, dfXMax, dfYMax,
-                            padfPixelSum, &dfAlpha01 ) )
-        continue;
-
-      if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
-        assert(dst_rb && src_rb);
-        assert( dst_rb->type == MS_BUFFER_BYTE_RGBA );
-        assert( src_rb->type == dst_rb ->type );
-
-        nSetPoints++;
-
-        if( dfAlpha01 > 0 ) {
-          unsigned char red, green, blue, alpha;
-
-          red   = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,padfPixelSum[0]+0.5));
-          green = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,padfPixelSum[1]+0.5));
-          blue  = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,padfPixelSum[2]+0.5));
-          alpha = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,255*dfAlpha01+0.5));
-
-          RB_MIX_PIXEL(dst_rb,nDstX,nDstY,
-                       red, green, blue, alpha );
-        }
-      } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
-        int band;
-        int dst_off = nDstX + nDstY * psDstImage->width;
-
-        MS_SET_BIT(psDstImage->img_mask,dst_off);
-
-        for( band = 0; band < psSrcImage->format->bands; band++ ) {
-          if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
-            psDstImage->img.raw_16bit[dst_off]
-              = (short) (padfPixelSum[band]+0.5);
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
-            psDstImage->img.raw_float[dst_off]
-              = (float) padfPixelSum[band];
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE ) {
-            psDstImage->img.raw_byte[dst_off]
-              = (unsigned char) padfPixelSum[band];
-          }
-
-          dst_off += psDstImage->width * psDstImage->height;
-        }
-      }
-    }
-  }
-
-  free( padfPixelSum );
-  free( panSuccess1 );
-  free( x1 );
-  free( y1 );
-  free( panSuccess2 );
-  free( x2 );
-  free( y2 );
-
-  /* -------------------------------------------------------------------- */
-  /*      Some debugging output.                                          */
-  /* -------------------------------------------------------------------- */
-  if( nFailedPoints > 0 && debug )
-  {
-    msDebug( "msAverageRasterResampler: "
-             "%d failed to transform, %d actually set.\n",
-             nFailedPoints, nSetPoints );
-  }
-
-  return 0;
-}
-
-/************************************************************************/
-/* ==================================================================== */
-/*      PROJ based transformer.         */
-/* ==================================================================== */
-/************************************************************************/
-
-typedef struct {
-  projectionObj *psSrcProjObj;
-  int bSrcIsGeographic;
-  double adfInvSrcGeoTransform[6];
-
-  projectionObj *psDstProjObj;
-  int bDstIsGeographic;
-  double adfDstGeoTransform[6];
-
-  int  bUseProj;
-#if PROJ_VERSION_MAJOR >= 6
-  reprojectionObj* pReprojectionDstToSrc;
-#endif
-} msProjTransformInfo;
-
-/************************************************************************/
-/*                       msInitProjTransformer()                        */
-/************************************************************************/
-
-void *msInitProjTransformer( projectionObj *psSrc,
-                             double *padfSrcGeoTransform,
-                             projectionObj *psDst,
-                             double *padfDstGeoTransform )
-
-{
-  int backup_src_need_gt;
-  int backup_dst_need_gt;
-  msProjTransformInfo *psPTInfo;
-
-  psPTInfo = (msProjTransformInfo *) msSmallCalloc(1,sizeof(msProjTransformInfo));
-
-  /* -------------------------------------------------------------------- */
-  /*      We won't even use PROJ.4 if either coordinate system is         */
-  /*      NULL.                                                           */
-  /* -------------------------------------------------------------------- */
-  backup_src_need_gt = psSrc->gt.need_geotransform;
-  psSrc->gt.need_geotransform = 0;
-  backup_dst_need_gt = psDst->gt.need_geotransform;
-  psDst->gt.need_geotransform = 0;
-  psPTInfo->bUseProj =
-    (psSrc->proj != NULL && psDst->proj != NULL
-     && msProjectionsDiffer( psSrc, psDst ) );
-  psSrc->gt.need_geotransform = backup_src_need_gt;
-  psDst->gt.need_geotransform = backup_dst_need_gt;
-
-  /* -------------------------------------------------------------------- */
-  /*      Record source image information.  We invert the source          */
-  /*      transformation for more convenient inverse application in       */
-  /*      the transformer.                                                */
-  /* -------------------------------------------------------------------- */
-  psPTInfo->psSrcProjObj = psSrc;
-  if( psPTInfo->bUseProj )
-    psPTInfo->bSrcIsGeographic = msProjIsGeographicCRS(psSrc);
-  else
-    psPTInfo->bSrcIsGeographic = MS_FALSE;
-
-  if( !InvGeoTransform(padfSrcGeoTransform,
-                       psPTInfo->adfInvSrcGeoTransform) ) {
-    free(psPTInfo);
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Record destination image information.                           */
-  /* -------------------------------------------------------------------- */
-  psPTInfo->psDstProjObj = psDst;
-  if( psPTInfo->bUseProj )
-    psPTInfo->bDstIsGeographic = msProjIsGeographicCRS(psDst);
-  else
-    psPTInfo->bDstIsGeographic = MS_FALSE;
-  memcpy( psPTInfo->adfDstGeoTransform, padfDstGeoTransform,
-          sizeof(double) * 6 );
-
-#if PROJ_VERSION_MAJOR >= 6
-  if( psPTInfo->bUseProj )
-  {
-    psPTInfo->pReprojectionDstToSrc =
-        msProjectCreateReprojector( psPTInfo->psDstProjObj, psPTInfo->psSrcProjObj );
-    if( !psPTInfo->pReprojectionDstToSrc )
-    {
-        free(psPTInfo);
-        return NULL;
-    }
-  }
-#endif
-
-  return psPTInfo;
-}
-
-/************************************************************************/
-/*                       msFreeProjTransformer()                        */
-/************************************************************************/
-
-void msFreeProjTransformer( void * pCBData )
-
-{
-#if PROJ_VERSION_MAJOR >= 6
-  if( pCBData )
-  {
-      msProjTransformInfo *psPTInfo = (msProjTransformInfo *)pCBData;
-      msProjectDestroyReprojector(psPTInfo->pReprojectionDstToSrc);
-  }
-#endif
-  free( pCBData );
-}
-
-/************************************************************************/
-/*                          msProjTransformer                           */
-/************************************************************************/
-
-int msProjTransformer( void *pCBData, int nPoints,
-                       double *x, double *y, int *panSuccess )
-
-{
-  int   i;
-  msProjTransformInfo *psPTInfo = (msProjTransformInfo*) pCBData;
-  double  x_out;
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform into destination georeferenced space.                 */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < nPoints; i++ ) {
-    x_out = psPTInfo->adfDstGeoTransform[0]
-            + psPTInfo->adfDstGeoTransform[1] * x[i]
-            + psPTInfo->adfDstGeoTransform[2] * y[i];
-    y[i] = psPTInfo->adfDstGeoTransform[3]
-           + psPTInfo->adfDstGeoTransform[4] * x[i]
-           + psPTInfo->adfDstGeoTransform[5] * y[i];
-    x[i] = x_out;
-
-    panSuccess[i] = 1;
-  }
-
-#if PROJ_VERSION_MAJOR >= 6
-  if( psPTInfo->bUseProj ) {
-    if( msProjectTransformPoints( psPTInfo->pReprojectionDstToSrc,
-                                  nPoints, x, y ) != MS_SUCCESS ) {
-      for( i = 0; i < nPoints; i++ )
-        panSuccess[i] = 0;
-
-      return MS_FALSE;
-    }
-    for( i = 0; i < nPoints; i++ ) {
-      if( x[i] == HUGE_VAL || y[i] == HUGE_VAL )
-        panSuccess[i] = 0;
-    }
-  }
-#else
-  /* -------------------------------------------------------------------- */
-  /*      Transform from degrees to radians if geographic.                */
-  /* -------------------------------------------------------------------- */
-  if( psPTInfo->bDstIsGeographic ) {
-    for( i = 0; i < nPoints; i++ ) {
-      x[i] = x[i] * DEG_TO_RAD;
-      y[i] = y[i] * DEG_TO_RAD;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform back to source projection space.                      */
-  /* -------------------------------------------------------------------- */
-  if( psPTInfo->bUseProj ) {
-    double *z;
-    int tr_result;
-
-    z = (double *) msSmallCalloc(sizeof(double),nPoints);
-
-    msAcquireLock( TLOCK_PROJ );
-    tr_result = pj_transform( psPTInfo->psDstProjObj->proj, psPTInfo->psSrcProjObj->proj,
-                              nPoints, 1, x, y,  z);
-    msReleaseLock( TLOCK_PROJ );
-
-    if( tr_result != 0 ) {
-      free( z );
-      for( i = 0; i < nPoints; i++ )
-        panSuccess[i] = 0;
-
-      return MS_FALSE;
-    }
-    free( z );
-
-    for( i = 0; i < nPoints; i++ ) {
-      if( x[i] == HUGE_VAL || y[i] == HUGE_VAL )
-        panSuccess[i] = 0;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform back to degrees if source is geographic.              */
-  /* -------------------------------------------------------------------- */
-  if( psPTInfo->bSrcIsGeographic ) {
-    for( i = 0; i < nPoints; i++ ) {
-      if( panSuccess[i] ) {
-        x[i] = x[i] * RAD_TO_DEG;
-        y[i] = y[i] * RAD_TO_DEG;
-      }
-    }
-  }
-#endif
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform to source raster space.                               */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < nPoints; i++ ) {
-    if( panSuccess[i] ) {
-      x_out = psPTInfo->adfInvSrcGeoTransform[0]
-              + psPTInfo->adfInvSrcGeoTransform[1] * x[i]
-              + psPTInfo->adfInvSrcGeoTransform[2] * y[i];
-      y[i] = psPTInfo->adfInvSrcGeoTransform[3]
-             + psPTInfo->adfInvSrcGeoTransform[4] * x[i]
-             + psPTInfo->adfInvSrcGeoTransform[5] * y[i];
-      x[i] = x_out;
-    } else {
-      x[i] = -1;
-      y[i] = -1;
-    }
-  }
-
-  return 1;
-}
-
-/************************************************************************/
-/* ==================================================================== */
-/*      Approximate transformer.                                        */
-/* ==================================================================== */
-/************************************************************************/
-
-typedef struct {
-  SimpleTransformer pfnBaseTransformer;
-  void             *pBaseCBData;
-
-  double        dfMaxError;
-} msApproxTransformInfo;
-
-/************************************************************************/
-/*                      msInitApproxTransformer()                       */
-/************************************************************************/
-
-static void *msInitApproxTransformer( SimpleTransformer pfnBaseTransformer,
-                                      void *pBaseCBData,
-                                      double dfMaxError )
-
-{
-  msApproxTransformInfo *psATInfo;
-
-  psATInfo = (msApproxTransformInfo *) msSmallMalloc(sizeof(msApproxTransformInfo));
-  psATInfo->pfnBaseTransformer = pfnBaseTransformer;
-  psATInfo->pBaseCBData = pBaseCBData;
-  psATInfo->dfMaxError = dfMaxError;
-
-  return psATInfo;
-}
-
-/************************************************************************/
-/*                      msFreeApproxTransformer()                       */
-/************************************************************************/
-
-static void msFreeApproxTransformer( void * pCBData )
-
-{
-  free( pCBData );
-}
-
-/************************************************************************/
-/*                         msApproxTransformer                          */
-/************************************************************************/
-
-static int msApproxTransformer( void *pCBData, int nPoints,
-                                double *x, double *y, int *panSuccess )
-
-{
-  msApproxTransformInfo *psATInfo = (msApproxTransformInfo *) pCBData;
-  double x2[3], y2[3], dfDeltaX, dfDeltaY, dfError, dfDist;
-  int nMiddle, anSuccess2[3], i, bSuccess;
-
-  nMiddle = (nPoints-1)/2;
-
-  /* -------------------------------------------------------------------- */
-  /*      Bail if our preconditions are not met, or if error is not       */
-  /*      acceptable.                                                     */
-  /* -------------------------------------------------------------------- */
-  if( y[0] != y[nPoints-1] || y[0] != y[nMiddle]
-      || x[0] == x[nPoints-1] || x[0] == x[nMiddle]
-      || psATInfo->dfMaxError == 0.0 || nPoints <= 5 ) {
-    return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData, nPoints,
-                                         x, y, panSuccess );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform first, last and middle point.                         */
-  /* -------------------------------------------------------------------- */
-  x2[0] = x[0];
-  y2[0] = y[0];
-  x2[1] = x[nMiddle];
-  y2[1] = y[nMiddle];
-  x2[2] = x[nPoints-1];
-  y2[2] = y[nPoints-1];
-
-  bSuccess =
-    psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData, 3, x2, y2,
-                                  anSuccess2 );
-  if( !bSuccess || !anSuccess2[0] || !anSuccess2[1] || !anSuccess2[2] )
-    return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData, nPoints,
-                                         x, y, panSuccess );
-
-  /* -------------------------------------------------------------------- */
-  /*      Is the error at the middle acceptable relative to an            */
-  /*      interpolation of the middle position?                           */
-  /* -------------------------------------------------------------------- */
-  dfDeltaX = (x2[2] - x2[0]) / (x[nPoints-1] - x[0]);
-  dfDeltaY = (y2[2] - y2[0]) / (x[nPoints-1] - x[0]);
-
-  dfError = fabs((x2[0] + dfDeltaX * (x[nMiddle] - x[0])) - x2[1])
-            + fabs((y2[0] + dfDeltaY * (x[nMiddle] - x[0])) - y2[1]);
-
-  if( dfError > psATInfo->dfMaxError ) {
-    bSuccess =
-      msApproxTransformer( psATInfo, nMiddle, x, y, panSuccess );
-
-    if( !bSuccess ) {
-      return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData,
-                                           nPoints,
-                                           x, y, panSuccess );
-    }
-
-    bSuccess =
-      msApproxTransformer( psATInfo, nPoints - nMiddle,
-                           x+nMiddle, y+nMiddle, panSuccess+nMiddle );
-
-    if( !bSuccess ) {
-      return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData,
-                                           nPoints,
-                                           x, y, panSuccess );
-    }
-
-    return 1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Error is OK, linearly interpolate all points along line.        */
-  /* -------------------------------------------------------------------- */
-  for( i = nPoints-1; i >= 0; i-- ) {
-    dfDist = (x[i] - x[0]);
-    y[i] = y2[0] + dfDeltaY * dfDist;
-    x[i] = x2[0] + dfDeltaX * dfDist;
-    panSuccess[i] = 1;
-  }
-
-  return 1;
-}
-
-/************************************************************************/
-/*                       msTransformMapToSource()                       */
-/*                                                                      */
-/*      Compute the extents of the current map view if transformed      */
-/*      onto the source raster.                                         */
-/************************************************************************/
-
-static int msTransformMapToSource( int nDstXSize, int nDstYSize,
-                                   double * adfDstGeoTransform,
-                                   projectionObj *psDstProj,
-                                   int nSrcXSize, int nSrcYSize,
-                                   double * adfInvSrcGeoTransform,
-                                   projectionObj *psSrcProj,
-                                   rectObj *psSrcExtent,
-                                   int bUseGrid )
-
-{
-  int nFailures = 0;
-
-#define EDGE_STEPS    10
-#define MAX_SIZE      ((EDGE_STEPS+1)*(EDGE_STEPS+1))
-
-  int   i, nSamples = 0, bOutInit = 0;
-  double      dfRatio;
-  double  x[MAX_SIZE], y[MAX_SIZE];
-#if PROJ_VERSION_MAJOR < 6
-  double z[MAX_SIZE];
-#endif
-
-  /* -------------------------------------------------------------------- */
-  /*      Collect edges in map image pixel/line coordinates               */
-  /* -------------------------------------------------------------------- */
-  if( !bUseGrid ) {
-    for( dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0/EDGE_STEPS) ) {
-      assert( nSamples < MAX_SIZE );
-      x[nSamples  ] = dfRatio * nDstXSize;
-      y[nSamples++] = 0.0;
-      x[nSamples  ] = dfRatio * nDstXSize;
-      y[nSamples++] = nDstYSize;
-      x[nSamples  ] = 0.0;
-      y[nSamples++] = dfRatio * nDstYSize;
-      x[nSamples  ] = nDstXSize;
-      y[nSamples++] = dfRatio * nDstYSize;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Collect a grid in the hopes of a more accurate region.          */
-  /* -------------------------------------------------------------------- */
-  else {
-    double dfRatio2;
-
-    for( dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0/EDGE_STEPS) ) {
-      for( dfRatio2=0.0; dfRatio2 <= 1.001; dfRatio2 += (1.0/EDGE_STEPS)) {
-        assert( nSamples < MAX_SIZE );
-        x[nSamples  ] = dfRatio2 * nDstXSize;
-        y[nSamples++] = dfRatio * nDstYSize;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      transform to map georeferenced units                            */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < nSamples; i++ ) {
-    double    x_out, y_out;
-
-    x_out = adfDstGeoTransform[0]
-            + x[i] * adfDstGeoTransform[1]
-            + y[i] * adfDstGeoTransform[2];
-
-    y_out = adfDstGeoTransform[3]
-            + x[i] * adfDstGeoTransform[4]
-            + y[i] * adfDstGeoTransform[5];
-
-    x[i] = x_out;
-    y[i] = y_out;
-#if PROJ_VERSION_MAJOR < 6
-    z[i] = 0.0;
-#endif
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Transform to layer georeferenced coordinates.                   */
-  /* -------------------------------------------------------------------- */
-  if( psDstProj->proj && psSrcProj->proj ) {
-#if PROJ_VERSION_MAJOR >= 6
-    reprojectionObj* reprojector = msProjectCreateReprojector(psDstProj, psSrcProj);
-    if( !reprojector )
-        return MS_FALSE;
-    if( msProjectTransformPoints( reprojector, nSamples, x, y ) != MS_SUCCESS ) {
-      msProjectDestroyReprojector(reprojector);
-      return MS_FALSE;
-    }
-    msProjectDestroyReprojector(reprojector);
-#else
-    int tr_result;
-    if( msProjIsGeographicCRS(psDstProj) ) {
-      for( i = 0; i < nSamples; i++ ) {
-        x[i] = x[i] * DEG_TO_RAD;
-        y[i] = y[i] * DEG_TO_RAD;
-      }
-    }
-
-    msAcquireLock( TLOCK_PROJ );
-    tr_result = pj_transform( psDstProj->proj, psSrcProj->proj,
-                              nSamples, 1, x, y, z );
-    msReleaseLock( TLOCK_PROJ );
-
-    if( tr_result != 0 )
-      return MS_FALSE;
-
-    if( msProjIsGeographicCRS(psSrcProj) ) {
-      for( i = 0; i < nSamples; i++ ) {
-        if( x[i] != HUGE_VAL && y[i] != HUGE_VAL ) {
-          x[i] = x[i] * RAD_TO_DEG;
-          y[i] = y[i] * RAD_TO_DEG;
-        }
-      }
-    }
-#endif
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If we just using the edges (not a grid) and we go some          */
-  /*      errors, then we need to restart using a grid pattern.           */
-  /* -------------------------------------------------------------------- */
-  if( !bUseGrid ) {
-    for( i = 0; i < nSamples; i++ ) {
-      if( x[i] == HUGE_VAL || y[i] == HUGE_VAL ) {
-        return msTransformMapToSource( nDstXSize, nDstYSize,
-                                       adfDstGeoTransform, psDstProj,
-                                       nSrcXSize, nSrcYSize,
-                                       adfInvSrcGeoTransform,psSrcProj,
-                                       psSrcExtent, 1 );
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      transform to layer raster coordinates, and collect bounds.      */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < nSamples; i++ ) {
-    double    x_out, y_out;
-
-    if( x[i] == HUGE_VAL || y[i] == HUGE_VAL ) {
-      nFailures++;
-      continue;
-    }
-
-    x_out =      adfInvSrcGeoTransform[0]
-                 +   x[i]*adfInvSrcGeoTransform[1]
-                 +   y[i]*adfInvSrcGeoTransform[2];
-    y_out =      adfInvSrcGeoTransform[3]
-                 +   x[i]*adfInvSrcGeoTransform[4]
-                 +   y[i]*adfInvSrcGeoTransform[5];
-
-    if( !bOutInit ) {
-      psSrcExtent->minx = psSrcExtent->maxx = x_out;
-      psSrcExtent->miny = psSrcExtent->maxy = y_out;
-      bOutInit = 1;
-    } else {
-      psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
-      psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
-      psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
-      psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Deal with discontinuities related to lon_wrap=XXX in source     */
-  /*      projection. In that case we must check if the points at         */
-  /*      lon_wrap +/- 180deg are in the output raster.                   */
-  /* -------------------------------------------------------------------- */
-  if( bOutInit && msProjIsGeographicCRS(psSrcProj) )
-  {
-      double dfLonWrap = 0;
-      int bHasLonWrap = msProjectHasLonWrap(psSrcProj, &dfLonWrap);
-
-      if( bHasLonWrap )
-      {
-          double x2[2], y2[2];
-#if PROJ_VERSION_MAJOR < 6
-          double z2[2];
-#endif
-          int nCountY = 0;
-          double dfY = 0.0;
-          double dfXMinOut = 0.0;
-          double dfYMinOut = 0.0;
-          double dfXMaxOut = 0.0;
-          double dfYMaxOut = 0.0;
-          const double dfHalfRes = adfDstGeoTransform[1] / 2;
-
-          /* Find out average y coordinate in src projection */
-          for( i = 0; i < nSamples; i++ ) {
-              if( y[i] != HUGE_VAL ) {
-                  dfY += y[i];
-                  nCountY ++;
-              }
-          }
-          dfY /= nCountY;
-
-          /* Compute bounds of output raster */
-          for( i = 0; i < 4; i ++ )
-          {
-              double dfX = adfDstGeoTransform[0] +
-                ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[1] +
-                ((i == 1 || i == 3 ) ? nDstYSize : 0) * adfDstGeoTransform[2];
-              double dfY = adfDstGeoTransform[3] +
-                ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[4] +
-                ((i == 1 || i == 3 ) ? nDstYSize : 0) * adfDstGeoTransform[5];
-              if( i == 0 || dfX < dfXMinOut ) dfXMinOut = dfX;
-              if( i == 0 || dfY < dfYMinOut ) dfYMinOut = dfY;
-              if( i == 0 || dfX > dfXMaxOut ) dfXMaxOut = dfX;
-              if( i == 0 || dfY > dfYMaxOut ) dfYMaxOut = dfY;
-          }
-
-          x2[0] = dfLonWrap-180+1e-7;
-          y2[0] = dfY;
-
-          x2[1] = dfLonWrap+180-1e-7;
-          y2[1] = dfY;
-
-#if PROJ_VERSION_MAJOR >= 6
-          {
-            reprojectionObj* reprojector = msProjectCreateReprojector(psSrcProj, psDstProj);
-            if( reprojector )
-            {
-              msProjectTransformPoints( reprojector, 2, x2, y2 );
-              msProjectDestroyReprojector(reprojector);
-            }
-          }
-#else
-          z2[0] = 0.0;
-          z2[1] = 0.0;
-          msAcquireLock( TLOCK_PROJ );
-          pj_transform( psSrcProj->proj, psDstProj->proj,
-                        2, 1, x2, y2, z2 );
-          msReleaseLock( TLOCK_PROJ );
-#endif
-
-          if( x2[0] >= dfXMinOut - dfHalfRes && x2[0] <= dfXMaxOut + dfHalfRes &&
-              y2[0] >= dfYMinOut && y2[0] <= dfYMaxOut )
-          {
-                double x_out =      adfInvSrcGeoTransform[0]
-                            +   (dfLonWrap-180)*adfInvSrcGeoTransform[1]
-                            +   dfY*adfInvSrcGeoTransform[2];
-                double y_out =      adfInvSrcGeoTransform[3]
-                            +   (dfLonWrap-180)*adfInvSrcGeoTransform[4]
-                            +   dfY*adfInvSrcGeoTransform[5];
-
-                /* Does the raster cover, at least, a whole 360 deg range ? */
-                if( nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360) )
-                {
-                    psSrcExtent->minx = 0;
-                    psSrcExtent->maxx = nSrcXSize;
-                }
-                else
-                {
-                    psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
-                    psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
-                }
-                psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
-                psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
-          }
-
-          if( x2[1] >= dfXMinOut - dfHalfRes && x2[1] <= dfXMaxOut + dfHalfRes &&
-              y2[1] >= dfYMinOut && y2[1] <= dfYMaxOut )
-          {
-                double x_out =      adfInvSrcGeoTransform[0]
-                            +   (dfLonWrap+180)*adfInvSrcGeoTransform[1]
-                            +   dfY*adfInvSrcGeoTransform[2];
-                double y_out =      adfInvSrcGeoTransform[3]
-                            +   (dfLonWrap+180)*adfInvSrcGeoTransform[4]
-                            +   dfY*adfInvSrcGeoTransform[5];
-
-                /* Does the raster cover, at least, a whole 360 deg range ? */
-                if( nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360) )
-                {
-                    psSrcExtent->minx = 0;
-                    psSrcExtent->maxx = nSrcXSize;
-                }
-                else
-                {
-                    psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
-                    psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
-                }
-                psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
-                psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
-          }
-      }
-  }
-
-  if( !bOutInit )
-    return MS_FALSE;
-
-  /* -------------------------------------------------------------------- */
-  /*      If we had some failures, we need to expand the region to        */
-  /*      represent our very coarse sampling grid.                        */
-  /* -------------------------------------------------------------------- */
-  if( nFailures > 0 ) {
-    int nGrowAmountX = (int)
-                       (psSrcExtent->maxx - psSrcExtent->minx)/EDGE_STEPS + 1;
-    int nGrowAmountY = (int)
-                       (psSrcExtent->maxy - psSrcExtent->miny)/EDGE_STEPS + 1;
-
-    psSrcExtent->minx = MS_MAX(psSrcExtent->minx - nGrowAmountX,0);
-    psSrcExtent->miny = MS_MAX(psSrcExtent->miny - nGrowAmountY,0);
-    psSrcExtent->maxx = MS_MIN(psSrcExtent->maxx + nGrowAmountX,nSrcXSize);
-    psSrcExtent->maxy = MS_MIN(psSrcExtent->maxy + nGrowAmountY,nSrcYSize);
-  }
-
-  return MS_TRUE;
-}
-
-/************************************************************************/
-/*                        msResampleGDALToMap()                         */
-/************************************************************************/
-
-int msResampleGDALToMap( mapObj *map, layerObj *layer, imageObj *image,
-                         rasterBufferObj *rb, GDALDatasetH hDS )
-
-{
-  int   nSrcXSize, nSrcYSize, nDstXSize, nDstYSize;
-  int   result, bSuccess;
-  double  adfSrcGeoTransform[6], adfDstGeoTransform[6];
-  double      adfInvSrcGeoTransform[6], dfNominalCellSize;
-  rectObj sSrcExtent = {0}, sOrigSrcExtent;
-  mapObj  sDummyMap;
-  imageObj   *srcImage;
-  void  *pTCBData;
-  void  *pACBData;
-  char       **papszAlteredProcessing = NULL;
-  int         nLoadImgXSize, nLoadImgYSize;
-  double      dfOversampleRatio;
-  rasterBufferObj src_rb, *psrc_rb = NULL, *mask_rb = NULL;
-  int         bAddPixelMargin = MS_TRUE;
-  int         bWrapAtLeftRight = MS_FALSE;
-
-
-  const char *resampleMode = CSLFetchNameValue( layer->processing,
-                             "RESAMPLE" );
-
-  if( resampleMode == NULL )
-    resampleMode = "NEAREST";
-  
-  if(layer->mask) {
-    int ret, maskLayerIdx;
-    layerObj *maskLayer;
-    maskLayerIdx = msGetLayerIndex(map,layer->mask);
-    if(maskLayerIdx == -1) {
-      msSetError(MS_MISCERR, "Invalid mask layer specified", "msResampleGDALToMap()");
-      return -1;
-    }
-    maskLayer = GET_LAYER(map, maskLayerIdx);
-    mask_rb = msSmallCalloc(1,sizeof(rasterBufferObj)); 
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS) {
-      free(mask_rb);
-      return -1;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      We will require source and destination to have a valid          */
-  /*      projection object.                                              */
-  /* -------------------------------------------------------------------- */
-  if( map->projection.proj == NULL
-      || layer->projection.proj == NULL ) {
-    if( layer->debug )
-      msDebug( "msResampleGDALToMap(): "
-               "Either map or layer projection is NULL, assuming compatible.\n" );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize some information.                                    */
-  /* -------------------------------------------------------------------- */
-  nDstXSize = image->width;
-  nDstYSize = image->height;
-
-  memcpy( adfDstGeoTransform, map->gt.geotransform, sizeof(double)*6 );
-
-  msGetGDALGeoTransform( hDS, map, layer, adfSrcGeoTransform );
-
-  nSrcXSize = GDALGetRasterXSize( hDS );
-  nSrcYSize = GDALGetRasterYSize( hDS );
-
-  InvGeoTransform( adfSrcGeoTransform, adfInvSrcGeoTransform );
-
-  /* -------------------------------------------------------------------- */
-  /*      We need to find the extents in the source layer projection      */
-  /*      of the output requested region.  We will accomplish this by     */
-  /*      collecting the extents of a region around the edge of the       */
-  /*      destination chunk.                                              */
-  /* -------------------------------------------------------------------- */
-  if( CSLFetchBoolean( layer->processing, "LOAD_WHOLE_IMAGE", FALSE ) )
-    bSuccess = FALSE;
-  else {
-    bSuccess =
-      msTransformMapToSource( nDstXSize, nDstYSize, adfDstGeoTransform,
-                              &(map->projection),
-                              nSrcXSize, nSrcYSize,adfInvSrcGeoTransform,
-                              &(layer->projection),
-                              &sSrcExtent, FALSE );
-      if (bSuccess) {
-    /* -------------------------------------------------------------------- */
-    /*      Repeat transformation for a rectangle interior to the output    */
-    /*      requested region.  If the latter results in a more extreme y    */
-    /*      extent, then extend extents in source layer projection to       */
-    /*      southern/northing bounds and entire x extent.                   */
-    /* -------------------------------------------------------------------- */
-      memcpy( &sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent) );
-      adfDstGeoTransform[0] = adfDstGeoTransform[0] + adfDstGeoTransform[1];
-      adfDstGeoTransform[3] = adfDstGeoTransform[3] + adfDstGeoTransform[5];
-      bSuccess =
-          msTransformMapToSource( nDstXSize-2, nDstYSize-2, adfDstGeoTransform,
-                                  &(map->projection),
-                                  nSrcXSize, nSrcYSize,adfInvSrcGeoTransform,
-                                  &(layer->projection),
-                                  &sSrcExtent, FALSE );
-      /* Reset this array to its original value! */
-      memcpy( adfDstGeoTransform, map->gt.geotransform, sizeof(double)*6 );
-
-      if (bSuccess) {
-          if (sSrcExtent.maxy > sOrigSrcExtent.maxy || sSrcExtent.miny < sOrigSrcExtent.miny) {
-              msDebug( "msTransformMapToSource(): extending bounds.\n");
-              sOrigSrcExtent.minx = 0;
-              sOrigSrcExtent.maxx = nSrcXSize;
-              if (sSrcExtent.maxy > sOrigSrcExtent.maxy)
-                  sOrigSrcExtent.maxy = nSrcYSize;
-              if (sSrcExtent.miny < sOrigSrcExtent.miny)
-                  sOrigSrcExtent.miny = 0;
-          }
-      }
-      memcpy( &sSrcExtent, &sOrigSrcExtent, sizeof(sOrigSrcExtent) );
-      bSuccess = TRUE;
-    }
-  }
-  /* -------------------------------------------------------------------- */
-  /*      If the transformation failed, it is likely that we have such    */
-  /*      broad extents that the projection transformation failed at      */
-  /*      points around the extents.  If so, we will assume we need       */
-  /*      the whole raster.  This and later assumptions are likely to     */
-  /*      result in the raster being loaded at a higher resolution        */
-  /*      than really needed but should give decent results.              */
-  /* -------------------------------------------------------------------- */
-  if( !bSuccess ) {
-    if( layer->debug ) {
-      if( CSLFetchBoolean( layer->processing, "LOAD_WHOLE_IMAGE", FALSE ))
-        msDebug( "msResampleGDALToMap(): "
-                 "LOAD_WHOLE_IMAGE set, loading whole image.\n" );
-      else
-        msDebug( "msTransformMapToSource(): "
-                 "pj_transform() failed.  Out of bounds?  Loading whole image.\n" );
-    }
-
-    sSrcExtent.minx = 0;
-    sSrcExtent.maxx = nSrcXSize;
-    sSrcExtent.miny = 0;
-    sSrcExtent.maxy = nSrcYSize;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If requesting at the raster resolution, on pixel boundaries,    */
-  /*      and no reprojection is  involved, we don't need any resampling. */
-  /*      And if they match an integral subsampling factor, no need to    */
-  /*      add pixel margin.                                               */
-  /*      This optimization helps a lot when operating with mode=tile     */
-  /*      and that the underlying raster is tiled and share the same      */
-  /*      tiling scheme as the queried tile mode.                         */
-  /* -------------------------------------------------------------------- */
-#define IS_ALMOST_INTEGER(x, eps)        (fabs((x)-(int)((x)+0.5)) < (eps))
-
-  if( adfSrcGeoTransform[1] > 0.0 && adfSrcGeoTransform[2] == 0.0 &&
-      adfSrcGeoTransform[4] == 0.0 && adfSrcGeoTransform[5] < 0.0 &&
-      IS_ALMOST_INTEGER(sSrcExtent.minx, 0.1) &&
-      IS_ALMOST_INTEGER(sSrcExtent.miny, 0.1) &&
-      IS_ALMOST_INTEGER(sSrcExtent.maxx, 0.1) &&
-      IS_ALMOST_INTEGER(sSrcExtent.maxy, 0.1) &&
-      !msProjectionsDiffer( &(map->projection), &(layer->projection)) ) 
-  {
-      double dfXFactor, dfYFactor;
-
-      sSrcExtent.minx = (int)(sSrcExtent.minx + 0.5);
-      sSrcExtent.miny = (int)(sSrcExtent.miny + 0.5);
-      sSrcExtent.maxx = (int)(sSrcExtent.maxx + 0.5);
-      sSrcExtent.maxy = (int)(sSrcExtent.maxy + 0.5);
-      
-      if( (int)(sSrcExtent.maxx - sSrcExtent.minx + 0.5) == nDstXSize &&
-          (int)(sSrcExtent.maxy - sSrcExtent.miny + 0.5) == nDstYSize )
-      {
-            if( layer->debug )
-                msDebug( "msResampleGDALToMap(): Request matching raster resolution and pixel boundaries. "
-                         "No need to do resampling/reprojection.\n" );
-            msFree(mask_rb);
-            return msDrawRasterLayerGDAL( map, layer, image, rb, hDS );
-      }
-
-      dfXFactor = (sSrcExtent.maxx - sSrcExtent.minx) / nDstXSize;
-      dfYFactor = (sSrcExtent.maxy - sSrcExtent.miny) / nDstYSize;
-      if( IS_ALMOST_INTEGER(dfXFactor, 1e-5) &&
-          IS_ALMOST_INTEGER(dfYFactor, 1e-5) &&
-          IS_ALMOST_INTEGER(sSrcExtent.minx/dfXFactor, 0.1) &&
-          IS_ALMOST_INTEGER(sSrcExtent.miny/dfXFactor, 0.1) &&
-          IS_ALMOST_INTEGER(sSrcExtent.maxx/dfYFactor, 0.1) &&
-          IS_ALMOST_INTEGER(sSrcExtent.maxy/dfYFactor, 0.1) )
-      {
-          bAddPixelMargin = MS_FALSE;
-          if( layer->debug )
-            msDebug( "msResampleGDALToMap(): Request matching raster resolution "
-                     "and pixel boundaries matching an integral subsampling factor\n" );
-      }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Project desired extents out by 2 pixels, and then strip to      */
-  /*      available data.                                                 */
-  /* -------------------------------------------------------------------- */
-  memcpy( &sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent) );
-
-  if( bAddPixelMargin )
-  {
-    sSrcExtent.minx = floor(sSrcExtent.minx-1.0);
-    sSrcExtent.maxx = ceil (sSrcExtent.maxx+1.0);
-    sSrcExtent.miny = floor(sSrcExtent.miny-1.0);
-    sSrcExtent.maxy = ceil (sSrcExtent.maxy+1.0);
-  }
-
-  sSrcExtent.minx = MS_MAX(0,sSrcExtent.minx);
-  sSrcExtent.maxx = MS_MIN(sSrcExtent.maxx, nSrcXSize );
-  sSrcExtent.miny = MS_MAX(sSrcExtent.miny, 0 );
-  sSrcExtent.maxy = MS_MIN(sSrcExtent.maxy, nSrcYSize );
-
-  if( sSrcExtent.maxx <= sSrcExtent.minx
-      || sSrcExtent.maxy <= sSrcExtent.miny ) {
-    if( layer->debug )
-      msDebug( "msResampleGDALToMap(): no overlap ... no result.\n" );
-    msFree(mask_rb);
-    return 0;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Determine desired oversampling ratio.  Default to 2.0 if not    */
-  /*      otherwise set.                                                  */
-  /* -------------------------------------------------------------------- */
-  dfOversampleRatio = 2.0;
-
-  if( CSLFetchNameValue( layer->processing, "OVERSAMPLE_RATIO" ) != NULL ) {
-    dfOversampleRatio =
-      atof(CSLFetchNameValue( layer->processing, "OVERSAMPLE_RATIO" ));
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Decide on a resolution to read from the source image at.  We    */
-  /*      will operate from full resolution data, if we are requesting    */
-  /*      at near to full resolution.  Otherwise we will read the data    */
-  /*      at twice the resolution of the eventual map.                    */
-  /* -------------------------------------------------------------------- */
-  dfNominalCellSize =
-    sqrt(adfSrcGeoTransform[1] * adfSrcGeoTransform[1]
-         + adfSrcGeoTransform[2] * adfSrcGeoTransform[2]);
-
-  /* Check first that the requested extent is not well beyond than the source */
-  /* raster. This might be the case for example if asking to visualize */
-  /* -180,-89,180,90 in EPSG:4326 from a raster in Arctic Polar Stereographic */
-  /* But restrict that to rasters of modest size, otherwise we may end up */
-  /* requesting very large dimensions in other legit reprojection cases */
-  /* See https://github.com/mapserver/mapserver/issues/5402 */
-  if( !(sOrigSrcExtent.minx <= -4 * nSrcXSize  && sOrigSrcExtent.miny <= -4 * nSrcYSize &&
-        sOrigSrcExtent.maxx >= 5 * nSrcXSize && sOrigSrcExtent.maxy >= 5 * nSrcYSize &&
-        nSrcXSize < 4000 && nSrcYSize < 4000)
-      && (sOrigSrcExtent.maxx - sOrigSrcExtent.minx) > dfOversampleRatio * nDstXSize
-      && !CSLFetchBoolean( layer->processing, "LOAD_FULL_RES_IMAGE", FALSE ))
-    sDummyMap.cellsize =
-      (dfNominalCellSize * (sOrigSrcExtent.maxx - sOrigSrcExtent.minx))
-      / (dfOversampleRatio * nDstXSize);
-  else
-    sDummyMap.cellsize = dfNominalCellSize;
-
-  nLoadImgXSize = MS_MAX(1, (int) (sSrcExtent.maxx - sSrcExtent.minx)
-                      * (dfNominalCellSize / sDummyMap.cellsize));
-  nLoadImgYSize = MS_MAX(1, (int) (sSrcExtent.maxy - sSrcExtent.miny)
-                      * (dfNominalCellSize / sDummyMap.cellsize));
-
-  /*
-  ** Because the previous calculation involved some round off, we need
-  ** to fixup the cellsize to ensure the map region represents the whole
-  ** RAW_WINDOW (at least in X).  Re: bug 1715.
-  */
-  sDummyMap.cellsize =
-    ((sSrcExtent.maxx - sSrcExtent.minx) * dfNominalCellSize)
-    / nLoadImgXSize;
-
-  if( layer->debug )
-    msDebug( "msResampleGDALToMap in effect: cellsize = %f\n",
-             sDummyMap.cellsize );
-
-  adfSrcGeoTransform[0] +=
-    + adfSrcGeoTransform[1] * sSrcExtent.minx
-    + adfSrcGeoTransform[2] * sSrcExtent.miny;
-  adfSrcGeoTransform[1] *= (sDummyMap.cellsize / dfNominalCellSize);
-  adfSrcGeoTransform[2] *= (sDummyMap.cellsize / dfNominalCellSize);
-
-  adfSrcGeoTransform[3] +=
-    + adfSrcGeoTransform[4] * sSrcExtent.minx
-    + adfSrcGeoTransform[5] * sSrcExtent.miny;
-  adfSrcGeoTransform[4] *= (sDummyMap.cellsize / dfNominalCellSize);
-  adfSrcGeoTransform[5] *= (sDummyMap.cellsize / dfNominalCellSize);
-
-  /* In the non-rotated case, make sure that the geotransform exactly */
-  /* matches the sSrcExtent, even if that generates non-square pixels (#1715) */
-  /* The rotated case should ideally be dealt with, but not for now... */
-  if( adfSrcGeoTransform[2] == 0 && adfSrcGeoTransform[4] == 0 &&
-      adfSrcGeoTransform[5] < 0 &&
-      /* But do that only if the pixels were square before, otherwise */
-      /* this is going to mess with source rasters whose pixels aren't at */
-      /* all square (#5445) */
-      fabs(fabs(adfSrcGeoTransform[1]) - fabs(adfSrcGeoTransform[5])) <
-                                        0.01 * fabs(adfSrcGeoTransform[1]) )
-  {
-      adfSrcGeoTransform[1] = (sSrcExtent.maxx - sSrcExtent.minx) *
-                                            dfNominalCellSize / nLoadImgXSize;
-      adfSrcGeoTransform[5] = -(sSrcExtent.maxy - sSrcExtent.miny) *
-                                            dfNominalCellSize / nLoadImgYSize;
-  }
-
-  papszAlteredProcessing = CSLDuplicate( layer->processing );
-  papszAlteredProcessing =
-    CSLSetNameValue( papszAlteredProcessing, "RAW_WINDOW",
-                     CPLSPrintf( "%d %d %d %d",
-                                 (int) sSrcExtent.minx,
-                                 (int) sSrcExtent.miny,
-                                 (int) (sSrcExtent.maxx-sSrcExtent.minx),
-                                 (int) (sSrcExtent.maxy-sSrcExtent.miny)));
-
-  /* -------------------------------------------------------------------- */
-  /*      We clone this without referencing it knowing that the           */
-  /*      srcImage will take a reference on it.  The sDummyMap is         */
-  /*      destroyed off the stack, so the missing map reference is        */
-  /*      never a problem.  The image's dereference of the                */
-  /*      outputformat during the msFreeImage() calls will result in      */
-  /*      the output format being cleaned up.                             */
-  /*                                                                      */
-  /*      We make a copy so we can easily modify the outputformat used    */
-  /*      for the temporary image to include transparentency support.     */
-  /* -------------------------------------------------------------------- */
-  sDummyMap.outputformat = msCloneOutputFormat( image->format );
-  sDummyMap.width = nLoadImgXSize;
-  sDummyMap.height = nLoadImgYSize;
-  sDummyMap.mappath = map->mappath;
-  sDummyMap.shapepath = map->shapepath;
-
-  /* -------------------------------------------------------------------- */
-  /*      If we are working in 256 color GD mode, allocate 0 as the       */
-  /*      transparent color on the temporary image so it will be          */
-  /*      initialized to see-through.  We pick an arbitrary rgb tuple     */
-  /*      as our transparent color, but ensure it is initalized in the    */
-  /*      map so that normal transparent avoidance will apply.            */
-  /* -------------------------------------------------------------------- */
-  if( MS_RENDERER_PLUGIN(sDummyMap.outputformat) ) {
-    assert(rb);
-    msInitializeRendererVTable(sDummyMap.outputformat);
-    assert( sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGB
-            || sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGBA );
-
-    sDummyMap.outputformat->transparent = MS_TRUE;
-    sDummyMap.outputformat->imagemode = MS_IMAGEMODE_RGBA;
-    MS_INIT_COLOR(sDummyMap.imagecolor,-1,-1,-1,255);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup a dummy map object we can use to read from the source     */
-  /*      raster, with the newly established extents, and resolution.     */
-  /* -------------------------------------------------------------------- */
-  srcImage = msImageCreate( nLoadImgXSize, nLoadImgYSize,
-                            sDummyMap.outputformat, NULL, NULL,
-                            map->resolution, map->defresolution, &(sDummyMap.imagecolor));
-
-  if (srcImage == NULL) {
-    msFree(mask_rb);
-    return -1; /* msSetError() should have been called already */
-  }
-
-  if( MS_RENDERER_PLUGIN( srcImage->format ) ) {
-    psrc_rb = &src_rb;
-    memset( psrc_rb, 0, sizeof(rasterBufferObj) );
-    if( srcImage->format->vtable->supports_pixel_buffer ) {
-      if(MS_UNLIKELY(MS_FAILURE == srcImage->format->vtable->getRasterBufferHandle( srcImage, psrc_rb ))) {
-        msFree(mask_rb);
-        return -1;
-      }
-    } else {
-      if(MS_UNLIKELY(MS_FAILURE == srcImage->format->vtable->initializeRasterBuffer(psrc_rb,nLoadImgXSize, nLoadImgYSize,MS_IMAGEMODE_RGBA))) {
-        msFree(mask_rb);
-        return -1;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Draw into the temporary image.  Temporarily replace the         */
-  /*      layer processing directive so that we use our RAW_WINDOW.       */
-  /* -------------------------------------------------------------------- */
-  {
-    char **papszSavedProcessing = layer->processing;
-    char* origMask = layer->mask;
-    layer->mask = NULL;
-    layer->processing = papszAlteredProcessing;
-
-    result = msDrawRasterLayerGDAL( &sDummyMap, layer, srcImage,
-                                    psrc_rb, hDS );
-
-    layer->processing = papszSavedProcessing;
-    layer->mask = origMask;
-    CSLDestroy( papszAlteredProcessing );
-
-    if( result ) {
-      if( MS_RENDERER_PLUGIN( srcImage->format ) && !srcImage->format->vtable->supports_pixel_buffer)
-        msFreeRasterBuffer(psrc_rb);
-
-      msFreeImage( srcImage );
-      msFree(mask_rb);
-
-      return result;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup transformations between our source image, and the         */
-  /*      target map image.                                               */
-  /* -------------------------------------------------------------------- */
-  pTCBData = msInitProjTransformer( &(layer->projection),
-                                    adfSrcGeoTransform,
-                                    &(map->projection),
-                                    adfDstGeoTransform );
-
-  if( pTCBData == NULL ) {
-    if( layer->debug )
-      msDebug( "msInitProjTransformer() returned NULL.\n" );
-    if( MS_RENDERER_PLUGIN( srcImage->format ) && !srcImage->format->vtable->supports_pixel_buffer)
-      msFreeRasterBuffer(psrc_rb);
-    msFreeImage( srcImage );
-    msFree(mask_rb);
-    return MS_PROJERR;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      It is cheaper to use linear approximations as long as our       */
-  /*      error is modest (less than 0.333 pixels).                       */
-  /* -------------------------------------------------------------------- */
-  pACBData = msInitApproxTransformer( msProjTransformer, pTCBData, 0.333 );
-
-  if( msProjIsGeographicCRS(&(layer->projection)) )
-  {
-      /* Does the raster cover a whole 360 deg range ? */
-      if( nSrcXSize == (int)(adfInvSrcGeoTransform[1] * 360 + 0.5) )
-          bWrapAtLeftRight = MS_TRUE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Perform the resampling.                                         */
-  /* -------------------------------------------------------------------- */
-  if( EQUAL(resampleMode,"AVERAGE") )
-    result =
-      msAverageRasterResampler( srcImage, psrc_rb, image, rb,
-                                msApproxTransformer, pACBData,
-                                layer->debug, mask_rb );
-  else if( EQUAL(resampleMode,"BILINEAR") )
-    result =
-      msBilinearRasterResampler( srcImage, psrc_rb, image, rb,
-                                 msApproxTransformer, pACBData,
-                                 layer->debug, mask_rb, bWrapAtLeftRight );
-  else
-    result =
-      msNearestRasterResampler( srcImage, psrc_rb, image, rb,
-                                msApproxTransformer, pACBData,
-                                layer->debug, mask_rb, bWrapAtLeftRight );
-
-  /* -------------------------------------------------------------------- */
-  /*      cleanup                                                         */
-  /* -------------------------------------------------------------------- */
-  msFree(mask_rb);
-  if( MS_RENDERER_PLUGIN( srcImage->format ) && !srcImage->format->vtable->supports_pixel_buffer)
-    msFreeRasterBuffer(psrc_rb);
-  msFreeImage( srcImage );
-
-  msFreeProjTransformer( pTCBData );
-  msFreeApproxTransformer( pACBData );
-
-  return result;
-}
diff -pruN 8.0.1-5/mapresample.h 8.2.0~beta1-1~exp1/mapresample.h
--- 8.0.1-5/mapresample.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapresample.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,54 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  CFS OGC MapServer
- * Purpose:  Definitions related to raster resampling support.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 2001, Frank Warmerdam, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef RESAMPLE_H
-#define RESAMPLE_H
-
-#include "mapserver.h"
-#include "mapproject.h"
-
-#include <gdal.h>
-#include <cpl_string.h>
-
-typedef int (*SimpleTransformer)( void *pCBData, int nPoints,
-                                  double *x, double *y, int *panSuccess );
-
-void *msInitProjTransformer( projectionObj *psSrc,
-                             double *padfSrcGeoTransform,
-                             projectionObj *psDst,
-                             double *padfDstGeoTransform );
-void msFreeProjTransformer( void * );
-int msProjTransformer( void *pCBData, int nPoints,
-                       double *x, double *y, int *panSuccess );
-
-int msResampleGDALToMap( mapObj *map, layerObj *layer,
-                         imageObj *image, rasterBufferObj *rb,
-                         GDALDatasetH hDS );
-
-#endif /* ndef RESAMPLE_H */
diff -pruN 8.0.1-5/mapscale.c 8.2.0~beta1-1~exp1/mapscale.c
--- 8.0.1-5/mapscale.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscale.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,603 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Scale object rendering.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-#define VMARGIN 3 /* buffer around the scalebar */
-#define HMARGIN 3
-#define VSPACING .8 /* spacing (% of font height) between scalebar and text */
-#define VSLOP 5 /* makes things fit a bit better vertically */
-
-/*
-** Match this with with unit enumerations is mapserver.h
-*/
-static char *unitText[9]= {"in", "ft", "mi", "m", "km", "dd", "??", "??", "NM"}; /* MS_PIXEL and MS_PERCENTAGE not used */
-double inchesPerUnit[9]= {1, 12, 63360.0, 39.3701, 39370.1, 4374754, 1, 1, 72913.3858 };
-
-static double roundInterval(double d)
-{
-  if(d<.001)
-    return(MS_NINT(d*10000)/10000.0);
-  if(d<.01)
-    return(MS_NINT(d*1000)/1000.0);
-  if(d<.1)
-    return(MS_NINT(d*100)/100.0);
-  if(d<1)
-    return(MS_NINT(d*10)/10.0);
-  if(d<100)
-    return(MS_NINT(d));
-  if(d<1000)
-    return(MS_NINT(d/10) * 10);
-  if(d<10000)
-    return(MS_NINT(d/100) * 100);
-  if(d<100000)
-    return(MS_NINT(d/1000) * 1000);
-  if(d<1000000)
-    return(MS_NINT(d/10000) * 10000);
-  if(d<10000000)
-    return(MS_NINT(d/100000) * 100000);
-  if(d<100000000)
-    return(MS_NINT(d/1000000) * 1000000);
-
-  return(-1);
-}
-
-/*
-** Calculate the approximate scale based on a few parameters. Note that this assumes the scale is
-** the same in the x direction as in the y direction, so run msAdjustExtent(...) first.
-*/
-int msCalculateScale(rectObj extent, int units, int width, int height, double resolution, double *scale)
-{
-  double md, gd, center_y;
-
-  /* if((extent.maxx == extent.minx) || (extent.maxy == extent.miny))   */
-  if(!MS_VALID_EXTENT(extent)) {
-    msSetError(MS_MISCERR, "Invalid image extent, minx=%lf, miny=%lf, maxx=%lf, maxy=%lf.", "msCalculateScale()", extent.minx, extent.miny, extent.maxx, extent.maxy);
-    return(MS_FAILURE);
-  }
-
-  if((width <= 0) || (height <= 0)) {
-    msSetError(MS_MISCERR, "Invalid image width or height.", "msCalculateScale()");
-    return(MS_FAILURE);
-  }
-
-  switch (units) {
-    case(MS_DD):
-    case(MS_METERS):
-    case(MS_KILOMETERS):
-    case(MS_MILES):
-    case(MS_NAUTICALMILES):
-    case(MS_INCHES):
-    case(MS_FEET):
-      center_y = (extent.miny+extent.maxy)/2.0;
-      md = (width-1)/(resolution*msInchesPerUnit(units, center_y)); /* remember, we use a pixel-center to pixel-center extent, hence the width-1 */
-      gd = extent.maxx - extent.minx;
-      *scale = gd/md;
-      break;
-    default:
-      *scale = -1; /* this is not an error */
-      break;
-  }
-
-  return(MS_SUCCESS);
-}
-
-double msInchesPerUnit(int units, double center_lat)
-{
-  (void)center_lat;
-  double lat_adj = 1.0, ipu = 1.0;
-
-  switch (units) {
-    case(MS_METERS):
-    case(MS_KILOMETERS):
-    case(MS_MILES):
-    case(MS_NAUTICALMILES):
-    case(MS_INCHES):
-    case(MS_FEET):
-      ipu = inchesPerUnit[units];
-      break;
-    case(MS_DD):
-      /* With geographical (DD) coordinates, we adjust the inchesPerUnit
-       * based on the latitude of the center of the view. For this we assume
-       * we have a perfect sphere and just use cos(lat) in our calculation.
-       */
-#ifdef ENABLE_VARIABLE_INCHES_PER_DEGREE
-      if (center_lat != 0.0) {
-        double cos_lat;
-        cos_lat = cos(MS_PI*center_lat/180.0);
-        lat_adj = sqrt(1+cos_lat*cos_lat)/sqrt(2.0);
-      }
-#endif
-      ipu = inchesPerUnit[units]*lat_adj;
-      break;
-    default:
-      break;
-  }
-
-  return ipu;
-}
-
-
-#define X_STEP_SIZE 5
-
-imageObj *msDrawScalebar(mapObj *map)
-{
-  int status;
-  char label[32];
-  double i, msx;
-  int j;
-  int isx, sx, sy, ox, oy, state, dsx;
-  pointObj p;
-  rectObj r;
-  imageObj      *image = NULL;
-  double fontWidth, fontHeight;
-  outputFormatObj *format = NULL;
-  strokeStyleObj strokeStyle = {0};
-  shapeObj shape;
-  lineObj line;
-  pointObj points[5];
-  textSymbolObj ts;
-  rendererVTableObj *renderer;
-
-  strokeStyle.patternlength=0;
-  initTextSymbol(&ts);
-
-  if((int)map->units == -1) {
-    msSetError(MS_MISCERR, "Map units not set.", "msDrawScalebar()");
-    return(NULL);
-  }
-
-  renderer = MS_MAP_RENDERER(map);
-  if(!renderer || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
-    msSetError(MS_MISCERR, "Outputformat not supported for scalebar", "msDrawScalebar()");
-    return(NULL);
-  }
-  
-  msPopulateTextSymbolForLabelAndString(&ts,&map->scalebar.label,msStrdup("0123456789"),1.0,map->resolution/map->defresolution, 0);
-
-  /*
-   *  A string containing the ten decimal digits is rendered to compute an average cell size
-   *  for each number, which is used later to place labels on the scalebar.
-   */
-  
-
-  if(msGetTextSymbolSize(map,&ts,&r) != MS_SUCCESS) {
-    return NULL;
-  }
-  fontWidth = (r.maxx-r.minx)/10.0;
-  fontHeight = r.maxy -r.miny;
-
-  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-  status = msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
-  if(status != MS_SUCCESS) {
-    return(NULL);
-  }
-  dsx = map->scalebar.width - 2*HMARGIN;
-  do {
-    msx = (map->cellsize * dsx)/(msInchesPerUnit(map->scalebar.units,0)/msInchesPerUnit(map->units,0));
-    i = roundInterval(msx/map->scalebar.intervals);
-    snprintf(label, sizeof(label), "%g", map->scalebar.intervals*i); /* last label */
-    isx = MS_NINT((i/(msInchesPerUnit(map->units,0)/msInchesPerUnit(map->scalebar.units,0)))/map->cellsize);
-    sx = (map->scalebar.intervals*isx) + MS_NINT((1.5 + strlen(label)/2.0 + strlen(unitText[map->scalebar.units]))*fontWidth);
-
-    if(sx <= (map->scalebar.width - 2*HMARGIN)) break; /* it will fit */
-
-    dsx -= X_STEP_SIZE; /* change the desired size in hopes that it will fit in user supplied width */
-  } while(1);
-
-  sy = (2*VMARGIN) + MS_NINT(VSPACING*fontHeight) + fontHeight + map->scalebar.height - VSLOP;
-
-  /*Ensure we have an image format representing the options for the scalebar.*/
-  msApplyOutputFormat( &format, map->outputformat, map->scalebar.transparent);
-
-  if(map->scalebar.transparent == MS_OFF) {
-    if(!MS_VALID_COLOR(map->scalebar.imagecolor))
-      MS_INIT_COLOR(map->scalebar.imagecolor,255,255,255,255);
-  }
-  image = msImageCreate(map->scalebar.width, sy, format,
-                        map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &map->scalebar.imagecolor);
-
-  /* did we succeed in creating the image? */
-  if(!image) {
-    msSetError(MS_MISCERR, "Unable to initialize image.", "msDrawScalebar()");
-    return NULL;
-  }
-  image->map = map;
-
-  /* drop this reference to output format */
-  msApplyOutputFormat( &format, NULL, MS_NOOVERRIDE);
-
-  switch(map->scalebar.align) {
-    case(MS_ALIGN_LEFT):
-      ox = HMARGIN;
-      break;
-    case(MS_ALIGN_RIGHT):
-      ox = MS_NINT((map->scalebar.width - sx) + fontWidth);
-      break;
-    default:
-      ox = MS_NINT((map->scalebar.width - sx)/2.0 + fontWidth/2.0); /* center the computed scalebar */
-  }
-  oy = VMARGIN;
-
-  switch(map->scalebar.style) {
-    case(0): {
-
-      line.numpoints = 5;
-      line.point = points;
-      shape.line = &line;
-      shape.numlines = 1;
-      if(MS_VALID_COLOR(map->scalebar.color)) {
-        INIT_STROKE_STYLE(strokeStyle);
-        strokeStyle.color = &map->scalebar.outlinecolor;
-        strokeStyle.color->alpha = 255;
-        strokeStyle.width = 1;
-      }
-      map->scalebar.backgroundcolor.alpha = 255;
-      map->scalebar.color.alpha = 255;
-      state = 1; /* 1 means filled */
-      for(j=0; j<map->scalebar.intervals; j++) {
-        points[0].x = points[4].x = points[3].x = ox + j*isx + 0.5;
-        points[0].y = points[4].y = points[1].y = oy + 0.5;
-        points[1].x = points[2].x = ox + (j+1)*isx + 0.5;
-        points[2].y = points[3].y = oy + map->scalebar.height + 0.5;
-        if(state == 1 && MS_VALID_COLOR(map->scalebar.color))
-          status = renderer->renderPolygon(image,&shape,&map->scalebar.color);
-        else if(MS_VALID_COLOR(map->scalebar.backgroundcolor))
-          status = renderer->renderPolygon(image,&shape,&map->scalebar.backgroundcolor);
-
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
-          goto scale_cleanup;
-        }
-
-        if(strokeStyle.color) {
-          status = renderer->renderLine(image,&shape,&strokeStyle);
-
-          if(MS_UNLIKELY(status == MS_FAILURE)) {
-            goto scale_cleanup;
-          }
-        }
-
-        sprintf(label, "%g", j*i);
-        map->scalebar.label.position = MS_CC;
-        p.x = ox + j*isx; /* + MS_NINT(fontPtr->w/2); */
-        p.y = oy + map->scalebar.height + MS_NINT(VSPACING*fontHeight);
-        status = msDrawLabel(map,image,p,msStrdup(label),&map->scalebar.label,1.0);
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
-          goto scale_cleanup;
-        }
-        state = -state;
-      }
-      sprintf(label, "%g", j*i);
-      ox = ox + j*isx - MS_NINT((strlen(label)*fontWidth)/2.0);
-      sprintf(label, "%g %s", j*i, unitText[map->scalebar.units]);
-      map->scalebar.label.position = MS_CR;
-      p.x = ox; /* + MS_NINT(fontPtr->w/2); */
-      p.y = oy + map->scalebar.height + MS_NINT(VSPACING*fontHeight);
-      status = msDrawLabel(map,image,p,msStrdup(label),&map->scalebar.label,1.0);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
-        goto scale_cleanup;
-      }
-      break;
-    }
-    case(1): {
-      line.numpoints = 2;
-      line.point = points;
-      shape.line = &line;
-      shape.numlines = 1;
-      if(MS_VALID_COLOR(map->scalebar.color)) {
-        strokeStyle.width = 1;
-        strokeStyle.color = &map->scalebar.color;
-      }
-
-      points[0].y = points[1].y = oy;
-      points[0].x = ox;
-      points[1].x = ox + isx*map->scalebar.intervals;
-      status = renderer->renderLine(image,&shape,&strokeStyle);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
-        goto scale_cleanup;
-      }
-
-      points[0].y = oy;
-      points[1].y = oy + map->scalebar.height;
-      p.y = oy + map->scalebar.height + MS_NINT(VSPACING*fontHeight);
-      for(j=0; j<=map->scalebar.intervals; j++) {
-        points[0].x = points[1].x = ox + j*isx;
-        status = renderer->renderLine(image,&shape,&strokeStyle);
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
-          goto scale_cleanup;
-        }
-
-        sprintf(label, "%g", j*i);
-        if(j!=map->scalebar.intervals) {
-          map->scalebar.label.position = MS_CC;
-          p.x = ox + j*isx; /* + MS_NINT(fontPtr->w/2); */
-        } else {
-          sprintf(label, "%g %s", j*i, unitText[map->scalebar.units]);
-          map->scalebar.label.position = MS_CR;
-          p.x = ox + j*isx - MS_NINT((strlen(label)*fontWidth)/2.0);
-        }
-        status = msDrawLabel(map,image,p,msStrdup(label),&map->scalebar.label,1.0);
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
-          goto scale_cleanup;
-        }
-      }
-      break;
-    }
-    default:
-      msSetError(MS_MISCERR, "Unsupported scalebar style.", "msDrawScalebar()");
-      return(NULL);
-  }
-
-scale_cleanup:
-  freeTextSymbol(&ts);
-  if(MS_UNLIKELY(status == MS_FAILURE)) {
-    msFreeImage(image);
-    return NULL;
-  }
-  return(image);
-
-}
-
-int msEmbedScalebar(mapObj *map, imageObj *img)
-{
-  int l,index,s,status = MS_SUCCESS;
-  pointObj point;
-  imageObj *image = NULL;
-  rendererVTableObj *renderer;
-  symbolObj *embededSymbol;
-  char* imageType = NULL;
-
-  index = msGetSymbolIndex(&(map->symbolset), "scalebar", MS_FALSE);
-  if(index != -1)
-    msRemoveSymbol(&(map->symbolset), index); /* remove cached symbol in case the function is called multiple
-                      times with different zoom levels */
-
-  if((embededSymbol=msGrowSymbolSet(&map->symbolset)) == NULL)
-    return MS_FAILURE;
-
-  s = map->symbolset.numsymbols;
-  map->symbolset.numsymbols++;
-
-  if(!MS_RENDERER_PLUGIN(map->outputformat) || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
-    imageType = msStrdup(map->imagetype); /* save format */
-    if MS_DRIVER_CAIRO(map->outputformat)
-      map->outputformat = msSelectOutputFormat( map, "cairopng" );
-    else
-      map->outputformat = msSelectOutputFormat( map, "png" );
-    
-    msInitializeRendererVTable(map->outputformat);
-  }
-  renderer = MS_MAP_RENDERER(map);
-
-  image = msDrawScalebar(map);
-
-  if (imageType) {
-    map->outputformat = msSelectOutputFormat( map, imageType ); /* restore format */
-    msFree(imageType);
-  }
-
-  if(!image) {
-    return MS_FAILURE;
-  }
-  embededSymbol->pixmap_buffer = calloc(1,sizeof(rasterBufferObj));
-  MS_CHECK_ALLOC(embededSymbol->pixmap_buffer, sizeof(rasterBufferObj), MS_FAILURE);
-
-  if(MS_SUCCESS != renderer->getRasterBufferCopy(image,embededSymbol->pixmap_buffer)) {
-    return MS_FAILURE;
-  }
-
-  embededSymbol->type = MS_SYMBOL_PIXMAP; /* intialize a few things */
-  embededSymbol->name = msStrdup("scalebar");
-  embededSymbol->sizex = embededSymbol->pixmap_buffer->width;
-  embededSymbol->sizey = embededSymbol->pixmap_buffer->height;
-  if(map->scalebar.transparent) {
-    embededSymbol->transparent = MS_TRUE;
-    embededSymbol->transparentcolor = 0;
-  }
-
-  switch(map->scalebar.position) {
-    case(MS_LL):
-      point.x = MS_NINT(embededSymbol->pixmap_buffer->width/2.0) + map->scalebar.offsetx;
-      point.y = map->height - MS_NINT(embededSymbol->pixmap_buffer->height/2.0) - map->scalebar.offsety;
-      break;
-    case(MS_LR):
-      point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width/2.0) - map->scalebar.offsetx;
-      point.y = map->height - MS_NINT(embededSymbol->pixmap_buffer->height/2.0) - map->scalebar.offsety;
-      break;
-    case(MS_LC):
-      point.x = MS_NINT(map->width/2.0) + map->scalebar.offsetx;
-      point.y = map->height - MS_NINT(embededSymbol->pixmap_buffer->height/2.0) - map->scalebar.offsety;
-      break;
-    case(MS_UR):
-      point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width/2.0) - map->scalebar.offsetx;
-      point.y = MS_NINT(embededSymbol->pixmap_buffer->height/2.0) + map->scalebar.offsety;
-      break;
-    case(MS_UL):
-      point.x = MS_NINT(embededSymbol->pixmap_buffer->width/2.0) + map->scalebar.offsetx;
-      point.y = MS_NINT(embededSymbol->pixmap_buffer->height/2.0) + map->scalebar.offsety;
-      break;
-    case(MS_UC):
-      point.x = MS_NINT(map->width/2.0) + map->scalebar.offsetx;
-      point.y = MS_NINT(embededSymbol->pixmap_buffer->height/2.0) + map->scalebar.offsety;
-      break;
-  }
-
-  l = msGetLayerIndex(map, "__embed__scalebar");
-  if(l == -1) {
-    if (msGrowMapLayers(map) == NULL)
-      return(-1);
-    l = map->numlayers;
-    map->numlayers++;
-    if(initLayer((GET_LAYER(map, l)), map) == -1) return(-1);
-    GET_LAYER(map, l)->name = msStrdup("__embed__scalebar");
-    GET_LAYER(map, l)->type = MS_LAYER_POINT;
-
-    if (msGrowLayerClasses( GET_LAYER(map, l) ) == NULL)
-      return(-1);
-
-    if(initClass(GET_LAYER(map, l)->class[0]) == -1) return(-1);
-    GET_LAYER(map, l)->numclasses = 1; /* so we make sure to free it */
-
-    /* update the layer order list with the layer's index. */
-    map->layerorder[l] = l;
-  }
-
-  GET_LAYER(map, l)->status = MS_ON;
-  if(map->scalebar.postlabelcache) { /* add it directly to the image */
-    if(msMaybeAllocateClassStyle(GET_LAYER(map, l)->class[0], 0)==MS_FAILURE) return MS_FAILURE;
-    GET_LAYER(map, l)->class[0]->styles[0]->symbol = s;
-    status = msDrawMarkerSymbol(map, img, &point, GET_LAYER(map, l)->class[0]->styles[0], 1.0);
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
-      goto embed_cleanup;
-    }
-  } else {
-    if(!GET_LAYER(map, l)->class[0]->labels) {
-      if(msGrowClassLabels(GET_LAYER(map, l)->class[0]) == NULL) return MS_FAILURE;
-      initLabel(GET_LAYER(map, l)->class[0]->labels[0]);
-      GET_LAYER(map, l)->class[0]->numlabels = 1;
-      GET_LAYER(map, l)->class[0]->labels[0]->force = MS_TRUE;
-      GET_LAYER(map, l)->class[0]->labels[0]->size = MS_MEDIUM; /* must set a size to have a valid label definition */
-      GET_LAYER(map, l)->class[0]->labels[0]->priority = MS_MAX_LABEL_PRIORITY;
-    }
-    if(GET_LAYER(map, l)->class[0]->labels[0]->numstyles == 0) {
-      if(msGrowLabelStyles(GET_LAYER(map,l)->class[0]->labels[0]) == NULL)
-        return(MS_FAILURE);
-      GET_LAYER(map,l)->class[0]->labels[0]->numstyles = 1;
-      initStyle(GET_LAYER(map,l)->class[0]->labels[0]->styles[0]);
-      GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
-    }
-    GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->symbol = s;
-    status = msAddLabel(map, img, GET_LAYER(map, l)->class[0]->labels[0], l, 0, NULL, &point, -1, NULL);
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
-      goto embed_cleanup;
-    }
-  }
-
-embed_cleanup:
-  /* Mark layer as deleted so that it doesn't interfere with html legends or with saving maps */
-  GET_LAYER(map, l)->status = MS_DELETE;
-
-  msFreeImage( image );
-  return status;
-}
-
-/************************************************************************/
-/* These two functions are used in PHP/Mapscript and Swig/Mapscript     */
-/************************************************************************/
-
-/************************************************************************/
-/*  double GetDeltaExtentsUsingScale(double scale, int units,           */
-/*                                   double centerLat, int width,       */
-/*                                   double resolution)                 */
-/*                                                                      */
-/*      Utility function to return the maximum extent using the         */
-/*      scale and the width of the image.                               */
-/*                                                                      */
-/*      Base on the function msCalculateScale (mapscale.c)              */
-/************************************************************************/
-double GetDeltaExtentsUsingScale(double scale, int units, double centerLat, int width, double resolution)
-{
-  double md = 0.0;
-  double dfDelta = -1.0;
-
-  if (scale <= 0 || width <=0)
-    return -1;
-
-  switch (units) {
-    case(MS_DD):
-    case(MS_METERS):
-    case(MS_KILOMETERS):
-    case(MS_MILES):
-    case(MS_NAUTICALMILES):
-    case(MS_INCHES):
-    case(MS_FEET):
-      /* remember, we use a pixel-center to pixel-center extent, hence the width-1 */
-      md = (width-1)/(resolution*msInchesPerUnit(units,centerLat));
-      dfDelta = md * scale;
-      break;
-
-    default:
-      break;
-  }
-
-  return dfDelta;
-}
-
-/************************************************************************/
-/*    static double Pix2Georef(int nPixPos, int nPixMin, double nPixMax,*/
-/*                              double dfGeoMin, double dfGeoMax,       */
-/*                              bool bULisYOrig)                        */
-/*                                                                      */
-/*      Utility function to convert a pixel pos to georef pos. If       */
-/*      bULisYOrig parameter is set to true then the upper left is      */
-/*      considered to be the Y origin.                                  */
-/*                                                                      */
-/************************************************************************/
-double Pix2Georef(int nPixPos, int nPixMin, int nPixMax,
-                  double dfGeoMin, double dfGeoMax, int bULisYOrig)
-{
-  double      dfPosGeo = 0.0;
-
-  const double dfWidthGeo = dfGeoMax - dfGeoMin;
-  const int nWidthPix = nPixMax - nPixMin;
-
-  if (dfWidthGeo > 0.0 && nWidthPix > 0) {
-    const double dfPixToGeo = dfWidthGeo / (double)nWidthPix;
-
-    int nDeltaPix;
-    if (!bULisYOrig)
-      nDeltaPix = nPixPos - nPixMin;
-    else
-      nDeltaPix = nPixMax - nPixPos;
-
-    const double dfDeltaGeo = nDeltaPix * dfPixToGeo;
-
-    dfPosGeo = dfGeoMin + dfDeltaGeo;
-  }
-  return (dfPosGeo);
-}
-
-/* This function converts a pixel value in geo ref. The return value is in
- * layer units. This function has been added for the purpose of the ticket #1340 */
-
-double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value)
-{
-  double cellsize = MS_MAX(MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
-                           MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
-
-  double resolutionFactor = map->resolution/map->defresolution;
-  double unitsFactor = 1;
-
-  if (layer->sizeunits != MS_PIXELS)
-    unitsFactor = msInchesPerUnit(map->units,0)/msInchesPerUnit(layer->sizeunits,0);
-
-  return value*cellsize*resolutionFactor*unitsFactor;
-}
diff -pruN 8.0.1-5/mapscript/README.rst 8.2.0~beta1-1~exp1/mapscript/README.rst
--- 8.0.1-5/mapscript/README.rst	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/README.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
-MapServer MapScript Modules
-===========================
-
-Much of MapServer's functionality is accessible from Java, Perl, PHP, Python,
-Ruby, C#, and Tcl.  MapScript is not a language like JavaScript or Python. It
-is a loadable module that brings MapServer capabilities to your favorite high
-level programming language.
-
-PHP and SWIG Branches of MapScript
-----------------------------------
-
-The MapScript family tree looks like this:
-
-::
-
-               MapServer
-                  /\ 
-                 /  \    
-                /    \ 
-     PHPMapScript     \  SWIGMapScript
-         PHP5/7    +----+-----+----+----+--+----+------------+
-                   |    |     |    |    |  |    |            |
-                 Perl Python Ruby Java C# Tcl  PHP7 (PHPNG) ...
-                 
-
-
-The SWIGMapScript modules are generated by `SWIG <http://www.swig.org>`_. 
-The PHPMapScript module is developed using the PHP C API without using SWIG. 
-PHP users therefore have a choice of using the SWIG generated module or the 
-custom written PHP module. 
-
-PHPMapScript
-------------
-
-Source code, detailed installation instructions are located in the ``mapscript/php``
-folder. Documentation can be found in the `PHP MapScript Documentation <https://www.mapserver.org/mapscript/php/index.html>`_
-section. 
-
-SWIG MapScript
---------------
-
-Installation instructions are located in the individual languages
-directories such as ``mapscript/perl``, ``mapscript/python``. 
-
-The main MapScript SWIG interface file is ``mapscript/mapscript.i``.  This
-file includes specific class interface files from ``mapscript/swiginc`` and
-language specific code from the language directories.
-
-Note the **v8** folder contains files for `V8 MapScript Support <https://mapserver.org/installation/v8.html>`_. 
-This is not a JavaScript version of MapScript, but provides support for the use of JavaScript
-in `STYLEITEM <https://mapserver.org/mapfile/styleitem.html#styleitemjs>`_ and 
-`GEOTRANSFORM <https://mapserver.org/mapfile/geomtransform.html#geomtransformjs>`_. 
-
-API Documentation can be found at the `Shared SWIG MapScript Documentation <https://mapserver.org/mapscript/index.html>`_ 
-page. 
diff -pruN 8.0.1-5/mapscript/csharp/CMakeLists.txt 8.2.0~beta1-1~exp1/mapscript/csharp/CMakeLists.txt
--- 8.0.1-5/mapscript/csharp/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,103 +0,0 @@
-FIND_PACKAGE(SWIG REQUIRED)
-INCLUDE(${SWIG_USE_FILE})
-
-FIND_PROGRAM (CSHARP_COMPILER NAMES csc mcs gmcs gmcs2)
-
-IF (CSHARP_COMPILER)
-	MESSAGE(STATUS "Found CSharp compiler: ${CSHARP_COMPILER}")
-ELSE (CSHARP_COMPILER)
-	MESSAGE(FATAL_ERROR "Could not find csharp compiler")
-ENDIF (CSHARP_COMPILER)
-
-if (WIN32)
-  if (NOT MSVC71)
-    if (CMAKE_CL_64)
-      set(PLATFORM_TARGET /platform:anycpu)
-    else(CMAKE_CL_64)
-      set(PLATFORM_TARGET /platform:x86)
-    endif(CMAKE_CL_64)
-	set (KEYFILE_SPEC /keyfile:${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\mapscript.snk)
-  endif (NOT MSVC71)
-  if (MSVC_VERSION GREATER 1500)
-      set(PLATFORM_TARGET ${PLATFORM_TARGET} /define:CLR4)
-  endif (MSVC_VERSION GREATER 1500)
-  MESSAGE(STATUS "Cmake build type: ${CMAKE_BUILD_TYPE}")
-  if (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo") 
-      set(PLATFORM_TARGET ${PLATFORM_TARGET} /debug:full)
-  endif (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
-else()
-	set (KEYFILE_SPEC -keyfile:${PROJECT_SOURCE_DIR}/mapscript/csharp/mapscript.snk)
-endif(WIN32)
-
-MARK_AS_ADVANCED(CSHARP_COMPILER)
-
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/csharp)
-SET (CMAKE_SWIG_OUTDIR "${CMAKE_CURRENT_BINARY_DIR}")
-if (WIN32)
-	SET( CMAKE_SWIG_FLAGS -namespace OSGeo.MapServer -DWIN32 ${MAPSERVER_COMPILE_DEFINITIONS})
-else()
-	SET( CMAKE_SWIG_FLAGS -namespace OSGeo.MapServer ${MAPSERVER_COMPILE_DEFINITIONS})
-endif()
-if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
-	SWIG_ADD_MODULE(mapscript csharp ../mapscript.i)
-else()
-	SWIG_ADD_LIBRARY(mapscript LANGUAGE csharp SOURCES ../mapscript.i)
-endif()
-
-if (WIN32)
-	set_target_properties(mapscript PROPERTIES OUTPUT_NAME "mapscript")
-else()
-	set_target_properties(mapscript PROPERTIES OUTPUT_NAME "libmapscript")
-endif()
-
-SWIG_LINK_LIBRARIES(mapscript ${MAPSERVER_LIBMAPSERVER})
-
-
-
-
-if (WIN32)
-
-	ADD_CUSTOM_COMMAND(TARGET mapscript
-						  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-						  POST_BUILD
-						  COMMAND set MAPSCRIPT_SNK=${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\mapscript.snk
-						  COMMAND set MAPSCRIPT_SNK=%MAPSCRIPT_SNK:/=\\%
-						  COMMAND copy /Y \"%MAPSCRIPT_SNK%\"
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /t:library /out:mapscript_csharp.dll ${KEYFILE_SPEC} *.cs ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\config\\AssemblyInfo.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shpdump.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\shpdump.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawmap.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\drawmap.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shapeinfo.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\shapeinfo.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawquery.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\drawquery.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\getbytes.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:HTMLtemplate.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\HTMLtemplate.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:RFC24.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\RFC24.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirect.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\drawmapDirect.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirectPrint.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\drawmapDirectPrint.cs
-						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapGDIPlus.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\drawmapGDIPlus.cs
-						  #COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /lib:C:\Windows\Microsoft.NET\Framework\v4.0.30319\WPF /r:mapscript_csharp.dll /r:System.Xaml.dll /r:WindowsBase.dll /r:PresentationCore.dll /out:drawmapWPF.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\drawmapWPF.cs
-						  COMMENT "Compiling c# source files"
-						  )
-else()
-	ADD_CUSTOM_COMMAND(TARGET mapscript
-						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-						POST_BUILD
-						COMMAND cp -f ${PROJECT_SOURCE_DIR}/mapscript/csharp/mapscript.snk ./
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -target:library -out:mapscript_csharp.dll ${KEYFILE_SPEC} *.cs ${PROJECT_SOURCE_DIR}/mapscript/csharp/config/AssemblyInfo.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:shpdump.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/shpdump.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:drawmap.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/drawmap.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:shapeinfo.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/shapeinfo.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:drawquery.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/drawquery.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:getbytes.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/getbytes.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:HTMLtemplate.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/HTMLtemplate.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:RFC24.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/RFC24.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapDirect.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/drawmapDirect.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapDirectPrint.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/drawmapDirectPrint.cs
-						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapGDIPlus.exe ${PROJECT_SOURCE_DIR}/mapscript/csharp/examples/drawmapGDIPlus.cs
-						#COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /lib:C:\Windows\Microsoft.NET\Framework\v4.0.30319\WPF /r:mapscript_csharp.dll /r:System.Xaml.dll /r:WindowsBase.dll /r:PresentationCore.dll /out:drawmapWPF.exe ${PROJECT_SOURCE_DIR}\\mapscript\\csharp\\examples\\drawmapWPF.cs
-						COMMENT "Compiling c# source files"
-						)
-endif()
-
-
diff -pruN 8.0.1-5/mapscript/csharp/Makefile.in 8.2.0~beta1-1~exp1/mapscript/csharp/Makefile.in
--- 8.0.1-5/mapscript/csharp/Makefile.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/Makefile.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,98 +0,0 @@
-# $Id$
-#
-# Run ./configure in the main MapServer directory to turn this Makefile.in
-# into a proper Makefile
-
-#
-# If you want to ignore missing datafile errors uncomment the following
-# line. This is especially useful with large tiled datasets that may not
-# have complete data for each tile.
-#
-#IGNORE_MISSING_DATA=-DIGNORE_MISSING_DATA
-IGNORE_MISSING_DATA = @IGNORE_MISSING_DATA@
-
-#
-# Apparently these aren't as commonplace as I'd hoped. Edit the
-# following line to reflect the missing functions on your platform.
-#
-# STRINGS=-DNEED_STRCASECMP -DNEED_STRNCASECMP -DNEED_STRDUP -DNEED_STRLCAT
-STRINGS= @STRINGS@
-
-#
-# Flags.
-#
-
-XTRALIBS= @XTRALIBS@
-RUNPATHS= @RPATHS@
-
-FLAGS = @DEBUG_FLAGS@ @ALL_ENABLED@ @ALL_INC@ $(STRINGS) $(IGNORE_MISSING_DATA)
-
-CCFLAGS   = @CFLAGS@ $(FLAGS)
-
-# Link flags and shared libs only
-SUP_LIBS =  @ALL_LIB@
-
-# STATIC_LIBS is full filename with path of libs that will be statically linked
-STATIC_LIBS= $(GD_STATIC)
-
-LDFLAGS= $(RUNPATHS) -L../.. -lmapserver $(SUP_LIBS) $(STATIC_LIBS)
-
-LIBMAPSCRIPT_SHARED= libmapscript.@SO_EXT@
-LD_SHARED= @LD_SHARED@
-
-# END OF CONFIGURE----
-
-#
-# SWIG Stuff
-#
-SWIG= swig
-
-#
-# CSHARP Stuff
-#
-CSC= mcs
-
-CC= @CC@
-
-#
-# --- You shouldn't have to edit anything else. ---
-#
-all: interface mapscript_so mapscript_csharp
-
-sign:
-	sn -k mapscript.snk
-
-interface: ../mapscript.i
-	$(SWIG) -csharp -namespace OSGeo.MapServer $(FLAGS) -o mapscript_wrap.c ../mapscript.i
-
-mapscript_so: mapscript_wrap.c
-	$(CC) -fpic -c $(CCFLAGS) mapscript_wrap.c
-	$(LD_SHARED) mapscript_wrap.o -o $(LIBMAPSCRIPT_SHARED) $(LDFLAGS)
-
-mapscript_csharp::
-	$(CSC) /t:library /out:mapscript_csharp.dll *.cs config/AssemblyInfo.cs
-	$(CSC) /r:mapscript_csharp.dll /out:shpdump.exe examples/shpdump.cs
-	$(CSC) /r:mapscript_csharp.dll /out:shapeinfo.exe examples/shapeinfo.cs
-	$(CSC) /r:mapscript_csharp.dll /out:drawmap.exe examples/drawmap.cs
-	$(CSC) /r:mapscript_csharp.dll /out:inline.exe examples/inline.cs
-	$(CSC) /r:mapscript_csharp.dll /out:drawquery.exe examples/drawquery.cs
-	$(CSC) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe examples/getbytes.cs
-	$(CSC) /r:mapscript_csharp.dll /out:HTMLtemplate.exe examples/HTMLtemplate.cs
-	$(CSC) /r:mapscript_csharp.dll /out:RFC24.exe examples/RFC24.cs
-
-dll_config: Makefile
-	rm -rf mapscript_csharp.dll.config
-	echo "<configuration>" >> mapscript_csharp.dll.config
-	echo "<dllmap dll=\"mapscript\" target=\""mapscript"\">" >> mapscript_csharp.dll.config
-	echo "</configuration>" >> mapscript_csharp.dll.config
-
-clean:
-	rm -rf edu *.o *.c *.cs *.@SO_EXT@ *.dll *.dll.config
-
-test:
-	LC_ALL=C mono ./shpdump.exe ../../tests/point.shp
-	LC_ALL=C mono ./shapeinfo.exe ../../tests/point.shp
-	LC_ALL=C mono ./inline.exe png24 inline_test.png
-	LC_ALL=C mono ./getbytes.exe ../../tests/test.map test_csharp2.png
-	LC_ALL=C mono ./RFC24.exe ../../tests/test.map
-
diff -pruN 8.0.1-5/mapscript/csharp/Makefile.vc 8.2.0~beta1-1~exp1/mapscript/csharp/Makefile.vc
--- 8.0.1-5/mapscript/csharp/Makefile.vc	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/Makefile.vc	1970-01-01 00:00:00.000000000 +0000
@@ -1,127 +0,0 @@
-#
-# makefile.vc - MSVC++ makefile for the C#/MapScript extension
-#
-# This VC++ makefile will build the PHP module CSHARP_MAPSCRIPT.DLL
-#
-# To use the makefile:
-#  - Open a DOS prompt window
-#  - Run the VCVARS32.BAT script to initialize the VC++ environment variables
-#  - Start the build with:  nmake /f makefile.vc
-#
-# $Id$
-#
-
-
-# Flag indicating to the option files that this is the build of C#/MapScript
-#!INCLUDE ../../nmake.opt
-
-# Be aware when setting different options for libmap.dll and mapscript.dll (Bug 1476)
-# To change the options for mapscript.dll uncomment the following line
-# otherwise the options of nmake.opt will be used
-#OPTFLAGS =	/nologo /Zi /MD $(WARNING_LEVEL) $(DEBUG)
-BASE_CFLAGS = 	$(OPTFLAGS) -DWIN32 -D_WIN32
-#LDFLAGS =	/NODEFAULTLIB:msvcrt /NODEFAULTLIB:libcd /dll $(LDEBUG)
-LDFLAGS =	/dll $(LDEBUG)
-CFLAGS = 	$(BASE_CFLAGS) $(MS_CFLAGS) -I../.. 
-
-CC=     cl
-LINK=   link
-
-!IFDEF MS_DEBUG
-CSDEBUG = /debug:full
-!ELSE
-CSDEBUG =
-!ENDIF
-
-!IFDEF MONO
-CSC = mcs
-!ELSE
-!IF $(MSVC_VER) >= 1400
-!IFDEF WIN64
-CSC = csc /platform:anycpu $(CSDEBUG)
-!ELSE
-CSC = csc /platform:x86 $(CSDEBUG)
-!ENDIF
-!ELSE
-CSC = csc $(CSDEBUG)
-!ENDIF
-!ENDIF
-
-!IF $(MSVC_VER) >= 1600
-CSC = $(CSC) /define:CLR4
-!ENDIF
-
-#SWIG = swig
-
-!IFDEF DLLBUILD
-MS_LIBS = ../../mapserver_i.lib $(EXTERNAL_LIBS)
-!ELSE
-MS_LIBS = $(EXTERNAL_LIBS) ../../mapserver.lib
-!ENDIF
-
-#
-# The rest of the file should not have to be edited...
-#
-
-MAPSCRIPT_OBJS =  mapscript_wrap.obj  
-MAPSCRIPT_DLL =   mapscript.dll
-CSHARP_DLL = mapscript_csharp.dll
-
-default: 	all
-
-all:		interface $(MAPSCRIPT_DLL) $(CSHARP_DLL)
-
-sign:
-	sn -k mapscript.snk
-
-interface: ../mapscript.i
-	$(SWIG) -csharp -namespace OSGeo.MapServer $(MS_DEFS) -DWIN32 -o mapscript_wrap.c ../mapscript.i
-
-.c.obj:
-	$(CC) $(CFLAGS) /DCOMPILE_DL=1 /c $*.c /Fo$*.obj	
-		
-$(MAPSCRIPT_DLL): $(MAPSCRIPT_OBJS)
-	$(LINK) $(LDFLAGS) /out:$(MAPSCRIPT_DLL) $(MAPSCRIPT_OBJS) $(MS_LIBS)
-	if exist $(MAPSCRIPT_DLL).manifest mt -manifest $(MAPSCRIPT_DLL).manifest -outputresource:$(MAPSCRIPT_DLL);2
-
-$(CSHARP_DLL)::
-	$(CSC) $(CSFLAGS) /t:library /out:mapscript_csharp.dll *.cs config\AssemblyInfo.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:shpdump.exe examples\shpdump.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:drawmap.exe examples\drawmap.cs
-#	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:inline.exe examples\inline.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:shapeinfo.exe examples\shapeinfo.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:drawquery.exe examples\drawquery.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe examples\getbytes.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:HTMLtemplate.exe examples\HTMLtemplate.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:RFC24.exe examples\RFC24.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirect.exe examples\drawmapDirect.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirectPrint.exe examples\drawmapDirectPrint.cs
-	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapGDIPlus.exe examples\drawmapGDIPlus.cs
-
-test:
-!IFDEF MONO
-	mono shpdump.exe ../../tests/point.shp
-	mono shapeinfo.exe ../../tests/point.shp
-#	mono inline.exe aggpng24 inline_test.png
-	mono getbytes.exe ../../tests/test.map test_csharp2.png
-	mono RFC24.exe ../../tests/test.map
-!ELSE
-	shpdump ../../tests/point.shp
-	shapeinfo ../../tests/point.shp
-#	inline png24 inline_test.png
-	getbytes ../../tests/test.map test_csharp2.png
-	RFC24.exe ../../tests/test.map
-!ENDIF
-	
-clean:
-	del *.obj
-	del *.dll
-	del *.lib
-	del *.pdb
-	del *.exp
-	del *.ilk
-	del *.cs
-	del *.c
-	del *.exe
-	del *.manifest
-
diff -pruN 8.0.1-5/mapscript/csharp/README 8.2.0~beta1-1~exp1/mapscript/csharp/README
--- 8.0.1-5/mapscript/csharp/README	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,285 +0,0 @@
--- $Id$
-
-The most recent version of this document can be found on
-http://mapserver.gis.umn.edu/docs/howto/mapscriptcscompile
-
-
-1. Compilation
-==============
-Before compiling C# mapscript you should compile mapserver with the options for your requirements.
-For more information about the compilation of mapserver please see `Win32 Compilation and Installation <http://mapserver.gis.umn.edu/docs/howto/win32_compiling>`__ .
-It is highly recommended to minimize the library dependency of your application, so
-when compiling mapserver enable only the features really needed.
-To compile the C# binding SWIG 1.3.27 or later is required.
-
-
-1.1 Win32 compilation targeting the MS.NET framework 1.1
---------------------------------------------------------
-You should compile mapserver, mapscript and all of the subsequent libraries using Visual Studio 2003.
-Download and uncompress the latest SWIGWIN package that contains the precompiled swig.exe
-Open the Visual Studio .NET 2003 Command Prompt and step into the /mapscript/csharp directory
-Edit makefile.vc and set the SWIG variable to the location of your swig.exe
-Use
-
-::
-
-       nmake -f makefile.vc 
-
-to compile mapscript.dll and mapscript_csharp.dll.
-
-
-1.2 Win32 compilation targeting the MS.NET framework 2.0
---------------------------------------------------------
-You should compile mapserver, mapscript and all of the subsequent libraries using Visual Studio 2005.
-Download and uncompress the latest SWIGWIN package that contains the precompiled swig.exe
-Open the Visual Studio 2005 Command Prompt and step into the /mapscript/csharp directory
-Edit makefile.vc and set the SWIG variable to the location of your swig.exe
-Use
-
-::
- 
-       nmake -f makefile.vc 
-
-to compile mapscript.dll and mapscript_csharp.dll.
-
-1.3 Win32 compilation targeting the MONO framework
---------------------------------------------------
-Before the compilation you should download and install the recent mono Win32 setup package (eg. mono-1.1.13.2-gtksharp-2.8.1-win32-1.exe)
-Edit makefile.vc and set the CSC variable to the location of your mcs.exe. Alternatively you can define
-
-::
-
-        MONO = YES
-
-In your nmake.opt file.
-
-You should use the same compiler for compiling mapscript as the compiler has been used for
-the mapserver compilation. To compile mapscript open the Command Prompt supplied with your compiler
-and use
-
-::
-
-        nmake -f makefile.vc 
-
-to compile mapscript.dll and mapscript_csharp.dll.
-
-1.4 Alternative compilation methods on Windows
-----------------------------------------------
-Beginning from mapserver 4.8.3 you can invoke the C# compilation from the mapserver directory by uncommenting DOT_NET in nmake.opt 
-
-::
-
-#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-# .NET/C# MapScript
-# ----------------------------------------------------------------------
-# .NET will of course only work with MSVC 7.0 and 7.1.  Also note that
-# you will definitely want USE_THREAD defined.
-#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-#DOT_NET = YES
-
-and invoking the compilation by
-
-::
-
-        nmake -f makefile.vc csharp
-
-You can also use
-
-::
-
-        nmake -f makefile.vc install
-
-for making the compilation an copying the targets into a common output directory.
-
-1.5 Testing the compilation
----------------------------
-
-For testing the compilation and the runtime environment you can use
-
-::
-
-      nmake -f makefile.vc test
-
-within the csharp directory for starting the sample applications compiled previously. Before making the test the location of the corresponding libraries should be incuded in the system PATH. 
-
-1.6 Linux compilation targeting the MONO framework
---------------------------------------------------
-Before the compilation you should download and install the recent mono Linux package.
-Some distributions have precompiled binaries to install, but for using the latest
-version you might want to compile and install it from the source.
-Download and uncompress the latest SWIG release. You should probably compile it
-from the source if precompiled binaries are not available for your platform.
-
-Before compiling mapscript mapserver should be configured and compiled. Beginning from mapserver 4.8.2 during configuration the mapscript/csharp/Makefile will be created according to the configuration options. Edit this file and set the SWIG and CSC for the corresponding executable pathes if the files could not be accessed by default. To compile at a console step into the /mapscript/csharp directory
-use
-
-::
-
-      make
-      
-to compile libmapscript.so and mapscript_csharp.dll.
-
-For testing the compilation and the runtime environment you can use
-
-::
-
-      make test
-
-for starting the sample applications compiled previously.
-
-1.7 OSX compilation targeting the MONO framework
-------------------------------------------------
-Beginning from 4.10.0 the csharp/Makefile supports the OSX builds. Before making the build the recent MONO package should be installed on the system.
-
-Before compiling mapscript mapserver should be configured and compiled. Beginning from mapserver 4.8.2 during configuration the mapscript/csharp/Makefile will be created according to the configuration options. Edit this file and set the SWIG and CSC for the corresponding executable pathes if the files could not be accessed by default. To compile at a console step into the /mapscript/csharp directory
-use
-
-::
-
-      make
-      
-to compile libmapscript.dylib and mapscript_csharp.dll.
-
-For testing the compilation and the runtime environment you can use
-
-::
-
-      make test
-
-for starting the sample applications compiled previously.
-
-To run the applications mapscript_csharp.dll.config is needed along with the mapscript_csharp.dll file. This file is created during the make process
-
-2. Installation
-===============
-The files required for your application should be manually installed. It is highly recommended to copy the files into the same folder as the executable resides.
-
-3. Known issues
-===============
-
-3.1 Visual Studio 2005 requires a manifest file to load the CRT native assembly wrapper
----------------------------------------------------------------------------------------
-
-If you have compiled mapserver for using the CRT libraries and you are using the MS.NET framework 2.0 as the execution runtime you should supply a proper manifest file along with your executable, like:
-
-::
-
-<?xml version="1.0" encoding="utf-8"?>
-<assembly xsi:schemaLocation="urn:schemas-microsoft-com:asm.v1 assembly.adaptive.xsd" manifestVersion="1.0" xmlns:asmv1="urn:schemas-microsoft-com:asm.v1" xmlns:asmv2="urn:schemas-microsoft-com:asm.v2" xmlns:dsig="http://www.w3.org/2000/09/xmldsig#" xmlns="urn:schemas-microsoft-com:asm.v1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
-<assemblyIdentity name="drawmap.exe" version="1.0.0.0" type="win32" />
-<dependency>
-<dependentAssembly asmv2:dependencyType="install" asmv2:codebase="Microsoft.VC80.CRT.manifest" asmv2:size="522">
-<assemblyIdentity name="Microsoft.VC80.CRT" version="8.0.50608.0" publicKeyToken="1fc8b3b9a1e18e3b" processorArchitecture="x86" type="win32" />
-<hash xmlns="urn:schemas-microsoft-com:asm.v2">
-<dsig:Transforms>
-<dsig:Transform Algorithm="urn:schemas-microsoft-com:HashTransforms.Identity" />
-</dsig:Transforms>
-<dsig:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1" />
-<dsig:DigestValue>UMOlhUBGeKRrrg9DaaPNgyhRjyM=</dsig:DigestValue>
-</hash>
-</dependentAssembly>
-</dependency>
-</assembly>
-
-This will inform the CLR that your exe depends on the CRT and the proper assembly wrapper is to be used.
-If you are using the IDE the manifest file could be pregenerated by adding a reference to
-Microsoft.VC80.CRT.manifest within the /Microsoft Visual Studio 8/VC/redist/x86/Microsoft.VC80.CRT
-directory.
-
-3.2 Manifests for the dll-s must be embedded as a resource
-----------------------------------------------------------
-
-According to the windows makefile the mapscript compilation target (mapscript.dll) is linked with the /MD option. In this case the VS2005 linker will generate a manifest file containing the unmanaged assembly dependency. The sample contents of the manifest file are:
-
-::
-
-<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
-<assembly xmlns='urn:schemas-microsoft-com:asm.v1' manifestVersion='1.0'>
-<dependency>
-<dependentAssembly>
-<assemblyIdentity type='win32' name='Microsoft.VC80.CRT' version='8.0.50608.0' processorArchitecture='x86' publicKeyToken='1fc8b3b9a1e18e3b' />
-</dependentAssembly>
-</dependency>
-</assembly>
-
-Like previously mentioned if you are creating a windows application the common language runtime will search for a manifest file for the application. The name of the manifest file should be the same as the executable appendend with the .manifest extension.
-However if the host process is not controlled by you (like web mapping applications using aspnet_wp.exe as the host process) you will not be certain if the host process (.exe) will have a manifest containing a reference to the CRT wrapper. In this case you may have to embed the manifest into the dll as a resource using the mt tool like:
-
-::
-
- mt /manifest mapscript.dll.manifest /outputresource:mapscript.dll;#2
-
-the common language runtime will search for the embedded resource and load the CRT assembly properly.
-
-Normally it is enough to load the CRT with the root dll (mapscript.dll), but it is not harmful embedding the manifest into the dependent libraries as well.
-
-
-3.3 Issue with regex and Visual Studio 2005
--------------------------------------------
-
-When compiling with Microsoft Visual Studio 2005 variable name collision may occur between regex.c
-and crtdefs.h. For more details see:
-
-http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1651
-
-3.4 C# mapscript library name mapping with MONO
------------------------------------------------
-
-Using the mapscript interface created by the SWIG interface generator the communication between the C# wrapper classes (mapscript_csharp.dll) and the C code (mapscript.dll) takes place using platform invoke like:
-
-::
-
- [DllImport("mapscript", EntryPoint="CSharp_new_mapObj")]
- public static extern IntPtr new_mapObj(string jarg1); 
-
-The DllImport declaration contains the library name, however to transform the library name into a file name is platform dependent.
-On Windows the library name is simply appended with the .dll extension (mapscript.dll). On the Unix systems the library file name normally starts with the lib prefix and appended with the .so extension (libmapscript.so).
-
-Mapping of the library name may be manually controlled using a dll.config file. This simply
-maps the library file the DllImport is looking for to its unix equivalent. The file normally contains the following information (mapscript_csharp.dll.config):
-
-::
-
-<configuration>
-<dllmap dll="mapscript" target="libmapscript.so" />
-</configuration>
-
-and with the OSX builds:
-
-::
-
-<configuration>
-<dllmap dll="mapscript" target="libmapscript.dylib" />
-</configuration>
- 
-The file should be placed along with the corresponding mapscript_csharp.dll file, and created by default during the make process.
-For more information see:
-
-http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1596
-http://www.mono-project.com/Interop_with_Native_Libraries
-
-3.5 Localization issues with MONO/Linux
----------------------------------------
-
-According to http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1762 mapserver may not operate equally well on different locale settings. Especially when the decimal separator is other than "." inside the locale of the process may cause parse errors when the mapfile contains float numbers.
-Since the MONO process takes over the locale settings of the environment it is worth considering to set the default locale to "C" of the host process, like:
-
-::
-
- LC_ALL=C mono ./drawmap.exe ../../tests/test.map test_csharp.png
-
-4. Most frequent errors
-=======================
-
-This chapter will summarize the most frequent problems the user can run into. The issues were collected mainly from the -users list and the IRC.
-
-4.1 Unable to load dll (mapscript)
-----------------------------------
-
-You can get this problem on Windows and in most cases it can be dedicated to a missing or an unloadable shared library. The error message talks about mapscript.dll but surely one or more of the dll-s are missing that libmap.dll depends on. So firstly you might want to check for the dependencies of your libmap.dll in your application directory. You can use the Visual Studio Dependency Walker to accomplish this task. You can also use a file monitoring tool (like SysInternal's filemon) to detect the dll-s that could not be loaded. I propose to store all of the dll-s required by your application in the application folder. If you can run the drawmap C# sample application with your mapfile your compilation might be correct and all of the dlls are available.
-
-You may find that the mapscript C# interface behaves differently for the desktop and the ASP.NET applications. Although you can run the drawmap sample correctly you may encounter the dll loading problem with the ASP.NET applications. When creating an ASP.NET project your application folder will be '\Inetpub\wwwroot\[YourApp]\bin' by default. The host process of the application will aspnet_wp.exe or w3wp.exe depending on your system. The application will run under a different security context than the interactive user (under the context of the ASPNET user by default). When placing the dll-s outside of your application directory you should consider that the PATH environment variable may differ between the interactive and the ASPNET user and/or you may not have enough permission to access a dll outside of your application folder.
-
-5. Bug reports
-==============
-If you find a problem dedicated to the mapscript C# interface feel free to file a bug report to BugZilla.
diff -pruN 8.0.1-5/mapscript/csharp/config/AssemblyInfo.cs 8.2.0~beta1-1~exp1/mapscript/csharp/config/AssemblyInfo.cs
--- 8.0.1-5/mapscript/csharp/config/AssemblyInfo.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/config/AssemblyInfo.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,98 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  MapScript CSharp Assembly Information
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System.Reflection;
-using System.Runtime.CompilerServices;
-using System.Security;
-
-//
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-//
-[assembly: AssemblyTitle("mapscript")]
-[assembly: AssemblyDescription("MapScript C# Library")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("")]
-[assembly: AssemblyProduct("")]
-[assembly: AssemblyCopyright("")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]		
-
-//
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Revision and Build Numbers 
-// by using the '*' as shown below:
-
-[assembly: AssemblyVersion("1.0.*")]
-
-//
-// In order to sign your assembly you must specify a key to use. Refer to the 
-// Microsoft .NET Framework documentation for more information on assembly signing.
-//
-// Use the attributes below to control which key is used for signing. 
-//
-// Notes: 
-//   (*) If no key is specified, the assembly is not signed.
-//   (*) KeyName refers to a key that has been installed in the Crypto Service
-//       Provider (CSP) on your machine. KeyFile refers to a file which contains
-//       a key.
-//   (*) If the KeyFile and the KeyName values are both specified, the 
-//       following processing occurs:
-//       (1) If the KeyName can be found in the CSP, that key is used.
-//       (2) If the KeyName does not exist and the KeyFile does exist, the key 
-//           in the KeyFile is installed into the CSP and used.
-//   (*) In order to create a KeyFile, you can use the sn.exe (Strong Name) utility.
-//       When specifying the KeyFile, the location of the KeyFile should be
-//       relative to the project output directory which is
-//       %Project Directory%\obj\<configuration>. For example, if your KeyFile is
-//       located in the project directory, you would specify the AssemblyKeyFile 
-//       attribute as [assembly: AssemblyKeyFile("..\\..\\mykey.snk")]
-//   (*) Delay Signing is an advanced option - see the Microsoft .NET Framework
-//       documentation for more information on this.
-//
-[assembly: AssemblyDelaySign(false)]
-[assembly: AssemblyKeyFile("mapscript.snk")]
-[assembly: AssemblyKeyName("")]
-
-// The AllowPartiallyTrustedCallersAttribute requires the assembly to be signed with a strong name key.
-// This attribute is necessary since the control is called by either an intranet or Internet
-// Web page that should be running under restricted permissions.
-[assembly: AllowPartiallyTrustedCallers]
-
-// Use the .NET Framework 2.0 transparency rules (level 1 transparency) as default
-#if (CLR4)
-[assembly: SecurityRules(SecurityRuleSet.Level1)]
-#endif
\ No newline at end of file
diff -pruN 8.0.1-5/mapscript/csharp/config/mapscript_csharp.dll.config 8.2.0~beta1-1~exp1/mapscript/csharp/config/mapscript_csharp.dll.config
--- 8.0.1-5/mapscript/csharp/config/mapscript_csharp.dll.config	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/config/mapscript_csharp.dll.config	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-<configuration>
-    <dllmap dll="mapscript" target="libmapscript.so" />
-</configuration>
diff -pruN 8.0.1-5/mapscript/csharp/csmodule.i 8.2.0~beta1-1~exp1/mapscript/csharp/csmodule.i
--- 8.0.1-5/mapscript/csharp/csmodule.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/csmodule.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,480 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  C#-specific enhancements to MapScript
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-/*Uncomment the following lines if you want to receive subsequent exceptions as
-inner exceptions. Otherwise the exception message will be concatenated*/
-//#if SWIG_VERSION >= 0x010329
-//#define ALLOW_INNER_EXCEPTIONS
-//#endif
-
-%ignore fp;
-
-/******************************************************************************
- * Implement Equals and GetHashCode properly
- *****************************************************************************/
-
-%typemap(cscode) SWIGTYPE %{
-  public override bool Equals(object obj) {
-    if (obj == null)
-        return false;
-    if (this.GetType() != obj.GetType())
-        return false;
-    return swigCPtr.Handle.Equals($csclassname.getCPtr(($csclassname)obj).Handle);
-  }
-
-  public override int GetHashCode() {
-    return swigCPtr.Handle.GetHashCode();
-  }
-%}
-
-/******************************************************************************
- * Module initialization helper (bug 1665)
- *****************************************************************************/
-
-%pragma(csharp) imclasscode=%{
-  protected class $moduleHelper 
-	{
-		static $moduleHelper() 
-		{
-			$module.msSetup();
-		}
-		 ~$moduleHelper() 
-		{
-			//$module.msCleanup();
-		}
-	}
-	protected static $moduleHelper the$moduleHelper = new $moduleHelper();
-%}
-
-/******************************************************************************
- * C# exception redefinition
- *****************************************************************************/
-#ifdef ALLOW_INNER_EXCEPTIONS
-%exception
-{
-	errorObj *ms_error;
-	$action
-    ms_error = msGetErrorObj();
-    if (ms_error != NULL && ms_error->code != MS_NOERR) {
-	    if (ms_error->code != MS_NOTFOUND && ms_error->code != -1) {
-            int ms_errorcode = ms_error->code;
-            while (ms_error!=NULL && ms_error->code != MS_NOERR) {
-                char* msg =  msAddErrorDisplayString(NULL, ms_error);
-                if (msg) {
-			        SWIG_CSharpException(SWIG_SystemError, msg);
-			        free(msg);
-		        }
-                else SWIG_CSharpException(SWIG_SystemError, "MapScript unknown error");
-                ms_error = ms_error->next;	  
-            }
-            msResetErrorList();
-            return $null;
-        }
-        msResetErrorList();
-    }
-}
-#else
-%exception
-{
-	errorObj *ms_error;
-	$action
-    ms_error = msGetErrorObj();
-    if (ms_error != NULL && ms_error->code != MS_NOERR) {
-	    if (ms_error->code != MS_NOTFOUND && ms_error->code != -1) {
-            char* msg = msGetErrorString(";"); 
-		    if (msg) {
-			    SWIG_CSharpException(SWIG_SystemError, msg);
-			    free(msg);
-		    }
-            else SWIG_CSharpException(SWIG_SystemError, "MapScript unknown error");
-            msResetErrorList();
-		    return $null;
-        }
-        msResetErrorList();
-    }
-}
-#endif
-
-/******************************************************************************
- * typemaps for string arrays (for supporting map templates)
- *****************************************************************************/
- 
-%pragma(csharp) imclasscode=%{
-public class StringArrayMarshal : global::System.IDisposable {
-    public readonly System.IntPtr[] _ar;
-    public StringArrayMarshal(string[] ar) {
-      _ar = new System.IntPtr[ar.Length];
-      for (int cx = 0; cx < _ar.Length; cx++) {
-	      _ar[cx] = System.Runtime.InteropServices.Marshal.StringToHGlobalAnsi(ar[cx]);
-      }
-    }
-    public virtual void Dispose() {
-	  for (int cx = 0; cx < _ar.Length; cx++) {
-          System.Runtime.InteropServices.Marshal.FreeHGlobal(_ar[cx]);
-      }
-      System.GC.SuppressFinalize(this);
-    }
-  }
-%}
-
-%typemap(imtype, out="System.IntPtr") char** "System.IntPtr[]"
-%typemap(cstype) char** %{string[]%}
-%typemap(in) char** %{ $1 = ($1_ltype)$input; %}
-%typemap(out) char** %{ $result = $1; %}
-%typemap(csin) char** "new $modulePINVOKE.StringArrayMarshal($csinput)._ar"
-%typemap(csout, excode=SWIGEXCODE) char** {
-    $excode
-    throw new System.NotSupportedException("Returning string arrays is not implemented yet.");
-}
-%typemap(csvarin, excode=SWIGEXCODE2) char** %{
-    set {
-      $excode
-	  throw new System.NotSupportedException("Setting string arrays is not supported now.");
-    } 
-%}
-/* specializations */
-%typemap(csvarout, excode=SWIGEXCODE2) char** formatoptions %{
-    get {
-        System.IntPtr cPtr = $imcall;
-        System.IntPtr objPtr;
-	    string[] ret = new string[this.numformatoptions];
-        for(int cx = 0; cx < this.numformatoptions; cx++) {
-            objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
-            ret[cx]= (objPtr == System.IntPtr.Zero) ? null : System.Runtime.InteropServices.Marshal.PtrToStringAnsi(objPtr);
-        }
-        $excode
-        return ret;
-    }
-%}
-%typemap(csvarout, excode=SWIGEXCODE2) char** values %{
-    get {
-        System.IntPtr cPtr = $imcall;
-        System.IntPtr objPtr;
-	    string[] ret = new string[this.numvalues];
-        for(int cx = 0; cx < this.numvalues; cx++) {
-            objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
-            ret[cx]= (objPtr == System.IntPtr.Zero) ? null : System.Runtime.InteropServices.Marshal.PtrToStringAnsi(objPtr);
-        }
-        $excode
-        return ret;
-    }
-%}
-
-/******************************************************************************
- * typemaps for outputFormatObj arrays
- *****************************************************************************/
-
-%typemap(ctype) outputFormatObj** "void*"
-%typemap(imtype) outputFormatObj** "System.IntPtr"
-%typemap(cstype) outputFormatObj** "outputFormatObj[]"
-%typemap(out) outputFormatObj** %{ $result = $1; %}
-%typemap(csout, excode=SWIGEXCODE) outputFormatObj** {
-      System.IntPtr cPtr = $imcall;
-      System.IntPtr objPtr;
-      outputFormatObj[] ret = new outputFormatObj[this.numoutputformats];
-      for(int cx = 0; cx < this.numoutputformats; cx++) {
-          objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
-          ret[cx] = (objPtr == System.IntPtr.Zero) ? null : new outputFormatObj(objPtr, false, ThisOwn_false());
-      }
-      $excode
-      return ret;
-}
-
-%typemap(csvarout, excode=SWIGEXCODE2) outputFormatObj** %{
-    get {
-      System.IntPtr cPtr = $imcall;
-      System.IntPtr objPtr;
-      outputFormatObj[] ret = new outputFormatObj[this.numoutputformats];
-      for(int cx = 0; cx < this.numoutputformats; cx++) {
-          objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
-          ret[cx] = (objPtr == System.IntPtr.Zero) ? null : new outputFormatObj(objPtr, false, ThisOwn_false());
-      }
-      $excode
-      return ret;
-    }
-%}
-
-/******************************************************************************
- * gdBuffer Typemaps and helpers
- *****************************************************************************/
-
-%pragma(csharp) imclasscode=%{
-  public delegate void SWIGByteArrayDelegate(System.IntPtr data, int size);
-%}
-
-%insert(runtime) %{
-/* Callback for returning byte arrays to C# */
-typedef void (SWIGSTDCALL* SWIG_CSharpByteArrayHelperCallback)(const unsigned char *, const int);
-/* Default callback interface */
-static SWIG_CSharpByteArrayHelperCallback SWIG_csharp_bytearray_callback = NULL;
-%}
-
-%typemap(ctype) SWIG_CSharpByteArrayHelperCallback    %{SWIG_CSharpByteArrayHelperCallback%}
-%typemap(imtype) SWIG_CSharpByteArrayHelperCallback  %{SWIGByteArrayDelegate%}
-%typemap(cstype) SWIG_CSharpByteArrayHelperCallback %{$modulePINVOKE.SWIGByteArrayDelegate%}
-%typemap(in) SWIG_CSharpByteArrayHelperCallback %{ $1 = ($1_ltype)$input; %}
-%typemap(csin) SWIG_CSharpByteArrayHelperCallback "$csinput"
-
-%typemap(imtype) (unsigned char* pixels) "System.IntPtr"
-%typemap(cstype) (unsigned char* pixels) "System.IntPtr"
-%typemap(in) (unsigned char* pixels) %{ $1 = ($1_ltype)$input; %}
-%typemap(csin) (unsigned char* pixels) "$csinput"
-
-%csmethodmodifiers getBytes "private";
-%ignore imageObj::getBytes();
-%extend imageObj 
-{
-	void getBytes(SWIG_CSharpByteArrayHelperCallback callback) {
-        gdBuffer buffer;
-        
-        buffer.owns_data = MS_TRUE;
-        
-        buffer.data = msSaveImageBuffer(self, &buffer.size, self->format);
-            
-        if( buffer.data == NULL || buffer.size == 0 )
-        {
-            msSetError(MS_MISCERR, "Failed to get image buffer", "getBytes");
-            return;
-        }
-        callback(buffer.data, buffer.size);
-        msFree(buffer.data);
-    }
-
-    int getRawPixels(unsigned char* pixels) {
-      if (MS_RENDERER_PLUGIN(self->format)) {
-        rendererVTableObj *renderer = self->format->vtable;
-        if(renderer->supports_pixel_buffer) {
-          rasterBufferObj rb;
-          int status = MS_SUCCESS;
-          int size = self->width * self->height * 4 * sizeof(unsigned char);
-          
-          status = renderer->getRasterBufferHandle(self,&rb);
-          if(MS_UNLIKELY(status == MS_FAILURE)) {
-            return MS_FAILURE;
-          }
-          memcpy(pixels, rb.data.rgba.pixels, size);
-          return status;
-        }
-      }
-      return MS_FAILURE;
-    }
-}
-
-%ignore imageObj::write;
-%typemap(cscode) imageObj, struct imageObj %{
-  private byte[] gdbuffer;
-  private void CreateByteArray(System.IntPtr data, int size)
-  {
-      gdbuffer = new byte[size];
-      System.Runtime.InteropServices.Marshal.Copy(data, gdbuffer, 0, size);
-  }
-  
-  public byte[] getBytes()
-  {
-	getBytes(new $modulePINVOKE.SWIGByteArrayDelegate(this.CreateByteArray));
-	return gdbuffer;
-  }
-  
-  public void write(System.IO.Stream stream)
-  {
-	getBytes(new $modulePINVOKE.SWIGByteArrayDelegate(this.CreateByteArray));
-	stream.Write(gdbuffer, 0, gdbuffer.Length);
-  }
-%}
-
-
-%csmethodmodifiers processTemplate "private";
-%csmethodmodifiers processLegendTemplate "private";
-%csmethodmodifiers processQueryTemplate "private";
-
-%typemap(csinterfaces) mapObj "System.IDisposable, System.Runtime.Serialization.ISerializable";
-%typemap(csattributes) mapObj  "[Serializable]"
-%typemap(cscode) mapObj, struct mapObj %{  
-  public string processTemplate(int bGenerateImages, string[] names, string[] values)
-  {
-	if (names.Length != values.Length)
-	    throw new System.ArgumentException("Invalid array length specified!");
-	return processTemplate(bGenerateImages, names, values, values.Length);
-  }
-  
-  public string processLegendTemplate(string[] names, string[] values)
-  {
-	if (names.Length != values.Length)
-	    throw new System.ArgumentException("Invalid array length specified!");
-	return processLegendTemplate(names, values, values.Length);
-  }
-  
-  public string processQueryTemplate(string[] names, string[] values)
-  {
-	if (names.Length != values.Length)
-	    throw new System.ArgumentException("Invalid array length specified!");
-	return processQueryTemplate(names, values, values.Length);
-  }
- 
-  public mapObj(
-      System.Runtime.Serialization.SerializationInfo info
-      , System.Runtime.Serialization.StreamingContext context) : this(info.GetString("mapText"), 1)
-  {       
-        //this constructor is needed for ISerializable interface
-  }
-  
-  public void GetObjectData(System.Runtime.Serialization.SerializationInfo info, System.Runtime.Serialization.StreamingContext context) 
-    {    
-        info.AddValue( "mapText", this.convertToString() );        
-    }
-%}
-
-
-%typemap(ctype) gdBuffer    %{void%}
-%typemap(imtype) gdBuffer  %{void%}
-%typemap(cstype) gdBuffer %{byte[]%}
-
-%typemap(out, null="") gdBuffer
-%{ SWIG_csharp_bytearray_callback($1.data, $1.size);
-	if( $1.owns_data ) msFree($1.data); %}
-
-// SWIGEXCODE is a macro used by many other csout typemaps
-#ifdef SWIGEXCODE
-%typemap(csout, excode=SWIGEXCODE) gdBuffer {
-    $imcall;$excode
-    return $modulePINVOKE.GetBytes();
-}
-#else
-%typemap(csout) gdBuffer {
-    $imcall;
-    return $modulePINVOKE.GetBytes();
-}
-#endif
-
-%pragma(csharp) imclasscode=%{
-  protected class SWIGByteArrayHelper 
-	{
-		public delegate void SWIGByteArrayDelegate(System.IntPtr data, int size);
-		static SWIGByteArrayDelegate bytearrayDelegate = new SWIGByteArrayDelegate(CreateByteArray);
-
-		[System.Runtime.InteropServices.DllImport("$dllimport", EntryPoint="SWIGRegisterByteArrayCallback_$module")]
-		public static extern void SWIGRegisterByteArrayCallback_mapscript(SWIGByteArrayDelegate bytearrayDelegate);
-
-		static void CreateByteArray(System.IntPtr data, int size)
-		{
-			arraybuffer = new byte[size];
-			System.Runtime.InteropServices.Marshal.Copy(data, arraybuffer, 0, size);
-		}
-
-		static SWIGByteArrayHelper() 
-		{
-			SWIGRegisterByteArrayCallback_$module(bytearrayDelegate);
-		}
-	}
-	protected static SWIGByteArrayHelper bytearrayHelper = new SWIGByteArrayHelper();
-	[System.ThreadStatic]
-	private static byte[] arraybuffer;
-
-	internal static byte[] GetBytes()
-	{
-		return arraybuffer;
-	}
-%}
-
-%insert(runtime) %{
-#ifdef __cplusplus
-extern "C" 
-#endif
-#ifdef SWIGEXPORT
-SWIGEXPORT void SWIGSTDCALL SWIGRegisterByteArrayCallback_$module(SWIG_CSharpByteArrayHelperCallback callback) {
-  SWIG_csharp_bytearray_callback = callback;
-}
-#else
-DllExport void SWIGSTDCALL SWIGRegisterByteArrayCallback_$module(SWIG_CSharpByteArrayHelperCallback callback) {
-  SWIG_csharp_bytearray_callback = callback;
-}
-#endif
-%}
-
-/* Typemaps for pattern array */
-%typemap(imtype) (double pattern[ANY]) "System.IntPtr"
-%typemap(cstype) (double pattern[ANY]) "double[]"
-%typemap(in) (double pattern[ANY]) %{ $1 = ($1_ltype)$input; %}
-%typemap(csin) (double pattern[ANY]) "$csinput"
-%typemap(csvarout, excode=SWIGEXCODE2) (double pattern[ANY]) %{
-    get {
-      System.IntPtr cPtr = $imcall;
-      double[] ret = new double[patternlength];
-      if (patternlength > 0) {       
-	        System.Runtime.InteropServices.Marshal.Copy(cPtr, ret, 0, patternlength);
-      }
-      $excode
-      return ret;
-    } 
-    set {
-      System.IntPtr cPtr = $imcall;
-      if (value.Length > 0) {       
-	        System.Runtime.InteropServices.Marshal.Copy(value, 0, cPtr, value.Length);
-      }
-      patternlength = value.Length;
-      $excode
-    }
-    %}
-%typemap(csvarin, excode="") (double pattern[ANY]) %{$excode%}
-
-/* Typemaps for int array */
-%typemap(imtype, out="System.IntPtr") int *panIndexes "int[]"
-%typemap(cstype) int *panIndexes %{int[]%}
-%typemap(in) int *panIndexes %{ $1 = ($1_ltype)$input; %}
-%typemap(csin) (int *panIndexes)  "$csinput"
-
-/* Typemaps for device handle */
-%typemap(imtype) (void* device)  %{System.IntPtr%}
-%typemap(cstype) (void* device) %{System.IntPtr%}
-%typemap(in) (void* device) %{ $1 = ($1_ltype)$input; %}
-%typemap(csin) (void* device)  "$csinput"
-
-/******************************************************************************
- * Preventing to take ownership of the memory when constructing objects 
- * with parent objects (causing nullreference exception, Bug 1743)
- *****************************************************************************/
-
-%typemap(csconstruct, excode=SWIGEXCODE) layerObj(mapObj map) %{: this($imcall, true, map) {
-  $excode
-}
-%}
-%typemap(csconstruct, excode=SWIGEXCODE) classObj(layerObj layer) %{: this($imcall, true, layer) {
-  $excode
-}
-%}
-%typemap(csconstruct, excode=SWIGEXCODE) styleObj(classObj parent_class) %{: this($imcall, true, parent_class) {
-  $excode
-}
-%}
-
-%typemap(csout, excode=SWIGEXCODE) classObj* getClass, layerObj* getLayer, layerObj *getLayerByName, styleObj* getStyle {
-    System.IntPtr cPtr = $imcall;
-    $csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $csclassname(cPtr, $owner, ThisOwn_false());$excode
-    return ret;
-  }
diff -pruN 8.0.1-5/mapscript/csharp/examples/HTMLtemplate.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/HTMLtemplate.cs
--- 8.0.1-5/mapscript/csharp/examples/HTMLtemplate.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/HTMLtemplate.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,60 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to show the usage of HTML templates.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using OSGeo.MapServer;
-
-/// <summary>
-/// A C# based mapscript example to show the usage of HTML templates.
-/// </summary>
-class HTMLTemplate
-{
-    public static void usage() 
-    { 
-	    Console.WriteLine("usage: HTMLTemplate {mapfile} {templatefile} {outdir}");
-	    System.Environment.Exit(-1);
-    }
-    		  
-    public static void Main(string[] args)
-    {
-        if (args.Length < 3) usage();
-        
-        mapObj map = new mapObj(args[0]);
-		map.legend.template = args[1];
-		map.web.imagepath = args[2];
-		map.web.imageurl = "";
-		string str = null;
-		string[] names = null, values = null;
-		names = new string[] {"map"};
-		values = new string[] { args[0] };
-		str = map.processLegendTemplate(names, values);
-		Console.Write(str);
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/RFC24.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/RFC24.cs
--- 8.0.1-5/mapscript/csharp/examples/RFC24.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/RFC24.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,503 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Tests for RFC24 implementation. 
- *           (http://mapserver.gis.umn.edu/development/rfc/ms-rfc-24/).
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *           Umberto Nicoletti, umberto.nicoletti@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using OSGeo.MapServer;
-
-/**
- * <p>Title: Mapscript RFC24 tests.</p>
- * <p>Description: Tests for RFC24 implementation. (http://mapserver.gis.umn.edu/development/rfc/ms-rfc-24/)</p>
- * @author Umberto Nicoletti (umberto.nicoletti@gmail.com)
- */
-
-class RFC24 {
-	string mapfile;
-	int fails = 0;
-
-	public static void Main(string[] args) {
-		new RFC24(args[0]).run();
-	}
-	
-	public RFC24(string mapfile) {
-		this.mapfile=mapfile;
-	}
-	
-	public void run() {
-		Console.WriteLine("Running RFC24");
-		testLayerObj();
-		testLayerObjDestroy();
-		testClassObj();
-		testClassObjDestroy();
-		testInsertLayerObj();
-		testInsertLayerObjDestroy();
-		testRemoveLayerObj();
-		testInsertClassObj();
-		testInsertClassObjDestroy();
-		testRemoveClassObj();
-		testGetLayerObj();
-		testGetLayerObjDestroy();
-		testGetLayerObjByName();
-		testGetLayerObjByNameDestroy();
-		testGetClassObj();
-		testGetClassObjDestroy();
-		try { testStyleObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testStyleObj exception:" + e.Message); }
-		testStyleObjDestroy();
-		try { testInsertStyleObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testInsertStyleObj exception:" + e.Message); }
-		testInsertStyleObjDestroy();
-		testRemoveStyleObj();
-		try { testGetStyleObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testGetStyleObj exception:" + e.Message); }
-		testGetStyleObjDestroy();
-
-		try { testlegendObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testlegendObj exception:" + e.Message); }
-		try { testreferenceMapObj(); } 
-		catch (Exception e) { Console.WriteLine("\t- testreferenceMapObj exception:" + e.Message); }
-		try { testwebObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testwebObj exception:" + e.Message); }
-		try { testqueryMapObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testqueryMapObj exception:" + e.Message); }
-		try { testmapObjHashTable(); }
-		catch (Exception e) { Console.WriteLine("\t- testmapObjHashTable exception:" + e.Message); }
-		try { testsymbolSetObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testsymbolSetObj exception:" + e.Message); }
-		try { testimageObj(); }
-		catch (Exception e) { Console.WriteLine("\t- testimageObj exception:" + e.Message); }
-
-		if (fails > 0)
-			Console.WriteLine("\n     " + fails + " tests were FAILED!!!\n");
-
-		Console.WriteLine("Finished RFC24");
-	}
-
-	public void testlegendObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		legendObj legend = map.legend;
-		legend.template = "This is a sample!";
-
-		map=null;
-		gc();	
-		assert(legend.template == "This is a sample!", "testlegendObj");
-	}
-
-	public void testmapObjHashTable() 
-	{
-		mapObj map=new mapObj(mapfile);
-		hashTableObj configoptions = map.configoptions;
-		configoptions.set("key", "test value");
-
-		map=null;
-		gc();
-	
-		assert(configoptions.get("key", "") == "test value", "testmapObjHashTable");
-	}
-
-	public void testsymbolSetObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		symbolSetObj symbolset = map.symbolset;
-		symbolset.filename = "filename";
-
-		map=null;
-		gc();
-	
-		assert(symbolset.filename == "filename", "testsymbolSetObj");
-	}
-
-	public void testreferenceMapObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		referenceMapObj refmap = map.reference;
-		refmap.markername = "This is a sample!";
-
-		map=null;
-		gc();
-	    assert(refmap.markername == "This is a sample!", "testreferenceMapObj");
-	}
-
-	public void testwebObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		webObj web = map.web;
-		web.template = "This is a sample!";
-
-		map=null;
-		gc();
-		assert(web.template == "This is a sample!", "testwebObj");
-	}
-
-	public void testqueryMapObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		queryMapObj querymap = map.querymap;
-		querymap.color.setHex( "#13ba88" );
-
-		map=null;
-		gc();
-		assert(querymap.color.toHex() == "#13ba88", "testqueryMapObj");
-	}
-
-	public void testimageObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		imageObj image = map.draw();
-		outputFormatObj format = image.format;
-		format.setOption( "INTERLACE", "OFF");
-
-		map=null;
-		gc();
-		assert(format.getOption("INTERLACE", "") == "OFF", "testimageObj");
-	}
-	
-	public void testLayerObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=new layerObj(map);
-
-		map=null;
-		gc();
-		assertNotNull(newLayer.map, "testLayerObj");
-		assert(newLayer.refcount == 2, "testLayerObj refcount");
-	}
-
-	public void testLayerObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=new layerObj(map);
-		layerObj reference = map.getLayer(map.numlayers-1);
-
-		assert(newLayer.refcount == 3, "testLayerObjDestroy precondition");
-		newLayer.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
-		newLayer = null;
-		gc();
-		assert(reference.refcount == 2, "testLayerObjDestroy");
-	}
-	
-	public void testInsertLayerObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=new layerObj(null);
-		map.insertLayer(newLayer,-1);
-		
-		map=null;
-		gc();
-		assertNotNull(newLayer.map, "testInsertLayerObj");
-		assert(newLayer.refcount == 2, "testInsertLayerObj refcount");
-	}
-
-	public void testInsertLayerObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=new layerObj(null);
-		map.insertLayer(newLayer,0);
-		layerObj reference = map.getLayer(0);
-
-		assert(newLayer.refcount == 3, "testInsertLayerObjDestroy precondition");
-		newLayer.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
-		newLayer=null;
-		gc();
-		assert(reference.refcount == 2, "testInsertLayerObjDestroy");
-	}
-
-	public void testRemoveLayerObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=new layerObj(null);
-		map.insertLayer(newLayer,0);
-		map.removeLayer(0);
-
-		map=null;
-		gc();
-		assert(newLayer.refcount == 1, "testRemoveLayerObj");
-	}
-	
-	public void testGetLayerObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=map.getLayer(1);
-		
-		map=null;
-		gc();
-		assertNotNull(newLayer.map, "testGetLayerObj");
-		assert(newLayer.refcount == 2, "testGetLayerObj refcount");
-	}
-
-	public void testGetLayerObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=map.getLayer(1);
-		layerObj reference = map.getLayer(1);
-		
-		assert(newLayer.refcount == 3, "testGetLayerObjDestroy precondition");
-		//newLayer.Dispose(); // force the destruction needed for Mono on Windows
-		newLayer=null;
-		gc();
-		assert(reference.refcount == 2, "testGetLayerObjDestroy");
-	}
-
-	public void testGetLayerObjByName() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=map.getLayerByName("POLYGON");
-		
-		map=null;
-		gc();
-		assertNotNull(newLayer.map, "testGetLayerObjByName");
-		assert(newLayer.refcount == 2, "testGetLayerObjByName refcount");
-	}
-
-	public void testGetLayerObjByNameDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=map.getLayerByName("POLYGON");
-		layerObj reference=map.getLayerByName("POLYGON");
-		
-		assert(newLayer.refcount == 3, "testGetLayerObjByNameDestroy precondition");
-		//newLayer.Dispose(); // force the destruction needed for Mono on Windows
-		newLayer=null;
-		gc();
-		assert(reference.refcount == 2, "testGetLayerObjByNameDestroy");
-	}
-
-	public void testClassObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=new classObj(layer);
-		
-		map=null; layer=null;
-		gc();
-		assertNotNull(newClass.layer, "testClassObj");
-		assert(newClass.refcount == 2, "testClassObj refcount");
-	}
-
-	public void testClassObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=new classObj(layer);
-		classObj reference=layer.getClass(layer.numclasses-1);
-		
-		assert(newClass.refcount == 3, "testClassObjDestroy precondition");
-		newClass.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
-		map=null; layer=null; newClass=null;
-		gc();
-		assert(reference.refcount == 2, "testClassObjDestroy");
-	}
-
-	public void testStyleObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj classobj=layer.getClass(0);
-		styleObj newStyle=new styleObj(classobj);
-		
-		map=null; layer=null; classobj=null;
-		gc();
-		assert(newStyle.refcount == 2, "testStyleObj");
-	}
-
-	public void testStyleObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj classobj=layer.getClass(0);
-		styleObj newStyle=new styleObj(classobj);
-		styleObj reference=classobj.getStyle(classobj.numstyles-1);
-		
-		assert(newStyle.refcount == 3, "testStyleObjDestroy");
-		newStyle.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
-		map=null; layer=null; classobj=null; newStyle=null;
-		gc();
-		assert(reference.refcount == 2, "testStyleObjDestroy");
-	}
-
-	public void testInsertClassObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=new classObj(null);
-		layer.insertClass(newClass,-1);
-		
-		assertNotNull(newClass.layer, "testInsertClassObj precondition");
-		map=null; layer=null;
-		gc();
-		assertNotNull(newClass.layer, "testInsertClassObj");
-		assert(newClass.refcount == 2, "testInsertClassObj refcount");
-	}
-
-	public void testRemoveClassObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=new classObj(null);
-		layer.insertClass(newClass,0);
-		layer.removeClass(0);
-		
-		map=null; layer=null;
-		gc();
-		assert(newClass.refcount == 1, "testRemoveClassObj");
-	}
-
-	public void testInsertClassObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=new classObj(null);
-		layer.insertClass(newClass,0);
-		classObj reference = layer.getClass(0);
-
-		assert(newClass.refcount == 3, "testInsertClassObjDestroy precondition");
-		newClass.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
-		map=null; layer=null; newClass=null;
-		gc();
-		assert(reference.refcount == 2, "testInsertClassObjDestroy");
-	}
-
-	public void testInsertStyleObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj classobj=layer.getClass(0);
-		styleObj newStyle = new styleObj(null);
-		classobj.insertStyle(newStyle,-1);
-		
-		assert(newStyle.refcount == 2, "testInsertStyleObj precondition");
-		map=null; layer=null; classobj=null;
-		gc();
-		assert(newStyle.refcount == 2, "testInsertStyleObj");
-	}
-
-	public void testRemoveStyleObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj classobj=layer.getClass(0);
-		styleObj newStyle = new styleObj(null);
-		classobj.insertStyle(newStyle,0);
-		classobj.removeStyle(0);
-		
-		map=null; layer=null; classobj=null;
-		gc();
-		assert(newStyle.refcount == 1, "testRemoveStyleObj");
-	}
-
-	public void testInsertStyleObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj classobj=layer.getClass(0);
-		styleObj newStyle = new styleObj(null);
-		classobj.insertStyle(newStyle,0);
-		styleObj reference = classobj.getStyle(0);
-		
-		assert(newStyle.refcount == 3, "testInsertStyleObjDestroy precondition");
-		newStyle.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
-		map=null; layer=null; classobj=null; newStyle=null;
-		gc();
-		assert(reference.refcount == 2, "testInsertStyleObjDestroy");
-	}
-
-	public void testGetClassObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=layer.getClass(0);
-		
-		map=null; layer=null;
-		gc();
-		assertNotNull(newClass.layer, "testGetClassObj");
-		assert(newClass.refcount == 2, "testGetClassObj refcount");
-	}
-
-	public void testGetClassObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=layer.getClass(0);
-		classObj reference = layer.getClass(0);
-		
-		assert(newClass.refcount == 3, "testGetClassObjDestroy precondition");
-		map=null; layer=null; newClass=null;
-		gc();
-		assert(reference.refcount == 2, "testGetClassObjDestroy");
-	}
-
-	public void testGetStyleObj() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj classobj=layer.getClass(0);
-		styleObj style=classobj.getStyle(0);
-		
-		map=null; layer=null; classobj=null;
-		gc();
-		assert(style.refcount == 2, "testGetStyleObj");
-	}
-
-	public void testGetStyleObjDestroy() 
-	{
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj classobj=layer.getClass(0);
-		styleObj style=classobj.getStyle(0);
-		styleObj reference=classobj.getStyle(0);
-		
-		assert(style.refcount == 3, "testGetStyleObjDestroy precondition");
-		map=null; layer=null; classobj=null; style=null;
-		gc();
-		assert(reference.refcount == 2, "testGetStyleObjDestroy");
-	}
-
-	public void gc() {
-		for (int i=0; i<100; i++) {
-			GC.Collect();
-			GC.WaitForPendingFinalizers();
-		}
-	}
-	
-	public void assertNotNull(object o, string test) {
-		if ( o != null )
-			Console.WriteLine("\t- "+test+" PASSED");
-		else
-		{
-			Console.WriteLine("\t- "+test+" FAILED");
-			++fails;
-		}
-	}
-
-	public void assert(bool val, string test) 
-	{
-		if ( val )
-			Console.WriteLine("\t- "+test+" PASSED");
-		else
-		{
-			Console.WriteLine("\t- "+test+" FAILED");
-			++fails;
-		}
-	}
-}
diff -pruN 8.0.1-5/mapscript/csharp/examples/drawmap.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmap.cs
--- 8.0.1-5/mapscript/csharp/examples/drawmap.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmap.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to create an image given a mapfile.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *           Yew K Choo, ykchoo@geozervice.com 
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using OSGeo.MapServer;	
-
-/// <summary>
-/// A C# based mapscript mapscript example to create an image given a mapfile.
-/// </summary>
-class DrawMap
-{
-  public static void usage() 
-  { 
-	Console.WriteLine("usage: DrawMap {mapfile} {outfile} {imagetype optional}");
-	System.Environment.Exit(-1);
-  }
-		  
-  public static void Main(string[] args)
-  {
-    Console.WriteLine("");
-	if (args.Length < 2) usage();
-    
-	mapObj m_obj = new mapObj(args[0]);
-
-	if (args.Length >= 3) 
-	{
-      Console.WriteLine("Setting the imagetype to " + args[2]);
-	  m_obj.setImageType(args[2]);
-	}
-
-	Console.WriteLine ("# Map layers " + m_obj.numlayers + "; Map name = " + m_obj.name);	
-	for (int i=0; i<m_obj.numlayers; i++) 
-	{
-	  Console.WriteLine("Layer [" + i + "] name: " + m_obj.getLayer(i).name);
-	}
-	
-    imageObj i_obj = m_obj.draw();
-	Console.WriteLine("Image URL = " + i_obj.imageurl + "; Image path = " + i_obj.imagepath);    
-	Console.WriteLine("Image height = " + i_obj.height + "; width = " + i_obj.width); 
-	try 
-	{
-	  i_obj.save(args[1],m_obj);
-    } 
-	catch (Exception ex) 
-	{
-                Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
-                Console.WriteLine( 
-                    "\nHelpLink ---\n{0}", ex.HelpLink );
-                Console.WriteLine( "\nSource ---\n{0}", ex.Source );
-                Console.WriteLine( 
-                    "\nStackTrace ---\n{0}", ex.StackTrace );
-                Console.WriteLine( 
-                    "\nTargetSite ---\n{0}", ex.TargetSite );	}	
-  }
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/drawmapDirect.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapDirect.cs
--- 8.0.1-5/mapscript/csharp/examples/drawmapDirect.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapDirect.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,100 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to draw the map directly onto a GDI
- *           device context.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using System.Drawing;
-using System.Drawing.Imaging;
-using OSGeo.MapServer;	
-
-/// <summary>
-/// A C# based mapscript example to draw the map directly onto a GDI device context.
-/// </summary>
-class DrawMap
-{
-  public static void usage() 
-  { 
-	Console.WriteLine("usage: DrawMapDirect {mapfile} {outfile}");
-	System.Environment.Exit(-1);
-  }
-		  
-  public static void Main(string[] args)
-  {
-    Console.WriteLine("");
-	if (args.Length < 2) usage();
-    
-	mapObj map = new mapObj(args[0]);
-
-    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
-    for (int i = 0; i < map.numlayers; i++) 
-	{
-        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
-	}
-
-    try
-    {
-        // Create the output format
-        outputFormatObj of = new outputFormatObj("CAIRO/WINGDI", "cairowinGDI");
-        map.appendOutputFormat(of);
-        map.selectOutputFormat("cairowinGDI");
-
-        Bitmap mapImage = new Bitmap(map.width, map.height, PixelFormat.Format32bppRgb);
-
-        using (Graphics g = Graphics.FromImage(mapImage))
-        {
-            IntPtr hdc = g.GetHdc();
-            try
-            {
-                // Attach the device to the outputformat for drawing
-                of.attachDevice(hdc);
-                // Drawing directly to the GDI context
-                using (imageObj image = map.draw()) { };
-            }
-            finally
-            {
-                of.attachDevice(IntPtr.Zero);
-                g.ReleaseHdc(hdc);
-            }
-        }
-
-        mapImage.Save(args[1]);
-    } 
-	catch (Exception ex) 
-	{
-                Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
-                Console.WriteLine( 
-                    "\nHelpLink ---\n{0}", ex.HelpLink );
-                Console.WriteLine( "\nSource ---\n{0}", ex.Source );
-                Console.WriteLine( 
-                    "\nStackTrace ---\n{0}", ex.StackTrace );
-                Console.WriteLine( 
-                    "\nTargetSite ---\n{0}", ex.TargetSite );	}	
-  }
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/drawmapDirectPrint.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapDirectPrint.cs
--- 8.0.1-5/mapscript/csharp/examples/drawmapDirectPrint.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapDirectPrint.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,116 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to draw the map directly onto a GDI
- *           printing device context.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using System.Drawing;
-using System.Drawing.Printing;
-using OSGeo.MapServer;	
-
-/// <summary>
-/// A C# based mapscript example to draw the map directly onto a GDI printing device context.
-/// </summary>
-class DrawMap
-{
-  public static void usage() 
-  { 
-	Console.WriteLine("usage: DrawMapDirectPrint {mapfile} {printername}");
-	System.Environment.Exit(-1);
-  }
-
-  static mapObj map;
-		  
-  public static void Main(string[] args)
-  {
-    Console.WriteLine("");
-	if (args.Length < 2) usage();
-    
-	map = new mapObj(args[0]);
-
-    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
-    for (int i = 0; i < map.numlayers; i++) 
-    {
-        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
-    }
-
-    try
-    {
-        PrintDocument doc = new PrintDocument();
-
-        doc.PrintPage += new PrintPageEventHandler(doc_PrintPage);
-
-        // Specify the printer to use.
-        doc.PrinterSettings.PrinterName = args[1];
-
-        doc.Print();
-    } 
-    catch (Exception ex) 
-    {
-                Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
-                Console.WriteLine( 
-                    "\nHelpLink ---\n{0}", ex.HelpLink );
-                Console.WriteLine( "\nSource ---\n{0}", ex.Source );
-                Console.WriteLine( 
-                    "\nStackTrace ---\n{0}", ex.StackTrace );
-                Console.WriteLine( 
-                    "\nTargetSite ---\n{0}", ex.TargetSite );	}	
-    }
-
-    static void doc_PrintPage(object sender, PrintPageEventArgs e)
-    {
-        // Create the output format
-        outputFormatObj of = new outputFormatObj("CAIRO/WINGDIPRINT", "cairowinGDIPrint");
-        map.appendOutputFormat(of);
-        map.selectOutputFormat("cairowinGDIPrint");
-        map.resolution = e.Graphics.DpiX;
-        Console.WriteLine("map resolution = " + map.resolution.ToString() + "DPI  defresolution = " + map.defresolution.ToString() + " DPI");
-        // Calculating the desired image size to cover the entire area; 
-        map.width = Convert.ToInt32(e.PageBounds.Width * e.Graphics.DpiX / 100);
-        map.height = Convert.ToInt32(e.PageBounds.Height * e.Graphics.DpiY / 100);
-
-        Console.WriteLine("map size = " + map.width.ToString() + " * " + map.height.ToString() + " pixels");
-
-        IntPtr hdc = e.Graphics.GetHdc();
-        try
-        {
-            // Attach the device to the outputformat for drawing
-            of.attachDevice(hdc);
-            // Drawing directly to the GDI context
-            using (imageObj image = map.draw()) { };
-        }
-        finally
-        {
-            of.attachDevice(IntPtr.Zero);
-            e.Graphics.ReleaseHdc(hdc);
-        }
-
-        e.HasMorePages = false;
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/drawmapGDIPlus.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapGDIPlus.cs
--- 8.0.1-5/mapscript/csharp/examples/drawmapGDIPlus.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapGDIPlus.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,97 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to draw the map directly onto a GDI+ bitmap.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using System.Diagnostics;
-using System.Drawing;
-using System.Drawing.Imaging;
-using OSGeo.MapServer;	
-
-/// <summary>
-/// A C# based mapscript example to draw the map directly onto a GDI+ bitmap.
-/// </summary>
-class DrawMap
-{
-  public static void usage() 
-  { 
-	Console.WriteLine("usage: DrawMapGDIPlus {mapfile} {outfile}");
-	System.Environment.Exit(-1);
-  }
-		  
-  public static void Main(string[] args)
-  {
-    Console.WriteLine("");
-	if (args.Length < 2) usage();
-    
-	mapObj map = new mapObj(args[0]);
-
-    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
-    for (int i = 0; i < map.numlayers; i++) 
-	{
-        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
-	}
-
-    try
-    {
-        Bitmap mapImage = new Bitmap(map.width, map.height, PixelFormat.Format32bppRgb);
-        Stopwatch stopwatch = new Stopwatch();
-        stopwatch.Start();
-        using (imageObj image = map.draw())
-        {
-            BitmapData bitmapData = mapImage.LockBits(new Rectangle(0, 0, image.width, image.height), ImageLockMode.ReadWrite, PixelFormat.Format32bppRgb);
-            try
-            {
-                if (image.getRawPixels(bitmapData.Scan0) == (int)MS_RETURN_VALUE.MS_FAILURE)
-                {
-                    Console.WriteLine("Unable to get image contents");
-                }
-            }
-            finally
-            {
-                mapImage.UnlockBits(bitmapData);
-            }
-
-            Console.WriteLine("Rendering time: " + stopwatch.ElapsedMilliseconds + "ms");
-
-            mapImage.Save(args[1]);
-        }    
-    } 
-	catch (Exception ex) 
-	{
-        Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
-        Console.WriteLine( 
-            "\nHelpLink ---\n{0}", ex.HelpLink );
-        Console.WriteLine( "\nSource ---\n{0}", ex.Source );
-        Console.WriteLine( 
-            "\nStackTrace ---\n{0}", ex.StackTrace );
-        Console.WriteLine( 
-            "\nTargetSite ---\n{0}", ex.TargetSite );	}	
-  }
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/drawmapWPF.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapWPF.cs
--- 8.0.1-5/mapscript/csharp/examples/drawmapWPF.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawmapWPF.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,109 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to draw the map directly onto a WPF image.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using System.IO;
-using System.Diagnostics;
-using System.Windows;
-using System.Windows.Media;
-using System.Windows.Media.Imaging;
-using OSGeo.MapServer;	
-
-/// <summary>
-/// A C# based mapscript example to draw the map directly onto a WPF image.
-/// </summary>
-class DrawMap
-{
-  public static void usage() 
-  { 
-	Console.WriteLine("usage: DrawMapWPF {mapfile} {outfile}");
-	System.Environment.Exit(-1);
-  }
-		  
-  public static void Main(string[] args)
-  {
-    Console.WriteLine("");
-	if (args.Length < 2) usage();
-    
-	mapObj map = new mapObj(args[0]);
-
-    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
-    for (int i = 0; i < map.numlayers; i++) 
-	{
-        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
-	}
-
-    try
-    {
-        WriteableBitmap mapImage = new WriteableBitmap(map.width, map.height, 96, 96, PixelFormats.Bgr32, null);
-        Stopwatch stopwatch = new Stopwatch();
-        stopwatch.Start();
-        using (imageObj image = map.draw())
-        {
-            // Reserve the back buffer for updates.
-            mapImage.Lock();
-            try
-            {
-                if (image.getRawPixels(mapImage.BackBuffer) == (int)MS_RETURN_VALUE.MS_FAILURE)
-                {
-                    Console.WriteLine("Unable to get image contents");
-                }
-                // Specify the area of the bitmap that changed.
-                mapImage.AddDirtyRect(new Int32Rect(0, 0, map.width, map.height));
-            }
-            finally
-            {
-                // Release the back buffer and make it available for display.
-                mapImage.Unlock();
-            }
-
-            Console.WriteLine("Rendering time: " + stopwatch.ElapsedMilliseconds + "ms");
-
-            // Save the bitmap into a file.
-            using (FileStream stream = new FileStream(args[1], FileMode.Create))
-            {
-                PngBitmapEncoder encoder = new PngBitmapEncoder();
-                encoder.Frames.Add(BitmapFrame.Create(mapImage));
-                encoder.Save(stream);
-            }
-        }    
-    } 
-	catch (Exception ex) 
-	{
-        Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
-        Console.WriteLine( 
-            "\nHelpLink ---\n{0}", ex.HelpLink );
-        Console.WriteLine( "\nSource ---\n{0}", ex.Source );
-        Console.WriteLine( 
-            "\nStackTrace ---\n{0}", ex.StackTrace );
-        Console.WriteLine( 
-            "\nTargetSite ---\n{0}", ex.TargetSite );	}	
-  }
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/drawquery.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawquery.cs
--- 8.0.1-5/mapscript/csharp/examples/drawquery.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/drawquery.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,178 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to use the atribute query and 
- *           highlight the results.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using OSGeo.MapServer;
-
-/// <summary>
-/// A C# based mapscript example to use the arribute query an highlight the results.
-/// </summary>
-class DrawQuery
-{
-    public static void usage() 
-    { 
-	    Console.WriteLine("usage: QueryMap {mapfile} {query string} {outfile} {-zoom}");
-	    System.Environment.Exit(-1);
-    }
-    		  
-    public static void Main(string[] args)
-    {
-        Console.WriteLine("");
-		if (args.Length < 3 || args.Length > 4) usage();
-        
-        bool ZoomToResults = (args.Length == 4 && args[3] == "-zoom");
-
-	    mapObj map = new mapObj(args[0]);	
-	    Console.WriteLine ("# Map layers " + map.numlayers + "; Map name = " + map.name);
-        
-        QueryByAttribute(args[1], map, ZoomToResults);
-
-        map.querymap.status = mapscript.MS_ON;
-        map.querymap.color.setRGB(0,0,255,255);
-        map.querymap.style = (int)MS_QUERYMAP_STYLES.MS_HILITE;
-
-        try 
-        {
-            imageObj image = map.drawQuery();
-            image.save(args[2],map);
-        } 
-        catch (Exception ex) 
-        {
-            Console.WriteLine( "QueryMap: ", ex.Message );
-        }
-    }
-
-    private static bool IsLayerQueryable(layerObj layer)
-    {
-        if ( layer.type == MS_LAYER_TYPE.MS_LAYER_TILEINDEX )
-            return false;
-
-        if(layer.template != null && layer.template.Length > 0) return true;
-
-        for(int i=0; i<layer.numclasses; i++) 
-        {
-            if(layer.getClass(i).template != null && layer.getClass(i).template.Length > 0)
-                                                        return true;
-        }
-        return false;
-    }
-
-    public static void QueryByAttribute(string qstring, mapObj map, bool zoomToResults)
-    {
-        Console.WriteLine("\nPerforming QueryByAttribute:");
-        try
-        {
-        	layerObj layer;
-            rectObj query_bounds = null;
-            for (int i = 0; i < map.numlayers; i++)
-            {
-                layer = map.getLayer(i);
-                if (layer.connection != null && IsLayerQueryable(layer))
-                {
-                    Console.WriteLine("Layer [" + i + "] name: " + layer.name);
-                    BuildQuery(layer, qstring);
-                    // zoom to the query results
-                    using (resultCacheObj results = layer.getResults())
-                    {
-                        if (results != null && results.numresults > 0)
-                        {
-                            // calculating the extent of the results
-                            if (query_bounds == null)
-                                query_bounds = new rectObj(results.bounds.minx, results.bounds.miny,
-                                    results.bounds.maxx, results.bounds.maxy,0);
-                            else
-                            {
-                                if (results.bounds.minx < query_bounds.minx) query_bounds.minx = results.bounds.minx;
-                                if (results.bounds.miny < query_bounds.miny) query_bounds.miny = results.bounds.miny;
-                                if (results.bounds.maxx > query_bounds.maxx) query_bounds.maxx = results.bounds.maxx;
-                                if (results.bounds.maxy > query_bounds.maxy) query_bounds.maxy = results.bounds.maxy;
-                            }
-                        }
-                    }
-                }
-            }
-            // setting the map extent to the result bounds
-			if (query_bounds != null) 
-			{
-				if (zoomToResults) 
-				{
-					map.setExtent(query_bounds.minx, query_bounds.miny, query_bounds.maxx, query_bounds.maxy);
-					map.scaleExtent(1.2, 0, 0); // increasing the visible area
-					Console.WriteLine("Current map scale: 1:" + (int)map.scaledenom);
-				}
-			}
-			else
-				Console.WriteLine("The query returned 0 results ...");
-        }
-        catch (Exception e)
-        {
-        	Console.WriteLine("QueryByAttribute: " + e.Message);
-        }
-    }
-
-    private static void BuildQuery(layerObj layer, string qstring)
-    {
-        if (layer != null && layer.map != null)
-        {
-            /*layer.open();
-            string qs = "";
-            string att = "";
-            for (int i=0; i < layer.numitems; i++)
-            {
-                if (qs == "")
-                {
-                    qs = "(";
-                    att = layer.getItem(i);
-                }
-                else
-                {
-                    qs += " OR ";
-                }
-                qs += "'[" + layer.getItem(i) + "]'='" + qstring + "'";
-            }
-            qs += ")";
-            layer.close();*/
-            string qs = qstring;
-            string att = null;
-
-            Console.WriteLine("Query string: " + qs);
-            
-            try
-            {
-                layer.queryByAttributes(layer.map, att, qs, 1);
-            }
-            catch (Exception e)
-            {
-                Console.WriteLine("BuildQuery: " + e.Message);
-            }
-        }
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/getbytes.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/getbytes.cs
--- 8.0.1-5/mapscript/csharp/examples/getbytes.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/getbytes.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based mapscript example to show the usage of 
- *           imageObj.getBytes.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using System.Drawing;
-using System.IO;
-using OSGeo.MapServer;
-
-/// <summary>
-/// A C# based mapscript example to show the usage of imageObj.getBytes.
-/// </summary>
-class GetBytes
-{
-    public static void usage() 
-    { 
-	    Console.WriteLine("usage: getbytes {mapfile} {outfile}");
-	    System.Environment.Exit(-1);
-    }
-    		  
-    public static void Main(string[] args)
-    {
-        if (args.Length < 2) usage();
-        
-        try 
-        {
-			mapObj map = new mapObj(args[0]);
-
-			using(imageObj image = map.draw())
-			{
-				// solution 1
-				Console.WriteLine ("Drawing map: '" + map.name + "' using imageObj.getBytes");
-				
-				byte[] img = image.getBytes();
-				using (MemoryStream ms = new MemoryStream(img))
-				{
-					Image mapimage = Image.FromStream(ms);
-					mapimage.Save(args[1]);
-				}
-				
-				// solution 2
-				Console.WriteLine ("Drawing map: '" + map.name + "' using imageObj.write");
-
-				using (FileStream fs = File.Open("_" + args[1], FileMode.OpenOrCreate, FileAccess.ReadWrite))
-				{
-					image.write(fs);
-				}
-			}
-        } 
-        catch (Exception ex) 
-        {
-            Console.WriteLine( "GetBytes: ", ex.Message );
-        }
-    }
-
-}
-
diff -pruN 8.0.1-5/mapscript/csharp/examples/inline.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/inline.cs
--- 8.0.1-5/mapscript/csharp/examples/inline.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/inline.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,136 +0,0 @@
-/******************************************************************************
- * $Id: shapeinfo.cs 7418 2008-02-29 00:02:49Z nsavard $
- *
- * Project:  MapServer
- * Purpose:  A C# based based mapscript example to dump information from 
- *           a shapefile.
- * Author:   Tamas Szekeres, szekerest@gmail.com 
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using System.Collections;
-using OSGeo.MapServer;
-
-/// <summary>
-/// A MapScript application for creating inline layers with annotations.
-/// </summary> 
-class Inline {
-
-  public static void usage()
-  {
-      Console.WriteLine("usage: inline [outformat] [outfile]");
-      System.Environment.Exit(-1);
-  }
-  	
-  public static void Main(string[] args) 
-  {
-
-      if (args.Length < 2) usage();
-
-      // creating a new map from scratch
-      mapObj map = new mapObj(null);
-      // adding a layer
-      layerObj layer = new layerObj(map);
-      layer.type = MS_LAYER_TYPE.MS_LAYER_POINT;
-      layer.status = mapscript.MS_ON;
-      layer.connectiontype = MS_CONNECTION_TYPE.MS_INLINE;
-      // define the attribute names from the inline layer
-      layer.addProcessing("ITEMS=attribute1,attribute2,attribute3");
-      // define the class
-      classObj classobj = new classObj(layer);
-      classobj.template = "query";   // making the layer queryable
-      // setting up the text based on multiple attributes
-      classobj.setText("('Shape:' + '[attribute1]' + ' Color:' + '[attribute2]' + ' Size:' + '[attribute3]')");
-      // define the label
-      classobj.label.outlinecolor = new colorObj(255, 255, 255, 0);
-      classobj.label.force = mapscript.MS_TRUE;
-      classobj.label.size = (double)MS_BITMAP_FONT_SIZES.MS_MEDIUM;
-      classobj.label.position = (int)MS_POSITIONS_ENUM.MS_LC;
-      classobj.label.wrap = ' ';
-      // set up attribute binding
-      classobj.label.setBinding((int)MS_LABEL_BINDING_ENUM.MS_LABEL_BINDING_COLOR, "attribute2");
-      // define the style
-      styleObj style = new styleObj(classobj);
-      style.color = new colorObj(0, 255, 255, 0);
-      style.setBinding((int)MS_STYLE_BINDING_ENUM.MS_STYLE_BINDING_COLOR, "attribute2");
-      style.setBinding((int)MS_STYLE_BINDING_ENUM.MS_STYLE_BINDING_SIZE, "attribute3");
-
-      Random rand = new Random((int)DateTime.Now.ToFileTime()); ;
-
-      // creating the shapes
-      for (int i = 0; i < 10; i++)
-      {
-          shapeObj shape = new shapeObj((int)MS_SHAPE_TYPE.MS_SHAPE_POINT);
-
-          // setting the shape attributes
-          shape.initValues(4);
-          shape.setValue(0, Convert.ToString(i));
-          shape.setValue(1, new colorObj(rand.Next(255), rand.Next(255), rand.Next(255), 0).toHex());
-          shape.setValue(2, Convert.ToString(rand.Next(25) + 5));
-
-          lineObj line = new lineObj();
-          line.add(new pointObj(rand.Next(400) + 25, rand.Next(400) + 25, 0, 0));
-          shape.add(line);
-          layer.addFeature(shape);
-      }
-
-      map.width = 500;
-      map.height = 500;
-      map.setExtent(0,0,450,450);
-      map.selectOutputFormat(args[0]);
-      imageObj image = map.draw();
-      image.save(args[1], map);
-
-      //perform a query
-      layer.queryByRect(map, new rectObj(0, 0, 450, 450, 0));
-
-      resultObj res;
-      shapeObj feature;
-      using (resultCacheObj results = layer.getResults())
-      {
-          if (results != null && results.numresults > 0)
-          {
-              // extracting the features found
-              layer.open();
-              for (int j = 0; j < results.numresults; j++)
-              {
-                  res = results.getResult(j);
-                  feature = layer.getShape(res);
-                  if (feature != null)
-                  {
-                      Console.WriteLine("  Feature: shapeindex=" + res.shapeindex + " tileindex=" + res.tileindex);
-                      for (int k = 0; k < layer.numitems; k++)
-                      {
-                          Console.Write("     " + layer.getItem(k));
-                          Console.Write(" = ");
-                          Console.Write(feature.getValue(k));
-                          Console.WriteLine();
-                      }
-                  }
-              }
-              layer.close();
-          }
-      }
-  }
-}
\ No newline at end of file
diff -pruN 8.0.1-5/mapscript/csharp/examples/shapeinfo.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/shapeinfo.cs
--- 8.0.1-5/mapscript/csharp/examples/shapeinfo.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/shapeinfo.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,63 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based based mapscript example to dump information from 
- *           a shapefile.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *           Yew K Choo, ykchoo@geozervice.com 
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using System.Collections;
-using OSGeo.MapServer;
-
-/// <summary>
-/// A C# based mapscript mapscript to dump information from a shapefile.
-/// </summary> 
-class ShapeInfo {
-	
-  public static void usage() 
-  { 
-	Console.WriteLine("usage: shapeinfo {shapefile}");
-	System.Environment.Exit(-1);
-  }
-  
-  	
-  public static void Main(string[] args) {
-	 
-	if (args.Length != 1) usage();
-
-	Hashtable ht = new Hashtable();
-	ht.Add(1,"point");	
-	ht.Add(3,"arc");	
-	ht.Add(5,"polygon");
-	ht.Add(8,"multipoint");
-		
-    shapefileObj shpObj = new shapefileObj(args[0],-1); 
-    Console.WriteLine ("ShapeType = " + ht[shpObj.type]);
-    Console.WriteLine ("Num shapes = " + shpObj.numshapes);
-    Console.WriteLine ("(xmin, ymin) = (" + shpObj.bounds.minx + "," + shpObj.bounds.miny + ") (xmax, ymax) = (" + shpObj.bounds.maxx + "," + shpObj.bounds.maxy + ")");
-  }
-}
\ No newline at end of file
diff -pruN 8.0.1-5/mapscript/csharp/examples/shpdump.cs 8.2.0~beta1-1~exp1/mapscript/csharp/examples/shpdump.cs
--- 8.0.1-5/mapscript/csharp/examples/shpdump.cs	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/examples/shpdump.cs	1970-01-01 00:00:00.000000000 +0000
@@ -1,68 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  A C# based based mapscript example to dump information from 
- *           a shapefile.
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *           Yew K Choo, ykchoo@geozervice.com 
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-using System;
-using OSGeo.MapServer;
-
-/// <summary>
-/// A C# based mapscript mapscript to dump information from a shapefile.
-/// </summary>  
-class ShapeDump {
-  public static void usage() 
-  { 
-	Console.WriteLine("usage: shpdump {shapefile}");
-	System.Environment.Exit(-1);
-  }
-  	
-  public static void Main(string[] args) {
-
-	if (args.Length != 1) usage();
-		  
- 	shapefileObj sf_obj = new shapefileObj(args[0],-1); 
-	shapeObj s_obj = new shapeObj(-1);
-	for (int i=0; i<sf_obj.numshapes; i++) 
-	{
-	  sf_obj.get(i, s_obj);
-	  Console.WriteLine("Shape " + i + " has " + s_obj.numlines + " part(s)");
-	  Console.WriteLine("bounds (" + s_obj.bounds.minx + ", " +  s_obj.bounds.miny + ") (" + s_obj.bounds.maxx + ", " + s_obj.bounds.maxy + ")" );
-	  for(int j=0; j<s_obj.numlines; j++) 
-	  {
-		lineObj l_obj = s_obj.get(j);
-		Console.WriteLine("Part " + j + " has " + l_obj.numpoints + " points.");
-                    
-		for(int k=0; k < l_obj.numpoints; k++) {
-		  pointObj p_obj = l_obj.get(k);                     
-          Console.WriteLine(k +": " + p_obj.x + ", " + p_obj.y);							
-		}
-	  }	  
-    }
-  }
-}
\ No newline at end of file
Binary files 8.0.1-5/mapscript/csharp/mapscript.snk and 8.2.0~beta1-1~exp1/mapscript/csharp/mapscript.snk differ
diff -pruN 8.0.1-5/mapscript/csharp/run_test.sh 8.2.0~beta1-1~exp1/mapscript/csharp/run_test.sh
--- 8.0.1-5/mapscript/csharp/run_test.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/run_test.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-#!/bin/sh -ex
-cd ${CSHARP_MAPSCRIPT_SO}
-echo .: Testing shpdump.exe :.
-mono shpdump.exe ../../../tests/point.shp
-echo .: Testing drawmap.exe :.
-mono drawmap.exe ../../../tests/test.map ./map.png
-echo .: Testing shapeinfo.exe :.
-mono shapeinfo.exe ../../../tests/point.shp
-echo .: Testing getbytes.exe :.
-mono getbytes.exe ../../../tests/test.map test_csharp2.png
-echo .: Testing RFC24.exe :.
-mono RFC24.exe ../../../tests/test.map
diff -pruN 8.0.1-5/mapscript/csharp/swig_csharp_extensions.i 8.2.0~beta1-1~exp1/mapscript/csharp/swig_csharp_extensions.i
--- 8.0.1-5/mapscript/csharp/swig_csharp_extensions.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/csharp/swig_csharp_extensions.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,305 +0,0 @@
-
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Fix for the SWIG Interface problems (early GC)
- *           and implementing SWIGTYPE *DISOWN
- * Author:   Tamas Szekeres, szekerest@gmail.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-// Ensure the class is not marked BeforeFieldInit causing memory corruption with CLR4 
-%pragma(csharp) imclasscode=%{
-
-  public class UTF8Marshaler : System.Runtime.InteropServices.ICustomMarshaler {
-    static UTF8Marshaler static_instance;
-
-    public System.IntPtr MarshalManagedToNative(object managedObj) {
-        if (managedObj == null)
-            return System.IntPtr.Zero;
-        if (!(managedObj is string))
-            throw new System.Runtime.InteropServices.MarshalDirectiveException(
-                   "UTF8Marshaler must be used on a string.");
-
-        // not null terminated
-        byte[] strbuf = System.Text.Encoding.UTF8.GetBytes((string)managedObj);
-        System.IntPtr buffer = System.Runtime.InteropServices.Marshal.AllocHGlobal(strbuf.Length + 1);
-        System.Runtime.InteropServices.Marshal.Copy(strbuf, 0, buffer, strbuf.Length);
-
-        // write the terminating null
-        System.Runtime.InteropServices.Marshal.WriteByte(buffer, strbuf.Length, 0);
-        return buffer;
-    }
-
-    public object MarshalNativeToManaged(System.IntPtr pNativeData) {
-	    int len = System.Runtime.InteropServices.Marshal.PtrToStringAnsi(pNativeData).Length;
-        byte[] utf8data = new byte[len];
-        System.Runtime.InteropServices.Marshal.Copy(pNativeData, utf8data, 0, len);
-        return System.Text.Encoding.UTF8.GetString(utf8data);
-    }
-
-    public void CleanUpNativeData(System.IntPtr pNativeData) {
-        System.Runtime.InteropServices.Marshal.FreeHGlobal(pNativeData);
-    }
-
-    public void CleanUpManagedData(object managedObj) {
-    }
-
-    public int GetNativeDataSize() {
-        return -1;
-    }
-
-    public static System.Runtime.InteropServices.ICustomMarshaler GetInstance(string cookie) {
-        if (static_instance == null) {
-            return static_instance = new UTF8Marshaler();
-        }
-        return static_instance;
-    }
-  }
-%}
-
-%typemap(imtype, inattributes="[System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(UTF8Marshaler))]",
-  outattributes="[return: System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(UTF8Marshaler))]")
-  char *, char *&, char[ANY], char[]   "string"
-
-%typemap(csout, excode=SWIGEXCODE) SWIGTYPE {
-    /* %typemap(csout, excode=SWIGEXCODE) SWIGTYPE */
-    $&csclassname ret = new $&csclassname($imcall, true, null);$excode
-    return ret;
-  }
-
-%typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE & {
-    /* typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE & */
-    $csclassname ret = new $csclassname($imcall, $owner, ThisOwn_$owner());$excode
-    return ret;
-  }
-%typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) {
-    /* %typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) */
-    System.IntPtr cPtr = $imcall;
-    $csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $csclassname(cPtr, $owner, ThisOwn_$owner());$excode
-    return ret;
-  }
-%typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE %{
-    /* %typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE */
-    get {
-      $&csclassname ret = new $&csclassname($imcall, $owner, ThisOwn_$owner());$excode
-      return ret;
-    } %}
-%typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE & %{
-    /* %typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE & */
-    get {
-      $csclassname ret = new $csclassname($imcall, $owner, ThisOwn_$owner());$excode
-      return ret;
-    } %}
-%typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE *, struct SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) %{
-    /* %typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) */
-    get {
-      System.IntPtr cPtr = $imcall;
-      $csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $csclassname(cPtr, $owner, ThisOwn_$owner());$excode
-      return ret;
-    } %}
-%typemap(csout, excode=SWIGEXCODE) SWIGTYPE *& {
-    /* %typemap(csout, excode=SWIGEXCODE) SWIGTYPE *& */
-    System.IntPtr cPtr = $imcall;
-    $*csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $*csclassname(cPtr, $owner, ThisOwn_$owner());$excode
-    return ret;
-  }
-// Proxy classes (base classes, ie, not derived classes)
-%typemap(csbody) SWIGTYPE %{
-  /* %typemap(csbody) SWIGTYPE */
-  private System.Runtime.InteropServices.HandleRef swigCPtr;
-  protected bool swigCMemOwn;
-  protected object swigParentRef;
-  
-  protected static object ThisOwn_true() { return null; }
-  protected object ThisOwn_false() { return this; }
-
-  internal $csclassname(System.IntPtr cPtr, bool cMemoryOwn, object parent) {
-    swigCMemOwn = cMemoryOwn;
-    swigParentRef = parent;
-    swigCPtr = new System.Runtime.InteropServices.HandleRef(this, cPtr);
-  }
-
-  internal static System.Runtime.InteropServices.HandleRef getCPtr($csclassname obj) {
-    return (obj == null) ? new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero) : obj.swigCPtr;
-  }
-  internal static System.Runtime.InteropServices.HandleRef getCPtrAndDisown($csclassname obj, object parent) {
-    if (obj != null)
-    {
-      obj.swigCMemOwn = false;
-      obj.swigParentRef = parent;
-      return obj.swigCPtr;
-    }
-    else
-    {
-      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
-    }
-  }
-  internal static System.Runtime.InteropServices.HandleRef getCPtrAndSetReference($csclassname obj, object parent) {
-    if (obj != null)
-    {
-      obj.swigParentRef = parent;
-      return obj.swigCPtr;
-    }
-    else
-    {
-      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
-    }
-  }
-%}
-
-// Derived proxy classes
-%typemap(csbody_derived) SWIGTYPE %{
-  /* %typemap(csbody_derived) SWIGTYPE */
-  private System.Runtime.InteropServices.HandleRef swigCPtr;
-
-  internal $csclassname(System.IntPtr cPtr, bool cMemoryOwn, object parent) : base($modulePINVOKE.$csclassnameUpcast(cPtr), cMemoryOwn, parent) {
-    swigCPtr = new System.Runtime.InteropServices.HandleRef(this, cPtr);
-  }
-
-  internal static System.Runtime.InteropServices.HandleRef getCPtr($csclassname obj) {
-    return (obj == null) ? new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero) : obj.swigCPtr;
-  }
-  internal static System.Runtime.InteropServices.HandleRef getCPtrAndDisown($csclassname obj, object parent) {
-    if (obj != null)
-    {
-      obj.swigCMemOwn = false;
-      obj.swigParentRef = parent;
-      return obj.swigCPtr;
-    }
-    else
-    {
-      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
-    }
-  }
-  internal static System.Runtime.InteropServices.HandleRef getCPtrAndSetReference($csclassname obj, object parent) {
-    if (obj != null)
-    {
-      obj.swigParentRef = parent;
-      return obj.swigCPtr;
-    }
-    else
-    {
-      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
-    }
-  }
-%}
-
-// Typewrapper classes
-%typemap(csbody) SWIGTYPE *, SWIGTYPE &, SWIGTYPE [], SWIGTYPE (CLASS::*) %{
-  /* %typemap(csbody) SWIGTYPE *, SWIGTYPE &, SWIGTYPE [], SWIGTYPE (CLASS::*) */
-  private System.Runtime.InteropServices.HandleRef swigCPtr;
-
-  internal $csclassname(System.IntPtr cPtr, bool futureUse, object parent) {
-    swigCPtr = new System.Runtime.InteropServices.HandleRef(this, cPtr);
-  }
-
-  protected $csclassname() {
-    swigCPtr = new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
-  }
-
-  internal static System.Runtime.InteropServices.HandleRef getCPtr($csclassname obj) {
-    return (obj == null) ? new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero) : obj.swigCPtr;
-  }
-%}
-
-#if SWIG_VERSION < 0x040000
-%typemap(csfinalize) SWIGTYPE %{
-  /* %typemap(csfinalize) SWIGTYPE */
-  ~$csclassname() {
-    Dispose();
-  }
-%}
-#endif
-
-%typemap(csconstruct, excode=SWIGEXCODE) SWIGTYPE %{: this($imcall, true, null) {$excode
-  }
-%}
-
-#if SWIG_VERSION < 0x040000
-%typemap(csdestruct, methodname="Dispose", methodmodifiers="public") SWIGTYPE {
-  lock(this) {
-      if(swigCPtr.Handle != System.IntPtr.Zero && swigCMemOwn) {
-        swigCMemOwn = false;
-        $imcall;
-      }
-      swigCPtr = new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
-      swigParentRef = null;
-      System.GC.SuppressFinalize(this);
-    }
-  }
-#endif
-
-%typemap(csdestruct_derived, methodname="Dispose", methodmodifiers="public") TYPE {
-  lock(this) {
-      if(swigCPtr.Handle != System.IntPtr.Zero && swigCMemOwn) {
-        swigCMemOwn = false;
-        $imcall;
-      }
-      swigCPtr = new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
-      swigParentRef = null;
-      System.GC.SuppressFinalize(this);
-      base.Dispose();
-    }
-  }
-
-%typemap(csin) SWIGTYPE *DISOWN "$csclassname.getCPtrAndDisown($csinput, ThisOwn_false())"
-%typemap(csin) SWIGTYPE *SETREFERENCE "$csclassname.getCPtrAndSetReference($csinput, ThisOwn_false())"
-
-%pragma(csharp) modulecode=%{
-  /* %pragma(csharp) modulecode */
-  internal class $moduleObject : global::System.IDisposable {
-	public virtual void Dispose() {
-      
-    }
-  }
-  internal static $moduleObject the$moduleObject = new $moduleObject();
-  protected static object ThisOwn_true() { return null; }
-  protected static object ThisOwn_false() { return the$moduleObject; }
-  
-  [System.Runtime.InteropServices.DllImport("$dllimport", EntryPoint="SetEnvironmentVariable")]
-  public static extern int SetEnvironmentVariable(string envstring);
-%}
-
-
-%insert(runtime) %{
-#ifdef __cplusplus
-extern "C" 
-#endif
-#ifdef SWIGEXPORT
-SWIGEXPORT int SWIGSTDCALL SetEnvironmentVariable(const char *envstring) {
-  /* putenv may not make a copy, so do it ourselves despite the memory leak */
-  char* envstringDup = (char*)malloc(strlen(envstring)+1);
-  memcpy(envstringDup, envstring, strlen(envstring)+1);
-  return putenv(envstringDup);
-}
-#else
-DllExport int SWIGSTDCALL SetEnvironmentVariable(const char *envstring) {
-  /* putenv may not make a copy, so do it ourselves despite the memory leak */
-  char* envstringDup = (char*)malloc(strlen(envstring)+1);
-  memcpy(envstringDup, envstring, strlen(envstring)+1);
-  return putenv(envstringDup);
-}
-#endif
-%}
diff -pruN 8.0.1-5/mapscript/java/CMakeLists.txt 8.2.0~beta1-1~exp1/mapscript/java/CMakeLists.txt
--- 8.0.1-5/mapscript/java/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,40 +0,0 @@
-find_package(SWIG REQUIRED)
-include(${SWIG_USE_FILE})
-
-find_package(JNI)
-find_package(Java)
-if(NOT JNI_INCLUDE_DIRS OR NOT Java_JAVAC_EXECUTABLE OR NOT Java_JAR_EXECUTABLE)
-   message(SEND_ERROR "Could not find required Java components. Try setting the JAVA_HOME environment variable (required on e.g. Ubuntu)")
-endif(NOT JNI_INCLUDE_DIRS OR NOT Java_JAVAC_EXECUTABLE OR NOT Java_JAR_EXECUTABLE)
-
-include_directories(${JNI_INCLUDE_DIRS})
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/java)
-set (CMAKE_SWIG_OUTDIR "${CMAKE_CURRENT_BINARY_DIR}/edu/umn/gis/mapscript")
-set(CMAKE_SWIG_FLAGS -package edu.umn.gis.mapscript)
-
-# hide warnings
-if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
-endif ()
-
-
-if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
-    swig_add_library(javamapscript TYPE MODULE LANGUAGE java SOURCES ../mapscript.i)
-else ()
-    swig_add_module(javamapscript java ../mapscript.i)
-endif ()
-
-swig_link_libraries(javamapscript ${MAPSERVER_LIBMAPSERVER})
-
-add_custom_command(TARGET javamapscript
-                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-                      POST_BUILD
-                      COMMAND ${Java_JAVAC_EXECUTABLE} edu/umn/gis/mapscript/*.java
-                      COMMAND ${Java_JAR_EXECUTABLE} cf mapscript.jar edu/umn/gis/mapscript/*.class
-                      COMMENT "Compiling java source files, creating mapscript.jar"
-                      )
-
-set(mapscript_files $<TARGET_FILE:${SWIG_MODULE_javamapscript_REAL_NAME}>)
-install(FILES ${mapscript_files} DESTINATION ${CMAKE_INSTALL_LIBDIR})
diff -pruN 8.0.1-5/mapscript/java/README 8.2.0~beta1-1~exp1/mapscript/java/README
--- 8.0.1-5/mapscript/java/README	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,84 +0,0 @@
-Java mapscript
-==============
-
-WARNING: Starting with version 6.1 Mapserver (and Mapscript) uses libtool to build
-the shared libraries. Some files have changed names and the javamapscript.so shared
-library now depends on libmapserver.so.
-The easiest way way to handle the dependency is to simply use the 'make install'
-target.
-
-To generate the SWIG wrappers you need swig > 1.3.24.
-
-MAPSCRIPT Reference
--------------------
-
-The complete reference documentation is available on-line:
-
-http://mapserver.gis.umn.edu/docs/reference/mapscript
-
-or in the file:
-
-../doc/mapscript.txt
-
-SWIG wrappers
--------------
-
-MapServer releases, beginning with 4.2.4, contain pre-generated wrapper code
-(mapscript/java/mapscript_wrap.c) and class files (mapscript/java/edu).
-Nevertheless it is recommended that you generate your own using the "interface"
-target in the Java Makefile.
-
-Requires swig > 1.3.24. Version above 1.3.28 or 1.3.29 are recommended.
-
-Installation
-------------
-
-After MapServer is configured and compiled, change directory to the Java
-mapscript location and execute:
-
-    $ cd mapscript/java
-    $ make
-    $ make test (recommended)
-    $ make threadtests (optional)
-    $ make install (required as of 6.1)
-
-Remember to set the appropriate variable (LD_LIBRARY_PATH, java.library.path
-or edit /etc/ld.so.conf) to make sure Java can locate and load the libraries.
-
-Windows
--------
-
-Edit makefile.vc to match your environment.  You will need to set JAVA_HOME 
-and SWIG_HOME to the appropriate variables.  You will likely need to copy 
-all of the DLLs needed to run MapServer into the mapscript/java directory 
-(including libmap.dll) so the mapscript.dll can see them to run.
-
-cd mapscript/java
-nmake /f makefile.vc
-nmake /f makefile.vc test
-
-International language support
-------------------------------
-
-Since May 2006 Java mapscript has complete support for international languages
-usage in queries and mapscript internals. To document this improvement
-we have created the examples/QueryByAttributeUnicode.java
-test program which uses the ISO-8859-15 encoding.
-
-http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1753
-http://thread.gmane.org/gmane.comp.gis.mapserver.user/19298/focus=19298
-http://thread.gmane.org/gmane.comp.gis.mapserver.user/19213/focus=19213
-
-Onlice resources
-----------------
-
-Java mapscript related:
-
-http://mapserver.gis.umn.edu/docs/howto/javamapscript
-http://mapserver.gis.umn.edu/docs/howto/java_mapscript_Tomcat_55
-http://mapserver.gis.umn.edu/docs/faq/thread_safety
-
-General:
-
-http://mapserver.gis.umn.edu/docs
-
diff -pruN 8.0.1-5/mapscript/java/data/emptymap.map 8.2.0~beta1-1~exp1/mapscript/java/data/emptymap.map
--- 8.0.1-5/mapscript/java/data/emptymap.map	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/data/emptymap.map	1970-01-01 00:00:00.000000000 +0000
@@ -1,7 +0,0 @@
-MAP
-   NAME   "Niedersachsen"
-   EXTENT 3400000 5700000 3700000 6000000 
-   SIZE   500 500
-
-END
-
Binary files 8.0.1-5/mapscript/java/data/iso-subset.dbf and 8.2.0~beta1-1~exp1/mapscript/java/data/iso-subset.dbf differ
Binary files 8.0.1-5/mapscript/java/data/iso-subset.shp and 8.2.0~beta1-1~exp1/mapscript/java/data/iso-subset.shp differ
Binary files 8.0.1-5/mapscript/java/data/iso-subset.shx and 8.2.0~beta1-1~exp1/mapscript/java/data/iso-subset.shx differ
diff -pruN 8.0.1-5/mapscript/java/data/subset-umlauts.map 8.2.0~beta1-1~exp1/mapscript/java/data/subset-umlauts.map
--- 8.0.1-5/mapscript/java/data/subset-umlauts.map	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/data/subset-umlauts.map	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
-#
-# See http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1753
-#
-# Donated by: Nicol Hermann <nicol@nicol.info>
-# Modified by Umberto Nicoletti
-#
-MAP
-  NAME test 
-  EXTENT 3404414.882766 5429530.647216  3456884.187265 5550332.450907 
-  SIZE 600 600
-  UNITS METERS 
-  
-  LAYER
-    NAME test-iso 
-    STATUS DEFAULT
-    TYPE polygon
-    DATA "iso-subset"
-    TEMPLATE "dummy.html"
-    CLASS
-      NAME test
-      COLOR 128 128 0
-      OUTLINECOLOR 0 0 0
-    END
-  END
-  
-  LAYER
-    NAME test-utf 
-    STATUS DEFAULT
-    TYPE polygon
-    DATA "utf-subset"
-    TEMPLATE "dummy.html"
-    CLASS
-      NAME test
-      COLOR 128 128 0
-      OUTLINECOLOR 0 0 0
-    END
-  END
-END
-
Binary files 8.0.1-5/mapscript/java/data/utf-subset.dbf and 8.2.0~beta1-1~exp1/mapscript/java/data/utf-subset.dbf differ
Binary files 8.0.1-5/mapscript/java/data/utf-subset.shp and 8.2.0~beta1-1~exp1/mapscript/java/data/utf-subset.shp differ
Binary files 8.0.1-5/mapscript/java/data/utf-subset.shx and 8.2.0~beta1-1~exp1/mapscript/java/data/utf-subset.shx differ
diff -pruN 8.0.1-5/mapscript/java/examples/ConnPool.java 8.2.0~beta1-1~exp1/mapscript/java/examples/ConnPool.java
--- 8.0.1-5/mapscript/java/examples/ConnPool.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/ConnPool.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,19 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
- * <p>Title: Mapscript conn pool</p>
- * <p>Description: n.a. </p>
- * @author Umberto Nicoletti (umberto.nicoletti@gmail.com)
- * @version 1.0
- */
-
-public class ConnPool {
-
-  public static void main(String[] args) {
-    // at least it shouldn't crash
-    System.out.println("Running mapscript.msConnPoolCloseUnreferenced");
-    mapscript.msConnPoolCloseUnreferenced();
-    System.out.println("Finished.");
-  }
-
-}
diff -pruN 8.0.1-5/mapscript/java/examples/DrawMap.java 8.2.0~beta1-1~exp1/mapscript/java/examples/DrawMap.java
--- 8.0.1-5/mapscript/java/examples/DrawMap.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/DrawMap.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
- * <p>Title: Mapscript shape dump example.</p>
- * <p>Description: A Java based mapscript example to create an image given a mapfile.</p>
- * @author Yew K Choo 	ykchoo@geozervice.com
- * @version 1.0
- */
-
-public class DrawMap {
-
-  public static void usage() {
-    System.err.println("Usage: DrawMap {mapfile} {outfile}");
-    System.exit(-1);
-  }
-
-  public static void main(String[] args) {
-    if (args.length != 2) usage();
-   
-    mapObj map = new mapObj(args[0]);
-    //map.getImagecolor().setRGB(153, 153, 204);
-    //styleObj st = map.getLayer(1).getClass(0).getStyle(0);
-    //st.getColor().setHex("#000000");
-    if( map.getLayer(1).getMetadata().get("hidden") != null ) {
-    	System.out.println("Layer 1 is hidden? "+map.getLayer(1).getMetadata().get("hidden"));
-    }
-    int i=0;
-    //for (i=0; i<100; i++) {
-    	imageObj img = map.draw();
-    	System.out.println("Image size is: "+img.getSize());
-    	System.out.println("Image size from getBytes is: "+img.getBytes().length);
-    	System.out.println(i+") the map will be drawn to:"+args[1]);
-    	img.save(args[1], map);
-    //}
-    img.delete();
-    map.delete();
-    //mapscript.msCleanup();
-  }
-}
diff -pruN 8.0.1-5/mapscript/java/examples/DumpShp.java 8.2.0~beta1-1~exp1/mapscript/java/examples/DumpShp.java
--- 8.0.1-5/mapscript/java/examples/DumpShp.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/DumpShp.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,60 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
- * <p>Title: Mapscript shape dump example.</p>
- * <p>Description: A Java based mapscript to dump information from a shapefile.</p>
- * @author Yew K Choo  (ykchoo@geozervice.com)
- * @version 1.0
- */
-
-public class DumpShp {
-  public  static String getShapeType(int type)
-  {
-    switch (type)
-    {
-      case 1: return "point";
-      case 3: return "arc";
-      case 5: return "polygon";
-      case 8: return "multipoint";
-      default: return "unknown";
-    }
-  }
-
-  public static void usage() {
-    System.err.println("Usage: DumpShp {shapefile.shp}");
-    System.exit(-1);
-  }
-
-  public static void main(String[] args) {
-    if (args.length != 1) usage();
-
-    shapefileObj shapefile = new shapefileObj (args[0],-1);
-    System.out.println ("Shapefile opened (type = "  + getShapeType(shapefile.getType()) +
-                        " with " + shapefile.getNumshapes() + " shapes).");
-
-
-    shapeObj shape = new shapeObj(-1);
-
-    for(int i=0; i<shapefile.getNumshapes(); i++) {
-        shapefile.get(i, shape);
-
-        System.out.println("Shape[" + i + "] has " + shape.getNumlines() + " part(s)");
-        System.out.println("bounds (" + shape.getBounds().getMinx() + "," + shape.getBounds().getMiny() + ")" +
-                           "(" + shape.getBounds().getMaxx() + "," + shape.getBounds().getMaxy() + ")");
-
-        for(int j=0; j<shape.getNumlines(); j++) {
-            lineObj part = shape.get(j);
-            System.out.println("Part[" +j + "] has " + part.getNumpoints() + " point(s)");
-
-            for(int k=0; k<part.getNumpoints(); k++) {
-                pointObj point = part.get(k);
-                System.out.println("Point[" + k + "] = " + point.getX() + ", "  + point.getY());
-            }
-        }
-    }
-    // shape.delete();
-    // shapefile.delete();
-    // mapscript.msCleanup();
-  }
-
-}
diff -pruN 8.0.1-5/mapscript/java/examples/MakePoint.java 8.2.0~beta1-1~exp1/mapscript/java/examples/MakePoint.java
--- 8.0.1-5/mapscript/java/examples/MakePoint.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/MakePoint.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-/*
- Created by unicoletti@prometeo.it to test backwards-compatible
- pointObj constructor. See bug #1106.
-
- 2/1/2005: Created
-*/
-
-import edu.umn.gis.mapscript.*;
-
-public class MakePoint {
-	public static void main(String[] args) {
-	pointObj result = new pointObj(0,0,0);
-	System.out.println("Point made!");
-	}
-}
diff -pruN 8.0.1-5/mapscript/java/examples/Metadata.java 8.2.0~beta1-1~exp1/mapscript/java/examples/Metadata.java
--- 8.0.1-5/mapscript/java/examples/Metadata.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/Metadata.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,37 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
- * <p>Title: Mapscript shape dump example.</p>
- * <p>Description: A Java based mapscript example to create an image given a mapfile.</p>
- * @author Yew K Choo 	ykchoo@geozervice.com
- * @version 1.0
- */
-
-public class Metadata {
-
-  public static void usage() {
-    System.err.println("Usage: Metadata {mapfile}");
-    System.exit(-1);
-  }
-
-  public static void main(String[] args) {
-    if (args.length != 1) usage();
-   
-    mapObj map = new mapObj(args[0]);
-    
-    for (int i=0; i<100; i++) {
-	    System.out.println("Web->key1 ? "+map.getWeb().getMetadata().get("key1",null));
-	    System.out.println("Web->key2 ? "+map.getWeb().getMetadata().get("key2",null));
-	    System.out.println("Web->key3 ? "+map.getWeb().getMetadata().get("key3",null));
-	    System.out.println("Web->key4 ? "+map.getWeb().getMetadata().get("key4",null));
-	    System.out.println("Web->key5 ? "+map.getWeb().getMetadata().get("key5",null));
-	    
-	    System.gc();
-	    System.gc();
-	    System.gc();
-	    
-	    System.out.println("Web->key1 ? "+map.getWeb().getMetadata().get("key1",null));
-    }
-    map.delete();
-  }
-}
diff -pruN 8.0.1-5/mapscript/java/examples/OutputFormatList.java 8.2.0~beta1-1~exp1/mapscript/java/examples/OutputFormatList.java
--- 8.0.1-5/mapscript/java/examples/OutputFormatList.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/OutputFormatList.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,29 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
- * <p>Title: Mapscript outputformat dump example.</p>
- * @author Umberto Nicoletti 	umberto.nicoletti@gmail.com
- * @version 1.0
- */
-
-public class OutputFormatList {
-
-  public static void usage() {
-    System.err.println("Usage: OutputFormatList {mapfile}");
-    System.exit(-1);
-  }
-
-  public static void main(String[] args) {
-    if (args.length != 1) usage();
-   
-    mapObj map = new mapObj(args[0]);
-    for (int i=0; i<map.getNumoutputformats(); i++) {
-	outputFormatObj format = map.getOutputFormat(i);
-	System.out.println("["+i+"] Format name: "+format.getName());
-	System.out.println("\toption count: "+format.getNumformatoptions());
-	for(int j=0;j<format.getNumformatoptions();j++) {
-	    System.out.println("\t["+j+"] option: "+format.getOptionAt(j));
-	}
-    }
-  }
-}
diff -pruN 8.0.1-5/mapscript/java/examples/QueryByAttribute.java 8.2.0~beta1-1~exp1/mapscript/java/examples/QueryByAttribute.java
--- 8.0.1-5/mapscript/java/examples/QueryByAttribute.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/QueryByAttribute.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,37 +0,0 @@
-import edu.umn.gis.mapscript.imageObj;
-import edu.umn.gis.mapscript.mapObj;
-import edu.umn.gis.mapscript.layerObj;
-import edu.umn.gis.mapscript.shapeObj;
-import edu.umn.gis.mapscript.mapscriptConstants;
-
-
-
-public class QueryByAttribute {
-	public static void main(String[] args)  {
-	  
-	String filter="A Point";
-	mapObj map = new mapObj(args[0]);
-	if (args.length == 2) {
-		filter=args[1];
-	} else {
-		filter="A Point";
-	}
-
-	layerObj layer = map.getLayerByName("POINT");
-	layer.setTemplate("template.html");
-
-	layer.queryByAttributes(map,"FNAME", filter, mapscriptConstants.MS_MULTIPLE);
-	layer.open();
-	System.out.println( "Searched for: " +filter );        
-	int results=layer.getNumResults();
-	System.out.println( "Results number (should be always 1): " +results );
-	for(int i=0;i<results;i++) {
-		shapeObj shape=layer.getShape(layer.getResult(i));
-		System.out.println( "shape["+i+"]=" +shape );
-	}
-	layer.close();
-
-
-	}
-}
-
diff -pruN 8.0.1-5/mapscript/java/examples/QueryByAttributeUnicode.java 8.2.0~beta1-1~exp1/mapscript/java/examples/QueryByAttributeUnicode.java
--- 8.0.1-5/mapscript/java/examples/QueryByAttributeUnicode.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/QueryByAttributeUnicode.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,52 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-public class QueryByAttributeUnicode {
-	public static void main(String[] args)  {
-
-		String filter="/Südliche Weinstraße/";
-		if (args.length == 2) {
-			filter=args[1];
-		}
-		// Unsupported
-		//String langSettings=System.getenv("LANG");
-		// Only since jdk 1.5
-		//String charsetSetting=Charset.defaultCharset().displayName();
-		String charsetSetting = new java.io.OutputStreamWriter(System.out).getEncoding();
-		System.out.println( "("+charsetSetting+") Searching for: " +filter );        
-
-		if ( charsetSetting.indexOf("UTF") == -1 ) {
-			mapObj map = new mapObj(args[0]);
-			layerObj layer = map.getLayerByName("test-iso");
-			layer.queryByAttributes(map,"KREIS_NAME", filter, mapscriptConstants.MS_MULTIPLE);
-			layer.open();
-
-			resultObj result = layer.getResult(0);
-			if (result==null) {
-				System.out.println("Error: no results found, resultObj is null!");
-			} else {
-				shapeObj shp = layer.getShape(result);
-				for (int z = 0; z < shp.getNumvalues(); z++) {
-					System.out.println("shp.value[" + z + "]=" + shp.getValue(z));
-				}
-
-				System.out.println( "Results number (should be always 1): " +layer.getNumResults() );
-			}
-			layer.close();
-		} else {
-			mapObj map = new mapObj(args[0]);
-			layerObj layer = map.getLayerByName("test-utf");
-			layer.queryByAttributes(map,"KREIS_NAME", filter, mapscriptConstants.MS_MULTIPLE);
-			layer.open();
-
-        		int results=layer.getNumResults();
-		        System.out.println( "Results number (should be always 1): " +results );
-        		for(int i=0;i<results;i++) {
-                		shapeObj shape=layer.getShape(layer.getResult(i));
-		                System.out.println( "shape["+i+"]=" +shape );
-        		}
-
-			layer.close();     
-		}
-	}
-}
-
diff -pruN 8.0.1-5/mapscript/java/examples/RFC24.java 8.2.0~beta1-1~exp1/mapscript/java/examples/RFC24.java
--- 8.0.1-5/mapscript/java/examples/RFC24.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/RFC24.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,147 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
- * <p>Title: Mapscript RFC24 tests.</p>
- * <p>Description: Tests for RFC24 implementation. (http://mapserver.gis.umn.edu/development/rfc/ms-rfc-24/)</p>
- * @author Umberto Nicoletti (umberto.nicoletti@gmail.com)
- */
-
-public class RFC24 {
-	String mapfile;
-
-	public static void main(String[] args) {
-		new RFC24(args[0]).run();
-	}
-	
-	public RFC24(String mapfile) {
-		this.mapfile=mapfile;
-	}
-	
-	public void run() {
-		System.out.println("Running "+getClass().getName());
-		testLayerObj();
-		testClassObj();
-		testInsertLayerObj();
-		testInsertClassObj();
-		testGetLayerObj();
-		testGetLayerObjByName();
-		testGetClassObj();
-		testGetOutputformatObj();
-		testInsertOutputformatObj();
-
-		System.out.println("Finished "+getClass().getName());
-	}
-	
-	public void testLayerObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=new layerObj(map);
-		
-		map=null;
-		gc();
-		assertNotNull(newLayer.getMap(), "testLayerObj");
-	}
-	
-	public void testInsertLayerObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=new layerObj(null);
-		map.insertLayer(newLayer,-1);
-		
-		map=null;
-		gc();
-		assertNotNull(newLayer.getMap(), "testInsertLayerObj");
-	}
-	
-	public void testGetLayerObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=map.getLayer(1);
-		
-		map=null;
-		gc();
-		assertNotNull(newLayer.getMap(), "testGetLayerObj");
-	}
-
-	public void testGetLayerObjByName() {
-		mapObj map=new mapObj(mapfile);
-		layerObj newLayer=map.getLayerByName("POLYGON");
-		
-		map=null;
-		gc();
-		assertNotNull(newLayer.getMap(), "testGetLayerObjByName");
-	}
-
-	public void testClassObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=new classObj(layer);
-		
-		map=null; layer=null;
-		gc();
-		assertNotNull(newClass.getLayer(), "testClassObj");
-	}
-
-	public void testInsertClassObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=new classObj(null);
-		layer.insertClass(newClass,-1);
-		
-		map=null; layer=null;
-		gc();
-		assertNotNull(newClass.getLayer(), "testInsertClassObj");
-	}
-
-	public void testGetClassObj() {
-		mapObj map=new mapObj(mapfile);
-		layerObj layer=map.getLayer(1);
-		classObj newClass=layer.getClass(0);
-		
-		map=null; layer=null;
-		gc();
-		assertNotNull(newClass.getLayer(), "testGetClassObj");
-	}
-
-        public void testGetOutputformatObj() {
-                mapObj map=new mapObj(mapfile);
-                outputFormatObj format=null;
-                for (int i=0; i<map.getNumoutputformats(); i++) {
-                    format = map.getOutputFormat(i);
-                    //System.out.println("["+i+"] Format name: "+format.getName());
-                } 
-                map=null;
-                gc();
-                assertNotNull(format.getDriver(), "testGetOutputformatObj");
-        }
-
-        public void testInsertOutputformatObj() {
-                mapObj map=new mapObj(mapfile);
-                outputFormatObj format=null;
-                for (int i=0; i<map.getNumoutputformats(); i++) {
-                    format = map.getOutputFormat(i);
-		    // uncomment to see output
-                    //System.out.println("["+i+"] Format name: "+format.getName() + " driver="+format.getDriver());
-                } 
-                outputFormatObj newFormat=new outputFormatObj("AGG/PNG","test/rfc24");
-		map.appendOutputFormat(newFormat);
-                for (int i=0; i<map.getNumoutputformats(); i++) {
-                    format = map.getOutputFormat(i);
-		    // uncomment to see output
-                    //System.out.println("["+i+"] Format name: "+format.getName());
-                } 
-		map.draw();
-                map=null; format=null;
-                gc();
-                assertNotNull(newFormat.getDriver(), "testInsertOutputformatObj");
-        }
-
-	public void gc() {
-		for (int i=0; i<10; i++)
-			System.gc();
-	}
-	
-	public void assertNotNull(Object object, String test) {
-		if ( object != null )
-			System.out.println("\t- "+test+" PASSED");
-		else
-			System.out.println("\t- "+test+" FAILED");
-	}
-}
diff -pruN 8.0.1-5/mapscript/java/examples/RunTimeBuiltWMSClient.java 8.2.0~beta1-1~exp1/mapscript/java/examples/RunTimeBuiltWMSClient.java
--- 8.0.1-5/mapscript/java/examples/RunTimeBuiltWMSClient.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/RunTimeBuiltWMSClient.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,74 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
-	This example demoes a wms client almost entirely configured
-	at run time and without the use of a map file.
-	TODO: remove the need for even a basic map file and do everything at run time
-
-	@author: Nicole Herman, Umberto Nicoletti
-*/
-public class RunTimeBuiltWMSClient {
-	public static void main(String[] args)  {
-	   System.out.println(mapscript.msGetVersion());
-	   mapObj  map;
-	   webObj web;
-	   imageObj bild;
-	   	   
-	   map = new mapObj("data/emptymap.map");
-	   /*
-	   map.setWidth(400);
-	   map.setHeight(400);
-	   map.setDebug(1);
-           // map.setExtent(3280364,5237512,3921499,6103271);
-           map.setExtent(3400000,5700000,3700000,6000000);
-	   // map.setExtent(3300000,5600000,3800000,6100000);
-	   */
-	   map.setProjection("init=epsg:31467");
-	   map.setImageType("png");
-	   
-	   outputFormatObj output = new outputFormatObj("gd/png", "");
-	   output.setName("png");
-	   output.setDriver("gd/png");
-	   output.setMimetype("image/png");
-	   output.setExtension("png");
-	   output.setImagemode(MS_IMAGEMODE.MS_IMAGEMODE_RGB.swigValue());
-	   
-	   /* This fixes bug #1870 and #1803 */
-	   // Instanz des WebObjekts 
-	   // web = new webObj();
-	   web=map.getWeb();
-	   web.setImagepath("/tmp/");
-	   web.setImageurl("http://katrin/~nicol/mapserver/tmp/");
-	   web.setLog("/tmp/wms.log");
-	   web.setHeader("nh_header.html");
-	   web.setTemplate("../html/form.html");
-	   web.setEmpty("../themen/noFeature.html");
-	   
-	   // no longer necessary
-	   //web.setMap(map);
-	   //map.setWeb(web);
-	   System.out.println("ImagePath="+web.getImagepath());
-
-
-	   // Layer Objekt wird erzeugt
-	   layerObj layer;
-	   layer = new layerObj(map);
-	   layer.setName("DUEKN5000");
-           layer.setDebug(mapscriptConstants.MS_ON);
-	   layer.setType(MS_LAYER_TYPE.MS_LAYER_RASTER);
-	   layer.setConnectiontype(MS_CONNECTION_TYPE.MS_WMS);
-	   // TODO: replace with a permanent url
-	   layer.setConnection("http://www.mapserver.niedersachsen.de/freezoneogc/mapserverogc?");
-	   layer.setMetaData("wms_srs", "EPSG:31467");
-	   layer.setMetaData("wms_name", "DUEKN5000");
-	   layer.setMetaData("wms_server_version", "1.1.1");
-	   layer.setMetaData("wms_format","image/png");
-	   layer.setProjection("init=epsg:31467");
-	   layer.setStatus(mapscriptConstants.MS_ON);
-
-	   bild = map.draw();
-	   bild.save("test.png", map);
-	   bild.delete();
-	}
-}
-
diff -pruN 8.0.1-5/mapscript/java/examples/ShapeInfo.java 8.2.0~beta1-1~exp1/mapscript/java/examples/ShapeInfo.java
--- 8.0.1-5/mapscript/java/examples/ShapeInfo.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/ShapeInfo.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-import edu.umn.gis.mapscript.*;
-
-/**
- * <p>Title: Mapscript shapeinfo example.</p>
- * <p>Description: A Java based mapscript example to dump information from a shapefile.</p>
- * <p>Copyright: Copyright (c) 2004</p>
- * <p>Company: GeoZervice</p>
- * @author Yew K Choo (ykchoo@geozervice.com)
- * @version 1.0
- */
-
-public class ShapeInfo {
-  public  static String getShapeType(int type)
-  {
-    switch (type)
-    {
-      case 1: return "point";
-      case 3: return "arc";
-      case 5: return "polygon";
-      case 8: return "multipoint";
-      default: return "unknown";
-    }
-  }
-
-  public static void usage() {
-    System.err.println("Usage: ShapeInfo {shapefile.shp} {shapefile.dbf}");
-    System.exit(-1);
-  }
-
-  public static void main(String[] args) {
-
-    if (args.length != 2) usage();
-
-    shapefileObj shapefile = new shapefileObj (args[0],-1);
-
-    System.out.println ("Shapefile name = " + args[0]);
-    System.out.println ("Type = "  + getShapeType(shapefile.getType()));
-    System.out.println ("Number of features " + shapefile.getNumshapes());
-    System.out.println("bounds (" + shapefile.getBounds().getMinx() + "," + shapefile.getBounds().getMiny() + ")" +
-                        "(" + shapefile.getBounds().getMaxx() + "," + shapefile.getBounds().getMaxy() + ")");
-    shapefile.delete();
-    //mapscript.msCleanup();
-  }
-
-}
diff -pruN 8.0.1-5/mapscript/java/examples/WxSTest.java 8.2.0~beta1-1~exp1/mapscript/java/examples/WxSTest.java
--- 8.0.1-5/mapscript/java/examples/WxSTest.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/WxSTest.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-import edu.umn.gis.mapscript.mapObj;
-import edu.umn.gis.mapscript.OWSRequest;
-import edu.umn.gis.mapscript.mapscript;
-import java.io.*;
-
-class WxSTest_thread extends Thread {
-
-    public String	mapName;
-    public byte[]       resultBytes;
-
-    public void run() {
-	mapObj map = new mapObj(mapName);
-
-        map.setMetaData( "ows_onlineresource", "http://dummy.org/" );
-
-        OWSRequest req = new OWSRequest();
-
-        req.setParameter( "SERVICE", "WMS" );
-        req.setParameter( "VERSION", "1.1.0" );
-        req.setParameter( "REQUEST", "GetCapabilities" );
-
-        mapscript.msIO_installStdoutToBuffer();
-
-        int owsResult = map.OWSDispatch( req );
-
-        if( owsResult != 0 )
-            System.out.println( "OWSDispatch Result (expect 0): " + owsResult );
-
-//        System.out.println( "Document:" );
-//        System.out.println( mapscript.msIO_getStdoutBufferString() );
-
-        resultBytes = mapscript.msIO_getStdoutBufferBytes();
-        mapscript.msIO_resetHandlers();
-    }
-}
-
-public class WxSTest {
-    public static void main(String[] args)  {
-        try {
-            WxSTest_thread tt[] = new WxSTest_thread[100];
-            int i;
-            int expectedLength=0, success = 0, failure=0;
-
-            for( i = 0; i < tt.length; i++ )
-            {
-                tt[i] = new WxSTest_thread();
-                tt[i].mapName = args[0];
-            }
-            
-            for( i = 0; i < tt.length; i++ )
-                tt[i].start();
-
-            for( i = 0; i < tt.length; i++ )
-            {
-                tt[i].join();
-                if( i == 0 )
-                {
-                    expectedLength = tt[i].resultBytes.length;
-                    System.out.println( "["+i+"] Document Length: " + expectedLength + ", expecting somewhere around 10000 or more." );
-                }
-                else if( expectedLength != tt[i].resultBytes.length )
-                {
-                    System.out.println( "["+i+"] Document Length:" + tt[i].resultBytes.length + " Expected:" + expectedLength );
-                    failure++;
-                }
-                else
-                    success++;
-		
-		// dump test results to fs for post-mortem inspection
-		FileOutputStream fos = new FileOutputStream("/tmp/wxs_test_"+i);
-		fos.write(tt[i].resultBytes);
-		fos.close();
-            }
-
-            System.out.println( "Successes: " + success );
-            System.out.println( "Failures: " + failure );
-
-        } catch( Exception e ) {
-            e.printStackTrace();
-        }
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/java/examples/WxSTestNoThread.java 8.2.0~beta1-1~exp1/mapscript/java/examples/WxSTestNoThread.java
--- 8.0.1-5/mapscript/java/examples/WxSTestNoThread.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/examples/WxSTestNoThread.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,82 +0,0 @@
-import edu.umn.gis.mapscript.mapObj;
-import edu.umn.gis.mapscript.OWSRequest;
-import edu.umn.gis.mapscript.mapscript;
-import java.io.*;
-
-class WxSTest_nothread {
-
-    public String	mapName;
-    public byte[]       resultBytes;
-
-    public void run() {
-	mapObj map = new mapObj(mapName);
-
-        map.setMetaData( "ows_onlineresource", "http://dummy.org/" );
-
-        OWSRequest req = new OWSRequest();
-
-        req.setParameter( "SERVICE", "WMS" );
-        req.setParameter( "VERSION", "1.1.0" );
-        req.setParameter( "REQUEST", "GetCapabilities" );
-
-        mapscript.msIO_installStdoutToBuffer();
-
-        int owsResult = map.OWSDispatch( req );
-
-        if( owsResult != 0 )
-            System.out.println( "OWSDispatch Result (expect 0): " + owsResult );
-
-//        System.out.println( "Document:" );
-//        System.out.println( mapscript.msIO_getStdoutBufferString() );
-
-        resultBytes = mapscript.msIO_getStdoutBufferBytes();
-        mapscript.msIO_resetHandlers();
-    }
-}
-
-public class WxSTestNoThread {
-    public static void main(String[] args)  {
-        try {
-            WxSTest_nothread tt[] = new WxSTest_nothread[1];
-            int i;
-            int expectedLength=0, success = 0, failure=0;
-
-            for( i = 0; i < tt.length; i++ )
-            {
-                tt[i] = new WxSTest_nothread();
-                tt[i].mapName = args[0];
-            }
-            
-            for( i = 0; i < tt.length; i++ )
-                tt[i].run();
-
-            for( i = 0; i < tt.length; i++ )
-            {
-                if( i == 0 )
-                {
-                    expectedLength = tt[i].resultBytes.length;
-                    System.out.println( "["+i+"] Document Length: " + expectedLength + ", expecting somewhere around 10000 or more." );
-                }
-                else if( expectedLength != tt[i].resultBytes.length )
-                {
-                    System.out.println( "["+i+"] Document Length:" + tt[i].resultBytes.length + " Expected:" + expectedLength );
-                    failure++;
-                }
-                else
-                    success++;
-		
-		// dump test results to fs for post-mortem inspection
-		FileOutputStream fos = new FileOutputStream("/tmp/wxs_test_"+i);
-		fos.write(tt[i].resultBytes);
-		fos.close();
-            }
-
-            System.out.println( "Successes: " + success );
-            System.out.println( "Failures: " + failure );
-
-        } catch( Exception e ) {
-            e.printStackTrace();
-        }
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/java/javaextend.i 8.2.0~beta1-1~exp1/mapscript/java/javaextend.i
--- 8.0.1-5/mapscript/java/javaextend.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/javaextend.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,53 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Java-specific extensions to MapScript objects
- * Author:   Sean Gillies, sgillies@frii.com
- *           Jerry Pisk, jerry.pisk@gmail.com
- *
- *****************************************************************************/
-
-/*
-===============================================================================
-imageObj
-===============================================================================
-*/
-
-/* getBytes moved to mapscript/swiginc/image.i */
-
-/*
-==============================================================================
- pointObj
-==============================================================================
-*/
-
-%extend pointObj 
-{
-  
-    pointObj(double x, double y, double z, double m) 
-    {
-        pointObj *p;
-        p = (pointObj *)calloc(1,sizeof(pointObj));
-        if (!p) return NULL;
-        p->x = x;
-        p->y = y;
-        p->z = z;
-        p->m = m;
-        return p;
-    }
-
-    pointObj(double x, double y, double z)
-    {
-        pointObj *p;
-        p = (pointObj *)calloc(1,sizeof(pointObj));
-        if (!p) return NULL;
-        p->x = x;
-        p->y = y;
-        p->z = z;
-        p->m = -2e38;
-        return p;
-    }
-
-}
-
diff -pruN 8.0.1-5/mapscript/java/javamodule.i 8.2.0~beta1-1~exp1/mapscript/java/javamodule.i
--- 8.0.1-5/mapscript/java/javamodule.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/javamodule.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,224 +0,0 @@
-
-%include arrays_java.i
-
-/*
-  Uncomment this if you wish to hace enums wrapped in an interface compatible
-  with that generated by swig 1.3.21 (tests wont compile, though)
-  %include enumsimple.swg
-*/
-
-/* Mapscript library loader */
-
-%pragma(java) jniclasscode=%{
-    static {
-        String  library = System.getProperty("mapserver.library.name", "javamapscript");
-
-        System.loadLibrary(library);
-        /* TODO Throw when return value not MS_SUCCESS? */
-        edu.umn.gis.mapscript.mapscript.msSetup();
-    }
-%}
-
-%typemap(jni) gdBuffer    %{jbyteArray%}
-%typemap(jtype) gdBuffer  %{byte[]%}
-%typemap(jstype) gdBuffer %{byte[]%}
-
-%typemap(out) gdBuffer
-%{ $result = SWIG_JavaArrayOutSchar(jenv, $1.data, $1.size); 
-   if( $1.owns_data ) msFree($1.data); %}
-
-%typemap(javain) gdBuffer "$javainput"
-%typemap(javaout) gdBuffer {
-    return $jnicall;
-}
-
-/* String conversion utility function */
-
-%{
-/*
-	These functions taken from: http://java.sun.com/docs/books/jni/html/other.html#26018
-	Umberto Nicoletti, umberto.nicoletti@gmail.com
-
-	Fix bug: http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1753
-*/	
-
-
-void JNU_ThrowByName(JNIEnv *env, const char *name, const char *msg)
-{
-	jclass cls = (*env)->FindClass(env, name);
-	/* if cls is NULL, an exception has already been thrown */
-	if (cls != NULL) {
-		(*env)->ThrowNew(env, cls, msg);
-	}
-	/* free the local ref */
-	(*env)->DeleteLocalRef(env, cls);
-}
-
-char *JNU_GetStringNativeChars(JNIEnv *env, jstring jstr) {
-	jbyteArray bytes = 0;
-	jthrowable exc;
-	char *result = 0;
-	jclass jcls_str;
-	jmethodID MID_String_getBytes;
-
-	if (jstr == NULL) {
-		return NULL;
-	}
-
-	if ((*env)->EnsureLocalCapacity(env, 2) < 0) {
-		return 0; /* out of memory error */
-	}
-
-  	jcls_str = (*env)->FindClass(env, "java/lang/String"); 
-    	MID_String_getBytes = (*env)->GetMethodID(env, jcls_str, "getBytes", "()[B"); 
-     
-	bytes = (*env)->CallObjectMethod(env, jstr,
-                                      MID_String_getBytes);
-	exc = (*env)->ExceptionOccurred(env);
-	if (!exc) {
-    		jint len = (*env)->GetArrayLength(env, bytes);
-    		result = (char *)malloc(len + 1);
-    		if (result == 0) {
-        		JNU_ThrowByName(env, "java/lang/OutOfMemoryError",0);
-        		(*env)->DeleteLocalRef(env, bytes);
-        		return 0;
-    		}
-    		(*env)->GetByteArrayRegion(env, bytes, 0, len,
-                               (jbyte *)result);
-	    	result[len] = 0; /* NULL-terminate */
-	} else {
-    		(*env)->DeleteLocalRef(env, exc);
-	}
-	(*env)->DeleteLocalRef(env, bytes);
-	return result;
-}
-
-jstring JNU_NewStringNative(JNIEnv *env, const char *str) {
-	jstring result;
-	jbyteArray bytes = 0;
-	int len;
-	jclass jcls_str;
-	jmethodID MID_String_init;
-
-	if (str == NULL) {
-		return NULL;
-	}
-
-	if ((*env)->EnsureLocalCapacity(env, 2) < 0) {
-	    return NULL; /* out of memory error */
-	}
-	jcls_str = (*env)->FindClass(env, "java/lang/String"); 
-	MID_String_init = (*env)->GetMethodID(env, jcls_str, "<init>", "([B)V"); 
-
-	len = strlen(str);
-	bytes = (*env)->NewByteArray(env, len);
-	if (bytes != NULL) {
-	    (*env)->SetByteArrayRegion(env, bytes, 0, len,
-	                            (jbyte *)str);
-	    result = (*env)->NewObject(env, jcls_str,
-	                            MID_String_init, bytes);
-	    (*env)->DeleteLocalRef(env, bytes);
-	    return result;
-	} /* else fall through */
-	return NULL;
-}
- 
-%}
-
-%typemap(in) char * {
-	$1 = JNU_GetStringNativeChars(jenv, $input);
-}
-
-/* The default mapping would use ReleaseStringUTFChars to release the
-memory allocated with JNU_GetStringNativeChars which causes a
-memory corruption. (#3491) */
-%typemap(freearg, noblock=1) char * { if ($1) free($1); }
-
-%typemap(out) char * {
-	$result = JNU_NewStringNative(jenv, $1);
-}
-
-/*
-===============================================================================
-RFC-24 implementation follows
-===============================================================================
-   Modified constructor according to:
-   - cache population and sync, item 3.2
-*/
-%typemap(javaconstruct) layerObj(mapObj map) %{ {
-        this($imcall, true);
-        if (map != null) {
-                this.map=map;
-        }
-}
-%}
-
-%typemap(javaconstruct) classObj(layerObj layer) %{ {
-        this($imcall, true);
-        if (layer != null) {
-                this.layer=layer;
-        }
-}
-%}
-
-%typemap(javaout) int insertLayer {
-        // call the C API
-        int actualIndex=$jnicall;
-        /* Store parent reference, item 3.2 */
-        layer.map=this;
-        return actualIndex;
-}
-
-%typemap(javaout) layerObj* getLayer {
-        // call the C API
-        long cPtr=$jnicall;
-        layerObj layer = null;
-        if (cPtr != 0) {
-        	layer=new layerObj(cPtr, true);
-	        /* Store parent reference, item 3.2 */
-	        layer.map=this;
-        }
-        return layer;
-}
-
-%typemap(javaout) layerObj* getLayerByName {
-        // call the C API
-        long cPtr=$jnicall;
-        layerObj layer = null;
-        if (cPtr != 0) {
-        	layer=new layerObj(cPtr, true);
-	        /* Store parent reference, item 3.2 */
-	        layer.map=this;
-        }
-        return layer;
-}
-
-%typemap(javaout) int insertClass {
-        // call the C API
-        int actualIndex=$jnicall;
-        /* Store parent reference, item 3.2 */
-        classobj.layer=this;
-        return actualIndex;
-}
-
-%typemap(javaout) classObj* getClass {
-        // call the C API
-        long cPtr=$jnicall;
-        classObj clazz = null;
-        if (cPtr != 0) {
-        	clazz=new classObj(cPtr, true);
-	        /* Store parent reference, item 3.2 */
-	        clazz.layer=this;
-        }
-        return clazz;
-}
-                
-%typemap(javacode) struct layerObj %{
-        /* parent reference, RFC-24 item 3.2 */
-        mapObj map=null;
-%}
-
-%typemap(javacode) struct classObj %{
-        /* parent reference, RFC-24 item 3.2 */
-        layerObj layer=null;
-%}
diff -pruN 8.0.1-5/mapscript/java/makefile.vc 8.2.0~beta1-1~exp1/mapscript/java/makefile.vc
--- 8.0.1-5/mapscript/java/makefile.vc	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/makefile.vc	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-
-#
-# SWIG Stuff
-#
-#SWIG_HOME="D:\swig\SWIG-1.3.23\"  <- should get this from ..\..\nmake.opt
-#SWIG=$(SWIG_HOME)\swig
-
-!INCLUDE ..\..\nmake.opt
-
-MS_LIB = 	mapscript.lib
-MS_LIB_DLL  =	mapscript_i.lib
-
-#
-# Java Stuff
-#JAVA_HOME = "C:\Progra~1\Java\jdk1.5.0" <- should get this from ..\..\nmake.opt
-JAVADOC=$(JAVA_HOME)\bin\javadoc
-JAVAC=$(JAVA_HOME)\bin\javac
-JAVA=$(JAVA_HOME)\bin\java
-JAR=$(JAVA_HOME)\bin\jar
-JAVA_INCLUDE=-I$(JAVA_HOME)\include -I$(JAVA_HOME)\include\win32
-
-CC=     cl /MD
-LINK=   link
-
-MS_DLL = javamapscript.dll
-
-BASE_CFLAGS = 	$(OPTFLAGS) -DWIN32 -D_WIN32
-LDFLAGS =	/NODEFAULTLIB:"MSVCRTD" /NODEFAULTLIB:libcd /NODEFAULTLIB:libcmtd /NODEFAULTLIB:msvcrtd /NODEFAULTLIB:LIBC /DEBUG
-
-
-all: interface_release mapscript_java mapscript_lib mapscript_jar
-
-interface_release: 
-        -md edu\umn\gis\mapscript
-        $(SWIG) -java -package edu.umn.gis.mapscript -outdir edu/umn/gis/mapscript -o mapscript_wrap.c ../mapscript.i
-
-
-mapscript_java:
-	$(JAVAC) edu\umn\gis\mapscript\*.java
-
-mapscript_wrap:
-        $(CC) $(BASE_CFLAGS) $(MS_CFLAGS) $(JAVA_INCLUDE) /c mapscript_wrap.c  /Fomapscript_wrap.obj
-
-.c.obj:	
-	$(CC) $(BASE_CFLAGS) $(MS_CFLAGS) $(JAVA_INCLUDE) /c $*.c /Fo$*.obj
-
-mapscript_lib: mapscript_wrap.obj
-        link /dll /debug \
-		mapscript_wrap.obj $(EXTERNAL_LIBS) ..\..\mapserver_i.lib $(LDFLAGS) /def:..\..\mapserver.def \
-                /out:$(MS_DLL) /implib:$(MS_LIB_DLL)
-	if exist $(MS_DLL).manifest mt -manifest $(MS_DLL).manifest -outputresource:$(MS_DLL);2
-
-mapscript_javadoc:
-	$(JAVADOC) -d doc -sourcepath edu/umn/gis/mapscript/*.java
-		
-mapscript_jar:
-	$(JAR) cf mapscript.jar edu
-test:
-	$(JAVAC) -classpath ./mapscript.jar -d examples\ examples\*.java
-	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. DumpShp ../../tests/point.shp
-	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. ShapeInfo ..\..\tests\point.shp ..\..\tests\point.dbf
-	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. DrawMap ..\..\tests\test.map .\map.png
-	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. RFC24 ..\..\tests\test.map
-
-threadtests:
-	$(JAVAC) -cp ./mapscript.jar -d tests/threadtest/ tests/threadtest/*.java
-	@echo "-------------------------------------------------------------------------"
-	@echo "   You can use your own map! Copy the following command in your shell"
-	@echo "        and change the file to the map file (the last argument)"
-	@echo "-------------------------------------------------------------------------"
-	$(JAVA) -cp tests/threadtest/;./mapscript.jar -Djava.library.path=. MapTest -t 10 -i 5 ../../tests/test.map
-
-clean:
-	-del *.obj
-	-del *.lib
-	-rmdir /s /q edu
-	del $(MS_DLL)
-	del $(MS_DLL).manifest
-	del mapscript_wrap.c
-	del mapscript.jar
-	del *.ilk
-	del *.pdb
-	del *.exp
diff -pruN 8.0.1-5/mapscript/java/run_test.sh 8.2.0~beta1-1~exp1/mapscript/java/run_test.sh
--- 8.0.1-5/mapscript/java/run_test.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/run_test.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,23 +0,0 @@
-#!/bin/sh -ex
-
-JAVA=${JAVA_HOME}/bin/java
-JAVAC=${JAVA_HOME}/bin/javac
-
-${JAVAC} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -d examples/ examples/RFC24.java examples/ConnPool.java examples/DrawMap.java examples/DumpShp.java examples/MakePoint.java examples/QueryByAttribute.java examples/ShapeInfo.java examples/WxSTest.java examples/Metadata.java examples/RunTimeBuiltWMSClient.java examples/WxSTestNoThread.java
-${JAVAC} -encoding utf8 -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -d examples/ examples/QueryByAttributeUnicode.java 
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} DumpShp ../../tests/point.shp
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} ShapeInfo ../../tests/point.shp ../../tests/point.dbf
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} DrawMap ../../tests/test.map ./map.png
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} ConnPool
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} QueryByAttribute ../../tests/test.map
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} WxSTest ../../tests/test.map
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} WxSTestNoThread ../../tests/test.map
-${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} RFC24 ../../tests/test.map
-LC_ALL=en_US.UTF-8 ${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} QueryByAttributeUnicode data/subset-umlauts.map
-
-${JAVAC} -cp ${JAVA_MAPSCRIPT_SO}/mapscript.jar -d tests/threadtest/ tests/threadtest/*.java
-#-------------------------------------------------------------------------
-#  You can use your own map! Copy the following command in your shell
-#      and change the file to the map file (the last argument)
-#-------------------------------------------------------------------------
-${JAVA} -Djava.library.path=${JAVA_MAPSCRIPT_SO} -classpath tests/threadtest/:${JAVA_MAPSCRIPT_SO}/mapscript.jar MapTest -t 50 -i 5 ../../tests/test.map
diff -pruN 8.0.1-5/mapscript/java/tests/threadtest/MapTest.java 8.2.0~beta1-1~exp1/mapscript/java/tests/threadtest/MapTest.java
--- 8.0.1-5/mapscript/java/tests/threadtest/MapTest.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/tests/threadtest/MapTest.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-// $Id$
-//
-// See README_THREADTEST.TXT for usage details.
-//
-
-public class MapTest {
-    public static void main(String args[]) {
-        String      mapfile = null;
-        Integer     threads = null;
-        Integer     iterations = null;
-
-        for( int i = 0; i < args.length; i++ ) {
-            if( "-t".equals(args[i]) ) {
-                i++;
-                threads = new Integer(args[i]);
-                continue;
-            }
-            if( "-i".equals(args[i]) ) {
-                i++;
-                iterations = new Integer(args[i]);
-                continue;
-            }
-
-            mapfile = args[i];
-        }
-
-        Thread[]    tpool = new Thread[threads.intValue()];
-        for( int i = 0; i < tpool.length; i++ ) {
-            tpool[i] = new MapThread(mapfile, iterations.intValue(), i);
-        }
-        for( int i = 0; i < tpool.length; i++ ) {
-            tpool[i].start();
-        }
-    }
-}
diff -pruN 8.0.1-5/mapscript/java/tests/threadtest/MapThread.java 8.2.0~beta1-1~exp1/mapscript/java/tests/threadtest/MapThread.java
--- 8.0.1-5/mapscript/java/tests/threadtest/MapThread.java	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/tests/threadtest/MapThread.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,105 +0,0 @@
-// $Id$
-//
-// See README_THREADTEST.TXT for usage details.
-//
-
-
-import edu.umn.gis.mapscript.*;
-
-public class MapThread extends Thread {
-    MapThread(String mapfile, int iterations, int id) {
-        this.mapfile = mapfile;
-        this.iterations = iterations;
-	this.id=id;
-    }
-
-    public void run() {
-	System.out.println("Thread "+id+" running...");
-
-	/*
-		Uncomment this if you need to reschedule threads
-	if (id>=5) {
-		try {
-			sleep(10000);
-		} catch(InterruptedException ie) {
-			ie.printStackTrace();
-		}
-	}
-	*/
-
-        for( int i = 0; i < iterations; i++ ) {
-            mapObj  map = new mapObj(mapfile);
-	    long path=Math.round(Math.random()*10);
-
-	    if ( path > 5  ) {
-	       System.out.println("Thread "+id+"-"+i+" querying...");
-	       query(map);
-	    } else {
-	       System.out.println("Thread "+id+"-"+i+" using geos to create a buffer...");
-	       try {
-               	  createBuffer(map);
-	       } catch(Exception e) {
-		   System.out.println("have you enabled GEOS support? "+e.getMessage());
-	       }
-	    }
-   	    // We use this to test swig's memory management code
-	    //System.gc();
-            //map.draw().save("/tmp/mapthread"+id+"-"+i+".png", map);
-            map.draw();
-	    
-        }
-	mapscript.msConnPoolCloseUnreferenced();
-	System.out.println("Thread "+id+" done.");
-    }
-
-    public void createBuffer(mapObj map) {
-
-	layerObj layer = map.getLayer(3);
-	if (layer!=null) {
-		layer.open();
-		layer.queryByIndex(map,0,-1,mapscriptConstants.MS_FALSE);
-		shapeObj shape=layer.getShape(layer.getResults().getResult(0));
-		if (shape!=null) {
-			shapeObj buffer=shape.buffer(0.1);
-			if (buffer != null) {
-				layerObj bufferLayer=new layerObj(map);
-				bufferLayer.setStatus(mapscriptConstants.MS_DEFAULT);
-				bufferLayer.setDebug(mapscriptConstants.MS_ON);
-				bufferLayer.setName("BUFFER");
-				//bufferLayer.setType(mapscriptConstants.MS_LAYER_POLYGON);
-				bufferLayer.setProjection("init=epsg:4326");
-				bufferLayer.setType(MS_LAYER_TYPE.MS_LAYER_POINT);
-				bufferLayer.setOpacity(50);
-				classObj clazz=new classObj(bufferLayer);
-				clazz.setName("Buffer class");
-				styleObj style=new styleObj(clazz);
-				colorObj green=new colorObj(0,254,0,255);
-				//green.setRGB(0,254,0);
-				style.setColor(green);
-				bufferLayer.addFeature(buffer);
-
-			} else {
-				System.out.println("Buffer shape is NULL!");
-			}
-		}
-	}	
-    }
-
-    public void query(mapObj map) {
-
-	layerObj layer = map.getLayer(3);
-	if (layer!=null) {
-	   layer.setTemplate("template.html");
-	   String filter="A Point";
-
-	   layer.queryByAttributes(map,"FNAME", filter, mapscriptConstants.MS_MULTIPLE);
-	   layer.open();
-	   System.out.println( " numresults: " +layer.getNumResults() );
-	   layer.close();
-	}
-    }
-
-    String      mapfile;
-    int         iterations;
-    int 	id;
-}
diff -pruN 8.0.1-5/mapscript/java/tests/threadtest/README_THREADTEST.TXT 8.2.0~beta1-1~exp1/mapscript/java/tests/threadtest/README_THREADTEST.TXT
--- 8.0.1-5/mapscript/java/tests/threadtest/README_THREADTEST.TXT	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/java/tests/threadtest/README_THREADTEST.TXT	1970-01-01 00:00:00.000000000 +0000
@@ -1,132 +0,0 @@
------------------------------------
-June, 28th 2006
-Umberto Nicoletti (umberto.nicoletti@gmail.com)
-
-I have added more functionality to the thread test by integrating it
-in the Makefile so that it can be ran more easily and by adding a
-query by attribute and a buffer functions. The latter requires GEOS
-support in mapserver.
-
-It is best to run the tests with MALLOC_CHECK_ variable set to 2 so
-that memory errors are detected and reported (the jvm will crash
-on the first error so it should be quite noticeable ;-) ).
-
--------- Original Message --------
-Subject: [UMN_MAPSERVER-DEV] Multithreaded Mapscript
-Date: Mon, 6 Jun 2005 19:22:41 -0700
-From: Jerry Pisk <jerry.pisk@GMAIL.COM>
-Reply-To: Jerry Pisk <jerry.pisk@GMAIL.COM>
-To: MAPSERVER-DEV@LISTS.UMN.EDU
-
-Hi everybody,
-
-as I mentioned in my previous e-mail I was able to get mapserver to
-work in a multithreaded program. But the code I covered was just a
-fraction of mapserver's code, I only tested mapfile load and map
-drawing from a PostGIS backend. Since I do not have the resources to
-do extensive testing I decided to share what I've done with the
-community. I wrote a simple Java program that creates a number of
-threads and executes map operations on them. It uses Java mapscript to
-call mapserver. The following assumes a JDK (I used 1.5 but older
-versions should work as well) is installed and JAVA_HOME points to it.
-
-There are two source files:
-================  MapTest.java  ================
-
-public class MapTest {
-    public static void main(String args[]) {
-        String      mapfile = null;
-        Integer     threads = null;
-        Integer     iterations = null;
-
-        for( int i = 0; i < args.length; i++ ) {
-            if( "-t".equals(args[i]) ) {
-                i++;
-                threads = new Integer(args[i]);
-                continue;
-            }
-            if( "-i".equals(args[i]) ) {
-                i++;
-                iterations = new Integer(args[i]);
-                continue;
-            }
-
-            mapfile = args[i];
-        }
-
-        Thread[]    tpool = new Thread[threads.intValue()];
-        for( int i = 0; i < tpool.length; i++ ) {
-            tpool[i] = new MapThread(mapfile, iterations.intValue());
-        }
-        for( int i = 0; i < tpool.length; i++ ) {
-            tpool[i].start();
-        }
-    }
-}
-================================================
-
-================  MapThread.java  ================
-
-import edu.umn.gis.mapscript.mapObj;
-
-public class MapThread extends Thread {
-    MapThread(String mapfile, int iterations) {
-        this.mapfile = mapfile;
-        this.iterations = iterations;
-    }
-
-    public void run() {
-        mapObj  map = new mapObj(mapfile);
-
-        for( int i = 0; i < iterations; i++ ) {
-            map.draw();
-            // Add additional test code here
-        }
-    }
-
-    String      mapfile;
-    int         iterations;
-}
-================================================
-
-To use these simply compile mapserver and mapscript (for java you may
-need to run 'make interface' in mapscript/java). Save the two Java
-files into a directory of your choice. Compile them (point to your
-mapscript.jar, in mapscript/java/):
-
-$JAVA_HOME/bin/javac -cp ./mapscript.jar *.java
-
-and execute:
-
-$JAVA_HOME/bin/java -Djava.library.path=./ -cp ./:./mapscript.jar
-MapTest -t <t> -i <i> <map file>
-
-where <t> is the number of threads to create, <i> is the number of
-iterations to execute on each thread and <map file> is a full path to
-your map file. Again, make sure you point to your mapscript.jar and
-point to where libmapscript.so is in that java.library.path definition
-(I copied those two files into the same directory as the Java code but
-your setup may differ).
-
-There were occasional libgd related errors (Unable to initialize
-image) but those simply resulted in an exception being thrown, which
-is in my humble opinion acceptable, as long as the code does not
-crash.
-
-The code does no error checking, feel free to add it but this is
-really meant to be a developer's troubleshooting tool, not an end user
-utility. Also if a map drawing fails that thread will simply exit
-without finishing its number of iterations.
-
-The point of all this is to help make mapserver thread safe. The code
-above is meant as a simple starting point that should help mapserver
-developers test the code in a multithreaded application. Any comments
-and thoughts or even module tests (I do not have the resources to test
-a lot of mapserver's code, especially all the various data back ends)
-will be appreciated.
-
-Jerry Pisk
-
-
-----------
-$Id$
diff -pruN 8.0.1-5/mapscript/mapscript.i 8.2.0~beta1-1~exp1/mapscript/mapscript.i
--- 8.0.1-5/mapscript/mapscript.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/mapscript.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,330 +0,0 @@
-/* 
-===========================================================================
- $Id$
- 
- Project:  MapServer
- Purpose:  SWIG interface file for the MapServer mapscript module
- Author:   Steve Lime 
-           Sean Gillies, sgillies@frii.com
-             
- ===========================================================================
- Copyright (c) 1996-2005 Regents of the University of Minnesota.
-  
- Permission is hereby granted, free of charge, to any person obtaining a
- copy of this software and associated documentation files (the "Software"),
- to deal in the Software without restriction, including without limitation
- the rights to use, copy, modify, merge, publish, distribute, sublicense,
- and/or sell copies of the Software, and to permit persons to whom the
- Software is furnished to do so, subject to the following conditions:
- 
- The above copyright notice and this permission notice shall be included
- in all copies or substantial portions of the Software.
- 
- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- DEALINGS IN THE SOFTWARE.
-============================================================================
-*/
-
-%begin %{
-#ifdef _MSC_VER
-#define SWIG_PYTHON_INTERPRETER_NO_DEBUG
-#else
-#define _GNU_SOURCE 1
-#endif
-%}
-
-#ifndef SWIGPHPNG
-%module mapscript
-#else
-%module mapscriptng
-#endif
-
-#ifdef SWIGCSHARP
-%ignore frompointer;
-%include swig_csharp_extensions.i
-#endif
-
-#ifdef SWIGJAVA
-%ignore layerObj::extent;
-#endif
-
-%newobject msLoadMapFromString;
-
-%{
-#include "../../mapserver.h"
-#include "../../maptemplate.h"
-#include "../../mapogcsld.h"
-#include "../../mapows.h"
-#include "../../cgiutil.h"
-#include "../../mapcopy.h"
-#include "../../maperror.h"
-#include "../../mapprimitive.h"
-#include "../../mapshape.h"
-
-#if defined(_WIN32) && defined(SWIGCSHARP)
-/* <windows.h> is needed for GetExceptionCode() for unhandled exception */
-#include <windows.h>
-#endif
-
-%}
-
-/* Problem with SWIG CSHARP typemap for pointers */
-#ifndef SWIGCSHARP
-%include typemaps.i
-#endif
-
-%include constraints.i
-
-%include carrays.i
-%array_class(int, intarray)
-
-/* 
-===========================================================================
- Supporting 'None' as an argument to attribute accessor functions
-
- Typemaps to support NULL in attribute accessor functions
- provided to Steve Lime by David Beazley and tested for Python
- only by Sean Gillies.
-   
- With the use of these typemaps we can execute statements like
-
-   layer.group = None
-
-============================================================================
-*/
-
-#ifdef __cplusplus
-%typemap(memberin) char * {
-  if ($1) delete [] $1;
-  if ($input) {
-     $1 = ($1_type) (new char[strlen($input)+1]);
-     strcpy((char *) $1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-%typemap(memberin,warning="451:Setting const char * member may leak
-memory.") const char * {
-  if ($input) {
-     $1 = ($1_type) (new char[strlen($input)+1]);
-     strcpy((char *) $1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-%typemap(globalin) char * {
-  if ($1) delete [] $1;
-  if ($input) {
-     $1 = ($1_type) (new char[strlen($input)+1]);
-     strcpy((char *) $1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-%typemap(globalin,warning="451:Setting const char * variable may leak
-memory.") const char * {
-  if ($input) {
-     $1 = ($1_type) (new char[strlen($input)+1]);
-     strcpy((char *) $1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-#else
-%typemap(memberin) char * {
-  if ($1) free((char*)$1);
-  if ($input) {
-     $1 = ($1_type) malloc(strlen($input)+1);
-     strcpy((char*)$1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-%typemap(memberin,warning="451:Setting const char * member may leak
-memory.") const char * {
-  if ($input) {
-     $1 = ($1_type) malloc(strlen($input)+1);
-     strcpy((char*)$1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-%typemap(globalin) char * {
-  if ($1) free((char*)$1);
-  if ($input) {
-     $1 = ($1_type) malloc(strlen($input)+1);
-     strcpy((char*)$1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-%typemap(globalin,warning="451:Setting const char * variable may leak
-memory.") const char * {
-  if ($input) {
-     $1 = ($1_type) malloc(strlen($input)+1);
-     strcpy((char*)$1,$input);
-  } else {
-     $1 = 0;
-  }
-}
-#endif /* __cplusplus */
-
-/* GD Buffer Mapping for use with imageObj::getBytes */
-%{
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-typedef struct {
-    unsigned char *data;
-    int size;
-    int owns_data;
-} gdBuffer;
-
-#ifdef __cplusplus
-}
-#endif
-%}
-
-/* 
-============================================================================
- Exceptions
-
- Note: Python exceptions are in pymodule.i
-============================================================================
-*/
-
-#if defined(SWIGCSHARP) || defined(SWIGJAVA) || defined(SWIGRUBY) || defined(SWIGPHP7)
-%include "../mserror.i"
-#endif
-
-/* 
-============================================================================
- Language-specific module code
-============================================================================
-*/
-
-/* C# */
-#ifdef SWIGCSHARP
-%include "csmodule.i"
-#endif
-
-/* Java */
-#ifdef SWIGJAVA
-%include "javamodule.i"
-#endif
-
-/* Python */
-#ifdef SWIGPYTHON
-%include "pymodule.i"
-#endif /* SWIGPYTHON */
-
-/* Ruby */
-#ifdef SWIGRUBY
-%include "rbmodule.i"
-#endif
-
-/* Perl */
-#ifdef SWIGPERL5
-%include "plmodule.i"
-#endif
-
-/* Tcl */
-#ifdef SWIGTCL8
-%include "tclmodule.i"
-#endif /* SWIGTCL8 */
-
-/* PHP7 */
-#ifdef SWIGPHP7
-%include "php7module.i"
-#endif /* SWIGPHP7 */
-
-
-/* 
-=============================================================================
- Wrap MapServer structs into mapscript classes
-=============================================================================
-*/
-
-%include "../../mapserver.h"
-%include "../../mapserver-version.h"
-%include "../../mapprimitive.h"
-%include "../../maperror.h"
-%include "../../mapshape.h"
-%include "../../mapproject.h"
-%include "../../mapsymbol.h"
-%include "../../maphash.h"
-%include "../../maperror.h"
-%include "../../mapserv-config.h"
-
-%apply Pointer NONNULL { mapObj *map };
-%apply Pointer NONNULL { layerObj *layer };
-%apply Pointer NONNULL { configObj *config };
-
-/* 
-=============================================================================
- Class extension methods are now included from separate interface files  
-=============================================================================
-*/
-
-%include "../swiginc/error.i"
-%include "../swiginc/map.i"
-%include "../swiginc/mapzoom.i"
-%include "../swiginc/symbol.i"
-%include "../swiginc/symbolset.i"
-%include "../swiginc/layer.i"
-%include "../swiginc/class.i"
-%include "../swiginc/cluster.i"
-%include "../swiginc/style.i"
-%include "../swiginc/rect.i"
-%include "../swiginc/image.i"
-%include "../swiginc/shape.i"
-%include "../swiginc/point.i"
-%include "../swiginc/line.i"
-%include "../swiginc/shapefile.i"
-%include "../swiginc/outputformat.i"
-%include "../swiginc/projection.i"
-%include "../swiginc/dbfinfo.i"
-%include "../swiginc/labelcache.i"
-%include "../swiginc/color.i"
-%include "../swiginc/hashtable.i"
-%include "../swiginc/resultcache.i"
-%include "../swiginc/result.i"
-%include "../swiginc/owsrequest.i"
-%include "../swiginc/connpool.i"
-%include "../swiginc/msio.i"
-%include "../swiginc/web.i"
-%include "../swiginc/label.i"
-%include "../swiginc/scalebar.i"
-%include "../swiginc/legend.i"
-%include "../swiginc/referencemap.i"
-%include "../swiginc/querymap.i"
-%include "../swiginc/config.i"
-%include "../swiginc/reprojection.i"
-
-/* 
-=============================================================================
- Language-specific extensions to mapserver classes are included here 
-=============================================================================
-*/
-
-/* Java */
-#ifdef SWIGJAVA
-%include "javaextend.i"
-#endif
-
-/* Python */
-#ifdef SWIGPYTHON
-%include "pyextend.i"
-#endif /* SWIGPYTHON */
-
-/* Ruby */
-#ifdef SWIGRUBY
-%include "rbextend.i"
-#endif
-
diff -pruN 8.0.1-5/mapscript/mserror.i 8.2.0~beta1-1~exp1/mapscript/mserror.i
--- 8.0.1-5/mapscript/mserror.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/mserror.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,67 +0,0 @@
-/* 
-===========================================================================
- $Id$
- 
- Project:  MapServer
- Purpose:  MapScript exceptions
- Author:   Umberto Unicoletti, unicoletti@prometeo.it
-           Jerry Pisk, jerry.pisk@gmail.com
-           Sean Gillies, sgillies@frii.com
-           Tamas Szekeres, szekerest@gmail.com
-
- Note: Python exceptions are in mapscript/python
-       C# exceptions are redefinied in mapscript/csharp
-       
-       This implementation truncates the error message length
-       to MAX_ERROR_LEN since SWIG_exception does not allow
-       to free memory allocated on the heap easily (szekerest)
-============================================================================
-*/
-#define MAX_ERROR_LEN 8192
-%include exception.i
-
-%exception {
-    errorObj *ms_error;
-    $action
-    ms_error = msGetErrorObj();
-    if (ms_error!=NULL && ms_error->code != MS_NOERR) {
-        char ms_message[MAX_ERROR_LEN];
-        char* msg = msGetErrorString(";");
-        int ms_errorcode = ms_error->code;
-        if (msg) {
-			snprintf(ms_message, MAX_ERROR_LEN, "%s", msg);
-			free(msg);
-		}
-        else sprintf(ms_message, "Unknown message");
-
-        msResetErrorList();
-       
-        switch(ms_errorcode) {
-            case MS_NOTFOUND:
-                break;
-            case -1:
-                break;
-            case MS_IOERR:
-                SWIG_exception(SWIG_IOError ,ms_message);
-                break;
-            case MS_MEMERR:
-                SWIG_exception(SWIG_MemoryError,ms_message);
-                break;
-            case MS_TYPEERR:
-                SWIG_exception(SWIG_TypeError,ms_message);
-                break;
-            case MS_EOFERR:
-                SWIG_exception(SWIG_SyntaxError,ms_message);
-                break;
-            case MS_CHILDERR:
-                SWIG_exception(SWIG_SystemError,ms_message);
-                break;
-            case MS_NULLPARENTERR:
-                SWIG_exception(SWIG_SystemError,ms_message);
-                break;
-            default:
-                SWIG_exception(SWIG_UnknownError,ms_message);
-                break;
-        }       
-    }
-}
diff -pruN 8.0.1-5/mapscript/perl/CMakeLists.txt 8.2.0~beta1-1~exp1/mapscript/perl/CMakeLists.txt
--- 8.0.1-5/mapscript/perl/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,30 +0,0 @@
-find_package(SWIG REQUIRED)
-include(${SWIG_USE_FILE})
-find_package(Perl REQUIRED)
-find_package(PerlLibs REQUIRED)
-set(CUSTOM_PERL_SITE_ARCH_DIR ${PERL_SITEARCH} CACHE STRING "Custom installation directory for perl binary extension")
-include_directories(${PERL_INCLUDE_PATH})
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
-add_definitions(${PERL_EXTRA_C_FLAGS})
-set(CMAKE_SWIG_FLAGS -shadow -w314)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/perl)
-
-if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
-    swig_add_library(perlmapscript TYPE MODULE LANGUAGE perl5 SOURCES ../mapscript.i)
-else ()
-    swig_add_module(perlmapscript perl5 ../mapscript.i)
-endif ()
-
-SWIG_LINK_LIBRARIES(perlmapscript ${PERL_LIBRARIES} ${MAPSERVER_LIBMAPSERVER})
-set_target_properties(perlmapscript PROPERTIES OUTPUT_NAME mapscript)
-set_target_properties(perlmapscript PROPERTIES PREFIX "")
-if(APPLE)
-  set_target_properties(perlmapscript PROPERTIES SUFFIX ".bundle")
-endif(APPLE)
-
-install(FILES $<TARGET_FILE:${SWIG_MODULE_perlmapscript_REAL_NAME}> DESTINATION ${CUSTOM_PERL_SITE_ARCH_DIR}/auto/mapscript)
-install(FILES $<TARGET_FILE_DIR:${SWIG_MODULE_perlmapscript_REAL_NAME}>/mapscript.pm DESTINATION ${CUSTOM_PERL_SITE_ARCH_DIR})
-
-file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tests DESTINATION  ${CMAKE_CURRENT_BINARY_DIR})
-file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/examples DESTINATION  ${CMAKE_CURRENT_BINARY_DIR})
diff -pruN 8.0.1-5/mapscript/perl/README 8.2.0~beta1-1~exp1/mapscript/perl/README
--- 8.0.1-5/mapscript/perl/README	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,20 +0,0 @@
-To build type:
-
-  perl Makefile.PL
-  make
-  make install
-
-MapScript requires Swig version 1.3+. If you must re-SWIG things use a command like:
-
-  swig -perl5 -shadow -outdir . -o mapscript_wrap.c ../mapscript.i
-
-and then follow the sequence of steps to install mapscript. 
-
-If you need to change the name of the mapscript module (default=mapscript) you need to:
-
-  1) edit ../mapscript.i and change the name of the swig module
-  2) edit Makefile.PL and edit the name 'mapscript' in the WriteMakefile subroutine call
-  3) edit plmodule.i and change the name 'mapscript' to whatever the new name
-     will be throughout the file
-
-and now build as normal.
diff -pruN 8.0.1-5/mapscript/perl/examples/RFC24.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/RFC24.pl
--- 8.0.1-5/mapscript/perl/examples/RFC24.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/RFC24.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,104 +0,0 @@
-#!/usr/bin/perl
-use strict;
-use warnings;
-use mapscript;
-use Data::Dumper;
-
-my $file=$ARGV[0];
-
-# utility
-sub assertNotNull {
-	my ($o, $test) = @_;
-	if ($o) {
-		print $test . "  PASSED\n";
-	} else {
-		print $test . "  FAILED\n";
-	}
-}
-
-
-# layerObj
-sub testGetLayerObj {
-	my $map = new mapscript::mapObj($file);
-	my $layer = $map->getLayer(1);
-	$map = undef;
-	assertNotNull( $layer->{map} , "testGetLayerObj");
-	#$layer->{map}->draw()->save("/tmp/map.png");
-}
-
-sub testGetLayerObjByName {
-	my $map = new mapscript::mapObj($file);
-	my $layer = $map->getLayerByName("POLYGON");
-	$map = undef;
-	assertNotNull( $layer->{map} , "testGetLayerObjByName");
-}
-
-sub testLayerObj {
-	my $map = new mapscript::mapObj($file);
-	my $layer = new mapscript::layerObj($map);
-	$map = undef;
-	assertNotNull( $layer->{map} , "testLayerObj");
-}
-
-sub testInsertLayerObj {
-	my $map = new mapscript::mapObj($file);
-	my $layer = new mapscript::layerObj(undef);
-	my $position = $map->insertLayer($layer);
-	$map = undef;
-	assertNotNull( $position == 7 , "testInsertLayerObj position");
-	assertNotNull( $layer->{map} , "testInsertLayerObj notnull");
-}
-
-# classObj
-sub testGetClassObj {
-	#dumpHash(mapscript::getPARENT_PTRS());
-	my $map = new mapscript::mapObj($file);
-	my $layer = $map->getLayer(1);
-	my $clazz = $layer->getClass(0);
-	#dumpHash(mapscript::getPARENT_PTRS());
-	#$clazz->{layer}->{map}->draw()->save("/tmp/map1.png");
-	#print "parent layer=".$clazz->{layer}."\n";
-	$map = undef; $layer=undef;
-	#print "parent layer=".$clazz->{layer}."\n";
-	assertNotNull( $clazz->{layer} , "testGetClassObj");
-	#$clazz->{layer}->{map}->draw()->save("/tmp/map2.png");
-	#dumpHash(mapscript::getPARENT_PTRS());
-}
-
-sub testClassObj {
-	my $map = new mapscript::mapObj($file);
-	my $layer = $map->getLayer(1);
-	my $clazz = new mapscript::classObj($layer);
-	$map = undef; $layer=undef;
-	assertNotNull( $clazz->{layer} , "testClassObj");
-}
-
-sub testInsertClassObj {
-	my $map = new mapscript::mapObj($file);
-	my $layer = $map->getLayer(1);
-	my $clazz = new mapscript::classObj(undef);
-	my $position = $layer->insertClass($clazz);
-	$map = undef; $layer=undef;
-	assertNotNull( $position == 2 , "testInsertClassObj position");
-	assertNotNull( $clazz->{layer} , "testInsertClassObj notnull");
-}
-
-if ( ! $file ) {
-	print "Usage: RFC24.pl file.map\n";
-	exit 1;
-}
-
-testGetLayerObj;
-testGetLayerObjByName;
-testLayerObj;
-testInsertLayerObj;
-testGetClassObj;
-testClassObj;
-testInsertClassObj;
-
-my $hashmap = mapscript::getPARENT_PTRS();
-assertNotNull( keys( %$hashmap )==0 , "checking that hashmap of parent ptrs is empty");
-print "No of keys:".keys( %$hashmap )."\n";
-#dumpHash($hashmap);
-print Dumper( $hashmap );
-
diff -pruN 8.0.1-5/mapscript/perl/examples/buffer.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/buffer.pl
--- 8.0.1-5/mapscript/perl/examples/buffer.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/buffer.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-#!/usr/bin/perl
-#
-# Script : buffer.pl
-#
-# Purpose: Applies buffer to shapefile dataset using geos support
-#          buffer units as are per units of data
-#
-# $Id$
-#
-
-use strict;
-use warnings;
-use POSIX;
-use XBase;
-use mapscript;
-use Getopt::Long;
-use File::Copy;
-
-my ($infile, $outfile, $buffer);
-
-GetOptions("input=s", \$infile, "output=s", \$outfile, "buffer=n", \$buffer);
-
-if(!$infile or !$outfile or !$buffer) {
-  print "Usage: $0 --input=[filename] --output=[filename] --buffer=[native units]\n";
-  exit 0;
-}
-
-die "Tolerance must be greater than zero." unless $buffer > 0;
-
-# initialize counters for reporting
-my $incount  = 0;
-my $outcount = 0;
-
-# open the input shapefile
-my $inSHP = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile.";
-
-# create the output shapefile
-
-unlink "$outfile.shp";
-unlink "$outfile.shx";
-unlink "$outfile.dbf";
-
-my $outSHP = new mapscript::shapefileObj($outfile, $inSHP->{type}) or die "Unable to create shapefile '$outfile'. $!\n";
-
-copy("$infile.dbf", "$outfile.dbf") or die "Can't copy file $infile.dbf to $outfile.dbf: $!\n";
-
-my $inshape = new mapscript::shapeObj(-1); # something to hold shapes
-
-for(my $i=0; $i<$inSHP->{numshapes}; $i++) {
-  $inSHP->get($i, $inshape);
-  my $outshape = new mapscript::shapeObj(-1);
-
-  print "buffering feature: $i\n";
-
-  $outshape = $inshape->buffer($buffer) or die "Unable to buffer feature #$i: $!\n"; # in native map units
-
-  $outSHP->add($outshape);
-  undef($outshape); # free memory associated with shape
-
-} # for each shape
-
-$outSHP = ''; # write the file
-
-undef $inSHP;
-undef $outSHP;
-
diff -pruN 8.0.1-5/mapscript/perl/examples/distanceToPoint.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/distanceToPoint.pl
--- 8.0.1-5/mapscript/perl/examples/distanceToPoint.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/distanceToPoint.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
-#!/usr/bin/perl
-#
-# Script : distanceToPoint.pl
-#
-# Purpose: Returns distance between a shape and a point
-#
-# $Id$
-#
-
-use strict;
-use warnings;
-use POSIX;
-use XBase;
-use mapscript;
-use Getopt::Long;
-use File::Copy;
-
-my ($infile, $infile_shpid, $x, $y, $distance);
-
-GetOptions("infile=s", \$infile, "infile_shpid=s", \$infile_shpid, "x=s", \$x, "y=s", \$y);
-
-if(!$infile or !$infile_shpid or !$x or !$y) {
-  print "Usage: $0 --infile=[filename] --infile_shpid=[shpid] --x=[x] --y=[y]\n";
-  exit 0;
-}
-
-# open the first input shapefile
-my $inshpf = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile.";
-
-my $inshape = $inshpf->getShape($infile_shpid);
-
-my $inpt = new mapscript::pointObj($x, $y);
-
-$distance = $inshape->distanceToPoint($inpt);
-
-undef $inshpf;
-
-print "Distance between shape $infile/$infile_shpid and point $x $y is $distance\n";
-
diff -pruN 8.0.1-5/mapscript/perl/examples/distanceToShape.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/distanceToShape.pl
--- 8.0.1-5/mapscript/perl/examples/distanceToShape.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/distanceToShape.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,40 +0,0 @@
-#!/usr/bin/perl
-#
-# Script : distanceToShape.pl
-#
-# Purpose: Returns distance between two shapes
-#
-# $Id$
-#
-
-use strict;
-use warnings;
-use POSIX;
-use XBase;
-use mapscript;
-use Getopt::Long;
-use File::Copy;
-
-my ($infile1, $infile1_shpid, $infile2, $infile2_shpid, $distance);
-
-GetOptions("infile1=s", \$infile1, "infile1_shpid=s", \$infile1_shpid, "infile2=s", \$infile2, "infile2_shpid=s", \$infile2_shpid);
-
-if(!$infile1 or !$infile1_shpid or !$infile2 or !$infile2_shpid) {
-  print "Usage: $0 --infile1=[filename] --infile1_shpid=[shpid] --infile2=[filename] --infile2_shpid=[shpid]\n";
-  exit 0;
-}
-
-# open the first input shapefile
-my $inshpf1 = new mapscript::shapefileObj($infile1, -1) or die "Unable to open shapefile $infile1.";
-my $inshpf2 = new mapscript::shapefileObj($infile2, -1) or die "Unable to open shapefile $infile2.";
-
-my $inshape1 = $inshpf1->getShape($infile1_shpid);
-my $inshape2 = $inshpf2->getShape($infile2_shpid);
-
-$distance = $inshape1->distanceToShape($inshape2);
-
-undef $inshpf1;
-undef $inshpf2;
-
-print "Distance between shape $infile1/$infile1_shpid and shape $infile2/$infile2_shpid is $distance units\n";
-
diff -pruN 8.0.1-5/mapscript/perl/examples/dump.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/dump.pl
--- 8.0.1-5/mapscript/perl/examples/dump.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/dump.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-#!/usr/bin/perl
-
-use strict;
-use warnings;
-use mapscript;
-use Getopt::Long;
-
-my $file;
-my %types = ( '1' => 'point',
-	      '3' => 'arc',
-	      '5' => 'polygon',
-	      '8' => 'multipoint'
-	    );
-
-GetOptions("file=s", \$file);
-
-if(!$file) {
-  print "Syntax: dump.pl --file=[filename]\n";
-  exit 0;
-}
-
-my $shapefile = new mapscript::shapefileObj($file, -1) or die "Unable to open shapefile $file";
-
-print "Shapefile opened (type=". $types{$shapefile->{type}} .") with ".
-$shapefile->{numshapes} ." shape(s)\n";
-
-my $shape = new mapscript::shapeObj(-1);
-
-for(my $i=0; $i<$shapefile->{numshapes}; $i++) {
-    
-    $shapefile->get($i, $shape);
-
-    print "Shape $i has ". $shape->{numlines} ." part(s) - ";
-    printf "bounds (%f,%f) (%f,%f)\n", $shape->{bounds}->{minx}, $shape->{bounds}->{miny}, $shape->{bounds}->{maxx}, $shape->{bounds}->{maxy};
-
-    for(my $j=0; $j<$shape->{numlines}; $j++) {
-        my $part = $shape->get($j);
-        print "Part $j has ". $part->{numpoints} ." point(s)\n";
-
-        for(my $k=0; $k<$part->{numpoints}; $k++) {
-            my $point = $part->get($k);
-            print "$k: ". $point->{x} .", ". $point->{y} ."\n";
-        }
-    }
-}
diff -pruN 8.0.1-5/mapscript/perl/examples/shapeprops.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/shapeprops.pl
--- 8.0.1-5/mapscript/perl/examples/shapeprops.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/shapeprops.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,46 +0,0 @@
-#!/usr/bin/perl
-#
-# Script : shapeprops.pl
-#
-# Purpose: Applies area, perimeter and centroid calculations to a shapes
-#          in a shapefile (requires mapserver/mapscript to be built with GEOS)
-#
-# $Id$
-#
-
-use strict;
-use warnings;
-use mapscript;
-
-@ARGV == 1 or die "Usage: $0 <shapefile>\n";
-
-# open the shapefile
-my $sf = new mapscript::shapefileObj($ARGV[0], -1) or die "Unable to open shapefile $ARGV[0]: $!\n";
-
-# loop over every shape
-for(my $i = 0; $i < $sf->{numshapes}; $i++) {
-  # fetch the shape
-  my $s = $sf->getShape($i);
-
-  # calculate area
-  my $a = $s->getArea();
-
-  # calculate length / perimeter
-  my $l = $s->getLength();
-
-  # calculate centroid
-  my $c = $s->getCentroid();
-
-  print <<END;
-
-Area of shape $i: $a
-Length / Perimeter of shape $i: $l
-Centroid of shape $i: $c->{x}, $c->{y}
-END
-
-  # free shape
-  undef $s;
-}
-
-# free shapefile
-undef $sf;
diff -pruN 8.0.1-5/mapscript/perl/examples/shpPoint2GPX.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/shpPoint2GPX.pl
--- 8.0.1-5/mapscript/perl/examples/shpPoint2GPX.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/shpPoint2GPX.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,109 +0,0 @@
-#!/usr/bin/perl
-#
-# Script : shpPoint2GPX.pl
-#
-# Purpose: Converts a Point shapefile to a GPX document
-#          as per http://www.topografix.com/gpx.asp
-#
-# $Id$
-#
-
-use strict;
-use warnings;
-use POSIX;
-use XBase;
-use mapscript;
-use Getopt::Long;
-
-my ($infile, $outfile, $namecol);
-
-GetOptions("input=s", \$infile, "output=s", \$outfile, "namecol=s", \$namecol);
-
-if(!$infile or !$outfile or !$namecol) {
-  print "Usage: $0 --input=[filename] --output=[filename] --namecol=[namecol]\n"; 
-  exit 0;
-}
-
-# open the input shapefile and dbf
-my $shapefile = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile: $!\n";
-my $table     = new XBase "$infile" or die XBase->errstr;
-
-if ($shapefile->{type} != 1) {
-  print "input shapefile must be of type point\n";
-  exit 0;
-}
-
-# unlink and create the output GPX document
-unlink "$outfile.gpx";
-
-open(GPX, ">$outfile.gpx") or die "Unable to open GPX document $outfile.gpx: $!\n";
-
-# print the GPX header info
-print <<END;
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<gpx creator="shpPoint2GPX.pl" version="1.1" xsi:schemaLocation="http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd" xmlns="http://www.topografix.com/GPX/1/1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ms="http://mapserver.gis.umn.edu/mapserver">
-	<metadata>
-		<name>$outfile.gpx</name>
-		<desc>Description</desc>
-		<author>
-			<name>Name</name>
-			<email id="foouser" domain="mapserver.gis.umn.edu"/>
-			<link href="http://mapserver.gis.unm.edu/">
-				<text>Welcome to MapServer</text>
-				<type>text/html</type>
-			</link>
-		</author>
-		<copyright author="Regents of the University of Minnesota">
-			<year>2007</year>
-			<license>http://mapserver.gis.umn.edu/License</license>
-		</copyright>
-		<link href="http://mapserver.gis.unm.edu/">
-			<text>Welcome to MapServer</text>
-			<type>text/html</type>
-		</link>
-		<time>2001-12-17T09:30:47.0Z</time>
-		<keywords>MapServer, mapscript, perl, GPX, GPS</keywords>
-		<bounds maxlat="$shapefile->{bounds}->{maxx}" maxlon="$shapefile->{bounds}->{maxy}" minlat="$shapefile->{bounds}->{miny}" minlon="$shapefile->{bounds}->{minx}"/>
-		<extensions/>
-	</metadata>
-END
-
-my $shape = new mapscript::shapeObj(-1); # something to hold shapes
-
-# print each shape as a waypoint
-for(my $i=0; $i<$shapefile->{numshapes}; $i++) {
-  $shapefile->get($i, $shape);
-
-  for(my $j=0; $j<$shape->{numlines}; $j++) {
-    my $part = $shape->get($j);
-    for(my $k=0; $k<$part->{numpoints}; $k++) {
-      my $point = $part->get($k);
-      my %row = $table->get_record_as_hash($j) or die $table->errstr;
-      delete $row{"_DELETED"};
-      print "\t<wpt lat=\"$point->{y}\" lon=\"$point->{x}\">\n";
-
-      if ($row{uc($namecol)}) {
-        print "\t\t<name>$row{$namecol}</name>\n";
-      }
-
-      # print out the dbf values as GPX extensions
-      print "\t\t<extensions>\n";
-
-      foreach my $k (keys %row) {
-        print "\t\t\t<ms:$k><![CDATA[$row{$k}]]></ms:$k>\n";
-      }
-      print "\t\t</extensions>\n\t</wpt>\n";
-    }
-  }
-} # for each shape
-
-print <<END;
-	<extensions>
-		<ms:numshapes>$shapefile->{numshapes}</ms:numshapes>
-		<ms:source>$shapefile->{source}</ms:source>
-	</extensions>
-</gpx>
-END
-
-undef $shapefile;
-close(GPX);
diff -pruN 8.0.1-5/mapscript/perl/examples/shp_in_shp.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/shp_in_shp.pl
--- 8.0.1-5/mapscript/perl/examples/shp_in_shp.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/shp_in_shp.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,46 +0,0 @@
-#!/usr/bin/perl
-#
-# Script : shp_in_shp.pl
-#
-# Purpose: Tests whether a shape is within another shape
-#
-# $Id$
-#
-
-use strict;
-use warnings;
-use mapscript;
-use Getopt::Long;
-use File::Copy;
-
-my ($infile1, $infile1_shpid, $infile2, $infile2_shpid, $within);
-
-GetOptions("infile1=s", \$infile1, "infile1_shpid=s", \$infile1_shpid, "infile2=s", \$infile2, "infile2_shpid=s", \$infile2_shpid);
-
-# shpid can be zero, which looks false, so use defined()
-if(!$infile1 or !defined($infile1_shpid) or !$infile2 or !defined($infile2_shpid)) {
-  print "Usage: $0 --infile1=[filename] --infile1_shpid=[shpid] --infile2=[filename] --infile2_shpid=[shpid]\n";
-  exit 0;
-}
-
-# open the first input shapefile
-my $inshpf1 = new mapscript::shapefileObj($infile1, -1) or die "Unable to open shapefile $infile1.";
-my $inshpf2 = new mapscript::shapefileObj($infile2, -1) or die "Unable to open shapefile $infile2.";
-
-my $inshape1 = $inshpf1->getShape($infile1_shpid);
-my $inshape2 = $inshpf2->getShape($infile2_shpid);
-
-$within = $inshape1->within($inshape2);
-
-if ($within == 1) {
-  $within = "WITHIN";
-}
-elsif ($within == 0) {
-  $within = "NOT WITHIN";
-}
-
-undef $inshpf1;
-undef $inshpf2;
-
-print "Shape $infile1/$infile1_shpid is $within shape $infile2/$infile2_shpid\n";
-
diff -pruN 8.0.1-5/mapscript/perl/examples/shpinfo.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/shpinfo.pl
--- 8.0.1-5/mapscript/perl/examples/shpinfo.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/shpinfo.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,41 +0,0 @@
-#!/usr/bin/perl
-
-use strict;
-use warnings;
-use XBase;
-use mapscript;
-use Getopt::Long;
-
-my $file;
-
-my %types = ( '1' => 'point',
-              '3' => 'arc',
-              '5' => 'polygon',
-              '8' => 'multipoint'
-            );
-
-GetOptions("file=s", \$file);
-if(!$file) {
-  print "Syntax: shpinfo.pl --file=[filename]\n";
-  exit 0;
-}
-
-my $shapefile = new mapscript::shapefileObj($file, -1) or die "Unable to open shapefile $file.";
-
-print "Shapefile $file:\n\n";
-print "\ttype: ". $types{$shapefile->{type}} ."\n"; 
-print "\tnumber of features: ". $shapefile->{numshapes} ."\n";
-printf "\tbounds: (%f,%f) (%f,%f)\n", $shapefile->{bounds}->{minx}, $shapefile->{bounds}->{miny}, $shapefile->{bounds}->{maxx}, $shapefile->{bounds}->{maxy};
-
-my $table = new XBase $file.'.dbf' or die XBase->errstr;
-
-print "\nXbase table $file.dbf:\n\n";
-
-print "\tnumber of records: ". ($table->last_record+1) ."\n";
-print "\tnumber of fields: ". ($table->last_field+1) ."\n\n";
-
-print "\tName             Type Length Decimals\n";
-print "\t---------------- ---- ------ --------\n";
-foreach ($table->field_names) {
-  printf "\t%-16s %4s %6d %8d\n", $_, $table->field_type($_), $table->field_length($_), $table->field_decimal($_)
-}
diff -pruN 8.0.1-5/mapscript/perl/examples/thin.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/thin.pl
--- 8.0.1-5/mapscript/perl/examples/thin.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/thin.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,132 +0,0 @@
-#!/usr/bin/perl
-# Script : thin.pl
-#
-# Purpose: An adaption of the ArcView Avenue example script genfeat.ave. It's
-#          basically the Douglas-Peucker generalization algorithm.
-#          (http://mapserver.gis.umn.edu/community/scripts/thin.pl)
-#
-# $Id$
-#
-
-use strict;
-use warnings;
-use mapscript;
-use Getopt::Long;
-use File::Copy;
-
-my ($infile, $outfile, $tolerance);
-
-GetOptions("input=s", \$infile, "output=s", \$outfile, "tolerance=n", \$tolerance);
-
-if(!$infile or !$outfile or !$tolerance) {
-  print "Usage: $0 --input=[filename] --output=[filename] --tolerance=[maximum distance between vertices]\n";
-  exit 0;
-}
-
-die "Tolerance must be greater than zero." unless $tolerance > 0;
-
-# initialize counters for reporting
-my $incount  = 0;
-my $outcount = 0;
-
-# open the input shapefile
-my $inSHP = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile.";
-
-die "Cannot thin point/multipoint shapefiles." unless ($inSHP->{type} == 5 or $inSHP->{type} == 3);
-
-# create the output shapefile
-
-unlink "$outfile.shp";
-unlink "$outfile.shx";
-unlink "$outfile.dbf";
-
-my $outSHP = new mapscript::shapefileObj($outfile, $inSHP->{type}) or die "Unable to create shapefile '$outfile'. $!\n";
-
-copy("$infile.dbf", "$outfile.dbf") or die "Can't copy file $infile.dbf to $outfile.dbf: $!\n";
-
-my $inshape = new mapscript::shapeObj(-1); # something to hold shapes
-
-for(my $i=0; $i<$inSHP->{numshapes}; $i++) {
-
-  $inSHP->get($i, $inshape);
-  my $outshape = new mapscript::shapeObj(-1);
-
-  for(my $j=0; $j<$inshape->{numlines}; $j++) {
-
-    my $inpart  = $inshape->get($j);
-    my $outpart = new mapscript::lineObj();
-
-    my @stack = ();
-
-    $incount += $inpart->{numpoints};
-
-    my $anchor = $inpart->get(0); # save first point
-    $outpart->add($anchor);
-    my $aIndex = 0;
-
-    my $fIndex = $inpart->{numpoints} - 1;
-    push @stack, $fIndex;
-
-    # Douglas - Peucker algorithm
-    while(@stack) {
-
-      $fIndex = $stack[$#stack];
-      my $fPoint = $inpart->get($fIndex);
-
-      my $max = $tolerance; # comparison values
-      my $maxIndex = 0;
-
-      # process middle points
-      for (($aIndex+1) .. ($fIndex-1)) {
-
-        my $point = $inpart->get($_);
-        #my $dist = $point->distanceToLine($anchor, $fPoint);
-        my $dist = $point->distanceToSegment($anchor, $fPoint);
-
-        if($dist >= $max) {
-          $max = $dist;
-          $maxIndex = $_;
-        }
-      }
-
-      if($maxIndex > 0) {
-        push @stack, $maxIndex;
-      } else {
-        $outpart->add($fPoint);
-        $anchor = $inpart->get(pop @stack);
-        $aIndex = $fIndex;
-      }
-    }
-
-    # check for collapsed polygons, use original data in that case
-    if(($outpart->{numpoints} < 4) and ($inSHP->{type} == 5)) {
-      $outpart = $inpart;
-    }
-
-    $outcount += $outpart->{numpoints};
-    $outshape->add($outpart);
-
-  } # for each part
-
-  $outSHP->add($outshape);
-  undef($outshape); # free memory associated with shape
-
-} # for each shape
-
-$outSHP = ''; # write the file
-
-undef $inSHP;
-undef $outSHP;
-
-my $reduction = ((($outcount / $incount) * 100) - 100) * -1;
-
-print <<END;
-
-$0 Summary:
-
-Input File  : $infile  ($incount vertices)
-Output File : $outfile ($outcount vertices)
-Tolerance   : $tolerance
-Reduction   : $reduction%
-
-END
diff -pruN 8.0.1-5/mapscript/perl/examples/wxs.pl 8.2.0~beta1-1~exp1/mapscript/perl/examples/wxs.pl
--- 8.0.1-5/mapscript/perl/examples/wxs.pl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/examples/wxs.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,115 +0,0 @@
-#!/usr/bin/perl
-############################################################################
-# $Id: $
-#
-# Project:  MapServer
-# Purpose:  MapScript WxS example
-# Author:   Tom Kralidis (tomkralidis@gmail.com)
-#
-##############################################################################
-# Copyright (c) 2007, Tom Kralidis
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included in
-# all copies of this Software or works derived from this Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-############################################################################/
-
-use CGI::Carp qw(fatalsToBrowser);
-use mapscript;
-use strict;
-use warnings;
-use XML::LibXSLT;
-use XML::LibXML;
-
-my $dispatch;
-
-# uber-trivial XSLT document, as a file
-my $xsltfile = "/tmp/foo.xslt";
-
-# here's the actual document inline for
-# testing save and alter $xsltFile above
-
-=comment
-my $xsltstring = <<END;
-<?xml version="1.0" encoding="UTF-8"?> 
-<xsl:stylesheet version="1.0"
- xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
- xmlns:wfs="http://www.opengis.net/wfs">
- <xsl:output method="xml" indent="yes"/> 
- <xsl:template match="/"> 
-<WFSLayers> 
-<xsl:for-each select="//wfs:FeatureType"> 
-<wfs_layer>
-<name><xsl:value-of select="wfs:Name"/></name> 
-<title><xsl:value-of select="wfs:Title"/></title> 
-</wfs_layer>
-</xsl:for-each> 
-</WFSLayers> 
-</xsl:template> 
-</xsl:stylesheet>
-=cut
-
-my $mapfile  = "/tmp/config.map";
-
-# init OWSRequest object
-my $req = new mapscript::OWSRequest();
-
-# pick up CGI paramters passed
-$req->loadParams();
-
-# init mapfile 
-my $map = new mapscript::mapObj($mapfile);
-
-# if this is a WFS GetCapabilities request, then intercept
-# what is normally returned, process with an XSLT document
-# and then return that to the client
-if ($req->getValueByName('REQUEST') eq "GetCapabilities" && $req->getValueByName('SERVICE') eq "WFS") {
-
-  # push STDOUT to a buffer and run the incoming request
-  my $io = mapscript::msIO_installStdoutToBuffer();
-  $dispatch = $map->OWSDispatch($req);
-
-  # at this point, the client's request is sent
-
-  # pull out the HTTP headers
-  my $ct = mapscript::msIO_stripStdoutBufferContentType();
-
-  # and then pick up the actual content of the response
-  my $content = mapscript::msIO_getStdoutBufferString();
-
-  my $xml  = XML::LibXML->new();
-  my $xslt = XML::LibXSLT->new();
-
-  # load XML content
-  my $source = $xml->parse_string($content);
-
-  # load XSLT document
-  my $style_doc = $xml->parse_file($xsltfile);
-  my $stylesheet = $xslt->parse_stylesheet($style_doc);
-
-  # invoke the XSLT transformation
-  my $results = $stylesheet->transform($source);
-
-  # print out the result (header + content)
-  print "Content-type: $ct\n\n";
-  print $stylesheet->output_string($results);
-}
-
-# else process as normal
-else {
-  $dispatch = $map->OWSDispatch($req);
-}
diff -pruN 8.0.1-5/mapscript/perl/plextend.i 8.2.0~beta1-1~exp1/mapscript/perl/plextend.i
--- 8.0.1-5/mapscript/perl/plextend.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/plextend.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Perl-specific extensions to MapScript objects
- * Author: SDL based on Sean's Python conventions
- *
- ******************************************************************************
- *
- * Perl-specific mapscript code has been moved into this 
- * SWIG interface file to improve the readibility of the main
- * interface file.  The main mapscript.i file includes this
- * file when SWIGPERL is defined (via 'swig -perl5 ...').
- *
- *****************************************************************************/
-
diff -pruN 8.0.1-5/mapscript/perl/plmodule.i 8.2.0~beta1-1~exp1/mapscript/perl/plmodule.i
--- 8.0.1-5/mapscript/perl/plmodule.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/plmodule.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,200 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Perl-specific enhancements to MapScript
- * Author:   SDL based on Sean's Python conventions
- *
- ******************************************************************************
- *
- * Perl-specific mapscript code has been moved into this 
- * SWIG interface file to improve the readibility of the main
- * interface file.  The main mapscript.i file includes this
- * file when SWIGPERL is defined (via 'swig -perl5 ...').
- *
- *****************************************************************************/
-
-/******************************************************************************
- * Simple Typemaps
- *****************************************************************************/
-
-%init %{
-  if(msSetup() != MS_SUCCESS) {
-    msSetError(MS_MISCERR, "Error initializing MapServer/Mapscript.", "msSetup()");
-  }
-%}
-
-/* Translate Perl's built-in file object to FILE * */
-%typemap(in) FILE * {
-  $1 = PerlIO_exportFILE (IoIFP (sv_2io ($input)), NULL);
-}
-
-/* To support imageObj::getBytes */
-%typemap(out) gdBuffer {
-        SV *mysv;
-        mysv = sv_newmortal();
-        if ($1.data == NULL)
-            sv_setpv(mysv,"");
-        else
-            sv_setpvn(mysv,(const char*)$1.data,$1.size);
-        $result = newRV(mysv);
-        sv_2mortal($result);
-        argvi++;
-        if( $1.owns_data )
-            msFree($1.data);
-}
-
-%typemap(out) char[ANY] {
-        $result = newSVpvn($1, strlen($1));
-        argvi++;
-}
-
-/*
-===============================================================================
-RFC-24 implementation follows
-===============================================================================
-   Modified constructor according to:
-   - cache population and sync, item 3.2
-   - reference counter since Perl does not obey %newobject
-*/
-%allowexception;
-
-%exception layer {
-	/* Accessing layer */
-	$action;
-	MS_REFCNT_INCR(result);
-}
-%exception map {
-	/* Accessing map */
-	$action;
-	MS_REFCNT_INCR(result);
-}
-
-%feature("shadow") layerObj(mapObj *map)
-%{
-sub new {
-        my $pkg = shift;
-        my $self = mapscriptc::new_layerObj(@_);
-        bless $self, $pkg if defined($self);
-        if (defined($_[0])) {
-                # parent reference
-                mapscript::RFC24_ADD_PARENT_REF( tied(%$self), $_[0]);
-        }
-        return $self;
-}
-%}
-
-%feature("shadow") getLayer(int i)
-%{
-sub getLayer {
-        my $layer = mapscriptc::mapObj_getLayer(@_);
-        if (defined($layer)) {
-                # parent reference
-                #print "l=$layer,m=$_[0]\n";
-                mapscript::RFC24_ADD_PARENT_REF( tied(%$layer) , $_[0]);
-        }
-        return $layer;
-}
-%}
-
-%feature("shadow") getLayerByName(char* name)
-%{
-sub getLayerByName {
-        my $layer = mapscriptc::mapObj_getLayerByName(@_);
-        if (defined($layer)) {
-                # parent reference
-                #print "l=$layer,m=$_[0]\n";
-                mapscript::RFC24_ADD_PARENT_REF( tied(%$layer) , $_[0]);
-        }
-        return $layer;
-}
-%}
-
-%feature("shadow") insertLayer
-%{
-sub insertLayer {
-        my $idx = mapscriptc::mapObj_insertLayer(@_);
-        my $layer=$_[1];
-        # parent reference
-        mapscript::RFC24_ADD_PARENT_REF(tied(%$layer), $_[0]);
-        return $idx;
-}
-%}
-
-%feature("shadow") ~layerObj()
-%{
-sub DESTROY {
-        return unless $_[0]->isa('HASH');
-        my $self = tied(%{$_[0]});
-        return unless defined $self;
-        delete $ITERATORS{$self};
-        mapscriptc::delete_layerObj($self);
-        # remove parent reference
-        mapscript::RFC24_DEL_PARENT_REF($self);
-}
-%}
-
-%feature("shadow") classObj(layerObj *layer)
-%{
-sub new {
-        my $pkg = shift;
-        my $self = mapscriptc::new_classObj(@_);
-        bless $self, $pkg if defined($self);
-        if (defined($_[0])) {
-                # parent reference
-                mapscript::RFC24_ADD_PARENT_REF( tied(%$self), $_[0]);
-        }
-        return $self;
-}
-%}
-
-%feature("shadow") getClass(int i)
-%{
-sub getClass {
-        my $clazz = mapscriptc::layerObj_getClass(@_);
-        if (defined($clazz)) {
-                # parent reference
-                mapscript::RFC24_ADD_PARENT_REF( tied(%$clazz) , $_[0]);
-        }
-        return $clazz;
-}
-%}
-%feature("shadow") insertClass
-%{
-sub insertClass {
-        my $idx = mapscriptc::layerObj_insertClass(@_);
-        my $clazz=$_[1];
-        # parent reference
-        mapscript::RFC24_ADD_PARENT_REF(tied(%$clazz), $_[0]);
-        return $idx;
-}
-%}
-
-%feature("shadow") ~classObj()
-%{
-sub DESTROY {
-        return unless $_[0]->isa('HASH');
-        my $self = tied(%{$_[0]});
-        return unless defined $self;
-        delete $ITERATORS{$self};
-        mapscriptc::delete_classObj($self);
-        # remove parent reference
-        mapscript::RFC24_DEL_PARENT_REF($self);
-}
-%}
-%perlcode %{
-        %PARENT_PTRS=();
-        sub RFC24_ADD_PARENT_REF {
-                my ($child, $parent)=@_;
-                $PARENT_PTRS{ $$child }=$parent;
-        }
-        sub RFC24_DEL_PARENT_REF {
-                my ($child)=@_;
-                delete $PARENT_PTRS{ $$child };
-        }
-
-        # USE THIS function only for debugging!
-        sub getPARENT_PTRS {
-                return \%PARENT_PTRS;
-        }
-%}
diff -pruN 8.0.1-5/mapscript/perl/tests/0-load.t 8.2.0~beta1-1~exp1/mapscript/perl/tests/0-load.t
--- 8.0.1-5/mapscript/perl/tests/0-load.t	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/tests/0-load.t	1970-01-01 00:00:00.000000000 +0000
@@ -1,40 +0,0 @@
-#!/usr/bin/perl
-use strict;
-use warnings;
-use Test::More tests => 11;
-
-# check the mapserver version for keywords
-sub msHas
-{
-	my ($mod) = @_;
-	my $ver = mapscript::msGetVersion();
-	if (index($ver, $mod) > -1) {
-		return 1;
-	} else {
-		return 0;
-	}
-}
-
-require_ok( 'mapscript' );
-diag("Testing: " . $INC{'mapscript.pm'});
-diag( mapscript::msGetVersion() );
-
-SKIP: {
-	skip "no geos support", 10 unless msHas('SUPPORTS=GEOS');
-    my @wkt_list = (
-		'POINT (5.0000000000000000 7.0000000000000000)',
-		'LINESTRING (5.0000000000000000 7.0000000000000000, 7.0000000000000000 9.0000000000000000, 9.0000000000000000 -1.0000000000000000)',
-		'POLYGON ((500.0000000000000000 500.0000000000000000, 3500.0000000000000000 500.0000000000000000, 3500.0000000000000000 2500.0000000000000000, 500.0000000000000000 2500.0000000000000000, 500.0000000000000000 500.0000000000000000), (1000.0000000000000000 1000.0000000000000000, 1000.0000000000000000 1500.0000000000000000, 1500.0000000000000000 1500.0000000000000000, 1500.0000000000000000 1000.0000000000000000, 1000.0000000000000000 1000.0000000000000000))',
-		'MULTIPOINT (2000.0000000000000000 2000.0000000000000000, 2000.0000000000000000 1900.0000000000000000)',
-		'MULTILINESTRING ((600.0000000000000000 1500.0000000000000000, 1600.0000000000000000 2500.0000000000000000), (700.0000000000000000 1500.0000000000000000, 1700.0000000000000000 2500.0000000000000000))'
-	);
-
-	for my $orig (@wkt_list)
-	{
-		my $shp = mapscript::shapeObj::fromWKT( $orig );
-		ok( $shp, 'create shapeObj');
-		my $new_wkt = $shp->toWKT();
-		ok( $orig eq $new_wkt, 'from WKT <> toWKT' );
-	}
-};
-
diff -pruN 8.0.1-5/mapscript/perl/tests/maps.t 8.2.0~beta1-1~exp1/mapscript/perl/tests/maps.t
--- 8.0.1-5/mapscript/perl/tests/maps.t	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/perl/tests/maps.t	1970-01-01 00:00:00.000000000 +0000
@@ -1,61 +0,0 @@
-#!/usr/bin/perl
-use strict;
-use warnings;
-use Test::More tests => 10;
-use mapscript;
-
-sub msHas
-{
-	my ($mod) = @_;
-	my $ver = mapscript::msGetVersion();
-	if (index($ver, $mod) > -1) {
-		return 1;
-	} else {
-		return 0;
-	}
-}
-
-# we need to search up directories for the test folder
-my $mapfile = '../../../msautotest/mspython/test_mapio.map';
-if (! -e $mapfile)
-{
-	$mapfile = '../../../../msautotest/mspython/test_mapio.map';
-}
-ok(-e $mapfile, 'mapfile exists');
-
-my $map = new mapscript::mapObj($mapfile);
-ok($map, 'create mapObj');
-
-mapscript::msIO_installStdoutToBuffer();
-my $owreq = new mapscript::OWSRequest();
-ok($owreq, 'create OWSRequest');
-$owreq->loadParamsFromURL('service=WMS&version=1.1.1&request=GetMap&layers=grey&srs=EPSG:4326&bbox=-180,-90,180,90&format=image/png&width=80&height=40&STYLES=');
-ok($owreq->getName(0) eq 'service');
-ok($owreq->getValue(0) eq 'WMS');
-ok($owreq->getValueByName('request') eq 'GetMap');
-
-my $err = $map->OWSDispatch( $owreq );
-ok($err == 0, 'OWSDispatch');
-
-#	warn(mapscript::msGetErrorString("\n"));
-
-my $h  = mapscript::msIO_getAndStripStdoutBufferMimeHeaders();
-#my $k = $h->nextKey();
-#while ($k)
-#{
-#	diag("$k == " . $h->get($k));
-#	$k = $h->nextKey($k);
-#}
-
-ok($h->get('Cache-Control') eq 'max-age=86400');
-ok($h->get('Content-Type') eq 'image/png');
-
-
-my $x = mapscript::msIO_getStdoutBufferBytes();
-#open(F, '>', 'x.png');
-#print F $$x;
-#close(F);
-
-ok(substr($$x, 1, 3) eq 'PNG');
-
-
diff -pruN 8.0.1-5/mapscript/php/README 8.2.0~beta1-1~exp1/mapscript/php/README
--- 8.0.1-5/mapscript/php/README	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/php/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-Old native (and unmaintained) PHP MapScript was removed for the 
-MapServer 8.0 release.  Please see the /mapscript/phpng/ folder 
-for the maintained PHP MapScript support through SWIG, or the 
-documentation at https://mapserver.org/mapscript/mapscript.html .
diff -pruN 8.0.1-5/mapscript/phpng/CMakeLists.txt 8.2.0~beta1-1~exp1/mapscript/phpng/CMakeLists.txt
--- 8.0.1-5/mapscript/phpng/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/phpng/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,91 +0,0 @@
-find_package(SWIG REQUIRED)
-include(${SWIG_USE_FILE})
-if(WIN32 AND ((${CMAKE_VERSION} EQUAL "3.12.0") OR (${CMAKE_VERSION} EQUAL "3.12.1") OR (${CMAKE_VERSION} EQUAL "3.12.2") OR (${CMAKE_VERSION} EQUAL "3.12.3")))
-    message(FATAL_ERROR "Building with CMAKE ${CMAKE_VERSION} will not work. Please downgrade to 3.11.x or update to a higher version than 3.12.3")
-endif()
-
-if(WIN32)
-  FIND_PACKAGE(SWIG 3.0.11 REQUIRED)
-  if(WITH_THREAD_SAFETY)
-    FIND_PACKAGE(SWIG 4.0.0 REQUIRED)
-  endif(WITH_THREAD_SAFETY)
-endif(WIN32)
-
-FIND_PACKAGE(PHP REQUIRED)
-INCLUDE(UseSWIG)
-
-if(WIN32)
-  add_definitions(/DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
-  if(NOT CMAKE_CL_64)
-    add_definitions(-D_USE_32BIT_TIME_T)
-  endif(NOT CMAKE_CL_64)
-  if(WITH_THREAD_SAFETY)
-    add_definitions(-DZTS=1)
-  endif(WITH_THREAD_SAFETY)
-endif(WIN32)
-
-include_directories(${PHP_INCLUDE_PATH})
-message(STATUS "PHP Include Path: ${PHP_INCLUDE_PATH}")
-
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/phpng)
-include_directories(${CMAKE_CURRENT_BINARY_DIR}) # make sure mapscriptPHP7_wrap.c is found
-
-if(WIN32)
-  include_directories(${PHP_INCLUDE_PATH}/win32)
-endif(WIN32)
-
-IF(PHP_VERSION LESS 5)
-  MESSAGE(FATAL_ERROR "PHP version is not 5 or later")
-ENDIF(PHP_VERSION LESS 5)
-
-IF(PHP_VERSION LESS 7)
-  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
-      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php SOURCES ../mapscript.i)
-  else ()
-      swig_add_module(php_mapscriptng php ../mapscript.i)
-  endif ()
-ELSE()
-  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
-      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php7 SOURCES ../mapscript.i)
-  else ()
-      swig_add_module(php_mapscriptng php7 ../mapscript.i)
-  endif ()
-ENDIF(PHP_VERSION LESS 7)
-
-if(WIN32)
-  target_compile_options(php_mapscriptng PRIVATE /DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
-  if(WITH_THREAD_SAFETY)
-    target_compile_options(php_mapscriptng PRIVATE /DZTS=1)
-  endif(WITH_THREAD_SAFETY)
-  SWIG_LINK_LIBRARIES(php_mapscriptng ${PHP_LIBRARY})
-endif(WIN32)
-
-IF(APPLE)
-  if(XCODE)
-     SET(CMAKE_C_LINK_FLAGS 
-        "${CMAKE_C_LINK_FLAGS} -undefined dynamic_lookup")
-     SET(CMAKE_CXX_LINK_FLAGS 
-        "${CMAKE_CXX_LINK_FLAGS} -undefined dynamic_lookup")
-  else(XCODE)
-     SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS 
-        "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -undefined dynamic_lookup")
-     SET(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS 
-        "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
-  endif(XCODE)
-ENDIF(APPLE)
-
-# hide "defined but not used" warnings
-target_compile_options(php_mapscriptng PRIVATE -Wno-unused-label)
-
-target_link_libraries(php_mapscriptng mapserver)
-set_target_properties(${SWIG_MODULE_mapscript_REAL_NAME} PROPERTIES PREFIX "")
-
-if(NOT WIN32)
-  install(TARGETS php_mapscriptng DESTINATION ${PHP_EXTENSION_DIR})
-  # check if we must install the required file containing MapServer constants and functions
-  if(${SWIG_VERSION} LESS_EQUAL 4.0.2)
-     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mapscript.php DESTINATION ${PHP_EXTENSION_DIR} COMPONENT dev)
-  endif()
-endif()
diff -pruN 8.0.1-5/mapscript/phpng/README.WIN32 8.2.0~beta1-1~exp1/mapscript/phpng/README.WIN32
--- 8.0.1-5/mapscript/phpng/README.WIN32	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/phpng/README.WIN32	1970-01-01 00:00:00.000000000 +0000
@@ -1,71 +0,0 @@
-This readme covers building Mapserver from scatch on Windows.
-We will download current development state of php.
-If you need MapscriptNG for a different version of php, you have to fit the commands below.
-For the first time, it is a good idea to build as shown below and after you have a working state, you can change whatever you want, knowing there is a working state you can return to.
-
-All you need is Visual Studio 2017 Express (latest Version, check for updates) and GIT installed.
-
-To begin, start x64 or x86 Native Tools Command Prompt for VS 2017 and just execute all Commands listed below.
-Please always stay inside PHP-SDK-Shell to have wget and unzip available.
-
-rem --------------------------------------------------------------------
-rem Step 1: Create Directories
-rem --------------------------------------------------------------------
-mkdir C:\projects
-mkdir C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
-
-rem --------------------------------------------------------------------
-rem Step 2: Build PHP
-rem --------------------------------------------------------------------
-cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
-git clone https://github.com/Microsoft/php-sdk-binary-tools.git php-sdk
-cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\php-sdk
-set VS_VERSION=%VSCMD_VER:~0,2%
-phpsdk-vc%VS_VERSION%-%VSCMD_ARG_TGT_ARCH%.bat
-phpsdk_buildtree phpmaster
-git clone https://github.com/php/php-src.git
-cd php-src
-phpsdk_deps --update --branch master
-buildconf
-configure --enable-snapshot-build
-nmake snap
-
-rem --------------------------------------------------------------------
-rem Step 3: Get GISInternals SDK
-rem --------------------------------------------------------------------
-cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
-mkdir packages
-mkdir packages\gisinternals%VSCMD_ARG_TGT_ARCH%\
-mkdir gisinternals%VSCMD_ARG_TGT_ARCH%
-set GISInternalsArchitecture=-
-if %VSCMD_ARG_TGT_ARCH% == x64 set GISInternalsArchitecture=-%VSCMD_ARG_TGT_ARCH%-
-wget -O packages\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911%GISInternalsArchitecture%dev.zip http://download.gisinternals.com/sdk/downloads/release-1911%GISInternalsArchitecture%dev.zip
-unzip -q -o packages\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911%GISInternalsArchitecture%dev.zip -d gisinternals%VSCMD_ARG_TGT_ARCH%
-
-rem --------------------------------------------------------------------
-rem Step 4: Other Dependencies
-rem --------------------------------------------------------------------
-rem ### SWIG ###
-cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
-git clone https://github.com/AlexanderGabriel/swig
-mkdir swig\build
-cd swig\build
-cmake .. -G "NMake Makefiles"  -DCMAKE_BUILD_TYPE=Release
-cmake --build .
-move swig.exe ..
-rem ### gnulib ###
-cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
-git clone git://git.savannah.gnu.org/gnulib.git
-
---------------------------------------------------------------------
-Step 5: Build Mapserver with php_mapscriptng
---------------------------------------------------------------------
-cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
-git clone https://github.com/mapserver/mapserver
-cd mapserver
-mkdir build
-cd build
-cmake .. -G "NMake Makefiles" -DCMAKE_BUILD_TYPE=Release -Wno-dev -DCMAKE_PREFIX_PATH=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911-%VSCMD_ARG_TGT_ARCH%;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gnulib\lib;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gnulib\include;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911-%VSCMD_ARG_TGT_ARCH%\lib;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911-%VSCMD_ARG_TGT_ARCH%\include -DREGEX_DIR=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\regex-0.12 -DWITH_POSTGIS=0 -DWITH_PROTOBUFC=0 -DWITH_THREAD_SAFETY=1 -DWITH_PHPNG=1 -DSWIG_EXECUTABLE=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\swig\swig.exe -DSWIG_DIR=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\swig
-cmake --build .
-
-
diff -pruN 8.0.1-5/mapscript/phpng/php7module.i 8.2.0~beta1-1~exp1/mapscript/phpng/php7module.i
--- 8.0.1-5/mapscript/phpng/php7module.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/phpng/php7module.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,32 +0,0 @@
-%module mapscriptng;
-
-%pragma(php) phpinfo="
-  php_info_print_table_start();
-  php_info_print_table_row(2, \"MapServer Version\", msGetVersion());
-  php_info_print_table_end();
-"
-
-
-/* To support imageObj::getBytes */
-%typemap(out) gdBuffer {
-    RETVAL_STRINGL((const char*)$1.data, $1.size);
-    if( $1.owns_data )
-       msFree($1.data);
-}
-
-
-/* Module initialization: call msSetup() and register msCleanup() */
-%init %{
-    if (msSetup() != MS_SUCCESS)
-    {
-        msSetError(MS_MISCERR, "Failed to set up threads and font cache",
-                   "msSetup()");
-    }
-
-%}
-
-%mshutdown {
-    msCleanup();
-}
-
-
diff -pruN 8.0.1-5/mapscript/python/CMakeLists.txt 8.2.0~beta1-1~exp1/mapscript/python/CMakeLists.txt
--- 8.0.1-5/mapscript/python/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,144 +0,0 @@
-find_package(SWIG REQUIRED)
-include(${SWIG_USE_FILE})
-
-find_package (Python REQUIRED COMPONENTS Interpreter Development)
-
-include_directories(${Python_INCLUDE_DIRS})
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/python)
-
-set(SwigFile ${PROJECT_SOURCE_DIR}/mapscript/mapscript.i)
-
-# add annotations to py file output - requires >= SWIG 4.1
-if (WITH_PYMAPSCRIPT_ANNOTATIONS AND ${Python_VERSION_MAJOR} GREATER_EQUAL 3)
-  if (${Python_VERSION_MINOR} GREATER_EQUAL 6)
-     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c)
-  else ()
-     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c,python:annotations:novar)
-  endif ()
-endif ()
-
-if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
-    swig_add_library(pythonmapscript TYPE MODULE LANGUAGE python SOURCES ${SwigFile})
-else ()
-    swig_add_module(pythonmapscript python ${SwigFile})
-endif ()
-
-swig_link_libraries(pythonmapscript ${Python_LIBRARIES} ${MAPSERVER_LIBMAPSERVER})
-
-set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES PREFIX "")
-set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES OUTPUT_NAME _mapscript)
-
-set(SETUP_PY_IN "${PROJECT_SOURCE_DIR}/mapscript/python/setup.py.in")
-set(SETUP_PY_TEMP "${CMAKE_CURRENT_BINARY_DIR}/setup.py.temp")
-
-configure_file(${SETUP_PY_IN} ${SETUP_PY_TEMP} @ONLY)
-file(READ ${SETUP_PY_TEMP} SETUP_CONTENT)
-
-# each target (e.g. Debug, Release etc.) will have a copy of setup.py
-
-file(GENERATE OUTPUT $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/setup.py INPUT ${SETUP_PY_TEMP})
-
-if(MSVC)
-    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE})
-else()
-    # for non-Windows builds there are no build type subfolders (e.g. Release, Debug etc.)
-    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR})
-endif()
-
-if(WIN32)
-    # Windows venv binaries are in a different location than Linux
-    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/Scripts)
-else()
-    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/bin)
-endif()
-
-add_custom_target(
-    pythonmapscript-wheel
-    DEPENDS mapscripttests.stamp
-)
-
-add_custom_command(
-    DEPENDS ${SWIG_MODULE_pythonmapscript_REAL_NAME}
-    OUTPUT mapscriptvenv.stamp
-    WORKING_DIRECTORY ${OUTPUT_FOLDER}
-    COMMAND ${Python_EXECUTABLE} -m pip install pip --upgrade
-    COMMAND ${Python_EXECUTABLE} -m pip install virtualenv
-    COMMAND ${Python_EXECUTABLE} -m virtualenv mapscriptvenv
-    COMMAND ${Python_VENV_SCRIPTS}/pip install -r ${PROJECT_SOURCE_DIR}/mapscript/python/requirements-dev.txt > requires.log
-    COMMENT "Creating a Python virtual environment and installing the required packages"
-)
-
-add_custom_command(
-    DEPENDS mapscriptvenv.stamp
-    OUTPUT mapscriptlinting.stamp
-    WORKING_DIRECTORY ${OUTPUT_FOLDER}
-    COMMAND ${Python_VENV_SCRIPTS}/flake8 $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests --max-line-length=140
-    COMMAND ${Python_VENV_SCRIPTS}/flake8 $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/examples --max-line-length=120
-    COMMENT "Linting test suite and examples with flake8" # note only one comment is output per custom command block
-)
-
-add_custom_command(
-    DEPENDS mapscriptlinting.stamp
-    OUTPUT mapscriptwheel.stamp
-    WORKING_DIRECTORY ${OUTPUT_FOLDER}
-    COMMAND ${Python_VENV_SCRIPTS}/python setup.py bdist_wheel > wheel_build.log
-    COMMENT "Building the mapscript Python wheel"
-)
-
-add_custom_command(
-    WORKING_DIRECTORY ${Python_VENV_SCRIPTS} # make sure scripts aren't run when from the same folder as mapscript.py
-    DEPENDS mapscriptwheel.stamp
-    OUTPUT mapscripttests.stamp
-    COMMAND ${Python_VENV_SCRIPTS}/pip install --no-index --find-links=${OUTPUT_FOLDER}/dist mapscript
-    # ERROR: file or package not found: mapscript.tests (missing __init__.py?) is caused by
-    # ImportError: DLL load failed while importing _mapscript: The specified module could not be found.
-    COMMAND ${Python_VENV_SCRIPTS}/python -m pytest --pyargs mapscript.tests
-    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.project_csv ${PROJECT_SOURCE_DIR}/tests/cities.csv 2 1 EPSG:4326 EPSG:3857 > test.csv
-    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpdump ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpdump.txt
-    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpinfo ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpinfo.txt
-    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.wxs ${PROJECT_SOURCE_DIR}/tests/test.map > response.xml
-    COMMENT "Installing the Python wheel and testing it in the virtual environment, then running tests and examples"
-)
-
-add_custom_command(
-    TARGET ${SWIG_MODULE_pythonmapscript_REAL_NAME}
-    WORKING_DIRECTORY ${OUTPUT_FOLDER}
-    POST_BUILD
-    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/mapscript/python/mapscript/__init__.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/__init__.py
-    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/mapscript.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/mapscript.py
-    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:${SWIG_MODULE_pythonmapscript_REAL_NAME}>" "$<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/$<TARGET_FILE_NAME:${SWIG_MODULE_pythonmapscript_REAL_NAME}>"
-    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/mapscript/python/README.rst" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/README.rst
-    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/mapscript/python/tests/cases" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests
-    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/tests" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests/data
-    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/mapscript/python/examples" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/examples
-    COMMENT "Copying files required to build Mapscript"
-)
-
-install(  
-  CODE "
-  
-    SET(ENV{PYTHONPATH} \${Python_SITELIB}:\$ENV{PYTHONPATH})
-      
-    if(DEFINED ENV{DESTDIR})
-      SET(PYTHON_ROOT \"--root=\$ENV{DESTDIR}\")
-    endif()
-  
-    if(DEFINED CMAKE_INSTALL_PREFIX)
-      SET(PYTHON_PREFIX \"--prefix=\${CMAKE_INSTALL_PREFIX}\")
-    endif()
-
-    execute_process(
-      COMMAND ${Python_EXECUTABLE} setup.py install \${PYTHON_ROOT} \${PYTHON_PREFIX}
-      WORKING_DIRECTORY ${OUTPUT_FOLDER}
-    )
-  "
-)
-
-message(STATUS "CMake Version: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")
-message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
-message(STATUS "Python MapScript output directory: ${OUTPUT_FOLDER}")
-message(STATUS "Python Executable: ${Python_EXECUTABLE}")
-message(STATUS "Python Version: ${Python_VERSION}")
-message(STATUS "Python site packages: ${Python_SITELIB}")
diff -pruN 8.0.1-5/mapscript/python/README.rst 8.2.0~beta1-1~exp1/mapscript/python/README.rst
--- 8.0.1-5/mapscript/python/README.rst	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/README.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,320 +0,0 @@
-Python MapScript for MapServer README
-=====================================
-
-:Author: MapServer Team
-:Last Updated: 2021-01-29
-
-Introduction
-------------
-
-The Python mapscript module provides users an interface to `MapServer <http://mapserver.org>`_
-classes on any platform, and has been tested on Python versions 2.7 and 3.5+. 
-
-The Python mapscript module is created using `SWIG <http://www.swig.org.>`_ the
-the Simplified Wrapper and Interface Generator. This is used to create MapServer bindings in
-many different programming languages. 
-
-+ Language agnostic documentation is available at http://mapserver.org/mapscript/introduction.html
-+ Python specific documentation is available at http://mapserver.org/mapscript/python.html
-
-When working with Mapfiles in Python the `mappyfile <https://mappyfile.readthedocs.io/en/latest/>`_ project can
-also be used, this allows creating, parsing, formatting, and validating Mapfiles without any dependencies on MapServer. 
-
-Wheels and PyPI
----------------
-
-Python `wheels <https://wheel.readthedocs.io/en/stable/>`_ for Windows are automatically and uploaded to 
-`PyPI <https://pypi.org/>`_ - the Python Package Index on each MapServer release. 
-Note - MapServer binaries still need to be installed on the system, and are not included in the wheel itself, 
-see the *Installation* section below.
-
-Advantages of ready-made wheels on PyPI include:
-
-+ easy installation using `pip <https://pypi.org/project/pip/>`_
-+ mapscript can be added as a dependency to `Requirements Files <https://pip.pypa.io/en/stable/user_guide/#id1>`_
-+ mapscript can be easily added to a Python `Virtual Environment <https://docs.python-guide.org/dev/virtualenvs/>`_
-+ Python2 or Python3 versions of mapscript can be installed and work with a single installation of MapServer
-
-Wheels are built based on the `Appveyor build environments <https://github.com/MapServer/MapServer/blob/main/appveyor.yml>`_. 
-These are as follows at the time of writing:
-
-+ Python 2.7 x32
-+ Python 2.7 x64
-+ Python 3.6 x64
-+ Python 3.7 x64
-+ Python 3.8 x64
-
-The mapscript wheels have been compiled using Visual Studio 2017 version 15 (``MSVC++ 14.11 _MSC_VER == 1911``). 
-Linux Wheels may also be available in the future using the `manylinux <https://github.com/pypa/manylinux>`_ project. 
-
-No source distributions will be provided on PyPI - to build from source requires the full MapServer source code,
-in which case it is easiest to take a copy of the full MapServer project and run the CMake process detailed below. 
-
-The Wheels contain a full test suite and sample data that can be run to check that the installed MapServer is
-running correctly. 
-
-..
-    py3 SWIG flag adds type annotations
-
-Installation on Windows
------------------------
-
-To use mapscript you will need to add the MapServer binaries to your system path. 
-
-For Python 3.8+
-+++++++++++++++
-
-As of `Python 3.8 <https://docs.python.org/3/whatsnew/3.8.html#changes-in-the-python-api>`_ ``PATH`` 
-and the current working directory are no longer used when searching for the MapServer DLLs.
-A new environment variable ``MAPSERVER_DLL_PATH`` has been introduced to set the location of the MapServer DLLs.
-On Windows you can use the following, replacing ``C:\MapServer\bin`` with the location of your MapServer binaries.
-
-.. code-block:: bat
-
-    SET MAPSERVER_DLL_PATH=C:\MapServer\bin
-
-If several folders are required (e.g. GDAL DLLs) multiple paths can be provided separated by semi-colons:
-
-.. code-block:: bat
-
-    SET MAPSERVER_DLL_PATH=C:\MapServer\bin;C:\GDAL\bin
-
-For Earlier Python Versions
-+++++++++++++++++++++++++++
-
-For Python 3.7 and earlier (including Python 2.7) you can use either the ``MAPSERVER_DLL_PATH`` variable documented above,
-or the system ``PATH`` variable as below, replacing ``C:\MapServer\bin`` with the location of your MapServer binaries. 
-
-.. code-block:: bat
-
-    SET PATH=C:\MapServer\bin;%PATH%
-
-Windows Binaries
-++++++++++++++++
-
-Windows binary packages can be downloaded from `GIS Internals <https://www.gisinternals.com/stable.php>`_. 
-To ensure compatibility with the wheels, please use identical release packages, e.g. ``release-1928-x64-gdal-3-2-mapserver-7-6``
-for mapscript 7.6. 
-
-.. NOTE::
-   `MS4W <https://www.ms4w.com>`_ (MapServer for Windows) is a full installer that contains Python & Python
-   MapScript already configured out-of-the-box, as well as default OGC web services and over 60 working mapfiles.
-
-When using these packages the MapServer path will be similar to ``C:\release-1911-x64-gdal-2-3-mapserver-7-2\bin``. 
-
-Prior to installing mapscript it is recommended to update pip to the latest version with the following command:
-
-.. code-block:: bat
-
-    python -m pip install --upgrade pip
-
-If there are binary wheels available for your system, mapscript can be installed using:
-
-.. code-block:: bat
-
-    pip install mapscript
-
-If you already have mapscript installed and wish to upgrade it to a newer version you can use:
-
-.. code-block:: bat
-
-    pip install mapscript --upgrade
-
-Now you should be able to import mapscript:
-
-.. code-block:: python
-
-    python -c "import mapscript;print(mapscript.msGetVersion())"
-    MapServer version 7.6.0 OUTPUT=PNG OUTPUT=JPEG OUTPUT=KML SUPPORTS=PROJ SUPPORTS=AGG SUPPORTS=FREETYPE SUPPORTS=CAIRO SUPPORTS=SVG_SYMBOLS SUPPORTS=SVGCAIRO SUPPORTS=ICONV SUPPORTS=FRIBIDI SUPPORTS=WMS_SERVER SUPPORTS=WMS_CLIENT SUPPORTS=WFS_SERVER SUPPORTS=WFS_CLIENT SUPPORTS=WCS_SERVER SUPPORTS=SOS_SERVER SUPPORTS=FASTCGI SUPPORTS=THREADS SUPPORTS=GEOS SUPPORTS=PBF INPUT=JPEG INPUT=POSTGIS INPUT=OGR INPUT=GDAL INPUT=SHAPEFILE
-
-Installation on Unix
---------------------
-
-For Unix users there are two approaches to installing mapscript. The first is to install the ``python-mapscript`` package using a package manager. For example on
-Ubuntu the following command can be used:
-
-.. code-block:: bat
-
-    sudo apt-get install python-mapscript
-
-The second approach is to build and install the Python mapscript module from source. Full details on compiling MapServer from source are detailed on the
-`Compiling on Unix <https://www.mapserver.org/installation/unix.html>`_ page. To make sure Python mapscript is built alongside MapServer the following flag needs to be set:
-
-.. code-block:: bat
-
-    -DWITH_PYTHON=ON
-
-To configure the path of the mapscript installation location ``-DCMAKE_INSTALL_PREFIX`` can be set, e.g. 
-
-.. code-block:: bat
-
-    sudo cmake .. -DCMAKE_INSTALL_PREFIX=/usr
-
-When installing the `DESTDIR <https://cmake.org/cmake/help/latest/envvar/DESTDIR.html>`_ variable can be set (note ``DESTDIR`` is not used on Windows)
-to install mapscript to a non-default location. E.g.
-
-.. code-block:: bat
-
-    make install DESTDIR=/tmp
-
-In summary the ``install`` target runs the ``setup.py install`` command using custom paths (when set) similar to below:
-
-    python setup.py install --root=${DESTDIR} --prefix={CMAKE_INSTALL_PREFIX}
-
-Installation Troubleshooting
-----------------------------
-
-If the ``_mapscript.pyd`` (or ``_mapscript.so`` on Unix) is missing from the `Lib/site-packages/mapscript` 
-folder (which can happen if the source installation is installed rather than a pre-compiled version) the following error will occur:
-
-.. code-block:: python
-
-    ImportError: cannot import name '_mapscript' from partially initialized module 'mapscript' (most likely due to a circular import)
-
-If the mapscript library is not on your ``PYTHONPATH`` you may see one of the following errors:
-
-.. code-block:: python
-
-    ImportError: No module named _mapscript # Python 2.x
-    ModuleNotFoundError: No module named '_mapscript' # Python 3.x
-
-If the ``MapServer.dll`` cannot be found in your system paths (or ``MAPSERVER_DLL_PATH`` environment variable when using Python 3.8 
-or higher on Windows) you will see the following message:
-
-.. code-block:: python
-
-    ImportError: DLL load failed: The specified module could not be found.
-
-If MapServer has been built with a dependency also used by Python, and the versions don't match you may see the error below. 
-
-.. code-block:: python
-
-    ImportError: DLL load failed: The specified procedure could not be found.
-
-This is a particular problem on Windows with ``sqlite3.dll`` as it is used by both Python and MapServer. Copying the ``sqlite3.dll``
-from the MapServer binaries folder alongside ``_mapscript.pyd`` in `Lib/site-packages/mapscript` can resolve this.
-
-Another common cause is if the Python environment contains multiple versions of the GEOS binary. For example ``geos_c.dll`` is included
-as part of the Shapely Python library, as well as a MapServer installation.
-
-If you are using 32 bit Python on Windows and attempt to use a 64 bit version of MapScript the following import error will occur:
-
-.. code-block:: python
-
-    ImportError: DLL load failed while importing _mapscript: %1 is not a valid Win32 application.
-
-Quickstart
-----------
-
-Some basic examples of what can be done with mapscript are shown below. Note - before running any scripts using mapscript, 
-you will need to add the MapServer binaries to your system path, see the *Installation* section above. 
-
-To open an existing Mapfile:
-
-.. code-block:: python
-
-    >>> import mapscript
-    >>> test_map = mapscript.mapObj(r"C:\Maps\mymap.map")
-    >>> extent = test_map.extent
-
-Create a layer from a string:
-
-.. code-block:: python
-
-    >>> import mapscript
-    >>> layer = mapscript.fromstring("""LAYER NAME "test" TYPE POINT END""")
-    >>> layer
-    <mapscript.layerObj; proxy of C layerObj instance at ...>
-    >>> layer.name
-    'test'
-    >>> layer.type == mapscript.MS_LAYER_POINT
-    True
-
-Building the Mapscript Module
------------------------------
-
-The mapscript module is built as part of the MapServer CMake build process. This is configured using the ``mapserver/mapscript/CMakeLists.txt`` file. 
-
-Before the switch to CMake MapServer mapscript was built using distutils and ``setup.py``. Now the ``setup.py.in`` file is used as a template that
-is filled with the MapServer version number and used to created wheel files for distribution, or install mapscript directly on the build machine.  
-
-The build process works as follows. 
-
-+ CMake runs SWIG. This uses the SWIG interface files to create a ``mapscriptPYTHON_wrap.c`` file, 
-  and a ``mapscript.py`` file containing the Python wrapper to the mapscript binary module. 
-+ CMake then uses the appropriate compiler on the system to compile the ``mapscriptPYTHON_wrap.c`` file into a Python binary module -
-  ``_mapscript.pyd`` file on Windows, and a ``_mapscript.so`` file on Unix. 
-
-``CMakeLists.txt`` is configured with a ``pythonmapscript-wheel`` target that copies all the required files to the output build folder where they are then packaged
-into a Python wheel. The wheel can be built using the following command:
-
-.. code-block:: bat
-
-    cmake --build . --target pythonmapscript-wheel
-
-The ``pythonmapscript-wheel`` target creates a virtual environment, creates the Python wheel, installs it to the virtual environment and finally runs the test
-suite. This process runs commands similar to the following:
- 
-.. code-block:: bat
-
-    python -m pip install virtualenv
-    virtualenv mapscriptvenv
-    python -m pip install --upgrade pip
-    pip install -r requirements-dev.txt
-    python setup.py bdist_wheel
-    pip install --no-index --find-links=dist mapscript
-    python -m pytest --pyargs mapscript.tests
-
-SWIG can also be run manually, without using CMake. This may allow further optimizations and control on the output. 
-
-.. code-block:: bat
-
-    cd C:\Projects\mapserver\build
-    SET PATH=C:\MapServerBuild\swigwin-4.0.1;%PATH%
-    swig -python -shadow -o mapscript_wrap.c ../mapscript.i
-
-SWIG has several command line options to control the output, examples of which are shown below:
-
-.. code-block:: bat
-    
-    swig -python -shadow -modern -templatereduce -fastdispatch -fvirtual -fastproxy 
-    -modernargs -castmode -dirvtable -fastinit -fastquery -noproxydel -nobuildnone 
-    -o mapscript_wrap.c ../mapscript.i
-
-Testing
--------
-
-The mapscript module includes a test suite and a small sample dataset to check the output and MapServer installation. It is recommended
-`pytest <https://docs.pytest.org/en/latest/>`_ is used to run the tests. This can be installed using:
-
-.. code-block:: bat
-
-    pip install pytest
-
-Make sure the MapServer binaries are on the system path, and that the PROJ_LIB variable has been set as this is required for many of the tests. 
-
-.. code-block:: bat
-
-    SET PATH=C:\release-1928-x64-gdal-3-2-mapserver-7-6\bin;%PATH%
-    SET PROJ_LIB=C:\release-1928-x64-gdal-3-2-mapserver-7-6\bin\proj\SHARE
-
-Finally run the command below to run the test suite: 
-
-.. code-block:: bat
-
-    pytest --pyargs mapscript.tests
-
-Credits
--------
-
-+ Steve Lime (developer)
-+ Sean Gillies (developer)
-+ Frank Warmerdam (developer)
-+ Howard Butler (developer)
-+ Norman Vine (cygwin and distutils guru)
-+ Tim Cera (install)
-+ Michael Schultz (documentation)
-+ Thomas Bonfort (developer)
-+ Even Rouault (developer)
-+ Seth Girvin (Python3 migration, documentation and builds)
-+ Claude Paroz (Python3 migration)
diff -pruN 8.0.1-5/mapscript/python/examples/project_csv.py 8.2.0~beta1-1~exp1/mapscript/python/examples/project_csv.py
--- 8.0.1-5/mapscript/python/examples/project_csv.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/examples/project_csv.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,72 +0,0 @@
-#!/usr/bin/env python
-
-"""
-Simple example to read a csv file and reproject point x/y data
-
-Usage:
-
-project_csv.py cities.csv 2 1 EPSG:4326 EPSG:3857
-
-"""
-
-import sys
-import csv
-from io import open
-import mapscript
-
-
-def main(input_file, x_field_idx, y_field_idx, input_proj, output_proj):
-
-    # set input and output projections
-    proj_in = mapscript.projectionObj(input_proj)
-    proj_out = mapscript.projectionObj(output_proj)
-
-    # open file
-    with open(input_file, encoding='utf-8') as f:
-        # read csv
-        csv_in = csv.reader(f)
-        headers = next(csv_in)
-
-        # setup output
-        csv_out = csv.writer(sys.stdout)
-        csv_out.writerow(headers)
-
-        for row in csv_in:
-            # set pointObj
-            point = mapscript.pointObj(float(row[x_field_idx]), float(row[y_field_idx]))
-            # project
-            point.project(proj_in, proj_out)
-
-            # update with reprojected coordinates
-            row[x_field_idx] = point.x
-            row[y_field_idx] = point.y
-
-            csv_out.writerow(row)
-
-
-def usage():
-    """
-    Display usage if program is used incorrectly
-    """
-    print("Syntax: %s <csvfile> <x_col> <y_col> <epsg_code_in> <epsg_code_out>" % sys.argv[0])
-    sys.exit(2)
-
-
-# check input parameters
-
-if (len(sys.argv) != 6):
-    usage()
-
-
-input_file = sys.argv[1]
-
-# set x and y indices
-
-x_field_idx = int(sys.argv[2])
-y_field_idx = int(sys.argv[3])
-
-# get projection codes
-
-input_proj = "init="+sys.argv[4].lower()
-output_proj = "init="+sys.argv[5].lower()
-main(input_file, x_field_idx, y_field_idx, input_proj, output_proj)
diff -pruN 8.0.1-5/mapscript/python/examples/shpdump.py 8.2.0~beta1-1~exp1/mapscript/python/examples/shpdump.py
--- 8.0.1-5/mapscript/python/examples/shpdump.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/examples/shpdump.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,94 +0,0 @@
-#!/usr/bin/env python
-
-"""
-Dump the contents of the passed in Shapefile
-
-Usage:
-
-python shpdump.py polygon.shp
-
-"""
-
-import mapscript
-import sys
-import os
-
-
-def plural(x):
-    """
-    Returns an 's' if plural
-
-    Useful in print statements to avoid something like 'point(s)'
-    """
-    if x > 1:
-        return 's'
-    return ''
-
-
-def get_shapefile_object(sf_path):
-
-    # make sure can access .shp file, create shapefileObj
-
-    if os.access(sf_path, os.F_OK):
-        sf_obj = mapscript.shapefileObj(sf_path, -1)
-    else:
-        print("Can't access {}".format(sf_path))
-        sys.exit(2)
-
-    return sf_obj
-
-
-def main(sf_path):
-
-    if not sf_path.lower().endswith(".shp"):
-        sf_path += ".shp"
-
-    sf_obj = get_shapefile_object(sf_path)
-
-    # create an empty Shapefile object
-
-    s_obj = mapscript.shapeObj()
-
-    # loop through each shape in the original Shapefile
-
-    for i in range(sf_obj.numshapes):
-
-        # get the object at index i
-        sf_obj.get(i, s_obj)
-        print("Shape %i has %i part%s" % (i, s_obj.numlines, plural(s_obj.numlines)))
-        print("Bounds (%f, %f) (%f, %f)" % (s_obj.bounds.minx, s_obj.bounds.miny, s_obj.bounds.maxx, s_obj.bounds.maxy))
-
-        # loop through parts of each shape
-
-        for j in range(s_obj.numlines):
-
-            # get the jth part of the ith object
-
-            part = s_obj.get(j)
-            print("Part %i has %i point%s" % (j, part.numpoints, plural(part.numpoints)))
-
-            # loop through points in each part
-
-            for k in range(part.numpoints):
-
-                # get the kth point of the jth part of the ith shape
-
-                point = part.get(k)
-                print("%i: %f, %f" % (k, point.x, point.y))
-
-
-def usage():
-    """
-    Display usage if program is used incorrectly
-    """
-    print("Syntax: %s <shapefile_path>" % sys.argv[0])
-    sys.exit(2)
-
-
-# make sure passing in filename argument
-if len(sys.argv) != 2:
-    usage()
-
-
-sf_path = sys.argv[1]
-main(sf_path)
diff -pruN 8.0.1-5/mapscript/python/examples/shpinfo.py 8.2.0~beta1-1~exp1/mapscript/python/examples/shpinfo.py
--- 8.0.1-5/mapscript/python/examples/shpinfo.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/examples/shpinfo.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,109 +0,0 @@
-#!/usr/bin/env python
-
-"""
-Extracts basic descriptive information from a Shapefile
-
-Usage:
-
-python shpinfo.py point.shp
-
-"""
-import mapscript
-import sys
-import os
-
-
-def get_shapefile_object(sf_path):
-
-    # make sure can access .shp file, create shapefileObj
-
-    if os.access(sf_path, os.F_OK):
-        sf_obj = mapscript.shapefileObj(sf_path)
-    else:
-        print("Can't access {}".format(sf_path))
-        sys.exit(2)
-
-    return sf_obj
-
-
-def get_shapefile_details(sf_obj):
-
-    # dictionary of shapefile types
-
-    types = {
-              mapscript.MS_SHAPEFILE_POINT: 'Point',
-              mapscript.MS_SHAPEFILE_ARC: 'Line',
-              mapscript.MS_SHAPEFILE_POLYGON: 'Polygon',
-              mapscript.MS_SHAPEFILE_MULTIPOINT: 'Multipoint',
-
-              mapscript.MS_SHP_POINTZ: 'PointZ',
-              mapscript.MS_SHP_ARCZ: 'LineZ',
-              mapscript.MS_SHP_POLYGONZ: 'PolygonZ',
-              mapscript.MS_SHP_MULTIPOINTZ: 'MultipointZ',
-
-              mapscript.MS_SHP_POINTM: 'Multipoint',
-              mapscript.MS_SHP_ARCM: 'LineM',
-              mapscript.MS_SHP_POLYGONM: 'PolygonM',
-              mapscript.MS_SHP_MULTIPOINTM: 'MultipointM'
-            }
-
-    # print out basic information that is part of the shapefile object
-
-    print("\tType: %s" % types[sf_obj.type])
-
-    print("\tBounds: (%f, %f) (%f, %f)" % (sf_obj.bounds.minx,
-                                           sf_obj.bounds.miny,
-                                           sf_obj.bounds.maxx,
-                                           sf_obj.bounds.maxy))
-
-    print("\tNumber of features: %i" % sf_obj.numshapes)
-
-
-def get_dbf_details(sf_obj):
-
-    # get DBF object
-
-    dbf_obj = sf_obj.getDBF()
-
-    # print out table characteristics
-
-    print("\tNumber of records in DBF: %i" % dbf_obj.nRecords)
-    print("\tNumber of fields: %i" % dbf_obj.nFields)
-    print("")
-    print("\t%-20s %12s %8s %10s" % ("Name", "Type",  "Length", "Decimals"))
-    print("\t-----------------------------------------------------")
-
-    # print out field characteristics
-
-    for idx in range(0, dbf_obj.nFields):
-        print("\t%-20s %12s %8d %10d" % (dbf_obj.getFieldName(idx), dbf_obj.getFieldType(idx),
-                                         dbf_obj.getFieldWidth(idx), dbf_obj.getFieldDecimals(idx)))
-
-
-def main(sf_path):
-
-    if not sf_path.lower().endswith(".shp"):
-        sf_path += ".shp"
-
-    sf_obj = get_shapefile_object(sf_path)
-
-    print("Shapefile %s:" % sf_path)
-    print("")
-
-    get_shapefile_details(sf_obj)
-    get_dbf_details(sf_obj)
-
-
-def usage():
-    """
-    Display usage if program is used incorrectly
-    """
-    print("Syntax: %s <shapefile_path>" % sys.argv[0])
-    sys.exit(2)
-
-
-# make sure a filename argument is provided
-if len(sys.argv) != 2:
-    usage()
-
-main(sys.argv[1])
diff -pruN 8.0.1-5/mapscript/python/examples/wxs.py 8.2.0~beta1-1~exp1/mapscript/python/examples/wxs.py
--- 8.0.1-5/mapscript/python/examples/wxs.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/examples/wxs.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,61 +0,0 @@
-#!/usr/bin/env python
-
-"""
-Output WMS GetCapabilities response for a Mapfile
-
-Usage:
-
-python wxs.py test.map
-
-"""
-import sys
-import xml.dom.minidom
-import mapscript
-
-
-def main(map_file):
-
-    map = mapscript.mapObj(map_file)
-    map.web.metadata.set("ows_onlineresource", "http://dummy.org/")
-    ows_req = mapscript.OWSRequest()
-
-    ows_req.type = mapscript.MS_GET_REQUEST
-
-    ows_req.setParameter("SERVICE", "WMS")
-    ows_req.setParameter("VERSION", "1.1.0")
-    ows_req.setParameter("REQUEST", "GetCapabilities")
-
-    mapscript.msIO_installStdoutToBuffer()
-    dispatch_status = map.OWSDispatch(ows_req)
-
-    if dispatch_status != mapscript.MS_SUCCESS:
-        print("An error occurred")
-
-    content_type = mapscript.msIO_stripStdoutBufferContentType()
-    mapscript.msIO_stripStdoutBufferContentHeaders()
-    result = mapscript.msIO_getStdoutBufferBytes()
-
-    # [('Content-Type', 'application/vnd.ogc.wms_xml; charset=UTF-8'), ('Content-Length', '11385')]
-    response_headers = [('Content-Type', content_type),
-                        ('Content-Length', str(len(result)))]
-
-    assert int(response_headers[1][1]) > 0
-
-    dom = xml.dom.minidom.parseString(result)
-    print(dom.toprettyxml(indent="", newl=""))
-
-
-def usage():
-    """
-    Display usage if program is used incorrectly
-    """
-    print("Syntax: %s <mapfile_path>" % sys.argv[0])
-    sys.exit(2)
-
-
-# make sure a filename argument is provided
-if len(sys.argv) != 2:
-    usage()
-
-map_file = sys.argv[1]
-main(map_file)
diff -pruN 8.0.1-5/mapscript/python/mapscript/__init__.py 8.2.0~beta1-1~exp1/mapscript/python/mapscript/__init__.py
--- 8.0.1-5/mapscript/python/mapscript/__init__.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/mapscript/__init__.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,43 +0,0 @@
-import sys
-import platform
-import os
-import inspect
-
-# As of Python 3.8 PATH can no longer be used to resolve the MapServer
-# DLLs on Windows. Instead users will be required to set a new MAPSERVER_DLL_PATH
-# environment variable.
-# See https://docs.python.org/3/whatsnew/3.8.html#changes-in-the-python-api
-
-
-def add_dll_path(pth):
-    """
-    Allow Python to access the directory containing the MapServer DLL (for Python on Windows only)
-    """
-    if (3, 8) <= sys.version_info:
-        os.add_dll_directory(pth)
-    else:
-        # add the directory to the Windows path for earlier Python version
-        os.environ['PATH'] = pth + ';' + os.environ['PATH']
-
-
-if platform.system() == 'Windows':
-    mapserver_dll_path = os.getenv('MAPSERVER_DLL_PATH', '')
-    dll_paths = list(filter(os.path.exists, mapserver_dll_path.split(';')))
-    # add paths in the order listed in the string
-    dll_paths.reverse()
-    for pth in dll_paths:
-        add_dll_path(pth)
-
-
-from .mapscript import *
-
-
-# change all the class module names from mapscript.mapscript to mapscript
-
-for key, value in globals().copy().items():
-    if inspect.isclass(value) and value.__module__.startswith('mapscript.'):
-        value.__module__= 'mapscript'
-
-# remove the submodule name
-
-del mapscript
diff -pruN 8.0.1-5/mapscript/python/pyextend.i 8.2.0~beta1-1~exp1/mapscript/python/pyextend.i
--- 8.0.1-5/mapscript/python/pyextend.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/pyextend.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,490 +0,0 @@
-/******************************************************************************
- * Project:  MapServer
- * Purpose:  Python-specific extensions to MapScript objects
- * Author:   Sean Gillies, sgillies@frii.com
- * Author:   Seth Girvin, sethg@geographika.co.uk
- *
- ******************************************************************************
- *
- * Python-specific mapscript code has been moved into this 
- * SWIG interface file to improve the readability of the main
- * interface file.  The main mapscript.i file includes this
- * file when SWIGPYTHON is defined (via 'swig -python ...').
- *
- *****************************************************************************/
-
-// required for Python 3.10+ - see https://bugs.python.org/issue40943
-%begin %{
-#define PY_SSIZE_T_CLEAN
-%}
-
-/* fromstring: Factory for mapfile objects */
-
-%pythoncode %{
-def fromstring(data, mappath=None, configpath=None):
-    """Creates map objects from mapfile strings.
-
-    Parameters
-    ==========
-    data : string
-        Mapfile in a string.
-    mappath : string
-        Optional root map path, enabling relative paths in mapfile.
-
-    Example
-    =======
-    >>> mo = fromstring("MAP\nNAME 'test'\nEND")
-    >>> mo.name
-    'test'
-    """
-    import re
-    if re.search(r"^\s*MAP", data, re.I):
-        # create a config object if a path is supplied
-        if configpath:
-             config = configObj(configpath)
-        else:
-             config = None
-        return msLoadMapFromString(data, mappath, config)
-    elif re.search(r"^\s*LAYER", data, re.I):
-        ob = layerObj()
-        ob.updateFromString(data)
-        return ob
-    elif re.search(r"^\s*CLASS", data, re.I):
-        ob = classObj()
-        ob.updateFromString(data)
-        return ob
-    elif re.search(r"^\s*STYLE", data, re.I):
-        ob = styleObj()
-        ob.updateFromString(data)
-        return ob
-    else:
-        raise ValueError("No map, layer, class, or style found. Can not load from provided string")
-%}
-
-
-/* ===========================================================================
-   Python rectObj extensions
-   ======================================================================== */
-   
-%extend rectObj {
-
-%pythoncode %{
-
-    def __str__(self):
-        return self.toString()
-
-    def __contains__(self, item):
-        item_type = item.__class__.__name__
-        if item_type == "pointObj":
-            if item.x >= self.minx and item.x <= self.maxx \
-            and item.y >= self.miny and item.y <= self.maxy:
-                return True
-            else:
-                return False
-        else:
-            raise TypeError('__contains__ does not yet handle %s' % (item_type))
-
-%}
-}
-
-/* ===========================================================================
-   Python pointObj extensions
-   ======================================================================== */
-
-%extend pointObj {
-
-%pythoncode %{
-
-    def __str__(self):
-        return self.toString()
-
-    @property
-    def __geo_interface__(self):
-
-        if hasattr(self, "z"):
-            coords = (self.x, self.y, self.z)
-        else:
-            coords = (self.x, self.y)
-
-        return {"type": "Point", "coordinates": coords}
-
-%}
-}
-
-
-/* ===========================================================================
-   Python lineObj extensions
-   ======================================================================== */
-   
-%extend lineObj {
-
-%pythoncode %{
-
-    @property
-    def __geo_interface__(self):
-
-        coords = []
-
-        for idx in range(0, self.numpoints):
-            pt = self.get(idx)
-            geom = pt.__geo_interface__
-            coords.append(geom["coordinates"])
-
-        return {"type": "LineString", "coordinates": coords}
-
-%}
-}
-
-
-/* ===========================================================================
-   Python shapeObj extensions
-   ======================================================================== */
-
-%extend shapeObj {
-
-%pythoncode %{
-
-        def _convert_item_values(self, property_values, property_types):
-            """
-            **Python MapScript only**
-
-            Convert an item value, which is always stored as a string, into a
-            Python type, based on an attributes GML metadata type. These can be one
-            of the following:
-
-            ``Integer|Long|Real|Character|Date|Boolean``
-            """
-
-            typed_values = []
-
-            for value, type_ in zip(property_values, property_types):
-                try:
-                    if type_.lower() == "integer":
-                        value = int(value)
-                    elif type_.lower() == "long":
-                        value = long(value)
-                    elif type_.lower() == "real":
-                        value = float(value)
-                    else:
-                        pass
-                except ValueError:
-                    pass
-
-                typed_values.append(value)
-
-            return typed_values
-
-        @property
-        def __geo_interface__(self):
-
-            bounds = self.bounds
-            ms_geom_type = self.type
-
-            # see https://tools.ietf.org/html/rfc7946 for GeoJSON types
-
-            if ms_geom_type == MS_SHAPE_POINT or ms_geom_type == MS_SHP_POINTZ or ms_geom_type == MS_SHP_POINTM:
-                geom_type = "Point"
-            elif ms_geom_type == MS_SHP_MULTIPOINTZ or ms_geom_type == MS_SHP_MULTIPOINTM:
-                geom_type = "MultiPoint"
-            elif ms_geom_type == MS_SHAPE_LINE or ms_geom_type == MS_SHP_ARCZ or ms_geom_type == MS_SHP_ARCM:
-                if self.numlines == 1:
-                    geom_type = "LineString"
-                else:
-                    geom_type = "MultiLineString"
-            elif ms_geom_type == MS_SHAPE_POLYGON or ms_geom_type == MS_SHP_POLYGONZ or ms_geom_type == MS_SHP_POLYGONM:
-                if self.numlines == 1:
-                    geom_type = "Polygon"
-                else:
-                    geom_type = "MultiPolygon"
-            elif ms_geom_type == MS_SHAPE_NULL:
-                return None
-            else:
-                raise TypeError("Shape type {} not supported".format(geom_type))
-
-            properties = {}
-            coords = []
-
-            # property names are stored at the layer level
-            # https://github.com/mapserver/mapserver/issues/130
-
-            property_values = [self.getValue(idx) for idx in range(0, self.numvalues)]
-
-            if hasattr(self, "_item_definitions"):
-                property_names, property_types = zip(*self._item_definitions)
-                property_values = self._convert_item_values(property_values, property_types)
-            else:
-                property_names = [str(idx) for idx in range(0, self.numvalues)]
-
-            properties = dict(zip(property_names, property_values))
-
-            for idx in range(0, self.numlines):
-                line = self.get(idx)
-                geom = line.__geo_interface__
-                coords.append(geom["coordinates"])
-
-            return {
-                    "type": "Feature",
-                    "bbox": (bounds.minx, bounds.miny, bounds.maxx, bounds.maxy),
-                    "properties": properties,
-                    "geometry": {
-                        "type": geom_type,
-                        "coordinates": coords
-                        }
-                    }
-
-        @property
-        def itemdefinitions(self):
-            return self._item_definitions
-
-        @itemdefinitions.setter
-        def itemdefinitions(self, item_definitions):
-            self._item_definitions = item_definitions
-
-%}
-}
-
-/******************************************************************************
- * Extensions to mapObj
- *****************************************************************************/
-
-%extend mapObj {
-  
-    /**
-    \**Python MapScript only**  - returns the map layer order as a native sequence
-    */
-    PyObject *getLayerOrder() {
-        int i;
-        PyObject *order;
-        order = PyTuple_New(self->numlayers);
-        for (i = 0; i < self->numlayers; i++) {
-            PyTuple_SetItem(order,i,PyInt_FromLong((long)self->layerorder[i]));
-        }
-        return order;
-    } 
-
-    /**
-    \**Python MapScript only** - sets the map layer order using a native sequence
-    */
-    int setLayerOrder(PyObject *order) {
-        int i;
-        Py_ssize_t size = PyTuple_Size(order);
-        for (i = 0; i < size; i++) {
-            self->layerorder[i] = (int)PyInt_AsLong(PyTuple_GetItem(order, i));
-        }
-        return MS_SUCCESS;
-    }
-    
-    /**
-    \**Python MapScript only** - gets the map size as a tuple
-    */
-    PyObject* getSize()
-    {
-        PyObject* output ;
-        output = PyTuple_New(2);
-        PyTuple_SetItem(output,0,PyInt_FromLong((long)self->width));
-        PyTuple_SetItem(output,1,PyInt_FromLong((long)self->height));
-        return output;
-    }
-
-%pythoncode %{
-
-    def get_height(self):
-        """
-        **Python MapScript only**
-        Return the map height from the map size
-        """
-        return self.getSize()[1] # <-- second member is the height
-
-    def get_width(self):
-        """
-        **Python MapScript only**
-        Return the map width from the map size
-        """
-        return self.getSize()[0] # <-- first member is the width
-
-    def set_height(self, value):
-        """
-        **Python MapScript only**
-        Set the map height value of the map size
-        """
-        return self.setSize(self.getSize()[0], value)
-
-    def set_width(self, value):
-        """
-        **Python MapScript only**
-        Set the map width value of the map size
-        """
-        return self.setSize(value, self.getSize()[1])
-
-    width = property(get_width, set_width, doc="See :ref:`SIZE <mapfile-map-size>`")
-    height = property(get_height, set_height, doc = "See :ref:`SIZE <mapfile-map-size>`")
-
-%}
-}
-
-/******************************************************************************
- * Extensions to layerObj
- *****************************************************************************/
-
-%extend layerObj {
-  
-%pythoncode %{
-
-    def getItemDefinitions(self):
-        """
-        **Python MapScript only**
-        
-        Return item (field) names and their types if available.
-        Field types are specified using GML metadata and can be one of the following:
-
-        ``Integer|Long|Real|Character|Date|Boolean``
-
-        """
-        item_names = [self.getItem(idx) for idx in range(0, self.numitems)]
-        item_types = [self.getItemType(idx) for idx in range(0, self.numitems)]
-        return zip(item_names, item_types)
-
-%}
-}
-
-/******************************************************************************
- * Extensions to imageObj
- *****************************************************************************/
-    
-%extend imageObj {
-
-    /**
-    Write image data to an open file handle. Replaces
-    the removed saveToString function.  See ``python/pyextend.i`` for the Python specific
-    version of this method.
-    */
-    int write( PyObject *file=Py_None )
-    {
-        unsigned char *imgbuffer=NULL;
-        int imgsize;
-        PyObject *noerr;
-        int retval=MS_FAILURE;
-
-        /* Return immediately if image driver is not GD */
-        if ( !MS_RENDERER_PLUGIN(self->format) )
-        {
-            msSetError(MS_IMGERR, "Writing of %s format not implemented",
-                       "imageObj::write", self->format->driver);
-            return MS_FAILURE;
-        }
-
-        if (file == Py_None) /* write to stdout */
-            retval = msSaveImage(NULL, self, NULL);
-        else /* presume a Python file-like object */
-        {
-            imgbuffer = msSaveImageBuffer(self, &imgsize,
-                                          self->format);
-            if (imgsize == 0)
-            {
-                msSetError(MS_IMGERR, "failed to get image buffer", "write()");
-                return MS_FAILURE;
-            }
-
-%#if PY_MAJOR_VERSION >= 3
-            // https://docs.python.org/3/c-api/arg.html
-            noerr = PyObject_CallMethod(file, "write", "y#", imgbuffer, (Py_ssize_t)imgsize);
-%#else
-            // https://docs.python.org/2/c-api/arg.html
-            noerr = PyObject_CallMethod(file, "write", "s#", imgbuffer, imgsize);
-%#endif
-
-            free(imgbuffer);
-            if (noerr == NULL)
-                return MS_FAILURE;
-            else
-                Py_DECREF(noerr);
-            retval = MS_SUCCESS;
-        }
-
-        return retval;
-    }
-}
-
-
-/******************************************************************************
- * Extensions to styleObj
- *****************************************************************************/
-
-%extend styleObj {
-
-    /// **Python Only** Set the pattern for the style.
-    void pattern_set(int nListSize, double* pListValues)
-    {
-        if( nListSize < 2 )
-        {
-            msSetError(MS_SYMERR, "Not enough pattern elements. A minimum of 2 are required", "pattern_set()");
-            return;
-        }
-        if( nListSize > MS_MAXPATTERNLENGTH )
-        {
-            msSetError(MS_MISCERR, "Too many elements", "pattern_set()");
-            return;
-        }
-        memcpy( self->pattern, pListValues, sizeof(double) * nListSize);
-        self->patternlength = nListSize;
-    }
-
-    /// **Python Only** Get the pattern for the style.
-    void pattern_get(double** argout, int* pnListSize)
-    {
-        *pnListSize = self->patternlength;
-        *argout = (double*) malloc(sizeof(double) * *pnListSize);
-        memcpy( *argout, self->pattern, sizeof(double) * *pnListSize);
-    }
-
-
-%pythoncode %{
-
-pattern = property(pattern_get, pattern_set, doc=r"""pattern : list **Python Only**""")
-
-%}
-}
-
-/******************************************************************************
- * Extensions to hashTableObj - add dict methods
- *****************************************************************************/
-
-%extend hashTableObj{
-
-    %pythoncode %{
-
-    def __getitem__(self, key):
-        return self.get(key)
-
-    def __setitem__(self, key, value):
-        return self.set(key, value)
-
-    def __delitem__(self, key) :
-        return self.remove(key)
-
-    def __contains__(self, key):
-        return key.lower() in [k.lower() for k in self.keys()]
-
-    def __len__(self):
-        return self.numitems
-
-    def keys(self):
-        """
-        **Python-only**. In Python MapScript the ``hashTableObj`` can be used and accessed
-        as a dictionary. The ``keys`` method returns a view of all the keys in the ``hashTableObj``.
-        """
-
-        keys = []
-        k = None
-
-        while True :
-            k = self.nextKey(k)
-            if k :
-                keys.append(k)
-            else :
-                break
-
-        return keys
-            
-%}
-}
diff -pruN 8.0.1-5/mapscript/python/pymodule.i 8.2.0~beta1-1~exp1/mapscript/python/pymodule.i
--- 8.0.1-5/mapscript/python/pymodule.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/pymodule.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,312 +0,0 @@
-/******************************************************************************
- * Project:  MapServer
- * Purpose:  Python-specific enhancements to MapScript
- * Author:   Sean Gillies, sgillies@frii.com
- *
- ******************************************************************************
- *
- * Python-specific mapscript code has been moved into this 
- * SWIG interface file to improve the readability of the main
- * interface file.  The main mapscript.i file includes this
- * file when SWIGPYTHON is defined (via 'swig -python ...').
- *
- *****************************************************************************/
-
-/******************************************************************************
- * Simple Typemaps
- *****************************************************************************/
-
-/* Translates Python None to C NULL for strings */
-//%typemap(in,parse="z") char * "";
-
-/* To support imageObj::getBytes */
-%typemap(out) gdBuffer {
-    $result = PyBytes_FromStringAndSize((const char*)$1.data, $1.size);
-    if( $1.owns_data )
-       msFree($1.data);
-}
-
-
-/*
- *  Typemap for counted arrays of doubles <- PySequence
- */
-%typemap(in,numinputs=1) (int nListSize, double* pListValues)
-{
-  int i;
-  /* %typemap(in,numinputs=1) (int nListSize, double* pListValues)*/
-  /* check if is List */
-  if ( !PySequence_Check($input) ) {
-    PyErr_SetString(PyExc_TypeError, "not a sequence");
-    SWIG_fail;
-  }
-  $1 = (int) PySequence_Size($input);
-  $2 = (double*) malloc($1*sizeof(double));
-  for( i = 0; i<$1; i++ ) {
-    PyObject *o = PySequence_GetItem($input,i);
-    if ( !PyArg_Parse(o,"d",&$2[i]) ) {
-      PyErr_SetString(PyExc_TypeError, "not a number");
-      Py_DECREF(o);
-      SWIG_fail;
-    }
-    Py_DECREF(o);
-  }
-}
-
-
-%fragment("CreateTupleFromDoubleArray","header") %{
-static PyObject *
-CreateTupleFromDoubleArray( double *first, unsigned int size ) {
-  unsigned int i;
-  PyObject *out = PyTuple_New( size );
-  for( i=0; i<size; i++ ) {
-    PyObject *val = PyFloat_FromDouble( *first );
-    ++first;
-    PyTuple_SetItem( out, i, val );
-  }
-  return out;
-}
-%}
-
-%typemap(freearg) (int nListSize, double* pListValues)
-{
-  /* %typemap(freearg) (int nListSize, double* pListValues) */
-  if ($2) {
-    free((void*) $2);
-  }
-}
-
-
-%typemap(in,numinputs=0) (double** argout, int* pnListSize) ( double* argout, int nListSize ) {
-  /* %typemap(python,in,numinputs=0) (double *val, int*hasval) */
-  $1 = &argout;
-  $2 = &nListSize;
-}
-
-%typemap(argout,fragment="t_output_helper,CreateTupleFromDoubleArray") (double** argout, int* pnListSize) 
-{
-   /* %typemap(argout) (double* argout, int* pnListSize)  */
-  PyObject *r;
-  r = CreateTupleFromDoubleArray(*$1, *$2);
-  free(*$1);
-  $result = t_output_helper($result,r);
-}
-
-/*
- *  Typemap to turn a Python dict into two sequences and
- *  an item count. Used for msApplySubstitutions
- */
-%typemap(in) (char **names, char **values, int npairs) {
-  /* Check if is a dict */
-  if (PyDict_Check($input)) {
-
-    int i = 0;
-    int size = (int) PyDict_Size($input);
-
-    PyObject* keys = PyDict_Keys($input);
-    PyObject* values = PyDict_Values($input);
-
-    $3 = size;
-    $1 = (char **) malloc((size+1)*sizeof(char *));
-    $2 = (char **) malloc((size+1)*sizeof(char *));
-
-    for (i = 0; i < size; i++) {
-        PyObject* key = PyList_GetItem(keys, i);
-        PyObject* val = PyList_GetItem(values, i);
-
-        %#if PY_MAJOR_VERSION >= 3
-            // Changed in version 3.7: The return type is now const char * rather than char *
-            // avoid warning C4090: '=': different 'const' qualifiers
-            $1[i] = (char *)PyUnicode_AsUTF8(key);
-            $2[i] = (char *)PyUnicode_AsUTF8(val);
-        %#else
-            $1[i] = PyString_AsString(key);
-            $2[i] = PyString_AsString(val);
-        %#endif
-    }
-
-    $1[i] = 0;
-    $2[i] = 0;
-
-  } else {
-    PyErr_SetString(PyExc_TypeError, "Input not a dictionary");
-    SWIG_fail;
-  }
-}
-
-%typemap(freearg) (char **names, char **values, int npairs) {
-  free((char *) $1);
-  free((char *) $2);
-}
-
-/**************************************************************************
- * MapServer Errors and Python Exceptions
- **************************************************************************
- *
- * Translation of errors reported via the ms_error structure into
- * Python exceptions. Original code by Chris Chamberlin <cdc@aracnet.com>
- * has been updated by Sean Gillies <sgillies@frii.com> to use 
- * PyErr_SetString, %exception and $action for SWIG 1.3, do the most
- * obvious mapping of MapServer errors to Python exceptions and map all 
- * others to a new 'MapServerError' exception which can be caught like this:
- * 
- *   from mapscript import *
- *   empty_map = mapObj('')
- *   try:
- *       img = empty_map.draw()
- *   except MapServerError, msg:
- *       print "Caught MapServerError:", msg
- *
- *************************************************************************/
-
-%{
-PyObject *MSExc_MapServerError;
-PyObject *MSExc_MapServerChildError;
-%}
-
-/* Module initialization: call msSetup() and register msCleanup() */
-%init %{
-
-/* See bug 1203 for discussion of race condition with GD font cache */
-    if (msSetup() != MS_SUCCESS)
-    {
-        msSetError(MS_MISCERR, "Failed to set up threads and font cache",
-                   "msSetup()");
-    }
-
-    Py_AtExit(msCleanup);
-
-/* Define Generic MapServer error */
-MSExc_MapServerError=PyErr_NewException("_mapscript.MapServerError",NULL,NULL);
-if (MSExc_MapServerError != NULL)
-    PyDict_SetItemString(d, "MapServerError", MSExc_MapServerError);
-
-/* Define MapServer MS_CHILD error */
-MSExc_MapServerChildError = PyErr_NewException("_mapscript.MapServerChildError", NULL, NULL);
-if (MSExc_MapServerChildError != NULL)
-    PyDict_SetItemString(d, "MapServerChildError", MSExc_MapServerChildError);
-
-%}
-
-%{
-
-static void _raise_ms_exception( void );
-
-static void _raise_ms_exception() {
-    int errcode;
-    errorObj *ms_error;
-    char *errmsg;
-    ms_error = msGetErrorObj();
-    errcode = ms_error->code;
-    errmsg = msGetErrorString("\n");
-    
-    switch (errcode) {
-        case MS_IOERR:
-            PyErr_SetString(PyExc_IOError, errmsg);
-            break;
-        case MS_MEMERR:
-            PyErr_SetString(PyExc_MemoryError, errmsg);
-            break;
-        case MS_TYPEERR:
-            PyErr_SetString(PyExc_TypeError, errmsg);
-            break;
-        case MS_EOFERR:
-            PyErr_SetString(PyExc_EOFError, errmsg);
-            break;
-        case MS_CHILDERR:
-            PyErr_SetString(MSExc_MapServerChildError, errmsg);
-            break;
-        default:
-            PyErr_SetString(MSExc_MapServerError, errmsg);
-            break;
-    }
-
-    free(errmsg);
-}
-  
-%}
-
-%exception {
-    $action {
-        errorObj *ms_error = msGetErrorObj();
-       
-        switch(ms_error->code) {
-            case MS_NOERR:
-                break;
-            case MS_NOTFOUND:
-                msResetErrorList();
-                break;
-            case -1:
-                break;
-            case MS_IOERR:
-                /*
-                if (strcmp(ms_error->routine, "msSearchDiskTree()") != 0) {
-                    _raise_ms_exception();
-                    msResetErrorList();
-                    return NULL;
-                }
-                */
-            default:
-                _raise_ms_exception();
-                msResetErrorList();
-                return NULL;
-        }
-                
-    }
-}
-         
-%pythoncode %{
-MapServerError = _mapscript.MapServerError
-MapServerChildError = _mapscript.MapServerChildError
-%}
-
-%feature("pythonappend") layerObj %{
-    self.p_map = None
-    if map: 
-        self.p_map = map%}
-
-%feature("pythonappend") classObj %{
-    self.p_layer = None
-    if layer: 
-        self.p_layer = layer%}
-
-%feature("shadow") insertClass %{
-    def insertClass(*args):
-        actualIndex=$action(*args)
-        args[1].p_layer=args[0]
-        return actualIndex%}
-
-%feature("shadow") getClass %{
-    def getClass(*args):
-        clazz = $action(*args)
-        if clazz:
-            if args and len(args)!=0:
-                clazz.p_layer=args[0]
-            else:
-                clazz.p_layer=None
-        return clazz%}
-
-%feature("shadow") insertLayer %{
-    def insertLayer(*args):
-        actualIndex=$action(*args)
-        args[1].p_map=args[0]
-        return actualIndex%}
-
-%feature("shadow") getLayer %{
-    def getLayer(*args):
-        layer = $action(*args)
-        if layer:
-            if args and len(args)!=0:
-                layer.p_map=args[0]
-            else:
-                layer.p_map=None
-        return layer%}
-
-%feature("shadow") getLayerByName %{
-    def getLayerByName(*args):
-        layer = $action(*args)
-        if layer:
-            if args and len(args)!=0:
-                layer.p_map=args[0]
-            else:
-                layer.p_map=None
-        return layer%}
diff -pruN 8.0.1-5/mapscript/python/requirements-dev.txt 8.2.0~beta1-1~exp1/mapscript/python/requirements-dev.txt
--- 8.0.1-5/mapscript/python/requirements-dev.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/requirements-dev.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,6 +0,0 @@
-pytest
-pillow
-wheel>=0.31.1
-setuptools>=40.2.0
-flake8==3.9.2; python_version == '2.7'
-flake8==5.0.3; python_version >= '3.0'
\ No newline at end of file
diff -pruN 8.0.1-5/mapscript/python/setup.py.in 8.2.0~beta1-1~exp1/mapscript/python/setup.py.in
--- 8.0.1-5/mapscript/python/setup.py.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/setup.py.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
-from io import open
-from setuptools import setup, find_packages, Distribution
-
-
-class BinaryDistribution(Distribution):
-    """
-    Distribution which always forces a binary package with platform name
-    See http://lucumr.pocoo.org/2014/1/27/python-on-wheels/
-    and https://stackoverflow.com/questions/24071491/how-can-i-make-a-python-wheel-from-an-existing-native-library
-    """
-    def has_ext_modules(foo):
-        return True
-    def is_pure(self):
-        return False
-
-
-def readme():
-    with open('README.rst', "r", encoding="utf-8") as f:
-        return f.read()
-
-setup(
-    name="mapscript",
-    description = "MapServer Python MapScript bindings",
-    long_description=readme(),
-    classifiers = [
-        'Development Status :: 4 - Beta',
-        'Intended Audience :: Developers',
-        'Intended Audience :: Science/Research',
-        'License :: OSI Approved :: MIT License',
-        'Operating System :: OS Independent',
-        'Programming Language :: Python :: 2.7',
-        'Programming Language :: Python :: 3',
-        'Programming Language :: C',
-        'Programming Language :: C++',
-        'Topic :: Scientific/Engineering :: GIS',
-        'Topic :: Scientific/Engineering :: Information Analysis',
-    ],
-    author = "Steve Lime",
-    license = "MIT",
-    url="http://www.mapserver.org",
-    version="@MapServer_VERSION_MAJOR@.@MapServer_VERSION_MINOR@.@MapServer_VERSION_REVISION@",
-    packages=find_packages(),
-    package_data={
-        # list the files to include starting with the most deeply nested folder or they are overwritten
-        'mapscript': ['tests/data/vera/*.*', 'tests/data/*.*', '$<TARGET_FILE_NAME:@SWIG_MODULE_pythonmapscript_REAL_NAME@>']
-        },
-    distclass=BinaryDistribution
-)
\ No newline at end of file
diff -pruN 8.0.1-5/mapscript/python/tests/TESTING.txt 8.2.0~beta1-1~exp1/mapscript/python/tests/TESTING.txt
--- 8.0.1-5/mapscript/python/tests/TESTING.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/TESTING.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,34 +0,0 @@
-.. $Id$
-
-Python MapScript Unit Tests
-========================================
-
-Authors: Sean Gillies, sgillies@frii.com
-         Howard Butler, hobu@iastate.edu
-
-
-Running the tests
------------------
-
-To run all of the tests, change directory to cases and execute
-::
-
-    $ cd cases
-    $ python runalltests.py -v
-    
-This runs all tests found in every TestCase derived class defined in any
-module named "cases/*test.py".  The tests cannot be run properly from
-another path.  The unit test script will insert the local build directory
-produced by Python distutils into the head of the Python PATH.  This allows
-us to run the unit tests before installing the mapscript module.  The unit
-tests use a map config file, symbolset file, fontset file, and data located
-in the 'tests' directory of the mapserver distribution.
-
-If you encounter any errors, please create a new issue in the MapServer
-bug tracker
-
-    http://mapserver.gis.umn.edu/bugs/enter_bug.cgi
-
-under the SWIG-MapScript component.  Copy the relevant error messages
-and we'll get to the bug ASAP.  Thanks!
-
diff -pruN 8.0.1-5/mapscript/python/tests/cases/class_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/class_test.py
--- 8.0.1-5/mapscript/python/tests/cases/class_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/class_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,144 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of classObj
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase
-
-
-class ClassObjTestCase(unittest.TestCase):
-
-    def testConstructorNoArg(self):
-        c = mapscript.classObj()
-        assert c.thisown == 1
-        assert c.layer is None
-        assert c.numstyles == 0
-
-    def testConstructorWithArg(self):
-        lyr = mapscript.layerObj()
-        lyr.name = 'foo'
-        c = mapscript.classObj(lyr)
-        assert c.thisown == 1
-        assert c.layer.name == lyr.name
-        assert c.numstyles == 0
-
-    def testGetSetAttributes(self):
-        c = mapscript.classObj()
-
-        val = '/tmp/legend.png'
-        c.keyimage = val
-        assert c.keyimage == val
-
-        c.debug = mapscript.MS_TRUE
-        assert c.debug == mapscript.MS_TRUE
-
-        val = 'Group1'
-        c.group = val
-        assert c.group == val
-
-        val = 10000
-        c.maxscaledenom = val
-        assert c.maxscaledenom == val
-
-        val = 3
-        c.minfeaturesize = val
-        assert c.minfeaturesize == val
-
-        val = 1000
-        c.minscaledenom = val
-        assert c.minscaledenom == val
-
-        val = 'Class1'
-        c.name = val
-        assert c.name == val
-
-        c.status = mapscript.MS_OFF
-        assert c.status == mapscript.MS_OFF
-
-        val = 'template.html'
-        c.template = val
-        assert c.template == val
-
-        val = 'Title1'
-        c.title = val
-        assert c.title == val
-
-
-class ClassCloningTestCase(unittest.TestCase):
-
-    def testCloneClass(self):
-        """check attributes of a cloned class"""
-        c = mapscript.classObj()
-        c.minscaledenom = 5.0
-        clone = c.clone()
-        assert clone.thisown == 1
-        assert clone.minscaledenom == 5.0
-
-
-class ClassIconTestCase(MapTestCase):
-
-    """testing for bug 1250"""
-
-    def testAlphaTransparentPixmap(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-RGBA')
-        co = lo.getClass(0)
-        self.map.selectOutputFormat('PNG')
-        im = co.createLegendIcon(self.map, lo, 48, 48)
-        im.save('testAlphaTransparentPixmapIcon.png')
-
-    def testAlphaTransparentPixmapPNG24(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-RGBA')
-        co = lo.getClass(0)
-        self.map.selectOutputFormat('PNG24')
-        im = co.createLegendIcon(self.map, lo, 48, 48)
-        im.save('testAlphaTransparentPixmapIcon24.png')
-
-    def testAlphaTransparentPixmapJPG(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-RGBA')
-        co = lo.getClass(0)
-        self.map.selectOutputFormat('JPEG')
-        im = co.createLegendIcon(self.map, lo, 48, 48)
-        im.save('testAlphaTransparentPixmapIcon.jpg')
-
-    def testIndexedTransparentPixmap(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-PCT')
-        lo.type = mapscript.MS_LAYER_POINT
-        co = lo.getClass(0)
-        self.map.selectOutputFormat('PNG')
-        im = co.createLegendIcon(self.map, lo, 32, 32)
-        im.save('testIndexedTransparentPixmapIcon.png')
-
-    def testIndexedTransparentPixmapJPG(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-PCT')
-        lo.type = mapscript.MS_LAYER_POINT
-        co = lo.getClass(0)
-        self.map.selectOutputFormat('JPEG')
-        im = co.createLegendIcon(self.map, lo, 32, 32)
-        im.save('testIndexedTransparentPixmapIcon.jpg')
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/clone_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/clone_test.py
--- 8.0.1-5/mapscript/python/tests/cases/clone_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/clone_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,98 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of map cloning
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import TESTMAPFILE
-
-
-class MapCloneTestCase(unittest.TestCase):
-    """Base class for testing with a map fixture"""
-
-    def setUp(self):
-        self.mapobj_orig = mapscript.mapObj(TESTMAPFILE)
-        self.mapobj_clone = self.mapobj_orig.clone()
-
-    def tearDown(self):
-        self.mapobj_orig = None
-        self.mapobj_clone = None
-
-
-class MapCloningTestCase(MapCloneTestCase):
-
-    def testClonedName(self):
-        """MapCloningTestCase.testClonedName: the name of a cloned map equals the original"""
-        assert self.mapobj_clone.name == self.mapobj_orig.name
-
-    def testClonedLayers(self):
-        """MapCloningTestCase.testClonedLayers: the layers of a cloned map equal the original"""
-        assert self.mapobj_clone.numlayers == self.mapobj_orig.numlayers
-        assert self.mapobj_clone.getLayer(0).data \
-            == self.mapobj_orig.getLayer(0).data
-
-    def testSetFontSet(self):
-        """MapCloningTestCase.testSetFontSet: the number of fonts in a cloned map equal original"""
-        assert self.mapobj_clone.fontset.numfonts == 2
-
-    def testSetSymbolSet(self):
-        """MapCloningTestCase.testSetSymbolSet: the number of symbols in a cloned map equal original"""
-        num = self.mapobj_clone.symbolset.numsymbols
-        assert num == 5, num
-
-    def testDrawClone(self):
-        """drawing a cloned map works properly"""
-        msimg = self.mapobj_clone.draw()
-        assert msimg.thisown == 1
-        filename = 'testClone.png'
-        fh = open(filename, 'wb')
-        msimg.write(fh)
-        fh.close()
-
-    def testDrawCloneJPEG(self):
-        """drawing a cloned map works properly"""
-        self.mapobj_clone.selectOutputFormat('JPEG')
-        self.mapobj_clone.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
-        msimg = self.mapobj_clone.draw()
-        assert msimg.thisown == 1
-        filename = 'testClone.jpg'
-        fh = open(filename, 'wb')
-        msimg.write(fh)
-        fh.close()
-
-    def testDrawClonePNG24(self):
-        """drawing a cloned map works properly"""
-        self.mapobj_clone.selectOutputFormat('PNG24')
-        self.mapobj_clone.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
-        msimg = self.mapobj_clone.draw()
-        assert msimg.thisown == 1
-        filename = 'testClonePNG24.png'
-        fh = open(filename, 'wb')
-        msimg.write(fh)
-        fh.close()
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/cluster_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/cluster_test.py
--- 8.0.1-5/mapscript/python/tests/cases/cluster_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/cluster_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,60 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of clusterObj
-# Author:   Seth Girvin
-#
-# ===========================================================================
-# Copyright (c) 2019, Seth Girvin
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-
-
-class ClusterObjTestCase(unittest.TestCase):
-
-    def testClusterObjUpdateFromString(self):
-        """a cluster can be updated from a string"""
-        c = mapscript.clusterObj()
-        c.updateFromString("CLUSTER \n MAXDISTANCE 5 \n REGION \n 'rectangle' END")
-
-        assert c.maxdistance == 5
-        assert c.region == 'rectangle'
-
-        s = c.convertToString()
-        assert s == 'CLUSTER\n  MAXDISTANCE 5\n  REGION "rectangle"\nEND # CLUSTER\n'
-
-    def testClusterObjGetSetFilter(self):
-        """a cluster filter can be set and read"""
-        c = mapscript.clusterObj()
-        filter = '[attr1] > 5'
-        c.setFilter(filter)
-        assert '"{}"'.format(filter) == c.getFilterString()
-
-    def testClusterObjGetSetGroup(self):
-        """a cluster filter can be set and read"""
-        c = mapscript.clusterObj()
-        exp = '100'  # TODO not sure what would be a relevant expression here
-        c.setGroup(exp)
-        assert '"{}"'.format(exp) == c.getGroupString()
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/color_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/color_test.py
--- 8.0.1-5/mapscript/python/tests/cases/color_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/color_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,78 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of colorObj
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-
-
-class ColorObjTestCase(unittest.TestCase):
-
-    def testColorObjConstructorNoArgs(self):
-        """a color can be initialized with no arguments"""
-        c = mapscript.colorObj()
-        assert (c.red, c.green, c.blue, c.alpha) == (0, 0, 0, 255)
-
-    def testColorObjConstructorArgs(self):
-        """a color can be initialized with arguments"""
-        c = mapscript.colorObj(1, 2, 3, 4)
-        assert (c.red, c.green, c.blue, c.alpha) == (1, 2, 3, 4)
-
-    def testColorObjToHex(self):
-        """a color can be outputted as hex"""
-        c = mapscript.colorObj(255, 255, 255)
-        assert c.toHex() == '#ffffff'
-
-    def testColorObjToHexBadly(self):
-        """raise an error in the case of an undefined color"""
-        c = mapscript.colorObj(-1, -1, -1)
-        self.assertRaises(mapscript.MapServerError, c.toHex)
-
-    def testColorObjSetRGB(self):
-        """a color can be set using setRGB method"""
-        c = mapscript.colorObj()
-        c.setRGB(255, 255, 255, 100)
-        assert (c.red, c.green, c.blue, c.alpha) == (255, 255, 255, 100)
-
-    def testColorObjSetHexLower(self):
-        """a color can be set using lower case hex"""
-        c = mapscript.colorObj()
-        c.setHex('#ffffff64')
-        assert (c.red, c.green, c.blue, c.alpha) == (255, 255, 255, 100)
-
-    def testColorObjSetHexUpper(self):
-        """a color can be set using upper case hex"""
-        c = mapscript.colorObj()
-        c.setHex('#FFFFFF')
-        assert (c.red, c.green, c.blue) == (255, 255, 255)
-
-    def testColorObjSetHexBadly(self):
-        """invalid hex color string raises proper error"""
-        c = mapscript.colorObj()
-        self.assertRaises(mapscript.MapServerError, c.setHex, '#fffffg')
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/config_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/config_test.py
--- 8.0.1-5/mapscript/python/tests/cases/config_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/config_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,63 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map
-# Author:   Seth Girvin, sgirvin@geographika.co.uk
-#
-# ===========================================================================
-# Copyright (c) 2021, MapServer team
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import TESTCONFIGFILE
-
-
-class ConfigConstructorTestCase(unittest.TestCase):
-
-    def testConfigConstructorFilenameArg(self):
-        """ConfigConstructorTestCase.testConfigConstructorFilenameArg: map constructor with filename argument"""
-        test_config = mapscript.configObj(TESTCONFIGFILE)
-        assert test_config.__class__.__name__ == "configObj"
-        assert test_config.thisown == 1
-
-
-class ConfigHashTableTests(unittest.TestCase):
-
-    def testGetEnv(self):
-
-        test_config = mapscript.configObj(TESTCONFIGFILE)
-        assert test_config.env.__class__.__name__ == "hashTableObj"
-        assert test_config.env.numitems == 1
-
-    def testGetMaps(self):
-
-        test_config = mapscript.configObj(TESTCONFIGFILE)
-        assert test_config.maps.__class__.__name__ == "hashTableObj"
-        assert test_config.maps.numitems == 0
-
-    def testGetPlugins(self):
-
-        test_config = mapscript.configObj(TESTCONFIGFILE)
-        assert test_config.plugins.__class__.__name__ == "hashTableObj"
-        assert test_config.plugins.numitems == 0
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/font_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/font_test.py
--- 8.0.1-5/mapscript/python/tests/cases/font_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/font_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,85 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of hashTableObj
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import os
-import unittest
-import mapscript
-from .testing import TESTS_PATH
-
-
-class FontTestCase(unittest.TestCase):
-
-    def testSettingFonts(self):
-        mo = mapscript.mapObj()
-        assert mo.fontset.numfonts == 0
-        mo.fontset.fonts.set('Vera', os.path.join(TESTS_PATH, 'vera',
-                                                  'Vera.ttf'))
-        # NB: this does *not* increment the fonset.numfonts -- new bug
-
-        mo.setSize(300, 300)
-        mo.setExtent(-1.0, -1.0, 1.0, 1.0)
-
-        lo = mapscript.layerObj()
-        lo.type = mapscript.MS_LAYER_POINT
-        lo.connectiontype = mapscript.MS_INLINE
-        lo.status = mapscript.MS_DEFAULT
-
-        co = mapscript.classObj()
-        lbl = mapscript.labelObj()
-        lbl.type = mapscript.MS_TRUETYPE
-        lbl.font = 'Vera'
-        lbl.size = 10
-        lbl.color.setHex('#000000')
-        co.addLabel(lbl)
-
-        so = mapscript.styleObj()
-        so.symbol = 0
-        so.color.setHex('#000000')
-
-        co.insertStyle(so)
-        lo.insertClass(co)
-        li = mo.insertLayer(lo)
-        lo = mo.getLayer(li)
-
-        point = mapscript.pointObj(0, 0)
-        line = mapscript.lineObj()
-        line.add(point)
-        shape = mapscript.shapeObj(lo.type)
-        shape.add(line)
-        shape.setBounds()
-        shape.text = 'Foo'
-        shape.classindex = 0
-
-        lo.addFeature(shape)
-        im = mo.draw()
-
-        # im = mo.prepareImage()
-        # shape.draw(mo, lo, im)
-        im.save('testSettingFonts.png')
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/hash_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/hash_test.py
--- 8.0.1-5/mapscript/python/tests/cases/hash_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/hash_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,158 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of hashTableObj
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase
-
-
-# ===========================================================================
-# Base class for hashtable tests.  Derived classes use these tests, but
-# defined different values for self.table.
-
-class HashTableBaseTestCase(object):
-
-    keys = ['key1', 'key2', 'key3', 'key4']
-    values = ['value1', 'value2', 'value3', 'value4']
-
-    def testUseNonExistentKey(self):
-        assert self.table.get('bogus') is None
-
-    def testUseNonExistentKeyWithDefault(self):
-        assert self.table.get('bogus', 'default') == 'default'
-
-    def testGetValue(self):
-        for key, value in zip(self.keys, self.values):
-            assert self.table.get(key) == value
-            assert self.table.get(key.upper()) == value
-            assert self.table.get(key.capitalize()) == value
-
-    def testGetValueWithDefault(self):
-        for key, value in zip(self.keys, self.values):
-            assert self.table.get(key, 'foo') == value
-            assert self.table.get(key.upper(), 'foo') == value
-            assert self.table.get(key.capitalize(), 'foo') == value
-
-    def testClear(self):
-        self.table.clear()
-        for key in self.keys:
-            assert self.table.get(key) is None
-
-    def testRemoveItem(self):
-        key = self.keys[0]
-        self.table.remove(key)
-        assert self.table.get(key) is None
-
-    def testNextKey(self):
-        key = self.table.nextKey()
-        assert key == self.keys[0], key
-        for i in range(1, len(self.keys)):
-            key = self.table.nextKey(key)
-            assert key == self.keys[i], key
-        # We're at the end, next should be None
-        key = self.table.nextKey(key)
-        assert key is None, key
-
-    # tests using the Python dictionary access methods
-
-    def testDictKeys(self):
-        assert sorted(self.keys) == sorted(self.table.keys())
-
-    def testDictItems(self):
-        assert len(self.keys) == len(self.table)
-
-    def testCheckDictContains(self):
-        for key in self.keys:
-            assert key in self.table.keys()
-
-    def testGetDictValue(self):
-        for key, value in zip(self.keys, self.values):
-            assert self.table[key] == value
-            assert self.table[key.upper()] == value
-            assert self.table[key.capitalize()] == value
-
-    def testRemoveDictItem(self):
-        key = self.keys[0]
-        del self.table[key]
-        assert self.table[key] is None
-
-
-# ===========================================================================
-# Test begins now
-
-# ===========================================================================
-# HashTable test case
-#
-
-class HashTableTestCase(unittest.TestCase, HashTableBaseTestCase):
-    """Tests of the MapServer HashTable object"""
-
-    def setUp(self):
-        "our fixture is a HashTable with two items"
-        self.table = mapscript.hashTableObj()
-        for key, value in zip(self.keys, self.values):
-            self.table.set(key, value)
-
-    def tearDown(self):
-        self.table = None
-
-    def testConstructor(self):
-        table = mapscript.hashTableObj()
-        assert table.__class__.__name__ == "hashTableObj", table
-
-
-# ==============================================================================
-# following tests use the tests/test.map fixture
-
-class WebMetadataTestCase(MapTestCase, HashTableBaseTestCase):
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        self.table = self.map.web.metadata
-        self.keys = ['key1', 'key2', 'key3', 'key4', 'ows_enable_request']
-        self.values = ['value1', 'value2', 'value3', 'value4', '*']
-
-    def tearDown(self):
-        MapTestCase.tearDown(self)
-        self.table = None
-
-
-class LayerMetadataTestCase(WebMetadataTestCase):
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        self.table = self.map.getLayer(1).metadata
-
-
-class ClassMetadataTestCase(WebMetadataTestCase):
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        self.table = self.map.getLayer(1).getClass(0).metadata
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/image_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/image_test.py
--- 8.0.1-5/mapscript/python/tests/cases/image_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/image_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,159 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of map cloning
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-from io import BytesIO
-import urllib
-import mapscript
-from .testing import TEST_IMAGE as test_image
-from .testing import MapTestCase
-
-
-have_image = False
-
-try:
-    from PIL import Image
-    have_image = True
-except ImportError:
-    pass
-
-
-class ImageObjTestCase(unittest.TestCase):
-
-    def testConstructor(self):
-        """imageObj constructor works"""
-        imgobj = mapscript.imageObj(10, 10)
-        assert imgobj.thisown == 1
-        assert imgobj.height == 10
-        assert imgobj.width == 10
-
-    def testConstructorWithFormat(self):
-        """imageObj with an optional driver works"""
-        driver = 'AGG/PNG'
-        format = mapscript.outputFormatObj(driver)
-        imgobj = mapscript.imageObj(10, 10, format)
-        assert imgobj.thisown == 1
-        assert imgobj.format.driver == driver
-        assert imgobj.height == 10
-        assert imgobj.width == 10
-
-    def xtestConstructorFilename(self):
-        """imageObj with a filename works"""
-        imgobj = mapscript.imageObj(test_image)
-        assert imgobj.thisown == 1
-        assert imgobj.height == 200
-        assert imgobj.width == 200
-        imgobj.save('testConstructorFilename.png')
-
-    def xtestConstructorFilenameDriver(self):
-        """imageObj with a filename and a driver works"""
-        imgobj = mapscript.imageObj(test_image)
-        assert imgobj.thisown == 1
-        assert imgobj.height == 200
-        assert imgobj.width == 200
-        imgobj.save('testConstructorFilenameDriver.png')
-
-    def xtestConstructorStream(self):
-        """imageObj with a file stream works"""
-        f = open(test_image, 'rb')
-        imgobj = mapscript.imageObj(f)
-        f.close()
-        assert imgobj.thisown == 1
-        assert imgobj.height == 200
-        assert imgobj.width == 200
-
-    def xtestConstructorBytesIO(self):
-        """imageObj with a BytesIO works"""
-        with open(test_image, 'rb') as f:
-            data = f.read()
-        s = BytesIO(data)
-        imgobj = mapscript.imageObj(s)
-        assert imgobj.thisown == 1
-        assert imgobj.height == 200
-        assert imgobj.width == 200
-
-    def xtestConstructorUrlStream(self):
-        """imageObj with a URL stream works"""
-        url = urllib.urlopen('http://mapserver.org/_static/banner.png')
-        imgobj = mapscript.imageObj(url, 'AGG/JPEG')
-        assert imgobj.thisown == 1
-        assert imgobj.height == 68
-        assert imgobj.width == 439
-        imgobj.save('testConstructorUrlStream.jpg')
-
-
-class ImageWriteTestCase(MapTestCase):
-
-    def testImageWrite(self):
-        """image writes data to an open filehandle"""
-        image = self.map.draw()
-        assert image.thisown == 1
-        filename = 'testImageWrite.png'
-        fh = open(filename, 'wb')
-        image.write(fh)
-        fh.close()
-        if have_image:
-            pyimg = Image.open(filename)
-            assert pyimg.format == 'PNG'
-            assert pyimg.size == (200, 200)
-            assert pyimg.mode == 'RGB'
-
-    def testImageWriteBytesIO(self):
-        """image writes data to a BytesIO instance"""
-        image = self.map.draw()
-        assert image.thisown == 1
-
-        s = BytesIO()
-        image.write(s)
-
-        filename = 'testImageWriteBytesIO.png'
-        with open(filename, 'wb') as fh:
-            fh.write(s.getvalue())
-        if have_image:
-            pyimg = Image.open(filename)
-            assert pyimg.format == 'PNG'
-            assert pyimg.size == (200, 200)
-            assert pyimg.mode == 'RGB'
-
-    def testImageGetBytes(self):
-        """image returns bytes"""
-        image = self.map.draw()
-        assert image.thisown == 1
-
-        s = BytesIO(image.getBytes())
-
-        filename = 'testImageGetBytes.png'
-        with open(filename, 'wb') as fh:
-            fh.write(s.getvalue())
-        if have_image:
-            pyimg = Image.open(filename)
-            assert pyimg.format == 'PNG'
-            assert pyimg.size == (200, 200)
-            assert pyimg.mode == 'RGB'
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/label_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/label_test.py
--- 8.0.1-5/mapscript/python/tests/cases/label_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/label_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,56 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase
-
-
-class NewLabelsTestCase(MapTestCase):
-
-    def testLabelBinding(self):
-        """attribute binding can be set and get"""
-        new_label = mapscript.labelObj()
-        assert (not new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR))
-        new_label.setBinding(mapscript.MS_LABEL_BINDING_COLOR, "NEW_BINDING")
-        assert (new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR) == "NEW_BINDING")
-
-
-class LabelCacheMemberTestCase(MapTestCase):
-
-    def testCacheMemberText(self):
-        """string attribute has been renamed to 'text' (bug 852)"""
-        lo = self.map.getLayerByName('POINT')
-        lo.status = mapscript.MS_ON
-        img = self.map.draw()
-        assert img is not None
-        assert self.map.labelcache.num_rendered_members == 1, self.map.labelcache.num_rendered_members
-        # label = self.map.nextLabel()
-        # assert label.text == 'A Point', label.text
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/layer_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/layer_test.py
--- 8.0.1-5/mapscript/python/tests/cases/layer_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/layer_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,475 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Layer
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-from random import random
-import mapscript
-from .testing import MapTestCase
-
-
-class MapLayerTestCase(MapTestCase):
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        self.layer = self.map.getLayer(1)
-
-
-class LayerConstructorTestCase(MapLayerTestCase):
-
-    def testLayerConstructorNoArg(self):
-        """test layer constructor with no argument"""
-        layer = mapscript.layerObj()
-        assert layer.__class__.__name__ == "layerObj"
-        assert layer.thisown == 1
-        assert layer.index == -1
-        assert layer.map is None, layer.map
-
-    def testLayerConstructorMapArg(self):
-        """test layer constructor with map argument"""
-        layer = mapscript.layerObj(self.map)
-        assert layer.__class__.__name__ == "layerObj"
-        assert layer.thisown == 1
-        lyr = self.map.getLayer(self.map.numlayers-1)
-        assert lyr is not None
-        # assert str(layer) == str(lyr) # TODO - check why these are not equal
-        assert layer.map is not None, layer.map
-
-
-class LayerItemDefinitionTestCase(MapLayerTestCase):
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        self.layer = self.map.getLayerByName('POINT')
-        self.layer.open()
-
-    def tearDown(self):
-        self.layer.close()
-
-    def testLayerGetItemType(self):
-        """test getting layer item information for the first item"""
-
-        item_type = self.layer.getItemType(0)
-        assert item_type == "Integer"
-
-    def testLayerGetItemDefinition2(self):
-        """test getting layer item information for the second item"""
-
-        item_type = self.layer.getItemType(1)
-        assert item_type == "Character"
-
-    def testLayerGetMissingItemType(self):
-        """test getting item information for a non-existent index"""
-        item_type = self.layer.getItemType(100)
-        assert item_type is None
-
-    def testLayerGetItemTypeClosedLayer(self):
-        """item definition will be None for a closed layer"""
-        self.layer.close()
-        item_type = self.layer.getItemType(0)
-        assert item_type is None
-
-    def testLayerGetNonDefinedItemType(self):
-        """test getting layer item information for a layer with gml_types auto"""
-
-        layer = self.map.getLayerByName('POLYGON')
-        layer.open()
-        item_type = layer.getItemType(0)
-        assert item_type == ""
-        layer.close()
-
-
-class LayerCloningTestCase(MapLayerTestCase):
-
-    def testLayerCloning(self):
-        """check attributes of a cloned layer"""
-        clone = self.layer.clone()
-        assert clone.thisown == 1
-        assert str(clone) != str(self.layer)
-        assert clone.name == self.layer.name
-        assert clone.numclasses == self.layer.numclasses
-        assert clone.map is None, clone.map
-        assert clone.data == self.layer.data
-
-
-class LayerExtentTestCase(MapTestCase):
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        self.layer = self.map.getLayerByName('POLYGON')
-
-    def testPolygonExtent(self):
-        """retrieve the extent of a polygon layer"""
-        e = mapscript.rectObj()
-        self.assertRectsEqual(e, self.layer.extent)
-
-    def testPolygonGetExtent(self):
-        """retrieve the extent of a polygon layer"""
-        e = mapscript.rectObj(-0.25, 51.227222, 0.25, 51.727222)
-        self.assertRectsEqual(e, self.layer.getExtent())
-
-    def testGetPresetExtent(self):
-        """test layer.setExtent() and layer.getExtent() to return preset instead of calculating extents"""
-        r = mapscript.rectObj(1.0, 1.0, 3.0, 3.0)
-        self.layer.setExtent(r.minx, r.miny, r.maxx, r.maxy)
-        rect = self.layer.extent
-        assert r.minx == rect.minx, rect
-        assert r.miny == rect.miny, rect.miny
-        assert r.maxx == rect.maxx, rect.maxx
-        assert r.maxy == rect.maxy, rect.maxy
-
-    def testResetLayerExtent(self):
-        """test resetting a layer's extent"""
-        layer = self.map.getLayerByName('POLYGON')
-        layer.setExtent()
-        self.assertRectsEqual(layer.extent, mapscript.rectObj())
-
-    def testDirectExtentAccess(self):
-        """direct access to a layer's extent works properly"""
-        pt_layer = self.map.getLayerByName('POINT')
-        rect = pt_layer.extent
-        assert str(pt_layer.extent) == str(rect), (pt_layer.extent, rect)
-        e = mapscript.rectObj(-0.5, 51.0, 0.5, 52.0)
-        self.assertRectsEqual(e, rect)
-
-
-class LayerRasterProcessingTestCase(MapLayerTestCase):
-
-    def testAddProcessing(self):
-        """adding a layer's processing directive works"""
-        self.layer.addProcessing('directive0=foo')
-        assert self.layer.numprocessing == 1, self.layer.numprocessing
-        self.layer.addProcessing('directive1=bar')
-        assert self.layer.numprocessing == 2, self.layer.numprocessing
-        directives = [self.layer.getProcessing(i)
-                      for i in range(self.layer.numprocessing)]
-        assert directives == ['directive0=foo', 'directive1=bar']
-
-    def testClearProcessing(self):
-        """clearing a self.layer's processing directive works"""
-        self.layer.addProcessing('directive0=foo')
-        assert self.layer.numprocessing == 1, self.layer.numprocessing
-        self.layer.addProcessing('directive1=bar')
-        assert self.layer.numprocessing == 2, self.layer.numprocessing
-        assert self.layer.clearProcessing() == mapscript.MS_SUCCESS
-
-
-class RemoveClassTestCase(MapLayerTestCase):
-
-    def testRemoveClass1NumClasses(self):
-        """RemoveClassTestCase.testRemoveClass1NumClasses: removing the layer's first class
-        by index leaves one class left"""
-        c = self.layer.removeClass(0)
-        assert c.thisown == 1
-        assert self.layer.numclasses == 1
-
-    def testRemoveClass1ClassName(self):
-        """RemoveClassTestCase.testRemoveClass1ClassName:
-        confirm removing the layer's first class reverts the name of the second class"""
-        c2name = self.layer.getClass(1).name
-        c = self.layer.removeClass(0)
-        assert c is not None
-        assert self.layer.getClass(0).name == c2name
-
-    def testRemoveClass2NumClasses(self):
-        """RemoveClassTestCase.testRemoveClass2NumClasses:
-        removing the layer's second class by index leaves one class left"""
-        c = self.layer.removeClass(1)
-        assert c is not None
-        assert self.layer.numclasses == 1
-
-    def testRemoveClass2ClassName(self):
-        """RemoveClassTestCase.testRemoveClass2ClassName: confirm removing the layer's second class reverts
-         the name of the first class"""
-        c1name = self.layer.getClass(0).name
-        c = self.layer.removeClass(1)
-        assert c is not None
-        assert self.layer.getClass(0).name == c1name
-
-
-class InsertClassTestCase(MapLayerTestCase):
-
-    def testLayerInsertClass(self):
-        """insert class at default index"""
-        n = self.layer.numclasses
-        new_class = mapscript.classObj()
-        new_class.name = 'foo'
-        new_index = self.layer.insertClass(new_class)
-        assert new_index == n
-        assert self.layer.numclasses == n + 1
-        c = self.layer.getClass(new_index)
-        assert c.thisown == 1
-        assert c.name == new_class.name
-
-    def testLayerInsertClassAtZero(self):
-        """insert class at index 0"""
-        n = self.layer.numclasses
-        new_class = mapscript.classObj()
-        new_class.name = 'foo'
-        new_index = self.layer.insertClass(new_class, 0)
-        assert new_index == 0
-        assert self.layer.numclasses == n + 1
-        c = self.layer.getClass(new_index)
-        assert c.thisown == 1
-        assert c.name == new_class.name
-
-    def testInsertNULLClass(self):
-        """inserting NULL class should raise an error"""
-        self.assertRaises(mapscript.MapServerChildError,
-                          self.layer.insertClass, None)
-
-
-class LayerTestCase(MapTestCase):
-    def testLayerConstructorOwnership(self):
-        """LayerTestCase.testLayerConstructorOwnership: newly constructed layer has proper ownership"""
-        layer = mapscript.layerObj(self.map)
-        assert layer.thisown == 1
-
-    def testGetLayerOrder(self):
-        """LayerTestCase.testGetLayerOrder: get layer drawing order"""
-        order = self.map.getLayerOrder()
-        assert order == tuple(range(7)), order
-
-    def testSetLayerOrder(self):
-        """LayerTestCase.testSetLayerOrder: set layer drawing order"""
-        ord = (1, 0, 2, 3, 4, 5, 6)
-        self.map.setLayerOrder(ord)
-        order = self.map.getLayerOrder()
-        assert order == ord, order
-
-# Layer removal tests
-
-
-class RemoveLayerTestCase(MapTestCase):
-
-    def testRemoveLayer1NumLayers(self):
-        """removing the first layer by index from the mapfile leaves three"""
-        self.map.removeLayer(0)
-        assert self.map.numlayers == 6
-
-    def testRemoveLayer1LayerName(self):
-        """removing first layer reverts it to the second layer's name"""
-        l2name = self.map.getLayer(1).name
-        self.map.removeLayer(0)
-        assert self.map.getLayer(0).name == l2name
-
-    def testRemoveLayer2NumLayers(self):
-        """removing second layer by index from mapfile leaves three layers"""
-        self.map.removeLayer(1)
-        assert self.map.numlayers == 6
-
-    def testRemoveLayer2LayerName(self):
-        """removing of the second layer reverts it to the first layer's name"""
-        l1name = self.map.getLayer(0).name
-        self.map.removeLayer(1)
-        assert self.map.getLayer(0).name == l1name
-
-
-class ExpressionTestCase(MapLayerTestCase):
-
-    def testClearExpression(self):
-        """layer expression can be properly cleared"""
-        self.layer.setFilter('')
-        fs = self.layer.getFilterString()
-        assert fs is None, fs
-
-    def testSetStringExpression(self):
-        """layer expression can be set to string"""
-        self.layer.setFilter('foo')
-        fs = self.layer.getFilterString()
-        self.layer.filteritem = 'fid'
-        assert fs == '"foo"', fs
-        self.map.draw()
-
-    def testSetQuotedStringExpression(self):
-        """layer expression string can be quoted"""
-        self.layer.setFilter('"foo"')
-        fs = self.layer.getFilterString()
-        self.layer.filteritem = 'fid'
-        assert fs == '"foo"', fs
-        self.map.draw()
-
-    def testSetRegularExpression(self):
-        """layer expression can be regular expression"""
-        self.layer.setFilter('/foo/')
-        self.layer.filteritem = 'fid'
-        fs = self.layer.getFilterString()
-        assert fs == '/foo/', fs
-        self.map.draw()
-
-    def testSetLogicalExpression(self):
-        """layer expression can be logical expression"""
-        self.layer.setFilter('([fid] >= 2)')
-        fs = self.layer.getFilterString()
-        assert fs == '([fid] >= 2)', fs
-        self.map.draw()
-
-    def testSetCompoundLogicalExpression(self):
-        """layer expression can be a compound logical expression"""
-        # filter = '( ([fid] >= 2) AND (\'[fname]\' == \'A Polygon\' ))'
-        flt = """( ([fid] >= 2) AND ("[fname]" == 'A Polygon' ))"""
-        excode = self.layer.setFilter(flt)
-        assert excode == mapscript.MS_SUCCESS, excode
-        fs = self.layer.getFilterString()
-        assert fs == flt, fs
-        self.map.draw()
-
-
-class LayerQueryTestCase(MapLayerTestCase):
-
-    def setUp(self):
-        MapLayerTestCase.setUp(self)
-        self.layer = self.map.getLayerByName('POINT')
-        self.layer.template = 'foo'
-
-
-class SpatialLayerQueryTestCase(LayerQueryTestCase):
-
-    def testRectQuery(self):
-        qrect = mapscript.rectObj(-10.0, 45.0, 10.0, 55.0)
-        self.layer.queryByRect(self.map, qrect)
-        assert self.layer.getNumResults() == 1
-
-    def testShapeQuery(self):
-        qrect = mapscript.rectObj(-10.0, 45.0, 10.0, 55.0)
-        qshape = qrect.toPolygon()
-        self.layer.queryByShape(self.map, qshape)
-        assert self.layer.getNumResults() == 1
-
-    def testPointQuery(self):
-        qpoint = mapscript.pointObj(0.0, 51.5)
-        self.layer.queryByPoint(self.map, qpoint, mapscript.MS_MULTIPLE, 2.0)
-        assert self.layer.getNumResults() == 1
-
-    def testRectQueryNoResults(self):
-        qrect = mapscript.rectObj(-101.0, 0.0, -100.0, 1.0)
-        self.layer.queryByRect(self.map, qrect)
-        assert self.layer.getNumResults() == 0
-
-    def testShapeQueryNoResults(self):
-        qrect = mapscript.rectObj(-101.0, 0.0, -100.0, 1.0)
-        qshape = qrect.toPolygon()
-        self.layer.queryByShape(self.map, qshape)
-        assert self.layer.getNumResults() == 0
-
-    def testPointQueryNoResults(self):
-        qpoint = mapscript.pointObj(-100.0, 51.5)
-        self.layer.queryByPoint(self.map, qpoint, mapscript.MS_MULTIPLE, 2.0)
-        assert self.layer.getNumResults() == 0
-
-
-class AttributeLayerQueryTestCase(LayerQueryTestCase):
-
-    def testAttributeQuery(self):
-        self.layer.queryByAttributes(self.map, "FNAME", '"A Point"',
-                                     mapscript.MS_MULTIPLE)
-        assert self.layer.getNumResults() == 1
-
-    def testLogicalAttributeQuery(self):
-        self.layer.queryByAttributes(self.map, None, '("[FNAME]" == "A Point")',
-                                     mapscript.MS_MULTIPLE)
-        assert self.layer.getNumResults() == 1
-
-    def testAttributeQueryNoResults(self):
-        self.layer.queryByAttributes(self.map, "FNAME", '"Bogus Point"',
-                                     mapscript.MS_MULTIPLE)
-        assert self.layer.getNumResults() == 0
-
-
-class LayerVisibilityTestCase(MapLayerTestCase):
-
-    def setUp(self):
-        MapLayerTestCase.setUp(self)
-        self.layer.minscaledenom = 1000
-        self.layer.maxscaledenom = 2000
-        self.layer.status = mapscript.MS_ON
-        self.map.zoomScale(1500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None)
-
-    def testInitialVisibility(self):
-        """expect visibility"""
-        assert self.layer.isVisible() == mapscript.MS_TRUE
-
-    def testStatusOffVisibility(self):
-        """expect false visibility after switching status off"""
-        self.layer.status = mapscript.MS_OFF
-        assert self.layer.isVisible() == mapscript.MS_FALSE
-
-    def testZoomOutVisibility(self):
-        """expect false visibility after zooming out beyond maximum"""
-        self.map.zoomScale(2500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None)
-        assert self.layer.isVisible() == mapscript.MS_FALSE
-
-
-class InlineLayerTestCase(unittest.TestCase):
-
-    def setUp(self):
-        # Inline feature layer
-        self.ilayer = mapscript.layerObj()
-        self.ilayer.type = mapscript.MS_LAYER_POLYGON
-        self.ilayer.status = mapscript.MS_DEFAULT
-        self.ilayer.connectiontype = mapscript.MS_INLINE
-
-        cs = 'f7fcfd, e5f5f9, ccece6, 99d8c9, 66c2a4, 41ae76, 238b45, 006d2c, 00441b'
-        colors = ['#' + h for h in cs.split(', ')]
-
-        for i in range(9):
-            # Make a class for feature
-            ci = self.ilayer.insertClass(mapscript.classObj())
-            co = self.ilayer.getClass(ci)
-            si = co.insertStyle(mapscript.styleObj())
-            so = co.getStyle(si)
-            so.color.setHex(colors[i])
-            li = co.addLabel(mapscript.labelObj())
-            lbl = co.getLabel(li)
-            lbl.color.setHex('#000000')
-            lbl.outlinecolor.setHex('#FFFFFF')
-            lbl.type = mapscript.MS_BITMAP
-            lbl.size = mapscript.MS_SMALL
-
-            # The shape to add is randomly generated
-            xc = 4.0*(random() - 0.5)
-            yc = 4.0*(random() - 0.5)
-            r = mapscript.rectObj(xc-0.25, yc-0.25, xc+0.25, yc+0.25)
-            s = r.toPolygon()
-
-            # Classify
-            s.classindex = i
-            s.text = "F%d" % (i)
-
-            # Add to inline feature layer
-            self.ilayer.addFeature(s)
-
-    def testExternalClassification(self):
-        mo = mapscript.mapObj()
-        mo.setSize(400, 400)
-        mo.setExtent(-2.5, -2.5, 2.5, 2.5)
-        mo.selectOutputFormat('image/png')
-        mo.insertLayer(self.ilayer)
-        im = mo.draw()
-        im.save('testExternalClassification.png')
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/line_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/line_test.py
--- 8.0.1-5/mapscript/python/tests/cases/line_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/line_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map "zooming"
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-
-import unittest
-import mapscript
-from .testing import MapPrimitivesTestCase
-
-
-class LineObjTestCase(MapPrimitivesTestCase):
-    """Testing the lineObj class in stand-alone mode"""
-
-    def setUp(self):
-        """The test fixture is a line with two points"""
-        self.points = (mapscript.pointObj(0.0, 1.0),
-                       mapscript.pointObj(2.0, 3.0))
-        self.line = mapscript.lineObj()
-        self.addPointToLine(self.line, self.points[0])
-        self.addPointToLine(self.line, self.points[1])
-
-    def testCreateLine(self):
-        """created line has the correct number of points"""
-        assert self.line.numpoints == 2
-
-    def testGetPointsFromLine(self):
-        """points in the line share are the same that were input"""
-        for i in range(len(self.points)):
-            got_point = self.getPointFromLine(self.line, i)
-            self.assertPointsEqual(got_point, self.points[i])
-
-    def testAddPointToLine(self):
-        """adding a point to a line behaves correctly"""
-        new_point = mapscript.pointObj(4.0, 5.0)
-        self.addPointToLine(self.line, new_point)
-        assert self.line.numpoints == 3
-
-    def xtestAlterNumPoints(self):
-        """
-        numpoints is immutable, this should raise error
-        """
-        # The following works locally but fails on Appveyor (error is not raised)
-        # with self.assertRaises(AttributeError):
-        #    self.line.numpoints = 3
-
-        # the following approach also fails on appveyor
-        error_thrown = False
-        try:
-            self.line.numpoints = 3
-        except AttributeError:
-            error_thrown = True
-
-        assert error_thrown is True
-
-    def testLineGeoInterface(self):
-        """return line using the  __geo_interface__ protocol"""
-        assert self.line.__geo_interface__ == {"type": "LineString", "coordinates": [(0.0, 1.0, 0.0), (2.0, 3.0, 0.0)]}
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/map_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/map_test.py
--- 8.0.1-5/mapscript/python/tests/cases/map_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/map_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,334 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase, TESTMAPFILE
-
-
-class MapConstructorTestCase(unittest.TestCase):
-
-    def testMapConstructorNoArg(self):
-        """MapConstructorTestCase.testMapConstructorNoArg: test map constructor with no argument"""
-        test_map = mapscript.mapObj()
-        assert test_map.__class__.__name__ == "mapObj"
-        assert test_map.thisown == 1
-
-    def testMapConstructorEmptyStringArg(self):
-        """MapConstructorTestCase.testMapConstructorEmptyStringArg:
-        test map constructor with old-style empty string argument"""
-        test_map = mapscript.mapObj('')
-        assert test_map.__class__.__name__ == "mapObj"
-        assert test_map.thisown == 1
-
-    def testMapConstructorFilenameArg(self):
-        """MapConstructorTestCasetest.testMapConstructorEmptyStringArg: map constructor with filename argument"""
-        test_map = mapscript.mapObj(TESTMAPFILE)
-        assert test_map.__class__.__name__ == "mapObj"
-        assert test_map.thisown == 1
-
-
-class MapExtentTestCase(MapTestCase):
-    def testSetExtent(self):
-        """MapExtentTestCase.testSetExtent: test the setting of a mapObj's extent"""
-        test_map = mapscript.mapObj(TESTMAPFILE)
-        e = test_map.extent
-        result = test_map.setExtent(e.minx, e.miny, e.maxx, e.maxy)
-        self.assertAlmostEqual(test_map.scaledenom, 14.24445829)
-        assert result == mapscript.MS_SUCCESS, result
-
-    def testSetExtentBadly(self):
-        """MapExtentTestCase.testSetExtentBadly: test that mapscript raises an error for an invalid mapObj extent"""
-        test_map = mapscript.mapObj(TESTMAPFILE)
-        self.assertRaises(mapscript.MapServerError, test_map.setExtent,
-                          1.0, -2.0, -3.0, 4.0)
-
-    def testReBindingExtent(self):
-        """test the rebinding of a map's extent"""
-        test_map = mapscript.mapObj(TESTMAPFILE)
-        rect1 = mapscript.rectObj(-10.0, -10.0, 10.0, 10.0)
-        rect2 = mapscript.rectObj(-10.0, -10.0, 10.0, 10.0)
-        test_map.extent = rect1
-        assert repr(test_map.extent) != repr(rect1), (test_map.extent, rect1)
-        del rect1
-        self.assertRectsEqual(test_map.extent, rect2)
-
-
-class MapLayersTestCase(MapTestCase):
-
-    def testMapInsertLayer(self):
-        """MapLayersTestCase.testMapInsertLayer: test insertion of a new layer at default (last) index"""
-        n = self.map.numlayers
-        layer = mapscript.layerObj()
-        layer.name = 'new'
-        assert layer.map is None, layer.map
-        index = self.map.insertLayer(layer)
-        assert layer.map is not None, layer.map
-        assert index == n, index
-        assert self.map.numlayers == n + 1
-        names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
-        assert names == ['RASTER', 'POLYGON', 'LINE', 'POINT', 'INLINE',
-                         'INLINE-PIXMAP-RGBA', 'INLINE-PIXMAP-PCT', 'new']
-        order = self.map.getLayerOrder()
-        assert order == (0, 1, 2, 3, 4, 5, 6, 7), order
-
-    def testMapInsertLayerAtZero(self):
-        """MapLayersTestCase.testMapInsertLayerAtZero: test insertion of a new layer at first index"""
-        n = self.map.numlayers
-        layer = mapscript.layerObj()
-        layer.name = 'new'
-        assert layer.map is None, layer.map
-        index = self.map.insertLayer(layer, 0)
-        assert layer.map is not None, layer.map
-        assert index == 0, index
-        assert self.map.numlayers == n + 1
-        names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
-        assert names == ['new', 'RASTER', 'POLYGON', 'LINE', 'POINT', 'INLINE',
-                         'INLINE-PIXMAP-RGBA', 'INLINE-PIXMAP-PCT'], names
-        order = self.map.getLayerOrder()
-        assert order == (0, 1, 2, 3, 4, 5, 6, 7), order
-
-    def testMapInsertLayerDrawingOrder(self):
-        """MapLayersTestCase.testMapInsertLayerDrawingOrder: test affect of
-        insertion of a new layer at index 1 on drawing order"""
-        n = self.map.numlayers
-        assert n == 7
-        # reverse layer drawing order
-        o_start = (6, 5, 4, 3, 2, 1, 0)
-        self.map.setLayerOrder(o_start)
-        # insert Layer
-        layer = mapscript.layerObj()
-        layer.name = 'new'
-        index = self.map.insertLayer(layer, 1)
-        assert index == 1, index
-        # We expect our new layer to be at index 1 in drawing order as well
-        order = self.map.getLayerOrder()
-        assert order == (7, 1, 6, 5, 4, 3, 2, 0), order
-
-    def testMapInsertLayerBadIndex(self):
-        """MapLayersTestCase.testMapInsertLayerBadIndex: expect an exception when index is too large"""
-        layer = mapscript.layerObj()
-        self.assertRaises(mapscript.MapServerChildError, self.map.insertLayer,
-                          layer, 1000)
-
-    def testMapInsertNULLLayer(self):
-        """expect an exception on attempt to insert a NULL Layer"""
-        self.assertRaises(mapscript.MapServerChildError, self.map.insertLayer,
-                          None)
-
-    def testMapRemoveLayerAtTail(self):
-        """removal of highest index (tail) layer"""
-        n = self.map.numlayers
-        layer = self.map.removeLayer(n-1)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'INLINE-PIXMAP-PCT'
-        assert layer.thisown == 1
-        del layer
-        order = self.map.getLayerOrder()
-        assert order == (0, 1, 2, 3, 4, 5), order
-
-    def testMapRemoveLayerAtZero(self):
-        """removal of lowest index (0) layer"""
-        n = self.map.numlayers
-        layer = self.map.removeLayer(0)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'RASTER'
-        order = self.map.getLayerOrder()
-        assert order == (0, 1, 2, 3, 4, 5), order
-
-    def testMapRemoveLayerDrawingOrder(self):
-        """test affect of layer removal on drawing order"""
-        n = self.map.numlayers
-        # reverse layer drawing order
-        o_start = (6, 5, 4, 3, 2, 1, 0)
-        self.map.setLayerOrder(o_start)
-        layer = self.map.removeLayer(1)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'POLYGON'
-        order = self.map.getLayerOrder()
-        assert order == (5, 4, 3, 2, 1, 0), order
-        names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
-        assert names == ['RASTER', 'LINE', 'POINT', 'INLINE',
-                         'INLINE-PIXMAP-RGBA', 'INLINE-PIXMAP-PCT'], names
-
-
-class MapExceptionTestCase(MapTestCase):
-
-    def testDrawBadData(self):
-        """MapExceptionTestCase.testDrawBadData: a bad data descriptor in a layer returns proper error"""
-        self.map.getLayerByName('POLYGON').data = 'foo'
-        self.assertRaises(mapscript.MapServerError, self.map.draw)
-
-
-class EmptyMapExceptionTestCase(unittest.TestCase):
-
-    def setUp(self):
-        self.map = mapscript.mapObj('')
-
-    def tearDown(self):
-        self.map = None
-
-    def testDrawEmptyMap(self):
-        """EmptyMapExceptionTestCase.testDrawEmptyMap: drawing an empty map returns proper error"""
-        self.assertRaises(mapscript.MapServerError, self.map.draw)
-
-
-class NoFontSetTestCase(unittest.TestCase):
-
-    def testNoGetFontSetFile(self):
-        """an empty map should have fontset filename == None"""
-        self.map = mapscript.mapObj()
-        assert self.map.fontset.filename is None
-
-
-class MapFontSetTestCase(MapTestCase):
-
-    def testGetFontSetFile(self):
-        """expect fontset file to be 'fonts.txt'"""
-        file = self.map.fontset.filename
-        assert file == 'fonts.txt', file
-
-
-class MapSizeTestCase(MapTestCase):
-
-    def testDefaultSize(self):
-        assert self.map.width == 200
-        assert self.map.height == 200
-
-    def testSetSize(self):
-        retval = self.map.setSize(480, 480)
-        assert retval == mapscript.MS_SUCCESS, retval
-        assert self.map.width == 480
-        assert self.map.height == 480
-
-
-class MapSetWKTTestCase(MapTestCase):
-
-    def testOGCWKT(self):
-        self.map.setWKTProjection('''PROJCS["unnamed",GEOGCS["WGS 84",DATUM["WGS_1984",
-                                     SPHEROID["WGS 84",6378137,298.257223563]],
-                                     PRIMEM["Greenwich",0],
-                                     UNIT["Degree",0.0174532925199433]],
-                                     PROJECTION["Albers_Conic_Equal_Area"],
-                                     PARAMETER["standard_parallel_1", 65], PARAMETER["standard_parallel_2", 55],
-                                     PARAMETER["latitude_of_center", 0], PARAMETER["longitude_of_center", -153],
-                                     PARAMETER["false_easting", -4943910.68], PARAMETER["false_northing", 0],
-                                     UNIT["metre",1.0]
-                                     ]''')
-        proj4 = self.map.getProjection()
-
-        assert proj4.find('+proj=aea') != -1
-        assert proj4.find('+datum=WGS84') != -1
-        assert mapscript.projectionObj(proj4).getUnits() != mapscript.MS_DD
-
-    def testESRIWKT(self):
-        self.map.setWKTProjection('ESRI::PROJCS["Pulkovo_1995_GK_Zone_2", GEOGCS["GCS_Pulkovo_1995", '
-                                  'DATUM["D_Pulkovo_1995", SPHEROID["Krasovsky_1940", 6378245, 298.3]], '
-                                  'PRIMEM["Greenwich", 0], '
-                                  'UNIT["Degree", 0.017453292519943295]], PROJECTION["Gauss_Kruger"], '
-                                  'PARAMETER["False_Easting", 2500000], '
-                                  'PARAMETER["False_Northing", 0], PARAMETER["Central_Meridian", 9], '
-                                  'PARAMETER["Scale_Factor", 1], '
-                                  'PARAMETER["Latitude_Of_Origin", 0], UNIT["Meter", 1]]')
-        proj4 = self.map.getProjection()
-
-        assert proj4.find('+proj=tmerc') != -1
-        assert proj4.find('+ellps=krass') != -1
-        assert (mapscript.projectionObj(proj4)).getUnits() != mapscript.MS_DD
-
-    def testWellKnownGEOGCS(self):
-        self.map.setWKTProjection('WGS84')
-        proj4 = self.map.getProjection()
-        assert ('+proj=longlat' in proj4 and '+datum=WGS84' in proj4) or proj4 == '+init=epsg:4326', proj4
-        assert (mapscript.projectionObj(proj4)).getUnits() != mapscript.MS_METERS
-
-
-class MapRunSubTestCase(MapTestCase):
-
-    def testDefaultSubstitutions(self):
-        s = """
-MAP
-    WEB
-        VALIDATION
-            'key1' '.*'
-            'default_key1' 'Test Title'
-        END
-        METADATA
-            "wms_title" "%key1%"
-        END
-    END
-END
-        """
-        map = mapscript.fromstring(s)
-        map.applyDefaultSubstitutions()
-        assert map.web.metadata["wms_title"] == "Test Title"
-
-    def testRuntimeSubstitutions(self):
-        """
-        For supported parameters see https://mapserver.org/cgi/runsub.html#parameters-supported
-        """
-        s = """
-MAP
-    WEB
-        VALIDATION
-            'key1' '.*'
-            'default_key1' 'Test Title'
-        END
-        METADATA
-            "wms_title" "%key1%"
-        END
-    END
-    LAYER
-        TYPE POINT
-        FILTER ([size]<%my_filter%)
-        VALIDATION
-            'my_filter' '^[0-9]$'
-        END
-    END
-END
-        """
-        map = mapscript.fromstring(s)
-
-        d = {"key1": "New Title", "my_filter": "3"}
-        map.applySubstitutions(d)
-
-        assert map.web.metadata["wms_title"] == "New Title"
-        assert map.getLayer(0).getFilterString() == "([size]<3)"
-
-
-class MapSLDTestCase(MapTestCase):
-    def test(self):
-
-        test_map = mapscript.mapObj(TESTMAPFILE)
-        result = test_map.generateSLD()
-        assert result.startswith('<StyledLayerDescriptor version="1.0.0"'), result
-
-        result = test_map.generateSLD("1.1.0")
-        assert result.startswith('<StyledLayerDescriptor version="1.1.0"'), result
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/outputformat_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/outputformat_test.py
--- 8.0.1-5/mapscript/python/tests/cases/outputformat_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/outputformat_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,109 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of outputFormatObj
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase
-
-
-class OutputFormatTestCase(unittest.TestCase):
-    """http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511"""
-    def testOutputFormatConstructor(self):
-        new_format = mapscript.outputFormatObj('GDAL/GTiff', 'gtiff')
-        # assert new_format.refcount == 1, new_format.refcount
-        assert new_format.name == 'gtiff'
-        assert new_format.mimetype == 'image/tiff'
-
-
-class MapOutputFormatTestCase(MapTestCase):
-
-    def testAppendNewOutputFormat(self):
-        """test that a new output format can be created on-the-fly"""
-        num = self.map.numoutputformats
-        new_format = mapscript.outputFormatObj('GDAL/GTiff', 'gtiffx')
-        # assert new_format.refcount == 1, new_format.refcount
-        self.map.appendOutputFormat(new_format)
-        assert self.map.numoutputformats == num + 1
-        # assert new_format.refcount == 2, new_format.refcount
-        self.map.selectOutputFormat('gtiffx')
-        self.map.save('testAppendNewOutputFormat.map')
-        self.map.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
-        imgobj = self.map.draw()
-        filename = 'testAppendNewOutputFormat.tif'
-        imgobj.save(filename)
-
-    def testRemoveOutputFormat(self):
-        """testRemoveOutputFormat may fail depending on GD options"""
-        num = self.map.numoutputformats
-        new_format = mapscript.outputFormatObj('GDAL/GTiff', 'gtiffx')
-        self.map.appendOutputFormat(new_format)
-        assert self.map.numoutputformats == num + 1
-        # assert new_format.refcount == 2, new_format.refcount
-        assert self.map.removeOutputFormat('gtiffx') == mapscript.MS_SUCCESS
-        # assert new_format.refcount == 1, new_format.refcount
-        assert self.map.numoutputformats == num
-        self.assertRaises(mapscript.MapServerError,
-                          self.map.selectOutputFormat, 'gtiffx')
-        self.map.selectOutputFormat('GTiff')
-        assert self.map.outputformat.mimetype == 'image/tiff'
-
-    def testBuiltInPNG24Format(self):
-        """test built in PNG RGB format"""
-        self.map.selectOutputFormat('PNG24')
-        assert self.map.outputformat.mimetype == 'image/png'
-        self.map.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
-        img = self.map.draw()
-        assert img.format.mimetype == 'image/png'
-        filename = 'testBuiltInPNG24Format.png'
-        img.save(filename)
-
-    def testBuiltInJPEGFormat(self):
-        """test built in JPEG format"""
-        self.map.selectOutputFormat('JPEG')
-        assert self.map.outputformat.mimetype == 'image/jpeg'
-        self.map.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
-        img = self.map.draw()
-        assert img.format.mimetype == 'image/jpeg'
-        filename = 'testBuiltInJPEGFormat.jpg'
-        img.save(filename)
-
-    def testSelectBuiltInJPEGFormat(self):
-        """test selection of built-in JPEG format"""
-        self.map.selectOutputFormat('JPEG')
-        assert self.map.outputformat.mimetype == 'image/jpeg'
-
-
-class UnsupportedFormatTestCase(unittest.TestCase):
-    """I (Sean) don't ever configure for PDF, so this is the unsupported
-    format."""
-
-    def testCreateUnsupported(self):
-        self.assertRaises(mapscript.MapServerError, mapscript.outputFormatObj,
-                          'PDF')
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/ows_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/ows_test.py
--- 8.0.1-5/mapscript/python/tests/cases/ows_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/ows_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,124 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of OWS Requests
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import xml.dom.minidom
-import mapscript
-from .testing import MapTestCase
-
-
-class OWSRequestTestCase(MapTestCase):
-
-    def testInit(self):
-        """OWSRequestTestCase.testInit: OWS initializer works right"""
-        request = mapscript.OWSRequest()
-        request.setParameter("BBOX", "-0.3, 51.2, 0.3, 51.8")
-        assert request.NumParams == 1
-        assert request.getName(0) == "BBOX"
-        assert request.getValue(0) == "-0.3, 51.2, 0.3, 51.8"
-
-    def testGetParameter(self):
-        """OWSRequestTestCase.testGetParameter: OWS can get request parameters by index"""
-        request = mapscript.OWSRequest()
-        request.setParameter('foo', 'bar')
-        assert request.getValue(0) == 'bar'
-
-    def testGetParameterByName(self):
-        """OWSRequestTestCase.testGetParameterByName: OWS can get request parameters by name"""
-        request = mapscript.OWSRequest()
-        request.setParameter('foo', 'bar')
-        assert request.getValueByName('Foo') == 'bar'
-
-    def testResetParam(self):
-        """OWSRequestTestCase.testResetParam: OWS can reset parameters by name"""
-        request = mapscript.OWSRequest()
-        request.setParameter('foo', 'bar')
-        assert request.NumParams == 1
-        request.setParameter('Foo', 'bra')
-        assert request.NumParams == 1
-        assert request.getValue(0) == 'bra'
-
-    def testLoadWMSRequest(self):
-        """OWSRequestTestCase.testLoadWMSRequest: OWS can load a WMS request"""
-        request = mapscript.OWSRequest()
-        request.setParameter("REQUEST", "GetMap")
-        request.setParameter("VERSION", "1.1.0")
-        request.setParameter("FORMAT", "image/png")
-        request.setParameter("LAYERS", "POINT")
-        request.setParameter("BBOX", "-0.30, 51.20, 0.30, 51.80")
-        request.setParameter("SRS", "EPSG:4326")
-        request.setParameter("HEIGHT", "60")
-        request.setParameter("WIDTH", "60")
-        request.setParameter("STYLES", "")
-        for i in range(self.map.numlayers):
-            self.map.getLayer(i).status = mapscript.MS_ON
-        status = self.map.loadOWSParameters(request)
-        assert status == mapscript.MS_SUCCESS, status
-        self.assertEqual(self.map.height, 60)
-        self.assertEqual(self.map.width, 60)
-        self.assertEqual(self.map.getProjection(), "+init=epsg:4326")
-        # MapServer extents are from middle of the pixel
-        self.assertAlmostEqual(self.map.extent.minx, -0.295)
-        self.assertAlmostEqual(self.map.extent.miny, 51.205)
-        self.assertAlmostEqual(self.map.extent.maxx, 0.295)
-        self.assertAlmostEqual(self.map.extent.maxy, 51.795)
-        img = self.map.draw()
-        img.save("test_load_ows_request.png")
-
-    def testWFSPostRequest(self):
-        """OWSRequestTestCase.testLoadWMSRequest: OWS can POST a WFS request"""
-
-        self.map.web.metadata.set("ows_onlineresource", "http://dummy.org/")
-        request = mapscript.OWSRequest()
-        request.contenttype = "application/xml"
-
-        post_data = """<wfs:GetFeature xmlns:wfs="http://www.opengis.net/wfs" xmlns:ogc="http://www.opengis.net/ogc" service="WFS"
-        version="1.1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
-        <wfs:Query typeName="*:POINT" xmlns:feature="http://www.openplans.org/topp">
-            <ogc:Filter>
-                <ogc:PropertyIsEqualTo>
-                    <ogc:PropertyName>FID</ogc:PropertyName>
-                    <ogc:Literal>1</ogc:Literal>
-                </ogc:PropertyIsEqualTo>
-            </ogc:Filter>
-        </wfs:Query>
-        </wfs:GetFeature>
-        """
-
-        qs = ""  # additional parameters can be passed via the querystring
-        request.loadParamsFromPost(post_data, qs)
-        mapscript.msIO_installStdoutToBuffer()
-        status = self.map.OWSDispatch(request)
-        assert status == mapscript.MS_SUCCESS, status
-
-        mapscript.msIO_stripStdoutBufferContentHeaders()
-        result = mapscript.msIO_getStdoutBufferBytes()
-        dom = xml.dom.minidom.parseString(result)
-        assert len(dom.getElementsByTagName('ms:POINT')) == 1
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/parentreference_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/parentreference_test.py
--- 8.0.1-5/mapscript/python/tests/cases/parentreference_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/parentreference_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,117 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map
-# Author:   Umberto Nicoletti, unicoletti@prometeo.it
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import gc
-import unittest
-import mapscript
-from .testing import TESTMAPFILE
-
-
-class ParentReferenceTestCase(unittest.TestCase):
-
-    def initMap(self):
-        self.map = mapscript.mapObj(TESTMAPFILE)
-
-    def testGetLayerObj(self):
-        self.initMap()
-        layer = self.map.getLayer(1)
-        self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
-        gc.collect()
-        assert layer.map is not None, layer.map
-
-    def testGetLayerObjByName(self):
-        self.initMap()
-        layer = self.map.getLayerByName('POLYGON')
-        self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
-        gc.collect()
-        assert layer.map is not None, layer.map
-
-    def testLayerObj(self):
-        self.initMap()
-        layer = mapscript.layerObj(self.map)
-        self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
-        gc.collect()
-        assert layer.map is not None, layer.map
-
-    def testInsertLayerObj(self):
-        self.initMap()
-        layer = mapscript.layerObj()
-        self.map.insertLayer(layer)
-        self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
-        gc.collect()
-        assert layer.map is not None, layer.map
-
-    def testGetClassObj(self):
-        self.initMap()
-        layer = self.map.getLayer(1)
-        clazz = layer.getClass(0)
-        self.map = None
-        layer = None
-        assert str(clazz.p_layer).find('mapscript.layerObj') != -1
-        gc.collect()
-        assert clazz.layer is not None, clazz.layer
-
-    def testClassObj(self):
-        self.initMap()
-        layer = mapscript.layerObj(self.map)
-        clazz = mapscript.classObj(layer)
-        self.map = None
-        layer = None
-        assert str(clazz.p_layer).find('mapscript.layerObj') != -1
-        gc.collect()
-        assert clazz.layer is not None, clazz.layer
-
-    def testInsertClassObj(self):
-        self.initMap()
-        layer = mapscript.layerObj()
-        clazz = mapscript.classObj()
-        layer.insertClass(clazz)
-        self.map = None
-        layer = None
-        assert str(clazz.p_layer).find('mapscript.layerObj') != -1
-        gc.collect()
-        assert clazz.layer is not None, clazz.layer
-
-    def testRemoveClassObj(self):
-        self.initMap()
-        layer = self.map.getLayer(1)
-        clazz = layer.removeClass(0)
-        if hasattr(clazz, 'p_layer'):
-            assert clazz.p_layer is None, clazz.p_layer
-        assert clazz.layer is None, clazz.layer
-        self.initMap()
-        position = self.map.getLayer(0).insertClass(clazz)
-        assert position == 0, position
-        assert clazz.p_layer is not None, clazz.p_layer
-        assert clazz.layer is not None, clazz.layer
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/pgtest.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/pgtest.py
--- 8.0.1-5/mapscript/python/tests/cases/pgtest.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/pgtest.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,129 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of PostGIS Layer
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-#
-# Execute this module as a script from mapserver/mapscript/python
-#
-#     python tests/cases/pgtest.py -v
-#
-# NOTE: these tests use a fixture included in mapserver/tests. To produce
-# the testing database, follow these steps:
-#
-# $ cd mapserver/tests
-# $ shp2pgsql -s 4326 -I polygon.shp postgis.polygon > polygon.sql
-# $ su postgres
-# $ make -f makefile_postgis
-#
-# ===========================================================================
-
-import unittest
-import mapscript
-
-PG_CONNECTION_STRING = "dbname=mapserver_test user=postgres"
-
-
-class TableTest(unittest.TestCase):
-    def setUp(self):
-        self.mo = mapscript.mapObj()
-        lo = mapscript.layerObj()
-        lo.name = 'pg_layer'
-        lo.type = mapscript.MS_LAYER_POLYGON
-        lo.connectiontype = mapscript.MS_POSTGIS
-        lo.connection = PG_CONNECTION_STRING
-        lo.data = "the_geom from polygon"
-        li = self.mo.insertLayer(lo)
-        self.lo = self.mo.getLayer(li)
-
-    def test_getfeature(self):
-        self.lo.open()
-        f = self.lo.getFeature(1, -1)
-        atts = [f.getValue(i) for i in range(self.lo.numitems)]
-        self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
-
-
-class ViewTest(unittest.TestCase):
-    def setUp(self):
-        self.mo = mapscript.mapObj()
-        lo = mapscript.layerObj()
-        lo.name = 'pg_sub_layer'
-        lo.type = mapscript.MS_LAYER_POLYGON
-        lo.connectiontype = mapscript.MS_POSTGIS
-        lo.connection = PG_CONNECTION_STRING
-        lo.data = "the_geom from polygon_v using unique gid using srid=4326"
-        li = self.mo.insertLayer(lo)
-        self.lo = self.mo.getLayer(li)
-
-    def test_getfeature(self):
-        self.lo.open()
-        f = self.lo.getFeature(1, -1)
-        atts = [f.getValue(i) for i in range(self.lo.numitems)]
-        self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
-
-
-class SubSelectTest(unittest.TestCase):
-    def setUp(self):
-        self.mo = mapscript.mapObj()
-        lo = mapscript.layerObj()
-        lo.name = 'pg_sub_layer'
-        lo.type = mapscript.MS_LAYER_POLYGON
-        lo.connectiontype = mapscript.MS_POSTGIS
-        lo.connection = PG_CONNECTION_STRING
-        lo.data = "the_geom from (select * from polygon) as foo using unique gid using srid=4326"
-        li = self.mo.insertLayer(lo)
-        self.lo = self.mo.getLayer(li)
-
-    def test_getfeature(self):
-        self.lo.open()
-        f = self.lo.getFeature(1, -1)
-        atts = [f.getValue(i) for i in range(self.lo.numitems)]
-        self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
-
-
-class SubSelectNoSRIDTest(unittest.TestCase):
-    """SRID should be diagnosed from the selection"""
-    def setUp(self):
-        self.mo = mapscript.mapObj()
-        lo = mapscript.layerObj()
-        lo.name = 'pg_sub_layer'
-        lo.type = mapscript.MS_LAYER_POLYGON
-        lo.connectiontype = mapscript.MS_POSTGIS
-        lo.connection = PG_CONNECTION_STRING
-        lo.data = "the_geom from (select * from polygon) as foo using unique gid"
-        li = self.mo.insertLayer(lo)
-        self.lo = self.mo.getLayer(li)
-
-    def test_getfeature(self):
-        self.lo.open()
-        f = self.lo.getFeature(1, -1)
-        atts = [f.getValue(i) for i in range(self.lo.numitems)]
-        self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/point_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/point_test.py
--- 8.0.1-5/mapscript/python/tests/cases/point_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/point_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,158 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Point
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-
-
-have_image = False
-
-try:
-    from PIL import Image
-    have_image = True
-except ImportError:
-    pass
-
-
-class PointObjTestCase(unittest.TestCase):
-
-    def testPointObjConstructorNoArgs(self):
-        """point can be created with no arguments"""
-        p = mapscript.pointObj()
-        self.assertAlmostEqual(p.x, 0.0)
-        self.assertAlmostEqual(p.y, 0.0)
-
-    def testPointObjConstructorArgs(self):
-        """point can be created with arguments"""
-        p = mapscript.pointObj(1.0, 1.0)
-        self.assertAlmostEqual(p.x, 1.0)
-        self.assertAlmostEqual(p.y, 1.0)
-
-    def testSetXY(self):
-        """point can have its x and y reset"""
-        p = mapscript.pointObj()
-        p.setXY(1.0, 1.0)
-        self.assertAlmostEqual(p.x, 1.0)
-        self.assertAlmostEqual(p.y, 1.0)
-        if hasattr(p, 'm'):
-            self.assertAlmostEqual(p.m, -2e38)
-
-    def testSetXYM(self):
-        """point can have its x and y reset (with m value)"""
-        p = mapscript.pointObj()
-        p.setXY(1.0, 1.0, 1.0)
-        self.assertAlmostEqual(p.x, 1.0)
-        self.assertAlmostEqual(p.y, 1.0)
-        if hasattr(p, 'm'):
-            self.assertAlmostEqual(p.m, 1.0)
-
-    def testSetXYZ(self):
-        """point can have its x, y, z reset (with m value)"""
-        p = mapscript.pointObj()
-        p.setXYZ(1.0, 2.0, 3.0, 4.0)
-        self.assertAlmostEqual(p.x, 1.0)
-        self.assertAlmostEqual(p.y, 2.0)
-        if hasattr(p, 'z') and hasattr(p, 'm'):
-            self.assertAlmostEqual(p.z, 3.0)
-            self.assertAlmostEqual(p.m, 4.0)
-
-    def testPointDraw(self):
-        """Can create a point, add to a layer, and draw it directly"""
-
-        map_string = """
-        MAP
-            EXTENT 0 0 90 90
-            SIZE 500 500
-
-            SYMBOL
-            NAME "circle"
-            TYPE ELLIPSE
-            POINTS 1 1 END
-            FILLED true
-            END
-
-            LAYER
-            NAME "punkt"
-            STATUS ON
-            TYPE POINT
-            END
-
-        END"""
-
-        test_map = mapscript.fromstring(map_string)
-        layer = test_map.getLayerByName('punkt')
-        cls = mapscript.classObj()
-        style = mapscript.styleObj()
-        style.outlinecolor.setHex('#00aa00ff')
-        style.size = 10
-        style.setSymbolByName(test_map, 'circle')
-
-        cls.insertStyle(style)
-        class_idx = layer.insertClass(cls)
-        point = mapscript.pointObj(45, 45)
-
-        img = test_map.prepareImage()
-        point.draw(test_map, layer, img, class_idx, "test")
-
-        filename = 'testDrawPoint.png'
-        with open(filename, 'wb') as fh:
-            img.write(fh)
-
-        if have_image:
-            pyimg = Image.open(filename)
-            assert pyimg.size == (500, 500)
-
-    def testPoint__str__(self):
-        """return properly formatted string"""
-        p = mapscript.pointObj(1.0, 1.0)
-        if hasattr(p, 'z'):
-            p_str = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g }" % (p.x, p.y, p.z)
-        else:
-            p_str = "{ 'x': %.16g, 'y': %.16g }" % (p.x, p.y)
-        assert str(p) == p_str, str(p)
-
-    def testPointToString(self):
-        """return properly formatted string in toString()"""
-        p = mapscript.pointObj(1.0, 1.0, 0.002, 15.0)
-        if hasattr(p, 'z') and hasattr(p, 'm'):
-            p_str = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g, 'm': %.16g }" \
-                  % (p.x, p.y, p.z, p.m)
-        else:
-            p_str = "{ 'x': %.16g, 'y': %.16g }" % (p.x, p.y)
-
-        assert p.toString() == p_str, p.toString()
-
-    def testPointGeoInterface(self):
-        """return point using the  __geo_interface__ protocol"""
-        p = mapscript.pointObj(1.0, 1.0, 0.002, 15.0)
-        if hasattr(p, 'z'):
-            assert p.__geo_interface__ == {"type": "Point", "coordinates": (1.0, 1.0, 0.002)}
-        else:
-            assert p.__geo_interface__ == {"type": "Point", "coordinates": (1.0, 1.0)}
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/rect_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/rect_test.py
--- 8.0.1-5/mapscript/python/tests/cases/rect_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/rect_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,127 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of rectObj
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapPrimitivesTestCase
-
-
-class RectObjTestCase(MapPrimitivesTestCase):
-
-    def testRectObjConstructorNoArgs(self):
-        """a rect can be initialized with no args"""
-        r = mapscript.rectObj()
-        self.assertAlmostEqual(r.minx, -1.0)
-        self.assertAlmostEqual(r.miny, -1.0)
-        self.assertAlmostEqual(r.maxx, -1.0)
-        self.assertAlmostEqual(r.maxy, -1.0)
-
-    def testRectObjConstructorArgs(self):
-        """a rect can be initialized with arguments"""
-        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
-        self.assertAlmostEqual(r.minx, -1.0)
-        self.assertAlmostEqual(r.miny, -2.0)
-        self.assertAlmostEqual(r.maxx, 3.0)
-        self.assertAlmostEqual(r.maxy, 4.0)
-
-    def testRectObjConstructorBadXCoords(self):
-        """an invalid extent raises proper error (x direction)"""
-        self.assertRaises(mapscript.MapServerError, mapscript.rectObj,
-                          1.0, -2.0, -3.0, 4.0)
-
-    def testRectObjConstructorBadYCoords(self):
-        """an invalid extent raises proper error (y direction)"""
-        self.assertRaises(mapscript.MapServerError, mapscript.rectObj,
-                          -1.0, 2.0, 3.0, -2.0)
-
-    def testRectObjToPolygon(self):
-        """a rect can be converted into a MS_POLYGON shape"""
-        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
-        s = r.toPolygon()
-        assert s.numlines == 1, s.numlines
-        line = self.getLineFromShape(s, 0)
-        assert line.numpoints == 5, line.numpoints
-        point = self.getPointFromLine(line, 0)
-        self.assertAlmostEqual(point.x, -1.0)
-        self.assertAlmostEqual(point.y, -2.0)
-
-    def testExceptionMessage(self):
-        """test formatted error message"""
-        try:
-            r = mapscript.rectObj(1.0, -2.0, -3.0, 4.0)
-            print(r)
-        except mapscript.MapServerError as msg:
-            assert str(msg) == "rectObj(): Invalid rectangle. { 'minx': 1.000000 , " \
-                               "'miny': -2.000000 , 'maxx': -3.000000 , 'maxy': 4.000000 }", msg
-
-    def testRect__str__(self):
-        """__str__ returns properly formatted string"""
-        r = mapscript.rectObj(-1.0, -2.0, 3.0001, 4.0)
-        r_str = str(r)
-        assert r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }", r_str
-        r2 = eval(r_str)
-        self.assertAlmostEqual(r2['minx'], r.minx)
-        self.assertAlmostEqual(r2['miny'], r.miny)
-        self.assertAlmostEqual(r2['maxx'], r.maxx)
-        self.assertAlmostEqual(r2['maxy'], r.maxy)
-
-    def testRectToString(self):
-        """return properly formatted string"""
-        r = mapscript.rectObj(-1.0, -2.0, 3.0001, 4.0)
-        r_str = r.toString()
-        assert r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }", r_str
-
-    def testRectContainsPoint(self):
-        """point is contained (spatially) in rectangle"""
-        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
-        p = mapscript.pointObj(0.0, 0.0)
-        assert p in r, (p.x, p.y, r)
-
-    def testRectContainsPointNot(self):
-        """point is not contained (spatially) in rectangle"""
-        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
-        p = mapscript.pointObj(3.00001, 0.0)
-        assert p not in r, (p.x, p.y, r)
-
-
-class ImageRectObjTestCase(MapPrimitivesTestCase):
-
-    def testRectObjConstructorArgs(self):
-        """create a rect in image units"""
-        r = mapscript.rectObj(-1.0, 2.0, 3.0, 0.0, mapscript.MS_TRUE)
-        self.assertAlmostEqual(r.minx, -1.0)
-        self.assertAlmostEqual(r.miny, 2.0)
-        self.assertAlmostEqual(r.maxx, 3.0)
-        self.assertAlmostEqual(r.maxy, 0.0)
-
-    def testRectObjConstructorBadYCoords(self):
-        """in image units miny should be greater than maxy"""
-        self.assertRaises(mapscript.MapServerError, mapscript.rectObj,
-                          -1.0, 0.0, 3.0, 2.0, mapscript.MS_TRUE)
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/refcount_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/refcount_test.py
--- 8.0.1-5/mapscript/python/tests/cases/refcount_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/refcount_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,309 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map
-# Author:   Umberto Nicoletti, unicoletti@prometeo.it
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import TESTMAPFILE
-
-
-class ReferenceCountingTestCase(unittest.TestCase):
-
-    def initMap(self):
-        self.map = mapscript.mapObj(TESTMAPFILE)
-
-    def testMap(self):
-        """ReferenceCountingTestCase.testMap: test map constructor with no argument"""
-        test_map = mapscript.mapObj()
-        assert test_map.__class__.__name__ == "mapObj"
-        assert test_map.thisown == 1
-        assert test_map.refcount == 1
-
-    def testMapWithDefaultMap(self):
-        """ReferenceCountingTestCase.testTestMap: test map constructor with default map file"""
-        test_map = mapscript.mapObj(TESTMAPFILE)
-        assert test_map.__class__.__name__ == "mapObj"
-        assert test_map.thisown == 1
-        assert test_map.refcount == 1
-        assert test_map.getLayer(0).refcount == 2
-
-    def testMapLayersCounting(self):
-        """ReferenceCountingTestCase.testTestMap: test map constructor with default map file"""
-        self.initMap()
-        layerRef1 = self.map.getLayer(0)
-        assert layerRef1.refcount == 2
-        layerRef2 = self.map.getLayer(0)
-        assert layerRef2.refcount == 3
-
-    def testMapInsertedLayer(self):
-        """MapLayersTestCase.testMapInsertedLayer: test insertion of a new layer at default (last) index"""
-        self.initMap()
-        n = self.map.numlayers
-        layer = mapscript.layerObj()
-        layer.name = 'new'
-        assert layer.refcount == 1
-        assert layer.thisown == 1
-        index = self.map.insertLayer(layer)
-        assert index == n, index
-        assert self.map.numlayers == n + 1
-        assert layer.refcount == 2
-        assert layer.thisown == 1
-        assert self.map.getLayer(index).refcount == 3
-        assert self.map.getLayer(index).thisown == 1
-        assert layer.refcount == 2
-        assert layer.thisown == 1
-
-    def testMapInsertedLayerWithIndex(self):
-        """MapLayersTestCase.testMapInsertedLayerWithIndex: test insertion of a new layer at index 0"""
-        self.initMap()
-        n = self.map.numlayers
-        layer = mapscript.layerObj()
-        layer.name = 'new'
-        assert layer.refcount == 1
-        assert layer.thisown == 1
-        index = self.map.insertLayer(layer, 0)
-        assert index == 0, index
-        assert self.map.numlayers == n + 1
-        assert layer.refcount == 2
-        assert layer.thisown == 1
-        assert self.map.getLayer(index).refcount == 3
-        assert self.map.getLayer(index).thisown == 1
-        assert layer.refcount == 2
-        assert layer.thisown == 1
-
-    def testMapRemovedLayerAtTail(self):
-        """removal of highest index (tail) layer"""
-        self.initMap()
-        n = self.map.numlayers
-        layer = self.map.removeLayer(n-1)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'INLINE-PIXMAP-PCT'
-        assert layer.thisown == 1
-        assert layer.refcount == 1, layer.refcount
-        self.map.draw()
-
-    def testMapRemovedLayerAtZero(self):
-        """removal of lowest index (0) layer"""
-        self.initMap()
-        n = self.map.numlayers
-        layer = self.map.removeLayer(0)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'RASTER'
-        assert layer.thisown == 1
-        assert layer.refcount == 1, layer.refcount
-        self.map.draw()
-
-    def testBehaveWhenParentIsNull(self):
-        """behave when parent (map) is null"""
-        self.initMap()
-        layer = mapscript.layerObj()
-        layer.name = 'new'
-        index = self.map.insertLayer(layer, 0)
-        assert index == 0, index
-        self.map = None
-        assert layer.map is not None, layer.map
-        exception = None
-        try:
-            layer.open()
-        except Exception:
-            # must fail because the new layer is missing information
-            exception = True
-        assert exception is True
-
-    def testLayerClone(self):
-        """Clone a layer"""
-        layer = mapscript.layerObj()
-        layer.name = 'sample'
-        copy = layer.clone()
-
-        assert layer.refcount == 1, layer.refcount
-        assert copy.refcount == 1, copy.refcount
-        assert layer.name == copy.name
-        assert copy.map is None
-
-    def testMapGetLayerByName(self):
-        """behave when parent (map) is null"""
-        self.initMap()
-        layer = self.map.getLayerByName("RASTER")
-
-        assert layer.refcount == 2, layer.refcount
-        assert layer.thisown == 1, layer.thisown
-
-    def testBehaveWhenParentIsNotNull(self):
-        """behave when parent (map) is not null"""
-        self.initMap()
-        layer = mapscript.layerObj(self.map)
-        layer.name = 'new'
-        assert layer.refcount == 2, layer.refcount
-
-    def testDummyClass(self):
-        """basic refcounting for classObj"""
-        clazz = mapscript.classObj()
-        assert clazz.refcount == 1, clazz.refcount
-
-    def testClassWithArgument(self):
-        """classObj constructor with not null layer"""
-        self.initMap()
-        clazz = mapscript.classObj(self.map.getLayer(0))
-        assert clazz.refcount == 2, clazz.refcount
-
-    def testClassGetter(self):
-        """classObj getter"""
-        self.initMap()
-        clazz = self.map.getLayer(1).getClass(0)
-        assert clazz.refcount == 2, clazz.refcount
-
-    def testClassClone(self):
-        """classObj clone"""
-        self.initMap()
-        clazz = self.map.getLayer(1).getClass(0)
-        assert clazz.refcount == 2, clazz.refcount
-        clone = clazz.clone()
-        assert clone.refcount == 1, clone.refcount
-
-    def testClassInsert(self):
-        """classObj insert at end"""
-        self.initMap()
-        clazz = mapscript.classObj()
-        clazz.minscaledenom = 666
-        assert clazz.refcount == 1, clazz.refcount
-        idx = self.map.getLayer(1).insertClass(clazz)
-        assert clazz.refcount == 2, clazz.refcount
-        assert self.map.getLayer(1).getClass(idx).refcount == 3, self.map.getLayer(1).getClass(idx).refcount
-        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, self.map.getLayer(1).getClass(idx).minscaledenom
-
-    def testClassInsertAtMiddle(self):
-        """classObj insert at pos. 1"""
-        self.initMap()
-        clazz = mapscript.classObj()
-        clazz.minscaledenom = 666
-        assert clazz.refcount == 1, clazz.refcount
-        idx = self.map.getLayer(1).insertClass(clazz, 1)
-        assert idx == 1, idx
-        assert clazz.refcount == 2, clazz.refcount
-        assert self.map.getLayer(1).getClass(idx).refcount == 3, self.map.getLayer(1).getClass(idx).refcount
-        assert self.map.getLayer(1).getClass(idx).thisown, self.map.getLayer(1).getClass(idx).thisown
-        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, self.map.getLayer(1).getClass(idx).minscaledenom
-
-    def testRemoveFirstClass(self):
-        """removal of first class"""
-        self.initMap()
-        clazz = self.map.getLayerByName("POLYGON").removeClass(0)
-        assert clazz is not None
-        assert clazz.thisown == 1
-        assert clazz.refcount == 1, clazz.refcount
-        self.map.draw()
-
-    def testMapClone(self):
-        """cloning a mapObj"""
-        self.initMap()
-        clone = self.map.clone()
-        assert clone.refcount == 1, clone.refcount
-
-    def testStyleGetter(self):
-        """styleObj getter"""
-        self.initMap()
-        style = self.map.getLayer(1).getClass(0).getStyle(0)
-        assert style.refcount == 2, style.refcount
-        assert style.thisown == 1, style.thisown
-
-    def testStyleConstructor(self):
-        """styleObj Constructor"""
-        self.initMap()
-        style = mapscript.styleObj(self.map.getLayer(1).getClass(0))
-        assert style.refcount == 2, style.refcount
-        assert style.thisown == 1, style.thisown
-        style = mapscript.styleObj()
-        assert style.refcount == 1, style.refcount
-        assert style.thisown == 1, style.thisown
-
-    def testRemoveStyleAtBeginning(self):
-        """styleObj remove first one"""
-        self.initMap()
-        style = mapscript.styleObj()
-        assert style.refcount == 1, style.refcount
-        assert style.thisown == 1, style.thisown
-        self.map.getLayer(1).getClass(0).insertStyle(style)
-        assert style.refcount == 2, style.refcount
-        assert style.thisown == 1, style.thisown
-        style = self.map.getLayer(1).getClass(0).removeStyle(0)
-        assert style.refcount == 1, style.refcount
-        assert style.thisown == 1, style.thisown
-
-    def testInsertStyle(self):
-        """styleObj Insert"""
-        self.initMap()
-        style = mapscript.styleObj()
-        assert style.refcount == 1, style.refcount
-        assert style.thisown == 1, style.thisown
-        self.map.getLayer(1).getClass(0).insertStyle(style)
-        assert style.refcount == 2, style.refcount
-        assert style.thisown == 1, style.thisown
-
-    def testCloneStyle(self):
-        """styleObj Clone"""
-        self.initMap()
-        style = mapscript.styleObj()
-        assert style.refcount == 1, style.refcount
-        assert style.thisown == 1, style.thisown
-        clone = style.clone()
-        assert clone.refcount == 1, clone.refcount
-        assert clone.thisown == 1, clone.thisown
-        assert style.refcount == 1, style.refcount
-        assert style.thisown == 1, style.thisown
-        style = self.map.getLayer(1).getClass(0).getStyle(0)
-        clone = style.clone()
-        assert clone.refcount == 1, clone.refcount
-        assert clone.thisown == 1, clone.thisown
-
-    def testBasicSymbolRefcounting(self):
-        """symbolObj refcounting """
-        self.initMap()
-        symb = self.map.symbolset.getSymbol(0)
-        assert symb.refcount == 2, symb.refcount
-        assert symb.thisown == 1, symb.thisown
-        symb = self.map.symbolset.getSymbolByName("home-png")
-        assert symb.refcount == 2, symb.refcount
-        assert symb.thisown == 1, symb.thisown
-        symb2 = self.map.symbolset.getSymbolByName("home-png")
-        assert symb2.refcount == 3, symb2.refcount
-        assert symb2.thisown == 1, symb2.thisown
-
-    def testSymbolAppendRemove(self):
-        """appendSymbolObj refcounting """
-        self.initMap()
-        symb = mapscript.symbolObj("ANEWSYMBOL")
-        assert symb.refcount == 1, symb.refcount
-        assert symb.thisown == 1, symb.thisown
-        idx = self.map.symbolset.appendSymbol(symb)
-        assert symb.refcount == 2, symb.refcount
-        assert symb.thisown == 1, symb.thisown
-        symb = self.map.symbolset.removeSymbol(idx)
-        assert symb.refcount == 1, symb.refcount
-        assert symb.thisown == 1, symb.thisown
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/resultcache_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/resultcache_test.py
--- 8.0.1-5/mapscript/python/tests/cases/resultcache_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/resultcache_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,146 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of ResultCache
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase
-
-
-class LayerQueryTestCase(MapTestCase):
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        self.layer = self.map.getLayer(1)
-        self.layer.template = 'some day i will fix this!'
-
-    def pointquery(self):
-        p = mapscript.pointObj(0.0, 51.5)
-        self.layer.queryByPoint(self.map, p, mapscript.MS_MULTIPLE, -1)
-        return self.layer.getResults()
-
-    def indexquery(self):
-        self.layer.queryByIndex(self.map, -1, 0, mapscript.MS_TRUE)
-        return self.layer.getResults()
-
-
-class ResultCacheTestCase(LayerQueryTestCase):
-
-    def testNoDirectAccess(self):
-        """denying direct access to layer's resultcache"""
-        self.assertRaises(AttributeError, getattr, self.layer, 'resultcache')
-
-    def testNullResultCache(self):
-        """before a query layer's resultcache should be NULL"""
-        results = self.layer.getResults()
-        assert results is None
-
-
-class PointQueryResultsTestCase(LayerQueryTestCase):
-
-    def testCacheAfterQuery(self):
-        """simple point query returns one result"""
-        results = self.pointquery()
-        assert results.numresults == 1
-
-    def testCacheAfterFailedQuery(self):
-        """point query with no results returns NULL"""
-        p = mapscript.pointObj(0.0, 0.0)
-        self.layer.queryByPoint(self.map, p, mapscript.MS_MULTIPLE, -1)
-        results = self.layer.getResults()
-        assert results is None
-
-    def testDeletionOfResults(self):
-        """deleting results should not harm the layer"""
-        results = self.pointquery()
-        assert results.thisown == 0
-        del results
-        results = self.layer.getResults()
-        assert results.numresults == 1
-
-    def testQueryResultBounds(self):
-        """result bounds should equal layer bounds"""
-        results = self.pointquery()
-        e = self.layer.getExtent()
-        self.assertRectsEqual(results.bounds, e)
-
-    def testQueryResultMembers(self):
-        """get the single result member"""
-        results = self.pointquery()
-        self.layer.open()
-        res = results.getResult(0)
-        feature = self.layer.getShape(res)
-        self.layer.close()
-        self.assertRectsEqual(results.bounds, feature.bounds)
-        assert feature.getValue(1) == 'A Polygon'
-
-    def testQueryResultsListComp(self):
-        """get all results using list comprehension"""
-        results = self.pointquery()
-        result_list = [results.getResult(i) for i in range(results.numresults)]
-        assert len(result_list) == 1
-        assert result_list[0].shapeindex == 0
-
-    def testQueryByIndex(self):
-        """pop a result into the result set"""
-        self.layer.queryByIndex(self.map, -1, 0, mapscript.MS_FALSE)
-        results = self.layer.getResults()
-        assert results.numresults == 1
-        self.layer.queryByIndex(self.map, -1, 0, mapscript.MS_TRUE)
-        results = self.layer.getResults()
-        assert results.numresults == 2
-
-
-class DumpAndLoadTestCase(LayerQueryTestCase):
-
-    def testSaveAndLoadQuery(self):
-        """test saving query to a file"""
-        results = self.pointquery()
-        self.map.saveQuery('test.qy')
-        self.map.freeQuery()
-        results = self.layer.getResults()
-        assert results is None
-        self.map.loadQuery('test.qy')
-        results = self.layer.getResults()
-        assert results is not None
-
-
-class LayerOffQueryTestCase(LayerQueryTestCase):
-
-    def testPointQueryOffLayer(self):
-        """simple point query returns one result, even if layer is off"""
-        self.layer.status = mapscript.MS_OFF
-        results = self.pointquery()
-        assert results.numresults == 1
-
-    def testIndexQueryOffLayer(self):
-        """simple index query returns one result, even if layer is off"""
-        self.layer.status = mapscript.MS_OFF
-        results = self.indexquery()
-        assert results.numresults == 1
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/shape_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/shape_test.py
--- 8.0.1-5/mapscript/python/tests/cases/shape_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/shape_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,182 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Shape
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase, ShapeObjTestCase
-
-
-class ShapePointTestCase(ShapeObjTestCase):
-    """Test point type shapeObj in stand-alone mode"""
-
-    def setUp(self):
-        """The test fixture is a shape of one point"""
-        self.points = (mapscript.pointObj(0.0, 1.0), )
-        self.lines = (mapscript.lineObj(), )
-        self.addPointToLine(self.lines[0], self.points[0])
-        self.shape = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
-        self.addLineToShape(self.shape, self.lines[0])
-
-    def testCreateShape(self):
-        """the number of lines is correct"""
-        assert self.shape.numlines == 1
-
-    def testShapeClone(self):
-        """test shape can be copied"""
-        s = self.shape.clone()
-        self.assertShapesEqual(self.shape, s)
-
-
-class InlineFeatureTestCase(MapTestCase):
-    """tests for issue http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=562"""
-
-    def testAddPointFeature(self):
-        """adding a point to an inline feature works correctly"""
-        inline_layer = self.map.getLayerByName('INLINE')
-        assert inline_layer.connectiontype == mapscript.MS_INLINE
-        p = mapscript.pointObj(0.2, 51.5)
-        lyr = mapscript.lineObj()
-        self.addPointToLine(lyr, p)
-        shape = mapscript.shapeObj(inline_layer.type)
-        shape.classindex = 0
-        self.addLineToShape(shape, lyr)
-        inline_layer.addFeature(shape)
-        msimg = self.map.draw()
-        filename = 'testAddPointFeature.png'
-        msimg.save(filename)
-
-    def testGetShape(self):
-        """returning the shape from an inline feature works"""
-        inline_layer = self.map.getLayerByName('INLINE')
-        inline_layer.open()
-        inline_layer.template = "FAKE"
-        inline_layer.queryByIndex(self.map, -1, 0)
-        res = inline_layer.getResult(0)
-        s = inline_layer.getShape(res)
-        lyr = self.getLineFromShape(s, 0)
-        p = self.getPointFromLine(lyr, 0)
-        self.assertAlmostEqual(p.x, -0.2)
-        self.assertAlmostEqual(p.y, 51.5)
-
-    def testGetNumFeatures(self):
-        """the number of features in the inline layer is correct"""
-        inline_layer = self.map.getLayerByName('INLINE')
-        assert inline_layer.getNumFeatures() == 1
-
-    def testShapeGeoInterface(self):
-        """return the shape using the  __geo_interface__ protocol with no attribute names"""
-        layer = self.map.getLayerByName('POLYGON')
-        layer.open()
-        layer.template = "FAKE"
-        layer.queryByIndex(self.map, -1, 0)
-        res = layer.getResult(0)
-        s = layer.getShape(res)
-        assert s.__geo_interface__ == {
-            'geometry': {
-                'type': 'Polygon',
-                'coordinates': [[(-0.25, 51.227222, 0.0), (-0.25, 51.727222, 0.0), (0.25, 51.727222, 0.0),
-                                 (0.25, 51.227222, 0.0), (-0.25, 51.227222, 0.0)]]
-            },
-            'type': 'Feature',
-            'bbox': (-0.25, 51.227222, 0.25, 51.727222),
-            'properties': {'1': 'A Polygon', '0': '1'}
-         }
-
-        layer.close()
-
-    def testShapeGeoInterfaceWithFields(self):
-        """return the shape using the  __geo_interface__ protocol with attribute names"""
-        layer = self.map.getLayerByName('POINT')
-        layer.open()
-        layer.template = "FAKE"
-        layer.queryByIndex(self.map, -1, 0)
-        res = layer.getResult(0)
-        s = layer.getShape(res)
-        s.itemdefinitions = layer.getItemDefinitions()
-        assert s.__geo_interface__ == {
-            'geometry': {
-                'type': 'Point',
-                'coordinates': [[(0.0, 51.477222, 0.0)]]
-            },
-            'type': 'Feature',
-            'bbox': (0.0, 51.477222, 0.0, 51.477222),
-            'properties': {'FNAME': 'A Point', 'FID': 1}
-         }
-
-        layer.close()
-
-
-class ShapeValuesTestCase(unittest.TestCase):
-
-    def testNullValue(self):
-        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
-        assert so.numvalues == 0
-        assert so.getValue(0) is None
-
-    def testSetValue(self):
-        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
-        so.initValues(4)
-        so.setValue(0, 'Foo')
-        assert so.numvalues == 4
-        assert so.getValue(0) == 'Foo'
-        assert so.getValue(1) == ''
-
-
-# New class for testing the WKT stuff of RFC-2
-class ShapeWKTTestCase(unittest.TestCase):
-
-    # define a pair of coords, and WKT as class data
-    point_xy = (-105.5000000000000000, 40.0000000000000000)
-    point_wkt = 'POINT (-105.5000000000000000 40.0000000000000000)'
-
-    def testSetPointWKT(self):
-        # Create new instance and set/init from WKT
-        so = mapscript.shapeObj.fromWKT(self.point_wkt)
-
-        # expect one line with one point
-        self.assertTrue(so.numlines == 1, so.numlines)
-        self.assertTrue(so.get(0).numpoints == 1, so.get(0).numpoints)
-
-        # expect shape's x and y values to be correct
-        po = so.get(0).get(0)
-        self.assertAlmostEqual(po.x, self.point_xy[0])
-        self.assertAlmostEqual(po.y, self.point_xy[1])
-
-    def testGetPointWKT(self):
-        # Create new instance from class data
-        po = mapscript.pointObj(self.point_xy[0], self.point_xy[1])
-        lo = mapscript.lineObj()
-        lo.add(po)
-        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
-        so.add(lo)
-
-        # test output WKT
-        wkt = so.toWKT()
-        self.assertTrue(wkt == self.point_wkt, wkt)
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/shapefile_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/shapefile_test.py
--- 8.0.1-5/mapscript/python/tests/cases/shapefile_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/shapefile_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,53 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of shapefileObj
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import os
-import mapscript
-from .testing import TESTS_PATH
-
-
-class AddShapeTestCase(unittest.TestCase):
-
-    def testAddEmpty(self):
-        """expect an error rather than segfault when adding an empty shape"""
-        # See bug 1201
-        sf = mapscript.shapefileObj('testAddDud.shp', 1)
-        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
-        self.assertRaises(mapscript.MapServerError, sf.add, so)
-
-    def testGetDBFInfo(self):
-        """Fetch dbf information from shapefile"""
-        pth = os.path.join(TESTS_PATH, "polygon.shp")
-        sf = mapscript.shapefileObj(pth)
-        assert sf.getDBF() is not None, sf.getDBF()
-        assert sf.getDBF().nFields == 2, sf.getDBF().nFields
-        assert sf.getDBF().getFieldName(0) == 'FID', sf.getDBF().getFieldName(0)
-        assert sf.getDBF().getFieldName(1) == 'FNAME', sf.getDBF().getFieldName(1)
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/style_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/style_test.py
--- 8.0.1-5/mapscript/python/tests/cases/style_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/style_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,287 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map Styles
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapTestCase
-
-
-class DrawProgrammedStylesTestCase(MapTestCase):
-    def testDrawPoints(self):
-        """DrawProgrammedStylesTestCase.testDrawPoints: point drawing with styles works as advertised"""
-        points = [mapscript.pointObj(-0.2, 51.6),
-                  mapscript.pointObj(0.0, 51.2),
-                  mapscript.pointObj(0.2, 51.6)]
-        colors = [mapscript.colorObj(255, 0, 0),
-                  mapscript.colorObj(0, 255, 0),
-                  mapscript.colorObj(0, 0, 255)]
-        img = self.map.prepareImage()
-        layer = self.map.getLayerByName('POINT')
-        # layer.draw(self.map, img)
-        class0 = layer.getClass(0)
-        for i in range(len(points)):
-            style0 = class0.getStyle(0)
-            style0.color = colors[i]
-            # style0.color.pen = -4
-            assert style0.color.toHex() == colors[i].toHex()
-            points[i].draw(self.map, layer, img, 0, "foo")
-        img.save('test_draw_points.png')
-
-
-class NewStylesTestCase(MapTestCase):
-
-    def testStyleConstructor(self):
-        """a new style is properly initialized"""
-        new_style = mapscript.styleObj()
-        assert new_style.color.red == -1
-        assert new_style.color.green == -1
-        assert new_style.color.blue == -1
-
-    def testCloneStyle(self):
-        """check attributes of a cloned style"""
-        new_style = mapscript.styleObj()
-        new_style.color.setHex('#808080')
-        clone = new_style.clone()
-        assert clone.thisown == 1
-        assert clone.color.toHex() == '#808080'
-
-    def testStyleColorSettable(self):
-        """a style can be set with a color tuple"""
-        new_style = mapscript.styleObj()
-        new_style.color.setRGB(1, 2, 3)
-        assert new_style.color.red == 1
-        assert new_style.color.green == 2
-        assert new_style.color.blue == 3
-
-    def testStyleBinding(self):
-        """attribute binding can be set and get"""
-        new_style = mapscript.styleObj()
-        assert (not new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR))
-        new_style.setBinding(mapscript.MS_STYLE_BINDING_COLOR, "NEW_BINDING")
-        assert (new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR) == "NEW_BINDING")
-
-    def testAppendNewStyle(self):
-        """a new style can be appended properly"""
-        p_layer = self.map.getLayerByName('POINT')
-        class0 = p_layer.getClass(0)
-        assert class0.numstyles == 2, class0.numstyles
-        new_style = mapscript.styleObj()
-        new_style.color.setRGB(0, 0, 0)
-        new_style.setSymbolByName(self.map, 'circle')
-        new_style.size = 3
-        index = class0.insertStyle(new_style)
-        assert index == 2, index
-        assert class0.numstyles == 3, class0.numstyles
-        msimg = self.map.draw()
-        assert msimg.thisown == 1
-        filename = 'testAppendNewStyle.png'
-        fh = open(filename, 'wb')
-        msimg.write(fh)
-        fh.close()
-
-    def testAppendNewStyleOldWay(self):
-        """NewStylesTestCase.testAppendNewStyleOldWay: a new style can be appended properly using old method"""
-        p_layer = self.map.getLayerByName('POINT')
-        class0 = p_layer.getClass(0)
-        assert class0.numstyles == 2, class0.numstyles
-        new_style = mapscript.styleObj(class0)
-        assert new_style.thisown == 1, new_style.thisown
-        new_style.color.setRGB(0, 0, 0)
-        new_style.symbol = 1
-        new_style.size = 3
-        msimg = self.map.draw()
-        filename = 'testAppendNewStyleOldWay.png'
-        fh = open(filename, 'wb')
-        msimg.write(fh)
-        fh.close()
-
-    def testInsertNewStyleAtIndex0(self):
-        """NewStylesTestCase.testInsertNewStyleAtIndex0: a new style can be inserted ahead of all others"""
-        l_layer = self.map.getLayerByName('LINE')
-        class0 = l_layer.getClass(0)
-        new_style = mapscript.styleObj()
-        new_style.color.setRGB(255, 255, 0)
-        new_style.symbol = 1
-        new_style.size = 7
-        index = class0.insertStyle(new_style, 0)
-        assert index == 0, index
-        assert class0.numstyles == 2, class0.numstyles
-        msimg = self.map.draw()
-        assert msimg.thisown == 1
-        filename = 'testInsertNewStyleAtIndex0.png'
-        fh = open(filename, 'wb')
-        msimg.write(fh)
-        fh.close()
-
-    def testRemovePointStyle(self):
-        """NewStylesTestCase.testRemovePointStyle: a point style can be properly removed"""
-        p_layer = self.map.getLayerByName('POINT')
-        class0 = p_layer.getClass(0)
-        rem_style = class0.removeStyle(1)
-        assert rem_style is not None
-        assert class0.numstyles == 1, class0.numstyles
-        msimg = self.map.draw()
-        filename = 'testRemovePointStyle.png'
-        msimg.save(filename)
-
-    def testModifyMultipleStyle(self):
-        """NewStylesTestCase.testModifyMultipleStyle: multiple styles can be modified"""
-        p_layer = self.map.getLayerByName('POINT')
-        class0 = p_layer.getClass(0)
-        style1 = class0.getStyle(1)
-        style1.color.setRGB(255, 255, 0)
-        msimg = self.map.draw()
-        filename = 'testModifyMutiplePointStyle.png'
-        msimg.save(filename)
-
-    def testInsertStylePastEnd(self):
-        """NewStylesTestCase.testInsertStylePastEnd: inserting a style past the end of
-        the list raises the proper error"""
-        p_layer = self.map.getLayerByName('POINT')
-        class0 = p_layer.getClass(0)
-        new_style = mapscript.styleObj()
-        self.assertRaises(mapscript.MapServerChildError, class0.insertStyle, new_style, 6)
-
-    def testInsertNULLStyle(self):
-        """attempt to insert a NULL style should raise error"""
-        p_layer = self.map.getLayerByName('POINT')
-        class0 = p_layer.getClass(0)
-        self.assertRaises(mapscript.MapServerChildError,
-                          class0.insertStyle, None)
-
-    def testConvertToString(self):
-        """ensure styles can be created and output to strings
-        in a round trip"""
-        input_string = """
-            STYLE
-                SIZE 7.25
-                COLOR 255 0 0
-                OFFSET 10.5 20.75
-            END
-        """
-
-        new_style = mapscript.fromstring(input_string)
-        assert new_style.size == 7.25
-        assert new_style.color.red == 255
-        assert new_style.color.green == 0
-        assert new_style.color.blue == 0
-
-        assert new_style.offsetx == 10.5
-        assert new_style.offsety == 20.75
-
-        output_string = new_style.convertToString()
-        new_style2 = mapscript.fromstring(output_string)
-
-        # ensure attributes are output as doubles
-        assert new_style.size == 7.25
-        assert new_style2.offsetx == 10.5
-        assert new_style2.offsety == 20.75
-
-    def testPattern(self):
-        """See https://github.com/mapserver/mapserver/issues/4943"""
-
-        si = mapscript.styleObj()
-        assert si.pattern == ()
-        assert si.patternlength == 0
-
-    def testPattern2(self):
-
-        si = mapscript.styleObj()
-        si.pattern = [2.0, 3, 4]
-        assert si.pattern == (2.0, 3.0, 4.0)
-        assert si.patternlength == 3
-
-    def testPattern3(self):
-        """a pattern must have at least 2 elements"""
-
-        si = mapscript.styleObj()
-        exception = None
-        try:
-            si.pattern = [1.0]
-        except Exception:
-            exception = True
-        assert exception is True
-
-    def testPattern4(self):
-        """a pattern can have a max of 10 elements
-        This is set in mapsymbol.h with #define MS_MAXPATTERNLENGTH 10"""
-
-        si = mapscript.styleObj()
-        exception = None
-        try:
-            si.pattern = [i for i in range(11)]
-        except Exception:
-            exception = True
-        assert exception is True
-
-    def testPattern5(self):
-        """pattern length is read-only"""
-        si = mapscript.styleObj()
-        exception = None
-        try:
-            si.patternlength = 0
-        except Exception:
-            exception = True
-        assert exception is True
-
-
-class BrushCachingTestCase(MapTestCase):
-
-    def testDrawMapWithSecondPolygon(self):
-        """draw a blue polygon and a red polygon"""
-        p = self.map.getLayerByName('POLYGON')
-        ip = mapscript.layerObj(self.map)
-        ip.type = mapscript.MS_LAYER_POLYGON
-        ip.status = mapscript.MS_DEFAULT
-        c0 = mapscript.classObj(ip)
-
-        # turn off first polygon layer's color
-        p.getClass(0).getStyle(0).color.setRGB(-1, -1, -1)
-
-        # copy this style to inline polygon layer, then change outlinecolor
-        c0.insertStyle(p.getClass(0).getStyle(0))
-        st0 = c0.getStyle(0)
-        st0.outlinecolor.setRGB(255, 0, 0)
-
-        # pull out the first feature from polygon layer, shift it
-        # and use this as an inline feature in new layer
-        p.open()
-        p.template = "FAKE"  # set a template so the layer can be queried
-        p.queryByIndex(self.map, -1, 0, mapscript.MS_TRUE)
-        res = p.getResult(0)
-        s0 = p.getShape(res)
-        p.close()
-        r0 = s0.bounds
-        r1 = mapscript.rectObj(r0.minx-0.1, r0.miny-0.1, r0.maxx-0.1, r0.maxy-0.1)
-        s1 = r1.toPolygon()
-
-        ip.addFeature(s1)
-        img = self.map.draw()
-        img.save('test_drawmapw2ndpolygon.png')
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/symbol_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/symbol_test.py
--- 8.0.1-5/mapscript/python/tests/cases/symbol_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/symbol_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,161 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Symbol
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-from io import BytesIO
-import mapscript
-from .testing import MapTestCase, XMARKS_IMAGE, HOME_IMAGE
-
-
-class SymbolTestCase(unittest.TestCase):
-
-    def testConstructor(self):
-        """create new instance of symbolObj"""
-        symbol = mapscript.symbolObj('test')
-        assert symbol.name == 'test'
-        assert symbol.thisown == 1
-
-    def testConstructorImage(self):
-        """create new instance of symbolObj from an image"""
-        symbol = mapscript.symbolObj('xmarks', XMARKS_IMAGE)
-        assert symbol.name == 'xmarks'
-        assert symbol.type == mapscript.MS_SYMBOL_VECTOR  # was MS_SYMBOL_PIXMAP!
-        format = mapscript.outputFormatObj('AGG/PNG')
-        img = symbol.getImage(format)
-        img.save('sym-%s.%s' % (symbol.name, img.format.extension))
-
-
-class DynamicGraphicSymbolTestCase():
-
-    def setUp(self):
-        MapTestCase.setUp(self)
-        with open(HOME_IMAGE, 'rb') as fh:
-            s = BytesIO(fh.read())
-        symb_img = mapscript.imageObj(s)
-        self.h_symbol = mapscript.symbolObj('house')
-        self.h_symbol.type = mapscript.MS_SYMBOL_PIXMAP
-        self.h_symbol.setImage(symb_img)
-        with open(XMARKS_IMAGE, 'rb') as fh:
-            s = BytesIO(fh.read())
-        symb_img = mapscript.imageObj(s)
-        self.x_symbol = mapscript.symbolObj('xmarks')
-        self.x_symbol.type = mapscript.MS_SYMBOL_PIXMAP
-        self.x_symbol.setImage(symb_img)
-
-    def testSetPCTImage(self):
-        """set image of new symbolObj"""
-        assert self.h_symbol.name == 'house'
-        assert self.h_symbol.type == mapscript.MS_SYMBOL_PIXMAP
-        format = mapscript.outputFormatObj('AGG/PNG')
-        format.transparent = mapscript.MS_ON
-        img = self.h_symbol.getImage(format)
-        img.save('set-%s.%s' % (self.h_symbol.name, img.format.extension))
-
-    def testDrawSetPCTImage(self):
-        """draw a map using the set image symbol"""
-        symbol_index = self.map.symbolset.appendSymbol(self.h_symbol)
-        assert symbol_index == 4, symbol_index
-        num = self.map.symbolset.numsymbols
-        assert num == 5, num
-        inline_layer = self.map.getLayerByName('INLINE')
-        s = inline_layer.getClass(0).getStyle(0)
-        s.symbol = symbol_index
-        s.size = -1  # pixmap's own size
-        img = self.map.draw()
-        img.save('testDrawSetPCTImage.%s' % (img.format.extension))
-
-    def testSetRGBAImage(self):
-        """set image of new symbolObj"""
-        assert self.x_symbol.name == 'xmarks'
-        assert self.x_symbol.type == mapscript.MS_SYMBOL_PIXMAP
-        format = mapscript.outputFormatObj('AGG/PNG')
-        img = self.x_symbol.getImage(format)
-        img.save('set-%s.%s' % (self.x_symbol.name, img.format.extension))
-
-    def testDrawSetRGBAImage(self):
-        """draw a map using the set image symbol"""
-        symbol_index = self.map.symbolset.appendSymbol(self.x_symbol)
-        inline_layer = self.map.getLayerByName('INLINE')
-        s = inline_layer.getClass(0).getStyle(0)
-        s.symbol = symbol_index
-        s.size = -1  # pixmap's own size
-        self.map.selectOutputFormat('PNG24')
-        img = self.map.draw()
-        img.save('testDrawSetRGBAImage.%s' % (img.format.extension))
-
-
-class MapSymbolTestCase(MapTestCase):
-
-    def testGetPoints(self):
-        """get symbol points as line and test coords"""
-        symbol = self.map.symbolset.getSymbol(1)
-        assert symbol.name == 'circle'
-        line = symbol.getPoints()
-        assert line.numpoints == 1, line.numpoints
-        pt = self.getPointFromLine(line, 0)
-        self.assertPointsEqual(pt, mapscript.pointObj(1.0, 1.0))
-
-    def testSetPoints(self):
-        """add lines of points to an existing symbol"""
-        symbol = self.map.symbolset.getSymbol(1)
-        assert symbol.name == 'circle'
-        line = mapscript.lineObj()
-        self.addPointToLine(line, mapscript.pointObj(2.0, 2.0))
-        self.addPointToLine(line, mapscript.pointObj(3.0, 3.0))
-        assert symbol.setPoints(line) == 2
-        assert symbol.numpoints == 2
-        line = symbol.getPoints()
-        assert line.numpoints == 2, line.numpoints
-        pt = self.getPointFromLine(line, 1)
-        self.assertPointsEqual(pt, mapscript.pointObj(3.0, 3.0))
-
-    def testSetStyle(self):
-        """expect success after setting an existing symbol's style"""
-        symbol = self.map.symbolset.getSymbol(1)
-        # default MapScript API setPattern has been extended to allow lists
-        # assert symbol.setPattern(0, 1) == mapscript.MS_SUCCESS
-        symbol.pattern = [0, 1]
-        assert symbol.pattern == [0, 1]
-
-    def testRGBASymbolInPNG24(self):
-        """draw a RGBA PNG pixmap on PNG canvas"""
-        self.map.setImageType('PNG24')
-        # self.map.getLayerByName('INLINE-PIXMAP-RGBA').status \
-        #    == mapscript.MS_DEFAULT
-        img = self.map.draw()
-        img.save('pixmap-rgba-24.png')
-
-    def testRGBASymbolInJPEG(self):
-        """draw a RGBA PNG pixmap on JPEG canvas"""
-        self.map.setImageType('JPEG')
-        # self.map.getLayerByName('INLINE-PIXMAP-RGBA').status \
-        #    == mapscript.MS_DEFAULT
-        img = self.map.draw()
-        img.save('pixmap-rgba.jpg')
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/symbolset_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/symbolset_test.py
--- 8.0.1-5/mapscript/python/tests/cases/symbolset_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/symbolset_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,152 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of SymbolSet
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import os
-import unittest
-import mapscript
-from .testing import MapTestCase, XMARKS_IMAGE, TESTS_PATH
-
-SYMBOLSET = os.path.join(TESTS_PATH, "symbols.txt")
-
-
-class SymbolSetTestCase(unittest.TestCase):
-
-    def testConstructorNoArgs(self):
-        """new instance of symbolSetObj should have one symbol"""
-        symbolset = mapscript.symbolSetObj()
-        num = symbolset.numsymbols
-        assert num == 1, num
-
-    def testConstructorFile(self):
-        """new instance of symbolSetObj from symbols.txt"""
-        symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        num = symbolset.numsymbols
-        assert num == 4, num
-
-    def testAddSymbolToNewSymbolSet(self):
-        """add two new symbols to a SymbolSet"""
-        symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        symbola = mapscript.symbolObj('testa')
-        symbolb = mapscript.symbolObj('testb')
-        symbolset.appendSymbol(symbola)
-        symbolset.appendSymbol(symbolb)
-        num = symbolset.numsymbols
-        assert num == 6, num
-        names = [None, 'circle', 'xmarks-png', 'home-png', 'testa', 'testb']
-        for i in range(symbolset.numsymbols):
-            symbol = symbolset.getSymbol(i)
-            assert symbol.name == names[i], symbol.name
-
-    def testRemoveSymbolFromNewSymbolSet(self):
-        """after removing a symbol, expect numsymbols -= 1"""
-        symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        symbolset.removeSymbol(1)
-        num = symbolset.numsymbols
-        assert num == 3, num
-
-    def testSaveNewSymbolSet(self):
-        """save a new SymbolSet to disk"""
-        symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        symbola = mapscript.symbolObj('testa')
-        symbolb = mapscript.symbolObj('testb')
-        symbolset.appendSymbol(symbola)
-        symbolset.appendSymbol(symbolb)
-        assert symbolset.save('new_symbols.txt') == mapscript.MS_SUCCESS
-
-    def testError(self):
-        symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        symbola = mapscript.symbolObj('testa')
-        symbolb = mapscript.symbolObj('testb')
-        symbolset.appendSymbol(symbola)
-        symbolset.appendSymbol(symbolb)
-        self.assertRaises(mapscript.MapServerError, symbolset.save, '/bogus/new_symbols.txt')
-
-
-class MapSymbolSetTestCase(MapTestCase):
-
-    def testGetNumSymbols(self):
-        """expect getNumSymbols == 2 from test fixture test.map"""
-        num = self.map.getNumSymbols()
-        assert num == 4, num
-
-    def testSymbolSetNumsymbols(self):
-        """expect numsymbols == 2 from test fixture test.map"""
-        num = self.map.symbolset.numsymbols
-        assert num == 4, num
-
-    def testSymbolSetSymbolNames(self):
-        """test names of symbols in test fixture's symbolset"""
-        set = self.map.symbolset
-        names = [None, 'circle', 'xmarks-png', 'home-png']
-        for i in range(set.numsymbols):
-            symbol = set.getSymbol(i)
-            assert symbol.name == names[i], symbol.name
-
-    def testSymbolIndex(self):
-        """expect index of 'circle' symbol to be 1 in test fixture symbolset"""
-        i = self.map.symbolset.index('circle')
-        assert i == 1, i
-
-    def testBug1962(self):
-        """resetting imagepath doesn't cause segfault"""
-        layer = self.map.getLayerByName('POINT')
-        style0 = layer.getClass(0).getStyle(0)
-        sym0 = style0.symbol
-        sym1 = self.map.symbolset.getSymbol(sym0)
-        sym2 = mapscript.symbolObj('xxx')
-        assert sym2 is not None
-        sym1.setImagepath(XMARKS_IMAGE)
-        # self.assertRaises(IOError, sym1.setImagepath, '/bogus/new_symbols.txt')
-
-        msimg = self.map.draw()
-        assert msimg.thisown == 1
-        data = msimg.getBytes()
-        filename = 'testBug1962.png'
-        fh = open(filename, 'wb')
-        fh.write(data)
-        fh.close()
-
-    def testDrawNewSymbol(self):
-        """draw using a new symbol added to the fixture"""
-        symbol = mapscript.symbolObj('xmarks', XMARKS_IMAGE)
-        symbol_index = self.map.symbolset.appendSymbol(symbol)
-        assert symbol_index == 4, symbol_index
-        num = self.map.symbolset.numsymbols
-        assert num == 5, num
-        inline_layer = self.map.getLayerByName('INLINE')
-        s = inline_layer.getClass(0).getStyle(0)
-        s.symbol = symbol_index
-        # s.size = 24
-        msimg = self.map.draw()
-        assert msimg.thisown == 1
-        filename = 'testDrawNewSymbol.png'
-        fh = open(filename, 'wb')
-        msimg.write(fh)
-        fh.close()
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/testing.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/testing.py
--- 8.0.1-5/mapscript/python/tests/cases/testing.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/testing.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,150 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript testing utilities
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-#
-# Purpose of this module is to export the locally built mapscript module
-# prior to installation, do some name normalization that allows testing of
-# the so-called next generation class names, and define some classes
-# useful to many test cases.
-#
-# ===========================================================================
-
-import os
-import unittest
-import tempfile
-import mapscript
-
-# define the path to mapserver test data
-TESTS_PATH = os.path.abspath(os.path.join(os.path.dirname(__file__), "data"))
-TESTMAPFILE = os.path.join(TESTS_PATH, 'test.map')
-TESTCONFIGFILE = os.path.join(TESTS_PATH, 'mapserver-sample.conf')
-XMARKS_IMAGE = os.path.join(TESTS_PATH, 'xmarks.png')
-HOME_IMAGE = os.path.join(TESTS_PATH, 'home.png')
-TEST_IMAGE = os.path.join(TESTS_PATH, 'test.png')
-
-INCOMING = tempfile.mkdtemp(prefix="mapscript")
-
-
-# ==========================================================================
-# Base testing classes
-
-class MapPrimitivesTestCase(unittest.TestCase):
-    """Base class for testing primitives (points, lines, shapes)
-    in stand-alone mode"""
-
-    def addPointToLine(self, line, point):
-        """Using either the standard or next_generation_api"""
-        try:
-            line.add(point)
-        except AttributeError:  # next_generation_api
-            line.addPoint(point)
-        except Exception:
-            raise
-
-    def getPointFromLine(self, line, index):
-        """Using either the standard or next_generation_api"""
-        try:
-            point = line.get(index)
-            return point
-        except AttributeError:  # next_generation_api
-            point = line.getPoint(index)
-            return point
-        except Exception:
-            raise
-
-    def addLineToShape(self, shape, line):
-        """Using either the standard or next_generation_api"""
-        try:
-            shape.add(line)
-        except AttributeError:  # next_generation_api
-            shape.addLine(line)
-        except Exception:
-            raise
-
-    def getLineFromShape(self, shape, index):
-        """Using either the standard or next_generation_api"""
-        try:
-            line = shape.get(index)
-            return line
-        except AttributeError:  # next_generation_api
-            line = shape.getLine(index)
-            return line
-        except Exception:
-            raise
-
-    def assertPointsEqual(self, first, second):
-        self.assertAlmostEqual(first.x, second.x)
-        self.assertAlmostEqual(first.y, second.y)
-
-    def assertLinesEqual(self, first, second):
-        assert first.numpoints == second.numpoints
-        for i in range(first.numpoints):
-            point_first = self.getPointFromLine(first, i)
-            point_second = self.getPointFromLine(second, i)
-            self.assertPointsEqual(point_first, point_second)
-
-    def assertShapesEqual(self, first, second):
-        assert first.numlines == second.numlines
-        for i in range(first.numlines):
-            line_first = self.getLineFromShape(first, i)
-            line_second = self.getLineFromShape(second, i)
-            self.assertLinesEqual(line_first, line_second)
-
-    def assertRectsEqual(self, first, second):
-        self.assertAlmostEqual(first.minx, second.minx)
-        self.assertAlmostEqual(first.miny, second.miny)
-        self.assertAlmostEqual(first.maxx, second.maxx)
-        self.assertAlmostEqual(first.maxy, second.maxy)
-
-
-class MapTestCase(MapPrimitivesTestCase):
-    """Base class for testing with a map fixture"""
-    def setUp(self):
-        self.map = mapscript.mapObj(TESTMAPFILE)
-        # self.xmarks_image = xmarks_image
-        # self.test_image = test_image
-
-    def tearDown(self):
-        self.map = None
-
-
-class MapZoomTestCase(MapPrimitivesTestCase):
-    "Testing new zoom* methods that we are adapting from the PHP MapScript"
-    def setUp(self):
-        self.mapobj1 = mapscript.mapObj(TESTMAPFILE)
-        # Change the extent for purposes of zoom testing
-        rect = mapscript.rectObj()
-        rect.minx, rect.miny, rect.maxx, rect.maxy = (-50.0, -50.0, 50.0, 50.0)
-        self.mapobj1.extent = rect
-        # Change height/width as well
-        self.mapobj1.width, self.mapobj1.height = (100, 100)
-
-    def tearDown(self):
-        self.mapobj1 = None
-
-
-class ShapeObjTestCase(MapPrimitivesTestCase):
-    """Base class for shapeObj tests"""
-    pass
diff -pruN 8.0.1-5/mapscript/python/tests/cases/thread_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/thread_test.py
--- 8.0.1-5/mapscript/python/tests/cases/thread_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/thread_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,195 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript test of multi-threading
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import os
-import unittest
-import threading
-import mapscript
-from .testing import TESTMAPFILE, INCOMING
-
-
-def draw_map(name, save=0):
-
-    # print("making map in thread %s" % (name))
-    mo = mapscript.mapObj(TESTMAPFILE)
-    im = mo.draw()
-    if save:
-        im.save('threadtest_%s.png' % (name))
-
-
-def trigger_exception(name):
-
-    # print("triggering exception in thread %s" % (name))
-    mo = mapscript.mapObj(TESTMAPFILE)
-    try:
-        mo.setExtent(1, 50, -1, 51)
-        raise Exception("We expected a MapServer exception")
-    except mapscript.MapServerError:
-        pass
-
-
-class MultipleThreadsTestCase(unittest.TestCase):
-
-    def testDrawMultiThreads(self):
-        """map drawing with multiple threads"""
-
-        workers = []
-        for i in range(10):
-            name = 'd%d' % (i)
-            thread = threading.Thread(target=draw_map, name=name, args=(name, 1))
-            workers.append(thread)
-            thread.start()
-
-    def testExceptionsMultiThreads(self):
-        """mapserver exceptions behave with multiple threads"""
-
-        workers = []
-        for i in range(10):
-            name = 'e%d' % (i)
-            thread = threading.Thread(target=trigger_exception, name=name, args=(name,))
-            workers.append(thread)
-            thread.start()
-
-    def testExceptionContainmentMultiThreads(self):
-        """mapserver exceptions should be contained to a thread"""
-        num = 100
-        workers = []
-
-        # Trigger an exception in the first started thread
-        for i in range(0, 1):
-            name = 'c%d' % (i)
-            thread = threading.Thread(target=trigger_exception, name=name, args=(name,))
-            workers.append(thread)
-
-        # Draw normally
-        for i in range(1, num):
-            name = 'c%d' % (i)
-            thread = threading.Thread(target=draw_map, name=name, args=(name,))
-            workers.append(thread)
-
-        # Start all threads
-        for i in range(num):
-            workers[i].start()
-
-
-def draw_map_wfs(name, save=0):
-
-    # print("making map in thread %s" % (name))
-    mo = mapscript.mapObj(TESTMAPFILE)
-
-    # WFS layer
-    lo = mapscript.layerObj()
-    lo.name = 'cheapo_wfs'
-    lo.setProjection('+init=epsg:4326')
-    lo.connectiontype = mapscript.MS_WFS
-    lo.connection = 'http://zcologia.com:9001/mapserver/members/features.rpy?'
-    lo.metadata.set('wfs_service', 'WFS')
-    lo.metadata.set('wfs_typename', 'users')
-    lo.metadata.set('wfs_version', '1.0.0')
-    lo.type = mapscript.MS_LAYER_POINT
-    lo.status = mapscript.MS_DEFAULT
-    lo.labelitem = 'zco:mid'
-
-    so1 = mapscript.styleObj()
-    so1.color.setHex('#FFFFFF')
-    so1.size = 9
-    so1.symbol = 1  # mo.symbolset.index('circle')
-
-    so2 = mapscript.styleObj()
-    so2.color.setHex('#333333')
-    so2.size = 7
-    so2.symbol = 1  # mo.symbolset.index('circle')
-
-    co = mapscript.classObj()
-    co.label.type = mapscript.MS_BITMAP
-    co.label.size = mapscript.MS_SMALL
-    co.label.color.setHex('#000000')
-    co.label.outlinecolor.setHex('#FFFFFF')
-    co.label.position = mapscript.MS_AUTO
-
-    co.insertStyle(so1)
-    co.insertStyle(so2)
-    lo.insertClass(co)
-    mo.insertLayer(lo)
-
-    if not mo.web.imagepath:
-        mo.web.imagepath = os.environ.get('TEMP', None) or INCOMING
-    mo.debug = mapscript.MS_ON
-    im = mo.draw()
-    if save:
-        im.save('threadtest_wfs_%s.png' % (name))
-
-
-def draw_map_wms(name, save=0):
-
-    # print("making map in thread %s" % (name))
-    mo = mapscript.mapObj(TESTMAPFILE)
-    # WFS layer
-    lo = mapscript.layerObj()
-    lo.name = 'jpl_wms'
-    lo.setProjection('+init=epsg:4326')
-    lo.connectiontype = mapscript.MS_WMS
-    lo.connection = 'http://vmap0.tiles.osgeo.org/wms/vmap0?'
-    lo.metadata.set('wms_service', 'WMS')
-    lo.metadata.set('wms_server_version', '1.1.1')
-    lo.metadata.set('wms_name', 'basic')
-    lo.metadata.set('wms_style', 'visual')
-    lo.metadata.set('wms_format', 'image/jpeg')
-    lo.type = mapscript.MS_LAYER_RASTER
-    lo.status = mapscript.MS_DEFAULT
-    lo.debug = mapscript.MS_ON
-    mo.insertLayer(lo)
-
-    if not mo.web.imagepath:
-        mo.web.imagepath = os.environ.get('TEMP', None) or INCOMING
-    mo.debug = mapscript.MS_ON
-    mo.selectOutputFormat('image/jpeg')
-    im = mo.draw()
-    if save:
-        im.save('threadtest_wms_%s.jpg' % (name))
-
-
-class OWSRequestTestCase(unittest.TestCase):
-
-    # def testDrawWFS(self):
-    #    workers = []
-    #    for i in range(10):
-    #        name = 'd%d' % (i)
-    #        thread = threading.Thread(target=draw_map_wfs, name=name, args=(name, 1))
-    #        workers.append(thread)
-    #        thread.start()
-
-    def testDrawWMS(self):
-        workers = []
-        for i in range(10):
-            name = 'd%d' % (i)
-            thread = threading.Thread(target=draw_map_wms, name=name, args=(name, 1))
-            workers.append(thread)
-            thread.start()
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/zoom_test.py 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/zoom_test.py
--- 8.0.1-5/mapscript/python/tests/cases/zoom_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/cases/zoom_test.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,180 +0,0 @@
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript tests of Map "zooming"
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-#
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-
-import unittest
-import mapscript
-from .testing import MapZoomTestCase
-
-
-class ZoomPointTestCase(MapZoomTestCase):
-
-    def testRecenter(self):
-        """ZoomPointTestCase.testRecenter: recentering the map with a point returns the same extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        p = mapscript.pointObj(50.0, 50.0)
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomPoint(1, p, w, h, extent, None)
-        new_extent = self.mapobj1.extent
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-50, -50, 50, 50))
-
-    def testZoomInPoint(self):
-        """ZoomPointTestCase.testZoomInPoint: zooming in by a power of 2 returns the proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        p = mapscript.pointObj(50.0, 50.0)
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomPoint(2, p, w, h, extent, None)
-        new_extent = self.mapobj1.extent
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-25, -25, 25, 25))
-
-    def testZoomOutPoint(self):
-        """ZoomPointTestCase.testZoomOutPoint: zooming out by a power of 2 returns the proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomPoint(-2, p, w, h, extent, None)
-        new_extent = self.mapobj1.extent
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-100, -100, 100, 100))
-
-    def testZoomOutPointConstrained(self):
-        """ZoomPointTestCase.testZoomOutPointConstrained: zooming out to a constrained extent returns proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        max = mapscript.rectObj()
-        max.minx, max.miny, max.maxx, max.maxy = (-100.0, -100.0, 100.0, 100.0)
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomPoint(-4, p, w, h, extent, max)
-        new_extent = self.mapobj1.extent
-        self.assertRectsEqual(new_extent, max)
-
-    def testZoomBadSize(self):
-        """ZoomPointTestCase.testZoomBadSize: zooming to a bad size raises proper error"""
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        extent = self.mapobj1.extent
-        w = 0
-        h = -1
-        self.assertRaises(mapscript.MapServerError,
-                          self.mapobj1.zoomPoint, -2, p, w, h, extent, None)
-
-    def testZoomBadExtent(self):
-        """ZoomPointTestCase.testZoomBadExtent: zooming to a bad extent raises proper error"""
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        extent = self.mapobj1.extent
-        extent.maxx = extent.maxx - 1000000
-        w = 100
-        h = 100
-        self.assertRaises(mapscript.MapServerError,
-                          self.mapobj1.zoomPoint, -2, p, w, h, extent, None)
-
-
-class ZoomRectangleTestCase(MapZoomTestCase):
-
-    def testZoomRectangle(self):
-        """ZoomRectangleTestCase.testZoomRectangle: zooming to an extent returns proper map extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        r = mapscript.rectObj(1, 26, 26, 1, 1)
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomRectangle(r, w, h, extent, None)
-        new_extent = self.mapobj1.extent
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-49, 24, -24, 49))
-
-    def testZoomRectangleConstrained(self):
-        """ZoomRectangleTestCase.testZoomRectangleConstrained: zooming to a constrained extent returns proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        max = mapscript.rectObj(-100.0, -100.0, 100.0, 100.0)
-        r = mapscript.rectObj(0, 200, 200, 0, 1)
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomRectangle(r, w, h, extent, max)
-        new_extent = self.mapobj1.extent
-        self.assertRectsEqual(new_extent, max)
-
-    def testZoomRectangleBadly(self):
-        """zooming into an invalid extent raises proper error"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        r = mapscript.rectObj(0, 0, 200, 200)
-        extent = self.mapobj1.extent
-        self.assertRaises(mapscript.MapServerError,
-                          self.mapobj1.zoomRectangle, r, w, h, extent, None)
-
-
-class ZoomScaleTestCase(MapZoomTestCase):
-
-    def testRecenter(self):
-        """ZoomScaleTestCase.testRecenter: recentering map returns proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)  # 100 by 100
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        scale = 2834.6472
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomScale(scale, p, w, h, extent, None)
-        assert self.mapobj1.scaledenom == scale
-        new_extent = self.mapobj1.extent
-        # self.assertRectsEqual(new_extent, mapscript.rectObj(-50, -50, 50, 50))  # old values
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-49.5, -49.5, 49.5, 49.5))
-
-    def testZoomInScale(self):
-        """ZoomScaleTestCase.testZoomInScale: zooming in to a specified scale returns proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        scale = 1417.3236
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomScale(scale, p, w, h, extent, None)
-        new_extent = self.mapobj1.extent
-        # self.assertRectsEqual(new_extent, mapscript.rectObj(-25, -25, 25, 25))  # old values
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-24.75, -24.75, 24.75, 24.75))
-
-    def testZoomOutScale(self):
-        """ZoomScaleTestCase.testZoomOutScale: zooming out to a specified scale returns proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        scale = 5669.2944
-        extent = self.mapobj1.extent
-        self.mapobj1.zoomScale(scale, p, w, h, extent, None)
-        new_extent = self.mapobj1.extent
-        # self.assertRectsEqual(new_extent, mapscript.rectObj(-100, -100, 100, 100))  # old values
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-99, -99, 99, 99))
-
-    def testZoomOutPointConstrained(self):
-        """ZoomScaleTestCase.testZoomOutPointConstrained: zooming out to a constrained extent returns proper extent"""
-        w, h = (self.mapobj1.width, self.mapobj1.height)
-        max = mapscript.rectObj()
-        max.minx, max.miny, max.maxx, max.maxy = (-100.0, -100.0, 100.0, 100.0)
-        p = mapscript.pointObj()
-        p.x, p.y = (50, 50)
-        extent = self.mapobj1.extent
-        scale = 10000
-        self.mapobj1.zoomScale(scale, p, w, h, extent, max)
-        new_extent = self.mapobj1.extent
-        self.assertRectsEqual(new_extent, max)
-
-
-if __name__ == '__main__':
-    unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/fragments.txt 8.2.0~beta1-1~exp1/mapscript/python/tests/fragments.txt
--- 8.0.1-5/mapscript/python/tests/fragments.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/fragments.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,95 +0,0 @@
-Functional tests of mapfile fragment loading
-============================================
-
-Setup
------
-
-Use pkg_resources to maintain sanity with setuptools develop builds
-
-  >>> try:
-  ...     import pkg_resources
-  ...     msg = pkg_resources.require('mapscript')
-  ... except:
-  ...     pass
-
-Loading a MAP string
---------------------
-
-Empty map
-
-  >>> import mapscript
-  >>> mo = mapscript.fromstring("""MAP\nNAME "test"\nEND""")
-  >>> mo # doctest: +ELLIPSIS
-  <mapscript.mapObj; proxy of C mapObj instance at ...>
-  >>> mo.name
-  'test'
-
-  >>> del mo
-
-With map path
-
-  Read in the standard mapserver fixture, and verify quickly
-  
-  >>> import os
-  >>> mapfile = os.path.abspath('../../../tests/test.map')
-  >>> maproot = os.path.abspath("%s/.." % mapfile)
-  >>> f = file(mapfile, 'rb')
-  >>> mapstring = f.read()
-  >>> f.close()
-  >>> mapstring.startswith('MAP')
-  True
-
-  >>> mo = mapscript.fromstring(mapstring, maproot)
-  >>> mo # doctest: +ELLIPSIS
-  <mapscript.mapObj; proxy of C mapObj instance at ...>
-  >>> mo.name
-  'Testing'
-  >>> mo.numlayers
-  7
-
-  # Delete so next tests get a clean slate
-  >>> del mo
-
-Without map map
-
-  Massage the mapfile to use absolute paths to resources
-
-  >>> absmapstr = mapstring.replace('FONTSET "', 'FONTSET "%s/' % maproot)
-  >>> absmapstr = absmapstr.replace('SYMBOLSET "', 'SYMBOLSET "%s/' % maproot)
-  >>> absmapstr = absmapstr.replace('DATA "', 'DATA "%s/' % maproot)
-
-  >>> mo = mapscript.fromstring(absmapstr)
-  >>> mo # doctest: +ELLIPSIS
-  <mapscript.mapObj; proxy of C mapObj instance at ...>
-  >>> mo.name
-  'Testing'
-  >>> mo.numlayers
-  7
-
-Layers
-------
-
-  >>> lo = mapscript.fromstring("""LAYER NAME "test" TYPE POINT END""")
-  >>> lo #doctest: +ELLIPSIS
-  <mapscript.layerObj; proxy of C layerObj instance at ...>
-  >>> lo.name
-  'test'
-  >>> lo.type == mapscript.MS_LAYER_POINT
-  True
-
-Classes
--------
-
-  >>> co = mapscript.fromstring("""CLASS TITLE "test" END""")
-  >>> co #doctest: +ELLIPSIS
-  <mapscript.classObj; proxy of C classObj instance at ...>
-  >>> co.title
-  'test'
-
-Styles
-------
-
-  >>> so = mapscript.fromstring("""STYLE END""")
-  >>> so #doctest: +ELLIPSIS
-  <mapscript.styleObj; proxy of C styleObj instance at ...>
-
diff -pruN 8.0.1-5/mapscript/python/tests/runalldoctests.py 8.2.0~beta1-1~exp1/mapscript/python/tests/runalldoctests.py
--- 8.0.1-5/mapscript/python/tests/runalldoctests.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/runalldoctests.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-import doctest
-import getopt
-import glob
-import sys
-
-try:
-    import pkg_resources
-    pkg_resources.require('mapscript')
-except (ImportError, pkg_resources.DistributionNotFound):
-    pass
-
-def run(pattern):
-    if pattern is None:
-        testfiles = glob.glob('*.txt')
-    else:
-        testfiles = glob.glob(pattern)
-    for file in testfiles: 
-        doctest.testfile(file)
-
-if __name__ == "__main__":
-    try:
-        opts, args = getopt.getopt(sys.argv[1:], "t:v")
-    except getopt.GetoptError:
-        print("Usage: python runalldoctests.py [-t GLOB_PATTERN]")
-        sys.exit(2)
-    pattern = None
-    for o, a in opts:
-        if o == '-t':
-            pattern = a
-    run(pattern)
-
diff -pruN 8.0.1-5/mapscript/python/tests/rundoctests.dist 8.2.0~beta1-1~exp1/mapscript/python/tests/rundoctests.dist
--- 8.0.1-5/mapscript/python/tests/rundoctests.dist	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/rundoctests.dist	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-#!/bin/sh
-#export PYTHONPATH="YOUR_DEV_PYTHON_PATH"
-python runalldoctests.py
-
diff -pruN 8.0.1-5/mapscript/python/tests/runtests.py 8.2.0~beta1-1~exp1/mapscript/python/tests/runtests.py
--- 8.0.1-5/mapscript/python/tests/runtests.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/runtests.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,148 +0,0 @@
-# $Id$
-#
-# Project:  MapServer
-# Purpose:  Comprehensive xUnit style Python mapscript test suite
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-# 
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-#
-# Execute this module as a script from mapserver/mapscript/python
-#
-#     python tests/runtests.py -v
-#
-# ===========================================================================
-
-import unittest
-
-# Import test cases
-import cases
-
-from cases.recttest import RectObjTestCase
-
-from cases.hashtest import HashTableTestCase, WebMetadataTestCase
-from cases.hashtest import LayerMetadataTestCase, ClassMetadataTestCase
-
-from cases.owstest import OWSRequestTestCase
-from cases.clonetest import MapCloningTestCase
-
-from cases.imagetest import ImageObjTestCase, ImageWriteTestCase
-
-from cases.maptest import MapConstructorTestCase
-from cases.maptest import MapLayersTestCase
-from cases.maptest import MapExtentTestCase
-from cases.maptest import MapExceptionTestCase
-from cases.maptest import EmptyMapExceptionTestCase
-from cases.maptest import MapSizeTestCase
-
-from cases.layertest import LayerConstructorTestCase
-from cases.layertest import LayerExtentTestCase
-from cases.layertest import LayerRasterProcessingTestCase
-from cases.layertest import LayerTestCase
-from cases.layertest import RemoveLayerTestCase
-
-from cases.zoomtest import ZoomPointTestCase
-from cases.zoomtest import ZoomRectangleTestCase
-from cases.zoomtest import ZoomScaleTestCase
-
-from cases.linetest import LineObjTestCase
-from cases.shapetest import ShapePointTestCase
-from cases.pointtest import PointObjTestCase
-from cases.shapetest import InlineFeatureTestCase
-
-from cases.styletest import DrawProgrammedStylesTestCase
-from cases.styletest import NewStylesTestCase
-from cases.styletest import BrushCachingTestCase
-from cases.colortest import ColorObjTestCase
-
-from cases.symboltest import SymbolTestCase
-from cases.symboltest import MapSymbolTestCase
-
-from cases.symbolsettest import SymbolSetTestCase
-from cases.symbolsettest import MapSymbolSetTestCase
-
-from cases.outputformattest import OutputFormatTestCase
-from cases.outputformattest import MapOutputFormatTestCase
-
-from cases.labeltest import LabelCacheMemberTestCase
-
-from cases.resultcachetest import ResultCacheTestCase
-from cases.resultcachetest import PointQueryResultsTestCase
-from cases.resultcachetest import DumpAndLoadTestCase
-
-# Create a test suite
-suite = unittest.TestSuite()
-
-# Add tests to the suite
-suite.addTests([RectObjTestCase()])
-
-suite.addTests([HashTableTestCase(), WebMetadataTestCase(),
-                LayerMetadataTestCase(), ClassMetadataTestCase()])
-
-suite.addTests([MapCloningTestCase()])
-suite.addTests([OWSRequestTestCase()])
-
-suite.addTests([ImageObjTestCase(), ImageWriteTestCase()])
-
-suite.addTests([MapConstructorTestCase(),
-                MapLayersTestCase(),
-                MapExtentTestCase(),
-                MapExceptionTestCase(),
-                EmptyMapExceptionTestCase()])
-
-suite.addTests([LayerConstructorTestCase(),
-                LayerExtentTestCase(),
-                LayerRasterProcessingTestCase(),
-                RemoveLayerTestCase()])
-
-suite.addTests([LineObjTestCase(),
-                ShapePointTestCase(),
-                PointObjTestCase(),
-                InlineFeatureTestCase()])
-
-
-suite.addTests([DrawProgrammedStylesTestCase(),
-                NewStylesTestCase(), BrushCachingTestCase(),
-                ColorObjTestCase()])
-                
-suite.addTests([SymbolTestCase(),
-                MapSymbolTestCase()])
-
-suite.addTests([SymbolSetTestCase(),
-                MapSymbolSetTestCase()])
-
-suite.addTests([ZoomPointTestCase(),
-                ZoomRectangleTestCase(),
-                ZoomScaleTestCase()])
-                
-suite.addTests([OutputFormatTestCase(), MapOutputFormatTestCase()])
-
-suite.addTest(LabelCacheMemberTestCase())
-
-suite.addTests([ResultCacheTestCase(), PointQueryResultsTestCase(),
-                DumpAndLoadTestCase()])
-
-# ============================================================================
-# If module is run as a script, execute every test case in the suite
-if __name__ == '__main__':
-    unittest.main()
-
diff -pruN 8.0.1-5/mapscript/python/tests/timing/clonemaps.py 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/clonemaps.py
--- 8.0.1-5/mapscript/python/tests/timing/clonemaps.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/clonemaps.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,67 +0,0 @@
-# $Id$
-#
-# Timing tests of mapfile parsing vs map cloning
-
-import os
-from shutil import copyfile
-import timeit
-from .testing import TESTMAPFILE, mapscript
-
-# ===========================================================================
-# Test 1A: New maps from mapfile
-#
-# reloading the mapfile each time
-
-print("Test 1A: reloading maps from mapfile")
-s = """\
-m = mapscript.mapObj(TESTMAPFILE)
-"""
-t = timeit.Timer(stmt=s, setup='from __main__ import mapscript, TESTMAPFILE')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
-# ===========================================================================
-# Test 1B: Cloning
-#
-# Cloning instead of reloading
-
-print("Test 1B: cloning maps instead of reloading")
-m = mapscript.mapObj(TESTMAPFILE)
-s = """\
-c = m.clone()
-"""
-t = timeit.Timer(stmt=s, setup='from __main__ import m')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
-# ===========================================================================
-# Test 2: Add 20 dups of the POLYGON layer to see how results scale
-
-timing_map = mapscript.mapObj(TESTMAPFILE)
-polygon_layer = timing_map.getLayerByName('POLYGON')
-
-# duplicate POLYGON layer 20 times
-for i in range(20):
-    timing_map.insertLayer(polygon_layer)
-assert timing_map.numlayers == 24
-
-TIMINGMAPFILE = os.path.join(os.getcwd(), 'timing.map')
-timing_map.save(TIMINGMAPFILE)
-copyfile('../../tests/fonts.txt', os.path.join(os.getcwd(), 'fonts.txt'))
-copyfile('../../tests/symbols.txt', os.path.join(os.getcwd(), 'symbols.txt'))
-
-# Test 2A: reloading mapfile
-print("Test 2A: reloading inflated mapfile")
-s = """\
-m = mapscript.mapObj(TIMINGMAPFILE)
-"""
-t = timeit.Timer(stmt=s, setup='from __main__ import mapscript, TIMINGMAPFILE')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
-print("Test 2B: cloning inflated mapfile")
-m = mapscript.mapObj(TIMINGMAPFILE)
-s = """\
-c = m.clone()
-"""
-t = timeit.Timer(stmt=s, setup='from __main__ import m')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
-
diff -pruN 8.0.1-5/mapscript/python/tests/timing/drawshapes.py 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/drawshapes.py
--- 8.0.1-5/mapscript/python/tests/timing/drawshapes.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/drawshapes.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,113 +0,0 @@
-# $Id$
-#
-# Timing tests of feature drawing -- map.draw vs drawing features
-# shape by shape.
-
-import getopt
-import os
-import sys
-import timeit
-from random import random
-from .testing import mapscript
-
-# Get Number of shapes from the command line
-try:
-    opts, args = getopt.getopt(sys.argv[1:], 'n:')
-except getopt.GetoptError:
-    sys.exit(2)
-
-numshapes = 100 # default to 100
-for o, a in opts:
-    if o == '-n':
-        numshapes = int(a)
-
-# The shapefileObj
-shpfile = mapscript.shapefileObj('timing.shp', mapscript.MS_SHAPEFILE_POLYGON)
-
-# Inline feature layer
-ilayer = mapscript.layerObj()
-ilayer.type = mapscript.MS_LAYER_POLYGON
-ilayer.setProjection('init=epsg:4326')
-ilayer.status = mapscript.MS_DEFAULT
-ilayer.connectiontype = mapscript.MS_INLINE
-
-print(numshapes, "shapes")
-
-i = 0
-while i < numshapes:
-    # The shape to add is randomly generated
-    xc = 4.0*(random() - 0.5)
-    yc = 4.0*(random() - 0.5)
-    r = mapscript.rectObj(xc-0.25, yc-0.25, xc+0.25, yc+0.25)
-    s = r.toPolygon()
-
-    # Add to shapefile
-    shpfile.add(s)
-
-    # Add to inline feature layer
-    ilayer.addFeature(s)
-    
-    i = i + 1
-
-del shpfile # closes up the file
-
-# Prepare the testing fixture
-m = mapscript.mapObj('timing.map')
-l = m.getLayerByName('POLYGON')
-l.data = os.path.join(os.getcwd(), 'timing')
-
-# Save three map images to check afterwards
-img = m.draw()
-img.save('timing.png')
-
-shpfile = mapscript.shapefileObj('timing.shp')
-img = m.prepareImage()
-for i in range(shpfile.numshapes):
-    s = shpfile.getShape(i)
-    s.classindex = 0
-    s.draw(m, l, img)
-img.save('timing-shapes.png')
-
-class0 = mapscript.classObj(ilayer)
-class0.insertStyle(l.getClass(0).getStyle(0))
-img = m.prepareImage()
-ilayer.draw(m, img)
-img.save('timing-inline.png')
-
-# =========================================================================
-# Test 1A: Draw all shapes at once using map.draw()
-
-print("Test 1A: draw map, all shapes at once")
-s = """\
-img = m.draw()
-"""
-t = timeit.Timer(stmt=s, setup='from __main__ import m')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
-
-# =========================================================================
-# Test 1B: Draw shape by shape from the shapefileObj
-
-print("Test 1B: draw shapes one at a time")
-s = """\
-img = m.prepareImage()
-for i in range(shpfile.numshapes):
-    s = shpfile.getShape(i)
-    s.classindex = 0
-    s.draw(m, l, img)
-"""
-t = timeit.Timer(stmt=s, setup='from __main__ import m, l, shpfile')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
-
-# =========================================================================
-# Test 1C: Draw shapes after pushing them into an inline layer
-
-print("Test 1C: draw inline layer shapes")
-s = """\
-img = m.prepareImage()
-ilayer.draw(m, img)
-"""
-t = timeit.Timer(stmt=s, setup='from __main__ import m, ilayer')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
diff -pruN 8.0.1-5/mapscript/python/tests/timing/testing.py 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/testing.py
--- 8.0.1-5/mapscript/python/tests/timing/testing.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/testing.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,75 +0,0 @@
-# $Id$
-#
-# Project:  MapServer
-# Purpose:  xUnit style Python mapscript testing utilities
-# Author:   Sean Gillies, sgillies@frii.com
-#
-# ===========================================================================
-# Copyright (c) 2004, Sean Gillies
-# 
-# Permission is hereby granted, free of charge, to any person obtaining a
-# copy of this software and associated documentation files (the "Software"),
-# to deal in the Software without restriction, including without limitation
-# the rights to use, copy, modify, merge, publish, distribute, sublicense,
-# and/or sell copies of the Software, and to permit persons to whom the
-# Software is furnished to do so, subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be included
-# in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-# DEALINGS IN THE SOFTWARE.
-# ===========================================================================
-#
-# Purpose of this module is to export the locally built mapscript module
-# prior to installation, do some name normalization that allows testing of
-# the so-called next generation class names, and define some classes 
-# useful to many test cases.
-#
-# All test case modules should import mapscript from testing
-#
-#     from .testing import mapscript
-#
-# ===========================================================================
-
-import os
-import sys
-import sysconfig
-import unittest
-
-# define the path to mapserver test data
-TESTS_PATH = '../../tests'
-
-TESTMAPFILE = os.path.join(TESTS_PATH, 'test.map')
-XMARKS_IMAGE = os.path.join(TESTS_PATH, 'xmarks.png')
-TEST_IMAGE = os.path.join(TESTS_PATH, 'test.png')
-
-# Put local build directory on head of python path
-platformdir = '-'.join((sysconfig.get_platform(), 
-                        '.'.join(map(str, sys.version_info[0:2]))))
-sys.path.insert(0, os.path.join('build', 'lib.' + platformdir))
-
-# import mapscript from the local build directory
-import mapscript
-
-# normalize names, allows testing of module that uses the experimental
-# next generation names
-classnames = [ 'mapObj', 'layerObj', 'classObj', 'styleObj', 'shapeObj',
-            'lineObj', 'pointObj', 'rectObj', 'outputFormatObj', 'symbolObj',
-            'symbolSetObj', 'colorObj', 'imageObj', 'shapefileObj',
-            'projectionObj', 'fontSetObj', 'hashTableObj' ]
-
-for name in classnames:
-    try:
-        new_name = name.replace('Obj', '')
-        new_name = new_name.capitalize()
-        new_object = getattr(mapscript, new_name)
-        setattr(mapscript, name, new_object)
-    except AttributeError:
-        pass
-
diff -pruN 8.0.1-5/mapscript/python/tests/timing/timing.map 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/timing.map
--- 8.0.1-5/mapscript/python/tests/timing/timing.map	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/python/tests/timing/timing.map	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
-MAP
-  NAME "Testing"
-  EXTENT -2 -2 2 2
-  IMAGETYPE PNG
-  IMAGECOLOR 254 254 254
-  STATUS ON
-  SIZE 800 800
-
-  PROJECTION
-    "init=epsg:4326"
-  END
-  
-  SYMBOL
-    TYPE PIXMAP
-    NAME 'home-png'
-    IMAGE '../../../../tests/home.png'
-  END
-
-  SYMBOL
-    TYPE PIXMAP
-    NAME 'xmarks-png'
-    IMAGE '../../../../tests/xmarks.png'
-  END
-  
-  LAYER
-    NAME "POLYGON"
-    TYPE POLYGON
-    PROJECTION
-      "init=epsg:4326"
-    END
-    STATUS DEFAULT
-    DATA "timing.shp"
-    CLASS
-      STYLE
-        COLOR 0 0 204
-        #OUTLINECOLOR 0 0 204
-      END
-    END
-  END
-
-  LAYER
-    NAME "POINT"
-    TYPE POINT
-    PROJECTION
-      "init=epsg:4326"
-    END
-    STATUS OFF
-    CLASS
-      STYLE
-        SYMBOL 2
-      END
-    END
-  END
-
-END
diff -pruN 8.0.1-5/mapscript/ruby/CMakeLists.txt 8.2.0~beta1-1~exp1/mapscript/ruby/CMakeLists.txt
--- 8.0.1-5/mapscript/ruby/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/ruby/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,26 +0,0 @@
-find_package(SWIG REQUIRED)
-include(${SWIG_USE_FILE})
-find_package(Ruby REQUIRED)
-include_directories(${RUBY_INCLUDE_DIRS})
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
-include_directories(${PROJECT_SOURCE_DIR}/mapscript/ruby)
-
-if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
-    swig_add_library(rubymapscript TYPE MODULE LANGUAGE ruby SOURCES ../mapscript.i)
-else ()
-    swig_add_module(rubymapscript ruby ../mapscript.i)
-endif ()
-
-swig_link_libraries(rubymapscript ${RUBY_LIBRARY} ${MAPSERVER_LIBMAPSERVER})
-
-set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES PREFIX "")
-set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES OUTPUT_NAME mapscript)
-
-if(APPLE)
-    set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES SUFFIX ".bundle")
-endif(APPLE)
-
-set(mapscript_files $<TARGET_FILE:${SWIG_MODULE_rubymapscript_REAL_NAME}>)
-execute_process(COMMAND ${RUBY_EXECUTABLE} -r rbconfig -e "puts RbConfig::CONFIG['sitearchdir']" OUTPUT_VARIABLE RUBY_SITEARCHDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
-install(FILES ${mapscript_files} DESTINATION ${RUBY_SITEARCHDIR})
diff -pruN 8.0.1-5/mapscript/ruby/README 8.2.0~beta1-1~exp1/mapscript/ruby/README
--- 8.0.1-5/mapscript/ruby/README	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/ruby/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,62 +0,0 @@
-Ruby MapScript Interface
-------------------------
-
-BUILD
------
-
-The files that are required to create the library 'mapscript.so' : 
- mapscript.i 
- extconf.rb
-
-Be sure that you have installed SWIG version 1.3a5 or greater.
-The installation is tested with ruby version 1.6 and 1.8.
-
-To build type :
-
-# ruby extconf.rb
-# make
-
-
-INSTALL
--------
-
-If you don't want to install the library, you have to add the library
-path as argument to the command (ruby -I[path/to/the/library] ...).
-
-To install type as 'root' user : 
-
-# make install
-
-
-EXAMPLES
---------
-
-To run the examples:
-Go to the directory of the examples
-
-# cd examples
-
-
-Run the example to receive information about a shape file
-
-# ruby shpinfo.rb [path/shapefile.shp]
-or if you don't have executed 'make install'
-# ruby -I[path/to/mapscript.so] shpinfo.rb [path/shapefile.shp]
-
-e.g.: # ruby -I.. shpinfo.rb lake2spy.shp
-
-Run the example to create a PNG file from a shape file. The output
-will be in the file [shapefile].png.
-
-# ruby shp2img.rb [path/shapefile.shp]
-or
-# ruby -I[path/to/mapscript.so] shp2img.rb [path/shapefile.shp]
-e.g.: # ruby -I.. shp2img.rb lake2spy.shp
-
-
-AUTHOR
-------
-
-Markus Schnider
-msr@sourcepole.ch
-http://www.sourcepole.com
diff -pruN 8.0.1-5/mapscript/ruby/examples/shp2img.rb 8.2.0~beta1-1~exp1/mapscript/ruby/examples/shp2img.rb
--- 8.0.1-5/mapscript/ruby/examples/shp2img.rb	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/ruby/examples/shp2img.rb	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
-#!/usr/bin/env ruby 
-
-require "mapscript"
-include Mapscript
-
-filename = ARGV[0]
-
-shapefile = ShapefileObj.new(filename, -1)
-
-shapepath = File.dirname(filename)
-shapename = File.basename(filename, "....")
-
-map = MapObj.new('')
-map.shapepath = shapepath
-map.height = 200
-map.width = 200
-map.extent = shapefile.bounds
-
-$shapetypes =
-{
-   MS_SHAPEFILE_POINT      => MS_LAYER_POINT,
-   MS_SHAPEFILE_ARC        => MS_LAYER_LINE,
-   MS_SHAPEFILE_POLYGON    => MS_LAYER_POLYGON,
-   MS_SHAPEFILE_MULTIPOINT => MS_LAYER_LINE
-}
-
-layer = LayerObj.new(map)
-layer.name = shapename
-layer.type = $shapetypes[shapefile.type]
-layer.status = MS_ON
-layer.data = shapename
-
-cls = ClassObj.new(layer)
-style = StyleObj.new()
-color = ColorObj.new()
-color.red = 107
-color.green = 158
-color.blue = 160
-style.color = color
-cls.insertStyle(style)
-
-#map.save(shapename+'.map')
-img = map.draw
-img.save(shapename+'.png')
diff -pruN 8.0.1-5/mapscript/ruby/extconf.rb 8.2.0~beta1-1~exp1/mapscript/ruby/extconf.rb
--- 8.0.1-5/mapscript/ruby/extconf.rb	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/ruby/extconf.rb	1970-01-01 00:00:00.000000000 +0000
@@ -1,36 +0,0 @@
-#!/usr/bin/env ruby 
-require 'mkmf'
-require 'pathname'
-
-mapscriptvars = File.open("../../mapscriptvars")
-make_home = mapscriptvars.gets.chomp
-make_define = mapscriptvars.gets.chomp
-make_inc = mapscriptvars.gets.chomp
-make_libs = mapscriptvars.gets.chomp
-make_static_libs = mapscriptvars.gets.chomp
-mapscriptvars.close
-
-MAPSERVER_LOCAL_LIBS=Pathname.new(File.dirname(__FILE__) + '/../../.libs').realpath
-
-# $CFLAGS works only with 1.8 ??? -> the -Wall argument is not needed !!!
-$CFLAGS = ""
-$CPPFLAGS = make_inc + " -idirafter $(rubylibdir)/$(arch) " + make_define
-$LDFLAGS += " -fPIC -Wl,-rpath,#{MAPSERVER_LOCAL_LIBS}"
-#$LOCAL_LIBS += " -L../../.libs/ " + " -lmapserver " + make_static_libs
-$LOCAL_LIBS += " -L#{MAPSERVER_LOCAL_LIBS} " + " -lmapserver "
-
-# if the source file 'mapscript_wrap.c' is missing nothing works
-# this is a workaround !!
-if !FileTest.exist?("mapscript_wrap.c")
-	$objs = []
-	$objs.push("mapscript_wrap.o")
-end
-
-#CONFIG['LDSHARED'] = "LD_RUN_PATH=#{MAPSERVER_LOCAL_LIBS} " + CONFIG['LDSHARED']
-
-create_makefile("mapscript")
-
-make_file = File.open("Makefile", "a")
-make_file << "\nmapscript_wrap.c: ../mapscript.i\n\tswig -ruby -o mapscript_wrap.c ../mapscript.i"
-make_file.close
-
diff -pruN 8.0.1-5/mapscript/ruby/rbextend.i 8.2.0~beta1-1~exp1/mapscript/ruby/rbextend.i
--- 8.0.1-5/mapscript/ruby/rbextend.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/ruby/rbextend.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,16 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Ruby-specific extensions to MapScript objects
- * Author:
- *
- ******************************************************************************
- *
- * Ruby-specific mapscript code has been moved into this 
- * SWIG interface file to improve the readibility of the main
- * interface file.  The main mapscript.i file includes this
- * file when SWIGRUBY is defined (via 'swig -ruby ...').
- *
- *****************************************************************************/
-
diff -pruN 8.0.1-5/mapscript/ruby/rbmodule.i 8.2.0~beta1-1~exp1/mapscript/ruby/rbmodule.i
--- 8.0.1-5/mapscript/ruby/rbmodule.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/ruby/rbmodule.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,137 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Ruby-specific enhancements to MapScript
- * Author:   
- *
- ******************************************************************************
- *
- * Ruby-specific mapscript code has been moved into this 
- * SWIG interface file to improve the readibility of the main
- * interface file.  The main mapscript.i file includes this
- * file when SWIGRUBY is defined (via 'swig -ruby ...').
- *
- *****************************************************************************/
-
-/******************************************************************************
- * Simple Typemaps
- *****************************************************************************/
-/* To support imageObj::getBytes */
-%typemap(out) gdBuffer {
-    $result = rb_str_new($1.data, $1.size);
-    msFree($1.data);
-}
-
-/**************************************************************************
- * MapServer Errors and Ruby Exceptions
- **************************************************************************
- *
- * Translation of errors reported via the ms_error structure into
- * Ruby exceptions. Generally copied from Python MapScript by Jim Klassen.
- * Follows original code by Chris Chamberlin <cdc@aracnet.com> as updated
- * updated by Sean Gillies <sgillies@frii.com>. 
- * Uses rb_raise, %exception and $action for SWIG 1.3, do the most
- * obvious mapping of MapServer errors to Ruby exceptions and map all 
- * others to a new 'MapServerError' exception which can be caught like 
- * this:
- * 
- *   require 'mapscript'
- *   empty_map = Mapscript.MapObj.new('')
- *   begin:
- *       img = empty_map.draw()
- *   rescue Mapscript::MapServerError => msg
- *       print "Caught MapServerError:", msg.to_s
- *   end
- *
- *************************************************************************/
-
-%{
-    VALUE MSExc_MapServerError;
-    VALUE MSExc_MapServerChildError;
-%}
-
-/* Module initialization: call msSetup() and register msCleanup() */
-%init %{
-
-/* Copied from pymodule.i to fix #3619 */
-    if (msSetup() != MS_SUCCESS)
-    {
-        msSetError(MS_MISCERR, "Failed to set up threads and font cache",
-                   "msSetup()");
-    }
-
-    /* Is there a place to hook to call msCleanup()? */
-    VALUE exceptionClass = rb_eval_string("Exception");
-    VALUE mapscriptModule = rb_eval_string("Mapscript");
-    MSExc_MapServerError = rb_define_class_under(mapscriptModule, "MapserverError", exceptionClass);
-    MSExc_MapServerChildError = rb_define_class_under(mapscriptModule, "MapserverChildErrorError", exceptionClass);
-%}
-
-%{
-static void _raise_ms_exception( void );
-
-static void _raise_ms_exception() {
-    int errcode;
-    errorObj *ms_error;
-    char *errmsg;
-    ms_error = msGetErrorObj();
-    errcode = ms_error->code;
-    errmsg = msGetErrorString("\n");
-    
-    switch (errcode) {
-        case MS_IOERR:
-            rb_raise(rb_eIOError, errmsg, "%s");
-            break;
-        case MS_MEMERR:
-            rb_raise(rb_eNoMemError, errmsg, "%s");
-            break;
-        case MS_TYPEERR:
-            rb_raise(rb_eTypeError, errmsg, "%s");
-            break;
-        case MS_EOFERR:
-            rb_raise(rb_eEOFError, errmsg, "%s");
-            break;
-        case MS_CHILDERR:
-            rb_raise(MSExc_MapServerChildError, errmsg, "%s");
-            break;
-        default:
-            rb_raise(MSExc_MapServerError, errmsg, "%s");
-            break;
-    }
-
-    free(errmsg);
-}
-%}
-
-%exception {
-    msResetErrorList();
-    $action 
-    {
-        errorObj *ms_error = msGetErrorObj();
-
-        switch(ms_error->code) {
-            case MS_NOERR:
-                break;
-            case MS_NOTFOUND:
-                msResetErrorList();
-                break;
-            case -1:
-                break;
-            case MS_IOERR:
-                /*
-                if (strncmp(ms_error->routine, "msSearchDiskTree()", 20) != 0) {
-                    _raise_ms_exception();
-                    msResetErrorList();
-                    return NULL;
-                }
-                */
-            default:
-                _raise_ms_exception();
-                msResetErrorList();
-                return NULL;
-        }
-
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/swiginc/class.i 8.2.0~beta1-1~exp1/mapscript/swiginc/class.i
--- 8.0.1-5/mapscript/swiginc/class.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/class.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,273 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript classObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             Seth Girvin
-
-   ===========================================================================
-   Copyright (c) 1996-2019 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-
-%extend classObj {
-
-    /// Create a new child classObj instance at the tail (highest index) of the 
-    /// class array of the parent_layer. A class can be created outside the 
-    /// context of a parent layer by omitting the layerObj constructor argument
-    classObj(layerObj *layer=NULL) 
-    {
-        classObj *new_class=NULL;
-        
-        if (!layer)
-        {
-            new_class = (classObj *) malloc(sizeof(classObj));
-            if (!new_class)
-            {
-                msSetError(MS_MEMERR,
-                    "Could not allocate memory for new classObj instance",
-                    "classObj()");
-                return NULL;
-            }
-            if (initClass(new_class) == -1) return NULL;
-            new_class->layer = NULL;
-            return new_class;
-        }
-        else
-        {
-            if(msGrowLayerClasses(layer) == NULL)
-                return NULL;
-            if (initClass(layer->class[layer->numclasses]) == -1)
-                return NULL;
-            layer->class[layer->numclasses]->layer = layer;
-            MS_REFCNT_INCR(layer->class[layer->numclasses]);
-            layer->numclasses++;
-            return (layer->class[layer->numclasses-1]);
-        }
-
-        return NULL;
-    }
-
-    ~classObj() 
-    {
-        if (self)
-        {
-            if (freeClass(self)==MS_SUCCESS) {
-                free(self);
-                self=NULL;
-            }
-        }
-    }
-
-    /// Update a class from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int updateFromString(char *snippet)
-    {
-        return msUpdateClassFromString(self, snippet);
-    }
-
-    %newobject convertToString;
-    /// Output the CLASS as a Mapfile string
-    char* convertToString()
-    {
-        return msWriteClassToString(self);
-    }
-
-#if defined (SWIGJAVA) || defined (SWIGPHP)
-    %newobject cloneClass;
-    classObj *cloneClass() 
-#else
-    %newobject clone;
-    /**
-    Return an independent copy of the class without a parent layer
-
-    .. note::
-
-        In the Java & PHP modules this method is named ``cloneClass``.    
-    */ 
-    classObj *clone() 
-#endif
-    {
-        classObj *new_class;
-
-        new_class = (classObj *) malloc(sizeof(classObj));
-        if (!new_class)
-        {
-            msSetError(MS_MEMERR,
-                "Could not allocate memory for new classObj instance",
-                "clone()");
-            return NULL;
-        }
-        if (initClass(new_class) == -1)
-        {
-            msSetError(MS_MEMERR, "Failed to initialize Class",
-                                  "clone()");
-            return NULL;
-        }
-        new_class->layer = NULL;
-
-        if (msCopyClass(new_class, self, self->layer) != MS_SUCCESS) {
-            freeClass(new_class);
-            free(new_class);
-            new_class = NULL;
-        }
-        
-        return new_class;
-    }
-
-  /// Set :ref:`EXPRESSION <mapfile-class-expression>` string where `expression` is a MapServer regular, 
-  /// logical or string expression. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int setExpression(char *expression) 
-  {
-    if (!expression || strlen(expression) == 0) {
-       msFreeExpression(&self->expression);
-       return MS_SUCCESS;
-    }
-    else return msLoadExpressionString(&self->expression, expression);
-  }
-
-  %newobject getExpressionString;
-  /// Return a string representation of the :ref:`EXPRESSION <mapfile-class-expression>` enclosed in 
-  /// the quote characters appropriate to the expression type
-  char *getExpressionString() {
-    return msGetExpressionString(&(self->expression));
-  }
-
-  /// Set :ref:`TEXT <mapfile-class-text>` string where `text` is a MapServer text expression.
-  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int setText(char *text) {
-    if (!text || strlen(text) == 0) {
-      msFreeExpression(&self->text);
-      return MS_SUCCESS;
-    }    
-    else return msLoadExpressionString(&self->text, text);
-  }
-
-  %newobject getTextString;
-  /// Return a string representation of :ref:`TEXT <mapfile-class-text>`
-  char *getTextString() {
-    return msGetExpressionString(&(self->text));
-  }
-
-  /// Draw the legend icon onto *image* at *dstx*, *dsty*.  Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int drawLegendIcon(mapObj *map, layerObj *layer, int width, int height, imageObj *dstImage, int dstX, int dstY) {    
-    if(layer->sizeunits != MS_PIXELS) {
-      map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-      layer->scalefactor = (msInchesPerUnit(layer->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
-    }
-    else
-      layer->scalefactor = map->resolution/map->defresolution;
-
-  #if defined(WIN32) && defined(SWIGCSHARP)
-    __try {
-        return msDrawLegendIcon(map, layer, self, width, height, dstImage, dstX, dstY, MS_TRUE, NULL);
-    }    
-    __except(1 /*EXCEPTION_EXECUTE_HANDLER, catch every exception so it doesn't crash IIS*/) {  
-        msSetError(MS_IMGERR, "Unhandled exception in drawing legend image 0x%08x", "msDrawMap()", GetExceptionCode());
-    }
-  #else    
-    return msDrawLegendIcon(map, layer, self, width, height, dstImage, dstX, dstY, MS_TRUE, NULL);
-  #endif
-  }
-
-  %newobject createLegendIcon;
-  /// Draw and return a new legend icon
-  imageObj *createLegendIcon(mapObj *map, layerObj *layer, int width, int height) {
-    return msCreateLegendIcon(map, layer, self, width, height, MS_TRUE);
-  } 
-
-  %newobject getLabel;
-  /// Return a reference to the :class:`labelObj` at *index* in the labels array
-  labelObj *getLabel(int i) {
-    if (i >= 0 && i < self->numlabels) {
-      MS_REFCNT_INCR(self->labels[i]);
-      return self->labels[i];
-    } else {
-      msSetError(MS_CHILDERR, "Invalid index: %d.", "getLabel()", i);
-      return NULL;
-    }
-  }
-
-#ifdef SWIGCSHARP
-%apply SWIGTYPE *SETREFERENCE {labelObj *label};
-#endif
-  /// Add a :class:`labelObj` to the :class:`classObj` and return its index in the labels array
-  int addLabel(labelObj *label) {
-    return msAddLabelToClass(self, label);
-  }
-#ifdef SWIGCSHARP 
-%clear labelObj *label;
-#endif
-
-  %newobject removeLabel;
-  /// Remove the :class:`labelObj` at *index* from the labels array and return a
-  /// reference to the :class:`labelObj`. numlabels is decremented, and the array is updated
-  labelObj *removeLabel(int index) {
-    labelObj* label = (labelObj *) msRemoveLabelFromClass(self, index);
-    if (label) MS_REFCNT_INCR(label);
-    return label;
-  }
-  
-  // See https://github.com/mapserver/mapserver/issues/548 for more details about the Style methods
-
-  %newobject getStyle;
-  /// Return a reference to the :class:`styleObj` at *index* in the styles array
-  styleObj *getStyle(int i) {
-    if (i >= 0 && i < self->numstyles) {
-      MS_REFCNT_INCR(self->styles[i]);
-      return self->styles[i];
-    } else {
-      msSetError(MS_CHILDERR, "Invalid index: %d", "getStyle()", i);
-      return NULL;
-    }
-  }
-
-#ifdef SWIGCSHARP
-%apply SWIGTYPE *SETREFERENCE {styleObj *style};
-#endif
-  /// Insert a **copy** of *style* into the styles array at index *index*
-  /// Default is -1, or the end of the array.  Returns the index at which the style was inserted.
-  int insertStyle(styleObj *style, int index=-1) {
-    return msInsertStyle(self, style, index);
-  }
-#ifdef SWIGCSHARP 
-%clear styleObj *style;
-#endif
-
-  %newobject removeStyle;
-  /// Remove the :class:`styleObj` at *index* from the styles array and return a copy.
-  styleObj *removeStyle(int index) {
-    styleObj* style = (styleObj *) msRemoveStyle(self, index);
-    if (style) MS_REFCNT_INCR(style);
-    return style;
-  }
-
-  /// Swap the :class:`styleObj` at *index* with the styleObj at *index* - 1
-  int moveStyleUp(int index) {
-    return msMoveStyleUp(self, index);
-  }
-
-  /// Swap the :class:`styleObj` at *index* with the :class:`styleObj` at *index* + 1
-  int moveStyleDown(int index) {
-    return msMoveStyleDown(self, index);
-  }
-
-}
diff -pruN 8.0.1-5/mapscript/swiginc/cluster.i 8.2.0~beta1-1~exp1/mapscript/swiginc/cluster.i
--- 8.0.1-5/mapscript/swiginc/cluster.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/cluster.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,78 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript clusterObj extensions
-   Author:   Tamas Szekeres
-             Seth Girvin
-   ===========================================================================
-   Copyright (c) 1996-2019 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend clusterObj
-{
-
-
-  /// Update a cluster from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int updateFromString(char *snippet)
-  {
-    return msUpdateClusterFromString(self, snippet);
-  }
-
-  %newobject convertToString;
-  /// Output the :ref:`cluster` as a Mapfile string
-  char* convertToString()
-  {
-    return msWriteClusterToString(self);
-  }
-
-  /// Set :ref:`GROUP <mapfile-cluster-group>` string where `group` is a MapServer text expression.
-  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int setGroup(char *group) 
-  {
-    if (!group || strlen(group) == 0) {
-       msFreeExpression(&self->group);
-       return MS_SUCCESS;
-    }
-    else return msLoadExpressionString(&self->group, group);
-  }
-
-  %newobject getGroupString;
-  /// Return a string representation of :ref:`GROUP <mapfile-cluster-group>`
-  char *getGroupString() {
-    return msGetExpressionString(&(self->group));
-  }
-
-  /// Set :ref:`FILTER <mapfile-cluster-filter>` string where `filter` is a MapServer text expression.
-  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int setFilter(char *filter) {
-    if (!filter || strlen(filter) == 0) {
-      msFreeExpression(&self->filter);
-      return MS_SUCCESS;
-    }
-    else return msLoadExpressionString(&self->filter, filter);
-  }
-
-  /// Return a string representation of :ref:`FILTER <mapfile-cluster-filter>`
-  %newobject getFilterString;
-  char *getFilterString() {
-    return msGetExpressionString(&(self->filter));
-  }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/color.i 8.2.0~beta1-1~exp1/mapscript/swiginc/color.i
--- 8.0.1-5/mapscript/swiginc/color.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/color.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,142 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript colorObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             Seth Girvin
-
-   ===========================================================================
-   Copyright (c) 1996-2019 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend colorObj 
-{
-
-    /// Create a new instance. The color arguments are optional. 
-    colorObj(int red=0, int green=0, int blue=0, int alpha=255) 
-    {
-        colorObj *color;
-        
-        /* Check colors */
-        if (red > 255 || green > 255 || blue > 255 || alpha>255 ||
-            red<-1 || green<-1 || blue<-1 || alpha<0 ) {
-            msSetError(MS_MISCERR, "Invalid color", "colorObj()");
-            return NULL;
-        }
-    
-        color = (colorObj *)calloc(1, sizeof(colorObj));
-        if (!color)
-            return(NULL);
-    
-        MS_INIT_COLOR(*color, red, green, blue, alpha);
-
-        return(color);
-    }
-
-    ~colorObj() 
-    {
-        free(self);
-    }
-
-    /// Set all four RGBA components. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setRGB(int red, int green, int blue, int alpha = 255) 
-    {
-        /* Check colors */
-        if (red > 255 || green > 255 || blue > 255 || alpha > 255) {
-            msSetError(MS_MISCERR, "Invalid color index.", "setRGB()");
-            return MS_FAILURE;
-        }
-    
-        MS_INIT_COLOR(*self, red, green, blue, alpha);
-        return MS_SUCCESS;
-    }
-
-    /**
-    Set the color to values specified in case-independent hexadecimal notation. 
-    hex must start with a '#' followed by three or four hex bytes, e.g. '#ffffff' 
-    or '#ffffffff'. If only three hex bytes are supplied, the alpha will be set 
-    to 255. Calling setHex('#ffffff') therefore assigns values of 255 to each 
-    color component, including the alpha. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int setHex(char *psHexColor) 
-    {
-        int red, green, blue, alpha = 255;
-        if (psHexColor && (strlen(psHexColor) == 7 || strlen(psHexColor) == 9) && psHexColor[0] == '#') {
-            red = msHexToInt(psHexColor+1);
-            green = msHexToInt(psHexColor+3);
-            blue= msHexToInt(psHexColor+5);
-            if (strlen(psHexColor) == 9) {
-                alpha = msHexToInt(psHexColor+7);
-            }
-            if (red > 255 || green > 255 || blue > 255 || alpha > 255) {
-                msSetError(MS_MISCERR, "Invalid color index.", "setHex()");
-                return MS_FAILURE;
-            }
-
-            MS_INIT_COLOR(*self, red, green, blue, alpha);
-            return MS_SUCCESS;
-        }
-        else {
-            msSetError(MS_MISCERR, "Invalid hex color.", "setHex()");
-            return MS_FAILURE;
-        }
-    }   
-
-    %newobject toHex;
-    /**
-    Complement to setHex, returning a hexadecimal representation of the color 
-    components. If alpha is 255 then this is three hex bytes '#rrggbb', 
-    otherwise four hex bytes '#rrggbbaa'
-    */
-    char *toHex() 
-    {
-        char *hexcolor;
-
-        if (!self) 
-        {
-            msSetError(MS_MISCERR, "Can't express NULL color as hex",
-                       "toHex()");
-            return NULL;
-        }
-        if (self->red < 0 || self->green < 0 || self->blue < 0) 
-        {
-            msSetError(MS_MISCERR, "Can't express invalid color as hex",
-                       "toHex()");
-            return NULL;
-        }
-        if (self->alpha == 255) {
-          hexcolor = msSmallMalloc(8);
-          snprintf(hexcolor, 8, "#%02x%02x%02x",
-                   self->red, self->green, self->blue);
-        } else if (self->alpha >= 0) {
-          hexcolor = msSmallMalloc(10);
-          snprintf(hexcolor, 10, "#%02x%02x%02x%02x",
-                   self->red, self->green, self->blue, self->alpha);
-        } else {
-           msSetError(MS_MISCERR, "Can't express color with invalid alpha as hex",
-                      "toHex()");
-           return NULL;
-        }
-        return hexcolor;
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/config.i 8.2.0~beta1-1~exp1/mapscript/swiginc/config.i
--- 8.0.1-5/mapscript/swiginc/config.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/config.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,43 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript configObj extensions
-   Author:   Steve Lime 
-             Seth Girvin, sgirvin@geographika.co.uk
-             
-   ===========================================================================
-   Copyright (c) 1996-2021 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend configObj 
-{
-
-    /// Create a new instance of :class:`configObj`
-    configObj(char *filename=NULL)
-    {
-        return msLoadConfig(filename);
-    }
-
-    ~configObj()
-    {
-        msFreeConfig(self);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/connpool.i 8.2.0~beta1-1~exp1/mapscript/swiginc/connpool.i
--- 8.0.1-5/mapscript/swiginc/connpool.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/connpool.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for connection pool management
-   Author:   Umberto Nicoletti, unicoletti@prometeo.it
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-/// Some memory leaks can be avoided by closing any unreferenced 
-/// connections from time to time. See https://github.com/mapserver/mapserver/issues/1661
-void msConnPoolCloseUnreferenced();
diff -pruN 8.0.1-5/mapscript/swiginc/dbfinfo.i 8.2.0~beta1-1~exp1/mapscript/swiginc/dbfinfo.i
--- 8.0.1-5/mapscript/swiginc/dbfinfo.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/dbfinfo.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,74 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript DBFInfo extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend DBFInfo 
-{
-    /// Get the field name of a DBF using the field index ``iField``
-    char *getFieldName(int iField) 
-    {
-        static char pszFieldName[1000];
-        int pnWidth;
-        int pnDecimals;
-        msDBFGetFieldInfo(self, iField, &pszFieldName[0], &pnWidth, 
-                          &pnDecimals);
-        return pszFieldName;
-    }
-
-    /// Get the field width of a DBF using the field index ``iField``
-    int getFieldWidth(int iField) 
-    {
-        char pszFieldName[1000];
-        int pnWidth;
-        int pnDecimals;
-        msDBFGetFieldInfo(self, iField, &pszFieldName[0], &pnWidth,
-                          &pnDecimals);
-        return pnWidth;
-    }
-
-    /// Get the field decimals of a DBF using the field index ``iField``
-    int getFieldDecimals(int iField) 
-    {
-        char pszFieldName[1000];
-        int pnWidth;
-        int pnDecimals;
-        msDBFGetFieldInfo(self, iField, &pszFieldName[0], &pnWidth,
-                          &pnDecimals);
-        return pnDecimals;
-    }
-
-    /// Get the field type of a DBF using the field index ``iField``.
-    /// Field types are one of FTString, FTInteger, FTDouble, FTInvalid
-    int getFieldType(int iField) 
-    {
-        return msDBFGetFieldInfo(self, iField, NULL, NULL, NULL);
-    }   
-
-}
-
-
diff -pruN 8.0.1-5/mapscript/swiginc/error.i 8.2.0~beta1-1~exp1/mapscript/swiginc/error.i
--- 8.0.1-5/mapscript/swiginc/error.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/error.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,62 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript errorObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-
-/* A few things necessary for automatically wrapped functions */
-%newobject msGetErrorString;
-
-%extend errorObj
-{
-    /// Create a new instance
-    errorObj() 
-    {    
-        return msGetErrorObj();
-    }
-
-    ~errorObj() {}
-
-    /// Returns the next error in the stack or NULL if the end has been reached
-    errorObj *next() 
-    {
-        errorObj *ep;
-
-        if (self == NULL || self->next == NULL) return NULL;
-
-        ep = msGetErrorObj();
-        while (ep != self) {
-            /* We reached end of list of active errorObj and 
-               didn't find the errorObj... this is bad! */
-            if (ep->next == NULL) return NULL;
-            ep = ep->next;
-        }
-    
-        return ep->next;
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/swiginc/hashtable.i 8.2.0~beta1-1~exp1/mapscript/swiginc/hashtable.i
--- 8.0.1-5/mapscript/swiginc/hashtable.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/hashtable.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,86 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript hashTableObj extensions
-   Author:   Sean Gillies, sgillies@frii.com
-
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend hashTableObj {
-    
-    /// Create a new instance
-#if defined(SWIGJAVA) || defined(SWIGCSHARP)
-    hashTableObj() {
-#else
-    hashTableObj(void) {
-#endif
-        return msCreateHashTable();
-    }
-
-    /* Destroy instance */
-    ~hashTableObj() {
-        msFreeHashTable(self);
-    }
-
-    /// Set a hash item given key and value. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int set(char *key, char *value) {
-        if (msInsertHashTable(self, key, value) == NULL) {
-            return MS_FAILURE;
-        }
-        return MS_SUCCESS;
-    }
-
-    /// Returns the value of the item by its key, or default if the key does not exist
-    char *get(char *key, char *default_value=NULL) {
-        char *value = NULL;
-        if (!key) {
-            msSetError(MS_HASHERR, "NULL key", "get");
-        }
-     
-        value = (char *) msLookupHashTable(self, key);
-        if (!value) {
-            return default_value;
-        }
-        return value;
-    }
-
-    /// Removes the hash item by its key. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int remove(char *key) {
-        return msRemoveHashTable(self, key);
-    }
-
-    /// Empties the table of all items
-    void clear(void) {
-        msFreeHashItems(self);
-        initHashTable(self);
-    }
-
-    /// Returns the name of the next key or NULL if there is no valid next key.
-    /// If the input key is NULL, returns the first key
-    const char *nextKey(char *prevkey=NULL) {
-        return msNextKeyFromHashTable(self, (const char *) prevkey);
-    }
-    
-}
diff -pruN 8.0.1-5/mapscript/swiginc/image.i 8.2.0~beta1-1~exp1/mapscript/swiginc/image.i
--- 8.0.1-5/mapscript/swiginc/image.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/image.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,199 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript imageObj extensions
-   Author:   Steve Lime
-             Sean Gillies, sgillies@frii.com
-
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   =========================================================================*/
-
-%extend imageObj {
-
-  /**
-  Create a new :class:`imageObj` instance. If *filename* is specified, an imageObj
-  is created from the file and any specified *width*, *height*, and *format* parameters 
-  will be overridden by values of the image in *filename*.  Otherwise, if *format* is specified (as an :class:`outputFormatObj`) an imageObj is created
-  using that format. If *filename* is not specified, then *width* and *height* should be specified. 
-  The default resolution is currently 72 and defined by :data:`MS_DEFAULT_RESOLUTION` - this setting is 
-  not available in MapScript. 
-  */
-  imageObj(int width, int height, outputFormatObj *input_format=NULL,
-             const char *file=NULL,
-             double resolution=MS_DEFAULT_RESOLUTION, double defresolution=MS_DEFAULT_RESOLUTION)
-    {
-        imageObj *image=NULL;
-        outputFormatObj *format;
-        rendererVTableObj *renderer = NULL;
-        rasterBufferObj *rb = NULL;
-
-        if (input_format) {
-            format = input_format;
-        }
-        else {
-            format = msCreateDefaultOutputFormat(NULL, "AGG/PNG", "aggpng", NULL);
-            if (format)
-                msInitializeRendererVTable(format);
-        }
-        if (format == NULL) {
-            msSetError(MS_IMGERR, "Could not create output format",
-                       "imageObj()");
-            return NULL;
-        }
-
-        if (file) {
-
-            renderer = format->vtable;
-            rb = (rasterBufferObj*) malloc(sizeof(rasterBufferObj));
-            if (!rb) {
-                msSetError(MS_MEMERR, NULL, "imageObj()");
-                return NULL;
-            }
-            if ( (renderer->loadImageFromFile((char *)file, rb)) == MS_FAILURE) {
-                msFreeRasterBuffer(rb);
-                free(rb);
-                return NULL;
-            }
-            image = msImageCreate(rb->width, rb->height, format, NULL, NULL,
-                                  resolution, defresolution, NULL);
-            if (! image) {
-                msFreeRasterBuffer(rb);
-                free(rb);
-                return NULL;
-            }
-
-            if(renderer->mergeRasterBuffer(image, rb, 1.0, 0, 0, 0, 0, rb->width, rb->height) != MS_SUCCESS) {
-                msFreeImage(image);
-                image = NULL;
-            }
-
-            msFreeRasterBuffer(rb);
-            free(rb);
-
-            return image;
-        }
-
-        image = msImageCreate(width, height, format, NULL, NULL, resolution, defresolution, NULL);
-        return image;
-    }
-
-    ~imageObj()
-    {
-        msFreeImage(self);
-    }
-
-    /// Save image to filename. The optional map parameter must be specified if 
-    /// saving GeoTIFF images.
-    void save(char *filename, mapObj *map=NULL)
-    {
-        msSaveImage(map, self, filename );
-    }
-
-#ifndef SWIGPYTHON
-    /**
-    Write image data to an open file handle. Intended to replace
-    saveToString.  See ``python/pyextend.i`` for the Python specific
-    version of this method.
-    */
-    int write( FILE *file=NULL )
-    {
-        int retval=MS_FAILURE;
-        rendererVTableObj *renderer = NULL;
-
-        if (MS_RENDERER_PLUGIN(self->format))
-        {
-            if (file)
-            {
-                renderer = self->format->vtable;
-                /* FIXME? as an improvement, pass a map argument instead of the NULL (see #4216) */
-                retval = renderer->saveImage(self, NULL, file, self->format);
-            }
-            else
-            {
-                retval = msSaveImage(NULL, self, NULL);
-            }
-        }
-        else
-        {
-            msSetError(MS_IMGERR, "Writing of %s format not implemented",
-                       "imageObj::write",
-                       self->format->name);
-        }
-
-        return retval;
-    }
-#endif
-
-    /*
-    -------------------------------------------------------------------------
-    getBytes returns a gdBuffer structure (defined in mapscript.i) which must
-    be typemapped to an object appropriate to the target language.  This
-    typemap must also msFree the data member of the gdBuffer.  See the type-
-    maps in java/javamodule.i and python/pymodule.i for examples.
-
-    contributed by Jerry Pisk, jerry.pisk@gmail.com
-    -------------------------------------------------------------------------
-    */
-
-    /// Returns the image contents as a binary buffer. The exact form of this buffer will 
-    /// vary by MapScript language (e.g. a string in Python, byte[] array in Java and C#, unhandled in Perl)
-    gdBuffer getBytes()
-    {
-        gdBuffer buffer;
-
-        buffer.owns_data = MS_TRUE;
-
-        buffer.data = msSaveImageBuffer(self, &buffer.size, self->format);
-
-        if( buffer.data == NULL || buffer.size == 0 )
-        {
-            buffer.data = NULL;
-            msSetError(MS_MISCERR, "Failed to get image buffer", "getBytes");
-            return buffer;
-        }
-
-        return buffer;
-    }
-
-    /**
-    Returns the size of the binary buffer representing the image buffer
-
-    .. note:: 
-
-        The getSize method is inefficient as it does a call to getBytes and 
-        then computes the size of the byte array. The byte array is then immediately discarded. 
-        In most cases it is more efficient to call getBytes directly.
-    */
-    int getSize() {
-        gdBuffer buffer;
-        int size=0;
-
-        buffer.data = msSaveImageBuffer(self, &buffer.size, self->format);
-        size = buffer.size;
-
-        if( buffer.data == NULL || buffer.size == 0 ) {
-            buffer.data = NULL;
-            msSetError(MS_MISCERR, "Failed to get image buffer size", "getSize");
-        }
-        free(buffer.data);
-        return size;
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/label.i 8.2.0~beta1-1~exp1/mapscript/swiginc/label.i
--- 8.0.1-5/mapscript/swiginc/label.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/label.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,189 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript labelObj extensions
-   Author:   Steve Lime
-
-   ===========================================================================
-   Copyright (c) 1996-2007 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend labelObj
-{
-
-  /**
-  Create a new :class:`labelObj`. A :class:`labelObj` is associated with a 
-  :class:`classObj` a :class:`scalebarObj` or a :class:`legendObj`. 
-  An instance of :class:`labelObj` can exist outside of a :class:`classObj` container and be 
-  explicitly inserted into the :class:`classObj`:
-  
-  >>> new_label = new labelObj()
-  >>> the_class.addLabel(new_label)
-  */
-  labelObj() 
-    {
-      labelObj *label;
-        
-      label = (labelObj *)calloc(1, sizeof(labelObj));
-      if (!label)
-        return(NULL);
-    
-      initLabel(label);
-      
-      return(label);    	
-    }
-
-  ~labelObj() 
-    {
-      freeLabel(self);
-    }
-
-  /// Update a :class:`labelObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int updateFromString(char *snippet)
-  {
-    return msUpdateLabelFromString(self, snippet);
-  }
-
-  %newobject convertToString;
-  /// Output the :class:`labelObj` object as a Mapfile string. Provides the inverse option for :func:`labelObj.updateFromString`.
-  char* convertToString()
-  {
-    return msWriteLabelToString(self);
-  }
-
-  /// Remove the attribute binding for a specified label property.
-  int removeBinding(int binding) 
-  {
-    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return MS_FAILURE;
-
-    if(self->bindings[binding].item) {
-      free(self->bindings[binding].item);
-      self->bindings[binding].item = NULL;
-      self->bindings[binding].index = -1; 
-      self->numbindings--;
-    }
-
-    return MS_SUCCESS;
-  }
-
-  /// Get the attribute binding for a specified label property. Returns NULL if there is no binding for this property.
-  char *getBinding(int binding) 
-  {
-    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return NULL;
-
-    return self->bindings[binding].item;
-  }
-
-  /// Set the attribute binding for a specified label property. Binding constants look like this: ``MS_LABEL_BINDING_[attribute name]``:
-  /// >>> new_label.setBinding(MS_LABEL_BINDING_COLOR, "FIELD_NAME_COLOR")
-  int setBinding(int binding, char *item) 
-  {
-    if(!item) return MS_FAILURE;
-    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return MS_FAILURE;
-
-    if(self->bindings[binding].item) {
-      free(self->bindings[binding].item);
-      self->bindings[binding].item = NULL; 
-      self->bindings[binding].index = -1;
-      self->numbindings--;
-    }
-
-    self->bindings[binding].item = msStrdup(item); 
-    self->numbindings++;
-
-    return MS_SUCCESS;
-  }
-
-  /// Set the label expression.
-  int setExpression(char *expression) 
-  {
-    if (!expression || strlen(expression) == 0) {
-       msFreeExpression(&self->expression);
-       return MS_SUCCESS;
-    }
-    else return msLoadExpressionString(&self->expression, expression);
-  }
-
-  /// Returns the label expression string.
-  %newobject getExpressionString;
-  char *getExpressionString() {
-    return msGetExpressionString(&(self->expression));
-  }
-
-  /// Set the label text.
-  int setText(char *text) {
-    if (!text || strlen(text) == 0) {
-      msFreeExpression(&self->text);
-      return MS_SUCCESS;
-    }	
-    else return msLoadExpressionString(&self->text, text);
-  }
-
-  /// Returns the label text string.
-  %newobject getTextString;
-  char *getTextString() {
-    return msGetExpressionString(&(self->text));
-  }
-
-  %newobject getStyle;
-  /// Return a reference to the :class:`styleObj` at index *i* in the styles array.
-  styleObj *getStyle(int i) {
-      if (i >= 0 && i < self->numstyles) {
-          MS_REFCNT_INCR(self->styles[i]);
-          return self->styles[i];
-      } else {
-          msSetError(MS_CHILDERR, "Invalid index: %d", "getStyle()", i);
-          return NULL;
-      }
-  }
-
-#ifdef SWIGCSHARP
-%apply SWIGTYPE *SETREFERENCE {styleObj *style};
-#endif
-
-    /// Insert a copy of style into the styles array at index *index*. 
-    /// Default is -1, or the end of the array. Returns the index at which the style was inserted.
-    int insertStyle(styleObj *style, int index=-1) {
-        return msInsertLabelStyle(self, style, index);
-    }
-#ifdef SWIGCSHARP 
-%clear styleObj *style;
-#endif
-
-    %newobject removeStyle;
-    /// Remove the styleObj at *index* from the styles array and return a copy.
-    styleObj *removeStyle(int index) {
-        styleObj* style = (styleObj *) msRemoveLabelStyle(self, index);
-        if (style)
-            MS_REFCNT_INCR(style);
-            return style;
-    }
-
-    /// Swap the styleObj at *index* with the styleObj index - 1.
-    int moveStyleUp(int index) {
-        return msMoveLabelStyleUp(self, index);
-    }
-
-    /// Swap the styleObj at *index* with the styleObj index + 1.
-    int moveStyleDown(int index) {
-       return msMoveLabelStyleDown(self, index);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/labelcache.i 8.2.0~beta1-1~exp1/mapscript/swiginc/labelcache.i
--- 8.0.1-5/mapscript/swiginc/labelcache.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/labelcache.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,40 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript labelCacheObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend labelCacheObj 
-{
-
-    /// Free the labelCache
-    void freeCache() 
-    {
-        msFreeLabelCache(self);
-    }
-}
-
-
diff -pruN 8.0.1-5/mapscript/swiginc/layer.i 8.2.0~beta1-1~exp1/mapscript/swiginc/layer.i
--- 8.0.1-5/mapscript/swiginc/layer.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/layer.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,836 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript layerObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend layerObj 
-{
-
-    /**
-    A :class:`layerObj` is associated with :class:`mapObj`. An instance of 
-    :class:`layerObj` can exist outside of a :class:`mapObj`
-    */
-    layerObj(mapObj *map=NULL) 
-    {
-        layerObj *layer;
-        int result;
-        
-        if (!map) {
-            layer = (layerObj *) malloc(sizeof(layerObj));
-            if (!layer) {
-                msSetError(MS_MEMERR, "Failed to initialize Layer",
-                                       "layerObj()");
-                return NULL;
-            } 
-            result = initLayer(layer, NULL);
-            if (result == MS_SUCCESS) {
-                layer->index = -1;
-                return layer;
-            }
-            else {
-                msSetError(MS_MEMERR, "Failed to initialize Layer",
-                                       "layerObj()");
-                return NULL;
-            }
-        }
-        else {
-            if(msGrowMapLayers(map) == NULL)
-                return(NULL);
-
-            if (initLayer((map->layers[map->numlayers]), map) == -1)
-                return(NULL);
-
-            map->layers[map->numlayers]->index = map->numlayers;
-            map->layerorder[map->numlayers] = map->numlayers;
-            map->numlayers++;
-        MS_REFCNT_INCR(map->layers[map->numlayers-1]);
-
-            return (map->layers[map->numlayers-1]);
-        }
-    }
- 
-    /// Sets an opacity for the layer, where the value is an integer in range [0, 100]. 
-    /// A new :ref:`composite` block is generated, containing this ``OPACITY`` value.
-    void setOpacity(int opacity)
-    {
-      msSetLayerOpacity(self, opacity);
-    }
-
-    /// Returns the opacity value for the layer.
-    int getOpacity() {
-      if(self->compositer) return (self->compositer->opacity);
-      return (100);
-    }
-
-    ~layerObj() 
-    {
-        /*if (!self->map) {*/
-        if (self) {
-            if(freeLayer(self)==MS_SUCCESS) {
-                free(self);
-        }
-        }
-    }
-
-#if defined (SWIGJAVA) || defined(SWIGPHP)
-    %newobject cloneLayer;
-    layerObj *cloneLayer() 
-#else
-    %newobject clone;
-    /**
-    Return an independent copy of the layer with no parent map.
-
-    .. note::
-
-        In the Java & PHP modules this method is named ``cloneLayer``.    
-    */
-    layerObj *clone() 
-#endif
-    {
-        layerObj *layer;
-        int result;
-
-        layer = (layerObj *) malloc(sizeof(layerObj));
-        if (!layer) {
-            msSetError(MS_MEMERR, "Failed to initialize Layer",
-                                  "layerObj()");
-            return NULL;
-        } 
-        result = initLayer(layer, NULL);
-        if (result != MS_SUCCESS) {
-            msSetError(MS_MEMERR, "Failed to initialize Layer",
-                                  "layerObj()");
-            return NULL;
-        }
-
-        if (msCopyLayer(layer, self) != MS_SUCCESS) {
-            freeLayer(layer);
-            free(layer);
-            layer = NULL;
-        }
-        layer->map = NULL;
-        layer->index = -1;
-        
-        return layer;
-    }
-
-    /// Update a :class:`layerObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int updateFromString(char *snippet)
-    {
-        return msUpdateLayerFromString(self, snippet);
-    }
-    
-    %newobject convertToString;
-    /// Output the :class:`layerObj` object as a Mapfile string. Provides the inverse option for :func:`layerObj.updateFromString`.
-    char* convertToString()
-    {
-        return msWriteLayerToString(self);
-    }
-
-#ifdef SWIGCSHARP
-%apply SWIGTYPE *SETREFERENCE {classObj *classobj};
-#endif
-    /// Insert a **copy** of the class into the layer at the requested *index*. 
-    /// Default index of -1 means insertion at the end of the array of classes. Returns the index at which the class was inserted.
-    int insertClass(classObj *classobj, int index=-1)
-    {
-        return msInsertClass(self, classobj, index);
-    }
-#ifdef SWIGCSHARP
-%clear classObj *classobj;
-#endif
-
-
-    %newobject removeClass;
-    /// Removes the class at *index* and returns a copy, or NULL in the case of a failure. 
-    /// Note that subsequent classes will be renumbered by this operation. 
-    /// The numclasses field contains the number of classes available.
-    classObj *removeClass(int index) 
-    {
-        classObj* c = msRemoveClass(self, index);
-    if (c != NULL) {
-        MS_REFCNT_INCR(c);
-    }
-    return c;
-    }
-
-    /// Opens the underlying layer. This is required before operations like :func:`layerObj.getResult`
-    /// will work, but is not required before a draw or query call.
-    int open() 
-    {
-        int status;
-        status =  msLayerOpen(self);
-        if (status == MS_SUCCESS) {
-            return msLayerGetItems(self);
-        }
-        return status;
-    }
-
-    /**
-    Performs a spatial, and optionally an attribute based feature search. 
-    The function basically prepares things so that candidate features can be accessed by 
-    query or drawing functions (e.g using :func:`layerObj.nextShape` function). 
-    Returns :data:`MS_SUCCESS`, :data:`MS_FAILURE` or :data:`MS_DONE`.
-    MS_DONE is returned if the layer extent does not overlap *rect*.
-    */
-    int whichShapes(rectObj rect)
-    {
-        int oldconnectiontype = self->connectiontype;
-        self->connectiontype = MS_INLINE;
-
-        if(msLayerWhichItems(self, MS_TRUE, NULL) != MS_SUCCESS) {
-            self->connectiontype = oldconnectiontype;
-            return MS_FAILURE;
-        }
-        self->connectiontype = oldconnectiontype;
-
-        return msLayerWhichShapes(self, rect, MS_FALSE);
-    }    
-
-    %newobject nextShape;
-    /**
-    Called after :func:`layerObj.whichShapes` has been called to actually 
-    retrieve shapes within a given area returns a shape object or :data:`MS_FALSE`
-    Example of usage:
-
-    .. code-block::
-
-        mapObj map = new mapObj("d:/msapps/gmap-ms40/htdocs/gmap75.map");
-        layerObj layer = map.getLayerByName('road');
-        int status = layer.open();
-        status = layer.whichShapes(map.extent);
-        shapeObj shape;
-        while ((shape = layer.nextShape()) != null)
-        {
-          ...
-        }
-        layer.close();
-
-    */
-    shapeObj *nextShape() 
-    {
-       int status;
-       shapeObj *shape;
-
-       shape = (shapeObj *)malloc(sizeof(shapeObj));
-       if (!shape) return NULL;
-       msInitShape(shape);
-
-       status = msLayerNextShape(self, shape);
-       if(status != MS_SUCCESS) {
-         msFreeShape(shape);
-     free(shape);
-     return NULL;
-       } else
-         return shape;
-    }
-
-    /// Close the underlying layer.
-    void close() 
-    {
-        msLayerClose(self);
-    }
-
-    %newobject getShape;
-    /// Get a shape from layer data. Argument is a result cache member from :func:`layerObj.getResult`
-    shapeObj *getShape(resultObj *record) 
-    {
-        int retval;
-        shapeObj *shape;
-
-        if (!record) return NULL;
-    
-        shape = (shapeObj *)malloc(sizeof(shapeObj));
-        if (!shape) return NULL;
-
-        msInitShape(shape);
-        shape->type = self->type; /* is this right? */
-
-        retval = msLayerGetShape(self, shape, record);
-        if(retval != MS_SUCCESS) {
-          msFreeShape(shape);
-          free(shape);
-          return NULL;
-        } else
-        return shape;
-    }
-
-    /// Returns the number of entries in the query result cache for this layer.
-    int getNumResults() 
-    {
-        if (!self->resultcache) return 0;
-        return self->resultcache->numresults;
-    }
-
-    %newobject getResultsBounds;
-    /// Returns the bounds of the features in the result cache.
-    rectObj *getResultsBounds() 
-    {
-        rectObj *bounds;
-        if (!self->resultcache) return NULL;
-        bounds = (rectObj *) malloc(sizeof(rectObj));
-        MS_COPYRECT(bounds, &self->resultcache->bounds);
-        return bounds;
-    }
-
-    /// Fetches the requested query result cache entry, or NULL if the index is outside 
-    /// the range of available results. This method would normally only be used after 
-    /// issuing a query operation.
-    resultObj *getResult(int i) 
-    {
-        if (!self->resultcache) return NULL;
-        if (i >= 0 && i < self->resultcache->numresults)
-            return &self->resultcache->results[i]; 
-        else
-            return NULL;
-    }
-
-    %newobject getClass;
-    /// Fetch the requested class object at *i*. Returns NULL if the class index is out of the legal range. 
-    /// The numclasses field contains the number of classes available, and the first class is index 0.
-    classObj *getClass(int i) 
-    {
-    classObj *result=NULL;
-        if (i >= 0 && i < self->numclasses) {
-            result=self->class[i]; 
-        MS_REFCNT_INCR(result);
-    }
-    return result;
-    }
-
-    /// Returns the requested item. Items are attribute fields, and this method returns the 
-    /// item name (field name). The numitems field contains the number of items available, and the first item is index zero.
-    char *getItem(int i) 
-    {
-  
-        if (i >= 0 && i < self->numitems)
-            return (char *) (self->items[i]);
-        else
-            return NULL;
-    }
-
-    /// Set the items to be retrieved with a particular shape.
-    int setItems(char **items, int numitems) {
-        return msLayerSetItems(self, items, numitems);
-    }
-
-    /// Renders this layer into the target image, adding labels to the cache if required. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. 
-    // TODO: Does the map need to be the map on which the layer is defined? I suspect so.
-    int draw(mapObj *map, imageObj *image) 
-    {
-        return msDrawLayer(map, self, image);    
-    }
-
-    /// Draw query map for a single layer into the target image. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. 
-    int drawQuery(mapObj *map, imageObj *image) 
-    {
-        return msDrawQueryLayer(map, self, image);    
-    }
-
-    /**
-    Query by the filter *string*. 
-    For querying, we switch layer status ON and then back to original
-    value before returning. 
-    */
-    int queryByFilter(mapObj *map, char *string)
-    {
-        int status;
-        int retval;
-
-        msInitQuery(&(map->query));
-
-        map->query.type = MS_QUERY_BY_FILTER;
-        map->query.mode = MS_QUERY_MULTIPLE;
-
-        map->query.filter.string = msStrdup(string);
-        map->query.filter.type = MS_EXPRESSION;
-        
-        map->query.layer = self->index;
-        map->query.rect = map->extent;
-
-        status = self->status;
-        self->status = MS_ON;
-        retval = msQueryByFilter(map);
-        self->status = status;
-        return retval;
-    }
-
-    /**
-    Query layer for shapes that intersect current map extents. *qitem* is the item (attribute) 
-    on which the query is performed, and *qstring* is the expression to match. 
-    The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
-    Note that the layer's FILTER/FILTERITEM are ignored by this function. *mode* is :data:`MS_SINGLE` or :data:`MS_MULTIPLE` depending on number of results you want. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
-    */
-    int queryByAttributes(mapObj *map, char *qitem, char *qstring, int mode) 
-    {
-        int status;
-        int retval;
-
-        msInitQuery(&(map->query));
-        
-        map->query.type = MS_QUERY_BY_FILTER;
-        map->query.mode = mode;
-
-        if(qitem) map->query.filteritem = msStrdup(qitem);
-        if(qstring) {
-          msInitExpression(&map->query.filter);
-          msLoadExpressionString(&map->query.filter, qstring);
-        }
-
-        map->query.layer = self->index;
-        map->query.rect = map->extent;
-
-        status = self->status;
-        self->status = MS_ON;
-        retval = msQueryByFilter(map);
-        self->status = status;
-
-        return retval;
-    }
-
-    /**
-    Query layer at point location specified in georeferenced map coordinates (i.e. not pixels). 
-    The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
-    Note that the layer's FILTER/FILTERITEM are ignored by this function. *mode* is :data:`MS_SINGLE` or :data:`MS_MULTIPLE` depending on number of results you want. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
-    */
-    int queryByPoint(mapObj *map, pointObj *point, int mode, double buffer) 
-    {
-        int status;
-        int retval;
-
-        msInitQuery(&(map->query));
-
-        map->query.type = MS_QUERY_BY_POINT;
-        map->query.mode = mode;
-        map->query.point = *point;
-        map->query.buffer = buffer;
-        map->query.layer = self->index;
-        
-        status = self->status;
-        self->status = MS_ON;
-        retval = msQueryByPoint(map);
-        self->status = status;
-
-        return retval;
-    }
-
-    /**
-    Query layer using a rectangle specified in georeferenced map coordinates (i.e. not pixels).
-    The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
-    Note that the layer's FILTER/FILTERITEM are ignored by this function. The :data:`MS_MULTIPLE` mode is set by default.
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
-    */
-    int queryByRect(mapObj *map, rectObj rect) 
-    {
-        int status;
-        int retval;
-
-        msInitQuery(&(map->query));
-
-        map->query.type = MS_QUERY_BY_RECT;
-        map->query.mode = MS_QUERY_MULTIPLE;
-        map->query.rect = rect; 
-        map->query.layer = self->index;
-
-        status = self->status;
-        self->status = MS_ON;
-        retval = msQueryByRect(map);
-        self->status = status;
-
-        return retval;
-    }
-
-    /**
-    Perform a query set based on a previous set of results from another layer. 
-    At present the results MUST be based on a polygon layer. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
-    */
-    int queryByFeatures(mapObj *map, int slayer) 
-    {
-        int status;
-        int retval;
-
-        map->query.slayer = slayer;
-        map->query.layer = self->index;
-
-        status = self->status;
-        self->status = MS_ON;
-        retval = msQueryByFeatures(map);
-        self->status = status;
-        return retval;
-    }
-
-    /**
-    Query layer based on a single shape, the shape has to be a polygon at this point. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
-    */
-    int queryByShape(mapObj *map, shapeObj *shape) 
-    {
-        int status;
-        int retval;
-        
-        msInitQuery(&(map->query));
-
-        map->query.type = MS_QUERY_BY_SHAPE;
-        map->query.mode = MS_QUERY_MULTIPLE;
-        map->query.shape = (shapeObj *) malloc(sizeof(shapeObj));
-        msInitShape(map->query.shape);
-        msCopyShape(shape, map->query.shape);
-        map->query.layer = self->index;
-
-        status = self->status;
-        self->status = MS_ON;
-        retval = msQueryByShape(map);
-        self->status = status;
-        return retval;
-    }
-
-    /// Pop a query result member into the layer's result cache. By default clobbers existing cache.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int queryByIndex(mapObj *map, int tileindex, int shapeindex, int bAddToQuery=MS_FALSE)
-    {
-        int status;
-        int retval;
-        
-        msInitQuery(&(map->query));
-
-        map->query.type = MS_QUERY_BY_INDEX;
-        map->query.mode = MS_QUERY_SINGLE;
-        map->query.tileindex = tileindex;
-        map->query.shapeindex = shapeindex;
-        map->query.clear_resultcache = !bAddToQuery;
-        map->query.layer = self->index;
-
-        status = self->status;
-        self->status = MS_ON;
-        retval = msQueryByIndex(map);
-        self->status = status;
-        return retval;
-    }
-    
-    /// Returns a reference to layer's result cache. Should be NULL prior to any query, or after a failed query or query with no results.
-    resultCacheObj *getResults(void)
-    {
-        return self->resultcache;
-    }
-
-    /// Sets a filter expression similarly to the FILTER expression in a map file. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE` if the expression fails to parse.
-    int setFilter(char *filter) 
-    {
-        if (!filter || strlen(filter) == 0) {
-            msFreeExpression(&self->filter);
-            return MS_SUCCESS;
-        }
-        else return msLoadExpressionString(&self->filter, filter);
-    }
-
-    %newobject getFilterString;
-    /// Returns the current filter expression.
-    char *getFilterString() 
-    {
-        return msGetExpressionString(&(self->filter));
-    }
-
-    /// Set the layer projection using OpenGIS Well Known Text format. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setWKTProjection(char *wkt) 
-    {
-        self->project = MS_TRUE;
-        return msOGCWKT2ProjectionObj(wkt, &(self->projection), self->debug);
-    }
-
-    %newobject getProjection;
-    /// Returns the PROJ definition of the layer's projection.
-    char *getProjection() 
-    {    
-        return (char *) msGetProjectionString(&(self->projection));
-    }
-
-    /**
-    Set the layer projection using a PROJ format projection definition 
-    (i.e. "+proj=utm +zone=11 +datum=WGS84" or "init=EPSG:26911"). 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int setProjection(char *proj4) 
-    {
-        self->project = MS_TRUE;
-        return msLoadProjectionString(&(self->projection), proj4);
-    }
-
-    /// Add a new inline feature on a layer. Returns -1 on error. 
-    /// TODO: Is this similar to inline features in a mapfile? Does it work for any kind of layer or connection type?
-    int addFeature(shapeObj *shape) 
-    {    
-        self->connectiontype = MS_INLINE;
-        if(self->features != NULL && self->features->tailifhead != NULL) 
-            shape->index = self->features->tailifhead->shape.index + 1;
-        else 
-            shape->index = 0;
-        if (insertFeatureList(&(self->features), shape) == NULL) 
-        return MS_FAILURE;
-        return MS_SUCCESS;
-    }
-
-    /// Returns the number of inline features in a layer. 
-    /// TODO: is this really only online features or will it return the number of non-inline features on a regular layer?
-    int getNumFeatures() 
-    {
-        return msLayerGetNumFeatures(self);
-    }
-
-    %newobject getExtent;
-    /// Fetches the extents of the data in the layer. This normally requires a full read pass through the features of the layer and does not work for raster layers.
-    rectObj *getExtent() 
-    {
-        rectObj *extent;
-        extent = (rectObj *) malloc(sizeof(rectObj));
-        msLayerGetExtent(self, extent);
-        return extent;
-    }
-
-    /// Sets the extent of a layer. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setExtent(double minx=-1.0, double miny=-1.0,
-                  double maxx=-1.0, double maxy=-1.0)
-    {
-        if (minx > maxx || miny > maxy) {
-            msSetError(MS_RECTERR,
-                "{ 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }",
-                "layerObj::setExtent()", minx, miny, maxx, maxy);
-            return MS_FAILURE;
-        }
-
-        return msLayerSetExtent(self, minx, miny, maxx, maxy);
-    }
-
-    %newobject getWMSFeatureInfoURL;
-    /**
-    Return a WMS GetFeatureInfo URL (works only for WMS layers) *clickX*, *clickY*
-    is the location of to query in pixel coordinates with (0,0) at the top 
-    left of the image. *featureCount* is the number of results to return. *infoFormat* 
-    is the format the format in which the result should be requested. 
-    Depends on remote server's capabilities. MapServer WMS servers support only "MIME" 
-    (and should support "GML.1" soon). Returns "" and outputs a warning if layer is not a 
-    WMS layer or if it is not queryable.
-    */
-    char *getWMSFeatureInfoURL(mapObj *map, int click_x, int click_y,
-                               int feature_count, char *info_format)
-    {
-        return (char *) msWMSGetFeatureInfoURL(map, self, click_x, click_y,
-               feature_count, info_format);
-    }
- 
-    %newobject executeWFSGetFeature;
-    /// Executes a GetFeature request on a WFS layer and returns the name of the temporary GML file created. Returns an empty string on error.
-    char *executeWFSGetFeature(layerObj *layer) 
-    {
-        return (char *) msWFSExecuteGetFeature(layer);
-    }
-
-    /**
-    Apply the SLD document to the layer object. The matching between the SLD document and the 
-    layer will be done using the layer's name. If a *stylelayer* argument is passed (argument is optional), 
-    the NamedLayer in the SLD that matches it will be used to style the layer. 
-    See SLD HOWTO for more information on the SLD support.
-    */
-    int applySLD(char *sld, char *stylelayer) 
-    {
-      return msSLDApplySLD(self->map, sld, self->index, stylelayer, NULL);
-    }
-
-    /**
-    Apply the SLD document pointed by the URL to the layer object. The matching between the SLD document and the 
-    layer will be done using the layer's name. If a *stylelayer* argument is passed (argument is optional), 
-    the NamedLayer in the SLD that matches it will be used to style the layer. 
-    See SLD HOWTO for more information on the SLD support.
-    */
-    int applySLDURL(char *sld, char *stylelayer) 
-    {
-      return msSLDApplySLDURL(self->map, sld, self->index, stylelayer, NULL);
-    }
-
-    %newobject generateSLD; 
-    /// Returns an SLD XML string based on all the classes found in the layer (the layer must have ``STATUS ON```).
-    char *generateSLD() 
-    {
-        return (char *) msSLDGenerateSLD(self->map, self->index, NULL);
-    }
-
-    /// Returns :data:`MS_TRUE` or :data:`MS_FALSE` after considering the layer status, 
-    /// minscaledenom, and maxscaledenom within the context of the parent map.
-    int isVisible()
-    {
-        if (!self->map)
-        {
-            msSetError(MS_MISCERR,
-                "visibility has no meaning outside of a map context",
-                "isVisible()");
-            return MS_FAILURE;
-        }
-        return msLayerIsVisible(self->map, self);
-    }
-
-    /**
-    The class specified by the class index will be moved up in the array of classes. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. For example ``moveClassUp(1)`` will have the effect 
-    of moving class 1 up to position 0, and the class at position 0 will be moved to position 1.
-    */
-    int moveClassUp(int index) 
-    {
-        return msMoveClassUp(self, index);
-    }
-
-    /**
-    The class specified by the class index will be moved up into the array of classes. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. For example ``moveClassDown(1)`` will have the effect 
-    of moving class 1 down to position 2, and the class at position 2 will be moved to position 1.
-    */
-    int moveClassDown(int index) 
-    {
-        return msMoveClassDown(self, index);
-    }
-
-    /**
-    Adds or replaces a processing directive of the form "key=value". 
-    Unlike the :func:`layerObj.addProcessing` function, this will replace an existing processing directive 
-    for the given key value. Processing directives supported are specific to the layer type 
-    and underlying renderer.
-    */
-    void setProcessingKey(const char *key, const char *value) 
-    {
-       msLayerSetProcessingKey( self, key, value );
-    }
- 
-    /// Adds a new processing directive line to a layer, similar to the PROCESSING directive 
-    /// in a map file. Processing directives supported are specific to the layer type and 
-    /// underlying renderer.
-    void addProcessing(const char *directive ) 
-    {
-        msLayerAddProcessing( self, directive );
-    }
-
-    /// Return the raster processing directive at *index*.
-    char *getProcessing(int index) 
-    {
-        return (char *) msLayerGetProcessing(self, index);
-    }
-
-    /// Return the processing directive specified by *key*.
-    char *getProcessingKey(const char *key)
-    {
-      return (char *) msLayerGetProcessingKey(self, key);
-    }    
-
-    /**
-    Clears the layer's raster processing directives. 
-    Returns the subsequent number of directives, which will equal :data:`MS_SUCCESS` if the 
-    directives have been cleared.
-    */
-    int clearProcessing() 
-    {
-        return msLayerClearProcessing(self);
-    }
-
-    /**
-    Changes the connectiontype of the layer and recreates the vtable according to the new 
-    connection type. This method should be used instead of setting the *connectiontype*
-    parameter directly. In case when the layer.connectiontype = :data:`MS_PLUGIN` the *library_str* 
-    parameter should also be specified so as to select the library to load by MapServer. 
-    For the other connection types this parameter should be set to an empty string "". 
-    */
-    int setConnectionType(int connectiontype, const char *library_str) 
-    {    
-        /* Caller is responsible to close previous layer correctly before
-         * calling msConnectLayer() 
-         */
-        if (msLayerIsOpen(self))
-          msLayerClose(self);
-        return msConnectLayer(self, connectiontype, library_str);
-    }
-
-    /**
-    Get the class index for a shape in the layer.
-    */
-    int getClassIndex(mapObj *map, shapeObj *shape, int *classgroup=NULL, int numclasses=0) {
-        return msShapeGetClass(self, map, shape, classgroup, numclasses);
-    }
-
-    /**
-    Return the geomtransform string for the layer. 
-    */
-    char *getGeomTransform() 
-    {
-      return self->_geomtransform.string;
-    }
-
-    /**
-    Set the geomtransform string for the layer. 
-    */
-    void setGeomTransform(char *transform) 
-    {
-      msFree(self->_geomtransform.string);
-      if (!transform || strlen(transform) > 0) {
-        self->_geomtransform.string = msStrdup(transform);
-        self->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
-      }
-      else {
-        self->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
-        self->_geomtransform.string = NULL;
-      }
-    }
-
-    /**
-    Returns the requested item's field type.
-    A layer must be open to retrieve the item definition. 
-
-    Pass in the attribute index to retrieve the type. The 
-    layer's numitems property contains the number of items 
-    available, and the first item is index zero.
-    */
-    char *getItemType(int i)
-    {
-
-        char *itemType = NULL;
-
-        if (i >= 0 && i < self->numitems) {
-            gmlItemListObj *item_list;
-            item_list = msGMLGetItems(self, "G");
-            if (item_list != NULL) {
-                gmlItemObj *item = item_list->items + i;
-                itemType = msStrdup(item->type);
-                msGMLFreeItems(item_list); // destroy the original list
-            }
-        }
-
-        return itemType;
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/legend.i 8.2.0~beta1-1~exp1/mapscript/swiginc/legend.i
--- 8.0.1-5/mapscript/swiginc/legend.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/legend.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,43 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript legendObj extensions
-   Author:   Steve Lime
-
-   ===========================================================================
-   Copyright (c) 1996-2007 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend legendObj
-{
-  /// Update a :class:`legendObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int updateFromString(char *snippet)
-  {
-    return msUpdateLegendFromString(self, snippet);
-  }
-  
-  %newobject convertToString;
-  /// Output the :class:`legendObj` object as a Mapfile string. Provides the inverse option for :func:`legendObj.updateFromString`.
-  char* convertToString()
-  {
-    return msWriteLegendToString(self);
-  }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/line.i 8.2.0~beta1-1~exp1/mapscript/swiginc/line.i
--- 8.0.1-5/mapscript/swiginc/line.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/line.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,115 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript lineObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend lineObj 
-{
-
-    /// A :class:`lineObj` is composed of one or more :class:`pointObj` instances
-    lineObj() 
-    {
-        lineObj *line;
-
-        line = (lineObj *)malloc(sizeof(lineObj));
-        if (!line)
-            return(NULL);
-
-        line->numpoints=0;
-        line->point=NULL;
-
-        return line;
-    }
-
-    ~lineObj() 
-    {
-        free(self->point);
-        free(self);		
-    }
-
-    /// Transform line in place from proj_in to proj_out.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(projectionObj *projin, projectionObj *projout) 
-    {
-        return msProjectLine(projin, projout, self);
-    }
-
-    /// Reproject line given a reprojection object. Transformation is done in place.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(reprojectionObj *reprojector)
-    {
-        return msProjectLineEx(reprojector, self);
-    }
-
-    /// Return reference to point at index *i*.
-    pointObj *get(int i) 
-    {
-        if (i<0 || i>=self->numpoints)
-            return NULL;
-        else
-            return &(self->point[i]);
-    }
-
-    /// Add point *p* to the line.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int add(pointObj *p)
-    {
-        if (self->numpoints == 0) { /* new */	
-        self->point = (pointObj *)malloc(sizeof(pointObj));
-        if (!self->point)
-            return MS_FAILURE;
-        } else { /* extend array */
-            self->point = (pointObj *)realloc(self->point, 
-                                      sizeof(pointObj)*(self->numpoints+1));
-        if (!self->point)
-            return MS_FAILURE;
-        }
-
-        self->point[self->numpoints].x = p->x;
-        self->point[self->numpoints].y = p->y;
-        self->point[self->numpoints].z = p->z;
-        self->point[self->numpoints].m = p->m;
-        self->numpoints++;
-
-        return MS_SUCCESS;
-    }
-
-    /// Set the point at index *i* to point *p*. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int set(int i, pointObj *p)
-    {
-        if (i<0 || i>=self->numpoints)
-            return MS_FAILURE;
-
-        self->point[i].x = p->x;
-        self->point[i].y = p->y;
-        self->point[i].z = p->z;
-        self->point[i].m = p->m;
-        return MS_SUCCESS;
-    }
-
-}
diff -pruN 8.0.1-5/mapscript/swiginc/map.i 8.2.0~beta1-1~exp1/mapscript/swiginc/map.i
--- 8.0.1-5/mapscript/swiginc/map.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/map.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,718 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript mapObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend mapObj 
-{
-
-    /// Create a new instance of :class:`mapObj`. Note that the *filename* is optional.
-    mapObj(char *filename="", configObj *config=NULL) 
-    {
-        if (filename && strlen(filename))
-            return msLoadMap(filename, NULL, config);
-        else { /* create an empty map, no layers etc... */
-            return msNewMapObj();
-        }      
-    }
-
-#ifdef SWIGCSHARP
-
-  mapObj(char *filename) 
-  {
-        if (filename && strlen(filename))
-            return msLoadMap(filename, NULL, NULL);
-        else { /* create an empty map, no layers etc... */
-            return msNewMapObj();
-        } 
-  }
-
-  mapObj(char *mapText, int isMapText /*used as signature only to differentiate this constructor from default constructor*/ ) 
-  {
-      return msLoadMapFromString(mapText, NULL, NULL);
-  }
-
-  mapObj(char *mapText, int isMapText, configObj *config) 
-  {
-      return msLoadMapFromString(mapText, NULL, config);
-  }
-
-#endif 
-    
-    ~mapObj() 
-    {
-        msFreeMap(self);
-    }
-
-#if defined (SWIGJAVA) || defined (SWIGPHP)
-    %newobject cloneMap;
-    mapObj *cloneMap() 
-#else
-    %newobject clone;
-    /**
-    Return an independent copy of the map, less any caches.
-
-    .. note::
-
-        In the Java & PHP modules this method is named ``cloneMap``.
-    */
-    mapObj *clone() 
-#endif
-    {
-        mapObj *dstMap;
-        dstMap = msNewMapObj();
-        if (msCopyMap(dstMap, self) != MS_SUCCESS) {
-            msFreeMap(dstMap);
-            dstMap = NULL;
-        }
-        return dstMap;
-    }
-    
-#ifdef SWIGCSHARP
-%apply SWIGTYPE *SETREFERENCE {layerObj *layer};
-#endif
-    /**
-    Insert a copy of *layer* into the map at *index*.
-    The default value of *index* is -1, which means the last possible index. 
-    Returns the index of the new layer, or -1 in the case of a failure.
-    */
-    int insertLayer(layerObj *layer, int index=-1) 
-    {
-        return msInsertLayer(self, layer, index);  
-    }
-#ifdef SWIGCSHARP
-%clear layerObj *layer;
-#endif
-
-    %newobject removeLayer;
-    /// Remove the layer at *index*. Returns the :class:`layerObj`. 
-    layerObj *removeLayer(int index) 
-    {
-        layerObj *layer=msRemoveLayer(self, index);
-        MS_REFCNT_INCR(layer);
-        return layer;
-    }
-
-    /**
-    Set the map extent, returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. 
-    This method will correct the extents (width/height ratio) before setting the 
-    minx, miny, maxx, maxy values. See extent properties to set up a custom extent from :class:`rectObj`.
-    */
-    int setExtent(double minx, double miny, double maxx, double maxy) {
-        return msMapSetExtent( self, minx, miny, maxx, maxy );
-    }
-
-    /// Offset the map extent based on the given distances in map coordinates. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    int offsetExtent(double x, double y) {
-        return msMapOffsetExtent( self, x, y );
-    }
-
-    /**
-    Scale the map extent using the *zoomfactor* and ensure the extent within 
-    the *minscaledenom* and *maxscaledenom* domain. If *minscaledenom* and/or *maxscaledenom*
-    is 0 then the parameter is not taken into account. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int scaleExtent(double zoomfactor, double minscaledenom, double maxscaledenom) {
-        return msMapScaleExtent( self, zoomfactor, minscaledenom, maxscaledenom );
-    }
-
-    /// Set the map center to the given map point. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    int setCenter(pointObj *center) {
-        return msMapSetCenter( self, center );
-    }
-
-    /*
-    Set map's image *width* and *height* together and carry out the necessary subsequent 
-    geotransform computation. 
-
-    Recent rotation work makes setSize the only reliable 
-    method for changing the image size - direct access is deprecated. 
-
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int setSize(int width, int height) 
-    {
-        return msMapSetSize(self, width, height);
-    }
-
-    /// TODO
-    void pixelToGeoref(double pixPosX, double pixPosY, pointObj *geoPos)
-    {
-       geoPos->x = self->gt.geotransform[0] + self->gt.geotransform[1] * pixPosX + self->gt.geotransform[2] * pixPosY;
-       geoPos->y = self->gt.geotransform[3] + self->gt.geotransform[4] * pixPosX + self->gt.geotransform[5] * pixPosY;
-    }
-
-    /// Returns the map rotation angle.
-    double getRotation() 
-    {
-        return self->gt.rotation_angle;
-    }
-
-    /**
-    Set map rotation angle. The map view rectangle (specified in EXTENTS) will be rotated by 
-    the indicated angle in the counter- clockwise direction. Note that this implies the 
-    rendered map will be rotated by the angle in the clockwise direction. 
-
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int setRotation( double rotation_angle ) 
-    {
-        return msMapSetRotation( self, rotation_angle );
-    }
-
-    %newobject getLayer;
-    /// Returns a reference to the layer at index *i*.
-    layerObj *getLayer(int i) {
-      if(i >= 0 && i < self->numlayers) {
-          MS_REFCNT_INCR(self->layers[i]);
-          return (self->layers[i]); /* returns an EXISTING layer */
-      } else {
-        return NULL;
-      }
-    }
-
-    %newobject getLayerByName;
-    /// Returns a reference to the named layer.
-    layerObj *getLayerByName(char *name) {
-      int i;
-
-      i = msGetLayerIndex(self, name);
-
-      if(i != -1) {
-        MS_REFCNT_INCR(self->layers[i]);
-        return (self->layers[i]); /* returns an EXISTING layer */
-      }
-      else
-        return NULL;
-    }
-
-    /**
-    Return the index of the named symbol in the map's symbolset.
-
-    .. note::
-
-        This method is poorly named and too indirect. It is preferable to use the 
-        getSymbolByName method of :class:`symbolSetObj`, which really does return a :class:`symbolObj` 
-        reference, or use the index method of symbolSetObj to get a symbol's index number.
-    */
-    int getSymbolByName(char *name) {
-      return msGetSymbolIndex(&self->symbolset, name, MS_TRUE);
-    }
-
-    /// \**TODO** this function only calculates the scale or am I missing something?
-    void prepareQuery() {
-      int status;
-
-      status = msCalculateScale(self->extent, self->units, self->width, self->height, self->resolution, &self->scaledenom);
-      if(status != MS_SUCCESS) self->scaledenom = -1;
-    }
-
-    %newobject prepareImage;
-    /// Returns an :class:`imageObj` initialized to map extents and outputformat.
-    imageObj *prepareImage() 
-    {
-      return msPrepareImage(self, MS_FALSE);
-    }
-
-    /**
-    Sets map outputformat to the named format.
-
-    .. note::
-
-        :func:`mapObj.setImageType` remains in the module but its use 
-        is deprecated in favor of :func:`mapObj.selectOutputFormat`.
-    */
-    void setImageType( char * imagetype ) {
-        outputFormatObj *format;
-
-        format = msSelectOutputFormat( self, imagetype );
-        if( format == NULL )
-            msSetError(MS_MISCERR, "Unable to find IMAGETYPE '%s'.", 
-               "setImageType()", imagetype );
-        else
-        {  
-            msFree( self->imagetype );
-            self->imagetype = msStrdup(imagetype);
-            msApplyOutputFormat( &(self->outputformat), format, MS_NOOVERRIDE);
-        }
-    }
-
-    /**
-    Set the map's active output format to the internal format named imagetype. 
-    Built-in formats are "PNG", "PNG24", "JPEG", "GIF", "GTIFF".
-    */
-    void selectOutputFormat( char *imagetype )
-    {
-        outputFormatObj *format;
-
-        format = msSelectOutputFormat( self, imagetype );
-        if ( format == NULL )
-            msSetError(MS_MISCERR, "Unable to find IMAGETYPE '%s'.", 
-                       "setImageType()", imagetype );
-        else
-        {   
-            msFree( self->imagetype );
-            self->imagetype = msStrdup(imagetype);
-            msApplyOutputFormat( &(self->outputformat), format, MS_NOOVERRIDE);
-        }
-    }
-
- 
-    %newobject getOutputFormat;
-    /**
-    Returns the output format at the specified *i* index from the output formats array or 
-    null if *i* is beyond the array bounds. The number of outpuFormats can be 
-    retrieved by calling :func:`mapObj.getNumoutputformats`.
-    */
-    outputFormatObj *getOutputFormat(int i) {
-      if(i >= 0 && i < self->numoutputformats) {
-          MS_REFCNT_INCR(self->outputformatlist[i]);
-          return (self->outputformatlist[i]); 
-      } else {
-        return NULL;
-      }
-    }
-
-    /// Sets map outputformat.
-    void setOutputFormat( outputFormatObj *format ) {
-        msApplyOutputFormat( &(self->outputformat), format, MS_NOOVERRIDE);
-    }
-
-    %newobject draw;
-    /**
-    Draw the map, processing layers according to their defined order and status. 
-    Return an :class:`imageObj`.
-    */
-    imageObj *draw() {
-  #if defined(WIN32) && defined(SWIGCSHARP)
-      __try {
-          return msDrawMap(self, MS_FALSE);
-      }    
-      __except(1 /*EXCEPTION_EXECUTE_HANDLER, catch every exception so it doesn't crash IIS*/) {  
-          msSetError(MS_IMGERR, "Unhandled exception in drawing map image 0x%08x", "msDrawMap()", GetExceptionCode());
-      }
-  #else    
-      return msDrawMap(self, MS_FALSE);
-  #endif    
-    }
-
-    %newobject drawQuery;
-    /// Draw query map, returning an :class:`imageObj`.
-    imageObj *drawQuery() {
-      return msDrawMap(self, MS_TRUE);
-    }
-
-    %newobject drawLegend;
-    /// Draw map legend, returning an :class:`imageObj`.
-    imageObj *drawLegend(int scale_independent=MS_FALSE) {
-      return msDrawLegend(self, scale_independent, NULL);
-    }
-
-    %newobject drawScalebar;
-    /// Draw scale bar, returning an :class:`imageObj`.
-    imageObj *drawScalebar() {
-      return msDrawScalebar(self);
-    }
-
-    %newobject drawReferenceMap;
-    /// Draw reference map, returning an :class:`imageObj`.
-    imageObj *drawReferenceMap() {
-      return msDrawReferenceMap(self);
-    }
-
-    /**
-    Embed map's legend in *image*. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    */
-    int embedScalebar(imageObj *image) {	
-      return msEmbedScalebar(self, image);
-    }
-
-    /**
-    Embed map's legend in *image*. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    */
-    int embedLegend(imageObj *image) {	
-      return msEmbedLegend(self, image);
-    }
-
-    /**
-    Draw map's label cache on *image*.
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    */
-    int drawLabelCache(imageObj *image) {
-      return msDrawLabelCache(self,image);
-    }
-
-    /**
-    Query map layers using the filter *string*. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    */
-    int queryByFilter(char *string) {
-      msInitQuery(&(self->query));
-
-      self->query.type = MS_QUERY_BY_FILTER;
-      self->query.mode = MS_QUERY_MULTIPLE;
-
-      self->query.filter.string = msStrdup(string);
-      self->query.filter.type = MS_EXPRESSION;
-
-      self->query.rect = self->extent;
-
-      return msQueryByFilter(self);
-    }
-
-    /**
-    Query map layers, result sets contain one or more features, depending on mode, 
-    that intersect *point* within a tolerance *buffer*. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    */
-    int queryByPoint(pointObj *point, int mode, double buffer) {
-      msInitQuery(&(self->query));
-
-      self->query.type = MS_QUERY_BY_POINT;
-      self->query.mode = mode;
-      self->query.point = *point;
-      self->query.buffer = buffer;
-
-      return msQueryByPoint(self);
-    }
-
-    /**
-    Query map layers, result sets contain features that intersect or are contained within 
-    the features in the result set of the :data:`MS_LAYER_POLYGON` type layer at layer index *slayer*. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    */
-    int queryByRect(rectObj rect) {
-      msInitQuery(&(self->query));
-
-      self->query.type = MS_QUERY_BY_RECT;
-      self->query.mode = MS_QUERY_MULTIPLE;
-      self->query.rect = rect;
-
-      return msQueryByRect(self);
-    }
-
-
-    /**
-    Query map layers, result sets contain features that intersect or are contained within 
-    the features in the result set of the :data:`MS_LAYER_POLYGON` type layer at layer index *slayer*. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
-    */
-    int queryByFeatures(int slayer) {
-      self->query.slayer = slayer;
-      return msQueryByFeatures(self);
-    }
-
-    /**
-    Query layer based on a single shape, the shape has to be a polygon at this point. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found 
-    or if some other error happened
-    */
-    int queryByShape(shapeObj *shape) {
-      msInitQuery(&(self->query));
-      
-      self->query.type = MS_QUERY_BY_SHAPE;
-      self->query.mode = MS_QUERY_MULTIPLE;
-      self->query.shape = (shapeObj *) malloc(sizeof(shapeObj));
-      msInitShape(self->query.shape);
-      msCopyShape(shape, self->query.shape);
-
-      return msQueryByShape(self);
-    }
-
-
-    /// Sets map projection from OGC definition *wkt*.
-    int setWKTProjection(char *wkt) {
-      return msOGCWKT2ProjectionObj(wkt, &(self->projection), self->debug);
-    }
-
-    %newobject getProjection;
-    /// Returns the PROJ definition of the map's projection.
-    char *getProjection() {
-      return msGetProjectionString(&(self->projection));
-    }
-
-    /// Set map projection from PROJ definition string proj4.
-    int setProjection(char *proj4) {
-      return msLoadProjectionString(&(self->projection), proj4);
-    }
-
-    /// Save map to disk as a new map file. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int save(char *filename) {
-      return msSaveMap(self, filename);
-    }
-
-    /// Save query to disk. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int saveQuery(char *filename, int results=MS_FALSE) {
-      return msSaveQuery(self, filename, results);
-    }
-
-    /// Load a saved query. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int loadQuery(char *filename)  {
-      return msLoadQuery(self, filename);
-    }
-
-    /// Clear layer query result caches. Default is -1, or all layers.
-    void freeQuery(int qlayer=-1) {
-      msQueryFree(self, qlayer);
-    }
-
-    /// Save query to disk. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int saveQueryAsGML(char *filename, const char *ns="GOMF") {
-      return msGMLWriteQuery(self, filename, ns);
-    }
-
-    /// Load symbols defined in filename into map symbolset. The existing symbolset is cleared. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setSymbolSet(char *szFileName) {
-      msFreeSymbolSet(&self->symbolset);
-      msInitSymbolSet(&self->symbolset);
-
-      self->symbolset.filename = msStrdup(szFileName);
-
-      /* Symbolset shares same fontset as main mapfile */
-      self->symbolset.fontset = &(self->fontset);
-
-      return msLoadSymbolSet(&self->symbolset, self);
-    }
-
-    /// Return the number of symbols in map
-    int getNumSymbols() {
-      return self->symbolset.numsymbols;
-    }
-
-    ///. Load fonts defined in filename into map fontset. The existing fontset is cleared. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setFontSet(char *filename) {
-      msFreeFontSet(&(self->fontset));
-      msInitFontSet(&(self->fontset));
-
-      self->fontset.filename = msStrdup(filename);
-
-      return msLoadFontSet(&(self->fontset), self);
-    }
-
-    /* I removed a method to get the fonset filename. Instead I updated mapserver.h
-     to allow SWIG access to the fonset, although the numfonts and filename
-     members are read-only. Use the setFontSet method to actually change the
-     fontset. To get the filename do $map->{fontset}->{filename}; -- SG */
-
-    /// Save map definition to disk as OGC-compliant XML. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int saveMapContext(char *szFileName) {
-      return msSaveMapContext(self, szFileName);
-    }
-
-    /// Load an OGC map context file to define extents and layers of a map
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int loadMapContext(char *szFileName, int useUniqueNames=MS_FALSE) {
-      return msLoadMapContext(self, szFileName, useUniqueNames);
-    }
-   
-    /// Move the layer at layerindex up in the drawing order array, meaning 
-    /// that it is drawn earlier.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int  moveLayerUp(int layerindex) {
-      return msMoveLayerUp(self, layerindex);
-    }
-
-    /// Move the layer at layerindex down in the drawing order array, meaning 
-    /// that it is drawn later. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int  moveLayerDown(int layerindex) {
-      return msMoveLayerDown(self, layerindex);
-    }
-
-    %newobject getLayersDrawingOrder;
-    /// Returns an array of layer indexes in drawing order.
-    /// Note Unless the proper typemap is implemented for the module's language 
-    /// a user is more likely to get back an unusable SWIG pointer to the integer array.
-    intarray *getLayersDrawingOrder() {
-      int i;
-      intarray *order;
-      order = new_intarray(self->numlayers);
-      for (i=0; i<self->numlayers; i++) {
-          // see http://www.swig.org/Doc4.0/SWIGDocumentation.html#Library_carrays for %array_class interface
-          order[i] = self->layerorder[i];
-      }
-      return order;
-    }
-
-    /// Set map layer drawing order.
-    /// Note Unless the proper typemap is implemented for the module's language 
-    /// users will not be able to pass arrays or lists to this method and it will be unusable.
-    int setLayersDrawingOrder(int *panIndexes) {
-      return msSetLayersdrawingOrder(self, panIndexes); 
-    }
-
-    /// Set the indicated key configuration option to the indicated value. 
-    /// Equivalent to including a CONFIG keyword in a map file.
-    void setConfigOption(char *key, char *value) {
-      msSetConfigOption(self,key,value);
-    }
-
-    /// Fetches the value of the requested configuration key if set. 
-    /// Returns NULL if the key is not set.
-    char *getConfigOption(char *key) {
-      return (char *) msGetConfigOption(self,key);
-    }
-
-    /// Apply the defined configuration options set by setConfigOption()
-    void applyConfigOptions() {
-      msApplyMapConfigOptions( self );
-    } 
-
-    /* SLD */
-
-    /// Parse the SLD XML string sldxml and apply to map layers. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int applySLD(char *sld) {
-      return msSLDApplySLD(self, sld, -1, NULL, NULL);
-    }
-
-    /// Fetch SLD XML from the URL sldurl and apply to map layers.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int applySLDURL(char *sld) {
-      return msSLDApplySLDURL(self, sld, -1, NULL, NULL);
-    }
-
-    %newobject generateSLD;
-    /// Return SLD XML as a string for map layers that have STATUS on.
-    char *generateSLD(char *sldVersion=NULL) {
-        return (char *) msSLDGenerateSLD(self, -1, sldVersion);
-    }
-
-    %newobject processTemplate;
-    /**
-    Process MapServer template and return HTML.
-    Note none of the three template processing methods will be usable unless the proper 
-    typemaps are implemented in the module for the target language.Currently the typemaps 
-    are not implemented.
-    */
-    char *processTemplate(int bGenerateImages, char **names, char **values,
-                          int numentries)
-    {
-        return msProcessTemplate(self, bGenerateImages, names, values,
-                                 numentries);
-    }
-
-    %newobject processLegendTemplate;
-    /**
-    Process MapServer legend template and return HTML.
-    Note none of the three template processing methods will be usable unless the proper 
-    typemaps are implemented in the module for the target language.Currently the typemaps 
-    are not implemented.
-    */
-    char *processLegendTemplate(char **names, char **values, int numentries) {
-        return msProcessLegendTemplate(self, names, values, numentries);
-    }
-
-    %newobject processQueryTemplate;
-    /**
-    Process MapServer query template and return HTML. 
-    Note none of the three template processing methods will be usable unless the proper 
-    typemaps are implemented in the module for the target language.Currently the typemaps 
-    are not implemented.
-    */
-    char *processQueryTemplate(char **names, char **values, int numentries) {
-        return msProcessQueryTemplate(self, 1, names, values, numentries);
-    }
-
-    /**
-    Return the output format corresponding to driver name imagetype or to format name 
-    imagetype. This works exactly the same as the IMAGETYPE directive in a mapfile, is 
-    case insensitive and allows an output format to be found either by driver 
-    (like 'AGG/PNG') or name (like 'png').
-    */
-    outputFormatObj *getOutputFormatByName(char *name) {
-        return msSelectOutputFormat(self, name); 
-    }
-
-    /// Attach format to the map's output format list. 
-    /// Returns the updated number of output formats.
-    int appendOutputFormat(outputFormatObj *format) {
-        return msAppendOutputFormat(self, format);
-    }
-
-    /// Removes the format named name from the map's output format list. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int removeOutputFormat(char *name) {
-        return msRemoveOutputFormat(self, name);
-    }
-
-    /// Load OWS request parameters (BBOX, LAYERS, &c.) into map. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int loadOWSParameters(cgiRequestObj *request, char *wmtver_string="1.1.1") 
-    {
-        return msMapLoadOWSParameters(self, request, wmtver_string);
-    }
-
-    /**
-    Processes and executes the passed OpenGIS Web Services request on the map. 
-    Returns :data:`MS_DONE` (2) if there is no valid OWS request in the req object, 
-    :data:`MS_SUCCESS` (0) if an OWS request was successfully processed and :data:`MS_FAILURE` (1) 
-    if an OWS request was not successfully processed. OWS requests include WMS, WFS, WCS 
-    and SOS requests supported by MapServer. Results of a dispatched request are written to 
-    stdout and can be captured using the msIO services (i.e. :func:`mapscript.msIO_installStdoutToBuffer` 
-    and :func:`mapscript.msIO_getStdoutBufferString()`
-    */
-    int OWSDispatch( cgiRequestObj *req )
-    {
-        return msOWSDispatch( self, req, MS_TRUE );
-    }
-
-    %newobject convertToString;
-    /// Saves the object to a string. Provides the inverse option for updateFromString.
-    char* convertToString()
-    {
-        return msWriteMapToString(self);
-    }
-
-    /// Apply any default values defined in a VALIDATION block used for runtime substitutions
-    void applyDefaultSubstitutions()
-    {
-        msApplyDefaultSubstitutions(self);
-    }
-
-    /**
-    Pass in runtime substitution keys and values and apply them to the map. 
-    Note - this method is currently enabled for Python only. 
-    Typemaps are needed for other MapScript languages.
-    */
-    void applySubstitutions(char **names, char **values, int npairs)
-    {
-        msApplySubstitutions(self, names, values, npairs);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/mapzoom.i 8.2.0~beta1-1~exp1/mapscript/swiginc/mapzoom.i
--- 8.0.1-5/mapscript/swiginc/mapzoom.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/mapzoom.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,571 +0,0 @@
-/******************************************************************************
- * Project:  MapServer
- * Purpose:  Map zooming convenience methods for MapScript
- * Author:   Sean Gillies, sgillies@frii.com
- *
- ******************************************************************************
- *
- * These functions are adapted from the code in php_mapscript.c.
- *
- *****************************************************************************/
-
-%extend mapObj {
-
-    /**
-    Zoom by the given factor to a pixel position within the width
-    and height bounds. If max_extent is not NULL, the zoom is 
-    constrained to the max_extents
-
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-
-    */
-    int zoomPoint(int zoomfactor, pointObj *poPixPos, int width, int height, rectObj *poGeorefExt, rectObj *poMaxGeorefExt)
-    {
-        double      dfGeoPosX, dfGeoPosY;
-        double      dfDeltaX, dfDeltaY;
-        rectObj     oNewGeorefExt;    
-        double      dfNewScale;
-        int         bMaxExtSet;
-        double      dfDeltaExt;
-        double dX, dY;
-        
-        dfNewScale = 0.0;
-        bMaxExtSet = 0;
-        dfDeltaExt = -1.0;
-
-        if (poMaxGeorefExt != NULL) { bMaxExtSet = 1; }
-
-        /* ----------------------------------------------------------- */
-        /*      check the validity of the parameters.                  */
-        /* ----------------------------------------------------------- */
-        if (zoomfactor == 0 || width <= 0 || height <= 0 || poGeorefExt == NULL || poPixPos == NULL) {
-            msSetError(MS_MISCERR, "Incorrect arguments", "mapscript::mapObj::zoomPoint()");
-            return MS_FAILURE;
-        }
-
-        /* ----------------------------------------------------------- */
-        /*      check if the values passed are consistent min > max.   */
-        /* ----------------------------------------------------------- */
-        if (poGeorefExt->minx >= poGeorefExt->maxx)  {
-            msSetError(MS_MISCERR, "Georeferenced coordinates minx >= maxx",  "mapscript::mapObj::zoomPoint()");
-            return MS_FAILURE;
-        }
-        if (poGeorefExt->miny >= poGeorefExt->maxy)  {
-            msSetError(MS_MISCERR, "Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomPoint()");
-            return MS_FAILURE;
-        }
-
-        if (bMaxExtSet == 1) {
-            if (poMaxGeorefExt->minx >= poMaxGeorefExt->maxx) {
-                msSetError(MS_MISCERR, "Max Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomPoint()");
-                return MS_FAILURE;
-            }
-            if (poMaxGeorefExt->miny >= poMaxGeorefExt->maxy) {
-                msSetError(MS_MISCERR, "Max Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomPoint()");
-            }
-        }
-   
-        dfDeltaX = poGeorefExt->maxx - poGeorefExt->minx;
-        dfDeltaY = poGeorefExt->maxy - poGeorefExt->miny;
-        dX = dfDeltaX/((double)width);
-        dY = dfDeltaY/((double)height);
-        dfGeoPosX = poGeorefExt->minx + dX * (double)poPixPos->x;
-        dfGeoPosY = poGeorefExt->maxy - dY * (double)poPixPos->y;
-
-        if (self->gt.rotation_angle != 0) {
-            dfGeoPosX = self->gt.geotransform[0] + self->gt.geotransform[1] * (double)poPixPos->x + self->gt.geotransform[2] * (double)poPixPos->y;
-            dfGeoPosY = self->gt.geotransform[3] + self->gt.geotransform[4] * (double)poPixPos->x + self->gt.geotransform[5] * (double)poPixPos->y;
-        }
-        
-        /* --- -------------------------------------------------------- */
-        /*      zoom in                                                 */
-        /* ------------------------------------------------------------ */
-        if (zoomfactor > 1) {
-            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaX/(2*zoomfactor));        
-            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaY/(2*zoomfactor));        
-            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaX/(2*zoomfactor));        
-            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaY/(2*zoomfactor));
-        }
-
-        if (zoomfactor < 0) {
-            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaX/2)*(abs(zoomfactor));    
-            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaY/2)*(abs(zoomfactor));    
-            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaX/2)*(abs(zoomfactor));    
-            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaY/2)*(abs(zoomfactor));
-        }
-
-        if (zoomfactor == 1) {
-            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaX/2);
-            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaY/2);
-            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaX/2);
-            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaY/2);
-        }
-
-        /* ------------------------------------------------------------ */
-        /*   if the min and max scale are set in the map file, we will  */
-        /*   use them to test before zooming.                           */
-        /* ------------------------------------------------------------ */
-        msAdjustExtent(&oNewGeorefExt, self->width, self->height);
-        msCalculateScale(oNewGeorefExt, self->units, self->width, self->height, self->resolution, &dfNewScale);
-    
-        if (self->web.maxscaledenom > 0) {
-            if (zoomfactor < 0 && dfNewScale > self->web.maxscaledenom) {
-                return MS_FAILURE;
-            }
-        }
-
-        /* ============================================================ */
-        /*  we do a special case for zoom in : we try to zoom as much as */
-        /*  possible using the mincale set in the .map.                 */
-        /* ============================================================ */
-        if (self->web.minscaledenom > 0 && dfNewScale < self->web.minscaledenom && zoomfactor > 1) {
-            /* To be consistent in swig mapscript and PHP mapscript, 
-               use the same function to calculate the delta extents. */
-            dfDeltaExt = GetDeltaExtentsUsingScale(self->web.minscaledenom, self->units, dfGeoPosY, 
-                                                   self->width, self->resolution);
-
-            if (dfDeltaExt > 0.0) {
-                oNewGeorefExt.minx = dfGeoPosX - (dfDeltaExt/2);
-                oNewGeorefExt.miny = dfGeoPosY - (dfDeltaExt/2);
-                oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaExt/2);
-                oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaExt/2);
-            } else
-                return MS_FAILURE;
-        }
-
-        /* ------------------------------------------------------------ */
-        /*  If the buffer is set, make sure that the extents do not go  */
-        /*  beyond the buffer.                                          */
-        /* ------------------------------------------------------------ */
-        if (bMaxExtSet) {
-            dfDeltaX = oNewGeorefExt.maxx - oNewGeorefExt.minx;
-            dfDeltaY = oNewGeorefExt.maxy - oNewGeorefExt.miny;
-        
-            /* Make sure Current georef extents is not bigger than 
-             * max extents */
-            if (dfDeltaX > (poMaxGeorefExt->maxx-poMaxGeorefExt->minx))
-                dfDeltaX = poMaxGeorefExt->maxx-poMaxGeorefExt->minx;
-            if (dfDeltaY > (poMaxGeorefExt->maxy-poMaxGeorefExt->miny))
-                dfDeltaY = poMaxGeorefExt->maxy-poMaxGeorefExt->miny;
-
-            if (oNewGeorefExt.minx < poMaxGeorefExt->minx) {
-                oNewGeorefExt.minx = poMaxGeorefExt->minx;
-                oNewGeorefExt.maxx =  oNewGeorefExt.minx + dfDeltaX;
-            }
-            if (oNewGeorefExt.maxx > poMaxGeorefExt->maxx) {
-                oNewGeorefExt.maxx = poMaxGeorefExt->maxx;
-                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
-            }
-            if (oNewGeorefExt.miny < poMaxGeorefExt->miny) {
-                oNewGeorefExt.miny = poMaxGeorefExt->miny;
-                oNewGeorefExt.maxy =  oNewGeorefExt.miny + dfDeltaY;
-            }
-            if (oNewGeorefExt.maxy > poMaxGeorefExt->maxy) {
-                oNewGeorefExt.maxy = poMaxGeorefExt->maxy;
-                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
-            }
-        }
-    
-        /* ------------------------------------------------------------ */
-        /*      set the map extents with new values.                    */
-        /* ------------------------------------------------------------ */
-        self->extent.minx = oNewGeorefExt.minx;
-        self->extent.miny = oNewGeorefExt.miny;
-        self->extent.maxx = oNewGeorefExt.maxx;
-        self->extent.maxy = oNewGeorefExt.maxy;
-    
-        self->cellsize = msAdjustExtent(&(self->extent), self->width, self->height);      
-        dfDeltaX = self->extent.maxx - self->extent.minx;
-        dfDeltaY = self->extent.maxy - self->extent.miny; 
-
-        if (bMaxExtSet) {
-            if (self->extent.minx < poMaxGeorefExt->minx) {
-                self->extent.minx = poMaxGeorefExt->minx;
-                self->extent.maxx = self->extent.minx + dfDeltaX;
-            }
-            if (self->extent.maxx > poMaxGeorefExt->maxx) {
-                self->extent.maxx = poMaxGeorefExt->maxx;
-                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
-            }
-            if (self->extent.miny < poMaxGeorefExt->miny) {
-                self->extent.miny = poMaxGeorefExt->miny;
-                self->extent.maxy =  self->extent.miny + dfDeltaY;
-            }
-            if (self->extent.maxy > poMaxGeorefExt->maxy) {
-                self->extent.maxy = poMaxGeorefExt->maxy;
-                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
-            }
-        }
-    
-        msCalculateScale(self->extent, self->units, self->width, self->height, self->resolution, &(self->scaledenom));
-
-        return MS_SUCCESS;
-    }
-
-    /**
-    Set the map extents to a given extents. 
-    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE` on error
-    */
-    int zoomRectangle(rectObj *poPixRect, int width, int height, rectObj *poGeorefExt, rectObj *poMaxGeorefExt)
-    {
-        double      dfDeltaX, dfDeltaY;
-        rectObj     oNewGeorefExt;    
-        double      dfNewScale;
-        double      dfDeltaExt;
-        double dfMiddleX, dfMiddleY;
-        int bMaxExtSet;
-        
-        bMaxExtSet = 0;
-        dfNewScale = 0.0;
-        dfDeltaExt = -1.0;
-
-        if (poMaxGeorefExt != NULL) bMaxExtSet = 1;
-
-        /* ----------------------------------------------------------- */
-        /*      check the validity of the parameters.                  */
-        /* ----------------------------------------------------------- */
-        if (poPixRect == 0 || width <= 0 || height <= 0 || poGeorefExt == NULL) {
-            msSetError(MS_MISCERR, "Incorrect arguments", "mapscript::mapObj::zoomRectangle");
-            return MS_FAILURE;
-        }
-
-        /* ----------------------------------------------------------- */
-        /*      check if the values passed are consistent min <= max.   */
-        /* ----------------------------------------------------------- */
-        if (poPixRect->minx >= poPixRect->maxx) {
-            msSetError(MS_MISCERR, "image rectangle minx >= maxx", "mapscript::mapObj::zoomRectangle()");
-            return MS_FAILURE;
-        }
-        /* This is not a typo: "maxx >= minx". For historical reason, we
-         * keep this as it is. See documentation for more info about this check. */
-        if (poPixRect->maxy >= poPixRect->miny) {
-            msSetError(MS_MISCERR, "image rectangle maxy >= miny", "mapscript::mapObj::zoomRectangle()");
-            return MS_FAILURE;
-        }
-
-        if (poGeorefExt->minx >= poGeorefExt->maxx) {
-            msSetError(MS_MISCERR, "Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomRectangle()");
-            return MS_FAILURE;
-        }
-        if (poGeorefExt->miny >= poGeorefExt->maxy) {
-            msSetError(MS_MISCERR, "Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomRectangle()");
-            return MS_FAILURE;
-        }
-
-        if (bMaxExtSet == 1) {
-            if (poMaxGeorefExt->minx >= poMaxGeorefExt->maxx) {
-                msSetError(MS_MISCERR,  "Max Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomRectangle()");
-                return MS_FAILURE;
-            }
-            if (poMaxGeorefExt->miny >= poMaxGeorefExt->maxy) {
-                msSetError(MS_MISCERR, "Max Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomRectangle()");
-                return MS_FAILURE;
-            }
-        }
-
-  
-        /* ----------------------------------------------------------- */
-        /*   Convert pixel rectangle to georeferenced rectangle        */
-        /* ----------------------------------------------------------- */
-        
-        dfDeltaX = poGeorefExt->maxx - poGeorefExt->minx;
-        dfDeltaY = poGeorefExt->maxy - poGeorefExt->miny;
-
-        oNewGeorefExt.minx = Pix2Georef((int)poPixRect->minx, 0, width, poGeorefExt->minx, poGeorefExt->maxx, 0); 
-        oNewGeorefExt.maxx = Pix2Georef((int)poPixRect->maxx, 0, width, poGeorefExt->minx, poGeorefExt->maxx, 0); 
-        oNewGeorefExt.miny = Pix2Georef((int)poPixRect->miny, 0, height, poGeorefExt->miny, poGeorefExt->maxy, 1); 
-        oNewGeorefExt.maxy = Pix2Georef((int)poPixRect->maxy, 0, height, poGeorefExt->miny, poGeorefExt->maxy, 1); 
-
-        msAdjustExtent(&oNewGeorefExt, self->width, self->height);
-
-        /* ------------------------------------------------------------ */
-        /*   if the min and max scale are set in the map file, we will  */
-        /*   use them to test before setting extents.                   */
-        /* ------------------------------------------------------------ */
-        msCalculateScale(oNewGeorefExt, self->units, self->width, self->height, self->resolution, &dfNewScale);
-
-        if (self->web.maxscaledenom > 0 &&  dfNewScale > self->web.maxscaledenom)
-            return MS_FAILURE;
-
-        if (self->web.minscaledenom > 0 && dfNewScale <  self->web.minscaledenom) {
-            dfMiddleX = oNewGeorefExt.minx + ((oNewGeorefExt.maxx - oNewGeorefExt.minx)/2);
-            dfMiddleY = oNewGeorefExt.miny + ((oNewGeorefExt.maxy - oNewGeorefExt.miny)/2);
-
-            /* To be consistent in swig mapscript and PHP mapscript, 
-               use the same function to calculate the delta extents. */
-            dfDeltaExt = GetDeltaExtentsUsingScale(self->web.minscaledenom, self->units, dfMiddleY, self->width, self->resolution);
-
-            if (dfDeltaExt > 0.0) {
-                oNewGeorefExt.minx = dfMiddleX - (dfDeltaExt/2);
-                oNewGeorefExt.miny = dfMiddleY - (dfDeltaExt/2);
-                oNewGeorefExt.maxx = dfMiddleX + (dfDeltaExt/2);
-                oNewGeorefExt.maxy = dfMiddleY + (dfDeltaExt/2);
-            } else
-                return MS_FAILURE;
-        }
-
-        /* ------------------------------------------------------------ */
-        /*  If the buffer is set, make sure that the extents do not go  */
-        /*  beyond the buffer.                                          */
-        /* ------------------------------------------------------------ */
-        if (bMaxExtSet) {
-            dfDeltaX = oNewGeorefExt.maxx - oNewGeorefExt.minx;
-            dfDeltaY = oNewGeorefExt.maxy - oNewGeorefExt.miny;
-        
-            /* Make sure Current georef extents is not bigger 
-             * than max extents */
-            if (dfDeltaX > (poMaxGeorefExt->maxx-poMaxGeorefExt->minx))
-                dfDeltaX = poMaxGeorefExt->maxx-poMaxGeorefExt->minx;
-            if (dfDeltaY > (poMaxGeorefExt->maxy-poMaxGeorefExt->miny))
-                dfDeltaY = poMaxGeorefExt->maxy-poMaxGeorefExt->miny;
-
-            if (oNewGeorefExt.minx < poMaxGeorefExt->minx) {
-                oNewGeorefExt.minx = poMaxGeorefExt->minx;
-                oNewGeorefExt.maxx =  oNewGeorefExt.minx + dfDeltaX;
-            }
-            if (oNewGeorefExt.maxx > poMaxGeorefExt->maxx) {
-                oNewGeorefExt.maxx = poMaxGeorefExt->maxx;
-                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
-            }
-            if (oNewGeorefExt.miny < poMaxGeorefExt->miny) {
-                oNewGeorefExt.miny = poMaxGeorefExt->miny;
-                oNewGeorefExt.maxy =  oNewGeorefExt.miny + dfDeltaY;
-            }
-            if (oNewGeorefExt.maxy > poMaxGeorefExt->maxy) {
-                oNewGeorefExt.maxy = poMaxGeorefExt->maxy;
-                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
-            }
-        }
-
-        self->extent.minx = oNewGeorefExt.minx;
-        self->extent.miny = oNewGeorefExt.miny;
-        self->extent.maxx = oNewGeorefExt.maxx;
-        self->extent.maxy = oNewGeorefExt.maxy;
-
-        self->cellsize = msAdjustExtent(&(self->extent), self->width, self->height);    
-        dfDeltaX = self->extent.maxx - self->extent.minx;
-        dfDeltaY = self->extent.maxy - self->extent.miny; 
-
-        if (bMaxExtSet) {
-            if (self->extent.minx < poMaxGeorefExt->minx) {
-                self->extent.minx = poMaxGeorefExt->minx;
-                self->extent.maxx = self->extent.minx + dfDeltaX;
-            }
-            if (self->extent.maxx > poMaxGeorefExt->maxx) {
-                self->extent.maxx = poMaxGeorefExt->maxx;
-                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
-            }
-            if (self->extent.miny < poMaxGeorefExt->miny) {
-                self->extent.miny = poMaxGeorefExt->miny;
-                self->extent.maxy =  self->extent.miny + dfDeltaY;
-            }
-            if (self->extent.maxy > poMaxGeorefExt->maxy) {
-                self->extent.maxy = poMaxGeorefExt->maxy;
-                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
-            }
-        }
-
-        msCalculateScale(self->extent, self->units, self->width,  self->height, self->resolution, &(self->scaledenom));
-
-        return MS_SUCCESS;
-    }
-
-    /**
-     Zoom by the given factor to a pixel position within the width
-     and height bounds.  If max_extent is not NULL, the zoom is 
-     constrained to the max_extents
-    */
-    int zoomScale(double scale, pointObj *poPixPos, int width, int height,
-                  rectObj *poGeorefExt, rectObj *poMaxGeorefExt)
-    {
-        double      dfGeoPosX, dfGeoPosY;
-        double      dfDeltaX, dfDeltaY;
-        rectObj     oNewGeorefExt;    
-        double      dfNewScale, dfCurrentScale;
-        int         bMaxExtSet;
-        int nTmp;
-        double      dfDeltaExt;
-        double dX, dY;
-        
-        dfNewScale = 0.0;
-        dfCurrentScale = 0.0;
-        nTmp = 0;
-        bMaxExtSet = 0;
-        dfDeltaExt = -1.0;
-
-        if (poMaxGeorefExt != NULL) { bMaxExtSet = 1; }
-
-        /* ----------------------------------------------------------- */
-        /*      check the validity of the parameters.                  */
-        /* ----------------------------------------------------------- */
-        if (scale <= 0.0 || width <= 0 || height <= 0 || poGeorefExt == NULL || poPixPos == NULL ) {
-            msSetError(MS_MISCERR, "Incorrect arguments", "mapscript::mapObj::zoomScale");
-            return MS_FAILURE;
-        }
-
-        /* ----------------------------------------------------------- */
-        /*      check if the values passed are consistent min > max.   */
-        /* ----------------------------------------------------------- */
-        if (poGeorefExt->minx >= poGeorefExt->maxx) {
-            msSetError(MS_MISCERR, "Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomScale()");
-            return MS_FAILURE;
-        }
-        if (poGeorefExt->miny >= poGeorefExt->maxy) {
-            msSetError(MS_MISCERR, "Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomScale()");
-            return MS_FAILURE;
-        }
-
-        if (bMaxExtSet == 1) {
-            if (poMaxGeorefExt->minx >= poMaxGeorefExt->maxx) {
-                msSetError(MS_MISCERR, "Max Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomScale()");
-                return MS_FAILURE;
-            }
-            if (poMaxGeorefExt->miny >= poMaxGeorefExt->maxy) {
-                msSetError(MS_MISCERR,  "Max Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomScale()");
-            }
-        }
-   
-        dfDeltaX = poGeorefExt->maxx - poGeorefExt->minx;
-        dfDeltaY = poGeorefExt->maxy - poGeorefExt->miny;
-        dX = dfDeltaX/((double)width);
-        dY = dfDeltaY/((double)height);
-        dfGeoPosX = poGeorefExt->minx + dX * (double)poPixPos->x;
-        dfGeoPosY = poGeorefExt->maxy - dY * (double)poPixPos->y;
-
-        if (self->gt.rotation_angle != 0) {
-            dfGeoPosX = self->gt.geotransform[0] + self->gt.geotransform[1] * (double)poPixPos->x + self->gt.geotransform[2] * (double)poPixPos->y;
-            dfGeoPosY = self->gt.geotransform[3] + self->gt.geotransform[4] * (double)poPixPos->x + self->gt.geotransform[5] * (double)poPixPos->y;
-        }
-        
-        /* ------------------------------------------------------------ */
-        /*  Calculate new extents based on the scale.                   */
-        /* ------------------------------------------------------------ */
-
-        /* ============================================================ */
-        /*  make sure to take the smallest size because this is the one */
-        /*  that will be used to ajust the scale.                       */
-        /* ============================================================ */
-
-        if (self->width <  self->height)
-            nTmp = self->width;
-        else
-            nTmp = self->height;
-
-        /* To be consistent in swig mapscript and PHP mapscript, 
-           use the same function to calculate the delta extents. */
-        dfDeltaExt = GetDeltaExtentsUsingScale(scale, self->units, dfGeoPosY, nTmp, self->resolution);
-
-        if (dfDeltaExt > 0.0) {
-            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaExt/2);
-            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaExt/2);
-            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaExt/2);
-            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaExt/2);
-        } else
-            return MS_FAILURE;
-
-        /* ------------------------------------------------------------ */
-        /*   get current scale.                                         */
-        /* ------------------------------------------------------------ */
-        msCalculateScale(*poGeorefExt, self->units, self->width, self->height, self->resolution, &dfCurrentScale);
-
-        /* ------------------------------------------------------------ *
-         *   if the min and max scale are set in the map file, we will  *
-         *   use them to test before zooming.                           *
-         *                                                              *
-         *   This function has the same effect as zoomin or zoom out.
-         *   If the current scale is > newscale we zoom in; else it is
-         *   a zoom out.
-         * ------------------------------------------------------------ */
-        msAdjustExtent(&oNewGeorefExt, self->width, self->height);
-        msCalculateScale(oNewGeorefExt, self->units, self->width, self->height, self->resolution, &dfNewScale);
-
-        if (self->web.maxscaledenom > 0) {
-            if (dfCurrentScale < dfNewScale && dfNewScale >  self->web.maxscaledenom) {
-                return MS_FAILURE;
-            }
-        }
-
-        /* ============================================================ */
-        /* we do a special case for zoom in : we try to zoom as much as */
-        /* possible using the mincale set in the .map.                  */
-        /* ============================================================ */
-        if (self->web.minscaledenom > 0 && dfNewScale <  self->web.minscaledenom && dfCurrentScale > dfNewScale) {
-            /* To be consistent in swig mapscript and PHP mapscript, 
-               use the same function to calculate the delta extents. */
-            dfDeltaExt = GetDeltaExtentsUsingScale(scale, self->units, dfGeoPosY, nTmp, self->resolution);
-            if (dfDeltaExt > 0.0) {
-                oNewGeorefExt.minx = dfGeoPosX - (dfDeltaExt/2);
-                oNewGeorefExt.miny = dfGeoPosY - (dfDeltaExt/2);
-                oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaExt/2);
-                oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaExt/2);
-            } else
-                return MS_FAILURE;
-        }
-
-        /* ------------------------------------------------------------ */
-        /*  If the buffer is set, make sure that the extents do not go  */
-        /*  beyond the buffer.                                          */
-        /* ------------------------------------------------------------ */
-        if (bMaxExtSet) {
-            dfDeltaX = oNewGeorefExt.maxx - oNewGeorefExt.minx;
-            dfDeltaY = oNewGeorefExt.maxy - oNewGeorefExt.miny;
-        
-            /* Make sure Current georef extents is not bigger 
-             * than max extents */
-            if (dfDeltaX > (poMaxGeorefExt->maxx-poMaxGeorefExt->minx))
-                dfDeltaX = poMaxGeorefExt->maxx-poMaxGeorefExt->minx;
-            if (dfDeltaY > (poMaxGeorefExt->maxy-poMaxGeorefExt->miny))
-                dfDeltaY = poMaxGeorefExt->maxy-poMaxGeorefExt->miny;
-
-            if (oNewGeorefExt.minx < poMaxGeorefExt->minx) {
-                oNewGeorefExt.minx = poMaxGeorefExt->minx;
-                oNewGeorefExt.maxx =  oNewGeorefExt.minx + dfDeltaX;
-            }
-            if (oNewGeorefExt.maxx > poMaxGeorefExt->maxx) {
-                oNewGeorefExt.maxx = poMaxGeorefExt->maxx;
-                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
-            }
-            if (oNewGeorefExt.miny < poMaxGeorefExt->miny) {
-                oNewGeorefExt.miny = poMaxGeorefExt->miny;
-                oNewGeorefExt.maxy =  oNewGeorefExt.miny + dfDeltaY;
-            }
-            if (oNewGeorefExt.maxy > poMaxGeorefExt->maxy) {
-                oNewGeorefExt.maxy = poMaxGeorefExt->maxy;
-                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
-            }
-        }
-
-        self->extent.minx = oNewGeorefExt.minx;
-        self->extent.miny = oNewGeorefExt.miny;
-        self->extent.maxx = oNewGeorefExt.maxx;
-        self->extent.maxy = oNewGeorefExt.maxy;
-    
-        self->cellsize = msAdjustExtent(&(self->extent), self->width, self->height);    
-        dfDeltaX = self->extent.maxx - self->extent.minx;
-        dfDeltaY = self->extent.maxy - self->extent.miny; 
-
-        if (bMaxExtSet) {
-            if (self->extent.minx < poMaxGeorefExt->minx) {
-                self->extent.minx = poMaxGeorefExt->minx;
-                self->extent.maxx = self->extent.minx + dfDeltaX;
-            }
-            if (self->extent.maxx > poMaxGeorefExt->maxx) {
-                self->extent.maxx = poMaxGeorefExt->maxx;
-                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
-            }
-            if (self->extent.miny < poMaxGeorefExt->miny) {
-                self->extent.miny = poMaxGeorefExt->miny;
-                self->extent.maxy =  self->extent.miny + dfDeltaY;
-            }
-            if (self->extent.maxy > poMaxGeorefExt->maxy) {
-                self->extent.maxy = poMaxGeorefExt->maxy;
-                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
-            }
-        }
-
-        msCalculateScale(self->extent, self->units, self->width, self->height, self->resolution, &(self->scaledenom));
-
-        return MS_SUCCESS;
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/swiginc/msio.i 8.2.0~beta1-1~exp1/mapscript/swiginc/msio.i
--- 8.0.1-5/mapscript/swiginc/msio.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/msio.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,118 +0,0 @@
-/******************************************************************************
- * Project:  MapServer
- * Purpose:  Definitions for MapServer IO redirection capability.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- * Note:
- * copied from mapio.h to avoid to much #ifdef swigging
- *
- ******************************************************************************
- * Copyright (c) 2004, Frank Warmerdam <warmerdam@pobox.com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in 
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/// Resets the default stdin and stdout handlers in place of buffer based handlers.
-void msIO_resetHandlers(void);
-
-/// Installs a mapserver IO handler directing future stdout output to a memory buffer.
-void msIO_installStdoutToBuffer(void);
-
-/// Installs a mapserver IO handler directing future stdin reading 
-/// (i.e. post request capture) to come from a buffer.
-void msIO_installStdinFromBuffer(void);
-
-%newobject msIO_stripStdoutBufferContentType;
-/// Strip the Content-type header off the stdout buffer if it has one, and if a content type 
-/// is found it is returned (otherwise NULL/None/etc).
-const char *msIO_stripStdoutBufferContentType();
-
-/// Strip all Content-* headers off the stdout buffer if it has any.
-void msIO_stripStdoutBufferContentHeaders(void);
-
-/* mapscript only extensions */
-
-/// Fetch the current stdout buffer contents as a string. 
-/// This method does not clear the buffer.
-const char *msIO_getStdoutBufferString(void);
-
-/// Fetch the current stdout buffer contents as a binary buffer. The exact form of this buffer will vary by 
-/// MapScript language (e/g. string in Python, byte[] array in Java and C#, unhandled in Perl).
-gdBuffer msIO_getStdoutBufferBytes(void);
-
-%newobject msIO_getAndStripStdoutBufferMimeHeaders;
-/// Strip off all MIME headers and return them in a hashTableObj
-hashTableObj* msIO_getAndStripStdoutBufferMimeHeaders(void);
-
-%{
-
-const char *msIO_getStdoutBufferString() {
-    msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-    msIOBuffer  *buf;
-
-    if( ctx == NULL || ctx->write_channel == MS_FALSE 
-        || strcmp(ctx->label,"buffer") != 0 )
-    {
-        msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                    "msIO_getStdoutBufferString" );
-        return "";
-    }
-
-    buf = (msIOBuffer *) ctx->cbData;
-
-    /* write one zero byte and backtrack if it isn't already there */
-    if( buf->data_len == 0 || buf->data[buf->data_offset] != '\0' ) {
-        msIO_bufferWrite( buf, "", 1 );
-        buf->data_offset--;
-    }
-
-    return (const char *) (buf->data);
-}
-
-gdBuffer msIO_getStdoutBufferBytes() {
-    msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-    msIOBuffer  *buf;
-    gdBuffer     gdBuf;
-
-    if( ctx == NULL || ctx->write_channel == MS_FALSE 
-        || strcmp(ctx->label,"buffer") != 0 )
-    {
-        msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                        "msIO_getStdoutBufferString" );
-        gdBuf.data = (unsigned char*)"";
-        gdBuf.size = 0;
-        gdBuf.owns_data = MS_FALSE;
-        return gdBuf;
-    }
-
-    buf = (msIOBuffer *) ctx->cbData;
-
-    gdBuf.data = buf->data;
-    gdBuf.size = buf->data_offset;
-    gdBuf.owns_data = MS_TRUE;
-
-    /* we are seizing ownership of the buffer contents */
-    buf->data_offset = 0;
-    buf->data_len = 0;
-    buf->data = NULL;
-
-    return gdBuf;
-}
-
-%}
diff -pruN 8.0.1-5/mapscript/swiginc/outputformat.i 8.2.0~beta1-1~exp1/mapscript/swiginc/outputformat.i
--- 8.0.1-5/mapscript/swiginc/outputformat.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/outputformat.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,126 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript outputFormatObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend outputFormatObj 
-{
-    /// Create new instance. If name is not provided, the value of driver is used as a name.
-    outputFormatObj(const char *driver, char *name=NULL) 
-    {
-        outputFormatObj *format;
-
-        format = msCreateDefaultOutputFormat(NULL, driver, name, NULL);
-
-        /* in the case of unsupported formats, msCreateDefaultOutputFormat
-           should return NULL */
-        if (!format)
-        {
-            msSetError(MS_MISCERR, "Unsupported format driver: %s",
-                       "outputFormatObj()", driver);
-            return NULL;
-        }
-        
-        msInitializeRendererVTable(format);
-
-        MS_REFCNT_INIT(format);
-        format->inmapfile = MS_TRUE;
-
-        return format;
-    }
-
-    ~outputFormatObj() 
-    {
-        msFreeOutputFormat( self );
-    }
-
-    /**
-    * Set file extension for output format such as  'png' or 'jpg'. 
-    * Method could probably be deprecated since the extension attribute is mutable.
-    * Not in Java extension.
-    */
-#ifndef SWIGJAVA
-    void setExtension( const char *extension ) 
-    {
-        msFree( self->extension );
-        self->extension = msStrdup(extension);
-    }
-
-    /**
-    * Set mimetype for output format such as ``image/png`` or ``image/jpeg``.
-    * Method could probably be deprecated since the mimetype attribute is mutable.
-    * Not in Java extension
-    */
-    void setMimetype( const char *mimetype ) 
-    {
-        msFree( self->mimetype );
-        self->mimetype = msStrdup(mimetype);
-    }
-#endif
-
-    /// Set the format option at ``key`` to ``value``. Format options are mostly driver specific.
-    void setOption( const char *key, const char *value ) 
-    {
-        msSetOutputFormatOption( self, key, value );
-    }
-
-    /// Checks some internal consistency issues, and returns :data:`MS_TRUE` 
-    /// if things are OK and :data:`MS_FALSE` if there are problems. 
-    /// Some problems are fixed up internally. May produce debug output if issues encountered.
-    int validate() 
-    {
-        return msOutputFormatValidate(self, MS_FALSE );
-    }
-
-    %newobject getOption;
-    /// Return the format option at ``key`` or ``defaultvalue`` 
-    /// if key is not a valid hash index.
-    char *getOption(const char *key, const char *value="") 
-    {
-        return msStrdup(msGetOutputFormatOption(self, key, value));
-    }
-
-    %newobject getOptionAt;
-    /**
-    * Returns the option at ``idx`` or NULL if the index is beyond the array bounds. 
-    * The option is returned as the original KEY=VALUE string. 
-    * The number of available options can be obtained via :attr:`outputFormatObj.numformatoptions`
-    */
-    char* getOptionAt(int i) {
-       if( i >= 0 && i < self->numformatoptions ) {
-          return msStrdup(self->formatoptions[i]);
-       }
-       return NULL;
-    }
-
-    /// Set the device property of the output format
-    void attachDevice( void *device ) 
-    {
-        self->device = device;
-    }
-    
-}
diff -pruN 8.0.1-5/mapscript/swiginc/owsrequest.i 8.2.0~beta1-1~exp1/mapscript/swiginc/owsrequest.i
--- 8.0.1-5/mapscript/swiginc/owsrequest.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/owsrequest.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,207 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for manipulating OGC request stuff via
-             mapscript.
-   Author:   Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 2004 Sean Gillies
-   Copyright (c) 2006 Frank Warmerdam
-   Copyright (c) 1996-2007 Regents of the University of Minnesota.
-       
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-
-%{
-/**
-The following functions are used to simulate the CGI environment for a request
-and return default values when a environment key is passed in
-*/
-static char *msGetEnvURL( const char *key, void *thread_context )
-{
-    if( strcmp(key,"REQUEST_METHOD") == 0 )
-        return "GET";
-
-    if( strcmp(key,"QUERY_STRING") == 0 )
-        return (char *) thread_context;
-
-    return NULL;
-}
-
-static char *msPostEnvURL(const char *key, void *thread_context)
-{
-    if (strcmp(key, "REQUEST_METHOD") == 0)
-        return "POST";
-
-    if (strcmp(key, "QUERY_STRING") == 0)
-        return (char *)thread_context;
-
-    return NULL;
-}
-%}
-
-%rename(OWSRequest) cgiRequestObj;
-
-// include has to be placed here
-%include "../../cgiutil.h"
-
-/* Class for programming OWS services - SG */
-
-%extend cgiRequestObj {
-
-    /**
-    Not associated with other mapscript classes. Serves as a message intermediary 
-    between an application and MapServer's OWS capabilities. Using it permits creation 
-    of lightweight WMS services.
-    */
-    cgiRequestObj()
-    {
-        cgiRequestObj *request;
-
-        request = msAllocCgiObj();
-        if (!request) {
-            msSetError(MS_CGIERR, "Failed to initialize object","OWSRequest()");
-            return NULL;
-        }
-        
-        return request;
-    }
-
-    ~cgiRequestObj()
-    {
-        msFreeCgiObj(self);
-    }
-
-    /**
-    Initializes the OWSRequest object from the cgi environment variables 
-    ``REQUEST_METHOD``, ``QUERY_STRING`` and ``HTTP_COOKIE``. 
-    Returns the number of name/value pairs collected. 
-    Warning: most errors will result in a process exit!
-    */
-    int loadParams()
-    {
-        self->NumParams = loadParams( self, NULL, NULL, 0, NULL);
-        return self->NumParams;
-    }
-
-    /**
-    Initializes the OWSRequest object from the provided URL which is 
-    treated like a ``QUERY_STRING``. 
-    Note that ``REQUEST_METHOD=GET`` and no post data is assumed in this case. 
-    */
-    int loadParamsFromURL( const char *url )
-    {
-        self->NumParams = loadParams( self, msGetEnvURL, NULL, 0, (void*)url );
-        return self->NumParams;
-    }
-
-    /**
-    Initializes the OWSRequest object with POST data, along with a the provided URL which is
-    treated like a ``QUERY_STRING``.
-    Note that ``REQUEST_METHOD=POST`` and the caller is responsible for setting the correct
-    content type e.g. ``req.contenttype = "application/xml"``
-    */
-    int loadParamsFromPost( char *postData, const char *url)
-    {
-        self->NumParams = loadParams( self, msPostEnvURL, msStrdup(postData), (ms_uint32) strlen(postData), (void*)url);
-        return self->NumParams;
-    }
-
-    /**
-    Set a request parameter. For example:
-    
-    request.setParameter('REQUEST', 'GetMap')
-    request.setParameter('BBOX', '-107.0,40.0,-106.0,41.0')
-    */
-    void setParameter(char *name, char *value) 
-    {
-        int i;
-        
-        if (self->NumParams == MS_DEFAULT_CGI_PARAMS) {
-            msSetError(MS_CHILDERR, "Maximum number of items, %d, has been reached", "setItem()", MS_DEFAULT_CGI_PARAMS);
-        }
-        
-        for (i=0; i<self->NumParams; i++) {
-            if (strcasecmp(self->ParamNames[i], name) == 0) {
-                free(self->ParamValues[i]);
-                self->ParamValues[i] = msStrdup(value);
-                break;
-            }
-        }
-        if (i == self->NumParams) {
-            self->ParamNames[self->NumParams] = msStrdup(name);
-            self->ParamValues[self->NumParams] = msStrdup(value);
-            self->NumParams++;
-        }
-    }
-
-    /**
-    Add a request parameter, even if the parameter key was previously set. 
-    This is useful when multiple parameters with the same key are required. 
-    For example: 
-    request.addParameter('SIZE', 'x(100)')
-    request.addParameter('SIZE', 'y(100)')
-    */
-    void addParameter(char *name, char *value)
-    {
-        if (self->NumParams == MS_DEFAULT_CGI_PARAMS) {
-            msSetError(MS_CHILDERR, "Maximum number of items, %d, has been reached", "addParameter()", MS_DEFAULT_CGI_PARAMS);
-        }
-        self->ParamNames[self->NumParams] = msStrdup(name);
-        self->ParamValues[self->NumParams] = msStrdup(value);
-        self->NumParams++;
-    }
-
-    /// Return the name of the parameter at ``index`` in the request's 
-    /// array of parameter names.
-    char *getName(int index) 
-    {
-        if (index < 0 || index >= self->NumParams) {
-            msSetError(MS_CHILDERR, "Invalid index, valid range is [0, %d]", "getName()", self->NumParams-1);
-            return NULL;
-        }
-        return self->ParamNames[index];
-    }
-
-    /// Return the value of the parameter at ``index`` in the request's 
-    /// array of parameter values.
-    char *getValue(int index) 
-    {
-        if (index < 0 || index >= self->NumParams) {
-            msSetError(MS_CHILDERR, "Invalid index, valid range is [0, %d]", "getValue()", self->NumParams-1);
-            return NULL;
-        }
-        return self->ParamValues[index];
-    }
-
-    /// Return the value associated with the parameter ``name``
-    char *getValueByName(const char *name) 
-    {
-        int i;
-        for (i=0; i<self->NumParams; i++) {
-            if (strcasecmp(self->ParamNames[i], name) == 0) {
-                return self->ParamValues[i];
-            }
-        }
-        return NULL;
-    }
-
-}
diff -pruN 8.0.1-5/mapscript/swiginc/point.i 8.2.0~beta1-1~exp1/mapscript/swiginc/point.i
--- 8.0.1-5/mapscript/swiginc/point.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/point.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,191 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript pointObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend pointObj 
-{
-    /** 
-    * Create new instance. Easting, northing, and measure arguments are optional.
-    * Java pointObj constructors are in java/javaextend.i
-    * See https://github.com/mapserver/mapserver/issues/1106
-    */
-#ifndef SWIGJAVA
-    pointObj(double x=0.0, double y=0.0, double z=0.0, double m=-2e38) 
-    {
-        pointObj *p;
-        p = (pointObj *)calloc(1,sizeof(pointObj));
-        if (!p) return NULL;
-        p->x = x;
-        p->y = y;
-        p->z = z;
-        p->m = m;
-        return p;
-    }
-#endif
-
-    ~pointObj() 
-    {
-        free(self);
-    }
-
-    /// Reproject point from proj_in to proj_out. Transformation is done in place.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(projectionObj *projin, projectionObj *projout) 
-    {
-        return msProjectPoint(projin, projout, self);
-    }
-
-    /// Reproject point given a reprojection object. Transformation is done in place.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(reprojectionObj *reprojector)
-    {
-        return msProjectPointEx(reprojector, self);
-    }
-
-    /// Draw the point using the styles defined by the classindex class of layer and 
-    /// labelled with string text. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int draw(mapObj *map, layerObj *layer, imageObj *image, int classindex, 
-             char *text) 
-    {
-        return msDrawPoint(map, layer, self, image, classindex, text);
-    }
-
-    /// Returns the distance to point.
-    double distanceToPoint(pointObj *point) 
-    {
-        return msDistancePointToPoint(self, point);
-    }
-
-    /// Returns the minimum distance to a hypothetical line segment connecting point1 
-    /// and point2.
-    double distanceToSegment(pointObj *a, pointObj *b) 
-    {
-        return msDistancePointToSegment(self, a, b);
-    }
-
-    /// Returns the minimum distance to shape.
-    double distanceToShape(shapeObj *shape) 
-    {
-        return msDistancePointToShape(self, shape);
-    }
-
-    /**
-    * Set spatial coordinate and, optionally, measure values simultaneously. 
-    * The measure will be set only if the value of m is greater than the ESRI measure 
-    * no-data value of -1e38. 
-    * Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int setXY(double x, double y, double m=-2e38) 
-    {
-        self->x = x;
-        self->y = y;
-        self->z = 0.0;
-        self->m = m;
-        return MS_SUCCESS;
-    }
-
-    /**
-    * Set spatial coordinate and, optionally, measure values simultaneously. 
-    * The measure will be set only if the value of m is greater than the ESRI measure 
-    * no-data value of -1e38. 
-    * Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int setXYZ(double x, double y, double z, double m=-2e38) 
-    {
-        self->x = x;
-        self->y = y;
-        self->z = z;
-        self->m = m;
-        return MS_SUCCESS;
-    }
-
-    /**
-    * Set spatial coordinate and, optionally, measure values simultaneously.
-    * The measure will be set only if the value of m is greater than the ESRI measure
-    * no-data value of -1e38.
-    * Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    */
-    int setXYZM(double x, double y, double z, double m) 
-    {
-        self->x = x;
-        self->y = y;
-        self->z = z;
-        self->m = m;
-        return MS_SUCCESS;
-    }
-
-    %newobject toString;
-    /**
-    Return a string formatted like: ``{ 'x': %f , 'y': %f, 'z': %f }``
-    with the coordinate values substituted appropriately. Python users can get the same effect 
-    via the pointObj  __str__ method:
-    
-    >>> p = mapscript.pointObj(1, 1)
-    >>> str(p)
-    { 'x': 1.000000 , 'y': 1.000000, 'z': 1.000000 }
-    */
-    char *toString() 
-    {
-        char buffer[256];
-        const char *fmt;
-
-        if( self->m < -1e38 ){
-            fmt = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g }";
-        }
-        else {
-            fmt = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g, 'm': %.16g }";
-        }
-
-msPointToFormattedString(self, fmt, (char *) &buffer, 256);
-    return msStrdup(buffer);
-    }
-
-    %newobject toShape;
-    /// Convert to a new :class:`shapeObj`
-    shapeObj *toShape() 
-    {
-      shapeObj *shape;
-
-      shape = (shapeObj *) malloc(sizeof(shapeObj));
-      msInitShape(shape);
-    
-      shape->type = MS_SHAPE_POINT;
-      shape->line = (lineObj *) malloc(sizeof(lineObj));
-      shape->numlines = 1;
-      shape->line[0].point = (pointObj *) malloc(sizeof(pointObj));
-      shape->line[0].numpoints = 1;
-
-      shape->line[0].point[0].x = self->x;
-      shape->line[0].point[0].y = self->y;
-      shape->line[0].point[0].z = self->z;
-      shape->line[0].point[0].m = self->m;
-
-      return shape;
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/projection.i 8.2.0~beta1-1~exp1/mapscript/swiginc/projection.i
--- 8.0.1-5/mapscript/swiginc/projection.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/projection.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,71 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript projectionObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend projectionObj 
-{
-
-    /// Create new instance of projectionObj. Input parameter proj4 is a 
-    /// PROJ definition string such as 'init=EPSG:4269'
-    projectionObj(char *proj4) 
-    {
-        int status;
-        projectionObj *proj=NULL;
-
-        proj = (projectionObj *)malloc(sizeof(projectionObj));
-        if (!proj) return NULL;
-        msInitProjection(proj);
-
-        status = msLoadProjectionString(proj, proj4);
-        if (status == -1) {
-            msFreeProjection(proj);
-            free(proj);
-            return NULL;
-        }
-
-        return proj;
-    }
-
-    ~projectionObj() 
-    {
-        msFreeProjection(self);
-        free(self);
-    }
-
-    /// Update the projectionObj using an OGC WKT definition
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setWKTProjection(char* wkt) {
-        /* no debug output here */
-        return msOGCWKT2ProjectionObj(wkt, self, MS_FALSE);
-    }
-
-    /// Returns the units of a projection object. Returns -1 on error.
-    int getUnits() {
-      return GetMapserverUnitUsingProj(self);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/querymap.i 8.2.0~beta1-1~exp1/mapscript/swiginc/querymap.i
--- 8.0.1-5/mapscript/swiginc/querymap.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/querymap.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript queryMapObj extensions
-   Author:   Steve Lime
-
-   ===========================================================================
-   Copyright (c) 1996-2007 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend queryMapObj
-{
-
-  /// Update a querymap from a string snippet. 
-  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int updateFromString(char *snippet)
-  {
-    return msUpdateQueryMapFromString(self, snippet);
-  }
-
-  %newobject convertToString;
-  /// Saves the object to a string. Provides the inverse option for :func:`queryMapObj.updateFromString`.
-  char* convertToString()
-  {
-    return msWriteQueryMapToString(self);
-  }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/rect.i 8.2.0~beta1-1~exp1/mapscript/swiginc/rect.i
--- 8.0.1-5/mapscript/swiginc/rect.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/rect.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,188 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript rectObj extensions
-   Author:   Steve Lime
-             Sean Gillies, sgillies@frii.com
-
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend rectObj {
-
-    /**
-    * Create new instance. The four easting and northing arguments are optional and 
-    * default to -1.0. Note the new optional fifth argument which allows creation 
-    * of rectangles in image (pixel/line) units which are also tested for validity.
-    */
-    rectObj(double minx=-1.0, double miny=-1.0, 
-            double maxx=-1.0, double maxy=-1.0,
-            int imageunits=MS_FALSE) 
-    {
-        rectObj *rect;
-    
-        if (imageunits == MS_FALSE)
-        { 
-            if (minx > maxx || miny > maxy)
-            {
-                msSetError(MS_RECTERR,
-                    "{ 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }",
-                    "rectObj()", minx, miny, maxx, maxy);
-                return NULL;
-            }
-        }
-        else 
-        {
-            if (minx > maxx || maxy > miny) 
-            {
-                msSetError(MS_RECTERR,
-                    "image (pixel/line) units { 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }",
-                    "rectObj()", minx, miny, maxx, maxy);
-                return NULL;
-            }
-        }
-    
-        rect = (rectObj *)calloc(1, sizeof(rectObj));
-        if (!rect)
-            return(NULL);
-    
-        rect->minx = minx;
-        rect->miny = miny;
-        rect->maxx = maxx;
-        rect->maxy = maxy;
-
-        return(rect);
-    }
-
-    ~rectObj() {
-        free(self);
-    }
-
-    /// Reproject rectangle from proj_in to proj_out. Transformation is done in place. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(projectionObj *projin, projectionObj *projout) {
-        return msProjectRect(projin, projout, self);
-    }
-
-    /// Reproject rectangle given a reprojection object. Transformation is done in place.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(reprojectionObj *reprojector)
-    {
-        return msProjectRectAsPolygon(reprojector, self);
-    }
-
-    /// Adjust the rect to fit the width and height. Returns cellsize of rect.
-    double fit(int width, int height) {
-        return  msAdjustExtent(self, width, height);
-    } 
-
-    /// Draw rectangle into img using style defined by the classindex class of layer. 
-    /// The rectangle is labeled with the string text. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int draw(mapObj *map, layerObj *layer, imageObj *image, 
-             int classindex, char *text) 
-    {
-        shapeObj shape;
-        int ret;
-
-        msInitShape(&shape);
-        msRectToPolygon(*self, &shape);
-        shape.classindex = classindex;
-        if(text && layer->class[classindex]->numlabels > 0) {
-          shape.text = msStrdup(text);
-        }
-        
-        ret = msDrawShape(map, layer, &shape, image, -1, MS_DRAWMODE_FEATURES|MS_DRAWMODE_LABELS);
-
-        msFreeShape(&shape);
-    
-        return ret;
-    }
-    
-    %newobject getCenter;
-    /// Return the center point of the rectangle.
-    pointObj *getCenter() 
-    {
-        pointObj *center;
-        center = (pointObj *)calloc(1, sizeof(pointObj));
-        if (!center) {
-            msSetError(2, "Failed to allocate memory for point", "getCenter()");
-            return NULL;
-        }
-        center->x = (self->minx + self->maxx)/2;
-        center->y = (self->miny + self->maxy)/2;
-        
-        return center;
-    }
-
-    %newobject toPolygon;
-    /// Convert to a polygon of five vertices.
-    shapeObj *toPolygon() 
-    {
-        lineObj line = {0,NULL};
-        shapeObj *shape;
-        shape = (shapeObj *)malloc(sizeof(shapeObj));
-        if (!shape)
-            return NULL;
-        msInitShape(shape);
-        shape->type = MS_SHAPE_POLYGON;
-  
-        line.point = (pointObj *)malloc(sizeof(pointObj)*5);
-        line.point[0].x = self->minx;
-        line.point[0].y = self->miny;
-        line.point[1].x = self->minx;
-        line.point[1].y = self->maxy;
-        line.point[2].x = self->maxx;
-        line.point[2].y = self->maxy;
-        line.point[3].x = self->maxx;
-        line.point[3].y = self->miny;
-        line.point[4].x = line.point[0].x;
-        line.point[4].y = line.point[0].y;
-  
-        line.numpoints = 5;
-  
-        msAddLine(shape, &line);
-        msComputeBounds(shape);
-        
-        free(line.point);
-
-        return shape;
-    }
-
-    %newobject toString;
-    /**
-    Return a string formatted like: ``{ 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }``
-    with the bounding values substituted appropriately. Python users can get the same effect 
-    via the rectObj __str__ method:
-    
-    >>> r = mapscript.rectObj(0, 0, 1, 1)
-    >>> str(r)
-    { 'minx': 0 , 'miny': 0 , 'maxx': 1 , 'maxy': 1 }
-    */
-    char *toString()
-    {
-        char buffer[256];
-        char fmt[]="{ 'minx': %.16g , 'miny': %.16g , 'maxx': %.16g , 'maxy': %.16g }";
-        msRectToFormattedString(self, (char *) &fmt, (char *) &buffer, 256);
-        return msStrdup(buffer);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/referencemap.i 8.2.0~beta1-1~exp1/mapscript/swiginc/referencemap.i
--- 8.0.1-5/mapscript/swiginc/referencemap.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/referencemap.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript referenceMapObj extensions
-   Author:   Steve Lime
-
-   ===========================================================================
-   Copyright (c) 1996-2007 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend referenceMapObj
-{
-  /// Update a reference map from a string snippet. 
-  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int updateFromString(char *snippet)
-  {
-    return msUpdateReferenceMapFromString(self, snippet);
-  }
-
-  %newobject convertToString;
-  /// Saves the object to a string. Provides the inverse option for :func:`referenceMapObj.updateFromString`.
-  char* convertToString()
-  {
-    return msWriteReferenceMapToString(self);
-  }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/reprojection.i 8.2.0~beta1-1~exp1/mapscript/swiginc/reprojection.i
--- 8.0.1-5/mapscript/swiginc/reprojection.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/reprojection.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript reprojectionObj extensions
-   Author:   Steve Lime 
-             Even Rouault
-             
-   ===========================================================================
-   Copyright (c) 1996-2022 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-
-%extend reprojectionObj
-{
-    /// Create new instance of reprojectionObj. Input parameters are two projectionsObj's - in and out.
-    reprojectionObj(projectionObj *in, projectionObj *out) 
-    {
-        if(!in && !out) return NULL;
-        return msProjectCreateReprojector(in, out);
-    }
-
-    ~reprojectionObj() 
-    {
-        msProjectDestroyReprojector(self);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/result.i 8.2.0~beta1-1~exp1/mapscript/swiginc/result.i
--- 8.0.1-5/mapscript/swiginc/result.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/result.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,52 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript shapeObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend resultObj 
-{
-    /**
-    * The result object is a handle, of sorts, for a feature of the layer, having 
-    * ``shapeindex`` and ``tileindex`` attributes that can be used as arguments to 
-    * ``getFeature``
-    */
-    resultObj(long shapeindex) 
-    {
-        resultObj *result = (resultObj *) msSmallMalloc(sizeof(resultObj));
-
-        result->tileindex = -1;
-        result->resultindex = -1; 
-        result->shapeindex = shapeindex;
-        
-        return result;
-    }
-
-    ~resultObj() 
-    {
-        free(self);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/resultcache.i 8.2.0~beta1-1~exp1/mapscript/swiginc/resultcache.i
--- 8.0.1-5/mapscript/swiginc/resultcache.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/resultcache.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,43 +0,0 @@
-/* ===========================================================================   
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript resultCacheObj extensions
-   Author:   Steve Lime
-             Sean Gillies, sgillies@frii.com
-
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend resultCacheObj
-{
-    /// Returns the result at index i, like :meth:`layerObj.getResult`,
-    /// or ``NULL`` if index is outside the range of results.
-    resultObj *getResult(int i)
-    {
-        if (i >= 0 && i < self->numresults) {
-            return &self->results[i];
-        }
-        return NULL;
-    }
-
-}
-
diff -pruN 8.0.1-5/mapscript/swiginc/scalebar.i 8.2.0~beta1-1~exp1/mapscript/swiginc/scalebar.i
--- 8.0.1-5/mapscript/swiginc/scalebar.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/scalebar.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript scalebarObj extensions
-   Author:   Steve Lime
-
-   ===========================================================================
-   Copyright (c) 1996-2007 Regents of the University of Minnesota.
-
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
-
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend scalebarObj
-{
-  /// Update a scalebar from a string snippet. 
-  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-  int updateFromString(char *snippet)
-  {
-    return msUpdateScalebarFromString(self, snippet);
-  }
-  
-  %newobject convertToString;
-  /// Saves the object to a string. Provides the inverse option for updateFromString.
-  char* convertToString()
-  {
-    return msWriteScalebarToString(self);
-  }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/shape.i 8.2.0~beta1-1~exp1/mapscript/swiginc/shape.i
--- 8.0.1-5/mapscript/swiginc/shape.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/shape.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,340 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript shapeObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend shapeObj 
-{
-    /**
-    * Return a new shapeObj of the specified type. See the type attribute. 
-    * No attribute values created by default. 
-    * initValues should be explicitly called to create the required number of values. 
-    * Each feature of a layer's data is a shapeObj. Each part of the shape is a 
-    * closed :class:`lineObj`
-    */
-    shapeObj(int type=MS_SHAPE_NULL) 
-    {
-        shapeObj *shape;
-
-    shape = (shapeObj *)malloc(sizeof(shapeObj));
-        if (!shape)
-            return NULL;
-
-        msInitShape(shape);
-        if(type >= 0) shape->type = type;
-        
-        return shape;
-    }
-
-    ~shapeObj() 
-    {
-        msFreeShape(self);
-        free(self);		
-    }
-
-    %newobject fromWKT;
-    /// Returns a new shapeObj based on a well-known text representation of a geometry. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    static shapeObj *fromWKT(char *wkt)
-    {
-    shapeObj *shape;
-        
-        if(!wkt) return NULL;
-
-        shape = msShapeFromWKT(wkt);
-    if(!shape) return NULL;
-
-    return shape;
-    }
-
-    /// Reproject shape from proj_in to proj_out. Transformation is done in place. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(projectionObj *projin, projectionObj *projout) 
-    {
-        return msProjectShape(projin, projout, self);
-    }
-
-    /// Reproject shape given a reprojection object. Transformation is done in place.
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int project(reprojectionObj *reprojector)
-    {
-        return msProjectShapeEx(reprojector, self);
-    }
-
-    /// Returns a reference to part at index. Reference is valid only during 
-    /// the life of the shapeObj.
-    lineObj *get(int i) {
-        if (i<0 || i>=self->numlines)
-            return NULL;
-        else
-            return &(self->line[i]);
-    }
-
-    /// Add line (i.e. a part) to the shape. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int add(lineObj *line) {
-        return msAddLine(self, line);
-    }
-
-    /// Draws the individual shape using layer. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int draw(mapObj *map, layerObj *layer, imageObj *image) {
-        return msDrawShape(map, layer, self, image, -1, MS_DRAWMODE_FEATURES|MS_DRAWMODE_LABELS);
-    }
-
-    /// Must be called to calculate new bounding box after new parts have been added.
-    /// TODO: should return int and set msSetError.
-    void setBounds() 
-    {    
-        msComputeBounds(self);
-        return;
-    }
-
-#if defined (SWIGJAVA) || defined (SWIGPHP)
-    %newobject cloneShape;
-    shapeObj *cloneShape()
-#else
-    %newobject clone;
-    /**
-    Return an independent copy of the shape.
-
-    .. note::
-
-        In the Java & PHP modules this method is named ``cloneShape``.    
-    */    
-    shapeObj *clone()
-#endif
-    {
-        shapeObj *shape;
-        shape = (shapeObj *)malloc(sizeof(shapeObj));
-        if (!shape)
-            return NULL;
-        msInitShape(shape);
-        shape->type = self->type;
-        msCopyShape(self, shape);
-        return shape;
-    }
-
-    /// Copy the shape to shape_copy. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int copy(shapeObj *dest) 
-    {
-        return(msCopyShape(self, dest));
-    }
-
-    %newobject toWKT;
-    /// Returns the well - known text representation of a shapeObj.
-    /// Requires GEOS support.Returns NULL / undefined on failure.
-    char *toWKT()
-    {
-        return msShapeToWKT(self);
-    }
-
-    %newobject buffer;
-    /// Returns a new buffered shapeObj based on the supplied distance 
-    /// (given in the coordinates of the existing shapeObj). 
-    /// Requires GEOS support. Returns NULL/undefined on failure.
-    shapeObj *buffer(double width) { return msGEOSBuffer(self, width); }
-
-    %newobject simplify;
-    /// Given a tolerance, returns a simplified shape object or NULL on error. 
-    /// Requires GEOS support (>=3.0).
-    shapeObj *simplify(double tolerance) { return msGEOSSimplify(self, tolerance); }
-
-    %newobject topologyPreservingSimplify;
-    /// Given a tolerance, returns a simplified shape object or NULL on error. 
-    /// Requires GEOS support (>=3.0).
-    shapeObj *topologyPreservingSimplify(double tolerance) { return msGEOSTopologyPreservingSimplify(self, tolerance); }
-
-    %newobject convexHull;
-    /// Returns the convex hull of the existing shape. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    shapeObj *convexHull() { return msGEOSConvexHull(self); }
-
-    %newobject boundary;
-    /// Returns the boundary of the existing shape. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    shapeObj *boundary() { return msGEOSBoundary(self); }
-
-    %newobject getCentroid;
-    /// Returns the centroid for the existing shape. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    pointObj *getCentroid() { return msGEOSGetCentroid(self); }
-
-    %newobject Union;
-    /// Returns the union of the existing and supplied shape. 
-    /// Shapes must be of the same type. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    shapeObj *Union(shapeObj *shape) { return msGEOSUnion(self, shape); }
-
-    %newobject intersection;
-    /// Returns the computed intersection of the supplied and existing shape. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    shapeObj *intersection(shapeObj *shape) { return msGEOSIntersection(self, shape); }
-
-    %newobject difference;
-    /// Returns the computed difference of the supplied and existing shape. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    shapeObj *difference(shapeObj *shape) { return msGEOSDifference(self, shape); }
-
-    %newobject symDifference;
-    /// Returns the computed symmetric difference of the supplied and existing shape. 
-    /// Requires GEOS support. Returns NULL/undef on failure.
-    shapeObj *symDifference(shapeObj *shape) { return msGEOSSymDifference(self, shape); }
-
-    /// Returns :data:`MS_TRUE` if shape2 is entirely inside the shape, returns -1 on error and :data:`MS_FALSE` otherwise.
-    /// Requires GEOS support.
-    int contains(shapeObj *shape) { return msGEOSContains(self, shape); }
-
-    /// Returns :data:`MS_TRUE` if shape2 overlaps shape, returns -1 on error and :data:`MS_FALSE` otherwise.
-    /// Requires GEOS support.
-    int overlaps(shapeObj *shape) { return msGEOSOverlaps(self, shape); }
-
-    /// Returns :data:`MS_TRUE` if shape is entirely within shape2, returns -1 on error and :data:`MS_FALSE` otherwise.
-    /// Requires GEOS support.
-    int within(shapeObj *shape) { return msGEOSWithin(self, shape); }
-
-    /// Returns :data:`MS_TRUE` if shape2 crosses the shape, returns -1 on error and :data:`MS_FALSE` otherwise.
-    /// Requires GEOS support.
-    int crosses(shapeObj *shape) { return msGEOSCrosses(self, shape); }
-
-    /// Returns :data:`MS_TRUE` if shape and shape2 intersect, and :data:`MS_FALSE` otherwise.
-    /// Does not require GEOS support but will use GEOS functions if available.
-    int intersects(shapeObj *shape) { return msGEOSIntersects(self, shape); } /* if GEOS is not present an alternative computation is provided, see mapgeos.c */
-
-    /// Returns :data:`MS_TRUE` if shape and shape2 touch, returns -1 on error and :data:`MS_FALSE` otherwise.
-    /// Requires GEOS support.
-    int touches(shapeObj *shape) { return msGEOSTouches(self, shape); }
-
-    /// Returns :data:`MS_TRUE` if shape and shape2 are equal (geometry only), returns -1 on error and :data:`MS_FALSE` otherwise.
-    /// Requires GEOS support.
-    int equals(shapeObj *shape) { return msGEOSEquals(self, shape); }
-
-    /// Returns :data:`MS_TRUE` if shape and shape2 are disjoint, returns -1 on error and :data:`MS_FALSE` otherwise.
-    /// Requires GEOS support.
-    int disjoint(shapeObj *shape) { return msGEOSDisjoint(self, shape); }
-
-    /// Returns the area of the shape (if applicable). Requires GEOS support. 
-    double getArea() { return msGEOSArea(self); }
-
-    /// Returns the length (or perimeter) of the shape. Requires GEOS support. 
-    double getLength() { return msGEOSLength(self); }
-
-    /// Return the shape attribute at index i.
-    char *getValue(int i) 
-    {
-        if (i >= 0 && i < self->numvalues && self->values)
-            return (self->values[i]);
-        else
-            return NULL;
-    }
-
-    /// Returns :data:`MS_TRUE` if the point is inside the shape, :data:`MS_FALSE` otherwise
-    int contains(pointObj *point) 
-    {
-        if (self->type == MS_SHAPE_POLYGON)
-            return msIntersectPointPolygon(point, self);
-        
-        return -1;
-    }
-
-    /// Returns the distance to point.
-    double distanceToPoint(pointObj *point) 
-    {
-        return msDistancePointToShape(point, self); /* should there be a GEOS version of this? */
-    }
-
-    /// Returns the minimum distance to shape.
-    double distanceToShape(shapeObj *shape) 
-    {
-        return msGEOSDistance(self, shape); /* note this calls msDistanceShapeToShape() if GEOS support is not present */
-    }
-
-    %newobject getLabelPoint;
-    /// Given a shape, return a point object suitable for labelling it. 
-    pointObj *getLabelPoint()
-    {
-        pointObj *point = (pointObj *)calloc(1, sizeof(pointObj));
-        if (point == NULL) {
-            msSetError(MS_MEMERR, "Failed to allocate memory for point", "labelPoint()");
-            return NULL;
-        }
-
-        if(self->type == MS_SHAPE_POLYGON && msPolygonLabelPoint(self, point, -1) == MS_SUCCESS)
-            return point;
-
-        free(point);
-        return NULL;
-    }
-
-    /// Set the shape value at index i to value.
-    int setValue(int i, char *value)
-    {
-        if (!self->values || !value)
-        {
-            msSetError(MS_SHPERR, "Can't set value", "setValue()");
-            return MS_FAILURE;
-        }
-        if (i >= 0 && i < self->numvalues)
-        {
-            msFree(self->values[i]);
-            self->values[i] = msStrdup(value);
-            if (!self->values[i])
-            {
-                return MS_FAILURE;
-            }
-            else return MS_SUCCESS;
-        }
-        else
-        {
-            msSetError(MS_SHPERR, "Invalid value index", 
-                                  "setValue()");
-            return MS_FAILURE;
-        }
-    }
-
-    /// Allocates memory for the requested number of values.
-    void initValues(int numvalues)
-    {
-        int i;
-        
-        if(self->values) msFreeCharArray(self->values, self->numvalues);
-        self->values = NULL;
-        self->numvalues = 0;
-        
-        /* Allocate memory for the values */
-        if (numvalues > 0) {
-            if ((self->values = (char **)malloc(sizeof(char *)*numvalues)) == NULL) {
-                msSetError(MS_MEMERR, "Failed to allocate memory for values", "shapeObj()");
-                return;
-            } else {
-                for (i=0; i<numvalues; i++) self->values[i] = msStrdup("");
-            }
-            self->numvalues = numvalues;
-        }
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/shapefile.i 8.2.0~beta1-1~exp1/mapscript/swiginc/shapefile.i
--- 8.0.1-5/mapscript/swiginc/shapefile.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/shapefile.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,160 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript shapefileObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2001 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend shapefileObj 
-{
-    /**
-    * Create a new instance. Omit the type argument or use a value of -1 to open 
-    * an existing shapefile.
-    *
-    * Type should be one of :data:`MS_SHAPEFILE_POINT`, :data:`MS_SHAPEFILE_ARC`,
-    * :data:`MS_SHAPEFILE_POLYGON` or :data:`MS_SHAPEFILE_MULTIPOINT`
-    */
-    shapefileObj(char *filename, int type=-1) 
-    {    
-        shapefileObj *shapefile;
-        int status;
-
-        shapefile = (shapefileObj *)malloc(sizeof(shapefileObj));
-        if (!shapefile)
-            return NULL;
-
-        if (type == -1)
-            status = msShapefileOpen(shapefile, "rb", filename, MS_TRUE);
-        else if (type == -2)
-            status = msShapefileOpen(shapefile, "rb+", filename, MS_TRUE);
-        else
-            status = msShapefileCreate(shapefile, filename, type);
-
-        if (status == -1) {
-            msShapefileClose(shapefile);
-            free(shapefile);
-            return NULL;
-        }
- 
-        return(shapefile);
-    }
-
-    ~shapefileObj() 
-    {
-        msShapefileClose(self);
-        free(self);  
-    }
-
-    /// Get the shapefile feature from index i and store it in shape. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int get(int i, shapeObj *shape) 
-    {
-        if (i<0 || i>=self->numshapes)
-            return MS_FAILURE;
-
-        msFreeShape(shape); /* frees all lines and points before re-filling */
-        msSHPReadShape(self->hSHP, i, shape);
-
-        return MS_SUCCESS;
-    }
-
-    %newobject getShape;
-    /// Returns the shapefile feature at index i. More efficient than get.
-    shapeObj *getShape(int i)
-    {
-        shapeObj *shape;
-        shape = (shapeObj *)malloc(sizeof(shapeObj));
-        if (!shape)
-            return NULL;
-        msInitShape(shape);
-        shape->type = self->type;
-        msSHPReadShape(self->hSHP, i, shape);
-        return shape;
-
-    }
-
-    /// Returns the point feature at index i and store it in pointObj.
-    int getPoint(int i, pointObj *point) 
-    {
-        if (i<0 || i>=self->numshapes)
-            return MS_FAILURE;
-
-        msSHPReadPoint(self->hSHP, i, point);
-        return MS_SUCCESS;
-    }
-
-    /// Returns the feature at index i, simplify it, and store it in shape. Uses the
-    /// map extent and cellsize for simplification. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int getTransformed(mapObj *map, int i, shapeObj *shape) 
-    {
-        if (i<0 || i>=self->numshapes)
-            return MS_FAILURE;
-
-        msFreeShape(shape); /* frees all lines and points before re-filling */
-        msSHPReadShape(self->hSHP, i, shape);
-        msTransformShapeSimplify(shape, map->extent, map->cellsize);
-
-        return MS_SUCCESS;
-    }
-
-    /// Retrieve a shape's bounding box by index and stores it in rect.
-    void getExtent(int i, rectObj *rect) 
-    {
-        msSHPReadBounds(self->hSHP, i, rect);
-    }
-
-    /// Appends a shape to the open shapefile. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int add(shapeObj *shape) 
-    {
-        /* Trap NULL or empty shapes -- bug 1201 */
-        if (!shape) 
-        {
-            msSetError(MS_SHPERR, "Can't add NULL shape", "shapefileObj::add");
-            return MS_FAILURE;
-        }
-        else if (!shape->line)
-        {
-            msSetError(MS_SHPERR, "Can't add empty shape", "shapefileObj::add");
-            return MS_FAILURE;
-        }
-
-        return msSHPWriteShape(self->hSHP, shape);
-    }
-
-    /// Appends a point to the open shapefile. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int addPoint(pointObj *point) 
-    {    
-        return msSHPWritePoint(self->hSHP, point);
-    }
-
-    /// Returns a :class:`DBFInfo` object containing information on the associated DBF
-    DBFInfo *getDBF() {
-        return self->hDBF;
-    }
-}
-
diff -pruN 8.0.1-5/mapscript/swiginc/style.i 8.2.0~beta1-1~exp1/mapscript/swiginc/style.i
--- 8.0.1-5/mapscript/swiginc/style.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/style.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,199 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript styleObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2020 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-
-   */
-
-// See https://github.com/mapserver/mapserver/issues/548
-
-%extend styleObj {
-
-    /// Returns new default :class:`styleObj` instance. The ``parent_class`` is optional. 
-    styleObj(classObj *parent_class=NULL) 
-    {
-    
-        styleObj *style = NULL;
-        
-        if (parent_class!=NULL) {
-            if ((style = msGrowClassStyles(parent_class)) == NULL)
-                return NULL;
-
-            if ( initStyle(style) == MS_FAILURE ) {
-                msSetError(MS_MISCERR, "Failed to init new styleObj instance",
-                                       "initStyle()");
-            }
-            parent_class->numstyles++;
-            MS_REFCNT_INCR(style);
-        }
-        else {
-            style = (styleObj *) malloc(sizeof(styleObj));
-            if (!style) { 
-                msSetError(MS_MEMERR, "Failed to allocate memory for new styleObj instance",
-                                       "styleObj()");
-                return NULL;
-            }
-            if ( initStyle(style) == MS_FAILURE ) {
-                msSetError(MS_MISCERR, "Failed to init new styleObj instance",
-                                       "initStyle()");
-                msFree(style);
-                return NULL;
-            }
-        }
-        return style;
-    }
-   
-    ~styleObj() 
-    {
-        if (self) { 
-            if ( freeStyle(self) == MS_SUCCESS ) {
-                        free(self);
-                self=NULL;
-            }
-        }
-    }
-
-    /// Update a style from a string snippet. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int updateFromString(char *snippet)
-    {
-        return msUpdateStyleFromString(self, snippet);
-    }
-
-    %newobject convertToString;
-    /// Saves the object to a string. Provides the inverse option for :func:`styleObj.updateFromString` 
-    char* convertToString()
-    {
-        return msWriteStyleToString(self);
-    }
-
-#if defined (SWIGJAVA) || defined (SWIGPHP)
-    %newobject cloneStyle;
-    styleObj *cloneStyle() 
-#else
-    %newobject clone;
-    /**
-    Return an independent copy of the style with no parent class.
-
-    .. note::
-
-        In the Java & PHP modules this method is named ``cloneStyle``.    
-    */ 
-    styleObj *clone() 
-#endif
-    {
-        styleObj *style;
-
-        style = (styleObj *) malloc(sizeof(styleObj));
-        if (!style)
-        {
-            msSetError(MS_MEMERR,
-                "Could not allocate memory for new styleObj instance",
-                "clone()");
-            return NULL;
-        }
-        if (initStyle(style) == -1)
-        {
-            msSetError(MS_MEMERR, "Failed to initialize Style",
-                                  "clone()");
-            return NULL;
-        }
-
-        if (msCopyStyle(style, self) != MS_SUCCESS)
-        {
-            free(style);
-            return NULL;
-        }
-        
-        return style;
-    }
-
-    /// Setting the symbol of the :class:`styleObj` given the reference of the map 
-    /// object and the symbol name. 
-    int setSymbolByName(mapObj *map, char* symbolname) 
-    {
-        self->symbol = msGetSymbolIndex(&map->symbolset, symbolname, MS_TRUE);
-        if (self->symbolname) free((char*)self->symbolname);
-        if (symbolname) self->symbolname = msStrdup(symbolname);
-        else self->symbolname = 0;
-        return self->symbol;
-    }
-
-    /// Remove the attribute binding for a specified style property. 
-    int removeBinding(int binding) 
-    {
-        if(binding < 0 || binding >= MS_STYLE_BINDING_LENGTH) return MS_FAILURE;
-
-        if(self->bindings[binding].item) {
-            free(self->bindings[binding].item);
-            self->bindings[binding].item = NULL;
-            self->bindings[binding].index = -1;
-            self->numbindings--;
-        }
-
-        return MS_SUCCESS;
-    }
-
-    /// Remove the attribute binding for a specified style property. 
-    int setBinding(int binding, char *item) 
-    {
-        if(!item) return MS_FAILURE;
-        if(binding < 0 || binding >= MS_STYLE_BINDING_LENGTH) return MS_FAILURE;
-
-        if(self->bindings[binding].item) {
-            free(self->bindings[binding].item);
-            self->bindings[binding].item = NULL;
-            self->bindings[binding].index = -1;
-            self->numbindings--;
-        }
-
-        self->bindings[binding].item = msStrdup(item);
-        self->numbindings++;
-
-        return MS_SUCCESS;
-    }
-
-    /// Get the attribute binding for a specified style property. 
-    /// Returns NULL if there is no binding for this property. 
-    char *getBinding(int binding) 
-    {
-        if(binding < 0 || binding >= MS_STYLE_BINDING_LENGTH) return NULL;
-
-        return self->bindings[binding].item;
-    }
-
-    /// Get the :ref:`GEOMTRANSFORM <mapfile-style-geomtransform>` for the style. 
-    char *getGeomTransform() 
-    {
-        return self->_geomtransform.string;
-    }
-
-    /// Set the :ref:`GEOMTRANSFORM <mapfile-style-geomtransform>` for the style. 
-    void setGeomTransform(char *transform) 
-    {
-        msStyleSetGeomTransform(self, transform);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/symbol.i 8.2.0~beta1-1~exp1/mapscript/swiginc/symbol.i
--- 8.0.1-5/mapscript/swiginc/symbol.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/symbol.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,165 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript symbolObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2020 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-/// See also https://github.com/mapserver/mapserver/issues/579
-
-%extend symbolObj 
-{
-
-    /// Create new default :class:`symbolObj` named ``symbolname``. If ``imagefile`` is specified, then the symbol 
-    /// will be of type :data:`MS_SYMBOL_PIXMAP`. 
-    symbolObj(char *symbolname, const char *imagefile=NULL) 
-    {
-        symbolObj *symbol;
-        symbol = (symbolObj *) malloc(sizeof(symbolObj));
-        initSymbol(symbol);
-        symbol->name = msStrdup(symbolname);
-        if (imagefile) {
-            msLoadImageSymbol(symbol, imagefile);
-        }
-        return symbol;
-    }
-
-    ~symbolObj() 
-    {
-        if (self) {
-            if (msFreeSymbol(self)==MS_SUCCESS) {
-                free(self);
-                self=NULL;
-            }
-        }
-    }
-
-    /// Sets the ``imagefile`` path for a :data:`MS_SYMBOL_PIXMAP`. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setImagepath(const char *imagefile) {
-        return msLoadImageSymbol(self, imagefile);
-    }
-
-    /// Sets the symbol points from the points of line. Returns the updated number of points. 
-    int setPoints(lineObj *line) {
-        int i;
-    self->sizex = 0;
-    self->sizey = 0;
-        for (i=0; i<line->numpoints; i++) {
-            MS_COPYPOINT(&(self->points[i]), &(line->point[i]));
-        self->sizex = MS_MAX(self->sizex, self->points[i].x);
-        self->sizey = MS_MAX(self->sizey, self->points[i].y);
-        }
-        self->numpoints = line->numpoints;
-        return self->numpoints;
-    }
-
-    %newobject getPoints;
-    /// Returns the symbol points as a :class:`lineObj`. 
-    lineObj *getPoints() 
-    {
-        int i;
-        lineObj *line;
-        line = (lineObj *) malloc(sizeof(lineObj));
-        line->point = (pointObj *) malloc(sizeof(pointObj)*(self->numpoints));
-        for (i=0; i<self->numpoints; i++) {
-            line->point[i].x = self->points[i].x;
-            line->point[i].y = self->points[i].y;
-        }
-        line->numpoints = self->numpoints;
-        return line;
-    }
-
-    %newobject getImage;
-    /// Returns a pixmap symbol's imagery as an :class:`imageObj`. 
-    imageObj *getImage(outputFormatObj *input_format)
-    {
-        imageObj *image = NULL;
-        outputFormatObj *format = NULL;
-        rendererVTableObj *renderer = NULL;
-
-        if (input_format)
-        {
-            format = input_format;
-        }
-        else 
-        {
-            format = msCreateDefaultOutputFormat(NULL, "AGG/PNG", "aggpng", NULL);
-            if (format)
-                msInitializeRendererVTable(format);
-        }
-        
-        if (format == NULL) 
-        {
-            msSetError(MS_IMGERR, "Could not create output format",
-                       "getImage()");
-            return NULL;
-        }
-
-        renderer = format->vtable;
-        msPreloadImageSymbol(renderer, self);
-        if (self->pixmap_buffer) 
-        {
-            image = msImageCreate(self->pixmap_buffer->width, self->pixmap_buffer->height, format, NULL, NULL,
-                                  MS_DEFAULT_RESOLUTION, MS_DEFAULT_RESOLUTION, NULL);
-            if(!image) {
-              msSetError(MS_IMGERR, "Could not create image",
-                       "getImage()");
-              return NULL;
-            }
-            if(MS_SUCCESS != renderer->mergeRasterBuffer(image, self->pixmap_buffer, 1.0, 0, 0, 0, 0,
-                                        self->pixmap_buffer->width, self->pixmap_buffer->height)) {
-              msSetError(MS_IMGERR, "Could not merge symbol image",
-                       "getImage()");
-              msFreeImage(image);
-              return NULL;
-            }
-        }
-
-        return image;
-    }
-
-    /// Set a pixmap symbol's imagery from image. 
-    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int setImage(imageObj *image)
-    {
-        rendererVTableObj *renderer = NULL;
-        
-        renderer = image->format->vtable;
-        
-        if (self->pixmap_buffer) {
-            msFreeRasterBuffer(self->pixmap_buffer);
-            free(self->pixmap_buffer);
-        }
-        
-        self->pixmap_buffer = (rasterBufferObj*)malloc(sizeof(rasterBufferObj));
-        if (!self->pixmap_buffer) {
-            msSetError(MS_MEMERR, NULL, "setImage()");
-            return MS_FAILURE;
-        }
-        self->type = MS_SYMBOL_PIXMAP;
-        return renderer->getRasterBufferCopy(image, self->pixmap_buffer);
-    }
-}
diff -pruN 8.0.1-5/mapscript/swiginc/symbolset.i 8.2.0~beta1-1~exp1/mapscript/swiginc/symbolset.i
--- 8.0.1-5/mapscript/swiginc/symbolset.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/symbolset.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,118 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript symbolSetObj extensions
-   Author:   Steve Lime 
-             Sean Gillies, sgillies@frii.com
-             
-   ===========================================================================
-   Copyright (c) 1996-2020 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-%extend symbolSetObj 
-{
-
-    /// Create new :class:`symbolSetObj` instance. If symbolfile is specified, symbols will be 
-    /// loaded from the file. 
-    symbolSetObj(const char *symbolfile=NULL) 
-    {
-        symbolSetObj *symbolset;
-        mapObj *temp_map=NULL;
-        symbolset = (symbolSetObj *) malloc(sizeof(symbolSetObj));
-        msInitSymbolSet(symbolset);
-        if (symbolfile) {
-            symbolset->filename = msStrdup(symbolfile);
-            temp_map = msNewMapObj();
-            msLoadSymbolSet(symbolset, temp_map);
-            symbolset->map = NULL;
-            msFreeMap(temp_map);
-        }
-        return symbolset;
-    }
-
-    ~symbolSetObj() 
-    {
-        msFreeSymbolSet(self);
-        if (self->filename) free(self->filename);
-        free(self);
-    }
-
-    %newobject getSymbol;
-    /// Returns a reference to the symbol at index.
-    symbolObj *getSymbol(int i) 
-    {
-        if (i >= 0 && i < self->numsymbols) {
-            symbolObj *s=self->symbol[i];
-            MS_REFCNT_INCR(s);
-            return s;
-        } else
-            return NULL;
-    }
-
-    %newobject getSymbolByName;
-    /// Returns a reference to the symbol named name.
-    symbolObj *getSymbolByName(char *symbolname) 
-    {
-        int i;
-
-        if (!symbolname) return NULL;
-
-        i = msGetSymbolIndex(self, symbolname, MS_TRUE);
-        if (i == -1)
-            return NULL;
-        else {
-            MS_REFCNT_INCR(self->symbol[i]);
-            return self->symbol[i];
-        }
-    }
-
-    /// Return the index of the symbol named name or -1 in the case that no such 
-    /// symbol is found. 
-    int index(char *symbolname) 
-    {
-        return msGetSymbolIndex(self, symbolname, MS_TRUE);
-    }
-
-    /// Add a copy of symbol to the symbolset and return its index. 
-    int appendSymbol(symbolObj *symbol) 
-    {
-        return msAppendSymbol(self, symbol);
-    }
-
-    %newobject removeSymbol;
-    /// Remove the symbol at index and return a copy of the symbol.
-    symbolObj *removeSymbol(int index) 
-    {
-        symbolObj *s=msRemoveSymbol(self, index);
-        if (s!=NULL) {
-            MS_REFCNT_INCR(s);
-        }
-        return s;
-    }
-
-    /// Save symbol set to a file. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int save(const char *filename) {
-        return msSaveSymbolSet(self, filename);
-    }
-
-}
-
-
diff -pruN 8.0.1-5/mapscript/swiginc/web.i 8.2.0~beta1-1~exp1/mapscript/swiginc/web.i
--- 8.0.1-5/mapscript/swiginc/web.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/swiginc/web.i	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-/* ===========================================================================
-   Project:  MapServer
-   Purpose:  SWIG interface file for mapscript webObj extensions
-   Author:   Steve Lime 
-             Umberto Nicoletti unicoletti@prometeo.it
-             
-   ===========================================================================
-   Copyright (c) 1996-2020 Regents of the University of Minnesota.
-   
-   Permission is hereby granted, free of charge, to any person obtaining a
-   copy of this software and associated documentation files (the "Software"),
-   to deal in the Software without restriction, including without limitation
-   the rights to use, copy, modify, merge, publish, distribute, sublicense,
-   and/or sell copies of the Software, and to permit persons to whom the
-   Software is furnished to do so, subject to the following conditions:
- 
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
- 
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
-   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-   DEALINGS IN THE SOFTWARE.
-   ===========================================================================
-*/
-
-// See https://github.com/mapserver/mapserver/issues/1798 for a related issue
-
-%extend webObj 
-{
-    /**
-    * Instances of :class:`webObj` are always are always embedded inside the :class:`mapObj`. 
-    * Has no other existence than as an attribute of a :class:`mapObj`. Serves as a container for various run-time 
-    * web application definitions like temporary file paths, template paths, etc.
-    */
-    webObj() 
-    {
-        webObj *web;
-        web = (webObj *) malloc(sizeof(webObj));
-        initWeb(web);
-        return web;
-    }
-
-    ~webObj() 
-    {
-        if (!self) return;
-        freeWeb(self);
-        free(self);
-    }
-
-    /// Update a :class:`webObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
-    int updateFromString(char *snippet)
-    {
-        return msUpdateWebFromString(self, snippet);
-    }
-
-    %newobject convertToString;
-    /// Output the :ref:`web` object as a Mapfile string. Provides the inverse option for :func:`webObj.updateFromString`.
-    char* convertToString()
-    {
-        return msWriteWebToString(self);
-    }
-}
diff -pruN 8.0.1-5/mapscript/tcl/Makefile.in 8.2.0~beta1-1~exp1/mapscript/tcl/Makefile.in
--- 8.0.1-5/mapscript/tcl/Makefile.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/Makefile.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,103 +0,0 @@
-#
-# Makefile.in for mapscript Tcl interface
-# Tom Poindexter, tpoindex@nyx.net
-#
-
-DLTARGET            = libMapscript11
-PACKAGEDIR          = MapscriptTcl1.1
-
-# Note: also change 'package provide' version in pkgIndex.tcl !!
-
-SWIGINC             = -I@SWIGDIR@/include
-SWIGLIB             = -L@SWIGDIR@/lib
-SWIGLIB_SPEC        = -lswig
-
-TCL_PREFIX          = @TCL_PREFIX@
-TCL_EXEC_PREFIX     = @TCL_EXEC_PREFIX@
-TCL_CC              = @TCL_CC@
-TCL_DEFS            = @TCL_DEFS@
-TCL_SHLIB_SUFFIX    = @TCL_SHLIB_SUFFIX@
-TCL_SHLIB_CFLAGS    = @TCL_SHLIB_CFLAGS@
-TCL_LD_SEARCH_FLAGS = @TCL_LD_SEARCH_FLAGS@
-TCL_SHLIB_LD        = @TCL_SHLIB_LD@
-TCL_LIB_SPEC        = @TCL_LIB_SPEC@
-TCL_STUB_LIB_SPEC   = @TCL_STUB_LIB_SPEC@
-TCL_LIBS            = @TCL_LIBS@
-LIBS                = @TCL_LIBS@
-TCL_DBGX            = @TCL_DBGX@
-LIB_RUNTIME_DIR     = @TCL_EXEC_PREFIX@/lib:@TCL_EXEC_PREFIX@/lib/$(PACKAGEDIR):@TCL_PREFIX@/lib:@MAPSERVERHOME@
-
-MAPSERVERHOME       = @MAPSERVERHOME@
-MAPSERVERDEFS       = @MAPSERVERDEFS@
-MAPSERVERINCS       = @MAPSERVERINCS@
-MAPSERVERLIBS       = @MAPSERVERLIBS@
-
-# ugly alert!
-# see the README for this hack
-SWIG_STUB_HACK = -DUSE_TCL_STUBS -DITCL_NAMESPACES -DItcl_Namespace=int \
-		 -D"spaceId=spcid;Tcl_InitStubs(interp,\"8.1\",0)"
-
-all: stublib
-
-stublib: mapscript_wrap.c
-	$(TCL_CC) -c $(TCL_DEFS) $(TCL_SHLIB_CFLAGS) \
-		-I$(TCL_PREFIX)/include \
-		$(MAPSERVERDEFS) $(MAPSERVERINCS) \
-		$(SWIG_STUB_HACK) \
-		mapscript_wrap.c
-	$(TCL_SHLIB_LD) -o $(DLTARGET)$(TCL_SHLIB_SUFFIX) mapscript_wrap.o \
-		$(TCL_LD_SEARCH_FLAGS) \
-		$(TCL_STUB_LIB_SPEC) \
-		$(TCL_LIBS) \
-		-L$(MAPSERVERHOME) $(MAPSERVERLIBS)
-
-mapscript_wrap.c:
-	swig -tcl8 -dhtml -namespace $(MAPSERVERDEFS) $(MAPSERVERINCS) \
-		mapscript.i
-
-nostublib: mapscript_wrap.c
-	$(TCL_CC) -c $(TCL_DEFS) $(TCL_SHLIB_CFLAGS) \
-		-I$(TCL_PREFIX)/include \
-		$(MAPSERVERDEFS) $(MAPSERVERINCS) \
-		mapscript_wrap.c
-	$(TCL_SHLIB_LD) -o $(DLTARGET)$(TCL_SHLIB_SUFFIX) mapscript_wrap.o \
-		$(TCL_LD_SEARCH_FLAGS) \
-		$(TCL_LIB_SPEC) \
-		$(TCL_LIBS) \
-		-L$(MAPSERVERHOME) $(MAPSERVERLIBS)
-
-$(DLTARGET)$(TCL_SHLIB_SUFFIX): mapscript_wrap.o
-
-install: $(DLTARGET)$(TCL_SHLIB_SUFFIX)
-	-mkdir $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
-	cp $(DLTARGET)$(TCL_SHLIB_SUFFIX) $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
-	chmod +x \
-	   $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)/$(DLTARGET)$(TCL_SHLIB_SUFFIX)
-	cp pkgIndex.tcl                   $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
-	cp mapscriptsupp.tcl              $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
-	cp mapscriptsupp.html             $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
-	cp mapscript_wrap.html            $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
-
-
-useprebuilt:
-	gunzip -c mapscript_wrap.c.gz >mapscript_wrap.c
-
-prebuilt:  mapscript_wrap.c
-	gzip -cf mapscript_wrap.c >mapscript_wrap.c.gz
-
-tar:
-	if test ! -f mapscript_wrap.c.gz ; then \
-		gzip -cf mapscript_wrap.c >mapscript_wrap.c.gz; fi
-	rm -f mapscript_wrap.c
-	(cd ..; tar cf mapscript-tcl.tar tcl )
-	gzip -f ../mapscript-tcl.tar
-
-clean:
-	rm -f *.o core *.so
-
-distclean: clean
-	rm -f Makefile
-
-reallyclean: distclean
-	rm -f mapscript_wrap.*
-
diff -pruN 8.0.1-5/mapscript/tcl/README 8.2.0~beta1-1~exp1/mapscript/tcl/README
--- 8.0.1-5/mapscript/tcl/README	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,167 +0,0 @@
-Mapscript Tcl Interface
-
-WHAT
-It's a Tcl interface for Mapserver.  You can write Tcl scripts to generate
-maps, read/write shapefiles, etc.
-
-VERSION
-Mapscript 1.1 is built for Mapserver 3.5 +
-
-INSTALL
-A simple 'configure' script and Makefile is included.  The configure is hand
-built, rather than being derived from GNU autoconf.  Normally you can just 
-type:
-	configure
-	make
-	make install
-
-    to build and install the interface.  Three configure options are supported:
-
-	configure --with-tcl=[dir]  --with-swig=[dir]  --with-linker-cc
-
-	--with-tcl=[dir]    specify the directory where you installed Tcl,
-			    the default is /usr/local.  'configure' looks for
-			    $dir/lib/tclConfig.sh for Tcl configure info.
-
-	--with-swig=[dir]   specify the directory where you installed Swig,
-			    the default is /usr/local.  'configure' looks for
-			    $dir/include/swig.h and $dir/lib/libswig.a.
-
-	--with-linker-cc    use the compiler command as the front-end for
-			    linking, if not already so.  See 'COMPILE PROBLEMS'
-			    below.
-
-	** Mapserver source code is presumed to be two directory levels above
-	this directory, and uses various .h files from Mapscript, along	
-	with ../mapscript.i.
-
-	** Mapscript/Tcl normally builds as a Tcl stubbed dynamic library.
-	The makefile includes a target 'nostublib' if you want to build
-	with a Tcl version dependent library (not recommended).
-
-	** Tested with Tcl/Tk version 8.3.2, and Swig version 1.1-883
-
-
-REQUIREMENTS
-You must have Tcl (tcl.sourceforge.net) installed and optionally, Swig 
-installed also (www.swig.org).  
-
-The current mapscript.i Swig interface definition file is designed for
-Swig 1.1 versions.  Newer versions of Swig may require mapscript.i changes.
-You should have Tcl 8.3 or greater installed, as the Makefile normally builds
-with the Tcl dynamic stubs library.  Tcl 8.3.2 (or current release) is 
-recommended.  Additionally, you may want the Img Tcl extension to
-support upcoming Mapserver images (PNG, JPG, etc.)  See the NOTES section
-below for more information.
-
-
-COMPILE PROBLEMS
-Some users have reported link or runtime errors, most notably when 
-mapscript_wrap.c is compiled with gcc, but using ld to link the shared
-library.  If you experience this problem, try re-running the configure script,
-adding the '--with-linker-cc' option to the configure command line.
-
-For users without Swig installed, a pre-built mapscript_wrap.c is available.
-'make useprebuilt' will unpack the pre-built mapscript_wrap.c.
-
-If you get runtime errors reporting missing symbols, check the Mapscript/Tcl
-shared library for shared libraries it may be dependent upon.  In Linux, 
-Solaris (and possibly other unix systems) try this:
-	
-	ldd libMapscript*.*
-
-Note which libraries are unresolved.  Find the directories which contain the
-libraries that are unresolved, and add those directories to your 
-LD_LIBRARY_PATH environment variable, or whichever environment variable is
-appropriate for your system:
-
-	$ export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/other/required/dirs
-
-Add this to your .profile or .cshrc so you won't have to set this each
-time you login.  On some systems (Linux, et.al), a /etc/ld.so.conf file
-and 'ldconfig' program will set system-wide default library directory paths.
-
-
-WINDOWS
-See the ./win directory.   You should first install Tcl 8.3.2.  Then,
-run the 'setup.tcl' file to install Mapscript/Tcl.  You can double-click
-on the 'setup.tcl' file from Windows explorer, or 'start setup.tcl'
-from a DOS box.
-  
-To rebuild the DLL, see the file 'README.ms-mingw' and 'ms-mingw.tar.gz'.  
-The DLL provided was built with the Mingw compiler, as a cross compiler 
-hosted on Linux.  You should be able to rebuild the DLL on any Unix box, or 
-with a little work, using Mingw or Cygwin compiler & tools on Windows.  
-
-No Microsoft or Borland makefiles are provided.  Feel free to donate one(s). 
-
-You can use the popular 'WinZip' program to unpack tar.gz files on Windows
-(http://www.winzip.com), or use gunzip and tar from the Cygwin tools
-(http://sources.redhat.com/cygwin/).
-
-
-
-DOCS
-Swig generated documentation, plus and additional doc page for Tcl coded 
-helper functions are available as HTML.
-
-
-EXAMPLES
-See the ./examples directory.  
-
-	shpinfo.tcl    - print rudimentary info about a shape file.
-
-
-MAPSERVER WORKBENCH 
-MapServer Workbench is a set of tools written in Tcl/Tk with the Mapscript/Tcl
-extension, and is available separately.  The Workbench currently consists of:
-
-	msappwiz.tcl    -wizard to create mapserver application mapfiles
-	msedit.tcl	-tree-structured mapfile editor
-	msexplorer.tcl	-view, zoom, and query mapfiles 
-	msshapex.tcl	-view shapefile information and .dbf attributes
-
-MapServer Workbench tools run under Unix or Windows.
-
-For more information and to download MapServer Workbench:
-	http://msworkbench.sourceforge.net
-	http://sourceforge.net/projects/msworkbench/
-	http://www.nyx.net/~tpoindex/gis
-
-
-NOTES
-e.g., the "SWIG_STUB_HACK"
-Building Tcl extensions that are not dependent on a particular version of
-Tcl is the preferred method.  Prior to Tcl 8.1, an extension had to be
-linked against a version dependent Tcl libarary.  Extensions had to be
-recompiled and relinked when newer versions of Tcl were installed.
-
-Beginning with Tcl 8.1, the 'stub' library was introduced to facilitate 
-version independent extensions.  The stub library is a table of pointers
-to Tcl functions, that are initialized at run time, so extensions compiled
-for one version of Tcl don't have to be recompiled.  A call to Tcl_InitStubs()
-is required before using any Tcl function in an extension, and we link to
-libtclstub8.3.a, instead of the entire Tcl library. 
-
-Swig 1.1-883 doesn't initialize the stub table by calling Tcl_InitStubs(), so
-we must do it ourselves.  Normally, we use the Swig directive '%init' to
-include the call to Tcl_InitStubs.  However, we also prefer that the new
-Mapscript commands reside in their own namespace, by using the Swig option
-'-namespace'.  Unfortunately, Swig generates a call to Tcl_Eval() before
-the %init code is included in the wrapped .c file.
-
-We work around this problem for Mapscript by some crusty use of the
-C preprocessor.  Just before the Tcl_Eval call in the wrapped .c file, Swig
-also includes an bit of code that allows use the [incr Tcl] object system.  
-The makefile passes command line C preprocessor defines to
-subvert this bit of code for our use.  Thus, we are able to call the 
-Tcl_InitStub function before Tcl_Eval is called.  See the Makefile 
-macro "SWIG_STUB_HACK".
-
-
-WHO
-Tom Poindexter
-tpoindex@nyx.net
-http://www.nyx.net/~tpoindex/
-
-
diff -pruN 8.0.1-5/mapscript/tcl/configure 8.2.0~beta1-1~exp1/mapscript/tcl/configure
--- 8.0.1-5/mapscript/tcl/configure	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/configure	1970-01-01 00:00:00.000000000 +0000
@@ -1,178 +0,0 @@
-#!/bin/sh
-
-# not a normal autoconf configure script
-# grab the file ../../perlvars that mapserver made for the perl mapscript
-# build, and use gcc and ld flags
-
-if [ ! -f ../../perlvars ] ; then
-   echo "you must build MapServer first."
-   exit
-fi
-
-MAPSERVERHOME=`head -1 ../../mapscriptvars | tail -1`
-MAPSERVERDEFS=`head -2 ../../mapscriptvars | tail -1`
-MAPSERVERINCS=`head -3 ../../mapscriptvars | tail -1`
-MAPSERVERLIBS=`head -4 ../../mapscriptvars | tail -1`
-
-# make sure link to mapscript.i exists
-
-if [ ! -f mapscript.i ] ; then
-    ln -s ../mapscript.i mapscript.i
-fi
-
-# check for --with-tcl= and/or --with-swig=
-with_tcl=/usr/local
-with_swig=/usr/local
-with_linker_cc=no
-for arg in $*
-do
-    case $arg in
-	--help)
-		echo "mapscript tcl configure options:"
-		echo "--with-tcl=dir   where to find tcl  (lib/tclConfig.sh)"
-		echo "--with-swig=dir  where to find swig (include/swig.h)"
-		echo "--with-linker-cc use the compiler as linker front-end \
-				(see README)"
-		exit	
-		;;
-        --with-tcl=*)
-		save_if=$IFS
-		IFS==
-		set -- $arg
-		with_tcl=$2
-		IFS=$save_ifs
-		;;
-	--with-swig=*)
-		save_if=$IFS
-		IFS==
-		set -- $arg
-		with_swig=$2
-		IFS=$save_ifs
-		;;
-	--with-linker-cc)
-		with_linker_cc=yes
-		;;
-    esac
-done
-
-
-# look for Tcl configs
-
-echo "looking for Tcl in $with_tcl"
-if [ ! -f $with_tcl/lib/tclConfig.sh ] ; then
-    echo "can not find tclConfig.sh in $with_tcl"
-    exit
-fi
-echo "                  found lib/tclConfig.sh in $with_tcl"
-
-# look for swig
-
-echo "looking for Swig in $with_swig"
-if [ ! -f $with_swig/include/swig.h ] ; then
-    echo "can not find swig.h in $with_swig/include"
-    echo "using pre-built swig tcl interface"
-    # mapscript_wrap.c included in package
-else
-    echo "                  found include/swig.h in $with_swig"
-fi
-SWIGDIR=$with_swig
-
-
-# source the tcl Configs
-
-. $with_tcl/lib/tclConfig.sh
-echo "tcl version = $TCL_VERSION"
-
-
-# if --with-linker-cc option set, then change ld command to use TCL_CC
-
-if test "$with_linker_cc" = "yes" ; then
-    # get cc command, without any options that may be present
-    eval set -- $TCL_CC
-    cc="$1"
-    # get any linker command options
-    eval set -- $TCL_SHLIB_LD
-    shift
-    # build the new command using cc and linker options
-    TCL_SHLIB_LD="$cc $*"
-fi
-
-
-# ugh.  Tcl's tclConfig.sh only provides TCL_LD_SEARCH_FLAGS appropriate for
-#       use with 'cc'.  if 'ld' is the shared library loader, the flags
-#       might be wrong, try to fix.  this problem is often found on 
-#       Solaris, HP-UX, IRIX, {Free,Open,Net}BSD, OSF, Dec/Compaq Unix
-
-# first, get the shared lib loader command, should be ld or *cc
-
-eval set -- $TCL_SHLIB_LD
-ldcmd=`basename $1`
-if test "$ldcmd" = "ld" ; then
-
-    # this machine uses ld, now see if a flag begins with -Wl
-
-    newarg=""
-    eval set -- $TCL_LD_SEARCH_FLAGS
-    space=""
-    for arg in $*
-    do
-        case $TCL_LD_SEARCH_FLAGS in
-	    -Wl*)
-	        # yep, here's our problem child
-	        # strip off first arg, change "," to " " via sh set hack
-                IFSsave="$IFS"
-	        IFS=","
-	        eval set -- $arg
-	        IFS="$IFSsave"
-	        shift
-	        arg="$*"
-	        ;;
-	    *)
-		newarg="$newarg$space$arg"
-		;;
-        esac
-	space=" "
-    done
-    TCL_LD_SEARCH_FLAGS="$newarg"
-fi
-
-# also check for Solaris loader flags '-z text', which causes unresolved
-# link errors, because we're mixing -fPIC code (mapscript_wrap.o) with 
-# non -fPIC code (libmap.a, etc.)  the resulting libMapscript.so will be
-# mixed, so don't cause the link to fail.
-
-TCL_SHLIB_LD=`echo $TCL_SHLIB_LD | sed -e 's/-z text//'` 
-
-
-# fix up LIB_RUNTIME_DIR for those systems that leave it out
-
-if test -z "$LIB_RUNTIME_DIR" ; then
-    LIB_RUNTIME_DIR=$with_tcl/lib
-fi
-
-
-# create our Makefile
-
-echo "creating Makefile"
-
-sed -e "s%@MAPSERVERHOME@%$MAPSERVERHOME%g" \
-    -e "s%@MAPSERVERDEFS@%$MAPSERVERDEFS%g" \
-    -e "s%@MAPSERVERINCS@%$MAPSERVERINCS%g" \
-    -e "s%@MAPSERVERLIBS@%$MAPSERVERLIBS%g" \
-    -e "s%@TCL_PREFIX@%$TCL_PREFIX%g" \
-    -e "s%@TCL_EXEC_PREFIX@%$TCL_EXEC_PREFIX%g" \
-    -e "s%@TCL_CC@%$TCL_CC%g" \
-    -e "s%@TCL_DEFS@%$TCL_DEFS%g" \
-    -e "s%@TCL_SHLIB_SUFFIX@%$TCL_SHLIB_SUFFIX%g" \
-    -e "s%@TCL_SHLIB_CFLAGS@%$TCL_SHLIB_CFLAGS%g" \
-    -e "s%@TCL_LD_SEARCH_FLAGS@%$TCL_LD_SEARCH_FLAGS%g" \
-    -e "s%@TCL_SHLIB_LD@%$TCL_SHLIB_LD%g" \
-    -e "s%@TCL_LIB_SPEC@%$TCL_LIB_SPEC%g" \
-    -e "s%@TCL_STUB_LIB_SPEC@%$TCL_STUB_LIB_SPEC%g" \
-    -e "s%@TCL_LIBS@%$TCL_LIBS%g" \
-    -e "s%@LIB_RUNTIME_DIR@%$LIB_RUNTIME_DIR%g" \
-    -e "s%@TCL_DBGX@%$TCL_DBGX%g" \
-    -e "s%@SWIGDIR@%$SWIGDIR%g" \
- <Makefile.in >Makefile
-
-
diff -pruN 8.0.1-5/mapscript/tcl/examples/shpinfo.tcl 8.2.0~beta1-1~exp1/mapscript/tcl/examples/shpinfo.tcl
--- 8.0.1-5/mapscript/tcl/examples/shpinfo.tcl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/examples/shpinfo.tcl	1970-01-01 00:00:00.000000000 +0000
@@ -1,33 +0,0 @@
-#!/usr/local/bin/tclsh8.3
-
-# if running a test before install, include directory to find package
-
-lappend auto_path [pwd]/..
-
-package require Mapscript
-
-array set types {
-   1 point
-   3 arc
-   5 polygon
-   8 multipoint
-}
-
-
-set file $argv
-
-if {! [file isfile $file.shp]} {
-    puts "shapefile \"$file\" not found"
-    puts "usage: $argv0 <shapefile>"
-    exit
-}
-
-mapscript::shapefileObj shp1 $file -1
-
-puts "\nShapefile $file:\n"
-puts "\ttype: $types([shp1 cget -type])"
-puts "\tnumber of features: [shp1 cget -numshapes]"
-set rectPtr [shp1 cget -bounds]
-puts "\tbounds: ([mapscript::rectObjRef $rectPtr cget -minx],[mapscript::rectObjRef $rectPtr cget -miny]) ([mapscript::rectObjRef $rectPtr cget -maxx],[mapscript::rectObjRef $rectPtr cget -maxy])"
-
-
diff -pruN 8.0.1-5/mapscript/tcl/mapscript_wrap.html 8.2.0~beta1-1~exp1/mapscript/tcl/mapscript_wrap.html
--- 8.0.1-5/mapscript/tcl/mapscript_wrap.html	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/mapscript_wrap.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,2144 +0,0 @@
-<HTML>
-<HEAD>
-<TITLE>
-mapscript_wrap.c</TITLE>
-<BODY BGCOLOR="#ffffff">
-<H1>mapscript_wrap.c</H1>
-
-<HR><H1> Contents </H1>
-<UL><LI> <A HREF="#s1_">1. class featureListNodeObj</A>
-<LI> <A HREF="#s2_">2. class colorObj</A>
-<LI> <A HREF="#s3_">3. class queryObj</A>
-<LI> <A HREF="#s4_">4. class shapeResultObj</A>
-<LI> <A HREF="#s5_">5. class queryResultObj</A>
-<LI> <A HREF="#s6_">6. class queryMapObj</A>
-<LI> <A HREF="#s7_">7. class labelObj</A>
-<LI> <A HREF="#s8_">8. class webObj</A>
-<LI> <A HREF="#s9_">9. class classObj</A>
-<LI> <A HREF="#s10_">10. class labelCacheMemberObj</A>
-<LI> <A HREF="#s11_">11. class markerCacheMemberObj</A>
-<LI> <A HREF="#s12_">12. class labelCacheObj</A>
-<LI> <A HREF="#s13_">13. class symbolSetObj</A>
-<LI> <A HREF="#s14_">14. class referenceMapObj</A>
-<LI> <A HREF="#s15_">15. class scalebarObj</A>
-<LI> <A HREF="#s16_">16. class legendObj</A>
-<LI> <A HREF="#s17_">17. class layerObj</A>
-<LI> <A HREF="#s18_">18. class mapObj</A>
-<LI> <A HREF="#s19_">19. class errorObj</A>
-<LI> <A HREF="#s20_">20. class rectObj</A>
-<LI> <A HREF="#s21_">21. class pointObj</A>
-<LI> <A HREF="#s22_">22. class lineObj</A>
-<LI> <A HREF="#s23_">23. class shapeObj</A>
-<LI> <A HREF="#s24_">24. class DBFInfo</A>
-<LI> <A HREF="#s25_">25. class shapefileObj</A>
-</UL>
-
-<P><TT><B>mapscript::MS_VERSION = 3.4 (pre-release)</B></TT>
-<BLOCKQUOTE>[ Constant : char * ]
-<BR>   logical control variables   
-</BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_TRUE = 1</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_FALSE = 0</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_ON = 1</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_OFF = 0</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_DEFAULT = 2</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_QUERY = 3</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_EMBED = 4</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_YES = 1</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_NO = 0</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR>   modes for searching (spatial/database)   
-</BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SINGLE = 0</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_MULTIPLE = 1</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR>   General defines, not wrapable
-</BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_FILE_MAP = MS_FILE_MAP</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_FILE_SYMBOL = MS_FILE_SYMBOL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_INCHES = MS_INCHES</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_FEET = MS_FEET</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_MILES = MS_MILES</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_METERS = MS_METERS</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_NAUTICALMILES = MS_NAUTICALMILES</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_KILOMETERS = MS_KILOMETERS</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_DD = MS_DD</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_PIXELS = MS_PIXELS</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_POINT = MS_POINT</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_LINE = MS_LINE</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_POLYGON = MS_POLYGON</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_POLYLINE = MS_POLYLINE</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_RASTER = MS_RASTER</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_ANNOTATION = MS_ANNOTATION</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_NULL = MS_NULL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_TRUETYPE = MS_TRUETYPE</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_BITMAP = MS_BITMAP</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_UL = MS_UL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_LR = MS_LR</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_UR = MS_UR</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_LL = MS_LL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_CR = MS_CR</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_CL = MS_CL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_UC = MS_UC</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_LC = MS_LC</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_CC = MS_CC</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_AUTO = MS_AUTO</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_XY = MS_XY</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR>   arrangement matters for auto placement   
-</BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_TINY = MS_TINY</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SMALL = MS_SMALL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_MEDIUM = MS_MEDIUM</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_LARGE = MS_LARGE</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_GIANT = MS_GIANT</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_NORMAL = MS_NORMAL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_HILITE = MS_HILITE</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SELECTED = MS_SELECTED</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_INVERTED = MS_INVERTED</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_LOCAL = MS_LOCAL</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SDE = MS_SDE</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_OGR = MS_OGR</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_GIF = MS_GIF</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_PNG = MS_PNG</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_JPEG = MS_JPEG</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_WBMP = MS_WBMP</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_FILE_DEFAULT = (MS_FILE_MAP)</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s1_">
-<HR><H2>1. class featureListNodeObj</H2></A>
-[ created from struct featureListNodeObj ]<BR>
-<P><TT><B>-shape
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns shapeObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-next
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns struct listNode * ]
-<BR></BLOCKQUOTE>
-
-<A name="s2_">
-<HR><H2>2. class colorObj</H2></A>
-[ created from struct colorObj ]<BR>
-<P><TT><B>-red
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-green
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-blue
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s3_">
-<HR><H2>3. class queryObj</H2></A>
-[ created from struct queryObj ]<BR>
-<P><TT><B>-expression
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns expressionObj * ]
-<BR>   the expression to be matched  
-</BLOCKQUOTE>
-
-<P><TT><B>-template
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryObj name layer </B></TT>
-<BLOCKQUOTE>[ Constructor: returns queryObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>setExpression string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s4_">
-<HR><H2>4. class shapeResultObj</H2></A>
-[ created from struct shapeResultObj ]<BR>
-<P><TT><B>-layer
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-tile
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-shape
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-query
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s5_">
-<HR><H2>5. class queryResultObj</H2></A>
-[ created from struct queryResultObj ]<BR>
-<P><TT><B>-numlayers
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-numresults
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-numquerylayers
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-currentlayer
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-currenttile
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-currentshape
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   allows for cursors-like access to results
-</BLOCKQUOTE>
-
-<P><TT><B>queryResultObj name filename </B></TT>
-<BLOCKQUOTE>[ Constructor: returns queryResultObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>free </B></TT>
-<BLOCKQUOTE>[ Member : returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>save filename </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>next </B></TT>
-<BLOCKQUOTE>[ Member : returns shapeResultObj  ]
-<BR></BLOCKQUOTE>
-
-<A name="s6_">
-<HR><H2>6. class queryMapObj</H2></A>
-[ created from struct queryMapObj ]<BR>
-<P><TT><B>-height
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-width
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-status
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-style
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   HILITE, SELECTED or NORMAL   
-</BLOCKQUOTE>
-
-<P><TT><B>-color
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s7_">
-<HR><H2>7. class labelObj</H2></A>
-[ created from struct labelObj ]<BR>
-<P><TT><B>-font
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-type
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns enum MS_FONT_TYPE  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-color
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-outlinecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-shadowcolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-shadowsizex
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-shadowsizey
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-backgroundcolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-backgroundshadowcolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-backgroundshadowsizex
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-backgroundshadowsizey
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-size
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-sizescaled
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-minsize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-maxsize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-position
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-offsetx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-offsety
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-angle
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-autoangle
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   true or false 
-</BLOCKQUOTE>
-
-<P><TT><B>-buffer
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   space to reserve around a label   
-</BLOCKQUOTE>
-
-<P><TT><B>-antialias
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-wrap
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-minfeaturesize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   minimum feature size (in pixels) to label   
-</BLOCKQUOTE>
-
-<P><TT><B>-autominfeaturesize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   true or false 
-</BLOCKQUOTE>
-
-<P><TT><B>-mindistance
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-partials
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   can labels run of an image   
-</BLOCKQUOTE>
-
-<P><TT><B>-force
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   labels *must* be drawn
-</BLOCKQUOTE>
-
-<A name="s8_">
-<HR><H2>8. class webObj</H2></A>
-[ created from struct webObj ]<BR>
-<P><TT><B>-log
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-imagepath
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-imageurl
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-template
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-header
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-footer
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-empty
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-error
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   error handling   
-</BLOCKQUOTE>
-
-<P><TT><B>-extent
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns rectObj * ]
-<BR>   clipping extent   
-</BLOCKQUOTE>
-
-<P><TT><B>-minscale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-maxscale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-mintemplate
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-maxtemplate
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<A name="s9_">
-<HR><H2>9. class classObj</H2></A>
-[ created from struct classObj ]<BR>
-<P><TT><B>-color
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-backgroundcolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-outlinecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlaycolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlaybackgroundcolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlayoutlinecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-symbol
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-symbolname
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlaysymbol
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlaysymbolname
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-size
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-sizescaled
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-minsize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-maxsize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlaysize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlaysizescaled
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlayminsize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-overlaymaxsize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-label
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns labelObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-name
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   used for legend labeling   
-</BLOCKQUOTE>
-
-<P><TT><B>classObj name layer </B></TT>
-<BLOCKQUOTE>[ Constructor: returns classObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>setExpression string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>setText layer string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s10_">
-<HR><H2>10. class labelCacheMemberObj</H2></A>
-[ created from struct labelCacheMemberObj ]<BR>
-<P><TT><B>-size
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   parameters that can vary for each label/feature   
-</BLOCKQUOTE>
-
-<P><TT><B>-angle
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-string
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-featuresize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-layeridx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   indexes   
-</BLOCKQUOTE>
-
-<P><TT><B>-classidx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-tileidx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-shapeidx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-point
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns pointObj * ]
-<BR>   label point   
-</BLOCKQUOTE>
-
-<P><TT><B>-poly
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns shapeObj * ]
-<BR>   label bounding box   
-</BLOCKQUOTE>
-
-<P><TT><B>-status
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   has this label been drawn or not   
-</BLOCKQUOTE>
-
-<A name="s11_">
-<HR><H2>11. class markerCacheMemberObj</H2></A>
-[ created from struct markerCacheMemberObj ]<BR>
-<P><TT><B>-id
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   corresponding label
-</BLOCKQUOTE>
-
-<P><TT><B>-poly
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns shapeObj * ]
-<BR>   marker bounding box (POINT layers only)
-</BLOCKQUOTE>
-
-<A name="s12_">
-<HR><H2>12. class labelCacheObj</H2></A>
-[ created from struct labelCacheObj ]<BR>
-<P><TT><B>-labels
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns labelCacheMemberObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-numlabels
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-cachesize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-markers
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns markerCacheMemberObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-nummarkers
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-markercachesize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>freeCache </B></TT>
-<BLOCKQUOTE>[ Member : returns void  ]
-<BR></BLOCKQUOTE>
-
-<A name="s13_">
-<HR><H2>13. class symbolSetObj</H2></A>
-[ created from struct symbolSetObj ]<BR>
-<P><TT><B>-filename
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-fontset
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns fontSetObj * ]
-<BR>   a pointer to the main mapObj version
-</BLOCKQUOTE>
-
-<P><TT><B>-numsymbols
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-symbol
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns symbolObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-imagecache
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns struct imageCacheObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-imagecachesize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s14_">
-<HR><H2>14. class referenceMapObj</H2></A>
-[ created from struct referenceMapObj ]<BR>
-<P><TT><B>-extent
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns rectObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-height
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-width
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-color
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns colorObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-outlinecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns colorObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-image
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-status
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s15_">
-<HR><H2>15. class scalebarObj</H2></A>
-[ created from struct scalebarObj ]<BR>
-<P><TT><B>-imagecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns colorObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-height
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-width
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-style
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-intervals
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-label
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns labelObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-color
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-backgroundcolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-outlinecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-units
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-status
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   ON, OFF or EMBED
-</BLOCKQUOTE>
-
-<P><TT><B>-position
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   for embeded scalebars
-</BLOCKQUOTE>
-
-<P><TT><B>-transparent
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-interlace
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-postlabelcache
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s16_">
-<HR><H2>16. class legendObj</H2></A>
-[ created from struct legendObj ]<BR>
-<P><TT><B>-imagecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns colorObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-label
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns labelObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-keysizex
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-keysizey
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-keyspacingx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-keyspacingy
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-outlinecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   Color of outline of box, -1 for no outline   
-</BLOCKQUOTE>
-
-<P><TT><B>-status
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   ON, OFF or EMBED
-</BLOCKQUOTE>
-
-<P><TT><B>-height
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-width
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-position
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   for embeded legends
-</BLOCKQUOTE>
-
-<P><TT><B>-transparent
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-interlace
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-postlabelcache
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s17_">
-<HR><H2>17. class layerObj</H2></A>
-[ created from struct layerObj ]<BR>
-<P><TT><B>-index
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-classitem
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   .DBF item to be used for symbol lookup   
-</BLOCKQUOTE>
-
-<P><TT><B>-class
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns classObj * ]
-<BR>   always at least 1 class   
-</BLOCKQUOTE>
-
-<P><TT><B>-numclasses
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-name
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   layer name, must be unique   
-</BLOCKQUOTE>
-
-<P><TT><B>-group
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-description
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   layer title or description   
-</BLOCKQUOTE>
-
-<P><TT><B>-legend
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   legend graphic   
-</BLOCKQUOTE>
-
-<P><TT><B>-status
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   layer status, either ON or OFF   
-</BLOCKQUOTE>
-
-<P><TT><B>-data
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   layer data filename, including path   
-</BLOCKQUOTE>
-
-<P><TT><B>-type
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns enum MS_FEATURE_TYPE  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-tolerance
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   search buffer for point and line queries (in toleranceunits)   
-</BLOCKQUOTE>
-
-<P><TT><B>-toleranceunits
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-symbolscale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   scale at which symbols are default size   
-</BLOCKQUOTE>
-
-<P><TT><B>-maxscale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   layer is active only BELOW this scale value (<=)   
-</BLOCKQUOTE>
-
-<P><TT><B>-minscale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   layer is active only ABOVE this scale value (>)   
-</BLOCKQUOTE>
-
-<P><TT><B>-labelminscale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   annotation is active only BELOW this scale value (<=)   
-</BLOCKQUOTE>
-
-<P><TT><B>-labelmaxscale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   annotation is active only ABOVE this scale value (>)   
-</BLOCKQUOTE>
-
-<P><TT><B>-maxfeatures
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-offsite
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   offsite value for raster images   
-</BLOCKQUOTE>
-
-<P><TT><B>-transform
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   does this layer have to be transformed to file coordinates   
-</BLOCKQUOTE>
-
-<P><TT><B>-labelcache
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   on or off   
-</BLOCKQUOTE>
-
-<P><TT><B>-postlabelcache
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-labelitem
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   .DBF item to be used for text   
-</BLOCKQUOTE>
-
-<P><TT><B>-labelsizeitem
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-labelangleitem
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-tileitem
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-tileindex
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   layer index file for tiling support   
-</BLOCKQUOTE>
-
-<P><TT><B>-projection
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns projectionObj * ]
-<BR>   projection information for the layer   
-</BLOCKQUOTE>
-
-<P><TT><B>-features
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns featureListNodeObjPtr  ]
-<BR>   linked list so we don't need a counter   
-</BLOCKQUOTE>
-
-<P><TT><B>-connection
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-connectiontype
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns enum MS_CONNECTION_TYPE  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>layerObj name map </B></TT>
-<BLOCKQUOTE>[ Constructor: returns layerObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getClass i </B></TT>
-<BLOCKQUOTE>[ Member : returns classObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>draw map img </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingPoint map point mode buffer </B></TT>
-<BLOCKQUOTE>[ Member : returns queryResultObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingRect map rect </B></TT>
-<BLOCKQUOTE>[ Member : returns queryResultObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingFeatures map results </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingShape map shape </B></TT>
-<BLOCKQUOTE>[ Member : returns queryResultObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>setProjection string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>addFeature shape </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>classify string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s18_">
-<HR><H2>18. class mapObj</H2></A>
-[ created from struct mapObj ]<BR>
-   structure for a map   
-
-<P><TT><B>-name
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   small identifier for naming etc.   
-</BLOCKQUOTE>
-
-<P><TT><B>-status
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   is map creation on or off   
-</BLOCKQUOTE>
-
-<P><TT><B>-height
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-width
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-layers
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns layerObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-numlayers
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   number of layers in mapfile   
-</BLOCKQUOTE>
-
-<P><TT><B>-labelcache
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns labelCacheObj * ]
-<BR>   we need this here so multiple feature processors can access it   
-</BLOCKQUOTE>
-
-<P><TT><B>-transparent
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-interlace
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-extent
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns rectObj * ]
-<BR>   map extent array   
-</BLOCKQUOTE>
-
-<P><TT><B>-cellsize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   in map units   
-</BLOCKQUOTE>
-
-<P><TT><B>-units
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns enum MS_UNITS  ]
-<BR>   units of the projection   
-</BLOCKQUOTE>
-
-<P><TT><B>-scale
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR>   scale of the output image   
-</BLOCKQUOTE>
-
-<P><TT><B>-shapepath
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   where are the shape files located   
-</BLOCKQUOTE>
-
-<P><TT><B>-tile
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   an optional tile name to use as well   
-</BLOCKQUOTE>
-
-<P><TT><B>-palette
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns paletteObj * ]
-<BR>   holds a map palette   
-</BLOCKQUOTE>
-
-<P><TT><B>-imagecolor
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns colorObj * ]
-<BR>   holds the initial image color value   
-</BLOCKQUOTE>
-
-<P><TT><B>-imagetype
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-imagequality
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-projection
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns projectionObj * ]
-<BR>   projection information for output map   
-</BLOCKQUOTE>
-
-<P><TT><B>-reference
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns referenceMapObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-scalebar
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns scalebarObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-legend
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns legendObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-web
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns webObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapObj name filename </B></TT>
-<BLOCKQUOTE>[ Constructor: returns mapObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getLayer i </B></TT>
-<BLOCKQUOTE>[ Member : returns layerObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getLayerByName name </B></TT>
-<BLOCKQUOTE>[ Member : returns layerObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>addColor r g b </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getSymbolByName type name </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>prepareQuery </B></TT>
-<BLOCKQUOTE>[ Member : returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>prepareImage </B></TT>
-<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>draw </B></TT>
-<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>drawQueryMap results </B></TT>
-<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>drawLegend </B></TT>
-<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>drawScalebar </B></TT>
-<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>drawReferenceMap </B></TT>
-<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>embedScalebar img </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>embedLegend img </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>drawLabelCache img </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>nextLabel </B></TT>
-<BLOCKQUOTE>[ Member : returns labelCacheMemberObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingPoint point mode buffer </B></TT>
-<BLOCKQUOTE>[ Member : returns queryResultObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingRect rect </B></TT>
-<BLOCKQUOTE>[ Member : returns queryResultObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingFeatures results </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>queryUsingShape map shape </B></TT>
-<BLOCKQUOTE>[ Member : returns queryResultObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>setProjection string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>save filename </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::msSaveImage img filename transparent interlace </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::msFreeImage img </B></TT>
-<BLOCKQUOTE>[ returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_NOERR = 0</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_IOERR = 1</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_MEMERR = 2</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_TYPEERR = 3</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SYMERR = 4</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_REGEXERR = 5</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_TTFERR = 6</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_DBFERR = 7</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_GDERR = 8</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_IDENTERR = 9</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_EOFERR = 10</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_PROJERR = 11</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_MISCERR = 12</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_CGIERR = 13</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_WEBERR = 14</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_IMGERR = 15</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_HASHERR = 16</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_JOINERR = 17</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR>   empty search results   
-</BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_NOTFOUND = 18</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SHPERR = 19</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_PARSEERR = 20</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SDEERR = 21</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_OGRERR = 22</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_NUMERRORCODES = 23</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MESSAGELENGTH = 2048</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::ROUTINELENGTH = 64</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s19_">
-<HR><H2>19. class errorObj</H2></A>
-[ created from struct errorObj ]<BR>
-<P><TT><B>-code
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-routine
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-message
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::ms_error_set { errorObj * } 
-mapscript::ms_error_get </B></TT>
-<BLOCKQUOTE>[ Global : errorObj  ms_error ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::msSetError code message routine </B></TT>
-<BLOCKQUOTE>[ returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::msWriteError stream </B></TT>
-<BLOCKQUOTE>[ returns void  ]
-<BR></BLOCKQUOTE>
-
-<A name="s20_">
-<HR><H2>20. class rectObj</H2></A>
-[ created from struct rectObj ]<BR>
-<P><TT><B>-minx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-miny
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-maxx
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-maxy
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rectObj name </B></TT>
-<BLOCKQUOTE>[ Constructor: returns rectObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>fit width height </B></TT>
-<BLOCKQUOTE>[ Member : returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>draw map layer img class_string label_string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s21_">
-<HR><H2>21. class pointObj</H2></A>
-[ created from struct pointObj ]<BR>
-<P><TT><B>-x
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-y
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>pointObj name </B></TT>
-<BLOCKQUOTE>[ Constructor: returns pointObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>draw map layer img class_string label_string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>distanceToPoint point </B></TT>
-<BLOCKQUOTE>[ Member : returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>distanceToLine a b </B></TT>
-<BLOCKQUOTE>[ Member : returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>distanceToShape shape </B></TT>
-<BLOCKQUOTE>[ Member : returns double  ]
-<BR></BLOCKQUOTE>
-
-<A name="s22_">
-<HR><H2>22. class lineObj</H2></A>
-[ created from struct lineObj ]<BR>
-<P><TT><B>-numpoints
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-point
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns pointObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>lineObj name </B></TT>
-<BLOCKQUOTE>[ Constructor: returns lineObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>get i </B></TT>
-<BLOCKQUOTE>[ Member : returns pointObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>add p </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s23_">
-<HR><H2>23. class shapeObj</H2></A>
-[ created from struct shapeObj ]<BR>
-<P><TT><B>-numlines
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-line
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns lineObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-bounds
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns rectObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-type
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-classindex
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-queryindex
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-text
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>shapeObj name type </B></TT>
-<BLOCKQUOTE>[ Constructor: returns shapeObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>get i </B></TT>
-<BLOCKQUOTE>[ Member : returns lineObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>add line </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>draw map layer img class_string label_string </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>setBounds </B></TT>
-<BLOCKQUOTE>[ Member : returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>copy dest </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>contains point </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>intersects shape </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SHAPEFILE_POINT = 1</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SHAPEFILE_ARC = 3</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SHAPEFILE_POLYGON = 5</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::MS_SHAPEFILE_MULTIPOINT = 8</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s24_">
-<HR><H2>24. class DBFInfo</H2></A>
-[ created from struct DBFInfo ]<BR>
-<P><TT><B>-fp
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns FILE * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-nRecords
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-nRecordLength
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-nHeaderLength
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-nFields
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-panFieldOffset
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-panFieldSize
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-panFieldDecimals
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-pachFieldType
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-pszHeader
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-nCurrentRecord
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-bCurrentRecordModified
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-pszCurrentRecord
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-bNoHeader
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>-bUpdated
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getFieldName iField </B></TT>
-<BLOCKQUOTE>[ Member : returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getFieldWidth iField </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getFieldDecimals iField </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getFieldType iField </B></TT>
-<BLOCKQUOTE>[ Member : returns DBFFieldType  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::FTString = FTString</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::FTInteger = FTInteger</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::FTDouble = FTDouble</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::FTInvalid = FTInvalid</B></TT>
-<BLOCKQUOTE>[ Constant : int  ]
-<BR></BLOCKQUOTE>
-
-<A name="s25_">
-<HR><H2>25. class shapefileObj</H2></A>
-[ created from struct shapefileObj ]<BR>
-<P><TT><B>-source
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns char * ]
-<BR>   full path to the shapefile data   
-</BLOCKQUOTE>
-
-<P><TT><B>-hSHP
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns SHPHandle * ]
-<BR>   .SHP/.SHX file pointer   
-</BLOCKQUOTE>
-
-<P><TT><B>-type
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   shape type   
-</BLOCKQUOTE>
-
-<P><TT><B>-numshapes
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns int  ]
-<BR>   number of shapes   
-</BLOCKQUOTE>
-
-<P><TT><B>-bounds
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns rectObj * ]
-<BR>   shape extent   
-</BLOCKQUOTE>
-
-<P><TT><B>-hDBF
-</B></TT>
-<BLOCKQUOTE>[ Member data: returns DBFHandle  ]
-<BR>   .DBF file pointer   
-</BLOCKQUOTE>
-
-<P><TT><B>shapefileObj name filename type </B></TT>
-<BLOCKQUOTE>[ Constructor: returns shapefileObj * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>rename obj {}</B></TT>
-<BLOCKQUOTE>[ Destructor: returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>get i shape </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getTransformed map i shape </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>getExtent i rect </B></TT>
-<BLOCKQUOTE>[ Member : returns void  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>add shape </B></TT>
-<BLOCKQUOTE>[ Member : returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFOpen pszDBFFile pszAccess </B></TT>
-<BLOCKQUOTE>[ returns DBFHandle  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFCreate pszDBFFile </B></TT>
-<BLOCKQUOTE>[ returns DBFHandle  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFGetFieldCount psDBF </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFGetRecordCount psDBF </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFAddField hDBF pszFieldName eType nWidth nDecimals </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFGetFieldInfo psDBF iField pszFieldName pnWidth pnDecimals </B></TT>
-<BLOCKQUOTE>[ returns DBFFieldType  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFReadIntegerAttribute hDBF iShape iField </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFReadDoubleAttribute hDBF iShape iField </B></TT>
-<BLOCKQUOTE>[ returns double  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFReadStringAttribute hDBF iShape iField </B></TT>
-<BLOCKQUOTE>[ returns char * ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFWriteIntegerAttribute hDBF iShape iField nFieldValue </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFWriteDoubleAttribute hDBF iShape iField dFieldValue </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFWriteStringAttribute hDBF iShape iField pszFieldValue </B></TT>
-<BLOCKQUOTE>[ returns int  ]
-<BR></BLOCKQUOTE>
-
-<P><TT><B>mapscript::DBFClose hDBF </B></TT>
-<BLOCKQUOTE>[ returns void  ]
-<BR></BLOCKQUOTE>
-
-
-</BODY>
-</HTML>
diff -pruN 8.0.1-5/mapscript/tcl/mapscriptsupp.html 8.2.0~beta1-1~exp1/mapscript/tcl/mapscriptsupp.html
--- 8.0.1-5/mapscript/tcl/mapscriptsupp.html	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/mapscriptsupp.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,129 +0,0 @@
-<HTML>
-<HEAD>
-<TITLE>
-mapscript_supp.c</TITLE>
-<BODY BGCOLOR="#ffffff">
-<H1>mapscriptsupp.tcl</H1>
-
-<HR><H1> Mapscript Supplemental Procedures </H1>
-<UL>
-<LI> 1. proc mapscript::classObjRef
-<LI> 2. proc mapscript::colorObjRef
-<LI> 3. proc mapscript::errorObjRef
-<LI> 4. proc mapscript::featureListNodeObjRef
-<LI> 5. proc mapscript::itemObjRef
-<LI> 6. proc mapscript::labelCacheMemberObjRef
-<LI> 7. proc mapscript::labelCacheObjRef
-<LI> 8. proc mapscript::labelObjRef
-<LI> 9. proc mapscript::layerObjRef
-<LI> 10. proc mapscript::legendObjRef
-<LI> 11. proc mapscript::lineObjRef
-<LI> 12. proc mapscript::mapObjRef
-<LI> 13. proc mapscript::markerCacheMemberObjRef
-<LI> 14. proc mapscript::pointObjRef
-<LI> 15. proc mapscript::projectionObjRef
-<LI> 16. proc mapscript::queryMapObjRef
-<LI> 17. proc mapscript::rectObjRef
-<LI> 18. proc mapscript::referenceMapObjRef
-<LI> 19. proc mapscript::resultCacheMemberObjRef
-<LI> 20. proc mapscript::resultCacheObjRef
-<LI> 21. proc mapscript::scalebarObjRef
-<LI> 22. proc mapscript::shapeObjRef
-<LI> 23. proc mapscript::shapefileObjRef
-<LI> 24. proc mapscript::symbolSetObjRef
-<LI> 25. proc mapscript::webObjRef
-<LI> 26. proc mapscript::DBFInfoRef
-</UL>
-
-<H2> Usage </H2>
-<P> 
-These procedures allow methods to be invoked on object references 
-(i.e., pointers), without having to convert a reference into an object.
-A valid object reference is required; procedures check for valid object types.
-<P>
-General syntax:
-<BLOCKQUOTE>
-objectRefProc  $objectPtr  args
-</BLOCKQUOTE>
-<P>
-Sample:
-<BLOCKQUOTE>
-set map [mapscript::mapObj -args $mapFile]
-<BR>
-set rectPtr [$map cget -extent]
-<BR>
-set minx [<B>mapscript::rectObjRef</B> $rectPtr cget -minx]
-<BR>
-set miny [<B>mapscript::rectObjRef</B> $rectPtr cget -miny]
-<BR>
-</BLOCKQUOTE>
-<P>
-Notes:  each of the <EM>objectRef</EM> procedures is just a shortcut to invoke a
-SWIG generated method name.   Method names of:
-<UL>
-<LI> cget
-<LI> configure
-<LI> delete
-</UL>
-invoke that object's cget, configure, and delete method respectively.
-<P> Example:
-<BLOCKQUOTE>
-mapscript::rectObjRef $rectPtr cget -minx
-</BLOCKQUOTE>
-is equivalent to:
-<BLOCKQUOTE>
-mapscript::rectObj_minx_get $rectPtr
-</BLOCKQUOTE>
-
-<HR><H1> Mapscript Convenience Procedures </H1>
-<UL>
-<LI> 1. proc mapscript::getDBFNames
-<LI> 2. proc mapscript::getDBFTypes
-<LI> 3. proc mapscript::getDBFValues
-<LI> 4. proc mapscript::getQueryInfo
-</UL>
-
-<H2> Usage </H2>
-<P><b>mapscript::getDBFNames <em> DBFInfo_handle </em></b><br>
-getDBFNames returns a list of field names from a DBF file handle.  The
-<em> DBFInfo_handle </em> must be a valid DBFInfo handle returned from
-the DBFInfo constructor.
-
-<P><b>mapscript::getDBFTypes <em> DBFInfo_handle </em></b><br>
-getDBFTypes returns a list of field types and lengths from a DBF file handle.  
-The <em> DBFInfo_handle </em> must be a valid DBFInfo handle returned from
-the DBFInfo constructor.  Each list element is itself a list of field type
-and field length.  Valid field types are returned as: <b>string</b>,
-<b>integer</b>, and <b>double</b>. 
-
-<P><b>mapscript::getDBFValues <em> DBFInfo_handle record_number </em></b><br>
-getDBFValues returns a list of field values from a DBF file handle.  The
-<em> DBFInfo_handle </em> must be a valid DBFInfo handle returned from
-the DBFInfo constructor.  <em>Record_number</em> is the record number of the
-row to fetch.
-
-<P><b>mapscript::getQueryInfo <em> mapObj_pointer  layerObj_pointer 
-</em></b><br>
-getQueryInfo returns a list of name-value
-pairs from a layer that map query has generated.  
-<em> mapObj_pointer</em> and <em>queryObj_pointer</em> must be valid 
-mapObj and layerObj pointers.
-
-
-<BR>
-<HR>
-<H1>See also</H1>
-<P>
-See <A HREF="mapscript_wrap.html">mapscript_wrap.html</A> for the full
-Mapscript Tcl interface.
-<P>
-Note also that the Mapscript objects described in mapscript_wrap.html are
-defined in the <b> mapscript </b> namespace.
-<P>
-Tom Poindexter
-<BR>
-tpoindex@nyx.net
-<BR>
-
-</BODY>
-</HTML>
diff -pruN 8.0.1-5/mapscript/tcl/mapscriptsupp.tcl 8.2.0~beta1-1~exp1/mapscript/tcl/mapscriptsupp.tcl
--- 8.0.1-5/mapscript/tcl/mapscriptsupp.tcl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/mapscriptsupp.tcl	1970-01-01 00:00:00.000000000 +0000
@@ -1,177 +0,0 @@
-#  mapscriptsupp.tcl
-# 
-#  define procs to invoke object methods using an object pointer
-#  tom poindexter, nov 2000, tpoindex@nyx.net
-#  
-#  e.g.  shapeObj method arg arg ...
-#        can be invoked on a shapeObj pointer as:
-#        shapeObjRef $shapeObjPointer method arg arg ...        
-#
-#  convenience procedures:
-#   getDBFNames  $DBFHandle		       :returns list of field names
-#   getDBFTypes  $DBFHandle 		       :returns list of field types 
-#   getDBFValues $DBFHandle $rec	       :returns list of field values
-#   getQueryInfo $mapPtr $layerPtr             :return "field value" from query
-
-
-# fix SWIG error
-# some swig versions don't handle namespaces when generating shadow objects
-# mapscript just has one - ms_error
-#
-
-if {![string length [info commands ::mapscript::ms_error]]} {
- catch {
-  ::mapscript::errorObj ::mapscript::ms_error -this [::mapscript::ms_error_get]
- }
-}
-
-#
-# now define object helper procs
-#
-
-namespace eval ::mapscript {
-
-proc _mapscript_init_ {} {
-
-    set code {
-        proc OBJECTRef {ptr method args} {
-	    # check ptr for correct object type
-	    #if {! [regexp {_[^_]*_OBJECT_p} $ptr]} {
-	    #	error "OBJECTRef pointer \"$ptr\" has wrong object class"
-	    #}
-	    # check for configure/cget/delete commands 
-	    set member ""
-	    set delete ""
-	    switch -- $method {
-		configure {
-		    set command _set
-		    set member _[string range [lindex $args 0] 1 end]
-		    set args [lrange $args 1 end]
-		}
-		cget {
-		    set command _get
-		    set member _[string range [lindex $args 0] 1 end]
-		    set args ""
-		}
-		delete {
-		    set delete delete_
-		    set command ""
-		    set args ""
-		}
-		default {
-	    	    set command _$method
-		}
-	    }
-	    # check of existence of command
-	    if {! [string length \
-	      [info command ::mapscript::${delete}OBJECT${member}${command}]]} {
-		error "OBJECT does not have method named \"$method\", or \
-		       a member named \"$member\""
-	    }
-	    # invoke command 
-	    return [uplevel "::mapscript::${delete}OBJECT${member}${command} \
-								$ptr $args"]
-        }
-    }
-
-    foreach obj {classObj colorObj errorObj featureListNodeObj itemObj  \
-		 labelCacheMemberObj labelCacheObj labelObj layerObj  \
-		 legendObj lineObj mapObj markerCacheMemberObj pointObj \
-		 projectionObj queryMapObj rectObj referenceMapObj  \
-		 resultCacheMemberObj resultCacheObj scalebarObj shapeObj \
-		 shapefileObj symbolSetObj webObj \
-		 DBFInfo} {
-    
-        regsub -all OBJECT $code $obj proc_code
-        eval $proc_code
-    }
-}
-
-
-# run the help proc initialization, then get rid of it
-
-_mapscript_init_
-rename _mapscript_init_ {}
-
-
-#
-# now create convenience procs
-#
-
-proc getDBFNames {dbf} {
-    set n [msDBFGetFieldCount $dbf]
-    set names ""
-    for {set i 0} {$i < $n} {incr i} {
-	lappend names [DBFInfoRef $dbf getFieldName $i]
-    }
-    return $names
-}
-
-proc getDBFTypes {dbf} {
-    set n [msDBFGetFieldCount $dbf]
-    set types ""
-    for {set i 0} {$i < $n} {incr i} {
-	set t [DBFInfoRef $dbf getFieldType $i]
-	switch $t \
-	    $::mapscript::FTString  {set t string}  \
-	    $::mapscript::FTInteger {set t integer} \
-	    $::mapscript::FTDouble  {set t double}  \
-	    default      {set t invalid}
-
-	lappend t [DBFInfoRef $dbf getFieldWidth $i]
-        lappend types $t
-    }
-    return $types
-}
-
-proc getDBFValues {dbf rec} {
-    set n [msDBFGetFieldCount $dbf]
-    set r [msDBFGetRecordCount $dbf]
-    if {$rec >= $r || $rec < -1} {return ""}
-    set values ""
-    for {set i 0} {$i < $n} {incr i} {
-	switch [DBFInfoRef $dbf getFieldType $i] \
-	    $::mapscript::FTString  {
-		set t [msDBFReadStringAttribute  $dbf $rec $i]
-	    } \
-	    $::mapscript::FTInteger {
-		set t [msDBFReadIntegerAttribute $dbf $rec $i]
-	    } \
-	    $::mapscript::FTDouble  {
-		set t [msDBFReadDoubleAttribute  $dbf $rec $i]
-	    } \
-	    default      {set t ""}
-	lappend values $t
-    }
-    return $values
-}
-
-proc getQueryInfo {mapPtr layerPtr} {
-    
-    layerObjRef $layerPtr open [mapObjRef $mapPtr cget -shapepath]
-    set rescachePtr [layerObjRef $layerPtr cget -resultcache]
-    set numResults  [resultCacheObjRef $rescachePtr cget -numresults]
-
-    for {set i 0} {$i < $numResults} {incr i} {
-	set resmemPtr [layerObjRef $layerPtr getResult $i]
-        set shpIdx    [resultCacheMemberObjRef $resmemPtr cget -shapeindex]
-        set tileIdx   [resultCacheMemberObjRef $resmemPtr cget -tileindex]
-	set shpPtr    [shapeObj -args $mapscript::MS_SHAPE_NULL]
-	set rc        [layerObjRef $layerPtr getShape $shpPtr $tileIdx $shpIdx]
-	set numValues [shapeObjRef $shpPtr cget -numvalues]
-
-	set pairs ""
-	for {set j 0} {$j < $numValues} {incr j} {
-	    lappend pairs [layerObjRef $layerPtr getItem $j] \
-			  [shapeObjRef $shpPtr getValue $j]
-	}
-        # delete the temporary shpPtr
-	catch {rename $shpPtr {}}
-    }
-    layerObjRef $layerPtr close
-    return $pairs
-}
-
-
-
-} ;#end of namespace command
diff -pruN 8.0.1-5/mapscript/tcl/pkgIndex.tcl 8.2.0~beta1-1~exp1/mapscript/tcl/pkgIndex.tcl
--- 8.0.1-5/mapscript/tcl/pkgIndex.tcl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/pkgIndex.tcl	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-# pkgIndex.tcl for mapscript
-#
-# load shared library, and source supplementaly ref procs
-
-package ifneeded Mapscript 1.1 " 
-    load [list [file join $dir libMapscript11[info sharedlibextension]]]
-    # source the object reference helpers and convenience procs
-    source [list [file join $dir mapscriptsupp.tcl]]
-    package provide Mapscript 1.1
-"
-
-
diff -pruN 8.0.1-5/mapscript/tcl/win/README.ms-mingw 8.2.0~beta1-1~exp1/mapscript/tcl/win/README.ms-mingw
--- 8.0.1-5/mapscript/tcl/win/README.ms-mingw	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/win/README.ms-mingw	1970-01-01 00:00:00.000000000 +0000
@@ -1,130 +0,0 @@
-Mapserver and Mapscript/Tcl for Windows
-
-These are the steps I have made to compile Mapserver and Mapscript/Tcl for
-Windows.  My build environment is the Mingw (Minimalist GNU for Windows)
-compiler and toolchain, hosted on Linux/Unix.  
-
-You probably want to use the pre-compiled DLL, if at all possible.
-Things get ugly after this......
-
-
-
-First, make a new directory to hold everthing we will need.
-
-	mkdir ms_win
-	cd ms_win
-
-Unpack the ms-mingw.tar.gz in that directory:
-
-	gunzip -c ../ms-mingw.tar.gz | tar xf -
-
-
-Next, you'll need the Mingw compiler and toolchain, compiled as a 
-cross compiler, hosted on your Linux or Unix platform.
-
-Mo DeJong has written a shell script to download, compile, and install *all*
-of the compiler, toolchain, and Mingw libraries.  The script is in
-ms-mingw/mingw-xcc.sh  I have set the script to install the tools into
-/opt/mingw.  If you want to change this, you'll need to also change the 'build'
-shell script.  The mingw-xcc.sh script uses the 'wget' program to fetch
-files via ftp (ftp://ftp.gnu.org/gnu/wget/).
-
-	cd ms-mingw
-	sh mingw-xcc.sh
-	cd ..
-
-
-Next, get *fresh* sources of all of the required MapServer packages, and 
-unpack in the ms_win directory.  Your 'ms_win' directory should look 
-like this after unpacking all of the sources:
-
-	README.ms-mingw  install     ms-mingw/    tcl8.3.2/
-	build            jpeg-6b/    proj-4.4.2/  tiff-v3.5.5/
-	freetype-1.3.1/  mapserver/  regex-0.12/  zlib-1.1.3/
-
-
-The 'ms-mingw' directory contains directories for each of the components we
-will be building.  Each directory consists of a Makefile for Mingw as a 
-cross compiler, and a 'build' script to copy the Makefile into the source
-directories (as above), and make the libraries.
-
-Software locations:
-
-mingw:	http://www.mingw.org
-	The mingw-xcc.sh script will grab things for you.
-	There's a lot of info on the Mingw compiler and its use as a 
-	cross compiler at the site.
-
-proj:	http://www.remotesensing.org/proj/
-	Get version 4.4.2
-
-zlib:   http://www.info-zip.org/pub/infozip/zlib/
-	Get version 1.1.3
-
-jpeg:   ftp://ftp.uu.net/graphics/jpeg/
-	Get version 6b.
-
-tiff:   http://www.libtiff.org/
-	Get version 3.5.5
-
-freetype: http://www.freetype.org
-	Get version 1.3.1
-	NOTE!!!  I have found the the freetype-1.3.1.tar.gz file contains
-	source files with dos style end of line characters (cr-lf).  This 
-	will likely confuse gcc.  The easy way to convert into normal
-	unix-style text files is to get the freetype-1.3.1.zip, and
-	use 'unzip -a freetype-1.3.1' to unpack it, converting the
-	files to use lf only.  Rename the 'freetype' directory to 
-	'freetype-1.3.1'.
-
-regex: ftp://ftp.gnu.org/pub/gnu/regex/regex-0.12.tar.gz
-	  
-mapserver: http://mapserver.gis.umn.edu/dload.html
-	Get the 'nightly' CVS builds for 3.4 (beta), nightly.tar.gz. 
-	We will also use the GD 1.2 and GDFT libraries that come with 
-	Mapserver.  As a side effect, we will also build an executable,
-	mapserv.exe.
-
-tcl:	http://dev.scriptics.com
-	Get version 8.3.2
-	We will only be building 'libtclstub83.a', not the entire 
-	Tcl library.  Also get 'tcl832.exe' and install it on your Windows
-	machine(s) if you don't already have it.  For best results,
-	let the installer place Tcl in 'C:\Program Files\Tcl'.
-
-
-
-
-Build everything:
-Use the build script in this directory.  (change the values of 'mingwbin' and
-'mingwxcc' if needed.)
-
-	sh build
-
-Install:
-You probably have to be root to write into /c.
-
-	sh install
-
-Or, you can ftp the files over to your windows box and use the 'setup.tcl' 
-installer.
-
-
-Notes:  
-
-Building for Windows is a royal pain in the ***!  The biggest problem is
-building the various libraries the 'right' way, i.e, as DLL files.  This
-requires a majic Windows macro to export the symbols for the DLL, but another
-majic macro for code that uses the symbols in a DLL.  For software originally
-not designed to be portable across Unix and Windows, this requires changing
-alot of source files.  
-
-    Examples of software that is written for portability: zlib, tcl
-    Examples of software that is not: proj, mapserver
-
-The alternative:  compile the source library code, and bundling it into
-a standard library file, e.g., libz.a, libjpeg.a, libttf.a, etc.
-We then take all of the libraries and create our final DLL, libMapscript.dll.
-The downside is that we're not allowing any reuse of the libaries, but the
-upside is we don't have to change much exisiting code.  I do this method.
-
Binary files 8.0.1-5/mapscript/tcl/win/ms-mingw.tar and 8.2.0~beta1-1~exp1/mapscript/tcl/win/ms-mingw.tar differ
diff -pruN 8.0.1-5/mapscript/tcl/win/setup.tcl 8.2.0~beta1-1~exp1/mapscript/tcl/win/setup.tcl
--- 8.0.1-5/mapscript/tcl/win/setup.tcl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/tcl/win/setup.tcl	1970-01-01 00:00:00.000000000 +0000
@@ -1,20 +0,0 @@
-# install mapscript/tcl
-
-set tclhome [file dirname $tcl_library]
-set mslib $tclhome/MapscriptTcl1.0
-
-if {! [file isdirectory $mslib]} {
-    file mkdir $mslib
-}
-
-file copy -force libMapscript.dll      $mslib
-file copy -force ../pkgIndex.tcl       $mslib
-file copy -force ../mapscriptsupp.tcl  $mslib
-catch {file copy -force ../mapscriptsupp.html  $mslib}
-catch {file copy -force ../mapscript_wrap.html  $mslib}
-
-wm title . "Mapscript/Tcl Installer"
-label .l -text "Mapscript/Tcl Installation is complete."
-button .b -text Ok -command exit
-pack .l .b -side top -padx 30 -pady 30
-
diff -pruN 8.0.1-5/mapscript/v8/line.cpp 8.2.0~beta1-1~exp1/mapscript/v8/line.cpp
--- 8.0.1-5/mapscript/v8/line.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/line.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,232 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include "mapserver-config.h"
-#ifdef USE_V8_MAPSCRIPT
-
-#include "v8_mapscript.h"
-
-using namespace v8;
-
-Persistent<FunctionTemplate> Line::constructor;
-
-void Line::Initialize(Handle<Object> target)
-{
-  HandleScope scope;
-
-  Handle<FunctionTemplate> c = FunctionTemplate::New(Line::New);
-  c->InstanceTemplate()->SetInternalFieldCount(1);
-  c->SetClassName(String::NewSymbol("lineObj"));
-
-  SET_ATTRIBUTE_RO(c, "numpoints", getProp);
-
-  NODE_SET_PROTOTYPE_METHOD(c, "point", getPoint);
-  NODE_SET_PROTOTYPE_METHOD(c, "addXY", addXY);
-  NODE_SET_PROTOTYPE_METHOD(c, "addXYZ", addXYZ);
-  NODE_SET_PROTOTYPE_METHOD(c, "add", addPoint);
-
-  target->Set(String::NewSymbol("lineObj"), c->GetFunction());
-
-  constructor.Reset(Isolate::GetCurrent(), c);
-}
-
-void Line::Dispose()
-{
-  Line::constructor.Dispose();
-  Line::constructor.Clear();
-}
-
-Line::~Line()
-{
-  if (this->freeInternal) {
-    msFree(this->this_->point);
-    msFree(this->this_);
-  }
-}
-
-Handle<Function> Line::Constructor()
-{
-  return (*Line::constructor)->GetFunction();
-}
-
-void Line::New(const v8::FunctionCallbackInfo<Value>& args)
-{
-  HandleScope scope;
-
-  if (args[0]->IsExternal())
-  {
-    Local<External> ext = Local<External>::Cast(args[0]);
-    void *ptr = ext->Value();
-    Line *line = static_cast<Line*>(ptr);
-    Handle<Object> self = args.Holder();
-    line->Wrap(self);
-    if (line->parent_) {
-      self->SetHiddenValue(String::New("__parent__"), line->parent_->handle());
-      line->disableMemoryHandler();
-    }
-  }
-  else
-  {
-    lineObj *l = (lineObj *)msSmallMalloc(sizeof(lineObj));
-
-    l->numpoints=0;
-    l->point=NULL;
-
-    Line *line = new Line(l);
-    line->Wrap(args.Holder());
-  }
-
-}
-
-Line::Line(lineObj *l, ObjectWrap *p):
-  ObjectWrap()
-{
-  this->this_ = l;
-  this->parent_ = p;
-  this->freeInternal = true;
-}
-
-void Line::getProp(Local<String> property,
-                   const PropertyCallbackInfo<Value>& info)
-{
-    HandleScope scope;
-    Line* l = ObjectWrap::Unwrap<Line>(info.Holder());
-    std::string name = TOSTR(property);
-    Handle<Value> value = Undefined();
-
-    if (name == "numpoints")
-      value = Integer::New(l->get()->numpoints);
-
-    info.GetReturnValue().Set(value);
-}
-
-void Line::getPoint(const v8::FunctionCallbackInfo<Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 1 || !args[0]->IsInt32()) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
-
-  int index = args[0]->Int32Value();
-
-  if (index < 0 || index >= line->numpoints)
-  {
-    ThrowException(String::New("Invalid point index."));
-    return;
-  }
-
-  Point *point = new Point(&line->point[index], l);
-  Handle<Value> ext = External::New(point);
-  args.GetReturnValue().Set(Point::Constructor()->NewInstance(1, &ext));
-}
-
-void Line::addXY(const v8::FunctionCallbackInfo<Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 2 || !args[0]->IsNumber() || !args[1]->IsNumber()) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
-
-  if(line->numpoints == 0) /* new */
-    line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
-  else /* extend array */
-    line->point = (pointObj *)msSmallRealloc(line->point, sizeof(pointObj)*(line->numpoints+1));
-
-  line->point[line->numpoints].x = args[0]->NumberValue();
-  line->point[line->numpoints].y = args[1]->NumberValue();
-  if (args.Length() > 2 && args[2]->IsNumber())
-    line->point[line->numpoints].m = args[2]->NumberValue();
-
-  line->numpoints++;
-}
-
-void Line::addXYZ(const v8::FunctionCallbackInfo<Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 3 || !args[0]->IsNumber() ||
-      !args[1]->IsNumber() || !args[2]->IsNumber()) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
-
-  if(line->numpoints == 0) /* new */
-    line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
-  else /* extend array */
-    line->point = (pointObj *)msSmallRealloc(line->point, sizeof(pointObj)*(line->numpoints+1));
-
-  line->point[line->numpoints].x = args[0]->NumberValue();
-  line->point[line->numpoints].y = args[1]->NumberValue();
-  line->point[line->numpoints].z = args[2]->NumberValue();
-  if (args.Length() > 3 && args[3]->IsNumber())
-    line->point[line->numpoints].m = args[3]->NumberValue();
-  line->numpoints++;
-}
-
-void Line::addPoint(const v8::FunctionCallbackInfo<Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 1 || !args[0]->IsObject() ||
-      !args[0]->ToObject()->GetConstructorName()->Equals(String::New("pointObj"))) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
-  Point* p = ObjectWrap::Unwrap<Point>(args[0]->ToObject());
-  pointObj* point = p->get();
-
-  if(line->numpoints == 0) /* new */
-    line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
-  else /* extend array */
-    line->point = (pointObj *)msSmallRealloc(line->point, sizeof(pointObj)*(line->numpoints+1));
-
-  line->point[line->numpoints].x = point->x;
-  line->point[line->numpoints].y = point->y;
-  line->point[line->numpoints].z = point->z;
-  if (args.Length() > 3 && args[3]->IsNumber())
-    line->point[line->numpoints].m = point->m;
-  line->numpoints++;
-}
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/line.hpp 8.2.0~beta1-1~exp1/mapscript/v8/line.hpp
--- 8.0.1-5/mapscript/v8/line.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/line.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#ifndef LINE_H_
-#define LINE_H_
-
-#include <v8.h>
-
-using namespace v8;
-
-class Line: public ObjectWrap
-{
-public:
-  static void Initialize(Handle<Object> target);
-  static void New(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void Dispose();
-  static Handle<Function> Constructor();
-
-  Line(lineObj *l, ObjectWrap *p = NULL);
-  ~Line();
-  inline lineObj* get() { return this_; }
-  inline void disableMemoryHandler() { this->freeInternal = false; }
-
-  static void getProp(Local<String> property,
-                      const PropertyCallbackInfo<Value>& info);
-  static void setProp(Local<String> property,
-                      Local<Value> value,
-                      const PropertyCallbackInfo<void>& info);
-
-  static void getPoint(const v8::FunctionCallbackInfo<Value>& args);
-  static void addXY(const v8::FunctionCallbackInfo<Value>& args);
-  static void addXYZ(const v8::FunctionCallbackInfo<Value>& args);
-  static void addPoint(const v8::FunctionCallbackInfo<Value>& args);
-private:
-  static Persistent<FunctionTemplate> constructor;
-  lineObj *this_;
-  ObjectWrap *parent_;
-  bool freeInternal;
-};
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/point.cpp 8.2.0~beta1-1~exp1/mapscript/v8/point.cpp
--- 8.0.1-5/mapscript/v8/point.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/point.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,194 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include "mapserver-config.h"
-#ifdef USE_V8_MAPSCRIPT
-
-#include "v8_mapscript.h"
-
-using namespace v8;
-
-Persistent<FunctionTemplate> Point::constructor;
-
-void Point::Initialize(Handle<Object> target)
-{
-  HandleScope scope;
-
-  Handle<FunctionTemplate> c = FunctionTemplate::New(Point::New);
-  c->InstanceTemplate()->SetInternalFieldCount(1);
-  c->SetClassName(String::NewSymbol("pointObj"));
-
-  SET_ATTRIBUTE(c, "x", getProp, setProp);
-  SET_ATTRIBUTE(c, "y", getProp, setProp);
-  SET_ATTRIBUTE(c, "z", getProp, setProp);
-  SET_ATTRIBUTE(c, "m", getProp, setProp);
-
-  NODE_SET_PROTOTYPE_METHOD(c, "setXY", setXY);
-  NODE_SET_PROTOTYPE_METHOD(c, "setXYZ", setXYZ);
-
-  target->Set(String::NewSymbol("pointObj"), c->GetFunction());
-
-  constructor.Reset(Isolate::GetCurrent(), c);
-}
-
-void Point::Dispose()
-{
-  Point::constructor.Dispose();
-  Point::constructor.Clear();
-}
-
-Point::~Point()
-{
-  if (this->freeInternal) {
-    msFree(this->get());
-  }
-}
-
-Handle<Function> Point::Constructor()
-{
-  return (*Point::constructor)->GetFunction();
-}
-
-void Point::New(const v8::FunctionCallbackInfo<Value>& args)
-{
-  HandleScope scope;
-
-  if (args[0]->IsExternal())
-  {
-    Local<External> ext = Local<External>::Cast(args[0]);
-    void *ptr = ext->Value();
-    Point *point = static_cast<Point*>(ptr);
-    Handle<Object> self = args.Holder();
-    point->Wrap(self);
-    if (point->parent_) {
-      self->SetHiddenValue(String::New("__parent__"), point->parent_->handle());
-      point->disableMemoryHandler();
-    }
-  }
-  else
-  {
-    pointObj *p = (pointObj *)msSmallMalloc(sizeof(pointObj));
-
-    p->x = 0;
-    p->y = 0;
-    p->z = 0;
-    p->m = 0;
-
-    Point *point = new Point(p);
-    point->Wrap(args.Holder());
-  }
-}
-
- Point::Point(pointObj *p, ObjectWrap *pa):
-  ObjectWrap()
-{
-    this->this_ = p;
-    this->parent_ = pa;
-    this->freeInternal = true;
-}
-
-void Point::getProp(Local<String> property,
-                    const PropertyCallbackInfo<Value>& info)
-{
-    HandleScope scope;
-    Point* p = ObjectWrap::Unwrap<Point>(info.Holder());
-    std::string name = TOSTR(property);
-    Handle<Value> value = Undefined();
-    
-    if (name == "x")
-      value = Number::New(p->get()->x);
-    else if (name == "y")
-      value = Number::New(p->get()->y);
-    else if (name == "z")
-      value = Number::New(p->get()->z);
-    else if (name == "m")
-      value = Number::New(p->get()->m);
-
-    info.GetReturnValue().Set(value);
-}
-
-void Point::setProp(Local<String> property,
-                    Local<Value> value,
-                    const PropertyCallbackInfo<void>& info)
-{
-    HandleScope scope;
-    Point* p = ObjectWrap::Unwrap<Point>(info.Holder());
-    std::string name = TOSTR(property);
-    if (!value->IsNumber())
-      ThrowException(Exception::TypeError(
-                           String::New("point value must be a number")));
-    if (name == "x") {
-      p->get()->x = value->NumberValue();
-    } else if (name == "y") {
-      p->get()->y = value->NumberValue();
-    }
-    else if (name == "z") {
-      p->get()->z = value->NumberValue();
-    } else if (name == "m") {
-      p->get()->m = value->NumberValue();
-    }
-}
-
-void Point::setXY(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 2 || !args[0]->IsNumber() || !args[1]->IsNumber()) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Point* p = ObjectWrap::Unwrap<Point>(args.Holder());
-
-  p->get()->x = args[0]->NumberValue();
-  p->get()->y = args[1]->NumberValue();
-
-}
-
-void Point::setXYZ(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 3 ||
-      !args[0]->IsNumber() || !args[1]->IsNumber() || !args[2]->IsNumber()) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Point* p = ObjectWrap::Unwrap<Point>(args.Holder());
-
-  p->get()->x = args[0]->NumberValue();
-  p->get()->y = args[1]->NumberValue();
-
-  p->get()->z = args[2]->NumberValue();
-  if (args.Length() > 3 && args[3]->IsNumber()) {
-    p->get()->m = args[3]->NumberValue();
-  }
-}
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/point.hpp 8.2.0~beta1-1~exp1/mapscript/v8/point.hpp
--- 8.0.1-5/mapscript/v8/point.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/point.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,64 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#ifndef POINT_H_
-#define POINT_H_
-
-#include <v8.h>
-
-using namespace v8;
-
-class Point: public ObjectWrap
-{
-public:
-  static void Initialize(Handle<Object> target);
-  static void New(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void Dispose();
-  static Handle<Function> Constructor();
-
-  Point(pointObj *p, ObjectWrap *pa = NULL);
-  ~Point();
-  inline pointObj* get() { return this_; }
-  inline void disableMemoryHandler() { this->freeInternal = false; }
-
-  static void getProp(Local<String> property,
-                      const PropertyCallbackInfo<Value>& info);
-  static void setProp(Local<String> property,
-                      Local<Value> value,
-                      const PropertyCallbackInfo<void>& info);
-
-  static void setXY(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void setXYZ(const v8::FunctionCallbackInfo<v8::Value>& args);
-private:
-  static Persistent<FunctionTemplate> constructor;
-  pointObj *this_;
-  ObjectWrap *parent_;
-  bool freeInternal;
-};
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/shape.cpp 8.2.0~beta1-1~exp1/mapscript/v8/shape.cpp
--- 8.0.1-5/mapscript/v8/shape.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/shape.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,363 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include "mapserver-config.h"
-#ifdef USE_V8_MAPSCRIPT
-
-#include "v8_mapscript.h"
-#include <map>
-
-using namespace v8;
-using std::map;
-using std::string;
-
-Persistent<FunctionTemplate> Shape::constructor;
-
-void Shape::Initialize(Handle<Object> target)
-{
-  HandleScope scope;
-
-  Handle<FunctionTemplate> c = FunctionTemplate::New(Shape::New);
-  c->InstanceTemplate()->SetInternalFieldCount(1);
-  c->SetClassName(String::NewSymbol("shapeObj"));
-
-  SET_ATTRIBUTE_RO(c, "numvalues", getProp);
-  SET_ATTRIBUTE_RO(c, "numlines", getProp);
-  SET_ATTRIBUTE_RO(c, "index", getProp);
-  SET_ATTRIBUTE_RO(c, "type", getProp);
-  SET_ATTRIBUTE_RO(c, "tileindex", getProp);
-  SET_ATTRIBUTE_RO(c, "classindex", getProp);
-  SET_ATTRIBUTE(c, "text", getProp, setProp);
-
-  NODE_SET_PROTOTYPE_METHOD(c, "clone", clone);
-  NODE_SET_PROTOTYPE_METHOD(c, "line", getLine);
-  NODE_SET_PROTOTYPE_METHOD(c, "add", addLine);
-  NODE_SET_PROTOTYPE_METHOD(c, "setGeometry", setGeometry);
-
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Point",MS_SHAPE_POINT);
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Line",MS_SHAPE_LINE);
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Polygon",MS_SHAPE_POLYGON);
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Null",MS_SHAPE_NULL);
-
-  target->Set(String::NewSymbol("shapeObj"), c->GetFunction());
-
-  constructor.Reset(Isolate::GetCurrent(), c);
-}
-
-void Shape::Dispose()
-{
-  Shape::constructor.Dispose();
-  Shape::constructor.Clear();
-}
-
-Shape::~Shape()
-{
-  /* this is set to false if the shapeObj is owned by mapserver and not v8 */
-  if (freeInternal) {
-    msFreeShape(this->get());
-    msFree(this->get());
-  }
-}
-
-Handle<Function> Shape::Constructor()
-{
-  return (*Shape::constructor)->GetFunction();
-}
-
-void Shape::New(const v8::FunctionCallbackInfo<Value>& args)
-{
-  HandleScope scope;
-  Handle<Object> self = args.Holder();
-  Shape *shape;
-
-  if (args[0]->IsExternal())
-  {
-    Local<External> ext = Local<External>::Cast(args[0]);
-    void *ptr = ext->Value();
-    shape = static_cast<Shape*>(ptr);
-    shape->Wrap(args.Holder());
-  }
-  else
-  {
-    shapeObj *s = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
-
-    msInitShape(s);
-    if(args.Length() >= 1) {
-      s->type = args[0]->Int32Value();
-    }
-    else {
-      s->type = MS_SHAPE_NULL;
-    }
-
-    shape = new Shape(s);
-    shape->Wrap(self);
-  }
-
-  /* create the attribute template. should use ObjectWrap in future */
-  Handle<ObjectTemplate> attributes_templ = ObjectTemplate::New();
-  attributes_templ->SetInternalFieldCount(2);
-  attributes_templ->SetNamedPropertyHandler(attributeGetValue,
-                                            attributeSetValue);
-  Handle<Object> attributes = attributes_templ->NewInstance();
-  map<string, int> *attributes_map = new map<string, int>();
-  attributes->SetInternalField(0, External::New(attributes_map));
-  attributes->SetInternalField(1, External::New(shape->get()->values));  
-  attributes->SetHiddenValue(String::New("__parent__"), self);
-
-  if (shape->layer) {
-    for (int i=0; i<shape->layer->numitems; ++i) {
-      (*attributes_map)[string(shape->layer->items[i])] = i;
-    }
-  }
-
-  Persistent<Object> pattributes;
-  pattributes.Reset(Isolate::GetCurrent(), attributes);
-  pattributes.MakeWeak(attributes_map, attributeWeakCallback);
-  pattributes.MarkIndependent();
-
-  self->Set(String::New("attributes"), attributes);
-}
-
-Shape::Shape(shapeObj *s):
-  ObjectWrap()
-{
-  this->this_ = s;
-  this->layer = NULL;
-  this->freeInternal = true;
-}
-
-void Shape::getProp(Local<String> property,
-                    const PropertyCallbackInfo<Value>& info)
-{
-    HandleScope scope;
-    Shape* s = ObjectWrap::Unwrap<Shape>(info.Holder());
-    std::string name = TOSTR(property);
-    Handle<Value> value = Undefined();
-
-    if (name == "numvalues")
-      value = Integer::New(s->get()->numvalues);
-    else if (name == "numlines")
-      value = Integer::New(s->get()->numlines);
-    else if (name == "index")
-      value = Number::New(s->get()->index);
-    else if (name == "type")
-      value = Integer::New(s->get()->type);
-    else if (name == "tileindex")
-      value = Integer::New(s->get()->tileindex);
-    else if (name == "classindex")
-      value = Integer::New(s->get()->classindex);
-    else if (name == "text")
-      value = String::New(s->get()->text);
-
-    info.GetReturnValue().Set(value);
-}
-
-void Shape::setProp(Local<String> property,
-                    Local<Value> value,
-                    const PropertyCallbackInfo<void>& info)
-{
-    HandleScope scope;
-    Shape* s = ObjectWrap::Unwrap<Shape>(info.Holder());
-    std::string name = TOSTR(property);
-
-    if (name == "text") {
-      if (s->get()->text)
-        msFree(s->get()->text);
-      s->get()->text = getStringValue(value);
-    }
-}
-
-void Shape::clone(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
-  HandleScope scope;
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
-  shapeObj *shape = s->get();
-
-  shapeObj *new_shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
-  msInitShape(new_shape);
-  msCopyShape(shape, new_shape);
-
-  Shape *ns = new Shape(new_shape);
-  Handle<Value> ext = External::New(ns);
-  Handle<Object> clone =  Shape::Constructor()->NewInstance(1, &ext);
-
-  /* we need this to copy shape attributes */
-  Handle<Object> self = s->handle();
-  Handle<Object> self_attributes = self->Get(String::New("attributes"))->ToObject();
-  Local<External> wrap = Local<External>::Cast(self_attributes->GetInternalField(0));
-  void *ptr = wrap->Value();
-  map<string, int> *self_attributes_map = static_cast<map<string, int> *>(ptr);
-
-  Handle<Object> clone_attributes = clone->Get(String::New("attributes"))->ToObject();
-  wrap = Local<External>::Cast(clone_attributes->GetInternalField(0));
-  ptr = wrap->Value();
-  map<string, int> *clone_attributes_map = static_cast<map<string, int> *>(ptr);
-
-  clone_attributes_map->insert(self_attributes_map->begin(),
-                               self_attributes_map->end());
-
-  args.GetReturnValue().Set(clone);
-}
-
-void Shape::getLine(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 1 || !args[0]->IsInt32()) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  int index = args[0]->Int32Value();
-
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
-  shapeObj *shape = s->get();
-
-  if (index < 0 || index >= shape->numlines)
-  {
-    ThrowException(String::New("Invalid line index."));
-    return;
-  }
-
-  Line *line = new Line(&shape->line[index], s);
-  Handle<Value> ext = External::New(line);
-  args.GetReturnValue().Set(Line::Constructor()->NewInstance(1, &ext));
-}
-
-void Shape::addLine(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 1 || !args[0]->IsObject() ||
-      !args[0]->ToObject()->GetConstructorName()->Equals(String::New("lineObj"))) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
-  shapeObj *shape = s->get();
-
-  Line* l = ObjectWrap::Unwrap<Line>(args[0]->ToObject());
-  lineObj *line = l->get();
-
-  msAddLine(shape, line);
-}
-
-void Shape::setGeometry(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
-  HandleScope scope;
-
-  if (args.Length() < 1 || !args[0]->IsObject() ||
-      !args[0]->ToObject()->GetConstructorName()->Equals(String::New("shapeObj"))) {
-    ThrowException(String::New("Invalid argument"));
-    return;
-  }
-
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
-  shapeObj *shape = s->get();
-  Shape* ns = ObjectWrap::Unwrap<Shape>(args[0]->ToObject());
-  shapeObj *new_shape = ns->get();
-
-  /* clean current shape */
-  for (int i = 0; i < shape->numlines; i++) {
-    free(shape->line[i].point);
-  }
-  if (shape->line) free(shape->line);
-  shape->line = NULL;
-  shape->numlines = 0;
-
-  for (int i = 0; i < new_shape->numlines; i++) {
-    msAddLine(shape, &(new_shape->line[i]));
-  }
-
-  return;
-}
-
-void Shape::attributeWeakCallback(v8::Isolate* isolate,
-                           v8::Persistent<v8::Object>* pobj,
-                           map<string, int> *map) {
-    v8::HandleScope scope(isolate);
-    pobj->Dispose();
-    pobj->Clear();
-    delete map;
-}
-
-void Shape::attributeGetValue(Local<String> name,
-                              const PropertyCallbackInfo<Value> &info)
-{
-  Local<Object> self = info.Holder();
-  Local<External> wrap = Local<External>::Cast(self->GetInternalField(0));
-  void *ptr = wrap->Value();
-  map<string, int> *indexes = static_cast<map<string, int> *>(ptr);
-  wrap = Local<External>::Cast(self->GetInternalField(1));
-  ptr = wrap->Value();
-  char **values = static_cast<char **>(ptr);
-
-  String::Utf8Value utf8_value(name);
-  string key = string(*utf8_value);
-  map<string, int>::iterator iter = indexes->find(key);
-
-  if (iter != indexes->end()) {
-    const int &index = (*iter).second;
-    info.GetReturnValue().Set(String::New(values[index]));
-  }
-}
-
-void Shape::attributeSetValue(Local<String> name,
-                              Local<Value> value,
-                              const PropertyCallbackInfo<Value> &info)
-{
-  Local<Object> self = info.Holder();
-  Local<External> wrap = Local<External>::Cast(self->GetInternalField(0));
-  void *ptr = wrap->Value();
-  map<string, int> *indexes = static_cast<map<string, int> *>(ptr);
-  wrap = Local<External>::Cast(self->GetInternalField(1));
-  ptr = wrap->Value();
-  char **values = static_cast<char **>(ptr);
-
-  String::Utf8Value utf8_name(name), utf8_value(value);
-  string key = string(*utf8_name);
-
-  map<string, int>::iterator iter = indexes->find(key);
-
-  if (iter == indexes->end()) {
-    ThrowException(String::New("Invalid value name."));
-  }
-  else
-  {
-    const int &index = (*iter).second;
-    msFree(values[index]);
-    values[index] = msStrdup(*utf8_value);
-  }
-}
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/shape.hpp 8.2.0~beta1-1~exp1/mapscript/v8/shape.hpp
--- 8.0.1-5/mapscript/v8/shape.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/shape.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,85 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#ifndef SHAPE_H_
-#define SHAPE_H_
-
-#include <v8.h>
-#include <map>
-#include <string>
-
-using namespace v8;
-using std::map;
-using std::string;
-
-class Shape: public ObjectWrap
-{
-public:
-  static void Initialize(Handle<Object> target);
-  static void New(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void Dispose();
-  static Handle<Function> Constructor();
-
-  Shape(shapeObj *p);
-  ~Shape();  
-  inline shapeObj* get() { return this_; }
-  inline void disableMemoryHandler() { this->freeInternal = false; }
-  
-  inline void setLayer(layerObj *layer) { this->layer = layer; };
-  
-  static void getProp(Local<String> property,
-                      const PropertyCallbackInfo<Value>& info);
-  static void setProp(Local<String> property,
-                      Local<Value> value,
-                      const PropertyCallbackInfo<void>& info);
-
-  static void clone(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void getLine(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void addLine(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void setGeometry(const v8::FunctionCallbackInfo<v8::Value>& args);
-
-  /* This could be generic in the future.. */
-  static void attributeWeakCallback(v8::Isolate* isolate,
-                                    v8::Persistent<v8::Object>* pobj,
-                                    map<string, int> *map);
-  static void attributeGetValue(Local<String> name,
-                                const PropertyCallbackInfo<Value> &info);
-  static void attributeSetValue(Local<String> name,
-                                Local<Value> value,
-                                const PropertyCallbackInfo<Value> &info);
-  static void attributeMapDestroy(Isolate *isolate,
-                                  Persistent<Object> *object,
-                                  map<string, int> *map);  
-private:
-  static Persistent<FunctionTemplate> constructor;
-  bool freeInternal;
-  layerObj *layer; /* for attributes names */
-  shapeObj *this_;
-};
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/v8_mapscript.cpp 8.2.0~beta1-1~exp1/mapscript/v8/v8_mapscript.cpp
--- 8.0.1-5/mapscript/v8/v8_mapscript.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/v8_mapscript.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include "mapserver-config.h"
-#ifdef USE_V8_MAPSCRIPT
-
-#include "mapserver.h"
-#include "v8_mapscript.h"
-
-char* getStringValue(Local<Value> value, const char *fallback)
-{
-  if (value->IsString()) {
-    String::AsciiValue string(value);
-    char *str = (char *) malloc(string.length() + 1);
-    strcpy(str, *string);
-    return str;
-  }
-  char *str = (char *) malloc(strlen(fallback) + 1);
-  strcpy(str, fallback);
-  return str;
-}
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/v8_mapscript.h 8.2.0~beta1-1~exp1/mapscript/v8/v8_mapscript.h
--- 8.0.1-5/mapscript/v8/v8_mapscript.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/v8_mapscript.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,108 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#ifndef V8_MAPSCRIPT_H
-#define V8_MAPSCRIPT_H
-
-#include "mapserver-config.h"
-#ifdef USE_V8_MAPSCRIPT
-
-/* This need should be removed in future v8 version */
-#define V8_ALLOW_ACCESS_TO_RAW_HANDLE_CONSTRUCTOR 1
-#define V8_USE_UNSAFE_HANDLES 1
-
-#include "mapserver.h"
-#include <v8.h>
-#include <string>
-#include <stack>
-#include <map>
-#include "v8_object_wrap.hpp"
-#include "point.hpp"
-#include "line.hpp"
-#include "shape.hpp"
-
-using namespace v8;
-
-using std::string;
-using std::stack;
-using std::map;
-
-class V8Context
-{
-public:
-  V8Context(Isolate *isolate)
-    : isolate(isolate) {}
-  Isolate *isolate;
-  stack<string> paths; /* for relative paths and the require function */
-  map<string, Persistent<Script> > scripts;
-  Persistent<Context> context;
-  layerObj *layer; /* current layer, used in geomtransform */
-};
-
-#define V8CONTEXT(map) ((V8Context*) (map)->v8context)
-
-inline void NODE_SET_PROTOTYPE_METHOD(v8::Handle<v8::FunctionTemplate> recv,
-                                      const char* name,
-                                      v8::FunctionCallback callback) {
-  v8::Isolate* isolate = v8::Isolate::GetCurrent();
-  v8::HandleScope handle_scope(isolate);
-  v8::Local<v8::FunctionTemplate> t = v8::FunctionTemplate::New(callback);
-  recv->InstanceTemplate()->Set(v8::String::NewFromUtf8(isolate, name),
-                                t->GetFunction());
-}
-#define NODE_SET_PROTOTYPE_METHOD NODE_SET_PROTOTYPE_METHOD
-
-#define TOSTR(obj) (*String::Utf8Value((obj)->ToString()))
-
-#define SET(target, name, value)                 \
-  (target)->PrototypeTemplate()->Set(String::NewSymbol(name), value);
-
-#define SET_ATTRIBUTE(t, name, get, set)   \
-  t->InstanceTemplate()->SetAccessor(String::NewSymbol(name), get, set)
-
-#define SET_ATTRIBUTE_RO(t, name, get)             \
-  t->InstanceTemplate()->SetAccessor(              \
-        String::NewSymbol(name),                   \
-        get, 0,                                    \
-        Handle<Value>(),                           \
-        DEFAULT,                                   \
-        static_cast<PropertyAttribute>(            \
-          ReadOnly|DontDelete))
-
-#define NODE_DEFINE_CONSTANT(target, name, constant)     \
-    (target)->Set(String::NewSymbol(name),               \
-                  Integer::New(constant),                \
-                  static_cast<PropertyAttribute>(        \
-                  ReadOnly|DontDelete));
-
-char* getStringValue(Local<Value> value, const char *fallback="");
-
-
-#endif
-
-#endif
diff -pruN 8.0.1-5/mapscript/v8/v8_object_wrap.hpp 8.2.0~beta1-1~exp1/mapscript/v8/v8_object_wrap.hpp
--- 8.0.1-5/mapscript/v8/v8_object_wrap.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapscript/v8/v8_object_wrap.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,129 +0,0 @@
-// Copyright Joyent, Inc. and other Node contributors.
-//
-// Permission is hereby granted, free of charge, to any person obtaining a
-// copy of this software and associated documentation files (the
-// "Software"), to deal in the Software without restriction, including
-// without limitation the rights to use, copy, modify, merge, publish,
-// distribute, sublicense, and/or sell copies of the Software, and to permit
-// persons to whom the Software is furnished to do so, subject to the
-// following conditions:
-//
-// The above copyright notice and this permission notice shall be included
-// in all copies or substantial portions of the Software.
-//
-// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
-// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
-// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
-// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
-// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
-// USE OR OTHER DEALINGS IN THE SOFTWARE.
-
-#ifndef V8_OBJECT_WRAP_H_
-#define V8_OBJECT_WRAP_H_
-
-#include "v8.h"
-#include <assert.h>
-
-class ObjectWrap {
- public:
-  ObjectWrap() {
-    refs_ = 0;
-  }
-
-  virtual ~ObjectWrap() {
-    if (persistent().IsEmpty())
-      return;
-    assert(persistent().IsNearDeath());
-    persistent().ClearWeak();
-    persistent().Dispose();
-  }
-
-
-  template <class T>
-  static inline T* Unwrap(v8::Handle<v8::Object> handle) {
-    assert(!handle.IsEmpty());
-    assert(handle->InternalFieldCount() > 0);
-    // Cast to ObjectWrap before casting to T.  A direct cast from void
-    // to T won't work right when T has more than one base class.
-    void* ptr = handle->GetAlignedPointerFromInternalField(0);
-    ObjectWrap* wrap = static_cast<ObjectWrap*>(ptr);
-    return static_cast<T*>(wrap);
-  }
-
-
-  inline v8::Local<v8::Object> handle() {
-    return handle(v8::Isolate::GetCurrent());
-  }
-
-
-  inline v8::Local<v8::Object> handle(v8::Isolate* isolate) {
-    return v8::Local<v8::Object>::New(isolate, persistent());
-  }
-
-
-  inline v8::Persistent<v8::Object>& persistent() {
-    return handle_;
-  }
-
-
- protected:
-  inline void Wrap(v8::Handle<v8::Object> handle) {
-    assert(persistent().IsEmpty());
-    assert(handle->InternalFieldCount() > 0);
-    handle->SetAlignedPointerInInternalField(0, this);
-    persistent().Reset(v8::Isolate::GetCurrent(), handle);
-    MakeWeak();
-  }
-
-
-  inline void MakeWeak(void) {
-    persistent().MakeWeak(this, WeakCallback);
-    persistent().MarkIndependent();
-  }
-
-  /* Ref() marks the object as being attached to an event loop.
-   * Refed objects will not be garbage collected, even if
-   * all references are lost.
-   */
-  virtual void Ref() {
-    assert(!persistent().IsEmpty());
-    persistent().ClearWeak();
-    refs_++;
-  }
-
-  /* Unref() marks an object as detached from the event loop.  This is its
-   * default state.  When an object with a "weak" reference changes from
-   * attached to detached state it will be freed. Be careful not to access
-   * the object after making this call as it might be gone!
-   * (A "weak reference" means an object that only has a
-   * persistant handle.)
-   *
-   * DO NOT CALL THIS FROM DESTRUCTOR
-   */
-  virtual void Unref() {
-    assert(!persistent().IsEmpty());
-    assert(!persistent().IsWeak());
-    assert(refs_ > 0);
-    if (--refs_ == 0)
-      MakeWeak();
-  }
-
-  int refs_;  // ro
-
- private:
-  static void WeakCallback(v8::Isolate* isolate,
-                           v8::Persistent<v8::Object>* pobj,
-                           ObjectWrap* wrap) {
-    v8::HandleScope scope(isolate);
-    assert(wrap->refs_ == 0);
-    assert(*pobj == wrap->persistent());
-    assert((*pobj).IsNearDeath());
-    delete wrap;
-  }
-
-  v8::Persistent<v8::Object> handle_;
-};
-
-
-#endif  // v8_OBJECT_WRAP_H_
diff -pruN 8.0.1-5/mapsearch.c 8.2.0~beta1-1~exp1/mapsearch.c
--- 8.0.1-5/mapsearch.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapsearch.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,668 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Various geospatial search operations.
- * Author:   Steve Lime and the MapServer team.
- *
- * Notes: For information on point in polygon function please see:
- *
- *   http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html
- *
- * The appropriate copyright notice accompanies the funtion definition.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-#define LASTVERT(v,n)  ((v) == 0 ? n-2 : v-1)
-#define NEXTVERT(v,n)  ((v) == n-2 ? 0 : v+1)
-
-/*
-** Returns MS_TRUE if rectangles a and b overlap
-*/
-int msRectOverlap(const rectObj *a, const rectObj *b)
-{
-  if(a->minx > b->maxx) return(MS_FALSE);
-  if(a->maxx < b->minx) return(MS_FALSE);
-  if(a->miny > b->maxy) return(MS_FALSE);
-  if(a->maxy < b->miny) return(MS_FALSE);
-  return(MS_TRUE);
-}
-
-/*
-** Computes the intersection of two rectangles, updating the first
-** to be only the intersection of the two.  Returns MS_FALSE if
-** the intersection is empty.
-*/
-int msRectIntersect( rectObj *a, const rectObj *b )
-{
-  if( a->maxx > b->maxx )
-    a->maxx = b->maxx;
-  if( a->minx < b->minx )
-    a->minx = b->minx;
-  if( a->maxy > b->maxy )
-    a->maxy = b->maxy;
-  if( a->miny < b->miny )
-    a->miny = b->miny;
-
-  if( a->maxx < a->minx || b->maxx < b->minx )
-    return MS_FALSE;
-  else
-    return MS_TRUE;
-}
-
-/*
-** Returns MS_TRUE if rectangle a is contained in rectangle b
-*/
-int msRectContained(const rectObj *a, const rectObj *b)
-{
-  if(a->minx >= b->minx && a->maxx <= b->maxx)
-    if(a->miny >= b->miny && a->maxy <= b->maxy)
-      return(MS_TRUE);
-  return(MS_FALSE);
-}
-
-/*
-** Merges rect b into rect a. Rect a changes, b does not.
-*/
-void msMergeRect(rectObj *a, rectObj *b)
-{
-  a->minx = MS_MIN(a->minx, b->minx);
-  a->maxx = MS_MAX(a->maxx, b->maxx);
-  a->miny = MS_MIN(a->miny, b->miny);
-  a->maxy = MS_MAX(a->maxy, b->maxy);
-}
-
-int msPointInRect(const pointObj *p, const rectObj *rect)
-{
-  if(p->x < rect->minx) return(MS_FALSE);
-  if(p->x > rect->maxx) return(MS_FALSE);
-  if(p->y < rect->miny) return(MS_FALSE);
-  if(p->y > rect->maxy) return(MS_FALSE);
-  return(MS_TRUE);
-}
-
-int msPolygonDirection(lineObj *c)
-{
-  double mx, my, area;
-  int i, v=0, lv, nv;
-
-  /* first find lowest, rightmost point of polygon */
-  mx = c->point[0].x;
-  my = c->point[0].y;
-
-  for(i=0; i<c->numpoints-1; i++) {
-    if((c->point[i].y < my) || ((c->point[i].y == my) && (c->point[i].x > mx))) {
-      v = i;
-      mx = c->point[i].x;
-      my = c->point[i].y;
-    }
-  }
-
-  lv = LASTVERT(v,c->numpoints);
-  nv = NEXTVERT(v,c->numpoints);
-
-  area = c->point[lv].x*c->point[v].y - c->point[lv].y*c->point[v].x + c->point[lv].y*c->point[nv].x - c->point[lv].x*c->point[nv].y + c->point[v].x*c->point[nv].y - c->point[nv].x*c->point[v].y;
-  if(area > 0)
-    return(1); /* counter clockwise orientation */
-  else if(area < 0) /* clockwise orientation */
-    return(-1);
-  else
-    return(0); /* shouldn't happen unless the polygon is self intersecting */
-}
-
-/*
-** Copyright (c) 1970-2003, Wm. Randolph Franklin
-**
-** Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
-** associated documentation files (the "Software"), to deal in the Software without restriction, including
-** without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-** copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
-** following conditions:
-**
-** 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the
-**    following disclaimers.
-** 2. Redistributions in binary form must reproduce the above copyright notice in the documentation and/or
-**    other materials provided with the distribution.
-** 3. The name of W. Randolph Franklin may not be used to endorse or promote products derived from this
-**    Software without specific prior written permission.
-**
-** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-** LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-** NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-** WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-** SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
-*/
-int msPointInPolygon(pointObj *p, lineObj *c)
-{
-  int i, j, status = MS_FALSE;
-
-  for (i = 0, j = c->numpoints-1; i < c->numpoints; j = i++) {
-    if ((((c->point[i].y<=p->y) && (p->y<c->point[j].y)) || ((c->point[j].y<=p->y) && (p->y<c->point[i].y))) && (p->x < (c->point[j].x - c->point[i].x) * (p->y - c->point[i].y) / (c->point[j].y - c->point[i].y) + c->point[i].x))
-      status = !status;
-  }
-  return status;
-}
-
-/*
-** Note: the following functions are brute force implementations. Some fancy
-** computational geometry algorithms would speed things up nicely in many
-** cases. In due time... -SDL-
-*/
-
-int msIntersectSegments(const pointObj *a, const pointObj *b, const pointObj *c, const pointObj *d)   /* from comp.graphics.alogorithms FAQ */
-{
-
-  double r, s;
-  double denominator, numerator;
-
-  numerator = ((a->y-c->y)*(d->x-c->x) - (a->x-c->x)*(d->y-c->y));
-  denominator = ((b->x-a->x)*(d->y-c->y) - (b->y-a->y)*(d->x-c->x));
-
-  if((denominator == 0) && (numerator == 0)) { /* lines are coincident, intersection is a line segement if it exists */
-    if(a->y == c->y) { /* coincident horizontally, check x's */
-      if(((a->x >= MS_MIN(c->x,d->x)) && (a->x <= MS_MAX(c->x,d->x))) || ((b->x >= MS_MIN(c->x,d->x)) && (b->x <= MS_MAX(c->x,d->x))))
-        return(MS_TRUE);
-      else
-        return(MS_FALSE);
-    } else { /* test for y's will work fine for remaining cases */
-      if(((a->y >= MS_MIN(c->y,d->y)) && (a->y <= MS_MAX(c->y,d->y))) || ((b->y >= MS_MIN(c->y,d->y)) && (b->y <= MS_MAX(c->y,d->y))))
-        return(MS_TRUE);
-      else
-        return(MS_FALSE);
-    }
-  }
-
-  if(denominator == 0) /* lines are parallel, can't intersect */
-    return(MS_FALSE);
-
-  r = numerator/denominator;
-
-  if((r<0) || (r>1))
-    return(MS_FALSE); /* no intersection */
-
-  numerator = ((a->y-c->y)*(b->x-a->x) - (a->x-c->x)*(b->y-a->y));
-  s = numerator/denominator;
-
-  if((s<0) || (s>1))
-    return(MS_FALSE); /* no intersection */
-
-  return(MS_TRUE);
-}
-
-/*
-** Instead of using ring orientation we count the number of parts the
-** point falls in. If odd the point is in the polygon, if 0 or even
-** then the point is in a hole or completely outside.
-*/
-int msIntersectPointPolygon(pointObj *point, shapeObj *poly)
-{
-  int i;
-  int status=MS_FALSE;
-
-  for(i=0; i<poly->numlines; i++) {
-    if(msPointInPolygon(point, &poly->line[i]) == MS_TRUE) /* ok, the point is in a line */
-      status = !status;
-  }
-
-  return(status);
-}
-
-int msIntersectMultipointPolygon(shapeObj *multipoint, shapeObj *poly)
-{
-  int i,j;
-
-  /* The change to loop through all the lines has been made for ticket
-   * #2443 but is no more needed since ticket #2762. PostGIS now put all
-   * points into a single line.  */
-  for(i=0; i<multipoint->numlines; i++ ) {
-    lineObj points = multipoint->line[i];
-    for(j=0; j<points.numpoints; j++) {
-      if(msIntersectPointPolygon(&(points.point[j]), poly) == MS_TRUE)
-        return(MS_TRUE);
-    }
-  }
-
-  return(MS_FALSE);
-}
-
-int msIntersectPolylines(shapeObj *line1, shapeObj *line2)
-{
-  int c1,v1,c2,v2;
-
-  for(c1=0; c1<line1->numlines; c1++)
-    for(v1=1; v1<line1->line[c1].numpoints; v1++)
-      for(c2=0; c2<line2->numlines; c2++)
-        for(v2=1; v2<line2->line[c2].numpoints; v2++)
-          if(msIntersectSegments(&(line1->line[c1].point[v1-1]), &(line1->line[c1].point[v1]),
-                                 &(line2->line[c2].point[v2-1]), &(line2->line[c2].point[v2])) ==  MS_TRUE)
-            return(MS_TRUE);
-
-  return(MS_FALSE);
-}
-
-int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly)
-{
-  int i;
-
-  /* STEP 1: polygon might competely contain the polyline or one of it's parts (only need to check one point from each part) */
-  for(i=0; i<line->numlines; i++) {
-    if(msIntersectPointPolygon(&(line->line[i].point[0]), poly) == MS_TRUE) /* this considers holes and multiple parts */
-      return(MS_TRUE);
-  }
-
-  /* STEP 2: look for intersecting line segments */
-  if (msIntersectPolylines(line, poly) == MS_TRUE)
-    return (MS_TRUE);
-
-  return(MS_FALSE);
-}
-
-int msIntersectPolygons(shapeObj *p1, shapeObj *p2)
-{
-  int i;
-
-  /* STEP 1: polygon 1 completely contains 2 (only need to check one point from each part) */
-  for(i=0; i<p2->numlines; i++) {
-    if(msIntersectPointPolygon(&(p2->line[i].point[0]), p1) == MS_TRUE) /* this considers holes and multiple parts */
-      return(MS_TRUE);
-  }
-
-  /* STEP 2: polygon 2 completely contains 1 (only need to check one point from each part) */
-  for(i=0; i<p1->numlines; i++) {
-    if(msIntersectPointPolygon(&(p1->line[i].point[0]), p2) == MS_TRUE) /* this considers holes and multiple parts */
-      return(MS_TRUE);
-  }
-
-  /* STEP 3: look for intersecting line segments */
-  if (msIntersectPolylines(p1, p2) == MS_TRUE)
-    return(MS_TRUE);
-
-  /*
-  ** At this point we know there are are no intersections between edges. There may be other tests necessary
-  ** but I haven't run into any cases that require them.
-  */
-
-  return(MS_FALSE);
-}
-
-
-/*
-** Distance computations
-*/
-
-double msDistancePointToPoint(pointObj *a, pointObj *b)
-{
-  double d;
-
-  d = sqrt(msSquareDistancePointToPoint(a, b));
-
-  return(d);
-}
-
-/*
-** Quickly compute the square of the distance; avoids expensive sqrt() call on each invocation
-*/
-double msSquareDistancePointToPoint(pointObj *a, pointObj *b)
-{
-  double dx, dy;
-
-  dx = a->x - b->x;
-  dy = a->y - b->y;
-
-  return(dx*dx + dy*dy);
-}
-
-double msDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b)
-{
-  return (sqrt(msSquareDistancePointToSegment(p, a, b)));
-}
-
-double msSquareDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b)
-{
-  double l_squared; /* squared length of line ab */
-  double r,s;
-
-  l_squared = msSquareDistancePointToPoint(a,b);
-
-  if(l_squared == 0.0) /* a = b */
-    return(msSquareDistancePointToPoint(a,p));
-
-  r = ((a->y - p->y)*(a->y - b->y) - (a->x - p->x)*(b->x - a->x))/(l_squared);
-
-  if(r > 1) /* perpendicular projection of P is on the forward extention of AB */
-    return(MS_MIN(msSquareDistancePointToPoint(p, b),msSquareDistancePointToPoint(p, a)));
-  if(r < 0) /* perpendicular projection of P is on the backward extention of AB */
-    return(MS_MIN(msSquareDistancePointToPoint(p, b),msSquareDistancePointToPoint(p, a)));
-
-  s = ((a->y - p->y)*(b->x - a->x) - (a->x - p->x)*(b->y - a->y))/l_squared;
-
-  return(fabs(s*s*l_squared));
-}
-
-#define SMALL_NUMBER 0.00000001
-#define dot(u,v) ((u).x *(v).x + (u).y *(v).y) /* vector dot product */
-#define norm(v) sqrt(dot(v,v))
-
-#define slope(a,b) (((a)->y - (b)->y)/((a)->x - (b)->x))
-
-/* Segment to segment distance code is a modified version of that found at:  */
-/*  */
-/* http://www.geometryalgorithms.com/Archive/algorithm_0106/algorithm_0106.htm */
-/*  */
-/* Copyright 2001, softSurfer (www.softsurfer.com) */
-/* This code may be freely used and modified for any purpose */
-/* providing that this copyright notice is included with it. */
-/* SoftSurfer makes no warranty for this code, and cannot be held */
-/* liable for any real or imagined damage resulting from its use. */
-/* Users of this code must verify correctness for their application. */
-
-double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb, pointObj *pc, pointObj *pd)
-{
-  vectorObj u, v, w;
-
-  /* check for strictly parallel segments first */
-  /* if(((pa->x == pb->x) && (pc->x == pd->x)) || (slope(pa,pb) == slope(pc,pd))) { // vertical (infinite slope) || otherwise parallel */
-  /* D = msDistancePointToSegment(pa, pc, pd); */
-  /* D = MS_MIN(D, msDistancePointToSegment(pb, pc, pd)); */
-  /* D = MS_MIN(D, msDistancePointToSegment(pc, pa, pb)); */
-  /* return(MS_MIN(D, msDistancePointToSegment(pd, pa, pb))); */
-  /* } */
-
-  u.x = pb->x - pa->x; /* u = pb - pa */
-  u.y = pb->y - pa->y;
-  v.x = pd->x - pc->x; /* v = pd - pc  */
-  v.y = pd->y - pc->y;
-  w.x = pa->x - pc->x; /* w = pa - pc */
-  w.y = pa->y - pc->y;
-
-  const double a = dot(u,u);
-  const double b = dot(u,v);
-  const double c = dot(v,v);
-  const double d = dot(u,w);
-  const double e = dot(v,w);
-
-  const double D = a*c - b*b;
-  /* N=numerator, D=demoninator */
-  double sN = 0;
-  double sD = D;
-  double tD = D;
-  double tN = D;
-
-  /* compute the line parameters of the two closest points */
-  if(D < SMALL_NUMBER) { /* lines are parallel or almost parallel */
-    sD = 1.0;
-    tN = e;
-    tD = c;
-  } else { /* get the closest points on the infinite lines */
-    sN = b*e - c*d;
-    tN = a*e - b*d;
-    if(sN < 0) {
-      sN = 0.0;
-      tN = e;
-      tD = c;
-    } else if(sN > sD) {
-      sN = sD;
-      tN = e + b;
-      tD = c;
-    }
-  }
-
-  if(tN < 0) {
-    tN = 0.0;
-    if(-d < 0) {
-      /* sN = 0.0 */
-    }
-    else if(-d > a)
-      sN = sD;
-    else {
-      sN = -d;
-      sD = a;
-    }
-  } else if(tN > tD) {
-    tN = tD;
-    if((-d + b) < 0) {
-      /* sN = 0.0 */
-    }
-    else if((-d + b) > a)
-      sN = sD;
-    else {
-      sN = (-d + b);
-      sD = a;
-    }
-  }
-
-  /* finally do the division to get sc and tc */
-  const double sc = sN/sD;
-  const double tc = tN/tD;
-
-  vectorObj dP;
-  dP.x = w.x + (sc*u.x) - (tc*v.x);
-  dP.y = w.y + (sc*u.y) - (tc*v.y);
-
-  return(norm(dP));
-}
-
-double msDistancePointToShape(pointObj *point, shapeObj *shape)
-{
-  double d;
-
-  d = msSquareDistancePointToShape(point, shape);
-
-  return(sqrt(d));
-}
-
-/*
-** As msDistancePointToShape; avoid expensive sqrt calls
-*/
-double msSquareDistancePointToShape(pointObj *point, shapeObj *shape)
-{
-  int i, j;
-  double dist, minDist=-1;
-
-  switch(shape->type) {
-    case(MS_SHAPE_POINT):
-      for(j=0; j<shape->numlines; j++) {
-        for(i=0; i<shape->line[j].numpoints; i++) {
-          dist = msSquareDistancePointToPoint(point, &(shape->line[j].point[i]));
-          if((dist < minDist) || (minDist < 0)) minDist = dist;
-        }
-      }
-      break;
-    case(MS_SHAPE_LINE):
-      for(j=0; j<shape->numlines; j++) {
-        for(i=1; i<shape->line[j].numpoints; i++) {
-          dist = msSquareDistancePointToSegment(point, &(shape->line[j].point[i-1]), &(shape->line[j].point[i]));
-          if((dist < minDist) || (minDist < 0)) minDist = dist;
-        }
-      }
-      break;
-    case(MS_SHAPE_POLYGON):
-      if(msIntersectPointPolygon(point, shape))
-        minDist = 0; /* point is IN the shape */
-      else { /* treat shape just like a line */
-        for(j=0; j<shape->numlines; j++) {
-          for(i=1; i<shape->line[j].numpoints; i++) {
-            dist = msSquareDistancePointToSegment(point, &(shape->line[j].point[i-1]), &(shape->line[j].point[i]));
-            if((dist < minDist) || (minDist < 0)) minDist = dist;
-          }
-        }
-      }
-      break;
-    default:
-      break;
-  }
-
-  return(minDist);
-}
-
-double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2)
-{
-  int i,j,k,l;
-  double dist, minDist=-1;
-
-  switch(shape1->type) {
-    case(MS_SHAPE_POINT): /* shape1 */
-      for(i=0; i<shape1->numlines; i++) {
-        for(j=0; j<shape1->line[i].numpoints; j++) {
-          dist = msSquareDistancePointToShape(&(shape1->line[i].point[j]), shape2);
-          if((dist < minDist) || (minDist < 0))
-            minDist = dist;
-        }
-      }
-      minDist = sqrt(minDist);
-      break;
-    case(MS_SHAPE_LINE): /* shape1 */
-      switch(shape2->type) {
-        case(MS_SHAPE_POINT):
-          for(i=0; i<shape2->numlines; i++) {
-            for(j=0; j<shape2->line[i].numpoints; j++) {
-              dist = msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
-              if((dist < minDist) || (minDist < 0))
-                minDist = dist;
-            }
-          }
-          minDist = sqrt(minDist);
-          break;
-        case(MS_SHAPE_LINE):
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
-            }
-          }
-          break;
-        case(MS_SHAPE_POLYGON):
-          /* shape2 (the polygon) could contain shape1 or one of it's parts       */
-          for(i=0; i<shape1->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape1->line[0].point[0]), shape2) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
-
-          /* check segment intersection and, if necessary, distance between segments */
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
-            }
-          }
-          break;
-      }
-      break;
-    case(MS_SHAPE_POLYGON): /* shape1 */
-      switch(shape2->type) {
-        case(MS_SHAPE_POINT):
-          for(i=0; i<shape2->numlines; i++) {
-            for(j=0; j<shape2->line[i].numpoints; j++) {
-              dist = msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
-              if((dist < minDist) || (minDist < 0))
-                minDist = dist;
-            }
-          }
-          minDist = sqrt(minDist);
-          break;
-        case(MS_SHAPE_LINE):
-          /* shape1 (the polygon) could contain shape2 or one of it's parts       */
-          for(i=0; i<shape2->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
-
-          /* check segment intersection and, if necessary, distance between segments */
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
-            }
-          }
-          break;
-        case(MS_SHAPE_POLYGON):
-          /* shape1 completely contains shape2 (only need to check one point from each part) */
-          for(i=0; i<shape2->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
-
-          /* shape2 completely contains shape1 (only need to check one point from each part) */
-          for(i=0; i<shape1->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape1->line[i].point[0]), shape2) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
-
-          /* check segment intersection and, if necessary, distance between segments */
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
-            }
-          }
-          break;
-      }
-      break;
-  }
-
-  return(minDist);
-}
diff -pruN 8.0.1-5/mapserv-config.cpp 8.2.0~beta1-1~exp1/mapserv-config.cpp
--- 8.0.1-5/mapserv-config.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserv-config.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,202 +0,0 @@
-/**********************************************************************
- * $id$
- *
- * Project:  MapServer
- * Purpose:  Config File Support
- * Author:   Steve Lime and the MapServer team.
- *
- **********************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota. 
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-#include "mapserver.h"
-#include "mapfile.h" // format shares a couple of tokens
-
-#include "cpl_conv.h"
-
-#include <string>
-
-extern "C" int msyylex(void);
-extern "C" void msyyrestart(FILE *);
-
-extern "C" FILE *msyyin;
-extern "C" int msyystate;
-extern "C" int msyylineno;
-extern "C" char *msyystring_buffer;
-
-static int initConfig(configObj *config)
-{
-  if (config == NULL) {
-    msSetError(MS_MEMERR, "Config object is NULL.", "initConfig()");
-    return MS_FAILURE;
-  }
-
-  if(initHashTable(&(config->env)) != MS_SUCCESS) return MS_FAILURE;
-  if(initHashTable(&(config->maps)) != MS_SUCCESS) return MS_FAILURE;
-  if(initHashTable(&(config->plugins)) != MS_SUCCESS) return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-void msFreeConfig(configObj *config)
-{
-  if(config == NULL) return;
-  if(&(config->env)) msFreeHashItems(&(config->env));
-  if(&(config->maps)) msFreeHashItems(&(config->maps));
-  if(&(config->plugins)) msFreeHashItems(&(config->plugins));
-
-  msFree(config);
-}
-
-static int loadConfig(configObj *config)
-{
-  int token;
-
-  if(config == NULL) return MS_FAILURE;
-
-  token = msyylex();
-  if(token != MS_CONFIG_SECTION) {
-    msSetError(MS_IDENTERR, "First token must be CONFIG, this doesn't look like a mapserver config file.", "msLoadConfig()");
-    return MS_FAILURE;
-  }
-
-  for(;;) {
-    switch(msyylex()) {
-    case(MS_CONFIG_SECTION_ENV): {
-      if(loadHashTable(&(config->env)) != MS_SUCCESS) return MS_FAILURE;
-      break;
-    }
-    case(MS_CONFIG_SECTION_MAPS):
-      if(loadHashTable(&config->maps) != MS_SUCCESS) return MS_FAILURE;
-      break;
-    case(MS_CONFIG_SECTION_PLUGINS):
-      if(loadHashTable(&config->plugins) != MS_SUCCESS) return MS_FAILURE;
-      break;
-    case(EOF):
-      msSetError(MS_EOFERR, NULL, "msLoadConfig()");
-      return MS_FAILURE;
-    case(END):
-      if(msyyin) {
-	fclose(msyyin);
-	msyyin = NULL;
-      }
-      return MS_SUCCESS;
-      break;
-    default:
-      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "msLoadConfig()", msyystring_buffer, msyylineno);
-      return MS_FAILURE;
-    }
-  }
-}
-
-static void msConfigSetConfigOption(const char* key, const char* value)
-{
-  CPLSetConfigOption(key, value);
-  if( strcasecmp(key,"PROJ_DATA") == 0 ||
-      strcasecmp(key,"PROJ_LIB") == 0 ) {
-    msSetPROJ_DATA( value, nullptr );
-  }
-}
-
-configObj *msLoadConfig(const char* ms_config_file)
-{
-  configObj *config = NULL;
-
-  if (ms_config_file == NULL) {
-    // get config filename from environment
-    ms_config_file = getenv("MAPSERVER_CONFIG_FILE");
-  }
-
-  if(ms_config_file == NULL && MAPSERVER_CONFIG_FILE[0] != '\0') {
-    // Fallback to hardcoded file name
-    ms_config_file = MAPSERVER_CONFIG_FILE;
-  }
-
-  if(ms_config_file == NULL) {
-    msSetError(MS_MISCERR, "No config file set.", "msLoadConfig()");
-    return NULL;
-  }
-
-  config = (configObj *)calloc(sizeof(configObj), 1);
-  MS_CHECK_ALLOC(config, sizeof(configObj), NULL);
-
-  if(initConfig(config) != MS_SUCCESS) {
-    msFreeConfig(config);
-    return NULL;
-  }
-
-  msAcquireLock(TLOCK_PARSER);
-
-  if((msyyin = fopen(ms_config_file, "r")) == NULL) {    
-    msDebug("Cannot open configuration file %s.\n", ms_config_file);
-    msSetError(MS_IOERR, "See mapserver.org/mapfile/config.html for more information.", "msLoadConfig()");
-    msReleaseLock(TLOCK_PARSER);
-    msFreeConfig(config);
-    return NULL;
-  }
-
-  msyystate = MS_TOKENIZE_CONFIG;
-  msyylex(); // sets things up, but doesn't process any tokens
-
-  msyyrestart(msyyin); // start at line 1
-  msyylineno = 1;
-
-  if(loadConfig(config) != MS_SUCCESS) {
-    msFreeConfig(config);
-    msReleaseLock(TLOCK_PARSER);
-    if(msyyin) {
-      fclose(msyyin);
-      msyyin = NULL;
-    }
-    return NULL;
-  }
-  msReleaseLock(TLOCK_PARSER);
-
-  // load all env key/values using CPLSetConfigOption() - only do this *after* we have a good config
-  const char *key = msFirstKeyFromHashTable(&config->env);
-  if(key != NULL) {
-    msConfigSetConfigOption(key, msLookupHashTable(&config->env, key));
-
-    const char *last_key = key;
-    while((key = msNextKeyFromHashTable(&config->env, last_key)) != NULL) {
-      msConfigSetConfigOption(key, msLookupHashTable(&config->env, key));
-      last_key = key;
-    }
-  }
-
-  return config;  
-}
-
-const char *msConfigGetEnv(const configObj *config, const char *key) 
-{
-  if(config == NULL || key == NULL) return NULL;
-  return msLookupHashTable(&config->env, key);
-}
-
-const char *msConfigGetMap(const configObj *config, const char *key)
-{
-  if(config == NULL || key == NULL) return NULL;
-  return msLookupHashTable(&config->maps, key);
-}
-
-const char *msConfigGetPlugin(const configObj *config, const char *key)
-{
-  if(config == NULL || key == NULL) return NULL;
-  return msLookupHashTable(&config->plugins, key);
-}
diff -pruN 8.0.1-5/mapserv-config.h 8.2.0~beta1-1~exp1/mapserv-config.h
--- 8.0.1-5/mapserv-config.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserv-config.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-#ifndef MAPSERV_CONFIG_H
-#define MAPSERV_CONFIG_H
-
-#include "maphash.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-enum MS_CONFIG_SECTIONS { MS_CONFIG_SECTION=3000, MS_CONFIG_SECTION_ENV, MS_CONFIG_SECTION_MAPS, MS_CONFIG_SECTION_PLUGINS };
-
-/**
-The :ref:`CONFIG <config>` object
-*/
-typedef struct {
-  hashTableObj env; ///< Key-value pairs of environment variables and values
-  hashTableObj maps; ///< Key-value pairs of Mapfile names and paths
-  hashTableObj plugins; ///< Key-value pairs of plugin names and paths
-} configObj;
-
-MS_DLL_EXPORT configObj *msLoadConfig(const char* ms_config_file);
-MS_DLL_EXPORT void msFreeConfig(configObj *config);
-MS_DLL_EXPORT const char *msConfigGetEnv(const configObj *config, const char *key);
-MS_DLL_EXPORT const char *msConfigGetMap(const configObj *config, const char *key);
-MS_DLL_EXPORT const char *msConfigGetPlugin(const configObj *config, const char *key);
-
-#ifdef __cplusplus
-} /* extern C */
-#endif
-
-#endif 
diff -pruN 8.0.1-5/mapserv.c 8.2.0~beta1-1~exp1/mapserv.c
--- 8.0.1-5/mapserv.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserv.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,323 +0,0 @@
-/******************************************************************************
- * $id: mapserv.c 9470 2009-10-16 16:09:31Z sdlime $
- *
- * Project:  MapServer
- * Purpose:  MapServer CGI mainline.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef _XOPEN_SOURCE
-#define _XOPEN_SOURCE 500 // for putenv
-#endif
-
-#include "mapserver-config.h"
-#include <stdbool.h>
-#include <stdlib.h>
-
-#ifdef USE_FASTCGI
-#define NO_FCGI_DEFINES
-#include "fcgi_stdio.h"
-#endif
-
-#include "mapserv.h"
-#include "mapio.h"
-#include "maptime.h"
-
-#include "cpl_conv.h"
-
-#ifndef _WIN32
-#include <signal.h>
-#endif
-
-
-/************************************************************************/
-/*                      FastCGI cleanup functions.                      */
-/************************************************************************/
-
-static int finish_process = 0;
-
-#ifndef _WIN32
-static void msCleanupOnSignal( int nInData )
-{
-  (void)nInData;
-  finish_process = 1;
-}
-#endif
-
-#ifdef _WIN32
-static void msCleanupOnExit( void )
-{
-  finish_process = 1;
-}
-#endif
-
-#ifdef USE_FASTCGI
-
-/************************************************************************/
-/*                           msIO_fcgiRead()                            */
-/*                                                                      */
-/*      This is the default implementation via stdio.                   */
-/************************************************************************/
-
-static int msIO_fcgiRead( void *cbData, void *data, int byteCount )
-
-{
-  return (int) FCGI_fread( data, 1, byteCount, (FCGI_FILE *) cbData );
-}
-
-/************************************************************************/
-/*                           msIO_fcgiWrite()                           */
-/*                                                                      */
-/*      This is the default implementation via stdio.                   */
-/************************************************************************/
-
-static int msIO_fcgiWrite( void *cbData, void *data, int byteCount )
-
-{
-  return (int) FCGI_fwrite( data, 1, byteCount, (FCGI_FILE *) cbData );
-}
-
-/************************************************************************/
-/*                    msIO_installFastCGIRedirect()                     */
-/************************************************************************/
-static int msIO_installFastCGIRedirect()
-
-{
-  msIOContext stdin_ctx, stdout_ctx, stderr_ctx;
-
-  stdin_ctx.label = "fcgi";
-  stdin_ctx.write_channel = MS_FALSE;
-  stdin_ctx.readWriteFunc = msIO_fcgiRead;
-  stdin_ctx.cbData = (void *) FCGI_stdin;
-
-  stdout_ctx.label = "fcgi";
-  stdout_ctx.write_channel = MS_TRUE;
-  stdout_ctx.readWriteFunc = msIO_fcgiWrite;
-  stdout_ctx.cbData = (void *) FCGI_stdout;
-
-  stderr_ctx.label = "fcgi";
-  stderr_ctx.write_channel = MS_TRUE;
-  stderr_ctx.readWriteFunc = msIO_fcgiWrite;
-  stderr_ctx.cbData = (void *) FCGI_stderr;
-
-  msIO_installHandlers( &stdin_ctx, &stdout_ctx, &stderr_ctx );
-
-  return MS_TRUE;
-}
-
-#endif
-/************************************************************************/
-/*                                main()                                */
-/************************************************************************/
-int main(int argc, char *argv[])
-{
-  int sendheaders = MS_TRUE;
-  struct mstimeval execstarttime, execendtime;
-  struct mstimeval requeststarttime, requestendtime;
-  mapservObj  *mapserv = NULL;
-  configObj *config = NULL;
-
-  /* 
-  ** Process -v and -h command line arguments  first end exit. We want to avoid any error messages 
-  ** associated with msLoadConfig() or msSetup().
-  */
-  const char* config_filename = NULL;
-  const bool use_command_line_options = getenv("QUERY_STRING") == NULL;
-  if (use_command_line_options) {
-    /* WARNING:
-     * Do not parse command line arguments (especially those that could have
-     * dangerous consequences if controlled through a web request), without checking
-     * that the QUERY_STRING environment variable is *not* set, because in a
-     * CGI context, command line arguments can be generated from the content
-     * of the QUERY_STRING, and thus cause a security problem.
-     * For ex, "http://example.com/mapserv.cgi?-conf+bar
-     * would result in "mapserv.cgi -conf bar" being invoked.
-     * See https://github.com/MapServer/MapServer/pull/6429#issuecomment-952533589
-     * and https://datatracker.ietf.org/doc/html/rfc3875#section-4.4
-    */
-    for( int iArg = 1; iArg < argc; iArg++ ) {
-      if( strcmp(argv[iArg],"-v") == 0 ) {
-        printf("%s\n", msGetVersion());
-        fflush(stdout);
-        exit(0);
-      } else if (strcmp(argv[iArg], "-h") == 0 || strcmp(argv[iArg], "--help") == 0) {
-        printf("Usage: mapserv [--help] [-v] [-nh] [QUERY_STRING=value] [PATH_INFO=value]\n");
-        printf("                [-conf filename]\n");
-        printf("\n");
-        printf("Options :\n");
-        printf("  -h, --help              Display this help message.\n");
-        printf("  -v                      Display version and exit.\n");
-        printf("  -nh                     Suppress HTTP headers in CGI mode.\n");
-        printf("  -conf filename          Filename of the MapServer configuration file.\n");
-        printf("  QUERY_STRING=value      Set the QUERY_STRING in GET request mode.\n");
-        printf("  PATH_INFO=value         Set the PATH_INFO for an API request.\n");
-        fflush(stdout);
-        exit(0);
-      } else if( iArg < argc-1 && strcmp(argv[iArg], "-conf") == 0) {
-        config_filename = argv[iArg+1];
-        ++iArg;
-      }
-    }
-  }
-
-  config = msLoadConfig(config_filename); // first thing
-  if(config == NULL) {
-#ifdef USE_FASTCGI
-    msIO_installFastCGIRedirect(); // FastCGI setup for error handling here
-    FCGI_Accept();
-#endif
-    msCGIWriteError(mapserv);
-    exit(0);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize mapserver.  This sets up threads, GD and GEOS as     */
-  /*      well as using MS_ERRORFILE and MS_DEBUGLEVEL env vars if set.   */
-  /* -------------------------------------------------------------------- */
-  if( msSetup() != MS_SUCCESS ) {
-#ifdef USE_FASTCGI
-    msIO_installFastCGIRedirect(); // FastCGI setup for error handling here
-    FCGI_Accept();
-#endif
-    msCGIWriteError(mapserv);
-    msCleanup();
-    msFreeConfig(config);
-    exit(0);
-  }
-
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
-    msGettimeofday(&execstarttime, NULL);
-
-  /* -------------------------------------------------------------------- */
-  /*      Process arguments. In normal use as a cgi-bin there are no      */
-  /*      commandline switches, but we provide a few for test/debug       */
-  /*      purposes.                                                       */
-  /* -------------------------------------------------------------------- */
-  if(use_command_line_options) {
-    for( int iArg = 1; iArg < argc; iArg++ ) {
-      if(strcmp(argv[iArg], "-nh") == 0) {
-        sendheaders = MS_FALSE;
-        msIO_setHeaderEnabled( MS_FALSE );
-      } else if( strncmp(argv[iArg], "QUERY_STRING=", 13) == 0 ) {
-        /* Debugging hook... pass "QUERY_STRING=..." on the command-line */
-        putenv( "REQUEST_METHOD=GET" );
-        /* coverity[tainted_string] */
-        putenv( argv[iArg] );
-      } else if( strncmp(argv[iArg], "PATH_INFO=", 10) == 0 ) {
-        /* Debugging hook for APIs... pass "PATH_INFO=..." on the command-line */
-        putenv( "REQUEST_METHOD=GET" );
-        /* coverity[tainted_string] */
-        putenv( argv[iArg] );
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup cleanup magic, mainly for FastCGI case.                   */
-  /* -------------------------------------------------------------------- */
-#ifndef _WIN32
-  signal( SIGUSR1, msCleanupOnSignal );
-  signal( SIGTERM, msCleanupOnSignal );
-#endif
-
-#ifdef USE_FASTCGI
-  msIO_installFastCGIRedirect();
-
-  /* In FastCGI case we loop accepting multiple requests.  In normal CGI */
-  /* use we only accept and process one request.  */
-  while( !finish_process && FCGI_Accept() >= 0 ) {
-#endif /* def USE_FASTCGI */
-
-    /* -------------------------------------------------------------------- */
-    /*      Process a request.                                              */
-    /* -------------------------------------------------------------------- */
-    mapserv = msAllocMapServObj();
-    mapserv->sendheaders = sendheaders; /* override the default if necessary (via command line -nh switch) */
-
-    mapserv->request->NumParams = loadParams(mapserv->request, NULL, NULL, 0, NULL);
-    if(msCGIIsAPIRequest(mapserv) == MS_FALSE && mapserv->request->NumParams == -1) { /* no QUERY_STRING or PATH_INFO */
-      msCGIWriteError(mapserv);
-      goto end_request;
-    }
-
-    mapserv->map = msCGILoadMap(mapserv, config);
-    if(!mapserv->map) {
-      msCGIWriteError(mapserv);
-      goto end_request;
-    }
-
-    if( mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
-      msGettimeofday(&requeststarttime, NULL);
-
-#ifdef USE_FASTCGI
-    if( mapserv->map->debug ) {
-      static int nRequestCounter = 1;
-
-      msDebug( "CGI Request %d on process %d\n", nRequestCounter, getpid() );
-      nRequestCounter++;
-    }
-#endif
-
-    if(mapserv->request->api_path != NULL) {
-      if(msCGIDispatchAPIRequest(mapserv) != MS_SUCCESS) {
-	msCGIWriteError(mapserv);
-	goto end_request;
-      }
-    } else if(msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
-      msCGIWriteError(mapserv);
-      goto end_request;
-    }
-
-end_request:
-    if(mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
-      msGettimeofday(&requestendtime, NULL);
-      msDebug("mapserv request processing time (msLoadMap not incl.): %.3fs\n",
-              (requestendtime.tv_sec+requestendtime.tv_usec/1.0e6)-
-              (requeststarttime.tv_sec+requeststarttime.tv_usec/1.0e6) );
-    }
-    msFreeMapServObj(mapserv);
-#ifdef USE_FASTCGI
-    /* FCGI_ --- return to top of loop */
-    msResetErrorList();
-    continue;
-  } /* end fastcgi loop */
-#endif
-
-  /* normal case, processing is complete */
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&execendtime, NULL);
-    msDebug("mapserv total execution time: %.3fs\n",
-            (execendtime.tv_sec+execendtime.tv_usec/1.0e6)-
-            (execstarttime.tv_sec+execstarttime.tv_usec/1.0e6) );
-  }
-  msCleanup();
-  msFreeConfig(config);
-
-#ifdef _WIN32
-  /* flush pending writes to stdout */
-  fflush(stdout);
-#endif
-
-  exit( 0 );
-}
diff -pruN 8.0.1-5/mapserv.h 8.2.0~beta1-1~exp1/mapserv.h
--- 8.0.1-5/mapserv.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserv.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,71 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Declarations supporting mapserv.c.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPSERV_H
-#define MAPSERV_H
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#include <process.h>
-#endif
-
-#include <ctype.h>
-#include <time.h>
-
-#include "maptemplate.h"
-#include "maptile.h"
-
-#include "cgiutil.h"
-
-/*
-** Defines
-*/
-#define NUMEXP "[-]?(([0-9]+)|([0-9]*[.][0-9]+)([eE][-+]?[0-9]+)?)"
-#define EXTENT_PADDING .05
-
-/*
-** Macros
-*/
-#define TEMPLATE_TYPE(s)  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) || (strncmp("ftp://", s, 6)) == 0)  ? MS_URL : MS_FILE)
-
-MS_DLL_EXPORT void msCGIWriteError(mapservObj *mapserv);
-MS_DLL_EXPORT mapObj *msCGILoadMap(mapservObj *mapserv, configObj *context);
-int msCGISetMode(mapservObj *mapserv);
-int msCGILoadForm(mapservObj *mapserv);
-int msCGIDispatchBrowseRequest(mapservObj *mapserv);
-int msCGIDispatchCoordinateRequest(mapservObj *mapserv);
-int msCGIDispatchQueryRequest(mapservObj *mapserv);
-int msCGIDispatchImageRequest(mapservObj *mapserv);
-int msCGIDispatchLegendRequest(mapservObj *mapserv);
-int msCGIDispatchLegendIconRequest(mapservObj *mapserv);
-MS_DLL_EXPORT int msCGIDispatchRequest(mapservObj *mapserv);
-
-MS_DLL_EXPORT int msCGIIsAPIRequest(mapservObj *mapserv);
-MS_DLL_EXPORT int msCGIDispatchAPIRequest(mapservObj *mapserv);
-
-#endif /* MAPSERV_H */
diff -pruN 8.0.1-5/mapserver-api.c 8.2.0~beta1-1~exp1/mapserver-api.c
--- 8.0.1-5/mapserver-api.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserver-api.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,20 +0,0 @@
-#include "mapserver.h"
-
-
-mapObj* umnms_new_map(char *filename) {
-  mapObj *map = NULL;
-  if(filename) {  
-    map = msLoadMap(filename,NULL);
-  } else {
-    map = (mapObj *)msSmallCalloc(sizeof(mapObj),1);
-    if(initMap(map) == -1) {
-      free(map);
-      return NULL;
-    }
-  }
-  return map;
-}
-layerObj* umnms_new_layer(mapObj *map);
-classObj* umnms_new_class(layerObj *layer);
-styleObj* umnms_new_style(classObj *theclass);
-labelObj* umnms_new_label(classObj *theclass);
diff -pruN 8.0.1-5/mapserver-api.h 8.2.0~beta1-1~exp1/mapserver-api.h
--- 8.0.1-5/mapserver-api.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserver-api.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
-/* 
- * File:   mapserver-api.h
- * Author: tbonfort
- *
- * Created on March 14, 2013, 1:12 PM
- */
-
-#ifndef MAPSERVER_API_H
-#define	MAPSERVER_API_H
-
-#include "mapserver-version.h"
-
-#ifdef	__cplusplus
-extern "C" {
-#endif
-
-typedef struct mapObj mapObj;
-typedef struct layerObj layerObj;
-typedef struct classObj classObj;
-typedef struct styleObj styleObj;
-typedef struct labelObj labelObj;
-typedef struct symbolObj symbolObj;
-typedef struct imageObj imageObj;
-
-mapObj* umnms_new_map(char *filename);
-layerObj* umnms_new_layer(mapObj *map);
-classObj* umnms_new_class(layerObj *layer);
-styleObj* umnms_new_style(classObj *theclass);
-labelObj* umnms_new_label(classObj *theclass);
-
-
-
-
-#ifdef	__cplusplus
-}
-#endif
-
-#endif	/* MAPSERVER_API_H */
-
diff -pruN 8.0.1-5/mapserver-config-version.cmake.in 8.2.0~beta1-1~exp1/mapserver-config-version.cmake.in
--- 8.0.1-5/mapserver-config-version.cmake.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserver-config-version.cmake.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,11 +0,0 @@
-set(PACKAGE_VERSION "@MapServer_VERSION_STRING@")
-
-# Check whether the requested PACKAGE_FIND_VERSION is compatible
-if("${PACKAGE_VERSION}" VERSION_LESS "${PACKAGE_FIND_VERSION}")
-  set(PACKAGE_VERSION_COMPATIBLE FALSE)
-else()
-  set(PACKAGE_VERSION_COMPATIBLE TRUE)
-  if ("${PACKAGE_VERSION}" VERSION_EQUAL "${PACKAGE_FIND_VERSION}")
-    set(PACKAGE_VERSION_EXACT TRUE)
-  endif()
-endif()
diff -pruN 8.0.1-5/mapserver-config.cmake.in 8.2.0~beta1-1~exp1/mapserver-config.cmake.in
--- 8.0.1-5/mapserver-config.cmake.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserver-config.cmake.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,18 +0,0 @@
-# - Config file for the mapserver package
-# It defines the following variables
-#  MAPSERVER_INCLUDE_DIRS - include directories for mapserver
-#  MAPSERVER_LIBRARIES    - libraries to link against
-#  MAPSERVER_EXECUTABLES  - executables build for mapserver
-
-# Compute paths
-get_filename_component(MAPSERVER_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)
-set(MAPSERVER_INCLUDE_DIRS "@CONF_INCLUDE_DIRS@")
-
-# Our library dependencies (contains definitions for IMPORTED targets)
-if(NOT TARGET mapserver AND NOT MapServer_BINARY_DIR)
-  include("${MAPSERVER_CMAKE_DIR}/mapserverTargets.cmake")
-endif()
-
-# These are IMPORTED targets created by mapserverTargets.cmake
-set(MAPSERVER_LIBRARIES mapserver)
-set(MAPSERVER_EXECUTABLES sortshp shptree shptreevis msencrypt legend scalebar tile4ms shptreetst map2img mapserv)
diff -pruN 8.0.1-5/mapserver-config.h.in 8.2.0~beta1-1~exp1/mapserver-config.h.in
--- 8.0.1-5/mapserver-config.h.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserver-config.h.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-#ifndef _MAPSERVER_CONFIG_H
-#define _MAPSERVER_CONFIG_H
-
-#cmakedefine USE_PROJ 1
-#cmakedefine USE_PBF 1
-#cmakedefine USE_POSTGIS 1
-#cmakedefine USE_GDAL 1
-#cmakedefine USE_PIXMAN 1
-#cmakedefine USE_OGR 1
-#cmakedefine USE_WMS_SVR 1
-#cmakedefine USE_WCS_SVR 1
-#cmakedefine USE_WFS_SVR 1
-#cmakedefine USE_SOS_SVR 1
-#cmakedefine USE_OGCAPI_SVR 1
-#cmakedefine USE_WFS_LYR 1
-#cmakedefine USE_WMS_LYR 1
-#cmakedefine USE_CURL 1
-#cmakedefine USE_CAIRO 1
-#cmakedefine USE_GEOS 1
-#cmakedefine USE_GIF 1
-#cmakedefine USE_JPEG 1
-#cmakedefine USE_PNG 1
-#cmakedefine USE_ICONV 1
-#cmakedefine USE_FRIBIDI 1
-#cmakedefine USE_HARFBUZZ 1
-#cmakedefine USE_LIBXML2 1
-#cmakedefine USE_FASTCGI 1
-#cmakedefine USE_MYSQL 1
-#cmakedefine USE_THREAD 1
-#cmakedefine USE_KML 1
-#cmakedefine USE_ORACLESPATIAL 1
-#cmakedefine USE_EXEMPI 1
-#cmakedefine USE_XMLMAPFILE 1
-#cmakedefine USE_GENERIC_MS_NINT 1
-#cmakedefine POSTGIS_HAS_SERVER_VERSION 1
-#cmakedefine USE_SVG_CAIRO 1
-#cmakedefine USE_RSVG 1
-#cmakedefine USE_SDE 1
-#cmakedefine SDE64 1
-#cmakedefine USE_EXTENDED_DEBUG 1
-#cmakedefine USE_V8_MAPSCRIPT 1
-
-/*windows specific hacks*/
-#if defined(_WIN32)
-#cmakedefine REGEX_MALLOC 1
-#cmakedefine USE_GENERIC_MS_NINT 1
-#endif
-
-
-#cmakedefine HAVE_STRRSTR 1
-#cmakedefine HAVE_STRCASECMP 1
-#cmakedefine HAVE_STRCASESTR 1
-#cmakedefine HAVE_STRDUP 1
-#cmakedefine HAVE_STRLCAT 1
-#cmakedefine HAVE_STRLCPY 1
-#cmakedefine HAVE_STRLEN 1
-#cmakedefine HAVE_STRNCASECMP 1
-#cmakedefine HAVE_VSNPRINTF 1
-#cmakedefine HAVE_DLFCN_H 1
-
-#cmakedefine HAVE_LRINTF 1
-#cmakedefine HAVE_LRINT 1
-#cmakedefine HAVE_SYNC_FETCH_AND_ADD 1
-     
-
-#endif
diff -pruN 8.0.1-5/mapserver-version.h.in 8.2.0~beta1-1~exp1/mapserver-version.h.in
--- 8.0.1-5/mapserver-version.h.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserver-version.h.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,11 +0,0 @@
-#ifndef _MAPSERVER_VERSION_H
-#define _MAPSERVER_VERSION_H
-
-#define MS_VERSION_MAJOR @MapServer_VERSION_MAJOR@
-#define MS_VERSION_MINOR @MapServer_VERSION_MINOR@
-#define MS_VERSION_REV @MapServer_VERSION_REVISION@
-#define MS_VERSION "@MapServer_VERSION_STRING@"
-#define MS_VERSION_NUM  @MapServer_VERSION_NUM@ 
-
-#endif
-
diff -pruN 8.0.1-5/mapserver.h 8.2.0~beta1-1~exp1/mapserver.h
--- 8.0.1-5/mapserver.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapserver.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,3322 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Primary MapServer include file.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#ifndef MAP_H
-#define MAP_H
-
-#include "mapserver-config.h"
-
-/*
-** Main includes. If a particular header was needed by several .c files then
-** I just put it here. What the hell, it works and it's all right here. -SDL-
-*/
-#if defined(HAVE_STRCASESTR) && !defined(_GNU_SOURCE)
-#define _GNU_SOURCE /* Required for <string.h> strcasestr() defn */
-#endif
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <math.h>
-#include <time.h>
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#include <direct.h>
-#include <memory.h>
-#include <malloc.h>
-#include <process.h>
-#include <float.h>
-#else
-#include <unistd.h>
-#endif
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
-#define USE_MSFREE
-#else
-#define  MS_DLL_EXPORT
-#endif
-
-#if defined(__GNUC__)
-#define WARN_UNUSED __attribute__((warn_unused_result))
-#define MS_LIKELY(x)   __builtin_expect((x),1)
-#define MS_UNLIKELY(x) __builtin_expect((x),0)
-#else
-#define WARN_UNUSED
-#define MS_LIKELY(x) (x)
-#define MS_UNLIKELY(x) (x)
-#endif
-
-/* definition of  ms_int32/ms_uint32 */
-#include <limits.h>
-#ifndef _WIN32
-#include <stdint.h>
-#endif
-
-#ifdef _WIN32
-#ifndef SIZE_MAX
-#ifdef _WIN64
-#define SIZE_MAX _UI64_MAX
-#else
-#define SIZE_MAX UINT_MAX
-#endif
-#endif
-#endif
-
-#if ULONG_MAX == 0xffffffff
-typedef long            ms_int32;
-typedef unsigned long   ms_uint32;
-#elif UINT_MAX == 0xffffffff
-typedef int             ms_int32;
-typedef unsigned int    ms_uint32;
-#else
-typedef int32_t         ms_int32;
-typedef uint32_t        ms_uint32;
-#endif
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-/* Need to use _vsnprintf() with VS2003 */
-#define vsnprintf _vsnprintf
-#endif
-
-#include "mapserver-api.h"
-
-#ifndef SWIG
-/*forward declaration of rendering object*/
-typedef struct rendererVTableObj rendererVTableObj;
-typedef struct tileCacheObj tileCacheObj;
-typedef struct textPathObj textPathObj;
-typedef struct textRunObj textRunObj;
-typedef struct glyph_element glyph_element;
-typedef struct face_element face_element;
-#endif
-
-
-/* ms_bitarray is used by the bit mask in mapbit.c */
-typedef ms_uint32 *ms_bitarray;
-typedef const ms_uint32 *ms_const_bitarray;
-
-#include "maperror.h"
-#include "mapprimitive.h"
-#include "mapshape.h"
-#include "mapflatgeobuf.h"
-#include "mapsymbol.h"
-#include "maptree.h" /* quadtree spatial index */
-#include "maphash.h"
-#include "mapio.h"
-#include <assert.h>
-#include "mapproject.h"
-#include "cgiutil.h"
-#include "mapserv-config.h"
-
-#include <sys/types.h> /* regular expression support */
-
-/* The regex lib from the system and the regex lib from PHP needs to
- * be separated here. We separate here via its directory location.
- */
-#include "mapregex.h"
-
-
-#define CPL_SUPRESS_CPLUSPLUS
-#include "ogr_api.h"
-
-
-/* EQUAL and EQUALN are defined in cpl_port.h, so add them in here if ogr was not included */
-
-#ifndef EQUAL
-#if defined(_WIN32) || defined(WIN32CE)
-#  define EQUAL(a,b)              (stricmp(a,b)==0)
-#else
-#  define EQUAL(a,b)              (strcasecmp(a,b)==0)
-#endif
-#endif
-
-#ifndef EQUALN
-#if defined(_WIN32) || defined(WIN32CE)
-#  define EQUALN(a,b,n)           (strnicmp(a,b,n)==0)
-#else
-#  define EQUALN(a,b,n)           (strncasecmp(a,b,n)==0)
-#endif
-#endif
-
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#if (defined(_MSC_VER) && (_MSC_VER < 1900)) || !defined(_MSC_VER)
-#define snprintf _snprintf
-#endif
-#endif
-
-#ifdef __cplusplus
-#include <string>
-#include <vector>
-extern "C" {
-#endif
-
-// hide from swig or ruby will choke on the __FUNCTION__ name
-#ifndef SWIG
-  /* Memory allocation check utility */
-#ifndef __FUNCTION__
-#   define __FUNCTION__ "MapServer"
-#endif
-#endif
-
-#define MS_CHECK_ALLOC(var, size, retval)     \
-    if (!var) {   \
-        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", __FUNCTION__, \
-                   __FILE__, __LINE__, (unsigned int)(size));  \
-        return retval;                         \
-    }
-
-#define MS_CHECK_ALLOC_NO_RET(var, size)                                   \
-    if (!var) {                                                       \
-        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", __FUNCTION__, \
-                   __FILE__, __LINE__, (unsigned int)(size));                           \
-        return;                                                         \
-    }
-
-  /* General defines, wrapable */
-
-#define MS_TRUE 1 /* logical control variables */
-#define MS_FALSE 0
-#define MS_UNKNOWN -1
-#define MS_ON 1
-#define MS_OFF 0
-#define MS_DEFAULT 2
-#define MS_EMBED 3
-#define MS_DELETE 4
-#define MS_YES 1
-#define MS_NO 0
-
-
-  /* Number of layer, class and style ptrs to alloc at once in the
-     corresponding msGrow...() functions. Replaces former MS_MAXLAYERS,
-     MS_MAXCLASSES and MS_MAXSTYLES with dynamic allocation (see RFC-17). */
-#define MS_LAYER_ALLOCSIZE 64
-#define MS_CLASS_ALLOCSIZE 8
-#define MS_STYLE_ALLOCSIZE 4
-#define MS_LABEL_ALLOCSIZE 2 /* not too common */
-
-#define MS_MAX_LABEL_PRIORITY     10
-#define MS_MAX_LABEL_FONTS     5
-#define MS_DEFAULT_LABEL_PRIORITY 1
-#define MS_LABEL_FORCE_GROUP 2 /* other values are MS_ON/MS_OFF */
-
-  /* General defines, not wrapable */
-#ifndef SWIG
-#ifdef USE_XMLMAPFILE
-#define MS_DEFAULT_MAPFILE_PATTERN "\\.(map|xml)$"
-#define MS_DEFAULT_XMLMAPFILE_PATTERN "\\.xml$"
-#else
-#define MS_DEFAULT_MAPFILE_PATTERN "\\.map$"
-#endif
-#define MS_DEFAULT_CONTEXTFILE_PATTERN "\\.[Xx][Mm][Ll]$"
-#define MS_TEMPLATE_MAGIC_STRING "MapServer Template"
-#define MS_TEMPLATE_EXPR "\\.(xml|wml|html|htm|svg|kml|gml|js|tmpl)$"
-
-#define MS_INDEX_EXTENSION ".qix"
-
-#define MS_QUERY_RESULTS_MAGIC_STRING "MapServer Query Results"
-#define MS_QUERY_PARAMS_MAGIC_STRING "MapServer Query Params"
-#define MS_QUERY_EXTENSION ".qy"
-
-#define MS_DEG_TO_RAD .0174532925199432958
-#define MS_RAD_TO_DEG   57.29577951
-
-#define MS_DEFAULT_RESOLUTION 72
-
-#define MS_RED 0
-#define MS_GREEN 1
-#define MS_BLUE 2
-
-#define MS_MAXCOLORS 256
-
-#define MS_MISSING_DATA_IGNORE 0
-#define MS_MISSING_DATA_FAIL 1
-#define MS_MISSING_DATA_LOG 2
-
-#define MS_BUFFER_LENGTH 2048 /* maximum input line length */
-#define MS_URL_LENGTH 1024
-#define MS_MAXPATHLEN 1024
-
-#define MS_MAXIMAGESIZE_DEFAULT 4096
-
-#define MS_MAXPROJARGS 20
-#define MS_MAXJOINS 20
-#define MS_ITEMNAMELEN 32
-#define MS_NAMELEN 20
-
-#define MS_MINSYMBOLSIZE 0   /* in pixels */
-#define MS_MAXSYMBOLSIZE 500
-
-#define MS_MINSYMBOLWIDTH 0   /* in pixels */
-#define MS_MAXSYMBOLWIDTH 32
-
-#define MS_URL 0 /* template types */
-#define MS_FILE 1
-
-#define MS_MINFONTSIZE 4
-#define MS_MAXFONTSIZE 256
-
-#define MS_LABELCACHEINITSIZE 100
-#define MS_LABELCACHEINCREMENT 10
-
-#define MS_RESULTCACHEINITSIZE 10
-#define MS_RESULTCACHEINCREMENT 10
-
-#define MS_FEATUREINITSIZE 10 /* how many points initially can a feature have */
-#define MS_FEATUREINCREMENT 10
-
-#define MS_EXPRESSION 2000 /* todo: make this an enum */
-#define MS_REGEX 2001
-#define MS_STRING 2002
-#define MS_NUMBER 2003
-#define MS_COMMENT 2004
-#define MS_IREGEX 2005
-#define MS_ISTRING 2006
-#define MS_BINDING 2007
-#define MS_LIST 2008
-
-  /* string split flags */
-#define MS_HONOURSTRINGS      0x0001
-#define MS_ALLOWEMPTYTOKENS   0x0002
-#define MS_PRESERVEQUOTES     0x0004
-#define MS_PRESERVEESCAPES    0x0008
-#define MS_STRIPLEADSPACES    0x0010
-#define MS_STRIPENDSPACES     0x0020
-
-  /* boolean options for the expression object. */
-#define MS_EXP_INSENSITIVE 1
-
-  /* General macro definitions */
-#define MS_MIN(a,b) (((a)<(b))?(a):(b))
-#define MS_MAX(a,b) (((a)>(b))?(a):(b))
-#define MS_ABS(a) (((a)<0) ? -(a) : (a))
-#define MS_SGN(a) (((a)<0) ? -1 : 1)
-
-#define MS_STRING_IS_NULL_OR_EMPTY(s) ((!s || s[0] == '\0') ? MS_TRUE:MS_FALSE)
-
-#define MS_NINT_GENERIC(x) ((x) >= 0.0 ? ((long) ((x)+.5)) : ((long) ((x)-.5)))
-
-#ifdef _MSC_VER
-#define msIsNan(x) _isnan(x)
-#else
-#define msIsNan(x) isnan(x)
-#endif
-
-  /* see http://mega-nerd.com/FPcast/ for some discussion of fast
-     conversion to nearest int.  We avoid lrint() for now because it
-     would be hard to include math.h "properly". */
-
-#if defined(HAVE_LRINT) && !defined(USE_GENERIC_MS_NINT)
-#   define MS_NINT(x) lrint(x)
-  /*#   define MS_NINT(x) lround(x) */
-/* note that lrint rounds .5 to the nearest *even* integer, i.e. lrint(0.5)=0,lrint(1.5)=2 */
-#elif defined(_MSC_VER) && defined(_WIN32) && !defined(USE_GENERIC_MS_NINT)
-  static __inline long int MS_NINT (double flt)
-  {
-    int intgr;
-
-    _asm {
-      fld flt
-      fistp intgr
-    } ;
-
-    return intgr ;
-  }
-#elif defined(i386) && defined(__GNUC_PREREQ) && !defined(USE_GENERIC_MS_NINT)
-  static __inline long int MS_NINT( double __x )
-  {
-    long int __lrintres;
-    __asm__ __volatile__
-    ("fistpl %0"
-     : "=m" (__lrintres) : "t" (__x) : "st");
-    return __lrintres;
-  }
-#else
-#  define MS_NINT(x)      MS_NINT_GENERIC(x)
-#endif
-
-  /* #define MS_VALID_EXTENT(minx, miny, maxx, maxy)  (((minx<maxx) && (miny<maxy))?MS_TRUE:MS_FALSE) */
-#define MS_VALID_EXTENT(rect)  ((((rect).minx < (rect).maxx && (rect).miny < (rect).maxy))?MS_TRUE:MS_FALSE)
-#define MS_VALID_SEARCH_EXTENT(rect)  ((((rect).minx <= (rect).maxx && (rect).miny <= (rect).maxy))?MS_TRUE:MS_FALSE)
-
-#define MS_INIT_COLOR(color,r,g,b,a) { (color).red = r; (color).green = g; (color).blue = b; (color).alpha=a; }
-#define MS_VALID_COLOR(color) (((color).red==-1 || (color).green==-1 || (color).blue==-1)?MS_FALSE:MS_TRUE)
-#define MS_COMPARE_COLOR(color1, color2) (((color2).red==(color1).red && (color2).green==(color1).green && (color2).blue==(color1).blue)?MS_TRUE:MS_FALSE)
-#define MS_TRANSPARENT_COLOR(color) (((color).alpha==0 || (color).red==-255 || (color).green==-255 || (color).blue==-255)?MS_TRUE:MS_FALSE)
-#define MS_COMPARE_COLORS(a,b) (((a).red!=(b).red || (a).green!=(b).green || (a).blue!=(b).blue)?MS_FALSE:MS_TRUE)
-#define MS_COLOR_GETRGB(color) (MS_VALID_COLOR(color)?((color).red *0x10000 + (color).green *0x100 + (color).blue):-1)
-
-#define MS_IMAGE_MIME_TYPE(format) (format->mimetype ? format->mimetype : "unknown")
-#define MS_IMAGE_EXTENSION(format)  (format->extension ? format->extension : "unknown")
-#define MS_DRIVER_SWF(format) (strncasecmp((format)->driver,"swf",3)==0)
-#define MS_DRIVER_GDAL(format)  (strncasecmp((format)->driver,"gdal/",5)==0)
-#define MS_DRIVER_IMAGEMAP(format)  (strncasecmp((format)->driver,"imagemap",8)==0)
-#define MS_DRIVER_AGG(format) (strncasecmp((format)->driver,"agg/",4)==0)
-#define MS_DRIVER_MVT(format) (strncasecmp((format)->driver,"mvt",3)==0)
-#define MS_DRIVER_CAIRO(format) (strncasecmp((format)->driver,"cairo/",6)==0)
-#define MS_DRIVER_OGL(format) (strncasecmp((format)->driver,"ogl/",4)==0)
-#define MS_DRIVER_TEMPLATE(format) (strncasecmp((format)->driver,"template",8)==0)
-
-#endif /*SWIG*/
-
-#define MS_RENDER_WITH_SWF      2
-#define MS_RENDER_WITH_RAWDATA  3
-#define MS_RENDER_WITH_IMAGEMAP 5
-#define MS_RENDER_WITH_TEMPLATE 8 /* query results only */
-#define MS_RENDER_WITH_OGR 16
-
-#define MS_RENDER_WITH_PLUGIN 100
-#define MS_RENDER_WITH_CAIRO_RASTER   101
-#define MS_RENDER_WITH_CAIRO_PDF 102
-#define MS_RENDER_WITH_CAIRO_SVG 103
-#define MS_RENDER_WITH_OGL      104
-#define MS_RENDER_WITH_AGG 105
-#define MS_RENDER_WITH_KML 106
-#define MS_RENDER_WITH_UTFGRID 107
-#define MS_RENDER_WITH_MVT 108
-
-#ifndef SWIG
-
-#define MS_RENDERER_SWF(format) ((format)->renderer == MS_RENDER_WITH_SWF)
-#define MS_RENDERER_RAWDATA(format) ((format)->renderer == MS_RENDER_WITH_RAWDATA)
-#define MS_RENDERER_IMAGEMAP(format) ((format)->renderer == MS_RENDER_WITH_IMAGEMAP)
-#define MS_RENDERER_TEMPLATE(format) ((format)->renderer == MS_RENDER_WITH_TEMPLATE)
-#define MS_RENDERER_KML(format) ((format)->renderer == MS_RENDER_WITH_KML)
-#define MS_RENDERER_OGR(format) ((format)->renderer == MS_RENDER_WITH_OGR)
-#define MS_RENDERER_MVT(format) ((format)->renderer == MS_RENDER_WITH_MVT)
-
-#define MS_RENDERER_PLUGIN(format) ((format)->renderer > MS_RENDER_WITH_PLUGIN)
-
-#define MS_CELLSIZE(min,max,d) (((max) - (min))/((d)-1)) /* where min/max are from an MapServer pixel center-to-pixel center extent */
-#define MS_OWS_CELLSIZE(min,max,d) (((max) - (min))/(d)) /* where min/max are from an OGC pixel outside edge-to-pixel outside edge extent */
-#define MS_MAP2IMAGE_X(x,minx,cx) (MS_NINT(((x) - (minx))/(cx)))
-#define MS_MAP2IMAGE_Y(y,maxy,cy) (MS_NINT(((maxy) - (y))/(cy)))
-#define MS_IMAGE2MAP_X(x,minx,cx) ((minx) + (cx)*(x))
-#define MS_IMAGE2MAP_Y(y,maxy,cy) ((maxy) - (cy)*(y))
-
-  /* these versions of MS_MAP2IMAGE takes 1/cellsize and is much faster */
-#define MS_MAP2IMAGE_X_IC(x,minx,icx) (MS_NINT(((x) - (minx))*(icx)))
-#define MS_MAP2IMAGE_Y_IC(y,maxy,icy) (MS_NINT(((maxy) - (y))*(icy)))
-#define MS_MAP2IMAGE_XCELL_IC(x,minx,icx) ((int)(((x) - (minx))*(icx)))
-#define MS_MAP2IMAGE_YCELL_IC(y,maxy,icy) ((int)(((maxy) - (y))*(icy)))
-
-#define MS_MAP2IMAGE_X_IC_DBL(x,minx,icx) (((x) - (minx))*(icx))
-#define MS_MAP2IMAGE_Y_IC_DBL(y,maxy,icy) (((maxy) - (y))*(icy))
-
-#define MS_MAP2IMAGE_X_IC_SNAP(x,minx,icx,res) ((MS_NINT(((x) - (minx))*(icx)*(res)))/(res))
-#define MS_MAP2IMAGE_Y_IC_SNAP(y,maxy,icy,res) ((MS_NINT(((maxy) - (y))*(icy)*(res)))/(res))
-
-  /* For CARTO symbols */
-#define MS_PI    3.14159265358979323846
-#define MS_PI2   1.57079632679489661923  /* (MS_PI / 2) */
-#define MS_3PI2  4.71238898038468985769  /* (3 * MS_PI2) */
-#define MS_2PI   6.28318530717958647693  /* (2 * MS_PI) */
-
-#define MS_ENCRYPTION_KEY_SIZE  16   /* Key size: 128 bits = 16 bytes */
-
-#define GET_LAYER(map, pos) map->layers[pos]
-#define GET_CLASS(map, lid, cid) map->layers[lid]->class[cid]
-
-#ifdef USE_THREAD
-#if defined(HAVE_SYNC_FETCH_AND_ADD)
-#define MS_REFCNT_INCR(obj) __sync_fetch_and_add(&obj->refcount, +1)
-#define MS_REFCNT_DECR(obj) __sync_sub_and_fetch(&obj->refcount, +1)
-#define MS_REFCNT_INIT(obj) obj->refcount=1, __sync_synchronize()
-#elif defined(_MSC_VER) && (defined(_M_IX86) || defined(_M_X64))
-#include <intrin.h>
-#pragma intrinsic (_InterlockedExchangeAdd)
-#if defined(_MSC_VER) && (_MSC_VER <= 1200)
-#define MS_REFCNT_INCR(obj) ( _InterlockedExchangeAdd((long*)(&obj->refcount), (long)(+1)) +1 )
-#define MS_REFCNT_DECR(obj) ( _InterlockedExchangeAdd((long*)(&obj->refcount), (long)(-1)) -1 )
-#define MS_REFCNT_INIT(obj) obj->refcount=1
-#else
-#define MS_REFCNT_INCR(obj) ( _InterlockedExchangeAdd((volatile long*)(&obj->refcount), (long)(+1)) +1 )
-#define MS_REFCNT_DECR(obj) ( _InterlockedExchangeAdd((volatile long*)(&obj->refcount), (long)(-1)) -1 )
-#define MS_REFCNT_INIT(obj) obj->refcount=1
-#endif
-#elif defined(__MINGW32__) && defined(__i386__)
-#define MS_REFCNT_INCR(obj) ( InterlockedExchangeAdd((long*)(&obj->refcount), (long)(+1)) +1 )
-#define MS_REFCNT_DECR(obj) ( InterlockedExchangeAdd((long*)(&obj->refcount), (long)(-1)) -1 )
-#define MS_REFCNT_INIT(obj) obj->refcount=1
-#else
-  // unsafe fallback
-#define MS_REFCNT_INCR(obj) obj->refcount++
-#define MS_REFCNT_DECR(obj) (--(obj->refcount))
-#define MS_REFCNT_INIT(obj) obj->refcount=1
-#endif // close if defined(_MSC..
-#else /*USE_THREAD*/
-#define MS_REFCNT_INCR(obj) obj->refcount++
-#define MS_REFCNT_DECR(obj) (--(obj->refcount))
-#define MS_REFCNT_INIT(obj) obj->refcount=1
-#endif /*USE_THREAD*/
-
-#define MS_REFCNT_DECR_IS_NOT_ZERO(obj) (MS_REFCNT_DECR(obj))>0
-#define MS_REFCNT_DECR_IS_ZERO(obj) (MS_REFCNT_DECR(obj))<=0
-
-#define MS_IS_VALID_ARRAY_INDEX(index, size) ((index<0 || index>=size)?MS_FALSE:MS_TRUE)
-
-#define MS_CONVERT_UNIT(src_unit, dst_unit, value) (value * msInchesPerUnit(src_unit,0) / msInchesPerUnit(dst_unit,0))
-
-#define MS_INIT_INVALID_RECT { -1e300, -1e300, 1e300, 1e300 }
-
-#endif
-
-  enum MS_NUM_CHECK_TYPES { MS_NUM_CHECK_NONE=0, MS_NUM_CHECK_RANGE, MS_NUM_CHECK_GT, MS_NUM_CHECK_GTE };
-
-  /* General enumerated types - needed by scripts */
-  enum MS_FILE_TYPE {MS_FILE_MAP, MS_FILE_SYMBOL};
-  enum MS_UNITS {MS_INCHES, MS_FEET, MS_MILES, MS_METERS, MS_KILOMETERS, MS_DD, MS_PIXELS, MS_PERCENTAGES, MS_NAUTICALMILES, MS_INHERIT = -1};
-  enum MS_SHAPE_TYPE {MS_SHAPE_POINT, MS_SHAPE_LINE, MS_SHAPE_POLYGON, MS_SHAPE_NULL};
-  enum MS_LAYER_TYPE {MS_LAYER_POINT, MS_LAYER_LINE, MS_LAYER_POLYGON, MS_LAYER_RASTER, MS_LAYER_ANNOTATION /* only used for parser backwards compatibility */, MS_LAYER_QUERY, MS_LAYER_CIRCLE, MS_LAYER_TILEINDEX, MS_LAYER_CHART};
-  enum MS_FONT_TYPE {MS_TRUETYPE, MS_BITMAP};
-  enum MS_RENDER_MODE {MS_FIRST_MATCHING_CLASS, MS_ALL_MATCHING_CLASSES};
-
-#define MS_POSITIONS_LENGTH 14
-  enum MS_POSITIONS_ENUM {MS_UL=101, MS_LR, MS_UR, MS_LL, MS_CR, MS_CL, MS_UC, MS_LC, MS_CC, MS_AUTO, MS_XY, MS_NONE, MS_AUTO2,MS_FOLLOW};
-#define MS_TINY 5
-#define MS_SMALL 7
-#define MS_MEDIUM 10
-#define MS_LARGE 13
-#define MS_GIANT 16
-  enum MS_QUERYMAP_STYLES {MS_NORMAL, MS_HILITE, MS_SELECTED};
-  enum MS_CONNECTION_TYPE {MS_INLINE, MS_SHAPEFILE, MS_TILED_SHAPEFILE, MS_UNUSED_2, MS_OGR, MS_UNUSED_1, MS_POSTGIS, MS_WMS, MS_ORACLESPATIAL, MS_WFS, MS_GRATICULE, MS_MYSQL, MS_RASTER, MS_PLUGIN, MS_UNION, MS_UVRASTER, MS_CONTOUR, MS_KERNELDENSITY, MS_IDW, MS_FLATGEOBUF };
-#define IS_THIRDPARTY_LAYER_CONNECTIONTYPE(type) ((type) == MS_UNION || (type) == MS_KERNELDENSITY || (type) == MS_IDW)
-  enum MS_JOIN_CONNECTION_TYPE {MS_DB_XBASE, MS_DB_CSV, MS_DB_MYSQL, MS_DB_ORACLE, MS_DB_POSTGRES};
-  enum MS_JOIN_TYPE {MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY};
-
-#define MS_SINGLE 0 /* modes for searching (spatial/database) */
-#define MS_MULTIPLE 1
-
-  enum MS_QUERY_MODE {MS_QUERY_SINGLE, MS_QUERY_MULTIPLE};
-  enum MS_QUERY_TYPE {MS_QUERY_IS_NULL, MS_QUERY_BY_POINT, MS_QUERY_BY_RECT, MS_QUERY_BY_SHAPE, MS_QUERY_BY_ATTRIBUTE, MS_QUERY_BY_INDEX, MS_QUERY_BY_FILTER};
-
-  enum MS_ALIGN_VALUE {MS_ALIGN_DEFAULT, MS_ALIGN_LEFT, MS_ALIGN_CENTER, MS_ALIGN_RIGHT};
-
-  enum MS_CAPS_JOINS_AND_CORNERS {MS_CJC_NONE, MS_CJC_BEVEL, MS_CJC_BUTT, MS_CJC_MITER, MS_CJC_ROUND, MS_CJC_SQUARE, MS_CJC_TRIANGLE};
-
-#define MS_CJC_DEFAULT_CAPS MS_CJC_ROUND
-#define MS_CJC_DEFAULT_JOINS MS_CJC_NONE
-#define MS_CJC_DEFAULT_JOIN_MAXSIZE 3
-
-  enum MS_RETURN_VALUE {MS_SUCCESS, MS_FAILURE, MS_DONE};
-  enum MS_IMAGEMODE { MS_IMAGEMODE_PC256, MS_IMAGEMODE_RGB, MS_IMAGEMODE_RGBA, MS_IMAGEMODE_INT16, MS_IMAGEMODE_FLOAT32, MS_IMAGEMODE_BYTE, MS_IMAGEMODE_FEATURE, MS_IMAGEMODE_NULL };
-
-  enum MS_GEOS_OPERATOR {MS_GEOS_EQUALS, MS_GEOS_DISJOINT, MS_GEOS_TOUCHES, MS_GEOS_OVERLAPS, MS_GEOS_CROSSES, MS_GEOS_INTERSECTS, MS_GEOS_WITHIN, MS_GEOS_CONTAINS, MS_GEOS_BEYOND, MS_GEOS_DWITHIN};
-#define MS_FILE_DEFAULT MS_FILE_MAP
-
-#if defined(_MSC_VER) && (_MSC_VER <= 1310)
-#define MS_DEBUG msDebug2
-#else
-#ifdef USE_EXTENDED_DEBUG
-#define MS_DEBUG(level,elt,fmt, ...) if((elt)->debug >= (level)) msDebug(fmt,##__VA_ARGS__)
-#else
-#define MS_DEBUG(level,elt,fmt, ...) /* no-op */
-#endif
-#endif
-
-  /* coordinate to pixel simplification modes, used in msTransformShape */
-  enum MS_TRANSFORM_MODE {
-    MS_TRANSFORM_NONE, /* no geographic to pixel transformation */
-    MS_TRANSFORM_ROUND, /* round to integer, might create degenerate geometries (used for GD)*/
-    MS_TRANSFORM_SNAPTOGRID, /* snap to a grid, should be user configurable in the future*/
-    MS_TRANSFORM_FULLRESOLUTION, /* keep full resolution */
-    MS_TRANSFORM_SIMPLIFY /* keep full resolution */
-  };
-
-  typedef enum {
-        MS_COMPOP_CLEAR,
-        MS_COMPOP_SRC,
-        MS_COMPOP_DST,
-        MS_COMPOP_SRC_OVER,
-        MS_COMPOP_DST_OVER,
-        MS_COMPOP_SRC_IN,
-        MS_COMPOP_DST_IN,
-        MS_COMPOP_SRC_OUT,
-        MS_COMPOP_DST_OUT,
-        MS_COMPOP_SRC_ATOP,
-        MS_COMPOP_DST_ATOP,
-        MS_COMPOP_XOR,
-        MS_COMPOP_PLUS,
-        MS_COMPOP_MINUS,
-        MS_COMPOP_MULTIPLY,
-        MS_COMPOP_SCREEN,
-        MS_COMPOP_OVERLAY,
-        MS_COMPOP_DARKEN,
-        MS_COMPOP_LIGHTEN,
-        MS_COMPOP_COLOR_DODGE,
-        MS_COMPOP_COLOR_BURN,
-        MS_COMPOP_HARD_LIGHT,
-        MS_COMPOP_SOFT_LIGHT,
-        MS_COMPOP_DIFFERENCE,
-        MS_COMPOP_EXCLUSION,
-        MS_COMPOP_CONTRAST,
-        MS_COMPOP_INVERT,
-        MS_COMPOP_INVERT_RGB
-  } CompositingOperation;
-
-  typedef struct _CompositingFilter{
-    char *filter;
-    struct _CompositingFilter *next;
-  } CompositingFilter;
-
-  typedef struct _LayerCompositer{
-    CompositingOperation comp_op;
-    int opacity;
-    CompositingFilter *filter;
-    struct _LayerCompositer *next;
-  } LayerCompositer;
-
-#ifndef SWIG
-  /* Filter object */
-  typedef enum {
-    FILTER_NODE_TYPE_UNDEFINED = -1,
-    FILTER_NODE_TYPE_LOGICAL = 0,
-    FILTER_NODE_TYPE_SPATIAL = 1,
-    FILTER_NODE_TYPE_COMPARISON = 2,
-    FILTER_NODE_TYPE_PROPERTYNAME = 3,
-    FILTER_NODE_TYPE_BBOX = 4,
-    FILTER_NODE_TYPE_LITERAL = 5,
-    FILTER_NODE_TYPE_BOUNDARY = 6,
-    FILTER_NODE_TYPE_GEOMETRY_POINT = 7,
-    FILTER_NODE_TYPE_GEOMETRY_LINE = 8,
-    FILTER_NODE_TYPE_GEOMETRY_POLYGON = 9,
-    FILTER_NODE_TYPE_FEATUREID = 10,
-    FILTER_NODE_TYPE_TEMPORAL = 11,
-    FILTER_NODE_TYPE_TIME_PERIOD = 12
-  } FilterNodeType;
-
-
-  /************************************************************************/
-  /*                          FilterEncodingNode                          */
-  /************************************************************************/
-
-  typedef struct _FilterNode {
-    FilterNodeType      eType;
-    char                *pszValue;
-    void                *pOther;
-    char                *pszSRS;
-    struct _FilterNode  *psLeftNode;
-    struct _FilterNode  *psRightNode;
-  } FilterEncodingNode;
-#endif /*SWIG*/
-
-  /* Define supported bindings here (only covers existing bindings at first). Not accessible directly using MapScript. */
-#define MS_STYLE_BINDING_LENGTH 12
-  enum MS_STYLE_BINDING_ENUM { MS_STYLE_BINDING_SIZE, MS_STYLE_BINDING_WIDTH, MS_STYLE_BINDING_ANGLE, MS_STYLE_BINDING_COLOR, MS_STYLE_BINDING_OUTLINECOLOR, MS_STYLE_BINDING_SYMBOL, MS_STYLE_BINDING_OUTLINEWIDTH, MS_STYLE_BINDING_OPACITY, MS_STYLE_BINDING_OFFSET_X, MS_STYLE_BINDING_OFFSET_Y, MS_STYLE_BINDING_POLAROFFSET_PIXEL, MS_STYLE_BINDING_POLAROFFSET_ANGLE };
-#define MS_LABEL_BINDING_LENGTH 12
-  enum MS_LABEL_BINDING_ENUM { MS_LABEL_BINDING_SIZE, MS_LABEL_BINDING_ANGLE, MS_LABEL_BINDING_COLOR, MS_LABEL_BINDING_OUTLINECOLOR, MS_LABEL_BINDING_FONT, MS_LABEL_BINDING_PRIORITY, MS_LABEL_BINDING_POSITION, MS_LABEL_BINDING_SHADOWSIZEX, MS_LABEL_BINDING_SHADOWSIZEY, MS_LABEL_BINDING_OFFSET_X, MS_LABEL_BINDING_OFFSET_Y,MS_LABEL_BINDING_ALIGN };
-
-  /************************************************************************/
-  /*                         attributeBindingObj                          */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    char *item;
-    int index;
-  } attributeBindingObj;
-#endif /*SWIG*/
-
-  /************************************************************************/
-  /*                             labelPathObj                             */
-  /*                                                                      */
-  /*      Label path object - used to hold path and bounds of curved      */
-  /*      labels - Bug #1620 implementation.                              */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    multipointObj path;
-    shapeObj bounds;
-    double *angles;
-  } labelPathObj;
-#endif /*SWIG*/
-
-  /************************************************************************/
-  /*                              fontSetObj                              */
-  /*                                                                      */
-  /*      used to hold aliases for TRUETYPE fonts                         */
-  /************************************************************************/
-
-  /**
-  The :ref:`FONTSET <fontset>` object
-  */
-  typedef struct {
-#ifdef SWIG
-    %immutable;
-#endif
-    char *filename; ///< The filename of the fonset
-    int numfonts; ///< The number of fonts in the fontset
-    hashTableObj fonts; ///< Key, value pairs of font name and font file
-#ifdef SWIG
-    %mutable;
-#endif
-
-#ifndef SWIG
-    struct mapObj *map;
-#endif
-  } fontSetObj;
-
-  /************************************************************************/
-  /*                         featureListNodeObj                           */
-  /*                                                                      */
-  /*      for inline features, shape caches and queries                   */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct listNode {
-    shapeObj shape;
-    struct listNode *next;
-    struct listNode *tailifhead; /* this is the tail node in the list, if this is the head element, otherwise NULL */
-  } featureListNodeObj;
-
-  typedef featureListNodeObj * featureListNodeObjPtr;
-#endif
-
-  /************************************************************************/
-  /*                              paletteObj                              */
-  /*                                                                      */
-  /*      used to hold colors while a map file is read                    */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    colorObj colors[MS_MAXCOLORS-1];
-    int      colorvalue[MS_MAXCOLORS-1];
-    int numcolors;
-  } paletteObj;
-#endif
-
-  /************************************************************************/
-  /*                     expressionObj & tokenObj                         */
-  /************************************************************************/
-
-  enum MS_TOKEN_LOGICAL_ENUM { MS_TOKEN_LOGICAL_AND=300, MS_TOKEN_LOGICAL_OR, MS_TOKEN_LOGICAL_NOT };
-  enum MS_TOKEN_LITERAL_ENUM { MS_TOKEN_LITERAL_NUMBER=310, MS_TOKEN_LITERAL_STRING, MS_TOKEN_LITERAL_TIME, MS_TOKEN_LITERAL_SHAPE, MS_TOKEN_LITERAL_BOOLEAN };
-  enum MS_TOKEN_COMPARISON_ENUM {
-    MS_TOKEN_COMPARISON_EQ=320, MS_TOKEN_COMPARISON_NE, MS_TOKEN_COMPARISON_GT, MS_TOKEN_COMPARISON_LT, MS_TOKEN_COMPARISON_LE, MS_TOKEN_COMPARISON_GE, MS_TOKEN_COMPARISON_IEQ,
-    MS_TOKEN_COMPARISON_RE, MS_TOKEN_COMPARISON_IRE,
-    MS_TOKEN_COMPARISON_IN, MS_TOKEN_COMPARISON_LIKE,
-    MS_TOKEN_COMPARISON_INTERSECTS, MS_TOKEN_COMPARISON_DISJOINT, MS_TOKEN_COMPARISON_TOUCHES, MS_TOKEN_COMPARISON_OVERLAPS, MS_TOKEN_COMPARISON_CROSSES, MS_TOKEN_COMPARISON_WITHIN, MS_TOKEN_COMPARISON_CONTAINS, MS_TOKEN_COMPARISON_EQUALS, MS_TOKEN_COMPARISON_BEYOND, MS_TOKEN_COMPARISON_DWITHIN
-  };
-  enum MS_TOKEN_FUNCTION_ENUM {
-    MS_TOKEN_FUNCTION_LENGTH=350, MS_TOKEN_FUNCTION_TOSTRING, MS_TOKEN_FUNCTION_COMMIFY, MS_TOKEN_FUNCTION_AREA, MS_TOKEN_FUNCTION_ROUND, MS_TOKEN_FUNCTION_FROMTEXT,
-    MS_TOKEN_FUNCTION_BUFFER, MS_TOKEN_FUNCTION_DIFFERENCE, MS_TOKEN_FUNCTION_SIMPLIFY, MS_TOKEN_FUNCTION_SIMPLIFYPT, MS_TOKEN_FUNCTION_GENERALIZE, MS_TOKEN_FUNCTION_SMOOTHSIA, 
-    MS_TOKEN_FUNCTION_CENTERLINE, MS_TOKEN_FUNCTION_DENSIFY, MS_TOKEN_FUNCTION_OUTER, MS_TOKEN_FUNCTION_INNER,
-    MS_TOKEN_FUNCTION_JAVASCRIPT, MS_TOKEN_FUNCTION_UPPER, MS_TOKEN_FUNCTION_LOWER, MS_TOKEN_FUNCTION_INITCAP, MS_TOKEN_FUNCTION_FIRSTCAP
-  };
-  enum MS_TOKEN_BINDING_ENUM { MS_TOKEN_BINDING_DOUBLE=380, MS_TOKEN_BINDING_INTEGER, MS_TOKEN_BINDING_STRING, MS_TOKEN_BINDING_TIME, MS_TOKEN_BINDING_SHAPE, MS_TOKEN_BINDING_MAP_CELLSIZE, MS_TOKEN_BINDING_DATA_CELLSIZE };
-  enum MS_PARSE_TYPE_ENUM { MS_PARSE_TYPE_BOOLEAN, MS_PARSE_TYPE_STRING, MS_PARSE_TYPE_SHAPE, MS_PARSE_TYPE_SLD };
-
-#ifndef SWIG
-  typedef union {
-    int intval;
-    char *strval;
-    shapeObj *shpval;
-  } parseResultObj;
-
-  typedef union {
-    double dblval;
-    int intval;
-    char *strval;
-    struct tm tmval;
-    shapeObj *shpval;
-    attributeBindingObj bindval;
-  } tokenValueObj;
-
-  typedef struct tokenListNode {
-    int token;
-    tokenValueObj tokenval;
-    char *tokensrc; /* on occassion we may want to access to the original source string (e.g. date/time) */
-    struct tokenListNode *next;
-    struct tokenListNode *tailifhead; /* this is the tail node in the list if this is the head element, otherwise NULL */
-  } tokenListNodeObj;
-
-  typedef tokenListNodeObj * tokenListNodeObjPtr;
-
-  typedef struct {
-    char *string;
-    int type;
-    /* container for expression options such as case-insensitiveness */
-    /* This is a boolean container. */
-    int flags;
-
-    /* logical expression options */
-    tokenListNodeObjPtr tokens;
-    tokenListNodeObjPtr curtoken;
-
-    /* regular expression options */
-    ms_regex_t regex; /* compiled regular expression to be matched */
-    int compiled;
-
-    char *native_string; /* RFC 91 */
-  } expressionObj;
-
-  typedef struct {
-    colorObj *pixel; /* for raster layers */
-    shapeObj *shape; /* for vector layers */
-    double dblval; /* for map cellsize used by simplify */
-    double dblval2; /* for data cellsize */
-    expressionObj *expr; /* expression to be evaluated (contains tokens) */
-    int type; /* type of parse: boolean, string/text or shape/geometry */
-    parseResultObj result; /* parse result */
-  } parseObj;
-#endif
-
-  /************************************************************************/
-  /*                          clusterObj                                  */
-  /************************************************************************/
-
-/**
-The :ref:`CLUSTER <cluster>` object. See :ref:`RFC 69 <rfc69>`.
-*/
-  typedef struct {
-    double maxdistance; ///< Maximum distance between clusters - see :ref:`MAXDISTANCE <mapfile-cluster-maxdistance>`
-    double buffer; ///< The buffer size around the selection area - see :ref:`BUFFER <mapfile-cluster-buffer>`
-    char* region; ///< The type of the cluster region (rectangle or ellipse) - see :ref:`REGION <mapfile-cluster-region>`
-#ifndef SWIG
-    expressionObj group; /* expression to identify the groups */
-    expressionObj filter; /* expression for filtering the shapes */
-#endif
-  } clusterObj;
-
-  /************************************************************************/
-  /*                          processingParams                            */
-  /************************************************************************/
-
-#ifndef SWIG
-/* Used by idw.c and kerneldensity.c */
-  typedef struct {
-      float normalization_scale;
-      int expand_searchrect;
-      int radius;
-      float power;
-  } interpolationProcessingParams;
-#endif
-
-  /************************************************************************/
-  /*                               joinObj                                */
-  /*                                                                      */
-  /*      simple way to access other XBase files, one-to-one or           */
-  /*      one-to-many supported                                           */
-  /************************************************************************/
-
-#ifndef SWIG
-  typedef struct {
-    char *name;
-    char **items, **values; /* items/values (process 1 record at a time) */
-    int numitems;
-
-    char *table;
-    char *from, *to; /* item names */
-
-    void *joininfo; /* vendor specific (i.e. XBase, MySQL, etc.) stuff to allow for persistent access */
-
-    char *header, *footer;
-#ifndef __cplusplus
-    char *template;
-#else
-    char *_template;
-#endif
-
-    enum MS_JOIN_TYPE type;
-    char *connection;
-    enum MS_JOIN_CONNECTION_TYPE connectiontype;
-  } joinObj;
-#endif
-
-  /************************************************************************/
-  /*                           outputFormatObj                            */
-  /*                                                                      */
-  /*      see mapoutput.c for most related code.                          */
-  /************************************************************************/
- 
-/**
-The :ref:`OUTPUTFORMAT <outputformat>` object
-*/
-  typedef struct {
-#ifndef SWIG
-    int refcount;
-    char **formatoptions;
-    rendererVTableObj *vtable;
-    void *device; /* for supporting direct rendering onto a device context */
-#endif /* SWIG */
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-
-    /**
-    The number of option values set on this format - can be used to
-    iterate over the options array in conjunction with :func:`outputFormatObj.getOptionAt`
-    */
-    int  numformatoptions;
-
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-    char *name; ///< See :ref:`NAME <mapfile-outputformat-name>`
-    char *mimetype; ///< See :ref:`MIMETYPE <mapfile-outputformat-mimetype>`
-    char *driver; ///< See :ref:`DRIVER <mapfile-outputformat-driver>`
-    char *extension; ///< See :ref:`EXTENSION <mapfile-outputformat-extension>`
-    int  renderer;  ///< A :ref:`render mode constant<mapfile-constants-render>` - normally set internally based on the driver and some other setting in the constructor.
-    int  imagemode; ///< An :ref:`Image mode constant<mapfile-constants-imagemode>` - see :ref:`IMAGEMODE <mapfile-outputformat-imagemode>`
-    int  transparent; ///< See :ref:`TRANSPARENT <mapfile-outputformat-transparent>`
-    int  bands; ///< The number of bands in the raster, normally set via the BAND_COUNT formatoption - this field should be considered read-only
-                ///< Only used for the "raw" modes, MS_IMAGEMODE_BYTE, MS_IMAGEMODE_INT16, and MS_IMAGEMODE_FLOAT32
-    int inmapfile; ///< Boolean value indicating if the format is in the Mapfile
-  } outputFormatObj;
-
-  /* The following is used for "don't care" values in transparent, interlace and
-     imagequality values. */
-#define MS_NOOVERRIDE  -1111
-
-  /************************************************************************/
-  /*                             queryObj                                 */
-  /*                                                                      */
-  /*      encapsulates the information necessary to perform a query       */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    int type; /* MS_QUERY_TYPE */
-    int mode; /* MS_QUERY_MODE */
-
-    int layer;
-
-    pointObj point; /* by point */
-    double buffer;
-    int maxresults;
-
-    rectObj rect; /* by rect */
-    shapeObj *shape; /* by shape & operator (OGC filter) */
-
-    long shapeindex; /* by index */
-    long tileindex;
-    int clear_resultcache;
-
-    int  maxfeatures; /* global maxfeatures */
-    int  startindex;
-    int  only_cache_result_count; /* set to 1 sometimes by WFS 2.0 GetFeature request */
-
-    expressionObj filter; /* by filter */
-    char *filteritem;
-
-    int slayer; /* selection layer, used for msQueryByFeatures() (note this is not a query mode per se) */
-
-    int cache_shapes; /* whether to cache shapes in resultCacheObj */
-    int max_cached_shape_count; /* maximum number of shapes cached in the total number of resultCacheObj */
-    int max_cached_shape_ram_amount; /* maximum number of bytes taken by shapes cached in the total number of resultCacheObj */
-  } queryObj;
-#endif
-
-  /************************************************************************/
-  /*                             queryMapObj                              */
-  /*                                                                      */
-  /*      used to visualize query results                                 */
-  /************************************************************************/
-
-/**
-The :ref:`QUERYMAP <querymap>` object.
-Instances of querymapObj are always are always embedded inside the :class:`mapObj`.
-*/
-  typedef struct {
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-    struct mapObj *map; ///< Reference to parent :class:`mapObj`                                                                                                                 
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-    int height; ///< See :ref:`SIZE <mapfile-querymap-size>`
-    int width; ///< See :ref:`SIZE <mapfile-querymap-size>`
-    int status; ///< See :ref:`STATUS <mapfile-querymap-status>`
-    int style; ///< ``HILITE``, ``SELECTED`` or ``NORMAL`` - see :ref:`STYLE <mapfile-querymap-style>`
-    colorObj color; ///< See :ref:`COLOR <mapfile-querymap-color>`
-  } queryMapObj;
-
-  /************************************************************************/
-  /*                                webObj                                */
-  /*                                                                      */
-  /*      holds parameters for a mapserver/mapscript interface            */
-  /************************************************************************/
-
-/**
-The :ref:`WEB <web>` object.
-Has no other existence than as an attribute of a :class:`mapObj`. 
-Serves as a container for various run-time web application definitions like temporary file paths, template paths, etc.
-*/
-  typedef struct {
-
-#ifdef SWIG
-      %immutable;
-#endif /* SWIG */
-      hashTableObj metadata; ///< Metadata hash table - see :ref:`METADATA <mapfile-web-metadata>`
-      hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-web-validation>`
-      struct mapObj *map; ///< Reference to parent :class:`mapObj`
-
-#ifdef SWIG
-      %mutable;
-#endif /* SWIG */
-
-    char *imagepath; ///< Filesystem path to temporary image location - see :ref:`IMAGEPATH <mapfile-web-imagepath>`
-    char *imageurl; ///< URL to temporary image location - see :ref:`IMAGEURL <mapfile-web-imageurl>`
-    char *temppath; ///< See :ref:`TEMPPATH <mapfile-web-temppath>`
-    char *header; ///< Path to header document - see :ref:`HEADER <mapfile-web-header>`
-    char *footer; ///< Path to footer document - see :ref:`FOOTER <mapfile-web-footer>`
-    char *empty; ///< See :ref:`EMPTY <mapfile-web-empty>`
-    char *error; ///< Error handling - see :ref:`ERROR <mapfile-web-error>`
-
-    double minscaledenom; ///< Maximum map scale - see :ref:`MINSCALEDENOM <mapfile-web-minscaledenom>`
-    double maxscaledenom; ///< Minimum map scale - see :ref:`MAXSCALEDENOM <mapfile-web-maxscaledenom>`
-    char *mintemplate; ///< See :ref:`MINTEMPLATE <mapfile-web-mintemplate>`
-    char *maxtemplate; ///< See :ref:`MAXTEMPLATE <mapfile-web-maxtemplate>`
-
-    char *queryformat; ///< See :ref:`QUERYFORMAT <mapfile-web-queryformat>` /* what format is the query to be returned, given as a MIME type */
-    char *legendformat; ///< See :ref:`LEGENDFORMAT <mapfile-web-legendformat>`
-    char *browseformat; ///< See :ref:`BROWSEFORMAT <mapfile-web-browseformat>`
-
-#ifndef __cplusplus
-    char *template; ///< Path to template document - see :ref:`TEMPLATE <mapfile-web-template>`
-#else
-    char *_template;
-#endif
-
-  } webObj;
-
-  /************************************************************************/
-  /*                               styleObj                               */
-  /*                                                                      */
-  /*      holds parameters for symbolization, multiple styles may be      */
-  /*      applied within a classObj                                       */
-  /************************************************************************/
-
-/**
-The :ref:`STYLE <style>` object. An instance of styleObj is associated with one instance of :class:`classObj`.
-*/
-  struct styleObj{
-
-#ifndef SWIG
-      /* private vars for rfc 48 & 64 */
-      expressionObj _geomtransform;
-      double scalefactor; // computed, not set
-      attributeBindingObj bindings[MS_STYLE_BINDING_LENGTH];
-      int numbindings;
-      expressionObj exprBindings[MS_STYLE_BINDING_LENGTH];
-      int nexprbindings;
-#endif
-
-
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-
-    int refcount; ///< number of references to this object
-    char *symbolname; ///< Name of the style's symbol - see :ref:`symbolname <mapfile-style-symbol>`
-
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-
-#if defined(SWIG) && defined(SWIGPYTHON) /* would probably make sense to mark it immutable for other binding languages than Python */
-    %immutable;
-#endif
-    int patternlength; ///< Number of elements in the pattern attribute
-#if defined(SWIG) && defined(SWIGPYTHON)
-    %mutable;
-#endif
-
-#if !(defined(SWIG) && defined(SWIGPYTHON)) /* in Python we use a special typemap for this */
-    double pattern[MS_MAXPATTERNLENGTH]; ///< List of on, off values to define a dash pattern for line work (lines, polygon outlines, hatch lines)
-#endif
-
-    double angle; ///< Angle, given in degrees, to draw the line work, default is 0, for symbols of Type HATCH, this is the angle of the 
-                  ///< hatched lines - see :ref:`ANGLE <mapfile-style-angle>`
-    /*should an angle be automatically computed*/
-    int autoangle; ///< If the angle is set to ``AUTO`` - see :ref:`ANGLE <mapfile-style-angle>`
-
-    /* should lines be drawn with antialiasing (default)? */
-    int antialiased; ///< See :ref:`ANTIALIAS <mapfile-style-antialias>`
-
-    colorObj color; ///< Foreground or fill pen color - see :ref:`COLOR <mapfile-style-color>`
-    colorObj outlinecolor; ///< Outline pen color - see :ref:`OUTLINECOLOR <mapfile-style-outlinecolor>`
-
-    int opacity; ///< See :ref:`OPACITY <mapfile-style-opacity>`
-
-    /* Stuff to handle Color Range Styles */
-    colorObj mincolor; ///< Minimum color in the :ref:`COLORRANGE <mapfile-style-colorrange>`
-    colorObj maxcolor; ///< Maximum color in the :ref:`COLORRANGE <mapfile-style-colorrange>`
-    double minvalue; ///< related to color ranges
-    double maxvalue; ///< related to color ranges
-    char *rangeitem; ///< Attribute/field that stores the values for the Color Range Mapping  - see :ref:`RANGEITEM <mapfile-style-rangeitem>`
-    int rangeitemindex; ///< The index of the range item - see :ref:`RANGEITEM <mapfile-style-rangeitem>`
-
-    int symbol; ///< The index within the map symbolset of the style's symbol - see :ref:`SYMBOL <mapfile-style-symbol>`
-    double size; ///< Pixel width of the style's pen or symbol - see :ref:`SIZE <mapfile-style-size>`
-    double minsize; ///< Minimum pen or symbol width for scaling styles - see :ref:`MINSIZE <mapfile-style-minsize>`
-    double maxsize; ///< Maximum pen or symbol width for scaling - see :ref:`MAXSIZE <mapfile-style-maxsize>`
-
-    double gap; ///< See :ref:`GAP <mapfile-style-gap>` - moved from symbolObj in version 6.0
-    double initialgap; ///< See :ref:`INITIALGAP <mapfile-style-initialgap>`
-
-    int linecap; ///< See :ref:`LINECAP <mapfile-style-linecap>`
-    int linejoin; ///< See :ref:`LINEJOIN <mapfile-style-linejoin>` - moved from symbolObj in version 6.0
-    double linejoinmaxsize; ///< See :ref:`LINEJOINMAXSIZE <mapfile-style-linejoinmaxsize>` - moved from symbolObj in version 6.0
-
-    double width; ///< Width refers to the thickness of line work drawn, in pixels - default is 1,
-                  ///< for symbols of type ``HATCH``, the with is how thick the hatched lines are - see :ref:`WIDTH <mapfile-style-width>`
-    double outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-style-outlinewidth>`
-    double minwidth; ///< Minimum width of the symbol - see :ref:`MINWIDTH <mapfile-style-minwidth>`
-    double maxwidth; ///< Maximum width of the symbol - see :ref:`MAXWIDTH <mapfile-style-maxwidth>`
-
-    double offsetx; ///< Draw with pen or symbol offset from map data, for shadows, hollow symbols, etc - see :ref:`OFFSET <mapfile-style-offset>`
-    double offsety; ///< Draw with pen or symbol offset from map data, for shadows, hollow symbols, etc - see :ref:`OFFSET <mapfile-style-offset>`
-    double polaroffsetpixel; ///< Specifies the radius/distance - see :ref:`POLAROFFSET <mapfile-style-polaroffset>`
-    double polaroffsetangle; ///< Specified the angle - see :ref:`POLAROFFSET <mapfile-style-polaroffset>`
-
-
-    double minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-style-minscaledenom>`
-    double maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-style-maxscaledenom>`
-    int sizeunits; ///< Supersedes class's :ref:`SIZEUNITS <mapfile-layer-sizeunits>` to allow fine-grained sizing for improved SLD (RFC 124)
-  };
-
-#define MS_STYLE_SINGLE_SIDED_OFFSET -99
-#define MS_STYLE_DOUBLE_SIDED_OFFSET -999
-#define IS_PARALLEL_OFFSET(offsety) ((offsety) == MS_STYLE_SINGLE_SIDED_OFFSET || (offsety) == MS_STYLE_DOUBLE_SIDED_OFFSET)
-
-  /********************************************************************/
-  /*                          labelLeaderObj                          */
-  /*                                                                  */
-  /*  parameters defining how a label or a group of labels may be     */
-  /*  offsetted from its original position                            */
-  /********************************************************************/
-
-/**
-The :ref:`LEADER <leader>` object
-*/
-  typedef struct {
-#ifndef SWIG
-    styleObj **styles;
-    int maxstyles;
-#endif
-#ifdef SWIG
-    %immutable;
-#endif
-    int numstyles; ///< Number of styles used
-#ifdef SWIG
-    %mutable;
-#endif
-    int maxdistance; ///< See :ref:`MAXDISTANCE <mapfile-leader-maxdistance>`
-    int gridstep; ///< See :ref:`GRIDSTEP <mapfile-leader-gridstep>`
-  } labelLeaderObj;
-
-
-  /************************************************************************/
-  /*                               labelObj                               */
-  /*                                                                      */
-  /*      parameters needed to annotate a layer, legend or scalebar       */
-  /************************************************************************/
-
-/**
-The :ref:`LABEL <label>` object
-*/
-  struct labelObj{
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-    int refcount;
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-
-    char *font; ///< Name of TrueType font  see :ref:`FONT <mapfile-label-font>`
-    colorObj color; ///< Foreground color - see :ref:`COLOR <mapfile-label-color>`
-    colorObj outlinecolor; ///< Color of one point outline - see :ref:`OUTLINECOLOR <mapfile-label-outlinecolor>`
-    int outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-label-outlinewidth>`
-
-    colorObj shadowcolor; ///< See :ref:`SHADOWCOLOR <mapfile-label-shadowcolor>`
-    int shadowsizex; ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
-    int shadowsizey; ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
-
-    int size; ///< Annotation height in pixels - see :ref:`SIZE <mapfile-label-size>`
-    int minsize; ///< Minimum height in pixels - see :ref:`MINSIZE <mapfile-label-minsize>`
-    int maxsize; ///< Maximum height in pixels for scaled labels. See :ref:`MAXSIZE <mapfile-label-maxsize>`
-
-    int position; ///< See :ref:`POSTION <mapfile-label-position>`
-    int offsetx; ///< Horizontal offset of label - see :ref:`OFFSET <mapfile-label-offset>`
-    int offsety; ///< Vertical offset of label - see :ref:`OFFSET <mapfile-label-offset>`
-
-    double angle; ///< See :ref:`ANGLE <mapfile-label-angle>`
-    enum MS_POSITIONS_ENUM anglemode; ///< One of :data:`AUTO` :data:`AUTO2`, or :data:`FOLLOW` - see :ref:`ANGLE <mapfile-label-angle>`
-
-    int buffer; ///< Space to reserve around a label (padding) - see :ref:`BUFFER <mapfile-label-buffer>`
-
-    int align; ///< See :ref:`ALIGN <mapfile-label-align>`
-
-    char wrap; ///< See :ref:`WRAP <mapfile-label-wrap>`
-    int maxlength; ///< See :ref:`MAXLENGTH <mapfile-label-maxlength>`
-    double space_size_10; ///< Cached size of a single space character used for label text alignment of rfc40
-
-    /**
-    Minimum feature size (in pixels) to label, features of this size or greater will be 
-    labeled - see :ref:`MINFEATURESIZE  <mapfile-label-minfeaturesize>`
-    */
-    int minfeaturesize;
-    int autominfeaturesize; ///< :data:`MS_TRUE` or :data:`MS_FALSE`
-
-    double minscaledenom; ///< See :ref:`MINSCALEDENOM  <mapfile-label-minscaledenom>`
-    double maxscaledenom; ///< See :ref:`MAXSCALEDENOM  <mapfile-label-maxscaledenom>`
-
-    int mindistance; ///< Minimum distance in pixels between duplicate labels - see :ref:`MINDISTANCE <mapfile-label-mindistance>`
-    int repeatdistance; ///< See :ref:`REPEATDISTANCE <mapfile-label-repeatdistance>`
-    double maxoverlapangle; ///< See :ref:`MAXOVERLAPANGLE <mapfile-label-maxoverlapangle>`
-
-    /**
-    Indicates if labels can run off the edge of an image, either :data:`MS_TRUE` 
-    or :data:`MS_FALSE` (default) - see :ref:`PARTIALS <mapfile-label-partials>`
-    */
-    int partials;
-
-    int force; ///< Indicates if labels **must** be drawn - see :ref:`FORCE <mapfile-label-force>`
-
-    char *encoding; ///< Supported encoding format to be used for labels - see :ref:`ENCODING <mapfile-label-encoding>`
-
-    int priority; ///< Priority level 1 to :data:`MS_MAX_LABEL_PRIORITY`, default=1 - see :ref:`PRIORITY <mapfile-label-priority>`
-    int numstyles; ///< The number of styles associated with the label
-
-    int sizeunits; ///< Supersedes class's sizeunits, defaults to :data:`MS_INHERIT`.
-
-#ifndef SWIG
-    styleObj **styles;
-    int maxstyles;
-
-    expressionObj expression;
-    expressionObj text;
-
-    labelLeaderObj *leader;
-
-    attributeBindingObj bindings[MS_LABEL_BINDING_LENGTH];
-    int numbindings;
-    expressionObj exprBindings[MS_LABEL_BINDING_LENGTH];
-    int nexprbindings;
-
-    double scalefactor; // computed, not set
-#endif /* not SWIG */
-
-  };
-
-#ifdef SWIG
-#ifdef	__cplusplus
-extern "C" {
-#endif
-typedef struct labelObj labelObj;
-#ifdef	__cplusplus
-}
-#endif
-#endif
-
-#ifndef SWIG
-  /* lightweight structure containing information to render a labelObj */
-  typedef struct {
-    lineObj *poly;
-    rectObj bbox;
-  } label_bounds;
-
-  typedef struct {
-    labelObj *label;
-    char *annotext;
-    double scalefactor,resolutionfactor;
-    pointObj annopoint;
-    double rotation;
-    textPathObj *textpath;
-    //rectObj bbox;
-    label_bounds **style_bounds;
-  } textSymbolObj;
-#endif
-
-#define MS_LABEL_PERPENDICULAR_OFFSET -99
-#define MS_LABEL_PERPENDICULAR_TOP_OFFSET 99
-#define IS_PERPENDICULAR_OFFSET(offsety) ((offsety) == MS_LABEL_PERPENDICULAR_OFFSET || (offsety) == MS_LABEL_PERPENDICULAR_TOP_OFFSET)
-
-  /************************************************************************/
-  /*                          classObj                                    */
-  /************************************************************************/
-
-/**
- * The :ref:`CLASS <class>` object. Used for symbolization and classification information.
- *
- */
-  struct classObj {
-
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-    
-    hashTableObj metadata; ///< see :ref:`METADATA <mapfile-class-metadata>`
-    hashTableObj validation; ///< see :ref:`VALIDATION <mapfile-class-validation>`
-    int numstyles; ///< number of styles for class
-    int numlabels;  ///< number of labels for class
-    int refcount; ///< number of references to this object
-    struct layerObj *layer; ///< reference to the parent layer
-    labelLeaderObj *leader; ///< see :ref:`LEADER <mapfile-class-leader>`
-
-#ifdef SWIG
-    %mutable;
-#endif
-
-    int status; ///< :data:`MS_ON` or :data:`MS_OFF` - draw features of this class or do not - see :ref:`STATUS <mapfile-class-status>`
-    int isfallback; ///< :data:`MS_TRUE` or :data:`MS_FALSE` use :data:`MS_TRUE` if this class should be applied if and only if no other class is applicable
-    char *name; ///< See :ref:`NAME <mapfile-class-name>` should be unique within a layer
-    char *title; ///< See :ref:`TITLE <mapfile-class-title>`
-    double minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-class-minscaledenom>`
-    double maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-CLASS-maxscaledenom>`
-    int minfeaturesize; ///< See :ref:`MINFEATURESIZE <mapfile-class-minfeaturesize>` minimum feature size in pixels
-    int debug; ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`DEBUG <mapfile-class-debug>`
-    char *keyimage; ///< See :ref:`KEYIMAGE <mapfile-class-keyimage>`
-    char *group; ///< See :ref:`GROUP <mapfile-class-group>`
-    int sizeunits; ///< Supersedes layer's sizeunits and applies to all styles and labels - see :ref:`LAYER SIZEUNITS <mapfile-layer-sizeunits>`
-
-#ifndef __cplusplus
-    char *template; ///< See :ref:`TEMPLATE <mapfile-class-template>`
-#else /* __cplusplus */
-    char *_template; // keyword in cplusplus
-#endif /* __cplusplus */
-
-#ifndef SWIG
-    expressionObj text;
-    expressionObj expression; /* the expression to be matched */
-    labelObj **labels;
-    int maxlabels;
-    int maxstyles;
-    styleObj **styles;
-    double scalefactor; // computed, not set
-#endif /* not SWIG */
-
-  };
-
-  /************************************************************************/
-  /*                         labelCacheMemberObj                          */
-  /*                                                                      */
-  /*      structures to implement label caching and collision             */
-  /*      avoidance etc                                                   */
-  /*                                                                      */
-  /*        Note: These are scriptable, but are read only.                */
-  /************************************************************************/
-
-
-#ifdef SWIG
-  %immutable;
-#endif /* SWIG */
-  /**
-  An individual feature label. The labelCacheMemberObj class is associated with labelCacheObj.
-  */
-  typedef struct {
-    int numtextsymbols; ///< Number of text symbols found in textsymbols
-    int layerindex; ///< The index of the layer of the labelled feature
-    int classindex; ///< Index of the class of the labelled feature
-    int status; ///< Has this label been drawn or not?
-    int markerid;  ///< Corresponding marker (POINT layers only)
-
-    pointObj point; ///< Label point
-    rectObj bbox; ///< Bounds of the whole cachePtr. Individual text and symbol sub bounds are found in textsymbols
-
-    lineObj *leaderline; ///< Leader lineObj
-    rectObj *leaderbbox; ///< Leader rectObj
-
-#ifndef SWIG
-    textSymbolObj **textsymbols;
-#endif
-
-  } labelCacheMemberObj;
-
-  /************************************************************************/
-  /*                         markerCacheMemberObj                         */
-  /************************************************************************/
-  /**
-  An individual marker. The markerCacheMemberObj class is associated with labelCacheObj.
-  */
-  typedef struct {
-    int id; ///< Corresponding label
-    rectObj bounds; ///< Bounds of the markerCacheMemberObj
-  } markerCacheMemberObj;
-
-  /************************************************************************/
-  /*                          labelCacheSlotObj                           */
-  /************************************************************************/
-  /**
-  A cache slot to hold labels grouped by priority
-  */
-  typedef struct {
-    int numlabels; ///< Number of label members
-    int cachesize; ///< TODO
-    int nummarkers; ///< Number of marker members
-    int markercachesize; ///< TODO
-    labelCacheMemberObj *labels;
-    markerCacheMemberObj *markers;
-  } labelCacheSlotObj;
-
-  /************************************************************************/
-  /*                            labelCacheObj                             */
-  /************************************************************************/
-  /**
-  Set of a map's cached labels. Has no other existence other than as a labelcache
-  attribute of a mapObj. Associated with labelCacheMemberObj and markerCacheMemberObj.
-  */
-  typedef struct {
-    int num_rendered_members; ///< Number of rendered labels
-#ifndef SWIG
-    /* One labelCacheSlotObj for each priority level */
-    labelCacheSlotObj slots[MS_MAX_LABEL_PRIORITY];
-    int gutter; /* space in pixels around the image where labels cannot be placed */
-    labelCacheMemberObj **rendered_text_symbols;
-    int num_allocated_rendered_members;
-#endif
-  } labelCacheObj;
-
-  /************************************************************************/
-  /*                         resultObj                                    */
-  /************************************************************************/
-  /**
-  The result object is a handle, of sorts, for a feature of the layer
-  */
-  typedef struct {
-#ifndef SWIG
-      shapeObj* shape;
-#endif
-    long shapeindex; ///< The shape index of the result
-    int tileindex; ///< The tile index of the result
-    int resultindex; ///< The index of the result
-    int classindex; ///< The class index of the result
-  } resultObj;
-
-  /************************************************************************/
-  /*                            resultCacheObj                            */
-  /************************************************************************/
-  /**
-  A cached result object
-  */
-  typedef struct {
-
-#ifndef SWIG
-    resultObj *results;
-    int cachesize;
-    rectObj previousBounds; /* bounds at previous iteration */
-#endif /* not SWIG */
-
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-    int numresults; ///< Length of result set
-    rectObj bounds; ///< Bounding box of query results
-
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-  } resultCacheObj;
-
-
-  /************************************************************************/
-  /*                             symbolSetObj                             */
-  /************************************************************************/
-  /**
-  A :class:`symbolSetObj` is an attribute of a :class:`mapObj` and is associated with instances of :class:`symbolObj`.
-  */
-  typedef struct {
-#ifndef SWIG
-      int refcount;
-      symbolObj** symbol;
-      struct mapObj *map;
-      fontSetObj *fontset; /* a pointer to the main mapObj version */
-      struct imageCacheObj *imagecache;
-#endif /* not SWIG */
-
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-    int numsymbols; ///< Number of symbols in the set
-    int maxsymbols; ///< Maximum number of allowed symbols
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-
-    char *filename; ///< Symbolset filename
-    int imagecachesize; ///< Symbols in the cache
-
-  } symbolSetObj;
-
-  /************************************************************************/
-  /*                           referenceMapObj                            */
-  /************************************************************************/
-
-/**
-The :ref:`REFERENCE <reference>` object
-*/
-  typedef struct {
-#ifdef SWIG
-      %immutable;
-#endif /* SWIG */
-      struct mapObj *map; ///< Reference to parent :class:`mapObj`
-#ifdef SWIG
-      %mutable;
-#endif /* SWIG */
-    rectObj extent; ///< Spatial extent of reference in units of parent map - see :ref:`EXTENT <mapfile-reference-extent>`
-    int height; ///< Height of reference map in pixels - see :ref:`SIZE <mapfile-reference-size>`
-    int width; ///< Width of reference map in pixels - see :ref:`SIZE <mapfile-reference-size>`
-    colorObj color; ///< Color of reference box - see :ref:`COLOR <mapfile-reference-color>`
-    colorObj outlinecolor; ///< Outline color of reference box - see :ref:`OUTLINECOLOR <mapfile-reference-outlinecolor>`
-    char *image; ///< Filename of reference map image - see :ref:`IMAGE <mapfile-reference-image>`
-    int status; ///< :data:`MS_ON` or :data:`MS_OFF` - see :ref:`STATUS <mapfile-reference-status>`
-    int marker; ///< Index of a symbol in the map symbol set to use for marker - see :ref:`MARKER <mapfile-reference-marker>`
-    char *markername; ///< Name of a symbol - see :ref:`MARKER <mapfile-reference-marker>`
-    int markersize; ///< Size of marker - see :ref:`MARKERSIZE <mapfile-reference-markersize>`
-    int minboxsize; ///< In pixels - see :ref:`MINBOXSIZE <mapfile-reference-minboxsize>`
-    int maxboxsize; ///< In pixels - see :ref:`MAXBOXSIZE <mapfile-reference-maxboxsize>`
-  } referenceMapObj;
-
-  /************************************************************************/
-  /*                             scalebarObj                              */
-  /************************************************************************/
-
-  #define MS_SCALEBAR_INTERVALS_MIN 1
-  #define MS_SCALEBAR_INTERVALS_MAX 100
-
-  #define MS_SCALEBAR_WIDTH_MIN 5
-  #define MS_SCALEBAR_WIDTH_MAX 1000
-  #define MS_SCALEBAR_HEIGHT_MIN 2
-  #define MS_SCALEBAR_HEIGHT_MAX 100
-
-  #define MS_SCALEBAR_OFFSET_MIN -50
-  #define MS_SCALEBAR_OFFSET_MAX 50
-  
-  /**
-  The :ref:`SCALEBAR <scalebar>` object
-  */
-  typedef struct {
-
-     int transparent; ///< Allows transparency for an embedded scalebar - see :ref:`TRANSPARENT <mapfile-scalebar-transparent>`
-     colorObj imagecolor; ///< Background color of scalebar - see :ref:`IMAGECOLOR <mapfile-scalebar-imagecolor>`
-      int height; ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
-      int width; ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
-      int style; ///< 0 or 1 - see :ref:`STYLE <mapfile-scalebar-style>`
-      int intervals; ///< Number of intervals - see :ref:`INTERVALS <mapfile-scalebar-intervals>`
-      labelObj label; ///< Scalebar label - see :ref:`LABEL <mapfile-scalebar-label>`
-      colorObj color; ///< Scalebar foreground color - see :ref:`COLOR <mapfile-scalebar-color>`
-      colorObj backgroundcolor; ///< Scalebar background color - see :ref:`BACKGROUNDCOLOR <mapfile-scalebar-backgroundcolor>`
-      colorObj outlinecolor; ///< Foreground outline color - see :ref:`OUTLINECOLOR <mapfile-scalebar-outlinecolor>`
-      int units; ///< See :ref:`UNITS <mapfile-scalebar-units>`
-      int status; ///< ON, OFF or EMBED - see :ref:`STATUS <mapfile-scalebar-status>` - :data:`MS_ON`, :data:`MS_OFF`, or :data:`MS_EMBED`.
-      int position; ///< For embeded scalebars - see :ref:`POSITION <mapfile-scalebar-position>` - 
-                    ///< :data:`MS_UL`, :data:`MS_UC`, :data:`MS_UR`, :data:`MS_LL`, :data:`MS_LC`, or :data:`MS_LR`
-
-      int postlabelcache; ///< See :ref:`POSTLABELCACHE <mapfile-scalebar-postlabelcache>` - :data:`MS_TRUE` or :data:`MS_FALSE`
-      int align; ///< See :ref:`ALIGN <mapfile-scalebar-align>`
-      int offsetx; ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
-      int offsety; ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
-  } scalebarObj;
-
-  /************************************************************************/
-  /*                              legendObj                               */
-  /************************************************************************/
-
-  #define MS_LEGEND_KEYSIZE_MIN 5
-  #define MS_LEGEND_KEYSIZE_MAX 200
-  #define MS_LEGEND_KEYSPACING_MIN 0
-  #define MS_LEGEND_KEYSPACING_MAX 50
-
-  /**
-  The :ref:`LEGEND <legend>` object
-  */
-  typedef struct {
-
-#ifdef SWIG
-    %immutable;
-#endif
-    labelObj label; ///< See :ref:`LABEL <mapfile-legend-label>`
-    struct mapObj *map; ///< Instances of legendObj are always are always embedded inside the mapObj
-#ifdef SWIG
-    %mutable;
-#endif
-    int transparent; ///< Allows transparency for an embedded legend - see :ref:`TRANSPARENT <mapfile-legend-transparent>`
-    colorObj imagecolor; ///< Legend background color - see :ref:`IMAGECOLOR <mapfile-legend-imagecolor>`
-    int keysizex; ///< Width in pixels of legend keys - see :ref:`KEYSIZE <mapfile-legend-keysize>`
-    int keysizey; ///< Height in pixels of legend keys - see :ref:`KEYSIZE <mapfile-legend-keysize>`
-    int keyspacingx; ///< Horizontal padding around keys in pixels - see :ref:`KEYSPACING <mapfile-legend-keyspacing>`
-    int keyspacingy; ///< Vertical padding around keys in pixels - see :ref:`KEYSPACING <mapfile-legend-keyspacing>`
-    colorObj outlinecolor; ///< Key outline color, -1 for no outline - see :ref:`OUTLINECOLOR <mapfile-legend-outlinecolor>`
-    int status; ///< :data:`MS_ON`, :data:`MS_OFF` or :data:`MS_EMBED`- see :ref:`STATUS <mapfile-legend-status>`
-    int height; ///< Legend height
-    int width; ///< Legend width
-    int position; ///< Used for embedded legends, see :ref:`POSITION  <mapfile-legend-position>`
-    int postlabelcache; ///< :data:`MS_TRUE`, :data:`MS_FALSE` - see :ref:`POSTLABELCACHE  <mapfile-legend-postlabelcache>`
-#ifndef __cplusplus
-    char *template; ///< See :ref:`TEMPLATE <mapfile-legend-template>`
-#else /* __cplusplus */
-    char *_template;
-#endif /* __cplusplus */
-  } legendObj;
-
-  /************************************************************************/
-  /*                             graticuleObj                             */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    double    dwhichlatitude;
-    double    dwhichlongitude;
-    double    dstartlatitude;
-    double    dstartlongitude;
-    double    dendlatitude;
-    double    dendlongitude;
-    double    dincrementlatitude;
-    double    dincrementlongitude;
-    double    minarcs;
-    double    maxarcs;
-    double    minincrement;
-    double    maxincrement;
-    double    minsubdivides;
-    double    maxsubdivides;
-    int     bvertical;
-    int     blabelaxes;
-    int     ilabelstate;
-    int     ilabeltype;
-    rectObj   extent;
-    lineObj   *pboundinglines;
-    pointObj  *pboundingpoints;
-    char    *labelformat;
-  } graticuleObj;
-
-  typedef struct {
-    int nTop;
-    pointObj *pasTop;
-    char  **papszTopLabels;
-    int nBottom;
-    pointObj *pasBottom;
-    char  **papszBottomLabels;
-    int nLeft;
-    pointObj *pasLeft;
-    char  **papszLeftLabels;
-    int nRight;
-    pointObj *pasRight;
-    char  **papszRightLabels;
-
-  } graticuleIntersectionObj;
-
-  struct layerVTable;
-  typedef struct layerVTable layerVTableObj;
-
-#endif /*SWIG*/
-
-  /************************************************************************/
-  /*                               imageObj                               */
-  /************************************************************************/
-
-/**
- * An image object is a wrapper for images generated by MapServer. 
- *
- */
-  struct imageObj{
-#ifdef SWIG
-    %immutable;
-#endif
-    int width; ///< image width in pixels
-    int height; ///< image height in pixels
-    double resolution; ///< image resolution in pixels per inch
-    double resolutionfactor; ///< resolution factor
-
-    char *imagepath; ///< if image is drawn by :func:`mapObj.draw` this is :ref:`IMAGEPATH <mapfile-web-imagepath>`
-    char *imageurl; ///< if image is drawn by :func:`mapObj.draw` this is :ref:`IMAGEURL <mapfile-web-imageurl>`
-    outputFormatObj *format; ///< an :class:`outputFormatObj` representing the output format of the image
-
-#ifndef SWIG
-    tileCacheObj *tilecache;
-    int ntiles;
-    int size;
-#endif
-#ifdef SWIG
-    %mutable;
-#endif
-
-#ifndef SWIG
-    union {
-      void *plugin;
-
-      char *imagemap;
-      short *raw_16bit;
-      float *raw_float;
-      unsigned char *raw_byte;
-    } img;
-    ms_bitarray  img_mask;
-    pointObj refpt;
-    mapObj *map;
-#endif
-  };
-
-  /************************************************************************/
-  /*                               layerObj                               */
-  /*                                                                      */
-  /*      base unit of a map.                                             */
-  /************************************************************************/
-
-  /**
-  An individual value within the :ref:`SCALETOKEN <mapfile-layer-scaletoken>` object
-  */
-  typedef struct {
-    double minscale; ///< The minimum scale for the replacement
-    double maxscale; ///< The maximum scale for the replacement
-    char *value; ///< The token replacement value
-  } scaleTokenEntryObj;
-
-  /**
-  The :ref:`SCALETOKEN <mapfile-layer-scaletoken>` object
-  */
-  typedef struct {
-     char *name; ///< The name of the token to replace in the :ref:`DATA <mapfile-layer-data>` statement
-     int n_entries; ///< The number of values within the scaletoken
-     scaleTokenEntryObj *tokens; ///< A reference to the values
-  } scaleTokenObj;
-
-#ifndef SWIG
-  typedef enum {
-      SORT_ASC,
-      SORT_DESC
-  } sortOrderEnum;
-
-  typedef struct {
-      char* item;
-      sortOrderEnum sortOrder;
-  } sortByProperties;
-
-  typedef struct {
-      int nProperties;
-      sortByProperties* properties;
-  } sortByClause;
-
-  typedef struct {
-    /* The following store original members if they have been modified at runtime by a rfc86 scaletoken */
-    char *data;
-    char *tileitem;
-    char *tileindex;
-    char *filteritem;
-    char *filter;
-    char **processing;
-    int *processing_idx;
-    int n_processing;
-  } originalScaleTokenStrings;
-#endif
-
-  /**
-  The :ref:`LAYER <layer>` object
-  */
-  struct layerObj {
-
-#ifndef SWIG
-    /* RFC86 Scale-dependent token replacements */
-    scaleTokenObj *scaletokens;
-    int numscaletokens;
-    originalScaleTokenStrings *orig_st;
-    int labelitemindex;
-
-    int tileitemindex;
-    projectionObj projection; /* projection information for the layer */
-    int project; /* boolean variable, do we need to project this layer or not */
-    reprojectionObj* reprojectorLayerToMap;
-    reprojectionObj* reprojectorMapToLayer;
-
-    featureListNodeObjPtr features; /* linked list so we don't need a counter */
-    featureListNodeObjPtr currentfeature; /* pointer to the current feature */
-
-    layerVTableObj *vtable;
-
-    /* SDL has converted OracleSpatial, SDE, Graticules */
-    void *layerinfo; /* all connection types should use this generic pointer to a vendor specific structure */
-    void *wfslayerinfo; /* For WFS layers, will contain a msWFSLayerInfo struct */
-
-    char **items;
-    void *iteminfo; /* connection specific information necessary to retrieve values */
-    expressionObj filter; /* connection specific attribute filter */
-    int bandsitemindex;
-    int filteritemindex;
-    int styleitemindex;
-
-    char **processing;
-    joinObj *joins;
-
-    imageObj *maskimage;
-    graticuleObj* grid;
-    expressionObj _geomtransform;
-    sortByClause sortBy;
-
-#endif
-
-#ifndef SWIG
-    int classitemindex;
-    resultCacheObj *resultcache; /* holds the results of a query against this layer */
-    double scalefactor; /* computed, not set */
-#ifndef __cplusplus
-    classObj **class; /* always at least 1 class */
-#else /* __cplusplus */
-    classObj **_class;
-#endif /* __cplusplus */
-#endif /* not SWIG */
-
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-    int refcount; ///< reference counting, RFC24
-    int numclasses; ///< Number of layer classes
-    int maxclasses; ///< Used to track of the maximum number of classes - see RFC-17
-    int index; ///< Index of layer within parent map's layers array
-    struct mapObj *map; ///< Reference to parent map
-    int numitems; ///< Number of layer feature attributes (items)
-    hashTableObj metadata; ///< See :ref:`METADATA <mapfile-layer-metadata>`
-    hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-layer-validation>`
-    hashTableObj bindvals; ///< Relates to RFC59
-    hashTableObj connectionoptions; ///< See :ref:`CONNECTIONOPTIONS <mapfile-layer-connectionoptions>`
-
-    clusterObj cluster; ///< See :ref:`CLUSTER <mapfile-layer-cluster>`
-    rectObj extent; ///< optional limiting extent for layer features - see :ref:`EXTENT <mapfile-layer-extent>`
-    int numprocessing; ///< Number of raster processing directives
-    int numjoins; ///< Number of layer joins
-
-    expressionObj utfdata; ///< See :ref:`UTFDATA <mapfile-layer-utfdata>`
-    LayerCompositer *compositer; ///< See :ref:`COMPOSITE <mapfile-layer-composite>`
-
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-
-    char *classitem; ///< the attribute used to classify layer data - see :ref:`CLASSITEM <mapfile-layer-classitem>`
-    char *header; ///< filename to a template for result's header - see :ref:`HEADER <mapfile-layer-header>`
-    char *footer; ///< filename to a template for result's footer - see :ref:`FOOTER <mapfile-layer-footer>`
-
-#ifndef __cplusplus
-    char *template; ///< See :ref:`TEMPLATE <mapfile-layer-template>` - global template, used across all classes
-#else /* __cplusplus */
-    char *_template;
-#endif /* __cplusplus */
-
-    char *name; ///< See :ref:`NAME <mapfile-layer-name>` - should be unique
-    char *group; ///< Name of a group of layers - see :ref:`GROUP <mapfile-layer-group>`
-    int status; ///< See :ref:`STATUS <mapfile-layer-status>`:data:`MS_ON`, :data:`MS_OFF` or :data:`MS_DEFAULT`
-    enum MS_RENDER_MODE rendermode; ///< :data:`MS_FIRST_MATCHING_CLASS` - default and historic MapServer behavior, :data:`MS_ALL_MATCHING_CLASSES` - SLD behavior
-    char *data; ///< Layer data definition, values depend upon connectiontype - see :ref:`DATA <mapfile-layer-data>`
-    enum MS_LAYER_TYPE type; ///< the layer type - see :ref:`TYPE <mapfile-layer-type>`
-    enum MS_CONNECTION_TYPE connectiontype; ///< the layer connection type - see :ref:`CONNECTIONTYPE <mapfile-layer-connectiontype>`
-
-    double tolerance; ///< search buffer for point and line queries (in toleranceunits) - see :ref:`TOLERANCE <mapfile-layer-tolerance>`
-    int toleranceunits; ///< See :ref:`TOLERANCEUNITS <mapfile-layer-toleranceunits>`
-
-    double symbolscaledenom; ///< scale at which symbols are default size - see :ref:`SYMBOLSCALEDENOM <mapfile-layer-symbolscaledenom>`
-    double minscaledenom; ///< Maximum scale at which layer will be drawn - see :ref:`MINSCALEDENOM <mapfile-layer-minscaledenom>`
-    double maxscaledenom; ///< Minimum scale at which layer will be drawn - see :ref:`MAXSCALEDENOM <mapfile-layer-maxscaledenom>`
-    int minfeaturesize; ///< minimum feature size (in pixels) for shape
-    double labelminscaledenom; ///< See :ref:`LABELMINSCALEDENOM <mapfile-layer-labelminscaledenom>`
-    double labelmaxscaledenom; ///< See :ref:`LABELMAXSCALEDENOM <mapfile-layer-labelmaxscaledenom>`
-    double mingeowidth; ///< min map width (in map units) at which the layer should be drawn - see :ref:`MAXGEOWIDTH <mapfile-layer-maxgeowidth>`
-    double maxgeowidth; ///< max map width (in map units) at which the layer should be drawn - see :ref:`MAXGEOWIDTH <mapfile-layer-maxgeowidth>`
-
-    int sizeunits; ///< applies to all classes - see :ref:`SIZEUNITS <mapfile-layer-sizeunits>`
-
-    int maxfeatures; ///< Maximum number of layer features that will be drawn - see :ref:`MAXFEATURES <mapfile-layer-maxfeatures>`
-    int startindex; ///< Feature start index - used for paging
-
-    colorObj offsite; ///< transparent pixel value for raster images - see :ref:`OFFSITE <mapfile-layer-offsite>`
-
-    /**
-    :data:`MS_TRUE` (default) or :data:`MS_FALSE` whether or not layer data is to be transformed to 
-    image units - see :ref:`TRANSFORM <mapfile-layer-transform>`
-    */
-    int transform;
-
-    int labelcache; ///< :data:`MS_ON` (default) or :data:`MS_OFF` - see :ref:`LABELCACHE <mapfile-layer-labelcache>`
-    int postlabelcache; ///< :data:`MS_ON` or :data:`MS_OFF` (default) - see :ref:`POSTLABELCACHE <mapfile-layer-postlabelcache>`
-
-    char *labelitem; ///< attribute defining feature label text - see :ref:`LABELITEM <mapfile-layer-labelitem>`
-    char *tileitem; ///< attribute defining tile paths - see :ref:`TILEITEM <mapfile-layer-tileitem>`
-    char *tileindex; ///< layer index file for tiling support - see :ref:`TILEINDEX <mapfile-layer-tileindex>`
-    char *tilesrs; ///< name of the attribute that contains the SRS of an individual tile - see :ref:`TILESRS <mapfile-layer-tilesrs>`
-    int units; ///< units of the layer - see :ref:`UNITS <mapfile-layer-units>`
-
-    char *connection; ///< layer connection or data source name - see :ref:`CONNECTION <mapfile-layer-connection>`
-    char *plugin_library; ///< Used to select the library to load by MapServer
-    char *plugin_library_original; ///< this is needed for Mapfile writing
-
-    /**
-    The attribute from the index file used to select the source raster band(s) to be 
-    used - normally NULL for default bands processing
-    */
-    char *bandsitem;
-
-    char *filteritem; ///< Attribute defining filter - see :ref:`FILTERITEM <mapfile-layer-filteritem>`
-    char *styleitem; ///< item to be used for style lookup - can also be 'AUTO' - see :ref:`STYLEITEM <mapfile-layer-styleitem>`
-
-    char *requires; ///< Context expressions, simple enough to not use expressionObj - see :ref:`REQUIRES <mapfile-layer-requires>`
-    char *labelrequires;  ///< Simple logical expression - see :ref:`LABELREQUIRES <mapfile-layer-labelrequires>`
-
-    int debug; ///< Enable debugging of layer-  :data:`MS_ON` or :data:`MS_OFF` (default) - see :ref:`DEBUG <mapfile-layer-debug>`
-    char *classgroup; ///< See :ref:`CLASSGROUP <mapfile-layer-classgroup>`
-    char *mask; ///< See :ref:`MASK <mapfile-layer-mask>`
-    char *encoding; ///< For iconving shape attributes, ignored if NULL or "utf-8" - see :ref:`ENCODING <mapfile-layer-encoding>`
-
-    /* RFC93 UTFGrid support */
-    char *utfitem; ///< See :ref:`UTFITEM <mapfile-layer-utfitem>`
-    int utfitemindex; ///< See :ref:`CLASSITEM <mapfile-layer-classitem>`
-  };
-
-
-#ifndef SWIG
-void msFontCacheSetup();
-void msFontCacheCleanup();
-
-typedef struct {
-  double minx,miny,maxx,maxy,advance;
-} glyph_metrics;
-
-typedef struct {
-  glyph_element *glyph;
-  face_element *face;
-  pointObj pnt;
-  double rot;
-} glyphObj;
-
-struct textPathObj{
-  int numglyphs;
-  int numlines;
-  int line_height;
-  int glyph_size;
-  int absolute; /* are the glyph positions absolutely placed, or relative to the origin */
-  glyphObj *glyphs;
-  label_bounds bounds;
-};
-
-typedef enum {
-  duplicate_never,
-  duplicate_always,
-  duplicate_if_needed
-} label_cache_mode;
-
-void initTextPath(textPathObj *tp);
-int WARN_UNUSED msComputeTextPath(mapObj *map, textSymbolObj *ts);
-void msCopyTextPath(textPathObj *dst, textPathObj *src);
-void freeTextPath(textPathObj *tp);
-void initTextSymbol(textSymbolObj *ts);
-void freeTextSymbol(textSymbolObj *ts);
-void freeTextSymbolEx(textSymbolObj *ts, int doFreeLabel);
-void copyLabelBounds(label_bounds *dst, label_bounds *src);
-void msCopyTextSymbol(textSymbolObj *dst, textSymbolObj *src);
-void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l, char *string, double scalefactor, double resolutionfactor, label_cache_mode cache);
-#endif /* SWIG */
-
-
-  /************************************************************************/
-  /*                                mapObj                                */
-  /*                                                                      */
-  /*      encompasses everything used in an Internet mapping              */
-  /*      application.                                                    */
-  /************************************************************************/
-
-  #define MS_RESOLUTION_MAX 1000 /* applies to resolution and defresolution */
-  #define MS_RESOLUTION_MIN 10
-
-  /**
-  The :ref:`MAP <map>` object
-  */
-  struct mapObj { /* structure for a map */
-
-#ifndef SWIG
-      layerObj **layers;
-      geotransformObj gt; /* rotation / geotransform */
-      rectObj saved_extent;
-      paletteObj palette; /* holds a map palette */
-      outputFormatObj **outputformatlist;
-      projectionObj projection; /* projection information for output map */
-      projectionObj latlon; /* geographic projection definition */
-
-      /* Private encryption key information - see mapcrypto.c */
-      int encryption_key_loaded;        /* MS_TRUE once key has been loaded */
-      unsigned char encryption_key[MS_ENCRYPTION_KEY_SIZE]; /* 128bits encryption key */
-      queryObj query;
-      projectionContext* projContext;
-
-#endif /* SWIG */
-
-#ifdef SWIG
-      %immutable;
-#endif /* SWIG */
-      int refcount; ///< Used for reference counting see RFC24
-      int numlayers; ///< Number of layers in mapfile
-      int maxlayers; ///< Allocated size of layers[] array
-
-      /**
-      A hash table of configuration options from CONFIG keywords 
-      in the map - see :ref:`CONFIG <mapfile-map-config>`
-      */
-      hashTableObj configoptions;
-
-      symbolSetObj symbolset; ///< See :ref:`SYMBOLSET <mapfile-map-symbolset>`
-      fontSetObj fontset; ///< See :ref:`FONTSET <mapfile-map-fontset>`
-
-      labelCacheObj labelcache; ///< We need this here so multiple feature processors can access it
-      int numoutputformats; ///< Number of output formats available in the map
-      outputFormatObj *outputformat; ///< See :ref:`OUTPUTFORMAT <mapfile-map-outputformat>`
-      char *imagetype; ///< Name of current outputformat
-
-      referenceMapObj reference; ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
-      scalebarObj scalebar; ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
-      legendObj legend; ///< See :ref:`LEGEND <mapfile-map-legend>`
-      queryMapObj querymap; ///< See :ref:`QUERYMAP <mapfile-map-querymap>`
-      webObj web; ///< See :ref:`WEB <mapfile-map-web>`
-
-      const configObj *config;
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-
-    char *datapattern; ///< TODO - Deprecated use VALIDATION ... END block instead
-    char *templatepattern; ///< TODO - Deprecated use VALIDATION ... END block instead
-
-    char *name; ///< Small identifier for naming etc - see :ref:`NAME <mapfile-map-name>`
-    int status;  ///< Is map creation on or off - see :ref:`STATUS <mapfile-map-status>`
-    int height; ///< See :ref:`SIZE <mapfile-map-size>`
-    int width; ///< See :ref:`SIZE <mapfile-map-size>`
-    int maxsize; ///< See :ref:`MAXSIZE  <mapfile-map-maxsize>`
-
-    rectObj extent; ///< Map extent array - see :ref:`EXTENT <mapfile-map-extent>`
-    double cellsize; ///< Pixel size in map units
-
-    enum MS_UNITS units; ///< Units of the projection - see :ref:`UNITS <mapfile-map-units>`
-    double scaledenom; ///< The nominal map scale, a value of 25000 means 1:25000 scale - see :ref:`SCALEDENOM  <mapfile-map-scaledenom>`
-    double resolution; ///< See :ref:`RESOLUTION <mapfile-map-resolution>`
-    double defresolution; ///< Default resolution - used to calculate the scalefactor, see :ref:`DEFRESOLUTION <mapfile-map-defresolution>`
-
-    char *shapepath; ///< Where are the shape files located - see :ref:`SHAPEPATH <mapfile-map-shapepath>`
-    char *mappath; ///< Path of the mapfile, all paths are relative to this path
-
-    /**
-    URL of SLD document as specified with "&SLD=..." WMS parameter d- currently this reference is 
-    used only in mapogcsld.c and has a NULL value outside that context
-    */
-    char *sldurl;
-
-    colorObj imagecolor; ///< Holds the initial image color value - see :ref:`IMAGECOLOR <mapfile-map-imagecolor>`
-
-    int *layerorder; ///< Used to modify the order in which the layers are drawn - TODO should be immutable?
-    int debug; ///< See :ref:`DEBUG <mapfile-map-debug>`
-
-#ifdef USE_V8_MAPSCRIPT
-    void *v8context;
-#endif
-
-  };
-
-  /************************************************************************/
-  /*                             layerVTable                              */
-  /*                                                                      */
-  /*      contains function pointers to the layer operations.  If you     */
-  /*      add new functions to here, remember to update                   */
-  /*      populateVirtualTable in maplayer.c                              */
-  /************************************************************************/
-#ifndef SWIG
-  struct layerVTable {
-    int (*LayerTranslateFilter)(layerObj *layer, expressionObj *filter, char *filteritem);
-    int (*LayerSupportsCommonFilters)(layerObj *layer);
-    int (*LayerInitItemInfo)(layerObj *layer);
-    void (*LayerFreeItemInfo)(layerObj *layer);
-    int (*LayerOpen)(layerObj *layer);
-    int (*LayerIsOpen)(layerObj *layer);
-    int (*LayerWhichShapes)(layerObj *layer, rectObj rect, int isQuery);
-    int (*LayerNextShape)(layerObj *layer, shapeObj *shape);
-    int (*LayerGetShape)(layerObj *layer, shapeObj *shape, resultObj *record);
-    int (*LayerGetShapeCount)(layerObj *layer, rectObj rect, projectionObj *rectProjection);
-    int (*LayerClose)(layerObj *layer);
-    int (*LayerGetItems)(layerObj *layer);
-    int (*LayerGetExtent)(layerObj *layer, rectObj *extent);
-    int (*LayerGetAutoStyle)(mapObj *map, layerObj *layer, classObj *c, shapeObj *shape);
-    int (*LayerCloseConnection)(layerObj *layer);
-    int (*LayerSetTimeFilter)(layerObj *layer, const char *timestring, const char *timefield);
-    int (*LayerApplyFilterToLayer)(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
-    int (*LayerCreateItems)(layerObj *layer, int nt);
-    int (*LayerGetNumFeatures)(layerObj *layer);
-    int (*LayerGetAutoProjection)(layerObj *layer, projectionObj *projection);
-    char* (*LayerEscapeSQLParam)(layerObj *layer, const char* pszString);
-    char* (*LayerEscapePropertyName)(layerObj *layer, const char* pszString);
-    void (*LayerEnablePaging)(layerObj *layer, int value);
-    int (*LayerGetPaging)(layerObj *layer);
-  };
-#endif /*SWIG*/
-
-  /* Function prototypes, wrapable */
-
-  /**
-  Saves a map image to a file
-  */
-  MS_DLL_EXPORT int msSaveImage(mapObj *map, imageObj *img, const char *filename); 
-
-  /**
-  Generic function to free a imageObj
-  */
-  MS_DLL_EXPORT void msFreeImage(imageObj *img);
-
-  /**
-  Sets up threads and font cache - called when MapScript is initialised
-  */
-  MS_DLL_EXPORT int msSetup(void);
-
-  /**
-  Attempts to recover all dynamically allocated resources allocated by MapServer code and
-  dependent libraries. It is used primarily for final clean-up in scripts that need to do
-  memory leak testing to get rid of "noise" one-time allocations.
-  It should not normally be used by production code.
-  */
-  MS_DLL_EXPORT void msCleanup(void);
-
-  /**
-  Sets up string-based mapfile loading and calls loadMapInternal to do the work
-  */
-  MS_DLL_EXPORT mapObj *msLoadMapFromString(char *buffer, char *new_mappath, const configObj* config);
-
-  /* Function prototypes, not wrapable */
-
-#ifndef SWIG
-
-  /*
-  ** helper functions not part of the general API but needed in
-  ** a few other places (like mapscript)... found in mapfile.c
-  */
-  int getString(char **s);
-  int getDouble(double *d, int num_check_type, double value1, double value2); // getDouble(double *d);
-  int getInteger(int *i, int num_check_type, int value1, int value2); // getInteger(int *i);
-  int getSymbol(int n, ...);
-  int getCharacter(char *c);
-
-  int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map);
-
-  MS_DLL_EXPORT int  hex2int(char *hex);
-
-  MS_DLL_EXPORT void initJoin(joinObj *join);
-  MS_DLL_EXPORT void initSymbol(symbolObj *s);
-  MS_DLL_EXPORT int initMap(mapObj *map);
-  MS_DLL_EXPORT layerObj *msGrowMapLayers( mapObj *map );
-  MS_DLL_EXPORT int initLayer(layerObj *layer, mapObj *map);
-  MS_DLL_EXPORT int freeLayer( layerObj * );
-  MS_DLL_EXPORT classObj *msGrowLayerClasses( layerObj *layer );
-  MS_DLL_EXPORT scaleTokenObj *msGrowLayerScaletokens( layerObj *layer );
-  MS_DLL_EXPORT int initScaleToken(scaleTokenObj *scaleToken);
-  MS_DLL_EXPORT int initClass(classObj *_class);
-  MS_DLL_EXPORT int freeClass( classObj * );
-  MS_DLL_EXPORT styleObj *msGrowClassStyles( classObj *_class );
-  MS_DLL_EXPORT labelObj *msGrowClassLabels( classObj *_class );
-  MS_DLL_EXPORT styleObj *msGrowLabelStyles( labelObj *label );
-  MS_DLL_EXPORT styleObj *msGrowLeaderStyles( labelLeaderObj *leader );
-  MS_DLL_EXPORT int msMaybeAllocateClassStyle(classObj* c, int idx);
-  MS_DLL_EXPORT void initLabel(labelObj *label);
-  MS_DLL_EXPORT int  freeLabel(labelObj *label);
-  MS_DLL_EXPORT int  freeLabelLeader(labelLeaderObj *leader);
-  MS_DLL_EXPORT void resetClassStyle(classObj *_class);
-  MS_DLL_EXPORT int initStyle(styleObj *style);
-  MS_DLL_EXPORT int freeStyle(styleObj *style);
-  MS_DLL_EXPORT void initReferenceMap(referenceMapObj *ref);
-  MS_DLL_EXPORT void initScalebar(scalebarObj *scalebar);
-  MS_DLL_EXPORT void initGrid( graticuleObj *pGraticule );
-  MS_DLL_EXPORT void initWeb(webObj *web);
-  MS_DLL_EXPORT void freeWeb(webObj *web);
-  MS_DLL_EXPORT void initResultCache(resultCacheObj *resultcache);
-  void cleanupResultCache(resultCacheObj *resultcache);
-  MS_DLL_EXPORT int initLayerCompositer(LayerCompositer *compositer);
-  MS_DLL_EXPORT void initLeader(labelLeaderObj *leader);
-  MS_DLL_EXPORT void freeGrid( graticuleObj *pGraticule);
-  int loadHashTable(hashTableObj *ptable); // used by other file loading code
-
-  MS_DLL_EXPORT featureListNodeObjPtr insertFeatureList(featureListNodeObjPtr *list, shapeObj *shape);
-  MS_DLL_EXPORT void freeFeatureList(featureListNodeObjPtr list);
-
-  /* To be used *only* within the mapfile loading phase */
-  MS_DLL_EXPORT int loadExpressionString(expressionObj *exp, char *value);
-  /* Use this next, thread safe wrapper, function everywhere else */
-  MS_DLL_EXPORT int msLoadExpressionString(expressionObj *exp, char *value);
-  MS_DLL_EXPORT char *msGetExpressionString(expressionObj *exp);
-  MS_DLL_EXPORT void msInitExpression(expressionObj *exp);
-  MS_DLL_EXPORT void msFreeExpressionTokens(expressionObj *exp);
-  MS_DLL_EXPORT void msFreeExpression(expressionObj *exp);
-
-  MS_DLL_EXPORT void msApplySubstitutions(mapObj *map, char **names, char **values, int npairs);
-  MS_DLL_EXPORT void msApplyDefaultSubstitutions(mapObj *map);
-
-  MS_DLL_EXPORT int getClassIndex(layerObj *layer, char *str);
-
-  /* For maplabel */
-  int intersectLabelPolygons(lineObj *p1, rectObj *r1, lineObj *p2, rectObj *r2);
-  int intersectTextSymbol(textSymbolObj *ts, label_bounds *lb);
-  pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy, double rotation, int buffer, label_bounds *metrics);
-  double dist(pointObj a, pointObj b);
-  void fastComputeBounds(lineObj *line, rectObj *bounds);
-
-  /*
-  ** Main API Functions
-  */
-
-  /* mapobject.c */
-
-  MS_DLL_EXPORT void msFreeMap(mapObj *map);
-  MS_DLL_EXPORT mapObj *msNewMapObj(void);
-  MS_DLL_EXPORT const char *msGetConfigOption( mapObj *map, const char *key);
-  MS_DLL_EXPORT int msSetConfigOption( mapObj *map, const char *key, const char *value);
-  MS_DLL_EXPORT int msTestConfigOption( mapObj *map, const char *key,
-                                        int default_result );
-  MS_DLL_EXPORT void msApplyMapConfigOptions( mapObj *map );
-  MS_DLL_EXPORT int msMapComputeGeotransform( mapObj *map );
-  int msMapComputeGeotransformEx( mapObj * map, double resolutionX, double resolutionY );
-
-  MS_DLL_EXPORT void msMapPixelToGeoref( mapObj *map, double *x, double *y );
-  MS_DLL_EXPORT void msMapGeorefToPixel( mapObj *map, double *x, double *y );
-
-  MS_DLL_EXPORT int msMapSetExtent(mapObj *map, double minx, double miny,
-                                   double maxx, double maxy);
-  MS_DLL_EXPORT int msMapOffsetExtent( mapObj *map, double x, double y);
-  MS_DLL_EXPORT int msMapScaleExtent( mapObj *map, double zoomfactor,
-                                      double minscaledenom, double maxscaledenom);
-  MS_DLL_EXPORT int msMapSetCenter( mapObj *map, pointObj *center);
-  MS_DLL_EXPORT int msMapSetRotation( mapObj *map, double rotation_angle );
-  MS_DLL_EXPORT int msMapSetSize( mapObj *map, int width, int height );
-  MS_DLL_EXPORT int msMapSetSize( mapObj *map, int width, int height );
-  MS_DLL_EXPORT int msMapSetFakedExtent( mapObj *map );
-  MS_DLL_EXPORT int msMapRestoreRealExtent( mapObj *map );
-  MS_DLL_EXPORT int msMapLoadOWSParameters( mapObj *map, cgiRequestObj *request,
-      const char *wmtver_string );
-  MS_DLL_EXPORT int msMapIgnoreMissingData( mapObj *map );
-
-  /* mapfile.c */
-
-  MS_DLL_EXPORT int msValidateParameter(const char *value, const char *pattern1, const char *pattern2, const char *pattern3, const char *pattern4);
-  MS_DLL_EXPORT int msGetLayerIndex(mapObj *map, const char *name);
-  MS_DLL_EXPORT int msGetSymbolIndex(symbolSetObj *set, char *name, int try_addimage_if_notfound);
-  MS_DLL_EXPORT mapObj  *msLoadMap(const char *filename, const char *new_mappath, const configObj *config);
-  MS_DLL_EXPORT int msTransformXmlMapfile(const char *stylesheet, const char *xmlMapfile, FILE *tmpfile);
-  MS_DLL_EXPORT int msSaveMap(mapObj *map, char *filename);
-  MS_DLL_EXPORT int msSaveConfig(configObj *map, const char *filename);
-  MS_DLL_EXPORT void msFreeCharArray(char **array, int num_items);
-  MS_DLL_EXPORT int msUpdateScalebarFromString(scalebarObj *scalebar, char *string);
-  MS_DLL_EXPORT int msUpdateQueryMapFromString(queryMapObj *querymap, char *string);
-  MS_DLL_EXPORT int msUpdateLabelFromString(labelObj *label, char *string);
-  MS_DLL_EXPORT int msUpdateClusterFromString(clusterObj *cluster, char *string);
-  MS_DLL_EXPORT int msUpdateReferenceMapFromString(referenceMapObj *ref, char *string);
-  MS_DLL_EXPORT int msUpdateLegendFromString(legendObj *legend, char *string);
-  MS_DLL_EXPORT int msUpdateWebFromString(webObj *web, char *string);
-  MS_DLL_EXPORT int msUpdateStyleFromString(styleObj *style, char *string);
-  MS_DLL_EXPORT int msUpdateClassFromString(classObj *_class, char *string);
-  MS_DLL_EXPORT int msUpdateLayerFromString(layerObj *layer, char *string);
-  MS_DLL_EXPORT char *msWriteLayerToString(layerObj *layer);
-  MS_DLL_EXPORT char *msWriteMapToString(mapObj *map);
-  MS_DLL_EXPORT char *msWriteClassToString(classObj *_class);
-  MS_DLL_EXPORT char *msWriteStyleToString(styleObj *style);
-  MS_DLL_EXPORT char *msWriteLabelToString(labelObj *label);
-  MS_DLL_EXPORT char *msWriteWebToString(webObj *web);
-  MS_DLL_EXPORT char *msWriteScalebarToString(scalebarObj *scalebar);
-  MS_DLL_EXPORT char *msWriteQueryMapToString(queryMapObj *querymap);
-  MS_DLL_EXPORT char *msWriteReferenceMapToString(referenceMapObj *ref);
-  MS_DLL_EXPORT char *msWriteLegendToString(legendObj *legend);
-  MS_DLL_EXPORT char *msWriteClusterToString(clusterObj *cluster);
-  MS_DLL_EXPORT int msIsValidRegex(const char* e);
-  MS_DLL_EXPORT int msEvalRegex(const char *e, const char *s);
-  MS_DLL_EXPORT int msCaseEvalRegex(const char *e, const char *s);
-#ifdef USE_MSFREE
-  MS_DLL_EXPORT void msFree(void *p);
-#else
-#define msFree free
-#endif
-  MS_DLL_EXPORT char **msTokenizeMap(char *filename, int *numtokens);
-  MS_DLL_EXPORT int msInitLabelCache(labelCacheObj *cache);
-  MS_DLL_EXPORT int msFreeLabelCache(labelCacheObj *cache);
-  MS_DLL_EXPORT int msCheckConnection(layerObj * layer); /* connection pooling functions (mapfile.c) */
-  MS_DLL_EXPORT void msCloseConnections(mapObj *map);
-
-  MS_DLL_EXPORT void msOGRInitialize(void);
-  MS_DLL_EXPORT void msOGRCleanup(void);
-  MS_DLL_EXPORT void msGDALCleanup(void);
-  MS_DLL_EXPORT void msGDALInitialize(void);
-
-  MS_DLL_EXPORT imageObj *msDrawScalebar(mapObj *map); /* in mapscale.c */
-  MS_DLL_EXPORT int msCalculateScale(rectObj extent, int units, int width, int height, double resolution, double *scaledenom);
-  MS_DLL_EXPORT double GetDeltaExtentsUsingScale(double scale, int units, double centerLat, int width, double resolution);
-  MS_DLL_EXPORT double Pix2Georef(int nPixPos, int nPixMin, int nPixMax, double dfGeoMin, double dfGeoMax, int bULisYOrig);
-  MS_DLL_EXPORT double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value);
-  MS_DLL_EXPORT double msInchesPerUnit(int units, double center_lat);
-  MS_DLL_EXPORT int msEmbedScalebar(mapObj *map, imageObj *img);
-
-  MS_DLL_EXPORT int msPointInRect(const pointObj *p, const rectObj *rect); /* in mapsearch.c */
-  MS_DLL_EXPORT int msRectOverlap(const rectObj *a, const rectObj *b);
-  MS_DLL_EXPORT int msRectContained(const rectObj *a, const rectObj *b);
-  MS_DLL_EXPORT int msRectIntersect(rectObj *a, const rectObj *b);
-
-  MS_DLL_EXPORT void msRectToFormattedString(rectObj *rect, char *format,
-      char *buffer, int buffer_length);
-  MS_DLL_EXPORT void msPointToFormattedString(pointObj *point, const char*format,
-      char *buffer, int buffer_length);
-  MS_DLL_EXPORT int msIsDegenerateShape(shapeObj *shape);
-
-  MS_DLL_EXPORT void msMergeRect(rectObj *a, rectObj *b);
-  MS_DLL_EXPORT double msDistancePointToPoint(pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msSquareDistancePointToPoint(pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msSquareDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msDistancePointToShape(pointObj *p, shapeObj *shape);
-  MS_DLL_EXPORT double msSquareDistancePointToShape(pointObj *p, shapeObj *shape);
-  MS_DLL_EXPORT double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb, pointObj *pc, pointObj *pd);
-  MS_DLL_EXPORT double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msIntersectSegments(const pointObj *a, const pointObj *b, const pointObj *c, const pointObj *d);
-  MS_DLL_EXPORT int msPointInPolygon(pointObj *p, lineObj *c);
-  MS_DLL_EXPORT int msIntersectMultipointPolygon(shapeObj *multipoint, shapeObj *polygon);
-  MS_DLL_EXPORT int msIntersectPointPolygon(pointObj *p, shapeObj *polygon);
-  MS_DLL_EXPORT int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly);
-  MS_DLL_EXPORT int msIntersectPolygons(shapeObj *p1, shapeObj *p2);
-  MS_DLL_EXPORT int msIntersectPolylines(shapeObj *line1, shapeObj *line2);
-
-  MS_DLL_EXPORT int msInitQuery(queryObj *query); /* in mapquery.c */
-  MS_DLL_EXPORT void msFreeQuery(queryObj *query);
-  MS_DLL_EXPORT int msSaveQuery(mapObj *map, char *filename, int results);
-  MS_DLL_EXPORT int msLoadQuery(mapObj *map, char *filename);
-  MS_DLL_EXPORT int msExecuteQuery(mapObj *map);
-
-  MS_DLL_EXPORT int msQueryByIndex(mapObj *map); /* various query methods, all rely on the queryObj hung off the mapObj */
-  MS_DLL_EXPORT int msQueryByAttributes(mapObj *map);
-  MS_DLL_EXPORT int msQueryByPoint(mapObj *map);
-  MS_DLL_EXPORT int msQueryByRect(mapObj *map);
-  MS_DLL_EXPORT int msQueryByFeatures(mapObj *map);
-  MS_DLL_EXPORT int msQueryByShape(mapObj *map);
-  MS_DLL_EXPORT int msQueryByFilter(mapObj *map);
-
-  MS_DLL_EXPORT int msGetQueryResultBounds(mapObj *map, rectObj *bounds);
-  MS_DLL_EXPORT int msIsLayerQueryable(layerObj *lp);
-  MS_DLL_EXPORT void msQueryFree(mapObj *map, int qlayer); /* todo: rename */
-  MS_DLL_EXPORT int msRasterQueryByShape(mapObj *map, layerObj *layer, shapeObj *selectshape);
-  MS_DLL_EXPORT int msRasterQueryByRect(mapObj *map, layerObj *layer, rectObj queryRect);
-  MS_DLL_EXPORT int msRasterQueryByPoint(mapObj *map, layerObj *layer, int mode, pointObj p, double buffer, int maxresults );
-
-  /* in mapstring.c */
-  MS_DLL_EXPORT void msStringTrim(char *str);
-  MS_DLL_EXPORT void msStringTrimBlanks(char *string);
-  MS_DLL_EXPORT char *msStringTrimLeft(char *string);
-  MS_DLL_EXPORT char *msStringChop(char *string);
-  MS_DLL_EXPORT void msStringTrimEOL(char *string);
-  MS_DLL_EXPORT char *msReplaceSubstring(char *str, const char *old, const char *sznew);
-  MS_DLL_EXPORT void msReplaceChar(char *str, char old, char sznew);
-  MS_DLL_EXPORT char *msCaseReplaceSubstring(char *str, const char *old, const char *sznew);
-  MS_DLL_EXPORT char *msStripPath(char *fn);
-  MS_DLL_EXPORT char *msGetPath(const char *fn);
-  MS_DLL_EXPORT char *msBuildPath(char *pszReturnPath, const char *abs_path, const char *path);
-  MS_DLL_EXPORT char *msBuildPath3(char *pszReturnPath, const char *abs_path, const char *path1, const char *path2);
-  MS_DLL_EXPORT char *msTryBuildPath(char *szReturnPath, const char *abs_path, const char *path);
-  MS_DLL_EXPORT char *msTryBuildPath3(char *szReturnPath, const char *abs_path, const char *path1, const char *path2);
-  MS_DLL_EXPORT char **msStringSplit(const char *string, char cd, int *num_tokens);
-  MS_DLL_EXPORT char ** msStringSplitComplex( const char * pszString, const char * pszDelimiters, int *num_tokens, int nFlags);
-  MS_DLL_EXPORT int msStringArrayContains(char **array, const char *element, int numElements);
-  MS_DLL_EXPORT char **msStringTokenize( const char *pszLine, const char *pszDelim, int *num_tokens, int preserve_quote);
-  MS_DLL_EXPORT int msCountChars(char *str, char ch);
-  MS_DLL_EXPORT char *msLongToString(long value);
-  MS_DLL_EXPORT char *msDoubleToString(double value, int force_f);
-  MS_DLL_EXPORT char *msIntToString(int value);
-  MS_DLL_EXPORT void msStringToUpper(char *string);
-  MS_DLL_EXPORT void msStringToLower(char *string);
-  MS_DLL_EXPORT void msStringInitCap(char *string);
-  MS_DLL_EXPORT void msStringFirstCap(char *string);
-  MS_DLL_EXPORT int msEncodeChar(const char);
-  MS_DLL_EXPORT char *msEncodeUrlExcept(const char*, const char);
-  MS_DLL_EXPORT char *msEncodeUrl(const char*);
-  MS_DLL_EXPORT char *msEscapeJSonString(const char* pszJSonString);
-  MS_DLL_EXPORT char *msEncodeHTMLEntities(const char *string);
-  MS_DLL_EXPORT void msDecodeHTMLEntities(const char *string);
-  MS_DLL_EXPORT int msIsXMLTagValid(const char *string);
-  MS_DLL_EXPORT char *msStringConcatenate(char *pszDest, const char *pszSrc);
-  MS_DLL_EXPORT char *msJoinStrings(char **array, int arrayLength, const char *delimeter);
-  MS_DLL_EXPORT char *msHashString(const char *pszStr);
-  MS_DLL_EXPORT char *msCommifyString(char *str);
-  MS_DLL_EXPORT int msHexToInt(char *hex);
-  MS_DLL_EXPORT char *msGetEncodedString(const char *string, const char *encoding);
-  MS_DLL_EXPORT char *msConvertWideStringToUTF8 (const wchar_t* string, const char* encoding);
-  MS_DLL_EXPORT wchar_t *msConvertWideStringFromUTF8 (const char* string, const char* encoding);
-  MS_DLL_EXPORT int msGetNextGlyph(const char **in_ptr, char *out_string);
-  MS_DLL_EXPORT int msGetNumGlyphs(const char *in_ptr);
-  MS_DLL_EXPORT int msGetUnicodeEntity(const char *inptr, unsigned int *unicode);
-  MS_DLL_EXPORT int msStringIsInteger(const char *string);
-  MS_DLL_EXPORT int msUTF8ToUniChar(const char *str, unsigned int *chPtr); /* maptclutf.c */
-  MS_DLL_EXPORT char* msStringEscape( const char * pszString );
-  MS_DLL_EXPORT int msStringInArray( const char * pszString, char **array, int numelements);
-
-  typedef struct msStringBuffer msStringBuffer;
-  MS_DLL_EXPORT msStringBuffer* msStringBufferAlloc(void);
-  MS_DLL_EXPORT void msStringBufferFree(msStringBuffer* sb);
-  MS_DLL_EXPORT const char* msStringBufferGetString(msStringBuffer* sb);
-  MS_DLL_EXPORT char* msStringBufferReleaseStringAndFree(msStringBuffer* sb);
-  MS_DLL_EXPORT int msStringBufferAppend(msStringBuffer* sb, const char* pszAppendedString);
-
-  MS_DLL_EXPORT int msStringToInt(const char *str, int *value, int base);
-  MS_DLL_EXPORT int msStringToDouble(const char *str, double *value);
-
-#ifdef __cplusplus
-}
-  std::string msStdStringEscape( const char * pszString );
-  void msStringTrim(std::string& string);
-  void msStringTrimBlanks(std::string& string);
-  void msStringTrimLeft(std::string& string);
-  std::vector<std::string> msStringSplit(const char *string, char cd);
-  std::string msStringToLower(const std::string& s);
-  bool msStringInArray( const char * pszString, const std::vector<std::string>& array);
-extern "C" {
-#endif
-
-#ifndef HAVE_STRRSTR
-  MS_DLL_EXPORT char *strrstr(const char *string, const char *find);
-#endif /* NEED_STRRSTR */
-
-#ifndef HAVE_STRCASESTR
-  MS_DLL_EXPORT char *strcasestr(const char *s, const char *find);
-#endif /* NEED_STRCASESTR */
-
-#ifndef HAVE_STRNCASECMP
-  MS_DLL_EXPORT int strncasecmp(const char *s1, const char *s2, size_t len);
-#endif /* NEED_STRNCASECMP */
-
-#ifndef HAVE_STRCASECMP
-  MS_DLL_EXPORT int strcasecmp(const char *s1, const char *s2);
-#endif /* NEED_STRCASECMP */
-
-#ifndef HAVE_STRLCAT
-  MS_DLL_EXPORT size_t strlcat(char *dst, const char *src, size_t siz);
-#endif /* NEED_STRLCAT */
-
-#ifndef HAVE_STRLCPY
-  MS_DLL_EXPORT size_t strlcpy(char *dst, const char *src, size_t siz);
-#endif /* NEED_STRLCAT */
-
-  MS_DLL_EXPORT char *msStrdup( const char * pszString );
-
-#include "hittest.h"
-
-  /* in mapsymbol.c */
-  /* Use this function *only* with mapfile loading phase */
-  MS_DLL_EXPORT int loadSymbolSet(symbolSetObj *symbolset, mapObj *map);
-  /* Use this threadsafe wrapper everywhere else */
-  MS_DLL_EXPORT int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map);
-  MS_DLL_EXPORT int msCopySymbol(symbolObj *dst, const symbolObj *src, mapObj *map);
-  MS_DLL_EXPORT int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src, mapObj *map);
-  MS_DLL_EXPORT int msCopyHashTable(hashTableObj *dst, const hashTableObj *src);
-  MS_DLL_EXPORT void msInitSymbolSet(symbolSetObj *symbolset);
-  MS_DLL_EXPORT symbolObj *msGrowSymbolSet( symbolSetObj *symbolset );
-  MS_DLL_EXPORT int msAddImageSymbol(symbolSetObj *symbolset, char *filename);
-  MS_DLL_EXPORT int msFreeSymbolSet(symbolSetObj *symbolset);
-  MS_DLL_EXPORT int msFreeSymbol(symbolObj *symbol);
-  MS_DLL_EXPORT int msAddNewSymbol(mapObj *map, char *name);
-  MS_DLL_EXPORT int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol);
-  MS_DLL_EXPORT symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int index);
-  MS_DLL_EXPORT int msSaveSymbolSet(symbolSetObj *symbolset, const char *filename);
-  MS_DLL_EXPORT int msLoadImageSymbol(symbolObj *symbol, const char *filename);
-  MS_DLL_EXPORT int msPreloadImageSymbol(rendererVTableObj *renderer, symbolObj *symbol);
-  MS_DLL_EXPORT int msPreloadSVGSymbol(symbolObj *symbol);
-  MS_DLL_EXPORT symbolObj *msRotateSymbol(symbolObj *symbol, double angle);
-
-  MS_DLL_EXPORT int WARN_UNUSED msGetCharacterSize(mapObj *map, char* font, int size, char *character, rectObj *r);
-  MS_DLL_EXPORT int WARN_UNUSED msGetMarkerSize(mapObj *map, styleObj *style, double *width, double *height, double scalefactor);
-  /* MS_DLL_EXPORT int msGetCharacterSize(char *character, int size, char *font, rectObj *rect); */
-  MS_DLL_EXPORT double msSymbolGetDefaultSize(symbolObj *s);
-  MS_DLL_EXPORT void freeImageCache(struct imageCacheObj *ic);
-
-  MS_DLL_EXPORT imageObj WARN_UNUSED *msDrawLegend(mapObj *map, int scale_independent, map_hittest *hittest); /* in maplegend.c */
-  MS_DLL_EXPORT int WARN_UNUSED msLegendCalcSize(mapObj *map, int scale_independent, int *size_x, int *size_y,
-                                     int *alayers, int numl_ayer, map_hittest *hittest, double resolutionfactor);
-  MS_DLL_EXPORT int WARN_UNUSED msEmbedLegend(mapObj *map, imageObj *img);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLegendIcon(mapObj* map, layerObj* lp, classObj* myClass, int width, int height, imageObj *img, int dstX, int dstY, int scale_independant, class_hittest *hittest);
-  MS_DLL_EXPORT imageObj WARN_UNUSED *msCreateLegendIcon(mapObj* map, layerObj* lp, classObj* myClass, int width, int height, int scale_independant);
-
-  MS_DLL_EXPORT int msLoadFontSet(fontSetObj *fontSet, mapObj *map); /* in maplabel.c */
-  MS_DLL_EXPORT int msInitFontSet(fontSetObj *fontset);
-  MS_DLL_EXPORT int msFreeFontSet(fontSetObj *fontset);
-
-  MS_DLL_EXPORT int WARN_UNUSED msGetTextSymbolSize(mapObj *map, textSymbolObj *ts, rectObj *r);
-  MS_DLL_EXPORT int WARN_UNUSED msGetStringSize(mapObj *map, labelObj *label, int size, char *string, rectObj *r);
-
-  MS_DLL_EXPORT int WARN_UNUSED msAddLabel(mapObj *map, imageObj *image, labelObj *label, int layerindex, int classindex, shapeObj *shape, pointObj *point, double featuresize, textSymbolObj *ts);
-  MS_DLL_EXPORT int WARN_UNUSED msAddLabelGroup(mapObj *map, imageObj *image, layerObj *layer, int classindex, shapeObj *shape, pointObj *point, double featuresize);
-  MS_DLL_EXPORT void insertRenderedLabelMember(mapObj *map, labelCacheMemberObj *cachePtr);
-  MS_DLL_EXPORT int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr, label_bounds *lb, int current_priority, int current_label);
-  MS_DLL_EXPORT int msTestLabelCacheLeaderCollision(mapObj *map, pointObj *lp1, pointObj *lp2);
-  MS_DLL_EXPORT labelCacheMemberObj *msGetLabelCacheMember(labelCacheObj *labelcache, int i);
-
-  MS_DLL_EXPORT void msFreeShape(shapeObj *shape); /* in mapprimitive.c */
-  int msGetShapeRAMSize(shapeObj* shape); /* in mapprimitive.c */
-  MS_DLL_EXPORT void msFreeLabelPathObj(labelPathObj *path);
-  MS_DLL_EXPORT shapeObj *msShapeFromWKT(const char *string);
-  MS_DLL_EXPORT char *msShapeToWKT(shapeObj *shape);
-  MS_DLL_EXPORT void msInitShape(shapeObj *shape);
-  MS_DLL_EXPORT void msShapeDeleteLine( shapeObj *shape, int line );
-  MS_DLL_EXPORT int msCopyShape(const shapeObj *from, shapeObj *to);
-  MS_DLL_EXPORT int msIsOuterRing(shapeObj *shape, int r);
-  MS_DLL_EXPORT int *msGetOuterList(shapeObj *shape);
-  MS_DLL_EXPORT int *msGetInnerList(shapeObj *shape, int r, int *outerlist);
-  MS_DLL_EXPORT void msComputeBounds(shapeObj *shape);
-  MS_DLL_EXPORT void msRectToPolygon(rectObj rect, shapeObj *poly);
-  MS_DLL_EXPORT void msClipPolylineRect(shapeObj *shape, rectObj rect);
-  MS_DLL_EXPORT void msClipPolygonRect(shapeObj *shape, rectObj rect);
-  MS_DLL_EXPORT void msTransformShape(shapeObj *shape, rectObj extent, double cellsize, imageObj *image);
-  MS_DLL_EXPORT void msTransformPoint(pointObj *point, rectObj *extent, double cellsize, imageObj *image);
-
-  MS_DLL_EXPORT void msOffsetPointRelativeTo(pointObj *point, layerObj *layer);
-  MS_DLL_EXPORT void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer);
-  MS_DLL_EXPORT void msTransformShapeSimplify(shapeObj *shape, rectObj extent, double cellsize);
-  MS_DLL_EXPORT void msTransformShapeToPixelSnapToGrid(shapeObj *shape, rectObj extent, double cellsize, double grid_resolution);
-  MS_DLL_EXPORT void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent, double cellsize);
-  MS_DLL_EXPORT void msTransformShapeToPixelDoublePrecision(shapeObj *shape, rectObj extent, double cellsize);
-
-  MS_DLL_EXPORT shapeObj *msDensify(shapeObj *shape, double tolerance);
-  MS_DLL_EXPORT shapeObj *msRings2Shape(shapeObj *shape, int outer);
-
-#ifndef SWIG
-
-  struct line_lengths {
-    double *segment_lengths;
-    double total_length;
-    int longest_segment_index;
-  };
-
-  struct polyline_lengths {
-    struct line_lengths *ll;
-    double total_length;
-    int longest_line_index;
-    int longest_segment_line_index, longest_segment_point_index;
-  };
-
-  struct label_auto_result {
-    pointObj *label_points;
-    double *angles;
-    int num_label_points;
-  };
-
-  struct label_follow_result {
-    textSymbolObj **follow_labels;
-    int num_follow_labels;
-    struct label_auto_result lar;
-  };
-
-#endif
-
-  MS_DLL_EXPORT void msTransformPixelToShape(shapeObj *shape, rectObj extent, double cellsize);
-  MS_DLL_EXPORT void msPolylineComputeLineSegments(shapeObj *shape, struct polyline_lengths *pll);
-  MS_DLL_EXPORT int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_follow_result *lfr);
-  MS_DLL_EXPORT int WARN_UNUSED msPolylineLabelPoint(mapObj *map, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_auto_result *lar, double resolutionfactor);
-  MS_DLL_EXPORT int WARN_UNUSED msLineLabelPath(mapObj *map, imageObj *img, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_follow_result *lfr, labelObj *lbl);
-  MS_DLL_EXPORT int WARN_UNUSED msLineLabelPoint(mapObj *map, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_auto_result *lar, labelObj *lbl, double resolutionfactor);
-  MS_DLL_EXPORT int msPolygonLabelPoint(shapeObj *p, pointObj *lp, double min_dimension);
-  MS_DLL_EXPORT int msAddLine(shapeObj *p, const lineObj *new_line);
-  MS_DLL_EXPORT int msAddLineDirectly(shapeObj *p, lineObj *new_line);
-  MS_DLL_EXPORT int msAddPointToLine(lineObj *line, pointObj *point );
-  MS_DLL_EXPORT double msGetPolygonArea(shapeObj *p);
-  MS_DLL_EXPORT int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny, double *maxy);
-
-  MS_DLL_EXPORT int msDrawRasterLayer(mapObj *map, layerObj *layer, imageObj *image); /* in mapraster.c */
-  MS_DLL_EXPORT imageObj *msDrawReferenceMap(mapObj *map);
-
-  /* mapbits.c - bit array handling functions and macros */
-
-#define MS_ARRAY_BIT 32
-
-#define MS_GET_BIT(array,i) (array[i>>5] & (1 <<(i & 0x3f)))
-#define MS_SET_BIT(array,i) {array[i>>5] |= (1 <<(i & 0x3f));}
-#define MS_CLR_BIT(array,i) {array[i>>5] &= (~(1 <<(i & 0x3f)));}
-
-  MS_DLL_EXPORT size_t msGetBitArraySize(int numbits); /* in mapbits.c */
-  MS_DLL_EXPORT ms_bitarray msAllocBitArray(int numbits);
-  MS_DLL_EXPORT int msGetBit(ms_const_bitarray array, int index);
-  MS_DLL_EXPORT void msSetBit(ms_bitarray array, int index, int value);
-  MS_DLL_EXPORT void msSetAllBits(ms_bitarray array, int index, int value);
-  MS_DLL_EXPORT void msFlipBit(ms_bitarray array, int index);
-  MS_DLL_EXPORT int msGetNextBit(ms_const_bitarray array, int index, int size);
-
-  /* maplayer.c - layerObj  api */
-
-  MS_DLL_EXPORT int msLayerInitItemInfo(layerObj *layer);
-  MS_DLL_EXPORT void msLayerFreeItemInfo(layerObj *layer);
-
-  MS_DLL_EXPORT int msLayerOpen(layerObj *layer); /* in maplayer.c */
-  MS_DLL_EXPORT int msLayerApplyScaletokens(layerObj *layer, double scale);
-  MS_DLL_EXPORT int msLayerRestoreFromScaletokens(layerObj *layer);
-  MS_DLL_EXPORT int msClusterLayerOpen(layerObj *layer); /* in mapcluster.c */
-  MS_DLL_EXPORT int msLayerIsOpen(layerObj *layer);
-  MS_DLL_EXPORT void msLayerClose(layerObj *layer);
-  MS_DLL_EXPORT void msLayerFreeExpressions(layerObj *layer);
-  MS_DLL_EXPORT int msLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery);
-  MS_DLL_EXPORT int msLayerGetItemIndex(layerObj *layer, char *item);
-  MS_DLL_EXPORT int msLayerWhichItems(layerObj *layer, int get_all, const char *metadata);
-  MS_DLL_EXPORT int msLayerNextShape(layerObj *layer, shapeObj *shape);
-  MS_DLL_EXPORT int msLayerGetItems(layerObj *layer);
-  MS_DLL_EXPORT int msLayerSetItems(layerObj *layer, char **items, int numitems);
-  MS_DLL_EXPORT int msLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
-  MS_DLL_EXPORT int msLayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection);
-  MS_DLL_EXPORT int msLayerGetExtent(layerObj *layer, rectObj *extent);
-  MS_DLL_EXPORT int msLayerSetExtent( layerObj *layer, double minx, double miny, double maxx, double maxy);
-  MS_DLL_EXPORT int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape);
-  MS_DLL_EXPORT int msLayerGetFeatureStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape);
-  MS_DLL_EXPORT void msLayerAddProcessing( layerObj *layer, const char *directive );
-  MS_DLL_EXPORT void msLayerSetProcessingKey( layerObj *layer, const char *key, const char *value);
-  MS_DLL_EXPORT const char *msLayerGetProcessing( const layerObj *layer, int proc_index);
-  MS_DLL_EXPORT const char *msLayerGetProcessingKey( const layerObj *layer, const char *);
-  MS_DLL_EXPORT int msLayerClearProcessing( layerObj *layer );
-  MS_DLL_EXPORT void msLayerSubstituteProcessing( layerObj *layer, const char *from, const char *to );
-  MS_DLL_EXPORT char *msLayerGetFilterString( layerObj *layer );
-  MS_DLL_EXPORT int msLayerEncodeShapeAttributes( layerObj *layer, shapeObj *shape);
-
-  MS_DLL_EXPORT int msLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem);
-  MS_DLL_EXPORT int msLayerSupportsCommonFilters(layerObj *layer);
-  MS_DLL_EXPORT const char *msExpressionTokenToString(int token);
-  MS_DLL_EXPORT int msTokenizeExpression(expressionObj *expression, char **list, int *listsize);
-
-  MS_DLL_EXPORT int msLayerSetTimeFilter(layerObj *lp, const char *timestring, const char *timefield);
-  MS_DLL_EXPORT int msLayerMakeBackticsTimeFilter(layerObj *lp, const char *timestring, const char *timefield);
-  MS_DLL_EXPORT int msLayerMakePlainTimeFilter(layerObj *lp, const char *timestring, const char *timefield);
-
-  MS_DLL_EXPORT int msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
-  MS_DLL_EXPORT int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
-
-  /* maplayer.c */
-  MS_DLL_EXPORT int msLayerGetNumFeatures(layerObj *layer);
-
-  MS_DLL_EXPORT int msLayerSupportsPaging(layerObj *layer);
-
-  MS_DLL_EXPORT void msLayerEnablePaging(layerObj *layer, int value);
-  MS_DLL_EXPORT int msLayerGetPaging(layerObj *layer);
-
-  MS_DLL_EXPORT int msLayerGetMaxFeaturesToDraw(layerObj *layer, outputFormatObj *format);
-
-  MS_DLL_EXPORT char *msLayerEscapeSQLParam(layerObj *layer, const char* pszString);
-  MS_DLL_EXPORT char *msLayerEscapePropertyName(layerObj *layer, const char* pszString);
-
-  int msLayerSupportsSorting(layerObj *layer);
-  void msLayerSetSort(layerObj *layer, const sortByClause* sortBy);
-  MS_DLL_EXPORT char* msLayerBuildSQLOrderBy(layerObj *layer);
-
-  /* These are special because SWF is using these */
-  int msOGRLayerNextShape(layerObj *layer, shapeObj *shape);
-  int msOGRLayerGetItems(layerObj *layer);
-  void msOGRLayerFreeItemInfo(layerObj *layer);
-  int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
-  int msOGRLayerGetExtent(layerObj *layer, rectObj *extent);
-
-  MS_DLL_EXPORT int msOGRGeometryToShape(OGRGeometryH hGeometry, shapeObj *shape,
-                                         OGRwkbGeometryType type);
-
-  MS_DLL_EXPORT int msInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msConnectLayer(layerObj *layer, const int connectiontype,
-                                   const char *library_str);
-
-  MS_DLL_EXPORT int msINLINELayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msSHPLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msTiledSHPLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msOGRLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msPostGISLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msWFSLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msGraticuleLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msRASTERLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msUVRASTERLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msContourLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msPluginLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msUnionLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT void msPluginFreeVirtualTableFactory(void);
-
-  MS_DLL_EXPORT int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection);
-  void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj* layer, mapObj* map);
-  rectObj msUVRASTERGetSearchRect( layerObj* layer, mapObj* map );
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in mapdraw.c                           */
-  /* ==================================================================== */
-
-  MS_DLL_EXPORT imageObj *msPrepareImage(mapObj *map, int allow_nonsquare);
-  MS_DLL_EXPORT imageObj *msDrawMap(mapObj *map, int querymap);
-  MS_DLL_EXPORT int msLayerIsVisible(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawVectorLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawQueryLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawWFSLayer(mapObj *map, layerObj *layer, imageObj *image);
-
-#define MS_DRAWMODE_FEATURES    0x00001
-#define MS_DRAW_FEATURES(mode) (MS_DRAWMODE_FEATURES&(mode))
-#define MS_DRAWMODE_LABELS      0x00002
-#define MS_DRAW_LABELS(mode) (MS_DRAWMODE_LABELS&(mode))
-#define MS_DRAWMODE_SINGLESTYLE 0x00004
-#define MS_DRAW_SINGLESTYLE(mode) (MS_DRAWMODE_SINGLESTYLE&(mode))
-#define MS_DRAWMODE_QUERY       0x00008
-#define MS_DRAW_QUERY(mode) (MS_DRAWMODE_QUERY&(mode))
-#define MS_DRAWMODE_UNCLIPPEDLABELS       0x00010
-#define MS_DRAW_UNCLIPPED_LABELS(mode) (MS_DRAWMODE_UNCLIPPEDLABELS&(mode))
-#define MS_DRAWMODE_UNCLIPPEDLINES       0x00020
-#define MS_DRAW_UNCLIPPED_LINES(mode) (MS_DRAWMODE_UNCLIPPEDLINES&(mode))
-
-  MS_DLL_EXPORT int WARN_UNUSED msDrawShape(mapObj *map, layerObj *layer, shapeObj *shape, imageObj *image, int style, int mode);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawPoint(mapObj *map, layerObj *layer, pointObj *point, imageObj *image, int classindex, char *labeltext);
-
-  /*Range Support*/
-  typedef enum {
-    MS_COLORSPACE_RGB,
-    MS_COLORSPACE_HSL
-  } colorspace;
-  MS_DLL_EXPORT int msShapeToRange(styleObj *style, shapeObj *shape);
-  MS_DLL_EXPORT int msValueToRange(styleObj *style, double fieldVal, colorspace cs);
-
-  MS_DLL_EXPORT int WARN_UNUSED msDrawMarkerSymbol(mapObj *map, imageObj *image, pointObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLineSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawShadeSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msCircleDrawLineSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msCircleDrawShadeSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawPieSlice(mapObj *map, imageObj *image, pointObj *p, styleObj *style, double radius, double start, double end);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLabelBounds(mapObj *map, imageObj *image, label_bounds *bnds, styleObj *style, double scalefactor);
-
-  MS_DLL_EXPORT void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image);
-
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLabel(mapObj *map, imageObj *image, pointObj labelPnt, char *string, labelObj *label, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawTextSymbol(mapObj *map, imageObj *image, pointObj labelPnt, textSymbolObj *ts);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLabelCache(mapObj *map, imageObj *image);
-
-  MS_DLL_EXPORT void msImageStartLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT void msImageEndLayer(mapObj *map, layerObj *layer, imageObj *image);
-
-  MS_DLL_EXPORT void msDrawStartShape(mapObj *map, layerObj *layer, imageObj *image, shapeObj *shape);
-  MS_DLL_EXPORT void msDrawEndShape(mapObj *map, layerObj *layer, imageObj *image, shapeObj *shape);
-  /* ==================================================================== */
-  /*      End of Prototypes for functions in mapdraw.c                    */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in mapgeomutil.cpp                       */
-  /* ==================================================================== */
-  MS_DLL_EXPORT shapeObj *msRasterizeArc(double x0, double y0, double radius, double startAngle, double endAngle, int isSlice);
-  MS_DLL_EXPORT int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing, double width, double *pattern, int patternlength, double angle, colorObj *color);
-
-
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in mapimagemap.c                       */
-  /* ==================================================================== */
-  MS_DLL_EXPORT imageObj *msImageCreateIM(int width, int height, outputFormatObj *format, char *imagepath, char *imageurl, double resolution, double defresolution);
-  MS_DLL_EXPORT void msImageStartLayerIM(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msSaveImageIM(imageObj* img, const char *filename, outputFormatObj *format);
-  MS_DLL_EXPORT void msFreeImageIM(imageObj* img);
-  MS_DLL_EXPORT void msDrawMarkerSymbolIM(mapObj *map, imageObj* img, pointObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT void msDrawLineSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT void msDrawShadeSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int msDrawTextIM(mapObj *map, imageObj* img, pointObj labelPnt, char *string, labelObj *label, double scalefactor);
-  /* ==================================================================== */
-  /*      End of Prototypes for functions in mapimagemap.c                */
-  /* ==================================================================== */
-
-
-  /* various JOIN functions (in mapjoin.c) */
-  MS_DLL_EXPORT int msJoinConnect(layerObj *layer, joinObj *join);
-  MS_DLL_EXPORT int msJoinPrepare(joinObj *join, shapeObj *shape);
-  MS_DLL_EXPORT int msJoinNext(joinObj *join);
-  MS_DLL_EXPORT int msJoinClose(joinObj *join);
-
-  /*in mapraster.c */
-  int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer);
-  void* msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
-                                      const char* filename,
-                                      char szPath[MS_MAXPATHLEN],
-                                      char** p_decrypted_path);
-  void msDrawRasterLayerLowCloseDataset(layerObj *layer, void* hDataset);
-  int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer, imageObj *image, rasterBufferObj *rb, void* hDatasetIn );
-
-  MS_DLL_EXPORT int msDrawRasterLayerLow(mapObj *map, layerObj *layer, imageObj *image, rasterBufferObj *rb );
-  MS_DLL_EXPORT int msGetClass(layerObj *layer, colorObj *color, int colormap_index);
-  MS_DLL_EXPORT int msGetClass_FloatRGB(layerObj *layer, float fValue,
-                                        int red, int green, int blue );
-  int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue, int red, int green, int blue, int firstClassToTry );
-
-  /* in mapdrawgdal.c */
-  MS_DLL_EXPORT int msDrawRasterLayerGDAL(mapObj *map, layerObj *layer, imageObj *image, rasterBufferObj *rb, void *hDSVoid );
-  MS_DLL_EXPORT int msGetGDALGeoTransform(void *hDS, mapObj *map, layerObj *layer, double *padfGeoTransform );
-  MS_DLL_EXPORT int *msGetGDALBandList( layerObj *layer, void *hDS, int max_bands, int *band_count );
-  MS_DLL_EXPORT double msGetGDALNoDataValue( layerObj *layer, void *hBand, int *pbGotNoData );
-
-  /* in interpolation.c */
-  MS_DLL_EXPORT int msInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer, void **hDSvoid, void **cleanup_ptr);
-  MS_DLL_EXPORT int msCleanupInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer, void *cleanup_ptr);
-
-  /* in mapchart.c */
-  MS_DLL_EXPORT int msDrawChartLayer(mapObj *map, layerObj *layer, imageObj *image);
-
-  /* ==================================================================== */
-  /*      End of prototypes for functions in mapgd.c                      */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in maputil.c                           */
-  /* ==================================================================== */
-
-  MS_DLL_EXPORT int msScaleInBounds(double scale, double minscale, double maxscale);
-  MS_DLL_EXPORT void *msSmallMalloc( size_t nSize );
-  MS_DLL_EXPORT void * msSmallRealloc( void * pData, size_t nNewSize );
-  MS_DLL_EXPORT void *msSmallCalloc( size_t nCount, size_t nSize );
-  MS_DLL_EXPORT int msIntegerInArray(const int value, int *array, int numelements);
-
-  MS_DLL_EXPORT int msExtentsOverlap(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req);
-
-  /* For mapswf */
-  MS_DLL_EXPORT int getRgbColor(mapObj *map,int i,int *r,int *g,int *b); /* maputil.c */
-
-  MS_DLL_EXPORT int msBindLayerToShape(layerObj *layer, shapeObj *shape, int querymapMode);
-  MS_DLL_EXPORT int msValidateContexts(mapObj *map);
-  MS_DLL_EXPORT int msEvalContext(mapObj *map, layerObj *layer, char *context);
-  MS_DLL_EXPORT int msEvalExpression(layerObj *layer, shapeObj *shape, expressionObj *expression, int itemindex);
-  MS_DLL_EXPORT int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape, int *classgroup, int numclasses);
-  MS_DLL_EXPORT int msShapeGetNextClass(int currentclass, layerObj *layer, mapObj *map, shapeObj *shape, int *classgroup, int numclasses);
-  MS_DLL_EXPORT int msShapeCheckSize(shapeObj *shape, double minfeaturesize);
-  MS_DLL_EXPORT char* msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape, labelObj *lbl);
-  MS_DLL_EXPORT int msGetLabelStatus(mapObj *map, layerObj *layer, shapeObj *shape, labelObj *lbl);
-  MS_DLL_EXPORT int msAdjustImage(rectObj rect, int *width, int *height);
-  MS_DLL_EXPORT char *msEvalTextExpression(expressionObj *expr, shapeObj *shape);
-  MS_DLL_EXPORT char *msEvalTextExpressionJSonEscape(expressionObj *expr, shapeObj *shape);
-  MS_DLL_EXPORT double msEvalDoubleExpression(expressionObj *expr, shapeObj *shape);
-  MS_DLL_EXPORT double msAdjustExtent(rectObj *rect, int width, int height);
-  MS_DLL_EXPORT int msConstrainExtent(rectObj *bounds, rectObj *rect, double overlay);
-  MS_DLL_EXPORT int *msGetLayersIndexByGroup(mapObj *map, char *groupname, int *nCount);
-  MS_DLL_EXPORT unsigned char *msSaveImageBuffer(imageObj* image, int *size_ptr, outputFormatObj *format);
-  MS_DLL_EXPORT shapeObj* msOffsetPolyline(shapeObj* shape, double offsetx, double offsety);
-  MS_DLL_EXPORT int msMapSetLayerProjections(mapObj* map);
-
-  /* Functions to chnage the drawing order of the layers. */
-  /* Defined in mapobject.c */
-  MS_DLL_EXPORT int msMoveLayerUp(mapObj *map, int nLayerIndex);
-  MS_DLL_EXPORT int msMoveLayerDown(mapObj *map, int nLayerIndex);
-  MS_DLL_EXPORT int msSetLayersdrawingOrder(mapObj *self, int *panIndexes);
-  MS_DLL_EXPORT int msInsertLayer(mapObj *map, layerObj *layer, int nIndex);
-  MS_DLL_EXPORT layerObj *msRemoveLayer(mapObj *map, int nIndex);
-
-  /* Defined in layerobject.c */
-  MS_DLL_EXPORT int msInsertClass(layerObj *layer,classObj *classobj,int nIndex);
-  MS_DLL_EXPORT classObj *msRemoveClass(layerObj *layer, int nIndex);
-  MS_DLL_EXPORT int msMoveClassUp(layerObj *layer, int nClassIndex);
-  MS_DLL_EXPORT int msMoveClassDown(layerObj *layer, int nClassIndex);
-
-  /* classobject.c */
-  MS_DLL_EXPORT int msAddLabelToClass(classObj *classo, labelObj *label);
-  MS_DLL_EXPORT labelObj *msRemoveLabelFromClass(classObj *classo, int nLabelIndex);
-  MS_DLL_EXPORT int msMoveStyleUp(classObj *classo, int nStyleIndex);
-  MS_DLL_EXPORT int msMoveStyleDown(classObj *classo, int nStyleIndex);
-  MS_DLL_EXPORT int msDeleteStyle(classObj *classo, int nStyleIndex);
-  MS_DLL_EXPORT int msInsertStyle(classObj *classo, styleObj *style, int nStyleIndex);
-  MS_DLL_EXPORT styleObj *msRemoveStyle(classObj *classo, int index);
-
-  /* maplabel.c */
-  MS_DLL_EXPORT int msInsertLabelStyle(labelObj *label, styleObj *style,
-                                       int nStyleIndex);
-  MS_DLL_EXPORT int msMoveLabelStyleUp(labelObj *label, int nStyleIndex);
-  MS_DLL_EXPORT int msMoveLabelStyleDown(labelObj *label, int nStyleIndex);
-  MS_DLL_EXPORT int msDeleteLabelStyle(labelObj *label, int nStyleIndex);
-  MS_DLL_EXPORT styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex);
-
-  /* Measured shape utility functions. */
-  MS_DLL_EXPORT pointObj *msGetPointUsingMeasure(shapeObj *shape, double m);
-  MS_DLL_EXPORT pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj *point);
-
-  MS_DLL_EXPORT char **msGetAllGroupNames(mapObj* map, int *numTok);
-  MS_DLL_EXPORT char *msTmpFile(mapObj *map, const char *mappath, const char *tmppath, const char *ext);
-  MS_DLL_EXPORT char *msTmpPath(mapObj *map, const char *mappath, const char *tmppath);
-  MS_DLL_EXPORT char *msTmpFilename(const char *ext);
-  MS_DLL_EXPORT void msForceTmpFileBase( const char *new_base );
-
-
-  MS_DLL_EXPORT imageObj *msImageCreate(int width, int height, outputFormatObj *format, char *imagepath, char *imageurl, double resolution, double defresolution, colorObj *bg);
-
-  MS_DLL_EXPORT void msAlphaBlend(
-    unsigned char red_src, unsigned char green_src,
-    unsigned char blue_src, unsigned char alpha_src,
-    unsigned char *red_dst, unsigned char *green_dst,
-    unsigned char *blue_dst, unsigned char *alpha_dst );
-  MS_DLL_EXPORT void msAlphaBlendPM(
-    unsigned char red_src, unsigned char green_src,
-    unsigned char blue_src, unsigned char alpha_src,
-    unsigned char *red_dst, unsigned char *green_dst,
-    unsigned char *blue_dst, unsigned char *alpha_dst );
-
-  MS_DLL_EXPORT void msRGBtoHSL(colorObj *rgb, double *h, double *s, double *l);
-
-  MS_DLL_EXPORT void msHSLtoRGB(double h, double s, double l, colorObj *rgb);
-
-  MS_DLL_EXPORT int msCheckParentPointer(void* p, const char* objname);
-
-  MS_DLL_EXPORT int *msAllocateValidClassGroups(layerObj *lp, int *nclasses);
-
-  MS_DLL_EXPORT void msFreeRasterBuffer(rasterBufferObj *b);
-  MS_DLL_EXPORT void msSetLayerOpacity(layerObj *layer, int opacity);
-
-  void msMapSetLanguageSpecificConnection(mapObj* map, const char* validated_language);
-  MS_DLL_EXPORT shapeObj* msGeneralize(shapeObj * shape, double tolerance);
-  /* ==================================================================== */
-  /*      End of prototypes for functions in maputil.c                    */
-  /* ==================================================================== */
-
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapoutput.c                         */
-  /* ==================================================================== */
-
-  MS_DLL_EXPORT void msApplyDefaultOutputFormats( mapObj * );
-  MS_DLL_EXPORT void msFreeOutputFormat( outputFormatObj * );
-  MS_DLL_EXPORT int msGetOutputFormatIndex(mapObj *map, const char *imagetype);
-  MS_DLL_EXPORT int msRemoveOutputFormat(mapObj *map, const char *imagetype);
-  MS_DLL_EXPORT int msAppendOutputFormat(mapObj *map, outputFormatObj *format);
-  MS_DLL_EXPORT outputFormatObj *msSelectOutputFormat( mapObj *map, const char *imagetype );
-  MS_DLL_EXPORT void msApplyOutputFormat( outputFormatObj **target, outputFormatObj *format, int transparent);
-  MS_DLL_EXPORT const char *msGetOutputFormatOption( outputFormatObj *format, const char *optionkey, const char *defaultresult );
-  MS_DLL_EXPORT outputFormatObj *msCreateDefaultOutputFormat( mapObj *map, const char *driver, const char *name, const char *mimetype );
-  MS_DLL_EXPORT int msPostMapParseOutputFormatSetup( mapObj *map );
-  MS_DLL_EXPORT void msSetOutputFormatOption( outputFormatObj *format, const char *key, const char *value );
-  MS_DLL_EXPORT void msGetOutputFormatMimeList( mapObj *map, char **mime_list, int max_mime );
-  MS_DLL_EXPORT void msGetOutputFormatMimeListImg( mapObj *map, const char **mime_list, int max_mime );
-  MS_DLL_EXPORT void msGetOutputFormatMimeListWMS( mapObj *map, const char **mime_list, int max_mime );
-  MS_DLL_EXPORT outputFormatObj *msCloneOutputFormat( outputFormatObj *format );
-  MS_DLL_EXPORT int msOutputFormatValidate( outputFormatObj *format,
-      int issue_error );
-  void  msOutputFormatResolveFromImage( mapObj *map, imageObj* img );
-
-  /* ==================================================================== */
-  /*      End of prototypes for functions in mapoutput.c                  */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgdal.c                           */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msSaveImageGDAL( mapObj *map, imageObj *image, const char *filename );
-  MS_DLL_EXPORT int msInitDefaultGDALOutputFormat( outputFormatObj *format );
-  void msCleanVSIDir( const char *pszDir );
-  char** msGetStringListFromHashTable(hashTableObj* table);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapogroutput.c                      */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msInitDefaultOGROutputFormat( outputFormatObj *format );
-  MS_DLL_EXPORT int msOGRWriteFromQuery( mapObj *map, outputFormatObj *format,
-                                         int sendheaders );
-
-  /* ==================================================================== */
-  /*      Public prototype for mapogr.cpp functions.                      */
-  /* ==================================================================== */
-  int MS_DLL_EXPORT msOGRLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery);
-  int MS_DLL_EXPORT msOGRLayerOpen(layerObj *layer, const char *pszOverrideConnection); /* in mapogr.cpp */
-  int MS_DLL_EXPORT msOGRLayerClose(layerObj *layer);
-
-  char MS_DLL_EXPORT *msOGRShapeToWKT(shapeObj *shape);
-  shapeObj MS_DLL_EXPORT *msOGRShapeFromWKT(const char *string);
-  int msOGRUpdateStyleFromString(mapObj *map, layerObj *layer, classObj *c,
-                                 const char *stylestring);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapcopy                             */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msCopyMap(mapObj *dst, const mapObj *src);
-  MS_DLL_EXPORT int msCopyLayer(layerObj *dst, const layerObj *src);
-  MS_DLL_EXPORT int msCopyScaleToken(const scaleTokenObj *src, scaleTokenObj *dst);
-  MS_DLL_EXPORT int msCopyPoint(pointObj *dst, const pointObj *src);
-  MS_DLL_EXPORT int msCopyFontSet(fontSetObj *dst, const fontSetObj *src, mapObj *map);
-  MS_DLL_EXPORT void copyProperty(void *dst, const void *src, int size);
-  MS_DLL_EXPORT char *copyStringProperty(char **dst, const char *src);
-  MS_DLL_EXPORT int msCopyClass(classObj *dst, const classObj *src, layerObj *layer);
-  MS_DLL_EXPORT int msCopyStyle(styleObj *dst, const styleObj *src);
-  MS_DLL_EXPORT int msCopyLabel(labelObj *dst, const labelObj *src);
-  MS_DLL_EXPORT int msCopyLabelLeader(labelLeaderObj *dst, const labelLeaderObj *src);
-  MS_DLL_EXPORT int msCopyLine(lineObj *dst, const lineObj *src);
-  MS_DLL_EXPORT int msCopyProjection(projectionObj *dst, const projectionObj *src);
-  MS_DLL_EXPORT int msCopyProjectionExtended(projectionObj *dst, const projectionObj *src, char ** args, int num_args);
-  int msCopyExpression(expressionObj *dst, const expressionObj *src);
-  int msCopyProjection(projectionObj *dst, const projectionObj *src);
-  MS_DLL_EXPORT int msCopyRasterBuffer(rasterBufferObj *dst, const rasterBufferObj *src);
-
-  /* ==================================================================== */
-  /*      end prototypes for functions in mapcopy                         */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      mappool.c: connection pooling API.                              */
-  /* ==================================================================== */
-  MS_DLL_EXPORT void *msConnPoolRequest( layerObj *layer );
-  MS_DLL_EXPORT void msConnPoolRelease( layerObj *layer, void * );
-  MS_DLL_EXPORT void msConnPoolRegister( layerObj *layer,
-                                         void *conn_handle,
-                                         void (*close)( void * ) );
-  MS_DLL_EXPORT void msConnPoolCloseUnreferenced( void );
-  MS_DLL_EXPORT void msConnPoolFinalCleanup( void );
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapcpl.c                            */
-  /* ==================================================================== */
-  MS_DLL_EXPORT const char *msGetBasename( const char *pszFullFilename );
-  MS_DLL_EXPORT void *msGetSymbol(const char *pszLibrary,
-                                  const char *pszEntryPoint);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgeos.c                         */
-  /* ==================================================================== */
-  MS_DLL_EXPORT void msGEOSSetup(void);
-  MS_DLL_EXPORT void msGEOSCleanup(void);
-  MS_DLL_EXPORT void msGEOSFreeGeometry(shapeObj *shape);
-
-  MS_DLL_EXPORT shapeObj *msGEOSShapeFromWKT(const char *string);
-  MS_DLL_EXPORT char *msGEOSShapeToWKT(shapeObj *shape);
-  MS_DLL_EXPORT void msGEOSFreeWKT(char* pszGEOSWKT);
-
-  MS_DLL_EXPORT shapeObj *msGEOSBuffer(shapeObj *shape, double width);
-  MS_DLL_EXPORT shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance);
-  MS_DLL_EXPORT shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape, double tolerance);
-  MS_DLL_EXPORT shapeObj *msGEOSConvexHull(shapeObj *shape);
-  MS_DLL_EXPORT shapeObj *msGEOSBoundary(shapeObj *shape);
-  MS_DLL_EXPORT pointObj *msGEOSGetCentroid(shapeObj *shape);
-  MS_DLL_EXPORT shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset);
-  MS_DLL_EXPORT shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance, int onlyEdges);
-  MS_DLL_EXPORT shapeObj *msGEOSCenterline(shapeObj *shape);
-
-  MS_DLL_EXPORT int msGEOSContains(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSWithin(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSTouches(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSEquals(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2);
-
-  MS_DLL_EXPORT double msGEOSArea(shapeObj *shape);
-  MS_DLL_EXPORT double msGEOSLength(shapeObj *shape);
-  MS_DLL_EXPORT double msGEOSDistance(shapeObj *shape1, shapeObj *shape2);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapcrypto.c                         */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msGenerateEncryptionKey(unsigned char *k);
-  MS_DLL_EXPORT int msReadEncryptionKeyFromFile(const char *keyfile, unsigned char *k);
-  MS_DLL_EXPORT void msEncryptStringWithKey(const unsigned char *key, const char *in, char *out);
-  MS_DLL_EXPORT void msDecryptStringWithKey(const unsigned char *key, const char *in, char *out);
-  MS_DLL_EXPORT char *msDecryptStringTokens(mapObj *map, const char *in);
-  MS_DLL_EXPORT void msHexEncode(const unsigned char *in, char *out, int numbytes);
-  MS_DLL_EXPORT int msHexDecode(const char *in, unsigned char *out, int numchars);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapxmp.c                            */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msXmpPresent(mapObj *map);
-  MS_DLL_EXPORT int msXmpWrite(mapObj *map, const char *filename);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgeomtransform.c                  */
-  /* ==================================================================== */
-  enum MS_GEOMTRANSFORM_TYPE {
-    MS_GEOMTRANSFORM_NONE,
-    MS_GEOMTRANSFORM_EXPRESSION,
-    MS_GEOMTRANSFORM_START,
-    MS_GEOMTRANSFORM_END,
-    MS_GEOMTRANSFORM_VERTICES,
-    MS_GEOMTRANSFORM_BBOX,
-    MS_GEOMTRANSFORM_CENTROID,
-    MS_GEOMTRANSFORM_BUFFER,
-    MS_GEOMTRANSFORM_CONVEXHULL,
-    MS_GEOMTRANSFORM_LABELPOINT,
-    MS_GEOMTRANSFORM_LABELPOLY,
-    MS_GEOMTRANSFORM_LABELCENTER
-  };
-
-  MS_DLL_EXPORT int msDrawTransformedShape(mapObj *map, imageObj *image, shapeObj *shape, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT void msStyleSetGeomTransform(styleObj *s, char *transform);
-  MS_DLL_EXPORT char *msStyleGetGeomTransform(styleObj *style);
-
-  MS_DLL_EXPORT int msGeomTransformShape(mapObj *map, layerObj *layer, shapeObj *shape);
-
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapgeomtransform.c                 */
-  /* ==================================================================== */
-
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgraticule.c                      */
-  /* ==================================================================== */
-  MS_DLL_EXPORT graticuleIntersectionObj *msGraticuleLayerGetIntersectionPoints(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT void msGraticuleLayerFreeIntersectionPoints( graticuleIntersectionObj *psValue);
-
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapgraticule.c               */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapsmoothing.c                      */
-  /* ==================================================================== */
-  MS_DLL_EXPORT shapeObj* msSmoothShapeSIA(shapeObj *shape, int ss, int si, char *preprocessing);
-
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapsmoothing.c               */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapv8.cpp                           */
-  /* ==================================================================== */
-#ifdef USE_V8_MAPSCRIPT
-  MS_DLL_EXPORT void msV8CreateContext(mapObj *map);
-  MS_DLL_EXPORT void msV8ContextSetLayer(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT void msV8FreeContext(mapObj *map);
-  MS_DLL_EXPORT char* msV8GetFeatureStyle(mapObj *map, const char *filename,
-                                          layerObj *layer, shapeObj *shape);
-  MS_DLL_EXPORT shapeObj *msV8TransformShape(shapeObj *shape,
-                                             const char* filename);
-#endif
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapv8.cpp                    */
-  /* ==================================================================== */
-
-#endif
-
-
-#ifndef SWIG
-  /*
-   * strokeStyleObj
-   */
-  typedef struct {
-    double width; /* line width in pixels */
-
-    /* line pattern, e.g. dots, dashes, etc.. */
-    int patternlength;
-    double pattern[MS_MAXPATTERNLENGTH];
-    double patternoffset;
-
-    /* must be a valid color if not NULL */
-    /* color.alpha must be used if supported by the renderer */
-    colorObj *color;
-
-    int linecap; /* MS_CJC_TRIANGLE, MS_CJC_SQUARE, MS_CJC_ROUND, MS_CJC_BUTT */
-    int linejoin; /* MS_CJC_BEVEL MS_CJC_ROUND MS_CJC_MITER */
-    double linejoinmaxsize;
-    int antialiased;
-  } strokeStyleObj;
-
-#define INIT_STROKE_STYLE(s) { (s).width=0; (s).patternlength=0; (s).color=NULL; (s).linecap=MS_CJC_ROUND; (s).linejoin=MS_CJC_ROUND; (s).linejoinmaxsize=0; (s).antialiased=MS_TRUE; }
-
-
-  /*
-   * symbolStyleObj
-   */
-  typedef struct {
-    /* must be valid colors if not NULL */
-    /* color.alpha must be used if supported by the renderer */
-    colorObj *color;
-    colorObj *backgroundcolor;
-
-    double outlinewidth;
-    colorObj *outlinecolor;
-
-    /* scalefactor to be applied on the tile or symbol*/
-    double scale;
-
-    /* rotation to apply on the symbol (and the tile?)
-     * in radians */
-    double rotation;
-
-    /* the gap to space symbols appart when used as a polygon tile
-     */
-    double gap;
-
-    /* style object, necessary for vector type renderers to be able
-     * to render symbols through other renders such as cairo/agg */
-    styleObj *style;
-  } symbolStyleObj;
-
-#define INIT_SYMBOL_STYLE(s) {(s).color=NULL; (s).backgroundcolor=NULL; (s).outlinewidth=0; (s).outlinecolor=NULL; (s).scale=1.0; (s).rotation=0; (s).style=NULL;}
-
-  struct tileCacheObj {
-    symbolObj *symbol;
-    int width;
-    int height;
-    colorObj color, outlinecolor, backgroundcolor;
-    double outlinewidth, rotation,scale;
-    imageObj *image;
-    tileCacheObj *next;
-  };
-
-
-  /*
-   * labelStyleObj
-   */
-  typedef struct {
-    /* full paths to truetype font file */
-    char* fonts[MS_MAX_LABEL_FONTS];
-    int numfonts;
-    double size;
-    double rotation;
-    colorObj *color;
-    double outlinewidth;
-    colorObj *outlinecolor;
-  } labelStyleObj;
-
-#define INIT_LABEL_STYLE(s) {memset(&(s),'\0',sizeof(labelStyleObj));}
-
-#endif
-
-#ifndef SWIG
-  MS_DLL_EXPORT int msInitializeDummyRenderer(rendererVTableObj *vtable);
-  MS_DLL_EXPORT int msInitializeRendererVTable(outputFormatObj *outputformat);
-  MS_DLL_EXPORT int msPopulateRendererVTableCairoRaster( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableCairoSVG( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableCairoPDF( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableOGL( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableAGG( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableUTFGrid( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableKML( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableOGR( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableMVT( rendererVTableObj *renderer );
-
-  MS_DLL_EXPORT int msMVTWriteTile( mapObj *map, int sendheaders );
-
-#ifdef USE_CAIRO
-  MS_DLL_EXPORT void msCairoCleanup(void);
-#endif
-
-  /* allocate 50k for starters */
-#define MS_DEFAULT_BUFFER_ALLOC 50000
-
-  typedef struct _autobuffer {
-    unsigned char *data;
-    size_t size;
-    size_t available;
-    size_t _next_allocation_size;
-  } bufferObj;
-
-
-  /* in mapimageio.c */
-  int msQuantizeRasterBuffer(rasterBufferObj *rb, unsigned int *reqcolors, rgbaPixel *palette,
-                             rgbaPixel *forced_palette, int num_forced_palette_entries,
-                             unsigned int *palette_scaling_maxval);
-  int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb);
-  int msSaveRasterBuffer(mapObj *map, rasterBufferObj *data, FILE *stream, outputFormatObj *format);
-  int msSaveRasterBufferToBuffer(rasterBufferObj *data, bufferObj *buffer, outputFormatObj *format);
-  int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb);
-
-  /* in mapagg.cpp */
-  void msApplyBlurringCompositingFilter(rasterBufferObj *rb, unsigned int radius);
-
-  int WARN_UNUSED msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb, CompositingFilter *filter);
-
-  void msBufferInit(bufferObj *buffer);
-  void msBufferResize(bufferObj *buffer, size_t target_size);
-  MS_DLL_EXPORT void msBufferFree(bufferObj *buffer);
-  MS_DLL_EXPORT void msBufferAppend(bufferObj *buffer, void *data, size_t length);
-
-  typedef struct {
-    int charWidth, charHeight;
-  } fontMetrics;
-
-  struct rendererVTableObj {
-    int supports_pixel_buffer;
-    int supports_clipping;
-    int supports_svg;
-    int use_imagecache;
-    enum MS_TRANSFORM_MODE default_transform_mode;
-    enum MS_TRANSFORM_MODE transform_mode;
-    double default_approximation_scale;
-    double approximation_scale;
-
-    void *renderer_data;
-
-    int WARN_UNUSED (*renderLine)(imageObj *img, shapeObj *p, strokeStyleObj *style);
-    int WARN_UNUSED (*renderPolygon)(imageObj *img, shapeObj *p, colorObj *color);
-    int WARN_UNUSED (*renderPolygonTiled)(imageObj *img, shapeObj *p, imageObj *tile);
-    int WARN_UNUSED (*renderLineTiled)(imageObj *img, shapeObj *p, imageObj *tile);
-
-    /* only ts->textpath is guaranteed to be populated. Other fields might be 0/NULL */
-    int WARN_UNUSED (*renderGlyphs)(imageObj *img, const textSymbolObj *ts, colorObj *clr, colorObj *olcolor, int olwidth, int isMarker);
-
-    int WARN_UNUSED (*renderVectorSymbol)(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderPixmapSymbol)(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderEllipseSymbol)(imageObj *image, double x, double y,
-                               symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderSVGSymbol)(imageObj *img, double x, double y,
-                           symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderTile)(imageObj *img, imageObj *tile, double x, double y);
-
-    int WARN_UNUSED (*loadImageFromFile)(char *path, rasterBufferObj *rb);
-
-    int WARN_UNUSED (*getRasterBufferHandle)(imageObj *img, rasterBufferObj *rb);
-    int WARN_UNUSED (*getRasterBufferCopy)(imageObj *img, rasterBufferObj *rb);
-    int WARN_UNUSED (*initializeRasterBuffer)(rasterBufferObj *rb, int width, int height, int mode);
-
-    int WARN_UNUSED (*mergeRasterBuffer)(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height);
-    int WARN_UNUSED (*compositeRasterBuffer)(imageObj *dest, rasterBufferObj *overlay, CompositingOperation comp_op, int opacity);
-
-
-    /* image i/o */
-    imageObj* WARN_UNUSED (*createImage)(int width, int height, outputFormatObj *format, colorObj* bg);
-    int WARN_UNUSED (*saveImage)(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format);
-    unsigned char* WARN_UNUSED (*saveImageBuffer)(imageObj *img, int *size_ptr, outputFormatObj *format);
-    /*...*/
-
-    int (*startLayer)(imageObj *img, mapObj *map, layerObj *layer);
-    int (*endLayer)(imageObj *img, mapObj *map, layerObj *layer);
-
-    int (*startShape)(imageObj *img, shapeObj *shape);
-    int (*endShape)(imageObj *img, shapeObj *shape);
-    int (*setClip)(imageObj *img, rectObj clipRect);
-    int (*resetClip)(imageObj *img);
-
-    int (*freeImage)(imageObj *image);
-    int (*freeSymbol)(symbolObj *symbol);
-    int (*cleanup)(void *renderer_data);
-  } ;
-  MS_DLL_EXPORT int msRenderRasterizedSVGSymbol(imageObj* img, double x, double y, symbolObj* symbol, symbolStyleObj* style);
-
-#define MS_IMAGE_RENDERER(im) ((im)->format->vtable)
-#define MS_RENDERER_CACHE(renderer) ((renderer)->renderer_data)
-#define MS_IMAGE_RENDERER_CACHE(im) MS_RENDERER_CACHE(MS_IMAGE_RENDERER((im)))
-#define MS_MAP_RENDERER(map) ((map)->outputformat->vtable)
-
-shapeObj *msOffsetCurve(shapeObj *p, double offset);
-#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
-shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset);
-#endif
-
-int msOGRSupportsIsNull(layerObj* layer);
-
-#ifdef NEED_IGNORE_RET_VAL
-static inline void IGNORE_RET_VAL(int x) { (void)x; }
-#endif
-
-#endif /* SWIG */
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAP_H */
diff -pruN 8.0.1-5/mapservutil.c 8.2.0~beta1-1~exp1/mapservutil.c
--- 8.0.1-5/mapservutil.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapservutil.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2130 +0,0 @@
-/******************************************************************************
- * $id$
- *
- * Project:  MapServer
- * Purpose:  MapServer CGI utility functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapserv.h"
-#include "maptime.h"
-#include "mapows.h"
-#include "mapogcapi.h"
-
-#include "cpl_conv.h"
-
-#include "mapserver-config.h"
-
-#include "cpl_conv.h"
-
-/*
-** Enumerated types, keep the query modes in sequence and at the end of the enumeration (mode enumeration is in maptemplate.h).
-*/
-static const int numModes = 23;
-static char *const modeStrings[23] = {"BROWSE","ZOOMIN","ZOOMOUT","MAP","LEGEND","LEGENDICON","REFERENCE","SCALEBAR","COORDINATE",
-                                "QUERY","NQUERY","ITEMQUERY","ITEMNQUERY",
-                                "FEATUREQUERY","FEATURENQUERY","ITEMFEATUREQUERY","ITEMFEATURENQUERY",
-                                "INDEXQUERY","TILE","OWS", "WFS", "MAPLEGEND", "MAPLEGENDICON"
-                               };
-
-static int commonLoadForm(mapservObj *mapserv, mapObj *map);
-
-void msCGIWriteError(mapservObj *mapserv)
-{
-  errorObj *ms_error = msGetErrorObj();
-
-  if(!ms_error || ms_error->code == MS_NOERR || ms_error->isreported) {
-    /* either we have no error, or it was already reported by other means */
-    return;
-  }
-
-  if(!mapserv || !mapserv->map) {
-    msIO_setHeader("Content-Type","text/html");
-    msIO_sendHeaders();
-    msIO_printf("<HTML>\n");
-    msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
-    msIO_printf("<BODY BGCOLOR=\"#FFFFFF\">\n");
-    msWriteErrorXML(stdout);
-    msIO_printf("</BODY></HTML>");
-    return;
-  }
-
-  if((ms_error->code == MS_NOTFOUND) && (mapserv->map->web.empty)) {
-    /* msRedirect(mapserv->map->web.empty); */
-    if(msReturnURL(mapserv, mapserv->map->web.empty, BROWSE) != MS_SUCCESS) {
-      msIO_setHeader("Content-Type","text/html");
-      msIO_sendHeaders();
-      msIO_printf("<HTML>\n");
-      msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
-      msIO_printf("<BODY BGCOLOR=\"#FFFFFF\">\n");
-      msWriteErrorXML(stdout);
-      msIO_printf("</BODY></HTML>");
-    }
-  } else {
-    if(mapserv->map->web.error) {
-      /* msRedirect(mapserv->map->web.error); */
-      if(msReturnURL(mapserv, mapserv->map->web.error, BROWSE) != MS_SUCCESS) {
-        msIO_setHeader("Content-Type","text/html");
-        msIO_sendHeaders();
-        msIO_printf("<HTML>\n");
-        msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
-        msIO_printf("<BODY BGCOLOR=\"#FFFFFF\">\n");
-        msWriteErrorXML(stdout);
-        msIO_printf("</BODY></HTML>");
-      }
-    } else {
-      msIO_setHeader("Content-Type","text/html");
-      msIO_sendHeaders();
-      msIO_printf("<HTML>\n");
-      msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
-      msIO_printf("<BODY BGCOLOR=\"#FFFFFF\">\n");
-      msWriteErrorXML(stdout);
-      msIO_printf("</BODY></HTML>");
-    }
-  }
-}
-
-/*
-** Converts a string (e.g. form parameter) to a double, first checking the format against
-** a regular expression. returns an error if the format test fails.
-*/
-
-#define GET_NUMERIC(string,dbl) do { \
-  dbl = strtod((string), &strtoderr);\
-  if (*strtoderr) {\
-    msSetError(MS_TYPEERR, NULL, "GET_NUMERIC()");\
-    return MS_FAILURE;\
-  }\
-} while (0)
-
-#define GET_NUMERIC_NO_ERROR(string,dbl) dbl = strtod((string), &strtoderr);
-
-#define FREE_TOKENS_ON_ERROR(ntok) if(!strtoderr) {\
-  msSetError(MS_TYPEERR, "invalid number", "msCGILoadForm()");\
-  msFreeCharArray(tokens,(ntok));\
-  return MS_FAILURE;\
-}
-
-static void setClassGroup(layerObj *layer, char *classgroup)
-{
-  int i;
-
-  if(!layer || !classgroup) return;
-
-  for(i=0; i<layer->numclasses; i++) {
-    if(layer->class[i]->group && strcmp(layer->class[i]->group, classgroup) == 0) {
-      msFree(layer->classgroup);
-      layer->classgroup = msStrdup(classgroup);
-      return; /* bail */
-    }
-  }
-}
-
-/*
-** Extract Map File name from params and load it.
-** Returns map object or NULL on error.
-*/
-mapObj *msCGILoadMap(mapservObj *mapserv, configObj *config)
-{
-  int i;
-  mapObj *map = NULL;
-
-  const char *ms_map_bad_pattern_default = "[/\\]{2}|[/\\]?\\.+[/\\]|,";
-
-  int ms_mapfile_tainted = MS_TRUE;
-  const char *ms_mapfile = CPLGetConfigOption("MS_MAPFILE", NULL);
-
-  const char *ms_map_no_path = CPLGetConfigOption("MS_MAP_NO_PATH", NULL);
-  const char *ms_map_pattern = CPLGetConfigOption("MS_MAP_PATTERN", NULL);
-
-  const char *ms_map_bad_pattern = CPLGetConfigOption("MS_MAP_BAD_PATTERN", NULL);
-  if(ms_map_bad_pattern == NULL) ms_map_bad_pattern = ms_map_bad_pattern_default;
-
-  const char *map_value = NULL;
-
-  if(mapserv->request->api_path != NULL) {
-    map_value = mapserv->request->api_path[0]; /* mapfile is *always* in the first position (/{mapfile}/{signature}) of an API call */
-  } else {
-    for(i=0; i<mapserv->request->NumParams; i++) { /* find the map parameter */
-      if(strcasecmp(mapserv->request->ParamNames[i], "map") == 0) {
-        map_value = mapserv->request->ParamValues[i];
-        break;
-      }
-    }
-  }
-
-  if(map_value == NULL) {
-    if(ms_mapfile == NULL) {
-      msSetError(MS_WEBERR, "CGI variable \"map\" is not set.", "msCGILoadMap()"); /* no default, outta here */
-      return NULL;
-    }
-    ms_mapfile_tainted = MS_FALSE;
-  } else {
-    ms_mapfile = msConfigGetMap(config, map_value); /* does NOT check the environment, only the config */
-    if(ms_mapfile) {
-      ms_mapfile_tainted = MS_FALSE;
-    } else {
-      /* by now we know the map parameter isn't referencing something in the configuration */
-      if(ms_map_no_path != NULL) {
-        msSetError(MS_WEBERR, "CGI variable \"map\" not found in configuration and this server is not configured for full paths.", "msCGILoadMap()");
-        return NULL;
-      }
-      ms_mapfile = map_value;
-    }
-  }
-
-  /* validate ms_mapfile if tainted */
-  if(ms_mapfile_tainted == MS_TRUE) {
-    if(ms_map_pattern == NULL) { // can't go any further, bail
-      msSetError(MS_WEBERR, "Required configuration value MS_MAP_PATTERN not set.", "msCGILoadMap()");
-      return NULL;
-    }
-    if(msIsValidRegex(ms_map_bad_pattern) == MS_FALSE || msEvalRegex(ms_map_bad_pattern, ms_mapfile) == MS_TRUE) {
-      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.", "msCGILoadMap()");
-      return NULL;
-    }
-    if(msEvalRegex(ms_map_pattern, ms_mapfile) != MS_TRUE) {
-      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.", "msCGILoadMap()");
-      return NULL;
-    }
-  }
-
-  /* ok to try to load now */
-  map = msLoadMap(ms_mapfile, NULL, config);
-  if(!map) return NULL;  
-
-  /* handle common parameters */
-  if(commonLoadForm(mapserv, map) != MS_SUCCESS) {
-    msFreeMap(map);
-    return NULL;
-  }
-
-  if(!msLookupHashTable(&(map->web.validation), "immutable")) {
-    /* check for any %variable% substitutions, we do this here so WMS/WFS  */
-    /* services can take advantage of these "vendor specific" extensions */
-
-    msApplySubstitutions(map, mapserv->request->ParamNames, mapserv->request->ParamValues, mapserv->request->NumParams);
-    msApplyDefaultSubstitutions(map);
-
-    /* check to see if a ogc map context is passed as argument. if there */
-    /* is one load it */
-
-    for(i=0; i<mapserv->request->NumParams; i++) {
-      if(strcasecmp(mapserv->request->ParamNames[i],"context") == 0) {
-        if(mapserv->request->ParamValues[i] && strlen(mapserv->request->ParamValues[i]) > 0) {
-          if(strncasecmp(mapserv->request->ParamValues[i],"http",4) == 0) {
-            if(msGetConfigOption(map, "CGI_CONTEXT_URL"))
-              msLoadMapContextURL(map, mapserv->request->ParamValues[i], MS_FALSE);
-          } else {
-            const char *map_context_filename = mapserv->request->ParamValues[i];
-            const char *ms_context_pattern = CPLGetConfigOption("MS_CONTEXT_PATTERN", NULL);
-            const char *ms_context_bad_pattern = CPLGetConfigOption("MS_CONTEXT_BAD_PATTERN", NULL);
-            if(ms_context_bad_pattern == NULL) ms_context_bad_pattern = ms_map_bad_pattern_default;
-
-            if(ms_context_pattern == NULL) { // can't go any further, bail
-              msSetError(MS_WEBERR, "Required configuration value MS_CONTEXT_PATTERN not set.", "msCGILoadMap()");
-              msFreeMap(map);
-              return NULL;
-            }
-            if(msIsValidRegex(ms_context_bad_pattern) == MS_FALSE ||
-               msEvalRegex(ms_context_bad_pattern, map_context_filename) == MS_TRUE) {
-              msSetError(MS_WEBERR, "CGI variable \"context\" fails to validate.", "msCGILoadMap()");
-              msFreeMap(map);
-              return NULL;
-            }
-            if(msEvalRegex(ms_context_pattern, map_context_filename) != MS_TRUE) {
-              msSetError(MS_WEBERR, "CGI variable \"context\" fails to validate.", "msCGILoadMap()");
-              msFreeMap(map);
-              return NULL;
-            }
-            msLoadMapContext(map, map_context_filename, MS_FALSE);
-          }
-        }
-      }
-    }
-  }
-
-  /*
-   * RFC-42 HTTP Cookie Forwarding
-   * Here we set the http_cookie_data metadata to handle the
-   * HTTP Cookie Forwarding. The content of this metadata is the cookie
-   * content. In the future, this metadata will probably be replaced
-   * by an object that is part of the mapObject that would contain
-   * information on the application status (such as cookie).
-   */
-  if( mapserv->request->httpcookiedata != NULL ) {
-    msInsertHashTable( &(map->web.metadata), "http_cookie_data",
-                       mapserv->request->httpcookiedata );
-  }
-
-  return map;
-}
-
-
-/*
-** Set operation mode. First look in MS_MODE env. var. as a
-** default value that can be overridden by the mode=... CGI param.
-** Returns silently, leaving mapserv->Mode unchanged if mode param not set.
-*/
-int msCGISetMode(mapservObj *mapserv)
-{
-  const char *mode = NULL;
-  int i, j;
-
-
-  mode = CPLGetConfigOption("MS_MODE", NULL);
-  for( i=0; i<mapserv->request->NumParams; i++ ) {
-    if(strcasecmp(mapserv->request->ParamNames[i], "mode") == 0) {
-      mode = mapserv->request->ParamValues[i];
-      break;
-    }
-  }
-
-  if (mode) {
-    for(j=0; j<numModes; j++) {
-      if(strcasecmp(mode, modeStrings[j]) == 0) {
-        mapserv->Mode = j;
-        break;
-      }
-    }
-
-    if(j == numModes) {
-      msSetError(MS_WEBERR, "Invalid mode.", "msCGISetMode()");
-      return MS_FAILURE;
-    }
-  }
-
-  if (mapserv->Mode >= 0)
-  {
-    int disabled = MS_FALSE;
-    const char* enable_modes = msLookupHashTable(&mapserv->map->web.metadata, "ms_enable_modes");
-
-    if (!msOWSParseRequestMetadata(enable_modes, mode, &disabled) && disabled) {
-      /* the current mode is disabled */
-      msSetError(MS_WEBERR, "The specified mode '%s' is not supported by the current map configuration", "msCGISetMode()", mode);
-      return MS_FAILURE;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** API-related funtions.
-*/
-int msCGIIsAPIRequest(mapservObj *mapserv) 
-{
-  char **tmp_api_path=NULL;
-  int i, n, tmp_api_path_length=0;
-
-  mapserv->request->path_info = getenv("PATH_INFO");
-  if(mapserv->request->path_info != NULL && strlen(mapserv->request->path_info) > 0) {
-    tmp_api_path = msStringSplit(mapserv->request->path_info, '/', &tmp_api_path_length); // ignores consecutive delimeters
-    if(tmp_api_path_length >= 3) { // /{mapfile}/{signature} so 3 components at a minimum (1st component is a zero-length string)
-
-      // capture only non-zero length components
-      n = 0;
-      for(i=0; i<tmp_api_path_length; i++) {
-        if(strlen(tmp_api_path[i]) > 0)
-          n++;
-      }
-
-      if(n < 2) { // not enough non-zero length components for a legitimate API request
-        msFreeCharArray(tmp_api_path, tmp_api_path_length);
-        return MS_FALSE;
-      }
-
-      mapserv->request->api_path = (char **) msSmallMalloc(sizeof(char *)*n);
-      if(mapserv->request->api_path == NULL) {
-        msFreeCharArray(tmp_api_path, tmp_api_path_length);
-        return MS_FALSE;
-      }
-
-      mapserv->request->api_path_length = 0;
-      for(i=0; i<tmp_api_path_length; i++) {
-        if(strlen(tmp_api_path[i]) > 0) {
-          mapserv->request->api_path[mapserv->request->api_path_length] = msStrdup(tmp_api_path[i]);
-          mapserv->request->api_path_length++;
-        }
-      }
-
-      msFreeCharArray(tmp_api_path, tmp_api_path_length);
-      return MS_TRUE;
-    } else {
-      msFreeCharArray(tmp_api_path, tmp_api_path_length);      
-    }
-  }
-
-  return MS_FALSE;
-}
-
-int msCGIDispatchAPIRequest(mapservObj *mapserv) 
-{
-  // should be a more elegant way to do this (perhaps similar to how drivers are handled)
-  if(strcmp("ogcapi", mapserv->request->api_path[1]) == 0) {
-#ifdef USE_OGCAPI_SVR
-    return msOGCAPIDispatchRequest(mapserv->map, mapserv->request);
-#else
-    msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.", "msCGIDispatchAPIRequest()");
-#endif
-  } else {
-    msSetError(MS_WEBERR, "Invalid API signature.", "msCGIDispatchAPIRequest()");
-  }
-
-  return MS_FAILURE;
-}
-
-/*
-** Process common parameters that can apply to CGI and WxS calls - there are just a few and affect the mapObj directly.
-*/
-static int commonLoadForm(mapservObj *mapserv, mapObj *map)
-{
-  double tmpval;
-  char *strtoderr;
-
-  if(!mapserv || !map) return MS_FAILURE;
-
-  for(int i=0; i<mapserv->request->NumParams; i++) {
-    if(strlen(mapserv->request->ParamValues[i]) == 0) continue;
-
-    if(strncasecmp(mapserv->request->ParamNames[i], "classgroup", 10) == 0) { /* #4207 */
-      for(int j=0; j<map->numlayers; j++) {
-	setClassGroup(GET_LAYER(map, j), mapserv->request->ParamValues[i]);
-      }
-      continue;
-    }
-
-    /*
-    ** For backwards compatibility. Might want to consider a vendor parameter for WFS specifically and then deprecate this.
-    */
-    if(strcasecmp(mapserv->request->ParamNames[i], "map.extent") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map_extent") == 0) {      
-      int n=0;
-      char **tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-	msSetError(MS_MEMERR, NULL, "commonLoadForm()");
-	return MS_FAILURE;
-      }
-
-      if(n != 4) {
-	msSetError(MS_WEBERR, "Not enough arguments for mapext.", "commonLoadForm()");
-	msFreeCharArray(tokens,n);
-	return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0], map->extent.minx);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[1], map->extent.miny);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[2], map->extent.maxx);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[3], map->extent.maxy);
-      FREE_TOKENS_ON_ERROR(4);
-
-      msFreeCharArray(tokens, 4);
-
-      if (!MS_VALID_EXTENT(map->extent)) {
-	msSetError(MS_WEBERR, "Supplied extent is invalid. Check that it is in the form: minx, miny, maxx, maxy", "commonLoadForm()");
-	return(MS_FAILURE);
-      }
-    }
-
-    /* 
-    ** For backwards compatibility - we don't use plain RESOLUTION here because of a potential conflict WCS. Might want
-    ** to consider a vendor parameter for WMS specifically and then deprecate these.
-    */
-    if(strcasecmp(mapserv->request->ParamNames[i], "map.resolution") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map_resolution") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
-      if(tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
-        msSetError(MS_WEBERR, "Resolution value out of range.", "commonLoadForm()");
-        return MS_FAILURE;
-      }
-      map->resolution = (int)tmpval;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"keysize") == 0) { // legend keysize, used with legend-related outputs
-      int n=0;
-      char **tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "commonLoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for keysize.", "commonLoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      map->legend.keysizex = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      map->legend.keysizey = (int)tmpval;
-
-      msFreeCharArray(tokens, 2);
-
-      if(map->legend.keysizex < MS_LEGEND_KEYSIZE_MIN || map->legend.keysizex > MS_LEGEND_KEYSIZE_MAX || map->legend.keysizey < MS_LEGEND_KEYSIZE_MIN || map->legend.keysizey > MS_LEGEND_KEYSIZE_MAX) {
-        msSetError(MS_WEBERR, "Legend keysize out of range.", "commonLoadForm()");
-        return MS_FAILURE;
-      }
-
-      continue;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Process CGI parameters.
-*/
-int msCGILoadForm(mapservObj *mapserv)
-{
-  int i,n;
-  char **tokens=NULL;
-  int rosa_type=0;
-  double tmpval;
-  char *strtoderr;
-
-  for(i=0; i<mapserv->request->NumParams; i++) { /* now process the rest of the form variables */
-    if(strlen(mapserv->request->ParamValues[i]) == 0)
-      continue;
-
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"icon") == 0) {
-      mapserv->icon = msStrdup(mapserv->request->ParamValues[i]);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"queryfile") == 0) {
-      mapserv->QueryFile = msStrdup(mapserv->request->ParamValues[i]);
-      if(msValidateParameter(mapserv->QueryFile, msLookupHashTable(&(mapserv->map->web.validation), "queryfile"), NULL, NULL, NULL) != MS_SUCCESS) {
-        msSetError(MS_WEBERR, "Parameter 'queryfile' value fails to validate.", "mapserv()");
-        return MS_FAILURE;
-      }
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"savequery") == 0) {
-      mapserv->savequery = MS_TRUE;
-      continue;
-    }
-
-    /* Insecure as implemented, need to save someplace non accessible by everyone in the universe
-        if(strcasecmp(mapserv->request->ParamNames[i],"savemap") == 0) {
-         mapserv->savemap = MS_TRUE;
-         continue;
-        }
-    */
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"zoom") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->Zoom);
-      if((mapserv->Zoom > MAXZOOM) || (mapserv->Zoom < MINZOOM)) {
-        msSetError(MS_WEBERR, "Zoom value out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"zoomdir") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
-      mapserv->ZoomDirection = (int)tmpval;
-      if((mapserv->ZoomDirection != -1) && (mapserv->ZoomDirection != 1) && (mapserv->ZoomDirection != 0)) {
-        msSetError(MS_WEBERR, "Zoom direction must be 1, 0 or -1.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"zoomsize") == 0) { /* absolute zoom magnitude */
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
-      mapserv->ZoomSize = (int)tmpval;
-      if((mapserv->ZoomSize > MAXZOOM) || (mapserv->ZoomSize < 1)) {
-        msSetError(MS_WEBERR, "Invalid zoom size.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgext") == 0) { /* extent of an existing image in a web application */
-      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 4) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgext.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->ImgExt.minx);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->ImgExt.miny);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[2],mapserv->ImgExt.maxx);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[3],mapserv->ImgExt.maxy);
-      FREE_TOKENS_ON_ERROR(4);
-
-      msFreeCharArray(tokens, 4);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"searchmap") == 0) {
-      mapserv->SearchMap = MS_TRUE;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"id") == 0) {
-      if(msEvalRegex(IDPATTERN, mapserv->request->ParamValues[i]) == MS_FALSE) {
-        msSetError(MS_WEBERR, "Parameter 'id' value fails to validate.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      strlcpy(mapserv->Id, mapserv->request->ParamValues[i], IDSIZE);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"mapext") == 0) { /* extent of the new map or query */
-
-      if(strncasecmp(mapserv->request->ParamValues[i],"shape",5) == 0)
-        mapserv->UseShapes = MS_TRUE;
-      else {
-        tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-        if(!tokens) {
-          msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-          return MS_FAILURE;
-        }
-
-        if(n != 4) {
-          msSetError(MS_WEBERR, "Not enough arguments for mapext.", "msCGILoadForm()");
-          msFreeCharArray(tokens,n);
-          return MS_FAILURE;
-        }
-
-        GET_NUMERIC_NO_ERROR(tokens[0],mapserv->map->extent.minx);
-        FREE_TOKENS_ON_ERROR(4);
-        GET_NUMERIC_NO_ERROR(tokens[1],mapserv->map->extent.miny);
-        FREE_TOKENS_ON_ERROR(4);
-        GET_NUMERIC_NO_ERROR(tokens[2],mapserv->map->extent.maxx);
-        FREE_TOKENS_ON_ERROR(4);
-        GET_NUMERIC_NO_ERROR(tokens[3],mapserv->map->extent.maxy);
-        FREE_TOKENS_ON_ERROR(4);
-
-        msFreeCharArray(tokens, 4);
-
-        /*
-         * If there is a projection in the map file, and it is not lon/lat, and the
-         * extents "look like" they *are* lon/lat, based on their size,
-         * then convert the extents to the map file projection.
-         *
-         * DANGER: If the extents are legitimately in the mapfile projection
-         *         and coincidentally fall in the lon/lat range, bad things
-         *         will ensue.
-         */
-        if(mapserv->map->projection.proj && !msProjIsGeographicCRS(&(mapserv->map->projection))
-            && (mapserv->map->extent.minx >= -180.0 && mapserv->map->extent.minx <= 180.0)
-            && (mapserv->map->extent.miny >= -90.0 && mapserv->map->extent.miny <= 90.0)
-            && (mapserv->map->extent.maxx >= -180.0 && mapserv->map->extent.maxx <= 180.0)
-            && (mapserv->map->extent.maxy >= -90.0 && mapserv->map->extent.maxy <= 90.0)) {
-          msProjectRect(&(mapserv->map->latlon), &(mapserv->map->projection), &(mapserv->map->extent)); /* extent is a in lat/lon */
-        }
-
-        if((mapserv->map->extent.minx != mapserv->map->extent.maxx) && (mapserv->map->extent.miny != mapserv->map->extent.maxy)) { /* extent seems ok */
-          mapserv->CoordSource = FROMUSERBOX;
-          mapserv->QueryCoordSource = FROMUSERBOX;
-        }
-      }
-
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"minx") == 0) { /* extent of the new map, in pieces */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.minx);
-      continue;
-    }
-    if(strcasecmp(mapserv->request->ParamNames[i],"maxx") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.maxx);
-      continue;
-    }
-    if(strcasecmp(mapserv->request->ParamNames[i],"miny") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.miny);
-      continue;
-    }
-    if(strcasecmp(mapserv->request->ParamNames[i],"maxy") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.maxy);
-      mapserv->CoordSource = FROMUSERBOX;
-      mapserv->QueryCoordSource = FROMUSERBOX;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"mapxy") == 0) { /* user map coordinate */
-
-      if(strncasecmp(mapserv->request->ParamValues[i],"shape",5) == 0) {
-        mapserv->UseShapes = MS_TRUE;
-      } else {
-        tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-        if(!tokens) {
-          msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-          return MS_FAILURE;
-        }
-
-        if(n != 2) {
-          msSetError(MS_WEBERR, "Not enough arguments for mapxy.", "msCGILoadForm()");
-          msFreeCharArray(tokens,n);
-          return MS_FAILURE;
-        }
-
-        GET_NUMERIC_NO_ERROR(tokens[0],mapserv->mappnt.x );
-        FREE_TOKENS_ON_ERROR(2);
-        GET_NUMERIC_NO_ERROR(tokens[1],mapserv->mappnt.y );
-        FREE_TOKENS_ON_ERROR(2);
-
-        msFreeCharArray(tokens, 2);
-
-        if(mapserv->map->projection.proj && !msProjIsGeographicCRS(&(mapserv->map->projection))
-            && (mapserv->mappnt.x >= -180.0 && mapserv->mappnt.x <= 180.0)
-            && (mapserv->mappnt.y >= -90.0 && mapserv->mappnt.y <= 90.0)) {
-          msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection), &mapserv->mappnt); /* point is a in lat/lon */
-        }
-
-        if(mapserv->CoordSource == NONE) { /* don't override previous settings (i.e. buffer or scale ) */
-          mapserv->CoordSource = FROMUSERPNT;
-          mapserv->QueryCoordSource = FROMUSERPNT;
-        }
-      }
-      continue;
-    }
-
-    /*
-    ** Query shape consisting of map or image coordinates. It's almost identical processing so we'll do either in this block...
-    */
-    if(strcasecmp(mapserv->request->ParamNames[i], "mapshape") == 0 || strcasecmp(mapserv->request->ParamNames[i], "imgshape") == 0) {
-      if(strcasecmp(mapserv->request->ParamNames[i],"mapshape") == 0)
-        mapserv->QueryCoordSource = FROMUSERSHAPE;
-      else
-        mapserv->QueryCoordSource = FROMIMGSHAPE;
-
-      if(strchr(mapserv->request->ParamValues[i], '(') != NULL) { /* try WKT */
-        if((mapserv->map->query.shape = msShapeFromWKT(mapserv->request->ParamValues[i])) == NULL) {
-          msSetError(MS_WEBERR, "WKT parse failed for mapshape/imgshape.", "msCGILoadForm()");
-          return MS_FAILURE;
-        }
-      } else {
-        lineObj line= {0,NULL};
-        char **tmp=NULL;
-        int n, j;
-
-        tmp = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-        if(n%2 != 0 || n<8) { /* n must be even and be at least 8 */
-          msSetError(MS_WEBERR, "Malformed polygon geometry for mapshape/imgshape.", "msCGILoadForm()");
-          msFreeCharArray(tmp,n);
-          return MS_FAILURE;
-        }
-
-        line.numpoints = n/2;
-        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*line.numpoints);
-
-        mapserv->map->query.shape = (shapeObj *) msSmallMalloc(sizeof(shapeObj));
-        msInitShape(mapserv->map->query.shape);
-        mapserv->map->query.shape->type = MS_SHAPE_POLYGON;
-
-        for(j=0; j<line.numpoints; j++) {
-          line.point[j].x = atof(tmp[2*j]);
-          line.point[j].y = atof(tmp[2*j+1]);
-
-          if(mapserv->QueryCoordSource == FROMUSERSHAPE && mapserv->map->projection.proj && !msProjIsGeographicCRS(&(mapserv->map->projection))
-              && (line.point[j].x >= -180.0 && line.point[j].x <= 180.0)
-              && (line.point[j].y >= -90.0 && line.point[j].y <= 90.0)) {
-            msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection), &line.point[j]); /* point is a in lat/lon */
-          }
-        }
-
-        if(msAddLine(mapserv->map->query.shape, &line) == -1) {
-          msFree(line.point);
-          msFreeCharArray(tmp, n);
-          return MS_FAILURE;
-        }
-
-        msFree(line.point);
-        msFreeCharArray(tmp, n);
-      }
-
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"img.x") == 0) { /* mouse click, in pieces */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->ImgPnt.x);
-      if((mapserv->ImgPnt.x > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.x < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      mapserv->CoordSource = FROMIMGPNT;
-      mapserv->QueryCoordSource = FROMIMGPNT;
-      continue;
-    }
-    if(strcasecmp(mapserv->request->ParamNames[i],"img.y") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->ImgPnt.y);
-      if((mapserv->ImgPnt.y > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.y < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      mapserv->CoordSource = FROMIMGPNT;
-      mapserv->QueryCoordSource = FROMIMGPNT;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgxy") == 0) { /* mouse click, single variable */
-      if(mapserv->CoordSource == FROMIMGPNT)
-        continue;
-
-      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgxy.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->ImgPnt.x );
-      FREE_TOKENS_ON_ERROR(2);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->ImgPnt.y );
-      FREE_TOKENS_ON_ERROR(2);
-
-      msFreeCharArray(tokens, 2);
-
-      if((mapserv->ImgPnt.x > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.x < (-2*mapserv->map->maxsize)) || (mapserv->ImgPnt.y > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.y < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Reference map coordinate out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(mapserv->CoordSource == NONE) { /* override nothing since this parameter is usually used to hold a default value */
-        mapserv->CoordSource = FROMIMGPNT;
-        mapserv->QueryCoordSource = FROMIMGPNT;
-      }
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgbox") == 0) { /* selection box (eg. mouse drag) */
-      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 4) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgbox.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->ImgBox.minx);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->ImgBox.miny);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[2],mapserv->ImgBox.maxx);
-      FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[3],mapserv->ImgBox.maxy);
-      FREE_TOKENS_ON_ERROR(4);
-
-      msFreeCharArray(tokens, 4);
-
-      if((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) && (mapserv->ImgBox.miny != mapserv->ImgBox.maxy)) { /* must not degenerate into a point */
-        mapserv->CoordSource = FROMIMGBOX;
-        mapserv->QueryCoordSource = FROMIMGBOX;
-      }
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"ref.x") == 0) { /* mouse click in reference image, in pieces */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->RefPnt.x);
-      if((mapserv->RefPnt.x > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.x < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      mapserv->CoordSource = FROMREFPNT;
-      continue;
-    }
-    if(strcasecmp(mapserv->request->ParamNames[i],"ref.y") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->RefPnt.y);
-      if((mapserv->RefPnt.y > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.y < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      mapserv->CoordSource = FROMREFPNT;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"refxy") == 0) { /* mouse click in reference image, single variable */
-      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgxy.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->RefPnt.x);
-      FREE_TOKENS_ON_ERROR(2);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->RefPnt.y);
-      FREE_TOKENS_ON_ERROR(2);
-
-      msFreeCharArray(tokens, 2);
-
-      if((mapserv->RefPnt.x > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.x < (-2*mapserv->map->maxsize)) || (mapserv->RefPnt.y > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.y < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Reference map coordinate out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      mapserv->CoordSource = FROMREFPNT;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"buffer") == 0) { /* radius (map units), actually 1/2 square side */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->Buffer);
-      mapserv->CoordSource = FROMBUF;
-      mapserv->QueryCoordSource = FROMUSERPNT;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"scale") == 0 || strcasecmp(mapserv->request->ParamNames[i],"scaledenom") == 0) { /* scale for new map */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->ScaleDenom);
-      if(mapserv->ScaleDenom <= 0) {
-        msSetError(MS_WEBERR, "Scale out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      mapserv->CoordSource = FROMSCALE;
-      mapserv->QueryCoordSource = FROMUSERPNT;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgsize") == 0) { /* size of existing image (pixels) */
-      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgsize.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      mapserv->ImgCols = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      mapserv->ImgRows = (int)tmpval;
-
-      msFreeCharArray(tokens, 2);
-
-      if(mapserv->ImgCols > mapserv->map->maxsize || mapserv->ImgRows > mapserv->map->maxsize || mapserv->ImgCols <= 0 || mapserv->ImgRows <= 0) {
-        msSetError(MS_WEBERR, "Image size out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i], "resolution") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
-      if(tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
-        msSetError(MS_WEBERR, "Resolution value out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      mapserv->map->resolution = (int)tmpval;
-      continue;
-    }
-
-    // map.imagetype and map_imagetype are for backwards compatibility and may be removed in the future
-    if(strcasecmp(mapserv->request->ParamNames[i], "imagetype") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map.imagetype") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map_imagetype") == 0) {
-
-      const char *imagetype_validation_pattern = msLookupHashTable(&(mapserv->map->web.validation), "imagetype");
-      if(imagetype_validation_pattern != NULL && msEvalRegex(imagetype_validation_pattern, mapserv->request->ParamValues[i]) != MS_TRUE) { /* optional check */
-	msSetError(MS_WEBERR, "Imagetype value fails to validate.", "msCGILoadMap()");
-	return MS_FAILURE;
-      }
-
-      outputFormatObj *format = msSelectOutputFormat(mapserv->map, mapserv->request->ParamValues[i]);
-      if(format == NULL) {
-	msSetError(MS_WEBERR, "Invalid imagetype value.\n", "msCGILoadForm()");
-        return MS_FAILURE;
-      } else {
-	msFree((char *) mapserv->map->imagetype);
-	mapserv->map->imagetype = msStrdup(mapserv->request->ParamValues[i]);
-	msApplyOutputFormat(&(mapserv->map->outputformat), format, MS_NOOVERRIDE);
-      }
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"tilesize") == 0) { /* size of existing image (pixels) */
-      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for tilesize.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      mapserv->TileWidth = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      mapserv->TileHeight = (int)tmpval;
-
-      msFreeCharArray(tokens, 2);
-
-      if(mapserv->TileWidth > mapserv->map->maxsize || mapserv->TileHeight > mapserv->map->maxsize || mapserv->TileWidth <= 0 || mapserv->TileHeight <= 0) {
-        msSetError(MS_WEBERR, "Tile size out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      continue;
-    }
-
-    /* size of new map (pixels), map.size/map_size are included for backwards compatibility and may be removed in future release */
-    if(strcasecmp(mapserv->request->ParamNames[i],"mapsize") == 0 ||
-       strcasecmp(mapserv->request->ParamNames[i],"map.size") == 0 || strcasecmp(mapserv->request->ParamNames[i],"map_size") == 0) {
-      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
-
-      if(!tokens) {
-        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for mapsize.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
-        return MS_FAILURE;
-      }
-
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      mapserv->map->width = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
-      FREE_TOKENS_ON_ERROR(2);
-      mapserv->map->height = (int)tmpval;
-
-      msFreeCharArray(tokens, 2);
-
-      if(mapserv->map->width > mapserv->map->maxsize || mapserv->map->height > mapserv->map->maxsize || mapserv->map->width <= 0 || mapserv->map->height <= 0) {
-        msSetError(MS_WEBERR, "Image size out of range.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      continue;
-    }
-
-    if(strncasecmp(mapserv->request->ParamNames[i],"layers", 6) == 0) { /* turn a set of layers, delimited by spaces, on */
-
-      /* If layers=all then turn on all layers */
-      if (strcasecmp(mapserv->request->ParamValues[i], "all") == 0) {
-        int l;
-
-        /* Reset NumLayers=0. If individual layers were already selected then free the previous values.  */
-        for(l=0; l<mapserv->NumLayers; l++)
-          msFree(mapserv->Layers[l]);
-        mapserv->NumLayers=0;
-
-        for(mapserv->NumLayers=0; mapserv->NumLayers < mapserv->map->numlayers; mapserv->NumLayers++) {
-          if(msGrowMapservLayers(mapserv) == MS_FAILURE)
-            return MS_FAILURE;
-
-          if(GET_LAYER(mapserv->map, mapserv->NumLayers)->name) {
-            mapserv->Layers[mapserv->NumLayers] = msStrdup(GET_LAYER(mapserv->map, mapserv->NumLayers)->name);
-          } else {
-            mapserv->Layers[mapserv->NumLayers] = msStrdup("");
-          }
-        }
-      } else {
-        int num_layers=0, l;
-        char **layers=NULL;
-
-        layers = msStringSplit(mapserv->request->ParamValues[i], ' ', &(num_layers));
-        for(l=0; l<num_layers; l++) {
-          if(msGrowMapservLayers(mapserv) == MS_FAILURE) {
-            msFreeCharArray(layers, num_layers);
-            return MS_FAILURE;
-          }
-          mapserv->Layers[mapserv->NumLayers++] = msStrdup(layers[l]);
-        }
-
-        msFreeCharArray(layers, num_layers);
-        num_layers = 0;
-      }
-
-      continue;
-    }
-
-    if(strncasecmp(mapserv->request->ParamNames[i],"layer", 5) == 0) { /* turn a single layer/group on */
-      if(msGrowMapservLayers(mapserv) == MS_FAILURE)
-        return MS_FAILURE;
-      mapserv->Layers[mapserv->NumLayers] = msStrdup(mapserv->request->ParamValues[i]);
-      mapserv->NumLayers++;
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"qlayer") == 0) { /* layer to query (i.e search) */
-      mapserv->QueryLayer = msStrdup(mapserv->request->ParamValues[i]);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"qitem") == 0) { /* attribute to query on (optional) */
-      mapserv->QueryItem = msStrdup(mapserv->request->ParamValues[i]);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"qstring") == 0) { /* attribute query string */
-      mapserv->QueryString = msStrdup(mapserv->request->ParamValues[i]);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"qformat") == 0) { /* format to apply to query results (shortcut instead of having to use "map.web=QUERYFORMAT+foo") */
-      if(mapserv->map->web.queryformat) free(mapserv->map->web.queryformat); /* avoid leak */
-      mapserv->map->web.queryformat = msStrdup(mapserv->request->ParamValues[i]);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"slayer") == 0) { /* layer to select (for feature based search) */
-      mapserv->SelectLayer = msStrdup(mapserv->request->ParamValues[i]);
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"shapeindex") == 0) { /* used for index queries */
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
-      mapserv->ShapeIndex = (int)tmpval;
-      continue;
-    }
-    if(strcasecmp(mapserv->request->ParamNames[i],"tileindex") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
-      mapserv->TileIndex = (int)tmpval;
-      continue;
-    }
-
-    /* --------------------------------------------------------------------
-     *   The following code is used to support mode=tile
-     * -------------------------------------------------------------------- */
-
-    if(strcasecmp(mapserv->request->ParamNames[i], "tilemode") == 0) {
-      /* currently, only valid tilemode is "spheremerc" */
-      if( strcasecmp(mapserv->request->ParamValues[i], "gmap") == 0) {
-        mapserv->TileMode = TILE_GMAP;
-      } else if ( strcasecmp(mapserv->request->ParamValues[i], "ve") == 0 ) {
-        mapserv->TileMode = TILE_VE;
-      } else {
-        msSetError(MS_WEBERR, "Invalid tilemode. Use one of: gmap, ve", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      continue;
-    }
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"tile") == 0) {
-
-      if( strlen(mapserv->request->ParamValues[i]) < 1 ) {
-        msSetError(MS_WEBERR, "Empty tile parameter.", "msCGILoadForm()");
-        return MS_FAILURE;
-      }
-      mapserv->CoordSource = FROMTILE;
-      mapserv->TileCoords = msStrdup(mapserv->request->ParamValues[i]);
-
-      continue;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      The following code is used to support the rosa applet (for      */
-    /*      more information on Rosa, please consult :                      */
-    /*      http://www.maptools.org/rosa/) .                                */
-    /*      This code was provided by Tim.Mackey@agso.gov.au.               */
-    /*                                                                      */
-    /*      For Application using it can be seen at :                       */
-    /*        http://www.agso.gov.au/map/pilbara/                           */
-    /*                                                                      */
-    /* -------------------------------------------------------------------- */
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"INPUT_TYPE") == 0) {
-      /* Rosa input type */
-      if(strcasecmp(mapserv->request->ParamValues[i],"auto_rect") == 0) {
-        rosa_type=1; /* rectangle */
-        continue;
-      }
-
-      if(strcasecmp(mapserv->request->ParamValues[i],"auto_point") == 0) {
-        rosa_type=2; /* point */
-        continue;
-      }
-    }
-    if(strcasecmp(mapserv->request->ParamNames[i],"INPUT_COORD") == 0) {
-      /* Rosa coordinates */
-
-      switch(rosa_type) {
-        case 1:
-          sscanf(mapserv->request->ParamValues[i],"%lf,%lf;%lf,%lf",
-                 &mapserv->ImgBox.minx,&mapserv->ImgBox.miny,&mapserv->ImgBox.maxx,
-                 &mapserv->ImgBox.maxy);
-          if((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) &&
-              (mapserv->ImgBox.miny != mapserv->ImgBox.maxy)) {
-            mapserv->CoordSource = FROMIMGBOX;
-            mapserv->QueryCoordSource = FROMIMGBOX;
-          } else {
-            mapserv->CoordSource = FROMIMGPNT;
-            mapserv->QueryCoordSource = FROMIMGPNT;
-            mapserv->ImgPnt.x=mapserv->ImgBox.minx;
-            mapserv->ImgPnt.y=mapserv->ImgBox.miny;
-          }
-          break;
-        case 2:
-          sscanf(mapserv->request->ParamValues[i],"%lf,%lf",&mapserv->ImgPnt.x,
-                 &mapserv->ImgPnt.y);
-          mapserv->CoordSource = FROMIMGPNT;
-          mapserv->QueryCoordSource = FROMIMGPNT;
-          break;
-      }
-      continue;
-    }
-    /* -------------------------------------------------------------------- */
-    /*      end of code for Rosa support.                                   */
-    /* -------------------------------------------------------------------- */
-
-  } /* next parameter */
-
-  if(mapserv->Mode == ZOOMIN) {
-    mapserv->ZoomDirection = 1;
-    mapserv->Mode = BROWSE;
-  }
-  if(mapserv->Mode == ZOOMOUT) {
-    mapserv->ZoomDirection = -1;
-    mapserv->Mode = BROWSE;
-  }
-
-  if(mapserv->ZoomSize != 0) { /* use direction and magnitude to calculate zoom */
-    if(mapserv->ZoomDirection == 0) {
-      mapserv->fZoom = 1;
-    } else {
-      mapserv->fZoom = mapserv->ZoomSize*mapserv->ZoomDirection;
-      if(mapserv->fZoom < 0)
-        mapserv->fZoom = 1.0/MS_ABS(mapserv->fZoom);
-    }
-  } else { /* use single value for zoom */
-    if((mapserv->Zoom >= -1) && (mapserv->Zoom <= 1)) {
-      mapserv->fZoom = 1; /* pan */
-    } else {
-      if(mapserv->Zoom < 0)
-        mapserv->fZoom = 1.0/MS_ABS(mapserv->Zoom);
-      else
-        mapserv->fZoom = mapserv->Zoom;
-    }
-  }
-
-  if(mapserv->ImgRows == -1) mapserv->ImgRows = mapserv->map->height;
-  if(mapserv->ImgCols == -1) mapserv->ImgCols = mapserv->map->width;
-  if(mapserv->map->height == -1) mapserv->map->height = mapserv->ImgRows;
-  if(mapserv->map->width == -1) mapserv->map->width = mapserv->ImgCols;
-  return MS_SUCCESS;
-}
-
-int setExtentFromShapes(mapservObj *mapserv)
-{
-  double dx, dy, cellsize;
-
-  rectObj tmpext= {-1.0,-1.0,-1.0,-1.0};
-  pointObj tmppnt= {-1.0,-1.0,-1.0,-1.0};
-
-  msGetQueryResultBounds(mapserv->map, &(tmpext));
-
-  dx = tmpext.maxx - tmpext.minx;
-  dy = tmpext.maxy - tmpext.miny;
-
-  tmppnt.x = (tmpext.maxx + tmpext.minx)/2;
-  tmppnt.y = (tmpext.maxy + tmpext.miny)/2;
-  tmpext.minx -= dx*EXTENT_PADDING/2.0;
-  tmpext.maxx += dx*EXTENT_PADDING/2.0;
-  tmpext.miny -= dy*EXTENT_PADDING/2.0;
-  tmpext.maxy += dy*EXTENT_PADDING/2.0;
-
-  if(mapserv->ScaleDenom != 0) { /* apply the scale around the center point (tmppnt) */
-    cellsize = (mapserv->ScaleDenom/mapserv->map->resolution)/msInchesPerUnit(mapserv->map->units,0); /* user supplied a point and a scale */
-    tmpext.minx = tmppnt.x - cellsize*mapserv->map->width/2.0;
-    tmpext.miny = tmppnt.y - cellsize*mapserv->map->height/2.0;
-    tmpext.maxx = tmppnt.x + cellsize*mapserv->map->width/2.0;
-    tmpext.maxy = tmppnt.y + cellsize*mapserv->map->height/2.0;
-  } else if(mapserv->Buffer != 0) { /* apply the buffer around the center point (tmppnt) */
-    tmpext.minx = tmppnt.x - mapserv->Buffer;
-    tmpext.miny = tmppnt.y - mapserv->Buffer;
-    tmpext.maxx = tmppnt.x + mapserv->Buffer;
-    tmpext.maxy = tmppnt.y + mapserv->Buffer;
-  }
-
-  /* in case we don't get  usable extent at this point (i.e. single point result) */
-  if(!MS_VALID_EXTENT(tmpext)) {
-    if(mapserv->map->web.minscaledenom > 0) { /* try web object minscale first */
-      cellsize = (mapserv->map->web.minscaledenom/mapserv->map->resolution)/msInchesPerUnit(mapserv->map->units,0); /* user supplied a point and a scale */
-      tmpext.minx = tmppnt.x - cellsize*mapserv->map->width/2.0;
-      tmpext.miny = tmppnt.y - cellsize*mapserv->map->height/2.0;
-      tmpext.maxx = tmppnt.x + cellsize*mapserv->map->width/2.0;
-      tmpext.maxy = tmppnt.y + cellsize*mapserv->map->height/2.0;
-    } else {
-      msSetError(MS_WEBERR, "No way to generate a valid map extent from selected shapes.", "mapserv()");
-      return MS_FAILURE;
-    }
-  }
-
-  mapserv->mappnt = tmppnt;
-  mapserv->map->extent = mapserv->RawExt = tmpext; /* save unadjusted extent */
-
-  return MS_SUCCESS;
-}
-
-
-/* FIX: NEED ERROR CHECKING HERE FOR IMGPNT or MAPPNT */
-void setCoordinate(mapservObj *mapserv)
-{
-  double cellx,celly;
-
-  cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
-  celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-
-  mapserv->mappnt.x = MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
-  mapserv->mappnt.y = MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
-
-  return;
-}
-
-
-int msCGIDispatchBrowseRequest(mapservObj *mapserv)
-{
-  char *template =  NULL;
-  int i,status;
-  for(i=0; i<mapserv->request->NumParams; i++) /* find the template param value */
-    if (strcasecmp(mapserv->request->ParamNames[i], "template") == 0)
-      template = mapserv->request->ParamValues[i];
-
-  if ( (!mapserv->map->web.template) && (template==NULL || (strcasecmp(template, "openlayers")!=0)) ) {
-    msSetError(MS_WEBERR, "Traditional BROWSE mode requires a TEMPLATE in the WEB section, but none was provided.", "mapserv()");
-    return MS_FAILURE;
-  }
-
-  if(mapserv->QueryFile) {
-    status = msLoadQuery(mapserv->map, mapserv->QueryFile);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-  }
-
-  status = setExtent(mapserv);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-  status = checkWebScale(mapserv);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  /* -------------------------------------------------------------------- */
-  /*      generate map, legend, scalebar and refernce images.             */
-  /* -------------------------------------------------------------------- */
-  if(msGenerateImages(mapserv, MS_FALSE, MS_TRUE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if ( (template != NULL) && (strcasecmp(template, "openlayers")==0) ) {
-    msIO_setHeader("Content-Type","text/html");
-    msIO_sendHeaders();
-    if (msReturnOpenLayersPage(mapserv) != MS_SUCCESS)
-      return MS_FAILURE;
-  } else if(mapserv->QueryFile) {
-    if(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) != MS_SUCCESS)
-      return MS_FAILURE;
-  } else {
-    if(TEMPLATE_TYPE(mapserv->map->web.template) == MS_FILE) { /* if thers's an html template, then use it */
-      if(mapserv->sendheaders) {
-        msIO_setHeader("Content-Type","%s", mapserv->map->web.browseformat); /* write MIME header */
-        msIO_sendHeaders();
-      }
-      if(msReturnPage(mapserv, mapserv->map->web.template, BROWSE, NULL) != MS_SUCCESS)
-        return MS_FAILURE;
-    } else {
-      if(msReturnURL(mapserv, mapserv->map->web.template, BROWSE) != MS_SUCCESS)
-        return MS_FAILURE;
-    }
-  }
-  return MS_SUCCESS;
-}
-
-
-int msCGIDispatchCoordinateRequest(mapservObj *mapserv)
-{
-  setCoordinate(mapserv); /* mouse click => map coord */
-  msIO_printf("Your \"<i>click</i>\" corresponds to (approximately): (%g, %g).",
-              mapserv->mappnt.x, mapserv->mappnt.y);
-
-  if(mapserv->map->projection.proj != NULL && !msProjIsGeographicCRS(&(mapserv->map->projection)) ) {
-    pointObj p=mapserv->mappnt;
-    msProjectPoint(&(mapserv->map->projection), &(mapserv->map->latlon), &p);
-    msIO_printf("Computed lat/lon value is (%g, %g).\n",p.x, p.y);
-  }
-  return MS_SUCCESS;
-}
-
-int msCGIDispatchQueryRequest(mapservObj *mapserv)
-{
-  int status,i,j;
-  char buffer[1024];
-  if(mapserv->QueryFile) { /* already got a completed query */
-    status = msLoadQuery(mapserv->map, mapserv->QueryFile);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-  } else {
-
-    if((mapserv->QueryLayerIndex = msGetLayerIndex(mapserv->map, mapserv->QueryLayer)) != -1) /* force the query layer on */
-      GET_LAYER(mapserv->map, mapserv->QueryLayerIndex)->status = MS_ON;
-
-    switch(mapserv->Mode) {
-      case ITEMFEATUREQUERY:
-      case ITEMFEATURENQUERY:
-        if((mapserv->SelectLayerIndex = msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) == -1) { /* force the selection layer on */
-          msSetError(MS_WEBERR, "Selection layer not set or references an invalid layer.", "mapserv()");
-          return MS_FAILURE;
-        }
-        GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
-
-        /* validate the qstring parameter */
-        if(msValidateParameter(mapserv->QueryString, msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->validation), "qstring"),
-                               msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
-                               NULL, NULL) != MS_SUCCESS) {
-          msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.", "mapserv()");
-          return MS_FAILURE;
-        }
-
-        if(mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
-          if(MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
-            return MS_FAILURE;
-
-        mapserv->map->query.type = MS_QUERY_BY_FILTER;
-        if(mapserv->QueryItem) mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
-        if(mapserv->QueryString) {
-          msInitExpression(&mapserv->map->query.filter);
-          msLoadExpressionString(&mapserv->map->query.filter, mapserv->QueryString);
-        }
-
-        mapserv->map->query.rect = mapserv->map->extent;
-
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE;
-        if(mapserv->Mode == ITEMFEATUREQUERY)
-          mapserv->map->query.mode = MS_QUERY_SINGLE;
-
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.slayer = mapserv->SelectLayerIndex; /* this will trigger the feature query eventually */
-        break;
-      case FEATUREQUERY:
-      case FEATURENQUERY:
-        if((mapserv->SelectLayerIndex = msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) == -1) { /* force the selection layer on */
-          msSetError(MS_WEBERR, "Selection layer not set or references an invalid layer.", "mapserv()");
-          return MS_FAILURE;
-        }
-        GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
-
-        if(mapserv->Mode == FEATUREQUERY) {
-          switch(mapserv->QueryCoordSource) {
-            case FROMIMGPNT:
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing map extent */
-              setCoordinate(mapserv);
-              break;
-            case FROMUSERPNT:
-              break;
-            default:
-              msSetError(MS_WEBERR, "No way to perform the initial search, not enough information.", "mapserv()");
-              return MS_FAILURE;
-              break;
-          }
-
-          mapserv->map->query.type = MS_QUERY_BY_POINT;
-        } else { /* FEATURENQUERY */
-          switch(mapserv->QueryCoordSource) {
-            case FROMIMGPNT:
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing map extent */
-              setCoordinate(mapserv);
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-              break;
-            case FROMIMGBOX:
-              /* TODO: this option was present but with no code to leverage the image box... */
-              break;
-            case FROMUSERPNT:
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-              break;
-            default:
-              if(MS_SUCCESS != setExtent(mapserv)) {
-                return MS_FAILURE;
-              }
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-              break;
-          }
-        }
-
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE;
-
-        mapserv->map->query.rect = mapserv->map->extent;
-        mapserv->map->query.point = mapserv->mappnt;
-        mapserv->map->query.buffer = mapserv->Buffer;
-
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.slayer = mapserv->SelectLayerIndex;
-        break;
-      case ITEMQUERY:
-      case ITEMNQUERY:
-        if(mapserv->QueryLayerIndex < 0 || mapserv->QueryLayerIndex >= mapserv->map->numlayers) {
-          msSetError(MS_WEBERR, "Query layer not set or references an invalid layer.", "mapserv()");
-          return MS_FAILURE;
-        }
-
-        /* validate the qstring parameter */
-        if(msValidateParameter(mapserv->QueryString, msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->QueryLayerIndex)->validation), "qstring"),
-                               msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
-                               NULL, NULL) != MS_SUCCESS) {
-          msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.", "mapserv()");
-          return MS_FAILURE;
-        }
-
-        if(mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
-          if(MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
-            return MS_FAILURE;
-
-        mapserv->map->query.type = MS_QUERY_BY_FILTER;
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        if(mapserv->QueryItem) mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
-        if(mapserv->QueryString) {
-          msInitExpression(&mapserv->map->query.filter);
-          msLoadExpressionString(&mapserv->map->query.filter, mapserv->QueryString);
-	}
-
-        mapserv->map->query.rect = mapserv->map->extent;
-
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE;
-        if(mapserv->Mode == ITEMQUERY) mapserv->map->query.mode = MS_QUERY_SINGLE;
-        break;
-      case NQUERY:
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE; /* all of these cases return multiple results */
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-
-        switch(mapserv->QueryCoordSource) {
-          case FROMIMGPNT:
-            setCoordinate(mapserv);
-
-            if(mapserv->SearchMap) { /* compute new extent, pan etc then search that extent */
-              if(MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
-                return MS_FAILURE;
-              mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->query.rect = mapserv->map->extent;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            } else {
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-              mapserv->map->width = mapserv->ImgCols;
-              mapserv->map->height = mapserv->ImgRows;
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->query.point = mapserv->mappnt;
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-            }
-
-            break;
-          case FROMIMGBOX:
-            if(mapserv->SearchMap) { /* compute new extent, pan etc then search that extent */
-              setExtent(mapserv);
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-              mapserv->map->query.rect = mapserv->map->extent;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            } else {
-              double cellx, celly;
-
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-              mapserv->map->width = mapserv->ImgCols;
-              mapserv->map->height = mapserv->ImgRows;
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols); /* calculate the new search extent */
-              celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-              mapserv->RawExt.minx = MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
-              mapserv->RawExt.maxx = MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
-              mapserv->RawExt.maxy = MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy, celly); /* y's are flip flopped because img/map coordinate systems are */
-              mapserv->RawExt.miny = MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
-
-              mapserv->map->query.rect = mapserv->RawExt;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            }
-            break;
-          case FROMIMGSHAPE:
-            mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-            mapserv->map->width = mapserv->ImgCols;
-            mapserv->map->height = mapserv->ImgRows;
-            mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-            if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-
-            /* convert from image to map coordinates here (see setCoordinate) */
-            for(i=0; i<mapserv->map->query.shape->numlines; i++) {
-              for(j=0; j<mapserv->map->query.shape->line[i].numpoints; j++) {
-                mapserv->map->query.shape->line[i].point[j].x = MS_IMAGE2MAP_X(mapserv->map->query.shape->line[i].point[j].x, mapserv->map->extent.minx, mapserv->map->cellsize);
-                mapserv->map->query.shape->line[i].point[j].y = MS_IMAGE2MAP_Y(mapserv->map->query.shape->line[i].point[j].y, mapserv->map->extent.maxy, mapserv->map->cellsize);
-              }
-            }
-
-            mapserv->map->query.type = MS_QUERY_BY_SHAPE;
-            break;
-          case FROMUSERPNT:
-            if(mapserv->Buffer == 0) { /* do a *pure* point query */
-              mapserv->map->query.point = mapserv->mappnt;
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-              setExtent(mapserv);
-            } else {
-              setExtent(mapserv);
-              if(mapserv->SearchMap) { /* the extent should be tied to a map, so we need to "adjust" it */
-                if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-                mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-              }
-              mapserv->map->query.rect = mapserv->map->extent;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            }
-            break;
-          case FROMUSERSHAPE:
-            setExtent(mapserv);
-            mapserv->map->query.type = MS_QUERY_BY_SHAPE;
-            break;
-          default: /* from an extent of some sort */
-            setExtent(mapserv);
-            if(mapserv->SearchMap) { /* the extent should be tied to a map, so we need to "adjust" it */
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-            }
-
-            mapserv->map->query.rect = mapserv->map->extent;
-            mapserv->map->query.type = MS_QUERY_BY_RECT;
-            break;
-        }
-        break;
-      case QUERY:
-        switch(mapserv->QueryCoordSource) {
-          case FROMIMGPNT:
-            setCoordinate(mapserv);
-            mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-            mapserv->map->width = mapserv->ImgCols;
-            mapserv->map->height = mapserv->ImgRows;
-            if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-            break;
-          case FROMUSERPNT: /* only a buffer makes sense, DOES IT? */
-            if(setExtent(mapserv) != MS_SUCCESS) return MS_FAILURE;
-            break;
-          default:
-            msSetError(MS_WEBERR, "Query mode needs a point, imgxy and mapxy are not set.", "mapserv()");
-            return MS_FAILURE;
-            break;
-        }
-
-        mapserv->map->query.type = MS_QUERY_BY_POINT;
-        mapserv->map->query.mode = MS_QUERY_SINGLE;
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.point = mapserv->mappnt;
-        mapserv->map->query.buffer = mapserv->Buffer;
-        break;
-      case INDEXQUERY:
-        mapserv->map->query.type = MS_QUERY_BY_INDEX;
-        mapserv->map->query.mode = MS_QUERY_SINGLE;
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.shapeindex = mapserv->ShapeIndex;
-        mapserv->map->query.tileindex = mapserv->TileIndex;
-        break;
-    } /* end mode switch */
-
-    /* finally execute the query */
-    if(msExecuteQuery(mapserv->map) != MS_SUCCESS) return MS_FAILURE;
-  }
-
-  if(mapserv->map->querymap.width > 0 && mapserv->map->querymap.width <= mapserv->map->maxsize) mapserv->map->width = mapserv->map->querymap.width; /* make sure we use the right size */
-  if(mapserv->map->querymap.height > 0 && mapserv->map->querymap.height <= mapserv->map->maxsize) mapserv->map->height = mapserv->map->querymap.height;
-
-  if(mapserv->UseShapes)
-    if(MS_SUCCESS != setExtentFromShapes(mapserv))
-      return MS_FAILURE;
-
-  if(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) != MS_SUCCESS) return MS_FAILURE;
-
-  if(mapserv->savequery) {
-    snprintf(buffer, sizeof(buffer), "%s%s%s%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_QUERY_EXTENSION);
-    if((status = msSaveQuery(mapserv->map, buffer, MS_FALSE)) != MS_SUCCESS) return status;
-  }
-  return MS_SUCCESS;
-}
-
-int msCGIDispatchImageRequest(mapservObj *mapserv)
-{
-  int status;
-  imageObj *img = NULL;
-  switch(mapserv->Mode) {
-    case MAP:
-      if(mapserv->QueryFile) {
-        status = msLoadQuery(mapserv->map, mapserv->QueryFile);
-        if(status != MS_SUCCESS) return MS_FAILURE;
-        img = msDrawMap(mapserv->map, MS_TRUE);
-      } else
-        img = msDrawMap(mapserv->map, MS_FALSE);
-      break;
-    case REFERENCE:
-      mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-      img = msDrawReferenceMap(mapserv->map);
-      break;
-    case SCALEBAR:
-      img = msDrawScalebar(mapserv->map);
-      break;
-    case TILE:
-      msTileSetExtent(mapserv);
-
-      if(!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat), "application/vnd.mapbox-vector-tile") || !strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat), "application/x-protobuf")) {
-        if(msMVTWriteTile(mapserv->map, mapserv->sendheaders) != MS_SUCCESS) return MS_FAILURE;
-        return MS_SUCCESS;
-      }
-
-      img = msTileDraw(mapserv);
-      break;
-    case LEGEND:
-    case MAPLEGEND:
-      img = msDrawLegend(mapserv->map, MS_FALSE, mapserv->hittest);
-      break;
-    default:
-      msSetError(MS_CGIERR,"Invalid CGI mode", "msCGIDispatchImageRequest()");
-      break;
-  }
-
-  if(!img) return MS_FAILURE;
-
-  /*
-   ** Set the Cache control headers if the option is set.
-   */
-  if( mapserv->sendheaders && msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age") ) {
-    msIO_setHeader("Cache-Control","max-age=%s", msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"));
-  }
-
-  if(mapserv->sendheaders)  {
-    const char *attachment = msGetOutputFormatOption(mapserv->map->outputformat, "ATTACHMENT", NULL );
-    if(attachment)
-      msIO_setHeader("Content-disposition","attachment; filename=%s", attachment);
-
-    if(!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat), "application/json")) {
-      msIO_setHeader("Content-Type","application/json; charset=utf-8");
-    } else {
-      msIO_setHeader("Content-Type","%s", MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
-    }
-    msIO_sendHeaders();
-  }
-
-  if( mapserv->Mode == MAP || mapserv->Mode == TILE )
-    status = msSaveImage(mapserv->map, img, NULL);
-  else
-    status = msSaveImage(NULL,img, NULL);
-
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  msFreeImage(img);
-  return MS_SUCCESS;
-}
-
-
-int msCGIDispatchLegendRequest(mapservObj *mapserv)
-{
-  int status;
-  if(mapserv->Mode == MAPLEGEND) {
-    if(setExtent(mapserv) != MS_SUCCESS) return MS_FAILURE;
-    if(checkWebScale(mapserv) != MS_SUCCESS) return MS_FAILURE;
-    mapserv->hittest = msSmallMalloc(sizeof(map_hittest));
-    initMapHitTests(mapserv->map,mapserv->hittest);
-    status = msHitTestMap(mapserv->map,mapserv->hittest);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-  }
-  if(mapserv->map->legend.template) {
-    char *legendTemplate;
-    legendTemplate = generateLegendTemplate(mapserv);
-    if(legendTemplate) {
-      if(mapserv->sendheaders) {
-        msIO_setHeader("Content-Type","%s",mapserv->map->web.legendformat);
-        msIO_sendHeaders();
-      }
-      msIO_fwrite(legendTemplate, strlen(legendTemplate), 1, stdout);
-
-      free(legendTemplate);
-      return MS_SUCCESS;
-    } else {/* error already generated by (generateLegendTemplate()) */
-      return MS_FAILURE;
-    }
-  } else {
-    return msCGIDispatchImageRequest(mapserv);
-  }
-}
-
-int msCGIDispatchLegendIconRequest(mapservObj *mapserv)
-{
-  char **tokens = NULL;
-  int numtokens=0;
-  int layerindex=-1, classindex=0, status;
-  outputFormatObj *format = NULL;
-  imageObj *img = NULL;
-
-  /* TODO: do we want to set scale here? */
-
-  /* do we have enough information */
-  if(!mapserv->icon) {
-    msSetError(MS_WEBERR, "Mode=LEGENDICON requires an icon parameter.", "mapserv()");
-    return MS_FAILURE;
-  }
-
-  /* process the icon definition */
-  tokens = msStringSplit(mapserv->icon, ',', &numtokens);
-
-  if(numtokens != 1 && numtokens != 2) {
-    msSetError(MS_WEBERR, "%d Malformed icon parameter, should be 'layer,class' or just 'layer' if the layer has only 1 class defined.", "mapserv()", numtokens);
-    status = MS_FAILURE;
-    goto li_cleanup;
-  }
-
-  if((layerindex = msGetLayerIndex(mapserv->map, tokens[0])) == -1) {
-    msSetError(MS_WEBERR, "Icon layer=%s not found in mapfile.", "mapserv()", tokens[0]);
-    status = MS_FAILURE;
-    goto li_cleanup;
-  }
-
-  if(numtokens == 2) { /* check the class index */
-    classindex = atoi(tokens[1]);
-    if(classindex < 0 || classindex >= GET_LAYER(mapserv->map, layerindex)->numclasses) {
-      msSetError(MS_WEBERR, "Icon class=%d not found in layer=%s.", "mapserv()", classindex, GET_LAYER(mapserv->map, layerindex)->name);
-      status = MS_FAILURE;
-      goto li_cleanup;
-    }
-  }
-
-  if(mapserv->Mode == MAPLEGENDICON) {
-    if(setExtent(mapserv) != MS_SUCCESS) {
-      status=MS_FAILURE;
-      goto li_cleanup;
-    }
-    if(checkWebScale(mapserv) != MS_SUCCESS) {
-      status=MS_FAILURE;
-      goto li_cleanup;
-    }
-    mapserv->hittest = msSmallMalloc(sizeof(map_hittest));
-    initMapHitTests(mapserv->map,mapserv->hittest);
-    status = msHitTestLayer(mapserv->map, GET_LAYER(mapserv->map,layerindex),&mapserv->hittest->layerhits[layerindex]);
-    if(status != MS_SUCCESS) goto li_cleanup;
-  }
-
-  /* ensure we have an image format representing the options for the legend. */
-  msApplyOutputFormat(&format, mapserv->map->outputformat, mapserv->map->legend.transparent);
-
-  /* initialize the legend image */
-  if( ! MS_RENDERER_PLUGIN(format) ) {
-    msSetError(MS_RENDERERERR, "unsupported renderer for legend icon", "mapserv main()");
-    status = MS_FAILURE;
-    goto li_cleanup;
-  }
-  img = msImageCreate(mapserv->map->legend.keysizex, mapserv->map->legend.keysizey, format,
-                      mapserv->map->web.imagepath, mapserv->map->web.imageurl, mapserv->map->resolution, mapserv->map->defresolution,
-                      &(mapserv->map->legend.imagecolor));
-  if(!img) {
-    status = MS_FAILURE;
-    goto li_cleanup;
-  }
-  img->map = mapserv->map;
-
-  /* drop this reference to output format */
-  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
-
-  if(msDrawLegendIcon(mapserv->map, GET_LAYER(mapserv->map, layerindex), GET_LAYER(mapserv->map, layerindex)->class[classindex], mapserv->map->legend.keysizex,  mapserv->map->legend.keysizey, img, 0, 0, MS_TRUE,
-      ((mapserv->hittest)?(&mapserv->hittest->layerhits[layerindex].classhits[classindex]):(NULL))) != MS_SUCCESS) {
-    status = MS_FAILURE;
-    goto li_cleanup;
-  }
-
-  if(mapserv->sendheaders) {
-    msIO_setHeader("Content-Type","%s",MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
-    msIO_sendHeaders();
-  }
-  /*
-   ** Set the Cache control headers if the option is set.
-   */
-  if( mapserv->sendheaders && msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age") ) {
-    msIO_printf("Cache-Control: max-age=%s%c", msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"), 10);
-  }
-  
-  status = msSaveImage(NULL, img, NULL);
-
-li_cleanup:
-  msFreeCharArray(tokens, numtokens);
-  msFreeImage(img);
-  return status;
-}
-
-int msCGIDispatchRequest(mapservObj *mapserv)
-{
-  int i;
-  int status;
-
-  /*
-   ** Determine 'mode': Check for MS_MODE env. var. and mode=... CGI param
-   */
-  mapserv->Mode = -1; /* Not set */
-  if( msCGISetMode(mapserv) != MS_SUCCESS) {
-    return MS_FAILURE;
-  }
-
-  /*
-   ** Start by calling the WMS/WFS/WCS Dispatchers.  If they fail then we'll
-   ** process this as a regular MapServer request.
-   */
-  if((mapserv->Mode == -1 || mapserv->Mode == OWS || mapserv->Mode == WFS) &&
-      (status = msOWSDispatch(mapserv->map, mapserv->request,
-                              mapserv->Mode)) != MS_DONE  )  {
-    /*
-     ** OWSDispatch returned either MS_SUCCESS or MS_FAILURE
-     */
-    if( status == MS_FAILURE ) {
-      return MS_FAILURE;
-    }
-
-    if (status == MS_SUCCESS &&
-        strcasecmp(mapserv->map->imagetype, "application/openlayers")==0) {
-      char *service = NULL;
-      for( i=0; i<mapserv->request->NumParams; i++) {
-        if(strcasecmp(mapserv->request->ParamNames[i], "SERVICE") == 0) {
-          service = mapserv->request->ParamValues[i];
-          break;
-        }
-      }
-      if (service && strcasecmp(service,"WMS")==0) {
-        if(mapserv->sendheaders) {
-          msIO_setHeader("Content-Type","text/html");
-          msIO_sendHeaders();
-        }
-
-        if (msReturnOpenLayersPage(mapserv) != MS_SUCCESS)
-          return MS_FAILURE;
-      }
-    }
-    return MS_SUCCESS;
-  } /* done OGC/OWS case */
-
-
-  /*
-  ** Do "traditional" mode processing.
-  */
-  if (mapserv->Mode == -1)
-    mapserv->Mode = BROWSE;
-
-  if(MS_SUCCESS != msCGILoadForm(mapserv)) {
-    return MS_FAILURE;
-  }
-
-  /* Insecure as implemented, need to save someplace non accessible by everyone in the universe
-      if(mapserv->savemap) {
-        snprintf(buffer, sizeof(buffer), "%s%s%s.map", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id);
-        if(msSaveMap(mapserv->map, buffer) == -1) return MS_FAILURE;
-      }
-  */
-
-  if((mapserv->CoordSource == FROMIMGPNT) || (mapserv->CoordSource == FROMIMGBOX)) /* make sure extent of existing image matches shape of image */
-    mapserv->map->cellsize = msAdjustExtent(&mapserv->ImgExt, mapserv->ImgCols, mapserv->ImgRows);
-
-  /*
-  ** For each layer let's set layer status
-  */
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    if((GET_LAYER(mapserv->map, i)->status != MS_DEFAULT)) {
-      if(isOn(mapserv,  GET_LAYER(mapserv->map, i)->name, GET_LAYER(mapserv->map, i)->group) == MS_TRUE) /* Set layer status */
-        GET_LAYER(mapserv->map, i)->status = MS_ON;
-      else
-        GET_LAYER(mapserv->map, i)->status = MS_OFF;
-    }
-  }
-
-  if(mapserv->CoordSource == FROMREFPNT) /* force browse mode if the reference coords are set */
-    mapserv->Mode = BROWSE;
-
-  if(mapserv->Mode == TILE) {
-    /*
-     ** Tile mode:
-     ** Set the projection up and test the parameters for legality.
-     */
-    if( msTileSetup(mapserv) != MS_SUCCESS ) {
-      return MS_FAILURE;
-    }
-  }
-  if(mapserv->Mode == BROWSE) {
-    return msCGIDispatchBrowseRequest(mapserv);
-  } else if(mapserv->Mode == MAP || mapserv->Mode == SCALEBAR || mapserv->Mode == REFERENCE || mapserv->Mode == TILE) { /* "image" only modes */
-    /* tile, map, scalebar and reference all need the extent to be set up correctly */
-    if(setExtent(mapserv) != MS_SUCCESS) return MS_FAILURE;
-    if(checkWebScale(mapserv) != MS_SUCCESS) return MS_FAILURE;
-    return msCGIDispatchImageRequest(mapserv);
-  } else if(mapserv->Mode == LEGEND || mapserv->Mode == MAPLEGEND) {
-    return msCGIDispatchLegendRequest(mapserv);
-  } else if(mapserv->Mode == LEGENDICON || mapserv->Mode == MAPLEGENDICON) {
-    return msCGIDispatchLegendIconRequest(mapserv);
-  } else if(mapserv->Mode >= QUERY) {
-    return msCGIDispatchQueryRequest(mapserv);
-  } else if(mapserv->Mode == COORDINATE) {
-    return msCGIDispatchCoordinateRequest(mapserv);
-  } else {
-    msSetError(MS_WEBERR, "Bug: unsupported mode", "msDispatchRequest");
-    return MS_FAILURE;
-  }
-}
-
-int msCGIHandler(const char *query_string, void **out_buffer, size_t *buffer_length)
-{
-  int x,m=0;
-  struct mstimeval execstarttime = {0}, execendtime = {0};
-  struct mstimeval requeststarttime = {0}, requestendtime = {0};
-  mapservObj *mapserv = NULL;
-  char *queryString = NULL;
-  int maxParams = MS_DEFAULT_CGI_PARAMS;
-  msIOContext *ctx;
-  msIOBuffer  *buf;
-
-  configObj *config = NULL;
-
-  msIO_installStdoutToBuffer();
-
-  /* Use PROJ_DATA/PROJ_LIB env vars if set */
-  msProjDataInitFromEnv();
-
-  /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
-  if( msDebugInitFromEnv() != MS_SUCCESS ) {
-    msCGIWriteError(mapserv);
-    goto end_request;
-  }
-
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
-    msGettimeofday(&execstarttime, NULL);
-
-  if(!query_string || !*query_string) {
-    msIO_setHeader("Content-Type","text/html");
-    msIO_sendHeaders();
-    msIO_printf("No query information to decode. QUERY_STRING not set.\n");
-    goto end_request;
-  }
-
-  config = msLoadConfig(NULL);
-  if(config == NULL) {
-    msCGIWriteError(mapserv);
-    goto end_request;
-  }
-  
-  mapserv = msAllocMapServObj();
-  mapserv->request->type = MS_GET_REQUEST;
-
-  /* don't modify the string */
-  queryString = msStrdup(query_string);
-  for(x=0; queryString[0] != '\0'; x++) {
-    if(m >= maxParams) {
-      maxParams *= 2;
-      mapserv->request->ParamNames = (char **) realloc(mapserv->request->ParamNames,sizeof(char *) * maxParams);
-      if (mapserv->request->ParamNames == NULL) {
-        msIO_printf("Out of memory trying to allocate name/value pairs.\n");
-        goto end_request;
-      }
-      mapserv->request->ParamValues = (char **) realloc(mapserv->request->ParamValues,sizeof(char *) * maxParams);
-      if (mapserv->request->ParamValues ==  NULL) {
-        msIO_printf("Out of memory trying to allocate name/value pairs.\n");
-        goto end_request;
-      }
-    }
-    mapserv->request->ParamValues[m] = makeword(queryString,'&');
-    plustospace(mapserv->request->ParamValues[m]);
-    unescape_url(mapserv->request->ParamValues[m]);
-    mapserv->request->ParamNames[m] = makeword(mapserv->request->ParamValues[m],'=');
-    m++;
-  }
-  mapserv->request->NumParams = m;
-
-  if( mapserv->request->NumParams == 0 ) {
-    msCGIWriteError(mapserv);
-    goto end_request;
-  }
-
-  mapserv->map = msCGILoadMap(mapserv, config);
-  if(!mapserv->map) {
-    msCGIWriteError(mapserv);
-    goto end_request;
-  }
-
-  if( mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
-    msGettimeofday(&requeststarttime, NULL);
-
-  if(msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
-    msCGIWriteError(mapserv);
-    goto end_request;
-  }
-
-
-end_request:
-  if(mapserv) {
-    if(mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
-      msGettimeofday(&requestendtime, NULL);
-      msDebug("mapserv request processing time (msLoadMap not incl.): %.3fs\n",
-              (requestendtime.tv_sec+requestendtime.tv_usec/1.0e6)-
-              (requeststarttime.tv_sec+requeststarttime.tv_usec/1.0e6) );
-    }
-    msFreeMapServObj(mapserv);
-    msFreeConfig(config);
-  }
-
-  /* normal case, processing is complete */
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&execendtime, NULL);
-    msDebug("mapserv total execution time: %.3fs\n",
-            (execendtime.tv_sec+execendtime.tv_usec/1.0e6)-
-            (execstarttime.tv_sec+execstarttime.tv_usec/1.0e6) );
-  }
-  ctx = msIO_getHandler( (FILE *) "stdout" );
-  buf = (msIOBuffer *) ctx->cbData;
-  *out_buffer = buf->data;
-  *buffer_length = buf->data_offset;
-
-  free(queryString);
-
-  return 0;
-}
diff -pruN 8.0.1-5/mapshape.c 8.2.0~beta1-1~exp1/mapshape.c
--- 8.0.1-5/mapshape.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapshape.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2984 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implements support for shapefile access.
- * Authors:  Steve Lime and Frank Warmerdam
- *
- * Note:
- * This code is entirely based on the previous work of Frank Warmerdam. It is
- * essentially shapelib 1.1.5. However, there were enough changes that it was
- * incorporated into the MapServer source to avoid confusion. Relicensed with
- * permission of Frank Warmerdam (shapelib author). See the README
- * for licence details.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#define NEED_IGNORE_RET_VAL
-
-#include <limits.h>
-#include <assert.h>
-#include <stdbool.h>
-#include "mapserver.h"
-#include "mapows.h"
-
-#include <cpl_conv.h>
-#include <ogr_srs_api.h>
-
-/* Only use this macro on 32-bit integers! */
-#define SWAP_FOUR_BYTES(data) CPL_SWAP32(data)
-
-
-#define ByteCopy( a, b, c )     memcpy( b, a, c )
-
-#ifdef __BYTE_ORDER__
-/* GCC/clang predefined macro */
-#define bBigEndian (__BYTE_ORDER__ == __ORDER_BIG_ENDIAN__)
-#elif defined(_MSC_VER)
-/* MSVC doesn't support the C99 trick below, but all Microsoft
-   platforms are little-endian */
-#define bBigEndian false
-#else
-/* generic check */
-#define bBigEndian (((union{int in;char out;}){1}).out)
-#endif
-
-/* SHX reading */
-static int msSHXLoadAll( SHPHandle psSHP );
-static int msSHXReadOffset( SHPHandle psSHP, int hEntity );
-static int msSHXReadSize( SHPHandle psSHP, int hEntity );
-
-/************************************************************************/
-/*                              SwapWord()                              */
-/*                                                                      */
-/*      Swap a 2, 4 or 8 byte word.                                     */
-/************************************************************************/
-static void SwapWord( int length, void * wordP )
-{
-  int i;
-  uchar temp;
-
-  for( i=0; i < length/2; i++ ) {
-    temp = ((uchar *) wordP)[i];
-    ((uchar *)wordP)[i] = ((uchar *) wordP)[length-i-1];
-    ((uchar *) wordP)[length-i-1] = temp;
-  }
-}
-
-/************************************************************************/
-/*                             SfRealloc()                              */
-/*                                                                      */
-/*      A realloc cover function that will access a NULL pointer as     */
-/*      a valid input.                                                  */
-/************************************************************************/
-static void * SfRealloc( void * pMem, int nNewSize )
-{
-  return realloc(pMem, nNewSize);
-}
-
-/************************************************************************/
-/*                          writeHeader()                               */
-/*                                                                      */
-/*      Write out a header for the .shp and .shx files as well as the */
-/*  contents of the index (.shx) file.        */
-/************************************************************************/
-static void writeHeader( SHPHandle psSHP )
-{
-  uchar abyHeader[100];
-  int i;
-  ms_int32 i32;
-  double dValue;
-  ms_int32 *panSHX;
-
-  /* -------------------------------------------------------------------- */
-  /*      Prepare header block for .shp file.                             */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < 100; i++ )
-    abyHeader[i] = 0;
-
-  abyHeader[2] = 0x27;        /* magic cookie */
-  abyHeader[3] = 0x0a;
-
-  i32 = psSHP->nFileSize/2;       /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
-
-  i32 = 1000;           /* version */
-  ByteCopy( &i32, abyHeader+28, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+28 );
-
-  i32 = psSHP->nShapeType;        /* shape type */
-  ByteCopy( &i32, abyHeader+32, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+32 );
-
-  dValue = psSHP->adBoundsMin[0];     /* set bounds */
-  ByteCopy( &dValue, abyHeader+36, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+36 );
-
-  dValue = psSHP->adBoundsMin[1];
-  ByteCopy( &dValue, abyHeader+44, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+44 );
-
-  dValue = psSHP->adBoundsMax[0];
-  ByteCopy( &dValue, abyHeader+52, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+52 );
-
-  dValue = psSHP->adBoundsMax[1];
-  ByteCopy( &dValue, abyHeader+60, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+60 );
-
-  dValue = psSHP->adBoundsMin[2];     /* z */
-  ByteCopy( &dValue, abyHeader+68, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+68 );
-
-  dValue = psSHP->adBoundsMax[2];
-  ByteCopy( &dValue, abyHeader+76, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+76 );
-
-
-  dValue = psSHP->adBoundsMin[3];     /* m */
-  ByteCopy( &dValue, abyHeader+84, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+84 );
-
-  dValue = psSHP->adBoundsMax[3];
-  ByteCopy( &dValue, abyHeader+92, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+92 );
-
-  /* -------------------------------------------------------------------- */
-  /*      Write .shp file header.                                         */
-  /* -------------------------------------------------------------------- */
-  VSIFSeekL( psSHP->fpSHP, 0, 0 );
-  VSIFWriteL( abyHeader, 100, 1, psSHP->fpSHP );
-
-  /* -------------------------------------------------------------------- */
-  /*      Prepare, and write .shx file header.                            */
-  /* -------------------------------------------------------------------- */
-  i32 = (psSHP->nRecords * 2 * sizeof(ms_int32) + 100)/2;   /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
-
-  VSIFSeekL( psSHP->fpSHX, 0, 0 );
-  VSIFWriteL( abyHeader, 100, 1, psSHP->fpSHX );
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out the .shx contents.                                    */
-  /* -------------------------------------------------------------------- */
-  panSHX = (ms_int32 *) msSmallMalloc(sizeof(ms_int32) * 2 * psSHP->nRecords);
-
-  for( i = 0; i < psSHP->nRecords; i++ ) {
-    panSHX[i*2  ] = psSHP->panRecOffset[i]/2;
-    panSHX[i*2+1] = psSHP->panRecSize[i]/2;
-    if( !bBigEndian ) {
-      *(panSHX+i*2) = SWAP_FOUR_BYTES(*(panSHX+i*2));
-      *(panSHX+i*2+1) = SWAP_FOUR_BYTES(*(panSHX+i*2+1));
-    }
-  }
-
-  VSIFWriteL( panSHX, sizeof(ms_int32) * 2, psSHP->nRecords, psSHP->fpSHX );
-
-  free( panSHX );
-}
-
-SHPHandle msSHPOpenVirtualFile( VSILFILE * fpSHP, VSILFILE * fpSHX )
-{
-  /* -------------------------------------------------------------------- */
-  /*  Initialize the info structure.              */
-  /* -------------------------------------------------------------------- */
-  SHPHandle psSHP = (SHPHandle) msSmallMalloc(sizeof(SHPInfo));
-
-  psSHP->bUpdated = MS_FALSE;
-
-  psSHP->pabyRec = NULL;
-  psSHP->panParts = NULL;
-  psSHP->nBufSize = psSHP->nPartMax = 0;
-
-  psSHP->fpSHP = fpSHP;
-  psSHP->fpSHX = fpSHX;
-
-  /* -------------------------------------------------------------------- */
-  /*   Read the file size from the SHP file.            */
-  /* -------------------------------------------------------------------- */
-  uchar *pabyBuf = (uchar *) msSmallMalloc(100);
-  if(1 != VSIFReadL( pabyBuf, 100, 1, psSHP->fpSHP )) {
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
-    free(pabyBuf);
-    return( NULL );
-  }
-
-  if( !bBigEndian ) SwapWord( 4, pabyBuf+24 );
-  memcpy(&psSHP->nFileSize, pabyBuf+24, 4);
-  if( psSHP->nFileSize < 0 || psSHP->nFileSize > INT_MAX / 2 ) {
-      msDebug("Invalid / unsupported nFileSize = %d value. Got it from actual file length", psSHP->nFileSize);
-      VSIFSeekL( psSHP->fpSHP, 0, SEEK_END );
-      vsi_l_offset nSize = VSIFTellL( psSHP->fpSHP );
-      if( nSize > (vsi_l_offset)INT_MAX ) {
-          msDebug("Actual .shp size is larger than 2 GB. Not suported. Invalidating nFileSize");
-          psSHP->nFileSize = 0;
-      }
-      else
-          psSHP->nFileSize = (int)nSize;
-  }
-  else {
-      psSHP->nFileSize *= 2;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Read SHX file Header info                                           */
-  /* -------------------------------------------------------------------- */
-  if(1 != VSIFReadL( pabyBuf, 100, 1, psSHP->fpSHX )) {
-    msSetError(MS_SHPERR, "Corrupted .shx file", "msSHPOpen()");
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
-    free(pabyBuf);
-    return( NULL );
-  }
-
-  if( pabyBuf[0] != 0 || pabyBuf[1] != 0 || pabyBuf[2] != 0x27  || (pabyBuf[3] != 0x0a && pabyBuf[3] != 0x0d) ) {
-    msSetError(MS_SHPERR, "Corrupted .shx file", "msSHPOpen()");
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
-    free(pabyBuf);
-
-    return( NULL );
-  }
-
-  int nSHXHalfFileSize;
-  if( !bBigEndian ) SwapWord( 4, pabyBuf+24 );
-  memcpy(&nSHXHalfFileSize, pabyBuf+24, 4);
-  if (nSHXHalfFileSize >= 50)
-    psSHP->nRecords = (nSHXHalfFileSize - 50) / 4;   // (nSHXFileSize - 100) / 8
-  else
-    psSHP->nRecords = -1;
-
-  if( psSHP->nRecords < 0 || psSHP->nRecords > 256000000 ) {
-    msSetError(MS_SHPERR, "Corrupted .shx file : nRecords = %d.", "msSHPOpen()",
-               psSHP->nRecords);
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
-    free(pabyBuf);
-    return( NULL );
-  }
-
-  psSHP->nShapeType = pabyBuf[32];
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+36 );
-  double dValue;
-  memcpy( &dValue, pabyBuf+36, 8 );
-  psSHP->adBoundsMin[0] = dValue;
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+44 );
-  memcpy( &dValue, pabyBuf+44, 8 );
-  psSHP->adBoundsMin[1] = dValue;
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+52 );
-  memcpy( &dValue, pabyBuf+52, 8 );
-  psSHP->adBoundsMax[0] = dValue;
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+60 );
-  memcpy( &dValue, pabyBuf+60, 8 );
-  psSHP->adBoundsMax[1] = dValue;
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+68 );   /* z */
-  memcpy( &dValue, pabyBuf+68, 8 );
-  psSHP->adBoundsMin[2] = dValue;
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+76 );
-  memcpy( &dValue, pabyBuf+76, 8 );
-  psSHP->adBoundsMax[2] = dValue;
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+84 );   /* m */
-  memcpy( &dValue, pabyBuf+84, 8 );
-  psSHP->adBoundsMin[3] = dValue;
-
-  if( bBigEndian ) SwapWord( 8, pabyBuf+92 );
-  memcpy( &dValue, pabyBuf+92, 8 );
-  psSHP->adBoundsMax[3] = dValue;
-  free( pabyBuf );
-
-  /* -------------------------------------------------------------------- */
-  /*  Read the .shx file to get the offsets to each record in       */
-  /*  the .shp file.                  */
-  /* -------------------------------------------------------------------- */
-  psSHP->nMaxRecords = psSHP->nRecords;
-
-  /* Our in-memory cache of offset information */
-  psSHP->panRecOffset = (int *) malloc(sizeof(int) * psSHP->nMaxRecords );
-  /* Our in-memory cache of size information */
-  psSHP->panRecSize = (int *) malloc(sizeof(int) * psSHP->nMaxRecords );
-  /* The completeness information for our in-memory cache */
-  psSHP->panRecLoaded = msAllocBitArray( 1 + (psSHP->nMaxRecords / SHX_BUFFER_PAGE) ) ;
-  /* Is our in-memory cache completely populated? */
-  psSHP->panRecAllLoaded = 0;
-
-  /* malloc failed? clean up and shut down */
-  if (psSHP->panRecOffset == NULL ||
-      psSHP->panRecSize == NULL ||
-      psSHP->panRecLoaded == NULL) {
-    free(psSHP->panRecOffset);
-    free(psSHP->panRecSize);
-    free(psSHP->panRecLoaded);
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
-    msSetError(MS_MEMERR, "Out of memory", "msSHPOpen()");
-    return( NULL );
-  }
-
-
-  return( psSHP );
-}
-
-/************************************************************************/
-/*                              msSHPOpen()                             */
-/*                                                                      */
-/*      Open the .shp and .shx files based on the basename of the       */
-/*      files or either file name.                                      */
-/************************************************************************/
-SHPHandle msSHPOpen( const char * pszLayer, const char * pszAccess )
-{
-  char *pszFullname, *pszBasename;
-
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*      Ensure the access string is one of the legal ones.  We          */
-  /*      ensure the result string indicates binary to avoid common       */
-  /*      problems on Windows.                                            */
-  /* -------------------------------------------------------------------- */
-  if( strcmp(pszAccess,"rb+") == 0 || strcmp(pszAccess,"r+b") == 0 || strcmp(pszAccess,"r+") == 0 )
-    pszAccess = "r+b";
-  else
-    pszAccess = "rb";
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension     */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(pszLayer)+5);
-  strcpy( pszBasename, pszLayer );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*  Open the .shp and .shx files.  Note that files pulled from      */
-  /*  a PC to Unix with upper case filenames won't work!        */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s.shp", pszBasename );
-  VSILFILE *fpSHP = VSIFOpenL(pszFullname, pszAccess );
-  if( fpSHP == NULL ) {
-    sprintf( pszFullname, "%s.SHP", pszBasename );
-    fpSHP = VSIFOpenL(pszFullname, pszAccess );
-  }
-  if( fpSHP == NULL ) {
-    msFree(pszBasename);
-    msFree(pszFullname);
-    return( NULL );
-  }
-
-  sprintf( pszFullname, "%s.shx", pszBasename );
-  VSILFILE *fpSHX = VSIFOpenL(pszFullname, pszAccess );
-  if( fpSHX == NULL ) {
-    sprintf( pszFullname, "%s.SHX", pszBasename );
-    fpSHX = VSIFOpenL(pszFullname, pszAccess );
-  }
-  if( fpSHX == NULL ) {
-    VSIFCloseL(fpSHP);
-    msFree(pszBasename);
-    msFree(pszFullname);
-    return( NULL );
-  }
-
-  free( pszFullname );
-  free( pszBasename );
-
-  return msSHPOpenVirtualFile(fpSHP, fpSHX);
-}
-
-/************************************************************************/
-/*                              msSHPClose()                            */
-/*                        */
-/*  Close the .shp and .shx files.          */
-/************************************************************************/
-void msSHPClose(SHPHandle psSHP )
-{
-  /* -------------------------------------------------------------------- */
-  /*  Update the header if we have modified anything.           */
-  /* -------------------------------------------------------------------- */
-  if( psSHP->bUpdated )
-    writeHeader( psSHP );
-
-  /* -------------------------------------------------------------------- */
-  /*      Free all resources, and close files.                            */
-  /* -------------------------------------------------------------------- */
-  free( psSHP->panRecOffset );
-  free( psSHP->panRecSize );
-  free( psSHP->panRecLoaded );
-
-
-  free(psSHP->pabyRec);
-  free(psSHP->panParts);
-
-  VSIFCloseL( psSHP->fpSHX );
-  VSIFCloseL( psSHP->fpSHP );
-
-  free( psSHP );
-}
-
-/************************************************************************/
-/*                             msSHPGetInfo()                           */
-/*                                                                      */
-/*      Fetch general information about the shape file.                 */
-/************************************************************************/
-void msSHPGetInfo(SHPHandle psSHP, int * pnEntities, int * pnShapeType )
-{
-  if( pnEntities )
-    *pnEntities = psSHP->nRecords;
-
-  if( pnShapeType )
-    *pnShapeType = psSHP->nShapeType;
-}
-
-/************************************************************************/
-/*                             msSHPCreate()                            */
-/*                                                                      */
-/*      Create a new shape file and return a handle to the open         */
-/*      shape file with read/write access.                              */
-/************************************************************************/
-SHPHandle msSHPCreate( const char * pszLayer, int nShapeType )
-{
-  char *pszBasename, *pszFullname;
-  int i;
-  VSILFILE *fpSHP, *fpSHX;
-  uchar abyHeader[100];
-  ms_int32 i32;
-  double dValue;
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension       */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(pszLayer)+5);
-  strcpy( pszBasename, pszLayer );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*      Open the two files so we can write their headers.               */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s.shp", pszBasename );
-  fpSHP = VSIFOpenL(pszFullname, "wb" );
-  if( fpSHP == NULL ) {
-    free( pszFullname );
-    free(pszBasename);
-    return( NULL );
-  }
-
-  sprintf( pszFullname, "%s.shx", pszBasename );
-  fpSHX = VSIFOpenL(pszFullname, "wb" );
-  if( fpSHX == NULL ) {
-    VSIFCloseL(fpSHP);
-    free( pszFullname );
-    free(pszBasename);
-    return( NULL );
-  }
-
-  free( pszFullname );
-  free(pszBasename);
-
-  /* -------------------------------------------------------------------- */
-  /*      Prepare header block for .shp file.                             */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < 100; i++ )
-    abyHeader[i] = 0;
-
-  abyHeader[2] = 0x27;        /* magic cookie */
-  abyHeader[3] = 0x0a;
-
-  i32 = 50;           /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
-
-  i32 = 1000;           /* version */
-  ByteCopy( &i32, abyHeader+28, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+28 );
-
-  i32 = nShapeType;         /* shape type */
-  ByteCopy( &i32, abyHeader+32, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+32 );
-
-  dValue = 0.0;         /* set bounds */
-  ByteCopy( &dValue, abyHeader+36, 8 );
-  ByteCopy( &dValue, abyHeader+44, 8 );
-  ByteCopy( &dValue, abyHeader+52, 8 );
-  ByteCopy( &dValue, abyHeader+60, 8 );
-
-  /* -------------------------------------------------------------------- */
-  /*      Write .shp file header.                                         */
-  /* -------------------------------------------------------------------- */
-  VSIFWriteL( abyHeader, 100, 1, fpSHP );
-
-  /* -------------------------------------------------------------------- */
-  /*      Prepare, and write .shx file header.                            */
-  /* -------------------------------------------------------------------- */
-  i32 = 50;           /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
-
-  VSIFWriteL( abyHeader, 100, 1, fpSHX );
-
-  /* -------------------------------------------------------------------- */
-  /*      Close the files, and then open them as regular existing files.  */
-  /* -------------------------------------------------------------------- */
-  VSIFCloseL( fpSHP );
-  VSIFCloseL( fpSHX );
-
-  return( msSHPOpen( pszLayer, "rb+" ) );
-}
-
-/************************************************************************/
-/*                           writeBounds()                              */
-/*                                                                      */
-/*      Compute a bounds rectangle for a shape, and set it into the     */
-/*      indicated location in the record.                               */
-/************************************************************************/
-static void writeBounds( uchar * pabyRec, shapeObj *shape, int nVCount )
-{
-  double dXMin, dXMax, dYMin, dYMax;
-  int i, j;
-
-  if( nVCount == 0 ) {
-    dXMin = dYMin = dXMax = dYMax = 0.0;
-  } else {
-    dXMin = dXMax = shape->line[0].point[0].x;
-    dYMin = dYMax = shape->line[0].point[0].y;
-
-    for( i=0; i<shape->numlines; i++ ) {
-      for( j=0; j<shape->line[i].numpoints; j++ ) {
-        dXMin = MS_MIN(dXMin, shape->line[i].point[j].x);
-        dXMax = MS_MAX(dXMax, shape->line[i].point[j].x);
-        dYMin = MS_MIN(dYMin, shape->line[i].point[j].y);
-        dYMax = MS_MAX(dYMax, shape->line[i].point[j].y);
-      }
-    }
-  }
-
-  if( bBigEndian ) {
-    SwapWord( 8, &dXMin );
-    SwapWord( 8, &dYMin );
-    SwapWord( 8, &dXMax );
-    SwapWord( 8, &dYMax );
-  }
-
-  ByteCopy( &dXMin, pabyRec +  0, 8 );
-  ByteCopy( &dYMin, pabyRec +  8, 8 );
-  ByteCopy( &dXMax, pabyRec + 16, 8 );
-  ByteCopy( &dYMax, pabyRec + 24, 8 );
-}
-
-int msSHPWritePoint(SHPHandle psSHP, pointObj *point )
-{
-  int nRecordOffset, nRecordSize=0;
-  uchar *pabyRec;
-  ms_int32  i32, nPoints, nParts;
-
-  if( psSHP->nShapeType != SHP_POINT) return(-1);
-  if( psSHP->nFileSize == 0 ) return -1;
-
-  psSHP->bUpdated = MS_TRUE;
-
-  /* Fill the SHX buffer if it is not already full. */
-  if( ! psSHP->panRecAllLoaded ) msSHXLoadAll( psSHP );
-
-  /* -------------------------------------------------------------------- */
-  /*      Add the new entity to the in memory index.                      */
-  /* -------------------------------------------------------------------- */
-  psSHP->nRecords++;
-  if( psSHP->nRecords > psSHP->nMaxRecords ) {
-    psSHP->nMaxRecords = (int) (psSHP->nMaxRecords * 1.3 + 100);
-
-    psSHP->panRecOffset = (int *) SfRealloc(psSHP->panRecOffset,sizeof(int) * psSHP->nMaxRecords );
-    psSHP->panRecSize = (int *) SfRealloc(psSHP->panRecSize,sizeof(int) * psSHP->nMaxRecords );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Compute a few things.                                           */
-  /* -------------------------------------------------------------------- */
-  nPoints = 1;
-  nParts = 1;
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize record.                                              */
-  /* -------------------------------------------------------------------- */
-  psSHP->panRecOffset[psSHP->nRecords-1] = nRecordOffset = psSHP->nFileSize;
-
-  pabyRec = (uchar *) msSmallMalloc(nPoints * 2 * sizeof(double) + nParts * 4 + 128);
-
-  /* -------------------------------------------------------------------- */
-  /*      Write vertices for a point.                                     */
-  /* -------------------------------------------------------------------- */
-  ByteCopy( &(point->x), pabyRec + 12, 8 );
-  ByteCopy( &(point->y), pabyRec + 20, 8 );
-
-
-  if( bBigEndian ) {
-    SwapWord( 8, pabyRec + 12 );
-    SwapWord( 8, pabyRec + 20 );
-  }
-
-  nRecordSize = 20;
-
-  /* -------------------------------------------------------------------- */
-  /*      Set the shape type, record number, and record size.             */
-  /* -------------------------------------------------------------------- */
-  i32 = psSHP->nRecords-1+1;          /* record # */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec, 4 );
-
-  i32 = nRecordSize/2;        /* record size */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 4, 4 );
-
-  i32 = psSHP->nShapeType;        /* shape type */
-  if( bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 8, 4 );
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out record.                                               */
-  /* -------------------------------------------------------------------- */
-  if(VSIFSeekL( psSHP->fpSHP, nRecordOffset, 0 ) == 0) {
-    VSIFWriteL( pabyRec, nRecordSize+8, 1, psSHP->fpSHP );
-
-    psSHP->panRecSize[psSHP->nRecords-1] = nRecordSize;
-    psSHP->nFileSize += nRecordSize + 8;
-
-    /* -------------------------------------------------------------------- */
-    /*  Expand file wide bounds based on this shape.        */
-    /* -------------------------------------------------------------------- */
-    if( psSHP->nRecords == 1 ) {
-      psSHP->adBoundsMin[0] = psSHP->adBoundsMax[0] = point->x;
-      psSHP->adBoundsMin[1] = psSHP->adBoundsMax[1] = point->y;
-    } else {
-      psSHP->adBoundsMin[0] = MS_MIN(psSHP->adBoundsMin[0], point->x);
-      psSHP->adBoundsMin[1] = MS_MIN(psSHP->adBoundsMin[1], point->y);
-      psSHP->adBoundsMax[0] = MS_MAX(psSHP->adBoundsMax[0], point->x);
-      psSHP->adBoundsMax[1] = MS_MAX(psSHP->adBoundsMax[1], point->y);
-    }
-  } else {
-    psSHP->nRecords -- ;
-  }
-  free( pabyRec );
-  return( psSHP->nRecords - 1 );
-}
-
-int msSHPWriteShape(SHPHandle psSHP, shapeObj *shape )
-{
-  int nRecordOffset, i, j, k, nRecordSize=0;
-  uchar *pabyRec;
-  int nShapeType;
-
-  ms_int32  i32, nPoints, nParts;
-
-  if( psSHP->nFileSize == 0 ) return -1;
-
-  psSHP->bUpdated = MS_TRUE;
-
-  /* Fill the SHX buffer if it is not already full. */
-  if( ! psSHP->panRecAllLoaded ) msSHXLoadAll( psSHP );
-
-  /* -------------------------------------------------------------------- */
-  /*      Add the new entity to the in memory index.                      */
-  /* -------------------------------------------------------------------- */
-  psSHP->nRecords++;
-  if( psSHP->nRecords > psSHP->nMaxRecords ) {
-    psSHP->nMaxRecords = (int) (psSHP->nMaxRecords * 1.3 + 100);
-
-    psSHP->panRecOffset = (int *) SfRealloc(psSHP->panRecOffset,sizeof(int) * psSHP->nMaxRecords );
-    psSHP->panRecSize = (int *) SfRealloc(psSHP->panRecSize,sizeof(int) * psSHP->nMaxRecords );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Compute a few things.                                           */
-  /* -------------------------------------------------------------------- */
-  nPoints = 0;
-  for(i=0; i<shape->numlines; i++)
-    nPoints += shape->line[i].numpoints;
-
-  nParts = shape->numlines;
-
-  /* -------------------------------------------------------------------- */
-  /*      Initialize record.                                              */
-  /* -------------------------------------------------------------------- */
-  psSHP->panRecOffset[psSHP->nRecords-1] = nRecordOffset = psSHP->nFileSize;
-
-  pabyRec = (uchar *) msSmallMalloc(nPoints * 4 * sizeof(double) + nParts * 8 + 128);
-  nShapeType = psSHP->nShapeType;
-
-  if (shape->type == MS_SHAPE_NULL) {
-    nShapeType = 0;
-    nRecordSize = 12;
-  }
-  /* -------------------------------------------------------------------- */
-  /*  Write vertices for a Polygon or Arc.            */
-  /* -------------------------------------------------------------------- */
-  else if(psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
-          psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM ||
-          psSHP->nShapeType == SHP_ARCZ ||  psSHP->nShapeType == SHP_POLYGONZ) {
-    ms_int32 t_nParts, t_nPoints, partSize;
-
-    t_nParts = nParts;
-    t_nPoints = nPoints;
-
-    writeBounds( pabyRec + 12, shape, t_nPoints );
-
-    if( bBigEndian ) {
-      nPoints = SWAP_FOUR_BYTES(nPoints);
-      nParts = SWAP_FOUR_BYTES(nParts);
-    }
-
-    ByteCopy( &nPoints, pabyRec + 40 + 8, 4 );
-    ByteCopy( &nParts, pabyRec + 36 + 8, 4 );
-
-    partSize = 0; /* first part always starts at 0 */
-    ByteCopy( &partSize, pabyRec + 44 + 8 + 4*0, 4 );
-    if( bBigEndian ) SwapWord( 4, pabyRec + 44 + 8 + 4*0);
-
-    for( i = 1; i < t_nParts; i++ ) {
-      partSize += shape->line[i-1].numpoints;
-      ByteCopy( &partSize, pabyRec + 44 + 8 + 4*i, 4 );
-      if( bBigEndian ) SwapWord( 4, pabyRec + 44 + 8 + 4*i);
-
-    }
-
-    k = 0; /* overall point counter */
-    for( i = 0; i < shape->numlines; i++ ) {
-      for( j = 0; j < shape->line[i].numpoints; j++ ) {
-        ByteCopy( &(shape->line[i].point[j].x), pabyRec + 44 + 4*t_nParts + 8 + k * 16, 8 );
-        ByteCopy( &(shape->line[i].point[j].y), pabyRec + 44 + 4*t_nParts + 8 + k * 16 + 8, 8 );
-
-        if( bBigEndian ) {
-          SwapWord( 8, pabyRec + 44+4*t_nParts+8+k*16 );
-          SwapWord( 8, pabyRec + 44+4*t_nParts+8+k*16+8 );
-        }
-
-        k++;
-      }
-    }
-
-    nRecordSize = 44 + 4*t_nParts + 16 * t_nPoints;
-
-    /* -------------------------------------------------------------------- */
-    /*      measured shape : polygon and arc.                               */
-    /* -------------------------------------------------------------------- */
-    if(psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
-      const double dfMMin = shape->line[0].point[0].m;
-      const double dfMMax = shape->line[shape->numlines-1].point[shape->line[shape->numlines-1].numpoints-1].m;
-
-      nRecordSize = 44 + 4*t_nParts + 8 + (t_nPoints* 16);
-
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      for( i = 0; i < shape->numlines; i++ ) {
-        for( j = 0; j < shape->line[i].numpoints; j++ ) {
-          ByteCopy( &(shape->line[i].point[j].m), pabyRec + nRecordSize, 8 );
-          if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-          nRecordSize += 8;
-        }
-      }
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Polygon. Arc with Z                                             */
-    /* -------------------------------------------------------------------- */
-    if (psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ
-        || psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
-      const double dfMMin = shape->line[0].point[0].z;
-      const double dfMMax = shape->line[shape->numlines-1].point[shape->line[shape->numlines-1].numpoints-1].z;
-
-      nRecordSize = 44 + 4*t_nParts + 8 + (t_nPoints* 16);
-
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      for( i = 0; i < shape->numlines; i++ ) {
-        for( j = 0; j < shape->line[i].numpoints; j++ ) {
-          ByteCopy( &(shape->line[i].point[j].z), pabyRec + nRecordSize, 8 );
-          if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-          nRecordSize += 8;
-        }
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Write vertices for a MultiPoint.                                    */
-  /* -------------------------------------------------------------------- */
-  else if( psSHP->nShapeType == SHP_MULTIPOINT ||
-           psSHP->nShapeType == SHP_MULTIPOINTM ||
-           psSHP->nShapeType == SHP_MULTIPOINTZ) {
-    ms_int32 t_nPoints;
-
-    t_nPoints = nPoints;
-
-    writeBounds( pabyRec + 12, shape, nPoints );
-
-    if( bBigEndian ) nPoints = SWAP_FOUR_BYTES(nPoints);
-    ByteCopy( &nPoints, pabyRec + 44, 4 );
-
-    for( i = 0; i < shape->line[0].numpoints; i++ ) {
-      ByteCopy( &(shape->line[0].point[i].x), pabyRec + 48 + i*16, 8 );
-      ByteCopy( &(shape->line[0].point[i].y), pabyRec + 48 + i*16 + 8, 8 );
-
-      if( bBigEndian ) {
-        SwapWord( 8, pabyRec + 48 + i*16 );
-        SwapWord( 8, pabyRec + 48 + i*16 + 8 );
-      }
-    }
-
-    nRecordSize = 40 + 16 * t_nPoints;
-
-    if (psSHP->nShapeType == SHP_MULTIPOINTM) {
-      const double dfMMin = shape->line[0].point[0].m;
-      const double dfMMax = shape->line[0].point[shape->line[0].numpoints-1].m;
-
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      for( i = 0; i < shape->line[0].numpoints; i++ ) {
-        ByteCopy( &(shape->line[0].point[i].m), pabyRec + nRecordSize, 8 );
-        if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-        nRecordSize += 8;
-      }
-    }
-
-    if (psSHP->nShapeType == SHP_MULTIPOINTZ) {
-      const double dfMMin = shape->line[0].point[0].z;
-      const double dfMMax = shape->line[0].point[shape->line[0].numpoints-1].z;
-
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-
-      for( i = 0; i < shape->line[0].numpoints; i++ ) {
-        ByteCopy( &(shape->line[0].point[i].z), pabyRec + nRecordSize, 8 );
-        if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-        nRecordSize += 8;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Write vertices for a point.                                     */
-  /* -------------------------------------------------------------------- */
-  else if( psSHP->nShapeType == SHP_POINT ||  psSHP->nShapeType == SHP_POINTM ||
-           psSHP->nShapeType == SHP_POINTZ) {
-    ByteCopy( &(shape->line[0].point[0].x), pabyRec + 12, 8 );
-    ByteCopy( &(shape->line[0].point[0].y), pabyRec + 20, 8 );
-
-    if( bBigEndian ) {
-      SwapWord( 8, pabyRec + 12 );
-      SwapWord( 8, pabyRec + 20 );
-    }
-
-    nRecordSize = 20;
-
-    if (psSHP->nShapeType == SHP_POINTM) {
-      ByteCopy( &(shape->line[0].point[0].m), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-    }
-
-    if (psSHP->nShapeType == SHP_POINTZ) {
-      ByteCopy( &(shape->line[0].point[0].z), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
-      nRecordSize += 8;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Set the shape type, record number, and record size.             */
-  /* -------------------------------------------------------------------- */
-  i32 = psSHP->nRecords-1+1;          /* record # */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec, 4 );
-
-  i32 = nRecordSize/2;        /* record size */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 4, 4 );
-
-  i32 = nShapeType;     /* shape type */
-  if( bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 8, 4 );
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out record.                                               */
-  /* -------------------------------------------------------------------- */
-  if(VSIFSeekL( psSHP->fpSHP, nRecordOffset, 0 ) == 0) {
-    VSIFWriteL( pabyRec, nRecordSize+8, 1, psSHP->fpSHP );
-
-    psSHP->panRecSize[psSHP->nRecords-1] = nRecordSize;
-    psSHP->nFileSize += nRecordSize + 8;
-
-    /* -------------------------------------------------------------------- */
-    /*  Expand file wide bounds based on this shape.        */
-    /* -------------------------------------------------------------------- */
-    if( psSHP->nRecords == 1 ) {
-      psSHP->adBoundsMin[0] = psSHP->adBoundsMax[0] = shape->line[0].point[0].x;
-      psSHP->adBoundsMin[1] = psSHP->adBoundsMax[1] = shape->line[0].point[0].y;
-      psSHP->adBoundsMin[2] = psSHP->adBoundsMax[2] = shape->line[0].point[0].z;
-      psSHP->adBoundsMin[3] = psSHP->adBoundsMax[3] = shape->line[0].point[0].m;
-    }
-
-    for( i=0; i<shape->numlines; i++ ) {
-      for( j=0; j<shape->line[i].numpoints; j++ ) {
-        psSHP->adBoundsMin[0] = MS_MIN(psSHP->adBoundsMin[0], shape->line[i].point[j].x);
-        psSHP->adBoundsMin[1] = MS_MIN(psSHP->adBoundsMin[1], shape->line[i].point[j].y);
-        psSHP->adBoundsMin[2] = MS_MIN(psSHP->adBoundsMin[2], shape->line[i].point[j].z);
-        psSHP->adBoundsMin[3] = MS_MIN(psSHP->adBoundsMin[3], shape->line[i].point[j].m);
-        psSHP->adBoundsMax[0] = MS_MAX(psSHP->adBoundsMax[0], shape->line[i].point[j].x);
-        psSHP->adBoundsMax[1] = MS_MAX(psSHP->adBoundsMax[1], shape->line[i].point[j].y);
-        psSHP->adBoundsMax[2] = MS_MAX(psSHP->adBoundsMax[2], shape->line[i].point[j].z);
-        psSHP->adBoundsMax[3] = MS_MAX(psSHP->adBoundsMax[3], shape->line[i].point[j].m);
-      }
-    }
-
-  } else {
-    psSHP->nRecords --;
-    /* there was an error writing the record */
-  }
-  free( pabyRec );
-  return( psSHP->nRecords - 1 );
-}
-
-/*
- ** msSHPReadAllocateBuffer() - Ensure our record buffer is large enough.
- */
-static uchar *msSHPReadAllocateBuffer( SHPHandle psSHP, int hEntity, const char* pszCallingFunction)
-{
-
-  int nEntitySize = msSHXReadSize(psSHP, hEntity);
-  if( nEntitySize <= 0 || nEntitySize > INT_MAX - 8 ) {
-      msSetError(MS_MEMERR, "Out of memory. Cannot allocate %d bytes. Probably broken shapefile at feature %d",
-                 pszCallingFunction, nEntitySize, hEntity);
-      return NULL;
-  }
-  nEntitySize += 8;
-  /* -------------------------------------------------------------------- */
-  /*      Ensure our record buffer is large enough.                       */
-  /* -------------------------------------------------------------------- */
-
-#ifdef FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION
-  /* when running with libFuzzer, allocate a new buffer for every
-     call, to allow AddressSanitizer to detect memory errors */
-  free(psSHP->pabyRec);
-  psSHP->pabyRec = NULL;
-  psSHP->nBufSize = 0;
-#endif
-
-  if( nEntitySize > psSHP->nBufSize ) {
-    uchar* pabyRec = (uchar *) SfRealloc(psSHP->pabyRec,nEntitySize);
-    if (pabyRec == NULL) {
-      msSetError(MS_MEMERR, "Out of memory. Cannot allocate %d bytes. Probably broken shapefile at feature %d",
-                 pszCallingFunction, nEntitySize, hEntity);
-      return NULL;
-    }
-    psSHP->pabyRec = pabyRec;
-    psSHP->nBufSize = nEntitySize;
-  }
-  return psSHP->pabyRec;
-}
-
-/*
-** msSHPReadPoint() - Reads a single point from a POINT shape file.
-*/
-int msSHPReadPoint( SHPHandle psSHP, int hEntity, pointObj *point )
-{
-  int nEntitySize;
-
-  /* -------------------------------------------------------------------- */
-  /*      Only valid for point shapefiles                                 */
-  /* -------------------------------------------------------------------- */
-  if( psSHP->nShapeType != SHP_POINT ) {
-    msSetError(MS_SHPERR, "msSHPReadPoint only operates on point shapefiles.", "msSHPReadPoint()");
-    return(MS_FAILURE);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Validate the record/entity number.                              */
-  /* -------------------------------------------------------------------- */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords ) {
-    msSetError(MS_SHPERR, "Record index out of bounds.", "msSHPReadPoint()");
-    return(MS_FAILURE);
-  }
-
-  nEntitySize = msSHXReadSize( psSHP, hEntity) + 8;
-
-  if( nEntitySize == 12 ) {
-    msSetError(MS_SHPERR, "NULL feature encountered.", "msSHPReadPoint()");
-    return(MS_FAILURE);
-  } else if ( nEntitySize < 28 ) {
-    msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity=%d, nEntitySize=%d", "msSHPReadPoint()",
-               hEntity, nEntitySize);
-    return(MS_FAILURE);
-  }
-
-  uchar *pabyRec = msSHPReadAllocateBuffer(psSHP, hEntity, "msSHPReadPoint()");
-  if (pabyRec == NULL) {
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Read the record.                                                */
-  /* -------------------------------------------------------------------- */
-  const int offset = msSHXReadOffset( psSHP, hEntity);
-  if( offset <= 0 || 0 != VSIFSeekL( psSHP->fpSHP, offset, 0 )) {
-    msSetError(MS_IOERR, "failed to seek offset", "msSHPReadPoint()");
-    return(MS_FAILURE);
-  }
-  if( 1 != VSIFReadL( pabyRec, nEntitySize, 1, psSHP->fpSHP )) {
-    msSetError(MS_IOERR, "failed to fread record", "msSHPReadPoint()");
-    return(MS_FAILURE);
-  }
-
-
-  memcpy( &(point->x), pabyRec + 12, 8 );
-  memcpy( &(point->y), pabyRec + 20, 8 );
-
-  if( bBigEndian ) {
-    SwapWord( 8, &(point->x));
-    SwapWord( 8, &(point->y));
-  }
-
-  return(MS_SUCCESS);
-}
-
-/*
-** msSHXLoadPage()
-**
-** The SHX tells us what the byte offsets of the shapes in the SHP file are.
-** We read the SHX file in ~8K pages and store those pages in memory for
-** successive accesses during the reading cycle (first bounds are read,
-** then entire shapes). Each time we read a page, we mark it as read.
-*/
-static bool msSHXLoadPage( SHPHandle psSHP, int shxBufferPage )
-{
-  int i;
-
-  /* Each SHX record is 8 bytes long (two ints), hence our buffer size. */
-  char buffer[SHX_BUFFER_PAGE * 8];
-
-  /*  Validate the page number. */
-  if( shxBufferPage < 0  )
-    return(MS_FAILURE);
-
-  const int nShapesToCache =
-      shxBufferPage < psSHP->nRecords / SHX_BUFFER_PAGE ? SHX_BUFFER_PAGE :
-      psSHP->nRecords - shxBufferPage * SHX_BUFFER_PAGE;
-
-  if( 0 != VSIFSeekL( psSHP->fpSHX, 100 + shxBufferPage * SHX_BUFFER_PAGE * 8, 0 )) {
-    memset(psSHP->panRecOffset + shxBufferPage * SHX_BUFFER_PAGE, 0,
-           nShapesToCache * sizeof(psSHP->panRecOffset[0]));
-    memset(psSHP->panRecSize + shxBufferPage * SHX_BUFFER_PAGE, 0,
-           nShapesToCache * sizeof(psSHP->panRecSize[0]));
-    msSetBit(psSHP->panRecLoaded, shxBufferPage, 1);
-    msSetError(MS_IOERR, "failed to seek offset", "msSHXLoadPage()");
-    return false;
-  }
-
-  if( (size_t)nShapesToCache != VSIFReadL( buffer, 8, nShapesToCache, psSHP->fpSHX )) {
-    memset(psSHP->panRecOffset + shxBufferPage * SHX_BUFFER_PAGE, 0,
-           nShapesToCache * sizeof(psSHP->panRecOffset[0]));
-    memset(psSHP->panRecSize + shxBufferPage * SHX_BUFFER_PAGE, 0,
-           nShapesToCache * sizeof(psSHP->panRecSize[0]));
-    msSetBit(psSHP->panRecLoaded, shxBufferPage, 1);
-    msSetError(MS_IOERR, "failed to fread SHX record", "msSHXLoadPage()");
-    return false;
-  }
-
-  /* Copy the buffer contents out into the working arrays. */
-  for( i = 0; i < nShapesToCache; i++ ) {
-    int tmpOffset, tmpSize;
-
-    memcpy( &tmpOffset, (buffer + (8*i)), 4);
-    memcpy( &tmpSize, (buffer + (8*i) + 4), 4);
-
-    /* SHX uses big endian numbers for the offsets, so we have to flip them */
-    /* if we are a little endian machine. */
-    if( !bBigEndian ) {
-      tmpOffset = SWAP_FOUR_BYTES(tmpOffset);
-      tmpSize = SWAP_FOUR_BYTES(tmpSize);
-    }
-
-    /* SHX stores the offsets in 2 byte units, so we double them to get */
-    /* an offset in bytes. */
-    if( tmpOffset > 0 && tmpOffset < INT_MAX / 2 )
-        tmpOffset = tmpOffset * 2;
-    else
-        tmpOffset = 0;
-
-    if( tmpSize > 0 && tmpSize < INT_MAX / 2 )
-        tmpSize = tmpSize * 2;
-    else
-        tmpSize = 0;
-
-    /* Write the answer into the working arrays on the SHPHandle */
-    psSHP->panRecOffset[shxBufferPage * SHX_BUFFER_PAGE + i] = tmpOffset;
-    psSHP->panRecSize[shxBufferPage * SHX_BUFFER_PAGE + i] = tmpSize;
-  }
-
-  msSetBit(psSHP->panRecLoaded, shxBufferPage, 1);
-
-  return(MS_SUCCESS);
-}
-
-static int msSHXLoadAll( SHPHandle psSHP )
-{
-
-  int i;
-  uchar *pabyBuf;
-
-  pabyBuf = (uchar *) malloc(8 * psSHP->nRecords );
-  if( pabyBuf == NULL )
-  {
-    msSetError(MS_IOERR, "failed to allocate memory for SHX buffer", "msSHXLoadAll()");
-    return MS_FAILURE;
-  }
-  if((size_t)psSHP->nRecords != VSIFReadL( pabyBuf, 8, psSHP->nRecords, psSHP->fpSHX )) {
-    msSetError(MS_IOERR, "failed to read shx records", "msSHXLoadAll()");
-    free(pabyBuf);
-    return MS_FAILURE;
-  }
-  for( i = 0; i < psSHP->nRecords; i++ ) {
-    ms_int32 nOffset, nLength;
-
-    memcpy( &nOffset, pabyBuf + i * 8, 4 );
-    memcpy( &nLength, pabyBuf + i * 8 + 4, 4 );
-
-    if( !bBigEndian ) {
-      nOffset = SWAP_FOUR_BYTES( nOffset );
-      nLength = SWAP_FOUR_BYTES( nLength );
-    }
-
-    /* SHX stores the offsets in 2 byte units, so we double them to get */
-    /* an offset in bytes. */
-    if( nOffset > 0 && nOffset < INT_MAX / 2 )
-        nOffset = nOffset * 2;
-    else
-        nOffset = 0;
-
-    if( nLength > 0 && nLength < INT_MAX / 2 )
-        nLength = nLength * 2;
-    else
-        nLength = 0;
-
-    psSHP->panRecOffset[i] = nOffset;
-    psSHP->panRecSize[i] = nLength;
-  }
-  free(pabyBuf);
-  psSHP->panRecAllLoaded = 1;
-
-  return(MS_SUCCESS);
-
-}
-
-static int msSHXReadOffset( SHPHandle psSHP, int hEntity )
-{
-
-  int shxBufferPage = hEntity / SHX_BUFFER_PAGE;
-
-  /*  Validate the record/entity number. */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords )
-    return 0;
-
-  if( ! (psSHP->panRecAllLoaded || msGetBit(psSHP->panRecLoaded, shxBufferPage)) ) {
-    msSHXLoadPage( psSHP, shxBufferPage );
-  }
-
-  return psSHP->panRecOffset[hEntity];
-
-}
-
-static int msSHXReadSize( SHPHandle psSHP, int hEntity )
-{
-
-  int shxBufferPage = hEntity / SHX_BUFFER_PAGE;
-
-  /*  Validate the record/entity number. */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords )
-    return 0;
-
-  if( ! (psSHP->panRecAllLoaded || msGetBit(psSHP->panRecLoaded, shxBufferPage)) ) {
-    msSHXLoadPage( psSHP, shxBufferPage );
-  }
-
-  return psSHP->panRecSize[hEntity];
-
-}
-
-static void ReadRect(rectObj *r, const uchar *src)
-{
-    memcpy( &r->minx, src, 8 );
-    memcpy( &r->miny, src + 8, 8 );
-    memcpy( &r->maxx, src + 16, 8 );
-    memcpy( &r->maxy, src + 24, 8 );
-
-    if( bBigEndian ) {
-      SwapWord( 8, &r->minx);
-      SwapWord( 8, &r->miny);
-      SwapWord( 8, &r->maxx);
-      SwapWord( 8, &r->maxy);
-    }
-}
-
-/*
-** msSHPReadShape() - Reads the vertices for one shape from a shape file.
-*/
-void msSHPReadShape( SHPHandle psSHP, int hEntity, shapeObj *shape )
-{
-  int i, j, k;
-  int nEntitySize, nRequiredSize;
-
-  msInitShape(shape); /* initialize the shape */
-
-  /* -------------------------------------------------------------------- */
-  /*      Validate the record/entity number.                              */
-  /* -------------------------------------------------------------------- */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords )
-    return;
-
-  nEntitySize = msSHXReadSize(psSHP, hEntity);
-  if( nEntitySize < 4 || nEntitySize > INT_MAX - 8 )
-  {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d", "msSHPReadShape()",
-                 hEntity, nEntitySize);
-      return;
-  }
-
-  nEntitySize += 8;
-  if( nEntitySize == 12 ) {
-    shape->type = MS_SHAPE_NULL;
-    return;
-  }
-
-  uchar *pabyRec = msSHPReadAllocateBuffer(psSHP, hEntity, "msSHPReadShape()");
-  if (pabyRec == NULL) {
-    shape->type = MS_SHAPE_NULL;
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Read the record.                                                */
-  /* -------------------------------------------------------------------- */
-  const int offset = msSHXReadOffset( psSHP, hEntity);
-  if( offset <= 0 || 0 != VSIFSeekL( psSHP->fpSHP, offset, 0 )) {
-    msSetError(MS_IOERR, "failed to seek offset", "msSHPReadShape()");
-    shape->type = MS_SHAPE_NULL;
-    return;
-  }
-  if( 1 != VSIFReadL( pabyRec, nEntitySize, 1, psSHP->fpSHP )) {
-    msSetError(MS_IOERR, "failed to fread record", "msSHPReadPoint()");
-    shape->type = MS_SHAPE_NULL;
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Extract vertices for a Polygon or Arc.            */
-  /* -------------------------------------------------------------------- */
-  if( psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
-      psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM ||
-      psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ) {
-    ms_int32  nPoints, nParts;
-
-    if (nEntitySize < 40 + 8 + 4) {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d", "msSHPReadShape()",
-                 hEntity, nEntitySize);
-      return;
-    }
-
-    /* copy the bounding box */
-    ReadRect(&shape->bounds, pabyRec + 8 + 4);
-
-    memcpy( &nPoints, pabyRec + 40 + 8, 4 );
-    memcpy( &nParts, pabyRec + 36 + 8, 4 );
-
-    if( bBigEndian ) {
-      nPoints = SWAP_FOUR_BYTES(nPoints);
-      nParts = SWAP_FOUR_BYTES(nParts);
-    }
-
-    if (nPoints < 0 || nParts < 0 ||
-        nPoints > 50 * 1000 * 1000 || nParts > 10 * 1000 * 1000) {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity = %d, nPoints =%d, nParts = %d", "msSHPReadShape()",
-                 hEntity, nPoints, nParts);
-      return;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Copy out the part array from the record.                        */
-    /* -------------------------------------------------------------------- */
-
-#ifdef FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION
-    /* when running with libFuzzer, allocate a new buffer for every
-       call, to allow AddressSanitizer to detect memory errors */
-    free(psSHP->panParts);
-    psSHP->panParts = NULL;
-    psSHP->nPartMax = 0;
-#endif
-
-    if( psSHP->nPartMax < nParts ) {
-      psSHP->panParts = (int *) SfRealloc(psSHP->panParts, nParts * sizeof(int) );
-      if (psSHP->panParts == NULL) {
-        /* Reallocate previous successfull size for following features */
-        psSHP->panParts = (int *) msSmallMalloc(psSHP->nPartMax * sizeof(int) );
-
-        shape->type = MS_SHAPE_NULL;
-        msSetError(MS_MEMERR, "Out of memory. Cannot allocate %d bytes. Probably broken shapefile at feature %d",
-                   "msSHPReadShape()", (int)(nParts * sizeof(int)), hEntity);
-        return;
-      }
-      psSHP->nPartMax = nParts;
-    }
-    if (psSHP->panParts == NULL) {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
-      return;
-    }
-
-    /* With the previous checks on nPoints and nParts, */
-    /* we should not overflow here and after */
-    /* since 50 M * (16 + 8 + 8) = 1 600 MB */
-    if (44 + 8 + 4 * nParts + 16 * nPoints > nEntitySize) {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted .shp file : shape %d, nPoints=%d, nParts=%d.",
-                 "msSHPReadShape()", hEntity, nPoints, nParts);
-      return;
-    }
-
-    memcpy( psSHP->panParts, pabyRec + 44 + 8, 4 * nParts );
-    if( bBigEndian ) {
-      for( i = 0; i < nParts; i++ ) {
-        *(psSHP->panParts+i) = SWAP_FOUR_BYTES(*(psSHP->panParts+i));
-      }
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Fill the shape structure.                                       */
-    /* -------------------------------------------------------------------- */
-    shape->line = (lineObj *)malloc(sizeof(lineObj)*nParts);
-    MS_CHECK_ALLOC_NO_RET(shape->line, sizeof(lineObj)*nParts);
-
-    shape->numlines = nParts;
-
-    k = 0; /* overall point counter */
-    for( i = 0; i < nParts; i++) {
-      const ms_int32 end = i == nParts - 1
-        ? nPoints
-        : psSHP->panParts[i+1];
-      if (psSHP->panParts[i] < 0 || end < 0 || end > nPoints ||
-          psSHP->panParts[i] >= end) {
-        msSetError(MS_SHPERR, "Corrupted .shp file : shape %d, shape->line[%d].start=%d, shape->line[%d].end=%d", "msSHPReadShape()",
-                   hEntity,
-                   i, psSHP->panParts[i],
-                   i, end);
-        while(--i >= 0)
-          free(shape->line[i].point);
-        free(shape->line);
-        shape->line = NULL;
-        shape->numlines = 0;
-        shape->type = MS_SHAPE_NULL;
-        return;
-      }
-
-      shape->line[i].numpoints = end - psSHP->panParts[i];
-      if( (shape->line[i].point = (pointObj *)malloc(sizeof(pointObj)*shape->line[i].numpoints)) == NULL ) {
-        while(--i >= 0)
-          free(shape->line[i].point);
-        free(shape->line);
-        shape->line = NULL;
-        shape->numlines = 0;
-        shape->type = MS_SHAPE_NULL;
-        msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
-        return;
-      }
-
-      /* nOffset = 44 + 8 + 4*nParts; */
-      for( j = 0; j < shape->line[i].numpoints; j++ ) {
-        memcpy(&(shape->line[i].point[j].x), pabyRec + 44 + 4*nParts + 8 + k * 16, 8 );
-        memcpy(&(shape->line[i].point[j].y), pabyRec + 44 + 4*nParts + 8 + k * 16 + 8, 8 );
-
-        if( bBigEndian ) {
-          SwapWord( 8, &(shape->line[i].point[j].x) );
-          SwapWord( 8, &(shape->line[i].point[j].y) );
-        }
-
-        /* -------------------------------------------------------------------- */
-        /*      Polygon, Arc with Z values.                                     */
-        /* -------------------------------------------------------------------- */
-        shape->line[i].point[j].z = 0.0; /* initialize */
-        if (psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ) {
-          const int nOffset = 44 + 8 + (4*nParts) + (16*nPoints) ;
-          if( nEntitySize >= nOffset + 16 + 8*nPoints ) {
-            memcpy(&(shape->line[i].point[j].z), pabyRec + nOffset + 16 + k*8, 8 );
-            if( bBigEndian ) SwapWord( 8, &(shape->line[i].point[j].z) );
-          }
-        }
-
-        /* -------------------------------------------------------------------- */
-        /*      Measured arc and polygon support.                               */
-        /* -------------------------------------------------------------------- */
-        shape->line[i].point[j].m = 0; /* initialize */
-        if (psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
-          const int nOffset = 44 + 8 + (4*nParts) + (16*nPoints) ;
-          if( nEntitySize >= nOffset + 16 + 8*nPoints ) {
-            memcpy(&(shape->line[i].point[j].m), pabyRec + nOffset + 16 + k*8, 8 );
-            if( bBigEndian ) SwapWord( 8, &(shape->line[i].point[j].m) );
-          }
-        }
-        k++;
-      }
-    }
-
-    if(psSHP->nShapeType == SHP_POLYGON
-        || psSHP->nShapeType == SHP_POLYGONZ
-        || psSHP->nShapeType == SHP_POLYGONM)
-      shape->type = MS_SHAPE_POLYGON;
-    else
-      shape->type = MS_SHAPE_LINE;
-
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Extract a MultiPoint.                                               */
-  /* -------------------------------------------------------------------- */
-  else if( psSHP->nShapeType == SHP_MULTIPOINT || psSHP->nShapeType == SHP_MULTIPOINTM ||
-           psSHP->nShapeType == SHP_MULTIPOINTZ) {
-    ms_int32 nPoints;
-
-    if (nEntitySize < 44 + 4) {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  recSize of feature %d=%d", "msSHPReadShape()",
-                 hEntity, msSHXReadSize(psSHP, hEntity));
-      return;
-    }
-
-    /* copy the bounding box */
-    ReadRect(&shape->bounds, pabyRec + 8 + 4);
-
-    memcpy( &nPoints, pabyRec + 44, 4 );
-    if( bBigEndian ) nPoints = SWAP_FOUR_BYTES(nPoints);
-
-    /* -------------------------------------------------------------------- */
-    /*      Fill the shape structure.                                       */
-    /* -------------------------------------------------------------------- */
-    if( (shape->line = (lineObj *)malloc(sizeof(lineObj))) == NULL ) {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
-      return;
-    }
-
-    if (nPoints < 0 || nPoints > 50 * 1000 * 1000) {
-      free(shape->line);
-      shape->line = NULL;
-      shape->numlines = 0;
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted .shp file : shape %d, nPoints=%d.",
-                 "msSHPReadShape()", hEntity, nPoints);
-      return;
-    }
-
-    nRequiredSize = 48 + nPoints * 16;
-    if (psSHP->nShapeType == SHP_MULTIPOINTZ || psSHP->nShapeType == SHP_MULTIPOINTM)
-      nRequiredSize += 16 + nPoints * 8;
-    if (nRequiredSize > nEntitySize) {
-      free(shape->line);
-      shape->line = NULL;
-      shape->numlines = 0;
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted .shp file : shape %d : nPoints = %d, nEntitySize = %d",
-                 "msSHPReadShape()", hEntity, nPoints, nEntitySize);
-      return;
-    }
-
-    shape->numlines = 1;
-    shape->line[0].numpoints = nPoints;
-    shape->line[0].point = (pointObj *) malloc( nPoints * sizeof(pointObj) );
-    if (shape->line[0].point == NULL) {
-      free(shape->line);
-      shape->line = NULL;
-      shape->numlines = 0;
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
-      return;
-    }
-
-    for( i = 0; i < nPoints; i++ ) {
-      memcpy(&(shape->line[0].point[i].x), pabyRec + 48 + 16 * i, 8 );
-      memcpy(&(shape->line[0].point[i].y), pabyRec + 48 + 16 * i + 8, 8 );
-
-      if( bBigEndian ) {
-        SwapWord( 8, &(shape->line[0].point[i].x) );
-        SwapWord( 8, &(shape->line[0].point[i].y) );
-      }
-
-      /* -------------------------------------------------------------------- */
-      /*      MulipointZ                                                      */
-      /* -------------------------------------------------------------------- */
-      shape->line[0].point[i].z = 0; /* initialize */
-      if (psSHP->nShapeType == SHP_MULTIPOINTZ) {
-        const int nOffset = 48 + 16*nPoints;
-        memcpy(&(shape->line[0].point[i].z), pabyRec + nOffset + 16 + i*8, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[i].z));
-      }
-
-      /* -------------------------------------------------------------------- */
-      /*      Measured shape : multipont.                                     */
-      /* -------------------------------------------------------------------- */
-      shape->line[0].point[i].m = 0; /* initialize */
-      if (psSHP->nShapeType == SHP_MULTIPOINTM) {
-        const int nOffset = 48 + 16*nPoints;
-        memcpy(&(shape->line[0].point[i].m), pabyRec + nOffset + 16 + i*8, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[i].m));
-      }
-    }
-
-    shape->type = MS_SHAPE_POINT;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Extract a Point.                            */
-  /* -------------------------------------------------------------------- */
-  else if(psSHP->nShapeType == SHP_POINT ||  psSHP->nShapeType == SHP_POINTM ||
-          psSHP->nShapeType == SHP_POINTZ) {
-
-    if (nEntitySize < 20 + 8) {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  recSize of feature %d=%d", "msSHPReadShape()",
-                 hEntity, msSHXReadSize(psSHP, hEntity));
-      return;
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Fill the shape structure.                                       */
-    /* -------------------------------------------------------------------- */
-    shape->line = (lineObj *)malloc(sizeof(lineObj));
-    MS_CHECK_ALLOC_NO_RET(shape->line, sizeof(lineObj));
-
-    shape->numlines = 1;
-    shape->line[0].numpoints = 1;
-    shape->line[0].point = (pointObj *) msSmallMalloc(sizeof(pointObj));
-
-    memcpy( &(shape->line[0].point[0].x), pabyRec + 12, 8 );
-    memcpy( &(shape->line[0].point[0].y), pabyRec + 20, 8 );
-
-    if( bBigEndian ) {
-      SwapWord( 8, &(shape->line[0].point[0].x));
-      SwapWord( 8, &(shape->line[0].point[0].y));
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      PointZ                                                          */
-    /* -------------------------------------------------------------------- */
-    shape->line[0].point[0].z = 0; /* initialize */
-    if (psSHP->nShapeType == SHP_POINTZ) {
-      const int nOffset = 20 + 8;
-      if( nEntitySize >= nOffset + 8 ) {
-        memcpy(&(shape->line[0].point[0].z), pabyRec + nOffset, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[0].z));
-      }
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Measured support : point.                                       */
-    /* -------------------------------------------------------------------- */
-    shape->line[0].point[0].m = 0; /* initialize */
-    if (psSHP->nShapeType == SHP_POINTM) {
-      const int nOffset = 20 + 8;
-      if( nEntitySize >= nOffset + 8 ) {
-        memcpy(&(shape->line[0].point[0].m), pabyRec + nOffset, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[0].m));
-      }
-    }
-
-    /* set the bounding box to the point */
-    shape->bounds.minx = shape->bounds.maxx = shape->line[0].point[0].x;
-    shape->bounds.miny = shape->bounds.maxy = shape->line[0].point[0].y;
-
-    shape->type = MS_SHAPE_POINT;
-  }
-
-  shape->index = hEntity;
-
-  return;
-}
-
-int msSHPReadBounds( SHPHandle psSHP, int hEntity, rectObj *padBounds)
-{
-  /* -------------------------------------------------------------------- */
-  /*      Validate the record/entity number.                              */
-  /* -------------------------------------------------------------------- */
-  if( psSHP->nRecords <= 0 || hEntity < -1 || hEntity >= psSHP->nRecords ) {
-    padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy = 0.0;
-    return MS_FAILURE;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  If the entity is -1 we fetch the bounds for the whole file.   */
-  /* -------------------------------------------------------------------- */
-  if( hEntity == -1 ) {
-    padBounds->minx = psSHP->adBoundsMin[0];
-    padBounds->miny = psSHP->adBoundsMin[1];
-    padBounds->maxx = psSHP->adBoundsMax[0];
-    padBounds->maxy = psSHP->adBoundsMax[1];
-  } else {
-
-    if( msSHXReadSize(psSHP, hEntity) <= 4 ) { /* NULL shape */
-      padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy = 0.0;
-      return MS_FAILURE;
-    }
-
-    const int offset = msSHXReadOffset( psSHP, hEntity);
-    if( offset <= 0 || offset >= INT_MAX - 12 || 0 != VSIFSeekL( psSHP->fpSHP, offset + 12, 0 )) {
-      msSetError(MS_IOERR, "failed to seek offset", "msSHPReadBounds()");
-      return(MS_FAILURE);
-    }
-
-    if( psSHP->nShapeType != SHP_POINT && psSHP->nShapeType != SHP_POINTZ && psSHP->nShapeType != SHP_POINTM) {
-      if( 1 != VSIFReadL( padBounds, sizeof(double)*4, 1, psSHP->fpSHP )) {
-        msSetError(MS_IOERR, "failed to fread record", "msSHPReadBounds()");
-        return(MS_FAILURE);
-      }
-
-      if( bBigEndian ) {
-        SwapWord( 8, &(padBounds->minx) );
-        SwapWord( 8, &(padBounds->miny) );
-        SwapWord( 8, &(padBounds->maxx) );
-        SwapWord( 8, &(padBounds->maxy) );
-      }
-
-      if(msIsNan(padBounds->minx)) { /* empty shape */
-        padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy = 0.0;
-        return MS_FAILURE;
-      }
-    } else {
-      /* -------------------------------------------------------------------- */
-      /*      For points we fetch the point, and duplicate it as the          */
-      /*      minimum and maximum bound.                                      */
-      /* -------------------------------------------------------------------- */
-      if( 1 != VSIFReadL( padBounds, sizeof(double)*2, 1, psSHP->fpSHP )) {
-        msSetError(MS_IOERR, "failed to fread record", "msSHPReadBounds()");
-        return(MS_FAILURE);
-      }
-
-      if( bBigEndian ) {
-        SwapWord( 8, &(padBounds->minx) );
-        SwapWord( 8, &(padBounds->miny) );
-      }
-
-      padBounds->maxx = padBounds->minx;
-      padBounds->maxy = padBounds->miny;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-int msShapefileOpenHandle(shapefileObj *shpfile, const char *filename, SHPHandle hSHP, DBFHandle hDBF)
-{
-  assert(filename != NULL);
-  assert(hSHP != NULL);
-  assert(hDBF != NULL);
-
-  /* initialize a few things */
-  shpfile->status = NULL;
-  shpfile->lastshape = -1;
-  shpfile->isopen = MS_FALSE;
-
-  shpfile->hSHP = hSHP;
-
-  strlcpy(shpfile->source, filename, sizeof(shpfile->source));
-
-  /* load some information about this shapefile */
-  msSHPGetInfo( shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
-
-  if( shpfile->numshapes < 0 || shpfile->numshapes > 256000000 ) {
-    msSetError(MS_SHPERR, "Corrupted .shp file : numshapes = %d.",
-               "msShapefileOpen()", shpfile->numshapes);
-    msDBFClose(hDBF);
-    msSHPClose(hSHP);
-    return -1;
-  }
-
-  msSHPReadBounds( shpfile->hSHP, -1, &(shpfile->bounds));
-
-  shpfile->hDBF = hDBF;
-
-  shpfile->isopen = MS_TRUE;
-  return(0); /* all o.k. */
-}
-
-int msShapefileOpenVirtualFile(shapefileObj *shpfile, const char *filename, VSILFILE * fpSHP, VSILFILE * fpSHX, VSILFILE * fpDBF, int log_failures)
-{
-  assert(filename != NULL);
-  assert(fpSHP != NULL);
-  assert(fpSHX != NULL);
-  assert(fpDBF != NULL);
-
-  /* open the shapefile file (appending ok) and get basic info */
-  SHPHandle hSHP = msSHPOpenVirtualFile(fpSHP, fpSHX);
-  if(!hSHP) {
-    if( log_failures )
-      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
-    VSIFCloseL( fpDBF );
-    return(-1);
-  }
-
-  DBFHandle hDBF = msDBFOpenVirtualFile(fpDBF);
-
-  if(!hDBF) {
-    if( log_failures )
-      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
-    msSHPClose(hSHP);
-    return(-1);
-  }
-
-  return msShapefileOpenHandle(shpfile, filename, hSHP, hDBF);
-}
-
-int msShapefileOpen(shapefileObj *shpfile, const char *mode, const char *filename, int log_failures)
-{
-  int i;
-  char *dbfFilename;
-  size_t bufferSize = 0;
-
-  if(!filename) {
-    if( log_failures )
-      msSetError(MS_IOERR, "No (NULL) filename provided.", "msShapefileOpen()");
-    return(-1);
-  }
-
-  /* open the shapefile file (appending ok) and get basic info */
-  SHPHandle hSHP;
-  if(!mode)
-    hSHP = msSHPOpen( filename, "rb");
-  else
-    hSHP = msSHPOpen( filename, mode);
-
-  if(!hSHP) {
-    if( log_failures )
-      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
-    return(-1);
-  }
-
-  bufferSize = strlen(filename)+5;
-  dbfFilename = (char *)msSmallMalloc(bufferSize);
-  strcpy(dbfFilename, filename);
-
-  /* clean off any extention the filename might have */
-  for (i = strlen(dbfFilename) - 1;
-       i > 0 && dbfFilename[i] != '.' && dbfFilename[i] != '/' && dbfFilename[i] != '\\';
-       i-- ) {}
-
-  if( dbfFilename[i] == '.' )
-    dbfFilename[i] = '\0';
-
-  strlcat(dbfFilename, ".dbf", bufferSize);
-
-  DBFHandle hDBF = msDBFOpen(dbfFilename, "rb");
-
-  if(!hDBF) {
-    if( log_failures )
-      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", dbfFilename);
-    free(dbfFilename);
-    msSHPClose(hSHP);
-    return(-1);
-  }
-  free(dbfFilename);
-
-  return msShapefileOpenHandle(shpfile, filename, hSHP, hDBF);
-}
-
-/* Creates a new shapefile */
-int msShapefileCreate(shapefileObj *shpfile, char *filename, int type)
-{
-  if(type != SHP_POINT && type != SHP_MULTIPOINT && type != SHP_ARC &&
-      type != SHP_POLYGON &&
-      type != SHP_POINTM && type != SHP_MULTIPOINTM &&
-      type != SHP_ARCM && type != SHP_POLYGONM &&
-      type != SHP_POINTZ && type != SHP_MULTIPOINTZ &&
-      type != SHP_ARCZ && type != SHP_POLYGONZ) {
-    msSetError(MS_SHPERR, "Invalid shape type.", "msNewSHPFile()");
-    return(-1);
-  }
-
-  /* create the spatial portion */
-  shpfile->hSHP = msSHPCreate(filename, type);
-  if(!shpfile->hSHP) {
-    msSetError(MS_IOERR, "(%s)", "msNewSHPFile()",filename);
-    return(-1);
-  }
-
-  /* retrieve a few things about this shapefile */
-  msSHPGetInfo( shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
-  msSHPReadBounds( shpfile->hSHP, -1, &(shpfile->bounds));
-
-  /* initialize a few other things */
-  shpfile->status = NULL;
-  shpfile->lastshape = -1;
-  shpfile->isopen = MS_TRUE;
-
-  shpfile->hDBF = NULL; /* XBase file is NOT created here... */
-  return(0);
-}
-
-void msShapefileClose(shapefileObj *shpfile)
-{
-  if (shpfile && shpfile->isopen == MS_TRUE) { /* Silently return if called with NULL shpfile by freeLayer() */
-    if(shpfile->hSHP) msSHPClose(shpfile->hSHP);
-    if(shpfile->hDBF) msDBFClose(shpfile->hDBF);
-    free(shpfile->status);
-    shpfile->isopen = MS_FALSE;
-  }
-}
-
-/* status array lives in the shpfile, can return MS_SUCCESS/MS_FAILURE/MS_DONE */
-int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect, int debug)
-{
-  int i;
-  rectObj shaperect;
-  char *filename;
-
-  free(shpfile->status);
-  shpfile->status = NULL;
-
-  /* rect and shapefile DON'T overlap... */
-  if(msRectOverlap(&shpfile->bounds, &rect) != MS_TRUE)
-    return(MS_DONE);
-
-  if(msRectContained(&shpfile->bounds, &rect) == MS_TRUE) {
-    shpfile->status = msAllocBitArray(shpfile->numshapes);
-    if(!shpfile->status) {
-      msSetError(MS_MEMERR, NULL, "msShapefileWhichShapes()");
-      return(MS_FAILURE);
-    }
-    msSetAllBits(shpfile->status, shpfile->numshapes, 1);
-  } else {
-
-    /* deal with case where sourcename is of the form 'file.shp' */
-    char* sourcename = msStrdup(shpfile->source); /* shape file source string from map file */
-    char* s = strstr(sourcename, ".shp");
-    if( s )
-      *s = '\0';
-    else {
-      s = strstr(sourcename, ".SHP");
-      if( s )
-        *s = '\0';
-    }
-
-    filename = (char *)malloc(strlen(sourcename)+strlen(MS_INDEX_EXTENSION)+1);
-    MS_CHECK_ALLOC(filename, strlen(sourcename)+strlen(MS_INDEX_EXTENSION)+1, MS_FAILURE);
-
-    sprintf(filename, "%s%s", sourcename, MS_INDEX_EXTENSION);
-
-    shpfile->status = msSearchDiskTree(filename, rect, debug, shpfile->numshapes);
-    free(filename);
-    free(sourcename);
-
-    if(shpfile->status) { /* index  */
-      msFilterTreeSearch(shpfile, shpfile->status, rect);
-    } else { /* no index  */
-      shpfile->status = msAllocBitArray(shpfile->numshapes);
-      if(!shpfile->status) {
-        msSetError(MS_MEMERR, NULL, "msShapefileWhichShapes()");
-        return(MS_FAILURE);
-      }
-
-      for(i=0; i<shpfile->numshapes; i++) {
-        if(msSHPReadBounds(shpfile->hSHP, i, &shaperect) != MS_SUCCESS) {
-          if (msSHXReadSize(shpfile->hSHP, i) == 4) { /* handle NULL shape */
-              continue;
-          }
-          return(MS_FAILURE);
-        }
-
-        if(msRectOverlap(&shaperect, &rect) == MS_TRUE) msSetBit(shpfile->status, i, 1);
-      }
-    }
-  }
-
-  shpfile->lastshape = -1;
-
-  return(MS_SUCCESS); /* success */
-}
-
-/* Return the absolute path to the given layer's tileindex file's directory */
-void msTileIndexAbsoluteDir(char *tiFileAbsDir, layerObj *layer)
-{
-  char tiFileAbsPath[MS_MAXPATHLEN];
-  char *tiFileAbsDirTmp=NULL;
-
-  msBuildPath(tiFileAbsPath, layer->map->mappath, layer->tileindex); /* absolute path to tileindex file */
-  tiFileAbsDirTmp = msGetPath(tiFileAbsPath); /* tileindex file's directory */
-  strlcpy(tiFileAbsDir, tiFileAbsDirTmp, MS_MAXPATHLEN);
-  free(tiFileAbsDirTmp);
-}
-
-/*
-** Build possible paths we might find the tile file at:
-**   map dir + shape path + filename?
-**   tile dir + shape path + filename?
-**   map dir + filename?
-**
-** Returns
-** MS_SUCCESS - found a file
-** MS_FAILURE - no file, and map is configured to fail on missing
-** MS_DONE - no file, and map is configured to continue on missing
-*/
-static
-int msTiledSHPTryOpen(shapefileObj *shpfile, layerObj *layer, char *tiFileAbsDir, const char *filename)
-{
-  char szPath[MS_MAXPATHLEN];
-  int ignore_missing = msMapIgnoreMissingData(layer->map);
-  int log_failures = MS_TRUE;
-
-  if( ignore_missing == MS_MISSING_DATA_IGNORE )
-    log_failures = MS_FALSE;
-
-  if(msShapefileOpen(shpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, filename), log_failures) == -1) {
-    if(msShapefileOpen(shpfile, "rb", msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename), log_failures) == -1) {
-      if(msShapefileOpen(shpfile, "rb", msBuildPath(szPath, layer->map->mappath, filename), log_failures) == -1) {
-        if(ignore_missing == MS_MISSING_DATA_FAIL) {
-          msSetError(MS_IOERR, "Unable to open shapefile '%s' for layer '%s' ... fatal error.", "msTiledSHPTryOpen()", filename, layer->name);
-          return(MS_FAILURE);
-        } else if( ignore_missing == MS_MISSING_DATA_LOG ) {
-          if( layer->debug || layer->map->debug ) {
-            msDebug( "Unable to open shapefile '%s' for layer '%s' ... ignoring this missing data.\n", szPath, layer->name );
-          }
-          return(MS_DONE);
-        } else if( ignore_missing == MS_MISSING_DATA_IGNORE ) {
-          return(MS_DONE);
-        } else {
-          /* never get here */
-          msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.", "msTiledSHPTryOpen()");
-          return(MS_FAILURE);
-        }
-      }
-    }
-  }
-  return(MS_SUCCESS);
-}
-
-static const char* msTiledSHPLoadEntry(layerObj *layer, int i, char* tilename, size_t tilenamesize)
-{
-    const char* filename;
-    msTiledSHPLayerInfo *tSHP= layer->layerinfo;
-
-    msProjectDestroyReprojector(tSHP->reprojectorFromTileProjToLayerProj);
-    tSHP->reprojectorFromTileProjToLayerProj = NULL;
-
-    msFreeProjection(&(tSHP->sTileProj));
-    if( layer->tilesrs != NULL )
-    {
-        int idx = msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs);
-        const char* pszWKT = msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, idx);
-        IGNORE_RET_VAL(msOGCWKT2ProjectionObj(pszWKT, &(tSHP->sTileProj), layer->debug ));
-    }
-
-    if(!layer->data) /* assume whole filename is in attribute field */
-      filename =msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, layer->tileitemindex);
-    else {
-      snprintf(tilename, tilenamesize, "%s/%s",
-               msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, layer->tileitemindex) ,
-               layer->data);
-      filename = tilename;
-    }
-
-    return filename;
-}
-
-static
-int msTiledSHPOpenFile(layerObj *layer)
-{
-  int i;
-  const char *filename;
-  char tilename[MS_MAXPATHLEN], szPath[MS_MAXPATHLEN];
-  char tiFileAbsDir[MS_MAXPATHLEN];
-
-  msTiledSHPLayerInfo *tSHP=NULL;
-
-  if (layer->layerinfo != NULL) {
-    return MS_SUCCESS;  // Nothing to do... layer is already opened
-  }
-
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  /* allocate space for a shapefileObj using layer->layerinfo  */
-  tSHP = (msTiledSHPLayerInfo *) calloc(1, sizeof(msTiledSHPLayerInfo));
-  MS_CHECK_ALLOC(tSHP, sizeof(msTiledSHPLayerInfo), MS_FAILURE);
-  msInitProjection(&(tSHP->sTileProj));
-  msProjectionInheritContextFrom(&(tSHP->sTileProj), &layer->projection);
-
-  tSHP->shpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
-  if (tSHP->shpfile == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msTiledSHPOpenFile()",
-               __FILE__, __LINE__, (unsigned int)sizeof(shapefileObj));
-    msFreeProjection(&(tSHP->sTileProj));
-    free(tSHP);
-    return MS_FAILURE;
-  }
-  
-  tSHP->shpfile->isopen = MS_FALSE; /* in case of error: do not try to close the shpfile */
-  tSHP->tileshpfile = NULL; /* may need this if not using a tile layer, look for malloc later */
-  layer->layerinfo = tSHP;
-
-  tSHP->tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
-  if(tSHP->tilelayerindex != -1) { /* does the tileindex reference another layer */
-    int status;
-    layerObj *tlp;
-
-    tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
-
-    if(tlp->connectiontype != MS_SHAPEFILE) {
-      msSetError(MS_SHPERR, "Tileindex layer must be a shapefile.", "msTiledSHPOpenFile()");
-      return(MS_FAILURE);
-    }
-
-    status = msLayerOpen(tlp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-
-    /* build item list */
-    status = msLayerWhichItems(tlp, MS_FALSE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
-
-    tSHP->tileshpfile = (shapefileObj *) tlp->layerinfo; /* shapefiles use layerinfo to point to a shapefileObj */
-
-  } else { /* or reference a shapefile directly */
-
-    /* we need tSHP->tileshpfile if we're not working with a layer */
-    tSHP->tileshpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
-    if (tSHP->tileshpfile == NULL) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msTiledSHPOpenFile()",
-                 __FILE__, __LINE__, (unsigned int)sizeof(shapefileObj));
-      free(tSHP->shpfile);
-      msFreeProjection(&(tSHP->sTileProj));
-      free(tSHP);
-      layer->layerinfo = NULL;
-      return MS_FAILURE;
-    }
-
-
-    if(msShapefileOpen(tSHP->tileshpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->tileindex), MS_TRUE) == -1)
-      if(msShapefileOpen(tSHP->tileshpfile, "rb", msBuildPath(szPath, layer->map->mappath, layer->tileindex), MS_TRUE) == -1)
-        return(MS_FAILURE);
-  }
-
-  if((layer->tileitemindex = msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tileitem)) == -1) return(MS_FAILURE);
-
-  if( layer->tilesrs != NULL &&
-      msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs) < 0 )
-  {
-    msSetError(MS_SHPERR,
-                "Cannot identify TILESRS field.",
-                "msTiledSHPOpenFile()");
-    return MS_FAILURE;
-  }
-  if( layer->tilesrs != NULL && layer->projection.numargs == 0 )
-  {
-    msSetError(MS_SHPERR,
-                "A layer with TILESRS set in TILEINDEX `%s' must have a "
-                "projection set on itself.",
-                "msOGRLayerOpen()",
-                layer->tileindex );
-    return MS_FAILURE;
-  }
-
-  msTileIndexAbsoluteDir(tiFileAbsDir, layer);
-
-  /* position the source at the FIRST tile to use as a template, this is so the functions that fill the iteminfo array have something to work from */
-  for(i=0; i<tSHP->tileshpfile->numshapes; i++) {
-    int try_open;
-
-    filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
-    if(strlen(filename) == 0) continue; /* check again */
-
-    try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-    if( try_open == MS_DONE )
-      continue;
-    else if (try_open == MS_FAILURE )
-      return(MS_FAILURE);
-
-    return(MS_SUCCESS); /* found a template, ok to proceed */
-  }
-
-  msSetError(MS_SHPERR, "Unable to open a single tile to use as a template in layer %s.", "msTiledSHPOpenFile()", layer->name?layer->name:"(null)");
-  return(MS_FAILURE);
-}
-
-static
-int msTiledSHPWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  int i, status;
-  const char *filename;
-  char tilename[MS_MAXPATHLEN];
-  char tiFileAbsDir[MS_MAXPATHLEN];
-
-  msTiledSHPLayerInfo *tSHP=NULL;
-
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPWhichShapes()");
-    return(MS_FAILURE);
-  }
-
-  msShapefileClose(tSHP->shpfile); /* close previously opened files */
-
-  tSHP->searchrect = rect; /* save the search extent */
-
-  if(tSHP->tilelayerindex != -1) {  /* does the tileindex reference another layer */
-    layerObj *tlp;
-    shapeObj tshape;
-
-    tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
-    status= msLayerWhichShapes(tlp, rect, isQuery);
-    if(status != MS_SUCCESS) return(status); /* could be MS_DONE or MS_FAILURE */
-
-    msTileIndexAbsoluteDir(tiFileAbsDir, layer);
-
-    msInitShape(&tshape);
-    while((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
-      int try_open;
-      rectObj rectTile = rect;
-
-      filename = msTiledSHPLoadEntry(layer, tshape.index, tilename, sizeof(tilename));
-      if(strlen(filename) == 0) continue; /* check again */
-
-      try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-      if( try_open == MS_DONE )
-        continue;
-      else if (try_open == MS_FAILURE )
-        return(MS_FAILURE);
-
-      if( tSHP->sTileProj.numargs > 0 )
-      {
-        msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
-      }
-
-      status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-      if(status == MS_DONE) {
-        /* Close and continue to next tile */
-        msShapefileClose(tSHP->shpfile);
-        continue;
-      } else if(status != MS_SUCCESS) {
-        msShapefileClose(tSHP->shpfile);
-        return(MS_FAILURE);
-      }
-
-      /* the layer functions keeps track of this */
-      /* tSHP->tileshpfile->lastshape = tshape.index; */
-      break;
-    }
-    return(status); /* if we reach here we either 1) ran out of tiles or 2) had an error reading a tile */
-
-  } else { /* or reference a shapefile directly */
-    int try_open;
-
-    status = msShapefileWhichShapes(tSHP->tileshpfile, rect, layer->debug);
-    if(status != MS_SUCCESS) return(status); /* could be MS_DONE or MS_FAILURE */
-
-    msTileIndexAbsoluteDir(tiFileAbsDir, layer);
-
-    /* position the source at the FIRST shapefile */
-    for(i=0; i<tSHP->tileshpfile->numshapes; i++) {
-      rectObj rectTile = rect;
-      if(msGetBit(tSHP->tileshpfile->status,i)) {
-
-        filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
-        if(strlen(filename) == 0) continue; /* check again */
-
-        try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-        if( try_open == MS_DONE )
-          continue;
-        else if (try_open == MS_FAILURE )
-          return(MS_FAILURE);
-
-        if( tSHP->sTileProj.numargs > 0 )
-        {
-          msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
-        }
-
-        status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-        if(status == MS_DONE) {
-          /* Close and continue to next tile */
-          msShapefileClose(tSHP->shpfile);
-          continue;
-        } else if(status != MS_SUCCESS) {
-          msShapefileClose(tSHP->shpfile);
-          return(MS_FAILURE);
-        }
-
-        tSHP->tileshpfile->lastshape = i;
-        break;
-      }
-    }
-
-    if(i == tSHP->tileshpfile->numshapes)
-      return(MS_DONE); /* no more tiles */
-    else
-      return(MS_SUCCESS);
-  }
-
-  return(MS_FAILURE); /* should *never* get here */
-}
-
-static
-int msTiledSHPNextShape(layerObj *layer, shapeObj *shape)
-{
-  int i, status, filter_passed = MS_FALSE;
-  const char *filename;
-  char tilename[MS_MAXPATHLEN];
-  char tiFileAbsDir[MS_MAXPATHLEN];
-
-  msTiledSHPLayerInfo *tSHP=NULL;
-
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPNextShape()");
-    return(MS_FAILURE);
-  }
-
-  msTileIndexAbsoluteDir(tiFileAbsDir, layer);
-
-  do {
-    i = tSHP->shpfile->lastshape + 1;
-    while(i<tSHP->shpfile->numshapes && !msGetBit(tSHP->shpfile->status,i)) i++; /* next "in" shape */
-
-    if(i == tSHP->shpfile->numshapes) { /* done with this tile, need a new one */
-      msShapefileClose(tSHP->shpfile); /* clean up */
-
-      /* position the source to the NEXT shapefile based on the tileindex */
-      if(tSHP->tilelayerindex != -1) { /* does the tileindex reference another layer */
-        layerObj *tlp;
-        shapeObj tshape;
-        int try_open;
-
-        tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
-
-        msInitShape(&tshape);
-        while((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
-          rectObj rectTile = tSHP->searchrect;
-
-          filename = msTiledSHPLoadEntry(layer, tshape.index, tilename, sizeof(tilename));
-          if(strlen(filename) == 0) continue; /* check again */
-
-          try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-          if( try_open == MS_DONE )
-            continue;
-          else if (try_open == MS_FAILURE )
-            return(MS_FAILURE);
-
-          if( tSHP->sTileProj.numargs > 0 )
-          {
-            msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
-          }
-
-          status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-          if(status == MS_DONE) {
-            /* Close and continue to next tile */
-            msShapefileClose(tSHP->shpfile);
-            continue;
-          } else if(status != MS_SUCCESS) {
-            msShapefileClose(tSHP->shpfile);
-            tSHP->tileshpfile->lastshape = -1;
-            return(MS_FAILURE);
-          }
-
-          /* the layer functions keeps track of this */
-          /* tSHP->tileshpfile->lastshape = tshape.index; */
-          break;
-        }
-
-        if(status == MS_DONE) {
-            tSHP->tileshpfile->lastshape = -1;
-            return(MS_DONE); /* no more tiles */
-        }
-        else {
-          msFreeShape(&tshape);
-          continue; /* we've got shapes */
-        }
-
-      } else { /* or reference a shapefile directly   */
-
-        for(i=(tSHP->tileshpfile->lastshape + 1); i<tSHP->tileshpfile->numshapes; i++) {
-          if(msGetBit(tSHP->tileshpfile->status,i)) {
-            rectObj rectTile = tSHP->searchrect;
-            int try_open;
-
-            filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
-            if(strlen(filename) == 0) continue; /* check again */
-
-            try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-            if( try_open == MS_DONE )
-              continue;
-            else if (try_open == MS_FAILURE )
-              return(MS_FAILURE);
-
-            if( tSHP->sTileProj.numargs > 0 )
-            {
-              msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
-            }
-
-            status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-            if(status == MS_DONE) {
-              /* Close and continue to next tile */
-              msShapefileClose(tSHP->shpfile);
-              continue;
-            } else if(status != MS_SUCCESS) {
-              msShapefileClose(tSHP->shpfile);
-              tSHP->tileshpfile->lastshape = -1;
-              return(MS_FAILURE);
-            }
-
-            tSHP->tileshpfile->lastshape = i;
-            break;
-          }
-        } /* end for loop */
-
-        if(i == tSHP->tileshpfile->numshapes) {
-            tSHP->tileshpfile->lastshape = -1;
-            return(MS_DONE); /* no more tiles */
-        }
-        else continue; /* we've got shapes */
-      }
-    }
-
-    tSHP->shpfile->lastshape = i;
-
-    msSHPReadShape(tSHP->shpfile->hSHP, i, shape);
-    if(shape->type == MS_SHAPE_NULL) {
-      msFreeShape(shape);
-      continue; /* skip NULL shapes */
-    }
-
-    if( tSHP->sTileProj.numargs > 0 )
-    {
-      if( tSHP->reprojectorFromTileProjToLayerProj == NULL )
-      {
-          tSHP->reprojectorFromTileProjToLayerProj = msProjectCreateReprojector(&(tSHP->sTileProj), &(layer->projection));
-      }
-      if( tSHP->reprojectorFromTileProjToLayerProj )
-      {
-        msProjectShapeEx( tSHP->reprojectorFromTileProjToLayerProj, shape);
-      }
-    }
-
-    shape->tileindex = tSHP->tileshpfile->lastshape;
-    shape->numvalues = layer->numitems;
-    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, i, layer->iteminfo, layer->numitems);
-    if(!shape->values) shape->numvalues = 0;
-
-    filter_passed = MS_TRUE;  /* By default accept ANY shape */
-    if(layer->numitems > 0 && layer->iteminfo) {
-      filter_passed = msEvalExpression(layer, shape, &(layer->filter), layer->filteritemindex);
-    }
-
-    if(!filter_passed) msFreeShape(shape); /* free's values as well */
-
-  } while(!filter_passed);  /* Loop until both spatial and attribute filters match  */
-
-  return(MS_SUCCESS);
-}
-
-static
-int msTiledSHPGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  const char *filename;
-  char tilename[MS_MAXPATHLEN], szPath[MS_MAXPATHLEN];
-
-  msTiledSHPLayerInfo *tSHP=NULL;
-  char tiFileAbsDir[MS_MAXPATHLEN];
-
-  long shapeindex = record->shapeindex;
-  int tileindex = record->tileindex;
-
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPGetShape()");
-    return(MS_FAILURE);
-  }
-
-  msTileIndexAbsoluteDir(tiFileAbsDir, layer);
-
-  if((tileindex < 0) || (tileindex >= tSHP->tileshpfile->numshapes)) return(MS_FAILURE); /* invalid tile id */
-
-  if(tileindex != tSHP->tileshpfile->lastshape) { /* correct tile is not currenly open so open the correct tile */
-    msShapefileClose(tSHP->shpfile); /* close current tile */
-
-    filename = msTiledSHPLoadEntry(layer, tileindex, tilename, sizeof(tilename));
-
-    /* open the shapefile, since a specific tile was request an error should be generated if that tile does not exist */
-    if(strlen(filename) == 0) return(MS_FAILURE);
-    if(msShapefileOpen(tSHP->shpfile, "rb", msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename), MS_TRUE) == -1) {
-      if(msShapefileOpen(tSHP->shpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, filename), MS_TRUE) == -1) {
-        if(msShapefileOpen(tSHP->shpfile, "rb", msBuildPath(szPath, layer->map->mappath, filename), MS_TRUE) == -1) {
-          return(MS_FAILURE);
-        }
-      }
-    }
-
-  }
-
-  if((shapeindex < 0) || (shapeindex >= tSHP->shpfile->numshapes)) return(MS_FAILURE);
-
-  msSHPReadShape(tSHP->shpfile->hSHP, shapeindex, shape);
-  tSHP->shpfile->lastshape = shapeindex;
-  tSHP->tileshpfile->lastshape = tileindex;
-
-  if( tSHP->sTileProj.numargs > 0 )
-  {
-      if( tSHP->reprojectorFromTileProjToLayerProj == NULL )
-      {
-          tSHP->reprojectorFromTileProjToLayerProj = msProjectCreateReprojector(&(tSHP->sTileProj), &(layer->projection));
-      }
-      if( tSHP->reprojectorFromTileProjToLayerProj )
-      {
-        msProjectShapeEx( tSHP->reprojectorFromTileProjToLayerProj, shape);
-      }
-  }
-
-  if(layer->numitems > 0 && layer->iteminfo) {
-    shape->numvalues = layer->numitems;
-    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, shapeindex, layer->iteminfo, layer->numitems);
-    if(!shape->values) return(MS_FAILURE);
-  }
-
-  shape->tileindex = tileindex;
-
-  return(MS_SUCCESS);
-}
-
-static
-void msTiledSHPClose(layerObj *layer)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
-
-  tSHP = layer->layerinfo;
-  if(tSHP) {
-    msShapefileClose(tSHP->shpfile);
-    free(tSHP->shpfile);
-
-    if(tSHP->tilelayerindex != -1) {
-      layerObj *tlp;
-      if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-        return;
-      tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
-      msLayerClose(tlp);
-    } else {
-      msShapefileClose(tSHP->tileshpfile);
-      free(tSHP->tileshpfile);
-    }
-
-    msProjectDestroyReprojector(tSHP->reprojectorFromTileProjToLayerProj);
-
-    msFreeProjection(&(tSHP->sTileProj));
-
-    free(tSHP);
-  }
-  layer->layerinfo = NULL;
-}
-/************************************************************************/
-/*                              msTiledSHPClose()                       */
-/* Overloaded version of msTiledSHPClose for virtual table architecture */
-/************************************************************************/
-int msTiledSHPCloseVT(layerObj *layer)
-{
-  msTiledSHPClose(layer);
-  return MS_SUCCESS;
-}
-
-void msTiledSHPLayerFreeItemInfo(layerObj *layer)
-{
-  if(layer->iteminfo) {
-    free(layer->iteminfo);
-    layer->iteminfo = NULL;
-  }
-}
-
-int msTiledSHPLayerInitItemInfo(layerObj *layer)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
-
-  tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPLayerInitItemInfo()");
-    return MS_FAILURE;
-  }
-
-  msTiledSHPLayerFreeItemInfo(layer);
-  layer->iteminfo = (int *) msDBFGetItemIndexes(tSHP->shpfile->hDBF, layer->items, layer->numitems);
-  if(!layer->iteminfo) return(MS_FAILURE);
-
-  return MS_SUCCESS;
-}
-
-static void msSHPPassThroughFieldDefinitions( layerObj *layer, DBFHandle hDBF )
-{
-  int numitems, i;
-
-  numitems = msDBFGetFieldCount( hDBF );
-
-  for(i=0; i<numitems; i++) {
-    char item[16];
-    int  nWidth=0, nPrecision=0;
-    char gml_width[32], gml_precision[32];
-    DBFFieldType eType;
-    const char *gml_type = NULL;
-
-    eType = msDBFGetFieldInfo( hDBF, i, item, &nWidth, &nPrecision );
-
-    gml_width[0] = '\0';
-    gml_precision[0] = '\0';
-
-    switch( eType ) {
-      case FTInteger:
-        gml_type = "Integer";
-        sprintf( gml_width, "%d", nWidth );
-        break;
-
-      case FTDouble:
-        gml_type = "Real";
-        sprintf( gml_width, "%d", nWidth );
-        sprintf( gml_precision, "%d", nPrecision );
-        break;
-
-      case FTString:
-      default:
-        gml_type = "Character";
-        sprintf( gml_width, "%d", nWidth );
-        break;
-    }
-
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
-
-  }
-}
-
-int msTiledSHPLayerGetItems(layerObj *layer)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
-  const char *value;
-
-  tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPLayerGetItems()");
-    return MS_FAILURE;
-  }
-
-  layer->numitems = msDBFGetFieldCount(tSHP->shpfile->hDBF);
-  layer->items = msDBFGetItems(tSHP->shpfile->hDBF);
-  if(!layer->items) return MS_FAILURE;
-
-  /* -------------------------------------------------------------------- */
-  /*      consider populating the field definitions in metadata.          */
-  /* -------------------------------------------------------------------- */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    msSHPPassThroughFieldDefinitions( layer, tSHP->shpfile->hDBF );
-
-  return msTiledSHPLayerInitItemInfo(layer);
-}
-
-int msTiledSHPLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
-
-  tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPLayerGetExtent()");
-    return MS_FAILURE;
-  }
-
-  *extent = tSHP->tileshpfile->bounds;
-  return MS_SUCCESS;
-}
-
-int msTiledSHPLayerIsOpen(layerObj *layer)
-{
-  if(layer->layerinfo)
-    return MS_TRUE;
-  else
-    return MS_FALSE;
-}
-
-int msTiledSHPLayerSupportsCommonFilters(layerObj *layer)
-{
-  (void)layer;
-  return MS_TRUE;
-}
-
-int msTiledSHPLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerSupportsCommonFilters = msTiledSHPLayerSupportsCommonFilters;
-  layer->vtable->LayerInitItemInfo = msTiledSHPLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msTiledSHPLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msTiledSHPOpenFile;
-  layer->vtable->LayerIsOpen = msTiledSHPLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msTiledSHPWhichShapes;
-  layer->vtable->LayerNextShape = msTiledSHPNextShape;
-  /* no special version, use ...GetShape() */
-  /* layer->vtable->LayerResultsGetShape = msTiledSHPGetShape; */
-  layer->vtable->LayerGetShape = msTiledSHPGetShape;
-  layer->vtable->LayerClose = msTiledSHPCloseVT;
-  layer->vtable->LayerGetItems = msTiledSHPLayerGetItems;
-  layer->vtable->LayerGetExtent = msTiledSHPLayerGetExtent;
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerCloseConnection, use default */;
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-  /* layer->vtable->LayerGetAutoProjection, use defaut*/
-
-  return MS_SUCCESS;
-}
-
-/* SHAPEFILE Layer virtual table functions */
-
-void msSHPLayerFreeItemInfo(layerObj *layer)
-{
-  if(layer->iteminfo) {
-    free(layer->iteminfo);
-    layer->iteminfo = NULL;
-  }
-}
-
-int msSHPLayerInitItemInfo(layerObj *layer)
-{
-  shapefileObj *shpfile = layer->layerinfo;
-  if( ! shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerInitItemInfo()");
-    return MS_FAILURE;
-  }
-
-  /* iteminfo needs to be a bit more complex, a list of indexes plus the length of the list */
-  msSHPLayerFreeItemInfo(layer);
-  layer->iteminfo = (int *) msDBFGetItemIndexes(shpfile->hDBF, layer->items, layer->numitems);
-  if( ! layer->iteminfo) {
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-int msSHPLayerOpen(layerObj *layer)
-{
-  char szPath[MS_MAXPATHLEN];
-  shapefileObj *shpfile;
-
-  if(layer->layerinfo) return MS_SUCCESS; /* layer already open */
-
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  /* allocate space for a shapefileObj using layer->layerinfo  */
-  shpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
-  MS_CHECK_ALLOC(shpfile, sizeof(shapefileObj), MS_FAILURE);
-
-
-  layer->layerinfo = shpfile;
-
-  if(msShapefileOpen(shpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->data), MS_TRUE) == -1) {
-    if(msShapefileOpen(shpfile, "rb", msBuildPath(szPath, layer->map->mappath, layer->data), MS_TRUE) == -1) {
-      layer->layerinfo = NULL;
-      free(shpfile);
-      return MS_FAILURE;
-    }
-  }
-  
-  if (layer->projection.numargs > 0 &&
-      EQUAL(layer->projection.args[0], "auto"))
-  {
-    const char* pszPRJFilename = CPLResetExtension(szPath, "prj");
-    int bOK = MS_FALSE;
-    VSILFILE* fp = VSIFOpenL(pszPRJFilename, "rb");
-    if( fp != NULL )
-    {
-        char szPRJ[2048];
-        OGRSpatialReferenceH hSRS;
-        int nRead;
-
-        nRead = (int)VSIFReadL(szPRJ, 1, sizeof(szPRJ) - 1, fp);
-        szPRJ[nRead] = '\0';
-        hSRS = OSRNewSpatialReference(szPRJ);
-        if( hSRS != NULL )
-        {
-            if( OSRMorphFromESRI( hSRS ) == OGRERR_NONE )
-            {
-                char* pszWKT = NULL;
-                if( OSRExportToWkt( hSRS, &pszWKT ) == OGRERR_NONE )
-                {
-                    if( msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
-                                               layer->debug ) == MS_SUCCESS )
-                    {
-                        bOK = MS_TRUE;
-                    }
-                }
-                CPLFree(pszWKT);
-            }
-            OSRDestroySpatialReference(hSRS);
-        }
-      VSIFCloseL(fp);
-    }
-
-    if( bOK != MS_TRUE )
-    {
-        if( layer->debug || layer->map->debug ) {
-            msDebug( "Unable to get SRS from shapefile '%s' for layer '%s'.\n", szPath, layer->name );
-        }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-int msSHPLayerIsOpen(layerObj *layer)
-{
-  if(layer->layerinfo)
-    return MS_TRUE;
-  else
-    return MS_FALSE;
-}
-
-int msSHPLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  (void)isQuery;
-  int status;
-  shapefileObj *shpfile;
-
-  shpfile = layer->layerinfo;
-
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerWhichShapes()");
-    return MS_FAILURE;
-  }
-
-  status = msShapefileWhichShapes(shpfile, rect, layer->debug);
-  if(status != MS_SUCCESS) {
-    return status;
-  }
-
-  return MS_SUCCESS;
-}
-
-int msSHPLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  int i;
-  shapefileObj *shpfile;
-
-  shpfile = layer->layerinfo;
-
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerNextShape()");
-    return MS_FAILURE;
-  }
-
-  if (!shpfile->status) {
-    /* probably whichShapes didn't overlap */
-    return MS_DONE;
-  }
-
-  i = msGetNextBit(shpfile->status, shpfile->lastshape + 1, shpfile->numshapes);
-  shpfile->lastshape = i;
-  if(i == -1) return(MS_DONE); /* nothing else to read */
-
-  msSHPReadShape(shpfile->hSHP, i, shape);
-  if(shape->type == MS_SHAPE_NULL) {
-    msFreeShape(shape);
-    return msSHPLayerNextShape(layer, shape); /* skip NULL shapes */
-  }
-  shape->numvalues = layer->numitems;
-  shape->values = msDBFGetValueList(shpfile->hDBF, i, layer->iteminfo, layer->numitems);
-  if(!shape->values) shape->numvalues = 0;
-
-  return MS_SUCCESS;
-}
-
-int msSHPLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  shapefileObj *shpfile;
-  long shapeindex;
-
-  shpfile = layer->layerinfo;
-
-  shapeindex = record->shapeindex;
-
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  /* msSHPReadShape *should* return success or failure so we don't have to test here */
-  if(shapeindex < 0 || shapeindex >= shpfile->numshapes) {
-    msSetError(MS_MISCERR, "Invalid feature id.", "msSHPLayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  msSHPReadShape(shpfile->hSHP, shapeindex, shape);
-  if(layer->numitems > 0 && layer->iteminfo) {
-    shape->numvalues = layer->numitems;
-    shape->values = msDBFGetValueList(shpfile->hDBF, shapeindex, layer->iteminfo, layer->numitems);
-    if(!shape->values) return MS_FAILURE;
-  }
-
-  shpfile->lastshape = shapeindex;
-
-  return MS_SUCCESS;
-}
-
-int msSHPLayerClose(layerObj *layer)
-{
-  shapefileObj *shpfile;
-  shpfile = layer->layerinfo;
-  if(!shpfile) return MS_SUCCESS; /* nothing to do */
-
-  msShapefileClose(shpfile);
-  free(layer->layerinfo);
-  layer->layerinfo = NULL;
-
-  return MS_SUCCESS;
-}
-
-int msSHPLayerGetItems(layerObj *layer)
-{
-  shapefileObj *shpfile;
-  const char *value;
-
-  shpfile = layer->layerinfo;
-
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerGetItems()");
-    return MS_FAILURE;
-  }
-
-  layer->numitems = msDBFGetFieldCount(shpfile->hDBF);
-  layer->items = msDBFGetItems(shpfile->hDBF);
-  if(layer->numitems == 0) return MS_SUCCESS; /* No items is a valid case (#3147) */
-  if(!layer->items) return MS_FAILURE;
-
-  /* -------------------------------------------------------------------- */
-  /*      consider populating the field definitions in metadata.          */
-  /* -------------------------------------------------------------------- */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    msSHPPassThroughFieldDefinitions( layer, shpfile->hDBF );
-
-  return msLayerInitItemInfo(layer);
-}
-
-int msSHPLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  *extent = ((shapefileObj*)layer->layerinfo)->bounds;
-  return MS_SUCCESS;
-}
-
-int msSHPLayerSupportsCommonFilters(layerObj *layer)
-{
-  (void)layer;
-  return MS_TRUE;
-}
-
-int msSHPLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerSupportsCommonFilters = msSHPLayerSupportsCommonFilters;
-  layer->vtable->LayerInitItemInfo = msSHPLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msSHPLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msSHPLayerOpen;
-  layer->vtable->LayerIsOpen = msSHPLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msSHPLayerWhichShapes;
-  layer->vtable->LayerNextShape = msSHPLayerNextShape;
-  layer->vtable->LayerGetShape = msSHPLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msSHPLayerClose;
-  layer->vtable->LayerGetItems = msSHPLayerGetItems;
-  layer->vtable->LayerGetExtent = msSHPLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerCloseConnection, use default */
-  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  /* layer->vtable->LayerTranslateFilter, use default */
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapshape.h 8.2.0~beta1-1~exp1/mapshape.h
--- 8.0.1-5/mapshape.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapshape.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,250 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Shapefile access API
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPSHAPE_H
-#define MAPSHAPE_H
-
-#include <stdio.h>
-#include "mapprimitive.h"
-#include "mapproject.h"
-
-#include "cpl_vsi.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#define SHX_BUFFER_PAGE 1024
-
-#ifndef SWIG
-#define MS_PATH_LENGTH 1024
-
-  /* Shapefile types */
-#define SHP_POINT 1
-#define SHP_ARC 3
-#define SHP_POLYGON 5
-#define SHP_MULTIPOINT 8
-
-#define SHP_POINTZ 11
-#define SHP_ARCZ  13
-#define SHP_POLYGONZ 15
-#define SHP_MULTIPOINTZ 18
-
-#define SHP_POINTM 21
-#define SHP_ARCM  23
-#define SHP_POLYGONM 25
-#define SHP_MULTIPOINTM 28
-#endif
-
-#define MS_SHAPEFILE_POINT 1
-#define MS_SHAPEFILE_ARC 3
-#define MS_SHAPEFILE_POLYGON 5
-#define MS_SHAPEFILE_MULTIPOINT 8
-
-#define MS_SHP_POINTZ 11
-#define MS_SHP_ARCZ  13
-#define MS_SHP_POLYGONZ 15
-#define MS_SHP_MULTIPOINTZ 18
-
-#define MS_SHP_POINTM 21
-#define MS_SHP_ARCM  23
-#define MS_SHP_POLYGONM 25
-#define MS_SHP_MULTIPOINTM 28
-
-#ifndef SWIG
-  typedef unsigned char uchar;
-
-  typedef struct {
-    VSILFILE  *fpSHP;
-    VSILFILE  *fpSHX;
-
-    int   nShapeType;       /* SHPT_* */
-    int   nFileSize;        /* SHP file */
-
-    int   nRecords;
-    int   nMaxRecords;
-
-    int   *panRecOffset;
-    int   *panRecSize;
-    ms_bitarray panRecLoaded;
-    int   panRecAllLoaded;
-
-    double  adBoundsMin[4];
-    double  adBoundsMax[4];
-
-    int   bUpdated;
-
-    int   nBufSize; /* these used static vars in shape readers, moved to be thread-safe */
-    uchar   *pabyRec;
-    int   nPartMax;
-    int   *panParts;
-
-  } SHPInfo;
-  typedef SHPInfo * SHPHandle;
-#endif
-
-  /************************************************************************/
-  /*                          DBFInfo                                     */
-  /************************************************************************/
-
-/**
- * An object containing information about a DBF file
- *
- */
-  typedef struct {
-#ifdef SWIG
-    %immutable;
-#endif
-
-    int   nRecords; ///< Number of records in the DBF
-    int   nFields; ///< Number of fields in the DBF
-
-
-#ifndef SWIG
-    VSILFILE  *fp;
-    unsigned int nRecordLength;
-    int   nHeaderLength;
-
-    int   *panFieldOffset;
-    int   *panFieldSize;
-    int   *panFieldDecimals;
-    char  *pachFieldType;
-
-    char  *pszHeader;
-
-    int   nCurrentRecord;
-    int   bCurrentRecordModified;
-    char  *pszCurrentRecord;
-
-    int   bNoHeader;
-    int   bUpdated;
-
-    char  *pszStringField;
-    int   nStringFieldLen;
-#endif /* not SWIG */
-  } DBFInfo;
-
-  typedef DBFInfo * DBFHandle;
-
-  typedef enum {FTString, FTInteger, FTDouble, FTInvalid} DBFFieldType;
-
-  /************************************************************************/
-  /*                          shapefileObj                                */
-  /************************************************************************/
-
-/**
- * An object representing a Shapefile. There is no write access to this object
- * using MapScript.
- */
-  typedef struct {
-#ifdef SWIG
-    %immutable;
-#endif
-
-    int type; ///< Shapefile type - see mapshape.h for values of type
-    int numshapes; ///< Number of shapes
-    rectObj bounds; ///< Extent of shapes
-
-#ifndef SWIG
-    char source[MS_PATH_LENGTH]; /* full path to this file data */
-    int lastshape;
-    ms_bitarray status;
-    int isopen;
-    SHPHandle hSHP; /* SHP/SHX file pointer */
-    DBFHandle hDBF; /* DBF file pointer */
-#endif
-
-  } shapefileObj;
-
-#ifndef SWIG
-  /* layerInfo structure for tiled shapefiles */
-  typedef struct {
-    shapefileObj *shpfile;
-    shapefileObj *tileshpfile;
-    int tilelayerindex;
-    projectionObj sTileProj;
-    rectObj searchrect;
-    reprojectionObj* reprojectorFromTileProjToLayerProj;
-  } msTiledSHPLayerInfo;
-
-  /* shapefileObj function prototypes  */
-  MS_DLL_EXPORT int msShapefileOpenHandle(shapefileObj *shpfile, const char *filename, SHPHandle hSHP, DBFHandle hDBF);
-  MS_DLL_EXPORT int msShapefileOpenVirtualFile(shapefileObj *shpfile, const char *filename, VSILFILE * fpSHP, VSILFILE * fpSHX, VSILFILE * fpDBF, int log_failures);
-  MS_DLL_EXPORT int msShapefileOpen(shapefileObj *shpfile, const char *mode, const char *filename, int log_failures);
-  MS_DLL_EXPORT int msShapefileCreate(shapefileObj *shpfile, char *filename, int type);
-  MS_DLL_EXPORT void msShapefileClose(shapefileObj *shpfile);
-  MS_DLL_EXPORT int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect, int debug);
-
-  /* SHP/SHX function prototypes */
-  MS_DLL_EXPORT SHPHandle msSHPOpenVirtualFile( VSILFILE * fpSHP, VSILFILE * fpSHX );
-  MS_DLL_EXPORT SHPHandle msSHPOpen( const char * pszShapeFile, const char * pszAccess );
-  MS_DLL_EXPORT SHPHandle msSHPCreate( const char * pszShapeFile, int nShapeType );
-  MS_DLL_EXPORT void msSHPClose( SHPHandle hSHP );
-  MS_DLL_EXPORT void msSHPGetInfo( SHPHandle hSHP, int * pnEntities, int * pnShapeType );
-  MS_DLL_EXPORT int msSHPReadBounds( SHPHandle psSHP, int hEntity, rectObj *padBounds );
-  MS_DLL_EXPORT void msSHPReadShape( SHPHandle psSHP, int hEntity, shapeObj *shape );
-  MS_DLL_EXPORT int msSHPReadPoint(SHPHandle psSHP, int hEntity, pointObj *point );
-  MS_DLL_EXPORT int msSHPWriteShape( SHPHandle psSHP, shapeObj *shape );
-  MS_DLL_EXPORT int msSHPWritePoint(SHPHandle psSHP, pointObj *point );
-
-  /* tiledShapefileObj function prototypes are in mapserver.h */
-
-  /* XBase function prototypes */
-  MS_DLL_EXPORT DBFHandle msDBFOpenVirtualFile( VSILFILE * fp );
-  MS_DLL_EXPORT DBFHandle msDBFOpen( const char * pszDBFFile, const char * pszAccess );
-  MS_DLL_EXPORT void msDBFClose( DBFHandle hDBF );
-  MS_DLL_EXPORT DBFHandle msDBFCreate( const char * pszDBFFile );
-
-  MS_DLL_EXPORT int msDBFGetFieldCount( DBFHandle psDBF );
-  MS_DLL_EXPORT int msDBFGetRecordCount( DBFHandle psDBF );
-  MS_DLL_EXPORT int msDBFAddField( DBFHandle hDBF, const char * pszFieldName, DBFFieldType eType, int nWidth, int nDecimals );
-
-  MS_DLL_EXPORT DBFFieldType msDBFGetFieldInfo( DBFHandle psDBF, int iField, char * pszFieldName, int * pnWidth, int * pnDecimals );
-
-  MS_DLL_EXPORT int msDBFReadIntegerAttribute( DBFHandle hDBF, int iShape, int iField );
-  MS_DLL_EXPORT double msDBFReadDoubleAttribute( DBFHandle hDBF, int iShape, int iField );
-  MS_DLL_EXPORT const char *msDBFReadStringAttribute( DBFHandle hDBF, int iShape, int iField );
-
-  MS_DLL_EXPORT int msDBFWriteIntegerAttribute( DBFHandle hDBF, int iShape, int iField, int nFieldValue );
-  MS_DLL_EXPORT int msDBFWriteDoubleAttribute( DBFHandle hDBF, int iShape, int iField, double dFieldValue );
-  MS_DLL_EXPORT int msDBFWriteStringAttribute( DBFHandle hDBF, int iShape, int iField, const char * pszFieldValue );
-
-  MS_DLL_EXPORT char **msDBFGetItems(DBFHandle dbffile);
-  MS_DLL_EXPORT char **msDBFGetValues(DBFHandle dbffile, int record);
-  MS_DLL_EXPORT char **msDBFGetValueList(DBFHandle dbffile, int record, int *itemindexes, int numitems);
-  MS_DLL_EXPORT int *msDBFGetItemIndexes(DBFHandle dbffile, char **items, int numitems);
-  MS_DLL_EXPORT int msDBFGetItemIndex(DBFHandle dbffile, char *name);
-
-#endif
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPSHAPE_H */
diff -pruN 8.0.1-5/mapsmoothing.c 8.2.0~beta1-1~exp1/mapsmoothing.c
--- 8.0.1-5/mapsmoothing.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapsmoothing.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,311 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  RFC94 Shape smoothing
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- * Author:   Daniel Morissette (dmorissette@mapgears.com)
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-
-#define FP_EPSILON 1e-12
-#define FP_EQ(a, b) (fabs((a)-(b)) < FP_EPSILON)
-
-/* Internal Use, represent a line window (points) */
-typedef struct {
-  int pos; /* current point position in line */
-  int size;
-  int index; /* index of the current point in points array */
-  lineObj *line;
-  int lineIsRing; /* closed ring? */  
-  pointObj **points;
-} lineWindow;
-
-static void initLineWindow(lineWindow *lw, lineObj *line, int size)
-{ 
-  lw->pos = -1;
-  lw->lineIsRing = MS_FALSE;
-  lw->size = size;
-  lw->line = line;
-  lw->index = floor(lw->size/2); /* index of current position in points array */
-  lw->points = (pointObj**)msSmallMalloc(sizeof(pointObj*)*size);
-  
-  if ( (line->numpoints >= 2) &&
-       ((FP_EQ(line->point[0].x,
-               line->point[line->numpoints-1].x)) &&
-        (FP_EQ(line->point[0].y,
-               line->point[line->numpoints-1].y))) ) {
-    lw->lineIsRing = 1; 
-  }
-}
-
-static void freeLineWindow(lineWindow *lw)
-{  
-  free(lw->points);
-}
-
-static int nextLineWindow(lineWindow *lw)
-{
-  int i;
-
-  if (++lw->pos >= lw->line->numpoints)
-    return MS_DONE;
-
-  lw->points[lw->index] = &lw->line->point[lw->pos];
-
-  for (i=0;i<lw->index;++i) {
-    int r, l;
-    r = lw->pos-(i+1);
-    l = lw->pos+(i+1);
-
-    /* adjust values */
-    if ((r < 0) && lw->lineIsRing)
-      r = lw->line->numpoints-(i+2);
-    if ((l >= lw->line->numpoints) && lw->lineIsRing)
-      l = 1+(l-lw->line->numpoints);
-    
-    /* return if the window in not valid.. */
-    if (r<0 || l>=lw->line->numpoints)
-      return MS_FALSE;
-    
-    lw->points[lw->index-(i+1)] = &lw->line->point[r];
-    lw->points[lw->index+(i+1)] = &lw->line->point[l];
-  }
-
-  return MS_TRUE;
-}
-
-/* Calculates the distance ratio between the total distance of a path and the distance
-   between the first and last point (to detect a loop). */
-static double computePathDistanceRatio(pointObj **points, int len)
-{
-  double sum;
-  int i;
-
-  for (sum=0,i=1;i<len;++i) {
-    sum += msDistancePointToPoint(points[i-1], points[i]);
-  }
-
-  return sum/msDistancePointToPoint(points[0], points[len-1]);
-}
-
-/* Pre-Processing of a shape. It modifies the shape by adding intermediate
-   points where a loop is detected to improve the smoothing result. */
-static int processShapePathDistance(shapeObj *shape, int force)
-{
-  shapeObj initialShape, *newShape;
-  int i;
-  
-  /* initial shape to process */
-  msInitShape(&initialShape);    
-  msCopyShape(shape, &initialShape);
-
-  newShape = shape; /* we modify the shape object directly */
-  shape = &initialShape;
-  
-  /* Clean our shape object */
-  for (i= 0; i < newShape->numlines; i++)
-    free(newShape->line[i].point);
-  newShape->numlines = 0;
-  if (newShape->line) free(newShape->line);
-  
-  for (i=0;i<shape->numlines;++i) {
-    const int windowSize = 5;
-    int res;
-    lineWindow lw;
-    lineObj line = {0, NULL};
-
-    initLineWindow(&lw, &shape->line[i], windowSize);
-    msAddLine(newShape, &line);
-
-    while ((res = nextLineWindow(&lw)) != MS_DONE) {
-      double ratio = 0;
-      pointObj point = {0}; // initialize
-
-      if (lw.lineIsRing && lw.pos==lw.line->numpoints-1) {
-        point = newShape->line[i].point[0];
-        msAddPointToLine(&newShape->line[i],
-                         &point);
-        continue;
-      }
-
-      if (res == MS_FALSE) { /* invalid window */
-        msAddPointToLine(&newShape->line[i],
-                         lw.points[lw.index]);
-        continue;
-      }
-
-      if (!force)
-        ratio = computePathDistanceRatio(lw.points, windowSize);
-                      
-      if (force || (ratio > 1.3)) {
-        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index-1]->x)/2;
-        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index-1]->y)/2;
-        msAddPointToLine(&newShape->line[i],
-                         &point);
-      }
-      
-      point = lw.line->point[lw.pos];
-      msAddPointToLine(&newShape->line[i],
-                       &point);
-      
-      if (force || (ratio > 1.3)) {
-        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index+1]->x)/2;
-        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index+1]->y)/2;
-        msAddPointToLine(&newShape->line[i],
-                         &point);
-      }
-      
-    }
-       
-    freeLineWindow(&lw);
-  }
-    
-  msFreeShape(shape);
-  
-  return MS_SUCCESS;
-}
-
-shapeObj* msSmoothShapeSIA(shapeObj *shape, int ss, int si, char *preprocessing)
-{
-  int i, j;
-  pointObj *p;
-  double *coeff;
-  shapeObj *newShape;
-
-  newShape = (shapeObj *) msSmallMalloc(sizeof (shapeObj));
-  msInitShape(newShape);
-  newShape->type = shape->type; // preserve the type
-
-  if (ss < 3)
-    ss = 3;
-  
-  if (si < 1)
-    si = 1;
-
-  /* Apply preprocessing */
-  if (preprocessing)
-  {
-    if (strcasecmp(preprocessing, "all") == 0)
-      processShapePathDistance(shape, MS_TRUE);
-    else if (strcasecmp(preprocessing, "angle") == 0)
-      processShapePathDistance(shape, MS_FALSE);
-  }
-  
-  p = (pointObj *) msSmallMalloc(ss*sizeof(pointObj));
-  coeff = (double *) msSmallMalloc(ss*sizeof (double));        
-  
-  for (i=0;i<si;++i) {
-    shapeObj initialShape;
-    
-    if (si > 1 && i>0) {
-      msInitShape(&initialShape);    
-      msCopyShape(shape, &initialShape);
-      
-      /* Clean our shape object */
-      for (j=0; j < newShape->numlines; ++j)
-        free(newShape->line[j].point);
-      newShape->numlines = 0;
-      if (newShape->line) {
-        free(newShape->line);
-        newShape->line = NULL;
-      }
-
-      shape = &initialShape;
-    }
-    
-    for (j=0;j<shape->numlines;++j) {
-      int k, ws, res;      
-      lineObj newLine = {0,NULL};
-      lineWindow lw;
-
-      /* determine if we can use the ss for this line */
-      ws = ss;      
-      if (ws >= shape->line[j].numpoints) {
-        ws = shape->line[j].numpoints-1;
-      }
-
-      if (ws%2==0)
-        ws-=1;  
-
-      initLineWindow(&lw, &shape->line[j], ws);
-      msAddLine(newShape, &newLine);
-
-      coeff[lw.index] = 1;
-      for (k=0;k<lw.index;++k) {
-        coeff[lw.index+(k+1)] = coeff[lw.index-k]/2;
-        coeff[lw.index-(k+1)] = coeff[lw.index+k]/2;    
-      }
-      
-      
-      while ((res = nextLineWindow(&lw)) != MS_DONE) {
-        double sum_x=0, sum_y=0, sum = 0;
-        pointObj point = {0}; // initialize
-        int k = 0;
-
-        if (res == MS_FALSE) { /* invalid window */
-          msAddPointToLine(&newShape->line[j],
-                           lw.points[lw.index]);
-          continue;
-        }
-
-        /* Apply Coefficient */
-        p[lw.index] = *lw.points[lw.index];
-        for (k=0; k<lw.index; ++k) {
-          p[lw.index-(k+1)] = *lw.points[lw.index-(k+1)];
-          p[lw.index-(k+1)].x *= coeff[lw.index-(k+1)];
-          p[lw.index-(k+1)].y *= coeff[lw.index-(k+1)];
-          p[lw.index+(k+1)] = *lw.points[lw.index+(k+1)];
-          p[lw.index+(k+1)].x *= coeff[lw.index+(k+1)];
-          p[lw.index+(k+1)].y *= coeff[lw.index+(k+1)];
-        }
-        
-        for (k=0; k<lw.size; ++k) {
-          sum += coeff[k];
-          sum_x += p[k].x;
-          sum_y += p[k].y;          
-        }
-      
-        point.x = sum_x/sum;
-        point.y = sum_y/sum;
-        msAddPointToLine(&newShape->line[j],
-                         &point);
-      }
-
-      freeLineWindow(&lw);      
-    }
-    
-    if (i>0) {
-      msFreeShape(shape);
-      shape = newShape;
-    }
-    
-  }
-  
-  free(p);
-  free(coeff);
-
-  return newShape;
-}
diff -pruN 8.0.1-5/mapstring.cpp 8.2.0~beta1-1~exp1/mapstring.cpp
--- 8.0.1-5/mapstring.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapstring.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,2511 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Various string handling functions.
- * Author:   Steve Lime and the MapServer team.
- *
- * Notes: A couple of string handling functions (strrstr, strlcat) were taken from
- * other sources. Copyright notices accompany those functions below.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- * Copyright (c) 1998 Todd C. Miller <Todd.Miller@courtesan.com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapthread.h"
-
-#include "cpl_vsi.h"
-
-#include <ctype.h>
-#include <string.h>
-#include <errno.h>
-
-#include <algorithm>
-#include <cctype>
-
-/*
- * Find the first occurrence of find in s, ignore case.
- */
-
-#ifdef USE_FRIBIDI
-#if (defined(_WIN32) && !defined(__CYGWIN__)) || defined(HAVE_FRIBIDI2)
-#include "fribidi.h"
-#else
-#include <fribidi/fribidi.h>
-#endif
-#define MAX_STR_LEN 65000
-#endif
-
-#ifdef USE_ICONV
-#include "mapiconv.h"
-#include <iconv.h>
-#include <wchar.h>
-#endif
-
-#include "mapentities.h"
-
-#ifndef HAVE_STRRSTR
-/*
-** Copyright (c) 2000-2004  University of Illinois Board of Trustees
-** Copyright (c) 2000-2005  Mark D. Roth
-** All rights reserved.
-**
-** Developed by: Campus Information Technologies and Educational Services,
-** University of Illinois at Urbana-Champaign
-**
-** Permission is hereby granted, free of charge, to any person obtaining
-** a copy of this software and associated documentation files (the
-** ``Software''), to deal with the Software without restriction, including
-** without limitation the rights to use, copy, modify, merge, publish,
-** distribute, sublicense, and/or sell copies of the Software, and to
-** permit persons to whom the Software is furnished to do so, subject to
-** the following conditions:
-**
-** * Redistributions of source code must retain the above copyright
-**   notice, this list of conditions and the following disclaimers.
-**
-** * Redistributions in binary form must reproduce the above copyright
-**   notice, this list of conditions and the following disclaimers in the
-**   documentation and/or other materials provided with the distribution.
-**
-** * Neither the names of Campus Information Technologies and Educational
-**   Services, University of Illinois at Urbana-Champaign, nor the names
-**   of its contributors may be used to endorse or promote products derived
-**   from this Software without specific prior written permission.
-**
-** THE SOFTWARE IS PROVIDED ``AS IS'', WITHOUT WARRANTY OF ANY KIND,
-** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
-** MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
-** IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
-** ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
-** TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
-** OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
-*/
-char *strrstr(const char *string, const char *find)
-{
-  size_t stringlen, findlen;
-  const char *cp;
-
-  findlen = strlen(find);
-  stringlen = strlen(string);
-  if (findlen > stringlen)
-    return NULL;
-
-  for (cp = string + stringlen - findlen; cp >= string; cp--)
-    if (strncmp(cp, find, findlen) == 0)
-      return (char*) cp;
-
-  return NULL;
-}
-#endif
-
-#ifndef HAVE_STRLCAT
-/*
- * Copyright (c) 1998 Todd C. Miller <Todd.Miller@courtesan.com>
- *
- * Permission to use, copy, modify, and distribute this software for any
- * purpose with or without fee is hereby granted, provided that the above
- * copyright notice and this permission notice appear in all copies.
- *
- * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
- * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
- * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
- * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
- * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
- * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-
-/*
- * Appends src to string dst of size siz (unlike strncat, siz is the
- * full size of dst, not space left).  At most siz-1 characters
- * will be copied.  Always NUL terminates (unless siz <= strlen(dst)).
- * Returns strlen(src) + MS_MIN(siz, strlen(initial dst)).
- * If retval >= siz, truncation occurred.
- */
-size_t strlcat(char *dst, const char *src, size_t siz)
-{
-  char *d = dst;
-  const char *s = src;
-  size_t n = siz;
-  size_t dlen;
-
-  /* Find the end of dst and adjust bytes left but don't go past end */
-  while (n-- != 0 && *d != '\0')
-    d++;
-  dlen = d - dst;
-  n = siz - dlen;
-
-  if (n == 0)
-    return(dlen + strlen(s));
-  while (*s != '\0') {
-    if (n != 1) {
-      *d++ = *s;
-      n--;
-    }
-    s++;
-  }
-  *d = '\0';
-
-  return(dlen + (s - src));/* count does not include NUL */
-}
-#endif
-
-#ifndef HAVE_STRLCPY
-/*
- * Copyright (c) 1998 Todd C. Miller <Todd.Miller@courtesan.com>
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of the author may not be used to endorse or promote products
- *    derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
- * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
- * THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
- * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
- * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
- * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
- * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/*
- * Copy src to string dst of size siz.  At most siz-1 characters
- * will be copied.  Always NUL terminates (unless siz == 0).
- * Returns strlen(src); if retval >= siz, truncation occurred.
- */
-size_t
-strlcpy(char *dst, const char *src, size_t siz)
-{
-  char *d = dst;
-  const char *s = src;
-  size_t n = siz;
-
-  /* Copy as many bytes as will fit */
-  if (n != 0 && --n != 0) {
-    do {
-      if ((*d++ = *s++) == 0)
-        break;
-    } while (--n != 0);
-  }
-
-  /* Not enough room in dst, add NUL and traverse rest of src */
-  if (n == 0) {
-    if (siz != 0)
-      *d = '\0';              /* NUL-terminate dst */
-    while (*s++)
-      ;
-  }
-
-  return(s - src - 1);    /* count does not include NUL */
-}
-#endif
-
-#ifndef HAVE_STRCASESTR
-/*-
- * Copyright (c) 1990, 1993
- *  The Regents of the University of California.  All rights reserved.
- *
- * This code is derived from software contributed to Berkeley by
- * Chris Torek.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- */
-char *strcasestr(const char *s, const char *find)
-{
-  char c, sc;
-  size_t len;
-
-  if ((c = *find++) != 0) {
-    c = tolower((unsigned char)c);
-    len = strlen(find);
-    do {
-      do {
-        if ((sc = *s++) == 0)
-          return (NULL);
-      } while ((char)tolower((unsigned char)sc) != c);
-    } while (strncasecmp(s, find, len) != 0);
-    s--;
-  }
-  return ((char *)s);
-}
-#endif
-
-#ifndef HAVE_STRNCASECMP
-int strncasecmp(const char *s1, const char *s2, size_t len)
-{
-  const char *cp1, *cp2;
-
-  cp1 = s1;
-  cp2 = s2;
-
-  if(len == 0)
-    return(0);
-
-  if (!*cp1)
-    return -1;
-  else if (!*cp2)
-    return 1;
-
-  while(*cp1 && *cp2 && len) {
-    int cmp;
-    if((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
-      return(cmp);
-    cp1++;
-    cp2++;
-    len--;
-  }
-
-  if(len == 0) {
-    return(0);
-  }
-  if(*cp1 || *cp2) {
-    if (*cp1)
-      return(1);
-    else
-      return (-1);
-  }
-  return(0);
-}
-#endif
-
-#ifndef HAVE_STRCASECMP
-int strcasecmp(const char *s1, const char *s2)
-{
-  const char *cp1, *cp2;
-
-  cp1 = s1;
-  cp2 = s2;
-  if ((!cp1) || (!cp2 )) {
-    return (0);
-  }
-  while(*cp1 && *cp2) {
-    int cmp;
-    if((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
-      return(cmp);
-    cp1++;
-    cp2++;
-  }
-  if(*cp1 || *cp2) {
-    if (*cp1)
-      return(1);
-    else
-      return (-1);
-  }
-
-  return(0);
-}
-#endif
-
-/*
-** msStringToInt() and msStringToDouble() are helper functions to convert strings to numbers. They
-** return MS_FAILURE if the input string is NULL or if the entire string did not convert successfully.
-*/
-int msStringToInt(const char *str, int *value, int base)
-{
-  char *parse_check = NULL;
-
-  if(!str) return MS_FAILURE;
-
-  *value = (int)strtol(str, &parse_check, base);
-  if(*parse_check != '\0') return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-int msStringToDouble(const char *str, double *value)
-{
-  char *parse_check = NULL;
-
-  if(!str) return MS_FAILURE;
-
-  *value = strtod(str, &parse_check);
-  if(*parse_check != '\0') return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-char *msLongToString(long value)
-{
-  size_t bufferSize = 256;
-  char *buffer = (char*)msSmallMalloc(bufferSize);
-
-  snprintf(buffer, bufferSize, "%ld", value);
-  return(buffer);
-}
-
-char *msDoubleToString(double value, int force_f)
-{
-  size_t bufferSize = 256;
-  char *buffer = (char*)msSmallMalloc(bufferSize);
-
-  if (force_f == MS_TRUE)
-    snprintf(buffer, bufferSize, "%f", value);
-  else
-    snprintf(buffer, bufferSize, "%g", value);
-  return(buffer);
-}
-
-char *msIntToString(int value)
-{
-  size_t bufferSize = 256;
-  char *buffer = (char*)msSmallMalloc(bufferSize);
-
-  snprintf(buffer, bufferSize, "%i", value);
-  return(buffer);
-}
-
-void msStringToUpper(char *string)
-{
-  int i;
-
-  if (string != NULL) {
-    for (i = 0; string[i]; i++) {
-      string[i] = toupper(string[i]);
-    }
-    return;
-  }
-}
-
-void msStringToLower(char *string)
-{
-  int i;
-
-  if (string != NULL) {
-    for (i = 0; string[i]; i++) {
-      string[i] = tolower(string[i]);
-    }
-    return;
-  }
-}
-
-std::string msStringToLower(const std::string& s) {
-  std::string ret(s);
-  std::transform(ret.begin(), ret.end(), ret.begin(), 
-                 [](unsigned char c){ return std::tolower(c); });
-  return ret;
-}
-
-/**
- * Force the first character to uppercase and the rest of the characters to
- * lower case for EACH word in the string.
- */
-void msStringInitCap(char *string)
-{
-  int i;
-  int start = 1; 
-  if (string != NULL) {
-    for (i = 0; i < (int)strlen(string); i++) {
-      if (string[i] == ' ')
-        start = 1;
-      else if (start) {
-        string[i] = toupper(string[i]);
-        start = 0;
-      }
-      else {
-        string[i] = tolower(string[i]);
-      }
-    }
-  }
-}
-
-/**
- * Force the first character to uppercase for the FIRST word in the string
- * and the rest of the characters to lower case.
- */
-void msStringFirstCap(char *string)
-{
-  int i;
-  int start = 1; 
-  if (string != NULL) {
-    for (i = 0; i < (int)strlen(string); i++) {
-      if (string[i] != ' ') {
-        if (start) {
-          string[i] = toupper(string[i]);
-          start = 0;
-        }
-        else
-          string[i] = tolower(string[i]);
-      }
-    }
-  }
-}
-
-char *msStringChop(char *string)
-{
-  int n;
-
-  n = strlen(string);
-  if(n>0)
-    string[n-1] = '\0';
-
-  return(string);
-}
-
-/*
-** Trim leading and trailing white space.
-*/
-void msStringTrim(char *str)
-{
-  int i;
-
-  /* Send nulls home without supper. */
-  if( ! str ) return;
-
-  /* Move non-white string to the front. */
-  i = strspn(str, " ");
-  if(i) {
-    memmove(str, str + i, strlen(str) - i + 1);
-  }
-  /* Nothing left? Exit. */
-  if(strlen(str) == 0) {
-    return;
-  }
-  /* Null-terminate end of non-white string. */
-  for(i=strlen(str)-1; i>=0; i--) { /* step backwards from end */
-    if(str[i] != ' ') {
-      str[i+1] = '\0';
-      return;
-    }
-  }
-  return;
-}
-
-void msStringTrim(std::string& string)
-{
-  const size_t npos = string.find_first_not_of(' ');
-  if( npos != std::string::npos )
-    string.erase(0, npos);
-  msStringTrimBlanks(string);
-}
-
-
-/*
-** Remove leading white spaces and shift everything to the left.
-*/
-char *msStringTrimLeft(char *string)
-{
-  char *read, *write;
-  int i, length;
-
-  if (string && strlen(string) > 0) {
-    length = strlen(string);
-    read = string;
-    write = string;
-
-    for (i=0; i<length; i++) {
-      if (isspace(string[i]))
-        read++;
-      else
-        break;
-    }
-
-    if (read > write) {
-      while (*read) {
-        *write = *read;
-        read++;
-        write++;
-      }
-      *write = '\0';
-    }
-  }
-  return string;
-}
-
-void msStringTrimLeft(std::string& string)
-{
-  const size_t length = string.length();
-  for( size_t i = 0; i < length; i++ ) {
-    if( !isspace(string[i]) ) {
-        if( i > 0 ) {
-          string.erase(0, i-1);
-        }
-        return;
-    }
-  }
-  string.clear();
-}
-
-/* ------------------------------------------------------------------------------- */
-/*       Trims trailing blanks from a string                                        */
-/* ------------------------------------------------------------------------------- */
-void msStringTrimBlanks(char *string)
-{
-  int i,n;
-
-  n = strlen(string);
-  for(i=n-1; i>=0; i--) { /* step backwards through the string */
-    if(string[i] != ' ') {
-      string[i+1] = '\0';
-      return;
-    }
-  }
-}
-
-void msStringTrimBlanks(std::string& string)
-{
-  const size_t npos = string.find_last_not_of(' ');
-  if( npos != std::string::npos )
-    string.resize(npos+1);
-}
-
-/* ------------------------------------------------------------------------------- */
-/*       Trims end-of-line marker from a string                                    */
-/*       Usefull in conjunction with fgets() calls                                 */
-/* ------------------------------------------------------------------------------- */
-void msStringTrimEOL(char *string)
-{
-  int i;
-
-  for(i=0 ; string[i] != '\0'; i++) {
-    if(string[i] == '\n') {
-      string[i] = '\0'; /* Terminate the string at the newline */
-      return;
-    }
-  }
-}
-
-/* ------------------------------------------------------------------------------- */
-/*       Replace all occurances of old with new in str.                            */
-/*       It is assumed that str was dynamically created using malloc.              */
-/* ------------------------------------------------------------------------------- */
-char *msReplaceSubstring(char *str, const char *old, const char *newstr)
-{
-  size_t str_len, old_len, new_len, tmp_offset;
-  char *tmp_ptr;
-
-  if(newstr == NULL)
-    newstr = "";
-
-  /*
-  ** If old is not found then leave str alone
-  */
-  if( (tmp_ptr = strstr(str, old)) == NULL)
-    return(str);
-
-  /*
-  ** Grab some info about incoming strings
-  */
-  str_len = strlen(str);
-  old_len = strlen(old);
-  new_len = strlen(newstr);
-
-  /*
-  ** Now loop until old is NOT found in new
-  */
-  while( tmp_ptr != NULL ) {
-
-    /*
-    ** re-allocate memory for buf assuming 1 replacement of old with new
-          ** don't bother reallocating if old is larger than new)
-    */
-    if (old_len < new_len) {
-      tmp_offset = tmp_ptr - str;
-      str_len = str_len - old_len + new_len;
-      str = (char *)msSmallRealloc(str, (str_len + 1)); /* make new space for a copy */
-      tmp_ptr = str + tmp_offset;
-    }
-
-    /*
-    ** Move the trailing part of str to make some room unless old_len == new_len
-    */
-    if (old_len != new_len) {
-      memmove(tmp_ptr+new_len, tmp_ptr+old_len, strlen(tmp_ptr)-old_len+1);
-    }
-
-    /*
-    ** Now copy new over old
-    */
-    memcpy(tmp_ptr, newstr, new_len);
-
-    /*
-    ** And look for more matches in the rest of the string
-    */
-    tmp_ptr = strstr(tmp_ptr + new_len, old);
-  }
-
-  return(str);
-}
-
-/*
- * same goal as msReplaceSubstring, but for the known case
- * when we won't have to do reallocs etc
- * used to replace the wrap characetr by a newline for labels
- */
-void msReplaceChar(char *str, char old, char newstr)
-{
-  while(*(str++))
-    if(*str==old)
-      *str=newstr;
-}
-
-/*
-** how many times does ch occur in str
-*/
-int msCountChars(char *str, char ch)
-{
-  int i, l, n=0;
-
-  l = strlen(str);
-  for(i=0; i<l; i++)
-    if(str[i] == ch) n++;
-
-  return(n);
-}
-
-/* ------------------------------------------------------------------------------- */
-/*       Strip filename from a full path                                           */
-/* ------------------------------------------------------------------------------- */
-char *msStripPath(char *fn)
-{
-  char *pSlash;
-  char *pBackslash;
-
-  /* try to locate both, the last slash or backslash */
-  pSlash = strrchr(fn,'/');
-  pBackslash = strrchr(fn,'\\');
-
-  if( pSlash != NULL && pBackslash != NULL ) {
-    if( pSlash < pBackslash )
-      return ++pBackslash;
-    else
-      return ++pSlash;
-  } else if ( pSlash != NULL )
-    return ++pSlash; /* skip past the "slash" */
-  else if ( pBackslash != NULL )
-    return ++pBackslash; /* skip past the "backslash" */
-  else
-    return(fn);
-}
-
-/*
-** Returns the *path* portion of the filename fn. Memory is allocated using malloc.
-*/
-char *msGetPath(const char *fn)
-{
-  char *str;
-  int i, length;
-
-  length = strlen(fn);
-  if((str = msStrdup(fn)) == NULL)
-    return(NULL);
-
-  for(i=length-1; i>=0; i--) { /* step backwards through the string */
-    if((str[i] == '/') || (str[i] == '\\')) {
-      str[i+1] = '\0';
-      break;
-    }
-  }
-
-  if(strcmp(str, fn) == 0) {
-    msFree(str);
-#if defined(_WIN32) && !defined(__CYGWIN__)
-    str = msStrdup(".\\");
-#else
-    str= msStrdup("./");
-#endif
-  }
-
-  return(str);
-}
-
-/*
-** Returns a *path* built from abs_path and path.
-** The pszReturnPath must be declared by the caller function as an array
-** of MS_MAXPATHLEN char
-*/
-char *msBuildPath(char *pszReturnPath, const char *abs_path, const char *path)
-{
-  int   abslen = 0;
-  int   pathlen = 0;
-
-
-  if(path == NULL) {
-    msSetError(MS_IOERR, NULL, "msBuildPath");
-    return NULL;
-  }
-
-  pathlen = strlen(path);
-  if (abs_path)
-    abslen = strlen(abs_path);
-
-  if((pathlen + abslen + 2) > MS_MAXPATHLEN) {
-    msSetError(MS_IOERR, "Path is too long.  Check server logs.",
-               "msBuildPath()");
-    msDebug("msBuildPath(): (%s%s): path is too long.\n", abs_path, path);
-    return NULL;
-  }
-
-  /* Check if path is absolute */
-  if((abs_path == NULL) || (abslen == 0) ||
-      (path[0] == '\\') || (path[0] == '/') ||
-      (pathlen > 1 && (path[1] == ':'))) {
-    strlcpy(pszReturnPath, path, MS_MAXPATHLEN);
-    return(pszReturnPath);
-  }
-
-  /* else return abs_path/path */
-  if((abs_path[abslen-1] == '/') || (abs_path[abslen-1] == '\\')) {
-    snprintf(pszReturnPath, MS_MAXPATHLEN, "%s%s", abs_path, path);
-  } else {
-    snprintf(pszReturnPath, MS_MAXPATHLEN, "%s/%s", abs_path, path);
-  }
-
-  return(pszReturnPath);
-}
-
-/*
-** Returns a *path* built from abs_path, path1 and path2.
-** abs_path/path1/path2
-** The pszReturnPath must be declared by the caller function as an array
-** of MS_MAXPATHLEN char
-*/
-char *msBuildPath3(char *pszReturnPath, const char *abs_path, const char *path1,const char *path2)
-{
-  char szPath[MS_MAXPATHLEN];
-
-  return msBuildPath(pszReturnPath, abs_path,
-                     msBuildPath(szPath, path1, path2));
-}
-
-/*
-** Similar to msBuildPath(), but the input path is only qualified by the
-** absolute path if this will result in it pointing to a readable file.
-**
-** Returns NULL if the resulting path doesn't point to a readable file.
-*/
-
-char *msTryBuildPath(char *szReturnPath, const char *abs_path, const char *path)
-
-{
-  VSILFILE  *fp;
-
-  if( msBuildPath( szReturnPath, abs_path, path ) == NULL )
-    return NULL;
-
-  fp = VSIFOpenL( szReturnPath, "r" );
-  if( fp == NULL ) {
-    strlcpy( szReturnPath, path, MS_MAXPATHLEN);
-    return NULL;
-  } else
-    VSIFCloseL( fp );
-
-  return szReturnPath;
-}
-
-/*
-** Similar to msBuildPath3(), but the input path is only qualified by the
-** absolute path if this will result in it pointing to a readable file.
-**
-** Returns NULL if the resulting path doesn't point to a readable file.
-*/
-
-char *msTryBuildPath3(char *szReturnPath, const char *abs_path, const char *path1, const char *path2)
-
-{
-  VSILFILE  *fp;
-
-  if( msBuildPath3( szReturnPath, abs_path, path1, path2 ) == NULL )
-    return NULL;
-
-  fp = VSIFOpenL( szReturnPath, "r" );
-  if( fp == NULL ) {
-    strlcpy( szReturnPath, path2, MS_MAXPATHLEN);
-    return NULL;
-  } else
-    VSIFCloseL( fp );
-
-  return szReturnPath;
-}
-
-/*
-** Splits a string into multiple strings based on ch. Consecutive ch's are ignored.
-*/
-char **msStringSplit(const char *string, char ch, int *num_tokens)
-{
-  int i,j,k;
-  int length,n;
-  char **token;
-  char last_ch='\0';
-
-  n = 1; /* always at least 1 token, the string itself */
-  length = strlen(string);
-  for(i=0; i<length; i++) {
-    if(string[i] == ch && last_ch != ch)
-      n++;
-    last_ch = string[i];
-  }
-
-  token = (char **) msSmallMalloc(sizeof(char *)*n);
-
-  k = 0;
-  token[k] = (char *)msSmallMalloc(sizeof(char)*(length+1));
-
-  j = 0;
-  last_ch='\0';
-  for(i=0; i<length; i++) {
-    if(string[i] == ch) {
-
-      if(last_ch == ch)
-        continue;
-
-      token[k][j] = '\0'; /* terminate current token */
-
-      k++;
-      token[k] = (char *)msSmallMalloc(sizeof(char)*(length+1));
-
-      j = 0;
-    } else {
-      token[k][j] = string[i];
-      j++;
-    }
-
-    last_ch = string[i];
-  }
-
-  token[k][j] = '\0'; /* terminate last token */
-
-  *num_tokens = n;
-
-  return(token);
-}
-
-std::vector<std::string> msStringSplit(const char *string, char ch)
-{
-    int num_tokens = 0;
-    char** tmp = msStringSplit(string, ch, &num_tokens);
-    std::vector<std::string> res;
-    res.reserve(num_tokens);
-    for( int i = 0; i < num_tokens; i++ )
-        res.push_back(tmp[i]);
-    msFreeCharArray(tmp, num_tokens);
-    return res;
-}
-
-/*
- This function is a copy of CSLTokenizeString2() function of the CPL component.
- See the port/cpl_string.cpp file in gdal source for the complete documentation.
- Available Flags:
- * - MS_ALLOWEMPTYTOKENS: allow the return of empty tokens when two
- * delimiters in a row occur with no other text between them.  If not set,
- * empty tokens will be discarded;
- * - MS_STRIPLEADSPACES: strip leading space characters from the token (as
- * reported by isspace());
- * - MS_STRIPENDSPACES: strip ending space characters from the token (as
- * reported by isspace());
- * - MS_HONOURSTRINGS: double quotes can be used to hold values that should
- * not be broken into multiple tokens;
- * - MS_PRESERVEQUOTES: string quotes are carried into the tokens when this
- * is set, otherwise they are removed;
- * - MS_PRESERVEESCAPES: if set backslash escapes (for backslash itself,
- * and for literal double quotes) will be preserved in the tokens, otherwise
- * the backslashes will be removed in processing.
- */
-char ** msStringSplitComplex( const char * pszString,
-                              const char * pszDelimiters,
-                              int *num_tokens,
-                              int nFlags )
-
-{
-  char        **papszRetList = NULL;
-  int         nRetMax = 0, nRetLen = 0;
-  char        *pszToken;
-  int         nTokenMax, nTokenLen;
-  int         bHonourStrings = (nFlags & MS_HONOURSTRINGS);
-  int         bAllowEmptyTokens = (nFlags & MS_ALLOWEMPTYTOKENS);
-  int         bStripLeadSpaces = (nFlags & MS_STRIPLEADSPACES);
-  int         bStripEndSpaces = (nFlags & MS_STRIPENDSPACES);
-
-  pszToken = (char *) msSmallMalloc(sizeof(char)*10);;
-  nTokenMax = 10;
-
-  while( pszString != NULL && *pszString != '\0' ) {
-    int     bInString = MS_FALSE;
-    int     bStartString = MS_TRUE;
-
-    nTokenLen = 0;
-
-    /* Try to find the next delimeter, marking end of token */
-    for( ; *pszString != '\0'; pszString++ ) {
-
-      /* End if this is a delimeter skip it and break. */
-      if( !bInString && strchr(pszDelimiters, *pszString) != NULL ) {
-        pszString++;
-        break;
-      }
-
-      /* If this is a quote, and we are honouring constant
-         strings, then process the constant strings, with out delim
-         but don't copy over the quotes */
-      if( bHonourStrings && *pszString == '"' ) {
-        if( nFlags & MS_PRESERVEQUOTES ) {
-          pszToken[nTokenLen] = *pszString;
-          nTokenLen++;
-        }
-
-        if( bInString ) {
-          bInString = MS_FALSE;
-          continue;
-        } else {
-          bInString = MS_TRUE;
-          continue;
-        }
-      }
-
-      /*
-       * Within string constants we allow for escaped quotes, but in
-       * processing them we will unescape the quotes and \\ sequence
-       * reduces to \
-       */
-      if( bInString && pszString[0] == '\\' ) {
-        if ( pszString[1] == '"' || pszString[1] == '\\' ) {
-          if( nFlags & MS_PRESERVEESCAPES ) {
-            pszToken[nTokenLen] = *pszString;
-            nTokenLen++;
-          }
-
-          pszString++;
-        }
-      }
-
-      /*
-       * Strip spaces at the token start if requested.
-       */
-      if ( !bInString && bStripLeadSpaces
-           && bStartString && isspace((unsigned char)*pszString) )
-        continue;
-
-      bStartString = MS_FALSE;
-
-      /*
-       * Extend token buffer if we are running close to its end.
-       */
-      if( nTokenLen >= nTokenMax-3 ) {
-        nTokenMax = nTokenMax * 2 + 10;
-        pszToken = (char *) msSmallRealloc(pszToken, sizeof(char)*nTokenMax);
-      }
-
-      pszToken[nTokenLen] = *pszString;
-      nTokenLen++;
-    }
-
-    /*
-     * Strip spaces at the token end if requested.
-     */
-    if ( !bInString && bStripEndSpaces ) {
-      while ( nTokenLen && isspace((unsigned char)pszToken[nTokenLen - 1]) )
-        nTokenLen--;
-    }
-
-    pszToken[nTokenLen] = '\0';
-
-    /*
-     * Add the token.
-     */
-    if( pszToken[0] != '\0' || bAllowEmptyTokens ) {
-      if( nRetLen >= nRetMax - 1 ) {
-        nRetMax = nRetMax * 2 + 10;
-        papszRetList = (char **) msSmallRealloc(papszRetList, sizeof(char*)*nRetMax);
-      }
-
-      papszRetList[nRetLen++] = msStrdup( pszToken );
-      papszRetList[nRetLen] = NULL;
-    }
-  }
-
-  /*
-   * If the last token was empty, then we need to capture
-   * it now, as the loop would skip it.
-   */
-  if( pszString != NULL && *pszString == '\0' && bAllowEmptyTokens && nRetLen > 0
-      && strchr(pszDelimiters,*(pszString-1)) != NULL ) {
-    if( nRetLen >= nRetMax - 1 ) {
-      nRetMax = nRetMax * 2 + 10;
-      papszRetList = (char **) msSmallRealloc(papszRetList, sizeof(char*)*nRetMax);
-    }
-
-    papszRetList[nRetLen++] = msStrdup("");
-    papszRetList[nRetLen] = NULL;
-  }
-
-  if( papszRetList == NULL )
-    papszRetList = (char **) msSmallMalloc(sizeof(char *)*1);
-
-  *num_tokens = nRetLen;
-  free(pszToken);
-
-  return papszRetList;
-}
-
-/* This method is similar to msStringSplit but support quoted strings.
-   It also support multi-characters delimiter and allows to preserve quotes */
-char **msStringTokenize( const char *pszLine, const char *pszDelim,
-                         int *num_tokens, int preserve_quote )
-{
-  char **papszResult = NULL;
-  int n = 1, iChar, nLength = strlen(pszLine), iTokenChar = 0, bInQuotes = MS_FALSE;
-  char *pszToken = (char *) msSmallMalloc(sizeof(char)*(nLength+1));
-  int nDelimLen = strlen(pszDelim);
-
-  /* Compute the number of tokens */
-  for( iChar = 0; pszLine[iChar] != '\0'; iChar++ ) {
-    if( bInQuotes && pszLine[iChar] == '"' && pszLine[iChar+1] == '"' ) {
-      iChar++;
-    } else if( pszLine[iChar] == '"' ) {
-      bInQuotes = !bInQuotes;
-    } else if ( !bInQuotes && strncmp(pszLine+iChar,pszDelim,nDelimLen) == 0 ) {
-      iChar += nDelimLen - 1;
-      n++;
-    }
-  }
-
-  papszResult = (char **) msSmallMalloc(sizeof(char *)*n);
-  n = iTokenChar = bInQuotes = 0;
-  for( iChar = 0; pszLine[iChar] != '\0'; iChar++ ) {
-    if( bInQuotes && pszLine[iChar] == '"' && pszLine[iChar+1] == '"' ) {
-      if (preserve_quote == MS_TRUE)
-        pszToken[iTokenChar++] = '"';
-      pszToken[iTokenChar++] = '"';
-      iChar++;
-    } else if( pszLine[iChar] == '"' ) {
-      if (preserve_quote == MS_TRUE)
-        pszToken[iTokenChar++] = '"';
-      bInQuotes = !bInQuotes;
-    } else if( !bInQuotes && strncmp(pszLine+iChar,pszDelim,nDelimLen) == 0 ) {
-      pszToken[iTokenChar++] = '\0';
-      papszResult[n] = pszToken;
-      pszToken = (char *) msSmallMalloc(sizeof(char)*(nLength+1));
-      iChar += nDelimLen - 1;
-      iTokenChar = 0;
-      n++;
-    } else {
-      pszToken[iTokenChar++] = pszLine[iChar];
-    }
-  }
-
-  pszToken[iTokenChar++] = '\0';
-  papszResult[n] = pszToken;
-
-  *num_tokens = n+1;
-
-  return papszResult;
-}
-
-/**********************************************************************
- *                       msEncodeChar()
- *
- * Return 1 if the character argument should be encoded for safety
- * in URL use and 0 otherwise. Specific character map taken from
- * http://www.ietf.org/rfc/rfc2396.txt
- *
- **********************************************************************/
-
-int msEncodeChar(const char c)
-{
-  if (
-    (c >= 0x61 && c <= 0x7A ) ||   /* Letters a-z */
-    (c >= 0x41 && c <= 0x5A ) ||   /* Letters A-Z */
-    (c >= 0x30 && c <= 0x39 ) ||   /* Numbers 0-9 */
-    (c >= 0x27 && c <= 0x2A ) ||   /* * ' ( )     */
-    (c >= 0x2D && c <= 0x2E ) ||   /* - .         */
-    (c == 0x5F ) ||                /* _           */
-    (c == 0x21 ) ||                /* !           */
-    (c == 0x7E ) ) {               /* ~           */
-    return(0);
-  } else {
-    return(1);
-  }
-}
-
-char *msEncodeUrl(const char *data)
-{
-  /*
-   * Delegate to msEncodeUrlExcept, with a null second argument
-   * to render the except handling moot.
-   */
-  return(msEncodeUrlExcept(data, '\0'));
-}
-
-/**********************************************************************
- *                       msEncodeCharExcept()
- *
- * URL encoding, applies RFP2396 encoding to all characters
- * except the one exception character. An exception character
- * of '\0' implies no exception handling.
- *
- **********************************************************************/
-
-char *msEncodeUrlExcept(const char *data, const char except)
-{
-  static const char *hex = "0123456789ABCDEF";
-  const char *i;
-  char  *j, *code;
-  int   inc;
-  unsigned char ch;
-
-  for (inc=0, i=data; *i!='\0'; i++)
-    if (msEncodeChar(*i))
-      inc += 2;
-
-  code = (char*)msSmallMalloc(strlen(data)+inc+1);
-
-  for (j=code, i=data; *i!='\0'; i++, j++) {
-    if ( except != '\0' && *i == except ) {
-      *j = except;
-    } else if (msEncodeChar(*i)) {
-      ch = *i;
-      *j++ = '%';
-      *j++ = hex[ch/16];
-      *j   = hex[ch%16];
-    } else
-      *j = *i;
-  }
-  *j = '\0';
-
-  return code;
-}
-
-/************************************************************************/
-/*                            msEscapeJSonString()                      */
-/************************************************************************/
-
-/* The input (and output) string are not supposed to start/end with double */
-/* quote characters. It is the responsibility of the caller to do that. */
-char* msEscapeJSonString(const char* pszJSonString)
-{
-    /* Worst case is one character to become \uABCD so 6 characters */
-    char* pszRet;
-    int i = 0, j = 0;
-    static const char* pszHex = "0123456789ABCDEF";
-    
-    pszRet = (char*) msSmallMalloc(strlen(pszJSonString) * 6 + 1);
-    /* From http://www.json.org/ */
-    for(i = 0; pszJSonString[i] != '\0'; i++)
-    {
-        unsigned char ch = pszJSonString[i];
-        if( ch == '\b' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'b';
-        }
-        else if( ch == '\f' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'f';
-        }
-        else if( ch == '\n' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'n';
-        }
-        else if( ch == '\r' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'r';
-        }
-        else if( ch == '\t' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 't';
-        }
-        else if( ch < 32 )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'u';
-            pszRet[j++] = '0';
-            pszRet[j++] = '0';
-            pszRet[j++] = pszHex[ch / 16];
-            pszRet[j++] = pszHex[ch % 16];
-        }
-        else if( ch == '"' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = '"';
-        }
-        else if( ch == '\\' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = '\\';
-        }
-        else
-        {
-            pszRet[j++] = ch;
-        }
-    }
-    pszRet[j] = '\0';
-    return pszRet;
-}
-
-/* msEncodeHTMLEntities()
-**
-** Return a copy of string after replacing some problematic chars with their
-** HTML entity equivalents.
-**
-** The replacements performed are:
-**  '&' -> "&amp;", '"' -> "&quot;", '<' -> "&lt;" and '>' -> "&gt;"
-**/
-char *msEncodeHTMLEntities(const char *string)
-{
-  int buflen, i;
-  char *newstring;
-  const char *c;
-
-  if(string == NULL)
-    return NULL;
-
-  /* Start with 100 extra chars for replacements...  */
-  /* should be good enough for most cases */
-  buflen = strlen(string) + 100;
-  newstring = (char*)malloc(buflen+1);
-  MS_CHECK_ALLOC(newstring, buflen+1, NULL);
-
-  for(i=0, c=string; *c != '\0'; c++) {
-    /* Need to realloc buffer? */
-    if (i+6 > buflen) {
-      /* If we had to realloc then this string must contain several */
-      /* entities... so let's go with twice the previous buffer size */
-      buflen *= 2;
-      /* cppcheck-suppress memleakOnRealloc */
-      newstring = (char*)realloc(newstring, buflen+1);
-      MS_CHECK_ALLOC(newstring, buflen+1, NULL);
-    }
-
-    switch(*c) {
-      case '&':
-        strcpy(newstring+i, "&amp;");
-        i += 5;
-        break;
-      case '<':
-        strcpy(newstring+i, "&lt;");
-        i += 4;
-        break;
-      case '>':
-        strcpy(newstring+i, "&gt;");
-        i += 4;
-        break;
-      case '"':
-        strcpy(newstring+i, "&quot;");
-        i += 6;
-        break;
-      case '\'':
-        strcpy(newstring+i, "&#39;"); /* changed from &apos; and i += 6 (bug 1040) */
-        i += 5;
-        break;
-      default:
-        newstring[i++] = *c;
-    }
-  }
-
-  newstring[i++] = '\0';
-
-  return newstring;
-}
-
-
-/* msDecodeHTMLEntities()
-**
-** Modify the string to replace encoded characters by their true value
-**
-** The replacements performed are:
-**  "&amp;" -> '&', "&quot;" -> '"', "&lt;" -> '<' and "&gt;" -> '>'
-**/
-void msDecodeHTMLEntities(const char *string)
-{
-  char *pszAmp=NULL, *pszSemiColon=NULL, *pszReplace=NULL, *pszEnd=NULL;
-  char *pszBuffer=NULL;
-  size_t bufferSize = 0;
-
-  if(string == NULL)
-    return;
-  else
-    pszBuffer = (char*)string;
-
-  bufferSize = strlen(pszBuffer);
-  pszReplace = (char*) msSmallMalloc(bufferSize+1);
-  pszEnd = (char*) msSmallMalloc(bufferSize+1);
-
-  while((pszAmp = strchr(pszBuffer, '&')) != NULL) {
-    /* Get the &...; */
-    strlcpy(pszReplace, pszAmp, bufferSize);
-    pszSemiColon = strchr(pszReplace, ';');
-    if(pszSemiColon == NULL)
-      break;
-    else
-      pszSemiColon++;
-
-    /* Get everything after the &...; */
-    strlcpy(pszEnd, pszSemiColon, bufferSize);
-
-    pszReplace[pszSemiColon-pszReplace] = '\0';
-
-    /* Replace the &...; */
-    if(strcasecmp(pszReplace, "&amp;") == 0) {
-      pszBuffer[pszAmp - pszBuffer] = '&';
-      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
-      strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&lt;") == 0) {
-      pszBuffer[pszAmp - pszBuffer] = '<';
-      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
-      strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&gt;") == 0) {
-      pszBuffer[pszAmp - pszBuffer] = '>';
-      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
-      strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&quot;") == 0) {
-      pszBuffer[pszAmp - pszBuffer] = '"';
-      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
-      strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&apos;") == 0) {
-      pszBuffer[pszAmp - pszBuffer] = '\'';
-      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
-      strcat(pszBuffer, pszEnd);
-    }
-
-    pszBuffer = pszAmp + 1;
-  }
-
-  free(pszReplace);
-  free(pszEnd);
-
-  return;
-}
-
-/*
-** msIsXMLValid
-**
-** Check if the string is an XML valid string. It should contains only
-** A-Z, a-z, 0-9, '_', '-', '.', and ':'
-** Return MS_TRUE or MS_FALSE
-*/
-int msIsXMLTagValid(const char *string)
-{
-  int i, nLen;
-
-  nLen = strlen(string);
-
-  for(i=0; i<nLen; i++) {
-    if( !( string[i] >= 'A' && string[i] <= 'Z' ) &&
-        !( string[i] >= 'a' && string[i] <= 'z' ) &&
-        !( string[i] >= '0' && string[i] <= '9' ) &&
-        string[i] != '-' && string[i] != '.' &&
-        string[i] != ':' && string[i] != '_' )
-      return MS_FALSE;
-  }
-
-  return MS_TRUE;
-}
-
-
-/*
- * Concatenate pszSrc to pszDest and reallocate memory if necessary.
-*/
-char *msStringConcatenate(char *pszDest, const char *pszSrc)
-{
-  int nLen;
-
-  if (pszSrc == NULL)
-    return pszDest;
-
-  /* if destination is null, allocate memory */
-  if (pszDest == NULL) {
-    pszDest = msStrdup(pszSrc);
-  } else { /* if dest is not null, reallocate memory */
-    char *pszTemp;
-
-    nLen = strlen(pszDest) + strlen(pszSrc);
-
-    pszTemp = (char*)realloc(pszDest, nLen + 1);
-    if (pszTemp) {
-      pszDest = pszTemp;
-      strcat(pszDest, pszSrc);
-      pszDest[nLen] = '\0';
-    } else {
-      msSetError(MS_MEMERR, "Error while reallocating memory.", "msStringConcatenate()");
-      return NULL;
-    }
-  }
-
-  return pszDest;
-}
-
-char *msJoinStrings(char **array, int arrayLength, const char *delimeter)
-{
-  char *string;
-  int stringLength=0;
-  int delimeterLength;
-  int i;
-
-  if(!array || arrayLength <= 0 || !delimeter) return NULL;
-
-  delimeterLength = strlen(delimeter);
-
-  for(i=0; i<arrayLength; i++)
-    stringLength += strlen(array[i]) + delimeterLength;
-
-  string = (char *)calloc(stringLength+1, sizeof(char));
-  MS_CHECK_ALLOC(string, (stringLength+1)* sizeof(char), NULL);
-  string[0] = '\0';
-
-  for(i=0; i<arrayLength-1; i++) {
-    strlcat(string, array[i], stringLength);
-    strlcat(string, delimeter, stringLength);
-  }
-  strlcat(string, array[i], stringLength); /* add last element, no delimiter */
-
-  return string;
-}
-
-#define HASH_SIZE  16
-/*
- * Return a hashed string for a given input string.
- * The caller should free the return value.
-*/
-char *msHashString(const char *pszStr)
-{
-  unsigned char sums[HASH_SIZE] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
-  char *pszOutBuf = NULL;
-  size_t bufferSize = 0;
-  int i=0;
-
-  bufferSize = HASH_SIZE*2+1;
-  pszOutBuf = (char*)msSmallMalloc(bufferSize);
-
-  for(i=0; pszStr && pszStr[i]; i++) {
-    sums[i%HASH_SIZE] += (unsigned char)(pszStr[i]);
-  }
-
-  for(i=0; i<HASH_SIZE; i++) {
-    snprintf(pszOutBuf + i*2, bufferSize-(i*2), "%02x", sums[i]);
-  }
-
-  return pszOutBuf;
-}
-
-char *msCommifyString(char *str)
-{
-  int i, j, old_length, new_length;
-  int num_commas=0, num_decimal_points=0;
-  int add_commas;
-
-  char comma=',', decimal_point='.';
-
-  if(!str) return NULL;
-
-  num_decimal_points = msCountChars(str, decimal_point);
-  if(num_decimal_points > 1) return str;
-
-  old_length = strlen(str);
-  if(num_decimal_points == 0) {
-    num_commas =  floor((old_length - 1)/3);
-    add_commas=1; /* add commas right away */
-  } else {
-    num_commas = floor(((old_length - strlen(strchr(str, decimal_point))) - 1)/3);
-    add_commas=0; /* wait until after the decimal point */
-  }
-
-  if(num_commas < 1) return str; /* nothing to add */
-
-  new_length = old_length + num_commas;
-  str = (char *) msSmallRealloc(str, new_length+1);
-  str[new_length] = '\0';
-
-  j = 0;
-  for(i=new_length-1; i>=0; i--) { /* step backwards through the string */
-
-    if(num_decimal_points == 1 &&  add_commas == 0) { /* to the right of the decimal point, no commas */
-      str[i] = str[i-num_commas];
-      if(str[i] == decimal_point) add_commas = 1;
-    } else if(add_commas == 1 && j>2) { /* need a comma */
-      str[i] = comma;
-      num_commas--; /* need one fewer now */
-      j = 0; /* reset */
-    } else {
-      str[i] = str[i-num_commas]; /* shift to the right */
-      j++;
-    }
-
-    if(num_commas == 0) break; /* done, rest of string is ok "as is" */
-  }
-
-  return str;
-}
-
-
-/* ------------------------------------------------------------------------------- */
-/*       Replace all occurrences of old with new in str.                           */
-/*       It is assumed that str was dynamically created using malloc.              */
-/*       Same function as msReplaceSubstring but this is case insensitive          */
-/* ------------------------------------------------------------------------------- */
-char *msCaseReplaceSubstring(char *str, const char *old, const char *newstr)
-{
-  size_t str_len, old_len, new_len, tmp_offset;
-  char *tmp_ptr;
-
-  /*
-  ** If old is not found then leave str alone
-  */
-  if( (tmp_ptr = (char *) strcasestr(str, old)) == NULL)
-    return(str);
-  
-  if(newstr == NULL)
-    newstr = "";
-
-
-  /*
-  ** Grab some info about incoming strings
-  */
-  str_len = strlen(str);
-  old_len = strlen(old);
-  new_len = strlen(newstr);
-
-  /*
-  ** Now loop until old is NOT found in new
-  */
-  while( tmp_ptr != NULL ) {
-
-    /*
-    ** re-allocate memory for buf assuming 1 replacement of old with new
-          ** don't bother reallocating if old is larger than new)
-    */
-    if (old_len < new_len) {
-      tmp_offset = tmp_ptr - str;
-      str_len = str_len - old_len + new_len;
-      str = (char *)msSmallRealloc(str, (str_len + 1)); /* make new space for a copy */
-      tmp_ptr = str + tmp_offset;
-    }
-
-    /*
-    ** Move the trailing part of str to make some room unless old_len == new_len
-    */
-    if (old_len != new_len) {
-      memmove(tmp_ptr+new_len, tmp_ptr+old_len, strlen(tmp_ptr)-old_len+1);
-    }
-
-    /*
-    ** Now copy new over old
-    */
-    memcpy(tmp_ptr, newstr, new_len);
-
-    /*
-    ** And look for more matches in the rest of the string
-    */
-    tmp_ptr = (char *) strcasestr(tmp_ptr + new_len, old);
-  }
-
-  return(str);
-}
-
-/*
-** Converts a 2 character hexidecimal string to an integer.
-*/
-int msHexToInt(char *hex)
-{
-  int number;
-
-  number = (hex[0] >= 'A' ? ((hex[0] & 0xdf) - 'A')+10 : (hex[0] - '0'));
-  number *= 16;
-  number += (hex[1] >= 'A' ? ((hex[1] & 0xdf) - 'A')+10 : (hex[1] - '0'));
-
-  return(number);
-}
-
-
-/*
-** Use FRIBIDI to encode the string.
-** The return value must be freed by the caller.
-*/
-#ifdef USE_FRIBIDI
-char *msGetFriBidiEncodedString(const char *string, const char *encoding)
-{
-  FriBidiChar logical[MAX_STR_LEN];
-  FriBidiParType base;
-  size_t len;
-
-#ifdef FRIBIDI_NO_CHARSETS
-  iconv_t to_ucs4, from_ucs4;
-#else
-  FriBidiCharSet to_char_set_num;
-  FriBidiCharSet from_char_set_num;
-#endif
-
-  len = strlen(string);
-
-#ifdef FRIBIDI_NO_CHARSETS
-  to_ucs4 = iconv_open ("WCHAR_T", encoding);
-  from_ucs4 = iconv_open ("UTF-8", "WCHAR_T");
-#else
-  to_char_set_num = fribidi_parse_charset ((char*)encoding);
-  from_char_set_num = fribidi_parse_charset ("UTF-8");
-#endif
-
-#ifdef FRIBIDI_NO_CHARSETS
-  if (to_ucs4 == (iconv_t) (-1) || from_ucs4 == (iconv_t) (-1))
-#else
-  if (!to_char_set_num || !from_char_set_num)
-#endif
-  {
-    msSetError(MS_IDENTERR, "Encoding not supported (%s).",
-               "msGetFriBidiEncodedString()", encoding);
-    return NULL;
-  }
-
-#ifdef FRIBIDI_NO_CHARSETS
-  {
-    char *st = string, *ust = (char *) logical;
-    int in_len = (int) len;
-    len = sizeof logical;
-    iconv (to_ucs4, &st, &in_len, &ust, (int *) &len);
-    len = (FriBidiChar *) ust - logical;
-  }
-#else
-  len = fribidi_charset_to_unicode (to_char_set_num, (char*)string, len, logical);
-#endif
-
-  {
-    FriBidiChar *visual;
-    char outstring[MAX_STR_LEN];
-    FriBidiStrIndex *ltov, *vtol;
-    FriBidiLevel *levels;
-    FriBidiStrIndex new_len;
-    fribidi_boolean log2vis;
-
-    visual = (FriBidiChar *) msSmallMalloc (sizeof (FriBidiChar) * (len + 1));
-    ltov = NULL;
-    vtol = NULL;
-    levels = NULL;
-
-    // fribidi_log2vis() doesn't support multi-line paragraphs.
-    // See: https://lists.freedesktop.org/archives/fribidi/2008-January/000515.html
-    for( size_t i = 0; i < len; i++ )
-    {
-        if (logical[i] == '\n') {
-          msSetError(MS_IDENTERR,
-                     "Input string is a multi-line paragraph, which is not supported.",
-                     "msGetFriBidiEncodedString()");
-          msFree(visual);
-          return NULL;
-        }
-    }
-
-    /* Create a bidi string. */
-    log2vis = fribidi_log2vis (logical, len, &base,
-                               /* output */
-                               visual, ltov, vtol, levels);
-
-    if (!log2vis) {
-      msSetError(MS_IDENTERR, "Failed to create bidi string.",
-                 "msGetFriBidiEncodedString()");
-      msFree(visual);
-      return NULL;
-    }
-
-    /* Convert it to utf-8 for display. */
-#ifdef FRIBIDI_NO_CHARSETS
-    {
-      char *str = outstring, *ust = (char *) visual;
-      int in_len = len * sizeof visual[0];
-      new_len = sizeof outstring;
-      iconv (from_ucs4, &ust, &in_len, &str, (int *) &new_len);
-      *str = '\0';
-      new_len = str - outstring;
-    }
-#else
-    new_len =
-      fribidi_unicode_to_charset (from_char_set_num,
-                                  visual, len, outstring);
-
-    /* scan str and compress out FRIBIDI_CHAR_FILL UTF8 characters */
-
-    int j=0;
-    for (int i=0; i<new_len; i++, j++) {
-      if (outstring[i] == '\xef' && outstring[i+1] == '\xbb' && outstring[i+2] == '\xbf') {
-        i += 3;
-      }
-      if (i != j) {
-        outstring[j] = outstring[i];
-      }
-    }
-    outstring[j] = '\0';
-
-#endif
-
-    msFree(visual);
-    return msStrdup(outstring);
-  }
-}
-#endif
-
-/*
-** Simple charset converter. Converts string from specified encoding to UTF-8.
-** The return value must be freed by the caller.
-*/
-char *msGetEncodedString(const char *string, const char *encoding)
-{
-#ifdef USE_ICONV
-  iconv_t cd = NULL;
-  const char *inp;
-  char *outp, *out = NULL;
-  size_t len, bufsize, bufleft;
-  assert(encoding);
-
-#ifdef USE_FRIBIDI
-  msAcquireLock(TLOCK_FRIBIDI);
-  if(fribidi_parse_charset ((char*)encoding)) {
-    char *ret = msGetFriBidiEncodedString(string, encoding);
-    msReleaseLock(TLOCK_FRIBIDI);
-    return ret;
-  }
-  msReleaseLock(TLOCK_FRIBIDI);
-#endif
-  len = strlen(string);
-
-  if (len == 0 || strcasecmp(encoding, "UTF-8")==0)
-    return msStrdup(string);    /* Nothing to do: string already in UTF-8 */
-
-  cd = iconv_open("UTF-8", encoding);
-  if(cd == (iconv_t)-1) {
-    msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
-               "msGetEncodedString()", encoding);
-    return NULL;
-  }
-
-  bufsize = len * 6 + 1; /* Each UTF-8 char can be up to 6 bytes */
-  inp = string;
-  out = (char*) malloc(bufsize);
-  if(out == NULL) {
-    msSetError(MS_MEMERR, NULL, "msGetEncodedString()");
-    iconv_close(cd);
-    return NULL;
-  }
-  strlcpy(out, string, bufsize);
-  outp = out;
-
-  bufleft = bufsize;
-
-  while (len > 0) {
-    const size_t iconv_status = msIconv(cd, (char**)&inp, &len, &outp, &bufleft);
-    if(iconv_status == static_cast<size_t>(-1)) {
-      msFree(out);
-      iconv_close(cd);
-      return msStrdup(string);
-    }
-  }
-  out[bufsize - bufleft] = '\0';
-
-  iconv_close(cd);
-
-  return out;
-#else
-  if (*string == '\0' || (encoding && strcasecmp(encoding, "UTF-8")==0))
-    return msStrdup(string);    /* Nothing to do: string already in UTF-8 */
-
-  msSetError(MS_MISCERR, "Not implemeted since Iconv is not enabled.", "msGetEncodedString()");
-  return NULL;
-#endif
-}
-
-
-char* msConvertWideStringToUTF8 (const wchar_t* string, const char* encoding)
-{
-#ifdef USE_ICONV
-
-  char* output = NULL;
-  const char* errormessage = NULL;
-  iconv_t cd = NULL;
-  size_t nStr;
-  size_t nInSize;
-  size_t nOutSize;
-  size_t nBufferSize;
-
-  char* pszUTF8 = NULL;
-  const wchar_t* pwszWide = NULL;
-
-  if (string != NULL) {
-    nStr = wcslen (string);
-    nBufferSize = ((nStr * 6) + 1);
-    output = (char*) msSmallMalloc (nBufferSize);
-
-    if (nStr == 0) {
-      /* return an empty 8 byte string */
-      output[0] = '\0';
-      return output;
-    }
-
-    cd = iconv_open("UTF-8", encoding);
-
-    nOutSize = nBufferSize;
-    if ((iconv_t)-1 != cd) {
-      nInSize = sizeof (wchar_t)*nStr;
-      pszUTF8 = output;
-      pwszWide = string;
-      size_t iconv_status = msIconv(cd, (char **)&pwszWide, &nInSize, &pszUTF8, &nOutSize);
-      if ((size_t)-1 == iconv_status) {
-        switch (errno) {
-          case E2BIG:
-            errormessage = "There is not sufficient room in buffer";
-            break;
-          case EILSEQ:
-            errormessage = "An invalid multibyte sequence has been encountered in the input";
-            break;
-          case EINVAL:
-            errormessage = "An incomplete multibyte sequence has been encountered in the input";
-            break;
-          default:
-            errormessage = "Unknown";
-            break;
-        }
-        msSetError(MS_MISCERR, "Unable to convert string in encoding '%s' to UTF8 %s",
-                   "msConvertWideStringToUTF8()",
-                   encoding,errormessage);
-        iconv_close(cd);
-        msFree(output);
-        return NULL;
-      }
-      iconv_close(cd);
-    } else {
-      msSetError(MS_MISCERR, "Encoding not supported by libiconv (%s).",
-                 "msConvertWideStringToUTF8()",
-                 encoding);
-      msFree(output);
-      return NULL;
-    }
-
-  } else {
-    /* we were given a NULL wide string, nothing we can do here */
-    return NULL;
-  }
-
-  /* NULL-terminate the output string */
-  output[nBufferSize - nOutSize] = '\0';
-  return output;
-#else
-  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.", "msConvertWideStringToUTF8()");
-  return NULL;
-#endif
-}
-
-wchar_t* msConvertWideStringFromUTF8 (const char* string, const char* encoding)
-{
-#ifdef USE_ICONV
-  wchar_t* output = NULL;
-  const char* errormessage = NULL;
-  iconv_t cd = NULL;
-  size_t nStr;
-  size_t nInSize;
-  size_t nOutSize;
-  size_t nBufferSize;
-
-  const char* pszUTF8 = NULL;
-  wchar_t* pwszWide = NULL;
-
-  if (string != NULL) {
-    nStr = strlen (string);
-    nBufferSize = ((nStr * 6) + 1);
-    output = (wchar_t*) msSmallMalloc (nBufferSize);
-
-    if (nStr == 0) {
-      /* return an empty 8 byte string */
-      output[0] = '\0';
-      return output;
-    }
-
-    cd = iconv_open(encoding, "UTF-8");
-
-    nOutSize = nBufferSize;
-    if ((iconv_t)-1 != cd) {
-      nInSize = sizeof (char)*nStr;
-      pszUTF8 = string;
-      pwszWide = output;
-      size_t iconv_status = msIconv(cd, (char **)&pszUTF8, &nInSize, (char **)&pwszWide, &nOutSize);
-      if ((size_t)-1 == iconv_status) {
-        switch (errno) {
-          case E2BIG:
-            errormessage = "There is not sufficient room in buffer";
-            break;
-          case EILSEQ:
-            errormessage = "An invalid multibyte sequence has been encountered in the input";
-            break;
-          case EINVAL:
-            errormessage = "An incomplete multibyte sequence has been encountered in the input";
-            break;
-          default:
-            errormessage = "Unknown";
-            break;
-        }
-        msSetError(MS_MISCERR, "Unable to convert string in UTF8 to encoding '%s' %s",
-                   "msConvertWideStringFromUTF8()",
-                   encoding, errormessage);
-        iconv_close(cd);
-        msFree(output);
-        return NULL;
-      }
-      iconv_close(cd);
-    } else {
-      msSetError(MS_MISCERR, "Encoding not supported by libiconv (%s).",
-                 "msConvertWideStringFromUTF8()",
-                 encoding);
-      msFree(output);
-      return NULL;
-    }
-  } else {
-    /* we were given a NULL wide string, nothing we can do here */
-    return NULL;
-  }
-
-  /* NULL-terminate the output string */
-  if (nOutSize >= sizeof (wchar_t))
-    *((wchar_t *) pwszWide) = L'\0';
-
-  return output;
-#else
-  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.", "msConvertWideStringFromUTF8()");
-  return NULL;
-#endif
-}
-
-/*
-** Returns the next glyph in string and advances *in_ptr to the next
-** character.
-**
-** If out_string is not NULL then the character (bytes) is copied to this
-** buffer and null-terminated. out_string must be a pre-allocated buffer of
-** at least 11 bytes.
-**
-** The function returns the number of bytes in this glyph.
-**
-** This function treats 3 types of glyph encodings:
-*   - as an html entity, for example &#123; , &#x1af; , or &eacute;
-*   - as an utf8 encoded character
-*   - if utf8 decoding fails, as a raw character
-*
-** This function mimics the character decoding function used in gdft.c of
-* libGD. It is necessary to have the same behaviour, as input strings must be
-* split into the same glyphs as what gd does.
-**
-** In UTF-8, the number of leading 1 bits in the first byte specifies the
-** number of bytes in the entire sequence.
-** Source: http://www.cl.cam.ac.uk/~mgk25/unicode.html#utf-8
-**
-** U-00000000 U-0000007F: 0xxxxxxx
-** U-00000080 U-000007FF: 110xxxxx 10xxxxxx
-** U-00000800 U-0000FFFF: 1110xxxx 10xxxxxx 10xxxxxx
-** U-00010000 U-001FFFFF: 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
-** U-00200000 U-03FFFFFF: 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
-** U-04000000 U-7FFFFFFF: 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
-*/
-int msGetNextGlyph(const char **in_ptr, char *out_string)
-{
-  unsigned char in;
-  int numbytes=0;
-  unsigned int unicode;
-  int i;
-
-  in = (unsigned char)**in_ptr;
-
-  if (in == 0)
-    return -1;  /* Empty string */
-  if((numbytes=msGetUnicodeEntity(*in_ptr,&unicode))>0) {
-    if(out_string) {
-      for(i=0; i<numbytes; i++) {
-        out_string[i]=(*in_ptr)[i];
-      }
-      out_string[numbytes]='\0';
-    }
-    *in_ptr+=numbytes;
-    return numbytes;
-  }
-  if (in < 0xC0) {
-    /*
-    * Handles properly formed UTF-8 characters between
-    * 0x01 and 0x7F.  Also treats \0 and naked trail
-    * bytes 0x80 to 0xBF as valid characters representing
-    * themselves.
-    */
-    /*goto end of loop to return just the char*/
-  } else if (in < 0xE0) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]='\0';
-      }
-      *in_ptr+=2;
-      return 2; /*110xxxxx 10xxxxxx*/
-    }
-  } else if (in < 0xF0) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        *in_ptr+=numbytes;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]='\0';
-      }
-      *in_ptr+=3;
-      return 3;   /* 1110xxxx 10xxxxxx 10xxxxxx */
-    }
-  } else if (in < 0xF8) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80
-        && ((*in_ptr)[3]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]=(*in_ptr)[3];
-        out_string[4]='\0';
-      }
-      *in_ptr+=4;
-      return 4;   /* 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx */
-    }
-  } else if (in < 0xFC) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80
-        && ((*in_ptr)[3]& 0xC0) == 0x80 && ((*in_ptr)[4]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]=(*in_ptr)[3];
-        out_string[4]=(*in_ptr)[4];
-        out_string[5]='\0';
-      }
-      *in_ptr+=5;
-      return 5;   /* 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
-    }
-  } else if (in < 0xFE) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80
-        && ((*in_ptr)[3]& 0xC0) == 0x80 && ((*in_ptr)[4]& 0xC0) == 0x80
-        && ((*in_ptr)[5]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]=(*in_ptr)[3];
-        out_string[4]=(*in_ptr)[4];
-        out_string[5]=(*in_ptr)[5];
-        out_string[6]='\0';
-      }
-      *in_ptr+=6;
-      return 6;   /* 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
-    }
-  }
-
-  if (out_string) {
-    out_string[0]=in;
-    out_string[1] = '\0';   /* 0xxxxxxx */
-  }
-  (*in_ptr)++;
-  return 1;
-}
-
-/*
-** Returns the number of glyphs in string
-*/
-int msGetNumGlyphs(const char *in_ptr)
-{
-  int numchars=0;
-
-  while( msGetNextGlyph(&in_ptr, NULL) != -1 )
-    numchars++;
-
-  return numchars;
-}
-
-static int cmp_entities(const void *e1, const void *e2)
-{
-  struct mapentities_s *en1 = (struct mapentities_s *) e1;
-  struct mapentities_s *en2 = (struct mapentities_s *) e2;
-  return strcmp(en1->name, en2->name);
-}
-/*
- * this function tests if the string pointed by inptr represents
- * an HTML entity, in decimal form ( e.g. &#197;), in hexadecimal
- * form ( e.g. &#x6C34; ), or from html 4.0 spec ( e.g. &eacute; )
- * - returns returns 0 if the string doesn't represent such an entity.
- * - if the string does start with such entity,it returns the number of
- * bytes occupied by said entity, and stores the unicode value in *unicode
- */
-int msGetUnicodeEntity(const char *inptr, unsigned int *unicode)
-{
-  unsigned char *in = (unsigned char*)inptr;
-  int l,val=0;
-  if(*in=='&') {
-    in++;
-    if(*in=='#') {
-      in++;
-      if(*in=='x'||*in=='X') {
-        in++;
-        for(l=3; l<8; l++) {
-          char byte;
-          if(*in>='0'&&*in<='9')
-            byte = *in - '0';
-          else if(*in>='a'&&*in<='f')
-            byte = *in - 'a' + 10;
-          else if(*in>='A'&&*in<='F')
-            byte = *in - 'A' + 10;
-          else
-            break;
-          in++;
-          val = (val * 16) + byte;
-        }
-        if(*in==';' && l>3 ) {
-          *unicode=val;
-          return ++l;
-        }
-      } else {
-        for(l=2; l<8; l++) {
-          if(*in>='0'&&*in<='9') {
-            val = val*10+*in-'0';
-            in++;
-          } else
-            break;
-        }
-        if(*in==';' && l>2 ) {
-          *unicode=val;
-          return ++l;
-        }
-      }
-    } else {
-      char entity_name_buf[MAP_ENTITY_NAME_LENGTH_MAX+1];
-      char *p;
-      struct mapentities_s key;
-      key.name = p = entity_name_buf;
-      for (l = 1; l <=  MAP_ENTITY_NAME_LENGTH_MAX+1; l++) {
-        if (*in == '\0') /*end of string before possible entity: return*/
-          break;
-        if (*in == ';') { /*possible end of entity: do a lookup*/
-          *p++ = '\0';
-          const struct mapentities_s* res =
-            static_cast<const struct mapentities_s*>(bsearch(
-                &key,
-                mapentities,
-                MAP_NR_OF_ENTITIES,
-                sizeof(mapentities[0]), cmp_entities));
-          if (res) {
-            *unicode = res->value;
-            return ++l;
-          }
-          break; /*the string was of the form of an entity but didn't correspond to an existing one: return*/
-        }
-        *p++ = *in;
-        in++;
-      }
-    }
-  }
-  return 0;
-}
-
-/**
- * msStringIsInteger()
- *
- * determines whether a given string is an integer
- *
- * @param string the string to be tested
- *
- * @return MS_SUCCESS or MS_FAILURE
- */
-
-int msStringIsInteger(const char *string)
-{
-  int length, i;
-
-  length = strlen(string);
-
-  if (length == 0)
-    return MS_FAILURE;
-
-  for(i=0; i<length; i++) {
-    if (!isdigit(string[i]))
-      return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                             msStrdup()                               */
-/************************************************************************/
-
-/* Safe version of msStrdup(). This function is taken from gdal/cpl. */
-
-char *msStrdup(const char * pszString)
-{
-    size_t nStringLength; 
-    char *pszReturn;
-
-    if (pszString == NULL)
-        pszString = "";
-
-    nStringLength = strlen(pszString) + 1; /* null terminated byte */
-    pszReturn = static_cast<char*>(malloc(nStringLength));
-
-    if (pszReturn == NULL) {
-        fprintf(stderr, "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
-            (long)strlen(pszString));
-        exit(1);
-    }
-
-    memcpy(pszReturn, pszString, nStringLength);
-
-    return pszReturn;
-}
-
-
-/************************************************************************/
-/*                             msStringEscape()                         */
-/************************************************************************/
-
-/* Checks if a string contains single or double quotes and escape them.
-   NOTE: the user must free the returned char* if it is different than the
-   one passed in */
-
-char* msStringEscape( const char * pszString )
-{
-  char *string_tmp, *string_ptr;
-  int i,ncharstoescape=0;
-
-  if (pszString ==  NULL || strlen(pszString) == 0)
-    return msStrdup("");
-
-  for (i=0; pszString[i]; i++)
-    ncharstoescape += ((pszString[i] == '\"')||(pszString[i] == '\''));
-  
-  if(!ncharstoescape) {
-    return (char*)pszString;
-  }
-
-  string_tmp = (char*)msSmallMalloc(strlen(pszString)+ncharstoescape+1);
-  for (string_ptr=(char*)pszString,i=0; *string_ptr!='\0'; ++string_ptr,++i) {
-    if ( (*string_ptr == '\"') || (*string_ptr == '\'') ) {
-      string_tmp[i] = '\\';
-      ++i;
-    }
-    string_tmp[i] = *string_ptr;
-  }
-
-  string_tmp[i] = '\0';
-  return string_tmp;
-}
-
-std::string msStdStringEscape( const char * pszString )
-{
-  char* tmp = msStringEscape(pszString);
-  std::string ret(tmp);
-  if( tmp != pszString )
-      msFree(tmp);
-  return ret;
-}
-
-/************************************************************************/
-/*                             msStringInArray()                        */
-/************************************************************************/
-
-/* Check if a string is in a array */
-int msStringInArray( const char * pszString, char **array, int numelements)
-{
-  int i;
-  for (i=0; i<numelements; ++i) {
-    if (strcasecmp(pszString, array[i])==0)
-      return MS_TRUE;
-  }
-  return MS_FALSE;
-}
-
-bool msStringInArray( const char * pszString, const std::vector<std::string>& array)
-{
-  for( const auto& str: array ) {
-    if (strcasecmp(pszString, str.c_str())==0)
-      return true;
-  }
-  return false;
-}
-
-int msLayerEncodeShapeAttributes( layerObj *layer, shapeObj *shape) {
-
-#ifdef USE_ICONV
-  iconv_t cd = NULL;
-  const char *inp;
-  char *outp, *out = NULL;
-  size_t len, bufsize, bufleft;
-  int i;
-
-  if( !layer->encoding || !*layer->encoding || !strcasecmp(layer->encoding, "UTF-8"))
-    return MS_SUCCESS;
-
-  cd = iconv_open("UTF-8", layer->encoding);
-  if(cd == (iconv_t)-1) {
-    msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
-               "msGetEncodedString()", layer->encoding);
-    return MS_FAILURE;
-  }
-
-  for(i=0;i <shape->numvalues; i++) {
-    if(!shape->values[i] || (len = strlen(shape->values[i]))==0) {
-      continue;    /* Nothing to do */
-    }
-
-    bufsize = len * 6 + 1; /* Each UTF-8 char can be up to 6 bytes */
-    inp = shape->values[i];
-    out = (char*) msSmallMalloc(bufsize);
-
-    strlcpy(out, shape->values[i], bufsize);
-    outp = out;
-
-    bufleft = bufsize;
-
-    bool failedIconv = false;
-    while (len > 0) {
-      const size_t iconv_status = msIconv(cd, (char**)&inp, &len, &outp, &bufleft);
-      if(iconv_status == static_cast<size_t>(-1)) {
-        failedIconv = true;
-        break;
-      }
-    }
-    if( failedIconv ) {
-      msFree(out);
-      continue; /* silently ignore failed conversions */
-    }
-    out[bufsize - bufleft] = '\0';
-    msFree(shape->values[i]);
-    shape->values[i] = out;
-  }
-  iconv_close(cd);
-
-  return MS_SUCCESS;
-#else
-  if( !layer->encoding || !*layer->encoding || !strcasecmp(layer->encoding, "UTF-8"))
-    return MS_SUCCESS;
-  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.", "msGetEncodedString()");
-  return MS_FAILURE;
-#endif
-}
-
-/************************************************************************/
-/*                             msStringBuffer                           */
-/************************************************************************/
-
-struct msStringBuffer
-{
-    size_t alloc_size;
-    size_t length;
-    char  *str;
-};
-
-/************************************************************************/
-/*                         msStringBufferAlloc()                        */
-/************************************************************************/
-
-msStringBuffer* msStringBufferAlloc(void)
-{
-    return (msStringBuffer*)msSmallCalloc(sizeof(msStringBuffer), 1);
-}
-
-/************************************************************************/
-/*                         msStringBufferFree()                         */
-/************************************************************************/
-
-void msStringBufferFree(msStringBuffer* sb)
-{
-    if( sb )
-        msFree(sb->str);
-    msFree(sb);
-}
-
-/************************************************************************/
-/*                       msStringBufferGetString()                      */
-/************************************************************************/
-
-const char* msStringBufferGetString(msStringBuffer* sb)
-{
-    return sb->str;
-}
-
-/************************************************************************/
-/*                   msStringBufferReleaseStringAndFree()               */
-/************************************************************************/
-
-char* msStringBufferReleaseStringAndFree(msStringBuffer* sb)
-{
-    char* str = sb->str;
-    sb->str = NULL;
-    sb->alloc_size = 0;
-    sb->length = 0;
-    msStringBufferFree(sb);
-    return str;
-}
-
-/************************************************************************/
-/*                        msStringBufferAppend()                        */
-/************************************************************************/
-
-int msStringBufferAppend(msStringBuffer* sb, const char* pszAppendedString)
-{
-    size_t nAppendLen = strlen(pszAppendedString);
-    if( sb->length + nAppendLen >= sb->alloc_size )
-    {
-        size_t newAllocSize1 = sb->alloc_size + sb->alloc_size / 3;
-        size_t newAllocSize2 = sb->length + nAppendLen + 1;
-        size_t newAllocSize = MAX(newAllocSize1, newAllocSize2);
-        void* newStr = realloc(sb->str, newAllocSize);
-        if( newStr == NULL ) {
-            msSetError(MS_MEMERR, "Not enough memory", "msStringBufferAppend()");
-            return MS_FAILURE;
-        }
-        sb->alloc_size = newAllocSize;
-        sb->str = (char*) newStr;
-    }
-    memcpy(sb->str + sb->length, pszAppendedString, nAppendLen + 1);
-    sb->length += nAppendLen;
-    return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapsymbol.c 8.2.0~beta1-1~exp1/mapsymbol.c
--- 8.0.1-5/mapsymbol.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapsymbol.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1079 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  symbolObj related functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <stdarg.h> /* variable number of function arguments support */
-#include <time.h> /* since the parser handles time/date we need this */
-
-#include "mapserver.h"
-#include "mapfile.h"
-#include "mapcopy.h"
-#include "mapthread.h"
-#include "fontcache.h"
-#include "mapows.h"
-
-
-
-extern int msyylex(void); /* lexer globals */
-extern void msyyrestart(FILE *);
-extern double msyynumber;
-extern char *msyystring_buffer;
-extern int msyylineno;
-extern FILE *msyyin;
-
-extern int msyystate;
-
-void freeImageCache(struct imageCacheObj *ic)
-{
-  if(ic) {
-    freeImageCache(ic->next); /* free any children */
-    msFreeRasterBuffer(&(ic->img));
-    free(ic);
-  }
-  return;
-}
-
-/*
-** msSymbolGetDefaultSize()
-**
-** Return the default size of a symbol.
-** Note: The size of a symbol is the height. Everywhere in the code, the width
-** is adjusted to the size that becomes the height.
-** See mapgd.c // size ~ height in pixels
-*/
-double msSymbolGetDefaultSize(symbolObj *s)
-{
-  double size = 1;
-  if(s == NULL)
-    return 1;
-
-  switch(s->type) {
-    case(MS_SYMBOL_TRUETYPE):
-      break;
-    case(MS_SYMBOL_PIXMAP):
-      assert(s->pixmap_buffer != NULL);
-      if(s->pixmap_buffer == NULL) return 1; /* FIXME */
-      size = (double)s->pixmap_buffer->height;
-      break;
-    case(MS_SYMBOL_SVG):
-#if defined(USE_SVG_CAIRO) || defined (USE_RSVG)
-      assert(s->renderer_cache != NULL);
-      size = s->sizey;
-#endif
-      break;
-    default: /* vector and ellipses, scalable */
-      size = (s->sizey<=0)?s->sizex:s->sizey;
-      break;
-  }
-
-  if(size <= 0)
-    return 1;
-
-  return size;
-}
-
-void initSymbol(symbolObj *s)
-{
-  MS_REFCNT_INIT(s);
-  s->type = MS_SYMBOL_VECTOR;
-  s->transparent = MS_FALSE;
-  s->transparentcolor = 0;
-  s->sizex = 1;
-  s->sizey = 1;
-  s->filled = MS_FALSE;
-  s->numpoints=0;
-  s->renderer=NULL;
-  s->renderer_free_func = NULL;
-  s->renderer_cache = NULL;
-  s->pixmap_buffer=NULL;
-  s->imagepath = NULL;
-  s->name = NULL;
-  s->inmapfile = MS_FALSE;
-  s->font = NULL;
-  s->full_pixmap_path = NULL;
-  s->character = NULL;
-  s->anchorpoint_x = s->anchorpoint_y = 0.5;
-
-}
-
-int msFreeSymbol(symbolObj *s)
-{
-  if(!s) return MS_FAILURE;
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(s) ) {
-    return MS_FAILURE;
-  }
-
-  if(s->name) free(s->name);
-  if(s->renderer_free_func) {
-    s->renderer_free_func(s);
-  } else {
-    if(s->renderer!=NULL) {
-      s->renderer->freeSymbol(s);
-    }
-  }
-  if(s->pixmap_buffer) {
-    msFreeRasterBuffer(s->pixmap_buffer);
-    free(s->pixmap_buffer);
-  }
-
-
-  if(s->font) free(s->font);
-  msFree(s->full_pixmap_path);
-  if(s->imagepath) free(s->imagepath);
-  if(s->character) free(s->character);
-
-  return MS_SUCCESS;
-}
-
-int loadSymbol(symbolObj *s, char *symbolpath)
-{
-  int done=MS_FALSE;
-  char szPath[MS_MAXPATHLEN];
-
-  initSymbol(s);
-
-  for(;;) {
-    switch(msyylex()) {
-      case(ANCHORPOINT):
-	if(getDouble(&(s->anchorpoint_x), MS_NUM_CHECK_RANGE, 0, 1) == -1) {
-	  msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1", "loadSymbol()");
-          return -1;
-        }
-        if(getDouble(&(s->anchorpoint_y), MS_NUM_CHECK_RANGE, 0, 1) == -1) {        
-          msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1", "loadSymbol()");
-          return(-1);
-	}
-        break;
-
-      case(ANTIALIAS): /*ignore*/
-        msyylex();
-        break;
-      case(CHARACTER):
-        if(getString(&s->character) == MS_FAILURE) return(-1);
-        break;
-      case(END): /* do some error checking */
-        if((s->type == MS_SYMBOL_SVG) && (s->imagepath == NULL)) {
-          msSetError(MS_SYMERR, "Symbol of type SVG has no file path specified.", "loadSymbol()");
-          return(-1);
-        }
-        if((s->type == MS_SYMBOL_PIXMAP) && (s->full_pixmap_path == NULL)) {
-          msSetError(MS_SYMERR, "Symbol of type PIXMAP has no image data.", "loadSymbol()");
-          return(-1);
-        }
-        if(((s->type == MS_SYMBOL_ELLIPSE) || (s->type == MS_SYMBOL_VECTOR)) && (s->numpoints == 0)) {
-          msSetError(MS_SYMERR, "Symbol of type VECTOR or ELLIPSE has no point data.", "loadSymbol()");
-          return(-1);
-        }
-        if(s->type == MS_SYMBOL_VECTOR) {
-          double minx = s->points[0].x;
-          double miny = s->points[0].y;
-          /* should only negative points be shifted? (#4116)*/
-          int shiftpositive = ((s->anchorpoint_x!=0.5)||(s->anchorpoint_y!=0.5));
-          int i;
-          for(i=1; i<s->numpoints; i++) {
-            if(s->points[i].x != -99 && s->points[i].y != -99) {
-              if(s->points[i].x<minx) minx = s->points[i].x;
-              if(s->points[i].y<miny) miny = s->points[i].y;
-            }
-          }
-          if(minx<0 || miny<0 || (shiftpositive && (minx!=0 || miny!=0))) {
-            for(i=0; i<s->numpoints; i++) {
-              if(s->points[i].x != -99 && s->points[i].y != -99) {
-                s->points[i].x -= minx;
-                s->points[i].y -= miny;
-              }
-            }
-            s->sizex -= minx;
-            s->sizey -= miny;
-          }
-        }
-
-        return(0);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadSymbol()");
-        return(-1);
-        break;
-      case(FILLED):
-        if((s->filled = getSymbol(2,MS_TRUE,MS_FALSE)) == -1)
-          return(-1);
-        break;
-      case(FONT):
-        if(getString(&s->font) == MS_FAILURE) return(-1);
-        break;
-      case(IMAGE):
-        if(msyylex() != MS_STRING) { /* get image location from next token */
-          msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)", "loadSymbol()", msyystring_buffer, msyylineno);
-          return(-1);
-        }
-        msFree(s->full_pixmap_path);
-        s->full_pixmap_path = msStrdup(msBuildPath(szPath, symbolpath, msyystring_buffer));
-        /* Set imagepath */
-        msFree(s->imagepath);
-        s->imagepath = msStrdup(msyystring_buffer);
-        break;
-      case(NAME):
-        if(getString(&s->name) == MS_FAILURE) return(-1);
-        break;
-      case(POINTS):
-        done = MS_FALSE;
-        s->sizex = 0;
-        s->sizey = 0;
-        for(;;) {
-          switch(msyylex()) {
-            case(END):
-              done = MS_TRUE;
-              break;
-            case(MS_NUMBER):
-              if(s->numpoints == MS_MAXVECTORPOINTS) {
-                msSetError(MS_SYMERR, "POINT block contains too many points.", "loadSymbol()");
-		return(-1);
-	      }
-              s->points[s->numpoints].x = atof(msyystring_buffer); /* grab the x */
-              if(getDouble(&(s->points[s->numpoints].y), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1); /* grab the y */
-              if(s->points[s->numpoints].x!=-99) {
-                s->sizex = MS_MAX(s->sizex, s->points[s->numpoints].x);
-                s->sizey = MS_MAX(s->sizey, s->points[s->numpoints].y);
-              }
-              s->numpoints++;
-              break;
-            default:
-              msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)", "loadSymbol()", msyystring_buffer, msyylineno);
-              return(-1);
-          }
-
-          if(done == MS_TRUE)
-            break;
-        }
-        break;
-      case(TRANSPARENT):
-        s->transparent = MS_TRUE;
-        if(getInteger(&(s->transparentcolor), MS_NUM_CHECK_RANGE, 0, 255) == -1) return(-1);
-        break;
-      case(TYPE):
-        if((s->type = getSymbol(8,MS_SYMBOL_VECTOR,MS_SYMBOL_ELLIPSE,MS_SYMBOL_PIXMAP,MS_SYMBOL_SIMPLE,MS_TRUETYPE,MS_SYMBOL_HATCH,MS_SYMBOL_SVG)) == -1)
-          return(-1);
-        if(s->type == MS_TRUETYPE) /* TrueType keyword is valid several place in map files and symbol files, this simplifies the lexer */
-          s->type = MS_SYMBOL_TRUETYPE;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadSymbol()", msyystring_buffer, msyylineno);
-        return(-1);
-    } /* end switch */
-  } /* end for */
-  return done;
-}
-
-void writeSymbol(symbolObj *s, FILE *stream)
-{
-  int i;
-
-  msIO_fprintf(stream, "  SYMBOL\n");
-  if(s->name != NULL) msIO_fprintf(stream, "    NAME \"%s\"\n", s->name);
-
-  switch (s->type) {
-    case(MS_SYMBOL_HATCH):
-      msIO_fprintf(stream, "    TYPE HATCH\n");
-      break;
-    case(MS_SYMBOL_PIXMAP):
-      msIO_fprintf(stream, "    TYPE PIXMAP\n");
-      if(s->imagepath != NULL) msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
-      if(s->anchorpoint_y!=0.5 || s->anchorpoint_x!=0.5) {
-        msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x, s->anchorpoint_y);
-      }
-      msIO_fprintf(stream, "    TRANSPARENT %d\n", s->transparentcolor);
-      break;
-    case(MS_SYMBOL_TRUETYPE):
-      msIO_fprintf(stream, "    TYPE TRUETYPE\n");
-      if (s->character != NULL) msIO_fprintf(stream, "    CHARACTER \"%s\"\n", s->character);
-      if (s->font != NULL) msIO_fprintf(stream, "    FONT \"%s\"\n", s->font);
-      if(s->anchorpoint_y!=0.5 || s->anchorpoint_x!=0.5) {
-        msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x, s->anchorpoint_y);
-      }
-      break;
-    default:
-      if(s->type == MS_SYMBOL_ELLIPSE)
-        msIO_fprintf(stream, "    TYPE ELLIPSE\n");
-      else if(s->type == MS_SYMBOL_VECTOR)
-        msIO_fprintf(stream, "    TYPE VECTOR\n");
-      else if(s->type == MS_SYMBOL_SVG)
-        msIO_fprintf(stream, "    TYPE SVG\n");
-      else
-        msIO_fprintf(stream, "    TYPE SIMPLE\n");
-
-      if(s->filled == MS_TRUE) msIO_fprintf(stream, "    FILLED TRUE\n");
-      if(s->imagepath != NULL) msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
-      if(s->anchorpoint_y!=0.5 || s->anchorpoint_x!=0.5) {
-        msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x, s->anchorpoint_y);
-      }
-
-      /* POINTS */
-      if(s->numpoints != 0) {
-        msIO_fprintf(stream, "    POINTS\n");
-        for(i=0; i<s->numpoints; i++) {
-          msIO_fprintf(stream, "      %g %g\n", s->points[i].x, s->points[i].y);
-        }
-        msIO_fprintf(stream, "    END\n");
-      }
-      break;
-  }
-
-  msIO_fprintf(stream, "  END\n\n");
-}
-
-
-/*
-** Little helper function to allow us to build symbol files on-the-fly
-** from just a file name.
-**
-** Returns the symbol index or -1 if it could not be added.
-*/
-int msAddImageSymbol(symbolSetObj *symbolset, char *filename)
-{
-  char szPath[MS_MAXPATHLEN];
-  symbolObj *symbol=NULL;
-  char *extension=NULL;
-  int symbolidx;
-
-  if(!symbolset) {
-    msSetError(MS_SYMERR, "Symbol structure unallocated.", "msAddImageSymbol()");
-    return(-1);
-  }
-
-  if(!filename || strlen(filename) == 0) return(-1);
-
-  /* Allocate/init memory for new symbol if needed */
-  if (msGrowSymbolSet(symbolset) == NULL)
-    return -1;
-  symbolidx = symbolset->numsymbols;
-  symbolset->numsymbols++;
-  symbol = symbolset->symbol[symbolidx];
-
-  /* check if svg checking extension otherwise assume it's a pixmap */
-  extension = strrchr(filename, '.');
-  if (extension == NULL)
-    extension = "";
-  if (strncasecmp(extension, ".svg", 4) == 0) {
-    symbol->type = MS_SYMBOL_SVG;
-  } else {
-    symbol->type = MS_SYMBOL_PIXMAP;
-  }
-
-#ifdef USE_CURL
-  if (strncasecmp(filename, "http", 4) == 0) {
-    char *tmpfullfilename = NULL;
-    char *tmpfilename = NULL;
-    char *tmppath = NULL;
-    int status = 0;
-    char szPath[MS_MAXPATHLEN];
-    int bCheckLocalCache = MS_TRUE;
-
-    tmppath = msTmpPath(NULL, NULL, NULL);
-    if (tmppath) {
-      tmpfilename = msEncodeUrl(filename);
-      tmpfullfilename = msBuildPath(szPath, tmppath, tmpfilename);
-      if (tmpfullfilename) {
-        /*use the url for now as a caching mechanism*/
-        if (msHTTPGetFile(filename, tmpfullfilename, &status, -1, bCheckLocalCache, 0, 1024*1024 /* 1 MegaByte */) == MS_SUCCESS) {
-          symbol->imagepath = msStrdup(tmpfullfilename);
-          symbol->full_pixmap_path = msStrdup(tmpfullfilename);
-        } else {
-          unlink(tmpfullfilename); 
-          msFree(tmpfilename);
-          msFree(tmppath);
-          return -1;
-        }
-      }
-      msFree(tmpfilename);
-      msFree(tmppath);
-    }
-  }
-#endif
-  /*if the http did not work, allow it to be treated as a file*/
-  if (!symbol->full_pixmap_path) {
-    if(symbolset->map) {
-      symbol->full_pixmap_path = msStrdup(msBuildPath(szPath, symbolset->map->mappath, filename));
-    } else {
-      symbol->full_pixmap_path = msStrdup(msBuildPath(szPath, NULL, filename));
-    }
-    symbol->imagepath = msStrdup(filename);
-  }
-  symbol->name = msStrdup(filename);
-  return symbolidx;
-}
-
-int msFreeSymbolSet(symbolSetObj *symbolset)
-{
-  int i;
-
-  freeImageCache(symbolset->imagecache);
-  for(i=0; i<symbolset->numsymbols; i++) {
-    if (symbolset->symbol[i]!=NULL) {
-      if ( msFreeSymbol((symbolset->symbol[i])) == MS_SUCCESS ) {
-        msFree(symbolset->symbol[i]);
-        symbolset->symbol[i]=NULL;
-      }
-    }
-  }
-  msFree(symbolset->symbol);
-
-  /* no need to deal with fontset, it's a pointer */
-  return MS_SUCCESS;
-}
-
-void msInitSymbolSet(symbolSetObj *symbolset)
-{
-  symbolset->filename = NULL;
-
-  symbolset->imagecache = NULL;
-  symbolset->imagecachesize = 0; /* 0 symbols in the cache */
-
-  symbolset->fontset = NULL;
-  symbolset->map = NULL;
-
-  symbolset->numsymbols = 0;
-  symbolset->maxsymbols = 0;
-  symbolset->symbol = NULL;
-
-  /* Alloc symbol[] array and ensure there is at least 1 symbol:
-   * symbol 0 which is the default symbol with all default params.
-   */
-  symbolObj* symbol = msGrowSymbolSet(symbolset);
-  if (symbol == NULL)
-    return; /* alloc failed */
-  symbol->type = MS_SYMBOL_ELLIPSE;
-  symbol->filled = MS_TRUE;
-  symbol->numpoints = 1;
-  symbol->points[0].x = 1;
-  symbol->points[0].y = 1;
-
-  /* Just increment numsymbols to reserve symbol 0.
-   * initSymbol() has already been called
-   */
-  symbolset->numsymbols = 1;
-
-}
-
-
-/*
-** Ensure there is at least one free entry in the symbol array of this
-** symbolSetObj. Grow the allocated symbol[] array if necessary and
-** allocate a new symbol for symbol[numsymbols] if there is not already one
-** and call initSymbol() on it.
-**
-** This function is safe to use for the initial allocation of the symbol[]
-** array as well (i.e. when maxsymbols==0 and symbol==NULL)
-**
-** Returns a reference to the new symbolObj on success, NULL on error.
-*/
-symbolObj *msGrowSymbolSet( symbolSetObj *symbolset )
-{
-  /* Do we need to increase the size of symbol[] by MS_SYMBOL_ALLOCSIZE? */
-  if (symbolset->numsymbols == symbolset->maxsymbols) {
-    int i;
-    if (symbolset->maxsymbols == 0) {
-      /* Initial allocation of array */
-      symbolset->maxsymbols += MS_SYMBOL_ALLOCSIZE;
-      symbolset->numsymbols = 0;
-      symbolset->symbol = (symbolObj**)malloc(symbolset->maxsymbols*sizeof(symbolObj*));
-    } else {
-      /* realloc existing array */
-      symbolset->maxsymbols += MS_SYMBOL_ALLOCSIZE;
-      symbolset->symbol = (symbolObj**)realloc(symbolset->symbol,
-                          symbolset->maxsymbols*sizeof(symbolObj*));
-    }
-
-    if (symbolset->symbol == NULL) {
-      msSetError(MS_MEMERR, "Failed to allocate memory for symbol array.", "msGrowSymbolSet()");
-      return NULL;
-    }
-
-    for(i=symbolset->numsymbols; i<symbolset->maxsymbols; i++)
-      symbolset->symbol[i] = NULL;
-  }
-
-  if (symbolset->symbol[symbolset->numsymbols]==NULL) {
-    symbolset->symbol[symbolset->numsymbols]=(symbolObj*)malloc(sizeof(symbolObj));
-    if (symbolset->symbol[symbolset->numsymbols]==NULL) {
-      msSetError(MS_MEMERR, "Failed to allocate memory for a symbolObj", "msGrowSymbolSet()");
-      return NULL;
-    }
-  }
-
-  /* Always call initSymbol() even if we didn't allocate a new symbolObj
-   * Since it's possible to dynamically remove/reuse symbols */
-  initSymbol(symbolset->symbol[symbolset->numsymbols]);
-
-  return symbolset->symbol[symbolset->numsymbols];
-}
-
-
-
-/* ---------------------------------------------------------------------------
-   msLoadSymbolSet and loadSymbolSet
-
-   msLoadSymbolSet wraps calls to loadSymbolSet with mutex acquisition and
-   release.  It should be used everywhere outside the mapfile loading
-   phase of an application.  loadSymbolSet should only be used when a mutex
-   exists.  It does not check for existence of a mutex!
-
-   See bug 339 for more details -- SG.
-   ------------------------------------------------------------------------ */
-
-int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map)
-{
-  int retval = MS_FAILURE;
-
-  msAcquireLock( TLOCK_PARSER );
-  retval = loadSymbolSet( symbolset, map );
-  msReleaseLock( TLOCK_PARSER );
-
-  return retval;
-}
-
-int loadSymbolSet(symbolSetObj *symbolset, mapObj *map)
-{
-  int status=1;
-  char szPath[MS_MAXPATHLEN], *pszSymbolPath=NULL;
-
-  int foundSymbolSetToken=MS_FALSE;
-  int symbolSetLevel=0;
-  int token;
-
-  if(!symbolset) {
-    msSetError(MS_SYMERR, "Symbol structure unallocated.", "loadSymbolSet()");
-    return(-1);
-  }
-
-  symbolset->map = (mapObj *)map;
-
-  if(!symbolset->filename) return(0);
-
-  /*
-  ** Open the file
-  */
-  if((msyyin = fopen(msBuildPath(szPath, symbolset->map->mappath, symbolset->filename), "r")) == NULL) {
-    msSetError(MS_IOERR, "(%s)", "loadSymbolSet()", symbolset->filename);
-    return(-1);
-  }
-
-  pszSymbolPath = msGetPath(szPath);
-
-  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return comments */
-  msyylex(); /* sets things up, but doesn't process any tokens */
-
-  msyylineno = 0; /* reset line counter */
-  msyyrestart(msyyin); /* flush the scanner - there's a better way but this works for now */
-
-  /*
-  ** Read the symbol file
-  */
-  for(;;) {
-    token = msyylex();
-
-    if(!foundSymbolSetToken && token != SYMBOLSET) {
-      msSetError(MS_IDENTERR, "First token must be SYMBOLSET, this doesn't look like a symbol file.", "msLoadSymbolSet()");
-      status = -1;
-      break;
-    }
-
-    switch(token) {
-      case(END):
-        if (--symbolSetLevel < 0) {
-          msSetError(MS_IDENTERR, "END token found outside SYMBOLSET context. When nesting multiple SYMBOLSETs, make sure the SYMBOLSET/END pairs match.", "msLoadSymbolSet()");
-          status = -1;
-        }
-        break;
-      case(EOF):
-        status = 0;
-        break;
-      case(SYMBOL):
-        /* Allocate/init memory for new symbol if needed */
-        if (symbolSetLevel == 0) {
-          msSetError(MS_IDENTERR, "SYMBOL token found outside SYMBOLSET context. When nesting multiple SYMBOLSETs, make sure the SYMBOLSET/END pairs match.", "msLoadSymbolSet()");
-          status = -1;
-        } else if (msGrowSymbolSet(symbolset) == NULL) {
-          status = -1;
-        } else if((loadSymbol((symbolset->symbol[symbolset->numsymbols]), pszSymbolPath) == -1))
-          status = -1;
-        else
-          symbolset->numsymbols++;
-        break;
-      case(SYMBOLSET):
-        foundSymbolSetToken = MS_TRUE;
-        symbolSetLevel++;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadSymbolSet()", msyystring_buffer, msyylineno);
-        status = -1;
-    } /* end switch */
-
-    if(status != 1) break;
-  } /* end for */
-
-  fclose(msyyin);
-  msyyin = NULL;
-  free(pszSymbolPath);
-  return(status);
-}
-
-int msGetCharacterSize(mapObj *map, char* font, int size, char *character, rectObj *r) {
-  unsigned int unicode, codepoint;
-  glyph_element *glyph;
-  face_element *face = msGetFontFace(font, &map->fontset);
-  if(MS_UNLIKELY(!face)) return MS_FAILURE;
-  msUTF8ToUniChar(character, &unicode);
-  codepoint = msGetGlyphIndex(face,unicode);
-  glyph = msGetGlyphByIndex(face,size,codepoint);
-  if(MS_UNLIKELY(!glyph)) return MS_FAILURE;
-  r->minx = glyph->metrics.minx;
-  r->maxx = glyph->metrics.maxx;
-  r->miny = - glyph->metrics.maxy;
-  r->maxy = - glyph->metrics.miny;
-  return MS_SUCCESS;
-}
-
-/*
-** Returns the size, in pixels, of a marker symbol defined by a specific style and scalefactor. Used for annotation
-** layer collision avoidance. A marker is made up of a number of styles so the calling code must either do the looping
-** itself or call this function for the bottom style which should be the largest.
-*/
-int msGetMarkerSize(mapObj *map, styleObj *style, double *width, double *height, double scalefactor)
-{
-  int size;
-  symbolObj *symbol;
-  *width = *height = 0; /* set a starting value */
-
-  if(style->symbol > map->symbolset.numsymbols || style->symbol < 0) return(MS_FAILURE); /* no such symbol, 0 is OK */
-
-  if(style->symbol == 0) { /* single point */
-    *width = 1;
-    *height = 1;
-    return(MS_SUCCESS);
-  }
-
-  symbol = map->symbolset.symbol[style->symbol];
-  if (symbol->type == MS_SYMBOL_PIXMAP && !symbol->pixmap_buffer) {
-    if (MS_SUCCESS != msPreloadImageSymbol(MS_MAP_RENDERER(map), symbol))
-      return MS_FAILURE;
-  }
-  if(symbol->type == MS_SYMBOL_SVG && !symbol->renderer_cache) {
-#if defined(USE_SVG_CAIRO) || defined (USE_RSVG)
-    if(MS_SUCCESS != msPreloadSVGSymbol(symbol))
-      return MS_FAILURE;
-#else
-    msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msGetMarkerSize()");
-    return MS_FAILURE;
-#endif
-  }
-  if(style->size == -1) {
-    size = ( msSymbolGetDefaultSize(symbol) * scalefactor );
-  } else
-    size = (style->size*scalefactor);
-  size = MS_MAX(size, style->minsize);
-  size = MS_MIN(size, style->maxsize);
-
-  switch(symbol->type) {
-
-    case(MS_SYMBOL_TRUETYPE): {
-      rectObj gbounds;
-      if(MS_UNLIKELY(MS_FAILURE == msGetCharacterSize(map,symbol->font,size,symbol->character, &gbounds)))
-        return MS_FAILURE;
-
-      *width = MS_MAX(*width, (gbounds.maxx-gbounds.minx));
-      *height = MS_MAX(*height, (gbounds.maxy-gbounds.miny));
-    }
-
-      break;
-
-    case(MS_SYMBOL_PIXMAP):
-      if(size == 1) {
-        *width = MS_MAX(*width, symbol->pixmap_buffer->width);
-        *height = MS_MAX(*height, symbol->pixmap_buffer->height);
-      } else {
-        *width = MS_MAX(*width, (((double)size/(double)symbol->pixmap_buffer->height) * symbol->pixmap_buffer->width));
-        *height = MS_MAX(*height, size);
-      }
-      break;
-    default: /* vector and ellipses, scalable */
-      if(style->size > 0) {
-        *width = MS_MAX(*width, ((size/symbol->sizey) * symbol->sizex));
-        *height = MS_MAX(*height, size);
-      } else { /* use symbol defaults */
-        *width = MS_MAX(*width, symbol->sizex);
-        *height = MS_MAX(*height, symbol->sizey);
-      }
-      break;
-  }
-
-  return(MS_SUCCESS);
-}
-
-/*
- * Add a default new symbol. If the symbol name exists
- * return the id of the symbol.
- */
-int msAddNewSymbol(mapObj *map, char *name)
-{
-  int i = 0;
-
-  if (!map || !name)
-    return -1;
-
-  i = msGetSymbolIndex(&map->symbolset, name, MS_TRUE);
-  if (i >= 0)
-    return i;
-
-  /* Allocate memory for new symbol if needed */
-  if (msGrowSymbolSet(&(map->symbolset)) == NULL)
-    return -1;
-
-  i = map->symbolset.numsymbols;
-  map->symbolset.symbol[i]->name = msStrdup(name);
-
-  map->symbolset.numsymbols++;
-
-  return i;
-}
-
-/* msAppendSymbol and msRemoveSymbol are part of the work to resolve
- * MapServer bug 579.
- * http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=579 */
-
-
-int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol)
-{
-  /* Allocate memory for new symbol if needed */
-  if (msGrowSymbolSet(symbolset) == NULL)
-    return -1;
-
-  /* we need to free the symbolObj that was already allocated as we are
-   going to replace it with the provided symbolObj*. Not the most efficient
-   technique, but this function should be rarely called, and in any case only
-   by mapscript. Another option could be to use msCopySymbol(), in which case
-   the call to MS_REFCNT_INCR(symbol) should be removed.*/
-  if(symbolset->symbol[symbolset->numsymbols]) {
-    msFreeSymbol(symbolset->symbol[symbolset->numsymbols]);
-    msFree(symbolset->symbol[symbolset->numsymbols]);
-  }
-  symbolset->symbol[symbolset->numsymbols]=symbol;
-  MS_REFCNT_INCR(symbol);
-  return symbolset->numsymbols++;
-}
-
-
-symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int nSymbolIndex)
-{
-  int i;
-  symbolObj *symbol;
-  if (symbolset->numsymbols == 1) {
-    msSetError(MS_CHILDERR, "Cannot remove a symbolset's sole symbol", "removeSymbol()");
-    return NULL;
-  } else if (nSymbolIndex < 0 || nSymbolIndex >= symbolset->numsymbols) {
-    msSetError(MS_CHILDERR, "Cannot remove symbol, invalid nSymbolIndex %d", "removeSymbol()", nSymbolIndex);
-    return NULL;
-  } else {
-    symbol=symbolset->symbol[nSymbolIndex];
-    for (i=nSymbolIndex+1; i<symbolset->numsymbols; i++) {
-      symbolset->symbol[i-1] = symbolset->symbol[i];
-    }
-    symbolset->symbol[i-1]=NULL;
-    symbolset->numsymbols--;
-    MS_REFCNT_DECR(symbol);
-    /* update symbol references in the map */
-    if (symbolset->map) {
-        int l,c,s,lb;
-        layerObj *layer;
-        classObj *cl;
-        styleObj *style;
-        labelObj *label;
-        for (l = 0; l < symbolset->map->numlayers; l++) {
-            layer = GET_LAYER(symbolset->map, l);
-            for (c = 0; c < layer->numclasses; c++) {
-                cl = layer->class[c];
-                for (s = 0; s < cl->numstyles; s++) {
-                    style = cl->styles[s];
-                    if (style->symbol >= nSymbolIndex)
-                        --style->symbol;
-                }
-                for (lb = 0; lb < cl->numlabels; lb++) {
-                    label = cl->labels[lb];
-                    for (s = 0; s < label->numstyles; s++) {
-                        style = label->styles[s];
-                        if (style->symbol >= nSymbolIndex)
-                            --style->symbol;
-                    }
-                }
-            }
-        }
-        /* Update symbol references in labelcache */
-        for(c = 0; c < MS_MAX_LABEL_PRIORITY; c++) {
-            labelCacheSlotObj *cacheslot = &(symbolset->map->labelcache.slots[c]);
-            for(l = 0; l < cacheslot->numlabels; l++) {
-                labelCacheMemberObj *cachePtr = &(cacheslot->labels[l]);
-                for(lb = 0; lb < cachePtr->numtextsymbols; lb++) {
-                    label = cachePtr->textsymbols[lb]->label;
-                    for (s = 0; s < label->numstyles; s++) {
-                        style = label->styles[s];
-                        if (style->symbol >= nSymbolIndex)
-                            --style->symbol;
-                    }
-                }
-            }
-        }
-    }
-    return symbol;
-  }
-}
-
-int msSaveSymbolSetStream(symbolSetObj *symbolset, FILE *stream)
-{
-  int i;
-  if (!symbolset || !stream) {
-    msSetError(MS_SYMERR, "Cannot save symbolset.", "msSaveSymbolSetStream()");
-    return MS_FAILURE;
-  }
-  /* Don't ever write out the default symbol at index 0 */
-  for (i=1; i<symbolset->numsymbols; i++) {
-    if(!symbolset->symbol[i]->inmapfile) writeSymbol((symbolset->symbol[i]), stream);
-  }
-  return MS_SUCCESS;
-}
-
-int msSaveSymbolSet(symbolSetObj *symbolset, const char *filename)
-{
-  FILE *stream;
-  int retval;
-  if (!filename || strlen(filename) == 0) {
-    msSetError(MS_SYMERR, "Invalid filename.", "msSaveSymbolSet()");
-    return MS_FAILURE;
-  }
-  stream = fopen(filename, "w");
-  if (stream) {
-    fprintf(stream, "SYMBOLSET\n");
-    retval = msSaveSymbolSetStream(symbolset, stream);
-    fprintf(stream, "END\n");
-    fclose(stream);
-  } else {
-    msSetError(MS_SYMERR, "Could not write to %s", "msSaveSymbolSet()",
-               filename);
-    retval = MS_FAILURE;
-  }
-  return retval;
-}
-
-int msLoadImageSymbol(symbolObj *symbol, const char *filename)
-{
-  msFree(symbol->full_pixmap_path);
-  symbol->full_pixmap_path = msStrdup(filename);
-  return MS_SUCCESS;
-}
-
-int msPreloadImageSymbol(rendererVTableObj *renderer, symbolObj *symbol)
-{
-  if(symbol->pixmap_buffer && symbol->renderer == renderer)
-    return MS_SUCCESS;
-  if(symbol->pixmap_buffer) { /* other renderer was used, start again */
-    msFreeRasterBuffer(symbol->pixmap_buffer);
-  } else {
-    symbol->pixmap_buffer = (rasterBufferObj*)calloc(1,sizeof(rasterBufferObj));
-  }
-  if(MS_SUCCESS != renderer->loadImageFromFile(symbol->full_pixmap_path, symbol->pixmap_buffer)) {
-    /* Free pixmap_buffer already allocated */
-    free(symbol->pixmap_buffer);
-    symbol->pixmap_buffer = NULL;
-    return MS_FAILURE;
-  }
-  symbol->renderer = renderer;
-  symbol->sizex = symbol->pixmap_buffer->width;
-  symbol->sizey = symbol->pixmap_buffer->height;
-  return MS_SUCCESS;
-
-}
-
-/***********************************************************************
- * msCopySymbol()                                                      *
- *                                                                     *
- * Copy a symbolObj, using mapfile.c:initSymbol(), msCopyPoint()       *
- * gdImageCreate(), gdImageCopy()                                      *
- **********************************************************************/
-
-int msCopySymbol(symbolObj *dst, const symbolObj *src, mapObj *map)
-{
-  int i;
-
-  initSymbol(dst);
-
-  MS_COPYSTRING(dst->name, src->name);
-  MS_COPYSTELEM(type);
-  MS_COPYSTELEM(inmapfile);
-
-  /* map is a special case */
-  dst->map = map;
-
-  MS_COPYSTELEM(sizex);
-  MS_COPYSTELEM(sizey);
-  MS_COPYSTELEM(anchorpoint_x);
-  MS_COPYSTELEM(anchorpoint_y);
-
-  for (i=0; i < src->numpoints; i++) {
-    MS_COPYPOINT(&(dst->points[i]), &(src->points[i]));
-  }
-
-  MS_COPYSTELEM(numpoints);
-  MS_COPYSTELEM(filled);
-
-  MS_COPYSTRING(dst->imagepath, src->imagepath);
-  MS_COPYSTELEM(transparent);
-  MS_COPYSTELEM(transparentcolor);
-  MS_COPYSTRING(dst->character, src->character);
-  MS_COPYSTRING(dst->font, src->font);
-  MS_COPYSTRING(dst->full_pixmap_path,src->full_pixmap_path);
-
-  return(MS_SUCCESS);
-}
-
-/***********************************************************************
- * msCopySymbolSet()                                                   *
- *                                                                     *
- * Copy a symbolSetObj using msCopyFontSet(), msCopySymbol()           *
- **********************************************************************/
-
-int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src, mapObj *map)
-{
-  int i, return_value;
-
-  MS_COPYSTRING(dst->filename, src->filename);
-
-  dst->map = map;
-  dst->fontset = &(map->fontset);
-
-  /* Copy child symbols */
-  for (i = 0; i < src->numsymbols; i++) {
-    if (msGrowSymbolSet(dst) == NULL)
-      return MS_FAILURE;
-    return_value = msCopySymbol(dst->symbol[i], src->symbol[i], map);
-    if (return_value != MS_SUCCESS) {
-      msSetError(MS_MEMERR,"Failed to copy symbol.","msCopySymbolSet()");
-      return(MS_FAILURE);
-    }
-    dst->numsymbols++;
-  }
-
-  /* MS_COPYSTELEM(imagecachesize); */
-
-  /* I have a feeling that the code below is not quite right - Sean */
-  /*copyProperty(&(dst->imagecache), &(src->imagecache),
-               sizeof(struct imageCacheObj));
-   */
-
-  dst->imagecachesize = 0; /* since we are not copying the cache set the cache  to NUNLL and the size to 0 (bug 1521) */
-  dst->imagecache = NULL;
-
-  return(MS_SUCCESS);
-}
-
-static void get_bbox(pointObj *poiList, int numpoints, double *minx, double *miny, double *maxx, double *maxy)
-{
-  int j;
-
-  *minx = *maxx = poiList[0].x;
-  *miny = *maxy = poiList[0].y;
-  for(j=1; j<numpoints; j++) {
-    if ((poiList[j].x==-99.0) || (poiList[j].y==-99.0)) continue;
-    *minx = MS_MIN(*minx, poiList[j].x);
-    *maxx = MS_MAX(*maxx, poiList[j].x);
-    *miny = MS_MIN(*miny, poiList[j].y);
-    *maxy = MS_MAX(*maxy, poiList[j].y);
-  }
-
-  return;
-}
-
-/*
- ** msRotateSymbol - Clockwise rotation of a symbol definition. Contributed
- ** by MapMedia, with clean up by SDL. Currently only type VECTOR and PIXMAP
- ** symbols are handled.
- */
-symbolObj *msRotateVectorSymbol(symbolObj *symbol, double angle)
-{
-  double angle_rad=0.0;
-  double cos_a, sin_a;
-  double minx=0.0, miny=0.0, maxx=0.0, maxy=0.0;
-  symbolObj *newSymbol = NULL;
-  double dp_x, dp_y, xcor, ycor;
-  double TOL=0.00000000001;
-  int i;
-
-  /* assert(symbol->type == MS_SYMBOL_VECTOR); */
-
-  newSymbol = (symbolObj *) malloc(sizeof(symbolObj));
-  msCopySymbol(newSymbol, symbol, NULL); /* TODO: do we really want to do this for all symbol types? */
-
-  angle_rad = (MS_DEG_TO_RAD*angle);
-
-
-  sin_a = sin(angle_rad);
-  cos_a = cos(angle_rad);
-
-  dp_x = symbol->sizex * .5; /* get the shift vector at 0,0 */
-  dp_y = symbol->sizey * .5;
-
-  /* center at 0,0 and rotate; then move back */
-  for( i=0; i < symbol->numpoints; i++) {
-    /* don't rotate PENUP commands (TODO: should use a constant here) */
-    if ((symbol->points[i].x == -99.0) && (symbol->points[i].y == -99.0) ) {
-      newSymbol->points[i].x = -99.0;
-      newSymbol->points[i].y = -99.0;
-      continue;
-    }
-
-    newSymbol->points[i].x = dp_x + ((symbol->points[i].x-dp_x)*cos_a - (symbol->points[i].y-dp_y)*sin_a);
-    newSymbol->points[i].y = dp_y + ((symbol->points[i].x-dp_x)*sin_a + (symbol->points[i].y-dp_y)*cos_a);
-  }
-
-  /* get the new bbox of the symbol, because we need it to get the new dimensions of the new symbol */
-  get_bbox(newSymbol->points, newSymbol->numpoints, &minx, &miny, &maxx, &maxy);
-  if ( (fabs(minx)>TOL) || (fabs(miny)>TOL) ) {
-    xcor = minx*-1.0; /* symbols always start at 0,0 so get the shift vector */
-    ycor = miny*-1.0;
-    for( i=0; i < newSymbol->numpoints; i++) {
-      if ((newSymbol->points[i].x == -99.0) && (newSymbol->points[i].y == -99.0))
-        continue;
-      newSymbol->points[i].x = newSymbol->points[i].x + xcor;
-      newSymbol->points[i].y = newSymbol->points[i].y + ycor;
-    }
-
-    /* update the bbox to get the final dimension values for the symbol */
-    get_bbox(newSymbol->points, newSymbol->numpoints, &minx, &miny, &maxx, &maxy);
-  }
-
-  newSymbol->sizex = maxx;
-  newSymbol->sizey = maxy;
-  return newSymbol;
-}
diff -pruN 8.0.1-5/mapsymbol.h 8.2.0~beta1-1~exp1/mapsymbol.h
--- 8.0.1-5/mapsymbol.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapsymbol.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,218 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  symbolObj related declarations.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPSYMBOL_H
-#define MAPSYMBOL_H
-
-#include "mapserver-api.h"
-#include <assert.h>
-
-enum MS_SYMBOL_TYPE {MS_SYMBOL_SIMPLE=1000, MS_SYMBOL_VECTOR, MS_SYMBOL_ELLIPSE, MS_SYMBOL_PIXMAP, MS_SYMBOL_TRUETYPE, MS_SYMBOL_HATCH, MS_SYMBOL_SVG};
-
-#define MS_SYMBOL_ALLOCSIZE 64      /* number of symbolObj ptrs to allocate for a symbolset at once */
-#define MS_MAXVECTORPOINTS 100      /* shade, marker and line symbol parameters */
-#define MS_MAXPATTERNLENGTH 10
-
-#define MS_IMAGECACHESIZE 6
-
-/* COLOR OBJECT */
-typedef struct {
-#ifdef SWIG
-  %feature("docstring", "An object representing a color.") colorObj;
-  %feature("docstring", "Red component of color in range [0-255]") red;
-  %feature("docstring", "Green component of color in range [0-255]") green;
-  %feature("docstring", "Blue component of color in range [0-255]") blue;
-  %feature("docstring", "Alpha (opacity) component of color in range [0-255]") alpha;
-#endif /* SWIG */
-  int red;
-  int green;
-  int blue;
-  int alpha;
-} colorObj;
-
-#ifndef SWIG
-enum MS_RASTER_BUFFER_TYPE { MS_BUFFER_NONE=2000, MS_BUFFER_BYTE_RGBA, MS_BUFFER_BYTE_PALETTE };
-
-typedef struct {
-  unsigned char *pixels;
-  unsigned int pixel_step, row_step;
-  unsigned char *a,*r,*g,*b;
-} rgbaArrayObj;
-
-typedef struct {
-  unsigned char b,g,r,a;
-} rgbaPixel;
-
-typedef struct {
-  unsigned char r,g,b;
-} rgbPixel;
-
-
-typedef struct {
-  unsigned char *pixels; /*stores the actual pixel indexes*/
-  rgbaPixel *palette; /*rgba palette entries*/
-  unsigned int num_entries; /*number of palette entries*/
-  unsigned int scaling_maxval;
-} paletteArrayObj;
-
-typedef struct {
-  int type;
-  unsigned int width,height;
-  union {
-    rgbaArrayObj rgba;
-    paletteArrayObj palette;
-  } data;
-} rasterBufferObj;
-
-/* NOTE: RB_SET_PIXEL() will premultiply by alpha, inputs should not be
-         premultiplied */
-
-#define RB_SET_PIXEL(rb,x,y,red,green,blue,alpha) \
-    {  \
-        int _rb_off = (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;   \
-        if( !(rb)->data.rgba.a ) { \
-           (rb)->data.rgba.r[_rb_off] = red; \
-           (rb)->data.rgba.g[_rb_off] = green; \
-           (rb)->data.rgba.b[_rb_off] = blue; \
-        } else { \
-           double a = alpha/255.0; \
-           (rb)->data.rgba.r[_rb_off] = red * a; \
-           (rb)->data.rgba.g[_rb_off] = green * a; \
-           (rb)->data.rgba.b[_rb_off] = blue * a; \
-           (rb)->data.rgba.a[_rb_off] = alpha; \
-        } \
-    }
-
-/* This versions receives an input red/green/blue that is already
-   premultiplied with alpha */
-#define RB_SET_PIXEL_PM(rb,x,y,red,green,blue,alpha) \
-    {  \
-        int _rb_off = (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;   \
-        (rb)->data.rgba.r[_rb_off] = red; \
-        (rb)->data.rgba.g[_rb_off] = green; \
-        (rb)->data.rgba.b[_rb_off] = blue; \
-        if( rb->data.rgba.a ) { \
-           (rb)->data.rgba.a[_rb_off] = alpha; \
-        } \
-    }
-
-/* NOTE: RB_MIX_PIXEL() will premultiply by alpha, inputs should not be
-         premultiplied */
-
-#define RB_MIX_PIXEL(rb,x,y,red,green,blue,alpha) \
-    {  \
-        int _rb_off = (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;   \
-        \
-        msAlphaBlend(  red, green, blue, alpha, \
-                       (rb)->data.rgba.r + _rb_off, \
-                       (rb)->data.rgba.g + _rb_off, \
-                       (rb)->data.rgba.b + _rb_off, \
-                       ((rb)->data.rgba.a == NULL ) ? NULL : (rb)->data.rgba.a + _rb_off );  \
-    }
-
-
-
-struct imageCacheObj {
-  int symbol;
-  int size;
-  colorObj color;
-  colorObj outlinecolor;
-  colorObj backgroundcolor;
-  rasterBufferObj img;
-  struct imageCacheObj *next;
-};
-
-
-#endif /* SWIG */
-
-/**
-The :ref:`SYMBOL <symbol>` object
-*/
-struct symbolObj{
-
-    /*
-    ** MS_SYMBOL_PIXMAP options
-    */
-#ifndef SWIG
-    rendererVTableObj *renderer;
-    void(*renderer_free_func)(symbolObj *self);
-    rasterBufferObj *pixmap_buffer;
-    void *renderer_cache;
-    char *full_pixmap_path;
-
-    /*
-    ** Pointer to his map
-    */
-    struct mapObj *map;
-
-    pointObj points[MS_MAXVECTORPOINTS];
-
-#endif /* SWIG */
-
-#ifdef SWIG
-    %immutable;
-#endif /* SWIG */
-    int refcount; ///< Reference counter
-    int numpoints; ///< Number of points of a vector symbol
-    char *imagepath; ///< Path to pixmap file - see :ref:`IMAGE <mapfile-symbol-image>`
-
-#ifdef SWIG
-    %mutable;
-#endif /* SWIG */
-
-  char *name; ///< Symbol name - see :ref:`NAME <mapfile-symbol-name>`
-  int type; ///< See :ref:`TYPE <mapfile-symbol-type>`
-  int inmapfile; ///< Boolean value for writing - if set to :data:`TRUE`, the symbol will be saved inside the Mapfile. Added in MapServer 5.6.1
-
-  /*
-  ** MS_SYMBOL_VECTOR and MS_SYMBOL_ELLIPSE options
-  */
-  double sizex; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double sizey; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-
-  double minx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double miny; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double maxx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double maxy; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-
-  int filled; ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`FILLED <mapfile-symbol-filled>`
-  double anchorpoint_x; ///< See :ref:`ANCHORPOINT <mapfile-symbol-anchorpoint>`
-  double anchorpoint_y; ///< See :ref:`ANCHORPOINT <mapfile-symbol-anchorpoint>`
-
-  int transparent; ///< \**TODO** Remove
-  int transparentcolor; ///< \**TODO** Remove
-
-  /*
-  ** MS_SYMBOL_TRUETYPE options
-  */
-  char *character; ///< For TrueType symbols - see :ref:`CHARACTER <mapfile-symbol-character>`
-  char *font; ///< For TrueType symbols - see :ref:`FONT <mapfile-symbol-font>`
-} ;
-
-#endif /* MAPSYMBOL_H */
diff -pruN 8.0.1-5/maptclutf.c 8.2.0~beta1-1~exp1/maptclutf.c
--- 8.0.1-5/maptclutf.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptclutf.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,332 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of msUTF8ToUniChar()
- * Author:   Daniel Morissette, Thomas Bonfort
- *
- * Note:
- * The source code of Tcl_UtfToUniChar() was borrowed from tclUtf.c
- * from the Tcl/Tk project.
- *
- * Website: http://www.tcl.tk/software/tcltk/
- * Source download: http://prdownloads.sourceforge.net/tcl/tcl8.4.15-src.tar.gz
- *
- * See copyright and license terms below the standard MapServer license.
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- * Copyright (c) 1997-1998 Sun Microsystems, Inc.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/*
- * tclUtf.c --
- *
- * Routines for manipulating UTF-8 strings.
- *
- * Copyright (c) 1997-1998 Sun Microsystems, Inc.
- *
- * This software is copyrighted by the Regents of the University of
- * California, Sun Microsystems, Inc., Scriptics Corporation, ActiveState
- * Corporation and other parties.  The following terms apply to all files
- * associated with the software unless explicitly disclaimed in
- * individual files.
- *
- * The authors hereby grant permission to use, copy, modify, distribute,
- * and license this software and its documentation for any purpose, provided
- * that existing copyright notices are retained in all copies and that this
- * notice is included verbatim in any distributions. No written agreement,
- * license, or royalty fee is required for any of the authorized uses.
- * Modifications to this software may be copyrighted by their authors
- * and need not follow the licensing terms described here, provided that
- * the new terms are clearly indicated on the first page of each file where
- * they apply.
- *
- * IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
- * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
- * ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
- * DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- *
- * THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
- * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
- * IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
- * NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
- * MODIFICATIONS.
- *
- * GOVERNMENT USE: If you are acquiring this software on behalf of the
- * U.S. government, the Government shall have only "Restricted Rights"
- * in the software and related documentation as defined in the Federal
- * Acquisition Regulations (FARs) in Clause 52.227.19 (c) (2).  If you
- * are acquiring the software on behalf of the Department of Defense, the
- * software shall be classified as "Commercial Computer Software" and the
- * Government shall have only "Restricted Rights" as defined in Clause
- * 252.227-7013 (c) (1) of DFARs.  Notwithstanding the foregoing, the
- * authors grant the U.S. Government and others acting in its behalf
- * permission to use and distribute the software in accordance with the
- * terms specified in this license.
- */
-
-
-#include "mapserver.h"
-
-
-
-
-/* The source code of Tcl_UtfToUniChar() was borrowed from tclUtf.c
- * from the Tcl/Tk project:
- * Website:
- *   http://www.tcl.tk/software/tcltk/
- * Source download:
- *   http://prdownloads.sourceforge.net/tcl/tcl8.4.15-src.tar.gz
- * Original License info follows below.
- */
-
-/*
- * tclUtf.c --
- *
- *  Routines for manipulating UTF-8 strings.
- *
- * Copyright (c) 1997-1998 Sun Microsystems, Inc.
- *
- * See the file "license.terms" for information on usage and redistribution of
- * this file, and for a DISCLAIMER OF ALL WARRANTIES.
- *
- * Id: tclUtf.c,v 1.30.2.3 2005/09/07 14:35:56 dgp Exp
- */
-
-/******************* Tcl license.terms *********************
-
-This software is copyrighted by the Regents of the University of
-California, Sun Microsystems, Inc., Scriptics Corporation, ActiveState
-Corporation and other parties.  The following terms apply to all files
-associated with the software unless explicitly disclaimed in
-individual files.
-
-The authors hereby grant permission to use, copy, modify, distribute,
-and license this software and its documentation for any purpose, provided
-that existing copyright notices are retained in all copies and that this
-notice is included verbatim in any distributions. No written agreement,
-license, or royalty fee is required for any of the authorized uses.
-Modifications to this software may be copyrighted by their authors
-and need not follow the licensing terms described here, provided that
-the new terms are clearly indicated on the first page of each file where
-they apply.
-
-IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
-FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
-ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
-DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
-POSSIBILITY OF SUCH DAMAGE.
-
-THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
-INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
-FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
-IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
-NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
-MODIFICATIONS.
-
-GOVERNMENT USE: If you are acquiring this software on behalf of the
-U.S. government, the Government shall have only "Restricted Rights"
-in the software and related documentation as defined in the Federal
-Acquisition Regulations (FARs) in Clause 52.227.19 (c) (2).  If you
-are acquiring the software on behalf of the Department of Defense, the
-software shall be classified as "Commercial Computer Software" and the
-Government shall have only "Restricted Rights" as defined in Clause
-252.227-7013 (c) (1) of DFARs.  Notwithstanding the foregoing, the
-authors grant the U.S. Government and others acting in its behalf
-permission to use and distribute the software in accordance with the
-terms specified in this license.
-
-***********************************************************/
-
-
-#define TCL_UTF_MAX 6
-
-
-/*
- * The following structures are used when mapping between Unicode (UCS-2)
- * and UTF-8.
- */
-
-static const unsigned char totalBytes[256] = {
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
-  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
-#if TCL_UTF_MAX > 3
-  4,4,4,4,4,4,4,4,
-#else
-  1,1,1,1,1,1,1,1,
-#endif
-#if TCL_UTF_MAX > 4
-  5,5,5,5,
-#else
-  1,1,1,1,
-#endif
-#if TCL_UTF_MAX > 5
-  6,6,6,6
-#else
-  1,1,1,1
-#endif
-};
-
-/*
- *---------------------------------------------------------------------------
- *
- * Tcl_UtfToUniChar --
- *
- *  Extract the Tcl_UniChar represented by the UTF-8 string.  Bad
- *  UTF-8 sequences are converted to valid Tcl_UniChars and processing
- *  continues.  Equivalent to Plan 9 chartorune().
- *
- *  The caller must ensure that the source buffer is long enough that
- *  this routine does not run off the end and dereference non-existent
- *  memory looking for trail bytes.  If the source buffer is known to
- *  be '\0' terminated, this cannot happen.  Otherwise, the caller
- *  should call Tcl_UtfCharComplete() before calling this routine to
- *  ensure that enough bytes remain in the string.
- *
- * Results:
- *  *chPtr is filled with the Tcl_UniChar, and the return value is the
- *  number of bytes from the UTF-8 string that were consumed.
- *
- * Side effects:
- *  None.
- *
- *---------------------------------------------------------------------------
- */
-
-int ms_Tcl_UtfToUniChar(register const char *str, register unsigned int *chPtr)
-{
-  register int byte;
-
-
-  /*
-   * Unroll 1 to 3 byte UTF-8 sequences, use loop to handle longer ones.
-   */
-
-  byte = *((unsigned char *) str);
-  if (byte < 0xC0) {
-    /*
-     * Handles properly formed UTF-8 characters between 0x01 and 0x7F.
-     * Also treats \0 and naked trail bytes 0x80 to 0xBF as valid
-     * characters representing themselves.
-     */
-
-    *chPtr = byte;
-    return 1;
-  } else if (byte < 0xE0) {
-    if ((str[1] & 0xC0) == 0x80) {
-      /*
-       * Two-byte-character lead-byte followed by a trail-byte.
-       */
-
-      *chPtr = (((byte & 0x1F) << 6) | (str[1] & 0x3F));
-      return 2;
-    }
-    /*
-     * A two-byte-character lead-byte not followed by trail-byte
-     * represents itself.
-     */
-
-    *chPtr = byte;
-    return 1;
-  } else if (byte < 0xF0) {
-    if (((str[1] & 0xC0) == 0x80) && ((str[2] & 0xC0) == 0x80)) {
-      /*
-       * Three-byte-character lead byte followed by two trail bytes.
-       */
-
-      *chPtr = (((byte & 0x0F) << 12)
-                              | ((str[1] & 0x3F) << 6) | (str[2] & 0x3F));
-      return 3;
-    }
-    /*
-     * A three-byte-character lead-byte not followed by two trail-bytes
-     * represents itself.
-     */
-
-    *chPtr = byte;
-    return 1;
-  }
-#if TCL_UTF_MAX > 3
-  else {
-    int ch, total, trail;
-
-    total = totalBytes[byte];
-    trail = total - 1;
-    if (trail > 0) {
-      ch = byte & (0x3F >> trail);
-      do {
-        str++;
-        if ((*str & 0xC0) != 0x80) {
-          *chPtr = byte;
-          return 1;
-        }
-        ch <<= 6;
-        ch |= (*str & 0x3F);
-        trail--;
-      } while (trail > 0);
-      *chPtr = ch;
-      return total;
-    }
-  }
-#endif
-
-  *chPtr = byte;
-  return 1;
-}
-
-
-/* msUTF8ToUniChar()
- *
- *  Extract the Unicode Char represented by the UTF-8 string.  Bad
- *  UTF-8 sequences are converted to valid Unicode Chars and processing
- *  continues.
- *
- *  The caller must ensure that the source buffer is long enough that
- *  this routine does not run off the end and dereference non-existent
- *  memory looking for trail bytes.  If the source buffer is known to
- *  be '\0' terminated, this cannot happen.
- *
- * Results:
- *  *chPtr is filled with the Unicode Char value, and the return value
- *  is the number of bytes from the UTF-8 string that were consumed.
-**
-**/
-int msUTF8ToUniChar(const char *str, /* The UTF-8 string. */
-                    unsigned int *chPtr)      /* Filled with the Unicode Char represented
-                                      * by the UTF-8 string. */
-{
-  /*check if the string is an html entity (eg &#123; or &#x12a;)*/
-  int entitylgth;
-  if(*str == '&' && (entitylgth=msGetUnicodeEntity(str, chPtr))>0)
-    return entitylgth;
-  return ms_Tcl_UtfToUniChar(str, chPtr);
-}
-
-
diff -pruN 8.0.1-5/maptemplate.c 8.2.0~beta1-1~exp1/maptemplate.c
--- 8.0.1-5/maptemplate.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptemplate.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,4905 +0,0 @@
-/******************************************************************************
- * $id: maptemplate.c 7725 2008-06-21 15:56:58Z sdlime $
- *
- * Project:  MapServer
- * Purpose:  Various template processing functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2008 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#define NEED_IGNORE_RET_VAL
-
-#include "maptemplate.h"
-#include "maphash.h"
-#include "mapserver.h"
-#include "maptile.h"
-#include "mapows.h"
-
-#include "cpl_conv.h"
-
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <time.h>
-
-#include <assert.h>
-#include <ctype.h>
-
-
-static inline void IGUR_sizet(size_t ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
-static inline void IGUR_voidp(void* ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
-
-static const char *const olUrl = "//www.mapserver.org/lib/OpenLayers-ms60.js";
-static const char *const olTemplate = \
-                          "<html>\n"
-                          "<head>\n"
-                          "<meta content=\"text/html;charset=utf-8\" http-equiv=\"Content-Type\">\n"
-                          "  <title>MapServer Simple Viewer</title>\n"
-                          "    <script type=\"text/javascript\" src=\"[openlayers_js_url]\"></script>\n"
-                          "    <link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"//www.mapserver.org/_static/mapserver.ico\"/>\n"
-                          "    </head>\n"
-                          "    <body>\n"
-                          "      <div style=\"width:[mapwidth]; height:[mapheight]\" id=\"map\"></div>\n"
-                          "      <script defer=\"defer\" type=\"text/javascript\">\n"
-                          "        var map = new OpenLayers.Map('map',\n"
-                          "                                     {maxExtent: new OpenLayers.Bounds([minx],[miny],[maxx],[maxy]),\n"
-                          "                                      maxResolution: [cellsize]});\n"
-                          "        [openlayers_layer];\n"
-                          "        map.addLayer(mslayer);\n"
-                          "        map.zoomToMaxExtent();\n"
-                          "      </script>\n"
-                          "</body>\n"
-                          "</html>";
-
-static const char *const olLayerMapServerTag = \
-                                   "var mslayer = new OpenLayers.Layer.MapServer( \"MapServer Layer\",\n"
-                                   "                                              \"[mapserv_onlineresource]\",\n"
-                                   "                                              {layers: '[layers]'},\n"
-                                   "                                              {singleTile: \"true\", ratio:1} )";
-
-static const char *const olLayerWMSTag = \
-                             "var mslayer = new OpenLayers.Layer.WMS('MapServer Simple Viewer\',\n"
-                             "                                   '[mapserv_onlineresource]',\n"
-                             "                                   {layers: '[LAYERS]',\n"
-                             "                                   bbox: '[minx],[miny],[maxx],[maxy]',\n"
-                             "                                   width: [mapwidth], height: [mapheight], version: '[VERSION]', format:'[openlayers_format]'},"
-                             "                                   {singleTile: \"true\", ratio:1, projection: '[openlayers_projection]'});\n";
-
-static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream, int mode);
-
-static int isValidTemplate(FILE *stream, const char *filename)
-{
-  char buffer[MS_BUFFER_LENGTH];
-
-  if(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
-    if(!strcasestr(buffer, MS_TEMPLATE_MAGIC_STRING)) {
-      msSetError(MS_WEBERR, "Missing magic string, %s doesn't look like a MapServer template.", "isValidTemplate()", filename);
-      return MS_FALSE;
-    }
-  }
-
-  return MS_TRUE;
-}
-
-/*
- * Redirect to (only use in CGI)
- *
-*/
-int msRedirect(char *url)
-{
-  msIO_setHeader("Status","302 Found");
-  msIO_setHeader("Uri","%s",url);
-  msIO_setHeader("Location","%s",url);
-  msIO_setHeader("Content-Type","text/html");
-  msIO_sendHeaders();
-  return MS_SUCCESS;
-}
-
-/*
-** Sets the map extent under a variety of scenarios.
-*/
-int setExtent(mapservObj *mapserv)
-{
-  double cellx,celly,cellsize;
-
-  if(mapserv->Mode == TILE) {
-    if(MS_SUCCESS != msTileSetExtent(mapserv)) {
-      return MS_FAILURE;
-    }
-  }
-  switch(mapserv->CoordSource) {
-    case FROMUSERBOX: /* user passed in a map extent */
-      break;
-    case FROMIMGBOX: /* fully interactive web, most likely with java front end */
-      cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
-      celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-      mapserv->map->extent.minx = MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
-      mapserv->map->extent.maxx = MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
-      mapserv->map->extent.maxy = MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy, celly); /* y's are flip flopped because img/map coordinate systems are */
-      mapserv->map->extent.miny = MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
-      break;
-    case FROMIMGPNT:
-      cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
-      celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-      mapserv->mappnt.x = MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
-      mapserv->mappnt.y = MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
-
-      mapserv->map->extent.minx = mapserv->mappnt.x - .5*((mapserv->ImgExt.maxx - mapserv->ImgExt.minx)/mapserv->fZoom); /* create an extent around that point */
-      mapserv->map->extent.miny = mapserv->mappnt.y - .5*((mapserv->ImgExt.maxy - mapserv->ImgExt.miny)/mapserv->fZoom);
-      mapserv->map->extent.maxx = mapserv->mappnt.x + .5*((mapserv->ImgExt.maxx - mapserv->ImgExt.minx)/mapserv->fZoom);
-      mapserv->map->extent.maxy = mapserv->mappnt.y + .5*((mapserv->ImgExt.maxy - mapserv->ImgExt.miny)/mapserv->fZoom);
-      break;
-    case FROMREFPNT:
-      cellx = MS_CELLSIZE(mapserv->map->reference.extent.minx, mapserv->map->reference.extent.maxx, mapserv->map->reference.width);
-      celly = MS_CELLSIZE(mapserv->map->reference.extent.miny, mapserv->map->reference.extent.maxy, mapserv->map->reference.height);
-      mapserv->mappnt.x = MS_IMAGE2MAP_X(mapserv->RefPnt.x, mapserv->map->reference.extent.minx, cellx);
-      mapserv->mappnt.y = MS_IMAGE2MAP_Y(mapserv->RefPnt.y, mapserv->map->reference.extent.maxy, celly);
-
-      mapserv->map->extent.minx = mapserv->mappnt.x - .5*(mapserv->ImgExt.maxx - mapserv->ImgExt.minx); /* create an extent around that point */
-      mapserv->map->extent.miny = mapserv->mappnt.y - .5*(mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
-      mapserv->map->extent.maxx = mapserv->mappnt.x + .5*(mapserv->ImgExt.maxx - mapserv->ImgExt.minx);
-      mapserv->map->extent.maxy = mapserv->mappnt.y + .5*(mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
-      break;
-    case FROMBUF:
-      mapserv->map->extent.minx = mapserv->mappnt.x - mapserv->Buffer; /* create an extent around that point, using the buffer */
-      mapserv->map->extent.miny = mapserv->mappnt.y - mapserv->Buffer;
-      mapserv->map->extent.maxx = mapserv->mappnt.x + mapserv->Buffer;
-      mapserv->map->extent.maxy = mapserv->mappnt.y + mapserv->Buffer;
-      break;
-    case FROMSCALE:
-      cellsize = (mapserv->ScaleDenom/mapserv->map->resolution)/msInchesPerUnit(mapserv->map->units,0); /* user supplied a point and a scale denominator */
-      mapserv->map->extent.minx = mapserv->mappnt.x - cellsize*(mapserv->map->width-1)/2.0;
-      mapserv->map->extent.miny = mapserv->mappnt.y - cellsize*(mapserv->map->height-1)/2.0;
-      mapserv->map->extent.maxx = mapserv->mappnt.x + cellsize*(mapserv->map->width-1)/2.0;
-      mapserv->map->extent.maxy = mapserv->mappnt.y + cellsize*(mapserv->map->height-1)/2.0;
-      break;
-    default: /* use the default in the mapfile if it exists */
-      if((mapserv->map->extent.minx == mapserv->map->extent.maxx) && (mapserv->map->extent.miny == mapserv->map->extent.maxy)) {
-        msSetError(MS_WEBERR, "No way to generate map extent.", "mapserv()");
-        return MS_FAILURE;
-      }
-  }
-
-  mapserv->RawExt = mapserv->map->extent; /* save unaltered extent */
-
-  return MS_SUCCESS;
-}
-
-int checkWebScale(mapservObj *mapserv)
-{
-  int status;
-  rectObj work_extent = mapserv->map->extent;
-
-  mapserv->map->cellsize = msAdjustExtent(&(work_extent), mapserv->map->width, mapserv->map->height); /* we do this cause we need a scale */
-  if((status = msCalculateScale(work_extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom)) != MS_SUCCESS) return status;
-
-  if((mapserv->map->scaledenom < mapserv->map->web.minscaledenom) && (mapserv->map->web.minscaledenom > 0)) {
-    if(mapserv->map->web.mintemplate) { /* use the template provided */
-      if(TEMPLATE_TYPE(mapserv->map->web.mintemplate) == MS_FILE) {
-        if((status = msReturnPage(mapserv, mapserv->map->web.mintemplate, BROWSE, NULL)) != MS_SUCCESS) return status;
-      } else {
-        if((status = msReturnURL(mapserv, mapserv->map->web.mintemplate, BROWSE)) != MS_SUCCESS) return status;
-      }
-    } else { /* force zoom = 1 (i.e. pan) */
-      mapserv->fZoom = mapserv->Zoom = 1;
-      mapserv->ZoomDirection = 0;
-      mapserv->CoordSource = FROMSCALE;
-      mapserv->ScaleDenom = mapserv->map->web.minscaledenom;
-      mapserv->mappnt.x = (mapserv->map->extent.maxx + mapserv->map->extent.minx)/2; /* use center of bad extent */
-      mapserv->mappnt.y = (mapserv->map->extent.maxy + mapserv->map->extent.miny)/2;
-      setExtent(mapserv);
-      mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-      if((status = msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom)) != MS_SUCCESS) return status;
-    }
-  } else {
-    if((mapserv->map->scaledenom > mapserv->map->web.maxscaledenom) && (mapserv->map->web.maxscaledenom > 0)) {
-      if(mapserv->map->web.maxtemplate) { /* use the template provided */
-        if(TEMPLATE_TYPE(mapserv->map->web.maxtemplate) == MS_FILE) {
-          if((status = msReturnPage(mapserv, mapserv->map->web.maxtemplate, BROWSE, NULL)) != MS_SUCCESS) return status;
-        } else {
-          if((status = msReturnURL(mapserv, mapserv->map->web.maxtemplate, BROWSE)) != MS_SUCCESS) return status;
-        }
-      } else { /* force zoom = 1 (i.e. pan) */
-        mapserv->fZoom = mapserv->Zoom = 1;
-        mapserv->ZoomDirection = 0;
-        mapserv->CoordSource = FROMSCALE;
-        mapserv->ScaleDenom = mapserv->map->web.maxscaledenom;
-        mapserv->mappnt.x = (mapserv->map->extent.maxx + mapserv->map->extent.minx)/2; /* use center of bad extent */
-        mapserv->mappnt.y = (mapserv->map->extent.maxy + mapserv->map->extent.miny)/2;
-        setExtent(mapserv);
-        mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-        if((status = msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom)) != MS_SUCCESS) return status;
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-int msReturnTemplateQuery(mapservObj *mapserv, char *queryFormat, char **papszBuffer)
-{
-  imageObj *img = NULL;
-  int i, status;
-
-  outputFormatObj *outputFormat=NULL;
-  mapObj *map = mapserv->map;
-
-  if(!queryFormat) {
-    msSetError(MS_WEBERR, "Return format/mime-type not specified.", "msReturnTemplateQuery()");
-    return MS_FAILURE;
-  }
-
-  msApplyDefaultOutputFormats(map);
-
-  i = msGetOutputFormatIndex(map, queryFormat); /* queryFormat can be a mime-type or name */
-  if(i >= 0) outputFormat = map->outputformatlist[i];
-
-  if(outputFormat) {
-    if( MS_RENDERER_PLUGIN(outputFormat) ) {
-      msInitializeRendererVTable(outputFormat);
-    }
-    if( MS_RENDERER_OGR(outputFormat) ) {
-      checkWebScale(mapserv);
-
-      status = msOGRWriteFromQuery(map, outputFormat, mapserv->sendheaders);
-
-      return status;
-    }
-
-    if( !MS_RENDERER_TEMPLATE(outputFormat) ) { /* got an image format, return the query results that way */
-      outputFormatObj *tempOutputFormat = map->outputformat; /* save format */
-
-      checkWebScale(mapserv);
-
-      map->outputformat = outputFormat; /* override what was given for IMAGETYPE */
-      img = msDrawMap(map, MS_TRUE);
-      if(!img) return MS_FAILURE;
-      map->outputformat = tempOutputFormat; /* restore format */
-
-      if(mapserv->sendheaders) {
-        msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(outputFormat));
-        msIO_sendHeaders();
-      }
-      status = msSaveImage(map, img, NULL);
-      msFreeImage(img);
-
-      return status;
-    }
-  }
-
-  /*
-  ** At this point we know we have a template of some sort, either the new style that references a or the old
-  ** style made up of external files slammed together. Either way we may have to compute a query map and other
-  ** images. We only create support images IF the querymap has status=MS_ON.
-  */
-  if(map->querymap.status) {
-    checkWebScale(mapserv);
-    if(msGenerateImages(mapserv, MS_TRUE, MS_TRUE) != MS_SUCCESS)
-      return MS_FAILURE;
-  }
-
-  if(outputFormat) {
-    const char *file = msGetOutputFormatOption( outputFormat, "FILE", NULL );
-    if(!file) {
-      msSetError(MS_WEBERR, "Template driver requires \"FILE\" format option be set.", "msReturnTemplateQuery()");
-      return MS_FAILURE;
-    }
-
-    if(mapserv->sendheaders) {
-      const char *attachment = msGetOutputFormatOption( outputFormat, "ATTACHMENT", NULL );
-      if(attachment)
-        msIO_setHeader("Content-disposition","attachment; filename=%s", attachment);
-      msIO_setHeader("Content-Type", "%s", outputFormat->mimetype);
-      msIO_sendHeaders();
-    }
-    if((status = msReturnPage(mapserv, (char *) file, BROWSE, papszBuffer)) != MS_SUCCESS)
-      return status;
-  } else {
-    if((status = msReturnNestedTemplateQuery(mapserv, queryFormat, papszBuffer)) != MS_SUCCESS)
-      return status;
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Is a particular layer or group on, that is was it requested explicitly by the user.
-*/
-int isOn(mapservObj *mapserv, char *name, char *group)
-{
-  int i;
-
-  for(i=0; i<mapserv->NumLayers; i++) {
-    if(name && strcmp(mapserv->Layers[i], name) == 0)  return(MS_TRUE);
-    if(group && strcmp(mapserv->Layers[i], group) == 0) return(MS_TRUE);
-  }
-
-  return(MS_FALSE);
-}
-
-/************************************************************************/
-/*            int sortLayerByOrder(mapObj *map, char* pszOrder)         */
-/*                                                                      */
-/*      sorth the displaying in ascending or descending order.          */
-/************************************************************************/
-int sortLayerByOrder(mapObj *map, const char* pszOrder)
-{
-  int *panCurrentOrder = NULL;
-
-  if(!map) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "sortLayerByOrder()");
-    return MS_FAILURE;
-  }
-  /* ==================================================================== */
-  /*      The flag "ascending" is in fact not useful since the            */
-  /*      default ordering is ascending.                                  */
-  /* ==================================================================== */
-
-  /* -------------------------------------------------------------------- */
-  /*      the map->layerorder should be set at this point in the          */
-  /*      sortLayerByMetadata.                                            */
-  /* -------------------------------------------------------------------- */
-  if(map->layerorder) {
-    panCurrentOrder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-    for (int i=0; i<map->numlayers ; i++)
-      panCurrentOrder[i] = map->layerorder[i];
-
-    if(strcasecmp(pszOrder, "DESCENDING") == 0) {
-      for (int i=0; i<map->numlayers; i++)
-        map->layerorder[i] = panCurrentOrder[map->numlayers-1-i];
-    }
-
-    free(panCurrentOrder);
-  }
-
-  return MS_SUCCESS;
-}
-
-
-/*!
- * This function set the map->layerorder
- * index order by the metadata collumn name
-*/
-static int sortLayerByMetadata(mapObj *map, const char* pszMetadata)
-{
-  int nLegendOrder1;
-  int nLegendOrder2;
-  int i, j;
-  int tmp;
-
-  if(!map) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "sortLayerByMetadata()");
-    return MS_FAILURE;
-  }
-
-  /*
-   * Initiate to default order (Reverse mapfile order)
-   */
-  if(map->layerorder) {
-    int *pnLayerOrder;
-
-    /* Backup the original layer order to be able to reverse it */
-    pnLayerOrder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-    for (i=0; i<map->numlayers ; i++)
-      pnLayerOrder[i] = map->layerorder[i];
-
-    /* Get a new layerorder array */
-    free(map->layerorder);
-    map->layerorder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-
-    /* Reverse the layerorder array */
-    for (i=0; i<map->numlayers ; i++)
-      map->layerorder[i] = pnLayerOrder[map->numlayers - i - 1];
-
-    free(pnLayerOrder);
-  } else {
-    map->layerorder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-
-    for (i=0; i<map->numlayers ; i++)
-      map->layerorder[i] = map->numlayers - i - 1;
-  }
-
-  if(!pszMetadata)
-    return MS_SUCCESS;
-
-  /*
-   * Bubble sort algo (not very efficient)
-   * should implement a kind of quick sort
-   * alog instead
-  */
-  for (i=0; i<map->numlayers-1; i++) {
-    for (j=0; j<map->numlayers-1-i; j++) {
-      const char* pszLegendOrder1 = msLookupHashTable(&(GET_LAYER(map, map->layerorder[j+1])->metadata), pszMetadata);
-      const char* pszLegendOrder2 = msLookupHashTable(&(GET_LAYER(map, map->layerorder[j])->metadata), pszMetadata);
-
-      if(!pszLegendOrder1 || !pszLegendOrder2)
-        continue;
-
-      nLegendOrder1 = atoi(pszLegendOrder1);
-      nLegendOrder2 = atoi(pszLegendOrder2);
-
-      if(nLegendOrder1 < nLegendOrder2) {  /* compare the two neighbors */
-        tmp = map->layerorder[j];         /* swap a[j] and a[j+1]      */
-        map->layerorder[j] = map->layerorder[j+1];
-        map->layerorder[j+1] = tmp;
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** This function return a pointer
-** at the begining of the first occurence
-** of pszTag in pszInstr.
-**
-** Tag can be [TAG] or [TAG something]
-*/
-char *findTag(char *pszInstr, char *pszTag)
-{
-  char *pszTag1, *pszStart=NULL;
-  char *pszTemp;
-  int done=MS_FALSE;
-  int length;
-
-  if(!pszInstr || !pszTag) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "findTag()");
-    return NULL;
-  }
-
-  length = strlen(pszTag) + 1; /* adding [ character to the beginning */
-  pszTag1 = (char*) msSmallMalloc(length+1);
-
-  strcpy(pszTag1, "[");
-  strcat(pszTag1, pszTag);
-
-  pszTemp = pszInstr;
-  while(!done) {
-    pszStart = strstr(pszTemp, pszTag1);
-
-    if(pszStart == NULL)
-      done = MS_TRUE; /* tag not found */
-    else if((*(pszStart+length) == ']' || *(pszStart+length) == ' '))
-      done = MS_TRUE; /* valid tag */
-    else
-      pszTemp += length; /* skip ahead and start over */
-  }
-
-  free(pszTag1);
-
-  return pszStart;
-}
-
-/*
-** This function return a pointer
-** to the end of the tag in pszTag
-**
-** The end of a tag is the next
-** non-quoted ']' character.
-** Return NULL if not found.
-*/
-
-char *findTagEnd(const char *pszTag)
-{
-  char *pszEnd = NULL,
-        *pszTmp = (char*)pszTag;
-
-  while (pszTmp != NULL) {
-    if (*pszTmp == '"')
-      pszTmp = strchr(pszTmp+1,'"');
-    if ((pszTmp == NULL) || (*pszTmp == ']')) {
-      pszEnd = pszTmp;
-      pszTmp = NULL;
-    } else
-      pszTmp++;
-  }
-
-  return pszEnd;
-}
-
-/*
-** Return a hashtableobj from instr of all
-** arguments. hashtable must be freed by caller.
-*/
-int getTagArgs(char* pszTag, char* pszInstr, hashTableObj **ppoHashTable)
-{
-  char *pszStart, *pszEnd, *pszArgs;
-  int nLength;
-  char **papszArgs, **papszVarVal;
-  int nArgs, nDummy;
-  int i;
-
-  if(!pszTag || !pszInstr) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "getTagArgs()");
-    return MS_FAILURE;
-  }
-
-  /* set position to the begining of tag */
-  pszStart = findTag(pszInstr, pszTag);
-
-  if(pszStart) {
-    /* find ending position */
-    pszEnd = findTagEnd(pszStart);
-
-    if(pszEnd) {
-      /* skip the tag name */
-      pszStart = pszStart + strlen(pszTag) + 1;
-
-      /* get length of all args */
-      nLength = pszEnd - pszStart;
-
-      if(nLength > 0) { /* is there arguments ? */
-        pszArgs = (char*)msSmallMalloc(nLength + 1);
-        strlcpy(pszArgs, pszStart, nLength+1);
-
-        if(!(*ppoHashTable))
-          *ppoHashTable = msCreateHashTable();
-
-        /* put all arguments seperate by space in a hash table */
-        papszArgs = msStringTokenize(pszArgs, " ", &nArgs, MS_TRUE);
-
-        /* msReturnTemplateQuerycheck all argument if they have values */
-        for (i=0; i<nArgs; i++) {
-          if(strlen(papszArgs[i]) == 0) {
-            free(papszArgs[i]);
-            continue;
-          }
-
-          if(strchr(papszArgs[i], '=')) {
-            papszVarVal = msStringTokenize(papszArgs[i], "=", &nDummy, MS_FALSE);
-            msInsertHashTable(*ppoHashTable, papszVarVal[0],
-                              papszVarVal[1]);
-            free(papszVarVal[0]);
-            free(papszVarVal[1]);
-            free(papszVarVal);
-          } else /* no value specified. set it to 1 */
-            msInsertHashTable(*ppoHashTable, papszArgs[i], "1");
-
-          free(papszArgs[i]);
-        }
-        free(papszArgs);
-        free(pszArgs);
-      }
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Return a substring from instr between [tag] and [/tag]
-** char * returned must be freed by caller.
-** pszNextInstr will be a pointer at the end of the
-** first occurence found.
-*/
-int getInlineTag(char *pszTag, char *pszInstr, char **pszResult)
-{
-  char *pszStart, *pszEnd=NULL,  *pszEndTag, *pszPatIn, *pszPatOut=NULL, *pszTmp;
-  int nInst=0;
-  int nLength;
-
-  *pszResult = NULL;
-
-  if(!pszInstr || !pszTag) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "getInlineTag()");
-    return MS_FAILURE;
-  }
-
-  pszEndTag = (char*)msSmallMalloc(strlen(pszTag) + 3);
-  strcpy(pszEndTag, "[/");
-  strcat(pszEndTag, pszTag);
-
-  /* find start tag */
-  pszPatIn  = findTag(pszInstr, pszTag);
-  pszPatOut = strstr(pszInstr, pszEndTag);
-
-  pszStart = pszPatIn;
-
-  pszTmp = pszInstr;
-
-  if(pszPatIn) {
-    do {
-      if(pszPatIn && pszPatIn < pszPatOut) {
-        nInst++;
-
-        pszTmp = pszPatIn;
-      }
-
-      if(pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
-        pszEnd = pszPatOut;
-        nInst--;
-
-        pszTmp = pszPatOut;
-      }
-
-      pszPatIn  = findTag(pszTmp+1, pszTag);
-      pszPatOut = strstr(pszTmp+1, pszEndTag);
-
-    } while (pszTmp != NULL && nInst > 0);
-  }
-
-  if(pszStart && pszEnd) {
-    /* find end of start tag */
-    pszStart = strchr(pszStart, ']');
-
-    if(pszStart) {
-      pszStart++;
-
-      nLength = pszEnd - pszStart;
-
-      if(nLength > 0) {
-        *pszResult = (char*)msSmallMalloc(nLength + 1);
-
-        /* copy string beetween start and end tag */
-        strlcpy(*pszResult, pszStart, nLength+1);
-
-        (*pszResult)[nLength] = '\0';
-      }
-    } else {
-      msSetError(MS_WEBERR, "Malformed [%s] tag.", "getInlineTag()", pszTag);
-      return MS_FAILURE;
-    }
-  }
-
-  msFree(pszEndTag);
-
-  return MS_SUCCESS;
-}
-
-/*!
- * this function process all if tag in pszInstr.
- * this function return a modified pszInstr.
- * ht mus contain all variables needed by the function
- * to interpret if expression.
- *
- * If bLastPass is true then all tests for 'null' values will be
- * considered true if the corresponding value is not set.
-*/
-int processIfTag(char **pszInstr, hashTableObj *ht, int bLastPass)
-{
-  /*   char *pszNextInstr = pszInstr; */
-  char *pszStart, *pszEnd=NULL;
-  const char *pszName, *pszValue, *pszOperator, *pszHTValue;
-  char *pszThen=NULL;
-  char *pszIfTag;
-  char *pszPatIn=NULL, *pszPatOut=NULL, *pszTmp;
-  int nInst = 0;
-  int nLength;
-
-  hashTableObj *ifArgs=NULL;
-
-  if(!*pszInstr) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "processIfTag()");
-    return MS_FAILURE;
-  }
-
-  /* find the if start tag */
-
-  pszStart  = findTag(*pszInstr, "if");
-
-  while (pszStart) {
-    pszPatIn  = findTag(pszStart, "if");
-    pszPatOut = strstr(pszStart, "[/if]");
-    pszTmp = pszPatIn;
-
-    do {
-      if(pszPatIn && pszPatIn < pszPatOut) {
-        nInst++;
-        pszTmp = pszPatIn;
-      }
-
-      if(pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
-        pszEnd = pszPatOut;
-        nInst--;
-        pszTmp = pszPatOut;
-      }
-
-      pszPatIn  = findTag(pszTmp+1, "if");
-      pszPatOut = strstr(pszTmp+1, "[/if]");
-
-    } while (nInst > 0);
-
-    /* get the then string (if expression is true) */
-    if(getInlineTag("if", pszStart, &pszThen) != MS_SUCCESS) {
-      msSetError(MS_WEBERR, "Malformed then if tag.", "processIfTag()");
-      return MS_FAILURE;
-    }
-
-    /* retrieve if tag args */
-    if(getTagArgs("if", pszStart, &ifArgs) != MS_SUCCESS) {
-      msSetError(MS_WEBERR, "Malformed args if tag.", "processIfTag()");
-      return MS_FAILURE;
-    }
-
-    pszName = msLookupHashTable(ifArgs, "name");
-    pszValue = msLookupHashTable(ifArgs, "value");
-    pszOperator = msLookupHashTable(ifArgs, "oper");
-    if(pszOperator == NULL) /* Default operator if not set is "eq" */
-      pszOperator = "eq";
-
-    int bEmpty = 0;
-
-    if(pszName) {
-      /* build the complete if tag ([if all_args]then string[/if]) */
-      /* to replace if by then string if expression is true */
-      /* or by a white space if not. */
-      nLength = pszEnd - pszStart;
-      pszIfTag = (char*)msSmallMalloc(nLength + 6);
-      strlcpy(pszIfTag, pszStart, nLength+1);
-      pszIfTag[nLength] = '\0';
-      strcat(pszIfTag, "[/if]");
-
-      pszHTValue = msLookupHashTable(ht, pszName);
-
-      if(strcmp(pszOperator, "neq") == 0) {
-        if(pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) != 0) {
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
-        } else if(pszHTValue) {
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
-          bEmpty = 1;
-        }
-      } else if(strcmp(pszOperator, "eq") == 0) {
-        if(pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) == 0) {
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
-        } else if(pszHTValue) {
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
-          bEmpty = 1;
-        }
-      } else if(strcmp(pszOperator, "isnull") == 0) {
-        if(pszHTValue != NULL) {
-          /* We met a non-null value... condition is false */
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
-          bEmpty = 1;
-        } else if(bLastPass) {
-          /* On last pass, if value is still null then condition is true */
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
-        }
-      } else if(strcmp(pszOperator, "isset") == 0) {
-        if(pszHTValue != NULL) {
-          /* Found a non-null value... condition is true */
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
-        } else if(bLastPass) {
-          /* On last pass, if value still not set then condition is false */
-          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
-          bEmpty = 1;
-        }
-      } else {
-        msSetError(MS_WEBERR, "Unsupported operator (%s) in if tag.",  "processIfTag()", pszOperator);
-        return MS_FAILURE;
-      }
-
-      free(pszIfTag);
-      pszIfTag = NULL;
-    }
-
-    if(pszThen)
-      free (pszThen);
-
-    pszThen=NULL;
-
-    msFreeHashTable(ifArgs);
-    ifArgs=NULL;
-
-    /* find the if start tag */
-    if(bEmpty)
-      pszStart = findTag(pszStart, "if");
-    else
-      pszStart = findTag(pszStart + 1, "if");
-  }
-
-  return MS_SUCCESS;
-}
-
-/* Helper function to return the text before the supplied string2 in string1. */
-static char *getPreTagText(const char *string1, const char *string2)
-{
-  int n;
-  char *result, *tmpstr;
-
-  if((tmpstr = strstr(string1, string2)) == NULL) return msStrdup(""); /* return an empty string */
-
-  n = strlen(string1) - strlen(tmpstr);
-  result = (char *) msSmallMalloc(n + 1);
-  strlcpy(result, string1, n+1);
-
-  return result;
-}
-
-/* Helper function to retunr the text after the supplied string2 in string1. */
-static char *getPostTagText(const char *string1, const char *string2)
-{
-  char *tmpstr;
-
-  if((tmpstr = strstr(string1, string2)) == NULL) return msStrdup(""); /* return an empty string */
-
-  tmpstr += strlen(string2); /* skip string2 */
-  return msStrdup(tmpstr);
-}
-
-/*
-** Function to process a [feature ...] tag. This tag can *only* be found within
-** a [resultset ...][/resultset] block.
-*/
-static int processFeatureTag(mapservObj *mapserv, char **line, layerObj *layer)
-{
-  char *preTag, *postTag; /* text before and after the tag */
-
-  const char *argValue;
-  char *tag, *tagInstance, *tagStart;
-  hashTableObj *tagArgs=NULL;
-
-  int limit=-1;
-  const char *trimLast=NULL;
-
-  int i, j, status;
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processFeatureTag()");
-    return(MS_FAILURE);
-  }
-
-  tagStart = findTag(*line, "feature");
-  if(!tagStart) return(MS_SUCCESS); /* OK, just return; */
-
-  /* check for any tag arguments */
-  if(getTagArgs("feature", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-  if(tagArgs) {
-    argValue = msLookupHashTable(tagArgs, "limit");
-    if(argValue) limit = atoi(argValue);
-
-    argValue = msLookupHashTable(tagArgs, "trimlast");
-    if(argValue) trimLast = argValue;
-  }
-
-  if(strstr(*line, "[/feature]") == NULL) { /* we know the closing tag must be here, if not throw an error */
-    msSetError(MS_WEBERR, "[feature] tag found without closing [/feature].", "processFeatureTag()");
-    msFreeHashTable(tagArgs);
-    return(MS_FAILURE);
-  }
-
-  if(getInlineTag("feature", *line, &tag) != MS_SUCCESS) {
-    msSetError(MS_WEBERR, "Malformed feature tag.", "processFeatureTag()");
-    msFreeHashTable(tagArgs);
-    return MS_FAILURE;
-  }
-
-  preTag = getPreTagText(*line, "[feature");
-  postTag = getPostTagText(*line, "[/feature]");
-
-  /* start rebuilding **line */
-  free(*line);
-  *line = preTag;
-
-  /* we know the layer has query results or we wouldn't be in this code */
-
-#if 0
-  status = msLayerOpen(layer); /* open the layer */
-  if(status != MS_SUCCESS) return status;
-  status = msLayerGetItems(layer); /* retrieve all the item names */
-  if(status != MS_SUCCESS) return status;
-#endif
-
-  if(layer->numjoins > 0) { /* initialize necessary JOINs here */
-    for(j=0; j<layer->numjoins; j++) {
-      status = msJoinConnect(layer, &(layer->joins[j]));
-      if(status != MS_SUCCESS) {
-        msFreeHashTable(tagArgs);
-        msFree(postTag);
-        msFree(tag);
-        return status;
-      }
-    }
-  }
-
-  mapserv->LRN = 1; /* layer result counter */
-  mapserv->resultlayer = layer;
-  msInitShape(&(mapserv->resultshape));
-
-  if(limit == -1) /* return all */
-    limit = layer->resultcache->numresults;
-  else
-    limit = MS_MIN(limit, layer->resultcache->numresults);
-
-  for(i=0; i<limit; i++) {
-    status = msLayerGetShape(layer, &(mapserv->resultshape), &(layer->resultcache->results[i]));
-    if(status != MS_SUCCESS) {
-      msFreeHashTable(tagArgs);
-      msFree(postTag);
-      msFree(tag);
-      return status;
-    }
-
-    mapserv->resultshape.classindex = msShapeGetClass(layer, layer->map, &mapserv->resultshape,  NULL, -1);
-
-    /* prepare any necessary JOINs here (one-to-one only) */
-    if(layer->numjoins > 0) {
-      for(j=0; j<layer->numjoins; j++) {
-        if(layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
-          msJoinPrepare(&(layer->joins[j]), &(mapserv->resultshape));
-          msJoinNext(&(layer->joins[j])); /* fetch the first row */
-        }
-      }
-    }
-
-    /*
-    ** if necessary trim a few characters off the end of the tag
-    */
-    if(trimLast && (i == limit-1)) {
-      char *ptr;
-      if((ptr = strrstr(tag, trimLast)) != NULL)
-        *ptr = '\0';
-    }
-
-    /* process the tag */
-    tagInstance = processLine(mapserv, tag, NULL, QUERY); /* do substitutions */
-    *line = msStringConcatenate(*line, tagInstance); /* grow the line */
-
-    free(tagInstance);
-    msFreeShape(&(mapserv->resultshape)); /* init too */
-
-    mapserv->RN++; /* increment counters */
-    mapserv->LRN++;
-  }
-
-  /* msLayerClose(layer); */
-  mapserv->resultlayer = NULL; /* necessary? */
-
-  *line = msStringConcatenate(*line, postTag);
-
-  /*
-  ** clean up
-  */
-  free(postTag);
-  free(tag);
-  msFreeHashTable(tagArgs);
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Function to process a [resultset ...] tag.
-*/
-static int processResultSetTag(mapservObj *mapserv, char **line, FILE *stream)
-{
-  char lineBuffer[MS_BUFFER_LENGTH];
-  int foundTagEnd;
-
-  char *preTag, *postTag; /* text before and after the tag */
-
-  char *tag, *tagStart;
-  hashTableObj *tagArgs=NULL;
-
-  const char *layerName=NULL;
-  const char *nodata=NULL;
-
-  layerObj *lp;
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processResultSetTag()");
-    return(MS_FAILURE);
-  }
-
-  tagStart = findTag(*line, "resultset");
-  if(!tagStart) return(MS_SUCCESS); /* OK, just return; */
-
-  while (tagStart) {
-    /* initialize the tag arguments */
-    layerName = NULL;
-
-
-    /* check for any tag arguments */
-    if(getTagArgs("resultset", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
-      layerName = msLookupHashTable(tagArgs, "layer");
-      nodata = msLookupHashTable(tagArgs, "nodata");
-    }
-
-    if(!layerName) {
-      msSetError(MS_WEBERR, "[resultset] tag missing required 'layer' argument.", "processResultSetTag()");
-      msFreeHashTable(tagArgs);
-      return(MS_FAILURE);
-    }
-
-    const int layerIndex = msGetLayerIndex(mapserv->map, layerName);
-    if(layerIndex>=mapserv->map->numlayers || layerIndex<0) {
-      msSetError(MS_MISCERR, "Layer named '%s' does not exist.", "processResultSetTag()", layerName);
-      msFreeHashTable(tagArgs);
-      return MS_FAILURE;
-    }
-    lp = GET_LAYER(mapserv->map, layerIndex);
-
-    if(strstr(*line, "[/resultset]") == NULL) { /* read ahead */
-      if(!stream) {
-        msSetError(MS_WEBERR, "Invalid file pointer.", "processResultSetTag()");
-        msFreeHashTable(tagArgs);
-        return(MS_FAILURE);
-      }
-
-      foundTagEnd = MS_FALSE;
-      while(!foundTagEnd) {
-        if(fgets(lineBuffer, MS_BUFFER_LENGTH, stream) != NULL) {
-          *line = msStringConcatenate(*line, lineBuffer);
-          if(strstr(*line, "[/resultset]") != NULL)
-            foundTagEnd = MS_TRUE;
-        } else
-          break; /* ran out of file */
-      }
-      if(foundTagEnd == MS_FALSE) {
-        msSetError(MS_WEBERR, "[resultset] tag found without closing [/resultset].", "processResultSetTag()");
-        msFreeHashTable(tagArgs);
-        return(MS_FAILURE);
-      }
-    }
-
-    if(getInlineTag("resultset", *line, &tag) != MS_SUCCESS) {
-      msSetError(MS_WEBERR, "Malformed resultset tag.", "processResultSetTag()");
-      msFreeHashTable(tagArgs);
-      return MS_FAILURE;
-    }
-
-    preTag = getPreTagText(*line, "[resultset"); /* TODO: need to handle tags in these */
-    postTag = getPostTagText(*line, "[/resultset]");
-
-    /* start rebuilding **line */
-    free(*line);
-    *line = preTag;
-
-    if(lp->resultcache && lp->resultcache->numresults > 0) {
-      /* probably will need a while-loop here to handle multiple instances of [feature ...] tags */
-      if(processFeatureTag(mapserv, &tag, lp) != MS_SUCCESS) {
-        msFreeHashTable(tagArgs);
-        return(MS_FAILURE); /* TODO: how to handle */
-      }
-      *line = msStringConcatenate(*line, tag);
-    } else if(nodata) {
-      *line = msStringConcatenate(*line, nodata);
-    }
-
-    *line = msStringConcatenate(*line, postTag);
-
-    /* clean up */
-    free(postTag);
-    free(tag);
-
-    tagStart = findTag(*line, "resultset");
-  }
-  msFreeHashTable(tagArgs);
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Function process a [include src="..."] tag.
-**
-** TODO's:
-**   - allow URLs
-*/
-static int processIncludeTag(mapservObj *mapserv, char **line, FILE *stream, int mode)
-{
-  char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
-  int tagOffset, tagLength;
-
-  char *content=NULL, *processedContent=NULL;
-  const char *src=NULL;
-
-  FILE *includeStream;
-  char buffer[MS_BUFFER_LENGTH], path[MS_MAXPATHLEN];
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processIncludeTag()");
-    return(MS_FAILURE);
-  }
-
-  tagStart = findTag(*line, "include");
-
-  /* It is OK to have no include tags, just return. */
-  if( !tagStart ) return MS_SUCCESS;
-
-  while( tagStart ) {
-    tagOffset = tagStart - *line;
-
-    /* check for any tag arguments */
-    if(getTagArgs("include", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
-      src = msLookupHashTable(tagArgs, "src");
-    }
-
-    if(!src) return(MS_SUCCESS); /* don't process the tag, could be something else so return MS_SUCCESS */
-
-    if((includeStream = fopen(msBuildPath(path, mapserv->map->mappath, src), "r")) == NULL) {
-      msSetError(MS_IOERR, "%s", "processIncludeTag()", src);
-      return MS_FAILURE;
-    }
-
-    if(isValidTemplate(includeStream, src) != MS_TRUE) {
-      fclose(includeStream);
-      return MS_FAILURE;
-    }
-
-    while(fgets(buffer, MS_BUFFER_LENGTH, includeStream) != NULL)
-      content = msStringConcatenate(content, buffer);
-
-    /* done with included file handle */
-    fclose(includeStream);
-
-    /* find the end of the tag */
-    tagEnd = findTagEnd(tagStart);
-    tagEnd++;
-
-    /* build the complete tag so we can do substitution */
-    tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
-
-    /* process any other tags in the content */
-    processedContent = processLine(mapserv, content, stream, mode);
-
-    /* do the replacement */
-    *line = msReplaceSubstring(*line, tag, processedContent);
-
-    /* clean up */
-    free(tag);
-    tag = NULL;
-    msFreeHashTable(tagArgs);
-    tagArgs=NULL;
-    free(content);
-    free(processedContent);
-
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "include");
-    else
-      tagStart = NULL;
-  }
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Function to process an [item ...] tag: line contains the tag, shape holds the attributes.
-*/
-enum ITEM_ESCAPING {ESCAPE_HTML, ESCAPE_URL, ESCAPE_JSON, ESCAPE_NONE};
-
-static int processItemTag(layerObj *layer, char **line, shapeObj *shape)
-{
-  int i;
-
-  char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
-  int tagLength;
-  char *encodedTagValue=NULL, *tagValue=NULL;
-
-  const char *argValue=NULL;
-
-  const char *name=NULL, *pattern=NULL;
-  const char *format=NULL, *nullFormat=NULL;
-  int precision;
-  int padding;
-  int uc, lc, commify;
-  int escape;
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processItemTag()");
-    return(MS_FAILURE);
-  }
-
-  tagStart = findTag(*line, "item");
-
-  if(!tagStart) return(MS_SUCCESS); /* OK, just return; */
-
-  while (tagStart) {
-    format = "$value"; /* initialize the tag arguments */
-    nullFormat = "";
-    precision = -1;
-    padding = -1;
-    name = pattern = NULL;
-    uc = lc = commify = MS_FALSE;
-    escape=ESCAPE_HTML;
-
-    /* check for any tag arguments */
-    if(getTagArgs("item", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
-      argValue = msLookupHashTable(tagArgs, "name");
-      if(argValue) name = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "pattern");
-      if(argValue) pattern = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
-
-      argValue = msLookupHashTable(tagArgs, "padding");
-      if (argValue) padding = atoi(argValue);
-
-      argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "nullformat");
-      if(argValue) nullFormat = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "uc");
-      if(argValue && strcasecmp(argValue, "true") == 0) uc = MS_TRUE;
-
-      argValue = msLookupHashTable(tagArgs, "lc");
-      if(argValue && strcasecmp(argValue, "true") == 0) lc = MS_TRUE;
-
-      argValue = msLookupHashTable(tagArgs, "commify");
-      if(argValue && strcasecmp(argValue, "true") == 0) commify = MS_TRUE;
-
-      argValue = msLookupHashTable(tagArgs, "escape");
-      if(argValue && strcasecmp(argValue, "url") == 0) escape = ESCAPE_URL;
-      else if(argValue && strcasecmp(argValue, "none") == 0) escape = ESCAPE_NONE;
-      else if(argValue && strcasecmp(argValue, "json") == 0) escape = ESCAPE_JSON;
-
-      /* TODO: deal with sub strings */
-    }
-
-    if(!name) {
-      msSetError(MS_WEBERR, "Item tag contains no name attribute.", "processItemTag()");
-      return(MS_FAILURE);
-    }
-
-    for(i=0; i<layer->numitems; i++)
-      if(strcasecmp(name, layer->items[i]) == 0) break;
-
-    if(i == layer->numitems) {
-      msSetError(MS_WEBERR, "Item name (%s) not found in layer item list.", "processItemTag()", name);
-      return(MS_FAILURE);
-    }
-
-    /*
-    ** now we know which item so build the tagValue
-    */
-    if(shape->values[i] && strlen(shape->values[i]) > 0) {
-      char *itemValue=NULL;
-
-      /* set tag text depending on pattern (if necessary), nullFormat can contain $value (#3637) */
-      if(pattern && msEvalRegex(pattern, shape->values[i]) != MS_TRUE)
-        tagValue = msStrdup(nullFormat);
-      else
-        tagValue = msStrdup(format);
-
-      if(precision != -1) {
-        char numberFormat[16];
-
-        itemValue = (char *) msSmallMalloc(64); /* plenty big */
-        snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
-        snprintf(itemValue, 64, numberFormat, atof(shape->values[i]));
-      } else
-        itemValue = msStrdup(shape->values[i]);
-
-      if(commify == MS_TRUE)
-        itemValue = msCommifyString(itemValue);
-
-      /* apply other effects */
-      if(uc == MS_TRUE)
-        for(unsigned j=0; j<strlen(itemValue); j++) itemValue[j] = toupper(itemValue[j]);
-      if(lc == MS_TRUE)
-        for(unsigned j=0; j<strlen(itemValue); j++) itemValue[j] = tolower(itemValue[j]);
-
-      tagValue = msReplaceSubstring(tagValue, "$value", itemValue);
-      msFree(itemValue);
-
-      if (padding > 0 && padding < 1000) {
-          int paddedSize = strlen(tagValue) + padding + 1;
-          char *paddedValue = NULL;
-          paddedValue = (char *) msSmallMalloc(paddedSize);
-          snprintf(paddedValue, paddedSize, "%-*s", padding, tagValue);
-          msFree(tagValue);
-          tagValue = paddedValue;
-      }
-
-      if(!tagValue) {
-        msSetError(MS_WEBERR, "Error applying item format.", "processItemTag()");
-        return(MS_FAILURE); /* todo leaking... */
-      }
-    } else {
-      tagValue = msStrdup(nullFormat); /* attribute value is NULL or empty */
-    }
-
-    /* find the end of the tag */
-    tagEnd = findTagEnd(tagStart);
-    tagEnd++;
-
-    /* build the complete tag so we can do substitution */
-    tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
-
-    /* do the replacement */
-    switch(escape) {
-      case ESCAPE_HTML:
-        encodedTagValue = msEncodeHTMLEntities(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_JSON:
-        encodedTagValue = msEscapeJSonString(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_URL:
-        encodedTagValue = msEncodeUrl(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_NONE:
-        *line = msReplaceSubstring(*line, tag, tagValue);
-        break;
-      default:
-        break;
-    }
-
-    /* clean up */
-    free(tag);
-    tag = NULL;
-    msFreeHashTable(tagArgs);
-    tagArgs=NULL;
-    msFree(tagValue);
-    tagValue=NULL;
-    msFree(encodedTagValue);
-    encodedTagValue=NULL;
-
-    tagStart = findTag(*line, "item");
-  }
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Function process any number of MapServer extent tags (e.g. shpext, mapext, etc...).
-*/
-static int processExtentTag(mapservObj *mapserv, char **line, char *name, rectObj *extent, projectionObj *rectProj)
-{
-  char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
-  int tagOffset, tagLength;
-
-  char *encodedTagValue=NULL, *tagValue=NULL;
-
-  rectObj tempExtent;
-
-  char number[64]; /* holds a single number in the extent */
-  char numberFormat[16];
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processExtentTag()");
-    return(MS_FAILURE);
-  }
-
-  tagStart = findTag(*line, name); /* this supports any extent */
-
-  /* It is OK to have no include tags, just return. */
-  if(!tagStart) return MS_SUCCESS;
-
-  while(tagStart) {
-    double xExpand = 0, yExpand = 0; /* set tag argument defaults */
-    int precision = -1;
-    const char* format = "$minx $miny $maxx $maxy";
-    const char* projectionString = NULL;
-
-    /* hack to handle tags like 'mapext_esc' easily */
-    int escape;
-    if(strstr(name, "_esc"))
-      escape = ESCAPE_URL;
-    else
-      escape = ESCAPE_HTML;
-
-    tagOffset = tagStart - *line;
-
-    /* check for any tag arguments */
-    if(getTagArgs(name, tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
-      const char* argValue = msLookupHashTable(tagArgs, "expand");
-      if(argValue) {
-        if(strchr(argValue, '%') != NULL) {
-          float f;
-          sscanf(argValue, "%f%%", &f);
-          xExpand = ((f/100.0)*(extent->maxx-extent->minx))/2;
-          yExpand = ((f/100.0)*(extent->maxy-extent->miny))/2;
-        } else {
-          xExpand = atof(argValue);
-          yExpand = xExpand;
-        }
-      }
-
-      argValue = msLookupHashTable(tagArgs, "escape");
-      if(argValue && strcasecmp(argValue, "url") == 0) escape = ESCAPE_URL;
-      else if(argValue && strcasecmp(argValue, "none") == 0) escape = ESCAPE_NONE;
-
-      argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
-
-      argValue = msLookupHashTable(tagArgs, "proj");
-      if(argValue) projectionString = argValue;
-    }
-
-    tempExtent.minx = extent->minx - xExpand;
-    tempExtent.miny = extent->miny - yExpand;
-    tempExtent.maxx = extent->maxx + xExpand;
-    tempExtent.maxy = extent->maxy + yExpand;
-
-    /* no big deal to convert from file to image coordinates, but what are the image parameters */
-    if(rectProj && projectionString && strcasecmp(projectionString,"image") == 0) {
-      precision = 0;
-
-      /* if necessary, project the shape to match the map */
-      if(msProjectionsDiffer(rectProj, &(mapserv->map->projection)))
-        msProjectRect(rectProj, &mapserv->map->projection, &tempExtent);
-
-      /* convert tempExtent to image coordinates based on the map extent and cellsize */
-      tempExtent.minx = MS_MAP2IMAGE_X(tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
-      tempExtent.miny = MS_MAP2IMAGE_Y(tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
-      tempExtent.maxx = MS_MAP2IMAGE_X(tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
-      tempExtent.maxy = MS_MAP2IMAGE_Y(tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
-    } else if(rectProj && projectionString) {
-      projectionObj projection;
-      msInitProjection(&projection);
-      msProjectionInheritContextFrom(&projection, &mapserv->map->projection);
-
-      if(MS_SUCCESS != msLoadProjectionString(&projection, projectionString)) return MS_FAILURE;
-
-      if(msProjectionsDiffer(rectProj, &projection))
-        msProjectRect(rectProj, &projection, &tempExtent);
-    }
-
-    tagValue = msStrdup(format);
-
-    if(precision != -1)
-      snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
-    else
-      snprintf(numberFormat, sizeof(numberFormat), "%%f");
-
-    snprintf(number, sizeof(number), numberFormat, tempExtent.minx);
-    tagValue = msReplaceSubstring(tagValue, "$minx", number);
-    snprintf(number, sizeof(number), numberFormat, tempExtent.miny);
-    tagValue = msReplaceSubstring(tagValue, "$miny", number);
-    snprintf(number, sizeof(number), numberFormat, tempExtent.maxx);
-    tagValue = msReplaceSubstring(tagValue, "$maxx", number);
-    snprintf(number, sizeof(number), numberFormat, tempExtent.maxy);
-    tagValue = msReplaceSubstring(tagValue, "$maxy", number);
-
-    /* find the end of the tag */
-    tagEnd = findTagEnd(tagStart);
-    tagEnd++;
-
-    /* build the complete tag so we can do substitution */
-    tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
-
-    /* do the replacement */
-    switch(escape) {
-      case ESCAPE_HTML:
-        encodedTagValue = msEncodeHTMLEntities(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_URL:
-        encodedTagValue = msEncodeUrl(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_NONE:
-        *line = msReplaceSubstring(*line, tag, tagValue);
-        break;
-      default:
-        break;
-    }
-
-    /* clean up */
-    free(tag);
-    tag = NULL;
-    msFreeHashTable(tagArgs);
-    tagArgs=NULL;
-    msFree(tagValue);
-    tagValue=NULL;
-    msFree(encodedTagValue);
-    encodedTagValue=NULL;
-
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, name);
-    else
-      tagStart = NULL;
-  }
-
-  return(MS_SUCCESS);
-}
-
-// RFC 77 TODO: Need to validate these changes with Assefa...
-static int processShplabelTag(layerObj *layer, char **line, shapeObj *origshape)
-{
-  char *tag, *tagStart, *tagEnd;
-  char *tagValue=NULL;
-  hashTableObj *tagArgs=NULL;
-  int tagOffset, tagLength;
-  const char *format;
-  const char *argValue=NULL;
-  const char *projectionString=NULL;
-  shapeObj tShape;
-  int precision=0;
-  int clip_to_map=MS_TRUE;
-  int use_label_settings=MS_FALSE;
-  int labelposvalid = MS_FALSE;
-  pointObj labelPos;
-  int status;
-  char number[64]; /* holds a single number in the extent */
-  char numberFormat[16];
-  shapeObj *shape = NULL;
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processShplabelTag()");
-    return(MS_FAILURE);
-  }
-  if(msCheckParentPointer(layer->map,"map") == MS_FAILURE)
-    return MS_FAILURE;
-
-  tagStart = findTag(*line, "shplabel");
-
-  /* It is OK to have no shplabel tags, just return. */
-  if(!tagStart)
-    return MS_SUCCESS;
-
-  if(!origshape || origshape->numlines <= 0) { /* I suppose we need to make sure the part has vertices (need shape checker?) */
-    msSetError(MS_WEBERR, "Null or empty shape.", "processShplabelTag()");
-    return(MS_FAILURE);
-  }
-
-  while(tagStart) {
-    if(shape) msFreeShape(shape);
-    shape = (shapeObj *) msSmallMalloc(sizeof(shapeObj));
-    msInitShape(shape);
-    msCopyShape(origshape, shape);
-
-    projectionString = NULL;
-    format = "$x,$y";
-    tagOffset = tagStart - *line;
-
-    if(getTagArgs("shplabel", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
-      argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
-
-      argValue = msLookupHashTable(tagArgs, "proj");
-      if(argValue) projectionString = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "clip_to_map");
-      if(argValue) {
-        if(strcasecmp(argValue,"false") == 0) clip_to_map = MS_FALSE;
-      }
-
-      argValue = msLookupHashTable(tagArgs, "use_label_settings");
-      if(argValue) {
-        if(strcasecmp(argValue,"true") == 0) use_label_settings = MS_TRUE;
-      }
-    }
-
-    labelPos.x = -1;
-    labelPos.y = -1;
-    msInitShape(&tShape);
-
-    tShape.type = MS_SHAPE_LINE;
-    tShape.line = (lineObj *) msSmallMalloc(sizeof(lineObj));
-    tShape.numlines = 1;
-    tShape.line[0].point = NULL; /* initialize the line */
-    tShape.line[0].numpoints = 0;
-
-    double cellsize;
-    if(layer->map->cellsize <= 0)
-      cellsize = MS_MAX(MS_CELLSIZE(layer->map->extent.minx, layer->map->extent.maxx, layer->map->width), MS_CELLSIZE(layer->map->extent.miny, layer->map->extent.maxy, layer->map->height));
-    else
-      cellsize = layer->map->cellsize ;
-
-    if(shape->type == MS_SHAPE_POINT) {
-      labelposvalid = MS_FALSE;
-      if(shape->numlines > 0 && shape->line[0].numpoints > 0) {
-        labelposvalid = MS_TRUE;
-        labelPos = shape->line[0].point[0];
-        if(layer->transform == MS_TRUE) {
-          if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-          {
-            if( layer->reprojectorLayerToMap == NULL )
-            {
-                layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                    &layer->projection, &layer->map->projection);
-            }
-            if( layer->reprojectorLayerToMap )
-            {
-                msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-            }
-          }
-
-          labelPos = shape->line[0].point[0];
-          labelPos.x = MS_MAP2IMAGE_X(labelPos.x, layer->map->extent.minx, cellsize);
-          labelPos.y = MS_MAP2IMAGE_Y(labelPos.y, layer->map->extent.maxy, cellsize);
-        }
-      }
-    } else if(shape->type == MS_SHAPE_LINE) {
-      labelposvalid = MS_FALSE;
-      if(layer->transform == MS_TRUE) {
-        if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-        {
-            if( layer->reprojectorLayerToMap == NULL )
-            {
-                layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                    &layer->projection, &layer->map->projection);
-            }
-            if( layer->reprojectorLayerToMap )
-            {
-                msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-            }
-        }
-
-        if(clip_to_map)
-          msClipPolylineRect(shape, layer->map->extent);
-
-        msTransformShapeToPixelRound(shape, layer->map->extent, cellsize);
-      } else
-        msOffsetShapeRelativeTo(shape, layer);
-
-      if(shape->numlines > 0) {
-        struct label_auto_result lar;
-        memset(&lar,0,sizeof(struct label_auto_result));
-        if(MS_UNLIKELY(MS_FAILURE == msPolylineLabelPoint(layer->map, shape, NULL, NULL, &lar, 0))) {
-          free(lar.angles);
-          free(lar.label_points);
-          return MS_FAILURE;
-        }
-        if(lar.num_label_points > 0) {
-          /* convert to geo */
-          labelPos.x = lar.label_points[0].x;
-          labelPos.y = lar.label_points[0].y;
-          labelposvalid = MS_TRUE;
-        }
-        free(lar.angles);
-        free(lar.label_points);
-      }
-    } else if (shape->type == MS_SHAPE_POLYGON) {
-      labelposvalid = MS_FALSE;
-      if(layer->transform == MS_TRUE) {
-        if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-        {
-            if( layer->reprojectorLayerToMap == NULL )
-            {
-                layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                    &layer->projection, &layer->map->projection);
-            }
-            if( layer->reprojectorLayerToMap )
-            {
-                msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-            }
-        }
-
-        if(clip_to_map)
-          msClipPolygonRect(shape, layer->map->extent);
-
-        msTransformShapeToPixelRound(shape, layer->map->extent, cellsize);
-      } else
-        msOffsetShapeRelativeTo(shape, layer);
-
-      if(shape->numlines > 0) {
-        if(msPolygonLabelPoint(shape, &labelPos, -1) == MS_SUCCESS) {
-          if(labelPos.x == -1 && labelPos.y == -1)
-            labelposvalid = MS_FALSE;
-          else
-            labelposvalid = MS_TRUE;
-        }
-      }
-    }
-
-    if(labelposvalid == MS_TRUE) {
-      pointObj p1 = {0}; // initialize
-      pointObj p2 = {0};
-      int label_offset_x, label_offset_y;
-      labelObj *label=NULL;
-      label_bounds lbounds;
-      lineObj lbounds_line;
-      pointObj lbounds_point[5];
-      double tmp;
-
-      p1.x =labelPos.x;
-      p1.y =labelPos.y;
-
-      p2.x =labelPos.x;
-      p2.y =labelPos.y;
-      if(use_label_settings == MS_TRUE) {
-
-        /* RFC 77: classes (and shapes) can have more than 1 piece of annotation, here we only use the first (index=0) */
-        if(shape->classindex >= 0  && layer->class[shape->classindex]->numlabels > 0) {
-          label = layer->class[shape->classindex]->labels[0];
-          if(msGetLabelStatus(layer->map,layer,shape,label) == MS_ON) {
-            char *annotext = msShapeGetLabelAnnotation(layer,shape,label);
-            if(annotext) {
-              textSymbolObj ts;
-              initTextSymbol(&ts);
-              msPopulateTextSymbolForLabelAndString(&ts, label, annotext, layer->scalefactor, 1.0, 0);
-
-              label_offset_x = (int)(label->offsetx*layer->scalefactor);
-              label_offset_y = (int)(label->offsety*layer->scalefactor);
-              lbounds.poly = &lbounds_line;
-              lbounds_line.numpoints = 5;
-              lbounds_line.point = lbounds_point;
-
-              p1 = get_metrics(&labelPos, label->position, ts.textpath, label_offset_x, label_offset_y, label->angle* MS_DEG_TO_RAD, 0, &lbounds);
-
-              /* should we use the point returned from  get_metrics?. From few test done, It seems
-                to return the UL corner of the text. For now use the bounds.minx/miny */
-              p1.x = lbounds.bbox.minx;
-              p1.y = lbounds.bbox.miny;
-              p2.x = lbounds.bbox.maxx;
-              p2.y = lbounds.bbox.maxy;
-              freeTextSymbol(&ts);
-            }
-          }
-        }
-      }
-
-      /* y's are flipped because it is in image coordinate systems */
-      p1.x = MS_IMAGE2MAP_X(p1.x, layer->map->extent.minx, cellsize);
-      tmp = p1.y;
-      p1.y = MS_IMAGE2MAP_Y(p2.y, layer->map->extent.maxy, cellsize);
-      p2.x = MS_IMAGE2MAP_X(p2.x, layer->map->extent.minx, cellsize);
-      p2.y = MS_IMAGE2MAP_Y(tmp, layer->map->extent.maxy, cellsize);
-      if(layer->transform == MS_TRUE) {
-        if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection))) {
-          msProjectPoint(&layer->map->projection, &layer->projection, &p1);
-          msProjectPoint(&layer->map->projection, &layer->projection, &p2);
-        }
-      }
-      msAddPointToLine(&(tShape.line[0]), &p1);
-      msAddPointToLine(&(tShape.line[0]), &p2);
-    } else
-      tShape.numlines = 0;
-
-    if(projectionString && strcasecmp(projectionString,"image") == 0) {
-      precision = 0;
-
-      /* if necessary, project the shape to match the map */
-      if(msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-      {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &layer->map->projection);
-        }
-        if( layer->reprojectorLayerToMap )
-        {
-            msProjectShapeEx(layer->reprojectorLayerToMap, &tShape);
-        }
-      }
-
-      msClipPolylineRect(&tShape, layer->map->extent);
-
-      msTransformShapeToPixelRound(&tShape, layer->map->extent, layer->map->cellsize);
-    } else if(projectionString) {
-      projectionObj projection;
-      msInitProjection(&projection);
-      msProjectionInheritContextFrom(&projection, &layer->map->projection);
-
-      status = msLoadProjectionString(&projection, projectionString);
-      if(status != MS_SUCCESS) return MS_FAILURE;
-
-      if(msProjectionsDiffer(&(layer->projection), &projection))
-        msProjectShape(&layer->projection, &projection, &tShape);
-    }
-
-    /* do the replacement */
-    tagValue = msStrdup(format);
-    if(precision > 0)
-      snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
-    else
-      snprintf(numberFormat, sizeof(numberFormat), "%%f");
-
-    if(tShape.numlines > 0) {
-      if(strcasestr(tagValue, "$x") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].x);
-        tagValue = msReplaceSubstring(tagValue, "$x", number);
-      }
-      if(strcasestr(tagValue, "$y") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].y);
-        tagValue = msReplaceSubstring(tagValue, "$y", number);
-      }
-
-      if(strcasestr(tagValue, "$minx") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].x);
-        tagValue = msReplaceSubstring(tagValue, "$minx", number);
-      }
-      if(strcasestr(tagValue, "$miny") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].y);
-        tagValue = msReplaceSubstring(tagValue, "$miny", number);
-      }
-      if(strcasestr(tagValue, "$maxx") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[1].x);
-        tagValue = msReplaceSubstring(tagValue, "$maxx", number);
-      }
-      if(strcasestr(tagValue, "$maxy") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[1].y);
-        tagValue = msReplaceSubstring(tagValue, "$maxy", number);
-      }
-    }
-
-    /* find the end of the tag */
-    tagEnd = findTagEnd(tagStart);
-    tagEnd++;
-
-    /* build the complete tag so we can do substitution */
-    tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
-
-    *line = msReplaceSubstring(*line, tag, tagValue);
-
-    /* clean up */
-    msFreeShape(&tShape);
-    free(tag);
-    tag = NULL;
-    msFreeHashTable(tagArgs);
-    tagArgs=NULL;
-    msFree(tagValue);
-    tagValue=NULL;
-
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "shplabel");
-    else
-      tagStart = NULL;
-  }
-  if(shape)
-    msFreeShape(shape);
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Function to process a [date ...] tag
-*/
-static int processDateTag(char **line)
-{
-  struct tm *datetime;
-  time_t t;
-  int result;
-  char *tag=NULL, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
-  int tagOffset, tagLength;
-#define DATE_BUFLEN 1024
-  char datestr[DATE_BUFLEN];
-  const char *argValue=NULL;
-  const char *format, *tz; /* tag parameters */
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processDateTag()");
-    return(MS_FAILURE);
-  }
-
-  tagStart = findTag(*line, "date");
-
-  /* It is OK to have no date tags, just return. */
-  if( !tagStart )
-    return MS_SUCCESS;
-
-  while (tagStart) {
-    /* set tag params to defaults */
-    format = DEFAULT_DATE_FORMAT;
-    tz = "";
-
-    tagOffset = tagStart - *line;
-
-    /* check for any tag arguments */
-    if(getTagArgs("date", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-
-    if(tagArgs) {
-      argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
-      argValue = msLookupHashTable(tagArgs, "tz");
-      if(argValue) tz = argValue;
-    }
-
-    t = time(NULL);
-    if( strncasecmp( tz, "gmt", 4 ) == 0 ) {
-      datetime = gmtime(&t);
-    } else {
-      datetime = localtime(&t);
-    }
-    result = strftime(datestr, DATE_BUFLEN, format, datetime);
-
-    /* Only do the replacement if the date was successfully written */
-    if( result > 0 ) {
-      /* find the end of the tag */
-      tagEnd = findTagEnd(tagStart);
-      tagEnd++;
-
-      /* build the complete tag so we can do substitution */
-      tagLength = tagEnd - tagStart;
-      tag = (char *) msSmallMalloc(tagLength + 1);
-      strlcpy(tag, tagStart, tagLength+1);
-
-      /* do the replacement */
-      *line = msReplaceSubstring(*line, tag, datestr);
-    }
-
-    /* clean up */
-    msFree(tag);
-    tag = NULL;
-    msFreeHashTable(tagArgs);
-    tagArgs=NULL;
-
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "date");
-    else
-      tagStart = NULL;
-  }
-
-  return(MS_SUCCESS);
-
-}
-
-/*
-** Function to process a [shpxy ...] tag: line contains the tag, shape holds the coordinates.
-**
-** TODO's:
-**   - May need to change attribute names.
-**   - Need generalization routines (not here, but in mapprimative.c).
-**   - Try to avoid all the realloc calls.
-*/
-static int processShpxyTag(layerObj *layer, char **line, shapeObj *shape)
-{
-  int i,j,p;
-  int status;
-
-  char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
-  int tagOffset, tagLength;
-
-  const char *argValue=NULL;
-  char *pointFormat1=NULL, *pointFormat2=NULL;
-  int pointFormatLength;
-
-  /*
-  ** Pointers to static strings, naming convention is:
-  **   char 1/2 - x=x, y=y, c=coordinate, p=part, s=shape, ir=inner ring, or=outer ring
-  **   last char - h=header, f=footer, s=seperator
-  */
-  const char *xh, *xf, *yh, *yf;
-  const char *cs;
-  const char *ph, *pf, *ps;
-  const char *sh, *sf;
-  const char *irh, *irf; /* inner ring: necessary for complex polygons */
-  const char *orh, *orf; /* outer ring */
-
-  int centroid;
-  int precision;
-
-  double scale_x, scale_y;
-
-  const char *projectionString=NULL;
-
-  shapeObj tShape;
-  char *coords=NULL, point[128];
-
-  if(!*line) {
-    msSetError(MS_WEBERR, "Invalid line pointer.", "processShpxyTag()");
-    return(MS_FAILURE);
-  }
-  if( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  tagStart = findTag(*line, "shpxy");
-
-  /* It is OK to have no shpxy tags, just return. */
-  if( !tagStart )
-    return MS_SUCCESS;
-
-  if(!shape || shape->numlines <= 0) { /* I suppose we need to make sure the part has vertices (need shape checker?) */
-    msSetError(MS_WEBERR, "Null or empty shape.", "processShpxyTag()");
-    return(MS_FAILURE);
-  }
-
-  while (tagStart) {
-#ifdef USE_GEOS
-    double buffer = 0;
-    int bufferUnits = -1;
-#endif
-    xh = yh = yf = ph = pf = sh = sf = ""; /* initialize the tag arguments */
-    xf= ",";
-    irh = irf = orh = orf = "";
-    ps = cs = " ";
-
-    centroid = MS_FALSE;
-    precision = 0;
-    scale_x = scale_y = 1.0;
-
-    projectionString = NULL;
-
-    tagOffset = tagStart - *line;
-
-    /* check for any tag arguments */
-    if(getTagArgs("shpxy", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
-      argValue = msLookupHashTable(tagArgs, "xh");
-      if(argValue) xh = argValue;
-      argValue = msLookupHashTable(tagArgs, "xf");
-      if(argValue) xf = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "yh");
-      if(argValue) yh = argValue;
-      argValue = msLookupHashTable(tagArgs, "yf");
-      if(argValue) yf = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "cs");
-      if(argValue) cs = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "irh");
-      if(argValue) irh = argValue;
-      argValue = msLookupHashTable(tagArgs, "irf");
-      if(argValue) irf = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "orh");
-      if(argValue) orh = argValue;
-      argValue = msLookupHashTable(tagArgs, "orf");
-      if(argValue) orf = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "ph");
-      if(argValue) ph = argValue;
-      argValue = msLookupHashTable(tagArgs, "pf");
-      if(argValue) pf = argValue;
-      argValue = msLookupHashTable(tagArgs, "ps");
-      if(argValue) ps = argValue;
-
-      argValue = msLookupHashTable(tagArgs, "sh");
-      if(argValue) sh = argValue;
-      argValue = msLookupHashTable(tagArgs, "sf");
-      if(argValue) sf = argValue;
-
-#ifdef USE_GEOS
-      argValue = msLookupHashTable(tagArgs, "buffer");
-      if(argValue) {
-        buffer = atof(argValue);
-        if(strstr(argValue, "px")) bufferUnits = MS_PIXELS; /* may support others at some point */
-      }
-#endif
-
-      argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
-
-      argValue = msLookupHashTable(tagArgs, "scale");
-      if(argValue) {
-        scale_x = atof(argValue);
-        scale_y = scale_x;
-      }
-
-      argValue = msLookupHashTable(tagArgs, "scale_x");
-      if(argValue) scale_x = atof(argValue);
-
-      argValue = msLookupHashTable(tagArgs, "scale_y");
-      if(argValue) scale_y = atof(argValue);
-
-      argValue = msLookupHashTable(tagArgs, "centroid");
-      if(argValue)
-        if(strcasecmp(argValue,"true") == 0) centroid = MS_TRUE;
-
-      argValue = msLookupHashTable(tagArgs, "proj");
-      if(argValue) projectionString = argValue;
-    }
-
-    /* build the per point format strings (version 1 contains the coordinate seperator, version 2 doesn't) */
-    pointFormatLength = strlen(xh) + strlen(xf) + strlen(yh) + strlen(yf) + strlen(cs) + 12 + 1;
-    pointFormat1 = (char *) msSmallMalloc(pointFormatLength);
-    snprintf(pointFormat1, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s%s", xh, precision, xf, yh, precision, yf, cs);
-    pointFormat2 = (char *) msSmallMalloc(pointFormatLength);
-    snprintf(pointFormat2, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s", xh, precision, xf, yh, precision, yf);
-
-    /* make a copy of the original shape or compute a centroid if necessary */
-    msInitShape(&tShape);
-    if(centroid == MS_TRUE) {
-      pointObj p;
-
-      p.x = (shape->bounds.minx + shape->bounds.maxx)/2;
-      p.y = (shape->bounds.miny + shape->bounds.maxy)/2;
-
-      tShape.type = MS_SHAPE_POINT;
-      tShape.line = (lineObj *) msSmallMalloc(sizeof(lineObj));
-      tShape.numlines = 1;
-      tShape.line[0].point = NULL; /* initialize the line */
-      tShape.line[0].numpoints = 0;
-
-      msAddPointToLine(&(tShape.line[0]), &p);
-    }
-
-#ifdef USE_GEOS
-    else if(buffer != 0 && bufferUnits != MS_PIXELS) {
-      shapeObj *bufferShape=NULL;
-
-      bufferShape = msGEOSBuffer(shape, buffer);
-      if(!bufferShape) {
-        free(pointFormat1);
-        free(pointFormat2);
-        return(MS_FAILURE); /* buffer failed */
-      }
-      msCopyShape(bufferShape, &tShape);
-      msFreeShape(bufferShape);
-    }
-#endif
-    else {
-      status = msCopyShape(shape, &tShape);
-      if(status != 0) {
-        free(pointFormat1);
-        free(pointFormat2);
-        return(MS_FAILURE); /* copy failed */
-      }
-    }
-
-    /* no big deal to convert from file to image coordinates, but what are the image parameters */
-    if(projectionString && strcasecmp(projectionString,"image") == 0) {
-      precision = 0;
-
-      /* if necessary, project the shape to match the map */
-      if(msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-      {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &layer->map->projection);
-        }
-        if( layer->reprojectorLayerToMap )
-        {
-            msProjectShapeEx(layer->reprojectorLayerToMap, &tShape);
-        }
-      }
-
-      switch(tShape.type) {
-        case(MS_SHAPE_POINT):
-          /* no clipping necessary */
-          break;
-        case(MS_SHAPE_LINE):
-          msClipPolylineRect(&tShape, layer->map->extent);
-          break;
-        case(MS_SHAPE_POLYGON):
-          msClipPolygonRect(&tShape, layer->map->extent);
-          break;
-        default:
-          /* TO DO: need an error message here */
-          return(MS_FAILURE);
-          break;
-      }
-      msTransformShapeToPixelRound(&tShape, layer->map->extent, layer->map->cellsize);
-
-#ifdef USE_GEOS
-      if(buffer != 0 && bufferUnits == MS_PIXELS) {
-        shapeObj *bufferShape=NULL;
-
-        bufferShape = msGEOSBuffer(&tShape, buffer);
-        if(!bufferShape) {
-          if(!msIsDegenerateShape(&tShape)) /* If shape is degenerate this is expected. */
-            return(MS_FAILURE); /* buffer failed */
-        } else {
-          msFreeShape(&tShape); /* avoid memory leak */
-          msCopyShape(bufferShape, &tShape);
-          msFreeShape(bufferShape);
-        }
-      }
-#endif
-
-    } else if(projectionString) {
-      projectionObj projection;
-      msInitProjection(&projection);
-      msProjectionInheritContextFrom(&projection, &(layer->projection));
-
-      status = msLoadProjectionString(&projection, projectionString);
-      if(status != MS_SUCCESS) return MS_FAILURE;
-
-      if(msProjectionsDiffer(&(layer->projection), &projection))
-        msProjectShape(&layer->projection, &projection, &tShape);
-    }
-
-    /* TODO: add thinning support here */
-
-    /*
-    ** build the coordinate string
-    */
-
-    if(strlen(sh) > 0) coords = msStringConcatenate(coords, sh);
-
-    /* do we need to handle inner/outer rings */
-    if(tShape.type == MS_SHAPE_POLYGON && strlen(orh) > 0 && strlen(irh) > 0) {
-      int *outers;
-      int firstPart; /* to keep track of inserting part separators before each part after the first */
-      outers = msGetOuterList( &tShape );
-      firstPart = 1;
-      /* loop over rings looking for outers*/
-      for(i=0; i<tShape.numlines; i++) {
-        int *inners;
-        if( outers[i] ) {
-          /* this is an outer ring */
-          if((!firstPart) && (strlen(ps) > 0)) coords = msStringConcatenate(coords, ps);
-          firstPart = 0;
-          if(strlen(ph) > 0) coords = msStringConcatenate(coords, ph);
-          coords = msStringConcatenate(coords, orh);
-          for(p=0; p<tShape.line[i].numpoints-1; p++) {
-            snprintf(point, sizeof(point), pointFormat1, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
-            coords = msStringConcatenate(coords, point);
-          }
-          snprintf(point, sizeof(point), pointFormat2, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
-          coords = msStringConcatenate(coords, point);
-          coords = msStringConcatenate(coords, orf);
-
-          inners = msGetInnerList(&tShape, i, outers);
-          /* loop over rings looking for inners to this outer */
-          for(j=0; j<tShape.numlines; j++) {
-            if( inners[j] ) {
-              /* j is an inner ring of i */
-              coords = msStringConcatenate(coords, irh);
-              for(p=0; p<tShape.line[j].numpoints-1; p++) {
-                snprintf(point, sizeof(point), pointFormat1, scale_x*tShape.line[j].point[p].x, scale_y*tShape.line[j].point[p].y);
-                coords = msStringConcatenate(coords, point);
-              }
-              snprintf(point, sizeof(point), pointFormat2, scale_x*tShape.line[j].point[p].x, scale_y*tShape.line[j].point[p].y);
-              coords = msStringConcatenate(coords, irf);
-            }
-          }
-          free( inners );
-          if(strlen(pf) > 0) coords = msStringConcatenate(coords, pf);
-        }
-      } /* end of loop over outer rings */
-      free( outers );
-    } else { /* output without ring formatting */
-
-      for(i=0; i<tShape.numlines; i++) { /* e.g. part */
-
-        /* skip degenerate parts, really should only happen with pixel output */
-        if((tShape.type == MS_SHAPE_LINE && tShape.line[i].numpoints < 2) ||
-            (tShape.type == MS_SHAPE_POLYGON && tShape.line[i].numpoints < 3))
-          continue;
-
-        if(strlen(ph) > 0) coords = msStringConcatenate(coords, ph);
-
-        for(p=0; p<tShape.line[i].numpoints-1; p++) {
-          snprintf(point, sizeof(point), pointFormat1, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
-          coords = msStringConcatenate(coords, point);
-        }
-        snprintf(point, sizeof(point), pointFormat2, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
-        coords = msStringConcatenate(coords, point);
-
-        if(strlen(pf) > 0) coords = msStringConcatenate(coords, pf);
-
-        if((i < tShape.numlines-1) && (strlen(ps) > 0)) coords = msStringConcatenate(coords, ps);
-      }
-    }
-    if(strlen(sf) > 0) coords = msStringConcatenate(coords, sf);
-
-    msFreeShape(&tShape);
-
-    /* find the end of the tag */
-    tagEnd = findTagEnd(tagStart);
-    tagEnd++;
-
-    /* build the complete tag so we can do substitution */
-    tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
-
-    /* do the replacement */
-    *line = msReplaceSubstring(*line, tag, coords);
-
-    /* clean up */
-    free(tag);
-    tag = NULL;
-    msFreeHashTable(tagArgs);
-    tagArgs=NULL;
-    free(pointFormat1);
-    pointFormat1 = NULL;
-    free(pointFormat2);
-    pointFormat2 = NULL;
-    free(coords);
-    coords = NULL;
-
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "shpxy");
-    else
-      tagStart = NULL;
-  }
-
-  return(MS_SUCCESS);
-}
-
-/*!
- * this function process all metadata
- * in pszInstr. ht mus contain all corresponding
- * metadata value.
- *
- * this function return a modified pszInstr
-*/
-int processMetadata(char** pszInstr, hashTableObj *ht)
-{
-  /* char *pszNextInstr = pszInstr; */
-  char *pszEnd, *pszStart;
-  char *pszMetadataTag;
-  const char *pszHashName;
-  const char *pszHashValue;
-  int nLength, nOffset;
-
-  hashTableObj *metadataArgs = NULL;
-
-  if(!*pszInstr) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "processMetadata()");
-    return MS_FAILURE;
-  }
-
-  /* set position to the begining of metadata tag */
-  pszStart = findTag(*pszInstr, "metadata");
-
-  while (pszStart) {
-    /* get metadata args */
-    if(getTagArgs("metadata", pszStart, &metadataArgs) != MS_SUCCESS)
-      return MS_FAILURE;
-
-    pszHashName = msLookupHashTable(metadataArgs, "name");
-    pszHashValue = msLookupHashTable(ht, pszHashName);
-
-    nOffset = pszStart - *pszInstr;
-
-    if(pszHashName && pszHashValue) {
-      /* set position to the end of metadata start tag */
-      pszEnd = strchr(pszStart, ']');
-      pszEnd++;
-
-      /* build the complete metadata tag ([metadata all_args]) */
-      /* to replace it by the corresponding value from ht */
-      nLength = pszEnd - pszStart;
-      pszMetadataTag = (char*)msSmallMalloc(nLength + 1);
-      strlcpy(pszMetadataTag, pszStart, nLength+1);
-
-      *pszInstr = msReplaceSubstring(*pszInstr, pszMetadataTag, pszHashValue);
-
-      free(pszMetadataTag);
-      pszMetadataTag=NULL;
-    }
-
-    msFreeHashTable(metadataArgs);
-    metadataArgs=NULL;
-
-
-    /* set position to the begining of the next metadata tag */
-    if((*pszInstr)[nOffset] != '\0')
-      pszStart = findTag(*pszInstr+nOffset+1, "metadata");
-    else
-      pszStart = NULL;
-  }
-
-  return MS_SUCCESS;
-}
-
-/*!
- * this function process all icon tag
- * from pszInstr.
- *
- * This func return a modified pszInstr.
-*/
-int processIcon(mapObj *map, int nIdxLayer, int nIdxClass, char** pszInstr, char* pszPrefix)
-{
-  int nWidth, nHeight, nLen;
-  char szImgFname[1024], *pszFullImgFname=NULL, *pszImgTag;
-  char szPath[MS_MAXPATHLEN];
-  hashTableObj *myHashTable=NULL;
-  FILE *fIcon;
-
-  if(!map ||
-      nIdxLayer > map->numlayers ||
-      nIdxLayer < 0 ) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "processIcon()");
-    return MS_FAILURE;
-  }
-
-  /* find the begining of tag */
-  pszImgTag = strstr(*pszInstr, "[leg_icon");
-
-  while (pszImgTag) {
-    int i;
-    char szStyleCode[512] = "";
-    classObj *thisClass=NULL;
-
-    /* It's okay to have no classes... we'll generate an empty icon in this case */
-    if(nIdxClass >= 0 && nIdxClass < GET_LAYER(map, nIdxLayer)->numclasses)
-      thisClass = GET_LAYER(map, nIdxLayer)->class[nIdxClass];
-
-    if(getTagArgs("leg_icon", pszImgTag, &myHashTable) != MS_SUCCESS)
-      return MS_FAILURE;
-
-    /* if no specified width or height, set them to map default */
-    if(!msLookupHashTable(myHashTable, "width") || !msLookupHashTable(myHashTable, "height")) {
-      nWidth = map->legend.keysizex;
-      nHeight= map->legend.keysizey;
-    } else {
-      nWidth  = atoi(msLookupHashTable(myHashTable, "width"));
-      nHeight = atoi(msLookupHashTable(myHashTable, "height"));
-    }
-
-    /* Create a unique and predictable filename to cache the legend icons.
-     * Include some key parameters from the first 2 styles
-     */
-    for(i=0; i<2 && thisClass && i<thisClass->numstyles; i++) {
-      styleObj *style;
-      char *pszSymbolNameHash = NULL;
-      style = thisClass->styles[i];
-      if(style->symbolname)
-        pszSymbolNameHash = msHashString(style->symbolname);
-
-      snprintf(szStyleCode+strlen(szStyleCode), 255,
-               "s%d_%x_%x_%d_%s_%g",
-               i, MS_COLOR_GETRGB(style->color),MS_COLOR_GETRGB(style->outlinecolor),
-               style->symbol, pszSymbolNameHash?pszSymbolNameHash:"",
-               style->angle);
-      msFree(pszSymbolNameHash);
-    }
-
-    snprintf(szImgFname, sizeof(szImgFname), "%s_%d_%d_%d_%d_%s.%s%c",
-             pszPrefix, nIdxLayer, nIdxClass, nWidth, nHeight,
-             szStyleCode, MS_IMAGE_EXTENSION(map->outputformat),'\0');
-
-    pszFullImgFname = msStrdup(msBuildPath3(szPath, map->mappath,
-                                            map->web.imagepath, szImgFname));
-
-    /* check if icon already exist in cache */
-    if((fIcon = fopen(pszFullImgFname, "r")) != NULL) {
-      /* File already exists. No need to generate it again */
-      fclose(fIcon);
-    } else {
-      /* Create an image corresponding to the current class */
-      imageObj *img=NULL;
-
-      if(thisClass == NULL) {
-        /* Nonexistent class.  Create an empty image */
-        img = msCreateLegendIcon(map, NULL, NULL, nWidth, nHeight, MS_TRUE);
-      } else {
-        img = msCreateLegendIcon(map, GET_LAYER(map, nIdxLayer),
-                                 thisClass, nWidth, nHeight, MS_TRUE);
-      }
-
-      if(!img) {
-        if(myHashTable)
-          msFreeHashTable(myHashTable);
-
-        msSetError(MS_IMGERR, "Error while creating image.", "processIcon()");
-        return MS_FAILURE;
-      }
-
-      /* save it with a unique file name */
-      if(msSaveImage(map, img, pszFullImgFname) != MS_SUCCESS) {
-        if(myHashTable)
-          msFreeHashTable(myHashTable);
-
-        msFreeImage(img);
-
-        msSetError(MS_IOERR, "Error saving GD image to disk (%s).", "processIcon()", pszFullImgFname);
-        msFree(pszFullImgFname);
-        return MS_FAILURE;
-      }
-
-      msFreeImage(img);
-    }
-
-    msFree(pszFullImgFname);
-    pszFullImgFname = NULL;
-
-    nLen = (strchr(pszImgTag, ']') + 1) - pszImgTag;
-
-    if(nLen > 0) {
-      char *pszTag;
-
-      /* rebuid image tag ([leg_class_img all_args]) */
-      /* to replace it by the image url */
-      pszTag = (char*)msSmallMalloc(nLen + 1);
-      strlcpy(pszTag, pszImgTag, nLen+1);
-
-      pszFullImgFname = (char*)msSmallMalloc(strlen(map->web.imageurl) + strlen(szImgFname) + 1);
-      strcpy(pszFullImgFname, map->web.imageurl);
-      strcat(pszFullImgFname, szImgFname);
-
-      *pszInstr = msReplaceSubstring(*pszInstr, pszTag, pszFullImgFname);
-
-      msFree(pszFullImgFname);
-      pszFullImgFname = NULL;
-      msFree(pszTag);
-
-      /* find the begining of tag */
-      pszImgTag = strstr(*pszInstr, "[leg_icon");
-    } else {
-      pszImgTag = NULL;
-    }
-
-    if(myHashTable) {
-      msFreeHashTable(myHashTable);
-      myHashTable = NULL;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*!
- * Replace all tags from group template
- * with correct value.
- *
- * this function return a buffer containing
- * the template with correct values.
- *
- * buffer must be freed by caller.
-*/
-int generateGroupTemplate(char* pszGroupTemplate, mapObj *map, char* pszGroupName, hashTableObj *oGroupArgs, char **pszTemp, char* pszPrefix)
-{
-  hashTableObj *myHashTable;
-  char pszStatus[3];
-  char *pszClassImg;
-  const char *pszOptFlag = NULL;
-  int i, j;
-  int nOptFlag = 15;
-  int bShowGroup;
-
-  *pszTemp = NULL;
-
-  if(!pszGroupName || !pszGroupTemplate) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "generateGroupTemplate()");
-    return MS_FAILURE;
-  }
-
-  /*
-   * Get the opt_flag is any.
-   */
-  if(oGroupArgs)
-    pszOptFlag = msLookupHashTable(oGroupArgs, "opt_flag");
-
-  if(pszOptFlag)
-    nOptFlag = atoi(pszOptFlag);
-
-  /*
-   * Check all layers, if one in the group
-   * should be visible, print the group.
-   * (Check for opt_flag)
-   */
-  bShowGroup = 0;
-  for (j=0; j<map->numlayers; j++) {
-    if(GET_LAYER(map, map->layerorder[j])->group &&
-        strcmp(GET_LAYER(map, map->layerorder[j])->group, pszGroupName) == 0) {
-      /* dont display layer is off. */
-      if( (nOptFlag & 2) == 0 &&
-          GET_LAYER(map, map->layerorder[j])->status == MS_OFF )
-        bShowGroup = 0;
-      else
-        bShowGroup = 1;
-
-      /* dont display layer is query. */
-      if( (nOptFlag & 4) == 0  &&
-          GET_LAYER(map, map->layerorder[j])->type == MS_LAYER_QUERY )
-        bShowGroup = 0;
-
-      /* dont display layer if out of scale. */
-      if((nOptFlag & 1) == 0) {
-        if(map->scaledenom > 0) {
-          if((GET_LAYER(map, map->layerorder[j])->maxscaledenom > 0) &&
-              (map->scaledenom > GET_LAYER(map, map->layerorder[j])->maxscaledenom))
-            bShowGroup = 0;
-          if((GET_LAYER(map, map->layerorder[j])->minscaledenom > 0) &&
-              (map->scaledenom <= GET_LAYER(map, map->layerorder[j])->minscaledenom))
-            bShowGroup = 0;
-        }
-      }
-
-      /* The group contains one visible layer */
-      /* Draw the group */
-      if( bShowGroup )
-        break;
-    }
-  }
-
-  if( ! bShowGroup )
-    return MS_SUCCESS;
-
-  /*
-   * Work from a copy
-   */
-  *pszTemp = (char*)msSmallMalloc(strlen(pszGroupTemplate) + 1);
-  strcpy(*pszTemp, pszGroupTemplate);
-
-  /*
-   * Change group tags
-   */
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_group_name]", pszGroupName);
-
-
-  /*
-   * Create a hash table that contain info
-   * on current layer
-   */
-  myHashTable = msCreateHashTable();
-
-  /*
-   * Check for the first layer
-   * that belong to this group.
-   * Get his status and check for if.
-   */
-  for (j=0; j<map->numlayers; j++) {
-    if(GET_LAYER(map, map->layerorder[j])->group && strcmp(GET_LAYER(map, map->layerorder[j])->group, pszGroupName) == 0) {
-      snprintf(pszStatus, sizeof(pszStatus), "%d", GET_LAYER(map, map->layerorder[j])->status);
-      msInsertHashTable(myHashTable, "layer_status", pszStatus);
-      msInsertHashTable(myHashTable, "layer_visible", msLayerIsVisible(map, GET_LAYER(map, map->layerorder[j]))?"1":"0" );
-      msInsertHashTable(myHashTable, "layer_queryable", msIsLayerQueryable(GET_LAYER(map, map->layerorder[j]))?"1":"0" );
-      msInsertHashTable(myHashTable, "group_name", pszGroupName);
-
-      if(processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
-        return MS_FAILURE;
-
-      if(processIfTag(pszTemp, &(GET_LAYER(map, map->layerorder[j])->metadata), MS_FALSE) != MS_SUCCESS)
-        return MS_FAILURE;
-
-      if(processMetadata(pszTemp, &GET_LAYER(map, map->layerorder[j])->metadata) != MS_SUCCESS)
-        return MS_FAILURE;
-
-      break;
-    }
-  }
-
-  msFreeHashTable(myHashTable);
-
-  /*
-   * Process all metadata tags
-   * only web object is accessible
-  */
-  if(processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  /*
-   * check for if tag
-  */
-  if(processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  /*
-   * Check if leg_icon tag exist
-   * if so display the first layer first class icon
-   */
-  pszClassImg = strstr(*pszTemp, "[leg_icon");
-  if(pszClassImg) {
-    /* find first layer of this group */
-    for (i=0; i<map->numlayers; i++)
-      if(GET_LAYER(map, map->layerorder[i])->group && strcmp(GET_LAYER(map, map->layerorder[i])->group, pszGroupName) == 0)
-        processIcon(map, map->layerorder[i], 0, pszTemp, pszPrefix);
-  }
-
-  return MS_SUCCESS;
-}
-
-/*!
- * Replace all tags from layer template
- * with correct value.
- *
- * this function return a buffer containing
- * the template with correct values.
- *
- * buffer must be freed by caller.
-*/
-int generateLayerTemplate(char *pszLayerTemplate, mapObj *map, int nIdxLayer, hashTableObj *oLayerArgs, char **pszTemp, char* pszPrefix)
-{
-  hashTableObj *myHashTable;
-  char szStatus[10];
-  char szType[10];
-
-  int nOptFlag=0;
-  const char *pszOptFlag = NULL;
-  char *pszClassImg;
-
-  char szTmpstr[128]; /* easily big enough for the couple of instances we need */
-
-  *pszTemp = NULL;
-
-  if(!pszLayerTemplate ||
-      !map ||
-      nIdxLayer > map->numlayers ||
-      nIdxLayer < 0 ) {
-    msSetError(MS_WEBERR, "Invalid pointer.", "generateLayerTemplate()");
-    return MS_FAILURE;
-  }
-
-  if(oLayerArgs)
-    pszOptFlag = msLookupHashTable(oLayerArgs, "opt_flag");
-
-  if(pszOptFlag)
-    nOptFlag = atoi(pszOptFlag);
-
-  /* don't display deleted layers */
-  if(GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
-    return MS_SUCCESS;
-
-  /* dont display layer is off. */
-  /* check this if Opt flag is not set */
-  if((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
-    return MS_SUCCESS;
-
-  /* dont display layer is query. */
-  /* check this if Opt flag is not set */
-  if((nOptFlag & 4) == 0  && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
-    return MS_SUCCESS;
-
-  /* dont display layer if out of scale. */
-  /* check this if Opt flag is not set             */
-  if((nOptFlag & 1) == 0) {
-    if(map->scaledenom > 0) {
-      if((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) && (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
-        return MS_SUCCESS;
-      if((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) && (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
-        return MS_SUCCESS;
-    }
-  }
-
-  /*
-   * Work from a copy
-   */
-  *pszTemp = msStrdup(pszLayerTemplate);
-
-  /*
-   * Change layer tags
-   */
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]", GET_LAYER(map, nIdxLayer)->name);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_group]", GET_LAYER(map, nIdxLayer)->group);
-
-  snprintf(szTmpstr, sizeof(szTmpstr), "%d", nIdxLayer);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_index]", szTmpstr);
-
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->minscaledenom);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_minscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_minscaledenom]", szTmpstr);
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->maxscaledenom);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_maxscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_maxscaledenom]", szTmpstr);
-
-  /*
-   * Create a hash table that contain info
-   * on current layer
-   */
-  myHashTable = msCreateHashTable();
-
-  /*
-   * for now, only status and type is required by template
-   */
-  snprintf(szStatus, sizeof(szStatus), "%d", GET_LAYER(map, nIdxLayer)->status);
-  msInsertHashTable(myHashTable, "layer_status", szStatus);
-
-  snprintf(szType, sizeof(szType), "%d", GET_LAYER(map, nIdxLayer)->type);
-  msInsertHashTable(myHashTable, "layer_type", szType);
-
-  msInsertHashTable(myHashTable, "layer_name", (GET_LAYER(map, nIdxLayer)->name)? GET_LAYER(map, nIdxLayer)->name : "");
-  msInsertHashTable(myHashTable, "layer_group", (GET_LAYER(map, nIdxLayer)->group)? GET_LAYER(map, nIdxLayer)->group : "");
-  msInsertHashTable(myHashTable, "layer_visible", msLayerIsVisible(map, GET_LAYER(map, nIdxLayer))?"1":"0" );
-  msInsertHashTable(myHashTable, "layer_queryable", msIsLayerQueryable(GET_LAYER(map, nIdxLayer))?"1":"0" );
-
-  if(processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if(processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if(processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  msFreeHashTable(myHashTable);
-
-  /*
-   * Check if leg_icon tag exist
-   * if so display the first class icon
-   */
-  pszClassImg = strstr(*pszTemp, "[leg_icon");
-  if(pszClassImg) {
-    processIcon(map, nIdxLayer, 0, pszTemp, pszPrefix);
-  }
-
-  /* process all metadata tags
-   * only current layer and web object
-   * metaddata are accessible
-  */
-  if(processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if(processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-/*!
- * Replace all tags from class template
- * with correct value.
- *
- * this function return a buffer containing
- * the template with correct values.
- *
- * buffer must be freed by caller.
-*/
-int generateClassTemplate(char* pszClassTemplate, mapObj *map, int nIdxLayer, int nIdxClass, hashTableObj *oClassArgs, char **pszTemp, char* pszPrefix)
-{
-  hashTableObj *myHashTable;
-  char szStatus[10];
-  char szType[10];
-
-  char *pszClassImg;
-  int nOptFlag=0;
-  const char *pszOptFlag = NULL;
-
-  char szTmpstr[128]; /* easily big enough for the couple of instances we need */
-
-  *pszTemp = NULL;
-
-  if(!pszClassTemplate ||
-      !map ||
-      nIdxLayer > map->numlayers ||
-      nIdxLayer < 0 ||
-      nIdxClass > GET_LAYER(map, nIdxLayer)->numclasses ||
-      nIdxClass < 0) {
-
-    msSetError(MS_WEBERR, "Invalid pointer.", "generateClassTemplate()");
-    return MS_FAILURE;
-  }
-
-  if(oClassArgs)
-    pszOptFlag = msLookupHashTable(oClassArgs, "Opt_flag");
-
-  if(pszOptFlag)
-    nOptFlag = atoi(pszOptFlag);
-
-  /* don't display deleted layers */
-  if(GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
-    return MS_SUCCESS;
-
-  /* dont display class if layer is off. */
-  /* check this if Opt flag is not set */
-  if((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
-    return MS_SUCCESS;
-
-  /* dont display class if layer is query. */
-  /* check this if Opt flag is not set       */
-  if((nOptFlag & 4) == 0 && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
-    return MS_SUCCESS;
-
-  /* dont display layer if out of scale. */
-  /* check this if Opt flag is not set */
-  if((nOptFlag & 1) == 0) {
-    if(map->scaledenom > 0) {
-      if((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) && (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
-        return MS_SUCCESS;
-      if((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) && (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
-        return MS_SUCCESS;
-    }
-  }
-
-  /*
-   * Work from a copy
-   */
-  *pszTemp = (char*)msSmallMalloc(strlen(pszClassTemplate) + 1);
-  strcpy(*pszTemp, pszClassTemplate);
-
-  /*
-   * Change class tags
-   */
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_name]", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->name);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_title]", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->title);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]", GET_LAYER(map, nIdxLayer)->name);
-
-  snprintf(szTmpstr, sizeof(szTmpstr), "%d", nIdxClass);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_index]", szTmpstr);
-
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->minscaledenom);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_minscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_minscaledenom]", szTmpstr);
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->maxscaledenom);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_maxscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_maxscaledenom]", szTmpstr);
-
-  /*
-   * Create a hash table that contain info
-   * on current layer
-   */
-  myHashTable = msCreateHashTable();
-
-  /*
-   * for now, only status, type, name and group are  required by template
-   */
-  snprintf(szStatus, sizeof(szStatus), "%d", GET_LAYER(map, nIdxLayer)->status);
-  msInsertHashTable(myHashTable, "layer_status", szStatus);
-
-  snprintf(szType, sizeof(szType), "%d", GET_LAYER(map, nIdxLayer)->type);
-  msInsertHashTable(myHashTable, "layer_type", szType);
-
-  msInsertHashTable(myHashTable, "layer_name",
-                    (GET_LAYER(map, nIdxLayer)->name)? GET_LAYER(map, nIdxLayer)->name : "");
-  msInsertHashTable(myHashTable, "layer_group",
-                    (GET_LAYER(map, nIdxLayer)->group)? GET_LAYER(map, nIdxLayer)->group : "");
-  msInsertHashTable(myHashTable, "layer_visible", msLayerIsVisible(map, GET_LAYER(map, nIdxLayer))?"1":"0" );
-  msInsertHashTable(myHashTable, "layer_queryable", msIsLayerQueryable(GET_LAYER(map, nIdxLayer))?"1":"0" );
-  msInsertHashTable(myHashTable, "class_name",
-                    (GET_LAYER(map, nIdxLayer)->class[nIdxClass]->name)? GET_LAYER(map, nIdxLayer)->class[nIdxClass]->name : "");
-
-  if(processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if(processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if(processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  msFreeHashTable(myHashTable);
-
-  /*
-   * Check if leg_icon tag exist
-   */
-  pszClassImg = strstr(*pszTemp, "[leg_icon");
-  if(pszClassImg) {
-    processIcon(map, nIdxLayer, nIdxClass, pszTemp, pszPrefix);
-  }
-
-  /* process all metadata tags
-   * only current layer and web object
-   * metaddata are accessible
-  */
-  if(processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  if(processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
-    return MS_FAILURE;
-
-  return MS_SUCCESS;
-}
-
-char *generateLegendTemplate(mapservObj *mapserv)
-{
-  FILE *stream;
-  char *file = NULL;
-  int length;
-  char *pszResult = NULL;
-  char *legGroupHtml = NULL;
-  char *legLayerHtml = NULL;
-  char *legClassHtml = NULL;
-  char *legLayerHtmlCopy = NULL;
-  char *legClassHtmlCopy = NULL;
-  char *legGroupHtmlCopy = NULL;
-
-  char *legHeaderHtml = NULL;
-  char *legFooterHtml = NULL;
-
-  char *pszPrefix = NULL;
-  char *pszMapFname = NULL;
-
-  struct stat tmpStat;
-
-  const char *pszOrderMetadata = NULL;
-  const char *pszOrder = NULL;
-
-  int i,j,k;
-  char **papszGroups = NULL;
-  int nGroupNames = 0;
-
-  int nLegendOrder = 0;
-  const char *pszOrderValue;
-
-  hashTableObj *groupArgs = NULL;
-  hashTableObj *layerArgs = NULL;
-  hashTableObj *classArgs = NULL;
-
-  ms_regex_t re; /* compiled regular expression to be matched */
-
-  int  *panCurrentDrawingOrder = NULL;
-  char szPath[MS_MAXPATHLEN];
-
-  if(ms_regcomp(&re, MS_TEMPLATE_EXPR, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
-    msSetError(MS_IOERR, "Error regcomp.", "generateLegendTemplate()");
-    return NULL;
-  }
-
-  if(ms_regexec(&re, mapserv->map->legend.template, 0, NULL, 0) != 0) { /* no match */
-    msSetError(MS_IOERR, "Invalid template file name.", "generateLegendTemplate()");
-    ms_regfree(&re);
-    return NULL;
-  }
-  ms_regfree(&re);
-
-  /* -------------------------------------------------------------------- */
-  /*      Save the current drawing order. The drawing order is reset      */
-  /*      at the end of the function.                                     */
-  /* -------------------------------------------------------------------- */
-  if(mapserv->map->numlayers > 0) {
-    panCurrentDrawingOrder =
-      (int *)msSmallMalloc(sizeof(int)*mapserv->map->numlayers);
-
-    for (i=0; i<mapserv->map->numlayers; i++) {
-      if(mapserv->map->layerorder)
-        panCurrentDrawingOrder[i] = mapserv->map->layerorder[i];
-      else
-        panCurrentDrawingOrder[i] = i;
-    }
-  }
-
-  /*
-   * build prefix filename
-   * for legend icon creation
-  */
-  for(i=0; i<mapserv->request->NumParams; i++) /* find the mapfile parameter first */
-    if(strcasecmp(mapserv->request->ParamNames[i], "map") == 0) break;
-
-  if(i == mapserv->request->NumParams) {
-    const char *ms_mapfile = CPLGetConfigOption("MS_MAPFILE", NULL);
-    if(ms_mapfile)
-      pszMapFname = msStringConcatenate(pszMapFname, ms_mapfile);
-  } else {
-    if(getenv(mapserv->request->ParamValues[i])) /* an environment references the actual file to use */
-      pszMapFname = msStringConcatenate(pszMapFname, getenv(mapserv->request->ParamValues[i]));
-    else
-      pszMapFname = msStringConcatenate(pszMapFname, mapserv->request->ParamValues[i]);
-  }
-
-  if(pszMapFname) {
-    if(stat(pszMapFname, &tmpStat) != -1) {
-      int nLen;
-
-      nLen = (mapserv->map->name?strlen(mapserv->map->name):0)  + 50;
-      pszPrefix = (char*)msSmallMalloc((nLen+1) * sizeof(char));
-      snprintf(pszPrefix, nLen, "%s_%ld_%ld",
-               mapserv->map->name,
-               (long) tmpStat.st_size,
-               (long) tmpStat.st_mtime);
-      pszPrefix[nLen] = '\0';
-    }
-
-    free(pszMapFname);
-    pszMapFname = NULL;
-  } else {
-    /* -------------------------------------------------------------------- */
-    /*      map file name may not be avaible when the template functions    */
-    /*      are called from mapscript. Use the time stamp as prefix.        */
-    /* -------------------------------------------------------------------- */
-    char pszTime[20];
-
-    snprintf(pszTime, sizeof(pszTime), "%ld", (long)time(NULL));
-    pszPrefix = msStringConcatenate(pszPrefix, pszTime);
-  }
-
-  /* open template */
-  if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, mapserv->map->legend.template), "r")) == NULL) {
-    msSetError(MS_IOERR, "Error while opening template file.", "generateLegendTemplate()");
-    free(pszResult);
-    pszResult=NULL;
-    goto error;
-  }
-
-  fseek(stream, 0, SEEK_END);
-  long lengthLong = ftell(stream);
-  rewind(stream);
-  if( lengthLong < 0 || lengthLong > INT_MAX - 1 )
-  {
-    msSetError(MS_IOERR, "Too large template file.", "generateLegendTemplate()");
-    free(pszResult);
-    pszResult=NULL;
-    goto error;
-  }
-  length = (int)lengthLong;
-
-  file = (char*)malloc(length + 1);
-  if( file == NULL )
-  {
-    msSetError(MS_IOERR, "Cannot allocate memory for template file.", "generateLegendTemplate()");
-    free(pszResult);
-    pszResult=NULL;
-    goto error;
-  }
-
-  /*
-   * Read all the template file
-   */
-  IGUR_sizet(fread(file, length, 1, stream));
-  /* E. Rouault: the below issue is due to opening in "r" mode, which is a
-   * synonymous of "rt" on Windows. In that mode \r\n are turned into \n,
-   * consequently less bytes are written in the output buffer than requested.
-   * A potential fix might be to open in "rb" mode, but is the code ready
-   * to deal with Windows \r\n end of lines ? */
-  /* Disabled for now due to Windows issue, see ticket #3814
-     if( 1 != fread(file, length, 1, stream)) {
-       msSetError(MS_IOERR, "Error while reading template file.", "generateLegendTemplate()");
-       free(file);
-       fclose(stream);
-       return NULL;
-     }
-  */
-  file[length] = '\0';
-
-  if(msValidateContexts(mapserv->map) != MS_SUCCESS) { /* make sure there are no recursive REQUIRES or LABELREQUIRES expressions */
-    if(pszResult)
-      free(pszResult);
-    pszResult=NULL;
-    goto error;
-  }
-
-  /*
-   * Seperate header/footer, groups, layers and class
-   */
-  getInlineTag("leg_header_html", file, &legHeaderHtml);
-  getInlineTag("leg_footer_html", file, &legFooterHtml);
-  getInlineTag("leg_group_html", file, &legGroupHtml);
-  getInlineTag("leg_layer_html", file, &legLayerHtml);
-  getInlineTag("leg_class_html", file, &legClassHtml);
-
-  /*
-   * Retrieve arguments of all three parts
-   */
-  if(legGroupHtml)
-    if(getTagArgs("leg_group_html", file, &groupArgs) != MS_SUCCESS) {
-      if(pszResult)
-        free(pszResult);
-      pszResult=NULL;
-      goto error;
-    }
-
-  if(legLayerHtml)
-    if(getTagArgs("leg_layer_html", file, &layerArgs) != MS_SUCCESS) {
-      if(pszResult)
-        free(pszResult);
-      pszResult=NULL;
-      goto error;
-    }
-
-  if(legClassHtml)
-    if(getTagArgs("leg_class_html", file, &classArgs) != MS_SUCCESS) {
-      if(pszResult)
-        free(pszResult);
-      pszResult=NULL;
-      goto error;
-    }
-
-
-  mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent),
-                                          mapserv->map->width,
-                                          mapserv->map->height);
-  if(msCalculateScale(mapserv->map->extent, mapserv->map->units,
-                      mapserv->map->width, mapserv->map->height,
-                      mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) {
-    if(pszResult)
-      free(pszResult);
-    pszResult=NULL;
-    goto error;
-  }
-
-  /* start with the header if present */
-  if(legHeaderHtml) pszResult = msStringConcatenate(pszResult, legHeaderHtml);
-
-  /********************************************************************/
-
-  /*
-   * order layers if order_metadata args is set
-   * If not, keep default order
-   */
-  pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-
-  if(sortLayerByMetadata(mapserv->map, pszOrderMetadata) != MS_SUCCESS) {
-    if(pszResult)
-      free(pszResult);
-    pszResult=NULL;
-    goto error;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      if the order tag is set to ascending or descending, the         */
-  /*      current order will be changed to correspond to that.            */
-  /* -------------------------------------------------------------------- */
-  pszOrder = msLookupHashTable(layerArgs, "order");
-  if(pszOrder && ((strcasecmp(pszOrder, "ASCENDING") == 0) ||
-                  (strcasecmp(pszOrder, "DESCENDING") == 0))) {
-    if(sortLayerByOrder(mapserv->map, pszOrder) != MS_SUCCESS) {
-      if(pszResult)
-        free(pszResult);
-      pszResult=NULL;
-      goto error;
-    }
-  }
-
-  if(legGroupHtml) {
-    /* retrieve group names */
-    papszGroups = msGetAllGroupNames(mapserv->map, &nGroupNames);
-
-    for (i=0; i<nGroupNames; i++) {
-      /* process group tags */
-      if(generateGroupTemplate(legGroupHtml, mapserv->map, papszGroups[i], groupArgs, &legGroupHtmlCopy, pszPrefix) != MS_SUCCESS) {
-        if(pszResult)
-          free(pszResult);
-        pszResult=NULL;
-        goto error;
-      }
-
-      /* concatenate it to final result */
-      pszResult = msStringConcatenate(pszResult, legGroupHtmlCopy);
-
-      /*
-               if(!pszResult)
-               {
-                  if(pszResult)
-                    free(pszResult);
-                  pszResult=NULL;
-                  goto error;
-               }
-      */
-
-      if(legGroupHtmlCopy) {
-        free(legGroupHtmlCopy);
-        legGroupHtmlCopy = NULL;
-      }
-
-      /* for all layers in group */
-      if(legLayerHtml) {
-        for (j=0; j<mapserv->map->numlayers; j++) {
-          /*
-           * if order_metadata is set and the order
-           * value is less than 0, dont display it
-           */
-          pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-          if(pszOrderMetadata) {
-            pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-            if(pszOrderValue) {
-              nLegendOrder = atoi(pszOrderValue);
-              if(nLegendOrder < 0)
-                continue;
-            }
-          }
-          if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
-            continue;
-          }
-
-          if(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group && strcmp(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group, papszGroups[i]) == 0) {
-            /* process all layer tags */
-            if(generateLayerTemplate(legLayerHtml, mapserv->map, mapserv->map->layerorder[j], layerArgs, &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
-              if(pszResult)
-                free(pszResult);
-              pszResult=NULL;
-              goto error;
-            }
-
-
-            /* concatenate to final result */
-            pszResult = msStringConcatenate(pszResult, legLayerHtmlCopy);
-
-            if(legLayerHtmlCopy) {
-              free(legLayerHtmlCopy);
-              legLayerHtmlCopy = NULL;
-            }
-
-
-            /* for all classes in layer */
-            if(legClassHtml) {
-              for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
-                /* process all class tags */
-                if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
-                  continue;
-                if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
-                  continue;
-                }
-
-                if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-                  if(pszResult)
-                    free(pszResult);
-                  pszResult=NULL;
-                  goto error;
-                }
-
-
-                /* concatenate to final result */
-                pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
-
-                if(legClassHtmlCopy) {
-                  free(legClassHtmlCopy);
-                  legClassHtmlCopy = NULL;
-                }
-              }
-            }
-          }
-        }
-      } else if(legClassHtml) { /* no layer template specified but class and group template */
-        for (j=0; j<mapserv->map->numlayers; j++) {
-          /*
-           * if order_metadata is set and the order
-           * value is less than 0, dont display it
-           */
-          pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-          if(pszOrderMetadata) {
-            pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-            if(pszOrderValue) {
-              nLegendOrder = atoi(pszOrderValue);
-              if(nLegendOrder < 0)
-                continue;
-            }
-          }
-          if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
-            continue;
-          }
-
-          if(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group && strcmp(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group, papszGroups[i]) == 0) {
-            /* for all classes in layer */
-
-              for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
-                /* process all class tags */
-                if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
-                  continue;
-                if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
-                  continue;
-                }
-
-                if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-                  if(pszResult)
-                    free(pszResult);
-                  pszResult=NULL;
-                  goto error;
-                }
-
-
-                /* concatenate to final result */
-                pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
-
-                if(legClassHtmlCopy) {
-                  free(legClassHtmlCopy);
-                  legClassHtmlCopy = NULL;
-                }
-              }
-
-          }
-        }
-      }
-    }
-  } else {
-    /* if no group template specified */
-    if(legLayerHtml) {
-      for (j=0; j<mapserv->map->numlayers; j++) {
-        /*
-         * if order_metadata is set and the order
-         * value is less than 0, dont display it
-         */
-        pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-        if(pszOrderMetadata) {
-          pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-          if(pszOrderValue) {
-            nLegendOrder = atoi(pszOrderValue);
-            if(nLegendOrder < 0)
-              continue;
-          } else
-            nLegendOrder=0;
-        }
-        if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
-          continue;
-        }
-
-        /* process a layer tags */
-        if(generateLayerTemplate(legLayerHtml, mapserv->map, mapserv->map->layerorder[j], layerArgs, &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
-          if(pszResult)
-            free(pszResult);
-          pszResult=NULL;
-          goto error;
-        }
-
-        /* concatenate to final result */
-        pszResult = msStringConcatenate(pszResult, legLayerHtmlCopy);
-
-        if(legLayerHtmlCopy) {
-          free(legLayerHtmlCopy);
-          legLayerHtmlCopy = NULL;
-        }
-
-        /* for all classes in layer */
-        if(legClassHtml) {
-          for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
-            /* process all class tags */
-            if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
-              continue;
-            if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
-              continue;
-            }
-
-            if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-              if(pszResult)
-                free(pszResult);
-              pszResult=NULL;
-              goto error;
-            }
-
-
-            /* concatenate to final result */
-            pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
-
-            if(legClassHtmlCopy) {
-              free(legClassHtmlCopy);
-              legClassHtmlCopy = NULL;
-            }
-          }
-        }
-      }
-    } else { /* if no group and layer template specified */
-      if(legClassHtml) {
-        for (j=0; j<mapserv->map->numlayers; j++) {
-          /*
-           * if order_metadata is set and the order
-           * value is less than 0, dont display it
-           */
-          pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-          if(pszOrderMetadata) {
-            pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-            if(pszOrderValue) {
-              nLegendOrder = atoi(pszOrderValue);
-              if(nLegendOrder < 0)
-                continue;
-            }
-          }
-          if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
-            continue;
-          }
-
-          for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
-            if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
-              continue;
-            if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
-              continue;
-            }
-
-            if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-              if(pszResult)
-                free(pszResult);
-              pszResult=NULL;
-              goto error;
-            }
-
-
-            pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
-
-            if(legClassHtmlCopy) {
-              free(legClassHtmlCopy);
-              legClassHtmlCopy = NULL;
-            }
-          }
-        }
-      }
-    }
-  }
-
-  /* finish with the footer if present */
-  if(legFooterHtml) pszResult = msStringConcatenate(pszResult, legFooterHtml);
-
-  /*
-   * if we reach this point, that mean no error was generated.
-   * So check if template is null and initialize it to <space>.
-   */
-  if(pszResult == NULL) {
-    pszResult = msStringConcatenate(pszResult, " ");
-  }
-
-
-  /********************************************************************/
-
-error:
-
-  if(papszGroups) {
-    for (i=0; i<nGroupNames; i++)
-      msFree(papszGroups[i]);
-
-    msFree(papszGroups);
-  }
-
-  msFreeHashTable(groupArgs);
-  msFreeHashTable(layerArgs);
-  msFreeHashTable(classArgs);
-
-  msFree(file);
-
-  msFree(legGroupHtmlCopy);
-  msFree(legLayerHtmlCopy);
-  msFree(legClassHtmlCopy);
-
-  msFree(legHeaderHtml);
-  msFree(legFooterHtml);
-
-  msFree(legGroupHtml);
-  msFree(legLayerHtml);
-  msFree(legClassHtml);
-  msFree(pszPrefix);
-
-  if(stream)
-    fclose(stream);
-
-  /* -------------------------------------------------------------------- */
-  /*      Reset the layerdrawing order.                                   */
-  /* -------------------------------------------------------------------- */
-  if(panCurrentDrawingOrder && mapserv->map->layerorder) {
-    for (i=0; i<mapserv->map->numlayers; i++)
-      mapserv->map->layerorder[i] =  panCurrentDrawingOrder[i];
-
-    free(panCurrentDrawingOrder);
-  }
-
-  return pszResult;
-}
-
-char *processOneToManyJoin(mapservObj* mapserv, joinObj *join)
-{
-  int records=MS_FALSE;
-  FILE *stream=NULL;
-  char *outbuf;
-  char line[MS_BUFFER_LENGTH], *tmpline;
-  char szPath[MS_MAXPATHLEN];
-
-  if((outbuf = msStrdup("")) == NULL) return(NULL); /* empty at first */
-
-  msJoinPrepare(join, &(mapserv->resultshape)); /* execute the join */
-  while(msJoinNext(join) == MS_SUCCESS) {
-    /* First time through, deal with the header (if necessary) and open the main template. We only */
-    /* want to do this if there are joined records. */
-    if(records == MS_FALSE) {
-      if(join->header != NULL) {
-        /* coverity[dead_error_line] */
-        if(stream) fclose(stream);
-        if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, join->header), "r")) == NULL) {
-          msSetError(MS_IOERR, "Error while opening join header file %s.", "processOneToManyJoin()", join->header);
-          msFree(outbuf);
-          return(NULL);
-        }
-
-        if(isValidTemplate(stream, join->header) != MS_TRUE) {
-          fclose(stream);
-          msFree(outbuf);
-          return NULL;
-        }
-
-        /* echo file to the output buffer, no substitutions */
-        while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) outbuf = msStringConcatenate(outbuf, line);
-
-        fclose(stream);
-        stream = NULL;
-      }
-
-      if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, join->template), "r")) == NULL) {
-        msSetError(MS_IOERR, "Error while opening join template file %s.", "processOneToManyJoin()", join->template);
-        msFree(outbuf);
-        return(NULL);
-      }
-
-      if(isValidTemplate(stream, join->template) != MS_TRUE) {
-        fclose(stream);
-        msFree(outbuf);
-        return NULL;
-      }
-
-      records = MS_TRUE;
-    }
-
-    while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) { /* now on to the end of the template */
-      if(strchr(line, '[') != NULL) {
-        tmpline = processLine(mapserv, line, NULL, QUERY); /* no multiline tags are allowed in a join */
-        if(!tmpline) {
-           msFree(outbuf);
-           fclose(stream);
-           return NULL;
-        }
-        outbuf = msStringConcatenate(outbuf, tmpline);
-        free(tmpline);
-      } else /* no subs, just echo */
-        outbuf = msStringConcatenate(outbuf, line);
-    }
-
-    rewind(stream);
-    IGUR_voidp(fgets(line, MS_BUFFER_LENGTH, stream)); /* skip the first line since it's the magic string */
-  } /* next record */
-
-  if(records==MS_TRUE && join->footer) {
-    if(stream) fclose(stream);
-    if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, join->footer), "r")) == NULL) {
-      msSetError(MS_IOERR, "Error while opening join footer file %s.", "processOneToManyJoin()", join->footer);
-      msFree(outbuf);
-      return(NULL);
-    }
-
-    if(isValidTemplate(stream, join->footer) != MS_TRUE) {
-      msFree(outbuf);
-      fclose(stream);
-      return NULL;
-    }
-
-    /* echo file to the output buffer, no substitutions */
-    while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) outbuf = msStringConcatenate(outbuf, line);
-
-    fclose(stream);
-    stream = NULL;
-  }
-
-  /* clear any data associated with the join */
-  msFreeCharArray(join->values, join->numitems);
-  join->values = NULL;
-
-  if(stream) fclose(stream);
-
-  return(outbuf);
-}
-
-/*
-** Process a single line in the template. A few tags (e.g. [resultset]...[/resultset]) can be multi-line so
-** we pass the filehandle to look ahead if necessary.
-*/
-static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream, int mode)
-{
-  int i, j;
-#define PROCESSLINE_BUFLEN 5120
-  char repstr[PROCESSLINE_BUFLEN], substr[PROCESSLINE_BUFLEN], *outstr; /* repstr = replace string, substr = sub string */
-  struct hashObj *tp=NULL;
-  char *encodedstr;
-
-  rectObj llextent;
-  pointObj llpoint;
-
-  outstr = msStrdup(instr); /* work from a copy */
-
-  if(strstr(outstr, "[version]")) outstr = msReplaceSubstring(outstr, "[version]",  msGetVersion());
-
-  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-  outstr = msReplaceSubstring(outstr, "[img]", repstr);
-  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sref%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-  outstr = msReplaceSubstring(outstr, "[ref]", repstr);
-
-  if(strstr(outstr, "[errmsg")) {
-    char *errmsg = msGetErrorString(";");
-    if(!errmsg) errmsg = msStrdup("Error message buffer is empty."); /* should never happen, but just in case... */
-    outstr = msReplaceSubstring(outstr, "[errmsg]", errmsg);
-    encodedstr = msEncodeUrl(errmsg);
-    outstr = msReplaceSubstring(outstr, "[errmsg_esc]", encodedstr);
-    free(errmsg);
-    free(encodedstr);
-  }
-
-  if(strstr(outstr, "[legend]")) {
-    /* if there's a template legend specified, use it */
-    if(mapserv->map->legend.template) {
-      char *legendTemplate;
-
-      legendTemplate = generateLegendTemplate(mapserv);
-      if(legendTemplate) {
-        outstr = msReplaceSubstring(outstr, "[legend]", legendTemplate);
-
-        free(legendTemplate);
-      } else /* error already generated by (generateLegendTemplate()) */
-        return NULL;
-    } else { /* if not display gif image with all legend icon */
-      snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sleg%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-      outstr = msReplaceSubstring(outstr, "[legend]", repstr);
-    }
-  }
-
-  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%ssb%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-  outstr = msReplaceSubstring(outstr, "[scalebar]", repstr);
-
-  if(mapserv->savequery) {
-    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_QUERY_EXTENSION);
-    outstr = msReplaceSubstring(outstr, "[queryfile]", repstr);
-  }
-
-  if(mapserv->savemap) {
-    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.map", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id);
-    outstr = msReplaceSubstring(outstr, "[map]", repstr);
-  }
-
-  if(strstr(outstr,"[mapserv_onlineresource]")) {
-    char *ol;
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-    ol = msOWSGetOnlineResource(mapserv->map, "O", "onlineresource", mapserv->request);
-#else
-    ol = msBuildOnlineResource(mapserv->map, mapserv->request);
-#endif
-    outstr = msReplaceSubstring(outstr, "[mapserv_onlineresource]",ol);
-    msFree(ol);
-  }
-
-  if(getenv("HTTP_HOST")) {
-    snprintf(repstr, PROCESSLINE_BUFLEN, "%s", getenv("HTTP_HOST"));
-    outstr = msReplaceSubstring(outstr, "[host]", repstr);
-  }
-  if(getenv("SERVER_PORT")) {
-    snprintf(repstr, PROCESSLINE_BUFLEN, "%s", getenv("SERVER_PORT"));
-    outstr = msReplaceSubstring(outstr, "[port]", repstr);
-  }
-
-  snprintf(repstr, PROCESSLINE_BUFLEN, "%s", mapserv->Id);
-  outstr = msReplaceSubstring(outstr, "[id]", repstr);
-
-  repstr[0] = '\0'; /* Layer list for a "POST" request */
-  for(i=0; i<mapserv->NumLayers; i++) {
-    strlcat(repstr, mapserv->Layers[i], sizeof(repstr));
-    strlcat(repstr, " ", sizeof(repstr));
-  }
-  msStringTrimBlanks(repstr);
-  encodedstr = msEncodeHTMLEntities(repstr);
-  outstr = msReplaceSubstring(outstr, "[layers]", encodedstr);
-  free(encodedstr);
-
-  encodedstr = msEncodeUrl(repstr);
-  outstr = msReplaceSubstring(outstr, "[layers_esc]", encodedstr);
-  free(encodedstr);
-
-  strcpy(repstr, ""); /* list of ALL layers that can be toggled */
-  repstr[0] = '\0';
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    if(GET_LAYER(mapserv->map, i)->status != MS_DEFAULT && GET_LAYER(mapserv->map, i)->name != NULL) {
-      strlcat(repstr, GET_LAYER(mapserv->map, i)->name, sizeof(repstr));
-      strlcat(repstr, " ", sizeof(repstr));
-    }
-  }
-  msStringTrimBlanks(repstr);
-  outstr = msReplaceSubstring(outstr, "[toggle_layers]", repstr);
-
-  encodedstr = msEncodeUrl(repstr);
-  outstr = msReplaceSubstring(outstr, "[toggle_layers_esc]", encodedstr);
-  free(encodedstr);
-
-  for(i=0; i<mapserv->map->numlayers; i++) { /* Set form widgets (i.e. checkboxes, radio and select lists), note that default layers don't show up here */
-    if(isOn(mapserv, GET_LAYER(mapserv->map, i)->name, GET_LAYER(mapserv->map, i)->group) == MS_TRUE) {
-      if(GET_LAYER(mapserv->map, i)->group) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->group);
-        outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->group);
-        outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
-      }
-      if(GET_LAYER(mapserv->map, i)->name) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->name);
-        outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->name);
-        outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
-      }
-    } else {
-      if(GET_LAYER(mapserv->map, i)->group) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->group);
-        outstr = msReplaceSubstring(outstr, substr, "");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->group);
-        outstr = msReplaceSubstring(outstr, substr, "");
-      }
-      if(GET_LAYER(mapserv->map, i)->name) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->name);
-        outstr = msReplaceSubstring(outstr, substr, "");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->name);
-        outstr = msReplaceSubstring(outstr, substr, "");
-      }
-    }
-  }
-
-  for(i=-1; i<=1; i++) { /* make zoom direction persistant */
-    if(mapserv->ZoomDirection == i) {
-      snprintf(substr, sizeof(substr), "[zoomdir_%d_select]", i);
-      outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
-      snprintf(substr, sizeof(substr), "[zoomdir_%d_check]", i);
-      outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
-    } else {
-      snprintf(substr, sizeof(substr), "[zoomdir_%d_select]", i);
-      outstr = msReplaceSubstring(outstr, substr, "");
-      snprintf(substr, sizeof(substr), "[zoomdir_%d_check]", i);
-      outstr = msReplaceSubstring(outstr, substr, "");
-    }
-  }
-
-  for(i=MINZOOM; i<=MAXZOOM; i++) { /* make zoom persistant */
-    if(mapserv->Zoom == i) {
-      snprintf(substr, sizeof(substr), "[zoom_%d_select]", i);
-      outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
-      snprintf(substr, sizeof(substr), "[zoom_%d_check]", i);
-      outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
-    } else {
-      snprintf(substr, sizeof(substr), "[zoom_%d_select]", i);
-      outstr = msReplaceSubstring(outstr, substr, "");
-      snprintf(substr, sizeof(substr), "[zoom_%d_check]", i);
-      outstr = msReplaceSubstring(outstr, substr, "");
-    }
-  }
-
-  /* allow web object metadata access in template */
-
-  /*
-   * reworked by SG to use HashTable methods
-   */
-
-  if(&(mapserv->map->web.metadata) && strstr(outstr, "web_")) {
-    for (j=0; j<MS_HASHSIZE; j++) {
-      if(mapserv->map->web.metadata.items[j] != NULL) {
-        for(tp=mapserv->map->web.metadata.items[j]; tp!=NULL; tp=tp->next) {
-          snprintf(substr, PROCESSLINE_BUFLEN, "[web_%s]", tp->key);
-          outstr = msReplaceSubstring(outstr, substr, tp->data);
-          snprintf(substr, PROCESSLINE_BUFLEN, "[web_%s_esc]", tp->key);
-
-          encodedstr = msEncodeUrl(tp->data);
-          outstr = msReplaceSubstring(outstr, substr, encodedstr);
-          free(encodedstr);
-        }
-      }
-    }
-  }
-
-  /* allow layer metadata access in template */
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    if(&(GET_LAYER(mapserv->map, i)->metadata) && GET_LAYER(mapserv->map, i)->name && strstr(outstr, GET_LAYER(mapserv->map, i)->name)) {
-      for(j=0; j<MS_HASHSIZE; j++) {
-        if(GET_LAYER(mapserv->map, i)->metadata.items[j] != NULL) {
-          for(tp=GET_LAYER(mapserv->map, i)->metadata.items[j]; tp!=NULL; tp=tp->next) {
-            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]", GET_LAYER(mapserv->map, i)->name, tp->key);
-            if(GET_LAYER(mapserv->map, i)->status == MS_ON)
-              outstr = msReplaceSubstring(outstr, substr, tp->data);
-            else
-              outstr = msReplaceSubstring(outstr, substr, "");
-            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]", GET_LAYER(mapserv->map, i)->name, tp->key);
-            if(GET_LAYER(mapserv->map, i)->status == MS_ON) {
-              encodedstr = msEncodeUrl(tp->data);
-              outstr = msReplaceSubstring(outstr, substr, encodedstr);
-              free(encodedstr);
-            } else
-              outstr = msReplaceSubstring(outstr, substr, "");
-          }
-        }
-      }
-    }
-  }
-
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->mappnt.x);
-  outstr = msReplaceSubstring(outstr, "[mapx]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->mappnt.y);
-  outstr = msReplaceSubstring(outstr, "[mapy]", repstr);
-
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.minx); /* Individual mapextent elements for spatial query building, deprecated. */
-  outstr = msReplaceSubstring(outstr, "[minx]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.maxx);
-  outstr = msReplaceSubstring(outstr, "[maxx]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.miny);
-  outstr = msReplaceSubstring(outstr, "[miny]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.maxy);
-  outstr = msReplaceSubstring(outstr, "[maxy]", repstr);
-
-  if(processDateTag( &outstr ) != MS_SUCCESS)
-    return(NULL);
-
-  if(processExtentTag(mapserv, &outstr, "mapext", &(mapserv->map->extent), &(mapserv->map->projection)) != MS_SUCCESS)
-    return(NULL);
-  if(processExtentTag(mapserv, &outstr, "mapext_esc", &(mapserv->map->extent), &(mapserv->map->projection)) != MS_SUCCESS) /* depricated */
-    return(NULL);
-
-  snprintf(repstr, sizeof(repstr), "%f", (mapserv->map->extent.maxx-mapserv->map->extent.minx)); /* useful for creating cachable extents (i.e. 0 0 dx dy) with legends and scalebars */
-  outstr = msReplaceSubstring(outstr, "[dx]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", (mapserv->map->extent.maxy-mapserv->map->extent.miny));
-  outstr = msReplaceSubstring(outstr, "[dy]", repstr);
-
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.minx); /* Individual raw extent elements for spatial query building, deprecated. */
-  outstr = msReplaceSubstring(outstr, "[rawminx]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.maxx);
-  outstr = msReplaceSubstring(outstr, "[rawmaxx]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.miny);
-  outstr = msReplaceSubstring(outstr, "[rawminy]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.maxy);
-  outstr = msReplaceSubstring(outstr, "[rawmaxy]", repstr);
-
-  if(processExtentTag(mapserv, &outstr, "rawext", &(mapserv->RawExt), &(mapserv->map->projection)) != MS_SUCCESS)
-    return(NULL);
-  if(processExtentTag(mapserv, &outstr, "rawext_esc", &(mapserv->RawExt), &(mapserv->map->projection)) != MS_SUCCESS) /* depricated */
-    return(NULL);
-
-  if((strstr(outstr, "lat]") || strstr(outstr, "lon]") || strstr(outstr, "lon_esc]"))
-      && mapserv->map->projection.proj != NULL
-      && !msProjIsGeographicCRS(&(mapserv->map->projection)) ) {
-    llextent=mapserv->map->extent;
-    llpoint=mapserv->mappnt;
-    msProjectRect(&(mapserv->map->projection), &(mapserv->map->latlon), &llextent);
-    msProjectPoint(&(mapserv->map->projection), &(mapserv->map->latlon), &llpoint);
-
-    snprintf(repstr, sizeof(repstr), "%f", llpoint.x);
-    outstr = msReplaceSubstring(outstr, "[maplon]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", llpoint.y);
-    outstr = msReplaceSubstring(outstr, "[maplat]", repstr);
-
-    snprintf(repstr, sizeof(repstr), "%f", llextent.minx); /* map extent as lat/lon */
-    outstr = msReplaceSubstring(outstr, "[minlon]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", llextent.maxx);
-    outstr = msReplaceSubstring(outstr, "[maxlon]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", llextent.miny);
-    outstr = msReplaceSubstring(outstr, "[minlat]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", llextent.maxy);
-    outstr = msReplaceSubstring(outstr, "[maxlat]", repstr);
-
-    if(processExtentTag(mapserv, &outstr, "mapext_latlon", &(llextent), NULL) != MS_SUCCESS)
-      return(NULL);
-    if(processExtentTag(mapserv, &outstr, "mapext_latlon_esc", &(llextent), NULL) != MS_SUCCESS) /* depricated */
-      return(NULL);
-  }
-
-  /* submitted by J.F (bug 1102) */
-  if(mapserv->map->reference.status == MS_ON) {
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.minx); /* Individual reference map extent elements for spatial query building, depricated. */
-    outstr = msReplaceSubstring(outstr, "[refminx]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.maxx);
-    outstr = msReplaceSubstring(outstr, "[refmaxx]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.miny);
-    outstr = msReplaceSubstring(outstr, "[refminy]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.maxy);
-    outstr = msReplaceSubstring(outstr, "[refmaxy]", repstr);
-
-    if(processExtentTag(mapserv, &outstr, "refext", &(mapserv->map->reference.extent), &(mapserv->map->projection)) != MS_SUCCESS)
-      return(NULL);
-    if(processExtentTag(mapserv, &outstr, "refext_esc", &(mapserv->map->reference.extent), &(mapserv->map->projection)) != MS_SUCCESS) /* depricated */
-      return(NULL);
-  }
-
-  snprintf(repstr, sizeof(repstr), "%d %d", mapserv->map->width, mapserv->map->height);
-  outstr = msReplaceSubstring(outstr, "[mapsize]", repstr);
-
-  encodedstr = msEncodeUrl(repstr);
-  outstr = msReplaceSubstring(outstr, "[mapsize_esc]", encodedstr);
-  free(encodedstr);
-
-  snprintf(repstr, sizeof(repstr), "%d", mapserv->map->width);
-  outstr = msReplaceSubstring(outstr, "[mapwidth]", repstr);
-  snprintf(repstr, sizeof(repstr), "%d", mapserv->map->height);
-  outstr = msReplaceSubstring(outstr, "[mapheight]", repstr);
-
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->scaledenom);
-  outstr = msReplaceSubstring(outstr, "[scale]", repstr);
-  outstr = msReplaceSubstring(outstr, "[scaledenom]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->cellsize);
-  outstr = msReplaceSubstring(outstr, "[cellsize]", repstr);
-
-  snprintf(repstr, sizeof(repstr), "%.1f %.1f", (mapserv->map->width)/2.0, (mapserv->map->height)/2.0); /* not subtracting 1 from image dimensions (see bug 633) */
-  outstr = msReplaceSubstring(outstr, "[center]", repstr);
-  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->width)/2.0);
-  outstr = msReplaceSubstring(outstr, "[center_x]", repstr);
-  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->height)/2.0);
-  outstr = msReplaceSubstring(outstr, "[center_y]", repstr);
-
-  /* These are really for situations with multiple result sets only, but often used in header/footer   */
-  snprintf(repstr, sizeof(repstr), "%d", mapserv->NR); /* total number of results */
-  outstr = msReplaceSubstring(outstr, "[nr]", repstr);
-  snprintf(repstr, sizeof(repstr), "%d", mapserv->NL); /* total number of layers with results */
-  outstr = msReplaceSubstring(outstr, "[nl]", repstr);
-
-  if(mapserv->resultlayer) {
-    if(strstr(outstr, "[items]") != NULL) {
-      char *itemstr=NULL;
-
-      itemstr = msJoinStrings(mapserv->resultlayer->items, mapserv->resultlayer->numitems, ",");
-      outstr = msReplaceSubstring(outstr, "[items]", itemstr);
-      free(itemstr);
-    }
-
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->NLR); /* total number of results within this layer */
-    outstr = msReplaceSubstring(outstr, "[nlr]", repstr);
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->RN); /* sequential (eg. 1..n) result number within all layers */
-    outstr = msReplaceSubstring(outstr, "[rn]", repstr);
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->LRN); /* sequential (eg. 1..n) result number within this layer */
-    outstr = msReplaceSubstring(outstr, "[lrn]", repstr);
-    outstr = msReplaceSubstring(outstr, "[cl]", mapserv->resultlayer->name); /* current layer name */
-    /* if(resultlayer->description) outstr = msReplaceSubstring(outstr, "[cd]", resultlayer->description); */ /* current layer description */
-
-    /* allow layer metadata access when there is a current result layer (implicitly a query template) */
-    if(&(mapserv->resultlayer->metadata) && strstr(outstr, "[metadata_")) {
-      for(i=0; i<MS_HASHSIZE; i++) {
-        if(mapserv->resultlayer->metadata.items[i] != NULL) {
-          for(tp=mapserv->resultlayer->metadata.items[i]; tp!=NULL; tp=tp->next) {
-            snprintf(substr, PROCESSLINE_BUFLEN, "[metadata_%s]", tp->key);
-            outstr = msReplaceSubstring(outstr, substr, tp->data);
-
-            snprintf(substr, PROCESSLINE_BUFLEN, "[metadata_%s_esc]", tp->key);
-            encodedstr = msEncodeUrl(tp->data);
-            outstr = msReplaceSubstring(outstr, substr, encodedstr);
-            free(encodedstr);
-          }
-        }
-      }
-    }
-  }
-
-  if(mode != QUERY) {
-    if(processResultSetTag(mapserv, &outstr, stream) != MS_SUCCESS) {
-      msFree(outstr);
-      return(NULL);
-    }
-  } else { /* return shape and/or values */
-
-    assert(mapserv->resultlayer);
-
-    snprintf(repstr, sizeof(repstr), "%f %f", (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx)/2, (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny)/2);
-    outstr = msReplaceSubstring(outstr, "[shpmid]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx)/2);
-    outstr = msReplaceSubstring(outstr, "[shpmidx]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny)/2);
-    outstr = msReplaceSubstring(outstr, "[shpmidy]", repstr);
-
-    if(processExtentTag(mapserv, &outstr, "shpext", &(mapserv->resultshape.bounds), &(mapserv->resultlayer->projection)) != MS_SUCCESS)
-      return(NULL);
-    if(processExtentTag(mapserv, &outstr, "shpext_esc", &(mapserv->resultshape.bounds), &(mapserv->resultlayer->projection)) != MS_SUCCESS) /* depricated */
-      return(NULL);
-
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->resultshape.classindex);
-    outstr = msReplaceSubstring(outstr, "[shpclass]", repstr);
-
-    if(processShpxyTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) != MS_SUCCESS)
-      return(NULL);
-
-    if(processShplabelTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) != MS_SUCCESS)
-      return(NULL);
-
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.minx);
-    outstr = msReplaceSubstring(outstr, "[shpminx]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.miny);
-    outstr = msReplaceSubstring(outstr, "[shpminy]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.maxx);
-    outstr = msReplaceSubstring(outstr, "[shpmaxx]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.maxy);
-    outstr = msReplaceSubstring(outstr, "[shpmaxy]", repstr);
-
-    snprintf(repstr, sizeof(repstr), "%ld", mapserv->resultshape.index);
-    outstr = msReplaceSubstring(outstr, "[shpidx]", repstr);
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->resultshape.tileindex);
-    outstr = msReplaceSubstring(outstr, "[tileidx]", repstr);
-
-    /* return ALL attributes in one delimeted list */
-    if(strstr(outstr, "[values]") != NULL) {
-      char *valuestr=NULL;
-
-      valuestr = msJoinStrings(mapserv->resultshape.values, mapserv->resultlayer->numitems, ",");
-      outstr = msReplaceSubstring(outstr, "[values]", valuestr);
-      free(valuestr);
-    }
-
-    for(i=0; i<mapserv->resultlayer->numitems; i++) {
-      /* by default let's encode attributes for HTML presentation */
-      snprintf(substr, PROCESSLINE_BUFLEN, "[%s]", mapserv->resultlayer->items[i]);
-      if(strstr(outstr, substr) != NULL) {
-        encodedstr = msEncodeHTMLEntities(mapserv->resultshape.values[i]);
-        outstr = msReplaceSubstring(outstr, substr, encodedstr);
-        free(encodedstr);
-      }
-
-      /* of course you might want to embed that data in URLs */
-      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]", mapserv->resultlayer->items[i]);
-      if(strstr(outstr, substr) != NULL) {
-        encodedstr = msEncodeUrl(mapserv->resultshape.values[i]);
-        outstr = msReplaceSubstring(outstr, substr, encodedstr);
-        free(encodedstr);
-      }
-
-      /* or you might want to access the attributes unaltered */
-      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_raw]", mapserv->resultlayer->items[i]);
-      if(strstr(outstr, substr) != NULL)
-        outstr = msReplaceSubstring(outstr, substr, mapserv->resultshape.values[i]);
-    }
-
-    if(processItemTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) != MS_SUCCESS)
-      return(NULL);
-
-    /* handle joins in this next section */
-    for(i=0; i<mapserv->resultlayer->numjoins; i++) {
-      if(mapserv->resultlayer->joins[i].values) { /* join has data */
-        for(j=0; j<mapserv->resultlayer->joins[i].numitems; j++) {
-          /* by default let's encode attributes for HTML presentation */
-          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]", mapserv->resultlayer->joins[i].name, mapserv->resultlayer->joins[i].items[j]);
-          if(strstr(outstr, substr) != NULL) {
-            encodedstr = msEncodeHTMLEntities(mapserv->resultlayer->joins[i].values[j]);
-            outstr = msReplaceSubstring(outstr, substr, encodedstr);
-            free(encodedstr);
-          }
-
-          /* of course you might want to embed that data in URLs */
-          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]", mapserv->resultlayer->joins[i].name, mapserv->resultlayer->joins[i].items[j]);
-          if(strstr(outstr, substr) != NULL) {
-            encodedstr = msEncodeUrl(mapserv->resultlayer->joins[i].values[j]);
-            outstr = msReplaceSubstring(outstr, substr, encodedstr);
-            free(encodedstr);
-          }
-
-          /* or you might want to access the attributes unaltered */
-          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_raw]", mapserv->resultlayer->joins[i].name, mapserv->resultlayer->joins[i].items[j]);
-          if(strstr(outstr, substr) != NULL)
-            outstr = msReplaceSubstring(outstr, substr, mapserv->resultlayer->joins[i].values[j]);
-        }
-      } else if(mapserv->resultlayer->joins[i].type ==  MS_JOIN_ONE_TO_MANY) { /* one-to-many join */
-        char *joinTemplate=NULL;
-
-        snprintf(substr, PROCESSLINE_BUFLEN, "[join_%s]", mapserv->resultlayer->joins[i].name);
-        if(strstr(outstr, substr) != NULL) {
-          joinTemplate = processOneToManyJoin(mapserv, &(mapserv->resultlayer->joins[i]));
-          if(joinTemplate) {
-            outstr = msReplaceSubstring(outstr, substr, joinTemplate);
-            free(joinTemplate);
-          } else
-            return NULL;
-        }
-      }
-    } /* next join */
-
-  } /* end query mode specific substitutions */
-
-  if(processIncludeTag(mapserv, &outstr, stream, mode) != MS_SUCCESS)
-    return(NULL);
-
-  for(i=0; i<mapserv->request->NumParams; i++) {
-    /* Replace [variable] tags using values from URL. We cannot offer a
-     * [variable_raw] option here due to the risk of XSS.
-     *
-     * Replacement is case-insensitive. (#4511)
-     */
-    snprintf(substr, PROCESSLINE_BUFLEN, "[%s]", mapserv->request->ParamNames[i]);
-    encodedstr = msEncodeHTMLEntities(mapserv->request->ParamValues[i]);
-    outstr = msCaseReplaceSubstring(outstr, substr, encodedstr);
-    free(encodedstr);
-
-    snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]", mapserv->request->ParamNames[i]);
-    encodedstr = msEncodeUrl(mapserv->request->ParamValues[i]);
-    outstr = msCaseReplaceSubstring(outstr, substr, encodedstr);
-    free(encodedstr);
-  }
-
-  return(outstr);
-}
-
-#define MS_TEMPLATE_BUFFER 1024 /* 1k */
-
-int msReturnPage(mapservObj *mapserv, char *html, int mode, char **papszBuffer)
-{
-  FILE *stream;
-  char line[MS_BUFFER_LENGTH], *tmpline;
-  int   nBufferSize = 0;
-  int   nCurrentSize = 0;
-
-  ms_regex_t re; /* compiled regular expression to be matched */
-  char szPath[MS_MAXPATHLEN];
-
-  if(!html) {
-    msSetError(MS_WEBERR, "No template specified", "msReturnPage()");
-    return MS_FAILURE;
-  }
-
-  if(ms_regcomp(&re, MS_TEMPLATE_EXPR, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
-    msSetError(MS_REGEXERR, NULL, "msReturnPage()");
-    return MS_FAILURE;
-  }
-
-  if(ms_regexec(&re, html, 0, NULL, 0) != 0) { /* no match */
-    ms_regfree(&re);
-    msSetError(MS_WEBERR, "Malformed template name (%s).", "msReturnPage()", html);
-    return MS_FAILURE;
-  }
-  ms_regfree(&re);
-
-  if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, html), "r")) == NULL) {
-    msSetError(MS_IOERR, "%s", "msReturnPage()", html);
-    return MS_FAILURE;
-  }
-
-  if(isValidTemplate(stream, html) != MS_TRUE) {
-    fclose(stream);
-    return MS_FAILURE;
-  }
-
-  if(papszBuffer) {
-    if((*papszBuffer) == NULL) {
-      (*papszBuffer) = (char *)msSmallMalloc(MS_TEMPLATE_BUFFER);
-      (*papszBuffer)[0] = '\0';
-      nBufferSize = MS_TEMPLATE_BUFFER;
-      nCurrentSize = 0;
-    } else {
-      nCurrentSize = strlen((*papszBuffer));
-      nBufferSize = nCurrentSize;
-    }
-  }
-
-  while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) { /* now on to the end of the file */
-
-    if(strchr(line, '[') != NULL) {
-      tmpline = processLine(mapserv, line, stream, mode);
-      if(!tmpline) {
-        fclose(stream);
-        return MS_FAILURE;
-      }
-
-      if(papszBuffer) {
-        if(nBufferSize <= (int)(nCurrentSize + strlen(tmpline) + 1)) {
-          const int nExpandBuffer = (strlen(tmpline) /  MS_TEMPLATE_BUFFER) + 1;
-          nBufferSize = MS_TEMPLATE_BUFFER*nExpandBuffer + strlen((*papszBuffer));
-          (*papszBuffer) = (char *) msSmallRealloc((*papszBuffer),sizeof(char)*nBufferSize);
-        }
-        strcat((*papszBuffer), tmpline);
-        nCurrentSize += strlen(tmpline);
-      } else
-        msIO_fwrite(tmpline, strlen(tmpline), 1, stdout);
-
-      free(tmpline);
-    } else {
-      if(papszBuffer) {
-        if(nBufferSize <= (int)(nCurrentSize + strlen(line))) {
-          const int nExpandBuffer = (strlen(line) /  MS_TEMPLATE_BUFFER) + 1;
-          nBufferSize = MS_TEMPLATE_BUFFER*nExpandBuffer + strlen((*papszBuffer));
-          (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer),sizeof(char)*nBufferSize);
-        }
-        strcat((*papszBuffer), line);
-        nCurrentSize += strlen(line);
-      } else
-        msIO_fwrite(line, strlen(line), 1, stdout);
-    }
-    if(!papszBuffer)
-      fflush(stdout);
-  } /* next line */
-
-  fclose(stream);
-
-  return MS_SUCCESS;
-}
-
-int msReturnURL(mapservObj* ms, char* url, int mode)
-{
-  char *tmpurl;
-
-  if(url == NULL) {
-    msSetError(MS_WEBERR, "Empty URL.", "msReturnURL()");
-    return MS_FAILURE;
-  }
-
-  tmpurl = processLine(ms, url, NULL, mode); /* URL templates can't handle multi-line tags, hence the NULL file pointer */
-
-  if(!tmpurl)
-    return MS_FAILURE;
-
-  msRedirect(tmpurl);
-  free(tmpurl);
-
-  return MS_SUCCESS;
-}
-
-/*
-** Legacy query template parsing where you use headers, footers and such...
-*/
-int msReturnNestedTemplateQuery(mapservObj* mapserv, char* pszMimeType, char **papszBuffer)
-{
-  int status;
-  int i,j,k;
-  char buffer[1024];
-  int nBufferSize =0;
-  int nCurrentSize = 0;
-  int nExpandBuffer = 0;
-
-  char *template;
-
-  layerObj *lp=NULL;
-
-  if(papszBuffer) {
-    (*papszBuffer) = (char *)msSmallMalloc(MS_TEMPLATE_BUFFER);
-    (*papszBuffer)[0] = '\0';
-    nBufferSize = MS_TEMPLATE_BUFFER;
-    nCurrentSize = 0;
-    nExpandBuffer = 1;
-  }
-
-  msInitShape(&(mapserv->resultshape));
-
-  if((mapserv->Mode == ITEMQUERY) || (mapserv->Mode == QUERY)) { /* may need to handle a URL result set since these modes return exactly 1 result */
-
-    for(i=(mapserv->map->numlayers-1); i>=0; i--) {
-      lp = (GET_LAYER(mapserv->map, i));
-
-      if(!lp->resultcache) continue;
-      if(lp->resultcache->numresults > 0) break;
-    }
-
-    if(i >= 0) { /* at least if no result found, mapserver will display an empty template. */
-
-      if(lp->resultcache->results[0].classindex >= 0 && lp->class[(int)(lp->resultcache->results[0].classindex)]->template)
-        template = lp->class[(int)(lp->resultcache->results[0].classindex)]->template;
-      else
-        template = lp->template;
-
-      if( template == NULL ) {
-        msSetError(MS_WEBERR, "No template for layer %s or it's classes.", "msReturnNestedTemplateQuery()", lp->name );
-        return MS_FAILURE;
-      }
-
-      if(TEMPLATE_TYPE(template) == MS_URL) {
-        mapserv->resultlayer = lp;
-
-#if 0
-        status = msLayerOpen(lp);
-        if(status != MS_SUCCESS) return status;
-
-        status = msLayerGetItems(lp); /* retrieve all the item names */
-        if(status != MS_SUCCESS) return status;
-#endif
-
-        status = msLayerGetShape(lp, &(mapserv->resultshape), &(lp->resultcache->results[0]));
-        if(status != MS_SUCCESS) return status;
-
-        if(lp->numjoins > 0) {
-          for(k=0; k<lp->numjoins; k++) {
-            status = msJoinConnect(lp, &(lp->joins[k]));
-            if(status != MS_SUCCESS) return status;
-
-            msJoinPrepare(&(lp->joins[k]), &(mapserv->resultshape));
-            msJoinNext(&(lp->joins[k])); /* fetch the first row */
-          }
-        }
-
-        if(papszBuffer == NULL) {
-          if(msReturnURL(mapserv, template, QUERY) != MS_SUCCESS) return MS_FAILURE;
-        }
-
-        msFreeShape(&(mapserv->resultshape));
-        /* msLayerClose(lp); */
-        mapserv->resultlayer = NULL;
-
-        return MS_SUCCESS;
-      }
-    }
-  }
-
-  /*
-  ** Now we know we're making a template sandwich
-  */
-  mapserv->NR = mapserv->NL = 0;
-  for(i=0; i<mapserv->map->numlayers; i++) { /* compute some totals */
-    lp = (GET_LAYER(mapserv->map, i));
-
-    if(!lp->resultcache) continue;
-
-    if(lp->resultcache->numresults > 0) {
-      mapserv->NL++;
-      mapserv->NR += lp->resultcache->numresults;
-    }
-  }
-
-  /*
-  ** Is this step really necessary for buffered output? Legend and browse templates don't deal with mime-types
-  ** so why should this. Note that new-style templates don't buffer the mime-type either.
-  */
-  if(papszBuffer && mapserv->sendheaders) {
-    snprintf(buffer, sizeof(buffer), "Content-Type: %s%c%c", pszMimeType, 10, 10);
-    if(nBufferSize <= (int)(nCurrentSize + strlen(buffer) + 1)) {
-      nExpandBuffer++;
-      (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer), MS_TEMPLATE_BUFFER*nExpandBuffer);
-      nBufferSize = MS_TEMPLATE_BUFFER*nExpandBuffer;
-    }
-    strcat((*papszBuffer), buffer);
-    nCurrentSize += strlen(buffer);
-  } else if(mapserv->sendheaders) {
-    msIO_setHeader("Content-Type","%s",pszMimeType);
-    msIO_sendHeaders();
-  }
-
-  if(mapserv->map->web.header) {
-    if(msReturnPage(mapserv, mapserv->map->web.header, BROWSE, papszBuffer) != MS_SUCCESS) return MS_FAILURE;
-  }
-
-  mapserv->RN = 1; /* overall result number */
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    mapserv->resultlayer = lp = (GET_LAYER(mapserv->map, mapserv->map->layerorder[i]));
-
-    if(!lp->resultcache) continue;
-    if(lp->resultcache->numresults <= 0) continue;
-
-    mapserv->NLR = lp->resultcache->numresults;
-
-#if 0
-    status = msLayerOpen(lp); /* open this layer */
-    if(status != MS_SUCCESS) return status;
-
-    status = msLayerGetItems(lp); /* retrieve all the item names */
-    if(status != MS_SUCCESS) return status;
-#endif
-
-    if(lp->numjoins > 0) { /* open any necessary JOINs here */
-      for(k=0; k<lp->numjoins; k++) {
-        status = msJoinConnect(lp, &(lp->joins[k]));
-        if(status != MS_SUCCESS) return status;
-      }
-    }
-
-    if(lp->header) {
-      if(msReturnPage(mapserv, lp->header, BROWSE, papszBuffer) != MS_SUCCESS) return MS_FAILURE;
-    }
-
-    mapserv->LRN = 1; /* layer result number */
-    for(j=0; j<lp->resultcache->numresults; j++) {
-      status = msLayerGetShape(lp, &(mapserv->resultshape), &(lp->resultcache->results[j]));
-      if(status != MS_SUCCESS) return status;
-
-      /* prepare any necessary JOINs here (one-to-one only) */
-      if(lp->numjoins > 0) {
-        for(k=0; k<lp->numjoins; k++) {
-          if(lp->joins[k].type == MS_JOIN_ONE_TO_ONE) {
-            msJoinPrepare(&(lp->joins[k]), &(mapserv->resultshape));
-            msJoinNext(&(lp->joins[k])); /* fetch the first row */
-          }
-        }
-      }
-
-      if(lp->resultcache->results[j].classindex >= 0 && lp->class[(int)(lp->resultcache->results[j].classindex)]->template)
-        template = lp->class[(int)(lp->resultcache->results[j].classindex)]->template;
-      else
-        template = lp->template;
-
-      if(msReturnPage(mapserv, template, QUERY, papszBuffer) != MS_SUCCESS) {
-        msFreeShape(&(mapserv->resultshape));
-        return MS_FAILURE;
-      }
-
-      msFreeShape(&(mapserv->resultshape)); /* init too */
-
-      mapserv->RN++; /* increment counters */
-      mapserv->LRN++;
-    }
-
-    if(lp->footer) {
-      if(msReturnPage(mapserv, lp->footer, BROWSE, papszBuffer) != MS_SUCCESS) return MS_FAILURE;
-    }
-
-    /* msLayerClose(lp); */
-    mapserv->resultlayer = NULL;
-  }
-
-  if(mapserv->map->web.footer)
-    return msReturnPage(mapserv, mapserv->map->web.footer, BROWSE, papszBuffer);
-
-  return MS_SUCCESS;
-}
-
-int msReturnOpenLayersPage(mapservObj *mapserv)
-{
-  int i;
-  char *buffer = NULL, *layer = NULL;
-  const char *tmpUrl = NULL;
-  const char *openlayersUrl = olUrl;
-  char *projection = NULL;
-  char *format = NULL;
-
-  /* 2 CGI parameters are used in the template. we need to transform them
-   * to be sure the case match during the template processing. We also
-   * need to search the SRS/CRS parameter to get the projection info. OGC
-   * services version >= 1.3.0 uses CRS rather than SRS */
-  for( i=0; i<mapserv->request->NumParams; i++) {
-    if( (strcasecmp(mapserv->request->ParamNames[i], "SRS") == 0) ||
-        (strcasecmp(mapserv->request->ParamNames[i], "CRS") == 0) ) {
-      projection = mapserv->request->ParamValues[i];
-    } else if(strcasecmp(mapserv->request->ParamNames[i], "LAYERS") == 0) {
-      free(mapserv->request->ParamNames[i]);
-      mapserv->request->ParamNames[i] = msStrdup("LAYERS");
-    } else if(strcasecmp(mapserv->request->ParamNames[i], "VERSION") == 0) {
-      free(mapserv->request->ParamNames[i]);
-      mapserv->request->ParamNames[i] = msStrdup("VERSION");
-    }
-  }
-  if(mapserv->map->outputformat->mimetype && *mapserv->map->outputformat->mimetype) {
-    format = mapserv->map->outputformat->mimetype;
-  }
-
-  /* check if the environment variable or config MS_OPENLAYERS_JS_URL is set */
-  tmpUrl = msGetConfigOption(mapserv->map, "MS_OPENLAYERS_JS_URL");
-  if(tmpUrl == NULL) tmpUrl = CPLGetConfigOption("MS_OPENLAYERS_JS_URL", NULL);
-  
-  if(tmpUrl)
-    openlayersUrl = (char *)tmpUrl;
-
-  if (mapserv->Mode == BROWSE) {
-    msSetError(MS_WMSERR, "At least one layer name required in LAYERS.",
-               "msWMSLoadGetMapParams()");
-    layer = processLine(mapserv, olLayerMapServerTag, NULL, BROWSE);
-  } else
-    layer = processLine(mapserv, olLayerWMSTag, NULL, BROWSE);
-
-  buffer = processLine(mapserv, olTemplate, NULL, BROWSE);
-  buffer = msReplaceSubstring(buffer, "[openlayers_js_url]", openlayersUrl);
-  buffer = msReplaceSubstring(buffer, "[openlayers_layer]", layer);
-  if (projection)
-    buffer = msReplaceSubstring(buffer, "[openlayers_projection]", projection);
-  if (format)
-    buffer = msReplaceSubstring(buffer, "[openlayers_format]", format);
-  else
-    buffer = msReplaceSubstring(buffer, "[openlayers_format]", "image/jpeg");
-  msIO_fwrite(buffer, strlen(buffer), 1, stdout);
-  free(layer);
-  free(buffer);
-
-  return MS_SUCCESS;
-}
-
-mapservObj *msAllocMapServObj()
-{
-  mapservObj *mapserv = msSmallMalloc(sizeof(mapservObj));
-
-  mapserv->savemap=MS_FALSE;
-  mapserv->savequery=MS_FALSE; /* should the query and/or map be saved  */
-
-  mapserv->sendheaders = MS_TRUE;
-
-  mapserv->request = msAllocCgiObj();
-
-  mapserv->map=NULL;
-
-  mapserv->NumLayers=0; /* number of layers specfied by a user */
-  mapserv->MaxLayers=0; /* allocated size of Layers[] array */
-  mapserv->Layers = NULL;
-
-  mapserv->icon = NULL;
-
-  mapserv->RawExt.minx=-1;
-  mapserv->RawExt.miny=-1;
-  mapserv->RawExt.maxx=-1;
-  mapserv->RawExt.maxy=-1;
-
-  mapserv->fZoom=1;
-  mapserv->Zoom=1; /* default for browsing */
-
-  mapserv->resultlayer=NULL;
-
-  mapserv->UseShapes=MS_FALSE;
-
-  mapserv->mappnt.x=-1;
-  mapserv->mappnt.y=-1;
-
-  mapserv->ZoomDirection=0; /* whether zooming in or out, default is pan or 0 */
-
-  mapserv->Mode=BROWSE; /* can be BROWSE, QUERY, etc. */
-
-  sprintf(mapserv->Id, "%ld%d", (long)time(NULL), (int)getpid());
-
-  mapserv->CoordSource=NONE;
-  mapserv->ScaleDenom=0;
-
-  mapserv->ImgRows=-1;
-  mapserv->ImgCols=-1;
-
-  mapserv->ImgExt.minx=-1;
-  mapserv->ImgExt.miny=-1;
-  mapserv->ImgExt.maxx=-1;
-  mapserv->ImgExt.maxy=-1;
-
-  mapserv->ImgBox.minx=-1;
-  mapserv->ImgBox.miny=-1;
-  mapserv->ImgBox.maxx=-1;
-  mapserv->ImgBox.maxy=-1;
-
-  mapserv->RefPnt.x=-1;
-  mapserv->RefPnt.y=-1;
-  mapserv->ImgPnt.x=-1;
-  mapserv->ImgPnt.y=-1;
-
-  mapserv->Buffer=0;
-
-  /*
-  ** variables for multiple query results processing
-  */
-  mapserv->RN=0; /* overall result number */
-  mapserv->LRN=0; /* result number within a layer */
-  mapserv->NL=0; /* total number of layers with results */
-  mapserv->NR=0; /* total number or results */
-  mapserv->NLR=0; /* number of results in a layer */
-
-  mapserv->SearchMap=MS_FALSE; /* apply pan/zoom BEFORE doing the query (e.g. query the output image rather than the input image) */
-
-  mapserv->QueryFile=NULL;
-  mapserv->QueryLayer=NULL;
-  mapserv->SelectLayer=NULL;
-  mapserv->QueryLayerIndex=-1;
-  mapserv->SelectLayerIndex=-1;
-  mapserv->QueryItem=NULL;
-  mapserv->QueryString=NULL;
-  mapserv->ShapeIndex=-1;
-  mapserv->TileIndex=-1;
-  mapserv->TileMode=TILE_GMAP;
-  mapserv->TileCoords=NULL;
-  mapserv->TileWidth=-1;
-  mapserv->TileHeight=-1;
-  mapserv->QueryCoordSource=NONE;
-  mapserv->ZoomSize=0; /* zoom absolute magnitude (i.e. > 0) */
-
-  mapserv->hittest = NULL;
-
-  return mapserv;
-}
-
-void msFreeMapServObj(mapservObj* mapserv)
-{
-  int i;
-
-  if(mapserv) {
-    if( mapserv->map ) {
-      if(mapserv->hittest) {
-        freeMapHitTests(mapserv->map,mapserv->hittest);
-        free(mapserv->hittest);
-      }
-      msFreeMap(mapserv->map);
-      mapserv->map = NULL;
-    }
-
-    if( mapserv->request ) {
-      msFreeCgiObj(mapserv->request);
-      mapserv->request = NULL;
-    }
-
-    for(i=0; i<mapserv->NumLayers; i++)
-      msFree(mapserv->Layers[i]);
-    msFree(mapserv->Layers);
-
-    msFree(mapserv->icon);
-
-    msFree(mapserv->QueryItem);
-    msFree(mapserv->QueryString);
-    msFree(mapserv->QueryLayer);
-    msFree(mapserv->SelectLayer);
-    msFree(mapserv->QueryFile);
-
-    msFree(mapserv->TileCoords);
-
-    msFree(mapserv);
-  }
-}
-
-/*
-** Ensure there is at least one free entry in the Layers array.
-**
-** This function is safe to use for the initial allocation of the Layers[]
-** array as well (i.e. when MaxLayers==0 and Layers==NULL)
-**
-** Returns MS_SUCCESS/MS_FAILURE
-*/
-int msGrowMapservLayers( mapservObj* mapserv )
-{
-  /* Do we need to increase the size of Layers[] by MS_LAYER_ALLOCSIZE? */
-  if(mapserv->NumLayers == mapserv->MaxLayers) {
-    int i;
-
-    if(mapserv->MaxLayers == 0) {
-      /* initial allocation of array */
-      mapserv->MaxLayers += MS_LAYER_ALLOCSIZE;
-      mapserv->NumLayers = 0;
-      mapserv->Layers = (char**)msSmallMalloc(mapserv->MaxLayers*sizeof(char*));
-    } else {
-      /* realloc existing array */
-      mapserv->MaxLayers += MS_LAYER_ALLOCSIZE;
-      mapserv->Layers = (char**)msSmallRealloc(mapserv->Layers, mapserv->MaxLayers*sizeof(char*));
-    }
-
-    if(mapserv->Layers == NULL) {
-      msSetError(MS_MEMERR, "Failed to allocate memory for Layers array.", "msGrowMappservLayers()");
-      return MS_FAILURE;
-    }
-
-    for(i=mapserv->NumLayers; i<mapserv->MaxLayers; i++) {
-      mapserv->Layers[i] = NULL;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Utility function to generate map, legend, scalebar and reference images.
-**
-** Parameters:
-**   - mapserv: mapserv object (used to extract the map object).
-**   - bQueryMap: if set to TRUE a query map will be created instead of a regular map.
-**   - bReturnOnError: if set to TRUE, the function will return on the first error, else it will try to generate all the images.
-*/
-int msGenerateImages(mapservObj *mapserv, int bQueryMap, int bReturnOnError)
-{
-  char buffer[1024];
-
-  if(mapserv) {
-
-    /* render the map OR query map */
-    if((!bQueryMap && mapserv->map->status == MS_ON) || (bQueryMap && mapserv->map->querymap.status == MS_ON)) {
-      imageObj *image = NULL;
-
-      image = msDrawMap(mapserv->map, bQueryMap);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%s%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
-          msFreeImage(image);
-          return MS_FAILURE;
-        }
-        msFreeImage(image);
-      } else if(bReturnOnError)
-        return MS_FAILURE;
-    }
-
-    /* render the legend */
-    if(mapserv->map->legend.status == MS_ON) {
-      imageObj *image = NULL;
-      image = msDrawLegend(mapserv->map, MS_FALSE, NULL);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%sleg%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
-          msFreeImage(image);
-          return MS_FAILURE;
-        }
-        msFreeImage(image);
-      } else if(bReturnOnError)
-        return MS_FAILURE;
-    }
-
-    /* render the scalebar */
-    if(mapserv->map->scalebar.status == MS_ON) {
-      imageObj *image = NULL;
-      image = msDrawScalebar(mapserv->map);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%ssb%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
-          msFreeImage(image);
-          return MS_FAILURE;
-        }
-        msFreeImage(image);
-      } else if(bReturnOnError)
-        return MS_FAILURE;
-    }
-
-    /* render the reference map */
-    if(mapserv->map->reference.status == MS_ON) {
-      imageObj *image;
-      image = msDrawReferenceMap(mapserv->map);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%sref%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
-          msFreeImage(image);
-          return MS_FAILURE;
-        }
-        msFreeImage(image);
-      } else if(bReturnOnError)
-        return MS_FAILURE;
-    }
-
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Utility function to open a template file, process it and
-** and return into a buffer the processed template. Uses the
-** template file from the web object. Returns NULL if there is
-** an error.
-*/
-char *msProcessTemplate(mapObj *map, int bGenerateImages, char **names, char **values, int numentries)
-{
-  char *pszBuffer = NULL;
-
-  if(map) {
-
-    /* Initialize object and set appropriate defaults. */
-    mapservObj  *mapserv  = NULL;
-    mapserv = msAllocMapServObj();
-
-    mapserv->map = map;
-    mapserv->Mode = BROWSE;
-
-    if(names && values && numentries > 0) {
-      msFreeCharArray(mapserv->request->ParamNames, mapserv->request->NumParams);
-      msFreeCharArray(mapserv->request->ParamValues, mapserv->request->NumParams);
-      mapserv->request->ParamNames = names;
-      mapserv->request->ParamValues = values;
-      mapserv->request->NumParams = numentries;
-    }
-
-    /*
-    ** ISSUE/TODO : some of the name/values should be extracted and
-    ** processed (ex imgext, layers, ...) as it is done in function
-    ** loadform.
-    */
-
-    if(bGenerateImages)
-      msGenerateImages(mapserv, MS_FALSE, MS_FALSE);
-
-    /*
-    ** Process the template.
-    **
-    ** TODO : use web minscaledenom/maxscaledenom depending on the scale.
-    */
-    if(msReturnPage(mapserv, mapserv->map->web.template, BROWSE, &pszBuffer) != MS_SUCCESS) {
-      msFree(pszBuffer);
-      pszBuffer = NULL;
-    }
-
-    /* Don't free the map and names and values arrays since they were passed by reference. */
-    mapserv->map = NULL;
-    mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
-    mapserv->request->NumParams = 0;
-    msFreeMapServObj(mapserv);
-  }
-
-  return pszBuffer;
-}
-
-/*
-** Utility method to process the legend template.
-*/
-char *msProcessLegendTemplate(mapObj *map, char **names, char **values, int numentries)
-{
-  char *pszOutBuf = NULL;
-
-  if(map && map->legend.template) {
-
-    /* Initialize object and set appropriate defaults. */
-    mapservObj  *mapserv  = NULL;
-    mapserv = msAllocMapServObj();
-
-    mapserv->map = map;
-    mapserv->Mode = BROWSE;
-
-    if(names && values && numentries > 0) {
-      msFreeCharArray(mapserv->request->ParamNames, mapserv->request->NumParams);
-      msFreeCharArray(mapserv->request->ParamValues, mapserv->request->NumParams);
-      mapserv->request->ParamNames = names;
-      mapserv->request->ParamValues = values;
-      mapserv->request->NumParams = numentries;
-    }
-
-    pszOutBuf = generateLegendTemplate(mapserv);
-
-    /* Don't free the map and names and values arrays since they were passed by reference. */
-    mapserv->map = NULL;
-    mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
-    mapserv->request->NumParams = 0;
-    msFreeMapServObj(mapserv);
-  }
-
-  return pszOutBuf;
-}
-
-/*
-** Utility function that process a template file(s) used in the
-** query and return the processed template(s) in a buffer.
-*/
-char *msProcessQueryTemplate(mapObj *map, int bGenerateImages, char **names, char **values, int numentries)
-{
-  char *pszBuffer = NULL;
-
-  if(map) {
-
-    /* Initialize object and set appropriate defaults. */
-    mapservObj *mapserv = NULL;
-    mapserv = msAllocMapServObj();
-
-    mapserv->map = map;
-    mapserv->Mode = QUERY;
-
-    if(names && values && numentries > 0) {
-      msFreeCharArray(mapserv->request->ParamNames, mapserv->request->NumParams);
-      msFreeCharArray(mapserv->request->ParamValues, mapserv->request->NumParams);
-      mapserv->request->ParamNames = names;
-      mapserv->request->ParamValues = values;
-      mapserv->request->NumParams = numentries;
-    }
-
-    if(bGenerateImages)
-      msGenerateImages(mapserv, MS_TRUE, MS_FALSE);
-
-    mapserv->sendheaders = MS_FALSE;
-    IGNORE_RET_VAL(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, &pszBuffer));
-
-    mapserv->map = NULL;
-    mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
-    mapserv->request->NumParams = 0;
-    msFreeMapServObj(mapserv);
-  }
-
-  return pszBuffer;
-}
diff -pruN 8.0.1-5/maptemplate.h 8.2.0~beta1-1~exp1/maptemplate.h
--- 8.0.1-5/maptemplate.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptemplate.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,199 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Template processing related declarations.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPTEMPLATE_H
-#define MAPTEMPLATE_H
-
-#include "mapserver.h"
-#include "maphash.h"
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#define IDPATTERN "^[0-9A-Za-z]{1,63}$"
-#define IDSIZE 64
-#define TEMPLATE_TYPE(s)  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) || (strncmp("ftp://", s, 6)) == 0)  ? MS_URL : MS_FILE)
-#define MAXZOOM 25
-#define MINZOOM -25
-#define DEFAULT_DATE_FORMAT "%d/%b/%Y:%H:%M:%S %z"
-
-enum coordSources {NONE, FROMIMGPNT, FROMIMGBOX, FROMIMGSHAPE, FROMREFPNT, FROMUSERPNT, FROMUSERBOX, FROMUSERSHAPE, FROMBUF, FROMSCALE, FROMTILE};
-
-enum modes {BROWSE, ZOOMIN, ZOOMOUT, MAP, LEGEND, LEGENDICON, REFERENCE, SCALEBAR, COORDINATE,
-            QUERY, NQUERY, ITEMQUERY, ITEMNQUERY,
-            FEATUREQUERY, FEATURENQUERY, ITEMFEATUREQUERY, ITEMFEATURENQUERY,
-            INDEXQUERY, TILE, OWS, WFS, MAPLEGEND, MAPLEGENDICON
-           };
-
-
-/* struct mapservObj
- * Global structure used by templates and mapserver CGI interface.
- *
- * This structur was created to seperate template functionality
- * from the main mapserv file. Instead of moving all template
- * related functions in a new file (maptemplate.c) and change
- * their signatures to pass all global variables, we created this
- * structure with all global variables needed by template.
-*/
-typedef struct {
-  /* should the query and/or map be saved */
-  int savemap, savequery;
-
-  cgiRequestObj *request;
-
-  int sendheaders; /* should mime-type header be output, default will be MS_TRUE */
-
-  mapObj *map;
-
-  char **Layers;
-  char *icon; /* layer:class combination that defines a legend icon */
-
-  int NumLayers; /* number of layers specfied by a use */
-  int MaxLayers; /* Allocated size of Layers[] array */
-
-  layerObj *resultlayer;
-
-  int UseShapes; /* are results of a query to be used in calculating an extent of some sort */
-
-  shapeObj resultshape;
-
-  rectObj RawExt;
-
-  pointObj mappnt;
-
-  double fZoom, Zoom;
-  int ZoomDirection; /* whether zooming in or out, default is pan or 0 */
-
-  int Mode; /* can be BROWSE, QUERY, etc. */
-
-  int TileMode; /* can be GMAP, VE */
-  char *TileCoords; /* for GMAP: 0 0 1; for VE: 013021023 */
-  int TileWidth;
-  int TileHeight;
-
-  char Id[IDSIZE]; /* big enough for time + pid */
-
-  int CoordSource;
-  double ScaleDenom; /* used to create a map extent around a point */
-
-  int ImgRows, ImgCols;
-  rectObj ImgExt; /* Existing image's mapextent */
-  rectObj ImgBox;
-
-  pointObj RefPnt;
-  pointObj ImgPnt;
-
-  double Buffer;
-
-  int SearchMap; /* apply pan/zoom BEFORE doing the query (e.g. query the output image rather than the input image) */
-
-  char *QueryFile;
-  char *QueryLayer;
-  char *SelectLayer;
-  int QueryLayerIndex;
-  int SelectLayerIndex;
-
-  char *QueryItem;
-  char *QueryString;
-
-  int ShapeIndex;
-  int TileIndex;
-
-  int QueryCoordSource;
-
-  int ZoomSize; /* zoom absolute magnitude (i.e. > 0) */
-
-  /*
-  ** variables for multiple query results processing
-  */
-  int RN; /* overall result number */
-  int LRN; /* result number within a layer */
-  int NL; /* total number of layers with results */
-  int NR; /* total number or results */
-  int NLR; /* number of results in a layer */
-
-  map_hittest *hittest;
-
-} mapservObj;
-
-
-
-/*! \fn msAllocMapServObj
- * Allocate memory for all variables in strusture
- * and initiate default values
-*/
-MS_DLL_EXPORT mapservObj* msAllocMapServObj(void);
-
-/*! \fn msFreeMapServObj
- * free all variables in structure
-*/
-MS_DLL_EXPORT void msFreeMapServObj(mapservObj* msObj);
-
-/* For Mapserv.c */
-MS_DLL_EXPORT int isOn(mapservObj* msObj, char *name, char *group);
-MS_DLL_EXPORT int checkWebScale(mapservObj *msObj);
-MS_DLL_EXPORT int setExtent(mapservObj *msObj);
-
-MS_DLL_EXPORT int msReturnPage(mapservObj* msObj, char* , int, char **);
-MS_DLL_EXPORT int msReturnURL(mapservObj* msObj, char*, int);
-MS_DLL_EXPORT int msReturnNestedTemplateQuery(mapservObj* msObj, char* pszMimeType, char **papszBuffer);
-MS_DLL_EXPORT int msReturnTemplateQuery(mapservObj *msObj, char* pszMimeType,  char **papszBuffer);
-MS_DLL_EXPORT int msReturnOpenLayersPage(mapservObj *mapserv);
-
-MS_DLL_EXPORT int msRedirect(char* url);
-
-MS_DLL_EXPORT char *generateLegendTemplate(mapservObj *msObj);
-
-MS_DLL_EXPORT int msGenerateImages(mapservObj *msObj, int bQueryMap, int bReturnOnError);
-
-
-MS_DLL_EXPORT char *msProcessTemplate(mapObj *map, int bGenerateImages,
-                                      char **names, char **values,
-                                      int numentries);
-
-MS_DLL_EXPORT char *msProcessLegendTemplate(mapObj *map,
-    char **names, char **values,
-    int numentries);
-
-MS_DLL_EXPORT char *msProcessQueryTemplate(mapObj *map,
-    int bGenerateImages,
-    char **names, char **values,
-    int numentries);
-
-MS_DLL_EXPORT int msGrowMapservLayers( mapservObj* msObj );
-
-#ifdef __cplusplus
-} /* extern C */
-#endif
-
-#endif
-
-
-
diff -pruN 8.0.1-5/mapthread.c 8.2.0~beta1-1~exp1/mapthread.c
--- 8.0.1-5/mapthread.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapthread.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,318 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  UMN MapServer
- * Purpose:  Support code for abstracting thread issues.
- * Author:   Frank Warmerdam, warmerdam@pobox.com
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-/******************************************************************************
-
-            THREAD-SAFE SUPPORT IN MAPSERVER
-            ================================
-
-If thread safety is enabled the USE_THREAD macro will be defined.
-
-Thread API (mapthread.h/c)
---------------------------
-
-This API is made available to avoid having dependencies on different
-thread libraries in lots of places in MapServer.  It is intended to provide
-minimal services required by mapserver and isn't intended to be broadly useful.
-It should be available for Win32 and pthreads environments.  It should be
-possible to implement for other thread libraries if needed.
-
-  int msGetThreadId():
-    Returns the current threads integer id.  This can be used for making
-        some information thread specific, as has been done for the global
-        error context in maperror.c.
-
-  void msAcquireLock(int):
-        Acquires the indicated Mutex.  If it is already held by another thread
-        then this thread will block till the other thread releases it.  If
-        this thread already holds the mutex then behaviour is undefined.  If
-        the mutex id is not valid (not in the range 0 to TLOCK_STATIC_MAX)
-        then results are undefined.
-
-  void msReleaseLock(int):
-        Releases the indicated mutex.  If the lock id is invalid, or if the
-        mutex is not currently held by this thread then results are undefined.
-
-It is incredibly important to ensure that any mutex that is acquired is
-released as soon as possible.  Any flow of control that could result in a
-mutex not being release is going to be a disaster.
-
-The mutex numbers are defined in mapthread.h with the TLOCK_* codes.  If you
-need a new mutex, add a #define in mapthread.h for it.  Currently there is
-no "dynamic" mutex allocation, but this could be added.
-
-
-Making Things Thread-safe
--------------------------
-
-Generally, to make MapServer thread-safe it is necessary to ensure that
-different threads aren't read and updating common datastructures at the same
-time and that all appropriate state be kept thread specific.
-
-Generally this will mean:
-  o The previously global error status (errorObj ms_error) is now thread
-    specific.  Use msGetErrorObj() to get the current threads error state.
-
-  o Use of subcomponents that are not thread safe need to be protected by
-    a Mutex (lock).
-
-Currently a mutex is used for the entire map file parsing operation
-(msLoadMap() in mapfile.c) since the yacc parser uses a number of global
-variables.
-
-It is also done with pj_init() from PROJ.4 since this does not appear to be
-thread safe.  It isn't yet clear if pj_transform() is thread safe.
-
-It is expected that mutexes will need to be employed in a variety of other
-places to ensure serialized access to risky functionality.  This may apply
-to sublibraries like GDAL for instance.
-
-If a new section that is not thread-safe is identified (and assuming it
-can't be internally modified to make it thread-safe easily), it is necessary
-to define a new mutex (#define a TLOCK code in mapthread.h), and then
-surround the resource with acquire and release lock calls.
-
-eg.
-    msAcquireLock( TLOCK_PROJ );
-    if( !(p->proj = pj_init(p->numargs, p->args)) ) {
-        msReleaseLock( TLOCK_PROJ );
-        msSetError(MS_PROJERR, pj_strerrno(pj_errno),
-                   "msProcessProjection()");
-        return(-1);
-    }
-
-    msReleaseLock( TLOCK_PROJ );
-
-It is imperative that any acquired locks be released on all possible
-control paths or else the MapServer will lock up as other thread try to
-acquire the lock and block forever.
-
-
-Other Thread-safe Issues
-------------------------
-
-Some issues are not easily corrected with Mutexes or other similar
-mechanisms.  The following restrictions currently apply to MapServer when
-trying to use it in thread-safe mode.  Note that failure to adhere to these
-constraints will not usually generate nice error messages, instead operation
-will just fail sometimes.
-
-1) It is currently assumed that a mapObj belongs only to one thread at a time.
-That is, there is no effort to syncronize access to a mapObj itself.
-
-2) Stuff that results in a chdir() call are problematic.  In particular, the
-.map file SHAPEPATH directive should not be used.  Use full paths to data
-files instead.
-
-******************************************************************************/
-
-
-#include <assert.h>
-#include "mapserver.h"
-#include "mapthread.h"
-
-
-
-#if defined(USE_THREAD)
-static int thread_debug = 0;
-
-static char *const lock_names[] = {
-  NULL, "PARSER", "GDAL", "ERROROBJ", "PROJ", "TTF", "POOL", "SDE",
-  "ORACLE", "OWS", "LAYER_VTABLE", "IOCONTEXT", "TMPFILE", "DEBUGOBJ", "OGR", "TIME", "FRIBIDI", "WXS", "GEOS", NULL
-};
-#endif
-
-/************************************************************************/
-/* ==================================================================== */
-/*                               PTHREADS                               */
-/* ==================================================================== */
-/************************************************************************/
-
-#if defined(USE_THREAD) && !defined(_WIN32)
-
-#include "pthread.h"
-
-static int mutexes_initialized = 0;
-static pthread_mutex_t mutex_locks[TLOCK_MAX];
-
-/************************************************************************/
-/*                            msThreadInit()                            */
-/************************************************************************/
-
-void msThreadInit()
-
-{
-  static pthread_mutex_t core_lock = PTHREAD_MUTEX_INITIALIZER;
-
-  if( thread_debug )
-    fprintf( stderr, "msThreadInit() (posix)\n" );
-
-  pthread_mutex_lock( &core_lock );
-
-  for( ; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++ )
-    pthread_mutex_init( mutex_locks + mutexes_initialized, NULL );
-
-  pthread_mutex_unlock( &core_lock );
-}
-
-/************************************************************************/
-/*                           msGetThreadId()                            */
-/************************************************************************/
-
-void* msGetThreadId()
-
-{
-  return (void*) pthread_self();
-}
-
-/************************************************************************/
-/*                           msAcquireLock()                            */
-/************************************************************************/
-
-void msAcquireLock( int nLockId )
-
-{
-  if( mutexes_initialized == 0 )
-    msThreadInit();
-
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
-
-  if( thread_debug )
-    fprintf( stderr, "msAcquireLock(%d/%s) (posix)\n",
-             nLockId, lock_names[nLockId] );
-
-  pthread_mutex_lock( mutex_locks + nLockId );
-}
-
-/************************************************************************/
-/*                           msReleaseLock()                            */
-/************************************************************************/
-
-void msReleaseLock( int nLockId )
-
-{
-  assert( mutexes_initialized > 0 );
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
-
-  if( thread_debug )
-    fprintf( stderr, "msReleaseLock(%d/%s) (posix)\n",
-             nLockId, lock_names[nLockId] );
-
-  pthread_mutex_unlock( mutex_locks + nLockId );
-}
-
-#endif /* defined(USE_THREAD) && !defined(_WIN32) */
-
-/************************************************************************/
-/* ==================================================================== */
-/*                          WIN32 THREADS                               */
-/* ==================================================================== */
-/************************************************************************/
-
-#if defined(USE_THREAD) && defined(_WIN32)
-
-#include <windows.h>
-
-static int mutexes_initialized = 0;
-static HANDLE mutex_locks[TLOCK_MAX];
-
-/************************************************************************/
-/*                            msThreadInit()                            */
-/************************************************************************/
-
-void msThreadInit()
-
-{
-  /* static pthread_mutex_t core_lock = PTHREAD_MUTEX_INITIALIZER; */
-  static HANDLE core_lock = NULL;
-
-  if( mutexes_initialized >= TLOCK_STATIC_MAX )
-    return;
-
-  if( thread_debug )
-    fprintf( stderr, "msThreadInit() (win32)\n" );
-
-  if( core_lock == NULL )
-    core_lock = CreateMutex( NULL, TRUE, NULL );
-  else
-    WaitForSingleObject( core_lock, INFINITE );
-
-  for( ; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++ )
-    mutex_locks[mutexes_initialized] = CreateMutex( NULL, FALSE, NULL );
-
-  ReleaseMutex( core_lock );
-}
-
-/************************************************************************/
-/*                           msGetThreadId()                            */
-/************************************************************************/
-
-void* msGetThreadId()
-
-{
-  return (void*) (size_t) GetCurrentThreadId();
-}
-
-/************************************************************************/
-/*                           msAcquireLock()                            */
-/************************************************************************/
-
-void msAcquireLock( int nLockId )
-
-{
-  if( mutexes_initialized == 0 )
-    msThreadInit();
-
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
-
-  if( thread_debug )
-    fprintf( stderr, "msAcquireLock(%d/%s) (win32)\n",
-             nLockId, lock_names[nLockId] );
-
-  WaitForSingleObject( mutex_locks[nLockId], INFINITE );
-}
-
-/************************************************************************/
-/*                           msReleaseLock()                            */
-/************************************************************************/
-
-void msReleaseLock( int nLockId )
-
-{
-  assert( mutexes_initialized > 0 );
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
-
-  if( thread_debug )
-    fprintf( stderr, "msReleaseLock(%d/%s) (win32)\n",
-             nLockId, lock_names[nLockId] );
-
-  ReleaseMutex( mutex_locks[nLockId] );
-}
-
-#endif /* defined(USE_THREAD) && defined(_WIN32) */
diff -pruN 8.0.1-5/mapthread.h 8.2.0~beta1-1~exp1/mapthread.h
--- 8.0.1-5/mapthread.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapthread.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,88 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Multithreading / locking related declarations.
- * Author:   Frank Warmerdam <warmerdam@pobox.com>
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPTHREAD_H
-#define MAPTHREAD_H
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#ifdef USE_THREAD
-  void msThreadInit(void);
-  void* msGetThreadId(void);
-  void msAcquireLock(int);
-  void msReleaseLock(int);
-#else
-#define msThreadInit()
-#define msGetThreadId() (0)
-#define msAcquireLock(x)
-#define msReleaseLock(x)
-#endif
-
-  /*
-  ** lock ids - note there is a corresponding lock_names[] array in
-  ** mapthread.c that needs to be extended when new ids are added.
-  */
-
-#define TLOCK_PARSER  1
-#define TLOCK_GDAL  2
-#define TLOCK_ERROROBJ  3
-#define TLOCK_PROJ      4
-#define TLOCK_TTF       5
-#define TLOCK_POOL      6
-#define TLOCK_SDE       7
-#define TLOCK_ORACLE    8
-#define TLOCK_OWS       9
-#define TLOCK_LAYER_VTABLE 10
-#define TLOCK_IOCONTEXT 11
-#define TLOCK_TMPFILE   12
-#define TLOCK_DEBUGOBJ  13
-#define TLOCK_OGR       14
-#define TLOCK_TIME      15
-#define TLOCK_FRIBIDI   16
-#define TLOCK_WxS       17
-#define TLOCK_GEOS       18
-
-#define TLOCK_STATIC_MAX 20
-#define TLOCK_MAX       100
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPTHREAD_H */
-
-
-
-
-
-
-
-
diff -pruN 8.0.1-5/maptile.c 8.2.0~beta1-1~exp1/maptile.c
--- 8.0.1-5/maptile.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptile.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,529 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  MapServer Tile Access API
- * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
- *
- ******************************************************************************
- * Copyright (c) 2008, Paul Ramsey
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "maptile.h"
-#include "mapproject.h"
-
-#ifdef USE_TILE_API
-static void msTileResetMetatileLevel(mapObj *map)
-{
-  hashTableObj *meta = &(map->web.metadata);
-  const char *zero = "0";
-
-  /*  Is the tile_metatile_levetl set... */
-  if(msLookupHashTable(meta, "tile_metatile_level") != NULL) {
-    msRemoveHashTable(meta, "tile_metatile_level");
-  }
-  msInsertHashTable(meta, "tile_metatile_level", zero);
-}
-#endif
-
-/************************************************************************
- *                            msTileGetGMapCoords                       *
- ************************************************************************/
-static int msTileGetGMapCoords(const char *coordstring, int *x, int *y, int *zoom)
-{
-
-  int num_coords = 0;
-  char **coords = NULL;
-
-  if( coordstring ) {
-    coords = msStringSplit(coordstring, ' ', &(num_coords));
-    if( num_coords != 3 ) {
-      msFreeCharArray(coords, num_coords);
-      msSetError(MS_WEBERR, "Invalid number of tile coordinates (should be three).", "msTileSetup()");
-      return MS_FAILURE;
-    }
-  } else {
-    msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
-    return MS_FAILURE;
-  }
-
-  if( x )
-    *x = strtol(coords[0], NULL, 10);
-  if( y )
-    *y = strtol(coords[1], NULL, 10);
-  if( zoom )
-    *zoom = strtol(coords[2], NULL, 10);
-  
-  msFreeCharArray(coords, 3);
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************
- *                            msTileSetParams                           *
- ************************************************************************/
-static void msTileGetParams(const mapservObj *msObj, tileParams *params)
-{
-
-  const char *value = NULL;
-  const mapObj* map = msObj->map;
-  const hashTableObj *meta = &(map->web.metadata);
-
-  if( msObj->TileWidth < 0 )
-      params->tile_width = SPHEREMERC_IMAGE_SIZE;
-  else
-      params->tile_width = msObj->TileWidth;
-  if( msObj->TileHeight < 0 )
-      params->tile_height = SPHEREMERC_IMAGE_SIZE;
-  else
-      params->tile_height = msObj->TileHeight;
-
-  /* Check for tile buffer, set to buffer==0 as default */
-  if((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
-    params->map_edge_buffer = atoi(value);
-    if(map->debug)
-      msDebug("msTileSetParams(): tile_map_edge_buffer = %d\n", params->map_edge_buffer);
-  } else
-    params->map_edge_buffer = 0;
-
-  /* Check for metatile size, set to tile==metatile as default */
-  if((value = msLookupHashTable(meta, "tile_metatile_level")) != NULL) {
-    params->metatile_level = atoi(value);
-    /* Quietly force metatile_level to be sane */
-    if( params->metatile_level < 0 )
-      params->metatile_level = 0;
-    if( params->metatile_level > 2 )
-      params->metatile_level = 2;
-    if(map->debug)
-      msDebug("msTileSetParams(): tile_metatile_level = %d\n", params->metatile_level);
-  } else
-    params->metatile_level = 0;
-
-}
-
-/************************************************************************
- *                            msTileExtractSubTile                      *
- *                                                                      *
- ************************************************************************/
-static imageObj* msTileExtractSubTile(const mapservObj *msObj, const imageObj *img)
-{
-
-  int width, mini, minj;
-  int zoom = 2;
-  imageObj* imgOut = NULL;
-  tileParams params;
-  rendererVTableObj *renderer;
-  rasterBufferObj imgBuffer;
-
-  if( !MS_RENDERER_PLUGIN(msObj->map->outputformat)
-      || msObj->map->outputformat->renderer != img->format->renderer ||
-      ! MS_MAP_RENDERER(msObj->map)->supports_pixel_buffer ) {
-    msSetError(MS_MISCERR,"unsupported or mixed renderers","msTileExtractSubTile()");
-    return NULL;
-  }
-  renderer = MS_MAP_RENDERER(msObj->map);
-
-  if (renderer->getRasterBufferHandle((imageObj*)img,&imgBuffer) != MS_SUCCESS) {
-    return NULL;
-  }
-
-
-  /*
-  ** Load the metatiling information from the map file.
-  */
-  msTileGetParams(msObj, &params);
-
-  /*
-  ** Initialize values for the metatile clip area.
-  */
-  width = img->width - 2*params.map_edge_buffer;
-  mini = params.map_edge_buffer;
-  minj = params.map_edge_buffer;
-  
-  if( msObj->TileMode == TILE_GMAP ) {
-    int x, y, zoom;
-
-    if( msObj->TileCoords ) {
-      if( msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE )
-        return NULL;
-    } else {
-      msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
-      return NULL;
-    }
-
-    if(msObj->map->debug)
-      msDebug("msTileExtractSubTile(): gmaps coords (x: %d, y: %d)\n",x,y);
-
-    /*
-    ** The bottom N bits of the coordinates give us the subtile
-    ** location relative to the metatile.
-    */
-    x = (0xffff ^ (0xffff << params.metatile_level)) & x;
-    y = (0xffff ^ (0xffff << params.metatile_level)) & y;
-
-    if(msObj->map->debug)
-      msDebug("msTileExtractSubTile(): gmaps image coords (x: %d, y: %d)\n",x,y);
-
-    mini = mini + x * params.tile_width;
-    minj = minj + y * params.tile_height;
-
-  } else if( msObj->TileMode == TILE_VE ) {
-    int tsize;
-
-    const int lenTileCoords = (int)strlen( msObj->TileCoords );
-    if( lenTileCoords - params.metatile_level < 0 ) {
-      return(NULL);
-    }
-
-    /*
-    ** Process the last elements of the VE coordinate string to place the
-    ** requested tile in the context of the metatile
-    */
-    for( int i = lenTileCoords - params.metatile_level;
-         i < lenTileCoords;
-         i++ ) {
-      char j = msObj->TileCoords[i];
-      tsize = width / zoom;
-      if( j == '1' || j == '3' ) mini += tsize;
-      if( j == '2' || j == '3' ) minj += tsize;
-      zoom *= 2;
-    }
-  } else {
-    return(NULL); /* Huh? Should have a mode. */
-  }
-
-  imgOut = msImageCreate(params.tile_width, params.tile_height, msObj->map->outputformat, NULL, NULL, msObj->map->resolution, msObj->map->defresolution, NULL);
-
-  if( imgOut == NULL ) {
-    return NULL;
-  }
-
-  if(msObj->map->debug)
-    msDebug("msTileExtractSubTile(): extracting (%d x %d) tile, top corner (%d, %d)\n",params.tile_width, params.tile_height,mini,minj);
-
-
-
-  if(MS_UNLIKELY(MS_FAILURE == renderer->mergeRasterBuffer(imgOut,&imgBuffer,1.0,mini, minj,0, 0,params.tile_width, params.tile_height))) {
-    msFreeImage(imgOut);
-    return NULL;
-  }
-
-  return imgOut;
-}
-
-
-/************************************************************************
- *                            msTileSetup                               *
- *                                                                      *
- *  Called from mapserv.c, this is where the fun begins                 *
- *  Set up projections and test the parameters for legality.            *
- ************************************************************************/
-int msTileSetup(mapservObj* msObj)
-{
-#ifdef USE_TILE_API
-
-  char *outProjStr = NULL;
-  tileParams params;
-
-  /*
-  ** Load the metatiling information from the map file.
-  */
-  msTileGetParams(msObj, &params);
-
-  /*
-  ** Ensure all the LAYERs have a projection.
-  */
-  if( msMapSetLayerProjections(msObj->map) != 0 ) {
-    return(MS_FAILURE);
-  }
-
-  /*
-  ** Set the projection string for this mode.
-  */
-  if( msObj->TileMode == TILE_GMAP || msObj->TileMode == TILE_VE ) {
-    outProjStr = SPHEREMERC_PROJ4;
-  } else {
-    return MS_FAILURE; /* Huh? No mode? */
-  }
-  if( msLoadProjectionString(&(msObj->map->projection), outProjStr) != 0 ) {
-    msSetError(MS_CGIERR, "Unable to load projection string.", "msTileSetup()");
-    return MS_FAILURE;
-  }
-
-  /*
-  ** Set up the output extents for this tilemode and tile coordinates
-  */
-  if( msObj->TileMode == TILE_GMAP ) {
-
-    int x, y, zoom;
-    double zoomfactor;
-
-    if( msObj->TileCoords ) {
-      if( msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE )
-        return MS_FAILURE;
-    } else {
-      msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
-      return MS_FAILURE;
-    }
-
-    if( params.metatile_level >= zoom ) {
-      msTileResetMetatileLevel(msObj->map);
-    }
-
-    zoomfactor = pow(2.0, (double)zoom);
-
-    /*
-    ** Check the input request for sanity.
-    */
-    if( x >= zoomfactor || y >= zoomfactor ) {
-      msSetError(MS_CGIERR, "GMap tile coordinates are too large for supplied zoom.", "msTileSetup()");
-      return(MS_FAILURE);
-    }
-    if( x < 0 || y < 0 ) {
-      msSetError(MS_CGIERR, "GMap tile coordinates should not be less than zero.", "msTileSetup()");
-      return(MS_FAILURE);
-    }
-
-  } else if ( msObj->TileMode == TILE_VE ) {
-
-    if( strspn( msObj->TileCoords, "0123" ) < strlen( msObj->TileCoords ) ) {
-      msSetError(MS_CGIERR, "VE tile name should only include characters 0, 1, 2 and 3.", "msTileSetup()");
-      return(MS_FAILURE);
-    }
-
-    if( params.metatile_level >= (int)strlen(msObj->TileCoords) ) {
-      msTileResetMetatileLevel(msObj->map);
-    }
-
-  } else {
-    return(MS_FAILURE); /* Huh? Should have a mode. */
-  }
-
-  return MS_SUCCESS;
-#else
-  msSetError(MS_CGIERR, "Tile API is not available.", "msTileSetup()");
-  return(MS_FAILURE);
-#endif
-}
-
-
-
-/************************************************************************
- *                            msTileSetExtent                           *
- *                                                                      *
- *  Based on the input parameters, set the output extent for this       *
- *  tile.                                                               *
- ************************************************************************/
-int msTileSetExtent(mapservObj* msObj)
-{
-#ifdef USE_TILE_API
-
-  mapObj *map = msObj->map;
-  double  dx, dy, buffer;
-  tileParams params;
-
-  /* Read the tile-mode map file parameters */
-  msTileGetParams(msObj, &params);
-
-  if( msObj->TileMode == TILE_GMAP ) {
-    int x, y, zoom;
-    double zoomfactor, tilesize, xmin, xmax, ymin, ymax;
-
-    if( msObj->TileCoords ) {
-      if( msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE )
-        return MS_FAILURE;
-    } else {
-      msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
-      return MS_FAILURE;
-    }
-
-    if(map->debug)
-      msDebug("msTileSetExtent(): gmaps coords (x: %d, y: %d, z: %d)\n",x,y,zoom);
-
-    /*
-    ** If we are metatiling, adjust the zoom level appropriately,
-    ** then scale back the x/y coordinates to match the new level.
-    */
-    if( params.metatile_level > 0 ) {
-      zoom = zoom - params.metatile_level;
-      x = x >> params.metatile_level;
-      y = y >> params.metatile_level;
-    }
-
-    if(map->debug)
-      msDebug("msTileSetExtent(): gmaps metacoords (x: %d, y: %d, z: %d)\n",x,y,zoom);
-
-    zoomfactor = pow(2.0, (double)zoom);
-
-    /*
-    ** Calculate the ground extents of the tile request.
-    */
-    /* printf("X: %i  Y: %i  Z: %i\n",x,y,zoom); */
-    tilesize = SPHEREMERC_GROUND_SIZE / zoomfactor;
-    xmin = (x * tilesize) - (SPHEREMERC_GROUND_SIZE / 2.0);
-    xmax = ((x + 1) * tilesize) - (SPHEREMERC_GROUND_SIZE / 2.0);
-    ymin = (SPHEREMERC_GROUND_SIZE / 2.0) - ((y + 1) * tilesize);
-    ymax = (SPHEREMERC_GROUND_SIZE / 2.0) - (y * tilesize);
-
-    map->extent.minx = xmin;
-    map->extent.maxx = xmax;
-    map->extent.miny = ymin;
-    map->extent.maxy = ymax;
-
-  } else if( msObj->TileMode == TILE_VE ) {
-
-    double minx = SPHEREMERC_GROUND_SIZE / -2.0;
-    double miny = SPHEREMERC_GROUND_SIZE / -2.0;
-    double maxx = SPHEREMERC_GROUND_SIZE / 2.0;
-    double maxy = SPHEREMERC_GROUND_SIZE / 2.0;
-    double zoom = 2.0;
-    double tsize;
-
-    /*
-    ** Walk down the VE URL string, adjusting the extent each time.
-    ** For meta-tiling cases, we stop early, to draw a larger image.
-    */
-    for( int i = 0; i < (int)strlen( msObj->TileCoords ) - params.metatile_level; i++ ) {
-      char j = msObj->TileCoords[i];
-      tsize = SPHEREMERC_GROUND_SIZE / zoom;
-      if( j == '1' || j == '3' ) minx += tsize;
-      if( j == '0' || j == '2' ) maxx -= tsize;
-      if( j == '2' || j == '3' ) maxy -= tsize;
-      if( j == '0' || j == '1' ) miny += tsize;
-      zoom *= 2.0;
-    }
-
-    map->extent.minx = minx;
-    map->extent.maxx = maxx;
-    map->extent.miny = miny;
-    map->extent.maxy = maxy;
-
-  } else {
-    return(MS_FAILURE); /* Huh? Should have a mode. */
-  }
-
-  /*
-  ** Set the output tile size.
-  */
-  map->width = params.tile_width << params.metatile_level;
-  map->height = params.tile_height << params.metatile_level;
-
-  if(map->debug)
-    msDebug("msTileSetExtent(): base image size (%d x %d)\n",map->width,map->height);
-
-  /*
-  ** Add the gutters
-  ** First calculate ground units in the buffer at current extent
-  */
-  buffer = params.map_edge_buffer * (map->extent.maxx - map->extent.minx) / (double)map->width;
-  /*
-  ** Then adjust the map extents out by that amount
-  */
-  map->extent.minx -= buffer;
-  map->extent.maxx += buffer;
-  map->extent.miny -= buffer;
-  map->extent.maxy += buffer;
-  /*
-  ** Finally adjust the map image size by the pixel buffer
-  */
-  map->width += 2 * params.map_edge_buffer;
-  map->height += 2 * params.map_edge_buffer;
-
-  if(map->debug)
-    msDebug("msTileSetExtent(): buffered image size (%d x %d)\n",map->width,map->height);
-
-  /*
-  ** Adjust the extents inwards by 1/2 pixel so they are from
-  ** center-of-pixel to center-of-pixel, instead of edge-to-edge.
-  ** This is the way mapserver does it.
-  */
-  dx = (map->extent.maxx - map->extent.minx) / map->width;
-  map->extent.minx += dx*0.5;
-  map->extent.maxx -= dx*0.5;
-  dy = (map->extent.maxy - map->extent.miny) / map->height;
-  map->extent.miny += dy*0.5;
-  map->extent.maxy -= dy*0.5;
-
-  /*
-  ** Ensure the labelcache buffer is greater than the tile buffer.
-  */
-  if( params.map_edge_buffer > 0 ) {
-    const char *value;
-    hashTableObj *meta = &(map->web.metadata);
-    char tilebufferstr[64];
-
-    /* Write the tile buffer to a string */
-    snprintf(tilebufferstr, sizeof(tilebufferstr), "-%d", params.map_edge_buffer);
-
-    /* Hm, the labelcache buffer is set... */
-    if((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) != NULL) {
-      /* If it's too small, replace with a bigger one */
-      if( params.map_edge_buffer > abs(atoi(value)) ) {
-        msRemoveHashTable(meta, "labelcache_map_edge_buffer");
-        msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
-      }
-    }
-    /* No labelcache buffer value? Then we use the tile buffer. */
-    else {
-      msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
-    }
-  }
-
-  if(map->debug) {
-    msDebug( "msTileSetExtent (%f, %f) (%f, %f)\n", map->extent.minx, map->extent.miny, map->extent.maxx, map->extent.maxy);
-  }
-
-  return MS_SUCCESS;
-#else
-  msSetError(MS_CGIERR, "Tile API is not available.", "msTileSetExtent()");
-  return(MS_FAILURE);
-#endif
-}
-
-
-
-/************************************************************************
- *                            msDrawTile                                *
- *                                                                      *
- *   Draw the tile once with gutters, metatiling and buffers, then      *
- *   clip out the final tile.                                           *
- *   WARNING: Call msTileSetExtent() first or this will be a pointless  *
- *   fucnction call.                                                    *
- ************************************************************************/
-
-imageObj* msTileDraw(mapservObj *msObj)
-{
-  imageObj *img;
-  tileParams params;
-  msTileGetParams(msObj, &params);
-  img = msDrawMap(msObj->map, MS_FALSE);
-  if( img == NULL )
-    return NULL;
-  if( params.metatile_level > 0 || params.map_edge_buffer > 0 ) {
-    imageObj *tmp = msTileExtractSubTile(msObj, img);
-    msFreeImage(img);
-    if( tmp == NULL )
-      return NULL;
-    img = tmp;
-  }
-  return img;
-}
-
diff -pruN 8.0.1-5/maptile.h 8.2.0~beta1-1~exp1/maptile.h
--- 8.0.1-5/maptile.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptile.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,53 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  MapServer Tile Access API
- * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
- *
- ******************************************************************************
- * Copyright (c) 2008, Paul Ramsey
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maptemplate.h"
-
-#define USE_TILE_API 1
-
-#define SPHEREMERC_PROJ4 "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +units=m +k=1.0 +nadgrids=@null"
-#define SPHEREMERC_GROUND_SIZE (20037508.34*2)
-#define SPHEREMERC_IMAGE_SIZE 0x0100
-
-enum tileModes { TILE_GMAP, TILE_VE };
-
-MS_DLL_EXPORT int msTileSetup(mapservObj *msObj);
-MS_DLL_EXPORT int msTileSetExtent(mapservObj *msObj);
-MS_DLL_EXPORT int msTileSetProjections(mapObj *map);
-MS_DLL_EXPORT imageObj* msTileDraw(mapservObj *msObj);
-
-typedef struct {
-  int metatile_level; /* In zoom levels above tile request: best bet is 0, 1 or 2 */
-  int tile_width; /* In pixels */
-  int tile_height; /* In pixels */
-  int map_edge_buffer; /* In pixels */
-} tileParams;
-
-
diff -pruN 8.0.1-5/maptime.c 8.2.0~beta1-1~exp1/maptime.c
--- 8.0.1-5/maptime.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptime.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,474 +0,0 @@
-/******************************************************************************
- * $id$
- *
- * Project:  MapServer
- * Purpose:  Date/Time utility functions.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#define _GNU_SOURCE  /* glibc2 needs this for strptime() */
-#include <stdlib.h>
-#include <stdio.h>
-#include <time.h>
-
-#include "mapserver.h"
-#include "maptime.h"
-#include "maperror.h"
-#include "mapthread.h"
-
-typedef struct {
-  char pattern[64];
-  ms_regex_t *regex;
-  char  format[32];
-  char userformat[32];
-  MS_TIME_RESOLUTION resolution;
-} timeFormatObj;
-
-static timeFormatObj ms_timeFormats[] = {
-  {"^[0-9]{8}", NULL, "%Y%m%d","YYYYMMDD",TIME_RESOLUTION_DAY},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "%Y-%m-%dT%H:%M:%SZ","YYYY-MM-DDTHH:MM:SSZ",TIME_RESOLUTION_SECOND},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%dT%H:%M:%S", "YYYY-MM-DDTHH:MM:SS",TIME_RESOLUTION_SECOND},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%d %H:%M:%S", "YYYY-MM-DD HH:MM:SS", TIME_RESOLUTION_SECOND},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%dT%H:%M", "YYYY-MM-DDTHH:MM",TIME_RESOLUTION_MINUTE},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%d %H:%M", "YYYY-MM-DD HH:MM",TIME_RESOLUTION_MINUTE},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}", NULL, "%Y-%m-%dT%H", "YYYY-MM-DDTHH",TIME_RESOLUTION_HOUR},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}", NULL, "%Y-%m-%d %H", "YYYY-MM-DD HH",TIME_RESOLUTION_HOUR},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}", NULL, "%Y-%m-%d", "YYYY-MM-DD", TIME_RESOLUTION_DAY},
-  {"^[0-9]{4}-[0-9]{2}", NULL, "%Y-%m", "YYYY-MM",TIME_RESOLUTION_MONTH},
-  {"^[0-9]{4}", NULL, "%Y", "YYYY",TIME_RESOLUTION_YEAR},
-  {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "T%H:%M:%SZ", "THH:MM:SSZ",TIME_RESOLUTION_SECOND},
-  {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "T%H:%M:%S", "THH:MM:SS", TIME_RESOLUTION_SECOND},
-  {"^[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "%H:%M:%SZ", "HH:MM:SSZ", TIME_RESOLUTION_SECOND},
-  {"^[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%H:%M:%S", "HH:MM:SS", TIME_RESOLUTION_SECOND}
-};
-
-#define MS_NUMTIMEFORMATS (int)(sizeof(ms_timeFormats)/sizeof(ms_timeFormats[0]))
-
-int *ms_limited_pattern = NULL;
-int ms_num_limited_pattern;
-
-int ms_time_inited = 0;
-int msTimeSetup() 
-{
-  if(!ms_time_inited) {
-    msAcquireLock(TLOCK_TIME);
-    if(!ms_time_inited) {
-      int i;
-      for(i=0;i<MS_NUMTIMEFORMATS;i++) {
-        ms_timeFormats[i].regex = msSmallMalloc(sizeof(ms_regex_t));
-        if(0!=ms_regcomp(ms_timeFormats[i].regex, ms_timeFormats[i].pattern, MS_REG_EXTENDED|MS_REG_NOSUB)) {
-          msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msTimeSetup()", ms_timeFormats[i].pattern);
-          return MS_FAILURE;
-          /* TODO: free already init'd regexes */
-        }
-      }
-      ms_limited_pattern = (int *)msSmallMalloc(sizeof(int)*MS_NUMTIMEFORMATS);
-      ms_num_limited_pattern = 0;
-      ms_time_inited = 1;
-    }
-    msReleaseLock(TLOCK_TIME);
-  }
-  return MS_SUCCESS;
-}
-
-void msTimeCleanup() 
-{
-  if(ms_time_inited) {
-    int i;
-    for(i=0;i<MS_NUMTIMEFORMATS;i++) {
-      if(ms_timeFormats[i].regex) {
-        ms_regfree(ms_timeFormats[i].regex);
-        msFree(ms_timeFormats[i].regex);
-        ms_timeFormats[i].regex = NULL;
-      }
-    }
-    msFree(ms_limited_pattern);
-    ms_time_inited = 0;
-  }
-}
-
-void msTimeInit(struct tm *time) 
-{
-  time->tm_sec = 0; /* set all members to zero */
-  time->tm_min = 0;
-  time->tm_hour = 0;
-  time->tm_mday = 0;
-  time->tm_mon = 0;
-  time->tm_year = 0;
-  time->tm_wday = 0;
-  time->tm_yday = 0;
-  time->tm_isdst = 0;
-
-  return;
-}
-
-static int compareIntVals(int a, int b)
-{
-  if(a<b) return -1;
-  else if(a>b) return 1;
-  else return 0;
-}
-
-int msDateCompare(struct tm *time1, struct tm *time2)
-{
-  int result;
-
-  if((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
-    return result; /* not equal based on year */
-  else if((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
-    return result; /* not equal based on month */
-  else if((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
-    return result; /* not equal based on day of month */
-
-  return(0); /* must be equal */
-}
-
-int msTimeCompare(struct tm *time1, struct tm *time2)
-{
-  int result;
-
-  // fprintf(stderr, "in msTimeCompare()...\n");
-  // fprintf(stderr, "time1: %d %d %d %d %d %d\n", time1->tm_year, time1->tm_mon, time1->tm_mday, time1->tm_hour, time1->tm_min, time1->tm_sec);
-  // fprintf(stderr, "time2: %d %d %d %d %d %d\n", time2->tm_year, time2->tm_mon, time2->tm_mday, time2->tm_hour, time2->tm_min, time2->tm_sec);
-
-  if((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
-    return result; /* not equal based on year */
-  else if((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
-    return result; /* not equal based on month */
-  else if((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
-    return result; /* not equal based on day of month */
-  else if((result = compareIntVals(time1->tm_hour, time2->tm_hour)) != 0)
-    return result; /* not equal based on hour */
-  else if((result = compareIntVals(time1->tm_min, time2->tm_min)) != 0)
-    return result; /* not equal based on minute */
-  else if((result = compareIntVals(time1->tm_sec, time2->tm_sec)) != 0)
-    return result; /* not equal based on second */
-
-  return(0); /* must be equal */
-}
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#include <sys/timeb.h>
-void msGettimeofday(struct mstimeval* tp, void* tzp)
-{
-  struct _timeb theTime;
-
-  _ftime(&theTime);
-  tp->tv_sec = theTime.time;
-  tp->tv_usec = theTime.millitm * 1000;
-}
-#endif
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-/* we need to provide our own prototype on windows. */
-char *strptime( const char *buf, const char *format, struct tm *timeptr );
-#endif
-
-char *msStrptime(const char *s, const char *format, struct tm *tm)
-{
-  memset(tm, 0, sizeof(struct tm));
-  return strptime(s, format, tm);
-}
-
-/**
-   return MS_TRUE if the time string matchs the timeformat.
-   else return MS_FALSE.
- */
-int msTimeMatchPattern(const char *timestring, const char *timeformat)
-{
-  int i =-1;
-  if(msTimeSetup() != MS_SUCCESS) {
-    return MS_FALSE;
-  }
-
-  /* match the pattern format first and then check if the time string  */
-  /* matchs the pattern. If it is the case retrurn the MS_TRUE */
-  for (i=0; i<MS_NUMTIMEFORMATS; i++) {
-    if (strcasecmp(ms_timeFormats[i].userformat, timeformat) == 0)
-      break;
-  }
-
-  if (i >= 0 && i < MS_NUMTIMEFORMATS) {
-    int match = ms_regexec(ms_timeFormats[i].regex, timestring, 0, NULL, 0);
-    if(match == 0)
-      return MS_TRUE;
-  }
-  return MS_FALSE;
-}
-
-
-void msUnsetLimitedPatternToUse()
-{
-  msTimeSetup();
-  ms_num_limited_pattern = 0;
-}
-
-void msSetLimitedPatternsToUse(const char *patternstring)
-{
-  int *limitedpatternindice = NULL;
-  int numpatterns=0, ntmp=0;
-  char **patterns = NULL;
-  msTimeSetup();
-
-  limitedpatternindice = (int *)msSmallMalloc(sizeof(int)*MS_NUMTIMEFORMATS);
-
-  /* free previous setting */
-  msUnsetLimitedPatternToUse();
-
-  if (patternstring) {
-    patterns = msStringSplit(patternstring, ',', &ntmp);
-    if (patterns && ntmp >= 1) {
-
-      for (int i=0; i<ntmp; i++) {
-        for (int j=0; j<MS_NUMTIMEFORMATS; j++) {
-          if (strcasecmp( ms_timeFormats[j].userformat, patterns[i]) ==0) {
-            limitedpatternindice[numpatterns] = j;
-            numpatterns++;
-            break;
-          }
-        }
-      }
-    }
-    msFreeCharArray(patterns, ntmp);
-  }
-
-  if (numpatterns > 0) {
-    for (int i=0; i<numpatterns; i++)
-      ms_limited_pattern[i] = limitedpatternindice[i];
-
-    ms_num_limited_pattern = numpatterns;
-  }
-  free (limitedpatternindice);
-}
-
-int msParseTime(const char *string, struct tm *tm)
-{
-  int num_patterns = 0;
-  
-  if(MS_STRING_IS_NULL_OR_EMPTY(string)) return MS_FALSE; /* nothing to parse so bail */
-
-  if(msTimeSetup() != MS_SUCCESS) {
-    return MS_FALSE;
-  }
-
-  /* if limited patterns are set, use them, else use all the patterns defined */
-  if (ms_num_limited_pattern > 0)
-    num_patterns = ms_num_limited_pattern;
-  else
-    num_patterns = MS_NUMTIMEFORMATS;
-
-  for(int i=0; i<num_patterns; i++) {
-    int match;
-    int indice;
-    if (ms_num_limited_pattern > 0)
-      indice = ms_limited_pattern[i];
-    else
-      indice = i;
-
-    match = ms_regexec(ms_timeFormats[indice].regex, string, 0,NULL, 0);
-    /* test the expression against the string */
-    if(match == 0) {
-      /* match    */      
-      msStrptime(string, ms_timeFormats[indice].format, tm);
-      return(MS_TRUE);
-    }
-  }
-
-  msSetError(MS_REGEXERR, "Unrecognized date or time format (%s).", "msParseTime()", string);
-  return(MS_FALSE);
-}
-
-/**
- * Parse the time string and return the reslution
- */
-int msTimeGetResolution(const char *timestring)
-{
-  int i=0;
-
-  if (!timestring)
-    return -1;
-
-  for(i=0; i<MS_NUMTIMEFORMATS; i++) {
-    ms_regex_t *regex = (ms_regex_t *) msSmallMalloc(sizeof(ms_regex_t));
-    if(ms_regcomp(regex, ms_timeFormats[i].pattern,
-                  MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {
-      msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msParseTime()", ms_timeFormats[i].pattern);
-      msFree(regex);
-      return -1;
-    }
-    /* test the expression against the string */
-    if(ms_regexec(regex, timestring, 0, NULL, 0) == 0) {
-      /* match    */
-      ms_regfree(regex);
-      msFree(regex);
-      return ms_timeFormats[i].resolution;
-    }
-    ms_regfree(regex);
-    msFree(regex);
-  }
-
-  return -1;
-}
-
-
-int _msValidateTime(const char *timestring,  const char *timeextent)
-{
-  int numelements, numextents, i, numranges;
-  struct tm  tmtimestart, tmtimeend, tmstart, tmend;
-  char **atimerange = NULL, **atimeelements= NULL, **atimeextents=NULL;
-
-  if (!timestring || !timeextent)
-    return MS_FALSE;
-
-  if (strlen(timestring) == 0 || strlen(timeextent) == 0)
-    return MS_FALSE;
-
-  /* we first need to parse the timesting that is passed
-     so that we can determine if it is a descrete time
-     or a range */
-
-  numelements = 0;
-  atimeelements = msStringSplit (timestring, '/', &numelements);
-  msTimeInit(&tmtimestart);
-  msTimeInit(&tmtimeend);
-
-  if (numelements == 1) { /*descrete time*/
-    /*start end end times are the same*/
-    if (msParseTime(timestring, &tmtimestart) != MS_TRUE) {
-      msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
-    }
-    if (msParseTime(timestring, &tmtimeend) != MS_TRUE) {
-      msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
-    }
-  } else if (numelements >=2) { /*range */
-    if (msParseTime(atimeelements[0], &tmtimestart) != MS_TRUE) {
-      msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
-    }
-    if (msParseTime(atimeelements[1], &tmtimeend) != MS_TRUE) {
-      msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
-    }
-  }
-
-  msFreeCharArray(atimeelements, numelements);
-
-
-  /* Now parse the time extent. Extents can be
-    -  one range (2004-09-21/2004-09-25/resolution)
-    -  multiple rages 2004-09-21/2004-09-25/res1,2004-09-21/2004-09-25/res2
-    - one value 2004-09-21
-    - mutiple values 2004-09-21,2004-09-22,2004-09-23
-  */
-
-  numextents = 0;
-  atimeextents = msStringSplit (timeextent, ',', &numextents);
-  if (numextents <= 0) {
-    msFreeCharArray(atimeextents, numextents);
-    return MS_FALSE;
-  }
-
-  /*the time timestring should at be valid in one of the extents
-    defined */
-
-  for (i=0; i<numextents; i++) {
-    /* build time structure for the extents */
-    msTimeInit(&tmstart);
-    msTimeInit(&tmend);
-
-    numranges = 0;
-    atimerange = msStringSplit (atimeextents[i], '/', &numranges);
-    /* - one value 2004-09-21 */
-    if (numranges == 1) {
-      /*time tested can either be descrete or a range */
-
-      if (msParseTime(atimerange[0], &tmstart) == MS_TRUE &&
-          msParseTime(atimerange[0], &tmend) == MS_TRUE &&
-          msTimeCompare(&tmstart, &tmtimestart) <= 0 &&
-          msTimeCompare(&tmend, &tmtimeend) >= 0) {
-        msFreeCharArray(atimerange, numranges);
-        msFreeCharArray(atimeextents, numextents);
-        return MS_TRUE;
-      }
-    }
-    /*2004-09-21/2004-09-25/res1*/
-    else if (numranges >= 2) {
-      if (msParseTime(atimerange[0], &tmstart) == MS_TRUE &&
-          msParseTime(atimerange[1], &tmend) == MS_TRUE &&
-          msTimeCompare(&tmstart, &tmtimestart) <= 0 &&
-          msTimeCompare(&tmend, &tmtimeend) >= 0) {
-        msFreeCharArray(atimerange, numranges);
-        msFreeCharArray(atimeextents, numextents);
-        return MS_TRUE;
-      }
-    }
-    msFreeCharArray(atimerange, numranges);
-
-
-  }
-  msFreeCharArray(atimeextents, numextents);
-  return MS_FALSE;
-
-}
-
-int msValidateTimeValue(const char *timestring, const char *timeextent)
-{
-  char **atimes =  NULL;
-  int i, numtimes=0;
-
-  /* we need to validate the time passsed in the request */
-  /* against the time extent defined */
-
-  if (!timestring || !timeextent)
-    return MS_FALSE;
-
-  /* To avoid SQL injections */
-  if (strchr(timestring, '\''))
-    return MS_FALSE;
-
-  /* parse the time string. We support descrete times (eg 2004-09-21), */
-  /* multiple times (2004-09-21, 2004-09-22, ...) */
-  /* and range(s) (2004-09-21/2004-09-25, 2004-09-27/2004-09-29) */
-  if (strstr(timestring, ",") == NULL && strstr(timestring, "/") == NULL) { /* discrete time */
-    return _msValidateTime(timestring,  timeextent);
-  } else {
-    atimes = msStringSplit(timestring, ',', &numtimes);
-    if (numtimes >=1) { /* multiple times */
-      for (i=0; i<numtimes; i++) {
-        if (_msValidateTime(atimes[i], timeextent) == MS_FALSE) {
-          msFreeCharArray(atimes, numtimes);
-          return MS_FALSE;
-        }
-      }
-      msFreeCharArray(atimes, numtimes);
-      return MS_TRUE;
-    } else {
-      msFreeCharArray(atimes,numtimes);
-    }
-  }
-  return MS_FALSE;
-}
-
diff -pruN 8.0.1-5/maptime.h 8.2.0~beta1-1~exp1/maptime.h
--- 8.0.1-5/maptime.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptime.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Time processing related declarations.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPTIME_H
-#define MAPTIME_H
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-/* (bug 602) gettimeofday() and struct timeval aren't available on Windows,
- * so we provide a replacement with msGettimeofday() and struct mstimeval on
- * Windows.  On Unix/Linux they are just #defines to the real things.
- */
-#if defined(_WIN32) && !defined(__CYGWIN__)
-struct mstimeval {
-  long    tv_sec;         /* seconds */
-  long    tv_usec;        /* and microseconds */
-};
-MS_DLL_EXPORT void msGettimeofday(struct mstimeval *t, void *__not_used_here__);
-#else
-#  include <sys/time.h>     /* for gettimeofday() */
-#  define  mstimeval timeval
-#  define  msGettimeofday(t,u) gettimeofday(t,u)
-#endif
-
-typedef enum {
-  TIME_RESOLUTION_UNDEFINED = -1,
-  TIME_RESOLUTION_MICROSECOND =0,
-  TIME_RESOLUTION_MILLISECOND =1,
-  TIME_RESOLUTION_SECOND =2,
-  TIME_RESOLUTION_MINUTE =3,
-  TIME_RESOLUTION_HOUR =4,
-  TIME_RESOLUTION_DAY =5,
-  TIME_RESOLUTION_MONTH =6,
-  TIME_RESOLUTION_YEAR =7
-} MS_TIME_RESOLUTION;
-
-/* function prototypes */
-void msTimeInit(struct tm *time);
-int msDateCompare(struct tm *time1, struct tm *time2);
-int msTimeCompare(struct tm *time1, struct tm *time2);
-char *msStrptime(const char *s, const char *format, struct tm *tm);
-int msParseTime(const char *string, struct tm *tm);
-int msTimeMatchPattern(const char *timestring, const char *pattern);
-void msSetLimitedPatternsToUse(const char *patternstring);
-void msUnsetLimitedPatternToUse(void);
-MS_DLL_EXPORT int msTimeGetResolution(const char *timestring);
-void msTimeCleanup();
-
-int msValidateTimeValue(const char *timestring, const char *timeextent);
-
-#ifdef __cplusplus
-} /* extern C */
-#endif
-
-#endif /* MAPTIME_H */
diff -pruN 8.0.1-5/maptree.c 8.2.0~beta1-1~exp1/maptree.c
--- 8.0.1-5/maptree.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptree.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,847 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  .qix spatial index implementation.  Derived from shapelib, and
- *           relicensed with permission of Frank Warmerdam (shapelib author).
- * Author:   Steve Lime
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maptree.h"
-
-#include <limits.h>
-
-#ifdef __BYTE_ORDER__
-/* GCC/clang predefined macro */
-#define bBigEndian (__BYTE_ORDER__ == __ORDER_BIG_ENDIAN__)
-#elif defined(_MSC_VER)
-/* MSVC doesn't support the C99 trick below, but all Microsoft
-   platforms are little-endian */
-#define bBigEndian false
-#else
-/* generic check */
-#define bBigEndian (((union{int in;char out;}){1}).out)
-#endif
-
-/* -------------------------------------------------------------------- */
-/*      If the following is 0.5, nodes will be split in half.  If it    */
-/*      is 0.6 then each subnode will contain 60% of the parent         */
-/*      node, with 20% representing overlap.  This can be help to       */
-/*      prevent small objects on a boundary from shifting too high      */
-/*      up the tree.                                                    */
-/* -------------------------------------------------------------------- */
-#define SPLITRATIO  0.55
-
-static int treeAddShapeId(treeObj *tree, int id, rectObj rect);
-
-static void SwapWord( int length, void * wordP )
-{
-  int i;
-  uchar temp;
-
-  for( i=0; i < length/2; i++ ) {
-    temp = ((uchar *) wordP)[i];
-    ((uchar *)wordP)[i] = ((uchar *) wordP)[length-i-1];
-    ((uchar *) wordP)[length-i-1] = temp;
-  }
-}
-
-static void * SfRealloc( void * pMem, int nNewSize )
-
-{
-  if( pMem == NULL )
-    return( (void *) malloc(nNewSize) );
-  else
-    return( (void *) realloc(pMem,nNewSize) );
-}
-
-static treeNodeObj *treeNodeCreate(rectObj rect)
-{
-  treeNodeObj *node;
-
-  node = (treeNodeObj *) msSmallMalloc(sizeof(treeNodeObj));
-
-  node->numshapes = 0;
-  node->ids = NULL;
-
-  node->numsubnodes = 0;
-
-  memcpy(&(node->rect), &(rect), sizeof(rectObj));
-
-  return node;
-}
-
-
-SHPTreeHandle msSHPDiskTreeOpen(const char * pszTree, int debug)
-{
-  char    *pszFullname, *pszBasename;
-  SHPTreeHandle psTree;
-
-  char    pabyBuf[16];
-  int     i;
-
-  /* -------------------------------------------------------------------- */
-  /*  Initialize the info structure.              */
-  /* -------------------------------------------------------------------- */
-  psTree = (SHPTreeHandle) msSmallMalloc(sizeof(SHPTreeInfo));
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension     */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(pszTree)+5);
-  strcpy( pszBasename, pszTree );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*  Open the .shp and .shx files.  Note that files pulled from      */
-  /*  a PC to Unix with upper case filenames won't work!        */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
-  psTree->fp = fopen(pszFullname, "rb" );
-  if( psTree->fp == NULL ) {
-      sprintf( pszFullname, "%s.QIX", pszBasename);
-      psTree->fp = fopen(pszFullname, "rb" );
-  }
-
-  msFree(pszBasename); /* don't need these any more */
-  msFree(pszFullname);
-
-  if( psTree->fp == NULL ) {
-    msFree(psTree);
-    return( NULL );
-  }
-
-  if( fread( pabyBuf, 8, 1, psTree->fp ) != 1 ) {
-    msFree(psTree);
-    return( NULL );
-  }
-
-  memcpy( &psTree->signature, pabyBuf, 3 );
-  if( strncmp(psTree->signature,"SQT",3) ) {
-    /* ---------------------------------------------------------------------- */
-    /*     must check if the 2 first bytes equal 0 of max depth that cannot   */
-    /*     be more than 65535. If yes, we must swap all value. The problem    */
-    /*     here is if there's no Depth (bytea 5,6,7,8 in the file) all bytes  */
-    /*     will be set to 0. So,we will test with the number of shapes (bytes */
-    /*     1,2,3,4) that cannot be more than 65535 too.                       */
-    /* ---------------------------------------------------------------------- */
-    if (debug) {
-      msDebug("WARNING in msSHPDiskTreeOpen(): %s is in old index format "
-              "which has been deprecated.  It is strongly recommended to "
-              "regenerate it in new format.\n", pszTree);
-    }
-    if((pabyBuf[4] == 0 && pabyBuf[5] == 0 &&
-        pabyBuf[6] == 0 && pabyBuf[7] == 0)) {
-      psTree->LSB_order = !(pabyBuf[0] == 0 && pabyBuf[1] == 0);
-    } else {
-      psTree->LSB_order = !(pabyBuf[4] == 0 && pabyBuf[5] == 0);
-    }
-    psTree->needswap = ((psTree->LSB_order) != (!bBigEndian));
-
-    /* ---------------------------------------------------------------------- */
-    /*     poor hack to see if this quadtree was created by a computer with a */
-    /*     different Endian                                                   */
-    /* ---------------------------------------------------------------------- */
-    psTree->version = 0;
-  } else {
-    psTree->needswap = (( pabyBuf[3] == MS_NEW_MSB_ORDER ) ^ ( bBigEndian ));
-
-    psTree->LSB_order = ( pabyBuf[3] == MS_NEW_LSB_ORDER );
-    memcpy( &psTree->version, pabyBuf+4, 1 );
-    memcpy( &psTree->flags, pabyBuf+5, 3 );
-
-    if( fread( pabyBuf, 8, 1, psTree->fp ) != 1 )
-    {
-      msFree(psTree);
-      return( NULL );
-    }
-  }
-
-  if( psTree->needswap ) SwapWord( 4, pabyBuf );
-  memcpy( &psTree->nShapes, pabyBuf, 4 );
-
-  if( psTree->needswap ) SwapWord( 4, pabyBuf+4 );
-  memcpy( &psTree->nDepth, pabyBuf+4, 4 );
-
-  return( psTree );
-}
-
-
-void msSHPDiskTreeClose(SHPTreeHandle disktree)
-{
-  fclose( disktree->fp );
-  free( disktree );
-}
-
-
-treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth)
-{
-  int i;
-  treeObj *tree;
-  rectObj bounds;
-
-  if(!shapefile) return NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Allocate the tree object                                        */
-  /* -------------------------------------------------------------------- */
-  tree = (treeObj *) msSmallMalloc(sizeof(treeObj));
-
-  tree->numshapes = shapefile->numshapes;
-  tree->maxdepth = maxdepth;
-
-  /* -------------------------------------------------------------------- */
-  /*      If no max depth was defined, try to select a reasonable one     */
-  /*      that implies approximately 8 shapes per node.                   */
-  /* -------------------------------------------------------------------- */
-  if( tree->maxdepth == 0 ) {
-    int numnodes = 1;
-
-    while(numnodes*4 < shapefile->numshapes) {
-      tree->maxdepth += 1;
-      numnodes = numnodes * 2;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Allocate the root node.                                         */
-  /* -------------------------------------------------------------------- */
-  tree->root = treeNodeCreate(shapefile->bounds);
-
-  for(i=0; i<shapefile->numshapes; i++) {
-    if(msSHPReadBounds(shapefile->hSHP, i, &bounds) == MS_SUCCESS)
-      treeAddShapeId(tree, i, bounds);
-  }
-
-  return tree;
-}
-
-static void destroyTreeNode(treeNodeObj *node)
-{
-  int i;
-
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(node->subnode[i])
-      destroyTreeNode(node->subnode[i]);
-  }
-
-  if(node->ids)
-    free(node->ids);
-
-  free(node);
-}
-
-void msDestroyTree(treeObj *tree)
-{
-  destroyTreeNode(tree->root);
-  free(tree);
-}
-
-static void treeSplitBounds( rectObj *in, rectObj *out1, rectObj *out2)
-{
-  double range;
-
-  /* -------------------------------------------------------------------- */
-  /*      The output bounds will be very similar to the input bounds,     */
-  /*      so just copy over to start.                                     */
-  /* -------------------------------------------------------------------- */
-  memcpy(out1, in, sizeof(rectObj));
-  memcpy(out2, in, sizeof(rectObj));
-
-  /* -------------------------------------------------------------------- */
-  /*      Split in X direction.                                           */
-  /* -------------------------------------------------------------------- */
-  if((in->maxx - in->minx) > (in->maxy - in->miny)) {
-    range = in->maxx - in->minx;
-
-    out1->maxx = in->minx + range * SPLITRATIO;
-    out2->minx = in->maxx - range * SPLITRATIO;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise split in Y direction.                                 */
-  /* -------------------------------------------------------------------- */
-  else {
-    range = in->maxy - in->miny;
-
-    out1->maxy = in->miny + range * SPLITRATIO;
-    out2->miny = in->maxy - range * SPLITRATIO;
-  }
-}
-
-static int treeNodeAddShapeId( treeNodeObj *node, int id, rectObj rect, int maxdepth)
-{
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*      If there are subnodes, then consider whether this object        */
-  /*      will fit in them.                                               */
-  /* -------------------------------------------------------------------- */
-  if( maxdepth > 1 && node->numsubnodes > 0 ) {
-    for(i=0; i<node->numsubnodes; i++ ) {
-      if( msRectContained(&rect, &node->subnode[i]->rect)) {
-        return treeNodeAddShapeId( node->subnode[i], id, rect, maxdepth-1);
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise, consider creating four subnodes if could fit into    */
-  /*      them, and adding to the appropriate subnode.                    */
-  /* -------------------------------------------------------------------- */
-#if MAX_SUBNODES == 4
-  else if( maxdepth > 1 && node->numsubnodes == 0 ) {
-    rectObj half1, half2, quad1, quad2, quad3, quad4;
-
-    treeSplitBounds(&node->rect, &half1, &half2);
-    treeSplitBounds(&half1, &quad1, &quad2);
-    treeSplitBounds(&half2, &quad3, &quad4);
-
-    if(msRectContained(&rect, &quad1) || msRectContained(&rect, &quad2) ||  msRectContained(&rect, &quad3) || msRectContained(&rect, &quad4)) {
-      node->numsubnodes = 4;
-      node->subnode[0] = treeNodeCreate(quad1);
-      node->subnode[1] = treeNodeCreate(quad2);
-      node->subnode[2] = treeNodeCreate(quad3);
-      node->subnode[3] = treeNodeCreate(quad4);
-
-      /* recurse back on this node now that it has subnodes */
-      return(treeNodeAddShapeId(node, id, rect, maxdepth));
-    }
-  }
-#endif
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise, consider creating two subnodes if could fit into     */
-  /*      them, and adding to the appropriate subnode.                    */
-  /* -------------------------------------------------------------------- */
-#if MAX_SUBNODE == 2
-  else if( maxdepth > 1 && node->numsubnodes == 0 ) {
-    rectObj half1, half2;
-
-    treeSplitBounds(&node->rect, &half1, &half2);
-
-    if( msRectContained(&rect, &half1)) {
-      node->numsubnodes = 2;
-      node->subnode[0] = treeNodeCreate(half1);
-      node->subnode[1] = treeNodeCreate(half2);
-
-      return(treeNodeAddShapeId(node->subnode[0], id, rect, maxdepth-1));
-    } else if(msRectContained(&rect, &half2)) {
-      node->numsubnodes = 2;
-      node->subnode[0] = treeNodeCreate(&half1);
-      node->subnode[1] = treeNodeCreate(&half2);
-
-      return(treeNodeAddShapeId(node->subnode[1], id, rect, maxdepth-1));
-    }
-  }
-#endif /* MAX_SUBNODE == 2 */
-
-  /* -------------------------------------------------------------------- */
-  /*      If none of that worked, just add it to this nodes list.         */
-  /* -------------------------------------------------------------------- */
-  node->numshapes++;
-
-  node->ids = SfRealloc( node->ids, sizeof(ms_int32) * node->numshapes );
-  node->ids[node->numshapes-1] = id;
-
-  return MS_TRUE;
-}
-
-static int treeAddShapeId(treeObj *tree, int id, rectObj rect)
-{
-  return(treeNodeAddShapeId(tree->root, id, rect, tree->maxdepth));
-}
-
-static void treeCollectShapeIds(treeNodeObj *node, rectObj aoi, ms_bitarray status)
-{
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*      Does this node overlap the area of interest at all?  If not,    */
-  /*      return without adding to the list at all.                       */
-  /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &aoi))
-    return;
-
-  /* -------------------------------------------------------------------- */
-  /*      Add the local nodes shapeids to the list.                       */
-  /* -------------------------------------------------------------------- */
-  for(i=0; i<node->numshapes; i++)
-    msSetBit(status, node->ids[i], 1);
-
-  /* -------------------------------------------------------------------- */
-  /*      Recurse to subnodes if they exist.                              */
-  /* -------------------------------------------------------------------- */
-  for(i=0; i<node->numsubnodes; i++) {
-    if(node->subnode[i])
-      treeCollectShapeIds(node->subnode[i], aoi, status);
-  }
-}
-
-ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi)
-{
-  ms_bitarray status=NULL;
-
-  status = msAllocBitArray(tree->numshapes);
-  if(!status) {
-    msSetError(MS_MEMERR, NULL, "msSearchTree()");
-    return(NULL);
-  }
-
-  treeCollectShapeIds(tree->root, aoi, status);
-
-  return(status);
-}
-
-static int treeNodeTrim( treeNodeObj *node )
-{
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*      Trim subtrees, and free subnodes that come back empty.          */
-  /* -------------------------------------------------------------------- */
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(treeNodeTrim(node->subnode[i])) {
-      destroyTreeNode(node->subnode[i]);
-      node->subnode[i] = node->subnode[node->numsubnodes-1];
-      node->numsubnodes--;
-      i--; /* process the new occupant of this subnode entry */
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If the current node has 1 subnode and no shapes, promote that   */
-  /*      subnode to the current node position.                           */
-  /* -------------------------------------------------------------------- */
-  if( node->numsubnodes == 1 && node->numshapes == 0) {
-    treeNodeObj* psSubNode = node->subnode[0];
-
-    memcpy(&node->rect, &psSubNode->rect,
-           sizeof(psSubNode->rect));
-    node->numshapes = psSubNode->numshapes;
-    assert(node->ids == NULL);
-    node->ids = psSubNode->ids;
-    node->numsubnodes = psSubNode->numsubnodes;
-    for( i = 0; i < psSubNode->numsubnodes; i++ )
-      node->subnode[i] = psSubNode->subnode[i];
-    free(psSubNode);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      We should be trimmed if we have no subnodes, and no shapes.     */
-  /* -------------------------------------------------------------------- */
-
-  return(node->numsubnodes == 0 && node->numshapes == 0);
-}
-
-void msTreeTrim(treeObj *tree)
-{
-  treeNodeTrim(tree->root);
-}
-
-static void searchDiskTreeNode(SHPTreeHandle disktree, rectObj aoi, ms_bitarray status)
-{
-  int i;
-  ms_int32 offset;
-  ms_int32 numshapes, numsubnodes;
-  rectObj rect;
-
-  int *ids=NULL;
-
-  if( fread( &offset, 4, 1, disktree->fp ) != 1 )
-    goto error;
-  if ( disktree->needswap ) SwapWord ( 4, &offset );
-
-  if( fread( &rect, sizeof(rectObj), 1, disktree->fp ) != 1 )
-    goto error;
-  if ( disktree->needswap ) SwapWord ( 8, &rect.minx );
-  if ( disktree->needswap ) SwapWord ( 8, &rect.miny );
-  if ( disktree->needswap ) SwapWord ( 8, &rect.maxx );
-  if ( disktree->needswap ) SwapWord ( 8, &rect.maxy );
-
-  if( fread( &numshapes, 4, 1, disktree->fp ) != 1 )
-    goto error;
-  if ( disktree->needswap ) SwapWord ( 4, &numshapes );
-  if( numshapes < 0 || numshapes > INT_MAX / 4 )
-    goto error;
-
-  if(!msRectOverlap(&rect, &aoi)) { /* skip rest of this node and sub-nodes */
-    offset += numshapes*sizeof(ms_int32) + sizeof(ms_int32);
-    if( fseek(disktree->fp, offset, SEEK_CUR) < 0 )
-        goto error;
-    return;
-  }
-  if(numshapes > 0) {
-    ids = (int *)msSmallMalloc(numshapes*sizeof(ms_int32));
-
-    if( fread( ids, numshapes*sizeof(ms_int32), 1, disktree->fp ) != 1 )
-      goto error;
-    if (disktree->needswap ) {
-      for( i=0; i<numshapes; i++ ) {
-        SwapWord( 4, &ids[i] );
-        msSetBit(status, ids[i], 1);
-      }
-    } else {
-      for(i=0; i<numshapes; i++)
-        msSetBit(status, ids[i], 1);
-    }
-    free(ids);
-    ids = NULL;
-  }
-
-  if( fread( &numsubnodes, 4, 1, disktree->fp ) != 1 )
-    goto error;
-  if ( disktree->needswap ) SwapWord ( 4, &numsubnodes );
-  if( numsubnodes < 0 || numsubnodes > INT_MAX / 4 )
-    goto error;
-
-  for(i=0; i<numsubnodes; i++)
-    searchDiskTreeNode(disktree, aoi, status);
-
-  return;
-  
-error:
-  msSetError(MS_IOERR, NULL, "searchDiskTreeNode()");
-  free(ids);
-  return;
-}
-
-ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi, int debug, int numshapes)
-{
-  SHPTreeHandle disktree;
-  ms_bitarray status=NULL;
-
-  disktree = msSHPDiskTreeOpen (filename, debug);
-  if(!disktree) {
-
-    /* only set this error IF debugging is turned on, gets annoying otherwise */
-    if(debug) msSetError(MS_NOTFOUND, "Unable to open spatial index for %s. In most cases you can safely ignore this message, otherwise check file names and permissions.", "msSearchDiskTree()", filename);
-
-    return(NULL);
-  }
-
-  if (disktree->nShapes != numshapes) {
-      msSetError(MS_SHPERR, "The spatial index file %s is corrupt.", "msSearchDiskTree()", filename);
-      msSHPDiskTreeClose(disktree);
-      return(NULL);
-  }
-
-  status = msAllocBitArray(disktree->nShapes);
-  if(!status) {
-    msSetError(MS_MEMERR, NULL, "msSearchDiskTree()");
-    msSHPDiskTreeClose( disktree );
-    return(NULL);
-  }
-
-  searchDiskTreeNode(disktree, aoi, status);
-
-  msSHPDiskTreeClose( disktree );
-  return(status);
-}
-
-treeNodeObj *readTreeNode( SHPTreeHandle disktree )
-{
-  int i,res;
-  ms_int32 offset;
-  treeNodeObj *node;
-
-  node = (treeNodeObj *) msSmallMalloc(sizeof(treeNodeObj));
-  node->ids = NULL;
-
-  res = fread( &offset, 4, 1, disktree->fp );
-  if ( !res )
-  {
-    free(node);
-    return NULL;
-  }
-
-  if ( disktree->needswap ) SwapWord ( 4, &offset );
-
-  res = fread( &node->rect, sizeof(rectObj), 1, disktree->fp );
-  if ( !res )
-  {
-    free(node);
-    return NULL;
-  }
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.minx );
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.miny );
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.maxx );
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.maxy );
-
-  res = fread( &node->numshapes, 4, 1, disktree->fp );
-  if ( !res )
-  {
-    free(node);
-    return NULL;
-  }
-  if ( disktree->needswap ) SwapWord ( 4, &node->numshapes );
-  if ( node->numshapes < 0 || node->numshapes > INT_MAX / 4 )
-  {
-    free(node);
-    return NULL;
-  }
-  if( node->numshapes > 0 )
-  {
-    node->ids = (ms_int32 *)msSmallMalloc(sizeof(ms_int32)*node->numshapes);
-    res = fread( node->ids, node->numshapes*4, 1, disktree->fp );
-    if ( !res )
-    {
-      free(node->ids);
-      free(node);
-      return NULL;
-    }
-  }
-  for( i=0; i < node->numshapes; i++ ) {
-    if ( disktree->needswap ) SwapWord ( 4, &node->ids[i] );
-  }
-
-  res = fread( &node->numsubnodes, 4, 1, disktree->fp );
-  if ( !res )
-  {
-    free(node->ids);
-    free(node);
-    return NULL;
-  }
-  if ( disktree->needswap ) SwapWord ( 4, &node->numsubnodes );
-
-  return node;
-}
-
-treeObj *msReadTree(char *filename, int debug)
-{
-  treeObj *tree=NULL;
-  SHPTreeHandle disktree;
-
-  disktree = msSHPDiskTreeOpen( filename, debug );
-  if(!disktree) {
-    msSetError(MS_IOERR, NULL, "msReadTree()");
-    return(NULL);
-  }
-
-  tree = (treeObj *) malloc(sizeof(treeObj));
-  MS_CHECK_ALLOC(tree, sizeof(treeObj), NULL);
-
-  tree->numshapes = disktree->nShapes;
-  tree->maxdepth = disktree->nDepth;
-
-  tree->root = readTreeNode( disktree );
-
-  return(tree);
-}
-
-static ms_int32 getSubNodeOffset(treeNodeObj *node)
-{
-  int i;
-  ms_int32 offset=0;
-
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(node->subnode[i]) {
-      offset += sizeof(rectObj) + (node->subnode[i]->numshapes+3)*sizeof(int);
-      offset += getSubNodeOffset(node->subnode[i]);
-    }
-  }
-
-  /* offset is the disk offset in the index file on disk       */
-  /*   that format is (per node)                               */
-  /*      int       offset      4 bytes           */
-  /*      rectObj   rect      4 * 8 bytes         */
-  /*    int   numShapes   4 bytes           */
-  /*    int   ids[numShapes]  4 * numShapes bytes     */
-  /*    int   numSubNodes   4 bytes           */
-  /*                                               */
-
-  return(offset);
-}
-
-
-static void writeTreeNode(SHPTreeHandle disktree, treeNodeObj *node)
-{
-  int i,j;
-  ms_int32 offset;
-  char *pabyRec = NULL;
-
-  offset = getSubNodeOffset(node);
-
-  pabyRec = msSmallMalloc(sizeof(rectObj) + (3 * sizeof(ms_int32)) + (node->numshapes * sizeof(ms_int32)) );
-
-  memcpy( pabyRec, &offset, 4);
-  if( disktree->needswap ) SwapWord( 4, pabyRec );
-
-  memcpy( pabyRec+4, &node->rect, sizeof(rectObj));
-  for (i=0; i < 4; i++)
-    if( disktree->needswap ) SwapWord( 8, pabyRec+4+(8*i) );
-
-  memcpy( pabyRec+36, &node->numshapes, 4);
-  if( disktree->needswap ) SwapWord( 4, pabyRec+36 );
-
-  j = node->numshapes*sizeof(ms_int32);
-  memcpy( pabyRec+40, node->ids, j);
-  for (i=0; i<node->numshapes; i++)
-    if( disktree->needswap ) SwapWord( 4, pabyRec+40+(4*i));
-
-  memcpy( pabyRec+j+40, &node->numsubnodes, 4);
-  if( disktree->needswap ) SwapWord( 4, pabyRec+40+j );
-
-  fwrite( pabyRec, 44+j, 1, disktree->fp);
-  free (pabyRec);
-
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(node->subnode[i])
-      writeTreeNode(disktree, node->subnode[i]);
-  }
-
-
-  return;
-
-}
-
-int msWriteTree(treeObj *tree, char *filename, int B_order)
-{
-  char    signature[3] = "SQT";
-  char    version = 1;
-  char    reserved[3] = {0,0,0};
-  SHPTreeHandle disktree;
-  int   i;
-  char    mtBigEndian;
-  char    pabyBuf[32];
-  char    *pszBasename, *pszFullname;
-
-
-  disktree = (SHPTreeHandle) malloc(sizeof(SHPTreeInfo));
-  MS_CHECK_ALLOC(disktree, sizeof(SHPTreeInfo), MS_FALSE);
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension     */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(filename)+5);
-  strcpy( pszBasename, filename );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*  Open the .shp and .shx files.  Note that files pulled from      */
-  /*  a PC to Unix with upper case filenames won't work!        */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
-  disktree->fp = fopen(pszFullname, "wb");
-
-  msFree(pszBasename); /* not needed */
-  msFree(pszFullname);
-
-  if(!disktree->fp) {
-    msFree(disktree);
-    msSetError(MS_IOERR, NULL, "msWriteTree()");
-    return(MS_FALSE);
-  }
-
-
-  /* for efficiency, trim the tree */
-  msTreeTrim(tree);
-
-  /* -------------------------------------------------------------------- */
-  /*  Establish the byte order on this machine.         */
-  /* -------------------------------------------------------------------- */
-  i = 1;
-  /* cppcheck-suppress knownConditionTrueFalse */
-  if( *((uchar *) &i) == 1 )
-    mtBigEndian = MS_FALSE;
-  else
-    mtBigEndian = MS_TRUE;
-
-  if( !(mtBigEndian ^ ( B_order == MS_LSB_ORDER || B_order == MS_NEW_LSB_ORDER )) )
-    disktree->needswap = 1;
-  else
-    disktree->needswap = 0;
-
-  if( B_order == MS_NATIVE_ORDER )
-    disktree->needswap = 0;
-
-  /* write the header */
-  if ( B_order > 0 ) {
-    memcpy( pabyBuf, &signature, 3 );
-    memcpy (&disktree->signature, &signature, 3);
-    pabyBuf[3] = B_order;
-
-    memcpy( pabyBuf+4, &version, 1);
-    memcpy( pabyBuf+5, &reserved, 3);
-
-    memcpy( &disktree->version, &version, 1);
-    memcpy( &disktree->flags, &reserved, 3);
-
-    fwrite( pabyBuf, 8, 1, disktree->fp );
-  }
-
-  memcpy( pabyBuf, &tree->numshapes, 4 );
-  if( disktree->needswap ) SwapWord( 4, pabyBuf );
-
-  memcpy( pabyBuf+4, &tree->maxdepth, 4 );
-  if( disktree->needswap ) SwapWord( 4, pabyBuf+4 );
-
-  i = fwrite( pabyBuf, 8, 1, disktree->fp );
-  if( !i ) {
-    fprintf (stderr, "unable to write to index file ... exiting \n");
-    msSHPDiskTreeClose( disktree );
-    return (MS_FALSE);
-  }
-
-  writeTreeNode(disktree, tree->root);
-
-  msSHPDiskTreeClose( disktree );
-
-  return(MS_TRUE);
-}
-
-/* Function to filter search results further against feature bboxes */
-void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status, rectObj search_rect)
-{
-  int i;
-  rectObj shape_rect;
-
-  i = msGetNextBit(status, 0, shp->numshapes);
-  while(i >= 0) {
-    if(msSHPReadBounds(shp->hSHP, i, &shape_rect) == MS_SUCCESS) {
-      if(msRectOverlap(&shape_rect, &search_rect) != MS_TRUE) {
-        msSetBit(status, i, 0);
-      }
-    }
-    i = msGetNextBit(status, i+1, shp->numshapes);
-  }
-
-}
diff -pruN 8.0.1-5/maptree.h 8.2.0~beta1-1~exp1/maptree.h
--- 8.0.1-5/maptree.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maptree.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,99 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  .qix spatial index declarations.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPTREE_H
-#define MAPTREE_H
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-  /* this can be 2 or 4 for binary or quad tree */
-#define MAX_SUBNODES 4
-
-  typedef struct shape_tree_node {
-    /* area covered by this node */
-    rectObj rect;
-
-    /* list of shapes stored at this node. */
-    ms_int32 numshapes;
-    ms_int32 *ids;
-
-    int numsubnodes;
-    struct shape_tree_node *subnode[MAX_SUBNODES];
-  } treeNodeObj;
-
-  typedef struct {
-    ms_int32 numshapes;
-    ms_int32 maxdepth;
-    treeNodeObj *root;
-  } treeObj;
-
-
-  typedef struct {
-    FILE        *fp;
-    char        signature[3];
-    char  LSB_order;
-    char        needswap;
-    char  version;
-    char  flags[3];
-
-    ms_int32        nShapes;
-    ms_int32        nDepth;
-  } SHPTreeInfo;
-  typedef SHPTreeInfo * SHPTreeHandle;
-
-#define MS_LSB_ORDER -1
-#define MS_MSB_ORDER -2
-#define MS_NATIVE_ORDER 0
-#define MS_NEW_LSB_ORDER 1
-#define MS_NEW_MSB_ORDER 2
-
-
-  MS_DLL_EXPORT SHPTreeHandle msSHPDiskTreeOpen(const char * pszTree, int debug);
-  MS_DLL_EXPORT void msSHPDiskTreeClose(SHPTreeHandle disktree);
-  MS_DLL_EXPORT treeNodeObj *readTreeNode( SHPTreeHandle disktree );
-
-  MS_DLL_EXPORT treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth);
-  MS_DLL_EXPORT void msTreeTrim(treeObj *tree);
-  MS_DLL_EXPORT void msDestroyTree(treeObj *tree);
-
-  MS_DLL_EXPORT ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi);
-  MS_DLL_EXPORT ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi, int debug, int numshapes);
-
-  MS_DLL_EXPORT treeObj *msReadTree(char *filename, int debug);
-  MS_DLL_EXPORT int msWriteTree(treeObj *tree, char *filename, int LSB_order);
-
-  MS_DLL_EXPORT void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status, rectObj search_rect);
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* MAPTREE_H */
diff -pruN 8.0.1-5/mapunion.cpp 8.2.0~beta1-1~exp1/mapunion.cpp
--- 8.0.1-5/mapunion.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapunion.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,712 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of the union layer data provider (RFC-68).
- * Author:   Tamas Szekeres (szekerest@gmail.com).
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#define _CRT_SECURE_NO_WARNINGS 1
-
-/* $Id$ */
-#include <assert.h>
-#include "mapserver.h"
-
-
-
-#define MSUNION_NUMITEMS        3
-#define MSUNION_SOURCELAYERNAME        "Union_SourceLayerName"
-#define MSUNION_SOURCELAYERNAMEINDEX   -100
-#define MSUNION_SOURCELAYERGROUP        "Union_SourceLayerGroup"
-#define MSUNION_SOURCELAYERGROUPINDEX   -101
-#define MSUNION_SOURCELAYERVISIBLE        "Union_SourceLayerVisible"
-#define MSUNION_SOURCELAYERVISIBLEINDEX   -102
-
-typedef struct {
-  int layerIndex;  /* current source layer index */
-  int classIndex;  /* current class index */
-  char* classText;   /* current class text (autostyle) */
-  int layerCount;  /* number of the source layers */
-  layerObj* layers; /* structure to the source layers */
-  int *status;     /* the layer status */
-  int *classgroup; /* current array of the valid classes */
-  int nclasses;  /* number of the valid classes */
-  reprojectionObj* reprojectorSrcLayerToLayer;
-  int reprojectorCurSrcLayer;
-} msUnionLayerInfo;
-
-/* Close the the combined layer */
-int msUnionLayerClose(layerObj * const layer)
-{
-  int i;
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo)
-    return MS_SUCCESS;
-
-  if (!layer->map)
-    return MS_FAILURE;
-
-  msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
-  for (i = 0; i < layerinfo->layerCount; i++) {
-    layerObj* const srclayer = &layerinfo->layers[i];
-    msLayerClose(srclayer);
-    freeLayer(srclayer);
-  }
-  msFree(layerinfo->layers);
-  msFree(layerinfo->status);
-  msFree(layerinfo->classgroup);
-  msFree(layerinfo->classText);
-  msFree(layerinfo);
-  layer->layerinfo = NULL;
-
-  return MS_SUCCESS;
-}
-
-int isScaleInRange(mapObj* map, layerObj * const layer)
-{
-  if(map->scaledenom > 0) {
-    int i;
-    /* layer scale boundaries should be checked first */
-    if((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom))
-      return MS_FALSE;
-
-    if((layer->minscaledenom > 0) && (map->scaledenom <= layer->minscaledenom))
-      return MS_FALSE;
-
-    /* now check class scale boundaries (all layers *must* pass these tests) */
-    if(layer->numclasses > 0) {
-      for(i=0; i<layer->numclasses; i++) {
-        if((layer->_class[i]->maxscaledenom > 0) && (map->scaledenom > layer->_class[i]->maxscaledenom))
-          continue; /* can skip this one, next class */
-        if((layer->_class[i]->minscaledenom > 0) && (map->scaledenom <= layer->_class[i]->minscaledenom))
-          continue; /* can skip this one, next class */
-
-        break; /* can't skip this class (or layer for that matter) */
-      }
-      if(i == layer->numclasses)
-        return MS_FALSE;
-
-    }
-
-    if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
-      if((layer->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth))
-        return MS_FALSE;
-
-      if((layer->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < layer->mingeowidth))
-        return MS_FALSE;
-    }
-  }
-  return MS_TRUE;
-}
-
-int msUnionLayerOpen(layerObj * const layer)
-{
-  if (layer->layerinfo != NULL) {
-    return MS_SUCCESS;  /* Nothing to do... layer is already opened */
-  }
-
-  if (!layer->connection) {
-    msSetError(MS_MISCERR, "The CONNECTION option is not specified for layer: %s", "msUnionLayerOpen()", layer->name);
-    return MS_FAILURE;
-  }
-
-  if (!layer->map) {
-    msSetError(MS_MISCERR, "No map assigned to this layer: %s", "msUnionLayerOpen()", layer->name);
-    return MS_FAILURE;
-  }
-
-  mapObj* map = layer->map;
-
-  msUnionLayerInfo* layerinfo =(msUnionLayerInfo*)calloc(1, sizeof(msUnionLayerInfo));
-  MS_CHECK_ALLOC(layerinfo, sizeof(msUnionLayerInfo), MS_FAILURE);
-
-  layer->layerinfo = layerinfo;
-  layerinfo->layerIndex = 0;
-
-  layerinfo->classgroup = NULL;
-  layerinfo->nclasses = 0;
-
-  layerinfo->layerCount = 0;
-
-  layerinfo->classText = NULL;
-  layerinfo->reprojectorCurSrcLayer = -1;
-
-  const char* pkey = msLayerGetProcessingKey(layer, "UNION_STATUS_CHECK");
-  const bool status_check = (pkey && strcasecmp(pkey, "true") == 0);
-
-  pkey = msLayerGetProcessingKey(layer, "UNION_SCALE_CHECK");
-  const bool scale_check = !(pkey && strcasecmp(pkey, "false") == 0);
-
-  pkey = msLayerGetProcessingKey(layer, "UNION_SRCLAYER_CLOSE_CONNECTION");
-
-  const auto layerNames = msStringSplit(layer->connection, ',');
-
-  if (layerNames.empty()) {
-    msSetError(MS_MISCERR, "No source layers specified in layer: %s", "msUnionLayerOpen()", layer->name);
-    msUnionLayerClose(layer);
-    return MS_FAILURE;
-  }
-
-  const int layerCount = static_cast<int>(layerNames.size());
-  layerinfo->layers =(layerObj*)malloc(layerCount * sizeof(layerObj));
-  MS_CHECK_ALLOC(layerinfo->layers, layerCount * sizeof(layerObj), MS_FAILURE);
-
-  layerinfo->status =(int*)malloc(layerCount * sizeof(int));
-  MS_CHECK_ALLOC(layerinfo->status, layerCount * sizeof(int), MS_FAILURE);
-
-  for(int i=0; i < layerCount; i++) {
-    const char* layerName = layerNames[i].c_str();
-    const int layerindex = msGetLayerIndex(map, layerName);
-    if (layerindex >= 0 && layerindex < map->numlayers) {
-      const layerObj* const srclayer = map->layers[layerindex];
-
-      if (srclayer->type != layer->type) {
-        msSetError(MS_MISCERR, "The type of the source layer doesn't match with the union layer: %s", "msUnionLayerOpen()", srclayer->name);
-        msUnionLayerClose(layer);
-        return MS_FAILURE;
-      }
-
-      /* we need to create a new layer in order make the single pass query to work */
-      layerObj* dstlayer = &layerinfo->layers[i];
-      if(initLayer(dstlayer, map) == -1) {
-        msSetError(MS_MISCERR, "Cannot initialize source layer: %s", "msUnionLayerOpen()", srclayer->name);
-        msUnionLayerClose(layer);
-        return MS_FAILURE;
-      }
-
-      ++layerinfo->layerCount;
-
-      if (msCopyLayer(dstlayer, srclayer) != MS_SUCCESS) {
-        msSetError(MS_MISCERR, "Cannot copy source layer: %s", "msUnionLayerOpen()", srclayer->name);
-        msUnionLayerClose(layer);
-        return MS_FAILURE;
-      }
-
-      if (pkey) {
-        /* override connection flag */
-        msLayerSetProcessingKey(dstlayer, "CLOSE_CONNECTION", pkey);
-      }
-
-      /* check is we should skip this source (status check) */
-      if (status_check && dstlayer->status == MS_OFF) {
-        layerinfo->status[i] = MS_DONE;
-        continue;
-      }
-
-      /* check is we should skip this source (scale check) */
-      if (scale_check && isScaleInRange(map, dstlayer) == MS_FALSE) {
-        layerinfo->status[i] = MS_DONE;
-        continue;
-      }
-
-      layerinfo->status[i] = msLayerOpen(dstlayer);
-      if (layerinfo->status[i] != MS_SUCCESS) {
-        msUnionLayerClose(layer);
-        return MS_FAILURE;
-      }
-    } else {
-      msSetError(MS_MISCERR, "Invalid layer: %s", "msUnionLayerOpen()", layerName);
-      msUnionLayerClose(layer);
-      return MS_FAILURE;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
-int msUnionLayerIsOpen(layerObj * const layer)
-{
-  if (layer->layerinfo)
-    return(MS_TRUE);
-  else
-    return(MS_FALSE);
-}
-
-/* Free the itemindexes array in a layer. */
-void msUnionLayerFreeItemInfo(layerObj * const layer)
-{
-  int i;
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo || !layer->map)
-    return;
-
-  msFree(layer->iteminfo);
-
-  layer->iteminfo = NULL;
-
-  for (i = 0; i < layerinfo->layerCount; i++) {
-    msLayerFreeItemInfo(&(layerinfo->layers[i]));
-    if(layerinfo->layers[i].items) {
-      /* need to remove the source layer items */
-      msFreeCharArray(layerinfo->layers[i].items, layerinfo->layers[i].numitems);
-      layerinfo->layers[i].items = NULL;
-      layerinfo->layers[i].numitems = 0;
-    }
-  }
-}
-
-/* clean up expression tokens */
-void msUnionLayerFreeExpressionTokens(layerObj * const layer)
-{
-  int i,j;
-  msFreeExpressionTokens(&(layer->filter));
-  msFreeExpressionTokens(&(layer->cluster.group));
-  msFreeExpressionTokens(&(layer->cluster.filter));
-  for(i=0; i<layer->numclasses; i++) {
-    msFreeExpressionTokens(&(layer->_class[i]->expression));
-    msFreeExpressionTokens(&(layer->_class[i]->text));
-    for(j=0; j<layer->_class[i]->numstyles; j++)
-      msFreeExpressionTokens(&(layer->_class[i]->styles[j]->_geomtransform));
-  }
-}
-
-/* allocate the iteminfo index array - same order as the item list */
-int msUnionLayerInitItemInfo(layerObj * const layer)
-{
-  int i, numitems;
-  int *itemindexes;
-  char* itemlist = NULL;
-
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if(layer->numitems == 0) {
-    return MS_SUCCESS;
-  }
-
-  if (!layerinfo || !layer->map)
-    return MS_FAILURE;
-
-  /* Cleanup any previous item selection */
-  msUnionLayerFreeItemInfo(layer);
-
-  layer->iteminfo = (int *) malloc(sizeof(int) * layer->numitems);
-  MS_CHECK_ALLOC(layer->iteminfo, sizeof(int) * layer->numitems, MS_FAILURE);
-
-  itemindexes = (int*)layer->iteminfo;
-
-  /* check whether we require attributes from the source layers also */
-  numitems = 0;
-  for (i = 0; i < layer->numitems; i++) {
-    if (EQUAL(layer->items[i], MSUNION_SOURCELAYERNAME))
-      itemindexes[i] = MSUNION_SOURCELAYERNAMEINDEX;
-    else if (EQUAL(layer->items[i], MSUNION_SOURCELAYERGROUP))
-      itemindexes[i] = MSUNION_SOURCELAYERGROUPINDEX;
-    else if (EQUAL(layer->items[i], MSUNION_SOURCELAYERVISIBLE))
-      itemindexes[i] = MSUNION_SOURCELAYERVISIBLEINDEX;
-    else {
-      itemindexes[i] = numitems++;
-      if (itemlist) {
-        itemlist = msStringConcatenate(itemlist, ",");
-        itemlist = msStringConcatenate(itemlist, layer->items[i]);
-      } else {
-        itemlist = msStrdup(layer->items[i]);
-      }
-    }
-  }
-
-  for (i = 0; i < layerinfo->layerCount; i++) {
-    layerObj* const srclayer = &(layerinfo->layers[i]);
-
-    if (layerinfo->status[i] != MS_SUCCESS)
-      continue; /* skip empty layers */
-
-    msUnionLayerFreeExpressionTokens(srclayer);
-
-    if (itemlist) {
-      /* get items requested by the union layer plus the required items */
-      msLayerSetProcessingKey(srclayer, "ITEMS", itemlist);
-      if (msLayerWhichItems(srclayer, MS_TRUE, NULL) != MS_SUCCESS) {
-        msFree(itemlist);
-        return MS_FAILURE;
-      }
-    } else {
-      /* get only the required items */
-      if (msLayerWhichItems(srclayer, MS_FALSE, NULL) != MS_SUCCESS)
-        return MS_FAILURE;
-    }
-  }
-
-  msFree(itemlist);
-  return MS_SUCCESS;
-}
-
-// cppcheck-suppress passedByValue
-int msUnionLayerWhichShapes(layerObj * const layer, rectObj rect, int isQuery)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo || !layer->map)
-    return MS_FAILURE;
-
-  for (int i = 0; i < layerinfo->layerCount; i++) {
-    layerObj* const srclayer = &layerinfo->layers[i];
-
-    if (layerinfo->status[i] != MS_SUCCESS)
-      continue; /* skip empty layers */
-
-    if (layer->styleitem && layer->numitems == 0) {
-      /* need to initialize items */
-      msUnionLayerFreeExpressionTokens(srclayer);
-
-      /* get only the required items */
-      if (msLayerWhichItems(srclayer, MS_FALSE, NULL) != MS_SUCCESS)
-        return MS_FAILURE;
-    }
-
-    rectObj srcRect = rect;
-
-    if(srclayer->transform == MS_TRUE && srclayer->project && layer->transform == MS_TRUE && layer->project &&msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
-      msProjectRect(&layer->projection, &srclayer->projection, &srcRect); /* project the searchrect to source coords */
-
-    layerinfo->status[i] = msLayerWhichShapes(srclayer, srcRect, isQuery);
-    if (layerinfo->status[i] == MS_FAILURE)
-      return MS_FAILURE;
-  }
-
-  layerinfo->layerIndex = 0;
-  layerObj* const srclayer = &layerinfo->layers[0];
-
-  msFree(layerinfo->classgroup);
-
-  layerinfo->classgroup = NULL;
-  layerinfo->nclasses = 0;
-
-  if (srclayer->classgroup && srclayer->numclasses > 0)
-    layerinfo->classgroup = msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
-
-  return MS_SUCCESS;
-}
-
-static int BuildFeatureAttributes(layerObj * const layer, const layerObj* srclayer, shapeObj *shape)
-{
-  const int* const itemindexes = static_cast<const int*>(layer->iteminfo);
-
-  char** values = static_cast<char**>(msSmallMalloc(sizeof(char*) * (layer->numitems)));
-  MS_CHECK_ALLOC(values, layer->numitems * sizeof(char*), MS_FAILURE);;
-
-  for (int i = 0; i < layer->numitems; i++) {
-    if (itemindexes[i] == MSUNION_SOURCELAYERNAMEINDEX)
-      values[i] = msStrdup(srclayer->name);
-    else if (itemindexes[i] == MSUNION_SOURCELAYERGROUPINDEX)
-      values[i] = msStrdup(srclayer->group);
-    else if (itemindexes[i] == MSUNION_SOURCELAYERVISIBLEINDEX) {
-      if (srclayer->status == MS_OFF)
-        values[i] = msStrdup("0");
-      else
-        values[i] = msStrdup("1");
-    } else if (shape->values[itemindexes[i]])
-      values[i] = msStrdup(shape->values[itemindexes[i]]);
-    else
-      values[i] = msStrdup("");
-  }
-
-  if (shape->values)
-    msFreeCharArray(shape->values, shape->numvalues);
-
-  shape->values = values;
-  shape->numvalues = layer->numitems;
-
-  return MS_SUCCESS;
-}
-
-/* find the next shape with the appropriate shape type */
-/* also, load in the attribute data */
-/* MS_DONE => no more data */
-int msUnionLayerNextShape(layerObj * const layer, shapeObj *shape)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo || !layer->map)
-    return MS_FAILURE;
-
-  if (layerinfo->layerIndex < 0 || layerinfo->layerIndex >= layerinfo->layerCount)
-    return MS_FAILURE;
-
-  int rv = MS_DONE;
-
-  while (layerinfo->layerIndex < layerinfo->layerCount) {
-    layerObj* srclayer = &layerinfo->layers[layerinfo->layerIndex];
-    if (layerinfo->status[layerinfo->layerIndex] == MS_SUCCESS) {
-      while ((rv = srclayer->vtable->LayerNextShape(srclayer, shape)) == MS_SUCCESS) {
-        if(layer->styleitem) {
-          /* need to retrieve the source layer classindex if styleitem AUTO is set */
-          layerinfo->classIndex = msShapeGetClass(srclayer, layer->map, shape, layerinfo->classgroup, layerinfo->nclasses);
-          if(layerinfo->classIndex < 0 || layerinfo->classIndex >= srclayer->numclasses) {
-            /*  this shape is not visible, skip it */
-            msFreeShape(shape);
-            continue;
-          }
-          if(srclayer->styleitem && strcasecmp(srclayer->styleitem, "AUTO") != 0) {
-            /* Generic feature style handling as per RFC-61 */
-            msLayerGetFeatureStyle(layer->map, srclayer, srclayer->_class[layerinfo->classIndex], shape);
-          }
-          /* set up annotation */
-          msFree(layerinfo->classText);
-          layerinfo->classText = NULL;
-          if(srclayer->_class[layerinfo->classIndex]->numlabels > 0) {
-            /* pull text from the first label only */
-            if(msGetLabelStatus(layer->map,layer,shape,srclayer->_class[layerinfo->classIndex]->labels[0]) == MS_ON) {
-              layerinfo->classText = msShapeGetLabelAnnotation(layer,shape,srclayer->_class[layerinfo->classIndex]->labels[0]);
-            }
-          }
-        }
-
-        /* reproject to the target layer */
-        if( layerinfo->reprojectorCurSrcLayer != layerinfo->layerIndex )
-        {
-            msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
-            layerinfo->reprojectorSrcLayerToLayer = NULL;
-            layerinfo->reprojectorCurSrcLayer = layerinfo->layerIndex;
-            if(srclayer->project && msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
-                layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(&(srclayer->projection), &(layer->projection));
-            else
-                srclayer->project = MS_FALSE;
-        }
-        if(layerinfo->reprojectorSrcLayerToLayer)
-            msProjectShapeEx(layerinfo->reprojectorSrcLayerToLayer, shape);
-
-        /* update the layer styles with the bound values */
-        if(msBindLayerToShape(srclayer, shape, MS_FALSE) != MS_SUCCESS)
-          return MS_FAILURE;
-
-        shape->tileindex = layerinfo->layerIndex;
-
-        /* construct the item array */
-        if (layer->iteminfo)
-          rv = BuildFeatureAttributes(layer, srclayer, shape);
-
-        /* check the layer filter condition */
-        if(layer->filter.string != NULL && layer->numitems > 0 && layer->iteminfo) {
-          if (layer->filter.type == MS_EXPRESSION && layer->filter.tokens == NULL)
-            msTokenizeExpression(&(layer->filter), layer->items, &(layer->numitems));
-
-          if (!msEvalExpression(layer, shape, &(layer->filter), layer->filteritemindex)) {
-            /* this shape is filtered */
-            msFreeShape(shape);
-            continue;
-          }
-        }
-
-        return rv;
-      }
-    }
-
-    ++layerinfo->layerIndex;
-    if (layerinfo->layerIndex == layerinfo->layerCount) {
-      layerinfo->layerIndex = 0;
-      return MS_DONE;
-    }
-
-    /* allocate the classgroups for the next layer */
-    msFree(layerinfo->classgroup);
-
-    layerinfo->classgroup = NULL;
-    layerinfo->nclasses = 0;
-
-    if (srclayer->classgroup && srclayer->numclasses > 0)
-      layerinfo->classgroup = msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
-  }
-
-  return rv;
-}
-
-/* Random access of the feature. */
-int msUnionLayerGetShape(layerObj * const layer, shapeObj *shape, resultObj *record)
-{
-  const long tile = record->tileindex;
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo || !layer->map)
-    return MS_FAILURE;
-
-  if (tile < 0 || tile >= layerinfo->layerCount) {
-    msSetError(MS_MISCERR, "Invalid tile index: %s", "msUnionLayerGetShape()", layer->name);
-    return MS_FAILURE;
-  }
-
-  layerObj* const srclayer = &layerinfo->layers[tile];
-  record->tileindex = 0;
-  int rv = srclayer->vtable->LayerGetShape(srclayer, shape, record);
-  record->tileindex = tile;
-
-  if (rv == MS_SUCCESS) {
-    /* reproject to the target layer */
-    if( layerinfo->reprojectorCurSrcLayer != tile )
-    {
-        msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
-        layerinfo->reprojectorSrcLayerToLayer = NULL;
-        layerinfo->reprojectorCurSrcLayer = tile;
-        if(srclayer->project && msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
-            layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(&(srclayer->projection), &(layer->projection));
-        else
-            srclayer->project = MS_FALSE;
-    }
-    if(layerinfo->reprojectorSrcLayerToLayer)
-      msProjectShapeEx(layerinfo->reprojectorSrcLayerToLayer, shape);
-
-    shape->tileindex = tile;
-
-    /* construct the item array */
-    if (layer->iteminfo)
-      rv = BuildFeatureAttributes(layer, srclayer, shape);
-  }
-
-  return rv;
-}
-
-/* Query for the items collection */
-int msUnionLayerGetItems(layerObj * const layer)
-{
-  /* we support certain built in attributes */
-  layer->numitems = 2;
-  layer->items = static_cast<char**>(msSmallMalloc(sizeof(char*) * (layer->numitems)));
-  MS_CHECK_ALLOC(layer->items, layer->numitems * sizeof(char*), MS_FAILURE);
-  layer->items[0] = msStrdup(MSUNION_SOURCELAYERNAME);
-  layer->items[1] = msStrdup(MSUNION_SOURCELAYERGROUP);
-
-  return msUnionLayerInitItemInfo(layer);
-}
-
-int msUnionLayerGetNumFeatures(layerObj * const layer)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo || !layer->map)
-    return 0;
-
-  int numFeatures = 0;
-
-  for (int i = 0; i < layerinfo->layerCount; i++) {
-    if (layerinfo->status[i] != MS_SUCCESS)
-      continue; /* skip empty layers */
-
-    int c = msLayerGetNumFeatures(&(layerinfo->layers[i]));
-    if (c > 0)
-      numFeatures += c;
-  }
-
-  return numFeatures;
-}
-
-static int msUnionLayerGetAutoStyle(mapObj *map, layerObj * const layer, classObj *c, shapeObj* shape)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
-
-  if (!layerinfo || !layer->map)
-    return MS_FAILURE;
-
-  if (shape->tileindex < 0 || shape->tileindex >= layerinfo->layerCount) {
-    msSetError(MS_MISCERR, "Invalid tile index: %s", "msUnionLayerGetAutoStyle()", layer->name);
-    return MS_FAILURE;
-  }
-
-  layerObj* const srclayer = &layerinfo->layers[shape->tileindex];
-
-  if(srclayer->styleitem && strcasecmp(srclayer->styleitem, "AUTO") == 0) {
-    const int tileindex = shape->tileindex;
-    shape->tileindex = 0;
-    int rv = msLayerGetAutoStyle(map, srclayer, c, shape);
-    shape->tileindex = tileindex;
-    return rv;
-  } else {
-    const classObj* src = srclayer->_class[layerinfo->classIndex];
-    /* copy the style from the current class index */
-    /* free any previous styles on the dst layer */
-
-    resetClassStyle(c);
-
-    for (int i = 0; i < src->numstyles; i++) {
-      if (msMaybeAllocateClassStyle(c, i))
-        return MS_FAILURE;
-
-      if (msCopyStyle(c->styles[i], src->styles[i]) != MS_SUCCESS) {
-        msSetError(MS_MEMERR, "Failed to copy style.", "msUnionLayerGetAutoStyle()");
-        return MS_FAILURE;
-      }
-      /* remove the bindings on the style */
-      for(int j=0; j<MS_STYLE_BINDING_LENGTH; j++) {
-        msFree(c->styles[i]->bindings[j].item);
-        c->styles[i]->bindings[j].item = NULL;
-      }
-      c->styles[i]->numbindings = 0;
-    }
-
-    for (int i = 0; i < src->numlabels; i++) {
-      // RFC77 TODO: allocation need to be done, but is the right way (from mapcopy.c)?
-      if (msGrowClassLabels(c) == NULL)
-        return MS_FAILURE;
-      initLabel(c->labels[i]);
-
-      if (msCopyLabel(c->labels[i], src->labels[i]) != MS_SUCCESS) {
-        msSetError(MS_MEMERR, "Failed to copy label.", "msUnionLayerGetAutoStyle()");
-        return MS_FAILURE;
-      }
-
-      /* remove the bindings on the label */
-      for(int j=0; j<MS_LABEL_BINDING_LENGTH; j++) {
-        msFree(c->labels[i]->bindings[j].item);
-        c->labels[i]->bindings[j].item = NULL;
-      }
-      c->labels[i]->numbindings = 0;
-    }
-    c->numlabels = src->numlabels;
-
-    c->layer = layer;
-    c->text.string = layerinfo->classText;
-    layerinfo->classText = NULL;
-  }
-  return MS_SUCCESS;
-}
-
-int msUnionLayerCopyVirtualTable(layerVTableObj* vtable)
-{
-  vtable->LayerInitItemInfo = msUnionLayerInitItemInfo;
-  vtable->LayerFreeItemInfo = msUnionLayerFreeItemInfo;
-  vtable->LayerOpen = msUnionLayerOpen;
-  vtable->LayerIsOpen = msUnionLayerIsOpen;
-  vtable->LayerWhichShapes = msUnionLayerWhichShapes;
-  vtable->LayerNextShape = msUnionLayerNextShape;
-  vtable->LayerGetShape = msUnionLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  vtable->LayerClose = msUnionLayerClose;
-
-  vtable->LayerGetItems = msUnionLayerGetItems;
-  vtable->LayerCloseConnection = msUnionLayerClose;
-  vtable->LayerGetAutoStyle = msUnionLayerGetAutoStyle;
-
-  vtable->LayerGetNumFeatures = msUnionLayerGetNumFeatures;
-
-  return MS_SUCCESS;
-}
-
-int msUnionLayerInitializeVirtualTable(layerObj * const layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  return msUnionLayerCopyVirtualTable(layer->vtable);
-}
diff -pruN 8.0.1-5/maputfgrid.cpp 8.2.0~beta1-1~exp1/maputfgrid.cpp
--- 8.0.1-5/maputfgrid.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maputfgrid.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,772 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  UTFGrid rendering functions (using AGG)
- * Author:   Francois Desjarlais
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-
-#include "mapserver.h"
-#include "maputfgrid.h"
-#include "mapagg.h"
-#include "renderers/agg/include/agg_rasterizer_scanline_aa.h"
-#include "renderers/agg/include/agg_basics.h"
-#include "renderers/agg/include/agg_renderer_scanline.h"
-#include "renderers/agg/include/agg_scanline_bin.h"
-#include "renderers/agg/include/agg_gamma_functions.h"
-#include "renderers/agg/include/agg_conv_stroke.h"
-#include "renderers/agg/include/agg_ellipse.h"
-
-#include <memory>
-#include <vector>
-
-typedef mapserver::int32u band_type;
-typedef mapserver::row_ptr_cache<band_type> rendering_buffer;
-typedef pixfmt_utf<utfpix32, rendering_buffer> pixfmt_utf32;
-typedef mapserver::renderer_base<pixfmt_utf32> renderer_base;
-typedef mapserver::rasterizer_scanline_aa<> rasterizer_scanline;
-typedef mapserver::renderer_scanline_bin_solid<renderer_base> renderer_scanline;
-
-static const utfpix32 UTF_WATER = utfpix32(32);
-
-#define utfitem(c) utfpix32(c)
-
-namespace {
-
-struct shapeData
-{
-  std::string datavalues{};
-  std::string itemvalue{};
-  band_type utfvalue = 0;
-  int serialid = 0;
-};
-
-/*
- * UTFGrid specific polygon adaptor.
- */
-class polygon_adaptor_utf final: public polygon_adaptor
-{
-public:
-  polygon_adaptor_utf(shapeObj *shape,int utfres_in):
-      polygon_adaptor(shape),
-      utfresolution(utfres_in)
-  {
-  }
-
-  unsigned vertex(double* x, double* y) override
-  {
-    if(m_point < m_pend) {
-      bool first = m_point == m_line->point;
-      *x = m_point->x/utfresolution;
-      *y = m_point->y/utfresolution;
-      m_point++;
-      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
-    }
-    *x = *y = 0.0;
-    if(!m_stop) {
-
-      m_line++;
-      if(m_line>=m_lend) {
-        m_stop=true;
-        return mapserver::path_cmd_end_poly;
-      }
-
-      m_point=m_line->point;
-      m_pend=&(m_line->point[m_line->numpoints]);
-      return mapserver::path_cmd_end_poly;
-    }
-    return mapserver::path_cmd_stop;
-  }
-
-private:
-  int utfresolution;
-};
-
-/*
- * UTFGrid specific line adaptor.
- */
-class line_adaptor_utf final: public line_adaptor
-{
-public:
-  line_adaptor_utf(shapeObj *shape,int utfres_in):
-      line_adaptor(shape),
-      utfresolution(utfres_in)
-  {
-  }
-
-  unsigned vertex(double* x, double* y) override
-  {
-    if(m_point < m_pend) {
-      bool first = m_point == m_line->point;
-      *x = m_point->x/utfresolution;
-      *y = m_point->y/utfresolution;
-      m_point++;
-      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
-    }
-    m_line++;
-    *x = *y = 0.0;
-    if(m_line>=m_lend)
-      return mapserver::path_cmd_stop;
-
-    m_point=m_line->point;
-    m_pend=&(m_line->point[m_line->numpoints]);
-
-    return vertex(x,y);
-  }
-
-private:
-  int utfresolution;
-};
-
-class UTFGridRenderer {
-public:
-  std::vector<shapeData> table{};
-  int utfresolution = 0;
-  int layerwatch = 0;
-  bool renderlayer = false;
-  bool useutfitem = false;
-  bool useutfdata = false;
-  bool duplicates = false;
-  band_type utfvalue = 0;
-  layerObj *utflayer = nullptr;
-  int width = 0;
-  int height = 0;
-  std::vector<band_type> buffer{};
-  rendering_buffer m_rendering_buffer{};
-  pixfmt_utf32 m_pixel_format{};
-  renderer_base m_renderer_base{};
-  rasterizer_scanline m_rasterizer{};
-  renderer_scanline m_renderer_scanline{};
-  mapserver::scanline_bin sl_utf{};
-  std::unique_ptr<mapserver::conv_stroke<line_adaptor_utf>> stroke{};
-};
-
-} // namespace
-
-#define UTFGRID_RENDERER(image) (static_cast<UTFGridRenderer*>((image)->img.plugin))
-
-/*
- * Encode to avoid unavailable char in the JSON
- */
-static
-unsigned int encodeForRendering(unsigned int toencode)
-{
-  unsigned int encoded;
-  encoded = toencode + 32;
-  /* 34 => " */
-  if(encoded >= 34) {
-    encoded = encoded +1;
-  }
-  /* 92 => \ */
-  if (encoded >= 92) {
-    encoded = encoded +1;
-  }
-  return encoded;
-}
-
-/*
- * Decode value to have the initial one
- */
-static
-unsigned int decodeRendered(unsigned int todecode)
-{
-  unsigned int decoded;
-  
-  if(todecode >= 92)
-    todecode --;
-
-  if(todecode >= 34)
-    todecode --;
-
-  decoded = todecode-32;
-
-  return decoded;
-}
-
-/*
- * Add the shapeObj UTFDATA and UTFITEM to the lookup table.
- */
-static
-band_type addToTable(UTFGridRenderer *r, shapeObj *p)
-{
-  /* Looks for duplicates. */
-  if(r->duplicates == false && r->useutfitem) {
-    const auto itemvalue = p->values[r->utflayer->utfitemindex];
-    for( const auto& tableItem: r->table ) {
-      if(tableItem.itemvalue == itemvalue) {
-        /* Found a copy of the values in the table. */
-        return tableItem.utfvalue;
-      }
-    }
-  }
-
-  /* Data added to the table */
-  shapeData table;
-  char* escaped = msEvalTextExpressionJSonEscape(&r->utflayer->utfdata, p);
-  table.datavalues = escaped ? escaped : "";
-  msFree(escaped);
-
-  /* If UTFITEM is set in the mapfile we add its value to the table */
-  if(r->useutfitem)
-    table.itemvalue = p->values[r->utflayer->utfitemindex];
-
-  table.serialid = static_cast<int>(r->table.size()+1);
-
-  /* Simple operation so we don't have unavailable char in the JSON */
-  const auto utfvalue = encodeForRendering(table.serialid);
-  table.utfvalue = utfvalue;
-
-  r->table.emplace_back(std::move(table));
-
-  return utfvalue;
-}
-
-/*
- * Use AGG to render any path.
- */
-template<class vertex_source>
-static int utfgridRenderPath(imageObj *img, vertex_source &path)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-  r->m_rasterizer.reset();
-  r->m_rasterizer.filling_rule(mapserver::fill_even_odd);
-  r->m_rasterizer.add_path(path);
-  r->m_renderer_scanline.color(utfitem(r->utfvalue));
-  mapserver::render_scanlines(r->m_rasterizer, r->sl_utf, r->m_renderer_scanline);
-  return MS_SUCCESS;
-}
-
-/*
- * Initialize the renderer, create buffer, allocate memory.
- */
-static
-imageObj *utfgridCreateImage(int width, int height, outputFormatObj *format, colorObj * /*bg*/)
-{
-  auto r = std::unique_ptr<UTFGridRenderer>(new UTFGridRenderer);
-
-  r->utfresolution = atof(msGetOutputFormatOption(format, "UTFRESOLUTION", "4"));
-  if(r->utfresolution < 1) {
-    msSetError(MS_MISCERR, "UTFRESOLUTION smaller that 1 in the mapfile.", "utfgridCreateImage()");
-    return nullptr;
-  }
-  r->duplicates = EQUAL("true", msGetOutputFormatOption(format, "DUPLICATES", "true"));
-
-  r->width = width/r->utfresolution;
-  r->height = height/r->utfresolution;
-
-  r->buffer.resize(r->width * r->height);
-
-  /* AGG specific operations */
-  r->m_rendering_buffer.attach(&r->buffer[0], r->width, r->height, r->width);
-  r->m_pixel_format.attach(r->m_rendering_buffer);
-  r->m_renderer_base.attach(r->m_pixel_format);
-  r->m_renderer_scanline.attach(r->m_renderer_base);
-  r->m_renderer_base.clear(UTF_WATER);
-  r->m_rasterizer.gamma(mapserver::gamma_none());
-
-  imageObj *image = (imageObj *) msSmallCalloc(1,sizeof(imageObj));
-  image->img.plugin = r.release();
-
-  return image;
-}
-
-/*
- * Free all the memory used by the renderer.
- */
-static
-int utfgridFreeImage(imageObj *img)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-  delete r;
-
-  img->img.plugin = NULL;
-
-  return MS_SUCCESS;
-}
-
-/*
- * Update a character in the utfgrid.
-*/
-static
-int utfgridUpdateChar(imageObj *img, band_type oldChar, band_type newChar)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  for( auto& ch: r->buffer ) {
-    if(ch == oldChar) {
-      ch = newChar;
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
- * Remove unnecessary data that didn't made it to the final grid.
- */
-static
-int utfgridCleanData(imageObj *img)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  std::vector<bool> usedChar;
-  usedChar.resize(r->table.size());
-
-  int itemFound=0;
-
-  for(const auto ch: r->buffer)
-  {
-    const auto rendered = decodeRendered(ch);
-    if(rendered != 0 && !usedChar[rendered-1])
-    {
-      itemFound++;
-      usedChar[rendered-1] = true;
-    }
-  }
-
-  std::vector<shapeData> updatedData;
-  updatedData.reserve(itemFound);
-
-  for(const auto& tableItem: r->table) {
-    if(usedChar[decodeRendered(tableItem.utfvalue)-1]){
-        updatedData.emplace_back(tableItem);
-        auto& newData = updatedData.back();
-
-        newData.serialid=static_cast<int>(updatedData.size());
-
-        const band_type utfvalue=encodeForRendering(newData.serialid);
-
-        utfgridUpdateChar(img,newData.utfvalue,utfvalue);
-        newData.utfvalue = utfvalue;
-    }
-  }
-
-  r->table = std::move(updatedData);
-
-  return MS_SUCCESS;
-}
-
-/*
- * Print the renderer data as JSON.
- */
-static
-int utfgridSaveImage(imageObj *img, mapObj * /*map*/, FILE *fp, outputFormatObj * /*format*/)
-{
-  utfgridCleanData(img);
-
-  const UTFGridRenderer *renderer = UTFGRID_RENDERER(img);
-
-  if(renderer->layerwatch>1)
-    return MS_FAILURE;
-
-  const int imgheight = renderer->height;
-  const int imgwidth = renderer->width;
-
-  msIO_fprintf(fp,"{\"grid\":[");
-
-  /* Print the buffer */
-  std::vector<wchar_t> string;
-  string.resize(imgwidth+1);
-  for(int row=0; row<imgheight; row++) {
-
-    /* Need a comma between each line but JSON must not start with a comma. */
-    if(row!=0)
-      msIO_fprintf(fp,",");
-    msIO_fprintf(fp,"\"");
-    for(int col=0; col<imgwidth; col++) {
-      /* Get the data from buffer. */
-      band_type pixelid = renderer->buffer[(row*imgwidth)+col];
-      string[col] = pixelid;
-    }
-
-    /* Conversion to UTF-8 encoding */
-#if defined(_WIN32) && !defined(__CYGWIN__)
-	const char* encoding = "UCS-2LE";
-#else
-	const char* encoding = "UCS-4LE";
-#endif
-
-    char* utf8 = msConvertWideStringToUTF8(string.data(), encoding);
-    msIO_fprintf(fp,"%s", utf8);
-    msFree(utf8);
-    msIO_fprintf(fp,"\"");
-  }
-
-  msIO_fprintf(fp,"],\"keys\":[\"\"");
-
-  /* Print the specified key */
-  for(const auto& table: renderer->table) {
-      msIO_fprintf(fp,",");
-
-    if(renderer->useutfitem)
-    {
-      char* pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
-      msIO_fprintf(fp,"\"%s\"", pszEscaped);
-      msFree(pszEscaped);
-    }
-    /* If no UTFITEM specified use the serial ID as the key */
-    else
-      msIO_fprintf(fp,"\"%i\"", table.serialid);
-  }
-
-  msIO_fprintf(fp,"],\"data\":{");
-
-  /* Print the data */
-  if(renderer->useutfdata) {
-    bool first = true;
-    for(const auto& table: renderer->table) {
-      if(!first)
-        msIO_fprintf(fp,",");
-      first = false;
-
-      if(renderer->useutfitem)
-      {
-        char* pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
-        msIO_fprintf(fp,"\"%s\":", pszEscaped);
-        msFree(pszEscaped);
-      }
-      /* If no UTFITEM specified use the serial ID as the key */
-      else
-        msIO_fprintf(fp,"\"%i\":", table.serialid);
-
-      msIO_fprintf(fp,"%s", table.datavalues.c_str());
-    }
-  }
-  msIO_fprintf(fp,"}}");
-
-  return MS_SUCCESS;
-}
-
-/*
- * Starts a layer for UTFGrid renderer.
- */
-static
-int utfgridStartLayer(imageObj *img, mapObj * /*map*/, layerObj *layer)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  /* Look if the layer uses the UTFGrid output format */
-  if(layer->utfdata.string!=0) {
-    r->useutfdata = true;
-  }
-
-    /* layerwatch is set to 1 on first layer treated. Doesn't allow multiple layers. */
-    if(!r->layerwatch) {
-      r->layerwatch++;
-
-      r->renderlayer = true;
-      r->utflayer = layer;
-      layer->refcount++;
-
-      /* Verify if renderer needs to use UTFITEM */
-      if(r->utflayer->utfitem)
-        r->useutfitem = true;
-    }
-    /* If multiple layers, send error */
-    else {
-      r->layerwatch++;
-      msSetError(MS_MISCERR, "MapServer does not support multiple UTFGrid layers rendering simultaneously.", "utfgridStartLayer()");
-      return MS_FAILURE;
-    }
-
-  return MS_SUCCESS;
-}
-
-/*
- * Tell renderer the layer is done.
- */
-static
-int utfgridEndLayer(imageObj *img, mapObj * /*map*/, layerObj *layer)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  /* Look if the layer was rendered, if it was then turn off rendering. */
-  if(r->renderlayer) {
-    r->utflayer = NULL;
-    layer->refcount--;
-    r->renderlayer = false;
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
- * Do the table operations on the shapes. Allow multiple types of data to be rendered.
- */
-static
-int utfgridStartShape(imageObj *img, shapeObj *shape)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  if(!r->renderlayer)
-    return MS_FAILURE;
-
-  /* Table operations */
-  r->utfvalue = addToTable(r, shape);
-
-  return MS_SUCCESS;
-}
-
-/*
- * Tells the renderer that the shape's rendering is done.
- */
-static
-int utfgridEndShape(imageObj *img, shapeObj *)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  r->utfvalue = 0;
-  return MS_SUCCESS;
-}
-
-/*
- * Function that renders polygons into UTFGrid.
- */
-static
-int utfgridRenderPolygon(imageObj *img, shapeObj *polygonshape, colorObj *)
-{
-  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
-    return MS_FAILURE;
-  }
-
-  /* Render the polygon */
-  polygon_adaptor_utf polygons(polygonshape, r->utfresolution);
-  utfgridRenderPath(img, polygons);
-
-  return MS_SUCCESS;
-}
-
-/*
- * Function that renders lines into UTFGrid. Starts by looking if the line is a polygon
- * outline, draw it if it's not.
- */
-static
-int utfgridRenderLine(imageObj *img, shapeObj *lineshape, strokeStyleObj *linestyle)
-{
-  UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
-    return MS_SUCCESS;
-    /* If we dont get a caracter to draw we just skip execution
-     * instead of failing
-     */
-  }
-
-  /* Render the line */
-  line_adaptor_utf lines(lineshape, r->utfresolution);
-
-  if(!r->stroke) {
-    r->stroke.reset(new mapserver::conv_stroke<line_adaptor_utf>(lines));
-  } else {
-    r->stroke->attach(lines);
-  }
-  r->stroke->width(linestyle->width/r->utfresolution);
-  utfgridRenderPath(img, *r->stroke);
-
-  return MS_SUCCESS;
-}
-
-/*
- * Function that render vector type symbols into UTFGrid.
- */
-static
-int utfgridRenderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
-  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
-  double ox = symbol->sizex * 0.5;
-  double oy = symbol->sizey * 0.5;
-
-  /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
-    return MS_FAILURE;
-  }
-
-  /* Pathing the symbol */
-  mapserver::path_storage path = imageVectorSymbol(symbol);
-
-  /* Transformation to the right size/scale. */
-  mapserver::trans_affine mtx;
-  mtx *= mapserver::trans_affine_translation(-ox,-oy);
-  mtx *= mapserver::trans_affine_scaling(style->scale/r->utfresolution);
-  mtx *= mapserver::trans_affine_rotation(-style->rotation);
-  mtx *= mapserver::trans_affine_translation(x/r->utfresolution, y/r->utfresolution);
-  path.transform(mtx);
-
-  /* Rendering the symbol. */
-  utfgridRenderPath(img, path);
-
-  return MS_SUCCESS;
-}
-
-/*
- * Function that renders Pixmap type symbols into UTFGrid.
- */
-static
-int utfgridRenderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
-  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
-  rasterBufferObj *pixmap = symbol->pixmap_buffer;
-
-  /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
-    return MS_FAILURE;
-  }
-
-  /* Pathing the symbol BBox */
-  mapserver::path_storage pixmap_bbox;
-  double w, h;
-  w = pixmap->width*style->scale/(2.0);
-  h= pixmap->height*style->scale/(2.0);
-  pixmap_bbox.move_to((x-w)/r->utfresolution,(y-h)/r->utfresolution);
-  pixmap_bbox.line_to((x+w)/r->utfresolution,(y-h)/r->utfresolution);
-  pixmap_bbox.line_to((x+w)/r->utfresolution,(y+h)/r->utfresolution);
-  pixmap_bbox.line_to((x-w)/r->utfresolution,(y+h)/r->utfresolution);
-
-  /* Rendering the symbol */
-  utfgridRenderPath(img, pixmap_bbox);
-
-  return MS_SUCCESS;
-}
-
-/*
- * Function that render ellipse type symbols into UTFGrid.
- */
-static
-int utfgridRenderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
-  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
-    return MS_FAILURE;
-  }
-
-  /* Pathing the symbol. */
-  mapserver::path_storage path;
-  mapserver::ellipse ellipse(x/r->utfresolution,y/r->utfresolution,symbol->sizex*style->scale/2/r->utfresolution,symbol->sizey*style->scale/2/r->utfresolution);
-  path.concat_path(ellipse);
-
-  /* Rotation if necessary. */
-  if( style->rotation != 0) {
-    mapserver::trans_affine mtx;
-    mtx *= mapserver::trans_affine_translation(-x/r->utfresolution,-y/r->utfresolution);
-    mtx *= mapserver::trans_affine_rotation(-style->rotation);
-    mtx *= mapserver::trans_affine_translation(x/r->utfresolution,y/r->utfresolution);
-    path.transform(mtx);
-  }
-
-  /* Rendering the symbol. */
-  utfgridRenderPath(img, path);
-
-  return MS_SUCCESS;
-}
-
-static
-int utfgridRenderGlyphs(imageObj *img, const textSymbolObj *ts, colorObj * /*c*/, colorObj * /*oc*/, int /*ow*/, int isMarker) {
-
-  const textPathObj *tp = ts->textpath;
-  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
-
-  /* If it's not a marker then it's a label or other thing and we dont
-   *  want to draw it on the map
-   */
-  if(!isMarker) {
-    return MS_SUCCESS; //Stop the rendering with no errors
-  }
-
-  /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
-    return MS_SUCCESS; //Stop the rendering with no errors
-  }
-
-  /* Pathing the symbol BBox */
-  mapserver::path_storage box;
-  double size, x, y;
-  
-  size = tp->glyph_size;;
-  x = tp->glyphs->pnt.x;
-  y = tp->glyphs->pnt.y;
-  
-  box.move_to((x)/r->utfresolution,(y)/r->utfresolution);
-  box.line_to((x+size)/r->utfresolution,(y)/r->utfresolution);
-  box.line_to((x+size)/r->utfresolution,(y-size)/r->utfresolution);
-  box.line_to((x)/r->utfresolution,(y-size)/r->utfresolution);
-
-     /* Rotation if necessary. */
-  if( tp->glyphs->rot != 0) {
-    mapserver::trans_affine mtx;
-    mtx *= mapserver::trans_affine_translation(-x/r->utfresolution,-y/r->utfresolution);
-    mtx *= mapserver::trans_affine_rotation(-tp->glyphs->rot);
-    mtx *= mapserver::trans_affine_translation(x/r->utfresolution,y/r->utfresolution);
-    box.transform(mtx);
-  } 
-
-
-  /* Rendering the symbol */
-  utfgridRenderPath(img, box);
-
-  return MS_SUCCESS;
-}
-
-static
-int utfgridFreeSymbol(symbolObj *)
-{
-  return MS_SUCCESS;
-}
-
-/*
- * Add the necessary functions for UTFGrid to the renderer VTable.
- */
-int msPopulateRendererVTableUTFGrid( rendererVTableObj *renderer )
-{
-  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
-
-  renderer->createImage = &utfgridCreateImage;
-  renderer->freeImage = &utfgridFreeImage;
-  renderer->saveImage = &utfgridSaveImage;
-
-  renderer->startLayer = &utfgridStartLayer;
-  renderer->endLayer = &utfgridEndLayer;
-
-  renderer->startShape = &utfgridStartShape;
-  renderer->endShape = &utfgridEndShape;
-
-  renderer->renderPolygon = &utfgridRenderPolygon;
-  renderer->renderGlyphs = &utfgridRenderGlyphs;
-  renderer->renderLine = &utfgridRenderLine;
-  renderer->renderVectorSymbol = &utfgridRenderVectorSymbol;
-  renderer->renderPixmapSymbol = &utfgridRenderPixmapSymbol;
-  renderer->renderEllipseSymbol = &utfgridRenderEllipseSymbol;
-
-  renderer->freeSymbol = &utfgridFreeSymbol;
-
-  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/maputfgrid.h 8.2.0~beta1-1~exp1/maputfgrid.h
--- 8.0.1-5/maputfgrid.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maputfgrid.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,250 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  UTFGrid rendering functions (using AGG)
- * Author:   Francois Desjarlais
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "renderers/agg/include/agg_renderer_base.h"
-#include "renderers/agg/include/agg_rendering_buffer.h"
-
-/*
- * Using AGG templates to create UTFGrid pixel.
- */
-
-//==================================================================utfpix32
-struct utfpix32
-{
-  typedef mapserver::int32u value_type;
-  typedef mapserver::int64u calc_type;
-  typedef mapserver::int64  long_type;
-
-  typedef utfpix32 self_type;
-
-  value_type v;
-
-  //--------------------------------------------------------------------
-  utfpix32(): v(0) {}
-
-  //--------------------------------------------------------------------
-  explicit utfpix32(unsigned v_) :
-    v(mapserver::int32u(v_)) {}
-
-  //--------------------------------------------------------------------
-  utfpix32(const self_type& c) :
-    v(c.v) {}
-
-  //--------------------------------------------------------------------
-  utfpix32& operator= (const self_type&) = default;
-
-  //--------------------------------------------------------------------
-  void clear()
-  {
-    v = 0;
-  }
-
-  //--------------------------------------------------------------------
-  AGG_INLINE void add(const self_type& c, unsigned /*cover*/)
-  {
-    *this = c;
-  }
-};
-
-//=================================================pixfmt_utf
-template<class ColorT, class RenBuf, unsigned Step=1, unsigned Offset=0>
-class pixfmt_utf
-{
-public:
-  typedef RenBuf   rbuf_type;
-  typedef typename rbuf_type::row_data row_data;
-  typedef ColorT                            color_type;
-  typedef typename color_type::value_type   value_type;
-  typedef typename color_type::calc_type    calc_type;
-  enum base_scale_e
-  {
-    pix_width  = sizeof(value_type),
-    pix_step   = Step,
-    pix_offset = Offset
-  };
-
-private:
-  //--------------------------------------------------------------------
-  static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                           const color_type& c, 
-                                           unsigned cover)
-  {
-      *p = c.v;
-  }
-
-  static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                           const color_type& c)
-  {
-      *p = c.v;
-  }
-
-public:
-  pixfmt_utf() : m_rbuf(0) {}
-  //--------------------------------------------------------------------
-  explicit pixfmt_utf(rbuf_type& rb) :
-    m_rbuf(&rb)
-  {}
-  void attach(rbuf_type& rb) { m_rbuf = &rb; }
-  //--------------------------------------------------------------------
-
-  template<class PixFmt>
-  bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
-  {
-    mapserver::rect_i r(x1, y1, x2, y2);
-    if(r.clip(mapserver::rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
-    {
-      int stride = pixf.stride();
-      m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
-                     (r.x2 - r.x1) + 1,
-                     (r.y2 - r.y1) + 1, 
-                     stride);
-      return true;
-    }
-    return false;
-  }
-
-  //--------------------------------------------------------------------
-  AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
-  AGG_INLINE unsigned height() const { return m_rbuf->height(); }
-  AGG_INLINE int      stride() const { return m_rbuf->stride(); }
-
-  //--------------------------------------------------------------------
-        mapserver::int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
-  const mapserver::int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
-  row_data                row(int y)     const { return m_rbuf->row(y); }
-
-  const mapserver::int8u* pix_ptr(int x, int y) const
-  {
-    return m_rbuf->row_ptr(y) + x * Step + Offset+1213;
-  }
-
-  mapserver::int8u* pix_ptr(int x, int y)
-  {
-    return m_rbuf->row_ptr(y) + x * Step + Offset +1213;
-  }
-
-  //--------------------------------------------------------------------
-  AGG_INLINE static void make_pix(mapserver::int8u* p, const color_type& c)
-  {
-    *(value_type*)p = c.v;
-  }
-
-  //--------------------------------------------------------------------
-  AGG_INLINE color_type pixel(int x, int y) const
-  {
-    value_type* p = (value_type*)m_rbuf->row_ptr(y) + x * Step + Offset;
-    return color_type(*p);
-  }
-
-  //--------------------------------------------------------------------
-  AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
-  {
-    *((value_type*)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset) = c.v;
-  }
-
-  //--------------------------------------------------------------------
-  AGG_INLINE void blend_pixel(int x, int y, const color_type& c, mapserver::int8u cover)
-  {
-    copy_or_blend_pix((value_type*)
-                       m_rbuf->row_ptr(x, y, 1) + x * Step + Offset, 
-                       c);
-  }
-
-
-  //--------------------------------------------------------------------
-  AGG_INLINE void copy_hline(int x, int y, 
-                             unsigned len, 
-                             const color_type& c)
-  {
-    value_type* p = (value_type*)
-        m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
-
-    do
-    {
-      *p = c.v;
-      p += Step;
-    }
-    while(--len);
-  }
-
-
-  //--------------------------------------------------------------------
-  AGG_INLINE void copy_vline(int x, int y, 
-                             unsigned len, 
-                             const color_type& c)
-  {
-    do
-    {
-      value_type* p = (value_type*) 
-          m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-      *p = c.v;
-    }
-    while(--len);
-  }
-
-
-  //--------------------------------------------------------------------
-  void blend_hline(int x, int y, 
-                   unsigned len, 
-                   const color_type& c, 
-                   mapserver::int8u /*cover*/)
-  {
-    value_type* p = (value_type*) 
-        m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
-
-    do
-    {
-      *p = c.v;
-      p += Step;
-    }
-    while(--len);
-  }
-
-
-  //--------------------------------------------------------------------
-  void blend_vline(int x, int y, 
-                   unsigned len, 
-                   const color_type& c, 
-                   mapserver::int8u cover)
-  {
-    do
-    {
-      value_type* p = (value_type*) 
-          m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-      *p = c.v;
-    }
-    while(--len);
-  }
-
-
-private:
-  rbuf_type* m_rbuf;
-};
diff -pruN 8.0.1-5/maputil.c 8.2.0~beta1-1~exp1/maputil.c
--- 8.0.1-5/maputil.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/maputil.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,2743 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Various utility functions ... a real hodgepodge.
- * Author:   Steve Lime and the MapServer team.
- *
- * Notes: Some code (notably msAlphaBlend()) are directly derived from GD. See
- * the mapserver/GD-COPYING file for the GD license.  Use of this code in this
- * manner is compatible with the MapServer license.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <time.h>
-
-#include "mapserver.h"
-#include "maptime.h"
-#include "mapthread.h"
-#include "mapcopy.h"
-#include "mapows.h"
-
-#include "gdal.h"
-#include "cpl_conv.h"
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-# include <windows.h>
-# include <tchar.h>
-# include <fcntl.h>
-# include <io.h>
-#include <process.h>
-#endif
-
-#ifdef USE_RSVG
-#include <glib-object.h>
-#endif
-#ifdef USE_GEOS
-#include <geos_c.h>
-#endif
-
-
-extern char *msyystring_buffer;
-extern int msyylex_destroy(void);
-extern int yyparse(parseObj *);
-
-int msScaleInBounds(double scale, double minscale, double maxscale)
-{
-  if(scale > 0) {
-    if(maxscale != -1 && scale >= maxscale) return MS_FALSE;
-    if(minscale != -1 && scale < minscale) return MS_FALSE;
-  }
-  return MS_TRUE;
-}
-
-/*
-** Helper functions to convert from strings to other types or objects.
-*/
-static int bindIntegerAttribute(int *attribute, const char *value)
-{
-  if(!value || strlen(value) == 0) return MS_FAILURE;
-  *attribute = MS_NINT(atof(value)); /*use atof instead of atoi as a fix for bug 2394*/
-  return MS_SUCCESS;
-}
-
-static int bindDoubleAttribute(double *attribute, const char *value)
-{
-  if(!value || strlen(value) == 0) return MS_FAILURE;
-  *attribute = atof(value);
-  return MS_SUCCESS;
-}
-
-static int bindColorAttribute(colorObj *attribute, const char *value)
-{
-  int len;
-
-  if(!value || ((len = strlen(value)) == 0)) return MS_FAILURE;
-
-  if(value[0] == '#' && (len == 7 || len == 9)) { /* got a hex color */
-    char hex[2];
-
-    hex[0] = value[1];
-    hex[1] = value[2];
-    attribute->red = msHexToInt(hex);
-    hex[0] = value[3];
-    hex[1] = value[4];
-    attribute->green = msHexToInt(hex);
-    hex[0] = value[5];
-    hex[1] = value[6];
-    attribute->blue = msHexToInt(hex);
-    if(len == 9) {
-      hex[0] = value[7];
-      hex[1] = value[8];
-      attribute->alpha = msHexToInt(hex);
-    }
-    return MS_SUCCESS;
-  } else { /* try a space delimited string */
-    char **tokens=NULL;
-    int numtokens=0;
-
-    tokens = msStringSplit(value, ' ', &numtokens);
-    if(tokens==NULL || numtokens != 3) {
-      msFreeCharArray(tokens, numtokens);
-      return MS_FAILURE; /* punt */
-    }
-
-    attribute->red = atoi(tokens[0]);
-    attribute->green = atoi(tokens[1]);
-    attribute->blue = atoi(tokens[2]);
-    msFreeCharArray(tokens, numtokens);
-
-    return MS_SUCCESS;
-  }
-
-  return MS_FAILURE; /* shouldn't get here */
-}
-
-static void bindStyle(layerObj *layer, shapeObj *shape, styleObj *style, int drawmode)
-{
-  int applyOpacity = MS_FALSE;
-  assert(MS_DRAW_FEATURES(drawmode));
-  if(style->numbindings > 0) {
-    applyOpacity = MS_TRUE;
-    if(style->bindings[MS_STYLE_BINDING_SYMBOL].index != -1) {
-      style->symbol = msGetSymbolIndex(&(layer->map->symbolset), shape->values[style->bindings[MS_STYLE_BINDING_SYMBOL].index], MS_TRUE);
-      if(style->symbol == -1) style->symbol = 0; /* a reasonable default (perhaps should throw an error?) */
-    }
-    if(style->bindings[MS_STYLE_BINDING_ANGLE].index != -1) {
-      style->angle = 360.0;
-      bindDoubleAttribute(&style->angle, shape->values[style->bindings[MS_STYLE_BINDING_ANGLE].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_SIZE].index != -1) {
-      style->size = 1;
-      bindDoubleAttribute(&style->size, shape->values[style->bindings[MS_STYLE_BINDING_SIZE].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_WIDTH].index != -1) {
-      style->width = 1;
-      bindDoubleAttribute(&style->width, shape->values[style->bindings[MS_STYLE_BINDING_WIDTH].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_COLOR].index != -1 && !MS_DRAW_QUERY(drawmode)) {
-      MS_INIT_COLOR(style->color, -1,-1,-1,255);
-      bindColorAttribute(&style->color, shape->values[style->bindings[MS_STYLE_BINDING_COLOR].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index != -1 && !MS_DRAW_QUERY(drawmode)) {
-      MS_INIT_COLOR(style->outlinecolor, -1,-1,-1,255);
-      bindColorAttribute(&style->outlinecolor, shape->values[style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index != -1) {
-      style->outlinewidth = 1;
-      bindDoubleAttribute(&style->outlinewidth, shape->values[style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_OPACITY].index != -1) {
-      style->opacity = 100;
-      bindIntegerAttribute(&style->opacity, shape->values[style->bindings[MS_STYLE_BINDING_OPACITY].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_OFFSET_X].index != -1) {
-      style->offsetx = 0;
-      bindDoubleAttribute(&style->offsetx, shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_X].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_OFFSET_Y].index != -1) {
-      style->offsety = 0;
-      bindDoubleAttribute(&style->offsety, shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_Y].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].index != -1) {
-      style->polaroffsetpixel = 0;
-      bindDoubleAttribute(&style->polaroffsetpixel, shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].index != -1) {
-      style->polaroffsetangle = 0;
-      bindDoubleAttribute(&style->polaroffsetangle, shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].index]);
-    }
-  }
-  if (style->nexprbindings > 0)
-  {
-    applyOpacity = MS_TRUE;
-    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_X].type == MS_EXPRESSION)
-    {
-      style->offsetx = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_X]),
-          shape);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_Y].type == MS_EXPRESSION)
-    {
-      style->offsety = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_Y]),
-          shape);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_ANGLE].type == MS_EXPRESSION)
-    {
-      style->angle = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_ANGLE]),
-          shape);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_SIZE].type == MS_EXPRESSION)
-    {
-      style->size = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_SIZE]),
-          shape);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_WIDTH].type == MS_EXPRESSION)
-    {
-      style->width = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_WIDTH]),
-          shape);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_OPACITY].type == MS_EXPRESSION)
-    {
-      style->opacity = 100 * msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_OPACITY]),
-          shape);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR]), shape);
-      bindColorAttribute(&style->outlinecolor, txt);
-      msFree(txt);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_COLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(style->exprBindings[MS_STYLE_BINDING_COLOR]), shape);
-      bindColorAttribute(&style->color, txt);
-      msFree(txt);
-    }
-  }
-
-  if(applyOpacity == MS_TRUE && (style->opacity < 100 || style->color.alpha != 255) ) {
-    int alpha;
-    alpha = MS_NINT(style->opacity*2.55);
-    style->color.alpha = alpha;
-    style->outlinecolor.alpha = alpha;
-    style->mincolor.alpha = alpha;
-    style->maxcolor.alpha = alpha;
-  }
-}
-
-static void bindLabel(layerObj *layer, shapeObj *shape, labelObj *label, int drawmode)
-{
-  int i;
-  assert(MS_DRAW_LABELS(drawmode));
-
-  /* check the label styleObj's (TODO: do we need to use querymapMode here? */
-  for(i=0; i<label->numstyles; i++) {
-    /* force MS_DRAWMODE_FEATURES for label styles */
-    bindStyle(layer, shape, label->styles[i], drawmode|MS_DRAWMODE_FEATURES);
-  }
-
-  if(label->numbindings > 0) {
-    if(label->bindings[MS_LABEL_BINDING_ANGLE].index != -1) {
-      label->angle = 0.0;
-      bindDoubleAttribute(&label->angle, shape->values[label->bindings[MS_LABEL_BINDING_ANGLE].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_SIZE].index != -1) {
-      label->size = 1;
-      bindIntegerAttribute(&label->size, shape->values[label->bindings[MS_LABEL_BINDING_SIZE].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_COLOR].index != -1) {
-      MS_INIT_COLOR(label->color, -1,-1,-1,255);
-      bindColorAttribute(&label->color, shape->values[label->bindings[MS_LABEL_BINDING_COLOR].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index != -1) {
-      MS_INIT_COLOR(label->outlinecolor, -1,-1,-1,255);
-      bindColorAttribute(&label->outlinecolor, shape->values[label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_FONT].index != -1) {
-      msFree(label->font);
-      label->font = msStrdup(shape->values[label->bindings[MS_LABEL_BINDING_FONT].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_PRIORITY].index != -1) {
-      label->priority = MS_DEFAULT_LABEL_PRIORITY;
-      bindIntegerAttribute(&label->priority, shape->values[label->bindings[MS_LABEL_BINDING_PRIORITY].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index != -1) {
-      label->shadowsizex = 1;
-      bindIntegerAttribute(&label->shadowsizex, shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index]);
-    }
-    if(label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index != -1) {
-      label->shadowsizey = 1;
-      bindIntegerAttribute(&label->shadowsizey, shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_OFFSET_X].index != -1) {
-      label->offsetx = 0;
-      bindIntegerAttribute(&label->offsetx, shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_X].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_OFFSET_Y].index != -1) {
-      label->offsety = 0;
-      bindIntegerAttribute(&label->offsety, shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_Y].index]);
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_ALIGN].index != -1) {
-      int tmpAlign = 0;
-      bindIntegerAttribute(&tmpAlign, shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]);
-      if(tmpAlign != 0) { /* is this test sufficient? */
-        label->align = tmpAlign;
-      } else { /* Integer binding failed, look for strings like cc, ul, lr, etc... */
-        if(strlen(shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]) >= 4) {
-          char *va = shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index];
-          if(!strncasecmp(va,"center",5))
-            label->align = MS_ALIGN_CENTER;
-          else if(!strncasecmp(va,"left",4))
-            label->align = MS_ALIGN_LEFT;
-          else if(!strncasecmp(va,"right",5))
-            label->align = MS_ALIGN_RIGHT;
-        }
-      }
-    }
-
-    if(label->bindings[MS_LABEL_BINDING_POSITION].index != -1) {
-      int tmpPosition = 0;
-      bindIntegerAttribute(&tmpPosition, shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index]);
-      if(tmpPosition != 0) { /* is this test sufficient? */
-        label->position = tmpPosition;
-      } else { /* Integer binding failed, look for strings like cc, ul, lr, etc... */
-        if(strlen(shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index]) == 2) {
-          char *vp = shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index];
-          if(!strncasecmp(vp,"ul",2))
-            label->position = MS_UL;
-          else if(!strncasecmp(vp,"lr",2))
-            label->position = MS_LR;
-          else if(!strncasecmp(vp,"ur",2))
-            label->position = MS_UR;
-          else if(!strncasecmp(vp,"ll",2))
-            label->position = MS_LL;
-          else if(!strncasecmp(vp,"cr",2))
-            label->position = MS_CR;
-          else if(!strncasecmp(vp,"cl",2))
-            label->position = MS_CL;
-          else if(!strncasecmp(vp,"uc",2))
-            label->position = MS_UC;
-          else if(!strncasecmp(vp,"lc",2))
-            label->position = MS_LC;
-          else if(!strncasecmp(vp,"cc",2))
-            label->position = MS_CC;
-        }
-      }
-    }
-  }
-  if (label->nexprbindings > 0)
-  {
-    if (label->exprBindings[MS_LABEL_BINDING_ANGLE].type == MS_EXPRESSION)
-    {
-      label->angle = msEvalDoubleExpression(
-          &(label->exprBindings[MS_LABEL_BINDING_ANGLE]),
-          shape);
-    }
-    if (label->exprBindings[MS_LABEL_BINDING_SIZE].type == MS_EXPRESSION)
-    {
-      label->size = msEvalDoubleExpression(
-          &(label->exprBindings[MS_LABEL_BINDING_SIZE]),
-          shape);
-    }
-    if (label->exprBindings[MS_LABEL_BINDING_COLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(label->exprBindings[MS_LABEL_BINDING_COLOR]), shape);
-      bindColorAttribute(&label->color, txt);
-      msFree(txt);
-    }
-    if (label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR]), shape);
-      bindColorAttribute(&label->outlinecolor, txt);
-      msFree(txt);
-    }
-  }
-}
-
-/*
-** Function to bind various layer properties to shape attributes.
-*/
-int msBindLayerToShape(layerObj *layer, shapeObj *shape, int drawmode)
-{
-  int i, j;
-
-  if(!layer || !shape) return MS_FAILURE;
-
-  for(i=0; i<layer->numclasses; i++) {
-    /* check the styleObj's */
-    if(MS_DRAW_FEATURES(drawmode)) {
-      for(j=0; j<layer->class[i]->numstyles; j++) {
-        bindStyle(layer, shape, layer->class[i]->styles[j], drawmode);
-      }
-    }
-
-    /* check the labelObj's */
-    if(MS_DRAW_LABELS(drawmode)) {
-      for(j=0; j<layer->class[i]->numlabels; j++) {
-        bindLabel(layer, shape, layer->class[i]->labels[j], drawmode);
-      }
-    }
-  } /* next classObj */
-
-  return MS_SUCCESS;
-}
-
-/*
- * Used to get red, green, blue integers separately based upon the color index
- */
-int getRgbColor(mapObj *map,int i,int *r,int *g,int *b)
-{
-  /* check index range */
-  int status=1;
-  *r=*g=*b=-1;
-  if ((i > 0 ) && (i <= map->palette.numcolors) ) {
-    *r=map->palette.colors[i-1].red;
-    *g=map->palette.colors[i-1].green;
-    *b=map->palette.colors[i-1].blue;
-    status=0;
-  }
-  return status;
-}
-
-static int searchContextForTag(mapObj *map, char **ltags, char *tag, char *context, int requires)
-{
-  int i;
-
-  if(!context) return MS_FAILURE;
-
-  /*  printf("\tin searchContextForTag, searching %s for %s\n", context, tag); */
-
-  if(strstr(context, tag) != NULL) return MS_SUCCESS; /* found the tag */
-
-  /* check referenced layers for the tag too */
-  for(i=0; i<map->numlayers; i++) {
-    if(strstr(context, ltags[i]) != NULL) { /* need to check this layer */
-      if(requires == MS_TRUE) {
-        if(searchContextForTag(map, ltags, tag, GET_LAYER(map, i)->requires, MS_TRUE) == MS_SUCCESS) return MS_SUCCESS;
-      } else {
-        if(searchContextForTag(map, ltags, tag, GET_LAYER(map, i)->labelrequires, MS_FALSE) == MS_SUCCESS) return MS_SUCCESS;
-      }
-    }
-  }
-
-  return MS_FAILURE;
-}
-
-/*
-** Function to take a look at all layers with REQUIRES/LABELREQUIRES set to make sure there are no
-** recursive context requirements set (e.g. layer1 requires layer2 and layer2 requires layer1). This
-** is bug 1059.
-*/
-int msValidateContexts(mapObj *map)
-{
-  int i;
-  char **ltags;
-  int status = MS_SUCCESS;
-
-  ltags = (char **) msSmallMalloc(map->numlayers*sizeof(char *));
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->name == NULL) {
-      ltags[i] = msStrdup("[NULL]");
-    } else {
-      ltags[i] = (char *) msSmallMalloc(sizeof(char)*strlen(GET_LAYER(map, i)->name) + 3);
-      sprintf(ltags[i], "[%s]", GET_LAYER(map, i)->name);
-    }
-  }
-
-  /* check each layer's REQUIRES and LABELREQUIRES parameters */
-  for(i=0; i<map->numlayers; i++) {
-    /* printf("working on layer %s, looking for references to %s\n", GET_LAYER(map, i)->name, ltags[i]); */
-    if(searchContextForTag(map, ltags, ltags[i], GET_LAYER(map, i)->requires, MS_TRUE) == MS_SUCCESS) {
-      msSetError(MS_PARSEERR, "Recursion error found for REQUIRES parameter for layer %s.", "msValidateContexts", GET_LAYER(map, i)->name);
-      status = MS_FAILURE;
-      break;
-    }
-    if(searchContextForTag(map, ltags, ltags[i], GET_LAYER(map, i)->labelrequires, MS_FALSE) == MS_SUCCESS) {
-      msSetError(MS_PARSEERR, "Recursion error found for LABELREQUIRES parameter for layer %s.", "msValidateContexts", GET_LAYER(map, i)->name);
-      status = MS_FAILURE;
-      break;
-    }
-    /* printf("done layer %s\n", GET_LAYER(map, i)->name); */
-  }
-
-  /* clean up */
-  msFreeCharArray(ltags, map->numlayers);
-
-  return status;
-}
-
-int msEvalContext(mapObj *map, layerObj *layer, char *context)
-{
-  int i, status;
-  char *tag=NULL;
-
-  expressionObj e;
-  parseObj p;
-
-  if(!context) return(MS_TRUE);
-
-  /* initialize a temporary expression (e) */
-  msInitExpression(&e);
-
-  e.string = msStrdup(context);
-  e.type = MS_EXPRESSION; /* todo */
-
-  for(i=0; i<map->numlayers; i++) { /* step through all the layers */
-    if(layer->index == i) continue; /* skip the layer in question */
-    if (GET_LAYER(map, i)->name == NULL) continue; /* Layer without name cannot be used in contexts */
-
-    tag = (char *)msSmallMalloc(sizeof(char)*strlen(GET_LAYER(map, i)->name) + 3);
-    sprintf(tag, "[%s]", GET_LAYER(map, i)->name);
-
-    if(strstr(e.string, tag)) {
-      if(msLayerIsVisible(map, (GET_LAYER(map, i))))
-        e.string = msReplaceSubstring(e.string, tag, "1");
-      else
-        e.string = msReplaceSubstring(e.string, tag, "0");
-    }
-
-    free(tag);
-  }
-
-  msTokenizeExpression(&e, NULL, NULL);
-
-  p.shape = NULL;
-  p.expr = &e;
-  p.expr->curtoken = p.expr->tokens; /* reset */
-  p.type = MS_PARSE_TYPE_BOOLEAN;
-
-  status = yyparse(&p);
-
-  msFreeExpression(&e);
-
-  if (status != 0) {
-    msSetError(MS_PARSEERR, "Failed to parse context", "msEvalContext");
-    return MS_FALSE; /* error in parse */
-  }
-
-  return p.result.intval;
-}
-
-/* msEvalExpression()
- *
- * Evaluates a mapserver expression for a given set of attribute values and
- * returns the result of the expression (MS_TRUE or MS_FALSE)
- * May also return MS_FALSE in case of parsing errors or invalid expressions
- * (check the error stack if you care)
- *
- */
-int msEvalExpression(layerObj *layer, shapeObj *shape, expressionObj *expression, int itemindex)
-{
-  if(MS_STRING_IS_NULL_OR_EMPTY(expression->string)) return MS_TRUE; /* NULL or empty expressions are ALWAYS true */
-  if(expression->native_string != NULL) return MS_TRUE; /* expressions that are evaluated natively are ALWAYS true */
-
-  switch(expression->type) {
-    case(MS_STRING):
-      if(itemindex == -1) {
-        msSetError(MS_MISCERR, "Cannot evaluate expression, no item index defined.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      if(itemindex >= layer->numitems || itemindex >= shape->numvalues) {
-        msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      if(expression->flags & MS_EXP_INSENSITIVE) {
-        if(strcasecmp(expression->string, shape->values[itemindex]) == 0) return MS_TRUE; /* got a match */
-      } else {
-        if(strcmp(expression->string, shape->values[itemindex]) == 0) return MS_TRUE; /* got a match */
-      }
-      break;
-    case(MS_LIST):
-      if(itemindex == -1) {
-        msSetError(MS_MISCERR, "Cannot evaluate expression, no item index defined.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      if(itemindex >= layer->numitems || itemindex >= shape->numvalues) {
-        msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      {
-        char *start,*end;
-        int value_len = strlen(shape->values[itemindex]);
-        start = expression->string;
-        while((end = strchr(start,',')) != NULL) {
-          if(value_len == end-start && !strncmp(start,shape->values[itemindex],end-start)) return MS_TRUE;
-          start = end+1;
-        }
-        if(!strcmp(start,shape->values[itemindex])) return MS_TRUE;
-      }
-      break;
-    case(MS_EXPRESSION): {
-      int status;
-      parseObj p;
-
-      p.shape = shape;
-      p.expr = expression;
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_BOOLEAN;
-
-      status = yyparse(&p);
-
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to parse expression: %s", "msEvalExpression", expression->string);
-        return MS_FALSE;
-      }
-
-      return p.result.intval;
-
-    }
-    case(MS_REGEX):
-      if(itemindex == -1) {
-        msSetError(MS_MISCERR, "Cannot evaluate expression, no item index defined.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      if(itemindex >= layer->numitems || itemindex >= shape->numvalues) {
-        msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-
-      if(MS_STRING_IS_NULL_OR_EMPTY(shape->values[itemindex]) == MS_TRUE) return MS_FALSE;
-
-      if(!expression->compiled) {
-        if(expression->flags & MS_EXP_INSENSITIVE) {
-          if(ms_regcomp(&(expression->regex), expression->string, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) { /* compile the expression */
-            msSetError(MS_REGEXERR, "Invalid regular expression.", "msEvalExpression()");
-            return MS_FALSE;
-          }
-        } else {
-          if(ms_regcomp(&(expression->regex), expression->string, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) { /* compile the expression */
-            msSetError(MS_REGEXERR, "Invalid regular expression.", "msEvalExpression()");
-            return MS_FALSE;
-          }
-        }
-        expression->compiled = MS_TRUE;
-      }
-
-      if(ms_regexec(&(expression->regex), shape->values[itemindex], 0, NULL, 0) == 0) return MS_TRUE; /* got a match */
-      break;
-  }
-
-  return MS_FALSE;
-}
-
-int *msAllocateValidClassGroups(layerObj *lp, int *nclasses)
-{
-  int *classgroup = NULL;
-  int nvalidclass = 0, i=0;
-
-  if (!lp || !lp->classgroup || lp->numclasses <=0 || !nclasses)
-    return NULL;
-
-  classgroup = (int *)msSmallMalloc(sizeof(int)*lp->numclasses);
-  nvalidclass = 0;
-  for (i=0; i<lp->numclasses; i++) {
-    if (lp->class[i]->group && strcasecmp(lp->class[i]->group, lp->classgroup) == 0) {
-      classgroup[nvalidclass] = i;
-      nvalidclass++;
-    }
-  }
-  if (nvalidclass > 0) {
-    classgroup = (int *)msSmallRealloc(classgroup, sizeof(int)*nvalidclass);
-    *nclasses = nvalidclass;
-    return classgroup;
-  }
-
-  if (classgroup)
-    msFree(classgroup);
-
-  return NULL;
-
-}
-
-int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape, int *classgroup, int numclasses)
-{
-  return msShapeGetNextClass(-1, layer, map, shape, classgroup, numclasses);
-}
-
-int msShapeGetNextClass(int currentclass, layerObj *layer, mapObj *map,
-    shapeObj *shape, int *classgroup, int numclasses)
-{
-  int i, iclass;
-
-  if (currentclass < 0)
-    currentclass = -1;
-
-  if (layer->numclasses > 0) {
-    if (classgroup == NULL || numclasses <=0)
-      numclasses = layer->numclasses;
-
-    for(i=currentclass+1; i<numclasses; i++) {
-      if (classgroup)
-        iclass = classgroup[i];
-      else
-        iclass = i;
-
-      if (iclass < 0 || iclass >= layer->numclasses)
-        continue; /* this should never happen but just in case */
-
-      if(map->scaledenom > 0) { /* verify scaledenom here  */
-        if((layer->class[iclass]->maxscaledenom > 0) && (map->scaledenom > layer->class[iclass]->maxscaledenom))
-          continue; /* can skip this one, next class */
-        if((layer->class[iclass]->minscaledenom > 0) && (map->scaledenom <= layer->class[iclass]->minscaledenom))
-          continue; /* can skip this one, next class */
-      }
-
-      /* verify the minfeaturesize */
-      if ((shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) && (layer->class[iclass]->minfeaturesize > 0)) {
-        double minfeaturesize = Pix2LayerGeoref(map, layer,
-                                                layer->class[iclass]->minfeaturesize);
-        if (msShapeCheckSize(shape, minfeaturesize) == MS_FALSE)
-          continue; /* skip this one, next class */
-      }
-
-      if(layer->class[iclass]->status != MS_DELETE && msEvalExpression(layer, shape, &(layer->class[iclass]->expression), layer->classitemindex) == MS_TRUE)
-      {
-        if (layer->class[iclass]->isfallback && currentclass != -1)
-        {
-          // Class is not applicable if it is flagged as fallback (<ElseFilter/> tag in SLD)
-          // but other classes have been applied before.
-          return -1;
-        }
-        else
-        {
-          return(iclass);
-        }
-      }
-    }
-  }
-
-  return(-1); /* no match */
-}
-
-static
-char *msEvalTextExpressionInternal(expressionObj *expr, shapeObj *shape, int bJSonEscape)
-{
-  char *result=NULL;
-
-  if(!expr->string) return result; /* nothing to do */
-
-  switch(expr->type) {
-    case(MS_STRING): {
-      char *target=NULL;
-      char *pszEscaped;
-      tokenListNodeObjPtr node=NULL;
-      tokenListNodeObjPtr nextNode=NULL;
-
-      result = msStrdup(expr->string);
-
-      node = expr->tokens;
-      if(node) {
-        while(node != NULL) {
-          nextNode = node->next;
-          if(node->token == MS_TOKEN_BINDING_DOUBLE || node->token == MS_TOKEN_BINDING_INTEGER || node->token == MS_TOKEN_BINDING_STRING || node->token == MS_TOKEN_BINDING_TIME) {
-            target = (char *) msSmallMalloc(strlen(node->tokenval.bindval.item) + 3);
-            sprintf(target, "[%s]", node->tokenval.bindval.item);
-            if( bJSonEscape )
-                pszEscaped = msEscapeJSonString(shape->values[node->tokenval.bindval.index]);
-            else
-                pszEscaped = msStrdup(shape->values[node->tokenval.bindval.index]);
-            result = msReplaceSubstring(result, target, pszEscaped);
-            msFree(pszEscaped);
-            msFree(target);
-          }
-          node = nextNode;
-        }
-      }
-      if(!strlen(result)) {
-        msFree(result);
-        result = NULL;
-      }
-    }
-    break;
-    case(MS_EXPRESSION): {
-      int status;
-      parseObj p;
-
-      p.shape = shape;
-      p.expr = expr;
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_STRING;
-
-      status = yyparse(&p);
-
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to process text expression: %s", "msEvalTextExpression", expr->string);
-        return NULL;
-      }
-
-      result = p.result.strval;
-      break;
-    }
-    default:
-      break;
-  }
-  if(result && !strlen(result)) {
-    msFree(result);
-    result = NULL;
-  }
-  return result;
-}
-
-char *msEvalTextExpressionJSonEscape(expressionObj *expr, shapeObj *shape)
-{
-    return msEvalTextExpressionInternal(expr, shape, MS_TRUE);
-}
-
-char *msEvalTextExpression(expressionObj *expr, shapeObj *shape)
-{
-    return msEvalTextExpressionInternal(expr, shape, MS_FALSE);
-}
-
-double msEvalDoubleExpression(expressionObj *expression, shapeObj *shape)
-{
-  double value;
-  int status;
-  parseObj p;
-  p.shape = shape;
-  p.expr = expression;
-  p.expr->curtoken = p.expr->tokens; /* reset */
-  p.type = MS_PARSE_TYPE_STRING;
-  status = yyparse(&p);
-  if (status != 0) {
-    msSetError(MS_PARSEERR, "Failed to parse expression: %s",
-        "bindStyle", expression->string);
-    value = 0.0;
-  } else {
-    value = atof(p.result.strval);
-    msFree(p.result.strval);
-  }
-  return value;
-}
-
-char* msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape, labelObj *lbl) {
-  assert(shape && lbl);
-  if(lbl->text.string) {
-    return msEvalTextExpression(&(lbl->text), shape);
-  } else if(layer->class[shape->classindex]->text.string) {
-    return msEvalTextExpression(&(layer->class[shape->classindex]->text), shape);
-  } else {
-    if (shape->values && layer->labelitemindex >= 0 && shape->values[layer->labelitemindex] && strlen(shape->values[layer->labelitemindex]) )
-      return msStrdup(shape->values[layer->labelitemindex]);
-    else if(shape->text)
-      return msStrdup(shape->text); /* last resort but common with iniline features */
-  }
-  return NULL;
-}
-
-int msGetLabelStatus(mapObj *map, layerObj *layer, shapeObj *shape, labelObj *lbl) {
-  assert(layer && lbl);
-  if(!msScaleInBounds(map->scaledenom,lbl->minscaledenom,lbl->maxscaledenom))
-    return MS_OFF;
-  if(msEvalExpression(layer, shape, &(lbl->expression), layer->labelitemindex) != MS_TRUE)
-    return MS_OFF;
-  /* TODO: check for minfeaturesize here ? */
-  return MS_ON;
-}
-
-/* Check if the shape is enough big to be drawn with the
-   layer::minfeaturesize setting. The minfeaturesize parameter should be
-   the value in geo ref (not in pixel) and should have been multiplied by
-   the resolution factor.
- */
-int msShapeCheckSize(shapeObj *shape, double minfeaturesize)
-{
-  double dx = (shape->bounds.maxx-shape->bounds.minx);
-  double dy = (shape->bounds.maxy-shape->bounds.miny);
-
-  if (pow(minfeaturesize,2.0) > (pow(dx,2.0)+pow(dy,2.0)))
-    return MS_FALSE;
-
-  return MS_TRUE;
-}
-
-/*
-** Adjusts an image size in one direction to fit an extent.
-*/
-int msAdjustImage(rectObj rect, int *width, int *height)
-{
-  if(*width == -1 && *height == -1) {
-    msSetError(MS_MISCERR, "Cannot calculate both image height and width.", "msAdjustImage()");
-    return(-1);
-  }
-
-  if(*width > 0)
-    *height = MS_NINT((rect.maxy - rect.miny)/((rect.maxx - rect.minx)/(*width)));
-  else
-    *width = MS_NINT((rect.maxx - rect.minx)/((rect.maxy - rect.miny)/(*height)));
-
-  return(0);
-}
-
-/*
-** Make sure extent fits image window to be created. Returns cellsize of output image.
-*/
-double msAdjustExtent(rectObj *rect, int width, int height)
-{
-  double cellsize, ox, oy;
-
-  if(width == 1 || height == 1)
-    return 0;
-
-  cellsize = MS_MAX(MS_CELLSIZE(rect->minx, rect->maxx, width), MS_CELLSIZE(rect->miny, rect->maxy, height));
-
-  if(cellsize <= 0) /* avoid division by zero errors */
-    return(0);
-
-  ox = MS_MAX(((width-1) - (rect->maxx - rect->minx)/cellsize)/2,0); /* these were width-1 and height-1 */
-  oy = MS_MAX(((height-1) - (rect->maxy - rect->miny)/cellsize)/2,0);
-
-  rect->minx = rect->minx - ox*cellsize;
-  rect->miny = rect->miny - oy*cellsize;
-  rect->maxx = rect->maxx + ox*cellsize;
-  rect->maxy = rect->maxy + oy*cellsize;
-
-  return(cellsize);
-}
-
-/*
-** Rect must always contain a portion of bounds. If not, rect is
-** shifted to overlap by overlay percent. The dimensions of rect do
-** not change but placement relative to bounds can.
-*/
-int msConstrainExtent(rectObj *bounds, rectObj *rect, double overlay)
-{
-  /* check left edge, and if necessary the right edge of bounds */
-  if(rect->maxx <= bounds->minx) {
-    const double offset = overlay*(rect->maxx - rect->minx);
-    rect->minx += offset; /* shift right */
-    rect->maxx += offset;
-  } else if(rect->minx >= bounds->maxx) {
-    const double offset = overlay*(rect->maxx - rect->minx);
-    rect->minx -= offset; /* shift left */
-    rect->maxx -= offset;
-  }
-
-  /* check top edge, and if necessary the bottom edge of bounds */
-  if(rect->maxy <= bounds->miny) {
-    const double offset = overlay*(rect->maxy - rect->miny);
-    rect->miny -= offset; /* shift down */
-    rect->maxy -= offset;
-  } else if(rect->miny >= bounds->maxy) {
-    const double offset = overlay*(rect->maxy - rect->miny);
-    rect->miny += offset; /* shift up */
-    rect->maxy += offset;
-  }
-
-  return(MS_SUCCESS);
-}
-
-/*
-** Generic function to save an image to a file.
-**
-** Note that map may be NULL. If it is set, then it is used for two things:
-** - Deal with relative imagepaths (compute absolute path relative to map path)
-** - Extract the georeferenced extents and coordinate system
-**   of the map for writing out with the image when appropriate
-**   (primarily this means via msSaveImageGDAL() to something like GeoTIFF).
-**
-** The filename is NULL when the image is supposed to be written to stdout.
-*/
-
-int msSaveImage(mapObj *map, imageObj *img, const char *filename)
-{
-  int nReturnVal = MS_FAILURE;
-  char szPath[MS_MAXPATHLEN];
-  struct mstimeval starttime={0}, endtime={0};
-
-  if(map && map->debug >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&starttime, NULL);
-  }
-
-  if (img) {
-    if( MS_DRIVER_GDAL(img->format) ) {
-      if (map != NULL && filename != NULL )
-        nReturnVal = msSaveImageGDAL(map, img,
-                                     msBuildPath(szPath, map->mappath,
-                                         filename));
-      else
-        nReturnVal = msSaveImageGDAL(map, img, filename);
-    } else
-
-      if (MS_RENDERER_PLUGIN(img->format)) {
-        rendererVTableObj *renderer = img->format->vtable;
-        FILE *stream = NULL;
-        if(filename) {
-          if(map)
-            stream = fopen(msBuildPath(szPath, map->mappath, filename),"wb");
-          else
-            stream = fopen(filename,"wb");
-
-          if(!stream) {
-            msSetError(MS_IOERR,
-                       "Failed to create output file (%s).",
-                       "msSaveImage()", (map?szPath:filename) );
-            return MS_FAILURE;
-          }
-
-        } else {
-          if ( msIO_needBinaryStdout() == MS_FAILURE )
-            return MS_FAILURE;
-          stream = stdout;
-        }
-
-        if(renderer->supports_pixel_buffer) {
-          rasterBufferObj data;
-          if(renderer->getRasterBufferHandle(img,&data) != MS_SUCCESS) {
-            if( stream != stdout )
-              fclose(stream);
-            return MS_FAILURE;
-          }
-
-          nReturnVal = msSaveRasterBuffer(map,&data,stream,img->format );
-        } else {
-          nReturnVal = renderer->saveImage(img, map, stream, img->format);
-        }
-        if( stream != stdout )
-          fclose(stream);
-
-      } else if( MS_DRIVER_IMAGEMAP(img->format) )
-        nReturnVal = msSaveImageIM(img, filename, img->format);
-      else
-        msSetError(MS_MISCERR, "Unknown image type",
-                   "msSaveImage()");
-  }
-
-  if(map && map->debug >= MS_DEBUGLEVEL_TUNING) {
-    msGettimeofday(&endtime, NULL);
-    msDebug("msSaveImage(%s) total time: %.3fs\n",
-            (filename ? filename : "stdout"),
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
-  }
-
-  return nReturnVal;
-}
-
-/*
-** Generic function to save an image to a byte array.
-** - the return value is the pointer to the byte array
-** - size_ptr contains the number of bytes returned
-** - format: the desired output format
-**
-** The caller is responsible to free the returned array
-** The function returns NULL if the output format is not supported.
-*/
-
-unsigned char *msSaveImageBuffer(imageObj* image, int *size_ptr, outputFormatObj *format)
-{
-  *size_ptr = 0;
-  if( MS_RENDERER_PLUGIN(image->format)) {
-    rasterBufferObj data;
-    rendererVTableObj *renderer = image->format->vtable;
-    if(renderer->supports_pixel_buffer) {
-      bufferObj buffer;
-      msBufferInit(&buffer);
-      const int status = renderer->getRasterBufferHandle(image,&data);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
-        return NULL;
-      }
-      msSaveRasterBufferToBuffer(&data,&buffer,format);
-      *size_ptr = buffer.size;
-      return buffer.data;
-      /* don't free the bufferObj as we don't own the bytes anymore */
-    } else {
-      /* check if the renderer supports native buffer output */
-      if (renderer->saveImageBuffer)
-        return renderer->saveImageBuffer(image, size_ptr, format);
-
-      msSetError(MS_MISCERR, "Unsupported image type", "msSaveImageBuffer()");
-      return NULL;
-    }
-  }
-  msSetError(MS_MISCERR, "Unsupported image type", "msSaveImage()");
-  return NULL;
-}
-
-/**
- * Generic function to free the imageObj
- */
-void msFreeImage(imageObj *image)
-{
-  if (image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
-      rendererVTableObj *renderer = image->format->vtable;
-      tileCacheObj *next,*cur = image->tilecache;
-      while(cur) {
-        msFreeImage(cur->image);
-        next = cur->next;
-        free(cur);
-        cur = next;
-      }
-      image->ntiles = 0;
-      renderer->freeImage(image);
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
-      msFreeImageIM(image);
-    else if( MS_RENDERER_RAWDATA(image->format) )
-      msFree(image->img.raw_16bit);
-    else
-      msSetError(MS_MISCERR, "Unknown image type",
-                 "msFreeImage()");
-
-    if (image->imagepath)
-      free(image->imagepath);
-    if (image->imageurl)
-      free(image->imageurl);
-
-    if( --image->format->refcount < 1 )
-      msFreeOutputFormat( image->format );
-
-    image->imagepath = NULL;
-    image->imageurl = NULL;
-
-    msFree( image->img_mask );
-    image->img_mask= NULL;
-
-    msFree( image );
-  }
-}
-
-/*
-** Return an array containing all the layer's index given a group name.
-** If nothing is found, NULL is returned. The nCount is initalized
-** to the number of elements in the returned array.
-** Note : the caller of the function should free the array.
-*/
-int *msGetLayersIndexByGroup(mapObj *map, char *groupname, int *pnCount)
-{
-  int         i;
-  int         iLayer = 0;
-  int         *aiIndex;
-
-  if(!groupname || !map || !pnCount) {
-    return NULL;
-  }
-
-  aiIndex = (int *)msSmallMalloc(sizeof(int) * map->numlayers);
-
-  for(i=0; i<map->numlayers; i++) {
-    if(!GET_LAYER(map, i)->group) /* skip it */
-      continue;
-    if(strcmp(groupname, GET_LAYER(map, i)->group) == 0) {
-      aiIndex[iLayer] = i;
-      iLayer++;
-    }
-  }
-
-  if (iLayer == 0) {
-    free(aiIndex);
-    aiIndex = NULL;
-    *pnCount = 0;
-  } else {
-    aiIndex = (int *)msSmallRealloc(aiIndex, sizeof(int)* iLayer);
-    *pnCount = iLayer;
-  }
-
-  return aiIndex;
-}
-
-/* ==================================================================== */
-/*      Measured shape utility functions.                               */
-/* ==================================================================== */
-
-
-/************************************************************************/
-/*        pointObj *msGetPointUsingMeasure(shapeObj *shape, double m)   */
-/*                                                                      */
-/*      Using a measured value get the XY location it corresonds        */
-/*      to.                                                             */
-/*                                                                      */
-/************************************************************************/
-pointObj *msGetPointUsingMeasure(shapeObj *shape, double m)
-{
-  pointObj    *point = NULL;
-  int         bFound = 0;
-  double      dfFirstPointX = 0;
-  double      dfFirstPointY = 0;
-  double      dfFirstPointM = 0;
-  double      dfSecondPointX = 0;
-  double      dfSecondPointY = 0;
-  double      dfSecondPointM = 0;
-
-  if (shape &&  shape->numlines > 0) {
-    /* -------------------------------------------------------------------- */
-    /*      check fir the first value (min) and the last value(max) to      */
-    /*      see if the m is contained between these min and max.            */
-    /* -------------------------------------------------------------------- */
-    const lineObj* lineFirst = &(shape->line[0]);
-    const double dfMin = lineFirst->point[0].m;
-    const lineObj* lineLast = &(shape->line[shape->numlines-1]);
-    const double dfMax = lineLast->point[lineLast->numpoints-1].m;
-
-    if (m >= dfMin && m <= dfMax) {
-      for (int i=0; i<shape->numlines; i++) {
-        const lineObj* line = &(shape->line[i]);
-
-        for (int j=0; j<line->numpoints; j++) {
-          const double dfCurrentM = line->point[j].m;
-          if (dfCurrentM > m) {
-            bFound = 1;
-
-            dfSecondPointX = line->point[j].x;
-            dfSecondPointY = line->point[j].y;
-            dfSecondPointM = line->point[j].m;
-
-            /* -------------------------------------------------------------------- */
-            /*      get the previous node xy values.                                */
-            /* -------------------------------------------------------------------- */
-            if (j > 0) { /* not the first point of the line */
-              dfFirstPointX = line->point[j-1].x;
-              dfFirstPointY = line->point[j-1].y;
-              dfFirstPointM = line->point[j-1].m;
-            } else { /* get last point of previous line */
-              dfFirstPointX = shape->line[i-1].point[0].x;
-              dfFirstPointY = shape->line[i-1].point[0].y;
-              dfFirstPointM = shape->line[i-1].point[0].m;
-            }
-            break;
-          }
-        }
-      }
-    }
-
-    if (!bFound)
-      return NULL;
-
-    /* -------------------------------------------------------------------- */
-    /*      extrapolate the m value to get t he xy coordinate.              */
-    /* -------------------------------------------------------------------- */
-
-    double dfFactor = 0;
-    if (dfFirstPointM != dfSecondPointM)
-      dfFactor = (m-dfFirstPointM)/(dfSecondPointM - dfFirstPointM);
-
-    point = (pointObj *)msSmallMalloc(sizeof(pointObj));
-
-    point->x = dfFirstPointX + (dfFactor * (dfSecondPointX - dfFirstPointX));
-    point->y = dfFirstPointY +
-               (dfFactor * (dfSecondPointY - dfFirstPointY));
-    point->m = dfFirstPointM +
-               (dfFactor * (dfSecondPointM - dfFirstPointM));
-
-    return point;
-  }
-
-  return NULL;
-}
-
-
-/************************************************************************/
-/*       IntersectionPointLinepointObj *p, pointObj *a, pointObj *b)    */
-/*                                                                      */
-/*      Retunrs a point object corresponding to the intersection of     */
-/*      point p and a line formed of 2 points : a and b.                */
-/*                                                                      */
-/*      Alorith base on :                                               */
-/*      http://www.faqs.org/faqs/graphics/algorithms-faq/               */
-/*                                                                      */
-/*      Subject 1.02:How do I find the distance from a point to a line? */
-/*                                                                      */
-/*          Let the point be C (Cx,Cy) and the line be AB (Ax,Ay) to (Bx,By).*/
-/*          Let P be the point of perpendicular projection of C on AB.  The parameter*/
-/*          r, which indicates P's position along AB, is computed by the dot product */
-/*          of AC and AB divided by the square of the length of AB:     */
-/*                                                                      */
-/*          (1)     AC dot AB                                           */
-/*              r = ---------                                           */
-/*                  ||AB||^2                                            */
-/*                                                                      */
-/*          r has the following meaning:                                */
-/*                                                                      */
-/*              r=0      P = A                                          */
-/*              r=1      P = B                                          */
-/*              r<0      P is on the backward extension of AB           */
-/*              r>1      P is on the forward extension of AB            */
-/*              0<r<1    P is interior to AB                            */
-/*                                                                      */
-/*          The length of a line segment in d dimensions, AB is computed by:*/
-/*                                                                      */
-/*              L = sqrt( (Bx-Ax)^2 + (By-Ay)^2 + ... + (Bd-Ad)^2)      */
-/*                                                                      */
-/*          so in 2D:                                                   */
-/*                                                                      */
-/*              L = sqrt( (Bx-Ax)^2 + (By-Ay)^2 )                       */
-/*                                                                      */
-/*          and the dot product of two vectors in d dimensions, U dot V is computed:*/
-/*                                                                      */
-/*              D = (Ux * Vx) + (Uy * Vy) + ... + (Ud * Vd)             */
-/*                                                                      */
-/*          so in 2D:                                                   */
-/*                                                                      */
-/*              D = (Ux * Vx) + (Uy * Vy)                               */
-/*                                                                      */
-/*          So (1) expands to:                                          */
-/*                                                                      */
-/*                  (Cx-Ax)(Bx-Ax) + (Cy-Ay)(By-Ay)                     */
-/*              r = -------------------------------                     */
-/*                                L^2                                   */
-/*                                                                      */
-/*          The point P can then be found:                              */
-/*                                                                      */
-/*              Px = Ax + r(Bx-Ax)                                      */
-/*              Py = Ay + r(By-Ay)                                      */
-/*                                                                      */
-/*          And the distance from A to P = r*L.                         */
-/*                                                                      */
-/*          Use another parameter s to indicate the location along PC, with the */
-/*          following meaning:                                          */
-/*                 s<0      C is left of AB                             */
-/*                 s>0      C is right of AB                            */
-/*                 s=0      C is on AB                                  */
-/*                                                                      */
-/*          Compute s as follows:                                       */
-/*                                                                      */
-/*                  (Ay-Cy)(Bx-Ax)-(Ax-Cx)(By-Ay)                       */
-/*              s = -----------------------------                       */
-/*                              L^2                                     */
-/*                                                                      */
-/*                                                                      */
-/*          Then the distance from C to P = |s|*L.                      */
-/*                                                                      */
-/************************************************************************/
-pointObj *msIntersectionPointLine(pointObj *p, pointObj *a, pointObj *b)
-{
-  pointObj *result = NULL;
-
-  if (p && a && b) {
-    const double L = sqrt(((b->x - a->x)*(b->x - a->x)) +
-             ((b->y - a->y)*(b->y - a->y)));
-
-    double r = 0;
-    if (L != 0)
-      r = ((p->x - a->x)*(b->x - a->x) + (p->y - a->y)*(b->y - a->y))/(L*L);
-
-    result = (pointObj *)msSmallMalloc(sizeof(pointObj));
-    /* -------------------------------------------------------------------- */
-    /*      We want to make sure that the point returned is on the line     */
-    /*                                                                      */
-    /*              r=0      P = A                                          */
-    /*              r=1      P = B                                          */
-    /*              r<0      P is on the backward extension of AB           */
-    /*              r>1      P is on the forward extension of AB            */
-    /*                    0<r<1    P is interior to AB                      */
-    /* -------------------------------------------------------------------- */
-    if (r < 0) {
-      result->x = a->x;
-      result->y = a->y;
-    } else if (r > 1) {
-      result->x = b->x;
-      result->y = b->y;
-    } else {
-      result->x = a->x + r*(b->x - a->x);
-      result->y = a->y + r*(b->y - a->y);
-    }
-    result->m = 0;
-  }
-
-  return result;
-}
-
-
-/************************************************************************/
-/*         pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj   */
-/*      *point)                                                         */
-/*                                                                      */
-/*      Calculate the intersection point betwwen the point and the      */
-/*      shape and return the Measured value at the intersection.        */
-/************************************************************************/
-pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj *point)
-{
-  pointObj    oFirst;
-  pointObj    oSecond;
-
-  if (shape && point) {
-    double      dfMinDist = 1e35;
-    for (int i=0; i<shape->numlines; i++) {
-      lineObj line = shape->line[i];
-      /* -------------------------------------------------------------------- */
-      /*      for each line (2 consecutive lines) get the distance between    */
-      /*      the line and the point and determine which line segment is      */
-      /*      the closeset to the point.                                      */
-      /* -------------------------------------------------------------------- */
-      for (int j=0; j<line.numpoints-1; j++) {
-        const double dfDist = msDistancePointToSegment(point, &line.point[j], &line.point[j+1]);
-        if (dfDist < dfMinDist) {
-          oFirst.x = line.point[j].x;
-          oFirst.y = line.point[j].y;
-          oFirst.m = line.point[j].m;
-
-          oSecond.x =  line.point[j+1].x;
-          oSecond.y =  line.point[j+1].y;
-          oSecond.m =  line.point[j+1].m;
-
-          dfMinDist = dfDist;
-        }
-      }
-    }
-    /* -------------------------------------------------------------------- */
-    /*      once we have the nearest segment, look for the x,y location     */
-    /*      which is the nearest intersection between the line and the      */
-    /*      point.                                                          */
-    /* -------------------------------------------------------------------- */
-    pointObj* poIntersectionPt = msIntersectionPointLine(point, &oFirst, &oSecond);
-    if (poIntersectionPt) {
-      const double dfDistTotal = sqrt(((oSecond.x - oFirst.x)*(oSecond.x - oFirst.x)) +
-                         ((oSecond.y - oFirst.y)*(oSecond.y - oFirst.y)));
-
-      const double dfDistToIntersection = sqrt(((poIntersectionPt->x - oFirst.x)*
-                                   (poIntersectionPt->x - oFirst.x)) +
-                                  ((poIntersectionPt->y - oFirst.y)*
-                                   (poIntersectionPt->y - oFirst.y)));
-
-      const double dfFactor = dfDistToIntersection / dfDistTotal;
-
-      poIntersectionPt->m = oFirst.m + (oSecond.m - oFirst.m)*dfFactor;
-      return poIntersectionPt;
-    }
-
-  }
-  return NULL;
-}
-
-/* ==================================================================== */
-/*   End   Measured shape utility functions.                            */
-/* ==================================================================== */
-
-
-char **msGetAllGroupNames(mapObj *map, int *numTok)
-{
-  char        **papszGroups = NULL;
-
-  assert(map);
-  *numTok = 0;
-
-  if (!map->layerorder) {
-    map->layerorder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-
-    /*
-     * Initiate to default order
-     */
-    for (int i=0; i<map->numlayers; i++)
-      map->layerorder[i] = i;
-  }
-
-  if (map->numlayers > 0) {
-    const int nCount = map->numlayers;
-    papszGroups = (char **)msSmallMalloc(sizeof(char *)*nCount);
-
-    for (int i=0; i<nCount; i++)
-      papszGroups[i] = NULL;
-
-    for (int i=0; i<nCount; i++) {
-      layerObj *lp;
-      lp = (GET_LAYER(map, map->layerorder[i]));
-
-      int bFound = 0;
-      if (lp->group && lp->status != MS_DELETE) {
-        for (int j=0; j<*numTok; j++) {
-          if (papszGroups[j] &&
-              strcmp(lp->group, papszGroups[j]) == 0) {
-            bFound = 1;
-            break;
-          }
-        }
-        if (!bFound) {
-          /* New group... add to the list of groups found */
-          papszGroups[(*numTok)] = msStrdup(lp->group);
-          (*numTok)++;
-        }
-      }
-    }
-
-  }
-
-  return papszGroups;
-}
-
-/************************************************************************/
-/*                         msForceTmpFileBase()                         */
-/************************************************************************/
-
-static int tmpCount = 0;
-static char *ForcedTmpBase = NULL;
-
-void msForceTmpFileBase( const char *new_base )
-{
-  /* -------------------------------------------------------------------- */
-  /*      Clear previous setting, if any.                                 */
-  /* -------------------------------------------------------------------- */
-  if( ForcedTmpBase != NULL ) {
-    free( ForcedTmpBase );
-    ForcedTmpBase = NULL;
-  }
-
-  tmpCount = -1;
-
-  if( new_base == NULL )
-    return;
-
-  /* -------------------------------------------------------------------- */
-  /*      Record new base.                                                */
-  /* -------------------------------------------------------------------- */
-  ForcedTmpBase = msStrdup( new_base );
-  tmpCount = 0;
-}
-
-/**********************************************************************
- *                          msTmpFile()
- *
- * Generate a Unique temporary file.
- *
- * Returns char* which must be freed by caller.
- **********************************************************************/
-char *msTmpFile(mapObj *map, const char *mappath, const char *tmppath, const char *ext)
-{
-  char szPath[MS_MAXPATHLEN];
-  const char *fullFname;
-  char *tmpFileName; /* big enough for time + pid + ext */
-  char *tmpBase = NULL;
-
-  tmpBase = msTmpPath(map, mappath, tmppath);
-  tmpFileName = msTmpFilename(ext);
-
-  fullFname = msBuildPath(szPath, tmpBase, tmpFileName);
-
-  free(tmpFileName);
-  free(tmpBase);
-
-  if (fullFname)
-    return msStrdup(fullFname);
-
-  return NULL;
-}
-
-/**********************************************************************
- *                          msTmpPath()
- *
- * Return the temporary path based on the platform.
- *
- * Returns char* which must be freed by caller.
- **********************************************************************/
-char *msTmpPath(mapObj *map, const char *mappath, const char *tmppath)
-{
-  char szPath[MS_MAXPATHLEN];
-  const char *fullPath;
-  const char *tmpBase;
-  const char *ms_temppath;
-#ifdef _WIN32
-  DWORD dwRetVal = 0;
-  TCHAR lpTempPathBuffer[MAX_PATH];
-#endif
-
-  if( ForcedTmpBase != NULL )
-    tmpBase = ForcedTmpBase;
-  else if (tmppath != NULL)
-    tmpBase = tmppath;
-  else if ((ms_temppath = CPLGetConfigOption("MS_TEMPPATH", NULL)) != NULL)
-    tmpBase = ms_temppath;
-  else if (map && map->web.temppath)
-    tmpBase = map->web.temppath;
-  else { /* default paths */
-#ifndef _WIN32
-    tmpBase = "/tmp/";
-#else
-    dwRetVal =  GetTempPath(MAX_PATH,          /* length of the buffer */
-                            lpTempPathBuffer); /* buffer for path */
-    if (dwRetVal > MAX_PATH || (dwRetVal == 0)) {
-      tmpBase = "C:\\";
-    } else {
-      tmpBase = (char*)lpTempPathBuffer;
-    }
-#endif
-  }
-
-  fullPath = msBuildPath(szPath, mappath, tmpBase);
-  return msStrdup(fullPath);
-}
-
-/**********************************************************************
- *                          msTmpFilename()
- *
- * Generate a Unique temporary filename.
- *
- * Returns char* which must be freed by caller.
- **********************************************************************/
-char *msTmpFilename(const char *ext)
-{
-  char *tmpFname;
-  int tmpFnameBufsize;
-  char *fullFname;
-  char tmpId[128]; /* big enough for time + pid + ext */
-
-  snprintf(tmpId, sizeof(tmpId), "%lx_%x",(long)time(NULL),(int)getpid());
-
-  if (ext == NULL)  ext = "";
-  tmpFnameBufsize = strlen(tmpId) + 10 + strlen(ext) + 1;
-  tmpFname = (char*)msSmallMalloc(tmpFnameBufsize);
-
-  msAcquireLock( TLOCK_TMPFILE );
-  snprintf(tmpFname, tmpFnameBufsize, "%s_%x.%s", tmpId, tmpCount++, ext);
-  msReleaseLock( TLOCK_TMPFILE );
-
-  fullFname = msStrdup(tmpFname);
-  free(tmpFname);
-
-  return fullFname;
-}
-
-/**
- *  Generic function to Initalize an image object.
- */
-imageObj *msImageCreate(int width, int height, outputFormatObj *format,
-                        char *imagepath, char *imageurl, double resolution,
-                        double defresolution, colorObj *bg)
-{
-  imageObj *image = NULL;
-  if(MS_RENDERER_PLUGIN(format)) {
-
-    image = format->vtable->createImage(width,height,format,bg);
-    if (image == NULL) {
-      msSetError(MS_MEMERR, "Unable to create new image object.", "msImageCreate()");
-      return NULL;
-    }
-
-    image->format = format;
-    format->refcount++;
-
-    image->width = width;
-    image->height = height;
-    image->imagepath = NULL;
-    image->imageurl = NULL;
-    image->tilecache = NULL;
-    image->ntiles = 0;
-    image->resolution = resolution;
-    image->resolutionfactor = resolution/defresolution;
-
-    if (imagepath)
-      image->imagepath = msStrdup(imagepath);
-    if (imageurl)
-      image->imageurl = msStrdup(imageurl);
-  } else if( MS_RENDERER_RAWDATA(format) ) {
-    if( format->imagemode != MS_IMAGEMODE_INT16
-        && format->imagemode != MS_IMAGEMODE_FLOAT32
-        && format->imagemode != MS_IMAGEMODE_BYTE ) {
-      msSetError(MS_IMGERR,
-                 "Attempt to use illegal imagemode with rawdata renderer.",
-                 "msImageCreate()" );
-      return NULL;
-    }
-
-    image = (imageObj *)calloc(1,sizeof(imageObj));
-    if (image == NULL) {
-      msSetError(MS_MEMERR, "Unable to create new image object.", "msImageCreate()");
-      return NULL;
-    }
-
-    if( format->imagemode == MS_IMAGEMODE_INT16 )
-      image->img.raw_16bit = (short *)
-                             msSmallCalloc(sizeof(short),width*height*format->bands);
-    else if( format->imagemode == MS_IMAGEMODE_FLOAT32 )
-      image->img.raw_float = (float *)
-                             msSmallCalloc(sizeof(float),width*height*format->bands);
-    else if( format->imagemode == MS_IMAGEMODE_BYTE )
-      image->img.raw_byte = (unsigned char *)
-                            msSmallCalloc(sizeof(unsigned char),width*height*format->bands);
-
-    if( image->img.raw_16bit == NULL ) {
-      msFree( image );
-      msSetError(MS_IMGERR,
-                 "Attempt to allocate raw image failed, out of memory.",
-                 "msImageCreate()" );
-      return NULL;
-    }
-
-    image->img_mask = msAllocBitArray( width*height );
-
-    image->format = format;
-    format->refcount++;
-
-    image->width = width;
-    image->height = height;
-    image->imagepath = NULL;
-    image->imageurl = NULL;
-    image->resolution = resolution;
-    image->resolutionfactor = resolution/defresolution;
-
-    if (imagepath)
-      image->imagepath = msStrdup(imagepath);
-    if (imageurl)
-      image->imageurl = msStrdup(imageurl);
-
-    /* initialize to requested nullvalue if there is one */
-    const char *nullvalue = msGetOutputFormatOption(image->format,
-                              "NULLVALUE",NULL);
-    if( nullvalue != NULL ) {
-      int i = image->width * image->height * format->bands;
-      if( atof(nullvalue) == 0.0 )
-        /* nothing to do */;
-      else if( format->imagemode == MS_IMAGEMODE_INT16 ) {
-        short nv = atoi(nullvalue);
-        for( ; i > 0; )
-          image->img.raw_16bit[--i] = nv;
-      } else if( format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
-        float nv = atof(nullvalue);
-        for( ; i > 0; )
-          image->img.raw_float[--i] = nv;
-      } else if( format->imagemode == MS_IMAGEMODE_BYTE ) {
-        unsigned char nv = (unsigned char) atoi(nullvalue);
-
-        memset( image->img.raw_byte, nv, i );
-      }
-    }
-  } else if( MS_RENDERER_IMAGEMAP(format) ) {
-    image = msImageCreateIM(width, height, format,
-                            imagepath, imageurl, resolution, defresolution);
-  } else {
-    msSetError(MS_MISCERR,
-               "Unsupported renderer requested, unable to initialize image.",
-               "msImageCreate()");
-    return NULL;
-  }
-
-  if(!image) {
-    msSetError(MS_IMGERR, "Unable to initialize image.", "msImageCreate()");
-    return NULL;
-  }
-  image->refpt.x = image->refpt.y = 0;
-  return image;
-}
-
-
-/**
- * Generic function to transorm a point.
- *
- */
-void  msTransformPoint(pointObj *point, rectObj *extent, double cellsize,
-                       imageObj *image)
-{
-  double invcellsize;
-  /*We should probabaly have a function defined at all the renders*/
-  if (image != NULL && MS_RENDERER_PLUGIN(image->format)) {
-    if(image->format->renderer == MS_RENDER_WITH_KML) {
-      return;
-    }
-  }
-  invcellsize = 1.0/cellsize;
-  point->x = MS_MAP2IMAGE_X_IC_DBL(point->x, extent->minx, invcellsize);
-  point->y = MS_MAP2IMAGE_Y_IC_DBL(point->y, extent->maxy, invcellsize);
-}
-
-
-/*
-** Helper functions supplied as part of bug #2868 solution. Consider moving these to
-** mapprimitive.c for more general use.
-*/
-
-/* vector difference */
-static pointObj point_diff(const pointObj a, const pointObj b)
-{
-  pointObj retv;
-  retv.x = a.x-b.x;
-  retv.y = a.y-b.y;
-  retv.z = a.z-b.z;
-  retv.m = a.m-b.m;
-  return retv;
-}
-
-/* vector sum */
-static pointObj point_sum(const pointObj a, const pointObj b)
-{
-  pointObj retv;
-  retv.x = a.x+b.x;
-  retv.y = a.y+b.y;
-  retv.z = a.z+b.z;
-  retv.m = a.m+b.m;
-  return retv;
-}
-
-/* vector multiply */
-static pointObj point_mul(const pointObj a, double b)
-{
-  pointObj retv;
-  retv.x = a.x*b;
-  retv.y = a.y*b;
-  retv.z = a.z*b;
-  retv.m = a.m*b;
-  return retv;
-}
-
-/* vector ??? */
-static double point_abs2(const pointObj a)
-{
-  return a.x*a.x+a.y*a.y+a.z*a.z+a.m*a.m;
-}
-
-/* vector normal */
-static pointObj point_norm(const pointObj a)
-{
-  double lenmul;
-  pointObj retv;
-  int norm_vector;
-
-  norm_vector = a.x==0 && a.y==0;
-  norm_vector = norm_vector && a.z==0 && a.m==0;
-
-  if (norm_vector)
-    return a;
-
-  lenmul=1.0/sqrt(point_abs2(a));  /* this seems to be the costly operation */
-
-  retv.x = a.x*lenmul;
-  retv.y = a.y*lenmul;
-  retv.z = a.z*lenmul;
-  retv.m = a.m*lenmul;
-
-  return retv;
-}
-
-/* rotate a vector 90 degrees */
-static pointObj point_rotz90(const pointObj a)
-{
-  double nx=-1.0*a.y, ny=a.x;
-  pointObj retv=a;
-  retv.x=nx;
-  retv.y=ny;
-  return retv;
-}
-
-/* vector cross product (warning: z and m dimensions are ignored!) */
-static double point_cross(const pointObj a, const pointObj b)
-{
-  return a.x*b.y-a.y*b.x;
-}
-
-shapeObj *msOffsetCurve(shapeObj *p, double offset)
-{
-  shapeObj *ret;
-  int i, j, first,idx,ok=0;
-#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
-  ret = msGEOSOffsetCurve(p,offset);
-  /* GEOS curve offsetting can fail sometimes, we continue with our own implementation
-   if that is the case.*/
-  if(ret)
-    return ret;
-  /* clear error raised by geos in this case */
-  msResetErrorList();
-#endif
-  /*
-  ** For offset corner point calculation 1/sin() is used
-  ** to avoid 1/0 division (and long spikes) we define a
-  ** limit for sin().
-  */
-#define CURVE_SIN_LIMIT 0.3
-  ret = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
-  msInitShape(ret);
-  ret->numlines = p->numlines;
-  ret->line=(lineObj*)msSmallMalloc(sizeof(lineObj)*ret->numlines);
-  for(i=0; i<ret->numlines; i++) {
-    ret->line[i].numpoints=p->line[i].numpoints;
-    ret->line[i].point=(pointObj*)msSmallMalloc(sizeof(pointObj)*ret->line[i].numpoints);
-  }
-  for (i = 0; i < p->numlines; i++) {
-    pointObj old_diffdir, old_offdir;
-    if(p->line[i].numpoints<2) {
-      ret->line[i].numpoints = 0;
-      continue; /* skip degenerate points */
-    }
-    ok = 1;
-    /* initialize old_offdir and old_diffdir, as gcc isn't smart enough to see that it
-     * is not an error to do so, and prints a warning */
-    old_offdir.x=old_offdir.y=old_diffdir.x=old_diffdir.y = 0;
-
-    idx=0;
-    first = 1;
-
-    /* saved metrics of the last processed point */
-    pointObj old_pt=p->line[i].point[0];
-    for(j=1; j<p->line[i].numpoints; j++) {
-      const pointObj pt = p->line[i].point[j]; /* place of the point */
-      const pointObj diffdir = point_norm(point_diff(pt,old_pt)); /* direction of the line */
-      const pointObj offdir = point_rotz90(diffdir); /* direction where the distance between the line and the offset is measured */
-      pointObj offpt; /* this will be the corner point of the offset line */
-
-      /* offset line points computation */
-      if(first == 1) { /* first point */
-        first = 0;
-        offpt = point_sum(old_pt,point_mul(offdir,offset));
-      } else { /* middle points */
-        /* curve is the angle of the last and the current line's direction (supplementary angle of the shape's inner angle) */
-        double sin_curve = point_cross(diffdir,old_diffdir);
-        double cos_curve = point_cross(old_offdir,diffdir);
-        if ((-1.0)*CURVE_SIN_LIMIT < sin_curve && sin_curve < CURVE_SIN_LIMIT) {
-          /* do not calculate 1/sin, instead use a corner point approximation: average of the last and current offset direction and length */
-
-          /*
-          ** TODO: fair for obtuse inner angles, however, positive and negative
-          ** acute inner angles would need special handling - similar to LINECAP
-          ** to avoid drawing of long spikes
-          */
-          offpt = point_sum(old_pt, point_mul(point_sum(offdir, old_offdir),0.5*offset));
-        } else {
-          double base_shift = -1.0*(1.0+cos_curve)/sin_curve;
-          offpt = point_sum(old_pt, point_mul(point_sum(point_mul(diffdir,base_shift),offdir), offset));
-        }
-      }
-      ret->line[i].point[idx]=offpt;
-      idx++;
-      old_pt=pt;
-      old_diffdir=diffdir;
-      old_offdir=offdir;
-    }
-
-    /* last point */
-    if(first == 0) {
-      pointObj offpt=point_sum(old_pt,point_mul(old_offdir,offset));
-      ret->line[i].point[idx]=offpt;
-      idx++;
-    }
-
-    if(idx != p->line[i].numpoints) {
-      /* printf("shouldn't happen :(\n"); */
-      ret->line[i].numpoints=idx;
-      ret->line=msSmallRealloc(ret->line,ret->line[i].numpoints*sizeof(pointObj));
-    }
-  }
-  if(!ok) ret->numlines = 0; /* all lines where degenerate */
-  return ret;
-}
-
-shapeObj *msOffsetPolyline(shapeObj *p, double offsetx, double offsety)
-{
-  int i, j;
-  shapeObj *ret;
-  if(offsety == MS_STYLE_SINGLE_SIDED_OFFSET) { /* complex calculations */
-    return msOffsetCurve(p,offsetx);
-  } else if(offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
-    shapeObj *tmp1;
-    ret = msOffsetCurve(p,offsetx/2.0);
-    tmp1 = msOffsetCurve(p, -offsetx/2.0);
-    for(i=0;i<tmp1->numlines; i++) {
-      msAddLineDirectly(ret,tmp1->line + i);
-    }
-    msFreeShape(tmp1);
-    free(tmp1);
-    return ret;
-  }
-
-  ret = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
-  msInitShape(ret);
-  ret->numlines = p->numlines;
-  ret->line=(lineObj*)msSmallMalloc(sizeof(lineObj)*ret->numlines);
-  for(i=0; i<ret->numlines; i++) {
-    ret->line[i].numpoints=p->line[i].numpoints;
-    ret->line[i].point=(pointObj*)msSmallMalloc(sizeof(pointObj)*ret->line[i].numpoints);
-  }
-
-  for (i = 0; i < p->numlines; i++) {
-    for(j=0; j<p->line[i].numpoints; j++) {
-      ret->line[i].point[j].x=p->line[i].point[j].x+offsetx;
-      ret->line[i].point[j].y=p->line[i].point[j].y+offsety;
-    }
-  }
-
-  return ret;
-}
-
-/*
--------------------------------------------------------------------------------
- msSetup()
-
- Contributed by Jerry Pisk in bug 1203.  Heads off potential race condition
- in initializing GD font cache with multiple threads.  Should be called from
- mapscript module initialization code.
--------------------------------------------------------------------------------
-*/
-
-int msSetup()
-{
-#ifdef _WIN32
-  const char *maxfiles = CPLGetConfigOption("MS_MAX_OPEN_FILES", NULL);
-  if (maxfiles) {
-    int res = _getmaxstdio();
-    if (res < 2048) {
-      res = _setmaxstdio(atoi(maxfiles));
-      assert(res != -1);
-    }
-  }
-#endif
-
-#ifdef USE_THREAD
-  msThreadInit();
-#endif
-
-  /* Use PROJ_DATA/PROJ_LIB env vars if set */
-  msProjDataInitFromEnv();
-
-  /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
-  if (msDebugInitFromEnv() != MS_SUCCESS)
-    return MS_FAILURE;
-
-#ifdef USE_GEOS
-  msGEOSSetup();
-#endif
-
-#ifdef USE_RSVG
-#if !GLIB_CHECK_VERSION(2, 35, 0)
-  g_type_init();
-#endif
-#endif
-
-  msFontCacheSetup();
-
-
-  return MS_SUCCESS;
-}
-
-/* This is intended to be a function to cleanup anything that "hangs around"
-   when all maps are destroyed, like Registered GDAL drivers, and so forth. */
-#ifndef NDEBUG
-#if defined(USE_LIBXML2)
-#include "maplibxml2.h"
-#endif
-#endif
-void msCleanup()
-{
-  msForceTmpFileBase( NULL );
-  msConnPoolFinalCleanup();
-  /* Lexer string parsing variable */
-  if (msyystring_buffer != NULL) {
-    msFree(msyystring_buffer);
-    msyystring_buffer = NULL;
-  }
-  msyylex_destroy();
-
-  msOGRCleanup();
-  msGDALCleanup();
-
-  /* Release both GDAL and OGR resources */
-  msAcquireLock( TLOCK_GDAL );
-#if GDAL_VERSION_MAJOR >= 3 || (GDAL_VERSION_MAJOR == 2 && GDAL_VERSION_MINOR == 4)
-  /* Cleanup some GDAL global resources in particular */
-  GDALDestroy();
-#else
-  GDALDestroyDriverManager();
-#endif
-  msReleaseLock( TLOCK_GDAL );
-
-
-#if PROJ_VERSION_MAJOR < 6
-#  if PJ_VERSION >= 480
-  pj_clear_initcache();
-#  endif
-  pj_deallocate_grids();
-#endif
-  msSetPROJ_DATA( NULL, NULL );
-  msProjectionContextPoolCleanup();
-
-#if defined(USE_CURL)
-  msHTTPCleanup();
-#endif
-
-#ifdef USE_GEOS
-  msGEOSCleanup();
-#endif
-
-/* make valgrind happy on debug code */
-#ifndef NDEBUG
-#ifdef USE_CAIRO
-  msCairoCleanup();
-#endif
-#if defined(USE_LIBXML2)
-  xmlCleanupParser();
-#endif
-#endif
-
-  msFontCacheCleanup();
-
-  msTimeCleanup();
-
-  msIO_Cleanup();
-
-  msResetErrorList();
-
-  /* Close/cleanup log/debug output. Keep this at the very end. */
-  msDebugCleanup();
-
-  /* Clean up the vtable factory */
-  msPluginFreeVirtualTableFactory();
-}
-
-/************************************************************************/
-/*                            msAlphaBlend()                            */
-/*                                                                      */
-/*      Function to overlay/blend an RGBA value into an existing        */
-/*      RGBA value using the Porter-Duff "over" operator.               */
-/*      Primarily intended for use with rasterBufferObj                 */
-/*      raster rendering.  The "src" is the overlay value, and "dst"    */
-/*      is the existing value being overlaid. dst is expected to be     */
-/*      premultiplied, but the source should not be.                    */
-/*                                                                      */
-/*      NOTE: alpha_dst may be NULL.                                    */
-/************************************************************************/
-
-void msAlphaBlend( unsigned char red_src, unsigned char green_src,
-                   unsigned char blue_src, unsigned char alpha_src,
-                   unsigned char *red_dst, unsigned char *green_dst,
-                   unsigned char *blue_dst, unsigned char *alpha_dst )
-{
-  /* -------------------------------------------------------------------- */
-  /*      Simple cases we want to handle fast.                            */
-  /* -------------------------------------------------------------------- */
-  if( alpha_src == 0 )
-    return;
-
-  if( alpha_src == 255 ) {
-    *red_dst = red_src;
-    *green_dst = green_src;
-    *blue_dst = blue_src;
-    if( alpha_dst )
-      *alpha_dst = 255;
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Premultiple alpha for source values now.                        */
-  /* -------------------------------------------------------------------- */
-  red_src   = red_src * alpha_src / 255;
-  green_src = green_src * alpha_src / 255;
-  blue_src  = blue_src * alpha_src / 255;
-
-  /* -------------------------------------------------------------------- */
-  /*      Another pretty fast case if there is nothing in the             */
-  /*      destination to mix with.                                        */
-  /* -------------------------------------------------------------------- */
-  if( alpha_dst && *alpha_dst == 0) {
-    *red_dst = red_src;
-    *green_dst = green_src;
-    *blue_dst = blue_src;
-    *alpha_dst = alpha_src;
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Cases with actual blending.                                     */
-  /* -------------------------------------------------------------------- */
-  if(!alpha_dst || *alpha_dst == 255) {
-    int weight_dst = 256 - alpha_src;
-
-    *red_dst   = (256 * red_src   + *red_dst   * weight_dst) >> 8;
-    *green_dst = (256 * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (256 * blue_src  + *blue_dst  * weight_dst) >> 8;
-  } else {
-    int   weight_dst = (256 - alpha_src);
-
-    *red_dst   = (256 * red_src   + *red_dst   * weight_dst) >> 8;
-    *green_dst = (256 * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (256 * blue_src  + *blue_dst  * weight_dst) >> 8;
-
-    *alpha_dst = (256 * alpha_src + *alpha_dst * weight_dst) >> 8;
-  }
-}
-
-/************************************************************************/
-/*                           msAlphaBlendPM()                           */
-/*                                                                      */
-/*      Same as msAlphaBlend() except that the source RGBA is           */
-/*      assumed to already be premultiplied.                            */
-/************************************************************************/
-
-void msAlphaBlendPM( unsigned char red_src, unsigned char green_src,
-                     unsigned char blue_src, unsigned char alpha_src,
-                     unsigned char *red_dst, unsigned char *green_dst,
-                     unsigned char *blue_dst, unsigned char *alpha_dst )
-{
-  /* -------------------------------------------------------------------- */
-  /*      Simple cases we want to handle fast.                            */
-  /* -------------------------------------------------------------------- */
-  if( alpha_src == 0 )
-    return;
-
-  if( alpha_src == 255 ) {
-    *red_dst = red_src;
-    *green_dst = green_src;
-    *blue_dst = blue_src;
-    if( alpha_dst )
-      *alpha_dst = 255;
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Another pretty fast case if there is nothing in the             */
-  /*      destination to mix with.                                        */
-  /* -------------------------------------------------------------------- */
-  if( alpha_dst && *alpha_dst == 0) {
-    *red_dst = red_src;
-    *green_dst = green_src;
-    *blue_dst = blue_src;
-    *alpha_dst = alpha_src;
-    return;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Cases with actual blending.                                     */
-  /* -------------------------------------------------------------------- */
-  if(!alpha_dst || *alpha_dst == 255) {
-    int weight_dst = 255 - alpha_src;
-
-    *red_dst   = (alpha_src * red_src   + *red_dst   * weight_dst) >> 8;
-    *green_dst = (alpha_src * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (alpha_src * blue_src  + *blue_dst  * weight_dst) >> 8;
-  } else {
-    int   weight_dst = (255 - alpha_src);
-
-    *red_dst   = (alpha_src * red_src   + *red_dst   * weight_dst) >> 8;
-    *green_dst = (alpha_src * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (alpha_src * blue_src  + *blue_dst  * weight_dst) >> 8;
-
-    *alpha_dst = (255 * alpha_src + *alpha_dst * weight_dst) >> 8;
-  }
-}
-
-void msRGBtoHSL(colorObj *rgb, double *h, double *s, double *l) {
-  double r = rgb->red/255.0, g = rgb->green/255.0, b = rgb->blue/255.0;
-  double maxv = MS_MAX(MS_MAX(r, g), b), minv = MS_MIN(MS_MIN(r, g), b);
-  double d = maxv - minv;
-
-  *h = 0, *s = 0;
-  *l = (maxv + minv) / 2;
-
-  if (maxv != minv)
-  {
-    *s = *l > 0.5 ? d / (2 - maxv - minv) : d / (maxv + minv);
-    if (maxv == r) { *h = (g - b) / d + (g < b ? 6 : 0); }
-    else if (maxv == g) { *h = (b - r) / d + 2; }
-    else if (maxv == b) { *h = (r - g) / d + 4; }
-    *h /= 6;
-  }
-}
-
-static double hue_to_rgb(double p, double q, double t) {
-  if(t < 0) t += 1;
-  if(t > 1) t -= 1;
-  if(t < 0.1666666666666666) return p + (q - p) * 6 * t;
-  if(t < 0.5) return q;
-  if(t < 0.6666666666666666) return p + (q - p) * (0.666666666666 - t) * 6;
-  return p;
-}
-
-void msHSLtoRGB(double h, double s, double l, colorObj *rgb) {
-  double r, g, b;
-
-  if(s == 0){
-    r = g = b = l;
-  } else {
-
-    double q = l < 0.5 ? l * (1 + s) : l + s - l * s;
-    double p = 2 * l - q;
-    r = hue_to_rgb(p, q, h + 0.33333333333333333);
-    g = hue_to_rgb(p, q, h);
-    b = hue_to_rgb(p, q, h - 0.33333333333333333);
-  }
-  rgb->red = r * 255;
-  rgb->green = g * 255;
-  rgb->blue = b * 255;
-}
-
-/*
- RFC 24: check if the parent pointer is NULL and raise an error otherwise
-*/
-int msCheckParentPointer(void* p, const char *objname)
-{
-  if (p == NULL) {
-    if(objname != NULL) {
-      msSetError(MS_NULLPARENTERR, "The %s parent object is null", "msCheckParentPointer()", objname);
-    } else {
-      msSetError(MS_NULLPARENTERR, "The parent object is null", "msCheckParentPointer()");
-    }
-    return MS_FAILURE;
-  }
-  return MS_SUCCESS;
-}
-
-void msBufferInit(bufferObj *buffer)
-{
-  buffer->data=NULL;
-  buffer->size=0;
-  buffer->available=0;
-  buffer->_next_allocation_size = MS_DEFAULT_BUFFER_ALLOC;
-}
-
-void msBufferResize(bufferObj *buffer, size_t target_size)
-{
-  while(buffer->available <= target_size) {
-    buffer->data = msSmallRealloc(buffer->data,buffer->available+buffer->_next_allocation_size);
-    buffer->available += buffer->_next_allocation_size;
-    buffer->_next_allocation_size *= 2;
-  }
-}
-
-void msBufferAppend(bufferObj *buffer, void *data, size_t length)
-{
-  if(buffer->available < buffer->size+length) {
-    msBufferResize(buffer,buffer->size+length);
-  }
-  memcpy(&(buffer->data[buffer->size]),data,length);
-  buffer->size += length;
-}
-
-void msBufferFree(bufferObj *buffer)
-{
-  if(buffer->available>0)
-    free(buffer->data);
-}
-
-
-void msFreeRasterBuffer(rasterBufferObj *b)
-{
-  switch(b->type) {
-    case MS_BUFFER_BYTE_RGBA:
-      msFree(b->data.rgba.pixels);
-      b->data.rgba.pixels = NULL;
-      break;
-    case MS_BUFFER_BYTE_PALETTE:
-      msFree(b->data.palette.pixels);
-      msFree(b->data.palette.palette);
-      b->data.palette.pixels = NULL;
-      b->data.palette.palette = NULL;
-      break;
-  }
-
-}
-
-/*
-** Issue #3043: Layer extent comparison short circuit.
-**
-** msExtentsOverlap()
-**
-** Returns MS_TRUE if map extent and layer extent overlap,
-** MS_FALSE if they are disjoint, and MS_UNKNOWN if there is
-** not enough info to calculate a deterministic answer.
-**
-*/
-int msExtentsOverlap(mapObj *map, layerObj *layer)
-{
-  rectObj map_extent;
-  rectObj layer_extent;
-
-  /* No extent info? Nothing we can do, return MS_UNKNOWN. */
-  if( (map->extent.minx == -1) && (map->extent.miny == -1) && (map->extent.maxx == -1 ) && (map->extent.maxy == -1) ) return MS_UNKNOWN;
-  if( (layer->extent.minx == -1) && (layer->extent.miny == -1) && (layer->extent.maxx == -1 ) && (layer->extent.maxy == -1) ) return MS_UNKNOWN;
-
-  /* No map projection? Let someone else sort this out. */
-  if( ! (map->projection.numargs > 0) )
-    return MS_UNKNOWN;
-
-  /* No layer projection? Perform naive comparison, because they are
-  ** in the same projection. */
-  if( ! (layer->projection.numargs > 0) )
-    return msRectOverlap( &(map->extent), &(layer->extent) );
-
-  /* In the case where map and layer projections are identical, and the */
-  /* bounding boxes don't cross the dateline, do simple rectangle comparison */
-  if( map->extent.minx < map->extent.maxx &&
-      layer->extent.minx < layer->extent.maxx &&
-      !msProjectionsDiffer(&(map->projection), &(layer->projection)) ) {
-    return msRectOverlap( &(map->extent), &(layer->extent) );
-  }
-
-  /* We need to transform our rectangles for comparison,
-  ** so we will work with copies and leave the originals intact. */
-  MS_COPYRECT(&map_extent, &(map->extent) );
-  MS_COPYRECT(&layer_extent, &(layer->extent) );
-
-  /* Transform map extents into geographics for comparison. */
-  if( msProjectRect(&(map->projection), &(map->latlon), &map_extent) )
-    return MS_UNKNOWN;
-
-  /* Transform layer extents into geographics for comparison. */
-  if( msProjectRect(&(layer->projection), &(map->latlon), &layer_extent) )
-    return MS_UNKNOWN;
-
-  /* Simple case? Return simple answer. */
-  if ( map_extent.minx < map_extent.maxx && layer_extent.minx < layer_extent.maxx )
-    return msRectOverlap( &(map_extent), &(layer_extent) );
-
-  /* Uh oh, one of the rects crosses the dateline!
-  ** Let someone else handle it. */
-  return MS_UNKNOWN;
-}
-
-/************************************************************************/
-/*                             msSmallMalloc()                          */
-/************************************************************************/
-
-/* Safe version of malloc(). This function is taken from gdal/cpl. */
-
-void *msSmallMalloc( size_t nSize )
-{
-  void        *pReturn;
-
-  if( MS_UNLIKELY(nSize == 0) )
-    return NULL;
-
-  pReturn = malloc( nSize );
-  if( MS_UNLIKELY(pReturn == NULL) ) {
-    msIO_fprintf(stderr, "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
-                 (long) nSize );
-    exit(1);
-  }
-
-  return pReturn;
-}
-
-/************************************************************************/
-/*                             msSmallRealloc()                         */
-/************************************************************************/
-
-/* Safe version of realloc(). This function is taken from gdal/cpl. */
-
-void * msSmallRealloc( void * pData, size_t nNewSize )
-{
-  void        *pReturn;
-
-  if ( MS_UNLIKELY(nNewSize == 0) )
-    return NULL;
-
-  pReturn = realloc( pData, nNewSize );
-
-  if( MS_UNLIKELY(pReturn == NULL) ) {
-    msIO_fprintf(stderr, "msSmallRealloc(): Out of memory allocating %ld bytes.\n",
-                 (long)nNewSize );
-    exit(1);
-  }
-
-  return pReturn;
-}
-
-/************************************************************************/
-/*                             msSmallCalloc()                         */
-/************************************************************************/
-
-/* Safe version of calloc(). This function is taken from gdal/cpl. */
-
-void *msSmallCalloc( size_t nCount, size_t nSize )
-{
-  void  *pReturn;
-
-  if( MS_UNLIKELY(nSize * nCount == 0) )
-    return NULL;
-
-  pReturn = calloc( nCount, nSize );
-  if( MS_UNLIKELY(pReturn == NULL) ) {
-    msIO_fprintf(stderr, "msSmallCalloc(): Out of memory allocating %ld bytes.\n",
-                 (long)(nCount*nSize));
-    exit(1);
-  }
-
-  return pReturn;
-}
-
-/*
-** msBuildOnlineResource()
-**
-** Try to build the online resource (mapserv URL) for this service.
-** "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?"
-** (+append the map=... param if it was explicitly passed in QUERY_STRING)
-**
-** Returns a newly allocated string that should be freed by the caller or
-** NULL in case of error.
-*/
-char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req)
-{
-  (void)map;
-  char *online_resource = NULL;
-  const char *value, *hostname, *port, *script, *protocol="http", *mapparam=NULL;
-  char **hostname_array = NULL;
-  int mapparam_len = 0, hostname_array_len = 0;
-
-  hostname = getenv("HTTP_X_FORWARDED_HOST");
-  if(!hostname)
-    hostname = getenv("SERVER_NAME");
-  else {
-    if(strchr(hostname,',')) {
-      hostname_array = msStringSplit(hostname,',', &hostname_array_len);
-      hostname = hostname_array[0];
-    }
-  }
-
-  port = getenv("HTTP_X_FORWARDED_PORT");
-  if(!port)
-    port = getenv("SERVER_PORT");
-
-  script = getenv("SCRIPT_NAME");
-
-  /* HTTPS is set by Apache to "on" in an HTTPS server ... if not set */
-  /* then check SERVER_PORT: 443 is the default https port. */
-  if ( ((value=getenv("HTTPS")) && strcasecmp(value, "on") == 0) ||
-       ((value=getenv("SERVER_PORT")) && atoi(value) == 443) ) {
-    protocol = "https";
-  }
-  if ( (value=getenv("HTTP_X_FORWARDED_PROTO")) ) {
-    protocol = value;
-  }
-
-  /* If map=.. was explicitly set then we'll include it in onlineresource
-   */
-  if (req->type == MS_GET_REQUEST) {
-    int i;
-    for(i=0; i<req->NumParams; i++) {
-      if (strcasecmp(req->ParamNames[i], "map") == 0) {
-        mapparam = req->ParamValues[i];
-        mapparam_len = strlen(mapparam)+5; /* +5 for "map="+"&" */
-        break;
-      }
-    }
-  }
-
-  if (hostname && port && script) {
-    size_t buffer_size;
-    buffer_size = strlen(hostname)+strlen(port)+strlen(script)+mapparam_len+11; /* 11 comes from https://[host]:[port][scriptname]?[map]\0, i.e. "https://:?\0" */
-    online_resource = (char*)msSmallMalloc(buffer_size);
-    if ((atoi(port) == 80 && strcmp(protocol, "http") == 0) ||
-        (atoi(port) == 443 && strcmp(protocol, "https") == 0) )
-      snprintf(online_resource, buffer_size, "%s://%s%s?", protocol, hostname, script);
-    else
-      snprintf(online_resource, buffer_size, "%s://%s:%s%s?", protocol, hostname, port, script);
-
-    if (mapparam) {
-      int baselen;
-      baselen = strlen(online_resource);
-      snprintf(online_resource+baselen, buffer_size-baselen, "map=%s&", mapparam);
-    }
-  } else {
-    msSetError(MS_CGIERR, "Impossible to establish server URL.", "msBuildOnlineResource()");
-    return NULL;
-  }
-  if(hostname_array) {
-    msFreeCharArray(hostname_array, hostname_array_len);
-  }
-
-  return online_resource;
-}
-
-
-/************************************************************************/
-/*                             msIntegerInArray()                        */
-/************************************************************************/
-
-/* Check if a integer is in a array */
-int msIntegerInArray(const int value, int *array, int numelements)
-{
-  int i;
-  for (i=0; i<numelements; ++i) {
-    if (value == array[i])
-      return MS_TRUE;
-  }
-  return MS_FALSE;
-}
-
-
-/************************************************************************
- *                            msMapSetProjections                       *
- *                                                                      *
- *   Ensure that all the layers in the map file have a projection       *
- *   by copying the map-level projection to all layers than have no     *
- *   projection.                                                        *
- ************************************************************************/
-
-int msMapSetLayerProjections(mapObj* map)
-{
-
-  char *mapProjStr = NULL;
-  int i;
-
-  if (map->projection.numargs <= 0) {
-    msSetError(MS_WMSERR, "Cannot set new SRS on a map that doesn't "
-               "have any projection set. Please make sure your mapfile "
-               "has a PROJECTION defined at the top level.",
-               "msTileSetProjectionst()");
-    return(MS_FAILURE);
-  }
-
-  for(i=0; i<map->numlayers; i++) {
-    layerObj *lp = GET_LAYER(map,i);
-    /* This layer is turned on and needs a projection? */
-    if (lp->projection.numargs <= 0 &&
-        lp->status != MS_OFF &&
-        lp->transform == MS_TRUE) {
-
-      /* Fetch main map projection string only now that we need it */
-      if (mapProjStr == NULL)
-        mapProjStr = msGetProjectionString(&(map->projection));
-
-      /* Set the projection to the map file projection */
-      if (msLoadProjectionString(&(lp->projection), mapProjStr) != 0) {
-        msSetError(MS_CGIERR, "Unable to set projection on layer.", "msMapSetLayerProjections()");
-        return(MS_FAILURE);
-      }
-      lp->project = MS_TRUE;
-      if(lp->connection && IS_THIRDPARTY_LAYER_CONNECTIONTYPE(lp->connectiontype)) {
-        char **reflayers;
-        int numreflayers,j;
-        reflayers = msStringSplit(lp->connection,',',&numreflayers);
-        for(j=0; j<numreflayers; j++) {
-          int *lidx, nlidx;
-          /* first check layers referenced by group name */
-          lidx = msGetLayersIndexByGroup(map, reflayers[i], &nlidx);
-          if(lidx) {
-            int k;
-            for(k=0; k<nlidx; k++) {
-              layerObj *glp = GET_LAYER(map,lidx[k]);
-              if (glp->projection.numargs <= 0 && glp->transform == MS_TRUE) {
-
-                /* Set the projection to the map file projection */
-                if (msLoadProjectionString(&(glp->projection), mapProjStr) != 0) {
-                  msSetError(MS_CGIERR, "Unable to set projection on layer.", "msMapSetLayerProjections()");
-                  return(MS_FAILURE);
-                }
-                glp->project = MS_TRUE;
-              }
-            }
-            free(lidx);
-          } else {
-            /* group name did not match, check by layer name */
-            int layer_idx = msGetLayerIndex(map,lp->connection);
-            layerObj *glp = GET_LAYER(map,layer_idx);
-            if (glp->projection.numargs <= 0 && glp->transform == MS_TRUE) {
-
-              /* Set the projection to the map file projection */
-              if (msLoadProjectionString(&(glp->projection), mapProjStr) != 0) {
-                msSetError(MS_CGIERR, "Unable to set projection on layer.", "msMapSetLayerProjections()");
-                return(MS_FAILURE);
-              }
-              glp->project = MS_TRUE;
-            }
-          }
-        }
-        msFreeCharArray(reflayers, numreflayers);
-      }
-    }
-  }
-  msFree(mapProjStr);
-  return(MS_SUCCESS);
-}
-
-
-/************************************************************************
- *                    msMapSetLanguageSpecificConnection                *
- *                                                                      *
- *   Override DATA and CONNECTION of each layer with their specific     *
- *  variant for the specified language.                                 *
- ************************************************************************/
-
-void msMapSetLanguageSpecificConnection(mapObj* map, const char* validated_language)
-{
-    int i;
-    for(i=0; i<map->numlayers; i++) {
-      layerObj *layer = GET_LAYER(map, i);
-      if(layer->data) layer->data = msCaseReplaceSubstring(layer->data, "%language%", validated_language);
-      if(layer->connection) layer->connection = msCaseReplaceSubstring(layer->connection, "%language%", validated_language);
-    }
-}
-
-/* Generalize a shape based of the tolerance.
-   Ref: http://trac.osgeo.org/gdal/ticket/966 */
-shapeObj* msGeneralize(shapeObj *shape, double tolerance)
-{
-  lineObj newLine = {0,NULL};
-  const double sqTolerance = tolerance*tolerance;
-
-  shapeObj* newShape = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
-  msInitShape(newShape);
-  msCopyShape(shape, newShape);
-
-  if (shape->numlines<1)
-    return newShape;
-
-  /* Clean shape */
-  for (int i=0; i < newShape->numlines; i++)
-    free(newShape->line[i].point);
-  newShape->numlines = 0;
-  if (newShape->line) free(newShape->line);
-
-  msAddLine(newShape, &newLine);
-
-  if (shape->line[0].numpoints==0) {
-    return newShape;
-  }
-
-  msAddPointToLine(&newShape->line[0],
-                   &shape->line[0].point[0]);
-  double dX0 = shape->line[0].point[0].x;
-  double dY0 = shape->line[0].point[0].y;
-
-  for(int i=1; i<shape->line[0].numpoints; i++)
-  {
-      double dX1 = shape->line[0].point[i].x;
-      double dY1 = shape->line[0].point[i].y;
-
-      const double dX = dX1-dX0;
-      const double dY = dY1-dY0;
-      const double dSqDist = dX*dX + dY*dY;
-      if (i == shape->line[0].numpoints-1 || dSqDist >= sqTolerance)
-      {
-          pointObj p;
-          p.x = dX1;
-          p.y = dY1;
-
-          /* Keep this point (always keep the last point) */
-          msAddPointToLine(&newShape->line[0],
-                           &p);
-          dX0 = dX1;
-          dY0 = dY1;
-        }
-    }
-
-  return newShape;
-}
-
-void msSetLayerOpacity(layerObj *layer, int opacity) {
-  if(!layer->compositer) {
-    layer->compositer = msSmallMalloc(sizeof(LayerCompositer));
-    initLayerCompositer(layer->compositer);
-  }
-  layer->compositer->opacity = opacity;
-}
diff -pruN 8.0.1-5/mapuvraster.c 8.2.0~beta1-1~exp1/mapuvraster.c
--- 8.0.1-5/mapuvraster.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapuvraster.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1077 +0,0 @@
-/**********************************************************************
- * $Id: mapuv.c 12629 2011-10-06 18:06:34Z aboudreault $
- *
- * Project:  MapServer
- * Purpose:  UV Layer
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2011, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include "mapserver.h"
-
-#include <assert.h>
-#include <math.h>
-#include "mapows.h"
-#include "mapresample.h"
-#include "mapthread.h"
-
-#define MSUVRASTER_NUMITEMS        6
-#define MSUVRASTER_ANGLE    "uv_angle"
-#define MSUVRASTER_ANGLEINDEX   -100
-#define MSUVRASTER_MINUS_ANGLE    "uv_minus_angle"
-#define MSUVRASTER_MINUSANGLEINDEX   -101
-#define MSUVRASTER_LENGTH    "uv_length"
-#define MSUVRASTER_LENGTHINDEX   -102
-#define MSUVRASTER_LENGTH_2    "uv_length_2"
-#define MSUVRASTER_LENGTH2INDEX   -103
-#define MSUVRASTER_U    "u"
-#define MSUVRASTER_UINDEX   -104
-#define MSUVRASTER_V    "v"
-#define MSUVRASTER_VINDEX   -105
-
-#define RQM_UNKNOWN               0
-#define RQM_ENTRY_PER_PIXEL       1
-#define RQM_HIST_ON_CLASS         2
-#define RQM_HIST_ON_VALUE         3
-
-typedef struct {
-
-  /* query cache results */
-  int query_results;
-  /* int query_alloc_max;
-  int query_request_max;
-  int query_result_hard_max;
-  int raster_query_mode; */
-  int band_count;
-
-  int refcount;
-
-  /* query bound in force
-     shapeObj *searchshape;*/
-
-  /* Only nearest result to this point.
-  int      range_mode; MS_QUERY_SINGLE, MS_QUERY_MULTIPLE or -1 (skip test)
-  double   range_dist;
-  pointObj target_point;*/
-
-  /* double   shape_tolerance; */
-
-  float **u; /* u values */
-  float **v; /* v values */
-  int width;
-  int height;
-  rectObj extent;
-  int     next_shape;
-  int x, y; /* used internally in msUVRasterLayerNextShape() */
-
-  mapObj* mapToUseForWhichShapes; /* set if the map->extent and map->projection are valid in msUVRASTERLayerWhichShapes() */
-
-} uvRasterLayerInfo;
-
-void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj* layer,
-                                                                mapObj* map)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-  uvlinfo->mapToUseForWhichShapes = map;
-}
-
-static int msUVRASTERLayerInitItemInfo(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-  int   i;
-  int *itemindexes;
-  int failed=0;
-
-  if (layer->numitems == 0)
-    return MS_SUCCESS;
-
-  if( uvlinfo == NULL ) {
-    msSetError(MS_MISCERR, "Assertion failed: GDAL layer not opened!!!",
-               "msUVRASTERLayerInitItemInfo()");
-    return(MS_FAILURE);
-  }
-
-  if (layer->iteminfo)
-    free(layer->iteminfo);
-
-  if((layer->iteminfo = (int *)malloc(sizeof(int)*layer->numitems))== NULL) {
-    msSetError(MS_MEMERR, NULL, "msUVRASTERLayerInitItemInfo()");
-    return(MS_FAILURE);
-  }
-
-  itemindexes = (int*)layer->iteminfo;
-  for(i=0; i<layer->numitems; i++) {
-    /* Special case for handling text string and angle coming from */
-    /* OGR style strings.  We use special attribute snames. */
-    if (EQUAL(layer->items[i], MSUVRASTER_ANGLE))
-      itemindexes[i] = MSUVRASTER_ANGLEINDEX;
-    else if (EQUAL(layer->items[i], MSUVRASTER_MINUS_ANGLE))
-      itemindexes[i] = MSUVRASTER_MINUSANGLEINDEX;
-    else if (EQUAL(layer->items[i], MSUVRASTER_LENGTH))
-      itemindexes[i] = MSUVRASTER_LENGTHINDEX;
-    else if (EQUAL(layer->items[i], MSUVRASTER_LENGTH_2))
-      itemindexes[i] = MSUVRASTER_LENGTH2INDEX;
-    else if (EQUAL(layer->items[i], MSUVRASTER_U))
-      itemindexes[i] = MSUVRASTER_UINDEX;
-    else if (EQUAL(layer->items[i], MSUVRASTER_V))
-      itemindexes[i] = MSUVRASTER_VINDEX;
-    else {
-      itemindexes[i] = -1;
-      msSetError(MS_OGRERR,
-                 "Invalid Field name: %s",
-                 "msUVRASTERLayerInitItemInfo()",
-                 layer->items[i]);
-      failed=1;
-    }
-  }
-
-  return failed ? (MS_FAILURE) : (MS_SUCCESS);
-}
-
-
-void msUVRASTERLayerFreeItemInfo(layerObj *layer)
-{
-  if (layer->iteminfo)
-    free(layer->iteminfo);
-  layer->iteminfo = NULL;
-}
-
-static void msUVRasterLayerInfoInitialize(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-
-  if( uvlinfo != NULL )
-    return;
-
-  uvlinfo = (uvRasterLayerInfo *) msSmallCalloc(1,sizeof(uvRasterLayerInfo));
-  layer->layerinfo = uvlinfo;
-
-  uvlinfo->band_count = -1;
-  /* uvlinfo->raster_query_mode = RQM_ENTRY_PER_PIXEL; */
-  /* uvlinfo->range_mode = -1; /\* inactive *\/ */
-  /* uvlinfo->refcount = 0; */
-  /* uvlinfo->shape_tolerance = 0.0; */
-  uvlinfo->u = NULL;
-  uvlinfo->v = NULL;
-  uvlinfo->width = 0;
-  uvlinfo->height = 0;
-
-  /* Set attribute type to Real, unless the user has explicitly set */
-  /* something else. */
-  {
-      const char* const items[] = {
-          MSUVRASTER_ANGLE,
-          MSUVRASTER_MINUS_ANGLE,
-          MSUVRASTER_LENGTH,
-          MSUVRASTER_LENGTH_2,
-          MSUVRASTER_U,
-          MSUVRASTER_V,
-      };
-      size_t i;
-      for( i = 0; i < sizeof(items)/sizeof(items[0]); ++i ) {
-          char szTmp[100];
-          snprintf(szTmp, sizeof(szTmp), "%s_type", items[i]);
-          if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
-              snprintf(szTmp, sizeof(szTmp), "gml_%s_type", items[i]);
-              msInsertHashTable(&(layer->metadata), szTmp, "Real");
-          }
-      }
-  }
-
-  /* uvlinfo->query_result_hard_max = 1000000; */
-
-  /* if( CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" )  */
-  /*     != NULL ) */
-  /* { */
-  /*     uvlinfo->query_result_hard_max =  */
-  /*         atoi(CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" )); */
-  /* } */
-}
-
-static void msUVRasterLayerInfoFree( layerObj *layer )
-
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-  int i;
-
-  if( uvlinfo == NULL )
-    return;
-
-  if (uvlinfo->u) {
-    for (i=0; i<uvlinfo->width; ++i) {
-      free(uvlinfo->u[i]);
-    }
-    free(uvlinfo->u);
-  }
-
-  if (uvlinfo->v) {
-    for (i=0; i<uvlinfo->width; ++i) {
-      free(uvlinfo->v[i]);
-    }
-    free(uvlinfo->v);
-  }
-
-  free( uvlinfo );
-
-  layer->layerinfo = NULL;
-}
-
-int msUVRASTERLayerOpen(layerObj *layer)
-{
-  /* If we don't have info, initialize an empty one now */
-  if( layer->layerinfo == NULL )
-    msUVRasterLayerInfoInitialize( layer );
-  if( layer->layerinfo == NULL )
-    return MS_FAILURE;
-
-  uvRasterLayerInfo* uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-
-  uvlinfo->refcount = uvlinfo->refcount + 1;
-
-  return MS_SUCCESS;
-}
-
-int msUVRASTERLayerIsOpen(layerObj *layer)
-{
-  if (layer->layerinfo)
-    return MS_TRUE;
-  return MS_FALSE;
-}
-
-
-int msUVRASTERLayerClose(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-
-  if( uvlinfo != NULL ) {
-    uvlinfo->refcount--;
-
-    if( uvlinfo->refcount < 1 )
-      msUVRasterLayerInfoFree( layer );
-  }
-  return MS_SUCCESS;
-}
-
-int msUVRASTERLayerGetItems(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-
-  if( uvlinfo == NULL )
-    return MS_FAILURE;
-
-  layer->numitems = 0;
-  layer->items = (char **) msSmallCalloc(sizeof(char *),10);;
-
-  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_ANGLE);
-  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_MINUS_ANGLE);
-  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_LENGTH);
-  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_LENGTH_2);
-  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_U);
-  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_V);
-  layer->items[layer->numitems] = NULL;
-
-  return msUVRASTERLayerInitItemInfo(layer);
-}
-
-/**********************************************************************
- *                     msUVRASTERGetValues()
- *
- * Special attribute names are used to return some UV params: uv_angle,
- * uv_length, u and v.
- **********************************************************************/
-static char **msUVRASTERGetValues(layerObj *layer, float *u, float *v)
-{
-  char **values;
-  int i = 0;
-  char tmp[100];
-  float size_scale;
-  int *itemindexes = (int*)layer->iteminfo;
-
-  if(layer->numitems == 0)
-    return(NULL);
-
-  if(!layer->iteminfo) { /* Should not happen... but just in case! */
-    if (msUVRASTERLayerInitItemInfo(layer) != MS_SUCCESS)
-      return NULL;
-    itemindexes = (int*)layer->iteminfo; /* reassign after malloc */
-  }
-
-  if((values = (char **)malloc(sizeof(char *)*layer->numitems)) == NULL) {
-    msSetError(MS_MEMERR, NULL, "msUVRASTERGetValues()");
-    return(NULL);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*    Determine desired size_scale.  Default to 1 if not otherwise set  */
-  /* -------------------------------------------------------------------- */
-  size_scale = 1;
-  if( CSLFetchNameValue( layer->processing, "UV_SIZE_SCALE" ) != NULL ) {
-    size_scale =
-      atof(CSLFetchNameValue( layer->processing, "UV_SIZE_SCALE" ));
-  }
-
-  for(i=0; i<layer->numitems; i++) {
-    if (itemindexes[i] == MSUVRASTER_ANGLEINDEX) {
-      snprintf(tmp, 100, "%f", (atan2((double)*v, (double)*u) * 180 / MS_PI));
-      values[i] = msStrdup(tmp);
-    } else if (itemindexes[i] == MSUVRASTER_MINUSANGLEINDEX) {
-      double minus_angle;
-      minus_angle = (atan2((double)*v, (double)*u) * 180 / MS_PI)+180;
-      if (minus_angle >= 360)
-        minus_angle -= 360;
-      snprintf(tmp, 100, "%f", minus_angle);
-      values[i] = msStrdup(tmp);
-    } else if ( (itemindexes[i] == MSUVRASTER_LENGTHINDEX) ||
-                (itemindexes[i] == MSUVRASTER_LENGTH2INDEX) ) {
-      float length = sqrt((*u**u)+(*v**v))*size_scale;
-
-      if (itemindexes[i] == MSUVRASTER_LENGTHINDEX)
-        snprintf(tmp, 100, "%f", length);
-      else
-        snprintf(tmp, 100, "%f", length/2);
-
-      values[i] = msStrdup(tmp);
-    } else if (itemindexes[i] == MSUVRASTER_UINDEX) {
-      snprintf(tmp, 100, "%f",*u);
-      values[i] = msStrdup(tmp);
-    } else if (itemindexes[i] == MSUVRASTER_VINDEX) {
-      snprintf(tmp, 100, "%f",*v);
-      values[i] = msStrdup(tmp);
-    } else {
-      values[i] = NULL;
-      }
-  }
-
-  return values;
-}
-
-rectObj msUVRASTERGetSearchRect( layerObj* layer, mapObj* map )
-{
-    rectObj searchrect = map->extent;
-    int bDone = MS_FALSE;
-
-    /* For UVRaster, it is important that the searchrect is not too large */
-    /* to avoid insufficient intermediate raster resolution, which could */
-    /* happen if we use the default code path, given potential reprojection */
-    /* issues when using a map extent that is not in the validity area of */
-    /* the layer projection. */
-    if( !layer->projection.gt.need_geotransform &&
-        !(msProjIsGeographicCRS(&(map->projection)) &&
-        msProjIsGeographicCRS(&(layer->projection))) ) {
-      rectObj layer_ori_extent;
-
-      if( msLayerGetExtent(layer, &layer_ori_extent) == MS_SUCCESS ) {
-        projectionObj map_proj;
-
-        double map_extent_minx = map->extent.minx;
-        double map_extent_miny = map->extent.miny;
-        double map_extent_maxx = map->extent.maxx;
-        double map_extent_maxy = map->extent.maxy;
-        rectObj layer_extent = layer_ori_extent;
-
-        /* Create a variant of map->projection without geotransform for */
-        /* conveniency */
-        msInitProjection(&map_proj);
-        msCopyProjection(&map_proj, &map->projection);
-        map_proj.gt.need_geotransform = MS_FALSE;
-        if( map->projection.gt.need_geotransform ) {
-            map_extent_minx = map->projection.gt.geotransform[0]
-                + map->projection.gt.geotransform[1] * map->extent.minx
-                + map->projection.gt.geotransform[2] * map->extent.miny;
-            map_extent_miny = map->projection.gt.geotransform[3]
-                + map->projection.gt.geotransform[4] * map->extent.minx
-                + map->projection.gt.geotransform[5] * map->extent.miny;
-            map_extent_maxx = map->projection.gt.geotransform[0]
-                + map->projection.gt.geotransform[1] * map->extent.maxx
-                + map->projection.gt.geotransform[2] * map->extent.maxy;
-            map_extent_maxy = map->projection.gt.geotransform[3]
-                + map->projection.gt.geotransform[4] * map->extent.maxx
-                + map->projection.gt.geotransform[5] * map->extent.maxy;
-        }
-
-        /* Reproject layer extent to map projection */
-        msProjectRect(&layer->projection, &map_proj, &layer_extent);
-
-        if( layer_extent.minx <= map_extent_minx &&
-            layer_extent.miny <= map_extent_miny &&
-            layer_extent.maxx >= map_extent_maxx &&
-            layer_extent.maxy >= map_extent_maxy ) {
-            /* do nothing special if area to map is inside layer extent */
-        }
-        else {
-            if( layer_extent.minx >= map_extent_minx &&
-                layer_extent.maxx <= map_extent_maxx &&
-                layer_extent.miny >= map_extent_miny &&
-                layer_extent.maxy <= map_extent_maxy ) {
-                /* if the area to map is larger than the layer extent, then */
-                /* use full layer extent and add some margin to reflect the */
-                /* proportion of the useful area over the requested bbox */
-                double extra_x =
-                (map_extent_maxx - map_extent_minx) /
-                    (layer_extent.maxx - layer_extent.minx) *
-                    (layer_ori_extent.maxx -  layer_ori_extent.minx);
-                double extra_y =
-                    (map_extent_maxy - map_extent_miny) /
-                    (layer_extent.maxy - layer_extent.miny) *
-                    (layer_ori_extent.maxy -  layer_ori_extent.miny);
-                searchrect.minx = layer_ori_extent.minx - extra_x / 2;
-                searchrect.maxx = layer_ori_extent.maxx + extra_x / 2;
-                searchrect.miny = layer_ori_extent.miny - extra_y / 2;
-                searchrect.maxy = layer_ori_extent.maxy + extra_y / 2;
-            }
-            else
-            {
-                /* otherwise clip the map extent with the reprojected layer */
-                /* extent */
-                searchrect.minx = MS_MAX( map_extent_minx, layer_extent.minx );
-                searchrect.maxx = MS_MIN( map_extent_maxx, layer_extent.maxx );
-                searchrect.miny = MS_MAX( map_extent_miny, layer_extent.miny );
-                searchrect.maxy = MS_MIN( map_extent_maxy, layer_extent.maxy );
-                /* and reproject into the layer projection */
-                msProjectRect(&map_proj, &layer->projection, &searchrect);
-            }
-            bDone = MS_TRUE;
-        }
-
-        msFreeProjection(&map_proj);
-      }
-    }
-
-    if( !bDone )
-      msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-
-    return searchrect;
-}
-
-int msUVRASTERLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-  imageObj *image_tmp;
-  outputFormatObj *outputformat = NULL;
-  mapObj *map_tmp;
-  double map_cellsize;
-  unsigned int spacing;
-  int width, height, u_src_off, v_src_off, i, x, y;
-  char   **alteredProcessing = NULL, *saved_layer_mask;
-  char **savedProcessing = NULL;
-  int bHasLonWrap = MS_FALSE;
-  double dfLonWrap = 0.0;
-  rectObj oldLayerExtent = {0};
-  char* oldLayerData = NULL;
-  projectionObj oldLayerProjection={0};
-  int ret;
-
-  if (layer->debug)
-    msDebug("Entering msUVRASTERLayerWhichShapes().\n");
-
-  if( uvlinfo == NULL )
-    return MS_FAILURE;
-
-  if( CSLFetchNameValue( layer->processing, "BANDS" ) == NULL ) {
-    msSetError( MS_MISCERR, "BANDS processing option is required for UV layer. You have to specified 2 bands.",
-                "msUVRASTERLayerWhichShapes()" );
-    return MS_FAILURE;
-  }
-  
-  /*
-  ** Allocate mapObj structure
-  */
-  map_tmp = (mapObj *)msSmallCalloc(sizeof(mapObj),1);
-  if(initMap(map_tmp) == -1) { /* initialize this map */
-    msFree(map_tmp);
-    return(MS_FAILURE);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Determine desired spacing.  Default to 32 if not otherwise set  */
-  /* -------------------------------------------------------------------- */
-  spacing = 32;
-  if( CSLFetchNameValue( layer->processing, "UV_SPACING" ) != NULL ) {
-    spacing =
-      atoi(CSLFetchNameValue( layer->processing, "UV_SPACING" ));
-    if( spacing == 0 )
-        spacing = 32;
-  }
-
-  width = (int)(layer->map->width/spacing);
-  height = (int)(layer->map->height/spacing);
-
-  /* Initialize our dummy map */
-  MS_INIT_COLOR(map_tmp->imagecolor, 255,255,255,255);
-  map_tmp->resolution = layer->map->resolution;
-  map_tmp->defresolution = layer->map->defresolution;
-
-  outputformat = (outputFormatObj *) msSmallCalloc(1,sizeof(outputFormatObj));
-  outputformat->bands = uvlinfo->band_count = 2;
-  outputformat->name = NULL;
-  outputformat->driver = NULL;
-  outputformat->refcount = 0;
-  outputformat->vtable = NULL;
-  outputformat->device = NULL;
-  outputformat->renderer = MS_RENDER_WITH_RAWDATA;
-  outputformat->imagemode = MS_IMAGEMODE_FLOAT32;
-  msAppendOutputFormat(map_tmp, outputformat);
-  
-  msCopyHashTable(&map_tmp->configoptions, &layer->map->configoptions);
-  map_tmp->mappath = msStrdup(layer->map->mappath);
-  map_tmp->shapepath = msStrdup(layer->map->shapepath);
-  map_tmp->gt.rotation_angle = 0.0;
-
-  /* Custom msCopyProjection() that removes lon_wrap parameter */
-  {
-    int i;
-
-    map_tmp->projection.numargs = 0;
-    map_tmp->projection.gt = layer->projection.gt;
-    map_tmp->projection.automatic = layer->projection.automatic;
-
-    for (i = 0; i < layer->projection.numargs; i++) {
-      if( strncmp(layer->projection.args[i], "lon_wrap=",
-                  strlen("lon_wrap=")) == 0 ) {
-        bHasLonWrap = MS_TRUE;
-        dfLonWrap = atof( layer->projection.args[i] + strlen("lon_wrap=") );
-      }
-      else {
-        map_tmp->projection.args[map_tmp->projection.numargs ++] =
-            msStrdup(layer->projection.args[i]);
-      }
-    }
-    if (map_tmp->projection.numargs != 0) {
-      msProcessProjection(&(map_tmp->projection));
-    }
-
-    map_tmp->projection.wellknownprojection = layer->projection.wellknownprojection;
-  }
-
-  /* Very special case to improve quality for rasters referenced from lon=0 to 360 */
-  /* We create a temporary VRT that swiches the 2 hemispheres, and then we */
-  /* modify the georeferncing to be in the more standard [-180, 180] range */
-  /* and we adjust the layer->data, extent and projection accordingly */
-  if( layer->tileindex == NULL &&
-      uvlinfo->mapToUseForWhichShapes && bHasLonWrap && dfLonWrap == 180.0 )
-  {
-      rectObj layerExtent;
-      msLayerGetExtent(layer, &layerExtent);
-      if( layerExtent.minx == 0 && layerExtent.maxx == 360 )
-      {
-          GDALDatasetH hDS = NULL;
-          char* decrypted_path;
-
-          if( strncmp(layer->data, "<VRTDataset", strlen("<VRTDataset")) == 0 )
-          {
-            decrypted_path = msStrdup(layer->data);
-          }
-          else
-          {
-            char szPath[MS_MAXPATHLEN];
-            msTryBuildPath3(szPath, layer->map->mappath,
-                            layer->map->shapepath, layer->data);
-            decrypted_path = msDecryptStringTokens( layer->map, szPath );
-          }
-
-          if( decrypted_path )
-          {
-              char** connectionoptions;
-              GDALAllRegister();
-              connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-              hDS = GDALOpenEx(decrypted_path,
-                                        GDAL_OF_RASTER,
-                                        NULL,
-                                        (const char* const*)connectionoptions,
-                                        NULL);
-              CSLDestroy(connectionoptions);
-          }
-          if( hDS != NULL )
-          {
-              int iBand;
-              int nXSize = GDALGetRasterXSize( hDS );
-              int nYSize = GDALGetRasterYSize( hDS );
-              int nBands = GDALGetRasterCount( hDS );
-              int nMaxLen = 100 + nBands * (800 + 2 * strlen(decrypted_path));
-              int nOffset = 0;
-              char* pszInlineVRT = msSmallMalloc( nMaxLen );
-
-              snprintf(pszInlineVRT, nMaxLen,
-                "<VRTDataset rasterXSize=\"%d\" rasterYSize=\"%d\">",
-                nXSize, nYSize);
-              nOffset = strlen(pszInlineVRT);
-              for( iBand = 1; iBand <= nBands; iBand++ )
-              {
-                  const char* pszDataType = "Byte";
-                  switch( GDALGetRasterDataType(GDALGetRasterBand(hDS, iBand)) )
-                  {
-                      case GDT_Byte: pszDataType = "Byte"; break;
-                      case GDT_Int16: pszDataType = "Int16"; break;
-                      case GDT_UInt16: pszDataType = "UInt16"; break;
-                      case GDT_Int32: pszDataType = "Int32"; break;
-                      case GDT_UInt32: pszDataType = "UInt32"; break;
-                      case GDT_Float32: pszDataType = "Float32"; break;
-                      case GDT_Float64: pszDataType = "Float64"; break;
-                      default: break;
-                  }
-
-                  snprintf( pszInlineVRT + nOffset, nMaxLen - nOffset,
-                    "    <VRTRasterBand dataType=\"%s\" band=\"%d\">"
-                    "        <SimpleSource>"
-                    "            <SourceFilename relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
-                    "            <SourceBand>%d</SourceBand>"
-                    "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "        </SimpleSource>"
-                    "        <SimpleSource>"
-                    "            <SourceFilename relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
-                    "            <SourceBand>%d</SourceBand>"
-                    "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "        </SimpleSource>"
-                    "    </VRTRasterBand>",
-                    pszDataType, iBand,
-                    decrypted_path, iBand,
-                    nXSize / 2, 0, nXSize - nXSize / 2, nYSize,
-                    0,          0, nXSize - nXSize / 2, nYSize,
-                    decrypted_path, iBand,
-                    0,                   0, nXSize / 2, nYSize,
-                    nXSize - nXSize / 2, 0, nXSize / 2, nYSize );
-
-                  nOffset += strlen(pszInlineVRT + nOffset);
-              }
-              snprintf(pszInlineVRT + nOffset, nMaxLen - nOffset,
-                "</VRTDataset>");
-
-              oldLayerExtent = layer->extent;
-              oldLayerData = layer->data;
-              oldLayerProjection = layer->projection;
-              layer->extent.minx = -180;
-              layer->extent.maxx = 180;
-              layer->data = pszInlineVRT;
-              layer->projection = map_tmp->projection;
-
-
-              /* map_tmp->projection is actually layer->projection without lon_wrap */
-              rect = uvlinfo->mapToUseForWhichShapes->extent;
-              msProjectRect(&uvlinfo->mapToUseForWhichShapes->projection,
-                            &map_tmp->projection, &rect);
-              bHasLonWrap = MS_FALSE;
-
-              GDALClose(hDS);
-          }
-          msFree( decrypted_path );
-      }
-  }
-
-  if( isQuery )
-  {
-      /* For query mode, use layer->map->extent reprojected rather than */
-      /* the provided rect. Generic query code will filter returned features. */
-      rect = msUVRASTERGetSearchRect(layer, layer->map);
-  }
-
-  map_cellsize = MS_MAX(MS_CELLSIZE(rect.minx, rect.maxx,layer->map->width),
-                        MS_CELLSIZE(rect.miny,rect.maxy,layer->map->height));
-  map_tmp->cellsize = map_cellsize*spacing;
-  map_tmp->extent.minx = rect.minx-(0.5*map_cellsize)+(0.5*map_tmp->cellsize);
-  map_tmp->extent.miny = rect.miny-(0.5*map_cellsize)+(0.5*map_tmp->cellsize);
-  map_tmp->extent.maxx = map_tmp->extent.minx+((width-1)*map_tmp->cellsize);
-  map_tmp->extent.maxy = map_tmp->extent.miny+((height-1)*map_tmp->cellsize);
-
-  if( bHasLonWrap && dfLonWrap == 180.0) {
-    if( map_tmp->extent.minx >= 180 ) {
-      /* Request on the right half of the shifted raster (= western hemisphere) */
-      map_tmp->extent.minx -= 360;
-      map_tmp->extent.maxx -= 360;
-    }
-    else if( map_tmp->extent.maxx >= 180.0 ) {
-      /* Request spanning on the 2 hemispheres => drawing whole planet */
-      /* Take only into account vertical resolution, as horizontal one */
-      /* will be unreliable (assuming square pixels...) */
-      map_cellsize = MS_CELLSIZE(rect.miny,rect.maxy,layer->map->height);
-      map_tmp->cellsize = map_cellsize*spacing;
-
-      width = 360.0 / map_tmp->cellsize;
-      map_tmp->extent.minx = -180.0+(0.5*map_tmp->cellsize);
-      map_tmp->extent.maxx = 180.0-(0.5*map_tmp->cellsize);
-    }
-  }
-
-  if (layer->debug)
-    msDebug("msUVRASTERLayerWhichShapes(): width: %d, height: %d, cellsize: %g\n",
-            width, height, map_tmp->cellsize);
-
-  if (layer->debug == MS_DEBUGLEVEL_VVV)
-    msDebug("msUVRASTERLayerWhichShapes(): extent: %g %g %g %g\n",
-            map_tmp->extent.minx, map_tmp->extent.miny,
-            map_tmp->extent.maxx, map_tmp->extent.maxy);
-
-  /* important to use that function, to compute map
-     geotransform, used by the resampling*/
-   msMapSetSize(map_tmp, width, height);
-
-  if (layer->debug == MS_DEBUGLEVEL_VVV)
-    msDebug("msUVRASTERLayerWhichShapes(): geotransform: %g %g %g %g %g %g\n",
-            map_tmp->gt.geotransform[0], map_tmp->gt.geotransform[1],
-            map_tmp->gt.geotransform[2], map_tmp->gt.geotransform[3],
-            map_tmp->gt.geotransform[4], map_tmp->gt.geotransform[5]);
-
-  uvlinfo->extent = map_tmp->extent;
-
-  image_tmp = msImageCreate(width, height, map_tmp->outputformatlist[0],
-                            NULL, NULL, map_tmp->resolution, map_tmp->defresolution,
-                            &(map_tmp->imagecolor));
-
-  /* Default set to AVERAGE resampling */
-  if( CSLFetchNameValue( layer->processing, "RESAMPLE" ) == NULL ) {
-    alteredProcessing = CSLDuplicate( layer->processing );
-    alteredProcessing =
-      CSLSetNameValue( alteredProcessing, "RESAMPLE",
-                       "AVERAGE");
-    savedProcessing = layer->processing;
-    layer->processing = alteredProcessing;
-  }
-
-  /* disable masking at this level: we don't want to apply the mask at the raster level,
-   * it will be applied with the correct cellsize and image size in the vector rendering
-   * phase.
-   */
-  saved_layer_mask = layer->mask;
-  layer->mask = NULL;
-  ret = msDrawRasterLayerLow(map_tmp, layer, image_tmp, NULL );
-
-  /* restore layer attributes if we went through the above on-the-fly VRT */
-  if( oldLayerData )
-  {
-      msFree(layer->data);
-      layer->data = oldLayerData;
-      layer->extent = oldLayerExtent;
-      layer->projection = oldLayerProjection;
-  }
-
-  /* restore layer mask */
-  layer->mask = saved_layer_mask;
-
-  /* restore the saved processing */
-  if (alteredProcessing != NULL) {
-    layer->processing = savedProcessing;
-    CSLDestroy(alteredProcessing);
-  }
-
-  if( ret == MS_FAILURE) {
-    msSetError(MS_MISCERR, "Unable to draw raster data.", "msUVRASTERLayerWhichShapes()");
-
-    msFreeMap(map_tmp);
-    msFreeImage(image_tmp);
-
-    return MS_FAILURE;
-  }
-
-  /* free old query arrays */
-  if (uvlinfo->u) {
-    for (i=0; i<uvlinfo->width; ++i) {
-      free(uvlinfo->u[i]);
-    }
-    free(uvlinfo->u);
-  }
-
-  if (uvlinfo->v) {
-    for (i=0; i<uvlinfo->width; ++i) {
-      free(uvlinfo->v[i]);
-    }
-    free(uvlinfo->v);
-  }
-
-  /* Update our uv layer structure */
-  uvlinfo->width = width;
-  uvlinfo->height = height;
-  uvlinfo->query_results = width*height;
-
-  uvlinfo->u = (float **)msSmallMalloc(sizeof(float *)*width);
-  uvlinfo->v = (float **)msSmallMalloc(sizeof(float *)*width);
-
-  for (x = 0; x < width; ++x) {
-    uvlinfo->u[x] = (float *)msSmallMalloc(height * sizeof(float));
-    uvlinfo->v[x] = (float *)msSmallMalloc(height * sizeof(float));
-
-    for (y = 0; y < height; ++y) {
-      u_src_off = v_src_off = x + y * width;
-      v_src_off += width*height;
-
-      uvlinfo->u[x][y] = image_tmp->img.raw_float[u_src_off];
-      uvlinfo->v[x][y] = image_tmp->img.raw_float[v_src_off];
-
-      /* null vector? update the number of results  */
-      if (uvlinfo->u[x][y] == 0 && uvlinfo->v[x][y] == 0)
-        --uvlinfo->query_results;
-    }
-  }
-
-  msFreeImage(image_tmp); /* we do not need the imageObj anymore */
-  msFreeMap(map_tmp);
-
-  uvlinfo->next_shape = 0;
-
-  return MS_SUCCESS;
-}
-
-int msUVRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-  lineObj line ;
-  pointObj point;
-  int i, j, k, x=0, y=0;
-  long shapeindex = record->shapeindex;
-
-  msFreeShape(shape);
-  shape->type = MS_SHAPE_NULL;
-
-  if( shapeindex < 0 || shapeindex >= uvlinfo->query_results ) {
-    msSetError(MS_MISCERR,
-               "Out of range shape index requested.  Requested %ld\n"
-               "but only %d shapes available.",
-               "msUVRASTERLayerGetShape()",
-               shapeindex, uvlinfo->query_results );
-    return MS_FAILURE;
-  }
-
-  /* loop to the next non null vector */
-  k = 0;
-  for (i=0, x=-1; i<uvlinfo->width && k<=shapeindex; ++i, ++x) {
-    for (j=0, y=-1; j<uvlinfo->height && k<=shapeindex; ++j, ++k, ++y) {
-      if (uvlinfo->u[i][j] == 0 && uvlinfo->v[i][j] == 0)
-        --k;
-    }
-  }
-
-  point.x = Pix2Georef(x, 0, uvlinfo->width-1,
-                       uvlinfo->extent.minx, uvlinfo->extent.maxx, MS_FALSE);
-  point.y = Pix2Georef(y, 0, uvlinfo->height-1,
-                       uvlinfo->extent.miny, uvlinfo->extent.maxy, MS_TRUE);
-  if (layer->debug == MS_DEBUGLEVEL_VVV)
-    msDebug("msUVRASTERLayerWhichShapes(): shapeindex: %ld, x: %g, y: %g\n",
-            shapeindex, point.x, point.y);
-
-  point.m = 0.0;
-
-  shape->type = MS_SHAPE_POINT;
-  line.numpoints = 1;
-  line.point = &point;
-  msAddLine( shape, &line );
-  msComputeBounds( shape );
-
-  shape->numvalues = layer->numitems;
-  shape->values = msUVRASTERGetValues(layer, &uvlinfo->u[x][y], &uvlinfo->v[x][y]);
-  shape->index = shapeindex;
-  shape->resultindex = shapeindex;
-
-  return MS_SUCCESS;
-
-}
-
-int msUVRASTERLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-
-  if( uvlinfo->next_shape < 0
-      || uvlinfo->next_shape >= uvlinfo->query_results ) {
-    msFreeShape(shape);
-    shape->type = MS_SHAPE_NULL;
-    return MS_DONE;
-  } else {
-    resultObj record;
-
-    record.shapeindex = uvlinfo->next_shape++;
-    record.tileindex = 0;
-    record.classindex = record.resultindex = -1;
-
-    return msUVRASTERLayerGetShape( layer, shape, &record);
-  }
-}
-
-/************************************************************************/
-/*                       msUVRASTERLayerGetExtent()                     */
-/* Simple copy of the maprasterquery.c file. might change in the future */
-/************************************************************************/
-
-int msUVRASTERLayerGetExtent(layerObj *layer, rectObj *extent)
-
-{
-  char szPath[MS_MAXPATHLEN];
-  mapObj *map = layer->map;
-  shapefileObj *tileshpfile;
-
-  if( (!layer->data || strlen(layer->data) == 0)
-      && layer->tileindex == NULL) {
-    /* should we be issuing a specific error about not supporting
-       extents for tileindexed raster layers? */
-    return MS_FAILURE;
-  }
-
-  if( map == NULL )
-    return MS_FAILURE;
-
-  /* If the layer use a tileindex, return the extent of the tileindex shapefile/referenced layer */
-  if (layer->tileindex) {
-    const int tilelayerindex = msGetLayerIndex(map, layer->tileindex);
-    if(tilelayerindex != -1) /* does the tileindex reference another layer */
-      return msLayerGetExtent(GET_LAYER(map, tilelayerindex), extent);
-    else {
-      tileshpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
-      MS_CHECK_ALLOC(tileshpfile, sizeof(shapefileObj), MS_FAILURE);
-
-      if(msShapefileOpen(tileshpfile, "rb", msBuildPath3(szPath, map->mappath, map->shapepath, layer->tileindex), MS_TRUE) == -1)
-        if(msShapefileOpen(tileshpfile, "rb", msBuildPath(szPath, map->mappath, layer->tileindex), MS_TRUE) == -1)
-          return MS_FAILURE;
-
-      *extent = tileshpfile->bounds;
-      msShapefileClose(tileshpfile);
-      free(tileshpfile);
-      return MS_SUCCESS;
-    }
-  }
-
-  msTryBuildPath3(szPath, map->mappath, map->shapepath, layer->data);
-  char* decrypted_path = msDecryptStringTokens( map, szPath );
-  if( !decrypted_path )
-      return MS_FAILURE;
-
-  GDALAllRegister();
-
-  char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-  GDALDatasetH hDS = GDALOpenEx(decrypted_path,
-                                GDAL_OF_RASTER,
-                                NULL,
-                                (const char* const*)connectionoptions,
-                                NULL);
-  CSLDestroy(connectionoptions);
-  msFree( decrypted_path );
-  if( hDS == NULL ) {
-    return MS_FAILURE;
-  }
-
-  const int nXSize = GDALGetRasterXSize( hDS );
-  const int nYSize = GDALGetRasterYSize( hDS );
-  double adfGeoTransform[6] = {0};
-  const CPLErr eErr = GDALGetGeoTransform( hDS, adfGeoTransform );
-  if( eErr != CE_None ) {
-    GDALClose( hDS );
-    return MS_FAILURE;
-  }
-
-  /* If this appears to be an ungeoreferenced raster than flip it for
-     mapservers purposes. */
-  if( adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0 ) {
-    adfGeoTransform[5] = -1.0;
-    adfGeoTransform[3] = nYSize;
-  }
-
-  extent->minx = adfGeoTransform[0];
-  extent->maxy = adfGeoTransform[3];
-
-  extent->maxx = adfGeoTransform[0] + nXSize * adfGeoTransform[1];
-  extent->miny = adfGeoTransform[3] + nYSize * adfGeoTransform[5];
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                     msUVRASTERLayerSetTimeFilter()                   */
-/*                                                                      */
-/*      This function is actually just used in the context of           */
-/*      setting a filter on the tileindex for time based queries.       */
-/*      For instance via WMS requests.  So it isn't really related      */
-/*      to the "raster query" support at all.                           */
-/*                                                                      */
-/*      If a local shapefile tileindex is in use, we will set a         */
-/*      backtics filter (shapefile compatible).  If another layer is    */
-/*      being used as the tileindex then we will forward the            */
-/*      SetTimeFilter call to it.  If there is no tileindex in          */
-/*      place, we do nothing.                                           */
-/************************************************************************/
-
-int msUVRASTERLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                                 const char *timefield)
-{
-  int tilelayerindex;
-
-  /* -------------------------------------------------------------------- */
-  /*      If we don't have a tileindex the time filter has no effect.     */
-  /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL )
-    return MS_SUCCESS;
-
-  /* -------------------------------------------------------------------- */
-  /*      Find the tileindex layer.                                       */
-  /* -------------------------------------------------------------------- */
-  tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
-
-  /* -------------------------------------------------------------------- */
-  /*      If we are using a local shapefile as our tileindex (that is     */
-  /*      to say, the tileindex name is not of another layer), then we    */
-  /*      just install a backtics style filter on the raster layer.       */
-  /*      This is propogated to the "working layer" created for the       */
-  /*      tileindex by code in mapraster.c.                               */
-  /* -------------------------------------------------------------------- */
-  if( tilelayerindex == -1 )
-    return msLayerMakeBackticsTimeFilter( layer, timestring, timefield );
-
-  /* -------------------------------------------------------------------- */
-  /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
-  /*      method.                                                         */
-  /* -------------------------------------------------------------------- */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-  return msLayerSetTimeFilter( layer->GET_LAYER(map,tilelayerindex),
-                               timestring, timefield );
-}
-
-
-/************************************************************************/
-/*                msRASTERLayerInitializeVirtualTable()                 */
-/************************************************************************/
-
-int
-msUVRASTERLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerInitItemInfo = msUVRASTERLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msUVRASTERLayerFreeItemInfo;
-  layer->vtable->LayerOpen = msUVRASTERLayerOpen;
-  layer->vtable->LayerIsOpen = msUVRASTERLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msUVRASTERLayerWhichShapes;
-  layer->vtable->LayerNextShape = msUVRASTERLayerNextShape;
-  layer->vtable->LayerGetShape = msUVRASTERLayerGetShape;
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerClose = msUVRASTERLayerClose;
-  layer->vtable->LayerGetItems = msUVRASTERLayerGetItems;
-  layer->vtable->LayerGetExtent = msUVRASTERLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /* layer->vtable->LayerCloseConnection = msUVRASTERLayerClose; */
-  /* we use backtics for proper tileindex shapefile functioning */
-  layer->vtable->LayerSetTimeFilter = msUVRASTERLayerSetTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapv8.cpp 8.2.0~beta1-1~exp1/mapv8.cpp
--- 8.0.1-5/mapv8.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapv8.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,388 +0,0 @@
-/**********************************************************************
- *
- * Project:  MapServer
- * Purpose:  V8 JavaScript Engine Support
- * Author:   Alan Boudreault (aboudreault@mapgears.com)
- *
- **********************************************************************
- * Copyright (c) 2013, Alan Boudreault, MapGears
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- **********************************************************************/
-
-#include "mapserver-config.h"
-#ifdef USE_V8_MAPSCRIPT
-
-#include "mapserver.h"
-#include "v8_mapscript.h"
-
-/* This file could be refactored in the future to encapsulate the global
-   functions and internal use functions in a class. */
-
-/* Handler for Javascript Exceptions. Not exposed to JavaScript, used internally.
-   Most of the code from v8 shell example.
-*/
-void msV8ReportException(TryCatch* try_catch, const char *msg = "")
-{
-  HandleScope handle_scope;
-
-  if (!try_catch || !try_catch->HasCaught()) {
-    msSetError(MS_V8ERR, "%s.", "msV8ReportException()", msg);
-    return;
-  }
-
-  String::Utf8Value exception(try_catch->Exception());
-  const char* exception_string = *exception;
-  Handle<Message> message = try_catch->Message();
-  if (message.IsEmpty()) {
-    msSetError(MS_V8ERR, "Javascript Exception: %s.", "msV8ReportException()",
-               exception_string);
-  } else {
-    String::Utf8Value filename(message->GetScriptResourceName());
-    const char* filename_string = *filename;
-    int linenum = message->GetLineNumber();
-    msSetError(MS_V8ERR, "Javascript Exception: %s:%i: %s", "msV8ReportException()",
-               filename_string, linenum, exception_string);
-    String::Utf8Value sourceline(message->GetSourceLine());
-    const char* sourceline_string = *sourceline;
-    msSetError(MS_V8ERR, "Exception source line: %s", "msV8ReportException()",
-               sourceline_string);
-    String::Utf8Value stack_trace(try_catch->StackTrace());
-    if (stack_trace.length() > 0) {
-      const char* stack_trace_string = *stack_trace;
-      msSetError(MS_V8ERR, "Exception StackTrace: %s", "msV8ReportException()",
-                 stack_trace_string);
-    }
-  }
-}
-
-/* This function load a javascript file in memory. */
-static Handle<Value> msV8ReadFile(V8Context *v8context, const char *path)
-{
-  FILE* file = fopen(path, "rb");
-  if (file == NULL) {
-    char err[MS_MAXPATHLEN+21];
-    sprintf(err, "Error opening file: %s", path);
-    msV8ReportException(NULL, err);
-    return Handle<String>(String::New(""));
-  }
-
-  fseek(file, 0, SEEK_END);
-  int size = ftell(file);
-  rewind(file);
-
-  char* chars = new char[size + 1];
-  chars[size] = '\0';
-  for (int i = 0; i < size;) {
-    int read = static_cast<int>(fread(&chars[i], 1, size - i, file));
-    if (read == 0) {
-      delete [] chars;
-      fclose(file);
-      msDebug("msV8ReadFile: error while reading file '%s'\n", path);
-      return Undefined();
-    }
-    i += read;
-  }
-
-  fclose(file);
-  Handle<String> result = String::New(chars, size);
-  delete[] chars;
-  return result;
-}
-
-/* Returns a compiled javascript script. */
-static Handle<Script> msV8CompileScript(Handle<String> source, Handle<String> script_name)
-{
-  TryCatch try_catch;
-
-  if (source.IsEmpty() || source->Length() == 0) {
-    msV8ReportException(NULL, "No source to compile");
-    return Handle<Script>();
-  }
-
-  Handle<Script> script = Script::Compile(source, script_name);
-  if (script.IsEmpty() && try_catch.HasCaught()) {
-    msV8ReportException(&try_catch);
-  }
-
-  return script;
-}
-
-/* Runs a compiled script */
-static Handle<Value> msV8RunScript(Handle<Script> script)
-{
-  if (script.IsEmpty()) {
-    ThrowException(String::New("No script to run"));
-    return Handle<Value>();
-  }
-
-  TryCatch try_catch;
-  Handle<Value> result = script->Run();
-
-  if (result.IsEmpty() && try_catch.HasCaught()) {
-    msV8ReportException(&try_catch);
-  }
-
-  return result;
-}
-
-/* Execute a javascript file */
-static Handle<Value> msV8ExecuteScript(const char *path, int throw_exception = MS_FALSE)
-{
-  char fullpath[MS_MAXPATHLEN];
-  map<string, Persistent<Script> >::iterator it;
-  Isolate *isolate = Isolate::GetCurrent();
-  V8Context *v8context = (V8Context*)isolate->GetData();
-
-  /* construct the path */
-  msBuildPath(fullpath, v8context->paths.top().c_str(), path);
-  char *filepath = msGetPath((char*)fullpath);
-  v8context->paths.push(filepath);
-  free(filepath);
-
-  Handle<Script> script;
-  it = v8context->scripts.find(fullpath);
-  if (it == v8context->scripts.end()) {
-    Handle<Value> source = msV8ReadFile(v8context, fullpath);
-    Handle<String> script_name = String::New(msStripPath((char*)path));
-    script = msV8CompileScript(source->ToString(), script_name);
-    if (script.IsEmpty()) {
-      v8context->paths.pop();
-      if (throw_exception) {
-        return ThrowException(String::New("Error compiling script"));
-      }
-    }
-    /* cache the compiled script */
-    Persistent<Script> pscript;
-    pscript.Reset(isolate, script);
-    v8context->scripts[fullpath] = pscript;
-  } else {
-    script = v8context->scripts[fullpath];
-  }
-
-  Handle<Value> result = msV8RunScript(script);
-  v8context->paths.pop();
-  if (result.IsEmpty() && throw_exception) {
-    return ThrowException(String::New("Error running script"));
-  }
-
-  return result;
-}
-
-/* END OF INTERNAL JAVASCRIPT FUNCTIONS */
-
-/* JAVASCRIPT EXPOSED FUNCTIONS */
-
-/* JavaScript Function to load javascript dependencies.
-   Exposed to JavaScript as 'require()'. */
-static Handle<Value> msV8Require(const Arguments& args)
-{
-  TryCatch try_catch;
-
-  for (int i = 0; i < args.Length(); i++) {
-    String::Utf8Value filename(args[i]);
-    msV8ExecuteScript(*filename, MS_TRUE);
-    if (try_catch.HasCaught()) {
-      return try_catch.ReThrow();
-    }
-  }
-
-  return Undefined();
-}
-
-/* Javascript Function print: print to debug file.
-   Exposed to JavaScript as 'print()'. */
-static Handle<Value> msV8Print(const Arguments& args)
-{
-  for (int i = 0; i < args.Length(); i++) {
-    String::Utf8Value str(args[i]);
-    msDebug("msV8Print: %s\n", *str);
-  }
-
-  return Undefined();
-}
-
-/* END OF JAVASCRIPT EXPOSED FUNCTIONS */
-
-/* Create and return a v8 context. Thread safe. */
-void msV8CreateContext(mapObj *map)
-{
-
-  Isolate *isolate = Isolate::GetCurrent();
-  Isolate::Scope isolate_scope(isolate);
-  HandleScope handle_scope(isolate);
-
-  V8Context *v8context = new V8Context(isolate);
-
-  Handle<ObjectTemplate> global_templ = ObjectTemplate::New();
-  global_templ->Set(String::New("require"), FunctionTemplate::New(msV8Require));
-  global_templ->Set(String::New("print"), FunctionTemplate::New(msV8Print));
-  global_templ->Set(String::New("alert"), FunctionTemplate::New(msV8Print));
-
-  Handle<Context> context_ = Context::New(v8context->isolate, NULL, global_templ);
-  v8context->context.Reset(v8context->isolate, context_);
-
-  /* we have to enter the context before getting global instance */
-  Context::Scope context_scope(context_);
-  Handle<Object> global = context_->Global();
-  Shape::Initialize(global);
-  Point::Initialize(global);
-  Line::Initialize(global);
-
-  v8context->paths.push(map->mappath);
-  v8context->isolate->SetData(v8context);
-  v8context->layer = NULL;
-
-  map->v8context = (void*)v8context;
-}
-
-void msV8ContextSetLayer(mapObj *map, layerObj *layer)
-{
-  V8Context* v8context = V8CONTEXT(map);
-
-  if (!v8context) {
-    msSetError(MS_V8ERR, "V8 Persistent Context is not created.", "msV8ContextSetLayer()");
-    return;
-  }
-
-  v8context->layer = layer;
-}
-
-static void msV8FreeContextScripts(V8Context *v8context)
-{
-  map<string, Persistent<Script> >::iterator it;
-  for(it=v8context->scripts.begin(); it!=v8context->scripts.end(); ++it)
-  {
-    ((*it).second).Dispose();
-  }
-}
-
-void msV8FreeContext(mapObj *map)
-{
-  V8Context* v8context = V8CONTEXT(map);
-  Shape::Dispose();
-  Point::Dispose();
-  Line::Dispose();
-  msV8FreeContextScripts(v8context);
-  v8context->context.Dispose();
-  delete v8context;
-}
-
-/* Create a V8 execution context, execute a script and return the feature
- * style. */
-char* msV8GetFeatureStyle(mapObj *map, const char *filename, layerObj *layer, shapeObj *shape)
-{
-  TryCatch try_catch;
-  V8Context* v8context = V8CONTEXT(map);
-  char *ret = NULL;
-    
-  if (!v8context) {
-    msSetError(MS_V8ERR, "V8 Persistent Context is not created.", "msV8ReportException()");
-    return NULL;
-  }
-
-  Isolate::Scope isolate_scope(v8context->isolate);
-  HandleScope handle_scope(v8context->isolate);
-
-  /* execution context */
-  Local<Context> context = Local<Context>::New(v8context->isolate, v8context->context);
-  Context::Scope context_scope(context);
-  Handle<Object> global = context->Global();
-
-  Shape *shape_ = new Shape(shape);
-  shape_->setLayer(layer); // hack to set the attribute names, should change in future.
-  shape_->disableMemoryHandler(); /* the internal object should not be freed by the v8 GC */
-  Handle<Value> ext = External::New(shape_);
-  global->Set(String::New("shape"),
-              Shape::Constructor()->NewInstance(1, &ext));
-  
-  msV8ExecuteScript(filename);
-  Handle<Value> value = global->Get(String::New("styleitem"));
-  if (value->IsUndefined()) {
-    msDebug("msV8GetFeatureStyle: Function 'styleitem' is missing.\n");
-    return ret;
-  }
-  Handle<Function> func = Handle<Function>::Cast(value);
-  Handle<Value> result = func->Call(global, 0, 0);
-  if (result.IsEmpty() && try_catch.HasCaught()) {
-    msV8ReportException(&try_catch);
-  }
-
-  if (!result.IsEmpty() && !result->IsUndefined()) {
-     String::AsciiValue ascii(result);
-     ret = msStrdup(*ascii);
-  }
-
-  return ret;
-}
-
-/* for geomtransform, we don't have the mapObj */
-shapeObj *msV8TransformShape(shapeObj *shape, const char* filename)
-{
-  TryCatch try_catch;
-  Isolate *isolate = Isolate::GetCurrent();
-  V8Context *v8context = (V8Context*)isolate->GetData();
-
-  HandleScope handle_scope(v8context->isolate);
-
-  /* execution context */
-  Local<Context> context = Local<Context>::New(v8context->isolate, v8context->context);
-  Context::Scope context_scope(context);
-  Handle<Object> global = context->Global();
-
-  Shape* shape_ = new Shape(shape);
-  shape_->setLayer(v8context->layer);
-  shape_->disableMemoryHandler();
-  Handle<Value> ext = External::New(shape_);
-  global->Set(String::New("shape"),
-              Shape::Constructor()->NewInstance(1, &ext));
-
-  msV8ExecuteScript(filename);
-  Handle<Value> value = global->Get(String::New("geomtransform"));
-  if (value->IsUndefined()) {
-    msDebug("msV8TransformShape: Function 'geomtransform' is missing.\n");
-    return NULL;
-  }
-  Handle<Function> func = Handle<Function>::Cast(value);
-  Handle<Value> result = func->Call(global, 0, 0);
-  if (result.IsEmpty() && try_catch.HasCaught()) {
-    msV8ReportException(&try_catch);
-  }
-
-  if (!result.IsEmpty() && result->IsObject()) {
-    Handle<Object> obj = result->ToObject();
-    if (obj->GetConstructorName()->Equals(String::New("shapeObj"))) {
-      Shape* new_shape = ObjectWrap::Unwrap<Shape>(result->ToObject());
-      if (shape == new_shape->get()) {
-        shapeObj *new_shape_ = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
-        msInitShape(new_shape_);
-        msCopyShape(shape, new_shape_);
-        return new_shape_;
-      }
-      else {
-        new_shape->disableMemoryHandler();
-        return new_shape->get();
-      }
-    }
-  }
-
-  return NULL;
-}
-
-#endif /* USE_V8_MAPSCRIPT */
diff -pruN 8.0.1-5/mapwcs.cpp 8.2.0~beta1-1~exp1/mapwcs.cpp
--- 8.0.1-5/mapwcs.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwcs.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,3254 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OpenGIS Web Coverage Server (WCS) Implementation.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapthread.h"
-#include "mapows.h"
-#include <assert.h>
-
-#include <map>
-#include <string>
-
-#if defined(USE_WCS_SVR)
-
-#include "mapwcs.h"
-
-#include "maptime.h"
-#include <time.h>
-
-#include "gdal.h"
-#include "cpl_string.h" /* GDAL string handling */
-
-/************************************************************************/
-/*                    msWCSValidateRangeSetParam()                      */
-/************************************************************************/
-static int msWCSValidateRangeSetParam(layerObj *lp, char *name, const char *value)
-{
-  char **allowed_ri_values;
-  char **client_ri_values;
-  int  allowed_count, client_count;
-  int  i_client, i, all_match = 1;
-  char *tmpname = NULL;
-  const char *ri_values_list;
-
-  if( name == NULL )
-    return MS_FAILURE;
-
-  /* Fetch the available values list for the rangeset item and tokenize */
-  tmpname = (char *)msSmallMalloc(sizeof(char)*strlen(name) + 10);
-  sprintf(tmpname,"%s_values", name);
-  ri_values_list = msOWSLookupMetadata(&(lp->metadata), "CO", tmpname);
-  msFree( tmpname );
-
-  if (ri_values_list == NULL)
-    return MS_FAILURE;
-
-  allowed_ri_values = msStringSplit( ri_values_list, ',', &allowed_count);
-
-  /* Parse the client value list into tokens. */
-  client_ri_values = msStringSplit( value, ',', &client_count );
-
-  /* test each client value against the allowed list. */
-
-  for( i_client = 0; all_match && i_client < client_count; i_client++ ) {
-    for( i = 0;
-         i < allowed_count
-         && strcasecmp(client_ri_values[i_client],
-                       allowed_ri_values[i]) != 0;
-         i++ ) {}
-
-    if( i == allowed_count )
-      all_match = 0;
-  }
-
-  msFreeCharArray(allowed_ri_values, allowed_count );
-  msFreeCharArray(client_ri_values, client_count );
-
-  if (all_match == 0)
-    return MS_FAILURE;
-  else
-    return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                    msWCSConvertRangeSetToString()                    */
-/************************************************************************/
-static char *msWCSConvertRangeSetToString(const char *value)
-{
-  char **tokens;
-  int numtokens;
-  double min, max, res;
-  double val;
-  char buf1[128], *buf2=NULL;
-
-  if(strchr(value, '/')) { /* value is min/max/res */
-    tokens = msStringSplit(value, '/', &numtokens);
-    if(tokens==NULL || numtokens != 3) {
-      msFreeCharArray(tokens, numtokens);
-      return NULL; /* not a set of equally spaced intervals */
-    }
-
-    min = atof(tokens[0]);
-    max = atof(tokens[1]);
-    res = atof(tokens[2]);
-    msFreeCharArray(tokens, numtokens);
-
-    for(val=min; val<=max; val+=res) {
-      if(val == min)
-        snprintf(buf1, sizeof(buf1), "%g", val);
-      else
-        snprintf(buf1, sizeof(buf1), ",%g", val);
-      buf2 = msStringConcatenate(buf2, buf1);
-    }
-
-    return buf2;
-  } else
-    return msStrdup(value);
-}
-
-/************************************************************************/
-/*                           msWCSException()                           */
-/************************************************************************/
-int msWCSException(mapObj *map, const char *code, const char *locator,
-                   const char *version )
-{
-  char *pszEncodedVal = NULL;
-  char version_string[OWS_VERSION_MAXLEN];
-
-  if( version == NULL )
-    version = "1.0.0";
-
-#if defined(USE_LIBXML2)
-  if( msOWSParseVersionString(version) >= OWS_2_0_0 )
-    return msWCSException20( map, code, locator, msOWSGetVersionString(msOWSParseVersionString(version), version_string) );
-#endif
-
-  if( msOWSParseVersionString(version) >= OWS_1_1_0 )
-    return msWCSException11( map, code, locator, msOWSGetVersionString(msOWSParseVersionString(version), version_string) );
-
-  msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  /* msIO_printf("Content-Type: text/xml%c%c",10,10); */
-
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-
-  msIO_printf("<ServiceExceptionReport version=\"1.2.0\"\n");
-  msIO_printf("xmlns=\"http://www.opengis.net/ogc\" ");
-  msIO_printf("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ");
-  pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc %s/wcs/1.0.0/OGC-exception.xsd\">\n",
-              pszEncodedVal);
-  msFree(pszEncodedVal);
-  msIO_printf("  <ServiceException");
-  if (code) {
-    msIO_printf(" code=\"%s\"", code);
-  }
-  if (locator) {
-    msIO_printf(" locator=\"%s\"", locator);
-  }
-  msIO_printf(">");
-  msWriteErrorXML(stdout);
-  msIO_printf("  </ServiceException>\n");
-  msIO_printf("</ServiceExceptionReport>\n");
-
-  msResetErrorList();
-
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                    msWCSPrintRequestCapability()                     */
-/************************************************************************/
-
-static void msWCSPrintRequestCapability(const char *request_tag, const char *script_url)
-{
-  msIO_printf("    <%s>\n", request_tag);
-
-  msIO_printf("      <DCPType>\n");
-  msIO_printf("        <HTTP>\n");
-  msIO_printf("          <Get><OnlineResource xlink:type=\"simple\" xlink:href=\"%s\" /></Get>\n", script_url);
-  msIO_printf("        </HTTP>\n");
-  msIO_printf("      </DCPType>\n");
-  msIO_printf("      <DCPType>\n");
-  msIO_printf("        <HTTP>\n");
-  msIO_printf("          <Post><OnlineResource xlink:type=\"simple\" xlink:href=\"%s\" /></Post>\n", script_url);
-  msIO_printf("        </HTTP>\n");
-  msIO_printf("      </DCPType>\n");
-
-  msIO_printf("    </%s>\n", request_tag);
-}
-
-/************************************************************************/
-/*                         msWCSCreateParams()                          */
-/************************************************************************/
-static wcsParamsObj *msWCSCreateParams()
-{
-  wcsParamsObj *params;
-
-  params = (wcsParamsObj *) calloc(1, sizeof(wcsParamsObj));
-  MS_CHECK_ALLOC(params, sizeof(wcsParamsObj), NULL);
-
-  return params;
-}
-
-/************************************************************************/
-/*                          msWCSFreeParams()                           */
-/************************************************************************/
-void msWCSFreeParams(wcsParamsObj *params)
-{
-  if(params) {
-    /* TODO */
-    if(params->version) free(params->version);
-    if(params->updatesequence) free(params->updatesequence);
-    if(params->request) free(params->request);
-    if(params->service) free(params->service);
-    if(params->section) free(params->section);
-    if(params->crs) free(params->crs);
-    if(params->response_crs) free(params->response_crs);
-    if(params->format) free(params->format);
-    if(params->exceptions) free(params->exceptions);
-    if(params->time) free(params->time);
-    if(params->interpolation) free(params->interpolation);
-    CSLDestroy( params->coverages );
-  }
-}
-
-/************************************************************************/
-/*                       msWCSIsLayerSupported()                        */
-/************************************************************************/
-
-int msWCSIsLayerSupported(layerObj *layer)
-{
-  /* only raster layers, are elligible to be served via WCS, WMS rasters are not ok */
-  if((layer->type == MS_LAYER_RASTER) && layer->connectiontype != MS_WMS && layer->name != NULL) return MS_TRUE;
-
-  return MS_FALSE;
-}
-
-/************************************************************************/
-/*                      msWCSGetRequestParameter()                      */
-/*                                                                      */
-/************************************************************************/
-
-const char *msWCSGetRequestParameter(cgiRequestObj *request, const char *name)
-{
-  int i;
-
-  if(!request || !name) /* nothing to do */
-    return NULL;
-
-  if(request->NumParams > 0) {
-    for(i=0; i<request->NumParams; i++) {
-      if(strcasecmp(request->ParamNames[i], name) == 0)
-        return request->ParamValues[i];
-    }
-  }
-
-  return NULL;
-}
-
-/************************************************************************/
-/*                  msWCSSetDefaultBandsRangeSetInfo()                  */
-/************************************************************************/
-
-void msWCSSetDefaultBandsRangeSetInfo( wcsParamsObj *params,
-                                       coverageMetadataObj *cm,
-                                       layerObj *lp )
-{
-  (void)params;
-
-  /* This function will provide default rangeset information for the "special" */
-  /* "bands" rangeset if it appears in the axes list but has no specifics provided */
-  /* in the metadata.   */
-
-  const char *value;
-  char *bandlist;
-  size_t bufferSize = 0;
-  int  i;
-
-  /* Does this item exist in the axes list?  */
-
-  value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_axes");
-  if( value == NULL )
-    return;
-
-  value = strstr(value,"bands");
-  if( value == NULL || (value[5] != '\0' && value[5] != ' ') )
-    return;
-
-  /* Are there any w*s_bands_ metadata already? If so, skip out. */
-  if( msOWSLookupMetadata(&(lp->metadata), "CO", "bands_description") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_name") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_label") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_semantic") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_type") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_rangeitem") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_semantic") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsys") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsyslabel") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_interval") != NULL )
-    return;
-
-  /* OK, we have decided to fill in the information. */
-
-  msInsertHashTable( &(lp->metadata), "wcs_bands_name", "bands" );
-  msInsertHashTable( &(lp->metadata), "wcs_bands_label", "Bands/Channels/Samples" );
-  msInsertHashTable( &(lp->metadata), "wcs_bands_rangeitem", "_bands" ); /* ? */
-
-  bufferSize = cm->bandcount*30+30;
-  bandlist = (char *) msSmallMalloc(bufferSize);
-  strcpy( bandlist, "1" );
-  for( i = 1; i < cm->bandcount; i++ )
-    snprintf( bandlist+strlen(bandlist), bufferSize-strlen(bandlist), ",%d", i+1 );
-
-  msInsertHashTable( &(lp->metadata), "wcs_bands_values", bandlist );
-  free( bandlist );
-}
-
-/************************************************************************/
-/*                         msWCSParseRequest()                          */
-/************************************************************************/
-
-static int msWCSParseRequest(cgiRequestObj *request, wcsParamsObj *params, mapObj *map)
-{
-  int i, n;
-  char **tokens;
-
-  if(!request || !params) /* nothing to do */
-    return MS_SUCCESS;
-
-  /* -------------------------------------------------------------------- */
-  /*      Check if this appears to be an XML POST WCS request.            */
-  /* -------------------------------------------------------------------- */
-
-  msDebug("msWCSParseRequest(): request is %s.\n", (request->type == MS_POST_REQUEST)?"POST":"KVP");
-
-  if( request->type == MS_POST_REQUEST
-      && request->postrequest ) {
-#if defined(USE_LIBXML2)
-    xmlDocPtr doc = NULL;
-    xmlNodePtr root = NULL, child = NULL;
-    char *tmp = NULL;
-
-    /* parse to DOM-Structure and get root element */
-    if((doc = xmlParseMemory(request->postrequest, strlen(request->postrequest)))
-        == NULL) {
-      xmlErrorPtr error = xmlGetLastError();
-      msSetError(MS_WCSERR, "XML parsing error: %s",
-                 "msWCSParseRequest()", error->message);
-      return MS_FAILURE;
-    }
-    root = xmlDocGetRootElement(doc);
-
-    /* Get service, version and request from root */
-    params->request = msStrdup((char *) root->name);
-    if ((tmp = (char *) xmlGetProp(root, BAD_CAST "service")) != NULL)
-      params->service = tmp;
-    if ((tmp = (char *) xmlGetProp(root, BAD_CAST "version")) != NULL)
-      params->version = tmp;
-
-    /* search first level children, either CoverageID,  */
-    for (child = root->children; child != NULL; child = child->next) {
-      if (EQUAL((char *)child->name, "AcceptVersions")) {
-        /* will be overridden to 1.1.1 anyway */
-      } else if (EQUAL((char *) child->name, "UpdateSequence")) {
-        params->updatesequence = (char *)xmlNodeGetContent(child);
-      } else if (EQUAL((char *) child->name, "Sections")) {
-        xmlNodePtr sectionNode = NULL;
-        /* concatenate all sections by ',' */
-        for(sectionNode = child->children; sectionNode != NULL; sectionNode = sectionNode->next) {
-          char *content;
-          if(!EQUAL((char *)sectionNode->name, "Section"))
-            continue;
-          content = (char *)xmlNodeGetContent(sectionNode);
-          if(!params->section) {
-            params->section = content;
-          } else {
-            params->section = msStringConcatenate(params->section, ",");
-            params->section = msStringConcatenate(params->section, content);
-            xmlFree(content);
-          }
-        }
-      } else if(EQUAL((char *) child->name, "AcceptFormats")) {
-        /* TODO: implement */
-      } else if(EQUAL((char *) child->name, "Identifier")) {
-        char *content = (char *)xmlNodeGetContent(child);
-        params->coverages = CSLAddString(params->coverages, content);
-        xmlFree(content);
-      } else if(EQUAL((char *) child->name, "DomainSubset")) {
-        xmlNodePtr tmpNode = NULL;
-        for(tmpNode = child->children; tmpNode != NULL; tmpNode = tmpNode->next) {
-          if(EQUAL((char *) tmpNode->name, "BoundingBox")) {
-            xmlNodePtr cornerNode = NULL;
-            params->crs = (char *)xmlGetProp(tmpNode, BAD_CAST "crs");
-            if( strncasecmp(params->crs,"urn:ogc:def:crs:",16) == 0
-                && strncasecmp(params->crs+strlen(params->crs)-8,"imageCRS",8)==0)
-              strcpy( params->crs, "imageCRS" );
-            for(cornerNode = tmpNode->children; cornerNode != NULL; cornerNode = cornerNode->next) {
-              if(EQUAL((char *) cornerNode->name, "LowerCorner")) {
-                char *value = (char *)xmlNodeGetContent(cornerNode);
-                tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for LowerCorner",
-                             "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "LowerCorner",
-                                        params->version );
-                }
-                params->bbox.minx = atof(tokens[0]);
-                params->bbox.miny = atof(tokens[1]);
-                msFreeCharArray(tokens, n);
-                xmlFree(value);
-              }
-              if(EQUAL((char *) cornerNode->name, "UpperCorner")) {
-                char *value = (char *)xmlNodeGetContent(cornerNode);
-                tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for UpperCorner",
-                             "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "UpperCorner",
-                                        params->version );
-                }
-                params->bbox.maxx = atof(tokens[0]);
-                params->bbox.maxy = atof(tokens[1]);
-                msFreeCharArray(tokens, n);
-                xmlFree(value);
-              }
-            }
-          }
-        }
-      } else if(EQUAL((char *) child->name, "RangeSubset")) {
-        /* TODO: not implemented in mapserver WCS 1.1? */
-      } else if(EQUAL((char *) child->name, "Output")) {
-        xmlNodePtr tmpNode = NULL;
-        params->format = (char *)xmlGetProp(child, BAD_CAST "format");
-        for(tmpNode = child->children; tmpNode != NULL; tmpNode = tmpNode->next) {
-          if(EQUAL((char *) tmpNode->name, "GridCRS")) {
-            xmlNodePtr crsNode = NULL;
-            for(crsNode = tmpNode->children; crsNode != NULL; crsNode = crsNode->next) {
-              if(EQUAL((char *) crsNode->name, "GridBaseCRS")) {
-                params->response_crs = (char *) xmlNodeGetContent(crsNode);
-              } else if (EQUAL((char *) crsNode->name, "GridOrigin")) {
-                char *value = (char *)xmlNodeGetContent(crsNode);
-                tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for GridOrigin",
-                             "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                        params->version );
-                }
-                params->originx = atof(tokens[0]);
-                params->originy = atof(tokens[1]);
-                msFreeCharArray(tokens, n);
-                xmlFree(value);
-              } else if (EQUAL((char *) crsNode->name, "GridOffsets")) {
-                char *value = (char *)xmlNodeGetContent(crsNode);
-                tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for GridOffsets",
-                             "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                        params->version );
-                }
-                /* take absolute values to convert to positive RESX/RESY style
-                WCS 1.0 behavior.  *but* this does break some possibilities! */
-                params->resx = fabs(atof(tokens[0]));
-                params->resy = fabs(atof(tokens[1]));
-                msFreeCharArray(tokens, n);
-                xmlFree(value);
-              }
-            }
-          }
-        }
-      }
-    }
-    xmlFreeDoc(doc);
-    xmlCleanupParser();
-    return MS_SUCCESS;
-#else /* defined(USE_LIBXML2) */
-    msSetError(MS_WCSERR, "To enable POST requests, MapServer has to "
-               "be compiled with libxml2.", "msWCSParseRequest()");
-    return MS_FAILURE;
-#endif /* defined(USE_LIBXML2) */
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Extract WCS KVP Parameters.                                     */
-  /* -------------------------------------------------------------------- */
-  if(request->NumParams > 0) {
-    for(i=0; i<request->NumParams; i++) {
-
-      if(strcasecmp(request->ParamNames[i], "VERSION") == 0)
-        params->version = msStrdup(request->ParamValues[i]);
-      if(strcasecmp(request->ParamNames[i], "UPDATESEQUENCE") == 0)
-        params->updatesequence = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "REQUEST") == 0)
-        params->request = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "INTERPOLATION") == 0)
-        params->interpolation = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "SERVICE") == 0)
-        params->service = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "SECTION") == 0) /* 1.0 */
-        params->section = msStrdup(request->ParamValues[i]); /* TODO: validate value here */
-      else if(strcasecmp(request->ParamNames[i], "SECTIONS") == 0) /* 1.1 */
-        params->section = msStrdup(request->ParamValues[i]); /* TODO: validate value here */
-
-      /* GetCoverage parameters. */
-      else if(strcasecmp(request->ParamNames[i], "BBOX") == 0) {
-        tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n != 4) {
-          msSetError(MS_WCSERR, "Wrong number of arguments for BBOX.", "msWCSParseRequest()");
-          return msWCSException(map, "InvalidParameterValue", "bbox",
-                                params->version );
-        }
-        params->bbox.minx = atof(tokens[0]);
-        params->bbox.miny = atof(tokens[1]);
-        params->bbox.maxx = atof(tokens[2]);
-        params->bbox.maxy = atof(tokens[3]);
-
-        msFreeCharArray(tokens, n);
-      } else if(strcasecmp(request->ParamNames[i], "RESX") == 0)
-        params->resx = atof(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "RESY") == 0)
-        params->resy = atof(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "WIDTH") == 0)
-        params->width = atoi(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "HEIGHT") == 0)
-        params->height = atoi(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "COVERAGE") == 0)
-        params->coverages = CSLAddString(params->coverages, request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "TIME") == 0)
-        params->time = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "FORMAT") == 0)
-        params->format = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "CRS") == 0)
-        params->crs = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "RESPONSE_CRS") == 0)
-        params->response_crs = msStrdup(request->ParamValues[i]);
-
-      /* WCS 1.1 DescribeCoverage and GetCoverage ... */
-      else if(strcasecmp(request->ParamNames[i], "IDENTIFIER") == 0
-              || strcasecmp(request->ParamNames[i], "IDENTIFIERS") == 0 ) {
-        msDebug("msWCSParseRequest(): Whole String: %s\n", request->ParamValues[i]);
-        params->coverages = CSLAddString(params->coverages, request->ParamValues[i]);
-      }
-      /* WCS 1.1 style BOUNDINGBOX */
-      else if(strcasecmp(request->ParamNames[i], "BOUNDINGBOX") == 0) {
-        tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n < 5) {
-          msSetError(MS_WCSERR, "Wrong number of arguments for BOUNDINGBOX.", "msWCSParseRequest()");
-          return msWCSException(map, "InvalidParameterValue", "boundingbox",
-                                params->version );
-        }
-
-        /* NOTE: WCS 1.1 boundingbox is center of pixel oriented, not edge
-           like in WCS 1.0.  So bbox semantics are wonky till this is fixed
-           later in the GetCoverage processing. */
-        params->bbox.minx = atof(tokens[0]);
-        params->bbox.miny = atof(tokens[1]);
-        params->bbox.maxx = atof(tokens[2]);
-        params->bbox.maxy = atof(tokens[3]);
-
-        params->crs = msStrdup(tokens[4]);
-        msFreeCharArray(tokens, n);
-        /* normalize imageCRS urns to simply "imageCRS" */
-        if( strncasecmp(params->crs,"urn:ogc:def:crs:",16) == 0
-            && strncasecmp(params->crs+strlen(params->crs)-8,"imageCRS",8)==0)
-          strcpy( params->crs, "imageCRS" );
-      } else if(strcasecmp(request->ParamNames[i], "GridOffsets") == 0) {
-        tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n < 2) {
-          msSetError(MS_WCSERR, "Wrong number of arguments for GridOffsets",
-                     "msWCSParseRequest()");
-          return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                params->version );
-        }
-        /* take absolute values to convert to positive RESX/RESY style
-           WCS 1.0 behavior.  *but* this does break some possibilities! */
-        params->resx = fabs(atof(tokens[0]));
-        params->resy = fabs(atof(tokens[1]));
-        msFreeCharArray(tokens, n);
-      } else if(strcasecmp(request->ParamNames[i], "GridOrigin") == 0) {
-        tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n < 2) {
-          msSetError(MS_WCSERR, "Wrong number of arguments for GridOrigin",
-                     "msWCSParseRequest()");
-          return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                params->version );
-        }
-        params->originx = atof(tokens[0]);
-        params->originy = atof(tokens[1]);
-        msFreeCharArray(tokens, n);
-      }
-
-      /* and so on... */
-    }
-  }
-  /* we are not dealing with an XML encoded request at this point */
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*           msWCSGetCapabilities_Service_ResponsibleParty()            */
-/************************************************************************/
-
-static void msWCSGetCapabilities_Service_ResponsibleParty(mapObj *map)
-{
-  int bEnableTelephone=MS_FALSE, bEnableAddress=MS_FALSE, bEnableOnlineResource=MS_FALSE;
-
-  /* the WCS-specific way */
-  if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_individualname") ||
-      msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_organizationname")) {
-
-    msIO_printf("<responsibleParty>\n");
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_individualname", OWS_NOERR, "    <individualName>%s</individualName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_organizationname", OWS_NOERR, "    <organisationName>%s</organisationName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_positionname", OWS_NOERR, "    <positionName>%s</positionName>\n", NULL);
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_phone_voice") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_phone_facsimile")) bEnableTelephone = MS_TRUE;
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_deliverypoint") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_city") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_administrativearea") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_postalcode") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_country") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_electronicmailaddress")) bEnableAddress = MS_TRUE;
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_onlineresource")) bEnableOnlineResource = MS_TRUE;
-
-    if(bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
-      msIO_printf("  <contactInfo>\n");
-      if(bEnableTelephone) {
-        msIO_printf("    <phone>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_phone_voice", OWS_NOERR, "    <voice>%s</voice>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_phone_facsimile", OWS_NOERR, "    <facsimile>%s</facsimile>\n", NULL);
-        msIO_printf("    </phone>\n");
-      }
-      if(bEnableAddress) {
-        msIO_printf("    <address>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_deliverypoint", OWS_NOERR, "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_city", OWS_NOERR, "    <city>%s</city>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_administrativearea", OWS_NOERR, "    <administrativeArea>%s</administrativeArea>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_postalcode", OWS_NOERR, "    <postalCode>%s</postalCode>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_country", OWS_NOERR, "    <country>%s</country>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_electronicmailaddress", OWS_NOERR, "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
-        msIO_printf("    </address>\n");
-      }
-      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_onlineresource", OWS_NOERR, "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n", NULL);
-      msIO_printf("  </contactInfo>\n");
-    }
-
-    msIO_printf("</responsibleParty>\n");
-
-  } else if(msOWSLookupMetadata(&(map->web.metadata), "CO", "contactperson") ||
-            msOWSLookupMetadata(&(map->web.metadata), "CO", "contactorganization")) { /* leverage WMS contact information */
-
-    msIO_printf("<responsibleParty>\n");
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactperson", OWS_NOERR, "    <individualName>%s</individualName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactorganization", OWS_NOERR, "    <organisationName>%s</organisationName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactposition", OWS_NOERR, "    <positionName>%s</positionName>\n", NULL);
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "contactvoicetelephone") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "contactfacsimiletelephone")) bEnableTelephone = MS_TRUE;
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "address") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "city") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "stateorprovince") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "postcode") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "country") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "contactelectronicmailaddress")) bEnableAddress = MS_TRUE;
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "service_onlineresource")) bEnableOnlineResource = MS_TRUE;
-
-    if(bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
-      msIO_printf("  <contactInfo>\n");
-      if(bEnableTelephone) {
-        msIO_printf("    <phone>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactvoicetelephone", OWS_NOERR, "    <voice>%s</voice>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactfacsimiletelephone", OWS_NOERR, "    <facsimile>%s</facsimile>\n", NULL);
-        msIO_printf("    </phone>\n");
-      }
-      if(bEnableAddress) {
-        msIO_printf("    <address>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "address", OWS_NOERR, "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "city", OWS_NOERR, "    <city>%s</city>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "stateorprovince", OWS_NOERR, "    <administrativeArea>%s</administrativeArea>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "postcode", OWS_NOERR, "    <postalCode>%s</postalCode>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "country", OWS_NOERR, "    <country>%s</country>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactelectronicmailaddress", OWS_NOERR, "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
-        msIO_printf("    </address>\n");
-      }
-      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "service_onlineresource", OWS_NOERR, "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n", NULL);
-      msIO_printf("  </contactInfo>\n");
-    }
-    msIO_printf("</responsibleParty>\n");
-  }
-
-  return;
-}
-
-/************************************************************************/
-/*                    msWCSGetCapabilities_Service()                    */
-/************************************************************************/
-
-static int msWCSGetCapabilities_Service(mapObj *map, wcsParamsObj *params)
-{
-  /* start the Service section, only need the full start tag if this is the only section requested */
-  if(!params->section || (params->section && strcasecmp(params->section, "/") == 0))
-    msIO_printf("<Service>\n");
-  else
-    msIO_printf("<Service\n"
-                "   version=\"%s\" \n"
-                "   updateSequence=\"%s\" \n"
-                "   xmlns=\"http://www.opengis.net/wcs\" \n"
-                "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
-                "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
-                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-                "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, params->updatesequence, msOWSGetSchemasLocation(map), params->version);
-
-  /* optional metadataLink */
-  msOWSPrintURLType(stdout, &(map->web.metadata), "CO", "metadatalink",
-                    OWS_NOERR,
-                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>",
-                    NULL, " metadataType=\"%s\"", NULL, NULL, NULL,
-                    " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
-                    MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
-
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "description", OWS_NOERR, "  <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "name", OWS_NOERR, "  <name>%s</name>\n", "MapServer WCS");
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "label", OWS_WARN, "  <label>%s</label>\n", NULL);
-
-  /* we are not supporting the optional keyword type, at least not yet */
-  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "CO", "keywordlist", "  <keywords>\n", "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
-
-  msWCSGetCapabilities_Service_ResponsibleParty(map);
-
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "fees", OWS_NOERR, "  <fees>%s</fees>\n", "NONE");
-  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "CO", "accessconstraints", "  <accessConstraints>\n", "  </accessConstraints>\n", "    %s\n", "NONE");
-
-  /* done */
-  msIO_printf("</Service>\n");
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                  msWCSGetCapabilities_Capability()                   */
-/************************************************************************/
-
-static int msWCSGetCapabilities_Capability(mapObj *map, wcsParamsObj *params, cgiRequestObj *req)
-{
-  char *script_url=NULL, *script_url_encoded=NULL;
-
-  /* we need this server's onlineresource for the request section */
-  if((script_url=msOWSGetOnlineResource(map, "CO", "onlineresource", req)) == NULL || (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
-    free(script_url);
-    free(script_url_encoded);
-    return msWCSException(map, NULL, NULL, params->version );
-  }
-
-  /* start the Capabilty section, only need the full start tag if this is the only section requested */
-  if(!params->section || (params->section && strcasecmp(params->section, "/") == 0))
-    msIO_printf("<Capability>\n");
-  else
-    msIO_printf("<Capability\n"
-                "   version=\"%s\" \n"
-                "   updateSequence=\"%s\" \n"
-                "   xmlns=\"http://www.opengis.net/wcs\" \n"
-                "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
-                "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
-                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-                "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, params->updatesequence, msOWSGetSchemasLocation(map), params->version);
-
-  /* describe the types of requests the server can handle */
-  msIO_printf("  <Request>\n");
-
-  msWCSPrintRequestCapability("GetCapabilities", script_url_encoded);
-  if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE))
-    msWCSPrintRequestCapability("DescribeCoverage", script_url_encoded);
-  if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE))
-    msWCSPrintRequestCapability("GetCoverage", script_url_encoded);
-
-  msIO_printf("  </Request>\n");
-
-  /* describe the exception formats the server can produce */
-  msIO_printf("  <Exception>\n");
-  msIO_printf("    <Format>application/vnd.ogc.se_xml</Format>\n");
-  msIO_printf("  </Exception>\n");
-
-  /* describe any vendor specific capabilities */
-  /* msIO_printf("  <VendorSpecificCapabilities />\n"); */ /* none yet */
-
-  /* done */
-  msIO_printf("</Capability>\n");
-
-  free(script_url);
-  free(script_url_encoded);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                    msWCSPrintMetadataLink()                          */
-/************************************************************************/
-
-static void  msWCSPrintMetadataLink(layerObj *layer, const char *script_url_encoded)
-{
-  const char* list = msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
-  if( list ) {
-    int ntokens = 0;
-    char** tokens = msStringSplit(list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
-      std::string key("metadatalink_");
-      key += tokens[i];
-      msOWSPrintURLType(stdout, &(layer->metadata), "CO", key.c_str(),
-                        OWS_NOERR,
-                        "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>",
-                        NULL, " metadataType=\"%s\"", NULL, NULL, NULL,
-                        " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
-                        MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
-    }
-    msFreeCharArray(tokens, ntokens);
-    return;
-  }
-
-  /* optional metadataLink */
-  if (! msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_href"))
-    msMetadataSetGetMetadataURL(layer, script_url_encoded);
-
-  msOWSPrintURLType(stdout, &(layer->metadata), "CO", "metadatalink",
-                    OWS_NOERR,
-                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>",
-                    NULL, " metadataType=\"%s\"", NULL, NULL, NULL,
-                    " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
-                    MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
-
-}
-
-/************************************************************************/
-/*             msWCSGetCapabilities_CoverageOfferingBrief()             */
-/************************************************************************/
-
-static int msWCSGetCapabilities_CoverageOfferingBrief(layerObj *layer, const char *script_url_encoded)
-{
-  coverageMetadataObj cm;
-  int status;
-
-  if((layer->status == MS_DELETE) || !msWCSIsLayerSupported(layer)) return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
-
-  status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  /* start the CoverageOfferingBrief section */
-  msIO_printf("  <CoverageOfferingBrief>\n"); /* is this tag right? (I hate schemas without ANY examples) */
-
-  msWCSPrintMetadataLink(layer, script_url_encoded);
-
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description", OWS_NOERR, "    <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR, "    <name>%s</name>\n", layer->name);
-
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN, "    <label>%s</label>\n", NULL);
-
-  /* TODO: add elevation ranges to lonLatEnvelope (optional) */
-  msIO_printf("    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx, cm.llextent.miny); /* TODO: don't know if this is right */
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx, cm.llextent.maxy);
-
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
-
-  msIO_printf("    </lonLatEnvelope>\n");
-
-  /* we are not supporting the optional keyword type, at least not yet */
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist", "  <keywords>\n", "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
-
-  /* done */
-  msIO_printf("  </CoverageOfferingBrief>\n");
-  
-  msWCSFreeCoverageMetadata(&cm);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                msWCSGetCapabilities_ContentMetadata()                */
-/************************************************************************/
-
-static int msWCSGetCapabilities_ContentMetadata(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request, cgiRequestObj *req)
-{
-  int i;
-  char *script_url_encoded=NULL;
-
-  {
-      char* pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
-      script_url_encoded = msEncodeHTMLEntities(pszTmp);
-      msFree(pszTmp);
-  }
-
-  /* start the ContentMetadata section, only need the full start tag if this is the only section requested */
-  /* TODO: add Xlink attributes for other sources of this information  */
-  if(!params->section || (params->section && strcasecmp(params->section, "/") == 0))
-    msIO_printf("<ContentMetadata>\n");
-  else
-    msIO_printf("<ContentMetadata\n"
-                "   version=\"%s\" \n"
-                "   updateSequence=\"%s\" \n"
-                "   xmlns=\"http://www.opengis.net/wcs\" \n"
-                "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
-                "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
-                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-                "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, params->updatesequence, msOWSGetSchemasLocation(map), params->version);
-
-  if(ows_request->numlayers == 0) {
-    msIO_printf("  <!-- WARNING: No WCS layers are enabled. Check wcs/ows_enable_request settings. -->\n");
-  } else {
-    for(i=0; i<map->numlayers; i++) {
-      if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-        continue;
-
-      if(msWCSGetCapabilities_CoverageOfferingBrief((GET_LAYER(map, i)), script_url_encoded) != MS_SUCCESS ) {
-        msIO_printf("  <!-- WARNING: There was a problem with one of layers. See server log for details. -->\n");
-      }
-    }
-  }
-
-  msFree(script_url_encoded);
-
-  /* done */
-  msIO_printf("</ContentMetadata>\n");
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                        msWCSGetCapabilities()                        */
-/************************************************************************/
-
-static int msWCSGetCapabilities(mapObj *map, wcsParamsObj *params, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  char tmpString[OWS_VERSION_MAXLEN];
-  int i, tmpInt = 0;
-  int wcsSupportedVersions[] = {OWS_1_1_2, OWS_1_1_1, OWS_1_1_0, OWS_1_0_0};
-  int wcsNumSupportedVersions = 4;
-  const char *updatesequence=NULL;
-
-  /* check version is valid */
-  tmpInt = msOWSParseVersionString(params->version);
-  if (tmpInt == OWS_VERSION_BADFORMAT) {
-    return msWCSException(map, "InvalidParameterValue",
-                          "version", "1.0.0 ");
-  }
-
-  /* negotiate version */
-  tmpInt = msOWSNegotiateVersion(tmpInt, wcsSupportedVersions, wcsNumSupportedVersions);
-
-  /* set result as string and carry on */
-  free(params->version);
-  params->version = msStrdup(msOWSGetVersionString(tmpInt, tmpString));
-
-  /* -------------------------------------------------------------------- */
-  /*      1.1.x is sufficiently different we have a whole case for        */
-  /*      it.  The remainder of this function is for 1.0.0.               */
-  /* -------------------------------------------------------------------- */
-  if( strncmp(params->version,"1.1",3) == 0 )
-    return msWCSGetCapabilities11( map, params, req, ows_request);
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
-
-  if (params->updatesequence != NULL) {
-    i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
-    if (i == 0) { /* current */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msWCSGetCapabilities()", params->updatesequence, updatesequence);
-      return msWCSException(map, "CurrentUpdateSequence",
-                            "updatesequence", params->version );
-    }
-    if (i > 0) { /* invalid */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msWCSGetCapabilities()", params->updatesequence, updatesequence);
-      return msWCSException(map, "InvalidUpdateSequence",
-                            "updatesequence", params->version );
-    }
-  }
-
-  else { /* set default updatesequence */
-    if(!updatesequence)
-      updatesequence = "0";
-    params->updatesequence = msStrdup(updatesequence);
-  }
-
-  /* if a bum section param is passed, throw exception */
-  if (params->section &&
-      strcasecmp(params->section, "/WCS_Capabilities/Service") != 0 &&
-      strcasecmp(params->section, "/WCS_Capabilities/Capability") != 0 &&
-      strcasecmp(params->section, "/WCS_Capabilities/ContentMetadata") != 0 &&
-      strcasecmp(params->section, "/") != 0) {
-    msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
-    msIO_sendHeaders();
-    msSetError( MS_WCSERR,
-                "Invalid SECTION parameter \"%s\"",
-                "msWCSGetCapabilities()", params->section);
-    return msWCSException(map, "InvalidParameterValue", "section",
-                          params->version );
-  }
-
-  else {
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-    msIO_sendHeaders();
-
-    /* print common capability elements  */
-    /* TODO: DocType? */
-
-    if (!updatesequence)
-      updatesequence = "0";
-
-    msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-
-    if(!params->section || (params->section && strcasecmp(params->section, "/")  == 0)) msIO_printf("<WCS_Capabilities\n"
-          "   version=\"%s\" \n"
-          "   updateSequence=\"%s\" \n"
-          "   xmlns=\"http://www.opengis.net/wcs\" \n"
-          "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
-          "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
-          "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-          "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, updatesequence, msOWSGetSchemasLocation(map), params->version);
-
-    /* print the various capability sections */
-    if(!params->section || strcasecmp(params->section, "/WCS_Capabilities/Service") == 0)
-      msWCSGetCapabilities_Service(map, params);
-
-    if(!params->section || strcasecmp(params->section, "/WCS_Capabilities/Capability")  == 0)
-      msWCSGetCapabilities_Capability(map, params, req);
-
-    if(!params->section || strcasecmp(params->section, "/WCS_Capabilities/ContentMetadata")  == 0)
-      msWCSGetCapabilities_ContentMetadata(map, params, ows_request, req);
-
-    if(params->section && strcasecmp(params->section, "/")  == 0) {
-      msWCSGetCapabilities_Service(map, params);
-      msWCSGetCapabilities_Capability(map, params, req);
-      msWCSGetCapabilities_ContentMetadata(map, params, ows_request, req);
-    }
-
-    /* done */
-    if(!params->section || (params->section && strcasecmp(params->section, "/")  == 0)) msIO_printf("</WCS_Capabilities>\n");
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*               msWCSDescribeCoverage_AxisDescription()                */
-/************************************************************************/
-
-static int msWCSDescribeCoverage_AxisDescription(layerObj *layer, char *name)
-{
-  const char *value;
-  char tag[100]; /* should be plenty of space */
-
-  msIO_printf("        <axisDescription>\n");
-  msIO_printf("          <AxisDescription");
-  snprintf(tag, sizeof(tag), "%s_semantic",  name); /* optional attributes follow (should escape?) */
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " semantic=\"%s\"", NULL);
-  snprintf(tag, sizeof(tag), "%s_refsys", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " refSys=\"%s\"", NULL);
-  snprintf(tag, sizeof(tag), "%s_refsyslabel", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " refSysLabel=\"%s\"", NULL);
-  msIO_printf(">\n");
-
-  /* TODO: add metadataLink (optional) */
-
-  snprintf(tag, sizeof(tag), "%s_description", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, "            <description>%s</description>\n", NULL);
-  /* snprintf(tag, sizeof(tag), "%s_name", name); */
-  /* msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN, "            <name>%s</name>\n", NULL); */
-  msIO_printf("            <name>%s</name>\n", name);
-
-  snprintf(tag, sizeof(tag), "%s_label", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN, "            <label>%s</label>\n", NULL);
-
-  /* Values */
-  msIO_printf("            <values");
-  snprintf(tag, sizeof(tag), "%s_values_semantic", name); /* optional attributes follow (should escape?) */
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " semantic=\"%s\"", NULL);
-  snprintf(tag, sizeof(tag), "%s_values_type", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " type=\"%s\"", NULL);
-  msIO_printf(">\n");
-
-  /* single values, we do not support optional type and semantic attributes */
-  snprintf(tag, sizeof(tag), "%s_values", name);
-  if(msOWSLookupMetadata(&(layer->metadata), "CO", tag))
-    msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", tag, NULL, NULL, "              <singleValue>%s</singleValue>\n", NULL);
-
-  /* intervals, only one per axis for now, we do not support optional type, atomic and semantic attributes */
-  snprintf(tag, sizeof(tag), "%s_interval", name);
-  if((value = msOWSLookupMetadata(&(layer->metadata), "CO", tag)) != NULL) {
-    int numtokens = 0;
-    char** tokens = msStringSplit(value, '/', &numtokens);
-    if(tokens && numtokens > 0) {
-      msIO_printf("            <interval>\n");
-      if(numtokens >= 1) msIO_printf("            <min>%s</min>\n", tokens[0]); /* TODO: handle closure */
-      if(numtokens >= 2) msIO_printf("            <max>%s</max>\n", tokens[1]);
-      if(numtokens >= 3) msIO_printf("            <res>%s</res>\n", tokens[2]);
-      msIO_printf("            </interval>\n");
-    }
-    msFreeCharArray(tokens, numtokens);
-  }
-
-  /* TODO: add default (optional) */
-
-  msIO_printf("            </values>\n");
-
-  msIO_printf("          </AxisDescription>\n");
-  msIO_printf("        </axisDescription>\n");
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*               msWCSDescribeCoverage_CoverageOffering()               */
-/************************************************************************/
-
-static int msWCSDescribeCoverage_CoverageOffering(layerObj *layer, wcsParamsObj *params, char *script_url_encoded)
-{
-  const char *value;
-  char *epsg_buf, *encoded_format;
-  coverageMetadataObj cm;
-  int i, status;
-
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  if(!msWCSIsLayerSupported(layer)) return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
-
-
-  status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  /* fill in bands rangeset info, if required.  */
-  msWCSSetDefaultBandsRangeSetInfo( params, &cm, layer );
-
-  /* start the Coverage section */
-  msIO_printf("  <CoverageOffering>\n");
-
-  msWCSPrintMetadataLink(layer, script_url_encoded);
-
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description", OWS_NOERR, "  <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR, "  <name>%s</name>\n", layer->name);
-
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN, "  <label>%s</label>\n", NULL);
-
-  /* TODO: add elevation ranges to lonLatEnvelope (optional) */
-  msIO_printf("    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx, cm.llextent.miny);
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx, cm.llextent.maxy);
-
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
-
-  msIO_printf("    </lonLatEnvelope>\n");
-
-  /* we are not supporting the optional keyword type, at least not yet */
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist", "  <keywords>\n", "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
-
-  /* DomainSet: starting simple, just a spatial domain (gml:envelope) and optionally a temporal domain */
-  msIO_printf("    <domainSet>\n");
-
-  /* SpatialDomain */
-  msIO_printf("      <spatialDomain>\n");
-
-  /* envelope in lat/lon */
-  msIO_printf("        <gml:Envelope srsName=\"EPSG:4326\">\n");
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx, cm.llextent.miny);
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx, cm.llextent.maxy);
-  msIO_printf("        </gml:Envelope>\n");
-
-  /* envelope in the native srs */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &epsg_buf);
-  if(!epsg_buf) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_TRUE, &epsg_buf);
-  }
-  if(epsg_buf) {
-    msIO_printf("        <gml:Envelope srsName=\"%s\">\n", epsg_buf);
-    msFree(epsg_buf);
-  } else {
-    msIO_printf("        <!-- NativeCRSs ERROR: missing required information, no SRSs defined -->\n");
-  }
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.minx, cm.extent.miny);
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.maxx, cm.extent.maxy);
-  msIO_printf("        </gml:Envelope>\n");
-
-  /* gml:rectifiedGrid */
-  msIO_printf("        <gml:RectifiedGrid dimension=\"2\">\n");
-  msIO_printf("          <gml:limits>\n");
-  msIO_printf("            <gml:GridEnvelope>\n");
-  msIO_printf("              <gml:low>0 0</gml:low>\n");
-  msIO_printf("              <gml:high>%d %d</gml:high>\n", cm.xsize-1, cm.ysize-1);
-  msIO_printf("            </gml:GridEnvelope>\n");
-  msIO_printf("          </gml:limits>\n");
-  msIO_printf("          <gml:axisName>x</gml:axisName>\n");
-  msIO_printf("          <gml:axisName>y</gml:axisName>\n");
-  msIO_printf("          <gml:origin>\n");
-  msIO_printf("            <gml:pos>%.15g %.15g</gml:pos>\n", cm.geotransform[0], cm.geotransform[3]);
-  msIO_printf("          </gml:origin>\n");
-  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n", cm.geotransform[1], cm.geotransform[2]); /* offset vector in X direction */
-  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n", cm.geotransform[4], cm.geotransform[5]); /* offset vector in Y direction */
-  msIO_printf("        </gml:RectifiedGrid>\n");
-
-  msIO_printf("      </spatialDomain>\n");
-  
-  msWCSFreeCoverageMetadata(&cm);
-
-  /* TemporalDomain */
-
-  /* TODO: figure out when a temporal domain is valid, for example only tiled rasters support time as a domain, plus we need a timeitem */
-  if(msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") || msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
-    msIO_printf("      <temporalDomain>\n");
-
-    /* TimePosition (should support a value AUTO, then we could mine positions from the timeitem) */
-    msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
-
-    /* TODO:  add TimePeriod (only one per layer)  */
-
-    msIO_printf("      </temporalDomain>\n");
-  }
-
-  msIO_printf("    </domainSet>\n");
-
-  /* rangeSet */
-  msIO_printf("    <rangeSet>\n");
-  msIO_printf("      <RangeSet>\n"); /* TODO: there are some optional attributes */
-
-  /* TODO: add metadataLink (optional) */
-
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_description", OWS_NOERR, "        <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_name", OWS_WARN, "        <name>%s</name>\n", NULL);
-
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_label", OWS_WARN, "        <label>%s</label>\n", NULL);
-
-  /* compound range sets */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "CO", "rangeset_axes")) != NULL) {
-    int numtokens = 0;
-    char** tokens = msStringSplit(value, ',', &numtokens);
-    if(tokens && numtokens > 0) {
-      for(i=0; i<numtokens; i++)
-        msWCSDescribeCoverage_AxisDescription(layer, tokens[i]);
-    }
-    msFreeCharArray(tokens, numtokens);
-  }
-
-  if((value = msOWSLookupMetadata(&(layer->metadata), "CO", "rangeset_nullvalue")) != NULL) {
-    msIO_printf("        <nullValues>\n");
-    msIO_printf("          <singleValue>%s</singleValue>\n", value);
-    msIO_printf("        </nullValues>\n");
-  }
-
-  msIO_printf("      </RangeSet>\n");
-  msIO_printf("    </rangeSet>\n");
-
-  /* supportedCRSs */
-  msIO_printf("    <supportedCRSs>\n");
-
-  /* requestResposeCRSs: check the layer metadata/projection, and then the map metadata/projection if necessary (should never get to the error message) */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_FALSE, &epsg_buf);
-  if(!epsg_buf) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_FALSE, &epsg_buf);
-  }
-  if(epsg_buf) {
-    int numtokens = 0;
-    char** tokens = msStringSplit(epsg_buf, ' ', &numtokens);
-    if(tokens && numtokens > 0) {
-      for(i=0; i<numtokens; i++)
-        msIO_printf("      <requestResponseCRSs>%s</requestResponseCRSs>\n", tokens[i]);
-    }
-    msFreeCharArray(tokens, numtokens);
-    msFree(epsg_buf);
-  } else {
-    msIO_printf("      <!-- requestResponseCRSs ERROR: missing required information, no SRSs defined -->\n");
-  }
-
-  /* nativeCRSs (only one in our case) */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &epsg_buf);
-  if(!epsg_buf) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_TRUE, &epsg_buf);
-  }
-  if(epsg_buf) {
-    msIO_printf("      <nativeCRSs>%s</nativeCRSs>\n", epsg_buf);
-    msFree(epsg_buf);
-  } else {
-    msIO_printf("      <!-- nativeCRSs ERROR: missing required information, no SRSs defined -->\n");
-  }
-
-  msIO_printf("    </supportedCRSs>\n");
-
-
-  /* supportedFormats */
-  msIO_printf("    <supportedFormats");
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "nativeformat", OWS_NOERR, " nativeFormat=\"%s\"", NULL);
-  msIO_printf(">\n");
-
-  if( (encoded_format = msOWSGetEncodeMetadata( &(layer->metadata), "CO", "formats",
-                                       "GTiff" )) != NULL ) {
-    int numtokens = 0;
-    char** tokens = msStringSplit(encoded_format, ' ', &numtokens);
-    if(tokens && numtokens > 0) {
-      for(i=0; i<numtokens; i++)
-        msIO_printf("      <formats>%s</formats>\n", tokens[i]);
-    }
-    msFreeCharArray(tokens, numtokens);
-    msFree(encoded_format);
-  }
-  msIO_printf("    </supportedFormats>\n");
-
-  msIO_printf("    <supportedInterpolations default=\"nearest neighbor\">\n");
-  msIO_printf("      <interpolationMethod>nearest neighbor</interpolationMethod>\n" );
-  msIO_printf("      <interpolationMethod>bilinear</interpolationMethod>\n" );
-  /*  msIO_printf("      <interpolationMethod>bicubic</interpolationMethod>\n" ); */
-  msIO_printf("    </supportedInterpolations>\n");
-
-
-  /* done */
-  msIO_printf("  </CoverageOffering>\n");
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msWCSDescribeCoverage()                        */
-/************************************************************************/
-
-static int msWCSDescribeCoverage(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request, cgiRequestObj *req)
-{
-  int i = 0,j = 0, k = 0;
-  const char *updatesequence=NULL;
-  char **coverages=NULL;
-  int numcoverages=0;
-
-  char *coverageName=NULL;
-  char *script_url_encoded=NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      1.1.x is sufficiently different we have a whole case for        */
-  /*      it.  The remainder of this function is for 1.0.0.               */
-  /* -------------------------------------------------------------------- */
-  if( strncmp(params->version,"1.1",3) == 0 )
-    return msWCSDescribeCoverage11( map, params, ows_request);
-
-  /* -------------------------------------------------------------------- */
-  /*      Process 1.0.0...                                                */
-  /* -------------------------------------------------------------------- */
-
-  if(params->coverages) { /* use the list, but validate it first */
-    for(j=0; params->coverages[j]; j++) {
-      coverages = msStringSplit(params->coverages[j], ',', &numcoverages);
-      for(k=0; k<numcoverages; k++) {
-
-        for(i=0; i<map->numlayers; i++) {
-          coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO", "name", GET_LAYER(map, i)->name);
-          if( coverageName != NULL && EQUAL(coverageName, coverages[k]) &&
-              (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-            msFree(coverageName);
-            break;
-          }
-          msFree(coverageName);
-        }
-
-        /* i = msGetLayerIndex(map, coverages[k]); */
-        if(i == map->numlayers) { /* coverage not found */
-          msSetError( MS_WCSERR, "COVERAGE %s cannot be opened / does not exist. A layer might be disabled for \
-this request. Check wcs/ows_enable_request settings.", "msWCSDescribeCoverage()", coverages[k]);
-          return msWCSException(map, "CoverageNotDefined", "coverage", params->version );
-        }
-      } /* next coverage */
-      msFreeCharArray(coverages,numcoverages);
-    }
-  }
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
-  if (!updatesequence)
-    updatesequence = "0";
-
-  /* printf("Content-Type: application/vnd.ogc.se_xml%c%c",10,10); */
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  /* print common capability elements  */
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-
-  /* start the DescribeCoverage section */
-  msIO_printf("<CoverageDescription\n"
-              "   version=\"%s\" \n"
-              "   updateSequence=\"%s\" \n"
-              "   xmlns=\"http://www.opengis.net/wcs\" \n"
-              "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
-              "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
-              "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-              "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/describeCoverage.xsd\">\n", params->version, updatesequence, msOWSGetSchemasLocation(map), params->version);
-
-  {
-    char* pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
-    script_url_encoded = msEncodeHTMLEntities(pszTmp);
-    msFree(pszTmp);
-  }
-
-  if(params->coverages) { /* use the list */
-    for( j = 0; params->coverages[j]; j++ ) {
-      coverages = msStringSplit(params->coverages[j], ',', &numcoverages);
-      for(k=0; k<numcoverages; k++) {
-        for(i=0; i<map->numlayers; i++) {
-          coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO", "name", GET_LAYER(map, i)->name);
-          if( coverageName != NULL && EQUAL(coverageName, coverages[k]) ) {
-            msFree(coverageName);
-            break;
-          }
-          msFree(coverageName);
-        }
-        msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params, script_url_encoded);
-      }
-      msFreeCharArray(coverages,numcoverages);
-    }
-  } else { /* return all layers */
-    for(i=0; i<map->numlayers; i++) {
-      if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-        continue;
-
-      msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params, script_url_encoded);
-    }
-  }
-
-  msFree(script_url_encoded);
-
-  /* done */
-  msIO_printf("</CoverageDescription>\n");
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msWCSGetCoverageBands10()                      */
-/************************************************************************/
-
-static int msWCSGetCoverageBands10( mapObj *map, cgiRequestObj *request,
-                                    wcsParamsObj *params, layerObj *lp,
-                                    char **p_bandlist )
-
-{
-  const char *value = NULL;
-  int i;
-
-  /* Are there any non-spatio/temporal ranges to do subsetting on (e.g. bands) */
-  value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_axes"); /* this will get all the compound range sets */
-  if(value) {
-    char **tokens;
-    int numtokens;
-    char tag[100];
-    const char *rangeitem;
-
-    tokens = msStringSplit(value, ',', &numtokens);
-
-    for(i=0; i<numtokens; i++) {
-      if((value = msWCSGetRequestParameter(request, tokens[i])) == NULL) continue; /* next rangeset parameter */
-
-      /* ok, a parameter has been passed which matches a token in wcs_rangeset_axes */
-      if(msWCSValidateRangeSetParam(lp, tokens[i], value) != MS_SUCCESS) {
-        int ret;
-        msSetError( MS_WCSERR, "Error specifying \"%s\" parameter value(s).", "msWCSGetCoverage()", tokens[i]);
-        ret = msWCSException(map, "InvalidParameterValue", tokens[i], params->version );
-        msFreeCharArray(tokens, numtokens);
-        return ret;
-      }
-
-      /* xxxxx_rangeitem tells us how to subset */
-      snprintf(tag, sizeof(tag), "%s_rangeitem", tokens[i]);
-      if((rangeitem = msOWSLookupMetadata(&(lp->metadata), "CO", tag)) == NULL) {
-        msSetError( MS_WCSERR, "Missing required metadata element \"%s\", unable to process %s=%s.", "msWCSGetCoverage()", tag, tokens[i], value);
-        msFreeCharArray(tokens, numtokens);
-        return msWCSException(map, NULL, NULL, params->version);
-      }
-
-      if(strcasecmp(rangeitem, "_bands") == 0) { /* special case, subset bands */
-        *p_bandlist = msWCSConvertRangeSetToString(value);
-
-        if(!*p_bandlist) {
-          msSetError( MS_WCSERR, "Error specifying \"%s\" parameter value(s).", "msWCSGetCoverage()", tokens[i]);
-          msFreeCharArray(tokens, numtokens);
-          return msWCSException(map, NULL, NULL, params->version );
-        }
-      } else if(strcasecmp(rangeitem, "_pixels") == 0) { /* special case, subset pixels */
-        msFreeCharArray(tokens, numtokens);
-        msSetError( MS_WCSERR, "Arbitrary range sets based on pixel values are not yet supported.", "msWCSGetCoverage()" );
-        return msWCSException(map, NULL, NULL, params->version);
-      } else {
-        msFreeCharArray(tokens, numtokens);
-        msSetError( MS_WCSERR, "Arbitrary range sets based on tile (i.e. image) attributes are not yet supported.", "msWCSGetCoverage()" );
-        return msWCSException(map, NULL, NULL, params->version );
-      }
-    }
-    /* clean-up */
-    msFreeCharArray(tokens, numtokens);
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSGetCoverage_ImageCRSSetup()                   */
-/*                                                                      */
-/*      The request was in imageCRS - update the map projection to      */
-/*      map the native projection of the layer, and reset the           */
-/*      bounding box to match the projected bounds corresponding to     */
-/*      the imageCRS request.                                           */
-/************************************************************************/
-
-static int msWCSGetCoverage_ImageCRSSetup(
-  mapObj *map, wcsParamsObj *params,
-  coverageMetadataObj *cm, layerObj *layer )
-
-{
-  /* -------------------------------------------------------------------- */
-  /*      Load map with the layer (coverage) coordinate system.  We       */
-  /*      really need a set projectionObj from projectionObj function!    */
-  /* -------------------------------------------------------------------- */
-  char *layer_proj = msGetProjectionString( &(layer->projection) );
-
-  if (msLoadProjectionString(&(map->projection), layer_proj) != 0) {
-    msFree(layer_proj);
-    return msWCSException( map, NULL, NULL, params->version );
-  }
-
-  free( layer_proj );
-  layer_proj = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Reset bounding box.                                             */
-  /* -------------------------------------------------------------------- */
-  if( params->bbox.maxx != params->bbox.minx ) {
-    rectObj orig_bbox = params->bbox;
-
-    params->bbox.minx =
-      cm->geotransform[0]
-      + orig_bbox.minx * cm->geotransform[1]
-      + orig_bbox.miny * cm->geotransform[2];
-    params->bbox.maxy =
-      cm->geotransform[3]
-      + orig_bbox.minx * cm->geotransform[4]
-      + orig_bbox.miny * cm->geotransform[5];
-    params->bbox.maxx =
-      cm->geotransform[0]
-      + (orig_bbox.maxx+1) * cm->geotransform[1]
-      + (orig_bbox.maxy+1) * cm->geotransform[2];
-    params->bbox.miny =
-      cm->geotransform[3]
-      + (orig_bbox.maxx+1) * cm->geotransform[4]
-      + (orig_bbox.maxy+1) * cm->geotransform[5];
-
-    /* WCS 1.1 boundbox is center of pixel oriented. */
-    if( strncasecmp(params->version,"1.1",3) == 0 ) {
-      params->bbox.minx += cm->geotransform[1]/2 + cm->geotransform[2]/2;
-      params->bbox.maxx -= cm->geotransform[1]/2 + cm->geotransform[2]/2;
-      params->bbox.maxy += cm->geotransform[4]/2 + cm->geotransform[5]/2;
-      params->bbox.miny -= cm->geotransform[4]/2 + cm->geotransform[5]/2;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Reset resolution.                                               */
-  /* -------------------------------------------------------------------- */
-  if( params->resx != 0.0 ) {
-    params->resx = cm->geotransform[1] * params->resx;
-    params->resy = fabs(cm->geotransform[5] * params->resy);
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                    msWCSApplyLayerCreationOptions()                  */
-/************************************************************************/
-
-void msWCSApplyLayerCreationOptions(layerObj* lp,
-                                    outputFormatObj* format,
-                                    const char* bandlist)
-
-{
-    const char* pszKey;
-    char szKeyBeginning[256];
-    size_t nKeyBeginningLength;
-    int nBands = 0;
-    char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-
-    snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-             "wcs_outputformat_%s_creationoption_", format->name);
-    nKeyBeginningLength = strlen(szKeyBeginning);
-
-    pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-    for( ; pszKey != NULL;
-           pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-    {
-        if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-        {
-            const char* pszValue = msLookupHashTable( &(lp->metadata), pszKey);
-            const char* pszGDALKey = pszKey + nKeyBeginningLength;
-            if( EQUALN(pszGDALKey, "BAND_", strlen("BAND_")) )
-            {
-                /* Remap BAND specific creation option to the real output
-                 * band number, given the band subset of the request */
-                int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
-                int nTargetBandNumber = -1;
-                int i;
-                for(i = 0; i < nBands; i++ )
-                {
-                    if( nKeyOriBandNumber == atoi(papszBandNumbers[i]) )
-                    {
-                        nTargetBandNumber = i + 1;
-                        break;
-                    }
-                }
-                if( nTargetBandNumber > 0 )
-                {
-                    char szModKey[256];
-                    const char* pszAfterBand =
-                        strchr(pszGDALKey + strlen("BAND_"), '_');
-                    if( pszAfterBand != NULL )
-                    {
-                        snprintf(szModKey, sizeof(szModKey),
-                                 "BAND_%d%s",
-                                 nTargetBandNumber,
-                                 pszAfterBand);
-                        if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                            msDebug("Setting GDAL %s=%s creation option\n",
-                                    szModKey, pszValue);
-                        }
-                        msSetOutputFormatOption(format, szModKey, pszValue);
-                    }
-                }
-            }
-            else
-            {
-                if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                    msDebug("Setting GDAL %s=%s creation option\n",
-                            pszGDALKey, pszValue);
-                }
-                msSetOutputFormatOption(format, pszGDALKey, pszValue);
-            }
-        }
-    }
-
-    msFreeCharArray( papszBandNumbers, nBands );
-}
-
-/************************************************************************/
-/*               msWCSApplyDatasetMetadataAsCreationOptions()           */
-/************************************************************************/
-
-void msWCSApplyDatasetMetadataAsCreationOptions(layerObj* lp,
-                                                outputFormatObj* format,
-                                                const char* bandlist,
-                                                void* hDSIn)
-{
-    /* Requires GDAL 2.3 in practice. */
-    /* Automatic forwarding of input dataset metadata if it is GRIB and the */
-    /* output is GRIB as well, and wcs_outputformat_GRIB_creationoption* are */
-    /* not defined. */
-    GDALDatasetH hDS = (GDALDatasetH)hDSIn;
-    if( hDS && GDALGetDatasetDriver(hDS) &&
-        EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "GRIB") &&
-        EQUAL(format->driver, "GDAL/GRIB") )
-    {
-        const char* pszKey;
-        char szKeyBeginning[256];
-        size_t nKeyBeginningLength;
-        int bWCSMetadataFound = MS_FALSE;
-
-        snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-                "wcs_outputformat_%s_creationoption_", format->name);
-        nKeyBeginningLength = strlen(szKeyBeginning);
-
-        for( pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-             pszKey != NULL;
-             pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-        {
-            if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-            {
-                bWCSMetadataFound = MS_TRUE;
-                break;
-            }
-        }
-        if( !bWCSMetadataFound )
-        {
-            int nBands = 0;
-            char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-            int i;
-            for(i = 0; i < nBands; i++ )
-            {
-                int nSrcBand = atoi(papszBandNumbers[i]);
-                int nDstBand = i + 1;
-                GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
-                if( hBand )
-                {
-                    char** papszMD = GDALGetMetadata(hBand, NULL);
-                    const char* pszMDI = CSLFetchNameValue(papszMD, "GRIB_IDS");
-                    // Make sure it is a GRIB2 band
-                    if( pszMDI )
-                    {
-                        char szKey[256];
-                        sprintf(szKey, "BAND_%d_IDS", nDstBand);
-                        msSetOutputFormatOption(format, szKey, pszMDI);
-
-                        sprintf(szKey, "BAND_%d_DISCIPLINE", nDstBand);
-                        msSetOutputFormatOption(format, szKey, 
-                                CSLFetchNameValue(papszMD, "DISCIPLINE"));
-
-                        sprintf(szKey, "BAND_%d_PDS_PDTN", nDstBand);
-                        msSetOutputFormatOption(format, szKey, 
-                                CSLFetchNameValue(papszMD, "GRIB_PDS_PDTN"));
-
-                        sprintf(szKey, "BAND_%d_PDS_TEMPLATE_NUMBERS",
-                                nDstBand);
-                        msSetOutputFormatOption(format, szKey, 
-                                CSLFetchNameValue(papszMD,
-                                                  "GRIB_PDS_TEMPLATE_NUMBERS"));
-                    }
-                }
-            }
-            msFreeCharArray( papszBandNumbers, nBands );
-        }
-    }
-}
-
-/************************************************************************/
-/*                  msWCSApplyLayerMetadataItemOptions()                */
-/************************************************************************/
-
-void msWCSApplyLayerMetadataItemOptions(layerObj* lp,
-                                        outputFormatObj* format,
-                                        const char* bandlist)
-
-{
-    if( !STARTS_WITH(format->driver, "GDAL/") )
-        return;
-
-    const bool bIsNetCDFOutput = EQUAL(format->driver, "GDAL/netCDF");
-    const char* pszKey;
-    char szKeyBeginning[256];
-    size_t nKeyBeginningLength;
-    int nBands = 0;
-    char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-
-    snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-             "wcs_outputformat_%s_mdi_", format->name);
-    nKeyBeginningLength = strlen(szKeyBeginning);
-
-    // Transform wcs_outputformat_{formatname}_mdi_{key} to mdi_{key}
-    // and Transform wcs_outputformat_{formatname}_mdi_BAND_X_{key} to mdi_BAND_Y_{key}
-    // MDI stands for MetaDataItem
-
-    // For netCDF 3D output
-    std::map<int, std::string> oMapExtraDimValues;
-    std::string osExtraDimName;
-    bool bExtraDimValid = false;
-
-    pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-    for( ; pszKey != NULL;
-           pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-    {
-        if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-        {
-            const char* pszValue = msLookupHashTable( &(lp->metadata), pszKey);
-            const char* pszGDALKey = pszKey + nKeyBeginningLength;
-
-            if( EQUALN(pszGDALKey, "BAND_", strlen("BAND_")) )
-            {
-                /* Remap BAND specific creation option to the real output
-                 * band number, given the band subset of the request */
-                int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
-                int nTargetBandNumber = -1;
-                int i;
-                for(i = 0; i < nBands; i++ )
-                {
-                    if( nKeyOriBandNumber == atoi(papszBandNumbers[i]) )
-                    {
-                        nTargetBandNumber = i + 1;
-                        break;
-                    }
-                }
-                if( nTargetBandNumber > 0 )
-                {
-                    char szModKey[256];
-                    const char* pszAfterBand =
-                        strchr(pszGDALKey + strlen("BAND_"), '_');
-                    if( pszAfterBand != NULL )
-                    {
-                        // Special case to generate 3D netCDF files
-                        if( bIsNetCDFOutput &&
-                            strncmp(pszAfterBand, "_default_NETCDF_DIM_",
-                                    strlen("_default_NETCDF_DIM_")) == 0 )
-                        {
-                            const char* pszDimName = pszAfterBand +
-                                                strlen("_default_NETCDF_DIM_");
-                            if( osExtraDimName.empty() )
-                            {
-                                bExtraDimValid = true;
-                                osExtraDimName = pszDimName;
-                                oMapExtraDimValues[nTargetBandNumber] = pszValue;
-                            }
-                            else if( bExtraDimValid )
-                            {
-                                if( osExtraDimName != pszDimName )
-                                {
-                                    msDebug("One band has several %sdefault_NETCDF_DIM_ metadata items, "
-                                            "or different bands have a different value. "
-                                            "Only a single extra dimension is supported.",
-                                            szKeyBeginning);
-                                    bExtraDimValid = false;
-                                }
-                                else
-                                {
-                                    oMapExtraDimValues[nTargetBandNumber] = pszValue;
-                                }
-                            }
-                        }
-                        else
-                        {
-                            snprintf(szModKey, sizeof(szModKey),
-                                     "mdi_BAND_%d%s",
-                                     nTargetBandNumber,
-                                     pszAfterBand);
-                            if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                                msDebug("Setting GDAL %s=%s metadata item option\n",
-                                        szModKey, pszValue);
-                            }
-                            msSetOutputFormatOption(format, szModKey, pszValue);
-                        }
-                    }
-                }
-            }
-            else
-            {
-                char szModKey[256];
-                snprintf(szModKey, sizeof(szModKey),
-                         "mdi_%s", pszGDALKey);
-                if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                    msDebug("Setting GDAL %s=%s metadata item option\n",
-                            szModKey, pszValue);
-                }
-                msSetOutputFormatOption(format, szModKey, pszValue);
-            }
-        }
-    }
-
-    // netCDF 3D output
-    // Tested in msautotest/wxs/wcs_netcdf_3d_output.map
-    std::string osExtraDimDataType;
-    if( bExtraDimValid && static_cast<int>(oMapExtraDimValues.size()) != nBands )
-    {
-        msDebug("One of the band lack a NETCDF_DIM_%s metadata item.",
-                osExtraDimName.c_str());
-        bExtraDimValid = false;
-    }
-    if( bExtraDimValid )
-    {
-        for( const auto& keyValue: oMapExtraDimValues )
-        {
-            const auto& osVal = keyValue.second;
-            const CPLValueType eType = CPLGetValueType(osVal.c_str());
-            if( eType == CPL_VALUE_STRING )
-            {
-                osExtraDimDataType = "string";
-                break;
-            }
-            else if( eType == CPL_VALUE_INTEGER )
-            {
-                if( osExtraDimDataType.empty() || osExtraDimDataType == "integer" )
-                {
-                    osExtraDimDataType = "integer";
-                    const GIntBig nVal = CPLAtoGIntBig(osVal.c_str());
-                    if( nVal > INT_MAX || nVal < INT_MIN )
-                    {
-                        osExtraDimDataType = "integer64";
-                    }
-                }
-            }
-            else
-            {
-                osExtraDimDataType = "double";
-            }
-        }
-        if( osExtraDimDataType == "string" )
-        {
-            msDebug("One of the value for the NETCDF_DIM_%s metadata is a string. "
-                    "This is not supported", osExtraDimName.c_str());
-            bExtraDimValid = false;
-        }
-    }
-    if( bExtraDimValid )
-    {
-        // Cf https://gdal.org/drivers/raster/netcdf.html#creation-of-multidimensional-files-with-createcopy-2d-raster-api
-
-        // Define the name of the extra dimensions
-        {
-            std::string osValue;
-            osValue = '{';
-            osValue += osExtraDimName;
-            osValue += '}';
-
-            msSetOutputFormatOption(format, "mdi_default_NETCDF_DIM_EXTRA", osValue.c_str());
-        }
-
-        // Define the size (in number of samples) and type of the extra dimension
-        {
-            std::string osKey;
-            osKey = "mdi_default_NETCDF_DIM_";
-            osKey += osExtraDimName;
-            osKey += "_DEF";
-
-            std::string osValue;
-            osValue = '{';
-            osValue += CPLSPrintf("%d", nBands);
-            osValue += ',';
-            if( osExtraDimDataType == "integer" )
-                osValue += '4';
-            else if ( osExtraDimDataType == "integer64" )
-                osValue += "10";
-            else /* if ( osExtraDimDataType == "double" ) */
-                osValue += '6';
-            osValue += '}';
-
-            msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
-        }
-
-        // Define the values along the extra dimension
-        {
-            std::string osKey;
-            osKey = "mdi_default_NETCDF_DIM_";
-            osKey += osExtraDimName;
-            osKey += "_VALUES";
-            std::string osValue;
-            osValue = '{';
-            bool bFirstVal = true;
-            for( const auto& keyValue: oMapExtraDimValues )
-            {
-                const auto& osVal = keyValue.second;
-                if( !bFirstVal )
-                    osValue += ',';
-                else
-                    bFirstVal = false;
-                osValue += osVal;
-            }
-            osValue += '}';
-
-            msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
-        }
-    }
-
-    msFreeCharArray( papszBandNumbers, nBands );
-}
-
-/************************************************************************/
-/*               msWCSApplySourceDatasetMetadata()                      */
-/************************************************************************/
-
-void msWCSApplySourceDatasetMetadata(layerObj* lp,
-                                     outputFormatObj* format,
-                                     const char* bandlist,
-                                     void* hDSIn)
-{
-    /* Automatic forwarding of input dataset metadata if it is netCDF and the */
-    /* output is netCDF as well, and wcs_outputformat_netCDF_mdi* are */
-    /* not defined. */
-    GDALDatasetH hDS = (GDALDatasetH)hDSIn;
-    if( hDS && GDALGetDatasetDriver(hDS) &&
-        EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "netCDF") &&
-        EQUAL(format->driver, "GDAL/netCDF") )
-    {
-        const char* pszKey;
-        char szKeyBeginning[256];
-        size_t nKeyBeginningLength;
-        int bWCSMetadataFound = MS_FALSE;
-
-        snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-                "wcs_outputformat_%s_mdi_", format->name);
-        nKeyBeginningLength = strlen(szKeyBeginning);
-
-        for( pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-             pszKey != NULL;
-             pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-        {
-            if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-            {
-                bWCSMetadataFound = MS_TRUE;
-                break;
-            }
-        }
-        if( !bWCSMetadataFound )
-        {
-            int nBands = 0;
-            char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-
-            std::string osExtraDimName;
-            // Special processing if the input dataset is a 3D one
-            {
-                // Check if extra dimensions are declared on the source dataset,
-                // and if so, if there's just a single one.
-                const char* pszDimExtraWithCurl = GDALGetMetadataItem(hDS, "NETCDF_DIM_EXTRA", nullptr);
-                if( pszDimExtraWithCurl &&
-                    strchr(pszDimExtraWithCurl, ',') == nullptr &&
-                    pszDimExtraWithCurl[0] == '{' &&
-                    pszDimExtraWithCurl[strlen(pszDimExtraWithCurl)-1] == '}')
-                {
-                    osExtraDimName.append(
-                        pszDimExtraWithCurl + 1, strlen(pszDimExtraWithCurl) - 2);
-
-                    // Declare the extra dimension name
-                    msSetOutputFormatOption(format,
-                                            "mdi_default_NETCDF_DIM_EXTRA",
-                                            pszDimExtraWithCurl);
-
-                    // Declare the extra dimension definition: size + data type
-                    const char* pszDimExtraDef = GDALGetMetadataItem(hDS,
-                         ("NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(), nullptr);
-                    if( pszDimExtraDef && pszDimExtraDef[0] == '{' &&
-                        pszDimExtraDef[strlen(pszDimExtraDef)-1] == '}' )
-                    {
-                        const auto tokens = msStringSplit(
-                            std::string(pszDimExtraDef + 1, strlen(pszDimExtraDef) -2).c_str(), ',');
-                        if( tokens.size() == 2 )
-                        {
-                            const auto varType = tokens[1];
-                            msSetOutputFormatOption(format,
-                                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(),
-                                (std::string("{") + CPLSPrintf("%d", nBands) + ',' + varType + '}').c_str());
-                        }
-                    }
-
-                    // Declare the extra dimension values
-                    const char* pszDimExtraValues = GDALGetMetadataItem(hDS,
-                         ("NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(), nullptr);
-                    if( pszDimExtraValues && pszDimExtraValues[0] == '{' &&
-                        pszDimExtraValues[strlen(pszDimExtraValues)-1] == '}' )
-                    {
-                        const auto tokens = msStringSplit(
-                            std::string(pszDimExtraValues + 1, strlen(pszDimExtraValues) -2).c_str(), ',');
-                        if( static_cast<int>(tokens.size()) == GDALGetRasterCount(hDS) )
-                        {
-                            std::string osValue = "{";
-                            for(int i = 0; i < nBands; i++ )
-                            {
-                                int nSrcBand = atoi(papszBandNumbers[i]);
-                                assert( nSrcBand >= 1 && nSrcBand <= static_cast<int>(tokens.size()) );
-                                if( i > 0 )
-                                    osValue += ',';
-                                osValue += tokens[nSrcBand - 1];
-                            }
-                            osValue += '}';
-
-                            msSetOutputFormatOption(format,
-                                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(),
-                                osValue.c_str());
-                        }
-                    }
-                    else if ( pszDimExtraValues )
-                    {
-                        // If there's a single value
-                        msSetOutputFormatOption(format,
-                                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(),
-                                pszDimExtraValues);
-                    }
-
-                }
-            }
-
-            {
-                char** papszMD = GDALGetMetadata(hDS, NULL);
-                if( papszMD )
-                {
-                    for( char** papszIter = papszMD; *papszIter; ++papszIter )
-                    {
-                        // Copy netCDF global attributes, as well as the ones
-                        // of the extra dimension for 3D netCDF files
-                        if( STARTS_WITH(*papszIter, "NC_GLOBAL#") ||
-                            (!osExtraDimName.empty() &&
-                             STARTS_WITH(*papszIter, osExtraDimName.c_str()) &&
-                             (*papszIter)[osExtraDimName.size()] == '#') )
-                        {
-                            char* pszKey = nullptr;
-                            const char* pszValue = CPLParseNameValue(*papszIter, &pszKey);
-                            if( pszKey && pszValue )
-                            {
-                                char szKey[256];
-                                snprintf(szKey, sizeof(szKey),
-                                    "mdi_default_%s", pszKey);
-                                msSetOutputFormatOption(format, szKey, pszValue);
-                            }
-                            CPLFree(pszKey);
-                        }
-                    }
-                }
-            }
-
-            for(int i = 0; i < nBands; i++ )
-            {
-                int nSrcBand = atoi(papszBandNumbers[i]);
-                int nDstBand = i + 1;
-                GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
-                if( hBand )
-                {
-                    char** papszMD = GDALGetMetadata(hBand, NULL);
-                    if( papszMD )
-                    {
-                        for( char** papszIter = papszMD; *papszIter; ++papszIter )
-                        {
-                            char* pszKey = nullptr;
-                            const char* pszValue = CPLParseNameValue(*papszIter, &pszKey);
-                            if( pszKey && pszValue &&
-                                !EQUAL(pszKey, "grid_name") &&
-                                !EQUAL(pszKey, "grid_mapping") )
-                            {
-                                char szKey[256];
-                                snprintf(szKey, sizeof(szKey),
-                                    "mdi_BAND_%d_default_%s",
-                                    nDstBand, pszKey);
-                                msSetOutputFormatOption(format, szKey, pszValue);
-                            }
-                            CPLFree(pszKey);
-                        }
-                    }
-                }
-            }
-            msFreeCharArray( papszBandNumbers, nBands );
-        }
-    }
-}
-
-/************************************************************************/
-/*                          msWCSGetCoverage()                          */
-/************************************************************************/
-
-static int msWCSGetCoverage(mapObj *map, cgiRequestObj *request,
-                            wcsParamsObj *params, owsRequestObj *ows_request)
-{
-  imageObj   *image;
-  layerObj   *lp;
-  int         status, i;
-  const char *value;
-  outputFormatObj *format;
-  char *bandlist=NULL;
-  size_t bufferSize = 0;
-  char numbands[12]; /* should be large enough to hold the number of bands in the bandlist */
-  coverageMetadataObj cm;
-  rectObj reqextent;
-  rectObj covextent;
-  rasterBufferObj rb;
-  int doDrawRasterLayerDraw = MS_TRUE;
-  GDALDatasetH hDS = NULL;
-
-  char *coverageName;
-
-  /* make sure all required parameters are available (at least the easy ones) */
-  if(!params->crs) {
-    msSetError( MS_WCSERR, "Required parameter CRS was not supplied.", "msWCSGetCoverage()");
-    return msWCSException(map, "MissingParameterValue", "crs", params->version);
-  }
-
-  if(!params->time && !params->bbox.minx && !params->bbox.miny
-      && !params->bbox.maxx && !params->bbox.maxy) {
-    msSetError(MS_WCSERR, "One of BBOX or TIME is required", "msWCSGetCoverage()");
-    return msWCSException(map, "MissingParameterValue", "bbox/time", params->version);
-  }
-
-  if( params->coverages == NULL || params->coverages[0] == NULL ) {
-    msSetError( MS_WCSERR,
-                "Required parameter COVERAGE was not supplied.",
-                "msWCSGetCoverage()");
-    return msWCSException(map, "MissingParameterValue", "coverage", params->version);
-  }
-
-  /* For WCS 1.1, we need to normalize the axis order of the BBOX and
-     resolution values some coordinate systems (eg. EPSG geographic) */
-  if( strncasecmp(params->version,"1.0",3) != 0
-      && params->crs != NULL
-      && strncasecmp(params->crs,"urn:",4) == 0 ) {
-    projectionObj proj;
-
-    msInitProjection( &proj );
-    msProjectionInheritContextFrom(&proj, &(map->projection));
-    if( msLoadProjectionString( &proj, (char *) params->crs ) == 0 ) {
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->bbox.minx),
-                             &(params->bbox.miny) );
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->bbox.maxx),
-                             &(params->bbox.maxy) );
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->resx),
-                             &(params->resy) );
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->originx),
-                             &(params->originy) );
-    } else
-      msResetErrorList();
-    msFreeProjection( &proj );
-  }
-
-  /* find the layer we are working with */
-  lp = NULL;
-  for(i=0; i<map->numlayers; i++) {
-    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO", "name", GET_LAYER(map, i)->name);
-    if( coverageName != NULL && EQUAL(coverageName, params->coverages[0]) &&
-        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-      lp = GET_LAYER(map, i);
-      free( coverageName );
-      break;
-    }
-    free( coverageName );
-  }
-
-  if(lp == NULL) {
-    msSetError( MS_WCSERR, "COVERAGE=%s not found, not in supported layer list. A layer might be disabled for \
-this request. Check wcs/ows_enable_request settings.", "msWCSGetCoverage()", params->coverages[0] );
-    return msWCSException(map, "InvalidParameterValue", "coverage", params->version);
-  }
-
-  /* make sure the layer is on */
-  lp->status = MS_ON;
-  
-  /* If the layer has no projection set, set it to the map's projection (#4079) */
-  if(lp->projection.numargs <=0) {
-    char *map_original_srs = msGetProjectionString(&(map->projection));
-    if (msLoadProjectionString(&(lp->projection), map_original_srs) != 0) {
-      msSetError( MS_WCSERR, "Error when setting map projection to a layer with no projection", "msWCSGetCoverage()" );
-      free(map_original_srs);
-      return msWCSException(map, NULL, NULL, params->version);
-    }
-    free(map_original_srs);
-  }
-
-  /* we need the coverage metadata, since things like numbands may not be available otherwise */
-  status = msWCSGetCoverageMetadata(lp, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  /* fill in bands rangeset info, if required.  */
-  msWCSSetDefaultBandsRangeSetInfo(params, &cm, lp);
-
-  /* handle the response CRS, that is, set the map object projection */
-  if(params->response_crs || params->crs ) {
-    int iUnits;
-    const char *crs_to_use = params->response_crs;
-
-    if( crs_to_use == NULL )
-      crs_to_use = params->crs;
-
-    if (strncasecmp(crs_to_use, "EPSG:", 5) == 0 || strncasecmp(crs_to_use,"urn:ogc:def:crs:",16) == 0 ) {
-      if (msLoadProjectionString(&(map->projection), (char *) crs_to_use) != 0)
-        return msWCSException( map, NULL, NULL,params->version);
-    } else if( strcasecmp(crs_to_use,"imageCRS") == 0 ) {
-      /* use layer native CRS, and rework bounding box accordingly */
-      if( msWCSGetCoverage_ImageCRSSetup( map, params, &cm, lp ) != MS_SUCCESS ) {
-        msWCSFreeCoverageMetadata(&cm);
-        return MS_FAILURE;
-      }
-    } else {  /* should we support WMS style AUTO: projections? (not for now) */
-      msSetError(MS_WCSERR, "Unsupported SRS namespace (only EPSG currently supported).", "msWCSGetCoverage()");
-      return msWCSException(map, "InvalidParameterValue", "srs", params->version);
-    }
-
-    iUnits = GetMapserverUnitUsingProj(&(map->projection));
-    if (iUnits != -1)
-      map->units = static_cast<MS_UNITS>(iUnits);
-  }
-
-  /* did we get a TIME value (support only a single value for now) */
-  if(params->time) {
-    int tli;
-    layerObj *tlp=NULL;
-
-    /* need to handle NOW case */
-
-    /* check format of TIME parameter */
-    if(strchr(params->time, ',')) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Temporal lists are not supported, only individual values.", "msWCSGetCoverage()" );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version);
-    }
-    if(strchr(params->time, '/')) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Temporal ranges are not supported, only individual values.", "msWCSGetCoverage()" );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version);
-    }
-
-    /* TODO: will need to expand this check if a time period is supported */
-    value = msOWSLookupMetadata(&(lp->metadata), "CO", "timeposition");
-    if(!value) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "The coverage does not support temporal subsetting.", "msWCSGetCoverage()" );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version );
-    }
-
-    /* check if timestamp is covered by the wcs_timeposition definition */
-    if (msValidateTimeValue(params->time, value) == MS_FALSE) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "The coverage does not have a time position of %s.", "msWCSGetCoverage()", params->time );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version);
-    }
-
-    /* make sure layer is tiled appropriately */
-    if(!lp->tileindex) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Underlying layer is not tiled, unable to do temporal subsetting.", "msWCSGetCoverage()" );
-      return msWCSException(map, NULL, NULL, params->version);
-    }
-    tli = msGetLayerIndex(map, lp->tileindex);
-    if(tli == -1) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Underlying layer does not use appropriate tiling mechanism.", "msWCSGetCoverage()" );
-      return msWCSException(map, NULL, NULL, params->version);
-    }
-
-    tlp = (GET_LAYER(map, tli));
-
-    /* make sure there is enough information to filter */
-    value = msOWSLookupMetadata(&(lp->metadata), "CO", "timeitem");
-    if(!tlp->filteritem && !value) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Not enough information available to filter.", "msWCSGetCoverage()" );
-      return msWCSException(map, NULL, NULL, params->version);
-    }
-
-    /* override filteritem if specified in metadata */
-    if(value) {
-      if(tlp->filteritem) free(tlp->filteritem);
-      tlp->filteritem = msStrdup(value);
-    }
-
-    /* finally set the filter */
-    msLayerSetTimeFilter(tlp, params->time, value);
-  }
-
-  if( strncasecmp(params->version,"1.0",3) == 0 )
-    status = msWCSGetCoverageBands10( map, request, params, lp, &bandlist );
-  else
-    status = msWCSGetCoverageBands11( map, request, params, lp, &bandlist );
-  if( status != MS_SUCCESS ) {
-    msWCSFreeCoverageMetadata(&cm);
-    return status;
-  }
-
-  /* did we get BBOX values? if not use the exent stored in the coverageMetadataObj */
-  if( fabs((params->bbox.maxx - params->bbox.minx)) < 0.000000000001  || fabs(params->bbox.maxy - params->bbox.miny) < 0.000000000001 ) {
-    params->bbox = cm.extent;
-
-    /* WCS 1.1 boundbox is center of pixel oriented. */
-    if( strncasecmp(params->version,"1.1",3) == 0 ) {
-      params->bbox.minx += cm.geotransform[1]/2 + cm.geotransform[2]/2;
-      params->bbox.maxx -= cm.geotransform[1]/2 + cm.geotransform[2]/2;
-      params->bbox.maxy += cm.geotransform[4]/2 + cm.geotransform[5]/2;
-      params->bbox.miny -= cm.geotransform[4]/2 + cm.geotransform[5]/2;
-    }
-  }
-
-  /* WCS 1.1+ GridOrigin is effectively resetting the minx/maxy
-     BOUNDINGBOX values, so apply that here */
-  if( params->originx != 0.0 || params->originy != 0.0 ) {
-    assert( strncasecmp(params->version,"1.0",3) != 0 ); /* should always be 1.0 in this logic. */
-    params->bbox.minx = params->originx;
-    params->bbox.maxy = params->originy;
-  }
-
-  /* if necessary, project the BBOX to the map->projection */
-  if(params->response_crs && params->crs) {
-    projectionObj tmp_proj;
-
-    msInitProjection(&tmp_proj);
-    msProjectionInheritContextFrom(&tmp_proj, &(map->projection));
-    if (msLoadProjectionString(&tmp_proj, (char *) params->crs) != 0) {
-      msWCSFreeCoverageMetadata(&cm);
-      return msWCSException( map, NULL, NULL, params->version);
-    }
-    msProjectRect(&tmp_proj, &map->projection, &(params->bbox));
-    msFreeProjection(&tmp_proj);
-  }
-
-  /* in WCS 1.1 the default is full resolution */
-  if( strncasecmp(params->version,"1.1",3) == 0 && params->resx == 0.0 && params->resy == 0.0 ) {
-    params->resx = cm.geotransform[1];
-    params->resy = fabs(cm.geotransform[5]);
-  }
-
-  /* compute width/height from BBOX and cellsize.  */
-  if( (params->resx == 0.0 || params->resy == 0.0) && params->width != 0 && params->height != 0 ) {
-    assert( strncasecmp(params->version,"1.0",3) == 0 ); /* should always be 1.0 in this logic. */
-    params->resx = (params->bbox.maxx -params->bbox.minx) / params->width;
-    params->resy = (params->bbox.maxy -params->bbox.miny) / params->height;
-  }
-
-  /* compute cellsize/res from bbox and raster size. */
-  if( (params->width == 0 || params->height == 0) && params->resx != 0 && params->resy != 0 ) {
-
-    /* WCS 1.0 boundbox is edge of pixel oriented. */
-    if( strncasecmp(params->version,"1.0",3) == 0 ) {
-      params->width = (int) ((params->bbox.maxx - params->bbox.minx) / params->resx + 0.5);
-      params->height = (int) ((params->bbox.maxy - params->bbox.miny) / params->resy + 0.5);
-    } else {
-      params->width = (int) ((params->bbox.maxx - params->bbox.minx) / params->resx + 1.000001);
-      params->height = (int) ((params->bbox.maxy - params->bbox.miny) / params->resy + 1.000001);
-
-      /* recompute bounding box so we get exactly the origin and
-         resolution requested. */
-      params->bbox.maxx = params->bbox.minx + (params->width-1) * params->resx;
-      params->bbox.miny = params->bbox.maxy - (params->height-1) * params->resy;
-    }
-  }
-
-  /* are we still underspecified?  */
-  if( (params->width == 0 || params->height == 0) && (params->resx == 0.0 || params->resy == 0.0 )) {
-    msWCSFreeCoverageMetadata(&cm);
-    msSetError( MS_WCSERR, "A non-zero RESX/RESY or WIDTH/HEIGHT is required but neither was provided.", "msWCSGetCoverage()" );
-    return msWCSException(map, "MissingParameterValue", "width/height/resx/resy", params->version);
-  }
-
-  map->cellsize = params->resx;
-
-  /* Do we need to force special handling?  */
-  if( fabs(params->resx/params->resy - 1.0) > 0.001 ) {
-    map->gt.need_geotransform = MS_TRUE;
-    if( map->debug ) msDebug( "RESX and RESY don't match.  Using geotransform/resample.\n");
-  }
-
-  /* Do we have a specified interpolation method */
-  if( params->interpolation != NULL ) {
-    if( strncasecmp(params->interpolation,"NEAREST",7) == 0 )
-      msLayerSetProcessingKey(lp, "RESAMPLE", "NEAREST");
-    else if( strcasecmp(params->interpolation,"BILINEAR") == 0 )
-      msLayerSetProcessingKey(lp, "RESAMPLE", "BILINEAR");
-    else if( strcasecmp(params->interpolation,"AVERAGE") == 0 )
-      msLayerSetProcessingKey(lp, "RESAMPLE", "AVERAGE");
-    else {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "INTERPOLATION=%s specifies an unsupported interpolation method.", "msWCSGetCoverage()", params->interpolation );
-      return msWCSException(map, "InvalidParameterValue", "interpolation", params->version);
-    }
-  }
-
-  /* apply region and size to map object.  */
-  map->width = params->width;
-  map->height = params->height;
-
-  /* Are we exceeding the MAXSIZE limit on result size? */
-  if(map->width > map->maxsize || map->height > map->maxsize ) {
-    msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "Raster size out of range, width and height of resulting coverage must be no more than MAXSIZE=%d.", "msWCSGetCoverage()", map->maxsize);
-
-    return msWCSException(map, "InvalidParameterValue",
-                          "width/height", params->version);
-  }
-
-  /* adjust OWS BBOX to MapServer's pixel model */
-  if( strncasecmp(params->version,"1.0",3) == 0 ) {
-    params->bbox.minx += params->resx*0.5;
-    params->bbox.miny += params->resy*0.5;
-    params->bbox.maxx -= params->resx*0.5;
-    params->bbox.maxy -= params->resy*0.5;
-  }
-
-  map->extent = params->bbox;
-
-  map->cellsize = params->resx; /* pick one, MapServer only supports square cells (what about msAdjustExtent here!) */
-
-  if( params->width == 1 || params->height == 1 )
-      msMapComputeGeotransformEx(map, params->resx, params->resy);
-  else
-      msMapComputeGeotransform(map);
-
-  /* Do we need to fake out stuff for rotated support? */
-  if( map->gt.need_geotransform )
-    msMapSetFakedExtent( map );
-
-  map->projection.gt = map->gt;
-
-  /* check for overlap */
-
-  /* get extent of bbox passed, and reproject */
-  reqextent.minx = map->extent.minx;
-  reqextent.miny = map->extent.miny;
-  reqextent.maxx = map->extent.maxx;
-  reqextent.maxy = map->extent.maxy;
-
-  /* reproject incoming bbox */
-  msProjectRect(&map->projection, &lp->projection, &(reqextent));
-
-  /* get extent of layer */
-  covextent.minx = cm.extent.minx;
-  covextent.miny = cm.extent.miny;
-  covextent.maxx = cm.extent.maxx;
-  covextent.maxy = cm.extent.maxy;
-
-  if(msRectOverlap(&reqextent, &covextent) == MS_FALSE) {
-    msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "Requested BBOX (%.15g,%.15g,%.15g,%.15g) is outside requested coverage BBOX (%.15g,%.15g,%.15g,%.15g)",
-               "msWCSGetCoverage()",
-               reqextent.minx, reqextent.miny, reqextent.maxx, reqextent.maxy,
-               covextent.minx, covextent.miny, covextent.maxx, covextent.maxy);
-    return msWCSException(map, "NoApplicableCode", "bbox", params->version);
-  }
-
-  /* check and make sure there is a format, and that it's valid (TODO: make sure in the layer metadata) */
-  if(!params->format) {
-    msWCSFreeCoverageMetadata(&cm);
-    msSetError( MS_WCSERR,  "Missing required FORMAT parameter.", "msWCSGetCoverage()" );
-    return msWCSException(map, "MissingParameterValue", "format", params->version);
-  }
-  msApplyDefaultOutputFormats(map);
-  if(msGetOutputFormatIndex(map,params->format) == -1) {
-    msWCSFreeCoverageMetadata(&cm);
-    msSetError( MS_WCSERR,  "Unrecognized value for the FORMAT parameter.", "msWCSGetCoverage()" );
-    return msWCSException(map, "InvalidParameterValue", "format",
-                          params->version );
-  }
-
-  /* create a temporary outputformat (we likely will need to tweak parts) */
-  format = msCloneOutputFormat(msSelectOutputFormat(map,params->format));
-  msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
-
-  if(!bandlist) { /* build a bandlist (default is ALL bands) */
-    bufferSize = cm.bandcount*30+30;
-    bandlist = (char *) msSmallMalloc(bufferSize);
-    strcpy(bandlist, "1");
-    for(i = 1; i < cm.bandcount; i++)
-      snprintf(bandlist+strlen(bandlist), bufferSize-strlen(bandlist), ",%d", i+1);
-  }
-
-  /* apply nullvalue to the output format object if we have it */
-  if((value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_nullvalue")) != NULL) {
-    msSetOutputFormatOption( map->outputformat, "NULLVALUE", value );
-  }
-
-  msLayerSetProcessingKey(lp, "BANDS", bandlist);
-  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',')+1);
-  msSetOutputFormatOption(map->outputformat, "BAND_COUNT", numbands);
-
-  msWCSApplyLayerCreationOptions(lp, map->outputformat, bandlist);
-  msWCSApplyLayerMetadataItemOptions(lp, map->outputformat, bandlist);
-
-  if( lp->tileindex == NULL && lp->data != NULL &&
-      strlen(lp->data) > 0 &&
-      lp->connectiontype != MS_KERNELDENSITY )
-  {
-      if( msDrawRasterLayerLowCheckIfMustDraw(map, lp) )
-      {
-          char* decrypted_path = NULL;
-          char szPath[MS_MAXPATHLEN];
-          hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
-                                    map, lp, lp->data, szPath, &decrypted_path);
-          msFree(decrypted_path);
-          if( hDS )
-          {
-            msWCSApplyDatasetMetadataAsCreationOptions(lp, map->outputformat, bandlist, hDS);
-            msWCSApplySourceDatasetMetadata(lp, map->outputformat, bandlist, hDS);
-          }
-      }
-      else
-      {
-          doDrawRasterLayerDraw = MS_FALSE;
-      }
-  }
-
-  free( bandlist );
-
-  if(lp->mask) {
-    int maskLayerIdx = msGetLayerIndex(map,lp->mask);
-    layerObj *maskLayer;
-    outputFormatObj *altFormat;
-    if(maskLayerIdx == -1) {
-      msWCSFreeCoverageMetadata(&cm);
-      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)", "msDrawLayer()",
-                 lp->name,lp->mask);
-      msDrawRasterLayerLowCloseDataset(lp, hDS);
-      return msWCSException(map, NULL, NULL, params->version );
-    }
-    maskLayer = GET_LAYER(map, maskLayerIdx);
-    if(!maskLayer->maskimage) {
-      int i,retcode;
-      int origstatus, origlabelcache;
-      char *origImageType = msStrdup(map->imagetype);
-      altFormat =  msSelectOutputFormat(map, "png24");
-      msInitializeRendererVTable(altFormat);
-      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg */
-      maskLayer->maskimage= msImageCreate(map->width, map->height, altFormat,
-                                          map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, NULL);
-      if (!maskLayer->maskimage) {
-        msWCSFreeCoverageMetadata(&cm);
-        msSetError(MS_MISCERR, "Unable to initialize mask image.", "msDrawLayer()");
-        msFree(origImageType);
-        msDrawRasterLayerLowCloseDataset(lp, hDS);
-        return msWCSException(map, NULL, NULL, params->version );
-      }
-
-      /*
-       * force the masked layer to status on, and turn off the labelcache so that
-       * eventual labels are added to the temporary image instead of being added
-       * to the labelcache
-       */
-      origstatus = maskLayer->status;
-      origlabelcache = maskLayer->labelcache;
-      maskLayer->status = MS_ON;
-      maskLayer->labelcache = MS_OFF;
-
-      /* draw the mask layer in the temporary image */
-      retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
-      maskLayer->status = origstatus;
-      maskLayer->labelcache = origlabelcache;
-      if(retcode != MS_SUCCESS) {
-        msWCSFreeCoverageMetadata(&cm);
-        /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
-        msFree(map->imagetype);
-        map->imagetype = origImageType;
-        msDrawRasterLayerLowCloseDataset(lp, hDS);
-        return msWCSException(map, NULL, NULL, params->version );
-      }
-      /*
-       * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-       * symbols that reference it. We want to remove those references before the altFormat is destroyed
-       * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-       * it's for him.
-       */
-      for(i=0; i<map->symbolset.numsymbols; i++) {
-        if (map->symbolset.symbol[i]!=NULL) {
-          symbolObj *s = map->symbolset.symbol[i];
-          if(s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
-            MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
-            s->renderer = NULL;
-          }
-        }
-      }
-      /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
-      msFree(map->imagetype);
-      map->imagetype = origImageType;
-      
-    }
-  }
-  
-  /* create the image object  */
-  if(!map->outputformat) {
-    msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "The map outputformat is missing!", "msWCSGetCoverage()");
-    msDrawRasterLayerLowCloseDataset(lp, hDS);
-    return msWCSException(map, NULL, NULL, params->version );
-  } else if( MS_RENDERER_RAWDATA(map->outputformat) || MS_RENDERER_PLUGIN(map->outputformat) ) {
-    image = msImageCreate(map->width, map->height, map->outputformat, map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, NULL);
-  } else {
-    msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "Map outputformat not supported for WCS!", "msWCSGetCoverage()");
-    msDrawRasterLayerLowCloseDataset(lp, hDS);
-    return msWCSException(map, NULL, NULL, params->version );
-  }
-
-  if( image == NULL ) {
-    msWCSFreeCoverageMetadata(&cm);
-    msDrawRasterLayerLowCloseDataset(lp, hDS);
-    return msWCSException(map, NULL, NULL, params->version );
-  }
-  if( MS_RENDERER_RAWDATA(map->outputformat) ) {
-    if( doDrawRasterLayerDraw ) {
-      status = msDrawRasterLayerLowWithDataset( map, lp, image, NULL, hDS );
-    } else {
-      status = MS_SUCCESS;
-    }
-  } else {
-    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image,&rb);
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
-      msWCSFreeCoverageMetadata(&cm);
-      msDrawRasterLayerLowCloseDataset(lp, hDS);
-      return MS_FAILURE;
-    }
-
-    /* Actually produce the "grid". */
-    if( doDrawRasterLayerDraw ) {
-      status = msDrawRasterLayerLowWithDataset( map, lp, image, &rb, hDS );
-    } else {
-      status = MS_SUCCESS;
-    }
-  }
-  msDrawRasterLayerLowCloseDataset(lp, hDS);
-
-  if( status != MS_SUCCESS ) {
-    msWCSFreeCoverageMetadata(&cm);
-    msFreeImage(image);
-    return msWCSException(map, NULL, NULL, params->version );
-  }
-
-
-  if( strncmp(params->version, "1.1",3) == 0 ) {
-    msWCSReturnCoverage11( params, map, image );
-  } else { /* WCS 1.0.0 - just return the binary data with a content type */
-    const char *fo_filename;
-
-    /* Do we have a predefined filename? */
-    fo_filename = msGetOutputFormatOption( format, "FILENAME", NULL );
-    if( fo_filename )
-      msIO_setHeader("Content-Disposition","attachment; filename=%s",
-                     fo_filename );
-
-    /* Emit back to client. */
-    msOutputFormatResolveFromImage( map, image );
-    msIO_setHeader("Content-Type","%s",MS_IMAGE_MIME_TYPE(map->outputformat));
-    msIO_sendHeaders();
-    status = msSaveImage(map, image, NULL);
-
-    if( status != MS_SUCCESS ) {
-      /* unfortunately, the image content type will have already been sent
-         but that is hard for us to avoid.  The main error that could happen
-         here is a misconfigured tmp directory or running out of space. */
-      msWCSFreeCoverageMetadata(&cm);
-      return msWCSException(map, NULL, NULL, params->version );
-    }
-  }
-
-  /* Cleanup */
-  msFreeImage(image);
-  msApplyOutputFormat(&(map->outputformat), NULL, MS_NOOVERRIDE);
-  /* msFreeOutputFormat(format); */
-
-  msWCSFreeCoverageMetadata(&cm);
-  return status;
-}
-#endif /* def USE_WCS_SVR */
-
-/************************************************************************/
-/*                           msWCSDispatch()                            */
-/*                                                                      */
-/*      Entry point for WCS requests                                    */
-/************************************************************************/
-
-int msWCSDispatch(mapObj *map, cgiRequestObj *request, owsRequestObj *ows_request)
-{
-#if defined(USE_WCS_SVR)
-  wcs20ParamsObj *params20 = NULL;
-  int status, retVal, operation;
-
-  /* If SERVICE is not set or not WCS exit gracefully. */
-  if (ows_request->service == NULL
-      || !EQUAL(ows_request->service, "WCS")) {
-    return MS_DONE;
-  }
-
-  /* If no REQUEST is set, exit with an error */
-  if (ows_request->request == NULL) {
-    /* The request has to be set. */
-    msSetError(MS_WCSERR, "Missing REQUEST parameter",
-               "msWCSDispatch()");
-    return msWCSException(map, "MissingParameterValue", "request",
-                          ows_request->version );
-  }
-
-  if (EQUAL(ows_request->request, "GetCapabilities")) {
-    operation = MS_WCS_GET_CAPABILITIES;
-  } else if (EQUAL(ows_request->request, "DescribeCoverage")) {
-    operation = MS_WCS_DESCRIBE_COVERAGE;
-  } else if (EQUAL(ows_request->request, "GetCoverage")) {
-    operation = MS_WCS_GET_COVERAGE;
-  } else {
-    msSetError(MS_WCSERR, "Invalid REQUEST parameter \"%s\"",
-               "msWCSDispatch()", ows_request->request);
-    return msWCSException(map, "InvalidParameterValue", "request",
-                          ows_request->version);
-  }
-
-  /* Check the number of enabled layers for the REQUEST */
-  msOWSRequestLayersEnabled(map, "C", ows_request->request, ows_request);
-  if (ows_request->numlayers == 0) {
-    int caps_globally_enabled = MS_FALSE, disabled = MS_FALSE;
-    const char *enable_request;
-    if(operation == MS_WCS_GET_CAPABILITIES) {
-      enable_request = msOWSLookupMetadata(&map->web.metadata, "OC", "enable_request");
-      caps_globally_enabled = msOWSParseRequestMetadata(enable_request, "GetCapabilities", &disabled);
-    }
-
-    if(caps_globally_enabled == MS_FALSE) {
-      msSetError(MS_WCSERR, "WCS request not enabled. Check "
-                 "wcs/ows_enable_request settings.",
-                 "msWCSDispatch()");
-      return msWCSException(map, "InvalidParameterValue", "request",
-                            ows_request->version );
-    }
-  }
-
-  /* Check the VERSION parameter */
-  if (ows_request->version == NULL) {
-    /* If the VERSION parameter is not set, it is either */
-    /* an error (Describe and GetCoverage), or it has to */
-    /* be determined (GetCapabilities). To determine the */
-    /* version, the request has to be fully parsed to    */
-    /* obtain the ACCEPTVERSIONS parameter. If this is   */
-    /* present also, set version to "2.0.1".             */
-
-    if (operation == MS_WCS_GET_CAPABILITIES) {
-      /* Parse it as if it was a WCS 2.0 request */
-      wcs20ParamsObjPtr params_tmp = msWCSCreateParamsObj20();
-      status = msWCSParseRequest20(map, request, ows_request, params_tmp);
-      if (status == MS_FAILURE) {
-        msWCSFreeParamsObj20(params_tmp);
-        return msWCSException(map, "InvalidParameterValue",
-                              "request", "2.0.1");
-      }
-
-      /* VERSION negotiation */
-      if (params_tmp->accept_versions != NULL) {
-        /* choose highest acceptable */
-        int i, highest_version = 0;
-        char version_string[OWS_VERSION_MAXLEN];
-        for(i = 0; params_tmp->accept_versions[i] != NULL; ++i) {
-          int version = msOWSParseVersionString(params_tmp->accept_versions[i]);
-          if (version == OWS_VERSION_BADFORMAT) {
-            msWCSFreeParamsObj20(params_tmp);
-            return msWCSException(map, "InvalidParameterValue",
-                                  "version", NULL );
-          }
-          if(version > highest_version) {
-            highest_version = version;
-          }
-        }
-        msOWSGetVersionString(highest_version, version_string);
-        params_tmp->version = msStrdup(version_string);
-        ows_request->version = msStrdup(version_string);
-      } else {
-        /* set to highest acceptable */
-        params_tmp->version = msStrdup("2.0.1");
-        ows_request->version = msStrdup("2.0.1");
-      }
-
-      /* check if we can keep the params object */
-      if (EQUAL(params_tmp->version, "2.0.1")) {
-        params20 = params_tmp;
-      } else {
-        msWCSFreeParamsObj20(params_tmp);
-      }
-    } else { /* operation != GetCapabilities */
-      /* VERSION is mandatory in other requests */
-      msSetError(MS_WCSERR, "VERSION parameter not set.",
-                 "msWCSDispatch()");
-      return msWCSException(map, "InvalidParameterValue", "version",
-                            NULL );
-    }
-  } else {
-    /* Parse the VERSION parameter */
-    int requested_version = msOWSParseVersionString(ows_request->version);
-    if (requested_version == OWS_VERSION_BADFORMAT) {
-      /* Return an error if the VERSION is */
-      /* in an unsupported format.         */
-      return msWCSException(map, "InvalidParameterValue",
-                            "version", NULL );
-    }
-
-    if (operation == MS_WCS_GET_CAPABILITIES) {
-      /* In case of GetCapabilities, make  */
-      char version_string[OWS_VERSION_MAXLEN];
-      int version, supported_versions[] =
-      {OWS_2_0_1, OWS_2_0_0, OWS_1_1_2, OWS_1_1_1, OWS_1_1_0, OWS_1_0_0};
-      version = msOWSNegotiateVersion(requested_version,
-                                      supported_versions,
-                                      sizeof(supported_versions)/sizeof(int));
-      msOWSGetVersionString(version, version_string);
-      msFree(ows_request->version);
-      ows_request->version = msStrdup(version_string);
-    }
-  }
-
-  /* VERSION specific request handler */
-  if (strcmp(ows_request->version, "1.0.0") == 0
-      || strcmp(ows_request->version, "1.1.0") == 0
-      || strcmp(ows_request->version, "1.1.1") == 0
-      || strcmp(ows_request->version, "1.1.2") == 0) {
-    auto paramsTmp = msWCSCreateParams();
-    status = msWCSParseRequest(request, paramsTmp, map);
-    if (status == MS_FAILURE) {
-      msWCSFreeParams(paramsTmp);
-      free(paramsTmp);
-      return msWCSException(map, "InvalidParameterValue",
-                            "request", "2.0");
-    }
-
-    retVal = MS_FAILURE;
-    if (operation == MS_WCS_GET_CAPABILITIES) {
-      retVal = msWCSGetCapabilities(map, paramsTmp, request, ows_request);
-    } else if (operation == MS_WCS_DESCRIBE_COVERAGE) {
-      retVal = msWCSDescribeCoverage(map, paramsTmp, ows_request, request);
-    } else if (operation == MS_WCS_GET_COVERAGE) {
-      retVal = msWCSGetCoverage(map, request, paramsTmp, ows_request);
-    }
-    msWCSFreeParams(paramsTmp);
-    free(paramsTmp);
-    return retVal;
-  } else if (strcmp(ows_request->version, "2.0.0") == 0
-             || strcmp(ows_request->version, "2.0.1") == 0) {
-#if defined(USE_LIBXML2)
-    int i;
-
-    if (params20 == NULL) {
-      params20 = msWCSCreateParamsObj20();
-      status = msWCSParseRequest20(map, request, ows_request, params20);
-      if (status == MS_FAILURE) {
-        msWCSFreeParamsObj20(params20);
-        return msWCSException(map, "InvalidParameterValue",
-                              "request", "2.0.1");
-      }
-      else if (status == MS_DONE) {
-        /* MS_DONE means, that the exception has already been written to the IO 
-          buffer. 
-        */
-        msWCSFreeParamsObj20(params20);
-        return MS_FAILURE;
-      }
-    }
-
-    /* check if all layer names are valid NCNames */
-    for(i = 0; i < map->numlayers; ++i) {
-      if(!msWCSIsLayerSupported(map->layers[i]))
-        continue;
-
-      /* Check if each layers name is a valid NCName. */
-      if (msEvalRegex("^[a-zA-z_][a-zA-Z0-9_.-]*$" , map->layers[i]->name) == MS_FALSE) {
-        msSetError(MS_WCSERR, "Layer name '%s' is not a valid NCName.",
-                   "msWCSDispatch()", map->layers[i]->name);
-        msWCSFreeParamsObj20(params20);
-        return msWCSException(map, "mapserv", "Internal", "2.0.1");
-      }
-    }
-
-    /* Call operation specific functions */
-    if (operation == MS_WCS_GET_CAPABILITIES) {
-      retVal = msWCSGetCapabilities20(map, request, params20, ows_request);
-    } else if (operation == MS_WCS_DESCRIBE_COVERAGE) {
-      retVal = msWCSDescribeCoverage20(map, params20, ows_request);
-    } else if (operation == MS_WCS_GET_COVERAGE) {
-      retVal = msWCSGetCoverage20(map, request, params20, ows_request);
-    } else {
-      msSetError(MS_WCSERR, "Invalid request '%s'.",
-                 "msWCSDispatch20()", ows_request->request);
-      retVal = msWCSException20(map, "InvalidParameterValue",
-                                "request", "2.0.1");
-    }
-    /* clean up */
-    msWCSFreeParamsObj20(params20);
-    return retVal;
-#else /* def USE_LIBXML2 */
-    msSetError(MS_WCSERR, "WCS 2.0 needs mapserver to be compiled with libxml2.",
-               "msWCSDispatch()");
-    return msWCSException(map, "mapserv", "NoApplicableCode", "2.0.1");
-#endif /* def USE_LIBXML2 */
-  } else { /* unsupported version */
-    msSetError(MS_WCSERR, "WCS Server does not support VERSION %s.",
-               "msWCSDispatch()", ows_request->version);
-    return msWCSException(map, "InvalidParameterValue",
-                          "version", ows_request->version);
-  }
-
-#else
-  msSetError(MS_WCSERR, "WCS server support is not available.", "msWCSDispatch()");
-  return MS_FAILURE;
-#endif
-}
-
-/************************************************************************/
-/*                      msWCSGetCoverageMetadata()                      */
-/************************************************************************/
-
-#ifdef USE_WCS_SVR
-
-void msWCSFreeCoverageMetadata(coverageMetadataObj *cm) {
-  msFree(cm->srs_epsg);
-}
-
-int msWCSGetCoverageMetadata( layerObj *layer, coverageMetadataObj *cm )
-{
-  char  *srs_urn = NULL;
-  int i = 0;
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  /* -------------------------------------------------------------------- */
-  /*      Get the SRS in WCS 1.0 format (eg. EPSG:n)                      */
-  /* -------------------------------------------------------------------- */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &(cm->srs_epsg));
-  if(!cm->srs_epsg) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_TRUE, &(cm->srs_epsg));
-    if(!cm->srs_epsg) {
-      msSetError(MS_WCSERR, "Unable to determine the SRS for this layer, no projection defined and no metadata available.", "msWCSGetCoverageMetadata()");
-      return MS_FAILURE;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Get the SRS in urn format.                                      */
-  /* -------------------------------------------------------------------- */
-  if((srs_urn = msOWSGetProjURN(&(layer->projection), &(layer->metadata),
-                                "CO", MS_TRUE)) == NULL) {
-    srs_urn = msOWSGetProjURN(&(layer->map->projection),
-                              &(layer->map->web.metadata),
-                              "CO", MS_TRUE);
-  }
-
-  if( srs_urn != NULL ) {
-    if( strlen(srs_urn) > sizeof(cm->srs_urn) - 1 ) {
-      msSetError(MS_WCSERR, "SRS URN too long!",
-                 "msWCSGetCoverageMetadata()");
-      return MS_FAILURE;
-    }
-
-    strcpy( cm->srs_urn, srs_urn );
-    msFree( srs_urn );
-  } else
-    cm->srs_urn[0] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*      If we have "virtual dataset" metadata on the layer, then use    */
-  /*      that in preference to inspecting the file(s).                   */
-  /*      We require extent and either size or resolution.                */
-  /* -------------------------------------------------------------------- */
-  if( msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL
-      && (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL
-          || msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL) ) {
-    const char *value;
-
-    /* get extent */
-    cm->extent.minx = 0.0;
-    cm->extent.maxx = 0.0;
-    cm->extent.miny = 0.0;
-    cm->extent.maxy = 0.0;
-    if( msOWSGetLayerExtent( layer->map, layer, "CO", &cm->extent ) == MS_FAILURE )
-      return MS_FAILURE;
-
-    /* get resolution */
-    cm->xresolution = 0.0;
-    cm->yresolution = 0.0;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) != NULL ) {
-      char **tokens;
-      int n;
-
-      tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_resolution metadata.", "msWCSGetCoverageMetadata()");
-        msFreeCharArray( tokens, n );
-        return MS_FAILURE;
-      }
-      cm->xresolution = atof(tokens[0]);
-      cm->yresolution = atof(tokens[1]);
-      msFreeCharArray( tokens, n );
-    }
-
-    /* get Size (in pixels and lines) */
-    cm->xsize = 0;
-    cm->ysize = 0;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "size")) != NULL ) {
-      char **tokens;
-      int n;
-
-      tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_size metadata.", "msWCSGetCoverageDomain()");
-        msFreeCharArray( tokens, n );
-        return MS_FAILURE;
-      }
-      cm->xsize = atoi(tokens[0]);
-      cm->ysize = atoi(tokens[1]);
-      msFreeCharArray( tokens, n );
-    }
-
-    /* try to compute raster size */
-    if( cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 && cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx && cm->extent.miny != cm->extent.maxy ) {
-      cm->xsize = (int) ((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
-      cm->ysize = (int) fabs((cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
-    }
-
-    /* try to compute raster resolution */
-    if( (cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 && cm->ysize != 0 ) {
-      cm->xresolution = (cm->extent.maxx - cm->extent.minx) / cm->xsize;
-      cm->yresolution = (cm->extent.maxy - cm->extent.miny) / cm->ysize;
-    }
-
-    /* do we have information to do anything */
-    if( cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 || cm->ysize == 0 ) {
-      msSetError( MS_WCSERR, "Failed to collect extent and resolution for WCS coverage from metadata for layer '%s'.  Need value wcs|ows_resolution or wcs|ows_size values.", "msWCSGetCoverageMetadata()", layer->name );
-      return MS_FAILURE;
-    }
-
-    /* compute geotransform */
-    cm->geotransform[0] = cm->extent.minx;
-    cm->geotransform[1] = cm->xresolution;
-    cm->geotransform[2] = 0.0;
-    cm->geotransform[3] = cm->extent.maxy;
-    cm->geotransform[4] = 0.0;
-    cm->geotransform[5] = -fabs(cm->yresolution);
-
-    /* get bands count, or assume 1 if not found */
-    cm->bandcount = 1;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) != NULL) {
-      cm->bandcount = atoi(value);
-    }
-
-    /* get bands type, or assume float if not found */
-    cm->imagemode = MS_IMAGEMODE_FLOAT32;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) != NULL ) {
-      if( EQUAL(value,"INT16") )
-        cm->imagemode = MS_IMAGEMODE_INT16;
-      else if( EQUAL(value,"FLOAT32") )
-        cm->imagemode = MS_IMAGEMODE_FLOAT32;
-      else if( EQUAL(value,"BYTE") )
-        cm->imagemode = MS_IMAGEMODE_BYTE;
-      else {
-        msSetError( MS_WCSERR, "Content of wcs|ows_imagemode (%s) not recognised.  Should be one of BYTE, INT16 or FLOAT32.", "msWCSGetCoverageMetadata()", value );
-        return MS_FAILURE;
-      }
-    }
-    /* set color interpretation to undefined */
-    /* TODO: find better solution */
-    for(i = 0; i < 10; ++i) {
-      cm->bandinterpretation[i] = GDALGetColorInterpretationName(GCI_Undefined);
-    }
-  } else if( layer->data == NULL ) { /* no virtual metadata, not ok unless we're talking 1 image, hopefully we can fix that */
-    msSetError( MS_WCSERR, "RASTER Layer with no DATA statement and no WCS virtual dataset metadata.  Tileindexed raster layers not supported for WCS without virtual dataset metadata (cm->extent, wcs_res, wcs_size).", "msWCSGetCoverageDomain()" );
-    return MS_FAILURE;
-  } else { /* work from the file (e.g. DATA) */
-    GDALDatasetH hDS;
-    GDALRasterBandH hBand;
-    char szPath[MS_MAXPATHLEN];
-    char *decrypted_path;
-
-    msGDALInitialize();
-
-    msTryBuildPath3(szPath,  layer->map->mappath, layer->map->shapepath, layer->data);
-    decrypted_path = msDecryptStringTokens( layer->map, szPath );
-    if( !decrypted_path )
-      return MS_FAILURE;
-
-    msAcquireLock( TLOCK_GDAL );
-    {
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        hDS = GDALOpenEx( decrypted_path, GDAL_OF_RASTER, NULL,
-                          (const char* const*)connectionoptions, NULL);
-        CSLDestroy(connectionoptions);
-    }
-    if( hDS == NULL ) {
-      const char *cpl_error_msg = CPLGetLastErrorMsg();
-
-      /* we wish to avoid reporting decrypted paths */
-      if( cpl_error_msg != NULL
-          && strstr(cpl_error_msg,decrypted_path) != NULL
-          && strcmp(decrypted_path,szPath) != 0 )
-        cpl_error_msg = NULL;
-
-      if( cpl_error_msg == NULL )
-        cpl_error_msg = "";
-
-      msReleaseLock( TLOCK_GDAL );
-
-      msSetError( MS_IOERR, "%s", "msWCSGetCoverageMetadata()",
-                  cpl_error_msg );
-
-      msFree( decrypted_path );
-      return MS_FAILURE;
-    }
-    msFree( decrypted_path );
-
-    msGetGDALGeoTransform( hDS, layer->map, layer, cm->geotransform );
-
-    cm->xsize = GDALGetRasterXSize( hDS );
-    cm->ysize = GDALGetRasterYSize( hDS );
-
-    cm->extent.minx = cm->geotransform[0];
-    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize + cm->geotransform[2] * cm->ysize;
-    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize + cm->geotransform[5] * cm->ysize;
-    cm->extent.maxy = cm->geotransform[3];
-
-    cm->xresolution = cm->geotransform[1];
-    cm->yresolution = cm->geotransform[5];
-
-    /* TODO: need to set resolution */
-
-    cm->bandcount = GDALGetRasterCount( hDS );
-
-    if( cm->bandcount == 0 ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_WCSERR, "Raster file %s has no raster bands.  This cannot be used in a layer.", "msWCSGetCoverageMetadata()", layer->data );
-      return MS_FAILURE;
-    }
-
-    hBand = GDALGetRasterBand( hDS, 1 );
-    switch( GDALGetRasterDataType( hBand ) ) {
-      case GDT_Byte:
-        cm->imagemode = MS_IMAGEMODE_BYTE;
-        break;
-      case GDT_Int16:
-        cm->imagemode = MS_IMAGEMODE_INT16;
-        break;
-      default:
-        cm->imagemode = MS_IMAGEMODE_FLOAT32;
-        break;
-    }
-
-    /* color interpretation */
-    for(i = 1; i <= 10 && i <= cm->bandcount; ++i) {
-      GDALColorInterp colorInterp;
-      hBand = GDALGetRasterBand( hDS, i );
-      colorInterp = GDALGetRasterColorInterpretation(hBand);
-      cm->bandinterpretation[i-1] = GDALGetColorInterpretationName(colorInterp);
-    }
-
-    GDALClose( hDS );
-    msReleaseLock( TLOCK_GDAL );
-  }
-
-  /* we must have the bounding box in lat/lon [WGS84(DD)/EPSG:4326] */
-  cm->llextent = cm->extent;
-
-  /* Already in latlong .. use directly. */
-  if( layer->projection.proj != NULL && msProjIsGeographicCRS(&(layer->projection))) {
-    /* no change */
-  }
-
-  else if (layer->projection.numargs > 0 && !msProjIsGeographicCRS(&(layer->projection))) /* check the layer projection */
-    msProjectRect(&(layer->projection), NULL, &(cm->llextent));
-
-  else if (layer->map->projection.numargs > 0 && !msProjIsGeographicCRS(&(layer->map->projection))) /* check the map projection */
-    msProjectRect(&(layer->map->projection), NULL, &(cm->llextent));
-
-  else { /* projection was specified in the metadata only (EPSG:... only at the moment)  */
-    projectionObj proj;
-    char projstring[32];
-
-    msInitProjection(&proj); /* or bad things happen */
-    msProjectionInheritContextFrom(&proj, &(layer->map->projection));
-
-    snprintf(projstring, sizeof(projstring), "init=epsg:%.20s", cm->srs_epsg+5);
-    if (msLoadProjectionString(&proj, projstring) != 0) return MS_FAILURE;
-    msProjectRect(&proj, NULL, &(cm->llextent));
-  }
-
-  return MS_SUCCESS;
-}
-#endif /* def USE_WCS_SVR */
-
diff -pruN 8.0.1-5/mapwcs.h 8.2.0~beta1-1~exp1/mapwcs.h
--- 8.0.1-5/mapwcs.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwcs.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,318 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OpenGIS Web Coverage Server (WCS) Declarations.
- * Author:   Steve Lime, Frank Warmerdam and the MapServer Team
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#ifndef MAPWCS_H
-#define MAPWCS_H
-
-#include "mapserver.h"
-#include "mapowscommon.h"
-#include <limits.h>
-#include <time.h>
-#include <float.h>
-
-#ifndef _WIN32
-#include <sys/time.h>
-#endif
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-/*
- * Definitions
- */
-
-#define MS_WCS_GML_COVERAGETYPE_RECTIFIED_GRID_COVERAGE "RectifiedGridCoverage"
-
-enum {
-  MS_WCS_GET_CAPABILITIES,
-  MS_WCS_DESCRIBE_COVERAGE,
-  MS_WCS_GET_COVERAGE
-};
-
-/*
-** Structure to hold metadata taken from the image or image tile index
-*/
-typedef struct {
-  char *srs_epsg;
-  char srs_urn[500];
-  rectObj extent, llextent;
-  double geotransform[6];
-  int xsize, ysize;
-  double xresolution, yresolution;
-  int bandcount;
-  int imagemode;
-  const char *bandinterpretation[10];
-} coverageMetadataObj;
-
-typedef struct {
-  char *version;    /* 1.0.0 for now */
-  char *updatesequence;   /* string, int or timestampe */
-  char *request;    /* GetCapabilities|DescribeCoverage|GetCoverage */
-  char *service;    /* MUST be WCS */
-  char *section;    /* of capabilities document: /WCS_Capabilities/Service|/WCS_Capabilities/Capability|/WCS_Capabilities/ContentMetadata */
-  char **coverages;   /* NULL terminated list of coverages (in the case of a GetCoverage there will only be 1) */
-  char *crs;          /* request coordinate reference system */
-  char *response_crs; /* response coordinate reference system */
-  rectObj bbox;       /* subset bounding box (3D), although we'll only use 2D */
-  char *time;
-  long width, height, depth;  /* image dimensions */
-  double originx, originy;      /* WCS 1.1 GridOrigin */
-  double resx, resy, resz;      /* resolution */
-  char *interpolation;          /* interpolationMethod */
-  char *format;
-  char *exceptions;   /* exception MIME type, (default application=vnd.ogc.se_xml) */
-} wcsParamsObj;
-
-/* -------------------------------------------------------------------- */
-/*      Prototypes from mapwcs.c used in mapwcs11.c.                    */
-/*                                                                      */
-/*      Note, all prototypes are deliberately not exported from DLL     */
-/*      since they are for internal use within the core.                */
-/* -------------------------------------------------------------------- */
-void msWCSFreeParams(wcsParamsObj *params);
-int msWCSException(mapObj *map, const char *code, const char *locator,
-                   const char *version);
-int msWCSIsLayerSupported(layerObj *layer);
-int msWCSGetCoverageMetadata( layerObj *layer, coverageMetadataObj *cm );
-void msWCSFreeCoverageMetadata(coverageMetadataObj *cm);
-void msWCSSetDefaultBandsRangeSetInfo( wcsParamsObj *params,
-                                       coverageMetadataObj *cm,
-                                       layerObj *lp );
-const char *msWCSGetRequestParameter(cgiRequestObj *request, const char *name);
-void msWCSApplyLayerCreationOptions(layerObj* lp,
-                                    outputFormatObj* format,
-                                    const char* bandlist);
-void msWCSApplyDatasetMetadataAsCreationOptions(layerObj* lp,
-                                                outputFormatObj* format,
-                                                const char* bandlist,
-                                                void* hDSIn);
-void msWCSApplyLayerMetadataItemOptions(layerObj* lp,
-                                        outputFormatObj* format,
-                                        const char* bandlist);
-void msWCSApplySourceDatasetMetadata(layerObj* lp,
-                                     outputFormatObj* format,
-                                     const char* bandlist,
-                                     void* hDSIn);
-/* -------------------------------------------------------------------- */
-/*      Some WCS 1.1 specific functions from mapwcs11.c                 */
-/* -------------------------------------------------------------------- */
-int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request);
-int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request);
-int msWCSReturnCoverage11( wcsParamsObj *params, mapObj *map, imageObj *image);
-int msWCSGetCoverageBands11( mapObj *map, cgiRequestObj *request,
-                             wcsParamsObj *params, layerObj *lp,
-                             char **p_bandlist );
-int msWCSException11(mapObj *map, const char *locator,
-                     const char *exceptionCode, const char *version);
-
-
-/* -------------------------------------------------------------------- */
-/*      Some WCS 2.0 specific functions and structs from mapwcs20.c     */
-/* -------------------------------------------------------------------- */
-
-enum {
-  MS_WCS20_TRIM = 0,
-  MS_WCS20_SLICE = 1
-};
-
-enum {
-  MS_WCS20_ERROR_VALUE = -1,
-  MS_WCS20_SCALAR_VALUE = 0,
-  MS_WCS20_TIME_VALUE = 1,
-  MS_WCS20_UNDEFINED_VALUE = 2
-};
-
-#define MS_WCS20_UNBOUNDED DBL_MAX
-#define MS_WCS20_UNBOUNDED_TIME 0xFFFFFFFF
-
-typedef struct {
-  union {
-    double scalar;
-    time_t time;
-  };
-  int unbounded; /* 0 if bounded, 1 if unbounded */
-} timeScalarUnion;
-
-typedef struct {
-  char *axis;         /* the name of the subsetted axis */
-  int operation;      /* Either TRIM or SLICE */
-  char *crs;          /* optional CRS to use */
-  int timeOrScalar;   /* 0 if scalar value, 1 if time value */
-  timeScalarUnion min; /* Minimum and Maximum of the subsetted axis;*/
-  timeScalarUnion max;
-} wcs20SubsetObj;
-typedef wcs20SubsetObj * wcs20SubsetObjPtr;
-
-typedef struct {
-  char *name;         /* name of the axis */
-  int size;           /* pixelsize of the axis */
-  double resolution;  /* resolution of the axis */
-  double scale;       /* scale of the axis */
-  char *resolutionUOM; /* resolution units of measure */
-  wcs20SubsetObjPtr subset;
-} wcs20AxisObj;
-typedef wcs20AxisObj * wcs20AxisObjPtr;
-
-typedef struct {
-  char *version;      /* 2.0.0 v 2.0.1 */
-  char *request;      /* GetCapabilities|DescribeCoverage|GetCoverage */
-  char *service;      /* MUST be WCS */
-  char **accept_versions; /* NULL terminated list of Accepted versions */
-  char **accept_languages; /* NULL terminated list of Accepted versions */
-  char **sections;    /* NULL terminated list of GetCapabilities sections */
-  char *updatesequence; /* GetCapabilities updatesequence */
-  char **ids;         /* NULL terminated list of coverages (in the case of a GetCoverage there will only be 1) */
-  long width, height; /* image dimensions */
-  double resolutionX; /* image resolution in X axis */
-  double resolutionY; /* image resolution in Y axis */
-  double scale;       /* Overall scale */
-  double scaleX;      /* X-Axis specific scale */
-  double scaleY;      /* Y-Axis specific scale */
-  char *resolutionUnits; /* Units of Measure for resolution */
-  char *format;       /* requested output format */
-  int multipart;      /* flag for multipart GML+image */
-  char *interpolation; /* requested interpolation method */
-  char *outputcrs;    /* requested CRS for output */
-  char *subsetcrs;    /* determined CRS of the subsets */
-  rectObj bbox;       /* determined Bounding Box */
-  int numaxes;        /* number of axes */
-  wcs20AxisObjPtr *axes; /* list of axes, NULL if none*/
-  char **range_subset; /* list of bands selected */
-  char **format_options; /* list of format specific options, NULL terminated */
-} wcs20ParamsObj;
-typedef wcs20ParamsObj * wcs20ParamsObjPtr;
-
-typedef struct {
-  union {
-    struct {
-      char *name;
-      char *interpretation;
-      char *uom;
-      char *definition;
-      char *description;
-    };
-    char *values[5];
-  };
-  double interval_min;
-  double interval_max;
-  int significant_figures;
-} wcs20rasterbandMetadataObj;
-typedef wcs20rasterbandMetadataObj * wcs20rasterbandMetadataObjPtr;
-
-typedef struct {
-  char *native_format;    /* mime type of the native format */
-  char *srs_epsg;
-  char srs_uri[200];
-  rectObj extent;
-  double geotransform[6];
-  double xresolution;
-  double yresolution;
-  int xsize;
-  int ysize;
-  int imagemode;
-  size_t numnilvalues;
-  char **nilvalues;
-  char **nilvalues_reasons;
-  size_t numbands;
-  wcs20rasterbandMetadataObjPtr bands;
-} wcs20coverageMetadataObj;
-typedef wcs20coverageMetadataObj * wcs20coverageMetadataObjPtr;
-
-#define MS_WCS_20_PROFILE_CORE      "http://www.opengis.net/spec/WCS/2.0/conf/core"
-#define MS_WCS_20_PROFILE_KVP       "http://www.opengis.net/spec/WCS_protocol-binding_get-kvp/1.0/conf/get-kvp"
-#define MS_WCS_20_PROFILE_POST      "http://www.opengis.net/spec/WCS_protocol-binding_post-xml/1.0/conf/post-xml"
-#define MS_WCS_20_PROFILE_GML       "http://www.opengis.net/spec/GMLCOV/1.0/conf/gml-coverage"
-#define MS_WCS_20_PROFILE_GML_MULTIPART "http://www.opengis.net/spec/GMLCOV/1.0/conf/multipart"
-#define MS_WCS_20_PROFILE_GML_SPECIAL "http://www.opengis.net/spec/GMLCOV/1.0/conf/special-format"
-#define MS_WCS_20_PROFILE_GML_GEOTIFF "http://www.opengis.net/spec/GMLCOV_geotiff-coverages/1.0/conf/geotiff-coverage"
-#define MS_WCS_20_PROFILE_CRS       "http://www.opengis.net/spec/WCS_service-extension_crs/1.0/conf/crs"
-#define MS_WCS_20_PROFILE_SCALING   "http://www.opengis.net/spec/WCS_service-extension_scaling/1.0/conf/scaling"
-#define MS_WCS_20_PROFILE_RANGESUBSET "http://www.opengis.net/spec/WCS_service-extension_range-subsetting/1.0/conf/record-subsetting"
-#define MS_WCS_20_PROFILE_INTERPOLATION "http://www.opengis.net/spec/WCS_service-extension_interpolation/1.0/conf/interpolation"
-
-/* -------------------------------------------------------------------- */
-/*      WCS 2.0 function prototypes.                                    */
-/* -------------------------------------------------------------------- */
-
-wcs20ParamsObjPtr msWCSCreateParamsObj20();
-void msWCSFreeParamsObj20(wcs20ParamsObjPtr params);
-int msWCSParseRequest20(mapObj *map, cgiRequestObj *request, owsRequestObj *ows_request, wcs20ParamsObjPtr params);
-
-int msWCSException20(mapObj *map, const char *locator, const char *exceptionCode, const char *version);
-
-int msWCSGetCapabilities20(mapObj *map, cgiRequestObj *req, wcs20ParamsObjPtr params, owsRequestObj *ows_request);
-int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params, owsRequestObj *ows_request);
-int msWCSGetCoverage20(mapObj *map, cgiRequestObj *request, wcs20ParamsObjPtr params, owsRequestObj *ows_request);
-
-/* -------------------------------------------------------------------- */
-/*      XML parsing helper macros.                                      */
-/* -------------------------------------------------------------------- */
-
-#define XML_FOREACH_CHILD(parent_node, child_node)              \
-    for(child_node = parent_node->children; child_node != NULL; child_node = child_node->next)
-
-/* Makro to continue the iteration over an xml structure    */
-/* when the current node has the type 'text' or 'comment'   */
-#define XML_LOOP_IGNORE_COMMENT_OR_TEXT(node)                   \
-    if(xmlNodeIsText(node) || node->type == XML_COMMENT_NODE)   \
-    {                                                           \
-        continue;                                               \
-    }
-
-/* Makro to set an XML error that an unknown node type      */
-/* occurred.                                                */
-#define XML_UNKNOWN_NODE_ERROR(node)                            \
-    msSetError(MS_WCSERR, "Unknown XML element '%s'.",          \
-            __FUNCTION__, (char *)node->name);                  \
-    return MS_FAILURE;
-
-#define XML_ASSERT_NODE_NAME(node,nodename)                     \
-    if(EQUAL((char *)node->name, nodename) == MS_FALSE)         \
-    {                                                           \
-        XML_UNKNOWN_NODE_ERROR(node);                           \
-    }
-
-#define MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params,section)  \
-    (params->sections == NULL                                   \
-    || CSLFindString(params->sections, "All") != -1             \
-    || CSLFindString(params->sections, section) != -1)
-
-
-#if defined(USE_LIBXML2)
-#include "maplibxml2.h"
-void msWCS_11_20_PrintMetadataLinks(layerObj *layer, xmlDocPtr doc, xmlNodePtr psCSummary);
-#endif
-
-#ifdef __cplusplus
-} /* extern C */
-#endif
-
-#endif /* nef MAPWCS_H */
diff -pruN 8.0.1-5/mapwcs11.cpp 8.2.0~beta1-1~exp1/mapwcs11.cpp
--- 8.0.1-5/mapwcs11.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwcs11.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1434 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OpenGIS Web Coverage Server (WCS) 1.1.0 Implementation.  This
- *           file holds some WCS 1.1.0 specific functions but other parts
- *           are still implemented in mapwcs.c.
- * Author:   Frank Warmerdam and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 2007, Frank Warmerdam
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include <assert.h>
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapthread.h"
-#include "mapows.h"
-#include "mapwcs.h"
-#include "mapgdal.h"
-
-
-#if defined(USE_WCS_SVR)
-#include "mapwcs.h"
-#include "gdal.h"
-#include "cpl_string.h" /* GDAL string handling */
-#endif
-
-#if defined(USE_LIBXML2)
-#include "maplibxml2.h"
-#endif
-
-#include <string>
-
-#if defined(USE_WCS_SVR) && defined(USE_LIBXML2)
-/*
-** msWCSException11()
-**
-** Report current MapServer error in XML exception format.
-** Wrapper function around msOWSCommonExceptionReport. Merely
-** passes WCS specific info.
-**
-*/
-
-int msWCSException11(mapObj *map, const char *exceptionCode,
-                     const char *locator, const char *version)
-{
-  int size = 0;
-  char *errorString     = NULL;
-  char *schemasLocation = NULL;
-
-  xmlDocPtr  psDoc      = NULL;
-  xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
-
-  psNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-
-  errorString = msGetErrorString("\n");
-  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_1_0, schemasLocation, version, msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
-
-  msIO_printf("%s", buffer);
-
-  /*free buffer and the document */
-  free(errorString);
-  free(schemasLocation);
-  xmlFree(buffer);
-  xmlFreeDoc(psDoc);
-  xmlFreeNs(psNsOws);
-
-  /* clear error since we have already reported it */
-  msResetErrorList();
-
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                       msWCSGetFormatsList11()                        */
-/*                                                                      */
-/*      Fetch back a comma delimited formats list for the past layer    */
-/*      if one is supplied, otherwise for all formats supported by      */
-/*      the server.  Formats should be identified by mime type.         */
-/************************************************************************/
-
-static char *msWCSGetFormatsList11( mapObj *map, layerObj *layer )
-
-{
-  char *format_list = msStrdup("");
-  char **tokens = NULL, **formats = NULL;
-  int  i, numtokens = 0, numformats;
-  char *value;
-
-  msApplyDefaultOutputFormats(map);
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse from layer metadata.                                      */
-  /* -------------------------------------------------------------------- */
-  if( layer != NULL
-      && (value = msOWSGetEncodeMetadata( &(layer->metadata),"CO","formats",
-                                          "GTiff" )) != NULL ) {
-    tokens = msStringSplit(value, ' ', &numtokens);
-    msFree(value);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse from map.web metadata.                                    */
-  /* -------------------------------------------------------------------- */
-  else if((value = msOWSGetEncodeMetadata( &(map->web.metadata), "CO", "formats",
-                                           NULL)) != NULL ) {
-    tokens = msStringSplit(value, ' ', &numtokens);
-    msFree(value);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Or generate from all configured raster output formats that      */
-  /*      look plausible.                                                 */
-  /* -------------------------------------------------------------------- */
-  else {
-    tokens = (char **) calloc(map->numoutputformats,sizeof(char*));
-    for( i = 0; i < map->numoutputformats; i++ ) {
-      switch( map->outputformatlist[i]->renderer ) {
-          /* seeminly normal raster format */
-        case MS_RENDER_WITH_AGG:
-        case MS_RENDER_WITH_RAWDATA:
-          tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
-          break;
-
-          /* rest of formats aren't really WCS compatible */
-        default:
-          break;
-
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Convert outputFormatObj names into mime types and remove        */
-  /*      duplicates.                                                     */
-  /* -------------------------------------------------------------------- */
-  numformats = 0;
-  formats = (char **) calloc(sizeof(char*),numtokens);
-
-  for( i = 0; i < numtokens; i++ ) {
-    int format_i, j;
-    const char *mimetype;
-
-    for( format_i = 0; format_i < map->numoutputformats; format_i++ ) {
-      if( strcasecmp(map->outputformatlist[format_i]->name,
-                     tokens[i]) == 0 )
-        break;
-    }
-
-
-    if( format_i == map->numoutputformats ) {
-      msDebug("Failed to find outputformat info on format '%s', ignore.\n",
-              tokens[i] );
-      continue;
-    }
-
-    mimetype = map->outputformatlist[format_i]->mimetype;
-    if( mimetype == NULL || strlen(mimetype) == 0 ) {
-      msDebug("No mimetime for format '%s', ignoring.\n",
-              tokens[i] );
-      continue;
-    }
-
-    for( j = 0; j < numformats; j++ ) {
-      if( strcasecmp(mimetype,formats[j]) == 0 )
-        break;
-    }
-
-    if( j < numformats ) {
-      msDebug( "Format '%s' ignored since mimetype '%s' duplicates another outputFormatObj.\n",
-               tokens[i], mimetype );
-      continue;
-    }
-
-    formats[numformats++] = msStrdup(mimetype);
-  }
-
-  msFreeCharArray(tokens,numtokens);
-
-  /* -------------------------------------------------------------------- */
-  /*      Turn mimetype list into comma delimited form for easy use       */
-  /*      with xml functions.                                             */
-  /* -------------------------------------------------------------------- */
-  for(i=0; i<numformats; i++) {
-    if(i > 0) {
-      format_list = msStringConcatenate(format_list, (char *) ",");
-    }
-    format_list = msStringConcatenate(format_list, formats[i]);
-  }
-  msFreeCharArray(formats,numformats);
-
-  return format_list;
-}
-
-/************************************************************************/
-/*                   msWCS_11_20_PrintMetadataLink()                    */
-/************************************************************************/
-
-static void msWCS_11_20_PrintMetadataLink(layerObj *layer,
-                                          const std::string& radix,
-                                          xmlDocPtr doc,
-                                          xmlNodePtr psCSummary)
-{
-  const char* value = msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_href").c_str());
-  if (value) {
-    xmlNsPtr psOwsNs = xmlSearchNs( doc, xmlDocGetRootElement(doc), BAD_CAST "ows" );
-    xmlNodePtr psMetadata = xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Metadata", NULL);
-    xmlNsPtr psXlinkNs = xmlSearchNs( doc, xmlDocGetRootElement(doc), BAD_CAST "xlink" );
-    const char *metadatalink_type = msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_type").c_str());
-    const char *metadatalink_format = msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_format").c_str());
-
-    xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "type", BAD_CAST "simple");
-    xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "href", BAD_CAST value);
-    if (metadatalink_type != NULL) {
-      xmlNewProp(psMetadata, BAD_CAST "about", BAD_CAST metadatalink_type);
-    }
-    if (metadatalink_format != NULL) {
-      xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "role", BAD_CAST metadatalink_format);
-    }
-  }
-}
-
-/************************************************************************/
-/*                   msWCS_11_20_PrintMetadataLinks()                   */
-/************************************************************************/
-
-void msWCS_11_20_PrintMetadataLinks(layerObj *layer, xmlDocPtr doc,
-                                    xmlNodePtr psCSummary)
-{
-  const char* list = msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
-  if( list ) {
-    int ntokens = 0;
-    char** tokens = msStringSplit(list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
-      std::string key("metadatalink_");
-      key += tokens[i];
-      msWCS_11_20_PrintMetadataLink(layer, key, doc, psCSummary);
-    }
-    msFreeCharArray(tokens, ntokens);
-    return;
-  }
-
-  msWCS_11_20_PrintMetadataLink(layer, "metadatalink", doc, psCSummary);
-}
-
-/************************************************************************/
-/*                msWCSGetCapabilities11_CoverageSummary()              */
-/*                                                                      */
-/*      Generate a WCS 1.1 CoverageSummary.                             */
-/************************************************************************/
-
-static int msWCSGetCapabilities11_CoverageSummary(
-  mapObj *map,
-  xmlDocPtr doc, xmlNodePtr psContents, layerObj *layer )
-
-{
-  coverageMetadataObj cm;
-  int status;
-  const char *value;
-  char *owned_value;
-  char *format_list;
-  xmlNodePtr psCSummary;
-  xmlNsPtr psOwsNs = xmlSearchNs( doc, psContents, BAD_CAST "ows" );
-  int i = 0;
-
-  status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  psCSummary = xmlNewChild( psContents, NULL, BAD_CAST "CoverageSummary", NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*      Title (from description)                                        */
-  /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "description");
-  if( value == NULL )
-    value = msOWSLookupMetadata( &(layer->metadata), "CO", "title");
-  if( value == NULL )
-    value = layer->name;
-  xmlNewChild( psCSummary, psOwsNs, BAD_CAST "Title", BAD_CAST value );
-
-  /* -------------------------------------------------------------------- */
-  /*      Abstract                                                        */
-  /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "abstract");
-  xmlNewChild( psCSummary, psOwsNs, BAD_CAST "Abstract", BAD_CAST value );
-
-  /* -------------------------------------------------------------------- */
-  /*      Keywords                                                        */
-  /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata(&(layer->metadata), "CO", "keywordlist");
-
-  if (value) {
-    xmlNodePtr psNode;
-
-    psNode = xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Keywords", NULL);
-
-    int n = 0;
-    char** tokens = msStringSplit(value, ',', &n);
-    if (tokens && n > 0) {
-      for (i=0; i<n; i++) {
-        xmlNewChild(psNode, NULL, BAD_CAST "Keyword", BAD_CAST tokens[i] );
-      }
-    }
-    msFreeCharArray(tokens, n);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Metadata Link                                                   */
-  /* -------------------------------------------------------------------- */
-  msWCS_11_20_PrintMetadataLinks(layer, doc, psCSummary);
-
-  /* -------------------------------------------------------------------- */
-  /*      WGS84 bounding box.                                             */
-  /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psCSummary,
-    msOWSCommonWGS84BoundingBox( psOwsNs, 2,
-                                 cm.llextent.minx, cm.llextent.miny,
-                                 cm.llextent.maxx, cm.llextent.maxy ));
-
-  /* -------------------------------------------------------------------- */
-  /*      Supported CRSes.                                                */
-  /* -------------------------------------------------------------------- */
-  if( (owned_value =
-         msOWSGetProjURN( &(layer->projection), &(layer->metadata),
-                          "CO", MS_FALSE)) != NULL ) {
-    /* ok */
-  } else if((owned_value =
-               msOWSGetProjURN( &(layer->map->projection),
-                                &(layer->map->web.metadata),
-                                "CO", MS_FALSE)) != NULL ) {
-    /* ok */
-  } else
-    msDebug( "mapwcs.c: missing required information, no SRSs defined.\n");
-
-  if( owned_value != NULL && strlen(owned_value) > 0 )
-    msLibXml2GenerateList( psCSummary, NULL, "SupportedCRS",
-                           owned_value, ' ' );
-
-  msFree( owned_value );
-
-  /* -------------------------------------------------------------------- */
-  /*      SupportedFormats                                                */
-  /* -------------------------------------------------------------------- */
-  format_list = msWCSGetFormatsList11( map, layer );
-
-  if (strlen(format_list) > 0 )
-    msLibXml2GenerateList( psCSummary, NULL, "SupportedFormat",
-                           format_list, ',' );
-
-  msFree( format_list );
-  msWCSFreeCoverageMetadata(&cm);
-
-  /* -------------------------------------------------------------------- */
-  /*      Identifier (layer name)                                         */
-  /* -------------------------------------------------------------------- */
-  xmlNewChild( psCSummary, NULL, BAD_CAST "Identifier", BAD_CAST layer->name );
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                       msWCSGetCapabilities11()                       */
-/************************************************************************/
-int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
-  xmlNodePtr psRootNode, psMainNode, psNode;
-  char *identifier_list = NULL, *format_list = NULL;
-  const char *updatesequence=NULL;
-  xmlNsPtr psOwsNs, psXLinkNs;
-  char *schemaLocation = NULL;
-  char *xsi_schemaLocation = NULL;
-  char *script_url=NULL, *script_url_encoded=NULL;
-
-  xmlChar *buffer = NULL;
-  int size = 0, i;
-  msIOContext *context = NULL;
-
-  int ows_version = OWS_1_1_0;
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle updatesequence                                           */
-  /* -------------------------------------------------------------------- */
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
-
-  if (params->updatesequence != NULL) {
-    i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
-    if (i == 0) { /* current */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
-      return msWCSException11(map, "CurrentUpdateSequence", "updatesequence", params->version);
-    }
-    if (i > 0) { /* invalid */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
-      return msWCSException11(map, "InvalidUpdateSequence", "updatesequence", params->version);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Build list of layer identifiers available.                      */
-  /* -------------------------------------------------------------------- */
-  identifier_list = msStrdup("");
-  for(i=0; i<map->numlayers; i++) {
-    layerObj *layer = map->layers[i];
-    int       new_length;
-
-    if(!msWCSIsLayerSupported(layer))
-      continue;
-
-    new_length = strlen(identifier_list) + strlen(layer->name) + 2;
-    identifier_list = (char *) realloc(identifier_list,new_length);
-
-    if( strlen(identifier_list) > 0 )
-      strcat( identifier_list, "," );
-    strcat( identifier_list, layer->name );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create document.                                                */
-  /* -------------------------------------------------------------------- */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "Capabilities");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* -------------------------------------------------------------------- */
-  /*      Name spaces                                                     */
-  /* -------------------------------------------------------------------- */
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
-  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  psXLinkNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
-
-  /*xmlNewProp(psRootNode, BAD_CAST " */
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version );
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
-
-  if (updatesequence)
-    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
-
-  schemaLocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-  xsi_schemaLocation = msStrdup("http://www.opengis.net/wcs/1.1");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/wcs/1.1/wcsGetCapabilities.xsd ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-  msFree(schemaLocation);
-  msFree(xsi_schemaLocation);
-
-  /* -------------------------------------------------------------------- */
-  /*      Service metadata.                                               */
-  /* -------------------------------------------------------------------- */
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"ServiceIdentification") != NULL ) {
-    xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
-                              psOwsNs, map, "OGC WCS", "2.0.1,1.1.1,1.0.0", "CO", NULL));
-  }
-
-  /*service provider*/
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"ServiceProvider") != NULL ) {
-    xmlAddChild(psRootNode, msOWSCommonServiceProvider(
-                              psOwsNs, psXLinkNs, map, "CO", NULL));
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Operations metadata.                                            */
-  /* -------------------------------------------------------------------- */
-  /*operation metadata */
-  if ((script_url=msOWSGetOnlineResource(map, "CO", "onlineresource", req)) == NULL
-      || (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
-    msSetError(MS_WCSERR, "Server URL not found", "msWCSGetCapabilities11()");
-    return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
-  }
-  free( script_url );
-
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"OperationsMetadata") != NULL ) {
-    psMainNode= xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psOwsNs));
-
-    /* -------------------------------------------------------------------- */
-    /*      GetCapabilities - add Sections and AcceptVersions?              */
-    /* -------------------------------------------------------------------- */
-    psNode = msOWSCommonOperationsMetadataOperation(
-               psOwsNs, psXLinkNs,
-               "GetCapabilities", OWS_METHOD_GETPOST, script_url_encoded);
-
-    xmlAddChild(psMainNode, psNode);
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                  ows_version, psOwsNs, "Parameter", "service", "WCS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                  ows_version, psOwsNs, "Parameter", "version", (char *)params->version));
-
-    /* -------------------------------------------------------------------- */
-    /*      DescribeCoverage                                                */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE)) {
-      psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "DescribeCoverage", OWS_METHOD_GETPOST, script_url_encoded);
-
-      xmlAddChild(psMainNode, psNode);
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "service", "WCS"));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "version", (char *)params->version));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "identifiers", identifier_list ));
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      GetCoverage                                                     */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE)) {
-
-      psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "GetCoverage", OWS_METHOD_GETPOST, script_url_encoded);
-
-      format_list = msWCSGetFormatsList11( map, NULL );
-
-      xmlAddChild(psMainNode, psNode);
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "service", "WCS"));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "version", (char *)params->version));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "Identifier", identifier_list ));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "InterpolationType",
-                    "NEAREST_NEIGHBOUR,BILINEAR" ));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "format", format_list ));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "store", "false" ));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "GridBaseCRS",
-                    "urn:ogc:def:crs:epsg::4326" ));
-
-      msFree( format_list );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Contents section.                                               */
-  /* -------------------------------------------------------------------- */
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"Contents") != NULL ) {
-    psMainNode = xmlNewChild( psRootNode, NULL, BAD_CAST "Contents", NULL );
-
-    if(ows_request->numlayers == 0) {
-      xmlAddChild(psMainNode,
-                  xmlNewComment(BAD_CAST "WARNING: No WCS layers are enabled. "
-                                "Check wcs/ows_enable_request settings."));
-    } else {
-      for(i=0; i<map->numlayers; i++) {
-        layerObj *layer = map->layers[i];
-        int       status;
-
-        if(!msWCSIsLayerSupported(layer))
-          continue;
-
-        if (!msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers))
-          continue;
-
-        status = msWCSGetCapabilities11_CoverageSummary(
-                   map, psDoc, psMainNode, layer );
-        if(status != MS_SUCCESS) {
-          msFree(identifier_list);
-          return MS_FAILURE;
-        }
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document.                                         */
-  /* -------------------------------------------------------------------- */
-
-  if( msIO_needBinaryStdout() == MS_FAILURE )
-    return MS_FAILURE;
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  context = msIO_getHandler(stdout);
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
-  msIO_contextWrite(context, buffer, size);
-  xmlFree(buffer);
-
-  /*free buffer and the document */
-  /*xmlFree(buffer);*/
-  xmlFreeDoc(psDoc);
-
-  xmlCleanupParser();
-
-  /* clean up */
-  free( script_url_encoded );
-  free( identifier_list );
-
-  return(MS_SUCCESS);
-}
-
-/************************************************************************/
-/*            msWCSDescribeCoverage_CoverageDescription11()             */
-/************************************************************************/
-
-static int
-msWCSDescribeCoverage_CoverageDescription11(
-  layerObj *layer, wcsParamsObj *params, xmlNodePtr psRootNode,
-  xmlNsPtr psOwsNs )
-
-{
-  int status;
-  coverageMetadataObj cm;
-  xmlNodePtr psCD, psDomain, psSD, psGridCRS;
-  const char *value;
-
-  /* -------------------------------------------------------------------- */
-  /*      Verify layer is processable.                                    */
-  /* -------------------------------------------------------------------- */
-  if( msCheckParentPointer(layer->map,"map") == MS_FAILURE )
-    return MS_FAILURE;
-
-  if(!msWCSIsLayerSupported(layer))
-    return MS_SUCCESS;
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup coverage metadata.                                        */
-  /* -------------------------------------------------------------------- */
-  status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return status;
-
-  /* fill in bands rangeset info, if required.  */
-  msWCSSetDefaultBandsRangeSetInfo( params, &cm, layer );
-
-  /* -------------------------------------------------------------------- */
-  /*      Create CoverageDescription node.                                */
-  /* -------------------------------------------------------------------- */
-  psCD = xmlNewChild( psRootNode, NULL, BAD_CAST "CoverageDescription", NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*      Title (from description)                                        */
-  /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "description");
-  if( value == NULL )
-    value = layer->name;
-  xmlNewChild( psCD, psOwsNs, BAD_CAST "Title", BAD_CAST value );
-
-  /* -------------------------------------------------------------------- */
-  /*      Abstract                                                        */
-  /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "abstract");
-  xmlNewChild( psCD, psOwsNs, BAD_CAST "Abstract", BAD_CAST value );
-
-  /* -------------------------------------------------------------------- */
-  /*      Keywords                                                        */
-  /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata(&(layer->metadata), "CO", "keywordlist");
-
-  if (value)
-    msLibXml2GenerateList(
-      xmlNewChild(psCD, psOwsNs, BAD_CAST "Keywords", NULL),
-      NULL, "Keyword", value, ',' );
-
-  /* -------------------------------------------------------------------- */
-  /*      Identifier (layer name)                                         */
-  /* -------------------------------------------------------------------- */
-  xmlNewChild( psCD, NULL, BAD_CAST "Identifier", BAD_CAST layer->name);
-
-  /* -------------------------------------------------------------------- */
-  /*      Domain                                                          */
-  /* -------------------------------------------------------------------- */
-  psDomain = xmlNewChild( psCD, NULL, BAD_CAST "Domain", NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*      SpatialDomain                                                   */
-  /* -------------------------------------------------------------------- */
-  psSD = xmlNewChild( psDomain, NULL, BAD_CAST "SpatialDomain", NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*      imageCRS bounding box.                                          */
-  /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psSD,
-    msOWSCommonBoundingBox( psOwsNs, "urn:ogc:def:crs:OGC::imageCRS",
-                            2, 0, 0, cm.xsize-1, cm.ysize-1 ));
-
-  /* -------------------------------------------------------------------- */
-  /*      native CRS bounding box.                                        */
-  /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psSD,
-    msOWSCommonBoundingBox( psOwsNs, cm.srs_urn, 2,
-                            cm.extent.minx, cm.extent.miny,
-                            cm.extent.maxx, cm.extent.maxy ));
-
-  /* -------------------------------------------------------------------- */
-  /*      WGS84 bounding box.                                             */
-  /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psSD,
-    msOWSCommonWGS84BoundingBox( psOwsNs, 2,
-                                 cm.llextent.minx, cm.llextent.miny,
-                                 cm.llextent.maxx, cm.llextent.maxy ));
-
-  /* -------------------------------------------------------------------- */
-  /*      GridCRS                                                         */
-  /* -------------------------------------------------------------------- */
-  {
-    char format_buf[500];
-    projectionObj proj;
-    double x0 = cm.geotransform[0]+cm.geotransform[1]/2+cm.geotransform[2]/2;
-    double y0 = cm.geotransform[3]+cm.geotransform[4]/2+cm.geotransform[5]/2;
-    double resx = cm.geotransform[1];
-    double resy = cm.geotransform[5];
-
-    msInitProjection( &proj );
-    msProjectionInheritContextFrom(&proj, &(layer->projection));
-    if( msLoadProjectionString( &proj, cm.srs_urn ) == 0 ) {
-      msAxisNormalizePoints( &proj, 1, &x0, &y0 );
-      msAxisNormalizePoints( &proj, 1, &resx, &resy );
-    }
-    msFreeProjection( &proj );
-
-    psGridCRS = xmlNewChild( psSD, NULL, BAD_CAST "GridCRS", NULL );
-
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridBaseCRS", BAD_CAST cm.srs_urn );
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridType",
-                 BAD_CAST "urn:ogc:def:method:WCS:1.1:2dSimpleGrid" );
-
-    sprintf( format_buf, "%.15g %.15g", x0, y0 );
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridOrigin", BAD_CAST format_buf );
-
-    sprintf( format_buf, "%.15g %.15g", resx, resy );
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridOffsets", BAD_CAST format_buf );
-
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridCS",
-                 BAD_CAST "urn:ogc:def:cs:OGC:0.0:Grid2dSquareCS" );
-  }
-
-
-
-#ifdef notdef
-  /* TemporalDomain */
-
-  /* TODO: figure out when a temporal domain is valid, for example only tiled rasters support time as a domain, plus we need a timeitem */
-  if(msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") || msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
-    msIO_printf("      <temporalDomain>\n");
-
-    /* TimePosition (should support a value AUTO, then we could mine positions from the timeitem) */
-    msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
-
-    /* TODO:  add TimePeriod (only one per layer)  */
-
-    msIO_printf("      </temporalDomain>\n");
-  }
-
-  msIO_printf("    </domainSet>\n");
-#endif
-
-  /* -------------------------------------------------------------------- */
-  /*      Range                                                           */
-  /* -------------------------------------------------------------------- */
-  {
-    xmlNodePtr psField, psInterpMethods, psAxis;
-    char *value;
-
-    psField =
-      xmlNewChild(
-        xmlNewChild( psCD, NULL, BAD_CAST "Range", NULL ),
-        NULL, BAD_CAST "Field", NULL );
-
-    value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                    "rangeset_label", NULL );
-    if( value )
-      xmlNewChild( psField, psOwsNs, BAD_CAST "Title", BAD_CAST value );
-    msFree(value);
-
-    /* ows:Abstract? TODO */
-
-    value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                    "rangeset_name", "raster" );
-    xmlNewChild( psField, NULL, BAD_CAST "Identifier", BAD_CAST value );
-    msFree(value);
-
-    xmlNewChild(
-        xmlNewChild( psField, NULL, BAD_CAST "Definition", NULL ),
-        psOwsNs, BAD_CAST "AnyValue", NULL );
-
-    /* NullValue */
-    value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                    "rangeset_nullvalue", NULL);
-    if( value )
-      xmlNewChild( psField, NULL, BAD_CAST "NullValue",
-                   BAD_CAST value );
-    msFree(value);
-
-    /* InterpolationMethods */
-    psInterpMethods =
-      xmlNewChild( psField, NULL, BAD_CAST "InterpolationMethods", NULL );
-
-    xmlNewChild( psInterpMethods, NULL, BAD_CAST "InterpolationMethod", BAD_CAST "bilinear" );
-    xmlNewChild( psInterpMethods, NULL,
-                 BAD_CAST "Default", BAD_CAST "nearest neighbor" );
-
-    /* -------------------------------------------------------------------- */
-    /*      Bands axis.                                                     */
-    /* -------------------------------------------------------------------- */
-    {
-      xmlNodePtr psKeys;
-      int iBand;
-
-      value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                      "bands_name", "bands" );
-      psAxis = xmlNewChild( psField, NULL, BAD_CAST "Axis", NULL );
-      xmlNewProp( psAxis, BAD_CAST "identifier", BAD_CAST value );
-      msFree(value);
-
-      psKeys = xmlNewChild( psAxis, NULL, BAD_CAST
-                            "AvailableKeys",  NULL );
-
-      for( iBand = 0; iBand < cm.bandcount; iBand++ ) {
-        char szBandName[32];
-
-        snprintf( szBandName, sizeof(szBandName), "%d", iBand+1 );
-        xmlNewChild( psKeys, NULL, BAD_CAST "Key",
-                     BAD_CAST szBandName );
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      SupportedCRS                                                    */
-  /* -------------------------------------------------------------------- */
-  {
-    char *owned_value;
-
-    if( (owned_value =
-           msOWSGetProjURN( &(layer->projection), &(layer->metadata),
-                            "CO", MS_FALSE)) != NULL ) {
-      /* ok */
-    } else if((owned_value =
-                 msOWSGetProjURN( &(layer->map->projection),
-                                  &(layer->map->web.metadata),
-                                  "CO", MS_FALSE)) != NULL ) {
-      /* ok */
-    } else
-      msDebug( "mapwcs.c: missing required information, no SRSs defined.\n");
-
-    if( owned_value != NULL && strlen(owned_value) > 0 )
-      msLibXml2GenerateList( psCD, NULL, "SupportedCRS",
-                             owned_value, ' ' );
-
-    msFree( owned_value );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      SupportedFormats                                                */
-  /* -------------------------------------------------------------------- */
-  {
-    char *format_list;
-
-    format_list = msWCSGetFormatsList11( layer->map, layer );
-
-    if (strlen(format_list) > 0 )
-      msLibXml2GenerateList( psCD, NULL, "SupportedFormat",
-                             format_list, ',' );
-
-    msFree( format_list );
-  }
-  msWCSFreeCoverageMetadata(&cm);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                      msWCSDescribeCoverage11()                       */
-/************************************************************************/
-
-int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
-  xmlNodePtr psRootNode;
-  xmlNsPtr psOwsNs;
-  char *schemaLocation = NULL;
-  char *xsi_schemaLocation = NULL;
-
-  int i,j;
-
-  /* -------------------------------------------------------------------- */
-  /*      We will actually get the coverages list as a single item in     */
-  /*      a string list with that item having the comma delimited         */
-  /*      coverage names.  Split it up now, and assign back in place      */
-  /*      of the old coverages list.                                      */
-  /* -------------------------------------------------------------------- */
-  if( CSLCount(params->coverages) == 1 ) {
-    char **old_coverages = params->coverages;
-    params->coverages = CSLTokenizeStringComplex( old_coverages[0], ",",
-                        FALSE, FALSE );
-    CSLDestroy( old_coverages );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Validate that the requested coverages exist as named layers.    */
-  /* -------------------------------------------------------------------- */
-  if(params->coverages) { /* use the list */
-    for( j = 0; params->coverages[j]; j++ ) {
-      i = msGetLayerIndex(map, params->coverages[j]);
-      if ( (i == -1) ||
-           (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-        msSetError( MS_WCSERR,
-                    "COVERAGE %s cannot be opened / does not exist",
-                    "msWCSDescribeCoverage()", params->coverages[j]);
-        return msWCSException11(map, "CoverageNotDefined", "coverage", params->version);
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create document.                                                */
-  /* -------------------------------------------------------------------- */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "CoverageDescriptions");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* -------------------------------------------------------------------- */
-  /*      Name spaces                                                     */
-  /* -------------------------------------------------------------------- */
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
-  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
-
-  schemaLocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-  xsi_schemaLocation = msStrdup("http://www.opengis.net/wcs/1.1");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/wcs/1.1/wcsDescribeCoverage.xsd ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-  msFree(schemaLocation);
-  msFree(xsi_schemaLocation);
-
-  /* -------------------------------------------------------------------- */
-  /*      Generate a CoverageDescription for each requested coverage.     */
-  /* -------------------------------------------------------------------- */
-
-  if(params->coverages) { /* use the list */
-    for( j = 0; params->coverages[j]; j++ ) {
-      i = msGetLayerIndex(map, params->coverages[j]);
-      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)),
-          params, psRootNode,
-          psOwsNs );
-    }
-  } else { /* return all layers */
-    for(i=0; i<map->numlayers; i++) {
-
-      if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-        continue;
-
-      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)),
-          params, psRootNode,
-          psOwsNs );
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document.                                         */
-  /* -------------------------------------------------------------------- */
-  {
-    xmlChar *buffer = NULL;
-    int size = 0;
-    msIOContext *context = NULL;
-
-    if( msIO_needBinaryStdout() == MS_FAILURE )
-      return MS_FAILURE;
-
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-    msIO_sendHeaders();
-
-    context = msIO_getHandler(stdout);
-
-    xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
-    msIO_contextWrite(context, buffer, size);
-    xmlFree(buffer);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Cleanup                                                         */
-  /* -------------------------------------------------------------------- */
-  xmlFreeDoc(psDoc);
-  xmlCleanupParser();
-
-  return MS_SUCCESS;
-}
-
-#endif /* defined(USE_WCS_SVR) && defined(USE_LIBXML2) */
-
-/************************************************************************/
-/*                      msWCSGetCoverageBands11()                       */
-/*                                                                      */
-/*      We expect input to be of the form:                              */
-/*      RangeSubset=raster:interpolation[bands[1]].                     */
-/*                                                                      */
-/*      RangeSet=raster:[bands[1,2]]                                    */
-/*       or                                                             */
-/*      RangeSet=raster:bilinear                                        */
-/*                                                                      */
-/*      This function tries to return a bandlist if found, and will     */
-/*      also push an INTERPOLATION keyword into the parameters list     */
-/*      if found in the RangeSubset.                                    */
-/************************************************************************/
-
-#if defined(USE_WCS_SVR)
-int msWCSGetCoverageBands11( mapObj *map, cgiRequestObj *request,
-                             wcsParamsObj *params, layerObj *lp,
-                             char **p_bandlist )
-
-{
-  char *rangesubset, *field_id;
-  const char *axis_id;
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch the RangeSubset from the parameters, skip building a      */
-  /*      bands list if not found.                                        */
-  /* -------------------------------------------------------------------- */
-  const char* value = msWCSGetRequestParameter(request, "RangeSubset");
-  if( value == NULL )
-    return MS_SUCCESS;
-
-  rangesubset = msStrdup(value);
-
-  /* -------------------------------------------------------------------- */
-  /*      What is the <Field identifier=...> (rangeset_name)?             */
-  /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(lp->metadata), "CO", "rangeset_name" );
-  if( value == NULL )
-    value = "raster";
-  field_id = msStrdup(value);
-
-  /* -------------------------------------------------------------------- */
-  /*      What is the <Axis identifier=...> (bands_name)?                 */
-  /* -------------------------------------------------------------------- */
-  axis_id = msOWSLookupMetadata( &(lp->metadata), "CO", "bands_name" );
-  if( axis_id == NULL )
-    axis_id = "bands";
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse out the field identifier from the request and verify.     */
-  /* -------------------------------------------------------------------- */
-  value = rangesubset + strlen(field_id);
-
-  if( strcasecmp(rangesubset,field_id) == 0 ) {
-    free(rangesubset);
-    free(field_id);
-    return MS_SUCCESS; /* we only got field ... default options */
-  }
-
-  if( strlen(rangesubset) <= strlen(field_id)+1
-      || strncasecmp(rangesubset,field_id,strlen(field_id)) != 0
-      || (*value != '[' && *value != ':') ) {
-    msSetError( MS_WCSERR,
-                "RangeSubset field name malformed, expected '%s', got RangeSubset=%s",
-                "msWCSGetCoverageBands11()",
-                field_id, rangesubset );
-    free(rangesubset);
-    free(field_id);
-    return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
-  }
-
-  free( field_id );
-  field_id = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse out the interpolation, if found.                          */
-  /* -------------------------------------------------------------------- */
-  if( *value == ':' ) {
-    assert( params->interpolation == NULL );
-    params->interpolation = msStrdup(value+1);
-    for( i = 0; params->interpolation[i] != '\0'; i++ ) {
-      if( params->interpolation[i] == '[' ) {
-        params->interpolation[i] = '\0';
-        break;
-      }
-    }
-
-    value += strlen(params->interpolation) + 1;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse out the axis name, and verify.                            */
-  /* -------------------------------------------------------------------- */
-  if( *value != '[' ) {
-    free(rangesubset);
-    return MS_SUCCESS;
-  }
-
-  value++;
-
-  if( strlen(value) <= strlen(axis_id)+1
-      || strncasecmp(value,axis_id,strlen(axis_id)) != 0
-      || value[strlen(axis_id)] != '[' ) {
-    msSetError( MS_WCSERR,
-                "RangeSubset axis name malformed, expected '%s', got RangeSubset=%s",
-                "msWCSGetCoverageBands11()",
-                axis_id, rangesubset );
-    free(rangesubset);
-    return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse the band list.  Basically assuming the band list is       */
-  /*      everything from here to a close ';'.                            */
-  /* -------------------------------------------------------------------- */
-  value += strlen(axis_id) + 1;
-
-  *p_bandlist = msStrdup(value);
-
-  for( i = 0; (*p_bandlist)[i] != '\0'; i++ ) {
-    if( (*p_bandlist)[i] == '[' ) {
-      (*p_bandlist)[i] = '\0';
-      break;
-    }
-  }
-  free(rangesubset);
-  return MS_SUCCESS;
-}
-#endif
-
-/************************************************************************/
-/*                       msWCSReturnCoverage11()                        */
-/*                                                                      */
-/*      Return a render image as a coverage to the caller with WCS      */
-/*      1.1 "mime" wrapping.                                            */
-/************************************************************************/
-
-#if defined(USE_WCS_SVR)
-int  msWCSReturnCoverage11( wcsParamsObj *params, mapObj *map,
-                            imageObj *image )
-{
-  int status, i;
-  char *filename = NULL;
-  char *base_dir = NULL;
-  const char *fo_filename;
-
-  fo_filename = msGetOutputFormatOption( image->format, "FILENAME", NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch the driver we will be using and check if it supports      */
-  /*      VSIL IO.                                                        */
-  /* -------------------------------------------------------------------- */
-  if( EQUALN(image->format->driver,"GDAL/",5) ) {
-    GDALDriverH hDriver;
-    const char *pszExtension = image->format->extension;
-
-    msAcquireLock( TLOCK_GDAL );
-    hDriver = GDALGetDriverByName( image->format->driver+5 );
-    if( hDriver == NULL ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_MISCERR,
-                  "Failed to find %s driver.",
-                  "msWCSReturnCoverage11()",
-                  image->format->driver+5 );
-      return msWCSException11(map, "NoApplicableCode", "mapserv",
-                              params->version);
-    }
-
-    if( pszExtension == NULL )
-      pszExtension = "img.tmp";
-
-    if( msGDALDriverSupportsVirtualIOOutput(hDriver) ) {
-      base_dir = msTmpFile(map, map->mappath, "/vsimem/wcsout", NULL);
-      if( fo_filename )
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            fo_filename,NULL));
-      else
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            "out", pszExtension ));
-
-      /*            CleanVSIDir( "/vsimem/wcsout" ); */
-
-      msReleaseLock( TLOCK_GDAL );
-      status = msSaveImage(map, image, filename);
-      if( status != MS_SUCCESS ) {
-        msFree(filename);
-        msSetError(MS_MISCERR, "msSaveImage() failed",
-                   "msWCSReturnCoverage11()");
-        return msWCSException11(map, "NoApplicableCode", "mapserv",
-                                params->version);
-      }
-    }
-    msReleaseLock( TLOCK_GDAL );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Output stock header.                                            */
-  /* -------------------------------------------------------------------- */
-  msIO_setHeader("Content-Type","multipart/mixed; boundary=wcs");
-  msIO_sendHeaders();
-  msIO_printf(
-    "\r\n--wcs\r\n"
-    "Content-Type: text/xml; charset=UTF-8\r\n"
-    "Content-ID: wcs.xml\r\n\r\n"
-    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
-    "<Coverages\n"
-    "     xmlns=\"http://www.opengis.net/wcs/1.1\"\n"
-    "     xmlns:ows=\"http://www.opengis.net/ows/1.1\"\n"
-    "     xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n"
-    "     xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-    "     xsi:schemaLocation=\"http://www.opengis.net/ows/1.1 ../owsCoverages.xsd\">\n"
-    "  <Coverage>\n");
-
-  /* -------------------------------------------------------------------- */
-  /*      If we weren't able to write data under /vsimem, then we just    */
-  /*      output a single "stock" filename.                               */
-  /* -------------------------------------------------------------------- */
-  if( filename == NULL ) {
-    msOutputFormatResolveFromImage( map, image );
-    msIO_fprintf(
-      stdout,
-      "    <ows:Reference xlink:href=\"cid:coverage/wcs.%s\"/>\n"
-      "  </Coverage>\n"
-      "</Coverages>\n"
-      "\r\n--wcs\r\n"
-      "Content-Type: %s\r\n"
-      "Content-Description: coverage data\r\n"
-      "Content-Transfer-Encoding: binary\r\n"
-      "Content-ID: coverage/wcs.%s\r\n"
-      "Content-Disposition: INLINE\r\n\r\n",
-      MS_IMAGE_EXTENSION(map->outputformat),
-      MS_IMAGE_MIME_TYPE(map->outputformat),
-      MS_IMAGE_EXTENSION(map->outputformat));
-
-    status = msSaveImage(map, image, NULL);
-    if( status != MS_SUCCESS ) {
-      msSetError( MS_MISCERR, "msSaveImage() failed", "msWCSReturnCoverage11()");
-      return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
-    }
-
-    msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
-    return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      When potentially listing multiple files, we take great care     */
-  /*      to identify the "primary" file and list it first.  In fact      */
-  /*      it is the only file listed in the coverages document.           */
-  /* -------------------------------------------------------------------- */
-  {
-    char **all_files = CPLReadDir( base_dir );
-    int count = CSLCount(all_files);
-
-    if( msIO_needBinaryStdout() == MS_FAILURE )
-      return MS_FAILURE;
-
-    msAcquireLock( TLOCK_GDAL );
-    for( i = count-1; i >= 0; i-- ) {
-      const char *this_file = all_files[i];
-
-      if( EQUAL(this_file,".") || EQUAL(this_file,"..") ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
-        continue;
-      }
-
-      if( i > 0 && EQUAL(this_file,CPLGetFilename(filename)) ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
-        all_files = CSLInsertString(all_files,0,CPLGetFilename(filename));
-        i++;
-      }
-    }
-
-    msIO_fprintf(
-      stdout,
-      "    <ows:Reference xlink:href=\"cid:coverage/%s\"/>\n"
-      "  </Coverage>\n"
-      "</Coverages>\n",
-      CPLGetFilename(filename) );
-
-    /* -------------------------------------------------------------------- */
-    /*      Dump all the files in the memory directory as mime sections.    */
-    /* -------------------------------------------------------------------- */
-    count = CSLCount(all_files);
-
-    for( i = 0; i < count; i++ ) {
-      const char *mimetype = NULL;
-      VSILFILE *fp;
-      unsigned char block[4000];
-      int bytes_read;
-
-      if( i == 0 )
-        mimetype = MS_IMAGE_MIME_TYPE(map->outputformat);
-
-      if( mimetype == NULL )
-        mimetype = "application/octet-stream";
-
-      msIO_fprintf(
-        stdout,
-        "\r\n--wcs\r\n"
-        "Content-Type: %s\r\n"
-        "Content-Description: coverage data\r\n"
-        "Content-Transfer-Encoding: binary\r\n"
-        "Content-ID: coverage/%s\r\n"
-        "Content-Disposition: INLINE\r\n\r\n",
-        mimetype,
-        all_files[i]);
-
-      fp = VSIFOpenL(
-             CPLFormFilename(base_dir, all_files[i], NULL),
-             "rb" );
-      if( fp == NULL ) {
-        msReleaseLock( TLOCK_GDAL );
-        msSetError( MS_MISCERR,
-                    "Failed to open %s for streaming to stdout.",
-                    "msWCSReturnCoverage11()", all_files[i] );
-        return MS_FAILURE;
-      }
-
-      while( (bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0 )
-        msIO_fwrite( block, 1, bytes_read, stdout );
-
-      VSIFCloseL( fp );
-
-      VSIUnlink( CPLFormFilename(base_dir, all_files[i], NULL) );
-    }
-
-    msFree(base_dir);
-    msFree(filename);
-    CSLDestroy( all_files );
-    msReleaseLock( TLOCK_GDAL );
-
-    msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
-    return MS_SUCCESS;
-  }
-}
-#endif /* defined(USE_WCS_SVR) && defined(USE_LIBXML2) */
-
-/************************************************************************/
-/* ==================================================================== */
-/*  If we don't have libxml2 but WCS SVR was selected, then         */
-/*      report WCS 1.1 requests as unsupported.                         */
-/* ==================================================================== */
-/************************************************************************/
-
-#if defined(USE_WCS_SVR) && !defined(USE_LIBXML2)
-
-#include "mapwcs.h"
-
-/* ==================================================================== */
-
-int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params,
-                            owsRequestObj *ows_request)
-{
-  msSetError( MS_WCSERR,
-              "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 services and this is not configured.",
-              "msWCSDescribeCoverage11()" );
-  return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
-}
-
-/* ==================================================================== */
-
-int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  msSetError( MS_WCSERR,
-              "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 services and this is not configured.",
-              "msWCSGetCapabilities11()" );
-
-  return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
-}
-
-int msWCSException11(mapObj *map, const char *exceptionCode, const char *locator, const char *version)
-{
-  /* fallback to reporting using 1.0 style exceptions. */
-  return msWCSException( map, exceptionCode, locator, "1.0.0" );
-}
-
-#endif /* defined(USE_WCS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/mapwcs20.cpp 8.2.0~beta1-1~exp1/mapwcs20.cpp
--- 8.0.1-5/mapwcs20.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwcs20.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,5029 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OpenGIS Web Coverage Server (WCS) 2.0 implementation.
- * Author:   Stephan Meissl <stephan.meissl@eox.at>
- *           Fabian Schindler <fabian.schindler@eox.at>
- *           and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 2010, 2011 EOX IT Services GmbH, Austria
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver-config.h"
-#if defined(USE_WCS_SVR)
-
-#include <assert.h>
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapthread.h"
-#include "mapows.h"
-#include "mapwcs.h"
-#include "mapgdal.h"
-#include <float.h>
-#include "gdal.h"
-#include "cpl_port.h"
-#include "maptime.h"
-#include "mapprimitive.h"
-#include "cpl_string.h"
-#include <string.h>
-
-#if defined(USE_LIBXML2)
-
-#include <libxml/tree.h>
-#include "maplibxml2.h"
-#include <libxml/parser.h>
-
-#endif /* defined(USE_LIBXML2) */
-
-#include <string>
-
-/************************************************************************/
-/*                          msXMLStripIndentation                       */
-/************************************************************************/
-
-static void msXMLStripIndentation(char* ptr)
-{
-    /* Remove spaces between > and < to get properly indented result */
-    char* afterLastClosingBracket = NULL;
-    if( *ptr == ' ' )
-        afterLastClosingBracket = ptr;
-    while( *ptr != '\0' )
-    {
-        if( *ptr == '<' && afterLastClosingBracket != NULL )
-        {
-            memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
-            ptr = afterLastClosingBracket;
-        }
-        else if( *ptr == '>' )
-        {
-            afterLastClosingBracket = ptr + 1;
-        }
-        else if( *ptr != ' ' &&  *ptr != '\n' )
-            afterLastClosingBracket = NULL;
-        ptr ++;
-    }
-}
-
-
-
-/************************************************************************/
-/*                   msStringParseInteger()                             */
-/*                                                                      */
-/*      Tries to parse a string as a integer value. If not possible     */
-/*      the value MS_WCS20_UNBOUNDED is stored as value.                */
-/*      If no characters could be parsed, MS_FAILURE is returned. If at */
-/*      least some characters could be parsed, MS_DONE is returned and  */
-/*      only if all characters could be parsed, MS_SUCCESS is returned. */
-/************************************************************************/
-
-static int msStringParseInteger(const char *string, int *dest)
-{
-  char *parse_check;
-  *dest = (int)strtol(string, &parse_check, 0);
-  if(parse_check == string) {
-    return MS_FAILURE;
-  } else if(parse_check - strlen(string) != string) {
-    return MS_DONE;
-  }
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msStringParseDouble()                              */
-/*                                                                      */
-/*      Tries to parse a string as a double value. If not possible      */
-/*      the value 0 is stored as value.                                 */
-/*      If no characters could be parsed, MS_FAILURE is returned. If at */
-/*      least some characters could be parsed, MS_DONE is returned and  */
-/*      only if all characters could be parsed, MS_SUCCESS is returned. */
-/************************************************************************/
-
-static int msStringParseDouble(const char *string, double *dest)
-{
-  char *parse_check = NULL;
-  *dest = strtod(string, &parse_check);
-  if(parse_check == string) {
-    return MS_FAILURE;
-  } else if(parse_check - strlen(string) != string) {
-    return MS_DONE;
-  }
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSParseTimeOrScalar20()                         */
-/*                                                                      */
-/*      Parses a string, either as a time or a scalar value and         */
-/*      writes the output into the timeScalarUnion.                     */
-/************************************************************************/
-
-static int msWCSParseTimeOrScalar20(timeScalarUnion *u, const char *string)
-{
-  struct tm time;
-  if (string) {
-    while(*string == ' ')
-      string ++;
-  }
-
-  if (!string || strlen(string) == 0 || !u) {
-    msSetError(MS_WCSERR, "Invalid string", "msWCSParseTimeOrScalar20()");
-    return MS_WCS20_ERROR_VALUE;
-  }
-  /* if the string is equal to "*" it means the value
-   *  of the interval is unbounded                    */
-  if (EQUAL(string, "*")) {
-    u->scalar = MS_WCS20_UNBOUNDED;
-    u->unbounded = 1;
-    return MS_WCS20_UNDEFINED_VALUE;
-  }
-
-  /* if returned a valid value, use it */
-  if (msStringParseDouble(string, &(u->scalar)) == MS_SUCCESS) {
-    return MS_WCS20_SCALAR_VALUE;
-  }
-  /* otherwise it might be a time value */
-  msTimeInit(&time);
-  if (msParseTime(string, &time) == MS_TRUE) {
-    u->time = mktime(&time);
-    return MS_WCS20_TIME_VALUE;
-  }
-  /* the value could neither be parsed as a double nor as a time value */
-  else {
-    msSetError(MS_WCSERR,
-               "String %s could not be parsed to a time or scalar value",
-               "msWCSParseTimeOrScalar20()",string);
-    return MS_WCS20_ERROR_VALUE;
-  }
-}
-
-/************************************************************************/
-/*                   msWCSCreateSubsetObj20()                           */
-/*                                                                      */
-/*      Creates a new wcs20SubsetObj and initializes it to standard     */
-/*      values.                                                         */
-/************************************************************************/
-
-static wcs20SubsetObjPtr msWCSCreateSubsetObj20()
-{
-  wcs20SubsetObjPtr subset = (wcs20SubsetObjPtr) malloc(sizeof(wcs20SubsetObj));
-  MS_CHECK_ALLOC(subset, sizeof(wcs20SubsetObj), NULL);
-
-  subset->axis = NULL;
-  subset->crs = NULL;
-  subset->min.scalar = subset->max.scalar = MS_WCS20_UNBOUNDED;
-  subset->min.unbounded = subset->max.unbounded = 0;
-  subset->operation = MS_WCS20_SLICE;
-
-  return subset;
-}
-
-/************************************************************************/
-/*                   msWCSFreeSubsetObj20()                             */
-/*                                                                      */
-/*      Frees a wcs20SubsetObj and releases all linked resources.       */
-/************************************************************************/
-
-static void msWCSFreeSubsetObj20(wcs20SubsetObjPtr subset)
-{
-  if (NULL == subset) {
-    return;
-  }
-  msFree(subset->axis);
-  msFree(subset->crs);
-  msFree(subset);
-}
-
-/************************************************************************/
-/*                   msWCSCreateAxisObj20()                             */
-/*                                                                      */
-/*      Creates a new wcs20AxisObj and initializes it to standard       */
-/*      values.                                                         */
-/************************************************************************/
-
-static wcs20AxisObjPtr msWCSCreateAxisObj20()
-{
-  wcs20AxisObj *axis = (wcs20AxisObjPtr)malloc(sizeof(wcs20AxisObj));
-  MS_CHECK_ALLOC(axis, sizeof(wcs20AxisObj), NULL);
-
-  axis->name = NULL;
-  axis->size = 0;
-  axis->resolution = MS_WCS20_UNBOUNDED;
-  axis->scale = MS_WCS20_UNBOUNDED;
-  axis->resolutionUOM = NULL;
-  axis->subset = NULL;
-
-  return axis;
-}
-
-/************************************************************************/
-/*                   msWCSFreeAxisObj20()                               */
-/*                                                                      */
-/*      Frees a wcs20AxisObj and releases all linked resources.         */
-/************************************************************************/
-
-static void msWCSFreeAxisObj20(wcs20AxisObjPtr axis)
-{
-  if(NULL == axis) {
-    return;
-  }
-
-  msFree(axis->name);
-  msFree(axis->resolutionUOM);
-  msWCSFreeSubsetObj20(axis->subset);
-  msFree(axis);
-}
-
-/************************************************************************/
-/*                   msWCSFindAxis20()                                  */
-/*                                                                      */
-/*      Helper function to retrieve an axis by the name from a params   */
-/*      object.                                                         */
-/************************************************************************/
-
-static wcs20AxisObjPtr msWCSFindAxis20(wcs20ParamsObjPtr params,
-                                       const char *name)
-{
-  int i = 0;
-  for(i = 0; i < params->numaxes; ++i) {
-    if(EQUAL(params->axes[i]->name, name)) {
-      return params->axes[i];
-    }
-  }
-  return NULL;
-}
-
-/************************************************************************/
-/*                   msWCSInsertAxisObj20()                             */
-/*                                                                      */
-/*      Helper function to insert an axis object into the axes list of  */
-/*      a params object.                                                */
-/************************************************************************/
-
-static void msWCSInsertAxisObj20(wcs20ParamsObjPtr params, wcs20AxisObjPtr axis)
-{
-  params->numaxes++;
-  params->axes = (wcs20AxisObjPtr*) msSmallRealloc(params->axes,
-                 sizeof(wcs20AxisObjPtr) * (params->numaxes));
-  params->axes[params->numaxes - 1] = axis;
-}
-
-/************************************************************************/
-/*                   msWCSCreateParamsObj20()                           */
-/*                                                                      */
-/*      Creates a new wcs20ParamsObj and initializes it to standard     */
-/*      values.                                                         */
-/************************************************************************/
-
-wcs20ParamsObjPtr msWCSCreateParamsObj20()
-{
-  wcs20ParamsObjPtr params
-    = (wcs20ParamsObjPtr) malloc(sizeof(wcs20ParamsObj));
-  MS_CHECK_ALLOC(params, sizeof(wcs20ParamsObj), NULL);
-
-  params->version         = NULL;
-  params->request         = NULL;
-  params->service         = NULL;
-  params->accept_versions = NULL;
-  params->accept_languages = NULL;
-  params->sections        = NULL;
-  params->updatesequence  = NULL;
-  params->ids             = NULL;
-  params->width           = 0;
-  params->height          = 0;
-  params->resolutionX     = MS_WCS20_UNBOUNDED;
-  params->resolutionY     = MS_WCS20_UNBOUNDED;
-  params->scale           = MS_WCS20_UNBOUNDED;
-  params->scaleX          = MS_WCS20_UNBOUNDED;
-  params->scaleY          = MS_WCS20_UNBOUNDED;
-  params->resolutionUnits = NULL;
-  params->numaxes         = 0;
-  params->axes            = NULL;
-  params->format          = NULL;
-  params->multipart       = 0;
-  params->interpolation   = NULL;
-  params->outputcrs       = NULL;
-  params->subsetcrs       = NULL;
-  params->bbox.minx = params->bbox.miny = -DBL_MAX;
-  params->bbox.maxx = params->bbox.maxy =  DBL_MAX;
-  params->range_subset    = NULL;
-  params->format_options  = NULL;
-
-  return params;
-}
-
-/************************************************************************/
-/*                   msWCSFreeParamsObj20()                             */
-/*                                                                      */
-/*      Frees a wcs20ParamsObj and releases all linked resources.       */
-/************************************************************************/
-
-void msWCSFreeParamsObj20(wcs20ParamsObjPtr params)
-{
-  if (NULL == params) {
-    return;
-  }
-
-  msFree(params->version);
-  msFree(params->request);
-  msFree(params->service);
-  CSLDestroy(params->accept_versions);
-  CSLDestroy(params->accept_languages);
-  CSLDestroy(params->sections);
-  msFree(params->updatesequence);
-  CSLDestroy(params->ids);
-  msFree(params->resolutionUnits);
-  msFree(params->format);
-  msFree(params->interpolation);
-  msFree(params->outputcrs);
-  msFree(params->subsetcrs);
-  while(params->numaxes > 0) {
-    params->numaxes -= 1;
-    msWCSFreeAxisObj20(params->axes[params->numaxes]);
-  }
-  msFree(params->axes);
-  CSLDestroy(params->range_subset);
-  CSLDestroy(params->format_options);
-  msFree(params);
-}
-
-/************************************************************************/
-/*                   msWCSParseSubset20()                               */
-/*                                                                      */
-/*      Parses several string parameters and fills them into the        */
-/*      subset object.                                                  */
-/************************************************************************/
-
-static int msWCSParseSubset20(wcs20SubsetObjPtr subset, const char *axis,
-                              const char *crs, const char *min, const char *max)
-{
-  int ts1, ts2;
-  ts1 = ts2 = MS_WCS20_UNDEFINED_VALUE;
-
-  if (subset == NULL) {
-    return MS_FAILURE;
-  }
-
-  if (axis == NULL || strlen(axis) == 0) {
-    msSetError(MS_WCSERR, "Subset axis is not given.",
-               "msWCSParseSubset20()");
-    return MS_FAILURE;
-  }
-
-  subset->axis = msStrdup(axis);
-  if (crs != NULL) {
-    subset->crs = msStrdup(crs);
-  }
-
-  /* Parse first (probably only) part of interval/point;
-   * check whether its a time value or a scalar value     */
-  ts1 = msWCSParseTimeOrScalar20(&(subset->min), min);
-  if (ts1 == MS_WCS20_ERROR_VALUE) {
-    return MS_FAILURE;
-  }
-
-  /* check if its an interval */
-  /* if there is a comma, then it is */
-  if (max != NULL && strlen(max) > 0) {
-    subset->operation = MS_WCS20_TRIM;
-
-    /* Parse the second value of the interval */
-    ts2 = msWCSParseTimeOrScalar20(&(subset->max), max);
-    if (ts2 == MS_WCS20_ERROR_VALUE) {
-      return MS_FAILURE;
-    }
-
-    /* if at least one boundary is defined, use that value */
-    if ((ts1 == MS_WCS20_UNDEFINED_VALUE) ^ (ts2
-        == MS_WCS20_UNDEFINED_VALUE)) {
-      if (ts1 == MS_WCS20_UNDEFINED_VALUE) {
-        ts1 = ts2;
-      }
-    }
-    /* if time and scalar values do not fit, throw an error */
-    else if (ts1 != MS_WCS20_UNDEFINED_VALUE && ts2
-             != MS_WCS20_UNDEFINED_VALUE && ts1 != ts2) {
-      msSetError(MS_WCSERR,
-                 "Interval error: minimum is a %s value, maximum is a %s value",
-                 "msWCSParseSubset20()", ts1 ? "time" : "scalar",
-                 ts2 ? "time" : "scalar");
-      return MS_FAILURE;
-    }
-    /* if both min and max are unbounded -> throw an error */
-    if (subset->min.unbounded && subset->max.unbounded) {
-      msSetError(MS_WCSERR, "Invalid values: no bounds could be parsed",
-                 "msWCSParseSubset20()");
-      return MS_FAILURE;
-    }
-  }
-  /* there is no second value, therefore it is a point.
-   * consequently set the operation to slice */
-  else {
-    subset->operation = MS_WCS20_SLICE;
-    if (ts1 == MS_WCS20_UNDEFINED_VALUE) {
-      msSetError(MS_WCSERR, "Invalid point value given",
-                 "msWCSParseSubset20()");
-      return MS_FAILURE;
-    }
-  }
-
-  subset->timeOrScalar = ts1;
-
-  /* check whether the min is smaller than the max */
-  if (subset->operation == MS_WCS20_TRIM) {
-    if(subset->timeOrScalar == MS_WCS20_SCALAR_VALUE && subset->min.scalar == MS_WCS20_UNBOUNDED) {
-      subset->min.scalar = -MS_WCS20_UNBOUNDED;
-    }
-
-    if (subset->timeOrScalar == MS_WCS20_TIME_VALUE && subset->min.time
-        > subset->max.time) {
-      msSetError(MS_WCSERR,
-                 "Minimum value of subset axis %s is larger than maximum value",
-                 "msWCSParseSubset20()", subset->axis);
-      return MS_FAILURE;
-    }
-    if (subset->timeOrScalar == MS_WCS20_SCALAR_VALUE && subset->min.scalar > subset->max.scalar) {
-      msSetError(MS_WCSERR,
-                 "Minimum value (%f) of subset axis '%s' is larger than maximum value (%f).",
-                 "msWCSParseSubset20()", subset->min.scalar, subset->axis, subset->max.scalar);
-      return MS_FAILURE;
-    }
-  }
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSParseSubsetKVPString20()                      */
-/*                                                                      */
-/*      Creates a new wcs20SubsetObj, parses a string and fills         */
-/*      the parsed values into the object. Returns NULL on failure.     */
-/*      Subset string: axis [ , crs ] ( intervalOrPoint )               */
-/************************************************************************/
-
-static int msWCSParseSubsetKVPString20(wcs20SubsetObjPtr subset, char *string)
-{
-  char *axis, *crs, *min, *max;
-
-  axis = string;
-  crs = NULL;
-  min = NULL;
-  max = NULL;
-
-  /* find first '(' */
-  min = strchr(string, '(');
-
-  /* if min could not be found, the string is invalid */
-  if (min == NULL) {
-    msSetError(MS_WCSERR, "Invalid axis subset string: '%s'",
-               "msWCSParseSubsetKVPString20()", string);
-    return MS_FAILURE;
-  }
-  /* set min to first letter */
-  *min = '\0';
-  ++min;
-
-  /* cut the trailing ')' */
-  if (min[strlen(min) - 1] == ')') {
-    min[strlen(min) - 1] = '\0';
-  }
-  /* look if also a max is defined */
-  max = strchr(min, ',');
-  if (max != NULL) {
-    *max = '\0';
-    ++max;
-  }
-
-  /* look if also a crs is defined */
-  crs = strchr(axis, ',');
-  if (crs != NULL) {
-    *crs = '\0';
-    ++crs;
-  }
-
-  return msWCSParseSubset20(subset, axis, crs, min, max);
-}
-
-/************************************************************************/
-/*                   msWCSParseSizeString20()                           */
-/*                                                                      */
-/*      Parses a string containing the axis and the size as an integer. */
-/*      Size string: axis ( size )                                      */
-/************************************************************************/
-
-static int msWCSParseSizeString20(char *string, char *outAxis, size_t axisStringLen, int *outSize)
-{
-  char *number = NULL;
-  char *check = NULL;
-
-  /* find first '(', the character before the number */
-  number = strchr(string, '(');
-
-  if(NULL == number) {
-    msSetError(MS_WCSERR, "Invalid size parameter value.",
-               "msWCSParseSize20()");
-    return MS_FAILURE;
-  }
-
-  /* cut trailing ')' */
-  check = strchr(string, ')');
-  if(NULL == check) {
-    msSetError(MS_WCSERR, "Invalid size parameter value.",
-               "msWCSParseSize20()");
-    return MS_FAILURE;
-  }
-  *number = '\0';
-  ++number;
-  *check = '\0';
-
-  strlcpy(outAxis, string, axisStringLen);
-
-  /* parse size value */
-  if(msStringParseInteger(number, outSize) != MS_SUCCESS) {
-    msSetError(MS_WCSERR, "Parameter value '%s' is not a valid integer.",
-               "msWCSParseSize20()", number);
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSParseResolutionString20()                     */
-/*                                                                      */
-/*      Parses a resolution string and returns the axis, the units of   */
-/*      measure and the resolution value.                               */
-/*      Subset string: axis ( value )                                   */
-/************************************************************************/
-
-static int msWCSParseResolutionString20(char *string,
-                                        char *outAxis, size_t axisStringLen, double *outResolution)
-{
-  char *number = NULL;
-  char *check = NULL;
-
-  /* find brackets */
-  number = strchr(string, '(');
-
-  if(NULL == number) {
-    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
-               "msWCSParseSize20()", string);
-    return MS_FAILURE;
-  }
-
-  /* cut trailing ')' */
-  check = strchr(string, ')');
-  if(NULL == check) {
-    msSetError(MS_WCSERR, "Invalid size parameter value.",
-               "msWCSParseSize20()");
-    return MS_FAILURE;
-  }
-
-  *number = '\0';
-  ++number;
-  *check = '\0';
-
-  strlcpy(outAxis, string, axisStringLen);
-
-  if(msStringParseDouble(number, outResolution) != MS_SUCCESS) {
-    *outResolution = MS_WCS20_UNBOUNDED;
-    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
-               "msWCSParseSize20()", number);
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSParseScaleString20()                          */
-/*                                                                      */
-/*      Parses a scale string and returns the axis, the and the value.  */
-/*      Subset string: axis ( value )                                   */
-/************************************************************************/
-
-static int msWCSParseScaleString20(char *string,
-                                  char *outAxis, size_t axisStringLen, double *outScale)
-{
-  char *number = NULL;
-  char *check = NULL;
-
-  /* find brackets */
-  number = strchr(string, '(');
-
-  if(NULL == number) {
-    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
-               "msWCSParseScaleString20()", string);
-    return MS_FAILURE;
-  }
-
-  /* cut trailing ')' */
-  check = strchr(string, ')');
-  if(NULL == check || check < number) {
-    msSetError(MS_WCSERR, "Invalid scale parameter value.",
-               "msWCSParseScaleString20()");
-    return MS_FAILURE;
-  }
-
-  *number = '\0';
-  ++number;
-  *check = '\0';
-
-  strlcpy(outAxis, string, axisStringLen);
-
-  if(msStringParseDouble(number, outScale) != MS_SUCCESS || *outScale <= 0.0) {
-    *outScale = MS_WCS20_UNBOUNDED;
-    msSetError(MS_WCSERR, "Invalid scale parameter value : %s.",
-               "msWCSParseScaleString20()", number);
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSParseResolutionString20()                     */
-/*                                                                      */
-/*      Parses a resolution string and returns the axis, the units of   */
-/*      measure and the resolution value.                               */
-/*      Subset string: axis ( value )                                   */
-/************************************************************************/
-
-static int msWCSParseScaleExtentString20(char *string, char *outAxis,
-                                         size_t axisStringLen,
-                                         int *outMin, int *outMax)
-{
-  char *number = NULL;
-  char *check = NULL;
-  char *colon = NULL;
-
-  /* find brackets */
-  number = strchr(string, '(');
-
-  if(NULL == number) {
-    msSetError(MS_WCSERR, "Invalid extent parameter value : %s.",
-               "msWCSParseScaleExtentString20()", string);
-    return MS_FAILURE;
-  }
-
-  /* find colon */
-  colon = strchr(string, ':');
-
-  if(NULL == colon || colon < number) {
-    msSetError(MS_WCSERR, "Invalid extent parameter value : %s.",
-               "msWCSParseScaleExtentString20()", string);
-    return MS_FAILURE;
-  }
-
-  /* cut trailing ')' */
-  check = strchr(string, ')');
-
-  if(NULL == check || check < colon) {
-    msSetError(MS_WCSERR, "Invalid extent parameter value.",
-               "msWCSParseScaleExtentString20()");
-    return MS_FAILURE;
-  }
-
-  *number = '\0';
-  ++number;
-  *colon = '\0';
-  ++colon;
-  *check = '\0';
-
-  strlcpy(outAxis, string, axisStringLen);
-
-  if(msStringParseInteger(number, outMin) != MS_SUCCESS) {
-    *outMin = 0;
-    msSetError(MS_WCSERR, "Invalid min parameter value : %s.",
-               "msWCSParseScaleExtentString20()", number);
-    return MS_FAILURE;
-  }
-  else if(msStringParseInteger(colon, outMax) != MS_SUCCESS) {
-    *outMax = 0;
-    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
-               "msWCSParseScaleExtentString20()", colon);
-    return MS_FAILURE;
-  }
-
-  if (*outMin > *outMax) {
-    msSetError(MS_WCSERR, "Invalid extent: lower part is higher than upper part.",
-               "msWCSParseScaleExtentString20()");
-    return MS_FAILURE;
-  }
-
-  return MS_SUCCESS;
-}
-
-#if defined(USE_LIBXML2)
-/*
-  Utility function to get the first child of a node with a given node name
-  */
-
-xmlNodePtr msLibXml2GetFirstChild(xmlNodePtr parent, const char *name) {
-  xmlNodePtr node;
-  if (!parent || !name) {
-    return NULL;
-  }
-
-  XML_FOREACH_CHILD(parent, node) {
-    XML_LOOP_IGNORE_COMMENT_OR_TEXT(node);
-    if (EQUAL((char *)node->name, name)) {
-      return node;
-    }
-  }
-  return NULL;
-}
-
-
-/*
-  Utility function to get the first child of a node with a given node name and
-  namespace.
-  */
-
-xmlNodePtr msLibXml2GetFirstChildNs(xmlNodePtr parent, const char *name, xmlNsPtr ns) {
-  xmlNodePtr node;
-  if (!parent || !name || !ns) {
-    return NULL;
-  }
-
-  XML_FOREACH_CHILD(parent, node) {
-    XML_LOOP_IGNORE_COMMENT_OR_TEXT(node);
-    if (EQUAL((char *)node->name, name) && ns == node->ns) {
-      return node;
-    }
-  }
-  return NULL;
-}
-
-/*
-  Utility function to get the first child of a node with a given node name
-  */
-
-xmlNodePtr msLibXml2GetFirstChildElement(xmlNodePtr parent) {
-  xmlNodePtr node;
-  if (!parent) {
-    return NULL;
-  }
-
-  XML_FOREACH_CHILD(parent, node) {
-    if (node->type == XML_ELEMENT_NODE) {
-      return node;
-    }
-  }
-  return NULL;
-}
-#endif /* defined(USE_LIBXML2) */
-
-/************************************************************************/
-/*                   msWCSParseRequest20_XMLGetCapabilities()           */
-/*                                                                      */
-/*      Parses a DOM element, representing a GetCapabilities-request    */
-/*      to a params object.                                             */
-/************************************************************************/
-#if defined(USE_LIBXML2)
-static int msWCSParseRequest20_XMLGetCapabilities(
-  xmlNodePtr root, wcs20ParamsObjPtr params)
-{
-  xmlNodePtr child;
-  char *content = NULL;
-  XML_FOREACH_CHILD(root, child) {
-    XML_LOOP_IGNORE_COMMENT_OR_TEXT(child)
-    else if (EQUAL((char *)child->name, "AcceptVersions")) {
-      xmlNodePtr versionNode = NULL;
-      XML_FOREACH_CHILD(child, versionNode) {
-        XML_LOOP_IGNORE_COMMENT_OR_TEXT(versionNode);
-        XML_ASSERT_NODE_NAME(versionNode, "Version");
-
-        content = (char *)xmlNodeGetContent(versionNode);
-        params->accept_versions = CSLAddString(params->accept_versions, content);
-        xmlFree(content);
-      }
-    } else if(EQUAL((char *)child->name, "Sections")) {
-      xmlNodePtr sectionNode = NULL;
-      XML_FOREACH_CHILD(child, sectionNode) {
-        XML_LOOP_IGNORE_COMMENT_OR_TEXT(sectionNode)
-        XML_ASSERT_NODE_NAME(sectionNode, "Section");
-
-        content = (char *)xmlNodeGetContent(sectionNode);
-        params->sections = CSLAddString(params->sections, content);
-        xmlFree(content);
-      }
-    } else if(EQUAL((char *)child->name, "UpdateSequence")) {
-      params->updatesequence =
-        (char *)xmlNodeGetContent(child);
-    } else if(EQUAL((char *)child->name, "AcceptFormats")) {
-      /* Maybe not necessary, since only format is xml.   */
-      /* At least ignore it, to not generate an error.    */
-    } else if(EQUAL((char *)child->name, "AcceptLanguages")) {
-      xmlNodePtr languageNode;
-      XML_FOREACH_CHILD(child, languageNode) {
-        XML_LOOP_IGNORE_COMMENT_OR_TEXT(languageNode)
-        XML_ASSERT_NODE_NAME(languageNode, "Language");
-
-        content = (char *)xmlNodeGetContent(languageNode);
-        params->accept_languages = CSLAddString(params->accept_languages, content);
-        xmlFree(content);
-      }
-    } else {
-      XML_UNKNOWN_NODE_ERROR(child);
-    }
-  }
-  return MS_SUCCESS;
-}
-#endif
-
-/************************************************************************/
-/*                   msWCSParseRequest20_XMLDescribeCoverage()          */
-/*                                                                      */
-/*      Parses a DOM element, representing a DescribeCoverage-request   */
-/*      to a params object.                                             */
-/************************************************************************/
-#if defined(USE_LIBXML2)
-static int msWCSParseRequest20_XMLDescribeCoverage(
-  xmlNodePtr root, wcs20ParamsObjPtr params)
-{
-  xmlNodePtr child;
-  int numIds = 0;
-  char *id;
-
-  XML_FOREACH_CHILD(root, child) {
-    XML_LOOP_IGNORE_COMMENT_OR_TEXT(child)
-    XML_ASSERT_NODE_NAME(child, "CoverageID");
-
-    /* Node content is the coverage ID */
-    id = (char *)xmlNodeGetContent(child);
-    if (id == NULL || strlen(id) == 0) {
-      msSetError(MS_WCSERR, "CoverageID could not be parsed.",
-                 "msWCSParseRequest20_XMLDescribeCoverage()");
-      return MS_FAILURE;
-    }
-    /* insert coverage ID into the list */
-    ++numIds;
-    params->ids = CSLAddString(params->ids, (char *)id);
-    xmlFree(id);
-  }
-  return MS_SUCCESS;
-}
-#endif
-
-/************************************************************************/
-/*                   msWCSParseRequest20_XMLGetCoverage()               */
-/*                                                                      */
-/*      Parses a DOM element, representing a GetCoverage-request to a   */
-/*      params object.                                                  */
-/************************************************************************/
-#if defined(USE_LIBXML2)
-static int msWCSParseRequest20_XMLGetCoverage(
-  mapObj* map, xmlNodePtr root, wcs20ParamsObjPtr params)
-{
-  xmlNodePtr child;
-  int numIds = 0;
-  char *id;
-
-  XML_FOREACH_CHILD(root, child) {
-    XML_LOOP_IGNORE_COMMENT_OR_TEXT(child)
-    else if (EQUAL((char *)child->name, "CoverageID")) {
-      /* Node content is the coverage ID */
-      id = (char *)xmlNodeGetContent(child);
-      if (id == NULL || strlen(id) == 0) {
-        msSetError(MS_WCSERR, "CoverageID could not be parsed.",
-                   "msWCSParseRequest20_XMLGetCoverage()");
-        return MS_FAILURE;
-      }
-
-      /* insert coverage ID into the list */
-      ++numIds;
-      params->ids = CSLAddString(params->ids, (char *)id);
-      xmlFree(id);
-    } else if (EQUAL((char *) child->name, "Format")) {
-      msFree(params->format);
-      params->format = (char *)xmlNodeGetContent(child);
-    } else if (EQUAL((char *) child->name, "Mediatype")) {
-      char *content = (char *)xmlNodeGetContent(child);
-      if(content != NULL && (EQUAL(content, "multipart/mixed")
-                          || EQUAL(content, "multipart/related"))) {
-        params->multipart = MS_TRUE;
-      }
-      else {
-        msSetError(MS_WCSERR, "Invalid value '%s' for parameter 'Mediatype'.",
-                  "msWCSParseRequest20()", content);
-        xmlFree(content);
-        return MS_FAILURE;
-      }
-      xmlFree(content);
-    } else if (EQUAL((char *) child->name, "DimensionTrim")) {
-      wcs20AxisObjPtr axis = NULL;
-      wcs20SubsetObjPtr subset = NULL;
-      xmlNodePtr node = NULL;
-      char *axisName = NULL, *min = NULL, *max = NULL, *crs = NULL;
-
-      /* get strings for axis, min and max */
-      XML_FOREACH_CHILD(child, node) {
-        XML_LOOP_IGNORE_COMMENT_OR_TEXT(node)
-        else if (EQUAL((char *)node->name, "Dimension")) {
-          if (axisName != NULL) {
-            msSetError(MS_WCSERR,
-                       "Parameter 'Dimension' is already set.",
-                       "msWCSParseRequest20_XMLGetCoverage()");
-            return MS_FAILURE;
-          }
-          axisName = (char *) xmlNodeGetContent(node);
-          crs = (char *) xmlGetProp(node, BAD_CAST "crs");
-        } else if (EQUAL((char *)node->name, "trimLow")) {
-          min = (char *) xmlNodeGetContent(node);
-        } else if (EQUAL((char *)node->name, "trimHigh")) {
-          max = (char *) xmlNodeGetContent(node);
-        } else {
-          msFree(axisName);
-          msFree(min);
-          msFree(max);
-          msFree(crs);
-          XML_UNKNOWN_NODE_ERROR(node);
-        }
-      }
-      if(NULL == (subset = msWCSCreateSubsetObj20())) {
-        msFree(axisName);
-        msFree(min);
-        msFree(max);
-        msFree(crs);
-        return MS_FAILURE;
-      }
-
-      /* min and max have to have a value */
-      if(min == NULL ) {
-        min = msStrdup("*");
-      }
-      if(max == NULL) {
-        max = msStrdup("*");
-      }
-      if (msWCSParseSubset20(subset, axisName, crs, min, max)
-          == MS_FAILURE) {
-        msWCSFreeSubsetObj20(subset);
-        msWCSException(map, "InvalidSubsetting", "subset", "2.0.1");
-        return MS_DONE;
-      }
-
-      if(NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
-          msFree(axisName);
-          msFree(min);
-          msFree(max);
-          msFree(crs);
-          return MS_FAILURE;
-        }
-        axis->name = msStrdup(subset->axis);
-        msWCSInsertAxisObj20(params, axis);
-      }
-
-      axis->subset = subset;
-
-      /* cleanup */
-      msFree(axisName);
-      msFree(min);
-      msFree(max);
-      msFree(crs);
-    } else if(EQUAL((char *) child->name, "DimensionSlice")) {
-      msSetError(MS_WCSERR, "Operation '%s' is not supported by MapServer.",
-                 "msWCSParseRequest20_XMLGetCoverage()", (char *)child->name);
-      return MS_FAILURE;
-    } else if(EQUAL((char *) child->name, "Size")) {
-      wcs20AxisObjPtr axis;
-      char *axisName;
-      char *content;
-
-      if(NULL == (axisName = (char *) xmlGetProp(child, BAD_CAST "dimension")) ) {
-        msSetError(MS_WCSERR, "Attribute 'dimension' is missing in element 'Size'.",
-                   "msWCSParseRequest20_XMLGetCoverage()");
-        return MS_FAILURE;
-      }
-
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
-          xmlFree(axisName);
-          return MS_FAILURE;
-        }
-        axis->name = msStrdup(axisName);
-        msWCSInsertAxisObj20(params, axis);
-      }
-      xmlFree(axisName);
-
-      content = (char *)xmlNodeGetContent(child);
-      if(msStringParseInteger(content, &(axis->size)) != MS_SUCCESS) {
-        xmlFree(content);
-        msSetError(MS_WCSERR, "Value of element 'Size' could not "
-                   "be parsed to a valid integer.",
-                   "msWCSParseRequest20_XMLGetCoverage()");
-        return MS_FAILURE;
-      }
-      xmlFree(content);
-    } else if(EQUAL((char *) child->name, "Resolution")) {
-      wcs20AxisObjPtr axis;
-      char *axisName;
-      char *content;
-
-      if(NULL == (axisName = (char *) xmlGetProp(child, BAD_CAST "dimension"))) {
-        msSetError(MS_WCSERR, "Attribute 'dimension' is missing "
-                   "in element 'Resolution'.",
-                   "msWCSParseRequest20_XMLGetCoverage()");
-        return MS_FAILURE;
-      }
-
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
-          xmlFree(axisName);
-          return MS_FAILURE;
-        }
-        axis->name = msStrdup(axisName);
-        msWCSInsertAxisObj20(params, axis);
-      }
-      xmlFree(axisName);
-
-      axis->resolutionUOM = (char *) xmlGetProp(child, BAD_CAST "uom");
-
-      content = (char *)xmlNodeGetContent(child);
-      if(msStringParseDouble(content, &(axis->resolution)) != MS_SUCCESS) {
-        msSetError(MS_WCSERR, "Value of element 'Resolution' could not "
-                   "be parsed to a valid value.",
-                   "msWCSParseRequest20_XMLGetCoverage()");
-        xmlFree(content);
-        return MS_FAILURE;
-      }
-      xmlFree(content);
-    } else if(EQUAL((char *) child->name, "Interpolation")) {
-      /* Deprecated, use wcs:Extension/int:Interpolation/int:globalInterpolation */
-      msFree(params->interpolation);
-      params->interpolation = (char *) xmlNodeGetContent(child);
-    } else if(EQUAL((char *) child->name, "OutputCRS")) {
-      params->outputcrs = (char *) xmlNodeGetContent(child);
-    } else if(EQUAL((char *) child->name, "rangeSubset")) {
-      /* Deprecated, use wcs:Extension/rsub:RangeSubset */
-      xmlNodePtr bandNode = NULL;
-      XML_FOREACH_CHILD(child, bandNode) {
-        char *content = NULL;
-        XML_LOOP_IGNORE_COMMENT_OR_TEXT(bandNode);
-        XML_ASSERT_NODE_NAME(bandNode, "band");
-
-        content = (char *)xmlNodeGetContent(bandNode);
-        params->range_subset =
-          CSLAddString(params->range_subset, content);
-        xmlFree(content);
-      }
-    } else if (EQUAL((char *)child->name, "Extension")) {
-      xmlNodePtr extensionNode = NULL;
-      XML_FOREACH_CHILD(child, extensionNode) {
-        XML_LOOP_IGNORE_COMMENT_OR_TEXT(extensionNode);
-
-        if (EQUAL((char *) extensionNode->name, "Scaling")) {
-          xmlNodePtr scaleMethodNode = msLibXml2GetFirstChildElement(extensionNode);
-
-          if (EQUAL((char *) scaleMethodNode->name, "ScaleByFactor")) {
-            xmlNodePtr scaleFactorNode = msLibXml2GetFirstChildElement(scaleMethodNode);
-            char *content;
-            if (!scaleFactorNode || !EQUAL((char *)scaleFactorNode->name, "scaleFactor")) {
-              msSetError(MS_WCSERR, "Missing 'scaleFactor' node.",
-                         "msWCSParseRequest20_XMLGetCoverage()");
-              return MS_FAILURE;
-            }
-            content = (char *)xmlNodeGetContent(scaleFactorNode);
-            if (msStringParseDouble(content, &(params->scale)) != MS_SUCCESS
-                || params->scale < 0.0) {
-              msSetError(MS_WCSERR, "Invalid scaleFactor '%s'.",
-                         "msWCSParseRequest20_XMLGetCoverage()", content);
-              xmlFree(content);
-              return MS_FAILURE;
-            }
-            xmlFree(content);
-          }
-
-          else if (EQUAL((char *) scaleMethodNode->name, "ScaleAxesByFactor")) {
-            xmlNodePtr scaleAxisNode, axisNode, scaleFactorNode;
-            char *axisName, *content;
-            wcs20AxisObjPtr axis;
-
-            XML_FOREACH_CHILD(scaleMethodNode, scaleAxisNode) {
-              XML_LOOP_IGNORE_COMMENT_OR_TEXT(scaleAxisNode);
-
-              if (!EQUAL((char *)scaleAxisNode->name, "ScaleAxis")) {
-                msSetError(MS_WCSERR, "Invalid ScaleAxesByFactor.",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              /* axis */
-              if (NULL == (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
-                msSetError(MS_WCSERR, "Missing axis node",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-              axisName = (char *)xmlNodeGetContent(axisNode);
-              if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-                if(NULL == (axis = msWCSCreateAxisObj20())) {
-                  xmlFree(axisName);
-                  return MS_FAILURE;
-                }
-                axis->name = msStrdup(axisName);
-                msWCSInsertAxisObj20(params, axis);
-              }
-              xmlFree(axisName);
-
-              if (axis->scale != MS_WCS20_UNBOUNDED) {
-                msSetError(MS_WCSERR, "scaleFactor was already set for axis '%s'.",
-                           "msWCSParseRequest20_XMLGetCoverage()", axis->name);
-                return MS_FAILURE;
-              }
-
-              /* scaleFactor */
-              if (NULL == (scaleFactorNode = msLibXml2GetFirstChild(scaleAxisNode, "scaleFactor"))) {
-                msSetError(MS_WCSERR, "Missing scaleFactor node",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              content = (char *)xmlNodeGetContent(scaleFactorNode);
-              if (msStringParseDouble(content, &(axis->scale)) != MS_SUCCESS
-                  || axis->scale < 0.0) {
-                msSetError(MS_WCSERR, "Invalid scaleFactor '%s'.",
-                           "msWCSParseRequest20_XMLGetCoverage()", content);
-                xmlFree(content);
-                return MS_FAILURE;
-              }
-              xmlFree(content);
-            }
-          }
-
-          else if (EQUAL((char *) scaleMethodNode->name, "ScaleToSize")) {
-            xmlNodePtr scaleAxisNode, axisNode, targetSizeNode;
-            char *axisName, *content;
-            wcs20AxisObjPtr axis;
-
-            XML_FOREACH_CHILD(scaleMethodNode, scaleAxisNode) {
-              XML_LOOP_IGNORE_COMMENT_OR_TEXT(scaleAxisNode);
-
-              if (!EQUAL((char *)scaleAxisNode->name, "TargetAxisSize")) {
-                msSetError(MS_WCSERR, "Invalid ScaleToSize.",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              /* axis */
-              if (NULL == (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
-                msSetError(MS_WCSERR, "Missing axis node",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-              axisName = (char *)xmlNodeGetContent(axisNode);
-              if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-                if(NULL == (axis = msWCSCreateAxisObj20())) {
-                  xmlFree(axisName);
-                  return MS_FAILURE;
-                }
-                axis->name = msStrdup(axisName);
-                msWCSInsertAxisObj20(params, axis);
-              }
-              xmlFree(axisName);
-
-              if (axis->size != 0) {
-                msSetError(MS_WCSERR, "targetSize was already set for axis '%s'.",
-                           "msWCSParseRequest20_XMLGetCoverage()", axis->name);
-                return MS_FAILURE;
-              }
-
-              /* targetSize */
-              if (NULL == (targetSizeNode = msLibXml2GetFirstChild(scaleAxisNode, "targetSize"))) {
-                msSetError(MS_WCSERR, "Missing targetSize node",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              content = (char *)xmlNodeGetContent(targetSizeNode);
-              if (msStringParseInteger(content, &(axis->size)) != MS_SUCCESS
-                  || axis->size <= 0) {
-                msSetError(MS_WCSERR, "Invalid targetSize '%s'.",
-                           "msWCSParseRequest20_XMLGetCoverage()", content);
-                xmlFree(content);
-                return MS_FAILURE;
-              }
-              xmlFree(content);
-            }
-          }
-
-          else if (EQUAL((char *) scaleMethodNode->name, "ScaleToExtent")) {
-            xmlNodePtr scaleAxisNode, axisNode, lowNode, highNode;
-            char *axisName, *content;
-            wcs20AxisObjPtr axis;
-            int low, high;
-
-            XML_FOREACH_CHILD(scaleMethodNode, scaleAxisNode) {
-              XML_LOOP_IGNORE_COMMENT_OR_TEXT(scaleAxisNode);
-
-              if (!EQUAL((char *)scaleAxisNode->name, "TargetAxisExtent")) {
-                msSetError(MS_WCSERR, "Invalid ScaleToExtent.",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              /* axis */
-              if (NULL == (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
-                msSetError(MS_WCSERR, "Missing axis node",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-              axisName = (char *)xmlNodeGetContent(axisNode);
-              if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-                if(NULL == (axis = msWCSCreateAxisObj20())) {
-                  xmlFree(axisName);
-                  return MS_FAILURE;
-                }
-                axis->name = msStrdup(axisName);
-                msWCSInsertAxisObj20(params, axis);
-              }
-              xmlFree(axisName);
-
-              if (axis->size != 0) {
-                msSetError(MS_WCSERR, "targetSize was already set for axis '%s'.",
-                           "msWCSParseRequest20_XMLGetCoverage()", axis->name);
-                return MS_FAILURE;
-              }
-
-              /* targetSize */
-              if (NULL == (lowNode = msLibXml2GetFirstChild(scaleAxisNode, "low"))) {
-                msSetError(MS_WCSERR, "Missing low node",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              if (NULL == (highNode = msLibXml2GetFirstChild(scaleAxisNode, "high"))) {
-                msSetError(MS_WCSERR, "Missing high node",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              content = (char *)xmlNodeGetContent(lowNode);
-              if (msStringParseInteger(content, &low) != MS_SUCCESS) {
-                msSetError(MS_WCSERR, "Invalid low value '%s'.",
-                           "msWCSParseRequest20_XMLGetCoverage()", content);
-                xmlFree(content);
-                return MS_FAILURE;
-              }
-              xmlFree(content);
-
-
-              content = (char *)xmlNodeGetContent(highNode);
-              if (msStringParseInteger(content, &high) != MS_SUCCESS) {
-                msSetError(MS_WCSERR, "Invalid high value '%s'.",
-                           "msWCSParseRequest20_XMLGetCoverage()", content);
-                xmlFree(content);
-                return MS_FAILURE;
-              }
-              xmlFree(content);
-
-              if (high <= low) {
-                msSetError(MS_WCSERR, "Invalid extent, high is lower than low.",
-                           "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              axis->size = high - low;
-            }
-          }
-        }
-
-        /* Range Subset */
-        else if(EQUAL((char *) extensionNode->name, "RangeSubset")) {
-          xmlNodePtr rangeItemNode = NULL;
-
-          XML_FOREACH_CHILD(extensionNode, rangeItemNode) {
-            xmlNodePtr rangeItemNodeChild = msLibXml2GetFirstChildElement(rangeItemNode);
-            XML_LOOP_IGNORE_COMMENT_OR_TEXT(rangeItemNode);
-
-            XML_ASSERT_NODE_NAME(rangeItemNode, "RangeItem");
-
-            if (!rangeItemNodeChild) {
-              msSetError(MS_WCSERR, "Missing RangeComponent or RangeInterval.",
-                                    "msWCSParseRequest20_XMLGetCoverage()");
-              return MS_FAILURE;
-            }
-            else if (EQUAL((char *) rangeItemNodeChild->name, "RangeComponent")) {
-              char *content = (char *)xmlNodeGetContent(rangeItemNodeChild);
-              params->range_subset =
-                CSLAddString(params->range_subset, content);
-              xmlFree(content);
-            }
-            else if (EQUAL((char *) rangeItemNodeChild->name, "RangeInterval")) {
-              xmlNodePtr intervalNode = rangeItemNodeChild;
-              xmlNodePtr startComponentNode = msLibXml2GetFirstChild(intervalNode, "startComponent");
-              xmlNodePtr endComponentNode = msLibXml2GetFirstChild(intervalNode, "endComponent");
-              char *start;
-              char *stop;
-
-              if (!startComponentNode || !endComponentNode) {
-                msSetError(MS_WCSERR, "Wrong RangeInterval.",
-                                      "msWCSParseRequest20_XMLGetCoverage()");
-                return MS_FAILURE;
-              }
-
-              start = (char *)xmlNodeGetContent(startComponentNode);
-              stop = (char *)xmlNodeGetContent(endComponentNode);
-
-              std::string value(start);
-              value += ':';
-              value += stop;
-
-              xmlFree(start);
-              xmlFree(stop);
-
-              params->range_subset =
-                CSLAddString(params->range_subset, value.c_str());
-            }
-          }
-        }
-
-        else if (EQUAL((char *) extensionNode->name, "subsettingCrs")) {
-          msFree(params->subsetcrs);
-          params->subsetcrs = (char *)xmlNodeGetContent(extensionNode);
-        }
-
-        else if (EQUAL((char *) extensionNode->name, "outputCrs")) {
-          msFree(params->outputcrs);
-          params->outputcrs = (char *)xmlNodeGetContent(extensionNode);
-        }
-
-        else if (EQUAL((char *) extensionNode->name, "Interpolation")) {
-          xmlNodePtr globalInterpolation = msLibXml2GetFirstChild(extensionNode, "globalInterpolation");
-          char *content;
-          if (globalInterpolation == NULL) {
-            msSetError(MS_WCSERR, "Missing 'globalInterpolation' node.",
-                                  "msWCSParseRequest20_XMLGetCoverage()");
-            return MS_FAILURE;
-          }
-          content = (char *)xmlNodeGetContent(globalInterpolation);
-          msFree(params->interpolation);
-          /* TODO: use URIs/URLs once they are specified */
-          params->interpolation = msStrdup(content);
-          xmlFree(content);
-        }
-
-        /* GeoTIFF parameters */
-        else if (EQUAL((char *) extensionNode->name, "parameters")
-                && extensionNode->ns
-                && EQUAL((char *)extensionNode->ns->href, "http://www.opengis.net/gmlcov/geotiff/1.0")) {
-
-          xmlNodePtr parameter;
-
-          XML_FOREACH_CHILD(extensionNode, parameter) {
-            char *content;
-            XML_LOOP_IGNORE_COMMENT_OR_TEXT(parameter);
-
-            content = (char *)xmlNodeGetContent(parameter);
-
-            params->format_options =
-              CSLAddNameValue(params->format_options, (char *)parameter->name, content);
-            xmlFree(content);
-          }
-        }
-      }
-    } else {
-      XML_UNKNOWN_NODE_ERROR(child);
-    }
-  }
-  return MS_SUCCESS;
-}
-#endif
-
-/************************************************************************/
-/*                   msWCSParseRequest20()                              */
-/*                                                                      */
-/*      Parses a CGI-request to a WCS 20 params object. It is           */
-/*      either a POST or a GET request. In case of a POST request       */
-/*      the xml content has to be parsed to a DOM structure             */
-/*      before the parameters can be extracted.                         */
-/************************************************************************/
-
-int msWCSParseRequest20(mapObj *map,
-                        cgiRequestObj *request,
-                        owsRequestObj *ows_request,
-                        wcs20ParamsObjPtr params)
-{
-  int i;
-  if (params == NULL || request == NULL || ows_request == NULL) {
-    msSetError(MS_WCSERR, "Internal error.", "msWCSParseRequest20()");
-    return MS_FAILURE;
-  }
-
-  /* Copy arbitrary service, version and request. */
-  params->service = msStrdup(ows_request->service);
-  if(ows_request->version != NULL) {
-    params->version = msStrdup(ows_request->version);
-  }
-  params->request = msStrdup(ows_request->request);
-
-
-  /* Parse the POST request */
-  if (request->type == MS_POST_REQUEST) {
-#if defined(USE_LIBXML2)
-    xmlDocPtr doc = static_cast<xmlDocPtr>(ows_request->document);
-    xmlNodePtr root = NULL;
-    const char *validate;
-    int ret = MS_SUCCESS;
-
-    /* parse to DOM-Structure and get root element */
-    if(doc == NULL) {
-      xmlErrorPtr error = xmlGetLastError();
-      msSetError(MS_WCSERR, "XML parsing error: %s",
-                 "msWCSParseRequest20()", error->message);
-      return MS_FAILURE;
-    }
-
-    root = xmlDocGetRootElement(doc);
-
-    validate = msOWSLookupMetadata(&(map->web.metadata), "CO", "validate_xml");
-    if (validate != NULL && EQUAL(validate, "TRUE")) {
-      char *schema_dir = msStrdup(msOWSLookupMetadata(&(map->web.metadata),
-                                  "CO", "schemas_dir"));
-      if (schema_dir != NULL
-          && (params->version == NULL ||
-              EQUALN(params->version, "2.0", 3))) {
-        schema_dir = msStringConcatenate(schema_dir,
-                                         "wcs/2.0.0/wcsAll.xsd");
-        if (msOWSSchemaValidation(schema_dir, request->postrequest) != 0) {
-          msSetError(MS_WCSERR, "Invalid POST request. "
-                     "XML is not valid",
-                     "msWCSParseRequest20()");
-          return MS_FAILURE;
-        }
-      }
-      msFree(schema_dir);
-    }
-
-    if(EQUAL(params->request, "GetCapabilities")) {
-      ret = msWCSParseRequest20_XMLGetCapabilities(root, params);
-    } else if(params->version != NULL && EQUALN(params->version, "2.0", 3)) {
-      if(EQUAL(params->request, "DescribeCoverage")) {
-        ret = msWCSParseRequest20_XMLDescribeCoverage(root, params);
-      } else if(EQUAL(params->request, "GetCoverage")) {
-        ret = msWCSParseRequest20_XMLGetCoverage(map, root, params);
-      }
-    }
-    return ret;
-
-#else /* defined(USE_LIBXML2) */
-    /* TODO: maybe with CPLXML? */
-    return MS_FAILURE;
-#endif /* defined(USE_LIBXML2) */
-  }
-
-  /* Parse the KVP GET request */
-  for (i = 0; i < request->NumParams; ++i) {
-    char *key = NULL, *value = NULL;
-    char **tokens;
-    int num, j;
-    key = request->ParamNames[i];
-    value = request->ParamValues[i];
-
-    if (EQUAL(key, "VERSION")) {
-      continue;
-    } else if (EQUAL(key, "REQUEST")) {
-      continue;
-    } else if (EQUAL(key, "SERVICE")) {
-      continue;
-    } else if (EQUAL(key, "ACCEPTVERSIONS")) {
-      tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        params->accept_versions =
-          CSLAddString(params->accept_versions, tokens[j]);
-      }
-      msFreeCharArray(tokens, num);
-    } else if (EQUAL(key, "SECTIONS")) {
-      tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        params->sections =
-          CSLAddString(params->sections, tokens[j]);
-      }
-      msFreeCharArray(tokens, num);
-    } else if (EQUAL(key, "UPDATESEQUENCE")) {
-      msFree(params->updatesequence);
-      params->updatesequence = msStrdup(value);
-    } else if (EQUAL(key, "ACCEPTFORMATS")) {
-      /* ignore */
-    } else if (EQUAL(key, "ACCEPTLANGUAGES")) {
-      if (params->accept_languages != NULL) {
-        CSLDestroy(params->accept_languages);
-      }
-      params->accept_languages = CSLTokenizeString2(value, ",", 0);
-    } else if (EQUAL(key, "COVERAGEID")) {
-      if (params->ids != NULL) {
-        msSetError(MS_WCSERR, "Parameter 'CoverageID' is already set. "
-                   "For multiple IDs use a comma separated list.",
-                   "msWCSParseRequest20()");
-        return MS_FAILURE;
-      }
-      params->ids = CSLTokenizeString2(value, ",",0);
-    } else if (EQUAL(key, "FORMAT")) {
-      msFree(params->format);
-      params->format = msStrdup(value);
-    } else if (EQUAL(key, "MEDIATYPE")) {
-      if(EQUAL(value, "multipart/mixed") || EQUAL(value, "multipart/related")) {
-        params->multipart = MS_TRUE;
-      }
-      else {
-         msSetError(MS_WCSERR, "Invalid value '%s' for parameter 'Mediatype'.",
-                    "msWCSParseRequest20()", value);
-         return MS_FAILURE;
-      }
-    } else if (EQUAL(key, "INTERPOLATION")) {
-      msFree(params->interpolation);
-      params->interpolation = msStrdup(value);
-    } else if (EQUAL(key, "OUTPUTCRS")) {
-      msFree(params->outputcrs);
-      params->outputcrs = msStrdup(value);
-    } else if (EQUAL(key, "SUBSETTINGCRS")) {
-      msFree(params->subsetcrs);
-      params->subsetcrs = msStrdup(value);
-    } else if (EQUAL(key, "SCALEFACTOR")) {
-      double scale = MS_WCS20_UNBOUNDED;
-      if (params->scale != MS_WCS20_UNBOUNDED) {
-        msSetError(MS_WCSERR, "Parameter 'SCALEFACTOR' already set.",
-                    "msWCSParseRequest20()");
-        return MS_FAILURE;
-      } else if (msStringParseDouble(value, &scale) != MS_SUCCESS) {
-        msSetError(MS_WCSERR, "Could not parse parameter 'SCALEFACTOR'.",
-                   "msWCSParseRequest20()");
-        return MS_FAILURE;
-      } else if (scale <= 0.0) {
-        msSetError(MS_WCSERR, "Invalid value for 'SCALEFACTOR'.",
-                   "msWCSParseRequest20()");
-        return MS_FAILURE;
-      }
-      params->scale = scale;
-    } else if (EQUAL(key, "SCALEAXES")) {
-      wcs20AxisObjPtr axis = NULL;
-      tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        char axisName[500];
-        double scale;
-
-        if (msWCSParseScaleString20(tokens[j], axisName, sizeof(axisName), &scale) != MS_SUCCESS) {
-          msFreeCharArray(tokens, num);
-          return MS_FAILURE;
-        }
-
-        if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-          if(NULL == (axis = msWCSCreateAxisObj20())) {
-            msFreeCharArray(tokens, num);
-            return MS_FAILURE;
-          }
-          axis->name = msStrdup(axisName);
-          msWCSInsertAxisObj20(params, axis);
-        }
-
-        /* check if the size of the axis is already set */
-        if(axis->scale != MS_WCS20_UNBOUNDED) {
-          msFreeCharArray(tokens, num);
-          msSetError(MS_WCSERR, "The scale of the axis is already set.",
-                     "msWCSParseRequest20()");
-          return MS_FAILURE;
-        }
-        axis->scale = scale;
-      }
-      msFreeCharArray(tokens, num);
-    } else if (EQUAL(key, "SCALESIZE")) {
-      wcs20AxisObjPtr axis = NULL;
-      tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        char axisName[500];
-        int size;
-
-        if (msWCSParseSizeString20(tokens[j], axisName, sizeof(axisName), &size) != MS_SUCCESS) {
-          msFreeCharArray(tokens, num);
-          return MS_FAILURE;
-        }
-
-        if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-          if(NULL == (axis = msWCSCreateAxisObj20())) {
-            msFreeCharArray(tokens, num);
-            return MS_FAILURE;
-          }
-          axis->name = msStrdup(axisName);
-          msWCSInsertAxisObj20(params, axis);
-        }
-
-        /* check if the size of the axis is already set */
-        if(axis->size != 0) {
-          msFreeCharArray(tokens, num);
-          msSetError(MS_WCSERR, "The size of the axis is already set.",
-                     "msWCSParseRequest20()");
-          return MS_FAILURE;
-        }
-        axis->size = size;
-      }
-      msFreeCharArray(tokens, num);
-    } else if (EQUAL(key, "SCALEEXTENT")) {
-      wcs20AxisObjPtr axis = NULL;
-      /* No real support for scaleextent, we just interprete it as SCALESIZE */
-      tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        char axisName[500];
-        int min, max;
-
-        if (msWCSParseScaleExtentString20(tokens[j], axisName, sizeof(axisName),
-                                          &min, &max) != MS_SUCCESS) {
-          msFreeCharArray(tokens, num);
-          return MS_FAILURE;
-        }
-
-        if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-          if(NULL == (axis = msWCSCreateAxisObj20())) {
-            msFreeCharArray(tokens, num);
-            return MS_FAILURE;
-          }
-          axis->name = msStrdup(axisName);
-          msWCSInsertAxisObj20(params, axis);
-        }
-
-        /* check if the size of the axis is already set */
-        if(axis->size != 0) {
-          msFreeCharArray(tokens, num);
-          msSetError(MS_WCSERR, "The size of the axis is already set.",
-                     "msWCSParseRequest20()");
-          return MS_FAILURE;
-        }
-        axis->size = max - min;
-      }
-      msFreeCharArray(tokens, num);
-      /* We explicitly don't test for strict equality as the parameter name is supposed to be unique */
-    } else if (EQUALN(key, "SIZE", 4)) {
-      /* Deprecated scaling */
-      wcs20AxisObjPtr axis = NULL;
-      char axisName[500];
-      int size = 0;
-
-      if(msWCSParseSizeString20(value, axisName, sizeof(axisName), &size) == MS_FAILURE) {
-        return MS_FAILURE;
-      }
-
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
-          return MS_FAILURE;
-        }
-        axis->name = msStrdup(axisName);
-        msWCSInsertAxisObj20(params, axis);
-      }
-
-      /* check if the size of the axis is already set */
-      if(axis->size != 0) {
-        msSetError(MS_WCSERR, "The size of the axis is already set.",
-                   "msWCSParseRequest20()");
-        return MS_FAILURE;
-      }
-      axis->size = size;
-    /* We explicitly don't test for strict equality as the parameter name is supposed to be unique */
-    } else if (EQUALN(key, "RESOLUTION", 10)) {
-      wcs20AxisObjPtr axis = NULL;
-      char axisName[500];
-      double resolution = 0;
-
-      if(msWCSParseResolutionString20(value, axisName, sizeof(axisName), &resolution) == MS_FAILURE) {
-        return MS_FAILURE;
-      }
-
-      /* check if axis object already exists, otherwise create a new one */
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
-          return MS_FAILURE;
-        }
-        axis->name = msStrdup(axisName);
-        msWCSInsertAxisObj20(params, axis);
-      }
-
-      /* check if the resolution of the axis is already set */
-      if(axis->resolution != MS_WCS20_UNBOUNDED) {
-        msSetError(MS_WCSERR, "The resolution of the axis is already set.",
-                   "msWCSParseRequest20()");
-        return MS_FAILURE;
-      }
-      axis->resolution = resolution;
-    /* We explicitly don't test for strict equality as the parameter name is supposed to be unique */
-    } else if (EQUALN(key, "SUBSET", 6)) {
-      wcs20AxisObjPtr axis = NULL;
-      wcs20SubsetObjPtr subset = msWCSCreateSubsetObj20();
-      if(NULL == subset) {
-        return MS_FAILURE;
-      }
-      if (msWCSParseSubsetKVPString20(subset, value) == MS_FAILURE) {
-        msWCSFreeSubsetObj20(subset);
-        msWCSException(map, "InvalidSubsetting", "subset", ows_request->version);
-        return MS_DONE;
-      }
-
-      if(NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
-          return MS_FAILURE;
-        }
-        axis->name = msStrdup(subset->axis);
-        msWCSInsertAxisObj20(params, axis);
-      }
-
-      if(NULL != axis->subset) {
-        msSetError(MS_WCSERR, "The axis '%s' is already subsetted.",
-                   "msWCSParseRequest20()", axis->name);
-        msWCSFreeSubsetObj20(subset);
-        msWCSException(map, "InvalidAxisLabel", "subset", ows_request->version);
-        return MS_DONE;
-      }
-      axis->subset = subset;
-    } else if(EQUAL(key, "RANGESUBSET")) {
-      tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        params->range_subset =
-          CSLAddString(params->range_subset, tokens[j]);
-      }
-      msFreeCharArray(tokens, num);
-    } else if (EQUALN(key, "GEOTIFF:", 8)) {
-      params->format_options =
-        CSLAddNameValue(params->format_options, key, value);
-    }
-    /* Ignore all other parameters here */
-  }
-
-  return MS_SUCCESS;
-}
-
-#if defined(USE_LIBXML2)
-
-/************************************************************************/
-/*                   msWCSValidateAndFindSubsets20()                    */
-/*                                                                      */
-/*      Iterates over every axis in the parameters and checks if the    */
-/*      axis name is in any string list. If found, but there already is */
-/*      a sample found for this axis, an Error is returned. Also if no  */
-/*      axis is found for a given axis, an error is returned.           */
-/************************************************************************/
-static int msWCSValidateAndFindAxes20(
-  wcs20ParamsObjPtr params,
-  wcs20AxisObjPtr outAxes[])
-{
-  static const int numAxis = 2;
-  const char * const validXAxisNames[] = {"x", "xaxis", "x-axis", "x_axis", "long", "long_axis", "long-axis", "lon", "lon_axis", "lon-axis", NULL};
-  const char * const validYAxisNames[] = {"y", "yaxis", "y-axis", "y_axis", "lat", "lat_axis", "lat-axis", NULL};
-  const char * const * const validAxisNames[2] = { validXAxisNames, validYAxisNames };
-  int iParamAxis, iAcceptedAxis, iName, i;
-
-  for(i = 0; i < numAxis; ++i) {
-    outAxes[i] = NULL;
-  }
-
-  /* iterate over all subsets */
-  for(iParamAxis = 0; iParamAxis < params->numaxes; ++iParamAxis) {
-    int found = 0;
-
-    /* iterate over all given axes */
-    for(iAcceptedAxis = 0; iAcceptedAxis < numAxis; ++iAcceptedAxis ) {
-      /* iterate over all possible names for the current axis */
-      for(iName = 0; validAxisNames[iAcceptedAxis][iName] != NULL ; ++iName) {
-        /* compare axis name with current possible name */
-        if(EQUAL(params->axes[iParamAxis]->name, validAxisNames[iAcceptedAxis][iName])) {
-          /* if there is already a sample for the axis, throw error */
-          if(outAxes[iAcceptedAxis] != NULL) {
-            msSetError(MS_WCSERR, "The axis with the name '%s' corresponds "
-                       "to the same axis as the subset with the name '%s'.",
-                       "msWCSValidateAndFindAxes20()",
-                       outAxes[iAcceptedAxis]->name, params->axes[iParamAxis]->name);
-            return MS_FAILURE;
-          }
-
-          /* if match is found, save it */
-          outAxes[iAcceptedAxis] = params->axes[iParamAxis];
-          found = 1;
-          break;
-        }
-      }
-      if (found) {
-        break;
-      }
-    }
-
-    /* no valid representation for current subset found */
-    /* exit and throw error                             */
-    if(found == 0) {
-      msSetError(MS_WCSERR, "Invalid subset axis '%s'.",
-                 "msWCSValidateAndFindAxes20()", params->axes[iParamAxis]->name);
-      return MS_FAILURE;
-    }
-  }
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSPrepareNamespaces20()                         */
-/*                                                                      */
-/*      Inserts namespace definitions into the root node of a DOM       */
-/*      structure.                                                      */
-/************************************************************************/
-
-static void msWCSPrepareNamespaces20(xmlDocPtr pDoc, xmlNodePtr psRootNode, mapObj* map, int addInspire)
-{
-  xmlNsPtr psXsiNs;
-  char *schemaLocation = NULL;
-  char *xsi_schemaLocation = NULL;
-
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX));
-
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_20_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,       BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,     BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI,     BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_SWE_20_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
-
-  if (addInspire) {
-    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
-    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
-  }
-
-  psXsiNs = xmlSearchNs(pDoc, psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-
-  schemaLocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WCS_20_NAMESPACE_URI);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-
-  if (addInspire) {
-    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_NAMESPACE_URI " ");
-    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
-    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
-  }
-
-  xmlNewNsProp(psRootNode, psXsiNs, BAD_CAST "schemaLocation", BAD_CAST xsi_schemaLocation);
-
-  msFree(schemaLocation);
-  msFree(xsi_schemaLocation);
-}
-
-/************************************************************************/
-/*                   msWCSGetFormatList20()                             */
-/*                                                                      */
-/*      Copied from mapwcs.c.                                           */
-/************************************************************************/
-
-static char *msWCSGetFormatsList20( mapObj *map, layerObj *layer )
-{
-  char *format_list = msStrdup("");
-  char **tokens = NULL, **formats = NULL;
-  int  i, numtokens = 0, numformats;
-  char *value;
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse from layer metadata.                                      */
-  /* -------------------------------------------------------------------- */
-  if( layer != NULL
-      && (value = msOWSGetEncodeMetadata( &(layer->metadata),"CO","formats",
-                                          NULL )) != NULL ) {
-    tokens = msStringSplit(value, ' ', &numtokens);
-    msFree(value);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse from map.web metadata.                                    */
-  /* -------------------------------------------------------------------- */
-  else if((value = msOWSGetEncodeMetadata( &(map->web.metadata), "CO", "formats",
-                                           NULL)) != NULL ) {
-    tokens = msStringSplit(value, ' ', &numtokens);
-    msFree(value);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Or generate from all configured raster output formats that      */
-  /*      look plausible.                                                 */
-  /* -------------------------------------------------------------------- */
-  else {
-    tokens = (char **) msSmallCalloc(map->numoutputformats,sizeof(char*));
-    for( i = 0; i < map->numoutputformats; i++ ) {
-      switch( map->outputformatlist[i]->renderer ) {
-          /* seemingly normal raster format */
-        case MS_RENDER_WITH_AGG:
-        case MS_RENDER_WITH_RAWDATA:
-          tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
-          break;
-          /* rest of formats aren't really WCS compatible */
-        default:
-          break;
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Convert outputFormatObj names into mime types and remove        */
-  /*      duplicates.                                                     */
-  /* -------------------------------------------------------------------- */
-  numformats = 0;
-  formats = (char **) msSmallCalloc(sizeof(char*),numtokens);
-
-  for( i = 0; i < numtokens; i++ ) {
-    int format_i, j;
-    const char *mimetype;
-
-    for( format_i = 0; format_i < map->numoutputformats; format_i++ ) {
-      if( EQUAL(map->outputformatlist[format_i]->name, tokens[i]) )
-        break;
-    }
-
-    if( format_i == map->numoutputformats ) {
-      msDebug("Failed to find outputformat info on format '%s', ignore.\n",
-              tokens[i] );
-      continue;
-    }
-
-    mimetype = map->outputformatlist[format_i]->mimetype;
-    if( mimetype == NULL || strlen(mimetype) == 0 ) {
-      msDebug("No mimetime for format '%s', ignoring.\n",
-              tokens[i] );
-      continue;
-    }
-
-    for( j = 0; j < numformats; j++ ) {
-      if( EQUAL(mimetype,formats[j]) )
-        break;
-    }
-
-    if( j < numformats ) {
-      msDebug( "Format '%s' ignored since mimetype '%s' duplicates another outputFormatObj.\n",
-               tokens[i], mimetype );
-      continue;
-    }
-
-    formats[numformats++] = msStrdup(mimetype);
-  }
-
-  msFreeCharArray(tokens,numtokens);
-
-  /* -------------------------------------------------------------------- */
-  /*      Turn mimetype list into comma delimited form for easy use       */
-  /*      with xml functions.                                             */
-  /* -------------------------------------------------------------------- */
-  for(i = 0; i < numformats; i++) {
-    if(i > 0) {
-      format_list = msStringConcatenate(format_list, (char *) ",");
-    }
-    format_list = msStringConcatenate(format_list, formats[i]);
-  }
-  msFreeCharArray(formats,numformats);
-
-  return format_list;
-}
-
-/************************************************************************/
-/*                   msWCSSwapAxes20                                    */
-/*                                                                      */
-/*      Helper function to determine if a SRS mandates swapped axes.    */
-/************************************************************************/
-
-static int msWCSSwapAxes20(char *srs_uri)
-{
-  int srid = 0;
-
-  /* get SRID from the srs uri */
-  if(srs_uri != NULL && strlen(srs_uri) > 0) {
-    if(sscanf(srs_uri, "http://www.opengis.net/def/crs/EPSG/0/%d", &srid) != EOF)
-      ;
-    else if(sscanf(srs_uri, "http://www.opengis.net/def/crs/%d", &srid) != EOF)
-      ;
-    else
-      srid = 0;
-  }
-  if (srid == 0)
-    return MS_FALSE;
-
-  return msIsAxisInverted(srid);
-}
-
-/************************************************************************/
-/*                   msWCSCommon20_CreateBoundedBy()                    */
-/*                                                                      */
-/*      Inserts the BoundedBy section into an existing DOM structure.   */
-/************************************************************************/
-
-static void msWCSCommon20_CreateBoundedBy(wcs20coverageMetadataObjPtr cm,
-    xmlNsPtr psGmlNs, xmlNodePtr psRoot, projectionObj *projection, int swapAxes)
-{
-  xmlNodePtr psBoundedBy, psEnvelope;
-  char lowerCorner[100], upperCorner[100], axisLabels[100], uomLabels[100];
-
-  psBoundedBy = xmlNewChild( psRoot, psGmlNs, BAD_CAST "boundedBy", NULL);
-  {
-    psEnvelope = xmlNewChild(psBoundedBy, psGmlNs, BAD_CAST "Envelope", NULL);
-    {
-      xmlNewProp(psEnvelope, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
-
-      if(projection->proj != NULL && msProjIsGeographicCRS(projection)) {
-        if (swapAxes == MS_FALSE) {
-          strlcpy(axisLabels, "long lat", sizeof(axisLabels));
-        } else {
-          strlcpy(axisLabels, "lat long", sizeof(axisLabels));
-        }
-        strlcpy(uomLabels, "deg deg", sizeof(uomLabels));
-      } else {
-        if (swapAxes == MS_FALSE) {
-          strlcpy(axisLabels, "x y", sizeof(axisLabels));
-        } else {
-          strlcpy(axisLabels, "y x", sizeof(axisLabels));
-        }
-        strlcpy(uomLabels, "m m", sizeof(uomLabels));
-      }
-      xmlNewProp(psEnvelope, BAD_CAST "axisLabels", BAD_CAST axisLabels);
-      xmlNewProp(psEnvelope, BAD_CAST "uomLabels", BAD_CAST uomLabels);
-      xmlNewProp(psEnvelope, BAD_CAST "srsDimension", BAD_CAST "2");
-
-      if (swapAxes == MS_FALSE) {
-        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g", cm->extent.minx, cm->extent.miny);
-        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g", cm->extent.maxx, cm->extent.maxy);
-      } else {
-        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g", cm->extent.miny, cm->extent.minx);
-        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g", cm->extent.maxy, cm->extent.maxx);
-      }
-
-      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "lowerCorner", BAD_CAST lowerCorner);
-      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "upperCorner", BAD_CAST upperCorner);
-    }
-  }
-}
-
-/************************************************************************/
-/*                   msWCSCommon20_CreateDomainSet()                    */
-/*                                                                      */
-/*      Inserts the DomainSet section into an existing DOM structure.   */
-/************************************************************************/
-
-static void msWCSCommon20_CreateDomainSet(layerObj* layer, wcs20coverageMetadataObjPtr cm,
-    xmlNsPtr psGmlNs, xmlNodePtr psRoot, projectionObj *projection, int swapAxes)
-{
-  xmlNodePtr psDomainSet, psGrid, psLimits, psGridEnvelope, psOrigin,
-             psOffsetX, psOffsetY;
-  char low[100], high[100], id[100], point[100];
-  char offsetVector1[100], offsetVector2[100], axisLabels[100];
-
-  psDomainSet = xmlNewChild( psRoot, psGmlNs, BAD_CAST "domainSet", NULL);
-  {
-    psGrid = xmlNewChild(psDomainSet, psGmlNs, BAD_CAST "RectifiedGrid", NULL);
-    {
-      double x0 = cm->geotransform[0]+cm->geotransform[1]/2+cm->geotransform[2]/2;
-      double y0 = cm->geotransform[3]+cm->geotransform[4]/2+cm->geotransform[5]/2;
-      double resx = cm->geotransform[1];
-      double resy = cm->geotransform[5];
-
-      xmlNewProp(psGrid, BAD_CAST "dimension", BAD_CAST "2");
-      snprintf(id, sizeof(id), "grid_%s", layer->name);
-      xmlNewNsProp(psGrid, psGmlNs, BAD_CAST "id", BAD_CAST id);
-
-      psLimits = xmlNewChild(psGrid, psGmlNs, BAD_CAST "limits", NULL);
-      {
-        psGridEnvelope = xmlNewChild(psLimits, psGmlNs, BAD_CAST "GridEnvelope", NULL);
-        {
-          strlcpy(low, "0 0", sizeof(low));
-          snprintf(high, sizeof(high), "%d %d", cm->xsize - 1, cm->ysize - 1);
-
-          xmlNewChild(psGridEnvelope, psGmlNs, BAD_CAST "low", BAD_CAST low);
-          xmlNewChild(psGridEnvelope, psGmlNs, BAD_CAST "high", BAD_CAST high);
-        }
-      }
-
-      if(projection->proj != NULL && msProjIsGeographicCRS(projection)) {
-        strlcpy(axisLabels, "long lat", sizeof(axisLabels));
-      } else {
-        strlcpy(axisLabels, "x y", sizeof(axisLabels));
-      }
-
-      xmlNewChild(psGrid, psGmlNs, BAD_CAST "axisLabels", BAD_CAST axisLabels);
-
-      psOrigin = xmlNewChild(psGrid, psGmlNs, BAD_CAST "origin", NULL);
-      {
-        if (swapAxes == MS_FALSE) {
-          snprintf(point, sizeof(point), "%f %f", x0, y0);
-        } else {
-          snprintf(point, sizeof(point), "%f %f", y0, x0);
-        }
-        psOrigin = xmlNewChild(psOrigin, psGmlNs, BAD_CAST "Point", NULL);
-        snprintf(id, sizeof(id), "grid_origin_%s", layer->name);
-        xmlNewNsProp(psOrigin, psGmlNs, BAD_CAST "id", BAD_CAST id);
-        xmlNewProp(psOrigin, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
-
-        xmlNewChild(psOrigin, psGmlNs, BAD_CAST "pos", BAD_CAST point);
-      }
-
-      if (swapAxes == MS_FALSE) {
-        snprintf(offsetVector1, sizeof(offsetVector1), "%f 0", resx);
-        snprintf(offsetVector2, sizeof(offsetVector2), "0 %f", resy);
-      } else {
-        snprintf(offsetVector1, sizeof(offsetVector1), "0 %f", resx);
-        snprintf(offsetVector2, sizeof(offsetVector2), "%f 0", resy);
-      }
-      psOffsetX = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector", BAD_CAST offsetVector1);
-      psOffsetY = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector", BAD_CAST offsetVector2);
-
-      xmlNewProp(psOffsetX, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
-      xmlNewProp(psOffsetY, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
-    }
-  }
-}
-
-/************************************************************************/
-/*                   msWCSCommon20_CreateRangeType()                    */
-/*                                                                      */
-/*      Inserts the RangeType section into an existing DOM structure.   */
-/************************************************************************/
-
-static void msWCSCommon20_CreateRangeType(wcs20coverageMetadataObjPtr cm, char *bands,
-    xmlNsPtr psGmlcovNs, xmlNsPtr psSweNs, xmlNodePtr psRoot)
-{
-  xmlNodePtr psRangeType, psDataRecord, psField, psQuantity,
-             psUom, psConstraint, psAllowedValues = NULL, psNilValues = NULL;
-  char **arr = NULL;
-  int num = 0;
-
-  if(NULL != bands) {
-    arr = msStringSplit(bands, ',', &num);
-  }
-
-  psRangeType = xmlNewChild( psRoot, psGmlcovNs, BAD_CAST "rangeType", NULL);
-  psDataRecord  = xmlNewChild(psRangeType, psSweNs, BAD_CAST "DataRecord", NULL);
-
-  /* iterate over every band */
-  for(unsigned i = 0; i < cm->numbands; ++i) {
-    /* only add bands that are in the range subset */
-    if (NULL != arr && num > 0) {
-      int found = MS_FALSE, j;
-      for(j = 0; j < num; ++j) {
-        int repr = 0;
-        if(msStringParseInteger(arr[j], &repr) == MS_SUCCESS &&
-           static_cast<unsigned>(repr) == i + 1) {
-          found = MS_TRUE;
-          break;
-        }
-      }
-      if(found == MS_FALSE) {
-        /* ignore this band since it is not in the range subset */
-        continue;
-      }
-    }
-
-    /* add field tag */
-    psField = xmlNewChild(psDataRecord, psSweNs, BAD_CAST "field", NULL);
-
-    if(cm->bands[i].name != NULL) {
-      xmlNewProp(psField, BAD_CAST "name", BAD_CAST cm->bands[i].name);
-    } else {
-      xmlNewProp(psField, BAD_CAST "name", BAD_CAST "band");
-    }
-    /* add Quantity tag */
-    psQuantity = xmlNewChild(psField, psSweNs, BAD_CAST "Quantity", NULL);
-    if(cm->bands[i].definition != NULL) {
-      xmlNewProp(psQuantity, BAD_CAST "definition", BAD_CAST cm->bands[i].definition);
-    }
-    if(cm->bands[i].description != NULL) {
-      xmlNewChild(psQuantity, psSweNs, BAD_CAST "description", BAD_CAST cm->bands[i].description);
-    }
-
-    /* if there are given nilvalues -> add them to the first field */
-    /* all other fields get a reference to these */
-    if(cm->numnilvalues > 0) {
-      psNilValues = xmlNewChild(
-                      xmlNewChild(psQuantity, psSweNs, BAD_CAST "nilValues", NULL),
-                      psSweNs, BAD_CAST "NilValues", NULL);
-      for(unsigned j = 0; j < cm->numnilvalues; ++j) {
-        xmlNodePtr psTemp =
-          xmlNewChild(psNilValues, psSweNs, BAD_CAST "nilValue", BAD_CAST cm->nilvalues[j]);
-        if(j < cm->numnilvalues)
-          xmlNewProp(psTemp, BAD_CAST "reason", BAD_CAST cm->nilvalues_reasons[j]);
-      }
-    } else { /* create an empty nilValues tag */
-      xmlNewChild(psQuantity, psSweNs, BAD_CAST "nilValues", NULL);
-    }
-
-    psUom = xmlNewChild(psQuantity, psSweNs, BAD_CAST "uom", NULL);
-    if(cm->bands[i].uom != NULL) {
-      xmlNewProp(psUom, BAD_CAST "code", BAD_CAST cm->bands[i].uom);
-    } else {
-      xmlNewProp(psUom, BAD_CAST "code", BAD_CAST "W.m-2.Sr-1");
-    }
-
-    /* add constraint */
-    psConstraint = xmlNewChild(psQuantity, psSweNs, BAD_CAST "constraint", NULL);
-
-    {
-      char interval[100], significant_figures[100];
-      psAllowedValues = xmlNewChild(psConstraint, psSweNs, BAD_CAST "AllowedValues", NULL);
-
-      /* Interval */
-      snprintf(interval, sizeof(interval), "%.5g %.5g", cm->bands[i].interval_min, cm->bands[i].interval_max);
-      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "interval", BAD_CAST interval);
-
-      /* Significant figures */
-      snprintf(significant_figures, sizeof(significant_figures), "%d", cm->bands[i].significant_figures);
-      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "significantFigures", BAD_CAST significant_figures);
-    }
-  }
-  msFreeCharArray(arr,num);
-}
-
-/************************************************************************/
-/*                   msWCSWriteDocument20()                             */
-/*                                                                      */
-/*      Writes out an xml structure to the stream.                      */
-/************************************************************************/
-
-static int msWCSWriteDocument20(xmlDocPtr psDoc)
-{
-  xmlChar *buffer = NULL;
-  int size = 0;
-  msIOContext *context = NULL;
-  char *contenttype = NULL;
-
-  if( msIO_needBinaryStdout() == MS_FAILURE ) {
-    return MS_FAILURE;
-  }
-
-  if( EQUAL((char *)xmlDocGetRootElement(psDoc)->name, "RectifiedGridCoverage") )
-    contenttype = msStrdup("application/gml+xml");
-  else
-    contenttype = msStrdup("text/xml");
-
-  msIO_setHeader("Content-Type","%s; charset=UTF-8", contenttype);
-  msIO_sendHeaders();
-  msFree(contenttype);
-
-  context = msIO_getHandler(stdout);
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
-  msIO_contextWrite(context, buffer, size);
-  xmlFree(buffer);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSWriteFile20()                                 */
-/*                                                                      */
-/*      Writes an image object to the stream. If multipart is set,      */
-/*      then content sections are inserted.                             */
-/************************************************************************/
-
-static int msWCSWriteFile20(mapObj* map, imageObj* image, wcs20ParamsObjPtr params, int multipart)
-{
-  int status;
-  char* filename = NULL;
-  char *base_dir = NULL;
-  const char *fo_filename;
-  int i;
-
-  fo_filename = msGetOutputFormatOption( image->format, "FILENAME", NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*      Fetch the driver we will be using and check if it supports      */
-  /*      VSIL IO.                                                        */
-  /* -------------------------------------------------------------------- */
-  if( EQUALN(image->format->driver,"GDAL/",5) ) {
-    GDALDriverH hDriver;
-    const char *pszExtension = image->format->extension;
-
-    msAcquireLock( TLOCK_GDAL );
-    hDriver = GDALGetDriverByName( image->format->driver+5 );
-    if( hDriver == NULL ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_MISCERR,
-                  "Failed to find %s driver.",
-                  "msWCSWriteFile20()",
-                  image->format->driver+5 );
-      return msWCSException(map, "NoApplicableCode", "mapserv",
-                            params->version);
-    }
-
-    if( pszExtension == NULL )
-      pszExtension = "img.tmp";
-
-    if( msGDALDriverSupportsVirtualIOOutput(hDriver) ) {
-      base_dir = msTmpFile(map, map->mappath, "/vsimem/wcsout", NULL);
-      if( fo_filename )
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            fo_filename,NULL));
-      else
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            "out", pszExtension ));
-
-      /*            CleanVSIDir( "/vsimem/wcsout" ); */
-
-      msReleaseLock( TLOCK_GDAL );
-      status = msSaveImage(map, image, filename);
-      if( status != MS_SUCCESS ) {
-        msSetError(MS_MISCERR, "msSaveImage() failed",
-                   "msWCSWriteFile20()");
-        return msWCSException20(map, "NoApplicableCode", "mapserv",
-                                params->version);
-      }
-    }
-    msReleaseLock( TLOCK_GDAL );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If we weren't able to write data under /vsimem, then we just    */
-  /*      output a single "stock" filename.                               */
-  /* -------------------------------------------------------------------- */
-  if( filename == NULL ) {
-    msOutputFormatResolveFromImage( map, image );
-    if(multipart) {
-      msIO_fprintf( stdout, "\r\n--wcs\r\n" );
-      msIO_fprintf(
-        stdout,
-        "Content-Type: %s\r\n"
-        "Content-Description: coverage data\r\n"
-        "Content-Transfer-Encoding: binary\r\n",
-        MS_IMAGE_MIME_TYPE(map->outputformat));
-
-      if( fo_filename != NULL )
-        msIO_fprintf( stdout,
-                      "Content-ID: coverage/%s\r\n"
-                      "Content-Disposition: INLINE; filename=%s\r\n\r\n",
-                      fo_filename,
-                      fo_filename);
-      else
-        msIO_fprintf( stdout,
-                      "Content-ID: coverage/wcs.%s\r\n"
-                      "Content-Disposition: INLINE\r\n\r\n",
-                      MS_IMAGE_EXTENSION(map->outputformat));
-    } else {
-      msIO_setHeader("Content-Type","%s",MS_IMAGE_MIME_TYPE(map->outputformat));
-      msIO_setHeader("Content-Description","coverage data");
-      msIO_setHeader("Content-Transfer-Encoding","binary");
-
-      if( fo_filename != NULL ) {
-        msIO_setHeader("Content-ID","coverage/%s",fo_filename);
-        msIO_setHeader("Content-Disposition","INLINE; filename=%s",fo_filename);
-      } else {
-        msIO_setHeader("Content-ID","coverage/wcs.%s",MS_IMAGE_EXTENSION(map->outputformat));
-        msIO_setHeader("Content-Disposition","INLINE");
-      }
-      msIO_sendHeaders();
-    }
-
-    status = msSaveImage(map, image, NULL);
-    if( status != MS_SUCCESS ) {
-      msSetError( MS_MISCERR, "msSaveImage() failed", "msWCSWriteFile20()");
-      return msWCSException(map, "NoApplicableCode", "mapserv", params->version);
-    }
-    if(multipart)
-      msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
-    return MS_SUCCESS;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      When potentially listing multiple files, we take great care     */
-  /*      to identify the "primary" file and list it first.  In fact      */
-  /*      it is the only file listed in the coverages document.           */
-  /* -------------------------------------------------------------------- */
-  {
-    char **all_files = CPLReadDir( base_dir );
-    int count = CSLCount(all_files);
-
-    if( msIO_needBinaryStdout() == MS_FAILURE )
-      return MS_FAILURE;
-
-    msAcquireLock( TLOCK_GDAL );
-    for( i = count-1; i >= 0; i-- ) {
-      const char *this_file = all_files[i];
-
-      if( EQUAL(this_file,".") || EQUAL(this_file,"..") ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
-        continue;
-      }
-
-      if( i > 0 && EQUAL(this_file,CPLGetFilename(filename)) ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
-        all_files = CSLInsertString(all_files,0,CPLGetFilename(filename));
-        i++;
-      }
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      Dump all the files in the memory directory as mime sections.    */
-    /* -------------------------------------------------------------------- */
-    count = CSLCount(all_files);
-
-    if(count > 1 && multipart == MS_FALSE) {
-      msDebug( "msWCSWriteFile20(): force multipart output without gml summary because we have multiple files in the result.\n" );
-
-      multipart = MS_TRUE;
-      msIO_setHeader("Content-Type","multipart/related; boundary=wcs");
-      msIO_sendHeaders();
-    }
-
-    for( i = 0; i < count; i++ ) {
-      const char *mimetype = NULL;
-      VSILFILE *fp;
-      unsigned char block[4000];
-      int bytes_read;
-
-      if( i == 0
-          && !EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "unknown") )
-        mimetype = MS_IMAGE_MIME_TYPE(map->outputformat);
-
-      if( mimetype == NULL )
-        mimetype = "application/octet-stream";
-      if(multipart) {
-        msIO_fprintf( stdout, "\r\n--wcs\r\n" );
-        msIO_fprintf(
-          stdout,
-          "Content-Type: %s\r\n"
-          "Content-Description: coverage data\r\n"
-          "Content-Transfer-Encoding: binary\r\n"
-          "Content-ID: coverage/%s\r\n"
-          "Content-Disposition: INLINE; filename=%s\r\n\r\n",
-          mimetype,
-          all_files[i],
-          all_files[i]);
-      } else {
-        msIO_setHeader("Content-Type","%s",mimetype);
-        msIO_setHeader("Content-Description","coverage data");
-        msIO_setHeader("Content-Transfer-Encoding","binary");
-        msIO_setHeader("Content-ID","coverage/%s",all_files[i]);
-        msIO_setHeader("Content-Disposition","INLINE; filename=%s",all_files[i]);
-        msIO_sendHeaders();
-      }
-
-
-      fp = VSIFOpenL(
-             CPLFormFilename(base_dir, all_files[i], NULL),
-             "rb" );
-      if( fp == NULL ) {
-        msReleaseLock( TLOCK_GDAL );
-        msSetError( MS_MISCERR,
-                    "Failed to open %s for streaming to stdout.",
-                    "msWCSWriteFile20()", all_files[i] );
-        return MS_FAILURE;
-      }
-
-      while( (bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0 )
-        msIO_fwrite( block, 1, bytes_read, stdout );
-
-      VSIFCloseL( fp );
-
-      VSIUnlink( CPLFormFilename(base_dir, all_files[i], NULL) );
-    }
-
-    msFree(base_dir);
-    msFree(filename);
-    CSLDestroy( all_files );
-    msReleaseLock( TLOCK_GDAL );
-    if(multipart)
-      msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
-    return MS_SUCCESS;
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSGetRangesetAxisMetadata20()                   */
-/*                                                                      */
-/*      Looks up a layers metadata for a specific axis information.     */
-/************************************************************************/
-
-static const char *msWCSLookupRangesetAxisMetadata20(hashTableObj *table,
-    const char *axis, const char *item)
-{
-  char buf[500];
-  const char* value;
-
-  if(table == NULL || axis == NULL || item == NULL) {
-    return NULL;
-  }
-
-  strlcpy(buf, axis, sizeof(buf));
-  strlcat(buf, "_", sizeof(buf));
-  strlcat(buf, item, sizeof(buf));
-  if((value = msLookupHashTable(table, buf)) != NULL) {
-    return value;
-  }
-  return msOWSLookupMetadata(table, "CO", buf);
-}
-
-/************************************************************************/
-/*                   msWCSGetCoverageMetadata20()                       */
-/*                                                                      */
-/*      Inits a coverageMetadataObj. Uses msWCSGetCoverageMetadata()    */
-/*      but exchanges the SRS URN by an URI for compliancy with 2.0.    */
-/************************************************************************/
-
-static int msWCSGetCoverageMetadata20(layerObj *layer, wcs20coverageMetadataObj *cm)
-{
-  char  *srs_uri = NULL;
-  memset(cm,0,sizeof(wcs20coverageMetadataObj));
-  if ( msCheckParentPointer(layer->map,"map") == MS_FAILURE )
-    return MS_FAILURE;
-
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &(cm->srs_epsg));
-  if(!cm->srs_epsg) {
-    msOWSGetEPSGProj(&(layer->map->projection),
-                                   &(layer->map->web.metadata), "CO", MS_TRUE, &cm->srs_epsg);
-    if(!cm->srs_epsg) {
-      msSetError(MS_WCSERR, "Unable to determine the SRS for this layer, "
-                 "no projection defined and no metadata available.",
-                 "msWCSGetCoverageMetadata20()");
-      return MS_FAILURE;
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Get the SRS in uri format.                                      */
-  /* -------------------------------------------------------------------- */
-  if((srs_uri = msOWSGetProjURI(&(layer->projection), &(layer->metadata),
-                                "CO", MS_TRUE)) == NULL) {
-    srs_uri = msOWSGetProjURI(&(layer->map->projection),
-                              &(layer->map->web.metadata), "CO", MS_TRUE);
-  }
-
-  if( srs_uri != NULL ) {
-    if( strlen(srs_uri) > sizeof(cm->srs_uri) - 1 ) {
-      msSetError(MS_WCSERR, "SRS URI too long!",
-                 "msWCSGetCoverageMetadata()");
-      return MS_FAILURE;
-    }
-
-    strlcpy( cm->srs_uri, srs_uri, sizeof(cm->srs_uri) );
-    msFree( srs_uri );
-  } else {
-    cm->srs_uri[0] = '\0';
-  }
-
-  /* setup nilvalues */
-  cm->numnilvalues = 0;
-  cm->nilvalues = NULL;
-  cm->nilvalues_reasons = NULL;
-  cm->native_format = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*      If we have "virtual dataset" metadata on the layer, then use    */
-  /*      that in preference to inspecting the file(s).                   */
-  /*      We require extent and either size or resolution.                */
-  /* -------------------------------------------------------------------- */
-  if( msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL
-      && (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL
-          || msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL) ) {
-    const char *value;
-
-    /* get extent */
-    cm->extent.minx = 0.0;
-    cm->extent.maxx = 0.0;
-    cm->extent.miny = 0.0;
-    cm->extent.maxy = 0.0;
-    if( msOWSGetLayerExtent( layer->map, layer, "CO", &cm->extent ) == MS_FAILURE )
-      return MS_FAILURE;
-
-    /* get resolution */
-    cm->xresolution = 0.0;
-    cm->yresolution = 0.0;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) != NULL ) {
-      char **tokens;
-      int n;
-
-      tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_resolution metadata.", "msWCSGetCoverageMetadata20()");
-        msFreeCharArray( tokens, n );
-        return MS_FAILURE;
-      }
-      cm->xresolution = atof(tokens[0]);
-      cm->yresolution = atof(tokens[1]);
-      msFreeCharArray( tokens, n );
-    }
-
-    /* get Size (in pixels and lines) */
-    cm->xsize = 0;
-    cm->ysize = 0;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "size")) != NULL ) {
-      char **tokens;
-      int n;
-
-      tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_size metadata.", "msWCSGetCoverageMetadata20()");
-        msFreeCharArray( tokens, n );
-        return MS_FAILURE;
-      }
-      cm->xsize = atoi(tokens[0]);
-      cm->ysize = atoi(tokens[1]);
-      msFreeCharArray( tokens, n );
-    }
-
-    /* try to compute raster size */
-    if( cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 && cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx && cm->extent.miny != cm->extent.maxy ) {
-      cm->xsize = (int) ((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
-      cm->ysize = (int) fabs((cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
-    }
-
-    /* try to compute raster resolution */
-    if( (cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 && cm->ysize != 0 ) {
-      cm->xresolution = (cm->extent.maxx - cm->extent.minx) / cm->xsize;
-      cm->yresolution = (cm->extent.maxy - cm->extent.miny) / cm->ysize;
-    }
-
-    /* do we have information to do anything */
-    if( cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 || cm->ysize == 0 ) {
-      msSetError( MS_WCSERR, "Failed to collect extent and resolution for WCS coverage from metadata for layer '%s'.  Need value wcs|ows_resolution or wcs|ows_size values.", "msWCSGetCoverageMetadata20()", layer->name );
-      return MS_FAILURE;
-    }
-
-    /* compute geotransform */
-    cm->geotransform[0] = cm->extent.minx;
-    cm->geotransform[1] = cm->xresolution;
-    cm->geotransform[2] = 0.0;
-    cm->geotransform[3] = cm->extent.maxy;
-    cm->geotransform[4] = 0.0;
-    cm->geotransform[5] = -fabs(cm->yresolution);
-
-    /* get bands count, or assume 1 if not found */
-    cm->numbands = 1;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) != NULL) {
-      int numbands = 0;
-      msStringParseInteger(value, &numbands);
-      cm->numbands = (size_t)numbands;
-    }
-
-    cm->bands = static_cast<wcs20rasterbandMetadataObj*>(msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
-
-    /* get bands type, or assume float if not found */
-    cm->imagemode = MS_IMAGEMODE_FLOAT32;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) != NULL ) {
-      if( EQUAL(value,"INT16") )
-        cm->imagemode = MS_IMAGEMODE_INT16;
-      else if( EQUAL(value,"FLOAT32") )
-        cm->imagemode = MS_IMAGEMODE_FLOAT32;
-      else if( EQUAL(value,"BYTE") )
-        cm->imagemode = MS_IMAGEMODE_BYTE;
-      else {
-        msSetError( MS_WCSERR, "Content of wcs|ows_imagemode (%s) not recognised.  Should be one of BYTE, INT16 or FLOAT32.", "msWCSGetCoverageMetadata20()", value );
-        return MS_FAILURE;
-      }
-    }
-
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "native_format")) != NULL ) {
-      cm->native_format = msStrdup(value);
-    }
-
-    /* determine nilvalues and reasons */
-    {
-      int n_nilvalues = 0, n_nilvalues_reasons = 0;
-      char **t_nilvalues = NULL, **t_nilvalues_reasons = NULL;
-      if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "nilvalues")) != NULL ) {
-        t_nilvalues = msStringSplit(value, ' ', &n_nilvalues);
-      } else if((value = msOWSLookupMetadata(&(layer->metadata), "CO", "rangeset_nullvalue")) != NULL) {
-        t_nilvalues = msStringSplit(value, ' ', &n_nilvalues);
-      }
-
-      if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "nilvalues_reasons")) != NULL ) {
-        t_nilvalues_reasons = msStringSplit(value, ' ', &n_nilvalues_reasons);
-      }
-
-      if(n_nilvalues > 0) {
-        int i;
-        cm->numnilvalues = n_nilvalues;
-        cm->nilvalues = static_cast<char**>(msSmallCalloc(sizeof(char*), n_nilvalues));
-        cm->nilvalues_reasons = static_cast<char**>(msSmallCalloc(sizeof(char*), n_nilvalues));
-        for(i = 0; i < n_nilvalues; ++i) {
-          cm->nilvalues[i] = msStrdup(t_nilvalues[i]);
-          if(i < n_nilvalues_reasons) {
-            cm->nilvalues_reasons[i] = msStrdup(t_nilvalues_reasons[i]);
-          } else {
-            cm->nilvalues_reasons[i] = msStrdup("");
-          }
-        }
-      }
-      msFreeCharArray(t_nilvalues, n_nilvalues);
-      msFreeCharArray(t_nilvalues_reasons, n_nilvalues_reasons);
-    }
-
-    {
-      int num_band_names = 0, j;
-      char **band_names = NULL;
-
-      const char *wcs11_band_names_key = "rangeset_axes";
-      const char *wcs20_band_names_key = "band_names";
-
-      const char *wcs11_interval_key = "interval";
-      const char *wcs20_interval_key = "interval";
-      const char *interval_key = NULL;
-
-      const char *significant_figures_key = "significant_figures";
-
-      const char *wcs11_keys[] =
-      { "label", "semantic", "values_type", "values_semantic", "description" };
-      const char *wcs20_keys[] =
-      { "band_name", "band_interpretation", "band_uom", "band_definition", "band_description" };
-      const char **keys = NULL;
-
-      char **interval_array;
-      int num_interval;
-
-      wcs20rasterbandMetadataObj default_values;
-
-      /* Decide whether WCS1.1 or WCS2.0 keys should be used */
-      if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", wcs20_band_names_key) ) != NULL ) {
-        keys = wcs20_keys;
-        interval_key = wcs20_interval_key;
-        band_names = msStringSplit(value, ' ', &num_band_names);
-      } else if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", wcs11_band_names_key)) != NULL ) {
-        keys = wcs11_keys;
-        interval_key = wcs11_interval_key;
-        /* "bands" has a special processing in WCS 1.0. See */
-        /* msWCSSetDefaultBandsRangeSetInfo */
-        if( EQUAL(value, "bands") )
-        {
-            num_band_names = cm->numbands;
-            band_names = (char**) msSmallMalloc( sizeof(char*) * num_band_names );
-            for( int i = 0; i < num_band_names; i++ )
-            {
-                char szName[30];
-                snprintf(szName, sizeof(szName), "Band%d", i+1);
-                band_names[i] = msStrdup(szName);
-            }
-        }
-        else
-        {
-            /* WARNING: in WCS 1.x,, "rangeset_axes" has never been intended */
-            /* to contain the list of band names... This code should probably */
-            /* be removed */
-            band_names = msStringSplit(value, ' ', &num_band_names);
-        }
-      }
-
-      /* return with error when number of bands does not match    */
-      /* the number of names                                      */
-      if (static_cast<size_t>(num_band_names) != cm->numbands && num_band_names != 0) {
-        msFreeCharArray(band_names, num_band_names);
-        msSetError( MS_WCSERR,
-                    "Wrong number of band names given in layer '%s'. "
-                    "Expected %d, got %d.", "msWCSGetCoverageMetadata20()",
-                    layer->name, (int)cm->numbands, num_band_names );
-        return MS_FAILURE;
-      }
-
-      /* look up default metadata values */
-      for(j = 1; j < 5; ++j) {
-        if(keys != NULL) {
-          default_values.values[j] = (char *)msOWSLookupMetadata(&(layer->metadata), "CO", keys[j]);
-        }
-      }
-
-      /* set default values for interval and significant figures */
-      switch(cm->imagemode) {
-        case MS_IMAGEMODE_BYTE:
-          default_values.interval_min = 0.;
-          default_values.interval_max = 255.;
-          default_values.significant_figures = 3;
-          break;
-        case MS_IMAGEMODE_INT16:
-          default_values.interval_min = 0.;
-          default_values.interval_max = (double)USHRT_MAX;
-          default_values.significant_figures = 5;
-          break;
-        case MS_IMAGEMODE_FLOAT32:
-          default_values.interval_min = -FLT_MAX;
-          default_values.interval_max = FLT_MAX;
-          default_values.significant_figures = 12;
-          break;
-        default:
-          // other imagemodes are invalid (see above), just keep the compiler happy
-          msFreeCharArray(band_names, num_band_names);
-          return MS_FAILURE;
-          break;
-      }
-
-      /* lookup default interval values */
-      if (interval_key != NULL
-          && (value = msOWSLookupMetadata(&(layer->metadata), "CO", interval_key)) != NULL) {
-        interval_array = msStringSplit(value, ' ', &num_interval);
-
-        if (num_interval != 2
-            || msStringParseDouble(interval_array[0], &(default_values.interval_min)) != MS_SUCCESS
-            || msStringParseDouble(interval_array[1], &(default_values.interval_max)) != MS_SUCCESS) {
-          msFreeCharArray(band_names, num_band_names);
-          msFreeCharArray(interval_array, num_interval);
-          msSetError(MS_WCSERR, "Wrong interval format for default axis.",
-                     "msWCSGetCoverageMetadata20()");
-          return MS_FAILURE;
-        }
-        msFreeCharArray(interval_array, num_interval);
-      }
-
-      /* lookup default value for significant figures */
-      if((value = msOWSLookupMetadata(&(layer->metadata), "CO", significant_figures_key)) != NULL) {
-        if(msStringParseInteger(value, &(default_values.significant_figures)) != MS_SUCCESS) {
-          msFreeCharArray(band_names, num_band_names);
-          msSetError(MS_WCSERR, "Wrong significant figures format "
-                     "for default axis.",
-                     "msWCSGetCoverageMetadata20()");
-          return MS_FAILURE;
-        }
-      }
-
-      /* iterate over every band */
-      for(unsigned i = 0; i < cm->numbands; ++i) {
-        cm->bands[i].name = NULL;
-
-        /* look up band metadata or copy defaults */
-        if(num_band_names != 0) {
-          cm->bands[i].name = msStrdup(band_names[i]);
-          for(j = 1; j < 5; ++j) {
-            value = (char *)msWCSLookupRangesetAxisMetadata20(&(layer->metadata),
-                    cm->bands[i].name, keys[j]);
-            if(value != NULL) {
-              cm->bands[i].values[j] = msStrdup(value);
-            } else if(default_values.values[j] != NULL) {
-              cm->bands[i].values[j] = msStrdup(default_values.values[j]);
-            }
-          }
-        }
-
-        /* set up interval */
-        value = (char *)msWCSLookupRangesetAxisMetadata20(&(layer->metadata),
-                cm->bands[i].name, interval_key);
-        if(value != NULL) {
-          num_interval = 0;
-          interval_array = msStringSplit(value, ' ', &num_interval);
-
-          if (num_interval != 2
-              || msStringParseDouble(interval_array[0], &(cm->bands[i].interval_min)) != MS_SUCCESS
-              || msStringParseDouble(interval_array[1], &(cm->bands[i].interval_max)) != MS_SUCCESS) {
-            msFreeCharArray(band_names, num_band_names);
-            msFreeCharArray(interval_array, num_interval);
-            msSetError(MS_WCSERR, "Wrong interval format for axis %s.",
-                       "msWCSGetCoverageMetadata20()", cm->bands[i].name);
-            return MS_FAILURE;
-          }
-
-          msFreeCharArray(interval_array, num_interval);
-        } else {
-          cm->bands[i].interval_min = default_values.interval_min;
-          cm->bands[i].interval_max = default_values.interval_max;
-        }
-
-        /* set up significant figures */
-        value = (char *)msWCSLookupRangesetAxisMetadata20(&(layer->metadata),
-                cm->bands[i].name, significant_figures_key);
-        if(value != NULL) {
-          if(msStringParseInteger(value, &(cm->bands[i].significant_figures)) != MS_SUCCESS) {
-            msFreeCharArray(band_names, num_band_names);
-            msSetError(MS_WCSERR, "Wrong significant figures format "
-                       "for axis %s.",
-                       "msWCSGetCoverageMetadata20()", cm->bands[i].name);
-            return MS_FAILURE;
-          }
-        } else {
-          cm->bands[i].significant_figures = default_values.significant_figures;
-        }
-      }
-
-      msFreeCharArray(band_names, num_band_names);
-    }
-  } else if( layer->data == NULL ) {
-    /* no virtual metadata, not ok unless we're talking 1 image, hopefully we can fix that */
-    msSetError( MS_WCSERR, "RASTER Layer with no DATA statement and no WCS virtual dataset metadata.  Tileindexed raster layers not supported for WCS without virtual dataset metadata (cm->extent, wcs_res, wcs_size).", "msWCSGetCoverageMetadata20()" );
-    return MS_FAILURE;
-  } else {
-    /* work from the file (e.g. DATA) */
-    GDALDatasetH hDS;
-    GDALDriverH hDriver;
-    GDALRasterBandH hBand;
-    char szPath[MS_MAXPATHLEN];
-    const char *driver_short_name, *driver_long_name;
-
-    msGDALInitialize();
-
-    msTryBuildPath3(szPath,  layer->map->mappath, layer->map->shapepath, layer->data);
-    msAcquireLock( TLOCK_GDAL );
-    {
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        hDS = GDALOpenEx( szPath, GDAL_OF_RASTER, NULL,
-                          (const char* const*)connectionoptions, NULL);
-        CSLDestroy(connectionoptions);
-    }
-    if( hDS == NULL ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_IOERR, "%s", "msWCSGetCoverageMetadata20()", CPLGetLastErrorMsg() );
-      return MS_FAILURE;
-    }
-
-    msGetGDALGeoTransform( hDS, layer->map, layer, cm->geotransform );
-
-    cm->xsize = GDALGetRasterXSize( hDS );
-    cm->ysize = GDALGetRasterYSize( hDS );
-
-    cm->extent.minx = cm->geotransform[0];
-    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize + cm->geotransform[2] * cm->ysize;
-    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize + cm->geotransform[5] * cm->ysize;
-    cm->extent.maxy = cm->geotransform[3];
-
-    cm->xresolution = cm->geotransform[1];
-    cm->yresolution = cm->geotransform[5];
-
-    cm->numbands = GDALGetRasterCount( hDS );
-
-    /* TODO nilvalues? */
-
-    if( cm->numbands == 0 ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_WCSERR, "Raster file %s has no raster bands.  This cannot be used in a layer.", "msWCSGetCoverageMetadata20()", layer->data );
-      return MS_FAILURE;
-    }
-
-    hBand = GDALGetRasterBand( hDS, 1 );
-    switch( GDALGetRasterDataType( hBand ) ) {
-      case GDT_Byte:
-        cm->imagemode = MS_IMAGEMODE_BYTE;
-        break;
-      case GDT_Int16:
-        cm->imagemode = MS_IMAGEMODE_INT16;
-        break;
-      default:
-        cm->imagemode = MS_IMAGEMODE_FLOAT32;
-        break;
-    }
-
-    cm->bands = static_cast<wcs20rasterbandMetadataObj*>(msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
-
-    /* get as much band metadata as possible */
-    for(unsigned i = 0; i < cm->numbands; ++i) {
-      char bandname[32];
-      GDALColorInterp colorInterp;
-      hBand = GDALGetRasterBand(hDS, i + 1);
-      snprintf(bandname, sizeof(bandname), "band%d", i+1);
-      cm->bands[i].name = msStrdup(bandname);
-      colorInterp = GDALGetRasterColorInterpretation(hBand);
-      cm->bands[i].interpretation = msStrdup(GDALGetColorInterpretationName(colorInterp));
-      cm->bands[i].uom = msStrdup(GDALGetRasterUnitType(hBand));
-      if(strlen(cm->bands[i].uom) == 0) {
-        msFree(cm->bands[i].uom);
-        cm->bands[i].uom = NULL;
-      }
-
-      /* set up interval and significant figures */
-      switch(cm->imagemode) {
-        case MS_IMAGEMODE_BYTE:
-        case MS_IMAGEMODE_PC256:
-          cm->bands[i].interval_min = 0.;
-          cm->bands[i].interval_max = 255.;
-          cm->bands[i].significant_figures = 3;
-          break;
-        case MS_IMAGEMODE_INT16:
-          cm->bands[i].interval_min = 0.;
-          cm->bands[i].interval_max = (double)USHRT_MAX;
-          cm->bands[i].significant_figures = 5;
-          break;
-        case MS_IMAGEMODE_FLOAT32:
-          cm->bands[i].interval_min = -FLT_MAX;
-          cm->bands[i].interval_max = FLT_MAX;
-          cm->bands[i].significant_figures = 12;
-          break;
-      }
-    }
-
-    hDriver = GDALGetDatasetDriver(hDS);
-    driver_short_name = GDALGetDriverShortName(hDriver);
-    driver_long_name = GDALGetDriverLongName(hDriver);
-    /* TODO: improve this, exchange strstr() */
-    for(int i = 0; i < layer->map->numoutputformats; ++i) {
-      if(strstr( layer->map->outputformatlist[i]->driver, driver_short_name) != NULL
-          || strstr(layer->map->outputformatlist[i]->driver, driver_long_name) != NULL) {
-        cm->native_format = msStrdup(layer->map->outputformatlist[i]->mimetype);
-        break;
-      }
-    }
-
-    GDALClose( hDS );
-    msReleaseLock( TLOCK_GDAL );
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSClearCoverageMetadata20()                     */
-/*                                                                      */
-/*      Returns all dynamically allocated memory from a coverage meta-  */
-/*      data object.                                                    */
-/************************************************************************/
-
-static int msWCSClearCoverageMetadata20(wcs20coverageMetadataObj *cm)
-{
-  msFree(cm->native_format);
-  for(unsigned i = 0; i < cm->numnilvalues; ++i) {
-    msFree(cm->nilvalues[i]);
-    msFree(cm->nilvalues_reasons[i]);
-  }
-  msFree(cm->nilvalues);
-  msFree(cm->nilvalues_reasons);
-
-  for(unsigned i = 0; i < cm->numbands; ++i) {
-    for(int j = 0; j < 5; ++j) {
-      msFree(cm->bands[i].values[j]);
-    }
-  }
-  msFree(cm->bands);
-  msFree(cm->srs_epsg);
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSException20()                                 */
-/*                                                                      */
-/*      Writes out an OWS compliant exception.                          */
-/************************************************************************/
-
-int msWCSException20(mapObj *map, const char *exceptionCode,
-                     const char *locator, const char *version)
-{
-  int size = 0;
-  const char *status = "400 Bad Request";
-  char *errorString = NULL;
-  char *schemasLocation = NULL;
-  char *xsi_schemaLocation = NULL;
-  char version_string[OWS_VERSION_MAXLEN];
-
-  xmlDocPtr psDoc = NULL;
-  xmlNodePtr psRootNode = NULL;
-  xmlNodePtr psMainNode = NULL;
-  xmlNsPtr psNsOws = NULL;
-  xmlNsPtr psNsXsi = NULL;
-  xmlChar *buffer = NULL;
-
-  errorString = msGetErrorString("\n");
-  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "ExceptionReport");
-  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_20_NAMESPACE_URI,
-                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  xmlSetNs(psRootNode, psNsOws);
-
-  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-
-  /* add attributes to root element */
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST version);
-  xmlNewProp(psRootNode, BAD_CAST "xml:lang", BAD_CAST msOWSGetLanguage(map, "exception"));
-
-  /* get 2 digits version string: '2.0' */
-  msOWSGetVersionString(OWS_2_0_0, version_string);
-  version_string[3]= '\0';
-
-  xsi_schemaLocation = msStrdup((char *)psNsOws->href);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)schemasLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, version_string);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
-
-  /* add namespace'd attributes to root element */
-  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation", BAD_CAST xsi_schemaLocation);
-
-  /* add child element */
-  psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Exception", NULL);
-
-  /* add attributes to child */
-  xmlNewProp(psMainNode, BAD_CAST "exceptionCode", BAD_CAST exceptionCode);
-
-  if (locator != NULL) {
-    xmlNewProp(psMainNode, BAD_CAST "locator", BAD_CAST locator);
-  }
-
-  if (errorString != NULL) {
-    char* errorMessage = msEncodeHTMLEntities(errorString);
-    xmlNewChild(psMainNode, NULL, BAD_CAST "ExceptionText", BAD_CAST errorMessage);
-    msFree(errorMessage);
-  }
-
-  /*psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_2_0_0,
-          schemasLocation, version, msOWSGetLanguage(map, "exception"),
-          exceptionCode, locator, errorMessage);*/
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  if (exceptionCode == NULL) {
-    /* Do nothing */
-  }
-  else if(EQUAL(exceptionCode, "OperationNotSupported")
-     || EQUAL(exceptionCode, "OptionNotSupported")) {
-    status = "501 Not Implemented";
-  }
-  else if (EQUAL(exceptionCode, "NoSuchCoverage")
-           || EQUAL(exceptionCode, "emptyCoverageIdList")
-           || EQUAL(exceptionCode, "InvalidAxisLabel")
-           || EQUAL(exceptionCode, "InvalidSubsetting")) {
-    status = "404 Not Found";
-  }
-
-  msIO_setHeader("Status", "%s", status);
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
-
-  msIO_printf("%s", buffer);
-
-  /* free buffer and the document */
-  free(errorString);
-  free(schemasLocation);
-  free(xsi_schemaLocation);
-  xmlFree(buffer);
-  xmlFreeDoc(psDoc);
-
-  /* clear error since we have already reported it */
-  msResetErrorList();
-  return MS_FAILURE;
-}
-
-#define MAX_MIMES 20
-
-static int msWCSGetCapabilities20_CreateProfiles(
-  mapObj *map, xmlNodePtr psServiceIdentification, xmlNsPtr psOwsNs)
-{
-  xmlNodePtr psProfile, psTmpNode;
-  char *available_mime_types[MAX_MIMES];
-  int i = 0;
-
-  /* even indices are urls, uneven are mime-types, or null*/
-  const char * const urls_and_mime_types[] = {
-    MS_WCS_20_PROFILE_CORE,     NULL,
-    MS_WCS_20_PROFILE_KVP,      NULL,
-    MS_WCS_20_PROFILE_POST,     NULL,
-    MS_WCS_20_PROFILE_GML,      NULL,
-    MS_WCS_20_PROFILE_GML_MULTIPART, NULL,
-    MS_WCS_20_PROFILE_GML_SPECIAL, NULL,
-    MS_WCS_20_PROFILE_GML_GEOTIFF, "image/tiff",
-    MS_WCS_20_PROFILE_CRS,     NULL,
-    MS_WCS_20_PROFILE_SCALING, NULL,
-    MS_WCS_20_PROFILE_RANGESUBSET, NULL,
-    MS_WCS_20_PROFILE_INTERPOLATION, NULL,
-    NULL, NULL /* guardian */
-  };
-
-  /* navigate to node where profiles shall be inserted */
-  for(psTmpNode = psServiceIdentification->children; psTmpNode->next != NULL; psTmpNode = psTmpNode->next) {
-    if(EQUAL((char *)psTmpNode->name, "ServiceTypeVersion") && !EQUAL((char *)psTmpNode->next->name, "ServiceTypeVersion"))
-      break;
-  }
-
-  /* get list of all available mime types */
-  msGetOutputFormatMimeList(map, available_mime_types, MAX_MIMES);
-
-  while(urls_and_mime_types[i] != NULL) {
-    const char* mime_type = urls_and_mime_types[i+1];
-
-    /* check if there is a mime type */
-    if(mime_type != NULL) {
-      /* check if the mime_type is in the list of outputformats */
-      if(CSLPartialFindString(available_mime_types, mime_type) == -1)
-        continue;
-    }
-
-    /* create a new node and attach it in the tree */
-    psProfile = xmlNewNode(psOwsNs, BAD_CAST "Profile");
-    xmlNodeSetContent(psProfile, BAD_CAST urls_and_mime_types[i]);
-    xmlAddNextSibling(psTmpNode, psProfile);
-
-    psTmpNode = psProfile;
-    i += 2;
-  }
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSGetCapabilities20_CoverageSummary()           */
-/*                                                                      */
-/*      Helper function to create a short summary for a specific        */
-/*      coverage.                                                       */
-/************************************************************************/
-
-static int msWCSGetCapabilities20_CoverageSummary(
-  xmlDocPtr doc, xmlNodePtr psContents, layerObj *layer )
-{
-  wcs20coverageMetadataObj cm;
-  int status;
-  xmlNodePtr psCSummary;
-
-  xmlNsPtr psWcsNs = xmlSearchNs( doc, xmlDocGetRootElement(doc), BAD_CAST "wcs" );
-
-  status = msWCSGetCoverageMetadata20(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
-
-  psCSummary = xmlNewChild( psContents, psWcsNs, BAD_CAST "CoverageSummary", NULL );
-  xmlNewChild(psCSummary, psWcsNs, BAD_CAST "CoverageId", BAD_CAST layer->name);
-  xmlNewChild(psCSummary, psWcsNs, BAD_CAST "CoverageSubtype", BAD_CAST "RectifiedGridCoverage");
-
-  msWCS_11_20_PrintMetadataLinks(layer, doc, psCSummary);
-
-  msWCSClearCoverageMetadata20(&cm);
-
-  return MS_SUCCESS;
-}
-
-
-/************************************************************************/
-/*                          msWCSAddInspireDSID20                       */
-/************************************************************************/
-
-static void msWCSAddInspireDSID20(mapObj *map,
-                                  xmlNsPtr psNsInspireDls,
-                                  xmlNsPtr psNsInspireCommon,
-                                  xmlNodePtr pDlsExtendedCapabilities)
-{
-    const char* dsid_code = msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_code");
-    const char* dsid_ns = msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_ns");
-    if( dsid_code == NULL )
-    {
-        xmlAddChild(pDlsExtendedCapabilities, xmlNewComment(BAD_CAST "WARNING: Required metadata \"inspire_dsid_code\" missing"));
-    }
-    else
-    {
-        int ntokensCode = 0, ntokensNS = 0;
-        char** tokensCode;
-        char** tokensNS = NULL;
-        int i;
-
-        tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
-        if( dsid_ns != NULL )
-            tokensNS = msStringSplitComplex( dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
-        if( ntokensNS > 0 && ntokensNS != ntokensCode )
-        {
-            xmlAddChild(pDlsExtendedCapabilities,
-                        xmlNewComment(BAD_CAST "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not the same number of elements. Ignoring inspire_dsid_ns"));
-            msFreeCharArray(tokensNS, ntokensNS);
-            tokensNS = NULL;
-            ntokensNS = 0;
-        }
-        for(i = 0; i<ntokensCode; i++ )
-        {
-            xmlNodePtr pSDSI = xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
-            xmlAddChild(pDlsExtendedCapabilities, pSDSI);
-            xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code", BAD_CAST tokensCode[i]);
-            if( ntokensNS > 0 && tokensNS[i][0] != '\0' )
-                xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace", BAD_CAST tokensNS[i]);
-        }
-        msFreeCharArray(tokensCode, ntokensCode);
-        msFreeCharArray(tokensNS, ntokensNS);
-    }
-}
-
-
-/************************************************************************/
-/*                   msWCSGetCapabilities20()                           */
-/*                                                                      */
-/*      Performs the GetCapabilities operation. Writes out a xml        */
-/*      structure with server specific information and a summary        */
-/*      of all available coverages.                                     */
-/************************************************************************/
-
-int msWCSGetCapabilities20(mapObj *map, cgiRequestObj *req,
-                           wcs20ParamsObjPtr params, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
-  xmlNodePtr psRootNode,
-             psOperationsNode,
-             psNode;
-  const char *updatesequence = NULL;
-  xmlNsPtr psOwsNs = NULL,
-           psXLinkNs = NULL,
-           psWcsNs = NULL,
-           psCrsNs = NULL,
-           psIntNs = NULL;
-  char *script_url=NULL, *script_url_encoded=NULL, *format_list=NULL;
-  int i;
-  xmlDocPtr pInspireTmpDoc = NULL;
-
-  const char *inspire_capabilities = msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_capabilities");
-
-  char *validated_language = msOWSLanguageNegotiation(map, "CO", params->accept_languages, CSLCount(params->accept_languages));
-
-  /* -------------------------------------------------------------------- */
-  /*      Create document.                                                */
-  /* -------------------------------------------------------------------- */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "Capabilities");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* -------------------------------------------------------------------- */
-  /*      Name spaces                                                     */
-  /* -------------------------------------------------------------------- */
-
-  msWCSPrepareNamespaces20(psDoc, psRootNode, map, inspire_capabilities != NULL);
-
-  /* lookup namespaces */
-  psOwsNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX );
-  psWcsNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX );
-  xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX );
-  psXLinkNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST "xlink" );
-  psCrsNs = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/crs/1.0", BAD_CAST "crs");
-  psIntNs = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/interpolation/1.0", BAD_CAST "int");
-
-  xmlSetNs(psRootNode, psWcsNs);
-
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version );
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
-  if (params->updatesequence != NULL) {
-    i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
-    if (i == 0) { /* current */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
-                 "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
-      xmlFreeDoc(psDoc);
-      return msWCSException(map, "CurrentUpdateSequence", "updatesequence",
-                            params->version);
-    }
-    if (i > 0) { /* invalid */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
-                 "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
-      xmlFreeDoc(psDoc);
-      return msWCSException(map, "InvalidUpdateSequence", "updatesequence",
-                            params->version);
-    }
-  }
-  if(updatesequence != NULL) {
-    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Service identification.                                         */
-  /* -------------------------------------------------------------------- */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceIdentification") ) {
-    psNode = xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
-                           psOwsNs, map, "OGC WCS", "2.0.1,1.1.1,1.0.0", "CO", validated_language));
-    msWCSGetCapabilities20_CreateProfiles(map, psNode, psOwsNs);
-  }
-
-  /* Service Provider */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceProvider") ) {
-    xmlAddChild(psRootNode,
-                msOWSCommonServiceProvider(psOwsNs, psXLinkNs, map, "CO", validated_language));
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Operations metadata.                                            */
-  /* -------------------------------------------------------------------- */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "OperationsMetadata") ) {
-    if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource", req)) == NULL
-        || (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
-      xmlFreeDoc(psDoc);
-      msSetError(MS_WCSERR, "Server URL not found", "msWCSGetCapabilities20()");
-      return msWCSException(map, "NoApplicableCode", "mapserv", params->version);
-    }
-    free(script_url);
-
-    psOperationsNode = xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psOwsNs));
-
-    /* -------------------------------------------------------------------- */
-    /*      GetCapabilities - add Sections and AcceptVersions?              */
-    /* -------------------------------------------------------------------- */
-    psNode = msOWSCommonOperationsMetadataOperation(
-               psOwsNs, psXLinkNs,
-               "GetCapabilities", OWS_METHOD_GETPOST, script_url_encoded);
-
-    xmlAddChild(psNode->last->last->last,
-                msOWSCommonOperationsMetadataDomainType(OWS_2_0_0, psOwsNs, "Constraint",
-                    "PostEncoding", "XML"));
-    xmlAddChild(psOperationsNode, psNode);
-
-    /* -------------------------------------------------------------------- */
-    /*      DescribeCoverage                                                */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE)) {
-      psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "DescribeCoverage", OWS_METHOD_GETPOST, script_url_encoded);
-      xmlAddChild(psNode->last->last->last,
-                  msOWSCommonOperationsMetadataDomainType(OWS_2_0_0, psOwsNs, "Constraint",
-                      "PostEncoding", "XML"));
-      xmlAddChild(psOperationsNode, psNode);
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      GetCoverage                                                     */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE)) {
-      psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "GetCoverage", OWS_METHOD_GETPOST, script_url_encoded);
-
-      xmlAddChild(psNode->last->last->last,
-                  msOWSCommonOperationsMetadataDomainType(OWS_2_0_0, psOwsNs, "Constraint",
-                      "PostEncoding", "XML"));
-      xmlAddChild(psOperationsNode, psNode);
-    }
-    msFree(script_url_encoded);
-
-
-    /* -------------------------------------------------------------------- */
-    /*      Extended Capabilities for inspire                               */
-    /* -------------------------------------------------------------------- */
-
-    if (inspire_capabilities) {
-      msIOContext* old_context;
-      msIOContext* new_context;
-      msIOBuffer* buffer;
-
-      xmlNodePtr pRoot;
-      xmlNodePtr pOWSExtendedCapabilities;
-      xmlNodePtr pDlsExtendedCapabilities;
-      xmlNodePtr pChild;
-
-      xmlNsPtr psInspireCommonNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX );
-      xmlNsPtr psInspireDlsNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX );
-
-
-      old_context = msIO_pushStdoutToBufferAndGetOldContext();
-      msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "CO", OWS_WARN,
-                                                  "foo",
-                                                  "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
-                                                  "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
-                                                  "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"", validated_language, OWS_WCS);
-
-      new_context = msIO_getHandler(stdout);
-      buffer = (msIOBuffer *) new_context->cbData;
-
-      /* Remove spaces between > and < to get properly indented result */
-      msXMLStripIndentation( (char*) buffer->data );
-
-      pInspireTmpDoc = xmlParseDoc((const xmlChar *)buffer->data);
-      pRoot = xmlDocGetRootElement(pInspireTmpDoc);
-      xmlReconciliateNs(psDoc, pRoot);
-
-      pOWSExtendedCapabilities = xmlNewNode(psOwsNs, BAD_CAST "ExtendedCapabilities");
-      xmlAddChild(psOperationsNode, pOWSExtendedCapabilities);
-
-      pDlsExtendedCapabilities = xmlNewNode(psInspireDlsNs, BAD_CAST "ExtendedCapabilities");
-      xmlAddChild(pOWSExtendedCapabilities, pDlsExtendedCapabilities);
-
-      pChild = pRoot->children;
-      while(pChild != NULL)
-      {
-          xmlNodePtr pNext = pChild->next;
-          xmlUnlinkNode(pChild);
-          xmlAddChild(pDlsExtendedCapabilities, pChild);
-          pChild = pNext;
-      }
-
-      msWCSAddInspireDSID20(map, psInspireDlsNs, psInspireCommonNs, pDlsExtendedCapabilities);
-
-      msIO_restoreOldStdoutContext(old_context);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Service metadata.                                               */
-  /* -------------------------------------------------------------------- */
-
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceMetadata") ) {
-    xmlNodePtr psExtensionNode = NULL;
-    psNode = xmlNewChild(psRootNode, psWcsNs, BAD_CAST "ServiceMetadata", NULL);
-
-    /* Apply default formats */
-    msApplyDefaultOutputFormats(map);
-
-    /* Add formats list */
-    format_list = msWCSGetFormatsList20(map, NULL);
-    msLibXml2GenerateList(psNode, psWcsNs, "formatSupported", format_list, ',');
-    msFree(format_list);
-
-    psExtensionNode = xmlNewChild(psNode, psWcsNs, BAD_CAST "Extension", NULL);
-    /* interpolations supported */
-    {
-      /* TODO: use URIs/URLs once they are specified */
-      const char * const interpolation_methods[] = {"NEAREST", "AVERAGE", "BILINEAR"};
-      int i;
-      xmlNodePtr imNode = xmlNewChild(psExtensionNode, psIntNs,
-                                      BAD_CAST "InterpolationMetadata", NULL);
-
-      for (i=0; i < 3; ++i) {
-        xmlNewChild(imNode, psIntNs, BAD_CAST "InterpolationSupported",
-                    BAD_CAST interpolation_methods[i]);
-      }
-    }
-
-    /* Report the supported CRSs */
-    {
-      char *crs_list = NULL;
-      xmlNodePtr crsMetadataNode = xmlNewChild(psExtensionNode, psCrsNs,
-                                               BAD_CAST "CrsMetadata", NULL);
-
-      if((crs_list = msOWSGetProjURI(&(map->projection),
-                                        &(map->web.metadata),
-                                        "CO", MS_FALSE)) != NULL ) {
-        msLibXml2GenerateList(crsMetadataNode, psCrsNs, "crsSupported",
-                              crs_list, ' ');
-        msFree(crs_list);
-      } else {
-        /* could not determine list of CRSs */
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Contents section.                                               */
-  /* -------------------------------------------------------------------- */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "Contents") ) {
-    psNode = xmlNewChild( psRootNode, psWcsNs, BAD_CAST "Contents", NULL );
-
-    if(ows_request->numlayers == 0) {
-      xmlAddChild(psNode,
-                  xmlNewComment(BAD_CAST("WARNING: No WCS layers are enabled. "
-                                         "Check wcs/ows_enable_request settings.")));
-    } else {
-      for(i = 0; i < map->numlayers; ++i) {
-        layerObj *layer = map->layers[i];
-        int       status;
-
-        if(!msWCSIsLayerSupported(layer))
-          continue;
-
-        if (!msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers))
-          continue;
-
-        status = msWCSGetCapabilities20_CoverageSummary(
-                   psDoc, psNode, layer );
-        if(status != MS_SUCCESS) {
-          msFree(validated_language);
-          xmlFreeDoc(psDoc);
-          xmlCleanupParser();
-          return msWCSException(map, "Internal", "mapserv", params->version);
-        }
-      }
-    }
-  }
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document and clean up.                            */
-  /* -------------------------------------------------------------------- */
-  msWCSWriteDocument20(psDoc);
-  msFree(validated_language);
-  xmlFreeDoc(psDoc);
-  if( pInspireTmpDoc )
-    xmlFreeDoc(pInspireTmpDoc);
-  xmlCleanupParser();
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSDescribeCoverage20_CoverageDescription()      */
-/*                                                                      */
-/*      Creates a description of a specific coverage with the three     */
-/*      major sections: BoundedBy, DomainSet and RangeType.             */
-/************************************************************************/
-
-static int msWCSDescribeCoverage20_CoverageDescription(
-    layerObj *layer, xmlDocPtr psDoc, xmlNodePtr psRootNode )
-{
-  int status, swapAxes;
-  wcs20coverageMetadataObj cm;
-  xmlNodePtr psCD;
-  xmlNsPtr psWcsNs, psGmlNs, psGmlcovNs, psSweNs, psXLinkNs;
-  psWcsNs = psGmlNs = psGmlcovNs = psSweNs = psXLinkNs = NULL;
-
-  psWcsNs    = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
-  psGmlNs    = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
-  psGmlcovNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
-  psSweNs    = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
-  psXLinkNs  = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-
-  /* -------------------------------------------------------------------- */
-  /*      Verify layer is processable.                                    */
-  /* -------------------------------------------------------------------- */
-  if( msCheckParentPointer(layer->map,"map") == MS_FAILURE )
-    return MS_FAILURE;
-
-  if(!msWCSIsLayerSupported(layer))
-    return MS_SUCCESS;
-
-  /* -------------------------------------------------------------------- */
-  /*      Setup coverage metadata.                                        */
-  /* -------------------------------------------------------------------- */
-  status = msWCSGetCoverageMetadata20(layer, &cm);
-  if(status != MS_SUCCESS)
-    return status;
-
-  swapAxes = msWCSSwapAxes20(cm.srs_uri);
-
-  /* fill in bands rangeset info, if required. */
-  /* msWCSSetDefaultBandsRangeSetInfo( NULL, &cm, layer ); */
-
-  /* -------------------------------------------------------------------- */
-  /*      Create CoverageDescription node.                                */
-  /* -------------------------------------------------------------------- */
-  psCD = xmlNewChild( psRootNode, psWcsNs, BAD_CAST "CoverageDescription", NULL );
-  xmlNewNsProp(psCD, psGmlNs, BAD_CAST "id", BAD_CAST layer->name);
-
-  /* -------------------------------------------------------------------- */
-  /*      gml:boundedBy                                                   */
-  /* -------------------------------------------------------------------- */
-  msWCSCommon20_CreateBoundedBy(&cm, psGmlNs, psCD, &(layer->projection), swapAxes);
-
-  xmlNewChild(psCD, psWcsNs, BAD_CAST "CoverageId", BAD_CAST layer->name);
-
-  /* -------------------------------------------------------------------- */
-  /*      gml:domainSet                                                   */
-  /* -------------------------------------------------------------------- */
-  msWCSCommon20_CreateDomainSet(layer, &cm, psGmlNs, psCD, &(layer->projection), swapAxes);
-
-  /* -------------------------------------------------------------------- */
-  /*      gmlcov:rangeType                                                */
-  /* -------------------------------------------------------------------- */
-  msWCSCommon20_CreateRangeType(&cm, NULL, psGmlcovNs, psSweNs, psCD);
-
-  /* -------------------------------------------------------------------- */
-  /*      wcs:ServiceParameters                                           */
-  /* -------------------------------------------------------------------- */
-  {
-    xmlNodePtr psSP;
-
-    psSP = xmlNewChild( psCD, psWcsNs, BAD_CAST "ServiceParameters", NULL);
-    xmlNewChild(psSP, psWcsNs, BAD_CAST "CoverageSubtype", BAD_CAST "RectifiedGridCoverage");
-
-    /* -------------------------------------------------------------------- */
-    /*      SupportedCRS                                                    */
-    /* -------------------------------------------------------------------- */
-    /* for now, WCS 2.0 does not allow per coverage CRS definitions */
-    /*{
-      xmlNodePtr psSupportedCrss;
-      char *owned_value;
-
-      psSupportedCrss = xmlNewChild(psSP, psWcsNs,
-                                    BAD_CAST "SupportedCRSs", NULL);
-
-      if ((owned_value = msOWSGetProjURI(&(layer->projection),
-                                         &(layer->metadata), "CO", MS_FALSE)) != NULL)
-      { }
-      else if ((owned_value = msOWSGetProjURI(&(layer->map->projection),
-                                              &(layer->map->web.metadata), "CO", MS_FALSE)) != NULL)
-      { }
-      else {
-        msDebug("missing required information, no SRSs defined.\n");
-      }
-
-      if (owned_value != NULL && strlen(owned_value) > 0) {
-        msLibXml2GenerateList(psSupportedCrss, psWcsNs,
-                              "SupportedCRS", owned_value, ' ');
-      }
-
-      xmlNewChild(psSupportedCrss, psWcsNs,
-                  BAD_CAST "NativeCRS", BAD_CAST cm.srs_uri);
-
-      msFree(owned_value);
-    }*/
-
-    /* -------------------------------------------------------------------- */
-    /*      SupportedFormats                                                */
-    /* -------------------------------------------------------------------- */
-    /* for now, WCS 2.0 does not allow per coverage format definitions */
-    /*{
-      xmlNodePtr psSupportedFormats;
-      char *format_list;
-
-      psSupportedFormats =
-      xmlNewChild(psSP, psWcsNs, BAD_CAST "SupportedFormats", NULL);
-
-      format_list = msWCSGetFormatsList20(layer->map, layer);
-
-      if (strlen(format_list) > 0) {
-        msLibXml2GenerateList(psSupportedFormats, psWcsNs,
-                              "SupportedFormat", format_list, ',');
-
-      msFree(format_list);
-    }*/
-
-
-    /* -------------------------------------------------------------------- */
-    /*      nativeFormat                                                    */
-    /* -------------------------------------------------------------------- */
-    xmlNewChild(psSP, psWcsNs,
-                BAD_CAST "nativeFormat", BAD_CAST (cm.native_format ?
-                    cm.native_format : ""));
-
-    if (!cm.native_format) {
-      msDebug("msWCSDescribeCoverage20_CoverageDescription(): "
-              "No native format specified.\n");
-    }
-  }
-
-  msWCSClearCoverageMetadata20(&cm);
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSDescribeCoverage20()                          */
-/*                                                                      */
-/*      Implementation of the DescibeCoverage Operation. The result     */
-/*      of this operation is a xml document, containing specific        */
-/*      information about a coverage identified by an ID. The result    */
-/*      is written on the stream.                                       */
-/************************************************************************/
-
-int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL; /* document pointer */
-  xmlNodePtr psRootNode;
-  xmlNsPtr psWcsNs = NULL;
-  int i, j;
-
-  /* create DOM document and root node */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-  psRootNode = xmlNewNode(NULL, BAD_CAST "CoverageDescriptions");
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* prepare initial namespace definitions */
-  msWCSPrepareNamespaces20(psDoc, psRootNode, map, MS_FALSE);
-
-  psWcsNs = xmlSearchNs(psDoc, psRootNode,
-                        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
-  xmlSetNs(psRootNode, psWcsNs);
-
-  /* check if IDs are given */
-  if (params->ids) {
-    /* for each given ID in the ID-list */
-    for (j = 0; params->ids[j]; j++) {
-      i = msGetLayerIndex(map, params->ids[j]);
-      if (i == -1 || (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-        msSetError(MS_WCSERR, "Unknown coverage: (%s)",
-                   "msWCSDescribeCoverage20()", params->ids[j]);
-        return msWCSException(map, "NoSuchCoverage", "coverage",
-                              params->version);
-      }
-      /* create coverage description for the specified layer */
-      if(msWCSDescribeCoverage20_CoverageDescription((GET_LAYER(map, i)),
-          psDoc, psRootNode) == MS_FAILURE) {
-        msSetError(MS_WCSERR, "Error retrieving coverage description.", "msWCSDescribeCoverage20()");
-        return msWCSException(map, "MissingParameterValue", "coverage",
-                              params->version);
-      }
-    }
-  } else {
-    /* Throw error, since IDs are mandatory */
-    msSetError(MS_WCSERR, "Missing COVERAGEID parameter.", "msWCSDescribeCoverage20()");
-    return msWCSException(map, "MissingParameterValue", "coverage",
-                          params->version);
-  }
-
-  /* write out the DOM document to the stream */
-  msWCSWriteDocument20(psDoc);
-
-  /* cleanup */
-  xmlFreeDoc(psDoc);
-  xmlCleanupParser();
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSGetCoverage_FinalizeParamsObj20()             */
-/*                                                                      */
-/*      Finalizes a wcs20ParamsObj for a GetCoverage operation. In the  */
-/*      process, the params boundig box is adjusted to the subsets,     */
-/*      width, height and resolution are determined and the subset crs  */
-/*      is found out.                                                   */
-/************************************************************************/
-
-static int msWCSGetCoverage20_FinalizeParamsObj(wcs20ParamsObjPtr params, wcs20AxisObjPtr *axes)
-{
-  char *crs = NULL;
-  int have_scale, have_size, have_resolution;
-  int have_global_scale = (params->scale != MS_WCS20_UNBOUNDED) ? 1 : 0;
-
-  if (axes[0] != NULL) {
-    if(axes[0]->subset != NULL) {
-      msDebug("Subset for X-axis found: %s\n", axes[0]->subset->axis);
-      if (!axes[0]->subset->min.unbounded)
-        params->bbox.minx = axes[0]->subset->min.scalar;
-      if (!axes[0]->subset->max.unbounded)
-        params->bbox.maxx = axes[0]->subset->max.scalar;
-      crs = axes[0]->subset->crs;
-    }
-    params->width = axes[0]->size;
-    params->resolutionX = axes[0]->resolution;
-    params->scaleX = axes[0]->scale;
-
-    if(axes[0]->resolutionUOM != NULL) {
-      params->resolutionUnits = msStrdup(axes[0]->resolutionUOM);
-    }
-
-    have_scale = (params->scaleX != MS_WCS20_UNBOUNDED) ? 1 : 0;
-    have_size = (params->width != 0) ? 1 : 0;
-    have_resolution = (params->resolutionX != MS_WCS20_UNBOUNDED) ? 1 : 0;
-
-    if ((have_global_scale + have_scale + have_size + have_resolution) > 1) {
-      msSetError(MS_WCSERR, "Axis '%s' defines scale, size and/or resolution multiple times.",
-                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name);
-      return MS_FAILURE;
-    }
-  }
-
-  if (axes[1] != NULL) {
-    if(axes[1]->subset != NULL) {
-      msDebug("Subset for Y-axis found: %s\n", axes[1]->subset->axis);
-      if (!axes[1]->subset->min.unbounded)
-        params->bbox.miny = axes[1]->subset->min.scalar;
-      if (!axes[1]->subset->max.unbounded)
-        params->bbox.maxy = axes[1]->subset->max.scalar;
-      if(crs != NULL && axes[0] != NULL && axes[0]->subset!= NULL) {
-        if(!EQUAL(crs, axes[1]->subset->crs)) {
-          msSetError(MS_WCSERR, "CRS for axis %s and axis %s are not the same.",
-                     "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name, axes[1]->name);
-          return MS_FAILURE;
-        }
-      } else {
-        crs = axes[1]->subset->crs;
-      }
-    }
-    params->height = axes[1]->size;
-    params->resolutionY = axes[1]->resolution;
-    params->scaleY = axes[1]->scale;
-
-    if(params->resolutionUnits == NULL && axes[1]->resolutionUOM != NULL) {
-      params->resolutionUnits = msStrdup(axes[1]->resolutionUOM);
-    } else if(params->resolutionUnits != NULL && axes[1]->resolutionUOM != NULL
-              && !EQUAL(params->resolutionUnits, axes[1]->resolutionUOM)) {
-      msSetError(MS_WCSERR, "The units of measure of the resolution for"
-                 "axis %s and axis %s are not the same.",
-                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name, axes[1]->name);
-      return MS_FAILURE;
-    }
-
-    have_scale = (params->scaleY != MS_WCS20_UNBOUNDED) ? 1 : 0;
-    have_size = (params->height != 0) ? 1 : 0;
-    have_resolution = (params->resolutionY != MS_WCS20_UNBOUNDED) ? 1 : 0;
-
-    if ((have_global_scale + have_scale + have_size + have_resolution) > 1) {
-      msSetError(MS_WCSERR, "Axis '%s' defines scale, size and/or resolution multiple times.",
-                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[1]->name);
-      return MS_FAILURE;
-    }
-  }
-
-  /* if scale is globally set, use this value instead */
-  if (params->scale != MS_WCS20_UNBOUNDED) {
-    params->scaleX = params->scaleY = params->scale;
-  }
-
-  /* check if projections are equal */
-  if(crs != NULL) {
-    if (params->subsetcrs && !EQUAL(crs, params->subsetcrs)) {
-      /* already set and not equal -> raise exception */
-      msSetError(MS_WCSERR, "SubsetCRS does not match the CRS of the axes: "
-                 "'%s' != '%s'",
-                 "msWCSCreateBoundingBox20()", params->subsetcrs, crs);
-      return MS_FAILURE;
-    }
-    else if (params->subsetcrs) {
-      /* equal, and already set -> do nothing */
-    }
-    else {
-      /* not yet globally set -> set it */
-      params->subsetcrs = msStrdup(crs);
-    }
-  } else if (!params->subsetcrs) {
-    /* default to CRS of image */
-    /* leave params->subsetcrs to null */
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSGetCoverage20_GetBands()                      */
-/*                                                                      */
-/*      Returns a string, containing a comma-separated list of band     */
-/*      indices.                                                        */
-/************************************************************************/
-
-static int msWCSGetCoverage20_GetBands(layerObj *layer,
-                                       wcs20ParamsObjPtr params, wcs20coverageMetadataObjPtr cm, char **bandlist)
-{
-  int maxlen, index;
-  char *interval_stop;
-  char **band_ids = NULL;
-
-  /* if rangesubset parameter is not given, default to all bands */
-  if(NULL == params->range_subset) {
-    *bandlist = msStrdup("1");
-    for(unsigned i = 1; i < cm->numbands; ++i) {
-      char strnumber[12];
-      snprintf(strnumber, sizeof(strnumber), ",%d", i + 1);
-      *bandlist = msStringConcatenate(*bandlist, strnumber);
-    }
-    return MS_SUCCESS;
-  }
-
-  maxlen = cm->numbands * 4 * sizeof(char);
-  *bandlist = static_cast<char*>( msSmallCalloc(sizeof(char), maxlen));
-
-  /* Use WCS 2.0 metadata items in priority */
-  {
-    char* tmp = msOWSGetEncodeMetadata(&layer->metadata,
-                               "CO", "band_names", NULL);
-
-    if( NULL == tmp ) {
-      /* Otherwise default to WCS 1.x*/
-      tmp = msOWSGetEncodeMetadata(&layer->metadata,
-                     "CO", "rangeset_axes", NULL);
-      /* "bands" has a special processing in WCS 1.0. See */
-      /* msWCSSetDefaultBandsRangeSetInfo */
-      if( tmp != NULL && EQUAL(tmp, "bands") )
-      {
-        int num_band_names = cm->numbands;
-        band_ids = (char**) msSmallCalloc( sizeof(char*), (num_band_names + 1) );
-        for( int i = 0; i < num_band_names; i++ )
-        {
-            char szName[30];
-            snprintf(szName, sizeof(szName), "Band%d", i+1);
-            band_ids[i] = msStrdup(szName);
-        }
-      }
-    }
-
-    if(NULL != tmp && band_ids == NULL) {
-      band_ids = CSLTokenizeString2(tmp, " ", 0);
-    }
-    msFree(tmp);
-  }
-
-  /* If we still don't have band names, use the band names from the coverage metadata */
-  if (band_ids == NULL) {
-    band_ids = (char**) CPLCalloc(sizeof(char*), (cm->numbands + 1));
-    for (unsigned i = 0; i < cm->numbands; ++i) {
-      band_ids[i] = CPLStrdup(cm->bands[i].name);
-    }
-  }
-
-  /* Iterate over all supplied range */
-  const int count = CSLCount(params->range_subset);
-  for(int i = 0; i < count; ++i) {
-    /* RangeInterval case: defined as "<start>:<stop>" */
-    if ((interval_stop = strchr(params->range_subset[i], ':')) != NULL) {
-      int start, stop;
-      *interval_stop = '\0';
-      ++interval_stop;
-
-      /* check if the string represents an integer */
-      if (msStringParseInteger(params->range_subset[i], &start) == MS_SUCCESS) {
-      }
-      /* get index of start clause, or raise an error if none was found */
-      else if ((start = CSLFindString(band_ids, params->range_subset[i])) != -1) {
-        start += 1; /* adjust index, since GDAL bands start with index 1 */
-      }
-      else {
-        msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
-               "msWCSGetCoverage20_GetBands()", params->range_subset[i]);
-        return MS_FAILURE;
-      }
-
-      /* check if the string represents an integer */
-      if (msStringParseInteger(interval_stop, &stop) == MS_SUCCESS) {
-      }
-      /* get index of stop clause, or raise an error if none was found */
-      else if ((stop = CSLFindString(band_ids, interval_stop)) != -1) {
-        stop += 1; /* adjust index, since GDAL bands start with index 1 */
-      }
-      else {
-        msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
-               "msWCSGetCoverage20_GetBands()", interval_stop);
-        return MS_FAILURE;
-      }
-
-      /* Check whether or not start and stop are different and stop is higher than start */
-      if (stop <= start) {
-        msSetError(MS_WCSERR, "Invalid range interval given.",
-               "msWCSGetCoverage20_GetBands()");
-        return MS_FAILURE;
-      } else if (start < 1 || static_cast<unsigned>(stop) > cm->numbands) {
-        msSetError(MS_WCSERR, "Band interval is out of the valid range: 1-%d",
-               "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
-        return MS_FAILURE;
-      }
-
-      /* expand the interval to a list of indices and push them on the list */
-      for (int j = start; j <= stop; ++j) {
-        char* tmp;
-        if(i != 0 || j != start) {
-          strlcat(*bandlist, ",", maxlen);
-        }
-        tmp = msIntToString(j);
-        strlcat(*bandlist, tmp, maxlen);
-        msFree(tmp);
-      }
-    }
-    /* RangeComponent case */
-    else {
-        if(i != 0) {
-        strlcat(*bandlist, ",", maxlen);
-      }
-
-      /* check if the string represents an integer */
-      if(msStringParseInteger(params->range_subset[i], &index) == MS_SUCCESS) {
-        char* tmp;
-        if (index < 1 || static_cast<unsigned>(index) > cm->numbands) {
-          msSetError(MS_WCSERR, "Band index is out of the valid range: 1-%d",
-                 "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
-          return MS_FAILURE;
-        }
-
-        tmp = msIntToString((int)index);
-        strlcat(*bandlist, tmp, maxlen);
-        msFree(tmp);
-        continue;
-      }
-
-      /* check if the string is equal to a band identifier    */
-      /* if so, what is the index of the band                 */
-      if((index = CSLFindString(band_ids, params->range_subset[i])) != -1) {
-        char* tmp = msIntToString((int)index + 1);
-        strlcat(*bandlist, tmp, maxlen);
-        msFree(tmp);
-      }
-      else {
-        msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
-                   "msWCSGetCoverage20_GetBands()", params->range_subset[i]);
-        return MS_FAILURE;
-      }
-    }
-  }
-
-  CSLDestroy(band_ids);
-  return MS_SUCCESS;
-}
-
-/* Fixes CPLParseNameValue to allow ':' characters for namespaced keys */
-
-static const char * fixedCPLParseNameValue(const char* string, char **key) {
-  const char *value;
-  size_t size;
-  value = strchr(string, '=');
-
-  if (value == NULL) {
-    *key = NULL;
-    return NULL;
-  }
-
-  size = value - string;
-  *key = static_cast<char*>(msSmallMalloc(size + 1));
-  strncpy(*key, string, size + 1);
-  (*key)[size] = '\0';
-  return value + 1;
-}
-
-/************************************************************************/
-/*                   msWCSSetFormatParams20()                           */
-/*                                                                      */
-/*      Parses the given format options and sets the appropriate        */
-/*      output format values.                                           */
-/************************************************************************/
-
-static int msWCSSetFormatParams20(outputFormatObj* format, char** format_options) {
-  /* currently geotiff only */
-  char *format_option;
-  int i = 0;
-  int is_geotiff = (format->mimetype && EQUAL(format->mimetype, "image/tiff"));
-
-  if (!is_geotiff || !format_options) {
-    /* Currently only geotiff available */
-    return MS_SUCCESS;
-  }
-
-  format_option = format_options[0];
-  while (format_option) {
-    /* key, value */
-    char *key;
-    const char *value = fixedCPLParseNameValue(format_option, &key);
-
-    if (!key) {
-      msSetError(MS_WCSERR, "Could not deduct the option key.",
-                 "msWCSSetFormatParams20()");
-      return MS_FAILURE;
-    }
-    else if (!value) {
-      msSetError(MS_WCSERR, "Missing value for parameter '%s'.",
-                 "msWCSSetFormatParams20()", key);
-      return MS_FAILURE;
-    }
-
-    if (EQUAL(key, "geotiff:compression") && is_geotiff) {
-      /*COMPRESS=[JPEG/LZW/PACKBITS/DEFLATE/CCITTRLE/CCITTFAX3/CCITTFAX4/NONE]*/
-      if (EQUAL(value, "None")) {
-        msSetOutputFormatOption(format, "COMPRESS", "NONE");
-      }
-      else if (EQUAL(value, "PackBits")) {
-        msSetOutputFormatOption(format, "COMPRESS", "PACKBITS");
-      }
-      else if (EQUAL(value, "Deflate")) {
-        msSetOutputFormatOption(format, "COMPRESS", "DEFLATE");
-      }
-      else if (EQUAL(value, "Huffman")) {
-        msSetOutputFormatOption(format, "COMPRESS", "CCITTRLE");
-      }
-      else if (EQUAL(value, "LZW")) {
-        msSetOutputFormatOption(format, "COMPRESS", "LZW");
-      }
-      else if (EQUAL(value, "JPEG")) {
-        msSetOutputFormatOption(format, "COMPRESS", "JPEG");
-      }
-      /* unsupported compression methods: CCITTFAX3/CCITTFAX4 */
-      else {
-        msSetError(MS_WCSERR, "Compression method '%s' not supported.",
-                   "msWCSSetFormatParams20()", value);
-        return MS_FAILURE;
-      }
-    }
-
-    else if (EQUAL(key, "geotiff:jpeg_quality") && is_geotiff) {
-      int quality;
-      /* JPEG_QUALITY=[1-100] */
-      if (msStringParseInteger(value, &quality) != MS_SUCCESS) {
-        msSetError(MS_WCSERR, "Could not parse jpeg_quality value.",
-                 "msWCSSetFormatParams20()");
-        return MS_FAILURE;
-      }
-      else if (quality < 1 || quality > 100) {
-        msSetError(MS_WCSERR, "Invalid jpeg_quality value '%d'.",
-                   "msWCSSetFormatParams20()", quality);
-        return MS_FAILURE;
-      }
-      msSetOutputFormatOption(format, "JPEG_QUALITY", value);
-    }
-    else if (EQUAL(key, "geotiff:predictor") && is_geotiff) {
-      /* PREDICTOR=[None/Horizontal/FloatingPoint] */
-      const char *predictor;
-      if (EQUAL(value, "None") || EQUAL(value, "1")) {
-        predictor = "1";
-      }
-      else if (EQUAL(value, "Horizontal") || EQUAL(value, "2")) {
-        predictor = "2";
-      }
-      else if (EQUAL(value, "FloatingPoint") || EQUAL(value, "3")) {
-        predictor = "3";
-      }
-      else {
-        msSetError(MS_WCSERR, "Invalid predictor value '%s'.",
-                   "msWCSSetFormatParams20()", value);
-        return MS_FAILURE;
-      }
-      msSetOutputFormatOption(format, "PREDICTOR", predictor);
-    }
-    else if (EQUAL(key, "geotiff:interleave") && is_geotiff) {
-      /* INTERLEAVE=[BAND,PIXEL] */
-      if (EQUAL(value, "Band")) {
-        msSetOutputFormatOption(format, "INTERLEAVE", "BAND");
-      }
-      else if (EQUAL(value, "Pixel")) {
-        msSetOutputFormatOption(format, "INTERLEAVE", "PIXEL");
-      }
-      else {
-        msSetError(MS_WCSERR, "Interleave method '%s' not supported.",
-                   "msWCSSetFormatParams20()", value);
-        return MS_FAILURE;
-      }
-    }
-    else if (EQUAL(key, "geotiff:tiling") && is_geotiff) {
-      /* TILED=YES */
-      if (EQUAL(value, "true")) {
-        msSetOutputFormatOption(format, "TILED", "YES");
-      }
-      else if (EQUAL(value, "false")) {
-        msSetOutputFormatOption(format, "TILED", "NO");
-      }
-      else {
-        msSetError(MS_WCSERR, "Invalid boolean value '%s'.",
-                   "msWCSSetFormatParams20()", value);
-        return MS_FAILURE;
-      }
-    }
-    else if (EQUAL(key, "geotiff:tileheight") && is_geotiff) {
-      /* BLOCKXSIZE=n */
-      int tileheight;
-
-      if (msStringParseInteger(value, &tileheight) != MS_SUCCESS) {
-        msSetError(MS_WCSERR, "Could not parse tileheight value.",
-                 "msWCSSetFormatParams20()");
-        return MS_FAILURE;
-      }
-      else if (tileheight < 1 || tileheight % 16) {
-        msSetError(MS_WCSERR, "Invalid tileheight value '%d'. "
-                   "Must be greater than 0 and dividable by 16.",
-                   "msWCSSetFormatParams20()", tileheight);
-        return MS_FAILURE;
-      }
-      msSetOutputFormatOption(format, "BLOCKXSIZE", value);
-    }
-    else if (EQUAL(key, "geotiff:tilewidth") && is_geotiff) {
-      /* BLOCKYSIZE=n */
-      int tilewidth;
-
-      if (msStringParseInteger(value, &tilewidth) != MS_SUCCESS) {
-        msSetError(MS_WCSERR, "Could not parse tilewidth value.",
-                 "msWCSSetFormatParams20()");
-        return MS_FAILURE;
-      }
-      else if (tilewidth < 1 || tilewidth % 16) {
-        msSetError(MS_WCSERR, "Invalid tilewidth value '%d'. "
-                   "Must be greater than 0 and dividable by 16.",
-                   "msWCSSetFormatParams20()", tilewidth);
-        return MS_FAILURE;
-      }
-      msSetOutputFormatOption(format, "BLOCKYSIZE", value);
-    }
-    else if (EQUALN(key, "geotiff:", 8)) {
-      msSetError(MS_WCSERR, "Unrecognized GeoTIFF parameter '%s'.",
-                 "msWCSSetFormatParams20()", key);
-      return MS_FAILURE;
-    }
-
-    msFree(key);
-
-    /* fetch next option */
-    format_option = format_options[++i];
-  }
-
-  return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                   msWCSGetCoverage20()                               */
-/*                                                                      */
-/*      Implementation of the GetCoverage Operation. The coverage       */
-/*      is either returned as an image or as a multipart xml/image.     */
-/*      The result is written on the stream.                            */
-/************************************************************************/
-
-int msWCSGetCoverage20(mapObj *map, cgiRequestObj *request,
-                       wcs20ParamsObjPtr params, owsRequestObj *ows_request)
-{
-  (void)request;
-  layerObj *layer = NULL;
-  wcs20coverageMetadataObj cm;
-  imageObj *image = NULL;
-  outputFormatObj *format = NULL;
-
-  rectObj subsets, bbox;
-  projectionObj imageProj;
-
-  int status, i;
-  double x_1, x_2, y_1, y_2;
-  char *coverageName, *bandlist=NULL, numbands[12];
-
-  int doDrawRasterLayerDraw = MS_TRUE;
-  GDALDatasetH hDS = NULL;
-
-  int widthFromComputationInImageCRS = 0;
-  int heightFromComputationInImageCRS = 0;
-
-  /* number of coverage ids should be 1 */
-  if (params->ids == NULL || params->ids[0] == NULL) {
-    msSetError(MS_WCSERR, "Required parameter CoverageID was not supplied.",
-               "msWCSGetCoverage20()");
-    return msWCSException(map, "MissingParameterValue", "coverage",
-                          params->version);
-  }
-  if (params->ids[1] != NULL) {
-    msSetError(MS_WCSERR, "GetCoverage operation supports only one coverage.",
-               "msWCSGetCoverage20()");
-    return msWCSException(map, "TooManyParameterValues", "coverage",
-                          params->version);
-  }
-
-  /* find the right layer */
-  layer = NULL;
-  for(i = 0; i < map->numlayers; i++) {
-    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata),
-                                          "CO", "name",
-                                          GET_LAYER(map, i)->name);
-    if (EQUAL(coverageName, params->ids[0]) &&
-        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))) {
-      layer = GET_LAYER(map, i);
-      i = map->numlayers; /* to exit loop don't use break, we want to free resources first */
-    }
-    msFree(coverageName);
-  }
-
-  /* throw exception if no Layer was found */
-  if (layer == NULL) {
-    msSetError(MS_WCSERR,
-               "COVERAGEID=%s not found, not in supported layer list. A layer might be disabled for \
-this request. Check wcs/ows_enable_request settings.", "msWCSGetCoverage20()", params->ids[0]);
-    return msWCSException(map, "NoSuchCoverage", "coverageid",
-                          params->version);
-  }
-  /* retrieve coverage metadata  */
-  status = msWCSGetCoverageMetadata20(layer, &cm);
-  if (status != MS_SUCCESS) {
-    msWCSClearCoverageMetadata20(&cm);
-    return MS_FAILURE;
-  }
-
-  /* fill in bands rangeset info, if required.  */
-  /* msWCSSetDefaultBandsRangeSetInfo(NULL, &cm, layer ); */
-
-  /* set  resolution, size and maximum extent */
-  layer->extent = map->extent = cm.extent;
-  map->cellsize = cm.xresolution;
-  map->width = cm.xsize;
-  map->height = cm.ysize;
-
-  /************************************************************************/
-  /*      finalize the params object. determine subset crs and subset     */
-  /*      bbox. Also project the image to the subset crs.                 */
-  /************************************************************************/
-
-  msInitProjection(&imageProj);
-  msProjectionInheritContextFrom(&imageProj, &(layer->projection));
-  if (msLoadProjectionString(&imageProj, cm.srs_epsg) == -1) {
-    msFreeProjection(&imageProj);
-    msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR,
-               "Error loading CRS %s.",
-               "msWCSGetCoverage20()", cm.srs_epsg);
-    return msWCSException(map, "InvalidParameterValue",
-                          "projection", params->version);
-  }
-
-  /* iterate over all subsets and check if they are valid*/
-  for(i = 0; i < params->numaxes; ++i) {
-    if(params->axes[i]->subset != NULL) {
-      if(params->axes[i]->subset->timeOrScalar == MS_WCS20_TIME_VALUE) {
-        msFreeProjection(&imageProj);
-        msWCSClearCoverageMetadata20(&cm);
-        msSetError(MS_WCSERR, "Time values for subsets are not supported. ",
-                   "msWCSGetCoverage20()");
-        return msWCSException(map, "InvalidSubsetting", "subset", params->version);
-      }
-      if(params->axes[i]->subset->operation == MS_WCS20_SLICE) {
-        msFreeProjection(&imageProj);
-        msWCSClearCoverageMetadata20(&cm);
-        msSetError(MS_WCSERR, "Subset operation 'slice' is not supported.",
-                   "msWCSGetCoverage20()");
-        return msWCSException(map, "InvalidSubsetting", "subset", params->version);
-      }
-    }
-  }
-
-  {
-    wcs20AxisObjPtr axes[2];
-    if(msWCSValidateAndFindAxes20(params, axes) == MS_FAILURE) {
-      msFreeProjection(&imageProj);
-      msWCSClearCoverageMetadata20(&cm);
-      return msWCSException(map, "InvalidAxisLabel", "subset", params->version);
-    }
-    if(msWCSGetCoverage20_FinalizeParamsObj(params, axes) == MS_FAILURE) {
-      msFreeProjection(&imageProj);
-      msWCSClearCoverageMetadata20(&cm);
-      return msWCSException(map, "InvalidParameterValue", "extent", params->version);
-    }
-  }
-
-  subsets = params->bbox;
-
-  /* if no subsetCRS was specified use the coverages CRS 
-     (Requirement 27 of the WCS 2.0 specification) */
-  if (!params->subsetcrs) {
-    params->subsetcrs = msStrdup(cm.srs_epsg);
-  }
-
-  if(EQUAL(params->subsetcrs, "imageCRS")) {
-    /* subsets are in imageCRS; reproject them to real coordinates */
-    rectObj orig_bbox = subsets;
-
-    msFreeProjection(&(map->projection));
-    map->projection = imageProj;
-
-    if(subsets.minx != -DBL_MAX || subsets.maxx != DBL_MAX) {
-      x_1 = cm.geotransform[0]
-            + orig_bbox.minx * cm.geotransform[1]
-            + orig_bbox.miny * cm.geotransform[2];
-      // below +1 look suspicious to me (E. Rouault) and probably mean that
-      // there are still issues with pixel-center vs pixel-corner convention
-      // The resolution computed on wcs_20_post_getcov_trim_x_y_both_1px
-      // with that is 11, whereas it should be 10
-      x_2 = cm.geotransform[0]
-            + (orig_bbox.maxx+1) * cm.geotransform[1]
-            + (orig_bbox.maxy+1) * cm.geotransform[2];
-
-      subsets.minx = MS_MIN(x_1, x_2);
-      subsets.maxx = MS_MAX(x_1, x_2);
-    }
-    if(subsets.miny != -DBL_MAX || subsets.maxy != DBL_MAX) {
-      // below +1 are suspicious. See bove comment in the minx/maxx cases
-      y_1 = cm.geotransform[3]
-            + (orig_bbox.maxx+1) * cm.geotransform[4]
-            + (orig_bbox.maxy+1) * cm.geotransform[5];
-      /*subsets.miny -= cm.geotransform[4]/2 + cm.geotransform[5]/2;*/
-      y_2 = cm.geotransform[3]
-            + orig_bbox.minx * cm.geotransform[4]
-            + orig_bbox.miny * cm.geotransform[5];
-
-      subsets.miny = MS_MIN(y_1, y_2);
-      subsets.maxy = MS_MAX(y_1, y_2);
-    }
-  } else { /* if crs is not the 'imageCRS' */
-    projectionObj subsetProj;
-
-    /* if the subsets have a crs given, project the image extent to it */
-    msInitProjection(&subsetProj);
-    msProjectionInheritContextFrom(&subsetProj, &(layer->projection));
-    if(msLoadProjectionString(&subsetProj, params->subsetcrs) != MS_SUCCESS) {
-      msFreeProjection(&subsetProj);
-      msFreeProjection(&imageProj);
-      msWCSClearCoverageMetadata20(&cm);
-      msSetError(MS_WCSERR,
-                 "Error loading CRS %s.",
-                 "msWCSGetCoverage20()", params->subsetcrs);
-      return msWCSException(map, "InvalidParameterValue",
-                            "projection", params->version);
-    }
-
-    if(msProjectionsDiffer(&imageProj, &subsetProj)) {
-
-      /* Reprojection of source raster extent of (-180,-90,180,90) to any */
-      /* projected CRS is going to exhibit strong anomalies. So instead */
-      /* do the reverse, project the subset extent to the layer CRS, and */
-      /* see how much the subset extent takes with respect to the source */
-      /* raster extent. This is only used if output width and resolutionX (or */
-      /* (height and resolutionY) are unknown. */
-      if( ((params->width == 0 && params->resolutionX == MS_WCS20_UNBOUNDED) ||
-           (params->height == 0 && params->resolutionY == MS_WCS20_UNBOUNDED)) &&
-          (msProjIsGeographicCRS(&imageProj) &&
-           !msProjIsGeographicCRS(&subsetProj) &&
-           fabs(layer->extent.minx - -180.0) < 1e-5 &&
-           fabs(layer->extent.miny - -90.0) < 1e-5 &&
-           fabs(layer->extent.maxx - 180.0) < 1e-5 &&
-           fabs(layer->extent.maxy - 90.0) < 1e-5) )
-      {
-          rectObj subsetInImageProj = subsets;
-          if( msProjectRect(&subsetProj, &imageProj, &(subsetInImageProj)) == MS_SUCCESS )
-          {
-            subsetInImageProj.minx = MS_MAX(subsetInImageProj.minx, layer->extent.minx);
-            subsetInImageProj.miny = MS_MAX(subsetInImageProj.miny, layer->extent.miny);
-            subsetInImageProj.maxx = MS_MIN(subsetInImageProj.maxx, layer->extent.maxx);
-            subsetInImageProj.maxy = MS_MIN(subsetInImageProj.maxy, layer->extent.maxy);
-            {
-                double total = ABS(layer->extent.maxx - layer->extent.minx);
-                double part = ABS(subsetInImageProj.maxx - subsetInImageProj.minx);
-                widthFromComputationInImageCRS = MS_NINT((part * map->width) / total);
-            }
-            {
-                double total = ABS(layer->extent.maxy - layer->extent.miny);
-                double part = ABS(subsetInImageProj.maxy - subsetInImageProj.miny);
-                heightFromComputationInImageCRS = MS_NINT((part * map->height) / total);
-            }
-          }
-      }
-
-      msProjectRect(&imageProj, &subsetProj, &(layer->extent));
-      map->extent = layer->extent;
-      msFreeProjection(&(map->projection));
-      map->projection = subsetProj;
-      msFreeProjection(&imageProj);
-    } else {
-      msFreeProjection(&(map->projection));
-      map->projection = imageProj;
-      msFreeProjection(&subsetProj);
-    }
-  }
-
-  /* create boundings of params subsets and image extent */
-  if(msRectOverlap(&subsets, &(layer->extent)) == MS_FALSE) {
-    /* extent and bbox do not overlap -> exit */
-    msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR, "Image extent does not intersect with desired region.",
-               "msWCSGetCoverage20()");
-    return msWCSException(map, "ExtentError", "extent", params->version);
-  }
-
-  /* write combined bounding box */
-  bbox.minx = MS_MAX(subsets.minx, map->extent.minx);
-  bbox.miny = MS_MAX(subsets.miny, map->extent.miny);
-  bbox.maxx = MS_MIN(subsets.maxx, map->extent.maxx);
-  bbox.maxy = MS_MIN(subsets.maxy, map->extent.maxy);
-
-  /* check if we are overspecified  */
-  if ((params->width != 0 &&  params->resolutionX != MS_WCS20_UNBOUNDED)
-      || (params->height != 0 && params->resolutionY != MS_WCS20_UNBOUNDED)) {
-    msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR, "GetCoverage operation supports only one of SIZE or RESOLUTION per axis.",
-               "msWCSGetCoverage20()");
-    return msWCSException(map, "TooManyParameterValues", "coverage",
-                          params->version);
-  }
-
-  /************************************************************************/
-  /* check both axes: see if either size or resolution are given (and     */
-  /* calculate the other value). If both are not given, calculate them    */
-  /* from the bounding box.                                               */
-  /************************************************************************/
-
-  /* check x axis */
-  if(params->width != 0) {
-    /* TODO Unit Of Measure? */
-    params->resolutionX = (bbox.maxx - bbox.minx) / params->width;
-  } else if(params->resolutionX != MS_WCS20_UNBOUNDED) {
-    params->width = MS_NINT((bbox.maxx - bbox.minx) / params->resolutionX);
-  } else {
-    if( widthFromComputationInImageCRS != 0 ) {
-      params->width = widthFromComputationInImageCRS;
-    } else if(ABS(bbox.maxx - bbox.minx) != ABS(map->extent.maxx - map->extent.minx)) {
-      double total = ABS(map->extent.maxx - map->extent.minx),
-             part = ABS(bbox.maxx - bbox.minx);
-      params->width = MS_NINT((part * map->width) / total);
-    } else {
-      params->width = map->width;
-    }
-
-    params->resolutionX = (bbox.maxx - bbox.minx) / params->width;
-
-    if (params->scaleX != MS_WCS20_UNBOUNDED) {
-      params->resolutionX /= params->scaleX;
-      params->width = (long)(((double) params->width) * params->scaleX);
-    }
-  }
-
-  /* check y axis */
-  if(params->height != 0) {
-    params->resolutionY = (bbox.maxy - bbox.miny) / params->height;
-  } else if(params->resolutionY != MS_WCS20_UNBOUNDED) {
-    params->height = MS_NINT((bbox.maxy - bbox.miny) / params->resolutionY);
-  } else {
-    if( heightFromComputationInImageCRS != 0 ) {
-      params->height = heightFromComputationInImageCRS;
-    } else if(ABS(bbox.maxy - bbox.miny) != ABS(map->extent.maxy - map->extent.miny)) {
-      double total = ABS(map->extent.maxy - map->extent.miny),
-             part = ABS(bbox.maxy - bbox.miny);
-      params->height = MS_NINT((part * map->height) / total);
-    } else {
-      params->height = map->height;
-    }
-
-    params->resolutionY = (bbox.maxy - bbox.miny) / params->height;
-
-    if (params->scaleY != MS_WCS20_UNBOUNDED) {
-      params->resolutionY /= params->scaleY;
-      params->height = (long)(((double) params->height) * params->scaleY);
-    }
-  }
-
-  /* WCS 2.0 is center of pixel oriented */
-  rectObj bboxOriginIsCorner = bbox;
-  bbox.minx += params->resolutionX * 0.5;
-  bbox.maxx -= params->resolutionX * 0.5;
-  bbox.miny += params->resolutionY * 0.5;
-  bbox.maxy -= params->resolutionY * 0.5;
-
-  /* if parameter 'outputcrs' is given, project the image to this crs */
-  if(params->outputcrs != NULL) {
-    projectionObj outputProj;
-
-    msInitProjection(&outputProj);
-    msProjectionInheritContextFrom(&outputProj, &(layer->projection));
-    if(msLoadProjectionString(&outputProj, params->outputcrs) == -1) {
-      msFreeProjection(&outputProj);
-      msWCSClearCoverageMetadata20(&cm);
-      return msWCSException(map, "InvalidParameterValue", "coverage",
-                            params->version);
-    }
-    if(msProjectionsDiffer(&(map->projection), &outputProj)) {
-
-      msDebug("msWCSGetCoverage20(): projecting to outputcrs %s\n", params->outputcrs);
-
-      msProjectRect(&(map->projection), &outputProj, &bbox);
-
-      /* recalculate resolutions, needed if UOM changes (e.g: deg -> m) */
-      if( params->width == 1 || params->height == 1 )
-      {
-          // if one of the dimension is 1, we cannot use the center-of-pixel bbox,
-          // but must use the origin-is-corner one.
-          msProjectRect(&(map->projection), &outputProj, &bboxOriginIsCorner);
-          params->resolutionX = (bboxOriginIsCorner.maxx - bboxOriginIsCorner.minx) / params->width;
-          params->resolutionY = (bboxOriginIsCorner.maxy - bboxOriginIsCorner.miny) / params->height;
-      }
-      else
-      {
-          params->resolutionX = (bbox.maxx - bbox.minx) / (params->width - 1);
-          params->resolutionY = (bbox.maxy - bbox.miny) / (params->height - 1);
-      }
-
-      msFreeProjection(&(map->projection));
-      map->projection = outputProj;
-    }
-    else {
-      msFreeProjection(&outputProj);
-    }
-  }
-
-  /* set the bounding box as new map extent */
-  map->extent = bbox;
-  map->width = params->width;
-  map->height = params->height;
-
-  /* Are we exceeding the MAXSIZE limit on result size? */
-  if(map->width > map->maxsize || map->height > map->maxsize ) {
-    msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR, "Raster size out of range, width and height of "
-               "resulting coverage must be no more than MAXSIZE=%d.",
-               "msWCSGetCoverage20()", map->maxsize);
-
-    return msWCSException(map, "InvalidParameterValue",
-                          "size", params->version);
-  }
-
-  /* Mapserver only supports square cells */
-  if (params->resolutionX <= params->resolutionY)
-    map->cellsize = params->resolutionX;
-  else
-    map->cellsize = params->resolutionY;
-
-  msDebug("msWCSGetCoverage20(): Set parameters from original"
-          "data. Width: %d, height: %d, cellsize: %f, extent: %f,%f,%f,%f\n",
-          map->width, map->height, map->cellsize, map->extent.minx,
-          map->extent.miny, map->extent.maxx, map->extent.maxy);
-
-  /**
-   * Which format to use?
-   *
-   * 1) format parameter
-   * 2) native format (from metadata) or GDAL format of the input dataset
-   * 3) exception
-   **/
-
-  if (!params->format) {
-    if (cm.native_format) {
-      params->format = msStrdup(cm.native_format);
-    }
-  }
-
-  if (!params->format) {
-    msSetError(MS_WCSERR, "Output format could not be automatically determined. "
-               "Use the FORMAT parameter to specify a format.",
-               "msWCSGetCoverage20()");
-    msWCSClearCoverageMetadata20(&cm);
-    return msWCSException(map, "MissingParameterValue", "format",
-                          params->version);
-  }
-
-  /*    make sure layer is on   */
-  layer->status = MS_ON;
-
-  if( params->width == 1 || params->height == 1 )
-      msMapComputeGeotransformEx(map, params->resolutionX, params->resolutionY);
-  else
-      msMapComputeGeotransform(map);
-
-  /*    fill in bands rangeset info, if required.  */
-  /* msWCSSetDefaultBandsRangeSetInfo(params, &cm, layer); */
-  /* msDebug("Bandcount: %d\n", cm.bandcount); */
-
-  msApplyDefaultOutputFormats(map);
-
-  if (msGetOutputFormatIndex(map, params->format) == -1) {
-    msSetError(MS_WCSERR, "Unrecognized value '%s' for the FORMAT parameter.",
-               "msWCSGetCoverage20()", params->format);
-    msWCSClearCoverageMetadata20(&cm);
-    return msWCSException(map, "InvalidParameterValue", "format",
-                          params->version);
-  }
-
-  /* create a temporary outputformat (we likely will need to tweak parts) */
-  format = msCloneOutputFormat(msSelectOutputFormat(map, params->format));
-  msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
-
-  /* set format specific parameters */
-  if (msWCSSetFormatParams20(format, params->format_options) != MS_SUCCESS) {
-    msFree(bandlist);
-    msWCSClearCoverageMetadata20(&cm);
-    return msWCSException(map, "InvalidParameterValue", "format",
-                          params->version);
-  }
-
-  if(msWCSGetCoverage20_GetBands(layer, params, &cm, &bandlist) != MS_SUCCESS) {
-    msFree(bandlist);
-    msWCSClearCoverageMetadata20(&cm);
-    return msWCSException(map, "InvalidParameterValue", "rangesubset",
-                          params->version);
-  }
-  msLayerSetProcessingKey(layer, "BANDS", bandlist);
-  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',')+1);
-  msSetOutputFormatOption(map->outputformat, "BAND_COUNT", numbands);
-
-  msWCSApplyLayerCreationOptions(layer, map->outputformat, bandlist);
-  msWCSApplyLayerMetadataItemOptions(layer, map->outputformat, bandlist);
-
-  /* check for the interpolation */
-  /* Defaults to NEAREST */
-  if(params->interpolation != NULL) {
-    if(EQUALN(params->interpolation,"NEAREST",7)) {
-      msLayerSetProcessingKey(layer, "RESAMPLE", "NEAREST");
-    } else if(EQUAL(params->interpolation,"BILINEAR")) {
-      msLayerSetProcessingKey(layer, "RESAMPLE", "BILINEAR");
-    } else if(EQUAL(params->interpolation,"AVERAGE")) {
-      msLayerSetProcessingKey(layer, "RESAMPLE", "AVERAGE");
-    } else {
-      msFree(bandlist);
-      msSetError( MS_WCSERR, "'%s' specifies an unsupported interpolation method.",
-                  "msWCSGetCoverage20()", params->interpolation );
-      msWCSClearCoverageMetadata20(&cm);
-      return msWCSException(map, "InvalidParameterValue", "interpolation", params->version);
-    }
-  } else {
-    msLayerSetProcessingKey(layer, "RESAMPLE", "NEAREST");
-  }
-
-  /* since the dataset is only used in one layer, set it to be    */
-  /* closed after drawing the layer. This normally defaults to    */
-  /* DEFER and will produce a memory leak, because the dataset    */
-  /* will not be closed.                                          */
-  if( msLayerGetProcessingKey(layer, "CLOSE_CONNECTION") == NULL ) {
-    msLayerSetProcessingKey(layer, "CLOSE_CONNECTION", "NORMAL");
-  }
-
-  if( layer->tileindex == NULL && layer->data != NULL &&
-      strlen(layer->data) > 0 &&
-      layer->connectiontype != MS_KERNELDENSITY )
-  {
-      if( msDrawRasterLayerLowCheckIfMustDraw(map, layer) )
-      {
-          char* decrypted_path = NULL;
-          char szPath[MS_MAXPATHLEN];
-          hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
-                                    map, layer, layer->data, szPath, &decrypted_path);
-          msFree(decrypted_path);
-          if( hDS )
-          {
-            msWCSApplyDatasetMetadataAsCreationOptions(layer, map->outputformat, bandlist, hDS);
-            msWCSApplySourceDatasetMetadata(layer, map->outputformat, bandlist, hDS);
-          }
-      }
-      else
-      {
-          doDrawRasterLayerDraw = MS_FALSE;
-      }
-  }
-
-  /* create the image object  */
-  if (MS_RENDERER_PLUGIN(map->outputformat)) {
-    image = msImageCreate(map->width, map->height, map->outputformat,
-                          map->web.imagepath, map->web.imageurl, map->resolution,
-                          map->defresolution, &map->imagecolor);
-  } else if (MS_RENDERER_RAWDATA(map->outputformat)) {
-    image = msImageCreate(map->width, map->height, map->outputformat,
-                          map->web.imagepath, map->web.imageurl, map->resolution,
-                          map->defresolution, &map->imagecolor);
-  } else {
-    msFree(bandlist);
-    msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR, "Map outputformat not supported for WCS!",
-               "msWCSGetCoverage20()");
-    msDrawRasterLayerLowCloseDataset(layer, hDS);
-    return msWCSException(map, NULL, NULL, params->version);
-  }
-
-  if (image == NULL) {
-    msFree(bandlist);
-    msWCSClearCoverageMetadata20(&cm);
-    msDrawRasterLayerLowCloseDataset(layer, hDS);
-    return msWCSException(map, NULL, NULL, params->version);
-  }
-
-  if(layer->mask) {
-    int maskLayerIdx = msGetLayerIndex(map,layer->mask);
-    layerObj *maskLayer;
-    outputFormatObj *altFormat;
-    if(maskLayerIdx == -1) {
-      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)", "msDrawLayer()",
-                 layer->name,layer->mask);
-      msFreeImage(image);
-      msFree(bandlist);
-      msWCSClearCoverageMetadata20(&cm);
-      msDrawRasterLayerLowCloseDataset(layer, hDS);
-      return msWCSException(map, NULL, NULL, params->version);
-    }
-    maskLayer = GET_LAYER(map, maskLayerIdx);
-    if(!maskLayer->maskimage) {
-      int i,retcode;
-      int origstatus, origlabelcache;
-      char *origImageType = msStrdup(map->imagetype);
-      altFormat =  msSelectOutputFormat(map, "png24");
-      msInitializeRendererVTable(altFormat);
-      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg */
-      maskLayer->maskimage= msImageCreate(image->width, image->height,altFormat,
-                                          image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
-      if (!maskLayer->maskimage) {
-        msSetError(MS_MISCERR, "Unable to initialize mask image.", "msDrawLayer()");
-        msFreeImage(image);
-        msFree(bandlist);
-        msWCSClearCoverageMetadata20(&cm);
-        msDrawRasterLayerLowCloseDataset(layer, hDS);
-        return msWCSException(map, NULL, NULL, params->version);
-      }
-
-      /*
-       * force the masked layer to status on, and turn off the labelcache so that
-       * eventual labels are added to the temporary image instead of being added
-       * to the labelcache
-       */
-      origstatus = maskLayer->status;
-      origlabelcache = maskLayer->labelcache;
-      maskLayer->status = MS_ON;
-      maskLayer->labelcache = MS_OFF;
-
-      /* draw the mask layer in the temporary image */
-      retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
-      maskLayer->status = origstatus;
-      maskLayer->labelcache = origlabelcache;
-      if(retcode != MS_SUCCESS) {
-        free(origImageType);
-        msFreeImage(image);
-        msFree(bandlist);
-        msWCSClearCoverageMetadata20(&cm);
-        msDrawRasterLayerLowCloseDataset(layer, hDS);
-        return msWCSException(map, NULL, NULL, params->version);
-      }
-      /*
-       * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-       * symbols that reference it. We want to remove those references before the altFormat is destroyed
-       * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-       * it's for him.
-       */
-      for(i=0; i<map->symbolset.numsymbols; i++) {
-        if (map->symbolset.symbol[i]!=NULL) {
-          symbolObj *s = map->symbolset.symbol[i];
-          if(s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
-            MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
-            s->renderer = NULL;
-          }
-        }
-      }
-      /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
-      msFree(map->imagetype);
-      map->imagetype = origImageType;
-
-    }
-  }
-
-  /* Actually produce the "grid". */
-  if( MS_RENDERER_RAWDATA(map->outputformat) ) {
-    if( doDrawRasterLayerDraw ) {
-      status = msDrawRasterLayerLowWithDataset( map, layer, image, NULL, hDS );
-    } else {
-      status = MS_SUCCESS;
-    }
-  } else {
-    rasterBufferObj rb;
-    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image,&rb);
-    if(MS_LIKELY(status == MS_SUCCESS)) {
-      if( doDrawRasterLayerDraw ) {
-        status = msDrawRasterLayerLowWithDataset( map, layer, image, &rb, hDS );
-      } else {
-        status = MS_SUCCESS;
-      }
-    }
-  }
-
-  msDrawRasterLayerLowCloseDataset(layer, hDS);
-
-  if( status != MS_SUCCESS ) {
-    msFree(bandlist);
-    msFreeImage(image);
-    msWCSClearCoverageMetadata20(&cm);
-    return msWCSException(map, NULL, NULL, params->version );
-  }
-
-  /* GML+Image */
-  /* Embed the image into multipart message */
-  if(params->multipart == MS_TRUE) {
-    xmlDocPtr psDoc = NULL;       /* document pointer */
-    xmlNodePtr psRootNode, psRangeSet, psFile, psRangeParameters;
-    xmlNsPtr psGmlNs = NULL,
-             psGmlcovNs = NULL,
-             psSweNs = NULL,
-             psXLinkNs = NULL;
-    wcs20coverageMetadataObj tmpCm;
-    char *srs_uri, *default_filename;
-    const char *filename;
-    int swapAxes;
-
-    /* Create Document  */
-    psDoc = xmlNewDoc(BAD_CAST "1.0");
-    psRootNode = xmlNewNode(NULL, BAD_CAST MS_WCS_GML_COVERAGETYPE_RECTIFIED_GRID_COVERAGE);
-    xmlDocSetRootElement(psDoc, psRootNode);
-
-    msWCSPrepareNamespaces20(psDoc, psRootNode, map, MS_FALSE);
-
-    psGmlNs    = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
-    psGmlcovNs = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
-    psSweNs    = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
-    xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
-    psXLinkNs  = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-
-    xmlNewNsProp(psRootNode, psGmlNs, BAD_CAST "id", BAD_CAST layer->name);
-
-    xmlSetNs(psRootNode, psGmlcovNs);
-
-    srs_uri = msOWSGetProjURI(&map->projection, NULL, "CO", 1);
-
-    tmpCm = cm;
-    tmpCm.extent = map->extent;
-    tmpCm.xsize = map->width;
-    tmpCm.ysize = map->height;
-    strlcpy(tmpCm.srs_uri, srs_uri, sizeof(tmpCm.srs_uri));
-
-    tmpCm.xresolution = map->gt.geotransform[1];
-    tmpCm.yresolution = map->gt.geotransform[5];
-
-    tmpCm.extent.minx = MS_MIN(map->gt.geotransform[0], map->gt.geotransform[0] + map->width * tmpCm.xresolution);
-    tmpCm.extent.miny = MS_MIN(map->gt.geotransform[3], map->gt.geotransform[3] + map->height * tmpCm.yresolution);
-    tmpCm.extent.maxx = MS_MAX(map->gt.geotransform[0], map->gt.geotransform[0] + map->width * tmpCm.xresolution);
-    tmpCm.extent.maxy = MS_MAX(map->gt.geotransform[3], map->gt.geotransform[3] + map->height * tmpCm.yresolution);
-
-    swapAxes = msWCSSwapAxes20(srs_uri);
-    msFree(srs_uri);
-
-    /* Setup layer information  */
-    msWCSCommon20_CreateBoundedBy(&tmpCm, psGmlNs, psRootNode, &(map->projection), swapAxes);
-    msWCSCommon20_CreateDomainSet(layer, &tmpCm, psGmlNs, psRootNode, &(map->projection), swapAxes);
-
-    psRangeSet = xmlNewChild(psRootNode, psGmlNs, BAD_CAST "rangeSet", NULL);
-    psFile     = xmlNewChild(psRangeSet, psGmlNs, BAD_CAST "File", NULL);
-
-    /* TODO: wait for updated specifications */
-    psRangeParameters = xmlNewChild(psFile, psGmlNs, BAD_CAST "rangeParameters", NULL);
-
-    default_filename = msStrdup("out.");
-    default_filename = msStringConcatenate(default_filename, MS_IMAGE_EXTENSION(image->format));
-
-    filename = msGetOutputFormatOption(image->format, "FILENAME", default_filename);
-    std::string file_ref("cid:coverage/");
-    file_ref += filename;
-
-    msFree(default_filename);
-
-    std::string role;
-    if(EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "image/tiff")) {
-      role = MS_WCS_20_PROFILE_GML_GEOTIFF;
-    } else {
-      role = MS_IMAGE_MIME_TYPE(map->outputformat);
-    }
-
-    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "href", BAD_CAST file_ref.c_str());
-    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "role", BAD_CAST role.c_str());
-    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "arcrole", BAD_CAST "fileReference");
-
-    xmlNewChild(psFile, psGmlNs, BAD_CAST "fileReference", BAD_CAST file_ref.c_str());
-    xmlNewChild(psFile, psGmlNs, BAD_CAST "fileStructure", NULL);
-    xmlNewChild(psFile, psGmlNs, BAD_CAST "mimeType", BAD_CAST MS_IMAGE_MIME_TYPE(map->outputformat));
-
-    msWCSCommon20_CreateRangeType(&cm, bandlist, psGmlcovNs, psSweNs, psRootNode);
-
-    msIO_setHeader("Content-Type","multipart/related; boundary=wcs");
-    msIO_sendHeaders();
-    msIO_printf("\r\n--wcs\r\n");
-
-    msWCSWriteDocument20(psDoc);
-    msWCSWriteFile20(map, image, params, 1);
-
-    xmlFreeDoc(psDoc);
-    xmlCleanupParser();
-  /* just print out the file without gml */
-  } else {
-    msWCSWriteFile20(map, image, params, 0);
-  }
-
-  msFree(bandlist);
-  msWCSClearCoverageMetadata20(&cm);
-  msFreeImage(image);
-  return MS_SUCCESS;
-}
-
-#endif /* defined(USE_LIBXML2) */
-
-#endif /* defined(USE_WCS_SVR) */
diff -pruN 8.0.1-5/mapwfs.cpp 8.2.0~beta1-1~exp1/mapwfs.cpp
--- 8.0.1-5/mapwfs.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwfs.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,5569 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  WFS server implementation
- * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2002, Daniel Morissette, DM Solutions Group Inc
- * Copyright (c) 2013, Even Rouault
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#include <string>
-
-
-#if defined(USE_WFS_SVR)
-
-/* There is a dependency to GDAL/OGR for the GML driver and MiniXML parser */
-#include "cpl_minixml.h"
-#include "cpl_conv.h"
-#include "cpl_string.h"
-
-#include "mapogcfilter.h"
-#include "mapowscommon.h"
-#include "maptemplate.h"
-
-#if defined(USE_LIBXML2)
-#include "maplibxml2.h"
-#endif
-
-#include <string>
-
-static int msWFSAnalyzeStoredQuery(mapObj* map,
-                                   wfsParamsObj *wfsparams,
-                                   const char* id,
-                                   const char* pszResolvedQuery);
-static void msWFSSimplifyPropertyNameAndFilter(wfsParamsObj *wfsparams);
-static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map, const wfsParamsObj *paramsObj,
-                                                  int bIsHits,
-                                                  int *pmaxfeatures, int* pstartindex);
-static int msWFSRunBasicGetFeature(mapObj* map,
-                                   layerObj* lp,
-                                   const wfsParamsObj *paramsObj,
-                                   int nWFSVersion);
-
-static int msWFSParseRequest(mapObj *map, cgiRequestObj *request,
-                      wfsParamsObj *wfsparams, int force_wfs_mode);
-
-/* Must be sorted from more recent to older one */
-static const int wfsSupportedVersions[] = {OWS_2_0_0, OWS_1_1_0, OWS_1_0_0};
-static const char* const wfsSupportedVersionsStr[] = { "2.0.0", "1.1.0", "1.0.0" };
-static const int wfsNumSupportedVersions =
-    (int)(sizeof(wfsSupportedVersions)/sizeof(wfsSupportedVersions[0]));
-static const char* const wfsUnsupportedOperations[] = { "GetFeatureWithLock",
-                                                  "LockFeature",
-                                                  "Transaction",
-                                                  "CreateStoredQuery",
-                                                  "DropStoredQuery" };
-static const int wfsNumUnsupportedOperations =
-    (int)(sizeof(wfsUnsupportedOperations)/sizeof(wfsUnsupportedOperations[0]));
-
-#define WFS_LATEST_VERSION  wfsSupportedVersionsStr[0]
-
-/* Supported DescribeFeature formats */
-typedef enum
-{
-    OWS_DEFAULT_SCHEMA, /* basically a GML 2.1 schema */
-    OWS_SFE_SCHEMA, /* GML for simple feature exchange (formerly GML3L0) */
-    OWS_GML32_SFE_SCHEMA /* GML 3.2 Simple Features Level 0 */
-} WFSSchemaVersion;
-
-/*
-** msWFSGetIndexUnsupportedOperation()
-**
-** Return index of pszOp in wfsUnsupportedOperations, or -1 otherwise
-*/
-
-static int msWFSGetIndexUnsupportedOperation(const char* pszOp)
-{
-    int i;
-    for(i = 0; i < wfsNumUnsupportedOperations; i++ )
-    {
-        if( strcasecmp(wfsUnsupportedOperations[i], pszOp) == 0 )
-            return i;
-    }
-    return -1;
-}
-
-
-static
-const char *msWFSGetDefaultVersion(mapObj *map);
-
-/*
-** msWFSException()
-**
-** Report current MapServer error in XML exception format.
-*/
-
-static
-int msWFSExceptionInternal(mapObj *map, const char *locator, const char *code,
-                           const char *version, int locatorShouldBeNull )
-{
-  char *schemalocation = NULL;
-  /* In WFS, exceptions are always XML.
-  */
-
-  if( version == NULL )
-    version = msWFSGetDefaultVersion(map);
-
-  if( msOWSParseVersionString(version) >= OWS_2_0_0 )
-    return msWFSException20( map, (locatorShouldBeNull) ? NULL : locator, code );
-  if( msOWSParseVersionString(version) >= OWS_1_1_0 )
-    return msWFSException11( map, (locatorShouldBeNull) ? NULL : locator, code, version );
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-
-  msIO_printf("<ServiceExceptionReport ");
-  msIO_printf("version=\"1.2.0\" ");
-  msIO_printf("xmlns=\"http://www.opengis.net/ogc\" ");
-  msIO_printf("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ");
-  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc %s/wfs/1.0.0/OGC-exception.xsd\">\n", schemalocation);
-  free(schemalocation);
-  msIO_printf("  <ServiceException code=\"%s\" locator=\"%s\">\n", code, locator);
-  /* Optional <Locator> element currently unused. */
-  /* msIO_printf("    <Message>\n"); */
-  msWriteErrorXML(stdout);
-  /* msIO_printf("    </Message>\n"); */
-  msIO_printf("  </ServiceException>\n");
-  msIO_printf("</ServiceExceptionReport>\n");
-
-  return MS_FAILURE; /* so we can call 'return msWFSException();' anywhere */
-}
-
-int msWFSException(mapObj *map, const char *locator, const char *code,
-                   const char *version )
-{
-    return msWFSExceptionInternal(map, locator, code, version, FALSE);
-}
-
-
-/*
-** msWFSExceptionNoLocator()
-**
-** Report current MapServer error in XML exception format.
-** For WFS >= 1.1.0, the locator will be ignored. It will be just used
-** for legacy WFS 1.0 exceptions.
-*/
-
-static
-int msWFSExceptionNoLocator(mapObj *map, const char *locator, const char *code,
-                   const char *version )
-{
-    return msWFSExceptionInternal(map, locator, code, version, TRUE);
-}
-
-/*
-** Helper function to build a list of output formats.
-**
-** Given a layer it will return all formats valid for that layer, otherwise
-** all formats permitted on layers in the map are returned.  The string
-** returned should be freed by the caller.
-*/
-
-char *msWFSGetOutputFormatList(mapObj *map, layerObj *layer, int nWFSVersion )
-{
-  int i, got_map_list = 0;
-  static const int out_list_size = 20000;
-  char *out_list = (char*) msSmallCalloc(1,out_list_size);
-
-  if( nWFSVersion == OWS_1_0_0 )
-      strcpy(out_list,"GML2");
-  else if( nWFSVersion == OWS_1_1_0 )
-      strcpy(out_list,"text/xml; subtype=gml/3.1.1");
-  else
-      strcpy(out_list,"application/gml+xml; version=3.2,"
-                      "text/xml; subtype=gml/3.2.1,"
-                      "text/xml; subtype=gml/3.1.1,"
-                      "text/xml; subtype=gml/2.1.2");
-
-  for( i = 0; i < map->numlayers; i++ ) {
-    const char *format_list;
-    layerObj *lp;
-    int j, n;
-    char **tokens;
-
-    lp = GET_LAYER(map, i);
-    if( layer != NULL && layer != lp )
-      continue;
-
-    format_list = msOWSLookupMetadata(&(lp->metadata),
-                                      "F","getfeature_formatlist");
-
-    if( format_list == NULL && !got_map_list ) {
-      format_list = msOWSLookupMetadata(&(map->web.metadata),
-                                        "F","getfeature_formatlist");
-      got_map_list = 1;
-    }
-
-    if( format_list == NULL )
-      continue;
-
-    n = 0;
-    tokens = msStringSplit(format_list, ',', &n);
-
-    for( j = 0; j < n; j++ ) {
-      int iformat;
-      const char *fname, *hit;
-      outputFormatObj *format_obj;
-
-      msStringTrim( tokens[j] );
-      iformat = msGetOutputFormatIndex(map,tokens[j]);
-      if( iformat < 0 )
-        continue;
-
-      format_obj = map->outputformatlist[iformat];
-
-      fname = format_obj->name;
-      if( nWFSVersion >= OWS_1_1_0
-          && format_obj->mimetype != NULL )
-        fname = format_obj->mimetype;
-
-      hit = strstr(out_list,fname);
-      if( hit != NULL
-          && (hit[strlen(fname)] == '\0' || hit[strlen(fname)] == ','))
-        continue;
-
-      if( strlen(out_list) + strlen(fname)+3 < out_list_size ) {
-        strcat( out_list, "," );
-        strcat( out_list, fname );
-      } else
-        break;
-    }
-
-    msFreeCharArray( tokens, n );
-  }
-
-  return out_list;
-}
-
-/*
-**
-*/
-static void msWFSPrintRequestCap(const char *request,
-                                 const char *script_url,
-                                 const char *format_tag,
-                                 const char *formats_list)
-{
-  msIO_printf("    <%s>\n", request);
-
-  /* We expect to receive a NULL-terminated args list of formats */
-  if (format_tag != NULL) {
-    int i, n;
-    char **tokens;
-
-    n = 0;
-    tokens = msStringSplit(formats_list, ',', &n);
-
-    msIO_printf("      <%s>\n", format_tag);
-
-    for( i = 0; i < n; i++ ) {
-      msIO_printf("        <%s/>\n", tokens[i] );
-    }
-
-    msFreeCharArray( tokens, n );
-
-    msIO_printf("      </%s>\n", format_tag);
-  }
-
-  msIO_printf("      <DCPType>\n");
-  msIO_printf("        <HTTP>\n");
-  msIO_printf("          <Get onlineResource=\"%s\" />\n", script_url);
-  msIO_printf("        </HTTP>\n");
-  msIO_printf("      </DCPType>\n");
-  msIO_printf("      <DCPType>\n");
-  msIO_printf("        <HTTP>\n");
-  msIO_printf("          <Post onlineResource=\"%s\" />\n", script_url);
-  msIO_printf("        </HTTP>\n");
-  msIO_printf("      </DCPType>\n");
-
-
-  msIO_printf("    </%s>\n", request);
-}
-
-
-/* msWFSLocateSRSInList()
-**
-** Utility function to check if a space separated list contains  the one passed in argument.
-**  The list comes normaly from ows_srs metadata, and is expected to use the simple EPSG notation
-** (EPSG:4326 ESPG:42304 ...). The srs comes from the query string and can either
-** be of simple EPSG format or using gc:def:crs:EPSG:xxx format
-*/
-int msWFSLocateSRSInList(const char *pszList, const char *srs)
-{
-  int nTokens,i;
-  char **tokens = NULL;
-  int bFound = MS_FALSE;
-  char epsg_string[100];
-  const char *code;
-
-  if (!pszList || !srs)
-    return MS_FALSE;
-
-  if (strncasecmp(srs, "EPSG:",5) == 0)
-    code = srs+5;
-  else if (strncasecmp(srs, "urn:ogc:def:crs:EPSG:",21) == 0) {
-    if (srs[21] == ':')
-      code = srs+21;
-    else
-      code = srs+20;
-
-    while( *code != ':' && *code != '\0')
-      code++;
-    if( *code == ':' )
-      code++;
-  } else if (strncasecmp(srs, "urn:EPSG:geographicCRS:",23) == 0)
-    code = srs + 23;
-  else
-    return MS_FALSE;
-
-  snprintf( epsg_string, sizeof(epsg_string), "EPSG:%s", code );
-
-  tokens = msStringSplit(pszList, ' ', &nTokens );
-  if (tokens && nTokens > 0) {
-    for (i=0; i<nTokens; i++) {
-      if (strcasecmp(tokens[i],  epsg_string) == 0) {
-        bFound = MS_TRUE;
-        break;
-      }
-    }
-  }
-  msFreeCharArray(tokens, nTokens);
-
-  return bFound;
-}
-
-/* msWFSGetFeatureApplySRS()
-**
-** Utility function called from msWFSGetFeature. It is assumed that at this point
-** all queried layers are turned ON
-*/
-static int msWFSGetFeatureApplySRS(mapObj *map, const char *srs, int nWFSVersion)
-{
-  char *pszMapSRS=NULL;
-  char *pszOutputSRS=NULL;
-  layerObj *lp;
-  int i;
-
-  /*validation of SRS
-    - wfs 1.0 does not have an srsname parameter so all queried layers should be advertized using the
-      same srs. For wfs 1.1.0 an srsName can be passed, we should validate that It is valid for all
-      queries layers
-  */
-
-  /* Start by applying the default service SRS to the mapObj, 
-   * make sure we reproject the map extent if a projection was 
-   * already set 
-   */
-  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE, &pszMapSRS);
-  if(pszMapSRS && nWFSVersion >  OWS_1_0_0){
-    projectionObj proj;
-    msInitProjection(&proj);
-    msProjectionInheritContextFrom(&proj, &(map->projection));
-    if (map->projection.numargs > 0 && msLoadProjectionStringEPSG(&proj, pszMapSRS) == 0) {
-      msProjectRect(&(map->projection), &proj, &map->extent);
-    }
-    msLoadProjectionStringEPSG(&(map->projection), pszMapSRS);
-    msFreeProjection(&proj);
-  }
-
-  if (srs == NULL || nWFSVersion == OWS_1_0_0) {
-    for (i=0; i<map->numlayers; i++) {
-      char *pszLayerSRS;
-      lp = GET_LAYER(map, i);
-      if (lp->status != MS_ON)
-        continue;
-
-      if (pszMapSRS)
-        pszLayerSRS = pszMapSRS;
-      else
-        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &pszLayerSRS);
-
-      if (pszLayerSRS == NULL) {
-        msSetError(MS_WFSERR,
-                   "Server config error: SRS must be set at least at the map or at the layer level.",
-                   "msWFSGetFeature()");
-        if (pszOutputSRS)
-          msFree(pszOutputSRS);
-        /*pszMapSrs would also be NULL, no use freeing*/
-        return MS_FAILURE;
-      }
-      if (pszOutputSRS == NULL)
-        pszOutputSRS = msStrdup(pszLayerSRS);
-      else if (strcasecmp(pszLayerSRS,pszOutputSRS) != 0) {
-        msSetError(MS_WFSERR,
-                   "Invalid GetFeature Request: All TYPENAMES in a single GetFeature request must have been advertized in the same SRS.  Please check the capabilities and reformulate your request.",
-                   "msWFSGetFeature()");
-        if (pszOutputSRS)
-          msFree(pszOutputSRS);
-        if(pszLayerSRS != pszMapSRS)
-          msFree(pszLayerSRS);
-        msFree(pszMapSRS);
-        return MS_FAILURE;
-      }
-      if(pszLayerSRS != pszMapSRS)
-        msFree(pszLayerSRS);
-    }
-  } else { /*srs is given so it should be valid for all layers*/
-    /*get all the srs defined at the map level and check them aginst the srsName passed
-      as argument*/
-    msFree(pszMapSRS);
-    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_FALSE, &pszMapSRS);
-    if (pszMapSRS) {
-      if (!msWFSLocateSRSInList(pszMapSRS, srs)) {
-        msSetError(MS_WFSERR,
-                   "Invalid GetFeature Request:Invalid SRS.  Please check the capabilities and reformulate your request.",
-                   "msWFSGetFeature()");
-        msFree(pszMapSRS);
-        return MS_FAILURE;
-      }
-      pszOutputSRS = msStrdup(srs);
-    } else {
-      for (i=0; i<map->numlayers; i++) {
-        char *pszLayerSRS=NULL;
-        lp = GET_LAYER(map, i);
-        if (lp->status != MS_ON)
-          continue;
-
-        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_FALSE, &pszLayerSRS);
-        if (!pszLayerSRS) {
-          msSetError(MS_WFSERR,
-                     "Server config error: SRS must be set at least at the map or at the layer level.",
-                     "msWFSGetFeature()");
-          msFree(pszMapSRS);
-          return MS_FAILURE;
-        }
-        if (!msWFSLocateSRSInList(pszLayerSRS, srs)) {
-          msSetError(MS_WFSERR,
-                     "Invalid GetFeature Request:Invalid SRS.  Please check the capabilities and reformulate your request.",
-                     "msWFSGetFeature()");
-          msFree(pszMapSRS);
-          msFree(pszLayerSRS);
-          return MS_FAILURE;
-        }
-        msFree(pszLayerSRS);
-      }
-      pszOutputSRS = msStrdup(srs);
-    }
-  }
-
-  if (pszOutputSRS) {
-    projectionObj sProjTmp;
-    int nTmp=0;
-
-    msInitProjection(&sProjTmp);
-    msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
-    if( nWFSVersion >= OWS_1_1_0 ) {
-      nTmp = msLoadProjectionStringEPSG(&(sProjTmp), pszOutputSRS);
-    } else {
-      nTmp = msLoadProjectionString(&(sProjTmp), pszOutputSRS);
-    }
-    if (nTmp == 0) {
-      msProjectRect(&(map->projection), &(sProjTmp), &map->extent);
-    }
-    msFreeProjection(&(sProjTmp));
-
-    if (nTmp != 0) {
-      msSetError(MS_WFSERR, "msLoadProjectionString() failed", "msWFSGetFeature()");
-      return MS_FAILURE;
-    }
-
-    /*we load the projection sting in the map and possibly
-    set the axis order*/
-    if( nWFSVersion >= OWS_1_1_0 ) {
-      msLoadProjectionStringEPSG(&(map->projection), pszOutputSRS);
-    } else {
-      msLoadProjectionString(&(map->projection), pszOutputSRS);
-    }
-
-    nTmp = GetMapserverUnitUsingProj(&(map->projection));
-    if( nTmp != -1 ) {
-      map->units = static_cast<MS_UNITS>(nTmp);
-    }
-  }
-
-  msFree(pszOutputSRS);
-  msFree(pszMapSRS);
-  return MS_SUCCESS;
-}
-
-
-/* msWFSIsLayerSupported()
-**
-** Returns true (1) is this layer meets the requirements to be served as
-** a WFS feature type.
-*/
-int msWFSIsLayerSupported(layerObj *lp)
-{
-  /* In order to be supported, lp->type must be specified, even for
-  ** layers that are OGR, SDE, SDO, etc connections.
-  */
-  if ((lp->type == MS_LAYER_POINT ||
-       lp->type == MS_LAYER_LINE ||
-       lp->type == MS_LAYER_POLYGON ) &&
-      lp->connectiontype != MS_WMS &&
-      lp->connectiontype != MS_GRATICULE) {
-    return 1; /* true */
-  }
-
-  return 0; /* false */
-}
-
-static int msWFSIsLayerAllowed(layerObj *lp, owsRequestObj *ows_request)
-{
-    return msWFSIsLayerSupported(lp) &&
-           (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers));
-}
-
-static layerObj* msWFSGetLayerByName(mapObj* map, owsRequestObj *ows_request, const char* name)
-{
-    int j;
-    for (j=0; j<map->numlayers; j++) {
-        layerObj *lp;
-
-        lp = GET_LAYER(map, j);
-
-        if (msWFSIsLayerAllowed(lp, ows_request) && lp->name && (strcasecmp(lp->name, name) == 0)) {
-            return lp;
-        }
-    }
-    return NULL;
-}
-
-/*
-** msWFSDumpLayer()
-*/
-int msWFSDumpLayer(mapObj *map, layerObj *lp, const char *script_url_encoded)
-{
-  rectObj ext;
-  char *pszWfsSrs = NULL;
-  projectionObj poWfs;
-
-  msIO_printf("    <FeatureType>\n");
-
-  if (lp->name && strlen(lp->name) > 0 &&
-      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
-    msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                 "invalid characters or may start with a number. This could lead to potential problems. -->\n",lp->name);
-
-  msOWSPrintEncodeParam(stdout, "LAYER.NAME", lp->name, OWS_WARN,
-                        "        <Name>%s</Name>\n", NULL);
-
-  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "title",
-                           OWS_WARN, "        <Title>%s</Title>\n", lp->name);
-
-  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "abstract",
-                           OWS_NOERR, "        <Abstract>%s</Abstract>\n", NULL);
-
-  msOWSPrintEncodeMetadataList(stdout, &(lp->metadata), "FO",
-                               "keywordlist",
-                               "        <Keywords>\n",
-                               "        </Keywords>\n",
-                               "          %s\n", NULL);
-
-  /* In WFS, every layer must have exactly one SRS and there is none at */
-  /* the top level contrary to WMS */
-  /*  */
-  /* So here is the way we'll deal with SRS: */
-  /* 1- If a top-level map projection (or wfs_srs metadata) is set then */
-  /* all layers are advertized in the map's projection and they will */
-  /* be reprojected on the fly in the GetFeature request. */
-  /* 2- If there is no top-level map projection (or wfs_srs metadata) then */
-  /* each layer is advertized in its own projection as defined in the */
-  /* layer's projection object or wfs_srs metadata. */
-  /*  */
-  
-  /* if Map has a SRS,  Use it for all layers. */
-  msOWSGetEPSGProj(&(map->projection),&(map->web.metadata),"FO",MS_TRUE, &pszWfsSrs);
-  if(!pszWfsSrs) {
-    /* Map has no SRS.  Use layer SRS or produce a warning. */
-    msOWSGetEPSGProj(&(lp->projection),&(lp->metadata), "FO", MS_TRUE, &pszWfsSrs);
-  }
-
-  msOWSPrintEncodeParam(stdout, "(at least one of) MAP.PROJECTION, LAYER.PROJECTION or wfs_srs metadata",
-                        pszWfsSrs, OWS_WARN, "        <SRS>%s</SRS>\n", NULL);
-
-  /* If layer has no proj set then use map->proj for bounding box. */
-  if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
-    msInitProjection(&poWfs);
-    msProjectionInheritContextFrom(&poWfs, &(map->projection));
-    if (pszWfsSrs != NULL)
-      msLoadProjectionString(&(poWfs), pszWfsSrs);
-
-    if(lp->projection.numargs > 0) {
-      msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
-                                  &(lp->projection), &(poWfs), OWS_WFS);
-    } else {
-      msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
-                                  &(map->projection), &(poWfs), OWS_WFS);
-    }
-    msFreeProjection(&poWfs);
-  } else {
-    msIO_printf("<!-- WARNING: Optional LatLongBoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wfs_extent metadata. Also check that your data exists in the DATA statement -->\n");
-  }
-
-  const char* metadataurl_list = msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
-  if( metadataurl_list ) {
-    int ntokens = 0;
-    char** tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
-      std::string key("metadataurl_");
-      key += tokens[i];
-      msOWSPrintURLType(stdout, &(lp->metadata), "FO", key.c_str(),
-                    OWS_WARN, NULL, "MetadataURL", " type=\"%s\"",
-                    NULL, NULL, " format=\"%s\"", "%s",
-                    MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                    NULL, NULL, NULL, NULL, NULL, "        ");
-    }
-    msFreeCharArray(tokens, ntokens);
-  }
-  else {
-    if (! msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
-      msMetadataSetGetMetadataURL(lp, script_url_encoded);
-
-    msOWSPrintURLType(stdout, &(lp->metadata), "FO", "metadataurl",
-                      OWS_WARN, NULL, "MetadataURL", " type=\"%s\"",
-                      NULL, NULL, " format=\"%s\"", "%s",
-                      MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                      NULL, NULL, NULL, NULL, NULL, "        ");
-  }
-
-  if (msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid") == NULL) {
-    msIO_fprintf(stdout, "<!-- WARNING: Required Feature Id attribute (fid) not specified for this feature type. Make sure you set one of wfs_featureid, ows_featureid or gml_featureid metadata. -->\n");
-  }
-
-  msIO_printf("    </FeatureType>\n");
-
-  msFree(pszWfsSrs);
-  return MS_SUCCESS;
-}
-
-/*
-** msWFSHandleUpdateSequence()
-*/
-int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *params, const char* pszFunction)
-{
-  /* -------------------------------------------------------------------- */
-  /*      Handle updatesequence                                           */
-  /* -------------------------------------------------------------------- */
-
-  const char* updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
-
-  if (params->pszUpdateSequence != NULL) {
-    int i = msOWSNegotiateUpdateSequence(params->pszUpdateSequence, updatesequence);
-    if (i == 0) { /* current */
-      msSetError(MS_WFSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", pszFunction, params->pszUpdateSequence, updatesequence);
-      /* FIXME? : according to table 7 of OWS 1.1, we should return a service */
-      /* metadata document with only “version” and “updateSequence” parameters */
-      return msWFSException(map, "updatesequence", "CurrentUpdateSequence", params->pszVersion);
-    }
-    if (i > 0) { /* invalid */
-      msSetError(MS_WFSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", pszFunction, params->pszUpdateSequence, updatesequence);
-      /* locator must be NULL. See Table 25 of OWS 1.1 */
-      return msWFSExceptionNoLocator(map, "updatesequence", MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE, params->pszVersion);
-    }
-  }
-  
-  return MS_SUCCESS;
-}
-
-
-/*
-** msWFSGetCapabilitiesNegotiateVersion()
-*/
-static int msWFSGetCapabilitiesNegotiateVersion(mapObj *map, wfsParamsObj *wfsparams)
-{
-  int iVersion = -1;
-  char tmpString[OWS_VERSION_MAXLEN];
-
-  /* acceptversions: do OWS Common style of version negotiation */
-  if (wfsparams->pszAcceptVersions && strlen(wfsparams->pszAcceptVersions) > 0) {
-    char **tokens;
-    int i, j;
-
-    tokens = msStringSplit(wfsparams->pszAcceptVersions, ',', &j);
-    for (i=0; i<j; i++) {
-      iVersion = msOWSParseVersionString(tokens[i]);
-
-      if (iVersion < 0) {
-        msSetError(MS_WFSERR, "Invalid version format : %s.", "msWFSGetCapabilities()", tokens[i]);
-        msFreeCharArray(tokens, j);
-        return msWFSException(map, "acceptversions", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,NULL);
-      }
-
-      /* negotiate version */
-      iVersion = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions, wfsNumSupportedVersions);
-      if (iVersion != -1)
-        break;
-    }
-    msFreeCharArray(tokens, j);
-    if(iVersion == -1) {
-      msSetError(MS_WFSERR, "ACCEPTVERSIONS list (%s) does not match supported versions", "msWFSGetCapabilities()", wfsparams->pszAcceptVersions);
-      /* locator must be NULL. See Table 25 of OWS 1.1 */
-      return msWFSExceptionNoLocator(map, "acceptversions", MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED,NULL);
-    }
-  } else {
-    /* negotiate version */
-    int tmpInt;
-    iVersion = msOWSParseVersionString(wfsparams->pszVersion);
-    if( iVersion < 0 )
-    {
-        return msWFSException(map, "version", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, NULL);
-    }
-    tmpInt = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions, wfsNumSupportedVersions);
-    /* Old style negociation : paragraph D.11 of OWS 1.1.0 spec */
-    if( tmpInt < 0 )
-    {
-        int i;
-        for( i = 0 ; i < wfsNumSupportedVersions; i++ )
-        {
-            if( iVersion >= wfsSupportedVersions[i] )
-            {
-                iVersion = wfsSupportedVersions[i];
-                break;
-            }
-        }
-        if( i == wfsNumSupportedVersions )
-            iVersion = wfsSupportedVersions[wfsNumSupportedVersions - 1];
-    }
-  }
-
-  /* set result as string and carry on */
-  if (wfsparams->pszVersion)
-    msFree(wfsparams->pszVersion);
-  wfsparams->pszVersion = msStrdup(msOWSGetVersionString(iVersion, tmpString));
-
-  return MS_SUCCESS;
-}
-
-
-/*
-** msWFSGetCapabilities()
-*/
-int msWFSGetCapabilities(mapObj *map, wfsParamsObj *wfsparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  char *script_url=NULL, *script_url_encoded;
-  const char *updatesequence=NULL;
-  const char *wmtver=NULL;
-  char *formats_list;
-  int ret;
-  int iVersion;
-  int i=0;
-  
-  ret = msWFSGetCapabilitiesNegotiateVersion(map, wfsparams);
-  if( ret != MS_SUCCESS )
-      return ret;
-
-  iVersion = msOWSParseVersionString(wfsparams->pszVersion);
-  if( iVersion == OWS_2_0_0 )
-    return msWFSGetCapabilities20( map, wfsparams, req, ows_request);
-  if( iVersion == OWS_1_1_0 )
-    return msWFSGetCapabilities11( map, wfsparams, req, ows_request);
-
-  /* Decide which version we're going to return... only 1.0.0 for now */
-  wmtver = "1.0.0";
-
-  /* We need this server's onlineresource. */
-  if ((script_url=msOWSGetOnlineResource(map, "FO", "onlineresource", req)) == NULL ||
-      (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
-    msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities()");
-    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wmtver);
-  }
-  free(script_url);
-  script_url = NULL;
-
-  ret = msWFSHandleUpdateSequence(map, wfsparams, "msWFSGetCapabilities()");
-  if( ret != MS_SUCCESS )
-  {
-      free(script_url_encoded);
-      return ret;
-  }
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
-  msIO_printf("<WFS_Capabilities \n"
-              "   version=\"%s\" \n"
-              "   updateSequence=\"%s\" \n"
-              "   xmlns=\"http://www.opengis.net/wfs\" \n"
-              "   xmlns:ogc=\"http://www.opengis.net/ogc\" \n"
-              "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-              "   xsi:schemaLocation=\"http://www.opengis.net/wfs %s/wfs/%s/WFS-capabilities.xsd\">\n",
-              wmtver, updatesequence ? updatesequence : "0",
-              msOWSGetSchemasLocation(map), wmtver);
-
-  /*
-  ** SERVICE definition
-  */
-  msIO_printf("<Service>\n");
-  msIO_printf("  <Name>MapServer WFS</Name>\n");
-
-  /* the majority of this section is dependent on appropriately named metadata in the WEB object */
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "title",
-                           OWS_WARN, "  <Title>%s</Title>\n", map->name);
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "abstract",
-                           OWS_NOERR, "  <Abstract>%s</Abstract>\n", NULL);
-
-  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "FO",
-                               "keywordlist",
-                               "  <Keywords>\n", "  </Keywords>\n",
-                               "    %s\n", NULL);
-
-  /* Service/onlineresource */
-  /* Defaults to same as request onlineresource if wfs_service_onlineresource  */
-  /* is not set. */
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
-                           "FO", "service_onlineresource", OWS_NOERR,
-                           "  <OnlineResource>%s</OnlineResource>\n",
-                           script_url_encoded);
-
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "fees",
-                           OWS_NOERR, "  <Fees>%s</Fees>\n", NULL);
-
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO",
-                           "accessconstraints", OWS_NOERR,
-                           "  <AccessConstraints>%s</AccessConstraints>\n",
-                           NULL);
-
-  msIO_printf("</Service>\n\n");
-
-  /*
-  ** CAPABILITY definitions: list of supported requests
-  */
-
-  msIO_printf("<Capability>\n");
-
-  msIO_printf("  <Request>\n");
-  msWFSPrintRequestCap("GetCapabilities", script_url_encoded,
-                       NULL, NULL);
-  /* msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded, "SchemaDescriptionLanguage", "XMLSCHEMA", "SFE_XMLSCHEMA", NULL); */
-  /* msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat", "GML2", "GML3", NULL); */
-
-  /* don't advertise the GML3 or GML for SFE support */
-  if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE))
-    msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded, "SchemaDescriptionLanguage", "XMLSCHEMA" );
-
-  if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
-    formats_list = msWFSGetOutputFormatList( map, NULL, OWS_1_0_0 );
-    msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat", formats_list );
-    msFree( formats_list );
-  }
-
-  msIO_printf("  </Request>\n");
-  msIO_printf("</Capability>\n\n");
-
-  /*
-  ** FeatureTypeList: layers
-  */
-
-  msIO_printf("<FeatureTypeList>\n");
-
-  /* Operations supported... set default at top-level, and more operations */
-  /* can be added inside each layer... for MapServer only query is supported */
-  msIO_printf("  <Operations>\n");
-  msIO_printf("    <Query/>\n");
-  msIO_printf("  </Operations>\n");
-
-  for(i=0; i<map->numlayers; i++) {
-    layerObj *lp;
-    lp = GET_LAYER(map, i);
-
-    if (lp->status == MS_DELETE)
-      continue;
-
-    if (msWFSIsLayerAllowed(lp, ows_request)) {
-      msWFSDumpLayer(map, lp, script_url_encoded);
-    }
-  }
-
-  msIO_printf("</FeatureTypeList>\n\n");
-
-
-  /*
-  ** OGC Filter Capabilities ... for now we support only BBOX
-  */
-
-  msIO_printf("<ogc:Filter_Capabilities>\n");
-  msIO_printf("  <ogc:Spatial_Capabilities>\n");
-  msIO_printf("    <ogc:Spatial_Operators>\n");
-#ifdef USE_GEOS
-  msIO_printf("      <ogc:Equals/>\n");
-  msIO_printf("      <ogc:Disjoint/>\n");
-  msIO_printf("      <ogc:Touches/>\n");
-  msIO_printf("      <ogc:Within/>\n");
-  msIO_printf("      <ogc:Overlaps/>\n");
-  msIO_printf("      <ogc:Crosses/>\n");
-  msIO_printf("      <ogc:Intersect/>\n");
-  msIO_printf("      <ogc:Contains/>\n");
-  msIO_printf("      <ogc:DWithin/>\n");
-#endif
-  msIO_printf("      <ogc:BBOX/>\n");
-  msIO_printf("    </ogc:Spatial_Operators>\n");
-  msIO_printf("  </ogc:Spatial_Capabilities>\n");
-
-  msIO_printf("  <ogc:Scalar_Capabilities>\n");
-  msIO_printf("    <ogc:Logical_Operators />\n");
-  msIO_printf("    <ogc:Comparison_Operators>\n");
-  msIO_printf("      <ogc:Simple_Comparisons />\n");
-  msIO_printf("      <ogc:Like />\n");
-  msIO_printf("      <ogc:Between />\n");
-  msIO_printf("    </ogc:Comparison_Operators>\n");
-  msIO_printf("  </ogc:Scalar_Capabilities>\n");
-
-  msIO_printf("</ogc:Filter_Capabilities>\n\n");
-
-  /*
-  ** Done!
-  */
-  msIO_printf("</WFS_Capabilities>\n");
-
-  free(script_url_encoded);
-
-  return MS_SUCCESS;
-}
-
-/*
-** Helper functions for producing XML schema.
-*/
-
-static const char *msWFSGetGeometryType(const char *type, OWSGMLVersion outputformat)
-{
-  if(!type) return "GeometryPropertyType";
-
-  if(strcasecmp(type, "point") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-      case OWS_GML3:
-      case OWS_GML32:
-        return "PointPropertyType";
-    }
-  } else if(strcasecmp(type, "multipoint") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-      case OWS_GML3:
-      case OWS_GML32:
-        return "MultiPointPropertyType";
-    }
-  } else if(strcasecmp(type, "line") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "LineStringPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "CurvePropertyType";
-    }
-  } else if(strcasecmp(type, "multiline") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "MultiLineStringPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "MultiCurvePropertyType";
-    }
-  } else if(strcasecmp(type, "polygon") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "PolygonPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "SurfacePropertyType";
-    }
-  } else if(strcasecmp(type, "multipolygon") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "MultiPolygonPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "MultiSurfacePropertyType";
-    }
-  }
-
-  return "???unknown???";
-}
-
-static void msWFSWriteGeometryElement(FILE *stream, gmlGeometryListObj *geometryList, OWSGMLVersion outputformat, const char *tab)
-{
-  int i;
-  gmlGeometryObj *geometry=NULL;
-
-  if(!stream || !tab) return;
-  if(geometryList->numgeometries == 1 && strcasecmp(geometryList->geometries[0].name, "none") == 0) return;
-
-  if(geometryList->numgeometries == 1) {
-    geometry = &(geometryList->geometries[0]);
-    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"", tab, geometry->name, msWFSGetGeometryType(geometry->type, outputformat), geometry->occurmin);
-    if(geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
-      msIO_fprintf(stream, " maxOccurs=\"unbounded\"/>\n");
-    else
-      msIO_fprintf(stream, " maxOccurs=\"%d\"/>\n", geometry->occurmax);
-  } else {
-    msIO_fprintf(stream, "%s<choice>\n", tab);
-    for(i=0; i<geometryList->numgeometries; i++) {
-      geometry = &(geometryList->geometries[i]);
-
-      msIO_fprintf(stream, "  %s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"", tab, geometry->name, msWFSGetGeometryType(geometry->type, outputformat), geometry->occurmin);
-      if(geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
-        msIO_fprintf(stream, " maxOccurs=\"unbounded\"/>\n");
-      else
-        msIO_fprintf(stream, " maxOccurs=\"%d\"/>\n", geometry->occurmax);
-    }
-    msIO_fprintf(stream, "%s</choice>\n", tab);
-  }
-
-  return;
-}
-
-static OWSGMLVersion msWFSGetGMLVersionFromSchemaVersion(WFSSchemaVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_DEFAULT_SCHEMA:
-            return OWS_GML2;
-        case OWS_SFE_SCHEMA:
-            return OWS_GML3;
-        case OWS_GML32_SFE_SCHEMA:
-            return OWS_GML32;
-    }
-    return OWS_GML2;
-}
-
-static void msWFSSchemaWriteGeometryElement(FILE *stream, gmlGeometryListObj *geometryList, WFSSchemaVersion outputformat, const char *tab)
-{
-  OWSGMLVersion gmlversion = msWFSGetGMLVersionFromSchemaVersion(outputformat);
-  msWFSWriteGeometryElement(stream,geometryList,gmlversion,tab);
-}
-
-static const char* msWFSMapServTypeToXMLType(const char* type)
-{
-    const char *element_type = "string";
-    /* Map from MapServer types to XSD types */
-    if( strcasecmp(type,"Integer") == 0 )
-      element_type = "integer";
-    /* Note : xs:int and xs:integer differ */
-    else if ( EQUAL(type,"int") )
-      element_type = "int";
-    if( strcasecmp(type,"Long") == 0 ) /* 64bit integer */
-      element_type = "long";
-    else if( EQUAL(type,"Real") ||
-             EQUAL(type,"double") /* just in case someone provided the xsd type directly */ )
-      element_type = "double";
-    else if( EQUAL(type,"Character") )
-      element_type = "string";
-    else if( EQUAL(type,"Date") )
-      element_type = "date";
-    else if( EQUAL(type,"Time") )
-      element_type = "time";
-    else if( EQUAL(type,"DateTime") )
-      element_type = "dateTime";
-    else if( EQUAL(type,"Boolean") )
-      element_type = "boolean";
-    return element_type;
-}
-
-static void msWFSWriteItemElement(FILE *stream, gmlItemObj *item, const char *tab,
-                                  WFSSchemaVersion outputformat, int is_nillable)
-{
-  const char *element_name;
-  const char *element_type = "string";
-  const char *pszMinOccurs = "";
-  const char* pszNillable = "";
-
-  if(!stream || !item || !tab) return;
-  if(!item->visible) return; /* not exposing this attribute */
-  if(item->_template) return; /* can't adequately deal with templated items yet */
-
-  if(item->alias) /* TODO: what about name spaces embedded in the alias? */
-    element_name = item->alias;
-  else
-    element_name = item->name;
-
-  if(item->type)
-  {
-    if( outputformat == OWS_GML32_SFE_SCHEMA &&
-        (EQUAL(item->type,"Date") || EQUAL(item->type,"Time") || EQUAL(item->type,"DateTime")) )
-      element_type = "gml:TimeInstantType";
-    else
-      element_type = msWFSMapServTypeToXMLType(item->type);
-  }
-
-  if( item->minOccurs == 0 )
-      pszMinOccurs = " minOccurs=\"0\"";
-
-  if( is_nillable )
-      pszNillable = " nillable=\"true\"";
-
-  msIO_fprintf(stream, "%s<element name=\"%s\"%s%s type=\"%s\"/>\n", tab, element_name, pszMinOccurs, pszNillable, element_type);
-
-  return;
-}
-
-static void msWFSWriteConstantElement(FILE *stream, gmlConstantObj *constant, const char *tab)
-{
-  const char *element_type = "string";
-
-  if(!stream || !constant || !tab) return;
-
-  if(constant->type)
-    element_type = msWFSMapServTypeToXMLType(constant->type);
-
-  msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s\"/>\n", tab, constant->name, element_type);
-
-  return;
-}
-
-static void msWFSWriteGroupElement(FILE *stream, gmlGroupObj *group, const char *tab, const char *_namespace)
-{
-  if(group->type)
-    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%s\"/>\n", tab, group->name, _namespace, group->type);
-  else
-    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%sType\"/>\n", tab, group->name, _namespace, group->name);
-
-  return;
-}
-
-static void msWFSWriteGroupElementType(FILE *stream, gmlGroupObj *group,
-                                       gmlItemListObj *itemList,
-                                       gmlConstantListObj *constantList,
-                                       const char *tab,
-                                       WFSSchemaVersion outputformat)
-{
-  int i, j;
-  char *element_tab;
-
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
-
-  /* setup the element tab */
-  element_tab = (char *) msSmallMalloc(sizeof(char)*strlen(tab)+5);
-  sprintf(element_tab, "%s    ", tab);
-
-  if(group->type)
-    msIO_fprintf(stream, "%s<complexType name=\"%s\">\n", tab, group->type);
-  else
-    msIO_fprintf(stream, "%s<complexType name=\"%sType\">\n", tab, group->name);
-
-  msIO_fprintf(stream, "%s  <sequence>\n", tab);
-
-  /* now the items/constants (e.g. elements) in the group */
-  for(i=0; i<group->numitems; i++) {
-    for(j=0; j<constantList->numconstants; j++) { /* find the right gmlConstantObj */
-      constant = &(constantList->constants[j]);
-      if(strcasecmp(constant->name, group->items[i]) == 0) {
-        msWFSWriteConstantElement(stream, constant, element_tab);
-        break;
-      }
-    }
-    if(j != constantList->numconstants) continue; /* found this item */
-    for(j=0; j<itemList->numitems; j++) { /* find the right gmlItemObj */
-      item = &(itemList->items[j]);
-      if(strcasecmp(item->name, group->items[i]) == 0) {
-        msWFSWriteItemElement(stream, item, element_tab, outputformat, MS_FALSE);
-        break;
-      }
-    }
-  }
-
-  msIO_fprintf(stream, "%s  </sequence>\n", tab);
-  msIO_fprintf(stream, "%s</complexType>\n", tab);
-  free(element_tab);
-
-  return;
-}
-
-static const char* msWFSGetGMLSchemaLocation(OWSGMLVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_GML2:
-            return MS_OWSCOMMON_GML_212_SCHEMA_LOCATION;
-        case OWS_GML3:
-            return MS_OWSCOMMON_GML_311_SCHEMA_LOCATION;
-        case OWS_GML32:
-            return MS_OWSCOMMON_GML_321_SCHEMA_LOCATION;
-    }
-    return "/unknown.xsd";
-}
-
-static const char* msWFSGetGMLNamespaceURI(WFSSchemaVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_DEFAULT_SCHEMA:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_SFE_SCHEMA:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_GML32_SFE_SCHEMA:
-            return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
-    }
-    return "http://unknown";
-}
-
-static const char* msWFSGetGMLNamespaceURIFromGMLVersion(OWSGMLVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_GML2:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_GML3:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_GML32:
-            return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
-    }
-    return "http://unknown";
-}
-
-static void msWFS_NS_printf(const char* prefix, const char* uri)
-{
-    if( prefix == NULL )
-        msIO_printf("   xmlns=\"%s\"\n", uri);
-    else
-        msIO_printf("   xmlns:%s=\"%s\"\n", prefix, uri);
-}
-
-static void msWFSPrintAdditionalNamespaces(const gmlNamespaceListObj *namespaceList)
-{
-    int i;
-    /* any additional namespaces */
-    for(i=0; i<namespaceList->numnamespaces; i++) {
-      if(namespaceList->namespaces[i].uri) {
-        char *uri_encoded=NULL;
-
-        uri_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].uri);
-        msWFS_NS_printf(namespaceList->namespaces[i].prefix, uri_encoded);
-        msFree(uri_encoded);
-      }
-    }
-}
-
-static const char* msWFSStripNS(const char* name)
-{
-    const char* pszColon = strchr(name, ':');
-    const char* pszSlash = strchr(name, '/');
-    if( pszColon && (pszSlash == NULL || pszColon < pszSlash) )
-      return pszColon + 1;
-    return name;
-}
-
-/*
-** msWFSDescribeFeatureType()
-*/
-static
-int msWFSDescribeFeatureType(mapObj *map, wfsParamsObj *paramsObj, owsRequestObj *ows_request,
-                             int nWFSVersion)
-{
-  int i, numlayers=0;
-  char **layers = NULL;
-
-  const char *value;
-  const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
-  const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
-  char *user_namespace_uri_encoded = NULL;
-  const char *collection_name = OWS_WFS_FEATURE_COLLECTION_NAME;
-  char *encoded;
-
-  WFSSchemaVersion outputformat = OWS_DEFAULT_SCHEMA; /* default output is GML 2.1 compliant schema*/
-
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
-  char *mimetype = NULL;
-
-  if(paramsObj->pszTypeName && numlayers == 0) {
-    /* Parse comma-delimited list of type names (layers) */
-    layers = msStringSplit(paramsObj->pszTypeName, ',', &numlayers);
-    if (numlayers > 0) {
-      /* strip namespace if there is one :ex TYPENAME=cdf:Other */
-      for (i=0; i<numlayers; i++) {
-        char* pszTmp = msStrdup(msWFSStripNS(layers[i]));
-        free(layers[i]);
-        layers[i] = pszTmp;
-      }
-    }
-  }
-
-
-  if (paramsObj->pszOutputFormat) {
-    if(strcasecmp(paramsObj->pszOutputFormat, "XMLSCHEMA") == 0 ||
-        strstr(paramsObj->pszOutputFormat, "gml/2")!= NULL) {
-      mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/2.1.2");
-      outputformat = OWS_DEFAULT_SCHEMA;
-    } else if(strcasecmp(paramsObj->pszOutputFormat, "SFE_XMLSCHEMA") == 0 ||
-              strstr(paramsObj->pszOutputFormat, "gml/3.1")!= NULL) {
-      mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/3.1.1");
-      outputformat = OWS_SFE_SCHEMA;
-    } else if(strstr(paramsObj->pszOutputFormat, "gml/3.2")!= NULL ||
-              strstr(paramsObj->pszOutputFormat, "application/gml+xml; version=3.2")!= NULL) {
-      mimetype = msEncodeHTMLEntities("application/gml+xml; version=3.2");
-      outputformat = OWS_GML32_SFE_SCHEMA;
-    } else {
-      msSetError(MS_WFSERR, "Unsupported DescribeFeatureType outputFormat (%s).", "msWFSDescribeFeatureType()", paramsObj->pszOutputFormat);
-      if( layers )
-        msFreeCharArray(layers, numlayers);
-      msFree(mimetype);
-      return msWFSException(map, "outputformat", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-  }
-  /* If no outputFormat explicitely asked, use a sensible default for the WFS version */
-  else {
-    switch( nWFSVersion )
-    {
-        case OWS_1_0_0:
-        default:
-            mimetype = msEncodeHTMLEntities("text/xml"); /* ERO: why not "text/xml; subtype=gml/2.1.2" ? */
-            break;
-
-        case OWS_1_1_0:
-            mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/3.1.1");
-            outputformat = OWS_SFE_SCHEMA;
-            break;
-
-        case OWS_2_0_0:
-            mimetype = msEncodeHTMLEntities("application/gml+xml; version=3.2");
-            outputformat = OWS_GML32_SFE_SCHEMA;
-            break;
-     }
-  }
-
-  /* Validate layers */
-  if (numlayers > 0) {
-    for (i=0; i<numlayers; i++) {
-      layerObj* lp = msWFSGetLayerByName(map, ows_request, layers[i]);
-      if ( lp == NULL ) {
-        msSetError(MS_WFSERR, "Invalid typename (%s). A layer might be disabled for \
-this request. Check wfs/ows_enable_request settings.", "msWFSDescribeFeatureType()", layers[i]);/* paramsObj->pszTypeName); */
-        msFreeCharArray(layers, numlayers);
-        msFree(mimetype);
-        return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-      }
-    }
-  }
-
-  /*
-  ** retrieve any necessary external namespace/schema configuration information
-  */
-  namespaceList = msGMLGetNamespaces(&(map->web), "G");
-  if (namespaceList == NULL) {
-    msSetError(MS_MISCERR, "Unable to populate namespace list", "msWFSDescribeFeatureType()");
-    return MS_FAILURE;
-  }
-
-  /*
-  ** DescribeFeatureType response
-  */
-
-  msIO_setHeader("Content-Type","%s; charset=UTF-8",mimetype);
-  msIO_sendHeaders();
-
-  if (mimetype)
-    msFree(mimetype);
-
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value) user_namespace_uri = value;
-  user_namespace_uri_encoded = msEncodeHTMLEntities(user_namespace_uri);
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value) user_namespace_prefix = value;
-  if(user_namespace_prefix != NULL && msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", user_namespace_prefix);
-
-  msIO_printf("<schema\n"
-              "   targetNamespace=\"%s\" \n"
-              "   xmlns:%s=\"%s\" \n",
-              user_namespace_uri_encoded, user_namespace_prefix,  user_namespace_uri_encoded);
-  if( nWFSVersion < OWS_2_0_0 )
-    msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX, MS_OWSCOMMON_OGC_NAMESPACE_URI);
-  msWFS_NS_printf("xsd", MS_OWSCOMMON_W3C_XS_NAMESPACE_URI);
-  msWFS_NS_printf(NULL, MS_OWSCOMMON_W3C_XS_NAMESPACE_URI);
-  msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
-                  msWFSGetGMLNamespaceURI(outputformat) );
-
-  msWFSPrintAdditionalNamespaces(namespaceList);
-
-  msIO_printf("   elementFormDefault=\"qualified\" version=\"0.1\" >\n");
-
-  encoded = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-
-  msIO_printf("\n  <import namespace=\"%s\"\n"
-              "          schemaLocation=\"%s%s\" />\n",
-              msWFSGetGMLNamespaceURI(outputformat),
-              encoded,
-              msWFSGetGMLSchemaLocation(msWFSGetGMLVersionFromSchemaVersion(outputformat)));
-
-  msFree(encoded);
-
-  /* any additional namespace includes */
-  for(i=0; i<namespaceList->numnamespaces; i++) {
-    if(namespaceList->namespaces[i].uri && namespaceList->namespaces[i].schemalocation) {
-      char *schema_location_encoded=NULL, *uri_encoded=NULL;
-
-      uri_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].uri);
-      schema_location_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].schemalocation);
-      msIO_printf("\n  <import namespace=\"%s\"\n schemaLocation=\"%s\" />\n", uri_encoded, schema_location_encoded);
-      msFree(uri_encoded);
-      msFree(schema_location_encoded);
-    }
-  }
-
-  /* output definition for the default feature container, can't use wfs:FeatureCollection with GML3:
-     kept here so that the behaviour with wfs1.0 and gml3 output is preserved.
-     We can use the wfs:FeatureCollection for wfs1.1*/
-  if(outputformat == OWS_SFE_SCHEMA && nWFSVersion == OWS_1_0_0 ) {
-    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "feature_collection");
-    if(value) collection_name = value;
-
-    msIO_printf("  <element name=\"%s\" type=\"%s:%sType\" substitutionGroup=\"gml:_FeatureCollection\"/>\n", collection_name, user_namespace_prefix, collection_name);
-    msIO_printf("  <complexType name=\"%sType\">\n", collection_name);
-    msIO_printf("    <complexContent>\n");
-    msIO_printf("      <extension base=\"gml:AbstractFeatureCollectionType\">\n");
-    msIO_printf("        <attribute name=\"version\" type=\"string\" use=\"required\" fixed=\"1.0.0\"/>\n");
-    msIO_printf("      </extension>\n");
-    msIO_printf("    </complexContent>\n");
-    msIO_printf("  </complexType>\n");
-  }
-
-  /*
-  ** loop through layers
-  */
-  for(i=0; i<map->numlayers; i++)  {
-    layerObj *lp;
-    int j, bFound = 0;
-
-    lp = GET_LAYER(map, i);
-
-    for (j=0; j<numlayers && !bFound; j++) {
-      if ( lp->name && strcasecmp(lp->name, layers[j]) == 0)
-        bFound = 1;
-    }
-
-    if ((numlayers == 0 || bFound) && msWFSIsLayerAllowed(lp, ows_request) ) {
-
-      /*
-      ** OK, describe this layer IF you can open it and retrieve items
-      */
-      if (msLayerOpen(lp) == MS_SUCCESS) {
-        if (msLayerGetItems(lp) == MS_SUCCESS) {
-          int k;
-          gmlGroupListObj *groupList=NULL;
-          gmlItemListObj *itemList=NULL;
-          gmlConstantListObj *constantList=NULL;
-          gmlGeometryListObj *geometryList=NULL;
-          gmlItemObj *item=NULL;
-          gmlConstantObj *constant=NULL;
-          char *encoded_name = NULL;
-
-          const char *layer_namespace_prefix;
-          const char *substitution_group;
-          char *encoded_type=NULL;
-
-          itemList = msGMLGetItems(lp, "G"); /* GML-related metadata */
-          constantList = msGMLGetConstants(lp, "G");
-          groupList = msGMLGetGroups(lp, "G");
-          geometryList = msGMLGetGeometries(lp, "GFO", MS_TRUE);
-          if (itemList == NULL || constantList == NULL || groupList == NULL || geometryList == NULL) {
-            msSetError(MS_MISCERR, "Unable to populate item and group metadata structures", "msWFSDescribeFeatureType()");
-            return MS_FAILURE;
-          }
-
-          value = msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
-          if(value)
-            layer_namespace_prefix = value;
-          else
-            layer_namespace_prefix = user_namespace_prefix;
-
-          encoded_name = msEncodeHTMLEntities( lp->name );
-          value = msOWSLookupMetadata(&(lp->metadata), "F", "layer_type");
-          if(value) {
-            encoded_type = msEncodeHTMLEntities(value);
-          } else {
-            size_t sz = strlen(encoded_name) + strlen("Type") + 1;
-            encoded_type = (char*) msSmallMalloc(sz);
-            strlcpy(encoded_type, encoded_name, sz);
-            strlcat(encoded_type, "Type", sz);
-          }
-
-          switch(outputformat)
-          {
-            case OWS_DEFAULT_SCHEMA: /* default GML 2.1.x schema */
-            case OWS_SFE_SCHEMA: /* reference GML 3.1.1 schema */
-            default:
-                substitution_group = "gml:_Feature";
-                break;
-
-            case OWS_GML32_SFE_SCHEMA:  /* reference GML 3.2.1 schema */
-                substitution_group = "gml:AbstractFeature";
-                break;
-          }
-
-          msIO_printf("\n"
-                      "  <element name=\"%s\" \n"
-                      "           type=\"%s:%s\" \n"
-                      "           substitutionGroup=\"%s\" />\n\n",
-                      encoded_name, layer_namespace_prefix, encoded_type,
-                      substitution_group);
-          msFree(encoded_type);
-
-          if(strcmp(layer_namespace_prefix, user_namespace_prefix) != 0) {
-            msFree(encoded_name);
-            msGMLFreeItems(itemList);
-            msGMLFreeConstants(constantList);
-            msGMLFreeGroups(groupList);
-            msGMLFreeGeometries(geometryList);
-            continue; /* the rest is defined in an external schema */
-          }
-
-          msIO_printf("  <complexType name=\"%sType\">\n", encoded_name);
-          msIO_printf("    <complexContent>\n");
-          msIO_printf("      <extension base=\"gml:AbstractFeatureType\">\n");
-          msIO_printf("        <sequence>\n");
-
-          /* write the geometry schema element(s) */
-          msWFSSchemaWriteGeometryElement(stdout, geometryList, outputformat, "          ");
-
-          /* write the constant-based schema elements */
-          for(k=0; k<constantList->numconstants; k++) {
-            constant = &(constantList->constants[k]);
-            if(msItemInGroups(constant->name, groupList) == MS_FALSE)
-              msWFSWriteConstantElement(stdout, constant, "          ");
-          }
-
-          /* write the item-based schema elements */
-          for(k=0; k<itemList->numitems; k++) {
-            item = &(itemList->items[k]);
-            if(msItemInGroups(item->name, groupList) == MS_FALSE) {
-              int nillable = MS_FALSE;
-              char mdname[256];
-              const char* pszNillable;
-              snprintf(mdname, sizeof(mdname), "%s_nillable", item->name);
-              pszNillable = msOWSLookupMetadata(&(lp->metadata), "G", mdname);
-              if( pszNillable && strcasecmp(pszNillable, "true") == 0 )
-                  nillable = MS_TRUE;
-              msWFSWriteItemElement(stdout, item, "          ", outputformat, nillable);
-            }
-          }
-
-          for(k=0; k<groupList->numgroups; k++)
-            msWFSWriteGroupElement(stdout, &(groupList->groups[k]), "          ", user_namespace_prefix);
-
-          msIO_printf("        </sequence>\n");
-          msIO_printf("      </extension>\n");
-          msIO_printf("    </complexContent>\n");
-          msIO_printf("  </complexType>\n");
-
-          /* any group types */
-          for(k=0; k<groupList->numgroups; k++)
-            msWFSWriteGroupElementType(stdout, &(groupList->groups[k]), itemList, constantList, "  ", outputformat);
-
-          msGMLFreeItems(itemList);
-          msGMLFreeConstants(constantList);
-          msGMLFreeGroups(groupList);
-          msGMLFreeGeometries(geometryList);
-
-          msFree(encoded_name);
-        }
-
-        msLayerClose(lp);
-      } else {
-        msIO_printf("\n\n<!-- ERROR: Failed opening layer %s -->\n\n", lp->name);
-      }
-    }
-  }
-
-  /*
-  ** Done!
-  */
-  msIO_printf("\n</schema>\n");
-
-  msFree(user_namespace_uri_encoded);
-
-  if(layers)
-    msFreeCharArray(layers, numlayers);
-
-  msGMLFreeNamespaces(namespaceList);
-
-  return MS_SUCCESS;
-}
-
-/*
-** msWFSGetFeature_GMLPreamble()
-**
-** Generate the GML preamble up to the first feature for the builtin
-** WFS GML support.
-*/
-
-typedef struct {
-  const char *user_namespace_prefix;
-  const char *user_namespace_uri;
-  char       *user_namespace_uri_encoded;
-  const char *collection_name;
-  const char *_typename;
-  char       *script_url, *script_url_encoded;
-  const char *output_mime_type;
-  const char *output_schema_format;
-} WFSGMLInfo;
-
-
-static void msWFSPrintURLAndXMLEncoded(const char* str)
-{
-    char* url_encoded = msEncodeUrl(str);
-    char* xml_encoded = msEncodeHTMLEntities(url_encoded);
-    msIO_printf("%s", xml_encoded);
-    msFree(xml_encoded);
-    msFree(url_encoded);
-}
-
-static void msWFSGetFeature_PrintBasePrevNextURI(cgiRequestObj *req,
-                                                 WFSGMLInfo *gmlinfo,
-                                                 wfsParamsObj *paramsObj,
-                                                 const char* encoded_version,
-                                                 const char* encoded_typename,
-                                                 const char* encoded_mime_type)
-{
-    int i;
-    int bFirstArg = MS_TRUE;
-    msIO_printf("%s", gmlinfo->script_url_encoded);
-
-    if( req->postrequest != NULL )
-    {
-        msIO_printf("SERVICE=WFS&amp;VERSION=");
-        msIO_printf("%s", encoded_version);
-        msIO_printf("&amp;REQUEST=");
-        msIO_printf("%s", paramsObj->pszRequest);
-        msIO_printf("&amp;TYPENAMES=");
-        msIO_printf("%s", encoded_typename);
-        msIO_printf("&amp;OUTPUTFORMAT=");
-        msIO_printf("%s", encoded_mime_type);
-        if( paramsObj->pszBbox != NULL )
-        {
-            msIO_printf("&amp;BBOX=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszBbox);
-        }
-        if( paramsObj->pszSrs != NULL )
-        {
-            msIO_printf("&amp;SRSNAME=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszSrs);
-        }
-        if( paramsObj->pszFilter != NULL )
-        {
-            msIO_printf("&amp;FILTER=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszFilter);
-        }
-        if( paramsObj->pszPropertyName != NULL)
-        {
-            msIO_printf("&amp;PROPERTYNAME=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszPropertyName);
-        }
-        if( paramsObj->pszValueReference != NULL)
-        {
-            msIO_printf("&amp;VALUEREFERENCE=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszValueReference);
-        }
-        if( paramsObj->pszSortBy != NULL )
-        {
-            msIO_printf("&amp;SORTBY=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszSortBy);
-        }
-        if( paramsObj->nMaxFeatures >= 0 )
-            msIO_printf("&amp;COUNT=%d", paramsObj->nMaxFeatures);
-    }
-    else
-    {
-        for(i=0; i<req->NumParams; i++) {
-            if (req->ParamNames[i] && req->ParamValues[i] &&
-                strcasecmp(req->ParamNames[i], "MAP") != 0 &&
-                strcasecmp(req->ParamNames[i], "STARTINDEX") != 0 &&
-                strcasecmp(req->ParamNames[i], "RESULTTYPE") != 0) {
-                if( !bFirstArg )
-                    msIO_printf("&amp;");
-                bFirstArg = MS_FALSE;
-                msIO_printf("%s=", req->ParamNames[i]);
-                msWFSPrintURLAndXMLEncoded(req->ParamValues[i]);
-            }
-        }
-    }
-}
-
-
-static void msWFSGetFeature_GetTimeStamp(char* timestring, size_t timestringlen)
-{
-    struct tm *now;
-    time_t tim=time(NULL);
-
-    now=localtime(&tim);
-
-    snprintf(timestring, timestringlen, "%d-%02d-%02dT%02d:%02d:%02d",
-                now->tm_year+1900, now->tm_mon+1, now->tm_mday,
-                now->tm_hour, now->tm_min, now->tm_sec);
-}
-
-static int msWFSGetFeature_GMLPreamble( mapObj *map,
-                                        cgiRequestObj *req,
-                                        WFSGMLInfo *gmlinfo,
-                                        wfsParamsObj *paramsObj,
-                                        OWSGMLVersion outputformat,
-                                        int iResultTypeHits,
-                                        int iNumberOfFeatures,
-                                        int nMatchingFeatures,
-                                        int maxfeatures,
-                                        int bHasNextFeatures,
-                                        int nWFSVersion )
-
-{
-  const char *value;
-  char       *encoded_version, *encoded_typename, *encoded_schema;
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
-  char timestring[100];
-  timestring[0] = '\0';
-
-  namespaceList = msGMLGetNamespaces(&(map->web), "G");
-  if (namespaceList == NULL) {
-    msSetError(MS_MISCERR, "Unable to populate namespace list", "msWFSGetFeature_GMLPreamble()");
-    return MS_FAILURE;
-  }
-
-  /*
-  ** Establish script_url.
-  */
-
-  if ((gmlinfo->script_url=msOWSGetOnlineResource(map,"FO","onlineresource",req)) ==NULL ||
-      (gmlinfo->script_url_encoded = msEncodeHTMLEntities(gmlinfo->script_url)) == NULL) {
-    msSetError(MS_WFSERR, "Server URL not found", "msWFSGetFeature()");
-    msGMLFreeNamespaces(namespaceList);
-    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-  }
-
-  /*
-  ** Write encoding.
-  */
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value) gmlinfo->user_namespace_uri = value;
-  gmlinfo->user_namespace_uri_encoded =
-    msEncodeHTMLEntities(gmlinfo->user_namespace_uri);
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value) gmlinfo->user_namespace_prefix = value;
-
-  if(gmlinfo->user_namespace_prefix != NULL && msIsXMLTagValid(gmlinfo->user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", gmlinfo->user_namespace_prefix);
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "feature_collection");
-  if(value) gmlinfo->collection_name = value;
-
-  encoded_version = msEncodeHTMLEntities( paramsObj->pszVersion );
-  encoded_typename = msEncodeHTMLEntities( gmlinfo->_typename );
-  encoded_schema = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-
-  if( nWFSVersion >= OWS_2_0_0) {
-    int nNextStartIndex;
-    char* tmp;
-    char* encoded_mime_type;
-    int bAbleToPrintPreviousOrNext = MS_TRUE;
-
-    tmp = msEncodeUrl( gmlinfo->output_mime_type );
-    encoded_mime_type = msEncodeHTMLEntities( tmp );
-    msFree(tmp);
-
-    msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
-
-    if( strcasecmp(paramsObj->pszRequest, "GetFeature") == 0 )
-      msIO_printf("<wfs:FeatureCollection\n");
-    else
-      msIO_printf("<wfs:ValueCollection\n");
-
-    msWFS_NS_printf(gmlinfo->user_namespace_prefix,
-                    gmlinfo->user_namespace_uri_encoded);
-    msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
-                    msWFSGetGMLNamespaceURIFromGMLVersion(outputformat));
-    msWFS_NS_printf(MS_OWSCOMMON_WFS_NAMESPACE_PREFIX,
-                    MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
-    msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
-                    MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
-    msWFSPrintAdditionalNamespaces(namespaceList);
-
-    msIO_printf("   xsi:schemaLocation=\"%s %sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s "
-                                        "%s %s%s "
-                                        "%s %s%s\"\n",
-                gmlinfo->user_namespace_uri_encoded,
-                gmlinfo->script_url_encoded, encoded_version,
-                encoded_typename,
-                gmlinfo->output_schema_format,
-
-                MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
-                encoded_schema,
-                MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION,
-
-                msWFSGetGMLNamespaceURIFromGMLVersion(outputformat),
-                encoded_schema,
-                msWFSGetGMLSchemaLocation(outputformat));
-
-    msIO_printf("   timeStamp=\"%s\" numberMatched=\"", timestring);
-    if( nMatchingFeatures < 0 )
-    {
-        /* If we don't know the exact number, at least return something */
-        /* equivalent to what we would return with WFS 1.1, otherwise */
-        /* resultType=hits would not return anything usefull to the client. */
-        if( iResultTypeHits == MS_TRUE )
-            msIO_printf("%d", iNumberOfFeatures);
-        else
-            msIO_printf("unknown");
-    }
-    else
-        msIO_printf("%d", nMatchingFeatures);
-    msIO_printf("\" numberReturned=\"%d\"",
-                (iResultTypeHits == 1) ? 0 : iNumberOfFeatures);
-
-    /* TODO: in case of a multi-layer GetFeature POST, it is difficult to build a */
-    /* valid GET KVP GetFeature/GetPropertyValue when some options are specified. So for now just */
-    /* avoid those problematic cases */
-    if( req->postrequest != NULL && (paramsObj->bHasPostStoredQuery ||
-        (strchr(encoded_typename, ',') != NULL &&
-        (paramsObj->pszFilter != NULL || paramsObj->pszPropertyName != NULL ||
-         paramsObj->pszSortBy != NULL))) )
-    {
-        bAbleToPrintPreviousOrNext = MS_FALSE;
-    }
-
-    if( bAbleToPrintPreviousOrNext )
-    {
-        if( maxfeatures > 0 && 
-            iResultTypeHits != 1 && paramsObj->nStartIndex > 0 &&
-            ((nMatchingFeatures < 0  && iNumberOfFeatures > 0) ||
-             (nMatchingFeatures >= 0 && paramsObj->nStartIndex < nMatchingFeatures)) )
-        {
-            int nPrevStartIndex;
-
-            msIO_printf("\n");
-            msIO_printf("   previous=\"");
-            msWFSGetFeature_PrintBasePrevNextURI(req,gmlinfo, paramsObj,
-                                                encoded_version,
-                                                encoded_typename,
-                                                encoded_mime_type);
-
-            nPrevStartIndex = paramsObj->nStartIndex - maxfeatures;
-            if( nPrevStartIndex > 0 )
-                msIO_printf("&amp;STARTINDEX=%d", nPrevStartIndex);
-            msIO_printf("\"");
-        }
-
-        if( iResultTypeHits != 1 && paramsObj->nStartIndex >= 0 )
-            nNextStartIndex = paramsObj->nStartIndex;
-        else
-            nNextStartIndex = 0;
-        if( maxfeatures > 0 && (bHasNextFeatures || (nMatchingFeatures > 0 &&
-            (iResultTypeHits == 1 || iNumberOfFeatures + nNextStartIndex < nMatchingFeatures))) )
-        {
-            msIO_printf("\n");
-            msIO_printf("   next=\"");
-            msWFSGetFeature_PrintBasePrevNextURI(req,gmlinfo, paramsObj,
-                                                encoded_version,
-                                                encoded_typename,
-                                                encoded_mime_type);
-
-            if( iResultTypeHits != 1 )
-                nNextStartIndex += iNumberOfFeatures;
-
-            if( nNextStartIndex > 0 )
-                msIO_printf("&amp;STARTINDEX=%d", nNextStartIndex);
-            msIO_printf("\"");
-        }
-    }
-
-    msIO_printf(">\n");
-
-    msFree(encoded_mime_type);
-  }
-  /*
-  ** GML 2.x
-  */
-  else if(outputformat == OWS_GML2) { /* use a wfs:FeatureCollection */
-    msIO_printf("<wfs:FeatureCollection\n");
-    msWFS_NS_printf(gmlinfo->user_namespace_prefix,
-                    gmlinfo->user_namespace_uri_encoded);
-    msWFS_NS_printf(MS_OWSCOMMON_WFS_NAMESPACE_PREFIX,
-                    MS_OWSCOMMON_WFS_NAMESPACE_URI);
-    msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
-                    MS_OWSCOMMON_GML_NAMESPACE_URI);
-    msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
-                    MS_OWSCOMMON_OGC_NAMESPACE_URI);
-    msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
-                    MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
-    msWFSPrintAdditionalNamespaces(namespaceList);
-
-    /* FIXME ? : the schemaLocation will be only valid for WFS 1.0.0 */
-    msIO_printf("   xsi:schemaLocation=\"http://www.opengis.net/wfs %s/wfs/%s/WFS-basic.xsd \n"
-                "                       %s %sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s\">\n",
-                encoded_schema, encoded_version,
-                gmlinfo->user_namespace_uri_encoded,
-                gmlinfo->script_url_encoded, encoded_version,
-                encoded_typename, gmlinfo->output_schema_format);
-  }
-
-  /*
-  ** GML 3
-  */
-  else if( outputformat == OWS_GML3 ) {
-    if( nWFSVersion == OWS_1_1_0 ) {
-      msIO_printf("<wfs:FeatureCollection\n");
-      msWFS_NS_printf(gmlinfo->user_namespace_prefix,
-                      gmlinfo->user_namespace_uri_encoded);
-      msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
-                      MS_OWSCOMMON_GML_NAMESPACE_URI);
-      msWFS_NS_printf(MS_OWSCOMMON_WFS_NAMESPACE_PREFIX,
-                      MS_OWSCOMMON_WFS_NAMESPACE_URI);
-      msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
-                      MS_OWSCOMMON_OGC_NAMESPACE_URI);
-      msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
-                      MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
-    } else {
-      msIO_printf("<%s:%s\n"
-                  "   version=\"1.0.0\"\n",
-                  gmlinfo->user_namespace_prefix,
-                  gmlinfo->collection_name);
-      msWFS_NS_printf(gmlinfo->user_namespace_prefix,
-                      gmlinfo->user_namespace_uri_encoded);
-      msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
-                      MS_OWSCOMMON_GML_NAMESPACE_URI);
-      msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
-                      MS_OWSCOMMON_OGC_NAMESPACE_URI);
-      msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
-                      MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
-    }
-
-    msWFSPrintAdditionalNamespaces(namespaceList);
-
-    msIO_printf("   xsi:schemaLocation=\"%s %sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s",
-                gmlinfo->user_namespace_uri_encoded,
-                gmlinfo->script_url_encoded, encoded_version,
-                encoded_typename, gmlinfo->output_schema_format);
-
-    if( nWFSVersion == OWS_1_1_0 ) {
-
-      msIO_printf("  %s %s%s",
-                  MS_OWSCOMMON_WFS_NAMESPACE_URI,
-                  encoded_schema,
-                  MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION);
-
-      if (iResultTypeHits == 1) {
-        msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
-
-        msIO_printf("\" timeStamp=\"%s\" numberOfFeatures=\"%d",
-                    timestring, iNumberOfFeatures);
-      }
-    }
-    msIO_printf("\">\n");
-  }
-
-  msFree(encoded_version);
-  msFree(encoded_schema);
-  msFree(encoded_typename);
-
-  msGMLFreeNamespaces(namespaceList);
-
-  return MS_SUCCESS;
-}
-
-/*
-** msWFSGetFeature_GMLPostfix()
-**
-** Generate the GML file tail closing the collection and cleanup a bit.
-*/
-
-static int msWFSGetFeature_GMLPostfix( WFSGMLInfo *gmlinfo,
-                                       OWSGMLVersion outputformat,
-                                       int maxfeatures,
-                                       int iResultTypeHits,
-                                       int iNumberOfFeatures,
-                                       int nWFSVersion )
-
-{
-  if (((iNumberOfFeatures==0) || (maxfeatures == 0)) && iResultTypeHits == 0) {
-
-    if( nWFSVersion < OWS_2_0_0 )
-    {
-      msIO_printf("   <gml:boundedBy>\n");
-      if(outputformat == OWS_GML3 || outputformat == OWS_GML32 )
-        msIO_printf("      <gml:Null>missing</gml:Null>\n");
-      else
-        msIO_printf("      <gml:null>missing</gml:null>\n");
-      msIO_printf("   </gml:boundedBy>\n");
-    }
-  }
-
-  if(outputformat == OWS_GML2)
-    msIO_printf("</wfs:FeatureCollection>\n\n");
-  else {
-    if( nWFSVersion >= OWS_1_1_0 )
-      msIO_printf("</wfs:FeatureCollection>\n\n");
-    else
-      msIO_printf("</%s:%s>\n\n", gmlinfo->user_namespace_prefix, gmlinfo->collection_name);
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** msWFSBuildParamList()
-*/
-static void msWFSBuildParamList(char** ppszStrList, const char* pszValue,
-                                const char* pszSep)
-{
-    if (*ppszStrList == NULL)
-        *ppszStrList = msStrdup(pszValue);
-    else
-    {
-        char* pszTmp = msStrdup(*ppszStrList);
-        *ppszStrList =
-            (char *)msSmallRealloc(*ppszStrList,
-                                    sizeof(char)*
-                                    (strlen(pszTmp)+
-                                     strlen(pszSep)+
-                                     strlen(pszValue)+1));
-
-        sprintf(*ppszStrList,"%s%s%s",pszTmp,pszSep,pszValue);
-        free(pszTmp);
-    }
-}
-
-/*
-** msWFSTurnOffAllLayer()
-*/
-static void msWFSTurnOffAllLayer(mapObj* map)
-{
-    int j;
-    for(j=0; j<map->numlayers; j++) {
-      layerObj *lp;
-      lp = GET_LAYER(map, j);
-      lp->status = MS_OFF;
-    }
-}
-
-/*
-** msWFSRunFilter()
-*/
-static int msWFSRunFilter(mapObj* map,
-                          layerObj* lp,
-                          const wfsParamsObj *paramsObj,
-                          const char* pszFilter,
-                          int nWFSVersion)
-{
-    int layerWasOpened;
-    FilterEncodingNode *psNode = NULL;
-
-    psNode = FLTParseFilterEncoding(pszFilter);
-
-    if (!psNode) {
-        msSetError(MS_WFSERR,
-                   "Invalid or Unsupported FILTER in GetFeature : %s",
-                   "msWFSGetFeature()", pszFilter);
-        return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    /* Starting with WFS 1.1, we need to swap coordinates of BBOX or geometry */
-    /* parameters in some circumstances */
-    if( nWFSVersion >= OWS_1_1_0 )
-    {
-          int bDefaultSRSNeedsAxisSwapping = MS_FALSE;
-          char* srs;
-          msOWSGetEPSGProj(&(map->projection),&(map->web.metadata),"FO",MS_TRUE,&srs);
-          if (!srs)
-          {
-              msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &srs);
-          }
-          if ( srs && strncasecmp(srs, "EPSG:", 5) == 0 )
-          {
-              bDefaultSRSNeedsAxisSwapping = msIsAxisInverted(atoi(srs+5));
-          }
-          msFree(srs);
-          FLTDoAxisSwappingIfNecessary(map, psNode, bDefaultSRSNeedsAxisSwapping);
-    }
-
-    layerWasOpened = msLayerIsOpen(lp);
-    if( !layerWasOpened && msLayerOpen(lp) != MS_SUCCESS )
-    {
-        FLTFreeFilterEncodingNode( psNode );
-        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-    }
-
-    FLTProcessPropertyIsNull(psNode, map, lp->index);
-
-    /*preparse the filter for gml aliases*/
-    FLTPreParseFilterForAliasAndGroup(psNode, map, lp->index, "G");
-
-    /* Check that FeatureId filters are consistent with the active layer */
-    if( FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE)
-    {
-        FLTFreeFilterEncodingNode( psNode );
-        return msWFSException(map, "resourceid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    /* FIXME?: could probably apply to WFS 1.1 too */
-    if( nWFSVersion >= OWS_2_0_0 )
-    {
-        int nEvaluation;
-
-        if( FLTCheckInvalidOperand(psNode) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            return msWFSException(map, "filter", MS_WFS_ERROR_OPERATION_PROCESSING_FAILED, paramsObj->pszVersion);
-        }
-
-        if( FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-        }
-
-        psNode = FLTSimplify(psNode, &nEvaluation);
-        if( psNode == NULL )
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            if( nEvaluation == 1 ) {
-                /* return full layer */
-                return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
-            }
-            else {
-                /* return empty result set */
-                return MS_SUCCESS;
-            }
-        }
-
-    }
-
-    /* run filter.  If no results are found, do not throw exception */
-    /* this is a null result */
-    if( FLTApplyFilterToLayer(psNode, map, lp->index) != MS_SUCCESS ) {
-        errorObj* ms_error = msGetErrorObj();
-
-        if(ms_error->code != MS_NOTFOUND) {
-            msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed", "msWFSGetFeature()");
-            FLTFreeFilterEncodingNode( psNode );
-            return msWFSException(map, "mapserv", ( nWFSVersion >= OWS_2_0_0 ) ? MS_WFS_ERROR_OPERATION_PROCESSING_FAILED : MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-        }
-    }
-
-    FLTFreeFilterEncodingNode( psNode );
-
-    return MS_SUCCESS;
-}
-
-/*
-** msWFSRunBasicGetFeature()
-*/
-static int msWFSRunBasicGetFeature(mapObj* map,
-                                   layerObj* lp,
-                                   const wfsParamsObj *paramsObj,
-                                   int nWFSVersion)
-{
-    rectObj ext;
-    int status;
-    
-    map->query.type = MS_QUERY_BY_RECT; /* setup the query */
-    map->query.mode = MS_QUERY_MULTIPLE;
-    map->query.rect = map->extent;
-    map->query.layer = lp->index;
-
-    if( FLTLayerSetInvalidRectIfSupported(lp, &(map->query.rect)) )
-    {
-        /* do nothing */
-    }
-    else if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
-        char *pszMapSRS=NULL;
-        
-        /*if srsName was given for wfs 1.1.0, It is at this point loaded into the
-        map object and should be used*/
-        if(!paramsObj->pszSrs)
-          msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE, &pszMapSRS);
-
-        /* For a single point layer, to avoid numerical precision issues */
-        /* when reprojection is involved */
-        ext.minx -= 1e-5;
-        ext.miny -= 1e-5;
-        ext.maxx += 1e-5;
-        ext.maxy += 1e-5;
-
-        if (pszMapSRS != NULL && strncmp(pszMapSRS, "EPSG:", 5) == 0) {
-
-            if( nWFSVersion >= OWS_1_1_0 )
-                status = msLoadProjectionStringEPSG(&(map->projection), pszMapSRS);
-            else
-                status = msLoadProjectionString(&(map->projection), pszMapSRS);
-
-            if (status != 0) {
-                msSetError(MS_WFSERR, "msLoadProjectionString() failed: %s", "msWFSGetFeature()", pszMapSRS);
-                msFree(pszMapSRS);
-                return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-            }
-        }
-        msFree(pszMapSRS);
-
-        /*make sure that the layer projection is loaded.
-            It could come from a ows/wfs_srs metadata*/
-        if (lp->projection.numargs == 0) {
-            char *pszLayerSRS;
-            msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &pszLayerSRS);
-            if (pszLayerSRS) {
-                if (strncmp(pszLayerSRS, "EPSG:", 5) == 0) {
-                    if( nWFSVersion >= OWS_1_1_0 )
-                        msLoadProjectionStringEPSG(&(lp->projection), pszLayerSRS);
-                    else
-                        msLoadProjectionString(&(lp->projection), pszLayerSRS);
-                }
-            }
-            msFree(pszLayerSRS);
-        }
-
-        if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
-            msProjectRect(&lp->projection, &map->projection, &(ext));
-        }
-        map->query.rect = ext;
-    }
-
-    if(msQueryByRect(map) != MS_SUCCESS) {
-        errorObj   *ms_error;
-        ms_error = msGetErrorObj();
-
-        if(ms_error->code != MS_NOTFOUND) {
-            msSetError(MS_WFSERR, "ms_error->code not found", "msWFSGetFeature()");
-            return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-        }
-    }
-
-    return MS_SUCCESS;
-}
-
-
-/*
-** msWFSRetrieveFeatures()
-*/
-static int msWFSRetrieveFeatures(mapObj* map,
-                                 owsRequestObj* ows_request,
-                              const wfsParamsObj *paramsObj,
-                              const WFSGMLInfo* gmlinfo,
-                              const char* pszFilter,
-                              int bBBOXSet,
-                              const char* pszBBOXSRS,
-                              rectObj bbox,
-                              const char* pszFeatureId,
-                              char **layers,
-                              int numlayers,
-                              int maxfeatures,
-                              int nWFSVersion,
-                              int* pnOutTotalFeatures,
-                              int* pnHasNext)
-{
-  int i, j;
-  int iNumberOfFeatures = 0;
-
-  if (pszFilter && strlen(pszFilter) > 0) {
-    int nFilters;
-    char **paszFilter = NULL;
-
-    /* -------------------------------------------------------------------- */
-    /*      Validate the parameters. When a FILTER parameter is given,      */
-    /*      It needs the TYPENAME parameter for the layers. Also Filter     */
-    /*      is Mutually exclusive with FEATUREID and BBOX (see wfs specs    */
-    /*      1.0 section 13.7.3 on GetFeature)                               */
-    /*                                                                      */
-    /* -------------------------------------------------------------------- */
-
-    /* WFS 2.0 */
-    if (nWFSVersion >= OWS_2_0_0 &&
-        paramsObj->pszFilterLanguage != NULL &&
-        strcasecmp(paramsObj->pszFilterLanguage, "urn:ogc:def:query Language:OGC-FES:Filter") != 0) {
-      msSetError(MS_WFSERR,
-                 "Unhandled value for FILTER_LANGUAGE parameter. Only \"urn:ogc:def:query Language:OGC-FES:Filter\" accepted.",
-                 "msWFSGetFeature()");
-      return msWFSException(map, "filter_language", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    if (gmlinfo->_typename == NULL || strlen(gmlinfo->_typename) <= 0 || layers == NULL || numlayers <= 0) {
-      msSetError(MS_WFSERR,
-                 "Required %s parameter missing for GetFeature with a FILTER parameter.",
-                 "msWFSGetFeature()",
-                 (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
-      return msWFSException(map, (nWFSVersion >= OWS_2_0_0 ) ? "typenames": "typename",
-                            MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    if (bBBOXSet) {
-      msSetError(MS_WFSERR,
-                 "BBOX parameter and FILTER parameter are mutually exclusive in GetFeature.",
-                 "msWFSGetFeature()");
-      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-    }
-
-    if (pszFeatureId != NULL) {
-      msSetError(MS_WFSERR,
-                 "%s parameter and FILTER parameter are mutually exclusive in GetFeature.",
-                 "msWFSGetFeature()",
-                 (nWFSVersion < OWS_2_0_0 ) ? "FEATUREID" : "RESOURCEID" );
-      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-    }
-
-    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) == MS_FAILURE)
-        return msWFSException(map, "srsname", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-
-    /* -------------------------------------------------------------------- */
-    /*      Parse the Filter parameter. If there are several Filter         */
-    /*      parameters, each Filter is inside a parantheses. Eg :           */
-    /*      FILTER=(<Filter><Within><PropertyName>                          */
-    /*      INWATERA_1M/WKB_GEOM|INWATERA_1M/WKB_GEOM                       */
-    /*      <PropertyName><gml:Box><gml:coordinates>10,10 20,20</gml:coordinates>*/
-    /*      </gml:Box></Within></Filter>)(<Filter><Within><PropertyName>    */
-    /*      INWATERA_1M/WKB_GEOM<PropertyName><gml:Box><gml:coordinates>10,10*/
-    /*      20,20</gml:coordinates></gml:Box></Within></Filter>)            */
-    /* -------------------------------------------------------------------- */
-    nFilters = 0;
-    if (strlen(pszFilter) > 0 && pszFilter[0] == '(') {
-      paszFilter = FLTSplitFilters(pszFilter, &nFilters);
-    } else if (numlayers == 1) {
-      nFilters=1;
-      paszFilter = (char **)msSmallMalloc(sizeof(char *)*nFilters);
-      paszFilter[0] = msStrdup(pszFilter);
-    }
-
-    if (numlayers != nFilters) {
-      msSetError(MS_WFSERR, "Wrong number of filter elements, one filter must be specified for each feature type listed in the %s parameter.",
-                 "msWFSGetFeature()",
-                 (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
-      msFreeCharArray(paszFilter, nFilters);
-      return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      run through the filters and build the class expressions.        */
-    /* -------------------------------------------------------------------- */
-    for (i=0; i<nFilters; i++) {
-      int status;
-      layerObj* lp;
-
-      lp = msWFSGetLayerByName(map, ows_request, layers[i]);
-
-      /* Special value set when parsing XML Post when there is a mix of */
-      /* Query with and without Filter */
-      if( strcmp(paszFilter[i], "!") == 0 )
-        status = msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
-      else
-        status = msWFSRunFilter(map, lp, paramsObj, paszFilter[i], nWFSVersion);
-
-      if( status != MS_SUCCESS )
-      {
-          msFreeCharArray(paszFilter, nFilters);
-          return status;
-      }
-
-      /* Decrement the total maxfeatures */
-      if( map->query.maxfeatures >= 0 )
-      {
-          if( lp->resultcache && lp->resultcache->numresults > 0 )
-          {
-            map->query.maxfeatures -= lp->resultcache->numresults;
-            if( map->query.maxfeatures <= 0 )
-                break;
-          }
-      }
-    }
-
-    msFreeCharArray(paszFilter, nFilters);
-  }/* end if filter set */
-
-
-  if (pszFeatureId != NULL) {
-    char **tokens = NULL;
-    int nTokens = 0, j=0, k=0;
-    FilterEncodingNode *psNode = NULL;
-    char **aFIDLayers = NULL;
-    char **aFIDValues = NULL;
-    int iFIDLayers = 0;
-
-    /* Keep only selected layers, set to OFF by default. */
-    msWFSTurnOffAllLayer(map);
-
-    /*featureid can be a list INWATERA_1M.1234, INWATERA_1M.1235
-    We will keep all the feature id from the same layer together
-    so that an OR would be applied if several of them are present
-    */
-    tokens = msStringSplit(pszFeatureId, ',', &nTokens);
-    iFIDLayers = 0;
-    if (tokens && nTokens >=1) {
-      aFIDLayers = (char **)msSmallMalloc(sizeof(char *)*nTokens);
-      aFIDValues = (char **)msSmallMalloc(sizeof(char *)*nTokens);
-      for (j=0; j<nTokens; j++) {
-        aFIDLayers[j] = NULL;
-        aFIDValues[j] = NULL;
-      }
-      for (j=0; j<nTokens; j++) {
-        const char* pszLastDot = strrchr(tokens[j], '.');
-        if (pszLastDot != NULL) {
-          char* pszLayerInFID = msStrdup(tokens[j]);
-          pszLayerInFID[pszLastDot - tokens[j]] = '\0';
-          /* Find if the layer is already requested */
-          for (k=0; k<iFIDLayers; k++) {
-            if (strcasecmp(aFIDLayers[k], pszLayerInFID) == 0)
-              break;
-          }
-          /* If not, add it to the list of requested layers */
-          if (k == iFIDLayers) {
-            aFIDLayers[iFIDLayers] = msStrdup(pszLayerInFID);
-            iFIDLayers++;
-          }
-          /* Add the id to the list of search identifiers of the layer */
-          if (aFIDValues[k] != NULL)
-            aFIDValues[k] = msStringConcatenate(aFIDValues[k], ",");
-          aFIDValues[k] = msStringConcatenate( aFIDValues[k], pszLastDot + 1);
-          msFree(pszLayerInFID);
-        } else {
-          /* In WFS 20, an unknown/invalid feature id shouldn't trigger an */
-          /* exception. Tested by CITE */
-          if( nWFSVersion < OWS_2_0_0 ) {
-            msSetError(MS_WFSERR,
-                       "Invalid FeatureId in GetFeature. Expecting layername.value : %s",
-                       "msWFSGetFeature()", tokens[j]);
-            if (tokens)
-              msFreeCharArray(tokens, nTokens);
-            msFreeCharArray(aFIDLayers, iFIDLayers);
-            msFreeCharArray(aFIDValues, iFIDLayers);
-            return msWFSException(map, "featureid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-          }
-        }
-      }
-    }
-    if (tokens)
-      msFreeCharArray(tokens, nTokens);
-
-    /*turn on the layers and make sure projections are set properly*/
-    for (j=0; j< iFIDLayers; j++) {
-      layerObj *lp;
-      lp = msWFSGetLayerByName(map, ows_request, aFIDLayers[j]);
-      if( lp == NULL ) {
-        msSetError(MS_WFSERR,
-                   "Invalid typename given with FeatureId in GetFeature : %s. A layer might be disabled for \
-this request. Check wfs/ows_enable_request settings.", "msWFSGetFeature()",
-                   aFIDLayers[j]);
-
-        msFreeCharArray(aFIDLayers, iFIDLayers);
-        msFreeCharArray(aFIDValues, iFIDLayers);
-        return msWFSException(map, "featureid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-      }
-
-      lp->status = MS_ON;
-    }
-
-    if( map->query.only_cache_result_count == MS_FALSE )
-        msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, FALSE, NULL, NULL);
-
-    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) == MS_FAILURE)
-        return msWFSException(map, "srsname", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-
-    for (j=0; j< iFIDLayers; j++) {
-      layerObj *lp;
-      lp = msWFSGetLayerByName(map, ows_request, aFIDLayers[j]);
-      if (lp->_template == NULL) {
-        /* Force setting a template to enable query. */
-        lp->_template = msStrdup("ttt.html");
-      }
-      psNode = FLTCreateFeatureIdFilterEncoding(aFIDValues[j]);
-
-      if( FLTApplyFilterToLayer(psNode, map, lp->index) != MS_SUCCESS ) {
-        msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed", "msWFSGetFeature");
-        FLTFreeFilterEncodingNode( psNode );
-        msFreeCharArray(aFIDLayers, iFIDLayers);
-        msFreeCharArray(aFIDValues, iFIDLayers);
-        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-      }
-
-      FLTFreeFilterEncodingNode( psNode );
-      psNode = NULL;
-
-      /* Decrement the total maxfeatures */
-      if( map->query.maxfeatures >= 0 )
-      {
-          if( lp->resultcache && lp->resultcache->numresults > 0 )
-          {
-            map->query.maxfeatures -= lp->resultcache->numresults;
-            if( map->query.maxfeatures <= 0 )
-                break;
-          }
-      }
-    }
-
-    msFreeCharArray(aFIDLayers, iFIDLayers);
-    msFreeCharArray(aFIDValues, iFIDLayers);
-  }
-
-  /*
-  ** Perform Query (only BBOX for now)
-  */
-  /* __TODO__ Using a rectangle query may not be the most efficient way */
-  /* to do things here. */
-  if (pszFilter == NULL && pszFeatureId == NULL) {
-
-    /* Apply the requested SRS */
-    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) == MS_FAILURE)
-        return msWFSException(map, "srsname", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-
-    if (!bBBOXSet) {
-      for(j=0; j<map->numlayers; j++) {
-        layerObj *lp;
-        lp = GET_LAYER(map, j);
-        if (lp->status == MS_ON) {
-          int status = msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
-          if( status != MS_SUCCESS )
-              return status;
-        }
-      }
-    } else {
-
-      char* sBBoxSrs = NULL;
-
-      if( pszBBOXSRS != NULL )
-          sBBoxSrs = msStrdup(pszBBOXSRS);
-
-      /* On WFS 2.0.0, if the BBOX has no explicit SRS, use the map SRS */
-      /* Should likely be used for WFS 1.1.0 too, but don't want to cause */
-      /* issue at that point, since it can influence axis ordering */
-      if( nWFSVersion >= OWS_2_0_0 && sBBoxSrs == NULL )
-      {
-          projectionObj sProjTmp;
-
-          msInitProjection(&sProjTmp);
-          msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
-          msOWSGetEPSGProj(&sProjTmp,&(map->web.metadata),"FO",MS_TRUE, &sBBoxSrs);
-          msFreeProjection(&sProjTmp);
-      }
-
-      if (sBBoxSrs) {
-        int status;
-        projectionObj sProjTmp;
-
-        msInitProjection(&sProjTmp);
-        msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
-        /*do the axis order for now. It is unclear if the bbox are expected
-          ro respect the axis oder defined in the projectsion #3296*/
-
-        if(nWFSVersion >= OWS_1_1_0) {
-          if ((status=msLoadProjectionStringEPSG(&sProjTmp, sBBoxSrs)) == 0) {
-            msAxisNormalizePoints( &sProjTmp, 1, &bbox.minx, &bbox.miny );
-            msAxisNormalizePoints( &sProjTmp, 1, &bbox.maxx, &bbox.maxy );
-          }
-        } else
-          status = msLoadProjectionString(&sProjTmp, sBBoxSrs);
-
-        if (status == 0 &&  map->projection.numargs > 0)
-          msProjectRect(&sProjTmp, &map->projection, &bbox);
-        msFreeProjection(&sProjTmp);
-
-        msFree(sBBoxSrs);
-        sBBoxSrs = NULL;
-      }
-      map->query.type = MS_QUERY_BY_RECT; /* setup the query */
-      map->query.mode = MS_QUERY_MULTIPLE;
-      map->query.rect = bbox;
-
-      /*
-        Retaining this block of code in case we want to setup a rendering path through
-        the query code at some point.
-      */
-      /* if(map->outputformat && MS_DRIVER_MVT(map->outputformat)) {
-        const char *mvt_buffer = msGetOutputFormatOption(map->outputformat, "EDGE_BUFFER", "10");
-        int buffer = MS_ABS(atoi(mvt_buffer));
-        double res = (bbox.maxx - bbox.minx)/(double)map->width;
-        bbox.minx -= buffer * res;
-        bbox.maxx += buffer * res;
-        res = (bbox.maxy - bbox.miny)/(double)map->height;
-        bbox.miny -= buffer * res;
-        bbox.maxy += buffer * res;
-        map->width += buffer*2;
-        map->height += buffer*2;
-        msCalculateScale(bbox,map->units,map->width,map->height, map->resolution, &map->scaledenom);
-        map->query.rect = bbox;
-      } */
-
-      if(msQueryByRect(map) != MS_SUCCESS) {
-        errorObj   *ms_error;
-        ms_error = msGetErrorObj();
-
-        if(ms_error->code != MS_NOTFOUND) {
-          msSetError(MS_WFSERR, "ms_error->code not found", "msWFSGetFeature()");
-          return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-        }
-      }
-    }
-  }
-
-  /* Count total number of features retrieved */
-  for(j=0; j<map->numlayers; j++) {
-    if (GET_LAYER(map, j)->resultcache && GET_LAYER(map, j)->resultcache->numresults > 0) {
-      iNumberOfFeatures += GET_LAYER(map, j)->resultcache->numresults;
-    }
-  }
-
-  /* If maxfeatures is set, we have actually asked for 1 more feature than asked */
-  /* to be able to know if there are next features. So it is now time to */
-  /* remove this extra unasked feature from the result cache */
-  if( maxfeatures >= 0 && iNumberOfFeatures == maxfeatures + 1 )
-  {
-      int lastJ = -1;
-      for(j=0; j<map->numlayers; j++) {
-          if (GET_LAYER(map, j)->resultcache && GET_LAYER(map, j)->resultcache->numresults > 0) {
-              lastJ = j;
-          }
-      }
-      GET_LAYER(map, lastJ)->resultcache->numresults --;
-      GET_LAYER(map, lastJ)->resultcache->bounds = GET_LAYER(map, lastJ)->resultcache->previousBounds;
-      iNumberOfFeatures --;
-      if( pnHasNext )
-          *pnHasNext = MS_TRUE;
-  }
-  else if( pnHasNext )
-      *pnHasNext = MS_FALSE;
-  
-  *pnOutTotalFeatures = iNumberOfFeatures;
-
-  return MS_SUCCESS;
-}
-
-/*
-** msWFSParsePropertyNameOrSortBy()
-*/
-static char** msWFSParsePropertyNameOrSortBy(const char* pszPropertyName,
-                                             int numlayers)
-{
-    char** tokens = NULL;
-    int nPropertyNames = 0;
-    char** papszPropertyName = NULL;
-    int i;
-
-    if( pszPropertyName == NULL )
-    {
-        papszPropertyName = (char **)msSmallMalloc(sizeof(char *)*numlayers);
-        for (i=0; i<numlayers; i++) {
-            papszPropertyName[i] = msStrdup("!");
-        }
-        return papszPropertyName;
-    }
-
-    if (!(pszPropertyName[0] == '(' || numlayers == 1))
-    {
-        return NULL;
-    }
-
-    if (numlayers == 1 && pszPropertyName[0] != '(') {
-        /* Accept PROPERTYNAME without () when there is a single TYPENAME */
-        std::string osTmpPropertyName;
-        osTmpPropertyName = '(';
-        osTmpPropertyName += pszPropertyName;
-        osTmpPropertyName += ')';
-        tokens = msStringSplit(osTmpPropertyName.c_str()+1, '(', &nPropertyNames);
-    } else
-        tokens = msStringSplit(pszPropertyName+1, '(', &nPropertyNames);
-
-    /*expecting to always have a list of property names equal to
-        the number of layers(typename)*/
-    if (nPropertyNames != numlayers) {
-        msFreeCharArray(tokens, nPropertyNames);
-        return NULL;
-    }
-
-    papszPropertyName = (char **)msSmallMalloc(sizeof(char *)*nPropertyNames);
-    for (i=0; i<nPropertyNames; i++) {
-        if (strlen(tokens[i]) > 0) {
-            papszPropertyName[i] = msStrdup(tokens[i]);
-            /* remove trailing ) */
-            papszPropertyName[i][strlen(papszPropertyName[i])-1] = '\0';
-        }
-        else {
-            for ( i--; i>=0; i-- )
-                msFree(papszPropertyName[i]);
-            msFree(papszPropertyName);
-            msFreeCharArray(tokens, nPropertyNames);
-            return NULL;
-        }
-    }
-
-    msFreeCharArray(tokens, nPropertyNames);
-
-    return papszPropertyName;
-}
-
-static void msWFSInitGMLInfo(WFSGMLInfo* pgmlinfo)
-{
-  memset( pgmlinfo, 0, sizeof(WFSGMLInfo) );
-  pgmlinfo->user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
-  pgmlinfo->user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
-  pgmlinfo->collection_name = OWS_WFS_FEATURE_COLLECTION_NAME;
-  pgmlinfo->_typename = "";
-  pgmlinfo->output_mime_type = "text/xml";
-  pgmlinfo->output_schema_format = "XMLSCHEMA";
-}
-
-static void msWFSCleanupGMLInfo(WFSGMLInfo* pgmlinfo)
-{
-  free(pgmlinfo->script_url);
-  free(pgmlinfo->script_url_encoded);
-  msFree(pgmlinfo->user_namespace_uri_encoded);
-}
-
-static int msWFSGetGMLOutputFormat( wfsParamsObj *paramsObj,
-                                    WFSGMLInfo* pgmlinfo,
-                                    int nWFSVersion)
-{
-  OWSGMLVersion outputformat = OWS_GML2;
-
-  /* Validate outputformat */
-  if (paramsObj->pszOutputFormat) {
-    /* We support GML2, GML3, GML3.2 for now. */
-    if(strcasecmp(paramsObj->pszOutputFormat, "GML2") == 0 ||
-       strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/2.1.2") == 0) {
-      outputformat = OWS_GML2;
-      pgmlinfo->output_schema_format = "XMLSCHEMA";
-    /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE WFS 2.0 */
-      pgmlinfo->output_mime_type = "text/xml; subtype=gml/2.1.2";
-    } else if(strcasecmp(paramsObj->pszOutputFormat, "GML3") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/3.1.1") == 0) {
-      outputformat = OWS_GML3;
-      pgmlinfo->output_schema_format = "SFE_XMLSCHEMA";
-      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE WFS 2.0 */
-      pgmlinfo->output_mime_type = "text/xml; subtype=gml/3.1.1";
-    } else if(strcasecmp(paramsObj->pszOutputFormat, "GML32") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/3.2.1") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=\"gml/3.2.1\"") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "application/gml+xml; version=3.2") == 0) {
-      outputformat = OWS_GML32;
-      pgmlinfo->output_schema_format = "application%2Fgml%2Bxml%3B%20version%3D3.2";
-      pgmlinfo->output_mime_type = "text/xml; subtype=\"gml/3.2.1\"";
-    } else {
-      return -1;
-    }
-
-    /* If OUTPUTFORMAT not set, default to gml */
-  } else {
-    /*set the output format using the version if available*/
-    if( nWFSVersion == OWS_1_1_0 ) {
-      outputformat = OWS_GML3;
-      pgmlinfo->output_schema_format = "text/xml;%20subtype=gml/3.1.1";
-      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE WFS 2.0 */
-      pgmlinfo->output_mime_type = "text/xml; subtype=gml/3.1.1";
-    }
-    else if( nWFSVersion >= OWS_2_0_0 ) {
-      outputformat = OWS_GML32;
-      pgmlinfo->output_schema_format = "application%2Fgml%2Bxml%3B%20version%3D3.2";
-      pgmlinfo->output_mime_type = "text/xml; subtype=\"gml/3.2.1\"";
-    }
-  }
-
-  if( nWFSVersion == OWS_1_0_0 ) {
-    pgmlinfo->output_mime_type = "text/xml";
-  }
-
-  return outputformat;
-}
-
-static outputFormatObj* msWFSGetOtherOutputFormat(mapObj *map, wfsParamsObj *paramsObj)
-{
-  const char *format_list;
-  hashTableObj *md;
-  outputFormatObj* psFormat = NULL;
-  int j;
-
-  /* validate selected format against all selected layers. */
-  for(j=0; j < map->numlayers; j++) {
-    layerObj *lp;
-
-    lp = GET_LAYER(map, j);
-
-    if( lp->status != MS_ON )
-        continue;
-
-    md = &(lp->metadata);
-    format_list = msOWSLookupMetadata(md, "F","getfeature_formatlist");
-    if( format_list == NULL ) {
-        md = &(map->web.metadata);
-        format_list = msOWSLookupMetadata(md, "F","getfeature_formatlist");
-    }
-    if (format_list) {
-        psFormat = msOwsIsOutputFormatValid(
-                    map, paramsObj->pszOutputFormat, md,
-                    "F", "getfeature_formatlist");
-    }
-    if (psFormat == NULL) {
-        msSetError(MS_WFSERR,
-                    "'%s' is not a permitted output format for layer '%s', review wfs_getfeature_formatlist setting.",
-                    "msWFSGetFeature()",
-                    paramsObj->pszOutputFormat,
-                    lp->name );
-        return NULL;
-    }
-
-    if( psFormat->imagemode != MS_IMAGEMODE_FEATURE ) {
-        msSetError(MS_WFSERR,
-                    "OUTPUTFORMAT '%s' does not have IMAGEMODE FEATURE, and is not permitted for WFS output.",
-                    "msWFSGetFeature()",
-                    paramsObj->pszOutputFormat );
-        return NULL;
-    }
-  }
-  
-  return psFormat;
-}
-
-static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map, const wfsParamsObj *paramsObj,
-                                                  int bIsHits,
-                                                  int *pmaxfeatures, int* pstartindex)
-{
-  const char *tmpmaxfeatures = NULL;
-  int   maxfeatures=-1,startindex=-1;
-  int j;
-
-  int nQueriedLayers=0;
-  layerObj *lpQueried=NULL;
-
-  tmpmaxfeatures = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
-  if (tmpmaxfeatures)
-    maxfeatures = atoi(tmpmaxfeatures);
-
-  if( bIsHits )
-  {
-    const char* ignoreMaxFeaturesForHits =
-        msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures_ignore_for_resulttype_hits");
-
-    /* For PostGIS where we have an efficient implementation of hits, default to true */
-    if( ignoreMaxFeaturesForHits == NULL )
-    {
-        int bHasEfficientHits = MS_TRUE;
-        for(j=0; j<map->numlayers; j++) {
-            layerObj *lp;
-            lp = GET_LAYER(map, j);
-            if (lp->status == MS_ON) {
-                if( lp->connectiontype != MS_POSTGIS )
-                {
-                    bHasEfficientHits = MS_FALSE;
-                    break;
-                }
-            }
-        }
-
-        if (bHasEfficientHits )
-            ignoreMaxFeaturesForHits = "true";
-    }
-
-    if( ignoreMaxFeaturesForHits != NULL && strcasecmp(ignoreMaxFeaturesForHits, "true") == 0 )
-        maxfeatures = -1;
-  }
-
-  if (paramsObj->nMaxFeatures >= 0) {
-    if (maxfeatures < 0 || (maxfeatures > 0 && paramsObj->nMaxFeatures < maxfeatures))
-      maxfeatures = paramsObj->nMaxFeatures;
-  }
-
-  nQueriedLayers=0;
-  for(j=0; j<map->numlayers; j++) {
-    layerObj *lp;
-    lp = GET_LAYER(map, j);
-    if (lp->status == MS_ON) {
-      /* No reason to handle tolerances for WFS GetFeature */
-      lp->tolerance = 0;
-      lpQueried = GET_LAYER(map, j);
-      nQueriedLayers++;
-    }
-  }
-
-  /* WFS convention is that STARTINDEX=0 means the first feature, whereas */
-  /* in MapServer internals we used another interpretation with STARTINDEX=1 */
-  /* being the first index. This was before that the SWG WFS clarified things */
-  /* hence the mess. Ultimately we should likely fix our internals to avoid */
-  /* possible confusion */
-  if (paramsObj->nStartIndex >= 0) {
-    startindex = 1 + paramsObj->nStartIndex;
-    map->query.startindex = startindex;    
-  } 
-
-
-  /* maxfeatures set */
-  if (maxfeatures >= 0) {
-    int extrafeature = 1;
-    for(j=0; j<map->numlayers; j++) {
-      layerObj *lp;
-      lp = GET_LAYER(map, j);
-      if (lp->status == MS_ON) {
-        /*over-ride the value only if it is unset or wfs maxfeatures is
-          lower that what is currently set*/
-        if (lp->maxfeatures <=0 || (lp->maxfeatures > 0 && maxfeatures < lp->maxfeatures))
-        {
-          /* TODO: We don't handle DESC sorting, as it would mean to be */
-          /* able to evict the first property, which mapquery cannot handle */
-          /* This would have impact on the resultcache.bounds */
-          if( lp->sortBy.nProperties > 0 )
-          {
-            int k;
-            int countDesc = 1;
-            for(k=0;k<lp->sortBy.nProperties;k++)
-            {
-                if( lp->sortBy.properties[k].sortOrder == SORT_DESC )
-                    countDesc ++;
-            }
-            if( countDesc > 0 )
-                extrafeature = 0;
-          }
-
-          /* + 1 to be able to detect if there are more features for a next request */
-          lp->maxfeatures = maxfeatures + extrafeature;
-        }
-      }
-    }
-    /* + 1 to be able to detect if there are more features for a next request */
-    map->query.maxfeatures = maxfeatures + extrafeature;
-  }
-
-  /* startindex set */
-  if (startindex > 0 && nQueriedLayers > 1) {
-    for(j=0; j<map->numlayers; j++) {
-      layerObj *lp;
-      lp = GET_LAYER(map, j);
-      if (lp->status == MS_ON) {
-        msLayerEnablePaging(lp, MS_FALSE);
-      }
-    }
-  } else if (startindex > 0 && lpQueried) {
-    lpQueried->startindex = startindex;    
-  }
-
-  if( pmaxfeatures )
-    *pmaxfeatures = maxfeatures;
-  if( pstartindex )
-    *pstartindex = startindex;
-}
-
-static int msWFSAnalyzeBBOX(mapObj *map, wfsParamsObj *paramsObj,
-                            rectObj* pbbox, char** pszBBoxSRS)
-{
-  /* Default filter is map extents */
-  *pbbox = map->extent;
-
-  if (paramsObj->pszBbox) {
-    char **tokens;
-    int n;
-
-    tokens = msStringSplit(paramsObj->pszBbox, ',', &n);
-    if (tokens==NULL || (n != 4 && n !=5)) {
-      msSetError(MS_WFSERR, "Wrong number of arguments for BBOX.", "msWFSGetFeature()");
-      msFreeCharArray(tokens, n);
-      return msWFSException(map, "bbox", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-    pbbox->minx = atof(tokens[0]);
-    pbbox->miny = atof(tokens[1]);
-    pbbox->maxx = atof(tokens[2]);
-    pbbox->maxy = atof(tokens[3]);
-    /*5th aregument is assumed to be projection*/
-    if (n == 5)
-      *pszBBoxSRS = msStrdup(tokens[4]);
-
-    msFreeCharArray(tokens, n);
-  }
-  return 0;
-}
-
-static int msWFSComputeMatchingFeatures(mapObj *map,
-                                        owsRequestObj *ows_request,
-                                        wfsParamsObj *paramsObj,
-                                        int iNumberOfFeatures,
-                                        int maxfeatures,
-                                        WFSGMLInfo* pgmlinfo,
-                                        rectObj bbox,
-                                        const char* sBBoxSrs,
-                                        char** layers,
-                                        int numlayers,
-                                        int nWFSVersion)
-{
-  int nMatchingFeatures = -1;
-
-  if( nWFSVersion >= OWS_2_0_0 )
-  {
-    /* If no features have been retrived and there was no feature count limit, then */
-    /* it is obvious. We must test maxfeatures because if startindex is defined, */
-    /* and above the number of matched features, iNumberOfFeatures can be 0. */
-    if( iNumberOfFeatures == 0 && maxfeatures < 0 )
-    {
-        nMatchingFeatures = 0;
-    }
-
-    /* In the case we had limited the query by a maximum number of features, and */
-    /* that the query has returned less features than the limit, or if there was */
-    /* no limit in fature count, we are able to determine the number of matching */
-    /* features */
-    else if( iNumberOfFeatures > 0 && (maxfeatures < 0 || iNumberOfFeatures < maxfeatures) )
-    {
-        if( paramsObj->nStartIndex >= 0 )
-            nMatchingFeatures = iNumberOfFeatures + paramsObj->nStartIndex;
-        else
-            nMatchingFeatures = iNumberOfFeatures;
-    }
-
-    /* Otherwise big hammer ! */
-    else
-    {
-        /* The WFS 2.0 spec is not really clear on numberMatched behaviour */
-        /* and there are interesting logic in server implementations. */
-        /* */
-        /* Deegree (http://deegree3-demo.deegree.org:80/inspire-workspace/services/wfs?) */
-        /* will return numberMatched="19005" on the cp:CadastralParcel layer for a */
-        /* resultType=hits request, whereas the server limitation is set to 15000 */
-        /* But on a regular GetFeature (without count specified), it will return */
-        /* numberMatched="15000" (and numberReturned="15000")) */
-        /* */
-        /* GeoServer 2.4.1 will also ignore its server limitation for a resultType=hits */
-        /* but when using a regular GetFeature (without count specified), il will return */
-        /* numberMatched=numberReturned=total_number_of_features_without_taking_into_account_server_limit */
-        /* but the number of actually returned features will be truncated to the server */
-        /* limit, likely a bug */
-        /* */
-        /* If wfs_compute_number_matched is set to TRUE, we will issue a full */
-        /* count of potentially matching features, ignoring any client or server */
-        /* side limits. */
-
-        const char* pszComputeNumberMatched =
-                msOWSLookupMetadata(&(map->web.metadata), "F",
-                                                "compute_number_matched");
-        if( pszComputeNumberMatched != NULL &&
-            strcasecmp(pszComputeNumberMatched, "true") == 0 )
-        {
-            int j;
-            mapObj* mapTmp = (mapObj*)msSmallCalloc(1, sizeof(mapObj));
-            initMap(mapTmp);
-            msCopyMap(mapTmp, map);
-
-            /* Re-run the query but with no limit */
-            mapTmp->query.maxfeatures = -1;
-            mapTmp->query.startindex = -1;
-            mapTmp->query.only_cache_result_count = MS_TRUE;
-            for(j=0; j<mapTmp->numlayers; j++) {
-                layerObj* lp = GET_LAYER(mapTmp, j);
-                /* Reset layer paging */
-                lp->maxfeatures = -1;
-                lp->startindex = -1;
-            }
-
-            nMatchingFeatures = 0;
-            msWFSRetrieveFeatures(mapTmp,
-                                  ows_request,
-                                paramsObj,
-                                pgmlinfo,
-                                paramsObj->pszFilter,
-                                paramsObj->pszBbox != NULL,
-                                sBBoxSrs,
-                                bbox,
-                                paramsObj->pszFeatureId,
-                                layers,
-                                numlayers,
-                                -1,
-                                nWFSVersion,
-                                &nMatchingFeatures,
-                                NULL);
-
-            msFreeMap(mapTmp);
-        }
-    }
-  }
-
-  return nMatchingFeatures;
-}
-
-static int msWFSResolveStoredQuery(mapObj *map, wfsParamsObj *paramsObj, cgiRequestObj *req)
-{
-  if (paramsObj->pszStoredQueryId != NULL )
-  {
-      int i;
-      int status;
-      hashTableObj* hashTable = msCreateHashTable();
-      char* pszResolvedQuery;
-
-      if (req->NumParams > 0 && req->postrequest == NULL ) {
-        for(i=0; i<req->NumParams; i++) {
-            if (req->ParamNames[i] && req->ParamValues[i]) {
-                msInsertHashTable(hashTable, req->ParamNames[i], req->ParamValues[i]);
-            }
-        }
-      }
-
-      pszResolvedQuery = msWFSGetResolvedStoredQuery20(map, paramsObj,
-                                                       paramsObj->pszStoredQueryId,
-                                                       hashTable);
-      msFreeHashTable(hashTable);
-
-      if( pszResolvedQuery == NULL )
-          return MS_FAILURE;
-
-      status = msWFSAnalyzeStoredQuery(map, paramsObj,
-                                       paramsObj->pszStoredQueryId,
-                                       pszResolvedQuery);
-      msFree(pszResolvedQuery);
-
-      if( status != MS_SUCCESS )
-          return status;
-      
-      msWFSSimplifyPropertyNameAndFilter(paramsObj);
-  }
-  return MS_SUCCESS;
-}
-
-/*
-** msWFSUnaliasItem()
-*/
-static
-const char* msWFSUnaliasItem(layerObj* lp, const char* name)
-{
-    const char* pszFullName;
-    char szTmp[256];
-    int z;
-    for(z=0; z<lp->numitems; z++) {
-        if (!lp->items[z] || strlen(lp->items[z]) <= 0)
-            continue;
-        snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[z]);
-        pszFullName = msOWSLookupMetadata(&(lp->metadata), "G", szTmp);
-        if (pszFullName && strcmp(name, pszFullName) == 0)
-            return lp->items[z];
-    }
-    return name;
-}
-
-/*
-** msWFSIsAllowedItem()
-*/
-static int msWFSIsAllowedItem(gmlItemListObj *itemList , const char* name)
-{
-    int z;
-    for(z=0; z<itemList->numitems; z++) {
-      if (itemList->items[z].visible &&
-          strcasecmp(name, itemList->items[z].name) == 0) {
-        return MS_TRUE;
-      }
-    }
-    return MS_FALSE;
-}
-
-/*
-** msWFSUngroupItem()
-*/
-static
-const char* msWFSUngroupItem(layerObj* lp, gmlGroupListObj* groupList,
-                             const char* name, int* pnGroupIndex)
-{
-    int z;
-
-    *pnGroupIndex = -1;
-    for(z=0; z<groupList->numgroups; z++) {
-        const char* pszGroupName = groupList->groups[z].name;
-        size_t nGroupNameLen = strlen(pszGroupName);
-
-        /* Is it a group name ? */
-        if(strcasecmp(name, pszGroupName) == 0)
-        {
-            *pnGroupIndex = z;
-            return NULL;
-        }
-
-        /* Is it an item of a group ? */
-        if(strncasecmp(name, pszGroupName, nGroupNameLen) == 0 &&
-                       name[nGroupNameLen] == '/') {
-
-            int w;
-            const char* pszSubName = msWFSStripNS(name+nGroupNameLen+1);
-            pszSubName = msWFSUnaliasItem(lp, pszSubName);
-            for(w=0;w<groupList->groups[z].numitems;w++)
-            {
-                if( strcasecmp(pszSubName, groupList->groups[z].items[w]) == 0 )
-                {
-                    return pszSubName;
-                }
-            }
-        }
-    }
-
-    return name;
-}
-
-/*
-** msWFSApplySortBy()
-*/
-static int msWFSApplySortBy(mapObj* map, wfsParamsObj *paramsObj, layerObj* lp,
-                            const char* pszSortBy,
-                            gmlItemListObj *itemList,
-                            gmlGroupListObj* groupList)
-{
-    int y, n;
-    char** tokens;
-    int invalidSortBy = MS_FALSE;
-    sortByClause sortBy;
-
-    if( !msLayerSupportsSorting(lp) )
-    {
-        msSetError(MS_WFSERR, "Layer %s does not support sorting", "msWFSGetFeature()", lp->name);
-        return msWFSException(map, "mapserv", MS_WFS_ERROR_OPERATION_PROCESSING_FAILED, paramsObj->pszVersion);
-    }
-
-    tokens = msStringSplit(pszSortBy, ',', &n);
-    sortBy.nProperties = n;
-    sortBy.properties = (sortByProperties* )msSmallMalloc(n * sizeof(sortByProperties));
-    for(y=0; y<n; y++) {
-        char* pszSpace;
-        int nGroupIndex = -1;
-        const char* pszSortProperty;
-        char* pszTmp;
-
-        sortBy.properties[y].item = msStrdup(tokens[y]);
-        sortBy.properties[y].sortOrder = SORT_ASC;
-        pszSpace = strchr(sortBy.properties[y].item, ' ');
-        if( pszSpace )
-        {
-            *pszSpace = '\0';
-            if( strcasecmp(pszSpace+1, "A") == 0 ||
-                strcasecmp(pszSpace+1, "ASC") == 0 )
-                ;
-            else if( strcasecmp(pszSpace+1, "D") == 0 ||
-                    strcasecmp(pszSpace+1, "DESC") == 0 )
-                sortBy.properties[y].sortOrder = SORT_DESC;
-            else
-                invalidSortBy = MS_TRUE;
-        }
-
-        pszSortProperty = msWFSStripNS(sortBy.properties[y].item);
-        pszSortProperty = msWFSUnaliasItem(lp, pszSortProperty);
-        pszSortProperty = msWFSUngroupItem(lp, groupList, pszSortProperty, &nGroupIndex);
-        if( nGroupIndex >= 0 )
-            invalidSortBy = MS_TRUE;
-
-        if( !msWFSIsAllowedItem(itemList, pszSortProperty) )
-            invalidSortBy = MS_TRUE;
-
-        pszTmp = msStrdup(pszSortProperty);
-        msFree(sortBy.properties[y].item);
-        sortBy.properties[y].item = pszTmp;
-    }
-    msFreeCharArray(tokens, n);
-
-    if( !invalidSortBy )
-        msLayerSetSort(lp, &sortBy);
-
-    for(y=0; y<n; y++) {
-        msFree(sortBy.properties[y].item);
-    }
-    msFree(sortBy.properties);
-
-    if( invalidSortBy )
-    {
-        msSetError(MS_WFSERR, "Invalid SORTBY clause", "msWFSGetFeature()");
-        return msWFSException(map, "sortby", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    return MS_SUCCESS;
-}
-
-static void msWFSSetShapeCache(mapObj* map)
-{
-    const char* pszFeaturesCacheCount =
-                msOWSLookupMetadata(&(map->web.metadata), "F",
-                                                "features_cache_count");
-    const char* pszFeaturesCacheSize =
-                msOWSLookupMetadata(&(map->web.metadata), "F",
-                                                "features_cache_size");
-    if( pszFeaturesCacheCount )
-    {
-        map->query.cache_shapes = MS_TRUE;
-        map->query.max_cached_shape_count = atoi(pszFeaturesCacheCount);
-        if (map->debug >= MS_DEBUGLEVEL_V){
-           msDebug("Caching up to %d shapes\n", map->query.max_cached_shape_count);
-        }
-    }
-
-    if( pszFeaturesCacheSize )
-    {
-        map->query.cache_shapes = MS_TRUE;
-        map->query.max_cached_shape_ram_amount = atoi(pszFeaturesCacheSize);
-        if( strstr(pszFeaturesCacheSize, "mb") || strstr(pszFeaturesCacheSize, "MB") )
-             map->query.max_cached_shape_ram_amount *= 1024 * 1024;
-        if (map->debug >= MS_DEBUGLEVEL_V) {
-            msDebug("Caching up to %d bytes of shapes\n", map->query.max_cached_shape_ram_amount);
-        }
-    }
-}
-
-/*
-** msWFSGetFeature()
-*/
-static
-int msWFSGetFeature(mapObj *map, wfsParamsObj *paramsObj, cgiRequestObj *req,
-                    owsRequestObj *ows_request, int nWFSVersion)
-{
-  int   status;
-  int   maxfeatures=-1,startindex=-1;
-  rectObj     bbox;
-
-  char **layers = NULL;
-  int numlayers = 0;
-
-  char *sBBoxSrs = NULL;
-
-  WFSGMLInfo gmlinfo;
-
-  OWSGMLVersion outputformat = OWS_GML2; /* default output is GML 2.1 */
-  outputFormatObj *psFormat = NULL;
-
-  int iNumberOfFeatures = 0;
-  int iResultTypeHits = 0;
-  int nMatchingFeatures = -1;
-  int bHasNextFeatures = MS_FALSE;
-
-  char** papszGMLGroups = NULL;
-  char** papszGMLIncludeItems = NULL;
-  char** papszGMLGeometries = NULL;
-  
-  msIOContext* old_context = NULL;
-
-  /* Initialize gml options */
-  msWFSInitGMLInfo(&gmlinfo);
-
-  if (paramsObj->pszResultType != NULL) {
-    if (strcasecmp(paramsObj->pszResultType, "hits") == 0)
-      iResultTypeHits = 1;
-  }
-
-  status = msWFSResolveStoredQuery(map, paramsObj, req);
-  if( status != MS_SUCCESS )
-      return status;
-
-  /* typename is mandatory unless featureid is specfied. We do not
-     support featureid */
-  if (paramsObj->pszTypeName==NULL && paramsObj->pszFeatureId == NULL) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: %s parameter missing",
-               "msWFSGetFeature()",
-               (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
-    return msWFSException(map, (nWFSVersion >= OWS_2_0_0 ) ? "typenames": "typename",
-                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-  }
-
-  /* Is it a WFS 2.0 GetFeatureById stored query with an unknown id ? */
-  /* If so, CITE interprets the spec as requesting to issue a OperationProcessingFailed */
-  /* exception. But it only checks that the HTTP error code is 403 or 404. So emit 404. */
-  /* A bit strange when a similar request but with RESOURCEID= should */
-  /* produce an empty FeatureCollection */
-  if( nWFSVersion >= OWS_2_0_0 &&
-      paramsObj->pszTypeName != NULL && strcmp(paramsObj->pszTypeName, "?") == 0 &&
-      paramsObj->pszFilter != NULL && paramsObj->pszFeatureId == NULL )
-  {
-    CPLXMLNode* psDoc;
-
-    psDoc = CPLParseXMLString(paramsObj->pszFilter);
-    if( psDoc != NULL )
-    {
-        const char* rid;
-
-        CPLStripXMLNamespace(psDoc, NULL, 1);
-        rid = CPLGetXMLValue(psDoc, "=Filter.ResourceId.rid", NULL);
-        if( rid != NULL )
-        {
-            msSetError(MS_WFSERR, "Invalid rid '%s'", "msWFSGetFeature()", rid);
-            CPLDestroyXMLNode(psDoc);
-            return msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
-                                  paramsObj->pszVersion );
-        }
-        CPLDestroyXMLNode(psDoc);
-    }
-  }
-
-  papszGMLGroups = (char**) calloc(sizeof(char*), map->numlayers);
-  papszGMLIncludeItems = (char**) calloc(sizeof(char*), map->numlayers);
-  papszGMLGeometries = (char**) calloc(sizeof(char*), map->numlayers);
-
-  if(paramsObj->pszTypeName) {
-    int k, y,z;
-
-    char **tokens;
-    int n=0, i=0;
-    char **papszPropertyName = NULL;
-    char **papszSortBy = NULL;
-
-    /* keep a ref for layer use. */
-    gmlinfo._typename = paramsObj->pszTypeName;
-
-    /* Parse comma-delimited list of type names (layers) */
-    /*  */
-    /* __TODO__ Need to handle type grouping, e.g. "(l1,l2),l3,l4" */
-    /*  */
-    layers = msStringSplit(gmlinfo._typename, ',', &numlayers);
-
-    /* ==================================================================== */
-    /*      TODO: check if the typename contains namespaces (ex cdf:Other), */
-    /*      If that is the case extract only the layer name.                */
-    /* ==================================================================== */
-
-    if (layers==NULL || numlayers < 1) {
-      msSetError(MS_WFSERR, "At least one type name required in %s parameter.", "msWFSGetFeature()",
-                 (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
-      return msWFSException(map, (nWFSVersion >= OWS_2_0_0 ) ? "typenames": "typename" ,
-                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    /* strip namespace if there is one :ex TYPENAME=cdf:Other */
-    for (i=0; i<numlayers; i++) {
-      char* pszTmp = msStrdup(msWFSStripNS(layers[i]));
-      free(layers[i]);
-      layers[i] = pszTmp;
-    }
-
-    /* Keep only selected layers, set to OFF by default. */
-    msWFSTurnOffAllLayer(map);
-
-    papszPropertyName = msWFSParsePropertyNameOrSortBy(paramsObj->pszPropertyName, numlayers);
-    if( papszPropertyName == NULL ) {
-        msFreeCharArray(layers, numlayers);
-        msFreeCharArray(papszGMLGroups, map->numlayers);
-        msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-        msFreeCharArray(papszGMLGeometries, map->numlayers);
-        msSetError(MS_WFSERR,
-                    "Optional PROPERTYNAME parameter. A list of properties may be specified for each type name. Example TYPENAME=name1,name2&PROPERTYNAME=(prop1,prop2)(prop1)",
-                    "msWFSGetFeature()");
-        return msWFSException(map, "PROPERTYNAME", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-    
-    papszSortBy = msWFSParsePropertyNameOrSortBy(paramsObj->pszSortBy, numlayers);
-    if( papszSortBy == NULL ) {
-        msFreeCharArray(layers, numlayers);
-        msFreeCharArray(papszPropertyName, numlayers);
-        msFreeCharArray(papszGMLGroups, map->numlayers);
-        msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-        msFreeCharArray(papszGMLGeometries, map->numlayers);
-        msSetError(MS_WFSERR,
-                    "Optional SORTBY parameter. A list may be specified for each type name. Example TYPENAME=name1,name2&SORTBY=(prop1,prop2)(prop1)",
-                    "msWFSGetFeature()");
-        return msWFSException(map, "SORTBY", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-
-    for (k=0; k<numlayers; k++) {
-      layerObj *lp;
-      lp = msWFSGetLayerByName(map, ows_request, layers[k]);
-      if( lp != NULL )
-      {
-            gmlItemListObj *itemList=NULL;
-            gmlGeometryListObj *geometryList=NULL;
-            gmlGroupListObj* groupList=NULL;
-
-            lp->status = MS_ON;
-            if (lp->_template == NULL) {
-              /* Force setting a template to enable query. */
-              lp->_template = msStrdup("ttt.html");
-            }
-
-            /*do an alias replace for the current layer*/
-            if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-
-              itemList = msGMLGetItems(lp, "G");
-              groupList = msGMLGetGroups(lp, "G");
-
-              if( strcmp(papszSortBy[k], "!") != 0 )
-              {
-                  status = msWFSApplySortBy(map, paramsObj, lp,
-                                            papszSortBy[k], itemList, groupList);
-                  if( status != MS_SUCCESS )
-                  {
-                    msFreeCharArray(papszPropertyName, numlayers);
-                    msFreeCharArray(papszSortBy, numlayers);
-                    msFreeCharArray(layers, numlayers);
-                    msFreeCharArray(papszGMLGroups, map->numlayers);
-                    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-                    msFreeCharArray(papszGMLGeometries, map->numlayers);
-                    msGMLFreeItems(itemList);
-                    msGMLFreeGroups(groupList);
-                    return status;
-                  }
-              }
-
-              geometryList=msGMLGetGeometries(lp, "GFO", MS_TRUE);
-
-              /* unalias, ungroup and validate that the property names passed are part of the items list*/
-              tokens = msStringSplit(papszPropertyName[k], ',', &n);
-              for (y=0; y<n; y++) {
-                const char* pszPropertyNameItem = tokens[y];
-                int nGroupIndex = -1;
-
-                if (strcasecmp(pszPropertyNameItem, "*") == 0 ||
-                    strcasecmp(pszPropertyNameItem, "!") == 0)
-                  continue;
-
-                pszPropertyNameItem = msWFSStripNS(pszPropertyNameItem);
-                pszPropertyNameItem = msWFSUnaliasItem(lp, pszPropertyNameItem);
-                pszPropertyNameItem = msWFSUngroupItem(lp, groupList, pszPropertyNameItem, &nGroupIndex);
-                if( nGroupIndex >= 0 )
-                  continue;
-
-                /* Check that the property name is allowed (#3563) */
-                /*we need to check of the property name is the geometry name; In that case it
-                  is a valid property name*/
-                if (!msWFSIsAllowedItem(itemList,pszPropertyNameItem)) {
-                  for(z=0; z<geometryList->numgeometries; z++) {
-                    if (strcasecmp(pszPropertyNameItem, geometryList->geometries[z].name) == 0)
-                      break;
-                  }
-
-                  if (z == geometryList->numgeometries) {
-                    msSetError(MS_WFSERR,
-                               "Invalid PROPERTYNAME %s",  "msWFSGetFeature()", tokens[y]);
-                    msFreeCharArray(tokens, n);
-                    msGMLFreeItems(itemList);
-                    msGMLFreeGroups(groupList);
-                    msGMLFreeGeometries(geometryList);
-                    msFreeCharArray(papszPropertyName, numlayers);
-                    msFreeCharArray(papszSortBy, numlayers);
-                    msFreeCharArray(layers, numlayers);
-                    msFreeCharArray(papszGMLGroups, map->numlayers);
-                    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-                    msFreeCharArray(papszGMLGeometries, map->numlayers);
-                    return msWFSException(map, "PROPERTYNAME", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-                  }
-                }
-                else
-                {
-                  char* pszTmp = msStrdup(pszPropertyNameItem);
-                  msFree(tokens[y]);
-                  tokens[y] = pszTmp;
-                }
-              }
-
-              /* Add mandatory items that are not explicitely listed. */
-              /* When the user specifies PROPERTYNAME, we might have to augment */
-              /* the list of returned parameters so as to validate against the schema. */
-              /* This is made clear in the WFS 1.0.0, 1.1.0 and 2.0.0 specs (#3319) */
-              for(z=0; z<itemList->numitems; z++) {
-                if( itemList->items[z].visible &&
-                    itemList->items[z].minOccurs == 1 )
-                {
-                    int bFound = MS_FALSE;
-                    for (y=0; y<n; y++) {
-                    if( strcasecmp(tokens[y], "*") == 0 ||
-                        strcasecmp(tokens[y], "!") == 0 ||
-                        strcasecmp(tokens[y], itemList->items[z].name) == 0 )
-                    {
-                        bFound = MS_TRUE;
-                        break;
-                    }
-                    }
-                    if( !bFound )
-                    {
-                        tokens = (char**) realloc(tokens, sizeof(char*) * (n+1));
-                        tokens[n] = msStrdup(itemList->items[z].name);
-                        n ++;
-                    }
-                }
-              }
-
-              /* Rebuild papszPropertyName[k] */
-              msFree(papszPropertyName[k]);
-              papszPropertyName[k] = NULL;
-              for (y=0; y<n; y++) {
-                if( y == 0 )
-                  papszPropertyName[k] = msStrdup(tokens[y]);
-                else {
-                  papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], ",");
-                  papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], tokens[y]);
-                }
-              }
-
-
-              msFreeCharArray(tokens, n);
-              msLayerClose(lp);
-
-              if (strlen(papszPropertyName[k]) > 0) {
-
-                if (strcasecmp(papszPropertyName[k], "*") == 0) {
-                  /* Add all non-excluded items, including optional ones */
-                  msFree(papszPropertyName[k]);
-                  papszPropertyName[k] = NULL;
-                  for(z=0; z<itemList->numitems; z++) {
-                    if( itemList->items[z].visible ) {
-                        if( papszPropertyName[k] != NULL )
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], ",");
-                        papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], itemList->items[z].name);
-                    }
-                  }
-                  if( papszPropertyName[k] )
-                    papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
-                  else
-                    papszGMLIncludeItems[lp->index] = msStrdup("");
-
-                /* The user didn't specify explicity PROPERTYNAME for this layer */
-                } else if (strcasecmp(papszPropertyName[k], "!") == 0) {
-                  /* Add all non-excluded items, but only default and mandatory ones (and geometry) */
-                  msFree(papszPropertyName[k]);
-                  papszPropertyName[k] = NULL;
-                  for(z=0; z<itemList->numitems; z++) {
-                    if( itemList->items[z].visible &&
-                        (itemList->items[z].outputByDefault == 1 ||
-                         itemList->items[z].minOccurs == 1) ) {
-                        if( papszPropertyName[k] != NULL )
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], ",");
-                        papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], itemList->items[z].name);
-                    }
-                  }
-                  if( papszPropertyName[k] )
-                    papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
-                  else
-                    papszGMLIncludeItems[lp->index] = msStrdup("");
-
-                } else {
-                  char* pszGeometryList = NULL;
-
-                  for(z=0; z<groupList->numgroups; z++) {
-                    const char* pszNeedle = strstr(papszPropertyName[k], groupList->groups[z].name);
-                    char chAfterNeedle = 0;
-                    if( pszNeedle != NULL )
-                        chAfterNeedle = papszPropertyName[k][strlen(groupList->groups[z].name)];
-                    if(pszNeedle != NULL && (chAfterNeedle == '\0' || chAfterNeedle == ',') ) {
-                      int w;
-                      for(w=0;w<groupList->groups[z].numitems;w++)
-                      {
-                        if(strstr(papszPropertyName[k], groupList->groups[z].items[w]) == NULL) {
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], ",");
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], groupList->groups[z].items[w]);
-                        }
-                      }
-                    }
-                  }
-
-                  // Set the "gml_select_items" metadata items that is used by
-                  // msQueryByRect() to restrict the number of properties to
-                  // select for faster results.
-                  if( msOWSLookupMetadata(&(lp->metadata), "OFG", "groups") == NULL )
-                  {
-                      auto properties = msStringSplit(papszPropertyName[k], ',');
-                      std::string selectItems;
-                      const char* featureid = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
-                      bool foundFeatureId = false;
-                      for( const auto& prop: properties )
-                      {
-                          bool isGeom = false;
-                          const char* propNoNS = prop.c_str();
-                          const char* pszColon = strchr(propNoNS, ':');
-                          if( pszColon )
-                            propNoNS = pszColon+1;
-                          for(z=0; z<geometryList->numgeometries; z++) {
-                            if (strcasecmp(propNoNS, geometryList->geometries[z].name) == 0) {
-                                isGeom = true;
-                                break;
-                            }
-                          }
-                          if( !isGeom ) {
-                              if( !selectItems.empty() )
-                                  selectItems += ',';
-                              selectItems += prop;
-                          }
-                          if( featureid && featureid == prop ) {
-                              foundFeatureId =  true;
-                          }
-                      }
-                      if( featureid && !foundFeatureId ) {
-                        if( !selectItems.empty() )
-                            selectItems += ',';
-                        selectItems += featureid;
-                      }
-                      if( !selectItems.empty() ) {
-                        msInsertHashTable(&(lp->metadata), "gml_select_items", selectItems.c_str());
-                      }
-                  }
-
-                  papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
-
-                  for(z=0; z<geometryList->numgeometries; z++) {
-                    if (strstr(papszPropertyName[k], geometryList->geometries[z].name) != NULL) {
-                        if( pszGeometryList != NULL )
-                            pszGeometryList = msStringConcatenate(
-                                pszGeometryList, ",");
-                        pszGeometryList = msStringConcatenate(
-                            pszGeometryList, geometryList->geometries[z].name);
-                    }
-                  }
-
-                  if( pszGeometryList != NULL ) {
-                      papszGMLGeometries[lp->index] = msStrdup(pszGeometryList);
-                      msFree(pszGeometryList);
-                  } else {
-                    papszGMLGeometries[lp->index] = msStrdup("none");
-                  }
-                }
-              } else {/*empty string*/
-                papszGMLGeometries[lp->index] = msStrdup("none");
-              }
-            }
-            else
-            {
-                msFreeCharArray(papszPropertyName, numlayers);
-                msFreeCharArray(papszSortBy, numlayers);
-                msFreeCharArray(layers, numlayers);
-                msFreeCharArray(papszGMLGroups, map->numlayers);
-                msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-                msFreeCharArray(papszGMLGeometries, map->numlayers);
-                msGMLFreeItems(itemList);
-                msGMLFreeGroups(groupList);
-                msGMLFreeGeometries(geometryList);
-                return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-            }
-
-            msGMLFreeItems(itemList);
-            msGMLFreeGroups(groupList);
-            msGMLFreeGeometries(geometryList);
-      }
-      else
-      {
-        /* Requested layer name was not in capabilities:
-         * either it just doesn't exist
-         */
-        msSetError(MS_WFSERR,
-                   "TYPENAME '%s' doesn't exist in this server.  Please check the capabilities and reformulate your request.",
-                   "msWFSGetFeature()", layers[k]);
-        msFreeCharArray(papszPropertyName, numlayers);
-        msFreeCharArray(papszSortBy, numlayers);
-        msFreeCharArray(layers, numlayers);
-        msFreeCharArray(papszGMLGroups, map->numlayers);
-        msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-        msFreeCharArray(papszGMLGeometries, map->numlayers);
-        return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-      }
-    }
-
-    msFreeCharArray(papszPropertyName, numlayers);
-    msFreeCharArray(papszSortBy, numlayers);
-  }
-
-  /* Validate outputformat */
-  status = msWFSGetGMLOutputFormat(paramsObj, &gmlinfo, nWFSVersion);
-  if( status < 0 ) {
-    psFormat = msWFSGetOtherOutputFormat(map, paramsObj);
-    if( psFormat == NULL ) {
-      msFreeCharArray(layers, numlayers);
-      msFreeCharArray(papszGMLGroups, map->numlayers);
-      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-      msFreeCharArray(papszGMLGeometries, map->numlayers);
-      return msWFSException(map, "outputformat",
-                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
-                            paramsObj->pszVersion );
-    }
-  }
-  else {
-    outputformat = (OWSGMLVersion) status;
-  }
-  
-  msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, iResultTypeHits,
-                                        &maxfeatures, &startindex);
-
-  status = msWFSAnalyzeBBOX(map, paramsObj, &bbox, &sBBoxSrs);
-  if( status != 0 )
-  {
-      msFreeCharArray(layers, numlayers);
-      msFreeCharArray(papszGMLGroups, map->numlayers);
-      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-      msFreeCharArray(papszGMLGeometries, map->numlayers);
-      return status;
-  }
-
-  if( iResultTypeHits == 1 )
-  {
-      map->query.only_cache_result_count = MS_TRUE;
-  }
-  else
-  {
-      msWFSSetShapeCache(map);
-  }
-
-  status = msWFSRetrieveFeatures(map,
-                                 ows_request,
-                           paramsObj,
-                           &gmlinfo,
-                           paramsObj->pszFilter,
-                           paramsObj->pszBbox != NULL,
-                           sBBoxSrs,
-                           bbox,
-                           paramsObj->pszFeatureId,
-                           layers,
-                           numlayers,
-                           maxfeatures,
-                           nWFSVersion,
-                           &iNumberOfFeatures,
-                           &bHasNextFeatures);
-  if( status != MS_SUCCESS )
-  {
-      msFreeCharArray(layers, numlayers);
-      msFree(sBBoxSrs);
-      msFreeCharArray(papszGMLGroups, map->numlayers);
-      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-      msFreeCharArray(papszGMLGeometries, map->numlayers);
-      return status;
-  }
-
-  /* ----------------------------------------- */
-  /* Now compute nMatchingFeatures for WFS 2.0 */
-  /* ----------------------------------------- */
-  
-  nMatchingFeatures = msWFSComputeMatchingFeatures(map,ows_request,paramsObj,
-                                                   iNumberOfFeatures,
-                                                   maxfeatures,
-                                                   &gmlinfo,
-                                                   bbox,
-                                                   sBBoxSrs,
-                                                   layers,
-                                                   numlayers,
-                                                   nWFSVersion);
-
-  msFreeCharArray(layers, numlayers);
-
-  msFree(sBBoxSrs);
-  sBBoxSrs = NULL;
-
-  /*
-  ** GML Header generation.
-  */
-
-  status = MS_SUCCESS;
-
-  if( psFormat == NULL ) {
-    if( paramsObj->countGetFeatureById == 1 && maxfeatures != 0 && iResultTypeHits == 0 )
-    {
-        /* When there's a single  urn:ogc:def:query:OGC-WFS::GetFeatureById GetFeature request */
-        /* we must not output a FeatureCollection but the object itself */
-        /* We do that as a post-processing step, so let print into a buffer and modify the */
-        /* XML afterwards */
-        old_context = msIO_pushStdoutToBufferAndGetOldContext();
-    }
-    else
-    {
-        msIO_setHeader("Content-Type","%s; charset=UTF-8", gmlinfo.output_mime_type);
-        msIO_sendHeaders();
-    }
-
-    status = msWFSGetFeature_GMLPreamble( map, req, &gmlinfo, paramsObj,
-                                 outputformat,
-                                 iResultTypeHits,
-                                 iNumberOfFeatures,
-                                 nMatchingFeatures,
-                                 maxfeatures,
-                                 bHasNextFeatures,
-                                 nWFSVersion );
-    if(status != MS_SUCCESS) {
-      if( old_context != NULL )
-          msIO_restoreOldStdoutContext(old_context);
-      msWFSCleanupGMLInfo(&gmlinfo);
-      msFreeCharArray(papszGMLGroups, map->numlayers);
-      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-      msFreeCharArray(papszGMLGeometries, map->numlayers);
-      return MS_FAILURE;
-    }
-  }
-
-  {
-    int i;
-    for(i=0;i<map->numlayers;i++)
-    {
-      layerObj* lp = GET_LAYER(map, i);
-      if( papszGMLGroups[i] )
-          msInsertHashTable(&(lp->metadata), "GML_GROUPS", papszGMLGroups[i]);
-      if( papszGMLIncludeItems[i] )
-          msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS", papszGMLIncludeItems[i]);
-      if( papszGMLGeometries[i] )
-          msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES", papszGMLGeometries[i]);
-    }
-  }
-
-  /* handle case of maxfeatures = 0 */
-  /*internally use a start index that start with 0 as the first index*/
-  if( psFormat == NULL ) {
-    if(maxfeatures != 0 && iResultTypeHits == 0)
-    {
-      int bWFS2MultipleFeatureCollection = MS_FALSE;
-
-      /* Would make sense for WFS 1.1.0 too ! See #3576 */
-      int bUseURN = (nWFSVersion == OWS_2_0_0);
-      const char* useurn = msOWSLookupMetadata(&(map->web.metadata), "F", "return_srs_as_urn");
-      if (useurn && strcasecmp(useurn, "true") == 0)
-        bUseURN = 1;
-      else if (useurn && strcasecmp(useurn, "false") == 0)
-        bUseURN = 0;
-
-      /* For WFS 2.0, when we request several types, we must present each type */
-      /* in its own FeatureCollection (§ 11.3.3.5 ) */
-      if( nWFSVersion >= OWS_2_0_0 && iResultTypeHits != 1 )
-      {
-          int i;
-          int nLayersWithFeatures = 0;
-          for(i=0; i<map->numlayers; i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              if(lp->resultcache && lp->resultcache->numresults > 0)
-                  nLayersWithFeatures ++;
-          }
-          if( nLayersWithFeatures > 1 )
-          {
-            char timestring[100];
-            resultCacheObj** saveResultCache = (resultCacheObj** )
-                    msSmallMalloc( map->numlayers * sizeof(resultCacheObj*));
-            int iLastNonEmptyLayer = -1;
-
-            msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
-
-            /* Emit global bounds */
-            msGMLWriteWFSBounds(map, stdout, "  ", outputformat, nWFSVersion, bUseURN);
-
-            /* Save the result cache that contains the features that we want to */
-            /* emit in the response */
-            for(i=0; i<map->numlayers; i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              saveResultCache[i] = lp->resultcache;
-              if( lp->resultcache  && lp->resultcache->numresults > 0) {
-                  iLastNonEmptyLayer = i;
-              }
-              lp->resultcache = NULL;
-            }
-
-            /* Just dump one layer at a time */
-            for(i=0;i<map->numlayers;i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              lp->resultcache = saveResultCache[i];
-              if( lp->resultcache  && lp->resultcache->numresults > 0) {
-                msIO_fprintf(stdout, "  <wfs:member>\n");
-                msIO_fprintf(stdout, "   <wfs:FeatureCollection timeStamp=\"%s\" numberMatched=\"", timestring);
-                if( i < iLastNonEmptyLayer || nMatchingFeatures >= 0 )
-                    msIO_fprintf(stdout, "%d", lp->resultcache->numresults );
-                else
-                    msIO_fprintf(stdout, "unknown" );
-                msIO_fprintf(stdout, "\" numberReturned=\"%d\">\n", lp->resultcache->numresults );
-
-                msGMLWriteWFSQuery(map, stdout,
-                                    gmlinfo.user_namespace_prefix,
-                                    outputformat,
-                                    nWFSVersion,
-                                    bUseURN,
-                                    MS_FALSE);
-                msIO_fprintf(stdout, "   </wfs:FeatureCollection>\n");
-                msIO_fprintf(stdout, "  </wfs:member>\n");
-              }
-              lp->resultcache = NULL;
-            }
-
-            /* Restore for later cleanup */
-            for(i=0; i<map->numlayers; i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              lp->resultcache = saveResultCache[i];
-            }
-            msFree(saveResultCache);
-
-            bWFS2MultipleFeatureCollection = MS_TRUE;
-         }
-      }
-
-      if( !bWFS2MultipleFeatureCollection )
-      {
-        msGMLWriteWFSQuery(map, stdout,
-                                    gmlinfo.user_namespace_prefix,
-                                    outputformat,
-                                    nWFSVersion,
-                                    bUseURN,
-                                    MS_FALSE);
-      }
-
-      status =  MS_SUCCESS;
-    }
-  } else {
-    mapservObj *mapserv = msAllocMapServObj();
-
-    /* Setup dummy mapserv object */
-    mapserv->sendheaders = MS_TRUE;
-    mapserv->map = map;
-    msFreeCgiObj(mapserv->request);
-    mapserv->request = req;
-    map->querymap.status = MS_FALSE;
-
-    if( nMatchingFeatures >= 0 )
-    {
-        char szMatchingFeatures[12];
-        sprintf(szMatchingFeatures, "%d", nMatchingFeatures);
-        msSetOutputFormatOption( psFormat, "_matching_features_",
-                                 szMatchingFeatures);
-    }
-    else
-    {
-        msSetOutputFormatOption( psFormat, "_matching_features_", "");
-    }
-    status = msReturnTemplateQuery( mapserv, psFormat->name, NULL );
-
-    mapserv->request = NULL;
-    mapserv->map = NULL;
-
-    msFreeMapServObj( mapserv );
-
-    if( status != MS_SUCCESS ) {
-      msFreeCharArray(papszGMLGroups, map->numlayers);
-      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-      msFreeCharArray(papszGMLGeometries, map->numlayers);
-      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
-                            paramsObj->pszVersion );
-    }
-  }
-
-  msFreeCharArray(papszGMLGroups, map->numlayers);
-  msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-  msFreeCharArray(papszGMLGeometries, map->numlayers);
-
-  if( psFormat == NULL && status == MS_SUCCESS ) {
-    msWFSGetFeature_GMLPostfix( &gmlinfo,
-                                outputformat,
-                                maxfeatures, iResultTypeHits, iNumberOfFeatures,
-                                nWFSVersion );
-  }
-
-  /*Special case for a single urn:ogc:def:query:OGC-WFS::GetFeatureById GetFeature request */
-  if( old_context != NULL )
-  {
-    msIOContext* new_context;
-    msIOBuffer* buffer;
-    CPLXMLNode* psRoot;
-
-    new_context = msIO_getHandler(stdout);
-    buffer = (msIOBuffer *) new_context->cbData;
-    psRoot = CPLParseXMLString((const char*) buffer->data);
-    msIO_restoreOldStdoutContext(old_context);
-    if( psRoot != NULL )
-    {
-        CPLXMLNode* psFeatureCollection = CPLGetXMLNode(psRoot, "=wfs:FeatureCollection");
-        if( psFeatureCollection != NULL )
-        {
-            CPLXMLNode* psMember = CPLGetXMLNode(psFeatureCollection, "wfs:member");
-            if( psMember != NULL && psMember->psChild != NULL )
-            {
-                CPLXMLNode* psIter;
-                CPLXMLNode* psFeatureNode;
-                char* pszTmpXML;
-
-                /* Transfer all namespaces of FeatureCollection to the Feature */
-                psFeatureNode = psMember->psChild;
-                psIter = psFeatureCollection->psChild;
-                while(psIter != NULL)
-                {
-                    if( psIter->eType == CXT_Attribute &&
-                        (strncmp(psIter->pszValue, "xmlns:", strlen("xmlns:")) == 0 ||
-                         strncmp(psIter->pszValue, "xsi:", strlen("xsi:")) == 0) )
-                    {
-                        CPLXMLNode* psIterNext = psIter->psNext;
-                        psIter->psNext = NULL;
-                        CPLAddXMLChild(psFeatureNode, CPLCloneXMLTree(psIter));
-                        psIter->psNext = psIterNext;
-                    }
-                    psIter = psIter->psNext;
-                }
-
-                pszTmpXML = CPLSerializeXMLTree(psFeatureNode);
-                msIO_setHeader("Content-Type","%s; charset=UTF-8", gmlinfo.output_mime_type);
-                msIO_sendHeaders();
-                msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-                msIO_printf("%s", pszTmpXML);
-                CPLFree(pszTmpXML);
-            }
-            else
-            {
-                status = msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
-                                        paramsObj->pszVersion );
-            }
-        }
-        CPLDestroyXMLNode(psRoot);
-    }
-  }
-
-  msWFSCleanupGMLInfo(&gmlinfo);
-
-  return status;
-}
-
-/*
-** msWFSGetPropertyValue()
-*/
-static
-int msWFSGetPropertyValue(mapObj *map, wfsParamsObj *paramsObj, cgiRequestObj *req,
-                         owsRequestObj *ows_request, int nWFSVersion)
-{
-  int   status;
-  int   maxfeatures=-1,startindex=-1;
-  rectObj     bbox;
-
-  char *sBBoxSrs = NULL;
-
-  WFSGMLInfo gmlinfo;
-
-  OWSGMLVersion outputformat = OWS_GML2; /* default output is GML 2.1 */
-
-  int iNumberOfFeatures = 0;
-  int iResultTypeHits = 0;
-  int nMatchingFeatures = -1;
-  int bHasNextFeatures = MS_FALSE;
-
-  const char* pszTypeName;
-  layerObj *lp;
-
-  char* pszGMLGroups = NULL;
-  char* pszGMLIncludeItems = NULL;
-  char* pszGMLGeometries = NULL;
-
-  status = msWFSResolveStoredQuery(map, paramsObj, req);
-  if( status != MS_SUCCESS )
-      return status;
-
-  if (paramsObj->pszTypeName==NULL) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: TYPENAMES parameter missing",
-               "msWFSGetPropertyValue()");
-    return msWFSException(map, "typenames",
-                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-  }
-
-  if (paramsObj->pszValueReference==NULL) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: VALUEREFERENCE parameter missing",
-               "msWFSGetPropertyValue()");
-    return msWFSException(map, "valuereference",
-                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-  }
-
-  /* Keep only selected layers, set to OFF by default. */
-  msWFSTurnOffAllLayer(map);
-
-  /* Remove namespace prefix */
-  pszTypeName = msWFSStripNS(paramsObj->pszTypeName);
-
-  lp = msWFSGetLayerByName(map, ows_request, pszTypeName);
-  if( lp != NULL ) {
-        gmlItemListObj *itemList=NULL;
-        gmlGeometryListObj *geometryList=NULL;
-        gmlGroupListObj* groupList=NULL;
-
-        lp->status = MS_ON;
-        if (lp->_template == NULL) {
-            /* Force setting a template to enable query. */
-            lp->_template = msStrdup("ttt.html");
-        }
-
-        /*do an alias replace for the current layer*/
-        if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-            const char* pszValueReference;
-            int z;
-            int nGroupIndex = -1;
-
-            itemList = msGMLGetItems(lp, "G");
-            groupList = msGMLGetGroups(lp, "G");
-
-            if( paramsObj->pszSortBy != NULL &&
-                strcmp(paramsObj->pszSortBy, "!") != 0 )
-            {
-              status = msWFSApplySortBy(map, paramsObj, lp,
-                                       paramsObj->pszSortBy, itemList, groupList);
-              if( status != MS_SUCCESS )
-              {
-                msGMLFreeItems(itemList);
-                msGMLFreeGroups(groupList);
-                return status;
-              }
-            }
-
-            geometryList=msGMLGetGeometries(lp, "GFO", MS_TRUE);
-
-            pszValueReference = msWFSStripNS(paramsObj->pszValueReference);
-            pszValueReference = msWFSUnaliasItem(lp, pszValueReference);
-            pszValueReference = msWFSUngroupItem(lp, groupList, pszValueReference, &nGroupIndex);
-
-            if( strcmp(paramsObj->pszValueReference, "@gml:id") == 0 ) {
-              pszGMLGroups = msStrdup("");
-              pszGMLIncludeItems = msStrdup(paramsObj->pszValueReference);
-              pszGMLGeometries = msStrdup("none");
-            }
-            else if( nGroupIndex >= 0 ) {
-              int w;
-              char* pszItems = NULL;
-              for(w=0;w<groupList->groups[nGroupIndex].numitems;w++) {
-                if( w > 0 )
-                  pszItems = msStringConcatenate(pszItems, ",");
-                pszItems = msStringConcatenate(pszItems, groupList->groups[nGroupIndex].items[w]);
-              }
-              pszGMLGroups = msStrdup(groupList->groups[nGroupIndex].name);
-              pszGMLIncludeItems = msStrdup(pszItems);
-              pszGMLGeometries = msStrdup("none");
-              msFree(pszItems);
-            }
-            else {
-              pszGMLGroups = msStrdup("");
-
-              /* Check that the property name is allowed (#3563) */
-              /*we need to check of the property name is the geometry name; In that case it
-                    is a valid property name*/
-              if (!msWFSIsAllowedItem(itemList, pszValueReference)) {
-                for(z=0; z<geometryList->numgeometries; z++) {
-                  if (strcasecmp(pszValueReference, geometryList->geometries[z].name) == 0)
-                    break;
-                }
-
-                if (z == geometryList->numgeometries) {
-                  msSetError(MS_WFSERR,
-                            "Invalid VALUEREFERENCE %s",  "msWFSGetPropertyValue()", paramsObj->pszValueReference);
-                  msFree(pszGMLGroups);
-                  msGMLFreeItems(itemList);
-                  msGMLFreeGroups(groupList);
-                  msGMLFreeGeometries(geometryList);
-                  return msWFSException(map, "valuereference", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-                }
-                else {
-                  pszGMLIncludeItems = msStrdup("");
-                  pszGMLGeometries = msStrdup(pszValueReference);
-                }
-              }
-              else {
-                pszGMLIncludeItems = msStrdup(pszValueReference);
-                pszGMLGeometries = msStrdup("none");
-              }
-            }
-
-            msLayerClose(lp);
-
-            msGMLFreeItems(itemList);
-            msGMLFreeGroups(groupList);
-            msGMLFreeGeometries(geometryList);
-        }
-  }
-  else {
-        /* Requested layer name was not in capabilities:
-         * either it just doesn't exist
-         */
-        msSetError(MS_WFSERR,
-                    "TYPENAME '%s' doesn't exist in this server.  Please check the capabilities and reformulate your request.",
-                    "msWFSGetFeature()", paramsObj->pszTypeName);
-        msFree(pszGMLGroups);
-        msFree(pszGMLIncludeItems);
-        msFree(pszGMLGeometries);
-        return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-  }
-
-  /* Initialize gml options */
-  msWFSInitGMLInfo(&gmlinfo);
-
-  if (paramsObj->pszResultType != NULL) {
-    if (strcasecmp(paramsObj->pszResultType, "hits") == 0)
-      iResultTypeHits = 1;
-  }
-
-  gmlinfo._typename = paramsObj->pszTypeName;
-
-  /* Validate outputformat */
-  status = msWFSGetGMLOutputFormat(paramsObj, &gmlinfo, nWFSVersion);
-  if( status < 0 ) {
-    msSetError(MS_WFSERR,
-                "'%s' is not a permitted output format for GetPropertyValue request.",
-                "msWFSGetPropertyValue()",
-                paramsObj->pszOutputFormat);
-    msFree(pszGMLGroups);
-    msFree(pszGMLIncludeItems);
-    msFree(pszGMLGeometries);
-    return msWFSException(map, "outputformat",
-                        MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
-                        paramsObj->pszVersion );
-  }
-  else {
-    outputformat = (OWSGMLVersion) status;
-  }
-
-  msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, iResultTypeHits,
-                                        &maxfeatures, &startindex);
-
-  status = msWFSAnalyzeBBOX(map, paramsObj, &bbox, &sBBoxSrs);
-  if( status != 0 ) {
-      msFree(pszGMLGroups);
-      msFree(pszGMLIncludeItems);
-      msFree(pszGMLGeometries);
-      return status;
-      }
-
-  if( iResultTypeHits == 1 )
-  {
-      map->query.only_cache_result_count = MS_TRUE;
-  }
-  else
-  {
-      msWFSSetShapeCache(map);
-  }
-
-  status = msWFSRetrieveFeatures(map,
-                                 ows_request,
-                           paramsObj,
-                           &gmlinfo,
-                           paramsObj->pszFilter,
-                           paramsObj->pszBbox != NULL,
-                           sBBoxSrs,
-                           bbox,
-                           paramsObj->pszFeatureId,
-                           (char**) &pszTypeName,
-                           1,
-                           maxfeatures,
-                           nWFSVersion,
-                           &iNumberOfFeatures,
-                           &bHasNextFeatures);
-  if( status != MS_SUCCESS )
-  {
-      msFree(sBBoxSrs);
-      msFree(pszGMLGroups);
-      msFree(pszGMLIncludeItems);
-      msFree(pszGMLGeometries);
-      return status;
-  }
-
-  /* ----------------------------------------- */
-  /* Now compute nMatchingFeatures for WFS 2.0 */
-  /* ----------------------------------------- */
-  
-  nMatchingFeatures = msWFSComputeMatchingFeatures(map,ows_request,paramsObj,
-                                                   iNumberOfFeatures,
-                                                   maxfeatures,
-                                                   &gmlinfo,
-                                                   bbox,
-                                                   sBBoxSrs,
-                                                   (char**) &pszTypeName,
-                                                   1,
-                                                   nWFSVersion);
-
-  msFree(sBBoxSrs);
-  sBBoxSrs = NULL;
-
-  /*
-  ** GML Header generation.
-  */
-  msIO_setHeader("Content-Type","%s; charset=UTF-8", gmlinfo.output_mime_type);
-  msIO_sendHeaders();
-
-  status = msWFSGetFeature_GMLPreamble( map, req, &gmlinfo, paramsObj,
-                                 outputformat,
-                                 iResultTypeHits,
-                                 iNumberOfFeatures,
-                                 nMatchingFeatures,
-                                 maxfeatures,
-                                 bHasNextFeatures,
-                                 nWFSVersion );
-
-  if(status == MS_SUCCESS && maxfeatures != 0 && iResultTypeHits == 0)
-  {
-      if( pszGMLGroups )
-        msInsertHashTable(&(lp->metadata), "GML_GROUPS", pszGMLGroups);
-      if( pszGMLIncludeItems )
-        msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS", pszGMLIncludeItems);
-      if( pszGMLGeometries )
-        msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES", pszGMLGeometries);
-
-      status = msGMLWriteWFSQuery(map, stdout,
-                                  gmlinfo.user_namespace_prefix,
-                                  outputformat,
-                                  nWFSVersion,
-                                  MS_TRUE,
-                                  MS_TRUE);
-  }
-
-  msIO_printf("</wfs:ValueCollection>\n");
-  
-  msFree(pszGMLGroups);
-  msFree(pszGMLIncludeItems);
-  msFree(pszGMLGeometries);
-
-  free(gmlinfo.script_url);
-  free(gmlinfo.script_url_encoded);
-  msFree(gmlinfo.user_namespace_uri_encoded);
-
-  return status;
-}
-
-
-#endif /* USE_WFS_SVR */
-
-
-/*
-** msWFSDispatch() is the entry point for WFS requests.
-** - If this is a valid request then it is processed and MS_SUCCESS is returned
-**   on success, or MS_FAILURE on failure.
-** - If this does not appear to be a valid WFS request then MS_DONE
-**   is returned and MapServer is expected to process this as a regular
-**   MapServer request.
-*/
-int msWFSDispatch(mapObj *map, cgiRequestObj *requestobj, owsRequestObj *ows_request, int force_wfs_mode)
-{
-#ifdef USE_WFS_SVR
-  int status;
-  int returnvalue = MS_DONE;
-  int nWFSVersion;
-  char* validated_language;
-
-  /* static char *wmtver = NULL, *request=NULL, *service=NULL; */
-  wfsParamsObj *paramsObj;
-  /*
-  ** Populate the Params object based on the request
-  */
-  paramsObj = msWFSCreateParamsObj();
-  /* TODO : store also parameters that are inside the map object */
-  /* into the paramsObj.  */
-  status = msWFSParseRequest(map, requestobj, paramsObj, force_wfs_mode);
-  if (status != MS_SUCCESS)
-  {
-    msWFSFreeParamsObj(paramsObj);
-    return status;
-  }
-
-  validated_language = msOWSGetLanguageFromList(map, "FO", paramsObj->pszLanguage);
-  if (validated_language != NULL) {
-    msMapSetLanguageSpecificConnection(map, validated_language);
-  }
-  msFree(validated_language);
-
-  if (force_wfs_mode) {
-    /*request is always required*/
-    if (paramsObj->pszRequest==NULL || strlen(paramsObj->pszRequest)<=0) {
-      msSetError(MS_WFSERR,
-                 "Incomplete WFS request: REQUEST parameter missing",
-                 "msWFSDispatch()");
-      returnvalue = msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-      msWFSFreeParamsObj(paramsObj);
-      return returnvalue;
-    }
-
-    /*version:
-      wfs 1.0 and 1.1.0 POST request: optional
-      wfs 1.0 and 1.1.0 GET request: optional for getcapabilities and required for describefeature and getfeature
-     */
-    if (paramsObj->pszVersion == NULL && requestobj && requestobj->postrequest == NULL &&
-        strcasecmp(paramsObj->pszRequest, "GetCapabilities") != 0) {
-      msSetError(MS_WFSERR,
-                 "Invalid WFS request: VERSION parameter missing",
-                 "msWFSDispatch()");
-      returnvalue = msWFSException(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-      msWFSFreeParamsObj(paramsObj);
-      return returnvalue;
-    }
-
-    if (paramsObj->pszVersion == NULL || strlen(paramsObj->pszVersion) <=0)
-      paramsObj->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
-
-    /*service
-      wfs 1.0 and 1.1.0 GET: required and should be set to WFS
-      wfs 1.0 POST: required
-      wfs 1.1.1 POST: optional
-    */
-    if ((paramsObj->pszService == NULL || strlen(paramsObj->pszService) == 0) &&
-        ((requestobj && requestobj->postrequest == NULL) || strcasecmp(paramsObj->pszVersion,"1.0") ==0)) {
-      msSetError(MS_WFSERR,
-                 "Invalid WFS request: Missing SERVICE parameter",
-                 "msWFSDispatch()");
-      returnvalue = msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-      msWFSFreeParamsObj(paramsObj);
-      return returnvalue;
-    }
-
-    if (paramsObj->pszService == NULL || strlen(paramsObj->pszService) == 0)
-      paramsObj->pszService = msStrdup("WFS");
-
-    if (paramsObj->pszService!=NULL && strcasecmp(paramsObj->pszService, "WFS") != 0) {
-      msSetError(MS_WFSERR,
-                 "Invalid WFS request: SERVICE parameter must be set to WFS",
-                 "msWFSDispatch()");
-      returnvalue = msWFSException(map, "service", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-      msWFSFreeParamsObj(paramsObj);
-      return returnvalue;
-    }
-
-  }
-  /* If SERVICE is specified then it MUST be "WFS" */
-  if (paramsObj->pszService != NULL &&
-      strcasecmp(paramsObj->pszService, "WFS") != 0) {
-    msWFSFreeParamsObj(paramsObj);
-    return MS_DONE;  /* Not a WFS request */
-  }
-
-  /* If SERVICE, VERSION and REQUEST not included than this isn't a WFS req*/
-  if (paramsObj->pszService == NULL && paramsObj->pszVersion==NULL &&
-      paramsObj->pszRequest==NULL) {
-    msWFSFreeParamsObj(paramsObj);
-    return MS_DONE;  /* Not a WFS request */
-  }
-
-  /* VERSION *and* REQUEST *and* SERVICE required by all WFS requests including
-   * GetCapabilities.
-   */
-  if (paramsObj->pszVersion==NULL || strlen(paramsObj->pszVersion)<=0) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: VERSION parameter missing",
-               "msWFSDispatch()");
-
-    returnvalue = msWFSException11(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, msWFSGetDefaultVersion(map));
-    msWFSFreeParamsObj(paramsObj);
-    return returnvalue;
-  }
-
-  if (paramsObj->pszRequest==NULL || strlen(paramsObj->pszRequest)<=0) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: REQUEST parameter missing",
-               "msWFSDispatch()");
-    returnvalue = msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-    msWFSFreeParamsObj(paramsObj);
-    return returnvalue;
-  }
-
-  if (paramsObj->pszService==NULL || strlen(paramsObj->pszService)<=0) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: SERVICE parameter missing",
-               "msWFSDispatch()");
-
-    returnvalue = msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
-    msWFSFreeParamsObj(paramsObj);
-    return returnvalue;
-  }
-
-  if ((status = msOWSMakeAllLayersUnique(map)) != MS_SUCCESS) {
-    msSetError(MS_WFSERR, "msOWSMakeAllLayersUnique() failed", "msWFSDispatch()");
-    returnvalue = msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-    msWFSFreeParamsObj(paramsObj);
-    return returnvalue;
-  }
-  /*
-  ** Start dispatching requests
-  */
-  if (strcasecmp(paramsObj->pszRequest, "GetCapabilities") == 0 ) {
-    msOWSRequestLayersEnabled(map, "F", paramsObj->pszRequest, ows_request);
-    if (ows_request->numlayers == 0) {
-      msSetError(MS_WFSERR, "WFS request not enabled. Check wfs/ows_enable_request settings.", "msWFSDispatch()");
-      returnvalue = msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-      msWFSFreeParamsObj(paramsObj);
-      return returnvalue;
-    }
-
-    returnvalue = msWFSGetCapabilities(map, paramsObj, requestobj, ows_request);
-    msWFSFreeParamsObj(paramsObj);
-    return returnvalue;
-  }
-
-  /*
-  ** Validate VERSION against the versions that we support... we don't do this
-  ** for GetCapabilities in order to allow version negociation.
-  */
-  if (strcmp(paramsObj->pszVersion, "1.0.0") != 0 &&
-      strcmp(paramsObj->pszVersion, "1.1.0") != 0 &&
-      strcmp(paramsObj->pszVersion, "2.0.0") != 0) {
-    msSetError(MS_WFSERR,
-               "WFS Server does not support VERSION %s.",
-               "msWFSDispatch()", paramsObj->pszVersion);
-    returnvalue = msWFSException(map, "version", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,msWFSGetDefaultVersion(map));
-    msWFSFreeParamsObj(paramsObj);
-    return returnvalue;
-
-  }
-  
-  nWFSVersion = msOWSParseVersionString(paramsObj->pszVersion);
-
-  /* Since the function can still return MS_DONE, we add an extra service check to not call
-     msOWSRequestLayersEnabled twice */
-  if (strcasecmp(paramsObj->pszService, "WFS") == 0) {
-    msOWSRequestLayersEnabled(map, "F", paramsObj->pszRequest, ows_request);
-    if (ows_request->numlayers == 0) {
-      msSetError(MS_WFSERR, "WFS request not enabled. Check wfs/ows_enable_request settings.", "msWFSDispatch()");
-      returnvalue = msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-      msWFSFreeParamsObj(paramsObj);
-      return returnvalue;
-    }
-  }
-
-  returnvalue = MS_DONE;
-  /* Continue dispatching...
-   */
-  if (strcasecmp(paramsObj->pszRequest, "DescribeFeatureType") == 0)
-    returnvalue = msWFSDescribeFeatureType(map, paramsObj, ows_request, nWFSVersion);
-
-  else if (strcasecmp(paramsObj->pszRequest, "GetFeature") == 0)
-    returnvalue = msWFSGetFeature(map, paramsObj, requestobj, ows_request, nWFSVersion);
-
-  else if (nWFSVersion >= OWS_2_0_0 &&
-           strcasecmp(paramsObj->pszRequest, "GetPropertyValue") == 0)
-    returnvalue = msWFSGetPropertyValue(map, paramsObj, requestobj, ows_request, nWFSVersion);
-
-  else if (nWFSVersion >= OWS_2_0_0 &&
-           strcasecmp(paramsObj->pszRequest, "ListStoredQueries") == 0)
-    returnvalue = msWFSListStoredQueries20(map, ows_request);
-
-  else if (nWFSVersion >= OWS_2_0_0 &&
-           strcasecmp(paramsObj->pszRequest, "DescribeStoredQueries") == 0)
-    returnvalue = msWFSDescribeStoredQueries20(map, paramsObj, ows_request);
-
-  else if (msWFSGetIndexUnsupportedOperation(paramsObj->pszRequest) >= 0 ) {
-    /* Unsupported WFS request */
-    msSetError(MS_WFSERR, "Unsupported WFS request: %s", "msWFSDispatch()",
-               paramsObj->pszRequest);
-    returnvalue = msWFSException(map, paramsObj->pszRequest, MS_OWS_ERROR_OPERATION_NOT_SUPPORTED, paramsObj->pszVersion);
-  } else if (strcasecmp(paramsObj->pszService, "WFS") == 0) {
-    /* Invalid WFS request */
-    msSetError(MS_WFSERR, "Invalid WFS request: %s", "msWFSDispatch()",
-               paramsObj->pszRequest);
-    returnvalue = msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-  }
-
-  /* This was not detected as a WFS request... let MapServer handle it */
-  msWFSFreeParamsObj(paramsObj);
-  return returnvalue;
-
-#else
-  msSetError(MS_WFSERR, "WFS server support is not available.",
-             "msWFSDispatch()");
-  return(MS_FAILURE);
-#endif
-}
-
-/************************************************************************/
-/*                           msWFSCreateParamsObj                       */
-/*                                                                      */
-/*      Create a parameter object, initialize it.                       */
-/*      The caller should free the object using msWFSFreeParamsObj.     */
-/************************************************************************/
-wfsParamsObj *msWFSCreateParamsObj()
-{
-  wfsParamsObj *paramsObj = (wfsParamsObj *)calloc(1, sizeof(wfsParamsObj));
-  MS_CHECK_ALLOC(paramsObj, sizeof(wfsParamsObj), NULL);
-
-  paramsObj->nMaxFeatures = -1;
-  paramsObj->nStartIndex = -1;
-
-  return paramsObj;
-}
-
-
-
-/************************************************************************/
-/*                            msWFSFreeParmsObj                         */
-/*                                                                      */
-/*      Free params object.                                             */
-/************************************************************************/
-void msWFSFreeParamsObj(wfsParamsObj *wfsparams)
-{
-  if (wfsparams) {
-    free(wfsparams->pszVersion);
-    free(wfsparams->pszUpdateSequence);
-    free(wfsparams->pszRequest);
-    free(wfsparams->pszService);
-    free(wfsparams->pszTypeName);
-    free(wfsparams->pszFilter);
-    free(wfsparams->pszFilterLanguage);
-    free(wfsparams->pszBbox);
-    free(wfsparams->pszGeometryName);
-    free(wfsparams->pszOutputFormat);
-    free(wfsparams->pszFeatureId);
-    free(wfsparams->pszSrs);
-    free(wfsparams->pszResultType);
-    free(wfsparams->pszPropertyName);
-    free(wfsparams->pszAcceptVersions);
-    free(wfsparams->pszSections);
-    free(wfsparams->pszSortBy);
-    free(wfsparams->pszLanguage);
-    free(wfsparams->pszValueReference);
-    free(wfsparams->pszStoredQueryId);
-
-    free(wfsparams);
-  }
-}
-
-#ifdef USE_WFS_SVR
-/************************************************************************/
-/*                       msWFSGetDefaultVersion                         */
-/************************************************************************/
-static
-const char *msWFSGetDefaultVersion(mapObj *map)
-{
-  const char* pszVersion =
-    msOWSLookupMetadata(&(map->web.metadata), "F", "getcapabilities_version");
-  if( pszVersion != NULL )
-  {
-      /* Check that the metadata value is one of the recognized versions */
-      int iVersion = msOWSParseVersionString(pszVersion);
-      int i;
-      for( i = 0; i < wfsNumSupportedVersions; i ++ )
-      {
-          if( iVersion == wfsSupportedVersions[i] )
-              return wfsSupportedVersionsStr[i];
-      }
-      /* If not, use the default (= latest) version */
-      msDebug("msWFSGetDefaultVersion(): invalid value for "
-              "wfs_getcapabilities_version: %s\n", pszVersion);
-  }
-  return WFS_LATEST_VERSION;
-}
-
-/************************************************************************/
-/*                             msWFSSetParam                            */
-/************************************************************************/
-static int msWFSSetParam(char** ppszOut, cgiRequestObj *request, int i,
-                         const char* pszExpectedParamName)
-{
-    if( strcasecmp(request->ParamNames[i], pszExpectedParamName) == 0 )
-    {
-        if( *ppszOut == NULL )
-            *ppszOut = msStrdup(request->ParamValues[i]);
-        return 1;
-    }
-    return 0;
-}
-
-/************************************************************************/
-/*                         msWFSParseXMLQueryNode                       */
-/************************************************************************/
-
-static void msWFSParseXMLQueryNode(CPLXMLNode* psQuery, wfsParamsObj *wfsparams)
-{
-    const char* pszTypename;
-    const char* pszValue;
-    char *pszSerializedFilter, *pszTmp, *pszTmp2;
-    CPLXMLNode* psPropertyName;
-    CPLXMLNode* psFilter;
-    CPLXMLNode* psSortBy;
-    char* pszSortBy = NULL;
-
-    pszValue = CPLGetXMLValue(psQuery,  "srsName",
-                                NULL);
-    if (pszValue)
-    {
-        msFree(wfsparams->pszSrs);
-        wfsparams->pszSrs = msStrdup(pszValue);
-    }
-
-    /* parse typenames */
-    pszTypename = CPLGetXMLValue(psQuery,
-                                "typename", NULL);
-    if( pszTypename == NULL ) /* WFS 2.0 */
-        pszTypename = CPLGetXMLValue(psQuery,
-                                "typeNames", NULL);
-
-    /*parse property name*/
-    psPropertyName = CPLGetXMLNode(psQuery, "PropertyName");
-    pszTmp2= NULL;
-
-    /*when there is no PropertyName, we output (!) so that it is parsed properly in GetFeature*/
-    if (psPropertyName == NULL)
-        pszTmp2 = msStrdup("!");
-
-    while (psPropertyName) {
-        if (!psPropertyName->pszValue ||
-            strcasecmp(psPropertyName->pszValue, "PropertyName") != 0) {
-            psPropertyName = psPropertyName->psNext;
-        continue;
-        }
-        pszValue = CPLGetXMLValue(psPropertyName, NULL, NULL);
-        if (pszTmp2 == NULL) {
-            pszTmp2 = msStrdup(pszValue);
-        } else {
-            pszTmp = msStrdup(pszTmp2);
-            pszTmp2 = (char *)msSmallRealloc(pszTmp2, sizeof(char)* (strlen(pszTmp)+ strlen(pszValue)+2));
-            sprintf(pszTmp2,"%s,%s",pszTmp, pszValue);
-            msFree(pszTmp);
-        }
-        psPropertyName = psPropertyName->psNext;
-    }
-    if (pszTmp2) {
-        pszTmp = msStrdup(pszTmp2);
-        pszTmp2 = (char *)msSmallRealloc(pszTmp2, sizeof(char)* (strlen(pszTmp)+ 3));
-        sprintf(pszTmp2,"(%s)", pszTmp);
-        msFree(pszTmp);
-
-        msWFSBuildParamList(&(wfsparams->pszPropertyName), pszTmp2, "");
-        msFree(pszTmp2);
-        pszTmp2 = NULL;
-    }
-
-    /* parse filter */
-    psFilter = CPLGetXMLNode(psQuery, "Filter");
-
-    if (psFilter == NULL) {
-        /*when there is no Filter, we output (!) so that it is parsed properly in GetFeature*/
-        pszSerializedFilter = msStrdup("(!)");
-    } else {
-        char* pszCPLTmp = CPLSerializeXMLTree(psFilter);
-        pszSerializedFilter = (char *)msSmallMalloc(sizeof(char)*
-                                        (strlen(pszCPLTmp)+3));
-        sprintf(pszSerializedFilter, "(%s)", pszCPLTmp);
-        CPLFree(pszCPLTmp);
-    }
-
-    msWFSBuildParamList(&(wfsparams->pszFilter), pszSerializedFilter, "");
-    free(pszSerializedFilter);
-
-    /* parse SortBy */
-    psSortBy = CPLGetXMLNode(psQuery, "SortBy");
-    if( psSortBy != NULL )
-    {
-        int bFirstProperty = MS_TRUE;
-        CPLXMLNode* psIter = psSortBy->psChild;
-
-        pszSortBy = msStringConcatenate(pszSortBy, "(");
-
-        while( psIter != NULL )
-        {
-            if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "SortProperty") == 0 )
-            {
-                const char* pszPropertyName = CPLGetXMLValue(psIter, "PropertyName", NULL);
-                if( pszPropertyName == NULL )
-                    pszPropertyName = CPLGetXMLValue(psIter, "ValueReference", NULL);
-                if( pszPropertyName != NULL )
-                {
-                    const char* pszSortOrder = CPLGetXMLValue(psIter, "SortOrder", NULL);
-                    if( !bFirstProperty )
-                        pszSortBy = msStringConcatenate(pszSortBy, ",");
-                    bFirstProperty = MS_FALSE;
-
-                    pszSortBy = msStringConcatenate(pszSortBy, pszPropertyName);
-                    if( pszSortOrder != NULL )
-                    {
-                        pszSortBy = msStringConcatenate(pszSortBy, " ");
-                        pszSortBy = msStringConcatenate(pszSortBy, pszSortOrder);
-                    }
-                }
-            }
-            psIter = psIter->psNext;
-        }
-
-        pszSortBy = msStringConcatenate(pszSortBy, ")");
-    }
-    else
-    {
-        pszSortBy = msStrdup("(!)");
-    }
-
-    msWFSBuildParamList(&(wfsparams->pszSortBy), pszSortBy, "");
-    free(pszSortBy);
-
-    /* Special case for "urn:ogc:def:query:OGC-WFS::GetFeatureById" */
-    /* Resolve the property typename */
-    if( pszTypename != NULL && strcmp(pszTypename, "?") == 0 && psFilter != NULL )
-    {
-        const char* rid;
-        rid = CPLGetXMLValue(psFilter, "ResourceId.rid", NULL);
-        if( rid != NULL )
-        {
-            char* pszTmpTypename = msStrdup(rid);
-            char* pszDot = strchr(pszTmpTypename, '.');
-            if( pszDot )
-            {
-                *pszDot = '\0';
-                msWFSBuildParamList(&(wfsparams->pszTypeName), pszTmpTypename, ",");
-                pszTypename = NULL;
-
-                if( wfsparams->countGetFeatureById >= 0 )
-                    wfsparams->countGetFeatureById ++;
-            }
-            else
-                wfsparams->countGetFeatureById = -1;
-            msFree(pszTmpTypename);
-        }
-        else
-            wfsparams->countGetFeatureById = -1;
-    }
-    else
-        wfsparams->countGetFeatureById = -1;
-
-    if (pszTypename) {
-        msWFSBuildParamList(&(wfsparams->pszTypeName), pszTypename, ",");
-    }
-
-}
-
-/************************************************************************/
-/*                     msWFSAnalyzeStoredQuery                          */
-/************************************************************************/
-
-static int msWFSAnalyzeStoredQuery(mapObj* map,
-                                   wfsParamsObj *wfsparams,
-                                   const char* id,
-                                   const char* pszResolvedQuery)
-{
-    CPLXMLNode* psRoot;
-    CPLXMLNode* psQuery;
-    CPLXMLNode* psIter;
-
-    psRoot = CPLParseXMLString(pszResolvedQuery);
-
-    if( psRoot == NULL )
-    {
-        msSetError(MS_WFSERR, "Resolved definition for stored query '%s' is invalid", "msWFSParseRequest()", id);
-        msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wfsparams->pszVersion);
-        return MS_FAILURE;
-    }
-
-    CPLStripXMLNamespace(psRoot, NULL, 1);
-    psQuery = CPLGetXMLNode(psRoot, "=StoredQueryDescription.QueryExpressionText.Query");
-    if( psQuery == NULL )
-    {
-        msSetError(MS_WFSERR, "Resolved definition for stored query '%s' is invalid", "msWFSParseRequest()", id);
-        msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wfsparams->pszVersion);
-        CPLDestroyXMLNode(psRoot);
-        return MS_FAILURE;
-    }
-
-    psIter = psQuery;
-    while( psIter != NULL )
-    {
-        if( psIter->eType == CXT_Element && strcmp(psIter->pszValue, "Query") == 0 ) {
-            msWFSParseXMLQueryNode(psIter, wfsparams);
-        }
-        psIter = psIter->psNext;
-    }
-
-    CPLDestroyXMLNode(psRoot);
-
-    return MS_SUCCESS;
-}
-
-/************************************************************************/
-/*                     msWFSParseXMLStoredQueryNode                     */
-/************************************************************************/
-
-static int msWFSParseXMLStoredQueryNode(mapObj* map,
-                                        wfsParamsObj *wfsparams,
-                                        CPLXMLNode* psQuery)
-{
-    const char* id;
-    CPLXMLNode* psIter;
-    hashTableObj * hashTable;
-    char* pszResolvedQuery;
-    int status;
-
-    id = CPLGetXMLValue(psQuery, "id", NULL);
-    if( id == NULL )
-    {
-        msSetError(MS_WFSERR, "Missing 'id' attribute in StoredQuery", "msWFSParseRequest()");
-        return msWFSException(map, "id", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, wfsparams->pszVersion);
-    }
-
-    hashTable = msCreateHashTable();
-    psIter = psQuery->psChild;
-    while(psIter != NULL)
-    {
-        if( psIter->eType == CXT_Element &&
-            strcmp(psIter->pszValue, "Parameter") == 0 )
-        {
-            const char* name;
-            CPLXMLNode* psIter2;
-            char* pszValue;
-
-            name = CPLGetXMLValue(psIter, "name", NULL);
-            if( name == NULL )
-            {
-                msSetError(MS_WFSERR, "Missing 'name' attribute in Parameter of StoredQuery", "msWFSParseRequest()");
-                msFreeHashTable(hashTable);
-                return msWFSException(map,  NULL, MS_OWS_ERROR_INVALID_PARAMETER_VALUE, wfsparams->pszVersion);
-            }
-
-            psIter2 = psIter->psChild;
-            while( psIter2 != NULL )
-            {
-                if( psIter2->eType != CXT_Attribute )
-                    break;
-                psIter2 = psIter2->psNext;
-            }
-
-            pszValue = CPLSerializeXMLTree(psIter2);
-            msInsertHashTable(hashTable, name, pszValue);
-            CPLFree(pszValue);
-        }
-        psIter = psIter->psNext;
-    }
-
-    pszResolvedQuery = msWFSGetResolvedStoredQuery20(map, wfsparams, id, hashTable);
-    msFreeHashTable(hashTable);
-    if( pszResolvedQuery == NULL)
-        return MS_FAILURE;
-
-    status = msWFSAnalyzeStoredQuery(map, wfsparams, id, pszResolvedQuery);
-
-    msFree(pszResolvedQuery);
-
-    return status;
-}
-
-/************************************************************************/
-/*                    msWFSSimplifyPropertyNameAndFilter                */
-/************************************************************************/
-
-static void msWFSSimplifyPropertyNameAndFilter(wfsParamsObj *wfsparams)
-{
-    int i;
-
-    /* If no PropertyName at all was specified, then clear the field */
-    /* that will be easier to generate valid 'next' and 'previous' uri */
-    /* for WFS 2.0 GetFeature */
-    if( wfsparams->pszPropertyName != NULL )
-    {
-        i = 0;
-        while( strncmp(wfsparams->pszPropertyName + i, "(!)", 3) == 0 )
-            i += 3;
-        if( wfsparams->pszPropertyName[i] == '\0' )
-        {
-            msFree(wfsparams->pszPropertyName);
-            wfsparams->pszPropertyName = NULL;
-        }
-    }
-
-    /* Same with filter */
-    if( wfsparams->pszFilter != NULL )
-    {
-        i = 0;
-        while( strncmp(wfsparams->pszFilter + i, "(!)", 3) == 0 )
-            i += 3;
-        if( wfsparams->pszFilter[i] == '\0' )
-        {
-            msFree(wfsparams->pszFilter);
-            wfsparams->pszFilter = NULL;
-        }
-    }
-
-    /* Same with SortBy */
-    if( wfsparams->pszSortBy != NULL )
-    {
-        i = 0;
-        while( strncmp(wfsparams->pszSortBy + i, "(!)", 3) == 0 )
-            i += 3;
-        if( wfsparams->pszSortBy[i] == '\0' )
-        {
-            msFree(wfsparams->pszSortBy);
-            wfsparams->pszSortBy = NULL;
-        }
-    }
-}
-
-#endif /* USE_WFS_SVR */
-
-
-/************************************************************************/
-/*                            msWFSParseRequest                         */
-/*                                                                      */
-/*      Parse request into the params object.                           */
-/************************************************************************/
-int msWFSParseRequest(mapObj *map, cgiRequestObj *request,
-                      wfsParamsObj *wfsparams, int force_wfs_mode)
-{
-#ifdef USE_WFS_SVR
-  int i = 0;
-
-  if (!request || !wfsparams)
-    return msWFSException(map, "request", "InvalidRequest", NULL);
-
-  if (request->NumParams > 0 && request->postrequest == NULL ) {
-    for(i=0; i<request->NumParams; i++) {
-      if (request->ParamNames[i] && request->ParamValues[i]) {
-        if( msWFSSetParam(&(wfsparams->pszVersion), request, i, "VERSION") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszUpdateSequence), request, i, "UPDATESEQUENCE") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszRequest), request, i, "REQUEST") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszService), request, i, "SERVICE") )
-        {}
-
-        else if (strcasecmp(request->ParamNames[i], "MAXFEATURES") == 0)
-          wfsparams->nMaxFeatures = atoi(request->ParamValues[i]);
-
-        /* WFS 2.0 */
-        else if (strcasecmp(request->ParamNames[i], "COUNT") == 0)
-          wfsparams->nMaxFeatures = atoi(request->ParamValues[i]);
-
-        else if (strcasecmp(request->ParamNames[i], "STARTINDEX") == 0)
-          wfsparams->nStartIndex = atoi(request->ParamValues[i]);
-
-        else if( msWFSSetParam(&(wfsparams->pszBbox), request, i, "BBOX") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszSrs), request, i, "SRSNAME") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszResultType), request, i, "RESULTTYPE") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszTypeName), request, i, "TYPENAME") )
-        {}
-
-        /* WFS 2.0 */
-        else if( msWFSSetParam(&(wfsparams->pszTypeName), request, i, "TYPENAMES") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszFilter), request, i, "FILTER") )
-        {}
-
-        /* WFS 2.0 */
-        else if( msWFSSetParam(&(wfsparams->pszFilterLanguage), request, i, "FILTER_LANGUAGE") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszOutputFormat), request, i, "OUTPUTFORMAT") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszFeatureId), request, i, "FEATUREID") )
-        {}
-
-        /* WFS 2.0 */
-        else if( msWFSSetParam(&(wfsparams->pszFeatureId), request, i, "RESOURCEID") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszPropertyName), request, i, "PROPERTYNAME") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszAcceptVersions), request, i, "ACCEPTVERSIONS") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszSections), request, i, "SECTIONS") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszSortBy), request, i, "SORTBY") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszLanguage), request, i, "LANGUAGE") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszValueReference), request, i, "VALUEREFERENCE") )
-        {}
-
-        else if( msWFSSetParam(&(wfsparams->pszStoredQueryId), request, i, "STOREDQUERY_ID") )
-        {}
-      }
-    }
-    /* version is optional is the GetCapabilities. If not */
-    /* provided, set it. Default it to latest implemented version */
-    /* or to the specified one in wfs_getcapabilities_version */
-    if (wfsparams->pszVersion == NULL &&
-        wfsparams->pszRequest &&
-        strcasecmp(wfsparams->pszRequest, "GetCapabilities") == 0) {
-      wfsparams->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Parse the post request. It is assumed to be an XML document.    */
-  /* -------------------------------------------------------------------- */
-  if (request->postrequest != NULL) {
-
-    CPLXMLNode *psRoot;
-    CPLXMLNode *psGetFeature = NULL;
-    CPLXMLNode *psGetCapabilities = NULL;
-    CPLXMLNode *psDescribeFeature = NULL;
-    CPLXMLNode *psGetPropertyValue = NULL;
-    CPLXMLNode *psListStoredQueries = NULL;
-    CPLXMLNode *psDescribeStoredQueries = NULL;
-    CPLXMLNode *psOperation = NULL;
-    const char *pszValue;
-    char *pszSchemaLocation = NULL;
-
-    psRoot = CPLParseXMLString(request->postrequest);
-    if(map->debug == MS_DEBUGLEVEL_VVV) {
-      msDebug("msWFSParseRequest(): WFS post request: %s\n", request->postrequest);
-    }
-    if (psRoot) {
-      /* need to strip namespaces */
-      CPLStripXMLNamespace(psRoot, NULL, 1);
-
-      for( psOperation = psRoot;
-           psOperation != NULL;
-           psOperation = psOperation->psNext ) {
-        if(psOperation->eType == CXT_Element) {
-
-          /* keep schemaLocation so as to be able to validate against appropriate */
-          /* wfs.xsd schema afterwards */
-          if( pszSchemaLocation == NULL &&
-              CPLGetXMLValue(psOperation, "schemaLocation", NULL) != NULL )
-             pszSchemaLocation = msStrdup( CPLGetXMLValue(psOperation, "schemaLocation", NULL) );
-
-          if(strcasecmp(psOperation->pszValue,"GetFeature")==0) {
-            psGetFeature = psOperation;
-            break;
-          } else if(strcasecmp(psOperation->pszValue,"GetCapabilities")==0) {
-            psGetCapabilities = psOperation;
-            break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "DescribeFeatureType")==0) {
-            psDescribeFeature = psOperation;
-            break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "GetPropertyValue")==0) {
-            psGetPropertyValue = psOperation;
-            break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "ListStoredQueries")==0) {
-            psListStoredQueries = psOperation;
-            break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "DescribeStoredQueries")==0) {
-            psDescribeStoredQueries = psOperation;
-            break;
-          }
-          /* these are unsupported requests. Just set the  */
-          /* request value and return; */
-          else {
-            int idx = msWFSGetIndexUnsupportedOperation(psOperation->pszValue);
-            if( idx >= 0 ) {
-              wfsparams->pszRequest = msStrdup(wfsUnsupportedOperations[idx]);
-              break;
-            }
-          }
-        }
-      }
-
-      if( psOperation != NULL )
-      {
-        pszValue = CPLGetXMLValue(psOperation, "version",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszVersion = msStrdup(pszValue);
-
-        pszValue = CPLGetXMLValue(psOperation, "service",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszService = msStrdup(pszValue);
-      }
-
-      /* -------------------------------------------------------------------- */
-      /*      Parse the GetFeature                                            */
-      /* -------------------------------------------------------------------- */
-      if (psGetFeature) {
-        CPLXMLNode* psIter;
-
-        wfsparams->pszRequest = msStrdup("GetFeature");
-
-        pszValue = CPLGetXMLValue(psGetFeature,  "resultType",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszResultType = msStrdup(pszValue);
-
-        pszValue = CPLGetXMLValue(psGetFeature,  "maxFeatures",
-                                  NULL);
-        if (pszValue)
-          wfsparams->nMaxFeatures = atoi(pszValue);
-        else
-        {
-            /* WFS 2.0 */
-            pszValue = CPLGetXMLValue(psGetFeature,  "count",
-                                  NULL);
-            if (pszValue)
-                wfsparams->nMaxFeatures = atoi(pszValue);
-        }
-
-        pszValue = CPLGetXMLValue(psGetFeature,  "startIndex",
-                                  NULL);
-        if (pszValue)
-          wfsparams->nStartIndex = atoi(pszValue);
-
-        pszValue = CPLGetXMLValue(psGetFeature, "outputFormat",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszOutputFormat = msStrdup(pszValue);
-
-          /* -------------------------------------------------------------------- */
-          /*      Parse typenames and filters. If there are multiple queries,     */
-          /*      typenames will be build with comma between thme                 */
-          /*      (typename1,typename2,...) and filters will be build with        */
-          /*      bracets enclosinf the filters :(filter1)(filter2)...            */
-          /*      propertynames are stored like (property1,property2)(property1)  */
-          /* -------------------------------------------------------------------- */
-        psIter = psGetFeature->psChild;
-        while( psIter != NULL )
-        {
-            if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "Query") == 0 )
-            {
-                msWFSParseXMLQueryNode(psIter, wfsparams);
-            }
-            else if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "StoredQuery") == 0 )
-            {
-                int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
-                if( status != MS_SUCCESS )
-                {
-                    CPLDestroyXMLNode(psRoot);
-                    msFree(pszSchemaLocation);
-                    return status;
-                }
-                wfsparams->bHasPostStoredQuery = MS_TRUE;
-            }
-            psIter = psIter->psNext;
-        }
-
-        msWFSSimplifyPropertyNameAndFilter(wfsparams);
-      }/* end of GetFeature */
-
-
-      /* -------------------------------------------------------------------- */
-      /*      Parse the GetPropertyValue                                      */
-      /* -------------------------------------------------------------------- */
-      if (psGetPropertyValue) {
-        CPLXMLNode* psIter;
-
-        wfsparams->pszRequest = msStrdup("GetPropertyValue");
-
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "valueReference",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszValueReference = msStrdup(pszValue);
-
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "resultType",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszResultType = msStrdup(pszValue);
-
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "count",
-                                 NULL);
-        if (pszValue)
-          wfsparams->nMaxFeatures = atoi(pszValue);
-
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "startIndex",
-                                  NULL);
-        if (pszValue)
-          wfsparams->nStartIndex = atoi(pszValue);
-
-        pszValue = CPLGetXMLValue(psGetPropertyValue, "outputFormat",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszOutputFormat = msStrdup(pszValue);
-
-        psIter = psGetPropertyValue->psChild;
-        while( psIter != NULL )
-        {
-            if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "Query") == 0 )
-            {
-                msWFSParseXMLQueryNode(psIter, wfsparams);
-                /* Just one is allowed for GetPropertyValue */
-                break;
-            }
-            else if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "StoredQuery") == 0 )
-            {
-                int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
-                if( status != MS_SUCCESS )
-                {
-                    CPLDestroyXMLNode(psRoot);
-                    msFree(pszSchemaLocation);
-                    return status;
-                }
-                wfsparams->bHasPostStoredQuery = MS_TRUE;
-                /* Just one is allowed for GetPropertyValue */
-                break;
-            }
-            psIter = psIter->psNext;
-        }
-
-        msWFSSimplifyPropertyNameAndFilter(wfsparams);
-      }/* end of GetPropertyValue */
-
-      /* -------------------------------------------------------------------- */
-      /*      Parse GetCapabilities.                                          */
-      /* -------------------------------------------------------------------- */
-      if (psGetCapabilities) {
-        CPLXMLNode* psAcceptVersions;
-        CPLXMLNode* psSections;
-          
-        wfsparams->pszRequest = msStrdup("GetCapabilities");
-        
-        pszValue = CPLGetXMLValue(psGetCapabilities,  "updateSequence", NULL);
-        if (pszValue)
-            wfsparams->pszUpdateSequence = msStrdup(pszValue);
-
-        /* version is optional for the GetCapabilities. If not */
-        /* provided, set it. */
-        if (wfsparams->pszVersion == NULL)
-          wfsparams->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
-
-        psAcceptVersions = CPLGetXMLNode(psGetCapabilities, "AcceptVersions");
-        if( psAcceptVersions != NULL )
-        {
-            CPLXMLNode* psIter = psAcceptVersions->psChild;
-            while( psIter != NULL )
-            {
-                if( psIter->eType == CXT_Element &&
-                    strcmp(psIter->pszValue, "Version") == 0 )
-                {
-                    pszValue = CPLGetXMLValue(psIter, NULL, NULL);
-                    if (pszValue) {
-                      msWFSBuildParamList(&(wfsparams->pszAcceptVersions), pszValue, ",");
-                    }
-                }
-                psIter = psIter->psNext;
-            }
-        }
-
-        psSections = CPLGetXMLNode(psGetCapabilities, "Sections");
-        if( psSections != NULL )
-        {
-            CPLXMLNode* psIter = psSections->psChild;
-            while( psIter != NULL )
-            {
-                if( psIter->eType == CXT_Element &&
-                    strcmp(psIter->pszValue, "Section") == 0 )
-                {
-                    pszValue = CPLGetXMLValue(psIter, NULL, NULL);
-                    if (pszValue) {
-                      msWFSBuildParamList(&(wfsparams->pszSections), pszValue, ",");
-                    }
-                }
-                psIter = psIter->psNext;
-            }
-        }
-      }/* end of GetCapabilites */
-      /* -------------------------------------------------------------------- */
-      /*      Parse DescribeFeatureType                                       */
-      /* -------------------------------------------------------------------- */
-      if (psDescribeFeature) {
-        CPLXMLNode* psIter;
-        wfsparams->pszRequest = msStrdup("DescribeFeatureType");
-
-        pszValue = CPLGetXMLValue(psDescribeFeature,
-                                  "outputFormat",
-                                  NULL);
-        if (pszValue)
-          wfsparams->pszOutputFormat = msStrdup(pszValue);
-
-        psIter = CPLGetXMLNode(psDescribeFeature, "TypeName");
-        if (psIter) {
-          /* free typname and filter. There may have been */
-          /* values if they were passed in the URL */
-          if (wfsparams->pszTypeName)
-            free(wfsparams->pszTypeName);
-          wfsparams->pszTypeName = NULL;
-
-          while (psIter )
-          {
-            if( psIter->eType == CXT_Element &&
-                strcasecmp(psIter->pszValue, "TypeName") == 0) {
-              pszValue = CPLGetXMLValue(psIter, NULL, NULL);
-              if (pszValue) {
-                msWFSBuildParamList(&(wfsparams->pszTypeName), pszValue, ",");
-              }
-            }
-            psIter = psIter->psNext;
-          }
-        }
-
-      }/* end of DescibeFeatureType */
-
-      /* -------------------------------------------------------------------- */
-      /*      Parse the ListStoredQueries                                     */
-      /* -------------------------------------------------------------------- */
-      if (psListStoredQueries) {
-        wfsparams->pszRequest = msStrdup("ListStoredQueries");
-      }/* end of ListStoredQueries */
-
-      /* -------------------------------------------------------------------- */
-      /*      Parse the DescribeStoredQueries                                 */
-      /* -------------------------------------------------------------------- */
-      if (psDescribeStoredQueries) {
-        CPLXMLNode* psIter;
-
-        wfsparams->pszRequest = msStrdup("DescribeStoredQueries");
-
-        psIter = CPLGetXMLNode(psDescribeStoredQueries, "StoredQueryId");
-        while (psIter )
-        {
-          if( psIter->eType == CXT_Element &&
-              strcasecmp(psIter->pszValue, "StoredQueryId") == 0) {
-            pszValue = CPLGetXMLValue(psIter, NULL, NULL);
-            if (pszValue) {
-              msWFSBuildParamList(&(wfsparams->pszStoredQueryId), pszValue, ",");
-            }
-          }
-          psIter = psIter->psNext;
-        }
-      }/* end of DescribeStoredQueries */
-
-      CPLDestroyXMLNode(psRoot);
-    }
-
-#if defined(USE_LIBXML2)
-    {
-        const char *schema_location=NULL, *validate=NULL;
-
-        /*do we validate the xml ?*/
-        validate = msOWSLookupMetadata(&(map->web.metadata), "FO", "validate_xml");
-        if (validate && strcasecmp(validate, "true") == 0 &&
-            (schema_location = msOWSLookupMetadata(&(map->web.metadata), "FO", "schemas_dir")))
-        {
-            if ((wfsparams->pszService  && strcmp(wfsparams->pszService, "WFS") == 0) ||
-                force_wfs_mode)
-            {
-                char *schema_file =NULL;
-                if (pszSchemaLocation != NULL && strstr(pszSchemaLocation, "wfs/1.0") != NULL )
-                {
-                    schema_file = msStringConcatenate(schema_file, schema_location);
-                    schema_file = msStringConcatenate(schema_file, MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION);
-                }
-                else if (pszSchemaLocation != NULL && strstr(pszSchemaLocation, "wfs/1.1") != NULL )
-                {
-                    schema_file = msStringConcatenate(schema_file, schema_location);
-                    schema_file = msStringConcatenate(schema_file, MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION);
-                }
-                else if (pszSchemaLocation != NULL && strstr(pszSchemaLocation, "wfs/2.0") != NULL )
-                {
-                    schema_file = msStringConcatenate(schema_file, schema_location);
-                    schema_file = msStringConcatenate(schema_file, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-                }
-                if( schema_file != NULL )
-                {
-                    if (msOWSSchemaValidation(schema_file, request->postrequest) != 0) {
-                        msSetError(MS_WFSERR, "Invalid POST request.  XML is not valid", "msWFSParseRequest()");
-                        msFree(schema_file);
-                        return msWFSException(map, "request", "InvalidRequest", NULL);
-                    }
-                    msFree(schema_file);
-                }
-            }
-        }
-    }
-#endif
-
-    msFree(pszSchemaLocation);
-
-  }
-
-#endif
-  return MS_SUCCESS;
-}
-
diff -pruN 8.0.1-5/mapwfs11.cpp 8.2.0~beta1-1~exp1/mapwfs11.cpp
--- 8.0.1-5/mapwfs11.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwfs11.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,550 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC WFS 1.1.0 implementation. This file holds some WFS 1.1.0
- *           specific functions but other parts are still implemented in mapwfs.c.
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2008, Y. Assefa, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#if defined(USE_WFS_SVR) && defined(USE_LIBXML2)
-#include "maplibxml2.h"
-#include "mapowscommon.h"
-#include "mapogcfilter.h"
-
-#include <string>
-
-template<class T> inline void IGNORE_RET_VAL(T) {}
-
-/************************************************************************/
-/*                          msWFSException11()                          */
-/************************************************************************/
-
-int msWFSException11(mapObj *map, const char *locator,
-                     const char *exceptionCode, const char *version)
-{
-  int size = 0;
-  char *errorString     = NULL;
-  char *schemasLocation = NULL;
-
-  xmlDocPtr  psDoc      = NULL;
-  xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
-
-  if (version == NULL)
-    version = "1.1.0";
-
-  psNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows", BAD_CAST "ows");
-
-  errorString = msGetErrorString("\n");
-  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_0_0, schemasLocation, version, msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows", BAD_CAST "ows");
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-
-  msIO_printf("%s", buffer);
-
-  /*free buffer and the document */
-  free(errorString);
-  free(schemasLocation);
-  xmlFree(buffer);
-  xmlFreeDoc(psDoc);
-  xmlFreeNs(psNsOws);
-
-  /* clear error since we have already reported it */
-  msResetErrorList();
-
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                       msWFSAddMetadataURL                            */
-/************************************************************************/
-
-static void msWFSAddMetadataURL(layerObj* lp,
-                                int nWFSVersion, 
-                                const std::string& radix,
-                                xmlNodePtr psRootNode)
-{
-  const char* value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_href").c_str());
-
-  if (value) {
-    if( nWFSVersion >= OWS_2_0_0 )
-    {
-        xmlNodePtr psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "MetadataURL", NULL);
-        xmlNewProp(psNode, BAD_CAST "xlink:href", BAD_CAST value);
-
-        value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_about").c_str());
-        if( value != NULL )
-            xmlNewProp(psNode, BAD_CAST "about", BAD_CAST value);
-    }
-    else
-    {
-        xmlNodePtr psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "MetadataURL", BAD_CAST value);
-
-        value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_format").c_str());
-
-        if (!value)
-            value = "text/html"; /* default */
-
-        xmlNewProp(psNode, BAD_CAST "format", BAD_CAST value);
-
-        value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_type").c_str());
-
-        if (!value)
-            value = "FGDC"; /* default */
-
-        xmlNewProp(psNode, BAD_CAST "type", BAD_CAST value);
-    }
-  }
-}
-
-/************************************************************************/
-/*                            msWFSDumpLayer11                          */
-/************************************************************************/
-xmlNodePtr msWFSDumpLayer11(mapObj *map, layerObj *lp, xmlNsPtr psNsOws,
-                            int nWFSVersion, const char* validate_language,
-                            char *script_url)
-{
-  rectObj ext;
-
-  xmlNodePtr psRootNode, psNode;
-  const char *value    = NULL;
-  char *valueToFree;
-  int i=0;
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "FeatureType");
-
-  /* add namespace to layer name */
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-
-  /* FIXME? Should probably be applied to WFS 1.1 as well, but the addition */
-  /* of the prefix can be disruptive for clients */
-  if( value == NULL && nWFSVersion >= OWS_2_0_0 )
-      value = MS_DEFAULT_NAMESPACE_PREFIX;
-
-  if(value) {
-    int n = strlen(value)+strlen(lp->name)+1+1;
-    valueToFree = (char *) msSmallMalloc(n);
-    snprintf(valueToFree, n, "%s:%s", value, lp->name);
-
-    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name", BAD_CAST valueToFree);
-    msFree(valueToFree);
-  } else {
-    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name", BAD_CAST lp->name);
-  }
-
-  if (lp->name && strlen(lp->name) > 0 &&
-      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
-  {
-    char szTmp[512];
-    snprintf(szTmp, sizeof(szTmp),
-             "WARNING: The layer name '%s' might contain spaces or "
-             "invalid characters or may start with a number. This could lead to potential problems",
-             lp->name);
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST szTmp));
-  }
-
-  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "title", validate_language);
-  if (!value)
-    value =(const char*)lp->name;
-
-  psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Title", BAD_CAST value);
-
-
-  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "abstract", validate_language);
-  if (value)
-    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Abstract", BAD_CAST value);
-
-
-
-  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "keywordlist", validate_language);
-
-  if(value)
-    msLibXml2GenerateList(
-        xmlNewChild(psRootNode, psNsOws, BAD_CAST "Keywords", NULL),
-        NULL, "Keyword", value, ',' );
-
-  /*support DefaultSRS and OtherSRS*/
-  valueToFree = msOWSGetProjURN(&(map->projection),&(map->web.metadata),"FO",MS_FALSE);
-  if (!valueToFree)
-    valueToFree = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", MS_FALSE);
-
-  if (valueToFree) {
-    int n = 0;
-    char** tokens = msStringSplit(valueToFree, ' ', &n);
-    if (tokens && n > 0) {
-      if( nWFSVersion == OWS_1_1_0 )
-        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultSRS", BAD_CAST tokens[0]));
-      else
-        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultCRS", BAD_CAST tokens[0]));
-      for (i=1; i<n; i++)
-      {
-        if( nWFSVersion == OWS_1_1_0 )
-          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherSRS", BAD_CAST tokens[i]));
-        else
-          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherCRS", BAD_CAST tokens[i]));
-      }
-    }
-    msFreeCharArray(tokens, n);
-  } else
-    xmlAddSibling(psNode,
-                  xmlNewComment(BAD_CAST "WARNING: Mandatory mapfile parameter: (at least one of) MAP.PROJECTION, LAYER.PROJECTION or wfs/ows_srs metadata was missing in this context."));
-
-  free(valueToFree);
-  valueToFree = NULL;
-
-  /*TODO: adevertize only gml3?*/
-  psNode = xmlNewNode(NULL, BAD_CAST "OutputFormats");
-  xmlAddChild(psRootNode, psNode);
-
-  {
-    char *formats_list = msWFSGetOutputFormatList( map, lp, nWFSVersion );
-    int iformat;
-    int n = 0;
-    char** tokens = msStringSplit(formats_list, ',', &n);
-
-    for( iformat = 0; iformat < n; iformat++ )
-      xmlNewTextChild(psNode, NULL, BAD_CAST "Format",
-                  BAD_CAST tokens[iformat] );
-    msFree( formats_list );
-    msFreeCharArray( tokens, n );
-  }
-
-  /*bbox*/
-  if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
-    /*convert to latlong*/
-    if (lp->projection.numargs > 0)
-      msOWSProjectToWGS84(&lp->projection, &ext);
-    else
-      msOWSProjectToWGS84(&map->projection, &ext);
-
-    xmlAddChild(psRootNode,
-                msOWSCommonWGS84BoundingBox( psNsOws, 2,
-                    ext.minx, ext.miny,
-                    ext.maxx, ext.maxy));
-  } else {
-    xmlAddSibling(psNode,
-                  xmlNewComment(BAD_CAST "WARNING: Optional WGS84BoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wfs_extent metadata. Also check that your data exists in the DATA statement"));
-  }
-
-  const char* metadataurl_list = msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
-  if( metadataurl_list ) {
-    int ntokens = 0;
-    char** tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
-      std::string key("metadataurl_");
-      key += tokens[i];
-      msWFSAddMetadataURL(lp, nWFSVersion, key, psRootNode);
-    }
-    msFreeCharArray(tokens, ntokens);
-  }
-  else {
-    if (! msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
-      msMetadataSetGetMetadataURL(lp, script_url);
-
-    msWFSAddMetadataURL(lp, nWFSVersion, "metadataurl", psRootNode);
-  }
-
-  return psRootNode;
-}
-
-/************************************************************************/
-/*                          msWFSGetCapabilities11                      */
-/*                                                                      */
-/*      Return the capabilities document for wfs 1.1.0                  */
-/************************************************************************/
-int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
-  xmlNodePtr psRootNode, psMainNode, psNode, psFtNode;
-  const char *updatesequence=NULL;
-  xmlNsPtr psNsOws, psNsXLink, psNsOgc;
-  char *schemalocation = NULL;
-  char *xsi_schemaLocation = NULL;
-  const char *user_namespace_prefix = NULL;
-  const char *user_namespace_uri = NULL;
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
-
-  char *script_url=NULL, *formats_list;
-  const char *value = NULL;
-
-  xmlChar *buffer = NULL;
-  int size = 0, i;
-  msIOContext *context = NULL;
-
-  int ows_version = OWS_1_0_0;
-  int ret;
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle updatesequence                                           */
-  /* -------------------------------------------------------------------- */
-  ret = msWFSHandleUpdateSequence(map, params, "msWFSGetCapabilities11()");
-  if( ret != MS_SUCCESS )
-      return ret;
-
-  /* -------------------------------------------------------------------- */
-  /*      Create document.                                                */
-  /* -------------------------------------------------------------------- */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "WFS_Capabilities");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* -------------------------------------------------------------------- */
-  /*      Name spaces                                                     */
-  /* -------------------------------------------------------------------- */
-  /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST "http://www.opengis.net/wfs");
-
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wfs", BAD_CAST "wfs"));
-
-  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  psNsXLink = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value) user_namespace_uri = value;
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value) user_namespace_prefix = value;
-  if(user_namespace_prefix != NULL && msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", user_namespace_prefix);
-  else
-    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
-
-  /* any additional namespaces */
-  namespaceList = msGMLGetNamespaces(&(map->web), "G");
-  for(i=0; i<namespaceList->numnamespaces; i++) {
-    if(namespaceList->namespaces[i].uri) {
-      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri, BAD_CAST namespaceList->namespaces[i].prefix);
-    }
-  }
-  msGMLFreeNamespaces(namespaceList);
-  
-
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion );
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
-
-  if (updatesequence)
-    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
-
-  /*schema*/
-  schemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-  xsi_schemaLocation = msStrdup("http://www.opengis.net/wfs");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/wfs/1.1.0/wfs.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-
-  /* -------------------------------------------------------------------- */
-  /*      Service metadata.                                               */
-  /* -------------------------------------------------------------------- */
-
-  xmlAddChild(psRootNode,
-                          msOWSCommonServiceIdentification(psNsOws, map, "OGC WFS", params->pszVersion, "FO", NULL));
-
-  /*service provider*/
-  xmlAddChild(psRootNode, msOWSCommonServiceProvider(
-                            psNsOws, psNsXLink, map, "FO", NULL));
-
-  /*operation metadata */
-  if ((script_url=msOWSGetOnlineResource(map, "FO", "onlineresource", req)) == NULL) {
-    msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities11()");
-    return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Operations metadata.                                            */
-  /* -------------------------------------------------------------------- */
-  psMainNode= xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psNsOws));
-
-  /* -------------------------------------------------------------------- */
-  /*      GetCapabilities                                                 */
-  /* -------------------------------------------------------------------- */
-  psNode = xmlAddChild(psMainNode,
-                       msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetCapabilities",
-                           OWS_METHOD_GETPOST, script_url));
-
-  xmlAddChild(psMainNode, psNode);
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                ows_version, psNsOws, "Parameter", "service", "WFS"));
-  /*accept version*/
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-              "Parameter", "AcceptVersions",
-              "1.0.0,1.1.0"));
-  /*format*/
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-              "Parameter", "AcceptFormats",
-              "text/xml"));
-
-
-  /* -------------------------------------------------------------------- */
-  /*      DescribeFeatureType                                             */
-  /* -------------------------------------------------------------------- */
-  if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE)) {
-    psNode = xmlAddChild(psMainNode,
-                         msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeFeatureType",
-                             OWS_METHOD_GETPOST, script_url));
-    xmlAddChild(psMainNode, psNode);
-
-    /*output format*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "outputFormat",
-                "XMLSCHEMA,text/xml; subtype=gml/2.1.2,text/xml; subtype=gml/3.1.1"));
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      GetFeature                                                      */
-  /* -------------------------------------------------------------------- */
-  if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
-
-    psNode = xmlAddChild(psMainNode,
-                         msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetFeature",
-                             OWS_METHOD_GETPOST, script_url));
-    xmlAddChild(psMainNode, psNode);
-
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "resultType",
-                "results,hits"));
-
-    formats_list = msWFSGetOutputFormatList( map, NULL, OWS_1_1_0 );
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "outputFormat",
-                formats_list));
-    msFree( formats_list );
-
-    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
-
-    if (value) {
-      xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                  "Constraint", "DefaultMaxFeatures",
-                  (char *)value));
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      FeatureTypeList                                                 */
-  /* -------------------------------------------------------------------- */
-
-  psFtNode = xmlNewNode(NULL, BAD_CAST "FeatureTypeList");
-  xmlAddChild(psRootNode, psFtNode);
-  psNode = xmlNewChild(psFtNode, NULL, BAD_CAST "Operations", NULL);
-  xmlNewChild(psNode, NULL, BAD_CAST "Operation", BAD_CAST "Query");
-
-  for(i=0; i<map->numlayers; i++) {
-    layerObj *lp;
-    lp = GET_LAYER(map, i);
-
-    if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers))
-      continue;
-
-    if (msWFSIsLayerSupported(lp))
-      xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_1_1_0, NULL, script_url));
-  }
-
-
-
-
-
-  /* -------------------------------------------------------------------- */
-  /*      Filter capabilities.                                            */
-  /* -------------------------------------------------------------------- */
-
-  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
-  xmlAddChild(psRootNode, FLTGetCapabilities(psNsOgc, psNsOgc, MS_FALSE));
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document.                                         */
-  /* -------------------------------------------------------------------- */
-
-  if( msIO_needBinaryStdout() == MS_FAILURE )
-    return MS_FAILURE;
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  context = msIO_getHandler(stdout);
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-  msIO_contextWrite(context, buffer, size);
-  xmlFree(buffer);
-
-  /*free buffer and the document */
-  /*xmlFree(buffer);*/
-  xmlFreeDoc(psDoc);
-  xmlFreeNs(psNsOgc);
-
-  free(script_url);
-  free(xsi_schemaLocation);
-  free(schemalocation);
-
-  xmlCleanupParser();
-
-  return(MS_SUCCESS);
-}
-
-
-#endif /*defined(USE_WFS_SVR) && defined(USE_LIBXML2)*/
-
-#if defined(USE_WFS_SVR) && !defined(USE_LIBXML2)
-
-
-
-int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-
-{
-  msSetError( MS_WFSERR,
-              "WFS 1.1 request made, but mapserver requires libxml2 for WFS 1.1 services and this is not configured.",
-              "msWFSGetCapabilities11()" );
-
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
-}
-
-int msWFSException11(mapObj *map, const char *locator, const char *exceptionCode, const char *version)
-{
-  /* fallback to reporting using 1.0 style exceptions. */
-  return msWFSException( map, locator, exceptionCode, "1.0.0" );
-}
-
-#endif /* defined(USE_WFS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/mapwfs20.c 8.2.0~beta1-1~exp1/mapwfs20.c
--- 8.0.1-5/mapwfs20.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwfs20.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1407 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OGC WFS 2.0.0 implementation. This file holds some WFS 2.0.0
- *           specific functions but other parts are still implemented in mapwfs.c.
- * Author:   Even Rouault
- *
- **********************************************************************
- * Copyright (c) 2013, Even Rouault
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "mapows.h"
-
-#if defined(USE_WFS_SVR) && defined(USE_LIBXML2)
-#include "maplibxml2.h"
-#include "mapowscommon.h"
-#include "mapogcfilter.h"
-
-#define MS_OWS_11_NAMESPACE_PREFIX       MS_OWSCOMMON_OWS_NAMESPACE_PREFIX
-#define MS_OWS_11_NAMESPACE_URI          MS_OWSCOMMON_OWS_110_NAMESPACE_URI
-
-#define URN_GET_FEATURE_BY_ID "urn:ogc:def:query:OGC-WFS::GetFeatureById"
-
-#define GET_FEATURE_BY_ID \
-"<StoredQueryDescription id=\"" URN_GET_FEATURE_BY_ID "\">" \
-"<Title>Get feature by identifier</Title>" \
-"<Abstract>Returns the single feature whose value is equal to the specified value of the ID argument</Abstract>" \
-"<Parameter name=\"ID\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" type=\"xs:string\"/>" \
-"<QueryExpressionText isPrivate=\"true\" language=\"urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression\" returnFeatureTypes=\"\">" \
-"<Query xmlns:fes=\"http://www.opengis.net/fes/2.0\" typeNames=\"?\">" \
-"<fes:Filter><fes:ResourceId rid=\"${ID}\"/></fes:Filter>" \
-"</Query>" \
-"</QueryExpressionText>" \
-"</StoredQueryDescription>"
-
-/************************************************************************/
-/*                          msWFSException20()                          */
-/************************************************************************/
-
-int msWFSException20(mapObj *map, const char *locator,
-                     const char *exceptionCode)
-{
-  int size = 0;
-  char *errorString     = NULL;
-
-  xmlDocPtr  psDoc      = NULL;
-  xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
-  const char* status    = NULL;
-
-  psNsOws = xmlNewNs(NULL, BAD_CAST MS_OWS_11_NAMESPACE_URI, BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
-
-  errorString = msGetErrorString("\n");
-
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_1_0, msOWSGetSchemasLocation(map), "2.0.0", msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  xmlNewNs(psRootNode, BAD_CAST MS_OWS_11_NAMESPACE_URI, BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
-
-  /* Table D.2 OGC 09-025r1 - For CITE compliance */
-  if( EQUAL(exceptionCode, MS_OWS_ERROR_OPERATION_NOT_SUPPORTED) ||
-      EQUAL(exceptionCode, MS_OWS_ERROR_OPTION_NOT_SUPPORTED) ) {
-    status = "400 Not Implemented";
-  }
-  else if( EQUAL(exceptionCode, MS_OWS_ERROR_MISSING_PARAMETER_VALUE) ||
-           EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_PARAMETER_VALUE) ||
-           EQUAL(exceptionCode, MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED) ||
-           EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE) ) {
-    status = "400 Bad request";
-  }
-  else if( EQUAL(exceptionCode, MS_WFS_ERROR_OPERATION_PROCESSING_FAILED) ) {
-    status = "403 Server processing failed";
-  }
-  else if( EQUAL(exceptionCode, MS_OWS_ERROR_NOT_FOUND) ) {
-    status = "404 Not Found";
-  }
-  else if( EQUAL(exceptionCode, MS_OWS_ERROR_NO_APPLICABLE_CODE) ) {
-    status = "400 Internal Server Error";
-  }
-
-  if( status != NULL )
-  {
-    msIO_setHeader("Status", "%s", status);
-  }
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
-
-  msIO_printf("%s", buffer);
-
-  /*free buffer and the document */
-  free(errorString);
-  xmlFree(buffer);
-  xmlFreeDoc(psDoc);
-  xmlFreeNs(psNsOws);
-
-  /* clear error since we have already reported it */
-  msResetErrorList();
-
-  return MS_FAILURE;
-}
-
-/************************************************************************/
-/*                          msWFSIncludeSection                         */
-/************************************************************************/
-static int msWFSIncludeSection(wfsParamsObj *params, const char* pszSection)
-{
-    int i;
-    if( params->pszSections == NULL )
-        return TRUE;
-    for(i = 0; params->pszSections[i] != '\0'; i++ )
-    {
-        if( strncasecmp( params->pszSections + i, "All", strlen("All")) == 0 )
-            return TRUE;
-        if( strncasecmp( params->pszSections + i, pszSection, strlen(pszSection)) == 0 )
-            return TRUE;
-    }
-    return FALSE;
-}
-
-/************************************************************************/
-/*                       msWFSConstraintDefaultValue                    */
-/************************************************************************/
-
-static
-xmlNodePtr msWFSConstraintDefaultValue(xmlNsPtr psNs, xmlNsPtr psNsOws, const char *name, const char* value)
-{
-  xmlNodePtr psRootNode = NULL;
-
-  psRootNode = xmlNewNode(psNs, BAD_CAST "Constraint");
-
-  xmlNewProp(psRootNode, BAD_CAST "name", BAD_CAST name);
-
-  xmlNewChild(psRootNode, psNsOws, BAD_CAST "NoValues", NULL );
-  xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "DefaultValue", BAD_CAST value);
-
-  return psRootNode;
-}
-
-/************************************************************************/
-/*                              msWFSOperator                           */
-/************************************************************************/
-
-static
-xmlNodePtr msWFSOperator(xmlNsPtr psNsFES, const char* pszOperatorType, const char* pszOperator)
-{
-    xmlNodePtr psNode = xmlNewNode(psNsFES, BAD_CAST pszOperatorType);
-    xmlNewProp(psNode, BAD_CAST "name", BAD_CAST pszOperator);
-    return psNode;
-}
-
-/************************************************************************/
-/*                       msWFS20FilterCapabilities                      */
-/************************************************************************/
-
-static
-xmlNodePtr msWFS20FilterCapabilities(xmlNsPtr psNsFES, xmlNsPtr psNsOws,
-                                     int bImplementsSorting)
-{
-  xmlNodePtr psRootNode = NULL, psNode = NULL, psSubNode = NULL;
-
-  psRootNode = xmlNewNode(psNsFES, BAD_CAST "Filter_Capabilities");
-  
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Conformance", NULL);
-  
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsQuery", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsAdHocQuery", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsFunctions", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsResourceId", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinStandardFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsStandardFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinSpatialFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsSpatialFilter", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinTemporalFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsTemporalFilter", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsVersionNav", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsSorting", ( bImplementsSorting ) ? "TRUE" : "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsExtendedOperators", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinimumXPath", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsSchemaElementFunc", "FALSE"));
-
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Id_Capabilities", NULL);
-    psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "ResourceIdentifier", NULL );
-    xmlNewProp(psSubNode, BAD_CAST "name", BAD_CAST "fes:ResourceId");
-
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Scalar_Capabilities", NULL);
-  xmlNewChild(psNode, psNsFES, BAD_CAST "LogicalOperators", NULL);
-  psNode = xmlNewChild(psNode, psNsFES, BAD_CAST "ComparisonOperators", NULL);
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsNotEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLessThan"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsGreaterThan"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLessThanOrEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsGreaterThanOrEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLike"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsBetween"));
-  /* Missing: PropertyIsNull, PropertyIsNil */
-
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Spatial_Capabilities", NULL);
-
-  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "GeometryOperands", NULL);
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Point"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPoint"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:LineString"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiLineString"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Curve"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiCurve"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Polygon"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPolygon"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Surface"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiSurface"));
-  /* xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiGeometry")); */
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Box"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Envelope"));
-
-  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "SpatialOperators", NULL);
-#ifdef USE_GEOS
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Equals"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Disjoint"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Touches"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Within"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Overlaps"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Crosses"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Intersects"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Contains"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "DWithin"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Beyond"));
-#endif
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "BBOX"));
-
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Temporal_Capabilities", NULL);
-    psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperands", NULL);
-    xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperand", "gml:TimePeriod"));
-    xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperand", "gml:TimeInstant"));
-
-    psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperators", NULL);
-    xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperator", "During"));
-
-  return psRootNode;
-}
-
-/************************************************************************/
-/*                          msXMLStripIndentation                       */
-/************************************************************************/
-
-static void msXMLStripIndentation(char* ptr)
-{
-    /* Remove spaces between > and < to get properly indented result */
-    char* afterLastClosingBracket = NULL;
-    if( *ptr == ' ' )
-        afterLastClosingBracket = ptr;
-    while( *ptr != '\0' )
-    {
-        if( *ptr == '<' && afterLastClosingBracket != NULL )
-        {
-            memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
-            ptr = afterLastClosingBracket;
-        }
-        else if( *ptr == '>' )
-        {
-            afterLastClosingBracket = ptr + 1;
-        }
-        else if( *ptr != ' ' &&  *ptr != '\n' )
-            afterLastClosingBracket = NULL;
-        ptr ++;
-    }
-}
-
-/************************************************************************/
-/*                          msWFSAddInspireDSID                         */
-/************************************************************************/
-
-static void msWFSAddInspireDSID(mapObj *map,
-                                xmlNsPtr psNsInspireDls,
-                                xmlNsPtr psNsInspireCommon,
-                                xmlNodePtr pDlsExtendedCapabilities)
-{
-    const char* dsid_code = msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_code");
-    const char* dsid_ns = msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_ns");
-    if( dsid_code == NULL )
-    {
-        xmlAddChild(pDlsExtendedCapabilities, xmlNewComment(BAD_CAST "WARNING: Required metadata \"inspire_dsid_code\" missing"));
-    }
-    else
-    {
-        int ntokensCode = 0, ntokensNS = 0;
-        char** tokensCode;
-        char** tokensNS = NULL;
-        int i;
-
-        tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
-        if( dsid_ns != NULL )
-            tokensNS = msStringSplitComplex( dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
-        if( ntokensNS > 0 && ntokensNS != ntokensCode )
-        {
-            xmlAddChild(pDlsExtendedCapabilities,
-                        xmlNewComment(BAD_CAST "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not the same number of elements. Ignoring inspire_dsid_ns"));
-            msFreeCharArray(tokensNS, ntokensNS);
-            tokensNS = NULL;
-            ntokensNS = 0;
-        }
-        for(i = 0; i<ntokensCode; i++ )
-        {
-            xmlNodePtr pSDSI = xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
-            xmlAddChild(pDlsExtendedCapabilities, pSDSI);
-            xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code", BAD_CAST tokensCode[i]);
-            if( ntokensNS > 0 && tokensNS[i][0] != '\0' )
-                xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace", BAD_CAST tokensNS[i]);
-        }
-        msFreeCharArray(tokensCode, ntokensCode);
-        if( ntokensNS > 0 )
-            msFreeCharArray(tokensNS, ntokensNS);
-    }
-}
-
-
-
-/************************************************************************/
-/*                          msWFSGetCapabilities20                      */
-/*                                                                      */
-/*      Return the capabilities document for WFS 2.0.0                  */
-/************************************************************************/
-int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
-  xmlNodePtr psRootNode, psMainNode, psNode, psFtNode = NULL;
-  const char *updatesequence=NULL;
-  xmlNsPtr psNsOws, psNsXLink;
-  xmlNsPtr psNsFES = NULL;
-  xmlNsPtr psNsInspireCommon = NULL;
-  xmlNsPtr psNsInspireDls = NULL;
-  xmlDocPtr pInspireTmpDoc = NULL;
-  char *xsi_schemaLocation = NULL;
-  const char *user_namespace_prefix = NULL;
-  const char *user_namespace_uri = NULL;
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
-
-  char *script_url=NULL, *formats_list;
-  const char *value = NULL;
-
-  xmlChar *buffer = NULL;
-  int size = 0, i;
-  msIOContext *context = NULL;
-
-  int ows_version = OWS_1_1_0;
-  int ret;
-
-  char* validated_language;
-  int bImplementsSorting = MS_FALSE;
-
-  /* -------------------------------------------------------------------- */
-  /*      Handle updatesequence                                           */
-  /* -------------------------------------------------------------------- */
-  ret = msWFSHandleUpdateSequence(map, params, "msWFSGetCapabilities20()");
-  if( ret != MS_SUCCESS )
-      return ret;
-
-  validated_language = msOWSGetLanguageFromList(map, "FO", params->pszLanguage);
-
-  /* -------------------------------------------------------------------- */
-  /*      Create document.                                                */
-  /* -------------------------------------------------------------------- */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "WFS_Capabilities");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* -------------------------------------------------------------------- */
-  /*      Name spaces                                                     */
-  /* -------------------------------------------------------------------- */
-  
-  /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
-
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
-
-  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  psNsXLink = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX );
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value)
-      user_namespace_uri = value;
-  else
-      user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
-
-  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value)
-      user_namespace_prefix = value;
-  else
-      user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
-
-  if(user_namespace_prefix != NULL && msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", user_namespace_prefix);
-  else
-    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
-
-  /* any additional namespaces */
-  namespaceList = msGMLGetNamespaces(&(map->web), "G");
-  for(i=0; i<namespaceList->numnamespaces; i++) {
-    if(namespaceList->namespaces[i].uri) {
-      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri, BAD_CAST namespaceList->namespaces[i].prefix);
-    }
-  }
-  msGMLFreeNamespaces(namespaceList);
-
-  if ( msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_capabilities") ) {
-      psNsInspireCommon = xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
-      psNsInspireDls = xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
-  }
-
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion );
-
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
-
-  if (updatesequence)
-    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
-
-  /*schema*/
-  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-
-  if( psNsInspireDls != NULL )
-  {
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_NAMESPACE_URI);
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_COMMON_NAMESPACE_URI);
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_COMMON_SCHEMA_LOCATION);
-  }
-
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-  free(xsi_schemaLocation);
-
-  /* -------------------------------------------------------------------- */
-  /*      Service metadata.                                               */
-  /* -------------------------------------------------------------------- */
-
-  /* TODO? : also add 1.1.0 and 1.0.0 as extra <ows:ServiceTypeVersion>. The OWS */
-  /* schema would suggest to do so, and also the example */
-  /* http://schemas.opengis.net/wfs/2.0/examples/GetCapabilities/GetCapabilities_Res_01.xml */
-  /* and Deegree too, but GeoServer also only lists the current version. */
-  if( msWFSIncludeSection(params, "ServiceIdentification") )
-  {
-    xmlAddChild(psRootNode,
-                msOWSCommonServiceIdentification(psNsOws, map, "WFS",
-                                                 params->pszVersion, "FO", validated_language));
-  }
-
-  /*service provider*/
-  if( msWFSIncludeSection(params, "ServiceProvider") )
-  {
-    xmlAddChild(psRootNode, msOWSCommonServiceProvider(
-                            psNsOws, psNsXLink, map, "FO", validated_language));
-  }
-
-  /*operation metadata */
-  if( msWFSIncludeSection(params, "OperationsMetadata") )
-  {
-    if ((script_url=msOWSGetOnlineResource2(map, "FO", "onlineresource", req, validated_language)) == NULL) {
-        msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities20()");
-        return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
-    }
-    
-
-    /* -------------------------------------------------------------------- */
-    /*      Operations metadata.                                            */
-    /* -------------------------------------------------------------------- */
-    psMainNode= xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psNsOws));
-    
-    /* -------------------------------------------------------------------- */
-    /*      GetCapabilities                                                 */
-    /* -------------------------------------------------------------------- */
-    psNode = xmlAddChild(psMainNode,
-                        msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetCapabilities",
-                            OWS_METHOD_GETPOST, script_url));
-
-    xmlAddChild(psMainNode, psNode);
-
-    /*accept version*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "AcceptVersions",
-                "2.0.0,1.1.0,1.0.0"));
-    /*format*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "AcceptFormats",
-                "text/xml"));
-    /*sections*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "Sections",
-                "ServiceIdentification,ServiceProvider,OperationsMetadata,FeatureTypeList,Filter_Capabilities"));
-
-    /* -------------------------------------------------------------------- */
-    /*      DescribeFeatureType                                             */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE)) {
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeFeatureType",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-
-        /*output format*/
-        xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                    "Parameter", "outputFormat",
-                    "application/gml+xml; version=3.2,"
-                    "text/xml; subtype=gml/3.2.1,"
-                    "text/xml; subtype=gml/3.1.1,"
-                    "text/xml; subtype=gml/2.1.2"));
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      GetFeature                                                      */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
-
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetFeature",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-
-        formats_list = msWFSGetOutputFormatList( map, NULL, OWS_2_0_0 );
-        xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                    "Parameter", "outputFormat",
-                    formats_list));
-        msFree( formats_list );
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      GetPropertyValue                                                */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "F", "GetPropertyValue", MS_TRUE)) {
-
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetPropertyValue",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-
-        /* Only advertize built-in GML formats for GetPropertyValue. Not sure */
-        /* it makes sense to advertize OGR formats. */
-        xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                    "Parameter", "outputFormat",
-                    "application/gml+xml; version=3.2,"
-                    "text/xml; subtype=gml/3.2.1,"
-                    "text/xml; subtype=gml/3.1.1,"
-                    "text/xml; subtype=gml/2.1.2"));
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      ListStoredQueries                                               */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "F", "ListStoredQueries", MS_TRUE)) {
-
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"ListStoredQueries",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      DescribeStoredQueries                                           */
-    /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeStoredQueries", MS_TRUE)) {
-
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeStoredQueries",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-    }
-
-    xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "version",
-                "2.0.0,1.1.0,1.0.0"));
-
-    /* Conformance declaration */
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsBasicWFS", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsTransactionalWFS", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsLockingWFS", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "KVPEncoding", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "XMLEncoding", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "SOAPEncoding", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsInheritance", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsRemoteResolve", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsResultPaging", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsStandardJoins", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsSpatialJoins", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsTemporalJoins", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsFeatureVersioning", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ManageStoredQueries", "FALSE"));
-
-    /* Capacity declaration */
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "PagingIsTransactionSafe", "FALSE"));
-
-    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
-    if (value) {
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "CountDefault", value));
-    }
-
-    xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Constraint", "QueryExpressions","wfs:Query,wfs:StoredQuery"));
-
-    /* Add Inspire Download Services extended capabilities */
-    if( psNsInspireDls != NULL )
-    {
-        msIOContext* old_context;
-        msIOContext* new_context;
-        msIOBuffer* buffer;
-        xmlNodePtr pRoot;
-        xmlNodePtr pOWSExtendedCapabilities;
-        xmlNodePtr pDlsExtendedCapabilities;
-        xmlNodePtr pChild;
-
-        old_context = msIO_pushStdoutToBufferAndGetOldContext();
-        msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "FO", OWS_WARN,
-                                                    "foo",
-                                                    "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
-                                                    "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
-                                                    "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"", validated_language, OWS_WFS);
-
-        new_context = msIO_getHandler(stdout);
-        buffer = (msIOBuffer *) new_context->cbData;
-
-        /* Remove spaces between > and < to get properly indented result */
-        msXMLStripIndentation( (char*) buffer->data );
-
-        pInspireTmpDoc = xmlParseDoc((const xmlChar *)buffer->data);
-        pRoot = xmlDocGetRootElement(pInspireTmpDoc);
-        xmlReconciliateNs(psDoc, pRoot);
-
-        pOWSExtendedCapabilities = xmlNewNode(psNsOws, BAD_CAST "ExtendedCapabilities");
-        xmlAddChild(psMainNode, pOWSExtendedCapabilities);
-
-        pDlsExtendedCapabilities = xmlNewNode(psNsInspireDls, BAD_CAST "ExtendedCapabilities");
-        xmlAddChild(pOWSExtendedCapabilities, pDlsExtendedCapabilities);
-
-        pChild = pRoot->children;
-        while(pChild != NULL)
-        {
-            xmlNodePtr pNext = pChild->next;
-            xmlUnlinkNode(pChild);
-            xmlAddChild(pDlsExtendedCapabilities, pChild);
-            pChild = pNext;
-        }
-
-        msWFSAddInspireDSID(map, psNsInspireDls, psNsInspireCommon, pDlsExtendedCapabilities);
-
-        msIO_restoreOldStdoutContext(old_context);
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      FeatureTypeList                                                 */
-  /* -------------------------------------------------------------------- */
-  if( msWFSIncludeSection(params, "FeatureTypeList") )
-  {
-    psFtNode = xmlNewNode(NULL, BAD_CAST "FeatureTypeList");
-    xmlAddChild(psRootNode, psFtNode);
-  }
-
-  for(i=0; i<map->numlayers; i++) {
-        layerObj *lp;
-        lp = GET_LAYER(map, i);
-
-        if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers))
-            continue;
-
-        if (msWFSIsLayerSupported(lp))
-        {
-          if( psFtNode != NULL ) {
-            xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_2_0_0, validated_language, script_url));
-          }
-
-          /* As soon as at least one layer supports sorting, advertize sorting */
-          if( msLayerSupportsSorting(lp) )
-              bImplementsSorting = MS_TRUE;
-        }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Filter capabilities.                                            */
-  /* -------------------------------------------------------------------- */
-  if( msWFSIncludeSection(params, "Filter_Capabilities") )
-  {
-    psNsFES = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX);
-    xmlAddChild(psRootNode, msWFS20FilterCapabilities(psNsFES, psNsOws, bImplementsSorting));
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document.                                         */
-  /* -------------------------------------------------------------------- */
-
-  if( msIO_needBinaryStdout() == MS_FAILURE )
-    return MS_FAILURE;
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  context = msIO_getHandler(stdout);
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-  msIO_contextWrite(context, buffer, size);
-  xmlFree(buffer);
-
-  /*free buffer and the document */
-  /*xmlFree(buffer);*/
-  xmlFreeDoc(psDoc);
-  if( psNsFES != NULL )
-      xmlFreeNs(psNsFES);
-  if( pInspireTmpDoc != NULL )
-      xmlFreeDoc(pInspireTmpDoc);
-
-  free(script_url);
-  msFree(validated_language);
-
-  xmlCleanupParser();
-
-  return(MS_SUCCESS);
-}
-
-/************************************************************************/
-/*                       msWFSGetStoredQueries                          */
-/*                                                                      */
-/* Result must be freed with msFreeCharArray()                          */
-/************************************************************************/
-
-static char** msWFSGetStoredQueries(mapObj *map, int* pn)
-{
-  const char* value;
-  char** tokens;
-  int i,n;
-  
-  value = msOWSLookupMetadata(&(map->web.metadata), "F", "storedqueries");
-  if( value != NULL )
-  {
-    tokens = msStringSplit(value, ',', &n);
-    for(i=0;i<n;i++)
-    {
-        if( strcasecmp(tokens[i], URN_GET_FEATURE_BY_ID) == 0 )
-            break;
-    }
-    /* Add mandatory GetFeatureById stored query if not found */
-    if(i == n)
-    {
-        tokens = (char**) realloc(tokens, (n+1) * sizeof(char*));
-        memmove(tokens + 1, tokens, n * sizeof(char*));
-        tokens[0] = msStrdup(URN_GET_FEATURE_BY_ID);
-        n ++;
-    }
-  }
-  else
-  {
-      tokens = (char**) malloc(sizeof(char*));
-      tokens[0] = msStrdup(URN_GET_FEATURE_BY_ID);
-      n = 1;
-  }
-  *pn = n;
-  return tokens;
-}
-
-/************************************************************************/
-/*                       msWFSGetStoredQuery                            */
-/*                                                                      */
-/* Result must be freed with msFree()                                   */
-/************************************************************************/
-
-static char* msWFSGetStoredQuery(mapObj *map, const char* pszURN)
-{
-    const char* value;
-    char szKey[256];
-    
-    snprintf(szKey, sizeof(szKey), "%s_inlinedef", pszURN);
-    value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
-    if( value != NULL )
-        return msStrdup(value);
-    
-    snprintf(szKey, sizeof(szKey), "%s_filedef", pszURN);
-    value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
-    if( value != NULL )
-    {
-        FILE* f = fopen(value, "rb");
-        if( f != NULL )
-        {
-            char* pszBuffer;
-            int nread;
-            long length;
-
-            fseek(f, 0, SEEK_END);
-            length = ftell(f);
-            if( length > 1000000 )
-            {
-                msSetError(MS_WFSERR, "%s: too big (%ld bytes > 1000000)",
-                           "msWFSGetStoredQuery()", value, length);
-                fclose(f);
-            }
-            else
-            {
-                fseek(f, 0, SEEK_SET);
-                pszBuffer = (char*) malloc((int)length + 1);
-                if( pszBuffer == NULL )
-                {
-                    msSetError(MS_WFSERR, "Cannot allocate %d bytes to read %s",
-                               "msWFSGetStoredQuery()",
-                               (int)length + 1, value);
-                    fclose(f);
-                }
-                else
-                {
-                    nread = (int)fread(pszBuffer, 1, length, f);
-                    fclose(f);
-                    if( nread == length )
-                    {
-                        pszBuffer[nread] = '\0';
-                        return pszBuffer;
-                    }
-                    msSetError(MS_WFSERR, "Could only read %d bytes / %d of %s",
-                               "msWFSGetStoredQuery()",
-                               nread, (int)length, value);
-                    msFree(pszBuffer);
-                }
-            }
-        }
-        else
-        {
-            msSetError(MS_WFSERR, "Cannot open %s", "msWFSGetStoredQuery()", value);
-        }
-    }
-
-    if( strcasecmp(pszURN, URN_GET_FEATURE_BY_ID) == 0 )
-        return msStrdup(GET_FEATURE_BY_ID);
-    return NULL;
-}
-
-/************************************************************************/
-/*                     msWFSGetResolvedStoredQuery20                    */
-/*                                                                      */
-/* Result must be freed with msFree()                                   */
-/************************************************************************/
-
-char* msWFSGetResolvedStoredQuery20(mapObj *map,
-                                    wfsParamsObj *wfsparams,
-                                    const char* id,
-                                    hashTableObj* hashTable)
-{
-    char* storedQuery;
-    xmlDocPtr psStoredQueryDoc;
-    xmlNodePtr psStoredQueryRoot, pChild;
-
-    storedQuery = msWFSGetStoredQuery(map, id);
-    if( storedQuery == NULL )
-    {
-        msSetError(MS_WFSERR, "Unknown stored query id: %s", "msWFSGetResolvedStoredQuery20()",
-                   id);
-        msWFSException(map, "storedqueryid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, wfsparams->pszVersion);
-        return NULL;
-    }
-
-    psStoredQueryDoc = xmlParseDoc((const xmlChar*) storedQuery);
-    if( psStoredQueryDoc == NULL )
-    {
-        msSetError(MS_WFSERR, "Definition for stored query '%s' is invalid", "msWFSGetResolvedStoredQuery20()", id);
-        msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wfsparams->pszVersion);
-        msFree(storedQuery);
-        return NULL;
-    }
-
-    psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
-
-    /* Check that all parameters are provided */
-    pChild = psStoredQueryRoot->children;
-    while(pChild != NULL)
-    {
-        if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "Parameter") == 0 )
-        {
-            xmlChar* parameterName = xmlGetProp(pChild, BAD_CAST "name");
-            if( parameterName != NULL )
-            {
-                char szTmp[256];
-                const char* value = msLookupHashTable(hashTable, (const char*)parameterName);
-                if( value == NULL )
-                {
-                    msSetError(MS_WFSERR, "Stored query '%s' requires parameter '%s'", "msWFSParseRequest()",
-                               id, (const char*)parameterName);
-                    msWFSException(map, (const char*)parameterName, MS_OWS_ERROR_MISSING_PARAMETER_VALUE, wfsparams->pszVersion);
-                    msFree(storedQuery);
-                    xmlFree(parameterName);
-                    xmlFreeDoc(psStoredQueryDoc);
-                    return NULL;
-                }
-
-                snprintf(szTmp, sizeof(szTmp), "${%s}", (const char*)parameterName);
-                storedQuery = msReplaceSubstring(storedQuery, szTmp, value);
-            }
-            xmlFree(parameterName);
-        }
-        pChild = pChild->next;
-    }
-
-    xmlFreeDoc(psStoredQueryDoc);
-
-    return storedQuery;
-}
-
-/************************************************************************/
-/*                       msWFSListStoredQueries20                       */
-/************************************************************************/
-
-int msWFSListStoredQueries20(mapObj *map, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc;
-  xmlChar *buffer = NULL;
-  int size = 0;
-  msIOContext *context = NULL;
-  xmlNodePtr psRootNode;
-  char *xsi_schemaLocation = NULL;
-  int i, j;
-  int nStoredQueries = 0;
-  char** storedQueries = NULL;
-
-  xmlDocPtr psStoredQueryDoc;
-  xmlNodePtr psStoredQueryRoot;
-  
-  /* -------------------------------------------------------------------- */
-  /*      Create document.                                                */
-  /* -------------------------------------------------------------------- */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "ListStoredQueriesResponse");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* -------------------------------------------------------------------- */
-  /*      Name spaces                                                     */
-  /* -------------------------------------------------------------------- */
-  
-  /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
-
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
-
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-
-  /*schema*/
-  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-  free(xsi_schemaLocation);
-
-  /* -------------------------------------------------------------------- */
-  /*      Add queries                                                     */
-  /* -------------------------------------------------------------------- */
-  
-  storedQueries = msWFSGetStoredQueries(map, &nStoredQueries);
-  for(i = 0; i < nStoredQueries; i++)
-  {
-    char* query = msWFSGetStoredQuery(map, storedQueries[i]);
-    if( query != NULL )
-    {
-      xmlNodePtr pChild;
-      xmlNodePtr psStoredQuery;
-
-      psStoredQueryDoc = xmlParseDoc((const xmlChar*) query);
-      if( psStoredQueryDoc == NULL )
-      {
-        char szMsg[256];
-        msFree(query);
-        snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s is invalid", storedQueries[i]);
-        xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
-        continue;
-      }
-
-      psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
-
-      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQuery" );
-      xmlNewProp(psStoredQuery, BAD_CAST "id", BAD_CAST storedQueries[i]);
-      xmlAddChild(psRootNode, psStoredQuery);
-
-      pChild = psStoredQueryRoot->children;
-      while(pChild != NULL)
-      {
-        xmlNodePtr pNext = pChild->next;
-        if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "Title") == 0 )
-        {
-            xmlUnlinkNode(pChild);
-            xmlAddChild(psStoredQuery, pChild);
-        }
-        else if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "QueryExpressionText") == 0 )
-        {
-            xmlNodePtr psReturnFeatureType;
-
-            if( strcasecmp( storedQueries[i], URN_GET_FEATURE_BY_ID ) == 0 )
-            {
-                for(j=0; j<map->numlayers; j++) {
-                    layerObj *lp;
-                    const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
-                    const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
-                    const char *value;
-                    char szValue[256];
-
-                    lp = GET_LAYER(map, j);
-
-                    if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers) ||
-                        !msWFSIsLayerSupported(lp))
-                    continue;
-
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-                    if(value) user_namespace_uri = value;
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-                    if(value) user_namespace_prefix = value;
-
-                    psReturnFeatureType = xmlNewNode(NULL, BAD_CAST "ReturnFeatureType" );
-                    xmlNewNs(psReturnFeatureType, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
-
-                    xmlAddChild(psStoredQuery, psReturnFeatureType);
-                    snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix, lp->name);
-                    xmlAddChild(psReturnFeatureType, xmlNewText( BAD_CAST szValue ));
-                }
-            }
-            else
-            {
-                xmlChar* returnFeatureTypes = xmlGetProp(pChild, BAD_CAST "returnFeatureTypes");
-                if( returnFeatureTypes != NULL && strlen((const char*)returnFeatureTypes) > 0 )
-                {
-                    int ntypes;
-                    char** types = msStringSplit((const char*)returnFeatureTypes, ' ', &ntypes);
-                    for(j=0; j<ntypes; j++)
-                    {
-                        psReturnFeatureType = xmlNewNode(NULL, BAD_CAST "ReturnFeatureType" );
-                        xmlAddChild(psStoredQuery, psReturnFeatureType);
-                        xmlAddChild(psReturnFeatureType, xmlNewText( BAD_CAST types[j] ));
-                    }
-                    msFreeCharArray(types, ntypes);
-                }
-                else
-                {
-                    psReturnFeatureType = xmlNewNode(NULL, BAD_CAST "ReturnFeatureType" );
-                    xmlAddChild(psStoredQuery, psReturnFeatureType);
-                    xmlAddChild(psReturnFeatureType, xmlNewComment( BAD_CAST "WARNING: Missing return type" ));
-                }
-                xmlFree(returnFeatureTypes);
-            }
-        }
-        pChild = pNext;
-      }
-
-      xmlReconciliateNs(psDoc, psStoredQuery);
-      xmlFreeDoc(psStoredQueryDoc);
-      msFree(query);
-    }
-    else
-    {
-      char szMsg[256];
-      snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s missing", storedQueries[i]);
-      xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
-    }
-  }
-  msFreeCharArray(storedQueries, nStoredQueries);
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document.                                         */
-  /* -------------------------------------------------------------------- */
-
-  if( msIO_needBinaryStdout() == MS_FAILURE )
-    return MS_FAILURE;
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  context = msIO_getHandler(stdout);
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-  msIO_contextWrite(context, buffer, size);
-  xmlFree(buffer);
-
-  /*free buffer and the document */
-  /*xmlFree(buffer);*/
-  xmlFreeDoc(psDoc);
-
-  xmlCleanupParser();
-
-  return(MS_SUCCESS);
-}
-
-
-/************************************************************************/
-/*                     msWFSDescribeStoredQueries20                     */
-/************************************************************************/
-
-int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
-                                 owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc;
-  xmlChar *buffer = NULL;
-  int size = 0;
-  msIOContext *context = NULL;
-  xmlNodePtr psRootNode;
-  char *xsi_schemaLocation = NULL;
-  int i, j;
-  int nStoredQueries = 0;
-  char** storedQueries = NULL;
-
-  xmlDocPtr psStoredQueryDoc;
-  xmlNodePtr psStoredQueryRoot;
-  
-  if( params->pszStoredQueryId != NULL ) {
-    storedQueries = msStringSplit(params->pszStoredQueryId,',',&nStoredQueries);
-    for(i = 0; i < nStoredQueries; i++)
-    {
-        char* query = msWFSGetStoredQuery(map, storedQueries[i]);
-        if( query == NULL )
-        {
-            msSetError(MS_WFSERR, "Unknown stored query id: %s", "msWFSDescribeStoredQueries20()",
-                       storedQueries[i]);
-            msFreeCharArray(storedQueries, nStoredQueries);
-            return msWFSException(map, "storedqueryid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, params->pszVersion);
-        }
-        msFree(query);
-    }
-  } else {
-    storedQueries = msWFSGetStoredQueries(map, &nStoredQueries);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Create document.                                                */
-  /* -------------------------------------------------------------------- */
-  psDoc = xmlNewDoc(BAD_CAST "1.0");
-
-  psRootNode = xmlNewNode(NULL, BAD_CAST "DescribeStoredQueriesResponse");
-
-  xmlDocSetRootElement(psDoc, psRootNode);
-
-  /* -------------------------------------------------------------------- */
-  /*      Name spaces                                                     */
-  /* -------------------------------------------------------------------- */
-  
-  /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
-
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
-
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-
-  /*schema*/
-  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
-  free(xsi_schemaLocation);
-
-  /* -------------------------------------------------------------------- */
-  /*      Add queries                                                     */
-  /* -------------------------------------------------------------------- */
-
-  for(i = 0; i < nStoredQueries; i++)
-  {
-    char* query = msWFSGetStoredQuery(map, storedQueries[i]);
-    if( query != NULL )
-    {
-      xmlNodePtr pChild;
-      xmlNs*  ns;
-      xmlNodePtr psStoredQuery;
-
-      psStoredQueryDoc = xmlParseDoc((const xmlChar*) query);
-      if( psStoredQueryDoc == NULL )
-      {
-        char szMsg[256];
-        msFree(query);
-        snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s is invalid", storedQueries[i]);
-        xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
-        continue;
-      }
-
-      psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
-
-      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQueryDescription" );
-      xmlNewProp(psStoredQuery, BAD_CAST "id", BAD_CAST storedQueries[i]);
-      xmlAddChild(psRootNode, psStoredQuery);
-
-      ns = psStoredQueryRoot->nsDef;
-      while( ns != NULL ) {
-        xmlNewNs(psStoredQuery, BAD_CAST ns->href, BAD_CAST ns->prefix);
-        ns = ns->next;
-      }
-
-      pChild = psStoredQueryRoot->children;
-      while(pChild != NULL)
-      {
-        xmlNodePtr pNext = pChild->next;
-
-        if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "QueryExpressionText") == 0 )
-        {
-            if( strcasecmp( storedQueries[i], URN_GET_FEATURE_BY_ID ) == 0 )
-            {
-                char** arrayNsPrefix = (char**) malloc( sizeof(char*) * map->numlayers );
-                char** arrayNsUri = (char**) malloc( sizeof(char*) * map->numlayers );
-                int arraysize = 0;
-                int k;
-                char* returnFeatureTypes = NULL;
-                xmlNodePtr psQueryExpressionText;
-
-                psQueryExpressionText = xmlNewNode(NULL, BAD_CAST "QueryExpressionText" );
-                xmlAddChild(psStoredQuery, psQueryExpressionText);
-                xmlNewProp(psQueryExpressionText, BAD_CAST "isPrivate", BAD_CAST "true");
-                xmlNewProp(psQueryExpressionText, BAD_CAST "language", BAD_CAST "urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression");
-
-                for(j=0; j<map->numlayers; j++) {
-                    layerObj *lp;
-                    const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
-                    const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
-                    const char *value;
-                    char szValue[256];
-
-                    lp = GET_LAYER(map, j);
-
-                    if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers) ||
-                        !msWFSIsLayerSupported(lp))
-                    continue;
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-                    if(value) user_namespace_uri = value;
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-                    if(value) user_namespace_prefix = value;
-
-                    for(k=0;k<arraysize;k++)
-                    {
-                        if( strcmp(arrayNsPrefix[k], user_namespace_prefix) == 0 )
-                            break;
-                    }
-                    if(k == arraysize) {
-                      arrayNsPrefix[arraysize] = msStrdup(user_namespace_prefix);
-                      arrayNsUri[arraysize] = msStrdup(user_namespace_uri);
-                      arraysize ++;
-
-                      xmlNewNs(psQueryExpressionText, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
-                    }
-
-                    if( returnFeatureTypes != NULL )
-                      returnFeatureTypes = msStringConcatenate(returnFeatureTypes, " ");
-                    snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix, lp->name);
-                    returnFeatureTypes = msStringConcatenate(returnFeatureTypes, szValue);
-                }
-
-                xmlNewProp(psQueryExpressionText, BAD_CAST "returnFeatureTypes", BAD_CAST returnFeatureTypes);
-
-                msFree(returnFeatureTypes);
-                msFreeCharArray(arrayNsPrefix, arraysize);
-                msFreeCharArray(arrayNsUri, arraysize);
-            }
-            else
-            {
-                xmlChar* isPrivate = xmlGetProp(pChild, BAD_CAST "isPrivate");
-                if( isPrivate != NULL && strcmp((const char*)isPrivate, "true") == 0) {
-                    xmlNodePtr pSubChild = xmlFirstElementChild(pChild);
-                    xmlUnlinkNode(pSubChild);
-                    xmlFreeNode(pSubChild);
-                }
-                xmlUnlinkNode(pChild);
-                xmlAddChild(psStoredQuery, pChild);
-                msFree(isPrivate);
-            }
-        }
-        else {
-            xmlUnlinkNode(pChild);
-            xmlAddChild(psStoredQuery, pChild);
-        }
-        pChild = pNext;
-      }
-
-      xmlReconciliateNs(psDoc, psStoredQuery);
-      xmlFreeDoc(psStoredQueryDoc);
-      msFree(query);
-    }
-    else
-    {
-      char szMsg[256];
-      snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s missing", storedQueries[i]);
-      xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
-    }
-  }
-  msFreeCharArray(storedQueries, nStoredQueries);
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out the document.                                         */
-  /* -------------------------------------------------------------------- */
-
-  if( msIO_needBinaryStdout() == MS_FAILURE )
-    return MS_FAILURE;
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  context = msIO_getHandler(stdout);
-
-  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
-  msIO_contextWrite(context, buffer, size);
-  xmlFree(buffer);
-
-  /*free buffer and the document */
-  /*xmlFree(buffer);*/
-  xmlFreeDoc(psDoc);
-
-  xmlCleanupParser();
-
-  return(MS_SUCCESS);
-}
-
-#endif /* defined(USE_WFS_SVR) && defined(USE_LIBXML2) */
-
-#if defined(USE_WFS_SVR) && !defined(USE_LIBXML2)
-
-int msWFSException20(mapObj *map, const char *locator,
-                     const char *exceptionCode)
-{
-  /* fallback to reporting using 1.0 style exceptions. */
-  return msWFSException( map, locator, exceptionCode, "1.0.0" );
-}
-
-int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-
-{
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSGetCapabilities20()" );
-
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
-}
-
-int msWFSListStoredQueries20(mapObj *map, wfsParamsObj *params,
-                             cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSListStoredQueries20()");
-
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
-}
-
-int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
-                             cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSDescribeStoredQueries20()" );
-
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
-}
-
-char* msWFSGetResolvedStoredQuery20(mapObj *map,
-                                    wfsParamsObj *params,
-                                    const char* id,
-                                    hashTableObj* hashTable)
-{
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSGetResolvedStoredQuery20()" );
-
-  msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
-  return NULL;
-}
-
-#endif /* defined(USE_WFS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/mapwfslayer.c 8.2.0~beta1-1~exp1/mapwfslayer.c
--- 8.0.1-5/mapwfslayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwfslayer.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1293 +0,0 @@
-/**********************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of WFS CONNECTIONTYPE - client to WFS servers
- * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
- *
- **********************************************************************
- * Copyright (c) 2002, Daniel Morissette, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapows.h"
-#include "mapproject.h"
-
-#include <time.h>
-#include <assert.h>
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#include <process.h>
-#endif
-
-
-
-#define WFS_V_0_0_14  14
-#define WFS_V_1_0_0  100
-
-
-/*====================================================================
- *  Private (static) functions
- *====================================================================*/
-
-#ifdef USE_WFS_LYR
-
-/************************************************************************/
-/*                           msBuildRequestParms                        */
-/*                                                                      */
-/*      Build the params object based on the metadata                   */
-/*      information. This object will be used when building the Get     */
-/*      and Post requsests.                                             */
-/*      Note : Verify the connection string to extract some values      */
-/*      for backward compatiblity. (It is though depricated).           */
-/*      This will also set layer projection and compute BBOX in that    */
-/*      projection.                                                     */
-/*                                                                      */
-/************************************************************************/
-static wfsParamsObj *msBuildRequestParams(mapObj *map, layerObj *lp,
-    rectObj *bbox_ret)
-{
-  wfsParamsObj *psParams = NULL;
-  rectObj bbox;
-  const char *pszTmp;
-  char *pszVersion, *pszTypeName;
-
-  if (!map || !lp || !bbox_ret)
-    return NULL;
-
-  if (lp->connection == NULL)
-    return NULL;
-
-  psParams = msWFSCreateParamsObj();
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "version");
-  if (pszTmp)
-    psParams->pszVersion = msStrdup(pszTmp);
-  else {
-    pszTmp = strstr(lp->connection, "VERSION=");
-    if (!pszTmp)
-      pszTmp = strstr(lp->connection, "version=");
-    if (pszTmp) {
-      pszVersion = strchr(pszTmp, '=')+1;
-      if (strncmp(pszVersion, "0.0.14", 6) == 0)
-        psParams->pszVersion = msStrdup("0.0.14");
-      else if (strncmp(pszVersion, "1.0.0", 5) == 0)
-        psParams->pszVersion = msStrdup("1.0.0");
-    }
-  }
-
-  /*the service is always set to WFS : see bug 1302 */
-  psParams->pszService = msStrdup("WFS");
-
-  /*
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "service");
-  if (pszTmp)
-    psParams->pszService = msStrdup(pszTmp);
-  else
-  {
-      pszTmp = strstr(lp->connection, "SERVICE=");
-      if (!pszTmp)
-        pszTmp = strstr(lp->connection, "service=");
-      if (pszTmp)
-      {
-          pszService = strchr(pszTmp, '=')+1;
-          if (strncmp(pszService, "WFS", 3) == 0)
-            psParams->pszService = msStrdup("WFS");
-      }
-  }
-  */
-
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "geometryname");
-  if (pszTmp)
-    psParams->pszGeometryName = msStrdup(pszTmp);
-
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "typename");
-  if (pszTmp)
-    psParams->pszTypeName = msStrdup(pszTmp);
-  else {
-    pszTmp = strstr(lp->connection, "TYPENAME=");
-    if (!pszTmp)
-      pszTmp = strstr(lp->connection, "typename=");
-    if (pszTmp) {
-      pszTypeName = strchr(pszTmp, '=')+1;
-      if (pszTypeName) {
-        const int nLength = strlen(pszTypeName);
-        if (nLength > 0) {
-          int i=0;
-          for (; i<nLength; i++) {
-            if (pszTypeName[i] == '&')
-              break;
-          }
-
-          if (i<nLength) {
-            char *pszTypeNameTmp = NULL;
-            pszTypeNameTmp = msStrdup(pszTypeName);
-            pszTypeNameTmp[i] = '\0';
-            psParams->pszTypeName = msStrdup(pszTypeNameTmp);
-            free(pszTypeNameTmp);
-          } else
-            psParams->pszTypeName = msStrdup(pszTypeName);
-        }
-      }
-    }
-  }
-
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "filter");
-  if (pszTmp && strlen(pszTmp) > 0) {
-    if (strstr(pszTmp, "<Filter>") !=NULL || strstr(pszTmp, "<ogc:Filter") != NULL)
-      psParams->pszFilter = msStrdup(pszTmp);
-    else {
-      psParams->pszFilter = msStringConcatenate(psParams->pszFilter, "<ogc:Filter xmlns:ogc=\"http://www.opengis.net/ogc\">");
-      psParams->pszFilter = msStringConcatenate(psParams->pszFilter, (char*)pszTmp);
-      psParams->pszFilter = msStringConcatenate(psParams->pszFilter, "</ogc:Filter>");
-    }
-  }
-
-  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "maxfeatures");
-  if (pszTmp)
-    psParams->nMaxFeatures = atoi(pszTmp);
-
-  /* Request is always GetFeature; */
-  psParams->pszRequest = msStrdup("GetFeature");
-
-
-  /* ------------------------------------------------------------------
-   * Figure the SRS we'll use for the request.
-   * - Fetch the map SRS (if it's EPSG)
-   * - Check if map SRS is listed in layer wfs_srs metadata
-   * - If map SRS is valid for this layer then use it
-   * - Otherwise request layer in its default SRS and we'll reproject later
-   * ------------------------------------------------------------------ */
-
-  /* __TODO__ WFS servers support only one SRS... need to decide how we'll */
-  /* handle this and document it well. */
-  /* It's likely that we'll simply reproject the BBOX to teh layer's projection. */
-
-  /* ------------------------------------------------------------------
-   * Set layer SRS and reproject map extents to the layer's SRS
-   * ------------------------------------------------------------------ */
-#ifdef __TODO__
-  /* No need to set lp->proj if it's already set to the right EPSG code */
-  if ((pszTmp = msGetEPSGProj(&(lp->projection), NULL, MS_TRUE)) == NULL ||
-      strcasecmp(pszEPSG, pszTmp) != 0) {
-    char szProj[20];
-    snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG+5);
-    if (msLoadProjectionString(&(lp->projection), szProj) != 0)
-      return NULL;
-  }
-#endif
-
-  bbox = map->extent;
-  if (msProjectionsDiffer(&(map->projection), &(lp->projection))) {
-    msProjectRect(&(map->projection), &(lp->projection), &bbox);
-  }
-
-  *bbox_ret = bbox;
-
-  return psParams;
-
-}
-
-/**********************************************************************
- *                          msBuildWFSLayerPostRequest()
- *
- * Build a WFS GetFeature xml document for a Post Request.
- *
- * Returns a reference to a newly allocated string that should be freed
- * by the caller.
- **********************************************************************/
-static char *msBuildWFSLayerPostRequest(rectObj *bbox, wfsParamsObj *psParams)
-{
-  char *pszPostReq = NULL;
-  char *pszFilter = NULL;
-  char *pszGeometryName = "Geometry";
-  size_t bufferSize = 0;
-
-  if (psParams->pszVersion == NULL ||
-      (strncmp(psParams->pszVersion, "0.0.14", 6) != 0 &&
-       strncmp(psParams->pszVersion, "1.0.0", 5)) != 0) {
-    msSetError(MS_WFSCONNERR, "MapServer supports only WFS 1.0.0 or 0.0.14 (please verify the version metadata wfs_version).", "msBuildWFSLayerPostRequest()");
-    return NULL;
-  }
-
-
-
-  if (psParams->pszTypeName == NULL) {
-    msSetError(MS_WFSCONNERR, "Metadata wfs_typename must be set in the layer", "msBuildWFSLayerPostRequest()");
-    return NULL;
-  }
-
-
-  if (psParams->pszGeometryName) {
-    pszGeometryName = psParams->pszGeometryName;
-  }
-
-  if (psParams->pszFilter)
-    pszFilter = psParams->pszFilter;
-  else {
-    bufferSize = 500;
-    pszFilter = (char *)msSmallMalloc(bufferSize);
-    snprintf(pszFilter, bufferSize, "<ogc:Filter>\n"
-             "<ogc:BBOX>\n"
-             "<ogc:PropertyName>%s</ogc:PropertyName>\n"
-             "<gml:Box>\n"
-             "<gml:coordinates>%f,%f %f,%f</gml:coordinates>\n"
-             "</gml:Box>\n"
-             "</ogc:BBOX>\n"
-             "</ogc:Filter>", pszGeometryName, bbox->minx, bbox->miny, bbox->maxx, bbox->maxy);
-  }
-
-  bufferSize = strlen(pszFilter)+strlen(psParams->pszTypeName)+500;
-  pszPostReq = (char *)msSmallMalloc(bufferSize);
-  if (psParams->nMaxFeatures > 0)
-    snprintf(pszPostReq, bufferSize, "<?xml version=\"1.0\" ?>\n"
-             "<wfs:GetFeature\n"
-             "service=\"WFS\"\n"
-             "version=\"1.0.0\"\n"
-             "maxFeatures=\"%d\"\n"
-             "outputFormat=\"GML2\"\n"
-			 "xmlns:wfs=\"http://www.opengis.net/wfs\" xmlns:ogc=\"http://www.opengis.net/ogc\" xsi:schemaLocation=\"http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:gml=\"http://www.opengis.net/gml\">\n"
-             "<wfs:Query typeName=\"%s\">\n"
-             "%s"
-             "</wfs:Query>\n"
-             "</wfs:GetFeature>\n", psParams->nMaxFeatures, psParams->pszTypeName, pszFilter);
-  else
-    snprintf(pszPostReq, bufferSize, "<?xml version=\"1.0\" ?>\n"
-             "<wfs:GetFeature\n"
-             "service=\"WFS\"\n"
-             "version=\"1.0.0\"\n"
-             "outputFormat=\"GML2\"\n"
-             "xmlns:wfs=\"http://www.opengis.net/wfs\" xmlns:ogc=\"http://www.opengis.net/ogc\" xsi:schemaLocation=\"http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:gml=\"http://www.opengis.net/gml\">\n"
-             "<wfs:Query typeName=\"%s\">\n"
-             "%s"
-             "</wfs:Query>\n"
-             "</wfs:GetFeature>\n", psParams->pszTypeName, pszFilter);
-  if (psParams->pszFilter == NULL)
-    free(pszFilter);
-
-
-  return pszPostReq;
-}
-
-/**********************************************************************
- *                          msBuildWFSLayerGetURL()
- *
- * Build a WFS GetFeature URL for a Get Request.
- *
- * Returns a reference to a newly allocated string that should be freed
- * by the caller.
- **********************************************************************/
-static char *msBuildWFSLayerGetURL(layerObj *lp, rectObj *bbox,
-                                   wfsParamsObj *psParams)
-{
-  char *pszURL = NULL, *pszOnlineResource=NULL;
-  const char *pszTmp;
-  char *pszVersion, *pszService, *pszTypename = NULL;
-  int bVersionInConnection = 0;
-  int bTypenameInConnection = 0;
-  size_t bufferSize = 0;
-
-  if (lp->connectiontype != MS_WFS || lp->connection == NULL) {
-    msSetError(MS_WFSCONNERR, "Call supported only for CONNECTIONTYPE WFS",
-               "msBuildWFSLayerGetURL()");
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Find out request version. Look first for the wfs_version        */
-  /*      metedata. If not available try to find out if the CONNECTION    */
-  /*      string contains the version. This last test is done for         */
-  /*      backward compatiblity but is depericated.                       */
-  /* -------------------------------------------------------------------- */
-  pszVersion = psParams->pszVersion;
-  if (!pszVersion) {
-    if ((pszTmp = strstr(lp->connection, "VERSION=")) == NULL &&
-        (pszTmp = strstr(lp->connection, "version=")) == NULL ) {
-      msSetError(MS_WFSCONNERR, "Metadata wfs_version must be set in the layer", "msBuildWFSLayerGetURL()");
-      return NULL;
-    }
-    pszVersion = strchr(pszTmp, '=')+1;
-    bVersionInConnection = 1;
-  }
-
-
-  if (strncmp(pszVersion, "0.0.14", 6) != 0 &&
-      strncmp(pszVersion, "1.0.0", 5) != 0 &&
-      strncmp(pszVersion, "1.1", 3) != 0) {
-    msSetError(MS_WFSCONNERR,
-	       "MapServer supports only WFS 1.1.0, 1.0.0 or 0.0.14 (please verify the version metadata wfs_version).",
-	       "msBuildWFSLayerGetURL()");
-    return NULL;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Find out the service. It is always set to WFS in function       */
-  /*      msBuildRequestParms  (check Bug 1302 for details).              */
-  /* -------------------------------------------------------------------- */
-  pszService = psParams->pszService;
-
-
-  /* -------------------------------------------------------------------- */
-  /*      Find out the typename. Look first for the wfs_tyename           */
-  /*      metadata. If not available try to find out if the CONNECTION    */
-  /*      string contains it. This last test is done for                  */
-  /*      backward compatiblity but is depericated.                       */
-  /* -------------------------------------------------------------------- */
-  pszTypename = psParams->pszTypeName;
-  if (!pszTypename) {
-    if ((pszTmp = strstr(lp->connection, "TYPENAME=")) == NULL &&
-        (pszTmp = strstr(lp->connection, "typename=")) == NULL ) {
-      msSetError(MS_WFSCONNERR, "Metadata wfs_typename must be set in the layer", "msBuildWFSLayerGetURL()");
-      return NULL;
-    }
-    bTypenameInConnection = 1;
-  }
-
-
-  /* --------------------------------------------------------------------
-   * Build the request URL.
-   * At this point we set only the following parameters for GetFeature:
-   *   REQUEST
-   *   BBOX
-   *   VERSION
-   *   SERVICE
-   *   TYPENAME
-   *   FILTER
-   *   MAXFEATURES
-   *
-   * For backward compatiblity the user could also have in the connection
-   * string the following parameters (but it is depricated):
-   *   VERSION
-   *   SERVICE
-   *   TYPENAME
-   * -------------------------------------------------------------------- */
-  /* Make sure we have a big enough buffer for the URL */
-  bufferSize = strlen(lp->connection)+1024;
-  pszURL = (char *)malloc(bufferSize);
-  MS_CHECK_ALLOC(pszURL, bufferSize, NULL);
-
-  /* __TODO__ We have to urlencode each value... especially the BBOX values */
-  /* because if they end up in exponent format (123e+06) the + will be seen */
-  /* as a space by the remote server. */
-
-  /* -------------------------------------------------------------------- */
-  /*      build the URL,                                                  */
-  /* -------------------------------------------------------------------- */
-  /* make sure connection ends with "&" or "?" */
-  pszOnlineResource = msOWSTerminateOnlineResource(lp->connection);
-  snprintf(pszURL, bufferSize, "%s", pszOnlineResource);
-  msFree(pszOnlineResource);
-
-  /* REQUEST */
-  snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&REQUEST=GetFeature");
-
-  /* VERSION */
-  if (!bVersionInConnection)
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&VERSION=%s", pszVersion);
-
-  /* SERVICE */
-  snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&SERVICE=%s", pszService);
-
-  /* TYPENAME */
-  if (!bTypenameInConnection)
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&TYPENAME=%s", pszTypename);
-
-  /* -------------------------------------------------------------------- */
-  /*      If the filter parameter is given in the wfs_filter metadata,    */
-  /*      we use it and do not send the BBOX paramter as they are         */
-  /*      mutually exclusive.                                             */
-  /* -------------------------------------------------------------------- */
-  if (psParams->pszFilter) {
-    char *encoded_filter = msEncodeUrl(psParams->pszFilter);
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL), "&FILTER=%s",encoded_filter);
-    free(encoded_filter);
-  } else {
-	  /*
-	   * take care about the axis order for WFS 1.1
-	   */
-	  char *projUrn;
-	  char *projEpsg;
-	  projUrn = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", 1);
-	  msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", 1, &projEpsg);
-
-	  /*
-	   * WFS 1.1 supports including the SRS in the BBOX parameter, should
-	   * respect axis order in the BBOX and has a separate SRSNAME parameter for
-	   * the desired result SRS.
-	   * WFS 1.0 is always easting, northing, doesn't include the SRS as part of
-	   * the BBOX parameter and has no SRSNAME parameter: if we don't have a
-	   * URN then fallback to WFS 1.0 style */
-	  if ((strncmp(pszVersion, "1.1", 3) == 0) && projUrn) {
-		 if (projEpsg && (strncmp(projEpsg, "EPSG:", 5) == 0) &&
-				 msIsAxisInverted(atoi(projEpsg + 5))) {
-			 snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
-					 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s",
-					 bbox->miny, bbox->minx, bbox->maxy, bbox->maxx,
-					 projUrn, projUrn);
-		 } else {
-			 snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
-					 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s",
-					 bbox->minx, bbox->miny, bbox->maxx, bbox->maxy,
-					 projUrn, projUrn);
-		 }
-	  } else {
-		  snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
-				  "&BBOX=%.15g,%.15g,%.15g,%.15g",
-				  bbox->minx, bbox->miny, bbox->maxx, bbox->maxy);
-	  }
-
-	  msFree(projUrn);
-	  msFree(projEpsg);
-  }
-
-  if (psParams->nMaxFeatures > 0)
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),
-             "&MAXFEATURES=%d", psParams->nMaxFeatures);
-
-  return pszURL;
-
-}
-
-/**********************************************************************
- *                          msWFSLayerInfo
- *
- **********************************************************************/
-typedef struct ms_wfs_layer_info_t {
-  char        *pszGMLFilename;
-  rectObj     rect;                     /* set by WhichShapes */
-  char        *pszGetUrl;
-  int         nStatus;           /* HTTP status */
-  int         bLayerHasValidGML;  /* False until msWFSLayerWhichShapes() is called and determines the result GML is valid with features*/
-} msWFSLayerInfo;
-
-
-/**********************************************************************
- *                          msAllocWFSLayerInfo()
- *
- **********************************************************************/
-static msWFSLayerInfo *msAllocWFSLayerInfo(void)
-{
-  msWFSLayerInfo *psInfo;
-
-  psInfo = (msWFSLayerInfo*)calloc(1,sizeof(msWFSLayerInfo));
-  MS_CHECK_ALLOC(psInfo, sizeof(msWFSLayerInfo), NULL);
-
-  psInfo->pszGMLFilename = NULL;
-  psInfo->rect.minx = psInfo->rect.maxx = 0;
-  psInfo->rect.miny = psInfo->rect.maxy = 0;
-  psInfo->pszGetUrl = NULL;
-  psInfo->nStatus = 0;
-
-  return psInfo;
-}
-
-/**********************************************************************
- *                          msFreeWFSLayerInfo()
- *
- **********************************************************************/
-static void msFreeWFSLayerInfo(msWFSLayerInfo *psInfo)
-{
-  if (psInfo) {
-    if (psInfo->pszGMLFilename)
-      free(psInfo->pszGMLFilename);
-    if (psInfo->pszGetUrl)
-      free(psInfo->pszGetUrl);
-
-    free(psInfo);
-  }
-}
-
-#endif /* USE_WFS_LYR */
-
-/*====================================================================
- *  Public functions
- *====================================================================*/
-
-/**********************************************************************
- *                          msPrepareWFSLayerRequest()
- *
- **********************************************************************/
-
-int msPrepareWFSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
-                             httpRequestObj *pasReqInfo, int *numRequests)
-{
-#ifdef USE_WFS_LYR
-  char *pszURL = NULL;
-  const char *pszTmp;
-  rectObj bbox;
-  int nTimeout;
-  int nStatus = MS_SUCCESS;
-  msWFSLayerInfo *psInfo = NULL;
-  int bPostRequest = 0;
-  wfsParamsObj *psParams = NULL;
-  char *pszHTTPCookieData = NULL;
-
-
-  if (lp->connectiontype != MS_WFS || lp->connection == NULL)
-    return MS_FAILURE;
-
-  /* ------------------------------------------------------------------
-   * Build a params object that will be used by to build the request,
-    this will also set layer projection and compute BBOX in that projection.
-   * ------------------------------------------------------------------ */
-  psParams = msBuildRequestParams(map, lp, &bbox);
-  if (!psParams)
-    return MS_FAILURE;
-
-  /* -------------------------------------------------------------------- */
-  /*      Depending on the metadata wfs_request_method, build a Get or    */
-  /*      a Post URL.                                                     */
-  /*    If it is a Get request the URL would contain all the parameters in*/
-  /*      the string;                                                     */
-  /*      If it is a Post request, the URL will only contain the          */
-  /*      connection string comming from the layer.                       */
-  /* -------------------------------------------------------------------- */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "FO", "request_method")) != NULL) {
-    if (strncmp(pszTmp, "GET", 3) ==0) {
-      pszURL = msBuildWFSLayerGetURL(lp, &bbox, psParams);
-      if (!pszURL) {
-        /* an error was already reported. */
-        return MS_FAILURE;
-      }
-    }
-  }
-  /* else it is a post request and just get the connection string */
-  if (!pszURL) {
-    bPostRequest = 1;
-    pszURL = msStrdup(lp->connection);
-  }
-
-  /* ------------------------------------------------------------------
-   * check to see if a the metadata wfs_connectiontimeout is set. If it is
-   * the case we will use it, else we use the default which is 30 seconds.
-   * First check the metadata in the layer object and then in the map object.
-   * ------------------------------------------------------------------ */
-  nTimeout = 30;  /* Default is 30 seconds  */
-  if ((pszTmp = msOWSLookupMetadata2(&(lp->metadata), &(map->web.metadata),
-                                    "FO", "connectiontimeout")) != NULL) {
-    nTimeout = atoi(pszTmp);
-  }
-
-  /*------------------------------------------------------------------
-   * Check to see if there's a HTTP Cookie to forward
-   * If Cookie differ between the two connection, it's NOT OK to merge
-   * the connection
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "FO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
-        pszHTTPCookieData = msStrdup(pszTmp);
-      }
-    } else {
-      pszHTTPCookieData = msStrdup(pszTmp);
-    }
-  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata),
-                       "FO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
-        pszHTTPCookieData = msStrdup(pszTmp);
-      }
-    } else {
-      pszHTTPCookieData = msStrdup(pszTmp);
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * If nLayerId == -1 then we need to figure it
-   * ------------------------------------------------------------------ */
-  if (nLayerId == -1) {
-    int iLayer;
-    for(iLayer=0; iLayer < map->numlayers; iLayer++) {
-      if (GET_LAYER(map, iLayer) == lp) {
-        nLayerId = iLayer;
-        break;
-      }
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * Add a request to the array (already preallocated)
-   * ------------------------------------------------------------------ */
-  pasReqInfo[(*numRequests)].nLayerId = nLayerId;
-  pasReqInfo[(*numRequests)].pszGetUrl = pszURL;
-
-  if (bPostRequest) {
-    pasReqInfo[(*numRequests)].pszPostRequest =
-      msBuildWFSLayerPostRequest(&bbox, psParams);
-    pasReqInfo[(*numRequests)].pszPostContentType =
-      msStrdup("text/xml");
-  }
-
-
-  /* We'll store the remote server's response to a tmp file. */
-  pasReqInfo[(*numRequests)].pszOutputFile = msTmpFile(map, map->mappath, NULL, "tmp.gml");
-
-  /* TODO: Implement Caching of GML responses. There was an older caching
-   * method, but it suffered from a race condition. See #3137.
-   */
-
-  pasReqInfo[(*numRequests)].pszHTTPCookieData = pszHTTPCookieData;
-  pszHTTPCookieData = NULL;
-  pasReqInfo[(*numRequests)].nStatus = 0;
-  pasReqInfo[(*numRequests)].nTimeout = nTimeout;
-  pasReqInfo[(*numRequests)].bbox = bbox;
-  pasReqInfo[(*numRequests)].debug = lp->debug;
-
-  if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata),
-                           pasReqInfo, *numRequests, map, "FO") != MS_SUCCESS) {
-    msWFSFreeParamsObj(psParams);
-    return MS_FAILURE;
-  }
-  
-  /* ------------------------------------------------------------------
-   * Pre-Open the layer now, (i.e. alloc and fill msWFSLayerInfo inside
-   * layer obj).  Layer will be ready for use when the main mapserver
-   * code calls msLayerOpen().
-   * ------------------------------------------------------------------ */
-  if (lp->wfslayerinfo != NULL) {
-    psInfo =(msWFSLayerInfo*)(lp->wfslayerinfo);
-  } else {
-    lp->wfslayerinfo = psInfo = msAllocWFSLayerInfo();
-  }
-
-  if (psInfo->pszGMLFilename)
-    free(psInfo->pszGMLFilename);
-  psInfo->pszGMLFilename=msStrdup(pasReqInfo[(*numRequests)].pszOutputFile);
-
-  psInfo->rect = pasReqInfo[(*numRequests)].bbox;
-
-  if (psInfo->pszGetUrl)
-    free(psInfo->pszGetUrl);
-  psInfo->pszGetUrl = msStrdup(pasReqInfo[(*numRequests)].pszGetUrl);
-
-  psInfo->nStatus = 0;
-
-  (*numRequests)++;
-
-  msWFSFreeParamsObj(psParams);
-
-  return nStatus;
-
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msPrepareWFSLayerRequest");
-  return(MS_FAILURE);
-
-#endif /* USE_WFS_LYR */
-
-}
-
-/**********************************************************************
- *                          msWFSUpdateRequestInfo()
- *
- * This function is called after a WFS request has been completed so that
- * we can copy request result information from the httpRequestObj to the
- * msWFSLayerInfo struct.  Things to copy here are the HTTP status, exceptions
- * information, mime type, etc.
- **********************************************************************/
-void msWFSUpdateRequestInfo(layerObj *lp, httpRequestObj *pasReqInfo)
-{
-#ifdef USE_WFS_LYR
-  if (lp->wfslayerinfo) {
-    msWFSLayerInfo *psInfo = NULL;
-
-    psInfo =(msWFSLayerInfo*)(lp->wfslayerinfo);
-
-    /* Copy request results infos to msWFSLayerInfo struct */
-    /* For now there is only nStatus, but we should eventually add */
-    /* mime type and WFS exceptions information. */
-    psInfo->nStatus = pasReqInfo->nStatus;
-  }
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSUpdateRequestInfo()");
-#endif /* USE_WFS_LYR */
-}
-
-/**********************************************************************
- *                          msWFSLayerOpen()
- *
- * WFS layers are just a special case of OGR connection.  Only the open/close
- * methods differ since they have to download and maintain GML files in cache
- * but the rest is mapped directly to OGR function calls in maplayer.c
- *
- **********************************************************************/
-
-int msWFSLayerOpen(layerObj *lp,
-                   const char *pszGMLFilename, rectObj *defaultBBOX)
-{
-#ifdef USE_WFS_LYR
-  int status = MS_SUCCESS;
-  msWFSLayerInfo *psInfo = NULL;
-
-  if ( msCheckParentPointer(lp->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-  if (lp->wfslayerinfo != NULL) {
-    psInfo =(msWFSLayerInfo*)lp->wfslayerinfo;
-
-    /* Layer already opened.  If explicit filename requested then check */
-    /* that file was already opened with the same filename. */
-    /* If no explicit filename requested then we'll try to reuse the */
-    /* previously opened layer... this will happen in a msDrawMap() call. */
-    if (pszGMLFilename == NULL ||
-        (psInfo->pszGMLFilename &&
-         strcmp(psInfo->pszGMLFilename, pszGMLFilename) == 0) ) {
-      if (lp->layerinfo == NULL) {
-        if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) == MS_FAILURE) /* no access to context (draw vs. query) here, although I doubt it matters... */
-          return MS_FAILURE;
-      }
-      return MS_SUCCESS;  /* Nothing to do... layer is already opened */
-    } else {
-      /* Hmmm... should we produce a fatal error? */
-      /* For now we'll just close the layer and reopen it. */
-      if (lp->debug)
-        msDebug("msWFSLayerOpen(): Layer already opened (%s)\n",
-                lp->name?lp->name:"(null)" );
-      msWFSLayerClose(lp);
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * Alloc and fill msWFSLayerInfo inside layer obj
-   * ------------------------------------------------------------------ */
-  lp->wfslayerinfo = psInfo = msAllocWFSLayerInfo();
-
-  if (pszGMLFilename)
-    psInfo->pszGMLFilename = msStrdup(pszGMLFilename);
-  else {
-    psInfo->pszGMLFilename = msTmpFile(lp->map,
-                                       lp->map->mappath,
-                                       NULL,
-                                       "tmp.gml");
-  }
-
-  if (defaultBBOX) {
-    /* __TODO__ If new bbox differs from current one then we should */
-    /* invalidate current GML file in cache */
-    psInfo->rect = *defaultBBOX;
-  } else {
-    /* Use map bbox by default */
-    psInfo->rect = lp->map->extent;
-  }
-
-  /* We will call whichshapes() now and force downloading layer right */
-  /* away.  This saves from having to call DescribeFeatureType and */
-  /* parsing the response (being lazy I guess) and anyway given the */
-  /* way we work with layers right now the bbox is unlikely to change */
-  /* between now and the time whichshapes() would have been called by */
-  /* the MapServer core. */
-
-  if((lp->map->projection.numargs > 0) && (lp->projection.numargs > 0))
-    msProjectRect(&lp->map->projection, &lp->projection, &psInfo->rect); /* project the searchrect to source coords */
-
-  if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) == MS_FAILURE)  /* no access to context (draw vs. query) here, although I doubt it matters... */
-    status = MS_FAILURE;
-
-
-  return status;
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerOpen()");
-  return(MS_FAILURE);
-
-#endif /* USE_WFS_LYR */
-}
-
-/**********************************************************************
- *                          msWFSLayerOpenVT()
- *
- * Overloaded version of msWFSLayerOpen for virtual table architecture
- **********************************************************************/
-int
-msWFSLayerOpenVT(layerObj *lp)
-{
-  return msWFSLayerOpen(lp, NULL, NULL);
-}
-
-/**********************************************************************
- *                          msWFSLayerIsOpen()
- *
- * Returns MS_TRUE if layer is already open, MS_FALSE otherwise.
- *
- **********************************************************************/
-
-int msWFSLayerIsOpen(layerObj *lp)
-{
-#ifdef USE_WFS_LYR
-  if (lp->wfslayerinfo != NULL)
-    return MS_TRUE;
-
-  return MS_FALSE;
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerIsOpen()");
-  return(MS_FALSE);
-
-#endif /* USE_WFS_LYR */
-}
-
-/**********************************************************************
- *                          msWFSLayerInitItemInfo()
- *
- **********************************************************************/
-
-int msWFSLayerInitItemInfo(layerObj *layer)
-{
-  (void)layer;
-  /* Nothing to do here.  OGR will do its own initialization when it */
-  /* opens the actual file. */
-  /* Note that we didn't implement our own msWFSLayerFreeItemInfo() */
-  /* so that the OGR one gets called. */
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                          msWFSLayerGetShape()
- *
- **********************************************************************/
-int msWFSLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-#ifdef USE_WFS_LYR
-  msWFSLayerInfo* psInfo = NULL;
-
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
-  else {
-    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetShape()");
-    return MS_FAILURE;
-  }
-
-  if(psInfo->bLayerHasValidGML)
-    return msOGRLayerGetShape(layer, shape, record);
-  else {
-    /* Layer is successful, but there is no data to process */
-    msFreeShape(shape);
-    shape->type = MS_SHAPE_NULL;
-    return MS_FAILURE;
-  }
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerGetShape()");
-  return(MS_FAILURE);
-#endif /* USE_WFS_LYR */
-
-}
-
-/**********************************************************************
- *                          msWFSLayerGetNextShape()
- *
- **********************************************************************/
-int msWFSLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-#ifdef USE_WFS_LYR
-  msWFSLayerInfo* psInfo = NULL;
-
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
-  else {
-    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerNextShape()");
-    return MS_FAILURE;
-  }
-
-  if(psInfo->bLayerHasValidGML)
-    return msOGRLayerNextShape(layer, shape);
-  else {
-    /* Layer is successful, but there is no data to process */
-    msFreeShape(shape);
-    shape->type = MS_SHAPE_NULL;
-    return MS_FAILURE;
-  }
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerNextShape()");
-  return(MS_FAILURE);
-#endif /* USE_WFS_LYR */
-
-}
-
-/**********************************************************************
- *                          msWFSLayerGetExtent()
- *
- **********************************************************************/
-int msWFSLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-#ifdef USE_WFS_LYR
-  msWFSLayerInfo* psInfo = NULL;
-
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
-  else {
-    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetExtent()");
-    return MS_FAILURE;
-  }
-
-  if(psInfo->bLayerHasValidGML)
-    return msOGRLayerGetExtent(layer, extent);
-  else {
-    /* Layer is successful, but there is no data to process */
-    msSetError(MS_WFSERR, "Unable to get extents for this layer.", "msWFSLayerGetExtent()");
-    return MS_FAILURE;
-  }
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerGetExtent()");
-  return(MS_FAILURE);
-#endif /* USE_WFS_LYR */
-
-}
-
-/**********************************************************************
- *                          msWFSLayerGetItems()
- *
- **********************************************************************/
-
-int msWFSLayerGetItems(layerObj *layer)
-{
-#ifdef USE_WFS_LYR
-  /* For now this method simply lets OGR parse the GML and figure the  */
-  /* schema itself. */
-  /* It could also be implemented to call DescribeFeatureType for */
-  /* this layer, but we don't need to do it so why waste resources? */
-
-  msWFSLayerInfo* psInfo = NULL;
-
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
-  else {
-    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetItems()");
-    return MS_FAILURE;
-  }
-
-  if(psInfo->bLayerHasValidGML)
-    return msOGRLayerGetItems(layer);
-  else {
-    /* Layer is successful, but there is no data to process */
-    layer->numitems = 0;
-    layer->items = NULL;
-    return MS_SUCCESS;
-  }
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerGetItems()");
-  return(MS_FAILURE);
-#endif /* USE_WFS_LYR */
-
-}
-
-/**********************************************************************
- *                          msWFSLayerWhichShapes()
- *
- **********************************************************************/
-
-int msWFSLayerWhichShapes(layerObj *lp, rectObj rect, int isQuery)
-{
-#ifdef USE_WFS_LYR
-  msWFSLayerInfo *psInfo;
-  int status = MS_SUCCESS;
-  const char *pszTmp;
-  FILE *fp;
-
-  if ( msCheckParentPointer(lp->map,"map")==MS_FAILURE )
-    return MS_FAILURE;
-
-
-  psInfo =(msWFSLayerInfo*)lp->wfslayerinfo;
-
-  if (psInfo == NULL) {
-    msSetError(MS_WFSCONNERR, "Assertion failed: WFS layer not opened!!!",
-               "msWFSLayerWhichShapes()");
-    return(MS_FAILURE);
-  }
-
-  /* ------------------------------------------------------------------
-   * Check if layer overlaps current view window (using wfs_latlonboundingbox)
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "FO", "latlonboundingbox")) != NULL) {
-    char **tokens;
-    int n;
-    rectObj ext;
-
-    tokens = msStringSplit(pszTmp, ' ', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_WFSCONNERR, "Wrong number of values in 'wfs_latlonboundingbox' metadata.",
-                 "msWFSLayerWhichShapes()");
-      return MS_FAILURE;
-    }
-
-    ext.minx = atof(tokens[0]);
-    ext.miny = atof(tokens[1]);
-    ext.maxx = atof(tokens[2]);
-    ext.maxy = atof(tokens[3]);
-
-    msFreeCharArray(tokens, n);
-
-    /* Reproject latlonboundingbox to the selected SRS for the layer and */
-    /* check if it overlaps the bbox that we calculated for the request */
-
-    msProjectRect(&(lp->map->latlon), &(lp->projection), &ext);
-    if (!msRectOverlap(&rect, &ext)) {
-      /* No overlap... nothing to do. If layer was never opened, go open it.*/
-      if (lp->layerinfo)
-        return MS_DONE;  /* No overlap. */
-    }
-  }
-
-
-  /* ------------------------------------------------------------------
-   * __TODO__ If new bbox differs from current one then we should
-   * invalidate current GML file in cache
-   * ------------------------------------------------------------------ */
-  psInfo->rect = rect;
-
-
-  /* ------------------------------------------------------------------
-   * If file not downloaded yet then do it now.
-   * ------------------------------------------------------------------ */
-  if (psInfo->nStatus == 0) {
-    httpRequestObj asReqInfo[2];
-    int numReq = 0;
-
-    msHTTPInitRequestObj(asReqInfo, 2);
-
-    if ( msPrepareWFSLayerRequest(-1, lp->map, lp,
-                                  asReqInfo, &numReq) == MS_FAILURE  ||
-         msOWSExecuteRequests(asReqInfo, numReq,
-                              lp->map, MS_TRUE) == MS_FAILURE ) {
-      /* Delete tmp file... we don't want it to stick around. */
-      unlink(asReqInfo[0].pszOutputFile);
-      return MS_FAILURE;
-    }
-
-    /* Cleanup */
-    msHTTPFreeRequestObj(asReqInfo, numReq);
-
-  }
-
-  if ( !MS_HTTP_SUCCESS( psInfo->nStatus ) ) {
-    /* Delete tmp file... we don't want it to stick around. */
-    unlink(psInfo->pszGMLFilename);
-
-    msSetError(MS_WFSCONNERR,
-               "Got HTTP status %d downloading WFS layer %s",
-               "msWFSLayerWhichShapes()",
-               psInfo->nStatus, lp->name?lp->name:"(null)");
-    return(MS_FAILURE);
-  }
-
-  /* ------------------------------------------------------------------
-   * Check that file is really GML... it could be an exception, or just junk.
-   * ------------------------------------------------------------------ */
-  if ((fp = fopen(psInfo->pszGMLFilename, "r")) != NULL) {
-    char szHeader[2000];
-    int  nBytes = 0;
-
-    nBytes = fread( szHeader, 1, sizeof(szHeader)-1, fp );
-    fclose(fp);
-
-    if (nBytes < 0)
-      nBytes = 0;
-    szHeader[nBytes] = '\0';
-
-    if ( nBytes == 0 ) {
-      msSetError(MS_WFSCONNERR,
-                 "WFS request produced no oputput for layer %s.",
-                 "msWFSLayerWhichShapes()",
-                 lp->name?lp->name:"(null)");
-      return(MS_FAILURE);
-
-    }
-    if ( strstr(szHeader, "<WFS_Exception>") ||
-         strstr(szHeader, "<ServiceExceptionReport>") ) {
-      msOWSProcessException(lp, psInfo->pszGMLFilename,
-                            MS_WFSCONNERR, "msWFSLayerWhichShapes()" );
-      return MS_FAILURE;
-    } else if ( strstr(szHeader,"opengis.net/gml") &&
-                strstr(szHeader,"featureMember>") == NULL ) {
-      /* This looks like valid GML, but contains 0 features. */
-      return MS_DONE;
-    } else if ( strstr(szHeader,"opengis.net/gml") == NULL ||
-                strstr(szHeader,"featureMember>") == NULL ) {
-      /* This is probably just junk. */
-      msSetError(MS_WFSCONNERR,
-                 "WFS request produced unexpected output (junk?) for layer %s.",
-                 "msWFSLayerWhichShapes()",
-                 lp->name?lp->name:"(null)");
-      return(MS_FAILURE);
-    }
-
-    /* If we got this far, it must be a valid GML dataset... keep going */
-  }
-
-
-  /* ------------------------------------------------------------------
-   * Open GML file using OGR.
-   * ------------------------------------------------------------------ */
-  if ((status = msOGRLayerOpen(lp, psInfo->pszGMLFilename)) != MS_SUCCESS)
-    return status;
-
-  status = msOGRLayerWhichShapes(lp, rect, isQuery);
-
-  /* Mark that the OGR Layer is valid */
-  psInfo->bLayerHasValidGML = MS_TRUE;
-
-  return status;
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerWhichShapes()");
-  return(MS_FAILURE);
-
-#endif /* USE_WFS_LYR */
-}
-
-
-
-/**********************************************************************
- *                          msWFSLayerClose()
- *
- **********************************************************************/
-
-int msWFSLayerClose(layerObj *lp)
-{
-#ifdef USE_WFS_LYR
-
-  /* ------------------------------------------------------------------
-   * Cleanup OGR connection
-   * ------------------------------------------------------------------ */
-  if (lp->layerinfo)
-    msOGRLayerClose(lp);
-
-  /* ------------------------------------------------------------------
-   * Cleanup WFS connection info.
-   * __TODO__ For now we flush everything, but we should try to cache some stuff
-   * ------------------------------------------------------------------ */
-  /* __TODO__ unlink()  .gml file and OGR's schema file if they exist */
-  /* unlink( */
-
-  msFreeWFSLayerInfo(lp->wfslayerinfo);
-  lp->wfslayerinfo = NULL;
-
-  return MS_SUCCESS;
-
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msWFSLayerClose()");
-  return(MS_FAILURE);
-
-#endif /* USE_WFS_LYR */
-
-}
-
-/**********************************************************************
- *                          msWFSExecuteGetFeature()
- * Returns the temporary gml file name. User shpuld free the return string.
- **********************************************************************/
-char *msWFSExecuteGetFeature(layerObj *lp)
-{
-#ifdef USE_WFS_LYR
-  char *gmltmpfile = NULL;
-  msWFSLayerInfo *psInfo = NULL;
-
-  if (lp == NULL || lp->connectiontype != MS_WFS)
-    return NULL;
-
-  msWFSLayerOpen(lp, NULL, NULL);
-  psInfo =(msWFSLayerInfo*)lp->wfslayerinfo;
-  if (psInfo &&  psInfo->pszGMLFilename)
-    gmltmpfile = msStrdup(psInfo->pszGMLFilename);
-  msWFSLayerClose(lp);
-
-  return gmltmpfile;
-
-#else
-  /* ------------------------------------------------------------------
-   * WFS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
-             "msExecuteWFSGetFeature()");
-  return NULL;
-
-#endif /* USE_WFS_LYR */
-
-}
-
-int
-msWFSLayerInitializeVirtualTable(layerObj *layer)
-{
-  assert(layer != NULL);
-  assert(layer->vtable != NULL);
-
-  layer->vtable->LayerInitItemInfo = msWFSLayerInitItemInfo;
-  layer->vtable->LayerFreeItemInfo = msOGRLayerFreeItemInfo; /* yes, OGR */
-  layer->vtable->LayerOpen = msWFSLayerOpenVT;
-  layer->vtable->LayerIsOpen = msWFSLayerIsOpen;
-  layer->vtable->LayerWhichShapes = msWFSLayerWhichShapes;
-  layer->vtable->LayerNextShape = msWFSLayerNextShape;
-  /* layer->vtable->LayerResultsGetShape = msWFSLayerResultGetShape; */
-  /* layer->vtable->LayerGetShapeCount, use default */
-  layer->vtable->LayerGetShape = msWFSLayerGetShape;
-  layer->vtable->LayerClose = msWFSLayerClose;
-  layer->vtable->LayerGetItems = msWFSLayerGetItems;
-  layer->vtable->LayerGetExtent = msWFSLayerGetExtent;
-  /* layer->vtable->LayerGetAutoStyle, use default */
-  /* layer->vtable->LayerApplyFilterToLayer, use default */
-  /* layer->vtable->LayerCloseConnection, use default */
-  layer->vtable->LayerSetTimeFilter = msLayerMakePlainTimeFilter;
-  /* layer->vtable->LayerCreateItems, use default */
-  /* layer->vtable->LayerGetNumFeatures, use default */
-  /* layer->vtable->LayerGetAutoProjection, use defaut*/
-
-  return MS_SUCCESS;
-}
diff -pruN 8.0.1-5/mapwms.cpp 8.2.0~beta1-1~exp1/mapwms.cpp
--- 8.0.1-5/mapwms.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwms.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,5175 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  OpenGIS Web Mapping Service support implementation.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#define NEED_IGNORE_RET_VAL
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapthread.h"
-#include "mapgml.h"
-#include <ctype.h>
-#include "maptemplate.h"
-#include "mapows.h"
-
-#include "mapogcsld.h"
-#include "mapogcfilter.h"
-#include "mapowscommon.h"
-
-#include "maptime.h"
-#include "mapproject.h"
-
-#include <cassert>
-#include <stdarg.h>
-#include <time.h>
-#include <string.h>
-
-#include <set>
-#include <string>
-#include <vector>
-
-#ifdef _WIN32
-#include <process.h>
-#endif
-
-/* ==================================================================
- * WMS Server stuff.
- * ================================================================== */
-#ifdef USE_WMS_SVR
-
-/*
-** msWMSException()
-**
-** Report current MapServer error in requested format.
-*/
-
-static
-int msWMSException(mapObj *map, int nVersion, const char *exception_code,
-                   const char *wms_exception_format)
-{
-  char *schemalocation = NULL;
-
-  /* Default to WMS 1.3.0 exceptions if version not set yet */
-  if (nVersion <= 0)
-    nVersion = OWS_1_3_0;
-
-  /* get scheam location */
-  schemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-
-  /* Establish default exception format depending on VERSION */
-  if (wms_exception_format == NULL) {
-    if (nVersion <= OWS_1_0_0)
-      wms_exception_format = "INIMAGE";  /* WMS 1.0.0 */
-    else if (nVersion <= OWS_1_0_7)
-      wms_exception_format = "SE_XML";   /* WMS 1.0.1 to 1.0.7 */
-    else if (nVersion <= OWS_1_1_1)
-      wms_exception_format = "application/vnd.ogc.se_xml"; /* WMS 1.1.0 and later */
-    else
-      wms_exception_format = "text/xml";
-  }
-
-  if (strcasecmp(wms_exception_format, "INIMAGE") == 0 ||
-      strcasecmp(wms_exception_format, "BLANK") == 0 ||
-      strcasecmp(wms_exception_format, "application/vnd.ogc.se_inimage")== 0 ||
-      strcasecmp(wms_exception_format, "application/vnd.ogc.se_blank") == 0) {
-    int blank = 0;
-
-    if (strcasecmp(wms_exception_format, "BLANK") == 0 ||
-        strcasecmp(wms_exception_format, "application/vnd.ogc.se_blank") == 0) {
-      blank = 1;
-    }
-
-    msWriteErrorImage(map, NULL, blank);
-
-  } else if (strcasecmp(wms_exception_format, "WMS_XML") == 0) { /* Only in V1.0.0 */
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-    msIO_sendHeaders();
-
-    msIO_printf("<WMTException version=\"1.0.0\">\n");
-    msWriteErrorXML(stdout);
-    msIO_printf("</WMTException>\n");
-  } else /* XML error, the default: SE_XML (1.0.1 to 1.0.7) */
-    /* or application/vnd.ogc.se_xml (1.1.0 and later) */
-  {
-    if (nVersion <= OWS_1_0_7) {
-      /* In V1.0.1 to 1.0.7, the MIME type was text/xml */
-      msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-      msIO_sendHeaders();
-
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM \"http://www.digitalearth.gov/wmt/xml/exception_1_0_1.dtd\">\n");
-
-      msIO_printf("<ServiceExceptionReport version=\"1.0.1\">\n");
-    } else if (nVersion <= OWS_1_1_0) {
-      /* In V1.1.0 and later, we have OGC-specific MIME types */
-      /* we cannot return anything else than application/vnd.ogc.se_xml here. */
-      msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
-      msIO_sendHeaders();
-
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-
-      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM \"%s/wms/1.1.0/exception_1_1_0.dtd\">\n",schemalocation);
-
-      msIO_printf("<ServiceExceptionReport version=\"1.1.0\">\n");
-    } else if (nVersion <= OWS_1_1_1) { /* 1.1.1 */
-      msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
-      msIO_sendHeaders();
-
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM \"%s/wms/1.1.1/exception_1_1_1.dtd\">\n", schemalocation);
-      msIO_printf("<ServiceExceptionReport version=\"1.1.1\">\n");
-    } else { /*1.3.0*/
-      if (strcasecmp(wms_exception_format, "application/vnd.ogc.se_xml") == 0) {
-        msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
-      } else {
-        msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-      }
-      msIO_sendHeaders();
-
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-      msIO_printf("<ServiceExceptionReport version=\"1.3.0\" xmlns=\"http://www.opengis.net/ogc\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.opengis.net/ogc %s/wms/1.3.0/exceptions_1_3_0.xsd\">\n",
-                  schemalocation);
-    }
-
-
-    if (exception_code)
-      msIO_printf("<ServiceException code=\"%s\">\n", exception_code);
-    else
-      msIO_printf("<ServiceException>\n");
-    msWriteErrorXML(stdout);
-    msIO_printf("</ServiceException>\n");
-    msIO_printf("</ServiceExceptionReport>\n");
-
-  }
-  free(schemalocation);
-
-  return MS_FAILURE; /* so that we can call 'return msWMSException();' anywhere */
-}
-
-static bool msWMSSetTimePattern(const char *timepatternstring, const char *timestring, bool checkonly)
-{
-  if (timepatternstring && timestring) {
-    /* parse the time parameter to extract a distinct time. */
-    /* time value can be dicrete times (eg 2004-09-21), */
-    /* multiple times (2004-09-21, 2004-09-22, ...) */
-    /* and range(s) (2004-09-21/2004-09-25, 2004-09-27/2004-09-29) */
-    const auto atimes = msStringSplit(timestring, ',');
-
-    /* get the pattern to use */
-    if (!atimes.empty()) {
-      auto patterns = msStringSplit(timepatternstring, ',');
-      for (auto& pattern: patterns) {
-        msStringTrimBlanks(pattern);
-        msStringTrimLeft(pattern);
-      }
-
-      for (const auto& atime: atimes) {
-        const auto ranges = msStringSplit(atime.c_str(), '/');
-        for( const auto& range: ranges) {
-          bool match = false;
-          for (const auto& pattern: patterns) {
-            if (!pattern.empty()) {
-              if (msTimeMatchPattern(range.c_str(), pattern.c_str()) == MS_TRUE) {
-                if (!checkonly) msSetLimitedPatternsToUse(pattern.c_str());
-                match = true;
-                break;
-              }
-            }
-          }
-          if (!match) {
-            msSetError(MS_WMSERR, "Time value %s given does not match the time format pattern.", "msWMSSetTimePattern", range.c_str());
-            return false;
-          }
-        }
-      }
-    }
-  }
-
-  return true;
-}
-
-/*
-** Apply the TIME parameter to layers that are time aware
-*/
-static
-int msWMSApplyTime(mapObj *map, int version, const char *time, const char *wms_exception_format)
-{
-  if (map) {
-
-    const char* timepattern = msOWSLookupMetadata(&(map->web.metadata), "MO", "timeformat");
-
-    for (int i=0; i<map->numlayers; i++) {
-      layerObj* lp = (GET_LAYER(map, i));
-      if (lp->status != MS_ON && lp->status != MS_DEFAULT)
-        continue;
-
-      /* check if the layer is time aware */
-      const char* timeextent = msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
-      const char* timefield =  msOWSLookupMetadata(&(lp->metadata), "MO", "timeitem");
-      const char* timedefault =  msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault");
-
-      if (timeextent && timefield) {
-        /* check to see if the time value is given. If not */
-        /* use default time. If default time is not available */
-        /* send an exception */
-        if (time == NULL || strlen(time) <=0) {
-          if (timedefault == NULL) {
-            msSetError(MS_WMSERR, "No Time value was given, and no default time value defined.", "msWMSApplyTime");
-            return msWMSException(map, version, "MissingDimensionValue", wms_exception_format);
-          } else {
-            if (msValidateTimeValue((char *)timedefault, timeextent) == MS_FALSE) {
-              msSetError(MS_WMSERR, "No Time value was given, and the default time value %s is invalid or outside the time extent defined %s", "msWMSApplyTime", timedefault, timeextent);
-              /* return MS_FALSE; */
-              return msWMSException(map, version, "InvalidDimensionValue", wms_exception_format);
-            }
-            msLayerSetTimeFilter(lp, timedefault, timefield);
-          }
-        } else {
-          /* 
-	        ** Check to see if there is a list of possible patterns defined. If it is the case, use 
-          ** it to set the time pattern to use for the request.
-          **
-          ** Last argument is set to TRUE (checkonly) to not trigger the patterns info setting, rather 
-          ** to only apply the wms_timeformats on the user request values, not the mapfile values. 
-          */
-          if (timepattern && time && strlen(time) > 0) {
-            if (!msWMSSetTimePattern(timepattern, time, true)) 
-              return msWMSException(map, version,"InvalidDimensionValue", wms_exception_format);
-          }
-          
-          /* check if given time is in the range */
-          if (msValidateTimeValue(time, timeextent) == MS_FALSE) {
-            if (timedefault == NULL) {
-              msSetError(MS_WMSERR, "Time value(s) %s given is invalid or outside the time extent defined (%s).", "msWMSApplyTime", time, timeextent);
-              /* return MS_FALSE; */
-              return msWMSException(map, version,
-                                    "InvalidDimensionValue", wms_exception_format);
-            } else {
-              if (msValidateTimeValue((char *)timedefault, timeextent) == MS_FALSE) {
-                msSetError(MS_WMSERR, "Time value(s) %s given is invalid or outside the time extent defined (%s), and default time set is invalid (%s)", "msWMSApplyTime", time, timeextent, timedefault);
-                /* return MS_FALSE; */
-                return msWMSException(map, version,
-                                      "InvalidDimensionValue",  wms_exception_format);
-              } else
-                msLayerSetTimeFilter(lp, timedefault, timefield);
-            }
-
-          } else {
-            /* build the time string */
-            msLayerSetTimeFilter(lp, time, timefield);
-            timeextent= NULL;
-          }
-        }
-      }
-    }
-
-    /* last argument is MS_FALSE to trigger a method call that set the patterns
-       info. some drivers use it */
-    if (timepattern && time && strlen(time) > 0) {
-      if (!msWMSSetTimePattern(timepattern, time, false))
-        return msWMSException(map, version, "InvalidDimensionValue", wms_exception_format);
-    }    
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-** Apply the FILTER parameter to layers (RFC118)
-*/
-static
-int msWMSApplyFilter(mapObj *map, int version, const char *filter,
-		     int def_srs_needs_axis_swap, const char *wms_exception_format, owsRequestObj *ows_request)
-{
-  // Empty filter should be ignored
-  if (!filter || strlen(filter) == 0)
-    return MS_SUCCESS;
-
-  if (!map)
-    return MS_FAILURE;  
-
-  /* Count number of requested layers / groups / etc.
-   * Only layers with STATUS ON were in the LAYERS request param.
-   * Layers with STATUS DEFAULT were set in the mapfile and are
-   * not expected to have a corresponding filter in the request
-   */
-  int numlayers = 0;
-  for(int i=0; i<map->numlayers; i++) {
-    layerObj *lp=NULL;
-
-    if(map->layerorder[i] != -1) {
-      lp = (GET_LAYER(map,  map->layerorder[i]));
-      if (lp->status == MS_ON)
-        numlayers++;
-    }
-  }
-   
-  /* -------------------------------------------------------------------- */
-  /*      Parse the Filter parameter. If there are several Filter         */
-  /*      parameters, each Filter is inside parentheses.                  */
-  /* -------------------------------------------------------------------- */
-  int numfilters = 0;
-  char **paszFilters = NULL;
-  if (filter[0] == '(') {
-    paszFilters = FLTSplitFilters(filter, &numfilters);
-
-  } else if (numlayers == 1) {
-    numfilters=1;
-    paszFilters = (char **)msSmallMalloc(sizeof(char *)*numfilters);
-    paszFilters[0] = msStrdup(filter);
-  }
-
-  if (numfilters != ows_request->numwmslayerargs) {
-    msSetError(MS_WMSERR, "Wrong number of filter elements, one filter must be specified for each requested layer or groups.",
-	       "msWMSApplyFilter" );
-    msFreeCharArray(paszFilters, numfilters);
-    return msWMSException(map, version, "InvalidParameterValue", wms_exception_format);
-  }
-
-  /* We're good to go. Apply each filter to the corresponding layer */
-  for(int i=0; i<map->numlayers; i++) {
-    layerObj *lp=NULL;
-
-    if(map->layerorder[i] != -1)
-      lp = (GET_LAYER(map,  map->layerorder[i]));
-
-    /* Only layers with STATUS ON were in the LAYERS request param.*/
-    if (lp == NULL || lp->status != MS_ON)
-      continue;
-
-    const int curfilter = ows_request->layerwmsfilterindex[lp->index];
-
-    /* Skip empty filters */
-    assert(paszFilters);
-    assert(curfilter >= 0 && curfilter < numfilters);
-    if (paszFilters[curfilter][0] == '\0') {
-      continue;
-    }
-    
-    /* Force setting a template to enable query. */
-    if (lp->_template == NULL)
-      lp->_template = msStrdup("ttt.html");
-
-    /* Parse filter */
-    FilterEncodingNode* psNode = FLTParseFilterEncoding(paszFilters[curfilter]);
-    if (!psNode) {
-      msSetError(MS_WMSERR,
-		 "Invalid or Unsupported FILTER : %s",
-		 "msWMSApplyFilter()", paszFilters[curfilter]);
-      msFreeCharArray(paszFilters, numfilters);
-      return msWMSException(map, version, "InvalidParameterValue", wms_exception_format);
-    }
-
-    /* For WMS 1.3 and up, we may need to swap the axis of bbox and geometry
-     * elements inside the filter(s)
-     */
-    if (version >= OWS_1_3_0)
-      FLTDoAxisSwappingIfNecessary(map, psNode, def_srs_needs_axis_swap);
-
-#ifdef do_we_need_this
-    FLTProcessPropertyIsNull(psNode, map, lp->index);
-
-    /*preparse the filter for gml aliases*/
-    FLTPreParseFilterForAliasAndGroup(psNode, map, lp->index, "G");
-
-    /* Check that FeatureId filters are consistent with the active layer */
-    if( FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE)
-      {
-        FLTFreeFilterEncodingNode( psNode );
-        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-      }
-
-    /* FIXME?: could probably apply to WFS 1.1 too */
-    if( nWFSVersion >= OWS_2_0_0 )
-      {
-	int nEvaluation;
-
-        if( FLTCheckInvalidOperand(psNode) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            msFreeCharArray(paszFilters, numfilters);
-            return msWFSException(map, "filter", MS_WFS_ERROR_OPERATION_PROCESSING_FAILED, paramsObj->pszVersion);
-        }
-
-        if( FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            msFreeCharArray(paszFilters, numfilters);
-            return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-        }
-
-        psNode = FLTSimplify(psNode, &nEvaluation);
-        if( psNode == NULL )
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            msFreeCharArray(paszFilters, numfilters);
-            if( nEvaluation == 1 ) {
-                /* return full layer */
-                return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
-            }
-            else {
-                /* return empty result set */
-                return MS_SUCCESS;
-            }
-        }
-
-      }
-    
-#endif
-
-    /* Apply filter to this layer */
-
-    /* But first, start by removing any wfs_use_default_extent_for_getfeature metadata item */
-    /* that could result in the BBOX to be removed */
-    std::string old_value_wfs_use_default_extent_for_getfeature;
-    {
-        const char* old_value_tmp = msLookupHashTable(
-            &(lp->metadata), "wfs_use_default_extent_for_getfeature");
-        if( old_value_tmp )
-        {
-            old_value_wfs_use_default_extent_for_getfeature = old_value_tmp;
-            msRemoveHashTable(&(lp->metadata), "wfs_use_default_extent_for_getfeature");
-        }
-    }
-
-    msInsertHashTable(&(lp->metadata), "gml_wmsfilter_flag", "true");
-
-    int ret = FLTApplyFilterToLayer(psNode, map, lp->index);
-
-    msRemoveHashTable(&(lp->metadata), "gml_wmsfilter_flag");
-
-    if( !old_value_wfs_use_default_extent_for_getfeature.empty() )
-    {
-        msInsertHashTable(&(lp->metadata), "wfs_use_default_extent_for_getfeature",
-                          old_value_wfs_use_default_extent_for_getfeature.c_str());
-    }
-
-    if( ret != MS_SUCCESS ) {
-      errorObj* ms_error = msGetErrorObj();
-
-      if(ms_error->code != MS_NOTFOUND) {
-	msSetError(MS_WMSERR, "FLTApplyFilterToLayer() failed", "msWMSApplyFilter()");
-	FLTFreeFilterEncodingNode( psNode );
-        msFreeCharArray(paszFilters, numfilters);
-	return msWMSException(map, version, "InvalidParameterValue", wms_exception_format);
-      }
-    }
-
-    FLTFreeFilterEncodingNode( psNode );
-
-  }/* for */
-
-    msFreeCharArray(paszFilters, numfilters);
-
-    return MS_SUCCESS;
-}
-
-/*
-** msWMSPrepareNestedGroups()
-**
-** purpose: Parse WMS_LAYER_GROUP settings into arrays
-**
-** params:
-** - nestedGroups: This array holds the arrays of groups that have been set
-**                 through the WMS_LAYER_GROUP metadata
-** - numNestedGroups: This array holds the number of groups set in
-**                    WMS_LAYER_GROUP for each layer
-** - isUsedInNestedGroup: This array indicates if the layer is used as group
-**                        as set through the WMS_LAYER_GROUP metadata
-*/
-static
-void msWMSPrepareNestedGroups(mapObj* map, int /* nVersion */, char*** nestedGroups, int* numNestedGroups, int* isUsedInNestedGroup)
-{
-  //Create set to hold unique groups
-  std::set<std::string> uniqgroups;
-
-  for (int i = 0; i < map->numlayers; i++) {
-    nestedGroups[i] = NULL; /* default */
-    numNestedGroups[i] = 0; /* default */
-    isUsedInNestedGroup[i] = 0; /* default */
-
-    const char* groups = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "MO", "layer_group");
-    if ((groups != NULL) && (strlen(groups) != 0)) {
-      if (GET_LAYER(map, i)->group != NULL && strlen(GET_LAYER(map, i)->group) != 0) {
-        const char* errorMsg = "It is not allowed to set both the GROUP and WMS_LAYER_GROUP for a layer";
-        msSetError(MS_WMSERR, errorMsg, "msWMSPrepareNestedGroups()", NULL);
-        msIO_fprintf(stdout, "<!-- ERROR: %s -->\n", errorMsg);
-        /* cannot return exception at this point because we are already writing to stdout */
-      } else {
-        if (groups[0] != '/') {
-          const char* errorMsg = "The WMS_LAYER_GROUP metadata does not start with a '/'";
-          msSetError(MS_WMSERR, errorMsg, "msWMSPrepareNestedGroups()", NULL);
-          msIO_fprintf(stdout, "<!-- ERROR: %s -->\n", errorMsg);
-          /* cannot return exception at this point because we are already writing to stdout */
-        } else {
-          /* split into subgroups. Start at address + 1 because the first '/' would cause an extra empty group */
-          nestedGroups[i] = msStringSplit(groups + 1, '/', &numNestedGroups[i]);
-          /* Iterate through the groups and add them to the unique groups array */
-          for (int k=0; k<numNestedGroups[i]; k++) {
-            uniqgroups.insert(msStringToLower(std::string(nestedGroups[i][k])));
-         }
-       } 
-     }
-   }
- } 
- /* Iterate through layers to find out whether they are in any of the nested groups */
- for (int i = 0; i < map->numlayers; i++) {
-    if (GET_LAYER(map, i)->name) {
-        if( uniqgroups.find(msStringToLower(std::string(GET_LAYER(map, i)->name))) != uniqgroups.end() ) {
-            isUsedInNestedGroup[i] = 1;
-        }
-    }
-  }
-}
-
-
-/*
-** Validate that a given dimension is inside the extents defined
-*/
-static
-bool msWMSValidateDimensionValue(const char *value, const char *dimensionextent, bool forcecharacter)
-{
-  std::vector<pointObj> aextentranges;
-
-  bool isextentavalue = false;
-  bool isextentarange = false;
-  bool ischaracter = false;
-
-  if (forcecharacter)
-    ischaracter = true;
-
-  if (!value || !dimensionextent)
-    return false;
-
-  /*for the value, we support descrete values (2005) */
-  /* multiple values (abc, def, ...) */
-  /* and range(s) (1000/2000, 3000/5000) */
-  /** we do not support resolution*/
-
-  /* -------------------------------------------------------------------- */
-  /*      parse the extent first.                                         */
-  /* -------------------------------------------------------------------- */
-  auto extents = msStringSplit (dimensionextent, ',');
-  for( auto& extent: extents ) // Make sure to get by reference so that it is updated in place
-    msStringTrim(extent);
-
-  std::vector<std::string> aextentvalues;
-  if (extents.size() == 1) {
-    if (strstr(dimensionextent, "/") == NULL) {
-      /*single value*/
-      isextentavalue = true;
-      aextentvalues.push_back(dimensionextent);
-      if (!forcecharacter)
-        ischaracter= FLTIsNumeric(dimensionextent) == MS_FALSE;
-
-    } else {
-      const auto ranges = msStringSplit (dimensionextent, '/');
-      if(ranges.size() == 2 || ranges.size() == 3) {
-        /*single range*/
-        isextentarange = true;
-        aextentranges.resize(1);
-        aextentranges[0].x = atof(ranges[0].c_str());
-        aextentranges[0].y = atof(ranges[1].c_str());
-        /*ranges should be numeric*/
-        ischaracter = false;
-      }
-    }
-  } else if (extents.size() > 1) { /*check if it is muliple values or mutliple ranges*/
-    if (strstr(dimensionextent, "/") == NULL) {
-      /*multiple values*/
-      isextentavalue = true;
-      aextentvalues = extents;
-      if (!forcecharacter)
-        ischaracter= FLTIsNumeric(aextentvalues[0].c_str()) == MS_FALSE;
-    } else { /*multiple range extent*/
-      int isvalidextent = MS_TRUE;
-      /*ranges should be numeric*/
-      ischaracter = false;
-      isextentarange = true;
-      aextentranges.resize(extents.size());
-      size_t nextentranges=0;
-
-      for(const auto& extent: extents) {
-        const auto onerange = msStringSplit(extent.c_str(), '/');
-        if (onerange.size() != 2 && onerange.size() != 3) {
-          isvalidextent = MS_FALSE;
-          break;
-        }
-        if (isvalidextent) {
-
-          aextentranges[nextentranges].x = atof(onerange[0].c_str());
-          aextentranges[nextentranges++].y = atof(onerange[1].c_str());
-        }
-      }
-      if (!isvalidextent) {
-        nextentranges = 0;
-        isextentarange = false;
-      }
-      aextentranges.resize(nextentranges);
-    }
-  }
-
-  /* make sure that we got a valid extent*/
-  if (!isextentavalue && !isextentarange) {
-    return false;
-  }
-
-  /*for the extent of the dimesion, we support
-  single value,  or list of mulitiple values comma separated,
-  a single range or multipe ranges */
-
-
-  const auto uservalues = msStringSplit (value, ',');
-  bool uservaluevalid = false;
-  if (uservalues.size() == 1) {
-    /*user iput=single*/
-    /*is it descret or range*/
-    const auto ranges = msStringSplit(uservalues[0].c_str(), '/');
-    if (ranges.size() == 1) { /*discrete*/
-      if (isextentavalue) {
-        /*single user value, single/multiple values extent*/
-        for (const auto& extentvalue: aextentvalues) {
-          if (ischaracter)
-            uservaluevalid = (uservalues[0] == extentvalue);
-          else {
-            if (atof(uservalues[0].c_str()) == atof(extentvalue.c_str()))
-              uservaluevalid = true;
-          }
-          if(uservaluevalid)
-            break;
-        }
-      } else if (isextentarange) {
-        /*single user value, single/multiple range extent*/
-        const float currentval = atof(uservalues[0].c_str());
-
-        for (const auto& extentrange: aextentranges) {
-          const float minval = extentrange.x;
-          const float maxval = extentrange.y;
-          if (currentval >= minval && currentval <= maxval) {
-            uservaluevalid= true;
-            break;
-          }
-        }
-      }
-    } else if (ranges.size() == 2 || ranges.size() == 3) { /*range*/
-      /*user input=single range. In this case the extents must
-       be of a range type.*/
-      const float mincurrentval = atof(ranges[0].c_str());
-      const float maxcurrentval = atof(ranges[1].c_str());
-      if (isextentarange) {
-        for (const auto& extentrange: aextentranges) {
-          const float minval = extentrange.x;
-          const float maxval = extentrange.y;
-
-          if(minval <= mincurrentval && maxval >= maxcurrentval &&
-              minval <= maxval) {
-            uservaluevalid= true;
-            break;
-          }
-        }
-      }
-    }
-  } else if (uservalues.size() > 1) { /*user input=multiple*/
-    if (strstr(value, "/") == NULL) {
-      /*user input=multiple value*/
-      bool valueisvalid = false;
-      for (const auto& uservalue: uservalues) {
-        valueisvalid = false;
-        if (isextentavalue) {
-          /*user input is multiple values, extent is defned as one or multiple values*/
-          for (const auto& extentvalue: aextentvalues) {
-            if (ischaracter) {
-              if (uservalue == extentvalue) {
-                valueisvalid = true;
-                break;
-              }
-            } else {
-              if (atof(uservalue.c_str()) == atof(extentvalue.c_str())) {
-                valueisvalid = true;
-                break;
-              }
-            }
-          }
-          /*every value shoule be valid*/
-          if (!valueisvalid)
-            break;
-        } else if (isextentarange) {
-          /*user input is multiple values, extent is defned as one or multiple ranges*/
-          for (const auto& extentrange: aextentranges) {
-            const float minval = extentrange.x;
-            const float maxval = extentrange.y;
-            const float currentval = atof(uservalue.c_str());
-            if(minval <= currentval && maxval >= currentval &&
-                minval <= maxval) {
-              valueisvalid = true;
-              break;
-            }
-          }
-          if (!valueisvalid)
-            break;
-        }
-      }
-      uservaluevalid = valueisvalid;
-    } else { /*user input multiple ranges*/
-      bool valueisvalid = true;
-
-      for (const auto& uservalue: uservalues) {
-        /*each ranges should be valid*/
-        const auto onerange = msStringSplit(uservalue.c_str(), '/');
-        if (onerange.size() == 2 || onerange.size() == 3) {
-          const float mincurrentval = atof(onerange[0].c_str());
-          const float maxcurrentval = atof(onerange[1].c_str());
-
-          /*extent must be defined also as a rangle*/
-          if (isextentarange) {
-            bool found = false;
-            for (const auto& extentrange: aextentranges) {
-              const float mincurrentrange = extentrange.x;
-              const float maxcurrentrange = extentrange.y;
-
-              if(mincurrentval >=mincurrentrange && maxcurrentval <= maxcurrentrange &&
-                  mincurrentval <= maxcurrentval) {
-                found = true;
-                break;
-              }
-
-            }
-            if (!found) {
-              valueisvalid = false;
-              break;
-            }
-          }
-        } else {
-          valueisvalid = false;
-        }
-      }
-      uservaluevalid = valueisvalid;
-    }
-
-  }
-
-  return uservaluevalid;
-}
-
-static
-bool msWMSApplyDimensionLayer(layerObj *lp, const char *item, const char *value, bool forcecharacter)
-{
-  bool result = false;
-
-  if (lp && item && value) {
-    /*for the value, we support descrete values (2005) */
-    /* multiple values (abc, def, ...) */
-    /* and range(s) (1000/2000, 3000/5000) */
-    char* pszExpression = FLTGetExpressionForValuesRanges(lp, item, value, forcecharacter ? MS_TRUE : MS_FALSE);
-
-    if (pszExpression) {
-      // If tileindex is set, the filter is applied to tileindex too.
-      int tlpindex = -1;
-      if (lp->tileindex && (tlpindex = msGetLayerIndex(lp->map, lp->tileindex)) != -1) {
-          result = FLTApplyExpressionToLayer((GET_LAYER(lp->map, tlpindex)), pszExpression) != MS_FALSE;
-      } else {
-          result = true;
-      }
-      result &= FLTApplyExpressionToLayer(lp, pszExpression) != MS_FALSE;
-      msFree(pszExpression);
-    }
-  }
-  return result;
-}
-
-static
-bool msWMSApplyDimension(layerObj *lp, int /* version */, const char *dimensionname, const char *value,
-                        const char * /* wms_exception_format */)
-{
-  bool forcecharacter = false;
-  bool result = false;
-
-  if (lp && dimensionname && value) {
-    /*check if the dimension name passes starts with dim_. All dimensions should start with dim_, except elevation*/
-    std::string dimension;
-    if (strncasecmp(dimensionname, "dim_", 4) == 0)
-      dimension = dimensionname+4;
-    else
-      dimension = dimensionname;
-
-    /*if value is empty and a default is defined, use it*/
-    std::string currentvalue;
-    if (strlen(value) > 0)
-      currentvalue = value;
-    else {
-      const char* dimensiondefault = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_default").c_str());
-      if (dimensiondefault)
-        currentvalue = dimensiondefault;
-    }
-
-    /*check if the manadatory metada related to the dimension are set*/
-    const char* dimensionitem = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_item").c_str());
-    const char* dimensionextent = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_extent").c_str());
-    const char* dimensionunit = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_units").c_str());
-
-    /*if the server want to force the type to character*/
-    const char* dimensiontype = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_type").c_str());
-    if (dimensiontype && strcasecmp(dimensiontype, "Character") == 0)
-      forcecharacter = true;
-
-    if (dimensionitem && dimensionextent && dimensionunit && !currentvalue.empty()) {
-      if(msWMSValidateDimensionValue(currentvalue.c_str(), dimensionextent, forcecharacter)) {
-        result = msWMSApplyDimensionLayer(lp, dimensionitem, currentvalue.c_str(), forcecharacter);
-      } else {
-        msSetError(MS_WMSERR, "Dimension %s with a value of %s is invalid or outside the extents defined", "msWMSApplyDimension",
-                   dimension.c_str(), currentvalue.c_str());
-        result = false;
-      }
-    } else
-      msSetError(MS_WMSERR, "Dimension %s : invalid settings. Make sure that item, units and extent are set.", "msWMSApplyDimension",
-                 dimension.c_str());
-  }
-  return result;
-}
-/*
-**
-*/
-int msWMSLoadGetMapParams(mapObj *map, int nVersion,
-                          char **names, char **values, int numentries, const char *wms_exception_format,
-                          const char * /*wms_request*/, owsRequestObj *ows_request)
-{
-  bool adjust_extent = false;
-  bool nonsquare_enabled = false;
-  int transparent = MS_NOOVERRIDE;
-  bool bbox_pixel_is_point = false;
-  outputFormatObj *format = NULL;
-  int validlayers = 0;
-  const char *styles = NULL;
-  int invalidlayers = 0;
-  std::string epsgbuf;
-  std::string srsbuffer;
-  bool epsgvalid = false;
-  bool timerequest = false;
-  const char *stime = NULL;
-  bool srsfound = false;
-  bool bboxfound = false;
-  bool formatfound = false;
-  bool widthfound = false;
-  bool heightfound = false;
-  const char *request = NULL;
-  int status = 0;
-  const char *layerlimit = NULL;
-  bool tiled = false;
-
-  const char *sldenabled=NULL;
-  const char *sld_url=NULL;
-  const char *sld_body=NULL;
-
-  const char *filter = NULL;
-
-  /* Some of the getMap parameters are actually required depending on the */
-  /* request, but for now we assume all are optional and the map file */
-  /* defaults will apply. */
-
-  msAdjustExtent(&(map->extent), map->width, map->height);
-
-  /*
-    Check for SLDs first. If SLD is available LAYERS and STYLES parameters are non mandatory
-   */
-  for(int i=0; i<numentries; i++) {
-    /* check if SLD is passed.  If yes, check for OGR support */
-    if (strcasecmp(names[i], "SLD") == 0 || strcasecmp(names[i], "SLD_BODY") == 0) {
-      sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
-
-      if (sldenabled == NULL) {
-        sldenabled = "true";
-      }
-
-      if (strcasecmp(sldenabled, "true") == 0) {
-        if (strcasecmp(names[i], "SLD") == 0) {
-          sld_url =  values[i];
-        }
-        if (strcasecmp(names[i], "SLD_BODY") == 0) {
-          sld_body =  values[i];
-        }
-      }
-    }
-  }
-
-  std::vector<std::string> wmslayers;
-  for(int i=0; i<numentries; i++) {
-    /* getMap parameters */
-
-    if (strcasecmp(names[i], "REQUEST") == 0) {
-      request = values[i];
-    }
-
-    if (strcasecmp(names[i], "LAYERS") == 0) {
-      std::vector<int> layerOrder(map->numlayers);
-
-      wmslayers = msStringSplit(values[i], ',');
-      if (wmslayers.empty()) {
-        if (sld_url == NULL &&   sld_body == NULL) {
-          msSetError(MS_WMSERR, "At least one layer name required in LAYERS.",
-                     "msWMSLoadGetMapParams()");
-          return msWMSException(map, nVersion, NULL, wms_exception_format);
-        }
-      }
-
-      if (nVersion >= OWS_1_3_0) {
-        layerlimit = msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
-        if(layerlimit) {
-          if (static_cast<int>(wmslayers.size()) > atoi(layerlimit)) {
-            msSetError(MS_WMSERR, "Number of layers requested exceeds LayerLimit.",
-                       "msWMSLoadGetMapParams()");
-            return msWMSException(map, nVersion, NULL, wms_exception_format);
-          }
-        }
-      }
-
-      for (int iLayer=0; iLayer < map->numlayers; iLayer++) {
-        map->layerorder[iLayer] = iLayer;
-      }
-
-      int nLayerOrder = 0;
-      for(int j=0; j<map->numlayers; j++) {
-        /* Keep only layers with status=DEFAULT by default */
-        /* Layer with status DEFAULT is drawn first. */
-        if (GET_LAYER(map, j)->status != MS_DEFAULT)
-          GET_LAYER(map, j)->status = MS_OFF;
-        else {
-          map->layerorder[nLayerOrder++] = j;
-          layerOrder[j] = 1;
-        }
-      }
-
-      char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-      int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-      if (ows_request->layerwmsfilterindex != NULL)
-        msFree(ows_request->layerwmsfilterindex);
-      ows_request->layerwmsfilterindex = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-      for(int j=0; j<map->numlayers; j++) {
-        ows_request->layerwmsfilterindex[j] = -1;
-      }
-      ows_request->numwmslayerargs = static_cast<int>(wmslayers.size());
-
-      for (int k = 0; k < static_cast<int>(wmslayers.size()); k++) {
-        const auto& wmslayer = wmslayers[k];
-        bool layerfound = false;
-        for (int j=0; j<map->numlayers; j++) {
-          /* Turn on selected layers only. */
-          if ( ((GET_LAYER(map, j)->name &&
-                 strcasecmp(GET_LAYER(map, j)->name, wmslayer.c_str()) == 0) ||
-                (map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
-                (GET_LAYER(map, j)->group && strcasecmp(GET_LAYER(map, j)->group, wmslayer.c_str()) == 0) ||
-                ((numNestedGroups[j] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[j], numNestedGroups[j]))) &&
-               ((msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers))) ) {
-            if (GET_LAYER(map, j)->status != MS_DEFAULT) {
-              if (layerOrder[j] == 0) {
-                map->layerorder[nLayerOrder++] = j;
-                layerOrder[j] = 1;
-                GET_LAYER(map, j)->status = MS_ON;
-              }
-            }
-            /* if a layer name is repeated assign the first matching filter */
-            /* duplicate names will be assigned filters later when layer copies are created */
-            if (ows_request->layerwmsfilterindex[j] == -1) {
-                ows_request->layerwmsfilterindex[j] = k;
-            }
-            validlayers++;
-            layerfound = true;
-          }
-        }
-        if (layerfound == false && !wmslayers.empty())
-          invalidlayers++;
-
-      }
-
-      /* free the stuff used for nested layers */
-      for (int k = 0; k < map->numlayers; k++) {
-        if (numNestedGroups[k] > 0) {
-          msFreeCharArray(nestedGroups[k], numNestedGroups[k]);
-        }
-      }
-      free(nestedGroups);
-      free(numNestedGroups);
-      free(isUsedInNestedGroup);
-
-      /* set all layers with status off at end of array */
-      for (int j=0; j<map->numlayers; j++) {
-        if (GET_LAYER(map, j)->status == MS_OFF)
-          if (layerOrder[j] == 0)
-            map->layerorder[nLayerOrder++] = j;
-      }
-    } else if (strcasecmp(names[i], "STYLES") == 0) {
-      styles = values[i];
-
-    } else if ((strcasecmp(names[i], "SRS") == 0 && nVersion < OWS_1_3_0) ||
-               (strcasecmp(names[i], "CRS") == 0 && nVersion >= OWS_1_3_0)) {
-      srsfound = true;
-      char* colon = strchr(values[i], ':');
-      bool srsOk = false;
-      /* SRS is in format "EPSG:epsg_id" or "AUTO:proj_id,unit_id,lon0,lat0" */
-      if (strncasecmp(values[i], "EPSG:", 5) == 0) {
-        srsOk = true;
-        /* SRS=EPSG:xxxx */
-
-        /* don't need to copy init=xxx since the srsbuffer is only
-           used with msLoadProjection and that does already the job */
-
-        srsbuffer = "EPSG:";
-        srsbuffer += (values[i]+5);
-        epsgbuf = srsbuffer;
-
-        /* This test was to correct a request by the OCG cite 1.3.0 test
-         sending CRS=ESPG:4326,  Bug:*/
-        if (nVersion >= OWS_1_3_0) {
-          if (srsbuffer.back() == ',')
-          {
-            srsbuffer.resize(srsbuffer.size() - 1);
-            epsgbuf = srsbuffer;
-          }
-        }
-
-        /* we need to wait until all params are read before */
-        /* loading the projection into the map. This will help */
-        /* insure that the passes srs is valid for all layers. */
-        /*
-        if (msLoadProjectionString(&(map->projection), buffer) != 0)
-          return msWMSException(map, nVersion, NULL);
-
-        iUnits = GetMapserverUnitUsingProj(&(map->projection));
-        if (iUnits != -1)
-          map->units = iUnits;
-        */
-      } else if (strncasecmp(values[i], "AUTO:", 5) == 0 && nVersion < OWS_1_3_0) {
-        if( nVersion < OWS_1_3_0 ) {
-            srsOk = true;
-            srsbuffer = values[i];
-            /* SRS=AUTO:proj_id,unit_id,lon0,lat0 */
-            /*
-            if (msLoadProjectionString(&(map->projection), values[i]) != 0)
-              return msWMSException(map, nVersion, NULL);
-
-            iUnits = GetMapserverUnitUsingProj(&(map->projection));
-            if (iUnits != -1)
-              map->units = iUnits;
-            */
-        }
-      } else if (strncasecmp(values[i], "AUTO2:", 6) == 0 ||
-                 strncasecmp(values[i], "CRS:", 4) == 0) {
-        if( nVersion >= OWS_1_3_0 ) {
-            srsOk = true;
-            srsbuffer = values[i];
-        }
-      } else if( colon != NULL && strchr(colon + 1, ':') == NULL ) {
-        srsOk = true;
-        srsbuffer = values[i];
-      }
-      if (!srsOk) {
-        if (nVersion >= OWS_1_3_0) {
-          msSetError(MS_WMSERR,
-                     "Unsupported CRS namespace (only EPSG, AUTO2, CRS currently supported).",
-                     "msWMSLoadGetMapParams()");
-          return msWMSException(map, nVersion, "InvalidCRS", wms_exception_format);
-        } else {
-          msSetError(MS_WMSERR,
-                     "Unsupported SRS namespace (only EPSG and AUTO currently supported).",
-                     "msWMSLoadGetMapParams()");
-          return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
-        }
-      }
-    } else if (strcasecmp(names[i], "BBOX") == 0) {
-      bboxfound = true;
-      const auto tokens = msStringSplit(values[i], ',');
-      if (tokens.size() != 4) {
-        msSetError(MS_WMSERR, "Wrong number of arguments for BBOX.",
-                   "msWMSLoadGetMapParams()");
-        return msWMSException(map, nVersion, NULL, wms_exception_format);
-      }
-      map->extent.minx = atof(tokens[0].c_str());
-      map->extent.miny = atof(tokens[1].c_str());
-      map->extent.maxx = atof(tokens[2].c_str());
-      map->extent.maxy = atof(tokens[3].c_str());
-
-      /*for wms 1.3.0 we will do the validation of the bbox after all parameters
-       are read to account for the axes order*/
-      if (nVersion < OWS_1_3_0) {
-
-        /* validate bbox values */
-        if ( map->extent.minx >= map->extent.maxx ||
-             map->extent.miny >=  map->extent.maxy) {
-          msSetError(MS_WMSERR,
-                     "Invalid values for BBOX.",
-                     "msWMSLoadGetMapParams()");
-          return msWMSException(map, nVersion, NULL, wms_exception_format);
-        }
-        adjust_extent = true;
-      }
-    } else if (strcasecmp(names[i], "WIDTH") == 0) {
-      widthfound = true;
-      map->width = atoi(values[i]);
-    } else if (strcasecmp(names[i], "HEIGHT") == 0) {
-      heightfound = true;
-      map->height = atoi(values[i]);
-    } else if (strcasecmp(names[i], "FORMAT") == 0) {
-      formatfound = true;
-
-      if (strcasecmp(values[i], "application/openlayers")!=0) {
-        /*check to see if a predefined list is given*/
-        const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getmap_formatlist");
-        if (format_list) {
-          format = msOwsIsOutputFormatValid(map, values[i], &(map->web.metadata),
-                                            "M", "getmap_formatlist");
-          if (format == NULL) {
-            msSetError(MS_IMGERR,
-                       "Unsupported output format (%s).",
-                       "msWMSLoadGetMapParams()",
-                       values[i] );
-            return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
-          }
-        } else {
-          format = msSelectOutputFormat( map, values[i] );
-          if( format == NULL ||
-              (strncasecmp(format->driver, "MVT", 3) != 0 &&
-               strncasecmp(format->driver, "GDAL/", 5) != 0 &&
-               strncasecmp(format->driver, "AGG/", 4) != 0 &&
-               strncasecmp(format->driver, "UTFGRID", 7) != 0 &&
-               strncasecmp(format->driver, "CAIRO/", 6) != 0 &&
-               strncasecmp(format->driver, "OGL/", 4) != 0 &&
-               strncasecmp(format->driver, "KML", 3) != 0 &&
-               strncasecmp(format->driver, "KMZ", 3) != 0)) {
-            msSetError(MS_IMGERR,
-                       "Unsupported output format (%s).",
-                       "msWMSLoadGetMapParams()",
-                       values[i] );
-            return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
-          }
-        }
-      }
-      msFree( map->imagetype );
-      map->imagetype = msStrdup(values[i]);
-    } else if (strcasecmp(names[i], "TRANSPARENT") == 0) {
-      transparent = (strcasecmp(values[i], "TRUE") == 0);
-    } else if (strcasecmp(names[i], "BGCOLOR") == 0) {
-      long c;
-      c = strtol(values[i], NULL, 16);
-      map->imagecolor.red = (c/0x10000)&0xff;
-      map->imagecolor.green = (c/0x100)&0xff;
-      map->imagecolor.blue = c&0xff;
-    }
-
-    /* value of time can be empty. We should look for a default value */
-    /* see function msWMSApplyTime */
-    else if (strcasecmp(names[i], "TIME") == 0) { /* &&  values[i]) */
-      stime = values[i];
-      timerequest = true;
-    }
-    /* Vendor-specific ANGLE param (for map rotation), added in ticket #3332,
-     * also supported by GeoServer
-     */
-    else if (strcasecmp(names[i], "ANGLE") == 0) {
-      msMapSetRotation(map, atof(values[i]));
-    }
-    /* Vendor-specific bbox_pixel_is_point, added in ticket #4652 */
-    else if (strcasecmp(names[i], "BBOX_PIXEL_IS_POINT") == 0) {
-      bbox_pixel_is_point = (strcasecmp(values[i], "TRUE") == 0);
-    }
-    /* Vendor specific TILED (WMS-C) */
-    else if (strcasecmp(names[i], "TILED") == 0) {
-      tiled = (strcasecmp(values[i], "TRUE") == 0);
-    }
-    /* Vendor-specific FILTER, added in RFC-118 */
-    else if (strcasecmp(names[i], "FILTER") == 0) {
-      filter = values[i];
-    }
-  }
-
-  /*validate the exception format WMS 1.3.0 section 7.3.3.11*/
-
-  if (nVersion >= OWS_1_3_0 && wms_exception_format != NULL) {
-    if (strcasecmp(wms_exception_format, "INIMAGE") != 0 &&
-        strcasecmp(wms_exception_format, "BLANK") != 0 &&
-        strcasecmp(wms_exception_format, "XML") != 0) {
-      msSetError(MS_WMSERR,
-                 "Invalid format %s for the EXCEPTIONS parameter.",
-                 "msWMSLoadGetMapParams()",  wms_exception_format);
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
-    }
-  }
-
-  int need_axis_swap = MS_FALSE;
-  if (bboxfound && nVersion >= OWS_1_3_0) {
-    rectObj rect;
-    projectionObj proj;
-
-    /*we have already validated that the request format when reading
-     the request parameters*/
-    rect = map->extent;
-
-    /*try to adjust the axes if necessary*/
-    if (srsbuffer.size() > 1) {
-      msInitProjection(&proj);
-      msProjectionInheritContextFrom(&proj, &(map->projection));
-      if (msLoadProjectionStringEPSG(&proj, srsbuffer.c_str()) == 0 &&
-	  (need_axis_swap = msIsAxisInvertedProj(&proj) ) ) {
-        msAxisNormalizePoints( &proj, 1, &rect.minx, &rect.miny );
-        msAxisNormalizePoints( &proj, 1, &rect.maxx, &rect.maxy );
-      }
-      msFreeProjection( &proj );
-    }
-    /*if the CRS is AUTO2:auto_crs_id,factor,lon0,lat0,
-     we need to grab the factor parameter and use it with the bbox*/
-    if (srsbuffer.size() > 1 && strncasecmp(srsbuffer.c_str(), "AUTO2:", 6) == 0) {
-      const auto args = msStringSplit(srsbuffer.c_str(), ',');
-      if (args.size() == 4) {
-        const double factor = atof(args[1].c_str());
-        if (factor > 0 && factor != 1.0) {
-          rect.minx = rect.minx*factor;
-          rect.miny = rect.miny*factor;
-          rect.maxx = rect.maxx*factor;
-          rect.maxx = rect.maxy*factor;
-        }
-      }
-    }
-
-    map->extent = rect;
-
-    /* validate bbox values */
-    if ( map->extent.minx >= map->extent.maxx ||
-         map->extent.miny >=  map->extent.maxy) {
-      msSetError(MS_WMSERR,
-                 "Invalid values for BBOX.",
-                 "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-    adjust_extent = true;
-  }
-
-  if (tiled) {
-    const char *value;
-    hashTableObj *meta = &(map->web.metadata);
-    int map_edge_buffer = 0;
-
-    if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
-        map_edge_buffer = atoi(value);
-    }
-    if (map_edge_buffer > 0 && map->width > 0 && map->height >  0) {
-      /* adjust bbox and width and height to the buffer */
-      const double buffer_x = map_edge_buffer * (map->extent.maxx - map->extent.minx) / (double)map->width;
-      const double buffer_y = map_edge_buffer * (map->extent.maxy - map->extent.miny) / (double)map->height;
-
-      // TODO: we should probably clamp the extent to avoid going outside of -180,-90,180,90 for geographic CRS for example
-      map->extent.minx -= buffer_x;
-      map->extent.maxx += buffer_x;
-      map->extent.miny -= buffer_y;
-      map->extent.maxy += buffer_y;
-
-      map->width += 2 * map_edge_buffer;
-      map->height += 2 * map_edge_buffer;
-
-      if( map_edge_buffer > 0 ) {
-        char tilebufferstr[64];
-
-        /* Write the tile buffer to a string */
-        snprintf(tilebufferstr, sizeof(tilebufferstr), "-%d", map_edge_buffer);
-
-        /* Hm, the labelcache buffer is set... */
-        if((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) != NULL) {
-          /* If it's too small, replace with a bigger one */
-          if( map_edge_buffer > abs(atoi(value)) ) {
-            msRemoveHashTable(meta, "labelcache_map_edge_buffer");
-            msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
-          }
-        }
-        /* No labelcache buffer value? Then we use the tile buffer. */
-        else {
-          msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
-        }
-      }
-    }
-  }
-
-  /*
-  ** If any select layers have a default time, we will apply the default
-  ** time value even if no TIME request was in the url.
-  */
-  if( !timerequest && map ) {
-    for (int i=0; i<map->numlayers && !timerequest; i++) {
-      layerObj *lp = NULL;
-
-      lp = (GET_LAYER(map, i));
-      if (lp->status != MS_ON && lp->status != MS_DEFAULT)
-        continue;
-
-      if( msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault") )
-        timerequest = true;
-    }
-  }
-
-  /*
-  ** Apply time filters if available in the request.
-  */
-  if (timerequest) {
-    if (msWMSApplyTime(map, nVersion, stime, wms_exception_format) == MS_FAILURE) {
-      return MS_FAILURE;/* msWMSException(map, nVersion, "InvalidTimeRequest"); */
-    }
-  }
-
-  /*
-  ** Check/apply wms dimensions
-  ** all dimension requests should start with dim_xxxx, except time and elevation.
-  */
-  for (int i=0; i<map->numlayers; i++) {
-    layerObj *lp = (GET_LAYER(map, i));
-    if (lp->status != MS_ON && lp->status != MS_DEFAULT)
-      continue;
-
-    const char* dimensionlist = msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
-    if (dimensionlist) {
-      auto tokens = msStringSplit(dimensionlist, ',');
-      for (auto& token: tokens) {
-          msStringTrim(token);
-          for(int k=0; k<numentries; k++) {
-            const std::string dimensionname(names[k]);
-
-            /*the dim_ is supposed to be part of the dimension name in the request*/
-            std::string stmp;
-            if (strcasecmp(token.c_str(), "elevation") == 0)
-              stmp = token;
-            else {
-              stmp = "dim_";
-              stmp += token;
-            }
-            if (strcasecmp(dimensionname.c_str(), stmp.c_str()) == 0) {
-              if (!msWMSApplyDimension(lp, nVersion, dimensionname.c_str(), values[k],
-                                       wms_exception_format)) {
-                return msWMSException(lp->map, nVersion, "InvalidDimensionValue",  wms_exception_format);
-              }
-              break;
-            }
-          }
-      }
-    }
-  }
-
-  /*
-  ** Apply the selected output format (if one was selected), and override
-  ** the transparency if needed.
-  */
-
-  if( format != NULL )
-    msApplyOutputFormat( &(map->outputformat), format, transparent);
-
-  /* Validate all layers given.
-  ** If an invalid layer is sent, return an exception.
-  */
-  if (validlayers == 0 || invalidlayers > 0) {
-    if (invalidlayers > 0) {
-      msSetError(MS_WMSERR, "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
-this request. Check wms/ows_enable_request settings.",
-                 "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
-    }
-    if (validlayers == 0 && sld_url == NULL &&   sld_body == NULL) {
-      msSetError(MS_WMSERR, "Missing required parameter LAYERS", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-  }
-
-  /* validate srs value: When the SRS parameter in a GetMap request contains a
-  ** SRS that is valid for some, but not all of the layers being requested,
-  ** then the server shall throw a Service Exception (code = "InvalidSRS").
-  ** Validate first against epsg in the map and if no matching srs is found
-  ** validate all layers requested.
-  */
-  if (epsgbuf.size() >= 2) { /*at least 2 chars*/
-    char *projstring;
-    epsgvalid = false;
-    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata),
-                                  "MO", MS_FALSE, &projstring);
-    if (projstring) {
-      const auto tokens = msStringSplit(projstring, ' ');
-      for( const auto& token: tokens) {
-        if (strcasecmp(token.c_str(), epsgbuf.c_str()) == 0) {
-          epsgvalid = true;
-          break;
-        }
-      }
-      msFree(projstring);
-    }
-    if (!epsgvalid) {
-      for (int i=0; i<map->numlayers; i++) {
-        epsgvalid = false;
-        if (GET_LAYER(map, i)->status == MS_ON) {
-          msOWSGetEPSGProj(&(GET_LAYER(map, i)->projection),
-                                        &(GET_LAYER(map, i)->metadata),
-                                        "MO", MS_FALSE, &projstring);
-          if (projstring) {
-            const auto tokens = msStringSplit(projstring, ' ');
-            for( const auto& token: tokens) {
-              if (strcasecmp(token.c_str(), epsgbuf.c_str()) == 0) {
-                epsgvalid = true;
-                break;
-              }
-            }
-            msFree(projstring);
-          }
-          if (!epsgvalid) {
-            if (nVersion >= OWS_1_3_0) {
-              msSetError(MS_WMSERR, "Invalid CRS given : CRS must be valid for all requested layers.",
-                         "msWMSLoadGetMapParams()");
-              return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
-            } else {
-              msSetError(MS_WMSERR, "Invalid SRS given : SRS must be valid for all requested layers.",
-                         "msWMSLoadGetMapParams()");
-              return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
-            }
-          }
-        }
-      }
-    }
-  }
-
-  if (request == NULL || strcasecmp(request, "DescribeLayer") != 0) {
-    /* Validate requested image size.
-    */
-    if(map->width > map->maxsize || map->height > map->maxsize ||
-        map->width < 1 || map->height < 1) {
-      msSetError(MS_WMSERR, "Image size out of range, WIDTH and HEIGHT must be between 1 and %d pixels.", "msWMSLoadGetMapParams()", map->maxsize);
-
-      /* Restore valid default values in case errors INIMAGE are used */
-      map->width = 400;
-      map->height= 300;
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-
-    /* Check whether requested BBOX and width/height result in non-square pixels
-    */
-    nonsquare_enabled = msTestConfigOption( map, "MS_NONSQUARE", MS_FALSE ) != MS_FALSE;
-    if (!nonsquare_enabled) {
-      const double dx = MS_ABS(map->extent.maxx - map->extent.minx);
-      const double dy = MS_ABS(map->extent.maxy - map->extent.miny);
-
-      const double reqy = ((double)map->width) * dy / dx;
-
-      /* Allow up to 1 pixel of error on the width/height ratios. */
-      /* If more than 1 pixel then enable non-square pixels */
-      if ( MS_ABS((reqy - (double)map->height)) > 1.0 ) {
-        if (map->debug)
-            msDebug("msWMSLoadGetMapParams(): enabling non-square pixels.\n");
-        msSetConfigOption(map, "MS_NONSQUARE", "YES");
-        nonsquare_enabled = true;
-      }
-    }
-  }
-
-  /* If the requested SRS is different from the default mapfile projection, or
-  ** if a BBOX resulting in non-square pixels is requested then
-  ** copy the original mapfile's projection to any layer that doesn't already
-  ** have a projection. This will prevent problems when users forget to
-  ** explicitly set a projection on all layers in a WMS mapfile.
-  */
-  if (srsbuffer.size() > 1 || nonsquare_enabled) {
-    projectionObj newProj;
-
-    if (map->projection.numargs <= 0) {
-      if (nVersion >= OWS_1_3_0) {
-        msSetError(MS_WMSERR, "Cannot set new CRS on a map that doesn't "
-                   "have any projection set. Please make sure your mapfile "
-                   "has a projection defined at the top level.",
-                   "msWMSLoadGetMapParams()");
-        return msWMSException(map, nVersion, "InvalidCRS", wms_exception_format);
-      } else {
-        msSetError(MS_WMSERR, "Cannot set new SRS on a map that doesn't "
-                   "have any projection set. Please make sure your mapfile "
-                   "has a projection defined at the top level.",
-                   "msWMSLoadGetMapParams()");
-        return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
-      }
-    }
-
-    msInitProjection(&newProj);
-    msProjectionInheritContextFrom(&newProj, &map->projection);
-    if (srsbuffer.size() > 1) {
-      int nTmp;
-
-      if (nVersion >= OWS_1_3_0)
-        nTmp = msLoadProjectionStringEPSG(&newProj, srsbuffer.c_str());
-      else
-        nTmp = msLoadProjectionString(&newProj, srsbuffer.c_str());
-      if (nTmp != 0) {
-        msFreeProjection(&newProj);
-        return msWMSException(map, nVersion, NULL, wms_exception_format);
-      }
-    }
-
-    if (nonsquare_enabled ||
-        msProjectionsDiffer(&(map->projection), &newProj)) {
-      msMapSetLayerProjections(map);
-    }
-    msFreeProjection(&newProj);
-  }
-
-  /* apply the srs to the map file. This is only done after validating */
-  /* that the srs given as parameter is valid for all layers */
-  if (srsbuffer.size() > 1) {
-    int nTmp;
-    msFreeProjectionExceptContext(&map->projection);
-    if (nVersion >= OWS_1_3_0)
-      nTmp = msLoadProjectionStringEPSG(&(map->projection), srsbuffer.c_str());
-    else
-      nTmp = msLoadProjectionString(&(map->projection), srsbuffer.c_str());
-
-    if (nTmp != 0)
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-    nTmp = GetMapserverUnitUsingProj(&(map->projection));
-    if( nTmp != -1 ) {
-      map->units = static_cast<MS_UNITS>(nTmp);
-    }
-  }
-
-  if (sld_url || sld_body) {
-    char *pszLayerNames = NULL;
-    const int nLayersBefore = map->numlayers;
-
-    /* -------------------------------------------------------------------- */
-    /*      if LAYERS parameter was not given, set all layers to off        */
-    /* -------------------------------------------------------------------- */
-    if (validlayers == 0) { /*no LAYERS parameter is give*/
-      for(int j=0; j<map->numlayers; j++) {
-        if (GET_LAYER(map, j)->status != MS_DEFAULT)
-          GET_LAYER(map, j)->status = MS_OFF;
-      }
-    }
-
-    /*apply sld if defined. This is done here so that bbox and srs are already applied*/
-    if (sld_url) {
-      if ((status = msSLDApplySLDURL(map, sld_url, -1, NULL, &pszLayerNames)) != MS_SUCCESS)
-        return msWMSException(map, nVersion, NULL, wms_exception_format);
-    } else if (sld_body) {
-      if ((status =msSLDApplySLD(map, sld_body, -1, NULL, &pszLayerNames)) != MS_SUCCESS)
-        return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-    /* -------------------------------------------------------------------- */
-    /*      SLD and styles can use the same layer multiple times. If        */
-    /*      that is the case we duplicate the layer for drawing             */
-    /*      purpose. We need to reset the ows request enable settings (#1602)*/
-    /* -------------------------------------------------------------------- */
-    const int nLayerAfter = map->numlayers;
-    if (nLayersBefore != nLayerAfter) {
-      msOWSRequestLayersEnabled(map, "M", "GetMap", ows_request);
-    }
-
-    /* -------------------------------------------------------------------- */
-    /*      We need to take into account where the LAYERS parameter was     */
-    /*      not given (the LAYERS is option when an SLD is given). In       */
-    /*      this particular case, we need to turn on the layers             */
-    /*      identified the SLD (#1166).                                     */
-    /*                                                                      */
-    /* -------------------------------------------------------------------- */
-    if (validlayers == 0) {
-      if (pszLayerNames) {
-        const auto tokens = msStringSplit(pszLayerNames, ',');
-        for (const auto& token: tokens) {
-            for (int j=0; j<map->numlayers; j++) {
-              if ( ((GET_LAYER(map, j)->name &&
-                     strcasecmp(GET_LAYER(map, j)->name, token.c_str()) == 0) ||
-                    (map->name && strcasecmp(map->name, token.c_str()) == 0) ||
-                    (GET_LAYER(map, j)->group && strcasecmp(GET_LAYER(map, j)->group, token.c_str()) == 0)) &&
-                   ((msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers))) ) {
-                if (GET_LAYER(map, j)->status != MS_DEFAULT)
-                  GET_LAYER(map, j)->status = MS_ON;
-              }
-            }
-        }
-      }
-    }
-    msFree(pszLayerNames);
-
-  }
-
-  /* Validate Styles :
-  ** MapServer advertize styles through the group setting in a class object.
-  ** If no styles are set MapServer expects to have empty values
-  ** for the styles parameter (...&STYLES=&...) Or for multiple Styles/Layers,
-  ** we could have ...&STYLES=,,,. If that is not the
-  ** case, we generate an exception.
-  */
-  if(styles && strlen(styles) > 0) {
-    bool hasCheckedLayerUnicity = false;
-    int n=0;
-    int layerCopyIndex;
-
-    char** tokens = msStringSplitComplex(styles, ",",&n,MS_ALLOWEMPTYTOKENS);
-    for (int i=0; i<n; i++) {
-      if (tokens[i] && strlen(tokens[i]) > 0 &&
-          strcasecmp(tokens[i],"default") != 0) {
-        if (!hasCheckedLayerUnicity) {
-          hasCheckedLayerUnicity = true;
-          bool bLayerInserted = false;
-
-          /* -------------------------------------------------------------------- */
-          /*      If the same layer is given more that once, we need to           */
-          /*      duplicate it.                                                   */
-          /* -------------------------------------------------------------------- */
-          for (size_t m=0; m<wmslayers.size(); m++) {
-              for (size_t l=m+1; l<wmslayers.size(); l++) {
-                const int nIndex = msGetLayerIndex(map, wmslayers[m].c_str());
-                if (nIndex != -1 &&
-                    strcasecmp(wmslayers[m].c_str(), wmslayers[l].c_str())== 0) {
-                  layerObj* psTmpLayer = (layerObj *) malloc(sizeof(layerObj));
-                  initLayer(psTmpLayer, map);
-                  msCopyLayer(psTmpLayer, GET_LAYER(map,nIndex));
-                  /* open the source layer */
-                  if ( !psTmpLayer->vtable)
-                    msInitializeVirtualTable(psTmpLayer);
-
-                  /*make the name unique*/
-                  char tmpId[128];
-                  snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d",(long)time(NULL),(int)getpid(),
-                           map->numlayers);
-                  if (psTmpLayer->name)
-                    msFree(psTmpLayer->name);
-                  psTmpLayer->name = msStrdup(tmpId);
-                  wmslayers[l] = tmpId;
-
-                  layerCopyIndex = msInsertLayer(map, psTmpLayer, -1);
-
-                  // expand the array mapping map layer index to filter indexes
-                  ows_request->layerwmsfilterindex = (int*)msSmallRealloc(ows_request->layerwmsfilterindex, map->numlayers * sizeof(int));
-                  ows_request->layerwmsfilterindex[layerCopyIndex] = l; // the filter index matches the index of the layer name in the WMS param
-
-                  bLayerInserted = true;
-                  /* layer was copied, we need to decrement its refcount */
-                  MS_REFCNT_DECR(psTmpLayer);
-                }
-              }
-          }
-
-          if (bLayerInserted) {
-            msOWSRequestLayersEnabled(map, "M", "GetMap", ows_request);
-          }
-        }
-
-        if (static_cast<int>(wmslayers.size()) == n) {
-          for (int j=0; j<map->numlayers; j++) {
-            layerObj* lp = GET_LAYER(map, j);
-            if ((lp->name &&
-                 strcasecmp(lp->name, wmslayers[i].c_str()) == 0) ||
-                (lp->group && strcasecmp(lp->group, wmslayers[i].c_str()) == 0)) {
-              bool found = false;
-              for (int k=0; k<lp->numclasses; k++) {
-                if (lp->_class[k]->group && strcasecmp(lp->_class[k]->group, tokens[i]) == 0) {
-                  msFree(lp->classgroup);
-                  lp->classgroup = msStrdup( tokens[i]);
-                  found = true;
-                  break;
-                }
-              }
-              if (!found) {
-                msSetError(MS_WMSERR, "Style (%s) not defined on layer.",
-                           "msWMSLoadGetMapParams()", tokens[i]);
-                msFreeCharArray(tokens, n);
-
-                return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
-              }
-            /* Check the style of the root layer */
-            } else if (map->name && strcasecmp(map->name, wmslayers[i].c_str()) == 0) {
-                const char* styleName = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
-                if (styleName == NULL)
-                  styleName = "default";
-                char* pszEncodedStyleName = msEncodeHTMLEntities(styleName);
-                if (strcasecmp(pszEncodedStyleName, tokens[i]) != 0) {
-                    msSetError(MS_WMSERR, "Style (%s) not defined on root layer.",
-                               "msWMSLoadGetMapParams()", tokens[i]);
-                    msFreeCharArray(tokens, n);
-                    msFree(pszEncodedStyleName);
-
-                    return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
-                }
-                msFree(pszEncodedStyleName);
-            }
-
-          }
-        } else {
-          msSetError(MS_WMSERR, "Invalid style (%s). Mapserver is expecting an empty string for the STYLES : STYLES= or STYLES=,,, or using keyword default  STYLES=default,default, ...",
-                     "msWMSLoadGetMapParams()", styles);
-          msFreeCharArray(tokens, n);
-          return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
-        }
-      }
-    }
-    msFreeCharArray(tokens, n);
-  }
-
-  /*
-  ** WMS extents are edge to edge while MapServer extents are center of
-  ** pixel to center of pixel.  Here we try to adjust the WMS extents
-  ** in by half a pixel.  We wait till here because we want to ensure we
-  ** are doing this in terms of the correct WIDTH and HEIGHT.
-  */
-  if( adjust_extent && map->width>1 && map->height>1 && !bbox_pixel_is_point) {
-    double  dx, dy;
-
-    dx = (map->extent.maxx - map->extent.minx) / map->width;
-    map->extent.minx += dx*0.5;
-    map->extent.maxx -= dx*0.5;
-
-    dy = (map->extent.maxy - map->extent.miny) / map->height;
-    map->extent.miny += dy*0.5;
-    map->extent.maxy -= dy*0.5;
-  }
-
-  if (request && strcasecmp(request, "DescribeLayer") != 0) {
-    if (!srsfound) {
-      if ( nVersion >= OWS_1_3_0)
-        msSetError(MS_WMSERR, "Missing required parameter CRS", "msWMSLoadGetMapParams()");
-      else
-        msSetError(MS_WMSERR, "Missing required parameter SRS", "msWMSLoadGetMapParams()");
-
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-
-    if (!bboxfound) {
-      msSetError(MS_WMSERR, "Missing required parameter BBOX", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-
-    if (!formatfound && (strcasecmp(request, "GetMap") == 0 || strcasecmp(request, "map") == 0)) {
-      msSetError(MS_WMSERR, "Missing required parameter FORMAT", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-
-    if (!widthfound) {
-      msSetError(MS_WMSERR, "Missing required parameter WIDTH", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-
-    if (!heightfound) {
-      msSetError(MS_WMSERR, "Missing required parameter HEIGHT", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-
-    if (styles == nullptr && sld_url == nullptr && sld_body == nullptr &&
-        (strcasecmp(request, "GetMap") == 0 ||
-         strcasecmp(request, "GetFeatureInfo") == 0) &&
-        msOWSLookupMetadata(&(map->web.metadata), "M",
-                            "allow_getmap_without_styles") == nullptr) {
-      msSetError(MS_WMSERR,
-                 "Missing required parameter STYLES. Note to service administrators: "
-                 "defining the \"wms_allow_getmap_without_styles\" \"true\" MAP.WEB.METADATA "
-                 "item will disable this check (backward compatibility with behaviour "
-                 "of MapServer < 8.0)", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-  }
-
-  /*
-  ** Apply vendor-specific filter if specified
-  */
-  if (filter) {
-    if (sld_url || sld_body) {
-      msSetError(MS_WMSERR,
-                 "Vendor-specific FILTER parameter cannot be used with SLD or SLD_BODY.",
-                 "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-
-    if (msWMSApplyFilter(map, nVersion, filter, need_axis_swap, wms_exception_format, ows_request) == MS_FAILURE) {
-      return MS_FAILURE;/* msWMSException(map, nVersion, "InvalidFilterRequest"); */
-    }
-  }
-
-  return MS_SUCCESS;
-}
-
-/*
-**
-*/
-static void msWMSPrintRequestCap(int nVersion, const char *request,
-                                 const char *script_url, const char *formats, ...)
-{
-  va_list argp;
-
-  msIO_printf("    <%s>\n", request);
-
-  /* We expect to receive a NULL-terminated args list of formats */
-  va_start(argp, formats);
-  const char* fmt = formats;
-  while(fmt != NULL) {
-    /* Special case for early WMS with subelements in Format (bug 908) */
-    char *encoded;
-    if( nVersion <= OWS_1_0_7 ) {
-      encoded = msStrdup( fmt );
-    }
-
-    /* otherwise we HTML code special characters */
-    else {
-      encoded = msEncodeHTMLEntities(fmt);
-    }
-
-    msIO_printf("      <Format>%s</Format>\n", encoded);
-    msFree(encoded);
-
-    fmt = va_arg(argp, const char *);
-  }
-  va_end(argp);
-
-  msIO_printf("      <DCPType>\n");
-  msIO_printf("        <HTTP>\n");
-  /* The URL should already be HTML encoded. */
-  if (nVersion == OWS_1_0_0) {
-    msIO_printf("          <Get onlineResource=\"%s\" />\n", script_url);
-    msIO_printf("          <Post onlineResource=\"%s\" />\n", script_url);
-  } else {
-    msIO_printf("          <Get><OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/></Get>\n", script_url);
-    msIO_printf("          <Post><OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/></Post>\n", script_url);
-  }
-
-  msIO_printf("        </HTTP>\n");
-  msIO_printf("      </DCPType>\n");
-  msIO_printf("    </%s>\n", request);
-}
-
-
-
-void msWMSPrintAttribution(FILE *stream, const char *tabspace,
-                           hashTableObj *metadata,
-                           const char * /*namespaces*/)
-{
-  if (stream && metadata) {
-    const char* title = msOWSLookupMetadata(metadata, "MO",
-                                "attribution_title");
-    const char* onlineres = msOWSLookupMetadata(metadata, "MO",
-                                    "attribution_onlineresource");
-    const char* logourl = msOWSLookupMetadata(metadata, "MO",
-                                  "attribution_logourl_width");
-
-    if (title || onlineres || logourl) {
-      msIO_printf("%s<Attribution>\n",tabspace);
-      if (title) {
-        char* pszEncodedValue = msEncodeHTMLEntities(title);
-        msIO_fprintf(stream, "%s%s<Title>%s</Title>\n", tabspace,
-                     tabspace, pszEncodedValue);
-        free(pszEncodedValue);
-      }
-
-      if (onlineres) {
-        char* pszEncodedValue = msEncodeHTMLEntities(onlineres);
-        msIO_fprintf(stream, "%s%s<OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/>\n", tabspace, tabspace,
-                     pszEncodedValue);
-        free(pszEncodedValue);
-      }
-
-      if (logourl) {
-        msOWSPrintURLType(stream, metadata, "MO","attribution_logourl",
-                          OWS_NOERR, NULL, "LogoURL", NULL,
-                          " width=\"%s\"", " height=\"%s\"",
-                          ">\n             <Format>%s</Format",
-                          "\n             <OnlineResource "
-                          "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                          " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                          "          ",
-                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                          NULL, NULL, NULL, NULL, NULL, "        ");
-
-
-      }
-      msIO_printf("%s</Attribution>\n", tabspace);
-
-    }
-  }
-}
-
-
-/*
-** msWMSPrintScaleHint()
-**
-** Print a Min/MaxScaleDenominator tag for the layer if applicable.
-** used for WMS >=1.3.0
-*/
-void msWMSPrintScaleDenominator(const char *tabspace, double minscaledenom,
-                                double maxscaledenom)
-{
-  if (minscaledenom > 0)
-    msIO_printf("%s<MinScaleDenominator>%g</MinScaleDenominator>\n",
-                tabspace, minscaledenom);
-
-  if (maxscaledenom > 0)
-    msIO_printf("%s<MaxScaleDenominator>%g</MaxScaleDenominator>\n",
-                tabspace, maxscaledenom);
-}
-
-
-
-/*
-** msWMSPrintScaleHint()
-**
-** Print a ScaleHint tag for this layer if applicable.
-**
-** (see WMS 1.1.0 sect. 7.1.5.4) The WMS defines the scalehint values as
-** the ground distance in meters of the southwest to northeast diagonal of
-** the central pixel of a map.  ScaleHint values are the min and max
-** recommended values of that diagonal.
-*/
-void msWMSPrintScaleHint(const char *tabspace, double minscaledenom,
-                         double maxscaledenom, double resolution)
-{
-  double scalehintmin=0.0, scalehintmax=0.0;
-
-  const double diag = sqrt(2.0);
-
-  if (minscaledenom > 0)
-    scalehintmin = diag*(minscaledenom/resolution)/msInchesPerUnit(MS_METERS,0);
-  if (maxscaledenom > 0)
-    scalehintmax = diag*(maxscaledenom/resolution)/msInchesPerUnit(MS_METERS,0);
-
-  if (scalehintmin > 0.0 || scalehintmax > 0.0) {
-    msIO_printf("%s<ScaleHint min=\"%.15g\" max=\"%.15g\" />\n",
-                tabspace, scalehintmin, scalehintmax);
-    if (scalehintmax == 0.0)
-      msIO_printf("%s<!-- WARNING: Only MINSCALEDENOM and no MAXSCALEDENOM specified in "
-                  "the mapfile. A default value of 0 has been returned for the "
-                  "Max ScaleHint but this is probably not what you want. -->\n",
-                  tabspace);
-  }
-}
-
-/*
-** msWMSPrintAuthorityURL()
-**
-** Print an AuthorityURL tag if applicable.
-*/
-void msWMSPrintAuthorityURL(FILE *stream, const char *tabspace,
-                            hashTableObj *metadata, const char *namespaces)
-{
-  if (stream && metadata) {
-    const char* pszWmsAuthorityName = msOWSLookupMetadata(metadata, namespaces, "authorityurl_name");
-    const char* pszWMSAuthorityHref = msOWSLookupMetadata(metadata, namespaces, "authorityurl_href");
-
-    /* AuthorityURL only makes sense if you have *both* the name and url */
-    if( pszWmsAuthorityName && pszWMSAuthorityHref ) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "authorityurl_name",
-                               OWS_NOERR,
-                               (std::string(tabspace) + "<AuthorityURL name=\"%s\">\n").c_str(),
-                               NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "authorityurl_href",
-                               OWS_NOERR,
-                               (std::string(tabspace) + "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/>\n").c_str(),
-                               NULL);
-      msIO_printf("%s</AuthorityURL>\n", tabspace);
-    } else if ( pszWmsAuthorityName || pszWMSAuthorityHref ) {
-      msIO_printf("%s<!-- WARNING: Both wms_authorityurl_name and wms_authorityurl_href must be set to output an AuthorityURL -->\n", tabspace);
-    }
-  }
-}
-
-/*
-** msWMSPrintIdentifier()
-**
-** Print an Identifier tag if applicable.
-*/
-void msWMSPrintIdentifier(FILE *stream, const char *tabspace,
-                          hashTableObj *metadata, const char *namespaces)
-{
-  if (stream && metadata) {
-    const char* pszWMSIdentifierAuthority = msOWSLookupMetadata(metadata, namespaces, "identifier_authority");
-    const char* pszWMSIdentifierValue = msOWSLookupMetadata(metadata, namespaces, "identifier_value");
-
-    /* Identifier only makes sense if you have *both* the authority and value */
-    if( pszWMSIdentifierAuthority && pszWMSIdentifierValue ) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "identifier_authority",
-                               OWS_NOERR,
-                               (std::string(tabspace) + "<Identifier authority=\"%s\">").c_str(),
-                               NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "identifier_value",
-                               OWS_NOERR, "%s</Identifier>\n",
-                               NULL);
-    } else if ( pszWMSIdentifierAuthority || pszWMSIdentifierValue ) {
-      msIO_printf("%s<!-- WARNING: Both wms_identifier_authority and wms_identifier_value must be set to output an Identifier -->\n", tabspace);
-    }
-  }
-}
-
-/*
-** msWMSPrintKeywordlist()
-**
-** Print a Keywordlist tag if applicable.
-*/
-void msWMSPrintKeywordlist(FILE *stream, const char *tabspace,
-                           const char *name, hashTableObj *metadata,
-                           const char *namespaces, int nVersion)
-{
-  std::string newname(name); /* max. rootlayer_keywordlist_items          */
-  newname += "_items";
-
-  std::string vocname(name); /* max. rootlayer_keywordlist_vocabulary     */
-  vocname += "_vocabulary";
-
-  if (nVersion == OWS_1_0_0) {
-    /* <Keywords> in V 1.0.0 */
-    /* The 1.0.0 spec doesn't specify which delimiter to use so let's use spaces */
-    msOWSPrintEncodeMetadataList(stream, metadata, namespaces,
-                                 name,
-                                 (std::string(tabspace) + "<Keywords>").c_str(),
-                                 (std::string(tabspace) + "</Keywords>\n").c_str(),
-                                 "%s ", NULL);
-  } else if ( msOWSLookupMetadata(metadata, namespaces, name) ||
-              msOWSLookupMetadata(metadata, namespaces, newname.c_str()) ||
-              msOWSLookupMetadata(metadata, namespaces, vocname.c_str()) ) {
-    /* <KeywordList><Keyword> ... in V1.0.6+ */
-    msIO_printf("%s<KeywordList>\n", tabspace);
-    std::string template1(tabspace);
-    template1 += "    <Keyword>%s</Keyword>\n";
-    /* print old styled ..._keywordlist */
-    msOWSPrintEncodeMetadataList(stream, metadata, namespaces,
-                                 name, NULL, NULL,
-                                 template1.c_str(), NULL);
-    /* print new styled ..._keywordlist_items */
-    msOWSPrintEncodeMetadataList(stream, metadata, namespaces,
-                                 newname.c_str(), NULL, NULL,
-                                 template1.c_str(), NULL);
-
-    /* find out if there's a vocabulary list set */
-    const char* vocabularylist = msOWSLookupMetadata(metadata, namespaces, vocname.c_str());
-    if ( vocabularylist && nVersion >= OWS_1_3_0 ) {
-      const auto tokens = msStringSplit(vocabularylist, ',');
-      for (const auto& token: tokens) {
-          msOWSPrintEncodeMetadataList(
-            stream, metadata, namespaces,
-            (std::string(name) + '_' + token + "_items").c_str(),
-            NULL, NULL,
-            (std::string(tabspace) + "    <Keyword vocabulary=\"" + token + "\">%s</Keyword>\n").c_str(),
-            NULL);
-      }
-    }
-    msIO_printf("%s</KeywordList>\n", tabspace);
-  }
-}
-
-/*
-** msDumpLayer()
-*/
-static
-int msDumpLayer(mapObj *map, layerObj *lp, int nVersion,
-                const char *script_url_encoded, const char *indent,
-                const char *validated_language, int grouplayer,
-                int hasQueryableSubLayers)
-{
-  rectObj ext;
-  char **classgroups = NULL;
-  int iclassgroups=0;
-  char *pszMapEPSG,*pszLayerEPSG;
-
-  /* if the layer status is set to MS_DEFAULT, output a warning */
-  if (lp->status == MS_DEFAULT)
-    msIO_fprintf(stdout, "<!-- WARNING: This layer has its status set to DEFAULT and will always be displayed when doing a GetMap request even if it is not requested by the client. This is not in line with the expected behavior of a WMS server. Using status ON or OFF is recommended. -->\n");
-
-  if (nVersion <= OWS_1_0_7) {
-    msIO_printf("%s    <Layer queryable=\"%d\">\n",
-                indent, hasQueryableSubLayers || msIsLayerQueryable(lp));
-  } else {
-    /* 1.1.0 and later: opaque and cascaded are new. */
-    int cascaded=0, opaque=0;
-    const char* value = msOWSLookupMetadata(&(lp->metadata), "MO", "opaque");
-    if (value != NULL)
-      opaque = atoi(value);
-    if (lp->connectiontype == MS_WMS)
-      cascaded = 1;
-
-    msIO_printf("%s    <Layer queryable=\"%d\" opaque=\"%d\" cascaded=\"%d\">\n",
-                indent, hasQueryableSubLayers || msIsLayerQueryable(lp), opaque, cascaded);
-  }
-
-  if (lp->name && strlen(lp->name) > 0 &&
-      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
-    msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                 "invalid characters or may start with a number. This could lead to potential problems. -->\n",
-                 lp->name);
-  msOWSPrintEncodeParam(stdout, "LAYER.NAME", lp->name, OWS_NOERR,
-                        "        <Name>%s</Name>\n", NULL);
-
-  /* the majority of this section is dependent on appropriately named metadata in the LAYER object */
-  msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO", "title",
-                            OWS_WARN, "        <Title>%s</Title>\n", lp->name, validated_language);
-
-  msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO", "abstract",
-                            OWS_NOERR, "        <Abstract>%s</Abstract>\n", NULL, validated_language);
-
-  msWMSPrintKeywordlist(stdout, "        ", "keywordlist", &(lp->metadata), "MO", nVersion);
-
-  msOWSGetEPSGProj(&(map->projection),&(map->web.metadata), "MO", MS_FALSE, &pszMapEPSG);
-  msOWSGetEPSGProj(&(lp->projection),&(lp->metadata), "MO", MS_FALSE, &pszLayerEPSG);
-  if(pszMapEPSG == NULL) {
-    /* If map has no proj then every layer MUST have one or produce a warning */
-    if (nVersion > OWS_1_1_0) {
-      /* starting 1.1.1 SRS are given in individual tags */
-      if (nVersion >= OWS_1_3_0) {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
-                                  "MAP.PROJECTION, LAYER.PROJECTION "
-                                  "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
-                                  "        <CRS>%s</CRS>\n", NULL);
-      }
-      else {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
-                                  "MAP.PROJECTION, LAYER.PROJECTION "
-                                  "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
-                                  "        <SRS>%s</SRS>\n", NULL);
-      }
-    } else {
-      msOWSPrintEncodeParam(stdout, "(at least one of) MAP.PROJECTION, "
-                            "LAYER.PROJECTION or wms_srs metadata",
-                            pszLayerEPSG,
-                            OWS_WARN, "        <SRS>%s</SRS>\n", NULL);
-    }
-  } else {
-    /* No warning required in this case since there's at least a map proj. */
-    if (nVersion > OWS_1_1_0) {
-      /* starting 1.1.1 SRS are given in individual tags */
-      if (nVersion >=  OWS_1_3_0) {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
-                                  "MAP.PROJECTION, LAYER.PROJECTION "
-                                  "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_NOERR, ' ', NULL, NULL,
-                                  "        <CRS>%s</CRS>\n", NULL);
-      } else {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
-                                  "MAP.PROJECTION, LAYER.PROJECTION "
-                                  "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_NOERR, ' ', NULL, NULL,
-                                  "        <SRS>%s</SRS>\n", NULL);
-      }
-    } else {
-      msOWSPrintEncodeParam(stdout,
-                            " LAYER.PROJECTION (or wms_srs metadata)",
-                            pszLayerEPSG,
-                            OWS_NOERR, "        <SRS>%s</SRS>\n", NULL);
-    }
-  }
-  msFree(pszLayerEPSG);
-  msFree(pszMapEPSG);
-
-  /* If layer has no proj set then use map->proj for bounding box. */
-  if (msOWSGetLayerExtent(map, lp, "MO", &ext) == MS_SUCCESS) {
-    if(lp->projection.numargs > 0) {
-      if (nVersion >= OWS_1_3_0)
-        msOWSPrintEX_GeographicBoundingBox(stdout, "        ", &(ext),
-                                           &(lp->projection));
-      else
-        msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
-                                    &(lp->projection), NULL, OWS_WMS);
-
-      msOWSPrintBoundingBox( stdout,"        ", &(ext), &(lp->projection),
-                             &(lp->metadata), &(map->web.metadata), "MO", nVersion );
-    } else {
-      if (nVersion >= OWS_1_3_0)
-        msOWSPrintEX_GeographicBoundingBox(stdout, "        ", &(ext),
-                                           &(map->projection));
-      else
-        msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
-                                    &(map->projection), NULL, OWS_WMS);
-      msOWSPrintBoundingBox(stdout,"        ", &(ext), &(map->projection),
-                            &(lp->metadata), &(map->web.metadata), "MO", nVersion );
-    }
-  } else {
-    if (nVersion >= OWS_1_3_0)
-      msIO_printf("        <!-- WARNING: Optional Ex_GeographicBoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wms_extent metadata. Also check that your data exists in the DATA statement -->\n");
-    else
-      msIO_printf("        <!-- WARNING: Optional LatLonBoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wms_extent metadata. Also check that your data exists in the DATA statement -->\n");
-  }
-
-  /* time support */
-  const char* pszWmsTimeExtent = msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
-  if (pszWmsTimeExtent) {
-    const char* pszWmsTimeDefault = msOWSLookupMetadata(&(lp->metadata),  "MO",
-                                            "timedefault");
-
-    if (nVersion >= OWS_1_3_0) {
-      if (pszWmsTimeDefault)
-        msIO_fprintf(stdout, "        <Dimension name=\"time\" units=\"ISO8601\" default=\"%s\" nearestValue=\"0\">%s</Dimension>\n",pszWmsTimeDefault, pszWmsTimeExtent);
-      else
-        msIO_fprintf(stdout, "        <Dimension name=\"time\" units=\"ISO8601\" nearestValue=\"0\">%s</Dimension>\n",pszWmsTimeExtent);
-    }
-
-    else {
-      msIO_fprintf(stdout, "        <Dimension name=\"time\" units=\"ISO8601\"/>\n");
-      if (pszWmsTimeDefault)
-        msIO_fprintf(stdout, "        <Extent name=\"time\" default=\"%s\" nearestValue=\"0\">%s</Extent>\n",pszWmsTimeDefault, pszWmsTimeExtent);
-      else
-        msIO_fprintf(stdout, "        <Extent name=\"time\" nearestValue=\"0\">%s</Extent>\n",pszWmsTimeExtent);
-    }
-  }
-
-  /*dimensions support: elevation + other user defined dimensions*/
-  const char* pszDimensionlist = msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
-  if (pszDimensionlist) {
-    auto tokens = msStringSplit(pszDimensionlist, ',');
-    for( auto& dimension: tokens ) {
-        /*check if manadatory unit and extent are set. Item should also be set. default value is optional*/
-        msStringTrim(dimension);
-
-        const char* pszDimensionItem = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_item").c_str());
-        const char* pszDimensionExtent = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_extent").c_str());
-        const char* pszDimensionUnit = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_units").c_str());
-        const char* pszDimensionDefault = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_default").c_str());
-
-        if (pszDimensionItem && pszDimensionExtent && pszDimensionUnit) {
-          if (nVersion >= OWS_1_3_0) {
-            if(pszDimensionDefault && strlen(pszDimensionDefault) > 0)
-              msIO_fprintf(stdout, "        <Dimension name=\"%s\" units=\"%s\" default=\"%s\" multipleValues=\"1\" nearestValue=\"0\">%s</Dimension>\n",
-                           dimension.c_str(), pszDimensionUnit, pszDimensionDefault, pszDimensionExtent);
-            else
-              msIO_fprintf(stdout, "        <Dimension name=\"%s\" units=\"%s\"  multipleValues=\"1\"  nearestValue=\"0\">%s</Dimension>\n",
-                           dimension.c_str(), pszDimensionUnit, pszDimensionExtent);
-          } else {
-            msIO_fprintf(stdout, "        <Dimension name=\"%s\" units=\"%s\"/>\n", dimension.c_str(), pszDimensionUnit);
-            if(pszDimensionDefault && strlen(pszDimensionDefault) > 0)
-              msIO_fprintf(stdout, "        <Extent name=\"%s\" default=\"%s\" nearestValue=\"0\">%s</Extent>\n",
-                           dimension.c_str(), pszDimensionDefault, pszDimensionExtent);
-            else
-              msIO_fprintf(stdout, "        <Extent name=\"%s\" nearestValue=\"0\">%s</Extent>\n",
-                           dimension.c_str(), pszDimensionExtent);
-          }
-        }
-    }
-  }
-
-
-  if (nVersion >= OWS_1_0_7) {
-    msWMSPrintAttribution(stdout, "    ", &(lp->metadata), "MO");
-  }
-
-  /* AuthorityURL support and Identifier support, only available >= WMS 1.1.0 */
-  if(nVersion >= OWS_1_1_0) {
-    msWMSPrintAuthorityURL(stdout, "        ", &(lp->metadata), "MO");
-    msWMSPrintIdentifier(stdout, "        ", &(lp->metadata), "MO");
-  }
-
-  if(nVersion >= OWS_1_1_0) {
-    const char* metadataurl_list = msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_list");
-    if( metadataurl_list ) {
-      const auto tokens = msStringSplit(metadataurl_list, ' ');
-      for( const auto& token: tokens )
-      {
-        std::string key("metadataurl_");
-        key += token;
-        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(),
-                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"",
-                        NULL, NULL, ">\n          <Format>%s</Format",
-                        "\n          <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                       "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
-      }
-    }
-    else {
-      if (! msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_href"))
-        msMetadataSetGetMetadataURL(lp, script_url_encoded);
-
-      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "metadataurl",
-                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"",
-                        NULL, NULL, ">\n          <Format>%s</Format",
-                        "\n          <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                       "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
-    }
-  }
-
-  if(nVersion < OWS_1_1_0)
-    msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO", "dataurl_href",
-                             OWS_NOERR, "        <DataURL>%s</DataURL>\n",
-                             NULL);
-  else {
-    const char* dataurl_list = msOWSLookupMetadata(&(lp->metadata), "MO", "dataurl_list");
-    if( dataurl_list ) {
-      const auto tokens = msStringSplit(dataurl_list, ' ');
-      for( const auto& token: tokens )
-      {
-        std::string key("dataurl_");
-        key += token;
-        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(),
-                        OWS_NOERR, NULL, "DataURL", NULL, NULL, NULL,
-                        ">\n          <Format>%s</Format",
-                        "\n          <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
-      }
-    }
-    else {
-      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "dataurl",
-                        OWS_NOERR, NULL, "DataURL", NULL, NULL, NULL,
-                        ">\n          <Format>%s</Format",
-                        "\n          <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
-    }
-  }
-
-  /* The LegendURL reside in a style. The Web Map Context spec already  */
-  /* included the support on this in mapserver. However, it is not in the  */
-  /* wms_legendurl_... metadatas it's in the styles metadata, */
-  /* In wms_style_<style_name>_lengendurl_... metadata. So we have to detect */
-  /* the current style before reading it. Also in the Style block, we need */
-  /* a Title and a name. Title is derived from wms_style_<style>_title, */
-  /* which allows mutiple style definitions, e.g. by using classgroups. */
-  const char* pszStyle = msOWSLookupMetadata(&(lp->metadata), "MO", "style");
-  const char *pszLegendURL=NULL;
-  if (pszStyle) {
-    pszLegendURL = msOWSLookupMetadata(&(lp->metadata), "MO",
-        (std::string("style_") + pszStyle + "_legendurl_href").c_str());
-  } else
-    pszStyle = "default";
-
-
-  if(nVersion <= OWS_1_0_0 && pszLegendURL) {
-    /* First, print the style block */
-    msIO_fprintf(stdout, "        <Style>\n");
-    msIO_fprintf(stdout, "          <Name>%s</Name>\n", pszStyle);
-    /* Print the real Title or Style name otherwise */
-    msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO",
-                              (std::string("style_") + pszStyle + "_title").c_str(),
-                              OWS_NOERR,
-                              "          <Title>%s</Title>\n",
-                              pszStyle, validated_language);
-
-    /* Inside, print the legend url block */
-    msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO",
-                             (std::string("style_") + pszStyle + "_legendurl_href").c_str(),
-                             OWS_NOERR,
-                             "          <StyleURL>%s</StyleURL>\n",
-                             NULL);
-
-    /* close the style block */
-    msIO_fprintf(stdout, "        </Style>\n");
-
-  } else if(nVersion >= OWS_1_1_0) {
-    if (pszLegendURL) {
-      /* First, print the style block */
-      msIO_fprintf(stdout, "        <Style>\n");
-      msIO_fprintf(stdout, "          <Name>%s</Name>\n", pszStyle);
-      /* Print the real Title or Style name otherwise */
-      msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO",
-                                (std::string("style_") + pszStyle + "_title").c_str(),
-                                OWS_NOERR,
-                                "          <Title>%s</Title>\n",
-                                pszStyle, validated_language);
-
-
-      /* Inside, print the legend url block */
-      msOWSPrintURLType(stdout, &(lp->metadata), "MO",
-                        (std::string("style_") + pszStyle + "_legendurl").c_str(),
-                        OWS_NOERR, NULL, "LegendURL", NULL,
-                        " width=\"%s\"", " height=\"%s\"",
-                        ">\n             <Format>%s</Format",
-                        "\n             <OnlineResource "
-                        "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                        " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                        "          ",
-                        MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "          ");
-      msIO_fprintf(stdout, "        </Style>\n");
-
-    } else {
-      if (script_url_encoded) {
-        if (lp->connectiontype != MS_WMS &&
-            lp->connectiontype != MS_WFS &&
-            lp->connectiontype != MS_UNUSED_1 &&
-            lp->numclasses > 0) {
-          bool classnameset = false;
-          for (int i=0; i<lp->numclasses; i++) {
-            if (lp->_class[i]->name &&
-                strlen(lp->_class[i]->name) > 0) {
-              classnameset = true;
-              break;
-            }
-          }
-          if (classnameset) {
-            int size_x=0, size_y=0;
-            std::vector<int> group_layers;
-            group_layers.reserve(map->numlayers);
-
-            char ***nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-            int *numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-            int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-            msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-            group_layers.push_back(lp->index);
-            if (isUsedInNestedGroup[lp->index]) {
-              for (int j=0; j < map->numlayers; j++) {
-                if (j == lp->index)
-                    continue;
-                for(int k = 0; k < numNestedGroups[j]; k++) {
-                  if (strcasecmp(lp->name, nestedGroups[j][k]) == 0) {
-                    group_layers.push_back(j);
-                    break;
-                  }
-                }
-              }
-            }
-
-            if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(), static_cast<int>(group_layers.size()), NULL, 1) == MS_SUCCESS) {
-              const std::string width(std::to_string(size_x));
-              const std::string height(std::to_string(size_y));
-
-              char* mimetype = NULL;
-#if defined USE_PNG
-              mimetype = msEncodeHTMLEntities("image/png");
-#endif
-
-#if defined USE_JPEG
-              if (!mimetype)
-                mimetype = msEncodeHTMLEntities("image/jpeg");
-#endif
-              if (!mimetype)
-                mimetype = msEncodeHTMLEntities(MS_IMAGE_MIME_TYPE(map->outputformat));
-
-              /* -------------------------------------------------------------------- */
-              /*      check if the group parameters for the classes are set. We       */
-              /*      should then publish the different class groups as different styles.*/
-              /* -------------------------------------------------------------------- */
-              iclassgroups = 0;
-              classgroups = NULL;
-
-              const char* styleName = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
-              if (styleName == NULL)
-                styleName = "default";
-              char* pszEncodedStyleName = msEncodeHTMLEntities(styleName);
-
-              for (int i=0; i<lp->numclasses; i++) {
-                if (lp->_class[i]->name && lp->_class[i]->group) {
-                  /* Check that style is not inherited from root layer (#4442). */
-                  if (strcasecmp(pszEncodedStyleName, lp->_class[i]->group) == 0)
-                    continue;
-                  /* Check that style is not inherited from group layer(s) (#4442). */
-                  if (numNestedGroups[lp->index] > 0) {
-                    int j=0;
-                    layerObj *lp2 = NULL;
-                    for (; j<numNestedGroups[lp->index]; j++) {
-                      int l = 0;
-                      for (int k=0; k < map->numlayers; k++) {
-                        if (GET_LAYER(map, k)->name && strcasecmp(GET_LAYER(map, k)->name, nestedGroups[lp->index][j]) == 0) {
-                          lp2 = (GET_LAYER(map, k));
-                          for (l=0; l < lp2->numclasses; l++) {
-                            if (strcasecmp(lp2->_class[l]->group, lp->_class[i]->group) == 0)
-                              break;
-                          }
-                          break;
-                        }
-                      }
-                      if (lp2 && l < lp2->numclasses)
-                        break;
-                    }
-                    if (j < numNestedGroups[lp->index])
-                      continue;
-                  }
-                  if (!classgroups) {
-                    classgroups = (char **)msSmallMalloc(sizeof(char *));
-                    classgroups[iclassgroups++]= msStrdup(lp->_class[i]->group);
-                  } else {
-                    /* Output style only once. */
-                    bool found = false;
-                    for (int j=0; j<iclassgroups; j++) {
-                      if (strcasecmp(classgroups[j], lp->_class[i]->group) == 0) {
-                        found = true;
-                        break;
-                      }
-                    }
-                    if (!found) {
-                      iclassgroups++;
-                      classgroups = (char **)msSmallRealloc(classgroups, sizeof(char *)*iclassgroups);
-                      classgroups[iclassgroups-1]= msStrdup(lp->_class[i]->group);
-                    }
-                  }
-                }
-              }
-              msFree(pszEncodedStyleName);
-              if (classgroups == NULL) {
-                classgroups = (char **)msSmallMalloc(sizeof(char *));
-                classgroups[0]= msStrdup("default");
-                iclassgroups = 1;
-              }
-
-              for (int i=0; i<iclassgroups; i++) {
-                char *name_encoded = msEncodeHTMLEntities(lp->name);
-                char *classgroup_encoded = msEncodeHTMLEntities(classgroups[i]);
-                std::string legendurl(script_url_encoded);
-                legendurl += "version=";
-                char szVersionBuf[OWS_VERSION_MAXLEN];
-                legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
-                legendurl += "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
-                if (nVersion >= OWS_1_3_0) {
-                  legendurl += "sld_version=1.1.0&amp;layer=";
-                }
-                else {
-                  legendurl += "layer=";
-                }
-                legendurl += name_encoded;
-                legendurl += "&amp;format=";
-                legendurl += mimetype;
-                legendurl += "&amp;STYLE=";
-                legendurl += classgroup_encoded;
-
-                msFree(name_encoded);
-                msFree(classgroup_encoded);
-
-                msIO_fprintf(stdout, "        <Style>\n");
-                msIO_fprintf(stdout, "          <Name>%s</Name>\n",  classgroups[i]);
-                msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO",
-                                          (std::string("style_") + classgroups[i] + "_title").c_str(),
-                                          OWS_NOERR,
-                                          "          <Title>%s</Title>\n",
-                                          classgroups[i], validated_language);
-
-                /* A legendurl from wms_style_<style>_legendurl_href will override a self generated legend graphic */
-                pszLegendURL = msOWSLookupMetadata(&(lp->metadata), "MO",
-                    (std::string("style_") + classgroups[i] + "_legendurl_href").c_str());
-                if (pszLegendURL) {
-                  msOWSPrintURLType(stdout, &(lp->metadata),
-                                    "MO",
-                                    (std::string("style_") + classgroups[i] + "_legendurl").c_str(),
-                                    OWS_NOERR, NULL,
-                                    "LegendURL", NULL,
-                                    " width=\"%s\"", " height=\"%s\"",
-                                    ">\n             <Format>%s</Format",
-                                    "\n             <OnlineResource "
-                                    "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                    " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                    "          ",
-                                    MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                                    NULL, NULL, NULL, NULL, NULL, "          ");
-                } else {
-                  msOWSPrintURLType(stdout, NULL,
-                                    "O", "ttt",
-                                    OWS_NOERR, NULL,
-                                    "LegendURL", NULL,
-                                    " width=\"%s\"", " height=\"%s\"",
-                                    ">\n             <Format>%s</Format",
-                                    "\n             <OnlineResource "
-                                    "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                    " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                    "          ",
-                                    MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                                    NULL, width.c_str(), height.c_str(), mimetype, legendurl.c_str(), "          ");
-                }
-                msIO_fprintf(stdout, "        </Style>\n");
-              }
-              msFreeCharArray(classgroups, iclassgroups);
-              msFree(mimetype);
-            }
-            /* free the stuff used for nested layers */
-            for (int i = 0; i < map->numlayers; i++) {
-              if (numNestedGroups[i] > 0) {
-                msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
-              }
-            }
-            free(nestedGroups);
-            free(numNestedGroups);
-            free(isUsedInNestedGroup);
-          }
-        }
-      }
-    }
-  }
-
-  /* print Min/Max ScaleDenominator */
-  if (nVersion <  OWS_1_3_0)
-    msWMSPrintScaleHint("        ", lp->minscaledenom, lp->maxscaledenom, map->resolution);
-  else
-    msWMSPrintScaleDenominator("        ", lp->minscaledenom, lp->maxscaledenom);
-
-  if ( grouplayer == MS_FALSE )
-    msIO_printf("%s    </Layer>\n", indent);
-
-  return MS_SUCCESS;
-}
-
-/*
- * msWMSIsSubGroup
- */
-static bool msWMSIsSubGroup(char** currentGroups, int currentLevel, char** otherGroups, int numOtherGroups)
-{
-  /* no match if otherGroups[] has less levels than currentLevel */
-  if (numOtherGroups <= currentLevel) {
-    return false;
-  }
-  /* compare all groups below the current level */
-  for (int i = 0; i <= currentLevel; i++) {
-    if (strcmp(currentGroups[i], otherGroups[i]) != 0) {
-      return false; /* if one of these is not equal it is not a sub group */
-    }
-  }
-  return true;
-}
-
-/*
- * msWMSHasQueryableSubLayers
- */
-static int msWMSHasQueryableSubLayers(mapObj* map, int index, int level,
-                                      char*** nestedGroups, int* numNestedGroups)
-{
-    for (int j = index; j < map->numlayers; j++) {
-      if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j], numNestedGroups[j])) {
-          if( msIsLayerQueryable( GET_LAYER(map,j) ) )
-              return MS_TRUE;
-      }
-    }
-    return MS_FALSE;
-}
-
-/***********************************************************************************
- * msWMSPrintNestedGroups()                                                        *
- *                                                                                 *
- * purpose: Writes the layers to the capabilities that have the                    *
- * "WMS_LAYER_GROUP" metadata set.                                                 *
- *                                                                                 *
- * params:                                                                         *
- * -map: The main map object                                                       *
- * -nVersion: OGC WMS version                                                      *
- * -pabLayerProcessed: boolean array indicating which layers have been dealt with. *
- * -index: the index of the current layer.                                         *
- * -level: the level of depth in the group tree (root = 0)                         *
- * -nestedGroups: This array holds the arrays of groups that have                  *
- *   been set through the WMS_LAYER_GROUP metadata                                 *
- * -numNestedGroups: This array holds the number of nested groups for each layer   *
- ***********************************************************************************/
-void msWMSPrintNestedGroups(mapObj* map, int nVersion, char* pabLayerProcessed,
-                            int index, int level, char*** nestedGroups, int* numNestedGroups, int* isUsedInNestedGroup, const char *script_url_encoded, const char *validated_language)
-{
-  bool groupAdded = false;
-  std::string indent;
-  for (int i = 0; i < level; i++) {
-    indent += "  ";
-  }
-
-  if (numNestedGroups[index] <= level) { /* no more subgroups */
-    if ((!pabLayerProcessed[index]) && (!isUsedInNestedGroup[index])) {
-      /* we are at the deepest level of the group branchings, so add layer now. */
-      msDumpLayer(map, GET_LAYER(map, index), nVersion, script_url_encoded, indent.c_str(), validated_language, MS_FALSE, MS_FALSE);
-      pabLayerProcessed[index] = 1; /* done */
-    }
-  } else { /* not yet there, we have to deal with this group and possible subgroups and layers. */
-    int j;
-    for (j = 0; j < map->numlayers; j++) {
-      if ( GET_LAYER(map, j)->name && strcasecmp(GET_LAYER(map, j)->name, nestedGroups[index][level]) == 0 ) {
-        break;
-      }
-    }
-
-    /* Beginning of a new group... enclose the group in a layer block */
-    if ( j < map->numlayers ) {
-      if (!pabLayerProcessed[j]) {
-        msDumpLayer(map, GET_LAYER(map, j), nVersion, script_url_encoded,
-                    indent.c_str(), validated_language, MS_TRUE,
-                    msWMSHasQueryableSubLayers(map, index, level,
-                            nestedGroups, numNestedGroups));
-        pabLayerProcessed[j] = 1; /* done */
-        groupAdded = true;
-      }
-    } else {
-      msIO_printf("%s    <Layer%s>\n", indent.c_str(),
-        msWMSHasQueryableSubLayers(map, index, level,
-                    nestedGroups, numNestedGroups) ? " queryable=\"1\"" : "");
-      msIO_printf("%s      <Name>%s</Name>\n", indent.c_str(), nestedGroups[index][level]);
-      msIO_printf("%s      <Title>%s</Title>\n", indent.c_str(), nestedGroups[index][level]);
-      groupAdded = true;
-    }
-
-    /* Look for one group deeper in the current layer */
-    if (!pabLayerProcessed[index]) {
-      msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed,
-                             index, level + 1, nestedGroups,
-                             numNestedGroups, isUsedInNestedGroup,
-                             script_url_encoded, validated_language);
-    }
-
-    /* look for subgroups in other layers. */
-    for (j = index + 1; j < map->numlayers; j++) {
-      if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j], numNestedGroups[j])) {
-        if (!pabLayerProcessed[j]) {
-          msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed,
-                                 j, level + 1, nestedGroups,
-                                 numNestedGroups, isUsedInNestedGroup,
-                                 script_url_encoded, validated_language);
-        }
-      } else {
-        /* TODO: if we would sort all layers on "WMS_LAYER_GROUP" beforehand */
-        /* we could break out of this loop at this point, which would increase */
-        /* performance.  */
-      }
-    }
-    /* Close group layer block */
-    if (groupAdded)
-      msIO_printf("%s    </Layer>\n", indent.c_str());
-  }
-} /* msWMSPrintNestedGroups */
-
-/*
-** msWMSGetCapabilities()
-*/
-static
-int msWMSGetCapabilities(mapObj *map, int nVersion, cgiRequestObj *req, owsRequestObj *ows_request,
-                         const char *requested_updatesequence, const char *wms_exception_format, const char *requested_language)
-{
-  const char* updatesequence = msOWSLookupMetadata(&(map->web.metadata), "MO", "updatesequence");
-
-  const char* sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
-
-  if (sldenabled == NULL)
-    sldenabled = "true";
-
-  if (requested_updatesequence != NULL) {
-    int i = msOWSNegotiateUpdateSequence(requested_updatesequence, updatesequence);
-    if (i == 0) { /* current */
-      msSetError(MS_WMSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
-      return msWMSException(map, nVersion, "CurrentUpdateSequence", wms_exception_format);
-    }
-    if (i > 0) { /* invalid */
-      msSetError(MS_WMSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
-      return msWMSException(map, nVersion, "InvalidUpdateSequence", wms_exception_format);
-    }
-  }
-
-  std::string schemalocation;
-  {
-      char* pszSchemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-      schemalocation = pszSchemalocation;
-      msFree(pszSchemalocation);
-  }
-
-  if (nVersion < 0)
-    nVersion = OWS_1_3_0;     /* Default to 1.3.0 */
-
-  /* Decide which version we're going to return. */
-  std::string dtd_url;
-  if (nVersion < OWS_1_0_7) {
-    nVersion = OWS_1_0_0;
-    dtd_url = schemalocation;
-    dtd_url += "/wms/1.0.0/capabilities_1_0_0.dtd";
-  }
-
-  else if (nVersion < OWS_1_1_0) {
-    nVersion = OWS_1_0_7;
-    dtd_url = schemalocation;
-    dtd_url += "/wms/1.0.7/capabilities_1_0_7.dtd";
-  } else if (nVersion < OWS_1_1_1) {
-    nVersion = OWS_1_1_0;
-    dtd_url = schemalocation;
-    dtd_url += "/wms/1.1.0/capabilities_1_1_0.dtd";
-  } else if (nVersion < OWS_1_3_0) {
-    nVersion = OWS_1_1_1;
-    dtd_url = schemalocation;
-    /* this exception was added to accomadote the OGC test suite (Bug 1576)*/
-    if (strcasecmp(schemalocation.c_str(), OWS_DEFAULT_SCHEMAS_LOCATION) == 0)
-      dtd_url += "/wms/1.1.1/WMS_MS_Capabilities.dtd";
-    else
-      dtd_url += "/wms/1.1.1/capabilities_1_1_1.dtd";
-  } else
-    nVersion = OWS_1_3_0;
-
-  /* This function owns validated_language, so remember to free it later*/
-  std::string validated_language;
-  {
-    char* pszValidated_language = msOWSGetLanguageFromList(map, "MO", requested_language);
-    if( pszValidated_language )
-    {
-        validated_language = pszValidated_language;
-        msMapSetLanguageSpecificConnection(map, pszValidated_language);
-    }
-    msFree(pszValidated_language);
-  }
-
-  /* We need this server's onlineresource. */
-  /* Default to use the value of the "onlineresource" metadata, and if not */
-  /* set then build it: "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?" */
-  /* the returned string should be freed once we're done with it. */
-  char *script_url_encoded=NULL;
-  {
-    char *script_url = msOWSGetOnlineResource2(map, "MO", "onlineresource", req, validated_language.c_str());
-    if (script_url == NULL ||
-        (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
-      free(script_url);
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-    free(script_url);
-  }
-
-  if (nVersion <= OWS_1_0_7 || nVersion >= OWS_1_3_0)   /* 1.0.0 to 1.0.7 and >=1.3.0*/
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  else /* 1.1.0 and later */
-    msIO_setHeader("Content-Type","application/vnd.ogc.wms_xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-
-  /*TODO review wms1.3.0*/
-  if ( nVersion < OWS_1_3_0) {
-    msIO_printf("<!DOCTYPE WMT_MS_Capabilities SYSTEM \"%s\"\n", dtd_url.c_str());
-    msIO_printf(" [\n");
-
-    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      msIO_printf("<!ELEMENT VendorSpecificCapabilities (inspire_vs:ExtendedCapabilities)><!ELEMENT inspire_vs:ExtendedCapabilities ((inspire_common:MetadataUrl, inspire_common:SupportedLanguages, inspire_common:ResponseLanguage) | (inspire_common:ResourceLocator+, inspire_common:ResourceType, inspire_common:TemporalReference+, inspire_common:Conformity+, inspire_common:MetadataPointOfContact+, inspire_common:MetadataDate, inspire_common:SpatialDataServiceType, inspire_common:MandatoryKeyword+, inspire_common:Keyword*, inspire_common:SupportedLanguages, inspire_common:ResponseLanguage, inspire_common:MetadataUrl?))><!ATTLIST inspire_vs:ExtendedCapabilities xmlns:inspire_vs CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/inspire_vs/1.0\" ><!ELEMENT inspire_common:MetadataUrl (inspire_common:URL, inspire_common:MediaType*)><!ATTLIST inspire_common:MetadataUrl xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA #FIXED \"http://www.w3.org/2001/XMLSchema-instance\" xsi:type CDATA #FIXED \"inspire_common:resourceLocatorType\" ><!ELEMENT inspire_common:URL (#PCDATA)><!ATTLIST inspire_common:URL xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:MediaType (#PCDATA)><!ATTLIST inspire_common:MediaType xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:SupportedLanguages (inspire_common:DefaultLanguage, inspire_common:SupportedLanguage*)><!ATTLIST inspire_common:SupportedLanguages xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:DefaultLanguage (inspire_common:Language)><!ATTLIST inspire_common:DefaultLanguage xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:SupportedLanguage (inspire_common:Language)><!ATTLIST inspire_common:SupportedLanguage xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
-                  "<!ELEMENT inspire_common:ResponseLanguage (inspire_common:Language)><!ATTLIST inspire_common:ResponseLanguage xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Language (#PCDATA)><!ATTLIST inspire_common:Language xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:ResourceLocator (inspire_common:URL, inspire_common:MediaType*)><!ATTLIST inspire_common:ResourceLocator xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:ResourceType (#PCDATA)> <!ATTLIST inspire_common:ResourceType xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:TemporalReference (inspire_common:DateOfCreation?, inspire_common:DateOfLastRevision?, inspire_common:DateOfPublication*, inspire_common:TemporalExtent*)><!ATTLIST inspire_common:TemporalReference xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:DateOfCreation (#PCDATA)> <!ATTLIST inspire_common:DateOfCreation xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:DateOfLastRevision (#PCDATA)><!ATTLIST inspire_common:DateOfLastRevision xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:DateOfPublication (#PCDATA)><!ATTLIST inspire_common:DateOfPublication xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:TemporalExtent (inspire_common:IndividualDate | inspire_common:IntervalOfDates)><!ATTLIST inspire_common:TemporalExtent xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:IndividualDate (#PCDATA)> <!ATTLIST inspire_common:IndividualDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\">"
-                  "<!ELEMENT inspire_common:IntervalOfDates (inspire_common:StartingDate, inspire_common:EndDate)><!ATTLIST inspire_common:IntervalOfDates xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:StartingDate (#PCDATA)><!ATTLIST inspire_common:StartingDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:EndDate (#PCDATA)><!ATTLIST inspire_common:EndDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Conformity (inspire_common:Specification, inspire_common:Degree)><!ATTLIST inspire_common:Conformity xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Specification (inspire_common:Title, (inspire_common:DateOfPublication | inspire_common:DateOfCreation | inspire_common:DateOfLastRevision), inspire_common:URI*, inspire_common:ResourceLocator*)><!ATTLIST inspire_common:Specification xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Title (#PCDATA)><!ATTLIST inspire_common:Title xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:URI (#PCDATA)><!ATTLIST inspire_common:URI xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Degree (#PCDATA)><!ATTLIST inspire_common:Degree xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:MetadataPointOfContact (inspire_common:OrganisationName, inspire_common:EmailAddress)><!ATTLIST inspire_common:MetadataPointOfContact xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
-                  "<!ELEMENT inspire_common:OrganisationName (#PCDATA)><!ATTLIST inspire_common:OrganisationName  xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:EmailAddress (#PCDATA)><!ATTLIST inspire_common:EmailAddress xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:MetadataDate (#PCDATA)><!ATTLIST inspire_common:MetadataDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:SpatialDataServiceType (#PCDATA)><!ATTLIST inspire_common:SpatialDataServiceType xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:MandatoryKeyword (inspire_common:KeywordValue)><!ATTLIST inspire_common:MandatoryKeyword xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:KeywordValue (#PCDATA)><!ATTLIST inspire_common:KeywordValue xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
-                  "<!ELEMENT inspire_common:Keyword (inspire_common:OriginatingControlledVocabulary?, inspire_common:KeywordValue)><!ATTLIST inspire_common:Keyword xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA #FIXED \"http://www.w3.org/2001/XMLSchemainstance\" xsi:type (inspire_common:inspireTheme_bul | inspire_common:inspireTheme_cze | inspire_common:inspireTheme_dan | inspire_common:inspireTheme_dut | inspire_common:inspireTheme_eng | inspire_common:inspireTheme_est | inspire_common:inspireTheme_fin | inspire_common:inspireTheme_fre | inspire_common:inspireTheme_ger | inspire_common:inspireTheme_gre | inspire_common:inspireTheme_hun | inspire_common:inspireTheme_gle | inspire_common:inspireTheme_ita | inspire_common:inspireTheme_lav | inspire_common:inspireTheme_lit | inspire_common:inspireTheme_mlt | inspire_common:inspireTheme_pol | inspire_common:inspireTheme_por | inspire_common:inspireTheme_rum | inspire_common:inspireTheme_slo | inspire_common:inspireTheme_slv | inspire_common:inspireTheme_spa | inspire_common:inspireTheme_swe) #IMPLIED ><!ELEMENT inspire_common:OriginatingControlledVocabulary (inspire_common:Title, (inspire_common:DateOfPublication | inspire_common:DateOfCreation | inspire_common:DateOfLastRevision), inspire_common:URI*, inspire_common:ResourceLocator*)><!ATTLIST inspire_common:OriginatingControlledVocabulary xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\">\n");
-    } else {
-      /* some mapserver specific declarations will go here */
-      msIO_printf(" <!ELEMENT VendorSpecificCapabilities EMPTY>\n");
-    }
-
-    msIO_printf(" ]>  <!-- end of DOCTYPE declaration -->\n\n");
-  }
-
-  char szVersionBuf[OWS_VERSION_MAXLEN];
-  const char* pszVersion = msOWSGetVersionString(nVersion, szVersionBuf);
-  if ( nVersion >= OWS_1_3_0)
-    msIO_printf("<WMS_Capabilities version=\"%s\"", pszVersion);
-  else
-    msIO_printf("<WMT_MS_Capabilities version=\"%s\"", pszVersion);
-  if (updatesequence)
-    msIO_printf(" updateSequence=\"%s\"",updatesequence);
-
-
-  if ( nVersion == OWS_1_3_0) {
-    msIO_printf("  xmlns=\"http://www.opengis.net/wms\""
-                "   xmlns:sld=\"http://www.opengis.net/sld\""
-                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\""
-                "   xmlns:ms=\"http://mapserver.gis.umn.edu/mapserver\"");
-
-    if ( msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      msIO_printf("   xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\""
-                  "   xmlns:" MS_INSPIRE_VS_NAMESPACE_PREFIX "=\"" MS_INSPIRE_VS_NAMESPACE_URI "\"" );
-    }
-
-    msIO_printf("   xsi:schemaLocation=\"http://www.opengis.net/wms %s/wms/%s/capabilities_1_3_0.xsd "
-                " http://www.opengis.net/sld %s/sld/1.1.0/sld_capabilities.xsd ",
-                msOWSGetSchemasLocation(map), pszVersion, msOWSGetSchemasLocation(map));
-
-    if ( msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      char* inspireschemalocation = msEncodeHTMLEntities( msOWSGetInspireSchemasLocation(map) );
-      msIO_printf(" " MS_INSPIRE_VS_NAMESPACE_URI " "
-                  " %s%s", inspireschemalocation, MS_INSPIRE_VS_SCHEMA_LOCATION);
-      free(inspireschemalocation);
-    }
-
-    msIO_printf(" http://mapserver.gis.umn.edu/mapserver %sservice=WMS&amp;version=1.3.0&amp;request=GetSchemaExtension\"",
-                script_url_encoded);
-  }
-
-  msIO_printf(">\n");
-
-  /* WMS definition */
-  msIO_printf("<Service>\n");
-
-  /* Service name is defined by the spec and changed at v1.0.0 */
-  if (nVersion <= OWS_1_0_7)
-    msIO_printf("  <Name>GetMap</Name>\n");  /* v 1.0.0 to 1.0.7 */
-  else if (nVersion > OWS_1_0_7 && nVersion < OWS_1_3_0)
-    msIO_printf("  <Name>OGC:WMS</Name>\n"); /* v 1.1.0 to 1.1.1*/
-  else
-    msIO_printf("  <Name>WMS</Name>\n"); /* v 1.3.0+ */
-
-
-  /* the majority of this section is dependent on appropriately named metadata in the WEB object */
-  msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "title",
-                            OWS_WARN, "  <Title>%s</Title>\n", map->name, validated_language.c_str());
-  msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "abstract",
-                            OWS_NOERR, "  <Abstract>%s</Abstract>\n", NULL, validated_language.c_str());
-
-  msWMSPrintKeywordlist(stdout, "  ", "keywordlist", &(map->web.metadata), "MO", nVersion);
-
-  /* Service/onlineresource */
-  /* Defaults to same as request onlineresource if wms_service_onlineresource  */
-  /* is not set. */
-  if (nVersion== OWS_1_0_0)
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
-                             "MO", "service_onlineresource", OWS_NOERR,
-                             "  <OnlineResource>%s</OnlineResource>\n",
-                             script_url_encoded);
-  else
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
-                             "MO", "service_onlineresource", OWS_NOERR,
-                             "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/>\n",
-                             script_url_encoded);
-
-  /* contact information is a required element in 1.0.7 but the */
-  /* sub-elements such as ContactPersonPrimary, etc. are not! */
-  /* In 1.1.0, ContactInformation becomes optional. */
-  msOWSPrintContactInfo(stdout, "  ", nVersion, &(map->web.metadata), "MO");
-
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO", "fees",
-                           OWS_NOERR, "  <Fees>%s</Fees>\n", NULL);
-
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO",
-                           "accessconstraints", OWS_NOERR,
-                           "  <AccessConstraints>%s</AccessConstraints>\n", NULL);
-
-  if (nVersion >= OWS_1_3_0) {
-    const char* layerlimit = msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
-    if (layerlimit) {
-      msIO_printf("  <LayerLimit>%s</LayerLimit>\n", layerlimit);
-    }
-    msIO_printf("  <MaxWidth>%d</MaxWidth>\n", map->maxsize);
-    msIO_printf("  <MaxHeight>%d</MaxHeight>\n", map->maxsize);
-  }
-
-  msIO_printf("</Service>\n\n");
-
-  /* WMS capabilities definitions */
-  msIO_printf("<Capability>\n");
-  msIO_printf("  <Request>\n");
-
-  if (nVersion <= OWS_1_0_7) {
-    /* WMS 1.0.0 to 1.0.7 - We don't try to use outputformats list here for now */
-    if (msOWSRequestIsEnabled(map, NULL, "M", "GetMap", MS_FALSE))
-      msWMSPrintRequestCap(nVersion, "Map", script_url_encoded, ""
-
-#if defined USE_PNG
-                           "<PNG />"
-#endif
-#if defined USE_JPEG
-                           "<JPEG />"
-#endif
-                           "<SVG />"
-                           , NULL);
-    if (msOWSRequestIsEnabled(map, NULL, "M", "GetCapabilities", MS_TRUE))
-      msWMSPrintRequestCap(nVersion, "Capabilities", script_url_encoded, "<WMS_XML />", NULL);
-    if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE))
-      msWMSPrintRequestCap(nVersion, "FeatureInfo", script_url_encoded, "<MIME /><GML.1 />", NULL);
-  } else {
-    const char *mime_list[20];
-    int mime_count = 0;
-    int max_mime = 20;
-    /* WMS 1.1.0 and later */
-    /* Note changes to the request names, their ordering, and to the formats */
-
-    if (msOWSRequestIsEnabled(map, NULL, "M", "GetCapabilities", MS_TRUE)) {
-      if (nVersion >= OWS_1_3_0)
-        msWMSPrintRequestCap(nVersion, "GetCapabilities", script_url_encoded,
-                             "text/xml",
-                             NULL);
-      else
-        msWMSPrintRequestCap(nVersion, "GetCapabilities", script_url_encoded,
-                             "application/vnd.ogc.wms_xml",
-                             NULL);
-    }
-
-    msGetOutputFormatMimeListWMS(map,mime_list,sizeof(mime_list)/sizeof(char*));
-    if (msOWSRequestIsEnabled(map, NULL, "M", "GetMap", MS_FALSE))
-      msWMSPrintRequestCap(nVersion, "GetMap", script_url_encoded,
-                           mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                           mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                           mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                           mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                           mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                           NULL );
-
-    const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
-                                      "getfeatureinfo_formatlist");
-    /*feature_info_mime_type depricated for MapServer 6.0*/
-    if (!format_list)
-      format_list = msOWSLookupMetadata(&(map->web.metadata), "MO",
-                                        "feature_info_mime_type");
-
-    if (format_list && strlen(format_list) > 0) {
-      auto tokens = msStringSplit(format_list, ',');
-      for(auto& token: tokens) {
-          msStringTrim(token);
-          /*text plain and gml do not need to be a format and accepted by default*/
-          /*can not really validate since the old way of using template
-            with wei->header, layer->template ... should be kept*/
-          if (!token.empty() && mime_count<max_mime)
-            mime_list[mime_count++] = token.c_str();
-      }
-      /*add text/plain and gml */
-      if (strcasestr(format_list, "GML") == 0 &&
-          strcasestr(format_list, "application/vnd.ogc.gml") == 0) {
-        if (mime_count<max_mime)
-          mime_list[mime_count++] = "application/vnd.ogc.gml";
-      }
-      if (strcasestr(format_list, "text/plain") == 0 &&
-          strcasestr(format_list, "MIME") == 0) {
-        if (mime_count<max_mime)
-          mime_list[mime_count++] = "text/plain";
-        else /*force always this format*/
-          mime_list[max_mime-1] = "text/plain";
-      }
-
-
-      if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE)) {
-        if (mime_count>0) {
-          if (mime_count<max_mime)
-            mime_list[mime_count] = NULL;
-          msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
-                               mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                               mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                               mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                               mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                               mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                               NULL);
-        }
-        /*if all formats given are invalid go to default*/
-        else
-          msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
-                               "text/plain",
-                               "application/vnd.ogc.gml",
-                               NULL);
-      }
-    } else {
-      if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE))
-        msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
-                             "text/plain",
-                             "application/vnd.ogc.gml",
-                             NULL);
-    }
-
-
-    if (strcasecmp(sldenabled, "true") == 0) {
-      if (msOWSRequestIsEnabled(map, NULL, "M", "DescribeLayer", MS_FALSE)) {
-        if (nVersion == OWS_1_3_0)
-          msWMSPrintRequestCap(nVersion, "sld:DescribeLayer", script_url_encoded, "text/xml", NULL);
-        else
-          msWMSPrintRequestCap(nVersion, "DescribeLayer", script_url_encoded, "text/xml", NULL);
-      }
-
-      msGetOutputFormatMimeListImg(map,mime_list,sizeof(mime_list)/sizeof(char*));
-
-      if (nVersion >= OWS_1_1_1) {
-        const auto isGetLegendGraphicEnabled =
-            msOWSRequestIsEnabled(map, NULL, "M", "GetLegendGraphic", MS_FALSE);
-        if (nVersion == OWS_1_3_0) {
-          if (isGetLegendGraphicEnabled)
-            msWMSPrintRequestCap(nVersion, "sld:GetLegendGraphic", script_url_encoded,
-                                 mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                                 mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                                 mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                                 mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                                 mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                                 NULL );
-          if (msOWSRequestIsEnabled(map, NULL, "M", "GetStyles", MS_FALSE))
-            msWMSPrintRequestCap(nVersion, "ms:GetStyles", script_url_encoded, "text/xml", NULL);
-        } else {
-          if (isGetLegendGraphicEnabled)
-            msWMSPrintRequestCap(nVersion, "GetLegendGraphic", script_url_encoded,
-                                 mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                                 mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                                 mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                                 mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                                 mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                                 NULL );
-          if (msOWSRequestIsEnabled(map, NULL, "M", "GetStyles", MS_FALSE))
-            msWMSPrintRequestCap(nVersion, "GetStyles", script_url_encoded, "text/xml", NULL);
-        }
-      }
-    }
-  }
-
-  msIO_printf("  </Request>\n");
-
-  msIO_printf("  <Exception>\n");
-  if (nVersion <= OWS_1_0_7)
-    msIO_printf("    <Format><BLANK /><INIMAGE /><WMS_XML /></Format>\n");
-  else if (nVersion <= OWS_1_1_1) {
-    msIO_printf("    <Format>application/vnd.ogc.se_xml</Format>\n");
-    msIO_printf("    <Format>application/vnd.ogc.se_inimage</Format>\n");
-    msIO_printf("    <Format>application/vnd.ogc.se_blank</Format>\n");
-  } else { /*>=1.3.0*/
-    msIO_printf("    <Format>XML</Format>\n");
-    msIO_printf("    <Format>INIMAGE</Format>\n");
-    msIO_printf("    <Format>BLANK</Format>\n");
-
-  }
-  msIO_printf("  </Exception>\n");
-
-  if (nVersion != OWS_1_3_0) {
-    /* INSPIRE extended capabilities for WMS 1.1.1 */
-    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      msIO_printf("  <VendorSpecificCapabilities>\n");
-      msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL, validated_language.c_str(), OWS_WMS);
-      msIO_printf("  </VendorSpecificCapabilities>\n");
-    } else {
-      msIO_printf("  <VendorSpecificCapabilities />\n"); /* nothing yet */
-    }
-  }
-
-  /* SLD support */
-  if (strcasecmp(sldenabled, "true") == 0) {
-    if (nVersion >= OWS_1_0_7) {
-      if (nVersion >= OWS_1_3_0)
-        msIO_printf("  <sld:UserDefinedSymbolization SupportSLD=\"1\" UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\" InlineFeature=\"0\" RemoteWCS=\"0\"/>\n");
-      else
-        msIO_printf("  <UserDefinedSymbolization SupportSLD=\"1\" UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\"/>\n");
-    }
-  }
-
-  /* INSPIRE extended capabilities for WMS 1.3.0 */
-  if (nVersion >= OWS_1_3_0 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-    msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL, validated_language.c_str(), OWS_WMS);
-  }
-
-  /* Top-level layer with map extents and SRS, encloses all map layers */
-  /* Output only if at least one layers is enabled. */
-  if (ows_request->numlayers == 0) {
-    msIO_fprintf(stdout, "  <!-- WARNING: No WMS layers are enabled. Check wms/ows_enable_request settings. -->\n");
-  } else {
-    int root_is_queryable = MS_FALSE;
-
-    const char* rootlayer_name = msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
-
-    /* Root layer is queryable if it has a valid name and at list one layer */
-    /* is queryable */
-    if( !rootlayer_name || strlen(rootlayer_name) > 0 ) {
-      int j;
-      for(j=0; j<map->numlayers; j++) {
-        layerObj* layer = GET_LAYER(map, j);
-        if( msIsLayerQueryable(layer) &&
-            msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers) ) {
-          root_is_queryable = MS_TRUE;
-          break;
-        }
-      }
-    }
-    msIO_printf("  <Layer%s>\n",root_is_queryable ? " queryable=\"1\"" : "");
-
-    /* Layer Name is optional but title is mandatory. */
-    if (map->name && strlen(map->name) > 0 &&
-        (msIsXMLTagValid(map->name) == MS_FALSE || isdigit(map->name[0])))
-      msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                   "invalid characters or may start with a number. This could lead to potential problems. -->\n",
-                   map->name);
-
-    if (rootlayer_name) {
-        if (strlen(rootlayer_name) > 0) {
-            msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO", "rootlayer_name",
-                                     OWS_NOERR, "    <Name>%s</Name>\n",
-                                     NULL);
-        }
-    }
-    else {
-        msOWSPrintEncodeParam(stdout, "MAP.NAME", map->name, OWS_NOERR,
-                              "    <Name>%s</Name>\n", NULL);
-    }
-
-    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO", "rootlayer_title", validated_language.c_str()))
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "rootlayer_title", OWS_WARN, "    <Title>%s</Title>\n", map->name, validated_language.c_str());
-
-    else
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "title", OWS_WARN, "    <Title>%s</Title>\n", map->name, validated_language.c_str());
-
-    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO", "rootlayer_abstract", validated_language.c_str()))
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "rootlayer_abstract", OWS_NOERR, "    <Abstract>%s</Abstract>\n", map->name, validated_language.c_str());
-    else
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "abstract", OWS_NOERR, "    <Abstract>%s</Abstract>\n", map->name, validated_language.c_str());
-
-    const char* pszTmp;
-    if (msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_keywordlist") ||
-        msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_keywordlist_vocabulary"))
-      pszTmp = "rootlayer_keywordlist";
-    else
-      pszTmp = "keywordlist";
-    msWMSPrintKeywordlist(stdout, "    ", pszTmp, &(map->web.metadata), "MO", nVersion);
-
-    /* According to normative comments in the 1.0.7 DTD, the root layer's SRS tag */
-    /* is REQUIRED.  It also suggests that we use an empty SRS element if there */
-    /* is no common SRS. */
-    char *pszMapEPSG;
-    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE, &pszMapEPSG);
-    if (nVersion > OWS_1_1_0) {
-      /* starting 1.1.1 SRS are given in individual tags */
-      if (nVersion >= OWS_1_3_0) {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
-                                  "MAP.PROJECTION, LAYER.PROJECTION "
-                                  "or wms_srs metadata",
-                                  pszMapEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
-                                  "    <CRS>%s</CRS>\n", "");
-      } else {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
-                                  "MAP.PROJECTION, LAYER.PROJECTION "
-                                  "or wms_srs metadata",
-                                  pszMapEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
-                                  "    <SRS>%s</SRS>\n", "");
-      }
-    } else {
-      /* If map has no proj then every layer MUST have one or produce a warning */
-      msOWSPrintEncodeParam(stdout, "MAP.PROJECTION (or wms_srs metadata)",
-                            pszMapEPSG,
-                            OWS_WARN, "    <SRS>%s</SRS>\n", "");
-    }
-    msFree(pszMapEPSG);
-
-    if (nVersion >= OWS_1_3_0)
-      msOWSPrintEX_GeographicBoundingBox(stdout, "    ", &(map->extent),
-                                         &(map->projection));
-    else
-      msOWSPrintLatLonBoundingBox(stdout, "    ", &(map->extent),
-                                  &(map->projection), NULL, OWS_WMS);
-
-    msOWSPrintBoundingBox( stdout, "    ", &(map->extent), &(map->projection),
-                           NULL, &(map->web.metadata), "MO", nVersion);
-
-    if (nVersion >= OWS_1_0_7) {
-      msWMSPrintAttribution(stdout, "    ", &(map->web.metadata), "MO");
-    }
-
-    /* AuthorityURL support and Identifier support, only available >= WMS 1.1.0 */
-    if(nVersion >= OWS_1_1_0) {
-      msWMSPrintAuthorityURL(stdout, "    ", &(map->web.metadata), "MO");
-      msWMSPrintIdentifier(stdout, "    ", &(map->web.metadata), "MO");
-    }
-
-    /* MetadataURL */
-    if(nVersion >= OWS_1_1_0)
-      msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "metadataurl",
-                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"",
-                        NULL, NULL, ">\n      <Format>%s</Format",
-                        "\n      <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n    ",
-                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "    ");
-
-    /* DataURL */
-    if(nVersion < OWS_1_1_0)
-      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO", "dataurl_href",
-                               OWS_NOERR, "    <DataURL>%s</DataURL>\n",
-                               NULL);
-    else
-      msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "dataurl",
-                        OWS_NOERR, NULL, "DataURL", NULL, NULL, NULL,
-                        ">\n      <Format>%s</Format",
-                        "\n      <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n    ",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "    ");
-
-    if (map->name && strlen(map->name) > 0 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      char *pszEncodedName = NULL;
-      const char *styleName = NULL;
-      char *pszEncodedStyleName = NULL;
-      const char *legendURL = NULL;
-
-      pszEncodedName = msEncodeHTMLEntities(map->name);
-
-      styleName = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
-      if (styleName == NULL)
-        styleName = "default";
-
-      pszEncodedStyleName = msEncodeHTMLEntities(styleName);
-
-      msIO_fprintf(stdout, "    <Style>\n");
-      msIO_fprintf(stdout, "       <Name>%s</Name>\n", pszEncodedStyleName);
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO",
-                                "style_title",
-                                OWS_NOERR,
-                                "       <Title>%s</Title>\n",
-                                styleName, validated_language.c_str());
-
-      legendURL = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_legendurl_href");
-      if (legendURL) {
-        msOWSPrintURLType(stdout, &(map->web.metadata),
-                          "MO", "style_legendurl",
-                          OWS_NOERR, NULL,
-                          "LegendURL", NULL,
-                          " width=\"%s\"", " height=\"%s\"",
-                          ">\n          <Format>%s</Format",
-                          "\n          <OnlineResource "
-                          "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                          " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                          "       ",
-                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                          NULL, NULL, NULL, NULL, NULL, "       ");
-      } else {
-        std::vector<int> group_layers;
-        group_layers.reserve(map->numlayers);
-
-        for(int i=0; i<map->numlayers; i++)
-          if (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-            group_layers.push_back(i);
-
-        if (!group_layers.empty()) {
-          int size_x=0, size_y=0;
-          if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(), static_cast<int>(group_layers.size()), NULL, 1) == MS_SUCCESS) {
-            const std::string width(std::to_string(size_x));
-            const std::string height(std::to_string(size_y));
-
-            const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M", "getlegendgraphic_formatlist");
-            char *pszMimetype = NULL;
-            if (format_list && strlen(format_list) > 0) {
-              const auto tokens = msStringSplit(format_list, ',');
-              if (!tokens.empty()) {
-                /*just grab the first mime type*/
-                pszMimetype = msEncodeHTMLEntities(tokens[0].c_str());
-              }
-            } else
-              pszMimetype = msEncodeHTMLEntities("image/png");
-
-            std::string legendurl(script_url_encoded);
-            legendurl += "version=";
-            char szVersionBuf[OWS_VERSION_MAXLEN];
-            legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
-            legendurl += "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
-            if (nVersion >= OWS_1_3_0) {
-                legendurl += "sld_version=1.1.0&amp;layer=";
-            }
-            else {
-                legendurl += "layer=";
-            }
-            legendurl += pszEncodedName;
-            legendurl += "&amp;format=";
-            legendurl += pszMimetype;
-            legendurl += "&amp;STYLE=";
-            legendurl += pszEncodedStyleName;
-
-            msOWSPrintURLType(stdout, NULL,
-                              "O", "ttt",
-                              OWS_NOERR, NULL,
-                              "LegendURL", NULL,
-                              " width=\"%s\"", " height=\"%s\"",
-                              ">\n          <Format>%s</Format",
-                              "\n          <OnlineResource "
-                              "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                              " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                              "       ",
-                              MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                              NULL, width.c_str(), height.c_str(), pszMimetype, legendurl.c_str(), "       ");
-            msFree(pszMimetype);
-          }
-        }
-      }
-      msIO_fprintf(stdout, "    </Style>\n");
-      msFree(pszEncodedName);
-      msFree(pszEncodedStyleName);
-
-    }
-
-    if (nVersion <  OWS_1_3_0)
-      msWMSPrintScaleHint("    ", map->web.minscaledenom, map->web.maxscaledenom,
-                          map->resolution);
-    else
-      msWMSPrintScaleDenominator("    ", map->web.minscaledenom, map->web.maxscaledenom);
-
-    /*  */
-    /* Dump list of layers organized by groups.  Layers with no group are listed */
-    /* individually, at the same level as the groups in the layer hierarchy */
-    /*  */
-    if (map->numlayers) {
-      char ***nestedGroups = NULL;
-      int *numNestedGroups = NULL;
-      int *isUsedInNestedGroup = NULL;
-
-      /* We'll use this array of booleans to track which layer/group have been */
-      /* processed already */
-      std::vector<char> pabLayerProcessed(map->numlayers);
-
-      /* Mark disabled layers as processed to prevent from being displayed in nested groups (#4533)*/
-      for(int i=0; i<map->numlayers; i++) {
-        if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-          pabLayerProcessed[i] = 1;
-      }
-
-      nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-      numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-      for(int i=0; i<map->numlayers; i++) {
-        layerObj *lp = (GET_LAYER(map, i));
-
-        if (pabLayerProcessed[i] || (lp->status == MS_DELETE))
-          continue;  /* Layer is hidden or has already been handled */
-
-        if (numNestedGroups[i] > 0) {
-          /* Has nested groups.  */
-          msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed.data(), i, 0,
-                                 nestedGroups, numNestedGroups, isUsedInNestedGroup,
-                                 script_url_encoded, validated_language.c_str());
-        } else if (lp->group == NULL || strlen(lp->group) == 0) {
-          /* Don't dump layer if it is used in wms_group_layer. */
-          if (!isUsedInNestedGroup[i]) {
-            /* This layer is not part of a group... dump it directly */
-            msDumpLayer(map, lp, nVersion, script_url_encoded, "", validated_language.c_str(), MS_FALSE, MS_FALSE);
-            pabLayerProcessed[i] = 1;
-          }
-        } else {
-          bool group_is_queryable = false;
-          /* Group is queryable as soon as its member layers is. */
-          for(int j=i; j<map->numlayers; j++) {
-            if (GET_LAYER(map, j)->group &&
-                strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
-                msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers) &&
-                msIsLayerQueryable(GET_LAYER(map, j)) ) {
-                group_is_queryable = true;
-                break;
-            }
-          }
-          /* Beginning of a new group... enclose the group in a layer block */
-          msIO_printf("    <Layer%s>\n",
-                      group_is_queryable ? " queryable=\"1\"" : "");
-
-          /* Layer Name is optional but title is mandatory. */
-          if (lp->group &&  strlen(lp->group) > 0 &&
-              (msIsXMLTagValid(lp->group) == MS_FALSE || isdigit(lp->group[0])))
-            msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                         "invalid characters or may start with a number. This could lead to potential problems. -->\n",
-                         lp->group);
-          msOWSPrintEncodeParam(stdout, "GROUP.NAME", lp->group,
-                                OWS_NOERR, "      <Name>%s</Name>\n", NULL);
-          msOWSPrintGroupMetadata2(stdout, map, lp->group,
-                                   "MO", "GROUP_TITLE", OWS_WARN,
-                                   "      <Title>%s</Title>\n", lp->group, validated_language.c_str());
-          msOWSPrintGroupMetadata2(stdout, map, lp->group,
-                                   "MO", "GROUP_ABSTRACT", OWS_NOERR,
-                                   "      <Abstract>%s</Abstract>\n", lp->group, validated_language.c_str());
-
-          /*build a getlegendgraphicurl*/
-          if( script_url_encoded) {
-            if (lp->group && strlen(lp->group) > 0) {
-              char *pszEncodedName = NULL;
-              const char *styleName = NULL;
-              char *pszEncodedStyleName = NULL;
-              const char *legendURL = NULL;
-
-              pszEncodedName = msEncodeHTMLEntities(lp->group);
-
-              styleName = msOWSLookupMetadata(&(lp->metadata), "MO", "group_style_name");
-              if (styleName == NULL)
-                styleName = "default";
-
-              pszEncodedStyleName = msEncodeHTMLEntities(styleName);
-
-              msIO_fprintf(stdout, "    <Style>\n");
-              msIO_fprintf(stdout, "       <Name>%s</Name>\n", pszEncodedStyleName);
-              msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO",
-                                       "group_style_title",
-                                       OWS_NOERR,
-                                       "       <Title>%s</Title>\n",
-                                       styleName);
-
-              legendURL = msOWSLookupMetadata(&(lp->metadata), "MO", "group_style_legendurl_href");
-              if (legendURL) {
-                msOWSPrintURLType(stdout, &(lp->metadata),
-                                  "MO", "group_style_legendurl",
-                                  OWS_NOERR, NULL,
-                                  "LegendURL", NULL,
-                                  " width=\"%s\"", " height=\"%s\"",
-                                  ">\n          <Format>%s</Format",
-                                  "\n          <OnlineResource "
-                                  "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                  " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                  "       ",
-                                  MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                                  NULL, NULL, NULL, NULL, NULL, "       ");
-              } else {
-                std::vector<int> group_layers;
-                group_layers.reserve(map->numlayers);
-
-                for(int j=i; j<map->numlayers; j++)
-                  if (!pabLayerProcessed[j] &&
-                      GET_LAYER(map, j)->group &&
-                      strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
-                      msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers))
-                    group_layers.push_back(j);
-
-                if (!group_layers.empty()) {
-                  int size_x=0, size_y=0;
-                  char *pszMimetype = NULL;
-
-                  if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(), static_cast<int>(group_layers.size()), NULL, 1) == MS_SUCCESS) {
-                    const std::string width(std::to_string(size_x));
-                    const std::string height(std::to_string(size_y));
-
-                    const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M", "getlegendgraphic_formatlist");
-                    if (format_list && strlen(format_list) > 0) {
-                      const auto tokens = msStringSplit(format_list,  ',');
-                      if (!tokens.empty()) {
-                        /*just grab the first mime type*/
-                        pszMimetype = msEncodeHTMLEntities(tokens[0].c_str());
-                      }
-                    } else
-                      pszMimetype = msEncodeHTMLEntities("image/png");
-
-                    std::string legendurl(script_url_encoded);
-                    legendurl += "version=";
-                    char szVersionBuf[OWS_VERSION_MAXLEN];
-                    legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
-                    legendurl += "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
-                    if (nVersion >= OWS_1_3_0) {
-                        legendurl += "sld_version=1.1.0&amp;layer=";
-                    }
-                    else {
-                        legendurl += "layer=";
-                    }
-                    legendurl += pszEncodedName;
-                    legendurl += "&amp;format=";
-                    legendurl += pszMimetype;
-                    legendurl += "&amp;STYLE=";
-                    legendurl += pszEncodedStyleName;
-
-                    msOWSPrintURLType(stdout, NULL,
-                                      "O", "ttt",
-                                      OWS_NOERR, NULL,
-                                      "LegendURL", NULL,
-                                      " width=\"%s\"", " height=\"%s\"",
-                                      ">\n          <Format>%s</Format",
-                                      "\n          <OnlineResource "
-                                      "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                      " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                      "       ",
-                                      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                                      NULL, width.c_str(), height.c_str(), pszMimetype, legendurl.c_str(), "       ");
-
-                    msFree(pszMimetype);
-                  }
-                }
-              }
-              msIO_fprintf(stdout, "    </Style>\n");
-              msFree(pszEncodedName);
-              msFree(pszEncodedStyleName);
-            }
-          }
-
-          /* Dump all layers for this group */
-          for(int j=i; j<map->numlayers; j++) {
-            if (!pabLayerProcessed[j] &&
-                GET_LAYER(map, j)->group &&
-                strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
-                msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers)) {
-              msDumpLayer(map, (GET_LAYER(map, j)), nVersion, script_url_encoded, "  ", validated_language.c_str(), MS_FALSE, MS_FALSE);
-              pabLayerProcessed[j] = 1;
-            }
-          }
-          /* Close group layer block */
-          msIO_printf("    </Layer>\n");
-        }
-      }
-
-      /* free the stuff used for nested layers */
-      for (int i = 0; i < map->numlayers; i++) {
-        if (numNestedGroups[i] > 0) {
-          msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
-        }
-      }
-      free(nestedGroups);
-      free(numNestedGroups);
-      free(isUsedInNestedGroup);
-    }
-
-    msIO_printf("  </Layer>\n");
-  }
-
-  msIO_printf("</Capability>\n");
-  if ( nVersion >= OWS_1_3_0)
-    msIO_printf("</WMS_Capabilities>\n");
-  else
-    msIO_printf("</WMT_MS_Capabilities>\n");
-
-  free(script_url_encoded);
-
-  return(MS_SUCCESS);
-}
-
-/*
- * This function look for params that can be used
- * by mapserv when generating template.
-*/
-int msTranslateWMS2Mapserv(const char **names, const char **values, int numentries, char ***translated_names, char ***translated_values, int *translated_numentries)
-{
-  int num_allocated = numentries;
-  *translated_names = (char**)msSmallMalloc(num_allocated * sizeof(char*));
-  *translated_values = (char**)msSmallMalloc(num_allocated * sizeof(char*));
-  *translated_numentries = 0;
-  for (int i=0; i<numentries; i++) {
-    (*translated_values)[*translated_numentries] = msStrdup(values[i]);
-    (*translated_names)[*translated_numentries] = msStrdup(names[i]);
-    (*translated_numentries)++;
-    if (strcasecmp("X", names[i]) == 0) {
-      num_allocated++;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
-      (*translated_values)[*translated_numentries] = msStrdup(values[i]);
-      (*translated_names)[*translated_numentries] = msStrdup("img.x");
-      (*translated_numentries)++;
-    } else if (strcasecmp("Y", names[i]) == 0) {
-      num_allocated++;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
-      (*translated_values)[*translated_numentries] = msStrdup(values[i]);
-      (*translated_names)[*translated_numentries] = msStrdup("img.y");
-      (*translated_numentries)++;
-    } else if (strcasecmp("LAYERS", names[i]) == 0) {
-      char **layers;
-      int tok;
-      int j;
-      layers = msStringSplit(values[i], ',', &tok);
-      num_allocated += tok;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
-      for (j=0; j<tok; j++) {
-        (*translated_values)[*translated_numentries] = layers[j];
-        (*translated_names)[*translated_numentries] = msStrdup("layer");
-        (*translated_numentries)++;
-        layers[j] = NULL;
-      }
-      free(layers);
-    } else if (strcasecmp("QUERY_LAYERS", names[i]) == 0) {
-      char **layers;
-      int tok;
-      int j;
-      layers = msStringSplit(values[i], ',', &tok);
-      num_allocated += tok;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
-      for (j=0; j<tok; j++) {
-        (*translated_values)[*translated_numentries] = layers[j];
-        (*translated_names)[*translated_numentries] = msStrdup("qlayer");
-        (*translated_numentries)++;
-        layers[j] = NULL;
-      }
-      free(layers);
-    } else if (strcasecmp("BBOX", names[i]) == 0) {
-      char *imgext;
-      num_allocated++;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
-
-      /* Note msReplaceSubstring() works on the string itself, so we need to make a copy */
-      imgext = msStrdup(values[i]);
-      imgext = msReplaceSubstring(imgext, ",", " ");
-      (*translated_values)[*translated_numentries] = imgext;
-      (*translated_names)[*translated_numentries] = msStrdup("imgext");
-      (*translated_numentries)++;
-    }
-  }
-
-
-  return MS_SUCCESS;
-}
-
-/*
-** msWMSGetMap()
-*/
-static
-int msWMSGetMap(mapObj *map, int nVersion, char **names, char **values, int numentries,
-                const char *wms_exception_format, owsRequestObj *ows_request)
-{
-  imageObj *img;
-  int sldrequested = MS_FALSE,  sldspatialfilter = MS_FALSE;
-  int drawquerymap = MS_FALSE;
-
-  /* __TODO__ msDrawMap() will try to adjust the extent of the map */
-  /* to match the width/height image ratio. */
-  /* The spec states that this should not happen so that we can deliver */
-  /* maps to devices with non-square pixels. */
-
-  /* If there was an SLD in the request, we need to treat it */
-  /* diffrently : some SLD may contain spatial filters requiring */
-  /* to do a query. While parsing the SLD and applying it to the */
-  /* layer, we added a temporary metadata on the layer */
-  /* (tmp_wms_sld_query) for layers with a spatial filter. */
-
-  for (int i=0; i<numentries; i++) {
-    if ((strcasecmp(names[i], "SLD") == 0 && values[i] && strlen(values[i]) > 0) ||
-        (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] && strlen(values[i]) > 0)) {
-      sldrequested = MS_TRUE;
-      break;
-    }
-  }
-  if (sldrequested) {
-    for (int i=0; i<map->numlayers; i++) {
-      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), "tmp_wms_sld_query")) {
-        sldspatialfilter = MS_TRUE;
-        break;
-      }
-    }
-  }
-  /* If FILTER is passed then we'll render layers as querymap */
-  for (int i=0; i<numentries; i++) {
-    if ((strcasecmp(names[i], "FILTER") == 0 && values[i] && strlen(values[i]) > 0)) {
-      drawquerymap = MS_TRUE;
-      map->querymap.status = MS_ON;
-      map->querymap.style = MS_SELECTED;
-      break;
-    }
-  }
-
-  /* turn off layer if WMS GetMap is not enabled */
-  for (int i=0; i<map->numlayers; i++)
-    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-      GET_LAYER(map, i)->status = MS_OFF;
-
-  if (sldrequested && sldspatialfilter) {
-    /* set the quermap style so that only selected features will be retruned */
-    map->querymap.status = MS_ON;
-    map->querymap.style = MS_SELECTED;
-
-    img = msPrepareImage(map, MS_TRUE);
-
-    /* compute layer scale factors now */
-    for(int i=0; i<map->numlayers; i++) {
-      if(GET_LAYER(map, i)->sizeunits != MS_PIXELS)
-        GET_LAYER(map, i)->scalefactor = (msInchesPerUnit(GET_LAYER(map, i)->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
-      else if(GET_LAYER(map, i)->symbolscaledenom > 0 && map->scaledenom > 0)
-        GET_LAYER(map, i)->scalefactor = GET_LAYER(map, i)->symbolscaledenom/map->scaledenom;
-      else
-        GET_LAYER(map, i)->scalefactor = 1;
-    }
-    for (int i=0; i<map->numlayers; i++) {
-      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), "tmp_wms_sld_query") &&
-          (GET_LAYER(map, i)->type == MS_LAYER_POINT ||
-           GET_LAYER(map, i)->type == MS_LAYER_LINE ||
-           GET_LAYER(map, i)->type == MS_LAYER_POLYGON ||
-           GET_LAYER(map, i)->type == MS_LAYER_TILEINDEX))
-
-      {
-        /* make sure that there is a resultcache. If not just ignore */
-        /* the layer */
-        if (GET_LAYER(map, i)->resultcache)
-          msDrawQueryLayer(map, GET_LAYER(map, i), img);
-      }
-
-      else
-        IGNORE_RET_VAL(msDrawLayer(map, GET_LAYER(map, i), img));
-    }
-
-  } else {
-
-    /* intercept requests for Mapbox vector tiles */
-    if(!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/vnd.mapbox-vector-tile") || !strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/x-protobuf")) {
-      int status=0;
-      if((status = msMVTWriteTile(map, MS_TRUE)) != MS_SUCCESS) return MS_FAILURE;
-      return MS_SUCCESS;
-    }
-
-    img = msDrawMap(map, drawquerymap);
-  }
-
-/* see if we have tiled = true and a buffer */
-  /* if so, clip the image */
-  for (int i=0; i<numentries; i++) {
-    if (strcasecmp(names[i], "TILED") == 0 && strcasecmp(values[i], "TRUE") == 0) {
-      hashTableObj *meta = &(map->web.metadata);
-      const char *value;
-
-      if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
-        const int map_edge_buffer = atoi(value);
-        if ( map_edge_buffer > 0 ) {
-          /* we have to clip the image */
-
-          // TODO: we could probably avoid the use of an intermediate image
-          // by playing with the rasterBufferObj's data->rgb.pixels and data->rgb.row_stride values.
-          rendererVTableObj* renderer = MS_MAP_RENDERER(map);
-          rasterBufferObj imgBuffer;
-          if( renderer->getRasterBufferHandle((imageObj*)img,&imgBuffer) != MS_SUCCESS )
-          {
-              msFreeImage(img);
-              return MS_FAILURE;
-          }
-
-          int width = map->width - map_edge_buffer - map_edge_buffer;
-          int height = map->height - map_edge_buffer - map_edge_buffer;
-          imageObj* tmp = msImageCreate( width, height, map->outputformat, NULL, NULL, map->resolution, map->defresolution, NULL);
-
-          if((MS_FAILURE == renderer->mergeRasterBuffer(tmp,&imgBuffer,1.0,map_edge_buffer, map_edge_buffer,0, 0, width, height ))) {
-            msFreeImage(tmp);
-            msFreeImage(img);
-            img = NULL;
-          } else {
-            msFreeImage(img);
-            img = tmp;
-          }
-        }
-      }
-      break;
-    }
-  }
-
-  if (img == NULL)
-    return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-  /* Set the HTTP Cache-control headers if they are defined
-     in the map object */
-
-  const char* http_max_age = msOWSLookupMetadata(&(map->web.metadata), "MO", "http_max_age");
-  if( http_max_age ) {
-    msIO_setHeader("Cache-Control","max-age=%s", http_max_age);
-  }
-
-  if (strcasecmp(map->imagetype, "application/openlayers")!=0) {
-    if(!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/json")) {
-      msIO_setHeader("Content-Type","application/json; charset=utf-8");
-    } else {
-      msOutputFormatResolveFromImage( map, img );
-      msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(map->outputformat));
-    }
-    msIO_sendHeaders();
-    if (msSaveImage(map, img, NULL) != MS_SUCCESS) {
-      msFreeImage(img);
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-  }
-  msFreeImage(img);
-
-  return(MS_SUCCESS);
-}
-
-static
-int msDumpResult(mapObj *map, int nVersion, const char *wms_exception_format)
-{
-  int numresults=0;
-
-  for(int i=0; i<map->numlayers; i++) {
-    layerObj *lp = (GET_LAYER(map, i));
-
-    if(lp->status != MS_ON || lp->resultcache==NULL || lp->resultcache->numresults == 0)
-      continue;
-
-    /* if(msLayerOpen(lp) != MS_SUCCESS || msLayerGetItems(lp) != MS_SUCCESS)
-     return msWMSException(map, nVersion, NULL); */
-
-    /* Use metadata to control which fields to output. We use the same
-     * metadata names as for GML:
-     * wms/ows_include_items: comma delimited list or keyword 'all'
-     * wms/ows_exclude_items: comma delimited list (all items are excluded by default)
-     */
-    /* get a list of items that should be excluded in output */
-    std::vector<std::string> incitems;
-    const char *value;
-    if((value = msOWSLookupMetadata(&(lp->metadata), "MO", "include_items")) != NULL)
-      incitems = msStringSplit(value, ',');
-
-    /* get a list of items that should be excluded in output */
-    std::vector<std::string> excitems;
-    if((value = msOWSLookupMetadata(&(lp->metadata), "MO", "exclude_items")) != NULL)
-      excitems = msStringSplit(value, ',');
-
-    std::vector<bool> itemvisible(lp->numitems);
-    for(int k=0; k<lp->numitems; k++) {
-      /* check visibility, included items first... */
-      if(incitems.size() == 1 && strcasecmp("all", incitems[0].c_str()) == 0) {
-        itemvisible[k] = true;
-      } else {
-        for( const auto& incitem: incitems ) {
-          if(strcasecmp(lp->items[k], incitem.c_str()) == 0)
-            itemvisible[k] = true;
-        }
-      }
-
-      /* ...and now excluded items */
-      for( const auto& excitem: excitems ) {
-        if(strcasecmp(lp->items[k], excitem.c_str()) == 0)
-          itemvisible[k] = false;
-      }
-    }
-
-    /* Output selected shapes for this layer */
-    msIO_printf("\nLayer '%s'\n", lp->name);
-
-    for(int j=0; j<lp->resultcache->numresults; j++) {
-      shapeObj shape;
-
-      msInitShape(&shape);
-      if (msLayerGetShape(lp, &shape, &(lp->resultcache->results[j])) != MS_SUCCESS) {
-        return msWMSException(map, nVersion, NULL, wms_exception_format);
-      }
-
-      msIO_printf("  Feature %ld: \n", lp->resultcache->results[j].shapeindex);
-
-      for(int k=0; k<lp->numitems; k++) {
-        if (itemvisible[k]) {
-          value = msOWSLookupMetadata(&(lp->metadata), "MO", (std::string(lp->items[k]) + "_alias").c_str());
-          const char *lineTemplate="    %s = '%s'\n";
-          msIO_printf(lineTemplate, value != NULL ? value : lp->items[k], shape.values[k]);
-        }
-      }
- 
-      msFreeShape(&shape);
-      numresults++;
-    }
-
-    /* msLayerClose(lp); */
-  }
-
-  return numresults;
-}
-
-
-/*
-** msWMSFeatureInfo()
-*/
-static
-int msWMSFeatureInfo(mapObj *map, int nVersion, char **names, char **values, int numentries,
-                     const char *wms_exception_format, owsRequestObj *ows_request)
-{
-  int feature_count=1, numlayers_found=0;
-  pointObj point = {-1.0, -1.0, -1.0, -1.0};
-  const char *info_format="MIME";
-  errorObj *ms_error = msGetErrorObj();
-  int query_status=MS_NOERR;
-  int query_layer = 0;
-  const char *format_list=NULL;
-  int valid_format=MS_FALSE;
-  int format_found = MS_FALSE;
-  int use_bbox = MS_FALSE;
-  int wms_layer =  MS_FALSE;
-  const char *wms_connection = NULL;
-  int numOWSLayers = 0;
-
-  char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-  int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-  for(int i=0; i<numentries; i++) {
-    if(strcasecmp(names[i], "QUERY_LAYERS") == 0) {
-      query_layer = 1; /* flag set if QUERY_LAYERS is the request */
-
-      const auto wmslayers = msStringSplit(values[i], ',');
-      if(wmslayers.empty()) {
-        msSetError(MS_WMSERR, "At least one layer name required in QUERY_LAYERS.", "msWMSFeatureInfo()");
-        return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
-      }
-
-      for(int j=0; j<map->numlayers; j++) {
-        /* Force all layers OFF by default */
-        GET_LAYER(map, j)->status = MS_OFF;
-      }
-
-      /* Special case for root layer */
-      const char* rootlayer_name = msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
-      if( !rootlayer_name )
-          rootlayer_name = map->name;
-      if( rootlayer_name && msStringInArray(rootlayer_name, wmslayers) ) {
-        for(int j=0; j<map->numlayers; j++) {
-          layerObj* layer = GET_LAYER(map, j);
-          if( msIsLayerQueryable(layer) &&
-              msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers) ) {
-            if (layer->connectiontype == MS_WMS) {
-              wms_layer = MS_TRUE;
-              wms_connection = layer->connection;
-            }
-
-            numlayers_found++;
-            layer->status = MS_ON;
-          }
-        }
-      }
-
-      for(int j=0; j<map->numlayers; j++) {
-        layerObj* layer = GET_LAYER(map, j);
-        if( !msIsLayerQueryable(layer) )
-            continue;
-        for(const auto& wmslayer: wmslayers) {
-          if (((layer->name && strcasecmp(layer->name, wmslayer.c_str()) == 0) ||
-               (layer->group && strcasecmp(layer->group, wmslayer.c_str()) == 0) ||
-               ((numNestedGroups[j] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[j], numNestedGroups[j]))) &&
-              (msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-
-            if (layer->connectiontype == MS_WMS) {
-              wms_layer = MS_TRUE;
-              wms_connection = layer->connection;
-            }
-
-            numlayers_found++;
-            layer->status = MS_ON;
-          }
-        }
-      }
-    } else if (strcasecmp(names[i], "INFO_FORMAT") == 0) {
-      if (values[i] && strlen(values[i]) > 0) {
-        info_format = values[i];
-        format_found = MS_TRUE;
-      }
-    } else if (strcasecmp(names[i], "FEATURE_COUNT") == 0)
-      feature_count = atoi(values[i]);
-    else if(strcasecmp(names[i], "X") == 0 || strcasecmp(names[i], "I") == 0)
-      point.x = atof(values[i]);
-    else if (strcasecmp(names[i], "Y") == 0 || strcasecmp(names[i], "J") == 0)
-      point.y = atof(values[i]);
-    else if (strcasecmp(names[i], "RADIUS") == 0) {
-      /* RADIUS in pixels. */
-      /* This is not part of the spec, but some servers such as cubeserv */
-      /* support it as a vendor-specific feature. */
-      /* It's easy for MapServer to handle this so let's do it! */
-
-      /* Special RADIUS value that changes the query into a bbox query */
-      /* based on the bbox in the request parameters. */
-      if( strcasecmp(values[i], "BBOX") == 0) {
-        use_bbox = MS_TRUE;
-      } else {
-        int j;
-        for(j=0; j<map->numlayers; j++) {
-          GET_LAYER(map, j)->tolerance = atoi(values[i]);
-          GET_LAYER(map, j)->toleranceunits = MS_PIXELS;
-        }
-      }
-    }
-
-  }
-
-  /* free the stuff used for nested layers */
-  for (int i = 0; i < map->numlayers; i++) {
-    if (numNestedGroups[i] > 0) {
-      msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
-    }
-  }
-  free(nestedGroups);
-  free(numNestedGroups);
-  free(isUsedInNestedGroup);
-
-  if(numlayers_found == 0) {
-    if (query_layer) {
-      msSetError(MS_WMSERR, "Layer(s) specified in QUERY_LAYERS parameter is not offered by the service instance.", "msWMSFeatureInfo()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
-    } else {
-      msSetError(MS_WMSERR, "Required QUERY_LAYERS parameter missing for getFeatureInfo.", "msWMSFeatureInfo()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
-    }
-  }
-
-  /*make sure to initialize the map scale so that layers that are scale dependent are resepected for
-    the query*/
-  msCalculateScale(map->extent,map->units,map->width,map->height, map->resolution, &map->scaledenom);
-
-  /* -------------------------------------------------------------------- */
-  /*      check if all layers selected are queryable. If not send an      */
-  /*      exception.                                                      */
-  /* -------------------------------------------------------------------- */
-
-  /* If a layer of type WMS was found... all layers have to be of that type and with the same connection */
-  for (int i=0; i<map->numlayers; i++) {
-    if (GET_LAYER(map, i)->status == MS_ON) {
-      if (wms_layer == MS_TRUE) {
-        if ( (GET_LAYER(map, i)->connectiontype != MS_WMS) || (strcasecmp(wms_connection, GET_LAYER(map, i)->connection) != 0) ) {
-          msSetError(MS_WMSERR, "Requested WMS layer(s) are not queryable: type or connection differ", "msWMSFeatureInfo()");
-          return msWMSException(map, nVersion, "LayerNotQueryable", wms_exception_format);
-        }
-        ++numOWSLayers;
-      }
-    }
-  }
-
-  /* It's a valid Cascading WMS GetFeatureInfo request */
-  if (wms_layer)
-    return msWMSLayerExecuteRequest(map, numOWSLayers, point.x, point.y,
-                                    feature_count, info_format, WMS_GETFEATUREINFO);
-
-  if( use_bbox == MS_FALSE ) {
-
-    if(point.x == -1.0 || point.y == -1.0) {
-      if (nVersion >= OWS_1_3_0)
-        msSetError(MS_WMSERR, "Required I/J parameters missing for getFeatureInfo.", "msWMSFeatureInfo()");
-      else
-        msSetError(MS_WMSERR, "Required X/Y parameters missing for getFeatureInfo.", "msWMSFeatureInfo()");
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-
-    /*wms1.3.0: check if the points are valid*/
-    if (nVersion >= OWS_1_3_0) {
-      if (point.x > map->width || point.y > map->height) {
-        msSetError(MS_WMSERR, "Invalid I/J values", "msWMSFeatureInfo()");
-        return msWMSException(map, nVersion, "InvalidPoint", wms_exception_format);
-      }
-    }
-    /* Perform the actual query */
-    const double cellx = MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width); /* note: don't adjust extent, WMS assumes incoming extent is correct */
-    const double celly = MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height);
-    point.x = MS_IMAGE2MAP_X(point.x, map->extent.minx, cellx);
-    point.y = MS_IMAGE2MAP_Y(point.y, map->extent.maxy, celly);
-
-    /* WMS 1.3.0 states that feature_count is *per layer*.
-     * Its value is a positive integer, if omitted then the default is 1
-     */
-    if (feature_count < 1)
-      feature_count = 1;
-
-    map->query.type = MS_QUERY_BY_POINT;
-    map->query.mode = (feature_count==1?MS_QUERY_SINGLE:MS_QUERY_MULTIPLE);
-    map->query.layer = -1;
-    map->query.point = point;
-    map->query.buffer = 0;
-    map->query.maxresults = feature_count;
-
-    if(msQueryByPoint(map) != MS_SUCCESS)
-      if((query_status=ms_error->code) != MS_NOTFOUND) return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-  } else { /* use_bbox == MS_TRUE */
-    map->query.type = MS_QUERY_BY_RECT;
-    map->query.mode = MS_QUERY_MULTIPLE;
-    map->query.layer = -1;
-    map->query.rect = map->extent;
-    map->query.buffer = 0;
-    map->query.maxresults = feature_count;
-    if(msQueryByRect(map) != MS_SUCCESS)
-      if((query_status=ms_error->code) != MS_NOTFOUND) return msWMSException(map, nVersion, NULL, wms_exception_format);
-  }
-
-  /*validate the INFO_FORMAT*/
-  valid_format = MS_FALSE;
-  format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
-                                    "getfeatureinfo_formatlist");
-  /*feature_info_mime_type depricated for MapServer 6.0*/
-  if (!format_list)
-    format_list = msOWSLookupMetadata(&(map->web.metadata), "MO",
-                                      "feature_info_mime_type");
-  if (format_list) {
-    /*can not really validate if it is a valid output format
-      since old way of using template with web->header/footer and
-      layer templates need to still be supported.
-      We can only validate if it was part of the format list*/
-    if (strcasestr(format_list, info_format))
-      valid_format = MS_TRUE;
-  }
-  /*check to see if the format passed is text/plain or GML and if is
-    defined in the formatlist. If that is the case, It is a valid format*/
-  if (strcasecmp(info_format, "MIME") == 0 ||
-      strcasecmp(info_format, "text/plain") == 0 ||
-      strncasecmp(info_format, "GML", 3) == 0 ||
-      strcasecmp(info_format, "application/vnd.ogc.gml") == 0)
-    valid_format = MS_TRUE;
-
-
-  /*last case: if the info_format is not part of the request, it defaults to MIME*/
-  if (!valid_format && format_found == MS_FALSE)
-    valid_format =MS_TRUE;
-
-  if (!valid_format) {
-    msSetError(MS_WMSERR, "Unsupported INFO_FORMAT value (%s).",
-               "msWMSFeatureInfo()", info_format);
-    if (nVersion >= OWS_1_3_0)
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
-    else
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-  }
-
-  /* Generate response */
-  if (strcasecmp(info_format, "MIME") == 0 ||
-      strcasecmp(info_format, "text/plain") == 0) {
-
-    /* MIME response... we're free to use any valid MIME type */
-    int numresults = 0;
-
-    msIO_setHeader("Content-Type","text/plain; charset=UTF-8");
-    msIO_sendHeaders();
-    msIO_printf("GetFeatureInfo results:\n");
-
-    numresults = msDumpResult(map, nVersion, wms_exception_format);
-
-    if (numresults == 0) msIO_printf("\n  Search returned no results.\n");
-
-  } else if (strncasecmp(info_format, "GML", 3) == 0 ||  /* accept GML.1 or GML */
-             strcasecmp(info_format, "application/vnd.ogc.gml") == 0) {
-
-    if (nVersion <= OWS_1_0_7)   /* 1.0.0 to 1.0.7 */
-      msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-    else /* 1.1.0 and later */
-      msIO_setHeader("Content-Type","application/vnd.ogc.gml; charset=UTF-8");
-    msIO_sendHeaders();
-    msGMLWriteQuery(map, NULL, "MGO"); /* default is stdout */
-
-  } else {
-    mapservObj *msObj;
-
-    char **translated_names, **translated_values;
-    int translated_numentries;
-    msObj = msAllocMapServObj();
-
-    /* Translate some vars from WMS to mapserv */
-    msTranslateWMS2Mapserv((const char**)names, (const char**)values, numentries, &translated_names, &translated_values, &translated_numentries);
-
-    msObj->map = map;
-    msFreeCharArray(msObj->request->ParamNames, msObj->request->NumParams);
-    msFreeCharArray(msObj->request->ParamValues, msObj->request->NumParams);
-    msObj->request->ParamNames = translated_names;
-    msObj->request->ParamValues = translated_values;
-    msObj->Mode = QUERY;
-    msObj->request->NumParams = translated_numentries;
-    msObj->mappnt.x = point.x;
-    msObj->mappnt.y = point.y;
-
-    if (query_status == MS_NOTFOUND && msObj->map->web.empty) {
-      if(msReturnURL(msObj, msObj->map->web.empty, BROWSE) != MS_SUCCESS)
-        return msWMSException(map, nVersion, NULL, wms_exception_format);
-    } else if (msReturnTemplateQuery(msObj, (char *)info_format, NULL) != MS_SUCCESS)
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-    /* We don't want to free the map since it */
-    /* belongs to the caller, set it to NULL before freeing the mapservObj */
-    msObj->map = NULL;
-
-    msFreeMapServObj(msObj);
-  }
-
-  return(MS_SUCCESS);
-}
-
-/*
-** msWMSDescribeLayer()
-*/
-static
-int msWMSDescribeLayer(mapObj *map, int nVersion, char **names,
-                       char **values, int numentries, const char *wms_exception_format)
-{
-  std::vector<std::string> wmslayers;
-  const char *version = NULL;
-  const char *sld_version = NULL;
-
-  for(int i=0; i<numentries; i++) {
-    if(strcasecmp(names[i], "LAYERS") == 0) {
-      wmslayers = msStringSplit(values[i], ',');
-    }
-    if(strcasecmp(names[i], "VERSION") == 0) {
-      version = values[i];
-    }
-    if(strcasecmp(names[i], "SLD_VERSION") == 0) {
-      sld_version = values[i];
-    }
-  }
-
-  if (nVersion >= OWS_1_3_0 && sld_version == NULL) {
-    msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION", "DescribeLayer()");
-    return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-  }
-  if (nVersion >= OWS_1_3_0 && strcasecmp(sld_version, "1.1.0") != 0) {
-    msSetError(MS_WMSERR, "SLD_VERSION must be 1.1.0", "DescribeLayer()");
-    return msWMSException(map, nVersion, "InvalidParameterValue", wms_exception_format);
-  }
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\"?>\n");
-
-  {
-   char* schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-   if (nVersion < OWS_1_3_0) {
-
-    msIO_printf("<!DOCTYPE WMS_DescribeLayerResponse SYSTEM \"%s/wms/1.1.1/WMS_DescribeLayerResponse.dtd\">\n", schemalocation);
-
-
-    msIO_printf("<WMS_DescribeLayerResponse version=\"%s\" >\n", version);
-   } else {
-    msIO_printf("<DescribeLayerResponse xmlns=\"http://www.opengis.net/sld\" xmlns:ows=\"http://www.opengis.net/ows\" xmlns:se=\"http://www.opengis.net/se\" xmlns:wfs=\"http://www.opengis.net/wfs\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xsi:schemaLocation=\"http://www.opengis.net/sld %s/sld/1.1.0/DescribeLayer.xsd\">\n", schemalocation);
-    msIO_printf("<Version>%s</Version>\n",sld_version);
-   }
-   free(schemalocation);
-  }
-
-  /* check if map-level metadata wfs(wcs)_onlineresource is available */
-  const char* pszOnlineResMapWFS = msOWSLookupMetadata(&(map->web.metadata), "FO", "onlineresource");
-  if (pszOnlineResMapWFS && strlen(pszOnlineResMapWFS) == 0)
-    pszOnlineResMapWFS = NULL;
-
-  const char* pszOnlineResMapWCS = msOWSLookupMetadata(&(map->web.metadata), "CO", "onlineresource");
-  if (pszOnlineResMapWCS && strlen(pszOnlineResMapWCS) == 0)
-    pszOnlineResMapWCS = NULL;
-
-  char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-  int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  int * isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-  for(const auto& wmslayer: wmslayers) {
-    for(int k=0; k<map->numlayers; k++) {
-      layerObj* lp = GET_LAYER(map, k);
-
-      if ((map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
-          (lp->name && strcasecmp(lp->name, wmslayer.c_str()) == 0) ||
-          (lp->group && strcasecmp(lp->group, wmslayer.c_str()) == 0) ||
-          ((numNestedGroups[k] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[k], numNestedGroups[k]))) {
-        /* Look for a WFS onlineresouce at the layer level and then at
-         * the map level.
-         */
-        const char* pszOnlineResLyrWFS = msOWSLookupMetadata(&(lp->metadata), "FO",
-                             "onlineresource");
-        const char* pszOnlineResLyrWCS = msOWSLookupMetadata(&(lp->metadata), "CO",
-                             "onlineresource");
-        if (pszOnlineResLyrWFS == NULL || strlen(pszOnlineResLyrWFS) == 0)
-          pszOnlineResLyrWFS = pszOnlineResMapWFS;
-
-        if (pszOnlineResLyrWCS == NULL || strlen(pszOnlineResLyrWCS) == 0)
-          pszOnlineResLyrWCS = pszOnlineResMapWCS;
-
-        if (pszOnlineResLyrWFS && (lp->type == MS_LAYER_POINT ||
-                                   lp->type == MS_LAYER_LINE ||
-                                   lp->type == MS_LAYER_POLYGON) ) {
-          char* pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWFS);
-          char* pszLayerName = msEncodeHTMLEntities(lp->name);
-
-          if (nVersion < OWS_1_3_0) {
-            msIO_printf("<LayerDescription name=\"%s\" wfs=\"%s\" owsType=\"WFS\" owsURL=\"%s\">\n",
-                        pszLayerName, pszOnlineResEncoded, pszOnlineResEncoded);
-            msIO_printf("<Query typeName=\"%s\" />\n", pszLayerName);
-            msIO_printf("</LayerDescription>\n");
-          } else { /*wms 1.3.0*/
-            msIO_printf("  <LayerDescription>\n");
-            msIO_printf("    <owsType>wfs</owsType>\n");
-            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                        pszOnlineResEncoded);
-            msIO_printf("    <TypeName>\n");
-            msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",pszLayerName);
-            msIO_printf("    </TypeName>\n");
-            msIO_printf("  </LayerDescription>\n");
-          }
-
-          msFree(pszOnlineResEncoded);
-          msFree(pszLayerName);
-        } else if (pszOnlineResLyrWCS && lp->type == MS_LAYER_RASTER &&
-                   lp->connectiontype != MS_WMS) {
-          char* pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWCS);
-          char* pszLayerName = msEncodeHTMLEntities(lp->name);
-
-          if (nVersion < OWS_1_3_0) {
-            msIO_printf("<LayerDescription name=\"%s\"  owsType=\"WCS\" owsURL=\"%s\">\n",
-                        pszLayerName, pszOnlineResEncoded);
-            msIO_printf("<Query typeName=\"%s\" />\n", pszLayerName);
-            msIO_printf("</LayerDescription>\n");
-          } else {
-            msIO_printf("  <LayerDescription>\n");
-            msIO_printf("    <owsType>wcs</owsType>\n");
-            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                        pszOnlineResEncoded);
-            msIO_printf("    <TypeName>\n");
-            msIO_printf("      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",pszLayerName);
-            msIO_printf("    </TypeName>\n");
-            msIO_printf("  </LayerDescription>\n");
-          }
-          msFree(pszOnlineResEncoded);
-          msFree(pszLayerName);
-        } else {
-          char *pszLayerName = msEncodeHTMLEntities(lp->name);
-
-          if (nVersion < OWS_1_3_0)
-            msIO_printf("<LayerDescription name=\"%s\"></LayerDescription>\n",
-                        pszLayerName);
-          else { /*wms 1.3.0*/
-            msIO_printf("  <LayerDescription>\n");
-            /*need to have a owstype for the DescribeLayer to be valid*/
-            if (lp->type == MS_LAYER_RASTER && lp->connectiontype != MS_WMS)
-              msIO_printf("    <owsType>wcs</owsType>\n");
-            else
-              msIO_printf("    <owsType>wfs</owsType>\n");
-
-            msIO_printf("    <se:OnlineResource xlink:type=\"simple\"/>\n");
-            msIO_printf("    <TypeName>\n");
-            if (lp->type == MS_LAYER_RASTER && lp->connectiontype != MS_WMS)
-              msIO_printf("      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",pszLayerName);
-            else
-              msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",pszLayerName);
-            msIO_printf("    </TypeName>\n");
-            msIO_printf("  </LayerDescription>\n");
-          }
-
-          msFree(pszLayerName);
-        }
-        /* break; */
-      }
-    }
-  }
-
-  if (nVersion < OWS_1_3_0)
-    msIO_printf("</WMS_DescribeLayerResponse>\n");
-  else
-    msIO_printf("</DescribeLayerResponse>\n");
-
-  /* free the stuff used for nested layers */
-  for (int i = 0; i < map->numlayers; i++) {
-    if (numNestedGroups[i] > 0) {
-      msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
-    }
-  }
-  free(nestedGroups);
-  free(numNestedGroups);
-  free(isUsedInNestedGroup);
-
-  return(MS_SUCCESS);
-}
-
-
-/*
-** msWMSGetLegendGraphic()
-*/
-static
-int msWMSLegendGraphic(mapObj *map, int nVersion, char **names,
-                       char **values, int numentries, const char *wms_exception_format, owsRequestObj *ows_request,
-                       map_hittest *hittest)
-{
-  const char *pszLayer = NULL;
-  const char *pszFormat = NULL;
-  const char *psRule = NULL;
-  const char *psScale = NULL;
-  int iLayerIndex = -1;
-  outputFormatObj *psFormat = NULL;
-  imageObj *img=NULL;
-  int nWidth = -1, nHeight =-1;
-  const char *pszStyle = NULL;
-  const char *sld_version = NULL;
-  int wms_layer =  MS_FALSE;
-  const char *sldenabled = NULL;
-  const char *format_list = NULL;
-  int nLayers =0;
-
-  if(!hittest) {
-    /* we can skip alot of testing if we already have a hittest, as it has already been done in the hittesting phase */
-
-
-    sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
-
-    if (sldenabled == NULL)
-      sldenabled = "true";
-
-    for(int i=0; i<numentries; i++) {
-      if (strcasecmp(names[i], "LAYER") == 0) {
-        pszLayer = values[i];
-      } else if (strcasecmp(names[i], "WIDTH") == 0)
-        nWidth = atoi(values[i]);
-      else if (strcasecmp(names[i], "HEIGHT") == 0)
-        nHeight = atoi(values[i]);
-      else if (strcasecmp(names[i], "FORMAT") == 0)
-        pszFormat = values[i];
-      else if (strcasecmp(names[i], "SCALE") == 0)
-        psScale = values[i];
-
-      /* -------------------------------------------------------------------- */
-      /*      SLD support :                                                   */
-      /*        - check if the SLD parameter is there. it is supposed to      */
-      /*      refer a valid URL containing an SLD document.                   */
-      /*        - check the SLD_BODY parameter that should contain the SLD    */
-      /*      xml string.                                                     */
-      /* -------------------------------------------------------------------- */
-      else if (strcasecmp(names[i], "SLD") == 0 &&
-          values[i] && strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
-        msSLDApplySLDURL(map, values[i], -1, NULL, NULL);
-      else if (strcasecmp(names[i], "SLD_BODY") == 0 &&
-          values[i] && strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
-        msSLDApplySLD(map, values[i], -1, NULL, NULL);
-      else if (strcasecmp(names[i], "RULE") == 0)
-        psRule = values[i];
-      else if (strcasecmp(names[i], "STYLE") == 0)
-        pszStyle = values[i];
-
-      /* -------------------------------------------------------------------- */
-      /*      SLD support:                                                    */
-      /*        - because the request parameter "sld_version" is required in  */
-      /*          in WMS 1.3.0, it will be set regardless of OGR support.     */
-      /* -------------------------------------------------------------------- */
-      else if(strcasecmp(names[i], "SLD_VERSION") == 0)
-        sld_version = values[i];
-    }
-
-    if (!pszLayer) {
-      msSetError(MS_WMSERR, "Mandatory LAYER parameter missing in GetLegendGraphic request.", "msWMSGetLegendGraphic()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
-    }
-    if (!pszFormat) {
-      msSetError(MS_WMSERR, "Mandatory FORMAT parameter missing in GetLegendGraphic request.", "msWMSGetLegendGraphic()");
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
-    }
-
-    if (nVersion >= OWS_1_3_0 && sld_version == NULL) {
-      msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION", "GetLegendGraphic()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
-    }
-    if (nVersion >= OWS_1_3_0 && strcasecmp(sld_version, "1.1.0") != 0) {
-      msSetError(MS_WMSERR, "SLD_VERSION must be 1.1.0", "GetLegendGraphic()");
-      return msWMSException(map, nVersion, "InvalidParameterValue", wms_exception_format);
-    }
-
-    char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-    int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-    int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-    msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-    /* check if layer name is valid. we check for layer's and group's name */
-    /* as well as wms_layer_group names */
-    for (int i=0; i<map->numlayers; i++) {
-      layerObj* lp = GET_LAYER(map, i);
-      if (  ((map->name && strcasecmp(map->name, pszLayer) == 0) ||
-          (lp->name && strcasecmp(lp->name, pszLayer) == 0) ||
-          (lp->group && strcasecmp(lp->group, pszLayer) == 0) ||
-          ((numNestedGroups[i] >0) && (msStringInArray(pszLayer, nestedGroups[i], numNestedGroups[i]))) ) &&
-          (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-        nLayers++;
-        lp->status = MS_ON;
-        iLayerIndex = i;
-        if (GET_LAYER(map, i)->connectiontype == MS_WMS) {
-          /* we do not cascade a wms layer if it contains at least
-           * one class with the property name set */
-          wms_layer = MS_TRUE;
-          for (int j=0; j<lp->numclasses; j++) {
-            if (lp->_class[j]->name != NULL && strlen(lp->_class[j]->name)>0) {
-              wms_layer = MS_FALSE;
-              break;
-            }
-          }
-        }
-      } else
-        lp->status = MS_OFF;
-    }
-
-    /* free the stuff used for nested layers */
-    for (int i = 0; i < map->numlayers; i++) {
-      if (numNestedGroups[i] > 0) {
-        msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
-      }
-    }
-    free(nestedGroups);
-    free(numNestedGroups);
-    free(isUsedInNestedGroup);
-
-    if (nLayers == 0) {
-      msSetError(MS_WMSERR, "Invalid layer given in the LAYER parameter. A layer might be disabled for \
-this request. Check wms/ows_enable_request settings.",
-"msWMSGetLegendGraphic()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
-    }
-
-
-    /* if SCALE was provided in request, calculate an extent and use a default width and height */
-    if ( psScale != NULL ) {
-      double scale, cellsize;
-
-      scale = atof(psScale);
-      map->width = 600;
-      map->height = 600;
-
-      cellsize = (scale/map->resolution)/msInchesPerUnit(map->units, 0.0);
-
-      map->extent.maxx = cellsize*map->width/2.0;
-      map->extent.maxy = cellsize*map->height/2.0;
-      map->extent.minx = -map->extent.maxx;
-      map->extent.miny = -map->extent.maxy;
-    }
-
-    /* It's a valid Cascading WMS GetLegendGraphic request */
-    if (wms_layer)
-      return msWMSLayerExecuteRequest(map, 1, 0, 0,
-          0, NULL, WMS_GETLEGENDGRAPHIC);
-
-    /*if STYLE is set, check if it is a valid style (valid = at least one
-    of the classes have a the group value equals to the style */
-    /*style is only validated when there is only one layer #3411*/
-    if (nLayers == 1 &&  pszStyle && strlen(pszStyle) > 0 && strcasecmp(pszStyle, "default") != 0) {
-      bool found = false;
-      for (int i=0; i<GET_LAYER(map, iLayerIndex)->numclasses; i++) {
-        if (GET_LAYER(map, iLayerIndex)->_class[i]->group &&
-            strcasecmp(GET_LAYER(map, iLayerIndex)->_class[i]->group, pszStyle) == 0) {
-          found = true;
-          break;
-        }
-      }
-
-      if (!found) {
-        msSetError(MS_WMSERR, "style used in the STYLE parameter is not defined on the layer.",
-            "msWMSGetLegendGraphic()");
-        return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
-      } else {
-        msFree(GET_LAYER(map, iLayerIndex)->classgroup);
-        GET_LAYER(map, iLayerIndex)->classgroup = msStrdup(pszStyle);
-
-      }
-    }
-  } else {
-    /* extract the parameters we need */
-    for(int i=0; i<numentries; i++) {
-      if (strcasecmp(names[i], "FORMAT") == 0)
-        pszFormat = values[i];
-      else if (strcasecmp(names[i], "RULE") == 0)
-        psRule = values[i];
-    }
-  }
-  /* validate format */
-
-  /*check to see if a predefined list is given*/
-  format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getlegendgraphic_formatlist");
-  if (format_list) {
-    psFormat = msOwsIsOutputFormatValid(map, pszFormat, &(map->web.metadata),
-        "M", "getlegendgraphic_formatlist");
-    if (psFormat == NULL) {
-      msSetError(MS_IMGERR,
-          "Unsupported output format (%s).",
-          "msWMSGetLegendGraphic()",
-          pszFormat);
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
-    }
-  } else {
-    psFormat = msSelectOutputFormat( map, pszFormat);
-    if( psFormat == NULL || ! MS_RENDERER_PLUGIN(psFormat) )
-      /* msDrawLegend and msCreateLegendIcon both switch the alpha channel to gd
-       ** after creation, so they can be called here without going through
-       ** the msAlphaGD2AGG functions */
-    {
-      msSetError(MS_IMGERR,
-          "Unsupported output format (%s).",
-          "msWMSGetLegendGraphic()",
-          pszFormat);
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
-    }
-  }
-  msApplyOutputFormat(&(map->outputformat), psFormat, MS_NOOVERRIDE);
-  
-  if ( psRule == NULL || nLayers > 1) {
-    if ( psScale != NULL ) {
-      /* Scale-dependent legend. map->scaledenom will be calculated in msDrawLegend */
-      img = msDrawLegend(map, MS_FALSE, NULL);
-    } else {
-      /* Scale-independent legend */
-      img = msDrawLegend(map, MS_TRUE, hittest);
-    }
-  } else {
-    /* RULE was specified. Get the class corresponding to the RULE */
-    /* (RULE = class->name) */
-    /* TBT FIXME? also check the map->scaledenom if multiple scale-dependant classes with same name */
-
-    layerObj* lp = GET_LAYER(map, iLayerIndex);
-    int i;
-    for (i=0; i<lp->numclasses; i++) {
-      if (lp->classgroup &&
-          (lp->_class[i]->group == NULL ||
-           strcasecmp(lp->_class[i]->group,
-                      lp->classgroup) != 0))
-        continue;
-
-      if (lp->_class[i]->name &&
-          strlen(lp->_class[i]->name) > 0 &&
-          strcasecmp(lp->_class[i]->name,psRule) == 0)
-        break;
-
-    }
-    if (i < lp->numclasses) {
-      /* set the map legend parameters */
-      if (nWidth < 0) {
-        if (map->legend.keysizex > 0)
-          nWidth = map->legend.keysizex;
-        else
-          nWidth = 20; /* default values : this in not defined in the specs */
-      }
-      if (nHeight < 0) {
-        if (map->legend.keysizey > 0)
-          nHeight = map->legend.keysizey;
-        else
-          nHeight = 20;
-      }
-
-      if ( psScale != NULL ) {
-        /* Scale-dependent legend. calculate map->scaledenom */
-        map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-        msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
-        img = msCreateLegendIcon(map, lp,
-                                 lp->_class[i],
-                                 nWidth, nHeight, MS_FALSE);
-      } else {
-        /* Scale-independent legend */
-        img = msCreateLegendIcon(map, lp,
-                                 lp->_class[i],
-                                 nWidth, nHeight, MS_TRUE);
-      }
-    }
-    if (img == NULL) {
-      msSetError(MS_IMGERR,
-                 "Unavailable RULE (%s).",
-                 "msWMSGetLegendGraphic()",
-                 psRule);
-      return msWMSException(map, nVersion, "InvalidRule", wms_exception_format);
-    }
-  }
-
-  if (img == NULL)
-    return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-  msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(map->outputformat));
-  msIO_sendHeaders();
-  if (msSaveImage(map, img, NULL) != MS_SUCCESS)
-    return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-  msFreeImage(img);
-
-  return(MS_SUCCESS);
-}
-
-/*
-** msWMSGetContentDependantLegend()
-*/
-static
-int msWMSGetContentDependantLegend(mapObj *map, int nVersion, char **names, char **values, int numentries,
-                const char *wms_exception_format, owsRequestObj *ows_request) {
-
-  /* turn off layer if WMS GetMap is not enabled */
-  for (int i=0; i<map->numlayers; i++)
-    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
-      GET_LAYER(map, i)->status = MS_OFF;
-
-  map_hittest hittest;
-  initMapHitTests(map,&hittest);
-  int status = msHitTestMap(map,&hittest);
-  if(status == MS_SUCCESS) {
-    status = msWMSLegendGraphic(map,nVersion,names,values,numentries,wms_exception_format,ows_request,&hittest);
-  }
-  freeMapHitTests(map,&hittest);
-  if(status != MS_SUCCESS) {
-    return msWMSException(map, nVersion, NULL, wms_exception_format);
-  } else {
-    return MS_SUCCESS;
-  }
-}
-
-/*
-** msWMSGetStyles() : return an SLD document for all layers that
-** have a status set to on or default.
-*/
-static
-int msWMSGetStyles(mapObj *map, int nVersion, char **names,
-                   char **values, int numentries, const char *wms_exception_format)
-
-{
-  bool validlayer = false;
-
-  char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-  int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-  const char* sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
-  if (sldenabled == NULL) sldenabled = "true";
-
-  for(int i=0; i<numentries; i++) {
-    /* getMap parameters */
-    if (strcasecmp(names[i], "LAYERS") == 0) {
-      const auto wmslayers = msStringSplit(values[i], ',');
-      if (wmslayers.empty()) {
-        msSetError(MS_WMSERR, "At least one layer name required in LAYERS.",
-                   "msWMSGetStyles()");
-        return msWMSException(map, nVersion, NULL, wms_exception_format);
-      }
-      for(int j=0; j<map->numlayers; j++)
-        GET_LAYER(map, j)->status = MS_OFF;
-
-      for (int k=0; k < static_cast<int>(wmslayers.size()); k++) {
-        const auto& wmslayer = wmslayers[k];
-        for (int j=0; j<map->numlayers; j++) {
-          if ((map->name &&
-               strcasecmp(map->name, wmslayer.c_str()) == 0) ||
-              (GET_LAYER(map, j)->name &&
-               strcasecmp(GET_LAYER(map, j)->name, wmslayer.c_str()) == 0) ||
-              (GET_LAYER(map, j)->group &&
-               strcasecmp(GET_LAYER(map, j)->group, wmslayer.c_str()) == 0) ||
-              ((numNestedGroups[j] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[j], numNestedGroups[j])) ) {
-            GET_LAYER(map, j)->status = MS_ON;
-            validlayer = true;
-          }
-        }
-      }
-    }
-
-    else if (strcasecmp(names[i], "SLD") == 0 &&
-        values[i] && strlen(values[i]) > 0 &&
-        strcasecmp(sldenabled, "true") == 0)
-    {
-        msSLDApplySLDURL(map, values[i], -1, NULL, NULL);
-    }
-
-    else if (strcasecmp(names[i], "SLD_BODY") == 0 &&
-        values[i] && strlen(values[i]) > 0 &&
-        strcasecmp(sldenabled, "true") == 0)
-    {
-      msSLDApplySLD(map, values[i], -1, NULL, NULL);
-    }
-  }
-
-  /* free the stuff used for nested layers */
-  for (int i = 0; i < map->numlayers; i++) {
-    if (numNestedGroups[i] > 0) {
-      msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
-    }
-  }
-  free(nestedGroups);
-  free(numNestedGroups);
-  free(isUsedInNestedGroup);
-
-  /* validate all layers given. If an invalid layer is sent, return an exception. */
-  if (!validlayer) {
-    msSetError(MS_WMSERR, "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
-this request. Check wms/ows_enable_request settings.",
-               "msWMSGetStyles()");
-    return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
-  }
-
-  char  *sld = NULL;
-  if (nVersion <= OWS_1_1_1) {
-    msIO_setHeader("Content-Type","application/vnd.ogc.sld+xml; charset=UTF-8");
-    msIO_sendHeaders();
-    sld = msSLDGenerateSLD(map, -1, "1.0.0");
-  } else {
-    /*for wms 1.3.0 generate a 1.1 sld*/
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-    msIO_sendHeaders();
-    sld = msSLDGenerateSLD(map, -1, "1.1.0");
-  }
-  if (sld) {
-    msIO_printf("%s\n", sld);
-    free(sld);
-  }
-
-  return(MS_SUCCESS);
-}
-
-int msWMSGetSchemaExtension(mapObj *map)
-{
-  char* schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-  msIO_sendHeaders();
-
-  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\"?>\n");
-  msIO_printf("<schema xmlns=\"http://www.w3.org/2001/XMLSchema\" xmlns:wms=\"http://www.opengis.net/wms\" xmlns:ms=\"http://mapserver.gis.umn.edu/mapserver\" targetNamespace=\"http://mapserver.gis.umn.edu/mapserver\" elementFormDefault=\"qualified\" version=\"1.0.0\">\n");
-  msIO_printf("  <import namespace=\"http://www.opengis.net/wms\" schemaLocation=\"%s/wms/1.3.0/capabilities_1_3_0.xsd\"/>\n", schemalocation);
-  msIO_printf("  <element name=\"GetStyles\" type=\"wms:OperationType\" substitutionGroup=\"wms:_ExtendedOperation\"/>\n");
-  msIO_printf("</schema>");
-
-  free(schemalocation);
-
-  return(MS_SUCCESS);
-}
-
-#endif /* USE_WMS_SVR */
-
-
-/*
-** msWMSDispatch() is the entry point for WMS requests.
-** - If this is a valid request then it is processed and MS_SUCCESS is returned
-**   on success, or MS_FAILURE on failure.
-** - If this does not appear to be a valid WMS request then MS_DONE
-**   is returned and MapServer is expected to process this as a regular
-**   MapServer request.
-*/
-int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request, int force_wms_mode)
-{
-#ifdef USE_WMS_SVR
-  int nVersion=OWS_VERSION_NOTSET;
-  const char *version=NULL, *request=NULL, *service=NULL, *format=NULL, *updatesequence=NULL, *language=NULL;
-  const char *wms_exception_format = NULL;
-
-  /*
-  ** Process Params common to all requests
-  */
-  /* VERSION (WMTVER in 1.0.0) and REQUEST must be present in a valid request */
-  for(int i=0; i<req->NumParams; i++) {
-    if(strcasecmp(req->ParamNames[i], "VERSION") == 0)
-      version = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "WMTVER") == 0 && version == NULL)
-      version = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "UPDATESEQUENCE") == 0)
-      updatesequence = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "REQUEST") == 0)
-      request = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "EXCEPTIONS") == 0)
-      wms_exception_format = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "SERVICE") == 0)
-      service = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "FORMAT") == 0)
-      format = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "LANGUAGE") == 0 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities"))
-      language = req->ParamValues[i];
-  }
-
-  /* If SERVICE is specified then it MUST be "WMS" */
-  if (service != NULL && strcasecmp(service, "WMS") != 0)
-    return MS_DONE;  /* Not a WMS request */
-
-  nVersion = msOWSParseVersionString(version);
-  if (nVersion == OWS_VERSION_BADFORMAT) {
-    /* Invalid version format. msSetError() has been called by
-     * msOWSParseVersionString() and we return the error as an exception
-     */
-    return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
-  }
-
-  /*
-  ** GetCapbilities request needs the service parametr defined as WMS:
-  see section 7.1.3.2 wms 1.1.1 specs for decsription.
-  */
-  if (request && service == NULL &&
-      (strcasecmp(request, "capabilities") == 0 ||
-       strcasecmp(request, "GetCapabilities") == 0) &&
-      (nVersion >= OWS_1_0_7 || nVersion == OWS_VERSION_NOTSET)) {
-    if (force_wms_mode) {
-      msSetError(MS_WMSERR, "Required SERVICE parameter missing.", "msWMSDispatch");
-      return msWMSException(map, nVersion, "ServiceNotDefined", wms_exception_format);
-    } else
-      return MS_DONE;
-  }
-
-  /*
-  ** Dispatch request... we should probably do some validation on VERSION here
-  ** vs the versions we actually support.
-  */
-  if (request && (strcasecmp(request, "capabilities") == 0 ||
-                  strcasecmp(request, "GetCapabilities") == 0) ) {
-    const char *enable_request;
-    int globally_enabled, disabled = MS_FALSE;
-
-    if (nVersion == OWS_VERSION_NOTSET) {
-      version = msOWSLookupMetadata(&(map->web.metadata), "M", "getcapabilities_version");
-      if (version)
-        nVersion = msOWSParseVersionString(version);
-      else
-        nVersion = OWS_1_3_0;/* VERSION is optional with getCapabilities only */
-    }
-
-    if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-    msOWSRequestLayersEnabled(map, "M", "GetCapabilities", ows_request);
-
-    enable_request = msOWSLookupMetadata(&map->web.metadata, "OM", "enable_request");
-    globally_enabled = msOWSParseRequestMetadata(enable_request, "GetCapabilities", &disabled);
-
-    if (ows_request->numlayers == 0 && !globally_enabled) {
-      msSetError(MS_WMSERR, "WMS request not enabled. Check wms/ows_enable_request settings.", "msWMSGetCapabilities()");
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-    msAcquireLock(TLOCK_WxS);
-    const int status=msWMSGetCapabilities(map, nVersion, req, ows_request, updatesequence, wms_exception_format, language);
-    msReleaseLock(TLOCK_WxS);
-    return status;
-  } else if (request && (strcasecmp(request, "context") == 0 ||
-                         strcasecmp(request, "GetContext") == 0) ) {
-    /* Return a context document with all layers in this mapfile
-     * This is not a standard WMS request.
-     * __TODO__ The real implementation should actually return only context
-     * info for selected layers in the LAYERS parameter.
-     */
-    const char *getcontext_enabled;
-    getcontext_enabled = msOWSLookupMetadata(&(map->web.metadata),
-                         "MO", "getcontext_enabled");
-
-    if (nVersion != OWS_VERSION_NOTSET) {
-      /* VERSION, if specified, is Map Context version, not WMS version */
-      /* Pass it via wms_context_version metadata */
-      char szVersion[OWS_VERSION_MAXLEN];
-      msInsertHashTable(&(map->web.metadata), "wms_context_version",
-                        msOWSGetVersionString(nVersion, szVersion));
-    }
-    /* Now set version to 1.1.1 for error handling purposes */
-    nVersion = OWS_1_1_1;
-
-    if (getcontext_enabled==NULL || atoi(getcontext_enabled) == 0) {
-      msSetError(MS_WMSERR, "GetContext not enabled on this server.",
-                 "msWMSDispatch()");
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-
-    if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
-    msIO_sendHeaders();
-
-    if ( msWriteMapContext(map, stdout) != MS_SUCCESS )
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    /* Request completed */
-    return MS_SUCCESS;
-  } else if (request && strcasecmp(request, "GetMap") == 0 &&
-             format && strcasecmp(format,  "image/txt") == 0) {
-    /* Until someone adds full support for ASCII graphics this should do. ;) */
-    msIO_setHeader("Content-Type","text/plain; charset=UTF-8");
-    msIO_sendHeaders();
-    msIO_printf(".\n               ,,ggddY\"\"\"Ybbgg,,\n          ,agd888b,_ "
-                "\"Y8, ___'\"\"Ybga,\n       ,gdP\"\"88888888baa,.\"\"8b    \""
-                "888g,\n     ,dP\"     ]888888888P'  \"Y     '888Yb,\n   ,dP\""
-                "      ,88888888P\"  db,       \"8P\"\"Yb,\n  ,8\"       ,8888"
-                "88888b, d8888a           \"8,\n ,8'        d88888888888,88P\""
-                "' a,          '8,\n,8'         88888888888888PP\"  \"\"      "
-                "     '8,\nd'          I88888888888P\"                   'b\n8"
-                "           '8\"88P\"\"Y8P'                      8\n8         "
-                "   Y 8[  _ \"                        8\n8              \"Y8d8"
-                "b  \"Y a                   8\n8                 '\"\"8d,   __"
-                "                 8\nY,                    '\"8bd888b,        "
-                "     ,P\n'8,                     ,d8888888baaa       ,8'\n '8"
-                ",                    888888888888'      ,8'\n  '8a           "
-                "        \"8888888888I      a8'\n   'Yba                  'Y88"
-                "88888P'    adP'\n     \"Yba                 '888888P'   adY\""
-                "\n       '\"Yba,             d8888P\" ,adP\"' \n          '\""
-                "Y8baa,      ,d888P,ad8P\"' \n               ''\"\"YYba8888P\""
-                "\"''\n");
-    return MS_SUCCESS;
-  }
-
-  /* If SERVICE, VERSION and REQUEST not included than this isn't a WMS req*/
-  if (service == NULL && nVersion == OWS_VERSION_NOTSET && request==NULL)
-    return MS_DONE;  /* Not a WMS request */
-
-  /* VERSION *and* REQUEST required by both getMap and getFeatureInfo */
-  if (nVersion == OWS_VERSION_NOTSET) {
-    msSetError(MS_WMSERR,
-               "Incomplete WMS request: VERSION parameter missing",
-               "msWMSDispatch()");
-    return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
-  }
-
-  /*check if the version is one of the supported vcersions*/
-  if (nVersion != OWS_1_0_0 &&  nVersion != OWS_1_0_6 &&
-      nVersion != OWS_1_0_7 && nVersion != OWS_1_1_0 &&
-      nVersion != OWS_1_1_1 && nVersion != OWS_1_3_0) {
-    msSetError(MS_WMSERR,
-               "Invalid WMS version: VERSION %s is not supported. Supported versions are 1.0.0, 1.0.6, 1.0.7, 1.1.0, 1.1.1, 1.3.0",
-               "msWMSDispatch()", version);
-    return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
-  }
-
-  if (request==NULL) {
-    msSetError(MS_WMSERR,
-               "Incomplete WMS request: REQUEST parameter missing",
-               "msWMSDispatch()");
-    return msWMSException(map, nVersion, NULL, wms_exception_format);
-  }
-
-  /* hack !? The function can return MS_DONE ... be sure it's a wms request
-   * before checking the enabled layers */
-  if ( (strcasecmp(request, "GetStyles") == 0) ||
-       (strcasecmp(request, "GetLegendGraphic") == 0) ||
-       (strcasecmp(request, "GetSchemaExtension") == 0) ||
-       (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0) ||
-       (strcasecmp(request, "feature_info") == 0 || strcasecmp(request, "GetFeatureInfo") == 0) ||
-       (strcasecmp(request, "DescribeLayer") == 0) ) {
-    const char* request_tmp;
-    if (strcasecmp(request, "map") == 0)
-      request_tmp = "GetMap";
-    else if (strcasecmp(request, "feature_info") == 0)
-      request_tmp = "GetFeatureInfo";
-    else
-      request_tmp = request;
-
-    msOWSRequestLayersEnabled(map, "M", request_tmp, ows_request);
-    if (ows_request->numlayers == 0) {
-      msSetError(MS_WMSERR, "WMS request not enabled. Check wms/ows_enable_request settings.", "msWMSDispatch()");
-      return msWMSException(map, nVersion, NULL, wms_exception_format);
-    }
-  }
-
-  if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
-    return msWMSException(map, nVersion, NULL, wms_exception_format);
-
-  bool isContentDependantLegend = false;
-  if (strcasecmp(request, "GetLegendGraphic") == 0) {
-    /*
-     * check for a BBOX in the request, in that case we have a content-dependant legend request,
-     * and should be following the GetMap path a bit more
-     */
-    bool found = false;
-    for(int i=0; i<req->NumParams; i++) {
-      if(strcasecmp(req->ParamNames[i], "BBOX") == 0) {
-        if(req->ParamValues[i] && *req->ParamValues[i]) {
-          found = true;
-          break;
-        }
-      }
-    }
-    if(found) {
-      isContentDependantLegend = true;
-      /* getLegendGraphic uses LAYER= , we need to create a LAYERS= value that is identical
-       * we'll suppose that the client is conformat and hasn't included a LAYERS= parameter
-       * in its request */
-      for(int i=0; i<req->NumParams; i++) {
-        if(strcasecmp(req->ParamNames[i], "LAYER") == 0) {
-          req->ParamNames[req->NumParams] = msStrdup("LAYERS");
-          req->ParamValues[req->NumParams] = msStrdup(req->ParamValues[i]);
-          req->NumParams++;
-        }
-      }
-    } else {
-      return msWMSLegendGraphic(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                              wms_exception_format, ows_request, NULL);
-    }
-  }
-
-  if (strcasecmp(request, "GetStyles") == 0)
-    return msWMSGetStyles(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                          wms_exception_format);
-
-  else if (request && strcasecmp(request, "GetSchemaExtension") == 0)
-    return msWMSGetSchemaExtension(map);
-
-  /* getMap parameters are used by both getMap, getFeatureInfo, and content dependant legendgraphics */
-  if (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0 ||
-      strcasecmp(request, "feature_info") == 0 || strcasecmp(request, "GetFeatureInfo") == 0 || strcasecmp(request, "DescribeLayer") == 0 || isContentDependantLegend) {
-
-    const int status = msWMSLoadGetMapParams(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                                   wms_exception_format, request, ows_request);
-    if (status != MS_SUCCESS) return status;
-  }
-
-  /* This function owns validated_language, so remember to free it later*/
-  char* validated_language = msOWSGetLanguageFromList(map, "MO", language);
-  if (validated_language != NULL) {
-    msMapSetLanguageSpecificConnection(map, validated_language);
-  }
-  msFree(validated_language);
-
-  if (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0)
-    return msWMSGetMap(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams, wms_exception_format, ows_request);
-  else if (strcasecmp(request, "feature_info") == 0 || strcasecmp(request, "GetFeatureInfo") == 0)
-    return msWMSFeatureInfo(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams, wms_exception_format, ows_request);
-  else if (strcasecmp(request, "DescribeLayer") == 0) {
-    return msWMSDescribeLayer(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                              wms_exception_format);
-  } else if (isContentDependantLegend) {
-    return msWMSGetContentDependantLegend(map,nVersion, req->ParamNames, req->ParamValues, req->NumParams, wms_exception_format, ows_request);
-  }
-
-  /* Hummmm... incomplete or unsupported WMS request */
-  if (service != NULL && strcasecmp(service, "WMS") == 0) {
-    msSetError(MS_WMSERR, "Incomplete or unsupported WMS request", "msWMSDispatch()");
-    return msWMSException(map, nVersion, NULL, wms_exception_format);
-  } else
-    return MS_DONE;  /* Not a WMS request */
-#else
-  msSetError(MS_WMSERR, "WMS server support is not available.", "msWMSDispatch()");
-  return(MS_FAILURE);
-#endif
-}
-
diff -pruN 8.0.1-5/mapwmslayer.c 8.2.0~beta1-1~exp1/mapwmslayer.c
--- 8.0.1-5/mapwmslayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapwmslayer.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,1658 +0,0 @@
-/*****************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Implementation of WMS CONNECTIONTYPE - client to WMS servers
- * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
- *
- *****************************************************************************
- * Copyright (c) 2001-2004, Daniel Morissette, DM Solutions Group Inc
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
- * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-#include "mapserver.h"
-#include "maperror.h"
-#include "mapogcsld.h"
-#include "mapows.h"
-
-#include <time.h>
-#include <ctype.h>
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#include <process.h>
-#include <stdio.h>
-#endif
-
-#include "cpl_vsi.h"
-
-/**********************************************************************
- *                          msInitWmsParamsObj()
- *
- **********************************************************************/
-int msInitWmsParamsObj(wmsParamsObj *wmsparams)
-{
-  wmsparams->onlineresource = NULL;
-  wmsparams->params = msCreateHashTable();
-  wmsparams->numparams=0;
-  wmsparams->httpcookiedata = NULL;
-
-  return MS_SUCCESS;
-}
-
-/**********************************************************************
- *                          msFreeWmsParamsObj()
- *
- * Frees the contents of the object, but not the object itself.
- **********************************************************************/
-void msFreeWmsParamsObj(wmsParamsObj *wmsparams)
-{
-  msFree(wmsparams->onlineresource);
-  wmsparams->onlineresource = NULL;
-
-  msFreeHashTable(wmsparams->params);
-  wmsparams->params = NULL;
-
-  msFree(wmsparams->httpcookiedata);
-
-  wmsparams->numparams=0;
-}
-
-/**********************************************************************
- *                          msSetWMSParamString()
- *
- **********************************************************************/
-
-#ifdef USE_WMS_LYR
-static int msSetWMSParamString(wmsParamsObj *psWMSParams,
-                               const char *name, const char * value,
-                               int urlencode, int nVersion)
-{
-  if (urlencode) {
-    char *pszTmp;
-
-    /*
-     *  Special case handling for characters the WMS specification
-     *  says should not be encoded, when they occur in certain
-     *  parameters.
-     *
-     *  Note: WMS 1.3 removes SRS and FORMAT from the set of
-     *        exceptional cases, but renames SRS as CRS in any case.
-     */
-    if( strcmp(name,"LAYERS") == 0 ||
-        strcmp(name,"STYLES") == 0 ||
-        strcmp(name,"BBOX") == 0 ) {
-      pszTmp = msEncodeUrlExcept(value,',');
-    } else if ( strcmp(name,"SRS") == 0 ) {
-      pszTmp = msEncodeUrlExcept(value,':');
-    } else if ( nVersion < OWS_1_3_0 && strcmp(name,"FORMAT") == 0 ) {
-      pszTmp = msEncodeUrlExcept(value,'/');
-    } else {
-      pszTmp = msEncodeUrl(value);
-    }
-
-    msInsertHashTable(psWMSParams->params, name, pszTmp);
-    msFree(pszTmp);
-  } else {
-    msInsertHashTable(psWMSParams->params, name, value);
-  }
-  psWMSParams->numparams++;
-
-  return MS_SUCCESS;
-}
-#endif /* def USE_WMS_LYR */
-
-/**********************************************************************
- *                          msSetWMSParamInt()
- *
- **********************************************************************/
-
-#ifdef USE_WMS_LYR
-static int msSetWMSParamInt(wmsParamsObj *wmsparams,
-                            const char *name, int value)
-{
-  char szBuf[100];
-
-  snprintf(szBuf, sizeof(szBuf), "%d", value);
-  msInsertHashTable(wmsparams->params, name, szBuf);
-  wmsparams->numparams++;
-
-  return MS_SUCCESS;
-}
-#endif /* def USE_WMS_LYR */
-
-/**********************************************************************
- *                          msBuildWMSParamsUrl()
- *
- **********************************************************************/
-static char *msBuildURLFromWMSParams(wmsParamsObj *wmsparams)
-{
-  const char *key, *value;
-  size_t bufferSize = 0;
-  int nLen;
-  char *pszURL;
-
-  /* Compute size required for URL buffer
-   */
-  nLen = strlen(wmsparams->onlineresource) + 3;
-
-  key = msFirstKeyFromHashTable(wmsparams->params);
-  while (key != NULL) {
-    value = msLookupHashTable(wmsparams->params, key);
-    nLen += strlen(key) + strlen(value) + 2;
-
-    key = msNextKeyFromHashTable(wmsparams->params, key);
-  }
-
-  bufferSize = nLen+1;
-  pszURL = (char*)msSmallMalloc(bufferSize);
-
-  /* Start with the onlineresource value and append trailing '?' or '&'
-   * if missing.
-   */
-  strcpy(pszURL, wmsparams->onlineresource);
-  if (strchr(pszURL, '?') == NULL)
-    strcat(pszURL, "?");
-  else {
-    char *c;
-    c = pszURL+strlen(pszURL)-1;
-    if (*c != '?' && *c != '&')
-      strcpy(c+1, "&");
-  }
-
-  /* Now add all the parameters
-   */
-  nLen = strlen(pszURL);
-  key = msFirstKeyFromHashTable(wmsparams->params);
-  while (key != NULL) {
-    value = msLookupHashTable(wmsparams->params, key);
-    snprintf(pszURL+nLen, bufferSize-nLen, "%s=%s&", key, value);
-    nLen += strlen(key) + strlen(value) + 2;
-    key = msNextKeyFromHashTable(wmsparams->params, key);
-  }
-
-  /* Get rid of trailing '&'*/
-  pszURL[nLen-1] = '\0';
-
-
-  return pszURL;
-}
-
-
-
-
-#ifdef USE_WMS_LYR
-/**********************************************************************
- *                          msBuildWMSLayerURLBase()
- *
- * Build the base of a GetMap or GetFeatureInfo URL using metadata.
- * The parameters to set are:
- *   VERSION
- *   LAYERS
- *   FORMAT
- *   TRANSPARENT
- *   STYLES
- *   QUERY_LAYERS (for queriable layers only)
- *
- * Returns a reference to a newly allocated string that should be freed
- * by the caller.
- **********************************************************************/
-static int msBuildWMSLayerURLBase(mapObj *map, layerObj *lp,
-                                  wmsParamsObj *psWMSParams, int nRequestType)
-{
-  const char *pszOnlineResource, *pszVersion, *pszName, *pszFormat;
-  const char *pszFormatList, *pszStyle, /* *pszStyleList,*/ *pszTime;
-  const char *pszBgColor, *pszTransparent;
-  const char *pszSLD=NULL, *pszStyleSLDBody=NULL, *pszVersionKeyword=NULL;
-  const char *pszSLDBody=NULL, *pszSLDURL = NULL;
-  char *pszSLDGenerated = NULL;
-  int nVersion=OWS_VERSION_NOTSET;
-
-  /* If lp->connection is not set then use wms_onlineresource metadata */
-  pszOnlineResource = lp->connection;
-  if (pszOnlineResource == NULL)
-    pszOnlineResource = msOWSLookupMetadata(&(lp->metadata),
-                                            "MO", "onlineresource");
-
-  pszVersion =        msOWSLookupMetadata(&(lp->metadata), "MO", "server_version");
-  pszName =           msOWSLookupMetadata(&(lp->metadata), "MO", "name");
-  pszFormat =         msOWSLookupMetadata(&(lp->metadata), "MO", "format");
-  pszFormatList =     msOWSLookupMetadata(&(lp->metadata), "MO", "formatlist");
-  pszStyle =          msOWSLookupMetadata(&(lp->metadata), "MO", "style");
-  /*pszStyleList =      msOWSLookupMetadata(&(lp->metadata), "MO", "stylelist");*/
-  pszTime =           msOWSLookupMetadata(&(lp->metadata), "MO", "time");
-  pszSLDBody =        msOWSLookupMetadata(&(lp->metadata), "MO", "sld_body");
-  pszSLDURL =         msOWSLookupMetadata(&(lp->metadata), "MO", "sld_url");
-  pszBgColor =        msOWSLookupMetadata(&(lp->metadata), "MO", "bgcolor");
-  pszTransparent =    msOWSLookupMetadata(&(lp->metadata), "MO", "transparent");
-
-  if (pszOnlineResource==NULL || pszVersion==NULL || pszName==NULL) {
-    msSetError(MS_WMSCONNERR,
-               "One of wms_onlineresource, wms_server_version, wms_name "
-               "metadata is missing in layer %s.  "
-               "Please either provide a valid CONNECTION URL, or provide "
-               "those values in the layer's metadata.\n",
-               "msBuildWMSLayerURLBase()", lp->name);
-    return MS_FAILURE;
-  }
-
-  psWMSParams->onlineresource = msStrdup(pszOnlineResource);
-
-  if (strncmp(pszVersion, "1.0.7", 5) < 0)
-    pszVersionKeyword = "WMTVER";
-  else
-    pszVersionKeyword = "VERSION";
-
-  nVersion = msOWSParseVersionString(pszVersion);
-  /* WMS 1.0.8 is really just 1.1.0 */
-  if (nVersion == OWS_1_0_8) nVersion = OWS_1_1_0;
-
-  msSetWMSParamString(psWMSParams, pszVersionKeyword, pszVersion, MS_FALSE, nVersion);
-  msSetWMSParamString(psWMSParams, "SERVICE", "WMS",     MS_FALSE, nVersion);
-  msSetWMSParamString(psWMSParams, "LAYERS",  pszName,   MS_TRUE, nVersion);
-
-  if (pszFormat==NULL && pszFormatList==NULL) {
-    msSetError(MS_WMSCONNERR,
-               "At least wms_format or wms_formatlist is required for "
-               "layer %s.  "
-               "Please either provide a valid CONNECTION URL, or provide "
-               "those values in the layer's metadata.\n",
-               "msBuildWMSLayerURLBase()", lp->name);
-    return MS_FAILURE;
-  }
-
-  if (pszFormat != NULL) {
-    msSetWMSParamString(psWMSParams, "FORMAT",  pszFormat, MS_TRUE, nVersion);
-  } else {
-    /* Look for the first format in list that matches */
-    char **papszTok;
-    int i, n;
-    papszTok = msStringSplit(pszFormatList, ',', &n);
-
-    for(i=0; pszFormat==NULL && i<n; i++) {
-      if (0
-#if defined USE_PNG
-          || strcasecmp(papszTok[i], "PNG")
-          || strcasecmp(papszTok[i], "image/png")
-#endif
-#if defined USE_JPEG
-          || strcasecmp(papszTok[i], "JPEG")
-          || strcasecmp(papszTok[i], "image/jpeg")
-#endif
-         ) {
-        pszFormat = papszTok[i];
-      }
-    }
-
-    if (pszFormat) {
-      msSetWMSParamString(psWMSParams, "FORMAT",  pszFormat, MS_TRUE, nVersion);
-      msFreeCharArray(papszTok, n);
-    } else {
-      msSetError(MS_WMSCONNERR,
-                 "Could not find a format that matches supported input "
-                 "formats in wms_formatlist metdata in layer %s.  "
-                 "Please either provide a valid CONNECTION URL, or "
-                 "provide the required layer metadata.\n",
-                 "msBuildWMSLayerURLBase()", lp->name);
-      msFreeCharArray(papszTok, n);
-      return MS_FAILURE;
-    }
-  }
-
-  if (pszStyle==NULL) {
-    /* When no style is selected, use "" which is a valid default. */
-    pszStyle = "";
-  } else {
-    /* Was a wms_style_..._sld URL provided? */
-    char szBuf[100];
-    snprintf(szBuf, sizeof(szBuf), "style_%.80s_sld", pszStyle);
-    pszSLD = msOWSLookupMetadata(&(lp->metadata), "MO", szBuf);
-    snprintf(szBuf, sizeof(szBuf), "style_%.80s_sld_body", pszStyle);
-    pszStyleSLDBody = msOWSLookupMetadata(&(lp->metadata), "MO", szBuf);
-
-    if (pszSLD || pszStyleSLDBody) {
-      /* SLD URL is set.  If this defn. came from a map context then */
-      /* the style name may just be an internal name: "Style{%d}" if */
-      /* that's the case then we should not pass this name via the URL */
-      if (strncmp(pszStyle, "Style{", 6) == 0)
-        pszStyle = "";
-    }
-  }
-
-  /*  set STYLE parameter no matter what, even if it's empty (i.e. "STYLES=")
-   *  GetLegendGraphic doesn't support multiple styles and is named STYLE
-   */
-  if (nRequestType == WMS_GETLEGENDGRAPHIC) {
-    msSetWMSParamString(psWMSParams, "STYLE", pszStyle, MS_TRUE, nVersion);
-  } else {
-    msSetWMSParamString(psWMSParams, "STYLES", pszStyle, MS_TRUE, nVersion);
-  }
-
-  if (pszSLD != NULL) {
-    /* Only SLD is set */
-    msSetWMSParamString(psWMSParams, "SLD",    pszSLD,   MS_TRUE, nVersion);
-  } else if (pszStyleSLDBody != NULL) {
-    /* SLDBODY are set */
-    msSetWMSParamString(psWMSParams, "SLD_BODY", pszStyleSLDBody, MS_TRUE, nVersion);
-  }
-
-  if (msIsLayerQueryable(lp)) {
-    msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszName, MS_TRUE, nVersion);
-  }
-  if (pszTime && strlen(pszTime) > 0) {
-    msSetWMSParamString(psWMSParams, "TIME",   pszTime,  MS_TRUE, nVersion);
-  }
-
-  /* if  the metadata wms_sld_body is set to AUTO, we generate
-   * the sld based on classes found in the map file and send
-   * it in the URL. If diffrent from AUTO, we are assuming that
-   * it is a valid sld.
-   */
-  if (pszSLDBody) {
-    if (strcasecmp(pszSLDBody, "AUTO") == 0) {
-      if (strncmp(pszVersion, "1.3.0", 5) == 0)
-        pszSLDGenerated = msSLDGenerateSLD(map, lp->index, "1.1.0");
-      else
-        pszSLDGenerated = msSLDGenerateSLD(map, lp->index, NULL);
-
-      if (pszSLDGenerated) {
-        msSetWMSParamString(psWMSParams, "SLD_BODY",
-                            pszSLDGenerated, MS_TRUE, nVersion);
-        free(pszSLDGenerated);
-      }
-    } else {
-      msSetWMSParamString(psWMSParams, "SLD_BODY", pszSLDBody, MS_TRUE, nVersion);
-    }
-
-  }
-
-  if (pszSLDURL) {
-    msSetWMSParamString(psWMSParams, "SLD", pszSLDURL, MS_TRUE, nVersion);
-  }
-
-  if (pszBgColor) {
-    msSetWMSParamString(psWMSParams, "BGCOLOR", pszBgColor, MS_TRUE, nVersion);
-  }
-
-  if (pszTransparent) {
-    msSetWMSParamString(psWMSParams, "TRANSPARENT", pszTransparent, MS_TRUE, nVersion);
-  } else {
-    msSetWMSParamString(psWMSParams, "TRANSPARENT", "TRUE", MS_TRUE, nVersion);
-  }
-
-  return MS_SUCCESS;
-}
-
-#endif /* USE_WMS_LYR */
-
-
-/**********************************************************************
- *                          msBuildWMSLayerURL()
- *
- * Build a GetMap or GetFeatureInfo URL.
- *
- * Returns a reference to a newly allocated string that should be freed
- * by the caller.
- **********************************************************************/
-
-static int
-msBuildWMSLayerURL(mapObj *map, layerObj *lp, int nRequestType,
-                   int nClickX, int nClickY, int nFeatureCount,
-                   const char *pszInfoFormat, rectObj *bbox_ret,
-                   int *width_ret, int *height_ret,
-                   wmsParamsObj *psWMSParams)
-{
-#ifdef USE_WMS_LYR
-  char *pszEPSG = NULL;
-  const char *pszVersion, *pszRequestParam,
-        *pszSrsParamName="SRS", *pszLayer=NULL, *pszQueryLayers=NULL,
-        *pszUseStrictAxisOrder;
-  rectObj bbox;
-  int bbox_width = map->width, bbox_height = map->height;
-  int nVersion=OWS_VERSION_NOTSET;
-  int bUseStrictAxisOrder = MS_FALSE; /* this is the assumption up to 1.1.0 */
-  int bFlipAxisOrder = MS_FALSE;
-  const char *pszTmp;
-  int bIsEssential = MS_FALSE;
-
-  if (lp->connectiontype != MS_WMS) {
-    msSetError(MS_WMSCONNERR, "Call supported only for CONNECTIONTYPE WMS",
-               "msBuildWMSLayerURL()");
-    return MS_FAILURE;
-  }
-
-  /* ------------------------------------------------------------------
-   * Find out request version
-   * ------------------------------------------------------------------ */
-  if (lp->connection == NULL ||
-      ((pszVersion = strstr(lp->connection, "VERSION=")) == NULL &&
-       (pszVersion = strstr(lp->connection, "version=")) == NULL &&
-       (pszVersion = strstr(lp->connection, "WMTVER=")) == NULL &&
-       (pszVersion = strstr(lp->connection, "wmtver=")) == NULL ) ) {
-    /* CONNECTION missing or seems incomplete... try to build from metadata */
-    if (msBuildWMSLayerURLBase(map, lp, psWMSParams, nRequestType) != MS_SUCCESS)
-      return MS_FAILURE;  /* An error already produced. */
-
-    /* If we received MS_SUCCESS then version must have been set */
-    pszVersion = msLookupHashTable(psWMSParams->params, "VERSION");
-    if (pszVersion ==NULL)
-      pszVersion = msLookupHashTable(psWMSParams->params, "WMTVER");
-
-    nVersion = msOWSParseVersionString(pszVersion);
-  } else {
-    /* CONNECTION string seems complete, start with that. */
-    char *pszDelimiter;
-    psWMSParams->onlineresource = msStrdup(lp->connection);
-
-    /* Fetch version info */
-    pszVersion = strchr(pszVersion, '=')+1;
-    pszDelimiter = strchr(pszVersion, '&');
-    if (pszDelimiter != NULL)
-      *pszDelimiter = '\0';
-    nVersion = msOWSParseVersionString(pszVersion);
-    if (pszDelimiter != NULL)
-      *pszDelimiter = '&';
-  }
-
-  switch (nVersion) {
-    case OWS_1_0_8:
-      nVersion = OWS_1_1_0;    /* 1.0.8 == 1.1.0 */
-      break;
-    case OWS_1_0_0:
-    case OWS_1_0_1:
-    case OWS_1_0_7:
-    case OWS_1_1_0:
-    case OWS_1_1_1:
-      /* All is good, this is a supported version. */
-      break;
-    case OWS_1_3_0:
-      /* 1.3.0 introduces a few changes... */
-      pszSrsParamName = "CRS";
-      bUseStrictAxisOrder = MS_TRUE; /* this is the assumption for 1.3.0 */
-      break;
-    default:
-      /* Not a supported version */
-      msSetError(MS_WMSCONNERR, "MapServer supports only WMS 1.0.0 to 1.3.0 (please verify the VERSION parameter in the connection string).", "msBuildWMSLayerURL()");
-      return MS_FAILURE;
-  }
-
-  /* ------------------------------------------------------------------
-   * For GetFeatureInfo requests, make sure QUERY_LAYERS is included
-   * ------------------------------------------------------------------ */
-  if  (nRequestType == WMS_GETFEATUREINFO &&
-       strstr(psWMSParams->onlineresource, "QUERY_LAYERS=") == NULL &&
-       strstr(psWMSParams->onlineresource, "query_layers=") == NULL &&
-       msLookupHashTable(psWMSParams->params, "QUERY_LAYERS") == NULL) {
-    pszQueryLayers = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
-
-    if (pszQueryLayers == NULL) {
-      msSetError(MS_WMSCONNERR, "wms_name not set or WMS Connection String must contain the QUERY_LAYERS parameter to support GetFeatureInfo requests (with name in uppercase).", "msBuildWMSLayerURL()");
-      return MS_FAILURE;
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * For GetLegendGraphic requests, make sure LAYER is included
-   * ------------------------------------------------------------------ */
-  if  (nRequestType == WMS_GETLEGENDGRAPHIC &&
-       strstr(psWMSParams->onlineresource, "LAYER=") == NULL &&
-       strstr(psWMSParams->onlineresource, "layer=") == NULL &&
-       msLookupHashTable(psWMSParams->params, "LAYER") == NULL) {
-    pszLayer = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
-
-    if (pszLayer == NULL) {
-      msSetError(MS_WMSCONNERR, "wms_name not set or WMS Connection String must contain the LAYER parameter to support GetLegendGraphic requests (with name in uppercase).", "msBuildWMSLayerURL()");
-      return MS_FAILURE;
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * Figure the SRS we'll use for the request.
-   * - Fetch the map SRS (if it's EPSG)
-   * - Check if map SRS is listed in layer wms_srs metadata
-   * - If map SRS is valid for this layer then use it
-   * - Otherwise request layer in its default SRS and we'll reproject later
-   * ------------------------------------------------------------------ */
-  msOWSGetEPSGProj(&(map->projection),NULL, NULL, MS_TRUE, &pszEPSG);
-  if ( pszEPSG &&
-      (strncasecmp(pszEPSG, "EPSG:", 5) == 0 ||
-       strncasecmp(pszEPSG, "AUTO:", 5) == 0) ) {
-    const char *pszFound;
-    char *pszLyrEPSG;
-    int nLen;
-    char *pszPtr = NULL;
-
-    /* If it's an AUTO projection then keep only id and strip off  */
-    /* the parameters for now (we'll restore them at the end) */
-    if (strncasecmp(pszEPSG, "AUTO:", 5) == 0) {
-      if ((pszPtr = strchr(pszEPSG, ',')))
-        *pszPtr = '\0';
-    }
-
-    nLen = strlen(pszEPSG);
-
-    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE, &pszLyrEPSG);
-
-    if (pszLyrEPSG == NULL ||
-        (pszFound = strstr(pszLyrEPSG, pszEPSG)) == NULL ||
-        ! ((*(pszFound+nLen) == '\0') || isspace(*(pszFound+nLen))) ) {
-      /* Not found in Layer's list of SRS (including projection object) */
-      free(pszEPSG);
-      pszEPSG = NULL;
-    }
-    msFree(pszLyrEPSG);
-    if (pszEPSG && pszPtr)
-      *pszPtr = ',';  /* Restore full AUTO:... definition */
-  }
-
-  if (pszEPSG == NULL) {
-      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata),"MO", MS_TRUE, &pszEPSG);
-      if( pszEPSG == NULL || (strncasecmp(pszEPSG, "EPSG:", 5) != 0 && strncasecmp(pszEPSG, "AUTO:", 5) != 0) )  {
-        msSetError(MS_WMSCONNERR, "Layer must have an EPSG or AUTO projection code (in its PROJECTION object or wms_srs metadata)", "msBuildWMSLayerURL()");
-        msFree(pszEPSG);
-        return MS_FAILURE;
-      }
-  }
-
-  /* ------------------------------------------------------------------
-   * For an AUTO projection, set the Units,lon0,lat0 if not already set
-   * ------------------------------------------------------------------ */
-  if (strncasecmp(pszEPSG, "AUTO:", 5) == 0 &&
-      strchr(pszEPSG, ',') == NULL) {
-    pointObj oPoint;
-    char *pszNewEPSG;
-
-    /* Use center of map view for lon0,lat0 */
-    oPoint.x = (map->extent.minx + map->extent.maxx)/2.0;
-    oPoint.y = (map->extent.miny + map->extent.maxy)/2.0;
-    msProjectPoint(&(map->projection), &(map->latlon), &oPoint);
-
-    pszNewEPSG = (char*)msSmallMalloc(101*sizeof(char));
-
-    snprintf(pszNewEPSG, 100, "%s,9001,%.16g,%.16g",
-             pszEPSG, oPoint.x, oPoint.y);
-    pszNewEPSG[100]='\0';
-    free(pszEPSG);
-    pszEPSG=pszNewEPSG;
-  }
-
-  /*
-   * Work out whether we'll be wanting to flip the axis order for the request
-   */
-  pszUseStrictAxisOrder = msOWSLookupMetadata(&(lp->metadata), "MO", "strict_axis_order");
-  if (pszUseStrictAxisOrder != NULL) {
-    if (strncasecmp(pszUseStrictAxisOrder, "1", 1) == 0 ||
-        strncasecmp(pszUseStrictAxisOrder, "true", 4) == 0) {
-      bUseStrictAxisOrder = MS_TRUE;
-    } else if (strncasecmp(pszUseStrictAxisOrder, "0", 1) == 0 ||
-        strncasecmp(pszUseStrictAxisOrder, "false", 5) == 0) {
-      bUseStrictAxisOrder = MS_FALSE;
-    }
-  }
-  if (bUseStrictAxisOrder == MS_TRUE && pszEPSG &&
-      strncasecmp(pszEPSG, "EPSG:", 5) == 0 &&
-      msIsAxisInverted(atoi(pszEPSG + 5))) {
-    bFlipAxisOrder = MS_TRUE;
-  }
-
-  /* ------------------------------------------------------------------
-   * Set layer SRS.
-   * ------------------------------------------------------------------ */
-  /* No need to set lp->proj if it's already set to the right EPSG code */
-  {
-    char* pszEPSGCodeFromLayer = NULL;
-    msOWSGetEPSGProj(&(lp->projection), NULL, "MO", MS_TRUE, &pszEPSGCodeFromLayer);
-    if (pszEPSGCodeFromLayer == NULL || strcasecmp(pszEPSG, pszEPSGCodeFromLayer) != 0) {
-      char *ows_srs = NULL;
-      msOWSGetEPSGProj(NULL, &(lp->metadata), "MO", MS_FALSE, &ows_srs);
-      /* no need to set lp->proj if it is already set and there is only
-      one item in the _srs metadata for this layer - we will assume
-      the projection block matches the _srs metadata (the search for ' '
-      in ows_srs is a test to see if there are multiple EPSG: codes) */
-      if( lp->projection.numargs == 0 || ows_srs == NULL || (strchr(ows_srs,' ') != NULL) ) {
-        // Reproject layer extent if lp-projection is set since we might change layer projection
-        if (msProjectionsDiffer(&(map->projection), &(lp->projection))) {
-          msProjectRect(&(lp->projection),&(map->projection), &(lp->extent));
-        }
-
-        if (strncasecmp(pszEPSG, "EPSG:", 5) == 0) {
-          char szProj[20];
-          snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG+5);
-          if (msLoadProjectionString(&(lp->projection), szProj) != 0) {
-            msFree(pszEPSGCodeFromLayer);
-            msFree(ows_srs);
-            return MS_FAILURE;
-          }
-        } else {
-          if (msLoadProjectionString(&(lp->projection), pszEPSG) != 0) {
-            msFree(pszEPSGCodeFromLayer);
-            msFree(ows_srs);
-            return MS_FAILURE;
-          }
-        }
-      }
-      msFree(ows_srs);
-    }
-    msFree(pszEPSGCodeFromLayer);
-  }
-
-  /* ------------------------------------------------------------------
-   * Adjust for MapServer EXTENT being center of pixel and WMS BBOX being
-   * edge of pixel (#2843).
-   * ------------------------------------------------------------------ */
-  bbox = map->extent;
-
-  bbox.minx -= map->cellsize * 0.5;
-  bbox.maxx += map->cellsize * 0.5;
-  bbox.miny -= map->cellsize * 0.5;
-  bbox.maxy += map->cellsize * 0.5;
-
-  /* -------------------------------------------------------------------- */
-  /*      Reproject if needed.                                            */
-  /* -------------------------------------------------------------------- */
-  if (msProjectionsDiffer(&(map->projection), &(lp->projection))) {
-    msProjectRect(&(map->projection), &(lp->projection), &bbox);
-
-    /* -------------------------------------------------------------------- */
-    /*      Sometimes our remote WMS only accepts square pixel              */
-    /*      requests.  If this is the case adjust adjust the number of      */
-    /*      pixels or lines in the request so that the pixels are           */
-    /*      square.                                                         */
-    /* -------------------------------------------------------------------- */
-    {
-      const char *nonsquare_ok =
-        msOWSLookupMetadata(&(lp->metadata),
-                            "MO", "nonsquare_ok");
-
-      /* assume nonsquare_ok is false */
-      if( nonsquare_ok != NULL
-          && (strcasecmp(nonsquare_ok,"no") == 0
-              || strcasecmp(nonsquare_ok,"false") == 0) ) {
-        double cellsize_x = (bbox.maxx-bbox.minx) / bbox_width;
-        double cellsize_y = (bbox.maxy-bbox.miny) / bbox_height;
-
-        if( cellsize_x < cellsize_y * 0.999999 ) {
-          int new_bbox_height =
-            ceil((cellsize_y/cellsize_x) * bbox_height);
-
-          if (lp->debug)
-            msDebug("NONSQUARE_OK=%s, adjusted HEIGHT from %d to %d to equalize cellsize at %g.\n",
-                    nonsquare_ok,
-                    bbox_height, new_bbox_height, cellsize_x );
-          bbox_height = new_bbox_height;
-        } else if( cellsize_y < cellsize_x * 0.999999 ) {
-          int new_bbox_width =
-            ceil((cellsize_x/cellsize_y) * bbox_width);
-
-          if (lp->debug)
-            msDebug("NONSQUARE_OK=%s, adjusted WIDTH from %d to %d to equalize cellsize at %g.\n",
-                    nonsquare_ok,
-                    bbox_width, new_bbox_width, cellsize_y );
-          bbox_width = new_bbox_width;
-        } else {
-          if (lp->debug)
-            msDebug("NONSQUARE_OK=%s, but cellsize was already square - no change.\n",
-                    nonsquare_ok );
-        }
-      }
-    }
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      If the layer has predefined extents, and a predefined           */
-  /*      projection that matches the request projection, then            */
-  /*      consider restricting the BBOX to match the limits.              */
-  /* -------------------------------------------------------------------- */
-  if( bbox_width != 0 ) {
-    char *ows_srs;
-    rectObj  layer_rect;
-
-    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE, &ows_srs);
-
-    if( ows_srs && strchr(ows_srs,' ') == NULL
-        && msOWSGetLayerExtent( map, lp, "MO", &layer_rect) == MS_SUCCESS ) {
-      /* fulloverlap */
-      if( msRectContained( &bbox, &layer_rect ) ) {
-        /* no changes */
-      }
-
-      /* no overlap */
-      else if( !msRectOverlap( &layer_rect, &bbox ) ) {
-        bbox_width = 0;
-        bbox_height = 0;
-      }
-
-      else {
-        double cellsize_x = (bbox.maxx-bbox.minx) / bbox_width;
-        double cellsize_y = (bbox.maxy-bbox.miny) / bbox_height;
-        double cellsize = MS_MIN(cellsize_x,cellsize_y);
-
-        msRectIntersect( &bbox, &layer_rect );
-
-        bbox_width = round((bbox.maxx - bbox.minx) / cellsize);
-        bbox_height = round((bbox.maxy - bbox.miny) / cellsize);
-
-        /* Force going through the resampler if we're going to receive a clipped BBOX (#4931) */
-        if(msLayerGetProcessingKey(lp, "RESAMPLE") == NULL) {
-          msLayerSetProcessingKey(lp, "RESAMPLE", "nearest");
-        }
-      }
-    }
-    msFree(ows_srs);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Potentially return the bbox.                                    */
-  /* -------------------------------------------------------------------- */
-  if (bbox_ret != NULL)
-    *bbox_ret = bbox;
-
-  if( width_ret != NULL )
-    *width_ret = bbox_width;
-
-  if( height_ret != NULL )
-    *height_ret = bbox_height;
-
-  /* ------------------------------------------------------------------
-   * Build the request URL.
-   * At this point we set only the following parameters for GetMap:
-   *   REQUEST
-   *   SRS (or CRS)
-   *   BBOX
-   *
-   * And for GetFeatureInfo:
-   *   X (I for 1.3.0)
-   *   Y (J for 1.3.0)
-   *   INFO_FORMAT
-   *   FEATURE_COUNT (only if nFeatureCount > 0)
-   *
-   * The connection string should contain all other required params,
-   * including:
-   *   VERSION
-   *   LAYERS
-   *   FORMAT
-   *   TRANSPARENT
-   *   STYLES
-   *   QUERY_LAYERS (for queryable layers only)
-   * ------------------------------------------------------------------ */
-
-  /* ------------------------------------------------------------------
-   * Sometimes a requested layer is essential for the map, so if the
-   * request fails or an error is delivered, the map has not to be drawn
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "essential")) != NULL) {
-    if( strcasecmp(pszTmp,"true") == 0
-        || strcasecmp(pszTmp,"on") == 0
-        || strcasecmp(pszTmp,"yes") == 0 )
-      bIsEssential = MS_TRUE;
-    else
-      bIsEssential = atoi(pszTmp);       
-  }
-
-  if (nRequestType == WMS_GETFEATUREINFO) {
-    char szBuf[100] = "";
-
-    if (nVersion >= OWS_1_0_7)
-      pszRequestParam = "GetFeatureInfo";
-    else
-      pszRequestParam = "feature_info";
-
-    const char* pszExceptionsParam;
-    if (nVersion >= OWS_1_3_0)
-      pszExceptionsParam = "XML";
-    else if (nVersion >= OWS_1_1_0) /* 1.1.0 to 1.1.0 */
-      pszExceptionsParam = "application/vnd.ogc.se_xml";
-    else if (nVersion > OWS_1_0_0)  /* 1.0.1 to 1.0.7 */
-      pszExceptionsParam = "SE_XML";
-    else
-      pszExceptionsParam = "WMS_XML";
-
-    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE, nVersion);
-    msSetWMSParamInt(   psWMSParams, "WIDTH",   bbox_width);
-    msSetWMSParamInt(   psWMSParams, "HEIGHT",  bbox_height);
-
-    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE, nVersion);
-
-    if (bFlipAxisOrder == MS_TRUE) {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.miny, bbox.minx, bbox.maxy, bbox.maxx);
-    } else {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.minx, bbox.miny, bbox.maxx, bbox.maxy);
-    }
-    msSetWMSParamString(psWMSParams, "BBOX",    szBuf, MS_TRUE, nVersion);
-
-    if (nVersion >= OWS_1_3_0) {
-      msSetWMSParamInt(   psWMSParams, "I",       nClickX);
-      msSetWMSParamInt(   psWMSParams, "J",       nClickY);
-    } else {
-      msSetWMSParamInt(   psWMSParams, "X",       nClickX);
-      msSetWMSParamInt(   psWMSParams, "Y",       nClickY);
-    }
-
-    msSetWMSParamString(psWMSParams, "EXCEPTIONS", pszExceptionsParam, MS_FALSE, nVersion);
-    msSetWMSParamString(psWMSParams, "INFO_FORMAT", pszInfoFormat, MS_TRUE, nVersion);
-
-    if (pszQueryLayers) { /* not set in CONNECTION string */
-      msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszQueryLayers, MS_FALSE, nVersion);
-    }
-
-    /* If FEATURE_COUNT <= 0 then don't pass this parameter */
-    /* The spec states that FEATURE_COUNT must be greater than zero */
-    /* and if not passed then the behavior is up to the server */
-    if (nFeatureCount > 0) {
-      msSetWMSParamInt(psWMSParams, "FEATURE_COUNT", nFeatureCount);
-    }
-
-  } else if (nRequestType == WMS_GETLEGENDGRAPHIC) {
-    if(map->extent.maxx > map->extent.minx && map->width > 0 && map->height > 0) {
-      char szBuf[20] = "";
-      double scaledenom;
-      msCalculateScale(map->extent, map->units, map->width, map->height,
-                     map->resolution, &scaledenom);
-      snprintf(szBuf, 20, "%g",scaledenom);
-      msSetWMSParamString(psWMSParams, "SCALE", szBuf, MS_FALSE, nVersion);
-    }
-    pszRequestParam = "GetLegendGraphic";
-
-    /*
-    const char* pszExceptionsParam = msOWSLookupMetadata(&(lp->metadata),
-                         "MO", "exceptions_format");
-    if (pszExceptionsParam == NULL) {
-      if (nVersion >= OWS_1_1_0 && nVersion < OWS_1_3_0)
-        pszExceptionsParam = "application/vnd.ogc.se_inimage";
-      else
-        pszExceptionsParam = "INIMAGE";
-    }*/
-
-    if (pszLayer) { /* not set in CONNECTION string */
-      msSetWMSParamString(psWMSParams, "LAYER", pszLayer, MS_FALSE, nVersion);
-    }
-
-    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE, nVersion);
-    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE, nVersion);
-
-    if (nVersion >= OWS_1_3_0) {
-      msSetWMSParamString(psWMSParams, "SLD_VERSION", "1.1.0", MS_FALSE, nVersion);
-    }
-
-  } else { /* if (nRequestType == WMS_GETMAP) */
-    char szBuf[100] = "";
-
-    if (nVersion >= OWS_1_0_7)
-      pszRequestParam = "GetMap";
-    else
-      pszRequestParam = "map";
-
-    const char* pszExceptionsParam = msOWSLookupMetadata(&(lp->metadata),
-                         "MO", "exceptions_format");
-
-    if (!bIsEssential) {
-      if (pszExceptionsParam == NULL) {
-        if (nVersion >= OWS_1_1_0 && nVersion < OWS_1_3_0)
-          pszExceptionsParam = "application/vnd.ogc.se_inimage";
-        else
-          pszExceptionsParam = "INIMAGE";
-      }
-    } else {
-      /* if layer is essential, do not emit EXCEPTIONS parameter (defaults to XML) */
-      pszExceptionsParam = NULL;
-    }
-
-    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE, nVersion);
-    msSetWMSParamInt(   psWMSParams, "WIDTH",   bbox_width);
-    msSetWMSParamInt(   psWMSParams, "HEIGHT",  bbox_height);
-    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE, nVersion);
-
-    if (bFlipAxisOrder == MS_TRUE) {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.miny, bbox.minx, bbox.maxy, bbox.maxx);
-    } else {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.minx, bbox.miny, bbox.maxx, bbox.maxy);
-    }
-    msSetWMSParamString(psWMSParams, "BBOX",    szBuf, MS_TRUE, nVersion);
-    if( pszExceptionsParam ) {
-      msSetWMSParamString(psWMSParams, "EXCEPTIONS",  pszExceptionsParam, MS_FALSE, nVersion);
-    }
-  }
-
-  free(pszEPSG);
-
-  return MS_SUCCESS;
-
-#else
-  /* ------------------------------------------------------------------
-   * WMS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
-             "msBuildWMSLayerURL()");
-  return MS_FAILURE;
-
-#endif /* USE_WMS_LYR */
-
-}
-
-
-/**********************************************************************
- *                          msWMSGetFeatureInfoURL()
- *
- * Build a GetFeatureInfo URL for this layer.
- *
- * Returns a reference to a newly allocated string that should be freed
- * by the caller.
- **********************************************************************/
-char *msWMSGetFeatureInfoURL(mapObj *map, layerObj *lp,
-                             int nClickX, int nClickY, int nFeatureCount,
-                             const char *pszInfoFormat)
-{
-  wmsParamsObj sThisWMSParams;
-  char *pszURL;
-
-  msInitWmsParamsObj(&sThisWMSParams);
-
-  if (msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO,
-                         nClickX, nClickY, nFeatureCount,
-                         pszInfoFormat, NULL, NULL, NULL,
-                         &sThisWMSParams)!= MS_SUCCESS) {
-    return NULL;
-  }
-
-  pszURL = msBuildURLFromWMSParams(&sThisWMSParams);
-  msFreeWmsParamsObj(&sThisWMSParams);
-
-  return pszURL;
-}
-
-/**********************************************************************
- *                          msPrepareWMSLayerRequest()
- *
- **********************************************************************/
-
-int msPrepareWMSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
-                             int nRequestType, enum MS_CONNECTION_TYPE lastconnectiontype,
-                             wmsParamsObj *psLastWMSParams,
-                             int nClickX, int nClickY, int nFeatureCount, const char *pszInfoFormat,
-                             httpRequestObj *pasReqInfo, int *numRequests)
-{
-#ifdef USE_WMS_LYR
-  char *pszURL = NULL, *pszHTTPCookieData = NULL;
-  const char *pszTmp;
-  rectObj bbox = { 0 };
-  int bbox_width = 0, bbox_height = 0;
-  int nTimeout, bOkToMerge, bForceSeparateRequest, bCacheToDisk;
-  wmsParamsObj sThisWMSParams;
-  int ret = MS_FAILURE;
-
-  if (lp->connectiontype != MS_WMS)
-    return MS_FAILURE;
-
-  msInitWmsParamsObj(&sThisWMSParams);
-
-  /* ------------------------------------------------------------------
-   * Build the request URL, this will also set layer projection and
-   * compute BBOX in that projection.
-   * ------------------------------------------------------------------ */
-
-  switch( nRequestType )
-  {
-      case WMS_GETMAP:
-          ret = msBuildWMSLayerURL(map, lp, WMS_GETMAP,
-                           0, 0, 0, NULL, &bbox, &bbox_width, &bbox_height,
-                           &sThisWMSParams);
-          break;
-
-      case WMS_GETFEATUREINFO:
-          ret = msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO,
-                              nClickX, nClickY, nFeatureCount, pszInfoFormat,
-                              NULL, NULL, NULL,
-                              &sThisWMSParams);
-          break;
-
-      case WMS_GETLEGENDGRAPHIC:
-          ret = msBuildWMSLayerURL(map, lp, WMS_GETLEGENDGRAPHIC,
-                                0, 0, 0, NULL,
-                                NULL, NULL, NULL,
-                                &sThisWMSParams);
-          break;
-
-      default:
-          assert(FALSE);
-          break;
-  }
-
-  if( ret != MS_SUCCESS) {
-    /* an error was already reported. */
-    msFreeWmsParamsObj(&sThisWMSParams);
-    return MS_FAILURE;
-  }
-
-  /* ------------------------------------------------------------------
-   * Check if the request is empty, perhaps due to reprojection problems
-   * or wms_extents restrictions.
-   * ------------------------------------------------------------------ */
-  if ((nRequestType == WMS_GETMAP) && (bbox_width == 0 || bbox_height == 0) ) {
-    msFreeWmsParamsObj(&sThisWMSParams);
-    return MS_SUCCESS;  /* No overlap. */
-  }
-
-  /* ------------------------------------------------------------------
-   * Check if layer overlaps current view window (using wms_latlonboundingbox)
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "latlonboundingbox")) != NULL) {
-    char **tokens;
-    int n;
-    rectObj ext;
-
-    tokens = msStringSplit(pszTmp, ' ', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_WMSCONNERR, "Wrong number of arguments for 'wms_latlonboundingbox' metadata.",
-                 "msDrawWMSLayer()");
-      msFreeWmsParamsObj(&sThisWMSParams);
-      return MS_FAILURE;
-    }
-
-    ext.minx = atof(tokens[0]);
-    ext.miny = atof(tokens[1]);
-    ext.maxx = atof(tokens[2]);
-    ext.maxy = atof(tokens[3]);
-
-    msFreeCharArray(tokens, n);
-
-    /* Reproject latlonboundingbox to the selected SRS for the layer and */
-    /* check if it overlaps the bbox that we calculated for the request */
-
-    msProjectRect(&(map->latlon), &(lp->projection), &ext);
-    if (!msRectOverlap(&bbox, &ext)) {
-      /* No overlap... nothing to do */
-
-      msFreeWmsParamsObj(&sThisWMSParams);
-      return MS_SUCCESS;  /* No overlap. */
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * check to see if a the metadata wms_connectiontimeout is set. If it is
-   * the case we will use it, else we use the default which is 30 seconds.
-   * First check the metadata in the layer object and then in the map object.
-   * ------------------------------------------------------------------ */
-  nTimeout = 30;  /* Default is 30 seconds  */
-  if ((pszTmp = msOWSLookupMetadata2(&(lp->metadata), &(map->web.metadata),
-                                    "MO", "connectiontimeout")) != NULL) {
-    nTimeout = atoi(pszTmp);
-  }
-
-  /* ------------------------------------------------------------------
-   * Check if we want to use in memory images instead of writing to disk.
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "cache_to_disk")) != NULL) {
-    if( strcasecmp(pszTmp,"true") == 0
-        || strcasecmp(pszTmp,"on") == 0
-        || strcasecmp(pszTmp,"yes") == 0 )
-      bCacheToDisk = MS_TRUE;
-    else
-      bCacheToDisk = atoi(pszTmp);
-  } else
-    bCacheToDisk = MS_FALSE;
-
-  if( bCacheToDisk ) {
-    /* We'll store the remote server's response to a tmp file. */
-    if (map->web.imagepath == NULL || strlen(map->web.imagepath) == 0) {
-      msSetError(MS_WMSERR,
-                 "WEB.IMAGEPATH must be set to use WMS client connections.",
-                 "msPrepareWMSLayerRequest()");
-      return MS_FAILURE;
-    }
-  }
-
-  /* ------------------------------------------------------------------
-   * Check if layer can be merged with previous WMS layer requests
-   * Metadata wms_force_separate_request can be set to 1 to prevent this
-   * this layer from being combined with any other layer.
-   * ------------------------------------------------------------------ */
-  bForceSeparateRequest = MS_FALSE;
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "force_separate_request")) != NULL) {
-    bForceSeparateRequest = atoi(pszTmp);
-  }
-  bOkToMerge = MS_FALSE;
-  if (!bForceSeparateRequest &&
-      lastconnectiontype == MS_WMS &&
-      psLastWMSParams != NULL &&
-      sThisWMSParams.numparams == psLastWMSParams->numparams &&
-      strcmp(sThisWMSParams.onlineresource,
-             psLastWMSParams->onlineresource) == 0) {
-    const char *key, *value1, *value2;
-    bOkToMerge = MS_TRUE;
-
-    key = msFirstKeyFromHashTable(sThisWMSParams.params);
-    while (key != NULL && bOkToMerge == MS_TRUE) {
-      /* Skip parameters whose values can be different */
-      if (!(strcmp(key, "LAYERS") == 0 ||
-            strcmp(key, "QUERY_LAYERS") == 0 ||
-            strcmp(key, "STYLES") == 0) ) {
-        value1 = msLookupHashTable(psLastWMSParams->params, key);
-        value2 = msLookupHashTable(sThisWMSParams.params, key);
-
-        if (value1==NULL || value2==NULL ||
-            strcmp(value1, value2) != 0) {
-          bOkToMerge = MS_FALSE;
-          break;
-        }
-      }
-      key = msNextKeyFromHashTable(sThisWMSParams.params, key);
-    }
-  }
-
-  /*------------------------------------------------------------------
-   * Check to see if there's a HTTP Cookie to forward
-   * If Cookie differ between the two connection, it's NOT OK to merge
-   * the connection
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
-        pszHTTPCookieData = msStrdup(pszTmp);
-      }
-    } else {
-      pszHTTPCookieData = msStrdup(pszTmp);
-    }
-  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata),
-                       "MO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
-        pszHTTPCookieData = msStrdup(pszTmp);
-      }
-    } else {
-      pszHTTPCookieData = msStrdup(pszTmp);
-    }
-  }
-
-  if(bOkToMerge && pszHTTPCookieData != sThisWMSParams.httpcookiedata) {
-    if(pszHTTPCookieData == NULL || sThisWMSParams.httpcookiedata == NULL) {
-      bOkToMerge = MS_FALSE;
-    }
-    else if(strcmp(pszHTTPCookieData, sThisWMSParams.httpcookiedata) != 0) {
-      bOkToMerge = MS_FALSE;
-    }
-  }
-
-  if (bOkToMerge) {
-    /* Merge both requests into sThisWMSParams
-     */
-    const char *value1, *value2;
-    char *keys[] = {"LAYERS", "QUERY_LAYERS", "STYLES"};
-    int i;
-
-    for(i=0; i<3; i++) {
-      value1 = msLookupHashTable(psLastWMSParams->params, keys[i]);
-      value2 = msLookupHashTable(sThisWMSParams.params, keys[i]);
-      if (value1 && value2) {
-        char *pszBuf;
-        int nLen;
-
-        nLen = strlen(value1) + strlen(value2) +2;
-        pszBuf = malloc(nLen);
-        MS_CHECK_ALLOC(pszBuf, nLen, MS_FAILURE);
-
-        snprintf(pszBuf, nLen, "%s,%s", value1, value2);
-        /* TODO should really send the server request version here */
-        msSetWMSParamString(&sThisWMSParams, keys[i], pszBuf,MS_FALSE, OWS_VERSION_NOTSET);
-
-        /* This key existed already, we don't want it counted twice */
-        sThisWMSParams.numparams--;
-
-        msFree(pszBuf);
-      }
-    }
-  }
-
-
-  /* ------------------------------------------------------------------
-   * Build new request URL
-   * ------------------------------------------------------------------ */
-  pszURL = msBuildURLFromWMSParams(&sThisWMSParams);
-
-  if (bOkToMerge && (*numRequests)>0) {
-    /* ------------------------------------------------------------------
-     * Update the last request in the array:  (*numRequests)-1
-     * ------------------------------------------------------------------ */
-    msFree(pasReqInfo[(*numRequests)-1].pszGetUrl);
-    pasReqInfo[(*numRequests)-1].pszGetUrl = pszURL;
-    pszURL = NULL;
-    pasReqInfo[(*numRequests)-1].debug |= lp->debug;
-    if (nTimeout > pasReqInfo[(*numRequests)-1].nTimeout)
-      pasReqInfo[(*numRequests)-1].nTimeout = nTimeout;
-  } else {
-    /* ------------------------------------------------------------------
-     * Add a request to the array (already preallocated)
-     * ------------------------------------------------------------------ */
-    pasReqInfo[(*numRequests)].nLayerId = nLayerId;
-    pasReqInfo[(*numRequests)].pszGetUrl = pszURL;
-
-    pszURL = NULL;
-    pasReqInfo[(*numRequests)].pszHTTPCookieData = pszHTTPCookieData;
-    pszHTTPCookieData = NULL;
-    if( bCacheToDisk ) {
-      pasReqInfo[(*numRequests)].pszOutputFile =
-        msTmpFile(map, map->mappath, NULL, "wms.tmp");
-    } else
-      pasReqInfo[(*numRequests)].pszOutputFile = NULL;
-    pasReqInfo[(*numRequests)].nStatus = 0;
-    pasReqInfo[(*numRequests)].nTimeout = nTimeout;
-    pasReqInfo[(*numRequests)].bbox   = bbox;
-    pasReqInfo[(*numRequests)].width  = bbox_width;
-    pasReqInfo[(*numRequests)].height = bbox_height;
-    pasReqInfo[(*numRequests)].debug = lp->debug;
-
-    if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata),
-                             pasReqInfo, *numRequests, map, "MO") != MS_SUCCESS)
-      return MS_FAILURE;
-
-    (*numRequests)++;
-  }
-
-
-  /* ------------------------------------------------------------------
-   * Replace contents of psLastWMSParams with sThisWMSParams
-   * unless bForceSeparateRequest is set in which case we make it empty
-   * ------------------------------------------------------------------ */
-  if (psLastWMSParams) {
-    msFreeWmsParamsObj(psLastWMSParams);
-    if (!bForceSeparateRequest)
-      *psLastWMSParams = sThisWMSParams;
-    else
-      msInitWmsParamsObj(psLastWMSParams);
-  } else {
-    /* Can't copy it, so we just free it */
-    msFreeWmsParamsObj(&sThisWMSParams);
-  }
-
-  return MS_SUCCESS;
-
-#else
-  /* ------------------------------------------------------------------
-   * WMS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
-             "msDrawWMSLayer()");
-  return(MS_FAILURE);
-
-#endif /* USE_WMS_LYR */
-
-}
-
-/**********************************************************************
- *                          msDrawWMSLayerLow()
- *
- **********************************************************************/
-
-int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo,
-                      int numRequests, mapObj *map, layerObj *lp, imageObj *img)
-{
-#ifdef USE_WMS_LYR
-  int status = MS_SUCCESS;
-  int iReq = -1;
-  char szPath[MS_MAXPATHLEN];
-  int currenttype;
-  int currentconnectiontype;
-  int numclasses;
-  char *mem_filename = NULL;
-  const char *pszTmp;
-  int bIsEssential = MS_FALSE;
-
-  /* ------------------------------------------------------------------
-   * Sometimes a requested layer is essential for the map, so if the
-   * request fails or an error is delivered, the map has not to be drawn
-   * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "essential")) != NULL) {
-    if( strcasecmp(pszTmp,"true") == 0
-        || strcasecmp(pszTmp,"on") == 0
-        || strcasecmp(pszTmp,"yes") == 0 )
-      bIsEssential = MS_TRUE;
-    else
-      bIsEssential = atoi(pszTmp);      
-  }
-
-  /* ------------------------------------------------------------------
-   * Find the request info for this layer in the array, based on nLayerId
-   * ------------------------------------------------------------------ */
-  for(iReq=0; iReq<numRequests; iReq++) {
-    if (pasReqInfo[iReq].nLayerId == nLayerId)
-      break;
-  }
-
-  if (iReq == numRequests) {
-    /* This layer was skipped or was included in a multi-layers
-     * request ... nothing to do.
-     */
-    return MS_SUCCESS;
-  }
-
-  if ( !MS_HTTP_SUCCESS( pasReqInfo[iReq].nStatus ) ) {
-    /* ====================================================================
-          Failed downloading layer... we log an error but we still return
-          SUCCESS here so that the layer is only skipped instead of aborting
-          the whole draw map.
-          If the layer is essential the map is not to be drawn.
-     ==================================================================== */
-    msSetError(MS_WMSERR,
-               "WMS GetMap request failed for layer '%s' (Status %d: %s).",
-               "msDrawWMSLayerLow()",
-               (lp->name?lp->name:"(null)"),
-               pasReqInfo[iReq].nStatus, pasReqInfo[iReq].pszErrBuf );
-
-    if (!bIsEssential)
-      return MS_SUCCESS;
-    else
-      return MS_FAILURE;
-  }
-
-  /* ------------------------------------------------------------------
-   * Check the Content-Type of the response to see if we got an exception,
-   * if yes then try to parse it and pass the info to msSetError().
-   * We log an error but we still return SUCCESS here so that the layer
-   * is only skipped instead of aborting the whole draw map.
-   * If the layer is essential the map is not to be drawn.
-   * ------------------------------------------------------------------ */
-  if (pasReqInfo[iReq].pszContentType &&
-      (strcmp(pasReqInfo[iReq].pszContentType, "text/xml") == 0 ||
-       strcmp(pasReqInfo[iReq].pszContentType, "application/vnd.ogc.se_xml") == 0)) {
-    FILE *fp;
-    char szBuf[MS_BUFFER_LENGTH];
-
-    if( pasReqInfo[iReq].pszOutputFile ) {
-      fp = fopen(pasReqInfo[iReq].pszOutputFile, "r");
-      if (fp) {
-        /* TODO: For now we'll only read the first chunk and return it
-         * via msSetError()... we should really try to parse the XML
-         * and extract the exception code/message though
-         */
-        size_t nSize;
-
-        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH-1, fp);
-        if (nSize < MS_BUFFER_LENGTH)
-          szBuf[nSize] = '\0';
-        else {
-          strlcpy(szBuf, "(!!!)", sizeof(szBuf)); /* This should never happen */
-        }
-
-        fclose(fp);
-
-        /* We're done with the remote server's response... delete it. */
-        if (!lp->debug)
-          unlink(pasReqInfo[iReq].pszOutputFile);
-      } else {
-        strlcpy(szBuf, "(Failed to open exception response)", sizeof(szBuf));
-      }
-    } else {
-      strlcpy( szBuf, pasReqInfo[iReq].result_data, MS_BUFFER_LENGTH );
-    }
-
-    if (lp->debug)
-      msDebug("WMS GetMap request got XML exception for layer '%s': %s.",
-              (lp->name?lp->name:"(null)"), szBuf );
-
-    msSetError(MS_WMSERR,
-               "WMS GetMap request got XML exception for layer '%s': %s.",
-               "msDrawWMSLayerLow()",
-               (lp->name?lp->name:"(null)"), szBuf );
-
-    if (!bIsEssential)
-      return MS_SUCCESS;
-    else
-      return MS_FAILURE;
-  }
-
-  /* ------------------------------------------------------------------
-   * If the output was written to a memory buffer, then we will need
-   * to attach a "VSI" name to this buffer.
-   * ------------------------------------------------------------------ */
-  if( pasReqInfo[iReq].pszOutputFile == NULL ) {
-    mem_filename = msTmpFile(map, NULL, "/vsimem/msout/", "img.tmp" );
-
-    VSIFCloseL(
-      VSIFileFromMemBuffer( mem_filename,
-                            (GByte*) pasReqInfo[iReq].result_data,
-                            (vsi_l_offset) pasReqInfo[iReq].result_size,
-                            FALSE ) );
-  }
-
-  /* ------------------------------------------------------------------
-   * Prepare layer for drawing, reprojecting the image received from the
-   * server if needed...
-   * ------------------------------------------------------------------ */
-  /* keep the current type that will be restored at the end of this  */
-  /* function. */
-  currenttype = lp->type;
-  currentconnectiontype = lp->connectiontype;
-  lp->type = MS_LAYER_RASTER;
-  lp->connectiontype = MS_SHAPEFILE;
-
-  /* set the classes to 0 so that It won't do client side */
-  /* classification if an sld was set. */
-  numclasses = lp->numclasses;
-
-  /* ensure the file connection is closed right away after the layer */
-  /* is rendered */
-  msLayerSetProcessingKey( lp, "CLOSE_CONNECTION", "NORMAL");
-
-  if (msOWSLookupMetadata(&(lp->metadata), "MO", "sld_body") ||
-      msOWSLookupMetadata(&(lp->metadata), "MO", "sld_url"))
-    lp->numclasses = 0;
-
-  if (lp->data) free(lp->data);
-  if( mem_filename != NULL )
-    lp->data = mem_filename;
-  else
-    lp->data =  msStrdup(pasReqInfo[iReq].pszOutputFile);
-
-  /* #3138 If PROCESSING "RESAMPLE=..." is set we cannot use the simple case */
-  if (!msProjectionsDiffer(&(map->projection), &(lp->projection)) &&
-      (msLayerGetProcessingKey(lp, "RESAMPLE") == NULL) ) {
-    /* The simple case... no reprojection needed... render layer directly. */
-    lp->transform = MS_FALSE;
-    /* if (msDrawRasterLayerLow(map, lp, img) != 0) */
-    /* status = MS_FAILURE; */
-    if (msDrawLayer(map, lp, img) != 0)
-      status = MS_FAILURE;
-  } else {
-    VSILFILE *fp;
-    char *wldfile;
-    /* OK, we have to resample the raster to map projection... */
-    lp->transform = MS_TRUE;
-    msLayerSetProcessingKey( lp, "LOAD_WHOLE_IMAGE", "YES" );
-
-    /* Create a world file with raster extents */
-    /* One line per value, in this order: cx, 0, 0, cy, ulx, uly */
-    wldfile = msBuildPath(szPath, lp->map->mappath, lp->data);
-    if (wldfile && (strlen(wldfile)>=3))
-      strcpy(wldfile+strlen(wldfile)-3, "wld");
-    if (wldfile && (fp = VSIFOpenL(wldfile, "wt")) != NULL) {
-      double dfCellSizeX = MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.minx,
-                                           pasReqInfo[iReq].bbox.maxx,
-                                           pasReqInfo[iReq].width);
-      double dfCellSizeY = MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.maxy,
-                                           pasReqInfo[iReq].bbox.miny,
-                                           pasReqInfo[iReq].height);
-      char world_text[5000];
-
-      sprintf( world_text, "%.12f\n0\n0\n%.12f\n%.12f\n%.12f\n",
-               dfCellSizeX,
-               dfCellSizeY,
-               pasReqInfo[iReq].bbox.minx + dfCellSizeX * 0.5,
-               pasReqInfo[iReq].bbox.maxy + dfCellSizeY * 0.5 );
-
-      VSIFWriteL( world_text, 1, strlen(world_text), fp );
-      VSIFCloseL( fp );
-
-      /* GDAL should be called to reproject automatically. */
-      if (msDrawLayer(map, lp, img) != 0)
-        status = MS_FAILURE;
-
-      if (!lp->debug || mem_filename != NULL)
-        VSIUnlink( wldfile );
-    } else {
-      msSetError(MS_WMSCONNERR,
-                 "Unable to create wld file for WMS slide.",
-                 "msDrawWMSLayer()");
-      status = MS_FAILURE;
-    }
-
-  }
-
-  /* We're done with the remote server's response... delete it. */
-  if (!lp->debug || mem_filename != NULL)
-    VSIUnlink(lp->data);
-
-  /* restore prveious type */
-  lp->type = currenttype;
-  lp->connectiontype = currentconnectiontype;
-
-  /* restore previous numclasses */
-  lp->numclasses = numclasses;
-
-  free(lp->data);
-  lp->data = NULL;
-
-  return status;
-
-#else
-  /* ------------------------------------------------------------------
-   * WMS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
-             "msDrawWMSLayer()");
-  return(MS_FAILURE);
-
-#endif /* USE_WMS_LYR */
-
-}
-
-
-int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX, int nClickY,
-                             int nFeatureCount, const char *pszInfoFormat, int type)
-{
-#ifdef USE_WMS_LYR
-
-  msIOContext *context;
-
-  httpRequestObj *pasReqInfo;
-  wmsParamsObj sLastWMSParams;
-  int i, numReq = 0;
-
-  pasReqInfo = (httpRequestObj *)msSmallMalloc((nOWSLayers+1)*sizeof(httpRequestObj));
-  msHTTPInitRequestObj(pasReqInfo, nOWSLayers+1);
-  msInitWmsParamsObj(&sLastWMSParams);
-
-  /* Generate the http request */
-  for (i=0; i<map->numlayers; i++) {
-    if (GET_LAYER(map,map->layerorder[i])->status == MS_ON) {
-      if (type == WMS_GETFEATUREINFO ) {
-        if( msPrepareWMSLayerRequest(map->layerorder[i], map, GET_LAYER(map,map->layerorder[i]),
-                                   WMS_GETFEATUREINFO,
-                                   MS_WMS, &sLastWMSParams,
-                                   nClickX, nClickY, nFeatureCount, pszInfoFormat,
-                                   pasReqInfo, &numReq) == MS_FAILURE) {
-          msFreeWmsParamsObj(&sLastWMSParams);
-          msFree(pasReqInfo);
-          return MS_FAILURE;
-        }
-      } else if (msPrepareWMSLayerRequest(map->layerorder[i], map, GET_LAYER(map,map->layerorder[i]),
-                                          WMS_GETLEGENDGRAPHIC,
-                                          MS_WMS, &sLastWMSParams,
-                                          0, 0, 0, NULL,
-                                          pasReqInfo, &numReq) == MS_FAILURE) {
-        msFreeWmsParamsObj(&sLastWMSParams);
-        msFree(pasReqInfo);
-        return MS_FAILURE;
-      }
-    }
-  }
-
-  if (msOWSExecuteRequests(pasReqInfo, numReq, map, MS_FALSE) == MS_FAILURE) {
-    msHTTPFreeRequestObj(pasReqInfo, numReq);
-    msFree(pasReqInfo);
-    msFreeWmsParamsObj(&sLastWMSParams);
-    return MS_FAILURE;
-  }
-
-  context = msIO_getHandler( stdout );
-  if( context == NULL ) {
-    msHTTPFreeRequestObj(pasReqInfo, numReq);
-    msFree(pasReqInfo);
-    msFreeWmsParamsObj(&sLastWMSParams);
-    return MS_FAILURE;
-  }
-
-  msIO_printf("Content-Type: %s%c%c",pasReqInfo[0].pszContentType, 10,10);
-
-  if( pasReqInfo[0].pszOutputFile ) {
-    FILE *fp;
-    char szBuf[MS_BUFFER_LENGTH];
-
-    fp = fopen(pasReqInfo[0].pszOutputFile, "r");
-    if (fp) {
-      while(1) {
-        size_t nSize;
-        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH-1, fp);
-        if (nSize > 0)
-          msIO_contextWrite( context,
-                             szBuf,
-                             nSize);
-        if (nSize != MS_BUFFER_LENGTH-1)
-          break;
-      }
-      fclose(fp);
-      if (!map->debug)
-        unlink(pasReqInfo[0].pszOutputFile);
-    } else {
-      msSetError(MS_IOERR, "'%s'.",
-                 "msWMSLayerExecuteRequest()", pasReqInfo[0].pszOutputFile);
-      return MS_FAILURE;
-    }
-  } else {
-    msIO_contextWrite( context,
-                       pasReqInfo[0].result_data,
-                       pasReqInfo[0].result_size );
-  }
-
-  msHTTPFreeRequestObj(pasReqInfo, numReq);
-  msFree(pasReqInfo);
-  msFreeWmsParamsObj(&sLastWMSParams);
-
-  return MS_SUCCESS;
-#else
-  /* ------------------------------------------------------------------
-   * WMS CONNECTION Support not included...
-   * ------------------------------------------------------------------ */
-  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
-             "msWMSLayerExecuteRequest()");
-  return(MS_FAILURE);
-
-#endif /* USE_WMS_LYR */
-
-}
diff -pruN 8.0.1-5/mapxbase.c 8.2.0~beta1-1~exp1/mapxbase.c
--- 8.0.1-5/mapxbase.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapxbase.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,915 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  .dbf access API.  Derived from shapelib, and relicensed with
- *           permission of Frank Warmerdam (shapelib author).
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include <stdlib.h> /* for atof() and atoi() */
-#include <math.h>
-
-#include "cpl_vsi.h"
-
-static inline void IGUR_sizet(size_t ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
-
-/************************************************************************/
-/*                             SfRealloc()                              */
-/*                                                                      */
-/*      A realloc cover function that will access a NULL pointer as     */
-/*      a valid input.                                                  */
-/************************************************************************/
-static void * SfRealloc( void * pMem, int nNewSize )
-
-{
-  return( (void *) realloc(pMem,nNewSize) );
-}
-
-/************************************************************************/
-/*                           writeHeader()                              */
-/*                                                                      */
-/*      This is called to write out the file header, and field          */
-/*      descriptions before writing any actual data records.  This      */
-/*      also computes all the DBFDataSet field offset/size/decimals     */
-/*      and so forth values.                                            */
-/************************************************************************/
-static void writeHeader(DBFHandle psDBF)
-
-{
-  uchar abyHeader[32];
-  int   i;
-
-  if( !psDBF->bNoHeader )
-    return;
-
-  psDBF->bNoHeader = MS_FALSE;
-
-  /* -------------------------------------------------------------------- */
-  /*  Initialize the file header information.               */
-  /* -------------------------------------------------------------------- */
-  for( i = 0; i < 32; i++ )
-    abyHeader[i] = 0;
-
-  abyHeader[0] = 0x03;    /* memo field? - just copying   */
-
-  /* date updated on close, record count preset at zero */
-
-  abyHeader[8] = psDBF->nHeaderLength % 256;
-  abyHeader[9] = psDBF->nHeaderLength / 256;
-
-  abyHeader[10] = psDBF->nRecordLength % 256;
-  abyHeader[11] = psDBF->nRecordLength / 256;
-
-  /* -------------------------------------------------------------------- */
-  /*      Write the initial 32 byte file header, and all the field        */
-  /*      descriptions.                                             */
-  /* -------------------------------------------------------------------- */
-  VSIFSeekL( psDBF->fp, 0, 0 );
-  VSIFWriteL( abyHeader, 32, 1, psDBF->fp );
-  VSIFWriteL( psDBF->pszHeader, 32, psDBF->nFields, psDBF->fp );
-
-  /* -------------------------------------------------------------------- */
-  /*      Write out the newline character if there is room for it.        */
-  /* -------------------------------------------------------------------- */
-  if( psDBF->nHeaderLength > 32*psDBF->nFields + 32 ) {
-    char  cNewline;
-
-    cNewline = 0x0d;
-    VSIFWriteL( &cNewline, 1, 1, psDBF->fp );
-  }
-}
-
-/************************************************************************/
-/*                           flushRecord()                              */
-/*                                                                      */
-/*      Write out the current record if there is one.                   */
-/************************************************************************/
-static void flushRecord( DBFHandle psDBF )
-
-{
-  unsigned int nRecordOffset;
-
-  if( psDBF->bCurrentRecordModified && psDBF->nCurrentRecord > -1 ) {
-    psDBF->bCurrentRecordModified = MS_FALSE;
-
-    nRecordOffset = psDBF->nRecordLength * psDBF->nCurrentRecord
-                    + psDBF->nHeaderLength;
-
-    VSIFSeekL( psDBF->fp, nRecordOffset, 0 );
-    VSIFWriteL( psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp );
-  }
-}
-
-DBFHandle msDBFOpenVirtualFile( VSILFILE * fp )
-{
-  DBFHandle   psDBF;
-  uchar   *pabyBuf;
-  int     nFields, nHeadLen, nRecLen, iField;
-
-  /* -------------------------------------------------------------------- */
-  /*      Open the file.                                                  */
-  /* -------------------------------------------------------------------- */
-  psDBF = (DBFHandle) calloc( 1, sizeof(DBFInfo) );
-  MS_CHECK_ALLOC(psDBF, sizeof(DBFInfo), NULL);
-  psDBF->fp = fp;
-
-  psDBF->bNoHeader = MS_FALSE;
-  psDBF->nCurrentRecord = -1;
-  psDBF->bCurrentRecordModified = MS_FALSE;
-
-  psDBF->pszStringField = NULL;
-  psDBF->nStringFieldLen = 0;
-
-  /* -------------------------------------------------------------------- */
-  /*  Read Table Header info                                              */
-  /* -------------------------------------------------------------------- */
-  pabyBuf = (uchar *) msSmallMalloc(500);
-  if( VSIFReadL( pabyBuf, 32, 1, psDBF->fp ) != 1 )
-  {
-    VSIFCloseL( psDBF->fp );
-    msFree(psDBF);
-    msFree(pabyBuf);
-    return( NULL );
-  }
-
-  if( pabyBuf[7] < 128 )
-      psDBF->nRecords = pabyBuf[4] + pabyBuf[5]*256 + pabyBuf[6]*256*256 + pabyBuf[7]*256*256*256;
-  else
-      psDBF->nRecords = 0;
-
-  psDBF->nHeaderLength = nHeadLen = pabyBuf[8] + pabyBuf[9]*256;
-  psDBF->nRecordLength = nRecLen = pabyBuf[10] + pabyBuf[11]*256;
-
-  if (nHeadLen <= 32) {
-    VSIFCloseL( psDBF->fp );
-    msFree(psDBF);
-    msFree(pabyBuf);
-    return( NULL );
-  }
-
-  psDBF->nFields = nFields = (nHeadLen - 32) / 32;
-
-  psDBF->pszCurrentRecord = (char *) msSmallMalloc(nRecLen);
-
-  /* -------------------------------------------------------------------- */
-  /*  Read in Field Definitions                                           */
-  /* -------------------------------------------------------------------- */
-  pabyBuf = (uchar *) SfRealloc(pabyBuf,nHeadLen);
-  psDBF->pszHeader = (char *) pabyBuf;
-
-  VSIFSeekL( psDBF->fp, 32, 0 );
-  if( VSIFReadL( pabyBuf, nHeadLen - 32, 1, psDBF->fp ) != 1 )
-  {
-    msFree(psDBF->pszCurrentRecord);
-    VSIFCloseL( psDBF->fp );
-    msFree(psDBF);
-    msFree(pabyBuf);
-    return( NULL );
-  }
-
-  psDBF->panFieldOffset = (int *) msSmallMalloc(sizeof(int) * nFields);
-  psDBF->panFieldSize = (int *) msSmallMalloc(sizeof(int) * nFields);
-  psDBF->panFieldDecimals = (int *) msSmallMalloc(sizeof(int) * nFields);
-  psDBF->pachFieldType = (char *) msSmallMalloc(sizeof(char) * nFields);
-
-  for( iField = 0; iField < nFields; iField++ ) {
-    uchar   *pabyFInfo;
-
-    pabyFInfo = pabyBuf+iField*32;
-
-    if( pabyFInfo[11] == 'N' || pabyFInfo[11] == 'F' ) {
-      psDBF->panFieldSize[iField] = pabyFInfo[16];
-      psDBF->panFieldDecimals[iField] = pabyFInfo[17];
-    } else {
-      psDBF->panFieldSize[iField] = pabyFInfo[16] + pabyFInfo[17]*256;
-      psDBF->panFieldDecimals[iField] = 0;
-    }
-
-    psDBF->pachFieldType[iField] = (char) pabyFInfo[11];
-    if( iField == 0 )
-      psDBF->panFieldOffset[iField] = 1;
-    else
-      psDBF->panFieldOffset[iField] =
-        psDBF->panFieldOffset[iField-1] + psDBF->panFieldSize[iField-1];
-  }
-
-  return( psDBF );
-}
-
-/************************************************************************/
-/*                              msDBFOpen()                             */
-/*                                                                      */
-/*      Open a .dbf file.                                               */
-/************************************************************************/
-DBFHandle msDBFOpen( const char * pszFilename, const char * pszAccess )
-
-{
-  /* -------------------------------------------------------------------- */
-  /*      We only allow the access strings "rb" and "r+".                 */
-  /* -------------------------------------------------------------------- */
-  if( strcmp(pszAccess,"r") != 0 && strcmp(pszAccess,"r+") != 0
-      && strcmp(pszAccess,"rb") != 0 && strcmp(pszAccess,"r+b") != 0 )
-    return( NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*  Ensure the extension is converted to dbf or DBF if it is      */
-  /*  currently .shp or .shx.               */
-  /* -------------------------------------------------------------------- */
-  char *pszDBFFilename = (char *) msSmallMalloc(strlen(pszFilename)+1);
-  strcpy( pszDBFFilename, pszFilename );
-
-  if( strcmp(pszFilename+strlen(pszFilename)-4,".shp") == 0
-      || strcmp(pszFilename+strlen(pszFilename)-4,".shx") == 0 ) {
-    strcpy( pszDBFFilename+strlen(pszDBFFilename)-4, ".dbf");
-  } else if( strcmp(pszFilename+strlen(pszFilename)-4,".SHP") == 0
-             || strcmp(pszFilename+strlen(pszFilename)-4,".SHX") == 0 ) {
-    strcpy( pszDBFFilename+strlen(pszDBFFilename)-4, ".DBF");
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Open the file.                                                  */
-  /* -------------------------------------------------------------------- */
-  VSILFILE *fp = VSIFOpenL( pszDBFFilename, pszAccess );
-  if( fp == NULL )
-  {
-    if( strcmp(pszDBFFilename+strlen(pszDBFFilename)-4,".dbf") == 0 ) {
-      strcpy( pszDBFFilename+strlen(pszDBFFilename)-4, ".DBF");
-      fp = VSIFOpenL( pszDBFFilename, pszAccess );
-    }
-  }
-  msFree(pszDBFFilename);
-  if( fp == NULL ) {
-    return( NULL );
-  }
-
-  return msDBFOpenVirtualFile(fp);
-}
-
-/************************************************************************/
-/*                              msDBFClose()                            */
-/************************************************************************/
-
-void  msDBFClose(DBFHandle psDBF)
-{
-  /* -------------------------------------------------------------------- */
-  /*      Write out header if not already written.                        */
-  /* -------------------------------------------------------------------- */
-  if( psDBF->bNoHeader )
-    writeHeader( psDBF );
-
-  flushRecord( psDBF );
-
-  /* -------------------------------------------------------------------- */
-  /*      Update last access date, and number of records if we have       */
-  /*  write access.                             */
-  /* -------------------------------------------------------------------- */
-  if( psDBF->bUpdated ) {
-    uchar   abyFileHeader[32];
-
-    VSIFSeekL( psDBF->fp, 0, 0 );
-    IGUR_sizet(VSIFReadL( abyFileHeader, 32, 1, psDBF->fp ));
-
-    abyFileHeader[1] = 95;      /* YY */
-    abyFileHeader[2] = 7;     /* MM */
-    abyFileHeader[3] = 26;      /* DD */
-
-    abyFileHeader[4] = psDBF->nRecords % 256;
-    abyFileHeader[5] = (psDBF->nRecords/256) % 256;
-    abyFileHeader[6] = (psDBF->nRecords/(256*256)) % 256;
-    abyFileHeader[7] = (psDBF->nRecords/(256*256*256)) % 256;
-
-    VSIFSeekL( psDBF->fp, 0, 0 );
-    VSIFWriteL( abyFileHeader, 32, 1, psDBF->fp );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Close, and free resources.                                      */
-  /* -------------------------------------------------------------------- */
-  VSIFCloseL( psDBF->fp );
-
-  if( psDBF->panFieldOffset != NULL ) {
-    free( psDBF->panFieldOffset );
-    free( psDBF->panFieldSize );
-    free( psDBF->panFieldDecimals );
-    free( psDBF->pachFieldType );
-  }
-
-  free( psDBF->pszHeader );
-  free( psDBF->pszCurrentRecord );
-
-  free(psDBF->pszStringField);
-
-  free( psDBF );
-}
-
-/************************************************************************/
-/*                             msDBFCreate()                            */
-/*                                                                      */
-/*      Create a new .dbf file.                                         */
-/************************************************************************/
-DBFHandle msDBFCreate( const char * pszFilename )
-
-{
-  DBFHandle psDBF;
-  VSILFILE  *fp;
-
-  /* -------------------------------------------------------------------- */
-  /*      Create the file.                                                */
-  /* -------------------------------------------------------------------- */
-  fp = VSIFOpenL( pszFilename, "wb" );
-  if( fp == NULL )
-    return( NULL );
-
-  {
-      char ch = 0;
-      VSIFWriteL(&ch, 1, 1, fp);
-  }
-  VSIFCloseL( fp );
-
-  fp = VSIFOpenL( pszFilename, "rb+" );
-  if( fp == NULL )
-    return( NULL );
-
-  /* -------------------------------------------------------------------- */
-  /*  Create the info structure.                */
-  /* -------------------------------------------------------------------- */
-  psDBF = (DBFHandle) malloc(sizeof(DBFInfo));
-  if (psDBF == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDBFCreate()",
-               __FILE__, __LINE__, (unsigned int)sizeof(DBFInfo));
-    VSIFCloseL(fp);
-    return NULL;
-  }
-
-  psDBF->fp = fp;
-  psDBF->nRecords = 0;
-  psDBF->nFields = 0;
-  psDBF->nRecordLength = 1;
-  psDBF->nHeaderLength = 33;
-
-  psDBF->panFieldOffset = NULL;
-  psDBF->panFieldSize = NULL;
-  psDBF->panFieldDecimals = NULL;
-  psDBF->pachFieldType = NULL;
-  psDBF->pszHeader = NULL;
-
-  psDBF->nCurrentRecord = -1;
-  psDBF->bCurrentRecordModified = MS_FALSE;
-  psDBF->pszCurrentRecord = NULL;
-
-  psDBF->pszStringField = NULL;
-  psDBF->nStringFieldLen = 0;
-
-  psDBF->bNoHeader = MS_TRUE;
-  psDBF->bUpdated = MS_FALSE;
-
-  return( psDBF );
-}
-
-/************************************************************************/
-/*                            msDBFAddField()                           */
-/*                                                                      */
-/*      Add a field to a newly created .dbf file before any records     */
-/*      are written.                                                    */
-/************************************************************************/
-int msDBFAddField(DBFHandle psDBF, const char * pszFieldName, DBFFieldType eType, int nWidth, int nDecimals )
-{
-  char  *pszFInfo;
-  int   i;
-
-  /* -------------------------------------------------------------------- */
-  /*      Do some checking to ensure we can add records to this file.     */
-  /* -------------------------------------------------------------------- */
-  if( psDBF->nRecords > 0 )
-    return( MS_FALSE );
-
-  if( !psDBF->bNoHeader )
-    return( MS_FALSE );
-
-  if( eType != FTDouble && nDecimals != 0 )
-    return( MS_FALSE );
-
-  /* -------------------------------------------------------------------- */
-  /*      SfRealloc all the arrays larger to hold the additional field    */
-  /*      information.                                                    */
-  /* -------------------------------------------------------------------- */
-  psDBF->nFields++;
-
-  psDBF->panFieldOffset = (int *)
-                          SfRealloc( psDBF->panFieldOffset, sizeof(int) * psDBF->nFields );
-
-  psDBF->panFieldSize = (int *)
-                        SfRealloc( psDBF->panFieldSize, sizeof(int) * psDBF->nFields );
-
-  psDBF->panFieldDecimals = (int *)
-                            SfRealloc( psDBF->panFieldDecimals, sizeof(int) * psDBF->nFields );
-
-  psDBF->pachFieldType = (char *)
-                         SfRealloc( psDBF->pachFieldType, sizeof(char) * psDBF->nFields );
-
-  /* -------------------------------------------------------------------- */
-  /*      Assign the new field information fields.                        */
-  /* -------------------------------------------------------------------- */
-  psDBF->panFieldOffset[psDBF->nFields-1] = psDBF->nRecordLength;
-  psDBF->nRecordLength += nWidth;
-  psDBF->panFieldSize[psDBF->nFields-1] = nWidth;
-  psDBF->panFieldDecimals[psDBF->nFields-1] = nDecimals;
-
-  if( eType == FTString )
-    psDBF->pachFieldType[psDBF->nFields-1] = 'C';
-  else
-    psDBF->pachFieldType[psDBF->nFields-1] = 'N';
-
-  /* -------------------------------------------------------------------- */
-  /*      Extend the required header information.                         */
-  /* -------------------------------------------------------------------- */
-  psDBF->nHeaderLength += 32;
-  psDBF->bUpdated = MS_FALSE;
-
-  psDBF->pszHeader = (char *) SfRealloc(psDBF->pszHeader,psDBF->nFields*32);
-
-  pszFInfo = psDBF->pszHeader + 32 * (psDBF->nFields-1);
-
-  for( i = 0; i < 32; i++ )
-    pszFInfo[i] = '\0';
-
-  strncpy( pszFInfo, pszFieldName, 10);
-
-  pszFInfo[11] = psDBF->pachFieldType[psDBF->nFields-1];
-
-  if( eType == FTString ) {
-    pszFInfo[16] = nWidth % 256;
-    pszFInfo[17] = nWidth / 256;
-  } else {
-    pszFInfo[16] = nWidth;
-    pszFInfo[17] = nDecimals;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Make the current record buffer appropriately larger.            */
-  /* -------------------------------------------------------------------- */
-  psDBF->pszCurrentRecord = (char *) SfRealloc(psDBF->pszCurrentRecord,
-                            psDBF->nRecordLength);
-
-  return( psDBF->nFields-1 );
-}
-
-/************************************************************************/
-/*                         DBFIsValueNULL()                             */
-/*                                                                      */
-/*      Return TRUE if value is NULL (in DBF terms).                    */
-/*                                                                      */
-/*      Based on DBFIsAttributeNULL of shapelib                         */
-/************************************************************************/
-
-static int DBFIsValueNULL( const char* pszValue, char type )
-
-{
-  switch(type) {
-    case 'N':
-    case 'F':
-      /* NULL numeric fields have value "****************" */
-      return pszValue[0] == '*';
-
-    case 'D':
-      /* NULL date fields have value "00000000" */
-      return strncmp(pszValue,"00000000",8) == 0;
-
-    case 'L':
-      /* NULL boolean fields have value "?" */
-      return pszValue[0] == '?';
-
-    default:
-      /* empty string fields are considered NULL */
-      return strlen(pszValue) == 0;
-  }
-}
-
-/************************************************************************/
-/*                          msDBFReadAttribute()                        */
-/*                                                                      */
-/*      Read one of the attribute fields of a record.                   */
-/************************************************************************/
-static const char *msDBFReadAttribute(DBFHandle psDBF, int hEntity, int iField )
-
-{
-  int         i;
-  unsigned int nRecordOffset;
-  const uchar *pabyRec;
-  const char  *pReturnField = NULL;
-
-  /* -------------------------------------------------------------------- */
-  /*  Is the request valid?                             */
-  /* -------------------------------------------------------------------- */
-  if( iField < 0 || iField >= psDBF->nFields ) {
-    msSetError(MS_DBFERR, "Invalid field index %d.", "msDBFReadAttribute()",iField );
-    return( NULL );
-  }
-
-  if( hEntity < 0 || hEntity >= psDBF->nRecords ) {
-    msSetError(MS_DBFERR, "Invalid record number %d.", "msDBFReadAttribute()",hEntity );
-    return( NULL );
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Have we read the record?              */
-  /* -------------------------------------------------------------------- */
-  if( psDBF->nCurrentRecord != hEntity ) {
-    flushRecord( psDBF );
-
-    nRecordOffset = psDBF->nRecordLength * hEntity + psDBF->nHeaderLength;
-
-    VSIFSeekL( psDBF->fp, nRecordOffset, 0 );
-    if( VSIFReadL( psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp ) != 1 )
-    {
-      msSetError(MS_DBFERR, "Cannot read record %d.", "msDBFReadAttribute()",hEntity );
-      return( NULL );
-    }
-
-    psDBF->nCurrentRecord = hEntity;
-  }
-
-  pabyRec = (const uchar *) psDBF->pszCurrentRecord;
-  /* DEBUG */
-  /* printf("CurrentRecord(%c):%s\n", psDBF->pachFieldType[iField], pabyRec); */
-
-  /* -------------------------------------------------------------------- */
-  /*  Ensure our field buffer is large enough to hold this buffer.      */
-  /* -------------------------------------------------------------------- */
-  if( psDBF->panFieldSize[iField]+1 > psDBF->nStringFieldLen ) {
-    psDBF->nStringFieldLen = psDBF->panFieldSize[iField]*2 + 10;
-    psDBF->pszStringField = (char *) SfRealloc(psDBF->pszStringField,psDBF->nStringFieldLen);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Extract the requested field.              */
-  /* -------------------------------------------------------------------- */
-  strncpy( psDBF->pszStringField,(const char *) pabyRec+psDBF->panFieldOffset[iField], psDBF->panFieldSize[iField] );
-  psDBF->pszStringField[psDBF->panFieldSize[iField]] = '\0';
-
-  /*
-  ** Trim trailing blanks (SDL Modification)
-  */
-  for(i=strlen(psDBF->pszStringField)-1; i>=0; i--) {
-    if(psDBF->pszStringField[i] != ' ') {
-      psDBF->pszStringField[i+1] = '\0';
-      break;
-    }
-  }
-
-  if(i == -1) psDBF->pszStringField[0] = '\0'; /* whole string is blank (SDL fix)       */
-
-  /*
-  ** Trim/skip leading blanks (SDL/DM Modification - only on numeric types)
-  */
-  if( psDBF->pachFieldType[iField] == 'N' || psDBF->pachFieldType[iField] == 'F' || psDBF->pachFieldType[iField] == 'D' ) {
-    for(i=0; psDBF->pszStringField[i] != '\0' ; i++) {
-      if(psDBF->pszStringField[i] != ' ')
-        break;
-    }
-    pReturnField = psDBF->pszStringField+i;
-  } else
-    pReturnField = psDBF->pszStringField;
-
-  /*  detect null values */
-  if ( DBFIsValueNULL( pReturnField, psDBF->pachFieldType[iField] )  ) {
-    if (psDBF->pachFieldType[iField] == 'N' || psDBF->pachFieldType[iField] == 'F' || psDBF->pachFieldType[iField] == 'D')
-      pReturnField="0";
-  }
-  return( pReturnField );
-}
-
-/************************************************************************/
-/*                        msDBFReadIntAttribute()                       */
-/*                                                                      */
-/*      Read an integer attribute.                                      */
-/************************************************************************/
-int msDBFReadIntegerAttribute( DBFHandle psDBF, int iRecord, int iField )
-
-{
-  return(atoi(msDBFReadAttribute( psDBF, iRecord, iField )));
-}
-
-/************************************************************************/
-/*                        msDBFReadDoubleAttribute()                    */
-/*                                                                      */
-/*      Read a double attribute.                                        */
-/************************************************************************/
-double  msDBFReadDoubleAttribute( DBFHandle psDBF, int iRecord, int iField )
-{
-  return(atof(msDBFReadAttribute( psDBF, iRecord, iField )));
-}
-
-/************************************************************************/
-/*                        msDBFReadStringAttribute()                      */
-/*                                                                      */
-/*      Read a string attribute.                                        */
-/************************************************************************/
-const char *msDBFReadStringAttribute( DBFHandle psDBF, int iRecord, int iField )
-{
-  return( msDBFReadAttribute( psDBF, iRecord, iField ) );
-}
-
-/************************************************************************/
-/*                          msDBFGetFieldCount()                        */
-/*                                                                      */
-/*      Return the number of fields in this table.                      */
-/************************************************************************/
-int msDBFGetFieldCount( DBFHandle psDBF )
-{
-  return( psDBF->nFields );
-}
-
-/************************************************************************/
-/*                         msDBFGetRecordCount()                        */
-/*                                                                      */
-/*      Return the number of records in this table.                     */
-/************************************************************************/
-int msDBFGetRecordCount( DBFHandle psDBF )
-{
-  return( psDBF->nRecords );
-}
-
-/************************************************************************/
-/*                          msDBFGetFieldInfo()                         */
-/*                                                                      */
-/*      Return any requested information about the field.               */
-/************************************************************************/
-DBFFieldType msDBFGetFieldInfo( DBFHandle psDBF, int iField, char * pszFieldName, int * pnWidth, int * pnDecimals )
-{
-  if( iField < 0 || iField >= psDBF->nFields )
-    return( FTInvalid );
-
-  if( pnWidth != NULL )
-    *pnWidth = psDBF->panFieldSize[iField];
-
-  if( pnDecimals != NULL )
-    *pnDecimals = psDBF->panFieldDecimals[iField];
-
-  if( pszFieldName != NULL ) {
-    int i;
-
-    strncpy( pszFieldName, (char *) psDBF->pszHeader+iField*32, 11 );
-    pszFieldName[11] = '\0';
-    for( i = 10; i > 0 && pszFieldName[i] == ' '; i-- )
-      pszFieldName[i] = '\0';
-  }
-
-  if( psDBF->pachFieldType[iField] == 'N'
-      || psDBF->pachFieldType[iField] == 'F'
-      || psDBF->pachFieldType[iField] == 'D' ) {
-    if( psDBF->panFieldDecimals[iField] > 0 )
-      return( FTDouble );
-    else
-      return( FTInteger );
-  } else {
-    return( FTString );
-  }
-}
-
-/************************************************************************/
-/*                         msDBFWriteAttribute()                        */
-/*                  */
-/*  Write an attribute record to the file.        */
-/************************************************************************/
-static int msDBFWriteAttribute(DBFHandle psDBF, int hEntity, int iField, void * pValue )
-{
-  unsigned int          nRecordOffset;
-  int  len;
-  uchar *pabyRec;
-  char  szSField[40];
-
-  /* -------------------------------------------------------------------- */
-  /*  Is this a valid record?             */
-  /* -------------------------------------------------------------------- */
-  if( hEntity < 0 || hEntity > psDBF->nRecords )
-    return( MS_FALSE );
-
-  if( psDBF->bNoHeader )
-    writeHeader(psDBF);
-
-  /* -------------------------------------------------------------------- */
-  /*      Is this a brand new record?                                     */
-  /* -------------------------------------------------------------------- */
-  if( hEntity == psDBF->nRecords ) {
-    flushRecord( psDBF );
-
-    psDBF->nRecords++;
-    for( unsigned i = 0; i < psDBF->nRecordLength; i++ )
-      psDBF->pszCurrentRecord[i] = ' ';
-
-    psDBF->nCurrentRecord = hEntity;
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Is this an existing record, but different than the last one     */
-  /*      we accessed?                                                    */
-  /* -------------------------------------------------------------------- */
-  if( psDBF->nCurrentRecord != hEntity ) {
-    flushRecord( psDBF );
-
-    nRecordOffset = psDBF->nRecordLength * hEntity + psDBF->nHeaderLength;
-
-    VSIFSeekL( psDBF->fp, nRecordOffset, 0 );
-    if( VSIFReadL( psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp ) != 1 )
-      return MS_FALSE;
-
-    psDBF->nCurrentRecord = hEntity;
-  }
-
-  pabyRec = (uchar *) psDBF->pszCurrentRecord;
-
-  /* -------------------------------------------------------------------- */
-  /*      Assign all the record fields.                                   */
-  /* -------------------------------------------------------------------- */
-  switch( psDBF->pachFieldType[iField] ) {
-    case 'D':
-    case 'N':
-    case 'F':
-      snprintf(szSField, sizeof(szSField), "%*.*f", psDBF->panFieldSize[iField], psDBF->panFieldDecimals[iField], *(double*) pValue); 
-      len = strlen((char *) szSField);
-      memcpy(pabyRec+psDBF->panFieldOffset[iField], szSField, MS_MIN(len, psDBF->panFieldSize[iField]));
-      break;
-
-    default:
-      len = strlen((char *) pValue);
-      memcpy(pabyRec+psDBF->panFieldOffset[iField], pValue, MS_MIN(len, psDBF->panFieldSize[iField]));
-      break;
-  }
-
-  psDBF->bCurrentRecordModified = MS_TRUE;
-  psDBF->bUpdated = MS_TRUE;
-
-  return( MS_TRUE );
-}
-
-/************************************************************************/
-/*                      msDBFWriteDoubleAttribute()                     */
-/*                                                                      */
-/*      Write a double attribute.                                       */
-/************************************************************************/
-int msDBFWriteDoubleAttribute( DBFHandle psDBF, int iRecord, int iField, double dValue )
-{
-  return( msDBFWriteAttribute( psDBF, iRecord, iField, (void *) &dValue ) );
-}
-
-/************************************************************************/
-/*                      msDBFWriteIntegerAttribute()                    */
-/*                                                                      */
-/*      Write a integer attribute.                                      */
-/************************************************************************/
-
-int msDBFWriteIntegerAttribute( DBFHandle psDBF, int iRecord, int iField, int nValue )
-{
-  double  dValue = nValue;
-
-  return( msDBFWriteAttribute( psDBF, iRecord, iField, (void *) &dValue ) );
-}
-
-/************************************************************************/
-/*                      msDBFWriteStringAttribute()                     */
-/*                                                                      */
-/*      Write a string attribute.                                       */
-/************************************************************************/
-int msDBFWriteStringAttribute( DBFHandle psDBF, int iRecord, int iField, const char * pszValue )
-{
-  return( msDBFWriteAttribute( psDBF, iRecord, iField, (void *) pszValue ) );
-}
-
-/*
-** Which column number in the .DBF file does the item correspond to
-*/
-int msDBFGetItemIndex(DBFHandle dbffile, char *name)
-{
-  int i;
-  int fWidth,fnDecimals; /* field width and number of decimals */
-  char fName[32]; /* field name */
-
-  if(!name) {
-    msSetError(MS_MISCERR, "NULL item name passed.", "msGetItemIndex()");
-    return(-1);
-  }
-
-  /* does name exist as a field? */
-  for(i=0; i<msDBFGetFieldCount(dbffile); i++) {
-    msDBFGetFieldInfo(dbffile,i,fName,&fWidth,&fnDecimals);
-    if(strcasecmp(name,fName) == 0) /* found it */
-      return(i);
-  }
-
-  msSetError(MS_DBFERR, "Item '%s' not found.", "msDBFGetItemIndex()",name);
-  return(-1); /* item not found */
-}
-
-/*
-** Load item names into a character array
-*/
-char **msDBFGetItems(DBFHandle dbffile)
-{
-  char **items;
-  int i, nFields;
-  char fName[32];
-
-  if((nFields = msDBFGetFieldCount(dbffile)) == 0) {
-    msSetError(MS_DBFERR, "File contains no data.", "msGetDBFItems()");
-    return(NULL);
-  }
-
-  items = (char **)malloc(sizeof(char *)*nFields);
-  MS_CHECK_ALLOC(items, sizeof(char *)*nFields, NULL);
-
-  for(i=0; i<nFields; i++) {
-    msDBFGetFieldInfo(dbffile, i, fName, NULL, NULL);
-    items[i] = msStrdup(fName);
-  }
-
-  return(items);
-}
-
-/*
-** Load item values into a character array
-*/
-char **msDBFGetValues(DBFHandle dbffile, int record)
-{
-  char **values;
-  int i, nFields;
-
-  if((nFields = msDBFGetFieldCount(dbffile)) == 0) {
-    msSetError(MS_DBFERR, "File contains no data.", "msGetDBFValues()");
-    return(NULL);
-  }
-
-  values = (char **)malloc(sizeof(char *)*nFields);
-  MS_CHECK_ALLOC(values, sizeof(char *)*nFields, NULL);
-
-  for(i=0; i<nFields; i++)
-    values[i] = msStrdup(msDBFReadStringAttribute(dbffile, record, i));
-
-  return(values);
-}
-
-int *msDBFGetItemIndexes(DBFHandle dbffile, char **items, int numitems)
-{
-  int *itemindexes=NULL, i;
-
-  if(numitems == 0) return(NULL);
-
-  itemindexes = (int *)malloc(sizeof(int)*numitems);
-  MS_CHECK_ALLOC(itemindexes, sizeof(int)*numitems, NULL);
-
-  for(i=0; i<numitems; i++) {
-    itemindexes[i] = msDBFGetItemIndex(dbffile, items[i]);
-    if(itemindexes[i] == -1) {
-      free(itemindexes);
-      return(NULL); /* item not found */
-    }
-  }
-
-  return(itemindexes);
-}
-
-char **msDBFGetValueList(DBFHandle dbffile, int record, int *itemindexes, int numitems)
-{
-  const char *value;
-  char **values=NULL;
-  int i;
-
-  if(numitems == 0) return(NULL);
-
-  values = (char **)malloc(sizeof(char *)*numitems);
-  MS_CHECK_ALLOC(values, sizeof(char *)*numitems, NULL);
-
-  for(i=0; i<numitems; i++) {
-    value = msDBFReadStringAttribute(dbffile, record, itemindexes[i]);
-    if (value == NULL) {
-      free(values);
-      return NULL; /* Error already reported by msDBFReadStringAttribute() */
-    }
-    values[i] = msStrdup(value);
-  }
-
-  return(values);
-}
diff -pruN 8.0.1-5/mapxml.c 8.2.0~beta1-1~exp1/mapxml.c
--- 8.0.1-5/mapxml.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapxml.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,89 +0,0 @@
-/******************************************************************************
- * $id: mapfile.c 7854 2008-08-14 19:22:48Z dmorissette $
- *
- * Project:  MapServer
- * Purpose:  High level Map file parsing code.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-#include "mapserver.h"
-
-#ifdef USE_XMLMAPFILE
-
-#include <libxslt/xslt.h>
-#include "libexslt/exslt.h"
-#include <libxslt/transform.h>
-#include <libxslt/xsltInternals.h>
-#include <libxslt/extensions.h>
-#include <libxslt/xsltutils.h>
-
-extern int xmlLoadExtDtdDefaultValue;
-
-int msTransformXmlMapfile(const char *stylesheet, const char *xmlMapfile, FILE *tmpfile)
-{
-  xsltStylesheetPtr cur = NULL;
-  int status = MS_FAILURE;
-  xmlDocPtr doc = NULL, res = NULL;
-
-  exsltRegisterAll();
-  xsltRegisterTestModule();
-
-  xmlSubstituteEntitiesDefault(1);
-  xmlLoadExtDtdDefaultValue = 1;
-
-  cur = xsltParseStylesheetFile((const xmlChar *)stylesheet);
-  if (cur == NULL) {
-    msSetError(MS_MISCERR, "Failed to load xslt stylesheet", "msTransformXmlMapfile()");
-    goto done;
-  }
-
-  doc = xmlParseFile(xmlMapfile);
-  if (doc == NULL) {
-    msSetError(MS_MISCERR, "Failed to load xml mapfile", "msTransformXmlMapfile()");
-    goto done;
-  }
-
-  res = xsltApplyStylesheet(cur, doc, NULL);
-  if (res == NULL) {
-    msSetError(MS_MISCERR, "Failed to apply style sheet to %s", "msTransformXmlMapfile()", xmlMapfile);
-    goto done;
-  }
-
-  if ( xsltSaveResultToFile(tmpfile, res, cur) != -1 )
-    status =  MS_SUCCESS;
-
-done:
-  if (cur)
-    xsltFreeStylesheet(cur);
-  if (res)
-    xmlFreeDoc(res);
-  if (doc)
-    xmlFreeDoc(doc);
-
-  xsltCleanupGlobals();
-  xmlCleanupParser();
-
-  return status;
-}
-
-#endif
diff -pruN 8.0.1-5/mapxmp.c 8.2.0~beta1-1~exp1/mapxmp.c
--- 8.0.1-5/mapxmp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/mapxmp.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,295 +0,0 @@
-/******************************************************************************
- * $Id: mapchart.c 11880 2011-07-07 19:51:37Z sdlime $
- *
- * Project:  MapServer
- * Purpose:  XMP embedded image metadata (MS-RFC-7X)
- * Author:   Paul Ramsey <pramsey@opengeo.org>
- *
- ******************************************************************************
- * Copyright (c) 1996-2007 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-#ifdef USE_EXEMPI
-
-/* To pull parts out of hash keys */
-#include <regex.h>
-
-/* To write the XMP XML into the files */
-#include <xmp.h>
-#include <xmpconsts.h>
-
-/**
-* Get standard Exempi namespace URI for a given namespace string
-*/
-static const char*
-msXmpUri(char *ns_name)
-{
-  /* Creative Commons */
-  if( strcmp(ns_name, "cc") == 0 )
-    return NS_CC;
-  /* Dublin Core */
-  else if( strcmp(ns_name, "dc") == 0 )
-    return NS_DC;
-  /* XMP Meta */
-  else if( strcmp(ns_name, "meta") == 0 )
-    return NS_XMP_META;
-  /* XMP Rights */
-  else if( strcmp(ns_name, "rights") == 0 )
-    return NS_XAP_RIGHTS;
-  /* EXIF */
-  else if( strcmp(ns_name, "exif") == 0 )
-    return NS_EXIF;
-  /* TIFF */
-  else if( strcmp(ns_name, "tiff") == 0 )
-    return NS_TIFF;
-  /* Photoshop Camera Raw Schema */
-  else if( strcmp(ns_name, "crs") == 0 )
-    return NS_CAMERA_RAW_SETTINGS;
-  /* Photoshop */
-  else if( strcmp(ns_name, "photoshop") == 0 )
-    return NS_PHOTOSHOP;
-  else
-    return NULL;
-}
-
-#endif
-
-/**
-* Is there any XMP metadata in the map file for us to worry about?
-*/
-int
-msXmpPresent( mapObj *map )
-{
-#ifdef USE_EXEMPI
-
-  /* Read the WEB.METADATA */
-  hashTableObj hash_metadata = map->web.metadata;
-  const char *key = NULL;
-  int rv = MS_FALSE;
-
-  /* Check all the keys for "xmp_" start pattern */
-  key = msFirstKeyFromHashTable(&hash_metadata);
-
-  /* No first key? No license info. */
-  if ( ! key )
-    return MS_FALSE;
-
-  do {
-    /* Found one! Break out and return true */
-    if ( strcasestr(key, "xmp_") == key ) {
-      rv = MS_TRUE;
-      break;
-    }
-  } while( (key = msNextKeyFromHashTable(&hash_metadata, key)) );
-
-  return rv;
-
-#else
-  return MS_FALSE;
-#endif
-}
-
-
-/**
-* Is there any XMP metadata in the map file for us to worry about?
-*/
-int
-msXmpWrite( mapObj *map, const char *filename )
-{
-#ifdef USE_EXEMPI
-
-  /* Should hold our keys */
-  hashTableObj hash_metadata = map->web.metadata;
-  /* Temporary place for custom name spaces */
-  hashTableObj hash_ns;
-  /* We use regex to strip out the namespace and XMP key value from the metadata key */
-  regex_t xmp_regex;
-  const char *xmp_ns_str = "^xmp_(.+)_namespace$";
-  const char *xmp_tag_str = "^xmp_(.+)_(.+)$";
-  const char *key = NULL;
-  static int regflags = REG_ICASE | REG_EXTENDED;
-
-  /* XMP object and file pointers */
-  XmpPtr xmp;
-  XmpFilePtr f;
-
-  /* Force the hash table to empty */
-  hash_ns.numitems = 0;
-
-  /* Prepare XMP library */
-  xmp_init();
-  f = xmp_files_open_new(filename, XMP_OPEN_FORUPDATE);
-  if ( ! f ) {
-    msSetError( MS_MISCERR,
-                "Unable to open temporary file '%s' to write XMP info",
-                "msXmpWrite()", filename );
-    return MS_FAILURE;
-  }
-
-  /* Create a new XMP structure if the file doesn't already have one */
-  xmp = xmp_files_get_new_xmp(f);
-  if ( xmp == NULL )
-    xmp = xmp_new_empty();
-
-  /* Check we can write to the file */
-  if ( ! xmp_files_can_put_xmp(f, xmp) ) {
-    msSetError( MS_MISCERR,
-                "Unable to write XMP information to '%s'",
-                "msXmpWrite()", filename );
-    return MS_FAILURE;
-  }
-
-  /* Compile our "xmp_*_namespace" regex */
-  if ( regcomp(&xmp_regex, xmp_ns_str, regflags) ) {
-    msSetError( MS_MISCERR,
-                "Unable compile regex '%s'",
-                "msXmpWrite()", xmp_ns_str );
-    return MS_FAILURE;
-  }
-
-  /* Check all the keys for "xmp_*_namespace" pattern */
-  initHashTable(&hash_ns);
-  key = msFirstKeyFromHashTable(&hash_metadata);
-
-  /* No first key? No license info. We shouldn't get here. */
-  if ( ! key )
-    return MS_SUCCESS;
-
-  do {
-    /* Our regex has one match slot */
-    regmatch_t matches[2];
-
-    /* Found a custom namespace entry! Store it for later. */
-    if ( 0 == regexec(&xmp_regex, key, 2, matches, 0) ) {
-      size_t ns_size = 0;
-      char *ns_name = NULL;
-      const char *ns_uri;
-
-      /* Copy in the namespace name */
-      ns_size = matches[1].rm_eo - matches[1].rm_so;
-      ns_name = msSmallMalloc(ns_size + 1);
-      memcpy(ns_name, key + matches[1].rm_so, ns_size);
-      ns_name[ns_size] = 0; /* null terminate */
-
-      /* Copy in the namespace uri */
-      ns_uri = msLookupHashTable(&hash_metadata, key);
-      msInsertHashTable(&hash_ns, ns_name, ns_uri);
-      xmp_register_namespace(ns_uri, ns_name, NULL);
-      msFree(ns_name);
-    }
-  } while( (key = msNextKeyFromHashTable(&hash_metadata, key)) );
-  /* Clean up regex */
-  regfree(&xmp_regex);
-
-
-  /* Compile our "xmp_*_*" regex */
-  if ( regcomp(&xmp_regex, xmp_tag_str, regflags) ) {
-    msFreeHashItems(&hash_ns);
-    msSetError( MS_MISCERR,
-                "Unable compile regex '%s'",
-                "msXmpWrite()", xmp_tag_str );
-    return MS_FAILURE;
-  }
-
-  /* Check all the keys for "xmp_*_*" pattern */
-  key = msFirstKeyFromHashTable(&hash_metadata);
-  for( ; key != NULL; key = msNextKeyFromHashTable(&hash_metadata, key) ) {
-    /* Our regex has two match slots */
-    regmatch_t matches[3];
-
-    /* Found a namespace entry! Write it into XMP. */
-    if ( 0 == regexec(&xmp_regex, key, 3, matches, 0) ) {
-      /* Get the namespace and tag name */
-      size_t ns_name_size = matches[1].rm_eo - matches[1].rm_so;
-      size_t ns_tag_size = matches[2].rm_eo - matches[2].rm_so;
-      char *ns_name = msSmallMalloc(ns_name_size + 1);
-      char *ns_tag = msSmallMalloc(ns_tag_size + 1);
-      const char *ns_uri = NULL;
-      memcpy(ns_name, key + matches[1].rm_so, ns_name_size);
-      memcpy(ns_tag, key + matches[2].rm_so, ns_tag_size);
-      ns_name[ns_name_size] = 0; /* null terminate */
-      ns_tag[ns_tag_size] = 0; /* null terminate */
-
-      if ( strcmp(ns_tag,"namespace") == 0 ) {
-        msFree(ns_name);
-        msFree(ns_tag);
-        continue;
-      }
-
-      /* If this is a default name space?... */
-      if ( (ns_uri = msXmpUri(ns_name)) ) {
-        xmp_register_namespace(ns_uri, ns_name, NULL);
-        xmp_set_property(xmp, ns_uri, ns_tag, msLookupHashTable(&hash_metadata, key), 0);
-      }
-      /* Or maybe it's a custom one?... */
-      else if ( (ns_uri = msLookupHashTable(&hash_ns, ns_name)) ) {
-        xmp_set_property(xmp, ns_uri, ns_tag, msLookupHashTable(&hash_metadata, key), 0);
-      }
-      /* Or perhaps we're screwed. */
-      else {
-        msSetError( MS_MISCERR,
-                    "Unable to identify XMP namespace '%s' in metadata key '%s'",
-                    "msXmpWrite()", ns_name, key );
-        msFreeHashItems(&hash_ns);
-        msFree(ns_name);
-        msFree(ns_tag);
-        return MS_FAILURE;
-      }
-      msFree(ns_name);
-      msFree(ns_tag);
-    }
-  }
-
-  /* Clean up regex */
-  regfree(&xmp_regex);
-
-  /* Write out the XMP */
-  if ( !xmp_files_put_xmp(f, xmp) ) {
-    msFreeHashItems(&hash_ns);
-    msSetError( MS_MISCERR,
-                "Unable to execute '%s' on pointer %p",
-                "msXmpWrite()", "xmp_files_put_xmp", f );
-    return MS_FAILURE;
-  }
-
-  /* Write out the file and flush */
-  if ( !xmp_files_close(f, XMP_CLOSE_SAFEUPDATE) ) {
-    msFreeHashItems(&hash_ns);
-    msSetError( MS_MISCERR,
-                "Unable to execute '%s' on pointer %p",
-                "msXmpWrite()", "xmp_files_close", f );
-    return MS_FAILURE;
-  }
-
-  msFreeHashItems(&hash_ns);
-  xmp_free(xmp);
-  xmp_terminate();
-
-  return MS_SUCCESS;
-
-#else
-  return MS_FAILURE;
-#endif
-}
-
diff -pruN 8.0.1-5/msencrypt.c 8.2.0~beta1-1~exp1/msencrypt.c
--- 8.0.1-5/msencrypt.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/msencrypt.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,79 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Command-line encryption utility (see MS-RFC-18)
- * Author:   Daniel Morissette
- *
- ******************************************************************************
- * Copyright (c) 1996-2006 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-void PrintUsage()
-{
-  printf("Usage: msencrypt <-keygen filename>|<-key filename string_to_encrypt>\n");
-}
-
-int main(int argc, char *argv[])
-{
-
-  if (argc == 3 && strcmp(argv[1], "-keygen")==0) {
-
-    /* TODO: Move this to a function */
-    unsigned char pabyKey[16];
-    char szKeyEncoded[50];
-    FILE *fp;
-    msGenerateEncryptionKey(pabyKey);
-    msHexEncode(pabyKey, szKeyEncoded, 16);
-
-    if ((fp = fopen(argv[2], "wt")) != NULL) {
-      fprintf(fp, "%s\n", szKeyEncoded);
-      fclose(fp);
-    } else {
-      printf("ERROR: Failed writing to %s\n", argv[2]);
-      return -1;
-    }
-  } else if (argc == 4 && strcmp(argv[1], "-key")==0) {
-    unsigned char key[16];
-    char *pszBuf;
-
-    if (msReadEncryptionKeyFromFile(argv[2], key) != MS_SUCCESS) {
-      printf("ERROR: Failed reading key from file %s\n", argv[2]);
-      return -1;
-    }
-
-    pszBuf = (char*)malloc((strlen(argv[3])*2+17)*sizeof(char));
-    MS_CHECK_ALLOC(pszBuf, (strlen(argv[3])*2+17)*sizeof(char), -1);
-
-    msEncryptStringWithKey(key, argv[3], pszBuf);
-
-    printf("%s\n", pszBuf);
-    msFree(pszBuf);
-  } else {
-    PrintUsage();
-  }
-
-  return 0;
-}
diff -pruN 8.0.1-5/opengl/glext.h 8.2.0~beta1-1~exp1/opengl/glext.h
--- 8.0.1-5/opengl/glext.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/opengl/glext.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,6569 +0,0 @@
-#ifndef __glext_h_
-#define __glext_h_
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-  /******************************************************************************
-
-   Copyright NVIDIA Corporation 2005
-
-   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
-   *AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
-   OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
-   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL
-   NVIDIA OR ITS SUPPLIERS BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR
-   CONSEQUENTIAL DAMAGES WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR
-   LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION,
-   OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE OF OR INABILITY TO USE
-   THIS SOFTWARE, EVEN IF NVIDIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
-   DAMAGES.
-
-  ******************************************************************************/
-
-  /*
-  ** License Applicability. Except to the extent portions of this file are
-  ** made subject to an alternative license as permitted in the SGI Free
-  ** Software License B, Version 1.1 (the "License"), the contents of this
-  ** file are subject only to the provisions of the License. You may not use
-  ** this file except in compliance with the License. You may obtain a copy
-  ** of the License at Silicon Graphics, Inc., attn: Legal Services, 1600
-  ** Amphitheatre Parkway, Mountain View, CA 94043-1351, or at:
-  **
-  ** http://oss.sgi.com/projects/FreeB
-  **
-  ** Note that, as provided in the License, the Software is distributed on an
-  ** "AS IS" basis, with ALL EXPRESS AND IMPLIED WARRANTIES AND CONDITIONS
-  ** DISCLAIMED, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES AND
-  ** CONDITIONS OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A
-  ** PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
-  **
-  ** Original Code. The Original Code is: OpenGL Sample Implementation,
-  ** Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
-  ** Inc. The Original Code is Copyright (c) 1991-2004 Silicon Graphics, Inc.
-  ** Copyright in any portions created by third parties is as indicated
-  ** elsewhere herein. All Rights Reserved.
-  **
-  ** Additional Notice Provisions: This software was created using the
-  ** OpenGL(R) version 1.2.1 Sample Implementation published by SGI, but has
-  ** not been independently verified as being compliant with the OpenGL(R)
-  ** version 1.2.1 Specification.
-  */
-
-#if defined(_WIN32) && !defined(APIENTRY) && !defined(__CYGWIN__) && !defined(__SCITECH_SNAP__)
-#define WIN32_LEAN_AND_MEAN 1
-#include <windows.h>
-#endif
-
-#ifndef APIENTRY
-#define APIENTRY
-#endif
-#ifndef APIENTRYP
-#define APIENTRYP APIENTRY *
-#endif
-#ifndef GLAPI
-#define GLAPI extern
-#endif
-
-  /*************************************************************/
-
-  /* Header file version number, required by OpenGL ABI for Linux */
-  /* glext.h last updated 2005/06/06 */
-  /* Current version at http://oss.sgi.com/projects/ogl-sample/registry/ */
-#define GL_GLEXT_VERSION 28
-
-#ifndef GL_VERSION_1_2
-#define GL_UNSIGNED_BYTE_3_3_2            0x8032
-#define GL_UNSIGNED_SHORT_4_4_4_4         0x8033
-#define GL_UNSIGNED_SHORT_5_5_5_1         0x8034
-#define GL_UNSIGNED_INT_8_8_8_8           0x8035
-#define GL_UNSIGNED_INT_10_10_10_2        0x8036
-#define GL_RESCALE_NORMAL                 0x803A
-#define GL_TEXTURE_BINDING_3D             0x806A
-#define GL_PACK_SKIP_IMAGES               0x806B
-#define GL_PACK_IMAGE_HEIGHT              0x806C
-#define GL_UNPACK_SKIP_IMAGES             0x806D
-#define GL_UNPACK_IMAGE_HEIGHT            0x806E
-#define GL_TEXTURE_3D                     0x806F
-#define GL_PROXY_TEXTURE_3D               0x8070
-#define GL_TEXTURE_DEPTH                  0x8071
-#define GL_TEXTURE_WRAP_R                 0x8072
-#define GL_MAX_3D_TEXTURE_SIZE            0x8073
-#define GL_UNSIGNED_BYTE_2_3_3_REV        0x8362
-#define GL_UNSIGNED_SHORT_5_6_5           0x8363
-#define GL_UNSIGNED_SHORT_5_6_5_REV       0x8364
-#define GL_UNSIGNED_SHORT_4_4_4_4_REV     0x8365
-#define GL_UNSIGNED_SHORT_1_5_5_5_REV     0x8366
-#define GL_UNSIGNED_INT_8_8_8_8_REV       0x8367
-#define GL_UNSIGNED_INT_2_10_10_10_REV    0x8368
-#define GL_BGR                            0x80E0
-#define GL_BGRA                           0x80E1
-#define GL_MAX_ELEMENTS_VERTICES          0x80E8
-#define GL_MAX_ELEMENTS_INDICES           0x80E9
-#define GL_CLAMP_TO_EDGE                  0x812F
-#define GL_TEXTURE_MIN_LOD                0x813A
-#define GL_TEXTURE_MAX_LOD                0x813B
-#define GL_TEXTURE_BASE_LEVEL             0x813C
-#define GL_TEXTURE_MAX_LEVEL              0x813D
-#define GL_LIGHT_MODEL_COLOR_CONTROL      0x81F8
-#define GL_SINGLE_COLOR                   0x81F9
-#define GL_SEPARATE_SPECULAR_COLOR        0x81FA
-#define GL_SMOOTH_POINT_SIZE_RANGE        0x0B12
-#define GL_SMOOTH_POINT_SIZE_GRANULARITY  0x0B13
-#define GL_SMOOTH_LINE_WIDTH_RANGE        0x0B22
-#define GL_SMOOTH_LINE_WIDTH_GRANULARITY  0x0B23
-#define GL_ALIASED_POINT_SIZE_RANGE       0x846D
-#define GL_ALIASED_LINE_WIDTH_RANGE       0x846E
-#endif
-
-#ifndef GL_ARB_imaging
-#define GL_CONSTANT_COLOR                 0x8001
-#define GL_ONE_MINUS_CONSTANT_COLOR       0x8002
-#define GL_CONSTANT_ALPHA                 0x8003
-#define GL_ONE_MINUS_CONSTANT_ALPHA       0x8004
-#define GL_BLEND_COLOR                    0x8005
-#define GL_FUNC_ADD                       0x8006
-#define GL_MIN                            0x8007
-#define GL_MAX                            0x8008
-#define GL_BLEND_EQUATION                 0x8009
-#define GL_FUNC_SUBTRACT                  0x800A
-#define GL_FUNC_REVERSE_SUBTRACT          0x800B
-#define GL_CONVOLUTION_1D                 0x8010
-#define GL_CONVOLUTION_2D                 0x8011
-#define GL_SEPARABLE_2D                   0x8012
-#define GL_CONVOLUTION_BORDER_MODE        0x8013
-#define GL_CONVOLUTION_FILTER_SCALE       0x8014
-#define GL_CONVOLUTION_FILTER_BIAS        0x8015
-#define GL_REDUCE                         0x8016
-#define GL_CONVOLUTION_FORMAT             0x8017
-#define GL_CONVOLUTION_WIDTH              0x8018
-#define GL_CONVOLUTION_HEIGHT             0x8019
-#define GL_MAX_CONVOLUTION_WIDTH          0x801A
-#define GL_MAX_CONVOLUTION_HEIGHT         0x801B
-#define GL_POST_CONVOLUTION_RED_SCALE     0x801C
-#define GL_POST_CONVOLUTION_GREEN_SCALE   0x801D
-#define GL_POST_CONVOLUTION_BLUE_SCALE    0x801E
-#define GL_POST_CONVOLUTION_ALPHA_SCALE   0x801F
-#define GL_POST_CONVOLUTION_RED_BIAS      0x8020
-#define GL_POST_CONVOLUTION_GREEN_BIAS    0x8021
-#define GL_POST_CONVOLUTION_BLUE_BIAS     0x8022
-#define GL_POST_CONVOLUTION_ALPHA_BIAS    0x8023
-#define GL_HISTOGRAM                      0x8024
-#define GL_PROXY_HISTOGRAM                0x8025
-#define GL_HISTOGRAM_WIDTH                0x8026
-#define GL_HISTOGRAM_FORMAT               0x8027
-#define GL_HISTOGRAM_RED_SIZE             0x8028
-#define GL_HISTOGRAM_GREEN_SIZE           0x8029
-#define GL_HISTOGRAM_BLUE_SIZE            0x802A
-#define GL_HISTOGRAM_ALPHA_SIZE           0x802B
-#define GL_HISTOGRAM_LUMINANCE_SIZE       0x802C
-#define GL_HISTOGRAM_SINK                 0x802D
-#define GL_MINMAX                         0x802E
-#define GL_MINMAX_FORMAT                  0x802F
-#define GL_MINMAX_SINK                    0x8030
-#define GL_TABLE_TOO_LARGE                0x8031
-#define GL_COLOR_MATRIX                   0x80B1
-#define GL_COLOR_MATRIX_STACK_DEPTH       0x80B2
-#define GL_MAX_COLOR_MATRIX_STACK_DEPTH   0x80B3
-#define GL_POST_COLOR_MATRIX_RED_SCALE    0x80B4
-#define GL_POST_COLOR_MATRIX_GREEN_SCALE  0x80B5
-#define GL_POST_COLOR_MATRIX_BLUE_SCALE   0x80B6
-#define GL_POST_COLOR_MATRIX_ALPHA_SCALE  0x80B7
-#define GL_POST_COLOR_MATRIX_RED_BIAS     0x80B8
-#define GL_POST_COLOR_MATRIX_GREEN_BIAS   0x80B9
-#define GL_POST_COLOR_MATRIX_BLUE_BIAS    0x80BA
-#define GL_POST_COLOR_MATRIX_ALPHA_BIAS   0x80BB
-#define GL_COLOR_TABLE                    0x80D0
-#define GL_POST_CONVOLUTION_COLOR_TABLE   0x80D1
-#define GL_POST_COLOR_MATRIX_COLOR_TABLE  0x80D2
-#define GL_PROXY_COLOR_TABLE              0x80D3
-#define GL_PROXY_POST_CONVOLUTION_COLOR_TABLE 0x80D4
-#define GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE 0x80D5
-#define GL_COLOR_TABLE_SCALE              0x80D6
-#define GL_COLOR_TABLE_BIAS               0x80D7
-#define GL_COLOR_TABLE_FORMAT             0x80D8
-#define GL_COLOR_TABLE_WIDTH              0x80D9
-#define GL_COLOR_TABLE_RED_SIZE           0x80DA
-#define GL_COLOR_TABLE_GREEN_SIZE         0x80DB
-#define GL_COLOR_TABLE_BLUE_SIZE          0x80DC
-#define GL_COLOR_TABLE_ALPHA_SIZE         0x80DD
-#define GL_COLOR_TABLE_LUMINANCE_SIZE     0x80DE
-#define GL_COLOR_TABLE_INTENSITY_SIZE     0x80DF
-#define GL_CONSTANT_BORDER                0x8151
-#define GL_REPLICATE_BORDER               0x8153
-#define GL_CONVOLUTION_BORDER_COLOR       0x8154
-#endif
-
-#ifndef GL_VERSION_1_3
-#define GL_TEXTURE0                       0x84C0
-#define GL_TEXTURE1                       0x84C1
-#define GL_TEXTURE2                       0x84C2
-#define GL_TEXTURE3                       0x84C3
-#define GL_TEXTURE4                       0x84C4
-#define GL_TEXTURE5                       0x84C5
-#define GL_TEXTURE6                       0x84C6
-#define GL_TEXTURE7                       0x84C7
-#define GL_TEXTURE8                       0x84C8
-#define GL_TEXTURE9                       0x84C9
-#define GL_TEXTURE10                      0x84CA
-#define GL_TEXTURE11                      0x84CB
-#define GL_TEXTURE12                      0x84CC
-#define GL_TEXTURE13                      0x84CD
-#define GL_TEXTURE14                      0x84CE
-#define GL_TEXTURE15                      0x84CF
-#define GL_TEXTURE16                      0x84D0
-#define GL_TEXTURE17                      0x84D1
-#define GL_TEXTURE18                      0x84D2
-#define GL_TEXTURE19                      0x84D3
-#define GL_TEXTURE20                      0x84D4
-#define GL_TEXTURE21                      0x84D5
-#define GL_TEXTURE22                      0x84D6
-#define GL_TEXTURE23                      0x84D7
-#define GL_TEXTURE24                      0x84D8
-#define GL_TEXTURE25                      0x84D9
-#define GL_TEXTURE26                      0x84DA
-#define GL_TEXTURE27                      0x84DB
-#define GL_TEXTURE28                      0x84DC
-#define GL_TEXTURE29                      0x84DD
-#define GL_TEXTURE30                      0x84DE
-#define GL_TEXTURE31                      0x84DF
-#define GL_ACTIVE_TEXTURE                 0x84E0
-#define GL_CLIENT_ACTIVE_TEXTURE          0x84E1
-#define GL_MAX_TEXTURE_UNITS              0x84E2
-#define GL_TRANSPOSE_MODELVIEW_MATRIX     0x84E3
-#define GL_TRANSPOSE_PROJECTION_MATRIX    0x84E4
-#define GL_TRANSPOSE_TEXTURE_MATRIX       0x84E5
-#define GL_TRANSPOSE_COLOR_MATRIX         0x84E6
-#define GL_MULTISAMPLE                    0x809D
-#define GL_SAMPLE_ALPHA_TO_COVERAGE       0x809E
-#define GL_SAMPLE_ALPHA_TO_ONE            0x809F
-#define GL_SAMPLE_COVERAGE                0x80A0
-#define GL_SAMPLE_BUFFERS                 0x80A8
-#define GL_SAMPLES                        0x80A9
-#define GL_SAMPLE_COVERAGE_VALUE          0x80AA
-#define GL_SAMPLE_COVERAGE_INVERT         0x80AB
-#define GL_MULTISAMPLE_BIT                0x20000000
-#define GL_NORMAL_MAP                     0x8511
-#define GL_REFLECTION_MAP                 0x8512
-#define GL_TEXTURE_CUBE_MAP               0x8513
-#define GL_TEXTURE_BINDING_CUBE_MAP       0x8514
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_X    0x8515
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X    0x8516
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y    0x8517
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y    0x8518
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z    0x8519
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z    0x851A
-#define GL_PROXY_TEXTURE_CUBE_MAP         0x851B
-#define GL_MAX_CUBE_MAP_TEXTURE_SIZE      0x851C
-#define GL_COMPRESSED_ALPHA               0x84E9
-#define GL_COMPRESSED_LUMINANCE           0x84EA
-#define GL_COMPRESSED_LUMINANCE_ALPHA     0x84EB
-#define GL_COMPRESSED_INTENSITY           0x84EC
-#define GL_COMPRESSED_RGB                 0x84ED
-#define GL_COMPRESSED_RGBA                0x84EE
-#define GL_TEXTURE_COMPRESSION_HINT       0x84EF
-#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE  0x86A0
-#define GL_TEXTURE_COMPRESSED             0x86A1
-#define GL_NUM_COMPRESSED_TEXTURE_FORMATS 0x86A2
-#define GL_COMPRESSED_TEXTURE_FORMATS     0x86A3
-#define GL_CLAMP_TO_BORDER                0x812D
-#define GL_COMBINE                        0x8570
-#define GL_COMBINE_RGB                    0x8571
-#define GL_COMBINE_ALPHA                  0x8572
-#define GL_SOURCE0_RGB                    0x8580
-#define GL_SOURCE1_RGB                    0x8581
-#define GL_SOURCE2_RGB                    0x8582
-#define GL_SOURCE0_ALPHA                  0x8588
-#define GL_SOURCE1_ALPHA                  0x8589
-#define GL_SOURCE2_ALPHA                  0x858A
-#define GL_OPERAND0_RGB                   0x8590
-#define GL_OPERAND1_RGB                   0x8591
-#define GL_OPERAND2_RGB                   0x8592
-#define GL_OPERAND0_ALPHA                 0x8598
-#define GL_OPERAND1_ALPHA                 0x8599
-#define GL_OPERAND2_ALPHA                 0x859A
-#define GL_RGB_SCALE                      0x8573
-#define GL_ADD_SIGNED                     0x8574
-#define GL_INTERPOLATE                    0x8575
-#define GL_SUBTRACT                       0x84E7
-#define GL_CONSTANT                       0x8576
-#define GL_PRIMARY_COLOR                  0x8577
-#define GL_PREVIOUS                       0x8578
-#define GL_DOT3_RGB                       0x86AE
-#define GL_DOT3_RGBA                      0x86AF
-#endif
-
-#ifndef GL_VERSION_1_4
-#define GL_BLEND_DST_RGB                  0x80C8
-#define GL_BLEND_SRC_RGB                  0x80C9
-#define GL_BLEND_DST_ALPHA                0x80CA
-#define GL_BLEND_SRC_ALPHA                0x80CB
-#define GL_POINT_SIZE_MIN                 0x8126
-#define GL_POINT_SIZE_MAX                 0x8127
-#define GL_POINT_FADE_THRESHOLD_SIZE      0x8128
-#define GL_POINT_DISTANCE_ATTENUATION     0x8129
-#define GL_GENERATE_MIPMAP                0x8191
-#define GL_GENERATE_MIPMAP_HINT           0x8192
-#define GL_DEPTH_COMPONENT16              0x81A5
-#define GL_DEPTH_COMPONENT24              0x81A6
-#define GL_DEPTH_COMPONENT32              0x81A7
-#define GL_MIRRORED_REPEAT                0x8370
-#define GL_FOG_COORDINATE_SOURCE          0x8450
-#define GL_FOG_COORDINATE                 0x8451
-#define GL_FRAGMENT_DEPTH                 0x8452
-#define GL_CURRENT_FOG_COORDINATE         0x8453
-#define GL_FOG_COORDINATE_ARRAY_TYPE      0x8454
-#define GL_FOG_COORDINATE_ARRAY_STRIDE    0x8455
-#define GL_FOG_COORDINATE_ARRAY_POINTER   0x8456
-#define GL_FOG_COORDINATE_ARRAY           0x8457
-#define GL_COLOR_SUM                      0x8458
-#define GL_CURRENT_SECONDARY_COLOR        0x8459
-#define GL_SECONDARY_COLOR_ARRAY_SIZE     0x845A
-#define GL_SECONDARY_COLOR_ARRAY_TYPE     0x845B
-#define GL_SECONDARY_COLOR_ARRAY_STRIDE   0x845C
-#define GL_SECONDARY_COLOR_ARRAY_POINTER  0x845D
-#define GL_SECONDARY_COLOR_ARRAY          0x845E
-#define GL_MAX_TEXTURE_LOD_BIAS           0x84FD
-#define GL_TEXTURE_FILTER_CONTROL         0x8500
-#define GL_TEXTURE_LOD_BIAS               0x8501
-#define GL_INCR_WRAP                      0x8507
-#define GL_DECR_WRAP                      0x8508
-#define GL_TEXTURE_DEPTH_SIZE             0x884A
-#define GL_DEPTH_TEXTURE_MODE             0x884B
-#define GL_TEXTURE_COMPARE_MODE           0x884C
-#define GL_TEXTURE_COMPARE_FUNC           0x884D
-#define GL_COMPARE_R_TO_TEXTURE           0x884E
-#endif
-
-#ifndef GL_VERSION_1_5
-#define GL_BUFFER_SIZE                    0x8764
-#define GL_BUFFER_USAGE                   0x8765
-#define GL_QUERY_COUNTER_BITS             0x8864
-#define GL_CURRENT_QUERY                  0x8865
-#define GL_QUERY_RESULT                   0x8866
-#define GL_QUERY_RESULT_AVAILABLE         0x8867
-#define GL_ARRAY_BUFFER                   0x8892
-#define GL_ELEMENT_ARRAY_BUFFER           0x8893
-#define GL_ARRAY_BUFFER_BINDING           0x8894
-#define GL_ELEMENT_ARRAY_BUFFER_BINDING   0x8895
-#define GL_VERTEX_ARRAY_BUFFER_BINDING    0x8896
-#define GL_NORMAL_ARRAY_BUFFER_BINDING    0x8897
-#define GL_COLOR_ARRAY_BUFFER_BINDING     0x8898
-#define GL_INDEX_ARRAY_BUFFER_BINDING     0x8899
-#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING 0x889A
-#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING 0x889B
-#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING 0x889C
-#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING 0x889D
-#define GL_WEIGHT_ARRAY_BUFFER_BINDING    0x889E
-#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING 0x889F
-#define GL_READ_ONLY                      0x88B8
-#define GL_WRITE_ONLY                     0x88B9
-#define GL_READ_WRITE                     0x88BA
-#define GL_BUFFER_ACCESS                  0x88BB
-#define GL_BUFFER_MAPPED                  0x88BC
-#define GL_BUFFER_MAP_POINTER             0x88BD
-#define GL_STREAM_DRAW                    0x88E0
-#define GL_STREAM_READ                    0x88E1
-#define GL_STREAM_COPY                    0x88E2
-#define GL_STATIC_DRAW                    0x88E4
-#define GL_STATIC_READ                    0x88E5
-#define GL_STATIC_COPY                    0x88E6
-#define GL_DYNAMIC_DRAW                   0x88E8
-#define GL_DYNAMIC_READ                   0x88E9
-#define GL_DYNAMIC_COPY                   0x88EA
-#define GL_SAMPLES_PASSED                 0x8914
-#define GL_FOG_COORD_SRC                  GL_FOG_COORDINATE_SOURCE
-#define GL_FOG_COORD                      GL_FOG_COORDINATE
-#define GL_CURRENT_FOG_COORD              GL_CURRENT_FOG_COORDINATE
-#define GL_FOG_COORD_ARRAY_TYPE           GL_FOG_COORDINATE_ARRAY_TYPE
-#define GL_FOG_COORD_ARRAY_STRIDE         GL_FOG_COORDINATE_ARRAY_STRIDE
-#define GL_FOG_COORD_ARRAY_POINTER        GL_FOG_COORDINATE_ARRAY_POINTER
-#define GL_FOG_COORD_ARRAY                GL_FOG_COORDINATE_ARRAY
-#define GL_FOG_COORD_ARRAY_BUFFER_BINDING GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING
-#define GL_SRC0_RGB                       GL_SOURCE0_RGB
-#define GL_SRC1_RGB                       GL_SOURCE1_RGB
-#define GL_SRC2_RGB                       GL_SOURCE2_RGB
-#define GL_SRC0_ALPHA                     GL_SOURCE0_ALPHA
-#define GL_SRC1_ALPHA                     GL_SOURCE1_ALPHA
-#define GL_SRC2_ALPHA                     GL_SOURCE2_ALPHA
-#endif
-
-#ifndef GL_VERSION_2_0
-#define GL_BLEND_EQUATION_RGB             GL_BLEND_EQUATION
-#define GL_VERTEX_ATTRIB_ARRAY_ENABLED    0x8622
-#define GL_VERTEX_ATTRIB_ARRAY_SIZE       0x8623
-#define GL_VERTEX_ATTRIB_ARRAY_STRIDE     0x8624
-#define GL_VERTEX_ATTRIB_ARRAY_TYPE       0x8625
-#define GL_CURRENT_VERTEX_ATTRIB          0x8626
-#define GL_VERTEX_PROGRAM_POINT_SIZE      0x8642
-#define GL_VERTEX_PROGRAM_TWO_SIDE        0x8643
-#define GL_VERTEX_ATTRIB_ARRAY_POINTER    0x8645
-#define GL_STENCIL_BACK_FUNC              0x8800
-#define GL_STENCIL_BACK_FAIL              0x8801
-#define GL_STENCIL_BACK_PASS_DEPTH_FAIL   0x8802
-#define GL_STENCIL_BACK_PASS_DEPTH_PASS   0x8803
-#define GL_MAX_DRAW_BUFFERS               0x8824
-#define GL_DRAW_BUFFER0                   0x8825
-#define GL_DRAW_BUFFER1                   0x8826
-#define GL_DRAW_BUFFER2                   0x8827
-#define GL_DRAW_BUFFER3                   0x8828
-#define GL_DRAW_BUFFER4                   0x8829
-#define GL_DRAW_BUFFER5                   0x882A
-#define GL_DRAW_BUFFER6                   0x882B
-#define GL_DRAW_BUFFER7                   0x882C
-#define GL_DRAW_BUFFER8                   0x882D
-#define GL_DRAW_BUFFER9                   0x882E
-#define GL_DRAW_BUFFER10                  0x882F
-#define GL_DRAW_BUFFER11                  0x8830
-#define GL_DRAW_BUFFER12                  0x8831
-#define GL_DRAW_BUFFER13                  0x8832
-#define GL_DRAW_BUFFER14                  0x8833
-#define GL_DRAW_BUFFER15                  0x8834
-#define GL_BLEND_EQUATION_ALPHA           0x883D
-#define GL_POINT_SPRITE                   0x8861
-#define GL_COORD_REPLACE                  0x8862
-#define GL_MAX_VERTEX_ATTRIBS             0x8869
-#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED 0x886A
-#define GL_MAX_TEXTURE_COORDS             0x8871
-#define GL_MAX_TEXTURE_IMAGE_UNITS        0x8872
-#define GL_FRAGMENT_SHADER                0x8B30
-#define GL_VERTEX_SHADER                  0x8B31
-#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS 0x8B49
-#define GL_MAX_VERTEX_UNIFORM_COMPONENTS  0x8B4A
-#define GL_MAX_VARYING_FLOATS             0x8B4B
-#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS 0x8B4C
-#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS 0x8B4D
-#define GL_SHADER_TYPE                    0x8B4F
-#define GL_FLOAT_VEC2                     0x8B50
-#define GL_FLOAT_VEC3                     0x8B51
-#define GL_FLOAT_VEC4                     0x8B52
-#define GL_INT_VEC2                       0x8B53
-#define GL_INT_VEC3                       0x8B54
-#define GL_INT_VEC4                       0x8B55
-#define GL_BOOL                           0x8B56
-#define GL_BOOL_VEC2                      0x8B57
-#define GL_BOOL_VEC3                      0x8B58
-#define GL_BOOL_VEC4                      0x8B59
-#define GL_FLOAT_MAT2                     0x8B5A
-#define GL_FLOAT_MAT3                     0x8B5B
-#define GL_FLOAT_MAT4                     0x8B5C
-#define GL_SAMPLER_1D                     0x8B5D
-#define GL_SAMPLER_2D                     0x8B5E
-#define GL_SAMPLER_3D                     0x8B5F
-#define GL_SAMPLER_CUBE                   0x8B60
-#define GL_SAMPLER_1D_SHADOW              0x8B61
-#define GL_SAMPLER_2D_SHADOW              0x8B62
-#define GL_DELETE_STATUS                  0x8B80
-#define GL_COMPILE_STATUS                 0x8B81
-#define GL_LINK_STATUS                    0x8B82
-#define GL_VALIDATE_STATUS                0x8B83
-#define GL_INFO_LOG_LENGTH                0x8B84
-#define GL_ATTACHED_SHADERS               0x8B85
-#define GL_ACTIVE_UNIFORMS                0x8B86
-#define GL_ACTIVE_UNIFORM_MAX_LENGTH      0x8B87
-#define GL_SHADER_SOURCE_LENGTH           0x8B88
-#define GL_ACTIVE_ATTRIBUTES              0x8B89
-#define GL_ACTIVE_ATTRIBUTE_MAX_LENGTH    0x8B8A
-#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT 0x8B8B
-#define GL_SHADING_LANGUAGE_VERSION       0x8B8C
-#define GL_CURRENT_PROGRAM                0x8B8D
-#define GL_POINT_SPRITE_COORD_ORIGIN      0x8CA0
-#define GL_LOWER_LEFT                     0x8CA1
-#define GL_UPPER_LEFT                     0x8CA2
-#define GL_STENCIL_BACK_REF               0x8CA3
-#define GL_STENCIL_BACK_VALUE_MASK        0x8CA4
-#define GL_STENCIL_BACK_WRITEMASK         0x8CA5
-#endif
-
-#ifndef GL_ARB_multitexture
-#define GL_TEXTURE0_ARB                   0x84C0
-#define GL_TEXTURE1_ARB                   0x84C1
-#define GL_TEXTURE2_ARB                   0x84C2
-#define GL_TEXTURE3_ARB                   0x84C3
-#define GL_TEXTURE4_ARB                   0x84C4
-#define GL_TEXTURE5_ARB                   0x84C5
-#define GL_TEXTURE6_ARB                   0x84C6
-#define GL_TEXTURE7_ARB                   0x84C7
-#define GL_TEXTURE8_ARB                   0x84C8
-#define GL_TEXTURE9_ARB                   0x84C9
-#define GL_TEXTURE10_ARB                  0x84CA
-#define GL_TEXTURE11_ARB                  0x84CB
-#define GL_TEXTURE12_ARB                  0x84CC
-#define GL_TEXTURE13_ARB                  0x84CD
-#define GL_TEXTURE14_ARB                  0x84CE
-#define GL_TEXTURE15_ARB                  0x84CF
-#define GL_TEXTURE16_ARB                  0x84D0
-#define GL_TEXTURE17_ARB                  0x84D1
-#define GL_TEXTURE18_ARB                  0x84D2
-#define GL_TEXTURE19_ARB                  0x84D3
-#define GL_TEXTURE20_ARB                  0x84D4
-#define GL_TEXTURE21_ARB                  0x84D5
-#define GL_TEXTURE22_ARB                  0x84D6
-#define GL_TEXTURE23_ARB                  0x84D7
-#define GL_TEXTURE24_ARB                  0x84D8
-#define GL_TEXTURE25_ARB                  0x84D9
-#define GL_TEXTURE26_ARB                  0x84DA
-#define GL_TEXTURE27_ARB                  0x84DB
-#define GL_TEXTURE28_ARB                  0x84DC
-#define GL_TEXTURE29_ARB                  0x84DD
-#define GL_TEXTURE30_ARB                  0x84DE
-#define GL_TEXTURE31_ARB                  0x84DF
-#define GL_ACTIVE_TEXTURE_ARB             0x84E0
-#define GL_CLIENT_ACTIVE_TEXTURE_ARB      0x84E1
-#define GL_MAX_TEXTURE_UNITS_ARB          0x84E2
-#endif
-
-#ifndef GL_ARB_transpose_matrix
-#define GL_TRANSPOSE_MODELVIEW_MATRIX_ARB 0x84E3
-#define GL_TRANSPOSE_PROJECTION_MATRIX_ARB 0x84E4
-#define GL_TRANSPOSE_TEXTURE_MATRIX_ARB   0x84E5
-#define GL_TRANSPOSE_COLOR_MATRIX_ARB     0x84E6
-#endif
-
-#ifndef GL_ARB_multisample
-#define GL_MULTISAMPLE_ARB                0x809D
-#define GL_SAMPLE_ALPHA_TO_COVERAGE_ARB   0x809E
-#define GL_SAMPLE_ALPHA_TO_ONE_ARB        0x809F
-#define GL_SAMPLE_COVERAGE_ARB            0x80A0
-#define GL_SAMPLE_BUFFERS_ARB             0x80A8
-#define GL_SAMPLES_ARB                    0x80A9
-#define GL_SAMPLE_COVERAGE_VALUE_ARB      0x80AA
-#define GL_SAMPLE_COVERAGE_INVERT_ARB     0x80AB
-#define GL_MULTISAMPLE_BIT_ARB            0x20000000
-#endif
-
-#ifndef GL_ARB_texture_env_add
-#endif
-
-#ifndef GL_ARB_texture_cube_map
-#define GL_NORMAL_MAP_ARB                 0x8511
-#define GL_REFLECTION_MAP_ARB             0x8512
-#define GL_TEXTURE_CUBE_MAP_ARB           0x8513
-#define GL_TEXTURE_BINDING_CUBE_MAP_ARB   0x8514
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB 0x8515
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB 0x8516
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB 0x8517
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB 0x8518
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB 0x8519
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB 0x851A
-#define GL_PROXY_TEXTURE_CUBE_MAP_ARB     0x851B
-#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB  0x851C
-#endif
-
-#ifndef GL_ARB_texture_compression
-#define GL_COMPRESSED_ALPHA_ARB           0x84E9
-#define GL_COMPRESSED_LUMINANCE_ARB       0x84EA
-#define GL_COMPRESSED_LUMINANCE_ALPHA_ARB 0x84EB
-#define GL_COMPRESSED_INTENSITY_ARB       0x84EC
-#define GL_COMPRESSED_RGB_ARB             0x84ED
-#define GL_COMPRESSED_RGBA_ARB            0x84EE
-#define GL_TEXTURE_COMPRESSION_HINT_ARB   0x84EF
-#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB 0x86A0
-#define GL_TEXTURE_COMPRESSED_ARB         0x86A1
-#define GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB 0x86A2
-#define GL_COMPRESSED_TEXTURE_FORMATS_ARB 0x86A3
-#endif
-
-#ifndef GL_ARB_texture_border_clamp
-#define GL_CLAMP_TO_BORDER_ARB            0x812D
-#endif
-
-#ifndef GL_ARB_point_parameters
-#define GL_POINT_SIZE_MIN_ARB             0x8126
-#define GL_POINT_SIZE_MAX_ARB             0x8127
-#define GL_POINT_FADE_THRESHOLD_SIZE_ARB  0x8128
-#define GL_POINT_DISTANCE_ATTENUATION_ARB 0x8129
-#endif
-
-#ifndef GL_ARB_vertex_blend
-#define GL_MAX_VERTEX_UNITS_ARB           0x86A4
-#define GL_ACTIVE_VERTEX_UNITS_ARB        0x86A5
-#define GL_WEIGHT_SUM_UNITY_ARB           0x86A6
-#define GL_VERTEX_BLEND_ARB               0x86A7
-#define GL_CURRENT_WEIGHT_ARB             0x86A8
-#define GL_WEIGHT_ARRAY_TYPE_ARB          0x86A9
-#define GL_WEIGHT_ARRAY_STRIDE_ARB        0x86AA
-#define GL_WEIGHT_ARRAY_SIZE_ARB          0x86AB
-#define GL_WEIGHT_ARRAY_POINTER_ARB       0x86AC
-#define GL_WEIGHT_ARRAY_ARB               0x86AD
-#define GL_MODELVIEW0_ARB                 0x1700
-#define GL_MODELVIEW1_ARB                 0x850A
-#define GL_MODELVIEW2_ARB                 0x8722
-#define GL_MODELVIEW3_ARB                 0x8723
-#define GL_MODELVIEW4_ARB                 0x8724
-#define GL_MODELVIEW5_ARB                 0x8725
-#define GL_MODELVIEW6_ARB                 0x8726
-#define GL_MODELVIEW7_ARB                 0x8727
-#define GL_MODELVIEW8_ARB                 0x8728
-#define GL_MODELVIEW9_ARB                 0x8729
-#define GL_MODELVIEW10_ARB                0x872A
-#define GL_MODELVIEW11_ARB                0x872B
-#define GL_MODELVIEW12_ARB                0x872C
-#define GL_MODELVIEW13_ARB                0x872D
-#define GL_MODELVIEW14_ARB                0x872E
-#define GL_MODELVIEW15_ARB                0x872F
-#define GL_MODELVIEW16_ARB                0x8730
-#define GL_MODELVIEW17_ARB                0x8731
-#define GL_MODELVIEW18_ARB                0x8732
-#define GL_MODELVIEW19_ARB                0x8733
-#define GL_MODELVIEW20_ARB                0x8734
-#define GL_MODELVIEW21_ARB                0x8735
-#define GL_MODELVIEW22_ARB                0x8736
-#define GL_MODELVIEW23_ARB                0x8737
-#define GL_MODELVIEW24_ARB                0x8738
-#define GL_MODELVIEW25_ARB                0x8739
-#define GL_MODELVIEW26_ARB                0x873A
-#define GL_MODELVIEW27_ARB                0x873B
-#define GL_MODELVIEW28_ARB                0x873C
-#define GL_MODELVIEW29_ARB                0x873D
-#define GL_MODELVIEW30_ARB                0x873E
-#define GL_MODELVIEW31_ARB                0x873F
-#endif
-
-#ifndef GL_ARB_matrix_palette
-#define GL_MATRIX_PALETTE_ARB             0x8840
-#define GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB 0x8841
-#define GL_MAX_PALETTE_MATRICES_ARB       0x8842
-#define GL_CURRENT_PALETTE_MATRIX_ARB     0x8843
-#define GL_MATRIX_INDEX_ARRAY_ARB         0x8844
-#define GL_CURRENT_MATRIX_INDEX_ARB       0x8845
-#define GL_MATRIX_INDEX_ARRAY_SIZE_ARB    0x8846
-#define GL_MATRIX_INDEX_ARRAY_TYPE_ARB    0x8847
-#define GL_MATRIX_INDEX_ARRAY_STRIDE_ARB  0x8848
-#define GL_MATRIX_INDEX_ARRAY_POINTER_ARB 0x8849
-#endif
-
-#ifndef GL_ARB_texture_env_combine
-#define GL_COMBINE_ARB                    0x8570
-#define GL_COMBINE_RGB_ARB                0x8571
-#define GL_COMBINE_ALPHA_ARB              0x8572
-#define GL_SOURCE0_RGB_ARB                0x8580
-#define GL_SOURCE1_RGB_ARB                0x8581
-#define GL_SOURCE2_RGB_ARB                0x8582
-#define GL_SOURCE0_ALPHA_ARB              0x8588
-#define GL_SOURCE1_ALPHA_ARB              0x8589
-#define GL_SOURCE2_ALPHA_ARB              0x858A
-#define GL_OPERAND0_RGB_ARB               0x8590
-#define GL_OPERAND1_RGB_ARB               0x8591
-#define GL_OPERAND2_RGB_ARB               0x8592
-#define GL_OPERAND0_ALPHA_ARB             0x8598
-#define GL_OPERAND1_ALPHA_ARB             0x8599
-#define GL_OPERAND2_ALPHA_ARB             0x859A
-#define GL_RGB_SCALE_ARB                  0x8573
-#define GL_ADD_SIGNED_ARB                 0x8574
-#define GL_INTERPOLATE_ARB                0x8575
-#define GL_SUBTRACT_ARB                   0x84E7
-#define GL_CONSTANT_ARB                   0x8576
-#define GL_PRIMARY_COLOR_ARB              0x8577
-#define GL_PREVIOUS_ARB                   0x8578
-#endif
-
-#ifndef GL_ARB_texture_env_crossbar
-#endif
-
-#ifndef GL_ARB_texture_env_dot3
-#define GL_DOT3_RGB_ARB                   0x86AE
-#define GL_DOT3_RGBA_ARB                  0x86AF
-#endif
-
-#ifndef GL_ARB_texture_mirrored_repeat
-#define GL_MIRRORED_REPEAT_ARB            0x8370
-#endif
-
-#ifndef GL_ARB_depth_texture
-#define GL_DEPTH_COMPONENT16_ARB          0x81A5
-#define GL_DEPTH_COMPONENT24_ARB          0x81A6
-#define GL_DEPTH_COMPONENT32_ARB          0x81A7
-#define GL_TEXTURE_DEPTH_SIZE_ARB         0x884A
-#define GL_DEPTH_TEXTURE_MODE_ARB         0x884B
-#endif
-
-#ifndef GL_ARB_shadow
-#define GL_TEXTURE_COMPARE_MODE_ARB       0x884C
-#define GL_TEXTURE_COMPARE_FUNC_ARB       0x884D
-#define GL_COMPARE_R_TO_TEXTURE_ARB       0x884E
-#endif
-
-#ifndef GL_ARB_shadow_ambient
-#define GL_TEXTURE_COMPARE_FAIL_VALUE_ARB 0x80BF
-#endif
-
-#ifndef GL_ARB_window_pos
-#endif
-
-#ifndef GL_ARB_vertex_program
-#define GL_COLOR_SUM_ARB                  0x8458
-#define GL_VERTEX_PROGRAM_ARB             0x8620
-#define GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB 0x8622
-#define GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB   0x8623
-#define GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB 0x8624
-#define GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB   0x8625
-#define GL_CURRENT_VERTEX_ATTRIB_ARB      0x8626
-#define GL_PROGRAM_LENGTH_ARB             0x8627
-#define GL_PROGRAM_STRING_ARB             0x8628
-#define GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB 0x862E
-#define GL_MAX_PROGRAM_MATRICES_ARB       0x862F
-#define GL_CURRENT_MATRIX_STACK_DEPTH_ARB 0x8640
-#define GL_CURRENT_MATRIX_ARB             0x8641
-#define GL_VERTEX_PROGRAM_POINT_SIZE_ARB  0x8642
-#define GL_VERTEX_PROGRAM_TWO_SIDE_ARB    0x8643
-#define GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB 0x8645
-#define GL_PROGRAM_ERROR_POSITION_ARB     0x864B
-#define GL_PROGRAM_BINDING_ARB            0x8677
-#define GL_MAX_VERTEX_ATTRIBS_ARB         0x8869
-#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB 0x886A
-#define GL_PROGRAM_ERROR_STRING_ARB       0x8874
-#define GL_PROGRAM_FORMAT_ASCII_ARB       0x8875
-#define GL_PROGRAM_FORMAT_ARB             0x8876
-#define GL_PROGRAM_INSTRUCTIONS_ARB       0x88A0
-#define GL_MAX_PROGRAM_INSTRUCTIONS_ARB   0x88A1
-#define GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB 0x88A2
-#define GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB 0x88A3
-#define GL_PROGRAM_TEMPORARIES_ARB        0x88A4
-#define GL_MAX_PROGRAM_TEMPORARIES_ARB    0x88A5
-#define GL_PROGRAM_NATIVE_TEMPORARIES_ARB 0x88A6
-#define GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB 0x88A7
-#define GL_PROGRAM_PARAMETERS_ARB         0x88A8
-#define GL_MAX_PROGRAM_PARAMETERS_ARB     0x88A9
-#define GL_PROGRAM_NATIVE_PARAMETERS_ARB  0x88AA
-#define GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB 0x88AB
-#define GL_PROGRAM_ATTRIBS_ARB            0x88AC
-#define GL_MAX_PROGRAM_ATTRIBS_ARB        0x88AD
-#define GL_PROGRAM_NATIVE_ATTRIBS_ARB     0x88AE
-#define GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB 0x88AF
-#define GL_PROGRAM_ADDRESS_REGISTERS_ARB  0x88B0
-#define GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB 0x88B1
-#define GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB 0x88B2
-#define GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB 0x88B3
-#define GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB 0x88B4
-#define GL_MAX_PROGRAM_ENV_PARAMETERS_ARB 0x88B5
-#define GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB 0x88B6
-#define GL_TRANSPOSE_CURRENT_MATRIX_ARB   0x88B7
-#define GL_MATRIX0_ARB                    0x88C0
-#define GL_MATRIX1_ARB                    0x88C1
-#define GL_MATRIX2_ARB                    0x88C2
-#define GL_MATRIX3_ARB                    0x88C3
-#define GL_MATRIX4_ARB                    0x88C4
-#define GL_MATRIX5_ARB                    0x88C5
-#define GL_MATRIX6_ARB                    0x88C6
-#define GL_MATRIX7_ARB                    0x88C7
-#define GL_MATRIX8_ARB                    0x88C8
-#define GL_MATRIX9_ARB                    0x88C9
-#define GL_MATRIX10_ARB                   0x88CA
-#define GL_MATRIX11_ARB                   0x88CB
-#define GL_MATRIX12_ARB                   0x88CC
-#define GL_MATRIX13_ARB                   0x88CD
-#define GL_MATRIX14_ARB                   0x88CE
-#define GL_MATRIX15_ARB                   0x88CF
-#define GL_MATRIX16_ARB                   0x88D0
-#define GL_MATRIX17_ARB                   0x88D1
-#define GL_MATRIX18_ARB                   0x88D2
-#define GL_MATRIX19_ARB                   0x88D3
-#define GL_MATRIX20_ARB                   0x88D4
-#define GL_MATRIX21_ARB                   0x88D5
-#define GL_MATRIX22_ARB                   0x88D6
-#define GL_MATRIX23_ARB                   0x88D7
-#define GL_MATRIX24_ARB                   0x88D8
-#define GL_MATRIX25_ARB                   0x88D9
-#define GL_MATRIX26_ARB                   0x88DA
-#define GL_MATRIX27_ARB                   0x88DB
-#define GL_MATRIX28_ARB                   0x88DC
-#define GL_MATRIX29_ARB                   0x88DD
-#define GL_MATRIX30_ARB                   0x88DE
-#define GL_MATRIX31_ARB                   0x88DF
-#endif
-
-#ifndef GL_ARB_fragment_program
-#define GL_FRAGMENT_PROGRAM_ARB           0x8804
-#define GL_PROGRAM_ALU_INSTRUCTIONS_ARB   0x8805
-#define GL_PROGRAM_TEX_INSTRUCTIONS_ARB   0x8806
-#define GL_PROGRAM_TEX_INDIRECTIONS_ARB   0x8807
-#define GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB 0x8808
-#define GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB 0x8809
-#define GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB 0x880A
-#define GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB 0x880B
-#define GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB 0x880C
-#define GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB 0x880D
-#define GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB 0x880E
-#define GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB 0x880F
-#define GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB 0x8810
-#define GL_MAX_TEXTURE_COORDS_ARB         0x8871
-#define GL_MAX_TEXTURE_IMAGE_UNITS_ARB    0x8872
-#endif
-
-#ifndef GL_ARB_vertex_buffer_object
-#define GL_BUFFER_SIZE_ARB                0x8764
-#define GL_BUFFER_USAGE_ARB               0x8765
-#define GL_ARRAY_BUFFER_ARB               0x8892
-#define GL_ELEMENT_ARRAY_BUFFER_ARB       0x8893
-#define GL_ARRAY_BUFFER_BINDING_ARB       0x8894
-#define GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB 0x8895
-#define GL_VERTEX_ARRAY_BUFFER_BINDING_ARB 0x8896
-#define GL_NORMAL_ARRAY_BUFFER_BINDING_ARB 0x8897
-#define GL_COLOR_ARRAY_BUFFER_BINDING_ARB 0x8898
-#define GL_INDEX_ARRAY_BUFFER_BINDING_ARB 0x8899
-#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB 0x889A
-#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB 0x889B
-#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB 0x889C
-#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB 0x889D
-#define GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB 0x889E
-#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB 0x889F
-#define GL_READ_ONLY_ARB                  0x88B8
-#define GL_WRITE_ONLY_ARB                 0x88B9
-#define GL_READ_WRITE_ARB                 0x88BA
-#define GL_BUFFER_ACCESS_ARB              0x88BB
-#define GL_BUFFER_MAPPED_ARB              0x88BC
-#define GL_BUFFER_MAP_POINTER_ARB         0x88BD
-#define GL_STREAM_DRAW_ARB                0x88E0
-#define GL_STREAM_READ_ARB                0x88E1
-#define GL_STREAM_COPY_ARB                0x88E2
-#define GL_STATIC_DRAW_ARB                0x88E4
-#define GL_STATIC_READ_ARB                0x88E5
-#define GL_STATIC_COPY_ARB                0x88E6
-#define GL_DYNAMIC_DRAW_ARB               0x88E8
-#define GL_DYNAMIC_READ_ARB               0x88E9
-#define GL_DYNAMIC_COPY_ARB               0x88EA
-#endif
-
-#ifndef GL_ARB_occlusion_query
-#define GL_QUERY_COUNTER_BITS_ARB         0x8864
-#define GL_CURRENT_QUERY_ARB              0x8865
-#define GL_QUERY_RESULT_ARB               0x8866
-#define GL_QUERY_RESULT_AVAILABLE_ARB     0x8867
-#define GL_SAMPLES_PASSED_ARB             0x8914
-#endif
-
-#ifndef GL_ARB_shader_objects
-#define GL_PROGRAM_OBJECT_ARB             0x8B40
-#define GL_SHADER_OBJECT_ARB              0x8B48
-#define GL_OBJECT_TYPE_ARB                0x8B4E
-#define GL_OBJECT_SUBTYPE_ARB             0x8B4F
-#define GL_FLOAT_VEC2_ARB                 0x8B50
-#define GL_FLOAT_VEC3_ARB                 0x8B51
-#define GL_FLOAT_VEC4_ARB                 0x8B52
-#define GL_INT_VEC2_ARB                   0x8B53
-#define GL_INT_VEC3_ARB                   0x8B54
-#define GL_INT_VEC4_ARB                   0x8B55
-#define GL_BOOL_ARB                       0x8B56
-#define GL_BOOL_VEC2_ARB                  0x8B57
-#define GL_BOOL_VEC3_ARB                  0x8B58
-#define GL_BOOL_VEC4_ARB                  0x8B59
-#define GL_FLOAT_MAT2_ARB                 0x8B5A
-#define GL_FLOAT_MAT3_ARB                 0x8B5B
-#define GL_FLOAT_MAT4_ARB                 0x8B5C
-#define GL_SAMPLER_1D_ARB                 0x8B5D
-#define GL_SAMPLER_2D_ARB                 0x8B5E
-#define GL_SAMPLER_3D_ARB                 0x8B5F
-#define GL_SAMPLER_CUBE_ARB               0x8B60
-#define GL_SAMPLER_1D_SHADOW_ARB          0x8B61
-#define GL_SAMPLER_2D_SHADOW_ARB          0x8B62
-#define GL_SAMPLER_2D_RECT_ARB            0x8B63
-#define GL_SAMPLER_2D_RECT_SHADOW_ARB     0x8B64
-#define GL_OBJECT_DELETE_STATUS_ARB       0x8B80
-#define GL_OBJECT_COMPILE_STATUS_ARB      0x8B81
-#define GL_OBJECT_LINK_STATUS_ARB         0x8B82
-#define GL_OBJECT_VALIDATE_STATUS_ARB     0x8B83
-#define GL_OBJECT_INFO_LOG_LENGTH_ARB     0x8B84
-#define GL_OBJECT_ATTACHED_OBJECTS_ARB    0x8B85
-#define GL_OBJECT_ACTIVE_UNIFORMS_ARB     0x8B86
-#define GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB 0x8B87
-#define GL_OBJECT_SHADER_SOURCE_LENGTH_ARB 0x8B88
-#endif
-
-#ifndef GL_ARB_vertex_shader
-#define GL_VERTEX_SHADER_ARB              0x8B31
-#define GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB 0x8B4A
-#define GL_MAX_VARYING_FLOATS_ARB         0x8B4B
-#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB 0x8B4C
-#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB 0x8B4D
-#define GL_OBJECT_ACTIVE_ATTRIBUTES_ARB   0x8B89
-#define GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB 0x8B8A
-#endif
-
-#ifndef GL_ARB_fragment_shader
-#define GL_FRAGMENT_SHADER_ARB            0x8B30
-#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB 0x8B49
-#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB 0x8B8B
-#endif
-
-#ifndef GL_ARB_shading_language_100
-#define GL_SHADING_LANGUAGE_VERSION_ARB   0x8B8C
-#endif
-
-#ifndef GL_ARB_texture_non_power_of_two
-#endif
-
-#ifndef GL_ARB_point_sprite
-#define GL_POINT_SPRITE_ARB               0x8861
-#define GL_COORD_REPLACE_ARB              0x8862
-#endif
-
-#ifndef GL_ARB_fragment_program_shadow
-#endif
-
-#ifndef GL_ARB_draw_buffers
-#define GL_MAX_DRAW_BUFFERS_ARB           0x8824
-#define GL_DRAW_BUFFER0_ARB               0x8825
-#define GL_DRAW_BUFFER1_ARB               0x8826
-#define GL_DRAW_BUFFER2_ARB               0x8827
-#define GL_DRAW_BUFFER3_ARB               0x8828
-#define GL_DRAW_BUFFER4_ARB               0x8829
-#define GL_DRAW_BUFFER5_ARB               0x882A
-#define GL_DRAW_BUFFER6_ARB               0x882B
-#define GL_DRAW_BUFFER7_ARB               0x882C
-#define GL_DRAW_BUFFER8_ARB               0x882D
-#define GL_DRAW_BUFFER9_ARB               0x882E
-#define GL_DRAW_BUFFER10_ARB              0x882F
-#define GL_DRAW_BUFFER11_ARB              0x8830
-#define GL_DRAW_BUFFER12_ARB              0x8831
-#define GL_DRAW_BUFFER13_ARB              0x8832
-#define GL_DRAW_BUFFER14_ARB              0x8833
-#define GL_DRAW_BUFFER15_ARB              0x8834
-#endif
-
-#ifndef GL_ARB_texture_rectangle
-#define GL_TEXTURE_RECTANGLE_ARB          0x84F5
-#define GL_TEXTURE_BINDING_RECTANGLE_ARB  0x84F6
-#define GL_PROXY_TEXTURE_RECTANGLE_ARB    0x84F7
-#define GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB 0x84F8
-#endif
-
-#ifndef GL_ARB_color_buffer_float
-#define GL_RGBA_FLOAT_MODE_ARB            0x8820
-#define GL_CLAMP_VERTEX_COLOR_ARB         0x891A
-#define GL_CLAMP_FRAGMENT_COLOR_ARB       0x891B
-#define GL_CLAMP_READ_COLOR_ARB           0x891C
-#define GL_FIXED_ONLY_ARB                 0x891D
-#endif
-
-#ifndef GL_ARB_half_float_pixel
-#define GL_HALF_FLOAT_ARB                 0x140B
-#endif
-
-#ifndef GL_ARB_texture_float
-#define GL_TEXTURE_RED_TYPE_ARB           0x8C10
-#define GL_TEXTURE_GREEN_TYPE_ARB         0x8C11
-#define GL_TEXTURE_BLUE_TYPE_ARB          0x8C12
-#define GL_TEXTURE_ALPHA_TYPE_ARB         0x8C13
-#define GL_TEXTURE_LUMINANCE_TYPE_ARB     0x8C14
-#define GL_TEXTURE_INTENSITY_TYPE_ARB     0x8C15
-#define GL_TEXTURE_DEPTH_TYPE_ARB         0x8C16
-#define GL_UNSIGNED_NORMALIZED_ARB        0x8C17
-#define GL_RGBA32F_ARB                    0x8814
-#define GL_RGB32F_ARB                     0x8815
-#define GL_ALPHA32F_ARB                   0x8816
-#define GL_INTENSITY32F_ARB               0x8817
-#define GL_LUMINANCE32F_ARB               0x8818
-#define GL_LUMINANCE_ALPHA32F_ARB         0x8819
-#define GL_RGBA16F_ARB                    0x881A
-#define GL_RGB16F_ARB                     0x881B
-#define GL_ALPHA16F_ARB                   0x881C
-#define GL_INTENSITY16F_ARB               0x881D
-#define GL_LUMINANCE16F_ARB               0x881E
-#define GL_LUMINANCE_ALPHA16F_ARB         0x881F
-#endif
-
-#ifndef GL_ARB_pixel_buffer_object
-#define GL_PIXEL_PACK_BUFFER_ARB          0x88EB
-#define GL_PIXEL_UNPACK_BUFFER_ARB        0x88EC
-#define GL_PIXEL_PACK_BUFFER_BINDING_ARB  0x88ED
-#define GL_PIXEL_UNPACK_BUFFER_BINDING_ARB 0x88EF
-#endif
-
-#ifndef GL_EXT_abgr
-#define GL_ABGR_EXT                       0x8000
-#endif
-
-#ifndef GL_EXT_blend_color
-#define GL_CONSTANT_COLOR_EXT             0x8001
-#define GL_ONE_MINUS_CONSTANT_COLOR_EXT   0x8002
-#define GL_CONSTANT_ALPHA_EXT             0x8003
-#define GL_ONE_MINUS_CONSTANT_ALPHA_EXT   0x8004
-#define GL_BLEND_COLOR_EXT                0x8005
-#endif
-
-#ifndef GL_EXT_polygon_offset
-#define GL_POLYGON_OFFSET_EXT             0x8037
-#define GL_POLYGON_OFFSET_FACTOR_EXT      0x8038
-#define GL_POLYGON_OFFSET_BIAS_EXT        0x8039
-#endif
-
-#ifndef GL_EXT_texture
-#define GL_ALPHA4_EXT                     0x803B
-#define GL_ALPHA8_EXT                     0x803C
-#define GL_ALPHA12_EXT                    0x803D
-#define GL_ALPHA16_EXT                    0x803E
-#define GL_LUMINANCE4_EXT                 0x803F
-#define GL_LUMINANCE8_EXT                 0x8040
-#define GL_LUMINANCE12_EXT                0x8041
-#define GL_LUMINANCE16_EXT                0x8042
-#define GL_LUMINANCE4_ALPHA4_EXT          0x8043
-#define GL_LUMINANCE6_ALPHA2_EXT          0x8044
-#define GL_LUMINANCE8_ALPHA8_EXT          0x8045
-#define GL_LUMINANCE12_ALPHA4_EXT         0x8046
-#define GL_LUMINANCE12_ALPHA12_EXT        0x8047
-#define GL_LUMINANCE16_ALPHA16_EXT        0x8048
-#define GL_INTENSITY_EXT                  0x8049
-#define GL_INTENSITY4_EXT                 0x804A
-#define GL_INTENSITY8_EXT                 0x804B
-#define GL_INTENSITY12_EXT                0x804C
-#define GL_INTENSITY16_EXT                0x804D
-#define GL_RGB2_EXT                       0x804E
-#define GL_RGB4_EXT                       0x804F
-#define GL_RGB5_EXT                       0x8050
-#define GL_RGB8_EXT                       0x8051
-#define GL_RGB10_EXT                      0x8052
-#define GL_RGB12_EXT                      0x8053
-#define GL_RGB16_EXT                      0x8054
-#define GL_RGBA2_EXT                      0x8055
-#define GL_RGBA4_EXT                      0x8056
-#define GL_RGB5_A1_EXT                    0x8057
-#define GL_RGBA8_EXT                      0x8058
-#define GL_RGB10_A2_EXT                   0x8059
-#define GL_RGBA12_EXT                     0x805A
-#define GL_RGBA16_EXT                     0x805B
-#define GL_TEXTURE_RED_SIZE_EXT           0x805C
-#define GL_TEXTURE_GREEN_SIZE_EXT         0x805D
-#define GL_TEXTURE_BLUE_SIZE_EXT          0x805E
-#define GL_TEXTURE_ALPHA_SIZE_EXT         0x805F
-#define GL_TEXTURE_LUMINANCE_SIZE_EXT     0x8060
-#define GL_TEXTURE_INTENSITY_SIZE_EXT     0x8061
-#define GL_REPLACE_EXT                    0x8062
-#define GL_PROXY_TEXTURE_1D_EXT           0x8063
-#define GL_PROXY_TEXTURE_2D_EXT           0x8064
-#define GL_TEXTURE_TOO_LARGE_EXT          0x8065
-#endif
-
-#ifndef GL_EXT_texture3D
-#define GL_PACK_SKIP_IMAGES_EXT           0x806B
-#define GL_PACK_IMAGE_HEIGHT_EXT          0x806C
-#define GL_UNPACK_SKIP_IMAGES_EXT         0x806D
-#define GL_UNPACK_IMAGE_HEIGHT_EXT        0x806E
-#define GL_TEXTURE_3D_EXT                 0x806F
-#define GL_PROXY_TEXTURE_3D_EXT           0x8070
-#define GL_TEXTURE_DEPTH_EXT              0x8071
-#define GL_TEXTURE_WRAP_R_EXT             0x8072
-#define GL_MAX_3D_TEXTURE_SIZE_EXT        0x8073
-#endif
-
-#ifndef GL_SGIS_texture_filter4
-#define GL_FILTER4_SGIS                   0x8146
-#define GL_TEXTURE_FILTER4_SIZE_SGIS      0x8147
-#endif
-
-#ifndef GL_EXT_subtexture
-#endif
-
-#ifndef GL_EXT_copy_texture
-#endif
-
-#ifndef GL_EXT_histogram
-#define GL_HISTOGRAM_EXT                  0x8024
-#define GL_PROXY_HISTOGRAM_EXT            0x8025
-#define GL_HISTOGRAM_WIDTH_EXT            0x8026
-#define GL_HISTOGRAM_FORMAT_EXT           0x8027
-#define GL_HISTOGRAM_RED_SIZE_EXT         0x8028
-#define GL_HISTOGRAM_GREEN_SIZE_EXT       0x8029
-#define GL_HISTOGRAM_BLUE_SIZE_EXT        0x802A
-#define GL_HISTOGRAM_ALPHA_SIZE_EXT       0x802B
-#define GL_HISTOGRAM_LUMINANCE_SIZE_EXT   0x802C
-#define GL_HISTOGRAM_SINK_EXT             0x802D
-#define GL_MINMAX_EXT                     0x802E
-#define GL_MINMAX_FORMAT_EXT              0x802F
-#define GL_MINMAX_SINK_EXT                0x8030
-#define GL_TABLE_TOO_LARGE_EXT            0x8031
-#endif
-
-#ifndef GL_EXT_convolution
-#define GL_CONVOLUTION_1D_EXT             0x8010
-#define GL_CONVOLUTION_2D_EXT             0x8011
-#define GL_SEPARABLE_2D_EXT               0x8012
-#define GL_CONVOLUTION_BORDER_MODE_EXT    0x8013
-#define GL_CONVOLUTION_FILTER_SCALE_EXT   0x8014
-#define GL_CONVOLUTION_FILTER_BIAS_EXT    0x8015
-#define GL_REDUCE_EXT                     0x8016
-#define GL_CONVOLUTION_FORMAT_EXT         0x8017
-#define GL_CONVOLUTION_WIDTH_EXT          0x8018
-#define GL_CONVOLUTION_HEIGHT_EXT         0x8019
-#define GL_MAX_CONVOLUTION_WIDTH_EXT      0x801A
-#define GL_MAX_CONVOLUTION_HEIGHT_EXT     0x801B
-#define GL_POST_CONVOLUTION_RED_SCALE_EXT 0x801C
-#define GL_POST_CONVOLUTION_GREEN_SCALE_EXT 0x801D
-#define GL_POST_CONVOLUTION_BLUE_SCALE_EXT 0x801E
-#define GL_POST_CONVOLUTION_ALPHA_SCALE_EXT 0x801F
-#define GL_POST_CONVOLUTION_RED_BIAS_EXT  0x8020
-#define GL_POST_CONVOLUTION_GREEN_BIAS_EXT 0x8021
-#define GL_POST_CONVOLUTION_BLUE_BIAS_EXT 0x8022
-#define GL_POST_CONVOLUTION_ALPHA_BIAS_EXT 0x8023
-#endif
-
-#ifndef GL_SGI_color_matrix
-#define GL_COLOR_MATRIX_SGI               0x80B1
-#define GL_COLOR_MATRIX_STACK_DEPTH_SGI   0x80B2
-#define GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI 0x80B3
-#define GL_POST_COLOR_MATRIX_RED_SCALE_SGI 0x80B4
-#define GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI 0x80B5
-#define GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI 0x80B6
-#define GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI 0x80B7
-#define GL_POST_COLOR_MATRIX_RED_BIAS_SGI 0x80B8
-#define GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI 0x80B9
-#define GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI 0x80BA
-#define GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI 0x80BB
-#endif
-
-#ifndef GL_SGI_color_table
-#define GL_COLOR_TABLE_SGI                0x80D0
-#define GL_POST_CONVOLUTION_COLOR_TABLE_SGI 0x80D1
-#define GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI 0x80D2
-#define GL_PROXY_COLOR_TABLE_SGI          0x80D3
-#define GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI 0x80D4
-#define GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI 0x80D5
-#define GL_COLOR_TABLE_SCALE_SGI          0x80D6
-#define GL_COLOR_TABLE_BIAS_SGI           0x80D7
-#define GL_COLOR_TABLE_FORMAT_SGI         0x80D8
-#define GL_COLOR_TABLE_WIDTH_SGI          0x80D9
-#define GL_COLOR_TABLE_RED_SIZE_SGI       0x80DA
-#define GL_COLOR_TABLE_GREEN_SIZE_SGI     0x80DB
-#define GL_COLOR_TABLE_BLUE_SIZE_SGI      0x80DC
-#define GL_COLOR_TABLE_ALPHA_SIZE_SGI     0x80DD
-#define GL_COLOR_TABLE_LUMINANCE_SIZE_SGI 0x80DE
-#define GL_COLOR_TABLE_INTENSITY_SIZE_SGI 0x80DF
-#endif
-
-#ifndef GL_SGIS_pixel_texture
-#define GL_PIXEL_TEXTURE_SGIS             0x8353
-#define GL_PIXEL_FRAGMENT_RGB_SOURCE_SGIS 0x8354
-#define GL_PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS 0x8355
-#define GL_PIXEL_GROUP_COLOR_SGIS         0x8356
-#endif
-
-#ifndef GL_SGIX_pixel_texture
-#define GL_PIXEL_TEX_GEN_SGIX             0x8139
-#define GL_PIXEL_TEX_GEN_MODE_SGIX        0x832B
-#endif
-
-#ifndef GL_SGIS_texture4D
-#define GL_PACK_SKIP_VOLUMES_SGIS         0x8130
-#define GL_PACK_IMAGE_DEPTH_SGIS          0x8131
-#define GL_UNPACK_SKIP_VOLUMES_SGIS       0x8132
-#define GL_UNPACK_IMAGE_DEPTH_SGIS        0x8133
-#define GL_TEXTURE_4D_SGIS                0x8134
-#define GL_PROXY_TEXTURE_4D_SGIS          0x8135
-#define GL_TEXTURE_4DSIZE_SGIS            0x8136
-#define GL_TEXTURE_WRAP_Q_SGIS            0x8137
-#define GL_MAX_4D_TEXTURE_SIZE_SGIS       0x8138
-#define GL_TEXTURE_4D_BINDING_SGIS        0x814F
-#endif
-
-#ifndef GL_SGI_texture_color_table
-#define GL_TEXTURE_COLOR_TABLE_SGI        0x80BC
-#define GL_PROXY_TEXTURE_COLOR_TABLE_SGI  0x80BD
-#endif
-
-#ifndef GL_EXT_cmyka
-#define GL_CMYK_EXT                       0x800C
-#define GL_CMYKA_EXT                      0x800D
-#define GL_PACK_CMYK_HINT_EXT             0x800E
-#define GL_UNPACK_CMYK_HINT_EXT           0x800F
-#endif
-
-#ifndef GL_EXT_texture_object
-#define GL_TEXTURE_PRIORITY_EXT           0x8066
-#define GL_TEXTURE_RESIDENT_EXT           0x8067
-#define GL_TEXTURE_1D_BINDING_EXT         0x8068
-#define GL_TEXTURE_2D_BINDING_EXT         0x8069
-#define GL_TEXTURE_3D_BINDING_EXT         0x806A
-#endif
-
-#ifndef GL_SGIS_detail_texture
-#define GL_DETAIL_TEXTURE_2D_SGIS         0x8095
-#define GL_DETAIL_TEXTURE_2D_BINDING_SGIS 0x8096
-#define GL_LINEAR_DETAIL_SGIS             0x8097
-#define GL_LINEAR_DETAIL_ALPHA_SGIS       0x8098
-#define GL_LINEAR_DETAIL_COLOR_SGIS       0x8099
-#define GL_DETAIL_TEXTURE_LEVEL_SGIS      0x809A
-#define GL_DETAIL_TEXTURE_MODE_SGIS       0x809B
-#define GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS 0x809C
-#endif
-
-#ifndef GL_SGIS_sharpen_texture
-#define GL_LINEAR_SHARPEN_SGIS            0x80AD
-#define GL_LINEAR_SHARPEN_ALPHA_SGIS      0x80AE
-#define GL_LINEAR_SHARPEN_COLOR_SGIS      0x80AF
-#define GL_SHARPEN_TEXTURE_FUNC_POINTS_SGIS 0x80B0
-#endif
-
-#ifndef GL_EXT_packed_pixels
-#define GL_UNSIGNED_BYTE_3_3_2_EXT        0x8032
-#define GL_UNSIGNED_SHORT_4_4_4_4_EXT     0x8033
-#define GL_UNSIGNED_SHORT_5_5_5_1_EXT     0x8034
-#define GL_UNSIGNED_INT_8_8_8_8_EXT       0x8035
-#define GL_UNSIGNED_INT_10_10_10_2_EXT    0x8036
-#endif
-
-#ifndef GL_SGIS_texture_lod
-#define GL_TEXTURE_MIN_LOD_SGIS           0x813A
-#define GL_TEXTURE_MAX_LOD_SGIS           0x813B
-#define GL_TEXTURE_BASE_LEVEL_SGIS        0x813C
-#define GL_TEXTURE_MAX_LEVEL_SGIS         0x813D
-#endif
-
-#ifndef GL_SGIS_multisample
-#define GL_MULTISAMPLE_SGIS               0x809D
-#define GL_SAMPLE_ALPHA_TO_MASK_SGIS      0x809E
-#define GL_SAMPLE_ALPHA_TO_ONE_SGIS       0x809F
-#define GL_SAMPLE_MASK_SGIS               0x80A0
-#define GL_1PASS_SGIS                     0x80A1
-#define GL_2PASS_0_SGIS                   0x80A2
-#define GL_2PASS_1_SGIS                   0x80A3
-#define GL_4PASS_0_SGIS                   0x80A4
-#define GL_4PASS_1_SGIS                   0x80A5
-#define GL_4PASS_2_SGIS                   0x80A6
-#define GL_4PASS_3_SGIS                   0x80A7
-#define GL_SAMPLE_BUFFERS_SGIS            0x80A8
-#define GL_SAMPLES_SGIS                   0x80A9
-#define GL_SAMPLE_MASK_VALUE_SGIS         0x80AA
-#define GL_SAMPLE_MASK_INVERT_SGIS        0x80AB
-#define GL_SAMPLE_PATTERN_SGIS            0x80AC
-#endif
-
-#ifndef GL_EXT_rescale_normal
-#define GL_RESCALE_NORMAL_EXT             0x803A
-#endif
-
-#ifndef GL_EXT_vertex_array
-#define GL_VERTEX_ARRAY_EXT               0x8074
-#define GL_NORMAL_ARRAY_EXT               0x8075
-#define GL_COLOR_ARRAY_EXT                0x8076
-#define GL_INDEX_ARRAY_EXT                0x8077
-#define GL_TEXTURE_COORD_ARRAY_EXT        0x8078
-#define GL_EDGE_FLAG_ARRAY_EXT            0x8079
-#define GL_VERTEX_ARRAY_SIZE_EXT          0x807A
-#define GL_VERTEX_ARRAY_TYPE_EXT          0x807B
-#define GL_VERTEX_ARRAY_STRIDE_EXT        0x807C
-#define GL_VERTEX_ARRAY_COUNT_EXT         0x807D
-#define GL_NORMAL_ARRAY_TYPE_EXT          0x807E
-#define GL_NORMAL_ARRAY_STRIDE_EXT        0x807F
-#define GL_NORMAL_ARRAY_COUNT_EXT         0x8080
-#define GL_COLOR_ARRAY_SIZE_EXT           0x8081
-#define GL_COLOR_ARRAY_TYPE_EXT           0x8082
-#define GL_COLOR_ARRAY_STRIDE_EXT         0x8083
-#define GL_COLOR_ARRAY_COUNT_EXT          0x8084
-#define GL_INDEX_ARRAY_TYPE_EXT           0x8085
-#define GL_INDEX_ARRAY_STRIDE_EXT         0x8086
-#define GL_INDEX_ARRAY_COUNT_EXT          0x8087
-#define GL_TEXTURE_COORD_ARRAY_SIZE_EXT   0x8088
-#define GL_TEXTURE_COORD_ARRAY_TYPE_EXT   0x8089
-#define GL_TEXTURE_COORD_ARRAY_STRIDE_EXT 0x808A
-#define GL_TEXTURE_COORD_ARRAY_COUNT_EXT  0x808B
-#define GL_EDGE_FLAG_ARRAY_STRIDE_EXT     0x808C
-#define GL_EDGE_FLAG_ARRAY_COUNT_EXT      0x808D
-#define GL_VERTEX_ARRAY_POINTER_EXT       0x808E
-#define GL_NORMAL_ARRAY_POINTER_EXT       0x808F
-#define GL_COLOR_ARRAY_POINTER_EXT        0x8090
-#define GL_INDEX_ARRAY_POINTER_EXT        0x8091
-#define GL_TEXTURE_COORD_ARRAY_POINTER_EXT 0x8092
-#define GL_EDGE_FLAG_ARRAY_POINTER_EXT    0x8093
-#endif
-
-#ifndef GL_EXT_misc_attribute
-#endif
-
-#ifndef GL_SGIS_generate_mipmap
-#define GL_GENERATE_MIPMAP_SGIS           0x8191
-#define GL_GENERATE_MIPMAP_HINT_SGIS      0x8192
-#endif
-
-#ifndef GL_SGIX_clipmap
-#define GL_LINEAR_CLIPMAP_LINEAR_SGIX     0x8170
-#define GL_TEXTURE_CLIPMAP_CENTER_SGIX    0x8171
-#define GL_TEXTURE_CLIPMAP_FRAME_SGIX     0x8172
-#define GL_TEXTURE_CLIPMAP_OFFSET_SGIX    0x8173
-#define GL_TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX 0x8174
-#define GL_TEXTURE_CLIPMAP_LOD_OFFSET_SGIX 0x8175
-#define GL_TEXTURE_CLIPMAP_DEPTH_SGIX     0x8176
-#define GL_MAX_CLIPMAP_DEPTH_SGIX         0x8177
-#define GL_MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX 0x8178
-#define GL_NEAREST_CLIPMAP_NEAREST_SGIX   0x844D
-#define GL_NEAREST_CLIPMAP_LINEAR_SGIX    0x844E
-#define GL_LINEAR_CLIPMAP_NEAREST_SGIX    0x844F
-#endif
-
-#ifndef GL_SGIX_shadow
-#define GL_TEXTURE_COMPARE_SGIX           0x819A
-#define GL_TEXTURE_COMPARE_OPERATOR_SGIX  0x819B
-#define GL_TEXTURE_LEQUAL_R_SGIX          0x819C
-#define GL_TEXTURE_GEQUAL_R_SGIX          0x819D
-#endif
-
-#ifndef GL_SGIS_texture_edge_clamp
-#define GL_CLAMP_TO_EDGE_SGIS             0x812F
-#endif
-
-#ifndef GL_SGIS_texture_border_clamp
-#define GL_CLAMP_TO_BORDER_SGIS           0x812D
-#endif
-
-#ifndef GL_EXT_blend_minmax
-#define GL_FUNC_ADD_EXT                   0x8006
-#define GL_MIN_EXT                        0x8007
-#define GL_MAX_EXT                        0x8008
-#define GL_BLEND_EQUATION_EXT             0x8009
-#endif
-
-#ifndef GL_EXT_blend_subtract
-#define GL_FUNC_SUBTRACT_EXT              0x800A
-#define GL_FUNC_REVERSE_SUBTRACT_EXT      0x800B
-#endif
-
-#ifndef GL_EXT_blend_logic_op
-#endif
-
-#ifndef GL_SGIX_interlace
-#define GL_INTERLACE_SGIX                 0x8094
-#endif
-
-#ifndef GL_SGIX_pixel_tiles
-#define GL_PIXEL_TILE_BEST_ALIGNMENT_SGIX 0x813E
-#define GL_PIXEL_TILE_CACHE_INCREMENT_SGIX 0x813F
-#define GL_PIXEL_TILE_WIDTH_SGIX          0x8140
-#define GL_PIXEL_TILE_HEIGHT_SGIX         0x8141
-#define GL_PIXEL_TILE_GRID_WIDTH_SGIX     0x8142
-#define GL_PIXEL_TILE_GRID_HEIGHT_SGIX    0x8143
-#define GL_PIXEL_TILE_GRID_DEPTH_SGIX     0x8144
-#define GL_PIXEL_TILE_CACHE_SIZE_SGIX     0x8145
-#endif
-
-#ifndef GL_SGIS_texture_select
-#define GL_DUAL_ALPHA4_SGIS               0x8110
-#define GL_DUAL_ALPHA8_SGIS               0x8111
-#define GL_DUAL_ALPHA12_SGIS              0x8112
-#define GL_DUAL_ALPHA16_SGIS              0x8113
-#define GL_DUAL_LUMINANCE4_SGIS           0x8114
-#define GL_DUAL_LUMINANCE8_SGIS           0x8115
-#define GL_DUAL_LUMINANCE12_SGIS          0x8116
-#define GL_DUAL_LUMINANCE16_SGIS          0x8117
-#define GL_DUAL_INTENSITY4_SGIS           0x8118
-#define GL_DUAL_INTENSITY8_SGIS           0x8119
-#define GL_DUAL_INTENSITY12_SGIS          0x811A
-#define GL_DUAL_INTENSITY16_SGIS          0x811B
-#define GL_DUAL_LUMINANCE_ALPHA4_SGIS     0x811C
-#define GL_DUAL_LUMINANCE_ALPHA8_SGIS     0x811D
-#define GL_QUAD_ALPHA4_SGIS               0x811E
-#define GL_QUAD_ALPHA8_SGIS               0x811F
-#define GL_QUAD_LUMINANCE4_SGIS           0x8120
-#define GL_QUAD_LUMINANCE8_SGIS           0x8121
-#define GL_QUAD_INTENSITY4_SGIS           0x8122
-#define GL_QUAD_INTENSITY8_SGIS           0x8123
-#define GL_DUAL_TEXTURE_SELECT_SGIS       0x8124
-#define GL_QUAD_TEXTURE_SELECT_SGIS       0x8125
-#endif
-
-#ifndef GL_SGIX_sprite
-#define GL_SPRITE_SGIX                    0x8148
-#define GL_SPRITE_MODE_SGIX               0x8149
-#define GL_SPRITE_AXIS_SGIX               0x814A
-#define GL_SPRITE_TRANSLATION_SGIX        0x814B
-#define GL_SPRITE_AXIAL_SGIX              0x814C
-#define GL_SPRITE_OBJECT_ALIGNED_SGIX     0x814D
-#define GL_SPRITE_EYE_ALIGNED_SGIX        0x814E
-#endif
-
-#ifndef GL_SGIX_texture_multi_buffer
-#define GL_TEXTURE_MULTI_BUFFER_HINT_SGIX 0x812E
-#endif
-
-#ifndef GL_EXT_point_parameters
-#define GL_POINT_SIZE_MIN_EXT             0x8126
-#define GL_POINT_SIZE_MAX_EXT             0x8127
-#define GL_POINT_FADE_THRESHOLD_SIZE_EXT  0x8128
-#define GL_DISTANCE_ATTENUATION_EXT       0x8129
-#endif
-
-#ifndef GL_SGIS_point_parameters
-#define GL_POINT_SIZE_MIN_SGIS            0x8126
-#define GL_POINT_SIZE_MAX_SGIS            0x8127
-#define GL_POINT_FADE_THRESHOLD_SIZE_SGIS 0x8128
-#define GL_DISTANCE_ATTENUATION_SGIS      0x8129
-#endif
-
-#ifndef GL_SGIX_instruments
-#define GL_INSTRUMENT_BUFFER_POINTER_SGIX 0x8180
-#define GL_INSTRUMENT_MEASUREMENTS_SGIX   0x8181
-#endif
-
-#ifndef GL_SGIX_texture_scale_bias
-#define GL_POST_TEXTURE_FILTER_BIAS_SGIX  0x8179
-#define GL_POST_TEXTURE_FILTER_SCALE_SGIX 0x817A
-#define GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX 0x817B
-#define GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX 0x817C
-#endif
-
-#ifndef GL_SGIX_framezoom
-#define GL_FRAMEZOOM_SGIX                 0x818B
-#define GL_FRAMEZOOM_FACTOR_SGIX          0x818C
-#define GL_MAX_FRAMEZOOM_FACTOR_SGIX      0x818D
-#endif
-
-#ifndef GL_SGIX_tag_sample_buffer
-#endif
-
-#ifndef GL_FfdMaskSGIX
-#define GL_TEXTURE_DEFORMATION_BIT_SGIX   0x00000001
-#define GL_GEOMETRY_DEFORMATION_BIT_SGIX  0x00000002
-#endif
-
-#ifndef GL_SGIX_polynomial_ffd
-#define GL_GEOMETRY_DEFORMATION_SGIX      0x8194
-#define GL_TEXTURE_DEFORMATION_SGIX       0x8195
-#define GL_DEFORMATIONS_MASK_SGIX         0x8196
-#define GL_MAX_DEFORMATION_ORDER_SGIX     0x8197
-#endif
-
-#ifndef GL_SGIX_reference_plane
-#define GL_REFERENCE_PLANE_SGIX           0x817D
-#define GL_REFERENCE_PLANE_EQUATION_SGIX  0x817E
-#endif
-
-#ifndef GL_SGIX_flush_raster
-#endif
-
-#ifndef GL_SGIX_depth_texture
-#define GL_DEPTH_COMPONENT16_SGIX         0x81A5
-#define GL_DEPTH_COMPONENT24_SGIX         0x81A6
-#define GL_DEPTH_COMPONENT32_SGIX         0x81A7
-#endif
-
-#ifndef GL_SGIS_fog_function
-#define GL_FOG_FUNC_SGIS                  0x812A
-#define GL_FOG_FUNC_POINTS_SGIS           0x812B
-#define GL_MAX_FOG_FUNC_POINTS_SGIS       0x812C
-#endif
-
-#ifndef GL_SGIX_fog_offset
-#define GL_FOG_OFFSET_SGIX                0x8198
-#define GL_FOG_OFFSET_VALUE_SGIX          0x8199
-#endif
-
-#ifndef GL_HP_image_transform
-#define GL_IMAGE_SCALE_X_HP               0x8155
-#define GL_IMAGE_SCALE_Y_HP               0x8156
-#define GL_IMAGE_TRANSLATE_X_HP           0x8157
-#define GL_IMAGE_TRANSLATE_Y_HP           0x8158
-#define GL_IMAGE_ROTATE_ANGLE_HP          0x8159
-#define GL_IMAGE_ROTATE_ORIGIN_X_HP       0x815A
-#define GL_IMAGE_ROTATE_ORIGIN_Y_HP       0x815B
-#define GL_IMAGE_MAG_FILTER_HP            0x815C
-#define GL_IMAGE_MIN_FILTER_HP            0x815D
-#define GL_IMAGE_CUBIC_WEIGHT_HP          0x815E
-#define GL_CUBIC_HP                       0x815F
-#define GL_AVERAGE_HP                     0x8160
-#define GL_IMAGE_TRANSFORM_2D_HP          0x8161
-#define GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP 0x8162
-#define GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP 0x8163
-#endif
-
-#ifndef GL_HP_convolution_border_modes
-#define GL_IGNORE_BORDER_HP               0x8150
-#define GL_CONSTANT_BORDER_HP             0x8151
-#define GL_REPLICATE_BORDER_HP            0x8153
-#define GL_CONVOLUTION_BORDER_COLOR_HP    0x8154
-#endif
-
-#ifndef GL_INGR_palette_buffer
-#endif
-
-#ifndef GL_SGIX_texture_add_env
-#define GL_TEXTURE_ENV_BIAS_SGIX          0x80BE
-#endif
-
-#ifndef GL_EXT_color_subtable
-#endif
-
-#ifndef GL_PGI_vertex_hints
-#define GL_VERTEX_DATA_HINT_PGI           0x1A22A
-#define GL_VERTEX_CONSISTENT_HINT_PGI     0x1A22B
-#define GL_MATERIAL_SIDE_HINT_PGI         0x1A22C
-#define GL_MAX_VERTEX_HINT_PGI            0x1A22D
-#define GL_COLOR3_BIT_PGI                 0x00010000
-#define GL_COLOR4_BIT_PGI                 0x00020000
-#define GL_EDGEFLAG_BIT_PGI               0x00040000
-#define GL_INDEX_BIT_PGI                  0x00080000
-#define GL_MAT_AMBIENT_BIT_PGI            0x00100000
-#define GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI 0x00200000
-#define GL_MAT_DIFFUSE_BIT_PGI            0x00400000
-#define GL_MAT_EMISSION_BIT_PGI           0x00800000
-#define GL_MAT_COLOR_INDEXES_BIT_PGI      0x01000000
-#define GL_MAT_SHININESS_BIT_PGI          0x02000000
-#define GL_MAT_SPECULAR_BIT_PGI           0x04000000
-#define GL_NORMAL_BIT_PGI                 0x08000000
-#define GL_TEXCOORD1_BIT_PGI              0x10000000
-#define GL_TEXCOORD2_BIT_PGI              0x20000000
-#define GL_TEXCOORD3_BIT_PGI              0x40000000
-#define GL_TEXCOORD4_BIT_PGI              0x80000000
-#define GL_VERTEX23_BIT_PGI               0x00000004
-#define GL_VERTEX4_BIT_PGI                0x00000008
-#endif
-
-#ifndef GL_PGI_misc_hints
-#define GL_PREFER_DOUBLEBUFFER_HINT_PGI   0x1A1F8
-#define GL_CONSERVE_MEMORY_HINT_PGI       0x1A1FD
-#define GL_RECLAIM_MEMORY_HINT_PGI        0x1A1FE
-#define GL_NATIVE_GRAPHICS_HANDLE_PGI     0x1A202
-#define GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI 0x1A203
-#define GL_NATIVE_GRAPHICS_END_HINT_PGI   0x1A204
-#define GL_ALWAYS_FAST_HINT_PGI           0x1A20C
-#define GL_ALWAYS_SOFT_HINT_PGI           0x1A20D
-#define GL_ALLOW_DRAW_OBJ_HINT_PGI        0x1A20E
-#define GL_ALLOW_DRAW_WIN_HINT_PGI        0x1A20F
-#define GL_ALLOW_DRAW_FRG_HINT_PGI        0x1A210
-#define GL_ALLOW_DRAW_MEM_HINT_PGI        0x1A211
-#define GL_STRICT_DEPTHFUNC_HINT_PGI      0x1A216
-#define GL_STRICT_LIGHTING_HINT_PGI       0x1A217
-#define GL_STRICT_SCISSOR_HINT_PGI        0x1A218
-#define GL_FULL_STIPPLE_HINT_PGI          0x1A219
-#define GL_CLIP_NEAR_HINT_PGI             0x1A220
-#define GL_CLIP_FAR_HINT_PGI              0x1A221
-#define GL_WIDE_LINE_HINT_PGI             0x1A222
-#define GL_BACK_NORMALS_HINT_PGI          0x1A223
-#endif
-
-#ifndef GL_EXT_paletted_texture
-#define GL_COLOR_INDEX1_EXT               0x80E2
-#define GL_COLOR_INDEX2_EXT               0x80E3
-#define GL_COLOR_INDEX4_EXT               0x80E4
-#define GL_COLOR_INDEX8_EXT               0x80E5
-#define GL_COLOR_INDEX12_EXT              0x80E6
-#define GL_COLOR_INDEX16_EXT              0x80E7
-#define GL_TEXTURE_INDEX_SIZE_EXT         0x80ED
-#endif
-
-#ifndef GL_EXT_clip_volume_hint
-#define GL_CLIP_VOLUME_CLIPPING_HINT_EXT  0x80F0
-#endif
-
-#ifndef GL_SGIX_list_priority
-#define GL_LIST_PRIORITY_SGIX             0x8182
-#endif
-
-#ifndef GL_SGIX_ir_instrument1
-#define GL_IR_INSTRUMENT1_SGIX            0x817F
-#endif
-
-#ifndef GL_SGIX_calligraphic_fragment
-#define GL_CALLIGRAPHIC_FRAGMENT_SGIX     0x8183
-#endif
-
-#ifndef GL_SGIX_texture_lod_bias
-#define GL_TEXTURE_LOD_BIAS_S_SGIX        0x818E
-#define GL_TEXTURE_LOD_BIAS_T_SGIX        0x818F
-#define GL_TEXTURE_LOD_BIAS_R_SGIX        0x8190
-#endif
-
-#ifndef GL_SGIX_shadow_ambient
-#define GL_SHADOW_AMBIENT_SGIX            0x80BF
-#endif
-
-#ifndef GL_EXT_index_texture
-#endif
-
-#ifndef GL_EXT_index_material
-#define GL_INDEX_MATERIAL_EXT             0x81B8
-#define GL_INDEX_MATERIAL_PARAMETER_EXT   0x81B9
-#define GL_INDEX_MATERIAL_FACE_EXT        0x81BA
-#endif
-
-#ifndef GL_EXT_index_func
-#define GL_INDEX_TEST_EXT                 0x81B5
-#define GL_INDEX_TEST_FUNC_EXT            0x81B6
-#define GL_INDEX_TEST_REF_EXT             0x81B7
-#endif
-
-#ifndef GL_EXT_index_array_formats
-#define GL_IUI_V2F_EXT                    0x81AD
-#define GL_IUI_V3F_EXT                    0x81AE
-#define GL_IUI_N3F_V2F_EXT                0x81AF
-#define GL_IUI_N3F_V3F_EXT                0x81B0
-#define GL_T2F_IUI_V2F_EXT                0x81B1
-#define GL_T2F_IUI_V3F_EXT                0x81B2
-#define GL_T2F_IUI_N3F_V2F_EXT            0x81B3
-#define GL_T2F_IUI_N3F_V3F_EXT            0x81B4
-#endif
-
-#ifndef GL_EXT_compiled_vertex_array
-#define GL_ARRAY_ELEMENT_LOCK_FIRST_EXT   0x81A8
-#define GL_ARRAY_ELEMENT_LOCK_COUNT_EXT   0x81A9
-#endif
-
-#ifndef GL_EXT_cull_vertex
-#define GL_CULL_VERTEX_EXT                0x81AA
-#define GL_CULL_VERTEX_EYE_POSITION_EXT   0x81AB
-#define GL_CULL_VERTEX_OBJECT_POSITION_EXT 0x81AC
-#endif
-
-#ifndef GL_SGIX_ycrcb
-#define GL_YCRCB_422_SGIX                 0x81BB
-#define GL_YCRCB_444_SGIX                 0x81BC
-#endif
-
-#ifndef GL_SGIX_fragment_lighting
-#define GL_FRAGMENT_LIGHTING_SGIX         0x8400
-#define GL_FRAGMENT_COLOR_MATERIAL_SGIX   0x8401
-#define GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX 0x8402
-#define GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX 0x8403
-#define GL_MAX_FRAGMENT_LIGHTS_SGIX       0x8404
-#define GL_MAX_ACTIVE_LIGHTS_SGIX         0x8405
-#define GL_CURRENT_RASTER_NORMAL_SGIX     0x8406
-#define GL_LIGHT_ENV_MODE_SGIX            0x8407
-#define GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX 0x8408
-#define GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX 0x8409
-#define GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX 0x840A
-#define GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX 0x840B
-#define GL_FRAGMENT_LIGHT0_SGIX           0x840C
-#define GL_FRAGMENT_LIGHT1_SGIX           0x840D
-#define GL_FRAGMENT_LIGHT2_SGIX           0x840E
-#define GL_FRAGMENT_LIGHT3_SGIX           0x840F
-#define GL_FRAGMENT_LIGHT4_SGIX           0x8410
-#define GL_FRAGMENT_LIGHT5_SGIX           0x8411
-#define GL_FRAGMENT_LIGHT6_SGIX           0x8412
-#define GL_FRAGMENT_LIGHT7_SGIX           0x8413
-#endif
-
-#ifndef GL_IBM_rasterpos_clip
-#define GL_RASTER_POSITION_UNCLIPPED_IBM  0x19262
-#endif
-
-#ifndef GL_HP_texture_lighting
-#define GL_TEXTURE_LIGHTING_MODE_HP       0x8167
-#define GL_TEXTURE_POST_SPECULAR_HP       0x8168
-#define GL_TEXTURE_PRE_SPECULAR_HP        0x8169
-#endif
-
-#ifndef GL_EXT_draw_range_elements
-#define GL_MAX_ELEMENTS_VERTICES_EXT      0x80E8
-#define GL_MAX_ELEMENTS_INDICES_EXT       0x80E9
-#endif
-
-#ifndef GL_WIN_phong_shading
-#define GL_PHONG_WIN                      0x80EA
-#define GL_PHONG_HINT_WIN                 0x80EB
-#endif
-
-#ifndef GL_WIN_specular_fog
-#define GL_FOG_SPECULAR_TEXTURE_WIN       0x80EC
-#endif
-
-#ifndef GL_EXT_light_texture
-#define GL_FRAGMENT_MATERIAL_EXT          0x8349
-#define GL_FRAGMENT_NORMAL_EXT            0x834A
-#define GL_FRAGMENT_COLOR_EXT             0x834C
-#define GL_ATTENUATION_EXT                0x834D
-#define GL_SHADOW_ATTENUATION_EXT         0x834E
-#define GL_TEXTURE_APPLICATION_MODE_EXT   0x834F
-#define GL_TEXTURE_LIGHT_EXT              0x8350
-#define GL_TEXTURE_MATERIAL_FACE_EXT      0x8351
-#define GL_TEXTURE_MATERIAL_PARAMETER_EXT 0x8352
-  /* reuse GL_FRAGMENT_DEPTH_EXT */
-#endif
-
-#ifndef GL_SGIX_blend_alpha_minmax
-#define GL_ALPHA_MIN_SGIX                 0x8320
-#define GL_ALPHA_MAX_SGIX                 0x8321
-#endif
-
-#ifndef GL_SGIX_impact_pixel_texture
-#define GL_PIXEL_TEX_GEN_Q_CEILING_SGIX   0x8184
-#define GL_PIXEL_TEX_GEN_Q_ROUND_SGIX     0x8185
-#define GL_PIXEL_TEX_GEN_Q_FLOOR_SGIX     0x8186
-#define GL_PIXEL_TEX_GEN_ALPHA_REPLACE_SGIX 0x8187
-#define GL_PIXEL_TEX_GEN_ALPHA_NO_REPLACE_SGIX 0x8188
-#define GL_PIXEL_TEX_GEN_ALPHA_LS_SGIX    0x8189
-#define GL_PIXEL_TEX_GEN_ALPHA_MS_SGIX    0x818A
-#endif
-
-#ifndef GL_EXT_bgra
-#define GL_BGR_EXT                        0x80E0
-#define GL_BGRA_EXT                       0x80E1
-#endif
-
-#ifndef GL_SGIX_async
-#define GL_ASYNC_MARKER_SGIX              0x8329
-#endif
-
-#ifndef GL_SGIX_async_pixel
-#define GL_ASYNC_TEX_IMAGE_SGIX           0x835C
-#define GL_ASYNC_DRAW_PIXELS_SGIX         0x835D
-#define GL_ASYNC_READ_PIXELS_SGIX         0x835E
-#define GL_MAX_ASYNC_TEX_IMAGE_SGIX       0x835F
-#define GL_MAX_ASYNC_DRAW_PIXELS_SGIX     0x8360
-#define GL_MAX_ASYNC_READ_PIXELS_SGIX     0x8361
-#endif
-
-#ifndef GL_SGIX_async_histogram
-#define GL_ASYNC_HISTOGRAM_SGIX           0x832C
-#define GL_MAX_ASYNC_HISTOGRAM_SGIX       0x832D
-#endif
-
-#ifndef GL_INTEL_texture_scissor
-#endif
-
-#ifndef GL_INTEL_parallel_arrays
-#define GL_PARALLEL_ARRAYS_INTEL          0x83F4
-#define GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL 0x83F5
-#define GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL 0x83F6
-#define GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL 0x83F7
-#define GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL 0x83F8
-#endif
-
-#ifndef GL_HP_occlusion_test
-#define GL_OCCLUSION_TEST_HP              0x8165
-#define GL_OCCLUSION_TEST_RESULT_HP       0x8166
-#endif
-
-#ifndef GL_EXT_pixel_transform
-#define GL_PIXEL_TRANSFORM_2D_EXT         0x8330
-#define GL_PIXEL_MAG_FILTER_EXT           0x8331
-#define GL_PIXEL_MIN_FILTER_EXT           0x8332
-#define GL_PIXEL_CUBIC_WEIGHT_EXT         0x8333
-#define GL_CUBIC_EXT                      0x8334
-#define GL_AVERAGE_EXT                    0x8335
-#define GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT 0x8336
-#define GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT 0x8337
-#define GL_PIXEL_TRANSFORM_2D_MATRIX_EXT  0x8338
-#endif
-
-#ifndef GL_EXT_pixel_transform_color_table
-#endif
-
-#ifndef GL_EXT_shared_texture_palette
-#define GL_SHARED_TEXTURE_PALETTE_EXT     0x81FB
-#endif
-
-#ifndef GL_EXT_separate_specular_color
-#define GL_LIGHT_MODEL_COLOR_CONTROL_EXT  0x81F8
-#define GL_SINGLE_COLOR_EXT               0x81F9
-#define GL_SEPARATE_SPECULAR_COLOR_EXT    0x81FA
-#endif
-
-#ifndef GL_EXT_secondary_color
-#define GL_COLOR_SUM_EXT                  0x8458
-#define GL_CURRENT_SECONDARY_COLOR_EXT    0x8459
-#define GL_SECONDARY_COLOR_ARRAY_SIZE_EXT 0x845A
-#define GL_SECONDARY_COLOR_ARRAY_TYPE_EXT 0x845B
-#define GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT 0x845C
-#define GL_SECONDARY_COLOR_ARRAY_POINTER_EXT 0x845D
-#define GL_SECONDARY_COLOR_ARRAY_EXT      0x845E
-#endif
-
-#ifndef GL_EXT_texture_perturb_normal
-#define GL_PERTURB_EXT                    0x85AE
-#define GL_TEXTURE_NORMAL_EXT             0x85AF
-#endif
-
-#ifndef GL_EXT_multi_draw_arrays
-#endif
-
-#ifndef GL_EXT_fog_coord
-#define GL_FOG_COORDINATE_SOURCE_EXT      0x8450
-#define GL_FOG_COORDINATE_EXT             0x8451
-#define GL_FRAGMENT_DEPTH_EXT             0x8452
-#define GL_CURRENT_FOG_COORDINATE_EXT     0x8453
-#define GL_FOG_COORDINATE_ARRAY_TYPE_EXT  0x8454
-#define GL_FOG_COORDINATE_ARRAY_STRIDE_EXT 0x8455
-#define GL_FOG_COORDINATE_ARRAY_POINTER_EXT 0x8456
-#define GL_FOG_COORDINATE_ARRAY_EXT       0x8457
-#endif
-
-#ifndef GL_REND_screen_coordinates
-#define GL_SCREEN_COORDINATES_REND        0x8490
-#define GL_INVERTED_SCREEN_W_REND         0x8491
-#endif
-
-#ifndef GL_EXT_coordinate_frame
-#define GL_TANGENT_ARRAY_EXT              0x8439
-#define GL_BINORMAL_ARRAY_EXT             0x843A
-#define GL_CURRENT_TANGENT_EXT            0x843B
-#define GL_CURRENT_BINORMAL_EXT           0x843C
-#define GL_TANGENT_ARRAY_TYPE_EXT         0x843E
-#define GL_TANGENT_ARRAY_STRIDE_EXT       0x843F
-#define GL_BINORMAL_ARRAY_TYPE_EXT        0x8440
-#define GL_BINORMAL_ARRAY_STRIDE_EXT      0x8441
-#define GL_TANGENT_ARRAY_POINTER_EXT      0x8442
-#define GL_BINORMAL_ARRAY_POINTER_EXT     0x8443
-#define GL_MAP1_TANGENT_EXT               0x8444
-#define GL_MAP2_TANGENT_EXT               0x8445
-#define GL_MAP1_BINORMAL_EXT              0x8446
-#define GL_MAP2_BINORMAL_EXT              0x8447
-#endif
-
-#ifndef GL_EXT_texture_env_combine
-#define GL_COMBINE_EXT                    0x8570
-#define GL_COMBINE_RGB_EXT                0x8571
-#define GL_COMBINE_ALPHA_EXT              0x8572
-#define GL_RGB_SCALE_EXT                  0x8573
-#define GL_ADD_SIGNED_EXT                 0x8574
-#define GL_INTERPOLATE_EXT                0x8575
-#define GL_CONSTANT_EXT                   0x8576
-#define GL_PRIMARY_COLOR_EXT              0x8577
-#define GL_PREVIOUS_EXT                   0x8578
-#define GL_SOURCE0_RGB_EXT                0x8580
-#define GL_SOURCE1_RGB_EXT                0x8581
-#define GL_SOURCE2_RGB_EXT                0x8582
-#define GL_SOURCE0_ALPHA_EXT              0x8588
-#define GL_SOURCE1_ALPHA_EXT              0x8589
-#define GL_SOURCE2_ALPHA_EXT              0x858A
-#define GL_OPERAND0_RGB_EXT               0x8590
-#define GL_OPERAND1_RGB_EXT               0x8591
-#define GL_OPERAND2_RGB_EXT               0x8592
-#define GL_OPERAND0_ALPHA_EXT             0x8598
-#define GL_OPERAND1_ALPHA_EXT             0x8599
-#define GL_OPERAND2_ALPHA_EXT             0x859A
-#endif
-
-#ifndef GL_APPLE_specular_vector
-#define GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE 0x85B0
-#endif
-
-#ifndef GL_APPLE_transform_hint
-#define GL_TRANSFORM_HINT_APPLE           0x85B1
-#endif
-
-#ifndef GL_SGIX_fog_scale
-#define GL_FOG_SCALE_SGIX                 0x81FC
-#define GL_FOG_SCALE_VALUE_SGIX           0x81FD
-#endif
-
-#ifndef GL_SUNX_constant_data
-#define GL_UNPACK_CONSTANT_DATA_SUNX      0x81D5
-#define GL_TEXTURE_CONSTANT_DATA_SUNX     0x81D6
-#endif
-
-#ifndef GL_SUN_global_alpha
-#define GL_GLOBAL_ALPHA_SUN               0x81D9
-#define GL_GLOBAL_ALPHA_FACTOR_SUN        0x81DA
-#endif
-
-#ifndef GL_SUN_triangle_list
-#define GL_RESTART_SUN                    0x0001
-#define GL_REPLACE_MIDDLE_SUN             0x0002
-#define GL_REPLACE_OLDEST_SUN             0x0003
-#define GL_TRIANGLE_LIST_SUN              0x81D7
-#define GL_REPLACEMENT_CODE_SUN           0x81D8
-#define GL_REPLACEMENT_CODE_ARRAY_SUN     0x85C0
-#define GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN 0x85C1
-#define GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN 0x85C2
-#define GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN 0x85C3
-#define GL_R1UI_V3F_SUN                   0x85C4
-#define GL_R1UI_C4UB_V3F_SUN              0x85C5
-#define GL_R1UI_C3F_V3F_SUN               0x85C6
-#define GL_R1UI_N3F_V3F_SUN               0x85C7
-#define GL_R1UI_C4F_N3F_V3F_SUN           0x85C8
-#define GL_R1UI_T2F_V3F_SUN               0x85C9
-#define GL_R1UI_T2F_N3F_V3F_SUN           0x85CA
-#define GL_R1UI_T2F_C4F_N3F_V3F_SUN       0x85CB
-#endif
-
-#ifndef GL_SUN_vertex
-#endif
-
-#ifndef GL_EXT_blend_func_separate
-#define GL_BLEND_DST_RGB_EXT              0x80C8
-#define GL_BLEND_SRC_RGB_EXT              0x80C9
-#define GL_BLEND_DST_ALPHA_EXT            0x80CA
-#define GL_BLEND_SRC_ALPHA_EXT            0x80CB
-#endif
-
-#ifndef GL_INGR_color_clamp
-#define GL_RED_MIN_CLAMP_INGR             0x8560
-#define GL_GREEN_MIN_CLAMP_INGR           0x8561
-#define GL_BLUE_MIN_CLAMP_INGR            0x8562
-#define GL_ALPHA_MIN_CLAMP_INGR           0x8563
-#define GL_RED_MAX_CLAMP_INGR             0x8564
-#define GL_GREEN_MAX_CLAMP_INGR           0x8565
-#define GL_BLUE_MAX_CLAMP_INGR            0x8566
-#define GL_ALPHA_MAX_CLAMP_INGR           0x8567
-#endif
-
-#ifndef GL_INGR_interlace_read
-#define GL_INTERLACE_READ_INGR            0x8568
-#endif
-
-#ifndef GL_EXT_stencil_wrap
-#define GL_INCR_WRAP_EXT                  0x8507
-#define GL_DECR_WRAP_EXT                  0x8508
-#endif
-
-#ifndef GL_EXT_422_pixels
-#define GL_422_EXT                        0x80CC
-#define GL_422_REV_EXT                    0x80CD
-#define GL_422_AVERAGE_EXT                0x80CE
-#define GL_422_REV_AVERAGE_EXT            0x80CF
-#endif
-
-#ifndef GL_NV_texgen_reflection
-#define GL_NORMAL_MAP_NV                  0x8511
-#define GL_REFLECTION_MAP_NV              0x8512
-#endif
-
-#ifndef GL_EXT_texture_cube_map
-#define GL_NORMAL_MAP_EXT                 0x8511
-#define GL_REFLECTION_MAP_EXT             0x8512
-#define GL_TEXTURE_CUBE_MAP_EXT           0x8513
-#define GL_TEXTURE_BINDING_CUBE_MAP_EXT   0x8514
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT 0x8515
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT 0x8516
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT 0x8517
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT 0x8518
-#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT 0x8519
-#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT 0x851A
-#define GL_PROXY_TEXTURE_CUBE_MAP_EXT     0x851B
-#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT  0x851C
-#endif
-
-#ifndef GL_SUN_convolution_border_modes
-#define GL_WRAP_BORDER_SUN                0x81D4
-#endif
-
-#ifndef GL_EXT_texture_env_add
-#endif
-
-#ifndef GL_EXT_texture_lod_bias
-#define GL_MAX_TEXTURE_LOD_BIAS_EXT       0x84FD
-#define GL_TEXTURE_FILTER_CONTROL_EXT     0x8500
-#define GL_TEXTURE_LOD_BIAS_EXT           0x8501
-#endif
-
-#ifndef GL_EXT_texture_filter_anisotropic
-#define GL_TEXTURE_MAX_ANISOTROPY_EXT     0x84FE
-#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT 0x84FF
-#endif
-
-#ifndef GL_EXT_vertex_weighting
-#define GL_MODELVIEW0_STACK_DEPTH_EXT     GL_MODELVIEW_STACK_DEPTH
-#define GL_MODELVIEW1_STACK_DEPTH_EXT     0x8502
-#define GL_MODELVIEW0_MATRIX_EXT          GL_MODELVIEW_MATRIX
-#define GL_MODELVIEW1_MATRIX_EXT          0x8506
-#define GL_VERTEX_WEIGHTING_EXT           0x8509
-#define GL_MODELVIEW0_EXT                 GL_MODELVIEW
-#define GL_MODELVIEW1_EXT                 0x850A
-#define GL_CURRENT_VERTEX_WEIGHT_EXT      0x850B
-#define GL_VERTEX_WEIGHT_ARRAY_EXT        0x850C
-#define GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT   0x850D
-#define GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT   0x850E
-#define GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT 0x850F
-#define GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT 0x8510
-#endif
-
-#ifndef GL_NV_light_max_exponent
-#define GL_MAX_SHININESS_NV               0x8504
-#define GL_MAX_SPOT_EXPONENT_NV           0x8505
-#endif
-
-#ifndef GL_NV_vertex_array_range
-#define GL_VERTEX_ARRAY_RANGE_NV          0x851D
-#define GL_VERTEX_ARRAY_RANGE_LENGTH_NV   0x851E
-#define GL_VERTEX_ARRAY_RANGE_VALID_NV    0x851F
-#define GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV 0x8520
-#define GL_VERTEX_ARRAY_RANGE_POINTER_NV  0x8521
-#endif
-
-#ifndef GL_NV_register_combiners
-#define GL_REGISTER_COMBINERS_NV          0x8522
-#define GL_VARIABLE_A_NV                  0x8523
-#define GL_VARIABLE_B_NV                  0x8524
-#define GL_VARIABLE_C_NV                  0x8525
-#define GL_VARIABLE_D_NV                  0x8526
-#define GL_VARIABLE_E_NV                  0x8527
-#define GL_VARIABLE_F_NV                  0x8528
-#define GL_VARIABLE_G_NV                  0x8529
-#define GL_CONSTANT_COLOR0_NV             0x852A
-#define GL_CONSTANT_COLOR1_NV             0x852B
-#define GL_PRIMARY_COLOR_NV               0x852C
-#define GL_SECONDARY_COLOR_NV             0x852D
-#define GL_SPARE0_NV                      0x852E
-#define GL_SPARE1_NV                      0x852F
-#define GL_DISCARD_NV                     0x8530
-#define GL_E_TIMES_F_NV                   0x8531
-#define GL_SPARE0_PLUS_SECONDARY_COLOR_NV 0x8532
-#define GL_UNSIGNED_IDENTITY_NV           0x8536
-#define GL_UNSIGNED_INVERT_NV             0x8537
-#define GL_EXPAND_NORMAL_NV               0x8538
-#define GL_EXPAND_NEGATE_NV               0x8539
-#define GL_HALF_BIAS_NORMAL_NV            0x853A
-#define GL_HALF_BIAS_NEGATE_NV            0x853B
-#define GL_SIGNED_IDENTITY_NV             0x853C
-#define GL_SIGNED_NEGATE_NV               0x853D
-#define GL_SCALE_BY_TWO_NV                0x853E
-#define GL_SCALE_BY_FOUR_NV               0x853F
-#define GL_SCALE_BY_ONE_HALF_NV           0x8540
-#define GL_BIAS_BY_NEGATIVE_ONE_HALF_NV   0x8541
-#define GL_COMBINER_INPUT_NV              0x8542
-#define GL_COMBINER_MAPPING_NV            0x8543
-#define GL_COMBINER_COMPONENT_USAGE_NV    0x8544
-#define GL_COMBINER_AB_DOT_PRODUCT_NV     0x8545
-#define GL_COMBINER_CD_DOT_PRODUCT_NV     0x8546
-#define GL_COMBINER_MUX_SUM_NV            0x8547
-#define GL_COMBINER_SCALE_NV              0x8548
-#define GL_COMBINER_BIAS_NV               0x8549
-#define GL_COMBINER_AB_OUTPUT_NV          0x854A
-#define GL_COMBINER_CD_OUTPUT_NV          0x854B
-#define GL_COMBINER_SUM_OUTPUT_NV         0x854C
-#define GL_MAX_GENERAL_COMBINERS_NV       0x854D
-#define GL_NUM_GENERAL_COMBINERS_NV       0x854E
-#define GL_COLOR_SUM_CLAMP_NV             0x854F
-#define GL_COMBINER0_NV                   0x8550
-#define GL_COMBINER1_NV                   0x8551
-#define GL_COMBINER2_NV                   0x8552
-#define GL_COMBINER3_NV                   0x8553
-#define GL_COMBINER4_NV                   0x8554
-#define GL_COMBINER5_NV                   0x8555
-#define GL_COMBINER6_NV                   0x8556
-#define GL_COMBINER7_NV                   0x8557
-  /* reuse GL_TEXTURE0_ARB */
-  /* reuse GL_TEXTURE1_ARB */
-  /* reuse GL_ZERO */
-  /* reuse GL_NONE */
-  /* reuse GL_FOG */
-#endif
-
-#ifndef GL_NV_fog_distance
-#define GL_FOG_DISTANCE_MODE_NV           0x855A
-#define GL_EYE_RADIAL_NV                  0x855B
-#define GL_EYE_PLANE_ABSOLUTE_NV          0x855C
-  /* reuse GL_EYE_PLANE */
-#endif
-
-#ifndef GL_NV_texgen_emboss
-#define GL_EMBOSS_LIGHT_NV                0x855D
-#define GL_EMBOSS_CONSTANT_NV             0x855E
-#define GL_EMBOSS_MAP_NV                  0x855F
-#endif
-
-#ifndef GL_NV_blend_square
-#endif
-
-#ifndef GL_NV_texture_env_combine4
-#define GL_COMBINE4_NV                    0x8503
-#define GL_SOURCE3_RGB_NV                 0x8583
-#define GL_SOURCE3_ALPHA_NV               0x858B
-#define GL_OPERAND3_RGB_NV                0x8593
-#define GL_OPERAND3_ALPHA_NV              0x859B
-#endif
-
-#ifndef GL_MESA_resize_buffers
-#endif
-
-#ifndef GL_MESA_window_pos
-#endif
-
-#ifndef GL_EXT_texture_compression_s3tc
-#define GL_COMPRESSED_RGB_S3TC_DXT1_EXT   0x83F0
-#define GL_COMPRESSED_RGBA_S3TC_DXT1_EXT  0x83F1
-#define GL_COMPRESSED_RGBA_S3TC_DXT3_EXT  0x83F2
-#define GL_COMPRESSED_RGBA_S3TC_DXT5_EXT  0x83F3
-#endif
-
-#ifndef GL_IBM_cull_vertex
-#define GL_CULL_VERTEX_IBM                103050
-#endif
-
-#ifndef GL_IBM_multimode_draw_arrays
-#endif
-
-#ifndef GL_IBM_vertex_array_lists
-#define GL_VERTEX_ARRAY_LIST_IBM          103070
-#define GL_NORMAL_ARRAY_LIST_IBM          103071
-#define GL_COLOR_ARRAY_LIST_IBM           103072
-#define GL_INDEX_ARRAY_LIST_IBM           103073
-#define GL_TEXTURE_COORD_ARRAY_LIST_IBM   103074
-#define GL_EDGE_FLAG_ARRAY_LIST_IBM       103075
-#define GL_FOG_COORDINATE_ARRAY_LIST_IBM  103076
-#define GL_SECONDARY_COLOR_ARRAY_LIST_IBM 103077
-#define GL_VERTEX_ARRAY_LIST_STRIDE_IBM   103080
-#define GL_NORMAL_ARRAY_LIST_STRIDE_IBM   103081
-#define GL_COLOR_ARRAY_LIST_STRIDE_IBM    103082
-#define GL_INDEX_ARRAY_LIST_STRIDE_IBM    103083
-#define GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM 103084
-#define GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM 103085
-#define GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM 103086
-#define GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM 103087
-#endif
-
-#ifndef GL_SGIX_subsample
-#define GL_PACK_SUBSAMPLE_RATE_SGIX       0x85A0
-#define GL_UNPACK_SUBSAMPLE_RATE_SGIX     0x85A1
-#define GL_PIXEL_SUBSAMPLE_4444_SGIX      0x85A2
-#define GL_PIXEL_SUBSAMPLE_2424_SGIX      0x85A3
-#define GL_PIXEL_SUBSAMPLE_4242_SGIX      0x85A4
-#endif
-
-#ifndef GL_SGIX_ycrcb_subsample
-#endif
-
-#ifndef GL_SGIX_ycrcba
-#define GL_YCRCB_SGIX                     0x8318
-#define GL_YCRCBA_SGIX                    0x8319
-#endif
-
-#ifndef GL_SGI_depth_pass_instrument
-#define GL_DEPTH_PASS_INSTRUMENT_SGIX     0x8310
-#define GL_DEPTH_PASS_INSTRUMENT_COUNTERS_SGIX 0x8311
-#define GL_DEPTH_PASS_INSTRUMENT_MAX_SGIX 0x8312
-#endif
-
-#ifndef GL_3DFX_texture_compression_FXT1
-#define GL_COMPRESSED_RGB_FXT1_3DFX       0x86B0
-#define GL_COMPRESSED_RGBA_FXT1_3DFX      0x86B1
-#endif
-
-#ifndef GL_3DFX_multisample
-#define GL_MULTISAMPLE_3DFX               0x86B2
-#define GL_SAMPLE_BUFFERS_3DFX            0x86B3
-#define GL_SAMPLES_3DFX                   0x86B4
-#define GL_MULTISAMPLE_BIT_3DFX           0x20000000
-#endif
-
-#ifndef GL_3DFX_tbuffer
-#endif
-
-#ifndef GL_EXT_multisample
-#define GL_MULTISAMPLE_EXT                0x809D
-#define GL_SAMPLE_ALPHA_TO_MASK_EXT       0x809E
-#define GL_SAMPLE_ALPHA_TO_ONE_EXT        0x809F
-#define GL_SAMPLE_MASK_EXT                0x80A0
-#define GL_1PASS_EXT                      0x80A1
-#define GL_2PASS_0_EXT                    0x80A2
-#define GL_2PASS_1_EXT                    0x80A3
-#define GL_4PASS_0_EXT                    0x80A4
-#define GL_4PASS_1_EXT                    0x80A5
-#define GL_4PASS_2_EXT                    0x80A6
-#define GL_4PASS_3_EXT                    0x80A7
-#define GL_SAMPLE_BUFFERS_EXT             0x80A8
-#define GL_SAMPLES_EXT                    0x80A9
-#define GL_SAMPLE_MASK_VALUE_EXT          0x80AA
-#define GL_SAMPLE_MASK_INVERT_EXT         0x80AB
-#define GL_SAMPLE_PATTERN_EXT             0x80AC
-#define GL_MULTISAMPLE_BIT_EXT            0x20000000
-#endif
-
-#ifndef GL_SGIX_vertex_preclip
-#define GL_VERTEX_PRECLIP_SGIX            0x83EE
-#define GL_VERTEX_PRECLIP_HINT_SGIX       0x83EF
-#endif
-
-#ifndef GL_SGIX_convolution_accuracy
-#define GL_CONVOLUTION_HINT_SGIX          0x8316
-#endif
-
-#ifndef GL_SGIX_resample
-#define GL_PACK_RESAMPLE_SGIX             0x842C
-#define GL_UNPACK_RESAMPLE_SGIX           0x842D
-#define GL_RESAMPLE_REPLICATE_SGIX        0x842E
-#define GL_RESAMPLE_ZERO_FILL_SGIX        0x842F
-#define GL_RESAMPLE_DECIMATE_SGIX         0x8430
-#endif
-
-#ifndef GL_SGIS_point_line_texgen
-#define GL_EYE_DISTANCE_TO_POINT_SGIS     0x81F0
-#define GL_OBJECT_DISTANCE_TO_POINT_SGIS  0x81F1
-#define GL_EYE_DISTANCE_TO_LINE_SGIS      0x81F2
-#define GL_OBJECT_DISTANCE_TO_LINE_SGIS   0x81F3
-#define GL_EYE_POINT_SGIS                 0x81F4
-#define GL_OBJECT_POINT_SGIS              0x81F5
-#define GL_EYE_LINE_SGIS                  0x81F6
-#define GL_OBJECT_LINE_SGIS               0x81F7
-#endif
-
-#ifndef GL_SGIS_texture_color_mask
-#define GL_TEXTURE_COLOR_WRITEMASK_SGIS   0x81EF
-#endif
-
-#ifndef GL_EXT_texture_env_dot3
-#define GL_DOT3_RGB_EXT                   0x8740
-#define GL_DOT3_RGBA_EXT                  0x8741
-#endif
-
-#ifndef GL_ATI_texture_mirror_once
-#define GL_MIRROR_CLAMP_ATI               0x8742
-#define GL_MIRROR_CLAMP_TO_EDGE_ATI       0x8743
-#endif
-
-#ifndef GL_NV_fence
-#define GL_ALL_COMPLETED_NV               0x84F2
-#define GL_FENCE_STATUS_NV                0x84F3
-#define GL_FENCE_CONDITION_NV             0x84F4
-#endif
-
-#ifndef GL_IBM_texture_mirrored_repeat
-#define GL_MIRRORED_REPEAT_IBM            0x8370
-#endif
-
-#ifndef GL_NV_evaluators
-#define GL_EVAL_2D_NV                     0x86C0
-#define GL_EVAL_TRIANGULAR_2D_NV          0x86C1
-#define GL_MAP_TESSELLATION_NV            0x86C2
-#define GL_MAP_ATTRIB_U_ORDER_NV          0x86C3
-#define GL_MAP_ATTRIB_V_ORDER_NV          0x86C4
-#define GL_EVAL_FRACTIONAL_TESSELLATION_NV 0x86C5
-#define GL_EVAL_VERTEX_ATTRIB0_NV         0x86C6
-#define GL_EVAL_VERTEX_ATTRIB1_NV         0x86C7
-#define GL_EVAL_VERTEX_ATTRIB2_NV         0x86C8
-#define GL_EVAL_VERTEX_ATTRIB3_NV         0x86C9
-#define GL_EVAL_VERTEX_ATTRIB4_NV         0x86CA
-#define GL_EVAL_VERTEX_ATTRIB5_NV         0x86CB
-#define GL_EVAL_VERTEX_ATTRIB6_NV         0x86CC
-#define GL_EVAL_VERTEX_ATTRIB7_NV         0x86CD
-#define GL_EVAL_VERTEX_ATTRIB8_NV         0x86CE
-#define GL_EVAL_VERTEX_ATTRIB9_NV         0x86CF
-#define GL_EVAL_VERTEX_ATTRIB10_NV        0x86D0
-#define GL_EVAL_VERTEX_ATTRIB11_NV        0x86D1
-#define GL_EVAL_VERTEX_ATTRIB12_NV        0x86D2
-#define GL_EVAL_VERTEX_ATTRIB13_NV        0x86D3
-#define GL_EVAL_VERTEX_ATTRIB14_NV        0x86D4
-#define GL_EVAL_VERTEX_ATTRIB15_NV        0x86D5
-#define GL_MAX_MAP_TESSELLATION_NV        0x86D6
-#define GL_MAX_RATIONAL_EVAL_ORDER_NV     0x86D7
-#endif
-
-#ifndef GL_NV_packed_depth_stencil
-#define GL_DEPTH_STENCIL_NV               0x84F9
-#define GL_UNSIGNED_INT_24_8_NV           0x84FA
-#endif
-
-#ifndef GL_NV_register_combiners2
-#define GL_PER_STAGE_CONSTANTS_NV         0x8535
-#endif
-
-#ifndef GL_NV_texture_compression_vtc
-#endif
-
-#ifndef GL_NV_texture_rectangle
-#define GL_TEXTURE_RECTANGLE_NV           0x84F5
-#define GL_TEXTURE_BINDING_RECTANGLE_NV   0x84F6
-#define GL_PROXY_TEXTURE_RECTANGLE_NV     0x84F7
-#define GL_MAX_RECTANGLE_TEXTURE_SIZE_NV  0x84F8
-#endif
-
-#ifndef GL_NV_texture_shader
-#define GL_OFFSET_TEXTURE_RECTANGLE_NV    0x864C
-#define GL_OFFSET_TEXTURE_RECTANGLE_SCALE_NV 0x864D
-#define GL_DOT_PRODUCT_TEXTURE_RECTANGLE_NV 0x864E
-#define GL_RGBA_UNSIGNED_DOT_PRODUCT_MAPPING_NV 0x86D9
-#define GL_UNSIGNED_INT_S8_S8_8_8_NV      0x86DA
-#define GL_UNSIGNED_INT_8_8_S8_S8_REV_NV  0x86DB
-#define GL_DSDT_MAG_INTENSITY_NV          0x86DC
-#define GL_SHADER_CONSISTENT_NV           0x86DD
-#define GL_TEXTURE_SHADER_NV              0x86DE
-#define GL_SHADER_OPERATION_NV            0x86DF
-#define GL_CULL_MODES_NV                  0x86E0
-#define GL_OFFSET_TEXTURE_MATRIX_NV       0x86E1
-#define GL_OFFSET_TEXTURE_SCALE_NV        0x86E2
-#define GL_OFFSET_TEXTURE_BIAS_NV         0x86E3
-#define GL_OFFSET_TEXTURE_2D_MATRIX_NV    GL_OFFSET_TEXTURE_MATRIX_NV
-#define GL_OFFSET_TEXTURE_2D_SCALE_NV     GL_OFFSET_TEXTURE_SCALE_NV
-#define GL_OFFSET_TEXTURE_2D_BIAS_NV      GL_OFFSET_TEXTURE_BIAS_NV
-#define GL_PREVIOUS_TEXTURE_INPUT_NV      0x86E4
-#define GL_CONST_EYE_NV                   0x86E5
-#define GL_PASS_THROUGH_NV                0x86E6
-#define GL_CULL_FRAGMENT_NV               0x86E7
-#define GL_OFFSET_TEXTURE_2D_NV           0x86E8
-#define GL_DEPENDENT_AR_TEXTURE_2D_NV     0x86E9
-#define GL_DEPENDENT_GB_TEXTURE_2D_NV     0x86EA
-#define GL_DOT_PRODUCT_NV                 0x86EC
-#define GL_DOT_PRODUCT_DEPTH_REPLACE_NV   0x86ED
-#define GL_DOT_PRODUCT_TEXTURE_2D_NV      0x86EE
-#define GL_DOT_PRODUCT_TEXTURE_CUBE_MAP_NV 0x86F0
-#define GL_DOT_PRODUCT_DIFFUSE_CUBE_MAP_NV 0x86F1
-#define GL_DOT_PRODUCT_REFLECT_CUBE_MAP_NV 0x86F2
-#define GL_DOT_PRODUCT_CONST_EYE_REFLECT_CUBE_MAP_NV 0x86F3
-#define GL_HILO_NV                        0x86F4
-#define GL_DSDT_NV                        0x86F5
-#define GL_DSDT_MAG_NV                    0x86F6
-#define GL_DSDT_MAG_VIB_NV                0x86F7
-#define GL_HILO16_NV                      0x86F8
-#define GL_SIGNED_HILO_NV                 0x86F9
-#define GL_SIGNED_HILO16_NV               0x86FA
-#define GL_SIGNED_RGBA_NV                 0x86FB
-#define GL_SIGNED_RGBA8_NV                0x86FC
-#define GL_SIGNED_RGB_NV                  0x86FE
-#define GL_SIGNED_RGB8_NV                 0x86FF
-#define GL_SIGNED_LUMINANCE_NV            0x8701
-#define GL_SIGNED_LUMINANCE8_NV           0x8702
-#define GL_SIGNED_LUMINANCE_ALPHA_NV      0x8703
-#define GL_SIGNED_LUMINANCE8_ALPHA8_NV    0x8704
-#define GL_SIGNED_ALPHA_NV                0x8705
-#define GL_SIGNED_ALPHA8_NV               0x8706
-#define GL_SIGNED_INTENSITY_NV            0x8707
-#define GL_SIGNED_INTENSITY8_NV           0x8708
-#define GL_DSDT8_NV                       0x8709
-#define GL_DSDT8_MAG8_NV                  0x870A
-#define GL_DSDT8_MAG8_INTENSITY8_NV       0x870B
-#define GL_SIGNED_RGB_UNSIGNED_ALPHA_NV   0x870C
-#define GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV 0x870D
-#define GL_HI_SCALE_NV                    0x870E
-#define GL_LO_SCALE_NV                    0x870F
-#define GL_DS_SCALE_NV                    0x8710
-#define GL_DT_SCALE_NV                    0x8711
-#define GL_MAGNITUDE_SCALE_NV             0x8712
-#define GL_VIBRANCE_SCALE_NV              0x8713
-#define GL_HI_BIAS_NV                     0x8714
-#define GL_LO_BIAS_NV                     0x8715
-#define GL_DS_BIAS_NV                     0x8716
-#define GL_DT_BIAS_NV                     0x8717
-#define GL_MAGNITUDE_BIAS_NV              0x8718
-#define GL_VIBRANCE_BIAS_NV               0x8719
-#define GL_TEXTURE_BORDER_VALUES_NV       0x871A
-#define GL_TEXTURE_HI_SIZE_NV             0x871B
-#define GL_TEXTURE_LO_SIZE_NV             0x871C
-#define GL_TEXTURE_DS_SIZE_NV             0x871D
-#define GL_TEXTURE_DT_SIZE_NV             0x871E
-#define GL_TEXTURE_MAG_SIZE_NV            0x871F
-#endif
-
-#ifndef GL_NV_texture_shader2
-#define GL_DOT_PRODUCT_TEXTURE_3D_NV      0x86EF
-#endif
-
-#ifndef GL_NV_vertex_array_range2
-#define GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV 0x8533
-#endif
-
-#ifndef GL_NV_vertex_program
-#define GL_VERTEX_PROGRAM_NV              0x8620
-#define GL_VERTEX_STATE_PROGRAM_NV        0x8621
-#define GL_ATTRIB_ARRAY_SIZE_NV           0x8623
-#define GL_ATTRIB_ARRAY_STRIDE_NV         0x8624
-#define GL_ATTRIB_ARRAY_TYPE_NV           0x8625
-#define GL_CURRENT_ATTRIB_NV              0x8626
-#define GL_PROGRAM_LENGTH_NV              0x8627
-#define GL_PROGRAM_STRING_NV              0x8628
-#define GL_MODELVIEW_PROJECTION_NV        0x8629
-#define GL_IDENTITY_NV                    0x862A
-#define GL_INVERSE_NV                     0x862B
-#define GL_TRANSPOSE_NV                   0x862C
-#define GL_INVERSE_TRANSPOSE_NV           0x862D
-#define GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV 0x862E
-#define GL_MAX_TRACK_MATRICES_NV          0x862F
-#define GL_MATRIX0_NV                     0x8630
-#define GL_MATRIX1_NV                     0x8631
-#define GL_MATRIX2_NV                     0x8632
-#define GL_MATRIX3_NV                     0x8633
-#define GL_MATRIX4_NV                     0x8634
-#define GL_MATRIX5_NV                     0x8635
-#define GL_MATRIX6_NV                     0x8636
-#define GL_MATRIX7_NV                     0x8637
-#define GL_CURRENT_MATRIX_STACK_DEPTH_NV  0x8640
-#define GL_CURRENT_MATRIX_NV              0x8641
-#define GL_VERTEX_PROGRAM_POINT_SIZE_NV   0x8642
-#define GL_VERTEX_PROGRAM_TWO_SIDE_NV     0x8643
-#define GL_PROGRAM_PARAMETER_NV           0x8644
-#define GL_ATTRIB_ARRAY_POINTER_NV        0x8645
-#define GL_PROGRAM_TARGET_NV              0x8646
-#define GL_PROGRAM_RESIDENT_NV            0x8647
-#define GL_TRACK_MATRIX_NV                0x8648
-#define GL_TRACK_MATRIX_TRANSFORM_NV      0x8649
-#define GL_VERTEX_PROGRAM_BINDING_NV      0x864A
-#define GL_PROGRAM_ERROR_POSITION_NV      0x864B
-#define GL_VERTEX_ATTRIB_ARRAY0_NV        0x8650
-#define GL_VERTEX_ATTRIB_ARRAY1_NV        0x8651
-#define GL_VERTEX_ATTRIB_ARRAY2_NV        0x8652
-#define GL_VERTEX_ATTRIB_ARRAY3_NV        0x8653
-#define GL_VERTEX_ATTRIB_ARRAY4_NV        0x8654
-#define GL_VERTEX_ATTRIB_ARRAY5_NV        0x8655
-#define GL_VERTEX_ATTRIB_ARRAY6_NV        0x8656
-#define GL_VERTEX_ATTRIB_ARRAY7_NV        0x8657
-#define GL_VERTEX_ATTRIB_ARRAY8_NV        0x8658
-#define GL_VERTEX_ATTRIB_ARRAY9_NV        0x8659
-#define GL_VERTEX_ATTRIB_ARRAY10_NV       0x865A
-#define GL_VERTEX_ATTRIB_ARRAY11_NV       0x865B
-#define GL_VERTEX_ATTRIB_ARRAY12_NV       0x865C
-#define GL_VERTEX_ATTRIB_ARRAY13_NV       0x865D
-#define GL_VERTEX_ATTRIB_ARRAY14_NV       0x865E
-#define GL_VERTEX_ATTRIB_ARRAY15_NV       0x865F
-#define GL_MAP1_VERTEX_ATTRIB0_4_NV       0x8660
-#define GL_MAP1_VERTEX_ATTRIB1_4_NV       0x8661
-#define GL_MAP1_VERTEX_ATTRIB2_4_NV       0x8662
-#define GL_MAP1_VERTEX_ATTRIB3_4_NV       0x8663
-#define GL_MAP1_VERTEX_ATTRIB4_4_NV       0x8664
-#define GL_MAP1_VERTEX_ATTRIB5_4_NV       0x8665
-#define GL_MAP1_VERTEX_ATTRIB6_4_NV       0x8666
-#define GL_MAP1_VERTEX_ATTRIB7_4_NV       0x8667
-#define GL_MAP1_VERTEX_ATTRIB8_4_NV       0x8668
-#define GL_MAP1_VERTEX_ATTRIB9_4_NV       0x8669
-#define GL_MAP1_VERTEX_ATTRIB10_4_NV      0x866A
-#define GL_MAP1_VERTEX_ATTRIB11_4_NV      0x866B
-#define GL_MAP1_VERTEX_ATTRIB12_4_NV      0x866C
-#define GL_MAP1_VERTEX_ATTRIB13_4_NV      0x866D
-#define GL_MAP1_VERTEX_ATTRIB14_4_NV      0x866E
-#define GL_MAP1_VERTEX_ATTRIB15_4_NV      0x866F
-#define GL_MAP2_VERTEX_ATTRIB0_4_NV       0x8670
-#define GL_MAP2_VERTEX_ATTRIB1_4_NV       0x8671
-#define GL_MAP2_VERTEX_ATTRIB2_4_NV       0x8672
-#define GL_MAP2_VERTEX_ATTRIB3_4_NV       0x8673
-#define GL_MAP2_VERTEX_ATTRIB4_4_NV       0x8674
-#define GL_MAP2_VERTEX_ATTRIB5_4_NV       0x8675
-#define GL_MAP2_VERTEX_ATTRIB6_4_NV       0x8676
-#define GL_MAP2_VERTEX_ATTRIB7_4_NV       0x8677
-#define GL_MAP2_VERTEX_ATTRIB8_4_NV       0x8678
-#define GL_MAP2_VERTEX_ATTRIB9_4_NV       0x8679
-#define GL_MAP2_VERTEX_ATTRIB10_4_NV      0x867A
-#define GL_MAP2_VERTEX_ATTRIB11_4_NV      0x867B
-#define GL_MAP2_VERTEX_ATTRIB12_4_NV      0x867C
-#define GL_MAP2_VERTEX_ATTRIB13_4_NV      0x867D
-#define GL_MAP2_VERTEX_ATTRIB14_4_NV      0x867E
-#define GL_MAP2_VERTEX_ATTRIB15_4_NV      0x867F
-#endif
-
-#ifndef GL_SGIX_texture_coordinate_clamp
-#define GL_TEXTURE_MAX_CLAMP_S_SGIX       0x8369
-#define GL_TEXTURE_MAX_CLAMP_T_SGIX       0x836A
-#define GL_TEXTURE_MAX_CLAMP_R_SGIX       0x836B
-#endif
-
-#ifndef GL_SGIX_scalebias_hint
-#define GL_SCALEBIAS_HINT_SGIX            0x8322
-#endif
-
-#ifndef GL_OML_interlace
-#define GL_INTERLACE_OML                  0x8980
-#define GL_INTERLACE_READ_OML             0x8981
-#endif
-
-#ifndef GL_OML_subsample
-#define GL_FORMAT_SUBSAMPLE_24_24_OML     0x8982
-#define GL_FORMAT_SUBSAMPLE_244_244_OML   0x8983
-#endif
-
-#ifndef GL_OML_resample
-#define GL_PACK_RESAMPLE_OML              0x8984
-#define GL_UNPACK_RESAMPLE_OML            0x8985
-#define GL_RESAMPLE_REPLICATE_OML         0x8986
-#define GL_RESAMPLE_ZERO_FILL_OML         0x8987
-#define GL_RESAMPLE_AVERAGE_OML           0x8988
-#define GL_RESAMPLE_DECIMATE_OML          0x8989
-#endif
-
-#ifndef GL_NV_copy_depth_to_color
-#define GL_DEPTH_STENCIL_TO_RGBA_NV       0x886E
-#define GL_DEPTH_STENCIL_TO_BGRA_NV       0x886F
-#endif
-
-#ifndef GL_ATI_envmap_bumpmap
-#define GL_BUMP_ROT_MATRIX_ATI            0x8775
-#define GL_BUMP_ROT_MATRIX_SIZE_ATI       0x8776
-#define GL_BUMP_NUM_TEX_UNITS_ATI         0x8777
-#define GL_BUMP_TEX_UNITS_ATI             0x8778
-#define GL_DUDV_ATI                       0x8779
-#define GL_DU8DV8_ATI                     0x877A
-#define GL_BUMP_ENVMAP_ATI                0x877B
-#define GL_BUMP_TARGET_ATI                0x877C
-#endif
-
-#ifndef GL_ATI_fragment_shader
-#define GL_FRAGMENT_SHADER_ATI            0x8920
-#define GL_REG_0_ATI                      0x8921
-#define GL_REG_1_ATI                      0x8922
-#define GL_REG_2_ATI                      0x8923
-#define GL_REG_3_ATI                      0x8924
-#define GL_REG_4_ATI                      0x8925
-#define GL_REG_5_ATI                      0x8926
-#define GL_REG_6_ATI                      0x8927
-#define GL_REG_7_ATI                      0x8928
-#define GL_REG_8_ATI                      0x8929
-#define GL_REG_9_ATI                      0x892A
-#define GL_REG_10_ATI                     0x892B
-#define GL_REG_11_ATI                     0x892C
-#define GL_REG_12_ATI                     0x892D
-#define GL_REG_13_ATI                     0x892E
-#define GL_REG_14_ATI                     0x892F
-#define GL_REG_15_ATI                     0x8930
-#define GL_REG_16_ATI                     0x8931
-#define GL_REG_17_ATI                     0x8932
-#define GL_REG_18_ATI                     0x8933
-#define GL_REG_19_ATI                     0x8934
-#define GL_REG_20_ATI                     0x8935
-#define GL_REG_21_ATI                     0x8936
-#define GL_REG_22_ATI                     0x8937
-#define GL_REG_23_ATI                     0x8938
-#define GL_REG_24_ATI                     0x8939
-#define GL_REG_25_ATI                     0x893A
-#define GL_REG_26_ATI                     0x893B
-#define GL_REG_27_ATI                     0x893C
-#define GL_REG_28_ATI                     0x893D
-#define GL_REG_29_ATI                     0x893E
-#define GL_REG_30_ATI                     0x893F
-#define GL_REG_31_ATI                     0x8940
-#define GL_CON_0_ATI                      0x8941
-#define GL_CON_1_ATI                      0x8942
-#define GL_CON_2_ATI                      0x8943
-#define GL_CON_3_ATI                      0x8944
-#define GL_CON_4_ATI                      0x8945
-#define GL_CON_5_ATI                      0x8946
-#define GL_CON_6_ATI                      0x8947
-#define GL_CON_7_ATI                      0x8948
-#define GL_CON_8_ATI                      0x8949
-#define GL_CON_9_ATI                      0x894A
-#define GL_CON_10_ATI                     0x894B
-#define GL_CON_11_ATI                     0x894C
-#define GL_CON_12_ATI                     0x894D
-#define GL_CON_13_ATI                     0x894E
-#define GL_CON_14_ATI                     0x894F
-#define GL_CON_15_ATI                     0x8950
-#define GL_CON_16_ATI                     0x8951
-#define GL_CON_17_ATI                     0x8952
-#define GL_CON_18_ATI                     0x8953
-#define GL_CON_19_ATI                     0x8954
-#define GL_CON_20_ATI                     0x8955
-#define GL_CON_21_ATI                     0x8956
-#define GL_CON_22_ATI                     0x8957
-#define GL_CON_23_ATI                     0x8958
-#define GL_CON_24_ATI                     0x8959
-#define GL_CON_25_ATI                     0x895A
-#define GL_CON_26_ATI                     0x895B
-#define GL_CON_27_ATI                     0x895C
-#define GL_CON_28_ATI                     0x895D
-#define GL_CON_29_ATI                     0x895E
-#define GL_CON_30_ATI                     0x895F
-#define GL_CON_31_ATI                     0x8960
-#define GL_MOV_ATI                        0x8961
-#define GL_ADD_ATI                        0x8963
-#define GL_MUL_ATI                        0x8964
-#define GL_SUB_ATI                        0x8965
-#define GL_DOT3_ATI                       0x8966
-#define GL_DOT4_ATI                       0x8967
-#define GL_MAD_ATI                        0x8968
-#define GL_LERP_ATI                       0x8969
-#define GL_CND_ATI                        0x896A
-#define GL_CND0_ATI                       0x896B
-#define GL_DOT2_ADD_ATI                   0x896C
-#define GL_SECONDARY_INTERPOLATOR_ATI     0x896D
-#define GL_NUM_FRAGMENT_REGISTERS_ATI     0x896E
-#define GL_NUM_FRAGMENT_CONSTANTS_ATI     0x896F
-#define GL_NUM_PASSES_ATI                 0x8970
-#define GL_NUM_INSTRUCTIONS_PER_PASS_ATI  0x8971
-#define GL_NUM_INSTRUCTIONS_TOTAL_ATI     0x8972
-#define GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI 0x8973
-#define GL_NUM_LOOPBACK_COMPONENTS_ATI    0x8974
-#define GL_COLOR_ALPHA_PAIRING_ATI        0x8975
-#define GL_SWIZZLE_STR_ATI                0x8976
-#define GL_SWIZZLE_STQ_ATI                0x8977
-#define GL_SWIZZLE_STR_DR_ATI             0x8978
-#define GL_SWIZZLE_STQ_DQ_ATI             0x8979
-#define GL_SWIZZLE_STRQ_ATI               0x897A
-#define GL_SWIZZLE_STRQ_DQ_ATI            0x897B
-#define GL_RED_BIT_ATI                    0x00000001
-#define GL_GREEN_BIT_ATI                  0x00000002
-#define GL_BLUE_BIT_ATI                   0x00000004
-#define GL_2X_BIT_ATI                     0x00000001
-#define GL_4X_BIT_ATI                     0x00000002
-#define GL_8X_BIT_ATI                     0x00000004
-#define GL_HALF_BIT_ATI                   0x00000008
-#define GL_QUARTER_BIT_ATI                0x00000010
-#define GL_EIGHTH_BIT_ATI                 0x00000020
-#define GL_SATURATE_BIT_ATI               0x00000040
-#define GL_COMP_BIT_ATI                   0x00000002
-#define GL_NEGATE_BIT_ATI                 0x00000004
-#define GL_BIAS_BIT_ATI                   0x00000008
-#endif
-
-#ifndef GL_ATI_pn_triangles
-#define GL_PN_TRIANGLES_ATI               0x87F0
-#define GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI 0x87F1
-#define GL_PN_TRIANGLES_POINT_MODE_ATI    0x87F2
-#define GL_PN_TRIANGLES_NORMAL_MODE_ATI   0x87F3
-#define GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI 0x87F4
-#define GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI 0x87F5
-#define GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI 0x87F6
-#define GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI 0x87F7
-#define GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI 0x87F8
-#endif
-
-#ifndef GL_ATI_vertex_array_object
-#define GL_STATIC_ATI                     0x8760
-#define GL_DYNAMIC_ATI                    0x8761
-#define GL_PRESERVE_ATI                   0x8762
-#define GL_DISCARD_ATI                    0x8763
-#define GL_OBJECT_BUFFER_SIZE_ATI         0x8764
-#define GL_OBJECT_BUFFER_USAGE_ATI        0x8765
-#define GL_ARRAY_OBJECT_BUFFER_ATI        0x8766
-#define GL_ARRAY_OBJECT_OFFSET_ATI        0x8767
-#endif
-
-#ifndef GL_EXT_vertex_shader
-#define GL_VERTEX_SHADER_EXT              0x8780
-#define GL_VERTEX_SHADER_BINDING_EXT      0x8781
-#define GL_OP_INDEX_EXT                   0x8782
-#define GL_OP_NEGATE_EXT                  0x8783
-#define GL_OP_DOT3_EXT                    0x8784
-#define GL_OP_DOT4_EXT                    0x8785
-#define GL_OP_MUL_EXT                     0x8786
-#define GL_OP_ADD_EXT                     0x8787
-#define GL_OP_MADD_EXT                    0x8788
-#define GL_OP_FRAC_EXT                    0x8789
-#define GL_OP_MAX_EXT                     0x878A
-#define GL_OP_MIN_EXT                     0x878B
-#define GL_OP_SET_GE_EXT                  0x878C
-#define GL_OP_SET_LT_EXT                  0x878D
-#define GL_OP_CLAMP_EXT                   0x878E
-#define GL_OP_FLOOR_EXT                   0x878F
-#define GL_OP_ROUND_EXT                   0x8790
-#define GL_OP_EXP_BASE_2_EXT              0x8791
-#define GL_OP_LOG_BASE_2_EXT              0x8792
-#define GL_OP_POWER_EXT                   0x8793
-#define GL_OP_RECIP_EXT                   0x8794
-#define GL_OP_RECIP_SQRT_EXT              0x8795
-#define GL_OP_SUB_EXT                     0x8796
-#define GL_OP_CROSS_PRODUCT_EXT           0x8797
-#define GL_OP_MULTIPLY_MATRIX_EXT         0x8798
-#define GL_OP_MOV_EXT                     0x8799
-#define GL_OUTPUT_VERTEX_EXT              0x879A
-#define GL_OUTPUT_COLOR0_EXT              0x879B
-#define GL_OUTPUT_COLOR1_EXT              0x879C
-#define GL_OUTPUT_TEXTURE_COORD0_EXT      0x879D
-#define GL_OUTPUT_TEXTURE_COORD1_EXT      0x879E
-#define GL_OUTPUT_TEXTURE_COORD2_EXT      0x879F
-#define GL_OUTPUT_TEXTURE_COORD3_EXT      0x87A0
-#define GL_OUTPUT_TEXTURE_COORD4_EXT      0x87A1
-#define GL_OUTPUT_TEXTURE_COORD5_EXT      0x87A2
-#define GL_OUTPUT_TEXTURE_COORD6_EXT      0x87A3
-#define GL_OUTPUT_TEXTURE_COORD7_EXT      0x87A4
-#define GL_OUTPUT_TEXTURE_COORD8_EXT      0x87A5
-#define GL_OUTPUT_TEXTURE_COORD9_EXT      0x87A6
-#define GL_OUTPUT_TEXTURE_COORD10_EXT     0x87A7
-#define GL_OUTPUT_TEXTURE_COORD11_EXT     0x87A8
-#define GL_OUTPUT_TEXTURE_COORD12_EXT     0x87A9
-#define GL_OUTPUT_TEXTURE_COORD13_EXT     0x87AA
-#define GL_OUTPUT_TEXTURE_COORD14_EXT     0x87AB
-#define GL_OUTPUT_TEXTURE_COORD15_EXT     0x87AC
-#define GL_OUTPUT_TEXTURE_COORD16_EXT     0x87AD
-#define GL_OUTPUT_TEXTURE_COORD17_EXT     0x87AE
-#define GL_OUTPUT_TEXTURE_COORD18_EXT     0x87AF
-#define GL_OUTPUT_TEXTURE_COORD19_EXT     0x87B0
-#define GL_OUTPUT_TEXTURE_COORD20_EXT     0x87B1
-#define GL_OUTPUT_TEXTURE_COORD21_EXT     0x87B2
-#define GL_OUTPUT_TEXTURE_COORD22_EXT     0x87B3
-#define GL_OUTPUT_TEXTURE_COORD23_EXT     0x87B4
-#define GL_OUTPUT_TEXTURE_COORD24_EXT     0x87B5
-#define GL_OUTPUT_TEXTURE_COORD25_EXT     0x87B6
-#define GL_OUTPUT_TEXTURE_COORD26_EXT     0x87B7
-#define GL_OUTPUT_TEXTURE_COORD27_EXT     0x87B8
-#define GL_OUTPUT_TEXTURE_COORD28_EXT     0x87B9
-#define GL_OUTPUT_TEXTURE_COORD29_EXT     0x87BA
-#define GL_OUTPUT_TEXTURE_COORD30_EXT     0x87BB
-#define GL_OUTPUT_TEXTURE_COORD31_EXT     0x87BC
-#define GL_OUTPUT_FOG_EXT                 0x87BD
-#define GL_SCALAR_EXT                     0x87BE
-#define GL_VECTOR_EXT                     0x87BF
-#define GL_MATRIX_EXT                     0x87C0
-#define GL_VARIANT_EXT                    0x87C1
-#define GL_INVARIANT_EXT                  0x87C2
-#define GL_LOCAL_CONSTANT_EXT             0x87C3
-#define GL_LOCAL_EXT                      0x87C4
-#define GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT 0x87C5
-#define GL_MAX_VERTEX_SHADER_VARIANTS_EXT 0x87C6
-#define GL_MAX_VERTEX_SHADER_INVARIANTS_EXT 0x87C7
-#define GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT 0x87C8
-#define GL_MAX_VERTEX_SHADER_LOCALS_EXT   0x87C9
-#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT 0x87CA
-#define GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT 0x87CB
-#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT 0x87CC
-#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT 0x87CD
-#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT 0x87CE
-#define GL_VERTEX_SHADER_INSTRUCTIONS_EXT 0x87CF
-#define GL_VERTEX_SHADER_VARIANTS_EXT     0x87D0
-#define GL_VERTEX_SHADER_INVARIANTS_EXT   0x87D1
-#define GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT 0x87D2
-#define GL_VERTEX_SHADER_LOCALS_EXT       0x87D3
-#define GL_VERTEX_SHADER_OPTIMIZED_EXT    0x87D4
-#define GL_X_EXT                          0x87D5
-#define GL_Y_EXT                          0x87D6
-#define GL_Z_EXT                          0x87D7
-#define GL_W_EXT                          0x87D8
-#define GL_NEGATIVE_X_EXT                 0x87D9
-#define GL_NEGATIVE_Y_EXT                 0x87DA
-#define GL_NEGATIVE_Z_EXT                 0x87DB
-#define GL_NEGATIVE_W_EXT                 0x87DC
-#define GL_ZERO_EXT                       0x87DD
-#define GL_ONE_EXT                        0x87DE
-#define GL_NEGATIVE_ONE_EXT               0x87DF
-#define GL_NORMALIZED_RANGE_EXT           0x87E0
-#define GL_FULL_RANGE_EXT                 0x87E1
-#define GL_CURRENT_VERTEX_EXT             0x87E2
-#define GL_MVP_MATRIX_EXT                 0x87E3
-#define GL_VARIANT_VALUE_EXT              0x87E4
-#define GL_VARIANT_DATATYPE_EXT           0x87E5
-#define GL_VARIANT_ARRAY_STRIDE_EXT       0x87E6
-#define GL_VARIANT_ARRAY_TYPE_EXT         0x87E7
-#define GL_VARIANT_ARRAY_EXT              0x87E8
-#define GL_VARIANT_ARRAY_POINTER_EXT      0x87E9
-#define GL_INVARIANT_VALUE_EXT            0x87EA
-#define GL_INVARIANT_DATATYPE_EXT         0x87EB
-#define GL_LOCAL_CONSTANT_VALUE_EXT       0x87EC
-#define GL_LOCAL_CONSTANT_DATATYPE_EXT    0x87ED
-#endif
-
-#ifndef GL_ATI_vertex_streams
-#define GL_MAX_VERTEX_STREAMS_ATI         0x876B
-#define GL_VERTEX_STREAM0_ATI             0x876C
-#define GL_VERTEX_STREAM1_ATI             0x876D
-#define GL_VERTEX_STREAM2_ATI             0x876E
-#define GL_VERTEX_STREAM3_ATI             0x876F
-#define GL_VERTEX_STREAM4_ATI             0x8770
-#define GL_VERTEX_STREAM5_ATI             0x8771
-#define GL_VERTEX_STREAM6_ATI             0x8772
-#define GL_VERTEX_STREAM7_ATI             0x8773
-#define GL_VERTEX_SOURCE_ATI              0x8774
-#endif
-
-#ifndef GL_ATI_element_array
-#define GL_ELEMENT_ARRAY_ATI              0x8768
-#define GL_ELEMENT_ARRAY_TYPE_ATI         0x8769
-#define GL_ELEMENT_ARRAY_POINTER_ATI      0x876A
-#endif
-
-#ifndef GL_SUN_mesh_array
-#define GL_QUAD_MESH_SUN                  0x8614
-#define GL_TRIANGLE_MESH_SUN              0x8615
-#endif
-
-#ifndef GL_SUN_slice_accum
-#define GL_SLICE_ACCUM_SUN                0x85CC
-#endif
-
-#ifndef GL_NV_multisample_filter_hint
-#define GL_MULTISAMPLE_FILTER_HINT_NV     0x8534
-#endif
-
-#ifndef GL_NV_depth_clamp
-#define GL_DEPTH_CLAMP_NV                 0x864F
-#endif
-
-#ifndef GL_NV_occlusion_query
-#define GL_PIXEL_COUNTER_BITS_NV          0x8864
-#define GL_CURRENT_OCCLUSION_QUERY_ID_NV  0x8865
-#define GL_PIXEL_COUNT_NV                 0x8866
-#define GL_PIXEL_COUNT_AVAILABLE_NV       0x8867
-#endif
-
-#ifndef GL_NV_point_sprite
-#define GL_POINT_SPRITE_NV                0x8861
-#define GL_COORD_REPLACE_NV               0x8862
-#define GL_POINT_SPRITE_R_MODE_NV         0x8863
-#endif
-
-#ifndef GL_NV_texture_shader3
-#define GL_OFFSET_PROJECTIVE_TEXTURE_2D_NV 0x8850
-#define GL_OFFSET_PROJECTIVE_TEXTURE_2D_SCALE_NV 0x8851
-#define GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_NV 0x8852
-#define GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_SCALE_NV 0x8853
-#define GL_OFFSET_HILO_TEXTURE_2D_NV      0x8854
-#define GL_OFFSET_HILO_TEXTURE_RECTANGLE_NV 0x8855
-#define GL_OFFSET_HILO_PROJECTIVE_TEXTURE_2D_NV 0x8856
-#define GL_OFFSET_HILO_PROJECTIVE_TEXTURE_RECTANGLE_NV 0x8857
-#define GL_DEPENDENT_HILO_TEXTURE_2D_NV   0x8858
-#define GL_DEPENDENT_RGB_TEXTURE_3D_NV    0x8859
-#define GL_DEPENDENT_RGB_TEXTURE_CUBE_MAP_NV 0x885A
-#define GL_DOT_PRODUCT_PASS_THROUGH_NV    0x885B
-#define GL_DOT_PRODUCT_TEXTURE_1D_NV      0x885C
-#define GL_DOT_PRODUCT_AFFINE_DEPTH_REPLACE_NV 0x885D
-#define GL_HILO8_NV                       0x885E
-#define GL_SIGNED_HILO8_NV                0x885F
-#define GL_FORCE_BLUE_TO_ONE_NV           0x8860
-#endif
-
-#ifndef GL_NV_vertex_program1_1
-#endif
-
-#ifndef GL_EXT_shadow_funcs
-#endif
-
-#ifndef GL_EXT_stencil_two_side
-#define GL_STENCIL_TEST_TWO_SIDE_EXT      0x8910
-#define GL_ACTIVE_STENCIL_FACE_EXT        0x8911
-#endif
-
-#ifndef GL_ATI_text_fragment_shader
-#define GL_TEXT_FRAGMENT_SHADER_ATI       0x8200
-#endif
-
-#ifndef GL_APPLE_client_storage
-#define GL_UNPACK_CLIENT_STORAGE_APPLE    0x85B2
-#endif
-
-#ifndef GL_APPLE_element_array
-#define GL_ELEMENT_ARRAY_APPLE            0x8768
-#define GL_ELEMENT_ARRAY_TYPE_APPLE       0x8769
-#define GL_ELEMENT_ARRAY_POINTER_APPLE    0x876A
-#endif
-
-#ifndef GL_APPLE_fence
-#define GL_DRAW_PIXELS_APPLE              0x8A0A
-#define GL_FENCE_APPLE                    0x8A0B
-#endif
-
-#ifndef GL_APPLE_vertex_array_object
-#define GL_VERTEX_ARRAY_BINDING_APPLE     0x85B5
-#endif
-
-#ifndef GL_APPLE_vertex_array_range
-#define GL_VERTEX_ARRAY_RANGE_APPLE       0x851D
-#define GL_VERTEX_ARRAY_RANGE_LENGTH_APPLE 0x851E
-#define GL_VERTEX_ARRAY_STORAGE_HINT_APPLE 0x851F
-#define GL_VERTEX_ARRAY_RANGE_POINTER_APPLE 0x8521
-#define GL_STORAGE_CACHED_APPLE           0x85BE
-#define GL_STORAGE_SHARED_APPLE           0x85BF
-#endif
-
-#ifndef GL_APPLE_ycbcr_422
-#define GL_YCBCR_422_APPLE                0x85B9
-#define GL_UNSIGNED_SHORT_8_8_APPLE       0x85BA
-#define GL_UNSIGNED_SHORT_8_8_REV_APPLE   0x85BB
-#endif
-
-#ifndef GL_S3_s3tc
-#define GL_RGB_S3TC                       0x83A0
-#define GL_RGB4_S3TC                      0x83A1
-#define GL_RGBA_S3TC                      0x83A2
-#define GL_RGBA4_S3TC                     0x83A3
-#endif
-
-#ifndef GL_ATI_draw_buffers
-#define GL_MAX_DRAW_BUFFERS_ATI           0x8824
-#define GL_DRAW_BUFFER0_ATI               0x8825
-#define GL_DRAW_BUFFER1_ATI               0x8826
-#define GL_DRAW_BUFFER2_ATI               0x8827
-#define GL_DRAW_BUFFER3_ATI               0x8828
-#define GL_DRAW_BUFFER4_ATI               0x8829
-#define GL_DRAW_BUFFER5_ATI               0x882A
-#define GL_DRAW_BUFFER6_ATI               0x882B
-#define GL_DRAW_BUFFER7_ATI               0x882C
-#define GL_DRAW_BUFFER8_ATI               0x882D
-#define GL_DRAW_BUFFER9_ATI               0x882E
-#define GL_DRAW_BUFFER10_ATI              0x882F
-#define GL_DRAW_BUFFER11_ATI              0x8830
-#define GL_DRAW_BUFFER12_ATI              0x8831
-#define GL_DRAW_BUFFER13_ATI              0x8832
-#define GL_DRAW_BUFFER14_ATI              0x8833
-#define GL_DRAW_BUFFER15_ATI              0x8834
-#endif
-
-#ifndef GL_ATI_pixel_format_float
-#define GL_TYPE_RGBA_FLOAT_ATI            0x8820
-#define GL_COLOR_CLEAR_UNCLAMPED_VALUE_ATI 0x8835
-#endif
-
-#ifndef GL_ATI_texture_env_combine3
-#define GL_MODULATE_ADD_ATI               0x8744
-#define GL_MODULATE_SIGNED_ADD_ATI        0x8745
-#define GL_MODULATE_SUBTRACT_ATI          0x8746
-#endif
-
-#ifndef GL_ATI_texture_float
-#define GL_RGBA_FLOAT32_ATI               0x8814
-#define GL_RGB_FLOAT32_ATI                0x8815
-#define GL_ALPHA_FLOAT32_ATI              0x8816
-#define GL_INTENSITY_FLOAT32_ATI          0x8817
-#define GL_LUMINANCE_FLOAT32_ATI          0x8818
-#define GL_LUMINANCE_ALPHA_FLOAT32_ATI    0x8819
-#define GL_RGBA_FLOAT16_ATI               0x881A
-#define GL_RGB_FLOAT16_ATI                0x881B
-#define GL_ALPHA_FLOAT16_ATI              0x881C
-#define GL_INTENSITY_FLOAT16_ATI          0x881D
-#define GL_LUMINANCE_FLOAT16_ATI          0x881E
-#define GL_LUMINANCE_ALPHA_FLOAT16_ATI    0x881F
-#endif
-
-#ifndef GL_NV_float_buffer
-#define GL_FLOAT_R_NV                     0x8880
-#define GL_FLOAT_RG_NV                    0x8881
-#define GL_FLOAT_RGB_NV                   0x8882
-#define GL_FLOAT_RGBA_NV                  0x8883
-#define GL_FLOAT_R16_NV                   0x8884
-#define GL_FLOAT_R32_NV                   0x8885
-#define GL_FLOAT_RG16_NV                  0x8886
-#define GL_FLOAT_RG32_NV                  0x8887
-#define GL_FLOAT_RGB16_NV                 0x8888
-#define GL_FLOAT_RGB32_NV                 0x8889
-#define GL_FLOAT_RGBA16_NV                0x888A
-#define GL_FLOAT_RGBA32_NV                0x888B
-#define GL_TEXTURE_FLOAT_COMPONENTS_NV    0x888C
-#define GL_FLOAT_CLEAR_COLOR_VALUE_NV     0x888D
-#define GL_FLOAT_RGBA_MODE_NV             0x888E
-#endif
-
-#ifndef GL_NV_fragment_program
-#define GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV 0x8868
-#define GL_FRAGMENT_PROGRAM_NV            0x8870
-#define GL_MAX_TEXTURE_COORDS_NV          0x8871
-#define GL_MAX_TEXTURE_IMAGE_UNITS_NV     0x8872
-#define GL_FRAGMENT_PROGRAM_BINDING_NV    0x8873
-#define GL_PROGRAM_ERROR_STRING_NV        0x8874
-#endif
-
-#ifndef GL_NV_half_float
-#define GL_HALF_FLOAT_NV                  0x140B
-#endif
-
-#ifndef GL_NV_pixel_data_range
-#define GL_WRITE_PIXEL_DATA_RANGE_NV      0x8878
-#define GL_READ_PIXEL_DATA_RANGE_NV       0x8879
-#define GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV 0x887A
-#define GL_READ_PIXEL_DATA_RANGE_LENGTH_NV 0x887B
-#define GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV 0x887C
-#define GL_READ_PIXEL_DATA_RANGE_POINTER_NV 0x887D
-#endif
-
-#ifndef GL_NV_primitive_restart
-#define GL_PRIMITIVE_RESTART_NV           0x8558
-#define GL_PRIMITIVE_RESTART_INDEX_NV     0x8559
-#endif
-
-#ifndef GL_NV_texture_expand_normal
-#define GL_TEXTURE_UNSIGNED_REMAP_MODE_NV 0x888F
-#endif
-
-#ifndef GL_NV_vertex_program2
-#endif
-
-#ifndef GL_ATI_map_object_buffer
-#endif
-
-#ifndef GL_ATI_separate_stencil
-#define GL_STENCIL_BACK_FUNC_ATI          0x8800
-#define GL_STENCIL_BACK_FAIL_ATI          0x8801
-#define GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI 0x8802
-#define GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI 0x8803
-#endif
-
-#ifndef GL_ATI_vertex_attrib_array_object
-#endif
-
-#ifndef GL_OES_read_format
-#define GL_IMPLEMENTATION_COLOR_READ_TYPE_OES 0x8B9A
-#define GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES 0x8B9B
-#endif
-
-#ifndef GL_EXT_depth_bounds_test
-#define GL_DEPTH_BOUNDS_TEST_EXT          0x8890
-#define GL_DEPTH_BOUNDS_EXT               0x8891
-#endif
-
-#ifndef GL_EXT_texture_mirror_clamp
-#define GL_MIRROR_CLAMP_EXT               0x8742
-#define GL_MIRROR_CLAMP_TO_EDGE_EXT       0x8743
-#define GL_MIRROR_CLAMP_TO_BORDER_EXT     0x8912
-#endif
-
-#ifndef GL_EXT_blend_equation_separate
-#define GL_BLEND_EQUATION_RGB_EXT         GL_BLEND_EQUATION
-#define GL_BLEND_EQUATION_ALPHA_EXT       0x883D
-#endif
-
-#ifndef GL_MESA_pack_invert
-#define GL_PACK_INVERT_MESA               0x8758
-#endif
-
-#ifndef GL_MESA_ycbcr_texture
-#define GL_UNSIGNED_SHORT_8_8_MESA        0x85BA
-#define GL_UNSIGNED_SHORT_8_8_REV_MESA    0x85BB
-#define GL_YCBCR_MESA                     0x8757
-#endif
-
-#ifndef GL_EXT_pixel_buffer_object
-#define GL_PIXEL_PACK_BUFFER_EXT          0x88EB
-#define GL_PIXEL_UNPACK_BUFFER_EXT        0x88EC
-#define GL_PIXEL_PACK_BUFFER_BINDING_EXT  0x88ED
-#define GL_PIXEL_UNPACK_BUFFER_BINDING_EXT 0x88EF
-#endif
-
-#ifndef GL_NV_fragment_program_option
-#endif
-
-#ifndef GL_NV_fragment_program2
-#define GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV 0x88F4
-#define GL_MAX_PROGRAM_CALL_DEPTH_NV      0x88F5
-#define GL_MAX_PROGRAM_IF_DEPTH_NV        0x88F6
-#define GL_MAX_PROGRAM_LOOP_DEPTH_NV      0x88F7
-#define GL_MAX_PROGRAM_LOOP_COUNT_NV      0x88F8
-#endif
-
-#ifndef GL_NV_vertex_program2_option
-  /* reuse GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV */
-  /* reuse GL_MAX_PROGRAM_CALL_DEPTH_NV */
-#endif
-
-#ifndef GL_NV_vertex_program3
-  /* reuse GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB */
-#endif
-
-#ifndef GL_EXT_framebuffer_object
-#define GL_INVALID_FRAMEBUFFER_OPERATION_EXT 0x0506
-#define GL_MAX_RENDERBUFFER_SIZE_EXT      0x84E8
-#define GL_FRAMEBUFFER_BINDING_EXT        0x8CA6
-#define GL_RENDERBUFFER_BINDING_EXT       0x8CA7
-#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT 0x8CD0
-#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT 0x8CD1
-#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT 0x8CD2
-#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT 0x8CD3
-#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT 0x8CD4
-#define GL_FRAMEBUFFER_COMPLETE_EXT       0x8CD5
-#define GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT 0x8CD6
-#define GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT 0x8CD7
-#define GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT_EXT 0x8CD8
-#define GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT 0x8CD9
-#define GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT 0x8CDA
-#define GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT 0x8CDB
-#define GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT 0x8CDC
-#define GL_FRAMEBUFFER_UNSUPPORTED_EXT    0x8CDD
-#define GL_MAX_COLOR_ATTACHMENTS_EXT      0x8CDF
-#define GL_COLOR_ATTACHMENT0_EXT          0x8CE0
-#define GL_COLOR_ATTACHMENT1_EXT          0x8CE1
-#define GL_COLOR_ATTACHMENT2_EXT          0x8CE2
-#define GL_COLOR_ATTACHMENT3_EXT          0x8CE3
-#define GL_COLOR_ATTACHMENT4_EXT          0x8CE4
-#define GL_COLOR_ATTACHMENT5_EXT          0x8CE5
-#define GL_COLOR_ATTACHMENT6_EXT          0x8CE6
-#define GL_COLOR_ATTACHMENT7_EXT          0x8CE7
-#define GL_COLOR_ATTACHMENT8_EXT          0x8CE8
-#define GL_COLOR_ATTACHMENT9_EXT          0x8CE9
-#define GL_COLOR_ATTACHMENT10_EXT         0x8CEA
-#define GL_COLOR_ATTACHMENT11_EXT         0x8CEB
-#define GL_COLOR_ATTACHMENT12_EXT         0x8CEC
-#define GL_COLOR_ATTACHMENT13_EXT         0x8CED
-#define GL_COLOR_ATTACHMENT14_EXT         0x8CEE
-#define GL_COLOR_ATTACHMENT15_EXT         0x8CEF
-#define GL_DEPTH_ATTACHMENT_EXT           0x8D00
-#define GL_STENCIL_ATTACHMENT_EXT         0x8D20
-#define GL_FRAMEBUFFER_EXT                0x8D40
-#define GL_RENDERBUFFER_EXT               0x8D41
-#define GL_RENDERBUFFER_WIDTH_EXT         0x8D42
-#define GL_RENDERBUFFER_HEIGHT_EXT        0x8D43
-#define GL_RENDERBUFFER_INTERNAL_FORMAT_EXT 0x8D44
-#define GL_STENCIL_INDEX_EXT              0x8D45
-#define GL_STENCIL_INDEX1_EXT             0x8D46
-#define GL_STENCIL_INDEX4_EXT             0x8D47
-#define GL_STENCIL_INDEX8_EXT             0x8D48
-#define GL_STENCIL_INDEX16_EXT            0x8D49
-#define GL_RENDERBUFFER_RED_SIZE_EXT      0x8D50
-#define GL_RENDERBUFFER_GREEN_SIZE_EXT    0x8D51
-#define GL_RENDERBUFFER_BLUE_SIZE_EXT     0x8D52
-#define GL_RENDERBUFFER_ALPHA_SIZE_EXT    0x8D53
-#define GL_RENDERBUFFER_DEPTH_SIZE_EXT    0x8D54
-#define GL_RENDERBUFFER_STENCIL_SIZE_EXT  0x8D55
-#endif
-
-#ifndef GL_GREMEDY_string_marker
-#endif
-
-#ifndef GL_EXT_Cg_shader
-#define GL_CG_VERTEX_SHADER_EXT           0x890E
-#define GL_CG_FRAGMENT_SHADER_EXT         0x890E
-#endif
-
-#ifndef GL_NV_element_array
-#define GL_ELEMENT_ARRAY_TYPE_NV          0x8769
-#define GL_ELEMENT_ARRAY_POINTER_NV       0x876A
-#endif
-
-#ifndef GL_NV_pixel_buffer_object
-#define GL_PIXEL_PACK_BUFFER_NV             0x88EB
-#define GL_PIXEL_UNPACK_BUFFER_NV           0x88EC
-#define GL_PIXEL_PACK_BUFFER_BINDING_NV     0x88ED
-#define GL_PIXEL_UNPACK_BUFFER_BINDING_NV   0x88EF
-#endif
-
-#ifndef GL_NV_stencil_two_side
-#define GL_STENCIL_TEST_TWO_SIDE_NV       0x8910
-#define GL_ACTIVE_STENCIL_FACE_NV         0x8911
-#endif
-
-  /*************************************************************/
-
-#include <stddef.h>
-#ifndef GL_VERSION_2_0
-  /* GL type for program/shader text */
-  typedef char GLchar;      /* native character */
-#endif
-
-#ifndef GL_VERSION_1_5
-  /* GL types for handling large vertex buffer objects */
-  typedef ptrdiff_t GLintptr;
-  typedef ptrdiff_t GLsizeiptr;
-#endif
-
-#ifndef GL_ARB_vertex_buffer_object
-  /* GL types for handling large vertex buffer objects */
-  typedef ptrdiff_t GLintptrARB;
-  typedef ptrdiff_t GLsizeiptrARB;
-#endif
-
-#ifndef GL_ARB_shader_objects
-  /* GL types for handling shader object handles and program/shader text */
-  typedef char GLcharARB;   /* native character */
-  typedef unsigned int GLhandleARB; /* shader object handle */
-#endif
-
-  /* GL types for "half" precision (s10e5) float data in host memory */
-#ifndef GL_ARB_half_float_pixel
-  typedef unsigned short GLhalfARB;
-#endif
-
-#ifndef GL_NV_half_float
-  typedef unsigned short GLhalfNV;
-#endif
-
-#ifndef GL_VERSION_1_2
-#define GL_VERSION_1_2 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendColor (GLclampf, GLclampf, GLclampf, GLclampf);
-  GLAPI void APIENTRY glBlendEquation (GLenum);
-  GLAPI void APIENTRY glDrawRangeElements (GLenum, GLuint, GLuint, GLsizei, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glColorTable (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glColorTableParameterfv (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glColorTableParameteriv (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glCopyColorTable (GLenum, GLenum, GLint, GLint, GLsizei);
-  GLAPI void APIENTRY glGetColorTable (GLenum, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetColorTableParameterfv (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetColorTableParameteriv (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glColorSubTable (GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glCopyColorSubTable (GLenum, GLsizei, GLint, GLint, GLsizei);
-  GLAPI void APIENTRY glConvolutionFilter1D (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glConvolutionFilter2D (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glConvolutionParameterf (GLenum, GLenum, GLfloat);
-  GLAPI void APIENTRY glConvolutionParameterfv (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glConvolutionParameteri (GLenum, GLenum, GLint);
-  GLAPI void APIENTRY glConvolutionParameteriv (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glCopyConvolutionFilter1D (GLenum, GLenum, GLint, GLint, GLsizei);
-  GLAPI void APIENTRY glCopyConvolutionFilter2D (GLenum, GLenum, GLint, GLint, GLsizei, GLsizei);
-  GLAPI void APIENTRY glGetConvolutionFilter (GLenum, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetConvolutionParameterfv (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetConvolutionParameteriv (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetSeparableFilter (GLenum, GLenum, GLenum, GLvoid *, GLvoid *, GLvoid *);
-  GLAPI void APIENTRY glSeparableFilter2D (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *, const GLvoid *);
-  GLAPI void APIENTRY glGetHistogram (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetHistogramParameterfv (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetHistogramParameteriv (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetMinmax (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetMinmaxParameterfv (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetMinmaxParameteriv (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glHistogram (GLenum, GLsizei, GLenum, GLboolean);
-  GLAPI void APIENTRY glMinmax (GLenum, GLenum, GLboolean);
-  GLAPI void APIENTRY glResetHistogram (GLenum);
-  GLAPI void APIENTRY glResetMinmax (GLenum);
-  GLAPI void APIENTRY glTexImage3D (GLenum, GLint, GLint, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glTexSubImage3D (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glCopyTexSubImage3D (GLenum, GLint, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDCOLORPROC) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
-  typedef void (APIENTRYP PFNGLBLENDEQUATIONPROC) (GLenum mode);
-  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTSPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices);
-  typedef void (APIENTRYP PFNGLCOLORTABLEPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table);
-  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERFVPROC) (GLenum target, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERIVPROC) (GLenum target, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLCOPYCOLORTABLEPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEPROC) (GLenum target, GLenum format, GLenum type, GLvoid *table);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLCOLORSUBTABLEPROC) (GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOPYCOLORSUBTABLEPROC) (GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER1DPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER2DPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFPROC) (GLenum target, GLenum pname, GLfloat params);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFVPROC) (GLenum target, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIPROC) (GLenum target, GLenum pname, GLint params);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIVPROC) (GLenum target, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER1DPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
-  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER2DPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
-  typedef void (APIENTRYP PFNGLGETCONVOLUTIONFILTERPROC) (GLenum target, GLenum format, GLenum type, GLvoid *image);
-  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETSEPARABLEFILTERPROC) (GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span);
-  typedef void (APIENTRYP PFNGLSEPARABLEFILTER2DPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column);
-  typedef void (APIENTRYP PFNGLGETHISTOGRAMPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
-  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETMINMAXPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
-  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLHISTOGRAMPROC) (GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
-  typedef void (APIENTRYP PFNGLMINMAXPROC) (GLenum target, GLenum internalformat, GLboolean sink);
-  typedef void (APIENTRYP PFNGLRESETHISTOGRAMPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLRESETMINMAXPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLTEXIMAGE3DPROC) (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
-  typedef void (APIENTRYP PFNGLTEXSUBIMAGE3DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels);
-  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE3DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
-#endif
-
-#ifndef GL_VERSION_1_3
-#define GL_VERSION_1_3 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glActiveTexture (GLenum);
-  GLAPI void APIENTRY glClientActiveTexture (GLenum);
-  GLAPI void APIENTRY glMultiTexCoord1d (GLenum, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord1dv (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord1f (GLenum, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord1fv (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord1i (GLenum, GLint);
-  GLAPI void APIENTRY glMultiTexCoord1iv (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord1s (GLenum, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord1sv (GLenum, const GLshort *);
-  GLAPI void APIENTRY glMultiTexCoord2d (GLenum, GLdouble, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord2dv (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord2f (GLenum, GLfloat, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord2fv (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord2i (GLenum, GLint, GLint);
-  GLAPI void APIENTRY glMultiTexCoord2iv (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord2s (GLenum, GLshort, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord2sv (GLenum, const GLshort *);
-  GLAPI void APIENTRY glMultiTexCoord3d (GLenum, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord3dv (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord3f (GLenum, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord3fv (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord3i (GLenum, GLint, GLint, GLint);
-  GLAPI void APIENTRY glMultiTexCoord3iv (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord3s (GLenum, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord3sv (GLenum, const GLshort *);
-  GLAPI void APIENTRY glMultiTexCoord4d (GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord4dv (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord4f (GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord4fv (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord4i (GLenum, GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glMultiTexCoord4iv (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord4s (GLenum, GLshort, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord4sv (GLenum, const GLshort *);
-  GLAPI void APIENTRY glLoadTransposeMatrixf (const GLfloat *);
-  GLAPI void APIENTRY glLoadTransposeMatrixd (const GLdouble *);
-  GLAPI void APIENTRY glMultTransposeMatrixf (const GLfloat *);
-  GLAPI void APIENTRY glMultTransposeMatrixd (const GLdouble *);
-  GLAPI void APIENTRY glSampleCoverage (GLclampf, GLboolean);
-  GLAPI void APIENTRY glCompressedTexImage3D (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexImage2D (GLenum, GLint, GLenum, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexImage1D (GLenum, GLint, GLenum, GLsizei, GLint, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexSubImage3D (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexSubImage2D (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexSubImage1D (GLenum, GLint, GLint, GLsizei, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glGetCompressedTexImage (GLenum, GLint, GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLACTIVETEXTUREPROC) (GLenum texture);
-  typedef void (APIENTRYP PFNGLCLIENTACTIVETEXTUREPROC) (GLenum texture);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DPROC) (GLenum target, GLdouble s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DVPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FPROC) (GLenum target, GLfloat s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FVPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IPROC) (GLenum target, GLint s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IVPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SPROC) (GLenum target, GLshort s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SVPROC) (GLenum target, const GLshort *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DPROC) (GLenum target, GLdouble s, GLdouble t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DVPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FPROC) (GLenum target, GLfloat s, GLfloat t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FVPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IPROC) (GLenum target, GLint s, GLint t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IVPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SPROC) (GLenum target, GLshort s, GLshort t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SVPROC) (GLenum target, const GLshort *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DVPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FVPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IPROC) (GLenum target, GLint s, GLint t, GLint r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IVPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SPROC) (GLenum target, GLshort s, GLshort t, GLshort r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SVPROC) (GLenum target, const GLshort *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DVPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FVPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IPROC) (GLenum target, GLint s, GLint t, GLint r, GLint q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IVPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SPROC) (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SVPROC) (GLenum target, const GLshort *v);
-  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXFPROC) (const GLfloat *m);
-  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXDPROC) (const GLdouble *m);
-  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXFPROC) (const GLfloat *m);
-  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXDPROC) (const GLdouble *m);
-  typedef void (APIENTRYP PFNGLSAMPLECOVERAGEPROC) (GLclampf value, GLboolean invert);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE3DPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE2DPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE1DPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC) (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLGETCOMPRESSEDTEXIMAGEPROC) (GLenum target, GLint level, GLvoid *img);
-#endif
-
-#ifndef GL_VERSION_1_4
-#define GL_VERSION_1_4 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendFuncSeparate (GLenum, GLenum, GLenum, GLenum);
-  GLAPI void APIENTRY glFogCoordf (GLfloat);
-  GLAPI void APIENTRY glFogCoordfv (const GLfloat *);
-  GLAPI void APIENTRY glFogCoordd (GLdouble);
-  GLAPI void APIENTRY glFogCoorddv (const GLdouble *);
-  GLAPI void APIENTRY glFogCoordPointer (GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glMultiDrawArrays (GLenum, GLint *, GLsizei *, GLsizei);
-  GLAPI void APIENTRY glMultiDrawElements (GLenum, const GLsizei *, GLenum, const GLvoid* *, GLsizei);
-  GLAPI void APIENTRY glPointParameterf (GLenum, GLfloat);
-  GLAPI void APIENTRY glPointParameterfv (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glPointParameteri (GLenum, GLint);
-  GLAPI void APIENTRY glPointParameteriv (GLenum, const GLint *);
-  GLAPI void APIENTRY glSecondaryColor3b (GLbyte, GLbyte, GLbyte);
-  GLAPI void APIENTRY glSecondaryColor3bv (const GLbyte *);
-  GLAPI void APIENTRY glSecondaryColor3d (GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glSecondaryColor3dv (const GLdouble *);
-  GLAPI void APIENTRY glSecondaryColor3f (GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glSecondaryColor3fv (const GLfloat *);
-  GLAPI void APIENTRY glSecondaryColor3i (GLint, GLint, GLint);
-  GLAPI void APIENTRY glSecondaryColor3iv (const GLint *);
-  GLAPI void APIENTRY glSecondaryColor3s (GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glSecondaryColor3sv (const GLshort *);
-  GLAPI void APIENTRY glSecondaryColor3ub (GLubyte, GLubyte, GLubyte);
-  GLAPI void APIENTRY glSecondaryColor3ubv (const GLubyte *);
-  GLAPI void APIENTRY glSecondaryColor3ui (GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glSecondaryColor3uiv (const GLuint *);
-  GLAPI void APIENTRY glSecondaryColor3us (GLushort, GLushort, GLushort);
-  GLAPI void APIENTRY glSecondaryColor3usv (const GLushort *);
-  GLAPI void APIENTRY glSecondaryColorPointer (GLint, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glWindowPos2d (GLdouble, GLdouble);
-  GLAPI void APIENTRY glWindowPos2dv (const GLdouble *);
-  GLAPI void APIENTRY glWindowPos2f (GLfloat, GLfloat);
-  GLAPI void APIENTRY glWindowPos2fv (const GLfloat *);
-  GLAPI void APIENTRY glWindowPos2i (GLint, GLint);
-  GLAPI void APIENTRY glWindowPos2iv (const GLint *);
-  GLAPI void APIENTRY glWindowPos2s (GLshort, GLshort);
-  GLAPI void APIENTRY glWindowPos2sv (const GLshort *);
-  GLAPI void APIENTRY glWindowPos3d (GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glWindowPos3dv (const GLdouble *);
-  GLAPI void APIENTRY glWindowPos3f (GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glWindowPos3fv (const GLfloat *);
-  GLAPI void APIENTRY glWindowPos3i (GLint, GLint, GLint);
-  GLAPI void APIENTRY glWindowPos3iv (const GLint *);
-  GLAPI void APIENTRY glWindowPos3s (GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glWindowPos3sv (const GLshort *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDFUNCSEPARATEPROC) (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
-  typedef void (APIENTRYP PFNGLFOGCOORDFPROC) (GLfloat coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDFVPROC) (const GLfloat *coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDDPROC) (GLdouble coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDDVPROC) (const GLdouble *coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDPOINTERPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLMULTIDRAWARRAYSPROC) (GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
-  typedef void (APIENTRYP PFNGLMULTIDRAWELEMENTSPROC) (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVPROC) (GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERIPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERIVPROC) (GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BPROC) (GLbyte red, GLbyte green, GLbyte blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BVPROC) (const GLbyte *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DPROC) (GLdouble red, GLdouble green, GLdouble blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DVPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FPROC) (GLfloat red, GLfloat green, GLfloat blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FVPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IPROC) (GLint red, GLint green, GLint blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IVPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SPROC) (GLshort red, GLshort green, GLshort blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SVPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBPROC) (GLubyte red, GLubyte green, GLubyte blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBVPROC) (const GLubyte *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIPROC) (GLuint red, GLuint green, GLuint blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIVPROC) (const GLuint *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USPROC) (GLushort red, GLushort green, GLushort blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USVPROC) (const GLushort *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLORPOINTERPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2DPROC) (GLdouble x, GLdouble y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2DVPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2FPROC) (GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2FVPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2IPROC) (GLint x, GLint y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2IVPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2SPROC) (GLshort x, GLshort y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2SVPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3DPROC) (GLdouble x, GLdouble y, GLdouble z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3DVPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3FPROC) (GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3FVPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3IPROC) (GLint x, GLint y, GLint z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3IVPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3SPROC) (GLshort x, GLshort y, GLshort z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3SVPROC) (const GLshort *v);
-#endif
-
-#ifndef GL_VERSION_1_5
-#define GL_VERSION_1_5 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGenQueries (GLsizei, GLuint *);
-  GLAPI void APIENTRY glDeleteQueries (GLsizei, const GLuint *);
-  GLAPI GLboolean APIENTRY glIsQuery (GLuint);
-  GLAPI void APIENTRY glBeginQuery (GLenum, GLuint);
-  GLAPI void APIENTRY glEndQuery (GLenum);
-  GLAPI void APIENTRY glGetQueryiv (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetQueryObjectiv (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetQueryObjectuiv (GLuint, GLenum, GLuint *);
-  GLAPI void APIENTRY glBindBuffer (GLenum, GLuint);
-  GLAPI void APIENTRY glDeleteBuffers (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenBuffers (GLsizei, GLuint *);
-  GLAPI GLboolean APIENTRY glIsBuffer (GLuint);
-  GLAPI void APIENTRY glBufferData (GLenum, GLsizeiptr, const GLvoid *, GLenum);
-  GLAPI void APIENTRY glBufferSubData (GLenum, GLintptr, GLsizeiptr, const GLvoid *);
-  GLAPI void APIENTRY glGetBufferSubData (GLenum, GLintptr, GLsizeiptr, GLvoid *);
-  GLAPI GLvoid* APIENTRY glMapBuffer (GLenum, GLenum);
-  GLAPI GLboolean APIENTRY glUnmapBuffer (GLenum);
-  GLAPI void APIENTRY glGetBufferParameteriv (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetBufferPointerv (GLenum, GLenum, GLvoid* *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGENQUERIESPROC) (GLsizei n, GLuint *ids);
-  typedef void (APIENTRYP PFNGLDELETEQUERIESPROC) (GLsizei n, const GLuint *ids);
-  typedef GLboolean (APIENTRYP PFNGLISQUERYPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLBEGINQUERYPROC) (GLenum target, GLuint id);
-  typedef void (APIENTRYP PFNGLENDQUERYPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLGETQUERYIVPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETQUERYOBJECTIVPROC) (GLuint id, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETQUERYOBJECTUIVPROC) (GLuint id, GLenum pname, GLuint *params);
-  typedef void (APIENTRYP PFNGLBINDBUFFERPROC) (GLenum target, GLuint buffer);
-  typedef void (APIENTRYP PFNGLDELETEBUFFERSPROC) (GLsizei n, const GLuint *buffers);
-  typedef void (APIENTRYP PFNGLGENBUFFERSPROC) (GLsizei n, GLuint *buffers);
-  typedef GLboolean (APIENTRYP PFNGLISBUFFERPROC) (GLuint buffer);
-  typedef void (APIENTRYP PFNGLBUFFERDATAPROC) (GLenum target, GLsizeiptr size, const GLvoid *data, GLenum usage);
-  typedef void (APIENTRYP PFNGLBUFFERSUBDATAPROC) (GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLGETBUFFERSUBDATAPROC) (GLenum target, GLintptr offset, GLsizeiptr size, GLvoid *data);
-  typedef GLvoid* (APIENTRYP PFNGLMAPBUFFERPROC) (GLenum target, GLenum access);
-  typedef GLboolean (APIENTRYP PFNGLUNMAPBUFFERPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLGETBUFFERPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETBUFFERPOINTERVPROC) (GLenum target, GLenum pname, GLvoid* *params);
-#endif
-
-#ifndef GL_VERSION_2_0
-#define GL_VERSION_2_0 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendEquationSeparate (GLenum, GLenum);
-  GLAPI void APIENTRY glDrawBuffers (GLsizei, const GLenum *);
-  GLAPI void APIENTRY glStencilOpSeparate (GLenum, GLenum, GLenum, GLenum);
-  GLAPI void APIENTRY glStencilFuncSeparate (GLenum, GLenum, GLint, GLuint);
-  GLAPI void APIENTRY glStencilMaskSeparate (GLenum, GLuint);
-  GLAPI void APIENTRY glAttachShader (GLuint, GLuint);
-  GLAPI void APIENTRY glBindAttribLocation (GLuint, GLuint, const GLchar *);
-  GLAPI void APIENTRY glCompileShader (GLuint);
-  GLAPI GLuint APIENTRY glCreateProgram (void);
-  GLAPI GLuint APIENTRY glCreateShader (GLenum);
-  GLAPI void APIENTRY glDeleteProgram (GLuint);
-  GLAPI void APIENTRY glDeleteShader (GLuint);
-  GLAPI void APIENTRY glDetachShader (GLuint, GLuint);
-  GLAPI void APIENTRY glDisableVertexAttribArray (GLuint);
-  GLAPI void APIENTRY glEnableVertexAttribArray (GLuint);
-  GLAPI void APIENTRY glGetActiveAttrib (GLuint, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLchar *);
-  GLAPI void APIENTRY glGetActiveUniform (GLuint, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLchar *);
-  GLAPI void APIENTRY glGetAttachedShaders (GLuint, GLsizei, GLsizei *, GLuint *);
-  GLAPI GLint APIENTRY glGetAttribLocation (GLuint, const GLchar *);
-  GLAPI void APIENTRY glGetProgramiv (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetProgramInfoLog (GLuint, GLsizei, GLsizei *, GLchar *);
-  GLAPI void APIENTRY glGetShaderiv (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetShaderInfoLog (GLuint, GLsizei, GLsizei *, GLchar *);
-  GLAPI void APIENTRY glGetShaderSource (GLuint, GLsizei, GLsizei *, GLchar *);
-  GLAPI GLint APIENTRY glGetUniformLocation (GLuint, const GLchar *);
-  GLAPI void APIENTRY glGetUniformfv (GLuint, GLint, GLfloat *);
-  GLAPI void APIENTRY glGetUniformiv (GLuint, GLint, GLint *);
-  GLAPI void APIENTRY glGetVertexAttribdv (GLuint, GLenum, GLdouble *);
-  GLAPI void APIENTRY glGetVertexAttribfv (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetVertexAttribiv (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetVertexAttribPointerv (GLuint, GLenum, GLvoid* *);
-  GLAPI GLboolean APIENTRY glIsProgram (GLuint);
-  GLAPI GLboolean APIENTRY glIsShader (GLuint);
-  GLAPI void APIENTRY glLinkProgram (GLuint);
-  GLAPI void APIENTRY glShaderSource (GLuint, GLsizei, const GLchar* *, const GLint *);
-  GLAPI void APIENTRY glUseProgram (GLuint);
-  GLAPI void APIENTRY glUniform1f (GLint, GLfloat);
-  GLAPI void APIENTRY glUniform2f (GLint, GLfloat, GLfloat);
-  GLAPI void APIENTRY glUniform3f (GLint, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glUniform4f (GLint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glUniform1i (GLint, GLint);
-  GLAPI void APIENTRY glUniform2i (GLint, GLint, GLint);
-  GLAPI void APIENTRY glUniform3i (GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glUniform4i (GLint, GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glUniform1fv (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform2fv (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform3fv (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform4fv (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform1iv (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniform2iv (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniform3iv (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniform4iv (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniformMatrix2fv (GLint, GLsizei, GLboolean, const GLfloat *);
-  GLAPI void APIENTRY glUniformMatrix3fv (GLint, GLsizei, GLboolean, const GLfloat *);
-  GLAPI void APIENTRY glUniformMatrix4fv (GLint, GLsizei, GLboolean, const GLfloat *);
-  GLAPI void APIENTRY glValidateProgram (GLuint);
-  GLAPI void APIENTRY glVertexAttrib1d (GLuint, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib1dv (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib1f (GLuint, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib1fv (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib1s (GLuint, GLshort);
-  GLAPI void APIENTRY glVertexAttrib1sv (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib2d (GLuint, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib2dv (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib2f (GLuint, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib2fv (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib2s (GLuint, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib2sv (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib3d (GLuint, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib3dv (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib3f (GLuint, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib3fv (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib3s (GLuint, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib3sv (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4Nbv (GLuint, const GLbyte *);
-  GLAPI void APIENTRY glVertexAttrib4Niv (GLuint, const GLint *);
-  GLAPI void APIENTRY glVertexAttrib4Nsv (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4Nub (GLuint, GLubyte, GLubyte, GLubyte, GLubyte);
-  GLAPI void APIENTRY glVertexAttrib4Nubv (GLuint, const GLubyte *);
-  GLAPI void APIENTRY glVertexAttrib4Nuiv (GLuint, const GLuint *);
-  GLAPI void APIENTRY glVertexAttrib4Nusv (GLuint, const GLushort *);
-  GLAPI void APIENTRY glVertexAttrib4bv (GLuint, const GLbyte *);
-  GLAPI void APIENTRY glVertexAttrib4d (GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib4dv (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib4f (GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib4fv (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib4iv (GLuint, const GLint *);
-  GLAPI void APIENTRY glVertexAttrib4s (GLuint, GLshort, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib4sv (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4ubv (GLuint, const GLubyte *);
-  GLAPI void APIENTRY glVertexAttrib4uiv (GLuint, const GLuint *);
-  GLAPI void APIENTRY glVertexAttrib4usv (GLuint, const GLushort *);
-  GLAPI void APIENTRY glVertexAttribPointer (GLuint, GLint, GLenum, GLboolean, GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDEQUATIONSEPARATEPROC) (GLenum modeRGB, GLenum modeAlpha);
-  typedef void (APIENTRYP PFNGLDRAWBUFFERSPROC) (GLsizei n, const GLenum *bufs);
-  typedef void (APIENTRYP PFNGLSTENCILOPSEPARATEPROC) (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
-  typedef void (APIENTRYP PFNGLSTENCILFUNCSEPARATEPROC) (GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask);
-  typedef void (APIENTRYP PFNGLSTENCILMASKSEPARATEPROC) (GLenum face, GLuint mask);
-  typedef void (APIENTRYP PFNGLATTACHSHADERPROC) (GLuint program, GLuint shader);
-  typedef void (APIENTRYP PFNGLBINDATTRIBLOCATIONPROC) (GLuint program, GLuint index, const GLchar *name);
-  typedef void (APIENTRYP PFNGLCOMPILESHADERPROC) (GLuint shader);
-  typedef GLuint (APIENTRYP PFNGLCREATEPROGRAMPROC) (void);
-  typedef GLuint (APIENTRYP PFNGLCREATESHADERPROC) (GLenum type);
-  typedef void (APIENTRYP PFNGLDELETEPROGRAMPROC) (GLuint program);
-  typedef void (APIENTRYP PFNGLDELETESHADERPROC) (GLuint shader);
-  typedef void (APIENTRYP PFNGLDETACHSHADERPROC) (GLuint program, GLuint shader);
-  typedef void (APIENTRYP PFNGLDISABLEVERTEXATTRIBARRAYPROC) (GLuint index);
-  typedef void (APIENTRYP PFNGLENABLEVERTEXATTRIBARRAYPROC) (GLuint index);
-  typedef void (APIENTRYP PFNGLGETACTIVEATTRIBPROC) (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name);
-  typedef void (APIENTRYP PFNGLGETACTIVEUNIFORMPROC) (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name);
-  typedef void (APIENTRYP PFNGLGETATTACHEDSHADERSPROC) (GLuint program, GLsizei maxCount, GLsizei *count, GLuint *obj);
-  typedef GLint (APIENTRYP PFNGLGETATTRIBLOCATIONPROC) (GLuint program, const GLchar *name);
-  typedef void (APIENTRYP PFNGLGETPROGRAMIVPROC) (GLuint program, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMINFOLOGPROC) (GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog);
-  typedef void (APIENTRYP PFNGLGETSHADERIVPROC) (GLuint shader, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETSHADERINFOLOGPROC) (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog);
-  typedef void (APIENTRYP PFNGLGETSHADERSOURCEPROC) (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *source);
-  typedef GLint (APIENTRYP PFNGLGETUNIFORMLOCATIONPROC) (GLuint program, const GLchar *name);
-  typedef void (APIENTRYP PFNGLGETUNIFORMFVPROC) (GLuint program, GLint location, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETUNIFORMIVPROC) (GLuint program, GLint location, GLint *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBDVPROC) (GLuint index, GLenum pname, GLdouble *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBFVPROC) (GLuint index, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBIVPROC) (GLuint index, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBPOINTERVPROC) (GLuint index, GLenum pname, GLvoid* *pointer);
-  typedef GLboolean (APIENTRYP PFNGLISPROGRAMPROC) (GLuint program);
-  typedef GLboolean (APIENTRYP PFNGLISSHADERPROC) (GLuint shader);
-  typedef void (APIENTRYP PFNGLLINKPROGRAMPROC) (GLuint program);
-  typedef void (APIENTRYP PFNGLSHADERSOURCEPROC) (GLuint shader, GLsizei count, const GLchar* *string, const GLint *length);
-  typedef void (APIENTRYP PFNGLUSEPROGRAMPROC) (GLuint program);
-  typedef void (APIENTRYP PFNGLUNIFORM1FPROC) (GLint location, GLfloat v0);
-  typedef void (APIENTRYP PFNGLUNIFORM2FPROC) (GLint location, GLfloat v0, GLfloat v1);
-  typedef void (APIENTRYP PFNGLUNIFORM3FPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
-  typedef void (APIENTRYP PFNGLUNIFORM4FPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
-  typedef void (APIENTRYP PFNGLUNIFORM1IPROC) (GLint location, GLint v0);
-  typedef void (APIENTRYP PFNGLUNIFORM2IPROC) (GLint location, GLint v0, GLint v1);
-  typedef void (APIENTRYP PFNGLUNIFORM3IPROC) (GLint location, GLint v0, GLint v1, GLint v2);
-  typedef void (APIENTRYP PFNGLUNIFORM4IPROC) (GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
-  typedef void (APIENTRYP PFNGLUNIFORM1FVPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM2FVPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM3FVPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM4FVPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM1IVPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORM2IVPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORM3IVPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORM4IVPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORMMATRIX2FVPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORMMATRIX3FVPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORMMATRIX4FVPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLVALIDATEPROGRAMPROC) (GLuint program);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DPROC) (GLuint index, GLdouble x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FPROC) (GLuint index, GLfloat x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SPROC) (GLuint index, GLshort x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DPROC) (GLuint index, GLdouble x, GLdouble y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FPROC) (GLuint index, GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SPROC) (GLuint index, GLshort x, GLshort y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SPROC) (GLuint index, GLshort x, GLshort y, GLshort z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NBVPROC) (GLuint index, const GLbyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NIVPROC) (GLuint index, const GLint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NSVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBPROC) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBVPROC) (GLuint index, const GLubyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUIVPROC) (GLuint index, const GLuint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUSVPROC) (GLuint index, const GLushort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4BVPROC) (GLuint index, const GLbyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4IVPROC) (GLuint index, const GLint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SPROC) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBVPROC) (GLuint index, const GLubyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UIVPROC) (GLuint index, const GLuint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4USVPROC) (GLuint index, const GLushort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBPOINTERPROC) (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer);
-#endif
-
-#ifndef GL_ARB_multitexture
-#define GL_ARB_multitexture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glActiveTextureARB (GLenum);
-  GLAPI void APIENTRY glClientActiveTextureARB (GLenum);
-  GLAPI void APIENTRY glMultiTexCoord1dARB (GLenum, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord1dvARB (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord1fARB (GLenum, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord1fvARB (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord1iARB (GLenum, GLint);
-  GLAPI void APIENTRY glMultiTexCoord1ivARB (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord1sARB (GLenum, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord1svARB (GLenum, const GLshort *);
-  GLAPI void APIENTRY glMultiTexCoord2dARB (GLenum, GLdouble, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord2dvARB (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord2fARB (GLenum, GLfloat, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord2fvARB (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord2iARB (GLenum, GLint, GLint);
-  GLAPI void APIENTRY glMultiTexCoord2ivARB (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord2sARB (GLenum, GLshort, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord2svARB (GLenum, const GLshort *);
-  GLAPI void APIENTRY glMultiTexCoord3dARB (GLenum, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord3dvARB (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord3fARB (GLenum, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord3fvARB (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord3iARB (GLenum, GLint, GLint, GLint);
-  GLAPI void APIENTRY glMultiTexCoord3ivARB (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord3sARB (GLenum, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord3svARB (GLenum, const GLshort *);
-  GLAPI void APIENTRY glMultiTexCoord4dARB (GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glMultiTexCoord4dvARB (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glMultiTexCoord4fARB (GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glMultiTexCoord4fvARB (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glMultiTexCoord4iARB (GLenum, GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glMultiTexCoord4ivARB (GLenum, const GLint *);
-  GLAPI void APIENTRY glMultiTexCoord4sARB (GLenum, GLshort, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glMultiTexCoord4svARB (GLenum, const GLshort *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLACTIVETEXTUREARBPROC) (GLenum texture);
-  typedef void (APIENTRYP PFNGLCLIENTACTIVETEXTUREARBPROC) (GLenum texture);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DARBPROC) (GLenum target, GLdouble s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DVARBPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FARBPROC) (GLenum target, GLfloat s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FVARBPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IARBPROC) (GLenum target, GLint s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IVARBPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SARBPROC) (GLenum target, GLshort s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SVARBPROC) (GLenum target, const GLshort *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DARBPROC) (GLenum target, GLdouble s, GLdouble t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DVARBPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FARBPROC) (GLenum target, GLfloat s, GLfloat t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FVARBPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IARBPROC) (GLenum target, GLint s, GLint t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IVARBPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SARBPROC) (GLenum target, GLshort s, GLshort t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SVARBPROC) (GLenum target, const GLshort *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DVARBPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FVARBPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IARBPROC) (GLenum target, GLint s, GLint t, GLint r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IVARBPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SVARBPROC) (GLenum target, const GLshort *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DVARBPROC) (GLenum target, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FVARBPROC) (GLenum target, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IARBPROC) (GLenum target, GLint s, GLint t, GLint r, GLint q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IVARBPROC) (GLenum target, const GLint *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SVARBPROC) (GLenum target, const GLshort *v);
-#endif
-
-#ifndef GL_ARB_transpose_matrix
-#define GL_ARB_transpose_matrix 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glLoadTransposeMatrixfARB (const GLfloat *);
-  GLAPI void APIENTRY glLoadTransposeMatrixdARB (const GLdouble *);
-  GLAPI void APIENTRY glMultTransposeMatrixfARB (const GLfloat *);
-  GLAPI void APIENTRY glMultTransposeMatrixdARB (const GLdouble *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXFARBPROC) (const GLfloat *m);
-  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXDARBPROC) (const GLdouble *m);
-  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXFARBPROC) (const GLfloat *m);
-  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXDARBPROC) (const GLdouble *m);
-#endif
-
-#ifndef GL_ARB_multisample
-#define GL_ARB_multisample 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glSampleCoverageARB (GLclampf, GLboolean);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSAMPLECOVERAGEARBPROC) (GLclampf value, GLboolean invert);
-#endif
-
-#ifndef GL_ARB_texture_env_add
-#define GL_ARB_texture_env_add 1
-#endif
-
-#ifndef GL_ARB_texture_cube_map
-#define GL_ARB_texture_cube_map 1
-#endif
-
-#ifndef GL_ARB_texture_compression
-#define GL_ARB_texture_compression 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glCompressedTexImage3DARB (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexImage2DARB (GLenum, GLint, GLenum, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexImage1DARB (GLenum, GLint, GLenum, GLsizei, GLint, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexSubImage3DARB (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexSubImage2DARB (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glCompressedTexSubImage1DARB (GLenum, GLint, GLint, GLsizei, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glGetCompressedTexImageARB (GLenum, GLint, GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE3DARBPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE2DARBPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE1DARBPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC) (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLGETCOMPRESSEDTEXIMAGEARBPROC) (GLenum target, GLint level, GLvoid *img);
-#endif
-
-#ifndef GL_ARB_texture_border_clamp
-#define GL_ARB_texture_border_clamp 1
-#endif
-
-#ifndef GL_ARB_point_parameters
-#define GL_ARB_point_parameters 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPointParameterfARB (GLenum, GLfloat);
-  GLAPI void APIENTRY glPointParameterfvARB (GLenum, const GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFARBPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVARBPROC) (GLenum pname, const GLfloat *params);
-#endif
-
-#ifndef GL_ARB_vertex_blend
-#define GL_ARB_vertex_blend 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glWeightbvARB (GLint, const GLbyte *);
-  GLAPI void APIENTRY glWeightsvARB (GLint, const GLshort *);
-  GLAPI void APIENTRY glWeightivARB (GLint, const GLint *);
-  GLAPI void APIENTRY glWeightfvARB (GLint, const GLfloat *);
-  GLAPI void APIENTRY glWeightdvARB (GLint, const GLdouble *);
-  GLAPI void APIENTRY glWeightubvARB (GLint, const GLubyte *);
-  GLAPI void APIENTRY glWeightusvARB (GLint, const GLushort *);
-  GLAPI void APIENTRY glWeightuivARB (GLint, const GLuint *);
-  GLAPI void APIENTRY glWeightPointerARB (GLint, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glVertexBlendARB (GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLWEIGHTBVARBPROC) (GLint size, const GLbyte *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTSVARBPROC) (GLint size, const GLshort *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTIVARBPROC) (GLint size, const GLint *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTFVARBPROC) (GLint size, const GLfloat *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTDVARBPROC) (GLint size, const GLdouble *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTUBVARBPROC) (GLint size, const GLubyte *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTUSVARBPROC) (GLint size, const GLushort *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTUIVARBPROC) (GLint size, const GLuint *weights);
-  typedef void (APIENTRYP PFNGLWEIGHTPOINTERARBPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLVERTEXBLENDARBPROC) (GLint count);
-#endif
-
-#ifndef GL_ARB_matrix_palette
-#define GL_ARB_matrix_palette 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glCurrentPaletteMatrixARB (GLint);
-  GLAPI void APIENTRY glMatrixIndexubvARB (GLint, const GLubyte *);
-  GLAPI void APIENTRY glMatrixIndexusvARB (GLint, const GLushort *);
-  GLAPI void APIENTRY glMatrixIndexuivARB (GLint, const GLuint *);
-  GLAPI void APIENTRY glMatrixIndexPointerARB (GLint, GLenum, GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCURRENTPALETTEMATRIXARBPROC) (GLint index);
-  typedef void (APIENTRYP PFNGLMATRIXINDEXUBVARBPROC) (GLint size, const GLubyte *indices);
-  typedef void (APIENTRYP PFNGLMATRIXINDEXUSVARBPROC) (GLint size, const GLushort *indices);
-  typedef void (APIENTRYP PFNGLMATRIXINDEXUIVARBPROC) (GLint size, const GLuint *indices);
-  typedef void (APIENTRYP PFNGLMATRIXINDEXPOINTERARBPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
-#endif
-
-#ifndef GL_ARB_texture_env_combine
-#define GL_ARB_texture_env_combine 1
-#endif
-
-#ifndef GL_ARB_texture_env_crossbar
-#define GL_ARB_texture_env_crossbar 1
-#endif
-
-#ifndef GL_ARB_texture_env_dot3
-#define GL_ARB_texture_env_dot3 1
-#endif
-
-#ifndef GL_ARB_texture_mirrored_repeat
-#define GL_ARB_texture_mirrored_repeat 1
-#endif
-
-#ifndef GL_ARB_depth_texture
-#define GL_ARB_depth_texture 1
-#endif
-
-#ifndef GL_ARB_shadow
-#define GL_ARB_shadow 1
-#endif
-
-#ifndef GL_ARB_shadow_ambient
-#define GL_ARB_shadow_ambient 1
-#endif
-
-#ifndef GL_ARB_window_pos
-#define GL_ARB_window_pos 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glWindowPos2dARB (GLdouble, GLdouble);
-  GLAPI void APIENTRY glWindowPos2dvARB (const GLdouble *);
-  GLAPI void APIENTRY glWindowPos2fARB (GLfloat, GLfloat);
-  GLAPI void APIENTRY glWindowPos2fvARB (const GLfloat *);
-  GLAPI void APIENTRY glWindowPos2iARB (GLint, GLint);
-  GLAPI void APIENTRY glWindowPos2ivARB (const GLint *);
-  GLAPI void APIENTRY glWindowPos2sARB (GLshort, GLshort);
-  GLAPI void APIENTRY glWindowPos2svARB (const GLshort *);
-  GLAPI void APIENTRY glWindowPos3dARB (GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glWindowPos3dvARB (const GLdouble *);
-  GLAPI void APIENTRY glWindowPos3fARB (GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glWindowPos3fvARB (const GLfloat *);
-  GLAPI void APIENTRY glWindowPos3iARB (GLint, GLint, GLint);
-  GLAPI void APIENTRY glWindowPos3ivARB (const GLint *);
-  GLAPI void APIENTRY glWindowPos3sARB (GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glWindowPos3svARB (const GLshort *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLWINDOWPOS2DARBPROC) (GLdouble x, GLdouble y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2DVARBPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2FARBPROC) (GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2FVARBPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2IARBPROC) (GLint x, GLint y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2IVARBPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2SARBPROC) (GLshort x, GLshort y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2SVARBPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3DARBPROC) (GLdouble x, GLdouble y, GLdouble z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3DVARBPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3FARBPROC) (GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3FVARBPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3IARBPROC) (GLint x, GLint y, GLint z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3IVARBPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3SARBPROC) (GLshort x, GLshort y, GLshort z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3SVARBPROC) (const GLshort *v);
-#endif
-
-#ifndef GL_ARB_vertex_program
-#define GL_ARB_vertex_program 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glVertexAttrib1dARB (GLuint, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib1dvARB (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib1fARB (GLuint, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib1fvARB (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib1sARB (GLuint, GLshort);
-  GLAPI void APIENTRY glVertexAttrib1svARB (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib2dARB (GLuint, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib2dvARB (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib2fARB (GLuint, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib2fvARB (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib2sARB (GLuint, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib2svARB (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib3dARB (GLuint, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib3dvARB (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib3fARB (GLuint, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib3fvARB (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib3sARB (GLuint, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib3svARB (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4NbvARB (GLuint, const GLbyte *);
-  GLAPI void APIENTRY glVertexAttrib4NivARB (GLuint, const GLint *);
-  GLAPI void APIENTRY glVertexAttrib4NsvARB (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4NubARB (GLuint, GLubyte, GLubyte, GLubyte, GLubyte);
-  GLAPI void APIENTRY glVertexAttrib4NubvARB (GLuint, const GLubyte *);
-  GLAPI void APIENTRY glVertexAttrib4NuivARB (GLuint, const GLuint *);
-  GLAPI void APIENTRY glVertexAttrib4NusvARB (GLuint, const GLushort *);
-  GLAPI void APIENTRY glVertexAttrib4bvARB (GLuint, const GLbyte *);
-  GLAPI void APIENTRY glVertexAttrib4dARB (GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib4dvARB (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib4fARB (GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib4fvARB (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib4ivARB (GLuint, const GLint *);
-  GLAPI void APIENTRY glVertexAttrib4sARB (GLuint, GLshort, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib4svARB (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4ubvARB (GLuint, const GLubyte *);
-  GLAPI void APIENTRY glVertexAttrib4uivARB (GLuint, const GLuint *);
-  GLAPI void APIENTRY glVertexAttrib4usvARB (GLuint, const GLushort *);
-  GLAPI void APIENTRY glVertexAttribPointerARB (GLuint, GLint, GLenum, GLboolean, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glEnableVertexAttribArrayARB (GLuint);
-  GLAPI void APIENTRY glDisableVertexAttribArrayARB (GLuint);
-  GLAPI void APIENTRY glProgramStringARB (GLenum, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glBindProgramARB (GLenum, GLuint);
-  GLAPI void APIENTRY glDeleteProgramsARB (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenProgramsARB (GLsizei, GLuint *);
-  GLAPI void APIENTRY glProgramEnvParameter4dARB (GLenum, GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glProgramEnvParameter4dvARB (GLenum, GLuint, const GLdouble *);
-  GLAPI void APIENTRY glProgramEnvParameter4fARB (GLenum, GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glProgramEnvParameter4fvARB (GLenum, GLuint, const GLfloat *);
-  GLAPI void APIENTRY glProgramLocalParameter4dARB (GLenum, GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glProgramLocalParameter4dvARB (GLenum, GLuint, const GLdouble *);
-  GLAPI void APIENTRY glProgramLocalParameter4fARB (GLenum, GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glProgramLocalParameter4fvARB (GLenum, GLuint, const GLfloat *);
-  GLAPI void APIENTRY glGetProgramEnvParameterdvARB (GLenum, GLuint, GLdouble *);
-  GLAPI void APIENTRY glGetProgramEnvParameterfvARB (GLenum, GLuint, GLfloat *);
-  GLAPI void APIENTRY glGetProgramLocalParameterdvARB (GLenum, GLuint, GLdouble *);
-  GLAPI void APIENTRY glGetProgramLocalParameterfvARB (GLenum, GLuint, GLfloat *);
-  GLAPI void APIENTRY glGetProgramivARB (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetProgramStringARB (GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetVertexAttribdvARB (GLuint, GLenum, GLdouble *);
-  GLAPI void APIENTRY glGetVertexAttribfvARB (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetVertexAttribivARB (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetVertexAttribPointervARB (GLuint, GLenum, GLvoid* *);
-  GLAPI GLboolean APIENTRY glIsProgramARB (GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DARBPROC) (GLuint index, GLdouble x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DVARBPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FARBPROC) (GLuint index, GLfloat x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FVARBPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SARBPROC) (GLuint index, GLshort x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SVARBPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DARBPROC) (GLuint index, GLdouble x, GLdouble y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DVARBPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FARBPROC) (GLuint index, GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FVARBPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SARBPROC) (GLuint index, GLshort x, GLshort y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SVARBPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DARBPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DVARBPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FARBPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FVARBPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SARBPROC) (GLuint index, GLshort x, GLshort y, GLshort z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SVARBPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NBVARBPROC) (GLuint index, const GLbyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NIVARBPROC) (GLuint index, const GLint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NSVARBPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBARBPROC) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBVARBPROC) (GLuint index, const GLubyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUIVARBPROC) (GLuint index, const GLuint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUSVARBPROC) (GLuint index, const GLushort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4BVARBPROC) (GLuint index, const GLbyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DARBPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DVARBPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FARBPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FVARBPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4IVARBPROC) (GLuint index, const GLint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SARBPROC) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SVARBPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBVARBPROC) (GLuint index, const GLubyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UIVARBPROC) (GLuint index, const GLuint *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4USVARBPROC) (GLuint index, const GLushort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBPOINTERARBPROC) (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLENABLEVERTEXATTRIBARRAYARBPROC) (GLuint index);
-  typedef void (APIENTRYP PFNGLDISABLEVERTEXATTRIBARRAYARBPROC) (GLuint index);
-  typedef void (APIENTRYP PFNGLPROGRAMSTRINGARBPROC) (GLenum target, GLenum format, GLsizei len, const GLvoid *string);
-  typedef void (APIENTRYP PFNGLBINDPROGRAMARBPROC) (GLenum target, GLuint program);
-  typedef void (APIENTRYP PFNGLDELETEPROGRAMSARBPROC) (GLsizei n, const GLuint *programs);
-  typedef void (APIENTRYP PFNGLGENPROGRAMSARBPROC) (GLsizei n, GLuint *programs);
-  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4DARBPROC) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4DVARBPROC) (GLenum target, GLuint index, const GLdouble *params);
-  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4FARBPROC) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4FVARBPROC) (GLenum target, GLuint index, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4DARBPROC) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4DVARBPROC) (GLenum target, GLuint index, const GLdouble *params);
-  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4FARBPROC) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4FVARBPROC) (GLenum target, GLuint index, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMENVPARAMETERDVARBPROC) (GLenum target, GLuint index, GLdouble *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMENVPARAMETERFVARBPROC) (GLenum target, GLuint index, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC) (GLenum target, GLuint index, GLdouble *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC) (GLenum target, GLuint index, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMIVARBPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMSTRINGARBPROC) (GLenum target, GLenum pname, GLvoid *string);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBDVARBPROC) (GLuint index, GLenum pname, GLdouble *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBFVARBPROC) (GLuint index, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBIVARBPROC) (GLuint index, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBPOINTERVARBPROC) (GLuint index, GLenum pname, GLvoid* *pointer);
-  typedef GLboolean (APIENTRYP PFNGLISPROGRAMARBPROC) (GLuint program);
-#endif
-
-#ifndef GL_ARB_fragment_program
-#define GL_ARB_fragment_program 1
-  /* All ARB_fragment_program entry points are shared with ARB_vertex_program. */
-#endif
-
-#ifndef GL_ARB_vertex_buffer_object
-#define GL_ARB_vertex_buffer_object 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBindBufferARB (GLenum, GLuint);
-  GLAPI void APIENTRY glDeleteBuffersARB (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenBuffersARB (GLsizei, GLuint *);
-  GLAPI GLboolean APIENTRY glIsBufferARB (GLuint);
-  GLAPI void APIENTRY glBufferDataARB (GLenum, GLsizeiptrARB, const GLvoid *, GLenum);
-  GLAPI void APIENTRY glBufferSubDataARB (GLenum, GLintptrARB, GLsizeiptrARB, const GLvoid *);
-  GLAPI void APIENTRY glGetBufferSubDataARB (GLenum, GLintptrARB, GLsizeiptrARB, GLvoid *);
-  GLAPI GLvoid* APIENTRY glMapBufferARB (GLenum, GLenum);
-  GLAPI GLboolean APIENTRY glUnmapBufferARB (GLenum);
-  GLAPI void APIENTRY glGetBufferParameterivARB (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetBufferPointervARB (GLenum, GLenum, GLvoid* *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBINDBUFFERARBPROC) (GLenum target, GLuint buffer);
-  typedef void (APIENTRYP PFNGLDELETEBUFFERSARBPROC) (GLsizei n, const GLuint *buffers);
-  typedef void (APIENTRYP PFNGLGENBUFFERSARBPROC) (GLsizei n, GLuint *buffers);
-  typedef GLboolean (APIENTRYP PFNGLISBUFFERARBPROC) (GLuint buffer);
-  typedef void (APIENTRYP PFNGLBUFFERDATAARBPROC) (GLenum target, GLsizeiptrARB size, const GLvoid *data, GLenum usage);
-  typedef void (APIENTRYP PFNGLBUFFERSUBDATAARBPROC) (GLenum target, GLintptrARB offset, GLsizeiptrARB size, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLGETBUFFERSUBDATAARBPROC) (GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid *data);
-  typedef GLvoid* (APIENTRYP PFNGLMAPBUFFERARBPROC) (GLenum target, GLenum access);
-  typedef GLboolean (APIENTRYP PFNGLUNMAPBUFFERARBPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLGETBUFFERPARAMETERIVARBPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETBUFFERPOINTERVARBPROC) (GLenum target, GLenum pname, GLvoid* *params);
-#endif
-
-#ifndef GL_ARB_occlusion_query
-#define GL_ARB_occlusion_query 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGenQueriesARB (GLsizei, GLuint *);
-  GLAPI void APIENTRY glDeleteQueriesARB (GLsizei, const GLuint *);
-  GLAPI GLboolean APIENTRY glIsQueryARB (GLuint);
-  GLAPI void APIENTRY glBeginQueryARB (GLenum, GLuint);
-  GLAPI void APIENTRY glEndQueryARB (GLenum);
-  GLAPI void APIENTRY glGetQueryivARB (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetQueryObjectivARB (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetQueryObjectuivARB (GLuint, GLenum, GLuint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGENQUERIESARBPROC) (GLsizei n, GLuint *ids);
-  typedef void (APIENTRYP PFNGLDELETEQUERIESARBPROC) (GLsizei n, const GLuint *ids);
-  typedef GLboolean (APIENTRYP PFNGLISQUERYARBPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLBEGINQUERYARBPROC) (GLenum target, GLuint id);
-  typedef void (APIENTRYP PFNGLENDQUERYARBPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLGETQUERYIVARBPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETQUERYOBJECTIVARBPROC) (GLuint id, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETQUERYOBJECTUIVARBPROC) (GLuint id, GLenum pname, GLuint *params);
-#endif
-
-#ifndef GL_ARB_shader_objects
-#define GL_ARB_shader_objects 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDeleteObjectARB (GLhandleARB);
-  GLAPI GLhandleARB APIENTRY glGetHandleARB (GLenum);
-  GLAPI void APIENTRY glDetachObjectARB (GLhandleARB, GLhandleARB);
-  GLAPI GLhandleARB APIENTRY glCreateShaderObjectARB (GLenum);
-  GLAPI void APIENTRY glShaderSourceARB (GLhandleARB, GLsizei, const GLcharARB* *, const GLint *);
-  GLAPI void APIENTRY glCompileShaderARB (GLhandleARB);
-  GLAPI GLhandleARB APIENTRY glCreateProgramObjectARB (void);
-  GLAPI void APIENTRY glAttachObjectARB (GLhandleARB, GLhandleARB);
-  GLAPI void APIENTRY glLinkProgramARB (GLhandleARB);
-  GLAPI void APIENTRY glUseProgramObjectARB (GLhandleARB);
-  GLAPI void APIENTRY glValidateProgramARB (GLhandleARB);
-  GLAPI void APIENTRY glUniform1fARB (GLint, GLfloat);
-  GLAPI void APIENTRY glUniform2fARB (GLint, GLfloat, GLfloat);
-  GLAPI void APIENTRY glUniform3fARB (GLint, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glUniform4fARB (GLint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glUniform1iARB (GLint, GLint);
-  GLAPI void APIENTRY glUniform2iARB (GLint, GLint, GLint);
-  GLAPI void APIENTRY glUniform3iARB (GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glUniform4iARB (GLint, GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glUniform1fvARB (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform2fvARB (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform3fvARB (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform4fvARB (GLint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glUniform1ivARB (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniform2ivARB (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniform3ivARB (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniform4ivARB (GLint, GLsizei, const GLint *);
-  GLAPI void APIENTRY glUniformMatrix2fvARB (GLint, GLsizei, GLboolean, const GLfloat *);
-  GLAPI void APIENTRY glUniformMatrix3fvARB (GLint, GLsizei, GLboolean, const GLfloat *);
-  GLAPI void APIENTRY glUniformMatrix4fvARB (GLint, GLsizei, GLboolean, const GLfloat *);
-  GLAPI void APIENTRY glGetObjectParameterfvARB (GLhandleARB, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetObjectParameterivARB (GLhandleARB, GLenum, GLint *);
-  GLAPI void APIENTRY glGetInfoLogARB (GLhandleARB, GLsizei, GLsizei *, GLcharARB *);
-  GLAPI void APIENTRY glGetAttachedObjectsARB (GLhandleARB, GLsizei, GLsizei *, GLhandleARB *);
-  GLAPI GLint APIENTRY glGetUniformLocationARB (GLhandleARB, const GLcharARB *);
-  GLAPI void APIENTRY glGetActiveUniformARB (GLhandleARB, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLcharARB *);
-  GLAPI void APIENTRY glGetUniformfvARB (GLhandleARB, GLint, GLfloat *);
-  GLAPI void APIENTRY glGetUniformivARB (GLhandleARB, GLint, GLint *);
-  GLAPI void APIENTRY glGetShaderSourceARB (GLhandleARB, GLsizei, GLsizei *, GLcharARB *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDELETEOBJECTARBPROC) (GLhandleARB obj);
-  typedef GLhandleARB (APIENTRYP PFNGLGETHANDLEARBPROC) (GLenum pname);
-  typedef void (APIENTRYP PFNGLDETACHOBJECTARBPROC) (GLhandleARB containerObj, GLhandleARB attachedObj);
-  typedef GLhandleARB (APIENTRYP PFNGLCREATESHADEROBJECTARBPROC) (GLenum shaderType);
-  typedef void (APIENTRYP PFNGLSHADERSOURCEARBPROC) (GLhandleARB shaderObj, GLsizei count, const GLcharARB* *string, const GLint *length);
-  typedef void (APIENTRYP PFNGLCOMPILESHADERARBPROC) (GLhandleARB shaderObj);
-  typedef GLhandleARB (APIENTRYP PFNGLCREATEPROGRAMOBJECTARBPROC) (void);
-  typedef void (APIENTRYP PFNGLATTACHOBJECTARBPROC) (GLhandleARB containerObj, GLhandleARB obj);
-  typedef void (APIENTRYP PFNGLLINKPROGRAMARBPROC) (GLhandleARB programObj);
-  typedef void (APIENTRYP PFNGLUSEPROGRAMOBJECTARBPROC) (GLhandleARB programObj);
-  typedef void (APIENTRYP PFNGLVALIDATEPROGRAMARBPROC) (GLhandleARB programObj);
-  typedef void (APIENTRYP PFNGLUNIFORM1FARBPROC) (GLint location, GLfloat v0);
-  typedef void (APIENTRYP PFNGLUNIFORM2FARBPROC) (GLint location, GLfloat v0, GLfloat v1);
-  typedef void (APIENTRYP PFNGLUNIFORM3FARBPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
-  typedef void (APIENTRYP PFNGLUNIFORM4FARBPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
-  typedef void (APIENTRYP PFNGLUNIFORM1IARBPROC) (GLint location, GLint v0);
-  typedef void (APIENTRYP PFNGLUNIFORM2IARBPROC) (GLint location, GLint v0, GLint v1);
-  typedef void (APIENTRYP PFNGLUNIFORM3IARBPROC) (GLint location, GLint v0, GLint v1, GLint v2);
-  typedef void (APIENTRYP PFNGLUNIFORM4IARBPROC) (GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
-  typedef void (APIENTRYP PFNGLUNIFORM1FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM2FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM3FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM4FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORM1IVARBPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORM2IVARBPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORM3IVARBPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORM4IVARBPROC) (GLint location, GLsizei count, const GLint *value);
-  typedef void (APIENTRYP PFNGLUNIFORMMATRIX2FVARBPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORMMATRIX3FVARBPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLUNIFORMMATRIX4FVARBPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
-  typedef void (APIENTRYP PFNGLGETOBJECTPARAMETERFVARBPROC) (GLhandleARB obj, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETOBJECTPARAMETERIVARBPROC) (GLhandleARB obj, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETINFOLOGARBPROC) (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *infoLog);
-  typedef void (APIENTRYP PFNGLGETATTACHEDOBJECTSARBPROC) (GLhandleARB containerObj, GLsizei maxCount, GLsizei *count, GLhandleARB *obj);
-  typedef GLint (APIENTRYP PFNGLGETUNIFORMLOCATIONARBPROC) (GLhandleARB programObj, const GLcharARB *name);
-  typedef void (APIENTRYP PFNGLGETACTIVEUNIFORMARBPROC) (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
-  typedef void (APIENTRYP PFNGLGETUNIFORMFVARBPROC) (GLhandleARB programObj, GLint location, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETUNIFORMIVARBPROC) (GLhandleARB programObj, GLint location, GLint *params);
-  typedef void (APIENTRYP PFNGLGETSHADERSOURCEARBPROC) (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *source);
-#endif
-
-#ifndef GL_ARB_vertex_shader
-#define GL_ARB_vertex_shader 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBindAttribLocationARB (GLhandleARB, GLuint, const GLcharARB *);
-  GLAPI void APIENTRY glGetActiveAttribARB (GLhandleARB, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLcharARB *);
-  GLAPI GLint APIENTRY glGetAttribLocationARB (GLhandleARB, const GLcharARB *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBINDATTRIBLOCATIONARBPROC) (GLhandleARB programObj, GLuint index, const GLcharARB *name);
-  typedef void (APIENTRYP PFNGLGETACTIVEATTRIBARBPROC) (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
-  typedef GLint (APIENTRYP PFNGLGETATTRIBLOCATIONARBPROC) (GLhandleARB programObj, const GLcharARB *name);
-#endif
-
-#ifndef GL_ARB_fragment_shader
-#define GL_ARB_fragment_shader 1
-#endif
-
-#ifndef GL_ARB_shading_language_100
-#define GL_ARB_shading_language_100 1
-#endif
-
-#ifndef GL_ARB_texture_non_power_of_two
-#define GL_ARB_texture_non_power_of_two 1
-#endif
-
-#ifndef GL_ARB_point_sprite
-#define GL_ARB_point_sprite 1
-#endif
-
-#ifndef GL_ARB_fragment_program_shadow
-#define GL_ARB_fragment_program_shadow 1
-#endif
-
-#ifndef GL_ARB_draw_buffers
-#define GL_ARB_draw_buffers 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDrawBuffersARB (GLsizei, const GLenum *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDRAWBUFFERSARBPROC) (GLsizei n, const GLenum *bufs);
-#endif
-
-#ifndef GL_ARB_texture_rectangle
-#define GL_ARB_texture_rectangle 1
-#endif
-
-#ifndef GL_ARB_color_buffer_float
-#define GL_ARB_color_buffer_float 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glClampColorARB (GLenum, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCLAMPCOLORARBPROC) (GLenum target, GLenum clamp);
-#endif
-
-#ifndef GL_ARB_half_float_pixel
-#define GL_ARB_half_float_pixel 1
-#endif
-
-#ifndef GL_ARB_texture_float
-#define GL_ARB_texture_float 1
-#endif
-
-#ifndef GL_ARB_pixel_buffer_object
-#define GL_ARB_pixel_buffer_object 1
-#endif
-
-#ifndef GL_EXT_abgr
-#define GL_EXT_abgr 1
-#endif
-
-#ifndef GL_EXT_blend_color
-#define GL_EXT_blend_color 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendColorEXT (GLclampf, GLclampf, GLclampf, GLclampf);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDCOLOREXTPROC) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
-#endif
-
-#ifndef GL_EXT_polygon_offset
-#define GL_EXT_polygon_offset 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPolygonOffsetEXT (GLfloat, GLfloat);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPOLYGONOFFSETEXTPROC) (GLfloat factor, GLfloat bias);
-#endif
-
-#ifndef GL_EXT_texture
-#define GL_EXT_texture 1
-#endif
-
-#ifndef GL_EXT_texture3D
-#define GL_EXT_texture3D 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTexImage3DEXT (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glTexSubImage3DEXT (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTEXIMAGE3DEXTPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
-  typedef void (APIENTRYP PFNGLTEXSUBIMAGE3DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels);
-#endif
-
-#ifndef GL_SGIS_texture_filter4
-#define GL_SGIS_texture_filter4 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGetTexFilterFuncSGIS (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glTexFilterFuncSGIS (GLenum, GLenum, GLsizei, const GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGETTEXFILTERFUNCSGISPROC) (GLenum target, GLenum filter, GLfloat *weights);
-  typedef void (APIENTRYP PFNGLTEXFILTERFUNCSGISPROC) (GLenum target, GLenum filter, GLsizei n, const GLfloat *weights);
-#endif
-
-#ifndef GL_EXT_subtexture
-#define GL_EXT_subtexture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTexSubImage1DEXT (GLenum, GLint, GLint, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glTexSubImage2DEXT (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTEXSUBIMAGE1DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels);
-  typedef void (APIENTRYP PFNGLTEXSUBIMAGE2DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
-#endif
-
-#ifndef GL_EXT_copy_texture
-#define GL_EXT_copy_texture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glCopyTexImage1DEXT (GLenum, GLint, GLenum, GLint, GLint, GLsizei, GLint);
-  GLAPI void APIENTRY glCopyTexImage2DEXT (GLenum, GLint, GLenum, GLint, GLint, GLsizei, GLsizei, GLint);
-  GLAPI void APIENTRY glCopyTexSubImage1DEXT (GLenum, GLint, GLint, GLint, GLint, GLsizei);
-  GLAPI void APIENTRY glCopyTexSubImage2DEXT (GLenum, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
-  GLAPI void APIENTRY glCopyTexSubImage3DEXT (GLenum, GLint, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOPYTEXIMAGE1DEXTPROC) (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border);
-  typedef void (APIENTRYP PFNGLCOPYTEXIMAGE2DEXTPROC) (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
-  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE1DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
-  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE2DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
-  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE3DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
-#endif
-
-#ifndef GL_EXT_histogram
-#define GL_EXT_histogram 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGetHistogramEXT (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetHistogramParameterfvEXT (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetHistogramParameterivEXT (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetMinmaxEXT (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetMinmaxParameterfvEXT (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetMinmaxParameterivEXT (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glHistogramEXT (GLenum, GLsizei, GLenum, GLboolean);
-  GLAPI void APIENTRY glMinmaxEXT (GLenum, GLenum, GLboolean);
-  GLAPI void APIENTRY glResetHistogramEXT (GLenum);
-  GLAPI void APIENTRY glResetMinmaxEXT (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGETHISTOGRAMEXTPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
-  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETMINMAXEXTPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
-  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLHISTOGRAMEXTPROC) (GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
-  typedef void (APIENTRYP PFNGLMINMAXEXTPROC) (GLenum target, GLenum internalformat, GLboolean sink);
-  typedef void (APIENTRYP PFNGLRESETHISTOGRAMEXTPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLRESETMINMAXEXTPROC) (GLenum target);
-#endif
-
-#ifndef GL_EXT_convolution
-#define GL_EXT_convolution 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glConvolutionFilter1DEXT (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glConvolutionFilter2DEXT (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glConvolutionParameterfEXT (GLenum, GLenum, GLfloat);
-  GLAPI void APIENTRY glConvolutionParameterfvEXT (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glConvolutionParameteriEXT (GLenum, GLenum, GLint);
-  GLAPI void APIENTRY glConvolutionParameterivEXT (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glCopyConvolutionFilter1DEXT (GLenum, GLenum, GLint, GLint, GLsizei);
-  GLAPI void APIENTRY glCopyConvolutionFilter2DEXT (GLenum, GLenum, GLint, GLint, GLsizei, GLsizei);
-  GLAPI void APIENTRY glGetConvolutionFilterEXT (GLenum, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetConvolutionParameterfvEXT (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetConvolutionParameterivEXT (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetSeparableFilterEXT (GLenum, GLenum, GLenum, GLvoid *, GLvoid *, GLvoid *);
-  GLAPI void APIENTRY glSeparableFilter2DEXT (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER1DEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER2DEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFEXTPROC) (GLenum target, GLenum pname, GLfloat params);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFVEXTPROC) (GLenum target, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIEXTPROC) (GLenum target, GLenum pname, GLint params);
-  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIVEXTPROC) (GLenum target, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER1DEXTPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
-  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER2DEXTPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
-  typedef void (APIENTRYP PFNGLGETCONVOLUTIONFILTEREXTPROC) (GLenum target, GLenum format, GLenum type, GLvoid *image);
-  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETSEPARABLEFILTEREXTPROC) (GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span);
-  typedef void (APIENTRYP PFNGLSEPARABLEFILTER2DEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column);
-#endif
-
-#ifndef GL_EXT_color_matrix
-#define GL_EXT_color_matrix 1
-#endif
-
-#ifndef GL_SGI_color_table
-#define GL_SGI_color_table 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glColorTableSGI (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glColorTableParameterfvSGI (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glColorTableParameterivSGI (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glCopyColorTableSGI (GLenum, GLenum, GLint, GLint, GLsizei);
-  GLAPI void APIENTRY glGetColorTableSGI (GLenum, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetColorTableParameterfvSGI (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetColorTableParameterivSGI (GLenum, GLenum, GLint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOLORTABLESGIPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table);
-  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERFVSGIPROC) (GLenum target, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERIVSGIPROC) (GLenum target, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLCOPYCOLORTABLESGIPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLESGIPROC) (GLenum target, GLenum format, GLenum type, GLvoid *table);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERFVSGIPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERIVSGIPROC) (GLenum target, GLenum pname, GLint *params);
-#endif
-
-#ifndef GL_SGIX_pixel_texture
-#define GL_SGIX_pixel_texture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPixelTexGenSGIX (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPIXELTEXGENSGIXPROC) (GLenum mode);
-#endif
-
-#ifndef GL_SGIS_pixel_texture
-#define GL_SGIS_pixel_texture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPixelTexGenParameteriSGIS (GLenum, GLint);
-  GLAPI void APIENTRY glPixelTexGenParameterivSGIS (GLenum, const GLint *);
-  GLAPI void APIENTRY glPixelTexGenParameterfSGIS (GLenum, GLfloat);
-  GLAPI void APIENTRY glPixelTexGenParameterfvSGIS (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glGetPixelTexGenParameterivSGIS (GLenum, GLint *);
-  GLAPI void APIENTRY glGetPixelTexGenParameterfvSGIS (GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERISGISPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERIVSGISPROC) (GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERFSGISPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERFVSGISPROC) (GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETPIXELTEXGENPARAMETERIVSGISPROC) (GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETPIXELTEXGENPARAMETERFVSGISPROC) (GLenum pname, GLfloat *params);
-#endif
-
-#ifndef GL_SGIS_texture4D
-#define GL_SGIS_texture4D 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTexImage4DSGIS (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glTexSubImage4DSGIS (GLenum, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTEXIMAGE4DSGISPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
-  typedef void (APIENTRYP PFNGLTEXSUBIMAGE4DSGISPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint woffset, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLenum format, GLenum type, const GLvoid *pixels);
-#endif
-
-#ifndef GL_SGI_texture_color_table
-#define GL_SGI_texture_color_table 1
-#endif
-
-#ifndef GL_EXT_cmyka
-#define GL_EXT_cmyka 1
-#endif
-
-#ifndef GL_EXT_texture_object
-#define GL_EXT_texture_object 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI GLboolean APIENTRY glAreTexturesResidentEXT (GLsizei, const GLuint *, GLboolean *);
-  GLAPI void APIENTRY glBindTextureEXT (GLenum, GLuint);
-  GLAPI void APIENTRY glDeleteTexturesEXT (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenTexturesEXT (GLsizei, GLuint *);
-  GLAPI GLboolean APIENTRY glIsTextureEXT (GLuint);
-  GLAPI void APIENTRY glPrioritizeTexturesEXT (GLsizei, const GLuint *, const GLclampf *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef GLboolean (APIENTRYP PFNGLARETEXTURESRESIDENTEXTPROC) (GLsizei n, const GLuint *textures, GLboolean *residences);
-  typedef void (APIENTRYP PFNGLBINDTEXTUREEXTPROC) (GLenum target, GLuint texture);
-  typedef void (APIENTRYP PFNGLDELETETEXTURESEXTPROC) (GLsizei n, const GLuint *textures);
-  typedef void (APIENTRYP PFNGLGENTEXTURESEXTPROC) (GLsizei n, GLuint *textures);
-  typedef GLboolean (APIENTRYP PFNGLISTEXTUREEXTPROC) (GLuint texture);
-  typedef void (APIENTRYP PFNGLPRIORITIZETEXTURESEXTPROC) (GLsizei n, const GLuint *textures, const GLclampf *priorities);
-#endif
-
-#ifndef GL_SGIS_detail_texture
-#define GL_SGIS_detail_texture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDetailTexFuncSGIS (GLenum, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glGetDetailTexFuncSGIS (GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDETAILTEXFUNCSGISPROC) (GLenum target, GLsizei n, const GLfloat *points);
-  typedef void (APIENTRYP PFNGLGETDETAILTEXFUNCSGISPROC) (GLenum target, GLfloat *points);
-#endif
-
-#ifndef GL_SGIS_sharpen_texture
-#define GL_SGIS_sharpen_texture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glSharpenTexFuncSGIS (GLenum, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glGetSharpenTexFuncSGIS (GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSHARPENTEXFUNCSGISPROC) (GLenum target, GLsizei n, const GLfloat *points);
-  typedef void (APIENTRYP PFNGLGETSHARPENTEXFUNCSGISPROC) (GLenum target, GLfloat *points);
-#endif
-
-#ifndef GL_EXT_packed_pixels
-#define GL_EXT_packed_pixels 1
-#endif
-
-#ifndef GL_SGIS_texture_lod
-#define GL_SGIS_texture_lod 1
-#endif
-
-#ifndef GL_SGIS_multisample
-#define GL_SGIS_multisample 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glSampleMaskSGIS (GLclampf, GLboolean);
-  GLAPI void APIENTRY glSamplePatternSGIS (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSAMPLEMASKSGISPROC) (GLclampf value, GLboolean invert);
-  typedef void (APIENTRYP PFNGLSAMPLEPATTERNSGISPROC) (GLenum pattern);
-#endif
-
-#ifndef GL_EXT_rescale_normal
-#define GL_EXT_rescale_normal 1
-#endif
-
-#ifndef GL_EXT_vertex_array
-#define GL_EXT_vertex_array 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glArrayElementEXT (GLint);
-  GLAPI void APIENTRY glColorPointerEXT (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glDrawArraysEXT (GLenum, GLint, GLsizei);
-  GLAPI void APIENTRY glEdgeFlagPointerEXT (GLsizei, GLsizei, const GLboolean *);
-  GLAPI void APIENTRY glGetPointervEXT (GLenum, GLvoid* *);
-  GLAPI void APIENTRY glIndexPointerEXT (GLenum, GLsizei, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glNormalPointerEXT (GLenum, GLsizei, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glTexCoordPointerEXT (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glVertexPointerEXT (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLARRAYELEMENTEXTPROC) (GLint i);
-  typedef void (APIENTRYP PFNGLCOLORPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLDRAWARRAYSEXTPROC) (GLenum mode, GLint first, GLsizei count);
-  typedef void (APIENTRYP PFNGLEDGEFLAGPOINTEREXTPROC) (GLsizei stride, GLsizei count, const GLboolean *pointer);
-  typedef void (APIENTRYP PFNGLGETPOINTERVEXTPROC) (GLenum pname, GLvoid* *params);
-  typedef void (APIENTRYP PFNGLINDEXPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLNORMALPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLTEXCOORDPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLVERTEXPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
-#endif
-
-#ifndef GL_EXT_misc_attribute
-#define GL_EXT_misc_attribute 1
-#endif
-
-#ifndef GL_SGIS_generate_mipmap
-#define GL_SGIS_generate_mipmap 1
-#endif
-
-#ifndef GL_SGIX_clipmap
-#define GL_SGIX_clipmap 1
-#endif
-
-#ifndef GL_SGIX_shadow
-#define GL_SGIX_shadow 1
-#endif
-
-#ifndef GL_SGIS_texture_edge_clamp
-#define GL_SGIS_texture_edge_clamp 1
-#endif
-
-#ifndef GL_SGIS_texture_border_clamp
-#define GL_SGIS_texture_border_clamp 1
-#endif
-
-#ifndef GL_EXT_blend_minmax
-#define GL_EXT_blend_minmax 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendEquationEXT (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDEQUATIONEXTPROC) (GLenum mode);
-#endif
-
-#ifndef GL_EXT_blend_subtract
-#define GL_EXT_blend_subtract 1
-#endif
-
-#ifndef GL_EXT_blend_logic_op
-#define GL_EXT_blend_logic_op 1
-#endif
-
-#ifndef GL_SGIX_interlace
-#define GL_SGIX_interlace 1
-#endif
-
-#ifndef GL_SGIX_pixel_tiles
-#define GL_SGIX_pixel_tiles 1
-#endif
-
-#ifndef GL_SGIX_texture_select
-#define GL_SGIX_texture_select 1
-#endif
-
-#ifndef GL_SGIX_sprite
-#define GL_SGIX_sprite 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glSpriteParameterfSGIX (GLenum, GLfloat);
-  GLAPI void APIENTRY glSpriteParameterfvSGIX (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glSpriteParameteriSGIX (GLenum, GLint);
-  GLAPI void APIENTRY glSpriteParameterivSGIX (GLenum, const GLint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSPRITEPARAMETERFSGIXPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLSPRITEPARAMETERFVSGIXPROC) (GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLSPRITEPARAMETERISGIXPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLSPRITEPARAMETERIVSGIXPROC) (GLenum pname, const GLint *params);
-#endif
-
-#ifndef GL_SGIX_texture_multi_buffer
-#define GL_SGIX_texture_multi_buffer 1
-#endif
-
-#ifndef GL_EXT_point_parameters
-#define GL_EXT_point_parameters 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPointParameterfEXT (GLenum, GLfloat);
-  GLAPI void APIENTRY glPointParameterfvEXT (GLenum, const GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFEXTPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVEXTPROC) (GLenum pname, const GLfloat *params);
-#endif
-
-#ifndef GL_SGIS_point_parameters
-#define GL_SGIS_point_parameters 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPointParameterfSGIS (GLenum, GLfloat);
-  GLAPI void APIENTRY glPointParameterfvSGIS (GLenum, const GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFSGISPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVSGISPROC) (GLenum pname, const GLfloat *params);
-#endif
-
-#ifndef GL_SGIX_instruments
-#define GL_SGIX_instruments 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI GLint APIENTRY glGetInstrumentsSGIX (void);
-  GLAPI void APIENTRY glInstrumentsBufferSGIX (GLsizei, GLint *);
-  GLAPI GLint APIENTRY glPollInstrumentsSGIX (GLint *);
-  GLAPI void APIENTRY glReadInstrumentsSGIX (GLint);
-  GLAPI void APIENTRY glStartInstrumentsSGIX (void);
-  GLAPI void APIENTRY glStopInstrumentsSGIX (GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef GLint (APIENTRYP PFNGLGETINSTRUMENTSSGIXPROC) (void);
-  typedef void (APIENTRYP PFNGLINSTRUMENTSBUFFERSGIXPROC) (GLsizei size, GLint *buffer);
-  typedef GLint (APIENTRYP PFNGLPOLLINSTRUMENTSSGIXPROC) (GLint *marker_p);
-  typedef void (APIENTRYP PFNGLREADINSTRUMENTSSGIXPROC) (GLint marker);
-  typedef void (APIENTRYP PFNGLSTARTINSTRUMENTSSGIXPROC) (void);
-  typedef void (APIENTRYP PFNGLSTOPINSTRUMENTSSGIXPROC) (GLint marker);
-#endif
-
-#ifndef GL_SGIX_texture_scale_bias
-#define GL_SGIX_texture_scale_bias 1
-#endif
-
-#ifndef GL_SGIX_framezoom
-#define GL_SGIX_framezoom 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glFrameZoomSGIX (GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLFRAMEZOOMSGIXPROC) (GLint factor);
-#endif
-
-#ifndef GL_SGIX_tag_sample_buffer
-#define GL_SGIX_tag_sample_buffer 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTagSampleBufferSGIX (void);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTAGSAMPLEBUFFERSGIXPROC) (void);
-#endif
-
-#ifndef GL_SGIX_polynomial_ffd
-#define GL_SGIX_polynomial_ffd 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDeformationMap3dSGIX (GLenum, GLdouble, GLdouble, GLint, GLint, GLdouble, GLdouble, GLint, GLint, GLdouble, GLdouble, GLint, GLint, const GLdouble *);
-  GLAPI void APIENTRY glDeformationMap3fSGIX (GLenum, GLfloat, GLfloat, GLint, GLint, GLfloat, GLfloat, GLint, GLint, GLfloat, GLfloat, GLint, GLint, const GLfloat *);
-  GLAPI void APIENTRY glDeformSGIX (GLbitfield);
-  GLAPI void APIENTRY glLoadIdentityDeformationMapSGIX (GLbitfield);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDEFORMATIONMAP3DSGIXPROC) (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble w1, GLdouble w2, GLint wstride, GLint worder, const GLdouble *points);
-  typedef void (APIENTRYP PFNGLDEFORMATIONMAP3FSGIXPROC) (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat w1, GLfloat w2, GLint wstride, GLint worder, const GLfloat *points);
-  typedef void (APIENTRYP PFNGLDEFORMSGIXPROC) (GLbitfield mask);
-  typedef void (APIENTRYP PFNGLLOADIDENTITYDEFORMATIONMAPSGIXPROC) (GLbitfield mask);
-#endif
-
-#ifndef GL_SGIX_reference_plane
-#define GL_SGIX_reference_plane 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glReferencePlaneSGIX (const GLdouble *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLREFERENCEPLANESGIXPROC) (const GLdouble *equation);
-#endif
-
-#ifndef GL_SGIX_flush_raster
-#define GL_SGIX_flush_raster 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glFlushRasterSGIX (void);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLFLUSHRASTERSGIXPROC) (void);
-#endif
-
-#ifndef GL_SGIX_depth_texture
-#define GL_SGIX_depth_texture 1
-#endif
-
-#ifndef GL_SGIS_fog_function
-#define GL_SGIS_fog_function 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glFogFuncSGIS (GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glGetFogFuncSGIS (GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLFOGFUNCSGISPROC) (GLsizei n, const GLfloat *points);
-  typedef void (APIENTRYP PFNGLGETFOGFUNCSGISPROC) (GLfloat *points);
-#endif
-
-#ifndef GL_SGIX_fog_offset
-#define GL_SGIX_fog_offset 1
-#endif
-
-#ifndef GL_HP_image_transform
-#define GL_HP_image_transform 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glImageTransformParameteriHP (GLenum, GLenum, GLint);
-  GLAPI void APIENTRY glImageTransformParameterfHP (GLenum, GLenum, GLfloat);
-  GLAPI void APIENTRY glImageTransformParameterivHP (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glImageTransformParameterfvHP (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glGetImageTransformParameterivHP (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetImageTransformParameterfvHP (GLenum, GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERIHPPROC) (GLenum target, GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERFHPPROC) (GLenum target, GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERIVHPPROC) (GLenum target, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERFVHPPROC) (GLenum target, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETIMAGETRANSFORMPARAMETERIVHPPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETIMAGETRANSFORMPARAMETERFVHPPROC) (GLenum target, GLenum pname, GLfloat *params);
-#endif
-
-#ifndef GL_HP_convolution_border_modes
-#define GL_HP_convolution_border_modes 1
-#endif
-
-#ifndef GL_SGIX_texture_add_env
-#define GL_SGIX_texture_add_env 1
-#endif
-
-#ifndef GL_EXT_color_subtable
-#define GL_EXT_color_subtable 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glColorSubTableEXT (GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glCopyColorSubTableEXT (GLenum, GLsizei, GLint, GLint, GLsizei);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOLORSUBTABLEEXTPROC) (GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data);
-  typedef void (APIENTRYP PFNGLCOPYCOLORSUBTABLEEXTPROC) (GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
-#endif
-
-#ifndef GL_PGI_vertex_hints
-#define GL_PGI_vertex_hints 1
-#endif
-
-#ifndef GL_PGI_misc_hints
-#define GL_PGI_misc_hints 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glHintPGI (GLenum, GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLHINTPGIPROC) (GLenum target, GLint mode);
-#endif
-
-#ifndef GL_EXT_paletted_texture
-#define GL_EXT_paletted_texture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glColorTableEXT (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glGetColorTableEXT (GLenum, GLenum, GLenum, GLvoid *);
-  GLAPI void APIENTRY glGetColorTableParameterivEXT (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetColorTableParameterfvEXT (GLenum, GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOLORTABLEEXTPROC) (GLenum target, GLenum internalFormat, GLsizei width, GLenum format, GLenum type, const GLvoid *table);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEEXTPROC) (GLenum target, GLenum format, GLenum type, GLvoid *data);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
-#endif
-
-#ifndef GL_EXT_clip_volume_hint
-#define GL_EXT_clip_volume_hint 1
-#endif
-
-#ifndef GL_SGIX_list_priority
-#define GL_SGIX_list_priority 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGetListParameterfvSGIX (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetListParameterivSGIX (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glListParameterfSGIX (GLuint, GLenum, GLfloat);
-  GLAPI void APIENTRY glListParameterfvSGIX (GLuint, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glListParameteriSGIX (GLuint, GLenum, GLint);
-  GLAPI void APIENTRY glListParameterivSGIX (GLuint, GLenum, const GLint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGETLISTPARAMETERFVSGIXPROC) (GLuint list, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETLISTPARAMETERIVSGIXPROC) (GLuint list, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLLISTPARAMETERFSGIXPROC) (GLuint list, GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLLISTPARAMETERFVSGIXPROC) (GLuint list, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLLISTPARAMETERISGIXPROC) (GLuint list, GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLLISTPARAMETERIVSGIXPROC) (GLuint list, GLenum pname, const GLint *params);
-#endif
-
-#ifndef GL_SGIX_ir_instrument1
-#define GL_SGIX_ir_instrument1 1
-#endif
-
-#ifndef GL_SGIX_calligraphic_fragment
-#define GL_SGIX_calligraphic_fragment 1
-#endif
-
-#ifndef GL_SGIX_texture_lod_bias
-#define GL_SGIX_texture_lod_bias 1
-#endif
-
-#ifndef GL_SGIX_shadow_ambient
-#define GL_SGIX_shadow_ambient 1
-#endif
-
-#ifndef GL_EXT_index_texture
-#define GL_EXT_index_texture 1
-#endif
-
-#ifndef GL_EXT_index_material
-#define GL_EXT_index_material 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glIndexMaterialEXT (GLenum, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLINDEXMATERIALEXTPROC) (GLenum face, GLenum mode);
-#endif
-
-#ifndef GL_EXT_index_func
-#define GL_EXT_index_func 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glIndexFuncEXT (GLenum, GLclampf);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLINDEXFUNCEXTPROC) (GLenum func, GLclampf ref);
-#endif
-
-#ifndef GL_EXT_index_array_formats
-#define GL_EXT_index_array_formats 1
-#endif
-
-#ifndef GL_EXT_compiled_vertex_array
-#define GL_EXT_compiled_vertex_array 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glLockArraysEXT (GLint, GLsizei);
-  GLAPI void APIENTRY glUnlockArraysEXT (void);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLLOCKARRAYSEXTPROC) (GLint first, GLsizei count);
-  typedef void (APIENTRYP PFNGLUNLOCKARRAYSEXTPROC) (void);
-#endif
-
-#ifndef GL_EXT_cull_vertex
-#define GL_EXT_cull_vertex 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glCullParameterdvEXT (GLenum, GLdouble *);
-  GLAPI void APIENTRY glCullParameterfvEXT (GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCULLPARAMETERDVEXTPROC) (GLenum pname, GLdouble *params);
-  typedef void (APIENTRYP PFNGLCULLPARAMETERFVEXTPROC) (GLenum pname, GLfloat *params);
-#endif
-
-#ifndef GL_SGIX_ycrcb
-#define GL_SGIX_ycrcb 1
-#endif
-
-#ifndef GL_SGIX_fragment_lighting
-#define GL_SGIX_fragment_lighting 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glFragmentColorMaterialSGIX (GLenum, GLenum);
-  GLAPI void APIENTRY glFragmentLightfSGIX (GLenum, GLenum, GLfloat);
-  GLAPI void APIENTRY glFragmentLightfvSGIX (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glFragmentLightiSGIX (GLenum, GLenum, GLint);
-  GLAPI void APIENTRY glFragmentLightivSGIX (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glFragmentLightModelfSGIX (GLenum, GLfloat);
-  GLAPI void APIENTRY glFragmentLightModelfvSGIX (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glFragmentLightModeliSGIX (GLenum, GLint);
-  GLAPI void APIENTRY glFragmentLightModelivSGIX (GLenum, const GLint *);
-  GLAPI void APIENTRY glFragmentMaterialfSGIX (GLenum, GLenum, GLfloat);
-  GLAPI void APIENTRY glFragmentMaterialfvSGIX (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glFragmentMaterialiSGIX (GLenum, GLenum, GLint);
-  GLAPI void APIENTRY glFragmentMaterialivSGIX (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glGetFragmentLightfvSGIX (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetFragmentLightivSGIX (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetFragmentMaterialfvSGIX (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetFragmentMaterialivSGIX (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glLightEnviSGIX (GLenum, GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLFRAGMENTCOLORMATERIALSGIXPROC) (GLenum face, GLenum mode);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTFSGIXPROC) (GLenum light, GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTFVSGIXPROC) (GLenum light, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTISGIXPROC) (GLenum light, GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTIVSGIXPROC) (GLenum light, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELFSGIXPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELFVSGIXPROC) (GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELISGIXPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELIVSGIXPROC) (GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALFSGIXPROC) (GLenum face, GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALFVSGIXPROC) (GLenum face, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALISGIXPROC) (GLenum face, GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALIVSGIXPROC) (GLenum face, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLGETFRAGMENTLIGHTFVSGIXPROC) (GLenum light, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETFRAGMENTLIGHTIVSGIXPROC) (GLenum light, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETFRAGMENTMATERIALFVSGIXPROC) (GLenum face, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETFRAGMENTMATERIALIVSGIXPROC) (GLenum face, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLLIGHTENVISGIXPROC) (GLenum pname, GLint param);
-#endif
-
-#ifndef GL_IBM_rasterpos_clip
-#define GL_IBM_rasterpos_clip 1
-#endif
-
-#ifndef GL_HP_texture_lighting
-#define GL_HP_texture_lighting 1
-#endif
-
-#ifndef GL_EXT_draw_range_elements
-#define GL_EXT_draw_range_elements 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDrawRangeElementsEXT (GLenum, GLuint, GLuint, GLsizei, GLenum, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTSEXTPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices);
-#endif
-
-#ifndef GL_WIN_phong_shading
-#define GL_WIN_phong_shading 1
-#endif
-
-#ifndef GL_WIN_specular_fog
-#define GL_WIN_specular_fog 1
-#endif
-
-#ifndef GL_EXT_light_texture
-#define GL_EXT_light_texture 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glApplyTextureEXT (GLenum);
-  GLAPI void APIENTRY glTextureLightEXT (GLenum);
-  GLAPI void APIENTRY glTextureMaterialEXT (GLenum, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLAPPLYTEXTUREEXTPROC) (GLenum mode);
-  typedef void (APIENTRYP PFNGLTEXTURELIGHTEXTPROC) (GLenum pname);
-  typedef void (APIENTRYP PFNGLTEXTUREMATERIALEXTPROC) (GLenum face, GLenum mode);
-#endif
-
-#ifndef GL_SGIX_blend_alpha_minmax
-#define GL_SGIX_blend_alpha_minmax 1
-#endif
-
-#ifndef GL_EXT_bgra
-#define GL_EXT_bgra 1
-#endif
-
-#ifndef GL_SGIX_async
-#define GL_SGIX_async 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glAsyncMarkerSGIX (GLuint);
-  GLAPI GLint APIENTRY glFinishAsyncSGIX (GLuint *);
-  GLAPI GLint APIENTRY glPollAsyncSGIX (GLuint *);
-  GLAPI GLuint APIENTRY glGenAsyncMarkersSGIX (GLsizei);
-  GLAPI void APIENTRY glDeleteAsyncMarkersSGIX (GLuint, GLsizei);
-  GLAPI GLboolean APIENTRY glIsAsyncMarkerSGIX (GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLASYNCMARKERSGIXPROC) (GLuint marker);
-  typedef GLint (APIENTRYP PFNGLFINISHASYNCSGIXPROC) (GLuint *markerp);
-  typedef GLint (APIENTRYP PFNGLPOLLASYNCSGIXPROC) (GLuint *markerp);
-  typedef GLuint (APIENTRYP PFNGLGENASYNCMARKERSSGIXPROC) (GLsizei range);
-  typedef void (APIENTRYP PFNGLDELETEASYNCMARKERSSGIXPROC) (GLuint marker, GLsizei range);
-  typedef GLboolean (APIENTRYP PFNGLISASYNCMARKERSGIXPROC) (GLuint marker);
-#endif
-
-#ifndef GL_SGIX_async_pixel
-#define GL_SGIX_async_pixel 1
-#endif
-
-#ifndef GL_SGIX_async_histogram
-#define GL_SGIX_async_histogram 1
-#endif
-
-#ifndef GL_INTEL_parallel_arrays
-#define GL_INTEL_parallel_arrays 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glVertexPointervINTEL (GLint, GLenum, const GLvoid* *);
-  GLAPI void APIENTRY glNormalPointervINTEL (GLenum, const GLvoid* *);
-  GLAPI void APIENTRY glColorPointervINTEL (GLint, GLenum, const GLvoid* *);
-  GLAPI void APIENTRY glTexCoordPointervINTEL (GLint, GLenum, const GLvoid* *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLVERTEXPOINTERVINTELPROC) (GLint size, GLenum type, const GLvoid* *pointer);
-  typedef void (APIENTRYP PFNGLNORMALPOINTERVINTELPROC) (GLenum type, const GLvoid* *pointer);
-  typedef void (APIENTRYP PFNGLCOLORPOINTERVINTELPROC) (GLint size, GLenum type, const GLvoid* *pointer);
-  typedef void (APIENTRYP PFNGLTEXCOORDPOINTERVINTELPROC) (GLint size, GLenum type, const GLvoid* *pointer);
-#endif
-
-#ifndef GL_HP_occlusion_test
-#define GL_HP_occlusion_test 1
-#endif
-
-#ifndef GL_EXT_pixel_transform
-#define GL_EXT_pixel_transform 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPixelTransformParameteriEXT (GLenum, GLenum, GLint);
-  GLAPI void APIENTRY glPixelTransformParameterfEXT (GLenum, GLenum, GLfloat);
-  GLAPI void APIENTRY glPixelTransformParameterivEXT (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glPixelTransformParameterfvEXT (GLenum, GLenum, const GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERIEXTPROC) (GLenum target, GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERFEXTPROC) (GLenum target, GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERIVEXTPROC) (GLenum target, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERFVEXTPROC) (GLenum target, GLenum pname, const GLfloat *params);
-#endif
-
-#ifndef GL_EXT_pixel_transform_color_table
-#define GL_EXT_pixel_transform_color_table 1
-#endif
-
-#ifndef GL_EXT_shared_texture_palette
-#define GL_EXT_shared_texture_palette 1
-#endif
-
-#ifndef GL_EXT_separate_specular_color
-#define GL_EXT_separate_specular_color 1
-#endif
-
-#ifndef GL_EXT_secondary_color
-#define GL_EXT_secondary_color 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glSecondaryColor3bEXT (GLbyte, GLbyte, GLbyte);
-  GLAPI void APIENTRY glSecondaryColor3bvEXT (const GLbyte *);
-  GLAPI void APIENTRY glSecondaryColor3dEXT (GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glSecondaryColor3dvEXT (const GLdouble *);
-  GLAPI void APIENTRY glSecondaryColor3fEXT (GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glSecondaryColor3fvEXT (const GLfloat *);
-  GLAPI void APIENTRY glSecondaryColor3iEXT (GLint, GLint, GLint);
-  GLAPI void APIENTRY glSecondaryColor3ivEXT (const GLint *);
-  GLAPI void APIENTRY glSecondaryColor3sEXT (GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glSecondaryColor3svEXT (const GLshort *);
-  GLAPI void APIENTRY glSecondaryColor3ubEXT (GLubyte, GLubyte, GLubyte);
-  GLAPI void APIENTRY glSecondaryColor3ubvEXT (const GLubyte *);
-  GLAPI void APIENTRY glSecondaryColor3uiEXT (GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glSecondaryColor3uivEXT (const GLuint *);
-  GLAPI void APIENTRY glSecondaryColor3usEXT (GLushort, GLushort, GLushort);
-  GLAPI void APIENTRY glSecondaryColor3usvEXT (const GLushort *);
-  GLAPI void APIENTRY glSecondaryColorPointerEXT (GLint, GLenum, GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BEXTPROC) (GLbyte red, GLbyte green, GLbyte blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BVEXTPROC) (const GLbyte *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DEXTPROC) (GLdouble red, GLdouble green, GLdouble blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DVEXTPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FEXTPROC) (GLfloat red, GLfloat green, GLfloat blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FVEXTPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IEXTPROC) (GLint red, GLint green, GLint blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IVEXTPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SEXTPROC) (GLshort red, GLshort green, GLshort blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SVEXTPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBEXTPROC) (GLubyte red, GLubyte green, GLubyte blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBVEXTPROC) (const GLubyte *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIEXTPROC) (GLuint red, GLuint green, GLuint blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIVEXTPROC) (const GLuint *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USEXTPROC) (GLushort red, GLushort green, GLushort blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USVEXTPROC) (const GLushort *v);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLORPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
-#endif
-
-#ifndef GL_EXT_texture_perturb_normal
-#define GL_EXT_texture_perturb_normal 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTextureNormalEXT (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTEXTURENORMALEXTPROC) (GLenum mode);
-#endif
-
-#ifndef GL_EXT_multi_draw_arrays
-#define GL_EXT_multi_draw_arrays 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glMultiDrawArraysEXT (GLenum, GLint *, GLsizei *, GLsizei);
-  GLAPI void APIENTRY glMultiDrawElementsEXT (GLenum, const GLsizei *, GLenum, const GLvoid* *, GLsizei);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLMULTIDRAWARRAYSEXTPROC) (GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
-  typedef void (APIENTRYP PFNGLMULTIDRAWELEMENTSEXTPROC) (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount);
-#endif
-
-#ifndef GL_EXT_fog_coord
-#define GL_EXT_fog_coord 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glFogCoordfEXT (GLfloat);
-  GLAPI void APIENTRY glFogCoordfvEXT (const GLfloat *);
-  GLAPI void APIENTRY glFogCoorddEXT (GLdouble);
-  GLAPI void APIENTRY glFogCoorddvEXT (const GLdouble *);
-  GLAPI void APIENTRY glFogCoordPointerEXT (GLenum, GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLFOGCOORDFEXTPROC) (GLfloat coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDFVEXTPROC) (const GLfloat *coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDDEXTPROC) (GLdouble coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDDVEXTPROC) (const GLdouble *coord);
-  typedef void (APIENTRYP PFNGLFOGCOORDPOINTEREXTPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
-#endif
-
-#ifndef GL_REND_screen_coordinates
-#define GL_REND_screen_coordinates 1
-#endif
-
-#ifndef GL_EXT_coordinate_frame
-#define GL_EXT_coordinate_frame 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTangent3bEXT (GLbyte, GLbyte, GLbyte);
-  GLAPI void APIENTRY glTangent3bvEXT (const GLbyte *);
-  GLAPI void APIENTRY glTangent3dEXT (GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glTangent3dvEXT (const GLdouble *);
-  GLAPI void APIENTRY glTangent3fEXT (GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTangent3fvEXT (const GLfloat *);
-  GLAPI void APIENTRY glTangent3iEXT (GLint, GLint, GLint);
-  GLAPI void APIENTRY glTangent3ivEXT (const GLint *);
-  GLAPI void APIENTRY glTangent3sEXT (GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glTangent3svEXT (const GLshort *);
-  GLAPI void APIENTRY glBinormal3bEXT (GLbyte, GLbyte, GLbyte);
-  GLAPI void APIENTRY glBinormal3bvEXT (const GLbyte *);
-  GLAPI void APIENTRY glBinormal3dEXT (GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glBinormal3dvEXT (const GLdouble *);
-  GLAPI void APIENTRY glBinormal3fEXT (GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glBinormal3fvEXT (const GLfloat *);
-  GLAPI void APIENTRY glBinormal3iEXT (GLint, GLint, GLint);
-  GLAPI void APIENTRY glBinormal3ivEXT (const GLint *);
-  GLAPI void APIENTRY glBinormal3sEXT (GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glBinormal3svEXT (const GLshort *);
-  GLAPI void APIENTRY glTangentPointerEXT (GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glBinormalPointerEXT (GLenum, GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTANGENT3BEXTPROC) (GLbyte tx, GLbyte ty, GLbyte tz);
-  typedef void (APIENTRYP PFNGLTANGENT3BVEXTPROC) (const GLbyte *v);
-  typedef void (APIENTRYP PFNGLTANGENT3DEXTPROC) (GLdouble tx, GLdouble ty, GLdouble tz);
-  typedef void (APIENTRYP PFNGLTANGENT3DVEXTPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLTANGENT3FEXTPROC) (GLfloat tx, GLfloat ty, GLfloat tz);
-  typedef void (APIENTRYP PFNGLTANGENT3FVEXTPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTANGENT3IEXTPROC) (GLint tx, GLint ty, GLint tz);
-  typedef void (APIENTRYP PFNGLTANGENT3IVEXTPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLTANGENT3SEXTPROC) (GLshort tx, GLshort ty, GLshort tz);
-  typedef void (APIENTRYP PFNGLTANGENT3SVEXTPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLBINORMAL3BEXTPROC) (GLbyte bx, GLbyte by, GLbyte bz);
-  typedef void (APIENTRYP PFNGLBINORMAL3BVEXTPROC) (const GLbyte *v);
-  typedef void (APIENTRYP PFNGLBINORMAL3DEXTPROC) (GLdouble bx, GLdouble by, GLdouble bz);
-  typedef void (APIENTRYP PFNGLBINORMAL3DVEXTPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLBINORMAL3FEXTPROC) (GLfloat bx, GLfloat by, GLfloat bz);
-  typedef void (APIENTRYP PFNGLBINORMAL3FVEXTPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLBINORMAL3IEXTPROC) (GLint bx, GLint by, GLint bz);
-  typedef void (APIENTRYP PFNGLBINORMAL3IVEXTPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLBINORMAL3SEXTPROC) (GLshort bx, GLshort by, GLshort bz);
-  typedef void (APIENTRYP PFNGLBINORMAL3SVEXTPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLTANGENTPOINTEREXTPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLBINORMALPOINTEREXTPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
-#endif
-
-#ifndef GL_EXT_texture_env_combine
-#define GL_EXT_texture_env_combine 1
-#endif
-
-#ifndef GL_APPLE_specular_vector
-#define GL_APPLE_specular_vector 1
-#endif
-
-#ifndef GL_APPLE_transform_hint
-#define GL_APPLE_transform_hint 1
-#endif
-
-#ifndef GL_SGIX_fog_scale
-#define GL_SGIX_fog_scale 1
-#endif
-
-#ifndef GL_SUNX_constant_data
-#define GL_SUNX_constant_data 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glFinishTextureSUNX (void);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLFINISHTEXTURESUNXPROC) (void);
-#endif
-
-#ifndef GL_SUN_global_alpha
-#define GL_SUN_global_alpha 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGlobalAlphaFactorbSUN (GLbyte);
-  GLAPI void APIENTRY glGlobalAlphaFactorsSUN (GLshort);
-  GLAPI void APIENTRY glGlobalAlphaFactoriSUN (GLint);
-  GLAPI void APIENTRY glGlobalAlphaFactorfSUN (GLfloat);
-  GLAPI void APIENTRY glGlobalAlphaFactordSUN (GLdouble);
-  GLAPI void APIENTRY glGlobalAlphaFactorubSUN (GLubyte);
-  GLAPI void APIENTRY glGlobalAlphaFactorusSUN (GLushort);
-  GLAPI void APIENTRY glGlobalAlphaFactoruiSUN (GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORBSUNPROC) (GLbyte factor);
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORSSUNPROC) (GLshort factor);
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORISUNPROC) (GLint factor);
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORFSUNPROC) (GLfloat factor);
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORDSUNPROC) (GLdouble factor);
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORUBSUNPROC) (GLubyte factor);
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORUSSUNPROC) (GLushort factor);
-  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORUISUNPROC) (GLuint factor);
-#endif
-
-#ifndef GL_SUN_triangle_list
-#define GL_SUN_triangle_list 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glReplacementCodeuiSUN (GLuint);
-  GLAPI void APIENTRY glReplacementCodeusSUN (GLushort);
-  GLAPI void APIENTRY glReplacementCodeubSUN (GLubyte);
-  GLAPI void APIENTRY glReplacementCodeuivSUN (const GLuint *);
-  GLAPI void APIENTRY glReplacementCodeusvSUN (const GLushort *);
-  GLAPI void APIENTRY glReplacementCodeubvSUN (const GLubyte *);
-  GLAPI void APIENTRY glReplacementCodePointerSUN (GLenum, GLsizei, const GLvoid* *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUISUNPROC) (GLuint code);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUSSUNPROC) (GLushort code);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUBSUNPROC) (GLubyte code);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUIVSUNPROC) (const GLuint *code);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUSVSUNPROC) (const GLushort *code);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUBVSUNPROC) (const GLubyte *code);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEPOINTERSUNPROC) (GLenum type, GLsizei stride, const GLvoid* *pointer);
-#endif
-
-#ifndef GL_SUN_vertex
-#define GL_SUN_vertex 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glColor4ubVertex2fSUN (GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat);
-  GLAPI void APIENTRY glColor4ubVertex2fvSUN (const GLubyte *, const GLfloat *);
-  GLAPI void APIENTRY glColor4ubVertex3fSUN (GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glColor4ubVertex3fvSUN (const GLubyte *, const GLfloat *);
-  GLAPI void APIENTRY glColor3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glColor3fVertex3fvSUN (const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glColor4fNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glColor4fNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glTexCoord2fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTexCoord2fVertex3fvSUN (const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glTexCoord4fVertex4fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTexCoord4fVertex4fvSUN (const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glTexCoord2fColor4ubVertex3fSUN (GLfloat, GLfloat, GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTexCoord2fColor4ubVertex3fvSUN (const GLfloat *, const GLubyte *, const GLfloat *);
-  GLAPI void APIENTRY glTexCoord2fColor3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTexCoord2fColor3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glTexCoord2fNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTexCoord2fNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glTexCoord2fColor4fNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTexCoord2fColor4fNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glTexCoord4fColor4fNormal3fVertex4fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glTexCoord4fColor4fNormal3fVertex4fvSUN (const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiVertex3fvSUN (const GLuint *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiColor4ubVertex3fSUN (GLuint, GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiColor4ubVertex3fvSUN (const GLuint *, const GLubyte *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiColor3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiColor3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiColor4fNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiColor4fNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *, const GLfloat *);
-  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX2FSUNPROC) (GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX2FVSUNPROC) (const GLubyte *c, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX3FSUNPROC) (GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX3FVSUNPROC) (const GLubyte *c, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLCOLOR3FVERTEX3FSUNPROC) (GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLCOLOR3FVERTEX3FVSUNPROC) (const GLfloat *c, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLNORMAL3FVERTEX3FSUNPROC) (GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLCOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLCOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *c, const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD4FVERTEX4FSUNPROC) (GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLTEXCOORD4FVERTEX4FVSUNPROC) (const GLfloat *tc, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4UBVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4UBVERTEX3FVSUNPROC) (const GLfloat *tc, const GLubyte *c, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR3FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR3FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *c, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FNORMAL3FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FSUNPROC) (GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FVSUNPROC) (const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUIVERTEX3FSUNPROC) (GLuint rc, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUIVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FSUNPROC) (GLuint rc, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FVSUNPROC) (const GLuint *rc, const GLubyte *c, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FSUNPROC) (GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *c, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FSUNPROC) (GLuint rc, GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *tc, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *tc, const GLfloat *n, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
-#endif
-
-#ifndef GL_EXT_blend_func_separate
-#define GL_EXT_blend_func_separate 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendFuncSeparateEXT (GLenum, GLenum, GLenum, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDFUNCSEPARATEEXTPROC) (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
-#endif
-
-#ifndef GL_INGR_blend_func_separate
-#define GL_INGR_blend_func_separate 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendFuncSeparateINGR (GLenum, GLenum, GLenum, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDFUNCSEPARATEINGRPROC) (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
-#endif
-
-#ifndef GL_INGR_color_clamp
-#define GL_INGR_color_clamp 1
-#endif
-
-#ifndef GL_INGR_interlace_read
-#define GL_INGR_interlace_read 1
-#endif
-
-#ifndef GL_EXT_stencil_wrap
-#define GL_EXT_stencil_wrap 1
-#endif
-
-#ifndef GL_EXT_422_pixels
-#define GL_EXT_422_pixels 1
-#endif
-
-#ifndef GL_NV_texgen_reflection
-#define GL_NV_texgen_reflection 1
-#endif
-
-#ifndef GL_SUN_convolution_border_modes
-#define GL_SUN_convolution_border_modes 1
-#endif
-
-#ifndef GL_EXT_texture_env_add
-#define GL_EXT_texture_env_add 1
-#endif
-
-#ifndef GL_EXT_texture_lod_bias
-#define GL_EXT_texture_lod_bias 1
-#endif
-
-#ifndef GL_EXT_texture_filter_anisotropic
-#define GL_EXT_texture_filter_anisotropic 1
-#endif
-
-#ifndef GL_EXT_vertex_weighting
-#define GL_EXT_vertex_weighting 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glVertexWeightfEXT (GLfloat);
-  GLAPI void APIENTRY glVertexWeightfvEXT (const GLfloat *);
-  GLAPI void APIENTRY glVertexWeightPointerEXT (GLsizei, GLenum, GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLVERTEXWEIGHTFEXTPROC) (GLfloat weight);
-  typedef void (APIENTRYP PFNGLVERTEXWEIGHTFVEXTPROC) (const GLfloat *weight);
-  typedef void (APIENTRYP PFNGLVERTEXWEIGHTPOINTEREXTPROC) (GLsizei size, GLenum type, GLsizei stride, const GLvoid *pointer);
-#endif
-
-#ifndef GL_NV_light_max_exponent
-#define GL_NV_light_max_exponent 1
-#endif
-
-#ifndef GL_NV_vertex_array_range
-#define GL_NV_vertex_array_range 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glFlushVertexArrayRangeNV (void);
-  GLAPI void APIENTRY glVertexArrayRangeNV (GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLFLUSHVERTEXARRAYRANGENVPROC) (void);
-  typedef void (APIENTRYP PFNGLVERTEXARRAYRANGENVPROC) (GLsizei length, const GLvoid *pointer);
-#endif
-
-#ifndef GL_NV_register_combiners
-#define GL_NV_register_combiners 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glCombinerParameterfvNV (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glCombinerParameterfNV (GLenum, GLfloat);
-  GLAPI void APIENTRY glCombinerParameterivNV (GLenum, const GLint *);
-  GLAPI void APIENTRY glCombinerParameteriNV (GLenum, GLint);
-  GLAPI void APIENTRY glCombinerInputNV (GLenum, GLenum, GLenum, GLenum, GLenum, GLenum);
-  GLAPI void APIENTRY glCombinerOutputNV (GLenum, GLenum, GLenum, GLenum, GLenum, GLenum, GLenum, GLboolean, GLboolean, GLboolean);
-  GLAPI void APIENTRY glFinalCombinerInputNV (GLenum, GLenum, GLenum, GLenum);
-  GLAPI void APIENTRY glGetCombinerInputParameterfvNV (GLenum, GLenum, GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetCombinerInputParameterivNV (GLenum, GLenum, GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetCombinerOutputParameterfvNV (GLenum, GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetCombinerOutputParameterivNV (GLenum, GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetFinalCombinerInputParameterfvNV (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetFinalCombinerInputParameterivNV (GLenum, GLenum, GLint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERFVNVPROC) (GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERFNVPROC) (GLenum pname, GLfloat param);
-  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERIVNVPROC) (GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERINVPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLCOMBINERINPUTNVPROC) (GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
-  typedef void (APIENTRYP PFNGLCOMBINEROUTPUTNVPROC) (GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum);
-  typedef void (APIENTRYP PFNGLFINALCOMBINERINPUTNVPROC) (GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
-  typedef void (APIENTRYP PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC) (GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC) (GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC) (GLenum stage, GLenum portion, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC) (GLenum stage, GLenum portion, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC) (GLenum variable, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC) (GLenum variable, GLenum pname, GLint *params);
-#endif
-
-#ifndef GL_NV_fog_distance
-#define GL_NV_fog_distance 1
-#endif
-
-#ifndef GL_NV_texgen_emboss
-#define GL_NV_texgen_emboss 1
-#endif
-
-#ifndef GL_NV_blend_square
-#define GL_NV_blend_square 1
-#endif
-
-#ifndef GL_NV_texture_env_combine4
-#define GL_NV_texture_env_combine4 1
-#endif
-
-#ifndef GL_MESA_resize_buffers
-#define GL_MESA_resize_buffers 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glResizeBuffersMESA (void);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLRESIZEBUFFERSMESAPROC) (void);
-#endif
-
-#ifndef GL_MESA_window_pos
-#define GL_MESA_window_pos 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glWindowPos2dMESA (GLdouble, GLdouble);
-  GLAPI void APIENTRY glWindowPos2dvMESA (const GLdouble *);
-  GLAPI void APIENTRY glWindowPos2fMESA (GLfloat, GLfloat);
-  GLAPI void APIENTRY glWindowPos2fvMESA (const GLfloat *);
-  GLAPI void APIENTRY glWindowPos2iMESA (GLint, GLint);
-  GLAPI void APIENTRY glWindowPos2ivMESA (const GLint *);
-  GLAPI void APIENTRY glWindowPos2sMESA (GLshort, GLshort);
-  GLAPI void APIENTRY glWindowPos2svMESA (const GLshort *);
-  GLAPI void APIENTRY glWindowPos3dMESA (GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glWindowPos3dvMESA (const GLdouble *);
-  GLAPI void APIENTRY glWindowPos3fMESA (GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glWindowPos3fvMESA (const GLfloat *);
-  GLAPI void APIENTRY glWindowPos3iMESA (GLint, GLint, GLint);
-  GLAPI void APIENTRY glWindowPos3ivMESA (const GLint *);
-  GLAPI void APIENTRY glWindowPos3sMESA (GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glWindowPos3svMESA (const GLshort *);
-  GLAPI void APIENTRY glWindowPos4dMESA (GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glWindowPos4dvMESA (const GLdouble *);
-  GLAPI void APIENTRY glWindowPos4fMESA (GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glWindowPos4fvMESA (const GLfloat *);
-  GLAPI void APIENTRY glWindowPos4iMESA (GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glWindowPos4ivMESA (const GLint *);
-  GLAPI void APIENTRY glWindowPos4sMESA (GLshort, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glWindowPos4svMESA (const GLshort *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLWINDOWPOS2DMESAPROC) (GLdouble x, GLdouble y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2DVMESAPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2FMESAPROC) (GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2FVMESAPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2IMESAPROC) (GLint x, GLint y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2IVMESAPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2SMESAPROC) (GLshort x, GLshort y);
-  typedef void (APIENTRYP PFNGLWINDOWPOS2SVMESAPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3DMESAPROC) (GLdouble x, GLdouble y, GLdouble z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3DVMESAPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3FMESAPROC) (GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3FVMESAPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3IMESAPROC) (GLint x, GLint y, GLint z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3IVMESAPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3SMESAPROC) (GLshort x, GLshort y, GLshort z);
-  typedef void (APIENTRYP PFNGLWINDOWPOS3SVMESAPROC) (const GLshort *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4DMESAPROC) (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4DVMESAPROC) (const GLdouble *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4FMESAPROC) (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4FVMESAPROC) (const GLfloat *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4IMESAPROC) (GLint x, GLint y, GLint z, GLint w);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4IVMESAPROC) (const GLint *v);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4SMESAPROC) (GLshort x, GLshort y, GLshort z, GLshort w);
-  typedef void (APIENTRYP PFNGLWINDOWPOS4SVMESAPROC) (const GLshort *v);
-#endif
-
-#ifndef GL_EXT_texture_compression_s3tc
-#define GL_EXT_texture_compression_s3tc 1
-#endif
-
-#ifndef GL_IBM_cull_vertex
-#define GL_IBM_cull_vertex 1
-#endif
-
-#ifndef GL_IBM_multimode_draw_arrays
-#define GL_IBM_multimode_draw_arrays 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glMultiModeDrawArraysIBM (const GLenum *, const GLint *, const GLsizei *, GLsizei, GLint);
-  GLAPI void APIENTRY glMultiModeDrawElementsIBM (const GLenum *, const GLsizei *, GLenum, const GLvoid* const *, GLsizei, GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLMULTIMODEDRAWARRAYSIBMPROC) (const GLenum *mode, const GLint *first, const GLsizei *count, GLsizei primcount, GLint modestride);
-  typedef void (APIENTRYP PFNGLMULTIMODEDRAWELEMENTSIBMPROC) (const GLenum *mode, const GLsizei *count, GLenum type, const GLvoid* const *indices, GLsizei primcount, GLint modestride);
-#endif
-
-#ifndef GL_IBM_vertex_array_lists
-#define GL_IBM_vertex_array_lists 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glColorPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
-  GLAPI void APIENTRY glSecondaryColorPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
-  GLAPI void APIENTRY glEdgeFlagPointerListIBM (GLint, const GLboolean* *, GLint);
-  GLAPI void APIENTRY glFogCoordPointerListIBM (GLenum, GLint, const GLvoid* *, GLint);
-  GLAPI void APIENTRY glIndexPointerListIBM (GLenum, GLint, const GLvoid* *, GLint);
-  GLAPI void APIENTRY glNormalPointerListIBM (GLenum, GLint, const GLvoid* *, GLint);
-  GLAPI void APIENTRY glTexCoordPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
-  GLAPI void APIENTRY glVertexPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOLORPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLORPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
-  typedef void (APIENTRYP PFNGLEDGEFLAGPOINTERLISTIBMPROC) (GLint stride, const GLboolean* *pointer, GLint ptrstride);
-  typedef void (APIENTRYP PFNGLFOGCOORDPOINTERLISTIBMPROC) (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
-  typedef void (APIENTRYP PFNGLINDEXPOINTERLISTIBMPROC) (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
-  typedef void (APIENTRYP PFNGLNORMALPOINTERLISTIBMPROC) (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
-  typedef void (APIENTRYP PFNGLTEXCOORDPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
-  typedef void (APIENTRYP PFNGLVERTEXPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
-#endif
-
-#ifndef GL_SGIX_subsample
-#define GL_SGIX_subsample 1
-#endif
-
-#ifndef GL_SGIX_ycrcba
-#define GL_SGIX_ycrcba 1
-#endif
-
-#ifndef GL_SGIX_ycrcb_subsample
-#define GL_SGIX_ycrcb_subsample 1
-#endif
-
-#ifndef GL_SGIX_depth_pass_instrument
-#define GL_SGIX_depth_pass_instrument 1
-#endif
-
-#ifndef GL_3DFX_texture_compression_FXT1
-#define GL_3DFX_texture_compression_FXT1 1
-#endif
-
-#ifndef GL_3DFX_multisample
-#define GL_3DFX_multisample 1
-#endif
-
-#ifndef GL_3DFX_tbuffer
-#define GL_3DFX_tbuffer 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTbufferMask3DFX (GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTBUFFERMASK3DFXPROC) (GLuint mask);
-#endif
-
-#ifndef GL_EXT_multisample
-#define GL_EXT_multisample 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glSampleMaskEXT (GLclampf, GLboolean);
-  GLAPI void APIENTRY glSamplePatternEXT (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSAMPLEMASKEXTPROC) (GLclampf value, GLboolean invert);
-  typedef void (APIENTRYP PFNGLSAMPLEPATTERNEXTPROC) (GLenum pattern);
-#endif
-
-#ifndef GL_SGIX_vertex_preclip
-#define GL_SGIX_vertex_preclip 1
-#endif
-
-#ifndef GL_SGIX_convolution_accuracy
-#define GL_SGIX_convolution_accuracy 1
-#endif
-
-#ifndef GL_SGIX_resample
-#define GL_SGIX_resample 1
-#endif
-
-#ifndef GL_SGIS_point_line_texgen
-#define GL_SGIS_point_line_texgen 1
-#endif
-
-#ifndef GL_SGIS_texture_color_mask
-#define GL_SGIS_texture_color_mask 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTextureColorMaskSGIS (GLboolean, GLboolean, GLboolean, GLboolean);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTEXTURECOLORMASKSGISPROC) (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
-#endif
-
-#ifndef GL_SGIX_igloo_interface
-#define GL_SGIX_igloo_interface 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glIglooInterfaceSGIX (GLenum, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLIGLOOINTERFACESGIXPROC) (GLenum pname, const GLvoid *params);
-#endif
-
-#ifndef GL_EXT_texture_env_dot3
-#define GL_EXT_texture_env_dot3 1
-#endif
-
-#ifndef GL_ATI_texture_mirror_once
-#define GL_ATI_texture_mirror_once 1
-#endif
-
-#ifndef GL_NV_fence
-#define GL_NV_fence 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDeleteFencesNV (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenFencesNV (GLsizei, GLuint *);
-  GLAPI GLboolean APIENTRY glIsFenceNV (GLuint);
-  GLAPI GLboolean APIENTRY glTestFenceNV (GLuint);
-  GLAPI void APIENTRY glGetFenceivNV (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glFinishFenceNV (GLuint);
-  GLAPI void APIENTRY glSetFenceNV (GLuint, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDELETEFENCESNVPROC) (GLsizei n, const GLuint *fences);
-  typedef void (APIENTRYP PFNGLGENFENCESNVPROC) (GLsizei n, GLuint *fences);
-  typedef GLboolean (APIENTRYP PFNGLISFENCENVPROC) (GLuint fence);
-  typedef GLboolean (APIENTRYP PFNGLTESTFENCENVPROC) (GLuint fence);
-  typedef void (APIENTRYP PFNGLGETFENCEIVNVPROC) (GLuint fence, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLFINISHFENCENVPROC) (GLuint fence);
-  typedef void (APIENTRYP PFNGLSETFENCENVPROC) (GLuint fence, GLenum condition);
-#endif
-
-#ifndef GL_NV_evaluators
-#define GL_NV_evaluators 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glMapControlPointsNV (GLenum, GLuint, GLenum, GLsizei, GLsizei, GLint, GLint, GLboolean, const GLvoid *);
-  GLAPI void APIENTRY glMapParameterivNV (GLenum, GLenum, const GLint *);
-  GLAPI void APIENTRY glMapParameterfvNV (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glGetMapControlPointsNV (GLenum, GLuint, GLenum, GLsizei, GLsizei, GLboolean, GLvoid *);
-  GLAPI void APIENTRY glGetMapParameterivNV (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGetMapParameterfvNV (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetMapAttribParameterivNV (GLenum, GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetMapAttribParameterfvNV (GLenum, GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glEvalMapsNV (GLenum, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLMAPCONTROLPOINTSNVPROC) (GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLint uorder, GLint vorder, GLboolean packed, const GLvoid *points);
-  typedef void (APIENTRYP PFNGLMAPPARAMETERIVNVPROC) (GLenum target, GLenum pname, const GLint *params);
-  typedef void (APIENTRYP PFNGLMAPPARAMETERFVNVPROC) (GLenum target, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETMAPCONTROLPOINTSNVPROC) (GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLboolean packed, GLvoid *points);
-  typedef void (APIENTRYP PFNGLGETMAPPARAMETERIVNVPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETMAPPARAMETERFVNVPROC) (GLenum target, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETMAPATTRIBPARAMETERIVNVPROC) (GLenum target, GLuint index, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETMAPATTRIBPARAMETERFVNVPROC) (GLenum target, GLuint index, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLEVALMAPSNVPROC) (GLenum target, GLenum mode);
-#endif
-
-#ifndef GL_NV_packed_depth_stencil
-#define GL_NV_packed_depth_stencil 1
-#endif
-
-#ifndef GL_NV_register_combiners2
-#define GL_NV_register_combiners2 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glCombinerStageParameterfvNV (GLenum, GLenum, const GLfloat *);
-  GLAPI void APIENTRY glGetCombinerStageParameterfvNV (GLenum, GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLCOMBINERSTAGEPARAMETERFVNVPROC) (GLenum stage, GLenum pname, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETCOMBINERSTAGEPARAMETERFVNVPROC) (GLenum stage, GLenum pname, GLfloat *params);
-#endif
-
-#ifndef GL_NV_texture_compression_vtc
-#define GL_NV_texture_compression_vtc 1
-#endif
-
-#ifndef GL_NV_texture_rectangle
-#define GL_NV_texture_rectangle 1
-#endif
-
-#ifndef GL_NV_texture_shader
-#define GL_NV_texture_shader 1
-#endif
-
-#ifndef GL_NV_texture_shader2
-#define GL_NV_texture_shader2 1
-#endif
-
-#ifndef GL_NV_vertex_array_range2
-#define GL_NV_vertex_array_range2 1
-#endif
-
-#ifndef GL_NV_vertex_program
-#define GL_NV_vertex_program 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI GLboolean APIENTRY glAreProgramsResidentNV (GLsizei, const GLuint *, GLboolean *);
-  GLAPI void APIENTRY glBindProgramNV (GLenum, GLuint);
-  GLAPI void APIENTRY glDeleteProgramsNV (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glExecuteProgramNV (GLenum, GLuint, const GLfloat *);
-  GLAPI void APIENTRY glGenProgramsNV (GLsizei, GLuint *);
-  GLAPI void APIENTRY glGetProgramParameterdvNV (GLenum, GLuint, GLenum, GLdouble *);
-  GLAPI void APIENTRY glGetProgramParameterfvNV (GLenum, GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetProgramivNV (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetProgramStringNV (GLuint, GLenum, GLubyte *);
-  GLAPI void APIENTRY glGetTrackMatrixivNV (GLenum, GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetVertexAttribdvNV (GLuint, GLenum, GLdouble *);
-  GLAPI void APIENTRY glGetVertexAttribfvNV (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetVertexAttribivNV (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetVertexAttribPointervNV (GLuint, GLenum, GLvoid* *);
-  GLAPI GLboolean APIENTRY glIsProgramNV (GLuint);
-  GLAPI void APIENTRY glLoadProgramNV (GLenum, GLuint, GLsizei, const GLubyte *);
-  GLAPI void APIENTRY glProgramParameter4dNV (GLenum, GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glProgramParameter4dvNV (GLenum, GLuint, const GLdouble *);
-  GLAPI void APIENTRY glProgramParameter4fNV (GLenum, GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glProgramParameter4fvNV (GLenum, GLuint, const GLfloat *);
-  GLAPI void APIENTRY glProgramParameters4dvNV (GLenum, GLuint, GLuint, const GLdouble *);
-  GLAPI void APIENTRY glProgramParameters4fvNV (GLenum, GLuint, GLuint, const GLfloat *);
-  GLAPI void APIENTRY glRequestResidentProgramsNV (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glTrackMatrixNV (GLenum, GLuint, GLenum, GLenum);
-  GLAPI void APIENTRY glVertexAttribPointerNV (GLuint, GLint, GLenum, GLsizei, const GLvoid *);
-  GLAPI void APIENTRY glVertexAttrib1dNV (GLuint, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib1dvNV (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib1fNV (GLuint, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib1fvNV (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib1sNV (GLuint, GLshort);
-  GLAPI void APIENTRY glVertexAttrib1svNV (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib2dNV (GLuint, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib2dvNV (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib2fNV (GLuint, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib2fvNV (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib2sNV (GLuint, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib2svNV (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib3dNV (GLuint, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib3dvNV (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib3fNV (GLuint, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib3fvNV (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib3sNV (GLuint, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib3svNV (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4dNV (GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexAttrib4dvNV (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttrib4fNV (GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexAttrib4fvNV (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttrib4sNV (GLuint, GLshort, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexAttrib4svNV (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVertexAttrib4ubNV (GLuint, GLubyte, GLubyte, GLubyte, GLubyte);
-  GLAPI void APIENTRY glVertexAttrib4ubvNV (GLuint, const GLubyte *);
-  GLAPI void APIENTRY glVertexAttribs1dvNV (GLuint, GLsizei, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttribs1fvNV (GLuint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttribs1svNV (GLuint, GLsizei, const GLshort *);
-  GLAPI void APIENTRY glVertexAttribs2dvNV (GLuint, GLsizei, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttribs2fvNV (GLuint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttribs2svNV (GLuint, GLsizei, const GLshort *);
-  GLAPI void APIENTRY glVertexAttribs3dvNV (GLuint, GLsizei, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttribs3fvNV (GLuint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttribs3svNV (GLuint, GLsizei, const GLshort *);
-  GLAPI void APIENTRY glVertexAttribs4dvNV (GLuint, GLsizei, const GLdouble *);
-  GLAPI void APIENTRY glVertexAttribs4fvNV (GLuint, GLsizei, const GLfloat *);
-  GLAPI void APIENTRY glVertexAttribs4svNV (GLuint, GLsizei, const GLshort *);
-  GLAPI void APIENTRY glVertexAttribs4ubvNV (GLuint, GLsizei, const GLubyte *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef GLboolean (APIENTRYP PFNGLAREPROGRAMSRESIDENTNVPROC) (GLsizei n, const GLuint *programs, GLboolean *residences);
-  typedef void (APIENTRYP PFNGLBINDPROGRAMNVPROC) (GLenum target, GLuint id);
-  typedef void (APIENTRYP PFNGLDELETEPROGRAMSNVPROC) (GLsizei n, const GLuint *programs);
-  typedef void (APIENTRYP PFNGLEXECUTEPROGRAMNVPROC) (GLenum target, GLuint id, const GLfloat *params);
-  typedef void (APIENTRYP PFNGLGENPROGRAMSNVPROC) (GLsizei n, GLuint *programs);
-  typedef void (APIENTRYP PFNGLGETPROGRAMPARAMETERDVNVPROC) (GLenum target, GLuint index, GLenum pname, GLdouble *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMPARAMETERFVNVPROC) (GLenum target, GLuint index, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMIVNVPROC) (GLuint id, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMSTRINGNVPROC) (GLuint id, GLenum pname, GLubyte *program);
-  typedef void (APIENTRYP PFNGLGETTRACKMATRIXIVNVPROC) (GLenum target, GLuint address, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBDVNVPROC) (GLuint index, GLenum pname, GLdouble *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBFVNVPROC) (GLuint index, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBIVNVPROC) (GLuint index, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBPOINTERVNVPROC) (GLuint index, GLenum pname, GLvoid* *pointer);
-  typedef GLboolean (APIENTRYP PFNGLISPROGRAMNVPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLLOADPROGRAMNVPROC) (GLenum target, GLuint id, GLsizei len, const GLubyte *program);
-  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4DNVPROC) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4DVNVPROC) (GLenum target, GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4FNVPROC) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4FVNVPROC) (GLenum target, GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLPROGRAMPARAMETERS4DVNVPROC) (GLenum target, GLuint index, GLuint count, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLPROGRAMPARAMETERS4FVNVPROC) (GLenum target, GLuint index, GLuint count, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLREQUESTRESIDENTPROGRAMSNVPROC) (GLsizei n, const GLuint *programs);
-  typedef void (APIENTRYP PFNGLTRACKMATRIXNVPROC) (GLenum target, GLuint address, GLenum matrix, GLenum transform);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBPOINTERNVPROC) (GLuint index, GLint fsize, GLenum type, GLsizei stride, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DNVPROC) (GLuint index, GLdouble x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DVNVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FNVPROC) (GLuint index, GLfloat x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FVNVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SNVPROC) (GLuint index, GLshort x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SVNVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DNVPROC) (GLuint index, GLdouble x, GLdouble y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DVNVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FNVPROC) (GLuint index, GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FVNVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SNVPROC) (GLuint index, GLshort x, GLshort y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SVNVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DNVPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DVNVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FNVPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FVNVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SNVPROC) (GLuint index, GLshort x, GLshort y, GLshort z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SVNVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DNVPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DVNVPROC) (GLuint index, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FNVPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FVNVPROC) (GLuint index, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SNVPROC) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SVNVPROC) (GLuint index, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBNVPROC) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBVNVPROC) (GLuint index, const GLubyte *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4UBVNVPROC) (GLuint index, GLsizei count, const GLubyte *v);
-#endif
-
-#ifndef GL_SGIX_texture_coordinate_clamp
-#define GL_SGIX_texture_coordinate_clamp 1
-#endif
-
-#ifndef GL_SGIX_scalebias_hint
-#define GL_SGIX_scalebias_hint 1
-#endif
-
-#ifndef GL_OML_interlace
-#define GL_OML_interlace 1
-#endif
-
-#ifndef GL_OML_subsample
-#define GL_OML_subsample 1
-#endif
-
-#ifndef GL_OML_resample
-#define GL_OML_resample 1
-#endif
-
-#ifndef GL_NV_copy_depth_to_color
-#define GL_NV_copy_depth_to_color 1
-#endif
-
-#ifndef GL_ATI_envmap_bumpmap
-#define GL_ATI_envmap_bumpmap 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glTexBumpParameterivATI (GLenum, const GLint *);
-  GLAPI void APIENTRY glTexBumpParameterfvATI (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glGetTexBumpParameterivATI (GLenum, GLint *);
-  GLAPI void APIENTRY glGetTexBumpParameterfvATI (GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLTEXBUMPPARAMETERIVATIPROC) (GLenum pname, const GLint *param);
-  typedef void (APIENTRYP PFNGLTEXBUMPPARAMETERFVATIPROC) (GLenum pname, const GLfloat *param);
-  typedef void (APIENTRYP PFNGLGETTEXBUMPPARAMETERIVATIPROC) (GLenum pname, GLint *param);
-  typedef void (APIENTRYP PFNGLGETTEXBUMPPARAMETERFVATIPROC) (GLenum pname, GLfloat *param);
-#endif
-
-#ifndef GL_ATI_fragment_shader
-#define GL_ATI_fragment_shader 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI GLuint APIENTRY glGenFragmentShadersATI (GLuint);
-  GLAPI void APIENTRY glBindFragmentShaderATI (GLuint);
-  GLAPI void APIENTRY glDeleteFragmentShaderATI (GLuint);
-  GLAPI void APIENTRY glBeginFragmentShaderATI (void);
-  GLAPI void APIENTRY glEndFragmentShaderATI (void);
-  GLAPI void APIENTRY glPassTexCoordATI (GLuint, GLuint, GLenum);
-  GLAPI void APIENTRY glSampleMapATI (GLuint, GLuint, GLenum);
-  GLAPI void APIENTRY glColorFragmentOp1ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glColorFragmentOp2ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glColorFragmentOp3ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glAlphaFragmentOp1ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glAlphaFragmentOp2ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glAlphaFragmentOp3ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glSetFragmentShaderConstantATI (GLuint, const GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef GLuint (APIENTRYP PFNGLGENFRAGMENTSHADERSATIPROC) (GLuint range);
-  typedef void (APIENTRYP PFNGLBINDFRAGMENTSHADERATIPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLDELETEFRAGMENTSHADERATIPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLBEGINFRAGMENTSHADERATIPROC) (void);
-  typedef void (APIENTRYP PFNGLENDFRAGMENTSHADERATIPROC) (void);
-  typedef void (APIENTRYP PFNGLPASSTEXCOORDATIPROC) (GLuint dst, GLuint coord, GLenum swizzle);
-  typedef void (APIENTRYP PFNGLSAMPLEMAPATIPROC) (GLuint dst, GLuint interp, GLenum swizzle);
-  typedef void (APIENTRYP PFNGLCOLORFRAGMENTOP1ATIPROC) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
-  typedef void (APIENTRYP PFNGLCOLORFRAGMENTOP2ATIPROC) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
-  typedef void (APIENTRYP PFNGLCOLORFRAGMENTOP3ATIPROC) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
-  typedef void (APIENTRYP PFNGLALPHAFRAGMENTOP1ATIPROC) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
-  typedef void (APIENTRYP PFNGLALPHAFRAGMENTOP2ATIPROC) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
-  typedef void (APIENTRYP PFNGLALPHAFRAGMENTOP3ATIPROC) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
-  typedef void (APIENTRYP PFNGLSETFRAGMENTSHADERCONSTANTATIPROC) (GLuint dst, const GLfloat *value);
-#endif
-
-#ifndef GL_ATI_pn_triangles
-#define GL_ATI_pn_triangles 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPNTrianglesiATI (GLenum, GLint);
-  GLAPI void APIENTRY glPNTrianglesfATI (GLenum, GLfloat);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPNTRIANGLESIATIPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLPNTRIANGLESFATIPROC) (GLenum pname, GLfloat param);
-#endif
-
-#ifndef GL_ATI_vertex_array_object
-#define GL_ATI_vertex_array_object 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI GLuint APIENTRY glNewObjectBufferATI (GLsizei, const GLvoid *, GLenum);
-  GLAPI GLboolean APIENTRY glIsObjectBufferATI (GLuint);
-  GLAPI void APIENTRY glUpdateObjectBufferATI (GLuint, GLuint, GLsizei, const GLvoid *, GLenum);
-  GLAPI void APIENTRY glGetObjectBufferfvATI (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetObjectBufferivATI (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glFreeObjectBufferATI (GLuint);
-  GLAPI void APIENTRY glArrayObjectATI (GLenum, GLint, GLenum, GLsizei, GLuint, GLuint);
-  GLAPI void APIENTRY glGetArrayObjectfvATI (GLenum, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetArrayObjectivATI (GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glVariantArrayObjectATI (GLuint, GLenum, GLsizei, GLuint, GLuint);
-  GLAPI void APIENTRY glGetVariantArrayObjectfvATI (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetVariantArrayObjectivATI (GLuint, GLenum, GLint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef GLuint (APIENTRYP PFNGLNEWOBJECTBUFFERATIPROC) (GLsizei size, const GLvoid *pointer, GLenum usage);
-  typedef GLboolean (APIENTRYP PFNGLISOBJECTBUFFERATIPROC) (GLuint buffer);
-  typedef void (APIENTRYP PFNGLUPDATEOBJECTBUFFERATIPROC) (GLuint buffer, GLuint offset, GLsizei size, const GLvoid *pointer, GLenum preserve);
-  typedef void (APIENTRYP PFNGLGETOBJECTBUFFERFVATIPROC) (GLuint buffer, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETOBJECTBUFFERIVATIPROC) (GLuint buffer, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLFREEOBJECTBUFFERATIPROC) (GLuint buffer);
-  typedef void (APIENTRYP PFNGLARRAYOBJECTATIPROC) (GLenum array, GLint size, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
-  typedef void (APIENTRYP PFNGLGETARRAYOBJECTFVATIPROC) (GLenum array, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETARRAYOBJECTIVATIPROC) (GLenum array, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLVARIANTARRAYOBJECTATIPROC) (GLuint id, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
-  typedef void (APIENTRYP PFNGLGETVARIANTARRAYOBJECTFVATIPROC) (GLuint id, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETVARIANTARRAYOBJECTIVATIPROC) (GLuint id, GLenum pname, GLint *params);
-#endif
-
-#ifndef GL_EXT_vertex_shader
-#define GL_EXT_vertex_shader 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBeginVertexShaderEXT (void);
-  GLAPI void APIENTRY glEndVertexShaderEXT (void);
-  GLAPI void APIENTRY glBindVertexShaderEXT (GLuint);
-  GLAPI GLuint APIENTRY glGenVertexShadersEXT (GLuint);
-  GLAPI void APIENTRY glDeleteVertexShaderEXT (GLuint);
-  GLAPI void APIENTRY glShaderOp1EXT (GLenum, GLuint, GLuint);
-  GLAPI void APIENTRY glShaderOp2EXT (GLenum, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glShaderOp3EXT (GLenum, GLuint, GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glSwizzleEXT (GLuint, GLuint, GLenum, GLenum, GLenum, GLenum);
-  GLAPI void APIENTRY glWriteMaskEXT (GLuint, GLuint, GLenum, GLenum, GLenum, GLenum);
-  GLAPI void APIENTRY glInsertComponentEXT (GLuint, GLuint, GLuint);
-  GLAPI void APIENTRY glExtractComponentEXT (GLuint, GLuint, GLuint);
-  GLAPI GLuint APIENTRY glGenSymbolsEXT (GLenum, GLenum, GLenum, GLuint);
-  GLAPI void APIENTRY glSetInvariantEXT (GLuint, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glSetLocalConstantEXT (GLuint, GLenum, const GLvoid *);
-  GLAPI void APIENTRY glVariantbvEXT (GLuint, const GLbyte *);
-  GLAPI void APIENTRY glVariantsvEXT (GLuint, const GLshort *);
-  GLAPI void APIENTRY glVariantivEXT (GLuint, const GLint *);
-  GLAPI void APIENTRY glVariantfvEXT (GLuint, const GLfloat *);
-  GLAPI void APIENTRY glVariantdvEXT (GLuint, const GLdouble *);
-  GLAPI void APIENTRY glVariantubvEXT (GLuint, const GLubyte *);
-  GLAPI void APIENTRY glVariantusvEXT (GLuint, const GLushort *);
-  GLAPI void APIENTRY glVariantuivEXT (GLuint, const GLuint *);
-  GLAPI void APIENTRY glVariantPointerEXT (GLuint, GLenum, GLuint, const GLvoid *);
-  GLAPI void APIENTRY glEnableVariantClientStateEXT (GLuint);
-  GLAPI void APIENTRY glDisableVariantClientStateEXT (GLuint);
-  GLAPI GLuint APIENTRY glBindLightParameterEXT (GLenum, GLenum);
-  GLAPI GLuint APIENTRY glBindMaterialParameterEXT (GLenum, GLenum);
-  GLAPI GLuint APIENTRY glBindTexGenParameterEXT (GLenum, GLenum, GLenum);
-  GLAPI GLuint APIENTRY glBindTextureUnitParameterEXT (GLenum, GLenum);
-  GLAPI GLuint APIENTRY glBindParameterEXT (GLenum);
-  GLAPI GLboolean APIENTRY glIsVariantEnabledEXT (GLuint, GLenum);
-  GLAPI void APIENTRY glGetVariantBooleanvEXT (GLuint, GLenum, GLboolean *);
-  GLAPI void APIENTRY glGetVariantIntegervEXT (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetVariantFloatvEXT (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetVariantPointervEXT (GLuint, GLenum, GLvoid* *);
-  GLAPI void APIENTRY glGetInvariantBooleanvEXT (GLuint, GLenum, GLboolean *);
-  GLAPI void APIENTRY glGetInvariantIntegervEXT (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetInvariantFloatvEXT (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetLocalConstantBooleanvEXT (GLuint, GLenum, GLboolean *);
-  GLAPI void APIENTRY glGetLocalConstantIntegervEXT (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetLocalConstantFloatvEXT (GLuint, GLenum, GLfloat *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBEGINVERTEXSHADEREXTPROC) (void);
-  typedef void (APIENTRYP PFNGLENDVERTEXSHADEREXTPROC) (void);
-  typedef void (APIENTRYP PFNGLBINDVERTEXSHADEREXTPROC) (GLuint id);
-  typedef GLuint (APIENTRYP PFNGLGENVERTEXSHADERSEXTPROC) (GLuint range);
-  typedef void (APIENTRYP PFNGLDELETEVERTEXSHADEREXTPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLSHADEROP1EXTPROC) (GLenum op, GLuint res, GLuint arg1);
-  typedef void (APIENTRYP PFNGLSHADEROP2EXTPROC) (GLenum op, GLuint res, GLuint arg1, GLuint arg2);
-  typedef void (APIENTRYP PFNGLSHADEROP3EXTPROC) (GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3);
-  typedef void (APIENTRYP PFNGLSWIZZLEEXTPROC) (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
-  typedef void (APIENTRYP PFNGLWRITEMASKEXTPROC) (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
-  typedef void (APIENTRYP PFNGLINSERTCOMPONENTEXTPROC) (GLuint res, GLuint src, GLuint num);
-  typedef void (APIENTRYP PFNGLEXTRACTCOMPONENTEXTPROC) (GLuint res, GLuint src, GLuint num);
-  typedef GLuint (APIENTRYP PFNGLGENSYMBOLSEXTPROC) (GLenum datatype, GLenum storagetype, GLenum range, GLuint components);
-  typedef void (APIENTRYP PFNGLSETINVARIANTEXTPROC) (GLuint id, GLenum type, const GLvoid *addr);
-  typedef void (APIENTRYP PFNGLSETLOCALCONSTANTEXTPROC) (GLuint id, GLenum type, const GLvoid *addr);
-  typedef void (APIENTRYP PFNGLVARIANTBVEXTPROC) (GLuint id, const GLbyte *addr);
-  typedef void (APIENTRYP PFNGLVARIANTSVEXTPROC) (GLuint id, const GLshort *addr);
-  typedef void (APIENTRYP PFNGLVARIANTIVEXTPROC) (GLuint id, const GLint *addr);
-  typedef void (APIENTRYP PFNGLVARIANTFVEXTPROC) (GLuint id, const GLfloat *addr);
-  typedef void (APIENTRYP PFNGLVARIANTDVEXTPROC) (GLuint id, const GLdouble *addr);
-  typedef void (APIENTRYP PFNGLVARIANTUBVEXTPROC) (GLuint id, const GLubyte *addr);
-  typedef void (APIENTRYP PFNGLVARIANTUSVEXTPROC) (GLuint id, const GLushort *addr);
-  typedef void (APIENTRYP PFNGLVARIANTUIVEXTPROC) (GLuint id, const GLuint *addr);
-  typedef void (APIENTRYP PFNGLVARIANTPOINTEREXTPROC) (GLuint id, GLenum type, GLuint stride, const GLvoid *addr);
-  typedef void (APIENTRYP PFNGLENABLEVARIANTCLIENTSTATEEXTPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLDISABLEVARIANTCLIENTSTATEEXTPROC) (GLuint id);
-  typedef GLuint (APIENTRYP PFNGLBINDLIGHTPARAMETEREXTPROC) (GLenum light, GLenum value);
-  typedef GLuint (APIENTRYP PFNGLBINDMATERIALPARAMETEREXTPROC) (GLenum face, GLenum value);
-  typedef GLuint (APIENTRYP PFNGLBINDTEXGENPARAMETEREXTPROC) (GLenum unit, GLenum coord, GLenum value);
-  typedef GLuint (APIENTRYP PFNGLBINDTEXTUREUNITPARAMETEREXTPROC) (GLenum unit, GLenum value);
-  typedef GLuint (APIENTRYP PFNGLBINDPARAMETEREXTPROC) (GLenum value);
-  typedef GLboolean (APIENTRYP PFNGLISVARIANTENABLEDEXTPROC) (GLuint id, GLenum cap);
-  typedef void (APIENTRYP PFNGLGETVARIANTBOOLEANVEXTPROC) (GLuint id, GLenum value, GLboolean *data);
-  typedef void (APIENTRYP PFNGLGETVARIANTINTEGERVEXTPROC) (GLuint id, GLenum value, GLint *data);
-  typedef void (APIENTRYP PFNGLGETVARIANTFLOATVEXTPROC) (GLuint id, GLenum value, GLfloat *data);
-  typedef void (APIENTRYP PFNGLGETVARIANTPOINTERVEXTPROC) (GLuint id, GLenum value, GLvoid* *data);
-  typedef void (APIENTRYP PFNGLGETINVARIANTBOOLEANVEXTPROC) (GLuint id, GLenum value, GLboolean *data);
-  typedef void (APIENTRYP PFNGLGETINVARIANTINTEGERVEXTPROC) (GLuint id, GLenum value, GLint *data);
-  typedef void (APIENTRYP PFNGLGETINVARIANTFLOATVEXTPROC) (GLuint id, GLenum value, GLfloat *data);
-  typedef void (APIENTRYP PFNGLGETLOCALCONSTANTBOOLEANVEXTPROC) (GLuint id, GLenum value, GLboolean *data);
-  typedef void (APIENTRYP PFNGLGETLOCALCONSTANTINTEGERVEXTPROC) (GLuint id, GLenum value, GLint *data);
-  typedef void (APIENTRYP PFNGLGETLOCALCONSTANTFLOATVEXTPROC) (GLuint id, GLenum value, GLfloat *data);
-#endif
-
-#ifndef GL_ATI_vertex_streams
-#define GL_ATI_vertex_streams 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glVertexStream1sATI (GLenum, GLshort);
-  GLAPI void APIENTRY glVertexStream1svATI (GLenum, const GLshort *);
-  GLAPI void APIENTRY glVertexStream1iATI (GLenum, GLint);
-  GLAPI void APIENTRY glVertexStream1ivATI (GLenum, const GLint *);
-  GLAPI void APIENTRY glVertexStream1fATI (GLenum, GLfloat);
-  GLAPI void APIENTRY glVertexStream1fvATI (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glVertexStream1dATI (GLenum, GLdouble);
-  GLAPI void APIENTRY glVertexStream1dvATI (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glVertexStream2sATI (GLenum, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexStream2svATI (GLenum, const GLshort *);
-  GLAPI void APIENTRY glVertexStream2iATI (GLenum, GLint, GLint);
-  GLAPI void APIENTRY glVertexStream2ivATI (GLenum, const GLint *);
-  GLAPI void APIENTRY glVertexStream2fATI (GLenum, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexStream2fvATI (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glVertexStream2dATI (GLenum, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexStream2dvATI (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glVertexStream3sATI (GLenum, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexStream3svATI (GLenum, const GLshort *);
-  GLAPI void APIENTRY glVertexStream3iATI (GLenum, GLint, GLint, GLint);
-  GLAPI void APIENTRY glVertexStream3ivATI (GLenum, const GLint *);
-  GLAPI void APIENTRY glVertexStream3fATI (GLenum, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexStream3fvATI (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glVertexStream3dATI (GLenum, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexStream3dvATI (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glVertexStream4sATI (GLenum, GLshort, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glVertexStream4svATI (GLenum, const GLshort *);
-  GLAPI void APIENTRY glVertexStream4iATI (GLenum, GLint, GLint, GLint, GLint);
-  GLAPI void APIENTRY glVertexStream4ivATI (GLenum, const GLint *);
-  GLAPI void APIENTRY glVertexStream4fATI (GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glVertexStream4fvATI (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glVertexStream4dATI (GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glVertexStream4dvATI (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glNormalStream3bATI (GLenum, GLbyte, GLbyte, GLbyte);
-  GLAPI void APIENTRY glNormalStream3bvATI (GLenum, const GLbyte *);
-  GLAPI void APIENTRY glNormalStream3sATI (GLenum, GLshort, GLshort, GLshort);
-  GLAPI void APIENTRY glNormalStream3svATI (GLenum, const GLshort *);
-  GLAPI void APIENTRY glNormalStream3iATI (GLenum, GLint, GLint, GLint);
-  GLAPI void APIENTRY glNormalStream3ivATI (GLenum, const GLint *);
-  GLAPI void APIENTRY glNormalStream3fATI (GLenum, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glNormalStream3fvATI (GLenum, const GLfloat *);
-  GLAPI void APIENTRY glNormalStream3dATI (GLenum, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glNormalStream3dvATI (GLenum, const GLdouble *);
-  GLAPI void APIENTRY glClientActiveVertexStreamATI (GLenum);
-  GLAPI void APIENTRY glVertexBlendEnviATI (GLenum, GLint);
-  GLAPI void APIENTRY glVertexBlendEnvfATI (GLenum, GLfloat);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1SATIPROC) (GLenum stream, GLshort x);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1SVATIPROC) (GLenum stream, const GLshort *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1IATIPROC) (GLenum stream, GLint x);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1IVATIPROC) (GLenum stream, const GLint *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1FATIPROC) (GLenum stream, GLfloat x);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1FVATIPROC) (GLenum stream, const GLfloat *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1DATIPROC) (GLenum stream, GLdouble x);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM1DVATIPROC) (GLenum stream, const GLdouble *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2SATIPROC) (GLenum stream, GLshort x, GLshort y);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2SVATIPROC) (GLenum stream, const GLshort *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2IATIPROC) (GLenum stream, GLint x, GLint y);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2IVATIPROC) (GLenum stream, const GLint *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2FATIPROC) (GLenum stream, GLfloat x, GLfloat y);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2FVATIPROC) (GLenum stream, const GLfloat *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2DATIPROC) (GLenum stream, GLdouble x, GLdouble y);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM2DVATIPROC) (GLenum stream, const GLdouble *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3SATIPROC) (GLenum stream, GLshort x, GLshort y, GLshort z);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3SVATIPROC) (GLenum stream, const GLshort *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3IATIPROC) (GLenum stream, GLint x, GLint y, GLint z);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3IVATIPROC) (GLenum stream, const GLint *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3FATIPROC) (GLenum stream, GLfloat x, GLfloat y, GLfloat z);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3FVATIPROC) (GLenum stream, const GLfloat *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3DATIPROC) (GLenum stream, GLdouble x, GLdouble y, GLdouble z);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM3DVATIPROC) (GLenum stream, const GLdouble *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4SATIPROC) (GLenum stream, GLshort x, GLshort y, GLshort z, GLshort w);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4SVATIPROC) (GLenum stream, const GLshort *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4IATIPROC) (GLenum stream, GLint x, GLint y, GLint z, GLint w);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4IVATIPROC) (GLenum stream, const GLint *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4FATIPROC) (GLenum stream, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4FVATIPROC) (GLenum stream, const GLfloat *coords);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4DATIPROC) (GLenum stream, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLVERTEXSTREAM4DVATIPROC) (GLenum stream, const GLdouble *coords);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3BATIPROC) (GLenum stream, GLbyte nx, GLbyte ny, GLbyte nz);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3BVATIPROC) (GLenum stream, const GLbyte *coords);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3SATIPROC) (GLenum stream, GLshort nx, GLshort ny, GLshort nz);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3SVATIPROC) (GLenum stream, const GLshort *coords);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3IATIPROC) (GLenum stream, GLint nx, GLint ny, GLint nz);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3IVATIPROC) (GLenum stream, const GLint *coords);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3FATIPROC) (GLenum stream, GLfloat nx, GLfloat ny, GLfloat nz);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3FVATIPROC) (GLenum stream, const GLfloat *coords);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3DATIPROC) (GLenum stream, GLdouble nx, GLdouble ny, GLdouble nz);
-  typedef void (APIENTRYP PFNGLNORMALSTREAM3DVATIPROC) (GLenum stream, const GLdouble *coords);
-  typedef void (APIENTRYP PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC) (GLenum stream);
-  typedef void (APIENTRYP PFNGLVERTEXBLENDENVIATIPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLVERTEXBLENDENVFATIPROC) (GLenum pname, GLfloat param);
-#endif
-
-#ifndef GL_ATI_element_array
-#define GL_ATI_element_array 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glElementPointerATI (GLenum, const GLvoid *);
-  GLAPI void APIENTRY glDrawElementArrayATI (GLenum, GLsizei);
-  GLAPI void APIENTRY glDrawRangeElementArrayATI (GLenum, GLuint, GLuint, GLsizei);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLELEMENTPOINTERATIPROC) (GLenum type, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLDRAWELEMENTARRAYATIPROC) (GLenum mode, GLsizei count);
-  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTARRAYATIPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count);
-#endif
-
-#ifndef GL_SUN_mesh_array
-#define GL_SUN_mesh_array 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDrawMeshArraysSUN (GLenum, GLint, GLsizei, GLsizei);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDRAWMESHARRAYSSUNPROC) (GLenum mode, GLint first, GLsizei count, GLsizei width);
-#endif
-
-#ifndef GL_SUN_slice_accum
-#define GL_SUN_slice_accum 1
-#endif
-
-#ifndef GL_NV_multisample_filter_hint
-#define GL_NV_multisample_filter_hint 1
-#endif
-
-#ifndef GL_NV_depth_clamp
-#define GL_NV_depth_clamp 1
-#endif
-
-#ifndef GL_NV_occlusion_query
-#define GL_NV_occlusion_query 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGenOcclusionQueriesNV (GLsizei, GLuint *);
-  GLAPI void APIENTRY glDeleteOcclusionQueriesNV (GLsizei, const GLuint *);
-  GLAPI GLboolean APIENTRY glIsOcclusionQueryNV (GLuint);
-  GLAPI void APIENTRY glBeginOcclusionQueryNV (GLuint);
-  GLAPI void APIENTRY glEndOcclusionQueryNV (void);
-  GLAPI void APIENTRY glGetOcclusionQueryivNV (GLuint, GLenum, GLint *);
-  GLAPI void APIENTRY glGetOcclusionQueryuivNV (GLuint, GLenum, GLuint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGENOCCLUSIONQUERIESNVPROC) (GLsizei n, GLuint *ids);
-  typedef void (APIENTRYP PFNGLDELETEOCCLUSIONQUERIESNVPROC) (GLsizei n, const GLuint *ids);
-  typedef GLboolean (APIENTRYP PFNGLISOCCLUSIONQUERYNVPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLBEGINOCCLUSIONQUERYNVPROC) (GLuint id);
-  typedef void (APIENTRYP PFNGLENDOCCLUSIONQUERYNVPROC) (void);
-  typedef void (APIENTRYP PFNGLGETOCCLUSIONQUERYIVNVPROC) (GLuint id, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGETOCCLUSIONQUERYUIVNVPROC) (GLuint id, GLenum pname, GLuint *params);
-#endif
-
-#ifndef GL_NV_point_sprite
-#define GL_NV_point_sprite 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPointParameteriNV (GLenum, GLint);
-  GLAPI void APIENTRY glPointParameterivNV (GLenum, const GLint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERINVPROC) (GLenum pname, GLint param);
-  typedef void (APIENTRYP PFNGLPOINTPARAMETERIVNVPROC) (GLenum pname, const GLint *params);
-#endif
-
-#ifndef GL_NV_texture_shader3
-#define GL_NV_texture_shader3 1
-#endif
-
-#ifndef GL_NV_vertex_program1_1
-#define GL_NV_vertex_program1_1 1
-#endif
-
-#ifndef GL_EXT_shadow_funcs
-#define GL_EXT_shadow_funcs 1
-#endif
-
-#ifndef GL_EXT_stencil_two_side
-#define GL_EXT_stencil_two_side 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glActiveStencilFaceEXT (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLACTIVESTENCILFACEEXTPROC) (GLenum face);
-#endif
-
-#ifndef GL_ATI_text_fragment_shader
-#define GL_ATI_text_fragment_shader 1
-#endif
-
-#ifndef GL_APPLE_client_storage
-#define GL_APPLE_client_storage 1
-#endif
-
-#ifndef GL_APPLE_element_array
-#define GL_APPLE_element_array 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glElementPointerAPPLE (GLenum, const GLvoid *);
-  GLAPI void APIENTRY glDrawElementArrayAPPLE (GLenum, GLint, GLsizei);
-  GLAPI void APIENTRY glDrawRangeElementArrayAPPLE (GLenum, GLuint, GLuint, GLint, GLsizei);
-  GLAPI void APIENTRY glMultiDrawElementArrayAPPLE (GLenum, const GLint *, const GLsizei *, GLsizei);
-  GLAPI void APIENTRY glMultiDrawRangeElementArrayAPPLE (GLenum, GLuint, GLuint, const GLint *, const GLsizei *, GLsizei);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLELEMENTPOINTERAPPLEPROC) (GLenum type, const GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLDRAWELEMENTARRAYAPPLEPROC) (GLenum mode, GLint first, GLsizei count);
-  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTARRAYAPPLEPROC) (GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
-  typedef void (APIENTRYP PFNGLMULTIDRAWELEMENTARRAYAPPLEPROC) (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount);
-  typedef void (APIENTRYP PFNGLMULTIDRAWRANGEELEMENTARRAYAPPLEPROC) (GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount);
-#endif
-
-#ifndef GL_APPLE_fence
-#define GL_APPLE_fence 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glGenFencesAPPLE (GLsizei, GLuint *);
-  GLAPI void APIENTRY glDeleteFencesAPPLE (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glSetFenceAPPLE (GLuint);
-  GLAPI GLboolean APIENTRY glIsFenceAPPLE (GLuint);
-  GLAPI GLboolean APIENTRY glTestFenceAPPLE (GLuint);
-  GLAPI void APIENTRY glFinishFenceAPPLE (GLuint);
-  GLAPI GLboolean APIENTRY glTestObjectAPPLE (GLenum, GLuint);
-  GLAPI void APIENTRY glFinishObjectAPPLE (GLenum, GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLGENFENCESAPPLEPROC) (GLsizei n, GLuint *fences);
-  typedef void (APIENTRYP PFNGLDELETEFENCESAPPLEPROC) (GLsizei n, const GLuint *fences);
-  typedef void (APIENTRYP PFNGLSETFENCEAPPLEPROC) (GLuint fence);
-  typedef GLboolean (APIENTRYP PFNGLISFENCEAPPLEPROC) (GLuint fence);
-  typedef GLboolean (APIENTRYP PFNGLTESTFENCEAPPLEPROC) (GLuint fence);
-  typedef void (APIENTRYP PFNGLFINISHFENCEAPPLEPROC) (GLuint fence);
-  typedef GLboolean (APIENTRYP PFNGLTESTOBJECTAPPLEPROC) (GLenum object, GLuint name);
-  typedef void (APIENTRYP PFNGLFINISHOBJECTAPPLEPROC) (GLenum object, GLint name);
-#endif
-
-#ifndef GL_APPLE_vertex_array_object
-#define GL_APPLE_vertex_array_object 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBindVertexArrayAPPLE (GLuint);
-  GLAPI void APIENTRY glDeleteVertexArraysAPPLE (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenVertexArraysAPPLE (GLsizei, const GLuint *);
-  GLAPI GLboolean APIENTRY glIsVertexArrayAPPLE (GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBINDVERTEXARRAYAPPLEPROC) (GLuint array);
-  typedef void (APIENTRYP PFNGLDELETEVERTEXARRAYSAPPLEPROC) (GLsizei n, const GLuint *arrays);
-  typedef void (APIENTRYP PFNGLGENVERTEXARRAYSAPPLEPROC) (GLsizei n, const GLuint *arrays);
-  typedef GLboolean (APIENTRYP PFNGLISVERTEXARRAYAPPLEPROC) (GLuint array);
-#endif
-
-#ifndef GL_APPLE_vertex_array_range
-#define GL_APPLE_vertex_array_range 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glVertexArrayRangeAPPLE (GLsizei, GLvoid *);
-  GLAPI void APIENTRY glFlushVertexArrayRangeAPPLE (GLsizei, GLvoid *);
-  GLAPI void APIENTRY glVertexArrayParameteriAPPLE (GLenum, GLint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLVERTEXARRAYRANGEAPPLEPROC) (GLsizei length, GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLFLUSHVERTEXARRAYRANGEAPPLEPROC) (GLsizei length, GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLVERTEXARRAYPARAMETERIAPPLEPROC) (GLenum pname, GLint param);
-#endif
-
-#ifndef GL_APPLE_ycbcr_422
-#define GL_APPLE_ycbcr_422 1
-#endif
-
-#ifndef GL_S3_s3tc
-#define GL_S3_s3tc 1
-#endif
-
-#ifndef GL_ATI_draw_buffers
-#define GL_ATI_draw_buffers 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDrawBuffersATI (GLsizei, const GLenum *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDRAWBUFFERSATIPROC) (GLsizei n, const GLenum *bufs);
-#endif
-
-#ifndef GL_ATI_pixel_format_float
-#define GL_ATI_pixel_format_float 1
-  /* This is really a WGL extension, but defines some associated GL enums.
-   * ATI does not export "GL_ATI_pixel_format_float" in the GL_EXTENSIONS string.
-   */
-#endif
-
-#ifndef GL_ATI_texture_env_combine3
-#define GL_ATI_texture_env_combine3 1
-#endif
-
-#ifndef GL_ATI_texture_float
-#define GL_ATI_texture_float 1
-#endif
-
-#ifndef GL_NV_float_buffer
-#define GL_NV_float_buffer 1
-#endif
-
-#ifndef GL_NV_fragment_program
-#define GL_NV_fragment_program 1
-  /* Some NV_fragment_program entry points are shared with ARB_vertex_program. */
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glProgramNamedParameter4fNV (GLuint, GLsizei, const GLubyte *, GLfloat, GLfloat, GLfloat, GLfloat);
-  GLAPI void APIENTRY glProgramNamedParameter4dNV (GLuint, GLsizei, const GLubyte *, GLdouble, GLdouble, GLdouble, GLdouble);
-  GLAPI void APIENTRY glProgramNamedParameter4fvNV (GLuint, GLsizei, const GLubyte *, const GLfloat *);
-  GLAPI void APIENTRY glProgramNamedParameter4dvNV (GLuint, GLsizei, const GLubyte *, const GLdouble *);
-  GLAPI void APIENTRY glGetProgramNamedParameterfvNV (GLuint, GLsizei, const GLubyte *, GLfloat *);
-  GLAPI void APIENTRY glGetProgramNamedParameterdvNV (GLuint, GLsizei, const GLubyte *, GLdouble *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4FNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
-  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4DNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
-  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4FVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, const GLfloat *v);
-  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4DVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, const GLdouble *v);
-  typedef void (APIENTRYP PFNGLGETPROGRAMNAMEDPARAMETERFVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETPROGRAMNAMEDPARAMETERDVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLdouble *params);
-#endif
-
-#ifndef GL_NV_half_float
-#define GL_NV_half_float 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glVertex2hNV (GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glVertex2hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glVertex3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glVertex3hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glVertex4hNV (GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glVertex4hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glNormal3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glNormal3hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glColor3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glColor3hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glColor4hNV (GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glColor4hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glTexCoord1hNV (GLhalfNV);
-  GLAPI void APIENTRY glTexCoord1hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glTexCoord2hNV (GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glTexCoord2hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glTexCoord3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glTexCoord3hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glTexCoord4hNV (GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glTexCoord4hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glMultiTexCoord1hNV (GLenum, GLhalfNV);
-  GLAPI void APIENTRY glMultiTexCoord1hvNV (GLenum, const GLhalfNV *);
-  GLAPI void APIENTRY glMultiTexCoord2hNV (GLenum, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glMultiTexCoord2hvNV (GLenum, const GLhalfNV *);
-  GLAPI void APIENTRY glMultiTexCoord3hNV (GLenum, GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glMultiTexCoord3hvNV (GLenum, const GLhalfNV *);
-  GLAPI void APIENTRY glMultiTexCoord4hNV (GLenum, GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glMultiTexCoord4hvNV (GLenum, const GLhalfNV *);
-  GLAPI void APIENTRY glFogCoordhNV (GLhalfNV);
-  GLAPI void APIENTRY glFogCoordhvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glSecondaryColor3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glSecondaryColor3hvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glVertexWeighthNV (GLhalfNV);
-  GLAPI void APIENTRY glVertexWeighthvNV (const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttrib1hNV (GLuint, GLhalfNV);
-  GLAPI void APIENTRY glVertexAttrib1hvNV (GLuint, const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttrib2hNV (GLuint, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glVertexAttrib2hvNV (GLuint, const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttrib3hNV (GLuint, GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glVertexAttrib3hvNV (GLuint, const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttrib4hNV (GLuint, GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
-  GLAPI void APIENTRY glVertexAttrib4hvNV (GLuint, const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttribs1hvNV (GLuint, GLsizei, const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttribs2hvNV (GLuint, GLsizei, const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttribs3hvNV (GLuint, GLsizei, const GLhalfNV *);
-  GLAPI void APIENTRY glVertexAttribs4hvNV (GLuint, GLsizei, const GLhalfNV *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLVERTEX2HNVPROC) (GLhalfNV x, GLhalfNV y);
-  typedef void (APIENTRYP PFNGLVERTEX2HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEX3HNVPROC) (GLhalfNV x, GLhalfNV y, GLhalfNV z);
-  typedef void (APIENTRYP PFNGLVERTEX3HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEX4HNVPROC) (GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
-  typedef void (APIENTRYP PFNGLVERTEX4HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLNORMAL3HNVPROC) (GLhalfNV nx, GLhalfNV ny, GLhalfNV nz);
-  typedef void (APIENTRYP PFNGLNORMAL3HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLCOLOR3HNVPROC) (GLhalfNV red, GLhalfNV green, GLhalfNV blue);
-  typedef void (APIENTRYP PFNGLCOLOR3HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLCOLOR4HNVPROC) (GLhalfNV red, GLhalfNV green, GLhalfNV blue, GLhalfNV alpha);
-  typedef void (APIENTRYP PFNGLCOLOR4HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD1HNVPROC) (GLhalfNV s);
-  typedef void (APIENTRYP PFNGLTEXCOORD1HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD2HNVPROC) (GLhalfNV s, GLhalfNV t);
-  typedef void (APIENTRYP PFNGLTEXCOORD2HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD3HNVPROC) (GLhalfNV s, GLhalfNV t, GLhalfNV r);
-  typedef void (APIENTRYP PFNGLTEXCOORD3HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLTEXCOORD4HNVPROC) (GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
-  typedef void (APIENTRYP PFNGLTEXCOORD4HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1HNVPROC) (GLenum target, GLhalfNV s);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD1HVNVPROC) (GLenum target, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2HNVPROC) (GLenum target, GLhalfNV s, GLhalfNV t);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD2HVNVPROC) (GLenum target, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3HNVPROC) (GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD3HVNVPROC) (GLenum target, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4HNVPROC) (GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
-  typedef void (APIENTRYP PFNGLMULTITEXCOORD4HVNVPROC) (GLenum target, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLFOGCOORDHNVPROC) (GLhalfNV fog);
-  typedef void (APIENTRYP PFNGLFOGCOORDHVNVPROC) (const GLhalfNV *fog);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3HNVPROC) (GLhalfNV red, GLhalfNV green, GLhalfNV blue);
-  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3HVNVPROC) (const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXWEIGHTHNVPROC) (GLhalfNV weight);
-  typedef void (APIENTRYP PFNGLVERTEXWEIGHTHVNVPROC) (const GLhalfNV *weight);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1HNVPROC) (GLuint index, GLhalfNV x);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB1HVNVPROC) (GLuint index, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2HNVPROC) (GLuint index, GLhalfNV x, GLhalfNV y);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB2HVNVPROC) (GLuint index, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3HNVPROC) (GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB3HVNVPROC) (GLuint index, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4HNVPROC) (GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIB4HVNVPROC) (GLuint index, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
-#endif
-
-#ifndef GL_NV_pixel_data_range
-#define GL_NV_pixel_data_range 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPixelDataRangeNV (GLenum, GLsizei, GLvoid *);
-  GLAPI void APIENTRY glFlushPixelDataRangeNV (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPIXELDATARANGENVPROC) (GLenum target, GLsizei length, GLvoid *pointer);
-  typedef void (APIENTRYP PFNGLFLUSHPIXELDATARANGENVPROC) (GLenum target);
-#endif
-
-#ifndef GL_NV_primitive_restart
-#define GL_NV_primitive_restart 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glPrimitiveRestartNV (void);
-  GLAPI void APIENTRY glPrimitiveRestartIndexNV (GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLPRIMITIVERESTARTNVPROC) (void);
-  typedef void (APIENTRYP PFNGLPRIMITIVERESTARTINDEXNVPROC) (GLuint index);
-#endif
-
-#ifndef GL_NV_texture_expand_normal
-#define GL_NV_texture_expand_normal 1
-#endif
-
-#ifndef GL_NV_vertex_program2
-#define GL_NV_vertex_program2 1
-#endif
-
-#ifndef GL_ATI_map_object_buffer
-#define GL_ATI_map_object_buffer 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI GLvoid* APIENTRY glMapObjectBufferATI (GLuint);
-  GLAPI void APIENTRY glUnmapObjectBufferATI (GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef GLvoid* (APIENTRYP PFNGLMAPOBJECTBUFFERATIPROC) (GLuint buffer);
-  typedef void (APIENTRYP PFNGLUNMAPOBJECTBUFFERATIPROC) (GLuint buffer);
-#endif
-
-#ifndef GL_ATI_separate_stencil
-#define GL_ATI_separate_stencil 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glStencilOpSeparateATI (GLenum, GLenum, GLenum, GLenum);
-  GLAPI void APIENTRY glStencilFuncSeparateATI (GLenum, GLenum, GLint, GLuint);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSTENCILOPSEPARATEATIPROC) (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
-  typedef void (APIENTRYP PFNGLSTENCILFUNCSEPARATEATIPROC) (GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask);
-#endif
-
-#ifndef GL_ATI_vertex_attrib_array_object
-#define GL_ATI_vertex_attrib_array_object 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glVertexAttribArrayObjectATI (GLuint, GLint, GLenum, GLboolean, GLsizei, GLuint, GLuint);
-  GLAPI void APIENTRY glGetVertexAttribArrayObjectfvATI (GLuint, GLenum, GLfloat *);
-  GLAPI void APIENTRY glGetVertexAttribArrayObjectivATI (GLuint, GLenum, GLint *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLVERTEXATTRIBARRAYOBJECTATIPROC) (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLuint buffer, GLuint offset);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBARRAYOBJECTFVATIPROC) (GLuint index, GLenum pname, GLfloat *params);
-  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBARRAYOBJECTIVATIPROC) (GLuint index, GLenum pname, GLint *params);
-#endif
-
-#ifndef GL_OES_read_format
-#define GL_OES_read_format 1
-#endif
-
-#ifndef GL_EXT_depth_bounds_test
-#define GL_EXT_depth_bounds_test 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glDepthBoundsEXT (GLclampd, GLclampd);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLDEPTHBOUNDSEXTPROC) (GLclampd zmin, GLclampd zmax);
-#endif
-
-#ifndef GL_EXT_texture_mirror_clamp
-#define GL_EXT_texture_mirror_clamp 1
-#endif
-
-#ifndef GL_EXT_blend_equation_separate
-#define GL_EXT_blend_equation_separate 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glBlendEquationSeparateEXT (GLenum, GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLBLENDEQUATIONSEPARATEEXTPROC) (GLenum modeRGB, GLenum modeAlpha);
-#endif
-
-#ifndef GL_MESA_pack_invert
-#define GL_MESA_pack_invert 1
-#endif
-
-#ifndef GL_MESA_ycbcr_texture
-#define GL_MESA_ycbcr_texture 1
-#endif
-
-#ifndef GL_EXT_pixel_buffer_object
-#define GL_EXT_pixel_buffer_object 1
-#endif
-
-#ifndef GL_NV_fragment_program_option
-#define GL_NV_fragment_program_option 1
-#endif
-
-#ifndef GL_NV_fragment_program2
-#define GL_NV_fragment_program2 1
-#endif
-
-#ifndef GL_NV_vertex_program2_option
-#define GL_NV_vertex_program2_option 1
-#endif
-
-#ifndef GL_NV_vertex_program3
-#define GL_NV_vertex_program3 1
-#endif
-
-#ifndef GL_EXT_framebuffer_object
-#define GL_EXT_framebuffer_object 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI GLboolean APIENTRY glIsRenderbufferEXT (GLuint);
-  GLAPI void APIENTRY glBindRenderbufferEXT (GLenum, GLuint);
-  GLAPI void APIENTRY glDeleteRenderbuffersEXT (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenRenderbuffersEXT (GLsizei, GLuint *);
-  GLAPI void APIENTRY glRenderbufferStorageEXT (GLenum, GLenum, GLsizei, GLsizei);
-  GLAPI void APIENTRY glGetRenderbufferParameterivEXT (GLenum, GLenum, GLint *);
-  GLAPI GLboolean APIENTRY glIsFramebufferEXT (GLuint);
-  GLAPI void APIENTRY glBindFramebufferEXT (GLenum, GLuint);
-  GLAPI void APIENTRY glDeleteFramebuffersEXT (GLsizei, const GLuint *);
-  GLAPI void APIENTRY glGenFramebuffersEXT (GLsizei, GLuint *);
-  GLAPI GLenum APIENTRY glCheckFramebufferStatusEXT (GLenum);
-  GLAPI void APIENTRY glFramebufferTexture1DEXT (GLenum, GLenum, GLenum, GLuint, GLint);
-  GLAPI void APIENTRY glFramebufferTexture2DEXT (GLenum, GLenum, GLenum, GLuint, GLint);
-  GLAPI void APIENTRY glFramebufferTexture3DEXT (GLenum, GLenum, GLenum, GLuint, GLint, GLint);
-  GLAPI void APIENTRY glFramebufferRenderbufferEXT (GLenum, GLenum, GLenum, GLuint);
-  GLAPI void APIENTRY glGetFramebufferAttachmentParameterivEXT (GLenum, GLenum, GLenum, GLint *);
-  GLAPI void APIENTRY glGenerateMipmapEXT (GLenum);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef GLboolean (APIENTRYP PFNGLISRENDERBUFFEREXTPROC) (GLuint renderbuffer);
-  typedef void (APIENTRYP PFNGLBINDRENDERBUFFEREXTPROC) (GLenum target, GLuint renderbuffer);
-  typedef void (APIENTRYP PFNGLDELETERENDERBUFFERSEXTPROC) (GLsizei n, const GLuint *renderbuffers);
-  typedef void (APIENTRYP PFNGLGENRENDERBUFFERSEXTPROC) (GLsizei n, GLuint *renderbuffers);
-  typedef void (APIENTRYP PFNGLRENDERBUFFERSTORAGEEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
-  typedef void (APIENTRYP PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
-  typedef GLboolean (APIENTRYP PFNGLISFRAMEBUFFEREXTPROC) (GLuint framebuffer);
-  typedef void (APIENTRYP PFNGLBINDFRAMEBUFFEREXTPROC) (GLenum target, GLuint framebuffer);
-  typedef void (APIENTRYP PFNGLDELETEFRAMEBUFFERSEXTPROC) (GLsizei n, const GLuint *framebuffers);
-  typedef void (APIENTRYP PFNGLGENFRAMEBUFFERSEXTPROC) (GLsizei n, GLuint *framebuffers);
-  typedef GLenum (APIENTRYP PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC) (GLenum target);
-  typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE1DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
-  typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE2DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
-  typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE3DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset);
-  typedef void (APIENTRYP PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC) (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
-  typedef void (APIENTRYP PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC) (GLenum target, GLenum attachment, GLenum pname, GLint *params);
-  typedef void (APIENTRYP PFNGLGENERATEMIPMAPEXTPROC) (GLenum target);
-#endif
-
-#ifndef GL_GREMEDY_string_marker
-#define GL_GREMEDY_string_marker 1
-#ifdef GL_GLEXT_PROTOTYPES
-  GLAPI void APIENTRY glStringMarkerGREMEDY (GLsizei, const GLvoid *);
-#endif /* GL_GLEXT_PROTOTYPES */
-  typedef void (APIENTRYP PFNGLSTRINGMARKERGREMEDYPROC) (GLsizei len, const GLvoid *string);
-#endif
-
-#ifndef GL_EXT_Cg_shader
-#define GL_EXT_Cg_shader 1
-#endif
-
-#ifndef GL_NV_element_array
-#define GL_NV_element_array 1
-#ifdef GL_GLEXT_PROTOTYPES
-  extern void APIENTRY glElementPointerNV(GLenum type, const GLvoid *pointer);
-  extern void APIENTRY glDrawElementArrayNV(GLenum mode, GLint first, GLsizei count);
-  extern void APIENTRY glDrawRangeElementArrayNV(GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
-  extern void APIENTRY glMultiDrawElementArrayNV(GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount);
-  extern void APIENTRY glMultiDrawRangeElementArrayNV(GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount);
-#endif
-  typedef void (APIENTRY * PFNGLELEMENTPOINTERNVPROC) (GLenum type, const GLvoid *pointer);
-  typedef void (APIENTRY * PFNGLDRAWELEMENTARRAYNVPROC) (GLenum mode, GLint first, GLsizei count);
-  typedef void (APIENTRY * PFNGLDRAWRANGEELEMENTARRAYNVPROC) (GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
-  typedef void (APIENTRY * PFNGLMULTIDRAWELEMENTARRAYNVPROC) (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount);
-  typedef void (APIENTRY * PFNGLMULTIDRAWRANGEELEMENTARRAYNVPROC) (GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount);
-#endif
-
-#ifndef GL_NV_pixel_buffer_object
-#define GL_NV_pixel_buffer_object 1
-#endif
-
-#ifndef GL_NV_stencil_two_side
-#define GL_NV_stencil_two_side 1
-#ifdef GL_GLEXT_PROTOTYPES
-  extern void APIENTRY glActiveStencilFaceNV(GLenum face);
-#endif
-  typedef void (APIENTRY * PFNGLACTIVESTENCILFACENVPROC) (GLenum face);
-#endif
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif
diff -pruN 8.0.1-5/opengl/wglext.h 8.2.0~beta1-1~exp1/opengl/wglext.h
--- 8.0.1-5/opengl/wglext.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/opengl/wglext.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,662 +0,0 @@
-#ifndef __wglext_h_
-#define __wglext_h_
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-  /*
-  ** License Applicability. Except to the extent portions of this file are
-  ** made subject to an alternative license as permitted in the SGI Free
-  ** Software License B, Version 1.1 (the "License"), the contents of this
-  ** file are subject only to the provisions of the License. You may not use
-  ** this file except in compliance with the License. You may obtain a copy
-  ** of the License at Silicon Graphics, Inc., attn: Legal Services, 1600
-  ** Amphitheatre Parkway, Mountain View, CA 94043-1351, or at:
-  **
-  ** http://oss.sgi.com/projects/FreeB
-  **
-  ** Note that, as provided in the License, the Software is distributed on an
-  ** "AS IS" basis, with ALL EXPRESS AND IMPLIED WARRANTIES AND CONDITIONS
-  ** DISCLAIMED, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES AND
-  ** CONDITIONS OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A
-  ** PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
-  **
-  ** Original Code. The Original Code is: OpenGL Sample Implementation,
-  ** Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
-  ** Inc. The Original Code is Copyright (c) 1991-2004 Silicon Graphics, Inc.
-  ** Copyright in any portions created by third parties is as indicated
-  ** elsewhere herein. All Rights Reserved.
-  **
-  ** Additional Notice Provisions: This software was created using the
-  ** OpenGL(R) version 1.2.1 Sample Implementation published by SGI, but has
-  ** not been independently verified as being compliant with the OpenGL(R)
-  ** version 1.2.1 Specification.
-  */
-
-#if defined(_WIN32) && !defined(APIENTRY) && !defined(__CYGWIN__) && !defined(__SCITECH_SNAP__)
-#define WIN32_LEAN_AND_MEAN 1
-#include <windows.h>
-#endif
-
-#ifndef APIENTRY
-#define APIENTRY
-#endif
-#ifndef APIENTRYP
-#define APIENTRYP APIENTRY *
-#endif
-#ifndef GLAPI
-#define GLAPI extern
-#endif
-
-  /*************************************************************/
-
-  /* Header file version number */
-  /* wglext.h last updated 2005/01/07 */
-  /* Current version at http://oss.sgi.com/projects/ogl-sample/registry/ */
-#define WGL_WGLEXT_VERSION 6
-
-#ifndef WGL_ARB_buffer_region
-#define WGL_FRONT_COLOR_BUFFER_BIT_ARB 0x00000001
-#define WGL_BACK_COLOR_BUFFER_BIT_ARB  0x00000002
-#define WGL_DEPTH_BUFFER_BIT_ARB       0x00000004
-#define WGL_STENCIL_BUFFER_BIT_ARB     0x00000008
-#endif
-
-#ifndef WGL_ARB_multisample
-#define WGL_SAMPLE_BUFFERS_ARB         0x2041
-#define WGL_SAMPLES_ARB                0x2042
-#endif
-
-#ifndef WGL_ARB_extensions_string
-#endif
-
-#ifndef WGL_ARB_pixel_format
-#define WGL_NUMBER_PIXEL_FORMATS_ARB   0x2000
-#define WGL_DRAW_TO_WINDOW_ARB         0x2001
-#define WGL_DRAW_TO_BITMAP_ARB         0x2002
-#define WGL_ACCELERATION_ARB           0x2003
-#define WGL_NEED_PALETTE_ARB           0x2004
-#define WGL_NEED_SYSTEM_PALETTE_ARB    0x2005
-#define WGL_SWAP_LAYER_BUFFERS_ARB     0x2006
-#define WGL_SWAP_METHOD_ARB            0x2007
-#define WGL_NUMBER_OVERLAYS_ARB        0x2008
-#define WGL_NUMBER_UNDERLAYS_ARB       0x2009
-#define WGL_TRANSPARENT_ARB            0x200A
-#define WGL_TRANSPARENT_RED_VALUE_ARB  0x2037
-#define WGL_TRANSPARENT_GREEN_VALUE_ARB 0x2038
-#define WGL_TRANSPARENT_BLUE_VALUE_ARB 0x2039
-#define WGL_TRANSPARENT_ALPHA_VALUE_ARB 0x203A
-#define WGL_TRANSPARENT_INDEX_VALUE_ARB 0x203B
-#define WGL_SHARE_DEPTH_ARB            0x200C
-#define WGL_SHARE_STENCIL_ARB          0x200D
-#define WGL_SHARE_ACCUM_ARB            0x200E
-#define WGL_SUPPORT_GDI_ARB            0x200F
-#define WGL_SUPPORT_OPENGL_ARB         0x2010
-#define WGL_DOUBLE_BUFFER_ARB          0x2011
-#define WGL_STEREO_ARB                 0x2012
-#define WGL_PIXEL_TYPE_ARB             0x2013
-#define WGL_COLOR_BITS_ARB             0x2014
-#define WGL_RED_BITS_ARB               0x2015
-#define WGL_RED_SHIFT_ARB              0x2016
-#define WGL_GREEN_BITS_ARB             0x2017
-#define WGL_GREEN_SHIFT_ARB            0x2018
-#define WGL_BLUE_BITS_ARB              0x2019
-#define WGL_BLUE_SHIFT_ARB             0x201A
-#define WGL_ALPHA_BITS_ARB             0x201B
-#define WGL_ALPHA_SHIFT_ARB            0x201C
-#define WGL_ACCUM_BITS_ARB             0x201D
-#define WGL_ACCUM_RED_BITS_ARB         0x201E
-#define WGL_ACCUM_GREEN_BITS_ARB       0x201F
-#define WGL_ACCUM_BLUE_BITS_ARB        0x2020
-#define WGL_ACCUM_ALPHA_BITS_ARB       0x2021
-#define WGL_DEPTH_BITS_ARB             0x2022
-#define WGL_STENCIL_BITS_ARB           0x2023
-#define WGL_AUX_BUFFERS_ARB            0x2024
-#define WGL_NO_ACCELERATION_ARB        0x2025
-#define WGL_GENERIC_ACCELERATION_ARB   0x2026
-#define WGL_FULL_ACCELERATION_ARB      0x2027
-#define WGL_SWAP_EXCHANGE_ARB          0x2028
-#define WGL_SWAP_COPY_ARB              0x2029
-#define WGL_SWAP_UNDEFINED_ARB         0x202A
-#define WGL_TYPE_RGBA_ARB              0x202B
-#define WGL_TYPE_COLORINDEX_ARB        0x202C
-#endif
-
-#ifndef WGL_ARB_make_current_read
-#define ERROR_INVALID_PIXEL_TYPE_ARB   0x2043
-#define ERROR_INCOMPATIBLE_DEVICE_CONTEXTS_ARB 0x2054
-#endif
-
-#ifndef WGL_ARB_pbuffer
-#define WGL_DRAW_TO_PBUFFER_ARB        0x202D
-#define WGL_MAX_PBUFFER_PIXELS_ARB     0x202E
-#define WGL_MAX_PBUFFER_WIDTH_ARB      0x202F
-#define WGL_MAX_PBUFFER_HEIGHT_ARB     0x2030
-#define WGL_PBUFFER_LARGEST_ARB        0x2033
-#define WGL_PBUFFER_WIDTH_ARB          0x2034
-#define WGL_PBUFFER_HEIGHT_ARB         0x2035
-#define WGL_PBUFFER_LOST_ARB           0x2036
-#endif
-
-#ifndef WGL_ARB_render_texture
-#define WGL_BIND_TO_TEXTURE_RGB_ARB    0x2070
-#define WGL_BIND_TO_TEXTURE_RGBA_ARB   0x2071
-#define WGL_TEXTURE_FORMAT_ARB         0x2072
-#define WGL_TEXTURE_TARGET_ARB         0x2073
-#define WGL_MIPMAP_TEXTURE_ARB         0x2074
-#define WGL_TEXTURE_RGB_ARB            0x2075
-#define WGL_TEXTURE_RGBA_ARB           0x2076
-#define WGL_NO_TEXTURE_ARB             0x2077
-#define WGL_TEXTURE_CUBE_MAP_ARB       0x2078
-#define WGL_TEXTURE_1D_ARB             0x2079
-#define WGL_TEXTURE_2D_ARB             0x207A
-#define WGL_MIPMAP_LEVEL_ARB           0x207B
-#define WGL_CUBE_MAP_FACE_ARB          0x207C
-#define WGL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB 0x207D
-#define WGL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB 0x207E
-#define WGL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB 0x207F
-#define WGL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB 0x2080
-#define WGL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB 0x2081
-#define WGL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB 0x2082
-#define WGL_FRONT_LEFT_ARB             0x2083
-#define WGL_FRONT_RIGHT_ARB            0x2084
-#define WGL_BACK_LEFT_ARB              0x2085
-#define WGL_BACK_RIGHT_ARB             0x2086
-#define WGL_AUX0_ARB                   0x2087
-#define WGL_AUX1_ARB                   0x2088
-#define WGL_AUX2_ARB                   0x2089
-#define WGL_AUX3_ARB                   0x208A
-#define WGL_AUX4_ARB                   0x208B
-#define WGL_AUX5_ARB                   0x208C
-#define WGL_AUX6_ARB                   0x208D
-#define WGL_AUX7_ARB                   0x208E
-#define WGL_AUX8_ARB                   0x208F
-#define WGL_AUX9_ARB                   0x2090
-#endif
-
-#ifndef WGL_ARB_pixel_format_float
-#define WGL_TYPE_RGBA_FLOAT_ARB        0x21A0
-#endif
-
-#ifndef WGL_EXT_make_current_read
-#define ERROR_INVALID_PIXEL_TYPE_EXT   0x2043
-#endif
-
-#ifndef WGL_EXT_pixel_format
-#define WGL_NUMBER_PIXEL_FORMATS_EXT   0x2000
-#define WGL_DRAW_TO_WINDOW_EXT         0x2001
-#define WGL_DRAW_TO_BITMAP_EXT         0x2002
-#define WGL_ACCELERATION_EXT           0x2003
-#define WGL_NEED_PALETTE_EXT           0x2004
-#define WGL_NEED_SYSTEM_PALETTE_EXT    0x2005
-#define WGL_SWAP_LAYER_BUFFERS_EXT     0x2006
-#define WGL_SWAP_METHOD_EXT            0x2007
-#define WGL_NUMBER_OVERLAYS_EXT        0x2008
-#define WGL_NUMBER_UNDERLAYS_EXT       0x2009
-#define WGL_TRANSPARENT_EXT            0x200A
-#define WGL_TRANSPARENT_VALUE_EXT      0x200B
-#define WGL_SHARE_DEPTH_EXT            0x200C
-#define WGL_SHARE_STENCIL_EXT          0x200D
-#define WGL_SHARE_ACCUM_EXT            0x200E
-#define WGL_SUPPORT_GDI_EXT            0x200F
-#define WGL_SUPPORT_OPENGL_EXT         0x2010
-#define WGL_DOUBLE_BUFFER_EXT          0x2011
-#define WGL_STEREO_EXT                 0x2012
-#define WGL_PIXEL_TYPE_EXT             0x2013
-#define WGL_COLOR_BITS_EXT             0x2014
-#define WGL_RED_BITS_EXT               0x2015
-#define WGL_RED_SHIFT_EXT              0x2016
-#define WGL_GREEN_BITS_EXT             0x2017
-#define WGL_GREEN_SHIFT_EXT            0x2018
-#define WGL_BLUE_BITS_EXT              0x2019
-#define WGL_BLUE_SHIFT_EXT             0x201A
-#define WGL_ALPHA_BITS_EXT             0x201B
-#define WGL_ALPHA_SHIFT_EXT            0x201C
-#define WGL_ACCUM_BITS_EXT             0x201D
-#define WGL_ACCUM_RED_BITS_EXT         0x201E
-#define WGL_ACCUM_GREEN_BITS_EXT       0x201F
-#define WGL_ACCUM_BLUE_BITS_EXT        0x2020
-#define WGL_ACCUM_ALPHA_BITS_EXT       0x2021
-#define WGL_DEPTH_BITS_EXT             0x2022
-#define WGL_STENCIL_BITS_EXT           0x2023
-#define WGL_AUX_BUFFERS_EXT            0x2024
-#define WGL_NO_ACCELERATION_EXT        0x2025
-#define WGL_GENERIC_ACCELERATION_EXT   0x2026
-#define WGL_FULL_ACCELERATION_EXT      0x2027
-#define WGL_SWAP_EXCHANGE_EXT          0x2028
-#define WGL_SWAP_COPY_EXT              0x2029
-#define WGL_SWAP_UNDEFINED_EXT         0x202A
-#define WGL_TYPE_RGBA_EXT              0x202B
-#define WGL_TYPE_COLORINDEX_EXT        0x202C
-#endif
-
-#ifndef WGL_EXT_pbuffer
-#define WGL_DRAW_TO_PBUFFER_EXT        0x202D
-#define WGL_MAX_PBUFFER_PIXELS_EXT     0x202E
-#define WGL_MAX_PBUFFER_WIDTH_EXT      0x202F
-#define WGL_MAX_PBUFFER_HEIGHT_EXT     0x2030
-#define WGL_OPTIMAL_PBUFFER_WIDTH_EXT  0x2031
-#define WGL_OPTIMAL_PBUFFER_HEIGHT_EXT 0x2032
-#define WGL_PBUFFER_LARGEST_EXT        0x2033
-#define WGL_PBUFFER_WIDTH_EXT          0x2034
-#define WGL_PBUFFER_HEIGHT_EXT         0x2035
-#endif
-
-#ifndef WGL_EXT_depth_float
-#define WGL_DEPTH_FLOAT_EXT            0x2040
-#endif
-
-#ifndef WGL_3DFX_multisample
-#define WGL_SAMPLE_BUFFERS_3DFX        0x2060
-#define WGL_SAMPLES_3DFX               0x2061
-#endif
-
-#ifndef WGL_EXT_multisample
-#define WGL_SAMPLE_BUFFERS_EXT         0x2041
-#define WGL_SAMPLES_EXT                0x2042
-#endif
-
-#ifndef WGL_I3D_digital_video_control
-#define WGL_DIGITAL_VIDEO_CURSOR_ALPHA_FRAMEBUFFER_I3D 0x2050
-#define WGL_DIGITAL_VIDEO_CURSOR_ALPHA_VALUE_I3D 0x2051
-#define WGL_DIGITAL_VIDEO_CURSOR_INCLUDED_I3D 0x2052
-#define WGL_DIGITAL_VIDEO_GAMMA_CORRECTED_I3D 0x2053
-#endif
-
-#ifndef WGL_I3D_gamma
-#define WGL_GAMMA_TABLE_SIZE_I3D       0x204E
-#define WGL_GAMMA_EXCLUDE_DESKTOP_I3D  0x204F
-#endif
-
-#ifndef WGL_I3D_genlock
-#define WGL_GENLOCK_SOURCE_MULTIVIEW_I3D 0x2044
-#define WGL_GENLOCK_SOURCE_EXTENAL_SYNC_I3D 0x2045
-#define WGL_GENLOCK_SOURCE_EXTENAL_FIELD_I3D 0x2046
-#define WGL_GENLOCK_SOURCE_EXTENAL_TTL_I3D 0x2047
-#define WGL_GENLOCK_SOURCE_DIGITAL_SYNC_I3D 0x2048
-#define WGL_GENLOCK_SOURCE_DIGITAL_FIELD_I3D 0x2049
-#define WGL_GENLOCK_SOURCE_EDGE_FALLING_I3D 0x204A
-#define WGL_GENLOCK_SOURCE_EDGE_RISING_I3D 0x204B
-#define WGL_GENLOCK_SOURCE_EDGE_BOTH_I3D 0x204C
-#endif
-
-#ifndef WGL_I3D_image_buffer
-#define WGL_IMAGE_BUFFER_MIN_ACCESS_I3D 0x00000001
-#define WGL_IMAGE_BUFFER_LOCK_I3D      0x00000002
-#endif
-
-#ifndef WGL_I3D_swap_frame_lock
-#endif
-
-#ifndef WGL_NV_render_depth_texture
-#define WGL_BIND_TO_TEXTURE_DEPTH_NV   0x20A3
-#define WGL_BIND_TO_TEXTURE_RECTANGLE_DEPTH_NV 0x20A4
-#define WGL_DEPTH_TEXTURE_FORMAT_NV    0x20A5
-#define WGL_TEXTURE_DEPTH_COMPONENT_NV 0x20A6
-#define WGL_DEPTH_COMPONENT_NV         0x20A7
-#endif
-
-#ifndef WGL_NV_render_texture_rectangle
-#define WGL_BIND_TO_TEXTURE_RECTANGLE_RGB_NV 0x20A0
-#define WGL_BIND_TO_TEXTURE_RECTANGLE_RGBA_NV 0x20A1
-#define WGL_TEXTURE_RECTANGLE_NV       0x20A2
-#endif
-
-#ifndef WGL_ATI_pixel_format_float
-#define WGL_TYPE_RGBA_FLOAT_ATI        0x21A0
-#define WGL_RGBA_FLOAT_MODE_ATI        0x8820
-#define WGL_COLOR_CLEAR_UNCLAMPED_VALUE_ATI 0x8835
-#endif
-
-#ifndef WGL_NV_float_buffer
-#define WGL_FLOAT_COMPONENTS_NV        0x20B0
-#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_R_NV 0x20B1
-#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_RG_NV 0x20B2
-#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_RGB_NV 0x20B3
-#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_RGBA_NV 0x20B4
-#define WGL_TEXTURE_FLOAT_R_NV         0x20B5
-#define WGL_TEXTURE_FLOAT_RG_NV        0x20B6
-#define WGL_TEXTURE_FLOAT_RGB_NV       0x20B7
-#define WGL_TEXTURE_FLOAT_RGBA_NV      0x20B8
-#endif
-
-#ifndef WGL_NV_swap_group
-#endif
-
-
-  /*************************************************************/
-
-#ifndef WGL_ARB_pbuffer
-  DECLARE_HANDLE(HPBUFFERARB);
-#endif
-#ifndef WGL_EXT_pbuffer
-  DECLARE_HANDLE(HPBUFFEREXT);
-#endif
-
-#ifndef WGL_ARB_buffer_region
-#define WGL_ARB_buffer_region 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern HANDLE WINAPI wglCreateBufferRegionARB (HDC, int, UINT);
-  extern VOID WINAPI wglDeleteBufferRegionARB (HANDLE);
-  extern BOOL WINAPI wglSaveBufferRegionARB (HANDLE, int, int, int, int);
-  extern BOOL WINAPI wglRestoreBufferRegionARB (HANDLE, int, int, int, int, int, int);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef HANDLE (WINAPI * PFNWGLCREATEBUFFERREGIONARBPROC) (HDC hDC, int iLayerPlane, UINT uType);
-  typedef VOID (WINAPI * PFNWGLDELETEBUFFERREGIONARBPROC) (HANDLE hRegion);
-  typedef BOOL (WINAPI * PFNWGLSAVEBUFFERREGIONARBPROC) (HANDLE hRegion, int x, int y, int width, int height);
-  typedef BOOL (WINAPI * PFNWGLRESTOREBUFFERREGIONARBPROC) (HANDLE hRegion, int x, int y, int width, int height, int xSrc, int ySrc);
-#endif
-
-#ifndef WGL_ARB_multisample
-#define WGL_ARB_multisample 1
-#endif
-
-#ifndef WGL_ARB_extensions_string
-#define WGL_ARB_extensions_string 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern const char * WINAPI wglGetExtensionsStringARB (HDC);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef const char * (WINAPI * PFNWGLGETEXTENSIONSSTRINGARBPROC) (HDC hdc);
-#endif
-
-#ifndef WGL_ARB_pixel_format
-#define WGL_ARB_pixel_format 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglGetPixelFormatAttribivARB (HDC, int, int, UINT, const int *, int *);
-  extern BOOL WINAPI wglGetPixelFormatAttribfvARB (HDC, int, int, UINT, const int *, FLOAT *);
-  extern BOOL WINAPI wglChoosePixelFormatARB (HDC, const int *, const FLOAT *, UINT, int *, UINT *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBIVARBPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, const int *piAttributes, int *piValues);
-  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBFVARBPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, const int *piAttributes, FLOAT *pfValues);
-  typedef BOOL (WINAPI * PFNWGLCHOOSEPIXELFORMATARBPROC) (HDC hdc, const int *piAttribIList, const FLOAT *pfAttribFList, UINT nMaxFormats, int *piFormats, UINT *nNumFormats);
-#endif
-
-#ifndef WGL_ARB_make_current_read
-#define WGL_ARB_make_current_read 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglMakeContextCurrentARB (HDC, HDC, HGLRC);
-  extern HDC WINAPI wglGetCurrentReadDCARB (void);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLMAKECONTEXTCURRENTARBPROC) (HDC hDrawDC, HDC hReadDC, HGLRC hglrc);
-  typedef HDC (WINAPI * PFNWGLGETCURRENTREADDCARBPROC) (void);
-#endif
-
-#ifndef WGL_ARB_pbuffer
-#define WGL_ARB_pbuffer 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern HPBUFFERARB WINAPI wglCreatePbufferARB (HDC, int, int, int, const int *);
-  extern HDC WINAPI wglGetPbufferDCARB (HPBUFFERARB);
-  extern int WINAPI wglReleasePbufferDCARB (HPBUFFERARB, HDC);
-  extern BOOL WINAPI wglDestroyPbufferARB (HPBUFFERARB);
-  extern BOOL WINAPI wglQueryPbufferARB (HPBUFFERARB, int, int *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef HPBUFFERARB (WINAPI * PFNWGLCREATEPBUFFERARBPROC) (HDC hDC, int iPixelFormat, int iWidth, int iHeight, const int *piAttribList);
-  typedef HDC (WINAPI * PFNWGLGETPBUFFERDCARBPROC) (HPBUFFERARB hPbuffer);
-  typedef int (WINAPI * PFNWGLRELEASEPBUFFERDCARBPROC) (HPBUFFERARB hPbuffer, HDC hDC);
-  typedef BOOL (WINAPI * PFNWGLDESTROYPBUFFERARBPROC) (HPBUFFERARB hPbuffer);
-  typedef BOOL (WINAPI * PFNWGLQUERYPBUFFERARBPROC) (HPBUFFERARB hPbuffer, int iAttribute, int *piValue);
-#endif
-
-#ifndef WGL_ARB_render_texture
-#define WGL_ARB_render_texture 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglBindTexImageARB (HPBUFFERARB, int);
-  extern BOOL WINAPI wglReleaseTexImageARB (HPBUFFERARB, int);
-  extern BOOL WINAPI wglSetPbufferAttribARB (HPBUFFERARB, const int *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLBINDTEXIMAGEARBPROC) (HPBUFFERARB hPbuffer, int iBuffer);
-  typedef BOOL (WINAPI * PFNWGLRELEASETEXIMAGEARBPROC) (HPBUFFERARB hPbuffer, int iBuffer);
-  typedef BOOL (WINAPI * PFNWGLSETPBUFFERATTRIBARBPROC) (HPBUFFERARB hPbuffer, const int *piAttribList);
-#endif
-
-#ifndef WGL_ARB_pixel_format_float
-#define WGL_ARB_pixel_format_float 1
-#endif
-
-#ifndef WGL_EXT_display_color_table
-#define WGL_EXT_display_color_table 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern GLboolean WINAPI wglCreateDisplayColorTableEXT (GLushort);
-  extern GLboolean WINAPI wglLoadDisplayColorTableEXT (const GLushort *, GLuint);
-  extern GLboolean WINAPI wglBindDisplayColorTableEXT (GLushort);
-  extern VOID WINAPI wglDestroyDisplayColorTableEXT (GLushort);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef GLboolean (WINAPI * PFNWGLCREATEDISPLAYCOLORTABLEEXTPROC) (GLushort id);
-  typedef GLboolean (WINAPI * PFNWGLLOADDISPLAYCOLORTABLEEXTPROC) (const GLushort *table, GLuint length);
-  typedef GLboolean (WINAPI * PFNWGLBINDDISPLAYCOLORTABLEEXTPROC) (GLushort id);
-  typedef VOID (WINAPI * PFNWGLDESTROYDISPLAYCOLORTABLEEXTPROC) (GLushort id);
-#endif
-
-#ifndef WGL_EXT_extensions_string
-#define WGL_EXT_extensions_string 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern const char * WINAPI wglGetExtensionsStringEXT (void);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef const char * (WINAPI * PFNWGLGETEXTENSIONSSTRINGEXTPROC) (void);
-#endif
-
-#ifndef WGL_EXT_make_current_read
-#define WGL_EXT_make_current_read 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglMakeContextCurrentEXT (HDC, HDC, HGLRC);
-  extern HDC WINAPI wglGetCurrentReadDCEXT (void);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLMAKECONTEXTCURRENTEXTPROC) (HDC hDrawDC, HDC hReadDC, HGLRC hglrc);
-  typedef HDC (WINAPI * PFNWGLGETCURRENTREADDCEXTPROC) (void);
-#endif
-
-#ifndef WGL_EXT_pbuffer
-#define WGL_EXT_pbuffer 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern HPBUFFEREXT WINAPI wglCreatePbufferEXT (HDC, int, int, int, const int *);
-  extern HDC WINAPI wglGetPbufferDCEXT (HPBUFFEREXT);
-  extern int WINAPI wglReleasePbufferDCEXT (HPBUFFEREXT, HDC);
-  extern BOOL WINAPI wglDestroyPbufferEXT (HPBUFFEREXT);
-  extern BOOL WINAPI wglQueryPbufferEXT (HPBUFFEREXT, int, int *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef HPBUFFEREXT (WINAPI * PFNWGLCREATEPBUFFEREXTPROC) (HDC hDC, int iPixelFormat, int iWidth, int iHeight, const int *piAttribList);
-  typedef HDC (WINAPI * PFNWGLGETPBUFFERDCEXTPROC) (HPBUFFEREXT hPbuffer);
-  typedef int (WINAPI * PFNWGLRELEASEPBUFFERDCEXTPROC) (HPBUFFEREXT hPbuffer, HDC hDC);
-  typedef BOOL (WINAPI * PFNWGLDESTROYPBUFFEREXTPROC) (HPBUFFEREXT hPbuffer);
-  typedef BOOL (WINAPI * PFNWGLQUERYPBUFFEREXTPROC) (HPBUFFEREXT hPbuffer, int iAttribute, int *piValue);
-#endif
-
-#ifndef WGL_EXT_pixel_format
-#define WGL_EXT_pixel_format 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglGetPixelFormatAttribivEXT (HDC, int, int, UINT, int *, int *);
-  extern BOOL WINAPI wglGetPixelFormatAttribfvEXT (HDC, int, int, UINT, int *, FLOAT *);
-  extern BOOL WINAPI wglChoosePixelFormatEXT (HDC, const int *, const FLOAT *, UINT, int *, UINT *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBIVEXTPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, int *piValues);
-  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBFVEXTPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, FLOAT *pfValues);
-  typedef BOOL (WINAPI * PFNWGLCHOOSEPIXELFORMATEXTPROC) (HDC hdc, const int *piAttribIList, const FLOAT *pfAttribFList, UINT nMaxFormats, int *piFormats, UINT *nNumFormats);
-#endif
-
-#ifndef WGL_EXT_swap_control
-#define WGL_EXT_swap_control 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglSwapIntervalEXT (int);
-  extern int WINAPI wglGetSwapIntervalEXT (void);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLSWAPINTERVALEXTPROC) (int interval);
-  typedef int (WINAPI * PFNWGLGETSWAPINTERVALEXTPROC) (void);
-#endif
-
-#ifndef WGL_EXT_depth_float
-#define WGL_EXT_depth_float 1
-#endif
-
-#ifndef WGL_NV_vertex_array_range
-#define WGL_NV_vertex_array_range 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern void* WINAPI wglAllocateMemoryNV (GLsizei, GLfloat, GLfloat, GLfloat);
-  extern void WINAPI wglFreeMemoryNV (void *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef void* (WINAPI * PFNWGLALLOCATEMEMORYNVPROC) (GLsizei size, GLfloat readfreq, GLfloat writefreq, GLfloat priority);
-  typedef void (WINAPI * PFNWGLFREEMEMORYNVPROC) (void *pointer);
-#endif
-
-#ifndef WGL_3DFX_multisample
-#define WGL_3DFX_multisample 1
-#endif
-
-#ifndef WGL_EXT_multisample
-#define WGL_EXT_multisample 1
-#endif
-
-#ifndef WGL_OML_sync_control
-#define WGL_OML_sync_control 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglGetSyncValuesOML (HDC, INT64 *, INT64 *, INT64 *);
-  extern BOOL WINAPI wglGetMscRateOML (HDC, INT32 *, INT32 *);
-  extern INT64 WINAPI wglSwapBuffersMscOML (HDC, INT64, INT64, INT64);
-  extern INT64 WINAPI wglSwapLayerBuffersMscOML (HDC, int, INT64, INT64, INT64);
-  extern BOOL WINAPI wglWaitForMscOML (HDC, INT64, INT64, INT64, INT64 *, INT64 *, INT64 *);
-  extern BOOL WINAPI wglWaitForSbcOML (HDC, INT64, INT64 *, INT64 *, INT64 *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLGETSYNCVALUESOMLPROC) (HDC hdc, INT64 *ust, INT64 *msc, INT64 *sbc);
-  typedef BOOL (WINAPI * PFNWGLGETMSCRATEOMLPROC) (HDC hdc, INT32 *numerator, INT32 *denominator);
-  typedef INT64 (WINAPI * PFNWGLSWAPBUFFERSMSCOMLPROC) (HDC hdc, INT64 target_msc, INT64 divisor, INT64 remainder);
-  typedef INT64 (WINAPI * PFNWGLSWAPLAYERBUFFERSMSCOMLPROC) (HDC hdc, int fuPlanes, INT64 target_msc, INT64 divisor, INT64 remainder);
-  typedef BOOL (WINAPI * PFNWGLWAITFORMSCOMLPROC) (HDC hdc, INT64 target_msc, INT64 divisor, INT64 remainder, INT64 *ust, INT64 *msc, INT64 *sbc);
-  typedef BOOL (WINAPI * PFNWGLWAITFORSBCOMLPROC) (HDC hdc, INT64 target_sbc, INT64 *ust, INT64 *msc, INT64 *sbc);
-#endif
-
-#ifndef WGL_I3D_digital_video_control
-#define WGL_I3D_digital_video_control 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglGetDigitalVideoParametersI3D (HDC, int, int *);
-  extern BOOL WINAPI wglSetDigitalVideoParametersI3D (HDC, int, const int *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLGETDIGITALVIDEOPARAMETERSI3DPROC) (HDC hDC, int iAttribute, int *piValue);
-  typedef BOOL (WINAPI * PFNWGLSETDIGITALVIDEOPARAMETERSI3DPROC) (HDC hDC, int iAttribute, const int *piValue);
-#endif
-
-#ifndef WGL_I3D_gamma
-#define WGL_I3D_gamma 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglGetGammaTableParametersI3D (HDC, int, int *);
-  extern BOOL WINAPI wglSetGammaTableParametersI3D (HDC, int, const int *);
-  extern BOOL WINAPI wglGetGammaTableI3D (HDC, int, USHORT *, USHORT *, USHORT *);
-  extern BOOL WINAPI wglSetGammaTableI3D (HDC, int, const USHORT *, const USHORT *, const USHORT *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLGETGAMMATABLEPARAMETERSI3DPROC) (HDC hDC, int iAttribute, int *piValue);
-  typedef BOOL (WINAPI * PFNWGLSETGAMMATABLEPARAMETERSI3DPROC) (HDC hDC, int iAttribute, const int *piValue);
-  typedef BOOL (WINAPI * PFNWGLGETGAMMATABLEI3DPROC) (HDC hDC, int iEntries, USHORT *puRed, USHORT *puGreen, USHORT *puBlue);
-  typedef BOOL (WINAPI * PFNWGLSETGAMMATABLEI3DPROC) (HDC hDC, int iEntries, const USHORT *puRed, const USHORT *puGreen, const USHORT *puBlue);
-#endif
-
-#ifndef WGL_I3D_genlock
-#define WGL_I3D_genlock 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglEnableGenlockI3D (HDC);
-  extern BOOL WINAPI wglDisableGenlockI3D (HDC);
-  extern BOOL WINAPI wglIsEnabledGenlockI3D (HDC, BOOL *);
-  extern BOOL WINAPI wglGenlockSourceI3D (HDC, UINT);
-  extern BOOL WINAPI wglGetGenlockSourceI3D (HDC, UINT *);
-  extern BOOL WINAPI wglGenlockSourceEdgeI3D (HDC, UINT);
-  extern BOOL WINAPI wglGetGenlockSourceEdgeI3D (HDC, UINT *);
-  extern BOOL WINAPI wglGenlockSampleRateI3D (HDC, UINT);
-  extern BOOL WINAPI wglGetGenlockSampleRateI3D (HDC, UINT *);
-  extern BOOL WINAPI wglGenlockSourceDelayI3D (HDC, UINT);
-  extern BOOL WINAPI wglGetGenlockSourceDelayI3D (HDC, UINT *);
-  extern BOOL WINAPI wglQueryGenlockMaxSourceDelayI3D (HDC, UINT *, UINT *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLENABLEGENLOCKI3DPROC) (HDC hDC);
-  typedef BOOL (WINAPI * PFNWGLDISABLEGENLOCKI3DPROC) (HDC hDC);
-  typedef BOOL (WINAPI * PFNWGLISENABLEDGENLOCKI3DPROC) (HDC hDC, BOOL *pFlag);
-  typedef BOOL (WINAPI * PFNWGLGENLOCKSOURCEI3DPROC) (HDC hDC, UINT uSource);
-  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSOURCEI3DPROC) (HDC hDC, UINT *uSource);
-  typedef BOOL (WINAPI * PFNWGLGENLOCKSOURCEEDGEI3DPROC) (HDC hDC, UINT uEdge);
-  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSOURCEEDGEI3DPROC) (HDC hDC, UINT *uEdge);
-  typedef BOOL (WINAPI * PFNWGLGENLOCKSAMPLERATEI3DPROC) (HDC hDC, UINT uRate);
-  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSAMPLERATEI3DPROC) (HDC hDC, UINT *uRate);
-  typedef BOOL (WINAPI * PFNWGLGENLOCKSOURCEDELAYI3DPROC) (HDC hDC, UINT uDelay);
-  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSOURCEDELAYI3DPROC) (HDC hDC, UINT *uDelay);
-  typedef BOOL (WINAPI * PFNWGLQUERYGENLOCKMAXSOURCEDELAYI3DPROC) (HDC hDC, UINT *uMaxLineDelay, UINT *uMaxPixelDelay);
-#endif
-
-#ifndef WGL_I3D_image_buffer
-#define WGL_I3D_image_buffer 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern LPVOID WINAPI wglCreateImageBufferI3D (HDC, DWORD, UINT);
-  extern BOOL WINAPI wglDestroyImageBufferI3D (HDC, LPVOID);
-  extern BOOL WINAPI wglAssociateImageBufferEventsI3D (HDC, const HANDLE *, const LPVOID *, const DWORD *, UINT);
-  extern BOOL WINAPI wglReleaseImageBufferEventsI3D (HDC, const LPVOID *, UINT);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef LPVOID (WINAPI * PFNWGLCREATEIMAGEBUFFERI3DPROC) (HDC hDC, DWORD dwSize, UINT uFlags);
-  typedef BOOL (WINAPI * PFNWGLDESTROYIMAGEBUFFERI3DPROC) (HDC hDC, LPVOID pAddress);
-  typedef BOOL (WINAPI * PFNWGLASSOCIATEIMAGEBUFFEREVENTSI3DPROC) (HDC hDC, const HANDLE *pEvent, const LPVOID *pAddress, const DWORD *pSize, UINT count);
-  typedef BOOL (WINAPI * PFNWGLRELEASEIMAGEBUFFEREVENTSI3DPROC) (HDC hDC, const LPVOID *pAddress, UINT count);
-#endif
-
-#ifndef WGL_I3D_swap_frame_lock
-#define WGL_I3D_swap_frame_lock 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglEnableFrameLockI3D (void);
-  extern BOOL WINAPI wglDisableFrameLockI3D (void);
-  extern BOOL WINAPI wglIsEnabledFrameLockI3D (BOOL *);
-  extern BOOL WINAPI wglQueryFrameLockMasterI3D (BOOL *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLENABLEFRAMELOCKI3DPROC) (void);
-  typedef BOOL (WINAPI * PFNWGLDISABLEFRAMELOCKI3DPROC) (void);
-  typedef BOOL (WINAPI * PFNWGLISENABLEDFRAMELOCKI3DPROC) (BOOL *pFlag);
-  typedef BOOL (WINAPI * PFNWGLQUERYFRAMELOCKMASTERI3DPROC) (BOOL *pFlag);
-#endif
-
-#ifndef WGL_I3D_swap_frame_usage
-#define WGL_I3D_swap_frame_usage 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglGetFrameUsageI3D (float *);
-  extern BOOL WINAPI wglBeginFrameTrackingI3D (void);
-  extern BOOL WINAPI wglEndFrameTrackingI3D (void);
-  extern BOOL WINAPI wglQueryFrameTrackingI3D (DWORD *, DWORD *, float *);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLGETFRAMEUSAGEI3DPROC) (float *pUsage);
-  typedef BOOL (WINAPI * PFNWGLBEGINFRAMETRACKINGI3DPROC) (void);
-  typedef BOOL (WINAPI * PFNWGLENDFRAMETRACKINGI3DPROC) (void);
-  typedef BOOL (WINAPI * PFNWGLQUERYFRAMETRACKINGI3DPROC) (DWORD *pFrameCount, DWORD *pMissedFrames, float *pLastMissedUsage);
-#endif
-
-#ifndef WGL_ATI_pixel_format_float
-#define WGL_ATI_pixel_format_float 1
-#endif
-
-#ifndef WGL_NV_render_depth_texture
-#define WGL_NV_render_depth_texture 1
-#endif
-
-#ifndef WGL_NV_render_texture_rectangle
-#define WGL_NV_render_texture_rectangle 1
-#endif
-
-#ifndef WGL_NV_float_buffer
-#define WGL_NV_float_buffer 1
-#endif
-
-#ifndef WGL_NV_swap_group
-#define WGL_NV_swap_group 1
-#ifdef WGL_WGLEXT_PROTOTYPES
-  extern BOOL WINAPI wglJoinSwapGroupNV(HDC hDC, GLuint group);
-  extern BOOL WINAPI wglBindSwapBarrierNV(GLuint group, GLuint barrier);
-  extern BOOL WINAPI wglQuerySwapGroupNV(HDC hDC GLuint *group, GLuint *barrier);
-  extern BOOL WINAPI wglQueryMaxSwapGroupsNV(HDC hDC, GLuint *maxGroups, GLuint *maxBarriers);
-  extern BOOL WINAPI wglQueryFrameCountNV(HDC hDC, GLuint *count);
-  extern BOOL WINAPI wglResetFrameCountNV(HDC hDC);
-#endif /* WGL_WGLEXT_PROTOTYPES */
-  typedef BOOL (WINAPI * PFNWGLJOINSWAPGROUPNVPROC) (HDC hDC, GLuint group);
-  typedef BOOL (WINAPI * PFNWGLBINDSWAPBARRIERNVPROC) (GLuint group, GLuint barrier);
-  typedef BOOL (WINAPI * PFNWGLQUERYSWAPGROUPNVPROC) (HDC hDC, GLuint *group, GLuint *barrier);
-  typedef BOOL (WINAPI * PFNWGLQUERYMAXSWAPGROUPSNVPROC) (HDC hDC, GLuint *maxGroups, GLuint *maxBarriers);
-  typedef BOOL (WINAPI * PFNWGLQUERYFRAMECOUNTNVPROC) (HDC hDC, GLuint *count);
-  typedef BOOL (WINAPI * PFNWGLRESETFRAMECOUNTNVPROC) (HDC hDC);
-#endif
-
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/LICENSE 8.2.0~beta1-1~exp1/renderers/agg/LICENSE
--- 8.0.1-5/renderers/agg/LICENSE	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/LICENSE	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-The Anti-Grain Geometry Project
-A high quality rendering engine for C++
-http://antigrain.com
-
-Anti-Grain Geometry - Version 2.4
-Copyright (C) 2002-2005 Maxim Shemanarev (McSeem)
-
-Permission to copy, use, modify, sell and distribute this software
-is granted provided this copyright notice appears in all copies.
-This software is provided "as is" without express or implied
-warranty, and with no claim as to its suitability for any purpose.
-
diff -pruN 8.0.1-5/renderers/agg/authors 8.2.0~beta1-1~exp1/renderers/agg/authors
--- 8.0.1-5/renderers/agg/authors	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/authors	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-Anti-Grain Geometry - Version 2.4
-Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
diff -pruN 8.0.1-5/renderers/agg/copying 8.2.0~beta1-1~exp1/renderers/agg/copying
--- 8.0.1-5/renderers/agg/copying	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/copying	1970-01-01 00:00:00.000000000 +0000
@@ -1,65 +0,0 @@
-The Anti-Grain Geometry Project
-A high quality rendering engine for C++
-http://antigrain.com
-
-Anti-Grain Geometry has dual licensing model. The Modified BSD 
-License was first added in version v2.4 just for convenience.
-It is a simple, permissive non-copyleft free software license, 
-compatible with the GNU GPL. It's well proven and recognizable.
-See http://www.fsf.org/licensing/licenses/index_html#ModifiedBSD
-for details.
-
-Note that the Modified BSD license DOES NOT restrict your rights 
-if you choose the Anti-Grain Geometry Public License.
-
-
-
-
-Anti-Grain Geometry Public License
-====================================================
-
-Anti-Grain Geometry - Version 2.4 
-Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
-
-Permission to copy, use, modify, sell and distribute this software 
-is granted provided this copyright notice appears in all copies. 
-This software is provided "as is" without express or implied
-warranty, and with no claim as to its suitability for any purpose.
-
-
-
-
-
-Modified BSD License
-====================================================
-Anti-Grain Geometry - Version 2.4 
-Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
-
-Redistribution and use in source and binary forms, with or without 
-modification, are permitted provided that the following conditions 
-are met:
-
-  1. Redistributions of source code must retain the above copyright 
-     notice, this list of conditions and the following disclaimer. 
-
-  2. Redistributions in binary form must reproduce the above copyright
-     notice, this list of conditions and the following disclaimer in 
-     the documentation and/or other materials provided with the 
-     distribution. 
-
-  3. The name of the author may not be used to endorse or promote 
-     products derived from this software without specific prior 
-     written permission. 
-
-THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
-IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
-WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
-ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
-INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
-(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
-SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
-HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
-STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
-IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
-POSSIBILITY OF SUCH DAMAGE.
-
diff -pruN 8.0.1-5/renderers/agg/include/Makefile.am 8.2.0~beta1-1~exp1/renderers/agg/include/Makefile.am
--- 8.0.1-5/renderers/agg/include/Makefile.am	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/Makefile.am	1970-01-01 00:00:00.000000000 +0000
@@ -1,47 +0,0 @@
-SUBDIRS = ctrl util platform 
-
-aggincludedir = $(includedir)/agg2
-agginclude_HEADERS = \
-	agg_alpha_mask_u8.h          agg_glyph_raster_bin.h          agg_span_allocator.h \
-	agg_arc.h                    agg_gsv_text.h                  agg_span_converter.h \
-	agg_array.h                  agg_image_accessors.h           agg_span_gouraud.h \
-	agg_arrowhead.h              agg_image_filters.h             agg_span_gouraud_gray.h \
-	agg_basics.h                 agg_line_aa_basics.h            agg_span_gouraud_rgba.h \
-	agg_bezier_arc.h             agg_math.h                      agg_span_gradient.h \
-	agg_bitset_iterator.h        agg_blur.h                      agg_math_stroke.h \
-	agg_span_gradient_alpha.h    agg_gradient_lut.h \
-	agg_bounding_rect.h          agg_path_length.h               agg_span_image_filter.h \
-	agg_bspline.h                agg_path_storage.h              agg_span_image_filter_gray.h \
-	agg_clip_liang_barsky.h      agg_path_storage_integer.h      agg_span_image_filter_rgb.h \
-	agg_color_gray.h             agg_pattern_filters_rgba.h      agg_span_image_filter_rgba.h \
-	agg_color_rgba.h             agg_pixfmt_amask_adaptor.h      agg_span_interpolator_adaptor.h \
-	agg_config.h                 agg_pixfmt_gray.h               agg_span_interpolator_linear.h \
-	agg_conv_adaptor_vcgen.h     agg_pixfmt_rgb.h                agg_span_interpolator_persp.h \
-	agg_conv_adaptor_vpgen.h     agg_pixfmt_rgb_packed.h         agg_span_interpolator_trans.h \
-	agg_conv_bspline.h           agg_pixfmt_rgba.h               agg_pixfmt_transposer.h \
-	agg_span_pattern_gray.h \
-	agg_conv_clip_polygon.h      agg_rasterizer_cells_aa.h       agg_span_pattern_rgb.h \
-	agg_conv_clip_polyline.h     agg_rasterizer_compound_aa.h    agg_span_pattern_rgba.h \
-	agg_conv_close_polygon.h     agg_rasterizer_outline.h        agg_span_solid.h \
-	agg_conv_concat.h            agg_rasterizer_outline_aa.h     agg_span_subdiv_adaptor.h \
-	agg_conv_contour.h           agg_rasterizer_scanline_aa.h    agg_trans_affine.h \
-	agg_conv_curve.h             agg_rasterizer_sl_clip.h        agg_trans_bilinear.h \
-	agg_conv_dash.h              agg_renderer_base.h             agg_trans_double_path.h \
-	agg_conv_gpc.h               agg_renderer_markers.h \
-	agg_conv_marker.h            agg_renderer_mclip.h            agg_trans_perspective.h \
-	agg_conv_marker_adaptor.h    agg_renderer_outline_aa.h       agg_trans_single_path.h \
-	agg_conv_segmentator.h       agg_renderer_outline_image.h    agg_trans_viewport.h \
-	agg_conv_shorten_path.h      agg_renderer_primitives.h       agg_trans_warp_magnifier.h \
-	agg_conv_smooth_poly1.h      agg_renderer_raster_text.h      agg_vcgen_bspline.h \
-	agg_conv_stroke.h            agg_renderer_scanline.h         agg_vcgen_contour.h \
-	agg_conv_transform.h         agg_rendering_buffer.h          agg_vcgen_dash.h \
-	agg_conv_unclose_polygon.h   agg_rendering_buffer_dynarow.h  agg_vcgen_markers_term.h \
-	agg_curves.h                 agg_rounded_rect.h              agg_vcgen_smooth_poly1.h \
-	                             agg_scanline_bin.h              agg_vcgen_stroke.h \
-	agg_dda_line.h               agg_scanline_boolean_algebra.h  agg_vcgen_vertex_sequence.h \
-	agg_ellipse.h                agg_scanline_p.h                agg_vertex_sequence.h \
-	agg_ellipse_bresenham.h      agg_scanline_storage_aa.h       agg_vpgen_clip_polygon.h \
-	agg_embedded_raster_fonts.h  agg_scanline_storage_bin.h      agg_vpgen_clip_polyline.h \
-	agg_font_cache_manager.h     agg_scanline_u.h                agg_vpgen_segmentator.h \
-	agg_gamma_functions.h        agg_shorten_path.h \
-	agg_gamma_lut.h              agg_simul_eq.h
diff -pruN 8.0.1-5/renderers/agg/include/agg_alpha_mask_u8.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_alpha_mask_u8.h
--- 8.0.1-5/renderers/agg/include/agg_alpha_mask_u8.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_alpha_mask_u8.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,499 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// scanline_u8 class
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_ALPHA_MASK_U8_INCLUDED
-#define AGG_ALPHA_MASK_U8_INCLUDED
-
-#include <string.h>
-#include "agg_basics.h"
-#include "agg_rendering_buffer.h"
-
-namespace mapserver
-{
-    //===================================================one_component_mask_u8
-    struct one_component_mask_u8
-    {
-        static unsigned calculate(const int8u* p) { return *p; }
-    };
-    
-
-    //=====================================================rgb_to_gray_mask_u8
-    template<unsigned R, unsigned G, unsigned B>
-    struct rgb_to_gray_mask_u8
-    {
-        static unsigned calculate(const int8u* p) 
-        { 
-            return (p[R]*77 + p[G]*150 + p[B]*29) >> 8; 
-        }
-    };
-
-    //==========================================================alpha_mask_u8
-    template<unsigned Step=1, unsigned Offset=0, class MaskF=one_component_mask_u8>
-    class alpha_mask_u8
-    {
-    public:
-        typedef int8u cover_type;
-        typedef alpha_mask_u8<Step, Offset, MaskF> self_type;
-        enum cover_scale_e
-        { 
-            cover_shift = 8,
-            cover_none  = 0,
-            cover_full  = 255
-        };
-
-        alpha_mask_u8() : m_rbuf(0) {}
-        explicit alpha_mask_u8(rendering_buffer& rbuf) : m_rbuf(&rbuf) {}
-
-        void attach(rendering_buffer& rbuf) { m_rbuf = &rbuf; }
-
-        MaskF& mask_function() { return m_mask_function; }
-        const MaskF& mask_function() const { return m_mask_function; }
-
-        
-        //--------------------------------------------------------------------
-        cover_type pixel(int x, int y) const
-        {
-            if(x >= 0 && y >= 0 && 
-               x < (int)m_rbuf->width() && 
-               y < (int)m_rbuf->height())
-            {
-                return (cover_type)m_mask_function.calculate(
-                                        m_rbuf->row_ptr(y) + x * Step + Offset);
-            }
-            return 0;
-        }
-
-        //--------------------------------------------------------------------
-        cover_type combine_pixel(int x, int y, cover_type val) const
-        {
-            if(x >= 0 && y >= 0 && 
-               x < (int)m_rbuf->width() && 
-               y < (int)m_rbuf->height())
-            {
-                return (cover_type)((cover_full + val * 
-                                     m_mask_function.calculate(
-                                        m_rbuf->row_ptr(y) + x * Step + Offset)) >> 
-                                     cover_shift);
-            }
-            return 0;
-        }
-
-
-        //--------------------------------------------------------------------
-        void fill_hspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            int xmax = m_rbuf->width() - 1;
-            int ymax = m_rbuf->height() - 1;
-
-            int count = num_pix;
-            cover_type* covers = dst;
-
-            if(y < 0 || y > ymax)
-            {
-                memset(dst, 0, num_pix * sizeof(cover_type));
-                return;
-            }
-
-            if(x < 0)
-            {
-                count += x;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers, 0, -x * sizeof(cover_type));
-                covers -= x;
-                x = 0;
-            }
-
-            if(x + count > xmax)
-            {
-                int rest = x + count - xmax - 1;
-                count -= rest;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers + count, 0, rest * sizeof(cover_type));
-            }
-
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *covers++ = (cover_type)m_mask_function.calculate(mask);
-                mask += Step;
-            }
-            while(--count);
-        }
-
-
-        //--------------------------------------------------------------------
-        void combine_hspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            int xmax = m_rbuf->width() - 1;
-            int ymax = m_rbuf->height() - 1;
-
-            int count = num_pix;
-            cover_type* covers = dst;
-
-            if(y < 0 || y > ymax)
-            {
-                memset(dst, 0, num_pix * sizeof(cover_type));
-                return;
-            }
-
-            if(x < 0)
-            {
-                count += x;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers, 0, -x * sizeof(cover_type));
-                covers -= x;
-                x = 0;
-            }
-
-            if(x + count > xmax)
-            {
-                int rest = x + count - xmax - 1;
-                count -= rest;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers + count, 0, rest * sizeof(cover_type));
-            }
-
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *covers = (cover_type)((cover_full + (*covers) * 
-                                       m_mask_function.calculate(mask)) >> 
-                                       cover_shift);
-                ++covers;
-                mask += Step;
-            }
-            while(--count);
-        }
-
-        //--------------------------------------------------------------------
-        void fill_vspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            int xmax = m_rbuf->width() - 1;
-            int ymax = m_rbuf->height() - 1;
-
-            int count = num_pix;
-            cover_type* covers = dst;
-
-            if(x < 0 || x > xmax)
-            {
-                memset(dst, 0, num_pix * sizeof(cover_type));
-                return;
-            }
-
-            if(y < 0)
-            {
-                count += y;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers, 0, -y * sizeof(cover_type));
-                covers -= y;
-                y = 0;
-            }
-
-            if(y + count > ymax)
-            {
-                int rest = y + count - ymax - 1;
-                count -= rest;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers + count, 0, rest * sizeof(cover_type));
-            }
-
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *covers++ = (cover_type)m_mask_function.calculate(mask);
-                mask += m_rbuf->stride();
-            }
-            while(--count);
-        }
-
-        //--------------------------------------------------------------------
-        void combine_vspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            int xmax = m_rbuf->width() - 1;
-            int ymax = m_rbuf->height() - 1;
-
-            int count = num_pix;
-            cover_type* covers = dst;
-
-            if(x < 0 || x > xmax)
-            {
-                memset(dst, 0, num_pix * sizeof(cover_type));
-                return;
-            }
-
-            if(y < 0)
-            {
-                count += y;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers, 0, -y * sizeof(cover_type));
-                covers -= y;
-                y = 0;
-            }
-
-            if(y + count > ymax)
-            {
-                int rest = y + count - ymax - 1;
-                count -= rest;
-                if(count <= 0) 
-                {
-                    memset(dst, 0, num_pix * sizeof(cover_type));
-                    return;
-                }
-                memset(covers + count, 0, rest * sizeof(cover_type));
-            }
-
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *covers = (cover_type)((cover_full + (*covers) * 
-                                       m_mask_function.calculate(mask)) >> 
-                                       cover_shift);
-                ++covers;
-                mask += m_rbuf->stride();
-            }
-            while(--count);
-        }
-
-
-    private:
-        alpha_mask_u8(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        rendering_buffer* m_rbuf;
-        MaskF             m_mask_function;
-    };
-    
-
-    typedef alpha_mask_u8<1, 0> alpha_mask_gray8;   //----alpha_mask_gray8
-
-    typedef alpha_mask_u8<3, 0> alpha_mask_rgb24r;  //----alpha_mask_rgb24r
-    typedef alpha_mask_u8<3, 1> alpha_mask_rgb24g;  //----alpha_mask_rgb24g
-    typedef alpha_mask_u8<3, 2> alpha_mask_rgb24b;  //----alpha_mask_rgb24b
-
-    typedef alpha_mask_u8<3, 2> alpha_mask_bgr24r;  //----alpha_mask_bgr24r
-    typedef alpha_mask_u8<3, 1> alpha_mask_bgr24g;  //----alpha_mask_bgr24g
-    typedef alpha_mask_u8<3, 0> alpha_mask_bgr24b;  //----alpha_mask_bgr24b
-
-    typedef alpha_mask_u8<4, 0> alpha_mask_rgba32r; //----alpha_mask_rgba32r
-    typedef alpha_mask_u8<4, 1> alpha_mask_rgba32g; //----alpha_mask_rgba32g
-    typedef alpha_mask_u8<4, 2> alpha_mask_rgba32b; //----alpha_mask_rgba32b
-    typedef alpha_mask_u8<4, 3> alpha_mask_rgba32a; //----alpha_mask_rgba32a
-
-    typedef alpha_mask_u8<4, 1> alpha_mask_argb32r; //----alpha_mask_argb32r
-    typedef alpha_mask_u8<4, 2> alpha_mask_argb32g; //----alpha_mask_argb32g
-    typedef alpha_mask_u8<4, 3> alpha_mask_argb32b; //----alpha_mask_argb32b
-    typedef alpha_mask_u8<4, 0> alpha_mask_argb32a; //----alpha_mask_argb32a
-
-    typedef alpha_mask_u8<4, 2> alpha_mask_bgra32r; //----alpha_mask_bgra32r
-    typedef alpha_mask_u8<4, 1> alpha_mask_bgra32g; //----alpha_mask_bgra32g
-    typedef alpha_mask_u8<4, 0> alpha_mask_bgra32b; //----alpha_mask_bgra32b
-    typedef alpha_mask_u8<4, 3> alpha_mask_bgra32a; //----alpha_mask_bgra32a
-
-    typedef alpha_mask_u8<4, 3> alpha_mask_abgr32r; //----alpha_mask_abgr32r
-    typedef alpha_mask_u8<4, 2> alpha_mask_abgr32g; //----alpha_mask_abgr32g
-    typedef alpha_mask_u8<4, 1> alpha_mask_abgr32b; //----alpha_mask_abgr32b
-    typedef alpha_mask_u8<4, 0> alpha_mask_abgr32a; //----alpha_mask_abgr32a
-
-    typedef alpha_mask_u8<3, 0, rgb_to_gray_mask_u8<0, 1, 2> > alpha_mask_rgb24gray;  //----alpha_mask_rgb24gray
-    typedef alpha_mask_u8<3, 0, rgb_to_gray_mask_u8<2, 1, 0> > alpha_mask_bgr24gray;  //----alpha_mask_bgr24gray
-    typedef alpha_mask_u8<4, 0, rgb_to_gray_mask_u8<0, 1, 2> > alpha_mask_rgba32gray; //----alpha_mask_rgba32gray
-    typedef alpha_mask_u8<4, 1, rgb_to_gray_mask_u8<0, 1, 2> > alpha_mask_argb32gray; //----alpha_mask_argb32gray
-    typedef alpha_mask_u8<4, 0, rgb_to_gray_mask_u8<2, 1, 0> > alpha_mask_bgra32gray; //----alpha_mask_bgra32gray
-    typedef alpha_mask_u8<4, 1, rgb_to_gray_mask_u8<2, 1, 0> > alpha_mask_abgr32gray; //----alpha_mask_abgr32gray
-
-
-
-    //==========================================================amask_no_clip_u8
-    template<unsigned Step=1, unsigned Offset=0, class MaskF=one_component_mask_u8>
-    class amask_no_clip_u8
-    {
-    public:
-        typedef int8u cover_type;
-        typedef amask_no_clip_u8<Step, Offset, MaskF> self_type;
-        enum cover_scale_e
-        { 
-            cover_shift = 8,
-            cover_none  = 0,
-            cover_full  = 255
-        };
-
-        amask_no_clip_u8() : m_rbuf(0) {}
-        explicit amask_no_clip_u8(rendering_buffer& rbuf) : m_rbuf(&rbuf) {}
-
-        void attach(rendering_buffer& rbuf) { m_rbuf = &rbuf; }
-
-        MaskF& mask_function() { return m_mask_function; }
-        const MaskF& mask_function() const { return m_mask_function; }
-
-
-        //--------------------------------------------------------------------
-        cover_type pixel(int x, int y) const
-        {
-            return (cover_type)m_mask_function.calculate(
-                                   m_rbuf->row_ptr(y) + x * Step + Offset);
-        }
-
-        
-        //--------------------------------------------------------------------
-        cover_type combine_pixel(int x, int y, cover_type val) const
-        {
-            return (cover_type)((cover_full + val * 
-                                 m_mask_function.calculate(
-                                    m_rbuf->row_ptr(y) + x * Step + Offset)) >> 
-                                 cover_shift);
-        }
-
-
-        //--------------------------------------------------------------------
-        void fill_hspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *dst++ = (cover_type)m_mask_function.calculate(mask);
-                mask += Step;
-            }
-            while(--num_pix);
-        }
-
-
-
-        //--------------------------------------------------------------------
-        void combine_hspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *dst = (cover_type)((cover_full + (*dst) * 
-                                    m_mask_function.calculate(mask)) >> 
-                                    cover_shift);
-                ++dst;
-                mask += Step;
-            }
-            while(--num_pix);
-        }
-
-
-        //--------------------------------------------------------------------
-        void fill_vspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *dst++ = (cover_type)m_mask_function.calculate(mask);
-                mask += m_rbuf->stride();
-            }
-            while(--num_pix);
-        }
-
-
-        //--------------------------------------------------------------------
-        void combine_vspan(int x, int y, cover_type* dst, int num_pix) const
-        {
-            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
-            do
-            {
-                *dst = (cover_type)((cover_full + (*dst) * 
-                                    m_mask_function.calculate(mask)) >> 
-                                    cover_shift);
-                ++dst;
-                mask += m_rbuf->stride();
-            }
-            while(--num_pix);
-        }
-
-    private:
-        amask_no_clip_u8(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        rendering_buffer* m_rbuf;
-        MaskF             m_mask_function;
-    };
-    
-
-    typedef amask_no_clip_u8<1, 0> amask_no_clip_gray8;   //----amask_no_clip_gray8
-
-    typedef amask_no_clip_u8<3, 0> amask_no_clip_rgb24r;  //----amask_no_clip_rgb24r
-    typedef amask_no_clip_u8<3, 1> amask_no_clip_rgb24g;  //----amask_no_clip_rgb24g
-    typedef amask_no_clip_u8<3, 2> amask_no_clip_rgb24b;  //----amask_no_clip_rgb24b
-
-    typedef amask_no_clip_u8<3, 2> amask_no_clip_bgr24r;  //----amask_no_clip_bgr24r
-    typedef amask_no_clip_u8<3, 1> amask_no_clip_bgr24g;  //----amask_no_clip_bgr24g
-    typedef amask_no_clip_u8<3, 0> amask_no_clip_bgr24b;  //----amask_no_clip_bgr24b
-
-    typedef amask_no_clip_u8<4, 0> amask_no_clip_rgba32r; //----amask_no_clip_rgba32r
-    typedef amask_no_clip_u8<4, 1> amask_no_clip_rgba32g; //----amask_no_clip_rgba32g
-    typedef amask_no_clip_u8<4, 2> amask_no_clip_rgba32b; //----amask_no_clip_rgba32b
-    typedef amask_no_clip_u8<4, 3> amask_no_clip_rgba32a; //----amask_no_clip_rgba32a
-
-    typedef amask_no_clip_u8<4, 1> amask_no_clip_argb32r; //----amask_no_clip_argb32r
-    typedef amask_no_clip_u8<4, 2> amask_no_clip_argb32g; //----amask_no_clip_argb32g
-    typedef amask_no_clip_u8<4, 3> amask_no_clip_argb32b; //----amask_no_clip_argb32b
-    typedef amask_no_clip_u8<4, 0> amask_no_clip_argb32a; //----amask_no_clip_argb32a
-
-    typedef amask_no_clip_u8<4, 2> amask_no_clip_bgra32r; //----amask_no_clip_bgra32r
-    typedef amask_no_clip_u8<4, 1> amask_no_clip_bgra32g; //----amask_no_clip_bgra32g
-    typedef amask_no_clip_u8<4, 0> amask_no_clip_bgra32b; //----amask_no_clip_bgra32b
-    typedef amask_no_clip_u8<4, 3> amask_no_clip_bgra32a; //----amask_no_clip_bgra32a
-
-    typedef amask_no_clip_u8<4, 3> amask_no_clip_abgr32r; //----amask_no_clip_abgr32r
-    typedef amask_no_clip_u8<4, 2> amask_no_clip_abgr32g; //----amask_no_clip_abgr32g
-    typedef amask_no_clip_u8<4, 1> amask_no_clip_abgr32b; //----amask_no_clip_abgr32b
-    typedef amask_no_clip_u8<4, 0> amask_no_clip_abgr32a; //----amask_no_clip_abgr32a
-
-    typedef amask_no_clip_u8<3, 0, rgb_to_gray_mask_u8<0, 1, 2> > amask_no_clip_rgb24gray;  //----amask_no_clip_rgb24gray
-    typedef amask_no_clip_u8<3, 0, rgb_to_gray_mask_u8<2, 1, 0> > amask_no_clip_bgr24gray;  //----amask_no_clip_bgr24gray
-    typedef amask_no_clip_u8<4, 0, rgb_to_gray_mask_u8<0, 1, 2> > amask_no_clip_rgba32gray; //----amask_no_clip_rgba32gray
-    typedef amask_no_clip_u8<4, 1, rgb_to_gray_mask_u8<0, 1, 2> > amask_no_clip_argb32gray; //----amask_no_clip_argb32gray
-    typedef amask_no_clip_u8<4, 0, rgb_to_gray_mask_u8<2, 1, 0> > amask_no_clip_bgra32gray; //----amask_no_clip_bgra32gray
-    typedef amask_no_clip_u8<4, 1, rgb_to_gray_mask_u8<2, 1, 0> > amask_no_clip_abgr32gray; //----amask_no_clip_abgr32gray
-
-
-}
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_arc.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_arc.h
--- 8.0.1-5/renderers/agg/include/agg_arc.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_arc.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,74 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Arc vertex generator
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_ARC_INCLUDED
-#define AGG_ARC_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //=====================================================================arc
-    //
-    // See Implementation agg_arc.cpp 
-    //
-    class arc
-    {
-    public:
-        arc() : m_scale(1.0), m_initialized(false) {}
-        arc(double x,  double y, 
-            double rx, double ry, 
-            double a1, double a2, 
-            bool ccw=true);
-
-        void init(double x,  double y, 
-                  double rx, double ry, 
-                  double a1, double a2, 
-                  bool ccw=true);
-
-        void approximation_scale(double s);
-        double approximation_scale() const { return m_scale;  }
-
-        void rewind(unsigned);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        void normalize(double a1, double a2, bool ccw);
-
-        double   m_x;
-        double   m_y;
-        double   m_rx;
-        double   m_ry;
-        double   m_angle = 0;
-        double   m_start;
-        double   m_end;
-        double   m_scale;
-        double   m_da;
-        bool     m_ccw;
-        bool     m_initialized;
-        unsigned m_path_cmd = 0;
-    };
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_array.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_array.h
--- 8.0.1-5/renderers/agg/include/agg_array.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_array.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1119 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_ARRAY_INCLUDED
-#define AGG_ARRAY_INCLUDED
-
-#include <stddef.h>
-#include <string.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //-------------------------------------------------------pod_array_adaptor
-    template<class T> class pod_array_adaptor
-    {
-    public:
-        typedef T value_type;
-        pod_array_adaptor(T* array, unsigned size) : 
-            m_array(array), m_size(size) {}
-
-        unsigned size() const { return m_size; }
-        const T& operator [] (unsigned i) const { return m_array[i]; }
-              T& operator [] (unsigned i)       { return m_array[i]; }
-        const T& at(unsigned i) const           { return m_array[i]; }
-              T& at(unsigned i)                 { return m_array[i]; }
-        T  value_at(unsigned i) const           { return m_array[i]; }
-
-    private:
-        T*       m_array;
-        unsigned m_size;
-    };
-
-
-    //---------------------------------------------------------pod_auto_array
-    template<class T, unsigned Size> class pod_auto_array
-    {
-    public:
-        typedef T value_type;
-        typedef pod_auto_array<T, Size> self_type;
-
-        pod_auto_array() {}
-        explicit pod_auto_array(const T* c)
-        {
-            memcpy(m_array, c, sizeof(T) * Size);
-        }
-
-        const self_type& operator = (const T* c)
-        {
-            memcpy(m_array, c, sizeof(T) * Size);
-            return *this;
-        }
-
-        static unsigned size() { return Size; }
-        const T& operator [] (unsigned i) const { return m_array[i]; }
-              T& operator [] (unsigned i)       { return m_array[i]; }
-        const T& at(unsigned i) const           { return m_array[i]; }
-              T& at(unsigned i)                 { return m_array[i]; }
-        T  value_at(unsigned i) const           { return m_array[i]; }
-
-    private:
-        T m_array[Size];
-    };
-
-
-    //--------------------------------------------------------pod_auto_vector
-    template<class T, unsigned Size> class pod_auto_vector
-    {
-    public:
-        typedef T value_type;
-        typedef pod_auto_vector<T, Size> self_type;
-
-        pod_auto_vector() : m_size(0) {}
-
-        void remove_all()            { m_size = 0; }
-        void clear()                 { m_size = 0; }
-        void add(const T& v)         { m_array[m_size++] = v; }
-        void push_back(const T& v)   { m_array[m_size++] = v; }
-        void inc_size(unsigned size) { m_size += size; }
-        
-        unsigned size() const { return m_size; }
-        const T& operator [] (unsigned i) const { return m_array[i]; }
-              T& operator [] (unsigned i)       { return m_array[i]; }
-        const T& at(unsigned i) const           { return m_array[i]; }
-              T& at(unsigned i)                 { return m_array[i]; }
-        T  value_at(unsigned i) const           { return m_array[i]; }
-
-    private:
-        T m_array[Size];
-        unsigned m_size;
-    };
-
-
-    //---------------------------------------------------------------pod_array
-    template<class T> class pod_array
-    {
-    public:
-        typedef T value_type;
-        typedef pod_array<T> self_type;
-
-        ~pod_array() { pod_allocator<T>::deallocate(m_array, m_size); }
-        pod_array() : m_array(0), m_size(0) {}
-
-        pod_array(unsigned size) : 
-            m_array(pod_allocator<T>::allocate(size)), 
-            m_size(size) 
-        {}
-
-        pod_array(const self_type& v) : 
-            m_array(pod_allocator<T>::allocate(v.m_size)), 
-            m_size(v.m_size) 
-        {
-            memcpy(m_array, v.m_array, sizeof(T) * m_size);
-        }
-
-        void resize(unsigned size)
-        {
-            if(size != m_size)
-            {
-                pod_allocator<T>::deallocate(m_array, m_size);
-                m_array = pod_allocator<T>::allocate(m_size = size);
-            }
-        }
-        const self_type& operator = (const self_type& v)
-        {
-            resize(v.size());
-            memcpy(m_array, v.m_array, sizeof(T) * m_size);
-            return *this;
-        }
-
-        unsigned size() const { return m_size; }
-        const T& operator [] (unsigned i) const { return m_array[i]; }
-              T& operator [] (unsigned i)       { return m_array[i]; }
-        const T& at(unsigned i) const           { return m_array[i]; }
-              T& at(unsigned i)                 { return m_array[i]; }
-        T  value_at(unsigned i) const           { return m_array[i]; }
-
-        const T* data() const { return m_array; }
-              T* data()       { return m_array; }
-    private:
-        T*       m_array;
-        unsigned m_size;
-    };
-
-
-
-    //--------------------------------------------------------------pod_vector
-    // A simple class template to store Plain Old Data, a vector
-    // of a fixed size. The data is continous in memory
-    //------------------------------------------------------------------------
-    template<class T> class pod_vector
-    {
-    public:
-        typedef T value_type;
-
-        ~pod_vector() { pod_allocator<T>::deallocate(m_array, m_capacity); }
-        pod_vector() : m_size(0), m_capacity(0), m_array(0) {}
-        pod_vector(unsigned cap, unsigned extra_tail=0);
-
-        // Copying
-        pod_vector(const pod_vector<T>&);
-        const pod_vector<T>& operator = (const pod_vector<T>&);
-
-        // Set new capacity. All data is lost, size is set to zero.
-        void capacity(unsigned cap, unsigned extra_tail=0);
-        unsigned capacity() const { return m_capacity; }
-
-        // Allocate n elements. All data is lost, 
-        // but elements can be accessed in range 0...size-1. 
-        void allocate(unsigned size, unsigned extra_tail=0);
-
-        // Resize keeping the content.
-        void resize(unsigned new_size);
-
-        void zero()
-        {
-            memset(m_array, 0, sizeof(T) * m_size);
-        }
-
-        void add(const T& v)         { m_array[m_size++] = v; }
-        void push_back(const T& v)   { m_array[m_size++] = v; }
-        void insert_at(unsigned pos, const T& val);
-        void inc_size(unsigned size) { m_size += size; }
-        unsigned size()      const   { return m_size; }
-        unsigned byte_size() const   { return m_size * sizeof(T); }
-        void serialize(int8u* ptr) const;
-        void deserialize(const int8u* data, unsigned byte_size);
-        const T& operator [] (unsigned i) const { return m_array[i]; }
-              T& operator [] (unsigned i)       { return m_array[i]; }
-        const T& at(unsigned i) const           { return m_array[i]; }
-              T& at(unsigned i)                 { return m_array[i]; }
-        T  value_at(unsigned i) const           { return m_array[i]; }
-
-        const T* data() const { return m_array; }
-              T* data()       { return m_array; }
-
-        void remove_all()         { m_size = 0; }
-        void clear()              { m_size = 0; }
-        void cut_at(unsigned num) { if(num < m_size) m_size = num; }
-
-    private:
-        unsigned m_size;
-        unsigned m_capacity;
-        T*       m_array;
-    };
-
-    //------------------------------------------------------------------------
-    template<class T> 
-    void pod_vector<T>::capacity(unsigned cap, unsigned extra_tail)
-    {
-        m_size = 0;
-        if(cap > m_capacity)
-        {
-            pod_allocator<T>::deallocate(m_array, m_capacity);
-            m_capacity = cap + extra_tail;
-            m_array = m_capacity ? pod_allocator<T>::allocate(m_capacity) : 0;
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class T> 
-    void pod_vector<T>::allocate(unsigned size, unsigned extra_tail)
-    {
-        capacity(size, extra_tail);
-        m_size = size;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T> 
-    void pod_vector<T>::resize(unsigned new_size)
-    {
-        if(new_size > m_size)
-        {
-            if(new_size > m_capacity)
-            {
-                T* data = pod_allocator<T>::allocate(new_size);
-                memcpy(data, m_array, m_size * sizeof(T));
-                pod_allocator<T>::deallocate(m_array, m_capacity);
-                m_array = data;
-            }
-        }
-        else
-        {
-            m_size = new_size;
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class T> pod_vector<T>::pod_vector(unsigned cap, unsigned extra_tail) :
-        m_size(0), 
-        m_capacity(cap + extra_tail), 
-        m_array(pod_allocator<T>::allocate(m_capacity)) {}
-
-    //------------------------------------------------------------------------
-    template<class T> pod_vector<T>::pod_vector(const pod_vector<T>& v) :
-        m_size(v.m_size),
-        m_capacity(v.m_capacity),
-        m_array(v.m_capacity ? pod_allocator<T>::allocate(v.m_capacity) : 0)
-    {
-        memcpy(m_array, v.m_array, sizeof(T) * v.m_size);
-    }
-
-    //------------------------------------------------------------------------
-    template<class T> const pod_vector<T>& 
-    pod_vector<T>::operator = (const pod_vector<T>&v)
-    {
-        allocate(v.m_size);
-        if(v.m_size) memcpy(m_array, v.m_array, sizeof(T) * v.m_size);
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T> void pod_vector<T>::serialize(int8u* ptr) const
-    { 
-        if(m_size) memcpy(ptr, m_array, m_size * sizeof(T)); 
-    }
-
-    //------------------------------------------------------------------------
-    template<class T> 
-    void pod_vector<T>::deserialize(const int8u* data, unsigned byte_size)
-    {
-        byte_size /= sizeof(T);
-        allocate(byte_size);
-        if(byte_size) memcpy(m_array, data, byte_size * sizeof(T));
-    }
-
-    //------------------------------------------------------------------------
-    template<class T> 
-    void pod_vector<T>::insert_at(unsigned pos, const T& val)
-    {
-        if(pos >= m_size) 
-        {
-            m_array[m_size] = val;
-        }
-        else
-        {
-            memmove(m_array + pos + 1, m_array + pos, (m_size - pos) * sizeof(T));
-            m_array[pos] = val;
-        }
-        ++m_size;
-    }
-
-    //---------------------------------------------------------------pod_bvector
-    // A simple class template to store Plain Old Data, similar to std::deque
-    // It doesn't reallocate memory but instead, uses blocks of data of size 
-    // of (1 << S), that is, power of two. The data is NOT contiguous in memory, 
-    // so the only valid access method is operator [] or curr(), prev(), next()
-    // 
-    // There reallocs occure only when the pool of pointers to blocks needs 
-    // to be extended (it happens very rarely). You can control the value 
-    // of increment to reallocate the pointer buffer. See the second constructor.
-    // By default, the incremeent value equals (1 << S), i.e., the block size.
-    //------------------------------------------------------------------------
-    template<class T, unsigned S=6> class pod_bvector
-    {
-    public:
-        enum block_scale_e
-        {   
-            block_shift = S,
-            block_size  = 1 << block_shift,
-            block_mask  = block_size - 1
-        };
-
-        typedef T value_type;
-
-        ~pod_bvector();
-        pod_bvector();
-        pod_bvector(unsigned block_ptr_inc);
-
-        // Copying
-        pod_bvector(const pod_bvector<T, S>& v);
-        const pod_bvector<T, S>& operator = (const pod_bvector<T, S>& v);
-
-        void remove_all() { m_size = 0; }
-        void clear()      { m_size = 0; }
-        void free_all()   { free_tail(0); }
-        void free_tail(unsigned size);
-        void add(const T& val);
-        void push_back(const T& val) { add(val); }
-        void modify_last(const T& val);
-        void remove_last();
-
-        int allocate_continuous_block(unsigned num_elements);
-
-        void add_array(const T* ptr, unsigned num_elem)
-        {
-            while(num_elem--)
-            {
-                add(*ptr++);
-            }
-        }
-
-        template<class DataAccessor> void add_data(DataAccessor& data)
-        {
-            while(data.size())
-            {
-                add(*data);
-                ++data;
-            }
-        }
-
-        void cut_at(unsigned size)
-        {
-            if(size < m_size) m_size = size;
-        }
-
-        unsigned size() const { return m_size; }
-
-        const T& operator [] (unsigned i) const
-        {
-            return m_blocks[i >> block_shift][i & block_mask];
-        }
-
-        T& operator [] (unsigned i)
-        {
-            return m_blocks[i >> block_shift][i & block_mask];
-        }
-
-        const T& at(unsigned i) const
-        { 
-            return m_blocks[i >> block_shift][i & block_mask];
-        }
-
-        T& at(unsigned i) 
-        { 
-            return m_blocks[i >> block_shift][i & block_mask];
-        }
-
-        T value_at(unsigned i) const
-        { 
-            return m_blocks[i >> block_shift][i & block_mask];
-        }
-
-        const T& curr(unsigned idx) const
-        {
-            return (*this)[idx];
-        }
-
-        T& curr(unsigned idx)
-        {
-            return (*this)[idx];
-        }
-
-        const T& prev(unsigned idx) const
-        {
-            return (*this)[(idx + m_size - 1) % m_size];
-        }
-
-        T& prev(unsigned idx)
-        {
-            return (*this)[(idx + m_size - 1) % m_size];
-        }
-
-        const T& next(unsigned idx) const
-        {
-            return (*this)[(idx + 1) % m_size];
-        }
-
-        T& next(unsigned idx)
-        {
-            return (*this)[(idx + 1) % m_size];
-        }
-
-        const T& last() const
-        {
-            return (*this)[m_size - 1];
-        }
-
-        T& last()
-        {
-            return (*this)[m_size - 1];
-        }
-
-        unsigned byte_size() const;
-        void serialize(int8u* ptr) const;
-        void deserialize(const int8u* data, unsigned byte_size);
-        void deserialize(unsigned start, const T& empty_val, 
-                         const int8u* data, unsigned byte_size);
-
-        template<class ByteAccessor> 
-        void deserialize(ByteAccessor data)
-        {
-            remove_all();
-            unsigned elem_size = data.size() / sizeof(T);
-
-            for(unsigned i = 0; i < elem_size; ++i)
-            {
-                int8u* ptr = (int8u*)data_ptr();
-                for(unsigned j = 0; j < sizeof(T); ++j)
-                {
-                    *ptr++ = *data;
-                    ++data;
-                }
-                ++m_size;
-            }
-        }
-
-        template<class ByteAccessor>
-        void deserialize(unsigned start, const T& empty_val, ByteAccessor data)
-        {
-            while(m_size < start)
-            {
-                add(empty_val);
-            }
-
-            unsigned elem_size = data.size() / sizeof(T);
-            for(unsigned i = 0; i < elem_size; ++i)
-            {
-                int8u* ptr;
-                if(start + i < m_size)
-                {
-                    ptr = (int8u*)(&((*this)[start + i]));
-                }
-                else
-                {
-                    ptr = (int8u*)data_ptr();
-                    ++m_size;
-                }
-                for(unsigned j = 0; j < sizeof(T); ++j)
-                {
-                    *ptr++ = *data;
-                    ++data;
-                }
-            }
-        }
-
-        const T* block(unsigned nb) const { return m_blocks[nb]; }
-
-    private:
-        void allocate_block(unsigned nb);
-        T*   data_ptr();
-
-        unsigned        m_size;
-        unsigned        m_num_blocks;
-        unsigned        m_max_blocks;
-        T**             m_blocks;
-        unsigned        m_block_ptr_inc;
-    };
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> pod_bvector<T, S>::~pod_bvector()
-    {
-        if(m_num_blocks)
-        {
-            T** blk = m_blocks + m_num_blocks - 1;
-            while(m_num_blocks--)
-            {
-                pod_allocator<T>::deallocate(*blk, block_size);
-                --blk;
-            }
-        }
-        pod_allocator<T*>::deallocate(m_blocks, m_max_blocks);
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void pod_bvector<T, S>::free_tail(unsigned size)
-    {
-        if(size < m_size)
-        {
-            unsigned nb = (size + block_mask) >> block_shift;
-            while(m_num_blocks > nb)
-            {
-                pod_allocator<T>::deallocate(m_blocks[--m_num_blocks], block_size);
-            }
-            if(m_num_blocks == 0)
-            {
-                pod_allocator<T*>::deallocate(m_blocks, m_max_blocks);
-                m_blocks = 0;
-                m_max_blocks = 0;
-            }
-            m_size = size;
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> pod_bvector<T, S>::pod_bvector() :
-        m_size(0),
-        m_num_blocks(0),
-        m_max_blocks(0),
-        m_blocks(0),
-        m_block_ptr_inc(block_size)
-    {
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    pod_bvector<T, S>::pod_bvector(unsigned block_ptr_inc) :
-        m_size(0),
-        m_num_blocks(0),
-        m_max_blocks(0),
-        m_blocks(0),
-        m_block_ptr_inc(block_ptr_inc)
-    {
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    pod_bvector<T, S>::pod_bvector(const pod_bvector<T, S>& v) :
-        m_size(v.m_size),
-        m_num_blocks(v.m_num_blocks),
-        m_max_blocks(v.m_max_blocks),
-        m_blocks(v.m_max_blocks ? 
-                 pod_allocator<T*>::allocate(v.m_max_blocks) : 
-                 0),
-        m_block_ptr_inc(v.m_block_ptr_inc)
-    {
-        unsigned i;
-        for(i = 0; i < v.m_num_blocks; ++i)
-        {
-            m_blocks[i] = pod_allocator<T>::allocate(block_size);
-            memcpy(m_blocks[i], v.m_blocks[i], block_size * sizeof(T));
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    const pod_bvector<T, S>& 
-    pod_bvector<T, S>::operator = (const pod_bvector<T, S>& v)
-    {
-        unsigned i;
-        for(i = m_num_blocks; i < v.m_num_blocks; ++i)
-        {
-            allocate_block(i);
-        }
-        for(i = 0; i < v.m_num_blocks; ++i)
-        {
-            memcpy(m_blocks[i], v.m_blocks[i], block_size * sizeof(T));
-        }
-        m_size = v.m_size;
-        return *this;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S>
-    void pod_bvector<T, S>::allocate_block(unsigned nb)
-    {
-        if(nb >= m_max_blocks) 
-        {
-            T** new_blocks = pod_allocator<T*>::allocate(m_max_blocks + m_block_ptr_inc);
-
-            if(m_blocks)
-            {
-                memcpy(new_blocks, 
-                       m_blocks, 
-                       m_num_blocks * sizeof(T*));
-
-                pod_allocator<T*>::deallocate(m_blocks, m_max_blocks);
-            }
-            m_blocks = new_blocks;
-            m_max_blocks += m_block_ptr_inc;
-        }
-        m_blocks[nb] = pod_allocator<T>::allocate(block_size);
-        m_num_blocks++;
-    }
-
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S>
-    inline T* pod_bvector<T, S>::data_ptr()
-    {
-        unsigned nb = m_size >> block_shift;
-        if(nb >= m_num_blocks)
-        {
-            allocate_block(nb);
-        }
-        return m_blocks[nb] + (m_size & block_mask);
-    }
-
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    inline void pod_bvector<T, S>::add(const T& val)
-    {
-        *data_ptr() = val;
-        ++m_size;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    inline void pod_bvector<T, S>::remove_last()
-    {
-        if(m_size) --m_size;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void pod_bvector<T, S>::modify_last(const T& val)
-    {
-        remove_last();
-        add(val);
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    int pod_bvector<T, S>::allocate_continuous_block(unsigned num_elements)
-    {
-        if(num_elements < block_size)
-        {
-            data_ptr(); // Allocate initial block if necessary
-            unsigned rest = block_size - (m_size & block_mask);
-            unsigned index;
-            if(num_elements <= rest)
-            {
-                // The rest of the block is good, we can use it
-                //-----------------
-                index = m_size;
-                m_size += num_elements;
-                return index;
-            }
-
-            // New block
-            //---------------
-            m_size += rest;
-            data_ptr();
-            index = m_size;
-            m_size += num_elements;
-            return index;
-        }
-        return -1; // Impossible to allocate
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    unsigned pod_bvector<T, S>::byte_size() const
-    {
-        return m_size * sizeof(T);
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void pod_bvector<T, S>::serialize(int8u* ptr) const
-    {
-        unsigned i;
-        for(i = 0; i < m_size; i++)
-        {
-            memcpy(ptr, &(*this)[i], sizeof(T));
-            ptr += sizeof(T);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void pod_bvector<T, S>::deserialize(const int8u* data, unsigned byte_size)
-    {
-        remove_all();
-        byte_size /= sizeof(T);
-        for(unsigned i = 0; i < byte_size; ++i)
-        {
-            T* ptr = data_ptr();
-            memcpy(ptr, data, sizeof(T));
-            ++m_size;
-            data += sizeof(T);
-        }
-    }
-
-
-    // Replace or add a number of elements starting from "start" position
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void pod_bvector<T, S>::deserialize(unsigned start, const T& empty_val, 
-                                        const int8u* data, unsigned byte_size)
-    {
-        while(m_size < start)
-        {
-            add(empty_val);
-        }
-
-        byte_size /= sizeof(T);
-        for(unsigned i = 0; i < byte_size; ++i)
-        {
-            if(start + i < m_size)
-            {
-                memcpy(&((*this)[start + i]), data, sizeof(T));
-            }
-            else
-            {
-                T* ptr = data_ptr();
-                memcpy(ptr, data, sizeof(T));
-                ++m_size;
-            }
-            data += sizeof(T);
-        }
-    }
-
-
-    //---------------------------------------------------------block_allocator
-    // Allocator for arbitrary POD data. Most usable in different cache
-    // systems for efficient memory allocations. 
-    // Memory is allocated with blocks of fixed size ("block_size" in
-    // the constructor). If required size exceeds the block size the allocator
-    // creates a new block of the required size. However, the most efficient
-    // use is when the average reqired size is much less than the block size. 
-    //------------------------------------------------------------------------
-    class block_allocator
-    {
-        struct block_type
-        {
-            int8u*   data;
-            unsigned size;
-        };
-
-    public:
-        void remove_all()
-        {
-            if(m_num_blocks)
-            {
-                block_type* blk = m_blocks + m_num_blocks - 1;
-                while(m_num_blocks--)
-                {
-                    pod_allocator<int8u>::deallocate(blk->data, blk->size);
-                    --blk;
-                }
-                pod_allocator<block_type>::deallocate(m_blocks, m_max_blocks);
-            }
-            m_num_blocks = 0;
-            m_max_blocks = 0;
-            m_blocks = 0;
-            m_buf_ptr = 0;
-            m_rest = 0;
-        }
-
-        ~block_allocator()
-        {
-            remove_all();
-        }
-
-        block_allocator(unsigned block_size, unsigned block_ptr_inc=256-8) :
-            m_block_size(block_size),
-            m_block_ptr_inc(block_ptr_inc),
-            m_num_blocks(0),
-            m_max_blocks(0),
-            m_blocks(0),
-            m_buf_ptr(0),
-            m_rest(0)
-        {
-        }
-       
-
-        int8u* allocate(unsigned size, unsigned alignment=1)
-        {
-            if(size == 0) return 0;
-            if(size <= m_rest)
-            {
-                int8u* ptr = m_buf_ptr;
-                if(alignment > 1)
-                {
-                    unsigned align = 
-                        (alignment - unsigned((size_t)ptr) % alignment) % alignment;
-
-                    size += align;
-                    ptr += align;
-                    if(size <= m_rest)
-                    {
-                        m_rest -= size;
-                        m_buf_ptr += size;
-                        return ptr;
-                    }
-                    allocate_block(size);
-                    return allocate(size - align, alignment);
-                }
-                m_rest -= size;
-                m_buf_ptr += size;
-                return ptr;
-            }
-            allocate_block(size + alignment - 1);
-            return allocate(size, alignment);
-        }
-
-
-    private:
-        void allocate_block(unsigned size)
-        {
-            if(size < m_block_size) size = m_block_size;
-            if(m_num_blocks >= m_max_blocks) 
-            {
-                block_type* new_blocks = 
-                    pod_allocator<block_type>::allocate(m_max_blocks + m_block_ptr_inc);
-
-                if(m_blocks)
-                {
-                    memcpy(new_blocks, 
-                           m_blocks, 
-                           m_num_blocks * sizeof(block_type));
-                    pod_allocator<block_type>::deallocate(m_blocks, m_max_blocks);
-                }
-                m_blocks = new_blocks;
-                m_max_blocks += m_block_ptr_inc;
-            }
-
-            m_blocks[m_num_blocks].size = size;
-            m_blocks[m_num_blocks].data = 
-                m_buf_ptr =
-                pod_allocator<int8u>::allocate(size);
-
-            m_num_blocks++;
-            m_rest = size;
-        }
-
-        unsigned    m_block_size;
-        unsigned    m_block_ptr_inc;
-        unsigned    m_num_blocks;
-        unsigned    m_max_blocks;
-        block_type* m_blocks;
-        int8u*      m_buf_ptr;
-        unsigned    m_rest;
-    };
-
-
-
-
-
-
-
-
-    //------------------------------------------------------------------------
-    enum quick_sort_threshold_e
-    {
-        quick_sort_threshold = 9
-    };
-
-    
-    //-----------------------------------------------------------swap_elements
-    template<class T> inline void swap_elements(T& a, T& b)
-    {
-        T temp = a;
-        a = b;
-        b = temp;
-    }
-
-
-    //--------------------------------------------------------------quick_sort
-    template<class Array, class Less>
-    void quick_sort(Array& arr, Less less)
-    {
-        if(arr.size() < 2) return;
-
-        typename Array::value_type* e1;
-        typename Array::value_type* e2;
-
-        int  stack[80];
-        int* top = stack; 
-        int  limit = arr.size();
-        int  base = 0;
-
-        for(;;)
-        {
-            int len = limit - base;
-
-            int i;
-            int j;
-            int pivot;
-
-            if(len > quick_sort_threshold)
-            {
-                // we use base + len/2 as the pivot
-                pivot = base + len / 2;
-                swap_elements(arr[base], arr[pivot]);
-
-                i = base + 1;
-                j = limit - 1;
-
-                // now ensure that *i <= *base <= *j 
-                e1 = &(arr[j]); 
-                e2 = &(arr[i]);
-                if(less(*e1, *e2)) swap_elements(*e1, *e2);
-
-                e1 = &(arr[base]); 
-                e2 = &(arr[i]);
-                if(less(*e1, *e2)) swap_elements(*e1, *e2);
-
-                e1 = &(arr[j]); 
-                e2 = &(arr[base]);
-                if(less(*e1, *e2)) swap_elements(*e1, *e2);
-
-                for(;;)
-                {
-                    do i++; while( less(arr[i], arr[base]) );
-                    do j--; while( less(arr[base], arr[j]) );
-
-                    if( i > j )
-                    {
-                        break;
-                    }
-
-                    swap_elements(arr[i], arr[j]);
-                }
-
-                swap_elements(arr[base], arr[j]);
-
-                // now, push the largest sub-array
-                if(j - base > limit - i)
-                {
-                    top[0] = base;
-                    top[1] = j;
-                    base   = i;
-                }
-                else
-                {
-                    top[0] = i;
-                    top[1] = limit;
-                    limit  = j;
-                }
-                top += 2;
-            }
-            else
-            {
-                // the sub-array is small, perform insertion sort
-                j = base;
-                i = j + 1;
-
-                for(; i < limit; j = i, i++)
-                {
-                    for(; less(*(e1 = &(arr[j + 1])), *(e2 = &(arr[j]))); j--)
-                    {
-                        swap_elements(*e1, *e2);
-                        if(j == base)
-                        {
-                            break;
-                        }
-                    }
-                }
-                if(top > stack)
-                {
-                    top  -= 2;
-                    base  = top[0];
-                    limit = top[1];
-                }
-                else
-                {
-                    break;
-                }
-            }
-        }
-    }
-
-
-
-
-    //------------------------------------------------------remove_duplicates
-    // Remove duplicates from a sorted array. It doesn't cut the 
-    // tail of the array, it just returns the number of remaining elements.
-    //-----------------------------------------------------------------------
-    template<class Array, class Equal>
-    unsigned remove_duplicates(Array& arr, Equal equal)
-    {
-        if(arr.size() < 2) return arr.size();
-
-        unsigned i, j;
-        for(i = 1, j = 1; i < arr.size(); i++)
-        {
-            typename Array::value_type& e = arr[i];
-            if(!equal(e, arr[i - 1]))
-            {
-                arr[j++] = e;
-            }
-        }
-        return j;
-    }
-
-    //--------------------------------------------------------invert_container
-    template<class Array> void invert_container(Array& arr)
-    {
-        int i = 0;
-        int j = arr.size() - 1;
-        while(i < j)
-        {
-            swap_elements(arr[i++], arr[j--]);
-        }
-    }
-
-    //------------------------------------------------------binary_search_pos
-    template<class Array, class Value, class Less>
-    unsigned binary_search_pos(const Array& arr, const Value& val, Less less)
-    {
-        if(arr.size() == 0) return 0;
-
-        unsigned beg = 0;
-        unsigned end = arr.size() - 1;
-
-        if(less(val, arr[0])) return 0;
-        if(less(arr[end], val)) return end + 1;
-
-        while(end - beg > 1)
-        {
-            unsigned mid = (end + beg) >> 1;
-            if(less(val, arr[mid])) end = mid; 
-            else                    beg = mid;
-        }
-
-        //if(beg <= 0 && less(val, arr[0])) return 0;
-        //if(end >= arr.size() - 1 && less(arr[end], val)) ++end;
-
-        return end;
-    }
-
-    //----------------------------------------------------------range_adaptor
-    template<class Array> class range_adaptor
-    {
-    public:
-        typedef typename Array::value_type value_type;
-
-        range_adaptor(Array& array, unsigned start, unsigned size) :
-            m_array(array), m_start(start), m_size(size)
-        {}
-
-        unsigned size() const { return m_size; }
-        const value_type& operator [] (unsigned i) const { return m_array[m_start + i]; }
-              value_type& operator [] (unsigned i)       { return m_array[m_start + i]; }
-        const value_type& at(unsigned i) const           { return m_array[m_start + i]; }
-              value_type& at(unsigned i)                 { return m_array[m_start + i]; }
-        value_type  value_at(unsigned i) const           { return m_array[m_start + i]; }
-
-    private:
-        Array& m_array;
-        unsigned m_start;
-        unsigned m_size;
-    };
-
-    //---------------------------------------------------------------int_less
-    inline bool int_less(int a, int b) { return a < b; }
-
-    //------------------------------------------------------------int_greater
-    inline bool int_greater(int a, int b) { return a > b; }
-
-    //----------------------------------------------------------unsigned_less
-    inline bool unsigned_less(unsigned a, unsigned b) { return a < b; }
-
-    //-------------------------------------------------------unsigned_greater
-    inline bool unsigned_greater(unsigned a, unsigned b) { return a > b; }
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_arrowhead.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_arrowhead.h
--- 8.0.1-5/renderers/agg/include/agg_arrowhead.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_arrowhead.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,82 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Simple arrowhead/arrowtail generator 
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_ARROWHEAD_INCLUDED
-#define AGG_ARROWHEAD_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //===============================================================arrowhead
-    //
-    // See implementation agg_arrowhead.cpp 
-    //
-    class arrowhead
-    {
-    public:
-        arrowhead();
-
-        void head(double d1, double d2, double d3, double d4)
-        {
-            m_head_d1 = d1;
-            m_head_d2 = d2;
-            m_head_d3 = d3;
-            m_head_d4 = d4;
-            m_head_flag = true;
-        }
-
-        void head()    { m_head_flag = true; }
-        void no_head() { m_head_flag = false; }
-
-        void tail(double d1, double d2, double d3, double d4)
-        {
-            m_tail_d1 = d1;
-            m_tail_d2 = d2;
-            m_tail_d3 = d3;
-            m_tail_d4 = d4;
-            m_tail_flag = true;
-        }
-
-        void tail()    { m_tail_flag = true;  }
-        void no_tail() { m_tail_flag = false; }
-
-        void rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        double   m_head_d1;
-        double   m_head_d2;
-        double   m_head_d3;
-        double   m_head_d4;
-        double   m_tail_d1;
-        double   m_tail_d2;
-        double   m_tail_d3;
-        double   m_tail_d4;
-        bool     m_head_flag;
-        bool     m_tail_flag;
-        double   m_coord[16];
-        unsigned m_cmd[8];
-        unsigned m_curr_id;
-        unsigned m_curr_coord;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_basics.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_basics.h
--- 8.0.1-5/renderers/agg/include/agg_basics.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_basics.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,538 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_BASICS_INCLUDED
-#define AGG_BASICS_INCLUDED
-
-#include <math.h>
-#include "agg_config.h"
-
-//---------------------------------------------------------AGG_CUSTOM_ALLOCATOR
-#ifdef AGG_CUSTOM_ALLOCATOR
-#include "agg_allocator.h"
-#else
-namespace mapserver
-{
-    // The policy of all AGG containers and memory allocation strategy 
-    // in general is that no allocated data requires explicit construction.
-    // It means that the allocator can be really simple; you can even
-    // replace new/delete to malloc/free. The constructors and destructors 
-    // won't be called in this case, however everything will remain working. 
-    // The second argument of deallocate() is the size of the allocated 
-    // block. You can use this information if you wish.
-    //------------------------------------------------------------pod_allocator
-    template<class T> struct pod_allocator
-    {
-        static T*   allocate(unsigned num)       { return new T [num]; }
-        static void deallocate(T* ptr, unsigned) { delete [] ptr;      }
-    };
-
-    // Single object allocator. It's also can be replaced with your custom
-    // allocator. The difference is that it can only allocate a single 
-    // object and the constructor and destructor must be called. 
-    // In AGG there is no need to allocate an array of objects with
-    // calling their constructors (only single ones). So that, if you
-    // replace these new/delete to malloc/free make sure that the in-place
-    // new is called and take care of calling the destructor too.
-    //------------------------------------------------------------obj_allocator
-    template<class T> struct obj_allocator
-    {
-        static T*   allocate()         { return new T; }
-        static void deallocate(T* ptr) { delete ptr;   }
-    };
-}
-#endif
-
-
-//-------------------------------------------------------- Default basic types
-//
-// If the compiler has different capacity of the basic types you can redefine
-// them via the compiler command line or by generating agg_config.h that is
-// empty by default.
-//
-#ifndef AGG_INT8
-#define AGG_INT8 signed char
-#endif
-
-#ifndef AGG_INT8U
-#define AGG_INT8U unsigned char
-#endif
-
-#ifndef AGG_INT16
-#define AGG_INT16 short
-#endif
-
-#ifndef AGG_INT16U
-#define AGG_INT16U unsigned short
-#endif
-
-#ifndef AGG_INT32
-#define AGG_INT32 int
-#endif
-
-#ifndef AGG_INT32U
-#define AGG_INT32U unsigned
-#endif
-
-#ifndef AGG_INT64
-#if defined(_MSC_VER) || defined(__BORLANDC__)
-#define AGG_INT64 signed __int64
-#define AGG_INT64_FRMT "%I64d"
-#else
-#define AGG_INT64 signed long long
-#define AGG_INT64_FRMT "%lld"
-#endif
-#endif
-
-#ifndef AGG_INT64U
-#if defined(_MSC_VER) || defined(__BORLANDC__)
-#define AGG_INT64U unsigned __int64
-#define AGG_INT64U_FRMT "%I64u"
-#else
-#define AGG_INT64U unsigned long long
-#define AGG_INT64U_FRMT "%llu"
-#endif
-#endif
-
-//------------------------------------------------ Some fixes for MS Visual C++
-#if defined(_MSC_VER)
-#pragma warning(disable:4786) // Identifier was truncated...
-#endif
-
-#if defined(_MSC_VER)
-#define AGG_INLINE __forceinline
-#else
-#define AGG_INLINE inline
-#endif
-
-namespace mapserver
-{
-    //-------------------------------------------------------------------------
-    typedef AGG_INT8   int8;         //----int8
-    typedef AGG_INT8U  int8u;        //----int8u
-    typedef AGG_INT16  int16;        //----int16
-    typedef AGG_INT16U int16u;       //----int16u
-    typedef AGG_INT32  int32;        //----int32
-    typedef AGG_INT32U int32u;       //----int32u
-    typedef AGG_INT64  int64;        //----int64
-    typedef AGG_INT64U int64u;       //----int64u
-
-#if defined(AGG_FISTP)
-#pragma warning(push)
-#pragma warning(disable : 4035) //Disable warning "no return value"
-    AGG_INLINE int iround(double v)              //-------iround
-    {
-        int t;
-        __asm fld   qword ptr [v]
-        __asm fistp dword ptr [t]
-        __asm mov eax, dword ptr [t]
-    }
-    AGG_INLINE unsigned uround(double v)         //-------uround
-    {
-        unsigned t;
-        __asm fld   qword ptr [v]
-        __asm fistp dword ptr [t]
-        __asm mov eax, dword ptr [t]
-    }
-#pragma warning(pop)
-    AGG_INLINE unsigned ufloor(double v)         //-------ufloor
-    {
-        return unsigned(floor(v));
-    }
-    AGG_INLINE unsigned uceil(double v)          //--------uceil
-    {
-        return unsigned(ceil(v));
-    }
-#elif defined(AGG_QIFIST)
-    AGG_INLINE int iround(double v)
-    {
-        return int(v);
-    }
-    AGG_INLINE int uround(double v)
-    {
-        return unsigned(v);
-    }
-    AGG_INLINE unsigned ufloor(double v)
-    {
-        return unsigned(floor(v));
-    }
-    AGG_INLINE unsigned uceil(double v)
-    {
-        return unsigned(ceil(v));
-    }
-#else
-    AGG_INLINE int iround(double v)
-    {
-#ifdef HAVE_LRINT
-        return lrint(v);
-#else
-        return int((v < 0.0) ? v - 0.5 : v + 0.5);
-#endif
-    }
-    AGG_INLINE int uround(double v)
-    {
-        return unsigned(v + 0.5);
-    }
-    AGG_INLINE unsigned ufloor(double v)
-    {
-        return unsigned(v);
-    }
-    AGG_INLINE unsigned uceil(double v)
-    {
-        return unsigned(ceil(v));
-    }
-#endif
-
-    //---------------------------------------------------------------saturation
-    template<int Limit> struct saturation
-    {
-        AGG_INLINE static int iround(double v)
-        {
-            if(v < double(-Limit)) return -Limit;
-            if(v > double( Limit)) return  Limit;
-            return mapserver::iround(v);
-        }
-    };
-
-    //------------------------------------------------------------------mul_one
-    template<unsigned Shift> struct mul_one
-    {
-        AGG_INLINE static unsigned mul(unsigned a, unsigned b)
-        {
-            const unsigned q = a * b + (1 << (Shift-1));
-            return (q + (q >> Shift)) >> Shift;
-        }
-    };
-
-    //-------------------------------------------------------------------------
-    typedef unsigned char cover_type;    //----cover_type
-    enum cover_scale_e
-    {
-        cover_shift = 8,                 //----cover_shift
-        cover_size  = 1 << cover_shift,  //----cover_size 
-        cover_mask  = cover_size - 1,    //----cover_mask 
-        cover_none  = 0,                 //----cover_none 
-        cover_full  = cover_mask         //----cover_full 
-    };
-
-    //----------------------------------------------------poly_subpixel_scale_e
-    // These constants determine the subpixel accuracy, to be more precise, 
-    // the number of bits of the fractional part of the coordinates. 
-    // The possible coordinate capacity in bits can be calculated by formula:
-    // sizeof(int) * 8 - poly_subpixel_shift, i.e, for 32-bit integers and
-    // 8-bits fractional part the capacity is 24 bits.
-    enum poly_subpixel_scale_e
-    {
-        poly_subpixel_shift = 8,                      //----poly_subpixel_shift
-        poly_subpixel_scale = 1<<poly_subpixel_shift, //----poly_subpixel_scale 
-        poly_subpixel_mask  = poly_subpixel_scale-1,  //----poly_subpixel_mask 
-    };
-
-    //----------------------------------------------------------filling_rule_e
-    enum filling_rule_e
-    {
-        fill_non_zero,
-        fill_even_odd
-    };
-
-    //-----------------------------------------------------------------------pi
-    const double pi = 3.14159265358979323846;
-
-    //------------------------------------------------------------------deg2rad
-    inline double deg2rad(double deg)
-    {
-        return deg * pi / 180.0;
-    }
-
-    //------------------------------------------------------------------rad2deg
-    inline double rad2deg(double rad)
-    {
-        return rad * 180.0 / pi;
-    }
- 
-    //----------------------------------------------------------------rect_base
-    template<class T> struct rect_base
-    {
-        typedef T            value_type;
-        typedef rect_base<T> self_type;
-        T x1, y1, x2, y2;
-
-        rect_base() {}
-        rect_base(T x1_, T y1_, T x2_, T y2_) :
-            x1(x1_), y1(y1_), x2(x2_), y2(y2_) {}
-
-        void init(T x1_, T y1_, T x2_, T y2_) 
-        {
-            x1 = x1_; y1 = y1_; x2 = x2_; y2 = y2_; 
-        }
-
-        const self_type& normalize()
-        {
-            T t;
-            if(x1 > x2) { t = x1; x1 = x2; x2 = t; }
-            if(y1 > y2) { t = y1; y1 = y2; y2 = t; }
-            return *this;
-        }
-
-        bool clip(const self_type& r)
-        {
-            if(x2 > r.x2) x2 = r.x2;
-            if(y2 > r.y2) y2 = r.y2;
-            if(x1 < r.x1) x1 = r.x1;
-            if(y1 < r.y1) y1 = r.y1;
-            return x1 <= x2 && y1 <= y2;
-        }
-
-        bool is_valid() const
-        {
-            return x1 <= x2 && y1 <= y2;
-        }
-
-        bool hit_test(T x, T y) const
-        {
-            return (x >= x1 && x <= x2 && y >= y1 && y <= y2);
-        }
-    };
-
-    //-----------------------------------------------------intersect_rectangles
-    template<class Rect> 
-    inline Rect intersect_rectangles(const Rect& r1, const Rect& r2)
-    {
-        Rect r = r1;
-
-        // First process x2,y2 because the other order 
-        // results in Internal Compiler Error under 
-        // Microsoft Visual C++ .NET 2003 69462-335-0000007-18038 in 
-        // case of "Maximize Speed" optimization option.
-        //-----------------
-        if(r.x2 > r2.x2) r.x2 = r2.x2; 
-        if(r.y2 > r2.y2) r.y2 = r2.y2;
-        if(r.x1 < r2.x1) r.x1 = r2.x1;
-        if(r.y1 < r2.y1) r.y1 = r2.y1;
-        return r;
-    }
-
-
-    //---------------------------------------------------------unite_rectangles
-    template<class Rect> 
-    inline Rect unite_rectangles(const Rect& r1, const Rect& r2)
-    {
-        Rect r = r1;
-        if(r.x2 < r2.x2) r.x2 = r2.x2;
-        if(r.y2 < r2.y2) r.y2 = r2.y2;
-        if(r.x1 > r2.x1) r.x1 = r2.x1;
-        if(r.y1 > r2.y1) r.y1 = r2.y1;
-        return r;
-    }
-
-    typedef rect_base<int>    rect_i; //----rect_i
-    typedef rect_base<float>  rect_f; //----rect_f
-    typedef rect_base<double> rect_d; //----rect_d
-
-    //---------------------------------------------------------path_commands_e
-    enum path_commands_e
-    {
-        path_cmd_stop     = 0,        //----path_cmd_stop    
-        path_cmd_move_to  = 1,        //----path_cmd_move_to 
-        path_cmd_line_to  = 2,        //----path_cmd_line_to 
-        path_cmd_curve3   = 3,        //----path_cmd_curve3  
-        path_cmd_curve4   = 4,        //----path_cmd_curve4  
-        path_cmd_curveN   = 5,        //----path_cmd_curveN
-        path_cmd_catrom   = 6,        //----path_cmd_catrom
-        path_cmd_ubspline = 7,        //----path_cmd_ubspline
-        path_cmd_end_poly = 0x0F,     //----path_cmd_end_poly
-        path_cmd_mask     = 0x0F      //----path_cmd_mask    
-    };
-
-    //------------------------------------------------------------path_flags_e
-    enum path_flags_e
-    {
-        path_flags_none  = 0,         //----path_flags_none 
-        path_flags_ccw   = 0x10,      //----path_flags_ccw  
-        path_flags_cw    = 0x20,      //----path_flags_cw   
-        path_flags_close = 0x40,      //----path_flags_close
-        path_flags_mask  = 0xF0       //----path_flags_mask 
-    };
-
-    //---------------------------------------------------------------is_vertex
-    inline bool is_vertex(unsigned c)
-    {
-        return c >= path_cmd_move_to && c < path_cmd_end_poly;
-    }
-
-    //--------------------------------------------------------------is_drawing
-    inline bool is_drawing(unsigned c)
-    {
-        return c >= path_cmd_line_to && c < path_cmd_end_poly;
-    }
-
-    //-----------------------------------------------------------------is_stop
-    inline bool is_stop(unsigned c)
-    { 
-        return c == path_cmd_stop;
-    }
-
-    //--------------------------------------------------------------is_move_to
-    inline bool is_move_to(unsigned c)
-    {
-        return c == path_cmd_move_to;
-    }
-
-    //--------------------------------------------------------------is_line_to
-    inline bool is_line_to(unsigned c)
-    {
-        return c == path_cmd_line_to;
-    }
-
-    //----------------------------------------------------------------is_curve
-    inline bool is_curve(unsigned c)
-    {
-        return c == path_cmd_curve3 || c == path_cmd_curve4;
-    }
-
-    //---------------------------------------------------------------is_curve3
-    inline bool is_curve3(unsigned c)
-    {
-        return c == path_cmd_curve3;
-    }
-
-    //---------------------------------------------------------------is_curve4
-    inline bool is_curve4(unsigned c)
-    {
-        return c == path_cmd_curve4;
-    }
-
-    //-------------------------------------------------------------is_end_poly
-    inline bool is_end_poly(unsigned c)
-    {
-        return (c & path_cmd_mask) == path_cmd_end_poly;
-    }
-
-    //----------------------------------------------------------------is_close
-    inline bool is_close(unsigned c)
-    {
-        return (c & ~(path_flags_cw | path_flags_ccw)) ==
-               (path_cmd_end_poly | path_flags_close); 
-    }
-
-    //------------------------------------------------------------is_next_poly
-    inline bool is_next_poly(unsigned c)
-    {
-        return is_stop(c) || is_move_to(c) || is_end_poly(c);
-    }
-
-    //-------------------------------------------------------------------is_cw
-    inline bool is_cw(unsigned c)
-    {
-        return (c & path_flags_cw) != 0;
-    }
-
-    //------------------------------------------------------------------is_ccw
-    inline bool is_ccw(unsigned c)
-    {
-        return (c & path_flags_ccw) != 0;
-    }
-
-    //-------------------------------------------------------------is_oriented
-    inline bool is_oriented(unsigned c)
-    {
-        return (c & (path_flags_cw | path_flags_ccw)) != 0; 
-    }
-
-    //---------------------------------------------------------------is_closed
-    inline bool is_closed(unsigned c)
-    {
-        return (c & path_flags_close) != 0; 
-    }
-
-    //----------------------------------------------------------get_close_flag
-    inline unsigned get_close_flag(unsigned c)
-    {
-        return c & path_flags_close; 
-    }
-
-    //-------------------------------------------------------clear_orientation
-    inline unsigned clear_orientation(unsigned c)
-    {
-        return c & ~(path_flags_cw | path_flags_ccw);
-    }
-
-    //---------------------------------------------------------get_orientation
-    inline unsigned get_orientation(unsigned c)
-    {
-        return c & (path_flags_cw | path_flags_ccw);
-    }
-
-    //---------------------------------------------------------set_orientation
-    inline unsigned set_orientation(unsigned c, unsigned o)
-    {
-        return clear_orientation(c) | o;
-    }
-
-    //--------------------------------------------------------------point_base
-    template<class T> struct point_base
-    {
-        typedef T value_type;
-        T x = 0,y = 0;
-        point_base() = default;
-        point_base(T x_, T y_) : x(x_), y(y_) {}
-    };
-    typedef point_base<int>    point_i; //-----point_i
-    typedef point_base<float>  point_f; //-----point_f
-    typedef point_base<double> point_d; //-----point_d
-
-    //-------------------------------------------------------------vertex_base
-    template<class T> struct vertex_base
-    {
-        typedef T value_type;
-        T x,y;
-        unsigned cmd;
-        vertex_base() {}
-        vertex_base(T x_, T y_, unsigned cmd_) : x(x_), y(y_), cmd(cmd_) {}
-    };
-    typedef vertex_base<int>    vertex_i; //-----vertex_i
-    typedef vertex_base<float>  vertex_f; //-----vertex_f
-    typedef vertex_base<double> vertex_d; //-----vertex_d
-
-    //----------------------------------------------------------------row_info
-    template<class T> struct row_info
-    {
-        int x1, x2;
-        T* ptr;
-        row_info() {}
-        row_info(int x1_, int x2_, T* ptr_) : x1(x1_), x2(x2_), ptr(ptr_) {}
-    };
-
-    //----------------------------------------------------------const_row_info
-    template<class T> struct const_row_info
-    {
-        int x1, x2;
-        const T* ptr;
-        const_row_info() {}
-        const_row_info(int x1_, int x2_, const T* ptr_) : 
-            x1(x1_), x2(x2_), ptr(ptr_) {}
-    };
-
-    //------------------------------------------------------------is_equal_eps
-    template<class T> inline bool is_equal_eps(T v1, T v2, T epsilon)
-    {
-        return fabs(v1 - v2) <= double(epsilon);
-    }
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_bezier_arc.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bezier_arc.h
--- 8.0.1-5/renderers/agg/include/agg_bezier_arc.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bezier_arc.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,159 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Arc generator. Produces at most 4 consecutive cubic bezier curves, i.e., 
-// 4, 7, 10, or 13 vertices.
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_BEZIER_ARC_INCLUDED
-#define AGG_BEZIER_ARC_INCLUDED
-
-#include "agg_conv_transform.h"
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------------------------
-    void arc_to_bezier(double cx, double cy, double rx, double ry, 
-                       double start_angle, double sweep_angle,
-                       double* curve);
-
-
-    //==============================================================bezier_arc
-    // 
-    // See implemantaion agg_bezier_arc.cpp
-    //
-    class bezier_arc
-    {
-    public:
-        //--------------------------------------------------------------------
-        bezier_arc() : m_vertex(26), m_num_vertices(0), m_cmd(path_cmd_line_to) {}
-        bezier_arc(double x,  double y, 
-                   double rx, double ry, 
-                   double start_angle, 
-                   double sweep_angle)
-        {
-            init(x, y, rx, ry, start_angle, sweep_angle);
-        }
-
-        //--------------------------------------------------------------------
-        void init(double x,  double y, 
-                  double rx, double ry, 
-                  double start_angle, 
-                  double sweep_angle);
-
-        //--------------------------------------------------------------------
-        void rewind(unsigned)
-        {
-            m_vertex = 0;
-        }
-
-        //--------------------------------------------------------------------
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_vertex >= m_num_vertices) return path_cmd_stop;
-            *x = m_vertices[m_vertex];
-            *y = m_vertices[m_vertex + 1];
-            m_vertex += 2;
-            return (m_vertex == 2) ? (unsigned)path_cmd_move_to : m_cmd;
-        }
-
-        // Supplemantary functions. num_vertices() actually returns doubled 
-        // number of vertices. That is, for 1 vertex it returns 2.
-        //--------------------------------------------------------------------
-        unsigned  num_vertices() const { return m_num_vertices; }
-        const double* vertices() const { return m_vertices;     }
-        double*       vertices()       { return m_vertices;     }
- 
-    private:
-        unsigned m_vertex;
-        unsigned m_num_vertices;
-        double   m_vertices[26];
-        unsigned m_cmd;
-    };
-
-
-
-    //==========================================================bezier_arc_svg
-    // Compute an SVG-style bezier arc. 
-    //
-    // Computes an elliptical arc from (x1, y1) to (x2, y2). The size and 
-    // orientation of the ellipse are defined by two radii (rx, ry) 
-    // and an x-axis-rotation, which indicates how the ellipse as a whole 
-    // is rotated relative to the current coordinate system. The center 
-    // (cx, cy) of the ellipse is calculated automatically to satisfy the 
-    // constraints imposed by the other parameters. 
-    // large-arc-flag and sweep-flag contribute to the automatic calculations 
-    // and help determine how the arc is drawn.
-    class bezier_arc_svg
-    {
-    public:
-        //--------------------------------------------------------------------
-        bezier_arc_svg() : m_arc(), m_radii_ok(false) {}
-
-        bezier_arc_svg(double x1, double y1, 
-                       double rx, double ry, 
-                       double angle,
-                       bool large_arc_flag,
-                       bool sweep_flag,
-                       double x2, double y2) : 
-            m_arc(), m_radii_ok(false)
-        {
-            init(x1, y1, rx, ry, angle, large_arc_flag, sweep_flag, x2, y2);
-        }
-
-        //--------------------------------------------------------------------
-        void init(double x1, double y1, 
-                  double rx, double ry, 
-                  double angle,
-                  bool large_arc_flag,
-                  bool sweep_flag,
-                  double x2, double y2);
-
-        //--------------------------------------------------------------------
-        bool radii_ok() const { return m_radii_ok; }
-
-        //--------------------------------------------------------------------
-        void rewind(unsigned)
-        {
-            m_arc.rewind(0);
-        }
-
-        //--------------------------------------------------------------------
-        unsigned vertex(double* x, double* y)
-        {
-            return m_arc.vertex(x, y);
-        }
-
-        // Supplemantary functions. num_vertices() actually returns doubled 
-        // number of vertices. That is, for 1 vertex it returns 2.
-        //--------------------------------------------------------------------
-        unsigned  num_vertices() const { return m_arc.num_vertices(); }
-        const double* vertices() const { return m_arc.vertices();     }
-        double*       vertices()       { return m_arc.vertices();     }
-
-    private:
-        bezier_arc m_arc;
-        bool       m_radii_ok;
-    };
-
-
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_bitset_iterator.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bitset_iterator.h
--- 8.0.1-5/renderers/agg/include/agg_bitset_iterator.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bitset_iterator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,54 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_BITSET_ITERATOR_INCLUDED
-#define AGG_BITSET_ITERATOR_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    
-    class bitset_iterator
-    {
-    public:
-        bitset_iterator(const int8u* bits, unsigned offset = 0) :
-            m_bits(bits + (offset >> 3)),
-            m_mask(0x80 >> (offset & 7))
-        {}
-
-        void operator ++ ()
-        {
-            m_mask >>= 1;
-            if(m_mask == 0)
-            {
-                ++m_bits;
-                m_mask = 0x80;
-            }
-        }
-
-        unsigned bit() const
-        {
-            return (*m_bits) & m_mask;
-        }
-
-    private:
-        const int8u* m_bits;
-        int8u        m_mask;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_blur.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_blur.h
--- 8.0.1-5/renderers/agg/include/agg_blur.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_blur.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1294 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// The Stack Blur Algorithm was invented by Mario Klingemann, 
-// mario@quasimondo.com and described here:
-// http://incubator.quasimondo.com/processing/fast_blur_deluxe.php
-// (search phrase "Stackblur: Fast But Goodlooking"). 
-// The major improvement is that there's no more division table
-// that was very expensive to create for large blur radii. Insted, 
-// for 8-bit per channel and radius not exceeding 254 the division is 
-// replaced by multiplication and shift. 
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_BLUR_INCLUDED
-#define AGG_BLUR_INCLUDED
-
-#include "agg_array.h"
-#include "agg_pixfmt_transposer.h"
-
-namespace mapserver
-{
-
-    template<class T> struct stack_blur_tables
-    {
-        static int16u const g_stack_blur8_mul[255];
-        static int8u  const g_stack_blur8_shr[255];
-    };
-
-    //------------------------------------------------------------------------
-    template<class T> 
-    int16u const stack_blur_tables<T>::g_stack_blur8_mul[255] = 
-    {
-        512,512,456,512,328,456,335,512,405,328,271,456,388,335,292,512,
-        454,405,364,328,298,271,496,456,420,388,360,335,312,292,273,512,
-        482,454,428,405,383,364,345,328,312,298,284,271,259,496,475,456,
-        437,420,404,388,374,360,347,335,323,312,302,292,282,273,265,512,
-        497,482,468,454,441,428,417,405,394,383,373,364,354,345,337,328,
-        320,312,305,298,291,284,278,271,265,259,507,496,485,475,465,456,
-        446,437,428,420,412,404,396,388,381,374,367,360,354,347,341,335,
-        329,323,318,312,307,302,297,292,287,282,278,273,269,265,261,512,
-        505,497,489,482,475,468,461,454,447,441,435,428,422,417,411,405,
-        399,394,389,383,378,373,368,364,359,354,350,345,341,337,332,328,
-        324,320,316,312,309,305,301,298,294,291,287,284,281,278,274,271,
-        268,265,262,259,257,507,501,496,491,485,480,475,470,465,460,456,
-        451,446,442,437,433,428,424,420,416,412,408,404,400,396,392,388,
-        385,381,377,374,370,367,363,360,357,354,350,347,344,341,338,335,
-        332,329,326,323,320,318,315,312,310,307,304,302,299,297,294,292,
-        289,287,285,282,280,278,275,273,271,269,267,265,263,261,259
-    };
-
-    //------------------------------------------------------------------------
-    template<class T> 
-    int8u const stack_blur_tables<T>::g_stack_blur8_shr[255] = 
-    {
-          9, 11, 12, 13, 13, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 17, 
-         17, 17, 17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 18, 19, 
-         19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20, 20, 20,
-         20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 21,
-         21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
-         21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 22, 22, 22, 22, 22, 22, 
-         22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
-         22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 23, 
-         23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
-         23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
-         23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 
-         23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 
-         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
-         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
-         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
-         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24
-    };
-
-
-
-    //==============================================================stack_blur
-    template<class ColorT, class CalculatorT> class stack_blur
-    {
-    public:
-        typedef ColorT      color_type;
-        typedef CalculatorT calculator_type;
-
-        //--------------------------------------------------------------------
-        template<class Img> void blur_x(Img& img, unsigned radius)
-        {
-            if(radius < 1) return;
-
-            unsigned x, y, xp, i;
-            unsigned stack_ptr;
-            unsigned stack_start;
-
-            color_type      pix;
-            color_type*     stack_pix;
-            calculator_type sum;
-            calculator_type sum_in;
-            calculator_type sum_out;
-
-            unsigned w   = img.width();
-            unsigned h   = img.height();
-            unsigned wm  = w - 1;
-            unsigned div = radius * 2 + 1;
-
-            unsigned div_sum = (radius + 1) * (radius + 1);
-            unsigned mul_sum = 0;
-            unsigned shr_sum = 0;
-            unsigned max_val = color_type::base_mask;
-
-            if(max_val <= 255 && radius < 255)
-            {
-                mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[radius];
-                shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[radius];
-            }
-
-            m_buf.allocate(w, 128);
-            m_stack.allocate(div, 32);
-
-            for(y = 0; y < h; y++)
-            {
-                sum.clear();
-                sum_in.clear();
-                sum_out.clear();
-
-                pix = img.pixel(0, y);
-                for(i = 0; i <= radius; i++)
-                {
-                    m_stack[i] = pix;
-                    sum.add(pix, i + 1);
-                    sum_out.add(pix);
-                }
-                for(i = 1; i <= radius; i++)
-                {
-                    pix = img.pixel((i > wm) ? wm : i, y);
-                    m_stack[i + radius] = pix;
-                    sum.add(pix, radius + 1 - i);
-                    sum_in.add(pix);
-                }
-
-                stack_ptr = radius;
-                for(x = 0; x < w; x++)
-                {
-                    if(mul_sum) sum.calc_pix(m_buf[x], mul_sum, shr_sum);
-                    else        sum.calc_pix(m_buf[x], div_sum);
-
-                    sum.sub(sum_out);
-           
-                    stack_start = stack_ptr + div - radius;
-                    if(stack_start >= div) stack_start -= div;
-                    stack_pix = &m_stack[stack_start];
-
-                    sum_out.sub(*stack_pix);
-
-                    xp = x + radius + 1;
-                    if(xp > wm) xp = wm;
-                    pix = img.pixel(xp, y);
-            
-                    *stack_pix = pix;
-            
-                    sum_in.add(pix);
-                    sum.add(sum_in);
-            
-                    ++stack_ptr;
-                    if(stack_ptr >= div) stack_ptr = 0;
-                    stack_pix = &m_stack[stack_ptr];
-
-                    sum_out.add(*stack_pix);
-                    sum_in.sub(*stack_pix);
-                }
-                img.copy_color_hspan(0, y, w, &m_buf[0]);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class Img> void blur_y(Img& img, unsigned radius)
-        {
-            pixfmt_transposer<Img> img2(img);
-            blur_x(img2, radius);
-        }
-
-        //--------------------------------------------------------------------
-        template<class Img> void blur(Img& img, unsigned radius)
-        {
-            blur_x(img, radius);
-            pixfmt_transposer<Img> img2(img);
-            blur_x(img2, radius);
-        }
-
-    private:
-        pod_vector<color_type> m_buf;
-        pod_vector<color_type> m_stack;
-    };
-
-    //====================================================stack_blur_calc_rgba
-    template<class T=unsigned> struct stack_blur_calc_rgba
-    {
-        typedef T value_type;
-        value_type r,g,b,a;
-
-        AGG_INLINE void clear() 
-        { 
-            r = g = b = a = 0; 
-        }
-
-        template<class ArgT> AGG_INLINE void add(const ArgT& v)
-        {
-            r += v.r;
-            g += v.g;
-            b += v.b;
-            a += v.a;
-        }
-
-        template<class ArgT> AGG_INLINE void add(const ArgT& v, unsigned k)
-        {
-            r += v.r * k;
-            g += v.g * k;
-            b += v.b * k;
-            a += v.a * k;
-        }
-
-        template<class ArgT> AGG_INLINE void sub(const ArgT& v)
-        {
-            r -= v.r;
-            g -= v.g;
-            b -= v.b;
-            a -= v.a;
-        }
-
-        template<class ArgT> AGG_INLINE void calc_pix(ArgT& v, unsigned div)
-        {
-            typedef typename ArgT::value_type value_type;
-            v.r = value_type(r / div);
-            v.g = value_type(g / div);
-            v.b = value_type(b / div);
-            v.a = value_type(a / div);
-        }
-
-        template<class ArgT> 
-        AGG_INLINE void calc_pix(ArgT& v, unsigned mul, unsigned shr)
-        {
-            typedef typename ArgT::value_type value_type;
-            v.r = value_type((r * mul) >> shr);
-            v.g = value_type((g * mul) >> shr);
-            v.b = value_type((b * mul) >> shr);
-            v.a = value_type((a * mul) >> shr);
-        }
-    };
-
-
-    //=====================================================stack_blur_calc_rgb
-    template<class T=unsigned> struct stack_blur_calc_rgb
-    {
-        typedef T value_type;
-        value_type r,g,b;
-
-        AGG_INLINE void clear() 
-        { 
-            r = g = b = 0; 
-        }
-
-        template<class ArgT> AGG_INLINE void add(const ArgT& v)
-        {
-            r += v.r;
-            g += v.g;
-            b += v.b;
-        }
-
-        template<class ArgT> AGG_INLINE void add(const ArgT& v, unsigned k)
-        {
-            r += v.r * k;
-            g += v.g * k;
-            b += v.b * k;
-        }
-
-        template<class ArgT> AGG_INLINE void sub(const ArgT& v)
-        {
-            r -= v.r;
-            g -= v.g;
-            b -= v.b;
-        }
-
-        template<class ArgT> AGG_INLINE void calc_pix(ArgT& v, unsigned div)
-        {
-            typedef typename ArgT::value_type value_type;
-            v.r = value_type(r / div);
-            v.g = value_type(g / div);
-            v.b = value_type(b / div);
-        }
-
-        template<class ArgT> 
-        AGG_INLINE void calc_pix(ArgT& v, unsigned mul, unsigned shr)
-        {
-            typedef typename ArgT::value_type value_type;
-            v.r = value_type((r * mul) >> shr);
-            v.g = value_type((g * mul) >> shr);
-            v.b = value_type((b * mul) >> shr);
-        }
-    };
-
-
-    //====================================================stack_blur_calc_gray
-    template<class T=unsigned> struct stack_blur_calc_gray
-    {
-        typedef T value_type;
-        value_type v;
-
-        AGG_INLINE void clear() 
-        { 
-            v = 0; 
-        }
-
-        template<class ArgT> AGG_INLINE void add(const ArgT& a)
-        {
-            v += a.v;
-        }
-
-        template<class ArgT> AGG_INLINE void add(const ArgT& a, unsigned k)
-        {
-            v += a.v * k;
-        }
-
-        template<class ArgT> AGG_INLINE void sub(const ArgT& a)
-        {
-            v -= a.v;
-        }
-
-        template<class ArgT> AGG_INLINE void calc_pix(ArgT& a, unsigned div)
-        {
-            typedef typename ArgT::value_type value_type;
-            a.v = value_type(v / div);
-        }
-
-        template<class ArgT> 
-        AGG_INLINE void calc_pix(ArgT& a, unsigned mul, unsigned shr)
-        {
-            typedef typename ArgT::value_type value_type;
-            a.v = value_type((v * mul) >> shr);
-        }
-    };
-
-
-
-    //========================================================stack_blur_gray8
-    template<class Img> 
-    void stack_blur_gray8(Img& img, unsigned rx, unsigned ry)
-    {
-        unsigned x, y, xp, yp, i;
-        unsigned stack_ptr;
-        unsigned stack_start;
-
-        const int8u* src_pix_ptr;
-              int8u* dst_pix_ptr;
-        unsigned pix;
-        unsigned stack_pix;
-        unsigned sum;
-        unsigned sum_in;
-        unsigned sum_out;
-
-        unsigned w   = img.width();
-        unsigned h   = img.height();
-        unsigned wm  = w - 1;
-        unsigned hm  = h - 1;
-
-        unsigned div;
-        unsigned mul_sum;
-        unsigned shr_sum;
-
-        pod_vector<int8u> stack;
-
-        if(rx > 0)
-        {
-            if(rx > 254) rx = 254;
-            div = rx * 2 + 1;
-            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[rx];
-            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[rx];
-            stack.allocate(div);
-
-            for(y = 0; y < h; y++)
-            {
-                sum = sum_in = sum_out = 0;
-
-                src_pix_ptr = img.pix_ptr(0, y);
-                pix = *src_pix_ptr;
-                for(i = 0; i <= rx; i++)
-                {
-                    stack[i] = pix;
-                    sum     += pix * (i + 1);
-                    sum_out += pix;
-                }
-                for(i = 1; i <= rx; i++)
-                {
-                    if(i <= wm) src_pix_ptr += Img::pix_step; 
-                    pix = *src_pix_ptr; 
-                    stack[i + rx] = pix;
-                    sum    += pix * (rx + 1 - i);
-                    sum_in += pix;
-                }
-
-                stack_ptr = rx;
-                xp = rx;
-                if(xp > wm) xp = wm;
-                src_pix_ptr = img.pix_ptr(xp, y);
-                dst_pix_ptr = img.pix_ptr(0, y);
-                for(x = 0; x < w; x++)
-                {
-                    *dst_pix_ptr = (sum * mul_sum) >> shr_sum;
-                    dst_pix_ptr += Img::pix_step;
-
-                    sum -= sum_out;
-       
-                    stack_start = stack_ptr + div - rx;
-                    if(stack_start >= div) stack_start -= div;
-                    sum_out -= stack[stack_start];
-
-                    if(xp < wm) 
-                    {
-                        src_pix_ptr += Img::pix_step;
-                        pix = *src_pix_ptr;
-                        ++xp;
-                    }
-        
-                    stack[stack_start] = pix;
-        
-                    sum_in += pix;
-                    sum    += sum_in;
-        
-                    ++stack_ptr;
-                    if(stack_ptr >= div) stack_ptr = 0;
-                    stack_pix = stack[stack_ptr];
-
-                    sum_out += stack_pix;
-                    sum_in  -= stack_pix;
-                }
-            }
-        }
-
-        if(ry > 0)
-        {
-            if(ry > 254) ry = 254;
-            div = ry * 2 + 1;
-            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[ry];
-            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[ry];
-            stack.allocate(div);
-
-            int stride = img.stride();
-            for(x = 0; x < w; x++)
-            {
-                sum = sum_in = sum_out = 0;
-
-                src_pix_ptr = img.pix_ptr(x, 0);
-                pix = *src_pix_ptr;
-                for(i = 0; i <= ry; i++)
-                {
-                    stack[i] = pix;
-                    sum     += pix * (i + 1);
-                    sum_out += pix;
-                }
-                for(i = 1; i <= ry; i++)
-                {
-                    if(i <= hm) src_pix_ptr += stride; 
-                    pix = *src_pix_ptr; 
-                    stack[i + ry] = pix;
-                    sum    += pix * (ry + 1 - i);
-                    sum_in += pix;
-                }
-
-                stack_ptr = ry;
-                yp = ry;
-                if(yp > hm) yp = hm;
-                src_pix_ptr = img.pix_ptr(x, yp);
-                dst_pix_ptr = img.pix_ptr(x, 0);
-                for(y = 0; y < h; y++)
-                {
-                    *dst_pix_ptr = (sum * mul_sum) >> shr_sum;
-                    dst_pix_ptr += stride;
-
-                    sum -= sum_out;
-       
-                    stack_start = stack_ptr + div - ry;
-                    if(stack_start >= div) stack_start -= div;
-                    sum_out -= stack[stack_start];
-
-                    if(yp < hm) 
-                    {
-                        src_pix_ptr += stride;
-                        pix = *src_pix_ptr;
-                        ++yp;
-                    }
-        
-                    stack[stack_start] = pix;
-        
-                    sum_in += pix;
-                    sum    += sum_in;
-        
-                    ++stack_ptr;
-                    if(stack_ptr >= div) stack_ptr = 0;
-                    stack_pix = stack[stack_ptr];
-
-                    sum_out += stack_pix;
-                    sum_in  -= stack_pix;
-                }
-            }
-        }
-    }
-
-
-
-    //========================================================stack_blur_rgb24
-    template<class Img> 
-    void stack_blur_rgb24(Img& img, unsigned rx, unsigned ry)
-    {
-        typedef typename Img::color_type color_type;
-        typedef typename Img::order_type order_type;
-        enum order_e 
-        { 
-            R = order_type::R, 
-            G = order_type::G, 
-            B = order_type::B 
-        };
-
-        unsigned x, y, xp, yp, i;
-        unsigned stack_ptr;
-        unsigned stack_start;
-
-        const int8u* src_pix_ptr;
-              int8u* dst_pix_ptr;
-        color_type*  stack_pix_ptr;
-
-        unsigned sum_r;
-        unsigned sum_g;
-        unsigned sum_b;
-        unsigned sum_in_r;
-        unsigned sum_in_g;
-        unsigned sum_in_b;
-        unsigned sum_out_r;
-        unsigned sum_out_g;
-        unsigned sum_out_b;
-
-        unsigned w   = img.width();
-        unsigned h   = img.height();
-        unsigned wm  = w - 1;
-        unsigned hm  = h - 1;
-
-        unsigned div;
-        unsigned mul_sum;
-        unsigned shr_sum;
-
-        pod_vector<color_type> stack;
-
-        if(rx > 0)
-        {
-            if(rx > 254) rx = 254;
-            div = rx * 2 + 1;
-            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[rx];
-            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[rx];
-            stack.allocate(div);
-
-            for(y = 0; y < h; y++)
-            {
-                sum_r = 
-                sum_g = 
-                sum_b = 
-                sum_in_r = 
-                sum_in_g = 
-                sum_in_b = 
-                sum_out_r = 
-                sum_out_g = 
-                sum_out_b = 0;
-
-                src_pix_ptr = img.pix_ptr(0, y);
-                for(i = 0; i <= rx; i++)
-                {
-                    stack_pix_ptr    = &stack[i];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    sum_r           += src_pix_ptr[R] * (i + 1);
-                    sum_g           += src_pix_ptr[G] * (i + 1);
-                    sum_b           += src_pix_ptr[B] * (i + 1);
-                    sum_out_r       += src_pix_ptr[R];
-                    sum_out_g       += src_pix_ptr[G];
-                    sum_out_b       += src_pix_ptr[B];
-                }
-                for(i = 1; i <= rx; i++)
-                {
-                    if(i <= wm) src_pix_ptr += Img::pix_width; 
-                    stack_pix_ptr = &stack[i + rx];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    sum_r           += src_pix_ptr[R] * (rx + 1 - i);
-                    sum_g           += src_pix_ptr[G] * (rx + 1 - i);
-                    sum_b           += src_pix_ptr[B] * (rx + 1 - i);
-                    sum_in_r        += src_pix_ptr[R];
-                    sum_in_g        += src_pix_ptr[G];
-                    sum_in_b        += src_pix_ptr[B];
-                }
-
-                stack_ptr = rx;
-                xp = rx;
-                if(xp > wm) xp = wm;
-                src_pix_ptr = img.pix_ptr(xp, y);
-                dst_pix_ptr = img.pix_ptr(0, y);
-                for(x = 0; x < w; x++)
-                {
-                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
-                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
-                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
-                    dst_pix_ptr   += Img::pix_width;
-
-                    sum_r -= sum_out_r;
-                    sum_g -= sum_out_g;
-                    sum_b -= sum_out_b;
-       
-                    stack_start = stack_ptr + div - rx;
-                    if(stack_start >= div) stack_start -= div;
-                    stack_pix_ptr = &stack[stack_start];
-
-                    sum_out_r -= stack_pix_ptr->r;
-                    sum_out_g -= stack_pix_ptr->g;
-                    sum_out_b -= stack_pix_ptr->b;
-
-                    if(xp < wm) 
-                    {
-                        src_pix_ptr += Img::pix_width;
-                        ++xp;
-                    }
-        
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-        
-                    sum_in_r += src_pix_ptr[R];
-                    sum_in_g += src_pix_ptr[G];
-                    sum_in_b += src_pix_ptr[B];
-                    sum_r    += sum_in_r;
-                    sum_g    += sum_in_g;
-                    sum_b    += sum_in_b;
-        
-                    ++stack_ptr;
-                    if(stack_ptr >= div) stack_ptr = 0;
-                    stack_pix_ptr = &stack[stack_ptr];
-
-                    sum_out_r += stack_pix_ptr->r;
-                    sum_out_g += stack_pix_ptr->g;
-                    sum_out_b += stack_pix_ptr->b;
-                    sum_in_r  -= stack_pix_ptr->r;
-                    sum_in_g  -= stack_pix_ptr->g;
-                    sum_in_b  -= stack_pix_ptr->b;
-                }
-            }
-        }
-
-        if(ry > 0)
-        {
-            if(ry > 254) ry = 254;
-            div = ry * 2 + 1;
-            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[ry];
-            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[ry];
-            stack.allocate(div);
-
-            int stride = img.stride();
-            for(x = 0; x < w; x++)
-            {
-                sum_r = 
-                sum_g = 
-                sum_b = 
-                sum_in_r = 
-                sum_in_g = 
-                sum_in_b = 
-                sum_out_r = 
-                sum_out_g = 
-                sum_out_b = 0;
-
-                src_pix_ptr = img.pix_ptr(x, 0);
-                for(i = 0; i <= ry; i++)
-                {
-                    stack_pix_ptr    = &stack[i];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    sum_r           += src_pix_ptr[R] * (i + 1);
-                    sum_g           += src_pix_ptr[G] * (i + 1);
-                    sum_b           += src_pix_ptr[B] * (i + 1);
-                    sum_out_r       += src_pix_ptr[R];
-                    sum_out_g       += src_pix_ptr[G];
-                    sum_out_b       += src_pix_ptr[B];
-                }
-                for(i = 1; i <= ry; i++)
-                {
-                    if(i <= hm) src_pix_ptr += stride; 
-                    stack_pix_ptr = &stack[i + ry];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    sum_r           += src_pix_ptr[R] * (ry + 1 - i);
-                    sum_g           += src_pix_ptr[G] * (ry + 1 - i);
-                    sum_b           += src_pix_ptr[B] * (ry + 1 - i);
-                    sum_in_r        += src_pix_ptr[R];
-                    sum_in_g        += src_pix_ptr[G];
-                    sum_in_b        += src_pix_ptr[B];
-                }
-
-                stack_ptr = ry;
-                yp = ry;
-                if(yp > hm) yp = hm;
-                src_pix_ptr = img.pix_ptr(x, yp);
-                dst_pix_ptr = img.pix_ptr(x, 0);
-                for(y = 0; y < h; y++)
-                {
-                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
-                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
-                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
-                    dst_pix_ptr += stride;
-
-                    sum_r -= sum_out_r;
-                    sum_g -= sum_out_g;
-                    sum_b -= sum_out_b;
-       
-                    stack_start = stack_ptr + div - ry;
-                    if(stack_start >= div) stack_start -= div;
-
-                    stack_pix_ptr = &stack[stack_start];
-                    sum_out_r -= stack_pix_ptr->r;
-                    sum_out_g -= stack_pix_ptr->g;
-                    sum_out_b -= stack_pix_ptr->b;
-
-                    if(yp < hm) 
-                    {
-                        src_pix_ptr += stride;
-                        ++yp;
-                    }
-        
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-        
-                    sum_in_r += src_pix_ptr[R];
-                    sum_in_g += src_pix_ptr[G];
-                    sum_in_b += src_pix_ptr[B];
-                    sum_r    += sum_in_r;
-                    sum_g    += sum_in_g;
-                    sum_b    += sum_in_b;
-        
-                    ++stack_ptr;
-                    if(stack_ptr >= div) stack_ptr = 0;
-                    stack_pix_ptr = &stack[stack_ptr];
-
-                    sum_out_r += stack_pix_ptr->r;
-                    sum_out_g += stack_pix_ptr->g;
-                    sum_out_b += stack_pix_ptr->b;
-                    sum_in_r  -= stack_pix_ptr->r;
-                    sum_in_g  -= stack_pix_ptr->g;
-                    sum_in_b  -= stack_pix_ptr->b;
-                }
-            }
-        }
-    }
-
-
-
-    //=======================================================stack_blur_rgba32
-    template<class Img> 
-    void stack_blur_rgba32(Img& img, unsigned rx, unsigned ry)
-    {
-        typedef typename Img::color_type color_type;
-        typedef typename Img::order_type order_type;
-        enum order_e 
-        { 
-            R = order_type::R, 
-            G = order_type::G, 
-            B = order_type::B,
-            A = order_type::A 
-        };
-
-        unsigned x, y, xp, yp, i;
-        unsigned stack_ptr;
-        unsigned stack_start;
-
-        const int8u* src_pix_ptr;
-              int8u* dst_pix_ptr;
-        color_type*  stack_pix_ptr;
-
-        unsigned sum_r;
-        unsigned sum_g;
-        unsigned sum_b;
-        unsigned sum_a;
-        unsigned sum_in_r;
-        unsigned sum_in_g;
-        unsigned sum_in_b;
-        unsigned sum_in_a;
-        unsigned sum_out_r;
-        unsigned sum_out_g;
-        unsigned sum_out_b;
-        unsigned sum_out_a;
-
-        unsigned w   = img.width();
-        unsigned h   = img.height();
-        unsigned wm  = w - 1;
-        unsigned hm  = h - 1;
-
-        unsigned div;
-        unsigned mul_sum;
-        unsigned shr_sum;
-
-        pod_vector<color_type> stack;
-
-        if(rx > 0)
-        {
-            if(rx > 254) rx = 254;
-            div = rx * 2 + 1;
-            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[rx];
-            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[rx];
-            stack.allocate(div);
-
-            for(y = 0; y < h; y++)
-            {
-                sum_r = 
-                sum_g = 
-                sum_b = 
-                sum_a = 
-                sum_in_r = 
-                sum_in_g = 
-                sum_in_b = 
-                sum_in_a = 
-                sum_out_r = 
-                sum_out_g = 
-                sum_out_b = 
-                sum_out_a = 0;
-
-                src_pix_ptr = img.pix_ptr(0, y);
-                for(i = 0; i <= rx; i++)
-                {
-                    stack_pix_ptr    = &stack[i];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    stack_pix_ptr->a = src_pix_ptr[A];
-                    sum_r           += src_pix_ptr[R] * (i + 1);
-                    sum_g           += src_pix_ptr[G] * (i + 1);
-                    sum_b           += src_pix_ptr[B] * (i + 1);
-                    sum_a           += src_pix_ptr[A] * (i + 1);
-                    sum_out_r       += src_pix_ptr[R];
-                    sum_out_g       += src_pix_ptr[G];
-                    sum_out_b       += src_pix_ptr[B];
-                    sum_out_a       += src_pix_ptr[A];
-                }
-                for(i = 1; i <= rx; i++)
-                {
-                    if(i <= wm) src_pix_ptr += Img::pix_width; 
-                    stack_pix_ptr = &stack[i + rx];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    stack_pix_ptr->a = src_pix_ptr[A];
-                    sum_r           += src_pix_ptr[R] * (rx + 1 - i);
-                    sum_g           += src_pix_ptr[G] * (rx + 1 - i);
-                    sum_b           += src_pix_ptr[B] * (rx + 1 - i);
-                    sum_a           += src_pix_ptr[A] * (rx + 1 - i);
-                    sum_in_r        += src_pix_ptr[R];
-                    sum_in_g        += src_pix_ptr[G];
-                    sum_in_b        += src_pix_ptr[B];
-                    sum_in_a        += src_pix_ptr[A];
-                }
-
-                stack_ptr = rx;
-                xp = rx;
-                if(xp > wm) xp = wm;
-                src_pix_ptr = img.pix_ptr(xp, y);
-                dst_pix_ptr = img.pix_ptr(0, y);
-                for(x = 0; x < w; x++)
-                {
-                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
-                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
-                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
-                    dst_pix_ptr[A] = (sum_a * mul_sum) >> shr_sum;
-                    dst_pix_ptr += Img::pix_width;
-
-                    sum_r -= sum_out_r;
-                    sum_g -= sum_out_g;
-                    sum_b -= sum_out_b;
-                    sum_a -= sum_out_a;
-       
-                    stack_start = stack_ptr + div - rx;
-                    if(stack_start >= div) stack_start -= div;
-                    stack_pix_ptr = &stack[stack_start];
-
-                    sum_out_r -= stack_pix_ptr->r;
-                    sum_out_g -= stack_pix_ptr->g;
-                    sum_out_b -= stack_pix_ptr->b;
-                    sum_out_a -= stack_pix_ptr->a;
-
-                    if(xp < wm) 
-                    {
-                        src_pix_ptr += Img::pix_width;
-                        ++xp;
-                    }
-        
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    stack_pix_ptr->a = src_pix_ptr[A];
-        
-                    sum_in_r += src_pix_ptr[R];
-                    sum_in_g += src_pix_ptr[G];
-                    sum_in_b += src_pix_ptr[B];
-                    sum_in_a += src_pix_ptr[A];
-                    sum_r    += sum_in_r;
-                    sum_g    += sum_in_g;
-                    sum_b    += sum_in_b;
-                    sum_a    += sum_in_a;
-        
-                    ++stack_ptr;
-                    if(stack_ptr >= div) stack_ptr = 0;
-                    stack_pix_ptr = &stack[stack_ptr];
-
-                    sum_out_r += stack_pix_ptr->r;
-                    sum_out_g += stack_pix_ptr->g;
-                    sum_out_b += stack_pix_ptr->b;
-                    sum_out_a += stack_pix_ptr->a;
-                    sum_in_r  -= stack_pix_ptr->r;
-                    sum_in_g  -= stack_pix_ptr->g;
-                    sum_in_b  -= stack_pix_ptr->b;
-                    sum_in_a  -= stack_pix_ptr->a;
-                }
-            }
-        }
-
-        if(ry > 0)
-        {
-            if(ry > 254) ry = 254;
-            div = ry * 2 + 1;
-            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[ry];
-            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[ry];
-            stack.allocate(div);
-
-            int stride = img.stride();
-            for(x = 0; x < w; x++)
-            {
-                sum_r = 
-                sum_g = 
-                sum_b = 
-                sum_a = 
-                sum_in_r = 
-                sum_in_g = 
-                sum_in_b = 
-                sum_in_a = 
-                sum_out_r = 
-                sum_out_g = 
-                sum_out_b = 
-                sum_out_a = 0;
-
-                src_pix_ptr = img.pix_ptr(x, 0);
-                for(i = 0; i <= ry; i++)
-                {
-                    stack_pix_ptr    = &stack[i];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    stack_pix_ptr->a = src_pix_ptr[A];
-                    sum_r           += src_pix_ptr[R] * (i + 1);
-                    sum_g           += src_pix_ptr[G] * (i + 1);
-                    sum_b           += src_pix_ptr[B] * (i + 1);
-                    sum_a           += src_pix_ptr[A] * (i + 1);
-                    sum_out_r       += src_pix_ptr[R];
-                    sum_out_g       += src_pix_ptr[G];
-                    sum_out_b       += src_pix_ptr[B];
-                    sum_out_a       += src_pix_ptr[A];
-                }
-                for(i = 1; i <= ry; i++)
-                {
-                    if(i <= hm) src_pix_ptr += stride; 
-                    stack_pix_ptr = &stack[i + ry];
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    stack_pix_ptr->a = src_pix_ptr[A];
-                    sum_r           += src_pix_ptr[R] * (ry + 1 - i);
-                    sum_g           += src_pix_ptr[G] * (ry + 1 - i);
-                    sum_b           += src_pix_ptr[B] * (ry + 1 - i);
-                    sum_a           += src_pix_ptr[A] * (ry + 1 - i);
-                    sum_in_r        += src_pix_ptr[R];
-                    sum_in_g        += src_pix_ptr[G];
-                    sum_in_b        += src_pix_ptr[B];
-                    sum_in_a        += src_pix_ptr[A];
-                }
-
-                stack_ptr = ry;
-                yp = ry;
-                if(yp > hm) yp = hm;
-                src_pix_ptr = img.pix_ptr(x, yp);
-                dst_pix_ptr = img.pix_ptr(x, 0);
-                for(y = 0; y < h; y++)
-                {
-                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
-                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
-                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
-                    dst_pix_ptr[A] = (sum_a * mul_sum) >> shr_sum;
-                    dst_pix_ptr += stride;
-
-                    sum_r -= sum_out_r;
-                    sum_g -= sum_out_g;
-                    sum_b -= sum_out_b;
-                    sum_a -= sum_out_a;
-       
-                    stack_start = stack_ptr + div - ry;
-                    if(stack_start >= div) stack_start -= div;
-
-                    stack_pix_ptr = &stack[stack_start];
-                    sum_out_r -= stack_pix_ptr->r;
-                    sum_out_g -= stack_pix_ptr->g;
-                    sum_out_b -= stack_pix_ptr->b;
-                    sum_out_a -= stack_pix_ptr->a;
-
-                    if(yp < hm) 
-                    {
-                        src_pix_ptr += stride;
-                        ++yp;
-                    }
-        
-                    stack_pix_ptr->r = src_pix_ptr[R];
-                    stack_pix_ptr->g = src_pix_ptr[G];
-                    stack_pix_ptr->b = src_pix_ptr[B];
-                    stack_pix_ptr->a = src_pix_ptr[A];
-        
-                    sum_in_r += src_pix_ptr[R];
-                    sum_in_g += src_pix_ptr[G];
-                    sum_in_b += src_pix_ptr[B];
-                    sum_in_a += src_pix_ptr[A];
-                    sum_r    += sum_in_r;
-                    sum_g    += sum_in_g;
-                    sum_b    += sum_in_b;
-                    sum_a    += sum_in_a;
-        
-                    ++stack_ptr;
-                    if(stack_ptr >= div) stack_ptr = 0;
-                    stack_pix_ptr = &stack[stack_ptr];
-
-                    sum_out_r += stack_pix_ptr->r;
-                    sum_out_g += stack_pix_ptr->g;
-                    sum_out_b += stack_pix_ptr->b;
-                    sum_out_a += stack_pix_ptr->a;
-                    sum_in_r  -= stack_pix_ptr->r;
-                    sum_in_g  -= stack_pix_ptr->g;
-                    sum_in_b  -= stack_pix_ptr->b;
-                    sum_in_a  -= stack_pix_ptr->a;
-                }
-            }
-        }
-    }
-
-
-
-    //===========================================================recursive_blur
-    template<class ColorT, class CalculatorT> class recursive_blur
-    {
-    public:
-        typedef ColorT color_type;
-        typedef CalculatorT calculator_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename calculator_type::value_type calc_type;
-
-        //--------------------------------------------------------------------
-        template<class Img> void blur_x(Img& img, double radius)
-        {
-            if(radius < 0.62) return;
-            if(img.width() < 3) return;
-
-            calc_type s = calc_type(radius * 0.5);
-            calc_type q = calc_type((s < 2.5) ?
-                                    3.97156 - 4.14554 * sqrt(1 - 0.26891 * s) :
-                                    0.98711 * s - 0.96330);
-
-            calc_type q2 = calc_type(q * q);
-            calc_type q3 = calc_type(q2 * q);
-
-            calc_type b0 = calc_type(1.0 / (1.578250 + 
-                                            2.444130 * q + 
-                                            1.428100 * q2 + 
-                                            0.422205 * q3));
-
-            calc_type b1 = calc_type( 2.44413 * q + 
-                                      2.85619 * q2 + 
-                                      1.26661 * q3);
-
-            calc_type b2 = calc_type(-1.42810 * q2 + 
-                                     -1.26661 * q3);
-
-            calc_type b3 = calc_type(0.422205 * q3);
-
-            calc_type b  = calc_type(1 - (b1 + b2 + b3) * b0);
-
-            b1 *= b0;
-            b2 *= b0;
-            b3 *= b0;
-
-            int w = img.width();
-            int h = img.height();
-            int wm = w-1;
-            int x, y;
-
-            m_sum1.allocate(w);
-            m_sum2.allocate(w);
-            m_buf.allocate(w);
-
-            for(y = 0; y < h; y++)
-            {
-                calculator_type c;
-                c.from_pix(img.pixel(0, y));
-                m_sum1[0].calc(b, b1, b2, b3, c, c, c, c);
-                c.from_pix(img.pixel(1, y));
-                m_sum1[1].calc(b, b1, b2, b3, c, m_sum1[0], m_sum1[0], m_sum1[0]);
-                c.from_pix(img.pixel(2, y));
-                m_sum1[2].calc(b, b1, b2, b3, c, m_sum1[1], m_sum1[0], m_sum1[0]);
-
-                for(x = 3; x < w; ++x)
-                {
-                    c.from_pix(img.pixel(x, y));
-                    m_sum1[x].calc(b, b1, b2, b3, c, m_sum1[x-1], m_sum1[x-2], m_sum1[x-3]);
-                }
-    
-                m_sum2[wm  ].calc(b, b1, b2, b3, m_sum1[wm  ], m_sum1[wm  ], m_sum1[wm], m_sum1[wm]);
-                m_sum2[wm-1].calc(b, b1, b2, b3, m_sum1[wm-1], m_sum2[wm  ], m_sum2[wm], m_sum2[wm]);
-                m_sum2[wm-2].calc(b, b1, b2, b3, m_sum1[wm-2], m_sum2[wm-1], m_sum2[wm], m_sum2[wm]);
-                m_sum2[wm  ].to_pix(m_buf[wm  ]);
-                m_sum2[wm-1].to_pix(m_buf[wm-1]);
-                m_sum2[wm-2].to_pix(m_buf[wm-2]);
-
-                for(x = wm-3; x >= 0; --x)
-                {
-                    m_sum2[x].calc(b, b1, b2, b3, m_sum1[x], m_sum2[x+1], m_sum2[x+2], m_sum2[x+3]);
-                    m_sum2[x].to_pix(m_buf[x]);
-                }
-                img.copy_color_hspan(0, y, w, &m_buf[0]);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class Img> void blur_y(Img& img, double radius)
-        {
-            pixfmt_transposer<Img> img2(img);
-            blur_x(img2, radius);
-        }
-
-        //--------------------------------------------------------------------
-        template<class Img> void blur(Img& img, double radius)
-        {
-            blur_x(img, radius);
-            pixfmt_transposer<Img> img2(img);
-            blur_x(img2, radius);
-        }
-
-    private:
-        mapserver::pod_vector<calculator_type> m_sum1;
-        mapserver::pod_vector<calculator_type> m_sum2;
-        mapserver::pod_vector<color_type>      m_buf;
-    };
-
-
-    //=================================================recursive_blur_calc_rgba
-    template<class T=double> struct recursive_blur_calc_rgba
-    {
-        typedef T value_type;
-        typedef recursive_blur_calc_rgba<T> self_type;
-
-        value_type r,g,b,a;
-
-        template<class ColorT> 
-        AGG_INLINE void from_pix(const ColorT& c)
-        {
-            r = c.r;
-            g = c.g;
-            b = c.b;
-            a = c.a;
-        }
-
-        AGG_INLINE void calc(value_type b1, 
-                             value_type b2, 
-                             value_type b3, 
-                             value_type b4,
-                             const self_type& c1, 
-                             const self_type& c2, 
-                             const self_type& c3, 
-                             const self_type& c4)
-        {
-            r = b1*c1.r + b2*c2.r + b3*c3.r + b4*c4.r;
-            g = b1*c1.g + b2*c2.g + b3*c3.g + b4*c4.g;
-            b = b1*c1.b + b2*c2.b + b3*c3.b + b4*c4.b;
-            a = b1*c1.a + b2*c2.a + b3*c3.a + b4*c4.a;
-        }
-
-        template<class ColorT> 
-        AGG_INLINE void to_pix(ColorT& c) const
-        {
-            typedef typename ColorT::value_type cv_type;
-            c.r = (cv_type)uround(r);
-            c.g = (cv_type)uround(g);
-            c.b = (cv_type)uround(b);
-            c.a = (cv_type)uround(a);
-        }
-    };
-
-
-    //=================================================recursive_blur_calc_rgb
-    template<class T=double> struct recursive_blur_calc_rgb
-    {
-        typedef T value_type;
-        typedef recursive_blur_calc_rgb<T> self_type;
-
-        value_type r,g,b;
-
-        template<class ColorT> 
-        AGG_INLINE void from_pix(const ColorT& c)
-        {
-            r = c.r;
-            g = c.g;
-            b = c.b;
-        }
-
-        AGG_INLINE void calc(value_type b1, 
-                             value_type b2, 
-                             value_type b3, 
-                             value_type b4,
-                             const self_type& c1, 
-                             const self_type& c2, 
-                             const self_type& c3, 
-                             const self_type& c4)
-        {
-            r = b1*c1.r + b2*c2.r + b3*c3.r + b4*c4.r;
-            g = b1*c1.g + b2*c2.g + b3*c3.g + b4*c4.g;
-            b = b1*c1.b + b2*c2.b + b3*c3.b + b4*c4.b;
-        }
-
-        template<class ColorT> 
-        AGG_INLINE void to_pix(ColorT& c) const
-        {
-            typedef typename ColorT::value_type cv_type;
-            c.r = (cv_type)uround(r);
-            c.g = (cv_type)uround(g);
-            c.b = (cv_type)uround(b);
-        }
-    };
-
-
-    //================================================recursive_blur_calc_gray
-    template<class T=double> struct recursive_blur_calc_gray
-    {
-        typedef T value_type;
-        typedef recursive_blur_calc_gray<T> self_type;
-
-        value_type v;
-
-        template<class ColorT> 
-        AGG_INLINE void from_pix(const ColorT& c)
-        {
-            v = c.v;
-        }
-
-        AGG_INLINE void calc(value_type b1, 
-                             value_type b2, 
-                             value_type b3, 
-                             value_type b4,
-                             const self_type& c1, 
-                             const self_type& c2, 
-                             const self_type& c3, 
-                             const self_type& c4)
-        {
-            v = b1*c1.v + b2*c2.v + b3*c3.v + b4*c4.v;
-        }
-
-        template<class ColorT> 
-        AGG_INLINE void to_pix(ColorT& c) const
-        {
-            typedef typename ColorT::value_type cv_type;
-            c.v = (cv_type)uround(v);
-        }
-    };
-
-}
-
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_bounding_rect.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bounding_rect.h
--- 8.0.1-5/renderers/agg/include/agg_bounding_rect.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bounding_rect.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,116 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// bounding_rect function template
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_BOUNDING_RECT_INCLUDED
-#define AGG_BOUNDING_RECT_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------------bounding_rect
-    template<class VertexSource, class GetId, class CoordT>
-    bool bounding_rect(VertexSource& vs, GetId& gi, 
-                       unsigned start, unsigned num, 
-                       CoordT* x1, CoordT* y1, CoordT* x2, CoordT* y2)
-    {
-        unsigned i;
-        double x;
-        double y;
-        bool first = true;
-
-        *x1 = CoordT(1);
-        *y1 = CoordT(1);
-        *x2 = CoordT(0);
-        *y2 = CoordT(0);
-
-        for(i = 0; i < num; i++)
-        {
-            vs.rewind(gi[start + i]);
-            unsigned cmd;
-            while(!is_stop(cmd = vs.vertex(&x, &y)))
-            {
-                if(is_vertex(cmd))
-                {
-                    if(first)
-                    {
-                        *x1 = CoordT(x);
-                        *y1 = CoordT(y);
-                        *x2 = CoordT(x);
-                        *y2 = CoordT(y);
-                        first = false;
-                    }
-                    else
-                    {
-                        if(CoordT(x) < *x1) *x1 = CoordT(x);
-                        if(CoordT(y) < *y1) *y1 = CoordT(y);
-                        if(CoordT(x) > *x2) *x2 = CoordT(x);
-                        if(CoordT(y) > *y2) *y2 = CoordT(y);
-                    }
-                }
-            }
-        }
-        return *x1 <= *x2 && *y1 <= *y2;
-    }
-
-
-    //-----------------------------------------------------bounding_rect_single
-    template<class VertexSource, class CoordT> 
-    bool bounding_rect_single(VertexSource& vs, unsigned path_id,
-                              CoordT* x1, CoordT* y1, CoordT* x2, CoordT* y2)
-    {
-        double x;
-        double y;
-        bool first = true;
-
-        *x1 = CoordT(1);
-        *y1 = CoordT(1);
-        *x2 = CoordT(0);
-        *y2 = CoordT(0);
-
-        vs.rewind(path_id);
-        unsigned cmd;
-        while(!is_stop(cmd = vs.vertex(&x, &y)))
-        {
-            if(is_vertex(cmd))
-            {
-                if(first)
-                {
-                    *x1 = CoordT(x);
-                    *y1 = CoordT(y);
-                    *x2 = CoordT(x);
-                    *y2 = CoordT(y);
-                    first = false;
-                }
-                else
-                {
-                    if(CoordT(x) < *x1) *x1 = CoordT(x);
-                    if(CoordT(y) < *y1) *y1 = CoordT(y);
-                    if(CoordT(x) > *x2) *x2 = CoordT(x);
-                    if(CoordT(y) > *y2) *y2 = CoordT(y);
-                }
-            }
-        }
-        return *x1 <= *x2 && *y1 <= *y2;
-    }
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_bspline.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bspline.h
--- 8.0.1-5/renderers/agg/include/agg_bspline.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_bspline.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,76 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class bspline
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_BSPLINE_INCLUDED
-#define AGG_BSPLINE_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-    //----------------------------------------------------------------bspline
-    // A very simple class of Bi-cubic Spline interpolation.
-    // First call init(num, x[], y[]) where num - number of source points, 
-    // x, y - arrays of X and Y values respectively. Here Y must be a function 
-    // of X. It means that all the X-coordinates must be arranged in the ascending
-    // order. 
-    // Then call get(x) that calculates a value Y for the respective X. 
-    // The class supports extrapolation, i.e. you can call get(x) where x is
-    // outside the given with init() X-range. Extrapolation is a simple linear 
-    // function.
-    //
-    //  See Implementation agg_bspline.cpp
-    //------------------------------------------------------------------------
-    class bspline 
-    {
-    public:
-        bspline();
-        bspline(int num);
-        bspline(int num, const double* x, const double* y);
-
-        void   init(int num);
-        void   add_point(double x, double y);
-        void   prepare();
-
-        void   init(int num, const double* x, const double* y);
-
-        double get(double x) const;
-        double get_stateful(double x) const;
-    
-    private:
-        bspline(const bspline&);
-        const bspline& operator = (const bspline&);
-
-        static void bsearch(int n, const double *x, double x0, int *i);
-        double extrapolation_left(double x) const;
-        double extrapolation_right(double x) const;
-        double interpolation(double x, int i) const;
-
-        int               m_max;
-        int               m_num;
-        double*           m_x;
-        double*           m_y;
-        pod_array<double> m_am;
-        mutable int       m_last_idx;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_clip_liang_barsky.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_clip_liang_barsky.h
--- 8.0.1-5/renderers/agg/include/agg_clip_liang_barsky.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_clip_liang_barsky.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,333 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Liang-Barsky clipping 
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CLIP_LIANG_BARSKY_INCLUDED
-#define AGG_CLIP_LIANG_BARSKY_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    enum clipping_flags_e
-    {
-        clipping_flags_x1_clipped = 4,
-        clipping_flags_x2_clipped = 1,
-        clipping_flags_y1_clipped = 8,
-        clipping_flags_y2_clipped = 2,
-        clipping_flags_x_clipped = clipping_flags_x1_clipped | clipping_flags_x2_clipped,
-        clipping_flags_y_clipped = clipping_flags_y1_clipped | clipping_flags_y2_clipped
-    };
-
-    //----------------------------------------------------------clipping_flags
-    // Determine the clipping code of the vertex according to the 
-    // Cyrus-Beck line clipping algorithm
-    //
-    //        |        |
-    //  0110  |  0010  | 0011
-    //        |        |
-    // -------+--------+-------- clip_box.y2
-    //        |        |
-    //  0100  |  0000  | 0001
-    //        |        |
-    // -------+--------+-------- clip_box.y1
-    //        |        |
-    //  1100  |  1000  | 1001
-    //        |        |
-    //  clip_box.x1  clip_box.x2
-    //
-    // 
-    template<class T>
-    inline unsigned clipping_flags(T x, T y, const rect_base<T>& clip_box)
-    {
-        return  (x > clip_box.x2) |
-               ((y > clip_box.y2) << 1) |
-               ((x < clip_box.x1) << 2) |
-               ((y < clip_box.y1) << 3);
-    }
-
-    //--------------------------------------------------------clipping_flags_x
-    template<class T>
-    inline unsigned clipping_flags_x(T x, const rect_base<T>& clip_box)
-    {
-        return  (x > clip_box.x2) | ((x < clip_box.x1) << 2);
-    }
-
-
-    //--------------------------------------------------------clipping_flags_y
-    template<class T>
-    inline unsigned clipping_flags_y(T y, const rect_base<T>& clip_box)
-    {
-        return ((y > clip_box.y2) << 1) | ((y < clip_box.y1) << 3);
-    }
-
-
-    //-------------------------------------------------------clip_liang_barsky
-    template<class T>
-    inline unsigned clip_liang_barsky(T x1, T y1, T x2, T y2,
-                                      const rect_base<T>& clip_box,
-                                      T* x, T* y)
-    {
-        const double nearzero = 1e-30;
-
-        double deltax = x2 - x1;
-        double deltay = y2 - y1; 
-        double xin;
-        double xout;
-        double yin;
-        double yout;
-        double tinx;
-        double tiny;
-        double toutx;
-        double touty;  
-        double tin1;
-        double tin2;
-        double tout1;
-        unsigned np = 0;
-
-        if(deltax == 0.0) 
-        {   
-            // bump off of the vertical
-            deltax = (x1 > clip_box.x1) ? -nearzero : nearzero;
-        }
-
-        if(deltay == 0.0) 
-        { 
-            // bump off of the horizontal 
-            deltay = (y1 > clip_box.y1) ? -nearzero : nearzero;
-        }
-        
-        if(deltax > 0.0) 
-        {                
-            // points to right
-            xin  = clip_box.x1;
-            xout = clip_box.x2;
-        }
-        else 
-        {
-            xin  = clip_box.x2;
-            xout = clip_box.x1;
-        }
-
-        if(deltay > 0.0) 
-        {
-            // points up
-            yin  = clip_box.y1;
-            yout = clip_box.y2;
-        }
-        else 
-        {
-            yin  = clip_box.y2;
-            yout = clip_box.y1;
-        }
-        
-        tinx = (xin - x1) / deltax;
-        tiny = (yin - y1) / deltay;
-        
-        if (tinx < tiny) 
-        {
-            // hits x first
-            tin1 = tinx;
-            tin2 = tiny;
-        }
-        else
-        {
-            // hits y first
-            tin1 = tiny;
-            tin2 = tinx;
-        }
-        
-        if(tin1 <= 1.0) 
-        {
-            if(0.0 < tin1) 
-            {
-                *x++ = (T)xin;
-                *y++ = (T)yin;
-                ++np;
-            }
-
-            if(tin2 <= 1.0)
-            {
-                toutx = (xout - x1) / deltax;
-                touty = (yout - y1) / deltay;
-                
-                tout1 = (toutx < touty) ? toutx : touty;
-                
-                if(tin2 > 0.0 || tout1 > 0.0) 
-                {
-                    if(tin2 <= tout1) 
-                    {
-                        if(tin2 > 0.0) 
-                        {
-                            if(tinx > tiny) 
-                            {
-                                *x++ = (T)xin;
-                                *y++ = (T)(y1 + tinx * deltay);
-                            }
-                            else 
-                            {
-                                *x++ = (T)(x1 + tiny * deltax);
-                                *y++ = (T)yin;
-                            }
-                            ++np;
-                        }
-
-                        if(tout1 < 1.0) 
-                        {
-                            if(toutx < touty) 
-                            {
-                                *x++ = (T)xout;
-                                *y++ = (T)(y1 + toutx * deltay);
-                            }
-                            else 
-                            {
-                                *x++ = (T)(x1 + touty * deltax);
-                                *y++ = (T)yout;
-                            }
-                        }
-                        else 
-                        {
-                            *x++ = x2;
-                            *y++ = y2;
-                        }
-                        ++np;
-                    }
-                    else 
-                    {
-                        if(tinx > tiny) 
-                        {
-                            *x++ = (T)xin;
-                            *y++ = (T)yout;
-                        }
-                        else 
-                        {
-                            *x++ = (T)xout;
-                            *y++ = (T)yin;
-                        }
-                        ++np;
-                    }
-                }
-            }
-        }
-        return np;
-    }
-
-
-    //----------------------------------------------------------------------------
-    template<class T>
-    bool clip_move_point(T x1, T y1, T x2, T y2, 
-                         const rect_base<T>& clip_box, 
-                         T* x, T* y, unsigned flags)
-    {
-       T bound;
-
-       if(flags & clipping_flags_x_clipped)
-       {
-           if(x1 == x2)
-           {
-               return false;
-           }
-           bound = (flags & clipping_flags_x1_clipped) ? clip_box.x1 : clip_box.x2;
-           *y = (T)(double(bound - x1) * (y2 - y1) / (x2 - x1) + y1);
-           *x = bound;
-       }
-
-       flags = clipping_flags_y(*y, clip_box);
-       if(flags & clipping_flags_y_clipped)
-       {
-           if(y1 == y2)
-           {
-               return false;
-           }
-           bound = (flags & clipping_flags_y1_clipped) ? clip_box.y1 : clip_box.y2;
-           *x = (T)(double(bound - y1) * (x2 - x1) / (y2 - y1) + x1);
-           *y = bound;
-       }
-       return true;
-    }
-
-    //-------------------------------------------------------clip_line_segment
-    // Returns: ret >= 4        - Fully clipped
-    //          (ret & 1) != 0  - First point has been moved
-    //          (ret & 2) != 0  - Second point has been moved
-    //
-    template<class T>
-    unsigned clip_line_segment(T* x1, T* y1, T* x2, T* y2,
-                               const rect_base<T>& clip_box)
-    {
-        unsigned f1 = clipping_flags(*x1, *y1, clip_box);
-        unsigned f2 = clipping_flags(*x2, *y2, clip_box);
-        unsigned ret = 0;
-
-        if((f2 | f1) == 0)
-        {
-            // Fully visible
-            return 0;
-        }
-
-        if((f1 & clipping_flags_x_clipped) != 0 && 
-           (f1 & clipping_flags_x_clipped) == (f2 & clipping_flags_x_clipped))
-        {
-            // Fully clipped
-            return 4;
-        }
-
-        if((f1 & clipping_flags_y_clipped) != 0 && 
-           (f1 & clipping_flags_y_clipped) == (f2 & clipping_flags_y_clipped))
-        {
-            // Fully clipped
-            return 4;
-        }
-
-        T tx1 = *x1;
-        T ty1 = *y1;
-        T tx2 = *x2;
-        T ty2 = *y2;
-        if(f1) 
-        {   
-            if(!clip_move_point(tx1, ty1, tx2, ty2, clip_box, x1, y1, f1)) 
-            {
-                return 4;
-            }
-            if(*x1 == *x2 && *y1 == *y2) 
-            {
-                return 4;
-            }
-            ret |= 1;
-        }
-        if(f2) 
-        {
-            if(!clip_move_point(tx1, ty1, tx2, ty2, clip_box, x2, y2, f2))
-            {
-                return 4;
-            }
-            if(*x1 == *x2 && *y1 == *y2) 
-            {
-                return 4;
-            }
-            ret |= 2;
-        }
-        return ret;
-    }
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_color_gray.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_color_gray.h
--- 8.0.1-5/renderers/agg/include/agg_color_gray.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_color_gray.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,414 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-//
-// color types gray8, gray16
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_COLOR_GRAY_INCLUDED
-#define AGG_COLOR_GRAY_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_rgba.h"
-
-namespace mapserver
-{
-
-    //===================================================================gray8
-    struct gray8
-    {
-        typedef int8u  value_type;
-        typedef int32u calc_type;
-        typedef int32  long_type;
-        enum base_scale_e
-        {
-            base_shift = 8,
-            base_scale = 1 << base_shift,
-            base_mask  = base_scale - 1
-        };
-        typedef gray8 self_type;
-
-        value_type v;
-        value_type a;
-
-        //--------------------------------------------------------------------
-        gray8() {}
-
-        //--------------------------------------------------------------------
-        gray8(unsigned v_, unsigned a_=base_mask) :
-            v(int8u(v_)), a(int8u(a_)) {}
-
-        //--------------------------------------------------------------------
-        gray8(const self_type& c, unsigned a_) :
-            v(c.v), a(value_type(a_)) {}
-
-        //--------------------------------------------------------------------
-        gray8(const rgba& c) :
-            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
-            a((value_type)uround(c.a * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        gray8(const rgba& c, double a_) :
-            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
-            a((value_type)uround(a_ * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        gray8(const rgba8& c) :
-            v((c.r*77 + c.g*150 + c.b*29) >> 8),
-            a(c.a) {}
-
-        //--------------------------------------------------------------------
-        gray8(const rgba8& c, unsigned a_) :
-            v((c.r*77 + c.g*150 + c.b*29) >> 8),
-            a(a_) {}
-
-        //--------------------------------------------------------------------
-        void clear()
-        {
-            v = a = 0;
-        }
-
-        //--------------------------------------------------------------------
-        const self_type& transparent()
-        {
-            a = 0;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        void opacity(double a_)
-        {
-            if(a_ < 0.0) a_ = 0.0;
-            if(a_ > 1.0) a_ = 1.0;
-            a = (value_type)uround(a_ * double(base_mask));
-        }
-
-        //--------------------------------------------------------------------
-        double opacity() const
-        {
-            return double(a) / double(base_mask);
-        }
-
-
-        //--------------------------------------------------------------------
-        const self_type& premultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                v = 0;
-                return *this;
-            }
-            v = value_type((calc_type(v) * a) >> base_shift);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const self_type& premultiply(unsigned a_)
-        {
-            if(a == base_mask && a_ >= base_mask) return *this;
-            if(a == 0 || a_ == 0)
-            {
-                v = a = 0;
-                return *this;
-            }
-            calc_type v_ = (calc_type(v) * a_) / a;
-            v = value_type((v_ > a_) ? a_ : v_);
-            a = value_type(a_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const self_type& demultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                v = 0;
-                return *this;
-            }
-            calc_type v_ = (calc_type(v) * base_mask) / a;
-            v = value_type((v_ > base_mask) ? (value_type)base_mask : v_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        self_type gradient(self_type c, double k) const
-        {
-            self_type ret;
-            calc_type ik = uround(k * base_scale);
-            ret.v = value_type(calc_type(v) + (((calc_type(c.v) - v) * ik) >> base_shift));
-            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
-            return ret;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void add(const self_type& c, unsigned cover)
-        {
-            calc_type cv, ca;
-            if(cover == cover_mask)
-            {
-                if(c.a == base_mask) 
-                {
-                    *this = c;
-                }
-                else
-                {
-                    cv = v + c.v; v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
-                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-                }
-            }
-            else
-            {
-                cv = v + ((c.v * cover + cover_mask/2) >> cover_shift);
-                ca = a + ((c.a * cover + cover_mask/2) >> cover_shift);
-                v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
-                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        static self_type no_color() { return self_type(0,0); }
-    };
-
-
-    //-------------------------------------------------------------gray8_pre
-    inline gray8 gray8_pre(unsigned v, unsigned a = gray8::base_mask)
-    {
-        return gray8(v,a).premultiply();
-    }
-    inline gray8 gray8_pre(const gray8& c, unsigned a)
-    {
-        return gray8(c,a).premultiply();
-    }
-    inline gray8 gray8_pre(const rgba& c)
-    {
-        return gray8(c).premultiply();
-    }
-    inline gray8 gray8_pre(const rgba& c, double a)
-    {
-        return gray8(c,a).premultiply();
-    }
-    inline gray8 gray8_pre(const rgba8& c)
-    {
-        return gray8(c).premultiply();
-    }
-    inline gray8 gray8_pre(const rgba8& c, unsigned a)
-    {
-        return gray8(c,a).premultiply();
-    }
-
-
-
-
-    //==================================================================gray16
-    struct gray16
-    {
-        typedef int16u value_type;
-        typedef int32u calc_type;
-        typedef int64  long_type;
-        enum base_scale_e
-        {
-            base_shift = 16,
-            base_scale = 1 << base_shift,
-            base_mask  = base_scale - 1
-        };
-        typedef gray16 self_type;
-
-        value_type v;
-        value_type a;
-
-        //--------------------------------------------------------------------
-        gray16() {}
-
-        //--------------------------------------------------------------------
-        gray16(unsigned v_, unsigned a_=base_mask) :
-            v(int16u(v_)), a(int16u(a_)) {}
-
-        //--------------------------------------------------------------------
-        gray16(const self_type& c, unsigned a_) :
-            v(c.v), a(value_type(a_)) {}
-
-        //--------------------------------------------------------------------
-        gray16(const rgba& c) :
-            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
-            a((value_type)uround(c.a * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        gray16(const rgba& c, double a_) :
-            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
-            a((value_type)uround(a_ * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        gray16(const rgba8& c) :
-            v(c.r*77 + c.g*150 + c.b*29),
-            a((value_type(c.a) << 8) | c.a) {}
-
-        //--------------------------------------------------------------------
-        gray16(const rgba8& c, unsigned a_) :
-            v(c.r*77 + c.g*150 + c.b*29),
-            a((value_type(a_) << 8) | c.a) {}
-
-        //--------------------------------------------------------------------
-        void clear()
-        {
-            v = a = 0;
-        }
-
-        //--------------------------------------------------------------------
-        const self_type& transparent()
-        {
-            a = 0;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        void opacity(double a_)
-        {
-            if(a_ < 0.0) a_ = 0.0;
-            if(a_ > 1.0) a_ = 1.0;
-            a = (value_type)uround(a_ * double(base_mask));
-        }
-
-        //--------------------------------------------------------------------
-        double opacity() const
-        {
-            return double(a) / double(base_mask);
-        }
-
-
-        //--------------------------------------------------------------------
-        const self_type& premultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                v = 0;
-                return *this;
-            }
-            v = value_type((calc_type(v) * a) >> base_shift);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const self_type& premultiply(unsigned a_)
-        {
-            if(a == base_mask && a_ >= base_mask) return *this;
-            if(a == 0 || a_ == 0)
-            {
-                v = a = 0;
-                return *this;
-            }
-            calc_type v_ = (calc_type(v) * a_) / a;
-            v = value_type((v_ > a_) ? a_ : v_);
-            a = value_type(a_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const self_type& demultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                v = 0;
-                return *this;
-            }
-            calc_type v_ = (calc_type(v) * base_mask) / a;
-            v = value_type((v_ > base_mask) ? base_mask : v_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        self_type gradient(self_type c, double k) const
-        {
-            self_type ret;
-            calc_type ik = uround(k * base_scale);
-            ret.v = value_type(calc_type(v) + (((calc_type(c.v) - v) * ik) >> base_shift));
-            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
-            return ret;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void add(const self_type& c, unsigned cover)
-        {
-            calc_type cv, ca;
-            if(cover == cover_mask)
-            {
-                if(c.a == base_mask) 
-                {
-                    *this = c;
-                }
-                else
-                {
-                    cv = v + c.v; v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
-                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-                }
-            }
-            else
-            {
-                cv = v + ((c.v * cover + cover_mask/2) >> cover_shift);
-                ca = a + ((c.a * cover + cover_mask/2) >> cover_shift);
-                v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
-                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        static self_type no_color() { return self_type(0,0); }
-    };
-
-
-    //------------------------------------------------------------gray16_pre
-    inline gray16 gray16_pre(unsigned v, unsigned a = gray16::base_mask)
-    {
-        return gray16(v,a).premultiply();
-    }
-    inline gray16 gray16_pre(const gray16& c, unsigned a)
-    {
-        return gray16(c,a).premultiply();
-    }
-    inline gray16 gray16_pre(const rgba& c)
-    {
-        return gray16(c).premultiply();
-    }
-    inline gray16 gray16_pre(const rgba& c, double a)
-    {
-        return gray16(c,a).premultiply();
-    }
-    inline gray16 gray16_pre(const rgba8& c)
-    {
-        return gray16(c).premultiply();
-    }
-    inline gray16 gray16_pre(const rgba8& c, unsigned a)
-    {
-        return gray16(c,a).premultiply();
-    }
-
-
-}
-
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_color_rgba.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_color_rgba.h
--- 8.0.1-5/renderers/agg/include/agg_color_rgba.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_color_rgba.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,743 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_COLOR_RGBA_INCLUDED
-#define AGG_COLOR_RGBA_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    // Supported byte orders for RGB and RGBA pixel formats
-    //=======================================================================
-    struct order_rgb  { enum rgb_e  { R=0, G=1, B=2, rgb_tag }; };       //----order_rgb
-    struct order_bgr  { enum bgr_e  { B=0, G=1, R=2, rgb_tag }; };       //----order_bgr
-    struct order_rgba { enum rgba_e { R=0, G=1, B=2, A=3, rgba_tag }; }; //----order_rgba
-    struct order_argb { enum argb_e { A=0, R=1, G=2, B=3, rgba_tag }; }; //----order_argb
-    struct order_abgr { enum abgr_e { A=0, B=1, G=2, R=3, rgba_tag }; }; //----order_abgr
-    struct order_bgra { enum bgra_e { B=0, G=1, R=2, A=3, rgba_tag }; }; //----order_bgra
-
-    //====================================================================rgba
-    struct rgba
-    {
-        typedef double value_type;
-
-        double r;
-        double g;
-        double b;
-        double a;
-
-        //--------------------------------------------------------------------
-        rgba() {}
-
-        //--------------------------------------------------------------------
-        rgba(double r_, double g_, double b_, double a_=1.0) :
-            r(r_), g(g_), b(b_), a(a_) {}
-
-        //--------------------------------------------------------------------
-        rgba(const rgba& c, double a_) : r(c.r), g(c.g), b(c.b), a(a_) {}
-
-        //--------------------------------------------------------------------
-        void clear()
-        {
-            r = g = b = a = 0;
-        }
-
-        //--------------------------------------------------------------------
-        const rgba& transparent()
-        {
-            a = 0.0;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const rgba& opacity(double a_)
-        {
-            if(a_ < 0.0) a_ = 0.0;
-            if(a_ > 1.0) a_ = 1.0;
-            a = a_;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        double opacity() const
-        {
-            return a;
-        }
-
-        //--------------------------------------------------------------------
-        const rgba& premultiply()
-        {
-            r *= a;
-            g *= a;
-            b *= a;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const rgba& premultiply(double a_)
-        {
-            if(a <= 0.0 || a_ <= 0.0)
-            {
-                r = g = b = a = 0.0;
-                return *this;
-            }
-            a_ /= a;
-            r *= a_;
-            g *= a_;
-            b *= a_;
-            a  = a_;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const rgba& demultiply()
-        {
-            if(a == 0)
-            {
-                r = g = b = 0;
-                return *this;
-            }
-            double a_ = 1.0 / a;
-            r *= a_;
-            g *= a_;
-            b *= a_;
-            return *this;
-        }
-
-
-        //--------------------------------------------------------------------
-        rgba gradient(rgba c, double k) const
-        {
-            rgba ret;
-            ret.r = r + (c.r - r) * k;
-            ret.g = g + (c.g - g) * k;
-            ret.b = b + (c.b - b) * k;
-            ret.a = a + (c.a - a) * k;
-            return ret;
-        }
-
-        //--------------------------------------------------------------------
-        static rgba no_color() { return rgba(0,0,0,0); }
-
-        //--------------------------------------------------------------------
-        static rgba from_wavelength(double wl, double gamma = 1.0);
-	
-        //--------------------------------------------------------------------
-        explicit rgba(double wavelen, double gamma=1.0)
-        {
-            *this = from_wavelength(wavelen, gamma);
-        }
-
-    };
-
-    //----------------------------------------------------------------rgba_pre
-    inline rgba rgba_pre(double r, double g, double b, double a=1.0)
-    {
-        return rgba(r, g, b, a).premultiply();
-    }
-    inline rgba rgba_pre(const rgba& c)
-    {
-        return rgba(c).premultiply();
-    }
-    inline rgba rgba_pre(const rgba& c, double a)
-    {
-        return rgba(c, a).premultiply();
-    }
-
-    //------------------------------------------------------------------------
-    inline rgba rgba::from_wavelength(double wl, double gamma)
-    {
-        rgba t(0.0, 0.0, 0.0);
-
-        if(wl >= 380.0 && wl <= 440.0)
-        {
-            t.r = -1.0 * (wl - 440.0) / (440.0 - 380.0);
-            t.b = 1.0;
-        }
-        else 
-        if(wl >= 440.0 && wl <= 490.0)
-        {
-            t.g = (wl - 440.0) / (490.0 - 440.0);
-            t.b = 1.0;
-        }
-        else
-        if(wl >= 490.0 && wl <= 510.0)
-        {
-            t.g = 1.0;
-            t.b = -1.0 * (wl - 510.0) / (510.0 - 490.0);
-        }
-        else
-        if(wl >= 510.0 && wl <= 580.0)
-        {
-            t.r = (wl - 510.0) / (580.0 - 510.0);
-            t.g = 1.0;
-        }
-        else
-        if(wl >= 580.0 && wl <= 645.0)
-        {
-            t.r = 1.0;
-            t.g = -1.0 * (wl - 645.0) / (645.0 - 580.0);
-        }
-        else
-        if(wl >= 645.0 && wl <= 780.0)
-        {
-            t.r = 1.0;
-        }
-
-        double s = 1.0;
-        if(wl > 700.0)       s = 0.3 + 0.7 * (780.0 - wl) / (780.0 - 700.0);
-        else if(wl <  420.0) s = 0.3 + 0.7 * (wl - 380.0) / (420.0 - 380.0);
-
-        t.r = pow(t.r * s, gamma);
-        t.g = pow(t.g * s, gamma);
-        t.b = pow(t.b * s, gamma);
-        return t;
-    }
-
-
-
-    
-    //===================================================================rgba8
-    struct rgba8
-    {
-        typedef int8u  value_type;
-        typedef int32u calc_type;
-        typedef int32  long_type;
-        enum base_scale_e
-        {
-            base_shift = 8,
-            base_scale = 1 << base_shift,
-            base_mask  = base_scale - 1
-        };
-        typedef rgba8 self_type;
-
-
-        value_type r = 0;
-        value_type g = 0;
-        value_type b = 0;
-        value_type a = 0;
-
-        //--------------------------------------------------------------------
-        rgba8() = default;
-
-        //--------------------------------------------------------------------
-        rgba8(unsigned r_, unsigned g_, unsigned b_, unsigned a_=base_mask) :
-            r(value_type(r_)), 
-            g(value_type(g_)), 
-            b(value_type(b_)), 
-            a(value_type(a_)) {}
-
-        //--------------------------------------------------------------------
-        rgba8(const rgba& c, double a_) :
-            r((value_type)uround(c.r * double(base_mask))), 
-            g((value_type)uround(c.g * double(base_mask))), 
-            b((value_type)uround(c.b * double(base_mask))), 
-            a((value_type)uround(a_  * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        rgba8(const self_type& c, unsigned a_) :
-            r(c.r), g(c.g), b(c.b), a(value_type(a_)) {}
-
-        //--------------------------------------------------------------------
-        rgba8(const rgba& c) :
-            r((value_type)uround(c.r * double(base_mask))), 
-            g((value_type)uround(c.g * double(base_mask))), 
-            b((value_type)uround(c.b * double(base_mask))), 
-            a((value_type)uround(c.a * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        void clear()
-        {
-            r = g = b = a = 0;
-        }
-        
-        //--------------------------------------------------------------------
-        const self_type& transparent()
-        {
-            a = 0;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        const self_type& opacity(double a_)
-        {
-            if(a_ < 0.0) a_ = 0.0;
-            if(a_ > 1.0) a_ = 1.0;
-            a = (value_type)uround(a_ * double(base_mask));
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        double opacity() const
-        {
-            return double(a) / double(base_mask);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE const self_type& premultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                r = g = b = 0;
-                return *this;
-            }
-            r = value_type((calc_type(r) * a) >> base_shift);
-            g = value_type((calc_type(g) * a) >> base_shift);
-            b = value_type((calc_type(b) * a) >> base_shift);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE const self_type& premultiply(unsigned a_)
-        {
-            if(a == base_mask && a_ >= base_mask) return *this;
-            if(a == 0 || a_ == 0)
-            {
-                r = g = b = a = 0;
-                return *this;
-            }
-            calc_type r_ = (calc_type(r) * a_) / a;
-            calc_type g_ = (calc_type(g) * a_) / a;
-            calc_type b_ = (calc_type(b) * a_) / a;
-            r = value_type((r_ > a_) ? a_ : r_);
-            g = value_type((g_ > a_) ? a_ : g_);
-            b = value_type((b_ > a_) ? a_ : b_);
-            a = value_type(a_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE const self_type& demultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                r = g = b = 0;
-                return *this;
-            }
-            calc_type r_ = (calc_type(r) * base_mask) / a;
-            calc_type g_ = (calc_type(g) * base_mask) / a;
-            calc_type b_ = (calc_type(b) * base_mask) / a;
-            r = value_type((r_ > calc_type(base_mask)) ? calc_type(base_mask) : r_);
-            g = value_type((g_ > calc_type(base_mask)) ? calc_type(base_mask) : g_);
-            b = value_type((b_ > calc_type(base_mask)) ? calc_type(base_mask) : b_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE self_type gradient(const self_type& c, double k) const
-        {
-            self_type ret;
-            calc_type ik = uround(k * base_scale);
-            ret.r = value_type(calc_type(r) + (((calc_type(c.r) - r) * ik) >> base_shift));
-            ret.g = value_type(calc_type(g) + (((calc_type(c.g) - g) * ik) >> base_shift));
-            ret.b = value_type(calc_type(b) + (((calc_type(c.b) - b) * ik) >> base_shift));
-            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
-            return ret;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void add(const self_type& c, unsigned cover)
-        {
-            calc_type cr, cg, cb, ca;
-            if(cover == cover_mask)
-            {
-                if(c.a == base_mask) 
-                {
-                    *this = c;
-                }
-                else
-                {
-                    cr = r + c.r; r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
-                    cg = g + c.g; g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
-                    cb = b + c.b; b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
-                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-                }
-            }
-            else
-            {
-                cr = r + ((c.r * cover + cover_mask/2) >> cover_shift);
-                cg = g + ((c.g * cover + cover_mask/2) >> cover_shift);
-                cb = b + ((c.b * cover + cover_mask/2) >> cover_shift);
-                ca = a + ((c.a * cover + cover_mask/2) >> cover_shift);
-                r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
-                g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
-                b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
-                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLUT>
-        AGG_INLINE void apply_gamma_dir(const GammaLUT& gamma)
-        {
-            r = gamma.dir(r);
-            g = gamma.dir(g);
-            b = gamma.dir(b);
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLUT>
-        AGG_INLINE void apply_gamma_inv(const GammaLUT& gamma)
-        {
-            r = gamma.inv(r);
-            g = gamma.inv(g);
-            b = gamma.inv(b);
-        }
-
-        //--------------------------------------------------------------------
-        static self_type no_color() { return self_type(0,0,0,0); }
-
-        //--------------------------------------------------------------------
-        static self_type from_wavelength(double wl, double gamma = 1.0)
-        {
-            return self_type(rgba::from_wavelength(wl, gamma));
-        }
-    };
-
-
-    //-------------------------------------------------------------rgba8_pre
-    inline rgba8 rgba8_pre(unsigned r, unsigned g, unsigned b, 
-                           unsigned a = rgba8::base_mask)
-    {
-        return rgba8(r,g,b,a).premultiply();
-    }
-    inline rgba8 rgba8_pre(const rgba8& c)
-    {
-        return rgba8(c).premultiply();
-    }
-    inline rgba8 rgba8_pre(const rgba8& c, unsigned a)
-    {
-        return rgba8(c,a).premultiply();
-    }
-    inline rgba8 rgba8_pre(const rgba& c)
-    {
-        return rgba8(c).premultiply();
-    }
-    inline rgba8 rgba8_pre(const rgba& c, double a)
-    {
-        return rgba8(c,a).premultiply();
-    }
-
-
-    //-------------------------------------------------------------rgb8_packed
-    inline rgba8 rgb8_packed(unsigned v)
-    {
-        return rgba8((v >> 16) & 0xFF, (v >> 8) & 0xFF, v & 0xFF);
-    }
-
-    //-------------------------------------------------------------bgr8_packed
-    inline rgba8 bgr8_packed(unsigned v)
-    {
-        return rgba8(v & 0xFF, (v >> 8) & 0xFF, (v >> 16) & 0xFF);
-    }
-
-    //------------------------------------------------------------argb8_packed
-    inline rgba8 argb8_packed(unsigned v)
-    {
-        return rgba8((v >> 16) & 0xFF, (v >> 8) & 0xFF, v & 0xFF, v >> 24);
-    }
-
-    //---------------------------------------------------------rgba8_gamma_dir
-    template<class GammaLUT>
-    rgba8 rgba8_gamma_dir(rgba8 c, const GammaLUT& gamma)
-    {
-        return rgba8(gamma.dir(c.r), gamma.dir(c.g), gamma.dir(c.b), c.a);
-    }
-
-    //---------------------------------------------------------rgba8_gamma_inv
-    template<class GammaLUT>
-    rgba8 rgba8_gamma_inv(rgba8 c, const GammaLUT& gamma)
-    {
-        return rgba8(gamma.inv(c.r), gamma.inv(c.g), gamma.inv(c.b), c.a);
-    }
-
-
-
-
-
-    //==================================================================rgba16
-    struct rgba16
-    {
-        typedef int16u value_type;
-        typedef int32u calc_type;
-        typedef int64  long_type;
-        enum base_scale_e
-        {
-            base_shift = 16,
-            base_scale = 1 << base_shift,
-            base_mask  = base_scale - 1
-        };
-        typedef rgba16 self_type;
-
-        value_type r;
-        value_type g;
-        value_type b;
-        value_type a;
-
-        //--------------------------------------------------------------------
-        rgba16() {}
-
-        //--------------------------------------------------------------------
-        rgba16(unsigned r_, unsigned g_, unsigned b_, unsigned a_=base_mask) :
-            r(value_type(r_)), 
-            g(value_type(g_)), 
-            b(value_type(b_)), 
-            a(value_type(a_)) {}
-
-        //--------------------------------------------------------------------
-        rgba16(const self_type& c, unsigned a_) :
-            r(c.r), g(c.g), b(c.b), a(value_type(a_)) {}
-
-        //--------------------------------------------------------------------
-        rgba16(const rgba& c) :
-            r((value_type)uround(c.r * double(base_mask))), 
-            g((value_type)uround(c.g * double(base_mask))), 
-            b((value_type)uround(c.b * double(base_mask))), 
-            a((value_type)uround(c.a * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        rgba16(const rgba& c, double a_) :
-            r((value_type)uround(c.r * double(base_mask))), 
-            g((value_type)uround(c.g * double(base_mask))), 
-            b((value_type)uround(c.b * double(base_mask))), 
-            a((value_type)uround(a_  * double(base_mask))) {}
-
-        //--------------------------------------------------------------------
-        rgba16(const rgba8& c) :
-            r(value_type((value_type(c.r) << 8) | c.r)), 
-            g(value_type((value_type(c.g) << 8) | c.g)), 
-            b(value_type((value_type(c.b) << 8) | c.b)), 
-            a(value_type((value_type(c.a) << 8) | c.a)) {}
-
-        //--------------------------------------------------------------------
-        rgba16(const rgba8& c, unsigned a_) :
-            r(value_type((value_type(c.r) << 8) | c.r)), 
-            g(value_type((value_type(c.g) << 8) | c.g)), 
-            b(value_type((value_type(c.b) << 8) | c.b)), 
-            a(value_type((             a_ << 8) | c.a)) {}
-
-        //--------------------------------------------------------------------
-        void clear()
-        {
-            r = g = b = a = 0;
-        }
-        
-        //--------------------------------------------------------------------
-        const self_type& transparent()
-        {
-            a = 0;
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE const self_type& opacity(double a_)
-        {
-            if(a_ < 0.0) a_ = 0.0;
-            if(a_ > 1.0) a_ = 1.0;
-            a = (value_type)uround(a_ * double(base_mask));
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        double opacity() const
-        {
-            return double(a) / double(base_mask);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE const self_type& premultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                r = g = b = 0;
-                return *this;
-            }
-            r = value_type((calc_type(r) * a) >> base_shift);
-            g = value_type((calc_type(g) * a) >> base_shift);
-            b = value_type((calc_type(b) * a) >> base_shift);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE const self_type& premultiply(unsigned a_)
-        {
-            if(a == base_mask && a_ >= base_mask) return *this;
-            if(a == 0 || a_ == 0)
-            {
-                r = g = b = a = 0;
-                return *this;
-            }
-            calc_type r_ = (calc_type(r) * a_) / a;
-            calc_type g_ = (calc_type(g) * a_) / a;
-            calc_type b_ = (calc_type(b) * a_) / a;
-            r = value_type((r_ > a_) ? a_ : r_);
-            g = value_type((g_ > a_) ? a_ : g_);
-            b = value_type((b_ > a_) ? a_ : b_);
-            a = value_type(a_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE const self_type& demultiply()
-        {
-            if(a == base_mask) return *this;
-            if(a == 0)
-            {
-                r = g = b = 0;
-                return *this;
-            }
-            calc_type r_ = (calc_type(r) * base_mask) / a;
-            calc_type g_ = (calc_type(g) * base_mask) / a;
-            calc_type b_ = (calc_type(b) * base_mask) / a;
-            r = value_type((r_ > calc_type(base_mask)) ? calc_type(base_mask) : r_);
-            g = value_type((g_ > calc_type(base_mask)) ? calc_type(base_mask) : g_);
-            b = value_type((b_ > calc_type(base_mask)) ? calc_type(base_mask) : b_);
-            return *this;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE self_type gradient(const self_type& c, double k) const
-        {
-            self_type ret;
-            calc_type ik = uround(k * base_scale);
-            ret.r = value_type(calc_type(r) + (((calc_type(c.r) - r) * ik) >> base_shift));
-            ret.g = value_type(calc_type(g) + (((calc_type(c.g) - g) * ik) >> base_shift));
-            ret.b = value_type(calc_type(b) + (((calc_type(c.b) - b) * ik) >> base_shift));
-            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
-            return ret;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void add(const self_type& c, unsigned cover)
-        {
-            calc_type cr, cg, cb, ca;
-            if(cover == cover_mask)
-            {
-                if(c.a == base_mask) 
-                {
-                    *this = c;
-                }
-                else
-                {
-                    cr = r + c.r; r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
-                    cg = g + c.g; g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
-                    cb = b + c.b; b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
-                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-                }
-            }
-            else
-            {
-                cr = r + ((c.r * cover + cover_mask) >> cover_shift);
-                cg = g + ((c.g * cover + cover_mask) >> cover_shift);
-                cb = b + ((c.b * cover + cover_mask) >> cover_shift);
-                ca = a + ((c.a * cover + cover_mask) >> cover_shift);
-                r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
-                g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
-                b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
-                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLUT>
-        AGG_INLINE void apply_gamma_dir(const GammaLUT& gamma)
-        {
-            r = gamma.dir(r);
-            g = gamma.dir(g);
-            b = gamma.dir(b);
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLUT>
-        AGG_INLINE void apply_gamma_inv(const GammaLUT& gamma)
-        {
-            r = gamma.inv(r);
-            g = gamma.inv(g);
-            b = gamma.inv(b);
-        }
-
-        //--------------------------------------------------------------------
-        static self_type no_color() { return self_type(0,0,0,0); }
-
-        //--------------------------------------------------------------------
-        static self_type from_wavelength(double wl, double gamma = 1.0)
-        {
-            return self_type(rgba::from_wavelength(wl, gamma));
-        }
-    };
-
-
-
-    //--------------------------------------------------------------rgba16_pre
-    inline rgba16 rgba16_pre(unsigned r, unsigned g, unsigned b, 
-                             unsigned a = rgba16::base_mask)
-    {
-        return rgba16(r,g,b,a).premultiply();
-    }
-    inline rgba16 rgba16_pre(const rgba16& c, unsigned a)
-    {
-        return rgba16(c,a).premultiply();
-    }
-    inline rgba16 rgba16_pre(const rgba& c)
-    {
-        return rgba16(c).premultiply();
-    }
-    inline rgba16 rgba16_pre(const rgba& c, double a)
-    {
-        return rgba16(c,a).premultiply();
-    }
-    inline rgba16 rgba16_pre(const rgba8& c)
-    {
-        return rgba16(c).premultiply();
-    }
-    inline rgba16 rgba16_pre(const rgba8& c, unsigned a)
-    {
-        return rgba16(c,a).premultiply();
-    }
-
-
-    //------------------------------------------------------rgba16_gamma_dir
-    template<class GammaLUT>
-    rgba16 rgba16_gamma_dir(rgba16 c, const GammaLUT& gamma)
-    {
-        return rgba16(gamma.dir(c.r), gamma.dir(c.g), gamma.dir(c.b), c.a);
-    }
-
-    //------------------------------------------------------rgba16_gamma_inv
-    template<class GammaLUT>
-    rgba16 rgba16_gamma_inv(rgba16 c, const GammaLUT& gamma)
-    {
-        return rgba16(gamma.inv(c.r), gamma.inv(c.g), gamma.inv(c.b), c.a);
-    }
-
-
-}
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_config.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_config.h
--- 8.0.1-5/renderers/agg/include/agg_config.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_config.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
-#ifndef AGG_CONFIG_INCLUDED
-#define AGG_CONFIG_INCLUDED
-
-// This file can be used to redefine certain data types.
-
-//---------------------------------------
-// 1. Default basic types such as:
-// 
-// AGG_INT8
-// AGG_INT8U
-// AGG_INT16
-// AGG_INT16U
-// AGG_INT32
-// AGG_INT32U
-// AGG_INT64
-// AGG_INT64U
-//
-// Just replace this file with new defines if necessary. 
-// For example, if your compiler doesn't have a 64 bit integer type
-// you can still use AGG if you define the follows:
-//
-// #define AGG_INT64  int
-// #define AGG_INT64U unsigned
-//
-// It will result in overflow in 16 bit-per-component image/pattern resampling
-// but it won't result any crash and the rest of the library will remain 
-// fully functional.
-
-
-//---------------------------------------
-// 2. Default rendering_buffer type. Can be:
-//
-// Provides faster access for massive pixel operations, 
-// such as blur, image filtering:
-// #define AGG_RENDERING_BUFFER row_ptr_cache<int8u>
-// 
-// Provides cheaper creation and destruction (no mem allocs):
-// #define AGG_RENDERING_BUFFER row_accessor<int8u>
-//
-// You can still use both of them simultaneouslyin your applications 
-// This #define is used only for default rendering_buffer type,
-// in short hand typedefs like pixfmt_rgba32.
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_adaptor_vcgen.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_adaptor_vcgen.h
--- 8.0.1-5/renderers/agg/include/agg_conv_adaptor_vcgen.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_adaptor_vcgen.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,159 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_ADAPTOR_VCGEN_INCLUDED
-#define AGG_CONV_ADAPTOR_VCGEN_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //------------------------------------------------------------null_markers
-    struct null_markers
-    {
-        void remove_all() {}
-        void add_vertex(double, double, unsigned) {}
-        void prepare_src() {}
-
-        void rewind(unsigned) {}
-        unsigned vertex(double*, double*) { return path_cmd_stop; }
-    };
-
-
-    //------------------------------------------------------conv_adaptor_vcgen
-    template<class VertexSource, 
-             class Generator, 
-             class Markers=null_markers> class conv_adaptor_vcgen
-    {
-        enum status
-        {
-            initial,
-            accumulate,
-            generate
-        };
-
-    public:
-        explicit conv_adaptor_vcgen(VertexSource& source) :
-            m_source(&source), 
-            m_status(initial)
-        {}
-        void attach(VertexSource& source) { m_source = &source; }
-
-        Generator& generator() { return m_generator; }
-        const Generator& generator() const { return m_generator; }
-
-        Markers& markers() { return m_markers; }
-        const Markers& markers() const { return m_markers; }
-        
-        void rewind(unsigned path_id) 
-        { 
-            m_source->rewind(path_id); 
-            m_status = initial;
-        }
-
-        unsigned vertex(double* x, double* y);
-
-    private:
-        // Prohibit copying
-        conv_adaptor_vcgen(const conv_adaptor_vcgen<VertexSource, Generator, Markers>&);
-        const conv_adaptor_vcgen<VertexSource, Generator, Markers>& 
-            operator = (const conv_adaptor_vcgen<VertexSource, Generator, Markers>&);
-
-        VertexSource* m_source;
-        Generator     m_generator;
-        Markers       m_markers;
-        status        m_status;
-        unsigned      m_last_cmd = 0;
-        double        m_start_x = 0;
-        double        m_start_y = 0;
-    };
-
-
-
-
-
-    //------------------------------------------------------------------------
-    template<class VertexSource, class Generator, class Markers> 
-    unsigned conv_adaptor_vcgen<VertexSource, Generator, Markers>::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_stop;
-        bool done = false;
-        while(!done)
-        {
-            switch(m_status)
-            {
-            case initial:
-                m_markers.remove_all();
-                m_last_cmd = m_source->vertex(&m_start_x, &m_start_y);
-                m_status = accumulate;
-                // FALLTHROUGH
-
-            case accumulate:
-                if(is_stop(m_last_cmd)) return path_cmd_stop;
-
-                m_generator.remove_all();
-                m_generator.add_vertex(m_start_x, m_start_y, path_cmd_move_to);
-                m_markers.add_vertex(m_start_x, m_start_y, path_cmd_move_to);
-
-                for(;;)
-                {
-                    cmd = m_source->vertex(x, y);
-                    if(is_vertex(cmd))
-                    {
-                        m_last_cmd = cmd;
-                        if(is_move_to(cmd))
-                        {
-                            m_start_x = *x;
-                            m_start_y = *y;
-                            break;
-                        }
-                        m_generator.add_vertex(*x, *y, cmd);
-                        m_markers.add_vertex(*x, *y, path_cmd_line_to);
-                    }
-                    else
-                    {
-                        if(is_stop(cmd))
-                        {
-                            m_last_cmd = path_cmd_stop;
-                            break;
-                        }
-                        if(is_end_poly(cmd))
-                        {
-                            m_generator.add_vertex(*x, *y, cmd);
-                            break;
-                        }
-                    }
-                }
-                m_generator.rewind(0);
-                m_status = generate;
-                // FALLTHROUGH
-
-            case generate:
-                cmd = m_generator.vertex(x, y);
-                if(is_stop(cmd))
-                {
-                    m_status = accumulate;
-                    break;
-                }
-                done = true;
-                break;
-            }
-        }
-        return cmd;
-    }
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_adaptor_vpgen.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_adaptor_vpgen.h
--- 8.0.1-5/renderers/agg/include/agg_conv_adaptor_vpgen.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_adaptor_vpgen.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,159 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_ADAPTOR_VPGEN_INCLUDED
-#define AGG_CONV_ADAPTOR_VPGEN_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //======================================================conv_adaptor_vpgen
-    template<class VertexSource, class VPGen> class conv_adaptor_vpgen
-    {
-    public:
-        explicit conv_adaptor_vpgen(VertexSource& source) : m_source(&source) {}
-        void attach(VertexSource& source) { m_source = &source; }
-
-        VPGen& vpgen() { return m_vpgen; }
-        const VPGen& vpgen() const { return m_vpgen; }
-
-        void rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        conv_adaptor_vpgen(const conv_adaptor_vpgen<VertexSource, VPGen>&);
-        const conv_adaptor_vpgen<VertexSource, VPGen>& 
-            operator = (const conv_adaptor_vpgen<VertexSource, VPGen>&);
-
-        VertexSource* m_source;
-        VPGen         m_vpgen;
-        double        m_start_x;
-        double        m_start_y;
-        unsigned      m_poly_flags;
-        int           m_vertices;
-    };
-
-
-
-    //------------------------------------------------------------------------
-    template<class VertexSource, class VPGen>
-    void conv_adaptor_vpgen<VertexSource, VPGen>::rewind(unsigned path_id) 
-    { 
-        m_source->rewind(path_id);
-        m_vpgen.reset();
-        m_start_x    = 0;
-        m_start_y    = 0;
-        m_poly_flags = 0;
-        m_vertices   = 0;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VertexSource, class VPGen>
-    unsigned conv_adaptor_vpgen<VertexSource, VPGen>::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_stop;
-        for(;;)
-        {
-            cmd = m_vpgen.vertex(x, y);
-            if(!is_stop(cmd)) break;
-
-            if(m_poly_flags && !m_vpgen.auto_unclose())
-            {
-                *x = 0.0;
-                *y = 0.0;
-                cmd = m_poly_flags;
-                m_poly_flags = 0;
-                break;
-            }
-
-            if(m_vertices < 0)
-            {
-                if(m_vertices < -1) 
-                {
-                    m_vertices = 0;
-                    return path_cmd_stop;
-                }
-                m_vpgen.move_to(m_start_x, m_start_y);
-                m_vertices = 1;
-                continue;
-            }
-
-            double tx, ty;
-            cmd = m_source->vertex(&tx, &ty);
-            if(is_vertex(cmd))
-            {
-                if(is_move_to(cmd)) 
-                {
-                    if(m_vpgen.auto_close() && m_vertices > 2)
-                    {
-                        m_vpgen.line_to(m_start_x, m_start_y);
-                        m_poly_flags = path_cmd_end_poly | path_flags_close;
-                        m_start_x    = tx;
-                        m_start_y    = ty;
-                        m_vertices   = -1;
-                        continue;
-                    }
-                    m_vpgen.move_to(tx, ty);
-                    m_start_x  = tx;
-                    m_start_y  = ty;
-                    m_vertices = 1;
-                }
-                else 
-                {
-                    m_vpgen.line_to(tx, ty);
-                    ++m_vertices;
-                }
-            }
-            else
-            {
-                if(is_end_poly(cmd))
-                {
-                    m_poly_flags = cmd;
-                    if(is_closed(cmd) || m_vpgen.auto_close())
-                    {
-                        if(m_vpgen.auto_close()) m_poly_flags |= path_flags_close;
-                        if(m_vertices > 2)
-                        {
-                            m_vpgen.line_to(m_start_x, m_start_y);
-                        }
-                        m_vertices = 0;
-                    }
-                }
-                else
-                {
-                    // path_cmd_stop
-                    if(m_vpgen.auto_close() && m_vertices > 2)
-                    {
-                        m_vpgen.line_to(m_start_x, m_start_y);
-                        m_poly_flags = path_cmd_end_poly | path_flags_close;
-                        m_vertices   = -2;
-                        continue;
-                    }
-                    break;
-                }
-            }
-        }
-        return cmd;
-    }
-
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_bspline.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_bspline.h
--- 8.0.1-5/renderers/agg/include/agg_conv_bspline.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_bspline.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_BSPLINE_INCLUDED
-#define AGG_CONV_BSPLINE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vcgen_bspline.h"
-#include "agg_conv_adaptor_vcgen.h"
-
-
-namespace mapserver
-{
-
-    //---------------------------------------------------------conv_bspline
-    template<class VertexSource> 
-    struct conv_bspline : public conv_adaptor_vcgen<VertexSource, vcgen_bspline>
-    {
-        typedef conv_adaptor_vcgen<VertexSource, vcgen_bspline> base_type;
-
-        conv_bspline(VertexSource& vs) : 
-            conv_adaptor_vcgen<VertexSource, vcgen_bspline>(vs) {}
-
-        void   interpolation_step(double v) { base_type::generator().interpolation_step(v); }
-        double interpolation_step() const { return base_type::generator().interpolation_step(); }
-
-    private:
-        conv_bspline(const conv_bspline<VertexSource>&);
-        const conv_bspline<VertexSource>& 
-            operator = (const conv_bspline<VertexSource>&);
-    };
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_clip_polygon.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_clip_polygon.h
--- 8.0.1-5/renderers/agg/include/agg_conv_clip_polygon.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_clip_polygon.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,63 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Polygon clipping converter
-// There an optimized Liang-Basky algorithm is used. 
-// The algorithm doesn't optimize the degenerate edges, i.e. it will never
-// break a closed polygon into two or more ones, instead, there will be 
-// degenerate edges coinciding with the respective clipping boundaries.
-// This is a sub-optimal solution, because that optimization would require 
-// extra, rather expensive math while the rasterizer tolerates it quite well, 
-// without any considerable overhead.
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_CLIP_POLYGON_INCLUDED
-#define AGG_CONV_CLIP_POLYGON_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_conv_adaptor_vpgen.h"
-#include "agg_vpgen_clip_polygon.h"
-
-namespace mapserver
-{
-
-    //=======================================================conv_clip_polygon
-    template<class VertexSource> 
-    struct conv_clip_polygon : public conv_adaptor_vpgen<VertexSource, vpgen_clip_polygon>
-    {
-        typedef conv_adaptor_vpgen<VertexSource, vpgen_clip_polygon> base_type;
-
-        conv_clip_polygon(VertexSource& vs) : 
-            conv_adaptor_vpgen<VertexSource, vpgen_clip_polygon>(vs) {}
-
-        void clip_box(double x1, double y1, double x2, double y2)
-        {
-            base_type::vpgen().clip_box(x1, y1, x2, y2);
-        }
-
-        double x1() const { return base_type::vpgen().x1(); }
-        double y1() const { return base_type::vpgen().y1(); }
-        double x2() const { return base_type::vpgen().x2(); }
-        double y2() const { return base_type::vpgen().y2(); }
-
-    private:
-        conv_clip_polygon(const conv_clip_polygon<VertexSource>&);
-        const conv_clip_polygon<VertexSource>& 
-            operator = (const conv_clip_polygon<VertexSource>&);
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_clip_polyline.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_clip_polyline.h
--- 8.0.1-5/renderers/agg/include/agg_conv_clip_polyline.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_clip_polyline.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,63 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// polyline clipping converter
-// There an optimized Liang-Basky algorithm is used. 
-// The algorithm doesn't optimize the degenerate edges, i.e. it will never
-// break a closed polyline into two or more ones, instead, there will be 
-// degenerate edges coinciding with the respective clipping boundaries.
-// This is a sub-optimal solution, because that optimization would require 
-// extra, rather expensive math while the rasterizer tolerates it quite well, 
-// without any considerable overhead.
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_CLIP_polyline_INCLUDED
-#define AGG_CONV_CLIP_polyline_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_conv_adaptor_vpgen.h"
-#include "agg_vpgen_clip_polyline.h"
-
-namespace mapserver
-{
-
-    //=======================================================conv_clip_polyline
-    template<class VertexSource> 
-    struct conv_clip_polyline : public conv_adaptor_vpgen<VertexSource, vpgen_clip_polyline>
-    {
-        typedef conv_adaptor_vpgen<VertexSource, vpgen_clip_polyline> base_type;
-
-        conv_clip_polyline(VertexSource& vs) : 
-            conv_adaptor_vpgen<VertexSource, vpgen_clip_polyline>(vs) {}
-
-        void clip_box(double x1, double y1, double x2, double y2)
-        {
-            base_type::vpgen().clip_box(x1, y1, x2, y2);
-        }
-
-        double x1() const { return base_type::vpgen().x1(); }
-        double y1() const { return base_type::vpgen().y1(); }
-        double x2() const { return base_type::vpgen().x2(); }
-        double y2() const { return base_type::vpgen().y2(); }
-
-    private:
-        conv_clip_polyline(const conv_clip_polyline<VertexSource>&);
-        const conv_clip_polyline<VertexSource>& 
-            operator = (const conv_clip_polyline<VertexSource>&);
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_clipper.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_clipper.h
--- 8.0.1-5/renderers/agg/include/agg_conv_clipper.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_clipper.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,299 +0,0 @@
-/*******************************************************************************
-*                                                                              *
-* Author    :  Angus Johnson                                                   *
-* Version   :  1.1                                                             *
-* Date      :  4 April 2011                                                    *
-* Website   :  http://www.angusj.com                                           *
-* Copyright :  Angus Johnson 2010-2011                                         *
-*                                                                              *
-* License:                                                                     *
-* Use, modification & distribution is subject to Boost Software License Ver 1. *
-* http://www.boost.org/LICENSE_1_0.txt                                         *
-*                                                                              *
-*******************************************************************************/
-
-#ifndef AGG_CONV_CLIPPER_INCLUDED
-#define AGG_CONV_CLIPPER_INCLUDED
-
-#if defined(_MSC_VER) && (_MSC_VER >= 1800)
-#include <algorithm>
-#endif
-
-#include <cmath>
-#include "agg_basics.h"
-#include "agg_array.h"
-#include "clipper.hpp"
-
-namespace mapserver
-{
-  enum clipper_op_e { clipper_or,
-    clipper_and, clipper_xor, clipper_a_minus_b, clipper_b_minus_a };
-  enum clipper_PolyFillType {clipper_even_odd, clipper_non_zero, clipper_positive, clipper_negative};
-
-  template<class VSA, class VSB> class conv_clipper
-  {
-    enum status { status_move_to, status_line_to, status_stop };
-    typedef VSA source_a_type;
-    typedef VSB source_b_type;
-    typedef conv_clipper<source_a_type, source_b_type> self_type;
-
-  private:
-    source_a_type*							m_src_a;
-    source_b_type*							m_src_b;
-    status									m_status;
-    int										m_vertex;
-    int										m_contour;
-	int										m_scaling_factor;
-    clipper_op_e							m_operation;
-    pod_bvector<ClipperLib::IntPoint, 8>		m_vertex_accumulator;
-    ClipperLib::Polygons						m_poly_a;
-    ClipperLib::Polygons						m_poly_b;
-    ClipperLib::Polygons						m_result;
-    ClipperLib::Clipper						m_clipper;
-    clipper_PolyFillType					m_subjFillType;
-    clipper_PolyFillType					m_clipFillType;
-
-    int Round(double val)
-    {
-    if ((val < 0)) return (int)(val - 0.5); else return (int)(val + 0.5);
-    }
-
-  public:
-    conv_clipper(source_a_type &a, source_b_type &b,
-      clipper_op_e op = clipper_or,
-      clipper_PolyFillType subjFillType = clipper_even_odd,
-      clipper_PolyFillType clipFillType = clipper_even_odd,
-	  int scaling_factor = 2) :
-        m_src_a(&a),
-        m_src_b(&b),
-        m_status(status_move_to),
-        m_vertex(-1),
-        m_contour(-1),
-        m_operation(op),
-        m_subjFillType(subjFillType),
-        m_clipFillType(clipFillType)
-    {
-		m_scaling_factor = std::max(std::min(scaling_factor, 6),0);
-		m_scaling_factor = Round(std::pow((double)10, m_scaling_factor));
-	}
-
-    ~conv_clipper()
-    {
-    }
-
-    void attach1(VSA &source, clipper_PolyFillType subjFillType = clipper_even_odd)
-      { m_src_a = &source; m_subjFillType = subjFillType; }
-    void attach2(VSB &source, clipper_PolyFillType clipFillType = clipper_even_odd)
-      { m_src_b = &source; m_clipFillType = clipFillType; }
-
-    void operation(clipper_op_e v) { m_operation = v; }
-
-    void rewind(unsigned path_id);
-    unsigned vertex(double* x, double* y);
-  
-    bool next_contour();
-    bool next_vertex(double* x, double* y);
-    void start_extracting();
-    void add_vertex_(double &x, double &y);
-    void end_contour(ClipperLib::Polygons &p);
-
-	template<class VS> void add(VS &src, ClipperLib::Polygons &p){
-		unsigned cmd;
-		double x; double y; double start_x; double start_y;
-		bool starting_first_line;
-
-		start_x = 0.0;
-		start_y = 0.0;
-		starting_first_line = true;
-		p.resize(0);
-
-		cmd = src->vertex( &x , &y );
-		while(!is_stop(cmd))
-		{
-		  if(is_vertex(cmd))
-		  {
-			if(is_move_to(cmd))
-			{
-			  if(!starting_first_line ) end_contour(p);
-			  start_x = x;
-			  start_y = y;
-			}
-			add_vertex_( x, y );
-			starting_first_line = false;
-		  }
-		  else if(is_end_poly(cmd))
-		  {
-			if(!starting_first_line && is_closed(cmd))
-			  add_vertex_( start_x, start_y );
-		  }
-		  cmd = src->vertex( &x, &y );
-		}
-		end_contour(p);
-	}
-  };
-
-  //------------------------------------------------------------------------
-
-  template<class VSA, class VSB> 
-  void conv_clipper<VSA, VSB>::start_extracting()
-  {
-    m_status = status_move_to;
-    m_contour = -1;
-    m_vertex = -1;
-  }
-  //------------------------------------------------------------------------------
-
-  template<class VSA, class VSB>
-  void conv_clipper<VSA, VSB>::rewind(unsigned path_id)
-  {
-    m_src_a->rewind( path_id );
-    m_src_b->rewind( path_id );
-
-    add( m_src_a , m_poly_a );
-    add( m_src_b , m_poly_b );
-    m_result.resize(0);
-
-    ClipperLib::PolyFillType pftSubj, pftClip;
-    switch (m_subjFillType)
-    {
-      case clipper_even_odd: pftSubj = ClipperLib::pftEvenOdd; break;
-      case clipper_non_zero: pftSubj = ClipperLib::pftNonZero; break;
-      case clipper_positive: pftSubj = ClipperLib::pftPositive; break;
-      default: pftSubj = ClipperLib::pftNegative;
-    }
-    switch (m_clipFillType)
-    {
-      case clipper_even_odd: pftClip = ClipperLib::pftEvenOdd; break;
-      case clipper_non_zero: pftClip = ClipperLib::pftNonZero; break;
-      case clipper_positive: pftClip = ClipperLib::pftPositive; break;
-      default: pftClip = ClipperLib::pftNegative;
-    }
-
-    m_clipper.Clear();
-    switch( m_operation ) {
-      case clipper_or:
-        {
-        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
-        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
-        m_clipper.Execute( ClipperLib::ctUnion , m_result , pftSubj, pftClip);
-		break;
-        }
-      case clipper_and:
-        {
-        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
-        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
-        m_clipper.Execute( ClipperLib::ctIntersection , m_result, pftSubj, pftClip );
-		break;
-        }
-      case clipper_xor:
-        {
-        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
-        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
-        m_clipper.Execute( ClipperLib::ctXor , m_result, pftSubj, pftClip );
-		break;
-        }
-      case clipper_a_minus_b:
-        {
-        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
-        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
-        m_clipper.Execute( ClipperLib::ctDifference , m_result, pftSubj, pftClip );
-		break;
-        }
-      case clipper_b_minus_a:
-        {
-        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptSubject );
-        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptClip );
-        m_clipper.Execute( ClipperLib::ctDifference , m_result, pftSubj, pftClip );
-		break;
-        }
-    }
-    start_extracting();
-  }
-  //------------------------------------------------------------------------------
-
-  template<class VSA, class VSB>
-  void conv_clipper<VSA, VSB>::end_contour( ClipperLib::Polygons &p)
-  {
-  unsigned i, len;
-
-  if( m_vertex_accumulator.size() < 3 ) return;
-  len = p.size();
-  p.resize(len+1);
-  p[len].resize(m_vertex_accumulator.size());
-  for( i = 0 ; i < m_vertex_accumulator.size() ; i++ )
-    p[len][i] = m_vertex_accumulator[i];
-  m_vertex_accumulator.remove_all();
-  }
-  //------------------------------------------------------------------------------
-
-  template<class VSA, class VSB> 
-  void conv_clipper<VSA, VSB>::add_vertex_(double &x, double &y)
-  {
-	  ClipperLib::IntPoint v;
-
-	  v.X = Round(x * m_scaling_factor);
-	  v.Y = Round(y * m_scaling_factor);
-	  m_vertex_accumulator.add( v );
-  }
-  //------------------------------------------------------------------------------
-
-  template<class VSA, class VSB> 
-  bool conv_clipper<VSA, VSB>::next_contour()
-  {   
-	m_contour++;
-	if(m_contour >= (int)m_result.size()) return false;
-	m_vertex =-1;
-	return true;
-}
-//------------------------------------------------------------------------------
-
-  template<class VSA, class VSB> 
-  bool conv_clipper<VSA, VSB>::next_vertex(double *x, double *y)
-  {
-    m_vertex++;
-    if(m_vertex >= (int)m_result[m_contour].size()) return false;
-    *x = (double)m_result[ m_contour ][ m_vertex ].X / m_scaling_factor;
-    *y = (double)m_result[ m_contour ][ m_vertex ].Y / m_scaling_factor;
-    return true;
-  }
-  //------------------------------------------------------------------------------
-
-  template<class VSA, class VSB>
-  unsigned conv_clipper<VSA, VSB>::vertex(double *x, double *y)
-{
-  if(  m_status == status_move_to )
-  {
-    if( next_contour() )
-    {
-      if(  next_vertex( x, y ) )
-      {
-        m_status =status_line_to;
-        return path_cmd_move_to;
-      }
-	  else
-	  {
-        m_status = status_stop;
-        return path_cmd_end_poly | path_flags_close;
-      }
-    }
-	else
-      return path_cmd_stop;
-  }
-  else
-  {
-    if(  next_vertex( x, y ) )
-    {
-      return path_cmd_line_to;
-    }
-	else
-    {
-      m_status = status_move_to;
-      return path_cmd_end_poly | path_flags_close;
-    }
-  }
-}
-//------------------------------------------------------------------------------
-
-
-} //namespace agg
-#endif //AGG_CONV_CLIPPER_INCLUDED
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_close_polygon.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_close_polygon.h
--- 8.0.1-5/renderers/agg/include/agg_conv_close_polygon.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_close_polygon.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,125 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_CLOSE_POLYGON_INCLUDED
-#define AGG_CONV_CLOSE_POLYGON_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //======================================================conv_close_polygon
-    template<class VertexSource> class conv_close_polygon
-    {
-    public:
-        explicit conv_close_polygon(VertexSource& vs) : m_source(&vs) {}
-        void attach(VertexSource& source) { m_source = &source; }
-
-        void rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        conv_close_polygon(const conv_close_polygon<VertexSource>&);
-        const conv_close_polygon<VertexSource>& 
-            operator = (const conv_close_polygon<VertexSource>&);
-
-        VertexSource* m_source;
-        unsigned      m_cmd[2];
-        double        m_x[2];
-        double        m_y[2];
-        unsigned      m_vertex;
-        bool          m_line_to;
-    };
-
-
-
-    //------------------------------------------------------------------------
-    template<class VertexSource> 
-    void conv_close_polygon<VertexSource>::rewind(unsigned path_id)
-    {
-        m_source->rewind(path_id);
-        m_vertex = 2;
-        m_line_to = false;
-    }
-
-
-    
-    //------------------------------------------------------------------------
-    template<class VertexSource> 
-    unsigned conv_close_polygon<VertexSource>::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_stop;
-        for(;;)
-        {
-            if(m_vertex < 2)
-            {
-                *x = m_x[m_vertex];
-                *y = m_y[m_vertex];
-                cmd = m_cmd[m_vertex];
-                ++m_vertex;
-                break;
-            }
-
-            cmd = m_source->vertex(x, y);
-
-            if(is_end_poly(cmd))
-            {
-                cmd |= path_flags_close;
-                break;
-            }
-
-            if(is_stop(cmd))
-            {
-                if(m_line_to)
-                {
-                    m_cmd[0]  = path_cmd_end_poly | path_flags_close;
-                    m_cmd[1]  = path_cmd_stop;
-                    m_vertex  = 0;
-                    m_line_to = false;
-                    continue;
-                }
-                break;
-            }
-
-            if(is_move_to(cmd))
-            {
-                if(m_line_to)
-                {
-                    m_x[0]    = 0.0;
-                    m_y[0]    = 0.0;
-                    m_cmd[0]  = path_cmd_end_poly | path_flags_close;
-                    m_x[1]    = *x;
-                    m_y[1]    = *y;
-                    m_cmd[1]  = cmd;
-                    m_vertex  = 0;
-                    m_line_to = false;
-                    continue;
-                }
-                break;
-            }
-
-            if(is_vertex(cmd))
-            {
-                m_line_to = true;
-                break;
-            }
-        }
-        return cmd;
-    }
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_concat.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_concat.h
--- 8.0.1-5/renderers/agg/include/agg_conv_concat.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_concat.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,73 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_CONCAT_INCLUDED
-#define AGG_CONV_CONCAT_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //=============================================================conv_concat
-    // Concatenation of two paths. Usually used to combine lines or curves 
-    // with markers such as arrowheads
-    template<class VS1, class VS2> class conv_concat
-    {
-    public:
-        conv_concat(VS1& source1, VS2& source2) :
-            m_source1(&source1), m_source2(&source2), m_status(2) {}
-        void attach1(VS1& source) { m_source1 = &source; }
-        void attach2(VS2& source) { m_source2 = &source; }
-
-
-        void rewind(unsigned path_id)
-        { 
-            m_source1->rewind(path_id);
-            m_source2->rewind(0);
-            m_status = 0;
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            unsigned cmd;
-            if(m_status == 0)
-            {
-                cmd = m_source1->vertex(x, y);
-                if(!is_stop(cmd)) return cmd;
-                m_status = 1;
-            }
-            if(m_status == 1)
-            {
-                cmd = m_source2->vertex(x, y);
-                if(!is_stop(cmd)) return cmd;
-                m_status = 2;
-            }
-            return path_cmd_stop;
-        }
-
-    private:
-        conv_concat(const conv_concat<VS1, VS2>&);
-        const conv_concat<VS1, VS2>& 
-            operator = (const conv_concat<VS1, VS2>&);
-
-        VS1* m_source1;
-        VS2* m_source2;
-        int  m_status;
-
-    };
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_contour.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_contour.h
--- 8.0.1-5/renderers/agg/include/agg_conv_contour.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_contour.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,65 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// conv_stroke
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_CONTOUR_INCLUDED
-#define AGG_CONV_CONTOUR_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vcgen_contour.h"
-#include "agg_conv_adaptor_vcgen.h"
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------------conv_contour
-    template<class VertexSource> 
-    struct conv_contour : public conv_adaptor_vcgen<VertexSource, vcgen_contour>
-    {
-        typedef conv_adaptor_vcgen<VertexSource, vcgen_contour> base_type;
-
-        conv_contour(VertexSource& vs) : 
-            conv_adaptor_vcgen<VertexSource, vcgen_contour>(vs)
-        {
-        }
-
-        void line_join(line_join_e lj) { base_type::generator().line_join(lj); }
-        void inner_join(inner_join_e ij) { base_type::generator().inner_join(ij); }
-        void width(double w) { base_type::generator().width(w); }
-        void miter_limit(double ml) { base_type::generator().miter_limit(ml); }
-        void miter_limit_theta(double t) { base_type::generator().miter_limit_theta(t); }
-        void inner_miter_limit(double ml) { base_type::generator().inner_miter_limit(ml); }
-        void approximation_scale(double as) { base_type::generator().approximation_scale(as); }
-        void auto_detect_orientation(bool v) { base_type::generator().auto_detect_orientation(v); }
-
-        line_join_e line_join() const { return base_type::generator().line_join(); }
-        inner_join_e inner_join() const { return base_type::generator().inner_join(); }
-        double width() const { return base_type::generator().width(); }
-        double miter_limit() const { return base_type::generator().miter_limit(); }
-        double inner_miter_limit() const { return base_type::generator().inner_miter_limit(); }
-        double approximation_scale() const { return base_type::generator().approximation_scale(); }
-        bool auto_detect_orientation() const { return base_type::generator().auto_detect_orientation(); }
-
-    private:
-        conv_contour(const conv_contour<VertexSource>&);
-        const conv_contour<VertexSource>& 
-            operator = (const conv_contour<VertexSource>&);
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_curve.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_curve.h
--- 8.0.1-5/renderers/agg/include/agg_conv_curve.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_curve.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,201 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// classes conv_curve
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_CURVE_INCLUDED
-#define AGG_CONV_CURVE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_curves.h"
-
-namespace mapserver
-{
-
-
-    //---------------------------------------------------------------conv_curve
-    // Curve converter class. Any path storage can have Bezier curves defined 
-    // by their control points. There're two types of curves supported: curve3 
-    // and curve4. Curve3 is a conic Bezier curve with 2 endpoints and 1 control
-    // point. Curve4 has 2 control points (4 points in total) and can be used
-    // to interpolate more complicated curves. Curve4, unlike curve3 can be used 
-    // to approximate arcs, both circular and elliptical. Curves are approximated 
-    // with straight lines and one of the approaches is just to store the whole 
-    // sequence of vertices that approximate our curve. It takes additional 
-    // memory, and at the same time the consecutive vertices can be calculated 
-    // on demand. 
-    //
-    // Initially, path storages are not suppose to keep all the vertices of the
-    // curves (although, nothing prevents us from doing so). Instead, path_storage
-    // keeps only vertices, needed to calculate a curve on demand. Those vertices
-    // are marked with special commands. So, if the path_storage contains curves 
-    // (which are not real curves yet), and we render this storage directly, 
-    // all we will see is only 2 or 3 straight line segments (for curve3 and 
-    // curve4 respectively). If we need to see real curves drawn we need to 
-    // include this class into the conversion pipeline. 
-    //
-    // Class conv_curve recognizes commands path_cmd_curve3 and path_cmd_curve4 
-    // and converts these vertices into a move_to/line_to sequence. 
-    //-----------------------------------------------------------------------
-    template<class VertexSource, 
-             class Curve3=curve3, 
-             class Curve4=curve4> class conv_curve
-    {
-    public:
-        typedef Curve3 curve3_type;
-        typedef Curve4 curve4_type;
-        typedef conv_curve<VertexSource, Curve3, Curve4> self_type;
-
-        explicit conv_curve(VertexSource& source) :
-          m_source(&source), m_last_x(0.0), m_last_y(0.0) {}
-        void attach(VertexSource& source) { m_source = &source; }
-
-        void approximation_method(curve_approximation_method_e v) 
-        { 
-            m_curve3.approximation_method(v);
-            m_curve4.approximation_method(v);
-        }
-
-        curve_approximation_method_e approximation_method() const 
-        { 
-            return m_curve4.approximation_method();
-        }
-
-        void approximation_scale(double s) 
-        { 
-            m_curve3.approximation_scale(s); 
-            m_curve4.approximation_scale(s); 
-        }
-
-        double approximation_scale() const 
-        { 
-            return m_curve4.approximation_scale();  
-        }
-
-        void angle_tolerance(double v) 
-        { 
-            m_curve3.angle_tolerance(v); 
-            m_curve4.angle_tolerance(v); 
-        }
-
-        double angle_tolerance() const 
-        { 
-            return m_curve4.angle_tolerance();  
-        }
-
-        void cusp_limit(double v) 
-        { 
-            m_curve3.cusp_limit(v); 
-            m_curve4.cusp_limit(v); 
-        }
-
-        double cusp_limit() const 
-        { 
-            return m_curve4.cusp_limit();  
-        }
-
-        void     rewind(unsigned path_id); 
-        unsigned vertex(double* x, double* y);
-
-    private:
-        conv_curve(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        VertexSource* m_source;
-        double        m_last_x;
-        double        m_last_y;
-        curve3_type   m_curve3;
-        curve4_type   m_curve4;
-    };
-
-
-
-    //------------------------------------------------------------------------
-    template<class VertexSource, class Curve3, class Curve4>
-    void conv_curve<VertexSource, Curve3, Curve4>::rewind(unsigned path_id)
-    {
-        m_source->rewind(path_id);
-        m_last_x = 0.0;
-        m_last_y = 0.0;
-        m_curve3.reset();
-        m_curve4.reset();
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VertexSource, class Curve3, class Curve4>
-    unsigned conv_curve<VertexSource, Curve3, Curve4>::vertex(double* x, double* y)
-    {
-        if(!is_stop(m_curve3.vertex(x, y)))
-        {
-            m_last_x = *x;
-            m_last_y = *y;
-            return path_cmd_line_to;
-        }
-
-        if(!is_stop(m_curve4.vertex(x, y)))
-        {
-            m_last_x = *x;
-            m_last_y = *y;
-            return path_cmd_line_to;
-        }
-
-        double ct2_x = 0;
-        double ct2_y = 0;
-        double end_x = 0;
-        double end_y = 0;
-
-        unsigned cmd = m_source->vertex(x, y);
-        switch(cmd)
-        {
-        case path_cmd_curve3:
-            m_source->vertex(&end_x, &end_y);
-
-            m_curve3.init(m_last_x, m_last_y, 
-                          *x,       *y, 
-                          end_x,     end_y);
-
-            m_curve3.vertex(x, y);    // First call returns path_cmd_move_to
-            m_curve3.vertex(x, y);    // This is the first vertex of the curve
-            cmd = path_cmd_line_to;
-            break;
-
-        case path_cmd_curve4:
-            m_source->vertex(&ct2_x, &ct2_y);
-            m_source->vertex(&end_x, &end_y);
-
-            m_curve4.init(m_last_x, m_last_y, 
-                          *x,       *y, 
-                          ct2_x,    ct2_y, 
-                          end_x,    end_y);
-
-            m_curve4.vertex(x, y);    // First call returns path_cmd_move_to
-            m_curve4.vertex(x, y);    // This is the first vertex of the curve
-            cmd = path_cmd_line_to;
-            break;
-        }
-        m_last_x = *x;
-        m_last_y = *y;
-        return cmd;
-    }
-
-
-}
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_dash.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_dash.h
--- 8.0.1-5/renderers/agg/include/agg_conv_dash.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_dash.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,68 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// conv_dash
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_DASH_INCLUDED
-#define AGG_CONV_DASH_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vcgen_dash.h"
-#include "agg_conv_adaptor_vcgen.h"
-
-namespace mapserver
-{
-
-    //---------------------------------------------------------------conv_dash
-    template<class VertexSource, class Markers=null_markers> 
-    struct conv_dash : public conv_adaptor_vcgen<VertexSource, vcgen_dash, Markers>
-    {
-        typedef Markers marker_type;
-        typedef conv_adaptor_vcgen<VertexSource, vcgen_dash, Markers> base_type;
-
-        conv_dash(VertexSource& vs) : 
-            conv_adaptor_vcgen<VertexSource, vcgen_dash, Markers>(vs)
-        {
-        }
-
-        void remove_all_dashes() 
-        { 
-            base_type::generator().remove_all_dashes(); 
-        }
-
-        void add_dash(double dash_len, double gap_len) 
-        { 
-            base_type::generator().add_dash(dash_len, gap_len); 
-        }
-
-        void dash_start(double ds) 
-        { 
-            base_type::generator().dash_start(ds); 
-        }
-
-        void shorten(double s) { base_type::generator().shorten(s); }
-        double shorten() const { return base_type::generator().shorten(); }
-
-    private:
-        conv_dash(const conv_dash<VertexSource, Markers>&);
-        const conv_dash<VertexSource, Markers>& 
-            operator = (const conv_dash<VertexSource, Markers>&);
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_gpc.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_gpc.h
--- 8.0.1-5/renderers/agg/include/agg_conv_gpc.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_gpc.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,432 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// General Polygon Clipper based on the GPC library by Alan Murta 
-// Union, Intersection, XOR, A-B, B-A
-// Contact the author if you intend to use it in commercial applications!
-// http://www.cs.man.ac.uk/aig/staff/alan/software/
-// Alan Murta (email: gpc@cs.man.ac.uk)
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_GPC_INCLUDED
-#define AGG_CONV_GPC_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-#include "agg_array.h"
-
-extern "C" 
-{ 
-#include "gpc.h" 
-}
-
-namespace mapserver
-{
-    enum gpc_op_e
-    {
-        gpc_or,
-        gpc_and,
-        gpc_xor,
-        gpc_a_minus_b,
-        gpc_b_minus_a
-    };
-
-
-    //================================================================conv_gpc
-    template<class VSA, class VSB> class conv_gpc
-    {
-        enum status
-        {
-            status_move_to,
-            status_line_to,
-            status_stop
-        };
-
-        struct contour_header_type
-        {
-            int num_vertices;
-            int hole_flag;
-            gpc_vertex* vertices;
-        };
-
-        typedef pod_bvector<gpc_vertex, 8>          vertex_array_type;
-        typedef pod_bvector<contour_header_type, 6> contour_header_array_type;
-
-
-    public:
-        typedef VSA source_a_type;
-        typedef VSB source_b_type;
-        typedef conv_gpc<source_a_type, source_b_type> self_type;
-
-        ~conv_gpc()
-        {
-            free_gpc_data();
-        }
-
-        conv_gpc(source_a_type& a, source_b_type& b, gpc_op_e op = gpc_or) :
-            m_src_a(&a),
-            m_src_b(&b),
-            m_status(status_move_to),
-            m_vertex(-1),
-            m_contour(-1),
-            m_operation(op)
-        {
-            memset(&m_poly_a, 0, sizeof(m_poly_a));
-            memset(&m_poly_b, 0, sizeof(m_poly_b));
-            memset(&m_result, 0, sizeof(m_result));
-        }
-
-        void attach1(VSA& source) { m_src_a = &source; }
-        void attach2(VSB& source) { m_src_b = &source; }
-
-        void operation(gpc_op_e v) { m_operation = v; }
-
-        // Vertex Source Interface
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        conv_gpc(const conv_gpc<VSA, VSB>&);
-        const conv_gpc<VSA, VSB>& operator = (const conv_gpc<VSA, VSB>&);
-
-        //--------------------------------------------------------------------
-        void free_polygon(gpc_polygon& p);
-        void free_result();
-        void free_gpc_data();
-        void start_contour();
-        void add_vertex(double x, double y);
-        void end_contour(unsigned orientation);
-        void make_polygon(gpc_polygon& p);
-        void start_extracting();
-        bool next_contour();
-        bool next_vertex(double* x, double* y);
-
-
-        //--------------------------------------------------------------------
-        template<class VS> void add(VS& src, gpc_polygon& p)
-        {
-            unsigned cmd;
-            double x, y;
-            double start_x = 0.0;
-            double start_y = 0.0;
-            bool line_to = false;
-            unsigned orientation = 0;
-
-            m_contour_accumulator.remove_all();
-
-            while(!is_stop(cmd = src.vertex(&x, &y)))
-            {
-                if(is_vertex(cmd))
-                {
-                    if(is_move_to(cmd))
-                    {
-                        if(line_to)
-                        {
-                            end_contour(orientation);
-                            orientation = 0;
-                        }
-                        start_contour();
-                        start_x = x;
-                        start_y = y;
-                    }
-                    add_vertex(x, y);
-                    line_to = true;
-                }
-                else
-                {
-                    if(is_end_poly(cmd))
-                    {
-                        orientation = get_orientation(cmd);
-                        if(line_to && is_closed(cmd))
-                        {
-                            add_vertex(start_x, start_y);
-                        }
-                    }
-                }
-            }
-            if(line_to)
-            {
-                end_contour(orientation);
-            }
-            make_polygon(p);
-        }
-
-
-    private:
-        //--------------------------------------------------------------------
-        source_a_type*             m_src_a;
-        source_b_type*             m_src_b;
-        status                     m_status;
-        int                        m_vertex;
-        int                        m_contour;
-        gpc_op_e                   m_operation;
-        vertex_array_type          m_vertex_accumulator;
-        contour_header_array_type  m_contour_accumulator;
-        gpc_polygon                m_poly_a;
-        gpc_polygon                m_poly_b;
-        gpc_polygon                m_result;
-    };
-
-
-
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::free_polygon(gpc_polygon& p)
-    {
-        int i;
-        for(i = 0; i < p.num_contours; i++)
-        {
-            pod_allocator<gpc_vertex>::deallocate(p.contour[i].vertex, 
-                                                  p.contour[i].num_vertices);
-        }
-        pod_allocator<gpc_vertex_list>::deallocate(p.contour, p.num_contours);
-        memset(&p, 0, sizeof(gpc_polygon));
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::free_result()
-    {
-        if(m_result.contour)
-        {
-            gpc_free_polygon(&m_result);
-        }
-        memset(&m_result, 0, sizeof(m_result));
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::free_gpc_data()
-    {
-        free_polygon(m_poly_a);
-        free_polygon(m_poly_b);
-        free_result();
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::start_contour()
-    {
-        contour_header_type h;
-        memset(&h, 0, sizeof(h));
-        m_contour_accumulator.add(h);
-        m_vertex_accumulator.remove_all();
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    inline void conv_gpc<VSA, VSB>::add_vertex(double x, double y)
-    {
-        gpc_vertex v;
-        v.x = x;
-        v.y = y;
-        m_vertex_accumulator.add(v);
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::end_contour(unsigned orientation)
-    {
-        if(m_contour_accumulator.size())
-        {
-            if(m_vertex_accumulator.size() > 2)
-            {
-                contour_header_type& h = 
-                    m_contour_accumulator[m_contour_accumulator.size() - 1];
-
-                h.num_vertices = m_vertex_accumulator.size();
-                h.hole_flag = 0;
-
-                // TO DO: Clarify the "holes"
-                //if(is_cw(orientation)) h.hole_flag = 1;
-
-                h.vertices = pod_allocator<gpc_vertex>::allocate(h.num_vertices);
-                gpc_vertex* d = h.vertices;
-                int i;
-                for(i = 0; i < h.num_vertices; i++)
-                {
-                    const gpc_vertex& s = m_vertex_accumulator[i];
-                    d->x = s.x;
-                    d->y = s.y;
-                    ++d;
-                }
-            }
-            else
-            {
-                m_vertex_accumulator.remove_last();
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::make_polygon(gpc_polygon& p)
-    {
-        free_polygon(p);
-        if(m_contour_accumulator.size())
-        {
-            p.num_contours = m_contour_accumulator.size();
-
-            p.hole = 0;
-            p.contour = pod_allocator<gpc_vertex_list>::allocate(p.num_contours);
-
-            int i;
-            gpc_vertex_list* pv = p.contour;
-            for(i = 0; i < p.num_contours; i++)
-            {
-                const contour_header_type& h = m_contour_accumulator[i];
-                pv->num_vertices = h.num_vertices;
-                pv->vertex = h.vertices;
-                ++pv;
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::start_extracting()
-    {
-        m_status = status_move_to;
-        m_contour = -1;
-        m_vertex = -1;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    bool conv_gpc<VSA, VSB>::next_contour()
-    {
-        if(++m_contour < m_result.num_contours)
-        {
-            m_vertex = -1;
-            return true;
-        }
-        return false;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    inline bool conv_gpc<VSA, VSB>::next_vertex(double* x, double* y)
-    {
-        const gpc_vertex_list& vlist = m_result.contour[m_contour];
-        if(++m_vertex < vlist.num_vertices)
-        {
-            const gpc_vertex& v = vlist.vertex[m_vertex];
-            *x = v.x;
-            *y = v.y;
-            return true;
-        }
-        return false;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    void conv_gpc<VSA, VSB>::rewind(unsigned path_id)
-    {
-        free_result();
-        m_src_a->rewind(path_id);
-        m_src_b->rewind(path_id);
-        add(*m_src_a, m_poly_a);
-        add(*m_src_b, m_poly_b);
-        switch(m_operation)
-        {
-           case gpc_or:
-                gpc_polygon_clip(GPC_UNION,
-                                 &m_poly_a,
-                                 &m_poly_b,
-                                 &m_result);
-               break;
-
-           case gpc_and:
-                gpc_polygon_clip(GPC_INT,
-                                 &m_poly_a,
-                                 &m_poly_b,
-                                 &m_result);
-               break;
-
-           case gpc_xor:
-                gpc_polygon_clip(GPC_XOR,
-                                 &m_poly_a,
-                                 &m_poly_b,
-                                 &m_result);
-               break;
-
-           case gpc_a_minus_b:
-                gpc_polygon_clip(GPC_DIFF,
-                                 &m_poly_a,
-                                 &m_poly_b,
-                                 &m_result);
-               break;
-
-           case gpc_b_minus_a:
-                gpc_polygon_clip(GPC_DIFF,
-                                 &m_poly_b,
-                                 &m_poly_a,
-                                 &m_result);
-               break;
-        }
-        start_extracting();
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VSA, class VSB> 
-    unsigned conv_gpc<VSA, VSB>::vertex(double* x, double* y)
-    {
-        if(m_status == status_move_to)
-        {
-            if(next_contour()) 
-            {
-                if(next_vertex(x, y))
-                {
-                    m_status = status_line_to;
-                    return path_cmd_move_to;
-                }
-                m_status = status_stop;
-                return path_cmd_end_poly | path_flags_close;
-            }
-        }
-        else
-        {
-            if(next_vertex(x, y))
-            {
-                return path_cmd_line_to;
-            }
-            else
-            {
-                m_status = status_move_to;
-            }
-            return path_cmd_end_poly | path_flags_close;
-        }
-        return path_cmd_stop;
-    }
-
-   
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_marker.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_marker.h
--- 8.0.1-5/renderers/agg/include/agg_conv_marker.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_marker.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,148 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// conv_marker
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_MARKER_INCLUDED
-#define AGG_CONV_MARKER_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_trans_affine.h"
-
-namespace mapserver
-{
-    //-------------------------------------------------------------conv_marker
-    template<class MarkerLocator, class MarkerShapes>
-    class conv_marker
-    {
-    public:
-        conv_marker(MarkerLocator& ml, MarkerShapes& ms);
-
-        trans_affine& transform() { return m_transform; }
-        const trans_affine& transform() const { return m_transform; }
-
-        void rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        conv_marker(const conv_marker<MarkerLocator, MarkerShapes>&);
-        const conv_marker<MarkerLocator, MarkerShapes>& 
-            operator = (const conv_marker<MarkerLocator, MarkerShapes>&);
-
-        enum status_e 
-        {
-            initial,
-            markers,
-            polygon,
-            stop
-        };
-
-        MarkerLocator* m_marker_locator;
-        MarkerShapes*  m_marker_shapes;
-        trans_affine   m_transform;
-        trans_affine   m_mtx;
-        status_e       m_status;
-        unsigned       m_marker;
-        unsigned       m_num_markers;
-    };
-
-
-    //------------------------------------------------------------------------
-    template<class MarkerLocator, class MarkerShapes> 
-    conv_marker<MarkerLocator, MarkerShapes>::conv_marker(MarkerLocator& ml, MarkerShapes& ms) :
-        m_marker_locator(&ml),
-        m_marker_shapes(&ms),
-        m_status(initial),
-        m_marker(0),
-        m_num_markers(1)
-    {
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class MarkerLocator, class MarkerShapes> 
-    void conv_marker<MarkerLocator, MarkerShapes>::rewind(unsigned)
-    {
-        m_status = initial;
-        m_marker = 0;
-        m_num_markers = 1;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class MarkerLocator, class MarkerShapes> 
-    unsigned conv_marker<MarkerLocator, MarkerShapes>::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_move_to;
-        double x1, y1, x2, y2;
-
-        while(!is_stop(cmd))
-        {
-            switch(m_status)
-            {
-            case initial:
-                if(m_num_markers == 0)
-                {
-                   cmd = path_cmd_stop;
-                   break;
-                }
-                m_marker_locator->rewind(m_marker);
-                ++m_marker;
-                m_num_markers = 0;
-                m_status = markers;
-
-            case markers:
-                if(is_stop(m_marker_locator->vertex(&x1, &y1)))
-                {
-                    m_status = initial;
-                    break;
-                }
-                if(is_stop(m_marker_locator->vertex(&x2, &y2)))
-                {
-                    m_status = initial;
-                    break;
-                }
-                ++m_num_markers;
-                m_mtx = m_transform;
-                m_mtx *= trans_affine_rotation(atan2(y2 - y1, x2 - x1));
-                m_mtx *= trans_affine_translation(x1, y1);
-                m_marker_shapes->rewind(m_marker - 1);
-                m_status = polygon;
-
-            case polygon:
-                cmd = m_marker_shapes->vertex(x, y);
-                if(is_stop(cmd))
-                {
-                    cmd = path_cmd_move_to;
-                    m_status = markers;
-                    break;
-                }
-                m_mtx.transform(x, y);
-                return cmd;
-
-            case stop:
-                cmd = path_cmd_stop;
-                break;
-            }
-        }
-        return cmd;
-    }
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_marker_adaptor.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_marker_adaptor.h
--- 8.0.1-5/renderers/agg/include/agg_conv_marker_adaptor.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_marker_adaptor.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,51 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_MARKER_ADAPTOR_INCLUDED
-#define AGG_CONV_MARKER_ADAPTOR_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_conv_adaptor_vcgen.h"
-#include "agg_vcgen_vertex_sequence.h"
-
-namespace mapserver
-{
-
-    //=====================================================conv_marker_adaptor
-    template<class VertexSource, class Markers=null_markers>
-    struct conv_marker_adaptor : 
-    public conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence, Markers>
-    {
-        typedef Markers marker_type;
-        typedef conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence, Markers> base_type;
-
-        conv_marker_adaptor(VertexSource& vs) : 
-            conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence, Markers>(vs)
-        {
-        }
-
-        void shorten(double s) { base_type::generator().shorten(s); }
-        double shorten() const { return base_type::generator().shorten(); }
-
-    private:
-        conv_marker_adaptor(const conv_marker_adaptor<VertexSource, Markers>&);
-        const conv_marker_adaptor<VertexSource, Markers>& 
-            operator = (const conv_marker_adaptor<VertexSource, Markers>&);
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_segmentator.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_segmentator.h
--- 8.0.1-5/renderers/agg/include/agg_conv_segmentator.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_segmentator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_SEGMENTATOR_INCLUDED
-#define AGG_CONV_SEGMENTATOR_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_conv_adaptor_vpgen.h"
-#include "agg_vpgen_segmentator.h"
-
-namespace mapserver
-{
-
-    //========================================================conv_segmentator
-    template<class VertexSource> 
-    struct conv_segmentator : public conv_adaptor_vpgen<VertexSource, vpgen_segmentator>
-    {
-        typedef conv_adaptor_vpgen<VertexSource, vpgen_segmentator> base_type;
-
-        conv_segmentator(VertexSource& vs) : 
-            conv_adaptor_vpgen<VertexSource, vpgen_segmentator>(vs) {}
-
-        void approximation_scale(double s) { base_type::vpgen().approximation_scale(s);        }
-        double approximation_scale() const { return base_type::vpgen().approximation_scale();  }
-
-    private:
-        conv_segmentator(const conv_segmentator<VertexSource>&);
-        const conv_segmentator<VertexSource>& 
-            operator = (const conv_segmentator<VertexSource>&);
-    };
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_shorten_path.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_shorten_path.h
--- 8.0.1-5/renderers/agg/include/agg_conv_shorten_path.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_shorten_path.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,50 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_SHORTEN_PATH_INCLUDED
-#define AGG_CONV_SHORTEN_PATH_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_conv_adaptor_vcgen.h"
-#include "agg_vcgen_vertex_sequence.h"
-
-namespace mapserver
-{
-
-    //=======================================================conv_shorten_path
-    template<class VertexSource>  class conv_shorten_path : 
-    public conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence>
-    {
-    public:
-        typedef conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence> base_type;
-
-        conv_shorten_path(VertexSource& vs) : 
-            conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence>(vs)
-        {
-        }
-
-        void shorten(double s) { base_type::generator().shorten(s); }
-        double shorten() const { return base_type::generator().shorten(); }
-
-    private:
-        conv_shorten_path(const conv_shorten_path<VertexSource>&);
-        const conv_shorten_path<VertexSource>& 
-            operator = (const conv_shorten_path<VertexSource>&);
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_smooth_poly1.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_smooth_poly1.h
--- 8.0.1-5/renderers/agg/include/agg_conv_smooth_poly1.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_smooth_poly1.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,80 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Smooth polygon generator
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_SMOOTH_POLY1_INCLUDED
-#define AGG_CONV_SMOOTH_POLY1_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vcgen_smooth_poly1.h"
-#include "agg_conv_adaptor_vcgen.h"
-#include "agg_conv_curve.h"
-
-
-namespace mapserver
-{
-
-    //-------------------------------------------------------conv_smooth_poly1
-    template<class VertexSource> 
-    struct conv_smooth_poly1 : 
-    public conv_adaptor_vcgen<VertexSource, vcgen_smooth_poly1>
-    {
-        typedef conv_adaptor_vcgen<VertexSource, vcgen_smooth_poly1> base_type;
-
-        conv_smooth_poly1(VertexSource& vs) : 
-            conv_adaptor_vcgen<VertexSource, vcgen_smooth_poly1>(vs)
-        {
-        }
-
-        void   smooth_value(double v) { base_type::generator().smooth_value(v); }
-        double smooth_value() const { return base_type::generator().smooth_value(); }
-
-    private:
-        conv_smooth_poly1(const conv_smooth_poly1<VertexSource>&);
-        const conv_smooth_poly1<VertexSource>& 
-            operator = (const conv_smooth_poly1<VertexSource>&);
-    };
-
-
-
-    //-------------------------------------------------conv_smooth_poly1_curve
-    template<class VertexSource> 
-    struct conv_smooth_poly1_curve : 
-    public conv_curve<conv_smooth_poly1<VertexSource> >
-    {
-        conv_smooth_poly1_curve(VertexSource& vs) :
-            conv_curve<conv_smooth_poly1<VertexSource> >(m_smooth),
-            m_smooth(vs)
-        {
-        }
-
-        void   smooth_value(double v) { m_smooth.generator().smooth_value(v); }
-        double smooth_value() const { return m_smooth.generator().smooth_value(); }
-
-    private:
-        conv_smooth_poly1_curve(const conv_smooth_poly1_curve<VertexSource>&);
-        const conv_smooth_poly1_curve<VertexSource>& 
-            operator = (const conv_smooth_poly1_curve<VertexSource>&);
-
-        conv_smooth_poly1<VertexSource> m_smooth;
-    };
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_stroke.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_stroke.h
--- 8.0.1-5/renderers/agg/include/agg_conv_stroke.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_stroke.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,73 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// conv_stroke
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_STROKE_INCLUDED
-#define AGG_CONV_STROKE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vcgen_stroke.h"
-#include "agg_conv_adaptor_vcgen.h"
-
-namespace mapserver
-{
-
-    //-------------------------------------------------------------conv_stroke
-    template<class VertexSource, class Markers=null_markers> 
-    struct conv_stroke : 
-    public conv_adaptor_vcgen<VertexSource, vcgen_stroke, Markers>
-    {
-        typedef Markers marker_type;
-        typedef conv_adaptor_vcgen<VertexSource, vcgen_stroke, Markers> base_type;
-
-        conv_stroke(VertexSource& vs) : 
-            conv_adaptor_vcgen<VertexSource, vcgen_stroke, Markers>(vs)
-        {
-        }
-
-        void line_cap(line_cap_e lc)     { base_type::generator().line_cap(lc);  }
-        void line_join(line_join_e lj)   { base_type::generator().line_join(lj); }
-        void inner_join(inner_join_e ij) { base_type::generator().inner_join(ij); }
-
-        line_cap_e   line_cap()   const { return base_type::generator().line_cap();  }
-        line_join_e  line_join()  const { return base_type::generator().line_join(); }
-        inner_join_e inner_join() const { return base_type::generator().inner_join(); }
-
-        void width(double w) { base_type::generator().width(w); }
-        void miter_limit(double ml) { base_type::generator().miter_limit(ml); }
-        void miter_limit_theta(double t) { base_type::generator().miter_limit_theta(t); }
-        void inner_miter_limit(double ml) { base_type::generator().inner_miter_limit(ml); }
-        void approximation_scale(double as) { base_type::generator().approximation_scale(as); }
-
-        double width() const { return base_type::generator().width(); }
-        double miter_limit() const { return base_type::generator().miter_limit(); }
-        double inner_miter_limit() const { return base_type::generator().inner_miter_limit(); }
-        double approximation_scale() const { return base_type::generator().approximation_scale(); }
-
-        void shorten(double s) { base_type::generator().shorten(s); }
-        double shorten() const { return base_type::generator().shorten(); }
-
-    private:
-       conv_stroke(const conv_stroke<VertexSource, Markers>&);
-       const conv_stroke<VertexSource, Markers>& 
-           operator = (const conv_stroke<VertexSource, Markers>&);
-
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_transform.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_transform.h
--- 8.0.1-5/renderers/agg/include/agg_conv_transform.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_transform.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,68 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class conv_transform
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_CONV_TRANSFORM_INCLUDED
-#define AGG_CONV_TRANSFORM_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_trans_affine.h"
-
-namespace mapserver
-{
-
-    //----------------------------------------------------------conv_transform
-    template<class VertexSource, class Transformer=trans_affine> class conv_transform
-    {
-    public:
-        conv_transform(VertexSource& source, const Transformer& tr) :
-            m_source(&source), m_trans(&tr) {}
-        void attach(VertexSource& source) { m_source = &source; }
-
-        void rewind(unsigned path_id) 
-        { 
-            m_source->rewind(path_id); 
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            unsigned cmd = m_source->vertex(x, y);
-            if(is_vertex(cmd))
-            {
-                m_trans->transform(x, y);
-            }
-            return cmd;
-        }
-
-        void transformer(const Transformer& tr)
-        {
-            m_trans = &tr;
-        }
-
-    private:
-        conv_transform(const conv_transform<VertexSource>&);
-        const conv_transform<VertexSource>& 
-            operator = (const conv_transform<VertexSource>&);
-
-        VertexSource*      m_source;
-        const Transformer* m_trans;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_conv_unclose_polygon.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_unclose_polygon.h
--- 8.0.1-5/renderers/agg/include/agg_conv_unclose_polygon.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_conv_unclose_polygon.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,52 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CONV_UNCLOSE_POLYGON_INCLUDED
-#define AGG_CONV_UNCLOSE_POLYGON_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //====================================================conv_unclose_polygon
-    template<class VertexSource> class conv_unclose_polygon
-    {
-    public:
-        explicit conv_unclose_polygon(VertexSource& vs) : m_source(&vs) {}
-        void attach(VertexSource& source) { m_source = &source; }
-
-        void rewind(unsigned path_id)
-        {
-            m_source->rewind(path_id);
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            unsigned cmd = m_source->vertex(x, y);
-            if(is_end_poly(cmd)) cmd &= ~path_flags_close;
-            return cmd;
-        }
-
-    private:
-        conv_unclose_polygon(const conv_unclose_polygon<VertexSource>&);
-        const conv_unclose_polygon<VertexSource>& 
-            operator = (const conv_unclose_polygon<VertexSource>&);
-
-        VertexSource* m_source;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_curves.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_curves.h
--- 8.0.1-5/renderers/agg/include/agg_curves.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_curves.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,669 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-// Copyright (C) 2005 Tony Juricic (tonygeek@yahoo.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_CURVES_INCLUDED
-#define AGG_CURVES_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-
-    // See Implementation agg_curves.cpp
-
-    //--------------------------------------------curve_approximation_method_e
-    enum curve_approximation_method_e
-    {
-        curve_inc,
-        curve_div
-    };
-    
-    //--------------------------------------------------------------curve3_inc
-    class curve3_inc
-    {
-    public:
-        curve3_inc() = default;
-
-        curve3_inc(double x1, double y1, 
-                   double x2, double y2, 
-                   double x3, double y3)
-        { 
-            init(x1, y1, x2, y2, x3, y3);
-        }
-
-        void reset() { m_num_steps = 0; m_step = -1; }
-        void init(double x1, double y1, 
-                  double x2, double y2, 
-                  double x3, double y3);
-
-        void approximation_method(curve_approximation_method_e) {}
-        curve_approximation_method_e approximation_method() const { return curve_inc; }
-
-        void approximation_scale(double s);
-        double approximation_scale() const;
-
-        void angle_tolerance(double) {}
-        double angle_tolerance() const { return 0.0; }
-
-        void cusp_limit(double) {}
-        double cusp_limit() const { return 0.0; }
-
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        int      m_num_steps = 0;
-        int      m_step = 0;
-        double   m_scale = 1;
-        double   m_start_x = 0; 
-        double   m_start_y = 0;
-        double   m_end_x = 0; 
-        double   m_end_y = 0;
-        double   m_fx = 0; 
-        double   m_fy = 0;
-        double   m_dfx = 0; 
-        double   m_dfy = 0;
-        double   m_ddfx = 0; 
-        double   m_ddfy = 0;
-        double   m_saved_fx = 0; 
-        double   m_saved_fy = 0;
-        double   m_saved_dfx = 0; 
-        double   m_saved_dfy = 0;
-    };
-
-
-
-
-
-    //-------------------------------------------------------------curve3_div
-    class curve3_div
-    {
-    public:
-        curve3_div() = default;
-
-        curve3_div(double x1, double y1, 
-                   double x2, double y2, 
-                   double x3, double y3)
-        { 
-            init(x1, y1, x2, y2, x3, y3);
-        }
-
-        void reset() { m_points.remove_all(); m_count = 0; }
-        void init(double x1, double y1, 
-                  double x2, double y2, 
-                  double x3, double y3);
-
-        void approximation_method(curve_approximation_method_e) {}
-        curve_approximation_method_e approximation_method() const { return curve_div; }
-
-        void approximation_scale(double s) { m_approximation_scale = s; }
-        double approximation_scale() const { return m_approximation_scale;  }
-
-        void angle_tolerance(double a) { m_angle_tolerance = a; }
-        double angle_tolerance() const { return m_angle_tolerance;  }
-
-        void cusp_limit(double) {}
-        double cusp_limit() const { return 0.0; }
-
-        void rewind(unsigned)
-        {
-            m_count = 0;
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_count >= m_points.size()) return path_cmd_stop;
-            const point_d& p = m_points[m_count++];
-            *x = p.x;
-            *y = p.y;
-            return (m_count == 1) ? path_cmd_move_to : path_cmd_line_to;
-        }
-
-    private:
-        void bezier(double x1, double y1, 
-                    double x2, double y2, 
-                    double x3, double y3);
-        void recursive_bezier(double x1, double y1, 
-                              double x2, double y2, 
-                              double x3, double y3,
-                              unsigned level);
-
-        double               m_approximation_scale = 1.0;
-        double               m_distance_tolerance_square = 0;
-        double               m_angle_tolerance = 0;
-        unsigned             m_count = 0;
-        pod_bvector<point_d> m_points;
-    };
-
-
-
-
-
-
-
-    //-------------------------------------------------------------curve4_points
-    struct curve4_points
-    {
-        double cp[8];
-        curve4_points() {}
-        curve4_points(double x1, double y1,
-                      double x2, double y2,
-                      double x3, double y3,
-                      double x4, double y4)
-        {
-            cp[0] = x1; cp[1] = y1; cp[2] = x2; cp[3] = y2;
-            cp[4] = x3; cp[5] = y3; cp[6] = x4; cp[7] = y4;
-        }
-        void init(double x1, double y1,
-                  double x2, double y2,
-                  double x3, double y3,
-                  double x4, double y4)
-        {
-            cp[0] = x1; cp[1] = y1; cp[2] = x2; cp[3] = y2;
-            cp[4] = x3; cp[5] = y3; cp[6] = x4; cp[7] = y4;
-        }
-        double  operator [] (unsigned i) const { return cp[i]; }
-        double& operator [] (unsigned i)       { return cp[i]; }
-    };
-
-
-
-    //-------------------------------------------------------------curve4_inc
-    class curve4_inc
-    {
-    public:
-        curve4_inc() = default;
-
-        curve4_inc(double x1, double y1, 
-                   double x2, double y2, 
-                   double x3, double y3,
-                   double x4, double y4)
-        { 
-            init(x1, y1, x2, y2, x3, y3, x4, y4);
-        }
-
-        curve4_inc(const curve4_points& cp)
-        { 
-            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
-        }
-
-        void reset() { m_num_steps = 0; m_step = -1; }
-        void init(double x1, double y1, 
-                  double x2, double y2, 
-                  double x3, double y3,
-                  double x4, double y4);
-
-        void init(const curve4_points& cp)
-        {
-            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
-        }
-
-        void approximation_method(curve_approximation_method_e) {}
-        curve_approximation_method_e approximation_method() const { return curve_inc; }
-
-        void approximation_scale(double s);
-        double approximation_scale() const;
-
-        void angle_tolerance(double) {}
-        double angle_tolerance() const { return 0.0; }
-
-        void cusp_limit(double) {}
-        double cusp_limit() const { return 0.0; }
-
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        int      m_num_steps = 0;
-        int      m_step = 0;
-        double   m_scale = 1.0;
-        double   m_start_x = 0.0; 
-        double   m_start_y = 0.0;
-        double   m_end_x = 0.0; 
-        double   m_end_y = 0.0;
-        double   m_fx = 0.0; 
-        double   m_fy = 0.0;
-        double   m_dfx = 0.0; 
-        double   m_dfy = 0.0;
-        double   m_ddfx = 0.0; 
-        double   m_ddfy = 0.0;
-        double   m_dddfx = 0.0; 
-        double   m_dddfy = 0.0;
-        double   m_saved_fx = 0.0; 
-        double   m_saved_fy = 0.0;
-        double   m_saved_dfx = 0.0; 
-        double   m_saved_dfy = 0.0;
-        double   m_saved_ddfx = 0.0; 
-        double   m_saved_ddfy = 0.0;
-    };
-
-
-
-    //-------------------------------------------------------catrom_to_bezier
-    inline curve4_points catrom_to_bezier(double x1, double y1, 
-                                          double x2, double y2, 
-                                          double x3, double y3,
-                                          double x4, double y4)
-    {
-        // Trans. matrix Catmull-Rom to Bezier
-        //
-        //  0       1       0       0
-        //  -1/6    1       1/6     0
-        //  0       1/6     1       -1/6
-        //  0       0       1       0
-        //
-        return curve4_points(
-            x2,
-            y2,
-            (-x1 + 6*x2 + x3) / 6,
-            (-y1 + 6*y2 + y3) / 6,
-            ( x2 + 6*x3 - x4) / 6,
-            ( y2 + 6*y3 - y4) / 6,
-            x3,
-            y3);
-    }
-
-
-    //-----------------------------------------------------------------------
-    inline curve4_points
-    catrom_to_bezier(const curve4_points& cp)
-    {
-        return catrom_to_bezier(cp[0], cp[1], cp[2], cp[3], 
-                                cp[4], cp[5], cp[6], cp[7]);
-    }
-
-
-
-    //-----------------------------------------------------ubspline_to_bezier
-    inline curve4_points ubspline_to_bezier(double x1, double y1, 
-                                            double x2, double y2, 
-                                            double x3, double y3,
-                                            double x4, double y4)
-    {
-        // Trans. matrix Uniform BSpline to Bezier
-        //
-        //  1/6     4/6     1/6     0
-        //  0       4/6     2/6     0
-        //  0       2/6     4/6     0
-        //  0       1/6     4/6     1/6
-        //
-        return curve4_points(
-            (x1 + 4*x2 + x3) / 6,
-            (y1 + 4*y2 + y3) / 6,
-            (4*x2 + 2*x3) / 6,
-            (4*y2 + 2*y3) / 6,
-            (2*x2 + 4*x3) / 6,
-            (2*y2 + 4*y3) / 6,
-            (x2 + 4*x3 + x4) / 6,
-            (y2 + 4*y3 + y4) / 6);
-    }
-
-
-    //-----------------------------------------------------------------------
-    inline curve4_points 
-    ubspline_to_bezier(const curve4_points& cp)
-    {
-        return ubspline_to_bezier(cp[0], cp[1], cp[2], cp[3], 
-                                  cp[4], cp[5], cp[6], cp[7]);
-    }
-
-
-
-
-    //------------------------------------------------------hermite_to_bezier
-    inline curve4_points hermite_to_bezier(double x1, double y1, 
-                                           double x2, double y2, 
-                                           double x3, double y3,
-                                           double x4, double y4)
-    {
-        // Trans. matrix Hermite to Bezier
-        //
-        //  1       0       0       0
-        //  1       0       1/3     0
-        //  0       1       0       -1/3
-        //  0       1       0       0
-        //
-        return curve4_points(
-            x1,
-            y1,
-            (3*x1 + x3) / 3,
-            (3*y1 + y3) / 3,
-            (3*x2 - x4) / 3,
-            (3*y2 - y4) / 3,
-            x2,
-            y2);
-    }
-
-
-
-    //-----------------------------------------------------------------------
-    inline curve4_points 
-    hermite_to_bezier(const curve4_points& cp)
-    {
-        return hermite_to_bezier(cp[0], cp[1], cp[2], cp[3], 
-                                 cp[4], cp[5], cp[6], cp[7]);
-    }
-
-
-    //-------------------------------------------------------------curve4_div
-    class curve4_div
-    {
-    public:
-        curve4_div() = default;
-
-        curve4_div(double x1, double y1, 
-                   double x2, double y2, 
-                   double x3, double y3,
-                   double x4, double y4)
-        { 
-            init(x1, y1, x2, y2, x3, y3, x4, y4);
-        }
-
-        curve4_div(const curve4_points& cp)
-        { 
-            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
-        }
-
-        void reset() { m_points.remove_all(); m_count = 0; }
-        void init(double x1, double y1, 
-                  double x2, double y2, 
-                  double x3, double y3,
-                  double x4, double y4);
-
-        void init(const curve4_points& cp)
-        {
-            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
-        }
-
-        void approximation_method(curve_approximation_method_e) {}
-
-        curve_approximation_method_e approximation_method() const 
-        { 
-            return curve_div; 
-        }
-
-        void approximation_scale(double s) { m_approximation_scale = s; }
-        double approximation_scale() const { return m_approximation_scale;  }
-
-        void angle_tolerance(double a) { m_angle_tolerance = a; }
-        double angle_tolerance() const { return m_angle_tolerance;  }
-
-        void cusp_limit(double v) 
-        { 
-            m_cusp_limit = (v == 0.0) ? 0.0 : pi - v; 
-        }
-
-        double cusp_limit() const 
-        { 
-            return (m_cusp_limit == 0.0) ? 0.0 : pi - m_cusp_limit; 
-        }
-
-        void rewind(unsigned)
-        {
-            m_count = 0;
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_count >= m_points.size()) return path_cmd_stop;
-            const point_d& p = m_points[m_count++];
-            *x = p.x;
-            *y = p.y;
-            return (m_count == 1) ? path_cmd_move_to : path_cmd_line_to;
-        }
-
-    private:
-        void bezier(double x1, double y1, 
-                    double x2, double y2, 
-                    double x3, double y3, 
-                    double x4, double y4);
-
-        void recursive_bezier(double x1, double y1, 
-                              double x2, double y2, 
-                              double x3, double y3, 
-                              double x4, double y4,
-                              unsigned level);
-
-        double               m_approximation_scale = 1.0;
-        double               m_distance_tolerance_square = 0.0;
-        double               m_angle_tolerance = 0.0;
-        double               m_cusp_limit = 0.0;
-        unsigned             m_count = 0;
-        pod_bvector<point_d> m_points;
-    };
-
-
-    //-----------------------------------------------------------------curve3
-    class curve3
-    {
-    public:
-        curve3() : m_approximation_method(curve_div) {}
-        curve3(double x1, double y1, 
-               double x2, double y2, 
-               double x3, double y3) :
-            m_approximation_method(curve_div)
-        { 
-            init(x1, y1, x2, y2, x3, y3);
-        }
-
-        void reset() 
-        { 
-            m_curve_inc.reset();
-            m_curve_div.reset();
-        }
-
-        void init(double x1, double y1, 
-                  double x2, double y2, 
-                  double x3, double y3)
-        {
-            if(m_approximation_method == curve_inc) 
-            {
-                m_curve_inc.init(x1, y1, x2, y2, x3, y3);
-            }
-            else
-            {
-                m_curve_div.init(x1, y1, x2, y2, x3, y3);
-            }
-        }
-
-        void approximation_method(curve_approximation_method_e v) 
-        { 
-            m_approximation_method = v; 
-        }
-
-        curve_approximation_method_e approximation_method() const 
-        { 
-            return m_approximation_method; 
-        }
-
-        void approximation_scale(double s) 
-        { 
-            m_curve_inc.approximation_scale(s);
-            m_curve_div.approximation_scale(s);
-        }
-
-        double approximation_scale() const 
-        { 
-            return m_curve_inc.approximation_scale(); 
-        }
-
-        void angle_tolerance(double a) 
-        { 
-            m_curve_div.angle_tolerance(a); 
-        }
-
-        double angle_tolerance() const 
-        { 
-            return m_curve_div.angle_tolerance(); 
-        }
-
-        void cusp_limit(double v) 
-        { 
-            m_curve_div.cusp_limit(v); 
-        }
-
-        double cusp_limit() const 
-        { 
-            return m_curve_div.cusp_limit();  
-        }
-
-        void rewind(unsigned path_id)
-        {
-            if(m_approximation_method == curve_inc) 
-            {
-                m_curve_inc.rewind(path_id);
-            }
-            else
-            {
-                m_curve_div.rewind(path_id);
-            }
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_approximation_method == curve_inc) 
-            {
-                return m_curve_inc.vertex(x, y);
-            }
-            return m_curve_div.vertex(x, y);
-        }
-
-    private:
-        curve3_inc m_curve_inc;
-        curve3_div m_curve_div;
-        curve_approximation_method_e m_approximation_method;
-    };
-
-
-
-
-
-    //-----------------------------------------------------------------curve4
-    class curve4
-    {
-    public:
-        curve4() : m_approximation_method(curve_div) {}
-        curve4(double x1, double y1, 
-               double x2, double y2, 
-               double x3, double y3,
-               double x4, double y4) : 
-            m_approximation_method(curve_div)
-        { 
-            init(x1, y1, x2, y2, x3, y3, x4, y4);
-        }
-
-        curve4(const curve4_points& cp) :
-            m_approximation_method(curve_div)
-        { 
-            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
-        }
-
-        void reset() 
-        { 
-            m_curve_inc.reset();
-            m_curve_div.reset();
-        }
-
-        void init(double x1, double y1, 
-                  double x2, double y2, 
-                  double x3, double y3,
-                  double x4, double y4)
-        {
-            if(m_approximation_method == curve_inc) 
-            {
-                m_curve_inc.init(x1, y1, x2, y2, x3, y3, x4, y4);
-            }
-            else
-            {
-                m_curve_div.init(x1, y1, x2, y2, x3, y3, x4, y4);
-            }
-        }
-
-        void init(const curve4_points& cp)
-        {
-            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
-        }
-
-        void approximation_method(curve_approximation_method_e v) 
-        { 
-            m_approximation_method = v; 
-        }
-
-        curve_approximation_method_e approximation_method() const 
-        { 
-            return m_approximation_method; 
-        }
-
-        void approximation_scale(double s) 
-        { 
-            m_curve_inc.approximation_scale(s);
-            m_curve_div.approximation_scale(s);
-        }
-        double approximation_scale() const { return m_curve_inc.approximation_scale(); }
-
-        void angle_tolerance(double v) 
-        { 
-            m_curve_div.angle_tolerance(v); 
-        }
-
-        double angle_tolerance() const 
-        { 
-            return m_curve_div.angle_tolerance();  
-        }
-
-        void cusp_limit(double v) 
-        { 
-            m_curve_div.cusp_limit(v); 
-        }
-
-        double cusp_limit() const 
-        { 
-            return m_curve_div.cusp_limit();  
-        }
-
-        void rewind(unsigned path_id)
-        {
-            if(m_approximation_method == curve_inc) 
-            {
-                m_curve_inc.rewind(path_id);
-            }
-            else
-            {
-                m_curve_div.rewind(path_id);
-            }
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_approximation_method == curve_inc) 
-            {
-                return m_curve_inc.vertex(x, y);
-            }
-            return m_curve_div.vertex(x, y);
-        }
-
-    private:
-        curve4_inc m_curve_inc;
-        curve4_div m_curve_div;
-        curve_approximation_method_e m_approximation_method;
-    };
-
-
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_dda_line.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_dda_line.h
--- 8.0.1-5/renderers/agg/include/agg_dda_line.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_dda_line.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,290 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// classes dda_line_interpolator, dda2_line_interpolator
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_DDA_LINE_INCLUDED
-#define AGG_DDA_LINE_INCLUDED
-
-#include <stdlib.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //===================================================dda_line_interpolator
-    template<int FractionShift, int YShift=0> class dda_line_interpolator
-    {
-    public:
-        //--------------------------------------------------------------------
-        dda_line_interpolator() {}
-
-        //--------------------------------------------------------------------
-        dda_line_interpolator(int y1, int y2, unsigned count) :
-            m_y(y1),
-            m_inc(((y2 - y1) << FractionShift) / int(count)),
-            m_dy(0)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        void operator ++ ()
-        {
-            m_dy += m_inc;
-        }
-
-        //--------------------------------------------------------------------
-        void operator -- ()
-        {
-            m_dy -= m_inc;
-        }
-
-        //--------------------------------------------------------------------
-        void operator += (unsigned n)
-        {
-            m_dy += m_inc * n;
-        }
-
-        //--------------------------------------------------------------------
-        void operator -= (unsigned n)
-        {
-            m_dy -= m_inc * n;
-        }
-
-
-        //--------------------------------------------------------------------
-        int y()  const { return m_y + (m_dy >> (FractionShift-YShift)); }
-        int dy() const { return m_dy; }
-
-
-    private:
-        int m_y;
-        int m_inc;
-        int m_dy;
-    };
-
-
-
-
-
-    //=================================================dda2_line_interpolator
-    class dda2_line_interpolator
-    {
-    public:
-        typedef int save_data_type;
-        enum save_size_e { save_size = 2 };
-
-        //--------------------------------------------------------------------
-        dda2_line_interpolator() = default;
-
-        //-------------------------------------------- Forward-adjusted line
-        dda2_line_interpolator(int y1, int y2, int count) :
-            m_cnt(count <= 0 ? 1 : count),
-            m_lft((y2 - y1) / m_cnt),
-            m_rem((y2 - y1) % m_cnt),
-            m_mod(m_rem),
-            m_y(y1)
-        {
-            if(m_mod <= 0)
-            {
-                m_mod += count;
-                m_rem += count;
-                m_lft--;
-            }
-            m_mod -= count;
-        }
-
-        //-------------------------------------------- Backward-adjusted line
-        dda2_line_interpolator(int y1, int y2, int count, int) :
-            m_cnt(count <= 0 ? 1 : count),
-            m_lft((y2 - y1) / m_cnt),
-            m_rem((y2 - y1) % m_cnt),
-            m_mod(m_rem),
-            m_y(y1)
-        {
-            if(m_mod <= 0)
-            {
-                m_mod += count;
-                m_rem += count;
-                m_lft--;
-            }
-        }
-
-        //-------------------------------------------- Backward-adjusted line
-        dda2_line_interpolator(int y, int count) :
-            m_cnt(count <= 0 ? 1 : count),
-            m_lft(y / m_cnt),
-            m_rem(y % m_cnt),
-            m_mod(m_rem),
-            m_y(0)
-        {
-            if(m_mod <= 0)
-            {
-                m_mod += count;
-                m_rem += count;
-                m_lft--;
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void save(save_data_type* data) const
-        {
-            data[0] = m_mod;
-            data[1] = m_y;
-        }
-
-        //--------------------------------------------------------------------
-        void load(const save_data_type* data)
-        {
-            m_mod = data[0];
-            m_y   = data[1];
-        }
-
-        //--------------------------------------------------------------------
-        void operator++()
-        {
-            m_mod += m_rem;
-            m_y += m_lft;
-            if(m_mod > 0)
-            {
-                m_mod -= m_cnt;
-                m_y++;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void operator--()
-        {
-            if(m_mod <= m_rem)
-            {
-                m_mod += m_cnt;
-                m_y--;
-            }
-            m_mod -= m_rem;
-            m_y -= m_lft;
-        }
-
-        //--------------------------------------------------------------------
-        void adjust_forward()
-        {
-            m_mod -= m_cnt;
-        }
-
-        //--------------------------------------------------------------------
-        void adjust_backward()
-        {
-            m_mod += m_cnt;
-        }
-
-        //--------------------------------------------------------------------
-        int mod() const { return m_mod; }
-        int rem() const { return m_rem; }
-        int lft() const { return m_lft; }
-
-        //--------------------------------------------------------------------
-        int y() const { return m_y; }
-
-    private:
-        int m_cnt = 0;
-        int m_lft = 0;
-        int m_rem = 0;
-        int m_mod = 0;
-        int m_y = 0;
-    };
-
-
-
-
-
-
-
-    //---------------------------------------------line_bresenham_interpolator
-    class line_bresenham_interpolator
-    {
-    public:
-        enum subpixel_scale_e
-        {
-            subpixel_shift = 8,
-            subpixel_scale = 1 << subpixel_shift,
-            subpixel_mask  = subpixel_scale - 1
-        };
-
-        //--------------------------------------------------------------------
-        static int line_lr(int v) { return v >> subpixel_shift; }
-
-        //--------------------------------------------------------------------
-        line_bresenham_interpolator(int x1, int y1, int x2, int y2) :
-            m_x1_lr(line_lr(x1)),
-            m_y1_lr(line_lr(y1)),
-            m_x2_lr(line_lr(x2)),
-            m_y2_lr(line_lr(y2)),
-            m_ver(abs(m_x2_lr - m_x1_lr) < abs(m_y2_lr - m_y1_lr)),
-            m_len(m_ver ? abs(m_y2_lr - m_y1_lr) : 
-                          abs(m_x2_lr - m_x1_lr)),
-            m_inc(m_ver ? ((y2 > y1) ? 1 : -1) : ((x2 > x1) ? 1 : -1)),
-            m_interpolator(m_ver ? x1 : y1, 
-                           m_ver ? x2 : y2, 
-                           m_len)
-        {
-        }
-    
-        //--------------------------------------------------------------------
-        bool     is_ver() const { return m_ver; }
-        unsigned len()    const { return m_len; }
-        int      inc()    const { return m_inc; }
-
-        //--------------------------------------------------------------------
-        void hstep()
-        {
-            ++m_interpolator;
-            m_x1_lr += m_inc;
-        }
-
-        //--------------------------------------------------------------------
-        void vstep()
-        {
-            ++m_interpolator;
-            m_y1_lr += m_inc;
-        }
-
-        //--------------------------------------------------------------------
-        int x1() const { return m_x1_lr; }
-        int y1() const { return m_y1_lr; }
-        int x2() const { return line_lr(m_interpolator.y()); }
-        int y2() const { return line_lr(m_interpolator.y()); }
-        int x2_hr() const { return m_interpolator.y(); }
-        int y2_hr() const { return m_interpolator.y(); }
-
-    private:
-        int                    m_x1_lr;
-        int                    m_y1_lr;
-        int                    m_x2_lr;
-        int                    m_y2_lr;
-        bool                   m_ver;
-        unsigned               m_len;
-        int                    m_inc;
-        dda2_line_interpolator m_interpolator;
-
-    };
-
-
-}
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_ellipse.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_ellipse.h
--- 8.0.1-5/renderers/agg/include/agg_ellipse.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_ellipse.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,123 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class ellipse
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_ELLIPSE_INCLUDED
-#define AGG_ELLIPSE_INCLUDED
-
-#include "agg_basics.h"
-#include <math.h>
-
-namespace mapserver
-{
-
-    //----------------------------------------------------------------ellipse
-    class ellipse
-    {
-    public:
-        ellipse() : 
-            m_x(0.0), m_y(0.0), m_rx(1.0), m_ry(1.0), m_scale(1.0), 
-            m_num(4), m_step(0), m_cw(false) {}
-
-        ellipse(double x, double y, double rx, double ry, 
-                unsigned num_steps=0, bool cw=false) :
-            m_x(x), m_y(y), m_rx(rx), m_ry(ry), m_scale(1.0), 
-            m_num(num_steps), m_step(0), m_cw(cw) 
-        {
-            if(m_num == 0) calc_num_steps();
-        }
-
-        void init(double x, double y, double rx, double ry, 
-                  unsigned num_steps=0, bool cw=false);
-
-        void approximation_scale(double scale);
-        void rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        void calc_num_steps();
-
-        double m_x;
-        double m_y;
-        double m_rx;
-        double m_ry;
-        double m_scale;
-        unsigned m_num;
-        unsigned m_step;
-        bool m_cw;
-    };
-
-    //------------------------------------------------------------------------
-    inline void ellipse::init(double x, double y, double rx, double ry, 
-                              unsigned num_steps, bool cw)
-    {
-        m_x = x;
-        m_y = y;
-        m_rx = rx;
-        m_ry = ry;
-        m_num = num_steps;
-        m_step = 0;
-        m_cw = cw;
-        if(m_num == 0) calc_num_steps();
-    }
-
-    //------------------------------------------------------------------------
-    inline void ellipse::approximation_scale(double scale)
-    {   
-        m_scale = scale;
-        calc_num_steps();
-    }
-
-    //------------------------------------------------------------------------
-    inline void ellipse::calc_num_steps()
-    {
-        double ra = (fabs(m_rx) + fabs(m_ry)) / 2;
-        double da = acos(ra / (ra + 0.125 / m_scale)) * 2;
-        m_num = uround(2*pi / da);
-    }
-
-    //------------------------------------------------------------------------
-    inline void ellipse::rewind(unsigned)
-    {
-        m_step = 0;
-    }
-
-    //------------------------------------------------------------------------
-    inline unsigned ellipse::vertex(double* x, double* y)
-    {
-        if(m_step == m_num) 
-        {
-            ++m_step;
-            return path_cmd_end_poly | path_flags_close | path_flags_ccw;
-        }
-        if(m_step > m_num) return path_cmd_stop;
-        double angle = double(m_step) / double(m_num) * 2.0 * pi;
-        if(m_cw) angle = 2.0 * pi - angle;
-        *x = m_x + cos(angle) * m_rx;
-        *y = m_y + sin(angle) * m_ry;
-        m_step++;
-        return ((m_step == 1) ? path_cmd_move_to : path_cmd_line_to);
-    }
-
-}
-
-
-
-#endif
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_ellipse_bresenham.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_ellipse_bresenham.h
--- 8.0.1-5/renderers/agg/include/agg_ellipse_bresenham.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_ellipse_bresenham.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,113 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Simple Bresenham interpolator for ellipsees
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_ELLIPSE_BRESENHAM_INCLUDED
-#define AGG_ELLIPSE_BRESENHAM_INCLUDED
-
-
-#include "agg_basics.h"
-
-
-namespace mapserver
-{
-
-    //------------------------------------------ellipse_bresenham_interpolator
-    class ellipse_bresenham_interpolator
-    {
-    public:
-        ellipse_bresenham_interpolator(int rx, int ry) :
-            m_rx2(rx * rx),
-            m_ry2(ry * ry),
-            m_two_rx2(m_rx2 << 1),
-            m_two_ry2(m_ry2 << 1),
-            m_dx(0),
-            m_dy(0),
-            m_inc_x(0),
-            m_inc_y(-ry * m_two_rx2),
-            m_cur_f(0)
-        {}
-        
-        int dx() const { return m_dx; }
-        int dy() const { return m_dy; }
-
-        void operator++ ()
-        {
-            int  mx, my, mxy, min_m;
-            int  fx, fy, fxy;
-
-            mx = fx = m_cur_f + m_inc_x + m_ry2;
-            if(mx < 0) mx = -mx;
-
-            my = fy = m_cur_f + m_inc_y + m_rx2;
-            if(my < 0) my = -my;
-
-            mxy = fxy = m_cur_f + m_inc_x + m_ry2 + m_inc_y + m_rx2;
-            if(mxy < 0) mxy = -mxy;
-
-            min_m = mx; 
-            bool flag = true;
-
-            if(min_m > my)  
-            { 
-                min_m = my; 
-                flag = false; 
-            }
-
-            m_dx = m_dy = 0;
-
-            if(min_m > mxy) 
-            { 
-                m_inc_x += m_two_ry2;
-                m_inc_y += m_two_rx2;
-                m_cur_f = fxy;
-                m_dx = 1; 
-                m_dy = 1;
-                return;
-            }
-
-            if(flag) 
-            {
-                m_inc_x += m_two_ry2;
-                m_cur_f = fx;
-                m_dx = 1;
-                return;
-            }
-
-            m_inc_y += m_two_rx2;
-            m_cur_f = fy;
-            m_dy = 1;
-        }
-
-    private:
-        int m_rx2;
-        int m_ry2;
-        int m_two_rx2;
-        int m_two_ry2;
-        int m_dx;
-        int m_dy;
-        int m_inc_x;
-        int m_inc_y;
-        int m_cur_f;
-
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_embedded_raster_fonts.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_embedded_raster_fonts.h
--- 8.0.1-5/renderers/agg/include/agg_embedded_raster_fonts.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_embedded_raster_fonts.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,59 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_EMBEDDED_RASTER_FONTS_INCLUDED
-#define AGG_EMBEDDED_RASTER_FONTS_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    extern const int8u gse4x6[];
-    extern const int8u gse4x8[];
-    extern const int8u gse5x7[];
-    extern const int8u gse5x9[];
-    extern const int8u gse6x12[];
-    extern const int8u gse6x9[];
-    extern const int8u gse7x11[];
-    extern const int8u gse7x11_bold[];
-    extern const int8u gse7x15[];
-    extern const int8u gse7x15_bold[];
-    extern const int8u gse8x16[];
-    extern const int8u gse8x16_bold[];
-    extern const int8u mcs11_prop[];
-    extern const int8u mcs11_prop_condensed[];
-    extern const int8u mcs12_prop[];
-    extern const int8u mcs13_prop[];
-    extern const int8u mcs5x10_mono[];
-    extern const int8u mcs5x11_mono[];
-    extern const int8u mcs6x10_mono[];
-    extern const int8u mcs6x11_mono[];
-    extern const int8u mcs7x12_mono_high[];
-    extern const int8u mcs7x12_mono_low[];
-    extern const int8u verdana12[];
-    extern const int8u verdana12_bold[];
-    extern const int8u verdana13[];
-    extern const int8u verdana13_bold[];
-    extern const int8u verdana14[];
-    extern const int8u verdana14_bold[];
-    extern const int8u verdana16[];
-    extern const int8u verdana16_bold[];
-    extern const int8u verdana17[];
-    extern const int8u verdana17_bold[];
-    extern const int8u verdana18[];
-    extern const int8u verdana18_bold[];
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_font_cache_manager.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_font_cache_manager.h
--- 8.0.1-5/renderers/agg/include/agg_font_cache_manager.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_font_cache_manager.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,409 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_FONT_CACHE_MANAGER_INCLUDED
-#define AGG_FONT_CACHE_MANAGER_INCLUDED
-
-#include <string.h>
-#include "agg_array.h"
-
-namespace mapserver
-{
-
-    //---------------------------------------------------------glyph_data_type
-    enum glyph_data_type
-    {
-        glyph_data_invalid = 0,
-        glyph_data_mono    = 1,
-        glyph_data_gray8   = 2,
-        glyph_data_outline = 3
-    };
-
-
-    //-------------------------------------------------------------glyph_cache
-    struct glyph_cache
-    {
-        unsigned        glyph_index;
-        int8u*          data;
-        unsigned        data_size;
-        glyph_data_type data_type;
-        rect_i          bounds;
-        double          advance_x;
-        double          advance_y;
-    };
-
-
-    //--------------------------------------------------------------font_cache
-    class font_cache
-    {
-    public:
-        enum block_size_e { block_size = 16384-16 };
-
-        //--------------------------------------------------------------------
-        font_cache() : 
-            m_allocator(block_size),
-            m_font_signature(0)
-        {}
-
-        //--------------------------------------------------------------------
-        void signature(const char* font_signature)
-        {
-            m_font_signature = (char*)m_allocator.allocate(strlen(font_signature) + 1);
-            strcpy(m_font_signature, font_signature);
-            memset(m_glyphs, 0, sizeof(m_glyphs));
-        }
-
-        //--------------------------------------------------------------------
-        bool font_is(const char* font_signature) const
-        {
-            return strcmp(font_signature, m_font_signature) == 0;
-        }
-
-        //--------------------------------------------------------------------
-        const glyph_cache* find_glyph(unsigned glyph_code) const
-        {
-            unsigned msb = (glyph_code >> 8) & 0xFF;
-            if(m_glyphs[msb]) 
-            {
-                return m_glyphs[msb][glyph_code & 0xFF];
-            }
-            return 0;
-        }
-
-        //--------------------------------------------------------------------
-        glyph_cache* cache_glyph(unsigned        glyph_code, 
-                                 unsigned        glyph_index,
-                                 unsigned        data_size,
-                                 glyph_data_type data_type,
-                                 const rect_i&   bounds,
-                                 double          advance_x,
-                                 double          advance_y)
-        {
-            unsigned msb = (glyph_code >> 8) & 0xFF;
-            if(m_glyphs[msb] == 0)
-            {
-                m_glyphs[msb] = 
-                    (glyph_cache**)m_allocator.allocate(sizeof(glyph_cache*) * 256, 
-                                                        sizeof(glyph_cache*));
-                memset(m_glyphs[msb], 0, sizeof(glyph_cache*) * 256);
-            }
-
-            unsigned lsb = glyph_code & 0xFF;
-            if(m_glyphs[msb][lsb]) return 0; // Already exists, do not overwrite
-
-            glyph_cache* glyph = 
-                (glyph_cache*)m_allocator.allocate(sizeof(glyph_cache),
-                                                   sizeof(double));
-
-            glyph->glyph_index        = glyph_index;
-            glyph->data               = m_allocator.allocate(data_size);
-            glyph->data_size          = data_size;
-            glyph->data_type          = data_type;
-            glyph->bounds             = bounds;
-            glyph->advance_x          = advance_x;
-            glyph->advance_y          = advance_y;
-            return m_glyphs[msb][lsb] = glyph;
-        }
-
-    private:
-        block_allocator m_allocator;
-        glyph_cache**   m_glyphs[256];
-        char*           m_font_signature;
-    };
-
-
-
-
-
-
-    
-    //---------------------------------------------------------font_cache_pool
-    class font_cache_pool
-    {
-    public:
-        //--------------------------------------------------------------------
-        ~font_cache_pool()
-        {
-            unsigned i;
-            for(i = 0; i < m_num_fonts; ++i)
-            {
-                obj_allocator<font_cache>::deallocate(m_fonts[i]);
-            }
-            pod_allocator<font_cache*>::deallocate(m_fonts, m_max_fonts);
-        }
-
-        //--------------------------------------------------------------------
-        font_cache_pool(unsigned max_fonts=32) : 
-            m_fonts(pod_allocator<font_cache*>::allocate(max_fonts)),
-            m_max_fonts(max_fonts),
-            m_num_fonts(0),
-            m_cur_font(0)
-        {}
-
-
-        //--------------------------------------------------------------------
-        void font(const char* font_signature, bool reset_cache = false)
-        {
-            int idx = find_font(font_signature);
-            if(idx >= 0)
-            {
-                if(reset_cache)
-                {
-                    obj_allocator<font_cache>::deallocate(m_fonts[idx]);
-                    m_fonts[idx] = obj_allocator<font_cache>::allocate();
-                    m_fonts[idx]->signature(font_signature);
-                }
-                m_cur_font = m_fonts[idx];
-            }
-            else
-            {
-                if(m_num_fonts >= m_max_fonts)
-                {
-                    obj_allocator<font_cache>::deallocate(m_fonts[0]);
-                    memcpy(m_fonts, 
-                           m_fonts + 1, 
-                           (m_max_fonts - 1) * sizeof(font_cache*));
-                    m_num_fonts = m_max_fonts - 1;
-                }
-                m_fonts[m_num_fonts] = obj_allocator<font_cache>::allocate();
-                m_fonts[m_num_fonts]->signature(font_signature);
-                m_cur_font = m_fonts[m_num_fonts];
-                ++m_num_fonts;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        const font_cache* font() const
-        {
-            return m_cur_font;
-        }
-
-        //--------------------------------------------------------------------
-        const glyph_cache* find_glyph(unsigned glyph_code) const
-        {
-            if(m_cur_font) return m_cur_font->find_glyph(glyph_code);
-            return 0;
-        }
-
-        //--------------------------------------------------------------------
-        glyph_cache* cache_glyph(unsigned        glyph_code, 
-                                 unsigned        glyph_index,
-                                 unsigned        data_size,
-                                 glyph_data_type data_type,
-                                 const rect_i&   bounds,
-                                 double          advance_x,
-                                 double          advance_y)
-        {
-            if(m_cur_font) 
-            {
-                return m_cur_font->cache_glyph(glyph_code,
-                                               glyph_index,
-                                               data_size,
-                                               data_type,
-                                               bounds,
-                                               advance_x,
-                                               advance_y);
-            }
-            return 0;
-        }
-
-
-        //--------------------------------------------------------------------
-        int find_font(const char* font_signature)
-        {
-            unsigned i;
-            for(i = 0; i < m_num_fonts; i++)
-            {
-                if(m_fonts[i]->font_is(font_signature)) return int(i);
-            }
-            return -1;
-        }
-
-    private:
-        font_cache** m_fonts;
-        unsigned     m_max_fonts;
-        unsigned     m_num_fonts;
-        font_cache*  m_cur_font;
-    };
-
-
-
-
-    //------------------------------------------------------------------------
-    enum glyph_rendering
-    {
-        glyph_ren_native_mono,
-        glyph_ren_native_gray8,
-        glyph_ren_outline,
-        glyph_ren_agg_mono,
-        glyph_ren_agg_gray8
-    };
-
-
-
-
-    //------------------------------------------------------font_cache_manager
-    template<class FontEngine> class font_cache_manager
-    {
-    public:
-        typedef FontEngine font_engine_type;
-        typedef font_cache_manager<FontEngine> self_type;
-        typedef typename font_engine_type::path_adaptor_type   path_adaptor_type;
-        typedef typename font_engine_type::gray8_adaptor_type  gray8_adaptor_type;
-        typedef typename gray8_adaptor_type::embedded_scanline gray8_scanline_type;
-        typedef typename font_engine_type::mono_adaptor_type   mono_adaptor_type;
-        typedef typename mono_adaptor_type::embedded_scanline  mono_scanline_type;
-
-        //--------------------------------------------------------------------
-        font_cache_manager(font_engine_type& engine, unsigned max_fonts=32) :
-            m_fonts(max_fonts),
-            m_engine(engine),
-            m_change_stamp(-1),
-            m_prev_glyph(0),
-            m_last_glyph(0)
-        {}
-
-        //--------------------------------------------------------------------
-        void reset_last_glyph()
-        {
-            m_prev_glyph = m_last_glyph = 0;
-        }
-
-        //--------------------------------------------------------------------
-        const glyph_cache* glyph(unsigned glyph_code)
-        {
-            synchronize();
-            const glyph_cache* gl = m_fonts.find_glyph(glyph_code);
-            if(gl) 
-            {
-                m_prev_glyph = m_last_glyph;
-                return m_last_glyph = gl;
-            }
-            else
-            {
-                if(m_engine.prepare_glyph(glyph_code))
-                {
-                    m_prev_glyph = m_last_glyph;
-                    m_last_glyph = m_fonts.cache_glyph(glyph_code, 
-                                                       m_engine.glyph_index(),
-                                                       m_engine.data_size(),
-                                                       m_engine.data_type(),
-                                                       m_engine.bounds(),
-                                                       m_engine.advance_x(),
-                                                       m_engine.advance_y());
-                    m_engine.write_glyph_to(m_last_glyph->data);
-                    return m_last_glyph;
-                }
-            }
-            return 0;
-        }
-
-        //--------------------------------------------------------------------
-        void init_embedded_adaptors(const glyph_cache* gl, 
-                                    double x, double y, 
-                                    double scale=1.0)
-        {
-            if(gl)
-            {
-                switch(gl->data_type)
-                {
-                default: return;
-                case glyph_data_mono:
-                    m_mono_adaptor.init(gl->data, gl->data_size, x, y);
-                    break;
-
-                case glyph_data_gray8:
-                    m_gray8_adaptor.init(gl->data, gl->data_size, x, y);
-                    break;
-
-                case glyph_data_outline:
-                    m_path_adaptor.init(gl->data, gl->data_size, x, y, scale);
-                    break;
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        path_adaptor_type&   path_adaptor()   { return m_path_adaptor;   }
-        gray8_adaptor_type&  gray8_adaptor()  { return m_gray8_adaptor;  }
-        gray8_scanline_type& gray8_scanline() { return m_gray8_scanline; }
-        mono_adaptor_type&   mono_adaptor()   { return m_mono_adaptor;   }
-        mono_scanline_type&  mono_scanline()  { return m_mono_scanline;  }
-
-        //--------------------------------------------------------------------
-        const glyph_cache* perv_glyph() const { return m_prev_glyph; }
-        const glyph_cache* last_glyph() const { return m_last_glyph; }
-
-        //--------------------------------------------------------------------
-        bool add_kerning(double* x, double* y)
-        {
-            if(m_prev_glyph && m_last_glyph)
-            {
-                return m_engine.add_kerning(m_prev_glyph->glyph_index, 
-                                            m_last_glyph->glyph_index,
-                                            x, y);
-            }
-            return false;
-        }
-
-        //--------------------------------------------------------------------
-        void precache(unsigned from, unsigned to)
-        {
-            for(; from <= to; ++from) glyph(from);
-        }
-
-        //--------------------------------------------------------------------
-        void reset_cache()
-        {
-            m_fonts.font(m_engine.font_signature(), true);
-            m_change_stamp = m_engine.change_stamp();
-            m_prev_glyph = m_last_glyph = 0;
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        font_cache_manager(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        //--------------------------------------------------------------------
-        void synchronize()
-        {
-            if(m_change_stamp != m_engine.change_stamp())
-            {
-                m_fonts.font(m_engine.font_signature());
-                m_change_stamp = m_engine.change_stamp();
-                m_prev_glyph = m_last_glyph = 0;
-            }
-        }
-
-        font_cache_pool     m_fonts;
-        font_engine_type&   m_engine;
-        int                 m_change_stamp;
-        double              m_dx = 0;
-        double              m_dy = 0;
-        const glyph_cache*  m_prev_glyph;
-        const glyph_cache*  m_last_glyph;
-        path_adaptor_type   m_path_adaptor;
-        gray8_adaptor_type  m_gray8_adaptor;
-        gray8_scanline_type m_gray8_scanline;
-        mono_adaptor_type   m_mono_adaptor;
-        mono_scanline_type  m_mono_scanline;
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_font_freetype.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_font_freetype.h
--- 8.0.1-5/renderers/agg/include/agg_font_freetype.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_font_freetype.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,196 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// See implementation agg_font_freetype.cpp
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_FONT_FREETYPE_INCLUDED
-#define AGG_FONT_FREETYPE_INCLUDED
-
-#include <ft2build.h>
-#include FT_FREETYPE_H
-
-
-#include "agg_scanline_storage_aa.h"
-#include "agg_scanline_storage_bin.h"
-#include "agg_scanline_u.h"
-#include "agg_scanline_bin.h"
-#include "agg_path_storage_integer.h"
-#include "agg_rasterizer_scanline_aa.h"
-#include "agg_conv_curve.h"
-#include "agg_font_cache_manager.h"
-#include "agg_trans_affine.h"
-
-namespace mapserver
-{
-
-
-    //-----------------------------------------------font_engine_freetype_base
-    class font_engine_freetype_base
-    {
-    public:
-        //--------------------------------------------------------------------
-        typedef serialized_scanlines_adaptor_aa<int8u>    gray8_adaptor_type;
-        typedef serialized_scanlines_adaptor_bin          mono_adaptor_type;
-        typedef scanline_storage_aa8                      scanlines_aa_type;
-        typedef scanline_storage_bin                      scanlines_bin_type;
-
-        //--------------------------------------------------------------------
-        ~font_engine_freetype_base();
-        font_engine_freetype_base(bool flag32, unsigned max_faces = 32);
-
-        // Set font parameters
-        //--------------------------------------------------------------------
-        void resolution(unsigned dpi);
-        bool load_font(const char* font_name, unsigned face_index, glyph_rendering ren_type,
-                       const char* font_mem = 0, const long font_mem_size = 0);
-        bool attach(const char* file_name);
-        bool char_map(FT_Encoding map);
-        bool height(double h);
-        bool width(double w);
-        void hinting(bool h);
-        void flip_y(bool f);
-        void transform(const trans_affine& affine);
-
-        // Set Gamma
-        //--------------------------------------------------------------------
-        template<class GammaF> void gamma(const GammaF& f)
-        {
-            m_rasterizer.gamma(f);
-        }
-
-        // Accessors
-        //--------------------------------------------------------------------
-        int         last_error()   const { return m_last_error; }
-        unsigned    resolution()   const { return m_resolution; }
-        const char* name()         const { return m_name;       }
-        unsigned    num_faces()    const;
-        FT_Encoding char_map()     const { return m_char_map;   }
-        double      height()       const { return double(m_height) / 64.0;    }
-        double      width()        const { return double(m_width) / 64.0;     }
-        double      ascender()     const;
-        double      descender()    const;
-        bool        hinting()      const { return m_hinting;    }
-        bool        flip_y()       const { return m_flip_y;     }
-
-
-        // Interface mandatory to implement for font_cache_manager
-        //--------------------------------------------------------------------
-        const char*     font_signature() const { return m_signature;    }
-        int             change_stamp()   const { return m_change_stamp; }
-
-        bool            prepare_glyph(unsigned glyph_code);
-        unsigned        glyph_index() const { return m_glyph_index; }
-        unsigned        data_size()   const { return m_data_size;   }
-        glyph_data_type data_type()   const { return m_data_type;   }
-        const rect_i&   bounds()      const { return m_bounds;      }
-        double          advance_x()   const { return m_advance_x;   }
-        double          advance_y()   const { return m_advance_y;   }
-        void            write_glyph_to(int8u* data) const;
-        bool            add_kerning(unsigned first, unsigned second,
-                                    double* x, double* y);
-
-    private:
-        font_engine_freetype_base(const font_engine_freetype_base&);
-        const font_engine_freetype_base& operator = (const font_engine_freetype_base&);
-
-        void update_char_size();
-        void update_signature();
-        int  find_face(const char* face_name) const;
-
-        bool            m_flag32;
-        int             m_change_stamp;
-        int             m_last_error;
-        char*           m_name;
-        unsigned        m_name_len;
-        unsigned        m_face_index;
-        FT_Encoding     m_char_map;
-        char*           m_signature;
-        unsigned        m_height;
-        unsigned        m_width;
-        bool            m_hinting;
-        bool            m_flip_y;
-        bool            m_library_initialized;
-        FT_Library      m_library;    // handle to library    
-        FT_Face*        m_faces;      // A pool of font faces
-        char**          m_face_names; 
-        unsigned        m_num_faces;
-        unsigned        m_max_faces;
-        FT_Face         m_cur_face;  // handle to the current face object
-        int             m_resolution;
-        glyph_rendering m_glyph_rendering;
-        unsigned        m_glyph_index;
-        unsigned        m_data_size;
-        glyph_data_type m_data_type;
-        rect_i          m_bounds;
-        double          m_advance_x;
-        double          m_advance_y;
-        trans_affine    m_affine;
-
-        path_storage_integer<int16, 6>              m_path16;
-        path_storage_integer<int32, 6>              m_path32;
-        conv_curve<path_storage_integer<int16, 6> > m_curves16;
-        conv_curve<path_storage_integer<int32, 6> > m_curves32;
-        scanline_u8              m_scanline_aa;
-        scanline_bin             m_scanline_bin;
-        scanlines_aa_type        m_scanlines_aa;
-        scanlines_bin_type       m_scanlines_bin;
-        rasterizer_scanline_aa<> m_rasterizer;
-    };
-
-
-
-
-    //------------------------------------------------font_engine_freetype_int16
-    // This class uses values of type int16 (10.6 format) for the vector cache. 
-    // The vector cache is compact, but when rendering glyphs of height
-    // more that 200 there integer overflow can occur.
-    //
-    class font_engine_freetype_int16 : public font_engine_freetype_base
-    {
-    public:
-        typedef serialized_integer_path_adaptor<int16, 6>     path_adaptor_type;
-        typedef font_engine_freetype_base::gray8_adaptor_type gray8_adaptor_type;
-        typedef font_engine_freetype_base::mono_adaptor_type  mono_adaptor_type;
-        typedef font_engine_freetype_base::scanlines_aa_type  scanlines_aa_type;
-        typedef font_engine_freetype_base::scanlines_bin_type scanlines_bin_type;
-
-        font_engine_freetype_int16(unsigned max_faces = 32) : 
-            font_engine_freetype_base(false, max_faces) {}
-    };
-
-    //------------------------------------------------font_engine_freetype_int32
-    // This class uses values of type int32 (26.6 format) for the vector cache. 
-    // The vector cache is twice larger than in font_engine_freetype_int16, 
-    // but it allows you to render glyphs of very large sizes.
-    //
-    class font_engine_freetype_int32 : public font_engine_freetype_base
-    {
-    public:
-        typedef serialized_integer_path_adaptor<int32, 6>     path_adaptor_type;
-        typedef font_engine_freetype_base::gray8_adaptor_type gray8_adaptor_type;
-        typedef font_engine_freetype_base::mono_adaptor_type  mono_adaptor_type;
-        typedef font_engine_freetype_base::scanlines_aa_type  scanlines_aa_type;
-        typedef font_engine_freetype_base::scanlines_bin_type scanlines_bin_type;
-
-        font_engine_freetype_int32(unsigned max_faces = 32) : 
-            font_engine_freetype_base(true, max_faces) {}
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_gamma_functions.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gamma_functions.h
--- 8.0.1-5/renderers/agg/include/agg_gamma_functions.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gamma_functions.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,123 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_GAMMA_FUNCTIONS_INCLUDED
-#define AGG_GAMMA_FUNCTIONS_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //===============================================================gamma_none
-    struct gamma_none
-    {
-        double operator()(double x) const { return x; }
-    };
-
-
-    //==============================================================gamma_power
-    class gamma_power
-    {
-    public:
-        gamma_power() : m_gamma(1.0) {}
-        gamma_power(double g) : m_gamma(g) {}
-
-        void gamma(double g) { m_gamma = g; }
-        double gamma() const { return m_gamma; }
-
-        double operator() (double x) const
-        {
-            return pow(x, m_gamma);
-        }
-
-    private:
-        double m_gamma;
-    };
-
-
-    //==========================================================gamma_threshold
-    class gamma_threshold
-    {
-    public:
-        gamma_threshold() : m_threshold(0.5) {}
-        gamma_threshold(double t) : m_threshold(t) {}
-
-        void threshold(double t) { m_threshold = t; }
-        double threshold() const { return m_threshold; }
-
-        double operator() (double x) const
-        {
-            return (x < m_threshold) ? 0.0 : 1.0;
-        }
-
-    private:
-        double m_threshold;
-    };
-
-
-    //============================================================gamma_linear
-    class gamma_linear
-    {
-    public:
-        gamma_linear() : m_start(0.0), m_end(1.0) {}
-        gamma_linear(double s, double e) : m_start(s), m_end(e) {}
-
-        void set(double s, double e) { m_start = s; m_end = e; }
-        void start(double s) { m_start = s; }
-        void end(double e) { m_end = e; }
-        double start() const { return m_start; }
-        double end() const { return m_end; }
-
-        double operator() (double x) const
-        {
-            if(x < m_start) return 0.0;
-            if(x > m_end) return 1.0;
-            return (x - m_start) / (m_end - m_start);
-        }
-
-    private:
-        double m_start;
-        double m_end;
-    };
-
-
-    //==========================================================gamma_multiply
-    class gamma_multiply
-    {
-    public:
-        gamma_multiply() : m_mul(1.0) {}
-        gamma_multiply(double v) : m_mul(v) {}
-
-        void value(double v) { m_mul = v; }
-        double value() const { return m_mul; }
-
-        double operator() (double x) const
-        {
-            double y = x * m_mul;
-            if(y > 1.0) y = 1.0;
-            return y;
-        }
-
-    private:
-        double m_mul;
-    };
-
-}
-
-#endif
-
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_gamma_lut.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gamma_lut.h
--- 8.0.1-5/renderers/agg/include/agg_gamma_lut.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gamma_lut.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,121 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_GAMMA_LUT_INCLUDED
-#define AGG_GAMMA_LUT_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    template<class LoResT=int8u, 
-             class HiResT=int8u, 
-             unsigned GammaShift=8, 
-             unsigned HiResShift=8> class gamma_lut
-    {
-    public:
-        typedef gamma_lut<LoResT, HiResT, GammaShift, HiResShift> self_type;
-
-        enum gamma_scale_e
-        {
-            gamma_shift = GammaShift,
-            gamma_size  = 1 << gamma_shift,
-            gamma_mask  = gamma_size - 1
-        };
-
-        enum hi_res_scale_e
-        {
-            hi_res_shift = HiResShift,
-            hi_res_size  = 1 << hi_res_shift,
-            hi_res_mask  = hi_res_size - 1
-        };
-
-        ~gamma_lut()
-        {
-            pod_allocator<LoResT>::deallocate(m_inv_gamma, hi_res_size);
-            pod_allocator<HiResT>::deallocate(m_dir_gamma, gamma_size);
-        }
-
-        gamma_lut() : 
-            m_gamma(1.0), 
-            m_dir_gamma(pod_allocator<HiResT>::allocate(gamma_size)),
-            m_inv_gamma(pod_allocator<LoResT>::allocate(hi_res_size))
-        {
-            unsigned i;
-            for(i = 0; i < gamma_size; i++)
-            {
-                m_dir_gamma[i] = HiResT(i << (hi_res_shift - gamma_shift));
-            }
-
-            for(i = 0; i < hi_res_size; i++)
-            {
-                m_inv_gamma[i] = LoResT(i >> (hi_res_shift - gamma_shift));
-            }
-        }
-
-        gamma_lut(double g) :
-            m_gamma(1.0), 
-            m_dir_gamma(pod_allocator<HiResT>::allocate(gamma_size)),
-            m_inv_gamma(pod_allocator<LoResT>::allocate(hi_res_size))
-        {
-            gamma(g);
-        }
-
-        void gamma(double g) 
-        {
-            m_gamma = g;
-
-            unsigned i;
-            for(i = 0; i < gamma_size; i++)
-            {
-                m_dir_gamma[i] = (HiResT)
-                    uround(pow(i / double(gamma_mask), m_gamma) * double(hi_res_mask));
-            }
-
-            double inv_g = 1.0 / g;
-            for(i = 0; i < hi_res_size; i++)
-            {
-                m_inv_gamma[i] = (LoResT)
-                    uround(pow(i / double(hi_res_mask), inv_g) * double(gamma_mask));
-            }
-        }
-
-        double gamma() const
-        {
-            return m_gamma;
-        }
-
-        HiResT dir(LoResT v) const 
-        { 
-            return m_dir_gamma[unsigned(v)]; 
-        }
-
-        LoResT inv(HiResT v) const 
-        { 
-            return m_inv_gamma[unsigned(v)];
-        }
-
-    private:
-        gamma_lut(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        double m_gamma;
-        HiResT* m_dir_gamma;
-        LoResT* m_inv_gamma;
-    };
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_glyph_raster_bin.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_glyph_raster_bin.h
--- 8.0.1-5/renderers/agg/include/agg_glyph_raster_bin.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_glyph_raster_bin.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,165 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_GLYPH_RASTER_BIN_INCLUDED
-#define AGG_GLYPH_RASTER_BIN_INCLUDED
-
-#include <string.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //========================================================glyph_raster_bin
-    template<class ColorT> class glyph_raster_bin
-    {
-    public:
-        typedef ColorT color_type;
-
-        //--------------------------------------------------------------------
-        struct glyph_rect
-        {
-            int x1,y1,x2,y2;
-            double dx, dy;
-        };
-
-        //--------------------------------------------------------------------
-        glyph_raster_bin(const int8u* font) :
-            m_font(font),
-            m_big_endian(false)
-        {
-            int t = 1;
-            if(*(char*)&t == 0) m_big_endian = true;
-            memset(m_span, 0, sizeof(m_span));
-        }
-
-        //--------------------------------------------------------------------
-        const int8u* font() const { return m_font; }
-        void font(const int8u* f) { m_font = f; }
-
-        //--------------------------------------------------------------------
-        double height()    const { return m_font[0]; }
-        double base_line() const { return m_font[1]; }
-
-        //--------------------------------------------------------------------
-        template<class CharT>
-        double width(const CharT* str) const
-        {
-            unsigned start_char = m_font[2];
-            unsigned num_chars = m_font[3];
-
-            unsigned w = 0;
-            while(*str)
-            {
-                unsigned glyph = *str;
-                const int8u* bits = m_font + 4 + num_chars * 2 + 
-                                    value(m_font + 4 + (glyph - start_char) * 2);
-                w += *bits;
-                ++str;
-            }
-            return w;
-        }
-
-        int8u glyph_width(unsigned glyph) const
-        {
-            unsigned start_char = m_font[2];
-            unsigned num_chars = m_font[3];
-
-            const int8u* bits = m_font + 4 + num_chars * 2 +
-                                    value(m_font + 4 + (glyph - start_char) * 2);
-            return *bits;
-        }
-
-        //--------------------------------------------------------------------
-        void prepare(glyph_rect* r, double x, double y, unsigned glyph, bool flip)
-        {
-            unsigned start_char = m_font[2];
-            unsigned num_chars = m_font[3];
-
-            m_bits = m_font + 4 + num_chars * 2 + 
-                     value(m_font + 4 + (glyph - start_char) * 2);
-
-            m_glyph_width = *m_bits++;
-            m_glyph_byte_width = (m_glyph_width + 7) >> 3;
-
-            r->x1 = int(x);
-            r->x2 = r->x1 + m_glyph_width - 1;
-            if(flip)
-            {
-                r->y1 = int(y) - m_font[0] + m_font[1];
-                r->y2 = r->y1 + m_font[0] - 1;
-            }
-            else
-            {
-                r->y1 = int(y) - m_font[1] + 1;
-                r->y2 = r->y1 + m_font[0] - 1;
-            }
-            r->dx = m_glyph_width; 
-            r->dy = 0;
-        }
-
-        //--------------------------------------------------------------------
-        const cover_type* span(unsigned i)
-        {
-            i = m_font[0] - i - 1;
-            const int8u* bits = m_bits + i * m_glyph_byte_width;
-            unsigned j;
-            unsigned val = *bits;
-            unsigned nb = 0;
-            for(j = 0; j < m_glyph_width; ++j)
-            {
-                m_span[j] = (cover_type)((val & 0x80) ? cover_full : cover_none);
-                val <<= 1;
-                if(++nb >= 8)
-                {
-                    val = *++bits;
-                    nb = 0;
-                }
-            }
-            return m_span;
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        int16u value(const int8u* p) const
-        {
-            int16u v;
-            if(m_big_endian)
-            {
-                 *(int8u*)&v      = p[1];
-                *((int8u*)&v + 1) = p[0];
-            }
-            else
-            {
-                 *(int8u*)&v      = p[0];
-                *((int8u*)&v + 1) = p[1];
-            }
-            return v;
-        }
-
-
-        //--------------------------------------------------------------------
-        const int8u* m_font;
-        bool m_big_endian;
-        cover_type m_span[32];
-        const int8u* m_bits;
-        unsigned m_glyph_width;
-        unsigned m_glyph_byte_width;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_gradient_lut.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gradient_lut.h
--- 8.0.1-5/renderers/agg/include/agg_gradient_lut.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gradient_lut.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,244 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_GRADIENT_LUT_INCLUDED
-#define AGG_GRADIENT_LUT_INCLUDED
-
-#include "agg_array.h"
-#include "agg_dda_line.h"
-#include "agg_color_rgba.h"
-#include "agg_color_gray.h"
-
-namespace mapserver
-{
-
-    //======================================================color_interpolator
-    template<class ColorT> struct color_interpolator
-    {
-    public:
-        typedef ColorT color_type;
-
-        color_interpolator(const color_type& c1, 
-                           const color_type& c2, 
-                           unsigned len) :
-            m_c1(c1),
-            m_c2(c2),
-            m_len(len),
-            m_count(0)
-        {}
-
-        void operator ++ ()
-        {
-            ++m_count;
-        }
-
-        color_type color() const
-        {
-            return m_c1.gradient(m_c2, double(m_count) / m_len);
-        }
-
-    private:
-        color_type m_c1;
-        color_type m_c2;
-        unsigned   m_len;
-        unsigned   m_count;
-    };
-
-    //========================================================================
-    // Fast specialization for rgba8
-    template<> struct color_interpolator<rgba8>
-    {
-    public:
-        typedef rgba8 color_type;
-
-        color_interpolator(const color_type& c1, 
-                           const color_type& c2, 
-                           unsigned len) :
-            r(c1.r, c2.r, len),
-            g(c1.g, c2.g, len),
-            b(c1.b, c2.b, len),
-            a(c1.a, c2.a, len)
-        {}
-
-        void operator ++ ()
-        {
-            ++r; ++g; ++b; ++a;
-        }
-
-        color_type color() const
-        {
-            return color_type(r.y(), g.y(), b.y(), a.y());
-        }
-
-    private:
-        mapserver::dda_line_interpolator<14> r, g, b, a;
-    };
-
-    //========================================================================
-    // Fast specialization for gray8
-    template<> struct color_interpolator<gray8>
-    {
-    public:
-        typedef gray8 color_type;
-
-        color_interpolator(const color_type& c1, 
-                           const color_type& c2, 
-                           unsigned len) :
-            v(c1.v, c2.v, len),
-            a(c1.a, c2.a, len)
-        {}
-
-        void operator ++ ()
-        {
-            ++v; ++a;
-        }
-
-        color_type color() const
-        {
-            return color_type(v.y(), a.y());
-        }
-
-    private:
-        mapserver::dda_line_interpolator<14> v,a;
-    };
-
-    //============================================================gradient_lut
-    template<class ColorInterpolator, 
-             unsigned ColorLutSize=256> class gradient_lut
-    {
-    public:
-        typedef ColorInterpolator interpolator_type;
-        typedef typename interpolator_type::color_type color_type;
-        enum { color_lut_size = ColorLutSize };
-
-        //--------------------------------------------------------------------
-        gradient_lut() : m_color_lut(color_lut_size) {}
-
-        // Build Gradient Lut
-        // First, call remove_all(), then add_color() at least twice, 
-        // then build_lut(). Argument "offset" in add_color must be 
-        // in range [0...1] and defines a color stop as it is described 
-        // in SVG specification, section Gradients and Patterns. 
-        // The simplest linear gradient is:
-        //    gradient_lut.add_color(0.0, start_color);
-        //    gradient_lut.add_color(1.0, end_color);
-        //--------------------------------------------------------------------
-        void remove_all();
-        void add_color(double offset, const color_type& color);
-        void build_lut();
-
-        // Size-index Interface. This class can be used directly as the 
-        // ColorF in span_gradient. All it needs is two access methods 
-        // size() and operator [].
-        //--------------------------------------------------------------------
-        static unsigned size() 
-        { 
-            return color_lut_size; 
-        }
-        const color_type& operator [] (unsigned i) const 
-        { 
-            return m_color_lut[i]; 
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        struct color_point
-        {
-            double     offset;
-            color_type color;
-
-            color_point() {}
-            color_point(double off, const color_type& c) : 
-                offset(off), color(c)
-            {
-                if(offset < 0.0) offset = 0.0;
-                if(offset > 1.0) offset = 1.0;
-            }
-        };
-        typedef mapserver::pod_bvector<color_point, 4> color_profile_type;
-        typedef mapserver::pod_array<color_type>       color_lut_type;
-
-        static bool offset_less(const color_point& a, const color_point& b)
-        {
-            return a.offset < b.offset;
-        }
-        static bool offset_equal(const color_point& a, const color_point& b)
-        {
-            return a.offset == b.offset;
-        }
-
-        //--------------------------------------------------------------------
-        color_profile_type  m_color_profile;
-        color_lut_type      m_color_lut;
-    };
-
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S>
-    void gradient_lut<T,S>::remove_all()
-    { 
-        m_color_profile.remove_all(); 
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S>
-    void gradient_lut<T,S>::add_color(double offset, const color_type& color)
-    {
-        m_color_profile.add(color_point(offset, color));
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S>
-    void gradient_lut<T,S>::build_lut()
-    {
-        quick_sort(m_color_profile, offset_less);
-        m_color_profile.cut_at(remove_duplicates(m_color_profile, offset_equal));
-        if(m_color_profile.size() >= 2)
-        {
-            unsigned i;
-            unsigned start = uround(m_color_profile[0].offset * color_lut_size);
-            unsigned end;
-            color_type c = m_color_profile[0].color;
-            for(i = 0; i < start; i++) 
-            {
-                m_color_lut[i] = c;
-            }
-            for(i = 1; i < m_color_profile.size(); i++)
-            {
-                end  = uround(m_color_profile[i].offset * color_lut_size);
-                interpolator_type ci(m_color_profile[i-1].color, 
-                                     m_color_profile[i  ].color, 
-                                     end - start + 1);
-                while(start < end)
-                {
-                    m_color_lut[start] = ci.color();
-                    ++ci;
-                    ++start;
-                }
-            }
-            c = m_color_profile.last().color;
-            for(; end < m_color_lut.size(); end++)
-            {
-                m_color_lut[end] = c;
-            }
-        }
-    }
-}
-
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_gsv_text.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gsv_text.h
--- 8.0.1-5/renderers/agg/include/agg_gsv_text.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_gsv_text.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,153 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Class gsv_text
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_GSV_TEXT_INCLUDED
-#define AGG_GSV_TEXT_INCLUDED
-
-#include "agg_array.h"
-#include "agg_conv_stroke.h"
-#include "agg_conv_transform.h"
-
-namespace mapserver
-{
-
-
-    //---------------------------------------------------------------gsv_text
-    //
-    // See Implementation agg_gsv_text.cpp 
-    //
-    class gsv_text
-    {
-        enum status
-        {
-            initial,
-            next_char,
-            start_glyph,
-            glyph
-        };
-
-    public:
-        gsv_text();
-
-        void font(const void* font);
-        void flip(bool flip_y) { m_flip = flip_y; }
-        void load_font(const char* file);
-        void size(double height, double width=0.0);
-        void space(double space);
-        void line_space(double line_space);
-        void start_point(double x, double y);
-        void text(const char* text);
-        
-        double text_width();
-
-        void rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        // not supposed to be copied
-        gsv_text(const gsv_text&);
-        const gsv_text& operator = (const gsv_text&);
-
-        int16u value(const int8u* p) const
-        {
-            int16u v;
-            if(m_big_endian)
-            {
-                 *(int8u*)&v      = p[1];
-                *((int8u*)&v + 1) = p[0];
-            }
-            else
-            {
-                 *(int8u*)&v      = p[0];
-                *((int8u*)&v + 1) = p[1];
-            }
-            return v;
-        }
-
-    private:
-        double          m_x;
-        double          m_y;
-        double          m_start_x;
-        double          m_width;
-        double          m_height;
-        double          m_space;
-        double          m_line_space;
-        char            m_chr[2];
-        char*           m_text;
-        pod_array<char> m_text_buf;
-        char*           m_cur_chr;
-        const void*     m_font;
-        pod_array<char> m_loaded_font;
-        status          m_status;
-        bool            m_big_endian;
-        bool            m_flip;
-        int8u*          m_indices;
-        int8*           m_glyphs;
-        int8*           m_bglyph;
-        int8*           m_eglyph;
-        double          m_w;
-        double          m_h;
-    };
-
-
-
-
-    //--------------------------------------------------------gsv_text_outline
-    template<class Transformer = trans_affine> class gsv_text_outline
-    {
-    public:
-        gsv_text_outline(gsv_text& text, const Transformer& trans) :
-          m_polyline(text),
-          m_trans(m_polyline, trans)
-        {
-        }
-
-        void width(double w) 
-        { 
-            m_polyline.width(w); 
-        }
-
-        void transformer(const Transformer* trans) 
-        {
-            m_trans->transformer(trans);
-        }
-
-        void rewind(unsigned path_id) 
-        { 
-            m_trans.rewind(path_id); 
-            m_polyline.line_join(round_join);
-            m_polyline.line_cap(round_cap);
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            return m_trans.vertex(x, y);
-        }
-
-    private:
-        conv_stroke<gsv_text> m_polyline;
-        conv_transform<conv_stroke<gsv_text>, Transformer> m_trans;
-    };
-
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_image_accessors.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_image_accessors.h
--- 8.0.1-5/renderers/agg/include/agg_image_accessors.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_image_accessors.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,481 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_IMAGE_ACCESSORS_INCLUDED
-#define AGG_IMAGE_ACCESSORS_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------image_accessor_clip
-    template<class PixFmt> class image_accessor_clip
-    {
-    public:
-        typedef PixFmt   pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::order_type order_type;
-        typedef typename pixfmt_type::value_type value_type;
-        enum pix_width_e { pix_width = pixfmt_type::pix_width };
-
-        image_accessor_clip() {}
-        explicit image_accessor_clip(const pixfmt_type& pixf, 
-                                     const color_type& bk) : 
-            m_pixf(&pixf)
-        {
-            pixfmt_type::make_pix(m_bk_buf, bk);
-        }
-
-        void attach(const pixfmt_type& pixf)
-        {
-            m_pixf = &pixf;
-        }
-
-        void background_color(const color_type& bk)
-        {
-            pixfmt_type::make_pix(m_bk_buf, bk);
-        }
-
-    private:
-        AGG_INLINE const int8u* pixel() const
-        {
-            if(m_y >= 0 && m_y < (int)m_pixf->height() &&
-               m_x >= 0 && m_x < (int)m_pixf->width())
-            {
-                return m_pixf->pix_ptr(m_x, m_y);
-            }
-            return m_bk_buf;
-        }
-
-    public:
-        AGG_INLINE const int8u* span(int x, int y, unsigned len)
-        {
-            m_x = m_x0 = x;
-            m_y = y;
-            if(y >= 0 && y < (int)m_pixf->height() &&
-               x >= 0 && x+(int)len <= (int)m_pixf->width())
-            {
-                return m_pix_ptr = m_pixf->pix_ptr(x, y);
-            }
-            m_pix_ptr = 0;
-            return pixel();
-        }
-
-        AGG_INLINE const int8u* next_x()
-        {
-            if(m_pix_ptr) return m_pix_ptr += pix_width;
-            ++m_x;
-            return pixel();
-        }
-
-        AGG_INLINE const int8u* next_y()
-        {
-            ++m_y;
-            m_x = m_x0;
-            if(m_pix_ptr && 
-               m_y >= 0 && m_y < (int)m_pixf->height())
-            {
-                return m_pix_ptr = m_pixf->pix_ptr(m_x, m_y);
-            }
-            m_pix_ptr = 0;
-            return pixel();
-        }
-
-    private:
-        const pixfmt_type* m_pixf;
-        int8u              m_bk_buf[4];
-        int                m_x, m_x0, m_y;
-        const int8u*       m_pix_ptr;
-    };
-
-
-
-
-    //--------------------------------------------------image_accessor_no_clip
-    template<class PixFmt> class image_accessor_no_clip
-    {
-    public:
-        typedef PixFmt   pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::order_type order_type;
-        typedef typename pixfmt_type::value_type value_type;
-        enum pix_width_e { pix_width = pixfmt_type::pix_width };
-
-        image_accessor_no_clip() {}
-        explicit image_accessor_no_clip(const pixfmt_type& pixf) : 
-            m_pixf(&pixf) 
-        {}
-
-        void attach(const pixfmt_type& pixf)
-        {
-            m_pixf = &pixf;
-        }
-
-        AGG_INLINE const int8u* span(int x, int y, unsigned)
-        {
-            m_x = x;
-            m_y = y;
-            return m_pix_ptr = m_pixf->pix_ptr(x, y);
-        }
-
-        AGG_INLINE const int8u* next_x()
-        {
-            return m_pix_ptr += pix_width;
-        }
-
-        AGG_INLINE const int8u* next_y()
-        {
-            ++m_y;
-            return m_pix_ptr = m_pixf->pix_ptr(m_x, m_y);
-        }
-
-    private:
-        const pixfmt_type* m_pixf;
-        int                m_x, m_y;
-        const int8u*       m_pix_ptr;
-    };
-
-
-
-
-    //----------------------------------------------------image_accessor_clone
-    template<class PixFmt> class image_accessor_clone
-    {
-    public:
-        typedef PixFmt   pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::order_type order_type;
-        typedef typename pixfmt_type::value_type value_type;
-        enum pix_width_e { pix_width = pixfmt_type::pix_width };
-
-        image_accessor_clone() {}
-        explicit image_accessor_clone(const pixfmt_type& pixf) : 
-            m_pixf(&pixf) 
-        {}
-
-        void attach(const pixfmt_type& pixf)
-        {
-            m_pixf = &pixf;
-        }
-
-    private:
-        AGG_INLINE const int8u* pixel() const
-        {
-            int x = m_x;
-            int y = m_y;
-            if(x < 0) x = 0;
-            if(y < 0) y = 0;
-            if(x >= (int)m_pixf->width())  x = m_pixf->width() - 1;
-            if(y >= (int)m_pixf->height()) y = m_pixf->height() - 1;
-            return m_pixf->pix_ptr(x, y);
-        }
-
-    public:
-        AGG_INLINE const int8u* span(int x, int y, unsigned len)
-        {
-            m_x = m_x0 = x;
-            m_y = y;
-            if(y >= 0 && y < (int)m_pixf->height() &&
-               x >= 0 && x+len <= (int)m_pixf->width())
-            {
-                return m_pix_ptr = m_pixf->pix_ptr(x, y);
-            }
-            m_pix_ptr = 0;
-            return pixel();
-        }
-
-        AGG_INLINE const int8u* next_x()
-        {
-            if(m_pix_ptr) return m_pix_ptr += pix_width;
-            ++m_x;
-            return pixel();
-        }
-
-        AGG_INLINE const int8u* next_y()
-        {
-            ++m_y;
-            m_x = m_x0;
-            if(m_pix_ptr && 
-               m_y >= 0 && m_y < (int)m_pixf->height())
-            {
-                return m_pix_ptr = m_pixf->pix_ptr(m_x, m_y);
-            }
-            m_pix_ptr = 0;
-            return pixel();
-        }
-
-    private:
-        const pixfmt_type* m_pixf;
-        int                m_x, m_x0, m_y;
-        const int8u*       m_pix_ptr;
-    };
-
-
-
-
-
-    //-----------------------------------------------------image_accessor_wrap
-    template<class PixFmt, class WrapX, class WrapY> class image_accessor_wrap
-    {
-    public:
-        typedef PixFmt   pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::order_type order_type;
-        typedef typename pixfmt_type::value_type value_type;
-        enum pix_width_e { pix_width = pixfmt_type::pix_width };
-
-        image_accessor_wrap() = default;
-        explicit image_accessor_wrap(const pixfmt_type& pixf) : 
-            m_pixf(&pixf), 
-            m_wrap_x(pixf.width()), 
-            m_wrap_y(pixf.height())
-        {}
-
-        void attach(const pixfmt_type& pixf)
-        {
-            m_pixf = &pixf;
-        }
-
-        AGG_INLINE const int8u* span(int x, int y, unsigned)
-        {
-            m_x = x;
-            m_row_ptr = m_pixf->row_ptr(m_wrap_y(y));
-            return m_row_ptr + m_wrap_x(x) * pix_width;
-        }
-
-        AGG_INLINE const int8u* next_x()
-        {
-            int x = ++m_wrap_x;
-            return m_row_ptr + x * pix_width;
-        }
-
-        AGG_INLINE const int8u* next_y()
-        {
-            m_row_ptr = m_pixf->row_ptr(++m_wrap_y);
-            return m_row_ptr + m_wrap_x(m_x) * pix_width;
-        }
-
-    private:
-        const pixfmt_type* m_pixf = nullptr;
-        const int8u*       m_row_ptr = nullptr;
-        int                m_x = 0;
-        WrapX              m_wrap_x = 0;
-        WrapY              m_wrap_y = 0;
-    };
-
-
-
-
-    //--------------------------------------------------------wrap_mode_repeat
-    class wrap_mode_repeat
-    {
-    public:
-        wrap_mode_repeat() {}
-        wrap_mode_repeat(unsigned size) : 
-            m_size(size), 
-            m_add(size * (0x3FFFFFFF / size)),
-            m_value(0)
-        {}
-
-        AGG_INLINE unsigned operator() (int v)
-        { 
-            return m_value = (unsigned(v) + m_add) % m_size; 
-        }
-
-        AGG_INLINE unsigned operator++ ()
-        {
-            ++m_value;
-            if(m_value >= m_size) m_value = 0;
-            return m_value;
-        }
-    private:
-        unsigned m_size;
-        unsigned m_add;
-        unsigned m_value;
-    };
-
-
-    //---------------------------------------------------wrap_mode_repeat_pow2
-    class wrap_mode_repeat_pow2
-    {
-    public:
-        wrap_mode_repeat_pow2() {}
-        wrap_mode_repeat_pow2(unsigned size) : m_value(0)
-        {
-            m_mask = 1;
-            while(m_mask < size) m_mask = (m_mask << 1) | 1;
-            m_mask >>= 1;
-        }
-        AGG_INLINE unsigned operator() (int v)
-        { 
-            return m_value = unsigned(v) & m_mask;
-        }
-        AGG_INLINE unsigned operator++ ()
-        {
-            ++m_value;
-            if(m_value > m_mask) m_value = 0;
-            return m_value;
-        }
-    private:
-        unsigned m_mask;
-        unsigned m_value;
-    };
-
-
-    //----------------------------------------------wrap_mode_repeat_auto_pow2
-    class wrap_mode_repeat_auto_pow2
-    {
-    public:
-        wrap_mode_repeat_auto_pow2() {}
-        wrap_mode_repeat_auto_pow2(unsigned size) :
-            m_size(size),
-            m_add(size * (0x3FFFFFFF / size)),
-            m_mask((m_size & (m_size-1)) ? 0 : m_size-1),
-            m_value(0)
-        {}
-
-        AGG_INLINE unsigned operator() (int v) 
-        { 
-            if(m_mask) return m_value = unsigned(v) & m_mask;
-            return m_value = (unsigned(v) + m_add) % m_size;
-        }
-        AGG_INLINE unsigned operator++ ()
-        {
-            ++m_value;
-            if(m_value >= m_size) m_value = 0;
-            return m_value;
-        }
-
-    private:
-        unsigned m_size;
-        unsigned m_add;
-        unsigned m_mask;
-        unsigned m_value;
-    };
-
-
-    //-------------------------------------------------------wrap_mode_reflect
-    class wrap_mode_reflect
-    {
-    public:
-        wrap_mode_reflect() {}
-        wrap_mode_reflect(unsigned size) : 
-            m_size(size), 
-            m_size2(size * 2),
-            m_add(m_size2 * (0x3FFFFFFF / m_size2)),
-            m_value(0)
-        {}
-
-        AGG_INLINE unsigned operator() (int v)
-        { 
-            m_value = (unsigned(v) + m_add) % m_size2;
-            if(m_value >= m_size) return m_size2 - m_value - 1;
-            return m_value;
-        }
-
-        AGG_INLINE unsigned operator++ ()
-        {
-            ++m_value;
-            if(m_value >= m_size2) m_value = 0;
-            if(m_value >= m_size) return m_size2 - m_value - 1;
-            return m_value;
-        }
-    private:
-        unsigned m_size;
-        unsigned m_size2;
-        unsigned m_add;
-        unsigned m_value;
-    };
-
-
-
-    //--------------------------------------------------wrap_mode_reflect_pow2
-    class wrap_mode_reflect_pow2
-    {
-    public:
-        wrap_mode_reflect_pow2() {}
-        wrap_mode_reflect_pow2(unsigned size) : m_value(0)
-        {
-            m_mask = 1;
-            m_size = 1;
-            while(m_mask < size) 
-            {
-                m_mask = (m_mask << 1) | 1;
-                m_size <<= 1;
-            }
-        }
-        AGG_INLINE unsigned operator() (int v)
-        { 
-            m_value = unsigned(v) & m_mask;
-            if(m_value >= m_size) return m_mask - m_value;
-            return m_value;
-        }
-        AGG_INLINE unsigned operator++ ()
-        {
-            ++m_value;
-            m_value &= m_mask;
-            if(m_value >= m_size) return m_mask - m_value;
-            return m_value;
-        }
-    private:
-        unsigned m_size;
-        unsigned m_mask;
-        unsigned m_value;
-    };
-
-
-
-    //---------------------------------------------wrap_mode_reflect_auto_pow2
-    class wrap_mode_reflect_auto_pow2
-    {
-    public:
-        wrap_mode_reflect_auto_pow2() {}
-        wrap_mode_reflect_auto_pow2(unsigned size) :
-            m_size(size),
-            m_size2(size * 2),
-            m_add(m_size2 * (0x3FFFFFFF / m_size2)),
-            m_mask((m_size2 & (m_size2-1)) ? 0 : m_size2-1),
-            m_value(0)
-        {}
-
-        AGG_INLINE unsigned operator() (int v) 
-        { 
-            m_value = m_mask ? unsigned(v) & m_mask : 
-                              (unsigned(v) + m_add) % m_size2;
-            if(m_value >= m_size) return m_size2 - m_value - 1;
-            return m_value;            
-        }
-        AGG_INLINE unsigned operator++ ()
-        {
-            ++m_value;
-            if(m_value >= m_size2) m_value = 0;
-            if(m_value >= m_size) return m_size2 - m_value - 1;
-            return m_value;
-        }
-
-    private:
-        unsigned m_size;
-        unsigned m_size2;
-        unsigned m_add;
-        unsigned m_mask;
-        unsigned m_value;
-    };
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_image_filters.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_image_filters.h
--- 8.0.1-5/renderers/agg/include/agg_image_filters.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_image_filters.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,448 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Image transformation filters,
-// Filtering classes (image_filter_lut, image_filter),
-// Basic filter shape classes
-//----------------------------------------------------------------------------
-#ifndef AGG_IMAGE_FILTERS_INCLUDED
-#define AGG_IMAGE_FILTERS_INCLUDED
-
-#include "agg_array.h"
-#include "agg_math.h"
-
-namespace mapserver
-{
-
-    // See Implementation agg_image_filters.cpp 
-
-    enum image_filter_scale_e
-    {
-        image_filter_shift = 14,                      //----image_filter_shift
-        image_filter_scale = 1 << image_filter_shift, //----image_filter_scale 
-        image_filter_mask  = image_filter_scale - 1   //----image_filter_mask 
-    };
-
-    enum image_subpixel_scale_e
-    {
-        image_subpixel_shift = 8,                         //----image_subpixel_shift
-        image_subpixel_scale = 1 << image_subpixel_shift, //----image_subpixel_scale 
-        image_subpixel_mask  = image_subpixel_scale - 1   //----image_subpixel_mask 
-    };
-
-
-    //-----------------------------------------------------image_filter_lut
-    class image_filter_lut
-    {
-    public:
-        template<class FilterF> void calculate(const FilterF& filter,
-                                               bool normalization=true)
-        {
-            double r = filter.radius();
-            realloc_lut(r);
-            unsigned i;
-            unsigned pivot = diameter() << (image_subpixel_shift - 1);
-            for(i = 0; i < pivot; i++)
-            {
-                double x = double(i) / double(image_subpixel_scale);
-                double y = filter.calc_weight(x);
-                m_weight_array[pivot + i] = 
-                m_weight_array[pivot - i] = (int16)iround(y * image_filter_scale);
-            }
-            unsigned end = (diameter() << image_subpixel_shift) - 1;
-            m_weight_array[0] = m_weight_array[end];
-            if(normalization) 
-            {
-                normalize();
-            }
-        }
-
-        image_filter_lut() : m_radius(0), m_diameter(0), m_start(0) {}
-
-        template<class FilterF> image_filter_lut(const FilterF& filter, 
-                                                 bool normalization=true)
-        {
-            calculate(filter, normalization);
-        }
-
-        double       radius()       const { return m_radius;   }
-        unsigned     diameter()     const { return m_diameter; }
-        int          start()        const { return m_start;    }
-        const int16* weight_array() const { return &m_weight_array[0]; }
-        void         normalize();
-
-    private:
-        void realloc_lut(double radius);
-        image_filter_lut(const image_filter_lut&);
-        const image_filter_lut& operator = (const image_filter_lut&);
-
-        double           m_radius;
-        unsigned         m_diameter;
-        int              m_start;
-        pod_array<int16> m_weight_array;
-    };
-
-
-
-    //--------------------------------------------------------image_filter
-    template<class FilterF> class image_filter : public image_filter_lut
-    {
-    public:
-        image_filter()
-        {
-            calculate(m_filter_function);
-        }
-    private:
-        FilterF m_filter_function;
-    };
-
-
-    //-----------------------------------------------image_filter_bilinear
-    struct image_filter_bilinear
-    {
-        static double radius() { return 1.0; }
-        static double calc_weight(double x)
-        {
-            return 1.0 - x;
-        }
-    };
-
-
-    //-----------------------------------------------image_filter_hanning
-    struct image_filter_hanning
-    {
-        static double radius() { return 1.0; }
-        static double calc_weight(double x)
-        {
-            return 0.5 + 0.5 * cos(pi * x);
-        }
-    };
-
-
-    //-----------------------------------------------image_filter_hamming
-    struct image_filter_hamming
-    {
-        static double radius() { return 1.0; }
-        static double calc_weight(double x)
-        {
-            return 0.54 + 0.46 * cos(pi * x);
-        }
-    };
-
-    //-----------------------------------------------image_filter_hermite
-    struct image_filter_hermite
-    {
-        static double radius() { return 1.0; }
-        static double calc_weight(double x)
-        {
-            return (2.0 * x - 3.0) * x * x + 1.0;
-        }
-    };
-   
-    //------------------------------------------------image_filter_quadric
-    struct image_filter_quadric
-    {
-        static double radius() { return 1.5; }
-        static double calc_weight(double x)
-        {
-            double t;
-            if(x <  0.5) return 0.75 - x * x;
-            if(x <  1.5) {t = x - 1.5; return 0.5 * t * t;}
-            return 0.0;
-        }
-    };
-
-    //------------------------------------------------image_filter_bicubic
-    class image_filter_bicubic
-    {
-        static double pow3(double x)
-        {
-            return (x <= 0.0) ? 0.0 : x * x * x;
-        }
-
-    public:
-        static double radius() { return 2.0; }
-        static double calc_weight(double x)
-        {
-            return
-                (1.0/6.0) * 
-                (pow3(x + 2) - 4 * pow3(x + 1) + 6 * pow3(x) - 4 * pow3(x - 1));
-        }
-    };
-
-    //-------------------------------------------------image_filter_kaiser
-    class image_filter_kaiser
-    {
-        double a;
-        double i0a;
-        double epsilon;
-
-    public:
-        image_filter_kaiser(double b = 6.33) :
-            a(b), epsilon(1e-12)
-        {
-            i0a = 1.0 / bessel_i0(b);
-        }
-
-        static double radius() { return 1.0; }
-        double calc_weight(double x) const
-        {
-            return bessel_i0(a * sqrt(1. - x * x)) * i0a;
-        }
-
-    private:
-        double bessel_i0(double x) const
-        {
-            int i;
-            double sum, y, t;
-
-            sum = 1.;
-            y = x * x / 4.;
-            t = y;
-        
-            for(i = 2; t > epsilon; i++)
-            {
-                sum += t;
-                t *= (double)y / (i * i);
-            }
-            return sum;
-        }
-    };
-
-    //----------------------------------------------image_filter_catrom
-    struct image_filter_catrom
-    {
-        static double radius() { return 2.0; }
-        static double calc_weight(double x)
-        {
-            if(x <  1.0) return 0.5 * (2.0 + x * x * (-5.0 + x * 3.0));
-            if(x <  2.0) return 0.5 * (4.0 + x * (-8.0 + x * (5.0 - x)));
-            return 0.;
-        }
-    };
-
-    //---------------------------------------------image_filter_mitchell
-    class image_filter_mitchell
-    {
-        double p0, p2, p3;
-        double q0, q1, q2, q3;
-
-    public:
-        image_filter_mitchell(double b = 1.0/3.0, double c = 1.0/3.0) :
-            p0((6.0 - 2.0 * b) / 6.0),
-            p2((-18.0 + 12.0 * b + 6.0 * c) / 6.0),
-            p3((12.0 - 9.0 * b - 6.0 * c) / 6.0),
-            q0((8.0 * b + 24.0 * c) / 6.0),
-            q1((-12.0 * b - 48.0 * c) / 6.0),
-            q2((6.0 * b + 30.0 * c) / 6.0),
-            q3((-b - 6.0 * c) / 6.0)
-        {}
-
-        static double radius() { return 2.0; }
-        double calc_weight(double x) const
-        {
-            if(x < 1.0) return p0 + x * x * (p2 + x * p3);
-            if(x < 2.0) return q0 + x * (q1 + x * (q2 + x * q3));
-            return 0.0;
-        }
-    };
-
-
-    //----------------------------------------------image_filter_spline16
-    struct image_filter_spline16
-    {
-        static double radius() { return 2.0; }
-        static double calc_weight(double x)
-        {
-            if(x < 1.0)
-            {
-                return ((x - 9.0/5.0 ) * x - 1.0/5.0 ) * x + 1.0;
-            }
-            return ((-1.0/3.0 * (x-1) + 4.0/5.0) * (x-1) - 7.0/15.0 ) * (x-1);
-        }
-    };
-
-
-    //---------------------------------------------image_filter_spline36
-    struct image_filter_spline36
-    {
-        static double radius() { return 3.0; }
-        static double calc_weight(double x)
-        {
-           if(x < 1.0)
-           {
-              return ((13.0/11.0 * x - 453.0/209.0) * x - 3.0/209.0) * x + 1.0;
-           }
-           if(x < 2.0)
-           {
-              return ((-6.0/11.0 * (x-1) + 270.0/209.0) * (x-1) - 156.0/ 209.0) * (x-1);
-           }
-           return ((1.0/11.0 * (x-2) - 45.0/209.0) * (x-2) +  26.0/209.0) * (x-2);
-        }
-    };
-
-
-    //----------------------------------------------image_filter_gaussian
-    struct image_filter_gaussian
-    {
-        static double radius() { return 2.0; }
-        static double calc_weight(double x) 
-        {
-            return exp(-2.0 * x * x) * sqrt(2.0 / pi);
-        }
-    };
-
-
-    //------------------------------------------------image_filter_bessel
-    struct image_filter_bessel
-    {
-        static double radius() { return 3.2383; } 
-        static double calc_weight(double x)
-        {
-            return (x == 0.0) ? pi / 4.0 : besj(pi * x, 1) / (2.0 * x);
-        }
-    };
-
-
-    //-------------------------------------------------image_filter_sinc
-    class image_filter_sinc
-    {
-    public:
-        image_filter_sinc(double r) : m_radius(r < 2.0 ? 2.0 : r) {}
-        double radius() const { return m_radius; }
-        double calc_weight(double x) const
-        {
-            if(x == 0.0) return 1.0;
-            x *= pi;
-            return sin(x) / x;
-        }
-    private:
-        double m_radius;
-    };
-
-
-    //-----------------------------------------------image_filter_lanczos
-    class image_filter_lanczos
-    {
-    public:
-        image_filter_lanczos(double r) : m_radius(r < 2.0 ? 2.0 : r) {}
-        double radius() const { return m_radius; }
-        double calc_weight(double x) const
-        {
-           if(x == 0.0) return 1.0;
-           if(x > m_radius) return 0.0;
-           x *= pi;
-           double xr = x / m_radius;
-           return (sin(x) / x) * (sin(xr) / xr);
-        }
-    private:
-        double m_radius;
-    };
-
-
-    //----------------------------------------------image_filter_blackman
-    class image_filter_blackman
-    {
-    public:
-        image_filter_blackman(double r) : m_radius(r < 2.0 ? 2.0 : r) {}
-        double radius() const { return m_radius; }
-        double calc_weight(double x) const
-        {
-           if(x == 0.0) return 1.0;
-           if(x > m_radius) return 0.0;
-           x *= pi;
-           double xr = x / m_radius;
-           return (sin(x) / x) * (0.42 + 0.5*cos(xr) + 0.08*cos(2*xr));
-        }
-    private:
-        double m_radius;
-    };
-
-    //------------------------------------------------image_filter_sinc36
-    class image_filter_sinc36 : public image_filter_sinc
-    { public: image_filter_sinc36() : image_filter_sinc(3.0){} };
-
-    //------------------------------------------------image_filter_sinc64
-    class image_filter_sinc64 : public image_filter_sinc
-    { public: image_filter_sinc64() : image_filter_sinc(4.0){} };
-
-    //-----------------------------------------------image_filter_sinc100
-    class image_filter_sinc100 : public image_filter_sinc
-    { public: image_filter_sinc100() : image_filter_sinc(5.0){} };
-
-    //-----------------------------------------------image_filter_sinc144
-    class image_filter_sinc144 : public image_filter_sinc
-    { public: image_filter_sinc144() : image_filter_sinc(6.0){} };
-
-    //-----------------------------------------------image_filter_sinc196
-    class image_filter_sinc196 : public image_filter_sinc
-    { public: image_filter_sinc196() : image_filter_sinc(7.0){} };
-
-    //-----------------------------------------------image_filter_sinc256
-    class image_filter_sinc256 : public image_filter_sinc
-    { public: image_filter_sinc256() : image_filter_sinc(8.0){} };
-
-    //---------------------------------------------image_filter_lanczos36
-    class image_filter_lanczos36 : public image_filter_lanczos
-    { public: image_filter_lanczos36() : image_filter_lanczos(3.0){} };
-
-    //---------------------------------------------image_filter_lanczos64
-    class image_filter_lanczos64 : public image_filter_lanczos
-    { public: image_filter_lanczos64() : image_filter_lanczos(4.0){} };
-
-    //--------------------------------------------image_filter_lanczos100
-    class image_filter_lanczos100 : public image_filter_lanczos
-    { public: image_filter_lanczos100() : image_filter_lanczos(5.0){} };
-
-    //--------------------------------------------image_filter_lanczos144
-    class image_filter_lanczos144 : public image_filter_lanczos
-    { public: image_filter_lanczos144() : image_filter_lanczos(6.0){} };
-
-    //--------------------------------------------image_filter_lanczos196
-    class image_filter_lanczos196 : public image_filter_lanczos
-    { public: image_filter_lanczos196() : image_filter_lanczos(7.0){} };
-
-    //--------------------------------------------image_filter_lanczos256
-    class image_filter_lanczos256 : public image_filter_lanczos
-    { public: image_filter_lanczos256() : image_filter_lanczos(8.0){} };
-
-    //--------------------------------------------image_filter_blackman36
-    class image_filter_blackman36 : public image_filter_blackman
-    { public: image_filter_blackman36() : image_filter_blackman(3.0){} };
-
-    //--------------------------------------------image_filter_blackman64
-    class image_filter_blackman64 : public image_filter_blackman
-    { public: image_filter_blackman64() : image_filter_blackman(4.0){} };
-
-    //-------------------------------------------image_filter_blackman100
-    class image_filter_blackman100 : public image_filter_blackman
-    { public: image_filter_blackman100() : image_filter_blackman(5.0){} };
-
-    //-------------------------------------------image_filter_blackman144
-    class image_filter_blackman144 : public image_filter_blackman
-    { public: image_filter_blackman144() : image_filter_blackman(6.0){} };
-
-    //-------------------------------------------image_filter_blackman196
-    class image_filter_blackman196 : public image_filter_blackman
-    { public: image_filter_blackman196() : image_filter_blackman(7.0){} };
-
-    //-------------------------------------------image_filter_blackman256
-    class image_filter_blackman256 : public image_filter_blackman
-    { public: image_filter_blackman256() : image_filter_blackman(8.0){} };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_line_aa_basics.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_line_aa_basics.h
--- 8.0.1-5/renderers/agg/include/agg_line_aa_basics.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_line_aa_basics.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,189 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_LINE_AA_BASICS_INCLUDED
-#define AGG_LINE_AA_BASICS_INCLUDED
-
-#include <stdlib.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    // See Implementation agg_line_aa_basics.cpp 
-
-    //-------------------------------------------------------------------------
-    enum line_subpixel_scale_e
-    {
-        line_subpixel_shift = 8,                          //----line_subpixel_shift
-        line_subpixel_scale  = 1 << line_subpixel_shift,  //----line_subpixel_scale
-        line_subpixel_mask  = line_subpixel_scale - 1,    //----line_subpixel_mask
-        line_max_coord      = (1 << 28) - 1,              //----line_max_coord
-        line_max_length = 1 << (line_subpixel_shift + 10) //----line_max_length
-    };
-
-    //-------------------------------------------------------------------------
-    enum line_mr_subpixel_scale_e
-    {
-        line_mr_subpixel_shift = 4,                           //----line_mr_subpixel_shift
-        line_mr_subpixel_scale = 1 << line_mr_subpixel_shift, //----line_mr_subpixel_scale 
-        line_mr_subpixel_mask  = line_mr_subpixel_scale - 1   //----line_mr_subpixel_mask 
-    };
-
-    //------------------------------------------------------------------line_mr
-    AGG_INLINE int line_mr(int x) 
-    { 
-        return x >> (line_subpixel_shift - line_mr_subpixel_shift); 
-    }
-
-    //-------------------------------------------------------------------line_hr
-    AGG_INLINE int line_hr(int x) 
-    { 
-        return x << (line_subpixel_shift - line_mr_subpixel_shift); 
-    }
-
-    //---------------------------------------------------------------line_dbl_hr
-    AGG_INLINE int line_dbl_hr(int x) 
-    { 
-        return x << line_subpixel_shift;
-    }
-
-    //---------------------------------------------------------------line_coord
-    struct line_coord
-    {
-        AGG_INLINE static int conv(double x)
-        {
-            return iround(x * line_subpixel_scale);
-        }
-    };
-
-    //-----------------------------------------------------------line_coord_sat
-    struct line_coord_sat
-    {
-        AGG_INLINE static int conv(double x)
-        {
-            return saturation<line_max_coord>::iround(x * line_subpixel_scale);
-        }
-    };
-
-    //==========================================================line_parameters
-    struct line_parameters
-    {
-        //---------------------------------------------------------------------
-        line_parameters() = default;
-        line_parameters(int x1_, int y1_, int x2_, int y2_, int len_) :
-            x1(x1_), y1(y1_), x2(x2_), y2(y2_), 
-            dx(abs(x2_ - x1_)),
-            dy(abs(y2_ - y1_)),
-            sx((x2_ > x1_) ? 1 : -1),
-            sy((y2_ > y1_) ? 1 : -1),
-            vertical(dy >= dx),
-            inc(vertical ? sy : sx),
-            len(len_),
-            octant((sy & 4) | (sx & 2) | int(vertical))
-        {
-        }
-
-        //---------------------------------------------------------------------
-        unsigned orthogonal_quadrant() const { return s_orthogonal_quadrant[octant]; }
-        unsigned diagonal_quadrant()   const { return s_diagonal_quadrant[octant];   }
-
-        //---------------------------------------------------------------------
-        bool same_orthogonal_quadrant(const line_parameters& lp) const
-        {
-            return s_orthogonal_quadrant[octant] == s_orthogonal_quadrant[lp.octant];
-        }
-
-        //---------------------------------------------------------------------
-        bool same_diagonal_quadrant(const line_parameters& lp) const
-        {
-            return s_diagonal_quadrant[octant] == s_diagonal_quadrant[lp.octant];
-        }
-
-        //---------------------------------------------------------------------
-        void divide(line_parameters& lp1, line_parameters& lp2) const
-        {
-            int xmid = (x1 + x2) >> 1;
-            int ymid = (y1 + y2) >> 1;
-            int len2 = len >> 1;
-
-            lp1 = *this;
-            lp2 = *this;
-
-            lp1.x2  = xmid;
-            lp1.y2  = ymid;
-            lp1.len = len2;
-            lp1.dx  = abs(lp1.x2 - lp1.x1);
-            lp1.dy  = abs(lp1.y2 - lp1.y1);
-
-            lp2.x1  = xmid;
-            lp2.y1  = ymid;
-            lp2.len = len2;
-            lp2.dx  = abs(lp2.x2 - lp2.x1);
-            lp2.dy  = abs(lp2.y2 - lp2.y1);
-        }
-        
-        //---------------------------------------------------------------------
-        int x1 = 0, y1 = 0, x2 = 0, y2 = 0, dx = 0, dy = 0, sx = 0, sy = 0;
-        bool vertical = false;
-        int inc = 0;
-        int len = 0;
-        int octant = 0;
-
-        //---------------------------------------------------------------------
-        static const int8u s_orthogonal_quadrant[8];
-        static const int8u s_diagonal_quadrant[8];
-    };
-
-
-
-    // See Implementation agg_line_aa_basics.cpp 
-
-    //----------------------------------------------------------------bisectrix
-    void bisectrix(const line_parameters& l1, 
-                   const line_parameters& l2, 
-                   int* x, int* y);
-
-
-    //-------------------------------------------fix_degenerate_bisectrix_start
-    void inline fix_degenerate_bisectrix_start(const line_parameters& lp, 
-                                               int* x, int* y)
-    {
-        int d = iround((double(*x - lp.x2) * double(lp.y2 - lp.y1) - 
-                        double(*y - lp.y2) * double(lp.x2 - lp.x1)) / lp.len);
-        if(d < line_subpixel_scale/2)
-        {
-            *x = lp.x1 + (lp.y2 - lp.y1);
-            *y = lp.y1 - (lp.x2 - lp.x1);
-        }
-    }
-
-
-    //---------------------------------------------fix_degenerate_bisectrix_end
-    void inline fix_degenerate_bisectrix_end(const line_parameters& lp, 
-                                             int* x, int* y)
-    {
-        int d = iround((double(*x - lp.x2) * double(lp.y2 - lp.y1) - 
-                        double(*y - lp.y2) * double(lp.x2 - lp.x1)) / lp.len);
-        if(d < line_subpixel_scale/2)
-        {
-            *x = lp.x2 + (lp.y2 - lp.y1);
-            *y = lp.y2 - (lp.x2 - lp.x1);
-        }
-    }
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_math.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_math.h
--- 8.0.1-5/renderers/agg/include/agg_math.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_math.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,437 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-// Bessel function (besj) was adapted for use in AGG library by Andy Wilk 
-// Contact: castor.vulgaris@gmail.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_MATH_INCLUDED
-#define AGG_MATH_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------vertex_dist_epsilon
-    // Coinciding points maximal distance (Epsilon)
-    const double vertex_dist_epsilon = 1e-14;
-
-    //-----------------------------------------------------intersection_epsilon
-    // See calc_intersection
-    const double intersection_epsilon = 1.0e-30;
-
-    //------------------------------------------------------------cross_product
-    AGG_INLINE double cross_product(double x1, double y1, 
-                                    double x2, double y2, 
-                                    double x,  double y)
-    {
-        return (x - x2) * (y2 - y1) - (y - y2) * (x2 - x1);
-    }
-
-    //--------------------------------------------------------point_in_triangle
-    AGG_INLINE bool point_in_triangle(double x1, double y1, 
-                                      double x2, double y2, 
-                                      double x3, double y3, 
-                                      double x,  double y)
-    {
-        bool cp1 = cross_product(x1, y1, x2, y2, x, y) < 0.0;
-        bool cp2 = cross_product(x2, y2, x3, y3, x, y) < 0.0;
-        bool cp3 = cross_product(x3, y3, x1, y1, x, y) < 0.0;
-        return cp1 == cp2 && cp2 == cp3 && cp3 == cp1;
-    }
-
-    //-----------------------------------------------------------calc_distance
-    AGG_INLINE double calc_distance(double x1, double y1, double x2, double y2)
-    {
-        double dx = x2-x1;
-        double dy = y2-y1;
-        return sqrt(dx * dx + dy * dy);
-    }
-
-    //--------------------------------------------------------calc_sq_distance
-    AGG_INLINE double calc_sq_distance(double x1, double y1, double x2, double y2)
-    {
-        double dx = x2-x1;
-        double dy = y2-y1;
-        return dx * dx + dy * dy;
-    }
-
-    //------------------------------------------------calc_line_point_distance
-    AGG_INLINE double calc_line_point_distance(double x1, double y1, 
-                                               double x2, double y2, 
-                                               double x,  double y)
-    {
-        double dx = x2-x1;
-        double dy = y2-y1;
-        double d = sqrt(dx * dx + dy * dy);
-        if(d < vertex_dist_epsilon)
-        {
-            return calc_distance(x1, y1, x, y);
-        }
-        return ((x - x2) * dy - (y - y2) * dx) / d;
-    }
-
-    //-------------------------------------------------------calc_line_point_u
-    AGG_INLINE double calc_segment_point_u(double x1, double y1, 
-                                           double x2, double y2, 
-                                           double x,  double y)
-    {
-        double dx = x2 - x1;
-        double dy = y2 - y1;
-
-        if(dx == 0 && dy == 0)
-        {
-	        return 0;
-        }
-
-        double pdx = x - x1;
-        double pdy = y - y1;
-
-        return (pdx * dx + pdy * dy) / (dx * dx + dy * dy);
-    }
-
-    //---------------------------------------------calc_line_point_sq_distance
-    AGG_INLINE double calc_segment_point_sq_distance(double x1, double y1, 
-                                                     double x2, double y2, 
-                                                     double x,  double y,
-                                                     double u)
-    {
-        if(u <= 0)
-        {
-	        return calc_sq_distance(x, y, x1, y1);
-        }
-        else 
-        if(u >= 1)
-        {
-	        return calc_sq_distance(x, y, x2, y2);
-        }
-        return calc_sq_distance(x, y, x1 + u * (x2 - x1), y1 + u * (y2 - y1));
-    }
-
-    //---------------------------------------------calc_line_point_sq_distance
-    AGG_INLINE double calc_segment_point_sq_distance(double x1, double y1, 
-                                                     double x2, double y2, 
-                                                     double x,  double y)
-    {
-        return 
-            calc_segment_point_sq_distance(
-                x1, y1, x2, y2, x, y,
-                calc_segment_point_u(x1, y1, x2, y2, x, y));
-    }
-
-    //-------------------------------------------------------calc_intersection
-    AGG_INLINE bool calc_intersection(double ax, double ay, double bx, double by,
-                                      double cx, double cy, double dx, double dy,
-                                      double* x, double* y)
-    {
-        double num = (ay-cy) * (dx-cx) - (ax-cx) * (dy-cy);
-        double den = (bx-ax) * (dy-cy) - (by-ay) * (dx-cx);
-        if(fabs(den) < intersection_epsilon) return false;
-        double r = num / den;
-        *x = ax + r * (bx-ax);
-        *y = ay + r * (by-ay);
-        return true;
-    }
-
-    //-----------------------------------------------------intersection_exists
-    AGG_INLINE bool intersection_exists(double x1, double y1, double x2, double y2,
-                                        double x3, double y3, double x4, double y4)
-    {
-        // It's less expensive but you can't control the 
-        // boundary conditions: Less or LessEqual
-        double dx1 = x2 - x1;
-        double dy1 = y2 - y1;
-        double dx2 = x4 - x3;
-        double dy2 = y4 - y3;
-        return ((x3 - x2) * dy1 - (y3 - y2) * dx1 < 0.0) != 
-               ((x4 - x2) * dy1 - (y4 - y2) * dx1 < 0.0) &&
-               ((x1 - x4) * dy2 - (y1 - y4) * dx2 < 0.0) !=
-               ((x2 - x4) * dy2 - (y2 - y4) * dx2 < 0.0);
-
-        // It's is more expensive but more flexible 
-        // in terms of boundary conditions.
-        //--------------------
-        //double den  = (x2-x1) * (y4-y3) - (y2-y1) * (x4-x3);
-        //if(fabs(den) < intersection_epsilon) return false;
-        //double nom1 = (x4-x3) * (y1-y3) - (y4-y3) * (x1-x3);
-        //double nom2 = (x2-x1) * (y1-y3) - (y2-y1) * (x1-x3);
-        //double ua = nom1 / den;
-        //double ub = nom2 / den;
-        //return ua >= 0.0 && ua <= 1.0 && ub >= 0.0 && ub <= 1.0;
-    }
-
-    //--------------------------------------------------------calc_orthogonal
-    AGG_INLINE void calc_orthogonal(double thickness,
-                                    double x1, double y1,
-                                    double x2, double y2,
-                                    double* x, double* y)
-    {
-        double dx = x2 - x1;
-        double dy = y2 - y1;
-        double d = sqrt(dx*dx + dy*dy); 
-        *x =  thickness * dy / d;
-        *y = -thickness * dx / d;
-    }
-
-    //--------------------------------------------------------dilate_triangle
-    AGG_INLINE void dilate_triangle(double x1, double y1,
-                                    double x2, double y2,
-                                    double x3, double y3,
-                                    double *x, double* y,
-                                    double d)
-    {
-        double dx1=0.0;
-        double dy1=0.0; 
-        double dx2=0.0;
-        double dy2=0.0; 
-        double dx3=0.0;
-        double dy3=0.0; 
-        double loc = cross_product(x1, y1, x2, y2, x3, y3);
-        if(fabs(loc) > intersection_epsilon)
-        {
-            if(cross_product(x1, y1, x2, y2, x3, y3) > 0.0) 
-            {
-                d = -d;
-            }
-            calc_orthogonal(d, x1, y1, x2, y2, &dx1, &dy1);
-            calc_orthogonal(d, x2, y2, x3, y3, &dx2, &dy2);
-            calc_orthogonal(d, x3, y3, x1, y1, &dx3, &dy3);
-        }
-        *x++ = x1 + dx1;  *y++ = y1 + dy1;
-        *x++ = x2 + dx1;  *y++ = y2 + dy1;
-        *x++ = x2 + dx2;  *y++ = y2 + dy2;
-        *x++ = x3 + dx2;  *y++ = y3 + dy2;
-        *x++ = x3 + dx3;  *y++ = y3 + dy3;
-        *x++ = x1 + dx3;  *y++ = y1 + dy3;
-    }
-
-    //------------------------------------------------------calc_triangle_area
-    AGG_INLINE double calc_triangle_area(double x1, double y1,
-                                         double x2, double y2,
-                                         double x3, double y3)
-    {
-        return (x1*y2 - x2*y1 + x2*y3 - x3*y2 + x3*y1 - x1*y3) * 0.5;
-    }
-
-    //-------------------------------------------------------calc_polygon_area
-    template<class Storage> double calc_polygon_area(const Storage& st)
-    {
-        unsigned i;
-        double sum = 0.0;
-        double x  = st[0].x;
-        double y  = st[0].y;
-        double xs = x;
-        double ys = y;
-
-        for(i = 1; i < st.size(); i++)
-        {
-            const typename Storage::value_type& v = st[i];
-            sum += x * v.y - y * v.x;
-            x = v.x;
-            y = v.y;
-        }
-        return (sum + x * ys - y * xs) * 0.5;
-    }
-
-    //------------------------------------------------------------------------
-    // Tables for fast sqrt
-    extern int16u g_sqrt_table[1024];
-    extern int8   g_elder_bit_table[256];
-
-
-    //---------------------------------------------------------------fast_sqrt
-    //Fast integer Sqrt - really fast: no cycles, divisions or multiplications
-    #if defined(_MSC_VER)
-    #pragma warning(push)
-    #pragma warning(disable : 4035) //Disable warning "no return value"
-    #endif
-    AGG_INLINE unsigned fast_sqrt(unsigned val)
-    {
-    #if defined(_M_IX86) && defined(_MSC_VER) && !defined(AGG_NO_ASM)
-        //For Ix86 family processors this assembler code is used. 
-        //The key command here is bsr - determination the number of the most 
-        //significant bit of the value. For other processors
-        //(and maybe compilers) the pure C "#else" section is used.
-        __asm
-        {
-            mov ebx, val
-            mov edx, 11
-            bsr ecx, ebx
-            sub ecx, 9
-            jle less_than_9_bits
-            shr ecx, 1
-            adc ecx, 0
-            sub edx, ecx
-            shl ecx, 1
-            shr ebx, cl
-    less_than_9_bits:
-            xor eax, eax
-            mov  ax, g_sqrt_table[ebx*2]
-            mov ecx, edx
-            shr eax, cl
-        }
-    #else
-
-        //This code is actually pure C and portable to most 
-        //arcitectures including 64bit ones. 
-        unsigned t = val;
-        int bit=0;
-        unsigned shift = 11;
-
-        //The following piece of code is just an emulation of the
-        //Ix86 assembler command "bsr" (see above). However on old
-        //Intels (like Intel MMX 233MHz) this code is about twice 
-        //faster (sic!) then just one "bsr". On PIII and PIV the
-        //bsr is optimized quite well.
-        bit = t >> 24;
-        if(bit)
-        {
-            bit = g_elder_bit_table[bit] + 24;
-        }
-        else
-        {
-            bit = (t >> 16) & 0xFF;
-            if(bit)
-            {
-                bit = g_elder_bit_table[bit] + 16;
-            }
-            else
-            {
-                bit = (t >> 8) & 0xFF;
-                if(bit)
-                {
-                    bit = g_elder_bit_table[bit] + 8;
-                }
-                else
-                {
-                    bit = g_elder_bit_table[t];
-                }
-            }
-        }
-
-        //This code calculates the sqrt.
-        bit -= 9;
-        if(bit > 0)
-        {
-            bit = (bit >> 1) + (bit & 1);
-            shift -= bit;
-            val >>= (bit << 1);
-        }
-        return g_sqrt_table[val] >> shift;
-    #endif
-    }
-    #if defined(_MSC_VER)
-    #pragma warning(pop)
-    #endif
-
-
-
-
-    //--------------------------------------------------------------------besj
-    // Function BESJ calculates Bessel function of first kind of order n
-    // Arguments:
-    //     n - an integer (>=0), the order
-    //     x - value at which the Bessel function is required
-    //--------------------
-    // C++ Mathematical Library
-    // Convereted from equivalent FORTRAN library
-    // Converetd by Gareth Walker for use by course 392 computational project
-    // All functions tested and yield the same results as the corresponding
-    // FORTRAN versions.
-    //
-    // If you have any problems using these functions please report them to
-    // M.Muldoon@UMIST.ac.uk
-    //
-    // Documentation available on the web
-    // http://www.ma.umist.ac.uk/mrm/Teaching/392/libs/392.html
-    // Version 1.0   8/98
-    // 29 October, 1999
-    //--------------------
-    // Adapted for use in AGG library by Andy Wilk (castor.vulgaris@gmail.com)
-    //------------------------------------------------------------------------
-    inline double besj(double x, int n)
-    {
-        if(n < 0)
-        {
-            return 0;
-        }
-        double d = 1E-6;
-        double b = 0;
-        if(fabs(x) <= d) 
-        {
-            if(n != 0) return 0;
-            return 1;
-        }
-        double b1 = 0; // b1 is the value from the previous iteration
-        // Set up a starting order for recurrence
-        int m1 = (int)fabs(x) + 6;
-        if(fabs(x) > 5) 
-        {
-            m1 = (int)(fabs(1.4 * x + 60 / x));
-        }
-        int m2 = (int)(n + 2 + fabs(x) / 4);
-        if (m1 > m2) 
-        {
-            m2 = m1;
-        }
-    
-        // Apply recurrence down from curent max order
-        for(;;) 
-        {
-            double c3 = 0;
-            double c2 = 1E-30;
-            double c4 = 0;
-            int m8 = 1;
-            if (m2 / 2 * 2 == m2) 
-            {
-                m8 = -1;
-            }
-            int imax = m2 - 2;
-            for (int i = 1; i <= imax; i++) 
-            {
-                double c6 = 2 * (m2 - i) * c2 / x - c3;
-                c3 = c2;
-                c2 = c6;
-                if(m2 - i - 1 == n)
-                {
-                    b = c6;
-                }
-                m8 = -1 * m8;
-                if (m8 > 0)
-                {
-                    c4 = c4 + 2 * c6;
-                }
-            }
-            double c6 = 2 * c2 / x - c3;
-            if(n == 0)
-            {
-                b = c6;
-            }
-            c4 += c6;
-            b /= c4;
-            if(fabs(b - b1) < d)
-            {
-                return b;
-            }
-            b1 = b;
-            m2 += 3;
-        }
-    }
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_math_stroke.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_math_stroke.h
--- 8.0.1-5/renderers/agg/include/agg_math_stroke.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_math_stroke.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,526 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Stroke math
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_STROKE_MATH_INCLUDED
-#define AGG_STROKE_MATH_INCLUDED
-
-#include "agg_math.h"
-#include "agg_vertex_sequence.h"
-
-namespace mapserver
-{
-    //-------------------------------------------------------------line_cap_e
-    enum line_cap_e
-    {
-        butt_cap,
-        square_cap,
-        round_cap
-    };
-
-    //------------------------------------------------------------line_join_e
-    enum line_join_e
-    {
-        miter_join         = 0,
-        miter_join_revert  = 1,
-        round_join         = 2,
-        bevel_join         = 3,
-        miter_join_round   = 4
-    };
-
-
-    //-----------------------------------------------------------inner_join_e
-    enum inner_join_e
-    {
-        inner_bevel,
-        inner_miter,
-        inner_jag,
-        inner_round
-    };
-
-    //------------------------------------------------------------math_stroke
-    template<class VertexConsumer> class math_stroke
-    {
-    public:
-        typedef typename VertexConsumer::value_type coord_type;
-
-        math_stroke();
-
-        void line_cap(line_cap_e lc)     { m_line_cap = lc; }
-        void line_join(line_join_e lj)   { m_line_join = lj; }
-        void inner_join(inner_join_e ij) { m_inner_join = ij; }
-
-        line_cap_e   line_cap()   const { return m_line_cap; }
-        line_join_e  line_join()  const { return m_line_join; }
-        inner_join_e inner_join() const { return m_inner_join; }
-
-        void width(double w);
-        void miter_limit(double ml) { m_miter_limit = ml; }
-        void miter_limit_theta(double t);
-        void inner_miter_limit(double ml) { m_inner_miter_limit = ml; }
-        void approximation_scale(double as) { m_approx_scale = as; }
-
-        double width() const { return m_width * 2.0; }
-        double miter_limit() const { return m_miter_limit; }
-        double inner_miter_limit() const { return m_inner_miter_limit; }
-        double approximation_scale() const { return m_approx_scale; }
-
-        void calc_cap(VertexConsumer& vc,
-                      const vertex_dist& v0, 
-                      const vertex_dist& v1, 
-                      double len);
-
-        void calc_join(VertexConsumer& vc,
-                       const vertex_dist& v0, 
-                       const vertex_dist& v1, 
-                       const vertex_dist& v2,
-                       double len1, 
-                       double len2);
-
-    private:
-        AGG_INLINE void add_vertex(VertexConsumer& vc, double x, double y)
-        {
-            vc.add(coord_type(x, y));
-        }
-
-        void calc_arc(VertexConsumer& vc,
-                      double x,   double y, 
-                      double dx1, double dy1, 
-                      double dx2, double dy2);
-
-        void calc_miter(VertexConsumer& vc,
-                        const vertex_dist& v0, 
-                        const vertex_dist& v1, 
-                        const vertex_dist& v2,
-                        double dx1, double dy1, 
-                        double dx2, double dy2,
-                        line_join_e lj,
-                        double mlimit,
-                        double dbevel);
-
-        double       m_width;
-        double       m_width_abs;
-        double       m_width_eps;
-        int          m_width_sign;
-        double       m_miter_limit;
-        double       m_inner_miter_limit;
-        double       m_approx_scale;
-        line_cap_e   m_line_cap;
-        line_join_e  m_line_join;
-        inner_join_e m_inner_join;
-    };
-
-    //-----------------------------------------------------------------------
-    template<class VC> math_stroke<VC>::math_stroke() :
-        m_width(0.5),
-        m_width_abs(0.5),
-        m_width_eps(0.5/1024.0),
-        m_width_sign(1),
-        m_miter_limit(4.0),
-        m_inner_miter_limit(1.01),
-        m_approx_scale(1.0),
-        m_line_cap(butt_cap),
-        m_line_join(miter_join),
-        m_inner_join(inner_miter)
-    {
-    }
-
-    //-----------------------------------------------------------------------
-    template<class VC> void math_stroke<VC>::width(double w)
-    { 
-        m_width = w * 0.5; 
-        if(m_width < 0)
-        {
-            m_width_abs  = -m_width;
-            m_width_sign = -1;
-        }
-        else
-        {
-            m_width_abs  = m_width;
-            m_width_sign = 1;
-        }
-        m_width_eps = m_width / 1024.0;
-    }
-
-    //-----------------------------------------------------------------------
-    template<class VC> void math_stroke<VC>::miter_limit_theta(double t)
-    { 
-        m_miter_limit = 1.0 / sin(t * 0.5) ;
-    }
-
-    //-----------------------------------------------------------------------
-    template<class VC> 
-    void math_stroke<VC>::calc_arc(VC& vc,
-                                   double x,   double y, 
-                                   double dx1, double dy1, 
-                                   double dx2, double dy2)
-    {
-        double a1 = atan2(dy1 * m_width_sign, dx1 * m_width_sign);
-        double a2 = atan2(dy2 * m_width_sign, dx2 * m_width_sign);
-        double da = a1 - a2;
-        int i, n;
-
-        da = acos(m_width_abs / (m_width_abs + 0.125 / m_approx_scale)) * 2;
-
-        add_vertex(vc, x + dx1, y + dy1);
-        if(m_width_sign > 0)
-        {
-            if(a1 > a2) a2 += 2 * pi;
-            n = int((a2 - a1) / da);
-            da = (a2 - a1) / (n + 1);
-            a1 += da;
-            for(i = 0; i < n; i++)
-            {
-                add_vertex(vc, x + cos(a1) * m_width, y + sin(a1) * m_width);
-                a1 += da;
-            }
-        }
-        else
-        {
-            if(a1 < a2) a2 -= 2 * pi;
-            n = int((a1 - a2) / da);
-            da = (a1 - a2) / (n + 1);
-            a1 -= da;
-            for(i = 0; i < n; i++)
-            {
-                add_vertex(vc, x + cos(a1) * m_width, y + sin(a1) * m_width);
-                a1 -= da;
-            }
-        }
-        add_vertex(vc, x + dx2, y + dy2);
-    }
-
-    //-----------------------------------------------------------------------
-    template<class VC> 
-    void math_stroke<VC>::calc_miter(VC& vc,
-                                     const vertex_dist& v0, 
-                                     const vertex_dist& v1, 
-                                     const vertex_dist& v2,
-                                     double dx1, double dy1, 
-                                     double dx2, double dy2,
-                                     line_join_e lj,
-                                     double mlimit,
-                                     double dbevel)
-    {
-        double xi  = v1.x;
-        double yi  = v1.y;
-        double di  = 1;
-        double lim = m_width_abs * mlimit;
-        bool miter_limit_exceeded = true; // Assume the worst
-        bool intersection_failed  = true; // Assume the worst
-
-        if(calc_intersection(v0.x + dx1, v0.y - dy1,
-                             v1.x + dx1, v1.y - dy1,
-                             v1.x + dx2, v1.y - dy2,
-                             v2.x + dx2, v2.y - dy2,
-                             &xi, &yi))
-        {
-            // Calculation of the intersection succeeded
-            //---------------------
-            di = calc_distance(v1.x, v1.y, xi, yi);
-            if(di <= lim)
-            {
-                // Inside the miter limit
-                //---------------------
-                add_vertex(vc, xi, yi);
-                miter_limit_exceeded = false;
-            }
-            intersection_failed = false;
-        }
-        else
-        {
-            // Calculation of the intersection failed, most probably
-            // the three points lie one straight line. 
-            // First check if v0 and v2 lie on the opposite sides of vector: 
-            // (v1.x, v1.y) -> (v1.x+dx1, v1.y-dy1), that is, the perpendicular
-            // to the line determined by vertices v0 and v1.
-            // This condition determines whether the next line segments continues
-            // the previous one or goes back.
-            //----------------
-            double x2 = v1.x + dx1;
-            double y2 = v1.y - dy1;
-            if((cross_product(v0.x, v0.y, v1.x, v1.y, x2, y2) < 0.0) == 
-               (cross_product(v1.x, v1.y, v2.x, v2.y, x2, y2) < 0.0))
-            {
-                // This case means that the next segment continues 
-                // the previous one (straight line)
-                //-----------------
-                add_vertex(vc, v1.x + dx1, v1.y - dy1);
-                miter_limit_exceeded = false;
-            }
-        }
-
-        if(miter_limit_exceeded)
-        {
-            // Miter limit exceeded
-            //------------------------
-            switch(lj)
-            {
-            case miter_join_revert:
-                // For the compatibility with SVG, PDF, etc, 
-                // we use a simple bevel join instead of
-                // "smart" bevel
-                //-------------------
-                add_vertex(vc, v1.x + dx1, v1.y - dy1);
-                add_vertex(vc, v1.x + dx2, v1.y - dy2);
-                break;
-
-            case miter_join_round:
-                calc_arc(vc, v1.x, v1.y, dx1, -dy1, dx2, -dy2);
-                break;
-
-            default:
-                // If no miter-revert, calculate new dx1, dy1, dx2, dy2
-                //----------------
-                if(intersection_failed)
-                {
-                    mlimit *= m_width_sign;
-                    add_vertex(vc, v1.x + dx1 + dy1 * mlimit, 
-                                   v1.y - dy1 + dx1 * mlimit);
-                    add_vertex(vc, v1.x + dx2 - dy2 * mlimit, 
-                                   v1.y - dy2 - dx2 * mlimit);
-                }
-                else
-                {
-                    double x1 = v1.x + dx1;
-                    double y1 = v1.y - dy1;
-                    double x2 = v1.x + dx2;
-                    double y2 = v1.y - dy2;
-                    di = (lim - dbevel) / (di - dbevel);
-                    add_vertex(vc, x1 + (xi - x1) * di, 
-                                   y1 + (yi - y1) * di);
-                    add_vertex(vc, x2 + (xi - x2) * di, 
-                                   y2 + (yi - y2) * di);
-                }
-                break;
-            }
-        }
-    }
-
-    //--------------------------------------------------------stroke_calc_cap
-    template<class VC> 
-    void math_stroke<VC>::calc_cap(VC& vc,
-                                   const vertex_dist& v0, 
-                                   const vertex_dist& v1, 
-                                   double len)
-    {
-        vc.remove_all();
-
-        double dx1 = (v1.y - v0.y) / len;
-        double dy1 = (v1.x - v0.x) / len;
-        double dx2 = 0;
-        double dy2 = 0;
-
-        dx1 *= m_width;
-        dy1 *= m_width;
-
-        if(m_line_cap != round_cap)
-        {
-            if(m_line_cap == square_cap)
-            {
-                dx2 = dy1 * m_width_sign;
-                dy2 = dx1 * m_width_sign;
-            }
-            add_vertex(vc, v0.x - dx1 - dx2, v0.y + dy1 - dy2);
-            add_vertex(vc, v0.x + dx1 - dx2, v0.y - dy1 - dy2);
-        }
-        else
-        {
-            double da = acos(m_width_abs / (m_width_abs + 0.125 / m_approx_scale)) * 2;
-            double a1;
-            int i;
-            int n = int(pi / da);
-
-            da = pi / (n + 1);
-            add_vertex(vc, v0.x - dx1, v0.y + dy1);
-            if(m_width_sign > 0)
-            {
-                a1 = atan2(dy1, -dx1);
-                a1 += da;
-                for(i = 0; i < n; i++)
-                {
-                    add_vertex(vc, v0.x + cos(a1) * m_width, 
-                                   v0.y + sin(a1) * m_width);
-                    a1 += da;
-                }
-            }
-            else
-            {
-                a1 = atan2(-dy1, dx1);
-                a1 -= da;
-                for(i = 0; i < n; i++)
-                {
-                    add_vertex(vc, v0.x + cos(a1) * m_width, 
-                                   v0.y + sin(a1) * m_width);
-                    a1 -= da;
-                }
-            }
-            add_vertex(vc, v0.x + dx1, v0.y - dy1);
-        }
-    }
-
-    //-----------------------------------------------------------------------
-    template<class VC> 
-    void math_stroke<VC>::calc_join(VC& vc,
-                                    const vertex_dist& v0, 
-                                    const vertex_dist& v1, 
-                                    const vertex_dist& v2,
-                                    double len1, 
-                                    double len2)
-    {
-        double dx1 = m_width * (v1.y - v0.y) / len1;
-        double dy1 = m_width * (v1.x - v0.x) / len1;
-        double dx2 = m_width * (v2.y - v1.y) / len2;
-        double dy2 = m_width * (v2.x - v1.x) / len2;
-
-        vc.remove_all();
-
-        double cp = cross_product(v0.x, v0.y, v1.x, v1.y, v2.x, v2.y);
-        if(cp != 0 && (cp > 0) == (m_width > 0))
-        {
-            // Inner join
-            //---------------
-            double limit = ((len1 < len2) ? len1 : len2) / m_width_abs;
-            if(limit < m_inner_miter_limit)
-            {
-                limit = m_inner_miter_limit;
-            }
-
-            switch(m_inner_join)
-            {
-            default: // inner_bevel
-                add_vertex(vc, v1.x + dx1, v1.y - dy1);
-                add_vertex(vc, v1.x + dx2, v1.y - dy2);
-                break;
-
-            case inner_miter:
-                calc_miter(vc,
-                           v0, v1, v2, dx1, dy1, dx2, dy2, 
-                           miter_join_revert, 
-                           limit, 0);
-                break;
-
-            case inner_jag:
-            case inner_round:
-                cp = (dx1-dx2) * (dx1-dx2) + (dy1-dy2) * (dy1-dy2);
-                if(cp < len1 * len1 && cp < len2 * len2)
-                {
-                    calc_miter(vc,
-                               v0, v1, v2, dx1, dy1, dx2, dy2, 
-                               miter_join_revert, 
-                               limit, 0);
-                }
-                else
-                {
-                    if(m_inner_join == inner_jag)
-                    {
-                        add_vertex(vc, v1.x + dx1, v1.y - dy1);
-                        add_vertex(vc, v1.x,       v1.y      );
-                        add_vertex(vc, v1.x + dx2, v1.y - dy2);
-                    }
-                    else
-                    {
-                        add_vertex(vc, v1.x + dx1, v1.y - dy1);
-                        add_vertex(vc, v1.x,       v1.y      );
-                        calc_arc(vc, v1.x, v1.y, dx2, -dy2, dx1, -dy1);
-                        add_vertex(vc, v1.x,       v1.y      );
-                        add_vertex(vc, v1.x + dx2, v1.y - dy2);
-                    }
-                }
-                break;
-            }
-        }
-        else
-        {
-            // Outer join
-            //---------------
-
-            // Calculate the distance between v1 and 
-            // the central point of the bevel line segment
-            //---------------
-            double dx = (dx1 + dx2) / 2;
-            double dy = (dy1 + dy2) / 2;
-            double dbevel = sqrt(dx * dx + dy * dy);
-
-            if(m_line_join == round_join || m_line_join == bevel_join)
-            {
-                // This is an optimization that reduces the number of points 
-                // in cases of almost collinear segments. If there's no
-                // visible difference between bevel and miter joins we'd rather
-                // use miter join because it adds only one point instead of two. 
-                //
-                // Here we calculate the middle point between the bevel points 
-                // and then, the distance between v1 and this middle point. 
-                // At outer joins this distance always less than stroke width, 
-                // because it's actually the height of an isosceles triangle of
-                // v1 and its two bevel points. If the difference between this
-                // width and this value is small (no visible bevel) we can 
-                // add just one point. 
-                //
-                // The constant in the expression makes the result approximately 
-                // the same as in round joins and caps. You can safely comment 
-                // out this entire "if".
-                //-------------------
-                if(m_approx_scale * (m_width_abs - dbevel) < m_width_eps)
-                {
-                    if(calc_intersection(v0.x + dx1, v0.y - dy1,
-                                         v1.x + dx1, v1.y - dy1,
-                                         v1.x + dx2, v1.y - dy2,
-                                         v2.x + dx2, v2.y - dy2,
-                                         &dx, &dy))
-                    {
-                        add_vertex(vc, dx, dy);
-                    }
-                    else
-                    {
-                        add_vertex(vc, v1.x + dx1, v1.y - dy1);
-                    }
-                    return;
-                }
-            }
-
-            switch(m_line_join)
-            {
-            case miter_join:
-            case miter_join_revert:
-            case miter_join_round:
-                calc_miter(vc, 
-                           v0, v1, v2, dx1, dy1, dx2, dy2, 
-                           m_line_join, 
-                           m_miter_limit,
-                           dbevel);
-                break;
-
-            case round_join:
-                calc_arc(vc, v1.x, v1.y, dx1, -dy1, dx2, -dy2);
-                break;
-
-            default: // Bevel join
-                add_vertex(vc, v1.x + dx1, v1.y - dy1);
-                add_vertex(vc, v1.x + dx2, v1.y - dy2);
-                break;
-            }
-        }
-    }
-
-
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_path_length.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_path_length.h
--- 8.0.1-5/renderers/agg/include/agg_path_length.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_path_length.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,65 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_PATH_LENGTH_INCLUDED
-#define AGG_PATH_LENGTH_INCLUDED
-
-#include "agg_math.h"
-
-namespace mapserver
-{
-    template<class VertexSource> 
-    double path_length(VertexSource& vs, unsigned path_id = 0)
-    {
-        double len = 0.0;
-        double start_x = 0.0;
-        double start_y = 0.0;
-        double x1 = 0.0;
-        double y1 = 0.0;
-        double x2 = 0.0;
-        double y2 = 0.0;
-        bool first = true;
-
-        unsigned cmd;
-        vs.rewind(path_id);
-        while(!is_stop(cmd = vs.vertex(&x2, &y2)))
-        {
-            if(is_vertex(cmd))
-            {
-                if(first || is_move_to(cmd))
-                {
-                    start_x = x2;
-                    start_y = y2;
-                }
-                else
-                {
-                    len += calc_distance(x1, y1, x2, y2);
-                }
-                x1 = x2;
-                y1 = y2;
-                first = false;
-            }
-            else
-            {
-                if(is_close(cmd) && !first)
-                {
-                    len += calc_distance(x1, y1, start_x, start_y);
-                }
-            }
-        }
-        return len;
-    }
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_path_storage.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_path_storage.h
--- 8.0.1-5/renderers/agg/include/agg_path_storage.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_path_storage.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1551 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PATH_STORAGE_INCLUDED
-#define AGG_PATH_STORAGE_INCLUDED
-
-#include <cassert>
-#include <string.h>
-#include <math.h>
-#include "agg_math.h"
-#include "agg_array.h"
-#include "agg_bezier_arc.h"
-
-namespace mapserver
-{
-
-
-    //----------------------------------------------------vertex_block_storage
-    template<class T, unsigned BlockShift=8, unsigned BlockPool=256>
-    class vertex_block_storage
-    {
-    public:
-        // Allocation parameters
-        enum block_scale_e
-        {
-            block_shift = BlockShift,
-            block_size  = 1 << block_shift,
-            block_mask  = block_size - 1,
-            block_pool  = BlockPool
-        };
-
-        typedef T value_type;
-        typedef vertex_block_storage<T, BlockShift, BlockPool> self_type;
-
-        ~vertex_block_storage();
-        vertex_block_storage();
-        vertex_block_storage(const self_type& v);
-        const self_type& operator = (const self_type& ps);
-
-        void remove_all();
-        void free_all();
-
-        void add_vertex(double x, double y, unsigned cmd);
-        void modify_vertex(unsigned idx, double x, double y);
-        void modify_vertex(unsigned idx, double x, double y, unsigned cmd);
-        void modify_command(unsigned idx, unsigned cmd);
-        void swap_vertices(unsigned v1, unsigned v2);
-
-        unsigned last_command() const;
-        unsigned last_vertex(double* x, double* y) const;
-        unsigned prev_vertex(double* x, double* y) const;
-
-        double last_x() const;
-        double last_y() const;
-
-        unsigned total_vertices() const;
-        unsigned vertex(unsigned idx, double* x, double* y) const;
-        unsigned command(unsigned idx) const;
-
-    private:
-        void   allocate_block(unsigned nb);
-        int8u* storage_ptrs(T** xy_ptr);
-
-    private:
-        unsigned m_total_vertices;
-        unsigned m_total_blocks;
-        unsigned m_max_blocks;
-        T**      m_coord_blocks;
-        int8u**  m_cmd_blocks;
-    };
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    void vertex_block_storage<T,S,P>::free_all()
-    {
-        if(m_total_blocks)
-        {
-            T** coord_blk = m_coord_blocks + m_total_blocks - 1;
-            while(m_total_blocks--)
-            {
-                pod_allocator<T>::deallocate(
-                    *coord_blk,
-                    block_size * 2 + 
-                    block_size / (sizeof(T) / sizeof(unsigned char)));
-                --coord_blk;
-            }
-            pod_allocator<T*>::deallocate(m_coord_blocks, m_max_blocks * 2);
-            m_total_blocks   = 0;
-            m_max_blocks     = 0;
-            m_coord_blocks   = 0;
-            m_cmd_blocks     = 0;
-            m_total_vertices = 0;
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    vertex_block_storage<T,S,P>::~vertex_block_storage()
-    {
-        free_all();
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    vertex_block_storage<T,S,P>::vertex_block_storage() :
-        m_total_vertices(0),
-        m_total_blocks(0),
-        m_max_blocks(0),
-        m_coord_blocks(0),
-        m_cmd_blocks(0)
-    {
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    vertex_block_storage<T,S,P>::vertex_block_storage(const vertex_block_storage<T,S,P>& v) :
-        m_total_vertices(0),
-        m_total_blocks(0),
-        m_max_blocks(0),
-        m_coord_blocks(0),
-        m_cmd_blocks(0)
-    {
-        *this = v;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    const vertex_block_storage<T,S,P>& 
-    vertex_block_storage<T,S,P>::operator = (const vertex_block_storage<T,S,P>& v)
-    {
-        remove_all();
-        unsigned i;
-        for(i = 0; i < v.total_vertices(); i++)
-        {
-            double x, y;
-            unsigned cmd = v.vertex(i, &x, &y);
-            add_vertex(x, y, cmd);
-        }
-	    return *this;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline void vertex_block_storage<T,S,P>::remove_all()
-    {
-        m_total_vertices = 0;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline void vertex_block_storage<T,S,P>::add_vertex(double x, double y, 
-                                                        unsigned cmd)
-    {
-        T* coord_ptr = 0;
-        *storage_ptrs(&coord_ptr) = (int8u)cmd;
-        coord_ptr[0] = T(x);
-        coord_ptr[1] = T(y);
-        m_total_vertices++;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline void vertex_block_storage<T,S,P>::modify_vertex(unsigned idx, 
-                                                           double x, double y)
-    {
-        T* pv = m_coord_blocks[idx >> block_shift] + ((idx & block_mask) << 1);
-        pv[0] = T(x);
-        pv[1] = T(y);
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline void vertex_block_storage<T,S,P>::modify_vertex(unsigned idx, 
-                                                           double x, double y, 
-                                                           unsigned cmd)
-    {
-        unsigned block = idx >> block_shift;
-        unsigned offset = idx & block_mask;
-        T* pv = m_coord_blocks[block] + (offset << 1);
-        pv[0] = T(x);
-        pv[1] = T(y);
-        m_cmd_blocks[block][offset] = (int8u)cmd;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline void vertex_block_storage<T,S,P>::modify_command(unsigned idx, 
-                                                            unsigned cmd)
-    {
-        m_cmd_blocks[idx >> block_shift][idx & block_mask] = (int8u)cmd;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline void vertex_block_storage<T,S,P>::swap_vertices(unsigned v1, unsigned v2)
-    {
-        unsigned b1 = v1 >> block_shift;
-        unsigned b2 = v2 >> block_shift;
-        unsigned o1 = v1 & block_mask;
-        unsigned o2 = v2 & block_mask;
-        T* pv1 = m_coord_blocks[b1] + (o1 << 1);
-        T* pv2 = m_coord_blocks[b2] + (o2 << 1);
-        T  val;
-        val = pv1[0]; pv1[0] = pv2[0]; pv2[0] = val;
-        val = pv1[1]; pv1[1] = pv2[1]; pv2[1] = val;
-        int8u cmd = m_cmd_blocks[b1][o1];
-        m_cmd_blocks[b1][o1] = m_cmd_blocks[b2][o2];
-        m_cmd_blocks[b2][o2] = cmd;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline unsigned vertex_block_storage<T,S,P>::last_command() const
-    {
-        if(m_total_vertices) return command(m_total_vertices - 1);
-        return path_cmd_stop;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline unsigned vertex_block_storage<T,S,P>::last_vertex(double* x, double* y) const
-    {
-        if(m_total_vertices) return vertex(m_total_vertices - 1, x, y);
-        return path_cmd_stop;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline unsigned vertex_block_storage<T,S,P>::prev_vertex(double* x, double* y) const
-    {
-        if(m_total_vertices > 1) return vertex(m_total_vertices - 2, x, y);
-        return path_cmd_stop;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline double vertex_block_storage<T,S,P>::last_x() const
-    {
-        if(m_total_vertices)
-        {
-            unsigned idx = m_total_vertices - 1;
-            return m_coord_blocks[idx >> block_shift][(idx & block_mask) << 1];
-        }
-        return 0.0;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline double vertex_block_storage<T,S,P>::last_y() const
-    {
-        if(m_total_vertices)
-        {
-            unsigned idx = m_total_vertices - 1;
-            return m_coord_blocks[idx >> block_shift][((idx & block_mask) << 1) + 1];
-        }
-        return 0.0;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline unsigned vertex_block_storage<T,S,P>::total_vertices() const
-    {
-        return m_total_vertices;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline unsigned vertex_block_storage<T,S,P>::vertex(unsigned idx, 
-                                                        double* x, double* y) const
-    {
-        unsigned nb = idx >> block_shift;
-        const T* pv = m_coord_blocks[nb] + ((idx & block_mask) << 1);
-        *x = pv[0];
-        *y = pv[1];
-        return m_cmd_blocks[nb][idx & block_mask];
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    inline unsigned vertex_block_storage<T,S,P>::command(unsigned idx) const
-    {
-        return m_cmd_blocks[idx >> block_shift][idx & block_mask];
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    void vertex_block_storage<T,S,P>::allocate_block(unsigned nb)
-    {
-        if(nb >= m_max_blocks) 
-        {
-            T** new_coords = 
-                pod_allocator<T*>::allocate((m_max_blocks + block_pool) * 2);
-
-            unsigned char** new_cmds = 
-                (unsigned char**)(new_coords + m_max_blocks + block_pool);
-
-            if(m_coord_blocks)
-            {
-                memcpy(new_coords, 
-                       m_coord_blocks, 
-                       m_max_blocks * sizeof(T*));
-
-                assert(m_cmd_blocks);
-                memcpy(new_cmds, 
-                       m_cmd_blocks, 
-                       m_max_blocks * sizeof(unsigned char*));
-
-                pod_allocator<T*>::deallocate(m_coord_blocks, m_max_blocks * 2);
-            }
-            m_coord_blocks = new_coords;
-            m_cmd_blocks   = new_cmds;
-            m_max_blocks  += block_pool;
-        }
-        assert(m_coord_blocks);
-        m_coord_blocks[nb] = 
-            pod_allocator<T>::allocate(block_size * 2 + 
-                   block_size / (sizeof(T) / sizeof(unsigned char)));
-
-        assert(m_cmd_blocks);
-        m_cmd_blocks[nb]  = 
-            (unsigned char*)(m_coord_blocks[nb] + block_size * 2);
-
-        m_total_blocks++;
-    }
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S, unsigned P>
-    int8u* vertex_block_storage<T,S,P>::storage_ptrs(T** xy_ptr)
-    {
-        unsigned nb = m_total_vertices >> block_shift;
-        if(nb >= m_total_blocks)
-        {
-            allocate_block(nb);
-        }
-        assert(m_coord_blocks);
-        assert(m_cmd_blocks);
-        *xy_ptr = m_coord_blocks[nb] + ((m_total_vertices & block_mask) << 1);
-        return m_cmd_blocks[nb] + (m_total_vertices & block_mask);
-    }
-
-
-
-
-    //-----------------------------------------------------poly_plain_adaptor
-    template<class T> class poly_plain_adaptor
-    {
-    public:
-        typedef T value_type;
-
-        poly_plain_adaptor() : 
-            m_data(0), 
-            m_ptr(0),
-            m_end(0),
-            m_closed(false),
-            m_stop(false)
-        {}
-
-        poly_plain_adaptor(const T* data, unsigned num_points, bool closed) :
-            m_data(data), 
-            m_ptr(data),
-            m_end(data + num_points * 2),
-            m_closed(closed),
-            m_stop(false)
-        {}
-
-        void init(const T* data, unsigned num_points, bool closed)
-        {
-            m_data = data;
-            m_ptr = data;
-            m_end = data + num_points * 2;
-            m_closed = closed;
-            m_stop = false;
-        }
-
-        void rewind(unsigned)
-        {
-            m_ptr = m_data;
-            m_stop = false;
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_ptr < m_end)
-            {
-                bool first = m_ptr == m_data;
-                *x = *m_ptr++;
-                *y = *m_ptr++;
-                return first ? path_cmd_move_to : path_cmd_line_to;
-            }
-            *x = *y = 0.0;
-            if(m_closed && !m_stop)
-            {
-                m_stop = true;
-                return path_cmd_end_poly | path_flags_close;
-            }
-            return path_cmd_stop;
-        }
-
-    private:
-        const T* m_data;
-        const T* m_ptr;
-        const T* m_end;
-        bool     m_closed;
-        bool     m_stop;
-    };
-
-
-
-
-
-    //-------------------------------------------------poly_container_adaptor
-    template<class Container> class poly_container_adaptor
-    {
-    public:
-        typedef typename Container::value_type vertex_type;
-
-        poly_container_adaptor() : 
-            m_container(0), 
-            m_index(0),
-            m_closed(false),
-            m_stop(false)
-        {}
-
-        poly_container_adaptor(const Container& data, bool closed) :
-            m_container(&data), 
-            m_index(0),
-            m_closed(closed),
-            m_stop(false)
-        {}
-
-        void init(const Container& data, bool closed)
-        {
-            m_container = &data;
-            m_index = 0;
-            m_closed = closed;
-            m_stop = false;
-        }
-
-        void rewind(unsigned)
-        {
-            m_index = 0;
-            m_stop = false;
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_index < m_container->size())
-            {
-                bool first = m_index == 0;
-                const vertex_type& v = (*m_container)[m_index++];
-                *x = v.x;
-                *y = v.y;
-                return first ? path_cmd_move_to : path_cmd_line_to;
-            }
-            *x = *y = 0.0;
-            if(m_closed && !m_stop)
-            {
-                m_stop = true;
-                return path_cmd_end_poly | path_flags_close;
-            }
-            return path_cmd_stop;
-        }
-
-    private:
-        const Container* m_container;
-        unsigned m_index;
-        bool     m_closed;
-        bool     m_stop;
-    };
-
-
-
-    //-----------------------------------------poly_container_reverse_adaptor
-    template<class Container> class poly_container_reverse_adaptor
-    {
-    public:
-        typedef typename Container::value_type vertex_type;
-
-        poly_container_reverse_adaptor() : 
-            m_container(0), 
-            m_index(-1),
-            m_closed(false),
-            m_stop(false)
-        {}
-
-        poly_container_reverse_adaptor(const Container& data, bool closed) :
-            m_container(&data), 
-            m_index(-1),
-            m_closed(closed),
-            m_stop(false)
-        {}
-
-        void init(const Container& data, bool closed)
-        {
-            m_container = &data;
-            m_index = m_container->size() - 1;
-            m_closed = closed;
-            m_stop = false;
-        }
-
-        void rewind(unsigned)
-        {
-            m_index = m_container->size() - 1;
-            m_stop = false;
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_index >= 0)
-            {
-                bool first = m_index == int(m_container->size() - 1);
-                const vertex_type& v = (*m_container)[m_index--];
-                *x = v.x;
-                *y = v.y;
-                return first ? path_cmd_move_to : path_cmd_line_to;
-            }
-            *x = *y = 0.0;
-            if(m_closed && !m_stop)
-            {
-                m_stop = true;
-                return path_cmd_end_poly | path_flags_close;
-            }
-            return path_cmd_stop;
-        }
-
-    private:
-        const Container* m_container;
-        int  m_index;
-        bool m_closed;
-        bool m_stop;
-    };
-
-
-
-
-
-    //--------------------------------------------------------line_adaptor
-    class line_adaptor
-    {
-    public:
-        typedef double value_type;
-
-        line_adaptor() : m_line(m_coord, 2, false) {}
-        line_adaptor(double x1, double y1, double x2, double y2) :
-            m_line(m_coord, 2, false)
-        {
-            m_coord[0] = x1;
-            m_coord[1] = y1;
-            m_coord[2] = x2;
-            m_coord[3] = y2;
-        }
-        
-        void init(double x1, double y1, double x2, double y2)
-        {
-            m_coord[0] = x1;
-            m_coord[1] = y1;
-            m_coord[2] = x2;
-            m_coord[3] = y2;
-            m_line.rewind(0);
-        }
-
-        void rewind(unsigned)
-        {
-            m_line.rewind(0);
-        }
-
-        unsigned vertex(double* x, double* y)
-        {
-            return m_line.vertex(x, y);
-        }
-
-    private:
-        double                     m_coord[4];
-        poly_plain_adaptor<double> m_line;
-    };
-
-
-
-
-
-
-
-
-
-
-
-
-
-    //---------------------------------------------------------------path_base
-    // A container to store vertices with their flags. 
-    // A path consists of a number of contours separated with "move_to" 
-    // commands. The path storage can keep and maintain more than one
-    // path. 
-    // To navigate to the beginning of a particular path, use rewind(path_id);
-    // Where path_id is what start_new_path() returns. So, when you call
-    // start_new_path() you need to store its return value somewhere else
-    // to navigate to the path afterwards.
-    //
-    // See also: vertex_source concept
-    //------------------------------------------------------------------------
-    template<class VertexContainer> class path_base
-    {
-    public:
-        typedef VertexContainer            container_type;
-        typedef path_base<VertexContainer> self_type;
-
-        //--------------------------------------------------------------------
-        path_base() : m_vertices(), m_iterator(0) {}
-        void remove_all() { m_vertices.remove_all(); m_iterator = 0; }
-        void free_all()   { m_vertices.free_all();   m_iterator = 0; }
-
-        // Make path functions
-        //--------------------------------------------------------------------
-        unsigned start_new_path();
-
-        void move_to(double x, double y);
-        void move_rel(double dx, double dy);
-
-        void line_to(double x, double y);
-        void line_rel(double dx, double dy);
-
-        void hline_to(double x);
-        void hline_rel(double dx);
-
-        void vline_to(double y);
-        void vline_rel(double dy);
-
-        void arc_to(double rx, double ry,
-                    double angle,
-                    bool large_arc_flag,
-                    bool sweep_flag,
-                    double x, double y);
-
-        void arc_rel(double rx, double ry,
-                     double angle,
-                     bool large_arc_flag,
-                     bool sweep_flag,
-                     double dx, double dy);
-
-        void curve3(double x_ctrl, double y_ctrl, 
-                    double x_to,   double y_to);
-
-        void curve3_rel(double dx_ctrl, double dy_ctrl, 
-                        double dx_to,   double dy_to);
-
-        void curve3(double x_to, double y_to);
-
-        void curve3_rel(double dx_to, double dy_to);
-
-        void curve4(double x_ctrl1, double y_ctrl1, 
-                    double x_ctrl2, double y_ctrl2, 
-                    double x_to,    double y_to);
-
-        void curve4_rel(double dx_ctrl1, double dy_ctrl1, 
-                        double dx_ctrl2, double dy_ctrl2, 
-                        double dx_to,    double dy_to);
-
-        void curve4(double x_ctrl2, double y_ctrl2, 
-                    double x_to,    double y_to);
-
-        void curve4_rel(double x_ctrl2, double y_ctrl2, 
-                        double x_to,    double y_to);
-
-
-        void end_poly(unsigned flags = path_flags_close);
-        void close_polygon(unsigned flags = path_flags_none);
-
-        // Accessors
-        //--------------------------------------------------------------------
-        const container_type& vertices() const { return m_vertices; } 
-              container_type& vertices()       { return m_vertices; } 
-
-        unsigned total_vertices() const;
-
-        void rel_to_abs(double* x, double* y) const;
-
-        unsigned last_vertex(double* x, double* y) const;
-        unsigned prev_vertex(double* x, double* y) const;
-
-        double last_x() const;
-        double last_y() const;
-
-        unsigned vertex(unsigned idx, double* x, double* y) const;
-        unsigned command(unsigned idx) const;
-
-        void modify_vertex(unsigned idx, double x, double y);
-        void modify_vertex(unsigned idx, double x, double y, unsigned cmd);
-        void modify_command(unsigned idx, unsigned cmd);
-
-        // VertexSource interface
-        //--------------------------------------------------------------------
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-        // Arrange the orientation of a polygon, all polygons in a path, 
-        // or in all paths. After calling arrange_orientations() or 
-        // arrange_orientations_all_paths(), all the polygons will have 
-        // the same orientation, i.e. path_flags_cw or path_flags_ccw
-        //--------------------------------------------------------------------
-        unsigned arrange_polygon_orientation(unsigned start, path_flags_e orientation);
-        unsigned arrange_orientations(unsigned path_id, path_flags_e orientation);
-        void     arrange_orientations_all_paths(path_flags_e orientation);
-        void     invert_polygon(unsigned start);
-
-        // Flip all vertices horizontally or vertically, 
-        // between x1 and x2, or between y1 and y2 respectively
-        //--------------------------------------------------------------------
-        void flip_x(double x1, double x2);
-        void flip_y(double y1, double y2);
-
-        // Concatenate path. The path is added as is.
-        //--------------------------------------------------------------------
-        template<class VertexSource> 
-        void concat_path(VertexSource& vs, unsigned path_id = 0)
-        {
-            double x = 0, y = 0;
-            unsigned cmd;
-            vs.rewind(path_id);
-            while(!is_stop(cmd = vs.vertex(&x, &y)))
-            {
-                m_vertices.add_vertex(x, y, cmd);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        // Join path. The path is joined with the existing one, that is, 
-        // it behaves as if the pen of a plotter was always down (drawing)
-        template<class VertexSource> 
-        void join_path(VertexSource& vs, unsigned path_id = 0)
-        {
-            double x, y;
-            unsigned cmd;
-            vs.rewind(path_id);
-            cmd = vs.vertex(&x, &y);
-            if(!is_stop(cmd))
-            {
-                if(is_vertex(cmd))
-                {
-                    double x0, y0;
-                    unsigned cmd0 = last_vertex(&x0, &y0);
-                    if(is_vertex(cmd0))
-                    {
-                        if(calc_distance(x, y, x0, y0) > vertex_dist_epsilon)
-                        {
-                            if(is_move_to(cmd)) cmd = path_cmd_line_to;
-                            m_vertices.add_vertex(x, y, cmd);
-                        }
-                    }
-                    else
-                    {
-                        if(is_stop(cmd0))
-                        {
-                            cmd = path_cmd_move_to;
-                        }
-                        else
-                        {
-                            if(is_move_to(cmd)) cmd = path_cmd_line_to;
-                        }
-                        m_vertices.add_vertex(x, y, cmd);
-                    }
-                }
-                while(!is_stop(cmd = vs.vertex(&x, &y)))
-                {
-                    m_vertices.add_vertex(x, y, is_move_to(cmd) ? 
-                                                    unsigned(path_cmd_line_to) : 
-                                                    cmd);
-                }
-            }
-        }
-
-        // Concatenate polygon/polyline. 
-        //--------------------------------------------------------------------
-        template<class T> void concat_poly(const T* data, 
-                                           unsigned num_points,
-                                           bool closed)
-        {
-            poly_plain_adaptor<T> poly(data, num_points, closed);
-            concat_path(poly);
-        }
-
-        // Join polygon/polyline continuously.
-        //--------------------------------------------------------------------
-        template<class T> void join_poly(const T* data, 
-                                         unsigned num_points,
-                                         bool closed)
-        {
-            poly_plain_adaptor<T> poly(data, num_points, closed);
-            join_path(poly);
-        }
-
-        //--------------------------------------------------------------------
-        void translate(double dx, double dy, unsigned path_id=0);
-        void translate_all_paths(double dx, double dy);
-
-        //--------------------------------------------------------------------
-        template<class Trans>
-        void transform(const Trans& trans, unsigned path_id=0)
-        {
-            unsigned num_ver = m_vertices.total_vertices();
-            for(; path_id < num_ver; path_id++)
-            {
-                double x, y;
-                unsigned cmd = m_vertices.vertex(path_id, &x, &y);
-                if(is_stop(cmd)) break;
-                if(is_vertex(cmd))
-                {
-                    trans.transform(&x, &y);
-                    m_vertices.modify_vertex(path_id, x, y);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class Trans>
-        void transform_all_paths(const Trans& trans)
-        {
-            unsigned idx;
-            unsigned num_ver = m_vertices.total_vertices();
-            for(idx = 0; idx < num_ver; idx++)
-            {
-                double x, y;
-                if(is_vertex(m_vertices.vertex(idx, &x, &y)))
-                {
-                    trans.transform(&x, &y);
-                    m_vertices.modify_vertex(idx, x, y);
-                }
-            }
-        }
-
-
-
-    private:
-        unsigned perceive_polygon_orientation(unsigned start, unsigned end);
-        void     invert_polygon(unsigned start, unsigned end);
-
-        VertexContainer m_vertices;
-        unsigned        m_iterator;
-    };
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    unsigned path_base<VC>::start_new_path()
-    {
-        if(!is_stop(m_vertices.last_command()))
-        {
-            m_vertices.add_vertex(0.0, 0.0, path_cmd_stop);
-        }
-        return m_vertices.total_vertices();
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::rel_to_abs(double* x, double* y) const
-    {
-        if(m_vertices.total_vertices())
-        {
-            double x2;
-            double y2;
-            if(is_vertex(m_vertices.last_vertex(&x2, &y2)))
-            {
-                *x += x2;
-                *y += y2;
-            }
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::move_to(double x, double y)
-    {
-        m_vertices.add_vertex(x, y, path_cmd_move_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::move_rel(double dx, double dy)
-    {
-        rel_to_abs(&dx, &dy);
-        m_vertices.add_vertex(dx, dy, path_cmd_move_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::line_to(double x, double y)
-    {
-        m_vertices.add_vertex(x, y, path_cmd_line_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::line_rel(double dx, double dy)
-    {
-        rel_to_abs(&dx, &dy);
-        m_vertices.add_vertex(dx, dy, path_cmd_line_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::hline_to(double x)
-    {
-        m_vertices.add_vertex(x, last_y(), path_cmd_line_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::hline_rel(double dx)
-    {
-        double dy = 0;
-        rel_to_abs(&dx, &dy);
-        m_vertices.add_vertex(dx, dy, path_cmd_line_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::vline_to(double y)
-    {
-        m_vertices.add_vertex(last_x(), y, path_cmd_line_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::vline_rel(double dy)
-    {
-        double dx = 0;
-        rel_to_abs(&dx, &dy);
-        m_vertices.add_vertex(dx, dy, path_cmd_line_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::arc_to(double rx, double ry,
-                               double angle,
-                               bool large_arc_flag,
-                               bool sweep_flag,
-                               double x, double y)
-    {
-        if(m_vertices.total_vertices() && is_vertex(m_vertices.last_command()))
-        {
-            const double epsilon = 1e-30;
-            double x0 = 0.0;
-            double y0 = 0.0;
-            m_vertices.last_vertex(&x0, &y0);
-
-            rx = fabs(rx);
-            ry = fabs(ry);
-
-            // Ensure radii are valid
-            //-------------------------
-            if(rx < epsilon || ry < epsilon) 
-            {
-                line_to(x, y);
-                return;
-            }
-
-            if(calc_distance(x0, y0, x, y) < epsilon)
-            {
-                // If the endpoints (x, y) and (x0, y0) are identical, then this
-                // is equivalent to omitting the elliptical arc segment entirely.
-                return;
-            }
-            bezier_arc_svg a(x0, y0, rx, ry, angle, large_arc_flag, sweep_flag, x, y);
-            if(a.radii_ok())
-            {
-                join_path(a);
-            }
-            else
-            {
-                line_to(x, y);
-            }
-        }
-        else
-        {
-            move_to(x, y);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::arc_rel(double rx, double ry,
-                                double angle,
-                                bool large_arc_flag,
-                                bool sweep_flag,
-                                double dx, double dy)
-    {
-        rel_to_abs(&dx, &dy);
-        arc_to(rx, ry, angle, large_arc_flag, sweep_flag, dx, dy);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve3(double x_ctrl, double y_ctrl, 
-                               double x_to,   double y_to)
-    {
-        m_vertices.add_vertex(x_ctrl, y_ctrl, path_cmd_curve3);
-        m_vertices.add_vertex(x_to,   y_to,   path_cmd_curve3);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve3_rel(double dx_ctrl, double dy_ctrl, 
-                                   double dx_to,   double dy_to)
-    {
-        rel_to_abs(&dx_ctrl, &dy_ctrl);
-        rel_to_abs(&dx_to,   &dy_to);
-        m_vertices.add_vertex(dx_ctrl, dy_ctrl, path_cmd_curve3);
-        m_vertices.add_vertex(dx_to,   dy_to,   path_cmd_curve3);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve3(double x_to, double y_to)
-    {
-        double x0;
-        double y0;
-        if(is_vertex(m_vertices.last_vertex(&x0, &y0)))
-        {
-            double x_ctrl;
-            double y_ctrl; 
-            unsigned cmd = m_vertices.prev_vertex(&x_ctrl, &y_ctrl);
-            if(is_curve(cmd))
-            {
-                x_ctrl = x0 + x0 - x_ctrl;
-                y_ctrl = y0 + y0 - y_ctrl;
-            }
-            else
-            {
-                x_ctrl = x0;
-                y_ctrl = y0;
-            }
-            curve3(x_ctrl, y_ctrl, x_to, y_to);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve3_rel(double dx_to, double dy_to)
-    {
-        rel_to_abs(&dx_to, &dy_to);
-        curve3(dx_to, dy_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve4(double x_ctrl1, double y_ctrl1, 
-                               double x_ctrl2, double y_ctrl2, 
-                               double x_to,    double y_to)
-    {
-        m_vertices.add_vertex(x_ctrl1, y_ctrl1, path_cmd_curve4);
-        m_vertices.add_vertex(x_ctrl2, y_ctrl2, path_cmd_curve4);
-        m_vertices.add_vertex(x_to,    y_to,    path_cmd_curve4);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve4_rel(double dx_ctrl1, double dy_ctrl1, 
-                                   double dx_ctrl2, double dy_ctrl2, 
-                                   double dx_to,    double dy_to)
-    {
-        rel_to_abs(&dx_ctrl1, &dy_ctrl1);
-        rel_to_abs(&dx_ctrl2, &dy_ctrl2);
-        rel_to_abs(&dx_to,    &dy_to);
-        m_vertices.add_vertex(dx_ctrl1, dy_ctrl1, path_cmd_curve4);
-        m_vertices.add_vertex(dx_ctrl2, dy_ctrl2, path_cmd_curve4);
-        m_vertices.add_vertex(dx_to,    dy_to,    path_cmd_curve4);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve4(double x_ctrl2, double y_ctrl2, 
-                               double x_to,    double y_to)
-    {
-        double x0;
-        double y0;
-        if(is_vertex(last_vertex(&x0, &y0)))
-        {
-            double x_ctrl1;
-            double y_ctrl1; 
-            unsigned cmd = prev_vertex(&x_ctrl1, &y_ctrl1);
-            if(is_curve(cmd))
-            {
-                x_ctrl1 = x0 + x0 - x_ctrl1;
-                y_ctrl1 = y0 + y0 - y_ctrl1;
-            }
-            else
-            {
-                x_ctrl1 = x0;
-                y_ctrl1 = y0;
-            }
-            curve4(x_ctrl1, y_ctrl1, x_ctrl2, y_ctrl2, x_to, y_to);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::curve4_rel(double dx_ctrl2, double dy_ctrl2, 
-                                   double dx_to,    double dy_to)
-    {
-        rel_to_abs(&dx_ctrl2, &dy_ctrl2);
-        rel_to_abs(&dx_to,    &dy_to);
-        curve4(dx_ctrl2, dy_ctrl2, dx_to, dy_to);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::end_poly(unsigned flags)
-    {
-        if(is_vertex(m_vertices.last_command()))
-        {
-            m_vertices.add_vertex(0.0, 0.0, path_cmd_end_poly | flags);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::close_polygon(unsigned flags)
-    {
-        end_poly(path_flags_close | flags);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline unsigned path_base<VC>::total_vertices() const
-    {
-        return m_vertices.total_vertices();
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline unsigned path_base<VC>::last_vertex(double* x, double* y) const
-    {
-        return m_vertices.last_vertex(x, y);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline unsigned path_base<VC>::prev_vertex(double* x, double* y) const
-    {
-        return m_vertices.prev_vertex(x, y);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline double path_base<VC>::last_x() const
-    {
-        return m_vertices.last_x();
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline double path_base<VC>::last_y() const
-    {
-        return m_vertices.last_y();
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline unsigned path_base<VC>::vertex(unsigned idx, double* x, double* y) const
-    {
-        return m_vertices.vertex(idx, x, y);
-    }
- 
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline unsigned path_base<VC>::command(unsigned idx) const
-    {
-        return m_vertices.command(idx);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::modify_vertex(unsigned idx, double x, double y)
-    {
-        m_vertices.modify_vertex(idx, x, y);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::modify_vertex(unsigned idx, double x, double y, unsigned cmd)
-    {
-        m_vertices.modify_vertex(idx, x, y, cmd);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::modify_command(unsigned idx, unsigned cmd)
-    {
-        m_vertices.modify_command(idx, cmd);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline void path_base<VC>::rewind(unsigned path_id)
-    {
-        m_iterator = path_id;
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    inline unsigned path_base<VC>::vertex(double* x, double* y)
-    {
-        if(m_iterator >= m_vertices.total_vertices()) return path_cmd_stop;
-        return m_vertices.vertex(m_iterator++, x, y);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    unsigned path_base<VC>::perceive_polygon_orientation(unsigned start,
-                                                         unsigned end)
-    {
-        // Calculate signed area (double area to be exact)
-        //---------------------
-        unsigned np = end - start;
-        double area = 0.0;
-        unsigned i;
-        for(i = 0; i < np; i++)
-        {
-            double x1, y1, x2, y2;
-            m_vertices.vertex(start + i,            &x1, &y1);
-            m_vertices.vertex(start + (i + 1) % np, &x2, &y2);
-            area += x1 * y2 - y1 * x2;
-        }
-        return (area < 0.0) ? path_flags_cw : path_flags_ccw;
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::invert_polygon(unsigned start, unsigned end)
-    {
-        unsigned i;
-        unsigned tmp_cmd = m_vertices.command(start);
-        
-        --end; // Make "end" inclusive
-
-        // Shift all commands to one position
-        for(i = start; i < end; i++)
-        {
-            m_vertices.modify_command(i, m_vertices.command(i + 1));
-        }
-
-        // Assign starting command to the ending command
-        m_vertices.modify_command(end, tmp_cmd);
-
-        // Reverse the polygon
-        while(end > start)
-        {
-            m_vertices.swap_vertices(start++, end--);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::invert_polygon(unsigned start)
-    {
-        // Skip all non-vertices at the beginning
-        while(start < m_vertices.total_vertices() && 
-              !is_vertex(m_vertices.command(start))) ++start;
-
-        // Skip all insignificant move_to
-        while(start+1 < m_vertices.total_vertices() && 
-              is_move_to(m_vertices.command(start)) &&
-              is_move_to(m_vertices.command(start+1))) ++start;
-
-        // Find the last vertex
-        unsigned end = start + 1;
-        while(end < m_vertices.total_vertices() && 
-              !is_next_poly(m_vertices.command(end))) ++end;
-
-        invert_polygon(start, end);
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    unsigned path_base<VC>::arrange_polygon_orientation(unsigned start, 
-                                                        path_flags_e orientation)
-    {
-        if(orientation == path_flags_none) return start;
-        
-        // Skip all non-vertices at the beginning
-        while(start < m_vertices.total_vertices() && 
-              !is_vertex(m_vertices.command(start))) ++start;
-
-        // Skip all insignificant move_to
-        while(start+1 < m_vertices.total_vertices() && 
-              is_move_to(m_vertices.command(start)) &&
-              is_move_to(m_vertices.command(start+1))) ++start;
-
-        // Find the last vertex
-        unsigned end = start + 1;
-        while(end < m_vertices.total_vertices() && 
-              !is_next_poly(m_vertices.command(end))) ++end;
-
-        if(end - start > 2)
-        {
-            if(perceive_polygon_orientation(start, end) != unsigned(orientation))
-            {
-                // Invert polygon, set orientation flag, and skip all end_poly
-                invert_polygon(start, end);
-                unsigned cmd;
-                while(end < m_vertices.total_vertices() && 
-                      is_end_poly(cmd = m_vertices.command(end)))
-                {
-                    m_vertices.modify_command(end++, set_orientation(cmd, orientation));
-                }
-            }
-        }
-        return end;
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    unsigned path_base<VC>::arrange_orientations(unsigned start, 
-                                                 path_flags_e orientation)
-    {
-        if(orientation != path_flags_none)
-        {
-            while(start < m_vertices.total_vertices())
-            {
-                start = arrange_polygon_orientation(start, orientation);
-                if(is_stop(m_vertices.command(start)))
-                {
-                    ++start;
-                    break;
-                }
-            }
-        }
-        return start;
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::arrange_orientations_all_paths(path_flags_e orientation)
-    {
-        if(orientation != path_flags_none)
-        {
-            unsigned start = 0;
-            while(start < m_vertices.total_vertices())
-            {
-                start = arrange_orientations(start, orientation);
-            }
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::flip_x(double x1, double x2)
-    {
-        unsigned i;
-        double x, y;
-        for(i = 0; i < m_vertices.total_vertices(); i++)
-        {
-            unsigned cmd = m_vertices.vertex(i, &x, &y);
-            if(is_vertex(cmd))
-            {
-                m_vertices.modify_vertex(i, x2 - x + x1, y);
-            }
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::flip_y(double y1, double y2)
-    {
-        unsigned i;
-        double x, y;
-        for(i = 0; i < m_vertices.total_vertices(); i++)
-        {
-            unsigned cmd = m_vertices.vertex(i, &x, &y);
-            if(is_vertex(cmd))
-            {
-                m_vertices.modify_vertex(i, x, y2 - y + y1);
-            }
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::translate(double dx, double dy, unsigned path_id)
-    {
-        unsigned num_ver = m_vertices.total_vertices();
-        for(; path_id < num_ver; path_id++)
-        {
-            double x, y;
-            unsigned cmd = m_vertices.vertex(path_id, &x, &y);
-            if(is_stop(cmd)) break;
-            if(is_vertex(cmd))
-            {
-                x += dx;
-                y += dy;
-                m_vertices.modify_vertex(path_id, x, y);
-            }
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class VC> 
-    void path_base<VC>::translate_all_paths(double dx, double dy)
-    {
-        unsigned idx;
-        unsigned num_ver = m_vertices.total_vertices();
-        for(idx = 0; idx < num_ver; idx++)
-        {
-            double x, y;
-            if(is_vertex(m_vertices.vertex(idx, &x, &y)))
-            {
-                x += dx;
-                y += dy;
-                m_vertices.modify_vertex(idx, x, y);
-            }
-        }
-    }
-
-    //-----------------------------------------------------vertex_stl_storage
-    template<class Container> class vertex_stl_storage
-    {
-    public:
-        typedef typename Container::value_type vertex_type;
-        typedef typename vertex_type::value_type value_type;
-
-        void remove_all() { m_vertices.clear(); }
-        void free_all()   { m_vertices.clear(); }
-
-        void add_vertex(double x, double y, unsigned cmd)
-        {
-            m_vertices.push_back(vertex_type(value_type(x), 
-                                             value_type(y), 
-                                             int8u(cmd)));
-        }
-
-        void modify_vertex(unsigned idx, double x, double y)
-        {
-            vertex_type& v = m_vertices[idx];
-            v.x = value_type(x);
-            v.y = value_type(y);
-        }
-
-        void modify_vertex(unsigned idx, double x, double y, unsigned cmd)
-        {
-            vertex_type& v = m_vertices[idx];
-            v.x   = value_type(x);
-            v.y   = value_type(y);
-            v.cmd = int8u(cmd);
-        }
-
-        void modify_command(unsigned idx, unsigned cmd)
-        {
-            m_vertices[idx].cmd = int8u(cmd);
-        }
-
-        void swap_vertices(unsigned v1, unsigned v2)
-        {
-            vertex_type t = m_vertices[v1];
-            m_vertices[v1] = m_vertices[v2];
-            m_vertices[v2] = t;
-        }
-
-        unsigned last_command() const
-        {
-            return m_vertices.size() ? 
-                m_vertices[m_vertices.size() - 1].cmd : 
-                path_cmd_stop;
-        }
-
-        unsigned last_vertex(double* x, double* y) const
-        {
-            if(m_vertices.size() == 0)
-            {
-                *x = *y = 0.0;
-                return path_cmd_stop;
-            }
-            return vertex(m_vertices.size() - 1, x, y);
-        }
-
-        unsigned prev_vertex(double* x, double* y) const
-        {
-            if(m_vertices.size() < 2)
-            {
-                *x = *y = 0.0;
-                return path_cmd_stop;
-            }
-            return vertex(m_vertices.size() - 2, x, y);
-        }
-
-        double last_x() const
-        {
-            return m_vertices.size() ? m_vertices[m_vertices.size() - 1].x : 0.0;
-        }
-
-        double last_y() const
-        {
-            return m_vertices.size() ? m_vertices[m_vertices.size() - 1].y : 0.0;
-        }
-
-        unsigned total_vertices() const
-        {
-            return m_vertices.size();
-        }
-
-        unsigned vertex(unsigned idx, double* x, double* y) const
-        {
-            const vertex_type& v = m_vertices[idx];
-            *x = v.x;
-            *y = v.y;
-            return v.cmd;
-        }
-
-        unsigned command(unsigned idx) const
-        {
-            return m_vertices[idx].cmd;
-        }
-
-    private:
-        Container m_vertices;
-    };
-
-    //-----------------------------------------------------------path_storage
-    typedef path_base<vertex_block_storage<double> > path_storage;
-
-    // Example of declarations path_storage with pod_bvector as a container
-    //-----------------------------------------------------------------------
-    //typedef path_base<vertex_stl_storage<pod_bvector<vertex_d> > > path_storage;
-
-}
-
-
-
-// Example of declarations path_storage with std::vector as a container
-//---------------------------------------------------------------------------
-//#include <vector>
-//namespace mapserver
-//{
-//    typedef path_base<vertex_stl_storage<std::vector<vertex_d> > > stl_path_storage; 
-//}
-
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_path_storage_integer.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_path_storage_integer.h
--- 8.0.1-5/renderers/agg/include/agg_path_storage_integer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_path_storage_integer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,295 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PATH_STORAGE_INTEGER_INCLUDED
-#define AGG_PATH_STORAGE_INTEGER_INCLUDED
-
-#include <string.h>
-#include "agg_array.h"
-
-namespace mapserver
-{
-    //---------------------------------------------------------vertex_integer
-    template<class T, unsigned CoordShift=6> struct vertex_integer
-    {
-        enum path_cmd
-        {
-            cmd_move_to = 0,
-            cmd_line_to = 1,
-            cmd_curve3  = 2,
-            cmd_curve4  = 3
-        };
-
-        enum coord_scale_e
-        {
-            coord_shift = CoordShift,
-            coord_scale  = 1 << coord_shift
-        };
-
-        T x = 0,y = 0;
-        vertex_integer() = default;
-        vertex_integer(T x_, T y_, unsigned flag) :
-            x(((x_ << 1) & ~1) | (flag &  1)),
-            y(((y_ << 1) & ~1) | (flag >> 1)) {}
-
-        unsigned vertex(double* x_, double* y_, 
-                        double dx=0, double dy=0,
-                        double scale=1.0) const
-        {
-            *x_ = dx + (double(x >> 1) / coord_scale) * scale;
-            *y_ = dy + (double(y >> 1) / coord_scale) * scale;
-            switch(((y & 1) << 1) | (x & 1))
-            {
-                case cmd_move_to: return path_cmd_move_to;
-                case cmd_line_to: return path_cmd_line_to;
-                case cmd_curve3:  return path_cmd_curve3;
-                case cmd_curve4:  return path_cmd_curve4;
-            }
-            return path_cmd_stop;
-        }
-    };
-
-
-    //---------------------------------------------------path_storage_integer
-    template<class T, unsigned CoordShift=6> class path_storage_integer
-    {
-    public:
-        typedef T value_type;
-        typedef vertex_integer<T, CoordShift> vertex_integer_type;
-
-        //--------------------------------------------------------------------
-        path_storage_integer() : m_storage(), m_vertex_idx(0), m_closed(true) {}
-
-        //--------------------------------------------------------------------
-        void remove_all() { m_storage.remove_all(); }
-
-        //--------------------------------------------------------------------
-        void move_to(T x, T y)
-        {
-            m_storage.add(vertex_integer_type(x, y, vertex_integer_type::cmd_move_to));
-        }
-
-        //--------------------------------------------------------------------
-        void line_to(T x, T y)
-        {
-            m_storage.add(vertex_integer_type(x, y, vertex_integer_type::cmd_line_to));
-        }
-
-        //--------------------------------------------------------------------
-        void curve3(T x_ctrl,  T y_ctrl, 
-                    T x_to,    T y_to)
-        {
-            m_storage.add(vertex_integer_type(x_ctrl, y_ctrl, vertex_integer_type::cmd_curve3));
-            m_storage.add(vertex_integer_type(x_to,   y_to,   vertex_integer_type::cmd_curve3));
-        }
-
-        //--------------------------------------------------------------------
-        void curve4(T x_ctrl1, T y_ctrl1, 
-                    T x_ctrl2, T y_ctrl2, 
-                    T x_to,    T y_to)
-        {
-            m_storage.add(vertex_integer_type(x_ctrl1, y_ctrl1, vertex_integer_type::cmd_curve4));
-            m_storage.add(vertex_integer_type(x_ctrl2, y_ctrl2, vertex_integer_type::cmd_curve4));
-            m_storage.add(vertex_integer_type(x_to,    y_to,    vertex_integer_type::cmd_curve4));
-        }
-
-        //--------------------------------------------------------------------
-        void close_polygon() {}
-
-        //--------------------------------------------------------------------
-        unsigned size() const { return m_storage.size(); }
-        unsigned vertex(unsigned idx, double* x, double* y) const
-        {
-            return m_storage[idx].vertex(x, y);
-        }
-
-        //--------------------------------------------------------------------
-        unsigned byte_size() const { return m_storage.size() * sizeof(vertex_integer_type); }
-        void serialize(int8u* ptr) const
-        {
-            unsigned i;
-            for(i = 0; i < m_storage.size(); i++)
-            {
-                memcpy(ptr, &m_storage[i], sizeof(vertex_integer_type));
-                ptr += sizeof(vertex_integer_type);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void rewind(unsigned) 
-        { 
-            m_vertex_idx = 0; 
-            m_closed = true;
-        }
-
-        //--------------------------------------------------------------------
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_storage.size() < 2 || m_vertex_idx > m_storage.size()) 
-            {
-                *x = 0;
-                *y = 0;
-                return path_cmd_stop;
-            }
-            if(m_vertex_idx == m_storage.size())
-            {
-                *x = 0;
-                *y = 0;
-                ++m_vertex_idx;
-                return path_cmd_end_poly | path_flags_close;
-            }
-            unsigned cmd = m_storage[m_vertex_idx].vertex(x, y);
-            if(is_move_to(cmd) && !m_closed)
-            {
-                *x = 0;
-                *y = 0;
-                m_closed = true;
-                return path_cmd_end_poly | path_flags_close;
-            }
-            m_closed = false;
-            ++m_vertex_idx;
-            return cmd;
-        }
-
-        //--------------------------------------------------------------------
-        rect_d bounding_rect() const
-        {
-            rect_d bounds(1e100, 1e100, -1e100, -1e100);
-            if(m_storage.size() == 0)
-            {
-                bounds.x1 = bounds.y1 = bounds.x2 = bounds.y2 = 0.0;
-            }
-            else
-            {
-                unsigned i;
-                for(i = 0; i < m_storage.size(); i++)
-                {
-                    double x, y;
-                    m_storage[i].vertex(&x, &y);
-                    if(x < bounds.x1) bounds.x1 = x;
-                    if(y < bounds.y1) bounds.y1 = y;
-                    if(x > bounds.x2) bounds.x2 = x;
-                    if(y > bounds.y2) bounds.y2 = y;
-                }
-            }
-            return bounds;
-        }
-
-    private:
-        pod_bvector<vertex_integer_type, 6> m_storage;
-        unsigned                            m_vertex_idx;
-        bool                                m_closed;
-    };
-
-
-
-
-    //-----------------------------------------serialized_integer_path_adaptor
-    template<class T, unsigned CoordShift=6> class serialized_integer_path_adaptor
-    {
-    public:
-        typedef vertex_integer<T, CoordShift> vertex_integer_type;
-
-        //--------------------------------------------------------------------
-        serialized_integer_path_adaptor() :
-            m_data(0),
-            m_end(0),
-            m_ptr(0),
-            m_dx(0.0),
-            m_dy(0.0),
-            m_scale(1.0),
-            m_vertices(0)
-        {}
-
-        //--------------------------------------------------------------------
-        serialized_integer_path_adaptor(const int8u* data, unsigned size,
-                                        double dx, double dy) :
-            m_data(data),
-            m_end(data + size),
-            m_ptr(data),
-            m_dx(dx),
-            m_dy(dy),
-            m_vertices(0)
-        {}
-
-        //--------------------------------------------------------------------
-        void init(const int8u* data, unsigned size, 
-                  double dx, double dy, double scale=1.0)
-        {
-            m_data     = data;
-            m_end      = data + size;
-            m_ptr      = data;
-            m_dx       = dx;
-            m_dy       = dy;
-            m_scale    = scale;
-            m_vertices = 0;
-        }
-
-
-        //--------------------------------------------------------------------
-        void rewind(unsigned) 
-        { 
-            m_ptr      = m_data; 
-            m_vertices = 0;
-        }
-
-        //--------------------------------------------------------------------
-        unsigned vertex(double* x, double* y)
-        {
-            if(m_data == 0 || m_ptr > m_end) 
-            {
-                *x = 0;
-                *y = 0;
-                return path_cmd_stop;
-            }
-
-            if(m_ptr == m_end)
-            {
-                *x = 0;
-                *y = 0;
-                m_ptr += sizeof(vertex_integer_type);
-                return path_cmd_end_poly | path_flags_close;
-            }
-
-            vertex_integer_type v;
-            memcpy(&v, m_ptr, sizeof(vertex_integer_type));
-            unsigned cmd = v.vertex(x, y, m_dx, m_dy, m_scale);
-            if(is_move_to(cmd) && m_vertices > 2)
-            {
-                *x = 0;
-                *y = 0;
-                m_vertices = 0;
-                return path_cmd_end_poly | path_flags_close;
-            }
-            ++m_vertices;
-            m_ptr += sizeof(vertex_integer_type);
-            return cmd;
-        }
-
-    private:
-        const int8u* m_data;
-        const int8u* m_end;
-        const int8u* m_ptr;
-        double       m_dx;
-        double       m_dy;
-        double       m_scale;
-        unsigned     m_vertices;
-    };
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_pattern_filters_rgba.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pattern_filters_rgba.h
--- 8.0.1-5/renderers/agg/include/agg_pattern_filters_rgba.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pattern_filters_rgba.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,122 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_PATTERN_FILTERS_RGBA8_INCLUDED
-#define AGG_PATTERN_FILTERS_RGBA8_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_line_aa_basics.h"
-#include "agg_color_rgba.h"
-
-
-namespace mapserver
-{
-
-    //=======================================================pattern_filter_nn
-    template<class ColorT> struct pattern_filter_nn
-    {
-        typedef ColorT color_type;
-        static unsigned dilation() { return 0; }
-
-        static void AGG_INLINE pixel_low_res(color_type const* const* buf, 
-                                             color_type* p, int x, int y)
-        {
-            *p = buf[y][x];
-        }
-
-        static void AGG_INLINE pixel_high_res(color_type const* const* buf, 
-                                              color_type* p, int x, int y)
-        {
-            *p = buf[y >> line_subpixel_shift]
-                    [x >> line_subpixel_shift];
-        }
-    };
-
-    typedef pattern_filter_nn<rgba8>  pattern_filter_nn_rgba8;
-    typedef pattern_filter_nn<rgba16> pattern_filter_nn_rgba16;
-
-
-    //===========================================pattern_filter_bilinear_rgba
-    template<class ColorT> struct pattern_filter_bilinear_rgba
-    {
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-
-
-        static unsigned dilation() { return 1; }
-
-        static AGG_INLINE void pixel_low_res(color_type const* const* buf, 
-                                             color_type* p, int x, int y)
-        {
-            *p = buf[y][x];
-        }
-
-        static AGG_INLINE void pixel_high_res(color_type const* const* buf, 
-                                              color_type* p, int x, int y)
-        {
-            calc_type r, g, b, a;
-            r = g = b = a = line_subpixel_scale * line_subpixel_scale / 2;
-
-            calc_type weight;
-            int x_lr = x >> line_subpixel_shift;
-            int y_lr = y >> line_subpixel_shift;
-
-            x &= line_subpixel_mask;
-            y &= line_subpixel_mask;
-            const color_type* ptr = buf[y_lr] + x_lr;
-
-            weight = (line_subpixel_scale - x) * 
-                     (line_subpixel_scale - y);
-            r += weight * ptr->r;
-            g += weight * ptr->g;
-            b += weight * ptr->b;
-            a += weight * ptr->a;
-
-            ++ptr;
-
-            weight = x * (line_subpixel_scale - y);
-            r += weight * ptr->r;
-            g += weight * ptr->g;
-            b += weight * ptr->b;
-            a += weight * ptr->a;
-
-            ptr = buf[y_lr + 1] + x_lr;
-
-            weight = (line_subpixel_scale - x) * y;
-            r += weight * ptr->r;
-            g += weight * ptr->g;
-            b += weight * ptr->b;
-            a += weight * ptr->a;
-
-            ++ptr;
-
-            weight = x * y;
-            r += weight * ptr->r;
-            g += weight * ptr->g;
-            b += weight * ptr->b;
-            a += weight * ptr->a;
-
-            p->r = (value_type)(r >> line_subpixel_shift * 2);
-            p->g = (value_type)(g >> line_subpixel_shift * 2);
-            p->b = (value_type)(b >> line_subpixel_shift * 2);
-            p->a = (value_type)(a >> line_subpixel_shift * 2);
-        }
-    };
-
-    typedef pattern_filter_bilinear_rgba<rgba8>  pattern_filter_bilinear_rgba8;
-    typedef pattern_filter_bilinear_rgba<rgba16> pattern_filter_bilinear_rgba16;
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_pixfmt_amask_adaptor.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_amask_adaptor.h
--- 8.0.1-5/renderers/agg/include/agg_pixfmt_amask_adaptor.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_amask_adaptor.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,240 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PIXFMT_AMASK_ADAPTOR_INCLUDED
-#define AGG_PIXFMT_AMASK_ADAPTOR_INCLUDED
-
-
-#include <string.h>
-#include "agg_array.h"
-#include "agg_rendering_buffer.h"
-
-
-namespace mapserver
-{
-    //==================================================pixfmt_amask_adaptor
-    template<class PixFmt, class AlphaMask> class pixfmt_amask_adaptor
-    {
-    public:
-        typedef PixFmt pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::row_data row_data;
-        typedef AlphaMask amask_type;
-        typedef typename amask_type::cover_type cover_type;
-
-    private:
-        enum span_extra_tail_e { span_extra_tail = 256 };
-
-        void realloc_span(unsigned len)
-        {
-            if(len > m_span.size())
-            {
-                m_span.resize(len + span_extra_tail);
-            }
-        }
-
-        void init_span(unsigned len)
-        {
-            realloc_span(len);
-            memset(&m_span[0], amask_type::cover_full, len * sizeof(cover_type));
-        }
-
-        void init_span(unsigned len, const cover_type* covers)
-        {
-            realloc_span(len);
-            memcpy(&m_span[0], covers, len * sizeof(cover_type));
-        }
-
-
-    public:
-        pixfmt_amask_adaptor(pixfmt_type& pixf, const amask_type& mask) :
-            m_pixf(&pixf), m_mask(&mask), m_span()
-        {}
-
-        void attach_pixfmt(pixfmt_type& pixf)          { m_pixf = &pixf; }
-        void attach_alpha_mask(const amask_type& mask) { m_mask = &mask; }
-
-        //--------------------------------------------------------------------
-        template<class PixFmt2>
-        bool attach_pixfmt(PixFmt2& pixf, int x1, int y1, int x2, int y2)
-        {
-            return m_pixf->attach(pixf, x1, y1, x2, y2);
-        }
-
-        //--------------------------------------------------------------------
-        unsigned width()  const { return m_pixf->width();  }
-        unsigned height() const { return m_pixf->height(); }
-
-        //--------------------------------------------------------------------
-        color_type pixel(int x, int y)
-        {
-            return m_pixf->pixel(x, y);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_pixel(int x, int y, const color_type& c)
-        {
-            m_pixf->blend_pixel(x, y, c, m_mask->pixel(x, y));
-        }
-
-        //--------------------------------------------------------------------
-        void blend_pixel(int x, int y, const color_type& c, cover_type cover)
-        {
-            m_pixf->blend_pixel(x, y, c, m_mask->combine_pixel(x, y, cover));
-        }
-
-        //--------------------------------------------------------------------
-        void copy_hline(int x, int y, 
-                        unsigned len, 
-                        const color_type& c)
-        {
-            realloc_span(len);
-            m_mask->fill_hspan(x, y, &m_span[0], len);
-            m_pixf->blend_solid_hspan(x, y, len, c, &m_span[0]);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         cover_type cover)
-        {
-            init_span(len);
-            m_mask->combine_hspan(x, y, &m_span[0], len);
-            m_pixf->blend_solid_hspan(x, y, len, c, &m_span[0]);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_vline(int x, int y,
-                        unsigned len, 
-                        const color_type& c)
-        {
-            realloc_span(len);
-            m_mask->fill_vspan(x, y, &m_span[0], len);
-            m_pixf->blend_solid_vspan(x, y, len, c, &m_span[0]);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         cover_type cover)
-        {
-            init_span(len);
-            m_mask->combine_vspan(x, y, &m_span[0], len);
-            m_pixf->blend_solid_vspan(x, y, len, c, &m_span[0]);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_from(const rendering_buffer& from, 
-                       int xdst, int ydst,
-                       int xsrc, int ysrc,
-                       unsigned len)
-        {
-            m_pixf->copy_from(from, xdst, ydst, xsrc, ysrc, len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const cover_type* covers)
-        {
-            init_span(len, covers);
-            m_mask->combine_hspan(x, y, &m_span[0], len);
-            m_pixf->blend_solid_hspan(x, y, len, c, &m_span[0]);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const cover_type* covers)
-        {
-            init_span(len, covers);
-            m_mask->combine_vspan(x, y, &m_span[0], len);
-            m_pixf->blend_solid_vspan(x, y, len, c, &m_span[0]);
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y, unsigned len, const color_type* colors)
-        {
-            realloc_span(len);
-            m_mask->fill_hspan(x, y, &m_span[0], len);
-            m_pixf->blend_color_hspan(x, y, len, colors, &m_span[0], cover_full);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_color_vspan(int x, int y, unsigned len, const color_type* colors)
-        {
-            realloc_span(len);
-            m_mask->fill_vspan(x, y, &m_span[0], len);
-            m_pixf->blend_color_vspan(x, y, len, colors, &m_span[0], cover_full);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const cover_type* covers,
-                               cover_type cover = cover_full)
-        {
-            if(covers) 
-            {
-                init_span(len, covers);
-                m_mask->combine_hspan(x, y, &m_span[0], len);
-            }
-            else
-            {
-                realloc_span(len);
-                m_mask->fill_hspan(x, y, &m_span[0], len);
-            }
-            m_pixf->blend_color_hspan(x, y, len, colors, &m_span[0], cover);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const cover_type* covers,
-                               cover_type cover = cover_full)
-        {
-            if(covers) 
-            {
-                init_span(len, covers);
-                m_mask->combine_vspan(x, y, &m_span[0], len);
-            }
-            else
-            {
-                realloc_span(len);
-                m_mask->fill_vspan(x, y, &m_span[0], len);
-            }
-            m_pixf->blend_color_vspan(x, y, len, colors, &m_span[0], cover);
-        }
-
-    private:
-        pixfmt_type*          m_pixf;
-        const amask_type*     m_mask;
-        pod_array<cover_type> m_span;
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_pixfmt_gray.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_gray.h
--- 8.0.1-5/renderers/agg/include/agg_pixfmt_gray.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_gray.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,670 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PIXFMT_GRAY_INCLUDED
-#define AGG_PIXFMT_GRAY_INCLUDED
-
-#include <string.h>
-#include "agg_basics.h"
-#include "agg_color_gray.h"
-#include "agg_rendering_buffer.h"
-
-namespace mapserver
-{
- 
-    //============================================================blender_gray
-    template<class ColorT> struct blender_gray
-    {
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e { base_shift = color_type::base_shift };
-
-        static AGG_INLINE void blend_pix(value_type* p, unsigned cv, 
-                                         unsigned alpha, unsigned cover=0)
-        {
-            *p = (value_type)((((cv - calc_type(*p)) * alpha) + (calc_type(*p) << base_shift)) >> base_shift);
-        }
-    };
-
-
-    //======================================================blender_gray_pre
-    template<class ColorT> struct blender_gray_pre
-    {
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e { base_shift = color_type::base_shift };
-
-        static AGG_INLINE void blend_pix(value_type* p, unsigned cv,
-                                         unsigned alpha, unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            cover = (cover + 1) << (base_shift - 8);
-            *p = (value_type)((*p * alpha + cv * cover) >> base_shift);
-        }
-
-        static AGG_INLINE void blend_pix(value_type* p, unsigned cv,
-                                         unsigned alpha)
-        {
-            *p = (value_type)(((*p * (color_type::base_mask - alpha)) >> base_shift) + cv);
-        }
-    };
-    
-
-
-    //=====================================================apply_gamma_dir_gray
-    template<class ColorT, class GammaLut> class apply_gamma_dir_gray
-    {
-    public:
-        typedef typename ColorT::value_type value_type;
-
-        apply_gamma_dir_gray(const GammaLut& gamma) : m_gamma(gamma) {}
-
-        AGG_INLINE void operator () (value_type* p)
-        {
-            *p = m_gamma.dir(*p);
-        }
-
-    private:
-        const GammaLut& m_gamma;
-    };
-
-
-
-    //=====================================================apply_gamma_inv_gray
-    template<class ColorT, class GammaLut> class apply_gamma_inv_gray
-    {
-    public:
-        typedef typename ColorT::value_type value_type;
-
-        apply_gamma_inv_gray(const GammaLut& gamma) : m_gamma(gamma) {}
-
-        AGG_INLINE void operator () (value_type* p)
-        {
-            *p = m_gamma.inv(*p);
-        }
-
-    private:
-        const GammaLut& m_gamma;
-    };
-
-
-
-    //=================================================pixfmt_alpha_blend_gray
-    template<class Blender, class RenBuf, unsigned Step=1, unsigned Offset=0>
-    class pixfmt_alpha_blend_gray
-    {
-    public:
-        typedef RenBuf   rbuf_type;
-        typedef typename rbuf_type::row_data row_data;
-        typedef Blender  blender_type;
-        typedef typename blender_type::color_type color_type;
-        typedef int                               order_type; // A fake one
-        typedef typename color_type::value_type   value_type;
-        typedef typename color_type::calc_type    calc_type;
-        enum base_scale_e 
-        {
-            base_shift = color_type::base_shift,
-            base_scale = color_type::base_scale,
-            base_mask  = color_type::base_mask,
-            pix_width  = sizeof(value_type),
-            pix_step   = Step,
-            pix_offset = Offset
-        };
-
-    private:
-        //--------------------------------------------------------------------
-        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                                 const color_type& c, 
-                                                 unsigned cover)
-        {
-            if (c.a)
-            {
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    *p = c.v;
-                }
-                else
-                {
-                    Blender::blend_pix(p, c.v, alpha, cover);
-                }
-            }
-        }
-
-
-        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                                 const color_type& c)
-        {
-            if (c.a)
-            {
-                if(c.a == base_mask)
-                {
-                    *p = c.v;
-                }
-                else
-                {
-                    Blender::blend_pix(p, c.v, c.a);
-                }
-            }
-        }
-
-
-    public:
-        //--------------------------------------------------------------------
-        explicit pixfmt_alpha_blend_gray(rbuf_type& rb) :
-            m_rbuf(&rb)
-        {}
-        void attach(rbuf_type& rb) { m_rbuf = &rb; }
-        //--------------------------------------------------------------------
-
-        template<class PixFmt>
-        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
-        {
-            rect_i r(x1, y1, x2, y2);
-            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
-            {
-                int stride = pixf.stride();
-                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
-                               (r.x2 - r.x1) + 1,
-                               (r.y2 - r.y1) + 1,
-                               stride);
-                return true;
-            }
-            return false;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
-        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
-        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
-
-        //--------------------------------------------------------------------
-              int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
-        const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
-        row_data     row(int y)     const { return m_rbuf->row(y); }
-
-        const int8u* pix_ptr(int x, int y) const
-        {
-            return m_rbuf->row_ptr(y) + x * Step + Offset;
-        }
-
-        int8u* pix_ptr(int x, int y)
-        {
-            return m_rbuf->row_ptr(y) + x * Step + Offset;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
-        {
-            *(value_type*)p = c.v;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE color_type pixel(int x, int y) const
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(y) + x * Step + Offset;
-            return color_type(*p);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
-        {
-            *((value_type*)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset) = c.v;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
-        {
-            copy_or_blend_pix((value_type*)
-                               m_rbuf->row_ptr(x, y, 1) + x * Step + Offset, 
-                               c, 
-                               cover);
-        }
-
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_hline(int x, int y, 
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            value_type* p = (value_type*)
-                m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
-
-            do
-            {
-                *p = c.v; 
-                p += Step;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_vline(int x, int y,
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            do
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-                *p = c.v;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
-
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    do
-                    {
-                        *p = c.v; 
-                        p += Step;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do
-                    {
-                        Blender::blend_pix(p, c.v, alpha, cover);
-                        p += Step;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                value_type* p;
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    do
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-                        *p = c.v; 
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-                        Blender::blend_pix(p, c.v, alpha, cover);
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            if (c.a)
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
-
-                do 
-                {
-                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
-                    if(alpha == base_mask)
-                    {
-                        *p = c.v;
-                    }
-                    else
-                    {
-                        Blender::blend_pix(p, c.v, alpha, *covers);
-                    }
-                    p += Step;
-                    ++covers;
-                }
-                while(--len);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            if (c.a)
-            {
-                do 
-                {
-                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
-
-                    value_type* p = (value_type*)
-                        m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-                    if(alpha == base_mask)
-                    {
-                        *p = c.v;
-                    }
-                    else
-                    {
-                        Blender::blend_pix(p, c.v, alpha, *covers);
-                    }
-                    ++covers;
-                }
-                while(--len);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            value_type* p = (value_type*)
-                m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
-
-            do 
-            {
-                *p = colors->v;
-                p += Step;
-                ++colors;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_vspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            do 
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-                *p = colors->v;
-                ++colors;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            value_type* p = (value_type*)
-                m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
-
-            if(covers)
-            {
-                do 
-                {
-                    copy_or_blend_pix(p, *colors++, *covers++);
-                    p += Step;
-                }
-                while(--len);
-            }
-            else
-            {
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        if(colors->a == base_mask)
-                        {
-                            *p = colors->v;
-                        }
-                        else
-                        {
-                            copy_or_blend_pix(p, *colors);
-                        }
-                        p += Step;
-                        ++colors;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        copy_or_blend_pix(p, *colors++, cover);
-                        p += Step;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            value_type* p;
-            if(covers)
-            {
-                do 
-                {
-                    p = (value_type*)
-                        m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-                    copy_or_blend_pix(p, *colors++, *covers++);
-                }
-                while(--len);
-            }
-            else
-            {
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-                        if(colors->a == base_mask)
-                        {
-                            *p = colors->v;
-                        }
-                        else
-                        {
-                            copy_or_blend_pix(p, *colors);
-                        }
-                        ++colors;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
-
-                        copy_or_blend_pix(p, *colors++, cover);
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class Function> void for_each_pixel(Function f)
-        {
-            unsigned y;
-            for(y = 0; y < height(); ++y)
-            {
-                row_data r = m_rbuf->row(y);
-                if(r.ptr)
-                {
-                    unsigned len = r.x2 - r.x1 + 1;
-
-                    value_type* p = (value_type*)
-                        m_rbuf->row_ptr(r.x1, y, len) + r.x1 * Step + Offset;
-
-                    do
-                    {
-                        f(p);
-                        p += Step;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_dir_gray<color_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_inv_gray<color_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class RenBuf2>
-        void copy_from(const RenBuf2& from, 
-                       int xdst, int ydst,
-                       int xsrc, int ysrc,
-                       unsigned len)
-        {
-            const int8u* p = from.row_ptr(ysrc);
-            if(p)
-            {
-                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
-                        p + xsrc * pix_width, 
-                        len * pix_width);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_color(const SrcPixelFormatRenderer& from, 
-                              const color_type& color,
-                              int xdst, int ydst,
-                              int xsrc, int ysrc,
-                              unsigned len,
-                              int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
-                do 
-                {
-                    copy_or_blend_pix(pdst, 
-                                      color, 
-                                      (*psrc * cover + base_mask) >> base_shift);
-                    ++psrc;
-                    ++pdst;
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_lut(const SrcPixelFormatRenderer& from, 
-                            const color_type* color_lut,
-                            int xdst, int ydst,
-                            int xsrc, int ysrc,
-                            unsigned len,
-                            int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
-                do 
-                {
-                    copy_or_blend_pix(pdst, color_lut[*psrc], cover);
-                    ++psrc;
-                    ++pdst;
-                }
-                while(--len);
-            }
-        }
-
-    private:
-        rbuf_type* m_rbuf;
-    };
-
-    typedef blender_gray<gray8>      blender_gray8;
-    typedef blender_gray_pre<gray8>  blender_gray8_pre;
-    typedef blender_gray<gray16>     blender_gray16;
-    typedef blender_gray_pre<gray16> blender_gray16_pre;
-
-    typedef pixfmt_alpha_blend_gray<blender_gray8,      rendering_buffer> pixfmt_gray8;      //----pixfmt_gray8
-    typedef pixfmt_alpha_blend_gray<blender_gray8_pre,  rendering_buffer> pixfmt_gray8_pre;  //----pixfmt_gray8_pre
-    typedef pixfmt_alpha_blend_gray<blender_gray16,     rendering_buffer> pixfmt_gray16;     //----pixfmt_gray16
-    typedef pixfmt_alpha_blend_gray<blender_gray16_pre, rendering_buffer> pixfmt_gray16_pre; //----pixfmt_gray16_pre
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_pixfmt_rgb.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_rgb.h
--- 8.0.1-5/renderers/agg/include/agg_pixfmt_rgb.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_rgb.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,860 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PIXFMT_RGB_INCLUDED
-#define AGG_PIXFMT_RGB_INCLUDED
-
-#include <string.h>
-#include "agg_basics.h"
-#include "agg_color_rgba.h"
-#include "agg_rendering_buffer.h"
-
-namespace mapserver
-{
-
-    //=====================================================apply_gamma_dir_rgb
-    template<class ColorT, class Order, class GammaLut> class apply_gamma_dir_rgb
-    {
-    public:
-        typedef typename ColorT::value_type value_type;
-
-        apply_gamma_dir_rgb(const GammaLut& gamma) : m_gamma(gamma) {}
-
-        AGG_INLINE void operator () (value_type* p)
-        {
-            p[Order::R] = m_gamma.dir(p[Order::R]);
-            p[Order::G] = m_gamma.dir(p[Order::G]);
-            p[Order::B] = m_gamma.dir(p[Order::B]);
-        }
-
-    private:
-        const GammaLut& m_gamma;
-    };
-
-
-
-    //=====================================================apply_gamma_inv_rgb
-    template<class ColorT, class Order, class GammaLut> class apply_gamma_inv_rgb
-    {
-    public:
-        typedef typename ColorT::value_type value_type;
-
-        apply_gamma_inv_rgb(const GammaLut& gamma) : m_gamma(gamma) {}
-
-        AGG_INLINE void operator () (value_type* p)
-        {
-            p[Order::R] = m_gamma.inv(p[Order::R]);
-            p[Order::G] = m_gamma.inv(p[Order::G]);
-            p[Order::B] = m_gamma.inv(p[Order::B]);
-        }
-
-    private:
-        const GammaLut& m_gamma;
-    };
-
-
-    //=========================================================blender_rgb
-    template<class ColorT, class Order> struct blender_rgb
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e { base_shift = color_type::base_shift };
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb, 
-                                         unsigned alpha, 
-                                         unsigned cover=0)
-        {
-            p[Order::R] += (value_type)(((cr - p[Order::R]) * alpha) >> base_shift);
-            p[Order::G] += (value_type)(((cg - p[Order::G]) * alpha) >> base_shift);
-            p[Order::B] += (value_type)(((cb - p[Order::B]) * alpha) >> base_shift);
-        }
-    };
-
-
-    //======================================================blender_rgb_pre
-    template<class ColorT, class Order> struct blender_rgb_pre
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e { base_shift = color_type::base_shift };
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha,
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            cover = (cover + 1) << (base_shift - 8);
-            p[Order::R] = (value_type)((p[Order::R] * alpha + cr * cover) >> base_shift);
-            p[Order::G] = (value_type)((p[Order::G] * alpha + cg * cover) >> base_shift);
-            p[Order::B] = (value_type)((p[Order::B] * alpha + cb * cover) >> base_shift);
-        }
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha)
-        {
-            alpha = color_type::base_mask - alpha;
-            p[Order::R] = (value_type)(((p[Order::R] * alpha) >> base_shift) + cr);
-            p[Order::G] = (value_type)(((p[Order::G] * alpha) >> base_shift) + cg);
-            p[Order::B] = (value_type)(((p[Order::B] * alpha) >> base_shift) + cb);
-        }
-
-    };
-
-
-
-    //===================================================blender_rgb_gamma
-    template<class ColorT, class Order, class Gamma> class blender_rgb_gamma
-    {
-    public:
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef Gamma gamma_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e { base_shift = color_type::base_shift };
-
-        //--------------------------------------------------------------------
-        blender_rgb_gamma() : m_gamma(0) {}
-        void gamma(const gamma_type& g) { m_gamma = &g; }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_pix(value_type* p, 
-                                  unsigned cr, unsigned cg, unsigned cb,
-                                  unsigned alpha, 
-                                  unsigned cover=0)
-        {
-            calc_type r = m_gamma->dir(p[Order::R]);
-            calc_type g = m_gamma->dir(p[Order::G]);
-            calc_type b = m_gamma->dir(p[Order::B]);
-            p[Order::R] = m_gamma->inv((((m_gamma->dir(cr) - r) * alpha) >> base_shift) + r);
-            p[Order::G] = m_gamma->inv((((m_gamma->dir(cg) - g) * alpha) >> base_shift) + g);
-            p[Order::B] = m_gamma->inv((((m_gamma->dir(cb) - b) * alpha) >> base_shift) + b);
-        }
-
-    private:
-        const gamma_type* m_gamma;
-    };
-
-
-
-    
-    //==================================================pixfmt_alpha_blend_rgb
-    template<class Blender, class RenBuf> class pixfmt_alpha_blend_rgb
-    {
-    public:
-        typedef RenBuf   rbuf_type;
-        typedef Blender  blender_type;
-        typedef typename rbuf_type::row_data row_data;
-        typedef typename blender_type::color_type color_type;
-        typedef typename blender_type::order_type order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e 
-        {
-            base_shift = color_type::base_shift,
-            base_scale = color_type::base_scale,
-            base_mask  = color_type::base_mask,
-            pix_width  = sizeof(value_type) * 3
-        };
-
-    private:
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                          const color_type& c, 
-                                          unsigned cover)
-        {
-            if (c.a)
-            {
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    p[order_type::R] = c.r;
-                    p[order_type::G] = c.g;
-                    p[order_type::B] = c.b;
-                }
-                else
-                {
-                    m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                          const color_type& c)
-        {
-            if (c.a)
-            {
-                if(c.a == base_mask)
-                {
-                    p[order_type::R] = c.r;
-                    p[order_type::G] = c.g;
-                    p[order_type::B] = c.b;
-                }
-                else
-                {
-                    m_blender.blend_pix(p, c.r, c.g, c.b, c.a);
-                }
-            }
-        }
-
-
-    public:
-        //--------------------------------------------------------------------
-        explicit pixfmt_alpha_blend_rgb(rbuf_type& rb) :
-            m_rbuf(&rb)
-        {}
-        void attach(rbuf_type& rb) { m_rbuf = &rb; }
-
-        //--------------------------------------------------------------------
-        template<class PixFmt>
-        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
-        {
-            rect_i r(x1, y1, x2, y2);
-            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
-            {
-                int stride = pixf.stride();
-                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
-                               (r.x2 - r.x1) + 1,
-                               (r.y2 - r.y1) + 1,
-                               stride);
-                return true;
-            }
-            return false;
-        }
-
-        //--------------------------------------------------------------------
-        Blender& blender() { return m_blender; }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
-        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
-        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
-        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
-        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE int8u* pix_ptr(int x, int y) 
-        { 
-            return m_rbuf->row_ptr(y) + x * pix_width; 
-        }
-
-        AGG_INLINE const int8u* pix_ptr(int x, int y) const 
-        { 
-            return m_rbuf->row_ptr(y) + x * pix_width; 
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
-        {
-            ((value_type*)p)[order_type::R] = c.r;
-            ((value_type*)p)[order_type::G] = c.g;
-            ((value_type*)p)[order_type::B] = c.b;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE color_type pixel(int x, int y) const
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(y) + x + x + x;
-            return color_type(p[order_type::R], 
-                              p[order_type::G], 
-                              p[order_type::B]);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, 1) + x + x + x;
-            p[order_type::R] = c.r;
-            p[order_type::G] = c.g;
-            p[order_type::B] = c.b;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
-        {
-            copy_or_blend_pix((value_type*)m_rbuf->row_ptr(x, y, 1) + x + x + x, c, cover);
-        }
-
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_hline(int x, int y, 
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + x + x + x;
-            do
-            {
-                p[order_type::R] = c.r; 
-                p[order_type::G] = c.g; 
-                p[order_type::B] = c.b;
-                p += 3;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_vline(int x, int y,
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            do
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-                p[order_type::R] = c.r; 
-                p[order_type::G] = c.g; 
-                p[order_type::B] = c.b;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y, len) + x + x + x;
-
-                calc_type alpha = (calc_type(c.a) * (calc_type(cover) + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    do
-                    {
-                        p[order_type::R] = c.r; 
-                        p[order_type::G] = c.g; 
-                        p[order_type::B] = c.b;
-                        p += 3;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do
-                    {
-                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
-                        p += 3;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                value_type* p;
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    do
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-
-                        p[order_type::R] = c.r; 
-                        p[order_type::G] = c.g; 
-                        p[order_type::B] = c.b;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-
-                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            if (c.a)
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y, len) + x + x + x;
-
-                do 
-                {
-                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
-                    if(alpha == base_mask)
-                    {
-                        p[order_type::R] = c.r;
-                        p[order_type::G] = c.g;
-                        p[order_type::B] = c.b;
-                    }
-                    else
-                    {
-                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, *covers);
-                    }
-                    p += 3;
-                    ++covers;
-                }
-                while(--len);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            if (c.a)
-            {
-                do 
-                {
-                    value_type* p = (value_type*)
-                        m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-
-                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
-                    if(alpha == base_mask)
-                    {
-                        p[order_type::R] = c.r;
-                        p[order_type::G] = c.g;
-                        p[order_type::B] = c.b;
-                    }
-                    else
-                    {
-                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, *covers);
-                    }
-                    ++covers;
-                }
-                while(--len);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            value_type* p = (value_type*)
-                m_rbuf->row_ptr(x, y, len) + x + x + x;
-
-            do 
-            {
-                p[order_type::R] = colors->r;
-                p[order_type::G] = colors->g;
-                p[order_type::B] = colors->b;
-                ++colors;
-                p += 3;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_vspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            do 
-            {
-                value_type* p = (value_type*)
-                    m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-                p[order_type::R] = colors->r;
-                p[order_type::G] = colors->g;
-                p[order_type::B] = colors->b;
-                ++colors;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            value_type* p = (value_type*)
-                m_rbuf->row_ptr(x, y, len) + x + x + x;
-
-            if(covers)
-            {
-                do 
-                {
-                    copy_or_blend_pix(p, *colors++, *covers++);
-                    p += 3;
-                }
-                while(--len);
-            }
-            else
-            {
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        copy_or_blend_pix(p, *colors++);
-                        p += 3;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        copy_or_blend_pix(p, *colors++, cover);
-                        p += 3;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            value_type* p;
-            if(covers)
-            {
-                do 
-                {
-                    p = (value_type*)
-                        m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-
-                    copy_or_blend_pix(p, *colors++, *covers++);
-                }
-                while(--len);
-            }
-            else
-            {
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-
-                        copy_or_blend_pix(p, *colors++);
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        p = (value_type*)
-                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
-
-                        copy_or_blend_pix(p, *colors++, cover);
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class Function> void for_each_pixel(Function f)
-        {
-            unsigned y;
-            for(y = 0; y < height(); ++y)
-            {
-                row_data r = m_rbuf->row(y);
-                if(r.ptr)
-                {
-                    unsigned len = r.x2 - r.x1 + 1;
-                    value_type* p = (value_type*)
-                        m_rbuf->row_ptr(r.x1, y, len) + r.x1 * 3;
-                    do
-                    {
-                        f(p);
-                        p += 3;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_dir_rgb<color_type, order_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_inv_rgb<color_type, order_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class RenBuf2>
-        void copy_from(const RenBuf2& from, 
-                       int xdst, int ydst,
-                       int xsrc, int ysrc,
-                       unsigned len)
-        {
-            const int8u* p = from.row_ptr(ysrc);
-            if(p)
-            {
-                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
-                        p + xsrc * pix_width, 
-                        len * pix_width);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from(const SrcPixelFormatRenderer& from, 
-                        int xdst, int ydst,
-                        int xsrc, int ysrc,
-                        unsigned len,
-                        int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::order_type src_order;
-
-            const value_type* psrc = (const value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                psrc += xsrc * 4;
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst * 3;   
-
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        value_type alpha = psrc[src_order::A];
-                        if(alpha)
-                        {
-                            if(alpha == base_mask)
-                            {
-                                pdst[order_type::R] = psrc[src_order::R];
-                                pdst[order_type::G] = psrc[src_order::G];
-                                pdst[order_type::B] = psrc[src_order::B];
-                            }
-                            else
-                            {
-                                m_blender.blend_pix(pdst, 
-                                                    psrc[src_order::R],
-                                                    psrc[src_order::G],
-                                                    psrc[src_order::B],
-                                                    alpha);
-                            }
-                        }
-                        psrc += 4;
-                        pdst += 3;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    color_type color;
-                    do 
-                    {
-                        color.r = psrc[src_order::R];
-                        color.g = psrc[src_order::G];
-                        color.b = psrc[src_order::B];
-                        color.a = psrc[src_order::A];
-                        copy_or_blend_pix(pdst, color, cover);
-                        psrc += 4;
-                        pdst += 3;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_color(const SrcPixelFormatRenderer& from, 
-                              const color_type& color,
-                              int xdst, int ydst,
-                              int xsrc, int ysrc,
-                              unsigned len,
-                              int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst * 3;
-                do 
-                {
-                    copy_or_blend_pix(pdst, 
-                                      color, 
-                                      (*psrc * cover + base_mask) >> base_shift);
-                    ++psrc;
-                    pdst += 3;
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_lut(const SrcPixelFormatRenderer& from, 
-                            const color_type* color_lut,
-                            int xdst, int ydst,
-                            int xsrc, int ysrc,
-                            unsigned len,
-                            int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst * 3;
-
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        const color_type& color = color_lut[*psrc];
-                        m_blender.blend_pix(pdst, 
-                                            color.r, color.g, color.b, color.a);
-                        ++psrc;
-                        pdst += 3;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        copy_or_blend_pix(pdst, color_lut[*psrc], cover);
-                        ++psrc;
-                        pdst += 3;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-    private:
-        rbuf_type* m_rbuf;
-        Blender    m_blender;
-    };
-
-    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba8,  order_rgb>, rendering_buffer> pixfmt_rgb24;    //----pixfmt_rgb24
-    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba8,  order_bgr>, rendering_buffer> pixfmt_bgr24;    //----pixfmt_bgr24
-    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba16, order_rgb>, rendering_buffer> pixfmt_rgb48;    //----pixfmt_rgb48
-    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba16, order_bgr>, rendering_buffer> pixfmt_bgr48;    //----pixfmt_bgr48
-
-    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba8,  order_rgb>, rendering_buffer> pixfmt_rgb24_pre; //----pixfmt_rgb24_pre
-    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba8,  order_bgr>, rendering_buffer> pixfmt_bgr24_pre; //----pixfmt_bgr24_pre
-    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba16, order_rgb>, rendering_buffer> pixfmt_rgb48_pre; //----pixfmt_rgb48_pre
-    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba16, order_bgr>, rendering_buffer> pixfmt_bgr48_pre; //----pixfmt_bgr48_pre
-
-    //-----------------------------------------------------pixfmt_rgb24_gamma
-    template<class Gamma> class pixfmt_rgb24_gamma : 
-    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_rgb, Gamma>, rendering_buffer>
-    {
-    public:
-        pixfmt_rgb24_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_rgb, Gamma>, rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-        
-    //-----------------------------------------------------pixfmt_bgr24_gamma
-    template<class Gamma> class pixfmt_bgr24_gamma : 
-    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_bgr, Gamma>, rendering_buffer>
-    {
-    public:
-        pixfmt_bgr24_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_bgr, Gamma>, rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-    //-----------------------------------------------------pixfmt_rgb48_gamma
-    template<class Gamma> class pixfmt_rgb48_gamma : 
-    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_rgb, Gamma>, rendering_buffer>
-    {
-    public:
-        pixfmt_rgb48_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_rgb, Gamma>, rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-        
-    //-----------------------------------------------------pixfmt_bgr48_gamma
-    template<class Gamma> class pixfmt_bgr48_gamma : 
-    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_bgr, Gamma>, rendering_buffer>
-    {
-    public:
-        pixfmt_bgr48_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_bgr, Gamma>, rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_pixfmt_rgb_packed.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_rgb_packed.h
--- 8.0.1-5/renderers/agg/include/agg_pixfmt_rgb_packed.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_rgb_packed.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1309 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PIXFMT_RGB_PACKED_INCLUDED
-#define AGG_PIXFMT_RGB_PACKED_INCLUDED
-
-#include <string.h>
-#include "agg_basics.h"
-#include "agg_color_rgba.h"
-#include "agg_rendering_buffer.h"
-
-namespace mapserver
-{
-    //=========================================================blender_rgb555
-    struct blender_rgb555
-    {
-        typedef rgba8 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int16u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 7) & 0xF8;
-            calc_type g = (rgb >> 2) & 0xF8;
-            calc_type b = (rgb << 3) & 0xF8;
-            *p = (pixel_type)
-               (((((cr - r) * alpha + (r << 8)) >> 1)  & 0x7C00) |
-                ((((cg - g) * alpha + (g << 8)) >> 6)  & 0x03E0) |
-                 (((cb - b) * alpha + (b << 8)) >> 11) | 0x8000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xF8) << 7) | 
-                                ((g & 0xF8) << 2) | 
-                                 (b >> 3) | 0x8000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 7) & 0xF8, 
-                              (p >> 2) & 0xF8, 
-                              (p << 3) & 0xF8);
-        }
-    };
-
-
-    //=====================================================blender_rgb555_pre
-    struct blender_rgb555_pre
-    {
-        typedef rgba8 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int16u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 7) & 0xF8;
-            calc_type g = (rgb >> 2) & 0xF8;
-            calc_type b = (rgb << 3) & 0xF8;
-            *p = (pixel_type)
-               ((((r * alpha + cr * cover) >> 1)  & 0x7C00) |
-                (((g * alpha + cg * cover) >> 6)  & 0x03E0) |
-                 ((b * alpha + cb * cover) >> 11) | 0x8000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xF8) << 7) | 
-                                ((g & 0xF8) << 2) | 
-                                 (b >> 3) | 0x8000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 7) & 0xF8, 
-                              (p >> 2) & 0xF8, 
-                              (p << 3) & 0xF8);
-        }
-    };
-
-
-
-
-    //=====================================================blender_rgb555_gamma
-    template<class Gamma> class blender_rgb555_gamma
-    {
-    public:
-        typedef rgba8 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int16u pixel_type;
-        typedef Gamma gamma_type;
-
-        blender_rgb555_gamma() : m_gamma(0) {}
-        void gamma(const gamma_type& g) { m_gamma = &g; }
-
-        AGG_INLINE void blend_pix(pixel_type* p, 
-                                  unsigned cr, unsigned cg, unsigned cb,
-                                  unsigned alpha, 
-                                  unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = m_gamma->dir((rgb >> 7) & 0xF8);
-            calc_type g = m_gamma->dir((rgb >> 2) & 0xF8);
-            calc_type b = m_gamma->dir((rgb << 3) & 0xF8);
-            *p = (pixel_type)
-               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 8)) >> 8) << 7) & 0x7C00) |
-                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 8)) >> 8) << 2) & 0x03E0) |
-                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 8)) >> 8) >> 3) | 0x8000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xF8) << 7) | 
-                                ((g & 0xF8) << 2) | 
-                                 (b >> 3) | 0x8000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 7) & 0xF8, 
-                              (p >> 2) & 0xF8, 
-                              (p << 3) & 0xF8);
-        }
-
-    private:
-        const Gamma* m_gamma;
-    };
-
-
-
-
-
-    //=========================================================blender_rgb565
-    struct blender_rgb565
-    {
-        typedef rgba8 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int16u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 8) & 0xF8;
-            calc_type g = (rgb >> 3) & 0xFC;
-            calc_type b = (rgb << 3) & 0xF8;
-            *p = (pixel_type)
-               (((((cr - r) * alpha + (r << 8))     ) & 0xF800) |
-                ((((cg - g) * alpha + (g << 8)) >> 5) & 0x07E0) |
-                 (((cb - b) * alpha + (b << 8)) >> 11));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 8) & 0xF8, 
-                              (p >> 3) & 0xFC, 
-                              (p << 3) & 0xF8);
-        }
-    };
-
-
-
-    //=====================================================blender_rgb565_pre
-    struct blender_rgb565_pre
-    {
-        typedef rgba8 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int16u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 8) & 0xF8;
-            calc_type g = (rgb >> 3) & 0xFC;
-            calc_type b = (rgb << 3) & 0xF8;
-            *p = (pixel_type)
-               ((((r * alpha + cr * cover)      ) & 0xF800) |
-                (((g * alpha + cg * cover) >> 5 ) & 0x07E0) |
-                 ((b * alpha + cb * cover) >> 11));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 8) & 0xF8, 
-                              (p >> 3) & 0xFC, 
-                              (p << 3) & 0xF8);
-        }
-    };
-
-
-
-    //=====================================================blender_rgb565_gamma
-    template<class Gamma> class blender_rgb565_gamma
-    {
-    public:
-        typedef rgba8 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int16u pixel_type;
-        typedef Gamma gamma_type;
-
-        blender_rgb565_gamma() : m_gamma(0) {}
-        void gamma(const gamma_type& g) { m_gamma = &g; }
-
-        AGG_INLINE void blend_pix(pixel_type* p, 
-                                  unsigned cr, unsigned cg, unsigned cb,
-                                  unsigned alpha, 
-                                  unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = m_gamma->dir((rgb >> 8) & 0xF8);
-            calc_type g = m_gamma->dir((rgb >> 3) & 0xFC);
-            calc_type b = m_gamma->dir((rgb << 3) & 0xF8);
-            *p = (pixel_type)
-               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 8)) >> 8) << 8) & 0xF800) |
-                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 8)) >> 8) << 3) & 0x07E0) |
-                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 8)) >> 8) >> 3));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 8) & 0xF8, 
-                              (p >> 3) & 0xFC, 
-                              (p << 3) & 0xF8);
-        }
-
-    private:
-        const Gamma* m_gamma;
-    };
-
-
-
-    //=====================================================blender_rgbAAA
-    struct blender_rgbAAA
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 14) & 0xFFC0;
-            calc_type g = (rgb >> 4)  & 0xFFC0;
-            calc_type b = (rgb << 6)  & 0xFFC0;
-            *p = (pixel_type)
-               (((((cr - r) * alpha + (r << 16)) >> 2)  & 0x3FF00000) |
-                ((((cg - g) * alpha + (g << 16)) >> 12) & 0x000FFC00) |
-                 (((cb - b) * alpha + (b << 16)) >> 22) | 0xC0000000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xFFC0) << 14) | 
-                                ((g & 0xFFC0) << 4) | 
-                                 (b >> 6) | 0xC0000000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 14) & 0xFFC0, 
-                              (p >> 4)  & 0xFFC0, 
-                              (p << 6)  & 0xFFC0);
-        }
-    };
-
-
-
-    //==================================================blender_rgbAAA_pre
-    struct blender_rgbAAA_pre
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            cover = (cover + 1) << (color_type::base_shift - 8);
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 14) & 0xFFC0;
-            calc_type g = (rgb >> 4)  & 0xFFC0;
-            calc_type b = (rgb << 6)  & 0xFFC0;
-            *p = (pixel_type)
-               ((((r * alpha + cr * cover) >> 2)  & 0x3FF00000) |
-                (((g * alpha + cg * cover) >> 12) & 0x000FFC00) |
-                 ((b * alpha + cb * cover) >> 22) | 0xC0000000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xFFC0) << 14) | 
-                                ((g & 0xFFC0) << 4) | 
-                                 (b >> 6) | 0xC0000000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 14) & 0xFFC0, 
-                              (p >> 4)  & 0xFFC0, 
-                              (p << 6)  & 0xFFC0);
-        }
-    };
-
-
-
-    //=================================================blender_rgbAAA_gamma
-    template<class Gamma> class blender_rgbAAA_gamma
-    {
-    public:
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-        typedef Gamma gamma_type;
-
-        blender_rgbAAA_gamma() : m_gamma(0) {}
-        void gamma(const gamma_type& g) { m_gamma = &g; }
-
-        AGG_INLINE void blend_pix(pixel_type* p, 
-                                  unsigned cr, unsigned cg, unsigned cb,
-                                  unsigned alpha, 
-                                  unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = m_gamma->dir((rgb >> 14) & 0xFFC0);
-            calc_type g = m_gamma->dir((rgb >> 4)  & 0xFFC0);
-            calc_type b = m_gamma->dir((rgb << 6)  & 0xFFC0);
-            *p = (pixel_type)
-               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) << 14) & 0x3FF00000) |
-                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 4 ) & 0x000FFC00) |
-                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) >> 6 ) | 0xC0000000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xFFC0) << 14) | 
-                                ((g & 0xFFC0) << 4) | 
-                                 (b >> 6) | 0xC0000000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 14) & 0xFFC0, 
-                              (p >> 4)  & 0xFFC0, 
-                              (p << 6)  & 0xFFC0);
-        }
-    private:
-        const Gamma* m_gamma;
-    };
-
-
-    //=====================================================blender_bgrAAA
-    struct blender_bgrAAA
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned)
-        {
-            pixel_type bgr = *p;
-            calc_type b = (bgr >> 14) & 0xFFC0;
-            calc_type g = (bgr >> 4)  & 0xFFC0;
-            calc_type r = (bgr << 6)  & 0xFFC0;
-            *p = (pixel_type)
-               (((((cb - b) * alpha + (b << 16)) >> 2)  & 0x3FF00000) |
-                ((((cg - g) * alpha + (g << 16)) >> 12) & 0x000FFC00) |
-                 (((cr - r) * alpha + (r << 16)) >> 22) | 0xC0000000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((b & 0xFFC0) << 14) | 
-                                ((g & 0xFFC0) << 4) | 
-                                 (r >> 6) | 0xC0000000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p << 6)  & 0xFFC0, 
-                              (p >> 4)  & 0xFFC0, 
-                              (p >> 14) & 0xFFC0);
-        }
-    };
-
-
-
-    //=================================================blender_bgrAAA_pre
-    struct blender_bgrAAA_pre
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            cover = (cover + 1) << (color_type::base_shift - 8);
-            pixel_type bgr = *p;
-            calc_type b = (bgr >> 14) & 0xFFC0;
-            calc_type g = (bgr >> 4)  & 0xFFC0;
-            calc_type r = (bgr << 6)  & 0xFFC0;
-            *p = (pixel_type)
-               ((((b * alpha + cb * cover) >> 2)  & 0x3FF00000) |
-                (((g * alpha + cg * cover) >> 12) & 0x000FFC00) |
-                 ((r * alpha + cr * cover) >> 22) | 0xC0000000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((b & 0xFFC0) << 14) | 
-                                ((g & 0xFFC0) << 4) | 
-                                 (r >> 6) | 0xC0000000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p << 6)  & 0xFFC0, 
-                              (p >> 4)  & 0xFFC0, 
-                              (p >> 14) & 0xFFC0);
-        }
-    };
-
-
-
-    //=================================================blender_bgrAAA_gamma
-    template<class Gamma> class blender_bgrAAA_gamma
-    {
-    public:
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-        typedef Gamma gamma_type;
-
-        blender_bgrAAA_gamma() : m_gamma(0) {}
-        void gamma(const gamma_type& g) { m_gamma = &g; }
-
-        AGG_INLINE void blend_pix(pixel_type* p, 
-                                  unsigned cr, unsigned cg, unsigned cb,
-                                  unsigned alpha, 
-                                  unsigned)
-        {
-            pixel_type bgr = *p;
-            calc_type b = m_gamma->dir((bgr >> 14) & 0xFFC0);
-            calc_type g = m_gamma->dir((bgr >> 4)  & 0xFFC0);
-            calc_type r = m_gamma->dir((bgr << 6)  & 0xFFC0);
-            *p = (pixel_type)
-               (((m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) << 14) & 0x3FF00000) |
-                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 4 ) & 0x000FFC00) |
-                 (m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) >> 6 ) | 0xC0000000);
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((b & 0xFFC0) << 14) | 
-                                ((g & 0xFFC0) << 4) | 
-                                 (r >> 6) | 0xC0000000);
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p << 6)  & 0xFFC0, 
-                              (p >> 4)  & 0xFFC0, 
-                              (p >> 14) & 0xFFC0);
-        }
-
-    private:
-        const Gamma* m_gamma;
-    };
-
-
-
-    //=====================================================blender_rgbBBA
-    struct blender_rgbBBA
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 16) & 0xFFE0;
-            calc_type g = (rgb >> 5)  & 0xFFE0;
-            calc_type b = (rgb << 6)  & 0xFFC0;
-            *p = (pixel_type)
-               (((((cr - r) * alpha + (r << 16))      ) & 0xFFE00000) |
-                ((((cg - g) * alpha + (g << 16)) >> 11) & 0x001FFC00) |
-                 (((cb - b) * alpha + (b << 16)) >> 22));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xFFE0) << 16) | ((g & 0xFFE0) << 5) | (b >> 6));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 16) & 0xFFE0, 
-                              (p >> 5)  & 0xFFE0, 
-                              (p << 6)  & 0xFFC0);
-        }
-    };
-
-
-    //=================================================blender_rgbBBA_pre
-    struct blender_rgbBBA_pre
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            cover = (cover + 1) << (color_type::base_shift - 8);
-            pixel_type rgb = *p;
-            calc_type r = (rgb >> 16) & 0xFFE0;
-            calc_type g = (rgb >> 5)  & 0xFFE0;
-            calc_type b = (rgb << 6)  & 0xFFC0;
-            *p = (pixel_type)
-               ((((r * alpha + cr * cover)      ) & 0xFFE00000) |
-                (((g * alpha + cg * cover) >> 11) & 0x001FFC00) |
-                 ((b * alpha + cb * cover) >> 22));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xFFE0) << 16) | ((g & 0xFFE0) << 5) | (b >> 6));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 16) & 0xFFE0, 
-                              (p >> 5)  & 0xFFE0, 
-                              (p << 6)  & 0xFFC0);
-        }
-    };
-
-
-
-    //=================================================blender_rgbBBA_gamma
-    template<class Gamma> class blender_rgbBBA_gamma
-    {
-    public:
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-        typedef Gamma gamma_type;
-
-        blender_rgbBBA_gamma() : m_gamma(0) {}
-        void gamma(const gamma_type& g) { m_gamma = &g; }
-
-        AGG_INLINE void blend_pix(pixel_type* p, 
-                                  unsigned cr, unsigned cg, unsigned cb,
-                                  unsigned alpha, 
-                                  unsigned)
-        {
-            pixel_type rgb = *p;
-            calc_type r = m_gamma->dir((rgb >> 16) & 0xFFE0);
-            calc_type g = m_gamma->dir((rgb >> 5)  & 0xFFE0);
-            calc_type b = m_gamma->dir((rgb << 6)  & 0xFFC0);
-            *p = (pixel_type)
-               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) << 16) & 0xFFE00000) |
-                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 5 ) & 0x001FFC00) |
-                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) >> 6 ));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((r & 0xFFE0) << 16) | ((g & 0xFFE0) << 5) | (b >> 6));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p >> 16) & 0xFFE0, 
-                              (p >> 5)  & 0xFFE0, 
-                              (p << 6)  & 0xFFC0);
-        }
-
-    private:
-        const Gamma* m_gamma;
-    };
-
-
-    //=====================================================blender_bgrABB
-    struct blender_bgrABB
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned)
-        {
-            pixel_type bgr = *p;
-            calc_type b = (bgr >> 16) & 0xFFC0;
-            calc_type g = (bgr >> 6)  & 0xFFE0;
-            calc_type r = (bgr << 5)  & 0xFFE0;
-            *p = (pixel_type)
-               (((((cb - b) * alpha + (b << 16))      ) & 0xFFC00000) |
-                ((((cg - g) * alpha + (g << 16)) >> 10) & 0x003FF800) |
-                 (((cr - r) * alpha + (r << 16)) >> 21));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((b & 0xFFC0) << 16) | ((g & 0xFFE0) << 6) | (r >> 5));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p << 5)  & 0xFFE0,
-                              (p >> 6)  & 0xFFE0, 
-                              (p >> 16) & 0xFFC0);
-        }
-    };
-
-
-    //=================================================blender_bgrABB_pre
-    struct blender_bgrABB_pre
-    {
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-
-        static AGG_INLINE void blend_pix(pixel_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            cover = (cover + 1) << (color_type::base_shift - 8);
-            pixel_type bgr = *p;
-            calc_type b = (bgr >> 16) & 0xFFC0;
-            calc_type g = (bgr >> 6)  & 0xFFE0;
-            calc_type r = (bgr << 5)  & 0xFFE0;
-            *p = (pixel_type)
-               ((((b * alpha + cb * cover)      ) & 0xFFC00000) |
-                (((g * alpha + cg * cover) >> 10) & 0x003FF800) |
-                 ((r * alpha + cr * cover) >> 21));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((b & 0xFFC0) << 16) | ((g & 0xFFE0) << 6) | (r >> 5));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p << 5)  & 0xFFE0,
-                              (p >> 6)  & 0xFFE0, 
-                              (p >> 16) & 0xFFC0);
-        }
-    };
-
-
-
-    //=================================================blender_bgrABB_gamma
-    template<class Gamma> class blender_bgrABB_gamma
-    {
-    public:
-        typedef rgba16 color_type;
-        typedef color_type::value_type value_type;
-        typedef color_type::calc_type calc_type;
-        typedef int32u pixel_type;
-        typedef Gamma gamma_type;
-
-        blender_bgrABB_gamma() : m_gamma(0) {}
-        void gamma(const gamma_type& g) { m_gamma = &g; }
-
-        AGG_INLINE void blend_pix(pixel_type* p, 
-                                  unsigned cr, unsigned cg, unsigned cb,
-                                  unsigned alpha, 
-                                  unsigned)
-        {
-            pixel_type bgr = *p;
-            calc_type b = m_gamma->dir((bgr >> 16) & 0xFFC0);
-            calc_type g = m_gamma->dir((bgr >> 6)  & 0xFFE0);
-            calc_type r = m_gamma->dir((bgr << 5)  & 0xFFE0);
-            *p = (pixel_type)
-               (((m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) << 16) & 0xFFC00000) |
-                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 6 ) & 0x003FF800) |
-                 (m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) >> 5 ));
-        }
-
-        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
-        {
-            return (pixel_type)(((b & 0xFFC0) << 16) | ((g & 0xFFE0) << 6) | (r >> 5));
-        }
-
-        static AGG_INLINE color_type make_color(pixel_type p)
-        {
-            return color_type((p << 5)  & 0xFFE0,
-                              (p >> 6)  & 0xFFE0, 
-                              (p >> 16) & 0xFFC0);
-        }
-
-    private:
-        const Gamma* m_gamma;
-    };
-
-
-    
-    //===========================================pixfmt_alpha_blend_rgb_packed
-    template<class Blender,  class RenBuf> class pixfmt_alpha_blend_rgb_packed
-    {
-    public:
-        typedef RenBuf   rbuf_type;
-        typedef typename rbuf_type::row_data row_data;
-        typedef Blender  blender_type;
-        typedef typename blender_type::color_type color_type;
-        typedef typename blender_type::pixel_type pixel_type;
-        typedef int                               order_type; // A fake one
-        typedef typename color_type::value_type   value_type;
-        typedef typename color_type::calc_type    calc_type;
-        enum base_scale_e 
-        {
-            base_shift = color_type::base_shift,
-            base_scale = color_type::base_scale,
-            base_mask  = color_type::base_mask,
-            pix_width  = sizeof(pixel_type)
-        };
-
-    private:
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_or_blend_pix(pixel_type* p, const color_type& c, unsigned cover)
-        {
-            if (c.a)
-            {
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    *p = m_blender.make_pix(c.r, c.g, c.b);
-                }
-                else
-                {
-                    m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
-                }
-            }
-        }
-
-    public:
-        //--------------------------------------------------------------------
-        explicit pixfmt_alpha_blend_rgb_packed(rbuf_type& rb) : m_rbuf(&rb) {}
-        void attach(rbuf_type& rb) { m_rbuf = &rb; }
-
-        //--------------------------------------------------------------------
-        template<class PixFmt>
-        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
-        {
-            rect_i r(x1, y1, x2, y2);
-            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
-            {
-                int stride = pixf.stride();
-                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
-                               (r.x2 - r.x1) + 1,
-                               (r.y2 - r.y1) + 1,
-                               stride);
-                return true;
-            }
-            return false;
-        }
-
-        Blender& blender() { return m_blender; }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
-        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
-        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
-        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
-        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE int8u* pix_ptr(int x, int y)
-        {
-            return m_rbuf->row_ptr(y) + x * pix_width;
-        }
-
-        AGG_INLINE const int8u* pix_ptr(int x, int y) const
-        {
-            return m_rbuf->row_ptr(y) + x * pix_width;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void make_pix(int8u* p, const color_type& c)
-        {
-            *(pixel_type*)p = m_blender.make_pix(c.r, c.g, c.b);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE color_type pixel(int x, int y) const
-        {
-            return m_blender.make_color(((pixel_type*)m_rbuf->row_ptr(y))[x]);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
-        {
-            ((pixel_type*)
-                m_rbuf->row_ptr(x, y, 1))[x] = 
-                    m_blender.make_pix(c.r, c.g, c.b);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
-        {
-            copy_or_blend_pix((pixel_type*)m_rbuf->row_ptr(x, y, 1) + x, c, cover);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_hline(int x, int y, 
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
-            pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
-            do
-            {
-                *p++ = v;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_vline(int x, int y,
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
-            do
-            {
-                pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x;
-                *p = v;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
-                    do
-                    {
-                        *p++ = v;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do
-                    {
-                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
-                        ++p;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
-                    do
-                    {
-                        ((pixel_type*)m_rbuf->row_ptr(x, y++, 1))[x] = v;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do
-                    {
-                        m_blender.blend_pix(
-                            (pixel_type*)m_rbuf->row_ptr(x, y++, 1), 
-                            c.r, c.g, c.b, alpha, cover);
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
-            do 
-            {
-                copy_or_blend_pix(p, c, *covers++);
-                ++p;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            do 
-            {
-                copy_or_blend_pix((pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x, 
-                                  c, *covers++);
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
-            do 
-            {
-                *p++ = m_blender.make_pix(colors->r, colors->g, colors->b);
-                ++colors;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_color_vspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            do 
-            {
-                pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x;
-                *p = m_blender.make_pix(colors->r, colors->g, colors->b);
-                ++colors;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
-            do 
-            {
-                copy_or_blend_pix(p++, *colors++, covers ? *covers++ : cover);
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            do 
-            {
-                copy_or_blend_pix((pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x, 
-                                  *colors++, covers ? *covers++ : cover);
-            }
-            while(--len);
-        }
-        
-        //--------------------------------------------------------------------
-        template<class RenBuf2>
-        void copy_from(const RenBuf2& from, 
-                       int xdst, int ydst,
-                       int xsrc, int ysrc,
-                       unsigned len)
-        {
-            const int8u* p = from.row_ptr(ysrc);
-            if(p)
-            {
-                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
-                        p + xsrc * pix_width, 
-                        len * pix_width);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from(const SrcPixelFormatRenderer& from, 
-                        int xdst, int ydst,
-                        int xsrc, int ysrc,
-                        unsigned len,
-                        int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::order_type src_order;
-
-            const value_type* psrc = (const value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                psrc += xsrc * 4;
-                pixel_type* pdst = 
-                    (pixel_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
-                do 
-                {
-                    value_type alpha = psrc[src_order::A];
-                    if(alpha)
-                    {
-                        if(alpha == base_mask && cover == 255)
-                        {
-                            *pdst = m_blender.make_pix(psrc[src_order::R], 
-                                                       psrc[src_order::G],
-                                                       psrc[src_order::B]);
-                        }
-                        else
-                        {
-                            m_blender.blend_pix(pdst, 
-                                                psrc[src_order::R],
-                                                psrc[src_order::G],
-                                                psrc[src_order::B],
-                                                alpha,
-                                                cover);
-                        }
-                    }
-                    psrc += 4;
-                    ++pdst;
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_color(const SrcPixelFormatRenderer& from, 
-                              const color_type& color,
-                              int xdst, int ydst,
-                              int xsrc, int ysrc,
-                              unsigned len,
-                              int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                pixel_type* pdst = 
-                    (pixel_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
-
-                do 
-                {
-                    m_blender.blend_pix(pdst, 
-                                        color.r, color.g, color.b, color.a,
-                                        cover);
-                    ++psrc;
-                    ++pdst;
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_lut(const SrcPixelFormatRenderer& from, 
-                            const color_type* color_lut,
-                            int xdst, int ydst,
-                            int xsrc, int ysrc,
-                            unsigned len,
-                            int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                pixel_type* pdst = 
-                    (pixel_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
-
-                do 
-                {
-                    const color_type& color = color_lut[*psrc];
-                    m_blender.blend_pix(pdst, 
-                                        color.r, color.g, color.b, color.a,
-                                        cover);
-                    ++psrc;
-                    ++pdst;
-                }
-                while(--len);
-            }
-        }
-
-
-
-    private:
-        rbuf_type* m_rbuf;
-        Blender    m_blender;
-    };
-
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb555, rendering_buffer> pixfmt_rgb555; //----pixfmt_rgb555
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb565, rendering_buffer> pixfmt_rgb565; //----pixfmt_rgb565
-
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb555_pre, rendering_buffer> pixfmt_rgb555_pre; //----pixfmt_rgb555_pre
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb565_pre, rendering_buffer> pixfmt_rgb565_pre; //----pixfmt_rgb565_pre
-
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbAAA, rendering_buffer> pixfmt_rgbAAA; //----pixfmt_rgbAAA
-    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrAAA, rendering_buffer> pixfmt_bgrAAA; //----pixfmt_bgrAAA
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbBBA, rendering_buffer> pixfmt_rgbBBA; //----pixfmt_rgbBBA
-    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrABB, rendering_buffer> pixfmt_bgrABB; //----pixfmt_bgrABB
-
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbAAA_pre, rendering_buffer> pixfmt_rgbAAA_pre; //----pixfmt_rgbAAA_pre
-    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrAAA_pre, rendering_buffer> pixfmt_bgrAAA_pre; //----pixfmt_bgrAAA_pre
-    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbBBA_pre, rendering_buffer> pixfmt_rgbBBA_pre; //----pixfmt_rgbBBA_pre
-    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrABB_pre, rendering_buffer> pixfmt_bgrABB_pre; //----pixfmt_bgrABB_pre
-
-
-    //-----------------------------------------------------pixfmt_rgb555_gamma
-    template<class Gamma> class pixfmt_rgb555_gamma : 
-    public pixfmt_alpha_blend_rgb_packed<blender_rgb555_gamma<Gamma>, 
-                                         rendering_buffer>
-    {
-    public:
-        pixfmt_rgb555_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb_packed<blender_rgb555_gamma<Gamma>, 
-                                          rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-
-    //-----------------------------------------------------pixfmt_rgb565_gamma
-    template<class Gamma> class pixfmt_rgb565_gamma : 
-    public pixfmt_alpha_blend_rgb_packed<blender_rgb565_gamma<Gamma>, rendering_buffer>
-    {
-    public:
-        pixfmt_rgb565_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb_packed<blender_rgb565_gamma<Gamma>, rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-
-    //-----------------------------------------------------pixfmt_rgbAAA_gamma
-    template<class Gamma> class pixfmt_rgbAAA_gamma : 
-    public pixfmt_alpha_blend_rgb_packed<blender_rgbAAA_gamma<Gamma>, 
-                                         rendering_buffer>
-    {
-    public:
-        pixfmt_rgbAAA_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb_packed<blender_rgbAAA_gamma<Gamma>, 
-                                          rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-
-    //-----------------------------------------------------pixfmt_bgrAAA_gamma
-    template<class Gamma> class pixfmt_bgrAAA_gamma : 
-    public pixfmt_alpha_blend_rgb_packed<blender_bgrAAA_gamma<Gamma>, 
-                                         rendering_buffer>
-    {
-    public:
-        pixfmt_bgrAAA_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb_packed<blender_bgrAAA_gamma<Gamma>, 
-                                          rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-
-    //-----------------------------------------------------pixfmt_rgbBBA_gamma
-    template<class Gamma> class pixfmt_rgbBBA_gamma : 
-    public pixfmt_alpha_blend_rgb_packed<blender_rgbBBA_gamma<Gamma>, 
-                                         rendering_buffer>
-    {
-    public:
-        pixfmt_rgbBBA_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb_packed<blender_rgbBBA_gamma<Gamma>, 
-                                          rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-
-    //-----------------------------------------------------pixfmt_bgrABB_gamma
-    template<class Gamma> class pixfmt_bgrABB_gamma : 
-    public pixfmt_alpha_blend_rgb_packed<blender_bgrABB_gamma<Gamma>, 
-                                         rendering_buffer>
-    {
-    public:
-        pixfmt_bgrABB_gamma(rendering_buffer& rb, const Gamma& g) :
-            pixfmt_alpha_blend_rgb_packed<blender_bgrABB_gamma<Gamma>, 
-                                          rendering_buffer>(rb) 
-        {
-            this->blender().gamma(g);
-        }
-    };
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_pixfmt_rgba.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_rgba.h
--- 8.0.1-5/renderers/agg/include/agg_pixfmt_rgba.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_rgba.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,2902 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PIXFMT_RGBA_INCLUDED
-#define AGG_PIXFMT_RGBA_INCLUDED
-
-#include <string.h>
-#include <math.h>
-#include "agg_basics.h"
-#include "agg_color_rgba.h"
-#include "agg_rendering_buffer.h"
-
-namespace mapserver
-{
-
-    //=========================================================multiplier_rgba
-    template<class ColorT, class Order> struct multiplier_rgba
-    {
-        typedef typename ColorT::value_type value_type;
-        typedef typename ColorT::calc_type calc_type;
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void premultiply(value_type* p)
-        {
-            calc_type a = p[Order::A];
-            if(a < ColorT::base_mask)
-            {
-                if(a == 0)
-                {
-                    p[Order::R] = p[Order::G] = p[Order::B] = 0;
-                    return;
-                }
-                p[Order::R] = value_type((p[Order::R] * a + ColorT::base_mask) >> ColorT::base_shift);
-                p[Order::G] = value_type((p[Order::G] * a + ColorT::base_mask) >> ColorT::base_shift);
-                p[Order::B] = value_type((p[Order::B] * a + ColorT::base_mask) >> ColorT::base_shift);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void demultiply(value_type* p)
-        {
-            calc_type a = p[Order::A];
-            if(a < ColorT::base_mask)
-            {
-                if(a == 0)
-                {
-                    p[Order::R] = p[Order::G] = p[Order::B] = 0;
-                    return;
-                }
-                calc_type r = (calc_type(p[Order::R]) * ColorT::base_mask) / a;
-                calc_type g = (calc_type(p[Order::G]) * ColorT::base_mask) / a;
-                calc_type b = (calc_type(p[Order::B]) * ColorT::base_mask) / a;
-                p[Order::R] = value_type((r > ColorT::base_mask) ? ColorT::base_mask : r);
-                p[Order::G] = value_type((g > ColorT::base_mask) ? ColorT::base_mask : g);
-                p[Order::B] = value_type((b > ColorT::base_mask) ? ColorT::base_mask : b);
-            }
-        }
-    };
-
-    //=====================================================apply_gamma_dir_rgba
-    template<class ColorT, class Order, class GammaLut> class apply_gamma_dir_rgba
-    {
-    public:
-        typedef typename ColorT::value_type value_type;
-
-        apply_gamma_dir_rgba(const GammaLut& gamma) : m_gamma(gamma) {}
-
-        AGG_INLINE void operator () (value_type* p)
-        {
-            p[Order::R] = m_gamma.dir(p[Order::R]);
-            p[Order::G] = m_gamma.dir(p[Order::G]);
-            p[Order::B] = m_gamma.dir(p[Order::B]);
-        }
-
-    private:
-        const GammaLut& m_gamma;
-    };
-
-    //=====================================================apply_gamma_inv_rgba
-    template<class ColorT, class Order, class GammaLut> class apply_gamma_inv_rgba
-    {
-    public:
-        typedef typename ColorT::value_type value_type;
-
-        apply_gamma_inv_rgba(const GammaLut& gamma) : m_gamma(gamma) {}
-
-        AGG_INLINE void operator () (value_type* p)
-        {
-            p[Order::R] = m_gamma.inv(p[Order::R]);
-            p[Order::G] = m_gamma.inv(p[Order::G]);
-            p[Order::B] = m_gamma.inv(p[Order::B]);
-        }
-
-    private:
-        const GammaLut& m_gamma;
-    };
-
-
-    
-
-
-
-
-
-
-
-    //=============================================================blender_rgba
-    template<class ColorT, class Order> struct blender_rgba
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e 
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha, 
-                                         unsigned cover=0)
-        {
-            calc_type r = p[Order::R];
-            calc_type g = p[Order::G];
-            calc_type b = p[Order::B];
-            calc_type a = p[Order::A];
-            p[Order::R] = (value_type)(((cr - r) * alpha + (r << base_shift)) >> base_shift);
-            p[Order::G] = (value_type)(((cg - g) * alpha + (g << base_shift)) >> base_shift);
-            p[Order::B] = (value_type)(((cb - b) * alpha + (b << base_shift)) >> base_shift);
-            p[Order::A] = (value_type)((alpha + a) - ((alpha * a + base_mask) >> base_shift));
-        }
-    };
-
-    //=========================================================blender_rgba_pre
-    template<class ColorT, class Order> struct blender_rgba_pre
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha,
-                                         unsigned cover)
-        {
-            alpha = color_type::base_mask - alpha;
-            cover = (cover + 1) << (base_shift - 8);
-            p[Order::R] = (value_type)((p[Order::R] * alpha + cr * cover) >> base_shift);
-            p[Order::G] = (value_type)((p[Order::G] * alpha + cg * cover) >> base_shift);
-            p[Order::B] = (value_type)((p[Order::B] * alpha + cb * cover) >> base_shift);
-            p[Order::A] = (value_type)(base_mask - ((alpha * (base_mask - p[Order::A])) >> base_shift));
-        }
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha)
-        {
-            alpha = color_type::base_mask - alpha;
-            p[Order::R] = (value_type)(((p[Order::R] * alpha) >> base_shift) + cr);
-            p[Order::G] = (value_type)(((p[Order::G] * alpha) >> base_shift) + cg);
-            p[Order::B] = (value_type)(((p[Order::B] * alpha) >> base_shift) + cb);
-            p[Order::A] = (value_type)(base_mask - ((alpha * (base_mask - p[Order::A])) >> base_shift));
-        }
-    };
-
-    //======================================================blender_rgba_plain
-    template<class ColorT, class Order> struct blender_rgba_plain
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e { base_shift = color_type::base_shift };
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned alpha,
-                                         unsigned cover=0)
-        {
-            if(alpha == 0) return;
-            calc_type a = p[Order::A];
-            calc_type r = p[Order::R] * a;
-            calc_type g = p[Order::G] * a;
-            calc_type b = p[Order::B] * a;
-            a = ((alpha + a) << base_shift) - alpha * a;
-            p[Order::A] = (value_type)(a >> base_shift);
-            p[Order::R] = (value_type)((((cr << base_shift) - r) * alpha + (r << base_shift)) / a);
-            p[Order::G] = (value_type)((((cg << base_shift) - g) * alpha + (g << base_shift)) / a);
-            p[Order::B] = (value_type)((((cb << base_shift) - b) * alpha + (b << base_shift)) / a);
-        }
-    };
-
-
-
-
-
-
-
-
-
-
-
-    //=========================================================comp_op_rgba_clear
-    template<class ColorT, class Order> struct comp_op_rgba_clear
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned, unsigned, unsigned, unsigned,
-                                         unsigned cover)
-        {
-            if(cover < 255)
-            {
-                cover = 255 - cover;
-                p[Order::R] = (value_type)((p[Order::R] * cover + 255) >> 8);
-                p[Order::G] = (value_type)((p[Order::G] * cover + 255) >> 8);
-                p[Order::B] = (value_type)((p[Order::B] * cover + 255) >> 8);
-                p[Order::A] = (value_type)((p[Order::A] * cover + 255) >> 8);
-            }
-            else
-            {
-                p[0] = p[1] = p[2] = p[3] = 0; 
-            }
-        }
-    };
-
-    //===========================================================comp_op_rgba_src
-    template<class ColorT, class Order> struct comp_op_rgba_src
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                unsigned alpha = 255 - cover;
-                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((sr * cover + 255) >> 8));
-                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((sg * cover + 255) >> 8));
-                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((sb * cover + 255) >> 8));
-                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((sa * cover + 255) >> 8));
-            }
-            else
-            {
-                p[Order::R] = sr;
-                p[Order::G] = sg;
-                p[Order::B] = sb;
-                p[Order::A] = sa;
-            }
-        }
-    };
-
-    //===========================================================comp_op_rgba_dst
-    template<class ColorT, class Order> struct comp_op_rgba_dst
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-
-        static AGG_INLINE void blend_pix(value_type*, 
-                                         unsigned, unsigned, unsigned, 
-                                         unsigned, unsigned)
-        {
-        }
-    };
-
-    //======================================================comp_op_rgba_src_over
-    template<class ColorT, class Order> struct comp_op_rgba_src_over
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //   Dca' = Sca + Dca.(1 - Sa)
-        //   Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            calc_type s1a = base_mask - sa;
-            p[Order::R] = (value_type)(sr + ((p[Order::R] * s1a + base_mask) >> base_shift));
-            p[Order::G] = (value_type)(sg + ((p[Order::G] * s1a + base_mask) >> base_shift));
-            p[Order::B] = (value_type)(sb + ((p[Order::B] * s1a + base_mask) >> base_shift));
-            p[Order::A] = (value_type)(sa + ((p[Order::A] * s1a + base_mask) >> base_shift));
-        }
-    };
-
-    //======================================================comp_op_rgba_dst_over
-    template<class ColorT, class Order> struct comp_op_rgba_dst_over
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Dca + Sca.(1 - Da)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            calc_type d1a = base_mask - p[Order::A];
-            p[Order::R] = (value_type)(p[Order::R] + ((sr * d1a + base_mask) >> base_shift));
-            p[Order::G] = (value_type)(p[Order::G] + ((sg * d1a + base_mask) >> base_shift));
-            p[Order::B] = (value_type)(p[Order::B] + ((sb * d1a + base_mask) >> base_shift));
-            p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask) >> base_shift));
-        }
-    };
-
-    //======================================================comp_op_rgba_src_in
-    template<class ColorT, class Order> struct comp_op_rgba_src_in
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca.Da
-        // Da'  = Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            calc_type da = p[Order::A];
-            if(cover < 255)
-            {
-                unsigned alpha = 255 - cover;
-                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((((sr * da + base_mask) >> base_shift) * cover + 255) >> 8));
-                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((((sg * da + base_mask) >> base_shift) * cover + 255) >> 8));
-                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((((sb * da + base_mask) >> base_shift) * cover + 255) >> 8));
-                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((((sa * da + base_mask) >> base_shift) * cover + 255) >> 8));
-            }
-            else
-            {
-                p[Order::R] = (value_type)((sr * da + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((sg * da + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((sb * da + base_mask) >> base_shift);
-                p[Order::A] = (value_type)((sa * da + base_mask) >> base_shift);
-            }
-        }
-    };
-
-    //======================================================comp_op_rgba_dst_in
-    template<class ColorT, class Order> struct comp_op_rgba_dst_in
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Dca.Sa
-        // Da'  = Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned, unsigned, unsigned, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sa = base_mask - ((cover * (base_mask - sa) + 255) >> 8);
-            }
-            p[Order::R] = (value_type)((p[Order::R] * sa + base_mask) >> base_shift);
-            p[Order::G] = (value_type)((p[Order::G] * sa + base_mask) >> base_shift);
-            p[Order::B] = (value_type)((p[Order::B] * sa + base_mask) >> base_shift);
-            p[Order::A] = (value_type)((p[Order::A] * sa + base_mask) >> base_shift);
-        }
-    };
-
-    //======================================================comp_op_rgba_src_out
-    template<class ColorT, class Order> struct comp_op_rgba_src_out
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca.(1 - Da)
-        // Da'  = Sa.(1 - Da) 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            calc_type da = base_mask - p[Order::A];
-            if(cover < 255)
-            {
-                unsigned alpha = 255 - cover;
-                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((((sr * da + base_mask) >> base_shift) * cover + 255) >> 8));
-                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((((sg * da + base_mask) >> base_shift) * cover + 255) >> 8));
-                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((((sb * da + base_mask) >> base_shift) * cover + 255) >> 8));
-                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((((sa * da + base_mask) >> base_shift) * cover + 255) >> 8));
-            }
-            else
-            {
-                p[Order::R] = (value_type)((sr * da + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((sg * da + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((sb * da + base_mask) >> base_shift);
-                p[Order::A] = (value_type)((sa * da + base_mask) >> base_shift);
-            }
-        }
-    };
-
-    //======================================================comp_op_rgba_dst_out
-    template<class ColorT, class Order> struct comp_op_rgba_dst_out
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Dca.(1 - Sa) 
-        // Da'  = Da.(1 - Sa) 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned, unsigned, unsigned, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sa = (sa * cover + 255) >> 8;
-            }
-            sa = base_mask - sa;
-            p[Order::R] = (value_type)((p[Order::R] * sa + base_shift) >> base_shift);
-            p[Order::G] = (value_type)((p[Order::G] * sa + base_shift) >> base_shift);
-            p[Order::B] = (value_type)((p[Order::B] * sa + base_shift) >> base_shift);
-            p[Order::A] = (value_type)((p[Order::A] * sa + base_shift) >> base_shift);
-        }
-    };
-
-    //=====================================================comp_op_rgba_src_atop
-    template<class ColorT, class Order> struct comp_op_rgba_src_atop
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca.Da + Dca.(1 - Sa)
-        // Da'  = Da
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            calc_type da = p[Order::A];
-            sa = base_mask - sa;
-            p[Order::R] = (value_type)((sr * da + p[Order::R] * sa + base_mask) >> base_shift);
-            p[Order::G] = (value_type)((sg * da + p[Order::G] * sa + base_mask) >> base_shift);
-            p[Order::B] = (value_type)((sb * da + p[Order::B] * sa + base_mask) >> base_shift);
-        }
-    };
-
-    //=====================================================comp_op_rgba_dst_atop
-    template<class ColorT, class Order> struct comp_op_rgba_dst_atop
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Dca.Sa + Sca.(1 - Da)
-        // Da'  = Sa 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            calc_type da = base_mask - p[Order::A];
-            if(cover < 255)
-            {
-                unsigned alpha = 255 - cover;
-                sr = (p[Order::R] * sa + sr * da + base_mask) >> base_shift;
-                sg = (p[Order::G] * sa + sg * da + base_mask) >> base_shift;
-                sb = (p[Order::B] * sa + sb * da + base_mask) >> base_shift;
-                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((sr * cover + 255) >> 8));
-                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((sg * cover + 255) >> 8));
-                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((sb * cover + 255) >> 8));
-                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((sa * cover + 255) >> 8));
-
-            }
-            else
-            {
-                p[Order::R] = (value_type)((p[Order::R] * sa + sr * da + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((p[Order::G] * sa + sg * da + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((p[Order::B] * sa + sb * da + base_mask) >> base_shift);
-                p[Order::A] = (value_type)sa;
-            }
-        }
-    };
-
-    //=========================================================comp_op_rgba_xor
-    template<class ColorT, class Order> struct comp_op_rgba_xor
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca.(1 - Da) + Dca.(1 - Sa)
-        // Da'  = Sa + Da - 2.Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type s1a = base_mask - sa;
-                calc_type d1a = base_mask - p[Order::A];
-                p[Order::R] = (value_type)((p[Order::R] * s1a + sr * d1a + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((p[Order::G] * s1a + sg * d1a + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((p[Order::B] * s1a + sb * d1a + base_mask) >> base_shift);
-                p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask/2) >> (base_shift - 1)));
-            }
-        }
-    };
-
-    //=========================================================comp_op_rgba_plus
-    template<class ColorT, class Order> struct comp_op_rgba_plus
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca + Dca
-        // Da'  = Sa + Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type dr = p[Order::R] + sr;
-                calc_type dg = p[Order::G] + sg;
-                calc_type db = p[Order::B] + sb;
-                calc_type da = p[Order::A] + sa;
-                p[Order::R] = (dr > base_mask) ? (value_type)base_mask : dr;
-                p[Order::G] = (dg > base_mask) ? (value_type)base_mask : dg;
-                p[Order::B] = (db > base_mask) ? (value_type)base_mask : db;
-                p[Order::A] = (da > base_mask) ? (value_type)base_mask : da;
-            }
-        }
-    };
-
-    //========================================================comp_op_rgba_minus
-    template<class ColorT, class Order> struct comp_op_rgba_minus
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Dca - Sca
-        // Da' = 1 - (1 - Sa).(1 - Da)
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type dr = p[Order::R] - sr;
-                calc_type dg = p[Order::G] - sg;
-                calc_type db = p[Order::B] - sb;
-                p[Order::R] = (dr > base_mask) ? 0 : dr;
-                p[Order::G] = (dg > base_mask) ? 0 : dg;
-                p[Order::B] = (db > base_mask) ? 0 : db;
-                p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask) >> base_shift));
-                //p[Order::A] = (value_type)(base_mask - (((base_mask - sa) * (base_mask - p[Order::A]) + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_multiply
-    template<class ColorT, class Order> struct comp_op_rgba_multiply
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca.Dca + Sca.(1 - Da) + Dca.(1 - Sa)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type s1a = base_mask - sa;
-                calc_type d1a = base_mask - p[Order::A];
-                calc_type dr = p[Order::R];
-                calc_type dg = p[Order::G];
-                calc_type db = p[Order::B];
-                p[Order::R] = (value_type)((sr * dr + sr * d1a + dr * s1a + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((sg * dg + sg * d1a + dg * s1a + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((sb * db + sb * d1a + db * s1a + base_mask) >> base_shift);
-                p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_screen
-    template<class ColorT, class Order> struct comp_op_rgba_screen
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca + Dca - Sca.Dca
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type dr = p[Order::R];
-                calc_type dg = p[Order::G];
-                calc_type db = p[Order::B];
-                calc_type da = p[Order::A];
-                p[Order::R] = (value_type)(sr + dr - ((sr * dr + base_mask) >> base_shift));
-                p[Order::G] = (value_type)(sg + dg - ((sg * dg + base_mask) >> base_shift));
-                p[Order::B] = (value_type)(sb + db - ((sb * db + base_mask) >> base_shift));
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_overlay
-    template<class ColorT, class Order> struct comp_op_rgba_overlay
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // if 2.Dca < Da
-        //   Dca' = 2.Sca.Dca + Sca.(1 - Da) + Dca.(1 - Sa)
-        // otherwise
-        //   Dca' = Sa.Da - 2.(Da - Dca).(Sa - Sca) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // 
-        // Da' = Sa + Da - Sa.Da
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type d1a  = base_mask - p[Order::A];
-                calc_type s1a  = base_mask - sa;
-                calc_type dr   = p[Order::R];
-                calc_type dg   = p[Order::G];
-                calc_type db   = p[Order::B];
-                calc_type da   = p[Order::A];
-                calc_type sada = sa * p[Order::A];
-
-                p[Order::R] = (value_type)(((2*dr < da) ? 
-                    2*sr*dr + sr*d1a + dr*s1a : 
-                    sada - 2*(da - dr)*(sa - sr) + sr*d1a + dr*s1a + base_mask) >> base_shift);
-
-                p[Order::G] = (value_type)(((2*dg < da) ? 
-                    2*sg*dg + sg*d1a + dg*s1a : 
-                    sada - 2*(da - dg)*(sa - sg) + sg*d1a + dg*s1a + base_mask) >> base_shift);
-
-                p[Order::B] = (value_type)(((2*db < da) ? 
-                    2*sb*db + sb*d1a + db*s1a : 
-                    sada - 2*(da - db)*(sa - sb) + sb*d1a + db*s1a + base_mask) >> base_shift);
-
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-
-    template<class T> inline T sd_min(T a, T b) { return (a < b) ? a : b; }
-    template<class T> inline T sd_max(T a, T b) { return (a > b) ? a : b; }
-
-    //=====================================================comp_op_rgba_darken
-    template<class ColorT, class Order> struct comp_op_rgba_darken
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = min(Sca.Da, Dca.Sa) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type d1a = base_mask - p[Order::A];
-                calc_type s1a = base_mask - sa;
-                calc_type dr  = p[Order::R];
-                calc_type dg  = p[Order::G];
-                calc_type db  = p[Order::B];
-                calc_type da  = p[Order::A];
-
-                p[Order::R] = (value_type)((sd_min(sr * da, dr * sa) + sr * d1a + dr * s1a + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((sd_min(sg * da, dg * sa) + sg * d1a + dg * s1a + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((sd_min(sb * da, db * sa) + sb * d1a + db * s1a + base_mask) >> base_shift);
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_lighten
-    template<class ColorT, class Order> struct comp_op_rgba_lighten
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = max(Sca.Da, Dca.Sa) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type d1a = base_mask - p[Order::A];
-                calc_type s1a = base_mask - sa;
-                calc_type dr  = p[Order::R];
-                calc_type dg  = p[Order::G];
-                calc_type db  = p[Order::B];
-                calc_type da  = p[Order::A];
-
-                p[Order::R] = (value_type)((sd_max(sr * da, dr * sa) + sr * d1a + dr * s1a + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((sd_max(sg * da, dg * sa) + sg * d1a + dg * s1a + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((sd_max(sb * da, db * sa) + sb * d1a + db * s1a + base_mask) >> base_shift);
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_color_dodge
-    template<class ColorT, class Order> struct comp_op_rgba_color_dodge
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // if Sca.Da + Dca.Sa >= Sa.Da
-        //   Dca' = Sa.Da + Sca.(1 - Da) + Dca.(1 - Sa)
-        // otherwise
-        //   Dca' = Dca.Sa/(1-Sca/Sa) + Sca.(1 - Da) + Dca.(1 - Sa)
-        //
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type d1a  = base_mask - p[Order::A];
-                calc_type s1a  = base_mask - sa;
-                calc_type dr   = p[Order::R];
-                calc_type dg   = p[Order::G];
-                calc_type db   = p[Order::B];
-                calc_type da   = p[Order::A];
-                long_type drsa = dr * sa;
-                long_type dgsa = dg * sa;
-                long_type dbsa = db * sa;
-                long_type srda = sr * da;
-                long_type sgda = sg * da;
-                long_type sbda = sb * da;
-                long_type sada = sa * da;
-
-                p[Order::R] = (value_type)((srda + drsa >= sada) ? 
-                    (sada + sr * d1a + dr * s1a + base_mask) >> base_shift :
-                    drsa / (base_mask - (sr << base_shift) / sa) + ((sr * d1a + dr * s1a + base_mask) >> base_shift));
-
-                p[Order::G] = (value_type)((sgda + dgsa >= sada) ? 
-                    (sada + sg * d1a + dg * s1a + base_mask) >> base_shift :
-                    dgsa / (base_mask - (sg << base_shift) / sa) + ((sg * d1a + dg * s1a + base_mask) >> base_shift));
-
-                p[Order::B] = (value_type)((sbda + dbsa >= sada) ? 
-                    (sada + sb * d1a + db * s1a + base_mask) >> base_shift :
-                    dbsa / (base_mask - (sb << base_shift) / sa) + ((sb * d1a + db * s1a + base_mask) >> base_shift));
-
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_color_burn
-    template<class ColorT, class Order> struct comp_op_rgba_color_burn
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // if Sca.Da + Dca.Sa <= Sa.Da
-        //   Dca' = Sca.(1 - Da) + Dca.(1 - Sa)
-        // otherwise
-        //   Dca' = Sa.(Sca.Da + Dca.Sa - Sa.Da)/Sca + Sca.(1 - Da) + Dca.(1 - Sa)
-        // 
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type d1a  = base_mask - p[Order::A];
-                calc_type s1a  = base_mask - sa;
-                calc_type dr   = p[Order::R];
-                calc_type dg   = p[Order::G];
-                calc_type db   = p[Order::B];
-                calc_type da   = p[Order::A];
-                long_type drsa = dr * sa;
-                long_type dgsa = dg * sa;
-                long_type dbsa = db * sa;
-                long_type srda = sr * da;
-                long_type sgda = sg * da;
-                long_type sbda = sb * da;
-                long_type sada = sa * da;
-
-                p[Order::R] = (value_type)(((srda + drsa <= sada) ? 
-                    sr * d1a + dr * s1a :
-                    sa * (srda + drsa - sada) / sr + sr * d1a + dr * s1a + base_mask) >> base_shift);
-
-                p[Order::G] = (value_type)(((sgda + dgsa <= sada) ? 
-                    sg * d1a + dg * s1a :
-                    sa * (sgda + dgsa - sada) / sg + sg * d1a + dg * s1a + base_mask) >> base_shift);
-
-                p[Order::B] = (value_type)(((sbda + dbsa <= sada) ? 
-                    sb * d1a + db * s1a :
-                    sa * (sbda + dbsa - sada) / sb + sb * d1a + db * s1a + base_mask) >> base_shift);
-
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_hard_light
-    template<class ColorT, class Order> struct comp_op_rgba_hard_light
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // if 2.Sca < Sa
-        //    Dca' = 2.Sca.Dca + Sca.(1 - Da) + Dca.(1 - Sa)
-        // otherwise
-        //    Dca' = Sa.Da - 2.(Da - Dca).(Sa - Sca) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // 
-        // Da'  = Sa + Da - Sa.Da
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type d1a  = base_mask - p[Order::A];
-                calc_type s1a  = base_mask - sa;
-                calc_type dr   = p[Order::R];
-                calc_type dg   = p[Order::G];
-                calc_type db   = p[Order::B];
-                calc_type da   = p[Order::A];
-                calc_type sada = sa * da;
-
-                p[Order::R] = (value_type)(((2*sr < sa) ? 
-                    2*sr*dr + sr*d1a + dr*s1a : 
-                    sada - 2*(da - dr)*(sa - sr) + sr*d1a + dr*s1a + base_mask) >> base_shift);
-
-                p[Order::G] = (value_type)(((2*sg < sa) ? 
-                    2*sg*dg + sg*d1a + dg*s1a : 
-                    sada - 2*(da - dg)*(sa - sg) + sg*d1a + dg*s1a + base_mask) >> base_shift);
-
-                p[Order::B] = (value_type)(((2*sb < sa) ? 
-                    2*sb*db + sb*d1a + db*s1a : 
-                    sada - 2*(da - db)*(sa - sb) + sb*d1a + db*s1a + base_mask) >> base_shift);
-
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_soft_light
-    template<class ColorT, class Order> struct comp_op_rgba_soft_light
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // if 2.Sca < Sa
-        //   Dca' = Dca.(Sa + (1 - Dca/Da).(2.Sca - Sa)) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // otherwise if 8.Dca <= Da
-        //   Dca' = Dca.(Sa + (1 - Dca/Da).(2.Sca - Sa).(3 - 8.Dca/Da)) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // otherwise
-        //   Dca' = (Dca.Sa + ((Dca/Da)^(0.5).Da - Dca).(2.Sca - Sa)) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // 
-        // Da'  = Sa + Da - Sa.Da 
-
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned r, unsigned g, unsigned b, 
-                                         unsigned a, unsigned cover)
-        {
-            double sr = double(r * cover) / (base_mask * 255);
-            double sg = double(g * cover) / (base_mask * 255);
-            double sb = double(b * cover) / (base_mask * 255);
-            double sa = double(a * cover) / (base_mask * 255);
-            if(sa > 0)
-            {
-                double dr = double(p[Order::R]) / base_mask;
-                double dg = double(p[Order::G]) / base_mask;
-                double db = double(p[Order::B]) / base_mask;
-                double da = double(p[Order::A] ? p[Order::A] : 1) / base_mask;
-                if(cover < 255)
-                {
-                    a = (a * cover + 255) >> 8;
-                }
-
-                if(2*sr < sa)       dr = dr*(sa + (1 - dr/da)*(2*sr - sa)) + sr*(1 - da) + dr*(1 - sa);
-                else if(8*dr <= da) dr = dr*(sa + (1 - dr/da)*(2*sr - sa)*(3 - 8*dr/da)) + sr*(1 - da) + dr*(1 - sa);
-                else                dr = (dr*sa + (sqrt(dr/da)*da - dr)*(2*sr - sa)) + sr*(1 - da) + dr*(1 - sa);
-
-                if(2*sg < sa)       dg = dg*(sa + (1 - dg/da)*(2*sg - sa)) + sg*(1 - da) + dg*(1 - sa);
-                else if(8*dg <= da) dg = dg*(sa + (1 - dg/da)*(2*sg - sa)*(3 - 8*dg/da)) + sg*(1 - da) + dg*(1 - sa);
-                else                dg = (dg*sa + (sqrt(dg/da)*da - dg)*(2*sg - sa)) + sg*(1 - da) + dg*(1 - sa);
-
-                if(2*sb < sa)       db = db*(sa + (1 - db/da)*(2*sb - sa)) + sb*(1 - da) + db*(1 - sa);
-                else if(8*db <= da) db = db*(sa + (1 - db/da)*(2*sb - sa)*(3 - 8*db/da)) + sb*(1 - da) + db*(1 - sa);
-                else                db = (db*sa + (sqrt(db/da)*da - db)*(2*sb - sa)) + sb*(1 - da) + db*(1 - sa);
-
-                p[Order::R] = (value_type)uround(dr * base_mask);
-                p[Order::G] = (value_type)uround(dg * base_mask);
-                p[Order::B] = (value_type)uround(db * base_mask);
-                p[Order::A] = (value_type)(a + p[Order::A] - ((a * p[Order::A] + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_difference
-    template<class ColorT, class Order> struct comp_op_rgba_difference
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_scale = color_type::base_scale,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = Sca + Dca - 2.min(Sca.Da, Dca.Sa)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type dr = p[Order::R];
-                calc_type dg = p[Order::G];
-                calc_type db = p[Order::B];
-                calc_type da = p[Order::A];
-                p[Order::R] = (value_type)(sr + dr - ((2 * sd_min(sr*da, dr*sa) + base_mask) >> base_shift));
-                p[Order::G] = (value_type)(sg + dg - ((2 * sd_min(sg*da, dg*sa) + base_mask) >> base_shift));
-                p[Order::B] = (value_type)(sb + db - ((2 * sd_min(sb*da, db*sa) + base_mask) >> base_shift));
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_exclusion
-    template<class ColorT, class Order> struct comp_op_rgba_exclusion
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = (Sca.Da + Dca.Sa - 2.Sca.Dca) + Sca.(1 - Da) + Dca.(1 - Sa)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type d1a = base_mask - p[Order::A];
-                calc_type s1a = base_mask - sa;
-                calc_type dr = p[Order::R];
-                calc_type dg = p[Order::G];
-                calc_type db = p[Order::B];
-                calc_type da = p[Order::A];
-                p[Order::R] = (value_type)((sr*da + dr*sa - 2*sr*dr + sr*d1a + dr*s1a + base_mask) >> base_shift);
-                p[Order::G] = (value_type)((sg*da + dg*sa - 2*sg*dg + sg*d1a + dg*s1a + base_mask) >> base_shift);
-                p[Order::B] = (value_type)((sb*da + db*sa - 2*sb*db + sb*d1a + db*s1a + base_mask) >> base_shift);
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=====================================================comp_op_rgba_contrast
-    template<class ColorT, class Order> struct comp_op_rgba_contrast
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            long_type dr = p[Order::R];
-            long_type dg = p[Order::G];
-            long_type db = p[Order::B];
-            int       da = p[Order::A];
-            long_type d2a = da >> 1;
-            unsigned s2a = sa >> 1;
-
-            int r = (int)((((dr - d2a) * int((sr - s2a)*2 + base_mask)) >> base_shift) + d2a); 
-            int g = (int)((((dg - d2a) * int((sg - s2a)*2 + base_mask)) >> base_shift) + d2a); 
-            int b = (int)((((db - d2a) * int((sb - s2a)*2 + base_mask)) >> base_shift) + d2a); 
-
-            r = (r < 0) ? 0 : r;
-            g = (g < 0) ? 0 : g;
-            b = (b < 0) ? 0 : b;
-
-            p[Order::R] = (value_type)((r > da) ? da : r);
-            p[Order::G] = (value_type)((g > da) ? da : g);
-            p[Order::B] = (value_type)((b > da) ? da : b);
-        }
-    };
-
-    //=====================================================comp_op_rgba_invert
-    template<class ColorT, class Order> struct comp_op_rgba_invert
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = (Da - Dca) * Sa + Dca.(1 - Sa)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned /*sr*/, unsigned /*sg*/, unsigned /*sb*/, 
-                                         unsigned sa, unsigned cover)
-        {
-            sa = (sa * cover + 255) >> 8;
-            if(sa)
-            {
-                calc_type da = p[Order::A];
-                calc_type dr = ((da - p[Order::R]) * sa + base_mask) >> base_shift;
-                calc_type dg = ((da - p[Order::G]) * sa + base_mask) >> base_shift;
-                calc_type db = ((da - p[Order::B]) * sa + base_mask) >> base_shift;
-                calc_type s1a = base_mask - sa;
-                p[Order::R] = (value_type)(dr + ((p[Order::R] * s1a + base_mask) >> base_shift));
-                p[Order::G] = (value_type)(dg + ((p[Order::G] * s1a + base_mask) >> base_shift));
-                p[Order::B] = (value_type)(db + ((p[Order::B] * s1a + base_mask) >> base_shift));
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-    //=================================================comp_op_rgba_invert_rgb
-    template<class ColorT, class Order> struct comp_op_rgba_invert_rgb
-    {
-        typedef ColorT color_type;
-        typedef Order order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        { 
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        // Dca' = (Da - Dca) * Sca + Dca.(1 - Sa)
-        // Da'  = Sa + Da - Sa.Da 
-        static AGG_INLINE void blend_pix(value_type* p, 
-                                         unsigned sr, unsigned sg, unsigned sb, 
-                                         unsigned sa, unsigned cover)
-        {
-            if(cover < 255)
-            {
-                sr = (sr * cover + 255) >> 8;
-                sg = (sg * cover + 255) >> 8;
-                sb = (sb * cover + 255) >> 8;
-                sa = (sa * cover + 255) >> 8;
-            }
-            if(sa)
-            {
-                calc_type da = p[Order::A];
-                calc_type dr = ((da - p[Order::R]) * sr + base_mask) >> base_shift;
-                calc_type dg = ((da - p[Order::G]) * sg + base_mask) >> base_shift;
-                calc_type db = ((da - p[Order::B]) * sb + base_mask) >> base_shift;
-                calc_type s1a = base_mask - sa;
-                p[Order::R] = (value_type)(dr + ((p[Order::R] * s1a + base_mask) >> base_shift));
-                p[Order::G] = (value_type)(dg + ((p[Order::G] * s1a + base_mask) >> base_shift));
-                p[Order::B] = (value_type)(db + ((p[Order::B] * s1a + base_mask) >> base_shift));
-                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
-            }
-        }
-    };
-
-
-
-
-
-    //======================================================comp_op_table_rgba
-    template<class ColorT, class Order> struct comp_op_table_rgba
-    {
-        typedef typename ColorT::value_type value_type;
-        typedef void (*comp_op_func_type)(value_type* p, 
-                                          unsigned cr, 
-                                          unsigned cg, 
-                                          unsigned cb,
-                                          unsigned ca,
-                                          unsigned cover);
-        static comp_op_func_type g_comp_op_func[];
-    };
-
-    //==========================================================g_comp_op_func
-    template<class ColorT, class Order> 
-    typename comp_op_table_rgba<ColorT, Order>::comp_op_func_type
-    comp_op_table_rgba<ColorT, Order>::g_comp_op_func[] = 
-    {
-        comp_op_rgba_clear      <ColorT,Order>::blend_pix,
-        comp_op_rgba_src        <ColorT,Order>::blend_pix,
-        comp_op_rgba_dst        <ColorT,Order>::blend_pix,
-        comp_op_rgba_src_over   <ColorT,Order>::blend_pix,
-        comp_op_rgba_dst_over   <ColorT,Order>::blend_pix,
-        comp_op_rgba_src_in     <ColorT,Order>::blend_pix,
-        comp_op_rgba_dst_in     <ColorT,Order>::blend_pix,
-        comp_op_rgba_src_out    <ColorT,Order>::blend_pix,
-        comp_op_rgba_dst_out    <ColorT,Order>::blend_pix,
-        comp_op_rgba_src_atop   <ColorT,Order>::blend_pix,
-        comp_op_rgba_dst_atop   <ColorT,Order>::blend_pix,
-        comp_op_rgba_xor        <ColorT,Order>::blend_pix,
-        comp_op_rgba_plus       <ColorT,Order>::blend_pix,
-        comp_op_rgba_minus      <ColorT,Order>::blend_pix,
-        comp_op_rgba_multiply   <ColorT,Order>::blend_pix,
-        comp_op_rgba_screen     <ColorT,Order>::blend_pix,
-        comp_op_rgba_overlay    <ColorT,Order>::blend_pix,
-        comp_op_rgba_darken     <ColorT,Order>::blend_pix,
-        comp_op_rgba_lighten    <ColorT,Order>::blend_pix,
-        comp_op_rgba_color_dodge<ColorT,Order>::blend_pix,
-        comp_op_rgba_color_burn <ColorT,Order>::blend_pix,
-        comp_op_rgba_hard_light <ColorT,Order>::blend_pix,
-        comp_op_rgba_soft_light <ColorT,Order>::blend_pix,
-        comp_op_rgba_difference <ColorT,Order>::blend_pix,
-        comp_op_rgba_exclusion  <ColorT,Order>::blend_pix,
-        comp_op_rgba_contrast   <ColorT,Order>::blend_pix,
-        comp_op_rgba_invert     <ColorT,Order>::blend_pix,
-        comp_op_rgba_invert_rgb <ColorT,Order>::blend_pix,
-        0
-    };
-
-
-    //==============================================================comp_op_e
-    enum comp_op_e
-    {
-        comp_op_clear,         //----comp_op_clear
-        comp_op_src,           //----comp_op_src
-        comp_op_dst,           //----comp_op_dst
-        comp_op_src_over,      //----comp_op_src_over
-        comp_op_dst_over,      //----comp_op_dst_over
-        comp_op_src_in,        //----comp_op_src_in
-        comp_op_dst_in,        //----comp_op_dst_in
-        comp_op_src_out,       //----comp_op_src_out
-        comp_op_dst_out,       //----comp_op_dst_out
-        comp_op_src_atop,      //----comp_op_src_atop
-        comp_op_dst_atop,      //----comp_op_dst_atop
-        comp_op_xor,           //----comp_op_xor
-        comp_op_plus,          //----comp_op_plus
-        comp_op_minus,         //----comp_op_minus
-        comp_op_multiply,      //----comp_op_multiply
-        comp_op_screen,        //----comp_op_screen
-        comp_op_overlay,       //----comp_op_overlay
-        comp_op_darken,        //----comp_op_darken
-        comp_op_lighten,       //----comp_op_lighten
-        comp_op_color_dodge,   //----comp_op_color_dodge
-        comp_op_color_burn,    //----comp_op_color_burn
-        comp_op_hard_light,    //----comp_op_hard_light
-        comp_op_soft_light,    //----comp_op_soft_light
-        comp_op_difference,    //----comp_op_difference
-        comp_op_exclusion,     //----comp_op_exclusion
-        comp_op_contrast,      //----comp_op_contrast
-        comp_op_invert,        //----comp_op_invert
-        comp_op_invert_rgb,    //----comp_op_invert_rgb
-
-        end_of_comp_op_e
-    };
-
-
-
-
-
-
-
-    //====================================================comp_op_adaptor_rgba
-    template<class ColorT, class Order> struct comp_op_adaptor_rgba
-    {
-        typedef Order  order_type;
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        {  
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask 
-        };
-
-        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned ca,
-                                         unsigned cover)
-        {
-            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op]
-                (p, (cr * ca + base_mask) >> base_shift, 
-                    (cg * ca + base_mask) >> base_shift,
-                    (cb * ca + base_mask) >> base_shift,
-                     ca, cover);
-        }
-    };
-
-    //=========================================comp_op_adaptor_clip_to_dst_rgba
-    template<class ColorT, class Order> struct comp_op_adaptor_clip_to_dst_rgba
-    {
-        typedef Order  order_type;
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        {  
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask 
-        };
-
-        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned ca,
-                                         unsigned cover)
-        {
-            cr = (cr * ca + base_mask) >> base_shift;
-            cg = (cg * ca + base_mask) >> base_shift;
-            cb = (cb * ca + base_mask) >> base_shift;
-            unsigned da = p[Order::A];
-            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op]
-                (p, (cr * da + base_mask) >> base_shift, 
-                    (cg * da + base_mask) >> base_shift, 
-                    (cb * da + base_mask) >> base_shift, 
-                    (ca * da + base_mask) >> base_shift, 
-                    cover);
-        }
-    };
-
-    //================================================comp_op_adaptor_rgba_pre
-    template<class ColorT, class Order> struct comp_op_adaptor_rgba_pre
-    {
-        typedef Order  order_type;
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        {  
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask 
-        };
-
-        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned ca,
-                                         unsigned cover)
-        {
-            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op](p, cr, cg, cb, ca, cover);
-        }
-    };
-
-    //=====================================comp_op_adaptor_clip_to_dst_rgba_pre
-    template<class ColorT, class Order> struct comp_op_adaptor_clip_to_dst_rgba_pre
-    {
-        typedef Order  order_type;
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        {  
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask 
-        };
-
-        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned ca,
-                                         unsigned cover)
-        {
-            unsigned da = p[Order::A];
-            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op]
-                (p, (cr * da + base_mask) >> base_shift, 
-                    (cg * da + base_mask) >> base_shift, 
-                    (cb * da + base_mask) >> base_shift, 
-                    (ca * da + base_mask) >> base_shift, 
-                    cover);
-        }
-    };
-
-    //=======================================================comp_adaptor_rgba
-    template<class BlenderPre> struct comp_adaptor_rgba
-    {
-        typedef typename BlenderPre::order_type order_type;
-        typedef typename BlenderPre::color_type color_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        {  
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask 
-        };
-
-        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned ca,
-                                         unsigned cover)
-        {
-            BlenderPre::blend_pix(p, 
-                                  (cr * ca + base_mask) >> base_shift, 
-                                  (cg * ca + base_mask) >> base_shift,
-                                  (cb * ca + base_mask) >> base_shift,
-                                  ca, cover);
-        }
-    };
-
-    //==========================================comp_adaptor_clip_to_dst_rgba
-    template<class BlenderPre> struct comp_adaptor_clip_to_dst_rgba
-    {
-        typedef typename BlenderPre::order_type order_type;
-        typedef typename BlenderPre::color_type color_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        {  
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask 
-        };
-
-        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned ca,
-                                         unsigned cover)
-        {
-            cr = (cr * ca + base_mask) >> base_shift;
-            cg = (cg * ca + base_mask) >> base_shift;
-            cb = (cb * ca + base_mask) >> base_shift;
-            unsigned da = p[order_type::A];
-            BlenderPre::blend_pix(p, 
-                                  (cr * da + base_mask) >> base_shift, 
-                                  (cg * da + base_mask) >> base_shift, 
-                                  (cb * da + base_mask) >> base_shift, 
-                                  (ca * da + base_mask) >> base_shift, 
-                                  cover);
-        }
-    };
-
-    //======================================comp_adaptor_clip_to_dst_rgba_pre
-    template<class BlenderPre> struct comp_adaptor_clip_to_dst_rgba_pre
-    {
-        typedef typename BlenderPre::order_type order_type;
-        typedef typename BlenderPre::color_type color_type;
-        typedef typename color_type::value_type value_type;
-        enum base_scale_e
-        {  
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask 
-        };
-
-        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
-                                         unsigned cr, unsigned cg, unsigned cb,
-                                         unsigned ca,
-                                         unsigned cover)
-        {
-            unsigned da = p[order_type::A];
-            BlenderPre::blend_pix(p, 
-                                  (cr * da + base_mask) >> base_shift, 
-                                  (cg * da + base_mask) >> base_shift, 
-                                  (cb * da + base_mask) >> base_shift, 
-                                  (ca * da + base_mask) >> base_shift, 
-                                  cover);
-        }
-    };
-
-
-
-
-
-
-    //===============================================copy_or_blend_rgba_wrapper
-    template<class Blender> struct copy_or_blend_rgba_wrapper
-    {
-        typedef typename Blender::color_type color_type;
-        typedef typename Blender::order_type order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_scale = color_type::base_scale,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                                 unsigned cr, unsigned cg, unsigned cb,
-                                                 unsigned alpha)
-        {
-            if(alpha)
-            {
-                if(alpha == base_mask)
-                {
-                    p[order_type::R] = cr;
-                    p[order_type::G] = cg;
-                    p[order_type::B] = cb;
-                    p[order_type::A] = base_mask;
-                }
-                else
-                {
-                    Blender::blend_pix(p, cr, cg, cb, alpha);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                                 unsigned cr, unsigned cg, unsigned cb,
-                                                 unsigned alpha,
-                                                 unsigned cover)
-        {
-            if(cover == 255)
-            {
-                copy_or_blend_pix(p, cr, cg, cb, alpha);
-            }
-            else
-            {
-                if(alpha)
-                {
-                    alpha = (alpha * (cover + 1)) >> 8;
-                    if(alpha == base_mask)
-                    {
-                        p[order_type::R] = cr;
-                        p[order_type::G] = cg;
-                        p[order_type::B] = cb;
-                        p[order_type::A] = base_mask;
-                    }
-                    else
-                    {
-                        Blender::blend_pix(p, cr, cg, cb, alpha, cover);
-                    }
-                }
-            }
-        }
-    };
-
-
-
-
-
-    
-    //=================================================pixfmt_alpha_blend_rgba
-    template<class Blender, class RenBuf, class PixelT = int32u> 
-    class pixfmt_alpha_blend_rgba
-    {
-    public:
-        typedef RenBuf   rbuf_type;
-        typedef typename rbuf_type::row_data row_data;
-        typedef PixelT   pixel_type;
-        typedef Blender  blender_type;
-        typedef typename blender_type::color_type color_type;
-        typedef typename blender_type::order_type order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        typedef copy_or_blend_rgba_wrapper<blender_type> cob_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_scale = color_type::base_scale,
-            base_mask  = color_type::base_mask,
-            pix_width  = sizeof(pixel_type)
-        };
-
-        //--------------------------------------------------------------------
-        pixfmt_alpha_blend_rgba() : m_rbuf(0) {}
-        explicit pixfmt_alpha_blend_rgba(rbuf_type& rb) : m_rbuf(&rb) {}
-        void attach(rbuf_type& rb) { m_rbuf = &rb; }
-
-        //--------------------------------------------------------------------
-        template<class PixFmt>
-        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
-        {
-            rect_i r(x1, y1, x2, y2);
-            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
-            {
-                int stride = pixf.stride();
-                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
-                               (r.x2 - r.x1) + 1,
-                               (r.y2 - r.y1) + 1,
-                               stride);
-                return true;
-            }
-            return false;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
-        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
-        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
-        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
-        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE int8u* pix_ptr(int x, int y)
-        {
-            return m_rbuf->row_ptr(y) + x * pix_width;
-        }
-
-        AGG_INLINE const int8u* pix_ptr(int x, int y) const
-        {
-            return m_rbuf->row_ptr(y) + x * pix_width;
-        }
-
-
-        //--------------------------------------------------------------------
-        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
-        {
-            ((value_type*)p)[order_type::R] = c.r;
-            ((value_type*)p)[order_type::G] = c.g;
-            ((value_type*)p)[order_type::B] = c.b;
-            ((value_type*)p)[order_type::A] = c.a;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE color_type pixel(int x, int y) const
-        {
-            const value_type* p = (const value_type*)m_rbuf->row_ptr(y);
-            if(p)
-            {
-                p += x << 2;
-                return color_type(p[order_type::R], 
-                                  p[order_type::G], 
-                                  p[order_type::B], 
-                                  p[order_type::A]);
-            }
-            return color_type::no_color();
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2);
-            p[order_type::R] = c.r;
-            p[order_type::G] = c.g;
-            p[order_type::B] = c.b;
-            p[order_type::A] = c.a;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
-        {
-            cob_type::copy_or_blend_pix(
-                (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2), 
-                c.r, c.g, c.b, c.a, 
-                cover);
-        }
-
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_hline(int x, int y, 
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-            pixel_type v;
-            ((value_type*)&v)[order_type::R] = c.r;
-            ((value_type*)&v)[order_type::G] = c.g;
-            ((value_type*)&v)[order_type::B] = c.b;
-            ((value_type*)&v)[order_type::A] = c.a;
-            do
-            {
-                *(pixel_type*)p = v;
-                p += 4;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_vline(int x, int y,
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            pixel_type v;
-            ((value_type*)&v)[order_type::R] = c.r;
-            ((value_type*)&v)[order_type::G] = c.g;
-            ((value_type*)&v)[order_type::B] = c.b;
-            ((value_type*)&v)[order_type::A] = c.a;
-            do
-            {
-                value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                *(pixel_type*)p = v;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    pixel_type v;
-                    ((value_type*)&v)[order_type::R] = c.r;
-                    ((value_type*)&v)[order_type::G] = c.g;
-                    ((value_type*)&v)[order_type::B] = c.b;
-                    ((value_type*)&v)[order_type::A] = c.a;
-                    do
-                    {
-                        *(pixel_type*)p = v;
-                        p += 4;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    if(cover == 255)
-                    {
-                        do
-                        {
-                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha);
-                            p += 4;
-                        }
-                        while(--len);
-                    }
-                    else
-                    {
-                        do
-                        {
-                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha, cover);
-                            p += 4;
-                        }
-                        while(--len);
-                    }
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y,
-                         unsigned len, 
-                         const color_type& c,
-                         int8u cover)
-        {
-            if (c.a)
-            {
-                value_type* p;
-                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
-                if(alpha == base_mask)
-                {
-                    pixel_type v;
-                    ((value_type*)&v)[order_type::R] = c.r;
-                    ((value_type*)&v)[order_type::G] = c.g;
-                    ((value_type*)&v)[order_type::B] = c.b;
-                    ((value_type*)&v)[order_type::A] = c.a;
-                    do
-                    {
-                        p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                        *(pixel_type*)p = v;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    if(cover == 255)
-                    {
-                        do
-                        {
-                            p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha);
-                        }
-                        while(--len);
-                    }
-                    else
-                    {
-                        do
-                        {
-                            p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha, cover);
-                        }
-                        while(--len);
-                    }
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            if (c.a)
-            {
-                value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-                do 
-                {
-                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
-                    if(alpha == base_mask)
-                    {
-                        p[order_type::R] = c.r;
-                        p[order_type::G] = c.g;
-                        p[order_type::B] = c.b;
-                        p[order_type::A] = base_mask;
-                    }
-                    else
-                    {
-                        blender_type::blend_pix(p, c.r, c.g, c.b, alpha, *covers);
-                    }
-                    p += 4;
-                    ++covers;
-                }
-                while(--len);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type& c,
-                               const int8u* covers)
-        {
-            if (c.a)
-            {
-                do 
-                {
-                    value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
-                    if(alpha == base_mask)
-                    {
-                        p[order_type::R] = c.r;
-                        p[order_type::G] = c.g;
-                        p[order_type::B] = c.b;
-                        p[order_type::A] = base_mask;
-                    }
-                    else
-                    {
-                        blender_type::blend_pix(p, c.r, c.g, c.b, alpha, *covers);
-                    }
-                    ++covers;
-                }
-                while(--len);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-            do 
-            {
-                p[order_type::R] = colors->r;
-                p[order_type::G] = colors->g;
-                p[order_type::B] = colors->b;
-                p[order_type::A] = colors->a;
-                ++colors;
-                p += 4;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_vspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            do 
-            {
-                value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                p[order_type::R] = colors->r;
-                p[order_type::G] = colors->g;
-                p[order_type::B] = colors->b;
-                p[order_type::A] = colors->a;
-                ++colors;
-            }
-            while(--len);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-            if(covers)
-            {
-                do 
-                {
-                    cob_type::copy_or_blend_pix(p, 
-                                                colors->r, 
-                                                colors->g, 
-                                                colors->b, 
-                                                colors->a, 
-                                                *covers++);
-                    p += 4;
-                    ++colors;
-                }
-                while(--len);
-            }
-            else
-            {
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        cob_type::copy_or_blend_pix(p, 
-                                                    colors->r, 
-                                                    colors->g, 
-                                                    colors->b, 
-                                                    colors->a);
-                        p += 4;
-                        ++colors;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        cob_type::copy_or_blend_pix(p, 
-                                                    colors->r, 
-                                                    colors->g, 
-                                                    colors->b, 
-                                                    colors->a, 
-                                                    cover);
-                        p += 4;
-                        ++colors;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            value_type* p;
-            if(covers)
-            {
-                do 
-                {
-                    p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                    cob_type::copy_or_blend_pix(p, 
-                                                colors->r, 
-                                                colors->g, 
-                                                colors->b, 
-                                                colors->a,
-                                                *covers++);
-                    ++colors;
-                }
-                while(--len);
-            }
-            else
-            {
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                        cob_type::copy_or_blend_pix(p, 
-                                                    colors->r, 
-                                                    colors->g, 
-                                                    colors->b, 
-                                                    colors->a);
-                        ++colors;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                        cob_type::copy_or_blend_pix(p, 
-                                                    colors->r, 
-                                                    colors->g, 
-                                                    colors->b, 
-                                                    colors->a, 
-                                                    cover);
-                        ++colors;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class Function> void for_each_pixel(Function f)
-        {
-            unsigned y;
-            for(y = 0; y < height(); ++y)
-            {
-                row_data r = m_rbuf->row(y);
-                if(r.ptr)
-                {
-                    unsigned len = r.x2 - r.x1 + 1;
-                    value_type* p = 
-                        (value_type*)m_rbuf->row_ptr(r.x1, y, len) + (r.x1 << 2);
-                    do
-                    {
-                        f(p);
-                        p += 4;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void premultiply()
-        {
-            for_each_pixel(multiplier_rgba<color_type, order_type>::premultiply);
-        }
-
-        //--------------------------------------------------------------------
-        void demultiply()
-        {
-            for_each_pixel(multiplier_rgba<color_type, order_type>::demultiply);
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_dir_rgba<color_type, order_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_inv_rgba<color_type, order_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class RenBuf2> void copy_from(const RenBuf2& from, 
-                                               int xdst, int ydst,
-                                               int xsrc, int ysrc,
-                                               unsigned len)
-        {
-            const int8u* p = from.row_ptr(ysrc);
-            if(p)
-            {
-                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
-                        p + xsrc * pix_width, 
-                        len * pix_width);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from(const SrcPixelFormatRenderer& from, 
-                        int xdst, int ydst,
-                        int xsrc, int ysrc,
-                        unsigned len,
-                        int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::order_type src_order;
-            const value_type* psrc = (value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                psrc += xsrc << 2;
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
-                int incp = 4;
-                if(xdst > xsrc)
-                {
-                    psrc += (len-1) << 2;
-                    pdst += (len-1) << 2;
-                    incp = -4;
-                }
-
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        cob_type::copy_or_blend_pix(pdst, 
-                                                    psrc[src_order::R],
-                                                    psrc[src_order::G],
-                                                    psrc[src_order::B],
-                                                    psrc[src_order::A]);
-                        psrc += incp;
-                        pdst += incp;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        cob_type::copy_or_blend_pix(pdst, 
-                                                    psrc[src_order::R],
-                                                    psrc[src_order::G],
-                                                    psrc[src_order::B],
-                                                    psrc[src_order::A],
-                                                    cover);
-                        psrc += incp;
-                        pdst += incp;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_color(const SrcPixelFormatRenderer& from, 
-                              const color_type& color,
-                              int xdst, int ydst,
-                              int xsrc, int ysrc,
-                              unsigned len,
-                              int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
-                do 
-                {
-                    cob_type::copy_or_blend_pix(pdst, 
-                                                color.r, color.g, color.b, color.a,
-                                                (*psrc * cover + base_mask) >> base_shift);
-                    ++psrc;
-                    pdst += 4;
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_lut(const SrcPixelFormatRenderer& from, 
-                            const color_type* color_lut,
-                            int xdst, int ydst,
-                            int xsrc, int ysrc,
-                            unsigned len,
-                            int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
-
-                if(cover == 255)
-                {
-                    do 
-                    {
-                        const color_type& color = color_lut[*psrc];
-                        cob_type::copy_or_blend_pix(pdst, 
-                                                    color.r, color.g, color.b, color.a);
-                        ++psrc;
-                        pdst += 4;
-                    }
-                    while(--len);
-                }
-                else
-                {
-                    do 
-                    {
-                        const color_type& color = color_lut[*psrc];
-                        cob_type::copy_or_blend_pix(pdst, 
-                                                    color.r, color.g, color.b, color.a,
-                                                    cover);
-                        ++psrc;
-                        pdst += 4;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-    private:
-        rbuf_type* m_rbuf;
-    };
-
-
-
-
-    //================================================pixfmt_custom_blend_rgba
-    template<class Blender, class RenBuf> class pixfmt_custom_blend_rgba
-    {
-    public:
-        typedef RenBuf   rbuf_type;
-        typedef typename rbuf_type::row_data row_data;
-        typedef Blender  blender_type;
-        typedef typename blender_type::color_type color_type;
-        typedef typename blender_type::order_type order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_scale = color_type::base_scale,
-            base_mask  = color_type::base_mask,
-            pix_width  = sizeof(value_type) * 4 
-        };
-
-
-        //--------------------------------------------------------------------
-        pixfmt_custom_blend_rgba() : m_rbuf(0), m_comp_op(3) {}
-        explicit pixfmt_custom_blend_rgba(rbuf_type& rb, unsigned comp_op=3) : 
-            m_rbuf(&rb),
-            m_comp_op(comp_op)
-        {}
-        void attach(rbuf_type& rb) { m_rbuf = &rb; }
-
-        //--------------------------------------------------------------------
-        template<class PixFmt>
-        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
-        {
-            rect_i r(x1, y1, x2, y2);
-            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
-            {
-                int stride = pixf.stride();
-                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
-                               (r.x2 - r.x1) + 1,
-                               (r.y2 - r.y1) + 1,
-                               stride);
-                return true;
-            }
-            return false;
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
-        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
-        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
-        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
-        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE int8u* pix_ptr(int x, int y)
-        {
-            return m_rbuf->row_ptr(y) + x * pix_width;
-        }
-
-        AGG_INLINE const int8u* pix_ptr(int x, int y) const
-        {
-            return m_rbuf->row_ptr(y) + x * pix_width;
-        }
-
-        //--------------------------------------------------------------------
-        void comp_op(unsigned op) { m_comp_op = op; }
-        unsigned comp_op() const  { return m_comp_op; }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
-        {
-            ((value_type*)p)[order_type::R] = c.r;
-            ((value_type*)p)[order_type::G] = c.g;
-            ((value_type*)p)[order_type::B] = c.b;
-            ((value_type*)p)[order_type::A] = c.a;
-        }
-
-        //--------------------------------------------------------------------
-        color_type pixel(int x, int y) const
-        {
-            const value_type* p = (value_type*)m_rbuf->row_ptr(y) + (x << 2);
-            return color_type(p[order_type::R], 
-                              p[order_type::G], 
-                              p[order_type::B], 
-                              p[order_type::A]);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_pixel(int x, int y, const color_type& c)
-        {
-            blender_type::blend_pix(
-                m_comp_op, 
-                (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2), 
-                c.r, c.g, c.b, c.a, 255);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_pixel(int x, int y, const color_type& c, int8u cover)
-        {
-            blender_type::blend_pix(
-                m_comp_op, 
-                (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2),
-                c.r, c.g, c.b, c.a, 
-                cover);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_hline(int x, int y, unsigned len, const color_type& c)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);;
-            do
-            {
-                blender_type::blend_pix(m_comp_op, p, c.r, c.g, c.b, c.a, 255);
-                p += 4;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_vline(int x, int y, unsigned len, const color_type& c)
-        {
-            do
-            {
-                blender_type::blend_pix(
-                    m_comp_op, 
-                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2),
-                    c.r, c.g, c.b, c.a, 255);
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x, int y, unsigned len, 
-                         const color_type& c, int8u cover)
-        {
-
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-            do
-            {
-                blender_type::blend_pix(m_comp_op, p, c.r, c.g, c.b, c.a, cover);
-                p += 4;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y, unsigned len, 
-                         const color_type& c, int8u cover)
-        {
-
-            do
-            {
-                blender_type::blend_pix(
-                    m_comp_op, 
-                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2), 
-                    c.r, c.g, c.b, c.a, 
-                    cover);
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y, unsigned len, 
-                               const color_type& c, const int8u* covers)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-            do 
-            {
-                blender_type::blend_pix(m_comp_op, 
-                                        p, c.r, c.g, c.b, c.a, 
-                                        *covers++);
-                p += 4;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y, unsigned len, 
-                               const color_type& c, const int8u* covers)
-        {
-            do 
-            {
-                blender_type::blend_pix(
-                    m_comp_op, 
-                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2), 
-                    c.r, c.g, c.b, c.a, 
-                    *covers++);
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-            do 
-            {
-                p[order_type::R] = colors->r;
-                p[order_type::G] = colors->g;
-                p[order_type::B] = colors->b;
-                p[order_type::A] = colors->a;
-                ++colors;
-                p += 4;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_color_vspan(int x, int y,
-                              unsigned len, 
-                              const color_type* colors)
-        {
-            do 
-            {
-                value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
-                p[order_type::R] = colors->r;
-                p[order_type::G] = colors->g;
-                p[order_type::B] = colors->b;
-                p[order_type::A] = colors->a;
-                ++colors;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y, unsigned len, 
-                               const color_type* colors, 
-                               const int8u* covers,
-                               int8u cover)
-        {
-            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
-            do 
-            {
-                blender_type::blend_pix(m_comp_op, 
-                                        p, 
-                                        colors->r, 
-                                        colors->g, 
-                                        colors->b, 
-                                        colors->a, 
-                                        covers ? *covers++ : cover);
-                p += 4;
-                ++colors;
-            }
-            while(--len);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y, unsigned len, 
-                               const color_type* colors, 
-                               const int8u* covers,
-                               int8u cover)
-        {
-            do 
-            {
-                blender_type::blend_pix(
-                    m_comp_op, 
-                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2), 
-                    colors->r,
-                    colors->g,
-                    colors->b,
-                    colors->a,
-                    covers ? *covers++ : cover);
-                ++colors;
-            }
-            while(--len);
-
-        }
-
-        //--------------------------------------------------------------------
-        template<class Function> void for_each_pixel(Function f)
-        {
-            unsigned y;
-            for(y = 0; y < height(); ++y)
-            {
-                row_data r = m_rbuf->row(y);
-                if(r.ptr)
-                {
-                    unsigned len = r.x2 - r.x1 + 1;
-                    value_type* p = 
-                        (value_type*)m_rbuf->row_ptr(r.x1, y, len) + (r.x1 << 2);
-                    do
-                    {
-                        f(p);
-                        p += 4;
-                    }
-                    while(--len);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void premultiply()
-        {
-            for_each_pixel(multiplier_rgba<color_type, order_type>::premultiply);
-        }
-
-        //--------------------------------------------------------------------
-        void demultiply()
-        {
-            for_each_pixel(multiplier_rgba<color_type, order_type>::demultiply);
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_dir_rgba<color_type, order_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
-        {
-            for_each_pixel(apply_gamma_inv_rgba<color_type, order_type, GammaLut>(g));
-        }
-
-        //--------------------------------------------------------------------
-        template<class RenBuf2> void copy_from(const RenBuf2& from, 
-                                               int xdst, int ydst,
-                                               int xsrc, int ysrc,
-                                               unsigned len)
-        {
-            const int8u* p = from.row_ptr(ysrc);
-            if(p)
-            {
-                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
-                        p + xsrc * pix_width, 
-                        len * pix_width);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer> 
-        void blend_from(const SrcPixelFormatRenderer& from, 
-                        int xdst, int ydst,
-                        int xsrc, int ysrc,
-                        unsigned len,
-                        int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::order_type src_order;
-            const value_type* psrc = (const value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                psrc += xsrc << 2;
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
-
-                int incp = 4;
-                if(xdst > xsrc)
-                {
-                    psrc += (len-1) << 2;
-                    pdst += (len-1) << 2;
-                    incp = -4;
-                }
-
-                do 
-                {
-                    blender_type::blend_pix(m_comp_op, 
-                                            pdst, 
-                                            psrc[src_order::R],
-                                            psrc[src_order::G],
-                                            psrc[src_order::B],
-                                            psrc[src_order::A],
-                                            cover);
-                    psrc += incp;
-                    pdst += incp;
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_color(const SrcPixelFormatRenderer& from, 
-                              const color_type& color,
-                              int xdst, int ydst,
-                              int xsrc, int ysrc,
-                              unsigned len,
-                              int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
-                do 
-                {
-                    blender_type::blend_pix(m_comp_op,
-                                            pdst, 
-                                            color.r, color.g, color.b, color.a,
-                                            (*psrc * cover + base_mask) >> base_shift);
-                    ++psrc;
-                    pdst += 4;
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_lut(const SrcPixelFormatRenderer& from, 
-                            const color_type* color_lut,
-                            int xdst, int ydst,
-                            int xsrc, int ysrc,
-                            unsigned len,
-                            int8u cover)
-        {
-            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
-            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
-            if(psrc)
-            {
-                value_type* pdst = 
-                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
-                do 
-                {
-                    const color_type& color = color_lut[*psrc];
-                    blender_type::blend_pix(m_comp_op,
-                                            pdst, 
-                                            color.r, color.g, color.b, color.a,
-                                            cover);
-                    ++psrc;
-                    pdst += 4;
-                }
-                while(--len);
-            }
-        }
-
-    private:
-        rbuf_type* m_rbuf;
-        unsigned m_comp_op;
-    };
-
-
-
-
-    //-----------------------------------------------------------------------
-    typedef blender_rgba<rgba8, order_rgba> blender_rgba32; //----blender_rgba32
-    typedef blender_rgba<rgba8, order_argb> blender_argb32; //----blender_argb32
-    typedef blender_rgba<rgba8, order_abgr> blender_abgr32; //----blender_abgr32
-    typedef blender_rgba<rgba8, order_bgra> blender_bgra32; //----blender_bgra32
-
-    typedef blender_rgba_pre<rgba8, order_rgba> blender_rgba32_pre; //----blender_rgba32_pre
-    typedef blender_rgba_pre<rgba8, order_argb> blender_argb32_pre; //----blender_argb32_pre
-    typedef blender_rgba_pre<rgba8, order_abgr> blender_abgr32_pre; //----blender_abgr32_pre
-    typedef blender_rgba_pre<rgba8, order_bgra> blender_bgra32_pre; //----blender_bgra32_pre
-
-    typedef blender_rgba_plain<rgba8, order_rgba> blender_rgba32_plain; //----blender_rgba32_plain
-    typedef blender_rgba_plain<rgba8, order_argb> blender_argb32_plain; //----blender_argb32_plain
-    typedef blender_rgba_plain<rgba8, order_abgr> blender_abgr32_plain; //----blender_abgr32_plain
-    typedef blender_rgba_plain<rgba8, order_bgra> blender_bgra32_plain; //----blender_bgra32_plain
-
-    typedef blender_rgba<rgba16, order_rgba> blender_rgba64; //----blender_rgba64
-    typedef blender_rgba<rgba16, order_argb> blender_argb64; //----blender_argb64
-    typedef blender_rgba<rgba16, order_abgr> blender_abgr64; //----blender_abgr64
-    typedef blender_rgba<rgba16, order_bgra> blender_bgra64; //----blender_bgra64
-
-    typedef blender_rgba_pre<rgba16, order_rgba> blender_rgba64_pre; //----blender_rgba64_pre
-    typedef blender_rgba_pre<rgba16, order_argb> blender_argb64_pre; //----blender_argb64_pre
-    typedef blender_rgba_pre<rgba16, order_abgr> blender_abgr64_pre; //----blender_abgr64_pre
-    typedef blender_rgba_pre<rgba16, order_bgra> blender_bgra64_pre; //----blender_bgra64_pre
-
-
-    //-----------------------------------------------------------------------
-    typedef int32u pixel32_type;
-    typedef pixfmt_alpha_blend_rgba<blender_rgba32, rendering_buffer, pixel32_type> pixfmt_rgba32; //----pixfmt_rgba32
-    typedef pixfmt_alpha_blend_rgba<blender_argb32, rendering_buffer, pixel32_type> pixfmt_argb32; //----pixfmt_argb32
-    typedef pixfmt_alpha_blend_rgba<blender_abgr32, rendering_buffer, pixel32_type> pixfmt_abgr32; //----pixfmt_abgr32
-    typedef pixfmt_alpha_blend_rgba<blender_bgra32, rendering_buffer, pixel32_type> pixfmt_bgra32; //----pixfmt_bgra32
-
-    typedef pixfmt_alpha_blend_rgba<blender_rgba32_pre, rendering_buffer, pixel32_type> pixfmt_rgba32_pre; //----pixfmt_rgba32_pre
-    typedef pixfmt_alpha_blend_rgba<blender_argb32_pre, rendering_buffer, pixel32_type> pixfmt_argb32_pre; //----pixfmt_argb32_pre
-    typedef pixfmt_alpha_blend_rgba<blender_abgr32_pre, rendering_buffer, pixel32_type> pixfmt_abgr32_pre; //----pixfmt_abgr32_pre
-    typedef pixfmt_alpha_blend_rgba<blender_bgra32_pre, rendering_buffer, pixel32_type> pixfmt_bgra32_pre; //----pixfmt_bgra32_pre
-
-    typedef pixfmt_alpha_blend_rgba<blender_rgba32_plain, rendering_buffer, pixel32_type> pixfmt_rgba32_plain; //----pixfmt_rgba32_plain
-    typedef pixfmt_alpha_blend_rgba<blender_argb32_plain, rendering_buffer, pixel32_type> pixfmt_argb32_plain; //----pixfmt_argb32_plain
-    typedef pixfmt_alpha_blend_rgba<blender_abgr32_plain, rendering_buffer, pixel32_type> pixfmt_abgr32_plain; //----pixfmt_abgr32_plain
-    typedef pixfmt_alpha_blend_rgba<blender_bgra32_plain, rendering_buffer, pixel32_type> pixfmt_bgra32_plain; //----pixfmt_bgra32_plain
-
-    struct  pixel64_type { int16u c[4]; };
-    typedef pixfmt_alpha_blend_rgba<blender_rgba64, rendering_buffer, pixel64_type> pixfmt_rgba64; //----pixfmt_rgba64
-    typedef pixfmt_alpha_blend_rgba<blender_argb64, rendering_buffer, pixel64_type> pixfmt_argb64; //----pixfmt_argb64
-    typedef pixfmt_alpha_blend_rgba<blender_abgr64, rendering_buffer, pixel64_type> pixfmt_abgr64; //----pixfmt_abgr64
-    typedef pixfmt_alpha_blend_rgba<blender_bgra64, rendering_buffer, pixel64_type> pixfmt_bgra64; //----pixfmt_bgra64
-
-    typedef pixfmt_alpha_blend_rgba<blender_rgba64_pre, rendering_buffer, pixel64_type> pixfmt_rgba64_pre; //----pixfmt_rgba64_pre
-    typedef pixfmt_alpha_blend_rgba<blender_argb64_pre, rendering_buffer, pixel64_type> pixfmt_argb64_pre; //----pixfmt_argb64_pre
-    typedef pixfmt_alpha_blend_rgba<blender_abgr64_pre, rendering_buffer, pixel64_type> pixfmt_abgr64_pre; //----pixfmt_abgr64_pre
-    typedef pixfmt_alpha_blend_rgba<blender_bgra64_pre, rendering_buffer, pixel64_type> pixfmt_bgra64_pre; //----pixfmt_bgra64_pre
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_pixfmt_transposer.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_transposer.h
--- 8.0.1-5/renderers/agg/include/agg_pixfmt_transposer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_pixfmt_transposer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,157 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_PIXFMT_TRANSPOSER_INCLUDED
-#define AGG_PIXFMT_TRANSPOSER_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //=======================================================pixfmt_transposer
-    template<class PixFmt> class pixfmt_transposer
-    {
-    public:
-        typedef PixFmt pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::row_data row_data;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-
-        //--------------------------------------------------------------------
-        pixfmt_transposer() : m_pixf(0) {}
-        explicit pixfmt_transposer(pixfmt_type& pixf) : m_pixf(&pixf) {}
-        void attach(pixfmt_type& pixf) { m_pixf = &pixf; }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned width()  const { return m_pixf->height();  }
-        AGG_INLINE unsigned height() const { return m_pixf->width(); }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE color_type pixel(int x, int y) const
-        {
-            return m_pixf->pixel(y, x);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
-        {
-            m_pixf->copy_pixel(y, x, c);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_pixel(int x, int y, 
-                                    const color_type& c, 
-                                    int8u cover)
-        {
-            m_pixf->blend_pixel(y, x, c, cover);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_hline(int x, int y, 
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            m_pixf->copy_vline(y, x, len, c);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_vline(int x, int y,
-                                   unsigned len, 
-                                   const color_type& c)
-        {
-            m_pixf->copy_hline(y, x, len, c);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_hline(int x, int y,
-                                    unsigned len, 
-                                    const color_type& c,
-                                    int8u cover)
-        {
-            m_pixf->blend_vline(y, x, len, c, cover);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_vline(int x, int y,
-                                    unsigned len, 
-                                    const color_type& c,
-                                    int8u cover)
-        {
-            m_pixf->blend_hline(y, x, len, c, cover);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_solid_hspan(int x, int y,
-                                          unsigned len, 
-                                          const color_type& c,
-                                          const int8u* covers)
-        {
-            m_pixf->blend_solid_vspan(y, x, len, c, covers);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_solid_vspan(int x, int y,
-                                          unsigned len, 
-                                          const color_type& c,
-                                          const int8u* covers)
-        {
-            m_pixf->blend_solid_hspan(y, x, len, c, covers);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_color_hspan(int x, int y,
-                                         unsigned len, 
-                                         const color_type* colors)
-        {
-            m_pixf->copy_color_vspan(y, x, len, colors);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void copy_color_vspan(int x, int y,
-                                         unsigned len, 
-                                         const color_type* colors)
-        {
-            m_pixf->copy_color_hspan(y, x, len, colors);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_color_hspan(int x, int y,
-                                          unsigned len, 
-                                          const color_type* colors,
-                                          const int8u* covers,
-                                          int8u cover)
-        {
-            m_pixf->blend_color_vspan(y, x, len, colors, covers, cover);
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE void blend_color_vspan(int x, int y,
-                               unsigned len, 
-                               const color_type* colors,
-                               const int8u* covers,
-                               int8u cover)
-        {
-            m_pixf->blend_color_hspan(y, x, len, colors, covers, cover);
-        }
-
-    private:
-        pixfmt_type* m_pixf;
-    };
-}
-
-#endif
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_rasterizer_cells_aa.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_cells_aa.h
--- 8.0.1-5/renderers/agg/include/agg_rasterizer_cells_aa.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_cells_aa.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,758 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-//
-// The author gratefully acknowleges the support of David Turner, 
-// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
-// libray - in producing this work. See http://www.freetype.org for details.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-#ifndef AGG_RASTERIZER_CELLS_AA_INCLUDED
-#define AGG_RASTERIZER_CELLS_AA_INCLUDED
-
-#include <string.h>
-#include <math.h>
-#include "agg_math.h"
-#include "agg_array.h"
-
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------rasterizer_cells_aa
-    // An internal class that implements the main rasterization algorithm.
-    // Used in the rasterizer. Should not be used direcly.
-    template<class Cell> class rasterizer_cells_aa
-    {
-        enum cell_block_scale_e
-        {
-            cell_block_shift = 12,
-            cell_block_size  = 1 << cell_block_shift,
-            cell_block_mask  = cell_block_size - 1,
-            cell_block_pool  = 256,
-            cell_block_limit = 1024
-        };
-
-        struct sorted_y
-        {
-            unsigned start;
-            unsigned num;
-        };
-
-    public:
-        typedef Cell cell_type;
-        typedef rasterizer_cells_aa<Cell> self_type;
-
-        ~rasterizer_cells_aa();
-        rasterizer_cells_aa();
-
-        void reset();
-        void style(const cell_type& style_cell);
-        void line(int x1, int y1, int x2, int y2);
-
-        int min_x() const { return m_min_x; }
-        int min_y() const { return m_min_y; }
-        int max_x() const { return m_max_x; }
-        int max_y() const { return m_max_y; }
-
-        void sort_cells();
-
-        unsigned total_cells() const 
-        {
-            return m_num_cells;
-        }
-
-        unsigned scanline_num_cells(unsigned y) const 
-        { 
-            return m_sorted_y[y - m_min_y].num; 
-        }
-
-        const cell_type* const* scanline_cells(unsigned y) const
-        { 
-            return m_sorted_cells.data() + m_sorted_y[y - m_min_y].start; 
-        }
-
-        bool sorted() const { return m_sorted; }
-
-    private:
-        rasterizer_cells_aa(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        void set_curr_cell(int x, int y);
-        void add_curr_cell();
-        void render_hline(int ey, int x1, int y1, int x2, int y2);
-        void allocate_block();
-        
-    private:
-        unsigned                m_num_blocks;
-        unsigned                m_max_blocks;
-        unsigned                m_curr_block;
-        unsigned                m_num_cells;
-        cell_type**             m_cells;
-        cell_type*              m_curr_cell_ptr;
-        pod_vector<cell_type*>  m_sorted_cells;
-        pod_vector<sorted_y>    m_sorted_y;
-        cell_type               m_curr_cell;
-        cell_type               m_style_cell;
-        int                     m_min_x;
-        int                     m_min_y;
-        int                     m_max_x;
-        int                     m_max_y;
-        bool                    m_sorted;
-    };
-
-
-
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    rasterizer_cells_aa<Cell>::~rasterizer_cells_aa()
-    {
-        if(m_num_blocks)
-        {
-            cell_type** ptr = m_cells + m_num_blocks - 1;
-            while(m_num_blocks--)
-            {
-                pod_allocator<cell_type>::deallocate(*ptr, cell_block_size);
-                ptr--;
-            }
-            pod_allocator<cell_type*>::deallocate(m_cells, m_max_blocks);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    rasterizer_cells_aa<Cell>::rasterizer_cells_aa() :
-        m_num_blocks(0),
-        m_max_blocks(0),
-        m_curr_block(0),
-        m_num_cells(0),
-        m_cells(0),
-        m_curr_cell_ptr(0),
-        m_sorted_cells(),
-        m_sorted_y(),
-        m_min_x(0x7FFFFFFF),
-        m_min_y(0x7FFFFFFF),
-        m_max_x(-0x7FFFFFFF),
-        m_max_y(-0x7FFFFFFF),
-        m_sorted(false)
-    {
-        m_style_cell.initial();
-        m_curr_cell.initial();
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    void rasterizer_cells_aa<Cell>::reset()
-    {
-        m_num_cells = 0; 
-        m_curr_block = 0;
-        m_curr_cell.initial();
-        m_style_cell.initial();
-        m_sorted = false;
-        m_min_x =  0x7FFFFFFF;
-        m_min_y =  0x7FFFFFFF;
-        m_max_x = -0x7FFFFFFF;
-        m_max_y = -0x7FFFFFFF;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    AGG_INLINE void rasterizer_cells_aa<Cell>::add_curr_cell()
-    {
-        if(m_curr_cell.area | m_curr_cell.cover)
-        {
-            if((m_num_cells & cell_block_mask) == 0)
-            {
-                if(m_num_blocks >= cell_block_limit) return;
-                allocate_block();
-            }
-            *m_curr_cell_ptr++ = m_curr_cell;
-            ++m_num_cells;
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    AGG_INLINE void rasterizer_cells_aa<Cell>::set_curr_cell(int x, int y)
-    {
-        if(m_curr_cell.not_equal(x, y, m_style_cell))
-        {
-            add_curr_cell();
-            m_curr_cell.style(m_style_cell);
-            m_curr_cell.x     = x;
-            m_curr_cell.y     = y;
-            m_curr_cell.cover = 0;
-            m_curr_cell.area  = 0;
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    AGG_INLINE void rasterizer_cells_aa<Cell>::render_hline(int ey, 
-                                                            int x1, int y1, 
-                                                            int x2, int y2)
-    {
-        int ex1 = x1 >> poly_subpixel_shift;
-        int ex2 = x2 >> poly_subpixel_shift;
-        int fx1 = x1 & poly_subpixel_mask;
-        int fx2 = x2 & poly_subpixel_mask;
-
-        int delta, p, first, dx;
-        int incr, lift, mod, rem;
-
-        //trivial case. Happens often
-        if(y1 == y2)
-        {
-            set_curr_cell(ex2, ey);
-            return;
-        }
-
-        //everything is located in a single cell.  That is easy!
-        if(ex1 == ex2)
-        {
-            delta = y2 - y1;
-            m_curr_cell.cover += delta;
-            m_curr_cell.area  += (fx1 + fx2) * delta;
-            return;
-        }
-
-        //ok, we'll have to render a run of adjacent cells on the same
-        //hline...
-        p     = (poly_subpixel_scale - fx1) * (y2 - y1);
-        first = poly_subpixel_scale;
-        incr  = 1;
-
-        dx = x2 - x1;
-
-        if(dx < 0)
-        {
-            p     = fx1 * (y2 - y1);
-            first = 0;
-            incr  = -1;
-            dx    = -dx;
-        }
-
-        delta = p / dx;
-        mod   = p % dx;
-
-        if(mod < 0)
-        {
-            delta--;
-            mod += dx;
-        }
-
-        m_curr_cell.cover += delta;
-        m_curr_cell.area  += (fx1 + first) * delta;
-
-        ex1 += incr;
-        set_curr_cell(ex1, ey);
-        y1  += delta;
-
-        if(ex1 != ex2)
-        {
-            p     = poly_subpixel_scale * (y2 - y1 + delta);
-            lift  = p / dx;
-            rem   = p % dx;
-
-            if (rem < 0)
-            {
-                lift--;
-                rem += dx;
-            }
-
-            mod -= dx;
-
-            while (ex1 != ex2)
-            {
-                delta = lift;
-                mod  += rem;
-                if(mod >= 0)
-                {
-                    mod -= dx;
-                    delta++;
-                }
-
-                m_curr_cell.cover += delta;
-                m_curr_cell.area  += poly_subpixel_scale * delta;
-                y1  += delta;
-                ex1 += incr;
-                set_curr_cell(ex1, ey);
-            }
-        }
-        delta = y2 - y1;
-        m_curr_cell.cover += delta;
-        m_curr_cell.area  += (fx2 + poly_subpixel_scale - first) * delta;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    AGG_INLINE void rasterizer_cells_aa<Cell>::style(const cell_type& style_cell)
-    { 
-        m_style_cell.style(style_cell); 
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    void rasterizer_cells_aa<Cell>::line(int x1, int y1, int x2, int y2)
-    {
-        enum dx_limit_e { dx_limit = 16384 << poly_subpixel_shift };
-
-        // Checking the limit and avoid integer overflows
-        if(((x1 < x2)? ((x1 < 0)? (x1 + dx_limit <= x2) : (x1 <= x2 - dx_limit)) : 
-                      ((x2 < 0)? (x2 + dx_limit <= x1) : (x2 <= x1 - dx_limit))) ||
-           ((y1 < y2)? ((y1 < 0)? (y1 + dx_limit <= y2) : (y1 <= y2 - dx_limit)) : 
-                      ((y2 < 0)? (y2 + dx_limit <= y1) : (y2 <= y1 - dx_limit))))
-        {
-            int cx = (x2&x1) + ((x2^x1)>>1);
-            int cy = (y2&y1) + ((y2^y1)>>1);
-
-            line(x1, y1, cx, cy);
-            line(cx, cy, x2, y2);
-        }
-
-        int dx = x2 - x1;
-        int dy = y2 - y1;
-        int ex1 = x1 >> poly_subpixel_shift;
-        int ex2 = x2 >> poly_subpixel_shift;
-        int ey1 = y1 >> poly_subpixel_shift;
-        int ey2 = y2 >> poly_subpixel_shift;
-        int fy1 = y1 & poly_subpixel_mask;
-        int fy2 = y2 & poly_subpixel_mask;
-
-        int x_from, x_to;
-        int p, rem, mod, lift, delta, first, incr;
-
-        if(ex1 < m_min_x) m_min_x = ex1;
-        if(ex1 > m_max_x) m_max_x = ex1;
-        if(ey1 < m_min_y) m_min_y = ey1;
-        if(ey1 > m_max_y) m_max_y = ey1;
-        if(ex2 < m_min_x) m_min_x = ex2;
-        if(ex2 > m_max_x) m_max_x = ex2;
-        if(ey2 < m_min_y) m_min_y = ey2;
-        if(ey2 > m_max_y) m_max_y = ey2;
-
-        set_curr_cell(ex1, ey1);
-
-        //everything is on a single hline
-        if(ey1 == ey2)
-        {
-            render_hline(ey1, x1, fy1, x2, fy2);
-            return;
-        }
-
-        //Vertical line - we have to calculate start and end cells,
-        //and then - the common values of the area and coverage for
-        //all cells of the line. We know exactly there's only one 
-        //cell, so, we don't have to call render_hline().
-        incr  = 1;
-        if(dx == 0)
-        {
-            int ex = x1 >> poly_subpixel_shift;
-            int two_fx = (x1 - (ex << poly_subpixel_shift)) << 1;
-            int area;
-
-            first = poly_subpixel_scale;
-            if(dy < 0)
-            {
-                first = 0;
-                incr  = -1;
-            }
-
-            x_from = x1;
-
-            //render_hline(ey1, x_from, fy1, x_from, first);
-            delta = first - fy1;
-            m_curr_cell.cover += delta;
-            m_curr_cell.area  += two_fx * delta;
-
-            ey1 += incr;
-            set_curr_cell(ex, ey1);
-
-            delta = first + first - poly_subpixel_scale;
-            area = two_fx * delta;
-            while(ey1 != ey2)
-            {
-                //render_hline(ey1, x_from, poly_subpixel_scale - first, x_from, first);
-                m_curr_cell.cover = delta;
-                m_curr_cell.area  = area;
-                ey1 += incr;
-                set_curr_cell(ex, ey1);
-            }
-            //render_hline(ey1, x_from, poly_subpixel_scale - first, x_from, fy2);
-            delta = fy2 - poly_subpixel_scale + first;
-            m_curr_cell.cover += delta;
-            m_curr_cell.area  += two_fx * delta;
-            return;
-        }
-
-        //ok, we have to render several hlines
-        p     = (poly_subpixel_scale - fy1) * dx;
-        first = poly_subpixel_scale;
-
-        if(dy < 0)
-        {
-            p     = fy1 * dx;
-            first = 0;
-            incr  = -1;
-            dy    = -dy;
-        }
-
-        delta = p / dy;
-        mod   = p % dy;
-
-        if(mod < 0)
-        {
-            delta--;
-            mod += dy;
-        }
-
-        x_from = x1 + delta;
-        render_hline(ey1, x1, fy1, x_from, first);
-
-        ey1 += incr;
-        set_curr_cell(x_from >> poly_subpixel_shift, ey1);
-
-        if(ey1 != ey2)
-        {
-            p     = poly_subpixel_scale * dx;
-            lift  = p / dy;
-            rem   = p % dy;
-
-            if(rem < 0)
-            {
-                lift--;
-                rem += dy;
-            }
-            mod -= dy;
-
-            while(ey1 != ey2)
-            {
-                delta = lift;
-                mod  += rem;
-                if (mod >= 0)
-                {
-                    mod -= dy;
-                    delta++;
-                }
-
-                x_to = x_from + delta;
-                render_hline(ey1, x_from, poly_subpixel_scale - first, x_to, first);
-                x_from = x_to;
-
-                ey1 += incr;
-                set_curr_cell(x_from >> poly_subpixel_shift, ey1);
-            }
-        }
-        render_hline(ey1, x_from, poly_subpixel_scale - first, x2, fy2);
-    }
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    void rasterizer_cells_aa<Cell>::allocate_block()
-    {
-        if(m_curr_block >= m_num_blocks)
-        {
-            if(m_num_blocks >= m_max_blocks)
-            {
-                cell_type** new_cells = 
-                    pod_allocator<cell_type*>::allocate(m_max_blocks + 
-                                                        cell_block_pool);
-
-                if(m_cells)
-                {
-                    memcpy(new_cells, m_cells, m_max_blocks * sizeof(cell_type*));
-                    pod_allocator<cell_type*>::deallocate(m_cells, m_max_blocks);
-                }
-                m_cells = new_cells;
-                m_max_blocks += cell_block_pool;
-            }
-
-            m_cells[m_num_blocks++] = 
-                pod_allocator<cell_type>::allocate(cell_block_size);
-
-        }
-        m_curr_cell_ptr = m_cells[m_curr_block++];
-    }
-
-
-
-    //------------------------------------------------------------------------
-    template <class T> static AGG_INLINE void swap_cells(T* a, T* b)
-    {
-        T temp = *a;
-        *a = *b;
-        *b = temp;
-    }
-
-
-    //------------------------------------------------------------------------
-    enum
-    {
-        qsort_threshold = 9
-    };
-
-
-    //------------------------------------------------------------------------
-    template<class Cell>
-    void qsort_cells(Cell** start, unsigned num)
-    {
-        Cell**  stack[80];
-        Cell*** top; 
-        Cell**  limit;
-        Cell**  base;
-
-        limit = start + num;
-        base  = start;
-        top   = stack;
-
-        for (;;)
-        {
-            int len = int(limit - base);
-
-            Cell** i;
-            Cell** j;
-            Cell** pivot;
-
-            if(len > qsort_threshold)
-            {
-                // we use base + len/2 as the pivot
-                pivot = base + len / 2;
-                swap_cells(base, pivot);
-
-                i = base + 1;
-                j = limit - 1;
-
-                // now ensure that *i <= *base <= *j 
-                if((*j)->x < (*i)->x)
-                {
-                    swap_cells(i, j);
-                }
-
-                if((*base)->x < (*i)->x)
-                {
-                    swap_cells(base, i);
-                }
-
-                if((*j)->x < (*base)->x)
-                {
-                    swap_cells(base, j);
-                }
-
-                for(;;)
-                {
-                    int x = (*base)->x;
-                    do i++; while( (*i)->x < x );
-                    do j--; while( x < (*j)->x );
-
-                    if(i > j)
-                    {
-                        break;
-                    }
-
-                    swap_cells(i, j);
-                }
-
-                swap_cells(base, j);
-
-                // now, push the largest sub-array
-                if(j - base > limit - i)
-                {
-                    top[0] = base;
-                    top[1] = j;
-                    base   = i;
-                }
-                else
-                {
-                    top[0] = i;
-                    top[1] = limit;
-                    limit  = j;
-                }
-                top += 2;
-            }
-            else
-            {
-                // the sub-array is small, perform insertion sort
-                j = base;
-                i = j + 1;
-
-                for(; i < limit; j = i, i++)
-                {
-                    for(; j[1]->x < (*j)->x; j--)
-                    {
-                        swap_cells(j + 1, j);
-                        if (j == base)
-                        {
-                            break;
-                        }
-                    }
-                }
-
-                if(top > stack)
-                {
-                    top  -= 2;
-                    base  = top[0];
-                    limit = top[1];
-                }
-                else
-                {
-                    break;
-                }
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class Cell> 
-    void rasterizer_cells_aa<Cell>::sort_cells()
-    {
-        if(m_sorted) return; //Perform sort only the first time.
-
-        add_curr_cell();
-        m_curr_cell.x     = 0x7FFFFFFF;
-        m_curr_cell.y     = 0x7FFFFFFF;
-        m_curr_cell.cover = 0;
-        m_curr_cell.area  = 0;
-
-        if(m_num_cells == 0) return;
-
-// DBG: Check to see if min/max works well.
-//for(unsigned nc = 0; nc < m_num_cells; nc++)
-//{
-//    cell_type* cell = m_cells[nc >> cell_block_shift] + (nc & cell_block_mask);
-//    if(cell->x < m_min_x || 
-//       cell->y < m_min_y || 
-//       cell->x > m_max_x || 
-//       cell->y > m_max_y)
-//    {
-//        cell = cell; // Breakpoint here
-//    }
-//}
-        // Allocate the array of cell pointers
-        m_sorted_cells.allocate(m_num_cells, 16);
-
-        // Allocate and zero the Y array
-        m_sorted_y.allocate(m_max_y - m_min_y + 1, 16);
-        m_sorted_y.zero();
-
-        // Create the Y-histogram (count the numbers of cells for each Y)
-        cell_type** block_ptr = m_cells;
-        cell_type*  cell_ptr;
-        unsigned nb = m_num_cells >> cell_block_shift;
-        unsigned i;
-        while(nb--)
-        {
-            cell_ptr = *block_ptr++;
-            i = cell_block_size;
-            while(i--) 
-            {
-                m_sorted_y[cell_ptr->y - m_min_y].start++;
-                ++cell_ptr;
-            }
-        }
-
-        cell_ptr = *block_ptr++;
-        i = m_num_cells & cell_block_mask;
-        while(i--) 
-        {
-            m_sorted_y[cell_ptr->y - m_min_y].start++;
-            ++cell_ptr;
-        }
-
-        // Convert the Y-histogram into the array of starting indexes
-        unsigned start = 0;
-        for(i = 0; i < m_sorted_y.size(); i++)
-        {
-            unsigned v = m_sorted_y[i].start;
-            m_sorted_y[i].start = start;
-            start += v;
-        }
-
-        // Fill the cell pointer array sorted by Y
-        block_ptr = m_cells;
-        nb = m_num_cells >> cell_block_shift;
-        while(nb--)
-        {
-            cell_ptr = *block_ptr++;
-            i = cell_block_size;
-            while(i--) 
-            {
-                sorted_y& curr_y = m_sorted_y[cell_ptr->y - m_min_y];
-                m_sorted_cells[curr_y.start + curr_y.num] = cell_ptr;
-                ++curr_y.num;
-                ++cell_ptr;
-            }
-        }
-        
-        cell_ptr = *block_ptr++;
-        i = m_num_cells & cell_block_mask;
-        while(i--) 
-        {
-            sorted_y& curr_y = m_sorted_y[cell_ptr->y - m_min_y];
-            m_sorted_cells[curr_y.start + curr_y.num] = cell_ptr;
-            ++curr_y.num;
-            ++cell_ptr;
-        }
-
-        // Finally arrange the X-arrays
-        for(i = 0; i < m_sorted_y.size(); i++)
-        {
-            const sorted_y& curr_y = m_sorted_y[i];
-            if(curr_y.num)
-            {
-                qsort_cells(m_sorted_cells.data() + curr_y.start, curr_y.num);
-            }
-        }
-        m_sorted = true;
-    }
-
-
-
-    //------------------------------------------------------scanline_hit_test
-    class scanline_hit_test
-    {
-    public:
-        scanline_hit_test(int x) : m_x(x), m_hit(false) {}
-
-        void reset_spans() {}
-        void finalize(int) {}
-        void add_cell(int x, int)
-        {
-            if(m_x == x) m_hit = true;
-        }
-        void add_span(int x, int len, int)
-        {
-            if(m_x >= x && m_x < x+len) m_hit = true;
-        }
-        unsigned num_spans() const { return 1; }
-        bool hit() const { return m_hit; }
-
-    private:
-        int  m_x;
-        bool m_hit;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_rasterizer_compound_aa.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_compound_aa.h
--- 8.0.1-5/renderers/agg/include/agg_rasterizer_compound_aa.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_compound_aa.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,698 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-//
-// The author gratefully acknowleges the support of David Turner, 
-// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
-// libray - in producing this work. See http://www.freetype.org for details.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-#ifndef AGG_RASTERIZER_COMPOUND_AA_INCLUDED
-#define AGG_RASTERIZER_COMPOUND_AA_INCLUDED
-
-#include "agg_rasterizer_cells_aa.h"
-#include "agg_rasterizer_sl_clip.h"
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------------cell_style_aa
-    // A pixel cell. There're no constructors defined and it was done 
-    // intentionally in order to avoid extra overhead when allocating an 
-    // array of cells.
-    struct cell_style_aa
-    {
-        int   x;
-        int   y;
-        int   cover;
-        int   area;
-        int16 left, right;
-
-        void initial()
-        {
-            x     = 0x7FFFFFFF;
-            y     = 0x7FFFFFFF;
-            cover = 0;
-            area  = 0;
-            left  = -1;
-            right = -1;
-        }
-
-        void style(const cell_style_aa& c)
-        {
-            left  = c.left;
-            right = c.right;
-        }
-
-        int not_equal(int ex, int ey, const cell_style_aa& c) const
-        {
-            return (ex - x) | (ey - y) | (left - c.left) | (right - c.right);
-        }
-    };
-
-
-    //===========================================================layer_order_e
-    enum layer_order_e
-    {
-        layer_unsorted, //------layer_unsorted
-        layer_direct,   //------layer_direct
-        layer_inverse   //------layer_inverse
-    };
-
-
-    //==================================================rasterizer_compound_aa
-    template<class Clip=rasterizer_sl_clip_int> class rasterizer_compound_aa
-    {
-        struct style_info 
-        { 
-            unsigned start_cell;
-            unsigned num_cells;
-            int      last_x;
-        };
-
-        struct cell_info
-        {
-            int x, area, cover; 
-        };
-
-    public:
-        typedef Clip                      clip_type;
-        typedef typename Clip::conv_type  conv_type;
-        typedef typename Clip::coord_type coord_type;
-
-        enum aa_scale_e
-        {
-            aa_shift  = 8,
-            aa_scale  = 1 << aa_shift,
-            aa_mask   = aa_scale - 1,
-            aa_scale2 = aa_scale * 2,
-            aa_mask2  = aa_scale2 - 1
-        };
-
-        //--------------------------------------------------------------------
-        rasterizer_compound_aa() : 
-            m_outline(),
-            m_clipper(),
-            m_filling_rule(fill_non_zero),
-            m_layer_order(layer_direct),
-            m_styles(),  // Active Styles
-            m_ast(),     // Active Style Table (unique values)
-            m_asm(),     // Active Style Mask 
-            m_cells(),
-            m_cover_buf(),
-            m_master_alpha(),
-            m_min_style(0x7FFFFFFF),
-            m_max_style(-0x7FFFFFFF),
-            m_start_x(0),
-            m_start_y(0),
-            m_scan_y(0x7FFFFFFF),
-            m_sl_start(0),
-            m_sl_len(0)
-        {}
-
-        //--------------------------------------------------------------------
-        void reset(); 
-        void reset_clipping();
-        void clip_box(double x1, double y1, double x2, double y2);
-        void filling_rule(filling_rule_e filling_rule);
-        void layer_order(layer_order_e order);
-        void master_alpha(int style, double alpha);
-
-        //--------------------------------------------------------------------
-        void styles(int left, int right);
-        void move_to(int x, int y);
-        void line_to(int x, int y);
-        void move_to_d(double x, double y);
-        void line_to_d(double x, double y);
-        void add_vertex(double x, double y, unsigned cmd);
-
-        void edge(int x1, int y1, int x2, int y2);
-        void edge_d(double x1, double y1, double x2, double y2);
-
-        //-------------------------------------------------------------------
-        template<class VertexSource>
-        void add_path(VertexSource& vs, unsigned path_id=0)
-        {
-            double x;
-            double y;
-
-            unsigned cmd;
-            vs.rewind(path_id);
-            if(m_outline.sorted()) reset();
-            while(!is_stop(cmd = vs.vertex(&x, &y)))
-            {
-                add_vertex(x, y, cmd);
-            }
-        }
-
-        
-        //--------------------------------------------------------------------
-        int min_x()     const { return m_outline.min_x(); }
-        int min_y()     const { return m_outline.min_y(); }
-        int max_x()     const { return m_outline.max_x(); }
-        int max_y()     const { return m_outline.max_y(); }
-        int min_style() const { return m_min_style; }
-        int max_style() const { return m_max_style; }
-
-        //--------------------------------------------------------------------
-        void sort();
-        bool rewind_scanlines();
-        unsigned sweep_styles();
-        int      scanline_start()  const { return m_sl_start; }
-        unsigned scanline_length() const { return m_sl_len;   }
-        unsigned style(unsigned style_idx) const;
-
-        cover_type* allocate_cover_buffer(unsigned len);
-
-        //--------------------------------------------------------------------
-        bool navigate_scanline(int y); 
-        bool hit_test(int tx, int ty);
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned calculate_alpha(int area, unsigned master_alpha) const
-        {
-            int cover = area >> (poly_subpixel_shift*2 + 1 - aa_shift);
-            if(cover < 0) cover = -cover;
-            if(m_filling_rule == fill_even_odd)
-            {
-                cover &= aa_mask2;
-                if(cover > aa_scale)
-                {
-                    cover = aa_scale2 - cover;
-                }
-            }
-            if(cover > aa_mask) cover = aa_mask;
-            return (cover * master_alpha + aa_mask) >> aa_shift;
-        }
-
-        //--------------------------------------------------------------------
-        // Sweeps one scanline with one style index. The style ID can be 
-        // determined by calling style(). 
-        template<class Scanline> bool sweep_scanline(Scanline& sl, int style_idx)
-        {
-            int scan_y = m_scan_y - 1;
-            if(scan_y > m_outline.max_y()) return false;
-
-            sl.reset_spans();
-
-            unsigned master_alpha = aa_mask;
-
-            if(style_idx < 0) 
-            {
-                style_idx = 0;
-            }
-            else 
-            {
-                style_idx++;
-                master_alpha = m_master_alpha[m_ast[style_idx] + m_min_style - 1];
-            }
-
-            const style_info& st = m_styles[m_ast[style_idx]];
-
-            unsigned num_cells = st.num_cells;
-            cell_info* cell = &m_cells[st.start_cell];
-
-            int cover = 0;
-            while(num_cells--)
-            {
-                unsigned alpha;
-                int x = cell->x;
-                int area = cell->area;
-
-                cover += cell->cover;
-
-                ++cell;
-
-                if(area)
-                {
-                    alpha = calculate_alpha((cover << (poly_subpixel_shift + 1)) - area,
-                                            master_alpha);
-                    sl.add_cell(x, alpha);
-                    x++;
-                }
-
-                if(num_cells && cell->x > x)
-                {
-                    alpha = calculate_alpha(cover << (poly_subpixel_shift + 1),
-                                            master_alpha);
-                    if(alpha)
-                    {
-                        sl.add_span(x, cell->x - x, alpha);
-                    }
-                }
-            }
-
-            if(sl.num_spans() == 0) return false;
-            sl.finalize(scan_y);
-            return true;
-        }
-
-    private:
-        void add_style(int style_id);
-        void allocate_master_alpha();
-
-        //--------------------------------------------------------------------
-        // Disable copying
-        rasterizer_compound_aa(const rasterizer_compound_aa<Clip>&);
-        const rasterizer_compound_aa<Clip>& 
-        operator = (const rasterizer_compound_aa<Clip>&);
-
-    private:
-        rasterizer_cells_aa<cell_style_aa> m_outline;
-        clip_type              m_clipper;
-        filling_rule_e         m_filling_rule;
-        layer_order_e          m_layer_order;
-        pod_vector<style_info> m_styles;  // Active Styles
-        pod_vector<unsigned>   m_ast;     // Active Style Table (unique values)
-        pod_vector<int8u>      m_asm;     // Active Style Mask 
-        pod_vector<cell_info>  m_cells;
-        pod_vector<cover_type> m_cover_buf;
-        pod_bvector<unsigned>  m_master_alpha;
-
-        int        m_min_style;
-        int        m_max_style;
-        coord_type m_start_x;
-        coord_type m_start_y;
-        int        m_scan_y;
-        int        m_sl_start;
-        unsigned   m_sl_len;
-    };
-
-
-
-
-
-
-
-
-
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::reset() 
-    { 
-        m_outline.reset(); 
-        m_min_style =  0x7FFFFFFF;
-        m_max_style = -0x7FFFFFFF;
-        m_scan_y    =  0x7FFFFFFF;
-        m_sl_start  =  0;
-        m_sl_len    = 0;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::filling_rule(filling_rule_e filling_rule) 
-    { 
-        m_filling_rule = filling_rule; 
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::layer_order(layer_order_e order)
-    {
-        m_layer_order = order;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::clip_box(double x1, double y1, 
-                                                double x2, double y2)
-    {
-        reset();
-        m_clipper.clip_box(conv_type::upscale(x1), conv_type::upscale(y1), 
-                           conv_type::upscale(x2), conv_type::upscale(y2));
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::reset_clipping()
-    {
-        reset();
-        m_clipper.reset_clipping();
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::styles(int left, int right)
-    {
-        cell_style_aa cell;
-        cell.initial();
-        cell.left = (int16)left;
-        cell.right = (int16)right;
-        m_outline.style(cell);
-        if(left  >= 0 && left  < m_min_style) m_min_style = left;
-        if(left  >= 0 && left  > m_max_style) m_max_style = left;
-        if(right >= 0 && right < m_min_style) m_min_style = right;
-        if(right >= 0 && right > m_max_style) m_max_style = right;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::move_to(int x, int y)
-    {
-        if(m_outline.sorted()) reset();
-        m_clipper.move_to(m_start_x = conv_type::downscale(x), 
-                          m_start_y = conv_type::downscale(y));
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::line_to(int x, int y)
-    {
-        m_clipper.line_to(m_outline, 
-                          conv_type::downscale(x), 
-                          conv_type::downscale(y));
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::move_to_d(double x, double y) 
-    { 
-        if(m_outline.sorted()) reset();
-        m_clipper.move_to(m_start_x = conv_type::upscale(x), 
-                          m_start_y = conv_type::upscale(y)); 
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::line_to_d(double x, double y) 
-    { 
-        m_clipper.line_to(m_outline, 
-                          conv_type::upscale(x), 
-                          conv_type::upscale(y)); 
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::add_vertex(double x, double y, unsigned cmd)
-    {
-        if(is_move_to(cmd)) 
-        {
-            move_to_d(x, y);
-        }
-        else 
-        if(is_vertex(cmd))
-        {
-            line_to_d(x, y);
-        }
-        else
-        if(is_close(cmd))
-        {
-            m_clipper.line_to(m_outline, m_start_x, m_start_y);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::edge(int x1, int y1, int x2, int y2)
-    {
-        if(m_outline.sorted()) reset();
-        m_clipper.move_to(conv_type::downscale(x1), conv_type::downscale(y1));
-        m_clipper.line_to(m_outline, 
-                          conv_type::downscale(x2), 
-                          conv_type::downscale(y2));
-    }
-    
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::edge_d(double x1, double y1, 
-                                              double x2, double y2)
-    {
-        if(m_outline.sorted()) reset();
-        m_clipper.move_to(conv_type::upscale(x1), conv_type::upscale(y1)); 
-        m_clipper.line_to(m_outline, 
-                          conv_type::upscale(x2), 
-                          conv_type::upscale(y2)); 
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    AGG_INLINE void rasterizer_compound_aa<Clip>::sort()
-    {
-        m_outline.sort_cells();
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    AGG_INLINE bool rasterizer_compound_aa<Clip>::rewind_scanlines()
-    {
-        m_outline.sort_cells();
-        if(m_outline.total_cells() == 0) 
-        {
-            return false;
-        }
-        if(m_max_style < m_min_style)
-        {
-            return false;
-        }
-        m_scan_y = m_outline.min_y();
-        m_styles.allocate(m_max_style - m_min_style + 2, 128);
-        allocate_master_alpha();
-        return true;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    AGG_INLINE void rasterizer_compound_aa<Clip>::add_style(int style_id)
-    {
-        if(style_id < 0) style_id  = 0;
-        else             style_id -= m_min_style - 1;
-
-        unsigned nbyte = style_id >> 3;
-        unsigned mask = 1 << (style_id & 7);
-
-        style_info* style = &m_styles[style_id];
-        if((m_asm[nbyte] & mask) == 0)
-        {
-            m_ast.add(style_id);
-            m_asm[nbyte] |= mask;
-            style->start_cell = 0;
-            style->num_cells = 0;
-            style->last_x = -0x7FFFFFFF;
-        }
-        ++style->start_cell;
-    }
-
-    //------------------------------------------------------------------------
-    // Returns the number of styles
-    template<class Clip> 
-    unsigned rasterizer_compound_aa<Clip>::sweep_styles()
-    {
-        for(;;)
-        {
-            if(m_scan_y > m_outline.max_y()) return 0;
-            unsigned num_cells = m_outline.scanline_num_cells(m_scan_y);
-            const cell_style_aa* const* cells = m_outline.scanline_cells(m_scan_y);
-            unsigned num_styles = m_max_style - m_min_style + 2;
-            const cell_style_aa* curr_cell;
-            unsigned style_id;
-            style_info* style;
-            cell_info* cell;
-
-            m_cells.allocate(num_cells * 2, 256); // Each cell can have two styles
-            m_ast.capacity(num_styles, 64);
-            m_asm.allocate((num_styles + 7) >> 3, 8);
-            m_asm.zero();
-
-            if(num_cells)
-            {
-                // Pre-add zero (for no-fill style, that is, -1).
-                // We need that to ensure that the "-1 style" would go first.
-                m_asm[0] |= 1; 
-                m_ast.add(0);
-                style = &m_styles[0];
-                style->start_cell = 0;
-                style->num_cells = 0;
-                style->last_x = -0x7FFFFFFF;
-
-                m_sl_start = cells[0]->x;
-                m_sl_len   = cells[num_cells-1]->x - m_sl_start + 1;
-                while(num_cells--)
-                {
-                    curr_cell = *cells++;
-                    add_style(curr_cell->left);
-                    add_style(curr_cell->right);
-                }
-
-                // Convert the Y-histogram into the array of starting indexes
-                unsigned i;
-                unsigned start_cell = 0;
-                for(i = 0; i < m_ast.size(); i++)
-                {
-                    style_info& st = m_styles[m_ast[i]];
-                    unsigned v = st.start_cell;
-                    st.start_cell = start_cell;
-                    start_cell += v;
-                }
-
-                cells = m_outline.scanline_cells(m_scan_y);
-                num_cells = m_outline.scanline_num_cells(m_scan_y);
-
-                while(num_cells--)
-                {
-                    curr_cell = *cells++;
-                    style_id = (curr_cell->left < 0) ? 0 : 
-                                curr_cell->left - m_min_style + 1;
-
-                    style = &m_styles[style_id];
-                    if(curr_cell->x == style->last_x)
-                    {
-                        cell = &m_cells[style->start_cell + style->num_cells - 1];
-                        cell->area  += curr_cell->area;
-                        cell->cover += curr_cell->cover;
-                    }
-                    else
-                    {
-                        cell = &m_cells[style->start_cell + style->num_cells];
-                        cell->x       = curr_cell->x;
-                        cell->area    = curr_cell->area;
-                        cell->cover   = curr_cell->cover;
-                        style->last_x = curr_cell->x;
-                        style->num_cells++;
-                    }
-
-                    style_id = (curr_cell->right < 0) ? 0 : 
-                                curr_cell->right - m_min_style + 1;
-
-                    style = &m_styles[style_id];
-                    if(curr_cell->x == style->last_x)
-                    {
-                        cell = &m_cells[style->start_cell + style->num_cells - 1];
-                        cell->area  -= curr_cell->area;
-                        cell->cover -= curr_cell->cover;
-                    }
-                    else
-                    {
-                        cell = &m_cells[style->start_cell + style->num_cells];
-                        cell->x       =  curr_cell->x;
-                        cell->area    = -curr_cell->area;
-                        cell->cover   = -curr_cell->cover;
-                        style->last_x =  curr_cell->x;
-                        style->num_cells++;
-                    }
-                }
-            }
-            if(m_ast.size() > 1) break;
-            ++m_scan_y;
-        }
-        ++m_scan_y;
-
-        if(m_layer_order != layer_unsorted)
-        {
-            range_adaptor<pod_vector<unsigned> > ra(m_ast, 1, m_ast.size() - 1);
-            if(m_layer_order == layer_direct) quick_sort(ra, unsigned_greater);
-            else                              quick_sort(ra, unsigned_less);
-        }
-
-        return m_ast.size() - 1;
-    }
-
-    //------------------------------------------------------------------------
-    // Returns style ID depending of the existing style index
-    template<class Clip> 
-    AGG_INLINE 
-    unsigned rasterizer_compound_aa<Clip>::style(unsigned style_idx) const
-    {
-        return m_ast[style_idx + 1] + m_min_style - 1;
-    }
-
-    //------------------------------------------------------------------------ 
-    template<class Clip> 
-    AGG_INLINE bool rasterizer_compound_aa<Clip>::navigate_scanline(int y)
-    {
-        m_outline.sort_cells();
-        if(m_outline.total_cells() == 0) 
-        {
-            return false;
-        }
-        if(m_max_style < m_min_style)
-        {
-            return false;
-        }
-        if(y < m_outline.min_y() || y > m_outline.max_y()) 
-        {
-            return false;
-        }
-        m_scan_y = y;
-        m_styles.allocate(m_max_style - m_min_style + 2, 128);
-        allocate_master_alpha();
-        return true;
-    }
-    
-    //------------------------------------------------------------------------ 
-    template<class Clip> 
-    bool rasterizer_compound_aa<Clip>::hit_test(int tx, int ty)
-    {
-        if(!navigate_scanline(ty)) 
-        {
-            return false;
-        }
-
-        unsigned num_styles = sweep_styles(); 
-        if(num_styles <= 0)
-        {
-            return false;
-        }
-
-        scanline_hit_test sl(tx);
-        sweep_scanline(sl, -1);
-        return sl.hit();
-    }
-
-    //------------------------------------------------------------------------ 
-    template<class Clip> 
-    cover_type* rasterizer_compound_aa<Clip>::allocate_cover_buffer(unsigned len)
-    {
-        m_cover_buf.allocate(len, 256);
-        return &m_cover_buf[0];
-    }
-
-    //------------------------------------------------------------------------ 
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::allocate_master_alpha()
-    {
-        while((int)m_master_alpha.size() <= m_max_style)
-        {
-            m_master_alpha.add(aa_mask);
-        }
-    }
-
-    //------------------------------------------------------------------------ 
-    template<class Clip> 
-    void rasterizer_compound_aa<Clip>::master_alpha(int style, double alpha)
-    {
-        if(style >= 0)
-        {
-            while((int)m_master_alpha.size() <= style)
-            {
-                m_master_alpha.add(aa_mask);
-            }
-            m_master_alpha[style] = uround(alpha * aa_mask);
-        }
-    }
-
-}
-
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_rasterizer_outline.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_outline.h
--- 8.0.1-5/renderers/agg/include/agg_rasterizer_outline.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_outline.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,147 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_RASTERIZER_OUTLINE_INCLUDED
-#define AGG_RASTERIZER_OUTLINE_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //======================================================rasterizer_outline
-    template<class Renderer> class rasterizer_outline
-    {
-    public:
-        explicit rasterizer_outline(Renderer& ren) : 
-            m_ren(&ren), 
-            m_start_x(0), 
-            m_start_y(0), 
-            m_vertices(0)
-        {}
-        void attach(Renderer& ren) { m_ren = &ren; }
-
-
-        //--------------------------------------------------------------------
-        void move_to(int x, int y)
-        {
-            m_vertices = 1;
-            m_ren->move_to(m_start_x = x, m_start_y = y);
-        }
-
-        //--------------------------------------------------------------------
-        void line_to(int x, int y)
-        {
-            ++m_vertices;
-            m_ren->line_to(x, y);
-        }
-
-        //--------------------------------------------------------------------
-        void move_to_d(double x, double y)
-        {
-            move_to(m_ren->coord(x), m_ren->coord(y));
-        }
-
-        //--------------------------------------------------------------------
-        void line_to_d(double x, double y)
-        {
-            line_to(m_ren->coord(x), m_ren->coord(y));
-        }
-
-        //--------------------------------------------------------------------
-        void close()
-        {
-            if(m_vertices > 2)
-            {
-                line_to(m_start_x, m_start_y);
-            }
-            m_vertices = 0;
-        }
-
-        //--------------------------------------------------------------------
-        void add_vertex(double x, double y, unsigned cmd)
-        {
-            if(is_move_to(cmd)) 
-            {
-                move_to_d(x, y);
-            }
-            else 
-            {
-                if(is_end_poly(cmd))
-                {
-                    if(is_closed(cmd)) close();
-                }
-                else
-                {
-                    line_to_d(x, y);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        template<class VertexSource>
-        void add_path(VertexSource& vs, unsigned path_id=0)
-        {
-            double x;
-            double y;
-
-            unsigned cmd;
-            vs.rewind(path_id);
-            while(!is_stop(cmd = vs.vertex(&x, &y)))
-            {
-                add_vertex(x, y, cmd);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        template<class VertexSource, class ColorStorage, class PathId>
-        void render_all_paths(VertexSource& vs, 
-                              const ColorStorage& colors, 
-                              const PathId& path_id,
-                              unsigned num_paths)
-        {
-            for(unsigned i = 0; i < num_paths; i++)
-            {
-                m_ren->line_color(colors[i]);
-                add_path(vs, path_id[i]);
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        template<class Ctrl> void render_ctrl(Ctrl& c)
-        {
-            unsigned i;
-            for(i = 0; i < c.num_paths(); i++)
-            {
-                m_ren->line_color(c.color(i));
-                add_path(c, i);
-            }
-        }
-
-
-    private:
-        Renderer* m_ren;
-        int       m_start_x;
-        int       m_start_y;
-        unsigned  m_vertices;
-    };
-
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_rasterizer_outline_aa.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_outline_aa.h
--- 8.0.1-5/renderers/agg/include/agg_rasterizer_outline_aa.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_outline_aa.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,598 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_RASTERIZER_OUTLINE_AA_INCLUDED
-#define AGG_RASTERIZER_OUTLINE_AA_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_line_aa_basics.h"
-#include "agg_vertex_sequence.h"
-
-namespace mapserver
-{
-
-    //-------------------------------------------------------------------------
-    inline bool cmp_dist_start(int d) { return d > 0;  }
-    inline bool cmp_dist_end(int d)   { return d <= 0; }
-
-
-
-    //-----------------------------------------------------------line_aa_vertex
-    // Vertex (x, y) with the distance to the next one. The last vertex has 
-    // the distance between the last and the first points
-    struct line_aa_vertex
-    {
-        int x = 0;
-        int y = 0;
-        int len = 0;
-
-        line_aa_vertex() = default;
-        line_aa_vertex(int x_, int y_) :
-            x(x_),
-            y(y_)
-        {
-        }
-
-        bool operator () (const line_aa_vertex& val)
-        {
-            double dx = val.x - x;
-            double dy = val.y - y;
-            return (len = uround(sqrt(dx * dx + dy * dy))) > 
-                   (line_subpixel_scale + line_subpixel_scale / 2);
-        }
-    };
-
-
-    //----------------------------------------------------------outline_aa_join_e
-    enum outline_aa_join_e
-    {
-        outline_no_join,             //-----outline_no_join
-        outline_miter_join,          //-----outline_miter_join
-        outline_round_join,          //-----outline_round_join
-        outline_miter_accurate_join  //-----outline_accurate_join
-    };
-
-    //=======================================================rasterizer_outline_aa
-    template<class Renderer, class Coord=line_coord> class rasterizer_outline_aa
-    {
-    private:
-        //------------------------------------------------------------------------
-        struct draw_vars
-        {
-            unsigned idx;
-            int x1, y1, x2, y2;
-            line_parameters curr, next;
-            int lcurr, lnext;
-            int xb1, yb1, xb2, yb2;
-            unsigned flags;
-        };
-
-        void draw(draw_vars& dv, unsigned start, unsigned end);
-
-    public:
-        typedef line_aa_vertex                  vertex_type;
-        typedef vertex_sequence<vertex_type, 6> vertex_storage_type;
-
-        explicit rasterizer_outline_aa(Renderer& ren) : 
-            m_ren(&ren), 
-            m_line_join(ren.accurate_join_only() ? 
-                            outline_miter_accurate_join : 
-                            outline_round_join),
-            m_round_cap(false),
-            m_start_x(0),
-            m_start_y(0)
-        {}
-        void attach(Renderer& ren) { m_ren = &ren; }
-
-        //------------------------------------------------------------------------
-        void line_join(outline_aa_join_e join) 
-        { 
-            m_line_join = m_ren->accurate_join_only() ? 
-                outline_miter_accurate_join : 
-                join; 
-        }
-        bool line_join() const { return m_line_join; }
-
-        //------------------------------------------------------------------------
-        void round_cap(bool v) { m_round_cap = v; }
-        bool round_cap() const { return m_round_cap; }
-
-        //------------------------------------------------------------------------
-        void move_to(int x, int y)
-        {
-            m_src_vertices.modify_last(vertex_type(m_start_x = x, m_start_y = y));
-        }
-
-        //------------------------------------------------------------------------
-        void line_to(int x, int y)
-        {
-            m_src_vertices.add(vertex_type(x, y));
-        }
-
-        //------------------------------------------------------------------------
-        void move_to_d(double x, double y)
-        {
-            move_to(Coord::conv(x), Coord::conv(y));
-        }
-
-        //------------------------------------------------------------------------
-        void line_to_d(double x, double y)
-        {
-            line_to(Coord::conv(x), Coord::conv(y));
-        }
-
-        //------------------------------------------------------------------------
-        void render(bool close_polygon);
-
-        //------------------------------------------------------------------------
-        void add_vertex(double x, double y, unsigned cmd)
-        {
-            if(is_move_to(cmd)) 
-            {
-                render(false);
-                move_to_d(x, y);
-            }
-            else 
-            {
-                if(is_end_poly(cmd))
-                {
-                    render(is_closed(cmd));
-                    if(is_closed(cmd)) 
-                    {
-                        move_to(m_start_x, m_start_y);
-                    }
-                }
-                else
-                {
-                    line_to_d(x, y);
-                }
-            }
-        }
-
-        //------------------------------------------------------------------------
-        template<class VertexSource>
-        void add_path(VertexSource& vs, unsigned path_id=0)
-        {
-            double x;
-            double y;
-
-            unsigned cmd;
-            vs.rewind(path_id);
-            while(!is_stop(cmd = vs.vertex(&x, &y)))
-            {
-                add_vertex(x, y, cmd);
-            }
-            render(false);
-        }
-
-
-        //------------------------------------------------------------------------
-        template<class VertexSource, class ColorStorage, class PathId>
-        void render_all_paths(VertexSource& vs, 
-                              const ColorStorage& colors, 
-                              const PathId& path_id,
-                              unsigned num_paths)
-        {
-            for(unsigned i = 0; i < num_paths; i++)
-            {
-                m_ren->color(colors[i]);
-                add_path(vs, path_id[i]);
-            }
-        }
-
-
-        //------------------------------------------------------------------------
-        template<class Ctrl> void render_ctrl(Ctrl& c)
-        {
-            unsigned i;
-            for(i = 0; i < c.num_paths(); i++)
-            {
-                m_ren->color(c.color(i));
-                add_path(c, i);
-            }
-        }
-
-    private:
-        rasterizer_outline_aa(const rasterizer_outline_aa<Renderer, Coord>&);
-        const rasterizer_outline_aa<Renderer, Coord>& operator = 
-            (const rasterizer_outline_aa<Renderer, Coord>&);
-
-        Renderer*           m_ren;
-        vertex_storage_type m_src_vertices;
-        outline_aa_join_e   m_line_join;
-        bool                m_round_cap;
-        int                 m_start_x;
-        int                 m_start_y;
-    };
-
-
-
-
-
-
-
-
-    //----------------------------------------------------------------------------
-    template<class Renderer, class Coord> 
-    void rasterizer_outline_aa<Renderer, Coord>::draw(draw_vars& dv, 
-                                                      unsigned start, 
-                                                      unsigned end)
-    {
-        unsigned i;
-        const vertex_storage_type::value_type* v;
-
-        for(i = start; i < end; i++)
-        {
-            if(m_line_join == outline_round_join)
-            {
-                dv.xb1 = dv.curr.x1 + (dv.curr.y2 - dv.curr.y1); 
-                dv.yb1 = dv.curr.y1 - (dv.curr.x2 - dv.curr.x1); 
-                dv.xb2 = dv.curr.x2 + (dv.curr.y2 - dv.curr.y1); 
-                dv.yb2 = dv.curr.y2 - (dv.curr.x2 - dv.curr.x1);
-            }
-
-            switch(dv.flags)
-            {
-            case 0: m_ren->line3(dv.curr, dv.xb1, dv.yb1, dv.xb2, dv.yb2); break;
-            case 1: m_ren->line2(dv.curr, dv.xb2, dv.yb2); break;
-            case 2: m_ren->line1(dv.curr, dv.xb1, dv.yb1); break;
-            case 3: m_ren->line0(dv.curr); break;
-            }
-
-            if(m_line_join == outline_round_join && (dv.flags & 2) == 0)
-            {
-                m_ren->pie(dv.curr.x2, dv.curr.y2, 
-                           dv.curr.x2 + (dv.curr.y2 - dv.curr.y1),
-                           dv.curr.y2 - (dv.curr.x2 - dv.curr.x1),
-                           dv.curr.x2 + (dv.next.y2 - dv.next.y1),
-                           dv.curr.y2 - (dv.next.x2 - dv.next.x1));
-            }
-
-            dv.x1 = dv.x2;
-            dv.y1 = dv.y2;
-            dv.lcurr = dv.lnext;
-            dv.lnext = m_src_vertices[dv.idx].len;
-
-            ++dv.idx;
-            if(dv.idx >= m_src_vertices.size()) dv.idx = 0; 
-
-            v = &m_src_vertices[dv.idx];
-            dv.x2 = v->x;
-            dv.y2 = v->y;
-
-            dv.curr = dv.next;
-            dv.next = line_parameters(dv.x1, dv.y1, dv.x2, dv.y2, dv.lnext);
-            dv.xb1 = dv.xb2;
-            dv.yb1 = dv.yb2;
-
-            switch(m_line_join)
-            {
-            case outline_no_join:
-                dv.flags = 3;
-                break;
-
-            case outline_miter_join:
-                dv.flags >>= 1;
-                dv.flags |= ((dv.curr.diagonal_quadrant() == 
-                              dv.next.diagonal_quadrant()) << 1);
-                if((dv.flags & 2) == 0)
-                {
-                    bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
-                }
-                break;
-
-            case outline_round_join:
-                dv.flags >>= 1;
-                dv.flags |= ((dv.curr.diagonal_quadrant() == 
-                              dv.next.diagonal_quadrant()) << 1);
-                break;
-
-            case outline_miter_accurate_join:
-                dv.flags = 0;
-                bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
-                break;
-            }
-        }
-    }
-
-
-
-
-    //----------------------------------------------------------------------------
-    template<class Renderer, class Coord> 
-    void rasterizer_outline_aa<Renderer, Coord>::render(bool close_polygon)
-    {
-        m_src_vertices.close(close_polygon);
-        draw_vars dv;
-        const vertex_storage_type::value_type* v;
-        int x1;
-        int y1;
-        int x2;
-        int y2;
-        int lprev;
-
-        if(close_polygon)
-        {
-            if(m_src_vertices.size() >= 3)
-            {
-                dv.idx = 2;
-
-                v     = &m_src_vertices[m_src_vertices.size() - 1];
-                x1    = v->x;
-                y1    = v->y;
-                lprev = v->len;
-
-                v  = &m_src_vertices[0];
-                x2 = v->x;
-                y2 = v->y;
-                dv.lcurr = v->len;
-                line_parameters prev(x1, y1, x2, y2, lprev);
-
-                v = &m_src_vertices[1];
-                dv.x1    = v->x;
-                dv.y1    = v->y;
-                dv.lnext = v->len;
-                dv.curr = line_parameters(x2, y2, dv.x1, dv.y1, dv.lcurr);
-
-                v = &m_src_vertices[dv.idx];
-                dv.x2 = v->x;
-                dv.y2 = v->y;
-                dv.next = line_parameters(dv.x1, dv.y1, dv.x2, dv.y2, dv.lnext);
-
-                dv.xb1 = 0;
-                dv.yb1 = 0;
-                dv.xb2 = 0;
-                dv.yb2 = 0;
-
-                switch(m_line_join)
-                {
-                case outline_no_join:
-                    dv.flags = 3;
-                    break;
-
-                case outline_miter_join:
-                case outline_round_join:
-                    dv.flags = 
-                            (prev.diagonal_quadrant() == dv.curr.diagonal_quadrant()) |
-                        ((dv.curr.diagonal_quadrant() == dv.next.diagonal_quadrant()) << 1);
-                    break;
-
-                case outline_miter_accurate_join:
-                    dv.flags = 0;
-                    break;
-                }
-
-                if((dv.flags & 1) == 0 && m_line_join != outline_round_join)
-                {
-                    bisectrix(prev, dv.curr, &dv.xb1, &dv.yb1);
-                }
-
-                if((dv.flags & 2) == 0 && m_line_join != outline_round_join)
-                {
-                    bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
-                }
-                draw(dv, 0, m_src_vertices.size());
-            }
-        }
-        else
-        {
-            switch(m_src_vertices.size())
-            {
-                case 0:
-                case 1:
-                    break;
-
-                case 2:
-                {
-                    v     = &m_src_vertices[0];
-                    x1    = v->x;
-                    y1    = v->y;
-                    lprev = v->len;
-                    v     = &m_src_vertices[1];
-                    x2    = v->x;
-                    y2    = v->y;
-                    line_parameters lp(x1, y1, x2, y2, lprev);
-                    if(m_round_cap) 
-                    {
-                        m_ren->semidot(cmp_dist_start, x1, y1, x1 + (y2 - y1), y1 - (x2 - x1));
-                    }
-                    m_ren->line3(lp, 
-                                 x1 + (y2 - y1), 
-                                 y1 - (x2 - x1),
-                                 x2 + (y2 - y1), 
-                                 y2 - (x2 - x1));
-                    if(m_round_cap) 
-                    {
-                        m_ren->semidot(cmp_dist_end, x2, y2, x2 + (y2 - y1), y2 - (x2 - x1));
-                    }
-                }
-                break;
-
-                case 3:
-                {
-                    int x3, y3;
-                    int lnext;
-                    v     = &m_src_vertices[0];
-                    x1    = v->x;
-                    y1    = v->y;
-                    lprev = v->len;
-                    v     = &m_src_vertices[1];
-                    x2    = v->x;
-                    y2    = v->y;
-                    lnext = v->len;
-                    v     = &m_src_vertices[2];
-                    x3    = v->x;
-                    y3    = v->y;
-                    line_parameters lp1(x1, y1, x2, y2, lprev);
-                    line_parameters lp2(x2, y2, x3, y3, lnext);
-
-                    if(m_round_cap) 
-                    {
-                        m_ren->semidot(cmp_dist_start, x1, y1, x1 + (y2 - y1), y1 - (x2 - x1));
-                    }
-
-                    if(m_line_join == outline_round_join)
-                    {
-                        m_ren->line3(lp1, x1 + (y2 - y1), y1 - (x2 - x1), 
-                                          x2 + (y2 - y1), y2 - (x2 - x1));
-
-                        m_ren->pie(x2, y2, x2 + (y2 - y1), y2 - (x2 - x1),
-                                           x2 + (y3 - y2), y2 - (x3 - x2));
-
-                        m_ren->line3(lp2, x2 + (y3 - y2), y2 - (x3 - x2),
-                                          x3 + (y3 - y2), y3 - (x3 - x2));
-                    }
-                    else
-                    {
-                        bisectrix(lp1, lp2, &dv.xb1, &dv.yb1);
-                        m_ren->line3(lp1, x1 + (y2 - y1), y1 - (x2 - x1),
-                                          dv.xb1,         dv.yb1);
-
-                        m_ren->line3(lp2, dv.xb1,         dv.yb1,
-                                          x3 + (y3 - y2), y3 - (x3 - x2));
-                    }
-                    if(m_round_cap) 
-                    {
-                        m_ren->semidot(cmp_dist_end, x3, y3, x3 + (y3 - y2), y3 - (x3 - x2));
-                    }
-                }
-                break;
-
-                default:
-                {
-                    dv.idx = 3;
-
-                    v     = &m_src_vertices[0];
-                    x1    = v->x;
-                    y1    = v->y;
-                    lprev = v->len;
-
-                    v  = &m_src_vertices[1];
-                    x2 = v->x;
-                    y2 = v->y;
-                    dv.lcurr = v->len;
-                    line_parameters prev(x1, y1, x2, y2, lprev);
-
-                    v = &m_src_vertices[2];
-                    dv.x1    = v->x;
-                    dv.y1    = v->y;
-                    dv.lnext = v->len;
-                    dv.curr = line_parameters(x2, y2, dv.x1, dv.y1, dv.lcurr);
-
-                    v = &m_src_vertices[dv.idx];
-                    dv.x2 = v->x;
-                    dv.y2 = v->y;
-                    dv.next = line_parameters(dv.x1, dv.y1, dv.x2, dv.y2, dv.lnext);
-
-                    dv.xb1 = 0;
-                    dv.yb1 = 0;
-                    dv.xb2 = 0;
-                    dv.yb2 = 0;
-
-                    switch(m_line_join)
-                    {
-                    case outline_no_join:
-                        dv.flags = 3;
-                        break;
-
-                    case outline_miter_join:
-                    case outline_round_join:
-                        dv.flags = 
-                                (prev.diagonal_quadrant() == dv.curr.diagonal_quadrant()) |
-                            ((dv.curr.diagonal_quadrant() == dv.next.diagonal_quadrant()) << 1);
-                        break;
-
-                    case outline_miter_accurate_join:
-                        dv.flags = 0;
-                        break;
-                    }
-
-                    if(m_round_cap) 
-                    {
-                        m_ren->semidot(cmp_dist_start, x1, y1, x1 + (y2 - y1), y1 - (x2 - x1));
-                    }
-                    if((dv.flags & 1) == 0)
-                    {
-                        if(m_line_join == outline_round_join)
-                        {
-                            m_ren->line3(prev, x1 + (y2 - y1), y1 - (x2 - x1),
-                                               x2 + (y2 - y1), y2 - (x2 - x1));
-                            m_ren->pie(prev.x2, prev.y2, 
-                                       x2 + (y2 - y1), y2 - (x2 - x1),
-                                       dv.curr.x1 + (dv.curr.y2 - dv.curr.y1), 
-                                       dv.curr.y1 - (dv.curr.x2 - dv.curr.x1));
-                        }
-                        else
-                        {
-                            bisectrix(prev, dv.curr, &dv.xb1, &dv.yb1);
-                            m_ren->line3(prev, x1 + (y2 - y1), y1 - (x2 - x1),
-                                               dv.xb1,         dv.yb1);
-                        }
-                    }
-                    else
-                    {
-                        m_ren->line1(prev, 
-                                     x1 + (y2 - y1), 
-                                     y1 - (x2 - x1));
-                    }
-                    if((dv.flags & 2) == 0 && m_line_join != outline_round_join)
-                    {
-                        bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
-                    }
-
-                    draw(dv, 1, m_src_vertices.size() - 2);
-
-                    if((dv.flags & 1) == 0)
-                    {
-                        if(m_line_join == outline_round_join)
-                        {
-                            m_ren->line3(dv.curr, 
-                                         dv.curr.x1 + (dv.curr.y2 - dv.curr.y1), 
-                                         dv.curr.y1 - (dv.curr.x2 - dv.curr.x1),
-                                         dv.curr.x2 + (dv.curr.y2 - dv.curr.y1), 
-                                         dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
-                        }
-                        else
-                        {
-                            m_ren->line3(dv.curr, dv.xb1, dv.yb1,
-                                         dv.curr.x2 + (dv.curr.y2 - dv.curr.y1), 
-                                         dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
-                        }
-                    }
-                    else
-                    {
-                        m_ren->line2(dv.curr, 
-                                     dv.curr.x2 + (dv.curr.y2 - dv.curr.y1), 
-                                     dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
-                    }
-                    if(m_round_cap) 
-                    {
-                        m_ren->semidot(cmp_dist_end, dv.curr.x2, dv.curr.y2,
-                                       dv.curr.x2 + (dv.curr.y2 - dv.curr.y1),
-                                       dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
-                    }
-
-                }
-                break;
-            }
-        }
-        m_src_vertices.remove_all();
-    }
-
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_rasterizer_scanline_aa.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_scanline_aa.h
--- 8.0.1-5/renderers/agg/include/agg_rasterizer_scanline_aa.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_scanline_aa.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,510 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-//
-// The author gratefully acknowleges the support of David Turner, 
-// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
-// libray - in producing this work. See http://www.freetype.org for details.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-#ifndef AGG_RASTERIZER_SCANLINE_AA_INCLUDED
-#define AGG_RASTERIZER_SCANLINE_AA_INCLUDED
-
-#include "agg_rasterizer_cells_aa.h"
-#include "agg_rasterizer_sl_clip.h"
-#include "agg_gamma_functions.h"
-
-
-namespace mapserver
-{
-
-
-    //-----------------------------------------------------------------cell_aa
-    // A pixel cell. There're no constructors defined and it was done 
-    // intentionally in order to avoid extra overhead when allocating an 
-    // array of cells.
-    struct cell_aa
-    {
-        int x;
-        int y;
-        int cover;
-        int area;
-
-        void initial()
-        {
-            x = 0x7FFFFFFF;
-            y = 0x7FFFFFFF;
-            cover = 0;
-            area  = 0;
-        }
-
-        void style(const cell_aa&) {}
-
-        int not_equal(int ex, int ey, const cell_aa&) const
-        {
-            return (ex - x) | (ey - y);
-        }
-    };
-
-
-    //==================================================rasterizer_scanline_aa
-    // Polygon rasterizer that is used to render filled polygons with 
-    // high-quality Anti-Aliasing. Internally, by default, the class uses 
-    // integer coordinates in format 24.8, i.e. 24 bits for integer part 
-    // and 8 bits for fractional - see poly_subpixel_shift. This class can be 
-    // used in the following  way:
-    //
-    // 1. filling_rule(filling_rule_e ft) - optional.
-    //
-    // 2. gamma() - optional.
-    //
-    // 3. reset()
-    //
-    // 4. move_to(x, y) / line_to(x, y) - make the polygon. One can create 
-    //    more than one contour, but each contour must consist of at least 3
-    //    vertices, i.e. move_to(x1, y1); line_to(x2, y2); line_to(x3, y3);
-    //    is the absolute minimum of vertices that define a triangle.
-    //    The algorithm does not check either the number of vertices nor
-    //    coincidence of their coordinates, but in the worst case it just 
-    //    won't draw anything.
-    //    The orger of the vertices (clockwise or counterclockwise) 
-    //    is important when using the non-zero filling rule (fill_non_zero).
-    //    In this case the vertex order of all the contours must be the same
-    //    if you want your intersecting polygons to be without "holes".
-    //    You actually can use different vertices order. If the contours do not 
-    //    intersect each other the order is not important anyway. If they do, 
-    //    contours with the same vertex order will be rendered without "holes" 
-    //    while the intersecting contours with different orders will have "holes".
-    //
-    // filling_rule() and gamma() can be called anytime before "sweeping".
-    //------------------------------------------------------------------------
-    template<class Clip=rasterizer_sl_clip_int> class rasterizer_scanline_aa
-    {
-        enum status
-        {
-            status_initial,
-            status_move_to,
-            status_line_to,
-            status_closed
-        };
-
-    public:
-        typedef Clip                      clip_type;
-        typedef typename Clip::conv_type  conv_type;
-        typedef typename Clip::coord_type coord_type;
-
-        enum aa_scale_e
-        {
-            aa_shift  = 8,
-            aa_scale  = 1 << aa_shift,
-            aa_mask   = aa_scale - 1,
-            aa_scale2 = aa_scale * 2,
-            aa_mask2  = aa_scale2 - 1
-        };
-
-        //--------------------------------------------------------------------
-        rasterizer_scanline_aa() : 
-            m_outline(),
-            m_clipper(),
-            m_filling_rule(fill_non_zero),
-            m_auto_close(true),
-            m_start_x(0),
-            m_start_y(0),
-            m_status(status_initial)
-        {
-            int i;
-            for(i = 0; i < aa_scale; i++) m_gamma[i] = i;
-        }
-
-        //--------------------------------------------------------------------
-        template<class GammaF> 
-        rasterizer_scanline_aa(const GammaF& gamma_function) : 
-            m_outline(),
-            m_clipper(m_outline),
-            m_filling_rule(fill_non_zero),
-            m_auto_close(true),
-            m_start_x(0),
-            m_start_y(0),
-            m_status(status_initial)
-        {
-            gamma(gamma_function);
-        }
-
-        //--------------------------------------------------------------------
-        void reset(); 
-        void reset_clipping();
-        void clip_box(double x1, double y1, double x2, double y2);
-        void filling_rule(filling_rule_e filling_rule);
-        void auto_close(bool flag) { m_auto_close = flag; }
-
-        //--------------------------------------------------------------------
-        template<class GammaF> void gamma(const GammaF& gamma_function)
-        { 
-            int i;
-            for(i = 0; i < aa_scale; i++)
-            {
-                m_gamma[i] = uround(gamma_function(double(i) / aa_mask) * aa_mask);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        unsigned apply_gamma(unsigned cover) const 
-        { 
-            return m_gamma[cover]; 
-        }
-
-        //--------------------------------------------------------------------
-        void move_to(int x, int y);
-        void line_to(int x, int y);
-        void move_to_d(double x, double y);
-        void line_to_d(double x, double y);
-        void close_polygon();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        void edge(int x1, int y1, int x2, int y2);
-        void edge_d(double x1, double y1, double x2, double y2);
-
-        //-------------------------------------------------------------------
-        template<class VertexSource>
-        void add_path(VertexSource& vs, unsigned path_id=0)
-        {
-            double x = 0;
-            double y = 0;
-
-            unsigned cmd;
-            vs.rewind(path_id);
-            if(m_outline.sorted()) reset();
-            while(!is_stop(cmd = vs.vertex(&x, &y)))
-            {
-                add_vertex(x, y, cmd);
-            }
-        }
-        
-        //--------------------------------------------------------------------
-        int min_x() const { return m_outline.min_x(); }
-        int min_y() const { return m_outline.min_y(); }
-        int max_x() const { return m_outline.max_x(); }
-        int max_y() const { return m_outline.max_y(); }
-
-        //--------------------------------------------------------------------
-        void sort();
-        bool rewind_scanlines();
-        bool navigate_scanline(int y);
-
-        //--------------------------------------------------------------------
-        AGG_INLINE unsigned calculate_alpha(int area) const
-        {
-            int cover = area >> (poly_subpixel_shift*2 + 1 - aa_shift);
-
-            if(cover < 0) cover = -cover;
-            if(m_filling_rule == fill_even_odd)
-            {
-                cover &= aa_mask2;
-                if(cover > aa_scale)
-                {
-                    cover = aa_scale2 - cover;
-                }
-            }
-            if(cover > aa_mask) cover = aa_mask;
-            return m_gamma[cover];
-        }
-
-        //--------------------------------------------------------------------
-        template<class Scanline> bool sweep_scanline(Scanline& sl)
-        {
-            for(;;)
-            {
-                if(m_scan_y > m_outline.max_y()) return false;
-                sl.reset_spans();
-                unsigned num_cells = m_outline.scanline_num_cells(m_scan_y);
-                const cell_aa* const* cells = m_outline.scanline_cells(m_scan_y);
-                int cover = 0;
-
-                while(num_cells)
-                {
-                    const cell_aa* cur_cell = *cells;
-                    int x    = cur_cell->x;
-                    int area = cur_cell->area;
-                    unsigned alpha;
-
-                    cover += cur_cell->cover;
-
-                    //accumulate all cells with the same X
-                    while(--num_cells)
-                    {
-                        cur_cell = *++cells;
-                        if(cur_cell->x != x) break;
-                        area  += cur_cell->area;
-                        cover += cur_cell->cover;
-                    }
-
-                    if(area)
-                    {
-                        alpha = calculate_alpha((cover << (poly_subpixel_shift + 1)) - area);
-                        if(alpha)
-                        {
-                            sl.add_cell(x, alpha);
-                        }
-                        x++;
-                    }
-
-                    if(num_cells && cur_cell->x > x)
-                    {
-                        alpha = calculate_alpha(cover << (poly_subpixel_shift + 1));
-                        if(alpha)
-                        {
-                            sl.add_span(x, cur_cell->x - x, alpha);
-                        }
-                    }
-                }
-        
-                if(sl.num_spans()) break;
-                ++m_scan_y;
-            }
-
-            sl.finalize(m_scan_y);
-            ++m_scan_y;
-            return true;
-        }
-
-        //--------------------------------------------------------------------
-        bool hit_test(int tx, int ty);
-
-
-    private:
-        //--------------------------------------------------------------------
-        // Disable copying
-        rasterizer_scanline_aa(const rasterizer_scanline_aa<Clip>&);
-        const rasterizer_scanline_aa<Clip>& 
-        operator = (const rasterizer_scanline_aa<Clip>&);
-
-    private:
-        rasterizer_cells_aa<cell_aa> m_outline;
-        clip_type      m_clipper;
-        int            m_gamma[aa_scale];
-        filling_rule_e m_filling_rule;
-        bool           m_auto_close;
-        coord_type     m_start_x;
-        coord_type     m_start_y;
-        unsigned       m_status;
-        int            m_scan_y = 0;
-    };
-
-
-
-
-
-
-
-
-
-
-
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::reset() 
-    { 
-        m_outline.reset(); 
-        m_status = status_initial;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::filling_rule(filling_rule_e filling_rule) 
-    { 
-        m_filling_rule = filling_rule; 
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::clip_box(double x1, double y1, 
-                                                double x2, double y2)
-    {
-        reset();
-        m_clipper.clip_box(conv_type::upscale(x1), conv_type::upscale(y1), 
-                           conv_type::upscale(x2), conv_type::upscale(y2));
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::reset_clipping()
-    {
-        reset();
-        m_clipper.reset_clipping();
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::close_polygon()
-    {
-        if(m_status == status_line_to)
-        {
-            m_clipper.line_to(m_outline, m_start_x, m_start_y);
-            m_status = status_closed;
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::move_to(int x, int y)
-    {
-        if(m_outline.sorted()) reset();
-        if(m_auto_close) close_polygon();
-        m_clipper.move_to(m_start_x = conv_type::downscale(x), 
-                          m_start_y = conv_type::downscale(y));
-        m_status = status_move_to;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::line_to(int x, int y)
-    {
-        m_clipper.line_to(m_outline, 
-                          conv_type::downscale(x), 
-                          conv_type::downscale(y));
-        m_status = status_line_to;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::move_to_d(double x, double y) 
-    { 
-        if(m_outline.sorted()) reset();
-        if(m_auto_close) close_polygon();
-        m_clipper.move_to(m_start_x = conv_type::upscale(x), 
-                          m_start_y = conv_type::upscale(y)); 
-        m_status = status_move_to;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::line_to_d(double x, double y) 
-    { 
-        m_clipper.line_to(m_outline, 
-                          conv_type::upscale(x), 
-                          conv_type::upscale(y)); 
-        m_status = status_line_to;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::add_vertex(double x, double y, unsigned cmd)
-    {
-        if(is_move_to(cmd)) 
-        {
-            move_to_d(x, y);
-        }
-        else 
-        if(is_vertex(cmd))
-        {
-            line_to_d(x, y);
-        }
-        else
-        if(is_close(cmd))
-        {
-            close_polygon();
-        }
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::edge(int x1, int y1, int x2, int y2)
-    {
-        if(m_outline.sorted()) reset();
-        m_clipper.move_to(conv_type::downscale(x1), conv_type::downscale(y1));
-        m_clipper.line_to(m_outline, 
-                          conv_type::downscale(x2), 
-                          conv_type::downscale(y2));
-        m_status = status_move_to;
-    }
-    
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::edge_d(double x1, double y1, 
-                                              double x2, double y2)
-    {
-        if(m_outline.sorted()) reset();
-        m_clipper.move_to(conv_type::upscale(x1), conv_type::upscale(y1)); 
-        m_clipper.line_to(m_outline, 
-                          conv_type::upscale(x2), 
-                          conv_type::upscale(y2)); 
-        m_status = status_move_to;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    void rasterizer_scanline_aa<Clip>::sort()
-    {
-        if(m_auto_close) close_polygon();
-        m_outline.sort_cells();
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    AGG_INLINE bool rasterizer_scanline_aa<Clip>::rewind_scanlines()
-    {
-        if(m_auto_close) close_polygon();
-        m_outline.sort_cells();
-        if(m_outline.total_cells() == 0) 
-        {
-            return false;
-        }
-        m_scan_y = m_outline.min_y();
-        return true;
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    AGG_INLINE bool rasterizer_scanline_aa<Clip>::navigate_scanline(int y)
-    {
-        if(m_auto_close) close_polygon();
-        m_outline.sort_cells();
-        if(m_outline.total_cells() == 0 || 
-           y < m_outline.min_y() || 
-           y > m_outline.max_y()) 
-        {
-            return false;
-        }
-        m_scan_y = y;
-        return true;
-    }
-
-    //------------------------------------------------------------------------
-    template<class Clip> 
-    bool rasterizer_scanline_aa<Clip>::hit_test(int tx, int ty)
-    {
-        if(!navigate_scanline(ty)) return false;
-        scanline_hit_test sl(tx);
-        sweep_scanline(sl);
-        return sl.hit();
-    }
-
-
-
-}
-
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_rasterizer_sl_clip.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_sl_clip.h
--- 8.0.1-5/renderers/agg/include/agg_rasterizer_sl_clip.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rasterizer_sl_clip.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,351 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_RASTERIZER_SL_CLIP_INCLUDED
-#define AGG_RASTERIZER_SL_CLIP_INCLUDED
-
-#include "agg_clip_liang_barsky.h"
-
-namespace mapserver
-{
-    //--------------------------------------------------------poly_max_coord_e
-    enum poly_max_coord_e
-    {
-        poly_max_coord = (1 << 30) - 1 //----poly_max_coord
-    };
-    
-    //------------------------------------------------------------ras_conv_int
-    struct ras_conv_int
-    {
-        typedef int coord_type;
-        static AGG_INLINE int mul_div(double a, double b, double c)
-        {
-            return iround(a * b / c);
-        }
-        static int xi(int v) { return v; }
-        static int yi(int v) { return v; }
-        static int upscale(double v) { return iround(v * poly_subpixel_scale); }
-        static int downscale(int v)  { return v; }
-    };
-
-    //--------------------------------------------------------ras_conv_int_sat
-    struct ras_conv_int_sat
-    {
-        typedef int coord_type;
-        static AGG_INLINE int mul_div(double a, double b, double c)
-        {
-            return saturation<poly_max_coord>::iround(a * b / c);
-        }
-        static int xi(int v) { return v; }
-        static int yi(int v) { return v; }
-        static int upscale(double v) 
-        { 
-            return saturation<poly_max_coord>::iround(v * poly_subpixel_scale); 
-        }
-        static int downscale(int v) { return v; }
-    };
-
-    //---------------------------------------------------------ras_conv_int_3x
-    struct ras_conv_int_3x
-    {
-        typedef int coord_type;
-        static AGG_INLINE int mul_div(double a, double b, double c)
-        {
-            return iround(a * b / c);
-        }
-        static int xi(int v) { return v * 3; }
-        static int yi(int v) { return v; }
-        static int upscale(double v) { return iround(v * poly_subpixel_scale); }
-        static int downscale(int v)  { return v; }
-    };
-
-    //-----------------------------------------------------------ras_conv_dbl
-    struct ras_conv_dbl
-    {
-        typedef double coord_type;
-        static AGG_INLINE double mul_div(double a, double b, double c)
-        {
-            return a * b / c;
-        }
-        static int xi(double v) { return iround(v * poly_subpixel_scale); }
-        static int yi(double v) { return iround(v * poly_subpixel_scale); }
-        static double upscale(double v) { return v; }
-        static double downscale(int v)  { return v / double(poly_subpixel_scale); }
-    };
-
-    //--------------------------------------------------------ras_conv_dbl_3x
-    struct ras_conv_dbl_3x
-    {
-        typedef double coord_type;
-        static AGG_INLINE double mul_div(double a, double b, double c)
-        {
-            return a * b / c;
-        }
-        static int xi(double v) { return iround(v * poly_subpixel_scale * 3); }
-        static int yi(double v) { return iround(v * poly_subpixel_scale); }
-        static double upscale(double v) { return v; }
-        static double downscale(int v)  { return v / double(poly_subpixel_scale); }
-    };
-
-
-
-
-
-    //------------------------------------------------------rasterizer_sl_clip
-    template<class Conv> class rasterizer_sl_clip
-    {
-    public:
-        typedef Conv                      conv_type;
-        typedef typename Conv::coord_type coord_type;
-        typedef rect_base<coord_type>     rect_type;
-
-        //--------------------------------------------------------------------
-        rasterizer_sl_clip() :  
-            m_clip_box(0,0,0,0),
-            m_x1(0),
-            m_y1(0),
-            m_f1(0),
-            m_clipping(false) 
-        {}
-
-        //--------------------------------------------------------------------
-        void reset_clipping()
-        {
-            m_clipping = false;
-        }
-
-        //--------------------------------------------------------------------
-        void clip_box(coord_type x1, coord_type y1, coord_type x2, coord_type y2)
-        {
-            m_clip_box = rect_type(x1, y1, x2, y2);
-            m_clip_box.normalize();
-            m_clipping = true;
-        }
-
-        //--------------------------------------------------------------------
-        void move_to(coord_type x1, coord_type y1)
-        {
-            m_x1 = x1;
-            m_y1 = y1;
-            if(m_clipping) m_f1 = clipping_flags(x1, y1, m_clip_box);
-        }
-
-    private:
-        //------------------------------------------------------------------------
-        template<class Rasterizer>
-        AGG_INLINE void line_clip_y(Rasterizer& ras,
-                                    coord_type x1, coord_type y1, 
-                                    coord_type x2, coord_type y2, 
-                                    unsigned   f1, unsigned   f2) const
-        {
-            f1 &= 10;
-            f2 &= 10;
-            if((f1 | f2) == 0)
-            {
-                // Fully visible
-                ras.line(Conv::xi(x1), Conv::yi(y1), Conv::xi(x2), Conv::yi(y2)); 
-            }
-            else
-            {
-                if(f1 == f2)
-                {
-                    // Invisible by Y
-                    return;
-                }
-
-                coord_type tx1 = x1;
-                coord_type ty1 = y1;
-                coord_type tx2 = x2;
-                coord_type ty2 = y2;
-
-                if(f1 & 8) // y1 < clip.y1
-                {
-                    tx1 = x1 + Conv::mul_div(m_clip_box.y1-y1, x2-x1, y2-y1);
-                    ty1 = m_clip_box.y1;
-                }
-
-                if(f1 & 2) // y1 > clip.y2
-                {
-                    tx1 = x1 + Conv::mul_div(m_clip_box.y2-y1, x2-x1, y2-y1);
-                    ty1 = m_clip_box.y2;
-                }
-
-                if(f2 & 8) // y2 < clip.y1
-                {
-                    tx2 = x1 + Conv::mul_div(m_clip_box.y1-y1, x2-x1, y2-y1);
-                    ty2 = m_clip_box.y1;
-                }
-
-                if(f2 & 2) // y2 > clip.y2
-                {
-                    tx2 = x1 + Conv::mul_div(m_clip_box.y2-y1, x2-x1, y2-y1);
-                    ty2 = m_clip_box.y2;
-                }
-                ras.line(Conv::xi(tx1), Conv::yi(ty1), 
-                         Conv::xi(tx2), Conv::yi(ty2)); 
-            }
-        }
-
-
-    public:
-        //--------------------------------------------------------------------
-        template<class Rasterizer>
-        void line_to(Rasterizer& ras, coord_type x2, coord_type y2)
-        {
-            if(m_clipping)
-            {
-                unsigned f2 = clipping_flags(x2, y2, m_clip_box);
-
-                if((m_f1 & 10) == (f2 & 10) && (m_f1 & 10) != 0)
-                {
-                    // Invisible by Y
-                    m_x1 = x2;
-                    m_y1 = y2;
-                    m_f1 = f2;
-                    return;
-                }
-
-                coord_type x1 = m_x1;
-                coord_type y1 = m_y1;
-                unsigned   f1 = m_f1;
-                coord_type y3, y4;
-                unsigned   f3, f4;
-
-                switch(((f1 & 5) << 1) | (f2 & 5))
-                {
-                case 0: // Visible by X
-                    line_clip_y(ras, x1, y1, x2, y2, f1, f2);
-                    break;
-
-                case 1: // x2 > clip.x2
-                    y3 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
-                    f3 = clipping_flags_y(y3, m_clip_box);
-                    line_clip_y(ras, x1, y1, m_clip_box.x2, y3, f1, f3);
-                    line_clip_y(ras, m_clip_box.x2, y3, m_clip_box.x2, y2, f3, f2);
-                    break;
-
-                case 2: // x1 > clip.x2
-                    y3 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
-                    f3 = clipping_flags_y(y3, m_clip_box);
-                    line_clip_y(ras, m_clip_box.x2, y1, m_clip_box.x2, y3, f1, f3);
-                    line_clip_y(ras, m_clip_box.x2, y3, x2, y2, f3, f2);
-                    break;
-
-                case 3: // x1 > clip.x2 && x2 > clip.x2
-                    line_clip_y(ras, m_clip_box.x2, y1, m_clip_box.x2, y2, f1, f2);
-                    break;
-
-                case 4: // x2 < clip.x1
-                    y3 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
-                    f3 = clipping_flags_y(y3, m_clip_box);
-                    line_clip_y(ras, x1, y1, m_clip_box.x1, y3, f1, f3);
-                    line_clip_y(ras, m_clip_box.x1, y3, m_clip_box.x1, y2, f3, f2);
-                    break;
-
-                case 6: // x1 > clip.x2 && x2 < clip.x1
-                    y3 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
-                    y4 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
-                    f3 = clipping_flags_y(y3, m_clip_box);
-                    f4 = clipping_flags_y(y4, m_clip_box);
-                    line_clip_y(ras, m_clip_box.x2, y1, m_clip_box.x2, y3, f1, f3);
-                    line_clip_y(ras, m_clip_box.x2, y3, m_clip_box.x1, y4, f3, f4);
-                    line_clip_y(ras, m_clip_box.x1, y4, m_clip_box.x1, y2, f4, f2);
-                    break;
-
-                case 8: // x1 < clip.x1
-                    y3 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
-                    f3 = clipping_flags_y(y3, m_clip_box);
-                    line_clip_y(ras, m_clip_box.x1, y1, m_clip_box.x1, y3, f1, f3);
-                    line_clip_y(ras, m_clip_box.x1, y3, x2, y2, f3, f2);
-                    break;
-
-                case 9:  // x1 < clip.x1 && x2 > clip.x2
-                    y3 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
-                    y4 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
-                    f3 = clipping_flags_y(y3, m_clip_box);
-                    f4 = clipping_flags_y(y4, m_clip_box);
-                    line_clip_y(ras, m_clip_box.x1, y1, m_clip_box.x1, y3, f1, f3);
-                    line_clip_y(ras, m_clip_box.x1, y3, m_clip_box.x2, y4, f3, f4);
-                    line_clip_y(ras, m_clip_box.x2, y4, m_clip_box.x2, y2, f4, f2);
-                    break;
-
-                case 12: // x1 < clip.x1 && x2 < clip.x1
-                    line_clip_y(ras, m_clip_box.x1, y1, m_clip_box.x1, y2, f1, f2);
-                    break;
-                }
-                m_f1 = f2;
-            }
-            else
-            {
-                ras.line(Conv::xi(m_x1), Conv::yi(m_y1), 
-                         Conv::xi(x2),   Conv::yi(y2)); 
-            }
-            m_x1 = x2;
-            m_y1 = y2;
-        }
-
-
-    private:
-        rect_type        m_clip_box;
-        coord_type       m_x1;
-        coord_type       m_y1;
-        unsigned         m_f1;
-        bool             m_clipping;
-    };
-
-
-
-
-    //---------------------------------------------------rasterizer_sl_no_clip
-    class rasterizer_sl_no_clip
-    {
-    public:
-        typedef ras_conv_int conv_type;
-        typedef int          coord_type;
-
-        rasterizer_sl_no_clip() : m_x1(0), m_y1(0) {}
-
-        void reset_clipping() {}
-        void clip_box(coord_type /*x1*/, coord_type /*y1*/, coord_type /*x2*/, coord_type /*y2*/) {}
-        void move_to(coord_type x1, coord_type y1) { m_x1 = x1; m_y1 = y1; }
-
-        template<class Rasterizer>
-        void line_to(Rasterizer& ras, coord_type x2, coord_type y2) 
-        { 
-            ras.line(m_x1, m_y1, x2, y2); 
-            m_x1 = x2; 
-            m_y1 = y2;
-        }
-
-    private:
-        int m_x1, m_y1;
-    };
-
-
-    //                                         -----rasterizer_sl_clip_int
-    //                                         -----rasterizer_sl_clip_int_sat
-    //                                         -----rasterizer_sl_clip_int_3x
-    //                                         -----rasterizer_sl_clip_dbl
-    //                                         -----rasterizer_sl_clip_dbl_3x
-    //------------------------------------------------------------------------
-    typedef rasterizer_sl_clip<ras_conv_int>     rasterizer_sl_clip_int;
-    typedef rasterizer_sl_clip<ras_conv_int_sat> rasterizer_sl_clip_int_sat;
-    typedef rasterizer_sl_clip<ras_conv_int_3x>  rasterizer_sl_clip_int_3x;
-    typedef rasterizer_sl_clip<ras_conv_dbl>     rasterizer_sl_clip_dbl;
-    typedef rasterizer_sl_clip<ras_conv_dbl_3x>  rasterizer_sl_clip_dbl_3x;
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_base.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_base.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_base.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_base.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,718 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class renderer_base
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERER_BASE_INCLUDED
-#define AGG_RENDERER_BASE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_rendering_buffer.h"
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------------renderer_base
-    template<class PixelFormat> class renderer_base
-    {
-    public:
-        typedef PixelFormat pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::row_data row_data;
-
-        //--------------------------------------------------------------------
-        renderer_base() : m_ren(0), m_clip_box(1, 1, 0, 0) {}
-        explicit renderer_base(pixfmt_type& ren) :
-            m_ren(&ren),
-            m_clip_box(0, 0, ren.width() - 1, ren.height() - 1)
-        {}
-        void attach(pixfmt_type& ren)
-        {
-            m_ren = &ren;
-            m_clip_box = rect_i(0, 0, ren.width() - 1, ren.height() - 1);
-        }
-
-        //--------------------------------------------------------------------
-        const pixfmt_type& ren() const { return *m_ren;  }
-        pixfmt_type& ren() { return *m_ren;  }
-          
-        //--------------------------------------------------------------------
-        unsigned width()  const { return m_ren->width();  }
-        unsigned height() const { return m_ren->height(); }
-
-        //--------------------------------------------------------------------
-        bool clip_box(int x1, int y1, int x2, int y2)
-        {
-            rect_i cb(x1, y1, x2, y2);
-            cb.normalize();
-            if(cb.clip(rect_i(0, 0, width() - 1, height() - 1)))
-            {
-                m_clip_box = cb;
-                return true;
-            }
-            m_clip_box.x1 = 1;
-            m_clip_box.y1 = 1;
-            m_clip_box.x2 = 0;
-            m_clip_box.y2 = 0;
-            return false;
-        }
-
-        //--------------------------------------------------------------------
-        void reset_clipping(bool visibility)
-        {
-            if(visibility)
-            {
-                m_clip_box.x1 = 0;
-                m_clip_box.y1 = 0;
-                m_clip_box.x2 = width() - 1;
-                m_clip_box.y2 = height() - 1;
-            }
-            else
-            {
-                m_clip_box.x1 = 1;
-                m_clip_box.y1 = 1;
-                m_clip_box.x2 = 0;
-                m_clip_box.y2 = 0;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void clip_box_naked(int x1, int y1, int x2, int y2)
-        {
-            m_clip_box.x1 = x1;
-            m_clip_box.y1 = y1;
-            m_clip_box.x2 = x2;
-            m_clip_box.y2 = y2;
-        }
-
-        //--------------------------------------------------------------------
-        bool inbox(int x, int y) const
-        {
-            return x >= m_clip_box.x1 && y >= m_clip_box.y1 &&
-                   x <= m_clip_box.x2 && y <= m_clip_box.y2;
-        }
-
-        //--------------------------------------------------------------------
-        const rect_i& clip_box() const { return m_clip_box;    }
-        int           xmin()     const { return m_clip_box.x1; }
-        int           ymin()     const { return m_clip_box.y1; }
-        int           xmax()     const { return m_clip_box.x2; }
-        int           ymax()     const { return m_clip_box.y2; }
-
-        //--------------------------------------------------------------------
-        const rect_i& bounding_clip_box() const { return m_clip_box;    }
-        int           bounding_xmin()     const { return m_clip_box.x1; }
-        int           bounding_ymin()     const { return m_clip_box.y1; }
-        int           bounding_xmax()     const { return m_clip_box.x2; }
-        int           bounding_ymax()     const { return m_clip_box.y2; }
-
-        //--------------------------------------------------------------------
-        void clear(const color_type& c)
-        {
-            unsigned y;
-            if(width())
-            {
-                for(y = 0; y < height(); y++)
-                {
-                    m_ren->copy_hline(0, y, width(), c);
-                }
-            }
-        }
-          
-
-        //--------------------------------------------------------------------
-        void copy_pixel(int x, int y, const color_type& c)
-        {
-            if(inbox(x, y))
-            {
-                m_ren->copy_pixel(x, y, c);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void blend_pixel(int x, int y, const color_type& c, cover_type cover)
-        {
-            if(inbox(x, y))
-            {
-                m_ren->blend_pixel(x, y, c, cover);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        color_type pixel(int x, int y) const
-        {
-            return inbox(x, y) ? 
-                   m_ren->pixel(x, y) :
-                   color_type::no_color();
-        }
-
-        //--------------------------------------------------------------------
-        void copy_hline(int x1, int y, int x2, const color_type& c)
-        {
-            if(x1 > x2) { int t = x2; x2 = x1; x1 = t; }
-            if(y  > ymax()) return;
-            if(y  < ymin()) return;
-            if(x1 > xmax()) return;
-            if(x2 < xmin()) return;
-
-            if(x1 < xmin()) x1 = xmin();
-            if(x2 > xmax()) x2 = xmax();
-
-            m_ren->copy_hline(x1, y, x2 - x1 + 1, c);
-        }
-
-        //--------------------------------------------------------------------
-        void copy_vline(int x, int y1, int y2, const color_type& c)
-        {
-            if(y1 > y2) { int t = y2; y2 = y1; y1 = t; }
-            if(x  > xmax()) return;
-            if(x  < xmin()) return;
-            if(y1 > ymax()) return;
-            if(y2 < ymin()) return;
-
-            if(y1 < ymin()) y1 = ymin();
-            if(y2 > ymax()) y2 = ymax();
-
-            m_ren->copy_vline(x, y1, y2 - y1 + 1, c);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x1, int y, int x2, 
-                         const color_type& c, cover_type cover)
-        {
-            if(x1 > x2) { int t = x2; x2 = x1; x1 = t; }
-            if(y  > ymax()) return;
-            if(y  < ymin()) return;
-            if(x1 > xmax()) return;
-            if(x2 < xmin()) return;
-
-            if(x1 < xmin()) x1 = xmin();
-            if(x2 > xmax()) x2 = xmax();
-
-            m_ren->blend_hline(x1, y, x2 - x1 + 1, c, cover);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y1, int y2, 
-                         const color_type& c, cover_type cover)
-        {
-            if(y1 > y2) { int t = y2; y2 = y1; y1 = t; }
-            if(x  > xmax()) return;
-            if(x  < xmin()) return;
-            if(y1 > ymax()) return;
-            if(y2 < ymin()) return;
-
-            if(y1 < ymin()) y1 = ymin();
-            if(y2 > ymax()) y2 = ymax();
-
-            m_ren->blend_vline(x, y1, y2 - y1 + 1, c, cover);
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_bar(int x1, int y1, int x2, int y2, const color_type& c)
-        {
-            rect_i rc(x1, y1, x2, y2);
-            rc.normalize();
-            if(rc.clip(clip_box()))
-            {
-                int y;
-                for(y = rc.y1; y <= rc.y2; y++)
-                {
-                    m_ren->copy_hline(rc.x1, y, unsigned(rc.x2 - rc.x1 + 1), c);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void blend_bar(int x1, int y1, int x2, int y2, 
-                       const color_type& c, cover_type cover)
-        {
-            rect_i rc(x1, y1, x2, y2);
-            rc.normalize();
-            if(rc.clip(clip_box()))
-            {
-                int y;
-                for(y = rc.y1; y <= rc.y2; y++)
-                {
-                    m_ren->blend_hline(rc.x1,
-                                       y,
-                                       unsigned(rc.x2 - rc.x1 + 1), 
-                                       c, 
-                                       cover);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y, int len, 
-                               const color_type& c, 
-                               const cover_type* covers)
-        {
-            if(y > ymax()) return;
-            if(y < ymin()) return;
-
-            if(x < xmin())
-            {
-                len -= xmin() - x;
-                if(len <= 0) return;
-                covers += xmin() - x;
-                x = xmin();
-            }
-            if(x + len > xmax())
-            {
-                len = xmax() - x + 1;
-                if(len <= 0) return;
-            }
-            m_ren->blend_solid_hspan(x, y, len, c, covers);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y, int len, 
-                               const color_type& c, 
-                               const cover_type* covers)
-        {
-            if(x > xmax()) return;
-            if(x < xmin()) return;
-
-            if(y < ymin())
-            {
-                len -= ymin() - y;
-                if(len <= 0) return;
-                covers += ymin() - y;
-                y = ymin();
-            }
-            if(y + len > ymax())
-            {
-                len = ymax() - y + 1;
-                if(len <= 0) return;
-            }
-            m_ren->blend_solid_vspan(x, y, len, c, covers);
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y, int len, const color_type* colors)
-        {
-            if(y > ymax()) return;
-            if(y < ymin()) return;
-
-            if(x < xmin())
-            {
-                int d = xmin() - x;
-                len -= d;
-                if(len <= 0) return;
-                colors += d;
-                x = xmin();
-            }
-            if(x + len > xmax())
-            {
-                len = xmax() - x + 1;
-                if(len <= 0) return;
-            }
-            m_ren->copy_color_hspan(x, y, len, colors);
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_vspan(int x, int y, int len, const color_type* colors)
-        {
-            if(x > xmax()) return;
-            if(x < xmin()) return;
-
-            if(y < ymin())
-            {
-                int d = ymin() - y;
-                len -= d;
-                if(len <= 0) return;
-                colors += d;
-                y = ymin();
-            }
-            if(y + len > ymax())
-            {
-                len = ymax() - y + 1;
-                if(len <= 0) return;
-            }
-            m_ren->copy_color_vspan(x, y, len, colors);
-        }
-
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y, int len, 
-                               const color_type* colors, 
-                               const cover_type* covers,
-                               cover_type cover = mapserver::cover_full)
-        {
-            if(y > ymax()) return;
-            if(y < ymin()) return;
-
-            if(x < xmin())
-            {
-                int d = xmin() - x;
-                len -= d;
-                if(len <= 0) return;
-                if(covers) covers += d;
-                colors += d;
-                x = xmin();
-            }
-            if(x + len > xmax())
-            {
-                len = xmax() - x + 1;
-                if(len <= 0) return;
-            }
-            m_ren->blend_color_hspan(x, y, len, colors, covers, cover);
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y, int len, 
-                               const color_type* colors, 
-                               const cover_type* covers,
-                               cover_type cover = mapserver::cover_full)
-        {
-            if(x > xmax()) return;
-            if(x < xmin()) return;
-
-            if(y < ymin())
-            {
-                int d = ymin() - y;
-                len -= d;
-                if(len <= 0) return;
-                if(covers) covers += d;
-                colors += d;
-                y = ymin();
-            }
-            if(y + len > ymax())
-            {
-                len = ymax() - y + 1;
-                if(len <= 0) return;
-            }
-            m_ren->blend_color_vspan(x, y, len, colors, covers, cover);
-        }
-
-        //--------------------------------------------------------------------
-        rect_i clip_rect_area(rect_i& dst, rect_i& src, int wsrc, int hsrc) const
-        {
-            rect_i rc(0,0,0,0);
-            rect_i cb = clip_box();
-            ++cb.x2;
-            ++cb.y2;
-
-            if(src.x1 < 0)
-            {
-                dst.x1 -= src.x1;
-                src.x1 = 0;
-            }
-            if(src.y1 < 0)
-            {
-                dst.y1 -= src.y1;
-                src.y1 = 0;
-            }
-
-            if(src.x2 > wsrc) src.x2 = wsrc;
-            if(src.y2 > hsrc) src.y2 = hsrc;
-
-            if(dst.x1 < cb.x1)
-            {
-                src.x1 += cb.x1 - dst.x1;
-                dst.x1 = cb.x1;
-            }
-            if(dst.y1 < cb.y1)
-            {
-                src.y1 += cb.y1 - dst.y1;
-                dst.y1 = cb.y1;
-            }
-
-            if(dst.x2 > cb.x2) dst.x2 = cb.x2;
-            if(dst.y2 > cb.y2) dst.y2 = cb.y2;
-
-            rc.x2 = dst.x2 - dst.x1;
-            rc.y2 = dst.y2 - dst.y1;
-
-            if(rc.x2 > src.x2 - src.x1) rc.x2 = src.x2 - src.x1;
-            if(rc.y2 > src.y2 - src.y1) rc.y2 = src.y2 - src.y1;
-            return rc;
-        }
-
-        //--------------------------------------------------------------------
-        template<class RenBuf>
-        void copy_from(const RenBuf& src, 
-                       const rect_i* rect_src_ptr = 0, 
-                       int dx = 0, 
-                       int dy = 0)
-        {
-            rect_i rsrc(0, 0, src.width(), src.height());
-            if(rect_src_ptr)
-            {
-                rsrc.x1 = rect_src_ptr->x1; 
-                rsrc.y1 = rect_src_ptr->y1;
-                rsrc.x2 = rect_src_ptr->x2 + 1;
-                rsrc.y2 = rect_src_ptr->y2 + 1;
-            }
-
-            // Version with xdst, ydst (absolute positioning)
-            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
-
-            // Version with dx, dy (relative positioning)
-            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
-
-            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
-
-            if(rc.x2 > 0)
-            {
-                int incy = 1;
-                if(rdst.y1 > rsrc.y1)
-                {
-                    rsrc.y1 += rc.y2 - 1;
-                    rdst.y1 += rc.y2 - 1;
-                    incy = -1;
-                }
-                while(rc.y2 > 0)
-                {
-                    m_ren->copy_from(src, 
-                                     rdst.x1, rdst.y1,
-                                     rsrc.x1, rsrc.y1,
-                                     rc.x2);
-                    rdst.y1 += incy;
-                    rsrc.y1 += incy;
-                    --rc.y2;
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from(const SrcPixelFormatRenderer& src, 
-                        const rect_i* rect_src_ptr = 0, 
-                        int dx = 0, 
-                        int dy = 0,
-                        cover_type cover = mapserver::cover_full)
-        {
-            rect_i rsrc(0, 0, src.width(), src.height());
-            if(rect_src_ptr)
-            {
-                rsrc.x1 = rect_src_ptr->x1; 
-                rsrc.y1 = rect_src_ptr->y1;
-                rsrc.x2 = rect_src_ptr->x2 + 1;
-                rsrc.y2 = rect_src_ptr->y2 + 1;
-            }
-
-            // Version with xdst, ydst (absolute positioning)
-            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
-
-            // Version with dx, dy (relative positioning)
-            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
-            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
-
-            if(rc.x2 > 0)
-            {
-                int incy = 1;
-                if(rdst.y1 > rsrc.y1)
-                {
-                    rsrc.y1 += rc.y2 - 1;
-                    rdst.y1 += rc.y2 - 1;
-                    incy = -1;
-                }
-                while(rc.y2 > 0)
-                {
-                    typename SrcPixelFormatRenderer::row_data rw = src.row(rsrc.y1);
-                    if(rw.ptr)
-                    {
-                        int x1src = rsrc.x1;
-                        int x1dst = rdst.x1;
-                        int len   = rc.x2;
-                        if(rw.x1 > x1src)
-                        {
-                            x1dst += rw.x1 - x1src;
-                            len   -= rw.x1 - x1src;
-                            x1src  = rw.x1;
-                        }
-                        if(len > 0)
-                        {
-                            if(x1src + len-1 > rw.x2)
-                            {
-                                len -= x1src + len - rw.x2 - 1;
-                            }
-                            if(len > 0)
-                            {
-                                m_ren->blend_from(src,
-                                                  x1dst, rdst.y1,
-                                                  x1src, rsrc.y1,
-                                                  len,
-                                                  cover);
-                            }
-                        }
-                    }
-                    rdst.y1 += incy;
-                    rsrc.y1 += incy;
-                    --rc.y2;
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_color(const SrcPixelFormatRenderer& src, 
-                              const color_type& color,
-                              const rect_i* rect_src_ptr = 0, 
-                              int dx = 0, 
-                              int dy = 0,
-                              cover_type cover = mapserver::cover_full)
-        {
-            rect_i rsrc(0, 0, src.width(), src.height());
-            if(rect_src_ptr)
-            {
-                rsrc.x1 = rect_src_ptr->x1; 
-                rsrc.y1 = rect_src_ptr->y1;
-                rsrc.x2 = rect_src_ptr->x2 + 1;
-                rsrc.y2 = rect_src_ptr->y2 + 1;
-            }
-
-            // Version with xdst, ydst (absolute positioning)
-            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
-
-            // Version with dx, dy (relative positioning)
-            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
-            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
-
-            if(rc.x2 > 0)
-            {
-                int incy = 1;
-                if(rdst.y1 > rsrc.y1)
-                {
-                    rsrc.y1 += rc.y2 - 1;
-                    rdst.y1 += rc.y2 - 1;
-                    incy = -1;
-                }
-                while(rc.y2 > 0)
-                {
-                    typename SrcPixelFormatRenderer::row_data rw = src.row(rsrc.y1);
-                    if(rw.ptr)
-                    {
-                        int x1src = rsrc.x1;
-                        int x1dst = rdst.x1;
-                        int len   = rc.x2;
-                        if(rw.x1 > x1src)
-                        {
-                            x1dst += rw.x1 - x1src;
-                            len   -= rw.x1 - x1src;
-                            x1src  = rw.x1;
-                        }
-                        if(len > 0)
-                        {
-                            if(x1src + len-1 > rw.x2)
-                            {
-                                len -= x1src + len - rw.x2 - 1;
-                            }
-                            if(len > 0)
-                            {
-                                m_ren->blend_from_color(src,
-                                                        color,
-                                                        x1dst, rdst.y1,
-                                                        x1src, rsrc.y1,
-                                                        len,
-                                                        cover);
-                            }
-                        }
-                    }
-                    rdst.y1 += incy;
-                    rsrc.y1 += incy;
-                    --rc.y2;
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from_lut(const SrcPixelFormatRenderer& src, 
-                            const color_type* color_lut,
-                            const rect_i* rect_src_ptr = 0, 
-                            int dx = 0, 
-                            int dy = 0,
-                            cover_type cover = mapserver::cover_full)
-        {
-            rect_i rsrc(0, 0, src.width(), src.height());
-            if(rect_src_ptr)
-            {
-                rsrc.x1 = rect_src_ptr->x1; 
-                rsrc.y1 = rect_src_ptr->y1;
-                rsrc.x2 = rect_src_ptr->x2 + 1;
-                rsrc.y2 = rect_src_ptr->y2 + 1;
-            }
-
-            // Version with xdst, ydst (absolute positioning)
-            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
-
-            // Version with dx, dy (relative positioning)
-            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
-            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
-
-            if(rc.x2 > 0)
-            {
-                int incy = 1;
-                if(rdst.y1 > rsrc.y1)
-                {
-                    rsrc.y1 += rc.y2 - 1;
-                    rdst.y1 += rc.y2 - 1;
-                    incy = -1;
-                }
-                while(rc.y2 > 0)
-                {
-                    typename SrcPixelFormatRenderer::row_data rw = src.row(rsrc.y1);
-                    if(rw.ptr)
-                    {
-                        int x1src = rsrc.x1;
-                        int x1dst = rdst.x1;
-                        int len   = rc.x2;
-                        if(rw.x1 > x1src)
-                        {
-                            x1dst += rw.x1 - x1src;
-                            len   -= rw.x1 - x1src;
-                            x1src  = rw.x1;
-                        }
-                        if(len > 0)
-                        {
-                            if(x1src + len-1 > rw.x2)
-                            {
-                                len -= x1src + len - rw.x2 - 1;
-                            }
-                            if(len > 0)
-                            {
-                                m_ren->blend_from_lut(src,
-                                                      color_lut,
-                                                      x1dst, rdst.y1,
-                                                      x1src, rsrc.y1,
-                                                      len,
-                                                      cover);
-                            }
-                        }
-                    }
-                    rdst.y1 += incy;
-                    rsrc.y1 += incy;
-                    --rc.y2;
-                }
-            }
-        }
-
-    private:
-        pixfmt_type* m_ren;
-        rect_i       m_clip_box;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_markers.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_markers.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_markers.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_markers.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,706 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class renderer_markers
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERER_MARKERS_INCLUDED
-#define AGG_RENDERER_MARKERS_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_renderer_primitives.h"
-
-namespace mapserver
-{
-
-    //---------------------------------------------------------------marker_e
-    enum marker_e
-    {
-        marker_square,
-        marker_diamond,
-        marker_circle,
-        marker_crossed_circle,
-        marker_semiellipse_left,
-        marker_semiellipse_right,
-        marker_semiellipse_up,
-        marker_semiellipse_down,
-        marker_triangle_left,
-        marker_triangle_right,
-        marker_triangle_up,
-        marker_triangle_down,
-        marker_four_rays,
-        marker_cross,
-        marker_x,
-        marker_dash,
-        marker_dot,
-        marker_pixel,
-        
-        end_of_markers
-    };
-
-
-
-    //--------------------------------------------------------renderer_markers
-    template<class BaseRenderer> class renderer_markers :
-    public renderer_primitives<BaseRenderer>
-    {
-    public:
-        typedef renderer_primitives<BaseRenderer> base_type;
-        typedef BaseRenderer base_ren_type;
-        typedef typename base_ren_type::color_type color_type;
-
-        //--------------------------------------------------------------------
-        renderer_markers(base_ren_type& rbuf) :
-            base_type(rbuf)
-        {}
-
-        //--------------------------------------------------------------------
-        bool visible(int x, int y, int r) const
-        {
-            rect_i rc(x-r, y-r, x+y, y+r);
-            return rc.clip(base_type::ren().bounding_clip_box());  
-        }
-
-        //--------------------------------------------------------------------
-        void square(int x, int y, int r)
-        {
-            if(visible(x, y, r)) 
-            {  
-                if(r) base_type::outlined_rectangle(x-r, y-r, x+r, y+r);
-                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void diamond(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int dy = -r;
-                    int dx = 0;
-                    do
-                    {
-                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
-                        
-                        if(dx)
-                        {
-                            base_type::ren().blend_hline(x-dx+1, y+dy, x+dx-1, base_type::fill_color(), cover_full);
-                            base_type::ren().blend_hline(x-dx+1, y-dy, x+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++dy;
-                        ++dx;
-                    }
-                    while(dy <= 0);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void circle(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r) base_type::outlined_ellipse(x, y, r, r);
-                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-            }
-        }
-
-
-
-        //--------------------------------------------------------------------
-        void crossed_circle(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    base_type::outlined_ellipse(x, y, r, r);
-                    int r6 = r + (r >> 1);
-                    if(r <= 2) r6++;
-                    r >>= 1;
-                    base_type::ren().blend_hline(x-r6, y, x-r,  base_type::line_color(), cover_full);
-                    base_type::ren().blend_hline(x+r,  y, x+r6, base_type::line_color(), cover_full);
-                    base_type::ren().blend_vline(x, y-r6, y-r,  base_type::line_color(), cover_full);
-                    base_type::ren().blend_vline(x, y+r,  y+r6, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //------------------------------------------------------------------------
-        void semiellipse_left(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int r8 = r * 4 / 5;
-                    int dy = -r;
-                    int dx = 0;
-                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
-                    do
-                    {
-                        dx += ei.dx();
-                        dy += ei.dy();
-                        
-                        base_type::ren().blend_pixel(x + dy, y + dx, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dy, y - dx, base_type::line_color(), cover_full);
-                        
-                        if(ei.dy() && dx)
-                        {
-                            base_type::ren().blend_vline(x+dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++ei;
-                    }
-                    while(dy < r8);
-                    base_type::ren().blend_vline(x+dy, y-dx, y+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void semiellipse_right(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int r8 = r * 4 / 5;
-                    int dy = -r;
-                    int dx = 0;
-                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
-                    do
-                    {
-                        dx += ei.dx();
-                        dy += ei.dy();
-                        
-                        base_type::ren().blend_pixel(x - dy, y + dx, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dy, y - dx, base_type::line_color(), cover_full);
-                        
-                        if(ei.dy() && dx)
-                        {
-                            base_type::ren().blend_vline(x-dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++ei;
-                    }
-                    while(dy < r8);
-                    base_type::ren().blend_vline(x-dy, y-dx, y+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void semiellipse_up(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int r8 = r * 4 / 5;
-                    int dy = -r;
-                    int dx = 0;
-                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
-                    do
-                    {
-                        dx += ei.dx();
-                        dy += ei.dy();
-                        
-                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
-                        
-                        if(ei.dy() && dx)
-                        {
-                            base_type::ren().blend_hline(x-dx+1, y-dy, x+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++ei;
-                    }
-                    while(dy < r8);
-                    base_type::ren().blend_hline(x-dx, y-dy-1, x+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void semiellipse_down(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int r8 = r * 4 / 5;
-                    int dy = -r;
-                    int dx = 0;
-                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
-                    do
-                    {
-                        dx += ei.dx();
-                        dy += ei.dy();
-                        
-                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
-                        
-                        if(ei.dy() && dx)
-                        {
-                            base_type::ren().blend_hline(x-dx+1, y+dy, x+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++ei;
-                    }
-                    while(dy < r8);
-                    base_type::ren().blend_hline(x-dx, y+dy+1, x+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void triangle_left(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int dy = -r;
-                    int dx = 0;
-                    int flip = 0;
-                    int r6 = r * 3 / 5;
-                    do
-                    {
-                        base_type::ren().blend_pixel(x + dy, y - dx, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dy, y + dx, base_type::line_color(), cover_full);
-                        
-                        if(dx)
-                        {
-                            base_type::ren().blend_vline(x+dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++dy;
-                        dx += flip;
-                        flip ^= 1;
-                    }
-                    while(dy < r6);
-                    base_type::ren().blend_vline(x+dy, y-dx, y+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void triangle_right(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int dy = -r;
-                    int dx = 0;
-                    int flip = 0;
-                    int r6 = r * 3 / 5;
-                    do
-                    {
-                        base_type::ren().blend_pixel(x - dy, y - dx, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dy, y + dx, base_type::line_color(), cover_full);
-                        
-                        if(dx)
-                        {
-                            base_type::ren().blend_vline(x-dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++dy;
-                        dx += flip;
-                        flip ^= 1;
-                    }
-                    while(dy < r6);
-                    base_type::ren().blend_vline(x-dy, y-dx, y+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void triangle_up(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int dy = -r;
-                    int dx = 0;
-                    int flip = 0;
-                    int r6 = r * 3 / 5;
-                    do
-                    {
-                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
-                        
-                        if(dx)
-                        {
-                            base_type::ren().blend_hline(x-dx+1, y-dy, x+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++dy;
-                        dx += flip;
-                        flip ^= 1;
-                    }
-                    while(dy < r6);
-                    base_type::ren().blend_hline(x-dx, y-dy, x+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void triangle_down(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int dy = -r;
-                    int dx = 0;
-                    int flip = 0;
-                    int r6 = r * 3 / 5;
-                    do
-                    {
-                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
-                        
-                        if(dx)
-                        {
-                            base_type::ren().blend_hline(x-dx+1, y+dy, x+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++dy;
-                        dx += flip;
-                        flip ^= 1;
-                    }
-                    while(dy < r6);
-                    base_type::ren().blend_hline(x-dx, y+dy, x+dx, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void four_rays(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int dy = -r;
-                    int dx = 0;
-                    int flip = 0;
-                    int r3 = -(r / 3);
-                    do
-                    {
-                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dy, y - dx, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dy, y + dx, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dy, y - dx, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dy, y + dx, base_type::line_color(), cover_full);
-                        
-                        if(dx)
-                        {
-                            base_type::ren().blend_hline(x-dx+1, y+dy,   x+dx-1, base_type::fill_color(), cover_full);
-                            base_type::ren().blend_hline(x-dx+1, y-dy,   x+dx-1, base_type::fill_color(), cover_full);
-                            base_type::ren().blend_vline(x+dy,   y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
-                            base_type::ren().blend_vline(x-dy,   y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
-                        }
-                        ++dy;
-                        dx += flip;
-                        flip ^= 1;
-                    }
-                    while(dy <= r3);
-                    base_type::solid_rectangle(x+r3+1, y+r3+1, x-r3-1, y-r3-1);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        void cross(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    base_type::ren().blend_vline(x, y-r, y+r, base_type::line_color(), cover_full);
-                    base_type::ren().blend_hline(x-r, y, x+r, base_type::line_color(), cover_full);
-                }
-                else
-                {
-                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-                }
-            }
-        }
-        
-        
-        //--------------------------------------------------------------------
-        void xing(int x, int y, int r)
-        {
-            if(visible(x, y, r))
-            {
-                if(r)
-                {
-                    int dy = -r * 7 / 10;
-                    do
-                    {
-                        base_type::ren().blend_pixel(x + dy, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dy, y + dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x + dy, y - dy, base_type::line_color(), cover_full);
-                        base_type::ren().blend_pixel(x - dy, y - dy, base_type::line_color(), cover_full);
-                        ++dy;
-                    }
-                    while(dy < 0);
-                }
-                base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-            }
-        }
-        
-        
-        //--------------------------------------------------------------------
-        void dash(int x, int y, int r)
-        {
-            if(visible(x, y, r)) 
-            {
-                if(r) base_type::ren().blend_hline(x-r, y, x+r, base_type::line_color(), cover_full);
-                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-            }
-        }
-        
-        
-        //--------------------------------------------------------------------
-        void dot(int x, int y, int r)
-        {
-            if(visible(x, y, r)) 
-            {
-                if(r) base_type::solid_ellipse(x, y, r, r);
-                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-            }
-        }
-        
-        //--------------------------------------------------------------------
-        void pixel(int x, int y, int)
-        {
-            base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
-        }
-        
-        //--------------------------------------------------------------------
-        void marker(int x, int y, int r, marker_e type)
-        {
-            switch(type)
-            {
-                case marker_square:            square(x, y, r);            break;
-                case marker_diamond:           diamond(x, y, r);           break;
-                case marker_circle:            circle(x, y, r);            break;
-                case marker_crossed_circle:    crossed_circle(x, y, r);    break;
-                case marker_semiellipse_left:  semiellipse_left(x, y, r);  break;
-                case marker_semiellipse_right: semiellipse_right(x, y, r); break;
-                case marker_semiellipse_up:    semiellipse_up(x, y, r);    break;
-                case marker_semiellipse_down:  semiellipse_down(x, y, r);  break;
-                case marker_triangle_left:     triangle_left(x, y, r);     break;
-                case marker_triangle_right:    triangle_right(x, y, r);    break;
-                case marker_triangle_up:       triangle_up(x, y, r);       break;
-                case marker_triangle_down:     triangle_down(x, y, r);     break;
-                case marker_four_rays:         four_rays(x, y, r);         break;
-                case marker_cross:             cross(x, y, r);             break;
-                case marker_x:                 xing(x, y, r);              break;
-                case marker_dash:              dash(x, y, r);              break;
-                case marker_dot:               dot(x, y, r);               break;
-                case marker_pixel:             pixel(x, y, r);             break;
-            }
-        }
-
-
-        //--------------------------------------------------------------------
-        template<class T>
-        void markers(int n, const T* x, const T* y, T r, marker_e type)
-        {
-            if(n <= 0) return;
-            if(r == 0)
-            {
-                do
-                {
-                    base_type::ren().blend_pixel(int(*x), int(*y), base_type::fill_color(), cover_full);
-                    ++x;
-                    ++y;
-                }
-                while(--n);
-                return;
-            }
-            
-            switch(type)
-            {
-                case marker_square:            do { square           (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_diamond:           do { diamond          (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_circle:            do { circle           (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_crossed_circle:    do { crossed_circle   (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_semiellipse_left:  do { semiellipse_left (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_semiellipse_right: do { semiellipse_right(int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_semiellipse_up:    do { semiellipse_up   (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_semiellipse_down:  do { semiellipse_down (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_triangle_left:     do { triangle_left    (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_triangle_right:    do { triangle_right   (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_triangle_up:       do { triangle_up      (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_triangle_down:     do { triangle_down    (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_four_rays:         do { four_rays        (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_cross:             do { cross            (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_x:                 do { xing             (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_dash:              do { dash             (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_dot:               do { dot              (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-                case marker_pixel:             do { pixel            (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
-            }                                                                                  
-        }
-        
-        //--------------------------------------------------------------------
-        template<class T>
-        void markers(int n, const T* x, const T* y, const T* r, marker_e type)
-        {
-            if(n <= 0) return;
-            switch(type)
-            {
-                case marker_square:            do { square           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_diamond:           do { diamond          (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_circle:            do { circle           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_crossed_circle:    do { crossed_circle   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_semiellipse_left:  do { semiellipse_left (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_semiellipse_right: do { semiellipse_right(int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_semiellipse_up:    do { semiellipse_up   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_semiellipse_down:  do { semiellipse_down (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_triangle_left:     do { triangle_left    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_triangle_right:    do { triangle_right   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_triangle_up:       do { triangle_up      (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_triangle_down:     do { triangle_down    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_four_rays:         do { four_rays        (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_cross:             do { cross            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_x:                 do { xing             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_dash:              do { dash             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_dot:               do { dot              (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-                case marker_pixel:             do { pixel            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
-            }                                                                                  
-        }
-        
-        //--------------------------------------------------------------------
-        template<class T>
-        void markers(int n, const T* x, const T* y, const T* r, const color_type* fc, marker_e type)
-        {
-            if(n <= 0) return;
-            switch(type)
-            {
-                case marker_square:            do { base_type::fill_color(*fc); square           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_diamond:           do { base_type::fill_color(*fc); diamond          (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_circle:            do { base_type::fill_color(*fc); circle           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_crossed_circle:    do { base_type::fill_color(*fc); crossed_circle   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_semiellipse_left:  do { base_type::fill_color(*fc); semiellipse_left (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_semiellipse_right: do { base_type::fill_color(*fc); semiellipse_right(int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_semiellipse_up:    do { base_type::fill_color(*fc); semiellipse_up   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_semiellipse_down:  do { base_type::fill_color(*fc); semiellipse_down (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_triangle_left:     do { base_type::fill_color(*fc); triangle_left    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_triangle_right:    do { base_type::fill_color(*fc); triangle_right   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_triangle_up:       do { base_type::fill_color(*fc); triangle_up      (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_triangle_down:     do { base_type::fill_color(*fc); triangle_down    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_four_rays:         do { base_type::fill_color(*fc); four_rays        (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_cross:             do { base_type::fill_color(*fc); cross            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_x:                 do { base_type::fill_color(*fc); xing             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_dash:              do { base_type::fill_color(*fc); dash             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_dot:               do { base_type::fill_color(*fc); dot              (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-                case marker_pixel:             do { base_type::fill_color(*fc); pixel            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
-            }
-        }
-        
-        //--------------------------------------------------------------------
-        template<class T>
-        void markers(int n, const T* x, const T* y, const T* r, const color_type* fc, const color_type* lc, marker_e type)
-        {
-            if(n <= 0) return;
-            switch(type)
-            {
-                case marker_square:            do { base_type::fill_color(*fc); base_type::line_color(*lc); square           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_diamond:           do { base_type::fill_color(*fc); base_type::line_color(*lc); diamond          (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_circle:            do { base_type::fill_color(*fc); base_type::line_color(*lc); circle           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_crossed_circle:    do { base_type::fill_color(*fc); base_type::line_color(*lc); crossed_circle   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_semiellipse_left:  do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_left (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_semiellipse_right: do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_right(int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_semiellipse_up:    do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_up   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_semiellipse_down:  do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_down (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_triangle_left:     do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_left    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_triangle_right:    do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_right   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_triangle_up:       do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_up      (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_triangle_down:     do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_down    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_four_rays:         do { base_type::fill_color(*fc); base_type::line_color(*lc); four_rays        (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_cross:             do { base_type::fill_color(*fc); base_type::line_color(*lc); cross            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_x:                 do { base_type::fill_color(*fc); base_type::line_color(*lc); xing             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_dash:              do { base_type::fill_color(*fc); base_type::line_color(*lc); dash             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_dot:               do { base_type::fill_color(*fc); base_type::line_color(*lc); dot              (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-                case marker_pixel:             do { base_type::fill_color(*fc); base_type::line_color(*lc); pixel            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
-            }
-        }
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_mclip.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_mclip.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_mclip.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_mclip.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,349 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class renderer_mclip
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERER_MCLIP_INCLUDED
-#define AGG_RENDERER_MCLIP_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_array.h"
-#include "agg_renderer_base.h"
-
-namespace mapserver
-{
-
-    //----------------------------------------------------------renderer_mclip
-    template<class PixelFormat> class renderer_mclip
-    {
-    public:
-        typedef PixelFormat pixfmt_type;
-        typedef typename pixfmt_type::color_type color_type;
-        typedef typename pixfmt_type::row_data row_data;
-        typedef renderer_base<pixfmt_type> base_ren_type;
-
-        //--------------------------------------------------------------------
-        explicit renderer_mclip(pixfmt_type& pixf) :
-            m_ren(pixf),
-            m_curr_cb(0),
-            m_bounds(m_ren.xmin(), m_ren.ymin(), m_ren.xmax(), m_ren.ymax())
-        {}
-        void attach(pixfmt_type& pixf)
-        {
-            m_ren.attach(pixf);
-            reset_clipping(true);
-        }
-          
-        //--------------------------------------------------------------------
-        const pixfmt_type& ren() const { return m_ren.ren();  }
-        pixfmt_type& ren() { return m_ren.ren();  }
-
-        //--------------------------------------------------------------------
-        unsigned width()  const { return m_ren.width();  }
-        unsigned height() const { return m_ren.height(); }
-
-        //--------------------------------------------------------------------
-        const rect_i& clip_box() const { return m_ren.clip_box(); }
-        int           xmin()     const { return m_ren.xmin(); }
-        int           ymin()     const { return m_ren.ymin(); }
-        int           xmax()     const { return m_ren.xmax(); }
-        int           ymax()     const { return m_ren.ymax(); }
-
-        //--------------------------------------------------------------------
-        const rect_i& bounding_clip_box() const { return m_bounds;    }
-        int           bounding_xmin()     const { return m_bounds.x1; }
-        int           bounding_ymin()     const { return m_bounds.y1; }
-        int           bounding_xmax()     const { return m_bounds.x2; }
-        int           bounding_ymax()     const { return m_bounds.y2; }
-
-        //--------------------------------------------------------------------
-        void first_clip_box() 
-        {
-            m_curr_cb = 0;
-            if(m_clip.size())
-            {
-                const rect_i& cb = m_clip[0];
-                m_ren.clip_box_naked(cb.x1, cb.y1, cb.x2, cb.y2);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        bool next_clip_box() 
-        { 
-            if(++m_curr_cb < m_clip.size())
-            {
-                const rect_i& cb = m_clip[m_curr_cb];
-                m_ren.clip_box_naked(cb.x1, cb.y1, cb.x2, cb.y2);
-                return true;
-            }
-            return false; 
-        }
-
-        //--------------------------------------------------------------------
-        void reset_clipping(bool visibility)
-        {
-            m_ren.reset_clipping(visibility);
-            m_clip.remove_all();
-            m_curr_cb = 0;
-            m_bounds = m_ren.clip_box();
-        }
-        
-        //--------------------------------------------------------------------
-        void add_clip_box(int x1, int y1, int x2, int y2)
-        {
-            rect_i cb(x1, y1, x2, y2); 
-            cb.normalize();
-            if(cb.clip(rect_i(0, 0, width() - 1, height() - 1)))
-            {
-                m_clip.add(cb);
-                if(cb.x1 < m_bounds.x1) m_bounds.x1 = cb.x1;
-                if(cb.y1 < m_bounds.y1) m_bounds.y1 = cb.y1;
-                if(cb.x2 > m_bounds.x2) m_bounds.x2 = cb.x2;
-                if(cb.y2 > m_bounds.y2) m_bounds.y2 = cb.y2;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void clear(const color_type& c)
-        {
-            m_ren.clear(c);
-        }
-          
-        //--------------------------------------------------------------------
-        void copy_pixel(int x, int y, const color_type& c)
-        {
-            first_clip_box();
-            do
-            {
-                if(m_ren.inbox(x, y))
-                {
-                    m_ren.ren().copy_pixel(x, y, c);
-                    break;
-                }
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_pixel(int x, int y, const color_type& c, cover_type cover)
-        {
-            first_clip_box();
-            do
-            {
-                if(m_ren.inbox(x, y))
-                {
-                    m_ren.ren().blend_pixel(x, y, c, cover);
-                    break;
-                }
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        color_type pixel(int x, int y) const
-        {
-            first_clip_box();
-            do
-            {
-                if(m_ren.inbox(x, y))
-                {
-                    return m_ren.ren().pixel(x, y);
-                }
-            }
-            while(next_clip_box());
-            return color_type::no_color();
-        }
-
-        //--------------------------------------------------------------------
-        void copy_hline(int x1, int y, int x2, const color_type& c)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.copy_hline(x1, y, x2, c);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void copy_vline(int x, int y1, int y2, const color_type& c)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.copy_vline(x, y1, y2, c);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_hline(int x1, int y, int x2, 
-                         const color_type& c, cover_type cover)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_hline(x1, y, x2, c, cover);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_vline(int x, int y1, int y2, 
-                         const color_type& c, cover_type cover)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_vline(x, y1, y2, c, cover);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void copy_bar(int x1, int y1, int x2, int y2, const color_type& c)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.copy_bar(x1, y1, x2, y2, c);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_bar(int x1, int y1, int x2, int y2, 
-                       const color_type& c, cover_type cover)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_bar(x1, y1, x2, y2, c, cover);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y, int len, 
-                               const color_type& c, const cover_type* covers)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_solid_hspan(x, y, len, c, covers);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y, int len, 
-                               const color_type& c, const cover_type* covers)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_solid_vspan(x, y, len, c, covers);
-            }
-            while(next_clip_box());
-        }
-
-
-        //--------------------------------------------------------------------
-        void copy_color_hspan(int x, int y, int len, const color_type* colors)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.copy_color_hspan(x, y, len, colors);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_hspan(int x, int y, int len, 
-                               const color_type* colors, 
-                               const cover_type* covers,
-                               cover_type cover = cover_full)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_color_hspan(x, y, len, colors, covers, cover);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void blend_color_vspan(int x, int y, int len, 
-                               const color_type* colors, 
-                               const cover_type* covers,
-                               cover_type cover = cover_full)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_color_vspan(x, y, len, colors, covers, cover);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        void copy_from(const rendering_buffer& from, 
-                       const rect_i* rc=0, 
-                       int x_to=0, 
-                       int y_to=0)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.copy_from(from, rc, x_to, y_to);
-            }
-            while(next_clip_box());
-        }
-
-        //--------------------------------------------------------------------
-        template<class SrcPixelFormatRenderer>
-        void blend_from(const SrcPixelFormatRenderer& src, 
-                        const rect_i* rect_src_ptr = 0, 
-                        int dx = 0, 
-                        int dy = 0,
-                        cover_type cover = cover_full)
-        {
-            first_clip_box();
-            do
-            {
-                m_ren.blend_from(src, rect_src_ptr, dx, dy, cover);
-            }
-            while(next_clip_box());
-        }
-
-        
-    private:
-        renderer_mclip(const renderer_mclip<PixelFormat>&);
-        const renderer_mclip<PixelFormat>& 
-            operator = (const renderer_mclip<PixelFormat>&);
-
-        base_ren_type          m_ren;
-        pod_bvector<rect_i, 4> m_clip;
-        unsigned               m_curr_cb;
-        rect_i                 m_bounds;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_outline_aa.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_outline_aa.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_outline_aa.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_outline_aa.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1836 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_RENDERER_OUTLINE_AA_INCLUDED
-#define AGG_RENDERER_OUTLINE_AA_INCLUDED
-
-#include "agg_array.h"
-#include "agg_math.h"
-#include "agg_line_aa_basics.h"
-#include "agg_dda_line.h"
-#include "agg_ellipse_bresenham.h"
-#include "agg_renderer_base.h"
-#include "agg_gamma_functions.h"
-#include "agg_clip_liang_barsky.h"
-
-namespace mapserver
-{
-
-    //===================================================distance_interpolator0
-    class distance_interpolator0
-    {
-    public:
-        //---------------------------------------------------------------------
-        distance_interpolator0() {}
-        distance_interpolator0(int x1, int y1, int x2, int y2, int x, int y) :
-            m_dx(line_mr(x2) - line_mr(x1)),
-            m_dy(line_mr(y2) - line_mr(y1)),
-            m_dist((line_mr(x + line_subpixel_scale/2) - line_mr(x2)) * m_dy - 
-                   (line_mr(y + line_subpixel_scale/2) - line_mr(y2)) * m_dx)
-        {
-            m_dx <<= line_mr_subpixel_shift;
-            m_dy <<= line_mr_subpixel_shift;
-        }
-
-        //---------------------------------------------------------------------
-        void inc_x() { m_dist += m_dy; }
-        int  dist() const { return m_dist; }
-
-    private:
-        //---------------------------------------------------------------------
-        int m_dx;
-        int m_dy;
-        int m_dist;
-    };
-
-    //==================================================distance_interpolator00
-    class distance_interpolator00
-    {
-    public:
-        //---------------------------------------------------------------------
-        distance_interpolator00() {}
-        distance_interpolator00(int xc, int yc, 
-                                int x1, int y1, int x2, int y2, 
-                                int x,  int y) :
-            m_dx1(line_mr(x1) - line_mr(xc)),
-            m_dy1(line_mr(y1) - line_mr(yc)),
-            m_dx2(line_mr(x2) - line_mr(xc)),
-            m_dy2(line_mr(y2) - line_mr(yc)),
-            m_dist1((line_mr(x + line_subpixel_scale/2) - line_mr(x1)) * m_dy1 - 
-                    (line_mr(y + line_subpixel_scale/2) - line_mr(y1)) * m_dx1),
-            m_dist2((line_mr(x + line_subpixel_scale/2) - line_mr(x2)) * m_dy2 - 
-                    (line_mr(y + line_subpixel_scale/2) - line_mr(y2)) * m_dx2)
-        {
-            m_dx1 <<= line_mr_subpixel_shift;
-            m_dy1 <<= line_mr_subpixel_shift;
-            m_dx2 <<= line_mr_subpixel_shift;
-            m_dy2 <<= line_mr_subpixel_shift;
-        }
-
-        //---------------------------------------------------------------------
-        void inc_x() { m_dist1 += m_dy1; m_dist2 += m_dy2; }
-        int  dist1() const { return m_dist1; }
-        int  dist2() const { return m_dist2; }
-
-    private:
-        //---------------------------------------------------------------------
-        int m_dx1;
-        int m_dy1;
-        int m_dx2;
-        int m_dy2;
-        int m_dist1;
-        int m_dist2;
-    };
-
-    //===================================================distance_interpolator1
-    class distance_interpolator1
-    {
-    public:
-        //---------------------------------------------------------------------
-        distance_interpolator1() {}
-        distance_interpolator1(int x1, int y1, int x2, int y2, int x, int y) :
-            m_dx(x2 - x1),
-            m_dy(y2 - y1),
-            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
-                          double(y + line_subpixel_scale/2 - y2) * double(m_dx)))
-        {
-            m_dx <<= line_subpixel_shift;
-            m_dy <<= line_subpixel_shift;
-        }
-
-        //---------------------------------------------------------------------
-        void inc_x() { m_dist += m_dy; }
-        void dec_x() { m_dist -= m_dy; }
-        void inc_y() { m_dist -= m_dx; }
-        void dec_y() { m_dist += m_dx; }
-
-        //---------------------------------------------------------------------
-        void inc_x(int dy)
-        {
-            m_dist += m_dy; 
-            if(dy > 0) m_dist -= m_dx; 
-            if(dy < 0) m_dist += m_dx; 
-        }
-
-        //---------------------------------------------------------------------
-        void dec_x(int dy)
-        {
-            m_dist -= m_dy; 
-            if(dy > 0) m_dist -= m_dx; 
-            if(dy < 0) m_dist += m_dx; 
-        }
-
-        //---------------------------------------------------------------------
-        void inc_y(int dx)
-        {
-            m_dist -= m_dx; 
-            if(dx > 0) m_dist += m_dy; 
-            if(dx < 0) m_dist -= m_dy; 
-        }
-
-        void dec_y(int dx)
-        //---------------------------------------------------------------------
-        {
-            m_dist += m_dx; 
-            if(dx > 0) m_dist += m_dy; 
-            if(dx < 0) m_dist -= m_dy; 
-        }
-
-        //---------------------------------------------------------------------
-        int dist() const { return m_dist; }
-        int dx()   const { return m_dx;   }
-        int dy()   const { return m_dy;   }
-
-    private:
-        //---------------------------------------------------------------------
-        int m_dx;
-        int m_dy;
-        int m_dist;
-    };
-
-
-
-
-
-    //===================================================distance_interpolator2
-    class distance_interpolator2
-    {
-    public:
-        //---------------------------------------------------------------------
-        distance_interpolator2() {}
-        distance_interpolator2(int x1, int y1, int x2, int y2,
-                               int sx, int sy, int x,  int y) :
-            m_dx(x2 - x1),
-            m_dy(y2 - y1),
-            m_dx_start(line_mr(sx) - line_mr(x1)),
-            m_dy_start(line_mr(sy) - line_mr(y1)),
-
-            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
-                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
-
-            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(sx)) * m_dy_start - 
-                         (line_mr(y + line_subpixel_scale/2) - line_mr(sy)) * m_dx_start)
-        {
-            m_dx       <<= line_subpixel_shift;
-            m_dy       <<= line_subpixel_shift;
-            m_dx_start <<= line_mr_subpixel_shift;
-            m_dy_start <<= line_mr_subpixel_shift;
-        }
-
-        distance_interpolator2(int x1, int y1, int x2, int y2,
-                               int ex, int ey, int x,  int y, int) :
-            m_dx(x2 - x1),
-            m_dy(y2 - y1),
-            m_dx_start(line_mr(ex) - line_mr(x2)),
-            m_dy_start(line_mr(ey) - line_mr(y2)),
-
-            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
-                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
-
-            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(ex)) * m_dy_start - 
-                         (line_mr(y + line_subpixel_scale/2) - line_mr(ey)) * m_dx_start)
-        {
-            m_dx       <<= line_subpixel_shift;
-            m_dy       <<= line_subpixel_shift;
-            m_dx_start <<= line_mr_subpixel_shift;
-            m_dy_start <<= line_mr_subpixel_shift;
-        }
-
-
-        //---------------------------------------------------------------------
-        void inc_x() { m_dist += m_dy; m_dist_start += m_dy_start; }
-        void dec_x() { m_dist -= m_dy; m_dist_start -= m_dy_start; }
-        void inc_y() { m_dist -= m_dx; m_dist_start -= m_dx_start; }
-        void dec_y() { m_dist += m_dx; m_dist_start += m_dx_start; }
-
-        //---------------------------------------------------------------------
-        void inc_x(int dy)
-        {
-            m_dist       += m_dy; 
-            m_dist_start += m_dy_start; 
-            if(dy > 0)
-            {
-                m_dist       -= m_dx; 
-                m_dist_start -= m_dx_start; 
-            }
-            if(dy < 0)
-            {
-                m_dist       += m_dx; 
-                m_dist_start += m_dx_start; 
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void dec_x(int dy)
-        {
-            m_dist       -= m_dy; 
-            m_dist_start -= m_dy_start; 
-            if(dy > 0)
-            {
-                m_dist       -= m_dx; 
-                m_dist_start -= m_dx_start; 
-            }
-            if(dy < 0)
-            {
-                m_dist       += m_dx; 
-                m_dist_start += m_dx_start; 
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void inc_y(int dx)
-        {
-            m_dist       -= m_dx; 
-            m_dist_start -= m_dx_start; 
-            if(dx > 0)
-            {
-                m_dist       += m_dy; 
-                m_dist_start += m_dy_start; 
-            }
-            if(dx < 0)
-            {
-                m_dist       -= m_dy; 
-                m_dist_start -= m_dy_start; 
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void dec_y(int dx)
-        {
-            m_dist       += m_dx; 
-            m_dist_start += m_dx_start; 
-            if(dx > 0)
-            {
-                m_dist       += m_dy; 
-                m_dist_start += m_dy_start; 
-            }
-            if(dx < 0)
-            {
-                m_dist       -= m_dy; 
-                m_dist_start -= m_dy_start; 
-            }
-        }
-
-        //---------------------------------------------------------------------
-        int dist()       const { return m_dist;       }
-        int dist_start() const { return m_dist_start; }
-        int dist_end()   const { return m_dist_start; }
-
-        //---------------------------------------------------------------------
-        int dx()       const { return m_dx;       }
-        int dy()       const { return m_dy;       }
-        int dx_start() const { return m_dx_start; }
-        int dy_start() const { return m_dy_start; }
-        int dx_end()   const { return m_dx_start; }
-        int dy_end()   const { return m_dy_start; }
-
-    private:
-        //---------------------------------------------------------------------
-        int m_dx;
-        int m_dy;
-        int m_dx_start;
-        int m_dy_start;
-
-        int m_dist;
-        int m_dist_start;
-    };
-
-
-
-
-
-    //===================================================distance_interpolator3
-    class distance_interpolator3
-    {
-    public:
-        //---------------------------------------------------------------------
-        distance_interpolator3() {}
-        distance_interpolator3(int x1, int y1, int x2, int y2,
-                               int sx, int sy, int ex, int ey, 
-                               int x,  int y) :
-            m_dx(x2 - x1),
-            m_dy(y2 - y1),
-            m_dx_start(line_mr(sx) - line_mr(x1)),
-            m_dy_start(line_mr(sy) - line_mr(y1)),
-            m_dx_end(line_mr(ex) - line_mr(x2)),
-            m_dy_end(line_mr(ey) - line_mr(y2)),
-
-            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
-                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
-
-            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(sx)) * m_dy_start - 
-                         (line_mr(y + line_subpixel_scale/2) - line_mr(sy)) * m_dx_start),
-
-            m_dist_end((line_mr(x + line_subpixel_scale/2) - line_mr(ex)) * m_dy_end - 
-                       (line_mr(y + line_subpixel_scale/2) - line_mr(ey)) * m_dx_end)
-        {
-            m_dx       <<= line_subpixel_shift;
-            m_dy       <<= line_subpixel_shift;
-            m_dx_start <<= line_mr_subpixel_shift;
-            m_dy_start <<= line_mr_subpixel_shift;
-            m_dx_end   <<= line_mr_subpixel_shift;
-            m_dy_end   <<= line_mr_subpixel_shift;
-        }
-
-        //---------------------------------------------------------------------
-        void inc_x() { m_dist += m_dy; m_dist_start += m_dy_start; m_dist_end += m_dy_end; }
-        void dec_x() { m_dist -= m_dy; m_dist_start -= m_dy_start; m_dist_end -= m_dy_end; }
-        void inc_y() { m_dist -= m_dx; m_dist_start -= m_dx_start; m_dist_end -= m_dx_end; }
-        void dec_y() { m_dist += m_dx; m_dist_start += m_dx_start; m_dist_end += m_dx_end; }
-
-        //---------------------------------------------------------------------
-        void inc_x(int dy)
-        {
-            m_dist       += m_dy; 
-            m_dist_start += m_dy_start; 
-            m_dist_end   += m_dy_end;
-            if(dy > 0)
-            {
-                m_dist       -= m_dx; 
-                m_dist_start -= m_dx_start; 
-                m_dist_end   -= m_dx_end;
-            }
-            if(dy < 0)
-            {
-                m_dist       += m_dx; 
-                m_dist_start += m_dx_start; 
-                m_dist_end   += m_dx_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void dec_x(int dy)
-        {
-            m_dist       -= m_dy; 
-            m_dist_start -= m_dy_start; 
-            m_dist_end   -= m_dy_end;
-            if(dy > 0)
-            {
-                m_dist       -= m_dx; 
-                m_dist_start -= m_dx_start; 
-                m_dist_end   -= m_dx_end;
-            }
-            if(dy < 0)
-            {
-                m_dist       += m_dx; 
-                m_dist_start += m_dx_start; 
-                m_dist_end   += m_dx_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void inc_y(int dx)
-        {
-            m_dist       -= m_dx; 
-            m_dist_start -= m_dx_start; 
-            m_dist_end   -= m_dx_end;
-            if(dx > 0)
-            {
-                m_dist       += m_dy; 
-                m_dist_start += m_dy_start; 
-                m_dist_end   += m_dy_end;
-            }
-            if(dx < 0)
-            {
-                m_dist       -= m_dy; 
-                m_dist_start -= m_dy_start; 
-                m_dist_end   -= m_dy_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void dec_y(int dx)
-        {
-            m_dist       += m_dx; 
-            m_dist_start += m_dx_start; 
-            m_dist_end   += m_dx_end;
-            if(dx > 0)
-            {
-                m_dist       += m_dy; 
-                m_dist_start += m_dy_start; 
-                m_dist_end   += m_dy_end;
-            }
-            if(dx < 0)
-            {
-                m_dist       -= m_dy; 
-                m_dist_start -= m_dy_start; 
-                m_dist_end   -= m_dy_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        int dist()       const { return m_dist;       }
-        int dist_start() const { return m_dist_start; }
-        int dist_end()   const { return m_dist_end;   }
-
-        //---------------------------------------------------------------------
-        int dx()       const { return m_dx;       }
-        int dy()       const { return m_dy;       }
-        int dx_start() const { return m_dx_start; }
-        int dy_start() const { return m_dy_start; }
-        int dx_end()   const { return m_dx_end;   }
-        int dy_end()   const { return m_dy_end;   }
-
-    private:
-        //---------------------------------------------------------------------
-        int m_dx;
-        int m_dy;
-        int m_dx_start;
-        int m_dy_start;
-        int m_dx_end;
-        int m_dy_end;
-
-        int m_dist;
-        int m_dist_start;
-        int m_dist_end;
-    };
-
-
-
-
-    
-    //================================================line_interpolator_aa_base
-    template<class Renderer> class line_interpolator_aa_base
-    {
-    public:
-        typedef Renderer renderer_type;
-        typedef typename Renderer::color_type color_type;
-
-        //---------------------------------------------------------------------
-        enum max_half_width_e
-        { 
-            max_half_width = 64
-        };
-
-        //---------------------------------------------------------------------
-        line_interpolator_aa_base(renderer_type& ren, const line_parameters& lp) :
-            m_lp(&lp),
-            m_li(lp.vertical ? line_dbl_hr(lp.x2 - lp.x1) :
-                               line_dbl_hr(lp.y2 - lp.y1),
-                 lp.vertical ? abs(lp.y2 - lp.y1) : 
-                               abs(lp.x2 - lp.x1) + 1),
-            m_ren(ren),
-            m_len((lp.vertical == (lp.inc > 0)) ? -lp.len : lp.len),
-            m_x(lp.x1 >> line_subpixel_shift),
-            m_y(lp.y1 >> line_subpixel_shift),
-            m_old_x(m_x),
-            m_old_y(m_y),
-            m_count((lp.vertical ? abs((lp.y2 >> line_subpixel_shift) - m_y) :
-                                   abs((lp.x2 >> line_subpixel_shift) - m_x))),
-            m_width(ren.subpixel_width()),
-            //m_max_extent(m_width >> (line_subpixel_shift - 2)),
-            m_max_extent((m_width + line_subpixel_mask) >> line_subpixel_shift),
-            m_step(0)
-        {
-            mapserver::dda2_line_interpolator li(0, lp.vertical ? 
-                                              (lp.dy << mapserver::line_subpixel_shift) :
-                                              (lp.dx << mapserver::line_subpixel_shift),
-                                           lp.len);
-
-            unsigned i;
-            int stop = m_width + line_subpixel_scale * 2;
-            for(i = 0; i < max_half_width; ++i)
-            {
-                m_dist[i] = li.y();
-                if(m_dist[i] >= stop) break;
-                ++li;
-            }
-            m_dist[i++] = 0x7FFF0000;
-        }
-
-        //---------------------------------------------------------------------
-        template<class DI> int step_hor_base(DI& di)
-        {
-            ++m_li;
-            m_x += m_lp->inc;
-            m_y = (m_lp->y1 + m_li.y()) >> line_subpixel_shift;
-
-            if(m_lp->inc > 0) di.inc_x(m_y - m_old_y);
-            else              di.dec_x(m_y - m_old_y);
-
-            m_old_y = m_y;
-
-            return di.dist() / m_len;
-        }
-
-        //---------------------------------------------------------------------
-        template<class DI> int step_ver_base(DI& di)
-        {
-            ++m_li;
-            m_y += m_lp->inc;
-            m_x = (m_lp->x1 + m_li.y()) >> line_subpixel_shift;
-
-            if(m_lp->inc > 0) di.inc_y(m_x - m_old_x);
-            else              di.dec_y(m_x - m_old_x);
-
-            m_old_x = m_x;
-
-            return di.dist() / m_len;
-        }
-
-        //---------------------------------------------------------------------
-        bool vertical() const { return m_lp->vertical; }
-        int  width() const { return m_width; }
-        int  count() const { return m_count; }
-
-    private:
-        line_interpolator_aa_base(const line_interpolator_aa_base<Renderer>&);
-        const line_interpolator_aa_base<Renderer>& 
-            operator = (const line_interpolator_aa_base<Renderer>&);
-
-    protected:
-        const line_parameters* m_lp;
-        dda2_line_interpolator m_li;
-        renderer_type&         m_ren;
-        int m_len;
-        int m_x;
-        int m_y;
-        int m_old_x;
-        int m_old_y;
-        int m_count;
-        int m_width;
-        int m_max_extent;
-        int m_step;
-        int m_dist[max_half_width + 1];
-        cover_type m_covers[max_half_width * 2 + 4];
-    };
-
-
-
-
-
-
-
-    //====================================================line_interpolator_aa0
-    template<class Renderer> class line_interpolator_aa0 :
-    public line_interpolator_aa_base<Renderer>
-    {
-    public:
-        typedef Renderer renderer_type;
-        typedef typename Renderer::color_type color_type;
-        typedef line_interpolator_aa_base<Renderer> base_type;
-
-        //---------------------------------------------------------------------
-        line_interpolator_aa0(renderer_type& ren, const line_parameters& lp) :
-            line_interpolator_aa_base<Renderer>(ren, lp),
-            m_di(lp.x1, lp.y1, lp.x2, lp.y2, 
-                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask)
-        {
-            base_type::m_li.adjust_forward();
-        }
-
-        //---------------------------------------------------------------------
-        bool step_hor()
-        {
-            int dist;
-            int dy;
-            int s1 = base_type::step_hor_base(m_di);
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            *p1++ = (cover_type)base_type::m_ren.cover(s1);
-
-            dy = 1;
-            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
-            {
-                *p1++ = (cover_type)base_type::m_ren.cover(dist);
-                ++dy;
-            }
-
-            dy = 1;
-            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
-            {
-                *--p0 = (cover_type)base_type::m_ren.cover(dist);
-                ++dy;
-            }
-            base_type::m_ren.blend_solid_vspan(base_type::m_x, 
-                                               base_type::m_y - dy + 1, 
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return ++base_type::m_step < base_type::m_count;
-        }
-
-        //---------------------------------------------------------------------
-        bool step_ver()
-        {
-            int dist;
-            int dx;
-            int s1 = base_type::step_ver_base(m_di);
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            *p1++ = (cover_type)base_type::m_ren.cover(s1);
-
-            dx = 1;
-            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
-            {
-                *p1++ = (cover_type)base_type::m_ren.cover(dist);
-                ++dx;
-            }
-
-            dx = 1;
-            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
-            {
-                *--p0 = (cover_type)base_type::m_ren.cover(dist);
-                ++dx;
-            }
-            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1, 
-                                               base_type::m_y,
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return ++base_type::m_step < base_type::m_count;
-        }
-
-    private:
-        line_interpolator_aa0(const line_interpolator_aa0<Renderer>&);
-        const line_interpolator_aa0<Renderer>& 
-            operator = (const line_interpolator_aa0<Renderer>&);
-
-        //---------------------------------------------------------------------
-        distance_interpolator1 m_di; 
-    };
-
-
-
-
-
-
-    //====================================================line_interpolator_aa1
-    template<class Renderer> class line_interpolator_aa1 :
-    public line_interpolator_aa_base<Renderer>
-    {
-    public:
-        typedef Renderer renderer_type;
-        typedef typename Renderer::color_type color_type;
-        typedef line_interpolator_aa_base<Renderer> base_type;
-
-        //---------------------------------------------------------------------
-        line_interpolator_aa1(renderer_type& ren, const line_parameters& lp, 
-                              int sx, int sy) :
-            line_interpolator_aa_base<Renderer>(ren, lp),
-            m_di(lp.x1, lp.y1, lp.x2, lp.y2, sx, sy,
-                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask)
-        {
-            int dist1_start;
-            int dist2_start;
-
-            int npix = 1;
-
-            if(lp.vertical)
-            {
-                do
-                {
-                    --base_type::m_li;
-                    base_type::m_y -= lp.inc;
-                    base_type::m_x = (base_type::m_lp->x1 + base_type::m_li.y()) >> line_subpixel_shift;
-
-                    if(lp.inc > 0) m_di.dec_y(base_type::m_x - base_type::m_old_x);
-                    else           m_di.inc_y(base_type::m_x - base_type::m_old_x);
-
-                    base_type::m_old_x = base_type::m_x;
-
-                    dist1_start = dist2_start = m_di.dist_start(); 
-
-                    int dx = 0;
-                    if(dist1_start < 0) ++npix;
-                    do
-                    {
-                        dist1_start += m_di.dy_start();
-                        dist2_start -= m_di.dy_start();
-                        if(dist1_start < 0) ++npix;
-                        if(dist2_start < 0) ++npix;
-                        ++dx;
-                    }
-                    while(base_type::m_dist[dx] <= base_type::m_width);
-                    --base_type::m_step;
-                    if(npix == 0) break;
-                    npix = 0;
-                }
-                while(base_type::m_step >= -base_type::m_max_extent);
-            }
-            else
-            {
-                do
-                {
-                    --base_type::m_li;
-                    base_type::m_x -= lp.inc;
-                    base_type::m_y = (base_type::m_lp->y1 + base_type::m_li.y()) >> line_subpixel_shift;
-
-                    if(lp.inc > 0) m_di.dec_x(base_type::m_y - base_type::m_old_y);
-                    else           m_di.inc_x(base_type::m_y - base_type::m_old_y);
-
-                    base_type::m_old_y = base_type::m_y;
-
-                    dist1_start = dist2_start = m_di.dist_start(); 
-
-                    int dy = 0;
-                    if(dist1_start < 0) ++npix;
-                    do
-                    {
-                        dist1_start -= m_di.dx_start();
-                        dist2_start += m_di.dx_start();
-                        if(dist1_start < 0) ++npix;
-                        if(dist2_start < 0) ++npix;
-                        ++dy;
-                    }
-                    while(base_type::m_dist[dy] <= base_type::m_width);
-                    --base_type::m_step;
-                    if(npix == 0) break;
-                    npix = 0;
-                }
-                while(base_type::m_step >= -base_type::m_max_extent);
-            }
-            base_type::m_li.adjust_forward();
-        }
-
-        //---------------------------------------------------------------------
-        bool step_hor()
-        {
-            int dist_start;
-            int dist;
-            int dy;
-            int s1 = base_type::step_hor_base(m_di);
-
-            dist_start = m_di.dist_start();
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            *p1 = 0;
-            if(dist_start <= 0)
-            {
-                *p1 = (cover_type)base_type::m_ren.cover(s1);
-            }
-            ++p1;
-
-            dy = 1;
-            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
-            {
-                dist_start -= m_di.dx_start();
-                *p1 = 0;
-                if(dist_start <= 0)
-                {   
-                    *p1 = (cover_type)base_type::m_ren.cover(dist);
-                }
-                ++p1;
-                ++dy;
-            }
-
-            dy = 1;
-            dist_start = m_di.dist_start();
-            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
-            {
-                dist_start += m_di.dx_start();
-                *--p0 = 0;
-                if(dist_start <= 0)
-                {   
-                    *p0 = (cover_type)base_type::m_ren.cover(dist);
-                }
-                ++dy;
-            }
-
-            base_type::m_ren.blend_solid_vspan(base_type::m_x, 
-                                               base_type::m_y - dy + 1,
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return ++base_type::m_step < base_type::m_count;
-        }
-
-        //---------------------------------------------------------------------
-        bool step_ver()
-        {
-            int dist_start;
-            int dist;
-            int dx;
-            int s1 = base_type::step_ver_base(m_di);
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            dist_start = m_di.dist_start();
-
-            *p1 = 0;
-            if(dist_start <= 0)
-            {
-                *p1 = (cover_type)base_type::m_ren.cover(s1);
-            }
-            ++p1;
-
-            dx = 1;
-            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
-            {
-                dist_start += m_di.dy_start();
-                *p1 = 0;
-                if(dist_start <= 0)
-                {   
-                    *p1 = (cover_type)base_type::m_ren.cover(dist);
-                }
-                ++p1;
-                ++dx;
-            }
-
-            dx = 1;
-            dist_start = m_di.dist_start();
-            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
-            {
-                dist_start -= m_di.dy_start();
-                *--p0 = 0;
-                if(dist_start <= 0)
-                {   
-                    *p0 = (cover_type)base_type::m_ren.cover(dist);
-                }
-                ++dx;
-            }
-            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1, 
-                                               base_type::m_y,
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return ++base_type::m_step < base_type::m_count;
-        }
-
-    private:
-        line_interpolator_aa1(const line_interpolator_aa1<Renderer>&);
-        const line_interpolator_aa1<Renderer>& 
-            operator = (const line_interpolator_aa1<Renderer>&);
-
-        //---------------------------------------------------------------------
-        distance_interpolator2 m_di; 
-    };
-
-
-
-
-
-
-
-
-
-
-
-
-    //====================================================line_interpolator_aa2
-    template<class Renderer> class line_interpolator_aa2 :
-    public line_interpolator_aa_base<Renderer>
-    {
-    public:
-        typedef Renderer renderer_type;
-        typedef typename Renderer::color_type color_type;
-        typedef line_interpolator_aa_base<Renderer> base_type;
-
-        //---------------------------------------------------------------------
-        line_interpolator_aa2(renderer_type& ren, const line_parameters& lp, 
-                              int ex, int ey) :
-            line_interpolator_aa_base<Renderer>(ren, lp),
-            m_di(lp.x1, lp.y1, lp.x2, lp.y2, ex, ey, 
-                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask,
-                 0)
-        {
-            base_type::m_li.adjust_forward();
-            base_type::m_step -= base_type::m_max_extent;
-        }
-
-        //---------------------------------------------------------------------
-        bool step_hor()
-        {
-            int dist_end;
-            int dist;
-            int dy;
-            int s1 = base_type::step_hor_base(m_di);
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            dist_end = m_di.dist_end();
-
-            int npix = 0;
-            *p1 = 0;
-            if(dist_end > 0)
-            {
-                *p1 = (cover_type)base_type::m_ren.cover(s1);
-                ++npix;
-            }
-            ++p1;
-
-            dy = 1;
-            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
-            {
-                dist_end -= m_di.dx_end();
-                *p1 = 0;
-                if(dist_end > 0)
-                {   
-                    *p1 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++p1;
-                ++dy;
-            }
-
-            dy = 1;
-            dist_end = m_di.dist_end();
-            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
-            {
-                dist_end += m_di.dx_end();
-                *--p0 = 0;
-                if(dist_end > 0)
-                {   
-                    *p0 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++dy;
-            }
-            base_type::m_ren.blend_solid_vspan(base_type::m_x,
-                                               base_type::m_y - dy + 1, 
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return npix && ++base_type::m_step < base_type::m_count;
-        }
-
-        //---------------------------------------------------------------------
-        bool step_ver()
-        {
-            int dist_end;
-            int dist;
-            int dx;
-            int s1 = base_type::step_ver_base(m_di);
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            dist_end = m_di.dist_end();
-
-            int npix = 0;
-            *p1 = 0;
-            if(dist_end > 0)
-            {
-                *p1 = (cover_type)base_type::m_ren.cover(s1);
-                ++npix;
-            }
-            ++p1;
-
-            dx = 1;
-            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
-            {
-                dist_end += m_di.dy_end();
-                *p1 = 0;
-                if(dist_end > 0)
-                {   
-                    *p1 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++p1;
-                ++dx;
-            }
-
-            dx = 1;
-            dist_end = m_di.dist_end();
-            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
-            {
-                dist_end -= m_di.dy_end();
-                *--p0 = 0;
-                if(dist_end > 0)
-                {   
-                    *p0 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++dx;
-            }
-            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1,
-                                               base_type::m_y, 
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return npix && ++base_type::m_step < base_type::m_count;
-        }
-
-    private:
-        line_interpolator_aa2(const line_interpolator_aa2<Renderer>&);
-        const line_interpolator_aa2<Renderer>& 
-            operator = (const line_interpolator_aa2<Renderer>&);
-
-        //---------------------------------------------------------------------
-        distance_interpolator2 m_di; 
-    };
-
-
-
-
-
-
-
-
-
-
-    //====================================================line_interpolator_aa3
-    template<class Renderer> class line_interpolator_aa3 :
-    public line_interpolator_aa_base<Renderer>
-    {
-    public:
-        typedef Renderer renderer_type;
-        typedef typename Renderer::color_type color_type;
-        typedef line_interpolator_aa_base<Renderer> base_type;
-
-        //---------------------------------------------------------------------
-        line_interpolator_aa3(renderer_type& ren, const line_parameters& lp, 
-                              int sx, int sy, int ex, int ey) :
-            line_interpolator_aa_base<Renderer>(ren, lp),
-            m_di(lp.x1, lp.y1, lp.x2, lp.y2, sx, sy, ex, ey, 
-                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask)
-        {
-            int dist1_start;
-            int dist2_start;
-            int npix = 1;
-            if(lp.vertical)
-            {
-                do
-                {
-                    --base_type::m_li;
-                    base_type::m_y -= lp.inc;
-                    base_type::m_x = (base_type::m_lp->x1 + base_type::m_li.y()) >> line_subpixel_shift;
-
-                    if(lp.inc > 0) m_di.dec_y(base_type::m_x - base_type::m_old_x);
-                    else           m_di.inc_y(base_type::m_x - base_type::m_old_x);
-
-                    base_type::m_old_x = base_type::m_x;
-
-                    dist1_start = dist2_start = m_di.dist_start(); 
-
-                    int dx = 0;
-                    if(dist1_start < 0) ++npix;
-                    do
-                    {
-                        dist1_start += m_di.dy_start();
-                        dist2_start -= m_di.dy_start();
-                        if(dist1_start < 0) ++npix;
-                        if(dist2_start < 0) ++npix;
-                        ++dx;
-                    }
-                    while(base_type::m_dist[dx] <= base_type::m_width);
-                    if(npix == 0) break;
-                    npix = 0;
-                }
-                while(--base_type::m_step >= -base_type::m_max_extent);
-            }
-            else
-            {
-                do
-                {
-                    --base_type::m_li;
-                    base_type::m_x -= lp.inc;
-                    base_type::m_y = (base_type::m_lp->y1 + base_type::m_li.y()) >> line_subpixel_shift;
-
-                    if(lp.inc > 0) m_di.dec_x(base_type::m_y - base_type::m_old_y);
-                    else           m_di.inc_x(base_type::m_y - base_type::m_old_y);
-
-                    base_type::m_old_y = base_type::m_y;
-
-                    dist1_start = dist2_start = m_di.dist_start(); 
-
-                    int dy = 0;
-                    if(dist1_start < 0) ++npix;
-                    do
-                    {
-                        dist1_start -= m_di.dx_start();
-                        dist2_start += m_di.dx_start();
-                        if(dist1_start < 0) ++npix;
-                        if(dist2_start < 0) ++npix;
-                        ++dy;
-                    }
-                    while(base_type::m_dist[dy] <= base_type::m_width);
-                    if(npix == 0) break;
-                    npix = 0;
-                }
-                while(--base_type::m_step >= -base_type::m_max_extent);
-            }
-            base_type::m_li.adjust_forward();
-            base_type::m_step -= base_type::m_max_extent;
-        }
-
-
-        //---------------------------------------------------------------------
-        bool step_hor()
-        {
-            int dist_start;
-            int dist_end;
-            int dist;
-            int dy;
-            int s1 = base_type::step_hor_base(m_di);
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            dist_start = m_di.dist_start();
-            dist_end   = m_di.dist_end();
-
-            int npix = 0;
-            *p1 = 0;
-            if(dist_end > 0)
-            {
-                if(dist_start <= 0)
-                {
-                    *p1 = (cover_type)base_type::m_ren.cover(s1);
-                }
-                ++npix;
-            }
-            ++p1;
-
-            dy = 1;
-            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
-            {
-                dist_start -= m_di.dx_start();
-                dist_end   -= m_di.dx_end();
-                *p1 = 0;
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    *p1 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++p1;
-                ++dy;
-            }
-
-            dy = 1;
-            dist_start = m_di.dist_start();
-            dist_end   = m_di.dist_end();
-            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
-            {
-                dist_start += m_di.dx_start();
-                dist_end   += m_di.dx_end();
-                *--p0 = 0;
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    *p0 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++dy;
-            }
-            base_type::m_ren.blend_solid_vspan(base_type::m_x,
-                                               base_type::m_y - dy + 1, 
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return npix && ++base_type::m_step < base_type::m_count;
-        }
-
-        //---------------------------------------------------------------------
-        bool step_ver()
-        {
-            int dist_start;
-            int dist_end;
-            int dist;
-            int dx;
-            int s1 = base_type::step_ver_base(m_di);
-            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
-            cover_type* p1 = p0;
-
-            dist_start = m_di.dist_start();
-            dist_end   = m_di.dist_end();
-
-            int npix = 0;
-            *p1 = 0;
-            if(dist_end > 0)
-            {
-                if(dist_start <= 0)
-                {
-                    *p1 = (cover_type)base_type::m_ren.cover(s1);
-                }
-                ++npix;
-            }
-            ++p1;
-
-            dx = 1;
-            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
-            {
-                dist_start += m_di.dy_start();
-                dist_end   += m_di.dy_end();
-                *p1 = 0;
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    *p1 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++p1;
-                ++dx;
-            }
-
-            dx = 1;
-            dist_start = m_di.dist_start();
-            dist_end   = m_di.dist_end();
-            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
-            {
-                dist_start -= m_di.dy_start();
-                dist_end   -= m_di.dy_end();
-                *--p0 = 0;
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    *p0 = (cover_type)base_type::m_ren.cover(dist);
-                    ++npix;
-                }
-                ++dx;
-            }
-            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1,
-                                               base_type::m_y, 
-                                               unsigned(p1 - p0), 
-                                               p0);
-            return npix && ++base_type::m_step < base_type::m_count;
-        }
-
-    private:
-        line_interpolator_aa3(const line_interpolator_aa3<Renderer>&);
-        const line_interpolator_aa3<Renderer>& 
-            operator = (const line_interpolator_aa3<Renderer>&);
-
-        //---------------------------------------------------------------------
-        distance_interpolator3 m_di; 
-    };
-
-
-
-
-    //==========================================================line_profile_aa
-    //
-    // See Implementation agg_line_profile_aa.cpp 
-    // 
-    class line_profile_aa
-    {
-    public:
-        //---------------------------------------------------------------------
-        typedef int8u value_type;
-        enum subpixel_scale_e
-        {
-            subpixel_shift = line_subpixel_shift,
-            subpixel_scale = 1 << subpixel_shift,
-            subpixel_mask  = subpixel_scale - 1
-        };
-
-        enum aa_scale_e
-        {
-            aa_shift = 8,
-            aa_scale = 1 << aa_shift,
-            aa_mask  = aa_scale - 1
-        };
-        
-        //---------------------------------------------------------------------
-        line_profile_aa() : 
-            m_subpixel_width(0),
-            m_min_width(1.0),
-            m_smoother_width(1.0)
-        {
-            int i;
-            for(i = 0; i < aa_scale; i++) m_gamma[i] = (value_type)i;
-        }
-
-        //---------------------------------------------------------------------
-        template<class GammaF> 
-        line_profile_aa(double w, const GammaF& gamma_function) : 
-            m_subpixel_width(0),
-            m_min_width(1.0),
-            m_smoother_width(1.0)
-        {
-            gamma(gamma_function);
-            width(w);
-        }
-
-        //---------------------------------------------------------------------
-        void min_width(double w) { m_min_width = w; }
-        void smoother_width(double w) { m_smoother_width = w; }
-
-        //---------------------------------------------------------------------
-        template<class GammaF> void gamma(const GammaF& gamma_function)
-        { 
-            int i;
-            for(i = 0; i < aa_scale; i++)
-            {
-                m_gamma[i] = value_type(
-                    uround(gamma_function(double(i) / aa_mask) * aa_mask));
-            }
-        }
-
-        void width(double w);
-
-        unsigned profile_size() const { return m_profile.size(); }
-        int subpixel_width() const { return m_subpixel_width; }
-
-        //---------------------------------------------------------------------
-        double min_width() const { return m_min_width; }
-        double smoother_width() const { return m_smoother_width; }
-
-        //---------------------------------------------------------------------
-        value_type value(int dist) const
-        {
-            return m_profile[dist + subpixel_scale*2];
-        }
-
-    private:
-        line_profile_aa(const line_profile_aa&);
-        const line_profile_aa& operator = (const line_profile_aa&);
-
-        value_type* profile(double w);
-        void set(double center_width, double smoother_width);
-
-        //---------------------------------------------------------------------
-        pod_array<value_type> m_profile;
-        value_type            m_gamma[aa_scale];
-        int                   m_subpixel_width;
-        double                m_min_width;
-        double                m_smoother_width;
-    };
-
-
-    //======================================================renderer_outline_aa
-    template<class BaseRenderer> class renderer_outline_aa
-    {
-    public:
-        //---------------------------------------------------------------------
-        typedef BaseRenderer base_ren_type;
-        typedef renderer_outline_aa<base_ren_type> self_type;
-        typedef typename base_ren_type::color_type color_type;
-
-        //---------------------------------------------------------------------
-        renderer_outline_aa(base_ren_type& ren, const line_profile_aa& prof) :
-            m_ren(&ren),
-            m_profile(&prof),
-            m_clip_box(0,0,0,0),
-            m_clipping(false)
-        {}
-        void attach(base_ren_type& ren) { m_ren = &ren; }
-
-        //---------------------------------------------------------------------
-        void color(const color_type& c) { m_color = c; }
-        const color_type& color() const { return m_color; }
-
-        //---------------------------------------------------------------------
-        void profile(const line_profile_aa& prof) { m_profile = &prof; }
-        const line_profile_aa& profile() const { return *m_profile; }
-
-        //---------------------------------------------------------------------
-        int subpixel_width() const { return m_profile->subpixel_width(); }
-
-        //---------------------------------------------------------------------
-        void reset_clipping() { m_clipping = false; }
-        void clip_box(double x1, double y1, double x2, double y2)
-        {
-            m_clip_box.x1 = line_coord_sat::conv(x1);
-            m_clip_box.y1 = line_coord_sat::conv(y1);
-            m_clip_box.x2 = line_coord_sat::conv(x2);
-            m_clip_box.y2 = line_coord_sat::conv(y2);
-            m_clipping = true;
-        }
-
-        //---------------------------------------------------------------------
-        int cover(int d) const
-        {
-            return m_profile->value(d);
-        }
-
-        //-------------------------------------------------------------------------
-        void blend_solid_hspan(int x, int y, unsigned len, const cover_type* covers)
-        {
-            m_ren->blend_solid_hspan(x, y, len, m_color, covers);
-        }
-
-        //-------------------------------------------------------------------------
-        void blend_solid_vspan(int x, int y, unsigned len, const cover_type* covers)
-        {
-            m_ren->blend_solid_vspan(x, y, len, m_color, covers);
-        }
-
-        //-------------------------------------------------------------------------
-        static bool accurate_join_only() { return false; }
-
-        //-------------------------------------------------------------------------
-        template<class Cmp>
-        void semidot_hline(Cmp cmp,
-                           int xc1, int yc1, int xc2, int yc2, 
-                           int x1,  int y1,  int x2)
-        {
-            cover_type covers[line_interpolator_aa_base<self_type>::max_half_width * 2 + 4];
-            cover_type* p0 = covers;
-            cover_type* p1 = covers;
-            int x = x1 << line_subpixel_shift;
-            int y = y1 << line_subpixel_shift;
-            int w = subpixel_width();
-            distance_interpolator0 di(xc1, yc1, xc2, yc2, x, y);
-            x += line_subpixel_scale/2;
-            y += line_subpixel_scale/2;
-
-            int x0 = x1;
-            int dx = x - xc1;
-            int dy = y - yc1;
-            do
-            {
-                int d = int(fast_sqrt(dx*dx + dy*dy));
-                *p1 = 0;
-                if(cmp(di.dist()) && d <= w)
-                {
-                    *p1 = (cover_type)cover(d);
-                }
-                ++p1;
-                dx += line_subpixel_scale;
-                di.inc_x();
-            }
-            while(++x1 <= x2);
-            m_ren->blend_solid_hspan(x0, y1, 
-                                     unsigned(p1 - p0), 
-                                     color(), 
-                                     p0);
-        }
-
-        //-------------------------------------------------------------------------
-        template<class Cmp> 
-        void semidot(Cmp cmp, int xc1, int yc1, int xc2, int yc2)
-        {
-            if(m_clipping && clipping_flags(xc1, yc1, m_clip_box)) return;
-
-            int r = ((subpixel_width() + line_subpixel_mask) >> line_subpixel_shift);
-            if(r < 1) r = 1;
-            ellipse_bresenham_interpolator ei(r, r);
-            int dx = 0;
-            int dy = -r;
-            int dy0 = dy;
-            int dx0 = dx;
-            int x = xc1 >> line_subpixel_shift;
-            int y = yc1 >> line_subpixel_shift;
-
-            do
-            {
-                dx += ei.dx();
-                dy += ei.dy();
-
-                if(dy != dy0)
-                {
-                    semidot_hline(cmp, xc1, yc1, xc2, yc2, x-dx0, y+dy0, x+dx0);
-                    semidot_hline(cmp, xc1, yc1, xc2, yc2, x-dx0, y-dy0, x+dx0);
-                }
-                dx0 = dx;
-                dy0 = dy;
-                ++ei;
-            }
-            while(dy < 0);
-            semidot_hline(cmp, xc1, yc1, xc2, yc2, x-dx0, y+dy0, x+dx0);
-        }
-
-        //-------------------------------------------------------------------------
-        void pie_hline(int xc, int yc, int xp1, int yp1, int xp2, int yp2, 
-                       int xh1, int yh1, int xh2)
-        {
-            if(m_clipping && clipping_flags(xc, yc, m_clip_box)) return;
-           
-            cover_type covers[line_interpolator_aa_base<self_type>::max_half_width * 2 + 4];
-            cover_type* p0 = covers;
-            cover_type* p1 = covers;
-            int x = xh1 << line_subpixel_shift;
-            int y = yh1 << line_subpixel_shift;
-            int w = subpixel_width();
-
-            distance_interpolator00 di(xc, yc, xp1, yp1, xp2, yp2, x, y);
-            x += line_subpixel_scale/2;
-            y += line_subpixel_scale/2;
-
-            int xh0 = xh1;
-            int dx = x - xc;
-            int dy = y - yc;
-            do
-            {
-                int d = int(fast_sqrt(dx*dx + dy*dy));
-                *p1 = 0;
-                if(di.dist1() <= 0 && di.dist2() > 0 && d <= w)
-                {
-                    *p1 = (cover_type)cover(d);
-                }
-                ++p1;
-                dx += line_subpixel_scale;
-                di.inc_x();
-            }
-            while(++xh1 <= xh2);
-            m_ren->blend_solid_hspan(xh0, yh1, 
-                                     unsigned(p1 - p0), 
-                                     color(), 
-                                     p0);
-        }
-
-
-        //-------------------------------------------------------------------------
-        void pie(int xc, int yc, int x1, int y1, int x2, int y2)
-        {
-            int r = ((subpixel_width() + line_subpixel_mask) >> line_subpixel_shift);
-            if(r < 1) r = 1;
-            ellipse_bresenham_interpolator ei(r, r);
-            int dx = 0;
-            int dy = -r;
-            int dy0 = dy;
-            int dx0 = dx;
-            int x = xc >> line_subpixel_shift;
-            int y = yc >> line_subpixel_shift;
-
-            do
-            {
-                dx += ei.dx();
-                dy += ei.dy();
-
-                if(dy != dy0)
-                {
-                    pie_hline(xc, yc, x1, y1, x2, y2, x-dx0, y+dy0, x+dx0);
-                    pie_hline(xc, yc, x1, y1, x2, y2, x-dx0, y-dy0, x+dx0);
-                }
-                dx0 = dx;
-                dy0 = dy;
-                ++ei;
-            }
-            while(dy < 0);
-            pie_hline(xc, yc, x1, y1, x2, y2, x-dx0, y+dy0, x+dx0);
-        }
-
-        //-------------------------------------------------------------------------
-        void line0_no_clip(const line_parameters& lp)
-        {
-            if(lp.len > line_max_length)
-            {
-                line_parameters lp1, lp2;
-                lp.divide(lp1, lp2);
-                line0_no_clip(lp1);
-                line0_no_clip(lp2);
-                return;
-            }
-
-            line_interpolator_aa0<self_type> li(*this, lp);
-            if(li.count())
-            {
-                if(li.vertical())
-                {
-                    while(li.step_ver());
-                }
-                else
-                {
-                    while(li.step_hor());
-                }
-            }
-        }
-
-        //-------------------------------------------------------------------------
-        void line0(const line_parameters& lp)
-        {
-            if(m_clipping)
-            {
-                int x1 = lp.x1;
-                int y1 = lp.y1;
-                int x2 = lp.x2;
-                int y2 = lp.y2;
-                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
-                if((flags & 4) == 0)
-                {
-                    if(flags)
-                    {
-                        line_parameters lp2(x1, y1, x2, y2, 
-                                           uround(calc_distance(x1, y1, x2, y2)));
-                        line0_no_clip(lp2);
-                    }
-                    else
-                    {
-                        line0_no_clip(lp);
-                    }
-                }
-            }
-            else
-            {
-                line0_no_clip(lp);
-            }
-        }
-
-        //-------------------------------------------------------------------------
-        void line1_no_clip(const line_parameters& lp, int sx, int sy)
-        {
-            if(lp.len > line_max_length)
-            {
-                line_parameters lp1, lp2;
-                lp.divide(lp1, lp2);
-                line1_no_clip(lp1, (lp.x1 + sx) >> 1, (lp.y1 + sy) >> 1);
-                line1_no_clip(lp2, lp1.x2 + (lp1.y2 - lp1.y1), lp1.y2 - (lp1.x2 - lp1.x1));
-                return;
-            }
-
-            fix_degenerate_bisectrix_start(lp, &sx, &sy);
-            line_interpolator_aa1<self_type> li(*this, lp, sx, sy);
-            if(li.vertical())
-            {
-                while(li.step_ver());
-            }
-            else
-            {
-                while(li.step_hor());
-            }
-        }
-
-
-        //-------------------------------------------------------------------------
-        void line1(const line_parameters& lp, int sx, int sy)
-        {
-            if(m_clipping)
-            {
-                int x1 = lp.x1;
-                int y1 = lp.y1;
-                int x2 = lp.x2;
-                int y2 = lp.y2;
-                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
-                if((flags & 4) == 0)
-                {
-                    if(flags)
-                    {
-                        line_parameters lp2(x1, y1, x2, y2, 
-                                           uround(calc_distance(x1, y1, x2, y2)));
-                        if(flags & 1)
-                        {
-                            sx = x1 + (y2 - y1); 
-                            sy = y1 - (x2 - x1);
-                        }
-                        else
-                        {
-                            while(abs(sx - lp.x1) + abs(sy - lp.y1) > lp2.len)
-                            {
-                                sx = (lp.x1 + sx) >> 1;
-                                sy = (lp.y1 + sy) >> 1;
-                            }
-                        }
-                        line1_no_clip(lp2, sx, sy);
-                    }
-                    else
-                    {
-                        line1_no_clip(lp, sx, sy);
-                    }
-                }
-            }
-            else
-            {
-                line1_no_clip(lp, sx, sy);
-            }
-        }
-
-        //-------------------------------------------------------------------------
-        void line2_no_clip(const line_parameters& lp, int ex, int ey)
-        {
-            if(lp.len > line_max_length)
-            {
-                line_parameters lp1, lp2;
-                lp.divide(lp1, lp2);
-                line2_no_clip(lp1, lp1.x2 + (lp1.y2 - lp1.y1), lp1.y2 - (lp1.x2 - lp1.x1));
-                line2_no_clip(lp2, (lp.x2 + ex) >> 1, (lp.y2 + ey) >> 1);
-                return;
-            }
-
-            fix_degenerate_bisectrix_end(lp, &ex, &ey);
-            line_interpolator_aa2<self_type> li(*this, lp, ex, ey);
-            if(li.vertical())
-            {
-                while(li.step_ver());
-            }
-            else
-            {
-                while(li.step_hor());
-            }
-        }
-
-        //-------------------------------------------------------------------------
-        void line2(const line_parameters& lp, int ex, int ey)
-        {
-            if(m_clipping)
-            {
-                int x1 = lp.x1;
-                int y1 = lp.y1;
-                int x2 = lp.x2;
-                int y2 = lp.y2;
-                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
-                if((flags & 4) == 0)
-                {
-                    if(flags)
-                    {
-                        line_parameters lp2(x1, y1, x2, y2, 
-                                           uround(calc_distance(x1, y1, x2, y2)));
-                        if(flags & 2)
-                        {
-                            ex = x2 + (y2 - y1); 
-                            ey = y2 - (x2 - x1);
-                        }
-                        else
-                        {
-                            while(abs(ex - lp.x2) + abs(ey - lp.y2) > lp2.len)
-                            {
-                                ex = (lp.x2 + ex) >> 1;
-                                ey = (lp.y2 + ey) >> 1;
-                            }
-                        }
-                        line2_no_clip(lp2, ex, ey);
-                    }
-                    else
-                    {
-                        line2_no_clip(lp, ex, ey);
-                    }
-                }
-            }
-            else
-            {
-                line2_no_clip(lp, ex, ey);
-            }
-        }
-
-        //-------------------------------------------------------------------------
-        void line3_no_clip(const line_parameters& lp, 
-                           int sx, int sy, int ex, int ey)
-        {
-            if(lp.len > line_max_length)
-            {
-                line_parameters lp1, lp2;
-                lp.divide(lp1, lp2);
-                int mx = lp1.x2 + (lp1.y2 - lp1.y1);
-                int my = lp1.y2 - (lp1.x2 - lp1.x1);
-                line3_no_clip(lp1, (lp.x1 + sx) >> 1, (lp.y1 + sy) >> 1, mx, my);
-                line3_no_clip(lp2, mx, my, (lp.x2 + ex) >> 1, (lp.y2 + ey) >> 1);
-                return;
-            }
-
-            fix_degenerate_bisectrix_start(lp, &sx, &sy);
-            fix_degenerate_bisectrix_end(lp, &ex, &ey);
-            line_interpolator_aa3<self_type> li(*this, lp, sx, sy, ex, ey);
-            if(li.vertical())
-            {
-                while(li.step_ver());
-            }
-            else
-            {
-                while(li.step_hor());
-            }
-        }
-
-        //-------------------------------------------------------------------------
-        void line3(const line_parameters& lp, 
-                   int sx, int sy, int ex, int ey)
-        {
-            if(m_clipping)
-            {
-                int x1 = lp.x1;
-                int y1 = lp.y1;
-                int x2 = lp.x2;
-                int y2 = lp.y2;
-                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
-                if((flags & 4) == 0)
-                {
-                    if(flags)
-                    {
-                        line_parameters lp2(x1, y1, x2, y2, 
-                                           uround(calc_distance(x1, y1, x2, y2)));
-                        if(flags & 1)
-                        {
-                            sx = x1 + (y2 - y1); 
-                            sy = y1 - (x2 - x1);
-                        }
-                        else
-                        {
-                            while(abs(sx - lp.x1) + abs(sy - lp.y1) > lp2.len)
-                            {
-                                sx = (lp.x1 + sx) >> 1;
-                                sy = (lp.y1 + sy) >> 1;
-                            }
-                        }
-                        if(flags & 2)
-                        {
-                            ex = x2 + (y2 - y1); 
-                            ey = y2 - (x2 - x1);
-                        }
-                        else
-                        {
-                            while(abs(ex - lp.x2) + abs(ey - lp.y2) > lp2.len)
-                            {
-                                ex = (lp.x2 + ex) >> 1;
-                                ey = (lp.y2 + ey) >> 1;
-                            }
-                        }
-                        line3_no_clip(lp2, sx, sy, ex, ey);
-                    }
-                    else
-                    {
-                        line3_no_clip(lp, sx, sy, ex, ey);
-                    }
-                }
-            }
-            else
-            {
-                line3_no_clip(lp, sx, sy, ex, ey);
-            }
-        }
-
-
-    private:
-        base_ren_type*         m_ren;
-        const line_profile_aa* m_profile; 
-        color_type             m_color;
-        rect_i                 m_clip_box;
-        bool                   m_clipping;
-    };
-
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_outline_image.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_outline_image.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_outline_image.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_outline_image.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1013 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_RENDERER_OUTLINE_IMAGE_INCLUDED
-#define AGG_RENDERER_OUTLINE_IMAGE_INCLUDED
-
-#include "agg_array.h"
-#include "agg_math.h"
-#include "agg_line_aa_basics.h"
-#include "agg_dda_line.h"
-#include "agg_rendering_buffer.h"
-#include "agg_clip_liang_barsky.h"
-
-
-namespace mapserver
-{
-    //========================================================line_image_scale
-    template<class Source> class line_image_scale
-    {
-    public:
-        typedef typename Source::color_type color_type;
-
-        line_image_scale(const Source& src, double height) :
-            m_source(src), 
-            m_height(height),
-            m_scale(src.height() / height)
-        {
-        }
-
-        double width()  const { return m_source.width(); }
-        double height() const { return m_height; }
-
-        color_type pixel(int x, int y) const 
-        { 
-            double src_y = (y + 0.5) * m_scale - 0.5;
-            int h  = m_source.height() - 1;
-            int y1 = ufloor(src_y);
-            int y2 = y1 + 1;
-            color_type pix1 = (y1 < 0) ? color_type::no_color() : m_source.pixel(x, y1);
-            color_type pix2 = (y2 > h) ? color_type::no_color() : m_source.pixel(x, y2);
-            return pix1.gradient(pix2, src_y - y1);
-        }
-
-    private:
-        line_image_scale(const line_image_scale<Source>&);
-        const line_image_scale<Source>& operator = (const line_image_scale<Source>&);
-
-        const Source& m_source;
-        double        m_height;
-        double        m_scale;
-    };
-
-
-
-    //======================================================line_image_pattern
-    template<class Filter> class line_image_pattern
-    {
-    public:
-        typedef Filter filter_type;
-        typedef typename filter_type::color_type color_type;
-
-        //--------------------------------------------------------------------
-        line_image_pattern(const Filter& filter) :
-            m_filter(&filter),
-            m_dilation(filter.dilation() + 1),
-            m_dilation_hr(m_dilation << line_subpixel_shift),
-            m_data(),
-            m_width(0),
-            m_height(0),
-            m_width_hr(0),
-            m_half_height_hr(0),
-            m_offset_y_hr(0)
-        {
-        }
-
-        // Create
-        //--------------------------------------------------------------------
-        template<class Source> 
-        line_image_pattern(const Filter& filter, const Source& src) :
-            m_filter(&filter),
-            m_dilation(filter.dilation() + 1),
-            m_dilation_hr(m_dilation << line_subpixel_shift),
-            m_data(),
-            m_width(0),
-            m_height(0),
-            m_width_hr(0),
-            m_half_height_hr(0),
-            m_offset_y_hr(0)
-        {
-            create(src);
-        }
-
-        // Create
-        //--------------------------------------------------------------------
-        template<class Source> void create(const Source& src)
-        {
-            m_height = uceil(src.height());
-            m_width  = uceil(src.width());
-            m_width_hr = uround(src.width() * line_subpixel_scale);
-            m_half_height_hr = uround(src.height() * line_subpixel_scale/2);
-            m_offset_y_hr = m_dilation_hr + m_half_height_hr - line_subpixel_scale/2;
-            m_half_height_hr += line_subpixel_scale/2;
-
-            m_data.resize((m_width + m_dilation * 2) * (m_height + m_dilation * 2));
-
-            m_buf.attach(&m_data[0], m_width  + m_dilation * 2, 
-                                     m_height + m_dilation * 2, 
-                                     m_width  + m_dilation * 2);
-            unsigned x, y;
-            color_type* d1;
-            color_type* d2;
-            for(y = 0; y < m_height; y++)
-            {
-                d1 = m_buf.row_ptr(y + m_dilation) + m_dilation;
-                for(x = 0; x < m_width; x++)
-                {
-                    *d1++ = src.pixel(x, y);
-                }
-            }
-
-            const color_type* s1;
-            const color_type* s2;
-            for(y = 0; y < m_dilation; y++)
-            {
-                //s1 = m_buf.row_ptr(m_height + m_dilation - 1) + m_dilation;
-                //s2 = m_buf.row_ptr(m_dilation) + m_dilation;
-                d1 = m_buf.row_ptr(m_dilation + m_height + y) + m_dilation;
-                d2 = m_buf.row_ptr(m_dilation - y - 1) + m_dilation;
-                for(x = 0; x < m_width; x++)
-                {
-                    //*d1++ = color_type(*s1++, 0);
-                    //*d2++ = color_type(*s2++, 0);
-                    *d1++ = color_type::no_color();
-                    *d2++ = color_type::no_color();
-                }
-            }
-
-            unsigned h = m_height + m_dilation * 2;
-            for(y = 0; y < h; y++)
-            {
-                s1 = m_buf.row_ptr(y) + m_dilation;
-                s2 = m_buf.row_ptr(y) + m_dilation + m_width;
-                d1 = m_buf.row_ptr(y) + m_dilation + m_width;
-                d2 = m_buf.row_ptr(y) + m_dilation;
-
-                for(x = 0; x < m_dilation; x++)
-                {
-                    *d1++ = *s1++;
-                    *--d2 = *--s2;
-                }
-            }
-        }
-
-        //--------------------------------------------------------------------
-        int pattern_width() const { return m_width_hr; }
-        int line_width()    const { return m_half_height_hr; }
-        double width()      const { return m_height; }
-
-        //--------------------------------------------------------------------
-        void pixel(color_type* p, int x, int y) const
-        {
-            m_filter->pixel_high_res(m_buf.rows(), 
-                                     p, 
-                                     x % m_width_hr + m_dilation_hr,
-                                     y + m_offset_y_hr);
-        }
-
-        //--------------------------------------------------------------------
-        const filter_type& filter() const { return *m_filter; }
-
-    private:
-        line_image_pattern(const line_image_pattern<filter_type>&);
-        const line_image_pattern<filter_type>& 
-            operator = (const line_image_pattern<filter_type>&);
-
-    protected:
-        row_ptr_cache<color_type> m_buf;
-        const filter_type*        m_filter;
-        unsigned                  m_dilation;
-        int                       m_dilation_hr;
-        pod_array<color_type>     m_data;
-        unsigned                  m_width;
-        unsigned                  m_height;
-        int                       m_width_hr;
-        int                       m_half_height_hr;
-        int                       m_offset_y_hr;
-    };
-
-
-
-
-
-
-    //=================================================line_image_pattern_pow2
-    template<class Filter> class line_image_pattern_pow2 : 
-    public line_image_pattern<Filter>
-    {
-    public:
-        typedef Filter filter_type;
-        typedef typename filter_type::color_type color_type;
-        typedef line_image_pattern<Filter> base_type;
-	
-        //--------------------------------------------------------------------
-        line_image_pattern_pow2(const Filter& filter) :
-            line_image_pattern<Filter>(filter), m_mask(line_subpixel_mask) {}
-
-        //--------------------------------------------------------------------
-        template<class Source> 
-        line_image_pattern_pow2(const Filter& filter, const Source& src) :
-            line_image_pattern<Filter>(filter), m_mask(line_subpixel_mask)
-        {
-            create(src);
-        }
-            
-        //--------------------------------------------------------------------
-        template<class Source> void create(const Source& src)
-        {
-            line_image_pattern<Filter>::create(src);
-            m_mask = 1;
-            while(m_mask < base_type::m_width) 
-            {
-                m_mask <<= 1;
-                m_mask |= 1;
-            }
-            m_mask <<= line_subpixel_shift - 1;
-            m_mask |=  line_subpixel_mask;
-            base_type::m_width_hr = m_mask + 1;
-        }
-
-        //--------------------------------------------------------------------
-        void pixel(color_type* p, int x, int y) const
-        {
-            base_type::m_filter->pixel_high_res(
-                    base_type::m_buf.rows(), 
-                    p,
-                    (x & m_mask) + base_type::m_dilation_hr,
-                    y + base_type::m_offset_y_hr);
-        }
-    private:
-        unsigned m_mask;
-    };
-    
-    
-    
-    
-    
-    
-    
-    //===================================================distance_interpolator4
-    class distance_interpolator4
-    {
-    public:
-        //---------------------------------------------------------------------
-        distance_interpolator4() {}
-        distance_interpolator4(int x1,  int y1, int x2, int y2,
-                               int sx,  int sy, int ex, int ey, 
-                               int len, double scale, int x, int y) :
-            m_dx(x2 - x1),
-            m_dy(y2 - y1),
-            m_dx_start(line_mr(sx) - line_mr(x1)),
-            m_dy_start(line_mr(sy) - line_mr(y1)),
-            m_dx_end(line_mr(ex) - line_mr(x2)),
-            m_dy_end(line_mr(ey) - line_mr(y2)),
-
-            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
-                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
-
-            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(sx)) * m_dy_start - 
-                         (line_mr(y + line_subpixel_scale/2) - line_mr(sy)) * m_dx_start),
-
-            m_dist_end((line_mr(x + line_subpixel_scale/2) - line_mr(ex)) * m_dy_end - 
-                       (line_mr(y + line_subpixel_scale/2) - line_mr(ey)) * m_dx_end),
-            m_len(uround(len / scale))
-        {
-            double d = len * scale;
-            int dx = iround(((x2 - x1) << line_subpixel_shift) / d);
-            int dy = iround(((y2 - y1) << line_subpixel_shift) / d);
-            m_dx_pict   = -dy;
-            m_dy_pict   =  dx;
-            m_dist_pict =  ((x + line_subpixel_scale/2 - (x1 - dy)) * m_dy_pict - 
-                            (y + line_subpixel_scale/2 - (y1 + dx)) * m_dx_pict) >> 
-                           line_subpixel_shift;
-
-            m_dx       <<= line_subpixel_shift;
-            m_dy       <<= line_subpixel_shift;
-            m_dx_start <<= line_mr_subpixel_shift;
-            m_dy_start <<= line_mr_subpixel_shift;
-            m_dx_end   <<= line_mr_subpixel_shift;
-            m_dy_end   <<= line_mr_subpixel_shift;
-        }
-
-        //---------------------------------------------------------------------
-        void inc_x() 
-        { 
-            m_dist += m_dy; 
-            m_dist_start += m_dy_start; 
-            m_dist_pict += m_dy_pict; 
-            m_dist_end += m_dy_end; 
-        }
-
-        //---------------------------------------------------------------------
-        void dec_x() 
-        { 
-            m_dist -= m_dy; 
-            m_dist_start -= m_dy_start; 
-            m_dist_pict -= m_dy_pict; 
-            m_dist_end -= m_dy_end; 
-        }
-
-        //---------------------------------------------------------------------
-        void inc_y() 
-        { 
-            m_dist -= m_dx; 
-            m_dist_start -= m_dx_start; 
-            m_dist_pict -= m_dx_pict; 
-            m_dist_end -= m_dx_end; 
-        }
-
-        //---------------------------------------------------------------------
-        void dec_y() 
-        { 
-            m_dist += m_dx; 
-            m_dist_start += m_dx_start; 
-            m_dist_pict += m_dx_pict; 
-            m_dist_end += m_dx_end; 
-        }
-
-        //---------------------------------------------------------------------
-        void inc_x(int dy)
-        {
-            m_dist       += m_dy; 
-            m_dist_start += m_dy_start; 
-            m_dist_pict  += m_dy_pict; 
-            m_dist_end   += m_dy_end;
-            if(dy > 0)
-            {
-                m_dist       -= m_dx; 
-                m_dist_start -= m_dx_start; 
-                m_dist_pict  -= m_dx_pict; 
-                m_dist_end   -= m_dx_end;
-            }
-            if(dy < 0)
-            {
-                m_dist       += m_dx; 
-                m_dist_start += m_dx_start; 
-                m_dist_pict  += m_dx_pict; 
-                m_dist_end   += m_dx_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void dec_x(int dy)
-        {
-            m_dist       -= m_dy; 
-            m_dist_start -= m_dy_start; 
-            m_dist_pict  -= m_dy_pict; 
-            m_dist_end   -= m_dy_end;
-            if(dy > 0)
-            {
-                m_dist       -= m_dx; 
-                m_dist_start -= m_dx_start; 
-                m_dist_pict  -= m_dx_pict; 
-                m_dist_end   -= m_dx_end;
-            }
-            if(dy < 0)
-            {
-                m_dist       += m_dx; 
-                m_dist_start += m_dx_start; 
-                m_dist_pict  += m_dx_pict; 
-                m_dist_end   += m_dx_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void inc_y(int dx)
-        {
-            m_dist       -= m_dx; 
-            m_dist_start -= m_dx_start; 
-            m_dist_pict  -= m_dx_pict; 
-            m_dist_end   -= m_dx_end;
-            if(dx > 0)
-            {
-                m_dist       += m_dy; 
-                m_dist_start += m_dy_start; 
-                m_dist_pict  += m_dy_pict; 
-                m_dist_end   += m_dy_end;
-            }
-            if(dx < 0)
-            {
-                m_dist       -= m_dy; 
-                m_dist_start -= m_dy_start; 
-                m_dist_pict  -= m_dy_pict; 
-                m_dist_end   -= m_dy_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        void dec_y(int dx)
-        {
-            m_dist       += m_dx; 
-            m_dist_start += m_dx_start; 
-            m_dist_pict  += m_dx_pict; 
-            m_dist_end   += m_dx_end;
-            if(dx > 0)
-            {
-                m_dist       += m_dy; 
-                m_dist_start += m_dy_start; 
-                m_dist_pict  += m_dy_pict; 
-                m_dist_end   += m_dy_end;
-            }
-            if(dx < 0)
-            {
-                m_dist       -= m_dy; 
-                m_dist_start -= m_dy_start; 
-                m_dist_pict  -= m_dy_pict; 
-                m_dist_end   -= m_dy_end;
-            }
-        }
-
-        //---------------------------------------------------------------------
-        int dist()       const { return m_dist;       }
-        int dist_start() const { return m_dist_start; }
-        int dist_pict()  const { return m_dist_pict;  }
-        int dist_end()   const { return m_dist_end;   }
-
-        //---------------------------------------------------------------------
-        int dx()       const { return m_dx;       }
-        int dy()       const { return m_dy;       }
-        int dx_start() const { return m_dx_start; }
-        int dy_start() const { return m_dy_start; }
-        int dx_pict()  const { return m_dx_pict;  }
-        int dy_pict()  const { return m_dy_pict;  }
-        int dx_end()   const { return m_dx_end;   }
-        int dy_end()   const { return m_dy_end;   }
-        int len()      const { return m_len;      }
-
-    private:
-        //---------------------------------------------------------------------
-        int m_dx;
-        int m_dy;
-        int m_dx_start;
-        int m_dy_start;
-        int m_dx_pict;
-        int m_dy_pict;
-        int m_dx_end;
-        int m_dy_end;
-
-        int m_dist;
-        int m_dist_start;
-        int m_dist_pict;
-        int m_dist_end;
-        int m_len;
-    };
-
-
-
-
-
-    //==================================================line_interpolator_image
-    template<class Renderer> class line_interpolator_image
-    {
-    public:
-        typedef Renderer renderer_type;
-        typedef typename Renderer::color_type color_type;
-
-        //---------------------------------------------------------------------
-        enum max_half_width_e
-        { 
-            max_half_width = 64
-        };
-
-        //---------------------------------------------------------------------
-        line_interpolator_image(renderer_type& ren, const line_parameters& lp,
-                                int sx, int sy, int ex, int ey, 
-                                int pattern_start,
-                                double scale_x) :
-            m_lp(lp),
-            m_li(lp.vertical ? line_dbl_hr(lp.x2 - lp.x1) :
-                               line_dbl_hr(lp.y2 - lp.y1),
-                 lp.vertical ? abs(lp.y2 - lp.y1) : 
-                               abs(lp.x2 - lp.x1) + 1),
-            m_di(lp.x1, lp.y1, lp.x2, lp.y2, sx, sy, ex, ey, lp.len, scale_x,
-                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask),
-            m_ren(ren),
-            m_x(lp.x1 >> line_subpixel_shift),
-            m_y(lp.y1 >> line_subpixel_shift),
-            m_old_x(m_x),
-            m_old_y(m_y),
-            m_count((lp.vertical ? abs((lp.y2 >> line_subpixel_shift) - m_y) :
-                                   abs((lp.x2 >> line_subpixel_shift) - m_x))),
-            m_width(ren.subpixel_width()),
-            //m_max_extent(m_width >> (line_subpixel_shift - 2)),
-            m_max_extent((m_width + line_subpixel_scale) >> line_subpixel_shift),
-            m_start(pattern_start + (m_max_extent + 2) * ren.pattern_width()),
-            m_step(0)
-        {
-            mapserver::dda2_line_interpolator li(0, lp.vertical ? 
-                                              (lp.dy << mapserver::line_subpixel_shift) :
-                                              (lp.dx << mapserver::line_subpixel_shift),
-                                           lp.len);
-
-            unsigned i;
-            int stop = m_width + line_subpixel_scale * 2;
-            for(i = 0; i < max_half_width; ++i)
-            {
-                m_dist_pos[i] = li.y();
-                if(m_dist_pos[i] >= stop) break;
-                ++li;
-            }
-            m_dist_pos[i] = 0x7FFF0000;
-
-            int dist1_start;
-            int dist2_start;
-            int npix = 1;
-
-            if(lp.vertical)
-            {
-                do
-                {
-                    --m_li;
-                    m_y -= lp.inc;
-                    m_x = (m_lp.x1 + m_li.y()) >> line_subpixel_shift;
-
-                    if(lp.inc > 0) m_di.dec_y(m_x - m_old_x);
-                    else           m_di.inc_y(m_x - m_old_x);
-
-                    m_old_x = m_x;
-
-                    dist1_start = dist2_start = m_di.dist_start(); 
-
-                    int dx = 0;
-                    if(dist1_start < 0) ++npix;
-                    do
-                    {
-                        dist1_start += m_di.dy_start();
-                        dist2_start -= m_di.dy_start();
-                        if(dist1_start < 0) ++npix;
-                        if(dist2_start < 0) ++npix;
-                        ++dx;
-                    }
-                    while(m_dist_pos[dx] <= m_width);
-                    if(npix == 0) break;
-
-                    npix = 0;
-                }
-                while(--m_step >= -m_max_extent);
-            }
-            else
-            {
-                do
-                {
-                    --m_li;
-
-                    m_x -= lp.inc;
-                    m_y = (m_lp.y1 + m_li.y()) >> line_subpixel_shift;
-
-                    if(lp.inc > 0) m_di.dec_x(m_y - m_old_y);
-                    else           m_di.inc_x(m_y - m_old_y);
-
-                    m_old_y = m_y;
-
-                    dist1_start = dist2_start = m_di.dist_start(); 
-
-                    int dy = 0;
-                    if(dist1_start < 0) ++npix;
-                    do
-                    {
-                        dist1_start -= m_di.dx_start();
-                        dist2_start += m_di.dx_start();
-                        if(dist1_start < 0) ++npix;
-                        if(dist2_start < 0) ++npix;
-                        ++dy;
-                    }
-                    while(m_dist_pos[dy] <= m_width);
-                    if(npix == 0) break;
-
-                    npix = 0;
-                }
-                while(--m_step >= -m_max_extent);
-            }
-            m_li.adjust_forward();
-            m_step -= m_max_extent;
-        }
-
-        //---------------------------------------------------------------------
-        bool step_hor()
-        {
-            ++m_li;
-            m_x += m_lp.inc;
-            m_y = (m_lp.y1 + m_li.y()) >> line_subpixel_shift;
-
-            if(m_lp.inc > 0) m_di.inc_x(m_y - m_old_y);
-            else             m_di.dec_x(m_y - m_old_y);
-
-            m_old_y = m_y;
-
-            int s1 = m_di.dist() / m_lp.len;
-            int s2 = -s1;
-
-            if(m_lp.inc < 0) s1 = -s1;
-
-            int dist_start;
-            int dist_pict;
-            int dist_end;
-            int dy;
-            int dist;
-
-            dist_start = m_di.dist_start();
-            dist_pict  = m_di.dist_pict() + m_start;
-            dist_end   = m_di.dist_end();
-            color_type* p0 = m_colors + max_half_width + 2;
-            color_type* p1 = p0;
-
-            int npix = 0;
-            p1->clear();
-            if(dist_end > 0)
-            {
-                if(dist_start <= 0)
-                {
-                    m_ren.pixel(p1, dist_pict, s2);
-                }
-                ++npix;
-            }
-            ++p1;
-
-            dy = 1;
-            while((dist = m_dist_pos[dy]) - s1 <= m_width)
-            {
-                dist_start -= m_di.dx_start();
-                dist_pict  -= m_di.dx_pict();
-                dist_end   -= m_di.dx_end();
-                p1->clear();
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    if(m_lp.inc > 0) dist = -dist;
-                    m_ren.pixel(p1, dist_pict, s2 - dist);
-                    ++npix;
-                }
-                ++p1;
-                ++dy;
-            }
-
-            dy = 1;
-            dist_start = m_di.dist_start();
-            dist_pict  = m_di.dist_pict() + m_start;
-            dist_end   = m_di.dist_end();
-            while((dist = m_dist_pos[dy]) + s1 <= m_width)
-            {
-                dist_start += m_di.dx_start();
-                dist_pict  += m_di.dx_pict();
-                dist_end   += m_di.dx_end();
-                --p0;
-                p0->clear();
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    if(m_lp.inc > 0) dist = -dist;
-                    m_ren.pixel(p0, dist_pict, s2 + dist);
-                    ++npix;
-                }
-                ++dy;
-            }
-            m_ren.blend_color_vspan(m_x, 
-                                    m_y - dy + 1, 
-                                    unsigned(p1 - p0), 
-                                    p0); 
-            return npix && ++m_step < m_count;
-        }
-
-
-
-        //---------------------------------------------------------------------
-        bool step_ver()
-        {
-            ++m_li;
-            m_y += m_lp.inc;
-            m_x = (m_lp.x1 + m_li.y()) >> line_subpixel_shift;
-
-            if(m_lp.inc > 0) m_di.inc_y(m_x - m_old_x);
-            else             m_di.dec_y(m_x - m_old_x);
-
-            m_old_x = m_x;
-
-            int s1 = m_di.dist() / m_lp.len;
-            int s2 = -s1;
-
-            if(m_lp.inc > 0) s1 = -s1;
-
-            int dist_start;
-            int dist_pict;
-            int dist_end;
-            int dist;
-            int dx;
-
-            dist_start = m_di.dist_start();
-            dist_pict  = m_di.dist_pict() + m_start;
-            dist_end   = m_di.dist_end();
-            color_type* p0 = m_colors + max_half_width + 2;
-            color_type* p1 = p0;
-
-            int npix = 0;
-            p1->clear();
-            if(dist_end > 0)
-            {
-                if(dist_start <= 0)
-                {
-                    m_ren.pixel(p1, dist_pict, s2);
-                }
-                ++npix;
-            }
-            ++p1;
-
-            dx = 1;
-            while((dist = m_dist_pos[dx]) - s1 <= m_width)
-            {
-                dist_start += m_di.dy_start();
-                dist_pict  += m_di.dy_pict();
-                dist_end   += m_di.dy_end();
-                p1->clear();
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    if(m_lp.inc > 0) dist = -dist;
-                    m_ren.pixel(p1, dist_pict, s2 + dist);
-                    ++npix;
-                }
-                ++p1;
-                ++dx;
-            }
-
-            dx = 1;
-            dist_start = m_di.dist_start();
-            dist_pict  = m_di.dist_pict() + m_start;
-            dist_end   = m_di.dist_end();
-            while((dist = m_dist_pos[dx]) + s1 <= m_width)
-            {
-                dist_start -= m_di.dy_start();
-                dist_pict  -= m_di.dy_pict();
-                dist_end   -= m_di.dy_end();
-                --p0;
-                p0->clear();
-                if(dist_end > 0 && dist_start <= 0)
-                {   
-                    if(m_lp.inc > 0) dist = -dist;
-                    m_ren.pixel(p0, dist_pict, s2 - dist);
-                    ++npix;
-                }
-                ++dx;
-            }
-            m_ren.blend_color_hspan(m_x - dx + 1, 
-                                    m_y, 
-                                    unsigned(p1 - p0), 
-                                    p0);
-            return npix && ++m_step < m_count;
-        }
-
-
-        //---------------------------------------------------------------------
-        int  pattern_end() const { return m_start + m_di.len(); }
-
-        //---------------------------------------------------------------------
-        bool vertical() const { return m_lp.vertical; }
-        int  width() const { return m_width; }
-        int  count() const { return m_count; }
-
-    private:
-        line_interpolator_image(const line_interpolator_image<Renderer>&);
-        const line_interpolator_image<Renderer>&
-            operator = (const line_interpolator_image<Renderer>&);
-
-    protected:
-        const line_parameters& m_lp;
-        dda2_line_interpolator m_li;
-        distance_interpolator4 m_di; 
-        renderer_type&         m_ren;
-        int m_plen = 0;
-        int m_x;
-        int m_y;
-        int m_old_x;
-        int m_old_y;
-        int m_count;
-        int m_width;
-        int m_max_extent;
-        int m_start;
-        int m_step;
-        int m_dist_pos[max_half_width + 1];
-        color_type m_colors[max_half_width * 2 + 4];
-    };
-
-
-
-
-
-
-
-
-    //===================================================renderer_outline_image
-    template<class BaseRenderer, class ImagePattern> 
-    class renderer_outline_image
-    {
-    public:
-        //---------------------------------------------------------------------
-        typedef BaseRenderer base_ren_type;
-        typedef renderer_outline_image<BaseRenderer, ImagePattern> self_type;
-        typedef typename base_ren_type::color_type color_type;
-        typedef ImagePattern pattern_type;
-
-
-        //---------------------------------------------------------------------
-        renderer_outline_image(base_ren_type& ren, const pattern_type& patt) :
-            m_ren(&ren),
-            m_pattern(&patt),
-            m_start(0),
-            m_scale_x(1.0),
-            m_clip_box(0,0,0,0),
-            m_clipping(false)
-        {}
-        void attach(base_ren_type& ren) { m_ren = &ren; }
-
-        //---------------------------------------------------------------------
-        void pattern(const pattern_type& p) { m_pattern = &p; }
-        const pattern_type& pattern() const { return *m_pattern; }
-
-        //---------------------------------------------------------------------
-        void reset_clipping() { m_clipping = false; }
-        void clip_box(double x1, double y1, double x2, double y2)
-        {
-            m_clip_box.x1 = line_coord_sat::conv(x1);
-            m_clip_box.y1 = line_coord_sat::conv(y1);
-            m_clip_box.x2 = line_coord_sat::conv(x2);
-            m_clip_box.y2 = line_coord_sat::conv(y2);
-            m_clipping = true;
-        }
-
-        //---------------------------------------------------------------------
-        void   scale_x(double s) { m_scale_x = s; }
-        double scale_x() const   { return m_scale_x; }
-
-        //---------------------------------------------------------------------
-        void   start_x(double s) { m_start = iround(s * line_subpixel_scale); }
-        double start_x() const   { return double(m_start) / line_subpixel_scale; }
-
-        //---------------------------------------------------------------------
-        int subpixel_width() const { return m_pattern->line_width(); }
-        int pattern_width() const { return m_pattern->pattern_width(); }
-        double width() const { return double(subpixel_width()) / line_subpixel_scale; }
-
-        //-------------------------------------------------------------------------
-        void pixel(color_type* p, int x, int y) const
-        {
-            m_pattern->pixel(p, x, y);
-        }
-
-        //-------------------------------------------------------------------------
-        void blend_color_hspan(int x, int y, unsigned len, const color_type* colors)
-        {
-            m_ren->blend_color_hspan(x, y, len, colors, 0);
-        }
-
-        //-------------------------------------------------------------------------
-        void blend_color_vspan(int x, int y, unsigned len, const color_type* colors)
-        {
-            m_ren->blend_color_vspan(x, y, len, colors, 0);
-        }
-
-        //-------------------------------------------------------------------------
-        static bool accurate_join_only() { return true; }
-
-        //-------------------------------------------------------------------------
-        template<class Cmp> 
-        void semidot(Cmp, int, int, int, int)
-        {
-        }
-
-        //-------------------------------------------------------------------------
-        void pie(int, int, int, int, int, int)
-        {
-        }
-
-        //-------------------------------------------------------------------------
-        void line0(const line_parameters&)
-        {
-        }
-
-        //-------------------------------------------------------------------------
-        void line1(const line_parameters&, int, int)
-        {
-        }
-
-        //-------------------------------------------------------------------------
-        void line2(const line_parameters&, int, int)
-        {
-        }
-
-        //-------------------------------------------------------------------------
-        void line3_no_clip(const line_parameters& lp, 
-                           int sx, int sy, int ex, int ey)
-        {
-            if(lp.len > line_max_length)
-            {
-                line_parameters lp1, lp2;
-                lp.divide(lp1, lp2);
-                int mx = lp1.x2 + (lp1.y2 - lp1.y1);
-                int my = lp1.y2 - (lp1.x2 - lp1.x1);
-                line3_no_clip(lp1, (lp.x1 + sx) >> 1, (lp.y1 + sy) >> 1, mx, my);
-                line3_no_clip(lp2, mx, my, (lp.x2 + ex) >> 1, (lp.y2 + ey) >> 1);
-                return;
-            }
-            
-            fix_degenerate_bisectrix_start(lp, &sx, &sy);
-            fix_degenerate_bisectrix_end(lp, &ex, &ey);
-            line_interpolator_image<self_type> li(*this, lp, 
-                                                  sx, sy, 
-                                                  ex, ey, 
-                                                  m_start, m_scale_x);
-            if(li.vertical())
-            {
-                while(li.step_ver());
-            }
-            else
-            {
-                while(li.step_hor());
-            }
-            m_start += uround(lp.len / m_scale_x);
-        }
-
-        //-------------------------------------------------------------------------
-        void line3(const line_parameters& lp, 
-                   int sx, int sy, int ex, int ey)
-        {
-            if(m_clipping)
-            {
-                int x1 = lp.x1;
-                int y1 = lp.y1;
-                int x2 = lp.x2;
-                int y2 = lp.y2;
-                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
-                int start = m_start;
-                if((flags & 4) == 0)
-                {
-                    if(flags)
-                    {
-                        line_parameters lp2(x1, y1, x2, y2, 
-                                           uround(calc_distance(x1, y1, x2, y2)));
-                        if(flags & 1)
-                        {
-                            m_start += uround(calc_distance(lp.x1, lp.y1, x1, y1) / m_scale_x);
-                            sx = x1 + (y2 - y1); 
-                            sy = y1 - (x2 - x1);
-                        }
-                        else
-                        {
-                            while(abs(sx - lp.x1) + abs(sy - lp.y1) > lp2.len)
-                            {
-                                sx = (lp.x1 + sx) >> 1;
-                                sy = (lp.y1 + sy) >> 1;
-                            }
-                        }
-                        if(flags & 2)
-                        {
-                            ex = x2 + (y2 - y1); 
-                            ey = y2 - (x2 - x1);
-                        }
-                        else
-                        {
-                            while(abs(ex - lp.x2) + abs(ey - lp.y2) > lp2.len)
-                            {
-                                ex = (lp.x2 + ex) >> 1;
-                                ey = (lp.y2 + ey) >> 1;
-                            }
-                        }
-                        line3_no_clip(lp2, sx, sy, ex, ey);
-                    }
-                    else
-                    {
-                        line3_no_clip(lp, sx, sy, ex, ey);
-                    }
-                }
-                m_start = start + uround(lp.len / m_scale_x);
-            }
-            else
-            {
-                line3_no_clip(lp, sx, sy, ex, ey);
-            }
-        }
-
-    private:
-        base_ren_type*      m_ren;
-        const pattern_type* m_pattern;
-        int                 m_start;
-        double              m_scale_x;
-        rect_i              m_clip_box;
-        bool                m_clipping;
-    };
-
-
-
-
-
-}
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_primitives.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_primitives.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_primitives.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_primitives.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,224 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class renderer_primitives
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERER_PRIMITIVES_INCLUDED
-#define AGG_RENDERER_PRIMITIVES_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_renderer_base.h"
-#include "agg_dda_line.h"
-#include "agg_ellipse_bresenham.h"
-
-namespace mapserver
-{
-    //-----------------------------------------------------renderer_primitives
-    template<class BaseRenderer> class renderer_primitives
-    {
-    public:
-        typedef BaseRenderer base_ren_type;
-        typedef typename base_ren_type::color_type color_type;
-
-        //--------------------------------------------------------------------
-        explicit renderer_primitives(base_ren_type& ren) :
-            m_ren(&ren),
-            m_fill_color(),
-            m_line_color(),
-            m_curr_x(0),
-            m_curr_y(0)
-        {}
-        void attach(base_ren_type& ren) { m_ren = &ren; }
-
-        //--------------------------------------------------------------------
-        static int coord(double c) 
-        { 
-            return iround(c * line_bresenham_interpolator::subpixel_scale); 
-        }
-
-        //--------------------------------------------------------------------
-        void fill_color(const color_type& c) { m_fill_color = c; }
-        void line_color(const color_type& c) { m_line_color = c; }
-        const color_type& fill_color() const { return m_fill_color; }
-        const color_type& line_color() const { return m_line_color; }
-
-        //--------------------------------------------------------------------
-        void rectangle(int x1, int y1, int x2, int y2)
-        {
-            m_ren->blend_hline(x1,   y1,   x2-1, m_line_color, cover_full);
-            m_ren->blend_vline(x2,   y1,   y2-1, m_line_color, cover_full);
-            m_ren->blend_hline(x1+1, y2,   x2,   m_line_color, cover_full);
-            m_ren->blend_vline(x1,   y1+1, y2,   m_line_color, cover_full);
-        }
-
-        //--------------------------------------------------------------------
-        void solid_rectangle(int x1, int y1, int x2, int y2)
-        {
-            m_ren->blend_bar(x1, y1, x2, y2, m_fill_color, cover_full);
-        }
-
-        //--------------------------------------------------------------------
-        void outlined_rectangle(int x1, int y1, int x2, int y2) 
-        {
-            rectangle(x1, y1, x2, y2);
-            m_ren->blend_bar(x1+1, y1+1, x2-1, y2-1, m_fill_color, cover_full);
-        }
-
-        //--------------------------------------------------------------------
-        void ellipse(int x, int y, int rx, int ry)
-        {
-            ellipse_bresenham_interpolator ei(rx, ry);
-            int dx = 0;
-            int dy = -ry;
-            do
-            {
-                dx += ei.dx();
-                dy += ei.dy();
-                m_ren->blend_pixel(x + dx, y + dy, m_line_color, cover_full);
-                m_ren->blend_pixel(x + dx, y - dy, m_line_color, cover_full);
-                m_ren->blend_pixel(x - dx, y - dy, m_line_color, cover_full);
-                m_ren->blend_pixel(x - dx, y + dy, m_line_color, cover_full);
-                ++ei;
-            }
-            while(dy < 0);
-        }
-
-        //--------------------------------------------------------------------
-        void solid_ellipse(int x, int y, int rx, int ry)
-        {
-            ellipse_bresenham_interpolator ei(rx, ry);
-            int dx = 0;
-            int dy = -ry;
-            int dy0 = dy;
-            int dx0 = dx;
-
-            do
-            {
-                dx += ei.dx();
-                dy += ei.dy();
-
-                if(dy != dy0)
-                {
-                    m_ren->blend_hline(x-dx0, y+dy0, x+dx0, m_fill_color, cover_full);
-                    m_ren->blend_hline(x-dx0, y-dy0, x+dx0, m_fill_color, cover_full);
-                }
-                dx0 = dx;
-                dy0 = dy;
-                ++ei;
-            }
-            while(dy < 0);
-            m_ren->blend_hline(x-dx0, y+dy0, x+dx0, m_fill_color, cover_full);
-        }
-
-        //--------------------------------------------------------------------
-        void outlined_ellipse(int x, int y, int rx, int ry)
-        {
-            ellipse_bresenham_interpolator ei(rx, ry);
-            int dx = 0;
-            int dy = -ry;
-
-            do
-            {
-                dx += ei.dx();
-                dy += ei.dy();
-
-                m_ren->blend_pixel(x + dx, y + dy, m_line_color, cover_full);
-                m_ren->blend_pixel(x + dx, y - dy, m_line_color, cover_full);
-                m_ren->blend_pixel(x - dx, y - dy, m_line_color, cover_full);
-                m_ren->blend_pixel(x - dx, y + dy, m_line_color, cover_full);
-
-                if(ei.dy() && dx)
-                {
-                   m_ren->blend_hline(x-dx+1, y+dy, x+dx-1, m_fill_color, cover_full);
-                   m_ren->blend_hline(x-dx+1, y-dy, x+dx-1, m_fill_color, cover_full);
-                }
-                ++ei;
-            }
-            while(dy < 0);
-        }
-
-        //--------------------------------------------------------------------
-        void line(int x1, int y1, int x2, int y2, bool last=false)
-        {
-            line_bresenham_interpolator li(x1, y1, x2, y2);
-
-            unsigned len = li.len();
-            if(len == 0)
-            {
-                if(last)
-                {
-                    m_ren->blend_pixel(li.line_lr(x1), li.line_lr(y1), m_line_color, cover_full);
-                }
-                return;
-            }
-
-            if(last) ++len;
-
-            if(li.is_ver())
-            {
-                do
-                {
-                    m_ren->blend_pixel(li.x2(), li.y1(), m_line_color, cover_full);
-                    li.vstep();
-                }
-                while(--len);
-            }
-            else
-            {
-                do
-                {
-                    m_ren->blend_pixel(li.x1(), li.y2(), m_line_color, cover_full);
-                    li.hstep();
-                }
-                while(--len);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void move_to(int x, int y)
-        {
-            m_curr_x = x;
-            m_curr_y = y;
-        }
-
-        //--------------------------------------------------------------------
-        void line_to(int x, int y, bool last=false)
-        {
-            line(m_curr_x, m_curr_y, x, y, last);
-            m_curr_x = x;
-            m_curr_y = y;
-        }
-
-        //--------------------------------------------------------------------
-        const base_ren_type& ren() const { return *m_ren; }        
-        base_ren_type& ren() { return *m_ren; }        
-
-        //--------------------------------------------------------------------
-        const rendering_buffer& rbuf() const { return m_ren->rbuf(); }
-        rendering_buffer& rbuf() { return m_ren->rbuf(); }
-
-    private:
-        base_ren_type* m_ren;
-        color_type m_fill_color;
-        color_type m_line_color;
-        int m_curr_x;
-        int m_curr_y;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_raster_text.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_raster_text.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_raster_text.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_raster_text.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,292 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERER_RASTER_TEXT_INCLUDED
-#define AGG_RENDERER_RASTER_TEXT_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //==============================================renderer_raster_htext_solid
-    template<class BaseRenderer, class GlyphGenerator> 
-    class renderer_raster_htext_solid
-    {
-    public:
-        typedef BaseRenderer ren_type;
-        typedef GlyphGenerator glyph_gen_type;
-        typedef typename glyph_gen_type::glyph_rect glyph_rect;
-        typedef typename ren_type::color_type color_type;
-
-        renderer_raster_htext_solid(ren_type& ren, glyph_gen_type& glyph) :
-            m_ren(&ren),
-            m_glyph(&glyph)
-        {}
-        void attach(ren_type& ren) { m_ren = &ren; }
-
-        //--------------------------------------------------------------------
-        void color(const color_type& c) { m_color = c; }
-        const color_type& color() const { return m_color; }
-
-        //--------------------------------------------------------------------
-        template<class CharT>
-        void render_text(double x, double y, const CharT* str, bool flip=false)
-        {
-            glyph_rect r;
-            while(*str)
-            {
-                m_glyph->prepare(&r, x, y, *str, flip);
-                if(r.x2 >= r.x1)
-                {
-                    int i;
-                    if(flip)
-                    {
-                        for(i = r.y1; i <= r.y2; i++)
-                        {
-                            m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
-                                                     m_color,
-                                                     m_glyph->span(r.y2 - i));
-                        }
-                    }
-                    else
-                    {
-                        for(i = r.y1; i <= r.y2; i++)
-                        {
-                            m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
-                                                     m_color,
-                                                     m_glyph->span(i - r.y1));
-                        }
-                    }
-                }
-                x += r.dx;
-                y += r.dy;
-                ++str;
-            }
-        }
-
-        void render_glyph(double x, double y, unsigned glyph, bool flip=false)
-        {
-          glyph_rect r;
-          m_glyph->prepare(&r, x, y, glyph, flip);
-          if(r.x2 >= r.x1)
-          {
-            int i;
-            if(flip)
-            {
-              for(i = r.y1; i <= r.y2; i++)
-              {
-                m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
-                    m_color,
-                    m_glyph->span(r.y2 - i));
-              }
-            }
-            else
-            {
-              for(i = r.y1; i <= r.y2; i++)
-              {
-                m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
-                    m_color,
-                    m_glyph->span(i - r.y1));
-              }
-            }
-          }
-        }
-
-    private:
-        ren_type* m_ren;
-        glyph_gen_type* m_glyph;
-        color_type m_color;
-    };
-
-
-
-    //=============================================renderer_raster_vtext_solid
-    template<class BaseRenderer, class GlyphGenerator> 
-    class renderer_raster_vtext_solid
-    {
-    public:
-        typedef BaseRenderer ren_type;
-        typedef GlyphGenerator glyph_gen_type;
-        typedef typename glyph_gen_type::glyph_rect glyph_rect;
-        typedef typename ren_type::color_type color_type;
-
-        renderer_raster_vtext_solid(ren_type& ren, glyph_gen_type& glyph) :
-            m_ren(&ren),
-            m_glyph(&glyph)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        void color(const color_type& c) { m_color = c; }
-        const color_type& color() const { return m_color; }
-
-        //--------------------------------------------------------------------
-        template<class CharT>
-        void render_text(double x, double y, const CharT* str, bool flip=false)
-        {
-            glyph_rect r;
-            while(*str)
-            {
-                m_glyph->prepare(&r, x, y, *str, !flip);
-                if(r.x2 >= r.x1)
-                {
-                    int i;
-                    if(flip)
-                    {
-                        for(i = r.y1; i <= r.y2; i++)
-                        {
-                            m_ren->blend_solid_vspan(i, r.x1, (r.x2 - r.x1 + 1),
-                                                     m_color,
-                                                     m_glyph->span(i - r.y1));
-                        }
-                    }
-                    else
-                    {
-                        for(i = r.y1; i <= r.y2; i++)
-                        {
-                            m_ren->blend_solid_vspan(i, r.x1, (r.x2 - r.x1 + 1),
-                                                     m_color,
-                                                     m_glyph->span(r.y2 - i));
-                        }
-                    }
-                }
-                x += r.dx;
-                y += r.dy;
-                ++str;
-            }
-        }
-
-    private:
-        ren_type* m_ren;
-        glyph_gen_type* m_glyph;
-        color_type m_color;
-    };
-
-
-
-
-
-
-    //===================================================renderer_raster_htext
-    template<class ScanlineRenderer, class GlyphGenerator> 
-    class renderer_raster_htext
-    {
-    public:
-        typedef ScanlineRenderer ren_type;
-        typedef GlyphGenerator glyph_gen_type;
-        typedef typename glyph_gen_type::glyph_rect glyph_rect;
-
-        class scanline_single_span
-        {
-        public:
-            typedef mapserver::cover_type cover_type;
-
-            //----------------------------------------------------------------
-            struct const_span
-            {
-                int x;
-                unsigned len;
-                const cover_type* covers;
-
-                const_span() {}
-                const_span(int x_, unsigned len_, const cover_type* covers_) :
-                    x(x_), len(len_), covers(covers_) 
-                {}
-            };
-
-            typedef const const_span* const_iterator;
-
-            //----------------------------------------------------------------
-            scanline_single_span(int x, int y, unsigned len, 
-                                 const cover_type* covers) :
-                m_y(y),
-                m_span(x, len, covers)
-            {}
-
-            //----------------------------------------------------------------
-            int      y()           const { return m_y; }
-            unsigned num_spans()   const { return 1;   }
-            const_iterator begin() const { return &m_span; }
-
-        private:
-            //----------------------------------------------------------------
-            int m_y;
-            const_span m_span;
-        };
-
-
-
-        //--------------------------------------------------------------------
-        renderer_raster_htext(ren_type& ren, glyph_gen_type& glyph) :
-            m_ren(&ren),
-            m_glyph(&glyph)
-        {
-        }
-
-
-        //--------------------------------------------------------------------
-        template<class CharT>
-        void render_text(double x, double y, const CharT* str, bool flip=false)
-        {
-            glyph_rect r;
-            while(*str)
-            {
-                m_glyph->prepare(&r, x, y, *str, flip);
-                if(r.x2 >= r.x1)
-                {
-                    m_ren->prepare();
-                    int i;
-                    if(flip)
-                    {
-                        for(i = r.y1; i <= r.y2; i++)
-                        {
-                            m_ren->render(
-                                scanline_single_span(r.x1, 
-                                                     i, 
-                                                     (r.x2 - r.x1 + 1),
-                                                     m_glyph->span(r.y2 - i)));
-                        }
-                    }
-                    else
-                    {
-                        for(i = r.y1; i <= r.y2; i++)
-                        {
-                            m_ren->render(
-                                scanline_single_span(r.x1, 
-                                                     i, 
-                                                     (r.x2 - r.x1 + 1),
-                                                     m_glyph->span(i - r.y1)));
-                        }
-                    }
-                }
-                x += r.dx;
-                y += r.dy;
-                ++str;
-            }
-        }
-
-    private:
-        ren_type* m_ren;
-        glyph_gen_type* m_glyph;
-    };
-
-
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_renderer_scanline.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_scanline.h
--- 8.0.1-5/renderers/agg/include/agg_renderer_scanline.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_renderer_scanline.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,852 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERER_SCANLINE_INCLUDED
-#define AGG_RENDERER_SCANLINE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_renderer_base.h"
-
-namespace mapserver
-{
-
-    //================================================render_scanline_aa_solid
-    template<class Scanline, class BaseRenderer, class ColorT> 
-    void render_scanline_aa_solid(const Scanline& sl, 
-                                  BaseRenderer& ren, 
-                                  const ColorT& color)
-    {
-        int y = sl.y();
-        unsigned num_spans = sl.num_spans();
-        typename Scanline::const_iterator span = sl.begin();
-
-        for(;;)
-        {
-            int x = span->x;
-            if(span->len > 0)
-            {
-                ren.blend_solid_hspan(x, y, (unsigned)span->len, 
-                                      color, 
-                                      span->covers);
-            }
-            else
-            {
-                ren.blend_hline(x, y, (unsigned)(x - span->len - 1), 
-                                color, 
-                                *(span->covers));
-            }
-            if(--num_spans == 0) break;
-            ++span;
-        }
-    }
-
-    //===============================================render_scanlines_aa_solid
-    template<class Rasterizer, class Scanline, 
-             class BaseRenderer, class ColorT>
-    void render_scanlines_aa_solid(Rasterizer& ras, Scanline& sl, 
-                                   BaseRenderer& ren, const ColorT& color)
-    {
-        if(ras.rewind_scanlines())
-        {
-            // Explicitly convert "color" to the BaseRenderer color type.
-            // For example, it can be called with color type "rgba", while
-            // "rgba8" is needed. Otherwise it will be implicitly 
-            // converted in the loop many times.
-            //----------------------
-            typename BaseRenderer::color_type ren_color(color);
-
-            sl.reset(ras.min_x(), ras.max_x());
-            while(ras.sweep_scanline(sl))
-            {
-                //render_scanline_aa_solid(sl, ren, ren_color);
-
-                // This code is equivalent to the above call (copy/paste). 
-                // It's just a "manual" optimization for old compilers,
-                // like Microsoft Visual C++ v6.0
-                //-------------------------------
-                int y = sl.y();
-                unsigned num_spans = sl.num_spans();
-                typename Scanline::const_iterator span = sl.begin();
-
-                for(;;)
-                {
-                    int x = span->x;
-                    if(span->len > 0)
-                    {
-                        ren.blend_solid_hspan(x, y, (unsigned)span->len, 
-                                              ren_color, 
-                                              span->covers);
-                    }
-                    else
-                    {
-                        ren.blend_hline(x, y, (unsigned)(x - span->len - 1), 
-                                        ren_color, 
-                                        *(span->covers));
-                    }
-                    if(--num_spans == 0) break;
-                    ++span;
-                }
-            }
-        }
-    }
-
-    //==============================================renderer_scanline_aa_solid
-    template<class BaseRenderer> class renderer_scanline_aa_solid
-    {
-    public:
-        typedef BaseRenderer base_ren_type;
-        typedef typename base_ren_type::color_type color_type;
-
-        //--------------------------------------------------------------------
-        renderer_scanline_aa_solid() : m_ren(0) {}
-        explicit renderer_scanline_aa_solid(base_ren_type& ren) : m_ren(&ren) {}
-        void attach(base_ren_type& ren)
-        {
-            m_ren = &ren;
-        }
-        
-        //--------------------------------------------------------------------
-        void color(const color_type& c) { m_color = c; }
-        const color_type& color() const { return m_color; }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-
-        //--------------------------------------------------------------------
-        template<class Scanline> void render(const Scanline& sl)
-        {
-            render_scanline_aa_solid(sl, *m_ren, m_color);
-        }
-        
-    private:
-        base_ren_type* m_ren;
-        color_type m_color;
-    };
-
-
-
-
-
-
-
-
-
-
-
-
-
-    //======================================================render_scanline_aa
-    template<class Scanline, class BaseRenderer, 
-             class SpanAllocator, class SpanGenerator> 
-    void render_scanline_aa(const Scanline& sl, BaseRenderer& ren, 
-                            SpanAllocator& alloc, SpanGenerator& span_gen)
-    {
-        int y = sl.y();
-
-        unsigned num_spans = sl.num_spans();
-        typename Scanline::const_iterator span = sl.begin();
-        for(;;)
-        {
-            int x = span->x;
-            int len = span->len;
-            const typename Scanline::cover_type* covers = span->covers;
-
-            if(len < 0) len = -len;
-            typename BaseRenderer::color_type* colors = alloc.allocate(len);
-            span_gen.generate(colors, x, y, len);
-            ren.blend_color_hspan(x, y, len, colors, 
-                                  (span->len < 0) ? 0 : covers, *covers);
-
-            if(--num_spans == 0) break;
-            ++span;
-        }
-    }
-
-    //=====================================================render_scanlines_aa
-    template<class Rasterizer, class Scanline, class BaseRenderer, 
-             class SpanAllocator, class SpanGenerator>
-    void render_scanlines_aa(Rasterizer& ras, Scanline& sl, BaseRenderer& ren, 
-                             SpanAllocator& alloc, SpanGenerator& span_gen)
-    {
-        if(ras.rewind_scanlines())
-        {
-            sl.reset(ras.min_x(), ras.max_x());
-            span_gen.prepare();
-            while(ras.sweep_scanline(sl))
-            {
-                render_scanline_aa(sl, ren, alloc, span_gen);
-            }
-        }
-    }
-
-    //====================================================renderer_scanline_aa
-    template<class BaseRenderer, class SpanAllocator, class SpanGenerator> 
-    class renderer_scanline_aa
-    {
-    public:
-        typedef BaseRenderer  base_ren_type;
-        typedef SpanAllocator alloc_type;
-        typedef SpanGenerator span_gen_type;
-
-        //--------------------------------------------------------------------
-        renderer_scanline_aa() : m_ren(0), m_alloc(0), m_span_gen(0) {}
-        renderer_scanline_aa(base_ren_type& ren, 
-                             alloc_type& alloc, 
-                             span_gen_type& span_gen) :
-            m_ren(&ren),
-            m_alloc(&alloc),
-            m_span_gen(&span_gen)
-        {}
-        void attach(base_ren_type& ren, 
-                    alloc_type& alloc, 
-                    span_gen_type& span_gen)
-        {
-            m_ren = &ren;
-            m_alloc = &alloc;
-            m_span_gen = &span_gen;
-        }
-        
-        //--------------------------------------------------------------------
-        void prepare() { m_span_gen->prepare(); }
-
-        //--------------------------------------------------------------------
-        template<class Scanline> void render(const Scanline& sl)
-        {
-            render_scanline_aa(sl, *m_ren, *m_alloc, *m_span_gen);
-        }
-
-    private:
-        base_ren_type* m_ren;
-        alloc_type*    m_alloc;
-        span_gen_type* m_span_gen;
-    };
-
-
-
-
-
-
-    //===============================================render_scanline_bin_solid
-    template<class Scanline, class BaseRenderer, class ColorT> 
-    void render_scanline_bin_solid(const Scanline& sl, 
-                                   BaseRenderer& ren, 
-                                   const ColorT& color)
-    {
-        unsigned num_spans = sl.num_spans();
-        typename Scanline::const_iterator span = sl.begin();
-        for(;;)
-        {
-            ren.blend_hline(span->x, 
-                            sl.y(), 
-                            span->x - 1 + ((span->len < 0) ? 
-                                              -span->len : 
-                                               span->len), 
-                               color, 
-                               cover_full);
-            if(--num_spans == 0) break;
-            ++span;
-        }
-    }
-
-    //==============================================render_scanlines_bin_solid
-    template<class Rasterizer, class Scanline, 
-             class BaseRenderer, class ColorT>
-    void render_scanlines_bin_solid(Rasterizer& ras, Scanline& sl, 
-                                    BaseRenderer& ren, const ColorT& color)
-    {
-        if(ras.rewind_scanlines())
-        {
-            // Explicitly convert "color" to the BaseRenderer color type.
-            // For example, it can be called with color type "rgba", while
-            // "rgba8" is needed. Otherwise it will be implicitly 
-            // converted in the loop many times.
-            //----------------------
-            typename BaseRenderer::color_type ren_color(color);
-
-            sl.reset(ras.min_x(), ras.max_x());
-            while(ras.sweep_scanline(sl))
-            {
-                //render_scanline_bin_solid(sl, ren, ren_color);
-
-                // This code is equivalent to the above call (copy/paste). 
-                // It's just a "manual" optimization for old compilers,
-                // like Microsoft Visual C++ v6.0
-                //-------------------------------
-                unsigned num_spans = sl.num_spans();
-                typename Scanline::const_iterator span = sl.begin();
-                for(;;)
-                {
-                    ren.blend_hline(span->x, 
-                                    sl.y(), 
-                                    span->x - 1 + ((span->len < 0) ? 
-                                                      -span->len : 
-                                                       span->len), 
-                                       ren_color, 
-                                       cover_full);
-                    if(--num_spans == 0) break;
-                    ++span;
-                }
-            }
-        }
-    }
-
-    //=============================================renderer_scanline_bin_solid
-    template<class BaseRenderer> class renderer_scanline_bin_solid
-    {
-    public:
-        typedef BaseRenderer base_ren_type;
-        typedef typename base_ren_type::color_type color_type;
-
-        //--------------------------------------------------------------------
-        renderer_scanline_bin_solid() : m_ren(0) {}
-        explicit renderer_scanline_bin_solid(base_ren_type& ren) : m_ren(&ren) {}
-        void attach(base_ren_type& ren)
-        {
-            m_ren = &ren;
-        }
-        
-        //--------------------------------------------------------------------
-        void color(const color_type& c) { m_color = c; }
-        const color_type& color() const { return m_color; }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-
-        //--------------------------------------------------------------------
-        template<class Scanline> void render(const Scanline& sl)
-        {
-            render_scanline_bin_solid(sl, *m_ren, m_color);
-        }
-        
-    private:
-        base_ren_type* m_ren;
-        color_type m_color;
-    };
-
-
-
-
-
-
-
-
-    //======================================================render_scanline_bin
-    template<class Scanline, class BaseRenderer, 
-             class SpanAllocator, class SpanGenerator> 
-    void render_scanline_bin(const Scanline& sl, BaseRenderer& ren, 
-                             SpanAllocator& alloc, SpanGenerator& span_gen)
-    {
-        int y = sl.y();
-
-        unsigned num_spans = sl.num_spans();
-        typename Scanline::const_iterator span = sl.begin();
-        for(;;)
-        {
-            int x = span->x;
-            int len = span->len;
-            if(len < 0) len = -len;
-            typename BaseRenderer::color_type* colors = alloc.allocate(len);
-            span_gen.generate(colors, x, y, len);
-            ren.blend_color_hspan(x, y, len, colors, 0, cover_full); 
-            if(--num_spans == 0) break;
-            ++span;
-        }
-    }
-
-    //=====================================================render_scanlines_bin
-    template<class Rasterizer, class Scanline, class BaseRenderer, 
-             class SpanAllocator, class SpanGenerator>
-    void render_scanlines_bin(Rasterizer& ras, Scanline& sl, BaseRenderer& ren, 
-                              SpanAllocator& alloc, SpanGenerator& span_gen)
-    {
-        if(ras.rewind_scanlines())
-        {
-            sl.reset(ras.min_x(), ras.max_x());
-            span_gen.prepare();
-            while(ras.sweep_scanline(sl))
-            {
-                render_scanline_bin(sl, ren, alloc, span_gen);
-            }
-        }
-    }
-
-    //====================================================renderer_scanline_bin
-    template<class BaseRenderer, class SpanAllocator, class SpanGenerator> 
-    class renderer_scanline_bin
-    {
-    public:
-        typedef BaseRenderer  base_ren_type;
-        typedef SpanAllocator alloc_type;
-        typedef SpanGenerator span_gen_type;
-
-        //--------------------------------------------------------------------
-        renderer_scanline_bin() : m_ren(0), m_alloc(0), m_span_gen(0) {}
-        renderer_scanline_bin(base_ren_type& ren, 
-                              alloc_type& alloc, 
-                              span_gen_type& span_gen) :
-            m_ren(&ren),
-            m_alloc(&alloc),
-            m_span_gen(&span_gen)
-        {}
-        void attach(base_ren_type& ren, 
-                    alloc_type& alloc, 
-                    span_gen_type& span_gen)
-        {
-            m_ren = &ren;
-            m_alloc = &alloc;
-            m_span_gen = &span_gen;
-        }
-        
-        //--------------------------------------------------------------------
-        void prepare() { m_span_gen->prepare(); }
-
-        //--------------------------------------------------------------------
-        template<class Scanline> void render(const Scanline& sl)
-        {
-            render_scanline_bin(sl, *m_ren, *m_alloc, *m_span_gen);
-        }
-
-    private:
-        base_ren_type* m_ren;
-        alloc_type*    m_alloc;
-        span_gen_type* m_span_gen;
-    };
-
-
-
-
-
-
-
-
-
-
-    //========================================================render_scanlines
-    template<class Rasterizer, class Scanline, class Renderer>
-    void render_scanlines(Rasterizer& ras, Scanline& sl, Renderer& ren)
-    {
-        if(ras.rewind_scanlines())
-        {
-            sl.reset(ras.min_x(), ras.max_x());
-            ren.prepare();
-            while(ras.sweep_scanline(sl))
-            {
-                ren.render(sl);
-            }
-        }
-    }
-
-    //========================================================render_all_paths
-    template<class Rasterizer, class Scanline, class Renderer, 
-             class VertexSource, class ColorStorage, class PathId>
-    void render_all_paths(Rasterizer& ras, 
-                          Scanline& sl,
-                          Renderer& r, 
-                          VertexSource& vs, 
-                          const ColorStorage& as, 
-                          const PathId& path_id,
-                          unsigned num_paths)
-    {
-        for(unsigned i = 0; i < num_paths; i++)
-        {
-            ras.reset();
-            ras.add_path(vs, path_id[i]);
-            r.color(as[i]);
-            render_scanlines(ras, sl, r);
-        }
-    }
-
-
-
-
-
-
-    //=============================================render_scanlines_compound
-    template<class Rasterizer, 
-             class ScanlineAA, 
-             class ScanlineBin, 
-             class BaseRenderer, 
-             class SpanAllocator,
-             class StyleHandler>
-    void render_scanlines_compound(Rasterizer& ras, 
-                                   ScanlineAA& sl_aa,
-                                   ScanlineBin& sl_bin,
-                                   BaseRenderer& ren,
-                                   SpanAllocator& alloc,
-                                   StyleHandler& sh)
-    {
-        if(ras.rewind_scanlines())
-        {
-            int min_x = ras.min_x();
-            int len = ras.max_x() - min_x + 2;
-            sl_aa.reset(min_x, ras.max_x());
-            sl_bin.reset(min_x, ras.max_x());
-
-            typedef typename BaseRenderer::color_type color_type;
-            color_type* color_span = alloc.allocate(len * 2);
-            color_type* mix_buffer = color_span + len;
-            unsigned num_spans;
-
-            unsigned num_styles;
-            unsigned style;
-            bool     solid;
-            while((num_styles = ras.sweep_styles()) > 0)
-            {
-                typename ScanlineAA::const_iterator span_aa;
-                if(num_styles == 1)
-                {
-                    // Optimization for a single style. Happens often
-                    //-------------------------
-                    if(ras.sweep_scanline(sl_aa, 0))
-                    {
-                        style = ras.style(0);
-                        if(sh.is_solid(style))
-                        {
-                            // Just solid fill
-                            //-----------------------
-                            render_scanline_aa_solid(sl_aa, ren, sh.color(style));
-                        }
-                        else
-                        {
-                            // Arbitrary span generator
-                            //-----------------------
-                            span_aa   = sl_aa.begin();
-                            num_spans = sl_aa.num_spans();
-                            for(;;)
-                            {
-                                len = span_aa->len;
-                                sh.generate_span(color_span, 
-                                                 span_aa->x, 
-                                                 sl_aa.y(), 
-                                                 len, 
-                                                 style);
-
-                                ren.blend_color_hspan(span_aa->x, 
-                                                      sl_aa.y(), 
-                                                      span_aa->len,
-                                                      color_span,
-                                                      span_aa->covers);
-                                if(--num_spans == 0) break;
-                                ++span_aa;
-                            }
-                        }
-                    }
-                }
-                else
-                {
-                    if(ras.sweep_scanline(sl_bin, -1))
-                    {
-                        // Clear the spans of the mix_buffer
-                        //--------------------
-                        typename ScanlineBin::const_iterator span_bin = sl_bin.begin();
-                        num_spans = sl_bin.num_spans();
-                        for(;;)
-                        {
-                            memset(mix_buffer + span_bin->x - min_x, 
-                                   0, 
-                                   span_bin->len * sizeof(color_type));
-
-                            if(--num_spans == 0) break;
-                            ++span_bin;
-                        }
-
-                        unsigned i;
-                        for(i = 0; i < num_styles; i++)
-                        {
-                            style = ras.style(i);
-                            solid = sh.is_solid(style);
-
-                            if(ras.sweep_scanline(sl_aa, i))
-                            {
-                                color_type* colors;
-                                color_type* cspan;
-                                typename ScanlineAA::cover_type* covers;
-                                span_aa   = sl_aa.begin();
-                                num_spans = sl_aa.num_spans();
-                                if(solid)
-                                {
-                                    // Just solid fill
-                                    //-----------------------
-                                    for(;;)
-                                    {
-                                        color_type c = sh.color(style);
-                                        len    = span_aa->len;
-                                        colors = mix_buffer + span_aa->x - min_x;
-                                        covers = span_aa->covers;
-                                        do
-                                        {
-                                            if(*covers == cover_full) 
-                                            {
-                                                *colors = c;
-                                            }
-                                            else
-                                            {
-                                                colors->add(c, *covers);
-                                            }
-                                            ++colors;
-                                            ++covers;
-                                        }
-                                        while(--len);
-                                        if(--num_spans == 0) break;
-                                        ++span_aa;
-                                    }
-                                }
-                                else
-                                {
-                                    // Arbitrary span generator
-                                    //-----------------------
-                                    for(;;)
-                                    {
-                                        len = span_aa->len;
-                                        colors = mix_buffer + span_aa->x - min_x;
-                                        cspan  = color_span;
-                                        sh.generate_span(cspan, 
-                                                         span_aa->x, 
-                                                         sl_aa.y(), 
-                                                         len, 
-                                                         style);
-                                        covers = span_aa->covers;
-                                        do
-                                        {
-                                            if(*covers == cover_full) 
-                                            {
-                                                *colors = *cspan;
-                                            }
-                                            else
-                                            {
-                                                colors->add(*cspan, *covers);
-                                            }
-                                            ++cspan;
-                                            ++colors;
-                                            ++covers;
-                                        }
-                                        while(--len);
-                                        if(--num_spans == 0) break;
-                                        ++span_aa;
-                                    }
-                                }
-                            }
-                        }
-
-                        // Emit the blended result as a color hspan
-                        //-------------------------
-                        span_bin = sl_bin.begin();
-                        num_spans = sl_bin.num_spans();
-                        for(;;)
-                        {
-                            ren.blend_color_hspan(span_bin->x, 
-                                                  sl_bin.y(), 
-                                                  span_bin->len,
-                                                  mix_buffer + span_bin->x - min_x,
-                                                  0,
-                                                  cover_full);
-                            if(--num_spans == 0) break;
-                            ++span_bin;
-                        }
-                    } // if(ras.sweep_scanline(sl_bin, -1))
-                } // if(num_styles == 1) ... else
-            } // while((num_styles = ras.sweep_styles()) > 0)
-        } // if(ras.rewind_scanlines())
-    }
-
-    //=======================================render_scanlines_compound_layered
-    template<class Rasterizer, 
-             class ScanlineAA, 
-             class BaseRenderer, 
-             class SpanAllocator,
-             class StyleHandler>
-    void render_scanlines_compound_layered(Rasterizer& ras, 
-                                           ScanlineAA& sl_aa,
-                                           BaseRenderer& ren,
-                                           SpanAllocator& alloc,
-                                           StyleHandler& sh)
-    {
-        if(ras.rewind_scanlines())
-        {
-            int min_x = ras.min_x();
-            int len = ras.max_x() - min_x + 2;
-            sl_aa.reset(min_x, ras.max_x());
-
-            typedef typename BaseRenderer::color_type color_type;
-            color_type* color_span   = alloc.allocate(len * 2);
-            color_type* mix_buffer   = color_span + len;
-            cover_type* cover_buffer = ras.allocate_cover_buffer(len);
-            unsigned num_spans;
-
-            unsigned num_styles;
-            unsigned style;
-            bool     solid;
-            while((num_styles = ras.sweep_styles()) > 0)
-            {
-                typename ScanlineAA::const_iterator span_aa;
-                if(num_styles == 1)
-                {
-                    // Optimization for a single style. Happens often
-                    //-------------------------
-                    if(ras.sweep_scanline(sl_aa, 0))
-                    {
-                        style = ras.style(0);
-                        if(sh.is_solid(style))
-                        {
-                            // Just solid fill
-                            //-----------------------
-                            render_scanline_aa_solid(sl_aa, ren, sh.color(style));
-                        }
-                        else
-                        {
-                            // Arbitrary span generator
-                            //-----------------------
-                            span_aa   = sl_aa.begin();
-                            num_spans = sl_aa.num_spans();
-                            for(;;)
-                            {
-                                len = span_aa->len;
-                                sh.generate_span(color_span, 
-                                                 span_aa->x, 
-                                                 sl_aa.y(), 
-                                                 len, 
-                                                 style);
-
-                                ren.blend_color_hspan(span_aa->x, 
-                                                      sl_aa.y(), 
-                                                      span_aa->len,
-                                                      color_span,
-                                                      span_aa->covers);
-                                if(--num_spans == 0) break;
-                                ++span_aa;
-                            }
-                        }
-                    }
-                }
-                else
-                {
-                    int      sl_start = ras.scanline_start();
-                    unsigned sl_len   = ras.scanline_length();
-
-                    if(sl_len)
-                    {
-                        memset(mix_buffer + sl_start - min_x, 
-                               0, 
-                               sl_len * sizeof(color_type));
-
-                        memset(cover_buffer + sl_start - min_x, 
-                               0, 
-                               sl_len * sizeof(cover_type));
-
-                        int sl_y = 0x7FFFFFFF;
-                        unsigned i;
-                        for(i = 0; i < num_styles; i++)
-                        {
-                            style = ras.style(i);
-                            solid = sh.is_solid(style);
-
-                            if(ras.sweep_scanline(sl_aa, i))
-                            {
-                                unsigned    cover;
-                                color_type* colors;
-                                color_type* cspan;
-                                cover_type* src_covers;
-                                cover_type* dst_covers;
-                                span_aa   = sl_aa.begin();
-                                num_spans = sl_aa.num_spans();
-                                sl_y      = sl_aa.y();
-                                if(solid)
-                                {
-                                    // Just solid fill
-                                    //-----------------------
-                                    for(;;)
-                                    {
-                                        color_type c = sh.color(style);
-                                        len    = span_aa->len;
-                                        colors = mix_buffer + span_aa->x - min_x;
-                                        src_covers = span_aa->covers;
-                                        dst_covers = cover_buffer + span_aa->x - min_x;
-                                        do
-                                        {
-                                            cover = *src_covers;
-                                            if(*dst_covers + cover > cover_full)
-                                            {
-                                                cover = cover_full - *dst_covers;
-                                            }
-                                            if(cover)
-                                            {
-                                                colors->add(c, cover);
-                                                *dst_covers += cover;
-                                            }
-                                            ++colors;
-                                            ++src_covers;
-                                            ++dst_covers;
-                                        }
-                                        while(--len);
-                                        if(--num_spans == 0) break;
-                                        ++span_aa;
-                                    }
-                                }
-                                else
-                                {
-                                    // Arbitrary span generator
-                                    //-----------------------
-                                    for(;;)
-                                    {
-                                        len = span_aa->len;
-                                        colors = mix_buffer + span_aa->x - min_x;
-                                        cspan  = color_span;
-                                        sh.generate_span(cspan, 
-                                                         span_aa->x, 
-                                                         sl_aa.y(), 
-                                                         len, 
-                                                         style);
-                                        src_covers = span_aa->covers;
-                                        dst_covers = cover_buffer + span_aa->x - min_x;
-                                        do
-                                        {
-                                            cover = *src_covers;
-                                            if(*dst_covers + cover > cover_full)
-                                            {
-                                                cover = cover_full - *dst_covers;
-                                            }
-                                            if(cover)
-                                            {
-                                                colors->add(*cspan, cover);
-                                                *dst_covers += cover;
-                                            }
-                                            ++cspan;
-                                            ++colors;
-                                            ++src_covers;
-                                            ++dst_covers;
-                                        }
-                                        while(--len);
-                                        if(--num_spans == 0) break;
-                                        ++span_aa;
-                                    }
-                                }
-                            }
-                        }
-                        ren.blend_color_hspan(sl_start, 
-                                              sl_y, 
-                                              sl_len,
-                                              mix_buffer + sl_start - min_x,
-                                              0,
-                                              cover_full);
-                    } //if(sl_len)
-                } //if(num_styles == 1) ... else
-            } //while((num_styles = ras.sweep_styles()) > 0)
-        } //if(ras.rewind_scanlines())
-    }
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_rendering_buffer.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rendering_buffer.h
--- 8.0.1-5/renderers/agg/include/agg_rendering_buffer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rendering_buffer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,300 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class rendering_buffer
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERING_BUFFER_INCLUDED
-#define AGG_RENDERING_BUFFER_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-
-    //===========================================================row_accessor
-    template<class T> class row_accessor
-    {
-    public:
-        typedef const_row_info<T> row_data;
-
-        //-------------------------------------------------------------------
-        row_accessor() :
-            m_buf(0),
-            m_start(0),
-            m_width(0),
-            m_height(0),
-            m_stride(0)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        row_accessor(T* buf, unsigned width, unsigned height, int stride) :
-            m_buf(0),
-            m_start(0),
-            m_width(0),
-            m_height(0),
-            m_stride(0)
-        {
-            attach(buf, width, height, stride);
-        }
-
-
-        //--------------------------------------------------------------------
-        void attach(T* buf, unsigned width, unsigned height, int stride)
-        {
-			m_buf = m_start = buf;
-			m_width = width;
-			m_height = height;
-			m_stride = stride;
-			if(stride < 0) 
-            { 
-				m_start = m_buf - (size_t)(height - 1) * stride;
-			}
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE       T* buf()          { return m_buf;    }
-        AGG_INLINE const T* buf()    const { return m_buf;    }
-        AGG_INLINE unsigned width()  const { return m_width;  }
-        AGG_INLINE unsigned height() const { return m_height; }
-        AGG_INLINE int      stride() const { return m_stride; }
-        AGG_INLINE unsigned stride_abs() const 
-        {
-            return (m_stride < 0) ? unsigned(-m_stride) : unsigned(m_stride); 
-        }
-
-        //--------------------------------------------------------------------
-		AGG_INLINE       T* row_ptr(int, int y, unsigned) 
-        { 
-            return m_start + (size_t)y * m_stride; 
-        }
-		AGG_INLINE       T* row_ptr(int y)       { return m_start + (size_t)y * m_stride; }
-		AGG_INLINE const T* row_ptr(int y) const { return m_start + (size_t)y * m_stride; }
-		AGG_INLINE row_data row    (int y) const 
-        { 
-            return row_data(0, m_width-1, row_ptr(y)); 
-        }
-
-        //--------------------------------------------------------------------
-        template<class RenBuf>
-        void copy_from(const RenBuf& src)
-        {
-            unsigned h = height();
-            if(src.height() < h) h = src.height();
-        
-            unsigned l = stride_abs();
-            if(src.stride_abs() < l) l = src.stride_abs();
-        
-            l *= sizeof(T);
-
-            unsigned y;
-            unsigned w = width();
-            for (y = 0; y < h; y++)
-            {
-                memcpy(row_ptr(0, y, w), src.row_ptr(y), l);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void clear(T value)
-        {
-            unsigned y;
-            unsigned w = width();
-            unsigned stride = stride_abs();
-            for(y = 0; y < height(); y++)
-            {
-                T* p = row_ptr(0, y, w);
-                unsigned x;
-                for(x = 0; x < stride; x++)
-                {
-                    *p++ = value;
-                }
-            }
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        T*            m_buf;    // Pointer to rendering buffer
-        T*            m_start;  // Pointer to first pixel depending on stride 
-        unsigned      m_width;  // Width in pixels
-        unsigned      m_height; // Height in pixels
-        int           m_stride; // Number of bytes per row. Can be < 0
-    };
-
-
-
-
-    //==========================================================row_ptr_cache
-    template<class T> class row_ptr_cache
-    {
-    public:
-        typedef const_row_info<T> row_data;
-
-        //-------------------------------------------------------------------
-        row_ptr_cache() :
-            m_buf(0),
-            m_rows(),
-            m_width(0),
-            m_height(0),
-            m_stride(0)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        row_ptr_cache(T* buf, unsigned width, unsigned height, int stride) :
-            m_buf(0),
-            m_rows(),
-            m_width(0),
-            m_height(0),
-            m_stride(0)
-        {
-            attach(buf, width, height, stride);
-        }
-
-        //--------------------------------------------------------------------
-        void attach(T* buf, unsigned width, unsigned height, int stride)
-        {
-            m_buf = buf;
-            m_width = width;
-            m_height = height;
-            m_stride = stride;
-            if(height > m_rows.size())
-            {
-                m_rows.resize(height);
-            }
-
-            T* row_ptr = m_buf;
-
-            if(stride < 0)
-            {
-                row_ptr = m_buf - int(height - 1) * stride;
-            }
-
-            T** rows = &m_rows[0];
-
-            while(height--)
-            {
-                *rows++ = row_ptr;
-                row_ptr += stride;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE       T* buf()          { return m_buf;    }
-        AGG_INLINE const T* buf()    const { return m_buf;    }
-        AGG_INLINE unsigned width()  const { return m_width;  }
-        AGG_INLINE unsigned height() const { return m_height; }
-        AGG_INLINE int      stride() const { return m_stride; }
-        AGG_INLINE unsigned stride_abs() const 
-        {
-            return (m_stride < 0) ? unsigned(-m_stride) : unsigned(m_stride); 
-        }
-
-        //--------------------------------------------------------------------
-        AGG_INLINE       T* row_ptr(int, int y, unsigned) 
-        { 
-            return m_rows[y]; 
-        }
-        AGG_INLINE       T* row_ptr(int y)       { return m_rows[y]; }
-        AGG_INLINE const T* row_ptr(int y) const { return m_rows[y]; }
-        AGG_INLINE row_data row    (int y) const 
-        { 
-            return row_data(0, m_width-1, m_rows[y]); 
-        }
-
-        //--------------------------------------------------------------------
-        T const* const* rows() const { return &m_rows[0]; }
-
-        //--------------------------------------------------------------------
-        template<class RenBuf>
-        void copy_from(const RenBuf& src)
-        {
-            unsigned h = height();
-            if(src.height() < h) h = src.height();
-        
-            unsigned l = stride_abs();
-            if(src.stride_abs() < l) l = src.stride_abs();
-        
-            l *= sizeof(T);
-
-            unsigned y;
-            unsigned w = width();
-            for (y = 0; y < h; y++)
-            {
-                memcpy(row_ptr(0, y, w), src.row_ptr(y), l);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        void clear(T value)
-        {
-            unsigned y;
-            unsigned w = width();
-            unsigned stride = stride_abs();
-            for(y = 0; y < height(); y++)
-            {
-                T* p = row_ptr(0, y, w);
-                unsigned x;
-                for(x = 0; x < stride; x++)
-                {
-                    *p++ = value;
-                }
-            }
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        T*            m_buf;        // Pointer to rendering buffer
-        pod_array<T*> m_rows;       // Pointers to each row of the buffer
-        unsigned      m_width;      // Width in pixels
-        unsigned      m_height;     // Height in pixels
-        int           m_stride;     // Number of bytes per row. Can be < 0
-    };
-
-
-
-
-    //========================================================rendering_buffer
-    // 
-    // The definition of the main type for accessing the rows in the frame 
-    // buffer. It provides functionality to navigate to the rows in a 
-    // rectangular matrix, from top to bottom or from bottom to top depending 
-    // on stride.
-    //
-    // row_accessor is cheap to create/destroy, but performs one multiplication
-    // when calling row_ptr().
-    // 
-    // row_ptr_cache creates an array of pointers to rows, so, the access 
-    // via row_ptr() may be faster. But it requires memory allocation 
-    // when creating. For example, on typical Intel Pentium hardware 
-    // row_ptr_cache speeds span_image_filter_rgb_nn up to 10%
-    //
-    // It's used only in short hand typedefs like pixfmt_rgba32 and can be 
-    // redefined in agg_config.h
-    // In real applications you can use both, depending on your needs
-    //------------------------------------------------------------------------
-#ifdef AGG_RENDERING_BUFFER
-    typedef AGG_RENDERING_BUFFER rendering_buffer;
-#else
-//  typedef row_ptr_cache<int8u> rendering_buffer;
-    typedef row_accessor<int8u> rendering_buffer;
-#endif
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_rendering_buffer_dynarow.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rendering_buffer_dynarow.h
--- 8.0.1-5/renderers/agg/include/agg_rendering_buffer_dynarow.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rendering_buffer_dynarow.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,137 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class rendering_buffer_dynarow
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_RENDERING_BUFFER_DYNAROW_INCLUDED
-#define AGG_RENDERING_BUFFER_DYNAROW_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-
-    //===============================================rendering_buffer_dynarow
-    // Rendering buffer class with dynamic allocation of the rows.
-    // The rows are allocated as needed when requesting for span_ptr().
-    // The class automatically calculates min_x and max_x for each row.
-    // Generally it's more efficient to use this class as a temporary buffer
-    // for rendering a few lines and then to blend it with another buffer.
-    //
-    class rendering_buffer_dynarow
-    {
-    public:
-        typedef row_info<int8u> row_data;
-
-        //-------------------------------------------------------------------
-        ~rendering_buffer_dynarow()
-        {
-            init(0,0,0);
-        }
-
-        //-------------------------------------------------------------------
-        rendering_buffer_dynarow() :
-            m_rows(),
-            m_width(0),
-            m_height(0),
-            m_byte_width(0)
-        {
-        }
-
-        // Allocate and clear the buffer
-        //--------------------------------------------------------------------
-        rendering_buffer_dynarow(unsigned width, unsigned height, 
-                                 unsigned byte_width) :
-            m_rows(height),
-            m_width(width),
-            m_height(height),
-            m_byte_width(byte_width)
-        {
-            memset(&m_rows[0], 0, sizeof(row_data) * height);
-        }
-
-        // Allocate and clear the buffer
-        //--------------------------------------------------------------------
-        void init(unsigned width, unsigned height, unsigned byte_width)
-        {
-            unsigned i;
-            for(i = 0; i < m_height; ++i) 
-            {
-                pod_allocator<int8u>::deallocate((int8u*)m_rows[i].ptr, m_byte_width);
-            }
-            if(width && height)
-            {
-                m_width  = width;
-                m_height = height;
-                m_byte_width = byte_width;
-                m_rows.resize(height);
-                memset(&m_rows[0], 0, sizeof(row_data) * height);
-            }
-        }
-
-        //--------------------------------------------------------------------
-        unsigned width()      const { return m_width;  }
-        unsigned height()     const { return m_height; }
-        unsigned byte_width() const { return m_byte_width; }
-
-        // The main function used for rendering. Returns pointer to the 
-        // pre-allocated span. Memory for the row is allocated as needed.
-        //--------------------------------------------------------------------
-        int8u* row_ptr(int x, int y, unsigned len)
-        {
-            row_data* r = &m_rows[y];
-            int x2 = x + len - 1;
-            if(r->ptr)
-            {
-                if(x  < r->x1) { r->x1 = x;  }
-                if(x2 > r->x2) { r->x2 = x2; }
-            }
-            else
-            {
-                int8u* p = pod_allocator<int8u>::allocate(m_byte_width);
-                r->ptr = p;
-                r->x1  = x;
-                r->x2  = x2;
-                memset(p, 0, m_byte_width);
-            }
-            return (int8u*)r->ptr;
-        }
-
-        //--------------------------------------------------------------------
-        const int8u* row_ptr(int y) const { return m_rows[y].ptr; }
-              int8u* row_ptr(int y)       { return row_ptr(0, y, m_width); }
-        row_data     row    (int y) const { return m_rows[y]; }
-
-    private:
-        //--------------------------------------------------------------------
-        // Prohibit copying
-        rendering_buffer_dynarow(const rendering_buffer_dynarow&);
-        const rendering_buffer_dynarow& operator = (const rendering_buffer_dynarow&);
-
-    private:
-        //--------------------------------------------------------------------
-        pod_array<row_data> m_rows;       // Pointers to each row of the buffer
-        unsigned            m_width;      // Width in pixels
-        unsigned            m_height;     // Height in pixels
-        unsigned            m_byte_width; // Width in bytes
-    };
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_rounded_rect.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rounded_rect.h
--- 8.0.1-5/renderers/agg/include/agg_rounded_rect.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_rounded_rect.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,72 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Rounded rectangle vertex generator
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_ROUNDED_RECT_INCLUDED
-#define AGG_ROUNDED_RECT_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_arc.h"
-
-namespace mapserver
-{
-    //------------------------------------------------------------rounded_rect
-    //
-    // See Implemantation agg_rounded_rect.cpp
-    //
-    class rounded_rect
-    {
-    public:
-        rounded_rect() {}
-        rounded_rect(double x1, double y1, double x2, double y2, double r);
-
-        void rect(double x1, double y1, double x2, double y2);
-        void radius(double r);
-        void radius(double rx, double ry);
-        void radius(double rx_bottom, double ry_bottom, double rx_top, double ry_top);
-        void radius(double rx1, double ry1, double rx2, double ry2, 
-                    double rx3, double ry3, double rx4, double ry4);
-        void normalize_radius();
-
-        void approximation_scale(double s) { m_arc.approximation_scale(s); }
-        double approximation_scale() const { return m_arc.approximation_scale(); }
-
-        void rewind(unsigned);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        double m_x1;
-        double m_y1;
-        double m_x2;
-        double m_y2;
-        double m_rx1;
-        double m_ry1;
-        double m_rx2;
-        double m_ry2;
-        double m_rx3;
-        double m_ry3;
-        double m_rx4;
-        double m_ry4;
-        unsigned m_status;
-        arc      m_arc;
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_scanline_bin.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_bin.h
--- 8.0.1-5/renderers/agg/include/agg_scanline_bin.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_bin.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,264 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Class scanline_bin - binary scanline.
-//
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates (scanline32_bin) has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SCANLINE_BIN_INCLUDED
-#define AGG_SCANLINE_BIN_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-
-    //=============================================================scanline_bin
-    // 
-    // This is binary scaline container which supports the interface 
-    // used in the rasterizer::render(). See description of agg_scanline_u8 
-    // for details.
-    // 
-    //------------------------------------------------------------------------
-    class scanline_bin
-    {
-    public:
-        typedef int32 coord_type;
-
-        struct span
-        {
-            int16 x;
-            int16 len;
-        };
-
-        typedef const span* const_iterator;
-
-        //--------------------------------------------------------------------
-        scanline_bin() :
-            m_last_x(0x7FFFFFF0),
-            m_spans(),
-            m_cur_span(0)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        void reset(int min_x, int max_x)
-        {
-            unsigned max_len = max_x - min_x + 3;
-            if(max_len > m_spans.size())
-            {
-                m_spans.resize(max_len);
-            }
-            m_last_x   = 0x7FFFFFF0;
-            m_cur_span = &m_spans[0];
-        }
-
-        //--------------------------------------------------------------------
-        void add_cell(int x, unsigned)
-        {
-            if(x == m_last_x+1)
-            {
-                m_cur_span->len++;
-            }
-            else
-            {
-                ++m_cur_span;
-                m_cur_span->x = (int16)x;
-                m_cur_span->len = 1;
-            }
-            m_last_x = x;
-        }
-
-        //--------------------------------------------------------------------
-        void add_span(int x, unsigned len, unsigned)
-        {
-            if(x == m_last_x+1)
-            {
-                m_cur_span->len = (int16)(m_cur_span->len + len);
-            }
-            else
-            {
-                ++m_cur_span;
-                m_cur_span->x = (int16)x;
-                m_cur_span->len = (int16)len;
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void add_cells(int x, unsigned len, const void*)
-        {
-            add_span(x, len, 0);
-        }
-
-        //--------------------------------------------------------------------
-        void finalize(int y) 
-        { 
-            m_y = y; 
-        }
-
-        //--------------------------------------------------------------------
-        void reset_spans()
-        {
-            m_last_x    = 0x7FFFFFF0;
-            m_cur_span  = &m_spans[0];
-        }
-
-        //--------------------------------------------------------------------
-        int            y()         const { return m_y; }
-        unsigned       num_spans() const { return unsigned(m_cur_span - &m_spans[0]); }
-        const_iterator begin()     const { return &m_spans[1]; }
-
-    private:
-        scanline_bin(const scanline_bin&);
-        const scanline_bin operator = (const scanline_bin&);
-
-        int             m_last_x;
-        int             m_y = 0;
-        pod_array<span> m_spans;
-        span*           m_cur_span;
-    };
-
-
-
-
-
-
-    //===========================================================scanline32_bin
-    class scanline32_bin
-    {
-    public:
-        typedef int32 coord_type;
-
-        //--------------------------------------------------------------------
-        struct span
-        {
-            span() {}
-            span(coord_type x_, coord_type len_) : x(x_), len(len_) {}
-
-            coord_type x;
-            coord_type len;
-        };
-        typedef pod_bvector<span, 4> span_array_type;
-
-
-        //--------------------------------------------------------------------
-        class const_iterator
-        {
-        public:
-            const_iterator(const span_array_type& spans) :
-                m_spans(spans),
-                m_span_idx(0)
-            {}
-
-            const span& operator*()  const { return m_spans[m_span_idx];  }
-            const span* operator->() const { return &m_spans[m_span_idx]; }
-
-            void operator ++ () { ++m_span_idx; }
-
-        private:
-            const span_array_type& m_spans;
-            unsigned               m_span_idx;
-        };
-
-
-        //--------------------------------------------------------------------
-        scanline32_bin() : m_max_len(0), m_last_x(0x7FFFFFF0) {}
-
-        //--------------------------------------------------------------------
-        void reset(int /*min_x*/, int /*max_x*/)
-        {
-            m_last_x = 0x7FFFFFF0;
-            m_spans.remove_all();
-        }
-
-        //--------------------------------------------------------------------
-        void add_cell(int x, unsigned)
-        {
-            if(x == m_last_x+1)
-            {
-                m_spans.last().len++;
-            }
-            else
-            {
-                m_spans.add(span(coord_type(x), 1));
-            }
-            m_last_x = x;
-        }
-
-        //--------------------------------------------------------------------
-        void add_span(int x, unsigned len, unsigned)
-        {
-            if(x == m_last_x+1)
-            {
-                m_spans.last().len += coord_type(len);
-            }
-            else
-            {
-                m_spans.add(span(coord_type(x), coord_type(len)));
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void add_cells(int x, unsigned len, const void*)
-        {
-            add_span(x, len, 0);
-        }
-
-        //--------------------------------------------------------------------
-        void finalize(int y) 
-        { 
-            m_y = y; 
-        }
-
-        //--------------------------------------------------------------------
-        void reset_spans()
-        {
-            m_last_x = 0x7FFFFFF0;
-            m_spans.remove_all();
-        }
-
-        //--------------------------------------------------------------------
-        int            y()         const { return m_y; }
-        unsigned       num_spans() const { return m_spans.size(); }
-        const_iterator begin()     const { return const_iterator(m_spans); }
-
-    private:
-        scanline32_bin(const scanline32_bin&);
-        const scanline32_bin operator = (const scanline32_bin&);
-
-        unsigned        m_max_len;
-        int             m_last_x;
-        int             m_y;
-        span_array_type m_spans;
-    };
-
-
-
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_scanline_boolean_algebra.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_boolean_algebra.h
--- 8.0.1-5/renderers/agg/include/agg_scanline_boolean_algebra.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_boolean_algebra.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,1567 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SCANLINE_BOOLEAN_ALGEBRA_INCLUDED
-#define AGG_SCANLINE_BOOLEAN_ALGEBRA_INCLUDED
-
-#include <stdlib.h>
-#include <math.h>
-#include "agg_basics.h"
-
-
-namespace mapserver
-{
-
-    //-----------------------------------------------sbool_combine_spans_bin
-    // Functor.
-    // Combine two binary encoded spans, i.e., when we don't have any
-    // anti-aliasing information, but only X and Length. The function
-    // is compatible with any type of scanlines.
-    //----------------
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline> 
-    struct sbool_combine_spans_bin
-    {
-        void operator () (const typename Scanline1::const_iterator&, 
-                          const typename Scanline2::const_iterator&, 
-                          int x, unsigned len, 
-                          Scanline& sl) const
-        {
-            sl.add_span(x, len, cover_full);
-        }
-    };
-
-
-
-    //---------------------------------------------sbool_combine_spans_empty
-    // Functor.
-    // Combine two spans as empty ones. The functor does nothing
-    // and is used to XOR binary spans.
-    //----------------
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline> 
-    struct sbool_combine_spans_empty
-    {
-        void operator () (const typename Scanline1::const_iterator&, 
-                          const typename Scanline2::const_iterator&, 
-                          int, unsigned, 
-                          Scanline&) const
-        {}
-    };
-
-
-
-    //--------------------------------------------------sbool_add_span_empty
-    // Functor.
-    // Add nothing. Used in conbine_shapes_sub
-    //----------------
-    template<class Scanline1, 
-             class Scanline> 
-    struct sbool_add_span_empty
-    {
-        void operator () (const typename Scanline1::const_iterator&, 
-                          int, unsigned, 
-                          Scanline&) const
-        {}
-    };
-
-
-    //----------------------------------------------------sbool_add_span_bin
-    // Functor.
-    // Add a binary span
-    //----------------
-    template<class Scanline1, 
-             class Scanline> 
-    struct sbool_add_span_bin
-    {
-        void operator () (const typename Scanline1::const_iterator&, 
-                          int x, unsigned len, 
-                          Scanline& sl) const
-        {
-            sl.add_span(x, len, cover_full);
-        }
-    };
-
-    
-
-
-    //-----------------------------------------------------sbool_add_span_aa
-    // Functor.
-    // Add an anti-aliased span
-    // anti-aliasing information, but only X and Length. The function
-    // is compatible with any type of scanlines.
-    //----------------
-    template<class Scanline1, 
-             class Scanline> 
-    struct sbool_add_span_aa
-    {
-        void operator () (const typename Scanline1::const_iterator& span, 
-                          int x, unsigned len, 
-                          Scanline& sl) const
-        {
-            if(span->len < 0)
-            {
-                sl.add_span(x, len, *span->covers);
-            }
-            else
-            if(span->len > 0)
-            {
-                const typename Scanline1::cover_type* covers = span->covers;
-                if(span->x < x) covers += x - span->x;
-                sl.add_cells(x, len, covers);
-            }
-        }
-    };
-
-
-
-
-    //----------------------------------------------sbool_intersect_spans_aa
-    // Functor.
-    // Intersect two spans preserving the anti-aliasing information.
-    // The result is added to the "sl" scanline.
-    //------------------
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             unsigned CoverShift = cover_shift> 
-    struct sbool_intersect_spans_aa
-    {
-        enum cover_scale_e
-        {
-            cover_shift = CoverShift,
-            cover_size  = 1 << cover_shift,
-            cover_mask  = cover_size - 1,
-            cover_full  = cover_mask
-        };
-        
-
-        void operator () (const typename Scanline1::const_iterator& span1, 
-                          const typename Scanline2::const_iterator& span2, 
-                          int x, unsigned len, 
-                          Scanline& sl) const
-        {
-            unsigned cover;
-            const typename Scanline1::cover_type* covers1;
-            const typename Scanline2::cover_type* covers2;
-
-            // Calculate the operation code and choose the 
-            // proper combination algorithm.
-            // 0 = Both spans are of AA type
-            // 1 = span1 is solid, span2 is AA
-            // 2 = span1 is AA, span2 is solid
-            // 3 = Both spans are of solid type
-            //-----------------
-            switch((span1->len < 0) | ((span2->len < 0) << 1))
-            {
-            case 0:      // Both are AA spans
-                covers1 = span1->covers;
-                covers2 = span2->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                if(span2->x < x) covers2 += x - span2->x;
-                do
-                {
-                    cover = *covers1++ * *covers2++;
-                    sl.add_cell(x++, 
-                                (cover == cover_full * cover_full) ?
-                                cover_full : 
-                                (cover >> cover_shift));
-                }
-                while(--len);
-                break;
-
-            case 1:      // span1 is solid, span2 is AA
-                covers2 = span2->covers;
-                if(span2->x < x) covers2 += x - span2->x;
-                if(*(span1->covers) == cover_full)
-                {
-                    sl.add_cells(x, len, covers2);
-                }
-                else
-                {
-                    do
-                    {
-                        cover = *(span1->covers) * *covers2++;
-                        sl.add_cell(x++, 
-                                    (cover == cover_full * cover_full) ?
-                                    cover_full : 
-                                    (cover >> cover_shift));
-                    }
-                    while(--len);
-                }
-                break;
-
-            case 2:      // span1 is AA, span2 is solid
-                covers1 = span1->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                if(*(span2->covers) == cover_full)
-                {
-                    sl.add_cells(x, len, covers1);
-                }
-                else
-                {
-                    do
-                    {
-                        cover = *covers1++ * *(span2->covers);
-                        sl.add_cell(x++, 
-                                    (cover == cover_full * cover_full) ?
-                                    cover_full : 
-                                    (cover >> cover_shift));
-                    }
-                    while(--len);
-                }
-                break;
-
-            case 3:      // Both are solid spans
-                cover = *(span1->covers) * *(span2->covers);
-                sl.add_span(x, len, 
-                            (cover == cover_full * cover_full) ?
-                            cover_full : 
-                            (cover >> cover_shift));
-                break;
-            }
-        }
-    };
-
-
-
-
-
-
-    //--------------------------------------------------sbool_unite_spans_aa
-    // Functor.
-    // Unite two spans preserving the anti-aliasing information.
-    // The result is added to the "sl" scanline.
-    //------------------
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             unsigned CoverShift = cover_shift> 
-    struct sbool_unite_spans_aa
-    {
-        enum cover_scale_e
-        {
-            cover_shift = CoverShift,
-            cover_size  = 1 << cover_shift,
-            cover_mask  = cover_size - 1,
-            cover_full  = cover_mask
-        };
-        
-
-        void operator () (const typename Scanline1::const_iterator& span1, 
-                          const typename Scanline2::const_iterator& span2, 
-                          int x, unsigned len, 
-                          Scanline& sl) const
-        {
-            unsigned cover;
-            const typename Scanline1::cover_type* covers1;
-            const typename Scanline2::cover_type* covers2;
-
-            // Calculate the operation code and choose the 
-            // proper combination algorithm.
-            // 0 = Both spans are of AA type
-            // 1 = span1 is solid, span2 is AA
-            // 2 = span1 is AA, span2 is solid
-            // 3 = Both spans are of solid type
-            //-----------------
-            switch((span1->len < 0) | ((span2->len < 0) << 1))
-            {
-            case 0:      // Both are AA spans
-                covers1 = span1->covers;
-                covers2 = span2->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                if(span2->x < x) covers2 += x - span2->x;
-                do
-                {
-                    cover = cover_mask * cover_mask - 
-                                (cover_mask - *covers1++) * 
-                                (cover_mask - *covers2++);
-                    sl.add_cell(x++, 
-                                (cover == cover_full * cover_full) ?
-                                cover_full : 
-                                (cover >> cover_shift));
-                }
-                while(--len);
-                break;
-
-            case 1:      // span1 is solid, span2 is AA
-                covers2 = span2->covers;
-                if(span2->x < x) covers2 += x - span2->x;
-                if(*(span1->covers) == cover_full)
-                {
-                    sl.add_span(x, len, cover_full);
-                }
-                else
-                {
-                    do
-                    {
-                        cover = cover_mask * cover_mask - 
-                                    (cover_mask - *(span1->covers)) * 
-                                    (cover_mask - *covers2++);
-                        sl.add_cell(x++, 
-                                    (cover == cover_full * cover_full) ?
-                                    cover_full : 
-                                    (cover >> cover_shift));
-                    }
-                    while(--len);
-                }
-                break;
-
-            case 2:      // span1 is AA, span2 is solid
-                covers1 = span1->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                if(*(span2->covers) == cover_full)
-                {
-                    sl.add_span(x, len, cover_full);
-                }
-                else
-                {
-                    do
-                    {
-                        cover = cover_mask * cover_mask - 
-                                    (cover_mask - *covers1++) * 
-                                    (cover_mask - *(span2->covers));
-                        sl.add_cell(x++, 
-                                    (cover == cover_full * cover_full) ?
-                                    cover_full : 
-                                    (cover >> cover_shift));
-                    }
-                    while(--len);
-                }
-                break;
-
-            case 3:      // Both are solid spans
-                cover = cover_mask * cover_mask - 
-                            (cover_mask - *(span1->covers)) * 
-                            (cover_mask - *(span2->covers));
-                sl.add_span(x, len, 
-                            (cover == cover_full * cover_full) ?
-                            cover_full : 
-                            (cover >> cover_shift));
-                break;
-            }
-        }
-    };
-
-
-    //---------------------------------------------sbool_xor_formula_linear
-    template<unsigned CoverShift = cover_shift> 
-    struct sbool_xor_formula_linear
-    {
-        enum cover_scale_e
-        {
-            cover_shift = CoverShift,
-            cover_size  = 1 << cover_shift,
-            cover_mask  = cover_size - 1
-        };
-
-        static AGG_INLINE unsigned calculate(unsigned a, unsigned b)
-        {
-            unsigned cover = a + b;
-            if(cover > cover_mask) cover = cover_mask + cover_mask - cover;
-            return cover;
-        }
-    };
-
-
-    //---------------------------------------------sbool_xor_formula_saddle
-    template<unsigned CoverShift = cover_shift> 
-    struct sbool_xor_formula_saddle
-    {
-        enum cover_scale_e
-        {
-            cover_shift = CoverShift,
-            cover_size  = 1 << cover_shift,
-            cover_mask  = cover_size - 1
-        };
-
-        static AGG_INLINE unsigned calculate(unsigned a, unsigned b)
-        {
-            unsigned k = a * b;
-            if(k == cover_mask * cover_mask) return 0;
-
-            a = (cover_mask * cover_mask - (a << cover_shift) + k) >> cover_shift;
-            b = (cover_mask * cover_mask - (b << cover_shift) + k) >> cover_shift;
-            return cover_mask - ((a * b) >> cover_shift);
-        }
-    };
-
-
-    //-------------------------------------------sbool_xor_formula_abs_diff
-    struct sbool_xor_formula_abs_diff
-    {
-        static AGG_INLINE unsigned calculate(unsigned a, unsigned b)
-        {
-            return unsigned(abs(int(a) - int(b)));
-        }
-    };
-
-
-
-    //----------------------------------------------------sbool_xor_spans_aa
-    // Functor.
-    // XOR two spans preserving the anti-aliasing information.
-    // The result is added to the "sl" scanline.
-    //------------------
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class XorFormula,
-             unsigned CoverShift = cover_shift> 
-    struct sbool_xor_spans_aa
-    {
-        enum cover_scale_e
-        {
-            cover_shift = CoverShift,
-            cover_size  = 1 << cover_shift,
-            cover_mask  = cover_size - 1,
-            cover_full  = cover_mask
-        };
-        
-
-        void operator () (const typename Scanline1::const_iterator& span1, 
-                          const typename Scanline2::const_iterator& span2, 
-                          int x, unsigned len, 
-                          Scanline& sl) const
-        {
-            unsigned cover;
-            const typename Scanline1::cover_type* covers1;
-            const typename Scanline2::cover_type* covers2;
-
-            // Calculate the operation code and choose the 
-            // proper combination algorithm.
-            // 0 = Both spans are of AA type
-            // 1 = span1 is solid, span2 is AA
-            // 2 = span1 is AA, span2 is solid
-            // 3 = Both spans are of solid type
-            //-----------------
-            switch((span1->len < 0) | ((span2->len < 0) << 1))
-            {
-            case 0:      // Both are AA spans
-                covers1 = span1->covers;
-                covers2 = span2->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                if(span2->x < x) covers2 += x - span2->x;
-                do
-                {
-                    cover = XorFormula::calculate(*covers1++, *covers2++);
-                    if(cover) sl.add_cell(x, cover);
-                    ++x;
-                }
-                while(--len);
-                break;
-
-            case 1:      // span1 is solid, span2 is AA
-                covers2 = span2->covers;
-                if(span2->x < x) covers2 += x - span2->x;
-                do
-                {
-                    cover = XorFormula::calculate(*(span1->covers), *covers2++);
-                    if(cover) sl.add_cell(x, cover);
-                    ++x;
-                }
-                while(--len);
-                break;
-
-            case 2:      // span1 is AA, span2 is solid
-                covers1 = span1->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                do
-                {
-                    cover = XorFormula::calculate(*covers1++, *(span2->covers));
-                    if(cover) sl.add_cell(x, cover);
-                    ++x;
-                }
-                while(--len);
-                break;
-
-            case 3:      // Both are solid spans
-                cover = XorFormula::calculate(*(span1->covers), *(span2->covers));
-                if(cover) sl.add_span(x, len, cover);
-                break;
-
-            }
-        }
-    };
-
-
-
-
-
-    //-----------------------------------------------sbool_subtract_spans_aa
-    // Functor.
-    // Unite two spans preserving the anti-aliasing information.
-    // The result is added to the "sl" scanline.
-    //------------------
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             unsigned CoverShift = cover_shift> 
-    struct sbool_subtract_spans_aa
-    {
-        enum cover_scale_e
-        {
-            cover_shift = CoverShift,
-            cover_size  = 1 << cover_shift,
-            cover_mask  = cover_size - 1,
-            cover_full  = cover_mask
-        };
-        
-
-        void operator () (const typename Scanline1::const_iterator& span1, 
-                          const typename Scanline2::const_iterator& span2, 
-                          int x, unsigned len, 
-                          Scanline& sl) const
-        {
-            unsigned cover;
-            const typename Scanline1::cover_type* covers1;
-            const typename Scanline2::cover_type* covers2;
-
-            // Calculate the operation code and choose the 
-            // proper combination algorithm.
-            // 0 = Both spans are of AA type
-            // 1 = span1 is solid, span2 is AA
-            // 2 = span1 is AA, span2 is solid
-            // 3 = Both spans are of solid type
-            //-----------------
-            switch((span1->len < 0) | ((span2->len < 0) << 1))
-            {
-            case 0:      // Both are AA spans
-                covers1 = span1->covers;
-                covers2 = span2->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                if(span2->x < x) covers2 += x - span2->x;
-                do
-                {
-                    cover = *covers1++ * (cover_mask - *covers2++);
-                    if(cover)
-                    {
-                        sl.add_cell(x, 
-                                    (cover == cover_full * cover_full) ?
-                                    cover_full : 
-                                    (cover >> cover_shift));
-                    }
-                    ++x;
-                }
-                while(--len);
-                break;
-
-            case 1:      // span1 is solid, span2 is AA
-                covers2 = span2->covers;
-                if(span2->x < x) covers2 += x - span2->x;
-                do
-                {
-                    cover = *(span1->covers) * (cover_mask - *covers2++);
-                    if(cover)
-                    {
-                        sl.add_cell(x, 
-                                    (cover == cover_full * cover_full) ?
-                                    cover_full : 
-                                    (cover >> cover_shift));
-                    }
-                    ++x;
-                }
-                while(--len);
-                break;
-
-            case 2:      // span1 is AA, span2 is solid
-                covers1 = span1->covers;
-                if(span1->x < x) covers1 += x - span1->x;
-                if(*(span2->covers) != cover_full)
-                {
-                    do
-                    {
-                        cover = *covers1++ * (cover_mask - *(span2->covers));
-                        if(cover)
-                        {
-                            sl.add_cell(x, 
-                                        (cover == cover_full * cover_full) ?
-                                        cover_full : 
-                                        (cover >> cover_shift));
-                        }
-                        ++x;
-                    }
-                    while(--len);
-                }
-                break;
-
-            case 3:      // Both are solid spans
-                cover = *(span1->covers) * (cover_mask - *(span2->covers));
-                if(cover)
-                {
-                    sl.add_span(x, len, 
-                                (cover == cover_full * cover_full) ?
-                                cover_full : 
-                                (cover >> cover_shift));
-                }
-                break;
-            }
-        }
-    };
-
-
-
-
-
-
-    //--------------------------------------------sbool_add_spans_and_render
-    template<class Scanline1, 
-             class Scanline, 
-             class Renderer, 
-             class AddSpanFunctor>
-    void sbool_add_spans_and_render(const Scanline1& sl1, 
-                                    Scanline& sl, 
-                                    Renderer& ren, 
-                                    AddSpanFunctor add_span)
-    {
-        sl.reset_spans();
-        typename Scanline1::const_iterator span = sl1.begin();
-        unsigned num_spans = sl1.num_spans();
-        for(;;)
-        {
-            add_span(span, span->x, abs((int)span->len), sl);
-            if(--num_spans == 0) break;
-            ++span;
-        }
-        sl.finalize(sl1.y());
-        ren.render(sl);
-    }
-
-
-
-
-
-
-
-    //---------------------------------------------sbool_intersect_scanlines
-    // Intersect two scanlines, "sl1" and "sl2" and generate a new "sl" one.
-    // The combine_spans functor can be of type sbool_combine_spans_bin or
-    // sbool_intersect_spans_aa. First is a general functor to combine
-    // two spans without Anti-Aliasing, the second preserves the AA
-    // information, but works slower
-    //
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class CombineSpansFunctor>
-    void sbool_intersect_scanlines(const Scanline1& sl1, 
-                                   const Scanline2& sl2, 
-                                   Scanline& sl, 
-                                   CombineSpansFunctor combine_spans)
-    {
-        sl.reset_spans();
-
-        unsigned num1 = sl1.num_spans();
-        if(num1 == 0) return;
-
-        unsigned num2 = sl2.num_spans();
-        if(num2 == 0) return;
-
-        typename Scanline1::const_iterator span1 = sl1.begin();
-        typename Scanline2::const_iterator span2 = sl2.begin();
-
-        while(num1 && num2)
-        {
-            int xb1 = span1->x;
-            int xb2 = span2->x;
-            int xe1 = xb1 + abs((int)span1->len) - 1;
-            int xe2 = xb2 + abs((int)span2->len) - 1;
-
-            // Determine what spans we should advance in the next step
-            // The span with the least ending X should be advanced
-            // advance_both is just an optimization when we ending 
-            // coordinates are the same and we can advance both
-            //--------------
-            bool advance_span1 = xe1 <  xe2;
-            bool advance_both  = xe1 == xe2;
-
-            // Find the intersection of the spans
-            // and check if they intersect
-            //--------------
-            if(xb1 < xb2) xb1 = xb2;
-            if(xe1 > xe2) xe1 = xe2;
-            if(xb1 <= xe1)
-            {
-                combine_spans(span1, span2, xb1, xe1 - xb1 + 1, sl);
-            }
-
-            // Advance the spans
-            //--------------
-            if(advance_both)
-            {
-                --num1;
-                --num2;
-                if(num1) ++span1;
-                if(num2) ++span2;
-            }
-            else
-            {
-                if(advance_span1)
-                {
-                    --num1;
-                    if(num1) ++span1;
-                }
-                else
-                {
-                    --num2;
-                    if(num2) ++span2;
-                }
-            }
-        }
-    }
-
-
-
-
-
-
-
-
-    //------------------------------------------------sbool_intersect_shapes
-    // Intersect the scanline shapes. Here the "Scanline Generator" 
-    // abstraction is used. ScanlineGen1 and ScanlineGen2 are 
-    // the generators, and can be of type rasterizer_scanline_aa<>.
-    // There function requires three scanline containers that can be of
-    // different types.
-    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
-    // "sl" is ised as the resulting scanline to render it.
-    // The external "sl1" and "sl2" are used only for the sake of
-    // optimization and reusing of the scanline objects.
-    // the function calls sbool_intersect_scanlines with CombineSpansFunctor 
-    // as the last argument. See sbool_intersect_scanlines for details.
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer,
-             class CombineSpansFunctor>
-    void sbool_intersect_shapes(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                Scanline1& sl1, Scanline2& sl2,
-                                Scanline& sl, Renderer& ren, 
-                                CombineSpansFunctor combine_spans)
-    {
-        // Prepare the scanline generators.
-        // If anyone of them doesn't contain 
-        // any scanlines, then return.
-        //-----------------
-        if(!sg1.rewind_scanlines()) return;
-        if(!sg2.rewind_scanlines()) return;
-
-        // Get the bounding boxes
-        //----------------
-        rect_i r1(sg1.min_x(), sg1.min_y(), sg1.max_x(), sg1.max_y());
-        rect_i r2(sg2.min_x(), sg2.min_y(), sg2.max_x(), sg2.max_y());
-
-        // Calculate the intersection of the bounding 
-        // boxes and return if they don't intersect.
-        //-----------------
-        rect_i ir = intersect_rectangles(r1, r2);
-        if(!ir.is_valid()) return;
-
-        // Reset the scanlines and get two first ones
-        //-----------------
-        sl.reset(ir.x1, ir.x2);
-        sl1.reset(sg1.min_x(), sg1.max_x());
-        sl2.reset(sg2.min_x(), sg2.max_x());
-        if(!sg1.sweep_scanline(sl1)) return;
-        if(!sg2.sweep_scanline(sl2)) return;
-
-        ren.prepare();
-
-        // The main loop
-        // Here we synchronize the scanlines with 
-        // the same Y coordinate, ignoring all other ones.
-        // Only scanlines having the same Y-coordinate 
-        // are to be combined.
-        //-----------------
-        for(;;)
-        {
-            while(sl1.y() < sl2.y())
-            {
-                if(!sg1.sweep_scanline(sl1)) return;
-            }
-            while(sl2.y() < sl1.y())
-            {
-                if(!sg2.sweep_scanline(sl2)) return;
-            }
-
-            if(sl1.y() == sl2.y())
-            {
-                // The Y coordinates are the same.
-                // Combine the scanlines, render if they contain any spans,
-                // and advance both generators to the next scanlines
-                //----------------------
-                sbool_intersect_scanlines(sl1, sl2, sl, combine_spans);
-                if(sl.num_spans())
-                {
-                    sl.finalize(sl1.y());
-                    ren.render(sl);
-                }
-                if(!sg1.sweep_scanline(sl1)) return;
-                if(!sg2.sweep_scanline(sl2)) return;
-            }
-        }
-    }
-
-
-
-
-
-
-
-    //-------------------------------------------------sbool_unite_scanlines
-    // Unite two scanlines, "sl1" and "sl2" and generate a new "sl" one.
-    // The combine_spans functor can be of type sbool_combine_spans_bin or
-    // sbool_intersect_spans_aa. First is a general functor to combine
-    // two spans without Anti-Aliasing, the second preserves the AA
-    // information, but works slower
-    //
-    template<class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class AddSpanFunctor1,
-             class AddSpanFunctor2,
-             class CombineSpansFunctor>
-    void sbool_unite_scanlines(const Scanline1& sl1, 
-                               const Scanline2& sl2, 
-                               Scanline& sl, 
-                               AddSpanFunctor1 add_span1,
-                               AddSpanFunctor2 add_span2,
-                               CombineSpansFunctor combine_spans)
-    {
-        sl.reset_spans();
-
-        unsigned num1 = sl1.num_spans();
-        unsigned num2 = sl2.num_spans();
-
-        typename Scanline1::const_iterator span1 = NULL;// = sl1.begin();
-        typename Scanline2::const_iterator span2 = NULL;// = sl2.begin();
-
-        enum invalidation_e 
-        { 
-            invalid_b = 0xFFFFFFF, 
-            invalid_e = invalid_b - 1 
-        };
-
-        // Initialize the spans as invalid
-        //---------------
-        int xb1 = invalid_b;
-        int xb2 = invalid_b;
-        int xe1 = invalid_e;
-        int xe2 = invalid_e;
-
-        // Initialize span1 if there are spans
-        //---------------
-        if(num1)
-        {
-            span1 = sl1.begin();
-            xb1 = span1->x;
-            xe1 = xb1 + abs((int)span1->len) - 1;
-            --num1;
-        }
-
-        // Initialize span2 if there are spans
-        //---------------
-        if(num2)
-        {
-            span2 = sl2.begin();
-            xb2 = span2->x;
-            xe2 = xb2 + abs((int)span2->len) - 1;
-            --num2;
-        }
-
-
-        for(;;)
-        {
-            // Retrieve a new span1 if it's invalid
-            //----------------
-            if(num1 && xb1 > xe1) 
-            {
-                --num1;
-                ++span1;
-                xb1 = span1->x;
-                xe1 = xb1 + abs((int)span1->len) - 1;
-            }
-
-            // Retrieve a new span2 if it's invalid
-            //----------------
-            if(num2 && xb2 > xe2) 
-            {
-                --num2;
-                ++span2;
-                xb2 = span2->x;
-                xe2 = xb2 + abs((int)span2->len) - 1;
-            }
-
-            if(xb1 > xe1 && xb2 > xe2) break;
-
-            // Calculate the intersection
-            //----------------
-            int xb = xb1;
-            int xe = xe1;
-            if(xb < xb2) xb = xb2;
-            if(xe > xe2) xe = xe2;
-            int len = xe - xb + 1; // The length of the intersection
-            if(len > 0)
-            {
-                // The spans intersect,
-                // add the beginning of the span
-                //----------------
-                if(xb1 < xb2)
-                {
-                    add_span1(span1, xb1, xb2 - xb1, sl);
-                    xb1 = xb2;
-                }
-                else
-                if(xb2 < xb1)
-                {
-                    add_span2(span2, xb2, xb1 - xb2, sl);
-                    xb2 = xb1;
-                }
-
-                // Add the combination part of the spans
-                //----------------
-                combine_spans(span1, span2, xb, len, sl);
-
-
-                // Invalidate the fully processed span or both
-                //----------------
-                if(xe1 < xe2)
-                {
-                    // Invalidate span1 and eat
-                    // the processed part of span2
-                    //--------------
-                    xb1 = invalid_b;    
-                    xe1 = invalid_e;
-                    xb2 += len;
-                }
-                else
-                if(xe2 < xe1)
-                {
-                    // Invalidate span2 and eat
-                    // the processed part of span1
-                    //--------------
-                    xb2 = invalid_b;  
-                    xe2 = invalid_e;
-                    xb1 += len;
-                }
-                else
-                {
-                    xb1 = invalid_b;  // Invalidate both
-                    xb2 = invalid_b;
-                    xe1 = invalid_e;
-                    xe2 = invalid_e;
-                }
-            }
-            else
-            {
-                // The spans do not intersect
-                //--------------
-                if(xb1 < xb2) 
-                {
-                    // Advance span1
-                    //---------------
-                    if(xb1 <= xe1)
-                    {
-                        add_span1(span1, xb1, xe1 - xb1 + 1, sl);
-                    }
-                    xb1 = invalid_b; // Invalidate
-                    xe1 = invalid_e;
-                }
-                else
-                {
-                    // Advance span2
-                    //---------------
-                    if(xb2 <= xe2)
-                    {
-                        add_span2(span2, xb2, xe2 - xb2 + 1, sl);
-                    }
-                    xb2 = invalid_b; // Invalidate
-                    xe2 = invalid_e;
-                }
-            }
-        }
-    }
-
-
-
-
-    //----------------------------------------------------sbool_unite_shapes
-    // Unite the scanline shapes. Here the "Scanline Generator" 
-    // abstraction is used. ScanlineGen1 and ScanlineGen2 are 
-    // the generators, and can be of type rasterizer_scanline_aa<>.
-    // There function requires three scanline containers that can be 
-    // of different type.
-    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
-    // "sl" is ised as the resulting scanline to render it.
-    // The external "sl1" and "sl2" are used only for the sake of
-    // optimization and reusing of the scanline objects.
-    // the function calls sbool_unite_scanlines with CombineSpansFunctor 
-    // as the last argument. See sbool_unite_scanlines for details.
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer,
-             class AddSpanFunctor1,
-             class AddSpanFunctor2,
-             class CombineSpansFunctor>
-    void sbool_unite_shapes(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                            Scanline1& sl1, Scanline2& sl2,
-                            Scanline& sl, Renderer& ren, 
-                            AddSpanFunctor1 add_span1,
-                            AddSpanFunctor2 add_span2,
-                            CombineSpansFunctor combine_spans)
-    {
-        // Prepare the scanline generators.
-        // If anyone of them doesn't contain 
-        // any scanlines, then return.
-        //-----------------
-        bool flag1 = sg1.rewind_scanlines();
-        bool flag2 = sg2.rewind_scanlines();
-        if(!flag1 && !flag2) return;
-
-        // Get the bounding boxes
-        //----------------
-        rect_i r1(sg1.min_x(), sg1.min_y(), sg1.max_x(), sg1.max_y());
-        rect_i r2(sg2.min_x(), sg2.min_y(), sg2.max_x(), sg2.max_y());
-
-        // Calculate the union of the bounding boxes
-        //-----------------
-        rect_i ur(1,1,0,0);
-             if(flag1 && flag2) ur = unite_rectangles(r1, r2);
-        else if(flag1)          ur = r1;
-        else if(flag2)          ur = r2;
-
-        if(!ur.is_valid()) return;
-
-        ren.prepare();
-
-        // Reset the scanlines and get two first ones
-        //-----------------
-        sl.reset(ur.x1, ur.x2);
-        if(flag1) 
-        {
-            sl1.reset(sg1.min_x(), sg1.max_x());
-            flag1 = sg1.sweep_scanline(sl1);
-        }
-
-        if(flag2) 
-        {
-            sl2.reset(sg2.min_x(), sg2.max_x());
-            flag2 = sg2.sweep_scanline(sl2);
-        }
-
-        // The main loop
-        // Here we synchronize the scanlines with 
-        // the same Y coordinate.
-        //-----------------
-        while(flag1 || flag2)
-        {
-            if(flag1 && flag2)
-            {
-                if(sl1.y() == sl2.y())
-                {
-                    // The Y coordinates are the same.
-                    // Combine the scanlines, render if they contain any spans,
-                    // and advance both generators to the next scanlines
-                    //----------------------
-                    sbool_unite_scanlines(sl1, sl2, sl, 
-                                          add_span1, add_span2, combine_spans);
-                    if(sl.num_spans())
-                    {
-                        sl.finalize(sl1.y());
-                        ren.render(sl);
-                    }
-                    flag1 = sg1.sweep_scanline(sl1);
-                    flag2 = sg2.sweep_scanline(sl2);
-                }
-                else
-                {
-                    if(sl1.y() < sl2.y())
-                    {
-                        sbool_add_spans_and_render(sl1, sl, ren, add_span1);
-                        flag1 = sg1.sweep_scanline(sl1);
-                    }
-                    else
-                    {
-                        sbool_add_spans_and_render(sl2, sl, ren, add_span2);
-                        flag2 = sg2.sweep_scanline(sl2);
-                    }
-                }
-            }
-            else
-            {
-                if(flag1)
-                {
-                    sbool_add_spans_and_render(sl1, sl, ren, add_span1);
-                    flag1 = sg1.sweep_scanline(sl1);
-                }
-                if(flag2)
-                {
-                    sbool_add_spans_and_render(sl2, sl, ren, add_span2);
-                    flag2 = sg2.sweep_scanline(sl2);
-                }
-            }
-        }
-    }
-
-
-
-
-
-
-
-
-    //-------------------------------------------------sbool_subtract_shapes
-    // Subtract the scanline shapes, "sg1-sg2". Here the "Scanline Generator" 
-    // abstraction is used. ScanlineGen1 and ScanlineGen2 are 
-    // the generators, and can be of type rasterizer_scanline_aa<>.
-    // There function requires three scanline containers that can be of
-    // different types.
-    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
-    // "sl" is ised as the resulting scanline to render it.
-    // The external "sl1" and "sl2" are used only for the sake of
-    // optimization and reusing of the scanline objects.
-    // the function calls sbool_intersect_scanlines with CombineSpansFunctor 
-    // as the last argument. See combine_scanlines_sub for details.
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer,
-             class AddSpanFunctor1,
-             class CombineSpansFunctor>
-    void sbool_subtract_shapes(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                               Scanline1& sl1, Scanline2& sl2,
-                               Scanline& sl, Renderer& ren, 
-                               AddSpanFunctor1 add_span1,
-                               CombineSpansFunctor combine_spans)
-    {
-        // Prepare the scanline generators.
-        // Here "sg1" is master, "sg2" is slave.
-        //-----------------
-        if(!sg1.rewind_scanlines()) return;
-        bool flag2 = sg2.rewind_scanlines();
-
-        // Get the bounding box
-        //----------------
-        rect_i r1(sg1.min_x(), sg1.min_y(), sg1.max_x(), sg1.max_y());
-
-        // Reset the scanlines and get two first ones
-        //-----------------
-        sl.reset(sg1.min_x(), sg1.max_x());
-        sl1.reset(sg1.min_x(), sg1.max_x());
-        sl2.reset(sg2.min_x(), sg2.max_x());
-        if(!sg1.sweep_scanline(sl1)) return;
-
-        if(flag2) flag2 = sg2.sweep_scanline(sl2);
-
-        ren.prepare();
-
-        // A fake span2 processor
-        sbool_add_span_empty<Scanline2, Scanline> add_span2;
-
-        // The main loop
-        // Here we synchronize the scanlines with 
-        // the same Y coordinate, ignoring all other ones.
-        // Only scanlines having the same Y-coordinate 
-        // are to be combined.
-        //-----------------
-        bool flag1 = true;
-        do
-        {
-            // Synchronize "slave" with "master"
-            //-----------------
-            while(flag2 && sl2.y() < sl1.y())
-            {
-                flag2 = sg2.sweep_scanline(sl2);
-            }
-
-
-            if(flag2 && sl2.y() == sl1.y())
-            {
-                // The Y coordinates are the same.
-                // Combine the scanlines and render if they contain any spans.
-                //----------------------
-                sbool_unite_scanlines(sl1, sl2, sl, add_span1, add_span2, combine_spans);
-                if(sl.num_spans())
-                {
-                    sl.finalize(sl1.y());
-                    ren.render(sl);
-                }
-            }
-            else
-            {
-                sbool_add_spans_and_render(sl1, sl, ren, add_span1);
-            }
-
-            // Advance the "master"
-            flag1 = sg1.sweep_scanline(sl1);
-        }
-        while(flag1);
-    }
-
-
-
-
-
-
-
-    //---------------------------------------------sbool_intersect_shapes_aa
-    // Intersect two anti-aliased scanline shapes. 
-    // Here the "Scanline Generator" abstraction is used. 
-    // ScanlineGen1 and ScanlineGen2 are the generators, and can be of 
-    // type rasterizer_scanline_aa<>. There function requires three 
-    // scanline containers that can be of different types.
-    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
-    // "sl" is ised as the resulting scanline to render it.
-    // The external "sl1" and "sl2" are used only for the sake of
-    // optimization and reusing of the scanline objects.
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_intersect_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                   Scanline1& sl1, Scanline2& sl2,
-                                   Scanline& sl, Renderer& ren)
-    {
-        sbool_intersect_spans_aa<Scanline1, Scanline2, Scanline> combine_functor;
-        sbool_intersect_shapes(sg1, sg2, sl1, sl2, sl, ren, combine_functor);
-    }
-
-
-
-
-
-    //--------------------------------------------sbool_intersect_shapes_bin
-    // Intersect two binary scanline shapes (without anti-aliasing). 
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_intersect_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                    Scanline1& sl1, Scanline2& sl2,
-                                    Scanline& sl, Renderer& ren)
-    {
-        sbool_combine_spans_bin<Scanline1, Scanline2, Scanline> combine_functor;
-        sbool_intersect_shapes(sg1, sg2, sl1, sl2, sl, ren, combine_functor);
-    }
-
-
-
-
-
-    //-------------------------------------------------sbool_unite_shapes_aa
-    // Unite two anti-aliased scanline shapes 
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_unite_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                               Scanline1& sl1, Scanline2& sl2,
-                               Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
-        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
-        sbool_unite_spans_aa<Scanline1, Scanline2, Scanline> combine_functor;
-        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                           add_functor1, add_functor2, combine_functor);
-    }
-
-
-
-
-
-    //------------------------------------------------sbool_unite_shapes_bin
-    // Unite two binary scanline shapes (without anti-aliasing). 
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_unite_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                Scanline1& sl1, Scanline2& sl2,
-                                Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_bin<Scanline1, Scanline> add_functor1;
-        sbool_add_span_bin<Scanline2, Scanline> add_functor2;
-        sbool_combine_spans_bin<Scanline1, Scanline2, Scanline> combine_functor;
-        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                           add_functor1, add_functor2, combine_functor);
-    }
-
-
-
-
-
-
-
-
-
-    //---------------------------------------------------sbool_xor_shapes_aa
-    // Apply eXclusive OR to two anti-aliased scanline shapes. There's 
-    // a modified "Linear" XOR used instead of classical "Saddle" one.
-    // The reason is to have the result absolutely conststent with what
-    // the scanline rasterizer produces.
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_xor_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                             Scanline1& sl1, Scanline2& sl2,
-                             Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
-        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
-        sbool_xor_spans_aa<Scanline1, Scanline2, Scanline, 
-                           sbool_xor_formula_linear<> > combine_functor;
-        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                           add_functor1, add_functor2, combine_functor);
-    }
-
-
-
-    //------------------------------------------sbool_xor_shapes_saddle_aa
-    // Apply eXclusive OR to two anti-aliased scanline shapes. 
-    // There's the classical "Saddle" used to calculate the 
-    // Anti-Aliasing values, that is:
-    // a XOR b : 1-((1-a+a*b)*(1-b+a*b))
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_xor_shapes_saddle_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                    Scanline1& sl1, Scanline2& sl2,
-                                    Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
-        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
-        sbool_xor_spans_aa<Scanline1, 
-                           Scanline2, 
-                           Scanline, 
-                           sbool_xor_formula_saddle<> > combine_functor;
-        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                           add_functor1, add_functor2, combine_functor);
-    }
-
-
-    //--------------------------------------sbool_xor_shapes_abs_diff_aa
-    // Apply eXclusive OR to two anti-aliased scanline shapes. 
-    // There's the absolute difference used to calculate 
-    // Anti-Aliasing values, that is:
-    // a XOR b : abs(a-b)
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_xor_shapes_abs_diff_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                      Scanline1& sl1, Scanline2& sl2,
-                                      Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
-        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
-        sbool_xor_spans_aa<Scanline1, 
-                           Scanline2, 
-                           Scanline, 
-                           sbool_xor_formula_abs_diff> combine_functor;
-        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                           add_functor1, add_functor2, combine_functor);
-    }
-
-
-
-    //--------------------------------------------------sbool_xor_shapes_bin
-    // Apply eXclusive OR to two binary scanline shapes (without anti-aliasing). 
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_xor_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                              Scanline1& sl1, Scanline2& sl2,
-                              Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_bin<Scanline1, Scanline> add_functor1;
-        sbool_add_span_bin<Scanline2, Scanline> add_functor2;
-        sbool_combine_spans_empty<Scanline1, Scanline2, Scanline> combine_functor;
-        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                           add_functor1, add_functor2, combine_functor);
-    }
-
-
-
-
-
-
-    //----------------------------------------------sbool_subtract_shapes_aa
-    // Subtract shapes "sg1-sg2" with anti-aliasing
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_subtract_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                  Scanline1& sl1, Scanline2& sl2,
-                                  Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_aa<Scanline1, Scanline> add_functor;
-        sbool_subtract_spans_aa<Scanline1, Scanline2, Scanline> combine_functor;
-        sbool_subtract_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                              add_functor, combine_functor);
-    }
-
-
-
-
-
-    //---------------------------------------------sbool_subtract_shapes_bin
-    // Subtract binary shapes "sg1-sg2" without anti-aliasing
-    // See intersect_shapes_aa for more comments
-    //----------
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_subtract_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                   Scanline1& sl1, Scanline2& sl2,
-                                   Scanline& sl, Renderer& ren)
-    {
-        sbool_add_span_bin<Scanline1, Scanline> add_functor;
-        sbool_combine_spans_empty<Scanline1, Scanline2, Scanline> combine_functor;
-        sbool_subtract_shapes(sg1, sg2, sl1, sl2, sl, ren, 
-                              add_functor, combine_functor);
-    }
-
-
-
-
-
-
-    //------------------------------------------------------------sbool_op_e
-    enum sbool_op_e
-    {
-        sbool_or,            //----sbool_or
-        sbool_and,           //----sbool_and
-        sbool_xor,           //----sbool_xor
-        sbool_xor_saddle,    //----sbool_xor_saddle
-        sbool_xor_abs_diff,  //----sbool_xor_abs_diff
-        sbool_a_minus_b,     //----sbool_a_minus_b
-        sbool_b_minus_a      //----sbool_b_minus_a
-    };
-
-
-
-
-
-
-    //----------------------------------------------sbool_combine_shapes_bin
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_combine_shapes_bin(sbool_op_e op,
-                                  ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                  Scanline1& sl1, Scanline2& sl2,
-                                  Scanline& sl, Renderer& ren)
-    {
-        switch(op)
-        {
-        case sbool_or          : sbool_unite_shapes_bin    (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_and         : sbool_intersect_shapes_bin(sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_xor         :
-        case sbool_xor_saddle  : 
-        case sbool_xor_abs_diff: sbool_xor_shapes_bin      (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_a_minus_b   : sbool_subtract_shapes_bin (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_b_minus_a   : sbool_subtract_shapes_bin (sg2, sg1, sl2, sl1, sl, ren); break;
-        }
-    }
-
-
-
-
-    //-----------------------------------------------sbool_combine_shapes_aa
-    template<class ScanlineGen1, 
-             class ScanlineGen2, 
-             class Scanline1, 
-             class Scanline2, 
-             class Scanline, 
-             class Renderer>
-    void sbool_combine_shapes_aa(sbool_op_e op,
-                                 ScanlineGen1& sg1, ScanlineGen2& sg2,
-                                 Scanline1& sl1, Scanline2& sl2,
-                                 Scanline& sl, Renderer& ren)
-    {
-        switch(op)
-        {
-        case sbool_or          : sbool_unite_shapes_aa       (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_and         : sbool_intersect_shapes_aa   (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_xor         : sbool_xor_shapes_aa         (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_xor_saddle  : sbool_xor_shapes_saddle_aa  (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_xor_abs_diff: sbool_xor_shapes_abs_diff_aa(sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_a_minus_b   : sbool_subtract_shapes_aa    (sg1, sg2, sl1, sl2, sl, ren); break;
-        case sbool_b_minus_a   : sbool_subtract_shapes_aa    (sg2, sg1, sl2, sl1, sl, ren); break;
-        }
-    }
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_scanline_p.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_p.h
--- 8.0.1-5/renderers/agg/include/agg_scanline_p.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_p.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,329 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Class scanline_p - a general purpose scanline container with packed spans.
-//
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates (scanline32_p) has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-#ifndef AGG_SCANLINE_P_INCLUDED
-#define AGG_SCANLINE_P_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-
-    //=============================================================scanline_p8
-    // 
-    // This is a general purpose scaline container which supports the interface 
-    // used in the rasterizer::render(). See description of scanline_u8
-    // for details.
-    // 
-    //------------------------------------------------------------------------
-    class scanline_p8
-    {
-    public:
-        typedef scanline_p8 self_type;
-        typedef int8u       cover_type;
-        typedef int16       coord_type;
-
-        //--------------------------------------------------------------------
-        struct span
-        {
-            coord_type        x;
-            coord_type        len; // If negative, it's a solid span, covers is valid
-            const cover_type* covers;
-        };
-
-        typedef span* iterator;
-        typedef const span* const_iterator;
-
-        scanline_p8() :
-            m_last_x(0x7FFFFFF0),
-            m_covers(),
-            m_cover_ptr(0),
-            m_spans(),
-            m_cur_span(0)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        void reset(int min_x, int max_x)
-        {
-            unsigned max_len = max_x - min_x + 3;
-            if(max_len > m_spans.size())
-            {
-                m_spans.resize(max_len);
-                m_covers.resize(max_len);
-            }
-            m_last_x    = 0x7FFFFFF0;
-            m_cover_ptr = &m_covers[0];
-            m_cur_span  = &m_spans[0];
-            m_cur_span->len = 0;
-        }
-
-        //--------------------------------------------------------------------
-        void add_cell(int x, unsigned cover)
-        {
-            *m_cover_ptr = (cover_type)cover;
-            if(x == m_last_x+1 && m_cur_span->len > 0)
-            {
-                m_cur_span->len++;
-            }
-            else
-            {
-                m_cur_span++;
-                m_cur_span->covers = m_cover_ptr;
-                m_cur_span->x = (int16)x;
-                m_cur_span->len = 1;
-            }
-            m_last_x = x;
-            m_cover_ptr++;
-        }
-
-        //--------------------------------------------------------------------
-        void add_cells(int x, unsigned len, const cover_type* covers)
-        {
-            memcpy(m_cover_ptr, covers, len * sizeof(cover_type));
-            if(x == m_last_x+1 && m_cur_span->len > 0)
-            {
-                m_cur_span->len += (int16)len;
-            }
-            else
-            {
-                m_cur_span++;
-                m_cur_span->covers = m_cover_ptr;
-                m_cur_span->x = (int16)x;
-                m_cur_span->len = (int16)len;
-            }
-            m_cover_ptr += len;
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void add_span(int x, unsigned len, unsigned cover)
-        {
-            if(x == m_last_x+1 && 
-               m_cur_span->len < 0 && 
-               cover == *m_cur_span->covers)
-            {
-                m_cur_span->len -= (int16)len;
-            }
-            else
-            {
-                *m_cover_ptr = (cover_type)cover;
-                m_cur_span++;
-                m_cur_span->covers = m_cover_ptr++;
-                m_cur_span->x      = (int16)x;
-                m_cur_span->len    = (int16)(-int(len));
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void finalize(int y) 
-        { 
-            m_y = y; 
-        }
-
-        //--------------------------------------------------------------------
-        void reset_spans()
-        {
-            m_last_x    = 0x7FFFFFF0;
-            m_cover_ptr = &m_covers[0];
-            m_cur_span  = &m_spans[0];
-            m_cur_span->len = 0;
-        }
-
-        //--------------------------------------------------------------------
-        int            y()         const { return m_y; }
-        unsigned       num_spans() const { return unsigned(m_cur_span - &m_spans[0]); }
-        const_iterator begin()     const { return &m_spans[1]; }
-
-    private:
-        scanline_p8(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        int                   m_last_x;
-        int                   m_y = 0;
-        pod_array<cover_type> m_covers;
-        cover_type*           m_cover_ptr;
-        pod_array<span>       m_spans;
-        span*                 m_cur_span;
-    };
-
-
-
-
-
-
-
-
-    //==========================================================scanline32_p8
-    class scanline32_p8
-    {
-    public:
-        typedef scanline32_p8 self_type;
-        typedef int8u         cover_type;
-        typedef int32         coord_type;
-
-        struct span
-        {
-            span() {}
-            span(coord_type x_, coord_type len_, const cover_type* covers_) :
-                x(x_), len(len_), covers(covers_) {}
-
-            coord_type x;
-            coord_type len; // If negative, it's a solid span, covers is valid
-            const cover_type* covers;
-        };
-        typedef pod_bvector<span, 4> span_array_type;
-
-
-        //--------------------------------------------------------------------
-        class const_iterator
-        {
-        public:
-            const_iterator(const span_array_type& spans) :
-                m_spans(spans),
-                m_span_idx(0)
-            {}
-
-            const span& operator*()  const { return m_spans[m_span_idx];  }
-            const span* operator->() const { return &m_spans[m_span_idx]; }
-
-            void operator ++ () { ++m_span_idx; }
-
-        private:
-            const span_array_type& m_spans;
-            unsigned               m_span_idx;
-        };
-
-        //--------------------------------------------------------------------
-        scanline32_p8() :
-            m_max_len(0),
-            m_last_x(0x7FFFFFF0),
-            m_covers(),
-            m_cover_ptr(0)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        void reset(int min_x, int max_x)
-        {
-            unsigned max_len = max_x - min_x + 3;
-            if(max_len > m_covers.size())
-            {
-                m_covers.resize(max_len);
-            }
-            m_last_x    = 0x7FFFFFF0;
-            m_cover_ptr = &m_covers[0];
-            m_spans.remove_all();
-        }
-
-        //--------------------------------------------------------------------
-        void add_cell(int x, unsigned cover)
-        {
-            *m_cover_ptr = cover_type(cover);
-            if(x == m_last_x+1 && m_spans.size() && m_spans.last().len > 0)
-            {
-                m_spans.last().len++;
-            }
-            else
-            {
-                m_spans.add(span(coord_type(x), 1, m_cover_ptr));
-            }
-            m_last_x = x;
-            m_cover_ptr++;
-        }
-
-        //--------------------------------------------------------------------
-        void add_cells(int x, unsigned len, const cover_type* covers)
-        {
-            memcpy(m_cover_ptr, covers, len * sizeof(cover_type));
-            if(x == m_last_x+1 && m_spans.size() && m_spans.last().len > 0)
-            {
-                m_spans.last().len += coord_type(len);
-            }
-            else
-            {
-                m_spans.add(span(coord_type(x), coord_type(len), m_cover_ptr));
-            }
-            m_cover_ptr += len;
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void add_span(int x, unsigned len, unsigned cover)
-        {
-            if(x == m_last_x+1 && 
-               m_spans.size() &&
-               m_spans.last().len < 0 && 
-               cover == *m_spans.last().covers)
-            {
-                m_spans.last().len -= coord_type(len);
-            }
-            else
-            {
-                *m_cover_ptr = cover_type(cover);
-                m_spans.add(span(coord_type(x), -coord_type(len), m_cover_ptr++));
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void finalize(int y) 
-        { 
-            m_y = y; 
-        }
-
-        //--------------------------------------------------------------------
-        void reset_spans()
-        {
-            m_last_x    = 0x7FFFFFF0;
-            m_cover_ptr = &m_covers[0];
-            m_spans.remove_all();
-        }
-
-        //--------------------------------------------------------------------
-        int            y()         const { return m_y; }
-        unsigned       num_spans() const { return m_spans.size(); }
-        const_iterator begin()     const { return const_iterator(m_spans); }
-
-    private:
-        scanline32_p8(const self_type&);
-        const self_type& operator = (const self_type&);
-
-        unsigned              m_max_len;
-        int                   m_last_x;
-        int                   m_y;
-        pod_array<cover_type> m_covers;
-        cover_type*           m_cover_ptr;
-        span_array_type       m_spans;
-    };
-
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_scanline_storage_aa.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_storage_aa.h
--- 8.0.1-5/renderers/agg/include/agg_scanline_storage_aa.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_storage_aa.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,815 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SCANLINE_STORAGE_AA_INCLUDED
-#define AGG_SCANLINE_STORAGE_AA_INCLUDED
-
-#include <string.h>
-#include <stdlib.h>
-#include <math.h>
-#include "agg_array.h"
-
-
-namespace mapserver
-{
-
-    //----------------------------------------------scanline_cell_storage
-    template<class T> class scanline_cell_storage
-    {
-        struct extra_span
-        {
-            unsigned len;
-            T*       ptr;
-        };
-
-    public:
-        typedef T value_type;
-
-        //---------------------------------------------------------------
-        ~scanline_cell_storage()
-        {
-            remove_all();
-        }
-
-        //---------------------------------------------------------------
-        scanline_cell_storage() :
-            m_cells(128-2),
-            m_extra_storage()
-        {}
-
-
-        // Copying
-        //---------------------------------------------------------------
-        scanline_cell_storage(const scanline_cell_storage<T>& v) :
-            m_cells(v.m_cells),
-            m_extra_storage()
-        {
-            copy_extra_storage(v);
-        }
-
-        //---------------------------------------------------------------
-        const scanline_cell_storage<T>& 
-        operator = (const scanline_cell_storage<T>& v)
-        {
-            remove_all();
-            m_cells = v.m_cells;
-            copy_extra_storage(v);
-            return *this;
-        }
-
-        //---------------------------------------------------------------
-        void remove_all()
-        {
-            int i;
-            for(i = m_extra_storage.size()-1; i >= 0; --i)
-            {
-                pod_allocator<T>::deallocate(m_extra_storage[i].ptr,
-                                             m_extra_storage[i].len);
-            }
-            m_extra_storage.remove_all();
-            m_cells.remove_all();
-        }
-
-        //---------------------------------------------------------------
-        int add_cells(const T* cells, unsigned num_cells)
-        {
-            int idx = m_cells.allocate_continuous_block(num_cells);
-            if(idx >= 0)
-            {
-                T* ptr = &m_cells[idx];
-                memcpy(ptr, cells, sizeof(T) * num_cells);
-                return idx;
-            }
-            extra_span s;
-            s.len = num_cells;
-            s.ptr = pod_allocator<T>::allocate(num_cells);
-            memcpy(s.ptr, cells, sizeof(T) * num_cells);
-            m_extra_storage.add(s);
-            return -int(m_extra_storage.size());
-        }
-
-        //---------------------------------------------------------------
-        const T* operator [] (int idx) const
-        {
-            if(idx >= 0)
-            {
-                if((unsigned)idx >= m_cells.size()) return 0;
-                return &m_cells[(unsigned)idx];
-            }
-            unsigned i = unsigned(-idx - 1);
-            if(i >= m_extra_storage.size()) return 0;
-            return m_extra_storage[i].ptr;
-        }
-
-        //---------------------------------------------------------------
-        T* operator [] (int idx)
-        {
-            if(idx >= 0)
-            {
-                if((unsigned)idx >= m_cells.size()) return 0;
-                return &m_cells[(unsigned)idx];
-            }
-            unsigned i = unsigned(-idx - 1);
-            if(i >= m_extra_storage.size()) return 0;
-            return m_extra_storage[i].ptr;
-        }
-
-    private:
-        void copy_extra_storage(const scanline_cell_storage<T>& v)
-        {
-            unsigned i;
-            for(i = 0; i < v.m_extra_storage.size(); ++i)
-            {
-                const extra_span& src = v.m_extra_storage[i];
-                extra_span dst;
-                dst.len = src.len;
-                dst.ptr = pod_allocator<T>::allocate(dst.len);
-                memcpy(dst.ptr, src.ptr, dst.len * sizeof(T));
-                m_extra_storage.add(dst);
-            }
-        }
-
-        pod_bvector<T, 12>         m_cells;
-        pod_bvector<extra_span, 6> m_extra_storage;
-    };
-
-
-
-
-
-
-    //-----------------------------------------------scanline_storage_aa
-    template<class T> class scanline_storage_aa
-    {
-    public:
-        typedef T cover_type;
-
-        //---------------------------------------------------------------
-        struct span_data
-        {
-            int32 x;
-            int32 len;       // If negative, it's a solid span, covers is valid
-            int   covers_id; // The index of the cells in the scanline_cell_storage
-        };
-
-        //---------------------------------------------------------------
-        struct scanline_data
-        {
-            int      y;
-            unsigned num_spans;
-            unsigned start_span;
-        };
-
-
-        //---------------------------------------------------------------
-        class embedded_scanline
-        {
-        public:
-
-            //-----------------------------------------------------------
-            class const_iterator
-            {
-            public:
-                struct span
-                {
-                    int32    x;
-                    int32    len; // If negative, it's a solid span, covers is valid
-                    const T* covers;
-                };
-
-                const_iterator() : m_storage(0) {}
-                const_iterator(const embedded_scanline& sl) :
-                    m_storage(sl.m_storage),
-                    m_span_idx(sl.m_scanline.start_span)
-                {
-                    init_span();
-                }
-
-                const span& operator*()  const { return m_span;  }
-                const span* operator->() const { return &m_span; }
-
-                void operator ++ ()
-                {
-                    ++m_span_idx;
-                    init_span();
-                }
-
-            private:
-                void init_span()
-                {
-                    const span_data& s = m_storage->span_by_index(m_span_idx);
-                    m_span.x      = s.x;
-                    m_span.len    = s.len;
-                    m_span.covers = m_storage->covers_by_index(s.covers_id);
-                }
-
-                const scanline_storage_aa* m_storage;
-                unsigned                   m_span_idx;
-                span                       m_span;
-            };
-
-            friend class const_iterator;
-
-
-            //-----------------------------------------------------------
-            embedded_scanline(const scanline_storage_aa& storage) :
-                m_storage(&storage)
-            {
-                init(0);
-            }
-
-            //-----------------------------------------------------------
-            void     reset(int, int)     {}
-            unsigned num_spans()   const { return m_scanline.num_spans;  }
-            int      y()           const { return m_scanline.y;          }
-            const_iterator begin() const { return const_iterator(*this); }
-
-            //-----------------------------------------------------------
-            void init(unsigned scanline_idx)
-            {
-                m_scanline_idx = scanline_idx;
-                m_scanline = m_storage->scanline_by_index(m_scanline_idx);
-            }
-
-        private:
-            const scanline_storage_aa* m_storage;
-            scanline_data              m_scanline;
-            unsigned                   m_scanline_idx;
-        };
-
-
-        //---------------------------------------------------------------
-        scanline_storage_aa() :
-            m_covers(),
-            m_spans(256-2),         // Block increment size
-            m_scanlines(),
-            m_min_x( 0x7FFFFFFF),
-            m_min_y( 0x7FFFFFFF),
-            m_max_x(-0x7FFFFFFF),
-            m_max_y(-0x7FFFFFFF),
-            m_cur_scanline(0)
-        {
-            m_fake_scanline.y = 0;
-            m_fake_scanline.num_spans = 0;
-            m_fake_scanline.start_span = 0;
-            m_fake_span.x = 0;
-            m_fake_span.len = 0;
-            m_fake_span.covers_id = 0;
-        }
-
-        // Renderer Interface
-        //---------------------------------------------------------------
-        void prepare()
-        {
-            m_covers.remove_all();
-            m_scanlines.remove_all();
-            m_spans.remove_all();
-            m_min_x =  0x7FFFFFFF;
-            m_min_y =  0x7FFFFFFF;
-            m_max_x = -0x7FFFFFFF;
-            m_max_y = -0x7FFFFFFF;
-            m_cur_scanline = 0;
-        }
-
-        //---------------------------------------------------------------
-        template<class Scanline> void render(const Scanline& sl)
-        {
-            scanline_data sl_this;
-
-            int y = sl.y();
-            if(y < m_min_y) m_min_y = y;
-            if(y > m_max_y) m_max_y = y;
-
-            sl_this.y = y;
-            sl_this.num_spans = sl.num_spans();
-            sl_this.start_span = m_spans.size();
-            typename Scanline::const_iterator span_iterator = sl.begin();
-
-            unsigned num_spans = sl_this.num_spans;
-            for(;;)
-            {
-                span_data sp;
-
-                sp.x         = span_iterator->x;
-                sp.len       = span_iterator->len;
-                int len      = abs(int(sp.len));
-                sp.covers_id = 
-                    m_covers.add_cells(span_iterator->covers, 
-                                       unsigned(len));
-                m_spans.add(sp);
-                int x1 = sp.x;
-                int x2 = sp.x + len - 1;
-                if(x1 < m_min_x) m_min_x = x1;
-                if(x2 > m_max_x) m_max_x = x2;
-                if(--num_spans == 0) break;
-                ++span_iterator;
-            }
-            m_scanlines.add(sl_this);
-        }
-
-
-        //---------------------------------------------------------------
-        // Iterate scanlines interface
-        int min_x() const { return m_min_x; }
-        int min_y() const { return m_min_y; }
-        int max_x() const { return m_max_x; }
-        int max_y() const { return m_max_y; }
-
-        //---------------------------------------------------------------
-        bool rewind_scanlines()
-        {
-            m_cur_scanline = 0;
-            return m_scanlines.size() > 0;
-        }
-
-
-        //---------------------------------------------------------------
-        template<class Scanline> bool sweep_scanline(Scanline& sl)
-        {
-            sl.reset_spans();
-            for(;;)
-            {
-                if(m_cur_scanline >= m_scanlines.size()) return false;
-                const scanline_data& sl_this = m_scanlines[m_cur_scanline];
-
-                unsigned num_spans = sl_this.num_spans;
-                unsigned span_idx  = sl_this.start_span;
-                do
-                {
-                    const span_data& sp = m_spans[span_idx++];
-                    const T* covers = covers_by_index(sp.covers_id);
-                    if(sp.len < 0)
-                    {
-                        sl.add_span(sp.x, unsigned(-sp.len), *covers);
-                    }
-                    else
-                    {
-                        sl.add_cells(sp.x, sp.len, covers);
-                    }
-                }
-                while(--num_spans);
-                ++m_cur_scanline;
-                if(sl.num_spans())
-                {
-                    sl.finalize(sl_this.y);
-                    break;
-                }
-            }
-            return true;
-        }
-
-
-        //---------------------------------------------------------------
-        // Specialization for embedded_scanline
-        bool sweep_scanline(embedded_scanline& sl)
-        {
-            do
-            {
-                if(m_cur_scanline >= m_scanlines.size()) return false;
-                sl.init(m_cur_scanline);
-                ++m_cur_scanline;
-            }
-            while(sl.num_spans() == 0);
-            return true;
-        }
-
-        //---------------------------------------------------------------
-        unsigned byte_size() const
-        {
-            unsigned i;
-            unsigned size = sizeof(int32) * 4; // min_x, min_y, max_x, max_y
-
-            for(i = 0; i < m_scanlines.size(); ++i)
-            {
-                size += sizeof(int32) * 3; // scanline size in bytes, Y, num_spans
-
-                const scanline_data& sl_this = m_scanlines[i];
-
-                unsigned num_spans = sl_this.num_spans;
-                unsigned span_idx  = sl_this.start_span;
-                do
-                {
-                    const span_data& sp = m_spans[span_idx++];
-
-                    size += sizeof(int32) * 2;                // X, span_len
-                    if(sp.len < 0)
-                    {
-                        size += sizeof(T);                    // cover
-                    }
-                    else
-                    {
-                        size += sizeof(T) * unsigned(sp.len); // covers
-                    }
-                }
-                while(--num_spans);
-            }
-            return size;
-        }
-
-
-        //---------------------------------------------------------------
-        static void write_int32(int8u* dst, int32 val)
-        {
-            dst[0] = ((const int8u*)&val)[0];
-            dst[1] = ((const int8u*)&val)[1];
-            dst[2] = ((const int8u*)&val)[2];
-            dst[3] = ((const int8u*)&val)[3];
-        }
-
-
-        //---------------------------------------------------------------
-        void serialize(int8u* data) const
-        {
-            unsigned i;
-
-            write_int32(data, min_x()); // min_x
-            data += sizeof(int32);
-            write_int32(data, min_y()); // min_y
-            data += sizeof(int32);
-            write_int32(data, max_x()); // max_x
-            data += sizeof(int32);
-            write_int32(data, max_y()); // max_y
-            data += sizeof(int32);
-
-            for(i = 0; i < m_scanlines.size(); ++i)
-            {
-                const scanline_data& sl_this = m_scanlines[i];
-                
-                int8u* size_ptr = data;
-                data += sizeof(int32);  // Reserve space for scanline size in bytes
-
-                write_int32(data, sl_this.y);            // Y
-                data += sizeof(int32);
-
-                write_int32(data, sl_this.num_spans);    // num_spans
-                data += sizeof(int32);
-
-                unsigned num_spans = sl_this.num_spans;
-                unsigned span_idx  = sl_this.start_span;
-                do
-                {
-                    const span_data& sp = m_spans[span_idx++];
-                    const T* covers = covers_by_index(sp.covers_id);
-
-                    write_int32(data, sp.x);            // X
-                    data += sizeof(int32);
-
-                    write_int32(data, sp.len);          // span_len
-                    data += sizeof(int32);
-
-                    if(sp.len < 0)
-                    {
-                        memcpy(data, covers, sizeof(T));
-                        data += sizeof(T);
-                    }
-                    else
-                    {
-                        memcpy(data, covers, unsigned(sp.len) * sizeof(T));
-                        data += sizeof(T) * unsigned(sp.len);
-                    }
-                }
-                while(--num_spans);
-                write_int32(size_ptr, int32(unsigned(data - size_ptr)));
-            }
-        }
-
-
-        //---------------------------------------------------------------
-        const scanline_data& scanline_by_index(unsigned i) const
-        {
-            return (i < m_scanlines.size()) ? m_scanlines[i] : m_fake_scanline;
-        }
-
-        //---------------------------------------------------------------
-        const span_data& span_by_index(unsigned i) const
-        {
-            return (i < m_spans.size()) ? m_spans[i] : m_fake_span;
-        }
-
-        //---------------------------------------------------------------
-        const T* covers_by_index(int i) const
-        {
-            return m_covers[i];
-        }
-
-    private:
-        scanline_cell_storage<T>      m_covers;
-        pod_bvector<span_data, 10>    m_spans;
-        pod_bvector<scanline_data, 8> m_scanlines;
-        span_data     m_fake_span;
-        scanline_data m_fake_scanline;
-        int           m_min_x;
-        int           m_min_y;
-        int           m_max_x;
-        int           m_max_y;
-        unsigned      m_cur_scanline;
-    };
-
-
-    typedef scanline_storage_aa<int8u>  scanline_storage_aa8;  //--------scanline_storage_aa8
-    typedef scanline_storage_aa<int16u> scanline_storage_aa16; //--------scanline_storage_aa16
-    typedef scanline_storage_aa<int32u> scanline_storage_aa32; //--------scanline_storage_aa32
-
-
-
-
-    //------------------------------------------serialized_scanlines_adaptor_aa
-    template<class T> class serialized_scanlines_adaptor_aa
-    {
-    public:
-        typedef T cover_type;
-
-        //---------------------------------------------------------------------
-        class embedded_scanline
-        {
-        public:
-            typedef T cover_type;
-
-            //-----------------------------------------------------------------
-            class const_iterator
-            {
-            public:
-                struct span
-                {
-                    int32    x;
-                    int32    len; // If negative, it's a solid span, "covers" is valid
-                    const T* covers; 
-                };
-
-                const_iterator() : m_ptr(0) {}
-                const_iterator(const embedded_scanline& sl) :
-                    m_ptr(sl.m_ptr),
-                    m_dx(sl.m_dx)
-                {
-                    init_span();
-                }
-
-                const span& operator*()  const { return m_span;  }
-                const span* operator->() const { return &m_span; }
-
-                void operator ++ ()
-                {
-                    if(m_span.len < 0) 
-                    {
-                        m_ptr += sizeof(T);
-                    }
-                    else 
-                    {
-                        m_ptr += m_span.len * sizeof(T);
-                    }
-                    init_span();
-                }
-
-            private:
-                int read_int32()
-                {
-                    int32 val;
-                    ((int8u*)&val)[0] = *m_ptr++;
-                    ((int8u*)&val)[1] = *m_ptr++;
-                    ((int8u*)&val)[2] = *m_ptr++;
-                    ((int8u*)&val)[3] = *m_ptr++;
-                    return val;
-                }
-
-                void init_span()
-                {
-                    m_span.x      = read_int32() + m_dx;
-                    m_span.len    = read_int32();
-                    m_span.covers = m_ptr;
-                }
-
-                const int8u* m_ptr;
-                span         m_span;
-                int          m_dx;
-            };
-
-            friend class const_iterator;
-
-
-            //-----------------------------------------------------------------
-            embedded_scanline() = default;
-
-            //-----------------------------------------------------------------
-            void     reset(int, int)     {}
-            unsigned num_spans()   const { return m_num_spans;  }
-            int      y()           const { return m_y;          }
-            const_iterator begin() const { return const_iterator(*this); }
-
-
-        private:
-            //-----------------------------------------------------------------
-            int read_int32()
-            {
-                int32 val;
-                ((int8u*)&val)[0] = *m_ptr++;
-                ((int8u*)&val)[1] = *m_ptr++;
-                ((int8u*)&val)[2] = *m_ptr++;
-                ((int8u*)&val)[3] = *m_ptr++;
-                return val;
-            }
-
-        public:
-            //-----------------------------------------------------------------
-            void init(const int8u* ptr, int dx, int dy)
-            {
-                m_ptr       = ptr;
-                m_y         = read_int32() + dy;
-                m_num_spans = unsigned(read_int32());
-                m_dx        = dx;
-            }
-
-        private:
-            const int8u* m_ptr = nullptr;
-            int          m_y = 0;
-            unsigned     m_num_spans = 0;
-            int          m_dx = 0;
-        };
-
-
-
-    public:
-        //--------------------------------------------------------------------
-        serialized_scanlines_adaptor_aa() :
-            m_data(0),
-            m_end(0),
-            m_ptr(0),
-            m_dx(0),
-            m_dy(0),
-            m_min_x(0x7FFFFFFF),
-            m_min_y(0x7FFFFFFF),
-            m_max_x(-0x7FFFFFFF),
-            m_max_y(-0x7FFFFFFF)
-        {}
-
-        //--------------------------------------------------------------------
-        serialized_scanlines_adaptor_aa(const int8u* data, unsigned size,
-                                        double dx, double dy) :
-            m_data(data),
-            m_end(data + size),
-            m_ptr(data),
-            m_dx(iround(dx)),
-            m_dy(iround(dy)),
-            m_min_x(0x7FFFFFFF),
-            m_min_y(0x7FFFFFFF),
-            m_max_x(-0x7FFFFFFF),
-            m_max_y(-0x7FFFFFFF)
-        {}
-
-        //--------------------------------------------------------------------
-        void init(const int8u* data, unsigned size, double dx, double dy)
-        {
-            m_data  = data;
-            m_end   = data + size;
-            m_ptr   = data;
-            m_dx    = iround(dx);
-            m_dy    = iround(dy);
-            m_min_x = 0x7FFFFFFF;
-            m_min_y = 0x7FFFFFFF;
-            m_max_x = -0x7FFFFFFF;
-            m_max_y = -0x7FFFFFFF;
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        int read_int32()
-        {
-            int32 val;
-            ((int8u*)&val)[0] = *m_ptr++;
-            ((int8u*)&val)[1] = *m_ptr++;
-            ((int8u*)&val)[2] = *m_ptr++;
-            ((int8u*)&val)[3] = *m_ptr++;
-            return val;
-        }
-
-        //--------------------------------------------------------------------
-        unsigned read_int32u()
-        {
-            int32u val;
-            ((int8u*)&val)[0] = *m_ptr++;
-            ((int8u*)&val)[1] = *m_ptr++;
-            ((int8u*)&val)[2] = *m_ptr++;
-            ((int8u*)&val)[3] = *m_ptr++;
-            return val;
-        }
-        
-    public:
-        // Iterate scanlines interface
-        //--------------------------------------------------------------------
-        bool rewind_scanlines()
-        {
-            m_ptr = m_data;
-            if(m_ptr < m_end)
-            {
-                m_min_x = read_int32() + m_dx; 
-                m_min_y = read_int32() + m_dy;
-                m_max_x = read_int32() + m_dx;
-                m_max_y = read_int32() + m_dy;
-            }
-            return m_ptr < m_end;
-        }
-
-        //--------------------------------------------------------------------
-        int min_x() const { return m_min_x; }
-        int min_y() const { return m_min_y; }
-        int max_x() const { return m_max_x; }
-        int max_y() const { return m_max_y; }
-
-        //--------------------------------------------------------------------
-        template<class Scanline> bool sweep_scanline(Scanline& sl)
-        {
-            sl.reset_spans();
-            for(;;)
-            {
-                if(m_ptr >= m_end) return false;
-
-                read_int32();      // Skip scanline size in bytes
-                int y = read_int32() + m_dy;
-                unsigned num_spans = read_int32();
-
-                do
-                {
-                    int x = read_int32() + m_dx;
-                    int len = read_int32();
-
-                    if(len < 0)
-                    {
-                        sl.add_span(x, unsigned(-len), *m_ptr);
-                        m_ptr += sizeof(T);
-                    }
-                    else
-                    {
-                        sl.add_cells(x, len, m_ptr);
-                        m_ptr += len * sizeof(T);
-                    }
-                }
-                while(--num_spans);
-
-                if(sl.num_spans())
-                {
-                    sl.finalize(y);
-                    break;
-                }
-            }
-            return true;
-        }
-
-
-        //--------------------------------------------------------------------
-        // Specialization for embedded_scanline
-        bool sweep_scanline(embedded_scanline& sl)
-        {
-            do
-            {
-                if(m_ptr >= m_end) return false;
-
-                unsigned byte_size = read_int32u();
-                sl.init(m_ptr, m_dx, m_dy);
-                m_ptr += byte_size - sizeof(int32);
-            }
-            while(sl.num_spans() == 0);
-            return true;
-        }
-
-    private:
-        const int8u* m_data;
-        const int8u* m_end;
-        const int8u* m_ptr;
-        int          m_dx;
-        int          m_dy;
-        int          m_min_x;
-        int          m_min_y;
-        int          m_max_x;
-        int          m_max_y;
-    };
-
-
-
-    typedef serialized_scanlines_adaptor_aa<int8u>  serialized_scanlines_adaptor_aa8;  //----serialized_scanlines_adaptor_aa8
-    typedef serialized_scanlines_adaptor_aa<int16u> serialized_scanlines_adaptor_aa16; //----serialized_scanlines_adaptor_aa16
-    typedef serialized_scanlines_adaptor_aa<int32u> serialized_scanlines_adaptor_aa32; //----serialized_scanlines_adaptor_aa32
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_scanline_storage_bin.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_storage_bin.h
--- 8.0.1-5/renderers/agg/include/agg_scanline_storage_bin.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_storage_bin.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,586 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-
-#ifndef AGG_SCANLINE_STORAGE_BIN_INCLUDED
-#define AGG_SCANLINE_STORAGE_BIN_INCLUDED
-
-#include <string.h>
-#include <stdlib.h>
-#include <math.h>
-#include "agg_array.h"
-
-
-namespace mapserver
-{
-
-    //-----------------------------------------------scanline_storage_bin
-    class scanline_storage_bin
-    {
-    public:
-        //---------------------------------------------------------------
-        struct span_data
-        {
-            int32 x;
-            int32 len;
-        };
-
-        //---------------------------------------------------------------
-        struct scanline_data
-        {
-            int      y;
-            unsigned num_spans;
-            unsigned start_span;
-        };
-
-
-        //---------------------------------------------------------------
-        class embedded_scanline
-        {
-        public:
-
-            //-----------------------------------------------------------
-            class const_iterator
-            {
-            public:
-                const_iterator() : m_storage(0) {}
-                const_iterator(const embedded_scanline& sl) :
-                    m_storage(sl.m_storage),
-                    m_span_idx(sl.m_scanline.start_span)
-                {
-                    m_span = m_storage->span_by_index(m_span_idx);
-                }
-
-                const span_data& operator*()  const { return m_span;  }
-                const span_data* operator->() const { return &m_span; }
-
-                void operator ++ ()
-                {
-                    ++m_span_idx;
-                    m_span = m_storage->span_by_index(m_span_idx);
-                }
-
-            private:
-                const scanline_storage_bin* m_storage;
-                unsigned                    m_span_idx;
-                span_data                   m_span;
-            };
-
-            friend class const_iterator;
-
-
-            //-----------------------------------------------------------
-            embedded_scanline(const scanline_storage_bin& storage) :
-                m_storage(&storage)
-            {
-                setup(0);
-            }
-
-            //-----------------------------------------------------------
-            void     reset(int, int)     {}
-            unsigned num_spans()   const { return m_scanline.num_spans;  }
-            int      y()           const { return m_scanline.y;          }
-            const_iterator begin() const { return const_iterator(*this); }
-
-            //-----------------------------------------------------------
-            void setup(unsigned scanline_idx)
-            {
-                m_scanline_idx = scanline_idx;
-                m_scanline = m_storage->scanline_by_index(m_scanline_idx);
-            }
-
-        private:
-            const scanline_storage_bin* m_storage;
-            scanline_data               m_scanline;
-            unsigned                    m_scanline_idx;
-        };
-
-
-        //---------------------------------------------------------------
-        scanline_storage_bin() :
-            m_spans(256-2),         // Block increment size
-            m_scanlines(),
-            m_min_x( 0x7FFFFFFF),
-            m_min_y( 0x7FFFFFFF),
-            m_max_x(-0x7FFFFFFF),
-            m_max_y(-0x7FFFFFFF),
-            m_cur_scanline(0)
-        {
-            m_fake_scanline.y = 0;
-            m_fake_scanline.num_spans = 0;
-            m_fake_scanline.start_span = 0;
-            m_fake_span.x = 0;
-            m_fake_span.len = 0;
-        }
-
-        // Renderer Interface
-        //---------------------------------------------------------------
-        void prepare()
-        {
-            m_scanlines.remove_all();
-            m_spans.remove_all();
-            m_min_x =  0x7FFFFFFF;
-            m_min_y =  0x7FFFFFFF;
-            m_max_x = -0x7FFFFFFF;
-            m_max_y = -0x7FFFFFFF;
-            m_cur_scanline = 0;
-        }
-
-        //---------------------------------------------------------------
-        template<class Scanline> void render(const Scanline& sl)
-        {
-            scanline_data sl_this;
-
-            int y = sl.y();
-            if(y < m_min_y) m_min_y = y;
-            if(y > m_max_y) m_max_y = y;
-
-            sl_this.y = y;
-            sl_this.num_spans = sl.num_spans();
-            sl_this.start_span = m_spans.size();
-            typename Scanline::const_iterator span_iterator = sl.begin();
-
-            unsigned num_spans = sl_this.num_spans;
-            for(;;)
-            {
-                span_data sp;
-                sp.x   = span_iterator->x;
-                sp.len = (int32)abs((int)(span_iterator->len));
-                m_spans.add(sp);
-                int x1 = sp.x;
-                int x2 = sp.x + sp.len - 1;
-                if(x1 < m_min_x) m_min_x = x1;
-                if(x2 > m_max_x) m_max_x = x2;
-                if(--num_spans == 0) break;
-                ++span_iterator;
-            }
-            m_scanlines.add(sl_this);
-        }
-
-
-        //---------------------------------------------------------------
-        // Iterate scanlines interface
-        int min_x() const { return m_min_x; }
-        int min_y() const { return m_min_y; }
-        int max_x() const { return m_max_x; }
-        int max_y() const { return m_max_y; }
-
-        //---------------------------------------------------------------
-        bool rewind_scanlines()
-        {
-            m_cur_scanline = 0;
-            return m_scanlines.size() > 0;
-        }
-
-
-        //---------------------------------------------------------------
-        template<class Scanline> bool sweep_scanline(Scanline& sl)
-        {
-            sl.reset_spans();
-            for(;;)
-            {
-                if(m_cur_scanline >= m_scanlines.size()) return false;
-                const scanline_data& sl_this = m_scanlines[m_cur_scanline];
-
-                unsigned num_spans = sl_this.num_spans;
-                unsigned span_idx  = sl_this.start_span;
-                do
-                {
-                    const span_data& sp = m_spans[span_idx++];
-                    sl.add_span(sp.x, sp.len, cover_full);
-                }
-                while(--num_spans);
-
-                ++m_cur_scanline;
-                if(sl.num_spans())
-                {
-                    sl.finalize(sl_this.y);
-                    break;
-                }
-            }
-            return true;
-        }
-
-
-        //---------------------------------------------------------------
-        // Specialization for embedded_scanline
-        bool sweep_scanline(embedded_scanline& sl)
-        {
-            do
-            {
-                if(m_cur_scanline >= m_scanlines.size()) return false;
-                sl.setup(m_cur_scanline);
-                ++m_cur_scanline;
-            }
-            while(sl.num_spans() == 0);
-            return true;
-        }
-
-
-        //---------------------------------------------------------------
-        unsigned byte_size() const
-        {
-            unsigned i;
-            unsigned size = sizeof(int32) * 4; // min_x, min_y, max_x, max_y
-
-            for(i = 0; i < m_scanlines.size(); ++i)
-            {
-                size += sizeof(int32) * 2 + // Y, num_spans
-                        unsigned(m_scanlines[i].num_spans) * sizeof(int32) * 2; // X, span_len
-            }
-            return size;
-        }
-
-
-        //---------------------------------------------------------------
-        static void write_int32(int8u* dst, int32 val)
-        {
-            dst[0] = ((const int8u*)&val)[0];
-            dst[1] = ((const int8u*)&val)[1];
-            dst[2] = ((const int8u*)&val)[2];
-            dst[3] = ((const int8u*)&val)[3];
-        }
-
-
-        //---------------------------------------------------------------
-        void serialize(int8u* data) const
-        {
-            unsigned i;
-
-            write_int32(data, min_x()); // min_x
-            data += sizeof(int32);
-            write_int32(data, min_y()); // min_y
-            data += sizeof(int32);
-            write_int32(data, max_x()); // max_x
-            data += sizeof(int32);
-            write_int32(data, max_y()); // max_y
-            data += sizeof(int32);
-
-            for(i = 0; i < m_scanlines.size(); ++i)
-            {
-                const scanline_data& sl_this = m_scanlines[i];
-
-                write_int32(data, sl_this.y);            // Y
-                data += sizeof(int32);
-
-                write_int32(data, sl_this.num_spans);    // num_spans
-                data += sizeof(int32);
-
-                unsigned num_spans = sl_this.num_spans;
-                unsigned span_idx  = sl_this.start_span;
-                do
-                {
-                    const span_data& sp = m_spans[span_idx++];
-
-                    write_int32(data, sp.x);             // X
-                    data += sizeof(int32);
-
-                    write_int32(data, sp.len);           // len
-                    data += sizeof(int32);
-                }
-                while(--num_spans);
-            }
-        }
-
-
-        //---------------------------------------------------------------
-        const scanline_data& scanline_by_index(unsigned i) const
-        {
-            return (i < m_scanlines.size()) ? m_scanlines[i] : m_fake_scanline;
-        }
-
-        //---------------------------------------------------------------
-        const span_data& span_by_index(unsigned i) const
-        {
-            return (i < m_spans.size()) ? m_spans[i] : m_fake_span;
-        }
-
-
-    private:
-        pod_bvector<span_data, 10>    m_spans;
-        pod_bvector<scanline_data, 8> m_scanlines;
-        span_data     m_fake_span;
-        scanline_data m_fake_scanline;
-        int           m_min_x;
-        int           m_min_y;
-        int           m_max_x;
-        int           m_max_y;
-        unsigned      m_cur_scanline;
-    };
-
-
-
-
-
-
-
-
-
-
-
-
-
-    //---------------------------------------serialized_scanlines_adaptor_bin
-    class serialized_scanlines_adaptor_bin
-    {
-    public:
-        typedef bool cover_type;
-
-        //--------------------------------------------------------------------
-        class embedded_scanline
-        {
-        public:
-
-            //----------------------------------------------------------------
-            class const_iterator
-            {
-            public:
-                struct span
-                {
-                    int32 x;
-                    int32 len;
-                };
-
-                const_iterator() : m_ptr(0) {}
-                const_iterator(const embedded_scanline& sl) :
-                    m_ptr(sl.m_ptr),
-                    m_dx(sl.m_dx)
-                {
-                    m_span.x   = read_int32() + m_dx;
-                    m_span.len = read_int32();
-                }
-
-                const span& operator*()  const { return m_span;  }
-                const span* operator->() const { return &m_span; }
-
-                void operator ++ ()
-                {
-                    m_span.x   = read_int32() + m_dx;
-                    m_span.len = read_int32();
-                }
-
-            private:
-                int read_int32()
-                {
-                    int32 val;
-                    ((int8u*)&val)[0] = *m_ptr++;
-                    ((int8u*)&val)[1] = *m_ptr++;
-                    ((int8u*)&val)[2] = *m_ptr++;
-                    ((int8u*)&val)[3] = *m_ptr++;
-                    return val;
-                }
-
-                const int8u* m_ptr;
-                span         m_span;
-                int          m_dx;
-            };
-
-            friend class const_iterator;
-
-
-            //----------------------------------------------------------------
-            embedded_scanline() = default;
-
-            //----------------------------------------------------------------
-            void     reset(int, int)     {}
-            unsigned num_spans()   const { return m_num_spans;  }
-            int      y()           const { return m_y;          }
-            const_iterator begin() const { return const_iterator(*this); }
-
-
-        private:
-            //----------------------------------------------------------------
-            int read_int32()
-            {
-                int32 val;
-                ((int8u*)&val)[0] = *m_ptr++;
-                ((int8u*)&val)[1] = *m_ptr++;
-                ((int8u*)&val)[2] = *m_ptr++;
-                ((int8u*)&val)[3] = *m_ptr++;
-                return val;
-            }
-
-        public:
-            //----------------------------------------------------------------
-            void init(const int8u* ptr, int dx, int dy)
-            {
-                m_ptr       = ptr;
-                m_y         = read_int32() + dy;
-                m_num_spans = unsigned(read_int32());
-                m_dx        = dx;
-            }
-
-        private:
-            const int8u* m_ptr = nullptr;
-            int          m_y = 0;
-            unsigned     m_num_spans = 0;
-            int          m_dx = 0;
-        };
-
-
-
-    public:
-        //--------------------------------------------------------------------
-        serialized_scanlines_adaptor_bin() :
-            m_data(0),
-            m_end(0),
-            m_ptr(0),
-            m_dx(0),
-            m_dy(0),
-            m_min_x(0x7FFFFFFF),
-            m_min_y(0x7FFFFFFF),
-            m_max_x(-0x7FFFFFFF),
-            m_max_y(-0x7FFFFFFF)
-        {}
-
-        //--------------------------------------------------------------------
-        serialized_scanlines_adaptor_bin(const int8u* data, unsigned size,
-                                         double dx, double dy) :
-            m_data(data),
-            m_end(data + size),
-            m_ptr(data),
-            m_dx(iround(dx)),
-            m_dy(iround(dy)),
-            m_min_x(0x7FFFFFFF),
-            m_min_y(0x7FFFFFFF),
-            m_max_x(-0x7FFFFFFF),
-            m_max_y(-0x7FFFFFFF)
-        {}
-
-        //--------------------------------------------------------------------
-        void init(const int8u* data, unsigned size, double dx, double dy)
-        {
-            m_data  = data;
-            m_end   = data + size;
-            m_ptr   = data;
-            m_dx    = iround(dx);
-            m_dy    = iround(dy);
-            m_min_x = 0x7FFFFFFF;
-            m_min_y = 0x7FFFFFFF;
-            m_max_x = -0x7FFFFFFF;
-            m_max_y = -0x7FFFFFFF;
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        int read_int32()
-        {
-            int32 val;
-            ((int8u*)&val)[0] = *m_ptr++;
-            ((int8u*)&val)[1] = *m_ptr++;
-            ((int8u*)&val)[2] = *m_ptr++;
-            ((int8u*)&val)[3] = *m_ptr++;
-            return val;
-        }
-       
-    public:
-        // Iterate scanlines interface
-        //--------------------------------------------------------------------
-        bool rewind_scanlines()
-        {
-            m_ptr = m_data;
-            if(m_ptr < m_end)
-            {
-                m_min_x = read_int32() + m_dx; 
-                m_min_y = read_int32() + m_dy;
-                m_max_x = read_int32() + m_dx;
-                m_max_y = read_int32() + m_dy;
-            }
-            return m_ptr < m_end;
-        }
-
-        //--------------------------------------------------------------------
-        int min_x() const { return m_min_x; }
-        int min_y() const { return m_min_y; }
-        int max_x() const { return m_max_x; }
-        int max_y() const { return m_max_y; }
-
-        //--------------------------------------------------------------------
-        template<class Scanline> bool sweep_scanline(Scanline& sl)
-        {
-            sl.reset_spans();
-            for(;;)
-            {
-                if(m_ptr >= m_end) return false;
-
-                int y = read_int32() + m_dy;
-                unsigned num_spans = read_int32();
-
-                do
-                {
-                    int x = read_int32() + m_dx;
-                    int len = read_int32();
-
-                    if(len < 0) len = -len;
-                    sl.add_span(x, unsigned(len), cover_full);
-                }
-                while(--num_spans);
-
-                if(sl.num_spans())
-                {
-                    sl.finalize(y);
-                    break;
-                }
-            }
-            return true;
-        }
-
-
-        //--------------------------------------------------------------------
-        // Specialization for embedded_scanline
-        bool sweep_scanline(embedded_scanline& sl)
-        {
-            do
-            {
-                if(m_ptr >= m_end) return false;
-
-                sl.init(m_ptr, m_dx, m_dy);
-
-                // Jump to the next scanline
-                //--------------------------
-                read_int32();                    // Y
-                int num_spans = read_int32();    // num_spans
-                m_ptr += num_spans * sizeof(int32) * 2;
-            }
-            while(sl.num_spans() == 0);
-            return true;
-        }
-
-    private:
-        const int8u* m_data;
-        const int8u* m_end;
-        const int8u* m_ptr;
-        int          m_dx;
-        int          m_dy;
-        int          m_min_x;
-        int          m_min_y;
-        int          m_max_x;
-        int          m_max_y;
-    };
-
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_scanline_u.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_u.h
--- 8.0.1-5/renderers/agg/include/agg_scanline_u.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_scanline_u.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,499 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for 32-bit screen coordinates (scanline32_u) has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SCANLINE_U_INCLUDED
-#define AGG_SCANLINE_U_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-    //=============================================================scanline_u8
-    //
-    // Unpacked scanline container class
-    //
-    // This class is used to transfer data from a scanline rasterizer 
-    // to the rendering buffer. It's organized very simple. The class stores 
-    // information of horizontal spans to render it into a pixel-map buffer. 
-    // Each span has staring X, length, and an array of bytes that determine the 
-    // cover-values for each pixel. 
-    // Before using this class you should know the minimal and maximal pixel 
-    // coordinates of your scanline. The protocol of using is:
-    // 1. reset(min_x, max_x)
-    // 2. add_cell() / add_span() - accumulate scanline. 
-    //    When forming one scanline the next X coordinate must be always greater
-    //    than the last stored one, i.e. it works only with ordered coordinates.
-    // 3. Call finalize(y) and render the scanline.
-    // 3. Call reset_spans() to prepare for the new scanline.
-    //    
-    // 4. Rendering:
-    // 
-    // Scanline provides an iterator class that allows you to extract
-    // the spans and the cover values for each pixel. Be aware that clipping
-    // has not been done yet, so you should perform it yourself.
-    // Use scanline_u8::iterator to render spans:
-    //-------------------------------------------------------------------------
-    //
-    // int y = sl.y();                    // Y-coordinate of the scanline
-    //
-    // ************************************
-    // ...Perform vertical clipping here...
-    // ************************************
-    //
-    // scanline_u8::const_iterator span = sl.begin();
-    // 
-    // unsigned char* row = m_rbuf->row(y); // The the address of the beginning 
-    //                                      // of the current row
-    // 
-    // unsigned num_spans = sl.num_spans(); // Number of spans. It's guaranteed that
-    //                                      // num_spans is always greater than 0.
-    //
-    // do
-    // {
-    //     const scanline_u8::cover_type* covers =
-    //         span->covers;                     // The array of the cover values
-    //
-    //     int num_pix = span->len;              // Number of pixels of the span.
-    //                                           // Always greater than 0, still it's
-    //                                           // better to use "int" instead of 
-    //                                           // "unsigned" because it's more
-    //                                           // convenient for clipping
-    //     int x = span->x;
-    //
-    //     **************************************
-    //     ...Perform horizontal clipping here...
-    //     ...you have x, covers, and pix_count..
-    //     **************************************
-    //
-    //     unsigned char* dst = row + x;  // Calculate the start address of the row.
-    //                                    // In this case we assume a simple 
-    //                                    // grayscale image 1-byte per pixel.
-    //     do
-    //     {
-    //         *dst++ = *covers++;        // Hypotetical rendering. 
-    //     }
-    //     while(--num_pix);
-    //
-    //     ++span;
-    // } 
-    // while(--num_spans);  // num_spans cannot be 0, so this loop is quite safe
-    //------------------------------------------------------------------------
-    //
-    // The question is: why should we accumulate the whole scanline when we
-    // could render just separate spans when they're ready?
-    // That's because using the scanline is generally faster. When is consists 
-    // of more than one span the conditions for the processor cash system
-    // are better, because switching between two different areas of memory 
-    // (that can be very large) occurs less frequently.
-    //------------------------------------------------------------------------
-    class scanline_u8
-    {
-    public:
-        typedef scanline_u8 self_type;
-        typedef int8u       cover_type;
-        typedef int16       coord_type;
-
-        //--------------------------------------------------------------------
-        struct span
-        {
-            coord_type  x;
-            coord_type  len;
-            cover_type* covers;
-        };
-
-        typedef span* iterator;
-        typedef const span* const_iterator;
-
-        //--------------------------------------------------------------------
-        scanline_u8() :
-            m_min_x(0),
-            m_last_x(0x7FFFFFF0),
-            m_cur_span(0)
-        {}
-
-        //--------------------------------------------------------------------
-        void reset(int min_x, int max_x)
-        {
-            unsigned max_len = max_x - min_x + 2;
-            if(max_len > m_spans.size())
-            {
-                m_spans.resize(max_len);
-                m_covers.resize(max_len);
-            }
-            m_last_x   = 0x7FFFFFF0;
-            m_min_x    = min_x;
-            m_cur_span = &m_spans[0];
-        }
-
-        //--------------------------------------------------------------------
-        void add_cell(int x, unsigned cover)
-        {
-            x -= m_min_x;
-            m_covers[x] = (cover_type)cover;
-            if(x == m_last_x+1)
-            {
-                m_cur_span->len++;
-            }
-            else
-            {
-                m_cur_span++;
-                m_cur_span->x      = (coord_type)(x + m_min_x);
-                m_cur_span->len    = 1;
-                m_cur_span->covers = &m_covers[x];
-            }
-            m_last_x = x;
-        }
-
-        //--------------------------------------------------------------------
-        void add_cells(int x, unsigned len, const cover_type* covers)
-        {
-            x -= m_min_x;
-            memcpy(&m_covers[x], covers, len * sizeof(cover_type));
-            if(x == m_last_x+1)
-            {
-                m_cur_span->len += (coord_type)len;
-            }
-            else
-            {
-                m_cur_span++;
-                m_cur_span->x      = (coord_type)(x + m_min_x);
-                m_cur_span->len    = (coord_type)len;
-                m_cur_span->covers = &m_covers[x];
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void add_span(int x, unsigned len, unsigned cover)
-        {
-            x -= m_min_x;
-            memset(&m_covers[x], cover, len);
-            if(x == m_last_x+1)
-            {
-                m_cur_span->len += (coord_type)len;
-            }
-            else
-            {
-                m_cur_span++;
-                m_cur_span->x      = (coord_type)(x + m_min_x);
-                m_cur_span->len    = (coord_type)len;
-                m_cur_span->covers = &m_covers[x];
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void finalize(int y) 
-        { 
-            m_y = y; 
-        }
-
-        //--------------------------------------------------------------------
-        void reset_spans()
-        {
-            m_last_x    = 0x7FFFFFF0;
-            m_cur_span  = &m_spans[0];
-        }
-
-        //--------------------------------------------------------------------
-        int      y()           const { return m_y; }
-        unsigned num_spans()   const { return unsigned(m_cur_span - &m_spans[0]); }
-        const_iterator begin() const { return &m_spans[1]; }
-        iterator       begin()       { return &m_spans[1]; }
-
-    private:
-        scanline_u8(const self_type&);
-        const self_type& operator = (const self_type&);
-
-    private:
-        int                   m_min_x;
-        int                   m_last_x;
-        int                   m_y = 0;
-        pod_array<cover_type> m_covers;
-        pod_array<span>       m_spans;
-        span*                 m_cur_span;
-    };
-
-
-
-
-    //==========================================================scanline_u8_am
-    // 
-    // The scanline container with alpha-masking
-    // 
-    //------------------------------------------------------------------------
-    template<class AlphaMask> 
-    class scanline_u8_am : public scanline_u8
-    {
-    public:
-        typedef scanline_u8           base_type;
-        typedef AlphaMask             alpha_mask_type;
-        typedef base_type::cover_type cover_type;
-        typedef base_type::coord_type coord_type;
-
-        scanline_u8_am() : base_type(), m_alpha_mask(0) {}
-        scanline_u8_am(const AlphaMask& am) : base_type(), m_alpha_mask(&am) {}
-
-        //--------------------------------------------------------------------
-        void finalize(int span_y)
-        {
-            base_type::finalize(span_y);
-            if(m_alpha_mask)
-            {
-                typename base_type::iterator span = base_type::begin();
-                unsigned count = base_type::num_spans();
-                do
-                {
-                    m_alpha_mask->combine_hspan(span->x, 
-                                                base_type::y(), 
-                                                span->covers, 
-                                                span->len);
-                    ++span;
-                }
-                while(--count);
-            }
-        }
-
-    private:
-        const AlphaMask* m_alpha_mask;
-    };
-
-
-
-
-    //===========================================================scanline32_u8
-    class scanline32_u8
-    {
-    public:
-        typedef scanline32_u8 self_type;
-        typedef int8u         cover_type;
-        typedef int32         coord_type;
-
-        //--------------------------------------------------------------------
-        struct span
-        {
-            span() {}
-            span(coord_type x_, coord_type len_, cover_type* covers_) :
-                x(x_), len(len_), covers(covers_) {}
-
-            coord_type  x;
-            coord_type  len;
-            cover_type* covers;
-        };
-
-        typedef pod_bvector<span, 4> span_array_type;
-
-        //--------------------------------------------------------------------
-        class const_iterator
-        {
-        public:
-            const_iterator(const span_array_type& spans) :
-                m_spans(spans),
-                m_span_idx(0)
-            {}
-
-            const span& operator*()  const { return m_spans[m_span_idx];  }
-            const span* operator->() const { return &m_spans[m_span_idx]; }
-
-            void operator ++ () { ++m_span_idx; }
-
-        private:
-            const span_array_type& m_spans;
-            unsigned               m_span_idx;
-        };
-
-        //--------------------------------------------------------------------
-        class iterator
-        {
-        public:
-            iterator(span_array_type& spans) :
-                m_spans(spans),
-                m_span_idx(0)
-            {}
-
-            span& operator*()  { return m_spans[m_span_idx];  }
-            span* operator->() { return &m_spans[m_span_idx]; }
-
-            void operator ++ () { ++m_span_idx; }
-
-        private:
-            span_array_type& m_spans;
-            unsigned         m_span_idx;
-        };
-
-
-
-        //--------------------------------------------------------------------
-        scanline32_u8() :
-            m_min_x(0),
-            m_last_x(0x7FFFFFF0),
-            m_covers()
-        {}
-
-        //--------------------------------------------------------------------
-        void reset(int min_x, int max_x)
-        {
-            unsigned max_len = max_x - min_x + 2;
-            if(max_len > m_covers.size())
-            {
-                m_covers.resize(max_len);
-            }
-            m_last_x = 0x7FFFFFF0;
-            m_min_x  = min_x;
-            m_spans.remove_all();
-        }
-
-        //--------------------------------------------------------------------
-        void add_cell(int x, unsigned cover)
-        {
-            x -= m_min_x;
-            m_covers[x] = cover_type(cover);
-            if(x == m_last_x+1)
-            {
-                m_spans.last().len++;
-            }
-            else
-            {
-                m_spans.add(span(coord_type(x + m_min_x), 1, &m_covers[x]));
-            }
-            m_last_x = x;
-        }
-
-        //--------------------------------------------------------------------
-        void add_cells(int x, unsigned len, const cover_type* covers)
-        {
-            x -= m_min_x;
-            memcpy(&m_covers[x], covers, len * sizeof(cover_type));
-            if(x == m_last_x+1)
-            {
-                m_spans.last().len += coord_type(len);
-            }
-            else
-            {
-                m_spans.add(span(coord_type(x + m_min_x), 
-                                 coord_type(len), 
-                                 &m_covers[x]));
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void add_span(int x, unsigned len, unsigned cover)
-        {
-            x -= m_min_x;
-            memset(&m_covers[x], cover, len);
-            if(x == m_last_x+1)
-            {
-                m_spans.last().len += coord_type(len);
-            }
-            else
-            {
-                m_spans.add(span(coord_type(x + m_min_x), 
-                                 coord_type(len), 
-                                 &m_covers[x]));
-            }
-            m_last_x = x + len - 1;
-        }
-
-        //--------------------------------------------------------------------
-        void finalize(int y) 
-        { 
-            m_y = y; 
-        }
-
-        //--------------------------------------------------------------------
-        void reset_spans()
-        {
-            m_last_x = 0x7FFFFFF0;
-            m_spans.remove_all();
-        }
-
-        //--------------------------------------------------------------------
-        int      y()           const { return m_y; }
-        unsigned num_spans()   const { return m_spans.size(); }
-        const_iterator begin() const { return const_iterator(m_spans); }
-        iterator       begin()       { return iterator(m_spans); }
-
-    private:
-        scanline32_u8(const self_type&);
-        const self_type& operator = (const self_type&);
-
-    private:
-        int                   m_min_x;
-        int                   m_last_x;
-        int                   m_y;
-        pod_array<cover_type> m_covers;
-        span_array_type       m_spans;
-    };
-
-
-
-
-    //========================================================scanline32_u8_am
-    // 
-    // The scanline container with alpha-masking
-    // 
-    //------------------------------------------------------------------------
-    template<class AlphaMask> 
-        class scanline32_u8_am : public scanline32_u8
-    {
-    public:
-        typedef scanline32_u8         base_type;
-        typedef AlphaMask             alpha_mask_type;
-        typedef base_type::cover_type cover_type;
-        typedef base_type::coord_type coord_type;
-
-
-        scanline32_u8_am() : base_type(), m_alpha_mask(0) {}
-        scanline32_u8_am(const AlphaMask& am) : base_type(), m_alpha_mask(&am) {}
-
-        //--------------------------------------------------------------------
-        void finalize(int span_y)
-        {
-            base_type::finalize(span_y);
-            if(m_alpha_mask)
-            {
-                typename base_type::iterator span = base_type::begin();
-                unsigned count = base_type::num_spans();
-                do
-                {
-                    m_alpha_mask->combine_hspan(span->x, 
-                                                base_type::y(), 
-                                                span->covers, 
-                                                span->len);
-                    ++span;
-                }
-                while(--count);
-            }
-        }
-
-    private:
-        const AlphaMask* m_alpha_mask;
-    };
-
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_shorten_path.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_shorten_path.h
--- 8.0.1-5/renderers/agg/include/agg_shorten_path.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_shorten_path.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SHORTEN_PATH_INCLUDED
-#define AGG_SHORTEN_PATH_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vertex_sequence.h"
-
-namespace mapserver
-{
-
-    //===========================================================shorten_path
-    template<class VertexSequence> 
-    void shorten_path(VertexSequence& vs, double s, unsigned closed = 0)
-    {
-        typedef typename VertexSequence::value_type vertex_type;
-
-        if(s > 0.0 && vs.size() > 1)
-        {
-            double d;
-            int n = int(vs.size() - 2);
-            while(n)
-            {
-                d = vs[n].dist;
-                if(d > s) break;
-                vs.remove_last();
-                s -= d;
-                --n;
-            }
-            if(vs.size() < 2)
-            {
-                vs.remove_all();
-            }
-            else
-            {
-                n = vs.size() - 1;
-                vertex_type& prev = vs[n-1];
-                vertex_type& last = vs[n];
-                d = (prev.dist - s) / prev.dist;
-                double x = prev.x + (last.x - prev.x) * d;
-                double y = prev.y + (last.y - prev.y) * d;
-                last.x = x;
-                last.y = y;
-                if(!prev(last)) vs.remove_last();
-                vs.close(closed != 0);
-            }
-        }
-    }
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_simul_eq.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_simul_eq.h
--- 8.0.1-5/renderers/agg/include/agg_simul_eq.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_simul_eq.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,147 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Solving simultaneous equations
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_SIMUL_EQ_INCLUDED
-#define AGG_SIMUL_EQ_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //=============================================================swap_arrays
-    template<class T> void swap_arrays(T* a1, T* a2, unsigned n)
-    {
-        unsigned i;
-        for(i = 0; i < n; i++)
-        {
-            T tmp = *a1;
-            *a1++ = *a2;
-            *a2++ = tmp;
-        }
-    }
-
-
-    //============================================================matrix_pivot
-    template<unsigned Rows, unsigned Cols>
-    struct matrix_pivot
-    {
-        static int pivot(double m[Rows][Cols], unsigned row)
-        {
-            int k = int(row);
-            double max_val, tmp;
-
-            max_val = -1.0;
-            unsigned i;
-            for(i = row; i < Rows; i++)
-            {
-                if((tmp = fabs(m[i][row])) > max_val && tmp != 0.0)
-                {
-                    max_val = tmp;
-                    k = i;
-                }
-            }
-
-            if(m[k][row] == 0.0)
-            {
-                return -1;
-            }
-
-            if(k != int(row))
-            {
-                swap_arrays(m[k], m[row], Cols);
-                return k;
-            }
-            return 0;
-        }
-    };
-    
-
-
-    //===============================================================simul_eq
-    template<unsigned Size, unsigned RightCols>
-    struct simul_eq
-    {
-        static bool solve(const double left[Size][Size], 
-                          const double right[Size][RightCols],
-                          double result[Size][RightCols])
-        {
-            unsigned i, j, k;
-            double a1;
-
-            double tmp[Size][Size + RightCols];
-
-            for(i = 0; i < Size; i++)
-            {
-                for(j = 0; j < Size; j++)
-                {
-                    tmp[i][j] = left[i][j];
-                } 
-                for(j = 0; j < RightCols; j++)
-                {
-                    tmp[i][Size + j] = right[i][j];
-                }
-            }
-
-            for(k = 0; k < Size; k++)
-            {
-                if(matrix_pivot<Size, Size + RightCols>::pivot(tmp, k) < 0)
-                {
-                    return false; // Singularity....
-                }
-
-                a1 = tmp[k][k];
-
-                for(j = k; j < Size + RightCols; j++)
-                {
-                    tmp[k][j] /= a1;
-                }
-
-                for(i = k + 1; i < Size; i++)
-                {
-                    a1 = tmp[i][k];
-                    for (j = k; j < Size + RightCols; j++)
-                    {
-                        tmp[i][j] -= a1 * tmp[k][j];
-                    }
-                }
-            }
-
-
-            for(k = 0; k < RightCols; k++)
-            {
-                int m;
-                for(m = int(Size - 1); m >= 0; m--)
-                {
-                    result[m][k] = tmp[m][Size + k];
-                    for(j = m + 1; j < Size; j++)
-                    {
-                        result[m][k] -= tmp[m][j] * result[j][k];
-                    }
-                }
-            }
-            return true;
-        }
-
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_allocator.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_allocator.h
--- 8.0.1-5/renderers/agg/include/agg_span_allocator.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_allocator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,54 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_ALLOCATOR_INCLUDED
-#define AGG_SPAN_ALLOCATOR_INCLUDED
-
-#include "agg_array.h"
-
-namespace mapserver
-{
-    //----------------------------------------------------------span_allocator
-    template<class ColorT> class span_allocator
-    {
-    public:
-        typedef ColorT color_type;
-
-        //--------------------------------------------------------------------
-        AGG_INLINE color_type* allocate(unsigned span_len)
-        {
-            if(span_len > m_span.size())
-            {
-                // To reduce the number of reallocs we align the 
-                // span_len to 256 color elements. 
-                // Well, I just like this number and it looks reasonable.
-                //-----------------------
-                m_span.resize(((span_len + 255) >> 8) << 8);
-            }
-            return &m_span[0];
-        }
-
-        AGG_INLINE color_type* span()               { return &m_span[0]; }
-        AGG_INLINE unsigned    max_span_len() const { return m_span.size(); }
-
-    private:
-        pod_array<color_type> m_span;
-    };
-}
-
-
-#endif
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_converter.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_converter.h
--- 8.0.1-5/renderers/agg/include/agg_span_converter.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_converter.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,56 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_CONVERTER_INCLUDED
-#define AGG_SPAN_CONVERTER_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //----------------------------------------------------------span_converter
-    template<class SpanGenerator, class SpanConverter> class span_converter
-    {
-    public:
-        typedef typename SpanGenerator::color_type color_type;
-
-        span_converter(SpanGenerator& span_gen, SpanConverter& span_cnv) : 
-            m_span_gen(&span_gen), m_span_cnv(&span_cnv) {}
-
-        void attach_generator(SpanGenerator& span_gen) { m_span_gen = &span_gen; }
-        void attach_converter(SpanConverter& span_cnv) { m_span_cnv = &span_cnv; }
-
-        //--------------------------------------------------------------------
-        void prepare() 
-        { 
-            m_span_gen->prepare(); 
-            m_span_cnv->prepare();
-        }
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            m_span_gen->generate(span, x, y, len);
-            m_span_cnv->generate(span, x, y, len);
-        }
-
-    private:
-        SpanGenerator* m_span_gen;
-        SpanConverter* m_span_cnv;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_gouraud.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gouraud.h
--- 8.0.1-5/renderers/agg/include/agg_span_gouraud.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gouraud.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,172 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_GOURAUD_INCLUDED
-#define AGG_SPAN_GOURAUD_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_math.h"
-
-namespace mapserver
-{
-
-    //============================================================span_gouraud
-    template<class ColorT> class span_gouraud
-    {
-    public:
-        typedef ColorT color_type;
-
-        struct coord_type
-        {
-            double x;
-            double y;
-            color_type color;
-        };
-
-        //--------------------------------------------------------------------
-        span_gouraud() : 
-            m_vertex(0)
-        {
-            m_cmd[0] = path_cmd_stop;
-        }
-
-        //--------------------------------------------------------------------
-        span_gouraud(const color_type& c1,
-                     const color_type& c2,
-                     const color_type& c3,
-                     double x1, double y1,
-                     double x2, double y2,
-                     double x3, double y3,
-                     double d) : 
-            m_vertex(0)
-        {
-            colors(c1, c2, c3);
-            triangle(x1, y1, x2, y2, x3, y3, d);
-        }
-
-        //--------------------------------------------------------------------
-        void colors(ColorT c1, ColorT c2, ColorT c3)
-        {
-            m_coord[0].color = c1;
-            m_coord[1].color = c2;
-            m_coord[2].color = c3;
-        }
-
-        //--------------------------------------------------------------------
-        // Sets the triangle and dilates it if needed.
-        // The trick here is to calculate beveled joins in the vertices of the 
-        // triangle and render it as a 6-vertex polygon. 
-        // It's necessary to achieve numerical stability. 
-        // However, the coordinates to interpolate colors are calculated
-        // as miter joins (calc_intersection).
-        void triangle(double x1, double y1, 
-                      double x2, double y2,
-                      double x3, double y3,
-                      double d)
-        {
-            m_coord[0].x = m_x[0] = x1; 
-            m_coord[0].y = m_y[0] = y1;
-            m_coord[1].x = m_x[1] = x2; 
-            m_coord[1].y = m_y[1] = y2;
-            m_coord[2].x = m_x[2] = x3; 
-            m_coord[2].y = m_y[2] = y3;
-            m_cmd[0] = path_cmd_move_to;
-            m_cmd[1] = path_cmd_line_to;
-            m_cmd[2] = path_cmd_line_to;
-            m_cmd[3] = path_cmd_stop;
-
-            if(d != 0.0)
-            {   
-                dilate_triangle(m_coord[0].x, m_coord[0].y,
-                                m_coord[1].x, m_coord[1].y,
-                                m_coord[2].x, m_coord[2].y,
-                                m_x, m_y, d);
-
-                calc_intersection(m_x[4], m_y[4], m_x[5], m_y[5],
-                                  m_x[0], m_y[0], m_x[1], m_y[1],
-                                  &m_coord[0].x, &m_coord[0].y);
-
-                calc_intersection(m_x[0], m_y[0], m_x[1], m_y[1],
-                                  m_x[2], m_y[2], m_x[3], m_y[3],
-                                  &m_coord[1].x, &m_coord[1].y);
-
-                calc_intersection(m_x[2], m_y[2], m_x[3], m_y[3],
-                                  m_x[4], m_y[4], m_x[5], m_y[5],
-                                  &m_coord[2].x, &m_coord[2].y);
-                m_cmd[3] = path_cmd_line_to;
-                m_cmd[4] = path_cmd_line_to;
-                m_cmd[5] = path_cmd_line_to;
-                m_cmd[6] = path_cmd_stop;
-            }
-        }
-
-        //--------------------------------------------------------------------
-        // Vertex Source Interface to feed the coordinates to the rasterizer
-        void rewind(unsigned)
-        {
-            m_vertex = 0;
-        }
-
-        //--------------------------------------------------------------------
-        unsigned vertex(double* x, double* y)
-        {
-            *x = m_x[m_vertex];
-            *y = m_y[m_vertex];
-            return m_cmd[m_vertex++];
-        }
-
-    protected:
-        //--------------------------------------------------------------------
-        void arrange_vertices(coord_type* coord) const
-        {
-            coord[0] = m_coord[0];
-            coord[1] = m_coord[1];
-            coord[2] = m_coord[2];
-
-            if(m_coord[0].y > m_coord[2].y)
-            {
-                coord[0] = m_coord[2]; 
-                coord[2] = m_coord[0];
-            }
-
-            coord_type tmp;
-            if(coord[0].y > coord[1].y)
-            {
-                tmp      = coord[1];
-                coord[1] = coord[0];
-                coord[0] = tmp;
-            }
-
-            if(coord[1].y > coord[2].y)
-            {
-                tmp      = coord[2];
-                coord[2] = coord[1];
-                coord[1] = tmp;
-            }
-       }
-
-    private:
-        //--------------------------------------------------------------------
-        coord_type m_coord[3];
-        double m_x[8];
-        double m_y[8];
-        unsigned m_cmd[8];
-        unsigned m_vertex;
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_gouraud_gray.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gouraud_gray.h
--- 8.0.1-5/renderers/agg/include/agg_span_gouraud_gray.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gouraud_gray.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,241 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_GOURAUD_GRAY_INCLUDED
-#define AGG_SPAN_GOURAUD_GRAY_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_gray.h"
-#include "agg_dda_line.h"
-#include "agg_span_gouraud.h"
-
-namespace mapserver
-{
-
-    //=======================================================span_gouraud_gray
-    template<class ColorT> class span_gouraud_gray : public span_gouraud<ColorT>
-    {
-    public:
-        typedef ColorT color_type;
-        typedef typename color_type::value_type value_type;
-        typedef span_gouraud<color_type> base_type;
-        typedef typename base_type::coord_type coord_type;
-        enum subpixel_scale_e
-        { 
-            subpixel_shift = 4, 
-            subpixel_scale = 1 << subpixel_shift
-        };
-
-    private:
-        //--------------------------------------------------------------------
-        struct gray_calc
-        {
-            void init(const coord_type& c1, const coord_type& c2)
-            {
-                m_x1  = c1.x - 0.5;
-                m_y1  = c1.y - 0.5;
-                m_dx  = c2.x - c1.x;
-                double dy = c2.y - c1.y;
-                m_1dy = (fabs(dy) < 1e-10) ? 1e10 : 1.0 / dy;
-                m_v1 = c1.color.v;
-                m_a1 = c1.color.a;
-                m_dv = c2.color.v - m_v1;
-                m_da = c2.color.a - m_a1;
-            }
-
-            void calc(double y)
-            {
-                double k = (y - m_y1) * m_1dy;
-                if(k < 0.0) k = 0.0;
-                if(k > 1.0) k = 1.0;
-                m_v = m_v1 + iround(m_dv * k);
-                m_a = m_a1 + iround(m_da * k);
-                m_x = iround((m_x1 + m_dx * k) * subpixel_scale);
-            }
-
-            double m_x1;
-            double m_y1;
-            double m_dx;
-            double m_1dy;
-            int    m_v1;
-            int    m_a1;
-            int    m_dv;
-            int    m_da;
-            int    m_v;
-            int    m_a;
-            int    m_x;
-        };
-
-
-    public:
-        //--------------------------------------------------------------------
-        span_gouraud_gray() {}
-        span_gouraud_gray(const color_type& c1, 
-                          const color_type& c2, 
-                          const color_type& c3,
-                          double x1, double y1, 
-                          double x2, double y2,
-                          double x3, double y3, 
-                          double d = 0) : 
-            base_type(c1, c2, c3, x1, y1, x2, y2, x3, y3, d)
-        {}
-
-        //--------------------------------------------------------------------
-        void prepare()
-        {
-            coord_type coord[3];
-            base_type::arrange_vertices(coord);
-
-            m_y2 = int(coord[1].y);
-
-            m_swap = cross_product(coord[0].x, coord[0].y, 
-                                   coord[2].x, coord[2].y,
-                                   coord[1].x, coord[1].y) < 0.0;
-
-            m_c1.init(coord[0], coord[2]);
-            m_c2.init(coord[0], coord[1]);
-            m_c3.init(coord[1], coord[2]);
-        }
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            m_c1.calc(y);
-            const gray_calc* pc1 = &m_c1;
-            const gray_calc* pc2 = &m_c2;
-
-            if(y < m_y2)
-            {
-                // Bottom part of the triangle (first subtriangle)
-                //-------------------------
-                m_c2.calc(y + m_c2.m_1dy);
-            }
-            else
-            {
-                // Upper part (second subtriangle)
-                //-------------------------
-                m_c3.calc(y - m_c3.m_1dy);
-                pc2 = &m_c3;
-            }
-
-            if(m_swap)
-            {
-                // It means that the triangle is oriented clockwise, 
-                // so that we need to swap the controlling structures
-                //-------------------------
-                const gray_calc* t = pc2;
-                pc2 = pc1;
-                pc1 = t;
-            }
-
-            // Get the horizontal length with subpixel accuracy
-            // and protect it from division by zero
-            //-------------------------
-            int nlen = abs(pc2->m_x - pc1->m_x);
-            if(nlen <= 0) nlen = 1;
-
-            dda_line_interpolator<14> v(pc1->m_v, pc2->m_v, nlen);
-            dda_line_interpolator<14> a(pc1->m_a, pc2->m_a, nlen);
-
-            // Calculate the starting point of the gradient with subpixel 
-            // accuracy and correct (roll back) the interpolators.
-            // This operation will also clip the beginning of the span
-            // if necessary.
-            //-------------------------
-            int start = pc1->m_x - (x << subpixel_shift);
-            v    -= start; 
-            a    -= start;
-            nlen += start;
-
-            int vv, va;
-            enum lim_e { lim = color_type::base_mask };
-
-            // Beginning part of the span. Since we rolled back the 
-            // interpolators, the color values may have overflow.
-            // So that, we render the beginning part with checking 
-            // for overflow. It lasts until "start" is positive;
-            // typically it's 1-2 pixels, but may be more in some cases.
-            //-------------------------
-            while(len && start > 0)
-            {
-                vv = v.y();
-                va = a.y();
-                if(vv < 0) vv = 0; if(vv > lim) vv = lim;
-                if(va < 0) va = 0; if(va > lim) va = lim;
-                span->v = (value_type)vv;
-                span->a = (value_type)va;
-                v     += subpixel_scale; 
-                a     += subpixel_scale;
-                nlen  -= subpixel_scale;
-                start -= subpixel_scale;
-                ++span;
-                --len;
-            }
-
-            // Middle part, no checking for overflow.
-            // Actual spans can be longer than the calculated length
-            // because of anti-aliasing, thus, the interpolators can 
-            // overflow. But while "nlen" is positive we are safe.
-            //-------------------------
-            while(len && nlen > 0)
-            {
-                span->v = (value_type)v.y();
-                span->a = (value_type)a.y();
-                v    += subpixel_scale; 
-                a    += subpixel_scale;
-                nlen -= subpixel_scale;
-                ++span;
-                --len;
-            }
-
-            // Ending part; checking for overflow.
-            // Typically it's 1-2 pixels, but may be more in some cases.
-            //-------------------------
-            while(len)
-            {
-                vv = v.y();
-                va = a.y();
-                if(vv < 0) vv = 0; if(vv > lim) vv = lim;
-                if(va < 0) va = 0; if(va > lim) va = lim;
-                span->v = (value_type)vv;
-                span->a = (value_type)va;
-                v += subpixel_scale; 
-                a += subpixel_scale;
-                ++span;
-                --len;
-            }
-        }
-
-
-    private:
-        bool      m_swap;
-        int       m_y2;
-        gray_calc m_c1;
-        gray_calc m_c2;
-        gray_calc m_c3;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_gouraud_rgba.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gouraud_rgba.h
--- 8.0.1-5/renderers/agg/include/agg_span_gouraud_rgba.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gouraud_rgba.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,277 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_GOURAUD_RGBA_INCLUDED
-#define AGG_SPAN_GOURAUD_RGBA_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_rgba.h"
-#include "agg_dda_line.h"
-#include "agg_span_gouraud.h"
-
-namespace mapserver
-{
-
-    //=======================================================span_gouraud_rgba
-    template<class ColorT> class span_gouraud_rgba : public span_gouraud<ColorT>
-    {
-    public:
-        typedef ColorT color_type;
-        typedef typename ColorT::value_type value_type;
-        typedef span_gouraud<color_type> base_type;
-        typedef typename base_type::coord_type coord_type;
-        enum subpixel_scale_e
-        { 
-            subpixel_shift = 4, 
-            subpixel_scale = 1 << subpixel_shift
-        };
-
-    private:
-        //--------------------------------------------------------------------
-        struct rgba_calc
-        {
-            void init(const coord_type& c1, const coord_type& c2)
-            {
-                m_x1  = c1.x - 0.5; 
-                m_y1  = c1.y - 0.5;
-                m_dx  = c2.x - c1.x;
-                double dy = c2.y - c1.y;
-                m_1dy = (dy < 1e-5) ? 1e5 : 1.0 / dy;
-                m_r1  = c1.color.r;
-                m_g1  = c1.color.g;
-                m_b1  = c1.color.b;
-                m_a1  = c1.color.a;
-                m_dr  = c2.color.r - m_r1;
-                m_dg  = c2.color.g - m_g1;
-                m_db  = c2.color.b - m_b1;
-                m_da  = c2.color.a - m_a1;
-            }
-
-            void calc(double y)
-            {
-                double k = (y - m_y1) * m_1dy;
-                if(k < 0.0) k = 0.0;
-                if(k > 1.0) k = 1.0;
-                m_r = m_r1 + iround(m_dr * k);
-                m_g = m_g1 + iround(m_dg * k);
-                m_b = m_b1 + iround(m_db * k);
-                m_a = m_a1 + iround(m_da * k);
-                m_x = iround((m_x1 + m_dx * k) * subpixel_scale);
-            }
-
-            double m_x1;
-            double m_y1;
-            double m_dx;
-            double m_1dy;
-            int    m_r1;
-            int    m_g1;
-            int    m_b1;
-            int    m_a1;
-            int    m_dr;
-            int    m_dg;
-            int    m_db;
-            int    m_da;
-            int    m_r;
-            int    m_g;
-            int    m_b;
-            int    m_a;
-            int    m_x;
-        };
-
-    public:
-
-        //--------------------------------------------------------------------
-        span_gouraud_rgba() {}
-        span_gouraud_rgba(const color_type& c1, 
-                          const color_type& c2, 
-                          const color_type& c3,
-                          double x1, double y1, 
-                          double x2, double y2,
-                          double x3, double y3, 
-                          double d = 0) : 
-            base_type(c1, c2, c3, x1, y1, x2, y2, x3, y3, d)
-        {}
-
-        //--------------------------------------------------------------------
-        void prepare()
-        {
-            coord_type coord[3];
-            base_type::arrange_vertices(coord);
-
-            m_y2 = int(coord[1].y);
-
-            m_swap = cross_product(coord[0].x, coord[0].y, 
-                                   coord[2].x, coord[2].y,
-                                   coord[1].x, coord[1].y) < 0.0;
-
-            m_rgba1.init(coord[0], coord[2]);
-            m_rgba2.init(coord[0], coord[1]);
-            m_rgba3.init(coord[1], coord[2]);
-        }
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            m_rgba1.calc(y);//(m_rgba1.m_1dy > 2) ? m_rgba1.m_y1 : y);
-            const rgba_calc* pc1 = &m_rgba1;
-            const rgba_calc* pc2 = &m_rgba2;
-
-            if(y <= m_y2)
-            {          
-                // Bottom part of the triangle (first subtriangle)
-                //-------------------------
-                m_rgba2.calc(y + m_rgba2.m_1dy);
-            }
-            else
-            {
-                // Upper part (second subtriangle)
-                m_rgba3.calc(y - m_rgba3.m_1dy);
-                //-------------------------
-                pc2 = &m_rgba3;
-            }
-
-            if(m_swap)
-            {
-                // It means that the triangle is oriented clockwise, 
-                // so that we need to swap the controlling structures
-                //-------------------------
-                const rgba_calc* t = pc2;
-                pc2 = pc1;
-                pc1 = t;
-            }
-
-            // Get the horizontal length with subpixel accuracy
-            // and protect it from division by zero
-            //-------------------------
-            int nlen = abs(pc2->m_x - pc1->m_x);
-            if(nlen <= 0) nlen = 1;
-
-            dda_line_interpolator<14> r(pc1->m_r, pc2->m_r, nlen);
-            dda_line_interpolator<14> g(pc1->m_g, pc2->m_g, nlen);
-            dda_line_interpolator<14> b(pc1->m_b, pc2->m_b, nlen);
-            dda_line_interpolator<14> a(pc1->m_a, pc2->m_a, nlen);
-
-            // Calculate the starting point of the gradient with subpixel 
-            // accuracy and correct (roll back) the interpolators.
-            // This operation will also clip the beginning of the span
-            // if necessary.
-            //-------------------------
-            int start = pc1->m_x - (x << subpixel_shift);
-            r    -= start; 
-            g    -= start; 
-            b    -= start; 
-            a    -= start;
-            nlen += start;
-
-            int vr, vg, vb, va;
-            enum lim_e { lim = color_type::base_mask };
-
-            // Beginning part of the span. Since we rolled back the 
-            // interpolators, the color values may have overflow.
-            // So that, we render the beginning part with checking 
-            // for overflow. It lasts until "start" is positive;
-            // typically it's 1-2 pixels, but may be more in some cases.
-            //-------------------------
-            while(len && start > 0)
-            {
-                vr = r.y();
-                vg = g.y();
-                vb = b.y();
-                va = a.y();
-                if(vr < 0) vr = 0; if(vr > lim) vr = lim;
-                if(vg < 0) vg = 0; if(vg > lim) vg = lim;
-                if(vb < 0) vb = 0; if(vb > lim) vb = lim;
-                if(va < 0) va = 0; if(va > lim) va = lim;
-                span->r = (value_type)vr;
-                span->g = (value_type)vg;
-                span->b = (value_type)vb;
-                span->a = (value_type)va;
-                r     += subpixel_scale; 
-                g     += subpixel_scale; 
-                b     += subpixel_scale; 
-                a     += subpixel_scale;
-                nlen  -= subpixel_scale;
-                start -= subpixel_scale;
-                ++span;
-                --len;
-            }
-
-            // Middle part, no checking for overflow.
-            // Actual spans can be longer than the calculated length
-            // because of anti-aliasing, thus, the interpolators can 
-            // overflow. But while "nlen" is positive we are safe.
-            //-------------------------
-            while(len && nlen > 0)
-            {
-                span->r = (value_type)r.y();
-                span->g = (value_type)g.y();
-                span->b = (value_type)b.y();
-                span->a = (value_type)a.y();
-                r    += subpixel_scale; 
-                g    += subpixel_scale; 
-                b    += subpixel_scale; 
-                a    += subpixel_scale;
-                nlen -= subpixel_scale;
-                ++span;
-                --len;
-            }
-
-            // Ending part; checking for overflow.
-            // Typically it's 1-2 pixels, but may be more in some cases.
-            //-------------------------
-            while(len)
-            {
-                vr = r.y();
-                vg = g.y();
-                vb = b.y();
-                va = a.y();
-                if(vr < 0) vr = 0; if(vr > lim) vr = lim;
-                if(vg < 0) vg = 0; if(vg > lim) vg = lim;
-                if(vb < 0) vb = 0; if(vb > lim) vb = lim;
-                if(va < 0) va = 0; if(va > lim) va = lim;
-                span->r = (value_type)vr;
-                span->g = (value_type)vg;
-                span->b = (value_type)vb;
-                span->a = (value_type)va;
-                r += subpixel_scale; 
-                g += subpixel_scale; 
-                b += subpixel_scale; 
-                a += subpixel_scale;
-                ++span;
-                --len;
-            }
-        }
-
-    private:
-        bool      m_swap;
-        int       m_y2;
-        rgba_calc m_rgba1;
-        rgba_calc m_rgba2;
-        rgba_calc m_rgba3;
-    };
-
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_gradient.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gradient.h
--- 8.0.1-5/renderers/agg/include/agg_span_gradient.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gradient.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,364 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_GRADIENT_INCLUDED
-#define AGG_SPAN_GRADIENT_INCLUDED
-
-#include <math.h>
-#include <stdlib.h>
-#include <string.h>
-#include "agg_basics.h"
-#include "agg_math.h"
-#include "agg_array.h"
-
-
-namespace mapserver
-{
-
-    enum gradient_subpixel_scale_e
-    {
-        gradient_subpixel_shift = 4,                              //-----gradient_subpixel_shift
-        gradient_subpixel_scale = 1 << gradient_subpixel_shift,   //-----gradient_subpixel_scale
-        gradient_subpixel_mask  = gradient_subpixel_scale - 1     //-----gradient_subpixel_mask
-    };
-
-
-
-    //==========================================================span_gradient
-    template<class ColorT,
-             class Interpolator,
-             class GradientF, 
-             class ColorF>
-    class span_gradient
-    {
-    public:
-        typedef Interpolator interpolator_type;
-        typedef ColorT color_type;
-
-        enum downscale_shift_e
-        {
-            downscale_shift = interpolator_type::subpixel_shift - 
-                              gradient_subpixel_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_gradient() {}
-
-        //--------------------------------------------------------------------
-        span_gradient(interpolator_type& inter,
-                      const GradientF& gradient_function,
-                      const ColorF& color_function,
-                      double d1, double d2) : 
-            m_interpolator(&inter),
-            m_gradient_function(&gradient_function),
-            m_color_function(&color_function),
-            m_d1(iround(d1 * gradient_subpixel_scale)),
-            m_d2(iround(d2 * gradient_subpixel_scale))
-        {}
-
-        //--------------------------------------------------------------------
-        interpolator_type& interpolator() { return *m_interpolator; }
-        const GradientF& gradient_function() const { return *m_gradient_function; }
-        const ColorF& color_function() const { return *m_color_function; }
-        double d1() const { return double(m_d1) / gradient_subpixel_scale; }
-        double d2() const { return double(m_d2) / gradient_subpixel_scale; }
-
-        //--------------------------------------------------------------------
-        void interpolator(interpolator_type& i) { m_interpolator = &i; }
-        void gradient_function(const GradientF& gf) { m_gradient_function = &gf; }
-        void color_function(const ColorF& cf) { m_color_function = &cf; }
-        void d1(double v) { m_d1 = iround(v * gradient_subpixel_scale); }
-        void d2(double v) { m_d2 = iround(v * gradient_subpixel_scale); }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {   
-            int dd = m_d2 - m_d1;
-            if(dd < 1) dd = 1;
-            m_interpolator->begin(x+0.5, y+0.5, len);
-            do
-            {
-                m_interpolator->coordinates(&x, &y);
-                int d = m_gradient_function->calculate(x >> downscale_shift, 
-                                                       y >> downscale_shift, m_d2);
-                d = ((d - m_d1) * (int)m_color_function->size()) / dd;
-                if(d < 0) d = 0;
-                if(d >= (int)m_color_function->size()) d = m_color_function->size() - 1;
-                *span++ = (*m_color_function)[d];
-                ++(*m_interpolator);
-            }
-            while(--len);
-        }
-
-    private:
-        interpolator_type* m_interpolator;
-        const GradientF*   m_gradient_function;
-        const ColorF*      m_color_function;
-        int                m_d1;
-        int                m_d2;
-    };
-
-
-
-
-    //=====================================================gradient_linear_color
-    template<class ColorT> 
-    struct gradient_linear_color
-    {
-        typedef ColorT color_type;
-
-        gradient_linear_color() {}
-        gradient_linear_color(const color_type& c1, const color_type& c2, 
-                              unsigned size = 256) :
-            m_c1(c1), m_c2(c2), m_size(size) {}
-
-        unsigned size() const { return m_size; }
-        color_type operator [] (unsigned v) const 
-        {
-            return m_c1.gradient(m_c2, double(v) / double(m_size - 1));
-        }
-
-        void colors(const color_type& c1, const color_type& c2, unsigned size = 256)
-        {
-            m_c1 = c1;
-            m_c2 = c2;
-            m_size = size;
-        }
-
-        color_type m_c1;
-        color_type m_c2;
-        unsigned m_size;
-    };
-
-
-
-
-
-
-    //==========================================================gradient_circle
-    class gradient_circle
-    {
-        // Actually the same as radial. Just for compatibility
-    public:
-        static AGG_INLINE int calculate(int x, int y, int)
-        {
-            return int(fast_sqrt(x*x + y*y));
-        }
-    };
-
-
-    //==========================================================gradient_radial
-    class gradient_radial
-    {
-    public:
-        static AGG_INLINE int calculate(int x, int y, int)
-        {
-            return int(fast_sqrt(x*x + y*y));
-        }
-    };
-
-    //========================================================gradient_radial_d
-    class gradient_radial_d
-    {
-    public:
-        static AGG_INLINE int calculate(int x, int y, int)
-        {
-            return uround(sqrt(double(x)*double(x) + double(y)*double(y)));
-        }
-    };
-
-    //====================================================gradient_radial_focus
-    class gradient_radial_focus
-    {
-    public:
-        //---------------------------------------------------------------------
-        gradient_radial_focus() : 
-            m_r(100 * gradient_subpixel_scale), 
-            m_fx(0), 
-            m_fy(0)
-        {
-            update_values();
-        }
-
-        //---------------------------------------------------------------------
-        gradient_radial_focus(double r, double fx, double fy) : 
-            m_r (iround(r  * gradient_subpixel_scale)), 
-            m_fx(iround(fx * gradient_subpixel_scale)), 
-            m_fy(iround(fy * gradient_subpixel_scale))
-        {
-            update_values();
-        }
-
-        //---------------------------------------------------------------------
-        void init(double r, double fx, double fy)
-        {
-            m_r  = iround(r  * gradient_subpixel_scale);
-            m_fx = iround(fx * gradient_subpixel_scale);
-            m_fy = iround(fy * gradient_subpixel_scale);
-            update_values();
-        }
-
-        //---------------------------------------------------------------------
-        double radius()  const { return double(m_r)  / gradient_subpixel_scale; }
-        double focus_x() const { return double(m_fx) / gradient_subpixel_scale; }
-        double focus_y() const { return double(m_fy) / gradient_subpixel_scale; }
-
-        //---------------------------------------------------------------------
-        int calculate(int x, int y, int) const
-        {
-            double dx = x - m_fx;
-            double dy = y - m_fy;
-            double d2 = dx * m_fy - dy * m_fx;
-            double d3 = m_r2 * (dx * dx + dy * dy) - d2 * d2;
-            return iround((dx * m_fx + dy * m_fy + sqrt(fabs(d3))) * m_mul);
-        }
-
-    private:
-        //---------------------------------------------------------------------
-        void update_values()
-        {
-            // Calculate the invariant values. In case the focal center
-            // lies exactly on the gradient circle the divisor degenerates
-            // into zero. In this case we just move the focal center by
-            // one subpixel unit possibly in the direction to the origin (0,0)
-            // and calculate the values again.
-            //-------------------------
-            m_r2  = double(m_r)  * double(m_r);
-            m_fx2 = double(m_fx) * double(m_fx);
-            m_fy2 = double(m_fy) * double(m_fy);
-            double d = (m_r2 - (m_fx2 + m_fy2));
-            if(d == 0)
-            {
-                if(m_fx) { if(m_fx < 0) ++m_fx; else --m_fx; }
-                if(m_fy) { if(m_fy < 0) ++m_fy; else --m_fy; }
-                m_fx2 = double(m_fx) * double(m_fx);
-                m_fy2 = double(m_fy) * double(m_fy);
-                d = (m_r2 - (m_fx2 + m_fy2));
-            }
-            m_mul = m_r / d;
-        }
-
-        int    m_r;
-        int    m_fx;
-        int    m_fy;
-        double m_r2;
-        double m_fx2;
-        double m_fy2;
-        double m_mul;
-    };
-
-
-    //==============================================================gradient_x
-    class gradient_x
-    {
-    public:
-        static int calculate(int x, int, int) { return x; }
-    };
-
-
-    //==============================================================gradient_y
-    class gradient_y
-    {
-    public:
-        static int calculate(int, int y, int) { return y; }
-    };
-
-    //========================================================gradient_diamond
-    class gradient_diamond
-    {
-    public:
-        static AGG_INLINE int calculate(int x, int y, int) 
-        { 
-            int ax = abs(x);
-            int ay = abs(y);
-            return ax > ay ? ax : ay; 
-        }
-    };
-
-    //=============================================================gradient_xy
-    class gradient_xy
-    {
-    public:
-        static AGG_INLINE int calculate(int x, int y, int d) 
-        { 
-            return abs(x) * abs(y) / d; 
-        }
-    };
-
-    //========================================================gradient_sqrt_xy
-    class gradient_sqrt_xy
-    {
-    public:
-        static AGG_INLINE int calculate(int x, int y, int) 
-        { 
-            return fast_sqrt(abs(x) * abs(y)); 
-        }
-    };
-
-    //==========================================================gradient_conic
-    class gradient_conic
-    {
-    public:
-        static AGG_INLINE int calculate(int x, int y, int d) 
-        { 
-            return uround(fabs(atan2(double(y), double(x))) * double(d) / pi);
-        }
-    };
-
-    //=================================================gradient_repeat_adaptor
-    template<class GradientF> class gradient_repeat_adaptor
-    {
-    public:
-        gradient_repeat_adaptor(const GradientF& gradient) : 
-            m_gradient(&gradient) {}
-
-        AGG_INLINE int calculate(int x, int y, int d) const
-        {
-            int ret = m_gradient->calculate(x, y, d) % d;
-            if(ret < 0) ret += d;
-            return ret;
-        }
-
-    private:
-        const GradientF* m_gradient;
-    };
-
-    //================================================gradient_reflect_adaptor
-    template<class GradientF> class gradient_reflect_adaptor
-    {
-    public:
-        gradient_reflect_adaptor(const GradientF& gradient) : 
-            m_gradient(&gradient) {}
-
-        AGG_INLINE int calculate(int x, int y, int d) const
-        {
-            int d2 = d << 1;
-            int ret = m_gradient->calculate(x, y, d) % d2;
-            if(ret <  0) ret += d2;
-            if(ret >= d) ret  = d2 - ret;
-            return ret;
-        }
-
-    private:
-        const GradientF* m_gradient;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_gradient_alpha.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gradient_alpha.h
--- 8.0.1-5/renderers/agg/include/agg_span_gradient_alpha.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_gradient_alpha.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,126 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_GRADIENT_ALPHA_INCLUDED
-#define AGG_SPAN_GRADIENT_ALPHA_INCLUDED
-
-#include "agg_span_gradient.h"
-
-namespace mapserver
-{
-    //======================================================span_gradient_alpha
-    template<class ColorT, 
-             class Interpolator,
-             class GradientF, 
-             class AlphaF>
-    class span_gradient_alpha
-    {
-    public:
-        typedef Interpolator interpolator_type;
-        typedef ColorT color_type;
-        typedef typename color_type::value_type alpha_type;
-
-        enum downscale_shift_e
-        {
-            downscale_shift = interpolator_type::subpixel_shift - gradient_subpixel_shift
-        };
-
-
-        //--------------------------------------------------------------------
-        span_gradient_alpha() {}
-
-        //--------------------------------------------------------------------
-        span_gradient_alpha(interpolator_type& inter,
-                            const GradientF& gradient_function,
-                            const AlphaF& alpha_function,
-                            double d1, double d2) : 
-            m_interpolator(&inter),
-            m_gradient_function(&gradient_function),
-            m_alpha_function(&alpha_function),
-            m_d1(iround(d1 * gradient_subpixel_scale)),
-            m_d2(iround(d2 * gradient_subpixel_scale))
-        {}
-
-        //--------------------------------------------------------------------
-        interpolator_type& interpolator() { return *m_interpolator; }
-        const GradientF& gradient_function() const { return *m_gradient_function; }
-        const AlphaF& alpha_function() const { return *m_alpha_function; }
-        double d1() const { return double(m_d1) / gradient_subpixel_scale; }
-        double d2() const { return double(m_d2) / gradient_subpixel_scale; }
-
-        //--------------------------------------------------------------------
-        void interpolator(interpolator_type& i) { m_interpolator = &i; }
-        void gradient_function(const GradientF& gf) { m_gradient_function = &gf; }
-        void alpha_function(const AlphaF& af) { m_alpha_function = &af; }
-        void d1(double v) { m_d1 = iround(v * gradient_subpixel_scale); }
-        void d2(double v) { m_d2 = iround(v * gradient_subpixel_scale); }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {   
-            int dd = m_d2 - m_d1;
-            if(dd < 1) dd = 1;
-            m_interpolator->begin(x+0.5, y+0.5, len);
-            do
-            {
-                m_interpolator->coordinates(&x, &y);
-                int d = m_gradient_function->calculate(x >> downscale_shift, 
-                                                       y >> downscale_shift, m_d2);
-                d = ((d - m_d1) * (int)m_alpha_function->size()) / dd;
-                if(d < 0) d = 0;
-                if(d >= (int)m_alpha_function->size()) d = m_alpha_function->size() - 1;
-                span->a = (*m_alpha_function)[d];
-                ++span;
-                ++(*m_interpolator);
-            }
-            while(--len);
-        }
-
-    private:
-        interpolator_type* m_interpolator;
-        const GradientF*   m_gradient_function;
-        const AlphaF*      m_alpha_function;
-        int                m_d1;
-        int                m_d2;
-    };
-
-
-    //=======================================================gradient_alpha_x
-    template<class ColorT> struct gradient_alpha_x
-    {
-        typedef typename ColorT::value_type alpha_type;
-        alpha_type operator [] (alpha_type x) const { return x; }
-    };
-
-    //====================================================gradient_alpha_x_u8
-    struct gradient_alpha_x_u8
-    {
-        typedef int8u alpha_type;
-        alpha_type operator [] (alpha_type x) const { return x; }
-    };
-
-    //==========================================gradient_alpha_one_munus_x_u8
-    struct gradient_alpha_one_munus_x_u8
-    {
-        typedef int8u alpha_type;
-        alpha_type operator [] (alpha_type x) const { return 255-x; }
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_image_filter.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter.h
--- 8.0.1-5/renderers/agg/include/agg_span_image_filter.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,246 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Image transformations with filtering. Span generator base class
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_SPAN_IMAGE_FILTER_INCLUDED
-#define AGG_SPAN_IMAGE_FILTER_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_image_filters.h"
-#include "agg_span_interpolator_linear.h"
-
-namespace mapserver
-{
-
-    //-------------------------------------------------------span_image_filter
-    template<class Source, class Interpolator> class span_image_filter
-    {
-    public:
-        typedef Source source_type;
-        typedef Interpolator interpolator_type;
-
-        //--------------------------------------------------------------------
-        span_image_filter() {}
-        span_image_filter(source_type& src, 
-                          interpolator_type& interpolator,
-                          const image_filter_lut* filter) : 
-            m_src(&src),
-            m_interpolator(&interpolator),
-            m_filter(filter),
-            m_dx_dbl(0.5),
-            m_dy_dbl(0.5),
-            m_dx_int(image_subpixel_scale / 2),
-            m_dy_int(image_subpixel_scale / 2)
-        {}
-        void attach(source_type& v) { m_src = &v; }
-
-        //--------------------------------------------------------------------
-               source_type& source()            { return *m_src; }
-        const  source_type& source()      const { return *m_src; }
-        const  image_filter_lut& filter() const { return *m_filter; }
-        int    filter_dx_int()            const { return m_dx_int; }
-        int    filter_dy_int()            const { return m_dy_int; }
-        double filter_dx_dbl()            const { return m_dx_dbl; }
-        double filter_dy_dbl()            const { return m_dy_dbl; }
-
-        //--------------------------------------------------------------------
-        void interpolator(interpolator_type& v)  { m_interpolator = &v; }
-        void filter(const image_filter_lut& v)   { m_filter = &v; }
-        void filter_offset(double dx, double dy)
-        {
-            m_dx_dbl = dx;
-            m_dy_dbl = dy;
-            m_dx_int = iround(dx * image_subpixel_scale);
-            m_dy_int = iround(dy * image_subpixel_scale);
-        }
-        void filter_offset(double d) { filter_offset(d, d); }
-
-        //--------------------------------------------------------------------
-        interpolator_type& interpolator() { return *m_interpolator; }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-
-        //--------------------------------------------------------------------
-    private:
-        source_type*            m_src;
-        interpolator_type*      m_interpolator;
-        const image_filter_lut* m_filter;
-        double   m_dx_dbl;
-        double   m_dy_dbl;
-        unsigned m_dx_int;
-        unsigned m_dy_int;
-    };
-
-
-
-
-    //==============================================span_image_resample_affine
-    template<class Source> 
-    class span_image_resample_affine : 
-    public span_image_filter<Source, span_interpolator_linear<trans_affine> >
-    {
-    public:
-        typedef Source source_type;
-        typedef span_interpolator_linear<trans_affine> interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-
-        //--------------------------------------------------------------------
-        span_image_resample_affine() : 
-            m_scale_limit(200.0),
-            m_blur_x(1.0),
-            m_blur_y(1.0)
-        {}
-
-        //--------------------------------------------------------------------
-        span_image_resample_affine(source_type& src, 
-                                   interpolator_type& inter,
-                                   const image_filter_lut& filter) :
-            base_type(src, inter, &filter),
-            m_scale_limit(200.0),
-            m_blur_x(1.0),
-            m_blur_y(1.0)
-        {}
-
-
-        //--------------------------------------------------------------------
-        int  scale_limit() const { return uround(m_scale_limit); }
-        void scale_limit(int v)  { m_scale_limit = v; }
-
-        //--------------------------------------------------------------------
-        double blur_x() const { return m_blur_x; }
-        double blur_y() const { return m_blur_y; }
-        void blur_x(double v) { m_blur_x = v; }
-        void blur_y(double v) { m_blur_y = v; }
-        void blur(double v) { m_blur_x = m_blur_y = v; }
-
-        //--------------------------------------------------------------------
-        void prepare() 
-        {
-            double scale_x;
-            double scale_y;
-
-            base_type::interpolator().transformer().scaling_abs(&scale_x, &scale_y);
-
-            if(scale_x * scale_y > m_scale_limit)
-            {
-                scale_x = scale_x * m_scale_limit / (scale_x * scale_y);
-                scale_y = scale_y * m_scale_limit / (scale_x * scale_y);
-            }
-
-            if(scale_x < 1) scale_x = 1;
-            if(scale_y < 1) scale_y = 1;
-
-            if(scale_x > m_scale_limit) scale_x = m_scale_limit;
-            if(scale_y > m_scale_limit) scale_y = m_scale_limit;
-
-            scale_x *= m_blur_x;
-            scale_y *= m_blur_y;
-
-            if(scale_x < 1) scale_x = 1;
-            if(scale_y < 1) scale_y = 1;
-
-            m_rx     = uround(    scale_x * double(image_subpixel_scale));
-            m_rx_inv = uround(1.0/scale_x * double(image_subpixel_scale));
-
-            m_ry     = uround(    scale_y * double(image_subpixel_scale));
-            m_ry_inv = uround(1.0/scale_y * double(image_subpixel_scale));
-        }
-
-    protected:
-        int m_rx;
-        int m_ry;
-        int m_rx_inv;
-        int m_ry_inv;
-
-    private:
-        double m_scale_limit;
-        double m_blur_x;
-        double m_blur_y;
-    };
-
-
-
-    //=====================================================span_image_resample
-    template<class Source, class Interpolator> 
-    class span_image_resample : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-
-        //--------------------------------------------------------------------
-        span_image_resample() : 
-            m_scale_limit(20),
-            m_blur_x(image_subpixel_scale),
-            m_blur_y(image_subpixel_scale)
-        {}
-
-        //--------------------------------------------------------------------
-        span_image_resample(source_type& src, 
-                            interpolator_type& inter,
-                            const image_filter_lut& filter) :
-            base_type(src, inter, &filter),
-            m_scale_limit(20),
-            m_blur_x(image_subpixel_scale),
-            m_blur_y(image_subpixel_scale)
-        {}
-
-        //--------------------------------------------------------------------
-        int  scale_limit() const { return m_scale_limit; }
-        void scale_limit(int v)  { m_scale_limit = v; }
-
-        //--------------------------------------------------------------------
-        double blur_x() const { return double(m_blur_x) / double(image_subpixel_scale); }
-        double blur_y() const { return double(m_blur_y) / double(image_subpixel_scale); }
-        void blur_x(double v) { m_blur_x = uround(v * double(image_subpixel_scale)); }
-        void blur_y(double v) { m_blur_y = uround(v * double(image_subpixel_scale)); }
-        void blur(double v)   { m_blur_x = 
-                                m_blur_y = uround(v * double(image_subpixel_scale)); }
-
-    protected:
-        AGG_INLINE void adjust_scale(int* rx, int* ry)
-        {
-            if(*rx < image_subpixel_scale) *rx = image_subpixel_scale;
-            if(*ry < image_subpixel_scale) *ry = image_subpixel_scale;
-            if(*rx > image_subpixel_scale * m_scale_limit) 
-            {
-                *rx = image_subpixel_scale * m_scale_limit;
-            }
-            if(*ry > image_subpixel_scale * m_scale_limit) 
-            {
-                *ry = image_subpixel_scale * m_scale_limit;
-            }
-            *rx = (*rx * m_blur_x) >> image_subpixel_shift;
-            *ry = (*ry * m_blur_y) >> image_subpixel_shift;
-            if(*rx < image_subpixel_scale) *rx = image_subpixel_scale;
-            if(*ry < image_subpixel_scale) *ry = image_subpixel_scale;
-        }
-
-        int m_scale_limit;
-        int m_blur_x;
-        int m_blur_y;
-    };
-
-
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_image_filter_gray.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter_gray.h
--- 8.0.1-5/renderers/agg/include/agg_span_image_filter_gray.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter_gray.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,748 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-#ifndef AGG_SPAN_IMAGE_FILTER_GRAY_INCLUDED
-#define AGG_SPAN_IMAGE_FILTER_GRAY_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_gray.h"
-#include "agg_span_image_filter.h"
-
-
-namespace mapserver
-{
-
-    //==============================================span_image_filter_gray_nn
-    template<class Source, class Interpolator> 
-    class span_image_filter_gray_nn : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_gray_nn() {}
-        span_image_filter_gray_nn(source_type& src, 
-                                  interpolator_type& inter) :
-            base_type(src, inter, 0) 
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-                span->v = *(const value_type*)
-                    base_type::source().span(x >> image_subpixel_shift, 
-                                             y >> image_subpixel_shift, 
-                                             1);
-                span->a = base_mask;
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-
-    //=========================================span_image_filter_gray_bilinear
-    template<class Source, class Interpolator> 
-    class span_image_filter_gray_bilinear : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_gray_bilinear() {}
-        span_image_filter_gray_bilinear(source_type& src, 
-                                        interpolator_type& inter) :
-            base_type(src, inter, 0) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            calc_type fg;
-            const value_type *fg_ptr;
-            do
-            {
-                int x_hr;
-                int y_hr;
-
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                fg = image_subpixel_scale * image_subpixel_scale / 2;
-
-                x_hr &= image_subpixel_mask;
-                y_hr &= image_subpixel_mask;
-
-                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
-                fg    += *fg_ptr * (image_subpixel_scale - x_hr) * (image_subpixel_scale - y_hr);
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                fg    += *fg_ptr * x_hr * (image_subpixel_scale - y_hr);
-
-                fg_ptr = (const value_type*)base_type::source().next_y();
-                fg    += *fg_ptr * (image_subpixel_scale - x_hr) * y_hr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                fg    += *fg_ptr * x_hr * y_hr;
-
-                span->v = value_type(fg >> (image_subpixel_shift * 2));
-                span->a = base_mask;
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-    //====================================span_image_filter_gray_bilinear_clip
-    template<class Source, class Interpolator> 
-    class span_image_filter_gray_bilinear_clip : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_gray_bilinear_clip() {}
-        span_image_filter_gray_bilinear_clip(source_type& src, 
-                                             const color_type& back_color,
-                                             interpolator_type& inter) :
-            base_type(src, inter, 0), 
-            m_back_color(back_color)
-        {}
-        const color_type& background_color() const { return m_back_color; }
-        void background_color(const color_type& v)   { m_back_color = v; }
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            calc_type fg;
-            calc_type src_alpha;
-            value_type back_v = m_back_color.v;
-            value_type back_a = m_back_color.a;
-
-            const value_type *fg_ptr;
-
-            int maxx = base_type::source().width() - 1;
-            int maxy = base_type::source().height() - 1;
-
-            do
-            {
-                int x_hr;
-                int y_hr;
-                
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                if(x_lr >= 0    && y_lr >= 0 &&
-                   x_lr <  maxx && y_lr <  maxy) 
-                {
-                    fg = image_subpixel_scale * image_subpixel_scale / 2;
-
-                    x_hr &= image_subpixel_mask;
-                    y_hr &= image_subpixel_mask;
-                    fg_ptr = (const value_type*)base_type::source().row_ptr(y_lr) + x_lr;
-
-                    fg += *fg_ptr++ * (image_subpixel_scale - x_hr) * (image_subpixel_scale - y_hr);
-                    fg += *fg_ptr++ * (image_subpixel_scale - y_hr) * x_hr;
-
-                    ++y_lr;
-                    fg_ptr = (const value_type*)base_type::source().row_ptr(y_lr) + x_lr;
-
-                    fg += *fg_ptr++ * (image_subpixel_scale - x_hr) * y_hr;
-                    fg += *fg_ptr++ * x_hr * y_hr;
-
-                    fg >>= image_subpixel_shift * 2;
-                    src_alpha = base_mask;
-                }
-                else
-                {
-                    unsigned weight;
-                    if(x_lr < -1   || y_lr < -1 ||
-                       x_lr > maxx || y_lr > maxy)
-                    {
-                        fg        = back_v;
-                        src_alpha = back_a;
-                    }
-                    else
-                    {
-                        fg = 
-                        src_alpha = image_subpixel_scale * image_subpixel_scale / 2;
-
-                        x_hr &= image_subpixel_mask;
-                        y_hr &= image_subpixel_mask;
-
-                        weight = (image_subpixel_scale - x_hr) * 
-                                 (image_subpixel_scale - y_hr);
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg += weight * 
-                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg        += back_v * weight;
-                            src_alpha += back_a * weight;
-                        }
-
-                        x_lr++;
-
-                        weight = x_hr * (image_subpixel_scale - y_hr);
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg += weight * 
-                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg        += back_v * weight;
-                            src_alpha += back_a * weight;
-                        }
-
-                        x_lr--;
-                        y_lr++;
-
-                        weight = (image_subpixel_scale - x_hr) * y_hr;
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg += weight * 
-                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg        += back_v * weight;
-                            src_alpha += back_a * weight;
-                        }
-
-                        x_lr++;
-
-                        weight = x_hr * y_hr;
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg += weight * 
-                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg        += back_v * weight;
-                            src_alpha += back_a * weight;
-                        }
-
-                        fg        >>= image_subpixel_shift * 2;
-                        src_alpha >>= image_subpixel_shift * 2;
-                    }
-                }
-
-                span->v = (value_type)fg;
-                span->a = (value_type)src_alpha;
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    private:
-        color_type m_back_color;
-    };
-
-
-
-    //==============================================span_image_filter_gray_2x2
-    template<class Source, class Interpolator> 
-    class span_image_filter_gray_2x2 : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_gray_2x2() {}
-        span_image_filter_gray_2x2(source_type& src, 
-                                   interpolator_type& inter,
-                                   const image_filter_lut& filter) :
-            base_type(src, inter, &filter) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            calc_type fg;
-
-            const value_type *fg_ptr;
-            const int16* weight_array = base_type::filter().weight_array() + 
-                                        ((base_type::filter().diameter()/2 - 1) << 
-                                          image_subpixel_shift);
-            do
-            {
-                int x_hr;
-                int y_hr;
-
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                unsigned weight;
-                fg = image_filter_scale / 2;
-
-                x_hr &= image_subpixel_mask;
-                y_hr &= image_subpixel_mask;
-
-                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
-                weight = (weight_array[x_hr + image_subpixel_scale] * 
-                          weight_array[y_hr + image_subpixel_scale] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = (weight_array[x_hr] * 
-                          weight_array[y_hr + image_subpixel_scale] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_y();
-                weight = (weight_array[x_hr + image_subpixel_scale] * 
-                          weight_array[y_hr] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = (weight_array[x_hr] * 
-                          weight_array[y_hr] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg += weight * *fg_ptr;
-
-                fg >>= image_filter_shift;
-                if(fg > base_mask) fg = base_mask;
-
-                span->v = (value_type)fg;
-                span->a = base_mask;
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-
-    //==================================================span_image_filter_gray
-    template<class Source, class Interpolator> 
-    class span_image_filter_gray : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_gray() {}
-        span_image_filter_gray(source_type& src, 
-                               interpolator_type& inter,
-                               const image_filter_lut& filter) :
-            base_type(src, inter, &filter) 
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            int fg;
-            const value_type *fg_ptr;
-
-            unsigned     diameter     = base_type::filter().diameter();
-            int          start        = base_type::filter().start();
-            const int16* weight_array = base_type::filter().weight_array();
-
-            int x_count; 
-            int weight_y;
-
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-
-                x -= base_type::filter_dx_int();
-                y -= base_type::filter_dy_int();
-
-                int x_hr = x; 
-                int y_hr = y; 
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                fg = image_filter_scale / 2;
-
-                int x_fract = x_hr & image_subpixel_mask;
-                unsigned y_count = diameter;
-
-                y_hr = image_subpixel_mask - (y_hr & image_subpixel_mask);
-                fg_ptr = (const value_type*)base_type::source().span(x_lr + start, 
-                                                                     y_lr + start, 
-                                                                     diameter);
-                for(;;)
-                {
-                    x_count  = diameter;
-                    weight_y = weight_array[y_hr];
-                    x_hr = image_subpixel_mask - x_fract;
-                    for(;;)
-                    {
-                        fg += *fg_ptr * 
-                              ((weight_y * weight_array[x_hr] + 
-                                image_filter_scale / 2) >> 
-                                image_filter_shift);
-                        if(--x_count == 0) break;
-                        x_hr  += image_subpixel_scale;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-
-                    if(--y_count == 0) break;
-                    y_hr  += image_subpixel_scale;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg >>= image_filter_shift;
-                if(fg < 0) fg = 0;
-                if(fg > base_mask) fg = base_mask;
-                span->v = (value_type)fg;
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //=========================================span_image_resample_gray_affine
-    template<class Source> 
-    class span_image_resample_gray_affine : 
-    public span_image_resample_affine<Source>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef span_image_resample_affine<source_type> base_type;
-        typedef typename base_type::interpolator_type interpolator_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        {
-            base_shift      = color_type::base_shift,
-            base_mask       = color_type::base_mask,
-            downscale_shift = image_filter_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_image_resample_gray_affine() {}
-        span_image_resample_gray_affine(source_type& src, 
-                                        interpolator_type& inter,
-                                        const image_filter_lut& filter) :
-            base_type(src, inter, filter) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            long_type fg;
-
-            int diameter     = base_type::filter().diameter();
-            int filter_scale = diameter << image_subpixel_shift;
-            int radius_x     = (diameter * base_type::m_rx) >> 1;
-            int radius_y     = (diameter * base_type::m_ry) >> 1;
-            int len_x_lr     = 
-                (diameter * base_type::m_rx + image_subpixel_mask) >> 
-                    image_subpixel_shift;
-
-            const int16* weight_array = base_type::filter().weight_array();
-
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-
-                x += base_type::filter_dx_int() - radius_x;
-                y += base_type::filter_dy_int() - radius_y;
-
-                fg = image_filter_scale / 2;
-
-                int y_lr = y >> image_subpixel_shift;
-                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
-                                base_type::m_ry_inv) >> 
-                                    image_subpixel_shift;
-                int total_weight = 0;
-                int x_lr = x >> image_subpixel_shift;
-                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
-                                base_type::m_rx_inv) >> 
-                                    image_subpixel_shift;
-
-                int x_hr2 = x_hr;
-                const value_type* fg_ptr = 
-                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
-                for(;;)
-                {
-                    int weight_y = weight_array[y_hr];
-                    x_hr = x_hr2;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     downscale_shift;
-
-                        fg += *fg_ptr * weight;
-                        total_weight += weight;
-                        x_hr  += base_type::m_rx_inv;
-                        if(x_hr >= filter_scale) break;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-                    y_hr += base_type::m_ry_inv;
-                    if(y_hr >= filter_scale) break;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg /= total_weight;
-                if(fg < 0) fg = 0;
-                if(fg > base_mask) fg = base_mask;
-
-                span->v = (value_type)fg;
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-
-    //================================================span_image_resample_gray
-    template<class Source, class Interpolator>
-    class span_image_resample_gray : 
-    public span_image_resample<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_resample<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask,
-            downscale_shift = image_filter_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_image_resample_gray() {}
-        span_image_resample_gray(source_type& src, 
-                                 interpolator_type& inter,
-                                 const image_filter_lut& filter) :
-            base_type(src, inter, filter)
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            long_type fg;
-
-            int diameter = base_type::filter().diameter();
-            int filter_scale = diameter << image_subpixel_shift;
-
-            const int16* weight_array = base_type::filter().weight_array();
-            do
-            {
-                int rx;
-                int ry;
-                int rx_inv = image_subpixel_scale;
-                int ry_inv = image_subpixel_scale;
-                base_type::interpolator().coordinates(&x,  &y);
-                base_type::interpolator().local_scale(&rx, &ry);
-                base_type::adjust_scale(&rx, &ry);
-
-                rx_inv = image_subpixel_scale * image_subpixel_scale / rx;
-                ry_inv = image_subpixel_scale * image_subpixel_scale / ry;
-
-                int radius_x = (diameter * rx) >> 1;
-                int radius_y = (diameter * ry) >> 1;
-                int len_x_lr = 
-                    (diameter * rx + image_subpixel_mask) >> 
-                        image_subpixel_shift;
-
-                x += base_type::filter_dx_int() - radius_x;
-                y += base_type::filter_dy_int() - radius_y;
-
-                fg = image_filter_scale / 2;
-
-                int y_lr = y >> image_subpixel_shift;
-                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
-                               ry_inv) >> 
-                                   image_subpixel_shift;
-                int total_weight = 0;
-                int x_lr = x >> image_subpixel_shift;
-                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
-                               rx_inv) >> 
-                                   image_subpixel_shift;
-                int x_hr2 = x_hr;
-                const value_type* fg_ptr = 
-                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
-
-                for(;;)
-                {
-                    int weight_y = weight_array[y_hr];
-                    x_hr = x_hr2;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     downscale_shift;
-                        fg += *fg_ptr * weight;
-                        total_weight += weight;
-                        x_hr  += rx_inv;
-                        if(x_hr >= filter_scale) break;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-                    y_hr += ry_inv;
-                    if(y_hr >= filter_scale) break;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg /= total_weight;
-                if(fg < 0) fg = 0;
-                if(fg > base_mask) fg = base_mask;
-
-                span->v = (value_type)fg;
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-}
-
-
-#endif
-
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_image_filter_rgb.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter_rgb.h
--- 8.0.1-5/renderers/agg/include/agg_span_image_filter_rgb.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter_rgb.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,892 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-#ifndef AGG_SPAN_IMAGE_FILTER_RGB_INCLUDED
-#define AGG_SPAN_IMAGE_FILTER_RGB_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_rgba.h"
-#include "agg_span_image_filter.h"
-
-
-namespace mapserver
-{
-
-    //===============================================span_image_filter_rgb_nn
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgb_nn : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgb_nn() {}
-        span_image_filter_rgb_nn(source_type& src, 
-                                 interpolator_type& inter) :
-            base_type(src, inter, 0) 
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-                const value_type* fg_ptr = (const value_type*)
-                    base_type::source().span(x >> image_subpixel_shift, 
-                                             y >> image_subpixel_shift, 
-                                             1);
-                span->r = fg_ptr[order_type::R];
-                span->g = fg_ptr[order_type::G];
-                span->b = fg_ptr[order_type::B];
-                span->a = base_mask;
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //==========================================span_image_filter_rgb_bilinear
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgb_bilinear : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgb_bilinear() {}
-        span_image_filter_rgb_bilinear(source_type& src, 
-                                       interpolator_type& inter) :
-            base_type(src, inter, 0) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            calc_type fg[3];
-            const value_type *fg_ptr;
-            do
-            {
-                int x_hr;
-                int y_hr;
-
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                unsigned weight;
-
-                fg[0] = 
-                fg[1] = 
-                fg[2] = image_subpixel_scale * image_subpixel_scale / 2;
-
-                x_hr &= image_subpixel_mask;
-                y_hr &= image_subpixel_mask;
-
-                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
-                weight = (image_subpixel_scale - x_hr) * 
-                         (image_subpixel_scale - y_hr);
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = x_hr * (image_subpixel_scale - y_hr);
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_y();
-                weight = (image_subpixel_scale - x_hr) * y_hr;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = x_hr * y_hr;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                span->r = value_type(fg[order_type::R] >> (image_subpixel_shift * 2));
-                span->g = value_type(fg[order_type::G] >> (image_subpixel_shift * 2));
-                span->b = value_type(fg[order_type::B] >> (image_subpixel_shift * 2));
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //=====================================span_image_filter_rgb_bilinear_clip
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgb_bilinear_clip : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgb_bilinear_clip() {}
-        span_image_filter_rgb_bilinear_clip(source_type& src, 
-                                            const color_type& back_color,
-                                            interpolator_type& inter) :
-            base_type(src, inter, 0),
-            m_back_color(back_color)
-        {}
-        const color_type& background_color() const { return m_back_color; }
-        void background_color(const color_type& v)   { m_back_color = v; }
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            calc_type fg[3];
-            calc_type src_alpha;
-            value_type back_r = m_back_color.r;
-            value_type back_g = m_back_color.g;
-            value_type back_b = m_back_color.b;
-            value_type back_a = m_back_color.a;
-
-            const value_type *fg_ptr;
-
-            int maxx = base_type::source().width() - 1;
-            int maxy = base_type::source().height() - 1;
-
-            do
-            {
-                int x_hr;
-                int y_hr;
-                
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-                unsigned weight;
-
-                if(x_lr >= 0    && y_lr >= 0 &&
-                   x_lr <  maxx && y_lr <  maxy) 
-                {
-                    fg[0] = 
-                    fg[1] = 
-                    fg[2] = image_subpixel_scale * image_subpixel_scale / 2;
-
-                    x_hr &= image_subpixel_mask;
-                    y_hr &= image_subpixel_mask;
-
-                    fg_ptr = (const value_type*)
-                        base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
-
-                    weight = (image_subpixel_scale - x_hr) * 
-                             (image_subpixel_scale - y_hr);
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-
-                    weight = x_hr * (image_subpixel_scale - y_hr);
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-
-                    ++y_lr;
-                    fg_ptr = (const value_type*)
-                        base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
-
-                    weight = (image_subpixel_scale - x_hr) * y_hr;
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-
-                    weight = x_hr * y_hr;
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-
-                    fg[0] >>= image_subpixel_shift * 2;
-                    fg[1] >>= image_subpixel_shift * 2;
-                    fg[2] >>= image_subpixel_shift * 2;
-                    src_alpha = base_mask;
-                }
-                else
-                {
-                    if(x_lr < -1   || y_lr < -1 ||
-                       x_lr > maxx || y_lr > maxy)
-                    {
-                        fg[order_type::R] = back_r;
-                        fg[order_type::G] = back_g;
-                        fg[order_type::B] = back_b;
-                        src_alpha         = back_a;
-                    }
-                    else
-                    {
-                        fg[0] = 
-                        fg[1] = 
-                        fg[2] = 
-                        src_alpha = image_subpixel_scale * image_subpixel_scale / 2;
-
-                        x_hr &= image_subpixel_mask;
-                        y_hr &= image_subpixel_mask;
-
-                        weight = (image_subpixel_scale - x_hr) * 
-                                 (image_subpixel_scale - y_hr);
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
-
-                            fg[0] += weight * *fg_ptr++;
-                            fg[1] += weight * *fg_ptr++;
-                            fg[2] += weight * *fg_ptr++;
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            src_alpha         += back_a * weight;
-                        }
-
-                        x_lr++;
-
-                        weight = x_hr * (image_subpixel_scale - y_hr);
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
-
-                            fg[0]     += weight * *fg_ptr++;
-                            fg[1]     += weight * *fg_ptr++;
-                            fg[2]     += weight * *fg_ptr++;
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            src_alpha         += back_a * weight;
-                        }
-
-                        x_lr--;
-                        y_lr++;
-
-                        weight = (image_subpixel_scale - x_hr) * y_hr;
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
-
-                            fg[0] += weight * *fg_ptr++;
-                            fg[1] += weight * *fg_ptr++;
-                            fg[2] += weight * *fg_ptr++;
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            src_alpha         += back_a * weight;
-                        }
-
-                        x_lr++;
-
-                        weight = x_hr * y_hr;
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
-
-                            fg[0] += weight * *fg_ptr++;
-                            fg[1] += weight * *fg_ptr++;
-                            fg[2] += weight * *fg_ptr++;
-                            src_alpha += weight * base_mask;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            src_alpha         += back_a * weight;
-                        }
-
-                        fg[0] >>= image_subpixel_shift * 2;
-                        fg[1] >>= image_subpixel_shift * 2;
-                        fg[2] >>= image_subpixel_shift * 2;
-                        src_alpha >>= image_subpixel_shift * 2;
-                    }
-                }
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = (value_type)src_alpha;
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    private:
-        color_type m_back_color;
-    };
-
-
-
-    //===============================================span_image_filter_rgb_2x2
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgb_2x2 : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgb_2x2() {}
-        span_image_filter_rgb_2x2(source_type& src, 
-                                  interpolator_type& inter,
-                                  const image_filter_lut& filter) :
-            base_type(src, inter, &filter) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            calc_type fg[3];
-
-            const value_type *fg_ptr;
-            const int16* weight_array = base_type::filter().weight_array() + 
-                                        ((base_type::filter().diameter()/2 - 1) << 
-                                          image_subpixel_shift);
-            do
-            {
-                int x_hr;
-                int y_hr;
-
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                unsigned weight;
-                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
-
-                x_hr &= image_subpixel_mask;
-                y_hr &= image_subpixel_mask;
-
-                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
-                weight = (weight_array[x_hr + image_subpixel_scale] * 
-                          weight_array[y_hr + image_subpixel_scale] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = (weight_array[x_hr] * 
-                          weight_array[y_hr + image_subpixel_scale] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_y();
-                weight = (weight_array[x_hr + image_subpixel_scale] * 
-                          weight_array[y_hr] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = (weight_array[x_hr] * 
-                          weight_array[y_hr] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr;
-
-                fg[0] >>= image_filter_shift;
-                fg[1] >>= image_filter_shift;
-                fg[2] >>= image_filter_shift;
-
-                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
-                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
-                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //===================================================span_image_filter_rgb
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgb : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgb() {}
-        span_image_filter_rgb(source_type& src, 
-                              interpolator_type& inter,
-                              const image_filter_lut& filter) :
-            base_type(src, inter, &filter) 
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            int fg[3];
-            const value_type *fg_ptr;
-
-            unsigned     diameter     = base_type::filter().diameter();
-            int          start        = base_type::filter().start();
-            const int16* weight_array = base_type::filter().weight_array();
-
-            int x_count; 
-            int weight_y;
-
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-
-                x -= base_type::filter_dx_int();
-                y -= base_type::filter_dy_int();
-
-                int x_hr = x; 
-                int y_hr = y; 
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
-
-                int x_fract = x_hr & image_subpixel_mask;
-                unsigned y_count = diameter;
-
-                y_hr = image_subpixel_mask - (y_hr & image_subpixel_mask);
-                fg_ptr = (const value_type*)base_type::source().span(x_lr + start, 
-                                                                     y_lr + start, 
-                                                                     diameter);
-                for(;;)
-                {
-                    x_count  = diameter;
-                    weight_y = weight_array[y_hr];
-                    x_hr = image_subpixel_mask - x_fract;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     image_filter_shift;
-
-                        fg[0] += weight * *fg_ptr++;
-                        fg[1] += weight * *fg_ptr++;
-                        fg[2] += weight * *fg_ptr;
-
-                        if(--x_count == 0) break;
-                        x_hr  += image_subpixel_scale;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-
-                    if(--y_count == 0) break;
-                    y_hr  += image_subpixel_scale;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg[0] >>= image_filter_shift;
-                fg[1] >>= image_filter_shift;
-                fg[2] >>= image_filter_shift;
-
-                if(fg[0] < 0) fg[0] = 0;
-                if(fg[1] < 0) fg[1] = 0;
-                if(fg[2] < 0) fg[2] = 0;
-
-                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
-                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
-                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //==========================================span_image_resample_rgb_affine
-    template<class Source> 
-    class span_image_resample_rgb_affine : 
-    public span_image_resample_affine<Source>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef span_image_resample_affine<source_type> base_type;
-        typedef typename base_type::interpolator_type interpolator_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        {
-            base_shift      = color_type::base_shift,
-            base_mask       = color_type::base_mask,
-            downscale_shift = image_filter_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_image_resample_rgb_affine() {}
-        span_image_resample_rgb_affine(source_type& src, 
-                                       interpolator_type& inter,
-                                       const image_filter_lut& filter) :
-            base_type(src, inter, filter) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            long_type fg[3];
-
-            int diameter     = base_type::filter().diameter();
-            int filter_scale = diameter << image_subpixel_shift;
-            int radius_x     = (diameter * base_type::m_rx) >> 1;
-            int radius_y     = (diameter * base_type::m_ry) >> 1;
-            int len_x_lr     = 
-                (diameter * base_type::m_rx + image_subpixel_mask) >> 
-                    image_subpixel_shift;
-
-            const int16* weight_array = base_type::filter().weight_array();
-
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-
-                x += base_type::filter_dx_int() - radius_x;
-                y += base_type::filter_dy_int() - radius_y;
-
-                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
-
-                int y_lr = y >> image_subpixel_shift;
-                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
-                                base_type::m_ry_inv) >> 
-                                    image_subpixel_shift;
-                int total_weight = 0;
-                int x_lr = x >> image_subpixel_shift;
-                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
-                                base_type::m_rx_inv) >> 
-                                    image_subpixel_shift;
-
-                int x_hr2 = x_hr;
-                const value_type* fg_ptr = 
-                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
-                for(;;)
-                {
-                    int weight_y = weight_array[y_hr];
-                    x_hr = x_hr2;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     downscale_shift;
-
-                        fg[0] += *fg_ptr++ * weight;
-                        fg[1] += *fg_ptr++ * weight;
-                        fg[2] += *fg_ptr   * weight;
-                        total_weight += weight;
-                        x_hr  += base_type::m_rx_inv;
-                        if(x_hr >= filter_scale) break;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-                    y_hr += base_type::m_ry_inv;
-                    if(y_hr >= filter_scale) break;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg[0] /= total_weight;
-                fg[1] /= total_weight;
-                fg[2] /= total_weight;
-
-                if(fg[0] < 0) fg[0] = 0;
-                if(fg[1] < 0) fg[1] = 0;
-                if(fg[2] < 0) fg[2] = 0;
-
-                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
-                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
-                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-
-    //=================================================span_image_resample_rgb
-    template<class Source, class Interpolator>
-    class span_image_resample_rgb : 
-    public span_image_resample<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_resample<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask,
-            downscale_shift = image_filter_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_image_resample_rgb() {}
-        span_image_resample_rgb(source_type& src, 
-                                interpolator_type& inter,
-                                const image_filter_lut& filter) :
-            base_type(src, inter, filter)
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            long_type fg[3];
-
-            int diameter = base_type::filter().diameter();
-            int filter_scale = diameter << image_subpixel_shift;
-
-            const int16* weight_array = base_type::filter().weight_array();
-            do
-            {
-                int rx;
-                int ry;
-                int rx_inv = image_subpixel_scale;
-                int ry_inv = image_subpixel_scale;
-                base_type::interpolator().coordinates(&x,  &y);
-                base_type::interpolator().local_scale(&rx, &ry);
-                base_type::adjust_scale(&rx, &ry);
-
-                rx_inv = image_subpixel_scale * image_subpixel_scale / rx;
-                ry_inv = image_subpixel_scale * image_subpixel_scale / ry;
-
-                int radius_x = (diameter * rx) >> 1;
-                int radius_y = (diameter * ry) >> 1;
-                int len_x_lr = 
-                    (diameter * rx + image_subpixel_mask) >> 
-                        image_subpixel_shift;
-
-                x += base_type::filter_dx_int() - radius_x;
-                y += base_type::filter_dy_int() - radius_y;
-
-                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
-
-                int y_lr = y >> image_subpixel_shift;
-                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
-                               ry_inv) >> 
-                                   image_subpixel_shift;
-                int total_weight = 0;
-                int x_lr = x >> image_subpixel_shift;
-                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
-                               rx_inv) >> 
-                                   image_subpixel_shift;
-                int x_hr2 = x_hr;
-                const value_type* fg_ptr = 
-                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
-
-                for(;;)
-                {
-                    int weight_y = weight_array[y_hr];
-                    x_hr = x_hr2;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     downscale_shift;
-                        fg[0] += *fg_ptr++ * weight;
-                        fg[1] += *fg_ptr++ * weight;
-                        fg[2] += *fg_ptr   * weight;
-                        total_weight += weight;
-                        x_hr  += rx_inv;
-                        if(x_hr >= filter_scale) break;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-                    y_hr += ry_inv;
-                    if(y_hr >= filter_scale) break;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg[0] /= total_weight;
-                fg[1] /= total_weight;
-                fg[2] /= total_weight;
-
-                if(fg[0] < 0) fg[0] = 0;
-                if(fg[1] < 0) fg[1] = 0;
-                if(fg[2] < 0) fg[2] = 0;
-
-                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
-                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
-                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = base_mask;
-
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-}
-
-
-#endif
-
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_image_filter_rgba.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter_rgba.h
--- 8.0.1-5/renderers/agg/include/agg_span_image_filter_rgba.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_image_filter_rgba.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,920 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-#ifndef AGG_SPAN_IMAGE_FILTER_RGBA_INCLUDED
-#define AGG_SPAN_IMAGE_FILTER_RGBA_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_rgba.h"
-#include "agg_span_image_filter.h"
-
-
-namespace mapserver
-{
-
-    //==============================================span_image_filter_rgba_nn
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgba_nn : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgba_nn() {}
-        span_image_filter_rgba_nn(source_type& src, 
-                                  interpolator_type& inter) :
-            base_type(src, inter, 0) 
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-                const value_type* fg_ptr = (const value_type*)
-                    base_type::source().span(x >> image_subpixel_shift, 
-                                             y >> image_subpixel_shift, 
-                                             1);
-                span->r = fg_ptr[order_type::R];
-                span->g = fg_ptr[order_type::G];
-                span->b = fg_ptr[order_type::B];
-                span->a = fg_ptr[order_type::A];
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //=========================================span_image_filter_rgba_bilinear
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgba_bilinear : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgba_bilinear() {}
-        span_image_filter_rgba_bilinear(source_type& src, 
-                                        interpolator_type& inter) :
-            base_type(src, inter, 0) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            calc_type fg[4];
-            const value_type *fg_ptr;
-
-            do
-            {
-                int x_hr;
-                int y_hr;
-
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                unsigned weight;
-
-                fg[0] = 
-                fg[1] = 
-                fg[2] = 
-                fg[3] = image_subpixel_scale * image_subpixel_scale / 2;
-
-                x_hr &= image_subpixel_mask;
-                y_hr &= image_subpixel_mask;
-
-                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
-                weight = (image_subpixel_scale - x_hr) * 
-                         (image_subpixel_scale - y_hr);
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = x_hr * (image_subpixel_scale - y_hr);
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_y();
-                weight = (image_subpixel_scale - x_hr) * y_hr;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = x_hr * y_hr;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                span->r = value_type(fg[order_type::R] >> (image_subpixel_shift * 2));
-                span->g = value_type(fg[order_type::G] >> (image_subpixel_shift * 2));
-                span->b = value_type(fg[order_type::B] >> (image_subpixel_shift * 2));
-                span->a = value_type(fg[order_type::A] >> (image_subpixel_shift * 2));
-
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-    //====================================span_image_filter_rgba_bilinear_clip
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgba_bilinear_clip : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgba_bilinear_clip() {}
-        span_image_filter_rgba_bilinear_clip(source_type& src, 
-                                             const color_type& back_color,
-                                             interpolator_type& inter) :
-            base_type(src, inter, 0),
-            m_back_color(back_color)
-        {}
-        const color_type& background_color() const { return m_back_color; }
-        void background_color(const color_type& v)   { m_back_color = v; }
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            calc_type fg[4];
-            value_type back_r = m_back_color.r;
-            value_type back_g = m_back_color.g;
-            value_type back_b = m_back_color.b;
-            value_type back_a = m_back_color.a;
-
-            const value_type *fg_ptr;
-            int maxx = base_type::source().width() - 1;
-            int maxy = base_type::source().height() - 1;
-
-            do
-            {
-                int x_hr;
-                int y_hr;
-
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                unsigned weight;
-
-                if(x_lr >= 0    && y_lr >= 0 &&
-                   x_lr <  maxx && y_lr <  maxy) 
-                {
-                    fg[0] = 
-                    fg[1] = 
-                    fg[2] = 
-                    fg[3] = image_subpixel_scale * image_subpixel_scale / 2;
-
-                    x_hr &= image_subpixel_mask;
-                    y_hr &= image_subpixel_mask;
-
-                    fg_ptr = (const value_type*)
-                        base_type::source().row_ptr(y_lr) + (x_lr << 2);
-
-                    weight = (image_subpixel_scale - x_hr) * 
-                             (image_subpixel_scale - y_hr);
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-                    fg[3] += weight * *fg_ptr++;
-
-                    weight = x_hr * (image_subpixel_scale - y_hr);
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-                    fg[3] += weight * *fg_ptr++;
-
-                    ++y_lr;
-                    fg_ptr = (const value_type*)
-                        base_type::source().row_ptr(y_lr) + (x_lr << 2);
-
-                    weight = (image_subpixel_scale - x_hr) * y_hr;
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-                    fg[3] += weight * *fg_ptr++;
-
-                    weight = x_hr * y_hr;
-                    fg[0] += weight * *fg_ptr++;
-                    fg[1] += weight * *fg_ptr++;
-                    fg[2] += weight * *fg_ptr++;
-                    fg[3] += weight * *fg_ptr++;
-
-                    fg[0] >>= image_subpixel_shift * 2;
-                    fg[1] >>= image_subpixel_shift * 2;
-                    fg[2] >>= image_subpixel_shift * 2;
-                    fg[3] >>= image_subpixel_shift * 2;
-                }
-                else
-                {
-                    if(x_lr < -1   || y_lr < -1 ||
-                       x_lr > maxx || y_lr > maxy)
-                    {
-                        fg[order_type::R] = back_r;
-                        fg[order_type::G] = back_g;
-                        fg[order_type::B] = back_b;
-                        fg[order_type::A] = back_a;
-                    }
-                    else
-                    {
-                        fg[0] = 
-                        fg[1] = 
-                        fg[2] = 
-                        fg[3] = image_subpixel_scale * image_subpixel_scale / 2;
-
-                        x_hr &= image_subpixel_mask;
-                        y_hr &= image_subpixel_mask;
-
-                        weight = (image_subpixel_scale - x_hr) * 
-                                 (image_subpixel_scale - y_hr);
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
-
-                            fg[0] += weight * *fg_ptr++;
-                            fg[1] += weight * *fg_ptr++;
-                            fg[2] += weight * *fg_ptr++;
-                            fg[3] += weight * *fg_ptr++;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            fg[order_type::A] += back_a * weight;
-                        }
-
-                        x_lr++;
-
-                        weight = x_hr * (image_subpixel_scale - y_hr);
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
-
-                            fg[0] += weight * *fg_ptr++;
-                            fg[1] += weight * *fg_ptr++;
-                            fg[2] += weight * *fg_ptr++;
-                            fg[3] += weight * *fg_ptr++;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            fg[order_type::A] += back_a * weight;
-                        }
-
-                        x_lr--;
-                        y_lr++;
-
-                        weight = (image_subpixel_scale - x_hr) * y_hr;
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
-
-                            fg[0] += weight * *fg_ptr++;
-                            fg[1] += weight * *fg_ptr++;
-                            fg[2] += weight * *fg_ptr++;
-                            fg[3] += weight * *fg_ptr++;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            fg[order_type::A] += back_a * weight;
-                        }
-
-                        x_lr++;
-
-                        weight = x_hr * y_hr;
-                        if(x_lr >= 0    && y_lr >= 0 &&
-                           x_lr <= maxx && y_lr <= maxy)
-                        {
-                            fg_ptr = (const value_type*)
-                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
-
-                            fg[0] += weight * *fg_ptr++;
-                            fg[1] += weight * *fg_ptr++;
-                            fg[2] += weight * *fg_ptr++;
-                            fg[3] += weight * *fg_ptr++;
-                        }
-                        else
-                        {
-                            fg[order_type::R] += back_r * weight;
-                            fg[order_type::G] += back_g * weight;
-                            fg[order_type::B] += back_b * weight;
-                            fg[order_type::A] += back_a * weight;
-                        }
-
-                        fg[0] >>= image_subpixel_shift * 2;
-                        fg[1] >>= image_subpixel_shift * 2;
-                        fg[2] >>= image_subpixel_shift * 2;
-                        fg[3] >>= image_subpixel_shift * 2;
-                    }
-                }
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = (value_type)fg[order_type::A];
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    private:
-        color_type m_back_color;
-    };
-
-
-    //==============================================span_image_filter_rgba_2x2
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgba_2x2 : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgba_2x2() {}
-        span_image_filter_rgba_2x2(source_type& src, 
-                                   interpolator_type& inter,
-                                   const image_filter_lut& filter) :
-            base_type(src, inter, &filter) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            calc_type fg[4];
-
-            const value_type *fg_ptr;
-            const int16* weight_array = base_type::filter().weight_array() + 
-                                        ((base_type::filter().diameter()/2 - 1) << 
-                                          image_subpixel_shift);
-
-            do
-            {
-                int x_hr;
-                int y_hr;
-
-                base_type::interpolator().coordinates(&x_hr, &y_hr);
-
-                x_hr -= base_type::filter_dx_int();
-                y_hr -= base_type::filter_dy_int();
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                unsigned weight;
-                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
-
-                x_hr &= image_subpixel_mask;
-                y_hr &= image_subpixel_mask;
-
-                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
-                weight = (weight_array[x_hr + image_subpixel_scale] * 
-                          weight_array[y_hr + image_subpixel_scale] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = (weight_array[x_hr] * 
-                          weight_array[y_hr + image_subpixel_scale] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_y();
-                weight = (weight_array[x_hr + image_subpixel_scale] * 
-                          weight_array[y_hr] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                fg_ptr = (const value_type*)base_type::source().next_x();
-                weight = (weight_array[x_hr] * 
-                          weight_array[y_hr] + 
-                          image_filter_scale / 2) >> 
-                          image_filter_shift;
-                fg[0] += weight * *fg_ptr++;
-                fg[1] += weight * *fg_ptr++;
-                fg[2] += weight * *fg_ptr++;
-                fg[3] += weight * *fg_ptr;
-
-                fg[0] >>= image_filter_shift;
-                fg[1] >>= image_filter_shift;
-                fg[2] >>= image_filter_shift;
-                fg[3] >>= image_filter_shift;
-
-                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
-                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
-                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
-                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = (value_type)fg[order_type::A];
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //==================================================span_image_filter_rgba
-    template<class Source, class Interpolator> 
-    class span_image_filter_rgba : 
-    public span_image_filter<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_filter<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask
-        };
-
-        //--------------------------------------------------------------------
-        span_image_filter_rgba() {}
-        span_image_filter_rgba(source_type& src, 
-                               interpolator_type& inter,
-                               const image_filter_lut& filter) :
-            base_type(src, inter, &filter) 
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            int fg[4];
-            const value_type *fg_ptr;
-
-            unsigned     diameter     = base_type::filter().diameter();
-            int          start        = base_type::filter().start();
-            const int16* weight_array = base_type::filter().weight_array();
-
-            int x_count; 
-            int weight_y;
-
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-
-                x -= base_type::filter_dx_int();
-                y -= base_type::filter_dy_int();
-
-                int x_hr = x; 
-                int y_hr = y; 
-
-                int x_lr = x_hr >> image_subpixel_shift;
-                int y_lr = y_hr >> image_subpixel_shift;
-
-                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
-
-                int x_fract = x_hr & image_subpixel_mask;
-                unsigned y_count = diameter;
-
-                y_hr = image_subpixel_mask - (y_hr & image_subpixel_mask);
-                fg_ptr = (const value_type*)base_type::source().span(x_lr + start, 
-                                                                     y_lr + start, 
-                                                                     diameter);
-                for(;;)
-                {
-                    x_count  = diameter;
-                    weight_y = weight_array[y_hr];
-                    x_hr = image_subpixel_mask - x_fract;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     image_filter_shift;
-
-                        fg[0] += weight * *fg_ptr++;
-                        fg[1] += weight * *fg_ptr++;
-                        fg[2] += weight * *fg_ptr++;
-                        fg[3] += weight * *fg_ptr;
-
-                        if(--x_count == 0) break;
-                        x_hr  += image_subpixel_scale;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-
-                    if(--y_count == 0) break;
-                    y_hr  += image_subpixel_scale;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg[0] >>= image_filter_shift;
-                fg[1] >>= image_filter_shift;
-                fg[2] >>= image_filter_shift;
-                fg[3] >>= image_filter_shift;
-
-                if(fg[0] < 0) fg[0] = 0;
-                if(fg[1] < 0) fg[1] = 0;
-                if(fg[2] < 0) fg[2] = 0;
-                if(fg[3] < 0) fg[3] = 0;
-
-                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
-                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
-                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
-                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = (value_type)fg[order_type::A];
-                ++span;
-                ++base_type::interpolator();
-
-            } while(--len);
-        }
-    };
-
-
-
-    //========================================span_image_resample_rgba_affine
-    template<class Source> 
-    class span_image_resample_rgba_affine : 
-    public span_image_resample_affine<Source>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef span_image_resample_affine<source_type> base_type;
-        typedef typename base_type::interpolator_type interpolator_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        {
-            base_shift      = color_type::base_shift,
-            base_mask       = color_type::base_mask,
-            downscale_shift = image_filter_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_image_resample_rgba_affine() {}
-        span_image_resample_rgba_affine(source_type& src, 
-                                        interpolator_type& inter,
-                                        const image_filter_lut& filter) :
-            base_type(src, inter, filter) 
-        {}
-
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-
-            long_type fg[4];
-
-            int diameter     = base_type::filter().diameter();
-            int filter_scale = diameter << image_subpixel_shift;
-            int radius_x     = (diameter * base_type::m_rx) >> 1;
-            int radius_y     = (diameter * base_type::m_ry) >> 1;
-            int len_x_lr     = 
-                (diameter * base_type::m_rx + image_subpixel_mask) >> 
-                    image_subpixel_shift;
-
-            const int16* weight_array = base_type::filter().weight_array();
-
-            do
-            {
-                base_type::interpolator().coordinates(&x, &y);
-
-                x += base_type::filter_dx_int() - radius_x;
-                y += base_type::filter_dy_int() - radius_y;
-
-                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
-
-                int y_lr = y >> image_subpixel_shift;
-                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
-                                base_type::m_ry_inv) >> 
-                                    image_subpixel_shift;
-                int total_weight = 0;
-                int x_lr = x >> image_subpixel_shift;
-                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
-                                base_type::m_rx_inv) >> 
-                                    image_subpixel_shift;
-
-                int x_hr2 = x_hr;
-                const value_type* fg_ptr = 
-                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
-                for(;;)
-                {
-                    int weight_y = weight_array[y_hr];
-                    x_hr = x_hr2;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     downscale_shift;
-
-                        fg[0] += *fg_ptr++ * weight;
-                        fg[1] += *fg_ptr++ * weight;
-                        fg[2] += *fg_ptr++ * weight;
-                        fg[3] += *fg_ptr++ * weight;
-                        total_weight += weight;
-                        x_hr  += base_type::m_rx_inv;
-                        if(x_hr >= filter_scale) break;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-                    y_hr += base_type::m_ry_inv;
-                    if(y_hr >= filter_scale) break;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg[0] /= total_weight;
-                fg[1] /= total_weight;
-                fg[2] /= total_weight;
-                fg[3] /= total_weight;
-
-                if(fg[0] < 0) fg[0] = 0;
-                if(fg[1] < 0) fg[1] = 0;
-                if(fg[2] < 0) fg[2] = 0;
-                if(fg[3] < 0) fg[3] = 0;
-
-                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
-                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
-                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
-                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = (value_type)fg[order_type::A];
-
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-
-    //==============================================span_image_resample_rgba
-    template<class Source, class Interpolator>
-    class span_image_resample_rgba : 
-    public span_image_resample<Source, Interpolator>
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef Interpolator interpolator_type;
-        typedef span_image_resample<source_type, interpolator_type> base_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::long_type long_type;
-        enum base_scale_e
-        {
-            base_shift = color_type::base_shift,
-            base_mask  = color_type::base_mask,
-            downscale_shift = image_filter_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_image_resample_rgba() {}
-        span_image_resample_rgba(source_type& src, 
-                                 interpolator_type& inter,
-                                 const image_filter_lut& filter) :
-            base_type(src, inter, filter)
-        {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {
-            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
-                                            y + base_type::filter_dy_dbl(), len);
-            long_type fg[4];
-
-            int diameter = base_type::filter().diameter();
-            int filter_scale = diameter << image_subpixel_shift;
-
-            const int16* weight_array = base_type::filter().weight_array();
-            do
-            {
-                int rx;
-                int ry;
-                int rx_inv = image_subpixel_scale;
-                int ry_inv = image_subpixel_scale;
-                base_type::interpolator().coordinates(&x,  &y);
-                base_type::interpolator().local_scale(&rx, &ry);
-                base_type::adjust_scale(&rx, &ry);
-
-                rx_inv = image_subpixel_scale * image_subpixel_scale / rx;
-                ry_inv = image_subpixel_scale * image_subpixel_scale / ry;
-
-                int radius_x = (diameter * rx) >> 1;
-                int radius_y = (diameter * ry) >> 1;
-                int len_x_lr = 
-                    (diameter * rx + image_subpixel_mask) >> 
-                        image_subpixel_shift;
-
-                x += base_type::filter_dx_int() - radius_x;
-                y += base_type::filter_dy_int() - radius_y;
-
-                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
-
-                int y_lr = y >> image_subpixel_shift;
-                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
-                               ry_inv) >> 
-                                   image_subpixel_shift;
-                int total_weight = 0;
-                int x_lr = x >> image_subpixel_shift;
-                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
-                               rx_inv) >> 
-                                   image_subpixel_shift;
-                int x_hr2 = x_hr;
-                const value_type* fg_ptr = 
-                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
-
-                for(;;)
-                {
-                    int weight_y = weight_array[y_hr];
-                    x_hr = x_hr2;
-                    for(;;)
-                    {
-                        int weight = (weight_y * weight_array[x_hr] + 
-                                     image_filter_scale / 2) >> 
-                                     downscale_shift;
-                        fg[0] += *fg_ptr++ * weight;
-                        fg[1] += *fg_ptr++ * weight;
-                        fg[2] += *fg_ptr++ * weight;
-                        fg[3] += *fg_ptr++ * weight;
-                        total_weight += weight;
-                        x_hr  += rx_inv;
-                        if(x_hr >= filter_scale) break;
-                        fg_ptr = (const value_type*)base_type::source().next_x();
-                    }
-                    y_hr += ry_inv;
-                    if(y_hr >= filter_scale) break;
-                    fg_ptr = (const value_type*)base_type::source().next_y();
-                }
-
-                fg[0] /= total_weight;
-                fg[1] /= total_weight;
-                fg[2] /= total_weight;
-                fg[3] /= total_weight;
-
-                if(fg[0] < 0) fg[0] = 0;
-                if(fg[1] < 0) fg[1] = 0;
-                if(fg[2] < 0) fg[2] = 0;
-                if(fg[3] < 0) fg[3] = 0;
-
-                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
-                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
-                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
-                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
-
-                span->r = (value_type)fg[order_type::R];
-                span->g = (value_type)fg[order_type::G];
-                span->b = (value_type)fg[order_type::B];
-                span->a = (value_type)fg[order_type::A];
-
-                ++span;
-                ++base_type::interpolator();
-            } while(--len);
-        }
-    };
-
-
-}
-
-
-#endif
-
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_interpolator_adaptor.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_adaptor.h
--- 8.0.1-5/renderers/agg/include/agg_span_interpolator_adaptor.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_adaptor.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,77 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_INTERPOLATOR_ADAPTOR_INCLUDED
-#define AGG_SPAN_INTERPOLATOR_ADAPTOR_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //===============================================span_interpolator_adaptor
-    template<class Interpolator, class Distortion>
-    class span_interpolator_adaptor : public Interpolator
-    {
-    public:
-        typedef Interpolator base_type;
-        typedef typename base_type::trans_type trans_type;
-        typedef Distortion distortion_type;
-
-        //--------------------------------------------------------------------
-        span_interpolator_adaptor() {}
-        span_interpolator_adaptor(const trans_type& trans, 
-                                  const distortion_type& dist) :
-            base_type(trans),
-            m_distortion(&dist)
-        {   
-        }
-
-        //--------------------------------------------------------------------
-        span_interpolator_adaptor(const trans_type& trans,
-                                  const distortion_type& dist,
-                                  double x, double y, unsigned len) :
-            base_type(trans, x, y, len),
-            m_distortion(&dist)
-        {
-        }
-
-        //--------------------------------------------------------------------
-        const distortion_type& distortion() const
-        {
-            return *m_distortion;
-        }
-
-        //--------------------------------------------------------------------
-        void distortion(const distortion_type& dist)
-        {
-            m_distortion = dist;
-        }
-
-        //--------------------------------------------------------------------
-        void coordinates(int* x, int* y) const
-        {
-            base_type::coordinates(x, y);
-            m_distortion->calculate(x, y);
-        }
-
-    private:
-        //--------------------------------------------------------------------
-        const distortion_type* m_distortion;
-    };
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_interpolator_linear.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_linear.h
--- 8.0.1-5/renderers/agg/include/agg_span_interpolator_linear.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_linear.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,232 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_INTERPOLATOR_LINEAR_INCLUDED
-#define AGG_SPAN_INTERPOLATOR_LINEAR_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_dda_line.h"
-#include "agg_trans_affine.h"
-
-namespace mapserver
-{
-
-    //================================================span_interpolator_linear
-    template<class Transformer = trans_affine, unsigned SubpixelShift = 8> 
-    class span_interpolator_linear
-    {
-    public:
-        typedef Transformer trans_type;
-
-        enum subpixel_scale_e
-        {
-            subpixel_shift = SubpixelShift,
-            subpixel_scale  = 1 << subpixel_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_interpolator_linear() {}
-        span_interpolator_linear(const trans_type& trans) : m_trans(&trans) {}
-        span_interpolator_linear(const trans_type& trans,
-                                 double x, double y, unsigned len) :
-            m_trans(&trans)
-        {
-            begin(x, y, len);
-        }
-
-        //----------------------------------------------------------------
-        const trans_type& transformer() const { return *m_trans; }
-        void transformer(const trans_type& trans) { m_trans = &trans; }
-
-        //----------------------------------------------------------------
-        void begin(double x, double y, unsigned len)
-        {
-            double tx;
-            double ty;
-
-            tx = x;
-            ty = y;
-            m_trans->transform(&tx, &ty);
-            int x1 = iround(tx * subpixel_scale);
-            int y1 = iround(ty * subpixel_scale);
-
-            tx = x + len;
-            ty = y;
-            m_trans->transform(&tx, &ty);
-            int x2 = iround(tx * subpixel_scale);
-            int y2 = iround(ty * subpixel_scale);
-
-            m_li_x = dda2_line_interpolator(x1, x2, len);
-            m_li_y = dda2_line_interpolator(y1, y2, len);
-        }
-
-        //----------------------------------------------------------------
-        void resynchronize(double xe, double ye, unsigned len)
-        {
-            m_trans->transform(&xe, &ye);
-            m_li_x = dda2_line_interpolator(m_li_x.y(), iround(xe * subpixel_scale), len);
-            m_li_y = dda2_line_interpolator(m_li_y.y(), iround(ye * subpixel_scale), len);
-        }
-    
-        //----------------------------------------------------------------
-        void operator++()
-        {
-            ++m_li_x;
-            ++m_li_y;
-        }
-
-        //----------------------------------------------------------------
-        void coordinates(int* x, int* y) const
-        {
-            *x = m_li_x.y();
-            *y = m_li_y.y();
-        }
-
-    private:
-        const trans_type* m_trans;
-        dda2_line_interpolator m_li_x;
-        dda2_line_interpolator m_li_y;
-    };
-
-
-
-
-
-
-    //=====================================span_interpolator_linear_subdiv
-    template<class Transformer = trans_affine, unsigned SubpixelShift = 8> 
-    class span_interpolator_linear_subdiv
-    {
-    public:
-        typedef Transformer trans_type;
-
-        enum subpixel_scale_e
-        {
-            subpixel_shift = SubpixelShift,
-            subpixel_scale = 1 << subpixel_shift
-        };
-
-
-        //----------------------------------------------------------------
-        span_interpolator_linear_subdiv() :
-            m_subdiv_shift(4),
-            m_subdiv_size(1 << m_subdiv_shift),
-            m_subdiv_mask(m_subdiv_size - 1) {}
-
-        span_interpolator_linear_subdiv(const trans_type& trans, 
-                                        unsigned subdiv_shift = 4) : 
-            m_subdiv_shift(subdiv_shift),
-            m_subdiv_size(1 << m_subdiv_shift),
-            m_subdiv_mask(m_subdiv_size - 1),
-            m_trans(&trans) {}
-
-        span_interpolator_linear_subdiv(const trans_type& trans,
-                                        double x, double y, unsigned len,
-                                        unsigned subdiv_shift = 4) :
-            m_subdiv_shift(subdiv_shift),
-            m_subdiv_size(1 << m_subdiv_shift),
-            m_subdiv_mask(m_subdiv_size - 1),
-            m_trans(&trans)
-        {
-            begin(x, y, len);
-        }
-
-        //----------------------------------------------------------------
-        const trans_type& transformer() const { return *m_trans; }
-        void transformer(const trans_type& trans) { m_trans = &trans; }
-
-        //----------------------------------------------------------------
-        unsigned subdiv_shift() const { return m_subdiv_shift; }
-        void subdiv_shift(unsigned shift) 
-        {
-            m_subdiv_shift = shift;
-            m_subdiv_size = 1 << m_subdiv_shift;
-            m_subdiv_mask = m_subdiv_size - 1;
-        }
-
-        //----------------------------------------------------------------
-        void begin(double x, double y, unsigned len)
-        {
-            double tx;
-            double ty;
-            m_pos   = 1;
-            m_src_x = iround(x * subpixel_scale) + subpixel_scale;
-            m_src_y = y;
-            m_len   = len;
-
-            if(len > m_subdiv_size) len = m_subdiv_size;
-            tx = x;
-            ty = y;
-            m_trans->transform(&tx, &ty);
-            int x1 = iround(tx * subpixel_scale);
-            int y1 = iround(ty * subpixel_scale);
-
-            tx = x + len;
-            ty = y;
-            m_trans->transform(&tx, &ty);
-
-            m_li_x = dda2_line_interpolator(x1, iround(tx * subpixel_scale), len);
-            m_li_y = dda2_line_interpolator(y1, iround(ty * subpixel_scale), len);
-        }
-
-        //----------------------------------------------------------------
-        void operator++()
-        {
-            ++m_li_x;
-            ++m_li_y;
-            if(m_pos >= m_subdiv_size)
-            {
-                unsigned len = m_len;
-                if(len > m_subdiv_size) len = m_subdiv_size;
-                double tx = double(m_src_x) / double(subpixel_scale) + len;
-                double ty = m_src_y;
-                m_trans->transform(&tx, &ty);
-                m_li_x = dda2_line_interpolator(m_li_x.y(), iround(tx * subpixel_scale), len);
-                m_li_y = dda2_line_interpolator(m_li_y.y(), iround(ty * subpixel_scale), len);
-                m_pos = 0;
-            }
-            m_src_x += subpixel_scale;
-            ++m_pos;
-            --m_len;
-        }
-
-        //----------------------------------------------------------------
-        void coordinates(int* x, int* y) const
-        {
-            *x = m_li_x.y();
-            *y = m_li_y.y();
-        }
-
-    private:
-        unsigned m_subdiv_shift;
-        unsigned m_subdiv_size;
-        unsigned m_subdiv_mask;
-        const trans_type* m_trans;
-        dda2_line_interpolator m_li_x;
-        dda2_line_interpolator m_li_y;
-        int      m_src_x;
-        double   m_src_y;
-        unsigned m_pos;
-        unsigned m_len;
-    };
-
-
-}
-
-
-
-#endif
-
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_interpolator_persp.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_persp.h
--- 8.0.1-5/renderers/agg/include/agg_span_interpolator_persp.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_persp.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,462 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_SPAN_INTERPOLATOR_PERSP_INCLUDED
-#define AGG_SPAN_INTERPOLATOR_PERSP_INCLUDED
-
-#include "agg_trans_perspective.h"
-#include "agg_dda_line.h"
-
-namespace mapserver
-{
-
-
-
-    //===========================================span_interpolator_persp_exact
-    template<unsigned SubpixelShift = 8> 
-    class span_interpolator_persp_exact
-    {
-    public:
-        typedef trans_perspective trans_type;
-        typedef trans_perspective::iterator_x iterator_type;
-        enum subpixel_scale_e
-        {
-            subpixel_shift = SubpixelShift,
-            subpixel_scale = 1 << subpixel_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_interpolator_persp_exact() {}
-
-        //--------------------------------------------------------------------
-        // Arbitrary quadrangle transformations
-        span_interpolator_persp_exact(const double* src, const double* dst) 
-        {
-            quad_to_quad(src, dst);
-        }
-
-        //--------------------------------------------------------------------
-        // Direct transformations 
-        span_interpolator_persp_exact(double x1, double y1, 
-                                      double x2, double y2, 
-                                      const double* quad)
-        {
-            rect_to_quad(x1, y1, x2, y2, quad);
-        }
-
-        //--------------------------------------------------------------------
-        // Reverse transformations 
-        span_interpolator_persp_exact(const double* quad, 
-                                      double x1, double y1, 
-                                      double x2, double y2)
-        {
-            quad_to_rect(quad, x1, y1, x2, y2);
-        }
-
-        //--------------------------------------------------------------------
-        // Set the transformations using two arbitrary quadrangles.
-        void quad_to_quad(const double* src, const double* dst)
-        {
-            m_trans_dir.quad_to_quad(src, dst);
-            m_trans_inv.quad_to_quad(dst, src);
-        }
-
-        //--------------------------------------------------------------------
-        // Set the direct transformations, i.e., rectangle -> quadrangle
-        void rect_to_quad(double x1, double y1, double x2, double y2, 
-                          const double* quad)
-        {
-            double src[8];
-            src[0] = src[6] = x1;
-            src[2] = src[4] = x2;
-            src[1] = src[3] = y1;
-            src[5] = src[7] = y2;
-            quad_to_quad(src, quad);
-        }
-
-
-        //--------------------------------------------------------------------
-        // Set the reverse transformations, i.e., quadrangle -> rectangle
-        void quad_to_rect(const double* quad, 
-                          double x1, double y1, double x2, double y2)
-        {
-            double dst[8];
-            dst[0] = dst[6] = x1;
-            dst[2] = dst[4] = x2;
-            dst[1] = dst[3] = y1;
-            dst[5] = dst[7] = y2;
-            quad_to_quad(quad, dst);
-        }
-
-        //--------------------------------------------------------------------
-        // Check if the equations were solved successfully
-        bool is_valid() const { return m_trans_dir.is_valid(); }
-
-        //----------------------------------------------------------------
-        void begin(double x, double y, unsigned len)
-        {
-            m_iterator = m_trans_dir.begin(x, y, 1.0);
-            double xt = m_iterator.x;
-            double yt = m_iterator.y;
-
-            double dx;
-            double dy;
-            const double delta = 1/double(subpixel_scale);
-            dx = xt + delta;
-            dy = yt;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sx1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-            dx = xt;
-            dy = yt + delta;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sy1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            x += len;
-            xt = x;
-            yt = y;
-            m_trans_dir.transform(&xt, &yt);
-
-            dx = xt + delta;
-            dy = yt;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-            dx = xt;
-            dy = yt + delta;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
-            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
-        }
-
-
-        //----------------------------------------------------------------
-        void resynchronize(double xe, double ye, unsigned len)
-        {
-            // Assume x1,y1 are equal to the ones at the previous end point 
-            int sx1 = m_scale_x.y();
-            int sy1 = m_scale_y.y();
-
-            // Calculate transformed coordinates at x2,y2 
-            double xt = xe;
-            double yt = ye;
-            m_trans_dir.transform(&xt, &yt);
-
-            const double delta = 1/double(subpixel_scale);
-            double dx;
-            double dy;
-
-            // Calculate scale by X at x2,y2
-            dx = xt + delta;
-            dy = yt;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= xe;
-            dy -= ye;
-            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Calculate scale by Y at x2,y2
-            dx = xt;
-            dy = yt + delta;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= xe;
-            dy -= ye;
-            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Initialize the interpolators
-            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
-            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
-        }
-
-
-
-        //----------------------------------------------------------------
-        void operator++()
-        {
-            ++m_iterator;
-            ++m_scale_x;
-            ++m_scale_y;
-        }
-
-        //----------------------------------------------------------------
-        void coordinates(int* x, int* y) const
-        {
-            *x = iround(m_iterator.x * subpixel_scale);
-            *y = iround(m_iterator.y * subpixel_scale);
-        }
-
-        //----------------------------------------------------------------
-        void local_scale(int* x, int* y)
-        {
-            *x = m_scale_x.y();
-            *y = m_scale_y.y();
-        }
-
-        //----------------------------------------------------------------
-        void transform(double* x, double* y) const
-        {
-            m_trans_dir.transform(x, y);
-        }
-        
-    private:
-        trans_type             m_trans_dir;
-        trans_type             m_trans_inv;
-        iterator_type          m_iterator;
-        dda2_line_interpolator m_scale_x;
-        dda2_line_interpolator m_scale_y;
-    };
-
-
-
-
-
-
-
-
-
-
-
-    //============================================span_interpolator_persp_lerp
-    template<unsigned SubpixelShift = 8> 
-    class span_interpolator_persp_lerp
-    {
-    public:
-        typedef trans_perspective trans_type;
-        enum subpixel_scale_e
-        {
-            subpixel_shift = SubpixelShift,
-            subpixel_scale = 1 << subpixel_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_interpolator_persp_lerp() {}
-
-        //--------------------------------------------------------------------
-        // Arbitrary quadrangle transformations
-        span_interpolator_persp_lerp(const double* src, const double* dst) 
-        {
-            quad_to_quad(src, dst);
-        }
-
-        //--------------------------------------------------------------------
-        // Direct transformations 
-        span_interpolator_persp_lerp(double x1, double y1, 
-                                     double x2, double y2, 
-                                     const double* quad)
-        {
-            rect_to_quad(x1, y1, x2, y2, quad);
-        }
-
-        //--------------------------------------------------------------------
-        // Reverse transformations 
-        span_interpolator_persp_lerp(const double* quad, 
-                                     double x1, double y1, 
-                                     double x2, double y2)
-        {
-            quad_to_rect(quad, x1, y1, x2, y2);
-        }
-
-        //--------------------------------------------------------------------
-        // Set the transformations using two arbitrary quadrangles.
-        void quad_to_quad(const double* src, const double* dst)
-        {
-            m_trans_dir.quad_to_quad(src, dst);
-            m_trans_inv.quad_to_quad(dst, src);
-        }
-
-        //--------------------------------------------------------------------
-        // Set the direct transformations, i.e., rectangle -> quadrangle
-        void rect_to_quad(double x1, double y1, double x2, double y2, 
-                          const double* quad)
-        {
-            double src[8];
-            src[0] = src[6] = x1;
-            src[2] = src[4] = x2;
-            src[1] = src[3] = y1;
-            src[5] = src[7] = y2;
-            quad_to_quad(src, quad);
-        }
-
-
-        //--------------------------------------------------------------------
-        // Set the reverse transformations, i.e., quadrangle -> rectangle
-        void quad_to_rect(const double* quad, 
-                          double x1, double y1, double x2, double y2)
-        {
-            double dst[8];
-            dst[0] = dst[6] = x1;
-            dst[2] = dst[4] = x2;
-            dst[1] = dst[3] = y1;
-            dst[5] = dst[7] = y2;
-            quad_to_quad(quad, dst);
-        }
-
-        //--------------------------------------------------------------------
-        // Check if the equations were solved successfully
-        bool is_valid() const { return m_trans_dir.is_valid(); }
-
-        //----------------------------------------------------------------
-        void begin(double x, double y, unsigned len)
-        {
-            // Calculate transformed coordinates at x1,y1 
-            double xt = x;
-            double yt = y;
-            m_trans_dir.transform(&xt, &yt);
-            int x1 = iround(xt * subpixel_scale);
-            int y1 = iround(yt * subpixel_scale);
-
-            double dx;
-            double dy;
-            const double delta = 1/double(subpixel_scale);
-
-            // Calculate scale by X at x1,y1
-            dx = xt + delta;
-            dy = yt;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sx1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Calculate scale by Y at x1,y1
-            dx = xt;
-            dy = yt + delta;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sy1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Calculate transformed coordinates at x2,y2 
-            x += len;
-            xt = x;
-            yt = y;
-            m_trans_dir.transform(&xt, &yt);
-            int x2 = iround(xt * subpixel_scale);
-            int y2 = iround(yt * subpixel_scale);
-
-            // Calculate scale by X at x2,y2
-            dx = xt + delta;
-            dy = yt;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Calculate scale by Y at x2,y2
-            dx = xt;
-            dy = yt + delta;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= x;
-            dy -= y;
-            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Initialize the interpolators
-            m_coord_x = dda2_line_interpolator(x1,  x2,  len);
-            m_coord_y = dda2_line_interpolator(y1,  y2,  len);
-            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
-            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
-        }
-
-
-        //----------------------------------------------------------------
-        void resynchronize(double xe, double ye, unsigned len)
-        {
-            // Assume x1,y1 are equal to the ones at the previous end point 
-            int x1  = m_coord_x.y();
-            int y1  = m_coord_y.y();
-            int sx1 = m_scale_x.y();
-            int sy1 = m_scale_y.y();
-
-            // Calculate transformed coordinates at x2,y2 
-            double xt = xe;
-            double yt = ye;
-            m_trans_dir.transform(&xt, &yt);
-            int x2 = iround(xt * subpixel_scale);
-            int y2 = iround(yt * subpixel_scale);
-
-            const double delta = 1/double(subpixel_scale);
-            double dx;
-            double dy;
-
-            // Calculate scale by X at x2,y2
-            dx = xt + delta;
-            dy = yt;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= xe;
-            dy -= ye;
-            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Calculate scale by Y at x2,y2
-            dx = xt;
-            dy = yt + delta;
-            m_trans_inv.transform(&dx, &dy);
-            dx -= xe;
-            dy -= ye;
-            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
-
-            // Initialize the interpolators
-            m_coord_x = dda2_line_interpolator(x1,  x2,  len);
-            m_coord_y = dda2_line_interpolator(y1,  y2,  len);
-            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
-            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
-        }
-
-
-        //----------------------------------------------------------------
-        void operator++()
-        {
-            ++m_coord_x;
-            ++m_coord_y;
-            ++m_scale_x;
-            ++m_scale_y;
-        }
-
-        //----------------------------------------------------------------
-        void coordinates(int* x, int* y) const
-        {
-            *x = m_coord_x.y();
-            *y = m_coord_y.y();
-        }
-
-        //----------------------------------------------------------------
-        void local_scale(int* x, int* y)
-        {
-            *x = m_scale_x.y();
-            *y = m_scale_y.y();
-        }
-
-        //----------------------------------------------------------------
-        void transform(double* x, double* y) const
-        {
-            m_trans_dir.transform(x, y);
-        }
-        
-    private:
-        trans_type             m_trans_dir;
-        trans_type             m_trans_inv;
-        dda2_line_interpolator m_coord_x;
-        dda2_line_interpolator m_coord_y;
-        dda2_line_interpolator m_scale_x;
-        dda2_line_interpolator m_scale_y;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_interpolator_trans.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_trans.h
--- 8.0.1-5/renderers/agg/include/agg_span_interpolator_trans.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_interpolator_trans.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,92 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Horizontal span interpolator for use with an arbitrary transformer
-// The efficiency highly depends on the operations done in the transformer
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_INTERPOLATOR_TRANS_INCLUDED
-#define AGG_SPAN_INTERPOLATOR_TRANS_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //=================================================span_interpolator_trans
-    template<class Transformer, unsigned SubpixelShift = 8> 
-    class span_interpolator_trans
-    {
-    public:
-        typedef Transformer trans_type;
-        enum subpixel_scale_e
-        {
-            subpixel_shift = SubpixelShift,
-            subpixel_scale = 1 << subpixel_shift
-        };
-
-        //--------------------------------------------------------------------
-        span_interpolator_trans() {}
-        span_interpolator_trans(const trans_type& trans) : m_trans(&trans) {}
-        span_interpolator_trans(const trans_type& trans,
-                                double x, double y, unsigned) :
-            m_trans(&trans)
-        {
-            begin(x, y, 0);
-        }
-
-        //----------------------------------------------------------------
-        const trans_type& transformer() const { return *m_trans; }
-        void transformer(const trans_type& trans) { m_trans = &trans; }
-
-        //----------------------------------------------------------------
-        void begin(double x, double y, unsigned)
-        {
-            m_x = x;
-            m_y = y;
-            m_trans->transform(&x, &y);
-            m_ix = iround(x * subpixel_scale);
-            m_iy = iround(y * subpixel_scale);
-        }
-
-        //----------------------------------------------------------------
-        void operator++()
-        {
-            m_x += 1.0;
-            double x = m_x;
-            double y = m_y;
-            m_trans->transform(&x, &y);
-            m_ix = iround(x * subpixel_scale);
-            m_iy = iround(y * subpixel_scale);
-        }
-
-        //----------------------------------------------------------------
-        void coordinates(int* x, int* y) const
-        {
-            *x = m_ix;
-            *y = m_iy;
-        }
-
-    private:
-        const trans_type* m_trans;
-        double            m_x;
-        double            m_y;
-        int               m_ix;
-        int               m_iy;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_pattern_gray.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_pattern_gray.h
--- 8.0.1-5/renderers/agg/include/agg_span_pattern_gray.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_pattern_gray.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,93 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-
-#ifndef AGG_SPAN_PATTERN_GRAY_INCLUDED
-#define AGG_SPAN_PATTERN_GRAY_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //=======================================================span_pattern_gray
-    template<class Source> class span_pattern_gray
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-
-        //--------------------------------------------------------------------
-        span_pattern_gray() {}
-        span_pattern_gray(source_type& src, 
-                          unsigned offset_x, unsigned offset_y) :
-            m_src(&src),
-            m_offset_x(offset_x),
-            m_offset_y(offset_y),
-            m_alpha(color_type::base_mask)
-        {}
-
-        //--------------------------------------------------------------------
-        void   attach(source_type& v)      { m_src = &v; }
-               source_type& source()       { return *m_src; }
-        const  source_type& source() const { return *m_src; }
-
-        //--------------------------------------------------------------------
-        void       offset_x(unsigned v) { m_offset_x = v; }
-        void       offset_y(unsigned v) { m_offset_y = v; }
-        unsigned   offset_x() const { return m_offset_x; }
-        unsigned   offset_y() const { return m_offset_y; }
-        void       alpha(value_type v) { m_alpha = v; }
-        value_type alpha() const { return m_alpha; }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-        void generate(color_type* span, int x, int y, unsigned len)
-        {   
-            x += m_offset_x;
-            y += m_offset_y;
-            const value_type* p = (const value_type*)m_src->span(x, y, len);
-            do
-            {
-                span->v = *p;
-                span->a = m_alpha;
-                p = m_src->next_x();
-                ++span;
-            }
-            while(--len);
-        }
-
-    private:
-        source_type* m_src;
-        unsigned     m_offset_x;
-        unsigned     m_offset_y;
-        value_type   m_alpha;
-
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_pattern_rgb.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_pattern_rgb.h
--- 8.0.1-5/renderers/agg/include/agg_span_pattern_rgb.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_pattern_rgb.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,96 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-
-#ifndef AGG_SPAN_PATTERN_RGB_INCLUDED
-#define AGG_SPAN_PATTERN_RGB_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //========================================================span_pattern_rgb
-    template<class Source> class span_pattern_rgb
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-
-        //--------------------------------------------------------------------
-        span_pattern_rgb() {}
-        span_pattern_rgb(source_type& src, 
-                         unsigned offset_x, unsigned offset_y) :
-            m_src(&src),
-            m_offset_x(offset_x),
-            m_offset_y(offset_y),
-            m_alpha(color_type::base_mask)
-        {}
-
-        //--------------------------------------------------------------------
-        void   attach(source_type& v)      { m_src = &v; }
-               source_type& source()       { return *m_src; }
-        const  source_type& source() const { return *m_src; }
-
-        //--------------------------------------------------------------------
-        void       offset_x(unsigned v) { m_offset_x = v; }
-        void       offset_y(unsigned v) { m_offset_y = v; }
-        unsigned   offset_x() const { return m_offset_x; }
-        unsigned   offset_y() const { return m_offset_y; }
-        void       alpha(value_type v) { m_alpha = v; }
-        value_type alpha() const { return m_alpha; }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-        void generate(color_type* span, int x, int y, unsigned len)
-        {   
-            x += m_offset_x;
-            y += m_offset_y;
-            const value_type* p = (const value_type*)m_src->span(x, y, len);
-            do
-            {
-                span->r = p[order_type::R];
-                span->g = p[order_type::G];
-                span->b = p[order_type::B];
-                span->a = m_alpha;
-                p = m_src->next_x();
-                ++span;
-            }
-            while(--len);
-        }
-
-    private:
-        source_type* m_src;
-        unsigned     m_offset_x;
-        unsigned     m_offset_y;
-        value_type   m_alpha;
-
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_pattern_rgba.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_pattern_rgba.h
--- 8.0.1-5/renderers/agg/include/agg_span_pattern_rgba.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_pattern_rgba.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,94 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Adaptation for high precision colors has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-
-
-#ifndef AGG_SPAN_PATTERN_RGBA_INCLUDED
-#define AGG_SPAN_PATTERN_RGBA_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //======================================================span_pattern_rgba
-    template<class Source> class span_pattern_rgba
-    {
-    public:
-        typedef Source source_type;
-        typedef typename source_type::color_type color_type;
-        typedef typename source_type::order_type order_type;
-        typedef typename color_type::value_type value_type;
-        typedef typename color_type::calc_type calc_type;
-
-        //--------------------------------------------------------------------
-        span_pattern_rgba() {}
-        span_pattern_rgba(source_type& src, 
-                          unsigned offset_x, unsigned offset_y) :
-            m_src(&src),
-            m_offset_x(offset_x),
-            m_offset_y(offset_y)
-        {}
-
-        //--------------------------------------------------------------------
-        void   attach(source_type& v)      { m_src = &v; }
-               source_type& source()       { return *m_src; }
-        const  source_type& source() const { return *m_src; }
-
-        //--------------------------------------------------------------------
-        void       offset_x(unsigned v) { m_offset_x = v; }
-        void       offset_y(unsigned v) { m_offset_y = v; }
-        unsigned   offset_x() const { return m_offset_x; }
-        unsigned   offset_y() const { return m_offset_y; }
-        void       alpha(value_type) {}
-        value_type alpha() const { return 0; }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-        void generate(color_type* span, int x, int y, unsigned len)
-        {   
-            x += m_offset_x;
-            y += m_offset_y;
-            const value_type* p = (const value_type*)m_src->span(x, y, len);
-            do
-            {
-                span->r = p[order_type::R];
-                span->g = p[order_type::G];
-                span->b = p[order_type::B];
-                span->a = p[order_type::A];
-                p = (const value_type*)m_src->next_x();
-                ++span;
-            }
-            while(--len);
-        }
-
-    private:
-        source_type* m_src;
-        unsigned     m_offset_x;
-        unsigned     m_offset_y;
-
-    };
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_solid.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_solid.h
--- 8.0.1-5/renderers/agg/include/agg_span_solid.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_solid.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,53 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// span_solid_rgba8
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SPAN_SOLID_INCLUDED
-#define AGG_SPAN_SOLID_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    //--------------------------------------------------------------span_solid
-    template<class ColorT> class span_solid
-    {
-    public:
-        typedef ColorT color_type;
-
-        //--------------------------------------------------------------------
-        void color(const color_type& c) { m_color = c; }
-        const color_type& color() const { return m_color; }
-
-        //--------------------------------------------------------------------
-        void prepare() {}
-
-        //--------------------------------------------------------------------
-        void generate(color_type* span, int x, int y, unsigned len)
-        {   
-            do { *span++ = m_color; } while(--len);
-        }
-
-    private:
-        color_type m_color;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_span_subdiv_adaptor.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_subdiv_adaptor.h
--- 8.0.1-5/renderers/agg/include/agg_span_subdiv_adaptor.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_span_subdiv_adaptor.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,141 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-#ifndef AGG_SPAN_SUBDIV_ADAPTOR_INCLUDED
-#define AGG_SPAN_SUBDIV_ADAPTOR_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //=================================================span_subdiv_adaptor
-    template<class Interpolator, unsigned SubpixelShift = 8> 
-    class span_subdiv_adaptor
-    {
-    public:
-        typedef Interpolator interpolator_type;
-        typedef typename interpolator_type::trans_type trans_type;
-
-        enum sublixel_scale_e
-        {
-            subpixel_shift = SubpixelShift,
-            subpixel_scale = 1 << subpixel_shift
-        };
-
-
-        //----------------------------------------------------------------
-        span_subdiv_adaptor() :
-            m_subdiv_shift(4),
-            m_subdiv_size(1 << m_subdiv_shift),
-            m_subdiv_mask(m_subdiv_size - 1) {}
-
-        span_subdiv_adaptor(interpolator_type& interpolator, 
-                             unsigned subdiv_shift = 4) : 
-            m_subdiv_shift(subdiv_shift),
-            m_subdiv_size(1 << m_subdiv_shift),
-            m_subdiv_mask(m_subdiv_size - 1),
-            m_interpolator(&interpolator) {}
-
-        span_subdiv_adaptor(interpolator_type& interpolator, 
-                             double x, double y, unsigned len,
-                             unsigned subdiv_shift = 4) :
-            m_subdiv_shift(subdiv_shift),
-            m_subdiv_size(1 << m_subdiv_shift),
-            m_subdiv_mask(m_subdiv_size - 1),
-            m_interpolator(&interpolator)
-        {
-            begin(x, y, len);
-        }
-
-
-        //----------------------------------------------------------------
-        const interpolator_type& interpolator() const { return *m_interpolator; }
-        void interpolator(interpolator_type& intr) { m_interpolator = &intr; }
-
-        //----------------------------------------------------------------
-        const trans_type& transformer() const 
-        { 
-            return *m_interpolator->transformer(); 
-        }
-        void transformer(const trans_type& trans) 
-        { 
-            m_interpolator->transformer(trans); 
-        }
-
-        //----------------------------------------------------------------
-        unsigned subdiv_shift() const { return m_subdiv_shift; }
-        void subdiv_shift(unsigned shift) 
-        {
-            m_subdiv_shift = shift;
-            m_subdiv_size = 1 << m_subdiv_shift;
-            m_subdiv_mask = m_subdiv_size - 1;
-        }
-
-        //----------------------------------------------------------------
-        void begin(double x, double y, unsigned len)
-        {
-            m_pos   = 1;
-            m_src_x = iround(x * subpixel_scale) + subpixel_scale;
-            m_src_y = y;
-            m_len   = len;
-            if(len > m_subdiv_size) len = m_subdiv_size;
-            m_interpolator->begin(x, y, len);
-        }
-
-        //----------------------------------------------------------------
-        void operator++()
-        {
-            ++(*m_interpolator);
-            if(m_pos >= m_subdiv_size)
-            {
-                unsigned len = m_len;
-                if(len > m_subdiv_size) len = m_subdiv_size;
-                m_interpolator->resynchronize(double(m_src_x) / double(subpixel_scale) + len, 
-                                              m_src_y, 
-                                              len);
-                m_pos = 0;
-            }
-            m_src_x += subpixel_scale;
-            ++m_pos;
-            --m_len;
-        }
-
-        //----------------------------------------------------------------
-        void coordinates(int* x, int* y) const
-        {
-            m_interpolator->coordinates(x, y);
-        }
-
-        //----------------------------------------------------------------
-        void local_scale(int* x, int* y) const
-        {
-            m_interpolator->local_scale(x, y);
-        }
-
-
-    private:
-        unsigned m_subdiv_shift;
-        unsigned m_subdiv_size;
-        unsigned m_subdiv_mask;
-        interpolator_type* m_interpolator;
-        int      m_src_x;
-        double   m_src_y;
-        unsigned m_pos;
-        unsigned m_len;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_svg_exception.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_exception.h
--- 8.0.1-5/renderers/agg/include/agg_svg_exception.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_exception.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,69 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// SVG exception
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SVG_EXCEPTION_INCLUDED
-#define AGG_SVG_EXCEPTION_INCLUDED
-
-#include <stdio.h>
-#include <string.h>
-#include <stdarg.h>
-
-namespace mapserver 
-{ 
-namespace svg
-{
-    class exception
-    {
-    public:
-        ~exception()
-        {
-            delete [] m_msg;
-        }
-
-        exception() : m_msg(0) {}
-          
-        exception(const char* fmt, ...) :
-            m_msg(0)
-        {
-            if(fmt) 
-            {
-                m_msg = new char [4096];
-                va_list arg;
-                va_start(arg, fmt);
-                vsprintf(m_msg, fmt, arg);
-                va_end(arg);
-            }
-        }
-
-        exception(const exception& exc) :
-            m_msg(exc.m_msg ? new char[strlen(exc.m_msg) + 1] : 0)
-        {
-            if(m_msg) strcpy(m_msg, exc.m_msg);
-        }
-        
-        const char* msg() const { return m_msg; }
-
-    private:
-        char* m_msg;
-    };
-
-}
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_svg_parser.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_parser.h
--- 8.0.1-5/renderers/agg/include/agg_svg_parser.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_parser.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,85 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// SVG parser.
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_SVG_PARSER_INCLUDED
-#define AGG_SVG_PARSER_INCLUDED
-
-#include "agg_svg_path_tokenizer.h"
-#include "agg_svg_path_renderer.h"
-
-namespace mapserver
-{
-namespace svg
-{
-
-    class parser
-    {
-        enum buf_size_e { buf_size = BUFSIZ };
-    public:
-
-        ~parser();
-        parser(path_renderer& path);
-
-        void parse(const char* fname);
-        const char* title() const { return m_title; }
-
-    private:
-        // XML event handlers
-        static void start_element(void* data, const char* el, const char** attr);
-        static void end_element(void* data, const char* el);
-        static void content(void* data, const char* s, int len);
-
-        void parse_attr(const char** attr);
-        void parse_path(const char** attr);
-        void parse_poly(const char** attr, bool close_flag);
-        void parse_rect(const char** attr);
-        void parse_line(const char** attr);
-        void parse_style(const char* str);
-        void parse_transform(const char* str);
-
-        unsigned parse_matrix(const char* str);
-        unsigned parse_translate(const char* str);
-        unsigned parse_rotate(const char* str);
-        unsigned parse_scale(const char* str);
-        unsigned parse_skew_x(const char* str);
-        unsigned parse_skew_y(const char* str);
-        
-        bool parse_attr(const char* name, const char* value);
-        bool parse_name_value(const char* nv_start, const char* nv_end);
-        void copy_name(const char* start, const char* end);
-        void copy_value(const char* start, const char* end);
-        
-    private:
-        path_renderer& m_path;
-        path_tokenizer m_tokenizer;
-        char*          m_buf;
-        char*          m_title;
-        unsigned       m_title_len;
-        bool           m_title_flag;
-        bool           m_path_flag;
-        char*          m_attr_name;
-        char*          m_attr_value;
-        unsigned       m_attr_name_len;
-        unsigned       m_attr_value_len;
-    };
-
-}
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_svg_path_renderer.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_path_renderer.h
--- 8.0.1-5/renderers/agg/include/agg_svg_path_renderer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_path_renderer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,321 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// SVG path renderer.
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_SVG_PATH_RENDERER_INCLUDED
-#define AGG_SVG_PATH_RENDERER_INCLUDED
-
-#include "agg_path_storage.h"
-#include "agg_conv_transform.h"
-#include "agg_conv_stroke.h"
-#include "agg_conv_contour.h"
-#include "agg_conv_curve.h"
-#include "agg_color_rgba.h"
-#include "agg_renderer_scanline.h"
-#include "agg_bounding_rect.h"
-#include "agg_rasterizer_scanline_aa.h"
-#include "agg_svg_path_tokenizer.h"
-
-namespace mapserver
-{
-namespace svg
-{
-    template<class VertexSource> class conv_count
-    {
-    public:
-        conv_count(VertexSource& vs) : m_source(&vs), m_count(0) {}
-
-        void count(unsigned n) { m_count = n; }
-        unsigned count() const { return m_count; }
-
-        void rewind(unsigned path_id) { m_source->rewind(path_id); }
-        unsigned vertex(double* x, double* y) 
-        { 
-            ++m_count; 
-            return m_source->vertex(x, y); 
-        }
-
-    private:
-        VertexSource* m_source;
-        unsigned m_count;
-    };
-
-
-
-
-    //============================================================================
-    // Basic path attributes
-    struct path_attributes
-    {
-        unsigned     index;
-        rgba8        fill_color;
-        rgba8        stroke_color;
-        bool         fill_flag;
-        bool         stroke_flag;
-        bool         even_odd_flag;
-        line_join_e  line_join;
-        line_cap_e   line_cap;
-        double       miter_limit;
-        double       stroke_width;
-        trans_affine transform;
-
-        // Empty constructor
-        path_attributes() :
-            index(0),
-            fill_color(rgba(0,0,0)),
-            stroke_color(rgba(0,0,0)),
-            fill_flag(true),
-            stroke_flag(false),
-            even_odd_flag(false),
-            line_join(miter_join),
-            line_cap(butt_cap),
-            miter_limit(4.0),
-            stroke_width(1.0),
-            transform()
-        {
-        }
-
-        // Copy constructor
-        path_attributes(const path_attributes& attr) :
-            index(attr.index),
-            fill_color(attr.fill_color),
-            stroke_color(attr.stroke_color),
-            fill_flag(attr.fill_flag),
-            stroke_flag(attr.stroke_flag),
-            even_odd_flag(attr.even_odd_flag),
-            line_join(attr.line_join),
-            line_cap(attr.line_cap),
-            miter_limit(attr.miter_limit),
-            stroke_width(attr.stroke_width),
-            transform(attr.transform)
-        {
-        }
-
-        // Copy constructor with new index value
-        path_attributes(const path_attributes& attr, unsigned idx) :
-            index(idx),
-            fill_color(attr.fill_color),
-            stroke_color(attr.stroke_color),
-            fill_flag(attr.fill_flag),
-            stroke_flag(attr.stroke_flag),
-            even_odd_flag(attr.even_odd_flag),
-            line_join(attr.line_join),
-            line_cap(attr.line_cap),
-            miter_limit(attr.miter_limit),
-            stroke_width(attr.stroke_width),
-            transform(attr.transform)
-        {
-        }
-    };
-
-
-    //============================================================================
-    // Path container and renderer. 
-    class path_renderer
-    {
-    public:
-        typedef pod_bvector<path_attributes>   attr_storage;
-
-        typedef conv_curve<path_storage>       curved;
-        typedef conv_count<curved>             curved_count;
-
-        typedef conv_stroke<curved_count>      curved_stroked;
-        typedef conv_transform<curved_stroked> curved_stroked_trans;
-
-        typedef conv_transform<curved_count>   curved_trans;
-        typedef conv_contour<curved_trans>     curved_trans_contour;
-
-        path_renderer();
-
-        void remove_all();
-
-        // Use these functions as follows:
-        // begin_path() when the XML tag <path> comes ("start_element" handler)
-        // parse_path() on "d=" tag attribute
-        // end_path() when parsing of the entire tag is done.
-        void begin_path();
-        void parse_path(path_tokenizer& tok);
-        void end_path();
-
-        // The following functions are essentially a "reflection" of
-        // the respective SVG path commands.
-        void move_to(double x, double y, bool rel=false);   // M, m
-        void line_to(double x,  double y, bool rel=false);  // L, l
-        void hline_to(double x, bool rel=false);            // H, h
-        void vline_to(double y, bool rel=false);            // V, v
-        void curve3(double x1, double y1,                   // Q, q
-                    double x,  double y, bool rel=false);
-        void curve3(double x, double y, bool rel=false);    // T, t
-        void curve4(double x1, double y1,                   // C, c
-                    double x2, double y2, 
-                    double x,  double y, bool rel=false);
-        void curve4(double x2, double y2,                   // S, s
-                    double x,  double y, bool rel=false);
-        void close_subpath();                               // Z, z
-
-//        template<class VertexSource> 
-//        void add_path(VertexSource& vs, 
-//                      unsigned path_id = 0, 
-//                      bool solid_path = true)
-//        {
-//            m_storage.add_path(vs, path_id, solid_path);
-//        }
-
-
-        unsigned vertex_count() const { return m_curved_count.count(); }
-        
-
-        // Call these functions on <g> tag (start_element, end_element respectively)
-        void push_attr();
-        void pop_attr();
-
-        // Attribute setting functions.
-        void fill(const rgba8& f);
-        void stroke(const rgba8& s);
-        void even_odd(bool flag);
-        void stroke_width(double w);
-        void fill_none();
-        void stroke_none();
-        void fill_opacity(double op);
-        void stroke_opacity(double op);
-        void line_join(line_join_e join);
-        void line_cap(line_cap_e cap);
-        void miter_limit(double ml);
-        trans_affine& transform();
-
-        // Make all polygons CCW-oriented
-        void arrange_orientations()
-        {
-            m_storage.arrange_orientations_all_paths(path_flags_ccw);
-        }
-
-        // Expand all polygons 
-        void expand(double value)
-        {
-            m_curved_trans_contour.width(value);
-        }
-
-        unsigned operator [](unsigned idx)
-        {
-            m_transform = m_attr_storage[idx].transform;
-            return m_attr_storage[idx].index;
-        }
-
-        void bounding_rect(double* x1, double* y1, double* x2, double* y2)
-        {
-            mapserver::conv_transform<mapserver::path_storage> trans(m_storage, m_transform);
-            mapserver::bounding_rect(trans, *this, 0, m_attr_storage.size(), x1, y1, x2, y2);
-        }
-
-        // Rendering. One can specify two additional parameters: 
-        // trans_affine and opacity. They can be used to transform the whole
-        // image and/or to make it translucent.
-        template<class Rasterizer, class Scanline, class Renderer> 
-        void render(Rasterizer& ras, 
-                    Scanline& sl,
-                    Renderer& ren, 
-                    const trans_affine& mtx, 
-                    const rect_i& cb,
-                    double opacity=1.0)
-        {
-            unsigned i;
-
-            ras.clip_box(cb.x1, cb.y1, cb.x2, cb.y2);
-            m_curved_count.count(0);
-
-            for(i = 0; i < m_attr_storage.size(); i++)
-            {
-                const path_attributes& attr = m_attr_storage[i];
-                m_transform = attr.transform;
-                m_transform *= mtx;
-                double scl = m_transform.scale();
-                //m_curved.approximation_method(curve_inc);
-                m_curved.approximation_scale(scl);
-                m_curved.angle_tolerance(0.0);
-
-                rgba8 color;
-
-                if(attr.fill_flag)
-                {
-                    ras.reset();
-                    ras.filling_rule(attr.even_odd_flag ? fill_even_odd : fill_non_zero);
-                    if(fabs(m_curved_trans_contour.width()) < 0.0001)
-                    {
-                        ras.add_path(m_curved_trans, attr.index);
-                    }
-                    else
-                    {
-                        m_curved_trans_contour.miter_limit(attr.miter_limit);
-                        ras.add_path(m_curved_trans_contour, attr.index);
-                    }
-
-                    color = attr.fill_color;
-                    color.opacity(color.opacity() * opacity);
-                    ren.color(color);
-                    mapserver::render_scanlines(ras, sl, ren);
-                }
-
-                if(attr.stroke_flag)
-                {
-                    m_curved_stroked.width(attr.stroke_width);
-                    //m_curved_stroked.line_join((attr.line_join == miter_join) ? miter_join_round : attr.line_join);
-                    m_curved_stroked.line_join(attr.line_join);
-                    m_curved_stroked.line_cap(attr.line_cap);
-                    m_curved_stroked.miter_limit(attr.miter_limit);
-                    m_curved_stroked.inner_join(inner_round);
-                    m_curved_stroked.approximation_scale(scl);
-
-                    // If the *visual* line width is considerable we 
-                    // turn on processing of curve cusps.
-                    //---------------------
-                    if(attr.stroke_width * scl > 1.0)
-                    {
-                        m_curved.angle_tolerance(0.2);
-                    }
-                    ras.reset();
-                    ras.filling_rule(fill_non_zero);
-                    ras.add_path(m_curved_stroked_trans, attr.index);
-                    color = attr.stroke_color;
-                    color.opacity(color.opacity() * opacity);
-                    ren.color(color);
-                    mapserver::render_scanlines(ras, sl, ren);
-                }
-            }
-        }
-
-    private:
-        path_attributes& cur_attr();
-
-        path_storage   m_storage;
-        attr_storage   m_attr_storage;
-        attr_storage   m_attr_stack;
-        trans_affine   m_transform;
-
-        curved                       m_curved;
-        curved_count                 m_curved_count;
-
-        curved_stroked               m_curved_stroked;
-        curved_stroked_trans         m_curved_stroked_trans;
-
-        curved_trans                 m_curved_trans;
-        curved_trans_contour         m_curved_trans_contour;
-    };
-
-}
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_svg_path_tokenizer.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_path_tokenizer.h
--- 8.0.1-5/renderers/agg/include/agg_svg_path_tokenizer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_svg_path_tokenizer.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,114 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// SVG path tokenizer.
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_SVG_PATH_TOKENIZER_INCLUDED
-#define AGG_SVG_PATH_TOKENIZER_INCLUDED
-
-#include "agg_svg_exception.h"
-
-namespace mapserver 
-{ 
-namespace svg
-{
-    // SVG path tokenizer. 
-    // Example:
-    //
-    // agg::svg::path_tokenizer tok;
-    //
-    // tok.set_str("M-122.304 84.285L-122.304 84.285 122.203 86.179 ");
-    // while(tok.next())
-    // {
-    //     printf("command='%c' number=%f\n", 
-    //             tok.last_command(), 
-    //             tok.last_number());
-    // }
-    //
-    // The tokenizer does all the routine job of parsing the SVG paths.
-    // It doesn't recognize any graphical primitives, it even doesn't know
-    // anything about pairs of coordinates (X,Y). The purpose of this class 
-    // is to tokenize the numeric values and commands. SVG paths can 
-    // have single numeric values for Horizontal or Vertical line_to commands 
-    // as well as more than two coordinates (4 or 6) for Bezier curves 
-    // depending on the semantics of the command.
-    // The behaviour is as follows:
-    //
-    // Each call to next() returns true if there's new command or new numeric
-    // value or false when the path ends. How to interpret the result
-    // depends on the sematics of the command. For example, command "C" 
-    // (cubic Bezier curve) implies 6 floating point numbers preceded by this 
-    // command. If the command assumes no arguments (like z or Z) the 
-    // the last_number() values won't change, that is, last_number() always
-    // returns the last recognized numeric value, so does last_command().
-    //===============================================================
-    class path_tokenizer
-    {
-     public:
-        path_tokenizer();
-
-        void set_path_str(const char* str);
-        bool next();
-
-        double next(char cmd);
-
-        char   last_command() const { return m_last_command; }
-        double last_number() const { return m_last_number; }
-
-
-    private:
-        static void init_char_mask(char* mask, const char* char_set);
-
-        bool contains(const char* mask, unsigned c) const
-        {
-            return (mask[(c >> 3) & (256/8-1)] & (1 << (c & 7))) != 0;
-        }
-
-        bool is_command(unsigned c) const
-        {
-            return contains(m_commands_mask, c);
-        }
-
-        bool is_numeric(unsigned c) const
-        {
-            return contains(m_numeric_mask, c);
-        }
-
-        bool is_separator(unsigned c) const
-        {
-            return contains(m_separators_mask, c);
-        }
-
-        bool parse_number();
-
-        char m_separators_mask[256/8];
-        char m_commands_mask[256/8];
-        char m_numeric_mask[256/8];
-
-        const char* m_path;
-        double m_last_number;
-        char   m_last_command;
-
-        static const char s_commands[];
-        static const char s_numeric[];
-        static const char s_separators[];
-    };
-
-} //namespace svg
-} //namespace mapserver
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_trans_affine.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_affine.h
--- 8.0.1-5/renderers/agg/include/agg_trans_affine.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_affine.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,518 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Affine transformation classes.
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_TRANS_AFFINE_INCLUDED
-#define AGG_TRANS_AFFINE_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-    const double affine_epsilon = 1e-14; 
-
-    //============================================================trans_affine
-    //
-    // See Implementation agg_trans_affine.cpp
-    //
-    // Affine transformation are linear transformations in Cartesian coordinates
-    // (strictly speaking not only in Cartesian, but for the beginning we will 
-    // think so). They are rotation, scaling, translation and skewing.  
-    // After any affine transformation a line segment remains a line segment 
-    // and it will never become a curve. 
-    //
-    // There will be no math about matrix calculations, since it has been 
-    // described many times. Ask yourself a very simple question:
-    // "why do we need to understand and use some matrix stuff instead of just 
-    // rotating, scaling and so on". The answers are:
-    //
-    // 1. Any combination of transformations can be done by only 4 multiplications
-    //    and 4 additions in floating point.
-    // 2. One matrix transformation is equivalent to the number of consecutive
-    //    discrete transformations, i.e. the matrix "accumulates" all transformations 
-    //    in the order of their settings. Suppose we have 4 transformations: 
-    //       * rotate by 30 degrees,
-    //       * scale X to 2.0, 
-    //       * scale Y to 1.5, 
-    //       * move to (100, 100). 
-    //    The result will depend on the order of these transformations, 
-    //    and the advantage of matrix is that the sequence of discret calls:
-    //    rotate(30), scaleX(2.0), scaleY(1.5), move(100,100) 
-    //    will have exactly the same result as the following matrix transformations:
-    //   
-    //    affine_matrix m;
-    //    m *= rotate_matrix(30); 
-    //    m *= scaleX_matrix(2.0);
-    //    m *= scaleY_matrix(1.5);
-    //    m *= move_matrix(100,100);
-    //
-    //    m.transform_my_point_at_last(x, y);
-    //
-    // What is the good of it? In real life we will set-up the matrix only once
-    // and then transform many points, let alone the convenience to set any 
-    // combination of transformations.
-    //
-    // So, how to use it? Very easy - literally as it's shown above. Not quite,
-    // let us write a correct example:
-    //
-    // mapserver::trans_affine m;
-    // m *= mapserver::trans_affine_rotation(30.0 * 3.1415926 / 180.0);
-    // m *= mapserver::trans_affine_scaling(2.0, 1.5);
-    // m *= mapserver::trans_affine_translation(100.0, 100.0);
-    // m.transform(&x, &y);
-    //
-    // The affine matrix is all you need to perform any linear transformation,
-    // but all transformations have origin point (0,0). It means that we need to 
-    // use 2 translations if we want to rotate someting around (100,100):
-    // 
-    // m *= mapserver::trans_affine_translation(-100.0, -100.0);         // move to (0,0)
-    // m *= mapserver::trans_affine_rotation(30.0 * 3.1415926 / 180.0);  // rotate
-    // m *= mapserver::trans_affine_translation(100.0, 100.0);           // move back to (100,100)
-    //----------------------------------------------------------------------
-    struct trans_affine
-    {
-        double sx, shy, shx, sy, tx, ty;
-
-        //------------------------------------------ Construction
-        // Identity matrix
-        trans_affine() :
-            sx(1.0), shy(0.0), shx(0.0), sy(1.0), tx(0.0), ty(0.0)
-        {}
-
-        // Custom matrix. Usually used in derived classes
-        trans_affine(double v0, double v1, double v2, 
-                     double v3, double v4, double v5) :
-            sx(v0), shy(v1), shx(v2), sy(v3), tx(v4), ty(v5)
-        {}
-
-        // Custom matrix from m[6]
-        explicit trans_affine(const double* m) :
-            sx(m[0]), shy(m[1]), shx(m[2]), sy(m[3]), tx(m[4]), ty(m[5])
-        {}
-
-        // Rectangle to a parallelogram.
-        trans_affine(double x1, double y1, double x2, double y2, 
-                     const double* parl)
-        {
-            rect_to_parl(x1, y1, x2, y2, parl);
-        }
-
-        // Parallelogram to a rectangle.
-        trans_affine(const double* parl, 
-                     double x1, double y1, double x2, double y2)
-        {
-            parl_to_rect(parl, x1, y1, x2, y2);
-        }
-
-        // Arbitrary parallelogram transformation.
-        trans_affine(const double* src, const double* dst)
-        {
-            parl_to_parl(src, dst);
-        }
-
-        //---------------------------------- Parellelogram transformations
-        // transform a parallelogram to another one. Src and dst are 
-        // pointers to arrays of three points (double[6], x1,y1,...) that 
-        // identify three corners of the parallelograms assuming implicit 
-        // fourth point. The arguments are arrays of double[6] mapped 
-        // to x1,y1, x2,y2, x3,y3  where the coordinates are:
-        //        *-----------------*
-        //       /          (x3,y3)/
-        //      /                 /
-        //     /(x1,y1)   (x2,y2)/
-        //    *-----------------*
-        const trans_affine& parl_to_parl(const double* src, 
-                                         const double* dst);
-
-        const trans_affine& rect_to_parl(double x1, double y1, 
-                                         double x2, double y2, 
-                                         const double* parl);
-
-        const trans_affine& parl_to_rect(const double* parl, 
-                                         double x1, double y1, 
-                                         double x2, double y2);
-
-
-        //------------------------------------------ Operations
-        // Reset - load an identity matrix
-        const trans_affine& reset();
-
-        // Direct transformations operations
-        const trans_affine& translate(double x, double y);
-        const trans_affine& rotate(double a);
-        const trans_affine& scale(double s);
-        const trans_affine& scale(double x, double y);
-
-        // Multiply matrix to another one
-        const trans_affine& multiply(const trans_affine& m);
-
-        // Multiply "m" to "this" and assign the result to "this"
-        const trans_affine& premultiply(const trans_affine& m);
-
-        // Multiply matrix to inverse of another one
-        const trans_affine& multiply_inv(const trans_affine& m);
-
-        // Multiply inverse of "m" to "this" and assign the result to "this"
-        const trans_affine& premultiply_inv(const trans_affine& m);
-
-        // Invert matrix. Do not try to invert degenerate matrices, 
-        // there's no check for validity. If you set scale to 0 and 
-        // then try to invert matrix, expect unpredictable result.
-        const trans_affine& invert();
-
-        // Mirroring around X
-        const trans_affine& flip_x();
-
-        // Mirroring around Y
-        const trans_affine& flip_y();
-
-        //------------------------------------------- Load/Store
-        // Store matrix to an array [6] of double
-        void store_to(double* m) const
-        {
-            *m++ = sx; *m++ = shy; *m++ = shx; *m++ = sy; *m++ = tx; *m++ = ty;
-        }
-
-        // Load matrix from an array [6] of double
-        const trans_affine& load_from(const double* m)
-        {
-            sx = *m++; shy = *m++; shx = *m++; sy = *m++; tx = *m++;  ty = *m++;
-            return *this;
-        }
-
-        //------------------------------------------- Operators
-        
-        // Multiply the matrix by another one
-        const trans_affine& operator *= (const trans_affine& m)
-        {
-            return multiply(m);
-        }
-
-        // Multiply the matrix by inverse of another one
-        const trans_affine& operator /= (const trans_affine& m)
-        {
-            return multiply_inv(m);
-        }
-
-        // Multiply the matrix by another one and return
-        // the result in a separete matrix.
-        trans_affine operator * (const trans_affine& m)
-        {
-            return trans_affine(*this).multiply(m);
-        }
-
-        // Multiply the matrix by inverse of another one 
-        // and return the result in a separete matrix.
-        trans_affine operator / (const trans_affine& m)
-        {
-            return trans_affine(*this).multiply_inv(m);
-        }
-
-        // Calculate and return the inverse matrix
-        trans_affine operator ~ () const
-        {
-            trans_affine ret = *this;
-            return ret.invert();
-        }
-
-        // Equal operator with default epsilon
-        bool operator == (const trans_affine& m) const
-        {
-            return is_equal(m, affine_epsilon);
-        }
-
-        // Not Equal operator with default epsilon
-        bool operator != (const trans_affine& m) const
-        {
-            return !is_equal(m, affine_epsilon);
-        }
-
-        //-------------------------------------------- Transformations
-        // Direct transformation of x and y
-        void transform(double* x, double* y) const;
-
-        // Direct transformation of x and y, 2x2 matrix only, no translation
-        void transform_2x2(double* x, double* y) const;
-
-        // Inverse transformation of x and y. It works slower than the 
-        // direct transformation. For massive operations it's better to 
-        // invert() the matrix and then use direct transformations. 
-        void inverse_transform(double* x, double* y) const;
-
-        //-------------------------------------------- Auxiliary
-        // Calculate the determinant of matrix
-        double determinant() const
-        {
-            return sx * sy - shy * shx;
-        }
-
-        // Calculate the reciprocal of the determinant
-        double determinant_reciprocal() const
-        {
-            return 1.0 / (sx * sy - shy * shx);
-        }
-
-        // Get the average scale (by X and Y). 
-        // Basically used to calculate the approximation_scale when
-        // decomposinting curves into line segments.
-        double scale() const;
-
-        // Check to see if the matrix is not degenerate
-        bool is_valid(double epsilon = affine_epsilon) const;
-
-        // Check to see if it's an identity matrix
-        bool is_identity(double epsilon = affine_epsilon) const;
-
-        // Check to see if two matrices are equal
-        bool is_equal(const trans_affine& m, double epsilon = affine_epsilon) const;
-
-        // Determine the major parameters. Use with caution considering 
-        // possible degenerate cases.
-        double rotation() const;
-        void   translation(double* dx, double* dy) const;
-        void   scaling(double* x, double* y) const;
-        void   scaling_abs(double* x, double* y) const;
-    };
-
-    //------------------------------------------------------------------------
-    inline void trans_affine::transform(double* x, double* y) const
-    {
-        const double tmp = *x;
-        *x = tmp * sx  + *y * shx + tx;
-        *y = tmp * shy + *y * sy  + ty;
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_affine::transform_2x2(double* x, double* y) const
-    {
-        const double tmp = *x;
-        *x = tmp * sx  + *y * shx;
-        *y = tmp * shy + *y * sy;
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_affine::inverse_transform(double* x, double* y) const
-    {
-        const double d = determinant_reciprocal();
-        const double a = (*x - tx) * d;
-        const double b = (*y - ty) * d;
-        *x = a * sy - b * shx;
-        *y = b * sx - a * shy;
-    }
-
-    //------------------------------------------------------------------------
-    inline double trans_affine::scale() const
-    {
-        double x = 0.707106781 * sx  + 0.707106781 * shx;
-        double y = 0.707106781 * shy + 0.707106781 * sy;
-        return sqrt(x*x + y*y);
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_affine& trans_affine::translate(double x, double y) 
-    { 
-        tx += x;
-        ty += y; 
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_affine& trans_affine::rotate(double a) 
-    {
-        double ca = cos(a); 
-        double sa = sin(a);
-        double t0 = sx  * ca - shy * sa;
-        double t2 = shx * ca - sy * sa;
-        double t4 = tx  * ca - ty * sa;
-        shy = sx  * sa + shy * ca;
-        sy  = shx * sa + sy * ca; 
-        ty  = tx  * sa + ty * ca;
-        sx  = t0;
-        shx = t2;
-        tx  = t4;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_affine& trans_affine::scale(double x, double y) 
-    {
-        double mm0 = x; // Possible hint for the optimizer
-        double mm3 = y; 
-        sx  *= mm0;
-        shx *= mm0;
-        tx  *= mm0;
-        shy *= mm3;
-        sy  *= mm3;
-        ty  *= mm3;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_affine& trans_affine::scale(double s) 
-    {
-        double m = s; // Possible hint for the optimizer
-        sx  *= m;
-        shx *= m;
-        tx  *= m;
-        shy *= m;
-        sy  *= m;
-        ty  *= m;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_affine& trans_affine::premultiply(const trans_affine& m)
-    {
-        trans_affine t = m;
-        return *this = t.multiply(*this);
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_affine& trans_affine::multiply_inv(const trans_affine& m)
-    {
-        trans_affine t = m;
-        t.invert();
-        return multiply(t);
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_affine& trans_affine::premultiply_inv(const trans_affine& m)
-    {
-        trans_affine t = m;
-        t.invert();
-        return *this = t.multiply(*this);
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_affine::scaling_abs(double* x, double* y) const
-    {
-        // Used to calculate scaling coefficients in image resampling. 
-        // When there is considerable shear this method gives us much
-        // better estimation than just sx, sy.
-        *x = sqrt(sx  * sx  + shx * shx);
-        *y = sqrt(shy * shy + sy  * sy);
-    }
-
-    //====================================================trans_affine_rotation
-    // Rotation matrix. sin() and cos() are calculated twice for the same angle.
-    // There's no harm because the performance of sin()/cos() is very good on all
-    // modern processors. Besides, this operation is not going to be invoked too 
-    // often.
-    class trans_affine_rotation : public trans_affine
-    {
-    public:
-        trans_affine_rotation(double a) : 
-          trans_affine(cos(a), sin(a), -sin(a), cos(a), 0.0, 0.0)
-        {}
-    };
-
-    //====================================================trans_affine_scaling
-    // Scaling matrix. x, y - scale coefficients by X and Y respectively
-    class trans_affine_scaling : public trans_affine
-    {
-    public:
-        trans_affine_scaling(double x, double y) : 
-          trans_affine(x, 0.0, 0.0, y, 0.0, 0.0)
-        {}
-
-        trans_affine_scaling(double s) : 
-          trans_affine(s, 0.0, 0.0, s, 0.0, 0.0)
-        {}
-    };
-
-    //================================================trans_affine_translation
-    // Translation matrix
-    class trans_affine_translation : public trans_affine
-    {
-    public:
-        trans_affine_translation(double x, double y) : 
-          trans_affine(1.0, 0.0, 0.0, 1.0, x, y)
-        {}
-    };
-
-    //====================================================trans_affine_skewing
-    // Sckewing (shear) matrix
-    class trans_affine_skewing : public trans_affine
-    {
-    public:
-        trans_affine_skewing(double x, double y) : 
-          trans_affine(1.0, tan(y), tan(x), 1.0, 0.0, 0.0)
-        {}
-    };
-
-
-    //===============================================trans_affine_line_segment
-    // Rotate, Scale and Translate, associating 0...dist with line segment 
-    // x1,y1,x2,y2
-    class trans_affine_line_segment : public trans_affine
-    {
-    public:
-        trans_affine_line_segment(double x1, double y1, double x2, double y2, 
-                                  double dist)
-        {
-            double dx = x2 - x1;
-            double dy = y2 - y1;
-            if(dist > 0.0)
-            {
-                multiply(trans_affine_scaling(sqrt(dx * dx + dy * dy) / dist));
-            }
-            multiply(trans_affine_rotation(atan2(dy, dx)));
-            multiply(trans_affine_translation(x1, y1));
-        }
-    };
-
-
-    //============================================trans_affine_reflection_unit
-    // Reflection matrix. Reflect coordinates across the line through 
-    // the origin containing the unit vector (ux, uy).
-    // Contributed by John Horigan
-    class trans_affine_reflection_unit : public trans_affine
-    {
-    public:
-        trans_affine_reflection_unit(double ux, double uy) :
-          trans_affine(2.0 * ux * ux - 1.0, 
-                       2.0 * ux * uy, 
-                       2.0 * ux * uy, 
-                       2.0 * uy * uy - 1.0, 
-                       0.0, 0.0)
-        {}
-    };
-
-
-    //=================================================trans_affine_reflection
-    // Reflection matrix. Reflect coordinates across the line through 
-    // the origin at the angle a or containing the non-unit vector (x, y).
-    // Contributed by John Horigan
-    class trans_affine_reflection : public trans_affine_reflection_unit
-    {
-    public:
-        trans_affine_reflection(double a) :
-          trans_affine_reflection_unit(cos(a), sin(a))
-        {}
-
-
-        trans_affine_reflection(double x, double y) :
-          trans_affine_reflection_unit(x / sqrt(x * x + y * y), y / sqrt(x * x + y * y))
-        {}
-    };
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_trans_bilinear.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_bilinear.h
--- 8.0.1-5/renderers/agg/include/agg_trans_bilinear.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_bilinear.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,166 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Bilinear 2D transformations
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_TRANS_BILINEAR_INCLUDED
-#define AGG_TRANS_BILINEAR_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_simul_eq.h"
-
-namespace mapserver
-{
-
-    //==========================================================trans_bilinear
-    class trans_bilinear
-    {
-    public:
-        //--------------------------------------------------------------------
-        trans_bilinear() : m_valid(false) {}
-
-        //--------------------------------------------------------------------
-        // Arbitrary quadrangle transformations
-        trans_bilinear(const double* src, const double* dst) 
-        {
-            quad_to_quad(src, dst);
-        }
-
-
-        //--------------------------------------------------------------------
-        // Direct transformations 
-        trans_bilinear(double x1, double y1, double x2, double y2, 
-                       const double* quad)
-        {
-            rect_to_quad(x1, y1, x2, y2, quad);
-        }
-
-
-        //--------------------------------------------------------------------
-        // Reverse transformations 
-        trans_bilinear(const double* quad, 
-                       double x1, double y1, double x2, double y2)
-        {
-            quad_to_rect(quad, x1, y1, x2, y2);
-        }
-
-
-        //--------------------------------------------------------------------
-        // Set the transformations using two arbitrary quadrangles.
-        void quad_to_quad(const double* src, const double* dst)
-        {
-            double left[4][4];
-            double right[4][2];
-
-            unsigned i;
-            for(i = 0; i < 4; i++)
-            {
-                unsigned ix = i * 2;
-                unsigned iy = ix + 1;
-                left[i][0] = 1.0;
-                left[i][1] = src[ix] * src[iy];
-                left[i][2] = src[ix];
-                left[i][3] = src[iy];
-
-                right[i][0] = dst[ix];
-                right[i][1] = dst[iy];
-            }
-            m_valid = simul_eq<4, 2>::solve(left, right, m_mtx);
-        }
-
-
-        //--------------------------------------------------------------------
-        // Set the direct transformations, i.e., rectangle -> quadrangle
-        void rect_to_quad(double x1, double y1, double x2, double y2, 
-                          const double* quad)
-        {
-            double src[8];
-            src[0] = src[6] = x1;
-            src[2] = src[4] = x2;
-            src[1] = src[3] = y1;
-            src[5] = src[7] = y2;
-            quad_to_quad(src, quad);
-        }
-
-
-        //--------------------------------------------------------------------
-        // Set the reverse transformations, i.e., quadrangle -> rectangle
-        void quad_to_rect(const double* quad, 
-                          double x1, double y1, double x2, double y2)
-        {
-            double dst[8];
-            dst[0] = dst[6] = x1;
-            dst[2] = dst[4] = x2;
-            dst[1] = dst[3] = y1;
-            dst[5] = dst[7] = y2;
-            quad_to_quad(quad, dst);
-        }
-
-        //--------------------------------------------------------------------
-        // Check if the equations were solved successfully
-        bool is_valid() const { return m_valid; }
-
-        //--------------------------------------------------------------------
-        // Transform a point (x, y)
-        void transform(double* x, double* y) const
-        {
-            double tx = *x;
-            double ty = *y;
-            double xy = tx * ty;
-            *x = m_mtx[0][0] + m_mtx[1][0] * xy + m_mtx[2][0] * tx + m_mtx[3][0] * ty;
-            *y = m_mtx[0][1] + m_mtx[1][1] * xy + m_mtx[2][1] * tx + m_mtx[3][1] * ty;
-        }
-
-
-        //--------------------------------------------------------------------
-        class iterator_x
-        {
-            double inc_x;
-            double inc_y;
-
-        public:
-            double x;
-            double y;
-
-            iterator_x() {}
-            iterator_x(double tx, double ty, double step, const double m[4][2]) :
-                inc_x(m[1][0] * step * ty + m[2][0] * step),
-                inc_y(m[1][1] * step * ty + m[2][1] * step),
-                x(m[0][0] + m[1][0] * tx * ty + m[2][0] * tx + m[3][0] * ty),
-                y(m[0][1] + m[1][1] * tx * ty + m[2][1] * tx + m[3][1] * ty)
-            {
-            }
-
-            void operator ++ ()
-            {
-                x += inc_x;
-                y += inc_y;
-            }
-        };
-
-        iterator_x begin(double x, double y, double step) const
-        {
-            return iterator_x(x, y, step, m_mtx);
-        }
-
-    private:
-        double m_mtx[4][2];
-        bool   m_valid;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_trans_double_path.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_double_path.h
--- 8.0.1-5/renderers/agg/include/agg_trans_double_path.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_double_path.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,131 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_TRANS_DOUBLE_PATH_INCLUDED
-#define AGG_TRANS_DOUBLE_PATH_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vertex_sequence.h"
-
-namespace mapserver
-{
-    
-    // See also: agg_trans_double_path.cpp
-    //
-    //-------------------------------------------------------trans_double_path
-    class trans_double_path
-    {
-        enum status_e
-        {
-            initial,
-            making_path,
-            ready
-        };
-
-    public:
-        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
-
-        trans_double_path();
-
-        //--------------------------------------------------------------------
-        void   base_length(double v)  { m_base_length = v; }
-        double base_length() const { return m_base_length; }
-
-        //--------------------------------------------------------------------
-        void   base_height(double v)  { m_base_height = v; }
-        double base_height() const { return m_base_height; }
-
-        //--------------------------------------------------------------------
-        void preserve_x_scale(bool f) { m_preserve_x_scale = f;    }
-        bool preserve_x_scale() const { return m_preserve_x_scale; }
-
-        //--------------------------------------------------------------------
-        void reset();
-        void move_to1(double x, double y);
-        void line_to1(double x, double y);
-        void move_to2(double x, double y);
-        void line_to2(double x, double y);
-        void finalize_paths();
-
-        //--------------------------------------------------------------------
-        template<class VertexSource1, class VertexSource2> 
-        void add_paths(VertexSource1& vs1, VertexSource2& vs2, 
-                       unsigned path1_id=0, unsigned path2_id=0)
-        {
-            double x;
-            double y;
-
-            unsigned cmd;
-
-            vs1.rewind(path1_id);
-            while(!is_stop(cmd = vs1.vertex(&x, &y)))
-            {
-                if(is_move_to(cmd)) 
-                {
-                    move_to1(x, y);
-                }
-                else 
-                {
-                    if(is_vertex(cmd))
-                    {
-                        line_to1(x, y);
-                    }
-                }
-            }
-
-            vs2.rewind(path2_id);
-            while(!is_stop(cmd = vs2.vertex(&x, &y)))
-            {
-                if(is_move_to(cmd)) 
-                {
-                    move_to2(x, y);
-                }
-                else 
-                {
-                    if(is_vertex(cmd))
-                    {
-                        line_to2(x, y);
-                    }
-                }
-            }
-            finalize_paths();
-        }
-
-        //--------------------------------------------------------------------
-        double total_length1() const;
-        double total_length2() const;
-        void transform(double *x, double *y) const;
-
-    private:
-        double finalize_path(vertex_storage& vertices);
-        void transform1(const vertex_storage& vertices, 
-                        double kindex, double kx,
-                        double *x, double* y) const;
-
-        vertex_storage m_src_vertices1;
-        vertex_storage m_src_vertices2;
-        double         m_base_length;
-        double         m_base_height;
-        double         m_kindex1;
-        double         m_kindex2;
-        status_e       m_status1;
-        status_e       m_status2;
-        bool           m_preserve_x_scale;
-    };
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_trans_perspective.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_perspective.h
--- 8.0.1-5/renderers/agg/include/agg_trans_perspective.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_perspective.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,731 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Perspective 2D transformations
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_TRANS_PERSPECTIVE_INCLUDED
-#define AGG_TRANS_PERSPECTIVE_INCLUDED
-
-#include "agg_trans_affine.h"
-
-namespace mapserver
-{
-    //=======================================================trans_perspective
-    struct trans_perspective
-    {
-        double sx, shy, w0, shx, sy, w1, tx, ty, w2;
-
-        //------------------------------------------------------- Construction
-        // Identity matrix
-        trans_perspective() : 
-            sx (1), shy(0), w0(0), 
-            shx(0), sy (1), w1(0), 
-            tx (0), ty (0), w2(1) {}
-
-        // Custom matrix
-        trans_perspective(double v0, double v1, double v2, 
-                          double v3, double v4, double v5,
-                          double v6, double v7, double v8) :
-           sx (v0), shy(v1), w0(v2), 
-           shx(v3), sy (v4), w1(v5), 
-           tx (v6), ty (v7), w2(v8) {}
-
-        // Custom matrix from m[9]
-        explicit trans_perspective(const double* m) :
-           sx (m[0]), shy(m[1]), w0(m[2]), 
-           shx(m[3]), sy (m[4]), w1(m[5]), 
-           tx (m[6]), ty (m[7]), w2(m[8]) {}
-
-        // From affine
-        explicit trans_perspective(const trans_affine& a) : 
-           sx (a.sx ), shy(a.shy), w0(0), 
-           shx(a.shx), sy (a.sy ), w1(0), 
-           tx (a.tx ), ty (a.ty ), w2(1) {}
-
-        // Rectangle to quadrilateral
-        trans_perspective(double x1, double y1, double x2, double y2, 
-                          const double* quad);
-
-        // Quadrilateral to rectangle
-        trans_perspective(const double* quad, 
-                          double x1, double y1, double x2, double y2);
-
-        // Arbitrary quadrilateral transformations
-        trans_perspective(const double* src, const double* dst);
-
-        //-------------------------------------- Quadrilateral transformations
-        // The arguments are double[8] that are mapped to quadrilaterals:
-        // x1,y1, x2,y2, x3,y3, x4,y4
-        bool quad_to_quad(const double* qs, const double* qd);
-
-        bool rect_to_quad(double x1, double y1, 
-                          double x2, double y2,
-                          const double* q);
-
-        bool quad_to_rect(const double* q,
-                          double x1, double y1, 
-                          double x2, double y2);
-
-        // Map square (0,0,1,1) to the quadrilateral and vice versa
-        bool square_to_quad(const double* q);
-        bool quad_to_square(const double* q);
-
-
-        //--------------------------------------------------------- Operations
-        // Reset - load an identity matrix
-        const trans_perspective& reset();
-
-        // Invert matrix. Returns false in degenerate case
-        bool invert();
-
-        // Direct transformations operations
-        const trans_perspective& translate(double x, double y);
-        const trans_perspective& rotate(double a);
-        const trans_perspective& scale(double s);
-        const trans_perspective& scale(double x, double y);
-
-        // Multiply the matrix by another one
-        const trans_perspective& multiply(const trans_perspective& m);
-
-        // Multiply "m" by "this" and assign the result to "this"
-        const trans_perspective& premultiply(const trans_perspective& m);
-
-        // Multiply matrix to inverse of another one
-        const trans_perspective& multiply_inv(const trans_perspective& m);
-
-        // Multiply inverse of "m" by "this" and assign the result to "this"
-        const trans_perspective& premultiply_inv(const trans_perspective& m);
-
-        // Multiply the matrix by another one
-        const trans_perspective& multiply(const trans_affine& m);
-
-        // Multiply "m" by "this" and assign the result to "this"
-        const trans_perspective& premultiply(const trans_affine& m);
-
-        // Multiply the matrix by inverse of another one
-        const trans_perspective& multiply_inv(const trans_affine& m);
-
-        // Multiply inverse of "m" by "this" and assign the result to "this"
-        const trans_perspective& premultiply_inv(const trans_affine& m);
-
-        //--------------------------------------------------------- Load/Store
-        void store_to(double* m) const;
-        const trans_perspective& load_from(const double* m);
-
-        //---------------------------------------------------------- Operators
-        // Multiply the matrix by another one
-        const trans_perspective& operator *= (const trans_perspective& m)
-        {
-            return multiply(m);
-        }
-        const trans_perspective& operator *= (const trans_affine& m)
-        {
-            return multiply(m);
-        }
-
-        // Multiply the matrix by inverse of another one
-        const trans_perspective& operator /= (const trans_perspective& m)
-        {
-            return multiply_inv(m);
-        }
-        const trans_perspective& operator /= (const trans_affine& m)
-        {
-            return multiply_inv(m);
-        }
-
-        // Multiply the matrix by another one and return
-        // the result in a separete matrix.
-        trans_perspective operator * (const trans_perspective& m)
-        {
-            return trans_perspective(*this).multiply(m);
-        }
-        trans_perspective operator * (const trans_affine& m)
-        {
-            return trans_perspective(*this).multiply(m);
-        }
-
-        // Multiply the matrix by inverse of another one 
-        // and return the result in a separete matrix.
-        trans_perspective operator / (const trans_perspective& m)
-        {
-            return trans_perspective(*this).multiply_inv(m);
-        }
-        trans_perspective operator / (const trans_affine& m)
-        {
-            return trans_perspective(*this).multiply_inv(m);
-        }
-
-        // Calculate and return the inverse matrix
-        trans_perspective operator ~ () const
-        {
-            trans_perspective ret = *this;
-            ret.invert();
-            return ret;
-        }
-
-        // Equal operator with default epsilon
-        bool operator == (const trans_perspective& m) const
-        {
-            return is_equal(m, affine_epsilon);
-        }
-
-        // Not Equal operator with default epsilon
-        bool operator != (const trans_perspective& m) const
-        {
-            return !is_equal(m, affine_epsilon);
-        }
-
-        //---------------------------------------------------- Transformations
-        // Direct transformation of x and y
-        void transform(double* x, double* y) const;
-
-        // Direct transformation of x and y, affine part only
-        void transform_affine(double* x, double* y) const;
-
-        // Direct transformation of x and y, 2x2 matrix only, no translation
-        void transform_2x2(double* x, double* y) const;
-
-        // Inverse transformation of x and y. It works slow because
-        // it explicitly inverts the matrix on every call. For massive 
-        // operations it's better to invert() the matrix and then use 
-        // direct transformations. 
-        void inverse_transform(double* x, double* y) const;
-
-
-        //---------------------------------------------------------- Auxiliary
-        const trans_perspective& from_affine(const trans_affine& a);
-        double determinant() const;
-        double determinant_reciprocal() const;
-
-        bool is_valid(double epsilon = affine_epsilon) const;
-        bool is_identity(double epsilon = affine_epsilon) const;
-        bool is_equal(const trans_perspective& m, 
-                      double epsilon = affine_epsilon) const;
-
-        // Determine the major affine parameters. Use with caution 
-        // considering possible degenerate cases.
-        double scale() const;
-        double rotation() const;
-        void   translation(double* dx, double* dy) const;
-        void   scaling(double* x, double* y) const;
-        void   scaling_abs(double* x, double* y) const;
-
-
-
-        //--------------------------------------------------------------------
-        class iterator_x
-        {
-            double den;
-            double den_step;
-            double nom_x;
-            double nom_x_step;
-            double nom_y;
-            double nom_y_step;
-
-        public:
-            double x;
-            double y;
-
-            iterator_x() {}
-            iterator_x(double px, double py, double step, const trans_perspective& m) :
-                den(px * m.w0 + py * m.w1 + m.w2),
-                den_step(m.w0 * step),
-                nom_x(px * m.sx + py * m.shx + m.tx),
-                nom_x_step(step * m.sx),
-                nom_y(px * m.shy + py * m.sy + m.ty),
-                nom_y_step(step * m.shy),
-                x(nom_x / den),
-                y(nom_y / den)
-            {}
-
-            void operator ++ ()
-            {
-                den   += den_step;
-                nom_x += nom_x_step;
-                nom_y += nom_y_step;
-                double d = 1.0 / den;
-                x = nom_x * d;
-                y = nom_y * d;
-            }
-        };
-
-        //--------------------------------------------------------------------
-        iterator_x begin(double x, double y, double step) const
-        {
-            return iterator_x(x, y, step, *this);
-        }
-    };
-
-
-
-
-
-
-
-
-
-   
-
-
-
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::square_to_quad(const double* q)
-    {
-        double dx = q[0] - q[2] + q[4] - q[6];
-        double dy = q[1] - q[3] + q[5] - q[7];
-        if(dx == 0.0 && dy == 0.0)
-        {   
-            // Affine case (parallelogram)
-            //---------------
-            sx  = q[2] - q[0];
-            shy = q[3] - q[1];
-            w0  = 0.0;
-            shx = q[4] - q[2];
-            sy  = q[5] - q[3];
-            w1  = 0.0;
-            tx  = q[0];
-            ty  = q[1];
-            w2  = 1.0;
-        }
-        else
-        {
-            double dx1 = q[2] - q[4];
-            double dy1 = q[3] - q[5];
-            double dx2 = q[6] - q[4];
-            double dy2 = q[7] - q[5];
-            double den = dx1 * dy2 - dx2 * dy1;
-            if(den == 0.0)
-            {
-                // Singular case
-                //---------------
-                sx = shy = w0 = shx = sy = w1 = tx = ty = w2 = 0.0;
-                return false;
-            }
-            // General case
-            //---------------
-            double u = (dx * dy2 - dy * dx2) / den;
-            double v = (dy * dx1 - dx * dy1) / den;
-            sx  = q[2] - q[0] + u * q[2];
-            shy = q[3] - q[1] + u * q[3];
-            w0  = u;
-            shx = q[6] - q[0] + v * q[6];
-            sy  = q[7] - q[1] + v * q[7];
-            w1  = v;
-            tx  = q[0];
-            ty  = q[1];
-            w2  = 1.0;
-        }
-        return true;
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::invert()
-    {
-        double d0 = sy  * w2 - w1  * ty;
-        double d1 = w0  * ty - shy * w2;
-        double d2 = shy * w1 - w0  * sy;
-        double d  = sx  * d0 + shx * d1 + tx * d2;
-        if(d == 0.0) 
-        {
-            sx = shy = w0 = shx = sy = w1 = tx = ty = w2 = 0.0;
-            return false;
-        }
-        d = 1.0 / d;
-        trans_perspective a = *this;
-        sx  = d * d0;
-        shy = d * d1;
-        w0  = d * d2;
-        shx = d * (a.w1 *a.tx  - a.shx*a.w2);
-        sy  = d * (a.sx *a.w2  - a.w0 *a.tx);
-        w1  = d * (a.w0 *a.shx - a.sx *a.w1);
-        tx  = d * (a.shx*a.ty  - a.sy *a.tx);
-        ty  = d * (a.shy*a.tx  - a.sx *a.ty);
-        w2  = d * (a.sx *a.sy  - a.shy*a.shx);
-        return true;
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::quad_to_square(const double* q)
-    {
-        if(!square_to_quad(q)) return false;
-        invert();
-        return true;
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::quad_to_quad(const double* qs, 
-                                                const double* qd)
-    {
-        trans_perspective p;
-        if(!  quad_to_square(qs)) return false;
-        if(!p.square_to_quad(qd)) return false;
-        multiply(p);
-        return true;
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::rect_to_quad(double x1, double y1, 
-                                                double x2, double y2,
-                                                const double* q)
-    {
-        double r[8];
-        r[0] = r[6] = x1;
-        r[2] = r[4] = x2;
-        r[1] = r[3] = y1;
-        r[5] = r[7] = y2;
-        return quad_to_quad(r, q);
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::quad_to_rect(const double* q,
-                                                double x1, double y1, 
-                                                double x2, double y2)
-    {
-        double r[8];
-        r[0] = r[6] = x1;
-        r[2] = r[4] = x2;
-        r[1] = r[3] = y1;
-        r[5] = r[7] = y2;
-        return quad_to_quad(q, r);
-    }
-
-    //------------------------------------------------------------------------
-    inline trans_perspective::trans_perspective(double x1, double y1, 
-                                                double x2, double y2, 
-                                                const double* quad)
-    {
-        rect_to_quad(x1, y1, x2, y2, quad);
-    }
-
-    //------------------------------------------------------------------------
-    inline trans_perspective::trans_perspective(const double* quad, 
-                                                double x1, double y1, 
-                                                double x2, double y2)
-    {
-        quad_to_rect(quad, x1, y1, x2, y2);
-    }
-
-    //------------------------------------------------------------------------
-    inline trans_perspective::trans_perspective(const double* src, 
-                                                const double* dst) 
-    {
-        quad_to_quad(src, dst);
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& trans_perspective::reset()
-    {
-        sx  = 1; shy = 0; w0 = 0; 
-        shx = 0; sy  = 1; w1 = 0;
-        tx  = 0; ty  = 0; w2 = 1;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& 
-    trans_perspective::multiply(const trans_perspective& a)
-    {
-        trans_perspective b = *this;
-        sx  = a.sx *b.sx  + a.shx*b.shy + a.tx*b.w0;
-        shx = a.sx *b.shx + a.shx*b.sy  + a.tx*b.w1;
-        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx*b.w2;
-        shy = a.shy*b.sx  + a.sy *b.shy + a.ty*b.w0;
-        sy  = a.shy*b.shx + a.sy *b.sy  + a.ty*b.w1;
-        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty*b.w2;
-        w0  = a.w0 *b.sx  + a.w1 *b.shy + a.w2*b.w0;
-        w1  = a.w0 *b.shx + a.w1 *b.sy  + a.w2*b.w1;
-        w2  = a.w0 *b.tx  + a.w1 *b.ty  + a.w2*b.w2;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& 
-    trans_perspective::multiply(const trans_affine& a)
-    {
-        trans_perspective b = *this;
-        sx  = a.sx *b.sx  + a.shx*b.shy + a.tx*b.w0;
-        shx = a.sx *b.shx + a.shx*b.sy  + a.tx*b.w1;
-        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx*b.w2;
-        shy = a.shy*b.sx  + a.sy *b.shy + a.ty*b.w0;
-        sy  = a.shy*b.shx + a.sy *b.sy  + a.ty*b.w1;
-        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty*b.w2;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& 
-    trans_perspective::premultiply(const trans_perspective& b)
-    {
-        trans_perspective a = *this;
-        sx  = a.sx *b.sx  + a.shx*b.shy + a.tx*b.w0;
-        shx = a.sx *b.shx + a.shx*b.sy  + a.tx*b.w1;
-        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx*b.w2;
-        shy = a.shy*b.sx  + a.sy *b.shy + a.ty*b.w0;
-        sy  = a.shy*b.shx + a.sy *b.sy  + a.ty*b.w1;
-        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty*b.w2;
-        w0  = a.w0 *b.sx  + a.w1 *b.shy + a.w2*b.w0;
-        w1  = a.w0 *b.shx + a.w1 *b.sy  + a.w2*b.w1;
-        w2  = a.w0 *b.tx  + a.w1 *b.ty  + a.w2*b.w2;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& 
-    trans_perspective::premultiply(const trans_affine& b)
-    {
-        trans_perspective a = *this;
-        sx  = a.sx *b.sx  + a.shx*b.shy;
-        shx = a.sx *b.shx + a.shx*b.sy;
-        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx;
-        shy = a.shy*b.sx  + a.sy *b.shy;
-        sy  = a.shy*b.shx + a.sy *b.sy;
-        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty;
-        w0  = a.w0 *b.sx  + a.w1 *b.shy;
-        w1  = a.w0 *b.shx + a.w1 *b.sy;
-        w2  = a.w0 *b.tx  + a.w1 *b.ty  + a.w2;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    const trans_perspective& 
-    trans_perspective::multiply_inv(const trans_perspective& m)
-    {
-        trans_perspective t = m;
-        t.invert();
-        return multiply(t);
-    }
-
-    //------------------------------------------------------------------------
-    const trans_perspective&
-    trans_perspective::multiply_inv(const trans_affine& m)
-    {
-        trans_affine t = m;
-        t.invert();
-        return multiply(t);
-    }
-
-    //------------------------------------------------------------------------
-    const trans_perspective&
-    trans_perspective::premultiply_inv(const trans_perspective& m)
-    {
-        trans_perspective t = m;
-        t.invert();
-        return *this = t.multiply(*this);
-    }
-
-    //------------------------------------------------------------------------
-    const trans_perspective&
-    trans_perspective::premultiply_inv(const trans_affine& m)
-    {
-        trans_perspective t(m);
-        t.invert();
-        return *this = t.multiply(*this);
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& 
-    trans_perspective::translate(double x, double y)
-    {
-        tx += x;
-        ty += y;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& trans_perspective::rotate(double a)
-    {
-        multiply(trans_affine_rotation(a));
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& trans_perspective::scale(double s)
-    {
-        multiply(trans_affine_scaling(s));
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& trans_perspective::scale(double x, double y)
-    {
-        multiply(trans_affine_scaling(x, y));
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_perspective::transform(double* px, double* py) const
-    {
-        double x = *px;
-        double y = *py;
-        double m = 1.0 / (x*w0 + y*w1 + w2);
-        *px = m * (x*sx  + y*shx + tx);
-        *py = m * (x*shy + y*sy  + ty);
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_perspective::transform_affine(double* x, double* y) const
-    {
-        double tmp = *x;
-        *x = tmp * sx  + *y * shx + tx;
-        *y = tmp * shy + *y * sy  + ty;
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_perspective::transform_2x2(double* x, double* y) const
-    {
-        double tmp = *x;
-        *x = tmp * sx  + *y * shx;
-        *y = tmp * shy + *y * sy;
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_perspective::inverse_transform(double* x, double* y) const
-    {
-        trans_perspective t(*this);
-        if(t.invert()) t.transform(x, y);
-    }
-
-    //------------------------------------------------------------------------
-    inline void trans_perspective::store_to(double* m) const
-    {
-        *m++ = sx;  *m++ = shy; *m++ = w0; 
-        *m++ = shx; *m++ = sy;  *m++ = w1;
-        *m++ = tx;  *m++ = ty;  *m++ = w2;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& trans_perspective::load_from(const double* m)
-    {
-        sx  = *m++; shy = *m++; w0 = *m++; 
-        shx = *m++; sy  = *m++; w1 = *m++;
-        tx  = *m++; ty  = *m++; w2 = *m++;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline const trans_perspective& 
-    trans_perspective::from_affine(const trans_affine& a)
-    {
-        sx  = a.sx;  shy = a.shy; w0 = 0; 
-        shx = a.shx; sy  = a.sy;  w1 = 0;
-        tx  = a.tx;  ty  = a.ty;  w2 = 1;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    inline double trans_perspective::determinant() const
-    {
-        return sx  * (sy  * w2 - ty  * w1) +
-               shx * (ty  * w0 - shy * w2) +
-               tx  * (shy * w1 - sy  * w0);
-    }
-  
-    //------------------------------------------------------------------------
-    inline double trans_perspective::determinant_reciprocal() const
-    {
-        return 1.0 / determinant();
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::is_valid(double epsilon) const
-    {
-        return fabs(sx) > epsilon && fabs(sy) > epsilon && fabs(w2) > epsilon;
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::is_identity(double epsilon) const
-    {
-        return is_equal_eps(sx,  1.0, epsilon) &&
-               is_equal_eps(shy, 0.0, epsilon) &&
-               is_equal_eps(w0,  0.0, epsilon) &&
-               is_equal_eps(shx, 0.0, epsilon) && 
-               is_equal_eps(sy,  1.0, epsilon) &&
-               is_equal_eps(w1,  0.0, epsilon) &&
-               is_equal_eps(tx,  0.0, epsilon) &&
-               is_equal_eps(ty,  0.0, epsilon) &&
-               is_equal_eps(w2,  1.0, epsilon);
-    }
-
-    //------------------------------------------------------------------------
-    inline bool trans_perspective::is_equal(const trans_perspective& m, 
-                                            double epsilon) const
-    {
-        return is_equal_eps(sx,  m.sx,  epsilon) &&
-               is_equal_eps(shy, m.shy, epsilon) &&
-               is_equal_eps(w0,  m.w0,  epsilon) &&
-               is_equal_eps(shx, m.shx, epsilon) && 
-               is_equal_eps(sy,  m.sy,  epsilon) &&
-               is_equal_eps(w1,  m.w1,  epsilon) &&
-               is_equal_eps(tx,  m.tx,  epsilon) &&
-               is_equal_eps(ty,  m.ty,  epsilon) &&
-               is_equal_eps(w2,  m.w2,  epsilon);
-    }
-
-    //------------------------------------------------------------------------
-    inline double trans_perspective::scale() const
-    {
-        double x = 0.707106781 * sx  + 0.707106781 * shx;
-        double y = 0.707106781 * shy + 0.707106781 * sy;
-        return sqrt(x*x + y*y);
-    }
-
-    //------------------------------------------------------------------------
-    inline double trans_perspective::rotation() const
-    {
-        double x1 = 0.0;
-        double y1 = 0.0;
-        double x2 = 1.0;
-        double y2 = 0.0;
-        transform(&x1, &y1);
-        transform(&x2, &y2);
-        return atan2(y2-y1, x2-x1);
-    }
-
-    //------------------------------------------------------------------------
-    void trans_perspective::translation(double* dx, double* dy) const
-    {
-        *dx = tx;
-        *dy = ty;
-    }
-
-    //------------------------------------------------------------------------
-    void trans_perspective::scaling(double* x, double* y) const
-    {
-        double x1 = 0.0;
-        double y1 = 0.0;
-        double x2 = 1.0;
-        double y2 = 1.0;
-        trans_perspective t(*this);
-        t *= trans_affine_rotation(-rotation());
-        t.transform(&x1, &y1);
-        t.transform(&x2, &y2);
-        *x = x2 - x1;
-        *y = y2 - y1;
-    }
-
-    //------------------------------------------------------------------------
-    void trans_perspective::scaling_abs(double* x, double* y) const
-    {
-        *x = sqrt(sx  * sx  + shx * shx);
-        *y = sqrt(shy * shy + sy  * sy);
-    }
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_trans_single_path.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_single_path.h
--- 8.0.1-5/renderers/agg/include/agg_trans_single_path.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_single_path.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,97 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_TRANS_SINGLE_PATH_INCLUDED
-#define AGG_TRANS_SINGLE_PATH_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vertex_sequence.h"
-
-namespace mapserver
-{
-
-    // See also: agg_trans_single_path.cpp
-    //
-    //-------------------------------------------------------trans_single_path
-    class trans_single_path
-    {
-        enum status_e
-        {
-            initial,
-            making_path,
-            ready
-        };
-
-    public:
-        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
-
-        trans_single_path();
-
-        //--------------------------------------------------------------------
-        void   base_length(double v)  { m_base_length = v; }
-        double base_length() const { return m_base_length; }
-
-        //--------------------------------------------------------------------
-        void preserve_x_scale(bool f) { m_preserve_x_scale = f;    }
-        bool preserve_x_scale() const { return m_preserve_x_scale; }
-
-        //--------------------------------------------------------------------
-        void reset();
-        void move_to(double x, double y);
-        void line_to(double x, double y);
-        void finalize_path();
-
-        //--------------------------------------------------------------------
-        template<class VertexSource> 
-        void add_path(VertexSource& vs, unsigned path_id=0)
-        {
-            double x;
-            double y;
-
-            unsigned cmd;
-            vs.rewind(path_id);
-            while(!is_stop(cmd = vs.vertex(&x, &y)))
-            {
-                if(is_move_to(cmd)) 
-                {
-                    move_to(x, y);
-                }
-                else 
-                {
-                    if(is_vertex(cmd))
-                    {
-                        line_to(x, y);
-                    }
-                }
-            }
-            finalize_path();
-        }
-
-        //--------------------------------------------------------------------
-        double total_length() const;
-        void transform(double *x, double *y) const;
-
-    private:
-        vertex_storage m_src_vertices;
-        double         m_base_length;
-        double         m_kindex;
-        status_e       m_status;
-        bool           m_preserve_x_scale;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_trans_viewport.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_viewport.h
--- 8.0.1-5/renderers/agg/include/agg_trans_viewport.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_viewport.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,303 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Viewport transformer - simple orthogonal conversions from world coordinates
-//                        to screen (device) ones.
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_TRANS_VIEWPORT_INCLUDED
-#define AGG_TRANS_VIEWPORT_INCLUDED
-
-#include <string.h>
-#include "agg_trans_affine.h"
-
-
-namespace mapserver
-{
-
-    enum aspect_ratio_e
-    {
-        aspect_ratio_stretch,
-        aspect_ratio_meet,
-        aspect_ratio_slice
-    };
-
-
-    //----------------------------------------------------------trans_viewport
-    class trans_viewport
-    {
-    public:
-        //-------------------------------------------------------------------
-        trans_viewport() : 
-            m_world_x1(0.0),
-            m_world_y1(0.0),
-            m_world_x2(1.0),
-            m_world_y2(1.0),
-            m_device_x1(0.0),
-            m_device_y1(0.0),
-            m_device_x2(1.0),
-            m_device_y2(1.0),
-            m_aspect(aspect_ratio_stretch),
-            m_is_valid(true),
-            m_align_x(0.5),
-            m_align_y(0.5),
-            m_wx1(0.0),
-            m_wy1(0.0),
-            m_wx2(1.0),
-            m_wy2(1.0),
-            m_dx1(0.0),
-            m_dy1(0.0),
-            m_kx(1.0),
-            m_ky(1.0)
-        {}
-
-        //-------------------------------------------------------------------
-        void preserve_aspect_ratio(double alignx, 
-                                   double aligny, 
-                                   aspect_ratio_e aspect)
-        {
-            m_align_x = alignx;
-            m_align_y = aligny;
-            m_aspect  = aspect;
-            update();
-        }
-
-        //-------------------------------------------------------------------
-        void device_viewport(double x1, double y1, double x2, double y2)
-        {
-            m_device_x1 = x1;
-            m_device_y1 = y1;
-            m_device_x2 = x2;
-            m_device_y2 = y2;
-            update();
-        }
-
-        //-------------------------------------------------------------------
-        void world_viewport(double x1, double y1, double x2, double y2)
-        {
-            m_world_x1 = x1;
-            m_world_y1 = y1;
-            m_world_x2 = x2;
-            m_world_y2 = y2;
-            update();
-        }
-
-        //-------------------------------------------------------------------
-        void device_viewport(double* x1, double* y1, double* x2, double* y2) const
-        {
-            *x1 = m_device_x1;
-            *y1 = m_device_y1;
-            *x2 = m_device_x2;
-            *y2 = m_device_y2;
-        }
-
-        //-------------------------------------------------------------------
-        void world_viewport(double* x1, double* y1, double* x2, double* y2) const
-        {
-            *x1 = m_world_x1;
-            *y1 = m_world_y1;
-            *x2 = m_world_x2;
-            *y2 = m_world_y2;
-        }
-
-        //-------------------------------------------------------------------
-        void world_viewport_actual(double* x1, double* y1, 
-                                   double* x2, double* y2) const
-        {
-            *x1 = m_wx1;
-            *y1 = m_wy1;
-            *x2 = m_wx2;
-            *y2 = m_wy2;
-        }
-
-        //-------------------------------------------------------------------
-        bool   is_valid()             const { return m_is_valid; }
-        double align_x()              const { return m_align_x; }
-        double align_y()              const { return m_align_y; }
-        aspect_ratio_e aspect_ratio() const { return m_aspect; }
-
-        //-------------------------------------------------------------------
-        void transform(double* x, double* y) const
-        {
-            *x = (*x - m_wx1) * m_kx + m_dx1;
-            *y = (*y - m_wy1) * m_ky + m_dy1;
-        }
-
-        //-------------------------------------------------------------------
-        void transform_scale_only(double* x, double* y) const
-        {
-            *x *= m_kx;
-            *y *= m_ky;
-        }
-
-        //-------------------------------------------------------------------
-        void inverse_transform(double* x, double* y) const
-        {
-            *x = (*x - m_dx1) / m_kx + m_wx1;
-            *y = (*y - m_dy1) / m_ky + m_wy1;
-        }
-
-        //-------------------------------------------------------------------
-        void inverse_transform_scale_only(double* x, double* y) const
-        {
-            *x /= m_kx;
-            *y /= m_ky;
-        }
-
-        //-------------------------------------------------------------------
-        double device_dx() const { return m_dx1 - m_wx1 * m_kx; }
-        double device_dy() const { return m_dy1 - m_wy1 * m_ky; }
-
-        //-------------------------------------------------------------------
-        double scale_x() const
-        {
-            return m_kx;
-        }
-
-        //-------------------------------------------------------------------
-        double scale_y() const
-        {
-            return m_ky;
-        }
-
-        //-------------------------------------------------------------------
-        double scale() const
-        {
-            return (m_kx + m_ky) * 0.5;
-        }
-
-        //-------------------------------------------------------------------
-        trans_affine to_affine() const
-        {
-            trans_affine mtx = trans_affine_translation(-m_wx1, -m_wy1);
-            mtx *= trans_affine_scaling(m_kx, m_ky);
-            mtx *= trans_affine_translation(m_dx1, m_dy1);
-            return mtx;
-        }
-
-        //-------------------------------------------------------------------
-        trans_affine to_affine_scale_only() const
-        {
-            return trans_affine_scaling(m_kx, m_ky);
-        }
-
-        //-------------------------------------------------------------------
-        unsigned byte_size() const
-        {
-            return sizeof(*this);
-        }
-
-        void serialize(int8u* ptr) const
-        {
-            memcpy(ptr, this, sizeof(*this)); 
-        }
-
-        void deserialize(const int8u* ptr)
-        {
-            memcpy(this,  ptr, sizeof(*this));
-        }
-
-    private:
-        void update();
-
-        double         m_world_x1;
-        double         m_world_y1;
-        double         m_world_x2;
-        double         m_world_y2;
-        double         m_device_x1;
-        double         m_device_y1;
-        double         m_device_x2;
-        double         m_device_y2;
-        aspect_ratio_e m_aspect;
-        bool           m_is_valid;
-        double         m_align_x;
-        double         m_align_y;
-        double         m_wx1;
-        double         m_wy1;
-        double         m_wx2;
-        double         m_wy2;
-        double         m_dx1;
-        double         m_dy1;
-        double         m_kx;
-        double         m_ky;
-    };
-
-
-
-    //-----------------------------------------------------------------------
-    inline void trans_viewport::update()
-    {
-        const double epsilon = 1e-30;
-        if(fabs(m_world_x1  - m_world_x2)  < epsilon ||
-           fabs(m_world_y1  - m_world_y2)  < epsilon ||
-           fabs(m_device_x1 - m_device_x2) < epsilon ||
-           fabs(m_device_y1 - m_device_y2) < epsilon)
-        {
-            m_wx1 = m_world_x1;
-            m_wy1 = m_world_y1;
-            m_wx2 = m_world_x1 + 1.0;
-            m_wy2 = m_world_y2 + 1.0;
-            m_dx1 = m_device_x1;
-            m_dy1 = m_device_y1;
-            m_kx  = 1.0;
-            m_ky  = 1.0;
-            m_is_valid = false;
-            return;
-        }
-
-        double world_x1  = m_world_x1;
-        double world_y1  = m_world_y1;
-        double world_x2  = m_world_x2;
-        double world_y2  = m_world_y2;
-        double device_x1 = m_device_x1;
-        double device_y1 = m_device_y1;
-        double device_x2 = m_device_x2;
-        double device_y2 = m_device_y2;
-        if(m_aspect != aspect_ratio_stretch)
-        {
-            double d;
-            m_kx = (device_x2 - device_x1) / (world_x2 - world_x1);
-            m_ky = (device_y2 - device_y1) / (world_y2 - world_y1);
-
-            if((m_aspect == aspect_ratio_meet) == (m_kx < m_ky))
-            {
-                d         = (world_y2 - world_y1) * m_ky / m_kx;
-                world_y1 += (world_y2 - world_y1 - d) * m_align_y;
-                world_y2  =  world_y1 + d;
-            }
-            else
-            {
-                d         = (world_x2 - world_x1) * m_kx / m_ky;
-                world_x1 += (world_x2 - world_x1 - d) * m_align_x;
-                world_x2  =  world_x1 + d;
-            }
-        }
-        m_wx1 = world_x1;
-        m_wy1 = world_y1;
-        m_wx2 = world_x2;
-        m_wy2 = world_y2;
-        m_dx1 = device_x1;
-        m_dy1 = device_y1;
-        m_kx  = (device_x2 - device_x1) / (world_x2 - world_x1);
-        m_ky  = (device_y2 - device_y1) / (world_y2 - world_y1);
-        m_is_valid = true;
-    }
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_trans_warp_magnifier.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_warp_magnifier.h
--- 8.0.1-5/renderers/agg/include/agg_trans_warp_magnifier.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_trans_warp_magnifier.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,56 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_WARP_MAGNIFIER_INCLUDED
-#define AGG_WARP_MAGNIFIER_INCLUDED
-
-
-namespace mapserver
-{
-
-    //----------------------------------------------------trans_warp_magnifier
-    //
-    // See Inmplementation agg_trans_warp_magnifier.cpp
-    //
-    class trans_warp_magnifier
-    {
-    public:
-        trans_warp_magnifier() : m_xc(0.0), m_yc(0.0), m_magn(1.0), m_radius(1.0) {}
- 
-        void center(double x, double y) { m_xc = x; m_yc = y; }
-        void magnification(double m)    { m_magn = m;         }
-        void radius(double r)           { m_radius = r;       }
-
-        double xc()            const { return m_xc; }
-        double yc()            const { return m_yc; }
-        double magnification() const { return m_magn;   }
-        double radius()        const { return m_radius; }
-
-        void transform(double* x, double* y) const;
-        void inverse_transform(double* x, double* y) const;
-
-    private:
-        double m_xc;
-        double m_yc;
-        double m_magn;
-        double m_radius;
-    };
-
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_vcgen_bspline.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_bspline.h
--- 8.0.1-5/renderers/agg/include/agg_vcgen_bspline.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_bspline.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,74 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VCGEN_BSPLINE_INCLUDED
-#define AGG_VCGEN_BSPLINE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_array.h"
-#include "agg_bspline.h"
-
-
-namespace mapserver
-{
-
-    //==========================================================vcgen_bspline
-    class vcgen_bspline
-    {
-        enum status_e
-        {
-            initial,
-            ready,
-            polygon,
-            end_poly,
-            stop
-        };
-
-    public:
-        typedef pod_bvector<point_d, 6> vertex_storage;
-
-        vcgen_bspline();
-
-        void interpolation_step(double v) { m_interpolation_step = v; }
-        double interpolation_step() const { return m_interpolation_step; }
-
-        // Vertex Generator Interface
-        void remove_all();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        // Vertex Source Interface
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        vcgen_bspline(const vcgen_bspline&);
-        const vcgen_bspline& operator = (const vcgen_bspline&);
-
-        vertex_storage m_src_vertices;
-        bspline        m_spline_x;
-        bspline        m_spline_y;
-        double         m_interpolation_step;
-        unsigned       m_closed;
-        status_e       m_status;
-        unsigned       m_src_vertex;
-        double         m_cur_abscissa;
-        double         m_max_abscissa;
-    };
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_vcgen_contour.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_contour.h
--- 8.0.1-5/renderers/agg/include/agg_vcgen_contour.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_contour.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,94 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VCGEN_CONTOUR_INCLUDED
-#define AGG_VCGEN_CONTOUR_INCLUDED
-
-#include "agg_math_stroke.h"
-
-namespace mapserver
-{
-
-    //----------------------------------------------------------vcgen_contour
-    //
-    // See Implementation agg_vcgen_contour.cpp
-    //
-    class vcgen_contour
-    {
-        enum status_e
-        {
-            initial,
-            ready,
-            outline,
-            out_vertices,
-            end_poly,
-            stop
-        };
-
-    public:
-        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
-        typedef pod_bvector<point_d, 6>         coord_storage;
-
-        vcgen_contour();
-
-        void line_cap(line_cap_e lc)     { m_stroker.line_cap(lc); }
-        void line_join(line_join_e lj)   { m_stroker.line_join(lj); }
-        void inner_join(inner_join_e ij) { m_stroker.inner_join(ij); }
-
-        line_cap_e   line_cap()   const { return m_stroker.line_cap(); }
-        line_join_e  line_join()  const { return m_stroker.line_join(); }
-        inner_join_e inner_join() const { return m_stroker.inner_join(); }
-
-        void width(double w) { m_stroker.width(m_width = w); }
-        void miter_limit(double ml) { m_stroker.miter_limit(ml); }
-        void miter_limit_theta(double t) { m_stroker.miter_limit_theta(t); }
-        void inner_miter_limit(double ml) { m_stroker.inner_miter_limit(ml); }
-        void approximation_scale(double as) { m_stroker.approximation_scale(as); }
-
-        double width() const { return m_width; }
-        double miter_limit() const { return m_stroker.miter_limit(); }
-        double inner_miter_limit() const { return m_stroker.inner_miter_limit(); }
-        double approximation_scale() const { return m_stroker.approximation_scale(); }
-
-        void auto_detect_orientation(bool v) { m_auto_detect = v; }
-        bool auto_detect_orientation() const { return m_auto_detect; }
-
-        // Generator interface
-        void remove_all();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        // Vertex Source Interface
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        vcgen_contour(const vcgen_contour&);
-        const vcgen_contour& operator = (const vcgen_contour&);
-
-        math_stroke<coord_storage> m_stroker;
-        double                     m_width;
-        vertex_storage             m_src_vertices;
-        coord_storage              m_out_vertices;
-        status_e                   m_status;
-        unsigned                   m_src_vertex;
-        unsigned                   m_out_vertex = 0;
-        unsigned                   m_closed;
-        unsigned                   m_orientation;
-        bool                       m_auto_detect;
-    };
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vcgen_dash.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_dash.h
--- 8.0.1-5/renderers/agg/include/agg_vcgen_dash.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_dash.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,93 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Line dash generator
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_VCGEN_DASH_INCLUDED
-#define AGG_VCGEN_DASH_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vertex_sequence.h"
-
-namespace mapserver
-{
-
-    //---------------------------------------------------------------vcgen_dash
-    //
-    // See Implementation agg_vcgen_dash.cpp
-    //
-    class vcgen_dash
-    {
-        enum max_dashes_e
-        {
-            max_dashes = 32
-        };
-
-        enum status_e
-        {
-            initial,
-            ready,
-            polyline,
-            stop
-        };
-
-    public:
-        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
-
-        vcgen_dash();
-
-        void remove_all_dashes();
-        void add_dash(double dash_len, double gap_len);
-        void dash_start(double ds);
-
-        void shorten(double s) { m_shorten = s; }
-        double shorten() const { return m_shorten; }
-
-        // Vertex Generator Interface
-        void remove_all();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        // Vertex Source Interface
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        vcgen_dash(const vcgen_dash&);
-        const vcgen_dash& operator = (const vcgen_dash&);
-
-        void calc_dash_start(double ds);
-
-        double             m_dashes[max_dashes];
-        double             m_total_dash_len;
-        unsigned           m_num_dashes;
-        double             m_dash_start;
-        double             m_shorten;
-        double             m_curr_dash_start;
-        unsigned           m_curr_dash;
-        double             m_curr_rest = 0;
-        const vertex_dist* m_v1 = nullptr;
-        const vertex_dist* m_v2 = nullptr;
-
-        vertex_storage m_src_vertices;
-        unsigned       m_closed;
-        status_e       m_status;
-        unsigned       m_src_vertex;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vcgen_markers_term.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_markers_term.h
--- 8.0.1-5/renderers/agg/include/agg_vcgen_markers_term.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_markers_term.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VCGEN_MARKERS_TERM_INCLUDED
-#define AGG_VCGEN_MARKERS_TERM_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vertex_sequence.h"
-
-namespace mapserver
-{
-
-    //======================================================vcgen_markers_term
-    //
-    // See Implemantation agg_vcgen_markers_term.cpp
-    // Terminal markers generator (arrowhead/arrowtail)
-    //
-    //------------------------------------------------------------------------
-    class vcgen_markers_term
-    {
-    public:
-        vcgen_markers_term() : m_curr_id(0), m_curr_idx(0) {}
-
-        // Vertex Generator Interface
-        void remove_all();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        // Vertex Source Interface
-        void rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        vcgen_markers_term(const vcgen_markers_term&);
-        const vcgen_markers_term& operator = (const vcgen_markers_term&);
-
-        struct coord_type
-        {
-            double x, y;
-
-            coord_type() {}
-            coord_type(double x_, double y_) : x(x_), y(y_) {}
-        };
-
-        typedef pod_bvector<coord_type, 6> coord_storage; 
-
-        coord_storage m_markers;
-        unsigned      m_curr_id;
-        unsigned      m_curr_idx;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vcgen_smooth_poly1.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_smooth_poly1.h
--- 8.0.1-5/renderers/agg/include/agg_vcgen_smooth_poly1.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_smooth_poly1.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,87 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VCGEN_SMOOTH_POLY1_INCLUDED
-#define AGG_VCGEN_SMOOTH_POLY1_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vertex_sequence.h"
-
-
-namespace mapserver
-{
-
-    //======================================================vcgen_smooth_poly1
-    //
-    // See Implementation agg_vcgen_smooth_poly1.cpp 
-    // Smooth polygon generator
-    //
-    //------------------------------------------------------------------------
-    class vcgen_smooth_poly1
-    {
-        enum status_e
-        {
-            initial,
-            ready,
-            polygon,
-            ctrl_b,
-            ctrl_e,
-            ctrl1,
-            ctrl2,
-            end_poly,
-            stop
-        };
-
-    public:
-        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
-
-        vcgen_smooth_poly1();
-
-        void   smooth_value(double v) { m_smooth_value = v * 0.5; }
-        double smooth_value() const { return m_smooth_value * 2.0; }
-
-        // Vertex Generator Interface
-        void remove_all();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        // Vertex Source Interface
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        vcgen_smooth_poly1(const vcgen_smooth_poly1&);
-        const vcgen_smooth_poly1& operator = (const vcgen_smooth_poly1&);
-
-        void calculate(const vertex_dist& v0, 
-                       const vertex_dist& v1, 
-                       const vertex_dist& v2,
-                       const vertex_dist& v3);
-
-        vertex_storage m_src_vertices;
-        double         m_smooth_value;
-        unsigned       m_closed;
-        status_e       m_status;
-        unsigned       m_src_vertex;
-        double         m_ctrl1_x;
-        double         m_ctrl1_y;
-        double         m_ctrl2_x;
-        double         m_ctrl2_y;
-    };
-
-}
-
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/agg_vcgen_stroke.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_stroke.h
--- 8.0.1-5/renderers/agg/include/agg_vcgen_stroke.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_stroke.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,102 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VCGEN_STROKE_INCLUDED
-#define AGG_VCGEN_STROKE_INCLUDED
-
-#include "agg_math_stroke.h"
-
-
-namespace mapserver
-{
-
-    //============================================================vcgen_stroke
-    //
-    // See Implementation agg_vcgen_stroke.cpp
-    // Stroke generator
-    //
-    //------------------------------------------------------------------------
-    class vcgen_stroke
-    {
-        enum status_e
-        {
-            initial,
-            ready,
-            cap1,
-            cap2,
-            outline1,
-            close_first,
-            outline2,
-            out_vertices,
-            end_poly1,
-            end_poly2,
-            stop
-        };
-
-    public:
-        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
-        typedef pod_bvector<point_d, 6>         coord_storage;
-
-        vcgen_stroke();
-
-        void line_cap(line_cap_e lc)     { m_stroker.line_cap(lc); }
-        void line_join(line_join_e lj)   { m_stroker.line_join(lj); }
-        void inner_join(inner_join_e ij) { m_stroker.inner_join(ij); }
-
-        line_cap_e   line_cap()   const { return m_stroker.line_cap(); }
-        line_join_e  line_join()  const { return m_stroker.line_join(); }
-        inner_join_e inner_join() const { return m_stroker.inner_join(); }
-
-        void width(double w) { m_stroker.width(w); }
-        void miter_limit(double ml) { m_stroker.miter_limit(ml); }
-        void miter_limit_theta(double t) { m_stroker.miter_limit_theta(t); }
-        void inner_miter_limit(double ml) { m_stroker.inner_miter_limit(ml); }
-        void approximation_scale(double as) { m_stroker.approximation_scale(as); }
-
-        double width() const { return m_stroker.width(); }
-        double miter_limit() const { return m_stroker.miter_limit(); }
-        double inner_miter_limit() const { return m_stroker.inner_miter_limit(); }
-        double approximation_scale() const { return m_stroker.approximation_scale(); }
-
-        void shorten(double s) { m_shorten = s; }
-        double shorten() const { return m_shorten; }
-
-        // Vertex Generator Interface
-        void remove_all();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        // Vertex Source Interface
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        vcgen_stroke(const vcgen_stroke&);
-        const vcgen_stroke& operator = (const vcgen_stroke&);
-
-        math_stroke<coord_storage> m_stroker;
-        vertex_storage             m_src_vertices;
-        coord_storage              m_out_vertices;
-        double                     m_shorten;
-        unsigned                   m_closed;
-        status_e                   m_status;
-        status_e                   m_prev_status = initial;
-        unsigned                   m_src_vertex;
-        unsigned                   m_out_vertex;
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vcgen_vertex_sequence.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_vertex_sequence.h
--- 8.0.1-5/renderers/agg/include/agg_vcgen_vertex_sequence.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vcgen_vertex_sequence.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,135 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VCGEN_VERTEX_SEQUENCE_INCLUDED
-#define AGG_VCGEN_VERTEX_SEQUENCE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_vertex_sequence.h"
-#include "agg_shorten_path.h"
-
-namespace mapserver
-{
-
-    //===================================================vcgen_vertex_sequence
-    class vcgen_vertex_sequence
-    {
-    public:
-        typedef vertex_dist_cmd                 vertex_type;
-        typedef vertex_sequence<vertex_type, 6> vertex_storage;
-
-        vcgen_vertex_sequence() :
-            m_flags(0),
-            m_cur_vertex(0),
-            m_shorten(0.0),
-            m_ready(false)
-        {
-        }
-
-        // Vertex Generator Interface
-        void remove_all();
-        void add_vertex(double x, double y, unsigned cmd);
-
-        // Vertex Source Interface
-        void     rewind(unsigned path_id);
-        unsigned vertex(double* x, double* y);
-
-        void shorten(double s) { m_shorten = s; }
-        double shorten() const { return m_shorten; }
-
-    private:
-        vcgen_vertex_sequence(const vcgen_vertex_sequence&);
-        const vcgen_vertex_sequence& operator = (const vcgen_vertex_sequence&);
-
-        vertex_storage m_src_vertices;
-        unsigned       m_flags;
-        unsigned       m_cur_vertex;
-        double         m_shorten;
-        bool           m_ready;
-    };
-
-
-    //------------------------------------------------------------------------
-    inline void vcgen_vertex_sequence::remove_all()
-    {
-        m_ready = false;
-        m_src_vertices.remove_all();
-        m_cur_vertex = 0;
-        m_flags = 0;
-    }
-
-    //------------------------------------------------------------------------
-    inline void vcgen_vertex_sequence::add_vertex(double x, double y, unsigned cmd)
-    {
-        m_ready = false;
-        if(is_move_to(cmd))
-        {
-            m_src_vertices.modify_last(vertex_dist_cmd(x, y, cmd));
-        }
-        else
-        {
-            if(is_vertex(cmd))
-            {
-                m_src_vertices.add(vertex_dist_cmd(x, y, cmd));
-            }
-            else
-            {
-                m_flags = cmd & path_flags_mask;
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    inline void vcgen_vertex_sequence::rewind(unsigned) 
-    { 
-        if(!m_ready)
-        {
-            m_src_vertices.close(is_closed(m_flags));
-            shorten_path(m_src_vertices, m_shorten, get_close_flag(m_flags));
-        }
-        m_ready = true;
-        m_cur_vertex = 0; 
-    }
-
-    //------------------------------------------------------------------------
-    inline unsigned vcgen_vertex_sequence::vertex(double* x, double* y)
-    {
-        if(!m_ready)
-        {
-            rewind(0);
-        }
-
-        if(m_cur_vertex == m_src_vertices.size())
-        {
-            ++m_cur_vertex;
-            return path_cmd_end_poly | m_flags;
-        }
-
-        if(m_cur_vertex > m_src_vertices.size())
-        {
-            return path_cmd_stop;
-        }
-
-        vertex_type& v = m_src_vertices[m_cur_vertex++];
-        *x = v.x;
-        *y = v.y;
-        return v.cmd;
-    }
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vertex_sequence.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vertex_sequence.h
--- 8.0.1-5/renderers/agg/include/agg_vertex_sequence.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vertex_sequence.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,171 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// vertex_sequence container and vertex_dist struct
-//
-//----------------------------------------------------------------------------
-#ifndef AGG_VERTEX_SEQUENCE_INCLUDED
-#define AGG_VERTEX_SEQUENCE_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_array.h"
-#include "agg_math.h"
-
-namespace mapserver
-{
-
-    //----------------------------------------------------------vertex_sequence
-    // Modified mapserver::pod_bvector. The data is interpreted as a sequence 
-    // of vertices. It means that the type T must expose:
-    //
-    // bool T::operator() (const T& val)
-    // 
-    // that is called every time new vertex is being added. The main purpose
-    // of this operator is the possibility to calculate some values during 
-    // adding and to return true if the vertex fits some criteria or false if
-    // it doesn't. In the last case the new vertex is not added. 
-    // 
-    // The simple example is filtering coinciding vertices with calculation 
-    // of the distance between the current and previous ones:
-    //
-    //    struct vertex_dist
-    //    {
-    //        double   x;
-    //        double   y;
-    //        double   dist;
-    //
-    //        vertex_dist() {}
-    //        vertex_dist(double x_, double y_) :
-    //            x(x_),
-    //            y(y_),
-    //            dist(0.0)
-    //        {
-    //        }
-    //
-    //        bool operator () (const vertex_dist& val)
-    //        {
-    //            return (dist = calc_distance(x, y, val.x, val.y)) > EPSILON;
-    //        }
-    //    };
-    //
-    // Function close() calls this operator and removes the last vertex if 
-    // necessary.
-    //------------------------------------------------------------------------
-    template<class T, unsigned S=6> 
-    class vertex_sequence : public pod_bvector<T, S>
-    {
-    public:
-        typedef pod_bvector<T, S> base_type;
-
-        void add(const T& val);
-        void modify_last(const T& val);
-        void close(bool remove_flag);
-    };
-
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void vertex_sequence<T, S>::add(const T& val)
-    {
-        if(base_type::size() > 1)
-        {
-            if(!(*this)[base_type::size() - 2]((*this)[base_type::size() - 1])) 
-            {
-                base_type::remove_last();
-            }
-        }
-        base_type::add(val);
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void vertex_sequence<T, S>::modify_last(const T& val)
-    {
-        base_type::remove_last();
-        add(val);
-    }
-
-
-
-    //------------------------------------------------------------------------
-    template<class T, unsigned S> 
-    void vertex_sequence<T, S>::close(bool closed)
-    {
-        while(base_type::size() > 1)
-        {
-            if((*this)[base_type::size() - 2]((*this)[base_type::size() - 1])) break;
-            T t = (*this)[base_type::size() - 1];
-            base_type::remove_last();
-            modify_last(t);
-        }
-
-        if(closed)
-        {
-            while(base_type::size() > 1)
-            {
-                if((*this)[base_type::size() - 1]((*this)[0])) break;
-                base_type::remove_last();
-            }
-        }
-    }
-
-
-    //-------------------------------------------------------------vertex_dist
-    // Vertex (x, y) with the distance to the next one. The last vertex has 
-    // distance between the last and the first points if the polygon is closed
-    // and 0.0 if it's a polyline.
-    struct vertex_dist
-    {
-        double   x = 0;
-        double   y = 0;
-        double   dist = 0;
-
-        vertex_dist() = default;
-        vertex_dist(double x_, double y_) :
-            x(x_),
-            y(y_)
-        {
-        }
-
-        bool operator () (const vertex_dist& val)
-        {
-            bool ret = (dist = calc_distance(x, y, val.x, val.y)) > vertex_dist_epsilon;
-            if(!ret) dist = 1.0 / vertex_dist_epsilon;
-            return ret;
-        }
-    };
-
-
-
-    //--------------------------------------------------------vertex_dist_cmd
-    // Save as the above but with additional "command" value
-    struct vertex_dist_cmd : public vertex_dist
-    {
-        unsigned cmd;
-
-        vertex_dist_cmd() {}
-        vertex_dist_cmd(double x_, double y_, unsigned cmd_) :
-            vertex_dist(x_, y_),
-            cmd(cmd_)
-        {
-        }
-    };
-
-
-}
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vpgen_clip_polygon.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vpgen_clip_polygon.h
--- 8.0.1-5/renderers/agg/include/agg_vpgen_clip_polygon.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vpgen_clip_polygon.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VPGEN_CLIP_POLYGON_INCLUDED
-#define AGG_VPGEN_CLIP_POLYGON_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //======================================================vpgen_clip_polygon
-    //
-    // See Implementation agg_vpgen_clip_polygon.cpp
-    //
-    class vpgen_clip_polygon
-    {
-    public:
-        vpgen_clip_polygon() : 
-            m_clip_box(0, 0, 1, 1),
-            m_x1(0),
-            m_y1(0),
-            m_clip_flags(0),
-            m_num_vertices(0),
-            m_vertex(0),
-            m_cmd(path_cmd_move_to)
-        {
-        }
-
-        void clip_box(double x1, double y1, double x2, double y2)
-        {
-            m_clip_box.x1 = x1;
-            m_clip_box.y1 = y1;
-            m_clip_box.x2 = x2;
-            m_clip_box.y2 = y2;
-            m_clip_box.normalize();
-        }
-
-
-        double x1() const { return m_clip_box.x1; }
-        double y1() const { return m_clip_box.y1; }
-        double x2() const { return m_clip_box.x2; }
-        double y2() const { return m_clip_box.y2; }
-
-        static bool auto_close()   { return true;  }
-        static bool auto_unclose() { return false; }
-
-        void     reset();
-        void     move_to(double x, double y);
-        void     line_to(double x, double y);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        unsigned clipping_flags(double x, double y);
-
-    private:
-        rect_d        m_clip_box;
-        double        m_x1;
-        double        m_y1;
-        unsigned      m_clip_flags;
-        double        m_x[4];
-        double        m_y[4];
-        unsigned      m_num_vertices;
-        unsigned      m_vertex;
-        unsigned      m_cmd;
-    };
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vpgen_clip_polyline.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vpgen_clip_polyline.h
--- 8.0.1-5/renderers/agg/include/agg_vpgen_clip_polyline.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vpgen_clip_polyline.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,78 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VPGEN_CLIP_POLYLINE_INCLUDED
-#define AGG_VPGEN_CLIP_POLYLINE_INCLUDED
-
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //======================================================vpgen_clip_polyline
-    //
-    // See Implementation agg_vpgen_clip_polyline.cpp
-    //
-    class vpgen_clip_polyline
-    {
-    public:
-        vpgen_clip_polyline() : 
-            m_clip_box(0, 0, 1, 1),
-            m_x1(0),
-            m_y1(0),
-            m_num_vertices(0),
-            m_vertex(0),
-            m_move_to(false)
-        {
-        }
-
-        void clip_box(double x1, double y1, double x2, double y2)
-        {
-            m_clip_box.x1 = x1;
-            m_clip_box.y1 = y1;
-            m_clip_box.x2 = x2;
-            m_clip_box.y2 = y2;
-            m_clip_box.normalize();
-        }
-
-        double x1() const { return m_clip_box.x1; }
-        double y1() const { return m_clip_box.y1; }
-        double x2() const { return m_clip_box.x2; }
-        double y2() const { return m_clip_box.y2; }
-
-        static bool auto_close()   { return false; }
-        static bool auto_unclose() { return true; }
-
-        void     reset();
-        void     move_to(double x, double y);
-        void     line_to(double x, double y);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        rect_d        m_clip_box;
-        double        m_x1;
-        double        m_y1;
-        double        m_x[2];
-        double        m_y[2];
-        unsigned      m_cmd[2];
-        unsigned      m_num_vertices;
-        unsigned      m_vertex;
-        bool          m_move_to;
-    };
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/agg_vpgen_segmentator.h 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vpgen_segmentator.h
--- 8.0.1-5/renderers/agg/include/agg_vpgen_segmentator.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/agg_vpgen_segmentator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,61 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#ifndef AGG_VPGEN_SEGMENTATOR_INCLUDED
-#define AGG_VPGEN_SEGMENTATOR_INCLUDED
-
-#include <math.h>
-#include "agg_basics.h"
-
-namespace mapserver
-{
-
-    //=======================================================vpgen_segmentator
-    // 
-    // See Implementation agg_vpgen_segmentator.cpp
-    //
-    class vpgen_segmentator
-    {
-    public:
-        vpgen_segmentator() : m_approximation_scale(1.0) {}
-
-        void approximation_scale(double s) { m_approximation_scale = s;     }
-        double approximation_scale() const { return m_approximation_scale;  }
-
-        static bool auto_close()   { return false; }
-        static bool auto_unclose() { return false; }
-
-        void reset() { m_cmd = path_cmd_stop; }
-        void move_to(double x, double y);
-        void line_to(double x, double y);
-        unsigned vertex(double* x, double* y);
-
-    private:
-        double   m_approximation_scale;
-        double   m_x1;
-        double   m_y1;
-        double   m_dx;
-        double   m_dy;
-        double   m_dl;
-        double   m_ddl;
-        unsigned m_cmd;
-    };
-
-
-
-}
-
-#endif
-
diff -pruN 8.0.1-5/renderers/agg/include/clipper.hpp 8.2.0~beta1-1~exp1/renderers/agg/include/clipper.hpp
--- 8.0.1-5/renderers/agg/include/clipper.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/clipper.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,302 +0,0 @@
-/*******************************************************************************
-*                                                                              *
-* Author    :  Angus Johnson                                                   *
-* Version   :  4.6.3                                                           *
-* Date      :  11 November 2011                                                *
-* Website   :  http://www.angusj.com                                           *
-* Copyright :  Angus Johnson 2010-2011                                         *
-*                                                                              *
-* License:                                                                     *
-* Use, modification & distribution is subject to Boost Software License Ver 1. *
-* http://www.boost.org/LICENSE_1_0.txt                                         *
-*                                                                              *
-* Attributions:                                                                *
-* The code in this library is an extension of Bala Vatti's clipping algorithm: *
-* "A generic solution to polygon clipping"                                     *
-* Communications of the ACM, Vol 35, Issue 7 (July 1992) pp 56-63.             *
-* http://portal.acm.org/citation.cfm?id=129906                                 *
-*                                                                              *
-* Computer graphics and geometric modeling: implementation and algorithms      *
-* By Max K. Agoston                                                            *
-* Springer; 1 edition (January 4, 2005)                                        *
-* http://books.google.com/books?q=vatti+clipping+agoston                       *
-*                                                                              *
-* See also:                                                                    *
-* "Polygon Offsetting by Computing Winding Numbers"                            *
-* Paper no. DETC2005-85513 pp. 565-575                                         *
-* ASME 2005 International Design Engineering Technical Conferences             *
-* and Computers and Information in Engineering Conference (IDETC/CIE2005)      *
-* September 24-28, 2005 , Long Beach, California, USA                          *
-* http://www.me.berkeley.edu/~mcmains/pubs/DAC05OffsetPolygon.pdf              *
-*                                                                              *
-*******************************************************************************/
-
-#ifndef clipper_hpp
-#define clipper_hpp
-
-#include <vector>
-#include <stdexcept>
-#include <cstring>
-#include <cstdlib>
-#include <ostream>
-
-namespace ClipperLib {
-
-enum ClipType { ctIntersection, ctUnion, ctDifference, ctXor };
-enum PolyType { ptSubject, ptClip };
-//By far the most widely used winding rules for polygon filling are
-//EvenOdd & NonZero (GDI, GDI+, XLib, OpenGL, Cairo, AGG, Quartz, SVG, Gr32)
-//Others rules include Positive, Negative and ABS_GTR_EQ_TWO (only in OpenGL)
-//see http://glprogramming.com/red/chapter11.html
-enum PolyFillType { pftEvenOdd, pftNonZero, pftPositive, pftNegative };
-
-typedef signed long long long64;
-typedef unsigned long long ulong64;
-
-struct IntPoint {
-public:
-  long64 X;
-  long64 Y;
-  IntPoint(long64 x = 0, long64 y = 0): X(x), Y(y) {};
-  friend std::ostream& operator <<(std::ostream &s, IntPoint &p);
-};
-
-typedef std::vector< IntPoint > Polygon;
-typedef std::vector< Polygon > Polygons;
-
-std::ostream& operator <<(std::ostream &s, Polygon &p);
-std::ostream& operator <<(std::ostream &s, Polygons &p);
-
-struct ExPolygon {
-  Polygon  outer;
-  Polygons holes;
-};
-typedef std::vector< ExPolygon > ExPolygons;
-
-enum JoinType { jtSquare, jtMiter, jtRound };
-
-bool Orientation(const Polygon &poly);
-double Area(const Polygon &poly);
-void OffsetPolygons(const Polygons &in_polys, Polygons &out_polys,
-  double delta, JoinType jointype = jtSquare, double MiterLimit = 2);
-
-void ReversePoints(Polygon& p);
-void ReversePoints(Polygons& p);
-
-//used internally ...
-enum EdgeSide { esLeft, esRight };
-enum IntersectProtects { ipNone = 0, ipLeft = 1, ipRight = 2, ipBoth = 3 };
-
-struct TEdge {
-  long64 xbot;
-  long64 ybot;
-  long64 xcurr;
-  long64 ycurr;
-  long64 xtop;
-  long64 ytop;
-  double dx;
-  long64 tmpX;
-  PolyType polyType;
-  EdgeSide side;
-  int windDelta; //1 or -1 depending on winding direction
-  int windCnt;
-  int windCnt2; //winding count of the opposite polytype
-  int outIdx;
-  TEdge *next;
-  TEdge *prev;
-  TEdge *nextInLML;
-  TEdge *nextInAEL;
-  TEdge *prevInAEL;
-  TEdge *nextInSEL;
-  TEdge *prevInSEL;
-};
-
-struct IntersectNode {
-  TEdge          *edge1;
-  TEdge          *edge2;
-  IntPoint        pt;
-  IntersectNode  *next;
-};
-
-struct LocalMinima {
-  long64        Y;
-  TEdge        *leftBound;
-  TEdge        *rightBound;
-  LocalMinima  *next;
-};
-
-struct Scanbeam {
-  long64    Y;
-  Scanbeam *next;
-};
-
-struct OutPt; //forward declaration
-
-struct OutRec {
-  int     idx;
-  bool    isHole;
-  OutRec *FirstLeft;
-  OutRec *AppendLink;
-  OutPt  *pts;
-  OutPt  *bottomPt;
-  TEdge  *bottomE1;
-  TEdge  *bottomE2;
-};
-
-struct OutPt {
-  int     idx;
-  IntPoint pt;
-  OutPt   *next;
-  OutPt   *prev;
-};
-
-struct JoinRec {
-  IntPoint  pt1a;
-  IntPoint  pt1b;
-  int       poly1Idx;
-  IntPoint  pt2a;
-  IntPoint  pt2b;
-  int       poly2Idx;
-};
-
-struct HorzJoinRec {
-  TEdge    *edge;
-  int       savedIdx;
-};
-
-struct IntRect { long64 left; long64 top; long64 right; long64 bottom; };
-
-typedef std::vector < OutRec* > PolyOutList;
-typedef std::vector < TEdge* > EdgeList;
-typedef std::vector < JoinRec* > JoinList;
-typedef std::vector < HorzJoinRec* > HorzJoinList;
-
-//ClipperBase is the ancestor to the Clipper class. It should not be
-//instantiated directly. This class simply abstracts the conversion of sets of
-//polygon coordinates into edge objects that are stored in a LocalMinima list.
-class ClipperBase
-{
-public:
-  ClipperBase();
-  virtual ~ClipperBase();
-  bool AddPolygon(const Polygon &pg, PolyType polyType);
-  bool AddPolygons( const Polygons &ppg, PolyType polyType);
-  virtual void Clear();
-  IntRect GetBounds();
-protected:
-  void DisposeLocalMinimaList();
-  TEdge* AddBoundsToLML(TEdge *e);
-  void PopLocalMinima();
-  virtual void Reset();
-  void InsertLocalMinima(LocalMinima *newLm);
-  LocalMinima      *m_CurrentLM;
-  LocalMinima      *m_MinimaList;
-  bool              m_UseFullRange;
-  EdgeList          m_edges;
-};
-
-class Clipper : public virtual ClipperBase
-{
-public:
-  Clipper();
-  ~Clipper();
-  bool Execute(ClipType clipType,
-  Polygons &solution,
-  PolyFillType subjFillType = pftEvenOdd,
-  PolyFillType clipFillType = pftEvenOdd);
-  bool Execute(ClipType clipType,
-  ExPolygons &solution,
-  PolyFillType subjFillType = pftEvenOdd,
-  PolyFillType clipFillType = pftEvenOdd);
-  void Clear();
-  bool ReverseSolution() {return m_ReverseOutput;};
-  void ReverseSolution(bool value) {m_ReverseOutput = value;};
-protected:
-  void Reset();
-  virtual bool ExecuteInternal(bool fixHoleLinkages);
-private:
-  PolyOutList       m_PolyOuts;
-  JoinList          m_Joins;
-  HorzJoinList      m_HorizJoins;
-  ClipType          m_ClipType = ctIntersection;
-  Scanbeam         *m_Scanbeam;
-  TEdge           *m_ActiveEdges;
-  TEdge           *m_SortedEdges;
-  IntersectNode    *m_IntersectNodes;
-  bool              m_ExecuteLocked;
-  PolyFillType      m_ClipFillType = pftEvenOdd;
-  PolyFillType      m_SubjFillType = pftEvenOdd;
-  bool              m_ReverseOutput;
-  void DisposeScanbeamList();
-  void SetWindingCount(TEdge& edge);
-  bool IsEvenOddFillType(const TEdge& edge) const;
-  bool IsEvenOddAltFillType(const TEdge& edge) const;
-  void InsertScanbeam(const long64 Y);
-  long64 PopScanbeam();
-  void InsertLocalMinimaIntoAEL(const long64 botY);
-  void InsertEdgeIntoAEL(TEdge *edge);
-  void AddEdgeToSEL(TEdge *edge);
-  void CopyAELToSEL();
-  void DeleteFromSEL(TEdge *e);
-  void DeleteFromAEL(TEdge *e);
-  void UpdateEdgeIntoAEL(TEdge *&e);
-  void SwapPositionsInSEL(TEdge *edge1, TEdge *edge2);
-  bool IsContributing(const TEdge& edge) const;
-  bool IsTopHorz(const long64 XPos);
-  void SwapPositionsInAEL(TEdge *edge1, TEdge *edge2);
-  void DoMaxima(TEdge *e, long64 topY);
-  void ProcessHorizontals();
-  void ProcessHorizontal(TEdge *horzEdge);
-  void AddLocalMaxPoly(TEdge *e1, TEdge *e2, const IntPoint &pt);
-  void AddLocalMinPoly(TEdge *e1, TEdge *e2, const IntPoint &pt);
-  void AppendPolygon(TEdge *e1, TEdge *e2);
-  void DoEdge1(TEdge *edge1, TEdge *edge2, const IntPoint &pt);
-  void DoEdge2(TEdge *edge1, TEdge *edge2, const IntPoint &pt);
-  void DoBothEdges(TEdge *edge1, TEdge *edge2, const IntPoint &pt);
-  void IntersectEdges(TEdge *e1, TEdge *e2,
-    const IntPoint &pt, IntersectProtects protects);
-  OutRec* CreateOutRec();
-  void AddOutPt(TEdge *e, TEdge *altE, const IntPoint &pt);
-  void DisposeAllPolyPts();
-  void DisposeOutRec(PolyOutList::size_type index, bool ignorePts = false);
-  bool ProcessIntersections(const long64 botY, const long64 topY);
-  void AddIntersectNode(TEdge *e1, TEdge *e2, const IntPoint &pt);
-  void BuildIntersectList(const long64 botY, const long64 topY);
-  void ProcessIntersectList();
-  void ProcessEdgesAtTopOfScanbeam(const long64 topY);
-  void BuildResult(Polygons& polys);
-  void BuildResultEx(ExPolygons& polys);
-  void SetHoleState(TEdge *e, OutRec *OutRec);
-  void DisposeIntersectNodes();
-  bool FixupIntersections();
-  void FixupOutPolygon(OutRec &outRec);
-  bool IsHole(TEdge *e);
-  void FixHoleLinkage(OutRec *outRec);
-  void CheckHoleLinkages1(OutRec *outRec1, OutRec *outRec2);
-  void CheckHoleLinkages2(OutRec *outRec1, OutRec *outRec2);
-  void AddJoin(TEdge *e1, TEdge *e2, int e1OutIdx = -1, int e2OutIdx = -1);
-  void ClearJoins();
-  void AddHorzJoin(TEdge *e, int idx);
-  void ClearHorzJoins();
-  void JoinCommonEdges(bool fixHoleLinkages);
-};
-
-//------------------------------------------------------------------------------
-//------------------------------------------------------------------------------
-
-class clipperException : public std::exception
-{
-  public:
-    clipperException(const char* description): m_descr(description) {}
-    virtual ~clipperException() throw() {}
-    virtual const char* what() const throw() {return m_descr.c_str();}
-  private:
-    std::string m_descr;
-};
-//------------------------------------------------------------------------------
-
-} //ClipperLib namespace
-
-#endif //clipper_hpp
-
-
diff -pruN 8.0.1-5/renderers/agg/include/util/Makefile.am 8.2.0~beta1-1~exp1/renderers/agg/include/util/Makefile.am
--- 8.0.1-5/renderers/agg/include/util/Makefile.am	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/util/Makefile.am	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-myincludedir = $(includedir)/agg2/util
-myinclude_HEADERS = agg_color_conv.h agg_color_conv_rgb8.h agg_color_conv_rgb16.h
diff -pruN 8.0.1-5/renderers/agg/include/util/agg_color_conv.h 8.2.0~beta1-1~exp1/renderers/agg/include/util/agg_color_conv.h
--- 8.0.1-5/renderers/agg/include/util/agg_color_conv.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/util/agg_color_conv.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,84 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Conversion from one colorspace/pixel format to another
-//
-//----------------------------------------------------------------------------
-
-#ifndef AGG_COLOR_CONV_INCLUDED
-#define AGG_COLOR_CONV_INCLUDED
-
-#include <string.h>
-#include "agg_basics.h"
-#include "agg_rendering_buffer.h"
-
-
-
-
-namespace mapserver
-{
-
-    //--------------------------------------------------------------color_conv
-    template<class RenBuf, class CopyRow> 
-    void color_conv(RenBuf* dst, const RenBuf* src, CopyRow copy_row_functor)
-    {
-        unsigned width = src->width();
-        unsigned height = src->height();
-
-        if(dst->width()  < width)  width  = dst->width();
-        if(dst->height() < height) height = dst->height();
-
-        if(width)
-        {
-            unsigned y;
-            for(y = 0; y < height; y++)
-            {
-                copy_row_functor(dst->row_ptr(0, y, width), 
-                                 src->row_ptr(y), 
-                                 width);
-            }
-        }
-    }
-
-
-    //---------------------------------------------------------color_conv_row
-    template<class CopyRow> 
-    void color_conv_row(int8u* dst, 
-                        const int8u* src,
-                        unsigned width,
-                        CopyRow copy_row_functor)
-    {
-        copy_row_functor(dst, src, width);
-    }
-
-
-    //---------------------------------------------------------color_conv_same
-    template<int BPP> class color_conv_same
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            memmove(dst, src, width*BPP);
-        }
-    };
-
-
-}
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/util/agg_color_conv_rgb16.h 8.2.0~beta1-1~exp1/renderers/agg/include/util/agg_color_conv_rgb16.h
--- 8.0.1-5/renderers/agg/include/util/agg_color_conv_rgb16.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/util/agg_color_conv_rgb16.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,285 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// This part of the library has been sponsored by 
-// Liberty Technology Systems, Inc., visit http://lib-sys.com
-//
-// Liberty Technology Systems, Inc. is the provider of
-// PostScript and PDF technology for software developers.
-// 
-//----------------------------------------------------------------------------
-//
-// A set of functors used with color_conv(). See file agg_color_conv.h
-// These functors can convert images with up to 8 bits per component.
-// Use convertors in the following way:
-//
-// mapserver::color_conv(dst, src, mapserver::color_conv_XXXX_to_YYYY());
-//----------------------------------------------------------------------------
-
-#ifndef AGG_COLOR_CONV_RGB16_INCLUDED
-#define AGG_COLOR_CONV_RGB16_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_conv.h"
-
-namespace mapserver
-{
-
-    //-------------------------------------------------color_conv_gray16_to_gray8
-    class color_conv_gray16_to_gray8
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            int16u* s = (int16u*)src;
-            do
-            {
-                *dst++ = *s++ >> 8;
-            }
-            while(--width);
-        }
-    };
-
-
-    //-----------------------------------------------------color_conv_rgb24_rgb48
-    template<int I1, int I3> class color_conv_rgb24_rgb48
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            int16u* d = (int16u*)dst;
-            do
-            {
-                *d++ = (src[I1] << 8) | src[I1];
-                *d++ = (src[1]  << 8) | src[1] ;
-                *d++ = (src[I3] << 8) | src[I3];
-                src += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_rgb24_rgb48<0,2> color_conv_rgb24_to_rgb48;
-    typedef color_conv_rgb24_rgb48<0,2> color_conv_bgr24_to_bgr48;
-    typedef color_conv_rgb24_rgb48<2,0> color_conv_rgb24_to_bgr48;
-    typedef color_conv_rgb24_rgb48<2,0> color_conv_bgr24_to_rgb48;
-
-
-    //-----------------------------------------------------color_conv_rgb24_rgb48
-    template<int I1, int I3> class color_conv_rgb48_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            const int16u* s = (const int16u*)src;
-            do
-            {
-                *dst++ = s[I1] >> 8;
-                *dst++ = s[1]  >> 8;
-                *dst++ = s[I3] >> 8;
-                s += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_rgb48_rgb24<0,2> color_conv_rgb48_to_rgb24;
-    typedef color_conv_rgb48_rgb24<0,2> color_conv_bgr48_to_bgr24;
-    typedef color_conv_rgb48_rgb24<2,0> color_conv_rgb48_to_bgr24;
-    typedef color_conv_rgb48_rgb24<2,0> color_conv_bgr48_to_rgb24;
-
-
-    //----------------------------------------------color_conv_rgbAAA_rgb24
-    template<int R, int B> class color_conv_rgbAAA_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                int32u rgb = *(int32u*)src;
-                dst[R] = int8u(rgb >> 22);
-                dst[1] = int8u(rgb >> 12);
-                dst[B] = int8u(rgb >> 2);
-                src += 4;
-                dst += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_rgbAAA_rgb24<0,2> color_conv_rgbAAA_to_rgb24;
-    typedef color_conv_rgbAAA_rgb24<2,0> color_conv_rgbAAA_to_bgr24;
-    typedef color_conv_rgbAAA_rgb24<2,0> color_conv_bgrAAA_to_rgb24;
-    typedef color_conv_rgbAAA_rgb24<0,2> color_conv_bgrAAA_to_bgr24;
-
-
-    //----------------------------------------------color_conv_rgbBBA_rgb24
-    template<int R, int B> class color_conv_rgbBBA_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                int32u rgb = *(int32u*)src;
-                dst[R] = int8u(rgb >> 24);
-                dst[1] = int8u(rgb >> 13);
-                dst[B] = int8u(rgb >> 2);
-                src += 4;
-                dst += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_rgbBBA_rgb24<0,2> color_conv_rgbBBA_to_rgb24;
-    typedef color_conv_rgbBBA_rgb24<2,0> color_conv_rgbBBA_to_bgr24;
-
-
-    //----------------------------------------------color_conv_bgrABB_rgb24
-    template<int B, int R> class color_conv_bgrABB_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                int32u bgr = *(int32u*)src;
-                dst[R] = int8u(bgr >> 3);
-                dst[1] = int8u(bgr >> 14);
-                dst[B] = int8u(bgr >> 24);
-                src += 4;
-                dst += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_bgrABB_rgb24<2,0> color_conv_bgrABB_to_rgb24;
-    typedef color_conv_bgrABB_rgb24<0,2> color_conv_bgrABB_to_bgr24;
-
-
-    //-------------------------------------------------color_conv_rgba64_rgba32
-    template<int I1, int I2, int I3, int I4> class color_conv_rgba64_rgba32
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *dst++ = int8u(((int16u*)src)[I1] >> 8);
-                *dst++ = int8u(((int16u*)src)[I2] >> 8);
-                *dst++ = int8u(((int16u*)src)[I3] >> 8);
-                *dst++ = int8u(((int16u*)src)[I4] >> 8); 
-                src += 8;
-            }
-            while(--width);
-        }
-    };
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_rgba64_to_rgba32; //----color_conv_rgba64_to_rgba32
-    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_argb64_to_argb32; //----color_conv_argb64_to_argb32
-    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_bgra64_to_bgra32; //----color_conv_bgra64_to_bgra32
-    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_abgr64_to_abgr32; //----color_conv_abgr64_to_abgr32
-    typedef color_conv_rgba64_rgba32<0,3,2,1> color_conv_argb64_to_abgr32; //----color_conv_argb64_to_abgr32
-    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_argb64_to_bgra32; //----color_conv_argb64_to_bgra32
-    typedef color_conv_rgba64_rgba32<1,2,3,0> color_conv_argb64_to_rgba32; //----color_conv_argb64_to_rgba32
-    typedef color_conv_rgba64_rgba32<3,0,1,2> color_conv_bgra64_to_abgr32; //----color_conv_bgra64_to_abgr32
-    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_bgra64_to_argb32; //----color_conv_bgra64_to_argb32
-    typedef color_conv_rgba64_rgba32<2,1,0,3> color_conv_bgra64_to_rgba32; //----color_conv_bgra64_to_rgba32
-    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_rgba64_to_abgr32; //----color_conv_rgba64_to_abgr32
-    typedef color_conv_rgba64_rgba32<3,0,1,2> color_conv_rgba64_to_argb32; //----color_conv_rgba64_to_argb32
-    typedef color_conv_rgba64_rgba32<2,1,0,3> color_conv_rgba64_to_bgra32; //----color_conv_rgba64_to_bgra32
-    typedef color_conv_rgba64_rgba32<0,3,2,1> color_conv_abgr64_to_argb32; //----color_conv_abgr64_to_argb32
-    typedef color_conv_rgba64_rgba32<1,2,3,0> color_conv_abgr64_to_bgra32; //----color_conv_abgr64_to_bgra32
-    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_abgr64_to_rgba32; //----color_conv_abgr64_to_rgba32
-
-
-
-    //--------------------------------------------color_conv_rgb24_rgba64
-    template<int I1, int I2, int I3, int A> class color_conv_rgb24_rgba64
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            int16u* d = (int16u*)dst;
-            do
-            {
-                d[I1] = (src[0] << 8) | src[0];
-                d[I2] = (src[1] << 8) | src[1];
-                d[I3] = (src[2] << 8) | src[2];
-                d[A]  = 65535; 
-                d   += 4;
-                src += 3;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb24_rgba64<1,2,3,0> color_conv_rgb24_to_argb64; //----color_conv_rgb24_to_argb64
-    typedef color_conv_rgb24_rgba64<3,2,1,0> color_conv_rgb24_to_abgr64; //----color_conv_rgb24_to_abgr64
-    typedef color_conv_rgb24_rgba64<2,1,0,3> color_conv_rgb24_to_bgra64; //----color_conv_rgb24_to_bgra64
-    typedef color_conv_rgb24_rgba64<0,1,2,3> color_conv_rgb24_to_rgba64; //----color_conv_rgb24_to_rgba64
-    typedef color_conv_rgb24_rgba64<3,2,1,0> color_conv_bgr24_to_argb64; //----color_conv_bgr24_to_argb64
-    typedef color_conv_rgb24_rgba64<1,2,3,0> color_conv_bgr24_to_abgr64; //----color_conv_bgr24_to_abgr64
-    typedef color_conv_rgb24_rgba64<0,1,2,3> color_conv_bgr24_to_bgra64; //----color_conv_bgr24_to_bgra64
-    typedef color_conv_rgb24_rgba64<2,1,0,3> color_conv_bgr24_to_rgba64; //----color_conv_bgr24_to_rgba64
-
-
-    template<int R, int B> class color_conv_rgb24_gray16
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            int16u* d = (int16u*)dst;
-            do
-            {
-                *d++ = src[R]*77 + src[1]*150 + src[B]*29;
-                src += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_rgb24_gray16<0,2> color_conv_rgb24_to_gray16;
-    typedef color_conv_rgb24_gray16<2,0> color_conv_bgr24_to_gray16;
-
-
-}
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/include/util/agg_color_conv_rgb8.h 8.2.0~beta1-1~exp1/renderers/agg/include/util/agg_color_conv_rgb8.h
--- 8.0.1-5/renderers/agg/include/util/agg_color_conv_rgb8.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/include/util/agg_color_conv_rgb8.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,469 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// A set of functors used with color_conv(). See file agg_color_conv.h
-// These functors can convert images with up to 8 bits per component.
-// Use convertors in the following way:
-//
-// mapserver::color_conv(dst, src, mapserver::color_conv_XXXX_to_YYYY());
-// whare XXXX and YYYY can be any of:
-//  rgb24
-//  bgr24
-//  rgba32
-//  abgr32
-//  argb32
-//  bgra32
-//  rgb555
-//  rgb565
-//----------------------------------------------------------------------------
-
-#ifndef AGG_COLOR_CONV_RGB8_INCLUDED
-#define AGG_COLOR_CONV_RGB8_INCLUDED
-
-#include "agg_basics.h"
-#include "agg_color_conv.h"
-
-namespace mapserver
-{
-
-    //-----------------------------------------------------color_conv_rgb24
-    class color_conv_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *dst++ = src[2];
-                *dst++ = src[1];
-                *dst++ = src[0];
-                src += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_rgb24 color_conv_rgb24_to_bgr24;
-    typedef color_conv_rgb24 color_conv_bgr24_to_rgb24;
-
-    typedef color_conv_same<3> color_conv_bgr24_to_bgr24;
-    typedef color_conv_same<3> color_conv_rgb24_to_rgb24;
-
-
-
-    //------------------------------------------------------color_conv_rgba32
-    template<int I1, int I2, int I3, int I4> class color_conv_rgba32
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *dst++ = src[I1];
-                *dst++ = src[I2];
-                *dst++ = src[I3];
-                *dst++ = src[I4]; 
-                src += 4;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgba32<0,3,2,1> color_conv_argb32_to_abgr32; //----color_conv_argb32_to_abgr32
-    typedef color_conv_rgba32<3,2,1,0> color_conv_argb32_to_bgra32; //----color_conv_argb32_to_bgra32
-    typedef color_conv_rgba32<1,2,3,0> color_conv_argb32_to_rgba32; //----color_conv_argb32_to_rgba32
-    typedef color_conv_rgba32<3,0,1,2> color_conv_bgra32_to_abgr32; //----color_conv_bgra32_to_abgr32
-    typedef color_conv_rgba32<3,2,1,0> color_conv_bgra32_to_argb32; //----color_conv_bgra32_to_argb32
-    typedef color_conv_rgba32<2,1,0,3> color_conv_bgra32_to_rgba32; //----color_conv_bgra32_to_rgba32
-    typedef color_conv_rgba32<3,2,1,0> color_conv_rgba32_to_abgr32; //----color_conv_rgba32_to_abgr32
-    typedef color_conv_rgba32<3,0,1,2> color_conv_rgba32_to_argb32; //----color_conv_rgba32_to_argb32
-    typedef color_conv_rgba32<2,1,0,3> color_conv_rgba32_to_bgra32; //----color_conv_rgba32_to_bgra32
-    typedef color_conv_rgba32<0,3,2,1> color_conv_abgr32_to_argb32; //----color_conv_abgr32_to_argb32
-    typedef color_conv_rgba32<1,2,3,0> color_conv_abgr32_to_bgra32; //----color_conv_abgr32_to_bgra32
-    typedef color_conv_rgba32<3,2,1,0> color_conv_abgr32_to_rgba32; //----color_conv_abgr32_to_rgba32
-
-    //------------------------------------------------------------------------
-    typedef color_conv_same<4> color_conv_rgba32_to_rgba32; //----color_conv_rgba32_to_rgba32
-    typedef color_conv_same<4> color_conv_argb32_to_argb32; //----color_conv_argb32_to_argb32
-    typedef color_conv_same<4> color_conv_bgra32_to_bgra32; //----color_conv_bgra32_to_bgra32
-    typedef color_conv_same<4> color_conv_abgr32_to_abgr32; //----color_conv_abgr32_to_abgr32
-
-
-    //--------------------------------------------color_conv_rgb24_rgba32
-    template<int I1, int I2, int I3, int A> class color_conv_rgb24_rgba32
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                dst[I1] = *src++;
-                dst[I2] = *src++;
-                dst[I3] = *src++;
-                dst[A]  = 255; 
-                dst += 4;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb24_rgba32<1,2,3,0> color_conv_rgb24_to_argb32; //----color_conv_rgb24_to_argb32
-    typedef color_conv_rgb24_rgba32<3,2,1,0> color_conv_rgb24_to_abgr32; //----color_conv_rgb24_to_abgr32
-    typedef color_conv_rgb24_rgba32<2,1,0,3> color_conv_rgb24_to_bgra32; //----color_conv_rgb24_to_bgra32
-    typedef color_conv_rgb24_rgba32<0,1,2,3> color_conv_rgb24_to_rgba32; //----color_conv_rgb24_to_rgba32
-    typedef color_conv_rgb24_rgba32<3,2,1,0> color_conv_bgr24_to_argb32; //----color_conv_bgr24_to_argb32
-    typedef color_conv_rgb24_rgba32<1,2,3,0> color_conv_bgr24_to_abgr32; //----color_conv_bgr24_to_abgr32
-    typedef color_conv_rgb24_rgba32<0,1,2,3> color_conv_bgr24_to_bgra32; //----color_conv_bgr24_to_bgra32
-    typedef color_conv_rgb24_rgba32<2,1,0,3> color_conv_bgr24_to_rgba32; //----color_conv_bgr24_to_rgba32
-
-    
-
-    //-------------------------------------------------color_conv_rgba32_rgb24
-    template<int I1, int I2, int I3> class color_conv_rgba32_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *dst++ = src[I1];
-                *dst++ = src[I2];
-                *dst++ = src[I3];
-                src += 4;
-            }
-            while(--width);
-        }
-    };
-
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgba32_rgb24<1,2,3> color_conv_argb32_to_rgb24; //----color_conv_argb32_to_rgb24
-    typedef color_conv_rgba32_rgb24<3,2,1> color_conv_abgr32_to_rgb24; //----color_conv_abgr32_to_rgb24
-    typedef color_conv_rgba32_rgb24<2,1,0> color_conv_bgra32_to_rgb24; //----color_conv_bgra32_to_rgb24
-    typedef color_conv_rgba32_rgb24<0,1,2> color_conv_rgba32_to_rgb24; //----color_conv_rgba32_to_rgb24
-    typedef color_conv_rgba32_rgb24<3,2,1> color_conv_argb32_to_bgr24; //----color_conv_argb32_to_bgr24
-    typedef color_conv_rgba32_rgb24<1,2,3> color_conv_abgr32_to_bgr24; //----color_conv_abgr32_to_bgr24
-    typedef color_conv_rgba32_rgb24<0,1,2> color_conv_bgra32_to_bgr24; //----color_conv_bgra32_to_bgr24
-    typedef color_conv_rgba32_rgb24<2,1,0> color_conv_rgba32_to_bgr24; //----color_conv_rgba32_to_bgr24
-
-
-    //------------------------------------------------color_conv_rgb555_rgb24
-    template<int R, int B> class color_conv_rgb555_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                unsigned rgb = *(int16u*)src;
-                dst[R] = (int8u)((rgb >> 7) & 0xF8);
-                dst[1] = (int8u)((rgb >> 2) & 0xF8);
-                dst[B] = (int8u)((rgb << 3) & 0xF8);
-                src += 2;
-                dst += 3;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb555_rgb24<2,0> color_conv_rgb555_to_bgr24; //----color_conv_rgb555_to_bgr24
-    typedef color_conv_rgb555_rgb24<0,2> color_conv_rgb555_to_rgb24; //----color_conv_rgb555_to_rgb24
-
-
-    //-------------------------------------------------color_conv_rgb24_rgb555
-    template<int R, int B> class color_conv_rgb24_rgb555
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 7) & 0x7C00) | 
-                                         ((unsigned(src[1]) << 2) & 0x3E0)  |
-                                         ((unsigned(src[B]) >> 3)));
-                src += 3;
-                dst += 2;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb24_rgb555<2,0> color_conv_bgr24_to_rgb555; //----color_conv_bgr24_to_rgb555
-    typedef color_conv_rgb24_rgb555<0,2> color_conv_rgb24_to_rgb555; //----color_conv_rgb24_to_rgb555
-
-
-    //-------------------------------------------------color_conv_rgb565_rgb24
-    template<int R, int B> class color_conv_rgb565_rgb24
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                unsigned rgb = *(int16u*)src;
-                dst[R] = (rgb >> 8) & 0xF8;
-                dst[1] = (rgb >> 3) & 0xFC;
-                dst[B] = (rgb << 3) & 0xF8;
-                src += 2;
-                dst += 3;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb565_rgb24<2,0> color_conv_rgb565_to_bgr24; //----color_conv_rgb565_to_bgr24
-    typedef color_conv_rgb565_rgb24<0,2> color_conv_rgb565_to_rgb24; //----color_conv_rgb565_to_rgb24
-
-
-    //-------------------------------------------------color_conv_rgb24_rgb565
-    template<int R, int B> class color_conv_rgb24_rgb565
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 8) & 0xF800) | 
-                                         ((unsigned(src[1]) << 3) & 0x7E0)  |
-                                         ((unsigned(src[B]) >> 3)));
-                src += 3;
-                dst += 2;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb24_rgb565<2,0> color_conv_bgr24_to_rgb565; //----color_conv_bgr24_to_rgb565
-    typedef color_conv_rgb24_rgb565<0,2> color_conv_rgb24_to_rgb565; //----color_conv_rgb24_to_rgb565
-
-
-
-    //-------------------------------------------------color_conv_rgb555_rgba32
-    template<int R, int G, int B, int A> class color_conv_rgb555_rgba32
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                int rgb = *(int16*)src;
-                dst[R] = (int8u)((rgb >> 7) & 0xF8);
-                dst[G] = (int8u)((rgb >> 2) & 0xF8);
-                dst[B] = (int8u)((rgb << 3) & 0xF8);
-                dst[A] = (int8u)(rgb >> 15);
-                src += 2;
-                dst += 4;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb555_rgba32<1,2,3,0> color_conv_rgb555_to_argb32; //----color_conv_rgb555_to_argb32
-    typedef color_conv_rgb555_rgba32<3,2,1,0> color_conv_rgb555_to_abgr32; //----color_conv_rgb555_to_abgr32
-    typedef color_conv_rgb555_rgba32<2,1,0,3> color_conv_rgb555_to_bgra32; //----color_conv_rgb555_to_bgra32
-    typedef color_conv_rgb555_rgba32<0,1,2,3> color_conv_rgb555_to_rgba32; //----color_conv_rgb555_to_rgba32
-
-
-    //------------------------------------------------color_conv_rgba32_rgb555
-    template<int R, int G, int B, int A> class color_conv_rgba32_rgb555
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 7) & 0x7C00) | 
-                                         ((unsigned(src[G]) << 2) & 0x3E0)  |
-                                         ((unsigned(src[B]) >> 3)) |
-                                         ((unsigned(src[A]) << 8) & 0x8000));
-                src += 4;
-                dst += 2;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgba32_rgb555<1,2,3,0> color_conv_argb32_to_rgb555; //----color_conv_argb32_to_rgb555
-    typedef color_conv_rgba32_rgb555<3,2,1,0> color_conv_abgr32_to_rgb555; //----color_conv_abgr32_to_rgb555
-    typedef color_conv_rgba32_rgb555<2,1,0,3> color_conv_bgra32_to_rgb555; //----color_conv_bgra32_to_rgb555
-    typedef color_conv_rgba32_rgb555<0,1,2,3> color_conv_rgba32_to_rgb555; //----color_conv_rgba32_to_rgb555
-
-
-
-    //------------------------------------------------color_conv_rgb565_rgba32
-    template<int R, int G, int B, int A> class color_conv_rgb565_rgba32
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                int rgb = *(int16*)src;
-                dst[R] = (rgb >> 8) & 0xF8;
-                dst[G] = (rgb >> 3) & 0xFC;
-                dst[B] = (rgb << 3) & 0xF8;
-                dst[A] = 255;
-                src += 2;
-                dst += 4;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgb565_rgba32<1,2,3,0> color_conv_rgb565_to_argb32; //----color_conv_rgb565_to_argb32
-    typedef color_conv_rgb565_rgba32<3,2,1,0> color_conv_rgb565_to_abgr32; //----color_conv_rgb565_to_abgr32
-    typedef color_conv_rgb565_rgba32<2,1,0,3> color_conv_rgb565_to_bgra32; //----color_conv_rgb565_to_bgra32
-    typedef color_conv_rgb565_rgba32<0,1,2,3> color_conv_rgb565_to_rgba32; //----color_conv_rgb565_to_rgba32
-
-
-    //------------------------------------------------color_conv_rgba32_rgb565
-    template<int R, int G, int B> class color_conv_rgba32_rgb565
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 8) & 0xF800) | 
-                                         ((unsigned(src[G]) << 3) & 0x7E0)  |
-                                         ((unsigned(src[B]) >> 3)));
-                src += 4;
-                dst += 2;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_rgba32_rgb565<1,2,3> color_conv_argb32_to_rgb565; //----color_conv_argb32_to_rgb565
-    typedef color_conv_rgba32_rgb565<3,2,1> color_conv_abgr32_to_rgb565; //----color_conv_abgr32_to_rgb565
-    typedef color_conv_rgba32_rgb565<2,1,0> color_conv_bgra32_to_rgb565; //----color_conv_bgra32_to_rgb565
-    typedef color_conv_rgba32_rgb565<0,1,2> color_conv_rgba32_to_rgb565; //----color_conv_rgba32_to_rgb565
-
-
-    //---------------------------------------------color_conv_rgb555_to_rgb565
-    class color_conv_rgb555_to_rgb565
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                unsigned rgb = *(int16u*)src;
-                *(int16u*)dst = (int16u)(((rgb << 1) & 0xFFC0) | (rgb & 0x1F));
-                src += 2;
-                dst += 2;
-            }
-            while(--width);
-        }
-    };
-
-
-    //----------------------------------------------color_conv_rgb565_to_rgb555
-    class color_conv_rgb565_to_rgb555
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                unsigned rgb = *(int16u*)src;
-                *(int16u*)dst = (int16u)(((rgb >> 1) & 0x7FE0) | (rgb & 0x1F));
-                src += 2;
-                dst += 2;
-            }
-            while(--width);
-        }
-    };
-
-
-    //------------------------------------------------------------------------
-    typedef color_conv_same<2> color_conv_rgb555_to_rgb555; //----color_conv_rgb555_to_rgb555
-    typedef color_conv_same<2> color_conv_rgb565_to_rgb565; //----color_conv_rgb565_to_rgb565
-
-    
-    template<int R, int B> class color_conv_rgb24_gray8
-    {
-    public:
-        void operator () (int8u* dst, 
-                          const int8u* src,
-                          unsigned width) const
-        {
-            do
-            {
-                *dst++ = (src[R]*77 + src[1]*150 + src[B]*29) >> 8;
-                src += 3;
-            }
-            while(--width);
-        }
-    };
-
-    typedef color_conv_rgb24_gray8<0,2> color_conv_rgb24_to_gray8; //----color_conv_rgb24_to_gray8
-    typedef color_conv_rgb24_gray8<2,0> color_conv_bgr24_to_gray8; //----color_conv_bgr24_to_gray8
-
-
-}
-
-
-
-#endif
diff -pruN 8.0.1-5/renderers/agg/readme 8.2.0~beta1-1~exp1/renderers/agg/readme
--- 8.0.1-5/renderers/agg/readme	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/readme	1970-01-01 00:00:00.000000000 +0000
@@ -1,63 +0,0 @@
-The Anti-Grain Geometry Project
-A high quality rendering engine for C++
-http://antigrain.com
-
-Anti-Grain Geometry - Version 2.4
-Copyright (C) 2002-2005 Maxim Shemanarev (McSeem)
-
-Permission to copy, use, modify, sell and distribute this software
-is granted provided this copyright notice appears in all copies.
-This software is provided "as is" without express or implied
-warranty, and with no claim as to its suitability for any purpose.
-
----------------------------------
-
-Use automake to build the library.
-
-If automake is not available you still can use the old make.
-There is a very simple Makefile that can be used. Note that
-if you use automake it will overwrite Makefile.
-
----------------------------------
-
-If building on AmigaOS 4.0 or higher type the following for
-instructions on what targets are available.
- make -f Makefile.AmigaOS
-
-To just build and install AGG into the standard AmigaOS SDK
-ready for use type:
- make -f Makefile.AmigaOS install
-
-If you just want to build one demo (e.g. lion) use:
- make -f Makefile.AmigaOS bin/lion
-
-If you have any questions about the AmigaOS port please
-contact Steven Solie (ssolie@telus.net) for help.
-
----------------------------------
-
-To build all examples using SDL (Mac or Linux) just type:
-
-cd /examples/sdl
-make
-
-Individual examples can be built with
-
-make aa_test
-
-In the same way the native Carbon examples can be built with
-
-cd /examples/macosx_carbon
-make
-
-In both cases the static library will be built (if it was not already) 
-from the existing global Makefile in /src/.
-
-The Makefiles for both SDL and Carbon will also attempt to download the 
-required .bmp files if they are not found in the system for a given 
-example. If the files could not be fetched (wget) the user will receive 
-a message explaining where to download the samples from (sphere.bmp, 
-etc.)  Since all programs reside in the same directory there is no need 
-to duplicate the .bmp files for each program that needs to use them.
-
----------------------------------
diff -pruN 8.0.1-5/renderers/agg/src/Makefile.am 8.2.0~beta1-1~exp1/renderers/agg/src/Makefile.am
--- 8.0.1-5/renderers/agg/src/Makefile.am	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/Makefile.am	1970-01-01 00:00:00.000000000 +0000
@@ -1,47 +0,0 @@
-SUBDIRS = ctrl . platform
-
-INCLUDES = -I$(top_srcdir)/include
-
-lib_LTLIBRARIES = libagg.la
-
-libagg_la_LDFLAGS = -no-undefined -version-info @AGG_LIB_VERSION@
-libagg_la_SOURCES =  agg_arc.cpp \
-										 agg_arrowhead.cpp \
-										 agg_bezier_arc.cpp \
-										 agg_bspline.cpp \
-										 agg_curves.cpp \
-										 agg_embedded_raster_fonts.cpp \
-										 agg_gsv_text.cpp \
-										 agg_image_filters.cpp \
-										 agg_line_aa_basics.cpp \
-										 agg_line_profile_aa.cpp \
-										 agg_rounded_rect.cpp \
-										 agg_sqrt_tables.cpp \
-										 agg_trans_affine.cpp \
-										 agg_trans_double_path.cpp \
-										 agg_trans_single_path.cpp \
-										 agg_trans_warp_magnifier.cpp \
-										 agg_vcgen_bspline.cpp \
-										 agg_vcgen_contour.cpp \
-										 agg_vcgen_dash.cpp \
-										 agg_vcgen_markers_term.cpp \
-										 agg_vcgen_smooth_poly1.cpp \
-										 agg_vcgen_stroke.cpp \
-										 agg_vpgen_clip_polygon.cpp \
-										 agg_vpgen_clip_polyline.cpp \
-										 agg_vpgen_segmentator.cpp
-
-if ENABLE_GPC
-GPCLD=$(top_builddir)/gpc/libagggpc.la 
-else
-GPCLD=
-endif
-
-if ENABLE_CTRL
-CTRLLD=$(top_builddir)/src/ctrl/libaggctrl.la 
-else
-CTRLLD=
-endif
-
-libagg_la_LIBADD = $(GPCLD) $(CTRLLD)
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_arc.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_arc.cpp
--- 8.0.1-5/renderers/agg/src/agg_arc.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_arc.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,106 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Arc vertex generator
-//
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_arc.h"
-
-
-namespace mapserver
-{
-    //------------------------------------------------------------------------
-    arc::arc(double x,  double y, 
-             double rx, double ry, 
-             double a1, double a2, 
-             bool ccw) :
-        m_x(x), m_y(y), m_rx(rx), m_ry(ry), m_scale(1.0)
-    {
-        normalize(a1, a2, ccw);
-    }
-
-    //------------------------------------------------------------------------
-    void arc::init(double x,  double y, 
-                   double rx, double ry, 
-                   double a1, double a2, 
-                   bool ccw)
-    {
-        m_x   = x;  m_y  = y;
-        m_rx  = rx; m_ry = ry; 
-        normalize(a1, a2, ccw);
-    }
-    
-    //------------------------------------------------------------------------
-    void arc::approximation_scale(double s)
-    {
-        m_scale = s;
-        if(m_initialized)
-        {
-            normalize(m_start, m_end, m_ccw);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void arc::rewind(unsigned)
-    {
-        m_path_cmd = path_cmd_move_to; 
-        m_angle = m_start;
-    }
-
-    //------------------------------------------------------------------------
-    unsigned arc::vertex(double* x, double* y)
-    {
-        if(is_stop(m_path_cmd)) return path_cmd_stop;
-        if((m_angle < m_end - m_da/4) != m_ccw)
-        {
-            *x = m_x + cos(m_end) * m_rx;
-            *y = m_y + sin(m_end) * m_ry;
-            m_path_cmd = path_cmd_stop;
-            return path_cmd_line_to;
-        }
-
-        *x = m_x + cos(m_angle) * m_rx;
-        *y = m_y + sin(m_angle) * m_ry;
-
-        m_angle += m_da;
-
-        unsigned pf = m_path_cmd;
-        m_path_cmd = path_cmd_line_to;
-        return pf;
-    }
-
-    //------------------------------------------------------------------------
-    void arc::normalize(double a1, double a2, bool ccw)
-    {
-        double ra = (fabs(m_rx) + fabs(m_ry)) / 2;
-        m_da = acos(ra / (ra + 0.125 / m_scale)) * 2;
-        if(ccw)
-        {
-            while(a2 < a1) a2 += pi * 2.0;
-        }
-        else
-        {
-            while(a1 < a2) a1 += pi * 2.0;
-            m_da = -m_da;
-        }
-        m_ccw   = ccw;
-        m_start = a1;
-        m_end   = a2;
-        m_initialized = true;
-    }
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_arrowhead.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_arrowhead.cpp
--- 8.0.1-5/renderers/agg/src/agg_arrowhead.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_arrowhead.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,110 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Simple arrowhead/arrowtail generator 
-//
-//----------------------------------------------------------------------------
-
-#include "../include/agg_arrowhead.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    arrowhead::arrowhead() :
-        m_head_d1(1.0),
-        m_head_d2(1.0),
-        m_head_d3(1.0),
-        m_head_d4(0.0),
-        m_tail_d1(1.0),
-        m_tail_d2(1.0),
-        m_tail_d3(1.0),
-        m_tail_d4(0.0),
-        m_head_flag(false),
-        m_tail_flag(false),
-        m_curr_id(0),
-        m_curr_coord(0)
-    {
-    }
-
-
-
-    //------------------------------------------------------------------------
-    void arrowhead::rewind(unsigned path_id)
-    {
-        m_curr_id = path_id;
-        m_curr_coord = 0;
-        if(path_id == 0)
-        {
-            if(!m_tail_flag)
-            {
-                m_cmd[0] = path_cmd_stop;
-                return;
-            }
-            m_coord[0]  =  m_tail_d1;             m_coord[1]  =  0.0;
-            m_coord[2]  =  m_tail_d1 - m_tail_d4; m_coord[3]  =  m_tail_d3;
-            m_coord[4]  = -m_tail_d2 - m_tail_d4; m_coord[5]  =  m_tail_d3;
-            m_coord[6]  = -m_tail_d2;             m_coord[7]  =  0.0;
-            m_coord[8]  = -m_tail_d2 - m_tail_d4; m_coord[9]  = -m_tail_d3;
-            m_coord[10] =  m_tail_d1 - m_tail_d4; m_coord[11] = -m_tail_d3;
-
-            m_cmd[0] = path_cmd_move_to;
-            m_cmd[1] = path_cmd_line_to;
-            m_cmd[2] = path_cmd_line_to;
-            m_cmd[3] = path_cmd_line_to;
-            m_cmd[4] = path_cmd_line_to;
-            m_cmd[5] = path_cmd_line_to;
-            m_cmd[7] = path_cmd_end_poly | path_flags_close | path_flags_ccw;
-            m_cmd[6] = path_cmd_stop;
-            return;
-        }
-
-        if(path_id == 1)
-        {
-            if(!m_head_flag)
-            {
-                m_cmd[0] = path_cmd_stop;
-                return;
-            }
-            m_coord[0]  = -m_head_d1;            m_coord[1]  = 0.0;
-            m_coord[2]  = m_head_d2 + m_head_d4; m_coord[3]  = -m_head_d3;
-            m_coord[4]  = m_head_d2;             m_coord[5]  = 0.0;
-            m_coord[6]  = m_head_d2 + m_head_d4; m_coord[7]  = m_head_d3;
-
-            m_cmd[0] = path_cmd_move_to;
-            m_cmd[1] = path_cmd_line_to;
-            m_cmd[2] = path_cmd_line_to;
-            m_cmd[3] = path_cmd_line_to;
-            m_cmd[4] = path_cmd_end_poly | path_flags_close | path_flags_ccw;
-            m_cmd[5] = path_cmd_stop;
-            return;
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    unsigned arrowhead::vertex(double* x, double* y)
-    {
-        if(m_curr_id < 2)
-        {
-            unsigned curr_idx = m_curr_coord * 2;
-            *x = m_coord[curr_idx];
-            *y = m_coord[curr_idx + 1];
-            return m_cmd[m_curr_coord++];
-        }
-        return path_cmd_stop;
-    }
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_bezier_arc.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_bezier_arc.cpp
--- 8.0.1-5/renderers/agg/src/agg_bezier_arc.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_bezier_arc.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,258 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Arc generator. Produces at most 4 consecutive cubic bezier curves, i.e., 
-// 4, 7, 10, or 13 vertices.
-//
-//----------------------------------------------------------------------------
-
-
-#include <math.h>
-#include "../include/agg_bezier_arc.h"
-
-
-namespace mapserver
-{
-
-    // This epsilon is used to prevent us from adding degenerate curves 
-    // (converging to a single point).
-    // The value isn't very critical. Function arc_to_bezier() has a limit 
-    // of the sweep_angle. If fabs(sweep_angle) exceeds pi/2 the curve 
-    // becomes inaccurate. But slight exceeding is quite appropriate.
-    //-------------------------------------------------bezier_arc_angle_epsilon
-    const double bezier_arc_angle_epsilon = 0.01;
-
-    //------------------------------------------------------------arc_to_bezier
-    void arc_to_bezier(double cx, double cy, double rx, double ry, 
-                       double start_angle, double sweep_angle,
-                       double* curve)
-    {
-        double x0 = cos(sweep_angle / 2.0);
-        double y0 = sin(sweep_angle / 2.0);
-        double tx = (1.0 - x0) * 4.0 / 3.0;
-        double ty = y0 - tx * x0 / y0;
-        double px[4];
-        double py[4];
-        px[0] =  x0;
-        py[0] = -y0;
-        px[1] =  x0 + tx;
-        py[1] = -ty;
-        px[2] =  x0 + tx;
-        py[2] =  ty;
-        px[3] =  x0;
-        py[3] =  y0;
-
-        double sn = sin(start_angle + sweep_angle / 2.0);
-        double cs = cos(start_angle + sweep_angle / 2.0);
-
-        unsigned i;
-        for(i = 0; i < 4; i++)
-        {
-            curve[i * 2]     = cx + rx * (px[i] * cs - py[i] * sn);
-            curve[i * 2 + 1] = cy + ry * (px[i] * sn + py[i] * cs);
-        }
-    }
-
-
-
-    //------------------------------------------------------------------------
-    void bezier_arc::init(double x,  double y, 
-                          double rx, double ry, 
-                          double start_angle, 
-                          double sweep_angle)
-    {
-        start_angle = fmod(start_angle, 2.0 * pi);
-        if(sweep_angle >=  2.0 * pi) sweep_angle =  2.0 * pi;
-        if(sweep_angle <= -2.0 * pi) sweep_angle = -2.0 * pi;
-
-        if(fabs(sweep_angle) < 1e-10)
-        {
-            m_num_vertices = 4;
-            m_cmd = path_cmd_line_to;
-            m_vertices[0] = x + rx * cos(start_angle);
-            m_vertices[1] = y + ry * sin(start_angle);
-            m_vertices[2] = x + rx * cos(start_angle + sweep_angle);
-            m_vertices[3] = y + ry * sin(start_angle + sweep_angle);
-            return;
-        }
-
-        double total_sweep = 0.0;
-        double local_sweep = 0.0;
-        double prev_sweep;
-        m_num_vertices = 2;
-        m_cmd = path_cmd_curve4;
-        bool done = false;
-        do
-        {
-            if(sweep_angle < 0.0)
-            {
-                prev_sweep  = total_sweep;
-                local_sweep = -pi * 0.5;
-                total_sweep -= pi * 0.5;
-                if(total_sweep <= sweep_angle + bezier_arc_angle_epsilon)
-                {
-                    local_sweep = sweep_angle - prev_sweep;
-                    done = true;
-                }
-            }
-            else
-            {
-                prev_sweep  = total_sweep;
-                local_sweep =  pi * 0.5;
-                total_sweep += pi * 0.5;
-                if(total_sweep >= sweep_angle - bezier_arc_angle_epsilon)
-                {
-                    local_sweep = sweep_angle - prev_sweep;
-                    done = true;
-                }
-            }
-
-            arc_to_bezier(x, y, rx, ry, 
-                          start_angle, 
-                          local_sweep, 
-                          m_vertices + m_num_vertices - 2);
-
-            m_num_vertices += 6;
-            start_angle += local_sweep;
-        }
-        while(!done && m_num_vertices < 26);
-    }
-
-
-
-
-    //--------------------------------------------------------------------
-    void bezier_arc_svg::init(double x0, double y0, 
-                              double rx, double ry, 
-                              double angle,
-                              bool large_arc_flag,
-                              bool sweep_flag,
-                              double x2, double y2)
-    {
-        m_radii_ok = true;
-
-        if(rx < 0.0) rx = -rx;
-        if(ry < 0.0) ry = -rx;
-
-        // Calculate the middle point between 
-        // the current and the final points
-        //------------------------
-        double dx2 = (x0 - x2) / 2.0;
-        double dy2 = (y0 - y2) / 2.0;
-
-        double cos_a = cos(angle);
-        double sin_a = sin(angle);
-
-        // Calculate (x1, y1)
-        //------------------------
-        double x1 =  cos_a * dx2 + sin_a * dy2;
-        double y1 = -sin_a * dx2 + cos_a * dy2;
-
-        // Ensure radii are large enough
-        //------------------------
-        double prx = rx * rx;
-        double pry = ry * ry;
-        double px1 = x1 * x1;
-        double py1 = y1 * y1;
-
-        // Check that radii are large enough
-        //------------------------
-        double radii_check = px1/prx + py1/pry;
-        if(radii_check > 1.0) 
-        {
-            rx = sqrt(radii_check) * rx;
-            ry = sqrt(radii_check) * ry;
-            prx = rx * rx;
-            pry = ry * ry;
-            if(radii_check > 10.0) m_radii_ok = false;
-        }
-
-        // Calculate (cx1, cy1)
-        //------------------------
-        double sign = (large_arc_flag == sweep_flag) ? -1.0 : 1.0;
-        double sq   = (prx*pry - prx*py1 - pry*px1) / (prx*py1 + pry*px1);
-        double coef = sign * sqrt((sq < 0) ? 0 : sq);
-        double cx1  = coef *  ((rx * y1) / ry);
-        double cy1  = coef * -((ry * x1) / rx);
-
-        //
-        // Calculate (cx, cy) from (cx1, cy1)
-        //------------------------
-        double sx2 = (x0 + x2) / 2.0;
-        double sy2 = (y0 + y2) / 2.0;
-        double cx = sx2 + (cos_a * cx1 - sin_a * cy1);
-        double cy = sy2 + (sin_a * cx1 + cos_a * cy1);
-
-        // Calculate the start_angle (angle1) and the sweep_angle (dangle)
-        //------------------------
-        double ux =  (x1 - cx1) / rx;
-        double uy =  (y1 - cy1) / ry;
-        double vx = (-x1 - cx1) / rx;
-        double vy = (-y1 - cy1) / ry;
-        double p, n;
-
-        // Calculate the angle start
-        //------------------------
-        n = sqrt(ux*ux + uy*uy);
-        p = ux; // (1 * ux) + (0 * uy)
-        sign = (uy < 0) ? -1.0 : 1.0;
-        double v = p / n;
-        if(v < -1.0) v = -1.0;
-        if(v >  1.0) v =  1.0;
-        double start_angle = sign * acos(v);
-
-        // Calculate the sweep angle
-        //------------------------
-        n = sqrt((ux*ux + uy*uy) * (vx*vx + vy*vy));
-        p = ux * vx + uy * vy;
-        sign = (ux * vy - uy * vx < 0) ? -1.0 : 1.0;
-        v = p / n;
-        if(v < -1.0) v = -1.0;
-        if(v >  1.0) v =  1.0;
-        double sweep_angle = sign * acos(v);
-        if(!sweep_flag && sweep_angle > 0) 
-        {
-            sweep_angle -= pi * 2.0;
-        } 
-        else 
-        if (sweep_flag && sweep_angle < 0) 
-        {
-            sweep_angle += pi * 2.0;
-        }
-
-        // We can now build and transform the resulting arc
-        //------------------------
-        m_arc.init(0.0, 0.0, rx, ry, start_angle, sweep_angle);
-        trans_affine mtx = trans_affine_rotation(angle);
-        mtx *= trans_affine_translation(cx, cy);
-        
-        for(unsigned i = 2; i < m_arc.num_vertices()-2; i += 2)
-        {
-            mtx.transform(m_arc.vertices() + i, m_arc.vertices() + i + 1);
-        }
-
-        // We must make sure that the starting and ending points
-        // exactly coincide with the initial (x0,y0) and (x2,y2)
-        m_arc.vertices()[0] = x0;
-        m_arc.vertices()[1] = y0;
-        if(m_arc.num_vertices() > 2)
-        {
-            m_arc.vertices()[m_arc.num_vertices() - 2] = x2;
-            m_arc.vertices()[m_arc.num_vertices() - 1] = y2;
-        }
-    }
-
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_bspline.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_bspline.cpp
--- 8.0.1-5/renderers/agg/src/agg_bspline.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_bspline.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,284 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// class bspline
-//
-//----------------------------------------------------------------------------
-
-#include "../include/agg_bspline.h"
-
-namespace mapserver
-{
-    //------------------------------------------------------------------------
-    bspline::bspline() :
-        m_max(0),
-        m_num(0),
-        m_x(0),
-        m_y(0),
-        m_last_idx(-1)
-    {
-    }
-
-    //------------------------------------------------------------------------
-    bspline::bspline(int num) :
-        m_max(0),
-        m_num(0),
-        m_x(0),
-        m_y(0),
-        m_last_idx(-1)
-    {
-        init(num);
-    }
-
-    //------------------------------------------------------------------------
-    bspline::bspline(int num, const double* x, const double* y) :
-        m_max(0),
-        m_num(0),
-        m_x(0),
-        m_y(0),
-        m_last_idx(-1)
-    {
-        init(num, x, y);
-    }
-
-    
-    //------------------------------------------------------------------------
-    void bspline::init(int max)
-    {
-        if(max > 2 && max > m_max)
-        {
-            m_am.resize(max * 3);
-            m_max = max;
-            m_x   = &m_am[m_max];
-            m_y   = &m_am[m_max * 2];
-        }
-        m_num = 0;
-        m_last_idx = -1;
-    }
-
-
-    //------------------------------------------------------------------------
-    void bspline::add_point(double x, double y)
-    {
-        if(m_num < m_max)
-        {
-            m_x[m_num] = x;
-            m_y[m_num] = y;
-            ++m_num;
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void bspline::prepare()
-    {
-        if(m_num > 2)
-        {
-            int i, k, n1;
-            double* temp; 
-            double* r; 
-            double* s;
-            double h, p, d, f, e;
-    
-            for(k = 0; k < m_num; k++) 
-            {
-                m_am[k] = 0.0;
-            }
-
-            n1 = 3 * m_num;
-
-            pod_array<double> al(n1);
-            temp = &al[0];
-
-            for(k = 0; k < n1; k++) 
-            {
-                temp[k] = 0.0;
-            }
-
-            r = temp + m_num;
-            s = temp + m_num * 2;
-
-            n1 = m_num - 1;
-            d = m_x[1] - m_x[0];
-            e = (m_y[1] - m_y[0]) / d;
-
-            for(k = 1; k < n1; k++) 
-            {
-                h     = d;
-                d     = m_x[k + 1] - m_x[k];
-                f     = e;
-                e     = (m_y[k + 1] - m_y[k]) / d;
-                al[k] = d / (d + h);
-                r[k]  = 1.0 - al[k];
-                s[k]  = 6.0 * (e - f) / (h + d);
-            }
-
-            for(k = 1; k < n1; k++) 
-            {
-                p = 1.0 / (r[k] * al[k - 1] + 2.0);
-                al[k] *= -p;
-                s[k] = (s[k] - r[k] * s[k - 1]) * p; 
-            }
-
-            m_am[n1]     = 0.0;
-            al[n1 - 1]   = s[n1 - 1];
-            m_am[n1 - 1] = al[n1 - 1];
-
-            for(k = n1 - 2, i = 0; i < m_num - 2; i++, k--) 
-            {
-                al[k]   = al[k] * al[k + 1] + s[k];
-                m_am[k] = al[k];
-            }
-        }
-        m_last_idx = -1;
-    }
-
-
-
-    //------------------------------------------------------------------------
-    void bspline::init(int num, const double* x, const double* y)
-    {
-        if(num > 2)
-        {
-            init(num);
-            int i;
-            for(i = 0; i < num; i++)
-            {
-                add_point(*x++, *y++);
-            }
-            prepare();
-        }
-        m_last_idx = -1;
-    }
-
-
-    //------------------------------------------------------------------------
-    void bspline::bsearch(int n, const double *x, double x0, int *i) 
-    {
-        int j = n - 1;
-        int k;
-          
-        for(*i = 0; (j - *i) > 1; ) 
-        {
-            if(x0 < x[k = (*i + j) >> 1]) j = k; 
-            else                         *i = k;
-        }
-    }
-
-
-
-    //------------------------------------------------------------------------
-    double bspline::interpolation(double x, int i) const
-    {
-        int j = i + 1;
-        double d = m_x[i] - m_x[j];
-        double h = x - m_x[j];
-        double r = m_x[i] - x;
-        double p = d * d / 6.0;
-        return (m_am[j] * r * r * r + m_am[i] * h * h * h) / 6.0 / d +
-               ((m_y[j] - m_am[j] * p) * r + (m_y[i] - m_am[i] * p) * h) / d;
-    }
-
-
-    //------------------------------------------------------------------------
-    double bspline::extrapolation_left(double x) const
-    {
-        double d = m_x[1] - m_x[0];
-        return (-d * m_am[1] / 6 + (m_y[1] - m_y[0]) / d) * 
-               (x - m_x[0]) + 
-               m_y[0];
-    }
-
-    //------------------------------------------------------------------------
-    double bspline::extrapolation_right(double x) const
-    {
-        double d = m_x[m_num - 1] - m_x[m_num - 2];
-        return (d * m_am[m_num - 2] / 6 + (m_y[m_num - 1] - m_y[m_num - 2]) / d) * 
-               (x - m_x[m_num - 1]) + 
-               m_y[m_num - 1];
-    }
-
-    //------------------------------------------------------------------------
-    double bspline::get(double x) const
-    {
-        if(m_num > 2)
-        {
-            int i;
-
-            // Extrapolation on the left
-            if(x < m_x[0]) return extrapolation_left(x);
-
-            // Extrapolation on the right
-            if(x >= m_x[m_num - 1]) return extrapolation_right(x);
-
-            // Interpolation
-            bsearch(m_num, m_x, x, &i);
-            return interpolation(x, i);
-        }
-        return 0.0;
-    }
-
-
-    //------------------------------------------------------------------------
-    double bspline::get_stateful(double x) const
-    {
-        if(m_num > 2)
-        {
-            // Extrapolation on the left
-            if(x < m_x[0]) return extrapolation_left(x);
-
-            // Extrapolation on the right
-            if(x >= m_x[m_num - 1]) return extrapolation_right(x);
-
-            if(m_last_idx >= 0)
-            {
-                // Check if x is not in current range
-                if(x < m_x[m_last_idx] || x > m_x[m_last_idx + 1])
-                {
-                    // Check if x between next points (most probably)
-                    if(m_last_idx < m_num - 2 && 
-                       x >= m_x[m_last_idx + 1] &&
-                       x <= m_x[m_last_idx + 2])
-                    {
-                        ++m_last_idx;
-                    }
-                    else
-                    if(m_last_idx > 0 && 
-                       x >= m_x[m_last_idx - 1] && 
-                       x <= m_x[m_last_idx])
-                    {
-                        // x is between pevious points
-                        --m_last_idx;
-                    }
-                    else
-                    {
-                        // Else perform full search
-                        bsearch(m_num, m_x, x, &m_last_idx);
-                    }
-                }
-                return interpolation(x, m_last_idx);
-            }
-            else
-            {
-                // Interpolation
-                bsearch(m_num, m_x, x, &m_last_idx);
-                return interpolation(x, m_last_idx);
-            }
-        }
-        return 0.0;
-    }
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_curves.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_curves.cpp
--- 8.0.1-5/renderers/agg/src/agg_curves.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_curves.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,611 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_curves.h"
-#include "../include/agg_math.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    const double curve_collinearity_epsilon              = 1e-30;
-    const double curve_angle_tolerance_epsilon           = 0.01;
-    enum curve_recursion_limit_e { curve_recursion_limit = 32 };
-
-
-
-    //------------------------------------------------------------------------
-    void curve3_inc::approximation_scale(double s) 
-    { 
-        m_scale = s;
-    }
-
-    //------------------------------------------------------------------------
-    double curve3_inc::approximation_scale() const 
-    { 
-        return m_scale;
-    }
-
-    //------------------------------------------------------------------------
-    void curve3_inc::init(double x1, double y1, 
-                          double x2, double y2, 
-                          double x3, double y3)
-    {
-        m_start_x = x1;
-        m_start_y = y1;
-        m_end_x   = x3;
-        m_end_y   = y3;
-
-        double dx1 = x2 - x1;
-        double dy1 = y2 - y1;
-        double dx2 = x3 - x2;
-        double dy2 = y3 - y2;
-
-        double len = sqrt(dx1 * dx1 + dy1 * dy1) + sqrt(dx2 * dx2 + dy2 * dy2); 
-
-        m_num_steps = uround(len * 0.25 * m_scale);
-
-        if(m_num_steps < 4)
-        {
-            m_num_steps = 4;   
-        }
-
-        double subdivide_step  = 1.0 / m_num_steps;
-        double subdivide_step2 = subdivide_step * subdivide_step;
-
-        double tmpx = (x1 - x2 * 2.0 + x3) * subdivide_step2;
-        double tmpy = (y1 - y2 * 2.0 + y3) * subdivide_step2;
-
-        m_saved_fx = m_fx = x1;
-        m_saved_fy = m_fy = y1;
-        
-        m_saved_dfx = m_dfx = tmpx + (x2 - x1) * (2.0 * subdivide_step);
-        m_saved_dfy = m_dfy = tmpy + (y2 - y1) * (2.0 * subdivide_step);
-
-        m_ddfx = tmpx * 2.0;
-        m_ddfy = tmpy * 2.0;
-
-        m_step = m_num_steps;
-    }
-
-    //------------------------------------------------------------------------
-    void curve3_inc::rewind(unsigned)
-    {
-        if(m_num_steps == 0)
-        {
-            m_step = -1;
-            return;
-        }
-        m_step = m_num_steps;
-        m_fx   = m_saved_fx;
-        m_fy   = m_saved_fy;
-        m_dfx  = m_saved_dfx;
-        m_dfy  = m_saved_dfy;
-    }
-
-    //------------------------------------------------------------------------
-    unsigned curve3_inc::vertex(double* x, double* y)
-    {
-        if(m_step < 0) return path_cmd_stop;
-        if(m_step == m_num_steps)
-        {
-            *x = m_start_x;
-            *y = m_start_y;
-            --m_step;
-            return path_cmd_move_to;
-        }
-        if(m_step == 0)
-        {
-            *x = m_end_x;
-            *y = m_end_y;
-            --m_step;
-            return path_cmd_line_to;
-        }
-        m_fx  += m_dfx; 
-        m_fy  += m_dfy;
-        m_dfx += m_ddfx; 
-        m_dfy += m_ddfy; 
-        *x = m_fx;
-        *y = m_fy;
-        --m_step;
-        return path_cmd_line_to;
-    }
-
-    //------------------------------------------------------------------------
-    void curve3_div::init(double x1, double y1, 
-                          double x2, double y2, 
-                          double x3, double y3)
-    {
-        m_points.remove_all();
-        m_distance_tolerance_square = 0.5 / m_approximation_scale;
-        m_distance_tolerance_square *= m_distance_tolerance_square;
-        bezier(x1, y1, x2, y2, x3, y3);
-        m_count = 0;
-    }
-
-    //------------------------------------------------------------------------
-    void curve3_div::recursive_bezier(double x1, double y1, 
-                                      double x2, double y2, 
-                                      double x3, double y3,
-                                      unsigned level)
-    {
-        if(level > curve_recursion_limit) 
-        {
-            return;
-        }
-
-        // Calculate all the mid-points of the line segments
-        //----------------------
-        double x12   = (x1 + x2) / 2;                
-        double y12   = (y1 + y2) / 2;
-        double x23   = (x2 + x3) / 2;
-        double y23   = (y2 + y3) / 2;
-        double x123  = (x12 + x23) / 2;
-        double y123  = (y12 + y23) / 2;
-
-        double dx = x3-x1;
-        double dy = y3-y1;
-        double d = fabs(((x2 - x3) * dy - (y2 - y3) * dx));
-        double da;
-
-        if(d > curve_collinearity_epsilon)
-        { 
-            // Regular case
-            //-----------------
-            if(d * d <= m_distance_tolerance_square * (dx*dx + dy*dy))
-            {
-                // If the curvature doesn't exceed the distance_tolerance value
-                // we tend to finish subdivisions.
-                //----------------------
-                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
-                {
-                    m_points.add(point_d(x123, y123));
-                    return;
-                }
-
-                // Angle & Cusp Condition
-                //----------------------
-                da = fabs(atan2(y3 - y2, x3 - x2) - atan2(y2 - y1, x2 - x1));
-                if(da >= pi) da = 2*pi - da;
-
-                if(da < m_angle_tolerance)
-                {
-                    // Finally we can stop the recursion
-                    //----------------------
-                    m_points.add(point_d(x123, y123));
-                    return;                 
-                }
-            }
-        }
-        else
-        {
-            // Collinear case
-            //------------------
-            da = dx*dx + dy*dy;
-            if(da == 0)
-            {
-                d = calc_sq_distance(x1, y1, x2, y2);
-            }
-            else
-            {
-                d = ((x2 - x1)*dx + (y2 - y1)*dy) / da;
-                if(d > 0 && d < 1)
-                {
-                    // Simple collinear case, 1---2---3
-                    // We can leave just two endpoints
-                    return;
-                }
-                     if(d <= 0) d = calc_sq_distance(x2, y2, x1, y1);
-                else if(d >= 1) d = calc_sq_distance(x2, y2, x3, y3);
-                else            d = calc_sq_distance(x2, y2, x1 + d*dx, y1 + d*dy);
-            }
-            if(d < m_distance_tolerance_square)
-            {
-                m_points.add(point_d(x2, y2));
-                return;
-            }
-        }
-
-        // Continue subdivision
-        //----------------------
-        recursive_bezier(x1, y1, x12, y12, x123, y123, level + 1); 
-        recursive_bezier(x123, y123, x23, y23, x3, y3, level + 1); 
-    }
-
-    //------------------------------------------------------------------------
-    void curve3_div::bezier(double x1, double y1, 
-                            double x2, double y2, 
-                            double x3, double y3)
-    {
-        m_points.add(point_d(x1, y1));
-        recursive_bezier(x1, y1, x2, y2, x3, y3, 0);
-        m_points.add(point_d(x3, y3));
-    }
-
-
-
-
-
-    //------------------------------------------------------------------------
-    void curve4_inc::approximation_scale(double s) 
-    { 
-        m_scale = s;
-    }
-
-    //------------------------------------------------------------------------
-    double curve4_inc::approximation_scale() const 
-    { 
-        return m_scale;
-    }
-
-#if defined(_MSC_VER) && _MSC_VER <= 1200
-    //------------------------------------------------------------------------
-    static double MSC60_fix_ICE(double v) { return v; }
-#endif
-    //------------------------------------------------------------------------
-    void curve4_inc::init(double x1, double y1, 
-                          double x2, double y2, 
-                          double x3, double y3,
-                          double x4, double y4)
-    {
-        m_start_x = x1;
-        m_start_y = y1;
-        m_end_x   = x4;
-        m_end_y   = y4;
-
-        double dx1 = x2 - x1;
-        double dy1 = y2 - y1;
-        double dx2 = x3 - x2;
-        double dy2 = y3 - y2;
-        double dx3 = x4 - x3;
-        double dy3 = y4 - y3;
-
-        double len = (sqrt(dx1 * dx1 + dy1 * dy1) + 
-                      sqrt(dx2 * dx2 + dy2 * dy2) + 
-                      sqrt(dx3 * dx3 + dy3 * dy3)) * 0.25 * m_scale;
-
-#if defined(_MSC_VER) && _MSC_VER <= 1200
-        m_num_steps = uround(MSC60_fix_ICE(len));
-#else
-        m_num_steps = uround(len);
-#endif
-
-        if(m_num_steps < 4)
-        {
-            m_num_steps = 4;   
-        }
-
-        double subdivide_step  = 1.0 / m_num_steps;
-        double subdivide_step2 = subdivide_step * subdivide_step;
-        double subdivide_step3 = subdivide_step * subdivide_step * subdivide_step;
-
-        double pre1 = 3.0 * subdivide_step;
-        double pre2 = 3.0 * subdivide_step2;
-        double pre4 = 6.0 * subdivide_step2;
-        double pre5 = 6.0 * subdivide_step3;
-	
-        double tmp1x = x1 - x2 * 2.0 + x3;
-        double tmp1y = y1 - y2 * 2.0 + y3;
-
-        double tmp2x = (x2 - x3) * 3.0 - x1 + x4;
-        double tmp2y = (y2 - y3) * 3.0 - y1 + y4;
-
-        m_saved_fx = m_fx = x1;
-        m_saved_fy = m_fy = y1;
-
-        m_saved_dfx = m_dfx = (x2 - x1) * pre1 + tmp1x * pre2 + tmp2x * subdivide_step3;
-        m_saved_dfy = m_dfy = (y2 - y1) * pre1 + tmp1y * pre2 + tmp2y * subdivide_step3;
-
-        m_saved_ddfx = m_ddfx = tmp1x * pre4 + tmp2x * pre5;
-        m_saved_ddfy = m_ddfy = tmp1y * pre4 + tmp2y * pre5;
-
-        m_dddfx = tmp2x * pre5;
-        m_dddfy = tmp2y * pre5;
-
-        m_step = m_num_steps;
-    }
-
-    //------------------------------------------------------------------------
-    void curve4_inc::rewind(unsigned)
-    {
-        if(m_num_steps == 0)
-        {
-            m_step = -1;
-            return;
-        }
-        m_step = m_num_steps;
-        m_fx   = m_saved_fx;
-        m_fy   = m_saved_fy;
-        m_dfx  = m_saved_dfx;
-        m_dfy  = m_saved_dfy;
-        m_ddfx = m_saved_ddfx;
-        m_ddfy = m_saved_ddfy;
-    }
-
-    //------------------------------------------------------------------------
-    unsigned curve4_inc::vertex(double* x, double* y)
-    {
-        if(m_step < 0) return path_cmd_stop;
-        if(m_step == m_num_steps)
-        {
-            *x = m_start_x;
-            *y = m_start_y;
-            --m_step;
-            return path_cmd_move_to;
-        }
-
-        if(m_step == 0)
-        {
-            *x = m_end_x;
-            *y = m_end_y;
-            --m_step;
-            return path_cmd_line_to;
-        }
-
-        m_fx   += m_dfx;
-        m_fy   += m_dfy;
-        m_dfx  += m_ddfx; 
-        m_dfy  += m_ddfy; 
-        m_ddfx += m_dddfx; 
-        m_ddfy += m_dddfy; 
-
-        *x = m_fx;
-        *y = m_fy;
-        --m_step;
-        return path_cmd_line_to;
-    }
-
-
-
-
-    //------------------------------------------------------------------------
-    void curve4_div::init(double x1, double y1, 
-                          double x2, double y2, 
-                          double x3, double y3,
-                          double x4, double y4)
-    {
-        m_points.remove_all();
-        m_distance_tolerance_square = 0.5 / m_approximation_scale;
-        m_distance_tolerance_square *= m_distance_tolerance_square;
-        bezier(x1, y1, x2, y2, x3, y3, x4, y4);
-        m_count = 0;
-    }
-
-    //------------------------------------------------------------------------
-    void curve4_div::recursive_bezier(double x1, double y1, 
-                                      double x2, double y2, 
-                                      double x3, double y3, 
-                                      double x4, double y4,
-                                      unsigned level)
-    {
-        if(level > curve_recursion_limit) 
-        {
-            return;
-        }
-
-        // Calculate all the mid-points of the line segments
-        //----------------------
-        double x12   = (x1 + x2) / 2;
-        double y12   = (y1 + y2) / 2;
-        double x23   = (x2 + x3) / 2;
-        double y23   = (y2 + y3) / 2;
-        double x34   = (x3 + x4) / 2;
-        double y34   = (y3 + y4) / 2;
-        double x123  = (x12 + x23) / 2;
-        double y123  = (y12 + y23) / 2;
-        double x234  = (x23 + x34) / 2;
-        double y234  = (y23 + y34) / 2;
-        double x1234 = (x123 + x234) / 2;
-        double y1234 = (y123 + y234) / 2;
-
-
-        // Try to approximate the full cubic curve by a single straight line
-        //------------------
-        double dx = x4-x1;
-        double dy = y4-y1;
-
-        double d2 = fabs(((x2 - x4) * dy - (y2 - y4) * dx));
-        double d3 = fabs(((x3 - x4) * dy - (y3 - y4) * dx));
-        double da1, da2, k;
-
-        switch((int(d2 > curve_collinearity_epsilon) << 1) +
-                int(d3 > curve_collinearity_epsilon))
-        {
-        case 0:
-            // All collinear OR p1==p4
-            //----------------------
-            k = dx*dx + dy*dy;
-            if(k == 0)
-            {
-                d2 = calc_sq_distance(x1, y1, x2, y2);
-                d3 = calc_sq_distance(x4, y4, x3, y3);
-            }
-            else
-            {
-                k   = 1 / k;
-                da1 = x2 - x1;
-                da2 = y2 - y1;
-                d2  = k * (da1*dx + da2*dy);
-                da1 = x3 - x1;
-                da2 = y3 - y1;
-                d3  = k * (da1*dx + da2*dy);
-                if(d2 > 0 && d2 < 1 && d3 > 0 && d3 < 1)
-                {
-                    // Simple collinear case, 1---2---3---4
-                    // We can leave just two endpoints
-                    return;
-                }
-                     if(d2 <= 0) d2 = calc_sq_distance(x2, y2, x1, y1);
-                else if(d2 >= 1) d2 = calc_sq_distance(x2, y2, x4, y4);
-                else             d2 = calc_sq_distance(x2, y2, x1 + d2*dx, y1 + d2*dy);
-
-                     if(d3 <= 0) d3 = calc_sq_distance(x3, y3, x1, y1);
-                else if(d3 >= 1) d3 = calc_sq_distance(x3, y3, x4, y4);
-                else             d3 = calc_sq_distance(x3, y3, x1 + d3*dx, y1 + d3*dy);
-            }
-            if(d2 > d3)
-            {
-                if(d2 < m_distance_tolerance_square)
-                {
-                    m_points.add(point_d(x2, y2));
-                    return;
-                }
-            }
-            else
-            {
-                if(d3 < m_distance_tolerance_square)
-                {
-                    m_points.add(point_d(x3, y3));
-                    return;
-                }
-            }
-            break;
-
-        case 1:
-            // p1,p2,p4 are collinear, p3 is significant
-            //----------------------
-            if(d3 * d3 <= m_distance_tolerance_square * (dx*dx + dy*dy))
-            {
-                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
-                {
-                    m_points.add(point_d(x23, y23));
-                    return;
-                }
-
-                // Angle Condition
-                //----------------------
-                da1 = fabs(atan2(y4 - y3, x4 - x3) - atan2(y3 - y2, x3 - x2));
-                if(da1 >= pi) da1 = 2*pi - da1;
-
-                if(da1 < m_angle_tolerance)
-                {
-                    m_points.add(point_d(x2, y2));
-                    m_points.add(point_d(x3, y3));
-                    return;
-                }
-
-                if(m_cusp_limit != 0.0)
-                {
-                    if(da1 > m_cusp_limit)
-                    {
-                        m_points.add(point_d(x3, y3));
-                        return;
-                    }
-                }
-            }
-            break;
-
-        case 2:
-            // p1,p3,p4 are collinear, p2 is significant
-            //----------------------
-            if(d2 * d2 <= m_distance_tolerance_square * (dx*dx + dy*dy))
-            {
-                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
-                {
-                    m_points.add(point_d(x23, y23));
-                    return;
-                }
-
-                // Angle Condition
-                //----------------------
-                da1 = fabs(atan2(y3 - y2, x3 - x2) - atan2(y2 - y1, x2 - x1));
-                if(da1 >= pi) da1 = 2*pi - da1;
-
-                if(da1 < m_angle_tolerance)
-                {
-                    m_points.add(point_d(x2, y2));
-                    m_points.add(point_d(x3, y3));
-                    return;
-                }
-
-                if(m_cusp_limit != 0.0)
-                {
-                    if(da1 > m_cusp_limit)
-                    {
-                        m_points.add(point_d(x2, y2));
-                        return;
-                    }
-                }
-            }
-            break;
-
-        case 3: 
-            // Regular case
-            //-----------------
-            if((d2 + d3)*(d2 + d3) <= m_distance_tolerance_square * (dx*dx + dy*dy))
-            {
-                // If the curvature doesn't exceed the distance_tolerance value
-                // we tend to finish subdivisions.
-                //----------------------
-                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
-                {
-                    m_points.add(point_d(x23, y23));
-                    return;
-                }
-
-                // Angle & Cusp Condition
-                //----------------------
-                k   = atan2(y3 - y2, x3 - x2);
-                da1 = fabs(k - atan2(y2 - y1, x2 - x1));
-                da2 = fabs(atan2(y4 - y3, x4 - x3) - k);
-                if(da1 >= pi) da1 = 2*pi - da1;
-                if(da2 >= pi) da2 = 2*pi - da2;
-
-                if(da1 + da2 < m_angle_tolerance)
-                {
-                    // Finally we can stop the recursion
-                    //----------------------
-                    m_points.add(point_d(x23, y23));
-                    return;
-                }
-
-                if(m_cusp_limit != 0.0)
-                {
-                    if(da1 > m_cusp_limit)
-                    {
-                        m_points.add(point_d(x2, y2));
-                        return;
-                    }
-
-                    if(da2 > m_cusp_limit)
-                    {
-                        m_points.add(point_d(x3, y3));
-                        return;
-                    }
-                }
-            }
-            break;
-        }
-
-        // Continue subdivision
-        //----------------------
-        recursive_bezier(x1, y1, x12, y12, x123, y123, x1234, y1234, level + 1); 
-        recursive_bezier(x1234, y1234, x234, y234, x34, y34, x4, y4, level + 1); 
-    }
-
-    //------------------------------------------------------------------------
-    void curve4_div::bezier(double x1, double y1, 
-                            double x2, double y2, 
-                            double x3, double y3, 
-                            double x4, double y4)
-    {
-        m_points.add(point_d(x1, y1));
-        recursive_bezier(x1, y1, x2, y2, x3, y3, x4, y4, 0);
-        m_points.add(point_d(x4, y4));
-    }
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_embedded_raster_fonts.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_embedded_raster_fonts.cpp
--- 8.0.1-5/renderers/agg/src/agg_embedded_raster_fonts.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_embedded_raster_fonts.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,10426 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include "../include/agg_embedded_raster_fonts.h"
-
-namespace mapserver
-{
-
-    const int8u gse4x6[] = 
-    {
-        6, 0, 32, 128-32,
-
-        0x00,0x00,0x07,0x00,0x0e,0x00,0x15,0x00,0x1c,0x00,0x23,0x00,0x2a,0x00,0x31,0x00,0x38,0x00,
-        0x3f,0x00,0x46,0x00,0x4d,0x00,0x54,0x00,0x5b,0x00,0x62,0x00,0x69,0x00,0x70,0x00,0x77,0x00,
-        0x7e,0x00,0x85,0x00,0x8c,0x00,0x93,0x00,0x9a,0x00,0xa1,0x00,0xa8,0x00,0xaf,0x00,0xb6,0x00,
-        0xbd,0x00,0xc4,0x00,0xcb,0x00,0xd2,0x00,0xd9,0x00,0xe0,0x00,0xe7,0x00,0xee,0x00,0xf5,0x00,
-        0xfc,0x00,0x03,0x01,0x0a,0x01,0x11,0x01,0x18,0x01,0x1f,0x01,0x26,0x01,0x2d,0x01,0x34,0x01,
-        0x3b,0x01,0x42,0x01,0x49,0x01,0x50,0x01,0x57,0x01,0x5e,0x01,0x65,0x01,0x6c,0x01,0x73,0x01,
-        0x7a,0x01,0x81,0x01,0x88,0x01,0x8f,0x01,0x96,0x01,0x9d,0x01,0xa4,0x01,0xab,0x01,0xb2,0x01,
-        0xb9,0x01,0xc0,0x01,0xc7,0x01,0xce,0x01,0xd5,0x01,0xdc,0x01,0xe3,0x01,0xea,0x01,0xf1,0x01,
-        0xf8,0x01,0xff,0x01,0x06,0x02,0x0d,0x02,0x14,0x02,0x1b,0x02,0x22,0x02,0x29,0x02,0x30,0x02,
-        0x37,0x02,0x3e,0x02,0x45,0x02,0x4c,0x02,0x53,0x02,0x5a,0x02,0x61,0x02,0x68,0x02,0x6f,0x02,
-        0x76,0x02,0x7d,0x02,0x84,0x02,0x8b,0x02,0x92,0x02,0x99,0x02,
-
-        4, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x40,0x40,0x40,0x00,0x40,0x00,
-
-        4, // 0x22 '"'
-        0xa0,0xa0,0x00,0x00,0x00,0x00,
-
-        4, // 0x23 '#'
-        0x60,0xf0,0x60,0xf0,0x60,0x00,
-
-        4, // 0x24 '$'
-        0x40,0x60,0xc0,0x60,0xc0,0x40,
-
-        4, // 0x25 '%'
-        0xa0,0x20,0x40,0x80,0xa0,0x00,
-
-        4, // 0x26 '&'
-        0xe0,0xa0,0x50,0xa0,0xd0,0x00,
-
-        4, // 0x27 '''
-        0x40,0x40,0x00,0x00,0x00,0x00,
-
-        4, // 0x28 '('
-        0x20,0x40,0x40,0x40,0x20,0x00,
-
-        4, // 0x29 ')'
-        0x40,0x20,0x20,0x20,0x40,0x00,
-
-        4, // 0x2a '*'
-        0xa0,0x40,0xe0,0x40,0xa0,0x00,
-
-        4, // 0x2b '+'
-        0x40,0x40,0xe0,0x40,0x40,0x00,
-
-        4, // 0x2c ','
-        0x00,0x00,0x00,0x40,0x40,0x80,
-
-        4, // 0x2d '-'
-        0x00,0x00,0xe0,0x00,0x00,0x00,
-
-        4, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x40,0x00,
-
-        4, // 0x2f '/'
-        0x10,0x20,0x20,0x40,0x40,0x80,
-
-        4, // 0x30 '0'
-        0xe0,0xa0,0xa0,0xa0,0xe0,0x00,
-
-        4, // 0x31 '1'
-        0x40,0xc0,0x40,0x40,0xe0,0x00,
-
-        4, // 0x32 '2'
-        0xe0,0xa0,0x20,0x40,0xe0,0x00,
-
-        4, // 0x33 '3'
-        0xe0,0x20,0x40,0x20,0xe0,0x00,
-
-        4, // 0x34 '4'
-        0xa0,0xa0,0xe0,0x20,0x20,0x00,
-
-        4, // 0x35 '5'
-        0xe0,0x80,0xc0,0x20,0xc0,0x00,
-
-        4, // 0x36 '6'
-        0x40,0x80,0xe0,0xa0,0xe0,0x00,
-
-        4, // 0x37 '7'
-        0xe0,0xa0,0x20,0x40,0x40,0x00,
-
-        4, // 0x38 '8'
-        0xe0,0xa0,0x40,0xa0,0xe0,0x00,
-
-        4, // 0x39 '9'
-        0xe0,0xa0,0xe0,0x20,0xc0,0x00,
-
-        4, // 0x3a ':'
-        0x00,0x40,0x00,0x40,0x00,0x00,
-
-        4, // 0x3b ';'
-        0x00,0x40,0x00,0x40,0x40,0x80,
-
-        4, // 0x3c '<'
-        0x20,0x40,0x80,0x40,0x20,0x00,
-
-        4, // 0x3d '='
-        0x00,0xe0,0x00,0xe0,0x00,0x00,
-
-        4, // 0x3e '>'
-        0x80,0x40,0x20,0x40,0x80,0x00,
-
-        4, // 0x3f '?'
-        0xc0,0x20,0x40,0x00,0x40,0x00,
-
-        4, // 0x40 '@'
-        0x40,0xa0,0xe0,0xe0,0x80,0x60,
-
-        4, // 0x41 'A'
-        0x40,0xa0,0xe0,0xa0,0xa0,0x00,
-
-        4, // 0x42 'B'
-        0xc0,0xa0,0xc0,0xa0,0xc0,0x00,
-
-        4, // 0x43 'C'
-        0x60,0x80,0x80,0x80,0x60,0x00,
-
-        4, // 0x44 'D'
-        0xc0,0xa0,0xa0,0xa0,0xc0,0x00,
-
-        4, // 0x45 'E'
-        0xe0,0x80,0xc0,0x80,0xe0,0x00,
-
-        4, // 0x46 'F'
-        0xe0,0x80,0xc0,0x80,0x80,0x00,
-
-        4, // 0x47 'G'
-        0x60,0x80,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x48 'H'
-        0xa0,0xa0,0xe0,0xa0,0xa0,0x00,
-
-        4, // 0x49 'I'
-        0xe0,0x40,0x40,0x40,0xe0,0x00,
-
-        4, // 0x4a 'J'
-        0x20,0x20,0x20,0x20,0xa0,0x40,
-
-        4, // 0x4b 'K'
-        0xa0,0xa0,0xc0,0xc0,0xa0,0x00,
-
-        4, // 0x4c 'L'
-        0x80,0x80,0x80,0x80,0xe0,0x00,
-
-        4, // 0x4d 'M'
-        0xa0,0xe0,0xa0,0xa0,0xa0,0x00,
-
-        4, // 0x4e 'N'
-        0x90,0xd0,0xb0,0x90,0x90,0x00,
-
-        4, // 0x4f 'O'
-        0x40,0xa0,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x50 'P'
-        0xc0,0xa0,0xa0,0xc0,0x80,0x00,
-
-        4, // 0x51 'Q'
-        0x40,0xa0,0xa0,0xa0,0x60,0x00,
-
-        4, // 0x52 'R'
-        0xc0,0xa0,0xa0,0xc0,0xa0,0x00,
-
-        4, // 0x53 'S'
-        0x60,0x80,0x40,0x20,0xc0,0x00,
-
-        4, // 0x54 'T'
-        0xe0,0x40,0x40,0x40,0x40,0x00,
-
-        4, // 0x55 'U'
-        0xa0,0xa0,0xa0,0xa0,0xe0,0x00,
-
-        4, // 0x56 'V'
-        0xa0,0xa0,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x57 'W'
-        0xa0,0xa0,0xa0,0xe0,0xa0,0x00,
-
-        4, // 0x58 'X'
-        0xa0,0xa0,0x40,0xa0,0xa0,0x00,
-
-        4, // 0x59 'Y'
-        0xa0,0xa0,0x40,0x40,0x40,0x00,
-
-        4, // 0x5a 'Z'
-        0xe0,0x20,0x40,0x80,0xe0,0x00,
-
-        4, // 0x5b '['
-        0xc0,0x80,0x80,0x80,0xc0,0x00,
-
-        4, // 0x5c '\'
-        0x80,0x40,0x40,0x20,0x20,0x10,
-
-        4, // 0x5d ']'
-        0xc0,0x40,0x40,0x40,0xc0,0x00,
-
-        4, // 0x5e '^'
-        0x40,0xa0,0x00,0x00,0x00,0x00,
-
-        4, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0xf0,
-
-        4, // 0x60 '`'
-        0x40,0x20,0x00,0x00,0x00,0x00,
-
-        4, // 0x61 'a'
-        0x00,0x60,0xa0,0xa0,0x70,0x00,
-
-        4, // 0x62 'b'
-        0x80,0x80,0xc0,0xa0,0xc0,0x00,
-
-        4, // 0x63 'c'
-        0x00,0x60,0x80,0x80,0x60,0x00,
-
-        4, // 0x64 'd'
-        0x20,0x20,0x60,0xa0,0x60,0x00,
-
-        4, // 0x65 'e'
-        0x00,0x40,0xe0,0x80,0x60,0x00,
-
-        4, // 0x66 'f'
-        0x20,0x40,0xe0,0x40,0x40,0x00,
-
-        4, // 0x67 'g'
-        0x00,0x60,0xa0,0x60,0x20,0xc0,
-
-        4, // 0x68 'h'
-        0x80,0x80,0xc0,0xa0,0xa0,0x00,
-
-        4, // 0x69 'i'
-        0x40,0x00,0xc0,0x40,0xe0,0x00,
-
-        4, // 0x6a 'j'
-        0x40,0x00,0xc0,0x40,0x40,0x80,
-
-        4, // 0x6b 'k'
-        0x80,0x80,0xa0,0xc0,0xa0,0x00,
-
-        4, // 0x6c 'l'
-        0xc0,0x40,0x40,0x40,0xe0,0x00,
-
-        4, // 0x6d 'm'
-        0x00,0xa0,0xf0,0xf0,0x90,0x00,
-
-        4, // 0x6e 'n'
-        0x00,0xc0,0xa0,0xa0,0xa0,0x00,
-
-        4, // 0x6f 'o'
-        0x00,0x40,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x70 'p'
-        0x00,0xc0,0xa0,0xc0,0x80,0x80,
-
-        4, // 0x71 'q'
-        0x00,0x60,0xa0,0x60,0x20,0x20,
-
-        4, // 0x72 'r'
-        0x00,0xa0,0x50,0x40,0x40,0x00,
-
-        4, // 0x73 's'
-        0x00,0x60,0xc0,0x20,0xc0,0x00,
-
-        4, // 0x74 't'
-        0x40,0x40,0xe0,0x40,0x60,0x00,
-
-        4, // 0x75 'u'
-        0x00,0xa0,0xa0,0xa0,0x60,0x00,
-
-        4, // 0x76 'v'
-        0x00,0xa0,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x77 'w'
-        0x00,0xa0,0xa0,0xe0,0xa0,0x00,
-
-        4, // 0x78 'x'
-        0x00,0xa0,0x40,0xa0,0xa0,0x00,
-
-        4, // 0x79 'y'
-        0x00,0xa0,0xa0,0x60,0x20,0xc0,
-
-        4, // 0x7a 'z'
-        0x00,0xe0,0x40,0x80,0xe0,0x00,
-
-        4, // 0x7b '{'
-        0x30,0x20,0xc0,0x20,0x30,0x00,
-
-        4, // 0x7c '|'
-        0x40,0x40,0x00,0x40,0x40,0x40,
-
-        4, // 0x7d '}'
-        0xc0,0x40,0x30,0x40,0xc0,0x00,
-
-        4, // 0x7e '~'
-        0x50,0xa0,0x00,0x00,0x00,0x00,
-
-        4, // 0x7f ''
-        0x00,0x60,0x90,0xf0,0x00,0x00,
-        0
-    };
-
-    const int8u gse4x8[] = 
-    {
-        8, 0, 32, 128-32,
-
-        0x00,0x00,0x09,0x00,0x12,0x00,0x1b,0x00,0x24,0x00,0x2d,0x00,0x36,0x00,0x3f,0x00,0x48,0x00,
-        0x51,0x00,0x5a,0x00,0x63,0x00,0x6c,0x00,0x75,0x00,0x7e,0x00,0x87,0x00,0x90,0x00,0x99,0x00,
-        0xa2,0x00,0xab,0x00,0xb4,0x00,0xbd,0x00,0xc6,0x00,0xcf,0x00,0xd8,0x00,0xe1,0x00,0xea,0x00,
-        0xf3,0x00,0xfc,0x00,0x05,0x01,0x0e,0x01,0x17,0x01,0x20,0x01,0x29,0x01,0x32,0x01,0x3b,0x01,
-        0x44,0x01,0x4d,0x01,0x56,0x01,0x5f,0x01,0x68,0x01,0x71,0x01,0x7a,0x01,0x83,0x01,0x8c,0x01,
-        0x95,0x01,0x9e,0x01,0xa7,0x01,0xb0,0x01,0xb9,0x01,0xc2,0x01,0xcb,0x01,0xd4,0x01,0xdd,0x01,
-        0xe6,0x01,0xef,0x01,0xf8,0x01,0x01,0x02,0x0a,0x02,0x13,0x02,0x1c,0x02,0x25,0x02,0x2e,0x02,
-        0x37,0x02,0x40,0x02,0x49,0x02,0x52,0x02,0x5b,0x02,0x64,0x02,0x6d,0x02,0x76,0x02,0x7f,0x02,
-        0x88,0x02,0x91,0x02,0x9a,0x02,0xa3,0x02,0xac,0x02,0xb5,0x02,0xbe,0x02,0xc7,0x02,0xd0,0x02,
-        0xd9,0x02,0xe2,0x02,0xeb,0x02,0xf4,0x02,0xfd,0x02,0x06,0x03,0x0f,0x03,0x18,0x03,0x21,0x03,
-        0x2a,0x03,0x33,0x03,0x3c,0x03,0x45,0x03,0x4e,0x03,0x57,0x03,
-
-        4, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x00,0x40,0x40,0x40,0x40,0x00,0x40,0x00,
-
-        4, // 0x22 '"'
-        0x00,0xa0,0xa0,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x23 '#'
-        0x60,0x60,0xf0,0x60,0x60,0xf0,0x60,0x60,
-
-        4, // 0x24 '$'
-        0x40,0x60,0xc0,0xc0,0x60,0x60,0xc0,0x40,
-
-        4, // 0x25 '%'
-        0x00,0xa0,0x20,0x40,0x40,0x80,0xa0,0x00,
-
-        4, // 0x26 '&'
-        0x00,0x40,0xa0,0xa0,0x40,0xb0,0xa0,0x70,
-
-        4, // 0x27 '''
-        0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x28 '('
-        0x20,0x40,0x80,0x80,0x80,0x80,0x40,0x20,
-
-        4, // 0x29 ')'
-        0x80,0x40,0x20,0x20,0x20,0x20,0x40,0x80,
-
-        4, // 0x2a '*'
-        0x00,0xa0,0x40,0xe0,0x40,0xa0,0x00,0x00,
-
-        4, // 0x2b '+'
-        0x00,0x40,0x40,0xe0,0x40,0x40,0x00,0x00,
-
-        4, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x80,
-
-        4, // 0x2d '-'
-        0x00,0x00,0x00,0xe0,0x00,0x00,0x00,0x00,
-
-        4, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,
-
-        4, // 0x2f '/'
-        0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,
-
-        4, // 0x30 '0'
-        0x00,0xe0,0xa0,0xa0,0xa0,0xa0,0xe0,0x00,
-
-        4, // 0x31 '1'
-        0x00,0x40,0xc0,0x40,0x40,0x40,0xe0,0x00,
-
-        4, // 0x32 '2'
-        0x00,0xe0,0xa0,0x20,0x40,0x80,0xe0,0x00,
-
-        4, // 0x33 '3'
-        0x00,0xe0,0x20,0x40,0x20,0x20,0xe0,0x00,
-
-        4, // 0x34 '4'
-        0x00,0x60,0xa0,0xa0,0xf0,0x20,0x20,0x00,
-
-        4, // 0x35 '5'
-        0x00,0xe0,0x80,0xc0,0x20,0x20,0xc0,0x00,
-
-        4, // 0x36 '6'
-        0x00,0x40,0x80,0xe0,0xa0,0xa0,0xe0,0x00,
-
-        4, // 0x37 '7'
-        0x00,0xe0,0xa0,0x20,0x40,0x40,0x40,0x00,
-
-        4, // 0x38 '8'
-        0x00,0xe0,0xa0,0x40,0xa0,0xa0,0xe0,0x00,
-
-        4, // 0x39 '9'
-        0x00,0xe0,0xa0,0xe0,0x20,0x20,0x40,0x00,
-
-        4, // 0x3a ':'
-        0x00,0x00,0x40,0x00,0x00,0x40,0x00,0x00,
-
-        4, // 0x3b ';'
-        0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x80,
-
-        4, // 0x3c '<'
-        0x00,0x20,0x40,0x80,0x40,0x20,0x00,0x00,
-
-        4, // 0x3d '='
-        0x00,0x00,0xe0,0x00,0xe0,0x00,0x00,0x00,
-
-        4, // 0x3e '>'
-        0x00,0x80,0x40,0x20,0x40,0x80,0x00,0x00,
-
-        4, // 0x3f '?'
-        0x00,0x40,0xa0,0x20,0x40,0x00,0x40,0x00,
-
-        4, // 0x40 '@'
-        0x00,0x40,0xa0,0xe0,0xe0,0x80,0x60,0x00,
-
-        4, // 0x41 'A'
-        0x00,0x40,0xa0,0xa0,0xe0,0xa0,0xa0,0x00,
-
-        4, // 0x42 'B'
-        0x00,0xc0,0xa0,0xc0,0xa0,0xa0,0xc0,0x00,
-
-        4, // 0x43 'C'
-        0x00,0x40,0xa0,0x80,0x80,0xa0,0x40,0x00,
-
-        4, // 0x44 'D'
-        0x00,0xc0,0xa0,0xa0,0xa0,0xa0,0xc0,0x00,
-
-        4, // 0x45 'E'
-        0x00,0xe0,0x80,0xc0,0x80,0x80,0xe0,0x00,
-
-        4, // 0x46 'F'
-        0x00,0xe0,0x80,0xc0,0x80,0x80,0x80,0x00,
-
-        4, // 0x47 'G'
-        0x00,0x60,0x80,0xa0,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x48 'H'
-        0x00,0xa0,0xa0,0xe0,0xa0,0xa0,0xa0,0x00,
-
-        4, // 0x49 'I'
-        0x00,0xe0,0x40,0x40,0x40,0x40,0xe0,0x00,
-
-        4, // 0x4a 'J'
-        0x00,0x20,0x20,0x20,0x20,0xa0,0x40,0x00,
-
-        4, // 0x4b 'K'
-        0x00,0xa0,0xa0,0xc0,0xc0,0xa0,0xa0,0x00,
-
-        4, // 0x4c 'L'
-        0x00,0x80,0x80,0x80,0x80,0x80,0xe0,0x00,
-
-        4, // 0x4d 'M'
-        0x00,0xa0,0xe0,0xa0,0xa0,0xa0,0xa0,0x00,
-
-        4, // 0x4e 'N'
-        0x00,0x90,0x90,0xd0,0xb0,0x90,0x90,0x00,
-
-        4, // 0x4f 'O'
-        0x00,0x40,0xa0,0xa0,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x50 'P'
-        0x00,0xc0,0xa0,0xa0,0xc0,0x80,0x80,0x00,
-
-        4, // 0x51 'Q'
-        0x00,0x40,0xa0,0xa0,0xa0,0xa0,0x60,0x00,
-
-        4, // 0x52 'R'
-        0x00,0xc0,0xa0,0xa0,0xc0,0xc0,0xa0,0x00,
-
-        4, // 0x53 'S'
-        0x00,0x60,0x80,0x40,0x20,0x20,0xc0,0x00,
-
-        4, // 0x54 'T'
-        0x00,0xe0,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        4, // 0x55 'U'
-        0x00,0xa0,0xa0,0xa0,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x56 'V'
-        0x00,0xa0,0xa0,0xa0,0xa0,0x40,0x40,0x00,
-
-        4, // 0x57 'W'
-        0x00,0xa0,0xa0,0xa0,0xa0,0xe0,0xa0,0x00,
-
-        4, // 0x58 'X'
-        0x00,0xa0,0xa0,0x40,0xa0,0xa0,0xa0,0x00,
-
-        4, // 0x59 'Y'
-        0x00,0xa0,0xa0,0x40,0x40,0x40,0x40,0x00,
-
-        4, // 0x5a 'Z'
-        0x00,0xe0,0x20,0x40,0x40,0x80,0xe0,0x00,
-
-        4, // 0x5b '['
-        0xc0,0x80,0x80,0x80,0x80,0x80,0x80,0xc0,
-
-        4, // 0x5c '\'
-        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,
-
-        4, // 0x5d ']'
-        0xc0,0x40,0x40,0x40,0x40,0x40,0x40,0xc0,
-
-        4, // 0x5e '^'
-        0x00,0x40,0xa0,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,
-
-        4, // 0x60 '`'
-        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x61 'a'
-        0x00,0x00,0x60,0xa0,0xa0,0xa0,0x70,0x00,
-
-        4, // 0x62 'b'
-        0x00,0x80,0x80,0xc0,0xa0,0xa0,0xc0,0x00,
-
-        4, // 0x63 'c'
-        0x00,0x00,0x40,0xa0,0x80,0xa0,0x40,0x00,
-
-        4, // 0x64 'd'
-        0x00,0x20,0x20,0x60,0xa0,0xa0,0x60,0x00,
-
-        4, // 0x65 'e'
-        0x00,0x00,0x40,0xa0,0xe0,0x80,0x60,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x20,0x40,0x40,0xe0,0x40,0x40,0x00,
-
-        4, // 0x67 'g'
-        0x00,0x00,0x60,0xa0,0xa0,0x60,0x20,0xc0,
-
-        4, // 0x68 'h'
-        0x00,0x80,0x80,0xc0,0xa0,0xa0,0xa0,0x00,
-
-        4, // 0x69 'i'
-        0x00,0x40,0x00,0xc0,0x40,0x40,0xe0,0x00,
-
-        4, // 0x6a 'j'
-        0x00,0x40,0x00,0xc0,0x40,0x40,0x40,0x80,
-
-        4, // 0x6b 'k'
-        0x00,0x80,0x80,0xa0,0xc0,0xc0,0xa0,0x00,
-
-        4, // 0x6c 'l'
-        0x00,0xc0,0x40,0x40,0x40,0x40,0xe0,0x00,
-
-        4, // 0x6d 'm'
-        0x00,0x00,0xa0,0xf0,0xf0,0xf0,0x90,0x00,
-
-        4, // 0x6e 'n'
-        0x00,0x00,0xc0,0xa0,0xa0,0xa0,0xa0,0x00,
-
-        4, // 0x6f 'o'
-        0x00,0x00,0x40,0xa0,0xa0,0xa0,0x40,0x00,
-
-        4, // 0x70 'p'
-        0x00,0x00,0xc0,0xa0,0xa0,0xc0,0x80,0x80,
-
-        4, // 0x71 'q'
-        0x00,0x00,0x60,0xa0,0xa0,0x60,0x20,0x20,
-
-        4, // 0x72 'r'
-        0x00,0x00,0xa0,0x50,0x40,0x40,0x40,0x00,
-
-        4, // 0x73 's'
-        0x00,0x00,0x60,0x80,0x40,0x20,0xc0,0x00,
-
-        4, // 0x74 't'
-        0x00,0x40,0x40,0xe0,0x40,0x40,0x20,0x00,
-
-        4, // 0x75 'u'
-        0x00,0x00,0xa0,0xa0,0xa0,0xa0,0x60,0x00,
-
-        4, // 0x76 'v'
-        0x00,0x00,0xa0,0xa0,0xa0,0x40,0x40,0x00,
-
-        4, // 0x77 'w'
-        0x00,0x00,0xa0,0xa0,0xa0,0xe0,0xa0,0x00,
-
-        4, // 0x78 'x'
-        0x00,0x00,0xa0,0xa0,0x40,0xa0,0xa0,0x00,
-
-        4, // 0x79 'y'
-        0x00,0x00,0xa0,0xa0,0xa0,0x60,0x20,0xc0,
-
-        4, // 0x7a 'z'
-        0x00,0x00,0xe0,0x20,0x40,0x80,0xe0,0x00,
-
-        4, // 0x7b '{'
-        0x10,0x20,0x20,0xc0,0x20,0x20,0x10,0x00,
-
-        4, // 0x7c '|'
-        0x00,0x40,0x40,0x40,0x00,0x40,0x40,0x40,
-
-        4, // 0x7d '}'
-        0x80,0x40,0x40,0x30,0x40,0x40,0x80,0x00,
-
-        4, // 0x7e '~'
-        0x00,0x50,0xa0,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x7f ''
-        0x00,0x00,0x00,0x60,0x90,0xf0,0x00,0x00,
-        0
-    };
-
-    const int8u gse5x7[] = 
-    {
-        7, 0, 32, 128-32,
-
-        0x00,0x00,0x08,0x00,0x10,0x00,0x18,0x00,0x20,0x00,0x28,0x00,0x30,0x00,0x38,0x00,0x40,0x00,
-        0x48,0x00,0x50,0x00,0x58,0x00,0x60,0x00,0x68,0x00,0x70,0x00,0x78,0x00,0x80,0x00,0x88,0x00,
-        0x90,0x00,0x98,0x00,0xa0,0x00,0xa8,0x00,0xb0,0x00,0xb8,0x00,0xc0,0x00,0xc8,0x00,0xd0,0x00,
-        0xd8,0x00,0xe0,0x00,0xe8,0x00,0xf0,0x00,0xf8,0x00,0x00,0x01,0x08,0x01,0x10,0x01,0x18,0x01,
-        0x20,0x01,0x28,0x01,0x30,0x01,0x38,0x01,0x40,0x01,0x48,0x01,0x50,0x01,0x58,0x01,0x60,0x01,
-        0x68,0x01,0x70,0x01,0x78,0x01,0x80,0x01,0x88,0x01,0x90,0x01,0x98,0x01,0xa0,0x01,0xa8,0x01,
-        0xb0,0x01,0xb8,0x01,0xc0,0x01,0xc8,0x01,0xd0,0x01,0xd8,0x01,0xe0,0x01,0xe8,0x01,0xf0,0x01,
-        0xf8,0x01,0x00,0x02,0x08,0x02,0x10,0x02,0x18,0x02,0x20,0x02,0x28,0x02,0x30,0x02,0x38,0x02,
-        0x40,0x02,0x48,0x02,0x50,0x02,0x58,0x02,0x60,0x02,0x68,0x02,0x70,0x02,0x78,0x02,0x80,0x02,
-        0x88,0x02,0x90,0x02,0x98,0x02,0xa0,0x02,0xa8,0x02,0xb0,0x02,0xb8,0x02,0xc0,0x02,0xc8,0x02,
-        0xd0,0x02,0xd8,0x02,0xe0,0x02,0xe8,0x02,0xf0,0x02,0xf8,0x02,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x00,0x20,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x50,0x50,0x00,0x00,0x00,0x00,
-
-        5, // 0x23 '#'
-        0x00,0x50,0xf8,0x50,0xf8,0x50,0x00,
-
-        5, // 0x24 '$'
-        0x20,0x78,0xa0,0x70,0x28,0xf0,0x20,
-
-        5, // 0x25 '%'
-        0x00,0x88,0x10,0x20,0x40,0x88,0x00,
-
-        5, // 0x26 '&'
-        0x00,0x40,0xa0,0x68,0x90,0x68,0x00,
-
-        5, // 0x27 '''
-        0x00,0x20,0x20,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x10,0x20,0x40,0x40,0x40,0x20,0x10,
-
-        5, // 0x29 ')'
-        0x80,0x40,0x20,0x20,0x20,0x40,0x80,
-
-        5, // 0x2a '*'
-        0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,
-
-        5, // 0x2b '+'
-        0x00,0x20,0x20,0xf8,0x20,0x20,0x00,
-
-        5, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x20,0x20,0x40,
-
-        5, // 0x2d '-'
-        0x00,0x00,0x00,0xf0,0x00,0x00,0x00,
-
-        5, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x40,0x00,
-
-        5, // 0x2f '/'
-        0x00,0x08,0x10,0x20,0x40,0x80,0x00,
-
-        5, // 0x30 '0'
-        0x00,0x60,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x70,0x00,
-
-        5, // 0x32 '2'
-        0x00,0x60,0x90,0x20,0x40,0xf0,0x00,
-
-        5, // 0x33 '3'
-        0x00,0xf0,0x20,0x60,0x10,0xe0,0x00,
-
-        5, // 0x34 '4'
-        0x00,0x30,0x50,0x90,0xf0,0x10,0x00,
-
-        5, // 0x35 '5'
-        0x00,0xf0,0x80,0xe0,0x10,0xe0,0x00,
-
-        5, // 0x36 '6'
-        0x00,0x60,0x80,0xe0,0x90,0x60,0x00,
-
-        5, // 0x37 '7'
-        0x00,0xf0,0x90,0x20,0x40,0x40,0x00,
-
-        5, // 0x38 '8'
-        0x00,0x60,0x90,0x60,0x90,0x60,0x00,
-
-        5, // 0x39 '9'
-        0x00,0x60,0x90,0x70,0x10,0x60,0x00,
-
-        5, // 0x3a ':'
-        0x00,0x00,0x20,0x00,0x20,0x00,0x00,
-
-        5, // 0x3b ';'
-        0x00,0x00,0x20,0x00,0x20,0x20,0x40,
-
-        5, // 0x3c '<'
-        0x00,0x10,0x20,0x40,0x20,0x10,0x00,
-
-        5, // 0x3d '='
-        0x00,0x00,0xf0,0x00,0xf0,0x00,0x00,
-
-        5, // 0x3e '>'
-        0x00,0x80,0x40,0x20,0x40,0x80,0x00,
-
-        5, // 0x3f '?'
-        0x00,0x60,0x90,0x20,0x00,0x20,0x00,
-
-        5, // 0x40 '@'
-        0x00,0x60,0x90,0xb0,0x80,0x70,0x00,
-
-        5, // 0x41 'A'
-        0x00,0x60,0x90,0xf0,0x90,0x90,0x00,
-
-        5, // 0x42 'B'
-        0x00,0xe0,0x90,0xe0,0x90,0xe0,0x00,
-
-        5, // 0x43 'C'
-        0x00,0x60,0x90,0x80,0x90,0x60,0x00,
-
-        5, // 0x44 'D'
-        0x00,0xe0,0x90,0x90,0x90,0xe0,0x00,
-
-        5, // 0x45 'E'
-        0x00,0xf0,0x80,0xe0,0x80,0xf0,0x00,
-
-        5, // 0x46 'F'
-        0x00,0xf0,0x80,0xe0,0x80,0x80,0x00,
-
-        5, // 0x47 'G'
-        0x00,0x70,0x80,0xb0,0x90,0x60,0x00,
-
-        5, // 0x48 'H'
-        0x00,0x90,0x90,0xf0,0x90,0x90,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x4a 'J'
-        0x00,0x70,0x20,0x20,0xa0,0x40,0x00,
-
-        5, // 0x4b 'K'
-        0x00,0x90,0xa0,0xc0,0xa0,0x90,0x00,
-
-        5, // 0x4c 'L'
-        0x00,0x80,0x80,0x80,0x80,0xf0,0x00,
-
-        5, // 0x4d 'M'
-        0x00,0x90,0xf0,0x90,0x90,0x90,0x00,
-
-        5, // 0x4e 'N'
-        0x00,0x90,0xd0,0xb0,0x90,0x90,0x00,
-
-        5, // 0x4f 'O'
-        0x00,0x60,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x50 'P'
-        0x00,0xe0,0x90,0xe0,0x80,0x80,0x00,
-
-        5, // 0x51 'Q'
-        0x00,0x60,0x90,0x90,0xa0,0x50,0x00,
-
-        5, // 0x52 'R'
-        0x00,0xe0,0x90,0xe0,0xa0,0x90,0x00,
-
-        5, // 0x53 'S'
-        0x00,0x70,0x80,0x60,0x10,0xe0,0x00,
-
-        5, // 0x54 'T'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x55 'U'
-        0x00,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x56 'V'
-        0x00,0x50,0x50,0x50,0x20,0x20,0x00,
-
-        5, // 0x57 'W'
-        0x00,0x90,0x90,0x90,0xf0,0x90,0x00,
-
-        5, // 0x58 'X'
-        0x00,0x90,0x90,0x60,0x90,0x90,0x00,
-
-        5, // 0x59 'Y'
-        0x00,0x50,0x50,0x20,0x20,0x20,0x00,
-
-        5, // 0x5a 'Z'
-        0x00,0xf0,0x10,0x20,0x40,0xf0,0x00,
-
-        5, // 0x5b '['
-        0x70,0x40,0x40,0x40,0x40,0x40,0x70,
-
-        5, // 0x5c '\'
-        0x00,0x80,0x40,0x20,0x10,0x08,0x00,
-
-        5, // 0x5d ']'
-        0xe0,0x20,0x20,0x20,0x20,0x20,0xe0,
-
-        5, // 0x5e '^'
-        0x00,0x20,0x50,0x00,0x00,0x00,0x00,
-
-        5, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0xf8,0x00,
-
-        5, // 0x60 '`'
-        0x00,0x40,0x20,0x00,0x00,0x00,0x00,
-
-        5, // 0x61 'a'
-        0x00,0x00,0x60,0xa0,0xa0,0x50,0x00,
-
-        5, // 0x62 'b'
-        0x00,0x80,0x80,0xe0,0x90,0xe0,0x00,
-
-        5, // 0x63 'c'
-        0x00,0x00,0x70,0x80,0x80,0x70,0x00,
-
-        5, // 0x64 'd'
-        0x00,0x10,0x10,0x70,0x90,0x70,0x00,
-
-        5, // 0x65 'e'
-        0x00,0x00,0x60,0xf0,0x80,0x70,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x30,0x40,0xe0,0x40,0x40,0x00,
-
-        5, // 0x67 'g'
-        0x00,0x00,0x70,0x90,0x70,0x10,0x60,
-
-        5, // 0x68 'h'
-        0x00,0x80,0x80,0xe0,0x90,0x90,0x00,
-
-        5, // 0x69 'i'
-        0x20,0x00,0x60,0x20,0x20,0x70,0x00,
-
-        5, // 0x6a 'j'
-        0x20,0x00,0x60,0x20,0x20,0xa0,0x40,
-
-        5, // 0x6b 'k'
-        0x80,0x80,0x90,0xa0,0xe0,0x90,0x00,
-
-        5, // 0x6c 'l'
-        0x00,0x60,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x6d 'm'
-        0x00,0x00,0xa0,0xf0,0xf0,0x90,0x00,
-
-        5, // 0x6e 'n'
-        0x00,0x00,0xa0,0xd0,0x90,0x90,0x00,
-
-        5, // 0x6f 'o'
-        0x00,0x00,0x60,0x90,0x90,0x60,0x00,
-
-        5, // 0x70 'p'
-        0x00,0x00,0xe0,0x90,0xe0,0x80,0x80,
-
-        5, // 0x71 'q'
-        0x00,0x00,0x70,0x90,0x70,0x10,0x10,
-
-        5, // 0x72 'r'
-        0x00,0x00,0xe0,0x90,0x80,0x80,0x00,
-
-        5, // 0x73 's'
-        0x00,0x00,0x70,0xe0,0x10,0xe0,0x00,
-
-        5, // 0x74 't'
-        0x40,0x40,0xe0,0x40,0x40,0x70,0x00,
-
-        5, // 0x75 'u'
-        0x00,0x00,0x90,0x90,0x90,0x70,0x00,
-
-        5, // 0x76 'v'
-        0x00,0x00,0x50,0x50,0x50,0x20,0x00,
-
-        5, // 0x77 'w'
-        0x00,0x00,0x90,0x90,0xf0,0x90,0x00,
-
-        5, // 0x78 'x'
-        0x00,0x00,0x90,0x60,0x60,0x90,0x00,
-
-        5, // 0x79 'y'
-        0x00,0x00,0x90,0x90,0x70,0x10,0x60,
-
-        5, // 0x7a 'z'
-        0x00,0x00,0xf0,0x20,0x40,0xf0,0x00,
-
-        5, // 0x7b '{'
-        0x10,0x20,0x20,0xc0,0x20,0x20,0x10,
-
-        5, // 0x7c '|'
-        0x20,0x20,0x20,0x00,0x20,0x20,0x20,
-
-        5, // 0x7d '}'
-        0x40,0x20,0x20,0x18,0x20,0x20,0x40,
-
-        5, // 0x7e '~'
-        0x00,0x40,0xa8,0x10,0x00,0x00,0x00,
-
-        5, // 0x7f ''
-        0x00,0x00,0x20,0x50,0x88,0xf8,0x00,
-        0
-    };
-
-    const int8u gse5x9[] = 
-    {
-        9, 0, 32, 128-32,
-
-        0x00,0x00,0x0a,0x00,0x14,0x00,0x1e,0x00,0x28,0x00,0x32,0x00,0x3c,0x00,0x46,0x00,0x50,0x00,
-        0x5a,0x00,0x64,0x00,0x6e,0x00,0x78,0x00,0x82,0x00,0x8c,0x00,0x96,0x00,0xa0,0x00,0xaa,0x00,
-        0xb4,0x00,0xbe,0x00,0xc8,0x00,0xd2,0x00,0xdc,0x00,0xe6,0x00,0xf0,0x00,0xfa,0x00,0x04,0x01,
-        0x0e,0x01,0x18,0x01,0x22,0x01,0x2c,0x01,0x36,0x01,0x40,0x01,0x4a,0x01,0x54,0x01,0x5e,0x01,
-        0x68,0x01,0x72,0x01,0x7c,0x01,0x86,0x01,0x90,0x01,0x9a,0x01,0xa4,0x01,0xae,0x01,0xb8,0x01,
-        0xc2,0x01,0xcc,0x01,0xd6,0x01,0xe0,0x01,0xea,0x01,0xf4,0x01,0xfe,0x01,0x08,0x02,0x12,0x02,
-        0x1c,0x02,0x26,0x02,0x30,0x02,0x3a,0x02,0x44,0x02,0x4e,0x02,0x58,0x02,0x62,0x02,0x6c,0x02,
-        0x76,0x02,0x80,0x02,0x8a,0x02,0x94,0x02,0x9e,0x02,0xa8,0x02,0xb2,0x02,0xbc,0x02,0xc6,0x02,
-        0xd0,0x02,0xda,0x02,0xe4,0x02,0xee,0x02,0xf8,0x02,0x02,0x03,0x0c,0x03,0x16,0x03,0x20,0x03,
-        0x2a,0x03,0x34,0x03,0x3e,0x03,0x48,0x03,0x52,0x03,0x5c,0x03,0x66,0x03,0x70,0x03,0x7a,0x03,
-        0x84,0x03,0x8e,0x03,0x98,0x03,0xa2,0x03,0xac,0x03,0xb6,0x03,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x23 '#'
-        0x00,0x50,0x50,0xf8,0x50,0xf8,0x50,0x50,0x00,
-
-        5, // 0x24 '$'
-        0x00,0x20,0x78,0xa0,0x70,0x28,0xf0,0x20,0x00,
-
-        5, // 0x25 '%'
-        0x00,0xc8,0xc8,0x10,0x20,0x40,0x98,0x98,0x00,
-
-        5, // 0x26 '&'
-        0x00,0x40,0xa0,0xa0,0x40,0xa8,0x90,0x68,0x00,
-
-        5, // 0x27 '''
-        0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x10,
-
-        5, // 0x29 ')'
-        0x80,0x40,0x20,0x20,0x20,0x20,0x20,0x40,0x80,
-
-        5, // 0x2a '*'
-        0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,
-
-        5, // 0x2b '+'
-        0x00,0x00,0x20,0x20,0xf8,0x20,0x20,0x00,0x00,
-
-        5, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x40,
-
-        5, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0xf0,0x00,0x00,0x00,0x00,
-
-        5, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,
-
-        5, // 0x2f '/'
-        0x00,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,
-
-        5, // 0x30 '0'
-        0x00,0x60,0x90,0xb0,0xd0,0x90,0x90,0x60,0x00,
-
-        5, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x32 '2'
-        0x00,0x60,0x90,0x10,0x20,0x40,0x80,0xf0,0x00,
-
-        5, // 0x33 '3'
-        0x00,0xf0,0x10,0x20,0x60,0x10,0x90,0x60,0x00,
-
-        5, // 0x34 '4'
-        0x00,0x30,0x50,0x90,0x90,0xf8,0x10,0x10,0x00,
-
-        5, // 0x35 '5'
-        0x00,0xf0,0x80,0xe0,0x10,0x10,0x10,0xe0,0x00,
-
-        5, // 0x36 '6'
-        0x00,0x60,0x80,0xe0,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x37 '7'
-        0x00,0xf0,0x90,0x10,0x20,0x40,0x40,0x40,0x00,
-
-        5, // 0x38 '8'
-        0x00,0x60,0x90,0x90,0x60,0x90,0x90,0x60,0x00,
-
-        5, // 0x39 '9'
-        0x00,0x60,0x90,0x90,0x70,0x10,0x90,0x60,0x00,
-
-        5, // 0x3a ':'
-        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x00,0x00,
-
-        5, // 0x3b ';'
-        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x20,0x40,
-
-        5, // 0x3c '<'
-        0x00,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x00,
-
-        5, // 0x3d '='
-        0x00,0x00,0x00,0xf0,0x00,0xf0,0x00,0x00,0x00,
-
-        5, // 0x3e '>'
-        0x00,0x80,0x40,0x20,0x10,0x20,0x40,0x80,0x00,
-
-        5, // 0x3f '?'
-        0x00,0x60,0x90,0x10,0x20,0x20,0x00,0x20,0x00,
-
-        5, // 0x40 '@'
-        0x00,0x60,0x90,0xb0,0xb0,0xb0,0x80,0x70,0x00,
-
-        5, // 0x41 'A'
-        0x00,0x60,0x90,0x90,0xf0,0x90,0x90,0x90,0x00,
-
-        5, // 0x42 'B'
-        0x00,0xe0,0x90,0x90,0xe0,0x90,0x90,0xe0,0x00,
-
-        5, // 0x43 'C'
-        0x00,0x60,0x90,0x80,0x80,0x80,0x90,0x60,0x00,
-
-        5, // 0x44 'D'
-        0x00,0xe0,0x90,0x90,0x90,0x90,0x90,0xe0,0x00,
-
-        5, // 0x45 'E'
-        0x00,0xf0,0x80,0x80,0xe0,0x80,0x80,0xf0,0x00,
-
-        5, // 0x46 'F'
-        0x00,0xf0,0x80,0x80,0xe0,0x80,0x80,0x80,0x00,
-
-        5, // 0x47 'G'
-        0x00,0x60,0x90,0x80,0xb0,0x90,0x90,0x60,0x00,
-
-        5, // 0x48 'H'
-        0x00,0x90,0x90,0x90,0xf0,0x90,0x90,0x90,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x4a 'J'
-        0x00,0x70,0x20,0x20,0x20,0x20,0xa0,0x40,0x00,
-
-        5, // 0x4b 'K'
-        0x00,0x90,0x90,0xa0,0xc0,0xa0,0x90,0x90,0x00,
-
-        5, // 0x4c 'L'
-        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xf0,0x00,
-
-        5, // 0x4d 'M'
-        0x00,0x90,0xf0,0x90,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x4e 'N'
-        0x00,0x90,0x90,0xd0,0xb0,0x90,0x90,0x90,0x00,
-
-        5, // 0x4f 'O'
-        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x50 'P'
-        0x00,0xe0,0x90,0x90,0xe0,0x80,0x80,0x80,0x00,
-
-        5, // 0x51 'Q'
-        0x00,0x60,0x90,0x90,0x90,0x90,0xa0,0x50,0x00,
-
-        5, // 0x52 'R'
-        0x00,0xe0,0x90,0x90,0xe0,0xa0,0x90,0x90,0x00,
-
-        5, // 0x53 'S'
-        0x00,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x00,
-
-        5, // 0x54 'T'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x55 'U'
-        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x56 'V'
-        0x00,0x50,0x50,0x50,0x50,0x50,0x20,0x20,0x00,
-
-        5, // 0x57 'W'
-        0x00,0x90,0x90,0x90,0x90,0x90,0xf0,0x90,0x00,
-
-        5, // 0x58 'X'
-        0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,
-
-        5, // 0x59 'Y'
-        0x00,0x50,0x50,0x50,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x5a 'Z'
-        0x00,0xf0,0x10,0x10,0x20,0x40,0x80,0xf0,0x00,
-
-        5, // 0x5b '['
-        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,
-
-        5, // 0x5c '\'
-        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x00,
-
-        5, // 0x5d ']'
-        0xe0,0x20,0x20,0x20,0x20,0x20,0x20,0xe0,0x00,
-
-        5, // 0x5e '^'
-        0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,
-
-        5, // 0x60 '`'
-        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x61 'a'
-        0x00,0x00,0x60,0x10,0x70,0x90,0x90,0x70,0x00,
-
-        5, // 0x62 'b'
-        0x00,0x80,0x80,0xe0,0x90,0x90,0x90,0xe0,0x00,
-
-        5, // 0x63 'c'
-        0x00,0x00,0x60,0x90,0x80,0x80,0x90,0x60,0x00,
-
-        5, // 0x64 'd'
-        0x00,0x10,0x10,0x70,0x90,0x90,0x90,0x70,0x00,
-
-        5, // 0x65 'e'
-        0x00,0x00,0x60,0x90,0xf0,0x80,0x80,0x70,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x30,0x40,0x40,0xe0,0x40,0x40,0x40,0x00,
-
-        5, // 0x67 'g'
-        0x00,0x00,0x70,0x90,0x90,0x70,0x10,0x90,0x60,
-
-        5, // 0x68 'h'
-        0x00,0x80,0x80,0xe0,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x69 'i'
-        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x6a 'j'
-        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0xa0,0x40,
-
-        5, // 0x6b 'k'
-        0x00,0x80,0x80,0x90,0xa0,0xc0,0xa0,0x90,0x00,
-
-        5, // 0x6c 'l'
-        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x6d 'm'
-        0x00,0x00,0xa0,0xf0,0xf0,0xf0,0x90,0x90,0x00,
-
-        5, // 0x6e 'n'
-        0x00,0x00,0xa0,0xd0,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x6f 'o'
-        0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x70 'p'
-        0x00,0x00,0xe0,0x90,0x90,0x90,0xe0,0x80,0x80,
-
-        5, // 0x71 'q'
-        0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0x10,
-
-        5, // 0x72 'r'
-        0x00,0x00,0xe0,0x90,0x80,0x80,0x80,0x80,0x00,
-
-        5, // 0x73 's'
-        0x00,0x00,0x60,0x90,0x40,0x20,0x90,0x60,0x00,
-
-        5, // 0x74 't'
-        0x00,0x40,0x40,0xe0,0x40,0x40,0x50,0x20,0x00,
-
-        5, // 0x75 'u'
-        0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x00,
-
-        5, // 0x76 'v'
-        0x00,0x00,0x50,0x50,0x50,0x50,0x20,0x20,0x00,
-
-        5, // 0x77 'w'
-        0x00,0x00,0x90,0x90,0x90,0x90,0xf0,0x90,0x00,
-
-        5, // 0x78 'x'
-        0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x00,
-
-        5, // 0x79 'y'
-        0x00,0x00,0x90,0x90,0x90,0x90,0x70,0x10,0xe0,
-
-        5, // 0x7a 'z'
-        0x00,0x00,0xf0,0x10,0x20,0x40,0x80,0xf0,0x00,
-
-        5, // 0x7b '{'
-        0x10,0x20,0x20,0x20,0xc0,0x20,0x20,0x20,0x10,
-
-        5, // 0x7c '|'
-        0x00,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00,
-
-        5, // 0x7d '}'
-        0x80,0x40,0x40,0x40,0x30,0x40,0x40,0x40,0x80,
-
-        5, // 0x7e '~'
-        0x00,0x40,0xa8,0x10,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x7f ''
-        0x00,0x00,0x00,0x20,0x50,0x88,0xf8,0x00,0x00,
-        0
-    };
-
-    const int8u gse6x12[] = 
-    {
-        12, 0, 32, 128-32,
-
-        0x00,0x00,0x0d,0x00,0x1a,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4e,0x00,0x5b,0x00,0x68,0x00,
-        0x75,0x00,0x82,0x00,0x8f,0x00,0x9c,0x00,0xa9,0x00,0xb6,0x00,0xc3,0x00,0xd0,0x00,0xdd,0x00,
-        0xea,0x00,0xf7,0x00,0x04,0x01,0x11,0x01,0x1e,0x01,0x2b,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
-        0x5f,0x01,0x6c,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xa0,0x01,0xad,0x01,0xba,0x01,0xc7,0x01,
-        0xd4,0x01,0xe1,0x01,0xee,0x01,0xfb,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2f,0x02,0x3c,0x02,
-        0x49,0x02,0x56,0x02,0x63,0x02,0x70,0x02,0x7d,0x02,0x8a,0x02,0x97,0x02,0xa4,0x02,0xb1,0x02,
-        0xbe,0x02,0xcb,0x02,0xd8,0x02,0xe5,0x02,0xf2,0x02,0xff,0x02,0x0c,0x03,0x19,0x03,0x26,0x03,
-        0x33,0x03,0x40,0x03,0x4d,0x03,0x5a,0x03,0x67,0x03,0x74,0x03,0x81,0x03,0x8e,0x03,0x9b,0x03,
-        0xa8,0x03,0xb5,0x03,0xc2,0x03,0xcf,0x03,0xdc,0x03,0xe9,0x03,0xf6,0x03,0x03,0x04,0x10,0x04,
-        0x1d,0x04,0x2a,0x04,0x37,0x04,0x44,0x04,0x51,0x04,0x5e,0x04,0x6b,0x04,0x78,0x04,0x85,0x04,
-        0x92,0x04,0x9f,0x04,0xac,0x04,0xb9,0x04,0xc6,0x04,0xd3,0x04,
-
-        6, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        6, // 0x22 '"'
-        0x00,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x23 '#'
-        0x00,0x50,0x50,0xf8,0x50,0x50,0x50,0xf8,0x50,0x50,0x00,0x00,
-
-        6, // 0x24 '$'
-        0x00,0x20,0x70,0xa8,0xa0,0x70,0x28,0xa8,0x70,0x20,0x00,0x00,
-
-        6, // 0x25 '%'
-        0x00,0xc8,0xd8,0x10,0x30,0x20,0x60,0x40,0xd8,0x98,0x00,0x00,
-
-        6, // 0x26 '&'
-        0x00,0x60,0x90,0x90,0x90,0x60,0xa8,0x90,0x90,0x68,0x00,0x00,
-
-        6, // 0x27 '''
-        0x00,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x28 '('
-        0x00,0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x10,0x00,0x00,
-
-        6, // 0x29 ')'
-        0x00,0x40,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x40,0x00,0x00,
-
-        6, // 0x2a '*'
-        0x00,0x00,0x00,0x50,0x20,0xf8,0x20,0x50,0x00,0x00,0x00,0x00,
-
-        6, // 0x2b '+'
-        0x00,0x00,0x20,0x20,0x20,0xf8,0x20,0x20,0x20,0x00,0x00,0x00,
-
-        6, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
-
-        6, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0x00,0xf8,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x00,
-
-        6, // 0x2f '/'
-        0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,0x00,
-
-        6, // 0x30 '0'
-        0x00,0x70,0x88,0x88,0x98,0xa8,0xc8,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x31 '1'
-        0x00,0x20,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        6, // 0x32 '2'
-        0x00,0x70,0x88,0x88,0x08,0x10,0x20,0x40,0x80,0xf8,0x00,0x00,
-
-        6, // 0x33 '3'
-        0x00,0xf8,0x10,0x20,0x70,0x08,0x08,0x08,0x88,0x70,0x00,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x10,0x20,0x40,0x90,0x90,0xf8,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x35 '5'
-        0x00,0xf8,0x80,0x80,0xf0,0x08,0x08,0x08,0x88,0x70,0x00,0x00,
-
-        6, // 0x36 '6'
-        0x00,0x70,0x88,0x80,0x80,0xf0,0x88,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x37 '7'
-        0x00,0xf8,0x88,0x08,0x08,0x10,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        6, // 0x38 '8'
-        0x00,0x70,0x88,0x88,0x88,0x70,0x88,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x39 '9'
-        0x00,0x70,0x88,0x88,0x88,0x78,0x08,0x08,0x88,0x70,0x00,0x00,
-
-        6, // 0x3a ':'
-        0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,
-
-        6, // 0x3b ';'
-        0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
-
-        6, // 0x3c '<'
-        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x00,0x00,
-
-        6, // 0x3d '='
-        0x00,0x00,0x00,0x00,0xf8,0x00,0xf8,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x3e '>'
-        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,0x00,0x00,
-
-        6, // 0x3f '?'
-        0x00,0x70,0x88,0x88,0x08,0x10,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        6, // 0x40 '@'
-        0x00,0x70,0x88,0x88,0xb8,0xb8,0xb0,0x80,0x88,0x70,0x00,0x00,
-
-        6, // 0x41 'A'
-        0x00,0x20,0x50,0x88,0x88,0x88,0xf8,0x88,0x88,0x88,0x00,0x00,
-
-        6, // 0x42 'B'
-        0x00,0xf0,0x88,0x88,0x88,0xf0,0x88,0x88,0x88,0xf0,0x00,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x70,0x88,0x88,0x80,0x80,0x80,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x44 'D'
-        0x00,0xe0,0x90,0x88,0x88,0x88,0x88,0x88,0x90,0xe0,0x00,0x00,
-
-        6, // 0x45 'E'
-        0x00,0xf8,0x80,0x80,0x80,0xf0,0x80,0x80,0x80,0xf8,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0xf8,0x80,0x80,0x80,0xf0,0x80,0x80,0x80,0x80,0x00,0x00,
-
-        6, // 0x47 'G'
-        0x00,0x70,0x88,0x80,0x80,0xb8,0x88,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x48 'H'
-        0x00,0x88,0x88,0x88,0x88,0xf8,0x88,0x88,0x88,0x88,0x00,0x00,
-
-        6, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        6, // 0x4a 'J'
-        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x90,0x60,0x00,0x00,
-
-        6, // 0x4b 'K'
-        0x00,0x88,0x88,0x90,0xa0,0xc0,0xa0,0x90,0x88,0x88,0x00,0x00,
-
-        6, // 0x4c 'L'
-        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xf8,0x00,0x00,
-
-        6, // 0x4d 'M'
-        0x00,0x88,0x88,0xd8,0xa8,0x88,0x88,0x88,0x88,0x88,0x00,0x00,
-
-        6, // 0x4e 'N'
-        0x00,0x88,0x88,0xc8,0xa8,0x98,0x88,0x88,0x88,0x88,0x00,0x00,
-
-        6, // 0x4f 'O'
-        0x00,0x70,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x50 'P'
-        0x00,0xf0,0x88,0x88,0x88,0xf0,0x80,0x80,0x80,0x80,0x00,0x00,
-
-        6, // 0x51 'Q'
-        0x00,0x70,0x88,0x88,0x88,0x88,0x88,0xa8,0x90,0x68,0x00,0x00,
-
-        6, // 0x52 'R'
-        0x00,0xf0,0x88,0x88,0x88,0x88,0xf0,0xa0,0x90,0x88,0x00,0x00,
-
-        6, // 0x53 'S'
-        0x00,0x70,0x88,0x80,0x80,0x70,0x08,0x08,0x88,0x70,0x00,0x00,
-
-        6, // 0x54 'T'
-        0x00,0xf8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        6, // 0x55 'U'
-        0x00,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x88,0x88,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,0x00,
-
-        6, // 0x57 'W'
-        0x00,0x88,0x88,0x88,0x88,0x88,0xa8,0xa8,0xd8,0x88,0x00,0x00,
-
-        6, // 0x58 'X'
-        0x00,0x88,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x88,0x00,0x00,
-
-        6, // 0x59 'Y'
-        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        6, // 0x5a 'Z'
-        0x00,0xf8,0x08,0x08,0x10,0x20,0x40,0x80,0x80,0xf8,0x00,0x00,
-
-        6, // 0x5b '['
-        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,
-
-        6, // 0x5c '\'
-        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,0x00,
-
-        6, // 0x5d ']'
-        0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,0x00,
-
-        6, // 0x5e '^'
-        0x00,0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,0x00,
-
-        6, // 0x60 '`'
-        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x61 'a'
-        0x00,0x00,0x00,0x70,0x88,0x08,0x78,0x88,0x88,0x78,0x00,0x00,
-
-        6, // 0x62 'b'
-        0x00,0x80,0x80,0x80,0xf0,0x88,0x88,0x88,0x88,0xf0,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x70,0x88,0x80,0x80,0x80,0x88,0x70,0x00,0x00,
-
-        6, // 0x64 'd'
-        0x00,0x08,0x08,0x08,0x78,0x88,0x88,0x88,0x88,0x78,0x00,0x00,
-
-        6, // 0x65 'e'
-        0x00,0x00,0x00,0x70,0x88,0x88,0xf8,0x80,0x80,0x78,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x18,0x20,0x20,0xf8,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        6, // 0x67 'g'
-        0x00,0x00,0x00,0x78,0x88,0x88,0x88,0x88,0x78,0x08,0x08,0xf0,
-
-        6, // 0x68 'h'
-        0x00,0x80,0x80,0x80,0xf0,0x88,0x88,0x88,0x88,0x88,0x00,0x00,
-
-        6, // 0x69 'i'
-        0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        6, // 0x6a 'j'
-        0x00,0x10,0x00,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x90,0x60,
-
-        6, // 0x6b 'k'
-        0x00,0x80,0x80,0x80,0x88,0x90,0xa0,0xd0,0x88,0x88,0x00,0x00,
-
-        6, // 0x6c 'l'
-        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        6, // 0x6d 'm'
-        0x00,0x00,0x00,0xd0,0xa8,0xa8,0xa8,0xa8,0xa8,0xa8,0x00,0x00,
-
-        6, // 0x6e 'n'
-        0x00,0x00,0x00,0xb0,0xc8,0x88,0x88,0x88,0x88,0x88,0x00,0x00,
-
-        6, // 0x6f 'o'
-        0x00,0x00,0x00,0x70,0x88,0x88,0x88,0x88,0x88,0x70,0x00,0x00,
-
-        6, // 0x70 'p'
-        0x00,0x00,0x00,0xf0,0x88,0x88,0x88,0x88,0xf0,0x80,0x80,0x80,
-
-        6, // 0x71 'q'
-        0x00,0x00,0x00,0x78,0x88,0x88,0x88,0x88,0x78,0x08,0x08,0x08,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0xb0,0xc8,0x88,0x80,0x80,0x80,0x80,0x00,0x00,
-
-        6, // 0x73 's'
-        0x00,0x00,0x00,0x70,0x88,0x80,0x70,0x08,0x88,0x70,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x40,0x40,0x40,0xe0,0x40,0x40,0x40,0x48,0x30,0x00,0x00,
-
-        6, // 0x75 'u'
-        0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x88,0x88,0x78,0x00,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,0x00,
-
-        6, // 0x77 'w'
-        0x00,0x00,0x00,0x88,0x88,0x88,0xa8,0xa8,0xd8,0x88,0x00,0x00,
-
-        6, // 0x78 'x'
-        0x00,0x00,0x00,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x00,0x00,
-
-        6, // 0x79 'y'
-        0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x88,0x78,0x08,0x10,0xe0,
-
-        6, // 0x7a 'z'
-        0x00,0x00,0x00,0xf8,0x08,0x10,0x20,0x40,0x80,0xf8,0x00,0x00,
-
-        6, // 0x7b '{'
-        0x18,0x20,0x20,0x20,0x20,0xc0,0x20,0x20,0x20,0x20,0x18,0x00,
-
-        6, // 0x7c '|'
-        0x00,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        6, // 0x7d '}'
-        0xc0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xc0,0x00,
-
-        6, // 0x7e '~'
-        0x00,0x00,0x40,0xa8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x7f ''
-        0x00,0x00,0x00,0x00,0x20,0x50,0x88,0xf8,0x00,0x00,0x00,0x00,
-        0
-    };
-
-    const int8u gse6x9[] = 
-    {
-        9, 0, 32, 128-32,
-
-        0x00,0x00,0x0a,0x00,0x14,0x00,0x1e,0x00,0x28,0x00,0x32,0x00,0x3c,0x00,0x46,0x00,0x50,0x00,
-        0x5a,0x00,0x64,0x00,0x6e,0x00,0x78,0x00,0x82,0x00,0x8c,0x00,0x96,0x00,0xa0,0x00,0xaa,0x00,
-        0xb4,0x00,0xbe,0x00,0xc8,0x00,0xd2,0x00,0xdc,0x00,0xe6,0x00,0xf0,0x00,0xfa,0x00,0x04,0x01,
-        0x0e,0x01,0x18,0x01,0x22,0x01,0x2c,0x01,0x36,0x01,0x40,0x01,0x4a,0x01,0x54,0x01,0x5e,0x01,
-        0x68,0x01,0x72,0x01,0x7c,0x01,0x86,0x01,0x90,0x01,0x9a,0x01,0xa4,0x01,0xae,0x01,0xb8,0x01,
-        0xc2,0x01,0xcc,0x01,0xd6,0x01,0xe0,0x01,0xea,0x01,0xf4,0x01,0xfe,0x01,0x08,0x02,0x12,0x02,
-        0x1c,0x02,0x26,0x02,0x30,0x02,0x3a,0x02,0x44,0x02,0x4e,0x02,0x58,0x02,0x62,0x02,0x6c,0x02,
-        0x76,0x02,0x80,0x02,0x8a,0x02,0x94,0x02,0x9e,0x02,0xa8,0x02,0xb2,0x02,0xbc,0x02,0xc6,0x02,
-        0xd0,0x02,0xda,0x02,0xe4,0x02,0xee,0x02,0xf8,0x02,0x02,0x03,0x0c,0x03,0x16,0x03,0x20,0x03,
-        0x2a,0x03,0x34,0x03,0x3e,0x03,0x48,0x03,0x52,0x03,0x5c,0x03,0x66,0x03,0x70,0x03,0x7a,0x03,
-        0x84,0x03,0x8e,0x03,0x98,0x03,0xa2,0x03,0xac,0x03,0xb6,0x03,
-
-        6, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
-
-        6, // 0x22 '"'
-        0x00,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x23 '#'
-        0x00,0x50,0x50,0xf8,0x50,0xf8,0x50,0x50,0x00,
-
-        6, // 0x24 '$'
-        0x00,0x70,0xa8,0xa0,0x70,0x28,0xa8,0x70,0x00,
-
-        6, // 0x25 '%'
-        0x00,0xc8,0xc8,0x10,0x20,0x40,0x98,0x98,0x00,
-
-        6, // 0x26 '&'
-        0x00,0x60,0x90,0x90,0x60,0xa8,0x90,0x68,0x00,
-
-        6, // 0x27 '''
-        0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x28 '('
-        0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x10,
-
-        6, // 0x29 ')'
-        0x40,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x40,
-
-        6, // 0x2a '*'
-        0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,
-
-        6, // 0x2b '+'
-        0x00,0x00,0x20,0x20,0xf8,0x20,0x20,0x00,0x00,
-
-        6, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x40,
-
-        6, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0xf8,0x00,0x00,0x00,0x00,
-
-        6, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,
-
-        6, // 0x2f '/'
-        0x00,0x08,0x08,0x10,0x20,0x40,0x80,0x80,0x00,
-
-        6, // 0x30 '0'
-        0x00,0x70,0x88,0x98,0xa8,0xc8,0x88,0x70,0x00,
-
-        6, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        6, // 0x32 '2'
-        0x00,0x70,0x88,0x08,0x10,0x20,0x40,0xf8,0x00,
-
-        6, // 0x33 '3'
-        0x00,0xf8,0x10,0x20,0x70,0x08,0x88,0x70,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x10,0x20,0x40,0x90,0xf8,0x10,0x10,0x00,
-
-        6, // 0x35 '5'
-        0x00,0xf8,0x80,0xf0,0x08,0x08,0x88,0x70,0x00,
-
-        6, // 0x36 '6'
-        0x00,0x70,0x88,0x80,0xf0,0x88,0x88,0x70,0x00,
-
-        6, // 0x37 '7'
-        0x00,0xf8,0x08,0x08,0x10,0x20,0x40,0x40,0x00,
-
-        6, // 0x38 '8'
-        0x00,0x70,0x88,0x88,0x70,0x88,0x88,0x70,0x00,
-
-        6, // 0x39 '9'
-        0x00,0x70,0x88,0x88,0x78,0x08,0x88,0x70,0x00,
-
-        6, // 0x3a ':'
-        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x00,0x00,
-
-        6, // 0x3b ';'
-        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x20,0x40,
-
-        6, // 0x3c '<'
-        0x00,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x00,
-
-        6, // 0x3d '='
-        0x00,0x00,0x00,0xf8,0x00,0xf8,0x00,0x00,0x00,
-
-        6, // 0x3e '>'
-        0x00,0x80,0x40,0x20,0x10,0x20,0x40,0x80,0x00,
-
-        6, // 0x3f '?'
-        0x00,0x70,0x88,0x08,0x10,0x20,0x00,0x20,0x00,
-
-        6, // 0x40 '@'
-        0x00,0x70,0x88,0x88,0xb8,0xb8,0x80,0x70,0x00,
-
-        6, // 0x41 'A'
-        0x00,0x20,0x50,0x88,0x88,0xf8,0x88,0x88,0x00,
-
-        6, // 0x42 'B'
-        0x00,0xf0,0x88,0x88,0xf0,0x88,0x88,0xf0,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x70,0x88,0x80,0x80,0x80,0x88,0x70,0x00,
-
-        6, // 0x44 'D'
-        0x00,0xe0,0x90,0x88,0x88,0x88,0x90,0xe0,0x00,
-
-        6, // 0x45 'E'
-        0x00,0xf8,0x80,0x80,0xf0,0x80,0x80,0xf8,0x00,
-
-        6, // 0x46 'F'
-        0x00,0xf8,0x80,0x80,0xf0,0x80,0x80,0x80,0x00,
-
-        6, // 0x47 'G'
-        0x00,0x70,0x88,0x80,0xb8,0x88,0x88,0x70,0x00,
-
-        6, // 0x48 'H'
-        0x00,0x88,0x88,0x88,0xf8,0x88,0x88,0x88,0x00,
-
-        6, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        6, // 0x4a 'J'
-        0x00,0x38,0x10,0x10,0x10,0x10,0x90,0x60,0x00,
-
-        6, // 0x4b 'K'
-        0x00,0x88,0x90,0xa0,0xc0,0xa0,0x90,0x88,0x00,
-
-        6, // 0x4c 'L'
-        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xf8,0x00,
-
-        6, // 0x4d 'M'
-        0x00,0x88,0xd8,0xa8,0x88,0x88,0x88,0x88,0x00,
-
-        6, // 0x4e 'N'
-        0x00,0x88,0x88,0xc8,0xa8,0x98,0x88,0x88,0x00,
-
-        6, // 0x4f 'O'
-        0x00,0x70,0x88,0x88,0x88,0x88,0x88,0x70,0x00,
-
-        6, // 0x50 'P'
-        0x00,0xf0,0x88,0x88,0xf0,0x80,0x80,0x80,0x00,
-
-        6, // 0x51 'Q'
-        0x00,0x70,0x88,0x88,0x88,0xa8,0x90,0x68,0x00,
-
-        6, // 0x52 'R'
-        0x00,0xf0,0x88,0x88,0x88,0xf0,0x90,0x88,0x00,
-
-        6, // 0x53 'S'
-        0x00,0x70,0x88,0x80,0x70,0x08,0x88,0x70,0x00,
-
-        6, // 0x54 'T'
-        0x00,0xf8,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        6, // 0x55 'U'
-        0x00,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,
-
-        6, // 0x57 'W'
-        0x00,0x88,0x88,0x88,0xa8,0xa8,0xd8,0x88,0x00,
-
-        6, // 0x58 'X'
-        0x00,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x00,
-
-        6, // 0x59 'Y'
-        0x00,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x00,
-
-        6, // 0x5a 'Z'
-        0x00,0xf8,0x08,0x10,0x20,0x40,0x80,0xf8,0x00,
-
-        6, // 0x5b '['
-        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,
-
-        6, // 0x5c '\'
-        0x00,0x80,0x80,0x40,0x20,0x10,0x08,0x08,0x00,
-
-        6, // 0x5d ']'
-        0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,
-
-        6, // 0x5e '^'
-        0x00,0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,
-
-        6, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,
-
-        6, // 0x60 '`'
-        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x61 'a'
-        0x00,0x00,0x00,0x70,0x08,0x78,0x88,0x78,0x00,
-
-        6, // 0x62 'b'
-        0x00,0x80,0x80,0xf0,0x88,0x88,0x88,0xf0,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x70,0x88,0x80,0x88,0x70,0x00,
-
-        6, // 0x64 'd'
-        0x00,0x08,0x08,0x78,0x88,0x88,0x88,0x78,0x00,
-
-        6, // 0x65 'e'
-        0x00,0x00,0x00,0x70,0x88,0xf8,0x80,0x78,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x18,0x20,0x20,0xf8,0x20,0x20,0x20,0x00,
-
-        6, // 0x67 'g'
-        0x00,0x00,0x00,0x78,0x88,0x88,0x78,0x08,0x70,
-
-        6, // 0x68 'h'
-        0x00,0x80,0x80,0xf0,0x88,0x88,0x88,0x88,0x00,
-
-        6, // 0x69 'i'
-        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x70,0x00,
-
-        6, // 0x6a 'j'
-        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x90,0x60,
-
-        6, // 0x6b 'k'
-        0x00,0x00,0x80,0x88,0x90,0xa0,0xd0,0x88,0x00,
-
-        6, // 0x6c 'l'
-        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        6, // 0x6d 'm'
-        0x00,0x00,0x00,0xd0,0xa8,0xa8,0xa8,0xa8,0x00,
-
-        6, // 0x6e 'n'
-        0x00,0x00,0x00,0xb0,0xc8,0x88,0x88,0x88,0x00,
-
-        6, // 0x6f 'o'
-        0x00,0x00,0x00,0x70,0x88,0x88,0x88,0x70,0x00,
-
-        6, // 0x70 'p'
-        0x00,0x00,0x00,0xf0,0x88,0x88,0xf0,0x80,0x80,
-
-        6, // 0x71 'q'
-        0x00,0x00,0x00,0x78,0x88,0x88,0x78,0x08,0x08,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0xb8,0xc0,0x80,0x80,0x80,0x00,
-
-        6, // 0x73 's'
-        0x00,0x00,0x00,0x78,0x80,0x70,0x08,0xf0,0x00,
-
-        6, // 0x74 't'
-        0x00,0x40,0x40,0xe0,0x40,0x40,0x48,0x30,0x00,
-
-        6, // 0x75 'u'
-        0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x78,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x20,0x00,
-
-        6, // 0x77 'w'
-        0x00,0x00,0x00,0x88,0x88,0xa8,0xd8,0x88,0x00,
-
-        6, // 0x78 'x'
-        0x00,0x00,0x00,0x88,0x50,0x20,0x50,0x88,0x00,
-
-        6, // 0x79 'y'
-        0x00,0x00,0x00,0x88,0x88,0x88,0x78,0x08,0x70,
-
-        6, // 0x7a 'z'
-        0x00,0x00,0x00,0xf8,0x10,0x20,0x40,0xf8,0x00,
-
-        6, // 0x7b '{'
-        0x18,0x20,0x20,0x20,0xc0,0x20,0x20,0x20,0x18,
-
-        6, // 0x7c '|'
-        0x00,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00,
-
-        6, // 0x7d '}'
-        0xc0,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0xc0,
-
-        6, // 0x7e '~'
-        0x00,0x40,0xa8,0x10,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x7f ''
-        0x00,0x00,0x00,0x20,0x50,0x88,0xf8,0x00,0x00,
-        0
-    };
-
-    const int8u gse7x11[] = 
-    {
-        11, 0, 32, 128-32,
-
-        0x00,0x00,0x0c,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3c,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
-        0x6c,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9c,0x00,0xa8,0x00,0xb4,0x00,0xc0,0x00,0xcc,0x00,
-        0xd8,0x00,0xe4,0x00,0xf0,0x00,0xfc,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2c,0x01,0x38,0x01,
-        0x44,0x01,0x50,0x01,0x5c,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8c,0x01,0x98,0x01,0xa4,0x01,
-        0xb0,0x01,0xbc,0x01,0xc8,0x01,0xd4,0x01,0xe0,0x01,0xec,0x01,0xf8,0x01,0x04,0x02,0x10,0x02,
-        0x1c,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4c,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7c,0x02,
-        0x88,0x02,0x94,0x02,0xa0,0x02,0xac,0x02,0xb8,0x02,0xc4,0x02,0xd0,0x02,0xdc,0x02,0xe8,0x02,
-        0xf4,0x02,0x00,0x03,0x0c,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3c,0x03,0x48,0x03,0x54,0x03,
-        0x60,0x03,0x6c,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9c,0x03,0xa8,0x03,0xb4,0x03,0xc0,0x03,
-        0xcc,0x03,0xd8,0x03,0xe4,0x03,0xf0,0x03,0xfc,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2c,0x04,
-        0x38,0x04,0x44,0x04,0x50,0x04,0x5c,0x04,0x68,0x04,0x74,0x04,
-
-        7, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x21 '!'
-        0x00,0x10,0x38,0x38,0x38,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x00,0x24,0x24,0x24,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x23 '#'
-        0x00,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x00,0x00,
-
-        7, // 0x24 '$'
-        0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,
-
-        7, // 0x25 '%'
-        0x00,0x00,0x42,0xa4,0x48,0x10,0x24,0x4a,0x84,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x30,0x48,0x48,0x30,0x60,0x94,0x98,0x6c,0x00,0x00,
-
-        7, // 0x27 '''
-        0x00,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x00,0x04,0x08,0x10,0x10,0x10,0x10,0x08,0x04,0x00,0x00,
-
-        7, // 0x29 ')'
-        0x00,0x40,0x20,0x10,0x10,0x10,0x10,0x20,0x40,0x00,0x00,
-
-        7, // 0x2a '*'
-        0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,
-
-        7, // 0x2b '+'
-        0x00,0x00,0x00,0x10,0x10,0x7c,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,
-
-        7, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        7, // 0x2f '/'
-        0x00,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x38,0x44,0x4c,0x54,0x64,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x7c,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x38,0x44,0x04,0x08,0x10,0x20,0x44,0x7c,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x7c,0x48,0x10,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x08,0x10,0x20,0x48,0x48,0x7c,0x08,0x1c,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x7c,0x40,0x40,0x78,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x18,0x20,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0x7c,0x44,0x04,0x08,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x44,0x3c,0x04,0x08,0x30,0x00,0x00,
-
-        7, // 0x3a ':'
-        0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x30,0x00,0x00,0x00,
-
-        7, // 0x3b ';'
-        0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x30,0x30,0x60,0x00,
-
-        7, // 0x3c '<'
-        0x00,0x00,0x04,0x08,0x10,0x20,0x10,0x08,0x04,0x00,0x00,
-
-        7, // 0x3d '='
-        0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,
-
-        7, // 0x3e '>'
-        0x00,0x00,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x00,0x00,
-
-        7, // 0x3f '?'
-        0x00,0x70,0x88,0x88,0x10,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x30,0x48,0x04,0x34,0x54,0x54,0x54,0x28,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x10,0x28,0x44,0x44,0x7c,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        7, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0x7c,0x40,0x40,0x70,0x40,0x40,0x40,0x7c,0x00,0x00,
-
-        7, // 0x46 'F'
-        0x00,0x7c,0x40,0x40,0x70,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x40,0x5c,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x7c,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x49 'I'
-        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x4a 'J'
-        0x00,0x1c,0x08,0x08,0x08,0x08,0x08,0x48,0x30,0x00,0x00,
-
-        7, // 0x4b 'K'
-        0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
-
-        7, // 0x4c 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7c,0x00,0x00,
-
-        7, // 0x4d 'M'
-        0x00,0x44,0x6c,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x4e 'N'
-        0x00,0x44,0x44,0x64,0x54,0x4c,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x4f 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x50,0x48,0x44,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x7c,0x54,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        7, // 0x57 'W'
-        0x00,0x44,0x44,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x5a 'Z'
-        0x00,0x7c,0x04,0x08,0x10,0x20,0x40,0x44,0x7c,0x00,0x00,
-
-        7, // 0x5b '['
-        0x00,0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,0x00,
-
-        7, // 0x5c '\'
-        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,0x00,
-
-        7, // 0x5d ']'
-        0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,0x00,
-
-        7, // 0x5e '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,
-
-        7, // 0x60 '`'
-        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3c,0x44,0x44,0x3c,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x04,0x04,0x3c,0x44,0x44,0x44,0x44,0x3c,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x7c,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x66 'f'
-        0x00,0x18,0x24,0x20,0x70,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x3c,0x44,0x44,0x44,0x3c,0x04,0x44,0x38,
-
-        7, // 0x68 'h'
-        0x00,0x40,0x40,0x40,0x58,0x64,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x69 'i'
-        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x6a 'j'
-        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x48,0x30,0x00,
-
-        7, // 0x6b 'k'
-        0x00,0x40,0x40,0x44,0x48,0x50,0x68,0x44,0x44,0x00,0x00,
-
-        7, // 0x6c 'l'
-        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x6d 'm'
-        0x00,0x00,0x00,0xa8,0x54,0x54,0x54,0x54,0x54,0x00,0x00,
-
-        7, // 0x6e 'n'
-        0x00,0x00,0x00,0xb8,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x6f 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x3c,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x64,0x44,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x3c,0x40,0x38,0x04,0x04,0x78,0x00,0x00,
-
-        7, // 0x74 't'
-        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x24,0x18,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3a,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x00,0x00,
-
-        7, // 0x77 'w'
-        0x00,0x00,0x00,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x3c,0x04,0x08,0x30,0x00,
-
-        7, // 0x7a 'z'
-        0x00,0x00,0x00,0x7c,0x08,0x10,0x20,0x44,0x7c,0x00,0x00,
-
-        7, // 0x7b '{'
-        0x00,0x0c,0x10,0x10,0x10,0x60,0x10,0x10,0x0c,0x00,0x00,
-
-        7, // 0x7c '|'
-        0x00,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        7, // 0x7d '}'
-        0x00,0x60,0x10,0x10,0x10,0x0c,0x10,0x10,0x60,0x00,0x00,
-
-        7, // 0x7e '~'
-        0x00,0x00,0x64,0x98,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7f ''
-        0x00,0x00,0x00,0x10,0x28,0x44,0x44,0x7c,0x00,0x00,0x00,
-        0
-    };
-
-    const int8u gse7x11_bold[] = 
-    {
-        11, 0, 32, 128-32,
-
-        0x00,0x00,0x0c,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3c,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
-        0x6c,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9c,0x00,0xa8,0x00,0xb4,0x00,0xc0,0x00,0xcc,0x00,
-        0xd8,0x00,0xe4,0x00,0xf0,0x00,0xfc,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2c,0x01,0x38,0x01,
-        0x44,0x01,0x50,0x01,0x5c,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8c,0x01,0x98,0x01,0xa4,0x01,
-        0xb0,0x01,0xbc,0x01,0xc8,0x01,0xd4,0x01,0xe0,0x01,0xec,0x01,0xf8,0x01,0x04,0x02,0x10,0x02,
-        0x1c,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4c,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7c,0x02,
-        0x88,0x02,0x94,0x02,0xa0,0x02,0xac,0x02,0xb8,0x02,0xc4,0x02,0xd0,0x02,0xdc,0x02,0xe8,0x02,
-        0xf4,0x02,0x00,0x03,0x0c,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3c,0x03,0x48,0x03,0x54,0x03,
-        0x60,0x03,0x6c,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9c,0x03,0xa8,0x03,0xb4,0x03,0xc0,0x03,
-        0xcc,0x03,0xd8,0x03,0xe4,0x03,0xf0,0x03,0xfc,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2c,0x04,
-        0x38,0x04,0x44,0x04,0x50,0x04,0x5c,0x04,0x68,0x04,0x74,0x04,
-
-        7, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x21 '!'
-        0x00,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x6c,0x6c,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x23 '#'
-        0x00,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x00,0x00,
-
-        7, // 0x24 '$'
-        0x30,0x30,0x78,0xcc,0xc0,0x78,0x0c,0xcc,0x78,0x30,0x30,
-
-        7, // 0x25 '%'
-        0x00,0x00,0xc4,0x0c,0x18,0x30,0x60,0xc0,0x8c,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x30,0x58,0x58,0x30,0x74,0xdc,0xd8,0x6c,0x00,0x00,
-
-        7, // 0x27 '''
-        0x00,0x30,0x30,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x00,0x0c,0x18,0x30,0x30,0x30,0x30,0x18,0x0c,0x00,0x00,
-
-        7, // 0x29 ')'
-        0x00,0xc0,0x60,0x30,0x30,0x30,0x30,0x60,0xc0,0x00,0x00,
-
-        7, // 0x2a '*'
-        0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,
-
-        7, // 0x2b '+'
-        0x00,0x00,0x00,0x30,0x30,0xfc,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x60,0x00,
-
-        7, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        7, // 0x2f '/'
-        0x00,0x0c,0x0c,0x18,0x18,0x30,0x30,0x60,0x60,0x00,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x78,0xcc,0xcc,0xdc,0xec,0xcc,0xcc,0x78,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x30,0x70,0xf0,0x30,0x30,0x30,0x30,0xfc,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x78,0xcc,0xcc,0x18,0x30,0x60,0xcc,0xfc,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0xfc,0x98,0x30,0x78,0x0c,0x0c,0xcc,0x78,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x18,0x30,0x68,0xd8,0xd8,0xfc,0x18,0x3c,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0xfc,0xc0,0xc0,0xf8,0x0c,0x0c,0xcc,0x78,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x38,0x60,0xc0,0xf8,0xcc,0xcc,0xcc,0x78,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0xfc,0x8c,0x0c,0x18,0x30,0x30,0x30,0x30,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x78,0xcc,0xcc,0x78,0xcc,0xcc,0xcc,0x78,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x78,0xcc,0xcc,0xcc,0x7c,0x0c,0x18,0x70,0x00,0x00,
-
-        7, // 0x3a ':'
-        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x3b ';'
-        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
-
-        7, // 0x3c '<'
-        0x00,0x00,0x0c,0x18,0x30,0x60,0x30,0x18,0x0c,0x00,0x00,
-
-        7, // 0x3d '='
-        0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,
-
-        7, // 0x3e '>'
-        0x00,0x00,0x60,0x30,0x18,0x0c,0x18,0x30,0x60,0x00,0x00,
-
-        7, // 0x3f '?'
-        0x00,0x78,0xcc,0xcc,0x18,0x30,0x30,0x00,0x30,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x70,0x88,0x04,0x74,0xb4,0xb4,0xb4,0x68,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x30,0x78,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0xf8,0xcc,0xcc,0xf8,0xcc,0xcc,0xcc,0xf8,0x00,0x00,
-
-        7, // 0x43 'C'
-        0x00,0x78,0xcc,0xc0,0xc0,0xc0,0xc0,0xcc,0x78,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0xf0,0xd8,0xcc,0xcc,0xcc,0xcc,0xd8,0xf0,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0xfc,0xc4,0xd0,0xf0,0xd0,0xc0,0xc4,0xfc,0x00,0x00,
-
-        7, // 0x46 'F'
-        0x00,0xfc,0xc4,0xd0,0xf0,0xd0,0xc0,0xc0,0xc0,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x78,0xcc,0xc0,0xc0,0xdc,0xcc,0xcc,0x78,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x49 'I'
-        0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        7, // 0x4a 'J'
-        0x00,0x3c,0x18,0x18,0x18,0x18,0xd8,0xd8,0x70,0x00,0x00,
-
-        7, // 0x4b 'K'
-        0x00,0xcc,0xcc,0xd8,0xf0,0xd8,0xcc,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x4c 'L'
-        0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc4,0xfc,0x00,0x00,
-
-        7, // 0x4d 'M'
-        0x00,0x84,0xcc,0xfc,0xb4,0xcc,0xcc,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x4e 'N'
-        0x00,0xcc,0xcc,0xec,0xfc,0xdc,0xcc,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x4f 'O'
-        0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xdc,0x78,0x18,0x0c,0x00,
-
-        7, // 0x52 'R'
-        0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xd8,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x78,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0x78,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0xfc,0xb4,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,
-
-        7, // 0x56 'V'
-        0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,
-
-        7, // 0x57 'W'
-        0x00,0xcc,0xcc,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0xcc,0xcc,0x78,0x30,0x78,0xcc,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0xcc,0xcc,0xcc,0x78,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        7, // 0x5a 'Z'
-        0x00,0xfc,0x8c,0x18,0x30,0x60,0xc0,0xc4,0xfc,0x00,0x00,
-
-        7, // 0x5b '['
-        0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x78,0x00,0x00,
-
-        7, // 0x5c '\'
-        0x00,0x60,0x60,0x30,0x30,0x18,0x18,0x0c,0x0c,0x00,0x00,
-
-        7, // 0x5d ']'
-        0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x78,0x00,0x00,
-
-        7, // 0x5e '^'
-        0x00,0x10,0x38,0x6c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,
-
-        7, // 0x60 '`'
-        0x00,0x30,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x70,0x18,0x78,0xd8,0xd8,0x6c,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x60,0x60,0x60,0x78,0x6c,0x6c,0x6c,0x78,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x78,0xcc,0xc0,0xc0,0xcc,0x78,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x18,0x18,0x18,0x78,0xd8,0xd8,0xd8,0x6c,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x78,0xcc,0xfc,0xc0,0xcc,0x78,0x00,0x00,
-
-        7, // 0x66 'f'
-        0x00,0x18,0x34,0x30,0x78,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x6c,0xd8,0xd8,0xd8,0x78,0x18,0xd8,0x70,
-
-        7, // 0x68 'h'
-        0x00,0xc0,0xc0,0xd8,0xec,0xcc,0xcc,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x69 'i'
-        0x00,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        7, // 0x6a 'j'
-        0x00,0x0c,0x00,0x1c,0x0c,0x0c,0x0c,0x0c,0x6c,0x6c,0x38,
-
-        7, // 0x6b 'k'
-        0x00,0xc0,0xc0,0xcc,0xcc,0xd8,0xf0,0xd8,0xcc,0x00,0x00,
-
-        7, // 0x6c 'l'
-        0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        7, // 0x6d 'm'
-        0x00,0x00,0x00,0xe8,0xfc,0xd4,0xd4,0xc4,0xc4,0x00,0x00,
-
-        7, // 0x6e 'n'
-        0x00,0x00,0x00,0xd8,0x6c,0x6c,0x6c,0x6c,0x6c,0x00,0x00,
-
-        7, // 0x6f 'o'
-        0x00,0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x7c,0xcc,0xcc,0xcc,0x7c,0x0c,0x0c,0x0c,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0xd8,0xec,0xcc,0xc0,0xc0,0xc0,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x78,0xcc,0x60,0x18,0xcc,0x78,0x00,0x00,
-
-        7, // 0x74 't'
-        0x00,0x20,0x60,0x60,0xf0,0x60,0x60,0x68,0x30,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0xd8,0xd8,0xd8,0xd8,0xd8,0x6c,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,
-
-        7, // 0x77 'w'
-        0x00,0x00,0x00,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0xcc,0x78,0x30,0x78,0xcc,0xcc,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x18,0xf0,
-
-        7, // 0x7a 'z'
-        0x00,0x00,0x00,0xfc,0x98,0x30,0x60,0xc4,0xfc,0x00,0x00,
-
-        7, // 0x7b '{'
-        0x1c,0x30,0x30,0x30,0xe0,0x30,0x30,0x30,0x1c,0x00,0x00,
-
-        7, // 0x7c '|'
-        0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x30,0x30,0x00,0x00,
-
-        7, // 0x7d '}'
-        0xe0,0x30,0x30,0x30,0x1c,0x30,0x30,0x30,0xe0,0x00,0x00,
-
-        7, // 0x7e '~'
-        0x00,0x34,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7f ''
-        0x00,0x00,0x00,0x30,0x78,0xcc,0xcc,0xfc,0x00,0x00,0x00,
-        0
-    };
-
-    const int8u gse7x15[] = 
-    {
-        15, 0, 32, 128-32,
-
-        0x00,0x00,0x10,0x00,0x20,0x00,0x30,0x00,0x40,0x00,0x50,0x00,0x60,0x00,0x70,0x00,0x80,0x00,
-        0x90,0x00,0xa0,0x00,0xb0,0x00,0xc0,0x00,0xd0,0x00,0xe0,0x00,0xf0,0x00,0x00,0x01,0x10,0x01,
-        0x20,0x01,0x30,0x01,0x40,0x01,0x50,0x01,0x60,0x01,0x70,0x01,0x80,0x01,0x90,0x01,0xa0,0x01,
-        0xb0,0x01,0xc0,0x01,0xd0,0x01,0xe0,0x01,0xf0,0x01,0x00,0x02,0x10,0x02,0x20,0x02,0x30,0x02,
-        0x40,0x02,0x50,0x02,0x60,0x02,0x70,0x02,0x80,0x02,0x90,0x02,0xa0,0x02,0xb0,0x02,0xc0,0x02,
-        0xd0,0x02,0xe0,0x02,0xf0,0x02,0x00,0x03,0x10,0x03,0x20,0x03,0x30,0x03,0x40,0x03,0x50,0x03,
-        0x60,0x03,0x70,0x03,0x80,0x03,0x90,0x03,0xa0,0x03,0xb0,0x03,0xc0,0x03,0xd0,0x03,0xe0,0x03,
-        0xf0,0x03,0x00,0x04,0x10,0x04,0x20,0x04,0x30,0x04,0x40,0x04,0x50,0x04,0x60,0x04,0x70,0x04,
-        0x80,0x04,0x90,0x04,0xa0,0x04,0xb0,0x04,0xc0,0x04,0xd0,0x04,0xe0,0x04,0xf0,0x04,0x00,0x05,
-        0x10,0x05,0x20,0x05,0x30,0x05,0x40,0x05,0x50,0x05,0x60,0x05,0x70,0x05,0x80,0x05,0x90,0x05,
-        0xa0,0x05,0xb0,0x05,0xc0,0x05,0xd0,0x05,0xe0,0x05,0xf0,0x05,
-
-        7, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x21 '!'
-        0x00,0x00,0x10,0x38,0x38,0x38,0x38,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x00,0x24,0x24,0x24,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x23 '#'
-        0x00,0x00,0x48,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x48,0x00,0x00,0x00,
-
-        7, // 0x24 '$'
-        0x00,0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x54,0x38,0x10,0x00,0x00,0x00,
-
-        7, // 0x25 '%'
-        0x00,0x00,0x44,0x44,0x08,0x08,0x10,0x10,0x20,0x20,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x00,0x00,0x30,0x48,0x48,0x30,0x60,0x94,0x98,0x90,0x6c,0x00,0x00,0x00,
-
-        7, // 0x27 '''
-        0x00,0x00,0x20,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x00,0x04,0x08,0x10,0x20,0x20,0x20,0x20,0x20,0x10,0x08,0x04,0x00,0x00,0x00,
-
-        7, // 0x29 ')'
-        0x00,0x40,0x20,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x20,0x40,0x00,0x00,0x00,
-
-        7, // 0x2a '*'
-        0x00,0x00,0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2b '+'
-        0x00,0x00,0x00,0x00,0x10,0x10,0x10,0x7c,0x10,0x10,0x10,0x00,0x00,0x00,0x00,
-
-        7, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
-
-        7, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x2f '/'
-        0x00,0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x00,0x38,0x44,0x44,0x4c,0x54,0x64,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x00,0x10,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x7c,0x00,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x00,0x38,0x44,0x44,0x04,0x08,0x10,0x20,0x40,0x44,0x7c,0x00,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x00,0x7c,0x44,0x08,0x10,0x38,0x04,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x00,0x08,0x10,0x20,0x40,0x48,0x48,0x7c,0x08,0x08,0x1c,0x00,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x00,0x7c,0x40,0x40,0x40,0x78,0x04,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x00,0x18,0x20,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0x00,0x7c,0x44,0x04,0x04,0x08,0x08,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,0x08,0x30,0x00,0x00,0x00,
-
-        7, // 0x3a ':'
-        0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,
-
-        7, // 0x3b ';'
-        0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x30,0x30,0x60,0x00,0x00,
-
-        7, // 0x3c '<'
-        0x00,0x00,0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,0x00,
-
-        7, // 0x3d '='
-        0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x3e '>'
-        0x00,0x00,0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,0x00,
-
-        7, // 0x3f '?'
-        0x00,0x00,0x78,0x84,0x84,0x84,0x08,0x10,0x20,0x20,0x00,0x20,0x00,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x00,0x00,0x30,0x48,0x04,0x34,0x54,0x54,0x54,0x54,0x28,0x00,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x00,0x10,0x28,0x44,0x44,0x44,0x7c,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
-
-        7, // 0x43 'C'
-        0x00,0x00,0x38,0x44,0x44,0x40,0x40,0x40,0x40,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0x00,0x7c,0x40,0x40,0x40,0x70,0x40,0x40,0x40,0x40,0x7c,0x00,0x00,0x00,
-
-        7, // 0x46 'F'
-        0x00,0x00,0x7c,0x40,0x40,0x40,0x70,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x5c,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x00,0x44,0x44,0x44,0x44,0x7c,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x49 'I'
-        0x00,0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x4a 'J'
-        0x00,0x00,0x1c,0x08,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,0x00,
-
-        7, // 0x4b 'K'
-        0x00,0x00,0x44,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x4c 'L'
-        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7c,0x00,0x00,0x00,
-
-        7, // 0x4d 'M'
-        0x00,0x00,0x44,0x6c,0x54,0x54,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x4e 'N'
-        0x00,0x00,0x44,0x44,0x44,0x64,0x54,0x4c,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x4f 'O'
-        0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x50,0x48,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x00,0x38,0x44,0x44,0x40,0x38,0x04,0x04,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x00,0x7c,0x54,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x56 'V'
-        0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x57 'W'
-        0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x5a 'Z'
-        0x00,0x00,0x7c,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x40,0x7c,0x00,0x00,0x00,
-
-        7, // 0x5b '['
-        0x00,0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,0x00,
-
-        7, // 0x5c '\'
-        0x00,0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,0x00,0x00,
-
-        7, // 0x5d ']'
-        0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,0x00,
-
-        7, // 0x5e '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,
-
-        7, // 0x60 '`'
-        0x00,0x20,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x38,0x44,0x04,0x3c,0x44,0x44,0x44,0x3a,0x00,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x00,0x40,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x00,0x04,0x04,0x04,0x3c,0x44,0x44,0x44,0x44,0x44,0x3a,0x00,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x38,0x44,0x44,0x7c,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x66 'f'
-        0x00,0x00,0x18,0x24,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x3a,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x44,0x38,0x00,
-
-        7, // 0x68 'h'
-        0x00,0x00,0x40,0x40,0x40,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x69 'i'
-        0x00,0x00,0x10,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x6a 'j'
-        0x00,0x00,0x08,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,
-
-        7, // 0x6b 'k'
-        0x00,0x00,0x40,0x40,0x44,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
-
-        7, // 0x6c 'l'
-        0x00,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x6d 'm'
-        0x00,0x00,0x00,0x00,0xa8,0x54,0x54,0x54,0x54,0x54,0x54,0x54,0x00,0x00,0x00,
-
-        7, // 0x6e 'n'
-        0x00,0x00,0x00,0x00,0xb8,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x6f 'o'
-        0x00,0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x3c,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,0x04,0x00,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x58,0x64,0x44,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x74 't'
-        0x00,0x00,0x20,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x24,0x18,0x00,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x3a,0x00,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x08,0x70,0x00,
-
-        7, // 0x7a 'z'
-        0x00,0x00,0x00,0x00,0x7c,0x04,0x08,0x10,0x20,0x40,0x40,0x7c,0x00,0x00,0x00,
-
-        7, // 0x7b '{'
-        0x00,0x0c,0x10,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x0c,0x00,0x00,
-
-        7, // 0x7c '|'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        7, // 0x7d '}'
-        0x00,0x60,0x10,0x10,0x10,0x10,0x10,0x0c,0x10,0x10,0x10,0x10,0x60,0x00,0x00,
-
-        7, // 0x7e '~'
-        0x00,0x00,0x64,0x98,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7f ''
-        0x00,0x00,0x00,0x00,0x00,0x10,0x28,0x44,0x44,0x7c,0x00,0x00,0x00,0x00,0x00,
-        0
-    };
-
-    const int8u gse7x15_bold[] = 
-    {
-        15, 0, 32, 128-32,
-
-        0x00,0x00,0x10,0x00,0x20,0x00,0x30,0x00,0x40,0x00,0x50,0x00,0x60,0x00,0x70,0x00,0x80,0x00,
-        0x90,0x00,0xa0,0x00,0xb0,0x00,0xc0,0x00,0xd0,0x00,0xe0,0x00,0xf0,0x00,0x00,0x01,0x10,0x01,
-        0x20,0x01,0x30,0x01,0x40,0x01,0x50,0x01,0x60,0x01,0x70,0x01,0x80,0x01,0x90,0x01,0xa0,0x01,
-        0xb0,0x01,0xc0,0x01,0xd0,0x01,0xe0,0x01,0xf0,0x01,0x00,0x02,0x10,0x02,0x20,0x02,0x30,0x02,
-        0x40,0x02,0x50,0x02,0x60,0x02,0x70,0x02,0x80,0x02,0x90,0x02,0xa0,0x02,0xb0,0x02,0xc0,0x02,
-        0xd0,0x02,0xe0,0x02,0xf0,0x02,0x00,0x03,0x10,0x03,0x20,0x03,0x30,0x03,0x40,0x03,0x50,0x03,
-        0x60,0x03,0x70,0x03,0x80,0x03,0x90,0x03,0xa0,0x03,0xb0,0x03,0xc0,0x03,0xd0,0x03,0xe0,0x03,
-        0xf0,0x03,0x00,0x04,0x10,0x04,0x20,0x04,0x30,0x04,0x40,0x04,0x50,0x04,0x60,0x04,0x70,0x04,
-        0x80,0x04,0x90,0x04,0xa0,0x04,0xb0,0x04,0xc0,0x04,0xd0,0x04,0xe0,0x04,0xf0,0x04,0x00,0x05,
-        0x10,0x05,0x20,0x05,0x30,0x05,0x40,0x05,0x50,0x05,0x60,0x05,0x70,0x05,0x80,0x05,0x90,0x05,
-        0xa0,0x05,0xb0,0x05,0xc0,0x05,0xd0,0x05,0xe0,0x05,0xf0,0x05,
-
-        7, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x21 '!'
-        0x00,0x00,0x00,0x30,0x78,0x78,0x78,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x00,0x6c,0x6c,0x6c,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x23 '#'
-        0x00,0x00,0x48,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x48,0x00,0x00,0x00,
-
-        7, // 0x24 '$'
-        0x00,0x30,0x30,0x78,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0x78,0x30,0x30,0x00,0x00,
-
-        7, // 0x25 '%'
-        0x00,0x00,0x00,0x64,0x6c,0x08,0x18,0x10,0x30,0x20,0x6c,0x4c,0x00,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x00,0x00,0x30,0x58,0x58,0x30,0x74,0xdc,0xd8,0xd8,0x6c,0x00,0x00,0x00,
-
-        7, // 0x27 '''
-        0x00,0x00,0x30,0x30,0x30,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x00,0x0c,0x18,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x18,0x0c,0x00,0x00,0x00,
-
-        7, // 0x29 ')'
-        0x00,0xc0,0x60,0x30,0x18,0x18,0x18,0x18,0x18,0x30,0x60,0xc0,0x00,0x00,0x00,
-
-        7, // 0x2a '*'
-        0x00,0x00,0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2b '+'
-        0x00,0x00,0x00,0x00,0x00,0x30,0x30,0xfc,0x30,0x30,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
-
-        7, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x2f '/'
-        0x00,0x00,0x0c,0x0c,0x18,0x18,0x30,0x30,0x60,0x60,0xc0,0xc0,0x00,0x00,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xdc,0xec,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x00,0x30,0x30,0x70,0xf0,0x30,0x30,0x30,0x30,0x30,0xfc,0x00,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x00,0x78,0xcc,0xcc,0x0c,0x18,0x30,0x60,0xc0,0xcc,0xfc,0x00,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x00,0xfc,0x8c,0x18,0x30,0x78,0x0c,0x0c,0x0c,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x00,0x18,0x30,0x60,0xc8,0xd8,0xd8,0xfc,0x18,0x18,0x3c,0x00,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x00,0xfc,0xc0,0xc0,0xc0,0xf8,0x0c,0x0c,0x0c,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x00,0x38,0x60,0xc0,0xc0,0xf8,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0x00,0xfc,0x8c,0x0c,0x0c,0x18,0x18,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x00,0x78,0xcc,0xcc,0xcc,0x78,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x0c,0x18,0x70,0x00,0x00,0x00,
-
-        7, // 0x3a ':'
-        0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,
-
-        7, // 0x3b ';'
-        0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
-
-        7, // 0x3c '<'
-        0x00,0x00,0x00,0x0c,0x18,0x30,0x60,0xc0,0x60,0x30,0x18,0x0c,0x00,0x00,0x00,
-
-        7, // 0x3d '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x3e '>'
-        0x00,0x00,0x00,0xc0,0x60,0x30,0x18,0x0c,0x18,0x30,0x60,0xc0,0x00,0x00,0x00,
-
-        7, // 0x3f '?'
-        0x00,0x00,0x78,0xcc,0xcc,0x18,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x00,0x00,0x70,0x88,0x04,0x74,0xb4,0xb4,0xb4,0xb4,0x68,0x00,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x00,0x30,0x78,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xcc,0xcc,0xcc,0xcc,0xf8,0x00,0x00,0x00,
-
-        7, // 0x43 'C'
-        0x00,0x00,0x78,0xcc,0xc4,0xc0,0xc0,0xc0,0xc0,0xc4,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x00,0xf0,0xd8,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xd8,0xf0,0x00,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0x00,0xfc,0xc4,0xc0,0xd0,0xf0,0xd0,0xc0,0xc0,0xc4,0xfc,0x00,0x00,0x00,
-
-        7, // 0x46 'F'
-        0x00,0x00,0xfc,0xc4,0xc0,0xd0,0xf0,0xd0,0xc0,0xc0,0xc0,0xc0,0x00,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x00,0x78,0xcc,0xc0,0xc0,0xc0,0xdc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x49 'I'
-        0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
-
-        7, // 0x4a 'J'
-        0x00,0x00,0x3c,0x18,0x18,0x18,0x18,0x18,0x18,0xd8,0xd8,0x70,0x00,0x00,0x00,
-
-        7, // 0x4b 'K'
-        0x00,0x00,0xcc,0xcc,0xd8,0xd8,0xf0,0xd8,0xd8,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x4c 'L'
-        0x00,0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc4,0xfc,0x00,0x00,0x00,
-
-        7, // 0x4d 'M'
-        0x00,0x00,0x84,0xcc,0xfc,0xb4,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x4e 'N'
-        0x00,0x00,0xcc,0xcc,0xcc,0xec,0xfc,0xdc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x4f 'O'
-        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,0xc0,0x00,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xdc,0x78,0x18,0x0c,0x00,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xcc,0xf8,0xd8,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x00,0x78,0xcc,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x00,0xfc,0xb4,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x56 'V'
-        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,0x00,
-
-        7, // 0x57 'W'
-        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x00,0xcc,0xcc,0xcc,0x78,0x30,0x78,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
-
-        7, // 0x5a 'Z'
-        0x00,0x00,0xfc,0x8c,0x0c,0x18,0x30,0x60,0xc0,0xc0,0xc4,0xfc,0x00,0x00,0x00,
-
-        7, // 0x5b '['
-        0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,0x00,0x00,
-
-        7, // 0x5c '\'
-        0x00,0x00,0xc0,0xc0,0x60,0x60,0x30,0x30,0x18,0x18,0x0c,0x0c,0x00,0x00,0x00,
-
-        7, // 0x5d ']'
-        0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,0x00,0x00,
-
-        7, // 0x5e '^'
-        0x00,0x10,0x38,0x6c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,
-
-        7, // 0x60 '`'
-        0x00,0x30,0x30,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x70,0xd8,0x18,0x78,0xd8,0xd8,0xd8,0x6c,0x00,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x00,0x60,0x60,0x60,0x78,0x6c,0x6c,0x6c,0x6c,0x6c,0x78,0x00,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x78,0xcc,0xc0,0xc0,0xc0,0xc0,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x00,0x18,0x18,0x18,0x78,0xd8,0xd8,0xd8,0xd8,0xd8,0x6c,0x00,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x78,0xcc,0xcc,0xfc,0xc0,0xc0,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x66 'f'
-        0x00,0x00,0x30,0x68,0x60,0x60,0xf0,0x60,0x60,0x60,0x60,0xf0,0x00,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x6c,0xd8,0xd8,0xd8,0xd8,0xd8,0x78,0x18,0xd8,0x70,0x00,
-
-        7, // 0x68 'h'
-        0x00,0x00,0xc0,0xc0,0xc0,0xd8,0xec,0xcc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x69 'i'
-        0x00,0x00,0x30,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
-
-        7, // 0x6a 'j'
-        0x00,0x00,0x18,0x18,0x00,0x38,0x18,0x18,0x18,0x18,0x18,0xd8,0xd8,0x70,0x00,
-
-        7, // 0x6b 'k'
-        0x00,0x00,0xc0,0xc0,0xcc,0xcc,0xcc,0xd8,0xf0,0xd8,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x6c 'l'
-        0x00,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
-
-        7, // 0x6d 'm'
-        0x00,0x00,0x00,0x00,0xe8,0xfc,0xd4,0xd4,0xd4,0xc4,0xc4,0xc4,0x00,0x00,0x00,
-
-        7, // 0x6e 'n'
-        0x00,0x00,0x00,0x00,0xd8,0x6c,0x6c,0x6c,0x6c,0x6c,0x6c,0x6c,0x00,0x00,0x00,
-
-        7, // 0x6f 'o'
-        0x00,0x00,0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,0x00,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x7c,0xcc,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x0c,0x0c,0x00,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0xd8,0xec,0xcc,0xc0,0xc0,0xc0,0xc0,0xc0,0x00,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x78,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0x78,0x00,0x00,0x00,
-
-        7, // 0x74 't'
-        0x00,0x00,0x20,0x60,0x60,0xf0,0x60,0x60,0x60,0x60,0x6c,0x38,0x00,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0xd8,0xd8,0xd8,0xd8,0xd8,0xd8,0xd8,0x6c,0x00,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,0x00,
-
-        7, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0xcc,0xcc,0x78,0x30,0x78,0xcc,0xcc,0xcc,0x00,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x18,0xf0,0x00,
-
-        7, // 0x7a 'z'
-        0x00,0x00,0x00,0x00,0xfc,0x8c,0x18,0x30,0x60,0xc0,0xc4,0xfc,0x00,0x00,0x00,
-
-        7, // 0x7b '{'
-        0x00,0x1c,0x30,0x30,0x30,0x30,0x30,0xe0,0x30,0x30,0x30,0x30,0x1c,0x00,0x00,
-
-        7, // 0x7c '|'
-        0x00,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x00,0x00,
-
-        7, // 0x7d '}'
-        0x00,0xe0,0x30,0x30,0x30,0x30,0x30,0x1c,0x30,0x30,0x30,0x30,0xe0,0x00,0x00,
-
-        7, // 0x7e '~'
-        0x00,0x00,0x34,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7f ''
-        0x00,0x00,0x00,0x00,0x00,0x30,0x78,0xcc,0xcc,0xfc,0x00,0x00,0x00,0x00,0x00,
-        0
-    };
-
-    const int8u gse8x16[] = 
-    {
-        16, 0, 32, 128-32,
-
-        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x44,0x00,0x55,0x00,0x66,0x00,0x77,0x00,0x88,0x00,
-        0x99,0x00,0xaa,0x00,0xbb,0x00,0xcc,0x00,0xdd,0x00,0xee,0x00,0xff,0x00,0x10,0x01,0x21,0x01,
-        0x32,0x01,0x43,0x01,0x54,0x01,0x65,0x01,0x76,0x01,0x87,0x01,0x98,0x01,0xa9,0x01,0xba,0x01,
-        0xcb,0x01,0xdc,0x01,0xed,0x01,0xfe,0x01,0x0f,0x02,0x20,0x02,0x31,0x02,0x42,0x02,0x53,0x02,
-        0x64,0x02,0x75,0x02,0x86,0x02,0x97,0x02,0xa8,0x02,0xb9,0x02,0xca,0x02,0xdb,0x02,0xec,0x02,
-        0xfd,0x02,0x0e,0x03,0x1f,0x03,0x30,0x03,0x41,0x03,0x52,0x03,0x63,0x03,0x74,0x03,0x85,0x03,
-        0x96,0x03,0xa7,0x03,0xb8,0x03,0xc9,0x03,0xda,0x03,0xeb,0x03,0xfc,0x03,0x0d,0x04,0x1e,0x04,
-        0x2f,0x04,0x40,0x04,0x51,0x04,0x62,0x04,0x73,0x04,0x84,0x04,0x95,0x04,0xa6,0x04,0xb7,0x04,
-        0xc8,0x04,0xd9,0x04,0xea,0x04,0xfb,0x04,0x0c,0x05,0x1d,0x05,0x2e,0x05,0x3f,0x05,0x50,0x05,
-        0x61,0x05,0x72,0x05,0x83,0x05,0x94,0x05,0xa5,0x05,0xb6,0x05,0xc7,0x05,0xd8,0x05,0xe9,0x05,
-        0xfa,0x05,0x0b,0x06,0x1c,0x06,0x2d,0x06,0x3e,0x06,0x4f,0x06,
-
-        8, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x21 '!'
-        0x00,0x00,0x10,0x38,0x38,0x38,0x38,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,0x00,
-
-        8, // 0x22 '"'
-        0x00,0x24,0x24,0x24,0x24,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x23 '#'
-        0x00,0x00,0x24,0x24,0x24,0x7e,0x24,0x24,0x7e,0x24,0x24,0x24,0x00,0x00,0x00,0x00,
-
-        8, // 0x24 '$'
-        0x00,0x14,0x14,0x3e,0x55,0x54,0x54,0x3e,0x15,0x15,0x55,0x3e,0x14,0x14,0x00,0x00,
-
-        8, // 0x25 '%'
-        0x00,0x00,0x32,0x56,0x6c,0x04,0x08,0x08,0x10,0x13,0x25,0x26,0x00,0x00,0x00,0x00,
-
-        8, // 0x26 '&'
-        0x00,0x00,0x18,0x24,0x24,0x24,0x18,0x28,0x45,0x46,0x44,0x3b,0x00,0x00,0x00,0x00,
-
-        8, // 0x27 '''
-        0x00,0x00,0x08,0x08,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x28 '('
-        0x00,0x04,0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x04,0x00,0x00,0x00,
-
-        8, // 0x29 ')'
-        0x00,0x10,0x08,0x04,0x04,0x02,0x02,0x02,0x02,0x04,0x04,0x08,0x10,0x00,0x00,0x00,
-
-        8, // 0x2a '*'
-        0x00,0x00,0x00,0x00,0x66,0x24,0x18,0xff,0x18,0x24,0x66,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x2b '+'
-        0x00,0x00,0x00,0x00,0x08,0x08,0x08,0x7f,0x08,0x08,0x08,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x20,0x00,
-
-        8, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,
-
-        8, // 0x2f '/'
-        0x00,0x02,0x02,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,0x00,
-
-        8, // 0x30 '0'
-        0x00,0x00,0x3c,0x42,0x42,0x46,0x4a,0x52,0x62,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x31 '1'
-        0x00,0x00,0x08,0x08,0x18,0x38,0x08,0x08,0x08,0x08,0x08,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x32 '2'
-        0x00,0x00,0x3c,0x42,0x42,0x02,0x04,0x08,0x10,0x20,0x42,0x7e,0x00,0x00,0x00,0x00,
-
-        8, // 0x33 '3'
-        0x00,0x00,0x7e,0x42,0x04,0x08,0x1c,0x02,0x02,0x02,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x34 '4'
-        0x00,0x00,0x04,0x08,0x10,0x24,0x44,0x44,0x7e,0x04,0x04,0x0e,0x00,0x00,0x00,0x00,
-
-        8, // 0x35 '5'
-        0x00,0x00,0x7e,0x42,0x40,0x40,0x7c,0x02,0x02,0x02,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x36 '6'
-        0x00,0x00,0x1c,0x20,0x40,0x40,0x7c,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x37 '7'
-        0x00,0x00,0x7e,0x42,0x42,0x02,0x04,0x08,0x10,0x10,0x10,0x10,0x00,0x00,0x00,0x00,
-
-        8, // 0x38 '8'
-        0x00,0x00,0x3c,0x42,0x42,0x42,0x3c,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x39 '9'
-        0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x3e,0x02,0x02,0x04,0x38,0x00,0x00,0x00,0x00,
-
-        8, // 0x3a ':'
-        0x00,0x00,0x00,0x00,0x18,0x00,0x00,0x00,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x3b ';'
-        0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x40,0x00,
-
-        8, // 0x3c '<'
-        0x00,0x00,0x00,0x02,0x04,0x08,0x10,0x20,0x10,0x08,0x04,0x02,0x00,0x00,0x00,0x00,
-
-        8, // 0x3d '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x3e '>'
-        0x00,0x00,0x00,0x20,0x10,0x08,0x04,0x02,0x04,0x08,0x10,0x20,0x00,0x00,0x00,0x00,
-
-        8, // 0x3f '?'
-        0x00,0x00,0x3c,0x42,0x42,0x42,0x04,0x08,0x08,0x00,0x08,0x08,0x00,0x00,0x00,0x00,
-
-        8, // 0x40 '@'
-        0x00,0x00,0x3c,0x42,0x01,0x39,0x49,0x49,0x49,0x49,0x49,0x36,0x00,0x00,0x00,0x00,
-
-        8, // 0x41 'A'
-        0x00,0x00,0x18,0x24,0x42,0x42,0x42,0x7e,0x42,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
-
-        8, // 0x42 'B'
-        0x00,0x00,0x7c,0x22,0x22,0x22,0x3c,0x22,0x22,0x22,0x22,0x7c,0x00,0x00,0x00,0x00,
-
-        8, // 0x43 'C'
-        0x00,0x00,0x3c,0x42,0x42,0x40,0x40,0x40,0x40,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x44 'D'
-        0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x7c,0x00,0x00,0x00,0x00,
-
-        8, // 0x45 'E'
-        0x00,0x00,0x7e,0x22,0x20,0x28,0x38,0x28,0x20,0x20,0x22,0x7e,0x00,0x00,0x00,0x00,
-
-        8, // 0x46 'F'
-        0x00,0x00,0x7e,0x22,0x20,0x28,0x38,0x28,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,
-
-        8, // 0x47 'G'
-        0x00,0x00,0x3c,0x42,0x42,0x40,0x40,0x4e,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x48 'H'
-        0x00,0x00,0x42,0x42,0x42,0x42,0x7e,0x42,0x42,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
-
-        8, // 0x49 'I'
-        0x00,0x00,0x1c,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
-
-        8, // 0x4a 'J'
-        0x00,0x00,0x0e,0x04,0x04,0x04,0x04,0x04,0x04,0x44,0x44,0x38,0x00,0x00,0x00,0x00,
-
-        8, // 0x4b 'K'
-        0x00,0x00,0x62,0x22,0x24,0x28,0x30,0x28,0x24,0x22,0x22,0x62,0x00,0x00,0x00,0x00,
-
-        8, // 0x4c 'L'
-        0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x22,0x7e,0x00,0x00,0x00,0x00,
-
-        8, // 0x4d 'M'
-        0x00,0x00,0x41,0x63,0x55,0x49,0x41,0x41,0x41,0x41,0x41,0x41,0x00,0x00,0x00,0x00,
-
-        8, // 0x4e 'N'
-        0x00,0x00,0x42,0x42,0x62,0x52,0x4a,0x46,0x42,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
-
-        8, // 0x4f 'O'
-        0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x50 'P'
-        0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x3c,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,
-
-        8, // 0x51 'Q'
-        0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x42,0x42,0x4a,0x44,0x3a,0x02,0x00,0x00,0x00,
-
-        8, // 0x52 'R'
-        0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x3c,0x28,0x24,0x22,0x62,0x00,0x00,0x00,0x00,
-
-        8, // 0x53 'S'
-        0x00,0x00,0x3c,0x42,0x42,0x40,0x30,0x0c,0x02,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x54 'T'
-        0x00,0x00,0x7f,0x49,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
-
-        8, // 0x55 'U'
-        0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x56 'V'
-        0x00,0x00,0x41,0x41,0x41,0x41,0x22,0x22,0x14,0x14,0x08,0x08,0x00,0x00,0x00,0x00,
-
-        8, // 0x57 'W'
-        0x00,0x00,0x41,0x41,0x41,0x41,0x41,0x49,0x49,0x55,0x63,0x41,0x00,0x00,0x00,0x00,
-
-        8, // 0x58 'X'
-        0x00,0x00,0x42,0x42,0x42,0x24,0x18,0x18,0x24,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
-
-        8, // 0x59 'Y'
-        0x00,0x00,0x22,0x22,0x22,0x22,0x14,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
-
-        8, // 0x5a 'Z'
-        0x00,0x00,0x7e,0x42,0x02,0x04,0x08,0x10,0x20,0x40,0x42,0x7e,0x00,0x00,0x00,0x00,
-
-        8, // 0x5b '['
-        0x00,0x1e,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x1e,0x00,0x00,0x00,
-
-        8, // 0x5c '\'
-        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x02,0x02,0x00,0x00,0x00,
-
-        8, // 0x5d ']'
-        0x00,0x3c,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x3c,0x00,0x00,0x00,
-
-        8, // 0x5e '^'
-        0x00,0x00,0x08,0x14,0x22,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,0x00,0x00,
-
-        8, // 0x60 '`'
-        0x00,0x00,0x08,0x08,0x08,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x04,0x3c,0x44,0x44,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x62 'b'
-        0x00,0x00,0x60,0x20,0x20,0x38,0x24,0x22,0x22,0x22,0x22,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x40,0x40,0x40,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x64 'd'
-        0x00,0x00,0x0c,0x04,0x04,0x1c,0x24,0x44,0x44,0x44,0x44,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x42,0x7e,0x40,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x66 'f'
-        0x00,0x00,0x0c,0x12,0x10,0x10,0x38,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,0x00,
-
-        8, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x3e,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x44,0x38,0x00,
-
-        8, // 0x68 'h'
-        0x00,0x00,0x60,0x20,0x20,0x2c,0x32,0x22,0x22,0x22,0x22,0x62,0x00,0x00,0x00,0x00,
-
-        8, // 0x69 'i'
-        0x00,0x00,0x08,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
-
-        8, // 0x6a 'j'
-        0x00,0x00,0x04,0x04,0x00,0x0c,0x04,0x04,0x04,0x04,0x04,0x44,0x44,0x38,0x00,0x00,
-
-        8, // 0x6b 'k'
-        0x00,0x00,0x60,0x20,0x20,0x22,0x24,0x28,0x38,0x24,0x22,0x62,0x00,0x00,0x00,0x00,
-
-        8, // 0x6c 'l'
-        0x00,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
-
-        8, // 0x6d 'm'
-        0x00,0x00,0x00,0x00,0x00,0x76,0x49,0x49,0x49,0x49,0x41,0x41,0x00,0x00,0x00,0x00,
-
-        8, // 0x6e 'n'
-        0x00,0x00,0x00,0x00,0x00,0x5c,0x22,0x22,0x22,0x22,0x22,0x22,0x00,0x00,0x00,0x00,
-
-        8, // 0x6f 'o'
-        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x22,0x3c,0x20,0x20,0x70,0x00,
-
-        8, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x3e,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,0x0e,0x00,
-
-        8, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x7c,0x22,0x22,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,
-
-        8, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x40,0x3c,0x02,0x42,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x74 't'
-        0x00,0x00,0x10,0x10,0x10,0x7c,0x10,0x10,0x10,0x10,0x12,0x0c,0x00,0x00,0x00,0x00,
-
-        8, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x41,0x41,0x41,0x41,0x22,0x14,0x08,0x00,0x00,0x00,0x00,
-
-        8, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x41,0x41,0x41,0x49,0x49,0x55,0x22,0x00,0x00,0x00,0x00,
-
-        8, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x18,0x24,0x42,0x42,0x00,0x00,0x00,0x00,
-
-        8, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x3e,0x02,0x04,0x78,0x00,
-
-        8, // 0x7a 'z'
-        0x00,0x00,0x00,0x00,0x00,0x7e,0x44,0x08,0x10,0x20,0x42,0x7e,0x00,0x00,0x00,0x00,
-
-        8, // 0x7b '{'
-        0x00,0x06,0x08,0x08,0x08,0x08,0x08,0x30,0x08,0x08,0x08,0x08,0x08,0x06,0x00,0x00,
-
-        8, // 0x7c '|'
-        0x00,0x00,0x08,0x08,0x08,0x08,0x08,0x00,0x08,0x08,0x08,0x08,0x08,0x00,0x00,0x00,
-
-        8, // 0x7d '}'
-        0x00,0x30,0x08,0x08,0x08,0x08,0x08,0x06,0x08,0x08,0x08,0x08,0x08,0x30,0x00,0x00,
-
-        8, // 0x7e '~'
-        0x00,0x00,0x39,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x7f ''
-        0x00,0x00,0x00,0x00,0x00,0x08,0x14,0x22,0x41,0x41,0x7f,0x00,0x00,0x00,0x00,0x00,
-        0
-    };
-
-    const int8u gse8x16_bold[] = 
-    {
-        16, 0, 32, 128-32,
-
-        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x44,0x00,0x55,0x00,0x66,0x00,0x77,0x00,0x88,0x00,
-        0x99,0x00,0xaa,0x00,0xbb,0x00,0xcc,0x00,0xdd,0x00,0xee,0x00,0xff,0x00,0x10,0x01,0x21,0x01,
-        0x32,0x01,0x43,0x01,0x54,0x01,0x65,0x01,0x76,0x01,0x87,0x01,0x98,0x01,0xa9,0x01,0xba,0x01,
-        0xcb,0x01,0xdc,0x01,0xed,0x01,0xfe,0x01,0x0f,0x02,0x20,0x02,0x31,0x02,0x42,0x02,0x53,0x02,
-        0x64,0x02,0x75,0x02,0x86,0x02,0x97,0x02,0xa8,0x02,0xb9,0x02,0xca,0x02,0xdb,0x02,0xec,0x02,
-        0xfd,0x02,0x0e,0x03,0x1f,0x03,0x30,0x03,0x41,0x03,0x52,0x03,0x63,0x03,0x74,0x03,0x85,0x03,
-        0x96,0x03,0xa7,0x03,0xb8,0x03,0xc9,0x03,0xda,0x03,0xeb,0x03,0xfc,0x03,0x0d,0x04,0x1e,0x04,
-        0x2f,0x04,0x40,0x04,0x51,0x04,0x62,0x04,0x73,0x04,0x84,0x04,0x95,0x04,0xa6,0x04,0xb7,0x04,
-        0xc8,0x04,0xd9,0x04,0xea,0x04,0xfb,0x04,0x0c,0x05,0x1d,0x05,0x2e,0x05,0x3f,0x05,0x50,0x05,
-        0x61,0x05,0x72,0x05,0x83,0x05,0x94,0x05,0xa5,0x05,0xb6,0x05,0xc7,0x05,0xd8,0x05,0xe9,0x05,
-        0xfa,0x05,0x0b,0x06,0x1c,0x06,0x2d,0x06,0x3e,0x06,0x4f,0x06,
-
-        8, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x21 '!'
-        0x00,0x00,0x18,0x3c,0x3c,0x3c,0x3c,0x18,0x18,0x00,0x18,0x18,0x00,0x00,0x00,0x00,
-
-        8, // 0x22 '"'
-        0x00,0x66,0x66,0x66,0x66,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x23 '#'
-        0x00,0x00,0x66,0x66,0x66,0xff,0x66,0x66,0xff,0x66,0x66,0x66,0x00,0x00,0x00,0x00,
-
-        8, // 0x24 '$'
-        0x00,0x08,0x08,0x3e,0x6b,0x6b,0x68,0x3e,0x0b,0x6b,0x6b,0x3e,0x08,0x08,0x00,0x00,
-
-        8, // 0x25 '%'
-        0x00,0x00,0x66,0xbe,0xcc,0x0c,0x18,0x18,0x30,0x33,0x65,0x66,0x00,0x00,0x00,0x00,
-
-        8, // 0x26 '&'
-        0x00,0x00,0x1c,0x36,0x36,0x36,0x1c,0x3b,0x6e,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
-
-        8, // 0x27 '''
-        0x00,0x00,0x18,0x18,0x18,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x28 '('
-        0x00,0x06,0x0c,0x18,0x18,0x30,0x30,0x30,0x30,0x18,0x18,0x0c,0x06,0x00,0x00,0x00,
-
-        8, // 0x29 ')'
-        0x00,0x30,0x18,0x0c,0x0c,0x06,0x06,0x06,0x06,0x0c,0x0c,0x18,0x30,0x00,0x00,0x00,
-
-        8, // 0x2a '*'
-        0x00,0x00,0x00,0x00,0x66,0x24,0x18,0xff,0x18,0x24,0x66,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x2b '+'
-        0x00,0x00,0x00,0x00,0x18,0x18,0x18,0xff,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x2c ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x20,0x00,
-
-        8, // 0x2d '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x2e '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,
-
-        8, // 0x2f '/'
-        0x00,0x03,0x03,0x06,0x06,0x0c,0x0c,0x18,0x18,0x30,0x30,0x60,0x60,0x00,0x00,0x00,
-
-        8, // 0x30 '0'
-        0x00,0x00,0x3e,0x63,0x63,0x67,0x6b,0x73,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x31 '1'
-        0x00,0x00,0x0c,0x0c,0x1c,0x3c,0x0c,0x0c,0x0c,0x0c,0x0c,0x3f,0x00,0x00,0x00,0x00,
-
-        8, // 0x32 '2'
-        0x00,0x00,0x3e,0x63,0x63,0x03,0x06,0x0c,0x18,0x30,0x61,0x7f,0x00,0x00,0x00,0x00,
-
-        8, // 0x33 '3'
-        0x00,0x00,0x7f,0x43,0x06,0x0c,0x1e,0x03,0x03,0x03,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x34 '4'
-        0x00,0x00,0x06,0x0c,0x18,0x32,0x66,0x66,0x7f,0x06,0x06,0x0f,0x00,0x00,0x00,0x00,
-
-        8, // 0x35 '5'
-        0x00,0x00,0x7f,0x61,0x60,0x60,0x7e,0x03,0x03,0x03,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x36 '6'
-        0x00,0x00,0x1e,0x30,0x60,0x60,0x7e,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x37 '7'
-        0x00,0x00,0x7f,0x63,0x63,0x03,0x06,0x0c,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,
-
-        8, // 0x38 '8'
-        0x00,0x00,0x3e,0x63,0x63,0x63,0x3e,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x39 '9'
-        0x00,0x00,0x3e,0x63,0x63,0x63,0x63,0x3f,0x03,0x03,0x06,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x3a ':'
-        0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x3b ';'
-        0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x40,0x00,
-
-        8, // 0x3c '<'
-        0x00,0x00,0x00,0x06,0x0c,0x18,0x30,0x60,0x30,0x18,0x0c,0x06,0x00,0x00,0x00,0x00,
-
-        8, // 0x3d '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x3e '>'
-        0x00,0x00,0x00,0x30,0x18,0x0c,0x06,0x03,0x06,0x0c,0x18,0x30,0x00,0x00,0x00,0x00,
-
-        8, // 0x3f '?'
-        0x00,0x00,0x3e,0x63,0x63,0x63,0x06,0x0c,0x0c,0x00,0x0c,0x0c,0x00,0x00,0x00,0x00,
-
-        8, // 0x40 '@'
-        0x00,0x00,0x7c,0x86,0x03,0x73,0xdb,0xdb,0xdb,0xdb,0xdb,0x6e,0x00,0x00,0x00,0x00,
-
-        8, // 0x41 'A'
-        0x00,0x00,0x08,0x1c,0x36,0x63,0x63,0x63,0x7f,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x42 'B'
-        0x00,0x00,0x7e,0x33,0x33,0x33,0x3e,0x33,0x33,0x33,0x33,0x7e,0x00,0x00,0x00,0x00,
-
-        8, // 0x43 'C'
-        0x00,0x00,0x1e,0x33,0x61,0x60,0x60,0x60,0x60,0x61,0x33,0x1e,0x00,0x00,0x00,0x00,
-
-        8, // 0x44 'D'
-        0x00,0x00,0x7c,0x36,0x33,0x33,0x33,0x33,0x33,0x33,0x36,0x7c,0x00,0x00,0x00,0x00,
-
-        8, // 0x45 'E'
-        0x00,0x00,0x7f,0x33,0x31,0x34,0x3c,0x34,0x30,0x31,0x33,0x7f,0x00,0x00,0x00,0x00,
-
-        8, // 0x46 'F'
-        0x00,0x00,0x7f,0x33,0x31,0x34,0x3c,0x34,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00,
-
-        8, // 0x47 'G'
-        0x00,0x00,0x1f,0x33,0x61,0x60,0x60,0x6f,0x63,0x63,0x33,0x1e,0x00,0x00,0x00,0x00,
-
-        8, // 0x48 'H'
-        0x00,0x00,0x63,0x63,0x63,0x63,0x7f,0x63,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x49 'I'
-        0x00,0x00,0x1e,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
-
-        8, // 0x4a 'J'
-        0x00,0x00,0x0f,0x06,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x4b 'K'
-        0x00,0x00,0x73,0x33,0x36,0x36,0x3c,0x36,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00,
-
-        8, // 0x4c 'L'
-        0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x31,0x33,0x7f,0x00,0x00,0x00,0x00,
-
-        8, // 0x4d 'M'
-        0x00,0x00,0x63,0x63,0x77,0x77,0x7f,0x6b,0x6b,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x4e 'N'
-        0x00,0x00,0x63,0x63,0x73,0x7b,0x6f,0x67,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x4f 'O'
-        0x00,0x00,0x1c,0x36,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1c,0x00,0x00,0x00,0x00,
-
-        8, // 0x50 'P'
-        0x00,0x00,0x7e,0x33,0x33,0x33,0x33,0x3e,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00,
-
-        8, // 0x51 'Q'
-        0x00,0x00,0x1c,0x36,0x63,0x63,0x63,0x63,0x63,0x6f,0x36,0x1e,0x03,0x00,0x00,0x00,
-
-        8, // 0x52 'R'
-        0x00,0x00,0x7e,0x33,0x33,0x33,0x33,0x3e,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00,
-
-        8, // 0x53 'S'
-        0x00,0x00,0x3e,0x63,0x63,0x30,0x18,0x0c,0x06,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x54 'T'
-        0x00,0x00,0x3f,0x3f,0x2d,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
-
-        8, // 0x55 'U'
-        0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x56 'V'
-        0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1c,0x08,0x00,0x00,0x00,0x00,
-
-        8, // 0x57 'W'
-        0x00,0x00,0x63,0x63,0x63,0x6b,0x6b,0x7f,0x77,0x77,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x58 'X'
-        0x00,0x00,0x63,0x63,0x63,0x36,0x1c,0x1c,0x36,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x59 'Y'
-        0x00,0x00,0x33,0x33,0x33,0x33,0x1e,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
-
-        8, // 0x5a 'Z'
-        0x00,0x00,0x7f,0x63,0x43,0x06,0x0c,0x18,0x30,0x61,0x63,0x7f,0x00,0x00,0x00,0x00,
-
-        8, // 0x5b '['
-        0x00,0x1f,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x1f,0x00,0x00,0x00,
-
-        8, // 0x5c '\'
-        0x00,0x60,0x60,0x30,0x30,0x18,0x18,0x0c,0x0c,0x06,0x06,0x03,0x03,0x00,0x00,0x00,
-
-        8, // 0x5d ']'
-        0x00,0x7c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x7c,0x00,0x00,0x00,
-
-        8, // 0x5e '^'
-        0x00,0x00,0x08,0x1c,0x36,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5f '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,0x00,0x00,
-
-        8, // 0x60 '`'
-        0x00,0x00,0x18,0x18,0x18,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x3c,0x66,0x06,0x3e,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
-
-        8, // 0x62 'b'
-        0x00,0x00,0x70,0x30,0x30,0x3c,0x36,0x33,0x33,0x33,0x33,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x63,0x60,0x60,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x64 'd'
-        0x00,0x00,0x0e,0x06,0x06,0x1e,0x36,0x66,0x66,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
-
-        8, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x63,0x7f,0x60,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x66 'f'
-        0x00,0x00,0x0e,0x1b,0x1b,0x18,0x3c,0x18,0x18,0x18,0x18,0x3c,0x00,0x00,0x00,0x00,
-
-        8, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x3b,0x66,0x66,0x66,0x66,0x66,0x3e,0x06,0x66,0x3c,0x00,
-
-        8, // 0x68 'h'
-        0x00,0x00,0x70,0x30,0x30,0x36,0x3b,0x33,0x33,0x33,0x33,0x73,0x00,0x00,0x00,0x00,
-
-        8, // 0x69 'i'
-        0x00,0x00,0x0c,0x0c,0x00,0x1c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
-
-        8, // 0x6a 'j'
-        0x00,0x00,0x06,0x06,0x00,0x0e,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3c,0x00,0x00,
-
-        8, // 0x6b 'k'
-        0x00,0x00,0x70,0x30,0x30,0x33,0x33,0x36,0x3c,0x36,0x33,0x73,0x00,0x00,0x00,0x00,
-
-        8, // 0x6c 'l'
-        0x00,0x00,0x1c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
-
-        8, // 0x6d 'm'
-        0x00,0x00,0x00,0x00,0x00,0x76,0x7f,0x6b,0x6b,0x6b,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x6e 'n'
-        0x00,0x00,0x00,0x00,0x00,0x6e,0x33,0x33,0x33,0x33,0x33,0x33,0x00,0x00,0x00,0x00,
-
-        8, // 0x6f 'o'
-        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x6e,0x33,0x33,0x33,0x33,0x33,0x3e,0x30,0x30,0x78,0x00,
-
-        8, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x3b,0x66,0x66,0x66,0x66,0x66,0x3e,0x06,0x06,0x0f,0x00,
-
-        8, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x6e,0x3b,0x33,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00,
-
-        8, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x60,0x3e,0x03,0x63,0x3e,0x00,0x00,0x00,0x00,
-
-        8, // 0x74 't'
-        0x00,0x00,0x08,0x18,0x18,0x7e,0x18,0x18,0x18,0x18,0x1b,0x0e,0x00,0x00,0x00,0x00,
-
-        8, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
-
-        8, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x63,0x36,0x1c,0x08,0x00,0x00,0x00,0x00,
-
-        8, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x6b,0x6b,0x7f,0x36,0x36,0x00,0x00,0x00,0x00,
-
-        8, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x36,0x1c,0x36,0x63,0x63,0x00,0x00,0x00,0x00,
-
-        8, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x3f,0x03,0x06,0x7c,0x00,
-
-        8, // 0x7a 'z'
-        0x00,0x00,0x00,0x00,0x00,0x7f,0x63,0x06,0x0c,0x18,0x31,0x7f,0x00,0x00,0x00,0x00,
-
-        8, // 0x7b '{'
-        0x00,0x03,0x04,0x0c,0x0c,0x0c,0x08,0x30,0x08,0x0c,0x0c,0x0c,0x04,0x03,0x00,0x00,
-
-        8, // 0x7c '|'
-        0x00,0x00,0x0c,0x0c,0x0c,0x0c,0x0c,0x00,0x0c,0x0c,0x0c,0x0c,0x0c,0x00,0x00,0x00,
-
-        8, // 0x7d '}'
-        0x00,0x60,0x10,0x18,0x18,0x18,0x08,0x06,0x08,0x18,0x18,0x18,0x10,0x60,0x00,0x00,
-
-        8, // 0x7e '~'
-        0x00,0x00,0x3b,0x6e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x7f ''
-        0x00,0x00,0x00,0x00,0x00,0x08,0x1c,0x36,0x63,0x63,0x7f,0x00,0x00,0x00,0x00,0x00,
-        0
-    };
-
-    const int8u mcs11_prop[] = 
-    {
-        11, 2, 32, 128-32,
-        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
-        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
-        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
-        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
-        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
-        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
-        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
-        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
-        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
-        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
-        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
-
-        4, // 0x22 '"'
-        0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x23 '#'
-        0x00,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x00,
-
-        6, // 0x24 '$'
-        0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,
-
-        6, // 0x25 '%'
-        0x00,0x00,0x68,0xA8,0xD0,0x10,0x20,0x2C,0x54,0x58,0x00,
-
-        6, // 0x26 '&'
-        0x00,0x20,0x50,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,
-
-        3, // 0x27 '''
-        0x40,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x28 '('
-        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
-
-        5, // 0x29 ')'
-        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
-
-        6, // 0x2A '*'
-        0x00,0x00,0x28,0x7C,0x38,0x7C,0x28,0x00,0x00,0x00,0x00,
-
-        6, // 0x2B '+'
-        0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0xC0,
-
-        6, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,
-
-        7, // 0x2F '/'
-        0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,
-
-        6, // 0x30 '0'
-        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,
-
-        4, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        6, // 0x32 '2'
-        0x00,0x38,0x44,0x44,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,
-
-        6, // 0x33 '3'
-        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x08,0x18,0x18,0x28,0x28,0x48,0x7C,0x08,0x08,0x00,
-
-        6, // 0x35 '5'
-        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,
-
-        6, // 0x36 '6'
-        0x00,0x38,0x44,0x40,0x40,0x78,0x44,0x44,0x44,0x38,0x00,
-
-        6, // 0x37 '7'
-        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,
-
-        6, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,
-
-        6, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,
-
-        4, // 0x3A ':'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,
-
-        4, // 0x3B ';'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0xC0,
-
-        6, // 0x3C '<'
-        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
-
-        6, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,
-
-        6, // 0x3E '>'
-        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,
-
-        6, // 0x40 '@'
-        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,
-
-        6, // 0x41 'A'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,
-
-        6, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,
-
-        6, // 0x44 'D'
-        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,
-
-        6, // 0x45 'E'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,
-
-        6, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,
-
-        6, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,
-
-        4, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x08,0x48,0x30,0x00,
-
-        6, // 0x4B 'K'
-        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,
-
-        8, // 0x4D 'M'
-        0x00,0x41,0x63,0x55,0x49,0x49,0x41,0x41,0x41,0x41,0x00,
-
-        7, // 0x4E 'N'
-        0x00,0x42,0x42,0x62,0x52,0x4A,0x46,0x42,0x42,0x42,0x00,
-
-        6, // 0x4F 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,
-
-        6, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x40,0x00,
-
-        6, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,
-
-        6, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x44,0x00,
-
-        6, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,
-
-        6, // 0x54 'T'
-        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
-
-        6, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,
-
-        8, // 0x57 'W'
-        0x00,0x41,0x41,0x41,0x41,0x49,0x49,0x49,0x55,0x22,0x00,
-
-        6, // 0x58 'X'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,
-
-        6, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x10,0x00,
-
-        6, // 0x5A 'Z'
-        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,
-
-        5, // 0x5B '['
-        0x30,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x30,
-
-        7, // 0x5C '\'
-        0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
-
-        4, // 0x5D ']'
-        0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
-
-        6, // 0x5E '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,
-
-        4, // 0x60 '`'
-        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,
-
-        6, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,
-
-        6, // 0x64 'd'
-        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,
-
-        6, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x10,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        6, // 0x67 'g'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,
-
-        6, // 0x68 'h'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,
-
-        2, // 0x69 'i'
-        0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        3, // 0x6A 'j'
-        0x00,0x20,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,
-
-        5, // 0x6B 'k'
-        0x00,0x40,0x40,0x48,0x50,0x60,0x60,0x50,0x48,0x48,0x00,
-
-        2, // 0x6C 'l'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        8, // 0x6D 'm'
-        0x00,0x00,0x00,0x76,0x49,0x49,0x49,0x49,0x41,0x41,0x00,
-
-        6, // 0x6E 'n'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,
-
-        6, // 0x6F 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,
-
-        6, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
-
-        6, // 0x71 'q'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        6, // 0x73 's'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,
-
-        5, // 0x74 't'
-        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x28,0x10,0x00,
-
-        6, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,
-
-        8, // 0x77 'w'
-        0x00,0x00,0x00,0x41,0x41,0x41,0x41,0x49,0x49,0x36,0x00,
-
-        6, // 0x78 'x'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,
-
-        6, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x3C,0x04,0x08,0x70,
-
-        6, // 0x7A 'z'
-        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,
-
-        5, // 0x7B '{'
-        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,
-
-        3, // 0x7C '|'
-        0x00,0x40,0x40,0x40,0x40,0x00,0x40,0x40,0x40,0x40,0x00,
-
-        5, // 0x7D '}'
-        0xC0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xC0,
-
-        6, // 0x7E '~'
-        0x00,0x24,0x54,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x7F ''
-        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs11_prop_condensed[] = 
-    {
-        11, 2, 32, 128-32,
-        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
-        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
-        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
-        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
-        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
-        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
-        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
-        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
-        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
-        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
-        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
-
-        3, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        3, // 0x21 '!'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x40,0x00,
-
-        4, // 0x22 '"'
-        0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x23 '#'
-        0x00,0x50,0x50,0xF8,0x50,0x50,0x50,0xF8,0x50,0x50,0x00,
-
-        5, // 0x24 '$'
-        0x00,0x40,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x20,0x00,
-
-        5, // 0x25 '%'
-        0x00,0x00,0x90,0x90,0x20,0x20,0x40,0x40,0x90,0x90,0x00,
-
-        5, // 0x26 '&'
-        0x00,0x40,0xA0,0xA0,0xA0,0x40,0xA8,0x90,0x90,0x68,0x00,
-
-        5, // 0x27 '''
-        0x00,0x00,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
-
-        4, // 0x29 ')'
-        0x80,0x40,0x40,0x20,0x20,0x20,0x20,0x20,0x40,0x40,0x80,
-
-        5, // 0x2A '*'
-        0x00,0x00,0x90,0x60,0xF0,0x60,0x90,0x00,0x00,0x00,0x00,
-
-        5, // 0x2B '+'
-        0x00,0x00,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0xC0,
-
-        5, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x00,
-
-        6, // 0x2F '/'
-        0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
-
-        5, // 0x30 '0'
-        0x00,0x70,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
-
-        3, // 0x31 '1'
-        0x00,0x40,0xC0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        5, // 0x32 '2'
-        0x00,0x60,0x90,0x90,0x10,0x10,0x20,0x40,0x80,0xF0,0x00,
-
-        5, // 0x33 '3'
-        0x00,0x60,0x90,0x10,0x10,0x60,0x10,0x10,0x90,0x60,0x00,
-
-        5, // 0x34 '4'
-        0x00,0x10,0x30,0x30,0x50,0x50,0x90,0xF0,0x10,0x10,0x00,
-
-        5, // 0x35 '5'
-        0x00,0xF0,0x80,0x80,0xE0,0x90,0x10,0x10,0x90,0x60,0x00,
-
-        5, // 0x36 '6'
-        0x00,0x60,0x90,0x80,0x80,0xE0,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x37 '7'
-        0x00,0xF0,0x10,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x00,
-
-        5, // 0x38 '8'
-        0x00,0x60,0x90,0x90,0x90,0x60,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x39 '9'
-        0x00,0x60,0x90,0x90,0x90,0x70,0x10,0x10,0x90,0x60,0x00,
-
-        4, // 0x3A ':'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,
-
-        4, // 0x3B ';'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0xC0,
-
-        6, // 0x3C '<'
-        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x00,
-
-        5, // 0x3D '='
-        0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0xF0,0x00,0x00,0x00,
-
-        6, // 0x3E '>'
-        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,0x00,
-
-        5, // 0x3F '?'
-        0x00,0x60,0x90,0x10,0x10,0x20,0x40,0x00,0x40,0x00,0x00,
-
-        5, // 0x40 '@'
-        0x00,0x60,0x90,0x90,0xB0,0xB0,0xB0,0x80,0x80,0x70,0x00,
-
-        5, // 0x41 'A'
-        0x00,0x60,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x42 'B'
-        0x00,0xE0,0x90,0x90,0x90,0xE0,0x90,0x90,0x90,0xE0,0x00,
-
-        5, // 0x43 'C'
-        0x00,0x60,0x90,0x80,0x80,0x80,0x80,0x80,0x90,0x60,0x00,
-
-        5, // 0x44 'D'
-        0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
-
-        5, // 0x45 'E'
-        0x00,0xF0,0x80,0x80,0x80,0xF0,0x80,0x80,0x80,0xF0,0x00,
-
-        5, // 0x46 'F'
-        0x00,0xF0,0x80,0x80,0x80,0xF0,0x80,0x80,0x80,0x80,0x00,
-
-        5, // 0x47 'G'
-        0x00,0x70,0x80,0x80,0x80,0xB0,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x48 'H'
-        0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,
-
-        4, // 0x49 'I'
-        0x00,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,
-
-        5, // 0x4A 'J'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0xA0,0xA0,0x40,0x00,
-
-        5, // 0x4B 'K'
-        0x00,0x90,0x90,0xA0,0xA0,0xC0,0xA0,0xA0,0x90,0x90,0x00,
-
-        5, // 0x4C 'L'
-        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xF0,0x00,
-
-        6, // 0x4D 'M'
-        0x00,0x88,0xD8,0xA8,0xA8,0xA8,0x88,0x88,0x88,0x88,0x00,
-
-        5, // 0x4E 'N'
-        0x00,0x90,0x90,0xD0,0xD0,0xB0,0xB0,0x90,0x90,0x90,0x00,
-
-        5, // 0x4F 'O'
-        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x50 'P'
-        0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0x80,0x80,0x80,0x00,
-
-        5, // 0x51 'Q'
-        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x30,
-
-        5, // 0x52 'R'
-        0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0xA0,0x90,0x90,0x00,
-
-        5, // 0x53 'S'
-        0x00,0x60,0x90,0x80,0x80,0x60,0x10,0x10,0x90,0x60,0x00,
-
-        6, // 0x54 'T'
-        0x00,0xF8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x55 'U'
-        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x88,0x88,0x88,0x88,0x50,0x50,0x50,0x20,0x20,0x00,
-
-        6, // 0x57 'W'
-        0x00,0x88,0x88,0x88,0xA8,0xA8,0xA8,0xA8,0xA8,0x50,0x00,
-
-        5, // 0x58 'X'
-        0x00,0x90,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x90,0x00,
-
-        6, // 0x59 'Y'
-        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x5A 'Z'
-        0x00,0xF0,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0xF0,0x00,
-
-        4, // 0x5B '['
-        0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,0x00,
-
-        6, // 0x5C '\'
-        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
-
-        4, // 0x5D ']'
-        0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,0x00,
-
-        5, // 0x5E '^'
-        0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,
-
-        5, // 0x60 '`'
-        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x61 'a'
-        0x00,0x00,0x00,0x60,0x90,0x10,0x70,0x90,0x90,0x70,0x00,
-
-        5, // 0x62 'b'
-        0x00,0x80,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0xE0,0x00,
-
-        5, // 0x63 'c'
-        0x00,0x00,0x00,0x60,0x90,0x80,0x80,0x80,0x90,0x60,0x00,
-
-        5, // 0x64 'd'
-        0x00,0x10,0x10,0x10,0x70,0x90,0x90,0x90,0x90,0x70,0x00,
-
-        5, // 0x65 'e'
-        0x00,0x00,0x00,0x60,0x90,0x90,0xF0,0x80,0x90,0x60,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x20,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        5, // 0x67 'g'
-        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0x90,0x60,
-
-        5, // 0x68 'h'
-        0x00,0x80,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,
-
-        2, // 0x69 'i'
-        0x00,0x80,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,
-
-        4, // 0x6A 'j'
-        0x00,0x20,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,
-
-        5, // 0x6B 'k'
-        0x00,0x80,0x80,0x90,0x90,0xA0,0xC0,0xA0,0x90,0x90,0x00,
-
-        2, // 0x6C 'l'
-        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,
-
-        6, // 0x6D 'm'
-        0x00,0x00,0x00,0xD0,0xA8,0xA8,0xA8,0x88,0x88,0x88,0x00,
-
-        5, // 0x6E 'n'
-        0x00,0x00,0x00,0xA0,0xD0,0x90,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x6F 'o'
-        0x00,0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x70 'p'
-        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0x80,0x80,
-
-        5, // 0x71 'q'
-        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x90,0x70,0x10,0x10,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0xB8,0x48,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        5, // 0x73 's'
-        0x00,0x00,0x00,0x60,0x90,0x40,0x20,0x10,0x90,0x60,0x00,
-
-        4, // 0x74 't'
-        0x00,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x20,0x00,
-
-        5, // 0x75 'u'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x70,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,
-
-        6, // 0x77 'w'
-        0x00,0x00,0x00,0x88,0x88,0x88,0xA8,0xA8,0xA8,0x50,0x00,
-
-        5, // 0x78 'x'
-        0x00,0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,
-
-        5, // 0x79 'y'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x70,0x10,0x20,0xC0,
-
-        5, // 0x7A 'z'
-        0x00,0x00,0x00,0xF0,0x10,0x20,0x40,0x80,0x80,0xF0,0x00,
-
-        5, // 0x7B '{'
-        0x30,0x40,0x40,0x40,0x40,0x80,0x40,0x40,0x40,0x40,0x30,
-
-        3, // 0x7C '|'
-        0x00,0x40,0x40,0x40,0x40,0x00,0x40,0x40,0x40,0x40,0x00,
-
-        5, // 0x7D '}'
-        0xC0,0x20,0x20,0x20,0x20,0x10,0x20,0x20,0x20,0x20,0xC0,
-
-        5, // 0x7E '~'
-        0x00,0x40,0xA8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x7F ''
-        0x00,0x20,0x70,0xD8,0x88,0x88,0xF8,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs12_prop[] = 
-    {
-        12, 3, 32, 128-32,
-        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4E,0x00,0x5B,0x00,0x68,0x00,
-        0x75,0x00,0x82,0x00,0x8F,0x00,0x9C,0x00,0xA9,0x00,0xB6,0x00,0xC3,0x00,0xD0,0x00,0xDD,0x00,
-        0xEA,0x00,0xF7,0x00,0x04,0x01,0x11,0x01,0x1E,0x01,0x2B,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
-        0x5F,0x01,0x6C,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xA0,0x01,0xAD,0x01,0xBA,0x01,0xC7,0x01,
-        0xD4,0x01,0xE1,0x01,0xEE,0x01,0xFB,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2F,0x02,0x3C,0x02,
-        0x49,0x02,0x62,0x02,0x6F,0x02,0x7C,0x02,0x89,0x02,0x96,0x02,0xA3,0x02,0xB0,0x02,0xBD,0x02,
-        0xCA,0x02,0xD7,0x02,0xF0,0x02,0xFD,0x02,0x0A,0x03,0x17,0x03,0x24,0x03,0x31,0x03,0x3E,0x03,
-        0x4B,0x03,0x58,0x03,0x65,0x03,0x72,0x03,0x7F,0x03,0x8C,0x03,0x99,0x03,0xA6,0x03,0xB3,0x03,
-        0xC0,0x03,0xCD,0x03,0xDA,0x03,0xE7,0x03,0xF4,0x03,0x01,0x04,0x1A,0x04,0x27,0x04,0x34,0x04,
-        0x41,0x04,0x4E,0x04,0x5B,0x04,0x68,0x04,0x75,0x04,0x82,0x04,0x8F,0x04,0xA8,0x04,0xB5,0x04,
-        0xC2,0x04,0xCF,0x04,0xDC,0x04,0xE9,0x04,0xF6,0x04,0x03,0x05,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        4, // 0x22 '"'
-        0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x23 '#'
-        0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x00,
-
-        6, // 0x24 '$'
-        0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,0x00,
-
-        7, // 0x25 '%'
-        0x32,0x54,0x64,0x08,0x08,0x10,0x10,0x26,0x2A,0x4C,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x30,0x48,0x48,0x48,0x30,0x4A,0x4A,0x44,0x3A,0x00,0x00,
-
-        3, // 0x27 '''
-        0x40,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x00,
-
-        5, // 0x29 ')'
-        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,0x00,
-
-        6, // 0x2A '*'
-        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,
-
-        6, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x40,0x80,
-
-        6, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        7, // 0x2F '/'
-        0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,0x00,
-
-        4, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x08,0x18,0x28,0x28,0x48,0x48,0x7C,0x08,0x08,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x37 '7'
-        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        4, // 0x3A ':'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        4, // 0x3B ';'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x40,0x80,
-
-        6, // 0x3C '<'
-        0x00,0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
-
-        6, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,
-
-        6, // 0x3E '>'
-        0x00,0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
-
-        6, // 0x45 'E'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
-
-        6, // 0x4B 'K'
-        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        9, // 0x4D 'M'
-        0x00,0x00,0x41,0x00,0x63,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x4E 'N'
-        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x44,0x00,0x00,
-
-        7, // 0x4F 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x54 'T'
-        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        9, // 0x57 'W'
-        0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x22,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x5A 'Z'
-        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,
-
-        4, // 0x5B '['
-        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,
-
-        7, // 0x5C '\'
-        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
-
-        4, // 0x5D ']'
-        0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xE0,0x00,
-
-        6, // 0x5E '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
-
-        4, // 0x60 '`'
-        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x78,
-
-        7, // 0x68 'h'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x10,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x90,0x60,
-
-        6, // 0x6B 'k'
-        0x00,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        9, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x76,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x6E 'n'
-        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x6F 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
-
-        5, // 0x74 't'
-        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x18,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        9, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x36,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3C,0x08,0x70,
-
-        6, // 0x7A 'z'
-        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        5, // 0x7B '{'
-        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,
-
-        3, // 0x7C '|'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        5, // 0x7D '}'
-        0xC0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xC0,0x00,
-
-        7, // 0x7E '~'
-        0x00,0x60,0x92,0x92,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7F ''
-        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs13_prop[] = 
-    {
-        13, 4, 32, 128-32,
-        0x00,0x00,0x0E,0x00,0x1C,0x00,0x2A,0x00,0x38,0x00,0x46,0x00,0x54,0x00,0x62,0x00,0x70,0x00,
-        0x7E,0x00,0x8C,0x00,0x9A,0x00,0xA8,0x00,0xB6,0x00,0xC4,0x00,0xD2,0x00,0xE0,0x00,0xEE,0x00,
-        0xFC,0x00,0x0A,0x01,0x18,0x01,0x26,0x01,0x34,0x01,0x42,0x01,0x50,0x01,0x5E,0x01,0x6C,0x01,
-        0x7A,0x01,0x88,0x01,0x96,0x01,0xA4,0x01,0xB2,0x01,0xC0,0x01,0xCE,0x01,0xDC,0x01,0xEA,0x01,
-        0xF8,0x01,0x06,0x02,0x14,0x02,0x22,0x02,0x30,0x02,0x3E,0x02,0x4C,0x02,0x5A,0x02,0x68,0x02,
-        0x76,0x02,0x91,0x02,0x9F,0x02,0xAD,0x02,0xBB,0x02,0xC9,0x02,0xD7,0x02,0xE5,0x02,0xF3,0x02,
-        0x01,0x03,0x0F,0x03,0x2A,0x03,0x38,0x03,0x46,0x03,0x54,0x03,0x62,0x03,0x70,0x03,0x7E,0x03,
-        0x8C,0x03,0x9A,0x03,0xA8,0x03,0xB6,0x03,0xC4,0x03,0xD2,0x03,0xE0,0x03,0xEE,0x03,0xFC,0x03,
-        0x0A,0x04,0x18,0x04,0x26,0x04,0x34,0x04,0x42,0x04,0x50,0x04,0x6B,0x04,0x79,0x04,0x87,0x04,
-        0x95,0x04,0xA3,0x04,0xB1,0x04,0xBF,0x04,0xCD,0x04,0xDB,0x04,0xE9,0x04,0x04,0x05,0x12,0x05,
-        0x20,0x05,0x2E,0x05,0x3C,0x05,0x4A,0x05,0x58,0x05,0x66,0x05,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        4, // 0x22 '"'
-        0x00,0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x23 '#'
-        0x00,0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x00,
-
-        6, // 0x24 '$'
-        0x00,0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,0x00,
-
-        7, // 0x25 '%'
-        0x00,0x32,0x54,0x64,0x08,0x08,0x10,0x10,0x26,0x2A,0x4C,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x30,0x48,0x48,0x48,0x30,0x4A,0x4A,0x44,0x3A,0x00,0x00,0x00,
-
-        3, // 0x27 '''
-        0x00,0x40,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x00,0x00,
-
-        5, // 0x29 ')'
-        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,0x00,0x00,
-
-        6, // 0x2A '*'
-        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,0x00,
-
-        6, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x20,0x40,0x80,
-
-        6, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,
-
-        7, // 0x2F '/'
-        0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        4, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x08,0x18,0x28,0x28,0x48,0x48,0x7C,0x08,0x08,0x00,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        6, // 0x37 '7'
-        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        4, // 0x3A ':'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,
-
-        4, // 0x3B ';'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x20,0x40,0x80,
-
-        6, // 0x3C '<'
-        0x00,0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,
-
-        6, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x3E '>'
-        0x00,0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,0x00,
-
-        6, // 0x45 'E'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,0x00,
-
-        6, // 0x4B 'K'
-        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,0x00,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
-
-        9, // 0x4D 'M'
-        0x00,0x00,0x41,0x00,0x63,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x4E 'N'
-        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x4F 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        6, // 0x54 'T'
-        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
-
-        9, // 0x57 'W'
-        0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        6, // 0x5A 'Z'
-        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,0x00,
-
-        4, // 0x5B '['
-        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,0x00,
-
-        7, // 0x5C '\'
-        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,0x00,
-
-        4, // 0x5D ']'
-        0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xE0,0x00,0x00,
-
-        6, // 0x5E '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,
-
-        4, // 0x60 '`'
-        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,
-
-        7, // 0x68 'h'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x10,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x90,0x60,0x00,
-
-        6, // 0x6B 'k'
-        0x00,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        9, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x76,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x6E 'n'
-        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x6F 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,0x04,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        5, // 0x74 't'
-        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x18,0x00,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
-
-        9, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x36,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x08,0x70,
-
-        6, // 0x7A 'z'
-        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
-
-        5, // 0x7B '{'
-        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,0x00,
-
-        3, // 0x7C '|'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        5, // 0x7D '}'
-        0xC0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xC0,0x00,0x00,
-
-        7, // 0x7E '~'
-        0x00,0x60,0x92,0x92,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7F ''
-        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs5x10_mono[] = 
-    {
-        10, 2, 32, 128-32,
-        0x00,0x00,0x0B,0x00,0x16,0x00,0x21,0x00,0x2C,0x00,0x37,0x00,0x42,0x00,0x4D,0x00,0x58,0x00,
-        0x63,0x00,0x6E,0x00,0x79,0x00,0x84,0x00,0x8F,0x00,0x9A,0x00,0xA5,0x00,0xB0,0x00,0xBB,0x00,
-        0xC6,0x00,0xD1,0x00,0xDC,0x00,0xE7,0x00,0xF2,0x00,0xFD,0x00,0x08,0x01,0x13,0x01,0x1E,0x01,
-        0x29,0x01,0x34,0x01,0x3F,0x01,0x4A,0x01,0x55,0x01,0x60,0x01,0x6B,0x01,0x76,0x01,0x81,0x01,
-        0x8C,0x01,0x97,0x01,0xA2,0x01,0xAD,0x01,0xB8,0x01,0xC3,0x01,0xCE,0x01,0xD9,0x01,0xE4,0x01,
-        0xEF,0x01,0xFA,0x01,0x05,0x02,0x10,0x02,0x1B,0x02,0x26,0x02,0x31,0x02,0x3C,0x02,0x47,0x02,
-        0x52,0x02,0x5D,0x02,0x68,0x02,0x73,0x02,0x7E,0x02,0x89,0x02,0x94,0x02,0x9F,0x02,0xAA,0x02,
-        0xB5,0x02,0xC0,0x02,0xCB,0x02,0xD6,0x02,0xE1,0x02,0xEC,0x02,0xF7,0x02,0x02,0x03,0x0D,0x03,
-        0x18,0x03,0x23,0x03,0x2E,0x03,0x39,0x03,0x44,0x03,0x4F,0x03,0x5A,0x03,0x65,0x03,0x70,0x03,
-        0x7B,0x03,0x86,0x03,0x91,0x03,0x9C,0x03,0xA7,0x03,0xB2,0x03,0xBD,0x03,0xC8,0x03,0xD3,0x03,
-        0xDE,0x03,0xE9,0x03,0xF4,0x03,0xFF,0x03,0x0A,0x04,0x15,0x04,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x23 '#'
-        0x00,0x50,0x50,0xF8,0x50,0x50,0x50,0xF8,0x50,0x50,
-
-        5, // 0x24 '$'
-        0x00,0x40,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x20,
-
-        5, // 0x25 '%'
-        0x00,0x00,0x90,0x90,0x20,0x20,0x40,0x40,0x90,0x90,
-
-        5, // 0x26 '&'
-        0x00,0x40,0xA0,0xA0,0xA0,0x40,0xA8,0x90,0x90,0x68,
-
-        5, // 0x27 '''
-        0x00,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
-
-        5, // 0x29 ')'
-        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
-
-        5, // 0x2A '*'
-        0x00,0x00,0x90,0x60,0xF0,0x60,0x90,0x00,0x00,0x00,
-
-        5, // 0x2B '+'
-        0x00,0x00,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0xC0,
-
-        5, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,
-
-        5, // 0x2F '/'
-        0x00,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x00,
-
-        5, // 0x30 '0'
-        0x00,0x70,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
-
-        5, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x32 '2'
-        0x00,0x60,0x90,0x90,0x10,0x20,0x40,0x80,0xF0,0x00,
-
-        5, // 0x33 '3'
-        0x00,0x60,0x90,0x10,0x60,0x10,0x10,0x90,0x60,0x00,
-
-        5, // 0x34 '4'
-        0x00,0x10,0x30,0x50,0x50,0x90,0xF0,0x10,0x10,0x00,
-
-        5, // 0x35 '5'
-        0x00,0xF0,0x80,0x80,0xE0,0x10,0x10,0x90,0x60,0x00,
-
-        5, // 0x36 '6'
-        0x00,0x60,0x80,0x80,0xE0,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x37 '7'
-        0x00,0xF0,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x00,
-
-        5, // 0x38 '8'
-        0x00,0x60,0x90,0x90,0x60,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x39 '9'
-        0x00,0x60,0x90,0x90,0x90,0x70,0x10,0x10,0x60,0x00,
-
-        5, // 0x3A ':'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x00,
-
-        5, // 0x3B ';'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0xC0,
-
-        5, // 0x3C '<'
-        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,
-
-        5, // 0x3D '='
-        0x00,0x00,0x00,0x00,0xF0,0x00,0xF0,0x00,0x00,0x00,
-
-        5, // 0x3E '>'
-        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,
-
-        5, // 0x3F '?'
-        0x00,0x60,0x90,0x10,0x10,0x20,0x40,0x00,0x40,0x00,
-
-        5, // 0x40 '@'
-        0x00,0x60,0x90,0x90,0xB0,0xB0,0x80,0x80,0x70,0x00,
-
-        5, // 0x41 'A'
-        0x00,0x60,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x00,
-
-        5, // 0x42 'B'
-        0x00,0xE0,0x90,0x90,0xE0,0x90,0x90,0x90,0xE0,0x00,
-
-        5, // 0x43 'C'
-        0x00,0x60,0x90,0x80,0x80,0x80,0x80,0x90,0x60,0x00,
-
-        5, // 0x44 'D'
-        0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
-
-        5, // 0x45 'E'
-        0x00,0xF0,0x80,0x80,0xF0,0x80,0x80,0x80,0xF0,0x00,
-
-        5, // 0x46 'F'
-        0x00,0xF0,0x80,0x80,0xF0,0x80,0x80,0x80,0x80,0x00,
-
-        5, // 0x47 'G'
-        0x00,0x60,0x90,0x80,0x80,0xB0,0x90,0x90,0x60,0x00,
-
-        5, // 0x48 'H'
-        0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x4A 'J'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,0x00,
-
-        5, // 0x4B 'K'
-        0x00,0x90,0xA0,0xA0,0xC0,0xC0,0xA0,0xA0,0x90,0x00,
-
-        5, // 0x4C 'L'
-        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xF0,0x00,
-
-        5, // 0x4D 'M'
-        0x00,0x90,0x90,0xF0,0xF0,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x4E 'N'
-        0x00,0x90,0x90,0xD0,0xD0,0xB0,0xB0,0x90,0x90,0x00,
-
-        5, // 0x4F 'O'
-        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x50 'P'
-        0x00,0xE0,0x90,0x90,0x90,0xE0,0x80,0x80,0x80,0x00,
-
-        5, // 0x51 'Q'
-        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x30,
-
-        5, // 0x52 'R'
-        0x00,0xE0,0x90,0x90,0x90,0xE0,0xA0,0x90,0x90,0x00,
-
-        5, // 0x53 'S'
-        0x00,0x60,0x90,0x80,0x60,0x10,0x90,0x90,0x60,0x00,
-
-        5, // 0x54 'T'
-        0x00,0xF8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x55 'U'
-        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x56 'V'
-        0x00,0x90,0x90,0x90,0x50,0x50,0x50,0x20,0x20,0x00,
-
-        5, // 0x57 'W'
-        0x00,0x90,0x90,0x90,0x90,0x90,0xF0,0xF0,0x90,0x00,
-
-        5, // 0x58 'X'
-        0x00,0x90,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,
-
-        5, // 0x59 'Y'
-        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x5A 'Z'
-        0x00,0xF0,0x10,0x20,0x20,0x40,0x40,0x80,0xF0,0x00,
-
-        5, // 0x5B '['
-        0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,
-
-        5, // 0x5C '\'
-        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,
-
-        5, // 0x5D ']'
-        0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
-
-        5, // 0x5E '^'
-        0x00,0x20,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,
-
-        5, // 0x60 '`'
-        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x61 'a'
-        0x00,0x00,0x00,0x60,0x10,0x70,0x90,0x90,0x70,0x00,
-
-        5, // 0x62 'b'
-        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0xE0,0x00,
-
-        5, // 0x63 'c'
-        0x00,0x00,0x00,0x60,0x90,0x80,0x80,0x90,0x60,0x00,
-
-        5, // 0x64 'd'
-        0x00,0x10,0x10,0x70,0x90,0x90,0x90,0x90,0x70,0x00,
-
-        5, // 0x65 'e'
-        0x00,0x00,0x00,0x60,0x90,0x90,0xF0,0x80,0x70,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x00,
-
-        5, // 0x67 'g'
-        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0xE0,
-
-        5, // 0x68 'h'
-        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x69 'i'
-        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0xC0,
-
-        5, // 0x6B 'k'
-        0x00,0x80,0x80,0x90,0xA0,0xC0,0xA0,0x90,0x90,0x00,
-
-        5, // 0x6C 'l'
-        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
-
-        5, // 0x6D 'm'
-        0x00,0x00,0x00,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x6E 'n'
-        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,
-
-        5, // 0x6F 'o'
-        0x00,0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x60,0x00,
-
-        5, // 0x70 'p'
-        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0xE0,0x80,0x80,
-
-        5, // 0x71 'q'
-        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0x10,
-
-        5, // 0x72 'r'
-        0x00,0x00,0x00,0xB0,0x50,0x40,0x40,0x40,0xE0,0x00,
-
-        5, // 0x73 's'
-        0x00,0x00,0x00,0x60,0x90,0x40,0x20,0x90,0x60,0x00,
-
-        5, // 0x74 't'
-        0x00,0x40,0x40,0xE0,0x40,0x40,0x40,0x50,0x20,0x00,
-
-        5, // 0x75 'u'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x00,
-
-        5, // 0x76 'v'
-        0x00,0x00,0x00,0x90,0x90,0x50,0x50,0x20,0x20,0x00,
-
-        5, // 0x77 'w'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x00,
-
-        5, // 0x78 'x'
-        0x00,0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x00,
-
-        5, // 0x79 'y'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x70,0x10,0xE0,
-
-        5, // 0x7A 'z'
-        0x00,0x00,0x00,0xF0,0x10,0x20,0x40,0x80,0xF0,0x00,
-
-        5, // 0x7B '{'
-        0x30,0x40,0x40,0x40,0x80,0x40,0x40,0x40,0x40,0x30,
-
-        5, // 0x7C '|'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
-
-        5, // 0x7D '}'
-        0xC0,0x20,0x20,0x20,0x10,0x20,0x20,0x20,0x20,0xC0,
-
-        5, // 0x7E '~'
-        0x00,0x40,0xA8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x7F ''
-        0x00,0x20,0x70,0xD8,0x88,0x88,0xF8,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs5x11_mono[] = 
-    {
-        11, 3, 32, 128-32,
-        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
-        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
-        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
-        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
-        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
-        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
-        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
-        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
-        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
-        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
-        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x23 '#'
-        0x00,0x50,0x50,0xF8,0x50,0x50,0x50,0xF8,0x50,0x50,0x00,
-
-        5, // 0x24 '$'
-        0x00,0x40,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x20,0x00,
-
-        5, // 0x25 '%'
-        0x00,0x00,0x90,0x90,0x20,0x20,0x40,0x40,0x90,0x90,0x00,
-
-        5, // 0x26 '&'
-        0x00,0x40,0xA0,0xA0,0x40,0xA8,0x90,0x90,0x68,0x00,0x00,
-
-        5, // 0x27 '''
-        0x00,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x00,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
-
-        5, // 0x29 ')'
-        0x00,0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
-
-        5, // 0x2A '*'
-        0x00,0x00,0x90,0x60,0xF0,0x60,0x90,0x00,0x00,0x00,0x00,
-
-        5, // 0x2B '+'
-        0x00,0x00,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x40,0x80,
-
-        5, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        5, // 0x2F '/'
-        0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
-
-        5, // 0x30 '0'
-        0x00,0x70,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,0x00,
-
-        5, // 0x31 '1'
-        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        5, // 0x32 '2'
-        0x00,0x60,0x90,0x90,0x10,0x20,0x40,0x80,0xF0,0x00,0x00,
-
-        5, // 0x33 '3'
-        0x00,0x60,0x90,0x10,0x60,0x10,0x10,0x90,0x60,0x00,0x00,
-
-        5, // 0x34 '4'
-        0x00,0x10,0x30,0x50,0x50,0x90,0xF8,0x10,0x10,0x00,0x00,
-
-        5, // 0x35 '5'
-        0x00,0xF0,0x80,0xE0,0x90,0x10,0x10,0x90,0x60,0x00,0x00,
-
-        5, // 0x36 '6'
-        0x00,0x60,0x90,0x80,0xE0,0x90,0x90,0x90,0x60,0x00,0x00,
-
-        5, // 0x37 '7'
-        0x00,0xF0,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x00,0x00,
-
-        5, // 0x38 '8'
-        0x00,0x60,0x90,0x90,0x60,0x90,0x90,0x90,0x60,0x00,0x00,
-
-        5, // 0x39 '9'
-        0x00,0x60,0x90,0x90,0x90,0x70,0x10,0x90,0x60,0x00,0x00,
-
-        5, // 0x3A ':'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        5, // 0x3B ';'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x40,0x80,
-
-        5, // 0x3C '<'
-        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x00,
-
-        5, // 0x3D '='
-        0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0xF0,0x00,0x00,0x00,
-
-        5, // 0x3E '>'
-        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,0x00,
-
-        5, // 0x3F '?'
-        0x00,0x60,0x90,0x10,0x10,0x20,0x40,0x00,0x40,0x00,0x00,
-
-        5, // 0x40 '@'
-        0x00,0x60,0x90,0x90,0xB0,0xB0,0x80,0x80,0x70,0x00,0x00,
-
-        5, // 0x41 'A'
-        0x00,0x60,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x00,0x00,
-
-        5, // 0x42 'B'
-        0x00,0xE0,0x90,0x90,0xE0,0x90,0x90,0x90,0xE0,0x00,0x00,
-
-        5, // 0x43 'C'
-        0x00,0x60,0x90,0x80,0x80,0x80,0x80,0x90,0x60,0x00,0x00,
-
-        5, // 0x44 'D'
-        0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,0x00,
-
-        5, // 0x45 'E'
-        0x00,0xF0,0x80,0x80,0xE0,0x80,0x80,0x80,0xF0,0x00,0x00,
-
-        5, // 0x46 'F'
-        0x00,0xF0,0x80,0x80,0xE0,0x80,0x80,0x80,0x80,0x00,0x00,
-
-        5, // 0x47 'G'
-        0x00,0x60,0x90,0x80,0x80,0xB0,0x90,0x90,0x60,0x00,0x00,
-
-        5, // 0x48 'H'
-        0x00,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        5, // 0x4A 'J'
-        0x00,0x70,0x20,0x20,0x20,0x20,0xA0,0xA0,0x40,0x00,0x00,
-
-        5, // 0x4B 'K'
-        0x00,0x90,0xA0,0xA0,0xC0,0xA0,0xA0,0x90,0x90,0x00,0x00,
-
-        5, // 0x4C 'L'
-        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xF0,0x00,0x00,
-
-        5, // 0x4D 'M'
-        0x00,0x90,0xF0,0xF0,0x90,0x90,0x90,0x90,0x90,0x00,0x00,
-
-        5, // 0x4E 'N'
-        0x00,0x90,0x90,0xD0,0xD0,0xB0,0xB0,0x90,0x90,0x00,0x00,
-
-        5, // 0x4F 'O'
-        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,0x00,
-
-        5, // 0x50 'P'
-        0x00,0xE0,0x90,0x90,0x90,0xE0,0x80,0x80,0x80,0x00,0x00,
-
-        5, // 0x51 'Q'
-        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x30,0x00,
-
-        5, // 0x52 'R'
-        0x00,0xE0,0x90,0x90,0x90,0xE0,0xA0,0x90,0x90,0x00,0x00,
-
-        5, // 0x53 'S'
-        0x00,0x60,0x90,0x80,0x60,0x10,0x90,0x90,0x60,0x00,0x00,
-
-        5, // 0x54 'T'
-        0x00,0xF8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        5, // 0x55 'U'
-        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,0x00,
-
-        5, // 0x56 'V'
-        0x00,0x90,0x90,0x90,0x50,0x50,0x50,0x20,0x20,0x00,0x00,
-
-        5, // 0x57 'W'
-        0x00,0x90,0x90,0x90,0x90,0x90,0xF0,0xF0,0x90,0x00,0x00,
-
-        5, // 0x58 'X'
-        0x00,0x90,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,0x00,
-
-        5, // 0x59 'Y'
-        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x00,0x00,
-
-        5, // 0x5A 'Z'
-        0x00,0xF0,0x10,0x20,0x20,0x40,0x40,0x80,0xF0,0x00,0x00,
-
-        5, // 0x5B '['
-        0x00,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,
-
-        5, // 0x5C '\'
-        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
-
-        5, // 0x5D ']'
-        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
-
-        5, // 0x5E '^'
-        0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,
-
-        5, // 0x60 '`'
-        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x61 'a'
-        0x00,0x00,0x00,0x60,0x10,0x70,0x90,0x90,0x70,0x00,0x00,
-
-        5, // 0x62 'b'
-        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0xE0,0x00,0x00,
-
-        5, // 0x63 'c'
-        0x00,0x00,0x00,0x60,0x90,0x80,0x80,0x90,0x60,0x00,0x00,
-
-        5, // 0x64 'd'
-        0x00,0x10,0x10,0x70,0x90,0x90,0x90,0x90,0x70,0x00,0x00,
-
-        5, // 0x65 'e'
-        0x00,0x00,0x00,0x60,0x90,0x90,0xF0,0x80,0x70,0x00,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        5, // 0x67 'g'
-        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x90,0x70,0x10,0xE0,
-
-        5, // 0x68 'h'
-        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,0x00,
-
-        5, // 0x69 'i'
-        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,
-
-        5, // 0x6B 'k'
-        0x00,0x80,0x80,0x90,0xA0,0xC0,0xA0,0x90,0x90,0x00,0x00,
-
-        5, // 0x6C 'l'
-        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        5, // 0x6D 'm'
-        0x00,0x00,0x00,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,0x00,
-
-        5, // 0x6E 'n'
-        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,0x00,
-
-        5, // 0x6F 'o'
-        0x00,0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x60,0x00,0x00,
-
-        5, // 0x70 'p'
-        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0x80,0x80,
-
-        5, // 0x71 'q'
-        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x90,0x70,0x10,0x10,
-
-        5, // 0x72 'r'
-        0x00,0x00,0x00,0xA0,0x50,0x40,0x40,0x40,0xE0,0x00,0x00,
-
-        5, // 0x73 's'
-        0x00,0x00,0x00,0x60,0x90,0x40,0x20,0x90,0x60,0x00,0x00,
-
-        5, // 0x74 't'
-        0x00,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x30,0x00,0x00,
-
-        5, // 0x75 'u'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x00,0x00,
-
-        5, // 0x76 'v'
-        0x00,0x00,0x00,0x90,0x90,0x50,0x50,0x20,0x20,0x00,0x00,
-
-        5, // 0x77 'w'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x00,0x00,
-
-        5, // 0x78 'x'
-        0x00,0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x00,0x00,
-
-        5, // 0x79 'y'
-        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x10,0xE0,
-
-        5, // 0x7A 'z'
-        0x00,0x00,0x00,0xF0,0x10,0x20,0x40,0x80,0xF0,0x00,0x00,
-
-        5, // 0x7B '{'
-        0x30,0x40,0x40,0x40,0x40,0x80,0x40,0x40,0x40,0x40,0x30,
-
-        5, // 0x7C '|'
-        0x00,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x20,0x00,
-
-        5, // 0x7D '}'
-        0xC0,0x20,0x20,0x20,0x20,0x10,0x20,0x20,0x20,0x20,0xC0,
-
-        5, // 0x7E '~'
-        0x00,0x40,0xA8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x7F ''
-        0x00,0x20,0x70,0xD8,0x88,0x88,0xF8,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs6x10_mono[] = 
-    {
-        10, 3, 32, 128-32,
-        0x00,0x00,0x0B,0x00,0x16,0x00,0x21,0x00,0x2C,0x00,0x37,0x00,0x42,0x00,0x4D,0x00,0x58,0x00,
-        0x63,0x00,0x6E,0x00,0x79,0x00,0x84,0x00,0x8F,0x00,0x9A,0x00,0xA5,0x00,0xB0,0x00,0xBB,0x00,
-        0xC6,0x00,0xD1,0x00,0xDC,0x00,0xE7,0x00,0xF2,0x00,0xFD,0x00,0x08,0x01,0x13,0x01,0x1E,0x01,
-        0x29,0x01,0x34,0x01,0x3F,0x01,0x4A,0x01,0x55,0x01,0x60,0x01,0x6B,0x01,0x76,0x01,0x81,0x01,
-        0x8C,0x01,0x97,0x01,0xA2,0x01,0xAD,0x01,0xB8,0x01,0xC3,0x01,0xCE,0x01,0xD9,0x01,0xE4,0x01,
-        0xEF,0x01,0xFA,0x01,0x05,0x02,0x10,0x02,0x1B,0x02,0x26,0x02,0x31,0x02,0x3C,0x02,0x47,0x02,
-        0x52,0x02,0x5D,0x02,0x68,0x02,0x73,0x02,0x7E,0x02,0x89,0x02,0x94,0x02,0x9F,0x02,0xAA,0x02,
-        0xB5,0x02,0xC0,0x02,0xCB,0x02,0xD6,0x02,0xE1,0x02,0xEC,0x02,0xF7,0x02,0x02,0x03,0x0D,0x03,
-        0x18,0x03,0x23,0x03,0x2E,0x03,0x39,0x03,0x44,0x03,0x4F,0x03,0x5A,0x03,0x65,0x03,0x70,0x03,
-        0x7B,0x03,0x86,0x03,0x91,0x03,0x9C,0x03,0xA7,0x03,0xB2,0x03,0xBD,0x03,0xC8,0x03,0xD3,0x03,
-        0xDE,0x03,0xE9,0x03,0xF4,0x03,0xFF,0x03,0x0A,0x04,0x15,0x04,
-
-        6, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x10,0x10,0x10,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        6, // 0x22 '"'
-        0x00,0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x23 '#'
-        0x00,0x28,0x28,0x7C,0x28,0x28,0x7C,0x28,0x28,0x00,
-
-        6, // 0x24 '$'
-        0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,
-
-        6, // 0x25 '%'
-        0x00,0x08,0xC8,0xD0,0x10,0x20,0x2C,0x4C,0x40,0x00,
-
-        6, // 0x26 '&'
-        0x00,0x20,0x50,0x50,0x24,0x54,0x48,0x34,0x00,0x00,
-
-        6, // 0x27 '''
-        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x28 '('
-        0x08,0x10,0x10,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
-
-        6, // 0x29 ')'
-        0x20,0x10,0x10,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
-
-        6, // 0x2A '*'
-        0x00,0x00,0x28,0x7C,0x38,0x7C,0x28,0x00,0x00,0x00,
-
-        6, // 0x2B '+'
-        0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
-
-        6, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
-
-        6, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        6, // 0x2F '/'
-        0x00,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,
-
-        6, // 0x30 '0'
-        0x00,0x38,0x44,0x4C,0x54,0x64,0x44,0x38,0x00,0x00,
-
-        6, // 0x31 '1'
-        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x32 '2'
-        0x00,0x38,0x44,0x04,0x18,0x20,0x40,0x7C,0x00,0x00,
-
-        6, // 0x33 '3'
-        0x00,0x38,0x44,0x04,0x38,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x08,0x18,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,
-
-        6, // 0x35 '5'
-        0x00,0x7C,0x40,0x40,0x78,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x36 '6'
-        0x00,0x38,0x40,0x40,0x78,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x37 '7'
-        0x00,0x7C,0x04,0x08,0x10,0x20,0x20,0x20,0x00,0x00,
-
-        6, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x3C,0x04,0x04,0x38,0x00,0x00,
-
-        6, // 0x3A ':'
-        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        6, // 0x3B ';'
-        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x20,0x40,
-
-        6, // 0x3C '<'
-        0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
-
-        6, // 0x3D '='
-        0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,
-
-        6, // 0x3E '>'
-        0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x38,0x44,0x04,0x18,0x10,0x00,0x10,0x00,0x00,
-
-        6, // 0x40 '@'
-        0x00,0x38,0x44,0x5C,0x54,0x5C,0x40,0x38,0x00,0x00,
-
-        6, // 0x41 'A'
-        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x00,0x00,
-
-        6, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        6, // 0x44 'D'
-        0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x45 'E'
-        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        6, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x4C,0x44,0x44,0x3C,0x00,0x00,
-
-        6, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x49 'I'
-        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x1C,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
-
-        6, // 0x4B 'K'
-        0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x4D 'M'
-        0x00,0x44,0x6C,0x54,0x54,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x4E 'N'
-        0x00,0x44,0x44,0x64,0x54,0x4C,0x44,0x44,0x00,0x00,
-
-        6, // 0x4F 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        6, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
-
-        6, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
-
-        6, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x54 'T'
-        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x00,0x00,
-
-        6, // 0x57 'W'
-        0x00,0x44,0x44,0x54,0x54,0x54,0x54,0x28,0x00,0x00,
-
-        6, // 0x58 'X'
-        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
-
-        6, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x5A 'Z'
-        0x00,0x78,0x08,0x10,0x20,0x40,0x40,0x78,0x00,0x00,
-
-        6, // 0x5B '['
-        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
-
-        6, // 0x5C '\'
-        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
-
-        6, // 0x5D ']'
-        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
-
-        6, // 0x5E '^'
-        0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
-
-        6, // 0x60 '`'
-        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x3C,0x00,0x00,
-
-        6, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x3C,0x00,0x00,
-
-        6, // 0x64 'd'
-        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        6, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x78,0x40,0x3C,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x0C,0x10,0x10,0x38,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x67 'g'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x3C,0x04,0x38,
-
-        6, // 0x68 'h'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x69 'i'
-        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x6A 'j'
-        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x48,0x30,
-
-        6, // 0x6B 'k'
-        0x00,0x40,0x40,0x48,0x50,0x60,0x50,0x48,0x00,0x00,
-
-        6, // 0x6C 'l'
-        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x6D 'm'
-        0x00,0x00,0x00,0x68,0x54,0x54,0x44,0x44,0x00,0x00,
-
-        6, // 0x6E 'n'
-        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x6F 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,
-
-        6, // 0x71 'q'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x3C,0x04,0x04,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x70,0x00,0x00,
-
-        6, // 0x73 's'
-        0x00,0x00,0x00,0x38,0x40,0x38,0x04,0x78,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x10,0x10,0x38,0x10,0x10,0x14,0x08,0x00,0x00,
-
-        6, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x10,0x00,0x00,
-
-        6, // 0x77 'w'
-        0x00,0x00,0x00,0x44,0x44,0x54,0x7C,0x28,0x00,0x00,
-
-        6, // 0x78 'x'
-        0x00,0x00,0x00,0x48,0x48,0x30,0x48,0x48,0x00,0x00,
-
-        6, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x3C,0x04,0x38,
-
-        6, // 0x7A 'z'
-        0x00,0x00,0x00,0x78,0x08,0x30,0x40,0x78,0x00,0x00,
-
-        6, // 0x7B '{'
-        0x18,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x18,0x00,
-
-        6, // 0x7C '|'
-        0x10,0x10,0x10,0x10,0x00,0x10,0x10,0x10,0x10,0x00,
-
-        6, // 0x7D '}'
-        0x60,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x60,0x00,
-
-        6, // 0x7E '~'
-        0x00,0x48,0xA8,0x90,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x7F ''
-        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs6x11_mono[] = 
-    {
-        11, 3, 32, 128-32,
-        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
-        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
-        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
-        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
-        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
-        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
-        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
-        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
-        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
-        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
-        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
-
-        6, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        6, // 0x22 '"'
-        0x00,0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x23 '#'
-        0x00,0x28,0x28,0x7C,0x28,0x28,0x7C,0x28,0x28,0x00,0x00,
-
-        6, // 0x24 '$'
-        0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,
-
-        6, // 0x25 '%'
-        0x00,0x68,0xA8,0xD0,0x10,0x20,0x2C,0x54,0x58,0x00,0x00,
-
-        6, // 0x26 '&'
-        0x00,0x20,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,0x00,
-
-        6, // 0x27 '''
-        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x28 '('
-        0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
-
-        6, // 0x29 ')'
-        0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
-
-        6, // 0x2A '*'
-        0x00,0x00,0x28,0x7C,0x38,0x7C,0x28,0x00,0x00,0x00,0x00,
-
-        6, // 0x2B '+'
-        0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
-
-        6, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
-
-        6, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        6, // 0x2F '/'
-        0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,
-
-        6, // 0x30 '0'
-        0x00,0x38,0x44,0x44,0x54,0x54,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x31 '1'
-        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x32 '2'
-        0x00,0x38,0x44,0x44,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        6, // 0x33 '3'
-        0x00,0x38,0x44,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x08,0x18,0x28,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,
-
-        6, // 0x35 '5'
-        0x00,0x7C,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x36 '6'
-        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x37 '7'
-        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x00,0x00,
-
-        6, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x3A ':'
-        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        6, // 0x3B ';'
-        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x20,0x40,
-
-        6, // 0x3C '<'
-        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
-
-        6, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,
-
-        6, // 0x3E '>'
-        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x38,0x44,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        6, // 0x40 '@'
-        0x00,0x38,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,
-
-        6, // 0x41 'A'
-        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        6, // 0x44 'D'
-        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
-
-        6, // 0x45 'E'
-        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        6, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x4C,0x34,0x00,0x00,
-
-        6, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x49 'I'
-        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x1C,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
-
-        6, // 0x4B 'K'
-        0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x4D 'M'
-        0x00,0x44,0x6C,0x54,0x54,0x54,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x4E 'N'
-        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x00,0x00,
-
-        6, // 0x4F 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        6, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
-
-        6, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
-
-        6, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        6, // 0x54 'T'
-        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        6, // 0x57 'W'
-        0x00,0x44,0x44,0x54,0x54,0x54,0x54,0x54,0x28,0x00,0x00,
-
-        6, // 0x58 'X'
-        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x5A 'Z'
-        0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x5B '['
-        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
-
-        6, // 0x5C '\'
-        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
-
-        6, // 0x5D ']'
-        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
-
-        6, // 0x5E '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
-
-        6, // 0x60 '`'
-        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x3C,0x00,0x00,
-
-        6, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        6, // 0x64 'd'
-        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        6, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x0C,0x10,0x38,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        6, // 0x67 'g'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x78,
-
-        6, // 0x68 'h'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x69 'i'
-        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x6A 'j'
-        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x50,0x20,
-
-        6, // 0x6B 'k'
-        0x00,0x40,0x40,0x4C,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
-
-        6, // 0x6C 'l'
-        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        6, // 0x6D 'm'
-        0x00,0x00,0x00,0x68,0x54,0x54,0x54,0x44,0x44,0x00,0x00,
-
-        6, // 0x6E 'n'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        6, // 0x6F 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        6, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
-
-        6, // 0x71 'q'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        6, // 0x73 's'
-        0x00,0x00,0x00,0x38,0x44,0x30,0x08,0x44,0x38,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x18,0x00,0x00,
-
-        6, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        6, // 0x77 'w'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x54,0x7C,0x28,0x00,0x00,
-
-        6, // 0x78 'x'
-        0x00,0x00,0x00,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
-
-        6, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3C,0x08,0x70,
-
-        6, // 0x7A 'z'
-        0x00,0x00,0x00,0x7C,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        6, // 0x7B '{'
-        0x18,0x20,0x20,0x20,0xC0,0xC0,0x20,0x20,0x20,0x18,0x00,
-
-        6, // 0x7C '|'
-        0x00,0x10,0x10,0x10,0x10,0x00,0x10,0x10,0x10,0x10,0x00,
-
-        6, // 0x7D '}'
-        0x60,0x10,0x10,0x10,0x0C,0x0C,0x10,0x10,0x10,0x60,0x00,
-
-        6, // 0x7E '~'
-        0x00,0x24,0x54,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x7F ''
-        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs7x12_mono_high[] = 
-    {
-        12, 3, 32, 128-32,
-        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4E,0x00,0x5B,0x00,0x68,0x00,
-        0x75,0x00,0x82,0x00,0x8F,0x00,0x9C,0x00,0xA9,0x00,0xB6,0x00,0xC3,0x00,0xD0,0x00,0xDD,0x00,
-        0xEA,0x00,0xF7,0x00,0x04,0x01,0x11,0x01,0x1E,0x01,0x2B,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
-        0x5F,0x01,0x6C,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xA0,0x01,0xAD,0x01,0xBA,0x01,0xC7,0x01,
-        0xD4,0x01,0xE1,0x01,0xEE,0x01,0xFB,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2F,0x02,0x3C,0x02,
-        0x49,0x02,0x56,0x02,0x63,0x02,0x70,0x02,0x7D,0x02,0x8A,0x02,0x97,0x02,0xA4,0x02,0xB1,0x02,
-        0xBE,0x02,0xCB,0x02,0xD8,0x02,0xE5,0x02,0xF2,0x02,0xFF,0x02,0x0C,0x03,0x19,0x03,0x26,0x03,
-        0x33,0x03,0x40,0x03,0x4D,0x03,0x5A,0x03,0x67,0x03,0x74,0x03,0x81,0x03,0x8E,0x03,0x9B,0x03,
-        0xA8,0x03,0xB5,0x03,0xC2,0x03,0xCF,0x03,0xDC,0x03,0xE9,0x03,0xF6,0x03,0x03,0x04,0x10,0x04,
-        0x1D,0x04,0x2A,0x04,0x37,0x04,0x44,0x04,0x51,0x04,0x5E,0x04,0x6B,0x04,0x78,0x04,0x85,0x04,
-        0x92,0x04,0x9F,0x04,0xAC,0x04,0xB9,0x04,0xC6,0x04,0xD3,0x04,
-
-        7, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x21 '!'
-        0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x23 '#'
-        0x24,0x24,0x24,0x7E,0x24,0x24,0x24,0x7E,0x24,0x24,0x24,0x00,
-
-        7, // 0x24 '$'
-        0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,0x00,
-
-        7, // 0x25 '%'
-        0x32,0x54,0x64,0x08,0x08,0x10,0x10,0x26,0x2A,0x4C,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x20,0x50,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,0x00,
-
-        7, // 0x27 '''
-        0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
-
-        7, // 0x29 ')'
-        0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
-
-        7, // 0x2A '*'
-        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,
-
-        7, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        7, // 0x2F '/'
-        0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x08,0x18,0x28,0x28,0x48,0x48,0x7C,0x08,0x08,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x3A ':'
-        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
-
-        7, // 0x3B ';'
-        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
-
-        7, // 0x3C '<'
-        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,
-
-        7, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,
-
-        7, // 0x3E '>'
-        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,
-
-        7, // 0x3F '?'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        7, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        7, // 0x46 'F'
-        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x49 'I'
-        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x4A 'J'
-        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
-
-        7, // 0x4B 'K'
-        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
-
-        7, // 0x4C 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        7, // 0x4D 'M'
-        0x00,0x44,0x6C,0x6C,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x4E 'N'
-        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x44,0x00,0x00,
-
-        7, // 0x4F 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        7, // 0x57 'W'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x5A 'Z'
-        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,
-
-        7, // 0x5B '['
-        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
-
-        7, // 0x5C '\'
-        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
-
-        7, // 0x5D ']'
-        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
-
-        7, // 0x5E '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
-
-        7, // 0x60 '`'
-        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x66 'f'
-        0x00,0x0C,0x10,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x78,
-
-        7, // 0x68 'h'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x69 'i'
-        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x6A 'j'
-        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x08,0x48,0x30,
-
-        7, // 0x6B 'k'
-        0x00,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
-
-        7, // 0x6C 'l'
-        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x6D 'm'
-        0x00,0x00,0x00,0x68,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x6E 'n'
-        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x6F 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x74 't'
-        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x24,0x18,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        7, // 0x77 'w'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3C,0x08,0x70,
-
-        7, // 0x7A 'z'
-        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        7, // 0x7B '{'
-        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,
-
-        7, // 0x7C '|'
-        0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
-
-        7, // 0x7D '}'
-        0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x10,0x60,0x00,
-
-        7, // 0x7E '~'
-        0x00,0x60,0x92,0x92,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7F ''
-        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u mcs7x12_mono_low[] = 
-    {
-        12, 4, 32, 128-32,
-        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4E,0x00,0x5B,0x00,0x68,0x00,
-        0x75,0x00,0x82,0x00,0x8F,0x00,0x9C,0x00,0xA9,0x00,0xB6,0x00,0xC3,0x00,0xD0,0x00,0xDD,0x00,
-        0xEA,0x00,0xF7,0x00,0x04,0x01,0x11,0x01,0x1E,0x01,0x2B,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
-        0x5F,0x01,0x6C,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xA0,0x01,0xAD,0x01,0xBA,0x01,0xC7,0x01,
-        0xD4,0x01,0xE1,0x01,0xEE,0x01,0xFB,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2F,0x02,0x3C,0x02,
-        0x49,0x02,0x56,0x02,0x63,0x02,0x70,0x02,0x7D,0x02,0x8A,0x02,0x97,0x02,0xA4,0x02,0xB1,0x02,
-        0xBE,0x02,0xCB,0x02,0xD8,0x02,0xE5,0x02,0xF2,0x02,0xFF,0x02,0x0C,0x03,0x19,0x03,0x26,0x03,
-        0x33,0x03,0x40,0x03,0x4D,0x03,0x5A,0x03,0x67,0x03,0x74,0x03,0x81,0x03,0x8E,0x03,0x9B,0x03,
-        0xA8,0x03,0xB5,0x03,0xC2,0x03,0xCF,0x03,0xDC,0x03,0xE9,0x03,0xF6,0x03,0x03,0x04,0x10,0x04,
-        0x1D,0x04,0x2A,0x04,0x37,0x04,0x44,0x04,0x51,0x04,0x5E,0x04,0x6B,0x04,0x78,0x04,0x85,0x04,
-        0x92,0x04,0x9F,0x04,0xAC,0x04,0xB9,0x04,0xC6,0x04,0xD3,0x04,
-
-        7, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x21 '!'
-        0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x23 '#'
-        0x00,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x00,0x00,
-
-        7, // 0x24 '$'
-        0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,0x00,
-
-        7, // 0x25 '%'
-        0x34,0x54,0x68,0x08,0x10,0x10,0x20,0x2C,0x54,0x58,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x20,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,0x00,0x00,
-
-        7, // 0x27 '''
-        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
-
-        7, // 0x29 ')'
-        0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
-
-        7, // 0x2A '*'
-        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,
-
-        7, // 0x2B '+'
-        0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,0x00,
-
-        7, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,0x00,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x2F '/'
-        0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x38,0x44,0x44,0x54,0x54,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x38,0x44,0x44,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x38,0x44,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x08,0x18,0x28,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x7C,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x00,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x3A ':'
-        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x3B ';'
-        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x20,0x40,0x00,
-
-        7, // 0x3C '<'
-        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,
-
-        7, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,
-
-        7, // 0x3E '>'
-        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,
-
-        7, // 0x3F '?'
-        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        7, // 0x40 '@'
-        0x00,0x38,0x44,0x44,0x5C,0x54,0x4C,0x40,0x38,0x00,0x00,0x00,
-
-        7, // 0x41 'A'
-        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
-
-        7, // 0x43 'C'
-        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
-
-        7, // 0x46 'F'
-        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x38,0x44,0x40,0x40,0x4C,0x44,0x4C,0x34,0x00,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x49 'I'
-        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x4A 'J'
-        0x00,0x1C,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,0x00,
-
-        7, // 0x4B 'K'
-        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
-
-        7, // 0x4C 'L'
-        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
-
-        7, // 0x4D 'M'
-        0x00,0x44,0x6C,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x4E 'N'
-        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x00,0x00,0x00,
-
-        7, // 0x4F 'O'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x51 'Q'
-        0x00,0x38,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x78,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x56 'V'
-        0x00,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x57 'W'
-        0x00,0x44,0x44,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x5A 'Z'
-        0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,0x00,
-
-        7, // 0x5B '['
-        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
-
-        7, // 0x5C '\'
-        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
-
-        7, // 0x5D ']'
-        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
-
-        7, // 0x5E '^'
-        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,
-
-        7, // 0x60 '`'
-        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x3C,0x00,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x38,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x66 'f'
-        0x00,0x0C,0x10,0x38,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,
-
-        7, // 0x68 'h'
-        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x69 'i'
-        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x6A 'j'
-        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,
-
-        7, // 0x6B 'k'
-        0x00,0x40,0x40,0x4C,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
-
-        7, // 0x6C 'l'
-        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
-
-        7, // 0x6D 'm'
-        0x00,0x00,0x00,0x68,0x54,0x54,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x6E 'n'
-        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x6F 'o'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,0x04,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x38,0x44,0x30,0x08,0x44,0x38,0x00,0x00,0x00,
-
-        7, // 0x74 't'
-        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x24,0x18,0x00,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x77 'w'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x08,0x70,
-
-        7, // 0x7A 'z'
-        0x00,0x00,0x00,0x7C,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
-
-        7, // 0x7B '{'
-        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,
-
-        7, // 0x7C '|'
-        0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
-
-        7, // 0x7D '}'
-        0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x10,0x60,0x00,
-
-        7, // 0x7E '~'
-        0x00,0x24,0x54,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x7F ''
-        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana12[] = 
-    {
-        12, 3, 32, 128-32,
-        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x5A,0x00,0x67,0x00,0x74,0x00,
-        0x81,0x00,0x8E,0x00,0x9B,0x00,0xA8,0x00,0xB5,0x00,0xC2,0x00,0xCF,0x00,0xDC,0x00,0xE9,0x00,
-        0xF6,0x00,0x03,0x01,0x10,0x01,0x1D,0x01,0x2A,0x01,0x37,0x01,0x44,0x01,0x51,0x01,0x5E,0x01,
-        0x6B,0x01,0x78,0x01,0x85,0x01,0x92,0x01,0x9F,0x01,0xAC,0x01,0xC5,0x01,0xD2,0x01,0xDF,0x01,
-        0xEC,0x01,0xF9,0x01,0x06,0x02,0x13,0x02,0x20,0x02,0x2D,0x02,0x3A,0x02,0x47,0x02,0x54,0x02,
-        0x61,0x02,0x7A,0x02,0x87,0x02,0xA0,0x02,0xAD,0x02,0xC6,0x02,0xD3,0x02,0xE0,0x02,0xED,0x02,
-        0xFA,0x02,0x07,0x03,0x20,0x03,0x2D,0x03,0x3A,0x03,0x47,0x03,0x54,0x03,0x61,0x03,0x6E,0x03,
-        0x7B,0x03,0x88,0x03,0x95,0x03,0xA2,0x03,0xAF,0x03,0xBC,0x03,0xC9,0x03,0xD6,0x03,0xE3,0x03,
-        0xF0,0x03,0xFD,0x03,0x0A,0x04,0x17,0x04,0x24,0x04,0x31,0x04,0x4A,0x04,0x57,0x04,0x64,0x04,
-        0x71,0x04,0x7E,0x04,0x8B,0x04,0x98,0x04,0xA5,0x04,0xB2,0x04,0xBF,0x04,0xCC,0x04,0xD9,0x04,
-        0xE6,0x04,0xF3,0x04,0x00,0x05,0x0D,0x05,0x1A,0x05,0x27,0x05,
-
-        3, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x00,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x28,0x7C,0x28,0x7C,0x28,0x00,0x00,0x00,
-
-        7, // 0x24 '$'
-        0x00,0x00,0x10,0x10,0x3C,0x50,0x30,0x18,0x14,0x78,0x10,0x10,
-
-        11, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x4A,0x00,0x4A,0x00,0x35,0x80,0x0A,0x40,0x0A,0x40,0x11,0x80,0x00,0x00,0x00,0x00,
-
-        7, // 0x26 '&'
-        0x00,0x00,0x00,0x30,0x48,0x48,0x32,0x4A,0x44,0x3A,0x00,0x00,
-
-        3, // 0x27 '''
-        0x00,0x00,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x28 '('
-        0x00,0x00,0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x10,
-
-        4, // 0x29 ')'
-        0x00,0x00,0x80,0x40,0x20,0x20,0x20,0x20,0x20,0x20,0x40,0x80,
-
-        7, // 0x2A '*'
-        0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
-
-        3, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x80,0x00,
-
-        5, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x00,0x00,
-
-        3, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,
-
-        4, // 0x2F '/'
-        0x00,0x00,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x80,0x80,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x00,0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x00,0x00,0x38,0x44,0x04,0x08,0x10,0x20,0x7C,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x00,0x00,0x38,0x44,0x04,0x18,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x00,0x00,0x08,0x18,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x00,0x00,0x7C,0x40,0x78,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x00,0x00,0x18,0x20,0x40,0x78,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0x00,0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x3C,0x04,0x08,0x30,0x00,0x00,
-
-        4, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x40,0x40,0x00,0x00,
-
-        4, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x40,0x40,0x80,0x00,
-
-        7, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x04,0x18,0x60,0x18,0x04,0x00,0x00,0x00,
-
-        7, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x7C,0x00,0x00,0x00,0x00,
-
-        7, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x40,0x30,0x0C,0x30,0x40,0x00,0x00,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x00,0x00,0x70,0x08,0x08,0x10,0x20,0x00,0x20,0x00,0x00,
-
-        10, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x4E,0x80,0x52,0x80,0x52,0x80,0x4D,0x00,0x20,0x00,0x1F,0x00,0x00,0x00,
-
-        8, // 0x41 'A'
-        0x00,0x00,0x00,0x18,0x18,0x24,0x24,0x7E,0x42,0x42,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x00,0x00,0x70,0x48,0x48,0x78,0x44,0x44,0x78,0x00,0x00,
-
-        8, // 0x43 'C'
-        0x00,0x00,0x00,0x1C,0x22,0x40,0x40,0x40,0x22,0x1C,0x00,0x00,
-
-        8, // 0x44 'D'
-        0x00,0x00,0x00,0x78,0x44,0x42,0x42,0x42,0x44,0x78,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        8, // 0x47 'G'
-        0x00,0x00,0x00,0x1C,0x22,0x40,0x4E,0x42,0x22,0x1C,0x00,0x00,
-
-        8, // 0x48 'H'
-        0x00,0x00,0x00,0x42,0x42,0x42,0x7E,0x42,0x42,0x42,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        5, // 0x4A 'J'
-        0x00,0x00,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0xE0,0x00,0x00,
-
-        7, // 0x4B 'K'
-        0x00,0x00,0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        9, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x55,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x4E 'N'
-        0x00,0x00,0x00,0x42,0x62,0x52,0x4A,0x46,0x42,0x42,0x00,0x00,
-
-        9, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x00,0x00,
-
-        9, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x04,0x00,0x03,0x00,
-
-        7, // 0x52 'R'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x78,0x50,0x48,0x44,0x00,0x00,
-
-        7, // 0x53 'S'
-        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x00,0x00,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        8, // 0x55 'U'
-        0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
-
-        8, // 0x56 'V'
-        0x00,0x00,0x00,0x42,0x42,0x42,0x24,0x24,0x18,0x18,0x00,0x00,
-
-        9, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x55,0x00,0x22,0x00,0x22,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x10,0x00,0x00,
-
-        7, // 0x5A 'Z'
-        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        4, // 0x5B '['
-        0x00,0x00,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,
-
-        4, // 0x5C '\'
-        0x00,0x00,0x80,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x00,
-
-        4, // 0x5D ']'
-        0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
-
-        7, // 0x5E '^'
-        0x00,0x00,0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFC,
-
-        6, // 0x60 '`'
-        0x00,0x00,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x30,0x08,0x38,0x48,0x38,0x00,0x00,
-
-        6, // 0x62 'b'
-        0x00,0x00,0x40,0x40,0x40,0x70,0x48,0x48,0x48,0x70,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x40,0x40,0x38,0x00,0x00,
-
-        6, // 0x64 'd'
-        0x00,0x00,0x08,0x08,0x08,0x38,0x48,0x48,0x48,0x38,0x00,0x00,
-
-        6, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x30,0x48,0x78,0x40,0x38,0x00,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x00,0x30,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        6, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x48,0x48,0x48,0x38,0x08,0x30,
-
-        6, // 0x68 'h'
-        0x00,0x00,0x40,0x40,0x40,0x70,0x48,0x48,0x48,0x48,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x00,0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        3, // 0x6A 'j'
-        0x00,0x00,0x00,0x40,0x00,0xC0,0x40,0x40,0x40,0x40,0x40,0x80,
-
-        6, // 0x6B 'k'
-        0x00,0x00,0x40,0x40,0x40,0x48,0x50,0x60,0x50,0x48,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        9, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x76,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x70,0x48,0x48,0x48,0x48,0x00,0x00,
-
-        6, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x30,0x48,0x48,0x48,0x30,0x00,0x00,
-
-        6, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x70,0x48,0x48,0x48,0x70,0x40,0x40,
-
-        6, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x48,0x48,0x48,0x38,0x08,0x08,
-
-        4, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x50,0x60,0x40,0x40,0x40,0x00,0x00,
-
-        6, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x30,0x08,0x70,0x00,0x00,
-
-        4, // 0x74 't'
-        0x00,0x00,0x00,0x00,0x40,0xF0,0x40,0x40,0x40,0x30,0x00,0x00,
-
-        6, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x48,0x48,0x38,0x00,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x48,0x30,0x30,0x00,0x00,
-
-        7, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x54,0x54,0x28,0x28,0x00,0x00,
-
-        6, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x30,0x48,0x48,0x00,0x00,
-
-        6, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x48,0x30,0x10,0x20,0x20,
-
-        5, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x70,0x10,0x20,0x40,0x70,0x00,0x00,
-
-        6, // 0x7B '{'
-        0x00,0x00,0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x18,
-
-        5, // 0x7C '|'
-        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
-
-        6, // 0x7D '}'
-        0x00,0x00,0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x60,
-
-        7, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x34,0x58,0x00,0x00,0x00,0x00,
-
-        9, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana12_bold[] = 
-    {
-        12, 3, 32, 128-32,
-        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x5A,0x00,0x67,0x00,0x74,0x00,
-        0x81,0x00,0x8E,0x00,0x9B,0x00,0xA8,0x00,0xB5,0x00,0xC2,0x00,0xCF,0x00,0xDC,0x00,0xE9,0x00,
-        0xF6,0x00,0x03,0x01,0x10,0x01,0x1D,0x01,0x2A,0x01,0x37,0x01,0x44,0x01,0x51,0x01,0x5E,0x01,
-        0x6B,0x01,0x78,0x01,0x85,0x01,0x92,0x01,0x9F,0x01,0xAC,0x01,0xC5,0x01,0xD2,0x01,0xDF,0x01,
-        0xEC,0x01,0xF9,0x01,0x06,0x02,0x13,0x02,0x20,0x02,0x2D,0x02,0x3A,0x02,0x47,0x02,0x54,0x02,
-        0x61,0x02,0x6E,0x02,0x7B,0x02,0x88,0x02,0x95,0x02,0xA2,0x02,0xAF,0x02,0xBC,0x02,0xC9,0x02,
-        0xD6,0x02,0xE3,0x02,0xFC,0x02,0x09,0x03,0x16,0x03,0x23,0x03,0x30,0x03,0x3D,0x03,0x4A,0x03,
-        0x57,0x03,0x64,0x03,0x71,0x03,0x7E,0x03,0x8B,0x03,0x98,0x03,0xA5,0x03,0xB2,0x03,0xBF,0x03,
-        0xCC,0x03,0xD9,0x03,0xE6,0x03,0xF3,0x03,0x00,0x04,0x0D,0x04,0x26,0x04,0x33,0x04,0x40,0x04,
-        0x4D,0x04,0x5A,0x04,0x67,0x04,0x74,0x04,0x81,0x04,0x8E,0x04,0x9B,0x04,0xB4,0x04,0xC1,0x04,
-        0xCE,0x04,0xDB,0x04,0xE8,0x04,0xF5,0x04,0x02,0x05,0x0F,0x05,
-
-        3, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x00,0x60,0x00,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x00,0xD8,0xD8,0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x23 '#'
-        0x00,0x00,0x00,0x14,0x14,0x7E,0x28,0xFC,0x50,0x50,0x00,0x00,
-
-        6, // 0x24 '$'
-        0x00,0x00,0x20,0x20,0x70,0xE8,0xE0,0x38,0xB8,0x70,0x20,0x20,
-
-        11, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x00,0x94,0x00,0x94,0x00,0x69,0x80,0x0A,0x40,0x0A,0x40,0x11,0x80,0x00,0x00,0x00,0x00,
-
-        8, // 0x26 '&'
-        0x00,0x00,0x00,0x70,0xD8,0xD8,0x76,0xDC,0xCC,0x76,0x00,0x00,
-
-        3, // 0x27 '''
-        0x00,0x00,0xC0,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x00,0x00,0x30,0x60,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0x60,0x30,
-
-        5, // 0x29 ')'
-        0x00,0x00,0xC0,0x60,0x30,0x30,0x30,0x30,0x30,0x30,0x60,0xC0,
-
-        6, // 0x2A '*'
-        0x00,0x00,0x20,0xA8,0x70,0xA8,0x20,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
-
-        3, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x80,0x00,
-
-        4, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0x00,0x00,0x00,0x00,0x00,
-
-        3, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x00,0x00,
-
-        6, // 0x2F '/'
-        0x00,0x00,0x08,0x08,0x10,0x10,0x20,0x40,0x40,0x80,0x80,0x00,
-
-        6, // 0x30 '0'
-        0x00,0x00,0x00,0x70,0xD8,0xD8,0xD8,0xD8,0xD8,0x70,0x00,0x00,
-
-        6, // 0x31 '1'
-        0x00,0x00,0x00,0x30,0x70,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        6, // 0x32 '2'
-        0x00,0x00,0x00,0x70,0x98,0x18,0x30,0x60,0xC0,0xF8,0x00,0x00,
-
-        6, // 0x33 '3'
-        0x00,0x00,0x00,0x70,0x98,0x18,0x70,0x18,0x98,0x70,0x00,0x00,
-
-        6, // 0x34 '4'
-        0x00,0x00,0x00,0x18,0x38,0x58,0x98,0xFC,0x18,0x18,0x00,0x00,
-
-        6, // 0x35 '5'
-        0x00,0x00,0x00,0xF8,0xC0,0xF0,0x18,0x18,0x98,0x70,0x00,0x00,
-
-        6, // 0x36 '6'
-        0x00,0x00,0x00,0x70,0xC0,0xF0,0xD8,0xD8,0xD8,0x70,0x00,0x00,
-
-        6, // 0x37 '7'
-        0x00,0x00,0x00,0xF8,0x18,0x30,0x30,0x60,0x60,0xC0,0x00,0x00,
-
-        6, // 0x38 '8'
-        0x00,0x00,0x00,0x70,0xD8,0xD8,0x70,0xD8,0xD8,0x70,0x00,0x00,
-
-        6, // 0x39 '9'
-        0x00,0x00,0x00,0x70,0xD8,0xD8,0xD8,0x78,0x18,0x70,0x00,0x00,
-
-        4, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x00,0x00,
-
-        4, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x40,0x00,
-
-        8, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x04,0x18,0x60,0x60,0x18,0x04,0x00,0x00,
-
-        8, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x7C,0x00,0x00,0x00,0x00,
-
-        8, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x40,0x30,0x0C,0x0C,0x30,0x40,0x00,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x00,0x00,0xF0,0x18,0x18,0x30,0x60,0x00,0x60,0x00,0x00,
-
-        9, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x42,0x00,0x9D,0x00,0xA5,0x00,0xA5,0x00,0x9E,0x00,0x40,0x00,0x3C,0x00,0x00,0x00,
-
-        8, // 0x41 'A'
-        0x00,0x00,0x00,0x38,0x38,0x6C,0x6C,0x7C,0xC6,0xC6,0x00,0x00,
-
-        7, // 0x42 'B'
-        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xF8,0xCC,0xCC,0xF8,0x00,0x00,
-
-        6, // 0x43 'C'
-        0x00,0x00,0x00,0x70,0xC8,0xC0,0xC0,0xC0,0xC8,0x70,0x00,0x00,
-
-        7, // 0x44 'D'
-        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xCC,0xCC,0xCC,0xF8,0x00,0x00,
-
-        6, // 0x45 'E'
-        0x00,0x00,0x00,0xF8,0xC0,0xC0,0xF8,0xC0,0xC0,0xF8,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x00,0x00,0xF8,0xC0,0xC0,0xF8,0xC0,0xC0,0xC0,0x00,0x00,
-
-        7, // 0x47 'G'
-        0x00,0x00,0x00,0x78,0xC4,0xC0,0xC0,0xDC,0xCC,0x7C,0x00,0x00,
-
-        7, // 0x48 'H'
-        0x00,0x00,0x00,0xCC,0xCC,0xCC,0xFC,0xCC,0xCC,0xCC,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x00,0x00,0xF0,0x60,0x60,0x60,0x60,0x60,0xF0,0x00,0x00,
-
-        5, // 0x4A 'J'
-        0x00,0x00,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0xE0,0x00,0x00,
-
-        7, // 0x4B 'K'
-        0x00,0x00,0x00,0xCC,0xD8,0xF0,0xE0,0xF0,0xD8,0xCC,0x00,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x00,0x00,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xF8,0x00,0x00,
-
-        8, // 0x4D 'M'
-        0x00,0x00,0x00,0x82,0xC6,0xEE,0xB6,0xB6,0x86,0x86,0x00,0x00,
-
-        7, // 0x4E 'N'
-        0x00,0x00,0x00,0x84,0xC4,0xE4,0xB4,0x9C,0x8C,0x84,0x00,0x00,
-
-        8, // 0x4F 'O'
-        0x00,0x00,0x00,0x7C,0xC6,0xC6,0xC6,0xC6,0xC6,0x7C,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xCC,0xF8,0xC0,0xC0,0x00,0x00,
-
-        8, // 0x51 'Q'
-        0x00,0x00,0x00,0x7C,0xC6,0xC6,0xC6,0xC6,0xC6,0x7C,0x18,0x0E,
-
-        7, // 0x52 'R'
-        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xF8,0xD8,0xCC,0xC6,0x00,0x00,
-
-        6, // 0x53 'S'
-        0x00,0x00,0x00,0x70,0xC8,0xC0,0x70,0x18,0x98,0x70,0x00,0x00,
-
-        6, // 0x54 'T'
-        0x00,0x00,0x00,0xFC,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,
-
-        7, // 0x55 'U'
-        0x00,0x00,0x00,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0x78,0x00,0x00,
-
-        7, // 0x56 'V'
-        0x00,0x00,0x00,0xCC,0xCC,0x78,0x78,0x78,0x30,0x30,0x00,0x00,
-
-        11, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0xCC,0xC0,0xCC,0xC0,0x6D,0x80,0x6D,0x80,0x73,0x80,0x33,0x00,0x33,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x58 'X'
-        0x00,0x00,0x00,0xCC,0xCC,0x78,0x30,0x78,0xCC,0xCC,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x00,0x00,0xCC,0xCC,0x78,0x30,0x30,0x30,0x30,0x00,0x00,
-
-        6, // 0x5A 'Z'
-        0x00,0x00,0x00,0xF8,0x18,0x30,0x60,0xC0,0xC0,0xF8,0x00,0x00,
-
-        5, // 0x5B '['
-        0x00,0x00,0x70,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x70,
-
-        6, // 0x5C '\'
-        0x00,0x00,0x80,0x80,0x40,0x40,0x20,0x10,0x10,0x08,0x08,0x00,
-
-        5, // 0x5D ']'
-        0x00,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x70,
-
-        8, // 0x5E '^'
-        0x00,0x00,0x00,0x18,0x3C,0x66,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFC,
-
-        6, // 0x60 '`'
-        0x00,0x00,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x70,0x18,0x78,0xD8,0x78,0x00,0x00,
-
-        6, // 0x62 'b'
-        0x00,0x00,0xC0,0xC0,0xC0,0xF0,0xD8,0xD8,0xD8,0xF0,0x00,0x00,
-
-        5, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x70,0xC0,0xC0,0xC0,0x70,0x00,0x00,
-
-        6, // 0x64 'd'
-        0x00,0x00,0x18,0x18,0x18,0x78,0xD8,0xD8,0xD8,0x78,0x00,0x00,
-
-        6, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x70,0xD8,0xF8,0xC0,0x78,0x00,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        6, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x78,0xD8,0xD8,0xD8,0x78,0x18,0x70,
-
-        6, // 0x68 'h'
-        0x00,0x00,0xC0,0xC0,0xC0,0xF0,0xD8,0xD8,0xD8,0xD8,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x00,0x00,0xC0,0x00,0xC0,0xC0,0xC0,0xC0,0xC0,0x00,0x00,
-
-        4, // 0x6A 'j'
-        0x00,0x00,0x00,0x60,0x00,0xE0,0x60,0x60,0x60,0x60,0x60,0xC0,
-
-        6, // 0x6B 'k'
-        0x00,0x00,0xC0,0xC0,0xC0,0xD8,0xD8,0xF0,0xD8,0xD8,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x00,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0x00,0x00,
-
-        9, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF6,0x00,0xDB,0x00,0xDB,0x00,0xDB,0x00,0xDB,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0xF0,0xD8,0xD8,0xD8,0xD8,0x00,0x00,
-
-        6, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x70,0xD8,0xD8,0xD8,0x70,0x00,0x00,
-
-        6, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0xF0,0xD8,0xD8,0xD8,0xF0,0xC0,0xC0,
-
-        6, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x78,0xD8,0xD8,0xD8,0x78,0x18,0x18,
-
-        4, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0xD0,0xE0,0xC0,0xC0,0xC0,0x00,0x00,
-
-        5, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x70,0xC0,0xF0,0x30,0xE0,0x00,0x00,
-
-        5, // 0x74 't'
-        0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x38,0x00,0x00,
-
-        6, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0xD8,0xD8,0x78,0x00,0x00,
-
-        6, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0xD8,0x70,0x70,0x00,0x00,
-
-        9, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xDB,0x00,0xDB,0x00,0xDB,0x00,0x66,0x00,0x66,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0x70,0xD8,0xD8,0x00,0x00,
-
-        6, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0xD8,0x70,0x70,0x30,0x60,
-
-        5, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0xF0,0x30,0x60,0xC0,0xF0,0x00,0x00,
-
-        6, // 0x7B '{'
-        0x00,0x00,0x18,0x30,0x30,0x30,0xE0,0x30,0x30,0x30,0x30,0x18,
-
-        5, // 0x7C '|'
-        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
-
-        6, // 0x7D '}'
-        0x00,0x00,0xC0,0x60,0x60,0x60,0x38,0x60,0x60,0x60,0x60,0xC0,
-
-        8, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x92,0x8C,0x00,0x00,0x00,
-
-        9, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana13[] = 
-    {
-        13, 3, 32, 128-32,
-        0x00,0x00,0x0E,0x00,0x1C,0x00,0x2A,0x00,0x45,0x00,0x53,0x00,0x6E,0x00,0x7C,0x00,0x8A,0x00,
-        0x98,0x00,0xA6,0x00,0xB4,0x00,0xCF,0x00,0xDD,0x00,0xEB,0x00,0xF9,0x00,0x07,0x01,0x15,0x01,
-        0x23,0x01,0x31,0x01,0x3F,0x01,0x4D,0x01,0x5B,0x01,0x69,0x01,0x77,0x01,0x85,0x01,0x93,0x01,
-        0xA1,0x01,0xAF,0x01,0xCA,0x01,0xE5,0x01,0x00,0x02,0x0E,0x02,0x29,0x02,0x37,0x02,0x45,0x02,
-        0x60,0x02,0x7B,0x02,0x89,0x02,0x97,0x02,0xB2,0x02,0xC0,0x02,0xCE,0x02,0xDC,0x02,0xEA,0x02,
-        0xF8,0x02,0x13,0x03,0x21,0x03,0x3C,0x03,0x4A,0x03,0x65,0x03,0x73,0x03,0x81,0x03,0x8F,0x03,
-        0x9D,0x03,0xAB,0x03,0xC6,0x03,0xD4,0x03,0xE2,0x03,0xF0,0x03,0xFE,0x03,0x0C,0x04,0x1A,0x04,
-        0x35,0x04,0x43,0x04,0x51,0x04,0x5F,0x04,0x6D,0x04,0x7B,0x04,0x89,0x04,0x97,0x04,0xA5,0x04,
-        0xB3,0x04,0xC1,0x04,0xCF,0x04,0xDD,0x04,0xEB,0x04,0xF9,0x04,0x14,0x05,0x22,0x05,0x30,0x05,
-        0x3E,0x05,0x4C,0x05,0x5A,0x05,0x68,0x05,0x76,0x05,0x84,0x05,0x92,0x05,0xAD,0x05,0xBB,0x05,
-        0xC9,0x05,0xD7,0x05,0xE5,0x05,0xF3,0x05,0x01,0x06,0x1C,0x06,
-
-        4, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x00,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0A,0x00,0x0A,0x00,0x3F,0x00,0x14,0x00,0x14,0x00,0x7E,0x00,0x28,0x00,0x28,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x24 '$'
-        0x00,0x00,0x10,0x10,0x3C,0x50,0x50,0x38,0x14,0x14,0x78,0x10,0x10,
-
-        12, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x49,0x00,0x4A,0x00,0x32,0x00,0x04,0xC0,0x05,0x20,0x09,0x20,0x08,0xC0,0x00,0x00,0x00,0x00,
-
-        8, // 0x26 '&'
-        0x00,0x00,0x00,0x30,0x48,0x48,0x32,0x4A,0x44,0x46,0x39,0x00,0x00,
-
-        3, // 0x27 '''
-        0x00,0x00,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x00,0x00,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
-
-        5, // 0x29 ')'
-        0x00,0x00,0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
-
-        7, // 0x2A '*'
-        0x00,0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
-
-        5, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,
-
-        5, // 0x2F '/'
-        0x00,0x00,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
-
-        7, // 0x30 '0'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x31 '1'
-        0x00,0x00,0x00,0x10,0x70,0x10,0x10,0x10,0x10,0x10,0x7C,0x00,0x00,
-
-        7, // 0x32 '2'
-        0x00,0x00,0x00,0x38,0x44,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        7, // 0x33 '3'
-        0x00,0x00,0x00,0x38,0x44,0x04,0x18,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x34 '4'
-        0x00,0x00,0x00,0x08,0x18,0x28,0x48,0x88,0xFC,0x08,0x08,0x00,0x00,
-
-        7, // 0x35 '5'
-        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x04,0x04,0x44,0x38,0x00,0x00,
-
-        7, // 0x36 '6'
-        0x00,0x00,0x00,0x18,0x20,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x37 '7'
-        0x00,0x00,0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x00,0x00,
-
-        7, // 0x38 '8'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x39 '9'
-        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x08,0x30,0x00,0x00,
-
-        5, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x20,0x20,0x00,0x00,
-
-        5, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x20,0x20,0x20,0x40,
-
-        9, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x3F '?'
-        0x00,0x00,0x00,0x70,0x08,0x08,0x10,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        10, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x4E,0x80,0x52,0x80,0x52,0x80,0x52,0x80,0x4D,0x00,0x20,0x00,0x1E,0x00,0x00,0x00,
-
-        8, // 0x41 'A'
-        0x00,0x00,0x00,0x18,0x18,0x24,0x24,0x24,0x7E,0x42,0x42,0x00,0x00,
-
-        8, // 0x42 'B'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x7C,0x42,0x42,0x42,0x7C,0x00,0x00,
-
-        9, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x45 'E'
-        0x00,0x00,0x00,0x7C,0x40,0x40,0x7C,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        6, // 0x46 'F'
-        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        9, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x47,0x00,0x41,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x48 'H'
-        0x00,0x00,0x00,0x42,0x42,0x42,0x7E,0x42,0x42,0x42,0x42,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        5, // 0x4A 'J'
-        0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,0x00,0x00,
-
-        8, // 0x4B 'K'
-        0x00,0x00,0x00,0x42,0x44,0x48,0x50,0x70,0x48,0x44,0x42,0x00,0x00,
-
-        6, // 0x4C 'L'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
-
-        9, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x55,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x4E 'N'
-        0x00,0x00,0x00,0x62,0x62,0x52,0x52,0x4A,0x4A,0x46,0x46,0x00,0x00,
-
-        9, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x50 'P'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
-
-        9, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x04,0x00,0x03,0x00,
-
-        8, // 0x52 'R'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x48,0x44,0x42,0x00,0x00,
-
-        8, // 0x53 'S'
-        0x00,0x00,0x00,0x3C,0x42,0x40,0x30,0x0C,0x02,0x42,0x3C,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x00,0x00,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        8, // 0x55 'U'
-        0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
-
-        8, // 0x56 'V'
-        0x00,0x00,0x00,0x42,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x00,0x00,
-
-        11, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x58 'X'
-        0x00,0x00,0x00,0x42,0x42,0x24,0x18,0x18,0x24,0x42,0x42,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x00,0x00,0x82,0x44,0x28,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        8, // 0x5A 'Z'
-        0x00,0x00,0x00,0x7E,0x02,0x04,0x08,0x10,0x20,0x40,0x7E,0x00,0x00,
-
-        5, // 0x5B '['
-        0x00,0x00,0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,
-
-        5, // 0x5C '\'
-        0x00,0x00,0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
-
-        5, // 0x5D ']'
-        0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,
-
-        9, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFE,
-
-        7, // 0x60 '`'
-        0x00,0x00,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x3C,0x00,0x00,
-
-        7, // 0x62 'b'
-        0x00,0x00,0x40,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        7, // 0x64 'd'
-        0x00,0x00,0x04,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        7, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x00,0x30,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x38,
-
-        7, // 0x68 'h'
-        0x00,0x00,0x40,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        4, // 0x6A 'j'
-        0x00,0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0xC0,
-
-        7, // 0x6B 'k'
-        0x00,0x00,0x40,0x40,0x40,0x44,0x48,0x50,0x70,0x48,0x44,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        11, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7B,0x80,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x00,0x00,0x00,0x00,
-
-        7, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
-
-        7, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
-
-        7, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
-
-        7, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
-
-        5, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x58,0x60,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        6, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x60,0x18,0x08,0x70,0x00,0x00,
-
-        4, // 0x74 't'
-        0x00,0x00,0x00,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x30,0x00,0x00,
-
-        7, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        9, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x55,0x00,0x22,0x00,0x22,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x28,0x10,0x10,0x28,0x44,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x28,0x28,0x28,0x10,0x10,0x10,0x20,
-
-        6, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x78,0x08,0x10,0x20,0x40,0x78,0x00,0x00,
-
-        7, // 0x7B '{'
-        0x00,0x00,0x0C,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x0C,
-
-        5, // 0x7C '|'
-        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
-
-        7, // 0x7D '}'
-        0x00,0x00,0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x10,0x60,
-
-        9, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x49,0x00,0x46,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x7F,0x80,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana13_bold[] = 
-    {
-        13, 3, 32, 128-32,
-        0x00,0x00,0x0E,0x00,0x1C,0x00,0x2A,0x00,0x45,0x00,0x53,0x00,0x6E,0x00,0x89,0x00,0x97,0x00,
-        0xA5,0x00,0xB3,0x00,0xC1,0x00,0xDC,0x00,0xEA,0x00,0xF8,0x00,0x06,0x01,0x14,0x01,0x22,0x01,
-        0x30,0x01,0x3E,0x01,0x4C,0x01,0x5A,0x01,0x68,0x01,0x76,0x01,0x84,0x01,0x92,0x01,0xA0,0x01,
-        0xAE,0x01,0xBC,0x01,0xD7,0x01,0xF2,0x01,0x0D,0x02,0x1B,0x02,0x36,0x02,0x51,0x02,0x5F,0x02,
-        0x6D,0x02,0x88,0x02,0x96,0x02,0xA4,0x02,0xBF,0x02,0xDA,0x02,0xE8,0x02,0xF6,0x02,0x04,0x03,
-        0x12,0x03,0x2D,0x03,0x48,0x03,0x63,0x03,0x71,0x03,0x8C,0x03,0x9A,0x03,0xA8,0x03,0xB6,0x03,
-        0xD1,0x03,0xDF,0x03,0xFA,0x03,0x08,0x04,0x16,0x04,0x24,0x04,0x32,0x04,0x40,0x04,0x4E,0x04,
-        0x69,0x04,0x77,0x04,0x85,0x04,0x93,0x04,0xA1,0x04,0xAF,0x04,0xBD,0x04,0xCB,0x04,0xD9,0x04,
-        0xE7,0x04,0xF5,0x04,0x03,0x05,0x11,0x05,0x1F,0x05,0x2D,0x05,0x48,0x05,0x56,0x05,0x64,0x05,
-        0x72,0x05,0x80,0x05,0x8E,0x05,0x9C,0x05,0xAA,0x05,0xB8,0x05,0xC6,0x05,0xE1,0x05,0xEF,0x05,
-        0xFD,0x05,0x0B,0x06,0x19,0x06,0x27,0x06,0x35,0x06,0x50,0x06,
-
-        4, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x21 '!'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x60,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x00,0x6C,0x6C,0x6C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0A,0x00,0x0A,0x00,0x3F,0x00,0x14,0x00,0x14,0x00,0x7E,0x00,0x28,0x00,0x28,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x24 '$'
-        0x00,0x00,0x08,0x08,0x3C,0x6A,0x68,0x3C,0x16,0x56,0x3C,0x10,0x10,
-
-        14, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x80,0x6C,0x80,0x6D,0x00,0x6D,0x70,0x3A,0xD8,0x02,0xD8,0x04,0xD8,0x04,0x70,0x00,0x00,0x00,0x00,
-
-        10, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x6C,0x00,0x6C,0x00,0x39,0x80,0x6D,0x00,0x66,0x00,0x63,0x00,0x3D,0x80,0x00,0x00,0x00,0x00,
-
-        4, // 0x27 '''
-        0x00,0x00,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x28 '('
-        0x00,0x00,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,
-
-        6, // 0x29 ')'
-        0x00,0x00,0x60,0x30,0x30,0x18,0x18,0x18,0x18,0x18,0x30,0x30,0x60,
-
-        8, // 0x2A '*'
-        0x00,0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x40,
-
-        6, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        8, // 0x2F '/'
-        0x00,0x00,0x06,0x06,0x0C,0x0C,0x18,0x18,0x18,0x30,0x30,0x60,0x60,
-
-        8, // 0x30 '0'
-        0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x66,0x66,0x66,0x3C,0x00,0x00,
-
-        8, // 0x31 '1'
-        0x00,0x00,0x00,0x18,0x38,0x18,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,
-
-        8, // 0x32 '2'
-        0x00,0x00,0x00,0x3C,0x66,0x06,0x0C,0x18,0x30,0x60,0x7E,0x00,0x00,
-
-        8, // 0x33 '3'
-        0x00,0x00,0x00,0x3C,0x66,0x06,0x1C,0x06,0x06,0x66,0x3C,0x00,0x00,
-
-        8, // 0x34 '4'
-        0x00,0x00,0x00,0x04,0x0C,0x1C,0x2C,0x4C,0x7E,0x0C,0x0C,0x00,0x00,
-
-        8, // 0x35 '5'
-        0x00,0x00,0x00,0x3E,0x30,0x30,0x3C,0x06,0x06,0x66,0x3C,0x00,0x00,
-
-        8, // 0x36 '6'
-        0x00,0x00,0x00,0x1C,0x30,0x60,0x7C,0x66,0x66,0x66,0x3C,0x00,0x00,
-
-        8, // 0x37 '7'
-        0x00,0x00,0x00,0x7E,0x06,0x0C,0x0C,0x18,0x18,0x30,0x30,0x00,0x00,
-
-        8, // 0x38 '8'
-        0x00,0x00,0x00,0x3C,0x66,0x66,0x3C,0x66,0x66,0x66,0x3C,0x00,0x00,
-
-        8, // 0x39 '9'
-        0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x3E,0x06,0x0C,0x38,0x00,0x00,
-
-        4, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        4, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x60,0x40,
-
-        9, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x3F '?'
-        0x00,0x00,0x00,0x38,0x4C,0x0C,0x18,0x30,0x30,0x00,0x30,0x00,0x00,
-
-        11, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x20,0x40,0x4F,0x40,0x5B,0x40,0x5B,0x40,0x5B,0x40,0x4F,0x80,0x20,0x00,0x1F,0x00,0x00,0x00,
-
-        9, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x7F,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x42 'B'
-        0x00,0x00,0x00,0x7C,0x66,0x66,0x7C,0x66,0x66,0x66,0x7C,0x00,0x00,
-
-        8, // 0x43 'C'
-        0x00,0x00,0x00,0x3C,0x62,0x60,0x60,0x60,0x60,0x62,0x3C,0x00,0x00,
-
-        9, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x66,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x66,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x45 'E'
-        0x00,0x00,0x00,0x7E,0x60,0x60,0x7E,0x60,0x60,0x60,0x7E,0x00,0x00,
-
-        8, // 0x46 'F'
-        0x00,0x00,0x00,0x7E,0x60,0x60,0x7E,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        9, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x61,0x00,0x60,0x00,0x60,0x00,0x67,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x49 'I'
-        0x00,0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0xF0,0x00,0x00,
-
-        8, // 0x4B 'K'
-        0x00,0x00,0x00,0x66,0x6C,0x78,0x70,0x70,0x78,0x6C,0x66,0x00,0x00,
-
-        7, // 0x4C 'L'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7E,0x00,0x00,
-
-        10, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x80,0x71,0x80,0x7B,0x80,0x5D,0x80,0x49,0x80,0x41,0x80,0x41,0x80,0x41,0x80,0x00,0x00,0x00,0x00,
-
-        9, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x61,0x00,0x71,0x00,0x59,0x00,0x4D,0x00,0x47,0x00,0x43,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x50 'P'
-        0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x7C,0x60,0x60,0x60,0x00,0x00,
-
-        9, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x0C,0x00,0x07,0x00,
-
-        8, // 0x52 'R'
-        0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x7C,0x6C,0x66,0x63,0x00,0x00,
-
-        8, // 0x53 'S'
-        0x00,0x00,0x00,0x3C,0x62,0x60,0x7C,0x3E,0x06,0x46,0x3C,0x00,0x00,
-
-        8, // 0x54 'T'
-        0x00,0x00,0x00,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,
-
-        9, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x56 'V'
-        0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x3C,0x18,0x18,0x00,0x00,
-
-        12, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x60,0x66,0x60,0x66,0x60,0x36,0xC0,0x3F,0xC0,0x39,0xC0,0x19,0x80,0x19,0x80,0x00,0x00,0x00,0x00,
-
-        8, // 0x58 'X'
-        0x00,0x00,0x00,0x66,0x66,0x3C,0x18,0x18,0x3C,0x66,0x66,0x00,0x00,
-
-        8, // 0x59 'Y'
-        0x00,0x00,0x00,0x66,0x66,0x3C,0x3C,0x18,0x18,0x18,0x18,0x00,0x00,
-
-        8, // 0x5A 'Z'
-        0x00,0x00,0x00,0x7E,0x06,0x0E,0x1C,0x38,0x70,0x60,0x7E,0x00,0x00,
-
-        6, // 0x5B '['
-        0x00,0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,
-
-        8, // 0x5C '\'
-        0x00,0x00,0x60,0x60,0x30,0x30,0x18,0x18,0x18,0x0C,0x0C,0x06,0x06,
-
-        6, // 0x5D ']'
-        0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,
-
-        10, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,
-
-        8, // 0x60 '`'
-        0x00,0x00,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x06,0x3E,0x66,0x66,0x3E,0x00,0x00,
-
-        8, // 0x62 'b'
-        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x7C,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x60,0x60,0x60,0x60,0x3C,0x00,0x00,
-
-        8, // 0x64 'd'
-        0x00,0x00,0x06,0x06,0x06,0x3E,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
-
-        8, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x7E,0x60,0x62,0x3C,0x00,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        8, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x3E,0x06,0x3C,
-
-        8, // 0x68 'h'
-        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
-
-        4, // 0x69 'i'
-        0x00,0x00,0x00,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x00,0x00,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0xE0,
-
-        8, // 0x6B 'k'
-        0x00,0x00,0x60,0x60,0x60,0x66,0x6C,0x78,0x78,0x6C,0x66,0x00,0x00,
-
-        4, // 0x6C 'l'
-        0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        12, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7D,0xC0,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x00,0x00,0x00,0x00,
-
-        8, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
-
-        8, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x66,0x3C,0x00,0x00,
-
-        8, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x7C,0x60,0x60,
-
-        8, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x3E,0x06,0x06,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x6C,0x7C,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x60,0x78,0x3C,0x0C,0x78,0x00,0x00,
-
-        5, // 0x74 't'
-        0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x38,0x00,0x00,
-
-        8, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
-
-        8, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x18,0x00,0x00,
-
-        10, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6D,0x80,0x6D,0x80,0x6D,0x80,0x6D,0x80,0x33,0x00,0x33,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x3C,0x3C,0x66,0x66,0x00,0x00,
-
-        8, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x3C,0x3C,0x18,0x18,0x30,0x30,
-
-        7, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x0C,0x18,0x30,0x60,0x7C,0x00,0x00,
-
-        8, // 0x7B '{'
-        0x00,0x00,0x0E,0x18,0x18,0x18,0x18,0x70,0x18,0x18,0x18,0x18,0x0E,
-
-        6, // 0x7C '|'
-        0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
-
-        8, // 0x7D '}'
-        0x00,0x00,0x70,0x18,0x18,0x18,0x18,0x0E,0x18,0x18,0x18,0x18,0x70,
-
-        9, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x49,0x00,0x49,0x00,0x46,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x7F,0x80,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana14[] = 
-    {
-        14, 3, 32, 128-32,
-        0x00,0x00,0x0F,0x00,0x1E,0x00,0x2D,0x00,0x4A,0x00,0x59,0x00,0x76,0x00,0x93,0x00,0xA2,0x00,
-        0xB1,0x00,0xC0,0x00,0xCF,0x00,0xEC,0x00,0xFB,0x00,0x0A,0x01,0x19,0x01,0x28,0x01,0x37,0x01,
-        0x46,0x01,0x55,0x01,0x64,0x01,0x73,0x01,0x82,0x01,0x91,0x01,0xA0,0x01,0xAF,0x01,0xBE,0x01,
-        0xCD,0x01,0xDC,0x01,0xF9,0x01,0x16,0x02,0x33,0x02,0x42,0x02,0x5F,0x02,0x6E,0x02,0x7D,0x02,
-        0x9A,0x02,0xB7,0x02,0xC6,0x02,0xD5,0x02,0xF2,0x02,0x0F,0x03,0x1E,0x03,0x2D,0x03,0x3C,0x03,
-        0x4B,0x03,0x68,0x03,0x85,0x03,0xA2,0x03,0xB1,0x03,0xCE,0x03,0xDD,0x03,0xEC,0x03,0xFB,0x03,
-        0x18,0x04,0x27,0x04,0x44,0x04,0x53,0x04,0x62,0x04,0x71,0x04,0x80,0x04,0x8F,0x04,0x9E,0x04,
-        0xBB,0x04,0xCA,0x04,0xD9,0x04,0xE8,0x04,0xF7,0x04,0x06,0x05,0x15,0x05,0x24,0x05,0x33,0x05,
-        0x42,0x05,0x51,0x05,0x60,0x05,0x6F,0x05,0x7E,0x05,0x8D,0x05,0xAA,0x05,0xB9,0x05,0xC8,0x05,
-        0xD7,0x05,0xE6,0x05,0xF5,0x05,0x04,0x06,0x13,0x06,0x22,0x06,0x31,0x06,0x4E,0x06,0x5D,0x06,
-        0x6C,0x06,0x7B,0x06,0x8A,0x06,0x99,0x06,0xA8,0x06,0xC5,0x06,
-
-        4, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
-
-        6, // 0x22 '"'
-        0x00,0x00,0x48,0x48,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x12,0x00,0x3F,0x80,0x12,0x00,0x12,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x24 '$'
-        0x00,0x00,0x10,0x10,0x3E,0x50,0x50,0x30,0x1C,0x12,0x12,0x7C,0x10,0x10,
-
-        13, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x49,0x00,0x49,0x00,0x4A,0x00,0x32,0x60,0x02,0x90,0x04,0x90,0x04,0x90,0x08,0x60,0x00,0x00,0x00,0x00,
-
-        10, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x44,0x00,0x44,0x00,0x44,0x00,0x39,0x00,0x45,0x00,0x42,0x00,0x43,0x00,0x3C,0x80,0x00,0x00,0x00,0x00,
-
-        3, // 0x27 '''
-        0x00,0x00,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x28 '('
-        0x00,0x00,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
-
-        5, // 0x29 ')'
-        0x00,0x00,0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
-
-        8, // 0x2A '*'
-        0x00,0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
-
-        5, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,
-
-        5, // 0x2F '/'
-        0x00,0x00,0x08,0x08,0x10,0x10,0x10,0x20,0x20,0x20,0x40,0x40,0x40,0x80,
-
-        8, // 0x30 '0'
-        0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
-
-        8, // 0x31 '1'
-        0x00,0x00,0x00,0x08,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x3E,0x00,0x00,
-
-        8, // 0x32 '2'
-        0x00,0x00,0x00,0x3C,0x42,0x42,0x02,0x04,0x18,0x20,0x40,0x7E,0x00,0x00,
-
-        8, // 0x33 '3'
-        0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x1C,0x02,0x02,0x42,0x3C,0x00,0x00,
-
-        8, // 0x34 '4'
-        0x00,0x00,0x00,0x04,0x0C,0x14,0x24,0x44,0x7F,0x04,0x04,0x04,0x00,0x00,
-
-        8, // 0x35 '5'
-        0x00,0x00,0x00,0x7E,0x40,0x40,0x7C,0x02,0x02,0x02,0x42,0x3C,0x00,0x00,
-
-        8, // 0x36 '6'
-        0x00,0x00,0x00,0x1C,0x20,0x40,0x7C,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
-
-        8, // 0x37 '7'
-        0x00,0x00,0x00,0x7E,0x02,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x00,0x00,
-
-        8, // 0x38 '8'
-        0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x3C,0x42,0x42,0x42,0x3C,0x00,0x00,
-
-        8, // 0x39 '9'
-        0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x3E,0x02,0x04,0x38,0x00,0x00,
-
-        5, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x00,0x00,
-
-        5, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
-
-        9, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x3F '?'
-        0x00,0x00,0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
-
-        12, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x27,0x40,0x49,0x20,0x49,0x20,0x49,0x20,0x49,0x20,0x27,0xC0,0x30,0x00,0x0F,0x00,0x00,0x00,
-
-        8, // 0x41 'A'
-        0x00,0x00,0x00,0x18,0x18,0x24,0x24,0x42,0x42,0x7E,0x81,0x81,0x00,0x00,
-
-        8, // 0x42 'B'
-        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x7C,0x42,0x42,0x42,0x7C,0x00,0x00,
-
-        9, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x45 'E'
-        0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7E,0x40,0x40,0x40,0x7E,0x00,0x00,
-
-        7, // 0x46 'F'
-        0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7C,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        9, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x47,0x00,0x41,0x00,0x41,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
-
-        5, // 0x4A 'J'
-        0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,0x00,0x00,
-
-        8, // 0x4B 'K'
-        0x00,0x00,0x00,0x42,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x42,0x00,0x00,
-
-        7, // 0x4C 'L'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7E,0x00,0x00,
-
-        10, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x52,0x80,0x52,0x80,0x52,0x80,0x4C,0x80,0x4C,0x80,0x40,0x80,0x40,0x80,0x00,0x00,0x00,0x00,
-
-        9, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x00,0x61,0x00,0x51,0x00,0x51,0x00,0x49,0x00,0x45,0x00,0x45,0x00,0x43,0x00,0x43,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x50 'P'
-        0x00,0x00,0x00,0x7C,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,0x40,0x00,0x00,
-
-        10, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x02,0x00,0x01,0x80,
-
-        8, // 0x52 'R'
-        0x00,0x00,0x00,0x7C,0x42,0x42,0x42,0x7C,0x48,0x44,0x42,0x41,0x00,0x00,
-
-        8, // 0x53 'S'
-        0x00,0x00,0x00,0x3C,0x42,0x40,0x40,0x3C,0x02,0x02,0x42,0x3C,0x00,0x00,
-
-        7, // 0x54 'T'
-        0x00,0x00,0x00,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        9, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x56 'V'
-        0x00,0x00,0x00,0x81,0x81,0x42,0x42,0x42,0x24,0x24,0x18,0x18,0x00,0x00,
-
-        13, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x10,0x42,0x10,0x45,0x10,0x45,0x10,0x25,0x20,0x28,0xA0,0x28,0xA0,0x10,0x40,0x10,0x40,0x00,0x00,0x00,0x00,
-
-        8, // 0x58 'X'
-        0x00,0x00,0x00,0x42,0x42,0x24,0x18,0x18,0x18,0x24,0x42,0x42,0x00,0x00,
-
-        7, // 0x59 'Y'
-        0x00,0x00,0x00,0x82,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
-
-        8, // 0x5A 'Z'
-        0x00,0x00,0x00,0x7E,0x02,0x04,0x08,0x10,0x10,0x20,0x40,0x7E,0x00,0x00,
-
-        5, // 0x5B '['
-        0x00,0x00,0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,
-
-        5, // 0x5C '\'
-        0x00,0x00,0x80,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x10,0x08,0x08,
-
-        5, // 0x5D ']'
-        0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,
-
-        10, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x12,0x00,0x21,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,
-
-        8, // 0x60 '`'
-        0x00,0x00,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x02,0x02,0x3E,0x42,0x42,0x3E,0x00,0x00,
-
-        8, // 0x62 'b'
-        0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x00,0x00,
-
-        6, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
-
-        8, // 0x64 'd'
-        0x00,0x00,0x02,0x02,0x02,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,
-
-        8, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x7E,0x40,0x42,0x3C,0x00,0x00,
-
-        4, // 0x66 'f'
-        0x00,0x00,0x30,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        8, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x3C,
-
-        8, // 0x68 'h'
-        0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        4, // 0x6A 'j'
-        0x00,0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xC0,
-
-        7, // 0x6B 'k'
-        0x00,0x00,0x40,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        11, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7B,0x80,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x00,0x00,0x00,0x00,
-
-        8, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,
-
-        8, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
-
-        8, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,
-
-        8, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x02,
-
-        5, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x58,0x60,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x40,0x40,0x38,0x04,0x04,0x78,0x00,0x00,
-
-        5, // 0x74 't'
-        0x00,0x00,0x00,0x40,0x40,0xF8,0x40,0x40,0x40,0x40,0x40,0x38,0x00,0x00,
-
-        8, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,
-
-        7, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
-
-        11, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
-
-        7, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x10,0x20,
-
-        7, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
-
-        8, // 0x7B '{'
-        0x00,0x00,0x0C,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x10,0x0C,
-
-        5, // 0x7C '|'
-        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
-
-        8, // 0x7D '}'
-        0x00,0x00,0x30,0x08,0x08,0x08,0x08,0x06,0x08,0x08,0x08,0x08,0x08,0x30,
-
-        10, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x4C,0x80,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3F,0xE0,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana14_bold[] = 
-    {
-        14, 3, 32, 128-32,
-        0x00,0x00,0x0F,0x00,0x1E,0x00,0x2D,0x00,0x4A,0x00,0x67,0x00,0x84,0x00,0xA1,0x00,0xB0,0x00,
-        0xBF,0x00,0xCE,0x00,0xEB,0x00,0x08,0x01,0x17,0x01,0x26,0x01,0x35,0x01,0x44,0x01,0x61,0x01,
-        0x7E,0x01,0x9B,0x01,0xB8,0x01,0xD5,0x01,0xF2,0x01,0x0F,0x02,0x2C,0x02,0x49,0x02,0x66,0x02,
-        0x75,0x02,0x84,0x02,0xA1,0x02,0xBE,0x02,0xDB,0x02,0xEA,0x02,0x07,0x03,0x24,0x03,0x41,0x03,
-        0x5E,0x03,0x7B,0x03,0x8A,0x03,0x99,0x03,0xB6,0x03,0xD3,0x03,0xE2,0x03,0xF1,0x03,0x0E,0x04,
-        0x1D,0x04,0x3A,0x04,0x57,0x04,0x74,0x04,0x91,0x04,0xAE,0x04,0xCB,0x04,0xE8,0x04,0xF7,0x04,
-        0x14,0x05,0x31,0x05,0x4E,0x05,0x6B,0x05,0x88,0x05,0x97,0x05,0xA6,0x05,0xB5,0x05,0xC4,0x05,
-        0xE1,0x05,0xFE,0x05,0x1B,0x06,0x2A,0x06,0x39,0x06,0x48,0x06,0x57,0x06,0x66,0x06,0x75,0x06,
-        0x84,0x06,0x93,0x06,0xA2,0x06,0xB1,0x06,0xC0,0x06,0xCF,0x06,0xEC,0x06,0xFB,0x06,0x0A,0x07,
-        0x19,0x07,0x28,0x07,0x37,0x07,0x46,0x07,0x55,0x07,0x64,0x07,0x73,0x07,0x90,0x07,0x9F,0x07,
-        0xAE,0x07,0xBD,0x07,0xDA,0x07,0xE9,0x07,0x06,0x08,0x23,0x08,
-
-        4, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x60,0x60,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x00,0x6C,0x6C,0x6C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x3F,0x80,0x3F,0x80,0x12,0x00,0x7F,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x24 '$'
-        0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x69,0x00,0x68,0x00,0x7E,0x00,0x3F,0x00,0x0B,0x00,0x4B,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,
-
-        15, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x6C,0x40,0x6C,0x80,0x6C,0xB8,0x6D,0x6C,0x3A,0x6C,0x02,0x6C,0x04,0x6C,0x04,0x38,0x00,0x00,0x00,0x00,
-
-        10, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x6C,0x00,0x6C,0x00,0x6C,0x00,0x39,0x80,0x6D,0x00,0x66,0x00,0x63,0x00,0x3D,0x80,0x00,0x00,0x00,0x00,
-
-        4, // 0x27 '''
-        0x00,0x00,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x00,0x00,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,
-
-        7, // 0x29 ')'
-        0x00,0x00,0x30,0x18,0x18,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x18,0x18,0x30,
-
-        9, // 0x2A '*'
-        0x00,0x00,0x00,0x00,0x08,0x00,0x2A,0x00,0x1C,0x00,0x1C,0x00,0x2A,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x40,
-
-        6, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        8, // 0x2F '/'
-        0x00,0x00,0x06,0x06,0x0C,0x0C,0x0C,0x18,0x18,0x30,0x30,0x30,0x60,0x60,
-
-        9, // 0x30 '0'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x31 '1'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x3C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x32 '2'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x33 '3'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x03,0x00,0x1E,0x00,0x03,0x00,0x03,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x34 '4'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0E,0x00,0x16,0x00,0x16,0x00,0x26,0x00,0x46,0x00,0x7F,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x35 '5'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x30,0x00,0x30,0x00,0x3E,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x36 '6'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x30,0x00,0x60,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x37 '7'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x38 '8'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x39 '9'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x03,0x00,0x06,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
-
-        5, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x60,0x40,
-
-        10, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x3F '?'
-        0x00,0x00,0x00,0x38,0x4C,0x0C,0x18,0x30,0x30,0x00,0x30,0x30,0x00,0x00,
-
-        12, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x2F,0x40,0x5B,0x20,0x5B,0x20,0x5B,0x20,0x5B,0x20,0x2F,0xC0,0x30,0x00,0x0F,0x00,0x00,0x00,
-
-        9, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x7F,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x42 'B'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x66,0x00,0x66,0x00,0x66,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x31,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x31,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x45 'E'
-        0x00,0x00,0x00,0x7E,0x60,0x60,0x60,0x7E,0x60,0x60,0x60,0x7E,0x00,0x00,
-
-        8, // 0x46 'F'
-        0x00,0x00,0x00,0x7E,0x60,0x60,0x60,0x7E,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        10, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x30,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x67,0x80,0x61,0x80,0x31,0x80,0x1F,0x80,0x00,0x00,0x00,0x00,
-
-        10, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x7F,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,
-
-        6, // 0x49 'I'
-        0x00,0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
-
-        7, // 0x4A 'J'
-        0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0xF8,0x00,0x00,
-
-        9, // 0x4B 'K'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x66,0x00,0x6C,0x00,0x78,0x00,0x70,0x00,0x78,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x4C 'L'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7F,0x00,0x00,
-
-        11, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x71,0xC0,0x71,0xC0,0x5A,0xC0,0x5A,0xC0,0x4C,0xC0,0x4C,0xC0,0x40,0xC0,0x40,0xC0,0x00,0x00,0x00,0x00,
-
-        10, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x80,0x70,0x80,0x58,0x80,0x58,0x80,0x4C,0x80,0x46,0x80,0x46,0x80,0x43,0x80,0x41,0x80,0x00,0x00,0x00,0x00,
-
-        11, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x50 'P'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x06,0x00,0x03,0xC0,
-
-        9, // 0x52 'R'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,
-
-        9, // 0x53 'S'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x61,0x00,0x60,0x00,0x70,0x00,0x3E,0x00,0x07,0x00,0x03,0x00,0x43,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x54 'T'
-        0x00,0x00,0x00,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,
-
-        10, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x56 'V'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x63,0x18,0x33,0x30,0x37,0xB0,0x34,0xB0,0x1C,0xE0,0x18,0x60,0x18,0x60,0x00,0x00,0x00,0x00,
-
-        9, // 0x58 'X'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x59 'Y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5A 'Z'
-        0x00,0x00,0x00,0x7E,0x0C,0x0C,0x18,0x18,0x30,0x30,0x60,0x7E,0x00,0x00,
-
-        6, // 0x5B '['
-        0x00,0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,
-
-        8, // 0x5C '\'
-        0x00,0x00,0x60,0x60,0x30,0x30,0x30,0x18,0x18,0x0C,0x0C,0x0C,0x06,0x06,
-
-        6, // 0x5D ']'
-        0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,
-
-        10, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
-
-        9, // 0x60 '`'
-        0x00,0x00,0x00,0x00,0x30,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x06,0x3E,0x66,0x66,0x66,0x3E,0x00,0x00,
-
-        8, // 0x62 'b'
-        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x66,0x7C,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x62,0x60,0x60,0x60,0x62,0x3C,0x00,0x00,
-
-        8, // 0x64 'd'
-        0x00,0x00,0x06,0x06,0x06,0x3E,0x66,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
-
-        8, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x66,0x7E,0x60,0x62,0x3C,0x00,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        8, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x66,0x3E,0x06,0x3C,
-
-        8, // 0x68 'h'
-        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
-
-        4, // 0x69 'i'
-        0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x00,0x30,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0xE0,
-
-        8, // 0x6B 'k'
-        0x00,0x00,0x60,0x60,0x60,0x66,0x6C,0x78,0x78,0x6C,0x66,0x63,0x00,0x00,
-
-        4, // 0x6C 'l'
-        0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        12, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6C,0xC0,0x77,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x00,0x00,0x00,0x00,
-
-        8, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
-
-        8, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x66,0x66,0x3C,0x00,0x00,
-
-        8, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x66,0x7C,0x60,0x60,
-
-        8, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x66,0x3E,0x06,0x06,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x6C,0x7C,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x3C,0x60,0x60,0x38,0x0C,0x0C,0x78,0x00,0x00,
-
-        5, // 0x74 't'
-        0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x38,0x00,0x00,
-
-        8, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
-
-        8, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x3C,0x18,0x00,0x00,
-
-        12, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x60,0x66,0x60,0x66,0x60,0x69,0x60,0x39,0xC0,0x30,0xC0,0x30,0xC0,0x00,0x00,0x00,0x00,
-
-        8, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x3C,0x18,0x3C,0x66,0x66,0x00,0x00,
-
-        8, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x3C,0x18,0x18,0x30,
-
-        7, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x7C,0x0C,0x18,0x38,0x30,0x60,0x7C,0x00,0x00,
-
-        9, // 0x7B '{'
-        0x00,0x00,0x00,0x00,0x0E,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x0E,0x00,
-
-        6, // 0x7C '|'
-        0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
-
-        9, // 0x7D '}'
-        0x00,0x00,0x00,0x00,0x38,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x38,0x00,
-
-        10, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x48,0x80,0x44,0x80,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3F,0xE0,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana16[] = 
-    {
-        16, 4, 32, 128-32,
-        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x54,0x00,0x65,0x00,0x86,0x00,0xA7,0x00,0xB8,0x00,
-        0xC9,0x00,0xDA,0x00,0xFB,0x00,0x1C,0x01,0x2D,0x01,0x3E,0x01,0x4F,0x01,0x60,0x01,0x71,0x01,
-        0x82,0x01,0x93,0x01,0xA4,0x01,0xB5,0x01,0xC6,0x01,0xD7,0x01,0xE8,0x01,0xF9,0x01,0x0A,0x02,
-        0x1B,0x02,0x2C,0x02,0x4D,0x02,0x6E,0x02,0x8F,0x02,0xA0,0x02,0xC1,0x02,0xE2,0x02,0xF3,0x02,
-        0x14,0x03,0x35,0x03,0x46,0x03,0x57,0x03,0x78,0x03,0x99,0x03,0xAA,0x03,0xBB,0x03,0xCC,0x03,
-        0xDD,0x03,0xFE,0x03,0x1F,0x04,0x40,0x04,0x51,0x04,0x72,0x04,0x93,0x04,0xB4,0x04,0xD5,0x04,
-        0xF6,0x04,0x17,0x05,0x38,0x05,0x59,0x05,0x7A,0x05,0x9B,0x05,0xAC,0x05,0xBD,0x05,0xCE,0x05,
-        0xEF,0x05,0x00,0x06,0x11,0x06,0x22,0x06,0x33,0x06,0x44,0x06,0x55,0x06,0x66,0x06,0x77,0x06,
-        0x88,0x06,0x99,0x06,0xAA,0x06,0xBB,0x06,0xCC,0x06,0xDD,0x06,0xFE,0x06,0x0F,0x07,0x20,0x07,
-        0x31,0x07,0x42,0x07,0x53,0x07,0x64,0x07,0x75,0x07,0x86,0x07,0x97,0x07,0xB8,0x07,0xC9,0x07,
-        0xDA,0x07,0xEB,0x07,0xFC,0x07,0x0D,0x08,0x1E,0x08,0x3F,0x08,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x21 '!'
-        0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        5, // 0x22 '"'
-        0x00,0x00,0x00,0x50,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x3F,0x80,0x12,0x00,0x12,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x24 '$'
-        0x00,0x00,0x00,0x10,0x10,0x3E,0x50,0x50,0x30,0x1C,0x12,0x12,0x7C,0x10,0x10,0x00,
-
-        13, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x44,0x80,0x45,0x00,0x45,0x00,0x3A,0xE0,0x05,0x10,0x05,0x10,0x09,0x10,0x10,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x44,0x00,0x44,0x00,0x44,0x00,0x38,0x80,0x45,0x00,0x42,0x00,0x46,0x00,0x39,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        3, // 0x27 '''
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x28 '('
-        0x00,0x00,0x00,0x08,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x08,
-
-        6, // 0x29 ')'
-        0x00,0x00,0x00,0x40,0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x40,
-
-        9, // 0x2A '*'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        6, // 0x2F '/'
-        0x00,0x00,0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
-
-        8, // 0x30 '0'
-        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
-
-        8, // 0x31 '1'
-        0x00,0x00,0x00,0x00,0x08,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x3E,0x00,0x00,0x00,
-
-        8, // 0x32 '2'
-        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x02,0x04,0x18,0x20,0x40,0x7E,0x00,0x00,0x00,
-
-        8, // 0x33 '3'
-        0x00,0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x1C,0x02,0x02,0x42,0x3C,0x00,0x00,0x00,
-
-        8, // 0x34 '4'
-        0x00,0x00,0x00,0x00,0x04,0x0C,0x14,0x24,0x44,0x7F,0x04,0x04,0x04,0x00,0x00,0x00,
-
-        8, // 0x35 '5'
-        0x00,0x00,0x00,0x00,0x3E,0x20,0x20,0x20,0x3C,0x02,0x02,0x42,0x3C,0x00,0x00,0x00,
-
-        8, // 0x36 '6'
-        0x00,0x00,0x00,0x00,0x1C,0x20,0x40,0x7C,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
-
-        8, // 0x37 '7'
-        0x00,0x00,0x00,0x00,0x7E,0x02,0x04,0x04,0x08,0x08,0x10,0x10,0x10,0x00,0x00,0x00,
-
-        8, // 0x38 '8'
-        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x3C,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
-
-        8, // 0x39 '9'
-        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x3E,0x02,0x04,0x38,0x00,0x00,0x00,
-
-        6, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        6, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
-
-        9, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x3F '?'
-        0x00,0x00,0x00,0x00,0x38,0x44,0x04,0x08,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
-
-        13, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x10,0x40,0x27,0xA0,0x48,0x90,0x48,0x90,0x48,0x90,0x48,0x90,0x48,0x90,0x27,0xE0,0x10,0x00,0x0F,0x80,0x00,0x00,
-
-        9, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x3E,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x42 'B'
-        0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x7C,0x42,0x42,0x42,0x7C,0x00,0x00,0x00,
-
-        9, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x45 'E'
-        0x00,0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7E,0x40,0x40,0x40,0x7E,0x00,0x00,0x00,
-
-        8, // 0x46 'F'
-        0x00,0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7C,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        9, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x47,0x00,0x41,0x00,0x21,0x00,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x00,0x00,0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xF0,0x00,0x00,0x00,
-
-        8, // 0x4B 'K'
-        0x00,0x00,0x00,0x00,0x42,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x42,0x00,0x00,0x00,
-
-        7, // 0x4C 'L'
-        0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7E,0x00,0x00,0x00,
-
-        11, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x51,0x40,0x51,0x40,0x4A,0x40,0x4A,0x40,0x44,0x40,0x44,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x00,0x61,0x00,0x51,0x00,0x51,0x00,0x49,0x00,0x45,0x00,0x45,0x00,0x43,0x00,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x50 'P'
-        0x00,0x00,0x00,0x00,0x7C,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        10, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x02,0x00,0x01,0x80,0x00,0x00,
-
-        9, // 0x52 'R'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x42,0x00,0x42,0x00,0x44,0x00,0x78,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x53 'S'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x40,0x00,0x40,0x00,0x3E,0x00,0x01,0x00,0x01,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x54 'T'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x56 'V'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x10,0x42,0x10,0x45,0x10,0x45,0x10,0x25,0x20,0x28,0xA0,0x28,0xA0,0x10,0x40,0x10,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x58 'X'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x59 'Y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x5A 'Z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x01,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5B '['
-        0x00,0x00,0x00,0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
-
-        6, // 0x5C '\'
-        0x00,0x00,0x00,0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
-
-        6, // 0x5D ']'
-        0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,0x00,
-
-        11, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x0A,0x00,0x11,0x00,0x20,0x80,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
-
-        8, // 0x60 '`'
-        0x00,0x00,0x00,0x10,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x02,0x02,0x3E,0x42,0x42,0x3E,0x00,0x00,0x00,
-
-        8, // 0x62 'b'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x00,0x00,0x00,
-
-        8, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x40,0x40,0x40,0x42,0x3C,0x00,0x00,0x00,
-
-        8, // 0x64 'd'
-        0x00,0x00,0x00,0x02,0x02,0x02,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,0x00,
-
-        8, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x7E,0x40,0x42,0x3C,0x00,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x00,0x00,0x1C,0x20,0x20,0x78,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
-
-        8, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x02,0x3C,
-
-        8, // 0x68 'h'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        4, // 0x6A 'j'
-        0x00,0x00,0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xC0,
-
-        7, // 0x6B 'k'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        11, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x59,0x80,0x66,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,0x00,
-
-        8, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
-
-        8, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,0x40,
-
-        8, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x02,0x02,
-
-        5, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x58,0x60,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        7, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x40,0x40,0x38,0x04,0x04,0x78,0x00,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x00,0x00,0x00,0x20,0x20,0x78,0x20,0x20,0x20,0x20,0x20,0x18,0x00,0x00,0x00,
-
-        8, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,0x00,
-
-        8, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x00,0x00,0x00,
-
-        11, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,0x00,
-
-        8, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x10,0x10,0x20,
-
-        7, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
-
-        8, // 0x7B '{'
-        0x00,0x00,0x00,0x0C,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x10,0x0C,0x00,
-
-        7, // 0x7C '|'
-        0x00,0x00,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
-
-        8, // 0x7D '}'
-        0x00,0x00,0x00,0x30,0x08,0x08,0x08,0x08,0x06,0x08,0x08,0x08,0x08,0x08,0x30,0x00,
-
-        11, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x4C,0x80,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF0,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x3F,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana16_bold[] = 
-    {
-        16, 4, 32, 128-32,
-        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x54,0x00,0x75,0x00,0xA6,0x00,0xC7,0x00,0xD8,0x00,
-        0xE9,0x00,0xFA,0x00,0x1B,0x01,0x3C,0x01,0x4D,0x01,0x5E,0x01,0x6F,0x01,0x90,0x01,0xB1,0x01,
-        0xD2,0x01,0xF3,0x01,0x14,0x02,0x35,0x02,0x56,0x02,0x77,0x02,0x98,0x02,0xB9,0x02,0xDA,0x02,
-        0xEB,0x02,0xFC,0x02,0x1D,0x03,0x3E,0x03,0x5F,0x03,0x70,0x03,0x91,0x03,0xB2,0x03,0xD3,0x03,
-        0xF4,0x03,0x15,0x04,0x36,0x04,0x57,0x04,0x78,0x04,0x99,0x04,0xAA,0x04,0xBB,0x04,0xDC,0x04,
-        0xED,0x04,0x0E,0x05,0x2F,0x05,0x50,0x05,0x71,0x05,0x92,0x05,0xB3,0x05,0xD4,0x05,0xE5,0x05,
-        0x06,0x06,0x27,0x06,0x48,0x06,0x69,0x06,0x8A,0x06,0xAB,0x06,0xBC,0x06,0xDD,0x06,0xEE,0x06,
-        0x0F,0x07,0x30,0x07,0x51,0x07,0x72,0x07,0x93,0x07,0xA4,0x07,0xC5,0x07,0xE6,0x07,0xF7,0x07,
-        0x18,0x08,0x39,0x08,0x4A,0x08,0x5B,0x08,0x6C,0x08,0x7D,0x08,0x9E,0x08,0xBF,0x08,0xE0,0x08,
-        0x01,0x09,0x22,0x09,0x33,0x09,0x44,0x09,0x55,0x09,0x76,0x09,0x97,0x09,0xB8,0x09,0xD9,0x09,
-        0xFA,0x09,0x0B,0x0A,0x2C,0x0A,0x3D,0x0A,0x5E,0x0A,0x7F,0x0A,
-
-        4, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x00,0x00,0x6C,0x6C,0x6C,0x6C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x3F,0x80,0x3F,0x80,0x12,0x00,0x7F,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x24 '$'
-        0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x69,0x00,0x68,0x00,0x78,0x00,0x3E,0x00,0x0F,0x00,0x0B,0x00,0x4B,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x00,0x00,
-
-        17, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x20,0x00,0x66,0x20,0x00,0x66,0x40,0x00,0x66,0x5E,0x00,0x66,0xB3,0x00,0x3D,0x33,0x00,0x01,0x33,0x00,0x02,0x33,0x00,0x02,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x66,0x00,0x66,0x00,0x66,0xC0,0x3C,0xC0,0x66,0x80,0x63,0x00,0x63,0x80,0x3C,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x27 '''
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x00,0x00,0x00,0x0C,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,0x0C,
-
-        7, // 0x29 ')'
-        0x00,0x00,0x00,0x60,0x30,0x18,0x18,0x0C,0x0C,0x0C,0x0C,0x0C,0x18,0x18,0x30,0x60,
-
-        9, // 0x2A '*'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x3F,0x80,0x04,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x60,0x60,0xC0,0xC0,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        9, // 0x2F '/'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x60,0x00,0x60,0x00,0x00,0x00,
-
-        9, // 0x30 '0'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x31 '1'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x3C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x32 '2'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x33 '3'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x03,0x00,0x0E,0x00,0x03,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x34 '4'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0E,0x00,0x16,0x00,0x26,0x00,0x46,0x00,0x7F,0x80,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x35 '5'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x30,0x00,0x30,0x00,0x3E,0x00,0x03,0x00,0x03,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x36 '6'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x30,0x00,0x60,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x37 '7'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x38 '8'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x39 '9'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x03,0x00,0x06,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        5, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x38,0x30,0x30,0x60,0x60,
-
-        11, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x40,0x01,0x80,0x06,0x00,0x18,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x3F '?'
-        0x00,0x00,0x00,0x00,0x3C,0x66,0x06,0x0C,0x18,0x18,0x00,0x18,0x18,0x00,0x00,0x00,
-
-        13, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0x60,0x27,0xA0,0x4D,0x90,0x4D,0x90,0x4D,0x90,0x4D,0x90,0x27,0xE0,0x30,0x00,0x0F,0x80,0x00,0x00,0x00,0x00,
-
-        10, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x0C,0x00,0x1E,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x7F,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x42 'B'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x61,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x61,0x80,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x45 'E'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x46 'F'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x61,0x80,0x60,0x00,0x60,0x00,0x63,0x80,0x61,0x80,0x31,0x80,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x7F,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x49 'I'
-        0x00,0x00,0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
-
-        7, // 0x4A 'J'
-        0x00,0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0xF8,0x00,0x00,0x00,
-
-        9, // 0x4B 'K'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x66,0x00,0x6C,0x00,0x78,0x00,0x78,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x4C 'L'
-        0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7F,0x00,0x00,0x00,
-
-        12, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0xE0,0x70,0xE0,0x59,0x60,0x59,0x60,0x4E,0x60,0x4E,0x60,0x44,0x60,0x44,0x60,0x40,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x80,0x70,0x80,0x58,0x80,0x58,0x80,0x4C,0x80,0x46,0x80,0x46,0x80,0x43,0x80,0x43,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x50 'P'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x03,0x00,0x01,0xC0,0x00,0x00,
-
-        9, // 0x52 'R'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x53 'S'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x70,0x00,0x3E,0x00,0x07,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x54 'T'
-        0x00,0x00,0x00,0x00,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,
-
-        10, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x56 'V'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x63,0x18,0x33,0x30,0x37,0xB0,0x34,0xB0,0x1C,0xE0,0x18,0x60,0x18,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x58 'X'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x33,0x00,0x33,0x00,0x1E,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x59 'Y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x5A 'Z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5B '['
-        0x00,0x00,0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,0x00,
-
-        9, // 0x5C '\'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x30,0x00,0x30,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x00,0x00,
-
-        6, // 0x5D ']'
-        0x00,0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,0x00,
-
-        10, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,0x00,
-
-        9, // 0x60 '`'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x03,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x62 'b'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x60,0x60,0x60,0x63,0x3E,0x00,0x00,0x00,
-
-        9, // 0x64 'd'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x7F,0x00,0x60,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x66 'f'
-        0x00,0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        9, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x03,0x00,0x03,0x00,0x3E,0x00,
-
-        9, // 0x68 'h'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x69 'i'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x00,0x00,0x30,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0xE0,
-
-        8, // 0x6B 'k'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x66,0x6C,0x78,0x78,0x6C,0x66,0x63,0x00,0x00,0x00,
-
-        4, // 0x6C 'l'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        14, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x70,0x73,0x98,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,
-
-        9, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x03,0x00,0x03,0x00,0x03,0x00,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x6C,0x7C,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        8, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x60,0x70,0x3C,0x0E,0x06,0x7C,0x00,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x38,0x00,0x00,0x00,
-
-        9, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x60,0x66,0x60,0x66,0x60,0x69,0x60,0x39,0xC0,0x30,0xC0,0x30,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x1C,0x00,0x36,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,
-
-        8, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x06,0x0C,0x18,0x30,0x60,0x7E,0x00,0x00,0x00,
-
-        9, // 0x7B '{'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x00,0x00,0x00,
-
-        8, // 0x7C '|'
-        0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,
-
-        9, // 0x7D '}'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x07,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x70,0x00,0x00,0x00,
-
-        11, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x44,0x40,0x44,0x40,0x43,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF0,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x3F,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana17[] = 
-    {
-        17, 4, 32, 128-32,
-        0x00,0x00,0x12,0x00,0x24,0x00,0x36,0x00,0x59,0x00,0x7C,0x00,0x9F,0x00,0xC2,0x00,0xD4,0x00,
-        0xE6,0x00,0xF8,0x00,0x1B,0x01,0x3E,0x01,0x50,0x01,0x62,0x01,0x74,0x01,0x86,0x01,0xA9,0x01,
-        0xCC,0x01,0xEF,0x01,0x12,0x02,0x35,0x02,0x58,0x02,0x7B,0x02,0x9E,0x02,0xC1,0x02,0xE4,0x02,
-        0xF6,0x02,0x08,0x03,0x2B,0x03,0x4E,0x03,0x71,0x03,0x83,0x03,0xA6,0x03,0xC9,0x03,0xEC,0x03,
-        0x0F,0x04,0x32,0x04,0x55,0x04,0x67,0x04,0x8A,0x04,0xAD,0x04,0xBF,0x04,0xD1,0x04,0xF4,0x04,
-        0x06,0x05,0x29,0x05,0x4C,0x05,0x6F,0x05,0x81,0x05,0xA4,0x05,0xC7,0x05,0xEA,0x05,0x0D,0x06,
-        0x30,0x06,0x53,0x06,0x76,0x06,0x99,0x06,0xBC,0x06,0xDF,0x06,0xF1,0x06,0x03,0x07,0x15,0x07,
-        0x38,0x07,0x5B,0x07,0x7E,0x07,0x90,0x07,0xB3,0x07,0xC5,0x07,0xE8,0x07,0xFA,0x07,0x0C,0x08,
-        0x2F,0x08,0x52,0x08,0x64,0x08,0x76,0x08,0x88,0x08,0x9A,0x08,0xBD,0x08,0xE0,0x08,0x03,0x09,
-        0x26,0x09,0x49,0x09,0x5B,0x09,0x6D,0x09,0x7F,0x09,0xA2,0x09,0xB4,0x09,0xD7,0x09,0xFA,0x09,
-        0x0C,0x0A,0x1E,0x0A,0x41,0x0A,0x53,0x0A,0x76,0x0A,0x99,0x0A,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        6, // 0x22 '"'
-        0x00,0x00,0x00,0x48,0x48,0x48,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x80,0x04,0x80,0x09,0x00,0x3F,0xC0,0x09,0x00,0x12,0x00,0x7F,0x80,0x12,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x24 '$'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x49,0x00,0x48,0x00,0x48,0x00,0x3E,0x00,0x09,0x00,0x09,0x00,0x49,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x00,0x00,
-
-        15, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x20,0x44,0x40,0x44,0x80,0x44,0x80,0x45,0x38,0x39,0x44,0x02,0x44,0x04,0x44,0x04,0x44,0x08,0x38,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x42,0x00,0x42,0x00,0x44,0x00,0x38,0x80,0x44,0x80,0x42,0x80,0x41,0x00,0x22,0x80,0x1C,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x27 '''
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x28 '('
-        0x00,0x00,0x00,0x08,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x08,
-
-        6, // 0x29 ')'
-        0x00,0x00,0x00,0x40,0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x40,
-
-        9, // 0x2A '*'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x7F,0xC0,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        6, // 0x2F '/'
-        0x00,0x00,0x00,0x04,0x08,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
-
-        9, // 0x30 '0'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x31 '1'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x38,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x32 '2'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x01,0x00,0x01,0x00,0x02,0x00,0x0C,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x33 '3'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x01,0x00,0x02,0x00,0x1C,0x00,0x02,0x00,0x01,0x00,0x01,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x34 '4'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x06,0x00,0x0A,0x00,0x12,0x00,0x22,0x00,0x42,0x00,0x7F,0x80,0x02,0x00,0x02,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x35 '5'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7C,0x00,0x02,0x00,0x01,0x00,0x01,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x36 '6'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x30,0x00,0x20,0x00,0x40,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x37 '7'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x01,0x00,0x02,0x00,0x02,0x00,0x04,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x10,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x38 '8'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x3E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x39 '9'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x21,0x00,0x1F,0x00,0x01,0x00,0x02,0x00,0x06,0x00,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        6, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
-
-        11, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x06,0x00,0x18,0x00,0x60,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xC0,0x00,0x00,0x00,0x00,0x3F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x3F '?'
-        0x00,0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x0C,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
-
-        14, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xC0,0x18,0x20,0x20,0x10,0x27,0xC8,0x48,0x48,0x48,0x48,0x48,0x48,0x48,0x48,0x27,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
-
-        10, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x12,0x00,0x12,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x7F,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x42 'B'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7E,0x00,0x41,0x00,0x40,0x80,0x40,0x80,0x41,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0x80,0x20,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x20,0x00,0x30,0x80,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x80,0x40,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x80,0x41,0x80,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x45 'E'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x46 'F'
-        0x00,0x00,0x00,0x00,0x7F,0x40,0x40,0x40,0x7E,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        11, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x00,0x40,0x00,0x43,0xC0,0x40,0x40,0x20,0x40,0x30,0x40,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x7F,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
-
-        6, // 0x4A 'J'
-        0x00,0x00,0x00,0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xF0,0x00,0x00,0x00,
-
-        10, // 0x4B 'K'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x42,0x00,0x44,0x00,0x48,0x00,0x50,0x00,0x68,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x4C 'L'
-        0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x00,0x00,0x00,
-
-        11, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x51,0x40,0x51,0x40,0x4A,0x40,0x4A,0x40,0x44,0x40,0x44,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x80,0x60,0x80,0x50,0x80,0x48,0x80,0x48,0x80,0x44,0x80,0x44,0x80,0x42,0x80,0x41,0x80,0x41,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x31,0x80,0x20,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x80,0x31,0x80,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x50 'P'
-        0x00,0x00,0x00,0x00,0x7C,0x42,0x41,0x41,0x42,0x7C,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        11, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x31,0x80,0x20,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x80,0x31,0x80,0x0E,0x00,0x02,0x00,0x02,0x00,0x01,0xC0,
-
-        10, // 0x52 'R'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x42,0x00,0x42,0x00,0x44,0x00,0x78,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x53 'S'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x40,0x00,0x40,0x00,0x38,0x00,0x07,0x00,0x00,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x54 'T'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x56 'V'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x80,0x40,0x40,0x80,0x40,0x80,0x21,0x00,0x21,0x00,0x21,0x00,0x12,0x00,0x12,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        15, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x04,0x41,0x04,0x22,0x88,0x22,0x88,0x22,0x88,0x14,0x50,0x14,0x50,0x14,0x50,0x08,0x20,0x08,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x58 'X'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x21,0x00,0x12,0x00,0x12,0x00,0x0C,0x00,0x0C,0x00,0x12,0x00,0x12,0x00,0x21,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x59 'Y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x5A 'Z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x5B '['
-        0x00,0x00,0x00,0x3C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3C,
-
-        6, // 0x5C '\'
-        0x00,0x00,0x00,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x10,0x08,0x08,0x08,0x04,0x00,
-
-        6, // 0x5D ']'
-        0x00,0x00,0x00,0x78,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x78,
-
-        11, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x0A,0x00,0x11,0x00,0x20,0x80,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,0x00,
-
-        9, // 0x60 '`'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x22,0x02,0x3E,0x42,0x42,0x46,0x3A,0x00,0x00,0x00,
-
-        9, // 0x62 'b'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x22,0x40,0x40,0x40,0x40,0x22,0x1C,0x00,0x00,0x00,
-
-        9, // 0x64 'd'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x24,0x42,0x7E,0x40,0x40,0x22,0x1C,0x00,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x00,0x00,0x1C,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
-
-        9, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x22,0x00,0x1C,0x00,
-
-        9, // 0x68 'h'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x00,0x00,0x00,0x10,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,
-
-        8, // 0x6B 'k'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x42,0x44,0x48,0x50,0x70,0x48,0x44,0x42,0x00,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        13, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0xE0,0x63,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x40,0x00,0x40,0x00,0x40,0x00,
-
-        9, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        8, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x40,0x30,0x0C,0x02,0x42,0x3C,0x00,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x00,0x00,0x00,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x1C,0x00,0x00,0x00,
-
-        9, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x43,0x00,0x3D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x18,0x00,0x00,0x00,
-
-        11, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x18,0x10,0x10,0x20,
-
-        8, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x02,0x04,0x08,0x10,0x20,0x40,0x7E,0x00,0x00,0x00,
-
-        9, // 0x7B '{'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x60,0x00,0x10,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x07,0x00,
-
-        6, // 0x7C '|'
-        0x00,0x00,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
-
-        9, // 0x7D '}'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x04,0x00,0x03,0x00,0x04,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x70,0x00,
-
-        11, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x44,0x40,0x44,0x40,0x43,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana17_bold[] = 
-    {
-        17, 4, 32, 128-32,
-        0x00,0x00,0x12,0x00,0x24,0x00,0x36,0x00,0x59,0x00,0x7C,0x00,0xB0,0x00,0xD3,0x00,0xE5,0x00,
-        0xF7,0x00,0x09,0x01,0x2C,0x01,0x4F,0x01,0x61,0x01,0x73,0x01,0x85,0x01,0xA8,0x01,0xCB,0x01,
-        0xEE,0x01,0x11,0x02,0x34,0x02,0x57,0x02,0x7A,0x02,0x9D,0x02,0xC0,0x02,0xE3,0x02,0x06,0x03,
-        0x18,0x03,0x2A,0x03,0x4D,0x03,0x70,0x03,0x93,0x03,0xB6,0x03,0xD9,0x03,0xFC,0x03,0x1F,0x04,
-        0x42,0x04,0x65,0x04,0x88,0x04,0xAB,0x04,0xCE,0x04,0xF1,0x04,0x03,0x05,0x15,0x05,0x38,0x05,
-        0x5B,0x05,0x7E,0x05,0xA1,0x05,0xC4,0x05,0xE7,0x05,0x0A,0x06,0x2D,0x06,0x50,0x06,0x73,0x06,
-        0x96,0x06,0xB9,0x06,0xDC,0x06,0xFF,0x06,0x22,0x07,0x45,0x07,0x57,0x07,0x7A,0x07,0x8C,0x07,
-        0xAF,0x07,0xD2,0x07,0xF5,0x07,0x18,0x08,0x3B,0x08,0x4D,0x08,0x70,0x08,0x93,0x08,0xA5,0x08,
-        0xC8,0x08,0xEB,0x08,0xFD,0x08,0x0F,0x09,0x32,0x09,0x44,0x09,0x67,0x09,0x8A,0x09,0xAD,0x09,
-        0xD0,0x09,0xF3,0x09,0x05,0x0A,0x17,0x0A,0x29,0x0A,0x4C,0x0A,0x6F,0x0A,0x92,0x0A,0xB5,0x0A,
-        0xD8,0x0A,0xEA,0x0A,0x0D,0x0B,0x1F,0x0B,0x42,0x0B,0x65,0x0B,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        8, // 0x22 '"'
-        0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x40,0x04,0x40,0x3F,0xE0,0x3F,0xE0,0x08,0x80,0x11,0x00,0x7F,0xC0,0x7F,0xC0,0x22,0x00,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x24 '$'
-        0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x1F,0x00,0x34,0x80,0x64,0x00,0x74,0x00,0x3C,0x00,0x0F,0x00,0x0B,0x80,0x09,0x80,0x4B,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x00,0x00,
-
-        18, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x08,0x00,0x66,0x10,0x00,0x66,0x20,0x00,0x66,0x2F,0x00,0x66,0x59,0x80,0x66,0x99,0x80,0x3D,0x19,0x80,0x01,0x19,0x80,0x02,0x19,0x80,0x04,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x36,0x00,0x1C,0x60,0x36,0x60,0x63,0x60,0x61,0xC0,0x31,0xC0,0x1F,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x27 '''
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x28 '('
-        0x00,0x00,0x00,0x0C,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,0x0C,
-
-        8, // 0x29 ')'
-        0x00,0x00,0x00,0x30,0x18,0x0C,0x0C,0x06,0x06,0x06,0x06,0x06,0x06,0x0C,0x0C,0x18,0x30,
-
-        10, // 0x2A '*'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x7F,0xC0,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x60,0x60,0xC0,0xC0,0x00,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        10, // 0x2F '/'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x60,0x00,0x60,0x00,0x00,0x00,
-
-        10, // 0x30 '0'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x31 '1'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x3C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x32 '2'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x61,0x80,0x01,0x80,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x33 '3'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x61,0x80,0x01,0x80,0x0F,0x00,0x03,0x00,0x01,0x80,0x61,0x80,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x34 '4'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x07,0x00,0x0B,0x00,0x13,0x00,0x23,0x00,0x43,0x00,0x7F,0xC0,0x03,0x00,0x03,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x35 '5'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x30,0x00,0x30,0x00,0x3E,0x00,0x03,0x00,0x01,0x80,0x01,0x80,0x61,0x80,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x36 '6'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x38,0x00,0x30,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x37 '7'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x38 '8'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x39 '9'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x03,0x00,0x07,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        6, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x38,0x30,0x30,0x60,0x60,0x00,
-
-        12, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x40,0x01,0x80,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3F '?'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xC0,0x18,0x20,0x20,0x10,0x27,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x27,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
-
-        11, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x0E,0x00,0x0E,0x00,0x1B,0x00,0x1B,0x00,0x31,0x80,0x3F,0x80,0x31,0x80,0x60,0xC0,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x42 'B'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0xC0,0x30,0xC0,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x30,0xC0,0x30,0xC0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x61,0x80,0x61,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x61,0x80,0x61,0x80,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x45 'E'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x46 'F'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0xC0,0x30,0xC0,0x60,0x00,0x60,0x00,0x63,0xC0,0x60,0xC0,0x30,0xC0,0x30,0xC0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x7F,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x49 'I'
-        0x00,0x00,0x00,0x00,0x7E,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x7E,0x00,0x00,0x00,
-
-        8, // 0x4A 'J'
-        0x00,0x00,0x00,0x00,0x3E,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x0C,0xF8,0x00,0x00,0x00,
-
-        11, // 0x4B 'K'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x61,0x80,0x63,0x00,0x66,0x00,0x6C,0x00,0x7C,0x00,0x76,0x00,0x63,0x00,0x61,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x4C 'L'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x70,0x70,0x70,0x70,0xF0,0x58,0xB0,0x59,0xB0,0x4D,0x30,0x4F,0x30,0x46,0x30,0x46,0x30,0x40,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x40,0x70,0x40,0x58,0x40,0x4C,0x40,0x4C,0x40,0x46,0x40,0x43,0x40,0x43,0x40,0x41,0xC0,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x30,0xC0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0xC0,0x30,0xC0,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x50 'P'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x30,0xC0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0xC0,0x30,0xC0,0x0F,0x80,0x03,0x00,0x03,0x00,0x01,0xE0,
-
-        11, // 0x52 'R'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x63,0x00,0x61,0x80,0x60,0xC0,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x53 'S'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x61,0x80,0x60,0x00,0x3E,0x00,0x1F,0x00,0x01,0x80,0x61,0x80,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x54 'T'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x56 'V'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x31,0x80,0x31,0x80,0x1B,0x00,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        16, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x86,0x61,0x86,0x63,0xC6,0x32,0x4C,0x36,0x6C,0x36,0x6C,0x34,0x2C,0x1C,0x38,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x58 'X'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x31,0x80,0x31,0x80,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x1B,0x00,0x31,0x80,0x31,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x59 'Y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x5A 'Z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x01,0x80,0x03,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5B '['
-        0x00,0x00,0x00,0x3E,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x3E,
-
-        10, // 0x5C '\'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x30,0x00,0x30,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x01,0x80,0x01,0x80,0x00,0x00,
-
-        8, // 0x5D ']'
-        0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x7C,
-
-        12, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x0E,0x00,0x1B,0x00,0x31,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xC0,0x00,0x00,
-
-        10, // 0x60 '`'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x03,0x00,0x03,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x62 'b'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,0x60,0x60,0x60,0x60,0x33,0x1E,0x00,0x00,0x00,
-
-        10, // 0x64 'd'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x01,0x80,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x63,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x00,0x00,0x1C,0x30,0x30,0x7C,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        10, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x03,0x00,0x3E,0x00,
-
-        10, // 0x68 'h'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x69 'i'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        6, // 0x6A 'j'
-        0x00,0x00,0x00,0x18,0x18,0x00,0x38,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0xF0,
-
-        9, // 0x6B 'k'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x63,0x00,0x66,0x00,0x6C,0x00,0x78,0x00,0x7C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x6C 'l'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        14, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x70,0x73,0x98,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,
-
-        10, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x01,0x80,0x01,0x80,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x7E,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        8, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x62,0x60,0x7C,0x3E,0x06,0x46,0x3C,0x00,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x00,0x00,0x00,0x60,0x60,0xFC,0x60,0x60,0x60,0x60,0x60,0x60,0x3C,0x00,0x00,0x00,
-
-        10, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x80,0x3D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x33,0x30,0x37,0xB0,0x34,0xB0,0x1C,0xE0,0x1C,0xE0,0x0C,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,
-
-        8, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x06,0x0C,0x18,0x18,0x30,0x60,0x7E,0x00,0x00,0x00,
-
-        10, // 0x7B '{'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x80,
-
-        8, // 0x7C '|'
-        0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
-
-        10, // 0x7D '}'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x06,0x00,0x03,0x80,0x06,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x78,0x00,
-
-        12, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x20,0x24,0x20,0x46,0x20,0x42,0x40,0x41,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana18[] = 
-    {
-        18, 4, 32, 128-32,
-        0x00,0x00,0x13,0x00,0x26,0x00,0x39,0x00,0x5E,0x00,0x83,0x00,0xA8,0x00,0xCD,0x00,0xE0,0x00,
-        0xF3,0x00,0x06,0x01,0x2B,0x01,0x50,0x01,0x63,0x01,0x76,0x01,0x89,0x01,0x9C,0x01,0xC1,0x01,
-        0xE6,0x01,0x0B,0x02,0x30,0x02,0x55,0x02,0x7A,0x02,0x9F,0x02,0xC4,0x02,0xE9,0x02,0x0E,0x03,
-        0x21,0x03,0x34,0x03,0x59,0x03,0x7E,0x03,0xA3,0x03,0xB6,0x03,0xDB,0x03,0x00,0x04,0x25,0x04,
-        0x4A,0x04,0x6F,0x04,0x94,0x04,0xB9,0x04,0xDE,0x04,0x03,0x05,0x16,0x05,0x29,0x05,0x4E,0x05,
-        0x61,0x05,0x86,0x05,0xAB,0x05,0xD0,0x05,0xF5,0x05,0x1A,0x06,0x3F,0x06,0x64,0x06,0x89,0x06,
-        0xAE,0x06,0xD3,0x06,0xF8,0x06,0x1D,0x07,0x42,0x07,0x67,0x07,0x7A,0x07,0x8D,0x07,0xA0,0x07,
-        0xC5,0x07,0xEA,0x07,0x0F,0x08,0x34,0x08,0x59,0x08,0x6C,0x08,0x91,0x08,0xB6,0x08,0xC9,0x08,
-        0xEE,0x08,0x13,0x09,0x26,0x09,0x39,0x09,0x5E,0x09,0x71,0x09,0x96,0x09,0xBB,0x09,0xE0,0x09,
-        0x05,0x0A,0x2A,0x0A,0x3D,0x0A,0x50,0x0A,0x63,0x0A,0x88,0x0A,0xAD,0x0A,0xD2,0x0A,0xF7,0x0A,
-        0x1C,0x0B,0x41,0x0B,0x66,0x0B,0x79,0x0B,0x9E,0x0B,0xC3,0x0B,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        7, // 0x22 '"'
-        0x00,0x00,0x00,0x48,0x48,0x48,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x80,0x04,0x80,0x09,0x00,0x3F,0xC0,0x09,0x00,0x11,0x00,0x12,0x00,0x7F,0x80,0x12,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x24 '$'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x49,0x00,0x48,0x00,0x48,0x00,0x38,0x00,0x0E,0x00,0x09,0x00,0x09,0x00,0x49,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
-
-        16, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x20,0x44,0x40,0x44,0x40,0x44,0x80,0x44,0x80,0x38,0x9C,0x01,0x22,0x01,0x22,0x02,0x22,0x02,0x22,0x04,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x1E,0x40,0x24,0x40,0x42,0x40,0x41,0x40,0x40,0x80,0x21,0x40,0x1E,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x27 '''
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x28 '('
-        0x00,0x00,0x00,0x08,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x08,
-
-        7, // 0x29 ')'
-        0x00,0x00,0x00,0x20,0x10,0x08,0x08,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x08,0x08,0x10,0x20,
-
-        10, // 0x2A '*'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x3F,0xE0,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x40,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
-
-        7, // 0x2F '/'
-        0x00,0x00,0x00,0x02,0x04,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x80,0x00,
-
-        10, // 0x30 '0'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x31 '1'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x1C,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x32 '2'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x33 '3'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x40,0x80,0x00,0x80,0x01,0x00,0x0E,0x00,0x01,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x34 '4'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x03,0x00,0x05,0x00,0x09,0x00,0x11,0x00,0x21,0x00,0x41,0x00,0x7F,0xC0,0x01,0x00,0x01,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x35 '5'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x20,0x00,0x20,0x00,0x20,0x00,0x3E,0x00,0x01,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x36 '6'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x5E,0x00,0x61,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x37 '7'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x01,0x00,0x02,0x00,0x02,0x00,0x04,0x00,0x04,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x10,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x38 '8'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x39 '9'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x20,0x80,0x1F,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x10,0x00,0x00,0x00,0x00,0x10,0x10,0x00,0x00,0x00,
-
-        7, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x10,0x00,0x00,0x00,0x00,0x10,0x10,0x10,0x20,0x20,
-
-        12, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x3F '?'
-        0x00,0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x04,0x08,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
-
-        15, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x18,0x60,0x20,0x10,0x23,0xD0,0x44,0x48,0x48,0x48,0x48,0x48,0x48,0x48,0x44,0x48,0x23,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
-
-        10, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x21,0x00,0x21,0x00,0x40,0x80,0x7F,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x42 'B'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7E,0x00,0x41,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x41,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x20,0x40,0x30,0xC0,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x80,0x40,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x80,0x41,0x80,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x45 'E'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x46 'F'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0x60,0x20,0x20,0x40,0x00,0x40,0x00,0x41,0xE0,0x40,0x20,0x40,0x20,0x20,0x20,0x30,0x20,0x0F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0xC0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x49 'I'
-        0x00,0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
-
-        7, // 0x4A 'J'
-        0x00,0x00,0x00,0x00,0x3C,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x08,0xF0,0x00,0x00,0x00,
-
-        10, // 0x4B 'K'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x41,0x00,0x42,0x00,0x44,0x00,0x48,0x00,0x50,0x00,0x68,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x4C 'L'
-        0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x00,0x00,0x00,
-
-        13, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x50,0x50,0x50,0x50,0x48,0x90,0x48,0x90,0x45,0x10,0x45,0x10,0x42,0x10,0x42,0x10,0x40,0x10,0x40,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x60,0x40,0x50,0x40,0x48,0x40,0x48,0x40,0x44,0x40,0x42,0x40,0x42,0x40,0x41,0x40,0x40,0xC0,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x20,0x40,0x30,0xC0,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x50 'P'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x41,0x00,0x7E,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x20,0x40,0x30,0xC0,0x0F,0x00,0x01,0x00,0x01,0x00,0x00,0xE0,
-
-        10, // 0x52 'R'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x53 'S'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x40,0x00,0x40,0x00,0x20,0x00,0x1E,0x00,0x01,0x00,0x00,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x54 'T'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x56 'V'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x80,0x40,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x21,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        15, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x04,0x41,0x04,0x22,0x88,0x22,0x88,0x22,0x88,0x12,0x90,0x14,0x50,0x14,0x50,0x14,0x50,0x08,0x20,0x08,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x58 'X'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x21,0x00,0x21,0x00,0x12,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x12,0x00,0x21,0x00,0x21,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x59 'Y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x5A 'Z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x5B '['
-        0x00,0x00,0x00,0x3C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3C,
-
-        7, // 0x5C '\'
-        0x00,0x00,0x00,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x04,0x02,0x00,
-
-        7, // 0x5D ']'
-        0x00,0x00,0x00,0x78,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x78,
-
-        12, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x09,0x00,0x10,0x80,0x20,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xC0,0x00,0x00,
-
-        10, // 0x60 '`'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x01,0x00,0x3F,0x00,0x41,0x00,0x41,0x00,0x43,0x00,0x3D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x62 'b'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x21,0x40,0x40,0x40,0x40,0x21,0x1E,0x00,0x00,0x00,
-
-        9, // 0x64 'd'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x00,0x00,0x1C,0x20,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
-
-        9, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x22,0x00,0x1C,0x00,
-
-        9, // 0x68 'h'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        3, // 0x69 'i'
-        0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        5, // 0x6A 'j'
-        0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,
-
-        9, // 0x6B 'k'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x42,0x00,0x44,0x00,0x48,0x00,0x50,0x00,0x68,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        3, // 0x6C 'l'
-        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        15, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2E,0x70,0x31,0x88,0x21,0x08,0x21,0x08,0x21,0x08,0x21,0x08,0x21,0x08,0x21,0x08,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x40,0x00,0x40,0x00,0x40,0x00,
-
-        9, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
-
-        6, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
-
-        8, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x40,0x30,0x0C,0x02,0x42,0x3C,0x00,0x00,0x00,
-
-        6, // 0x74 't'
-        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x1C,0x00,0x00,0x00,
-
-        9, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x43,0x00,0x3D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x10,0x42,0x10,0x25,0x20,0x25,0x20,0x28,0xA0,0x28,0xA0,0x10,0x40,0x10,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x10,0x00,
-
-        9, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x7B '{'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x60,0x00,0x10,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x07,0x00,
-
-        7, // 0x7C '|'
-        0x00,0x00,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
-
-        10, // 0x7D '}'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x02,0x00,0x01,0x80,0x02,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x38,0x00,
-
-        12, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x20,0x24,0x20,0x42,0x40,0x41,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        15, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-    const int8u verdana18_bold[] = 
-    {
-        18, 4, 32, 128-32,
-        0x00,0x00,0x13,0x00,0x26,0x00,0x4B,0x00,0x70,0x00,0x95,0x00,0xCC,0x00,0xF1,0x00,0x04,0x01,
-        0x17,0x01,0x2A,0x01,0x4F,0x01,0x74,0x01,0x87,0x01,0x9A,0x01,0xAD,0x01,0xD2,0x01,0xF7,0x01,
-        0x1C,0x02,0x41,0x02,0x66,0x02,0x8B,0x02,0xB0,0x02,0xD5,0x02,0xFA,0x02,0x1F,0x03,0x44,0x03,
-        0x57,0x03,0x6A,0x03,0x8F,0x03,0xB4,0x03,0xD9,0x03,0xFE,0x03,0x23,0x04,0x48,0x04,0x6D,0x04,
-        0x92,0x04,0xB7,0x04,0xDC,0x04,0x01,0x05,0x26,0x05,0x4B,0x05,0x5E,0x05,0x71,0x05,0x96,0x05,
-        0xBB,0x05,0xE0,0x05,0x05,0x06,0x2A,0x06,0x4F,0x06,0x74,0x06,0x99,0x06,0xBE,0x06,0xE3,0x06,
-        0x08,0x07,0x2D,0x07,0x52,0x07,0x77,0x07,0x9C,0x07,0xC1,0x07,0xD4,0x07,0xF9,0x07,0x0C,0x08,
-        0x31,0x08,0x56,0x08,0x7B,0x08,0xA0,0x08,0xC5,0x08,0xD8,0x08,0xFD,0x08,0x22,0x09,0x35,0x09,
-        0x5A,0x09,0x7F,0x09,0x92,0x09,0xA5,0x09,0xCA,0x09,0xDD,0x09,0x02,0x0A,0x27,0x0A,0x4C,0x0A,
-        0x71,0x0A,0x96,0x0A,0xA9,0x0A,0xCE,0x0A,0xE1,0x0A,0x06,0x0B,0x2B,0x0B,0x50,0x0B,0x75,0x0B,
-        0x9A,0x0B,0xBF,0x0B,0xE4,0x0B,0xF7,0x0B,0x1C,0x0C,0x41,0x0C,
-
-        5, // 0x20 ' '
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x21 '!'
-        0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
-
-        9, // 0x22 '"'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x23 '#'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x20,0x04,0x20,0x08,0x40,0x3F,0xF0,0x3F,0xF0,0x08,0x40,0x10,0x80,0x7F,0xE0,0x7F,0xE0,0x21,0x00,0x21,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x24 '$'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x1F,0x80,0x34,0xC0,0x64,0xC0,0x64,0x00,0x3C,0x00,0x07,0x80,0x04,0xC0,0x64,0xC0,0x65,0x80,0x3F,0x00,0x04,0x00,0x04,0x00,0x00,0x00,
-
-        19, // 0x25 '%'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x08,0x00,0x63,0x10,0x00,0x63,0x10,0x00,0x63,0x20,0x00,0x63,0x2F,0x80,0x63,0x58,0xC0,0x3E,0x98,0xC0,0x00,0x98,0xC0,0x01,0x18,0xC0,0x01,0x18,0xC0,0x02,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x26 '&'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x33,0x00,0x1E,0x60,0x36,0x60,0x63,0x60,0x61,0xC0,0x60,0xC0,0x30,0xE0,0x1F,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x27 '''
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x28 '('
-        0x00,0x00,0x00,0x06,0x0C,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,0x0C,0x06,
-
-        8, // 0x29 ')'
-        0x00,0x00,0x00,0x60,0x30,0x18,0x0C,0x0C,0x06,0x06,0x06,0x06,0x06,0x0C,0x0C,0x18,0x30,0x60,
-
-        11, // 0x2A '*'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x24,0x80,0x15,0x00,0x0E,0x00,0x15,0x00,0x24,0x80,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x2B '+'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x3F,0xE0,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2C ','
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x60,0x60,0x60,0xC0,0xC0,
-
-        7, // 0x2D '-'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        5, // 0x2E '.'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        10, // 0x2F '/'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x60,0x00,0x60,0x00,0x00,0x00,
-
-        11, // 0x30 '0'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x31 '1'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x1E,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x32 '2'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x60,0xC0,0x00,0xC0,0x01,0x80,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x33 '3'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x60,0xC0,0x00,0xC0,0x01,0x80,0x0F,0x00,0x01,0x80,0x00,0xC0,0x60,0xC0,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x34 '4'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x03,0x80,0x05,0x80,0x09,0x80,0x11,0x80,0x21,0x80,0x41,0x80,0x7F,0xE0,0x01,0x80,0x01,0x80,0x01,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x35 '5'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xC0,0x30,0x00,0x30,0x00,0x30,0x00,0x3F,0x00,0x01,0x80,0x00,0xC0,0x00,0xC0,0x60,0xC0,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x36 '6'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x18,0x00,0x30,0x00,0x60,0x00,0x6F,0x00,0x71,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x37 '7'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xC0,0x00,0xC0,0x01,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x38 '8'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x39 '9'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0xC0,0x1E,0xC0,0x00,0xC0,0x01,0x80,0x03,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x3A ':'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        6, // 0x3B ';'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x38,0x30,0x30,0x30,0x60,0x60,
-
-        13, // 0x3C '<'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x3D '='
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x3E '>'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x60,0x00,0x60,0x01,0x80,0x06,0x00,0x18,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        9, // 0x3F '?'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x40 '@'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x18,0x60,0x20,0x10,0x27,0xD0,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x27,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
-
-        12, // 0x41 'A'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x0F,0x00,0x0F,0x00,0x19,0x80,0x19,0x80,0x30,0xC0,0x3F,0xC0,0x30,0xC0,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x42 'B'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x43 'C'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x38,0xC0,0x30,0xC0,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x30,0xC0,0x38,0xC0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x44 'D'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0xC0,0x60,0xC0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0xC0,0x61,0xC0,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x45 'E'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x46 'F'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x47 'G'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x38,0x60,0x30,0x60,0x60,0x00,0x60,0x00,0x63,0xE0,0x60,0x60,0x60,0x60,0x30,0x60,0x38,0x60,0x0F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x48 'H'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7F,0xE0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x49 'I'
-        0x00,0x00,0x00,0x00,0x7E,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x7E,0x00,0x00,0x00,
-
-        8, // 0x4A 'J'
-        0x00,0x00,0x00,0x00,0x3E,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x0C,0xF8,0x00,0x00,0x00,
-
-        12, // 0x4B 'K'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0xC0,0x61,0x80,0x63,0x00,0x66,0x00,0x6C,0x00,0x7E,0x00,0x73,0x00,0x61,0x80,0x60,0xC0,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x4C 'L'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x4D 'M'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x38,0x70,0x38,0x70,0x78,0x58,0x58,0x58,0xD8,0x4C,0x98,0x4D,0x98,0x47,0x18,0x47,0x18,0x42,0x18,0x40,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x4E 'N'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x20,0x70,0x20,0x58,0x20,0x4C,0x20,0x4C,0x20,0x46,0x20,0x43,0x20,0x43,0x20,0x41,0xA0,0x40,0xE0,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x4F 'O'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x38,0xE0,0x30,0x60,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x30,0x60,0x38,0xE0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x50 'P'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        13, // 0x51 'Q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x38,0xE0,0x30,0x60,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x30,0x60,0x38,0xE0,0x0F,0x80,0x03,0x00,0x03,0x80,0x01,0xF0,
-
-        12, // 0x52 'R'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0x60,0x60,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x53 'S'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x30,0xC0,0x60,0xC0,0x60,0x00,0x7C,0x00,0x3F,0x80,0x03,0xC0,0x00,0xC0,0x60,0xC0,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x54 'T'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        12, // 0x55 'U'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0xC0,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x56 'V'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x31,0x80,0x31,0x80,0x1B,0x00,0x1B,0x00,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        16, // 0x57 'W'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x86,0x61,0x86,0x63,0xC6,0x33,0xCC,0x32,0x4C,0x32,0x4C,0x1E,0x78,0x1C,0x38,0x1C,0x38,0x0C,0x30,0x0C,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x58 'X'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x31,0x80,0x31,0x80,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x0E,0x00,0x1B,0x00,0x31,0x80,0x31,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x59 'Y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x5A 'Z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x01,0x80,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x5B '['
-        0x00,0x00,0x00,0x3E,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x3E,
-
-        10, // 0x5C '\'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x30,0x00,0x30,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x01,0x80,0x01,0x80,0x00,0x00,
-
-        8, // 0x5D ']'
-        0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x7C,
-
-        13, // 0x5E '^'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0F,0x00,0x19,0x80,0x30,0xC0,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x5F '_'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xE0,0x00,0x00,
-
-        11, // 0x60 '`'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x61 'a'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x01,0x80,0x01,0x80,0x3F,0x80,0x61,0x80,0x61,0x80,0x63,0x80,0x3D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x62 'b'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        8, // 0x63 'c'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,0x60,0x60,0x60,0x60,0x33,0x1E,0x00,0x00,0x00,
-
-        10, // 0x64 'd'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x01,0x80,0x01,0x80,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x65 'e'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x7F,0x80,0x60,0x00,0x60,0x00,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        6, // 0x66 'f'
-        0x00,0x00,0x00,0x1C,0x30,0x30,0x30,0x7C,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
-
-        10, // 0x67 'g'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x03,0x00,0x3E,0x00,
-
-        10, // 0x68 'h'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x69 'i'
-        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        6, // 0x6A 'j'
-        0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0xF0,
-
-        10, // 0x6B 'k'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x61,0x80,0x63,0x00,0x66,0x00,0x6C,0x00,0x7E,0x00,0x73,0x00,0x61,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        4, // 0x6C 'l'
-        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        16, // 0x6D 'm'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0x3C,0x71,0xC6,0x61,0x86,0x61,0x86,0x61,0x86,0x61,0x86,0x61,0x86,0x61,0x86,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x6E 'n'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x6F 'o'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x70 'p'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,
-
-        10, // 0x71 'q'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x01,0x80,0x01,0x80,
-
-        7, // 0x72 'r'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x7E,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
-
-        9, // 0x73 's'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x61,0x00,0x60,0x00,0x7E,0x00,0x3F,0x00,0x03,0x00,0x43,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        7, // 0x74 't'
-        0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x7E,0x30,0x30,0x30,0x30,0x30,0x30,0x1E,0x00,0x00,0x00,
-
-        10, // 0x75 'u'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x80,0x3D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x76 'v'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        14, // 0x77 'w'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x63,0x18,0x37,0xB0,0x34,0xB0,0x3C,0xF0,0x18,0x60,0x18,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x78 'x'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        10, // 0x79 'y'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,
-
-        9, // 0x7A 'z'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x60,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        11, // 0x7B '{'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x80,
-
-        8, // 0x7C '|'
-        0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
-
-        11, // 0x7D '}'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x01,0xC0,0x03,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x3C,0x00,
-
-        13, // 0x7E '~'
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x10,0x24,0x10,0x42,0x10,0x41,0x20,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        15, // 0x7F ''
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
-
-        0
-    };
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_font_freetype.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_font_freetype.cpp
--- 8.0.1-5/renderers/agg/src/agg_font_freetype.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_font_freetype.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,1164 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-
-#include <stdio.h>
-#include "../include/agg_font_freetype.h"
-#include "../include/agg_bitset_iterator.h"
-#include "../include/agg_renderer_scanline.h"
-
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------------
-    //
-    // This code implements the AUTODIN II polynomial
-    // The variable corresponding to the macro argument "crc" should
-    // be an unsigned long.
-    // Oroginal code  by Spencer Garrett <srg@quick.com>
-    //
-
-    // generated using the AUTODIN II polynomial
-    //   x^32 + x^26 + x^23 + x^22 + x^16 +
-    //   x^12 + x^11 + x^10 + x^8 + x^7 + x^5 + x^4 + x^2 + x^1 + 1
-    //
-    //------------------------------------------------------------------------------
-
-    static const unsigned crc32tab[256] = 
-    {
-       0x00000000, 0x77073096, 0xee0e612c, 0x990951ba,
-       0x076dc419, 0x706af48f, 0xe963a535, 0x9e6495a3,
-       0x0edb8832, 0x79dcb8a4, 0xe0d5e91e, 0x97d2d988,
-       0x09b64c2b, 0x7eb17cbd, 0xe7b82d07, 0x90bf1d91,
-       0x1db71064, 0x6ab020f2, 0xf3b97148, 0x84be41de,
-       0x1adad47d, 0x6ddde4eb, 0xf4d4b551, 0x83d385c7,
-       0x136c9856, 0x646ba8c0, 0xfd62f97a, 0x8a65c9ec,
-       0x14015c4f, 0x63066cd9, 0xfa0f3d63, 0x8d080df5,
-       0x3b6e20c8, 0x4c69105e, 0xd56041e4, 0xa2677172,
-       0x3c03e4d1, 0x4b04d447, 0xd20d85fd, 0xa50ab56b,
-       0x35b5a8fa, 0x42b2986c, 0xdbbbc9d6, 0xacbcf940,
-       0x32d86ce3, 0x45df5c75, 0xdcd60dcf, 0xabd13d59,
-       0x26d930ac, 0x51de003a, 0xc8d75180, 0xbfd06116,
-       0x21b4f4b5, 0x56b3c423, 0xcfba9599, 0xb8bda50f,
-       0x2802b89e, 0x5f058808, 0xc60cd9b2, 0xb10be924,
-       0x2f6f7c87, 0x58684c11, 0xc1611dab, 0xb6662d3d,
-       0x76dc4190, 0x01db7106, 0x98d220bc, 0xefd5102a,
-       0x71b18589, 0x06b6b51f, 0x9fbfe4a5, 0xe8b8d433,
-       0x7807c9a2, 0x0f00f934, 0x9609a88e, 0xe10e9818,
-       0x7f6a0dbb, 0x086d3d2d, 0x91646c97, 0xe6635c01,
-       0x6b6b51f4, 0x1c6c6162, 0x856530d8, 0xf262004e,
-       0x6c0695ed, 0x1b01a57b, 0x8208f4c1, 0xf50fc457,
-       0x65b0d9c6, 0x12b7e950, 0x8bbeb8ea, 0xfcb9887c,
-       0x62dd1ddf, 0x15da2d49, 0x8cd37cf3, 0xfbd44c65,
-       0x4db26158, 0x3ab551ce, 0xa3bc0074, 0xd4bb30e2,
-       0x4adfa541, 0x3dd895d7, 0xa4d1c46d, 0xd3d6f4fb,
-       0x4369e96a, 0x346ed9fc, 0xad678846, 0xda60b8d0,
-       0x44042d73, 0x33031de5, 0xaa0a4c5f, 0xdd0d7cc9,
-       0x5005713c, 0x270241aa, 0xbe0b1010, 0xc90c2086,
-       0x5768b525, 0x206f85b3, 0xb966d409, 0xce61e49f,
-       0x5edef90e, 0x29d9c998, 0xb0d09822, 0xc7d7a8b4,
-       0x59b33d17, 0x2eb40d81, 0xb7bd5c3b, 0xc0ba6cad,
-       0xedb88320, 0x9abfb3b6, 0x03b6e20c, 0x74b1d29a,
-       0xead54739, 0x9dd277af, 0x04db2615, 0x73dc1683,
-       0xe3630b12, 0x94643b84, 0x0d6d6a3e, 0x7a6a5aa8,
-       0xe40ecf0b, 0x9309ff9d, 0x0a00ae27, 0x7d079eb1,
-       0xf00f9344, 0x8708a3d2, 0x1e01f268, 0x6906c2fe,
-       0xf762575d, 0x806567cb, 0x196c3671, 0x6e6b06e7,
-       0xfed41b76, 0x89d32be0, 0x10da7a5a, 0x67dd4acc,
-       0xf9b9df6f, 0x8ebeeff9, 0x17b7be43, 0x60b08ed5,
-       0xd6d6a3e8, 0xa1d1937e, 0x38d8c2c4, 0x4fdff252,
-       0xd1bb67f1, 0xa6bc5767, 0x3fb506dd, 0x48b2364b,
-       0xd80d2bda, 0xaf0a1b4c, 0x36034af6, 0x41047a60,
-       0xdf60efc3, 0xa867df55, 0x316e8eef, 0x4669be79,
-       0xcb61b38c, 0xbc66831a, 0x256fd2a0, 0x5268e236,
-       0xcc0c7795, 0xbb0b4703, 0x220216b9, 0x5505262f,
-       0xc5ba3bbe, 0xb2bd0b28, 0x2bb45a92, 0x5cb36a04,
-       0xc2d7ffa7, 0xb5d0cf31, 0x2cd99e8b, 0x5bdeae1d,
-       0x9b64c2b0, 0xec63f226, 0x756aa39c, 0x026d930a,
-       0x9c0906a9, 0xeb0e363f, 0x72076785, 0x05005713,
-       0x95bf4a82, 0xe2b87a14, 0x7bb12bae, 0x0cb61b38,
-       0x92d28e9b, 0xe5d5be0d, 0x7cdcefb7, 0x0bdbdf21,
-       0x86d3d2d4, 0xf1d4e242, 0x68ddb3f8, 0x1fda836e,
-       0x81be16cd, 0xf6b9265b, 0x6fb077e1, 0x18b74777,
-       0x88085ae6, 0xff0f6a70, 0x66063bca, 0x11010b5c,
-       0x8f659eff, 0xf862ae69, 0x616bffd3, 0x166ccf45,
-       0xa00ae278, 0xd70dd2ee, 0x4e048354, 0x3903b3c2,
-       0xa7672661, 0xd06016f7, 0x4969474d, 0x3e6e77db,
-       0xaed16a4a, 0xd9d65adc, 0x40df0b66, 0x37d83bf0,
-       0xa9bcae53, 0xdebb9ec5, 0x47b2cf7f, 0x30b5ffe9,
-       0xbdbdf21c, 0xcabac28a, 0x53b39330, 0x24b4a3a6,
-       0xbad03605, 0xcdd70693, 0x54de5729, 0x23d967bf,
-       0xb3667a2e, 0xc4614ab8, 0x5d681b02, 0x2a6f2b94,
-       0xb40bbe37, 0xc30c8ea1, 0x5a05df1b, 0x2d02ef8d,
-    };
-
-
-    //------------------------------------------------------------------------------
-
-    static unsigned calc_crc32(const unsigned char* buf, unsigned size)
-    {
-        unsigned crc = (unsigned)~0;
-        const unsigned char* p;
-        unsigned len = 0; 
-        unsigned nr = size;
-
-        for (len += nr, p = buf; nr--; ++p) 
-        {
-            crc = (crc >> 8) ^ crc32tab[(crc ^ *p) & 0xff];
-        }
-        return ~crc;
-    }
-
-    //------------------------------------------------------------------------
-    static inline int dbl_to_plain_fx(double d)
-    {
-        return int(d * 65536.0);
-    }
-
-    //------------------------------------------------------------------------
-    static inline double int26p6_to_dbl(int p)
-    {
-        return double(p) / 64.0;
-    }
-
-    //------------------------------------------------------------------------
-    static inline int dbl_to_int26p6(double p)
-    {
-        return int(p * 64.0 + 0.5);
-    }
-
-
-    //------------------------------------------------------------------------
-    template<class PathStorage>
-    bool decompose_ft_outline(const FT_Outline& outline,
-                              bool flip_y,
-                              const trans_affine& mtx,
-                              PathStorage& path)
-    {   
-        typedef typename PathStorage::value_type value_type;
-
-        double x1, y1, x2, y2, x3, y3;
-
-        FT_Vector*  point;
-        FT_Vector*  limit;
-        char*       tags;
-
-        int   n;         // index of contour in outline
-        int   first;     // index of first point in contour
-        char  tag;       // current point's state
-
-        first = 0;
-
-        for(n = 0; n < outline.n_contours; n++)
-        {
-            int  last;  // index of last point in contour
-
-            last  = outline.contours[n];
-            limit = outline.points + last;
-
-            FT_Vector v_start = outline.points[first];
-
-            FT_Vector v_control = v_start;
-
-            point = outline.points + first;
-            tags  = outline.tags  + first;
-            tag   = FT_CURVE_TAG(tags[0]);
-
-            // A contour cannot start with a cubic control point!
-            if(tag == FT_CURVE_TAG_CUBIC) return false;
-
-            // check first point to determine origin
-            if( tag == FT_CURVE_TAG_CONIC)
-            {
-                const FT_Vector v_last  = outline.points[last];
-
-                // first point is conic control.  Yes, this happens.
-                if(FT_CURVE_TAG(outline.tags[last]) == FT_CURVE_TAG_ON)
-                {
-                    // start at last point if it is on the curve
-                    v_start = v_last;
-                    limit--;
-                }
-                else
-                {
-                    // if both first and last points are conic,
-                    // start at their middle and record its position
-                    // for closure
-                    v_start.x = (v_start.x + v_last.x) / 2;
-                    v_start.y = (v_start.y + v_last.y) / 2;
-                }
-                point--;
-                tags--;
-            }
-
-            x1 = int26p6_to_dbl(v_start.x);
-            y1 = int26p6_to_dbl(v_start.y);
-            if(flip_y) y1 = -y1;
-            mtx.transform(&x1, &y1);
-            path.move_to(value_type(dbl_to_int26p6(x1)), 
-                         value_type(dbl_to_int26p6(y1)));
-
-            while(point < limit)
-            {
-                point++;
-                tags++;
-
-                tag = FT_CURVE_TAG(tags[0]);
-                switch(tag)
-                {
-                    case FT_CURVE_TAG_ON:  // emit a single line_to
-                    {
-                        x1 = int26p6_to_dbl(point->x);
-                        y1 = int26p6_to_dbl(point->y);
-                        if(flip_y) y1 = -y1;
-                        mtx.transform(&x1, &y1);
-                        path.line_to(value_type(dbl_to_int26p6(x1)), 
-                                     value_type(dbl_to_int26p6(y1)));
-                        //path.line_to(conv(point->x), flip_y ? -conv(point->y) : conv(point->y));
-                        continue;
-                    }
-
-                    case FT_CURVE_TAG_CONIC:  // consume conic arcs
-                    {
-                        v_control.x = point->x;
-                        v_control.y = point->y;
-
-                    Do_Conic:
-                        if(point < limit)
-                        {
-                            FT_Vector vec;
-                            FT_Vector v_middle;
-
-                            point++;
-                            tags++;
-                            tag = FT_CURVE_TAG(tags[0]);
-
-                            vec.x = point->x;
-                            vec.y = point->y;
-
-                            if(tag == FT_CURVE_TAG_ON)
-                            {
-                                x1 = int26p6_to_dbl(v_control.x);
-                                y1 = int26p6_to_dbl(v_control.y);
-                                x2 = int26p6_to_dbl(vec.x);
-                                y2 = int26p6_to_dbl(vec.y);
-                                if(flip_y) { y1 = -y1; y2 = -y2; }
-                                mtx.transform(&x1, &y1);
-                                mtx.transform(&x2, &y2);
-                                path.curve3(value_type(dbl_to_int26p6(x1)), 
-                                            value_type(dbl_to_int26p6(y1)),
-                                            value_type(dbl_to_int26p6(x2)), 
-                                            value_type(dbl_to_int26p6(y2)));
-                                continue;
-                            }
-
-                            if(tag != FT_CURVE_TAG_CONIC) return false;
-
-                            v_middle.x = (v_control.x + vec.x) / 2;
-                            v_middle.y = (v_control.y + vec.y) / 2;
-
-                            x1 = int26p6_to_dbl(v_control.x);
-                            y1 = int26p6_to_dbl(v_control.y);
-                            x2 = int26p6_to_dbl(v_middle.x);
-                            y2 = int26p6_to_dbl(v_middle.y);
-                            if(flip_y) { y1 = -y1; y2 = -y2; }
-                            mtx.transform(&x1, &y1);
-                            mtx.transform(&x2, &y2);
-                            path.curve3(value_type(dbl_to_int26p6(x1)), 
-                                        value_type(dbl_to_int26p6(y1)),
-                                        value_type(dbl_to_int26p6(x2)), 
-                                        value_type(dbl_to_int26p6(y2)));
-
-                            //path.curve3(conv(v_control.x), 
-                            //            flip_y ? -conv(v_control.y) : conv(v_control.y), 
-                            //            conv(v_middle.x), 
-                            //            flip_y ? -conv(v_middle.y) : conv(v_middle.y));
-
-                            v_control = vec;
-                            goto Do_Conic;
-                        }
-
-                        x1 = int26p6_to_dbl(v_control.x);
-                        y1 = int26p6_to_dbl(v_control.y);
-                        x2 = int26p6_to_dbl(v_start.x);
-                        y2 = int26p6_to_dbl(v_start.y);
-                        if(flip_y) { y1 = -y1; y2 = -y2; }
-                        mtx.transform(&x1, &y1);
-                        mtx.transform(&x2, &y2);
-                        path.curve3(value_type(dbl_to_int26p6(x1)), 
-                                    value_type(dbl_to_int26p6(y1)),
-                                    value_type(dbl_to_int26p6(x2)), 
-                                    value_type(dbl_to_int26p6(y2)));
-
-                        //path.curve3(conv(v_control.x), 
-                        //            flip_y ? -conv(v_control.y) : conv(v_control.y), 
-                        //            conv(v_start.x), 
-                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
-                        goto Close;
-                    }
-
-                    default:  // FT_CURVE_TAG_CUBIC
-                    {
-                        FT_Vector vec1, vec2;
-
-                        if(point + 1 > limit || FT_CURVE_TAG(tags[1]) != FT_CURVE_TAG_CUBIC)
-                        {
-                            return false;
-                        }
-
-                        vec1.x = point[0].x; 
-                        vec1.y = point[0].y;
-                        vec2.x = point[1].x; 
-                        vec2.y = point[1].y;
-
-                        point += 2;
-                        tags  += 2;
-
-                        if(point <= limit)
-                        {
-                            FT_Vector vec;
-
-                            vec.x = point->x;
-                            vec.y = point->y;
-
-                            x1 = int26p6_to_dbl(vec1.x);
-                            y1 = int26p6_to_dbl(vec1.y);
-                            x2 = int26p6_to_dbl(vec2.x);
-                            y2 = int26p6_to_dbl(vec2.y);
-                            x3 = int26p6_to_dbl(vec.x);
-                            y3 = int26p6_to_dbl(vec.y);
-                            if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
-                            mtx.transform(&x1, &y1);
-                            mtx.transform(&x2, &y2);
-                            mtx.transform(&x3, &y3);
-                            path.curve4(value_type(dbl_to_int26p6(x1)), 
-                                        value_type(dbl_to_int26p6(y1)),
-                                        value_type(dbl_to_int26p6(x2)), 
-                                        value_type(dbl_to_int26p6(y2)),
-                                        value_type(dbl_to_int26p6(x3)), 
-                                        value_type(dbl_to_int26p6(y3)));
-
-                            //path.curve4(conv(vec1.x), 
-                            //            flip_y ? -conv(vec1.y) : conv(vec1.y), 
-                            //            conv(vec2.x), 
-                            //            flip_y ? -conv(vec2.y) : conv(vec2.y),
-                            //            conv(vec.x), 
-                            //            flip_y ? -conv(vec.y) : conv(vec.y));
-                            continue;
-                        }
-
-                        x1 = int26p6_to_dbl(vec1.x);
-                        y1 = int26p6_to_dbl(vec1.y);
-                        x2 = int26p6_to_dbl(vec2.x);
-                        y2 = int26p6_to_dbl(vec2.y);
-                        x3 = int26p6_to_dbl(v_start.x);
-                        y3 = int26p6_to_dbl(v_start.y);
-                        if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
-                        mtx.transform(&x1, &y1);
-                        mtx.transform(&x2, &y2);
-                        mtx.transform(&x3, &y3);
-                        path.curve4(value_type(dbl_to_int26p6(x1)), 
-                                    value_type(dbl_to_int26p6(y1)),
-                                    value_type(dbl_to_int26p6(x2)), 
-                                    value_type(dbl_to_int26p6(y2)),
-                                    value_type(dbl_to_int26p6(x3)), 
-                                    value_type(dbl_to_int26p6(y3)));
-
-                        //path.curve4(conv(vec1.x), 
-                        //            flip_y ? -conv(vec1.y) : conv(vec1.y), 
-                        //            conv(vec2.x), 
-                        //            flip_y ? -conv(vec2.y) : conv(vec2.y),
-                        //            conv(v_start.x), 
-                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
-                        goto Close;
-                    }
-                }
-            }
-
-            path.close_polygon();
-
-       Close:
-            first = last + 1; 
-        }
-
-        return true;
-    }
-
-
-
-    //------------------------------------------------------------------------
-    template<class Scanline, class ScanlineStorage>
-    void decompose_ft_bitmap_mono(const FT_Bitmap& bitmap,
-                                  int x, int y,
-                                  bool flip_y,
-                                  Scanline& sl,
-                                  ScanlineStorage& storage)
-    {
-        unsigned int i;
-        const int8u* buf = (const int8u*)bitmap.buffer;
-        int pitch = bitmap.pitch;
-        sl.reset(x, x + bitmap.width);
-        storage.prepare();
-        if(flip_y)
-        {
-            buf += bitmap.pitch * (bitmap.rows - 1);
-            y += bitmap.rows;
-            pitch = -pitch;
-        }
-        for(i = 0; i < (unsigned int)bitmap.rows; i++)
-        {
-            sl.reset_spans();
-            bitset_iterator bits(buf, 0);
-            unsigned int j;
-            for(j = 0; j < (unsigned int)bitmap.width; j++)
-            {
-                if(bits.bit()) sl.add_cell(x + j, cover_full);
-                ++bits;
-            }
-            buf += pitch;
-            if(sl.num_spans())
-            {
-                sl.finalize(y - i - 1);
-                storage.render(sl);
-            }
-        }
-    }
-
-
-
-    //------------------------------------------------------------------------
-    template<class Rasterizer, class Scanline, class ScanlineStorage>
-    void decompose_ft_bitmap_gray8(const FT_Bitmap& bitmap,
-                                   int x, int y,
-                                   bool flip_y,
-                                   Rasterizer& ras,
-                                   Scanline& sl,
-                                   ScanlineStorage& storage)
-    {
-        unsigned int i, j;
-        const int8u* buf = (const int8u*)bitmap.buffer;
-        int pitch = bitmap.pitch;
-        sl.reset(x, x + bitmap.width);
-        storage.prepare();
-        if(flip_y)
-        {
-            buf += bitmap.pitch * (bitmap.rows - 1);
-            y += bitmap.rows;
-            pitch = -pitch;
-        }
-        for(i = 0; i < (unsigned int)bitmap.rows; i++)
-        {
-            sl.reset_spans();
-            const int8u* p = buf;
-            for(j = 0; j < (unsigned int)bitmap.width; j++)
-            {
-                if(*p) sl.add_cell(x + j, ras.apply_gamma(*p));
-                ++p;
-            }
-            buf += pitch;
-            if(sl.num_spans())
-            {
-                sl.finalize(y - i - 1);
-                storage.render(sl);
-            }
-        }
-    }
-
-
-
-
-
-
-
-
-
-
-
-
-
-    //------------------------------------------------------------------------
-    font_engine_freetype_base::~font_engine_freetype_base()
-    {
-        unsigned i;
-        for(i = 0; i < m_num_faces; ++i)
-        {
-            delete [] m_face_names[i];
-            FT_Done_Face(m_faces[i]);
-        }
-        delete [] m_face_names;
-        delete [] m_faces;
-        delete [] m_signature;
-        if(m_library_initialized) FT_Done_FreeType(m_library);
-    }
-
-
-    //------------------------------------------------------------------------
-    font_engine_freetype_base::font_engine_freetype_base(bool flag32, 
-                                                         unsigned max_faces) :
-        m_flag32(flag32),
-        m_change_stamp(0),
-        m_last_error(0),
-        m_name(0),
-        m_name_len(256-16-1),
-        m_face_index(0),
-        m_char_map(FT_ENCODING_NONE),
-        m_signature(new char [256+256-16]),
-        m_height(0),
-        m_width(0),
-        m_hinting(true),
-        m_flip_y(false),
-        m_library_initialized(false),
-        m_library(0),
-        m_faces(new FT_Face [max_faces]),
-        m_face_names(new char* [max_faces]),
-        m_num_faces(0),
-        m_max_faces(max_faces),
-        m_cur_face(0),
-        m_resolution(0),
-        m_glyph_rendering(glyph_ren_native_gray8),
-        m_glyph_index(0),
-        m_data_size(0),
-        m_data_type(glyph_data_invalid),
-        m_bounds(1,1,0,0),
-        m_advance_x(0.0),
-        m_advance_y(0.0),
-
-        m_path16(),
-        m_path32(),
-        m_curves16(m_path16),
-        m_curves32(m_path32),
-        m_scanline_aa(),
-        m_scanline_bin(),
-        m_scanlines_aa(),
-        m_scanlines_bin(),
-        m_rasterizer()
-    {
-        m_curves16.approximation_scale(4.0);
-        m_curves32.approximation_scale(4.0);
-        m_last_error = FT_Init_FreeType(&m_library);
-        if(m_last_error == 0) m_library_initialized = true;
-    }
-
-
-
-    //------------------------------------------------------------------------
-    void font_engine_freetype_base::resolution(unsigned dpi) 
-    { 
-        m_resolution = dpi;
-        update_char_size();
-    }
-
-
-    //------------------------------------------------------------------------
-    int font_engine_freetype_base::find_face(const char* face_name) const
-    {
-        unsigned i;
-        for(i = 0; i < m_num_faces; ++i)
-        {
-            if(strcmp(face_name, m_face_names[i]) == 0) return i;
-        }
-        return -1;
-    }
-
-
-    //------------------------------------------------------------------------
-    double font_engine_freetype_base::ascender() const
-    {
-        if(m_cur_face)
-        {
-            return m_cur_face->ascender * height() / m_cur_face->height;
-        }
-        return 0.0;
-    }
-
-    //------------------------------------------------------------------------
-    double font_engine_freetype_base::descender() const
-    {
-        if(m_cur_face)
-        {
-            return m_cur_face->descender * height() / m_cur_face->height;
-        }
-        return 0.0;
-    }
-
-
-    //------------------------------------------------------------------------
-    bool font_engine_freetype_base::load_font(const char* font_name, 
-                                              unsigned face_index,
-                                              glyph_rendering ren_type,
-                                              const char* font_mem, 
-                                              const long font_mem_size)
-    {
-        bool ret = false;
-
-        if(m_library_initialized)
-        {
-            m_last_error = 0;
-
-            int idx = find_face(font_name);
-            if(idx >= 0)
-            {
-                m_cur_face = m_faces[idx];
-                m_name     = m_face_names[idx];
-            }
-            else
-            {
-                if(m_num_faces >= m_max_faces)
-                {
-                    delete [] m_face_names[0];
-                    FT_Done_Face(m_faces[0]);
-                    memmove(m_faces, 
-                           m_faces + 1, 
-                           (m_max_faces - 1) * sizeof(FT_Face));
-                    memmove(m_face_names, 
-                           m_face_names + 1, 
-                           (m_max_faces - 1) * sizeof(char*));
-                    m_num_faces = m_max_faces - 1;
-                }
-
-                if (font_mem && font_mem_size)
-                {
-                    m_last_error = FT_New_Memory_Face(m_library, 
-                                                      (const FT_Byte*)font_mem, 
-                                                      font_mem_size, 
-                                                      face_index, 
-                                                      &m_faces[m_num_faces]);
-                }
-                else
-                {
-                    m_last_error = FT_New_Face(m_library,
-                                               font_name,
-                                               face_index,
-                                               &m_faces[m_num_faces]);
-                }
-
-                if(m_last_error == 0)
-                {
-                    m_face_names[m_num_faces] = new char [strlen(font_name) + 1];
-                    strcpy(m_face_names[m_num_faces], font_name);
-                    m_cur_face = m_faces[m_num_faces];
-                    m_name     = m_face_names[m_num_faces];
-                    ++m_num_faces;
-                }
-                else
-                {
-                    m_face_names[m_num_faces] = 0;
-                    m_cur_face = 0;
-                    m_name = 0;
-                }
-                if( FT_Select_Charmap(m_cur_face, FT_ENCODING_UNICODE) ) {
-                    if( FT_Select_Charmap(m_cur_face, FT_ENCODING_MS_SYMBOL) ) {
-                        if( FT_Select_Charmap(m_cur_face, FT_ENCODING_APPLE_ROMAN) ) {
-                            m_char_map = FT_ENCODING_NONE;
-                        } else {
-                            m_char_map = FT_ENCODING_APPLE_ROMAN;
-                        }
-                    } else {
-                        m_char_map = FT_ENCODING_MS_SYMBOL;
-                    }
-                } else {
-                    m_char_map = FT_ENCODING_UNICODE;
-                }   
-            }
-
-
-            if(m_last_error == 0)
-            {
-                ret = true;
-                
-                switch(ren_type)
-                {
-                case glyph_ren_native_mono:
-                    m_glyph_rendering = glyph_ren_native_mono;
-                    break;
-
-                case glyph_ren_native_gray8:
-                    m_glyph_rendering = glyph_ren_native_gray8;
-                    break;
-
-                case glyph_ren_outline:
-                    if(FT_IS_SCALABLE(m_cur_face))
-                    {
-                        m_glyph_rendering = glyph_ren_outline;
-                    }
-                    else
-                    {
-                        m_glyph_rendering = glyph_ren_native_gray8;
-                    }
-                    break;
-
-                case glyph_ren_agg_mono:
-                    if(FT_IS_SCALABLE(m_cur_face))
-                    {
-                        m_glyph_rendering = glyph_ren_agg_mono;
-                    }
-                    else
-                    {
-                        m_glyph_rendering = glyph_ren_native_mono;
-                    }
-                    break;
-
-                case glyph_ren_agg_gray8:
-                    if(FT_IS_SCALABLE(m_cur_face))
-                    {
-                        m_glyph_rendering = glyph_ren_agg_gray8;
-                    }
-                    else
-                    {
-                        m_glyph_rendering = glyph_ren_native_gray8;
-                    }
-                    break;
-                }
-                update_signature();
-            }
-        }
-        return ret;
-    }
-
-
-    //------------------------------------------------------------------------
-    bool font_engine_freetype_base::attach(const char* file_name)
-    {
-        if(m_cur_face)
-        {
-            m_last_error = FT_Attach_File(m_cur_face, file_name);
-            return m_last_error == 0;
-        }
-        return false;
-    }
-
-    //------------------------------------------------------------------------
-    unsigned font_engine_freetype_base::num_faces() const
-    {
-        if(m_cur_face)
-        {
-            return m_cur_face->num_faces;
-        }
-        return 0;
-    }
-
-    //------------------------------------------------------------------------
-    bool font_engine_freetype_base::char_map(FT_Encoding /*char_map*/)
-    {
-        if(m_cur_face)
-        {
-            m_last_error = FT_Select_Charmap(m_cur_face, m_char_map);
-            if(m_last_error == 0)
-            {
-                update_signature();
-                return true;
-            }
-        }
-        return false;
-    }
-
-    //------------------------------------------------------------------------
-    bool font_engine_freetype_base::height(double h)
-    {
-        m_height = int(h * 64.0);
-        if(m_cur_face)
-        {
-            update_char_size();
-            return true;
-        }
-        return false;
-    }
-
-    //------------------------------------------------------------------------
-    bool font_engine_freetype_base::width(double w)
-    {
-        m_width = int(w * 64.0);
-        if(m_cur_face)
-        {
-            update_char_size();
-            return true;
-        }
-        return false;
-    }
-
-    //------------------------------------------------------------------------
-    void font_engine_freetype_base::hinting(bool h)
-    { 
-        m_hinting = h; 
-        if(m_cur_face)
-        {
-            update_signature();
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void font_engine_freetype_base::flip_y(bool f)
-    { 
-        m_flip_y = f; 
-        if(m_cur_face)
-        {
-            update_signature();
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void font_engine_freetype_base::transform(const trans_affine& affine)
-    {
-        m_affine = affine;
-        if(m_cur_face)
-        {
-            update_signature();
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void font_engine_freetype_base::update_signature()
-    {
-        if(m_cur_face && m_name)
-        {
-            unsigned name_len = strlen(m_name);
-            if(name_len > m_name_len)
-            {
-                delete [] m_signature;
-                m_signature = new char [name_len + 32 + 256];
-                m_name_len = name_len + 32 - 1;
-            }
-
-            unsigned gamma_hash = 0;
-            if(m_glyph_rendering == glyph_ren_native_gray8 ||
-               m_glyph_rendering == glyph_ren_agg_mono || 
-               m_glyph_rendering == glyph_ren_agg_gray8)
-            {
-                unsigned char gamma_table[rasterizer_scanline_aa<>::aa_scale];
-                unsigned i;
-                for(i = 0; i < rasterizer_scanline_aa<>::aa_scale; ++i)
-                {
-                    gamma_table[i] = m_rasterizer.apply_gamma(i);
-                }
-                gamma_hash = calc_crc32(gamma_table, sizeof(gamma_table));
-            }
-
-            sprintf(m_signature, 
-                    "%s,%u,%d,%d,%d:%dx%d,%d,%d,%08X", 
-                    m_name,
-                    m_char_map,
-                    m_face_index,
-                    int(m_glyph_rendering),
-                    m_resolution,
-                    m_height,
-                    m_width,
-                    int(m_hinting),
-                    int(m_flip_y),
-                    gamma_hash);
-            if(m_glyph_rendering == glyph_ren_outline ||
-               m_glyph_rendering == glyph_ren_agg_mono ||
-               m_glyph_rendering == glyph_ren_agg_gray8)
-            {
-                double mtx[6];
-                char buf[100];
-                m_affine.store_to(mtx);
-                sprintf(buf, ",%08X%08X%08X%08X%08X%08X", 
-                    dbl_to_plain_fx(mtx[0]), 
-                    dbl_to_plain_fx(mtx[1]), 
-                    dbl_to_plain_fx(mtx[2]), 
-                    dbl_to_plain_fx(mtx[3]), 
-                    dbl_to_plain_fx(mtx[4]), 
-                    dbl_to_plain_fx(mtx[5]));
-                strcat(m_signature, buf);
-            }
-            ++m_change_stamp;
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void font_engine_freetype_base::update_char_size()
-    {
-        if(m_cur_face)
-        {
-            if(m_resolution)
-            {
-                FT_Set_Char_Size(m_cur_face, 
-                                 m_width,       // char_width in 1/64th of points
-                                 m_height,      // char_height in 1/64th of points
-                                 m_resolution,  // horizontal device resolution 
-                                 m_resolution); // vertical device resolution 
-            }
-            else
-            {
-                FT_Set_Pixel_Sizes(m_cur_face,    
-                                   m_width >> 6,    // pixel_width
-                                   m_height >> 6);  // pixel_height
-            }
-            update_signature();
-        }
-    }
-
-
-
-
-
-    //------------------------------------------------------------------------
-    bool font_engine_freetype_base::prepare_glyph(unsigned glyph_code)
-    {
-        /* FT_ENCODING_MS_SYMBOL hack inspired from GD's gdft.c:  */
-        /* I do not know the significance of the constant 0xf000. */
-        /* It was determined by inspection of the character codes */
-        /* stored in Microsoft font symbol.ttf                    */
-        if (m_cur_face->charmap &&
-            m_cur_face->charmap->encoding == FT_ENCODING_MS_SYMBOL)
-            glyph_code |= 0xf000;
-
-        m_glyph_index = FT_Get_Char_Index(m_cur_face, glyph_code);
-        m_last_error = FT_Load_Glyph(m_cur_face, 
-                                     m_glyph_index, 
-                                     m_hinting ? FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP : FT_LOAD_NO_HINTING|FT_LOAD_NO_BITMAP);
-//                                     m_hinting ? FT_LOAD_FORCE_AUTOHINT : FT_LOAD_NO_HINTING);
-        if(m_last_error == 0)
-        {
-            switch(m_glyph_rendering)
-            {
-            case glyph_ren_native_mono:
-                m_last_error = FT_Render_Glyph(m_cur_face->glyph, FT_RENDER_MODE_MONO);
-                if(m_last_error == 0)
-                {
-                    decompose_ft_bitmap_mono(m_cur_face->glyph->bitmap, 
-                                             m_cur_face->glyph->bitmap_left,
-                                             m_flip_y ? -m_cur_face->glyph->bitmap_top : 
-                                                         m_cur_face->glyph->bitmap_top,
-                                             m_flip_y,
-                                             m_scanline_bin,
-                                             m_scanlines_bin);
-                    m_bounds.x1 = m_scanlines_bin.min_x();
-                    m_bounds.y1 = m_scanlines_bin.min_y();
-                    m_bounds.x2 = m_scanlines_bin.max_x() + 1;
-                    m_bounds.y2 = m_scanlines_bin.max_y() + 1;
-                    m_data_size = m_scanlines_bin.byte_size(); 
-                    m_data_type = glyph_data_mono;
-                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
-                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
-                    return true;
-                }
-                break;
-
-
-            case glyph_ren_native_gray8:
-                m_last_error = FT_Render_Glyph(m_cur_face->glyph, FT_RENDER_MODE_NORMAL);
-                if(m_last_error == 0)
-                {
-                    decompose_ft_bitmap_gray8(m_cur_face->glyph->bitmap, 
-                                              m_cur_face->glyph->bitmap_left,
-                                              m_flip_y ? -m_cur_face->glyph->bitmap_top : 
-                                                          m_cur_face->glyph->bitmap_top,
-                                              m_flip_y,
-                                              m_rasterizer,
-                                              m_scanline_aa,
-                                              m_scanlines_aa);
-                    m_bounds.x1 = m_scanlines_aa.min_x();
-                    m_bounds.y1 = m_scanlines_aa.min_y();
-                    m_bounds.x2 = m_scanlines_aa.max_x() + 1;
-                    m_bounds.y2 = m_scanlines_aa.max_y() + 1;
-                    m_data_size = m_scanlines_aa.byte_size(); 
-                    m_data_type = glyph_data_gray8;
-                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
-                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
-                    return true;
-                }
-                break;
-
-
-            case glyph_ren_outline:
-                if(m_last_error == 0)
-                {
-                    if(m_flag32)
-                    {
-                        m_path32.remove_all();
-                        if(decompose_ft_outline(m_cur_face->glyph->outline,
-                                                m_flip_y, 
-                                                m_affine,
-                                                m_path32))
-                        {
-                            rect_d bnd  = m_path32.bounding_rect();
-                            m_data_size = m_path32.byte_size();
-                            m_data_type = glyph_data_outline;
-                            m_bounds.x1 = int(floor(bnd.x1));
-                            m_bounds.y1 = int(floor(bnd.y1));
-                            m_bounds.x2 = int(ceil(bnd.x2));
-                            m_bounds.y2 = int(ceil(bnd.y2));
-                            m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
-                            m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
-                            m_affine.transform(&m_advance_x, &m_advance_y);
-                            return true;
-                        }
-                    }
-                    else
-                    {
-                        m_path16.remove_all();
-                        if(decompose_ft_outline(m_cur_face->glyph->outline,
-                                                m_flip_y, 
-                                                m_affine,
-                                                m_path16))
-                        {
-                            rect_d bnd  = m_path16.bounding_rect();
-                            m_data_size = m_path16.byte_size();
-                            m_data_type = glyph_data_outline;
-                            m_bounds.x1 = int(floor(bnd.x1));
-                            m_bounds.y1 = int(floor(bnd.y1));
-                            m_bounds.x2 = int(ceil(bnd.x2));
-                            m_bounds.y2 = int(ceil(bnd.y2));
-                            m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
-                            m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
-                            m_affine.transform(&m_advance_x, &m_advance_y);
-                            return true;
-                        }
-                    }
-                }
-                return false;
-
-            case glyph_ren_agg_mono:
-                if(m_last_error == 0)
-                {
-                    m_rasterizer.reset();
-                    if(m_flag32)
-                    {
-                        m_path32.remove_all();
-                        decompose_ft_outline(m_cur_face->glyph->outline,
-                                             m_flip_y, 
-                                             m_affine,
-                                             m_path32);
-                        m_rasterizer.add_path(m_curves32);
-                    }
-                    else
-                    {
-                        m_path16.remove_all();
-                        decompose_ft_outline(m_cur_face->glyph->outline,
-                                             m_flip_y, 
-                                             m_affine,
-                                             m_path16);
-                        m_rasterizer.add_path(m_curves16);
-                    }
-                    m_scanlines_bin.prepare(); // Remove all 
-                    render_scanlines(m_rasterizer, m_scanline_bin, m_scanlines_bin);
-                    m_bounds.x1 = m_scanlines_bin.min_x();
-                    m_bounds.y1 = m_scanlines_bin.min_y();
-                    m_bounds.x2 = m_scanlines_bin.max_x() + 1;
-                    m_bounds.y2 = m_scanlines_bin.max_y() + 1;
-                    m_data_size = m_scanlines_bin.byte_size(); 
-                    m_data_type = glyph_data_mono;
-                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
-                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
-                    m_affine.transform(&m_advance_x, &m_advance_y);
-                    return true;
-                }
-                return false;
-
-
-            case glyph_ren_agg_gray8:
-                if(m_last_error == 0)
-                {
-                    m_rasterizer.reset();
-                    if(m_flag32)
-                    {
-                        m_path32.remove_all();
-                        decompose_ft_outline(m_cur_face->glyph->outline,
-                                             m_flip_y, 
-                                             m_affine,
-                                             m_path32);
-                        m_rasterizer.add_path(m_curves32);
-                    }
-                    else
-                    {
-                        m_path16.remove_all();
-                        decompose_ft_outline(m_cur_face->glyph->outline,
-                                             m_flip_y, 
-                                             m_affine,
-                                             m_path16);
-                        m_rasterizer.add_path(m_curves16);
-                    }
-                    m_scanlines_aa.prepare(); // Remove all 
-                    render_scanlines(m_rasterizer, m_scanline_aa, m_scanlines_aa);
-                    m_bounds.x1 = m_scanlines_aa.min_x();
-                    m_bounds.y1 = m_scanlines_aa.min_y();
-                    m_bounds.x2 = m_scanlines_aa.max_x() + 1;
-                    m_bounds.y2 = m_scanlines_aa.max_y() + 1;
-                    m_data_size = m_scanlines_aa.byte_size(); 
-                    m_data_type = glyph_data_gray8;
-                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
-                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
-                    m_affine.transform(&m_advance_x, &m_advance_y);
-                    return true;
-                }
-                return false;
-            }
-        }
-        return false;
-    }
-
-
-
-
-    //------------------------------------------------------------------------
-    void font_engine_freetype_base::write_glyph_to(int8u* data) const
-    {
-        if(data && m_data_size)
-        {
-            switch(m_data_type)
-            {
-            default: return;
-            case glyph_data_mono:    m_scanlines_bin.serialize(data); break;
-            case glyph_data_gray8:   m_scanlines_aa.serialize(data);  break;
-            case glyph_data_outline: 
-                if(m_flag32)
-                {
-                    m_path32.serialize(data);
-                }
-                else
-                {
-                    m_path16.serialize(data);
-                }
-                break;
-            case glyph_data_invalid: break;
-            }
-        }
-    }
-
-
-
-    //------------------------------------------------------------------------
-    bool font_engine_freetype_base::add_kerning(unsigned first, unsigned second,
-                                           double* x, double* y)
-    {
-        if(m_cur_face && first && second && FT_HAS_KERNING(m_cur_face))
-        {
-            FT_Vector delta;
-            FT_Get_Kerning(m_cur_face, first, second,
-                           FT_KERNING_DEFAULT, &delta);
-            double dx = int26p6_to_dbl(delta.x);
-            double dy = int26p6_to_dbl(delta.y);
-            if(m_glyph_rendering == glyph_ren_outline ||
-               m_glyph_rendering == glyph_ren_agg_mono ||
-               m_glyph_rendering == glyph_ren_agg_gray8)
-            {
-                m_affine.transform_2x2(&dx, &dy);
-            }
-            *x += dx;
-            *y += dy;
-
-            return true;
-        }
-        return false;
-    }
-
-
-
-}
-
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_gsv_text.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_gsv_text.cpp
--- 8.0.1-5/renderers/agg/src/agg_gsv_text.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_gsv_text.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,675 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Class gsv_text
-//
-//----------------------------------------------------------------------------
-#include <string.h>
-#include <stdio.h>
-#include "../include/agg_gsv_text.h"
-#include "../include/agg_bounding_rect.h"
-
-
-
-namespace mapserver
-{
-    int8u gsv_default_font[] = 
-    {
-        0x40,0x00,0x6c,0x0f,0x15,0x00,0x0e,0x00,0xf9,0xff,
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x0d,0x0a,0x0d,0x0a,0x46,0x6f,0x6e,0x74,0x20,0x28,
-        0x63,0x29,0x20,0x4d,0x69,0x63,0x72,0x6f,0x50,0x72,
-        0x6f,0x66,0x20,0x32,0x37,0x20,0x53,0x65,0x70,0x74,
-        0x65,0x6d,0x62,0x2e,0x31,0x39,0x38,0x39,0x00,0x0d,
-        0x0a,0x0d,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
-        0x02,0x00,0x12,0x00,0x34,0x00,0x46,0x00,0x94,0x00,
-        0xd0,0x00,0x2e,0x01,0x3e,0x01,0x64,0x01,0x8a,0x01,
-        0x98,0x01,0xa2,0x01,0xb4,0x01,0xba,0x01,0xc6,0x01,
-        0xcc,0x01,0xf0,0x01,0xfa,0x01,0x18,0x02,0x38,0x02,
-        0x44,0x02,0x68,0x02,0x98,0x02,0xa2,0x02,0xde,0x02,
-        0x0e,0x03,0x24,0x03,0x40,0x03,0x48,0x03,0x52,0x03,
-        0x5a,0x03,0x82,0x03,0xec,0x03,0xfa,0x03,0x26,0x04,
-        0x4c,0x04,0x6a,0x04,0x7c,0x04,0x8a,0x04,0xb6,0x04,
-        0xc4,0x04,0xca,0x04,0xe0,0x04,0xee,0x04,0xf8,0x04,
-        0x0a,0x05,0x18,0x05,0x44,0x05,0x5e,0x05,0x8e,0x05,
-        0xac,0x05,0xd6,0x05,0xe0,0x05,0xf6,0x05,0x00,0x06,
-        0x12,0x06,0x1c,0x06,0x28,0x06,0x36,0x06,0x48,0x06,
-        0x4e,0x06,0x60,0x06,0x6e,0x06,0x74,0x06,0x84,0x06,
-        0xa6,0x06,0xc8,0x06,0xe6,0x06,0x08,0x07,0x2c,0x07,
-        0x3c,0x07,0x68,0x07,0x7c,0x07,0x8c,0x07,0xa2,0x07,
-        0xb0,0x07,0xb6,0x07,0xd8,0x07,0xec,0x07,0x10,0x08,
-        0x32,0x08,0x54,0x08,0x64,0x08,0x88,0x08,0x98,0x08,
-        0xac,0x08,0xb6,0x08,0xc8,0x08,0xd2,0x08,0xe4,0x08,
-        0xf2,0x08,0x3e,0x09,0x48,0x09,0x94,0x09,0xc2,0x09,
-        0xc4,0x09,0xd0,0x09,0xe2,0x09,0x04,0x0a,0x0e,0x0a,
-        0x26,0x0a,0x34,0x0a,0x4a,0x0a,0x66,0x0a,0x70,0x0a,
-        0x7e,0x0a,0x8e,0x0a,0x9a,0x0a,0xa6,0x0a,0xb4,0x0a,
-        0xd8,0x0a,0xe2,0x0a,0xf6,0x0a,0x18,0x0b,0x22,0x0b,
-        0x32,0x0b,0x56,0x0b,0x60,0x0b,0x6e,0x0b,0x7c,0x0b,
-        0x8a,0x0b,0x9c,0x0b,0x9e,0x0b,0xb2,0x0b,0xc2,0x0b,
-        0xd8,0x0b,0xf4,0x0b,0x08,0x0c,0x30,0x0c,0x56,0x0c,
-        0x72,0x0c,0x90,0x0c,0xb2,0x0c,0xce,0x0c,0xe2,0x0c,
-        0xfe,0x0c,0x10,0x0d,0x26,0x0d,0x36,0x0d,0x42,0x0d,
-        0x4e,0x0d,0x5c,0x0d,0x78,0x0d,0x8c,0x0d,0x8e,0x0d,
-        0x90,0x0d,0x92,0x0d,0x94,0x0d,0x96,0x0d,0x98,0x0d,
-        0x9a,0x0d,0x9c,0x0d,0x9e,0x0d,0xa0,0x0d,0xa2,0x0d,
-        0xa4,0x0d,0xa6,0x0d,0xa8,0x0d,0xaa,0x0d,0xac,0x0d,
-        0xae,0x0d,0xb0,0x0d,0xb2,0x0d,0xb4,0x0d,0xb6,0x0d,
-        0xb8,0x0d,0xba,0x0d,0xbc,0x0d,0xbe,0x0d,0xc0,0x0d,
-        0xc2,0x0d,0xc4,0x0d,0xc6,0x0d,0xc8,0x0d,0xca,0x0d,
-        0xcc,0x0d,0xce,0x0d,0xd0,0x0d,0xd2,0x0d,0xd4,0x0d,
-        0xd6,0x0d,0xd8,0x0d,0xda,0x0d,0xdc,0x0d,0xde,0x0d,
-        0xe0,0x0d,0xe2,0x0d,0xe4,0x0d,0xe6,0x0d,0xe8,0x0d,
-        0xea,0x0d,0xec,0x0d,0x0c,0x0e,0x26,0x0e,0x48,0x0e,
-        0x64,0x0e,0x88,0x0e,0x92,0x0e,0xa6,0x0e,0xb4,0x0e,
-        0xd0,0x0e,0xee,0x0e,0x02,0x0f,0x16,0x0f,0x26,0x0f,
-        0x3c,0x0f,0x58,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,
-        0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,
-        0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,
-        0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x10,0x80,
-        0x05,0x95,0x00,0x72,0x00,0xfb,0xff,0x7f,0x01,0x7f,
-        0x01,0x01,0xff,0x01,0x05,0xfe,0x05,0x95,0xff,0x7f,
-        0x00,0x7a,0x01,0x86,0xff,0x7a,0x01,0x87,0x01,0x7f,
-        0xfe,0x7a,0x0a,0x87,0xff,0x7f,0x00,0x7a,0x01,0x86,
-        0xff,0x7a,0x01,0x87,0x01,0x7f,0xfe,0x7a,0x05,0xf2,
-        0x0b,0x95,0xf9,0x64,0x0d,0x9c,0xf9,0x64,0xfa,0x91,
-        0x0e,0x00,0xf1,0xfa,0x0e,0x00,0x04,0xfc,0x08,0x99,
-        0x00,0x63,0x04,0x9d,0x00,0x63,0x04,0x96,0xff,0x7f,
-        0x01,0x7f,0x01,0x01,0x00,0x01,0xfe,0x02,0xfd,0x01,
-        0xfc,0x00,0xfd,0x7f,0xfe,0x7e,0x00,0x7e,0x01,0x7e,
-        0x01,0x7f,0x02,0x7f,0x06,0x7e,0x02,0x7f,0x02,0x7e,
-        0xf2,0x89,0x02,0x7e,0x02,0x7f,0x06,0x7e,0x02,0x7f,
-        0x01,0x7f,0x01,0x7e,0x00,0x7c,0xfe,0x7e,0xfd,0x7f,
-        0xfc,0x00,0xfd,0x01,0xfe,0x02,0x00,0x01,0x01,0x01,
-        0x01,0x7f,0xff,0x7f,0x10,0xfd,0x15,0x95,0xee,0x6b,
-        0x05,0x95,0x02,0x7e,0x00,0x7e,0xff,0x7e,0xfe,0x7f,
-        0xfe,0x00,0xfe,0x02,0x00,0x02,0x01,0x02,0x02,0x01,
-        0x02,0x00,0x02,0x7f,0x03,0x7f,0x03,0x00,0x03,0x01,
-        0x02,0x01,0xfc,0xf2,0xfe,0x7f,0xff,0x7e,0x00,0x7e,
-        0x02,0x7e,0x02,0x00,0x02,0x01,0x01,0x02,0x00,0x02,
-        0xfe,0x02,0xfe,0x00,0x07,0xf9,0x15,0x8d,0xff,0x7f,
-        0x01,0x7f,0x01,0x01,0x00,0x01,0xff,0x01,0xff,0x00,
-        0xff,0x7f,0xff,0x7e,0xfe,0x7b,0xfe,0x7d,0xfe,0x7e,
-        0xfe,0x7f,0xfd,0x00,0xfd,0x01,0xff,0x02,0x00,0x03,
-        0x01,0x02,0x06,0x04,0x02,0x02,0x01,0x02,0x00,0x02,
-        0xff,0x02,0xfe,0x01,0xfe,0x7f,0xff,0x7e,0x00,0x7e,
-        0x01,0x7d,0x02,0x7d,0x05,0x79,0x02,0x7e,0x03,0x7f,
-        0x01,0x00,0x01,0x01,0x00,0x01,0xf1,0xfe,0xfe,0x01,
-        0xff,0x02,0x00,0x03,0x01,0x02,0x02,0x02,0x00,0x86,
-        0x01,0x7e,0x08,0x75,0x02,0x7e,0x02,0x7f,0x05,0x80,
-        0x05,0x93,0xff,0x01,0x01,0x01,0x01,0x7f,0x00,0x7e,
-        0xff,0x7e,0xff,0x7f,0x06,0xf1,0x0b,0x99,0xfe,0x7e,
-        0xfe,0x7d,0xfe,0x7c,0xff,0x7b,0x00,0x7c,0x01,0x7b,
-        0x02,0x7c,0x02,0x7d,0x02,0x7e,0xfe,0x9e,0xfe,0x7c,
-        0xff,0x7d,0xff,0x7b,0x00,0x7c,0x01,0x7b,0x01,0x7d,
-        0x02,0x7c,0x05,0x85,0x03,0x99,0x02,0x7e,0x02,0x7d,
-        0x02,0x7c,0x01,0x7b,0x00,0x7c,0xff,0x7b,0xfe,0x7c,
-        0xfe,0x7d,0xfe,0x7e,0x02,0x9e,0x02,0x7c,0x01,0x7d,
-        0x01,0x7b,0x00,0x7c,0xff,0x7b,0xff,0x7d,0xfe,0x7c,
-        0x09,0x85,0x08,0x95,0x00,0x74,0xfb,0x89,0x0a,0x7a,
-        0x00,0x86,0xf6,0x7a,0x0d,0xf4,0x0d,0x92,0x00,0x6e,
-        0xf7,0x89,0x12,0x00,0x04,0xf7,0x06,0x81,0xff,0x7f,
-        0xff,0x01,0x01,0x01,0x01,0x7f,0x00,0x7e,0xff,0x7e,
-        0xff,0x7f,0x06,0x84,0x04,0x89,0x12,0x00,0x04,0xf7,
-        0x05,0x82,0xff,0x7f,0x01,0x7f,0x01,0x01,0xff,0x01,
-        0x05,0xfe,0x00,0xfd,0x0e,0x18,0x00,0xeb,0x09,0x95,
-        0xfd,0x7f,0xfe,0x7d,0xff,0x7b,0x00,0x7d,0x01,0x7b,
-        0x02,0x7d,0x03,0x7f,0x02,0x00,0x03,0x01,0x02,0x03,
-        0x01,0x05,0x00,0x03,0xff,0x05,0xfe,0x03,0xfd,0x01,
-        0xfe,0x00,0x0b,0xeb,0x06,0x91,0x02,0x01,0x03,0x03,
-        0x00,0x6b,0x09,0x80,0x04,0x90,0x00,0x01,0x01,0x02,
-        0x01,0x01,0x02,0x01,0x04,0x00,0x02,0x7f,0x01,0x7f,
-        0x01,0x7e,0x00,0x7e,0xff,0x7e,0xfe,0x7d,0xf6,0x76,
-        0x0e,0x00,0x03,0x80,0x05,0x95,0x0b,0x00,0xfa,0x78,
-        0x03,0x00,0x02,0x7f,0x01,0x7f,0x01,0x7d,0x00,0x7e,
-        0xff,0x7d,0xfe,0x7e,0xfd,0x7f,0xfd,0x00,0xfd,0x01,
-        0xff,0x01,0xff,0x02,0x11,0xfc,0x0d,0x95,0xf6,0x72,
-        0x0f,0x00,0xfb,0x8e,0x00,0x6b,0x07,0x80,0x0f,0x95,
-        0xf6,0x00,0xff,0x77,0x01,0x01,0x03,0x01,0x03,0x00,
-        0x03,0x7f,0x02,0x7e,0x01,0x7d,0x00,0x7e,0xff,0x7d,
-        0xfe,0x7e,0xfd,0x7f,0xfd,0x00,0xfd,0x01,0xff,0x01,
-        0xff,0x02,0x11,0xfc,0x10,0x92,0xff,0x02,0xfd,0x01,
-        0xfe,0x00,0xfd,0x7f,0xfe,0x7d,0xff,0x7b,0x00,0x7b,
-        0x01,0x7c,0x02,0x7e,0x03,0x7f,0x01,0x00,0x03,0x01,
-        0x02,0x02,0x01,0x03,0x00,0x01,0xff,0x03,0xfe,0x02,
-        0xfd,0x01,0xff,0x00,0xfd,0x7f,0xfe,0x7e,0xff,0x7d,
-        0x10,0xf9,0x11,0x95,0xf6,0x6b,0xfc,0x95,0x0e,0x00,
-        0x03,0xeb,0x08,0x95,0xfd,0x7f,0xff,0x7e,0x00,0x7e,
-        0x01,0x7e,0x02,0x7f,0x04,0x7f,0x03,0x7f,0x02,0x7e,
-        0x01,0x7e,0x00,0x7d,0xff,0x7e,0xff,0x7f,0xfd,0x7f,
-        0xfc,0x00,0xfd,0x01,0xff,0x01,0xff,0x02,0x00,0x03,
-        0x01,0x02,0x02,0x02,0x03,0x01,0x04,0x01,0x02,0x01,
-        0x01,0x02,0x00,0x02,0xff,0x02,0xfd,0x01,0xfc,0x00,
-        0x0c,0xeb,0x10,0x8e,0xff,0x7d,0xfe,0x7e,0xfd,0x7f,
-        0xff,0x00,0xfd,0x01,0xfe,0x02,0xff,0x03,0x00,0x01,
-        0x01,0x03,0x02,0x02,0x03,0x01,0x01,0x00,0x03,0x7f,
-        0x02,0x7e,0x01,0x7c,0x00,0x7b,0xff,0x7b,0xfe,0x7d,
-        0xfd,0x7f,0xfe,0x00,0xfd,0x01,0xff,0x02,0x10,0xfd,
-        0x05,0x8e,0xff,0x7f,0x01,0x7f,0x01,0x01,0xff,0x01,
-        0x00,0xf4,0xff,0x7f,0x01,0x7f,0x01,0x01,0xff,0x01,
-        0x05,0xfe,0x05,0x8e,0xff,0x7f,0x01,0x7f,0x01,0x01,
-        0xff,0x01,0x01,0xf3,0xff,0x7f,0xff,0x01,0x01,0x01,
-        0x01,0x7f,0x00,0x7e,0xff,0x7e,0xff,0x7f,0x06,0x84,
-        0x14,0x92,0xf0,0x77,0x10,0x77,0x04,0x80,0x04,0x8c,
-        0x12,0x00,0xee,0xfa,0x12,0x00,0x04,0xfa,0x04,0x92,
-        0x10,0x77,0xf0,0x77,0x14,0x80,0x03,0x90,0x00,0x01,
-        0x01,0x02,0x01,0x01,0x02,0x01,0x04,0x00,0x02,0x7f,
-        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xff,0x7e,0xff,0x7f,
-        0xfc,0x7e,0x00,0x7d,0x00,0xfb,0xff,0x7f,0x01,0x7f,
-        0x01,0x01,0xff,0x01,0x09,0xfe,0x12,0x8d,0xff,0x02,
-        0xfe,0x01,0xfd,0x00,0xfe,0x7f,0xff,0x7f,0xff,0x7d,
-        0x00,0x7d,0x01,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
-        0x01,0x02,0xfb,0x88,0xfe,0x7e,0xff,0x7d,0x00,0x7d,
-        0x01,0x7e,0x01,0x7f,0x07,0x8b,0xff,0x78,0x00,0x7e,
-        0x02,0x7f,0x02,0x00,0x02,0x02,0x01,0x03,0x00,0x02,
-        0xff,0x03,0xff,0x02,0xfe,0x02,0xfe,0x01,0xfd,0x01,
-        0xfd,0x00,0xfd,0x7f,0xfe,0x7f,0xfe,0x7e,0xff,0x7e,
-        0xff,0x7d,0x00,0x7d,0x01,0x7d,0x01,0x7e,0x02,0x7e,
-        0x02,0x7f,0x03,0x7f,0x03,0x00,0x03,0x01,0x02,0x01,
-        0x01,0x01,0xfe,0x8d,0xff,0x78,0x00,0x7e,0x01,0x7f,
-        0x08,0xfb,0x09,0x95,0xf8,0x6b,0x08,0x95,0x08,0x6b,
-        0xf3,0x87,0x0a,0x00,0x04,0xf9,0x04,0x95,0x00,0x6b,
-        0x00,0x95,0x09,0x00,0x03,0x7f,0x01,0x7f,0x01,0x7e,
-        0x00,0x7e,0xff,0x7e,0xff,0x7f,0xfd,0x7f,0xf7,0x80,
-        0x09,0x00,0x03,0x7f,0x01,0x7f,0x01,0x7e,0x00,0x7d,
-        0xff,0x7e,0xff,0x7f,0xfd,0x7f,0xf7,0x00,0x11,0x80,
-        0x12,0x90,0xff,0x02,0xfe,0x02,0xfe,0x01,0xfc,0x00,
-        0xfe,0x7f,0xfe,0x7e,0xff,0x7e,0xff,0x7d,0x00,0x7b,
-        0x01,0x7d,0x01,0x7e,0x02,0x7e,0x02,0x7f,0x04,0x00,
-        0x02,0x01,0x02,0x02,0x01,0x02,0x03,0xfb,0x04,0x95,
-        0x00,0x6b,0x00,0x95,0x07,0x00,0x03,0x7f,0x02,0x7e,
-        0x01,0x7e,0x01,0x7d,0x00,0x7b,0xff,0x7d,0xff,0x7e,
-        0xfe,0x7e,0xfd,0x7f,0xf9,0x00,0x11,0x80,0x04,0x95,
-        0x00,0x6b,0x00,0x95,0x0d,0x00,0xf3,0xf6,0x08,0x00,
-        0xf8,0xf5,0x0d,0x00,0x02,0x80,0x04,0x95,0x00,0x6b,
-        0x00,0x95,0x0d,0x00,0xf3,0xf6,0x08,0x00,0x06,0xf5,
-        0x12,0x90,0xff,0x02,0xfe,0x02,0xfe,0x01,0xfc,0x00,
-        0xfe,0x7f,0xfe,0x7e,0xff,0x7e,0xff,0x7d,0x00,0x7b,
-        0x01,0x7d,0x01,0x7e,0x02,0x7e,0x02,0x7f,0x04,0x00,
-        0x02,0x01,0x02,0x02,0x01,0x02,0x00,0x03,0xfb,0x80,
-        0x05,0x00,0x03,0xf8,0x04,0x95,0x00,0x6b,0x0e,0x95,
-        0x00,0x6b,0xf2,0x8b,0x0e,0x00,0x04,0xf5,0x04,0x95,
-        0x00,0x6b,0x04,0x80,0x0c,0x95,0x00,0x70,0xff,0x7d,
-        0xff,0x7f,0xfe,0x7f,0xfe,0x00,0xfe,0x01,0xff,0x01,
-        0xff,0x03,0x00,0x02,0x0e,0xf9,0x04,0x95,0x00,0x6b,
-        0x0e,0x95,0xf2,0x72,0x05,0x85,0x09,0x74,0x03,0x80,
-        0x04,0x95,0x00,0x6b,0x00,0x80,0x0c,0x00,0x01,0x80,
-        0x04,0x95,0x00,0x6b,0x00,0x95,0x08,0x6b,0x08,0x95,
-        0xf8,0x6b,0x08,0x95,0x00,0x6b,0x04,0x80,0x04,0x95,
-        0x00,0x6b,0x00,0x95,0x0e,0x6b,0x00,0x95,0x00,0x6b,
-        0x04,0x80,0x09,0x95,0xfe,0x7f,0xfe,0x7e,0xff,0x7e,
-        0xff,0x7d,0x00,0x7b,0x01,0x7d,0x01,0x7e,0x02,0x7e,
-        0x02,0x7f,0x04,0x00,0x02,0x01,0x02,0x02,0x01,0x02,
-        0x01,0x03,0x00,0x05,0xff,0x03,0xff,0x02,0xfe,0x02,
-        0xfe,0x01,0xfc,0x00,0x0d,0xeb,0x04,0x95,0x00,0x6b,
-        0x00,0x95,0x09,0x00,0x03,0x7f,0x01,0x7f,0x01,0x7e,
-        0x00,0x7d,0xff,0x7e,0xff,0x7f,0xfd,0x7f,0xf7,0x00,
-        0x11,0xf6,0x09,0x95,0xfe,0x7f,0xfe,0x7e,0xff,0x7e,
-        0xff,0x7d,0x00,0x7b,0x01,0x7d,0x01,0x7e,0x02,0x7e,
-        0x02,0x7f,0x04,0x00,0x02,0x01,0x02,0x02,0x01,0x02,
-        0x01,0x03,0x00,0x05,0xff,0x03,0xff,0x02,0xfe,0x02,
-        0xfe,0x01,0xfc,0x00,0x03,0xef,0x06,0x7a,0x04,0x82,
-        0x04,0x95,0x00,0x6b,0x00,0x95,0x09,0x00,0x03,0x7f,
-        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xff,0x7e,0xff,0x7f,
-        0xfd,0x7f,0xf7,0x00,0x07,0x80,0x07,0x75,0x03,0x80,
-        0x11,0x92,0xfe,0x02,0xfd,0x01,0xfc,0x00,0xfd,0x7f,
-        0xfe,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,0x02,0x7f,
-        0x06,0x7e,0x02,0x7f,0x01,0x7f,0x01,0x7e,0x00,0x7d,
-        0xfe,0x7e,0xfd,0x7f,0xfc,0x00,0xfd,0x01,0xfe,0x02,
-        0x11,0xfd,0x08,0x95,0x00,0x6b,0xf9,0x95,0x0e,0x00,
-        0x01,0xeb,0x04,0x95,0x00,0x71,0x01,0x7d,0x02,0x7e,
-        0x03,0x7f,0x02,0x00,0x03,0x01,0x02,0x02,0x01,0x03,
-        0x00,0x0f,0x04,0xeb,0x01,0x95,0x08,0x6b,0x08,0x95,
-        0xf8,0x6b,0x09,0x80,0x02,0x95,0x05,0x6b,0x05,0x95,
-        0xfb,0x6b,0x05,0x95,0x05,0x6b,0x05,0x95,0xfb,0x6b,
-        0x07,0x80,0x03,0x95,0x0e,0x6b,0x00,0x95,0xf2,0x6b,
-        0x11,0x80,0x01,0x95,0x08,0x76,0x00,0x75,0x08,0x95,
-        0xf8,0x76,0x09,0xf5,0x11,0x95,0xf2,0x6b,0x00,0x95,
-        0x0e,0x00,0xf2,0xeb,0x0e,0x00,0x03,0x80,0x03,0x93,
-        0x00,0x6c,0x01,0x94,0x00,0x6c,0xff,0x94,0x05,0x00,
-        0xfb,0xec,0x05,0x00,0x02,0x81,0x00,0x95,0x0e,0x68,
-        0x00,0x83,0x06,0x93,0x00,0x6c,0x01,0x94,0x00,0x6c,
-        0xfb,0x94,0x05,0x00,0xfb,0xec,0x05,0x00,0x03,0x81,
-        0x03,0x87,0x08,0x05,0x08,0x7b,0xf0,0x80,0x08,0x04,
-        0x08,0x7c,0x03,0xf9,0x01,0x80,0x10,0x00,0x01,0x80,
-        0x06,0x95,0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7f,
-        0x01,0x01,0xff,0x01,0x05,0xef,0x0f,0x8e,0x00,0x72,
-        0x00,0x8b,0xfe,0x02,0xfe,0x01,0xfd,0x00,0xfe,0x7f,
-        0xfe,0x7e,0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,
-        0x02,0x7f,0x03,0x00,0x02,0x01,0x02,0x02,0x04,0xfd,
-        0x04,0x95,0x00,0x6b,0x00,0x8b,0x02,0x02,0x02,0x01,
-        0x03,0x00,0x02,0x7f,0x02,0x7e,0x01,0x7d,0x00,0x7e,
-        0xff,0x7d,0xfe,0x7e,0xfe,0x7f,0xfd,0x00,0xfe,0x01,
-        0xfe,0x02,0x0f,0xfd,0x0f,0x8b,0xfe,0x02,0xfe,0x01,
-        0xfd,0x00,0xfe,0x7f,0xfe,0x7e,0xff,0x7d,0x00,0x7e,
-        0x01,0x7d,0x02,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
-        0x02,0x02,0x03,0xfd,0x0f,0x95,0x00,0x6b,0x00,0x8b,
-        0xfe,0x02,0xfe,0x01,0xfd,0x00,0xfe,0x7f,0xfe,0x7e,
-        0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,0x02,0x7f,
-        0x03,0x00,0x02,0x01,0x02,0x02,0x04,0xfd,0x03,0x88,
-        0x0c,0x00,0x00,0x02,0xff,0x02,0xff,0x01,0xfe,0x01,
-        0xfd,0x00,0xfe,0x7f,0xfe,0x7e,0xff,0x7d,0x00,0x7e,
-        0x01,0x7d,0x02,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
-        0x02,0x02,0x03,0xfd,0x0a,0x95,0xfe,0x00,0xfe,0x7f,
-        0xff,0x7d,0x00,0x6f,0xfd,0x8e,0x07,0x00,0x03,0xf2,
-        0x0f,0x8e,0x00,0x70,0xff,0x7d,0xff,0x7f,0xfe,0x7f,
-        0xfd,0x00,0xfe,0x01,0x09,0x91,0xfe,0x02,0xfe,0x01,
-        0xfd,0x00,0xfe,0x7f,0xfe,0x7e,0xff,0x7d,0x00,0x7e,
-        0x01,0x7d,0x02,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
-        0x02,0x02,0x04,0xfd,0x04,0x95,0x00,0x6b,0x00,0x8a,
-        0x03,0x03,0x02,0x01,0x03,0x00,0x02,0x7f,0x01,0x7d,
-        0x00,0x76,0x04,0x80,0x03,0x95,0x01,0x7f,0x01,0x01,
-        0xff,0x01,0xff,0x7f,0x01,0xf9,0x00,0x72,0x04,0x80,
-        0x05,0x95,0x01,0x7f,0x01,0x01,0xff,0x01,0xff,0x7f,
-        0x01,0xf9,0x00,0x6f,0xff,0x7d,0xfe,0x7f,0xfe,0x00,
-        0x09,0x87,0x04,0x95,0x00,0x6b,0x0a,0x8e,0xf6,0x76,
-        0x04,0x84,0x07,0x78,0x02,0x80,0x04,0x95,0x00,0x6b,
-        0x04,0x80,0x04,0x8e,0x00,0x72,0x00,0x8a,0x03,0x03,
-        0x02,0x01,0x03,0x00,0x02,0x7f,0x01,0x7d,0x00,0x76,
-        0x00,0x8a,0x03,0x03,0x02,0x01,0x03,0x00,0x02,0x7f,
-        0x01,0x7d,0x00,0x76,0x04,0x80,0x04,0x8e,0x00,0x72,
-        0x00,0x8a,0x03,0x03,0x02,0x01,0x03,0x00,0x02,0x7f,
-        0x01,0x7d,0x00,0x76,0x04,0x80,0x08,0x8e,0xfe,0x7f,
-        0xfe,0x7e,0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,
-        0x02,0x7f,0x03,0x00,0x02,0x01,0x02,0x02,0x01,0x03,
-        0x00,0x02,0xff,0x03,0xfe,0x02,0xfe,0x01,0xfd,0x00,
-        0x0b,0xf2,0x04,0x8e,0x00,0x6b,0x00,0x92,0x02,0x02,
-        0x02,0x01,0x03,0x00,0x02,0x7f,0x02,0x7e,0x01,0x7d,
-        0x00,0x7e,0xff,0x7d,0xfe,0x7e,0xfe,0x7f,0xfd,0x00,
-        0xfe,0x01,0xfe,0x02,0x0f,0xfd,0x0f,0x8e,0x00,0x6b,
-        0x00,0x92,0xfe,0x02,0xfe,0x01,0xfd,0x00,0xfe,0x7f,
-        0xfe,0x7e,0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,
-        0x02,0x7f,0x03,0x00,0x02,0x01,0x02,0x02,0x04,0xfd,
-        0x04,0x8e,0x00,0x72,0x00,0x88,0x01,0x03,0x02,0x02,
-        0x02,0x01,0x03,0x00,0x01,0xf2,0x0e,0x8b,0xff,0x02,
-        0xfd,0x01,0xfd,0x00,0xfd,0x7f,0xff,0x7e,0x01,0x7e,
-        0x02,0x7f,0x05,0x7f,0x02,0x7f,0x01,0x7e,0x00,0x7f,
-        0xff,0x7e,0xfd,0x7f,0xfd,0x00,0xfd,0x01,0xff,0x02,
-        0x0e,0xfd,0x05,0x95,0x00,0x6f,0x01,0x7d,0x02,0x7f,
-        0x02,0x00,0xf8,0x8e,0x07,0x00,0x03,0xf2,0x04,0x8e,
-        0x00,0x76,0x01,0x7d,0x02,0x7f,0x03,0x00,0x02,0x01,
-        0x03,0x03,0x00,0x8a,0x00,0x72,0x04,0x80,0x02,0x8e,
-        0x06,0x72,0x06,0x8e,0xfa,0x72,0x08,0x80,0x03,0x8e,
-        0x04,0x72,0x04,0x8e,0xfc,0x72,0x04,0x8e,0x04,0x72,
-        0x04,0x8e,0xfc,0x72,0x07,0x80,0x03,0x8e,0x0b,0x72,
-        0x00,0x8e,0xf5,0x72,0x0e,0x80,0x02,0x8e,0x06,0x72,
-        0x06,0x8e,0xfa,0x72,0xfe,0x7c,0xfe,0x7e,0xfe,0x7f,
-        0xff,0x00,0x0f,0x87,0x0e,0x8e,0xf5,0x72,0x00,0x8e,
-        0x0b,0x00,0xf5,0xf2,0x0b,0x00,0x03,0x80,0x09,0x99,
-        0xfe,0x7f,0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7e,
-        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xfe,0x7e,0x01,0x8e,
-        0xff,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,0x01,0x7e,
-        0x00,0x7e,0xff,0x7e,0xfc,0x7e,0x04,0x7e,0x01,0x7e,
-        0x00,0x7e,0xff,0x7e,0xff,0x7f,0xff,0x7e,0x00,0x7e,
-        0x01,0x7e,0xff,0x8e,0x02,0x7e,0x00,0x7e,0xff,0x7e,
-        0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,
-        0x02,0x7f,0x05,0x87,0x04,0x95,0x00,0x77,0x00,0xfd,
-        0x00,0x77,0x04,0x80,0x05,0x99,0x02,0x7f,0x01,0x7f,
-        0x01,0x7e,0x00,0x7e,0xff,0x7e,0xff,0x7f,0xff,0x7e,
-        0x00,0x7e,0x02,0x7e,0xff,0x8e,0x01,0x7e,0x00,0x7e,
-        0xff,0x7e,0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7e,
-        0x04,0x7e,0xfc,0x7e,0xff,0x7e,0x00,0x7e,0x01,0x7e,
-        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xff,0x7e,0x01,0x8e,
-        0xfe,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,0x01,0x7e,
-        0x00,0x7e,0xff,0x7e,0xff,0x7f,0xfe,0x7f,0x09,0x87,
-        0x03,0x86,0x00,0x02,0x01,0x03,0x02,0x01,0x02,0x00,
-        0x02,0x7f,0x04,0x7d,0x02,0x7f,0x02,0x00,0x02,0x01,
-        0x01,0x02,0xee,0xfe,0x01,0x02,0x02,0x01,0x02,0x00,
-        0x02,0x7f,0x04,0x7d,0x02,0x7f,0x02,0x00,0x02,0x01,
-        0x01,0x03,0x00,0x02,0x03,0xf4,0x10,0x80,0x03,0x80,
-        0x07,0x15,0x08,0x6b,0xfe,0x85,0xf5,0x00,0x10,0xfb,
-        0x0d,0x95,0xf6,0x00,0x00,0x6b,0x0a,0x00,0x02,0x02,
-        0x00,0x08,0xfe,0x02,0xf6,0x00,0x0e,0xf4,0x03,0x80,
-        0x00,0x15,0x0a,0x00,0x02,0x7e,0x00,0x7e,0x00,0x7d,
-        0x00,0x7e,0xfe,0x7f,0xf6,0x00,0x0a,0x80,0x02,0x7e,
-        0x01,0x7e,0x00,0x7d,0xff,0x7d,0xfe,0x7f,0xf6,0x00,
-        0x10,0x80,0x03,0x80,0x00,0x15,0x0c,0x00,0xff,0x7e,
-        0x03,0xed,0x03,0xfd,0x00,0x03,0x02,0x00,0x00,0x12,
-        0x02,0x03,0x0a,0x00,0x00,0x6b,0x02,0x00,0x00,0x7d,
-        0xfe,0x83,0xf4,0x00,0x11,0x80,0x0f,0x80,0xf4,0x00,
-        0x00,0x15,0x0c,0x00,0xff,0xf6,0xf5,0x00,0x0f,0xf5,
-        0x04,0x95,0x07,0x76,0x00,0x0a,0x07,0x80,0xf9,0x76,
-        0x00,0x75,0xf8,0x80,0x07,0x0c,0x09,0xf4,0xf9,0x0c,
-        0x09,0xf4,0x03,0x92,0x02,0x03,0x07,0x00,0x03,0x7d,
-        0x00,0x7b,0xfc,0x7e,0x04,0x7d,0x00,0x7a,0xfd,0x7e,
-        0xf9,0x00,0xfe,0x02,0x06,0x89,0x02,0x00,0x06,0xf5,
-        0x03,0x95,0x00,0x6b,0x0c,0x15,0x00,0x6b,0x02,0x80,
-        0x03,0x95,0x00,0x6b,0x0c,0x15,0x00,0x6b,0xf8,0x96,
-        0x03,0x00,0x07,0xea,0x03,0x80,0x00,0x15,0x0c,0x80,
-        0xf7,0x76,0xfd,0x00,0x03,0x80,0x0a,0x75,0x03,0x80,
-        0x03,0x80,0x07,0x13,0x02,0x02,0x03,0x00,0x00,0x6b,
-        0x02,0x80,0x03,0x80,0x00,0x15,0x09,0x6b,0x09,0x15,
-        0x00,0x6b,0x03,0x80,0x03,0x80,0x00,0x15,0x00,0xf6,
-        0x0d,0x00,0x00,0x8a,0x00,0x6b,0x03,0x80,0x07,0x80,
-        0xfd,0x00,0xff,0x03,0x00,0x04,0x00,0x07,0x00,0x04,
-        0x01,0x02,0x03,0x01,0x06,0x00,0x03,0x7f,0x01,0x7e,
-        0x01,0x7c,0x00,0x79,0xff,0x7c,0xff,0x7d,0xfd,0x00,
-        0xfa,0x00,0x0e,0x80,0x03,0x80,0x00,0x15,0x0c,0x00,
-        0x00,0x6b,0x02,0x80,0x03,0x80,0x00,0x15,0x0a,0x00,
-        0x02,0x7f,0x01,0x7d,0x00,0x7b,0xff,0x7e,0xfe,0x7f,
-        0xf6,0x00,0x10,0xf7,0x11,0x8f,0xff,0x03,0xff,0x02,
-        0xfe,0x01,0xfa,0x00,0xfd,0x7f,0xff,0x7e,0x00,0x7c,
-        0x00,0x79,0x00,0x7b,0x01,0x7e,0x03,0x00,0x06,0x00,
-        0x02,0x00,0x01,0x03,0x01,0x02,0x03,0xfb,0x03,0x95,
-        0x0c,0x00,0xfa,0x80,0x00,0x6b,0x09,0x80,0x03,0x95,
-        0x00,0x77,0x06,0x7a,0x06,0x06,0x00,0x09,0xfa,0xf1,
-        0xfa,0x7a,0x0e,0x80,0x03,0x87,0x00,0x0b,0x02,0x02,
-        0x03,0x00,0x02,0x7e,0x01,0x02,0x04,0x00,0x02,0x7e,
-        0x00,0x75,0xfe,0x7e,0xfc,0x00,0xff,0x01,0xfe,0x7f,
-        0xfd,0x00,0xfe,0x02,0x07,0x8e,0x00,0x6b,0x09,0x80,
-        0x03,0x80,0x0e,0x15,0xf2,0x80,0x0e,0x6b,0x03,0x80,
-        0x03,0x95,0x00,0x6b,0x0e,0x00,0x00,0x7d,0xfe,0x98,
-        0x00,0x6b,0x05,0x80,0x03,0x95,0x00,0x75,0x02,0x7d,
-        0x0a,0x00,0x00,0x8e,0x00,0x6b,0x02,0x80,0x03,0x95,
-        0x00,0x6b,0x10,0x00,0x00,0x15,0xf8,0x80,0x00,0x6b,
-        0x0a,0x80,0x03,0x95,0x00,0x6b,0x10,0x00,0x00,0x15,
-        0xf8,0x80,0x00,0x6b,0x0a,0x00,0x00,0x7d,0x02,0x83,
-        0x10,0x80,0x03,0x95,0x00,0x6b,0x09,0x00,0x03,0x02,
-        0x00,0x08,0xfd,0x02,0xf7,0x00,0x0e,0x89,0x00,0x6b,
-        0x03,0x80,0x03,0x95,0x00,0x6b,0x09,0x00,0x03,0x02,
-        0x00,0x08,0xfd,0x02,0xf7,0x00,0x0e,0xf4,0x03,0x92,
-        0x02,0x03,0x07,0x00,0x03,0x7d,0x00,0x70,0xfd,0x7e,
-        0xf9,0x00,0xfe,0x02,0x03,0x89,0x09,0x00,0x02,0xf5,
-        0x03,0x80,0x00,0x15,0x00,0xf5,0x07,0x00,0x00,0x08,
-        0x02,0x03,0x06,0x00,0x02,0x7d,0x00,0x70,0xfe,0x7e,
-        0xfa,0x00,0xfe,0x02,0x00,0x08,0x0c,0xf6,0x0f,0x80,
-        0x00,0x15,0xf6,0x00,0xfe,0x7d,0x00,0x79,0x02,0x7e,
-        0x0a,0x00,0xf4,0xf7,0x07,0x09,0x07,0xf7,0x03,0x8c,
-        0x01,0x02,0x01,0x01,0x05,0x00,0x02,0x7f,0x01,0x7e,
-        0x00,0x74,0x00,0x86,0xff,0x01,0xfe,0x01,0xfb,0x00,
-        0xff,0x7f,0xff,0x7f,0x00,0x7c,0x01,0x7e,0x01,0x00,
-        0x05,0x00,0x02,0x00,0x01,0x02,0x03,0xfe,0x04,0x8e,
-        0x02,0x01,0x04,0x00,0x02,0x7f,0x01,0x7e,0x00,0x77,
-        0xff,0x7e,0xfe,0x7f,0xfc,0x00,0xfe,0x01,0xff,0x02,
-        0x00,0x09,0x01,0x02,0x02,0x02,0x03,0x01,0x02,0x01,
-        0x01,0x01,0x01,0x02,0x02,0xeb,0x03,0x80,0x00,0x15,
-        0x03,0x00,0x02,0x7e,0x00,0x7b,0xfe,0x7e,0xfd,0x00,
-        0x03,0x80,0x04,0x00,0x03,0x7e,0x00,0x78,0xfd,0x7e,
-        0xf9,0x00,0x0c,0x80,0x03,0x8c,0x02,0x02,0x02,0x01,
-        0x03,0x00,0x02,0x7f,0x01,0x7d,0xfe,0x7e,0xf9,0x7d,
-        0xff,0x7e,0x00,0x7d,0x03,0x7f,0x02,0x00,0x03,0x01,
-        0x02,0x01,0x02,0xfe,0x0d,0x8c,0xff,0x02,0xfe,0x01,
-        0xfc,0x00,0xfe,0x7f,0xff,0x7e,0x00,0x77,0x01,0x7e,
-        0x02,0x7f,0x04,0x00,0x02,0x01,0x01,0x02,0x00,0x0f,
-        0xff,0x02,0xfe,0x01,0xf9,0x00,0x0c,0xeb,0x03,0x88,
-        0x0a,0x00,0x00,0x02,0x00,0x03,0xfe,0x02,0xfa,0x00,
-        0xff,0x7e,0xff,0x7d,0x00,0x7b,0x01,0x7c,0x01,0x7f,
-        0x06,0x00,0x02,0x02,0x03,0xfe,0x03,0x8f,0x06,0x77,
-        0x06,0x09,0xfa,0x80,0x00,0x71,0xff,0x87,0xfb,0x79,
-        0x07,0x87,0x05,0x79,0x02,0x80,0x03,0x8d,0x02,0x02,
-        0x06,0x00,0x02,0x7e,0x00,0x7d,0xfc,0x7d,0x04,0x7e,
-        0x00,0x7d,0xfe,0x7e,0xfa,0x00,0xfe,0x02,0x04,0x85,
-        0x02,0x00,0x06,0xf9,0x03,0x8f,0x00,0x73,0x01,0x7e,
-        0x07,0x00,0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,
-        0x03,0x80,0x03,0x8f,0x00,0x73,0x01,0x7e,0x07,0x00,
-        0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,0xf8,0x90,
-        0x03,0x00,0x08,0xf0,0x03,0x80,0x00,0x15,0x00,0xf3,
-        0x02,0x00,0x06,0x07,0xfa,0xf9,0x07,0x78,0x03,0x80,
-        0x03,0x80,0x04,0x0c,0x02,0x03,0x04,0x00,0x00,0x71,
-        0x02,0x80,0x03,0x80,0x00,0x0f,0x06,0x77,0x06,0x09,
-        0x00,0x71,0x02,0x80,0x03,0x80,0x00,0x0f,0x0a,0xf1,
-        0x00,0x0f,0xf6,0xf8,0x0a,0x00,0x02,0xf9,0x05,0x80,
-        0xff,0x01,0xff,0x04,0x00,0x05,0x01,0x03,0x01,0x02,
-        0x06,0x00,0x02,0x7e,0x00,0x7d,0x00,0x7b,0x00,0x7c,
-        0xfe,0x7f,0xfa,0x00,0x0b,0x80,0x03,0x80,0x00,0x0f,
-        0x00,0xfb,0x01,0x03,0x01,0x02,0x05,0x00,0x02,0x7e,
-        0x01,0x7d,0x00,0x76,0x03,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
-        0x10,0x80,0x0a,0x8f,0x02,0x7f,0x01,0x7e,0x00,0x76,
-        0xff,0x7f,0xfe,0x7f,0xfb,0x00,0xff,0x01,0xff,0x01,
-        0x00,0x0a,0x01,0x02,0x01,0x01,0x05,0x00,0xf9,0x80,
-        0x00,0x6b,0x0c,0x86,0x0d,0x8a,0xff,0x03,0xfe,0x02,
-        0xfb,0x00,0xff,0x7e,0xff,0x7d,0x00,0x7b,0x01,0x7c,
-        0x01,0x7f,0x05,0x00,0x02,0x01,0x01,0x03,0x03,0xfc,
-        0x03,0x80,0x00,0x0f,0x00,0xfb,0x01,0x03,0x01,0x02,
-        0x04,0x00,0x01,0x7e,0x01,0x7d,0x00,0x76,0x00,0x8a,
-        0x01,0x03,0x02,0x02,0x03,0x00,0x02,0x7e,0x01,0x7d,
-        0x00,0x76,0x03,0x80,0x03,0x8f,0x00,0x74,0x01,0x7e,
-        0x02,0x7f,0x04,0x00,0x02,0x01,0x01,0x01,0x00,0x8d,
-        0x00,0x6e,0xff,0x7e,0xfe,0x7f,0xfb,0x00,0xfe,0x01,
-        0x0c,0x85,0x03,0x8d,0x01,0x02,0x03,0x00,0x02,0x7e,
-        0x01,0x02,0x03,0x00,0x02,0x7e,0x00,0x74,0xfe,0x7f,
-        0xfd,0x00,0xff,0x01,0xfe,0x7f,0xfd,0x00,0xff,0x01,
-        0x00,0x0c,0x06,0x82,0x00,0x6b,0x08,0x86,0x03,0x80,
-        0x0a,0x0f,0xf6,0x80,0x0a,0x71,0x03,0x80,0x03,0x8f,
-        0x00,0x73,0x01,0x7e,0x07,0x00,0x02,0x02,0x00,0x0d,
-        0x00,0xf3,0x01,0x7e,0x00,0x7e,0x03,0x82,0x03,0x8f,
-        0x00,0x79,0x02,0x7e,0x08,0x00,0x00,0x89,0x00,0x71,
-        0x02,0x80,0x03,0x8f,0x00,0x73,0x01,0x7e,0x03,0x00,
-        0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,0x03,0x00,
-        0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,0x03,0x80,
-        0x03,0x8f,0x00,0x73,0x01,0x7e,0x03,0x00,0x02,0x02,
-        0x00,0x0d,0x00,0xf3,0x01,0x7e,0x03,0x00,0x02,0x02,
-        0x00,0x0d,0x00,0xf3,0x01,0x7e,0x00,0x7e,0x03,0x82,
-        0x03,0x8d,0x00,0x02,0x02,0x00,0x00,0x71,0x08,0x00,
-        0x02,0x02,0x00,0x06,0xfe,0x02,0xf8,0x00,0x0c,0xf6,
-        0x03,0x8f,0x00,0x71,0x07,0x00,0x02,0x02,0x00,0x06,
-        0xfe,0x02,0xf9,0x00,0x0c,0x85,0x00,0x71,0x02,0x80,
-        0x03,0x8f,0x00,0x71,0x07,0x00,0x03,0x02,0x00,0x06,
-        0xfd,0x02,0xf9,0x00,0x0c,0xf6,0x03,0x8d,0x02,0x02,
-        0x06,0x00,0x02,0x7e,0x00,0x75,0xfe,0x7e,0xfa,0x00,
-        0xfe,0x02,0x04,0x85,0x06,0x00,0x02,0xf9,0x03,0x80,
-        0x00,0x0f,0x00,0xf8,0x04,0x00,0x00,0x06,0x02,0x02,
-        0x04,0x00,0x02,0x7e,0x00,0x75,0xfe,0x7e,0xfc,0x00,
-        0xfe,0x02,0x00,0x05,0x0a,0xf9,0x0d,0x80,0x00,0x0f,
-        0xf7,0x00,0xff,0x7e,0x00,0x7b,0x01,0x7e,0x09,0x00,
-        0xf6,0xfa,0x04,0x06,0x08,0xfa
-    };
-
-    //-------------------------------------------------------------------------
-    gsv_text::gsv_text() :
-      m_x(0.0),
-      m_y(0.0),
-      m_start_x(0.0),
-      m_width(10.0),
-      m_height(0.0),
-      m_space(0.0),
-      m_line_space(0.0),
-      m_text(m_chr),
-      m_text_buf(),
-      m_cur_chr(m_chr),
-      m_font(gsv_default_font),
-      m_loaded_font(),
-      m_status(initial),
-      m_big_endian(false),
-      m_flip(false)
-    {
-        m_chr[0] = m_chr[1] = 0;
-
-        int t = 1;
-        if(*(char*)&t == 0) m_big_endian = true;
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::font(const void* font)
-    {
-        m_font = font;
-        if(m_font == 0) m_font = &m_loaded_font[0];
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::size(double height, double width)
-    {
-        m_height = height;
-        m_width  = width;
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::space(double space)
-    {
-        m_space = space;
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::line_space(double line_space)
-    {
-        m_line_space = line_space;
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::start_point(double x, double y)
-    {
-        m_x = m_start_x = x;
-        m_y = y;
-        //if(m_flip) m_y += m_height;
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::load_font(const char* file)
-    {
-        m_loaded_font.resize(0);
-        FILE* fd = fopen(file, "rb");
-        if(fd)
-        {
-            unsigned len;
-
-            fseek(fd, 0l, SEEK_END);
-            len = ftell(fd);
-            fseek(fd, 0l, SEEK_SET);
-            if(len > 0)
-            {
-                m_loaded_font.resize(len);
-                fread(&m_loaded_font[0], 1, len, fd);
-                m_font = &m_loaded_font[0];
-            }
-            fclose(fd);
-        }
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::text(const char* text)
-    {
-        if(text == 0)
-        {
-            m_chr[0] = 0;
-            m_text = m_chr;
-            return;
-        }
-        unsigned new_size = strlen(text) + 1;
-        if(new_size > m_text_buf.size())
-        {
-            m_text_buf.resize(new_size);
-        }
-        memcpy(&m_text_buf[0], text, new_size);
-        m_text = &m_text_buf[0];
-    }
-
-    //-------------------------------------------------------------------------
-    void gsv_text::rewind(unsigned)
-    {
-        m_status = initial;
-        if(m_font == 0) return;
-        
-        m_indices = (int8u*)m_font;
-        double base_height = value(m_indices + 4);
-        m_indices += value(m_indices);
-        m_glyphs = (int8*)(m_indices + 257*2);
-        m_h = m_height / base_height;
-        m_w = (m_width == 0.0) ? m_h : m_width / base_height;
-        if(m_flip) m_h = -m_h;
-        m_cur_chr = m_text;
-    }
-
-    //-------------------------------------------------------------------------
-    unsigned gsv_text::vertex(double* x, double* y)
-    {
-        unsigned idx;
-        int8 yc, yf;
-        int dx, dy;
-        bool quit = false;
-        
-        while(!quit)
-        {
-            switch(m_status)
-            {
-            case initial:
-                if(m_font == 0) 
-                {
-                    quit = true;
-                    break;
-                }
-                m_status = next_char;
-
-            case next_char:
-                if(*m_cur_chr == 0) 
-                {
-                    quit = true;
-                    break;
-                }
-                idx = (*m_cur_chr++) & 0xFF;
-                if(idx == '\n')
-                {
-                    m_x = m_start_x;
-                    m_y -= m_flip ? -m_height - m_line_space : m_height + m_line_space;
-                    break;
-                }
-                idx <<= 1;
-                m_bglyph = m_glyphs + value(m_indices + idx);
-                m_eglyph = m_glyphs + value(m_indices + idx + 2);
-                m_status = start_glyph;
-
-            case start_glyph:
-                *x = m_x;
-                *y = m_y;
-                m_status = glyph;
-                return path_cmd_move_to;
-
-            case glyph:
-                if(m_bglyph >= m_eglyph)
-                {
-                    m_status = next_char;
-                    m_x += m_space;
-                    break;
-                }
-                dx = int(*m_bglyph++);
-                yf = (yc = *m_bglyph++) & 0x80;
-                yc <<= 1; 
-                yc >>= 1;
-                dy = int(yc);
-                m_x += double(dx) * m_w;
-                m_y += double(dy) * m_h;
-                *x = m_x;
-                *y = m_y;
-                return yf ? path_cmd_move_to : path_cmd_line_to;
-            }
-
-        }
-        return path_cmd_stop;
-    }
-
-    //-------------------------------------------------------------------------
-    double gsv_text::text_width()
-    {
-        double x1, y1, x2, y2;
-        bounding_rect_single(*this, 0, &x1, &y1, &x2, &y2);
-        return x2 - x1;
-    }
-
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_image_filters.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_image_filters.cpp
--- 8.0.1-5/renderers/agg/src/agg_image_filters.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_image_filters.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,103 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Filtering class image_filter_lut implemantation
-//
-//----------------------------------------------------------------------------
-
-
-#include "../include/agg_image_filters.h"
-
-
-namespace mapserver
-{
-    //--------------------------------------------------------------------
-    void image_filter_lut::realloc_lut(double radius)
-    {
-        m_radius = radius;
-        m_diameter = uceil(radius) * 2;
-        m_start = -int(m_diameter / 2 - 1);
-        unsigned size = m_diameter << image_subpixel_shift;
-        if(size > m_weight_array.size())
-        {
-            m_weight_array.resize(size);
-        }
-    }
-
-
-
-    //--------------------------------------------------------------------
-    // This function normalizes integer values and corrects the rounding 
-    // errors. It doesn't do anything with the source floating point values
-    // (m_weight_array_dbl), it corrects only integers according to the rule 
-    // of 1.0 which means that any sum of pixel weights must be equal to 1.0.
-    // So, the filter function must produce a graph of the proper shape.
-    //--------------------------------------------------------------------
-    void image_filter_lut::normalize()
-    {
-        unsigned i;
-        int flip = 1;
-
-        for(i = 0; i < image_subpixel_scale; i++)
-        {
-            for(;;)
-            {
-                int sum = 0;
-                unsigned j;
-                for(j = 0; j < m_diameter; j++)
-                {
-                    sum += m_weight_array[j * image_subpixel_scale + i];
-                }
-
-                if(sum == image_filter_scale) break;
-
-                double k = double(image_filter_scale) / double(sum);
-                sum = 0;
-                for(j = 0; j < m_diameter; j++)
-                {
-                    sum +=     m_weight_array[j * image_subpixel_scale + i] = 
-                        iround(m_weight_array[j * image_subpixel_scale + i] * k);
-                }
-
-                sum -= image_filter_scale;
-                int inc = (sum > 0) ? -1 : 1;
-
-                for(j = 0; j < m_diameter && sum; j++)
-                {
-                    flip ^= 1;
-                    unsigned idx = flip ? m_diameter/2 + j/2 : m_diameter/2 - j/2;
-                    int v = m_weight_array[idx * image_subpixel_scale + i];
-                    if(v < image_filter_scale)
-                    {
-                        m_weight_array[idx * image_subpixel_scale + i] += inc;
-                        sum += inc;
-                    }
-                }
-            }
-        }
-
-        unsigned pivot = m_diameter << (image_subpixel_shift - 1);
-
-        for(i = 0; i < pivot; i++)
-        {
-            m_weight_array[pivot + i] = m_weight_array[pivot - i];
-        }
-        unsigned end = (diameter() << image_subpixel_shift) - 1;
-        m_weight_array[0] = m_weight_array[end];
-    }
-
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_line_aa_basics.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_line_aa_basics.cpp
--- 8.0.1-5/renderers/agg/src/agg_line_aa_basics.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_line_aa_basics.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,82 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_line_aa_basics.h"
-
-namespace mapserver
-{
-    //-------------------------------------------------------------------------
-    // The number of the octant is determined as a 3-bit value as follows:
-    // bit 0 = vertical flag
-    // bit 1 = sx < 0
-    // bit 2 = sy < 0
-    //
-    // [N] shows the number of the orthogonal quadrant
-    // <M> shows the number of the diagonal quadrant
-    //               <1>
-    //   [1]          |          [0]
-    //       . (3)011 | 001(1) .
-    //         .      |      .
-    //           .    |    . 
-    //             .  |  . 
-    //    (2)010     .|.     000(0)
-    // <2> ----------.+.----------- <0>
-    //    (6)110   .  |  .   100(4)
-    //           .    |    .
-    //         .      |      .
-    //       .        |        .
-    //         (7)111 | 101(5) 
-    //   [2]          |          [3]
-    //               <3> 
-    //                                                        0,1,2,3,4,5,6,7 
-    const int8u line_parameters::s_orthogonal_quadrant[8] = { 0,0,1,1,3,3,2,2 };
-    const int8u line_parameters::s_diagonal_quadrant[8]   = { 0,1,2,1,0,3,2,3 };
-
-
-
-    //-------------------------------------------------------------------------
-    void bisectrix(const line_parameters& l1, 
-                   const line_parameters& l2, 
-                   int* x, int* y)
-    {
-        double k = double(l2.len) / double(l1.len);
-        double tx = l2.x2 - (l2.x1 - l1.x1) * k;
-        double ty = l2.y2 - (l2.y1 - l1.y1) * k;
-
-        //All bisectrices must be on the right of the line
-        //If the next point is on the left (l1 => l2.2)
-        //then the bisectix should be rotated by 180 degrees.
-        if(double(l2.x2 - l2.x1) * double(l2.y1 - l1.y1) <
-           double(l2.y2 - l2.y1) * double(l2.x1 - l1.x1) + 100.0)
-        {
-            tx -= (tx - l2.x1) * 2.0;
-            ty -= (ty - l2.y1) * 2.0;
-        }
-
-        // Check if the bisectrix is too short
-        double dx = tx - l2.x1;
-        double dy = ty - l2.y1;
-        if((int)sqrt(dx * dx + dy * dy) < line_subpixel_scale)
-        {
-            *x = (l2.x1 + l2.x1 + (l2.y1 - l1.y1) + (l2.y2 - l2.y1)) >> 1;
-            *y = (l2.y1 + l2.y1 - (l2.x1 - l1.x1) - (l2.x2 - l2.x1)) >> 1;
-            return;
-        }
-        *x = iround(tx);
-        *y = iround(ty);
-    }
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_line_profile_aa.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_line_profile_aa.cpp
--- 8.0.1-5/renderers/agg/src/agg_line_profile_aa.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_line_profile_aa.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,116 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include "../include/agg_renderer_outline_aa.h"
-
-namespace mapserver
-{
-
-    //---------------------------------------------------------------------
-    void line_profile_aa::width(double w)
-    {
-        if(w < 0.0) w = 0.0;
-
-        if(w < m_smoother_width) w += w;
-        else                     w += m_smoother_width;
-
-        w *= 0.5;
-
-        w -= m_smoother_width;
-        double s = m_smoother_width;
-        if(w < 0.0) 
-        {
-            s += w;
-            w = 0.0;
-        }
-        set(w, s);
-    }
-
-
-    //---------------------------------------------------------------------
-    line_profile_aa::value_type* line_profile_aa::profile(double w)
-    {
-        m_subpixel_width = uround(w * subpixel_scale);
-        unsigned size = m_subpixel_width + subpixel_scale * 6;
-        if(size > m_profile.size())
-        {
-            m_profile.resize(size);
-        }
-        return &m_profile[0];
-    }
-
-
-    //---------------------------------------------------------------------
-    void line_profile_aa::set(double center_width, double smoother_width)
-    {
-        double base_val = 1.0;
-        if(center_width == 0.0)   center_width = 1.0 / subpixel_scale;
-        if(smoother_width == 0.0) smoother_width = 1.0 / subpixel_scale;
-
-        double width = center_width + smoother_width;
-        if(width < m_min_width)
-        {
-            double k = width / m_min_width;
-            base_val *= k;
-            center_width /= k;
-            smoother_width /= k;
-        }
-
-        value_type* ch = profile(center_width + smoother_width);
-
-        unsigned subpixel_center_width = unsigned(center_width * subpixel_scale);
-        unsigned subpixel_smoother_width = unsigned(smoother_width * subpixel_scale);
-
-        value_type* ch_center   = ch + subpixel_scale*2;
-        value_type* ch_smoother = ch_center + subpixel_center_width;
-
-        unsigned i;
-
-        unsigned val = m_gamma[unsigned(base_val * aa_mask)];
-        ch = ch_center;
-        for(i = 0; i < subpixel_center_width; i++)
-        {
-            *ch++ = (value_type)val;
-        }
-
-        for(i = 0; i < subpixel_smoother_width; i++)
-        {
-            *ch_smoother++ = 
-                m_gamma[unsigned((base_val - 
-                                  base_val * 
-                                  (double(i) / subpixel_smoother_width)) * aa_mask)];
-        }
-
-        unsigned n_smoother = profile_size() - 
-                              subpixel_smoother_width - 
-                              subpixel_center_width - 
-                              subpixel_scale*2;
-
-        val = m_gamma[0];
-        for(i = 0; i < n_smoother; i++)
-        {
-            *ch_smoother++ = (value_type)val;
-        }
-
-        ch = ch_center;
-        for(i = 0; i < subpixel_scale*2; i++)
-        {
-            *--ch = *ch_center++;
-        }
-    }
-
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_rounded_rect.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_rounded_rect.cpp
--- 8.0.1-5/renderers/agg/src/agg_rounded_rect.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_rounded_rect.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,164 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Rounded rectangle vertex generator
-//
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_rounded_rect.h"
-
-
-namespace mapserver
-{
-    //------------------------------------------------------------------------
-    rounded_rect::rounded_rect(double x1, double y1, double x2, double y2, double r) :
-        m_x1(x1), m_y1(y1), m_x2(x2), m_y2(y2),
-        m_rx1(r), m_ry1(r), m_rx2(r), m_ry2(r), 
-        m_rx3(r), m_ry3(r), m_rx4(r), m_ry4(r)
-    {
-        if(x1 > x2) { m_x1 = x2; m_x2 = x1; }
-        if(y1 > y2) { m_y1 = y2; m_y2 = y1; }
-    }
-
-    //--------------------------------------------------------------------
-    void rounded_rect::rect(double x1, double y1, double x2, double y2)
-    {
-        m_x1 = x1;
-        m_y1 = y1;
-        m_x2 = x2;
-        m_y2 = y2;
-        if(x1 > x2) { m_x1 = x2; m_x2 = x1; }
-        if(y1 > y2) { m_y1 = y2; m_y2 = y1; }
-    }
-
-    //--------------------------------------------------------------------
-    void rounded_rect::radius(double r)
-    {
-        m_rx1 = m_ry1 = m_rx2 = m_ry2 = m_rx3 = m_ry3 = m_rx4 = m_ry4 = r; 
-    }
-
-    //--------------------------------------------------------------------
-    void rounded_rect::radius(double rx, double ry)
-    {
-        m_rx1 = m_rx2 = m_rx3 = m_rx4 = rx; 
-        m_ry1 = m_ry2 = m_ry3 = m_ry4 = ry; 
-    }
-
-    //--------------------------------------------------------------------
-    void rounded_rect::radius(double rx_bottom, double ry_bottom, 
-                              double rx_top,    double ry_top)
-    {
-        m_rx1 = m_rx2 = rx_bottom; 
-        m_rx3 = m_rx4 = rx_top; 
-        m_ry1 = m_ry2 = ry_bottom; 
-        m_ry3 = m_ry4 = ry_top; 
-    }
-
-    //--------------------------------------------------------------------
-    void rounded_rect::radius(double rx1, double ry1, double rx2, double ry2, 
-                              double rx3, double ry3, double rx4, double ry4)
-    {
-        m_rx1 = rx1; m_ry1 = ry1; m_rx2 = rx2; m_ry2 = ry2; 
-        m_rx3 = rx3; m_ry3 = ry3; m_rx4 = rx4; m_ry4 = ry4;
-    }
-
-    //--------------------------------------------------------------------
-    void rounded_rect::normalize_radius()
-    {
-        double dx = fabs(m_y2 - m_y1);
-        double dy = fabs(m_x2 - m_x1);
-
-        double k = 1.0;
-        double t;
-        t = dx / (m_rx1 + m_rx2); if(t < k) k = t; 
-        t = dx / (m_rx3 + m_rx4); if(t < k) k = t; 
-        t = dy / (m_ry1 + m_ry2); if(t < k) k = t; 
-        t = dy / (m_ry3 + m_ry4); if(t < k) k = t; 
-
-        if(k < 1.0)
-        {
-            m_rx1 *= k; m_ry1 *= k; m_rx2 *= k; m_ry2 *= k;
-            m_rx3 *= k; m_ry3 *= k; m_rx4 *= k; m_ry4 *= k;
-        }
-    }
-
-    //--------------------------------------------------------------------
-    void rounded_rect::rewind(unsigned)
-    {
-        m_status = 0;
-    }
-
-    //--------------------------------------------------------------------
-    unsigned rounded_rect::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_stop;
-        switch(m_status)
-        {
-        case 0:
-            m_arc.init(m_x1 + m_rx1, m_y1 + m_ry1, m_rx1, m_ry1,
-                       pi, pi+pi*0.5);
-            m_arc.rewind(0);
-            m_status++;
-
-        case 1:
-            cmd = m_arc.vertex(x, y);
-            if(is_stop(cmd)) m_status++;
-            else return cmd;
-
-        case 2:
-            m_arc.init(m_x2 - m_rx2, m_y1 + m_ry2, m_rx2, m_ry2,
-                       pi+pi*0.5, 0.0);
-            m_arc.rewind(0);
-            m_status++;
-
-        case 3:
-            cmd = m_arc.vertex(x, y);
-            if(is_stop(cmd)) m_status++;
-            else return path_cmd_line_to;
-
-        case 4:
-            m_arc.init(m_x2 - m_rx3, m_y2 - m_ry3, m_rx3, m_ry3,
-                       0.0, pi*0.5);
-            m_arc.rewind(0);
-            m_status++;
-
-        case 5:
-            cmd = m_arc.vertex(x, y);
-            if(is_stop(cmd)) m_status++;
-            else return path_cmd_line_to;
-
-        case 6:
-            m_arc.init(m_x1 + m_rx4, m_y2 - m_ry4, m_rx4, m_ry4,
-                       pi*0.5, pi);
-            m_arc.rewind(0);
-            m_status++;
-
-        case 7:
-            cmd = m_arc.vertex(x, y);
-            if(is_stop(cmd)) m_status++;
-            else return path_cmd_line_to;
-
-        case 8:
-            cmd = path_cmd_end_poly | path_flags_close | path_flags_ccw;
-            m_status++;
-            break;
-        }
-        return cmd;
-    }
-
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_sqrt_tables.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_sqrt_tables.cpp
--- 8.0.1-5/renderers/agg/src/agg_sqrt_tables.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_sqrt_tables.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,115 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// static tables for fast integer sqrt
-//
-//----------------------------------------------------------------------------
-
-#include "../include/agg_basics.h"
-
-namespace mapserver
-{
-    int16u g_sqrt_table[1024] =                       //----------g_sqrt_table
-    {
-        0,
-        2048,2896,3547,4096,4579,5017,5418,5793,6144,6476,6792,7094,7384,7663,7932,8192,8444,
-        8689,8927,9159,9385,9606,9822,10033,10240,10443,10642,10837,11029,11217,11403,11585,
-        11765,11942,12116,12288,12457,12625,12790,12953,13114,13273,13430,13585,13738,13890,
-        14040,14189,14336,14482,14626,14768,14910,15050,15188,15326,15462,15597,15731,15864,
-        15995,16126,16255,16384,16512,16638,16764,16888,17012,17135,17257,17378,17498,17618,
-        17736,17854,17971,18087,18203,18318,18432,18545,18658,18770,18882,18992,19102,19212,
-        19321,19429,19537,19644,19750,19856,19961,20066,20170,20274,20377,20480,20582,20684,
-        20785,20886,20986,21085,21185,21283,21382,21480,21577,21674,21771,21867,21962,22058,
-        22153,22247,22341,22435,22528,22621,22713,22806,22897,22989,23080,23170,23261,23351,
-        23440,23530,23619,23707,23796,23884,23971,24059,24146,24232,24319,24405,24491,24576,
-        24661,24746,24831,24915,24999,25083,25166,25249,25332,25415,25497,25580,25661,25743,
-        25824,25905,25986,26067,26147,26227,26307,26387,26466,26545,26624,26703,26781,26859,
-        26937,27015,27092,27170,27247,27324,27400,27477,27553,27629,27705,27780,27856,27931,
-        28006,28081,28155,28230,28304,28378,28452,28525,28599,28672,28745,28818,28891,28963,
-        29035,29108,29180,29251,29323,29394,29466,29537,29608,29678,29749,29819,29890,29960,
-        30030,30099,30169,30238,30308,30377,30446,30515,30583,30652,30720,30788,30856,30924,
-        30992,31059,31127,31194,31261,31328,31395,31462,31529,31595,31661,31727,31794,31859,
-        31925,31991,32056,32122,32187,32252,32317,32382,32446,32511,32575,32640,32704,32768,
-        32832,32896,32959,33023,33086,33150,33213,33276,33339,33402,33465,33527,33590,33652,
-        33714,33776,33839,33900,33962,34024,34086,34147,34208,34270,34331,34392,34453,34514,
-        34574,34635,34695,34756,34816,34876,34936,34996,35056,35116,35176,35235,35295,35354,
-        35413,35472,35531,35590,35649,35708,35767,35825,35884,35942,36001,36059,36117,36175,
-        36233,36291,36348,36406,36464,36521,36578,36636,36693,36750,36807,36864,36921,36978,
-        37034,37091,37147,37204,37260,37316,37372,37429,37485,37540,37596,37652,37708,37763,
-        37819,37874,37929,37985,38040,38095,38150,38205,38260,38315,38369,38424,38478,38533,
-        38587,38642,38696,38750,38804,38858,38912,38966,39020,39073,39127,39181,39234,39287,
-        39341,39394,39447,39500,39553,39606,39659,39712,39765,39818,39870,39923,39975,40028,
-        40080,40132,40185,40237,40289,40341,40393,40445,40497,40548,40600,40652,40703,40755,
-        40806,40857,40909,40960,41011,41062,41113,41164,41215,41266,41317,41368,41418,41469,
-        41519,41570,41620,41671,41721,41771,41821,41871,41922,41972,42021,42071,42121,42171,
-        42221,42270,42320,42369,42419,42468,42518,42567,42616,42665,42714,42763,42813,42861,
-        42910,42959,43008,43057,43105,43154,43203,43251,43300,43348,43396,43445,43493,43541,
-        43589,43637,43685,43733,43781,43829,43877,43925,43972,44020,44068,44115,44163,44210,
-        44258,44305,44352,44400,44447,44494,44541,44588,44635,44682,44729,44776,44823,44869,
-        44916,44963,45009,45056,45103,45149,45195,45242,45288,45334,45381,45427,45473,45519,
-        45565,45611,45657,45703,45749,45795,45840,45886,45932,45977,46023,46069,46114,46160,
-        46205,46250,46296,46341,46386,46431,46477,46522,46567,46612,46657,46702,46746,46791,
-        46836,46881,46926,46970,47015,47059,47104,47149,47193,47237,47282,47326,47370,47415,
-        47459,47503,47547,47591,47635,47679,47723,47767,47811,47855,47899,47942,47986,48030,
-        48074,48117,48161,48204,48248,48291,48335,48378,48421,48465,48508,48551,48594,48637,
-        48680,48723,48766,48809,48852,48895,48938,48981,49024,49067,49109,49152,49195,49237,
-        49280,49322,49365,49407,49450,49492,49535,49577,49619,49661,49704,49746,49788,49830,
-        49872,49914,49956,49998,50040,50082,50124,50166,50207,50249,50291,50332,50374,50416,
-        50457,50499,50540,50582,50623,50665,50706,50747,50789,50830,50871,50912,50954,50995,
-        51036,51077,51118,51159,51200,51241,51282,51323,51364,51404,51445,51486,51527,51567,
-        51608,51649,51689,51730,51770,51811,51851,51892,51932,51972,52013,52053,52093,52134,
-        52174,52214,52254,52294,52334,52374,52414,52454,52494,52534,52574,52614,52654,52694,
-        52734,52773,52813,52853,52892,52932,52972,53011,53051,53090,53130,53169,53209,53248,
-        53287,53327,53366,53405,53445,53484,53523,53562,53601,53640,53679,53719,53758,53797,
-        53836,53874,53913,53952,53991,54030,54069,54108,54146,54185,54224,54262,54301,54340,
-        54378,54417,54455,54494,54532,54571,54609,54647,54686,54724,54762,54801,54839,54877,
-        54915,54954,54992,55030,55068,55106,55144,55182,55220,55258,55296,55334,55372,55410,
-        55447,55485,55523,55561,55599,55636,55674,55712,55749,55787,55824,55862,55900,55937,
-        55975,56012,56049,56087,56124,56162,56199,56236,56273,56311,56348,56385,56422,56459,
-        56497,56534,56571,56608,56645,56682,56719,56756,56793,56830,56867,56903,56940,56977,
-        57014,57051,57087,57124,57161,57198,57234,57271,57307,57344,57381,57417,57454,57490,
-        57527,57563,57599,57636,57672,57709,57745,57781,57817,57854,57890,57926,57962,57999,
-        58035,58071,58107,58143,58179,58215,58251,58287,58323,58359,58395,58431,58467,58503,
-        58538,58574,58610,58646,58682,58717,58753,58789,58824,58860,58896,58931,58967,59002,
-        59038,59073,59109,59144,59180,59215,59251,59286,59321,59357,59392,59427,59463,59498,
-        59533,59568,59603,59639,59674,59709,59744,59779,59814,59849,59884,59919,59954,59989,
-        60024,60059,60094,60129,60164,60199,60233,60268,60303,60338,60373,60407,60442,60477,
-        60511,60546,60581,60615,60650,60684,60719,60753,60788,60822,60857,60891,60926,60960,
-        60995,61029,61063,61098,61132,61166,61201,61235,61269,61303,61338,61372,61406,61440,
-        61474,61508,61542,61576,61610,61644,61678,61712,61746,61780,61814,61848,61882,61916,
-        61950,61984,62018,62051,62085,62119,62153,62186,62220,62254,62287,62321,62355,62388,
-        62422,62456,62489,62523,62556,62590,62623,62657,62690,62724,62757,62790,62824,62857,
-        62891,62924,62957,62991,63024,63057,63090,63124,63157,63190,63223,63256,63289,63323,
-        63356,63389,63422,63455,63488,63521,63554,63587,63620,63653,63686,63719,63752,63785,
-        63817,63850,63883,63916,63949,63982,64014,64047,64080,64113,64145,64178,64211,64243,
-        64276,64309,64341,64374,64406,64439,64471,64504,64536,64569,64601,64634,64666,64699,
-        64731,64763,64796,64828,64861,64893,64925,64957,64990,65022,65054,65086,65119,65151,
-        65183,65215,65247,65279,65312,65344,65376,65408,65440,65472,65504
-    };
-
-
-    int8 g_elder_bit_table[256] =          //---------g_elder_bit_table
-    {
-        0,0,1,1,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
-        5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
-        6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
-        6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
-        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
-        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
-        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
-        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
-    };
- 
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_svg_parser.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_svg_parser.cpp
--- 8.0.1-5/renderers/agg/src/agg_svg_parser.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_svg_parser.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,886 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// SVG parser.
-//
-//----------------------------------------------------------------------------
-
-#include <stdio.h>
-#include <string.h>
-#include <ctype.h>
-#include "agg_svg_parser.h"
-#include "expat.h"
-
-namespace mapserver
-{
-namespace svg
-{
-    struct named_color
-    {
-        char  name[22];
-        int8u r, g, b, a;
-    };
-
-    named_color colors[] = 
-    {
-        { "aliceblue",240,248,255, 255 },
-        { "antiquewhite",250,235,215, 255 },
-        { "aqua",0,255,255, 255 },
-        { "aquamarine",127,255,212, 255 },
-        { "azure",240,255,255, 255 },
-        { "beige",245,245,220, 255 },
-        { "bisque",255,228,196, 255 },
-        { "black",0,0,0, 255 },
-        { "blanchedalmond",255,235,205, 255 },
-        { "blue",0,0,255, 255 },
-        { "blueviolet",138,43,226, 255 },
-        { "brown",165,42,42, 255 },
-        { "burlywood",222,184,135, 255 },
-        { "cadetblue",95,158,160, 255 },
-        { "chartreuse",127,255,0, 255 },
-        { "chocolate",210,105,30, 255 },
-        { "coral",255,127,80, 255 },
-        { "cornflowerblue",100,149,237, 255 },
-        { "cornsilk",255,248,220, 255 },
-        { "crimson",220,20,60, 255 },
-        { "cyan",0,255,255, 255 },
-        { "darkblue",0,0,139, 255 },
-        { "darkcyan",0,139,139, 255 },
-        { "darkgoldenrod",184,134,11, 255 },
-        { "darkgray",169,169,169, 255 },
-        { "darkgreen",0,100,0, 255 },
-        { "darkgrey",169,169,169, 255 },
-        { "darkkhaki",189,183,107, 255 },
-        { "darkmagenta",139,0,139, 255 },
-        { "darkolivegreen",85,107,47, 255 },
-        { "darkorange",255,140,0, 255 },
-        { "darkorchid",153,50,204, 255 },
-        { "darkred",139,0,0, 255 },
-        { "darksalmon",233,150,122, 255 },
-        { "darkseagreen",143,188,143, 255 },
-        { "darkslateblue",72,61,139, 255 },
-        { "darkslategray",47,79,79, 255 },
-        { "darkslategrey",47,79,79, 255 },
-        { "darkturquoise",0,206,209, 255 },
-        { "darkviolet",148,0,211, 255 },
-        { "deeppink",255,20,147, 255 },
-        { "deepskyblue",0,191,255, 255 },
-        { "dimgray",105,105,105, 255 },
-        { "dimgrey",105,105,105, 255 },
-        { "dodgerblue",30,144,255, 255 },
-        { "firebrick",178,34,34, 255 },
-        { "floralwhite",255,250,240, 255 },
-        { "forestgreen",34,139,34, 255 },
-        { "fuchsia",255,0,255, 255 },
-        { "gainsboro",220,220,220, 255 },
-        { "ghostwhite",248,248,255, 255 },
-        { "gold",255,215,0, 255 },
-        { "goldenrod",218,165,32, 255 },
-        { "gray",128,128,128, 255 },
-        { "green",0,128,0, 255 },
-        { "greenyellow",173,255,47, 255 },
-        { "grey",128,128,128, 255 },
-        { "honeydew",240,255,240, 255 },
-        { "hotpink",255,105,180, 255 },
-        { "indianred",205,92,92, 255 },
-        { "indigo",75,0,130, 255 },
-        { "ivory",255,255,240, 255 },
-        { "khaki",240,230,140, 255 },
-        { "lavender",230,230,250, 255 },
-        { "lavenderblush",255,240,245, 255 },
-        { "lawngreen",124,252,0, 255 },
-        { "lemonchiffon",255,250,205, 255 },
-        { "lightblue",173,216,230, 255 },
-        { "lightcoral",240,128,128, 255 },
-        { "lightcyan",224,255,255, 255 },
-        { "lightgoldenrodyellow",250,250,210, 255 },
-        { "lightgray",211,211,211, 255 },
-        { "lightgreen",144,238,144, 255 },
-        { "lightgrey",211,211,211, 255 },
-        { "lightpink",255,182,193, 255 },
-        { "lightsalmon",255,160,122, 255 },
-        { "lightseagreen",32,178,170, 255 },
-        { "lightskyblue",135,206,250, 255 },
-        { "lightslategray",119,136,153, 255 },
-        { "lightslategrey",119,136,153, 255 },
-        { "lightsteelblue",176,196,222, 255 },
-        { "lightyellow",255,255,224, 255 },
-        { "lime",0,255,0, 255 },
-        { "limegreen",50,205,50, 255 },
-        { "linen",250,240,230, 255 },
-        { "magenta",255,0,255, 255 },
-        { "maroon",128,0,0, 255 },
-        { "mediumaquamarine",102,205,170, 255 },
-        { "mediumblue",0,0,205, 255 },
-        { "mediumorchid",186,85,211, 255 },
-        { "mediumpurple",147,112,219, 255 },
-        { "mediumseagreen",60,179,113, 255 },
-        { "mediumslateblue",123,104,238, 255 },
-        { "mediumspringgreen",0,250,154, 255 },
-        { "mediumturquoise",72,209,204, 255 },
-        { "mediumvioletred",199,21,133, 255 },
-        { "midnightblue",25,25,112, 255 },
-        { "mintcream",245,255,250, 255 },
-        { "mistyrose",255,228,225, 255 },
-        { "moccasin",255,228,181, 255 },
-        { "navajowhite",255,222,173, 255 },
-        { "navy",0,0,128, 255 },
-        { "oldlace",253,245,230, 255 },
-        { "olive",128,128,0, 255 },
-        { "olivedrab",107,142,35, 255 },
-        { "orange",255,165,0, 255 },
-        { "orangered",255,69,0, 255 },
-        { "orchid",218,112,214, 255 },
-        { "palegoldenrod",238,232,170, 255 },
-        { "palegreen",152,251,152, 255 },
-        { "paleturquoise",175,238,238, 255 },
-        { "palevioletred",219,112,147, 255 },
-        { "papayawhip",255,239,213, 255 },
-        { "peachpuff",255,218,185, 255 },
-        { "peru",205,133,63, 255 },
-        { "pink",255,192,203, 255 },
-        { "plum",221,160,221, 255 },
-        { "powderblue",176,224,230, 255 },
-        { "purple",128,0,128, 255 },
-        { "red",255,0,0, 255 },
-        { "rosybrown",188,143,143, 255 },
-        { "royalblue",65,105,225, 255 },
-        { "saddlebrown",139,69,19, 255 },
-        { "salmon",250,128,114, 255 },
-        { "sandybrown",244,164,96, 255 },
-        { "seagreen",46,139,87, 255 },
-        { "seashell",255,245,238, 255 },
-        { "sienna",160,82,45, 255 },
-        { "silver",192,192,192, 255 },
-        { "skyblue",135,206,235, 255 },
-        { "slateblue",106,90,205, 255 },
-        { "slategray",112,128,144, 255 },
-        { "slategrey",112,128,144, 255 },
-        { "snow",255,250,250, 255 },
-        { "springgreen",0,255,127, 255 },
-        { "steelblue",70,130,180, 255 },
-        { "tan",210,180,140, 255 },
-        { "teal",0,128,128, 255 },
-        { "thistle",216,191,216, 255 },
-        { "tomato",255,99,71, 255 },
-        { "turquoise",64,224,208, 255 },
-        { "violet",238,130,238, 255 },
-        { "wheat",245,222,179, 255 },
-        { "white",255,255,255, 255 },
-        { "whitesmoke",245,245,245, 255 },
-        { "yellow",255,255,0, 255 },
-        { "yellowgreen",154,205,50, 255 },
-        { "zzzzzzzzzzz",0,0,0, 0 }
-    }; 
-
-
-    //------------------------------------------------------------------------
-    parser::~parser()
-    {
-        delete [] m_attr_value;
-        delete [] m_attr_name;
-        delete [] m_buf;
-        delete [] m_title;
-    }
-
-    //------------------------------------------------------------------------
-    parser::parser(path_renderer& path) :
-        m_path(path),
-        m_tokenizer(),
-        m_buf(new char[buf_size]),
-        m_title(new char[256]),
-        m_title_len(0),
-        m_title_flag(false),
-        m_path_flag(false),
-        m_attr_name(new char[128]),
-        m_attr_value(new char[1024]),
-        m_attr_name_len(127),
-        m_attr_value_len(1023)
-    {
-        m_title[0] = 0;
-    }
-
-    //------------------------------------------------------------------------
-    void parser::parse(const char* fname)
-    {
-        char msg[1024];
-	    XML_Parser p = XML_ParserCreate(NULL);
-	    if(p == 0) 
-	    {
-		    throw exception("Couldn't allocate memory for parser");
-	    }
-
-        XML_SetUserData(p, this);
-	    XML_SetElementHandler(p, start_element, end_element);
-	    XML_SetCharacterDataHandler(p, content);
-
-        FILE* fd = fopen(fname, "r");
-        if(fd == 0)
-        {
-            sprintf(msg, "Couldn't open file %s", fname);
-		    throw exception(msg);
-        }
-
-        bool done = false;
-        do
-        {
-            size_t len = fread(m_buf, 1, buf_size, fd);
-            done = len < buf_size;
-            if(!XML_Parse(p, m_buf, len, done))
-            {
-                sprintf(msg,
-                    "%s at line %d\n",
-                    XML_ErrorString(XML_GetErrorCode(p)),
-                    (int)XML_GetCurrentLineNumber(p));
-                throw exception(msg);
-            }
-        }
-        while(!done);
-        fclose(fd);
-        XML_ParserFree(p);
-
-        char* ts = m_title;
-        while(*ts)
-        {
-            if(*ts < ' ') *ts = ' ';
-            ++ts;
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void parser::start_element(void* data, const char* el, const char** attr)
-    {
-        parser& self = *(parser*)data;
-
-        if(strcmp(el, "title") == 0)
-        {
-            self.m_title_flag = true;
-        }
-        else
-        if(strcmp(el, "g") == 0)
-        {
-            self.m_path.push_attr();
-            self.parse_attr(attr);
-        }
-        else
-        if(strcmp(el, "path") == 0)
-        {
-            if(self.m_path_flag)
-            {
-                throw exception("start_element: Nested path");
-            }
-            self.m_path.begin_path();
-            self.parse_path(attr);
-            self.m_path.end_path();
-            self.m_path_flag = true;
-        }
-        else
-        if(strcmp(el, "rect") == 0) 
-        {
-            self.parse_rect(attr);
-        }
-        else
-        if(strcmp(el, "line") == 0) 
-        {
-            self.parse_line(attr);
-        }
-        else
-        if(strcmp(el, "polyline") == 0) 
-        {
-            self.parse_poly(attr, false);
-        }
-        else
-        if(strcmp(el, "polygon") == 0) 
-        {
-            self.parse_poly(attr, true);
-        }
-        //else
-        //if(strcmp(el, "<OTHER_ELEMENTS>") == 0) 
-        //{
-        //}
-        // . . .
-    } 
-
-
-    //------------------------------------------------------------------------
-    void parser::end_element(void* data, const char* el)
-    {
-        parser& self = *(parser*)data;
-
-        if(strcmp(el, "title") == 0)
-        {
-            self.m_title_flag = false;
-        }
-        else
-        if(strcmp(el, "g") == 0)
-        {
-            self.m_path.pop_attr();
-        }
-        else
-        if(strcmp(el, "path") == 0)
-        {
-            self.m_path_flag = false;
-        }
-        //else
-        //if(strcmp(el, "<OTHER_ELEMENTS>") == 0) 
-        //{
-        //}
-        // . . .
-    }
-
-
-    //------------------------------------------------------------------------
-    void parser::content(void* data, const char* s, int len)
-    {
-        parser& self = *(parser*)data;
-
-        // m_title_flag signals that the <title> tag is being parsed now.
-        // The following code concatenates the pieces of content of the <title> tag.
-        if(self.m_title_flag)
-        {
-            if(len + self.m_title_len > 255) len = 255 - self.m_title_len;
-            if(len > 0) 
-            {
-                memcpy(self.m_title + self.m_title_len, s, len);
-                self.m_title_len += len;
-                self.m_title[self.m_title_len] = 0;
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void parser::parse_attr(const char** attr)
-    {
-        int i;
-        for(i = 0; attr[i]; i += 2)
-        {
-            if(strcmp(attr[i], "style") == 0)
-            {
-                parse_style(attr[i + 1]);
-            }
-            else
-            {
-                parse_attr(attr[i], attr[i + 1]);
-            }
-        }
-    }
-
-    //-------------------------------------------------------------
-    void parser::parse_path(const char** attr)
-    {
-        int i;
-
-        for(i = 0; attr[i]; i += 2)
-        {
-            // The <path> tag can consist of the path itself ("d=") 
-            // as well as of other parameters like "style=", "transform=", etc.
-            // In the last case we simply rely on the function of parsing 
-            // attributes (see 'else' branch).
-            if(strcmp(attr[i], "d") == 0)
-            {
-                m_tokenizer.set_path_str(attr[i + 1]);
-                m_path.parse_path(m_tokenizer);
-            }
-            else
-            {
-                // Create a temporary single pair "name-value" in order
-                // to avoid multiple calls for the same attribute.
-                const char* tmp[4];
-                tmp[0] = attr[i];
-                tmp[1] = attr[i + 1];
-                tmp[2] = 0;
-                tmp[3] = 0;
-                parse_attr(tmp);
-            }
-        }
-    }
-
-
-    //-------------------------------------------------------------
-    int cmp_color(const void* p1, const void* p2)
-    {
-        return strcmp(((named_color*)p1)->name, ((named_color*)p2)->name);
-    }
-
-    //-------------------------------------------------------------
-    rgba8 parse_color(const char* str)
-    {
-        while(*str == ' ') ++str;
-        unsigned c = 0;
-        if(*str == '#')
-        {
-            sscanf(str + 1, "%x", &c);
-            return rgb8_packed(c);
-        }
-        else
-        {
-            named_color c;
-            unsigned len = strlen(str);
-            if(len > sizeof(c.name) - 1)
-            {
-                throw exception("parse_color: Invalid color name '%s'", str);
-            }
-            strcpy(c.name, str);
-            const void* p = bsearch(&c, 
-                                    colors, 
-                                    sizeof(colors) / sizeof(colors[0]), 
-                                    sizeof(colors[0]), 
-                                    cmp_color);
-            if(p == 0)
-            {
-                throw exception("parse_color: Invalid color name '%s'", str);
-            }
-            const named_color* pc = (const named_color*)p;
-            return rgba8(pc->r, pc->g, pc->b, pc->a);
-        }
-    }
-
-    double parse_double(const char* str)
-    {
-        while(*str == ' ') ++str;
-        return atof(str);
-    }
-
-
-
-    //-------------------------------------------------------------
-    bool parser::parse_attr(const char* name, const char* value)
-    {
-        if(strcmp(name, "style") == 0)
-        {
-            parse_style(value);
-        }
-        else
-        if(strcmp(name, "fill") == 0)
-        {
-            if(strcmp(value, "none") == 0)
-            {
-                m_path.fill_none();
-            }
-            else
-            {
-                m_path.fill(parse_color(value));
-            }
-        }
-        else
-        if(strcmp(name, "fill-opacity") == 0)
-        {
-            m_path.fill_opacity(parse_double(value));
-        }
-        else
-        if(strcmp(name, "stroke") == 0)
-        {
-            if(strcmp(value, "none") == 0)
-            {
-                m_path.stroke_none();
-            }
-            else
-            {
-                m_path.stroke(parse_color(value));
-            }
-        }
-        else
-        if(strcmp(name, "stroke-width") == 0)
-        {
-            m_path.stroke_width(parse_double(value));
-        }
-        else
-        if(strcmp(name, "stroke-linecap") == 0)
-        {
-            if(strcmp(value, "butt") == 0)        m_path.line_cap(butt_cap);
-            else if(strcmp(value, "round") == 0)  m_path.line_cap(round_cap);
-            else if(strcmp(value, "square") == 0) m_path.line_cap(square_cap);
-        }
-        else
-        if(strcmp(name, "stroke-linejoin") == 0)
-        {
-            if(strcmp(value, "miter") == 0)      m_path.line_join(miter_join);
-            else if(strcmp(value, "round") == 0) m_path.line_join(round_join);
-            else if(strcmp(value, "bevel") == 0) m_path.line_join(bevel_join);
-        }
-        else
-        if(strcmp(name, "stroke-miterlimit") == 0)
-        {
-            m_path.miter_limit(parse_double(value));
-        }
-        else
-        if(strcmp(name, "stroke-opacity") == 0)
-        {
-            m_path.stroke_opacity(parse_double(value));
-        }
-        else
-        if(strcmp(name, "transform") == 0)
-        {
-            parse_transform(value);
-        }
-        //else
-        //if(strcmp(el, "<OTHER_ATTRIBUTES>") == 0) 
-        //{
-        //}
-        // . . .
-        else
-        {
-            return false;
-        }
-        return true;
-    }
-
-
-
-    //-------------------------------------------------------------
-    void parser::copy_name(const char* start, const char* end)
-    {
-        unsigned len = unsigned(end - start);
-        if(m_attr_name_len == 0 || len > m_attr_name_len)
-        {
-            delete [] m_attr_name;
-            m_attr_name = new char[len + 1];
-            m_attr_name_len = len;
-        }
-        if(len) memcpy(m_attr_name, start, len);
-        m_attr_name[len] = 0;
-    }
-
-
-
-    //-------------------------------------------------------------
-    void parser::copy_value(const char* start, const char* end)
-    {
-        unsigned len = unsigned(end - start);
-        if(m_attr_value_len == 0 || len > m_attr_value_len)
-        {
-            delete [] m_attr_value;
-            m_attr_value = new char[len + 1];
-            m_attr_value_len = len;
-        }
-        if(len) memcpy(m_attr_value, start, len);
-        m_attr_value[len] = 0;
-    }
-
-
-    //-------------------------------------------------------------
-    bool parser::parse_name_value(const char* nv_start, const char* nv_end)
-    {
-        const char* str = nv_start;
-        while(str < nv_end && *str != ':') ++str;
-
-        const char* val = str;
-
-        // Right Trim
-        while(str > nv_start && 
-            (*str == ':' || isspace(*str))) --str;
-        ++str;
-
-        copy_name(nv_start, str);
-
-        while(val < nv_end && (*val == ':' || isspace(*val))) ++val;
-        
-        copy_value(val, nv_end);
-        return parse_attr(m_attr_name, m_attr_value);
-    }
-
-
-
-    //-------------------------------------------------------------
-    void parser::parse_style(const char* str)
-    {
-        while(*str)
-        {
-            // Left Trim
-            while(*str && isspace(*str)) ++str;
-            const char* nv_start = str;
-            while(*str && *str != ';') ++str;
-            const char* nv_end = str;
-
-            // Right Trim
-            while(nv_end > nv_start && 
-                (*nv_end == ';' || isspace(*nv_end))) --nv_end;
-            ++nv_end;
-
-            parse_name_value(nv_start, nv_end);
-            if(*str) ++str;
-        }
-
-    }
-
-
-    //-------------------------------------------------------------
-    void parser::parse_rect(const char** attr)
-    {
-        int i;
-        double x = 0.0;
-        double y = 0.0;
-        double w = 0.0;
-        double h = 0.0;
-
-        m_path.begin_path();
-        for(i = 0; attr[i]; i += 2)
-        {
-            if(!parse_attr(attr[i], attr[i + 1]))
-            {
-                if(strcmp(attr[i], "x") == 0)      x = parse_double(attr[i + 1]);
-                if(strcmp(attr[i], "y") == 0)      y = parse_double(attr[i + 1]);
-                if(strcmp(attr[i], "width") == 0)  w = parse_double(attr[i + 1]);
-                if(strcmp(attr[i], "height") == 0) h = parse_double(attr[i + 1]);
-                // rx - to be implemented 
-                // ry - to be implemented
-            }
-        }
-
-
-        if(w != 0.0 && h != 0.0)
-        {
-            if(w < 0.0) throw exception("parse_rect: Invalid width: %f", w);
-            if(h < 0.0) throw exception("parse_rect: Invalid height: %f", h);
-
-            m_path.move_to(x,     y);
-            m_path.line_to(x + w, y);
-            m_path.line_to(x + w, y + h);
-            m_path.line_to(x,     y + h);
-            m_path.close_subpath();
-        }
-        m_path.end_path();
-    }
-
-
-    //-------------------------------------------------------------
-    void parser::parse_line(const char** attr)
-    {
-        int i;
-        double x1 = 0.0;
-        double y1 = 0.0;
-        double x2 = 0.0;
-        double y2 = 0.0;
-
-        m_path.begin_path();
-        for(i = 0; attr[i]; i += 2)
-        {
-            if(!parse_attr(attr[i], attr[i + 1]))
-            {
-                if(strcmp(attr[i], "x1") == 0) x1 = parse_double(attr[i + 1]);
-                if(strcmp(attr[i], "y1") == 0) y1 = parse_double(attr[i + 1]);
-                if(strcmp(attr[i], "x2") == 0) x2 = parse_double(attr[i + 1]);
-                if(strcmp(attr[i], "y2") == 0) y2 = parse_double(attr[i + 1]);
-            }
-        }
-
-        m_path.move_to(x1, y1);
-        m_path.line_to(x2, y2);
-        m_path.end_path();
-    }
-
-
-    //-------------------------------------------------------------
-    void parser::parse_poly(const char** attr, bool close_flag)
-    {
-        int i;
-        double x = 0.0;
-        double y = 0.0;
-
-        m_path.begin_path();
-        for(i = 0; attr[i]; i += 2)
-        {
-            if(!parse_attr(attr[i], attr[i + 1]))
-            {
-                if(strcmp(attr[i], "points") == 0) 
-                {
-                    m_tokenizer.set_path_str(attr[i + 1]);
-                    if(!m_tokenizer.next())
-                    {
-                        throw exception("parse_poly: Too few coordinates");
-                    }
-                    x = m_tokenizer.last_number();
-                    if(!m_tokenizer.next())
-                    {
-                        throw exception("parse_poly: Too few coordinates");
-                    }
-                    y = m_tokenizer.last_number();
-                    m_path.move_to(x, y);
-                    while(m_tokenizer.next())
-                    {
-                        x = m_tokenizer.last_number();
-                        if(!m_tokenizer.next())
-                        {
-                            throw exception("parse_poly: Odd number of coordinates");
-                        }
-                        y = m_tokenizer.last_number();
-                        m_path.line_to(x, y);
-                    }
-                }
-            }
-        }
-        if(close_flag) 
-        {
-            m_path.close_subpath();
-        }
-        m_path.end_path();
-    }
-
-    //-------------------------------------------------------------
-    void parser::parse_transform(const char* str)
-    {
-        while(*str)
-        {
-            if(islower(*str))
-            {
-                if(strncmp(str, "matrix", 6) == 0)    str += parse_matrix(str);    else 
-                if(strncmp(str, "translate", 9) == 0) str += parse_translate(str); else 
-                if(strncmp(str, "rotate", 6) == 0)    str += parse_rotate(str);    else 
-                if(strncmp(str, "scale", 5) == 0)     str += parse_scale(str);     else 
-                if(strncmp(str, "skewX", 5) == 0)     str += parse_skew_x(str);    else 
-                if(strncmp(str, "skewY", 5) == 0)     str += parse_skew_y(str);    else
-                {
-                    ++str;
-                }
-            }
-            else
-            {
-                ++str;
-            }
-        }
-    }
-
-
-    //-------------------------------------------------------------
-    static bool is_numeric(char c)
-    {
-        return strchr("0123456789+-.eE", c) != 0;
-    }
-
-    //-------------------------------------------------------------
-    static unsigned parse_transform_args(const char* str, 
-                                         double* args, 
-                                         unsigned max_na, 
-                                         unsigned* na)
-    {
-        *na = 0;
-        const char* ptr = str;
-        while(*ptr && *ptr != '(') ++ptr;
-        if(*ptr == 0)
-        {
-            throw exception("parse_transform_args: Invalid syntax");
-        }
-        const char* end = ptr;
-        while(*end && *end != ')') ++end;
-        if(*end == 0)
-        {
-            throw exception("parse_transform_args: Invalid syntax");
-        }
-
-        while(ptr < end)
-        {
-            if(is_numeric(*ptr))
-            {
-                if(*na >= max_na)
-                {
-                    throw exception("parse_transform_args: Too many arguments");
-                }
-                args[(*na)++] = atof(ptr);
-                while(ptr < end && is_numeric(*ptr)) ++ptr;
-            }
-            else
-            {
-                ++ptr;
-            }
-        }
-        return unsigned(end - str);
-    }
-
-    //-------------------------------------------------------------
-    unsigned parser::parse_matrix(const char* str)
-    {
-        double args[6];
-        unsigned na = 0;
-        unsigned len = parse_transform_args(str, args, 6, &na);
-        if(na != 6)
-        {
-            throw exception("parse_matrix: Invalid number of arguments");
-        }
-        m_path.transform().premultiply(trans_affine(args[0], args[1], args[2], args[3], args[4], args[5]));
-        return len;
-    }
-
-    //-------------------------------------------------------------
-    unsigned parser::parse_translate(const char* str)
-    {
-        double args[2];
-        unsigned na = 0;
-        unsigned len = parse_transform_args(str, args, 2, &na);
-        if(na == 1) args[1] = 0.0;
-        m_path.transform().premultiply(trans_affine_translation(args[0], args[1]));
-        return len;
-    }
-
-    //-------------------------------------------------------------
-    unsigned parser::parse_rotate(const char* str)
-    {
-        double args[3];
-        unsigned na = 0;
-        unsigned len = parse_transform_args(str, args, 3, &na);
-        if(na == 1) 
-        {
-            m_path.transform().premultiply(trans_affine_rotation(deg2rad(args[0])));
-        }
-        else if(na == 3)
-        {
-            trans_affine t = trans_affine_translation(-args[1], -args[2]);
-            t *= trans_affine_rotation(deg2rad(args[0]));
-            t *= trans_affine_translation(args[1], args[2]);
-            m_path.transform().premultiply(t);
-        }
-        else
-        {
-            throw exception("parse_rotate: Invalid number of arguments");
-        }
-        return len;
-    }
-
-    //-------------------------------------------------------------
-    unsigned parser::parse_scale(const char* str)
-    {
-        double args[2];
-        unsigned na = 0;
-        unsigned len = parse_transform_args(str, args, 2, &na);
-        if(na == 1) args[1] = args[0];
-        m_path.transform().premultiply(trans_affine_scaling(args[0], args[1]));
-        return len;
-    }
-
-    //-------------------------------------------------------------
-    unsigned parser::parse_skew_x(const char* str)
-    {
-        double arg;
-        unsigned na = 0;
-        unsigned len = parse_transform_args(str, &arg, 1, &na);
-        m_path.transform().premultiply(trans_affine_skewing(deg2rad(arg), 0.0));
-        return len;
-    }
-
-    //-------------------------------------------------------------
-    unsigned parser::parse_skew_y(const char* str)
-    {
-        double arg;
-        unsigned na = 0;
-        unsigned len = parse_transform_args(str, &arg, 1, &na);
-        m_path.transform().premultiply(trans_affine_skewing(0.0, deg2rad(arg)));
-        return len;
-    }
-
-}
-}
-
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_svg_path_renderer.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_svg_path_renderer.cpp
--- 8.0.1-5/renderers/agg/src/agg_svg_path_renderer.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_svg_path_renderer.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,358 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// SVG path renderer.
-//
-//----------------------------------------------------------------------------
-
-#include <stdio.h>
-#include "agg_svg_path_renderer.h"
-
-namespace mapserver
-{
-namespace svg
-{
-
-    //------------------------------------------------------------------------
-    path_renderer::path_renderer() :
-        m_curved(m_storage),
-        m_curved_count(m_curved),
-
-        m_curved_stroked(m_curved_count),
-        m_curved_stroked_trans(m_curved_stroked, m_transform),
-
-        m_curved_trans(m_curved_count, m_transform),
-        m_curved_trans_contour(m_curved_trans)
-    {
-        m_curved_trans_contour.auto_detect_orientation(false);
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::remove_all()
-    {
-        m_storage.remove_all();
-        m_attr_storage.remove_all();
-        m_attr_stack.remove_all();
-        m_transform.reset();
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::begin_path()
-    {
-        push_attr();
-        unsigned idx = m_storage.start_new_path();
-        m_attr_storage.add(path_attributes(cur_attr(), idx));
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::end_path()
-    {
-        if(m_attr_storage.size() == 0) 
-        {
-            throw exception("end_path : The path was not begun");
-        }
-        path_attributes attr = cur_attr();
-        unsigned idx = m_attr_storage[m_attr_storage.size() - 1].index;
-        attr.index = idx;
-        m_attr_storage[m_attr_storage.size() - 1] = attr;
-        pop_attr();
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::move_to(double x, double y, bool rel)          // M, m
-    {
-        if(rel) m_storage.rel_to_abs(&x, &y);
-        m_storage.move_to(x, y);
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::line_to(double x,  double y, bool rel)         // L, l
-    {
-        if(rel) m_storage.rel_to_abs(&x, &y);
-        m_storage.line_to(x, y);
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::hline_to(double x, bool rel)                   // H, h
-    {
-        double x2 = 0.0;
-        double y2 = 0.0;
-        if(m_storage.total_vertices())
-        {
-            m_storage.vertex(m_storage.total_vertices() - 1, &x2, &y2);
-            if(rel) x += x2;
-            m_storage.line_to(x, y2);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::vline_to(double y, bool rel)                   // V, v
-    {
-        double x2 = 0.0;
-        double y2 = 0.0;
-        if(m_storage.total_vertices())
-        {
-            m_storage.vertex(m_storage.total_vertices() - 1, &x2, &y2);
-            if(rel) y += y2;
-            m_storage.line_to(x2, y);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::curve3(double x1, double y1,                   // Q, q
-                               double x,  double y, bool rel)
-    {
-        if(rel) 
-        {
-            m_storage.rel_to_abs(&x1, &y1);
-            m_storage.rel_to_abs(&x,  &y);
-        }
-        m_storage.curve3(x1, y1, x, y);
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::curve3(double x, double y, bool rel)           // T, t
-    {
-//        throw exception("curve3(x, y) : NOT IMPLEMENTED YET");
-        if(rel) 
-        {
-            m_storage.curve3_rel(x, y);
-        } else 
-        {
-            m_storage.curve3(x, y);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::curve4(double x1, double y1,                   // C, c
-                               double x2, double y2, 
-                               double x,  double y, bool rel)
-    {
-        if(rel) 
-        {
-            m_storage.rel_to_abs(&x1, &y1);
-            m_storage.rel_to_abs(&x2, &y2);
-            m_storage.rel_to_abs(&x,  &y);
-        }
-        m_storage.curve4(x1, y1, x2, y2, x, y);
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::curve4(double x2, double y2,                   // S, s
-                               double x,  double y, bool rel)
-    {
-        //throw exception("curve4(x2, y2, x, y) : NOT IMPLEMENTED YET");
-        if(rel) 
-        {
-            m_storage.curve4_rel(x2, y2, x, y);
-        } else 
-        {
-            m_storage.curve4(x2, y2, x, y);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::close_subpath()
-    {
-        m_storage.end_poly(path_flags_close);
-    }
-
-    //------------------------------------------------------------------------
-    path_attributes& path_renderer::cur_attr()
-    {
-        if(m_attr_stack.size() == 0)
-        {
-            throw exception("cur_attr : Attribute stack is empty");
-        }
-        return m_attr_stack[m_attr_stack.size() - 1];
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::push_attr()
-    {
-        m_attr_stack.add(m_attr_stack.size() ? 
-                         m_attr_stack[m_attr_stack.size() - 1] :
-                         path_attributes());
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::pop_attr()
-    {
-        if(m_attr_stack.size() == 0)
-        {
-            throw exception("pop_attr : Attribute stack is empty");
-        }
-        m_attr_stack.remove_last();
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::fill(const rgba8& f)
-    {
-        path_attributes& attr = cur_attr();
-        attr.fill_color = f;
-        attr.fill_flag = true;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::stroke(const rgba8& s)
-    {
-        path_attributes& attr = cur_attr();
-        attr.stroke_color = s;
-        attr.stroke_flag = true;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::even_odd(bool flag)
-    {
-        cur_attr().even_odd_flag = flag;
-    }
-    
-    //------------------------------------------------------------------------
-    void path_renderer::stroke_width(double w)
-    {
-        cur_attr().stroke_width = w;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::fill_none()
-    {
-        cur_attr().fill_flag = false;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::stroke_none()
-    {
-        cur_attr().stroke_flag = false;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::fill_opacity(double op)
-    {
-        cur_attr().fill_color.opacity(op);
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::stroke_opacity(double op)
-    {
-        cur_attr().stroke_color.opacity(op);
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::line_join(line_join_e join)
-    {
-        cur_attr().line_join = join;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::line_cap(line_cap_e cap)
-    {
-        cur_attr().line_cap = cap;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::miter_limit(double ml)
-    {
-        cur_attr().miter_limit = ml;
-    }
-
-    //------------------------------------------------------------------------
-    trans_affine& path_renderer::transform()
-    {
-        return cur_attr().transform;
-    }
-
-    //------------------------------------------------------------------------
-    void path_renderer::parse_path(path_tokenizer& tok)
-    {
-        while(tok.next())
-        {
-            double arg[10];
-            char cmd = tok.last_command();
-            unsigned i;
-            switch(cmd)
-            {
-                case 'M': case 'm':
-                    arg[0] = tok.last_number();
-                    arg[1] = tok.next(cmd);
-                    move_to(arg[0], arg[1], cmd == 'm');
-                    break;
-
-                case 'L': case 'l':
-                    arg[0] = tok.last_number();
-                    arg[1] = tok.next(cmd);
-                    line_to(arg[0], arg[1], cmd == 'l');
-                    break;
-
-                case 'V': case 'v':
-                    vline_to(tok.last_number(), cmd == 'v');
-                    break;
-
-                case 'H': case 'h':
-                    hline_to(tok.last_number(), cmd == 'h');
-                    break;
-                
-                case 'Q': case 'q':
-                    arg[0] = tok.last_number();
-                    for(i = 1; i < 4; i++)
-                    {
-                        arg[i] = tok.next(cmd);
-                    }
-                    curve3(arg[0], arg[1], arg[2], arg[3], cmd == 'q');
-                    break;
-
-                case 'T': case 't':
-                    arg[0] = tok.last_number();
-                    arg[1] = tok.next(cmd);
-                    curve3(arg[0], arg[1], cmd == 't');
-                    break;
-
-                case 'C': case 'c':
-                    arg[0] = tok.last_number();
-                    for(i = 1; i < 6; i++)
-                    {
-                        arg[i] = tok.next(cmd);
-                    }
-                    curve4(arg[0], arg[1], arg[2], arg[3], arg[4], arg[5], cmd == 'c');
-                    break;
-
-                case 'S': case 's':
-                    arg[0] = tok.last_number();
-                    for(i = 1; i < 4; i++)
-                    {
-                        arg[i] = tok.next(cmd);
-                    }
-                    curve4(arg[0], arg[1], arg[2], arg[3], cmd == 's');
-                    break;
-
-                case 'A': case 'a':
-                    throw exception("parse_path: Command A: NOT IMPLEMENTED YET");
-
-                case 'Z': case 'z':
-                    close_subpath();
-                    break;
-
-                default:
-                {
-                    char buf[100];
-                    sprintf(buf, "parse_path: Invalid Command %c", cmd);
-                    throw exception(buf);
-                }
-            }
-        }
-    }
-
-}
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_svg_path_tokenizer.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_svg_path_tokenizer.cpp
--- 8.0.1-5/renderers/agg/src/agg_svg_path_tokenizer.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_svg_path_tokenizer.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,144 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.3
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// SVG path tokenizer.
-//
-//----------------------------------------------------------------------------
-#include <string.h>
-#include <stdlib.h>
-#include <stdio.h>
-#include "agg_svg_exception.h"
-#include "agg_svg_path_tokenizer.h"
-
-
-namespace mapserver 
-{ 
-namespace svg
-{
-
-    //------------------------------------------------------------------------
-    const char path_tokenizer::s_commands[]   = "+-MmZzLlHhVvCcSsQqTtAaFfPp";
-    const char path_tokenizer::s_numeric[]    = ".Ee0123456789";
-    const char path_tokenizer::s_separators[] = " ,\t\n\r";
-
-    //------------------------------------------------------------------------
-    path_tokenizer::path_tokenizer()
-        : m_path(0), m_last_number(0.0), m_last_command(0)
-    {
-        init_char_mask(m_commands_mask,   s_commands);
-        init_char_mask(m_numeric_mask,    s_numeric);
-        init_char_mask(m_separators_mask, s_separators);
-    }
-
-
-    //------------------------------------------------------------------------
-    void path_tokenizer::set_path_str(const char* str)
-    {
-        m_path = str;
-        m_last_command = 0;
-        m_last_number = 0.0;
-    }
-
-
-    //------------------------------------------------------------------------
-    void path_tokenizer::init_char_mask(char* mask, const char* char_set)
-    {
-        memset(mask, 0, 256/8);
-        while(*char_set) 
-        {
-            unsigned c = unsigned(*char_set++) & 0xFF;
-            mask[c >> 3] |= 1 << (c & 7);
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    bool path_tokenizer::next()
-    {
-        if(m_path == 0) return false;
-
-        // Skip all white spaces and other garbage
-        while(*m_path && !is_command(*m_path) && !is_numeric(*m_path)) 
-        {
-            if(!is_separator(*m_path))
-            {
-                char buf[100];
-                sprintf(buf, "path_tokenizer::next : Invalid Character %c", *m_path);
-                throw exception(buf);
-            }
-            m_path++;
-        }
-
-        if(*m_path == 0) return false;
-
-        if(is_command(*m_path))
-        {
-            // Check if the command is a numeric sign character
-            if(*m_path == '-' || *m_path == '+')
-            {
-                return parse_number();
-            }
-            m_last_command = *m_path++;
-            while(*m_path && is_separator(*m_path)) m_path++;
-            if(*m_path == 0) return true;
-        }
-        return parse_number();
-    }
-
-
-
-    //------------------------------------------------------------------------
-    double path_tokenizer::next(char cmd)
-    {
-        if(!next()) throw exception("parse_path: Unexpected end of path");
-        if(last_command() != cmd)
-        {
-            char buf[100];
-            sprintf(buf, "parse_path: Command %c: bad or missing parameters", cmd);
-            throw exception(buf);
-        }
-        return last_number();
-    }
-
-
-    //------------------------------------------------------------------------
-    bool path_tokenizer::parse_number()
-    {
-        char buf[256]; // Should be enough for any number
-        char* buf_ptr = buf;
-
-        // Copy all sign characters
-        while((buf_ptr < buf+255 && *m_path == '-') || *m_path == '+')
-        {
-            *buf_ptr++ = *m_path++;
-        }
-
-        // Copy all numeric characters
-        while(buf_ptr < buf+255 && is_numeric(*m_path))
-        {
-            *buf_ptr++ = *m_path++;
-        }
-        *buf_ptr = 0;
-        m_last_number = atof(buf);
-        return true;
-    }
-
-
-} //namespace svg
-} //namespace mapserver
-
-
-
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_trans_affine.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_affine.cpp
--- 8.0.1-5/renderers/agg/src/agg_trans_affine.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_affine.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,194 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Affine transformations
-//
-//----------------------------------------------------------------------------
-#include "../include/agg_trans_affine.h"
-
-
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    const trans_affine& trans_affine::parl_to_parl(const double* src, 
-                                                   const double* dst)
-    {
-        sx  = src[2] - src[0];
-        shy = src[3] - src[1];
-        shx = src[4] - src[0];
-        sy  = src[5] - src[1];
-        tx  = src[0];
-        ty  = src[1];
-        invert();
-        multiply(trans_affine(dst[2] - dst[0], dst[3] - dst[1], 
-                              dst[4] - dst[0], dst[5] - dst[1],
-                              dst[0], dst[1]));
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    const trans_affine& trans_affine::rect_to_parl(double x1, double y1, 
-                                                   double x2, double y2, 
-                                                   const double* parl)
-    {
-        double src[6];
-        src[0] = x1; src[1] = y1;
-        src[2] = x2; src[3] = y1;
-        src[4] = x2; src[5] = y2;
-        parl_to_parl(src, parl);
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    const trans_affine& trans_affine::parl_to_rect(const double* parl, 
-                                                   double x1, double y1, 
-                                                   double x2, double y2)
-    {
-        double dst[6];
-        dst[0] = x1; dst[1] = y1;
-        dst[2] = x2; dst[3] = y1;
-        dst[4] = x2; dst[5] = y2;
-        parl_to_parl(parl, dst);
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    const trans_affine& trans_affine::multiply(const trans_affine& m)
-    {
-        double t0 = sx  * m.sx + shy * m.shx;
-        double t2 = shx * m.sx + sy  * m.shx;
-        double t4 = tx  * m.sx + ty  * m.shx + m.tx;
-        shy = sx  * m.shy + shy * m.sy;
-        sy  = shx * m.shy + sy  * m.sy;
-        ty  = tx  * m.shy + ty  * m.sy + m.ty;
-        sx  = t0;
-        shx = t2;
-        tx  = t4;
-        return *this;
-    }
-
-
-    //------------------------------------------------------------------------
-    const trans_affine& trans_affine::invert()
-    {
-        double d  = determinant_reciprocal();
-
-        double t0  =  sy  * d;
-               sy  =  sx  * d;
-               shy = -shy * d;
-               shx = -shx * d;
-
-        double t4 = -tx * t0  - ty * shx;
-               ty = -tx * shy - ty * sy;
-
-        sx = t0;
-        tx = t4;
-        return *this;
-    }
-
-
-   //------------------------------------------------------------------------
-    const trans_affine& trans_affine::flip_x()
-    {
-        sx  = -sx;
-        shy = -shy;
-        tx  = -tx;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    const trans_affine& trans_affine::flip_y()
-    {
-        shx = -shx;
-        sy  = -sy;
-        ty  = -ty;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    const trans_affine& trans_affine::reset()
-    {
-        sx  = sy  = 1.0; 
-        shy = shx = tx = ty = 0.0;
-        return *this;
-    }
-
-    //------------------------------------------------------------------------
-    bool trans_affine::is_identity(double epsilon) const
-    {
-        return is_equal_eps(sx,  1.0, epsilon) &&
-               is_equal_eps(shy, 0.0, epsilon) &&
-               is_equal_eps(shx, 0.0, epsilon) && 
-               is_equal_eps(sy,  1.0, epsilon) &&
-               is_equal_eps(tx,  0.0, epsilon) &&
-               is_equal_eps(ty,  0.0, epsilon);
-    }
-
-    //------------------------------------------------------------------------
-    bool trans_affine::is_valid(double epsilon) const
-    {
-        return fabs(sx) > epsilon && fabs(sy) > epsilon;
-    }
-
-    //------------------------------------------------------------------------
-    bool trans_affine::is_equal(const trans_affine& m, double epsilon) const
-    {
-        return is_equal_eps(sx,  m.sx,  epsilon) &&
-               is_equal_eps(shy, m.shy, epsilon) &&
-               is_equal_eps(shx, m.shx, epsilon) && 
-               is_equal_eps(sy,  m.sy,  epsilon) &&
-               is_equal_eps(tx,  m.tx,  epsilon) &&
-               is_equal_eps(ty,  m.ty,  epsilon);
-    }
-
-    //------------------------------------------------------------------------
-    double trans_affine::rotation() const
-    {
-        double x1 = 0.0;
-        double y1 = 0.0;
-        double x2 = 1.0;
-        double y2 = 0.0;
-        transform(&x1, &y1);
-        transform(&x2, &y2);
-        return atan2(y2-y1, x2-x1);
-    }
-
-    //------------------------------------------------------------------------
-    void trans_affine::translation(double* dx, double* dy) const
-    {
-        *dx = tx;
-        *dy = ty;
-    }
-
-    //------------------------------------------------------------------------
-    void trans_affine::scaling(double* x, double* y) const
-    {
-        double x1 = 0.0;
-        double y1 = 0.0;
-        double x2 = 1.0;
-        double y2 = 1.0;
-        trans_affine t(*this);
-        t *= trans_affine_rotation(-rotation());
-        t.transform(&x1, &y1);
-        t.transform(&x2, &y2);
-        *x = x2 - x1;
-        *y = y2 - y1;
-    }
-
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_trans_double_path.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_double_path.cpp
--- 8.0.1-5/renderers/agg/src/agg_trans_double_path.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_double_path.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,273 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include "../include/agg_math.h"
-#include "../include/agg_trans_double_path.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    trans_double_path::trans_double_path() :
-        m_kindex1(0.0),
-        m_kindex2(0.0),
-        m_base_length(0.0),
-        m_base_height(1.0),
-        m_status1(initial),
-        m_status2(initial),
-        m_preserve_x_scale(true)
-    {
-    }
-
-
-        //------------------------------------------------------------------------
-    void trans_double_path::reset()
-    {
-        m_src_vertices1.remove_all();
-        m_src_vertices2.remove_all();
-        m_kindex1 = 0.0;
-        m_kindex1 = 0.0;
-        m_status1 = initial;
-        m_status2 = initial;
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_double_path::move_to1(double x, double y)
-    {
-        if(m_status1 == initial)
-        {
-            m_src_vertices1.modify_last(vertex_dist(x, y));
-            m_status1 = making_path;
-        }
-        else
-        {
-            line_to1(x, y);
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_double_path::line_to1(double x, double y)
-    {
-        if(m_status1 == making_path)
-        {
-            m_src_vertices1.add(vertex_dist(x, y));
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_double_path::move_to2(double x, double y)
-    {
-        if(m_status2 == initial)
-        {
-            m_src_vertices2.modify_last(vertex_dist(x, y));
-            m_status2 = making_path;
-        }
-        else
-        {
-            line_to2(x, y);
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_double_path::line_to2(double x, double y)
-    {
-        if(m_status2 == making_path)
-        {
-            m_src_vertices2.add(vertex_dist(x, y));
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    double trans_double_path::finalize_path(vertex_storage& vertices)
-    {
-        unsigned i;
-        double dist;
-        double d;
-
-        vertices.close(false);
-        if(vertices.size() > 2)
-        {
-            if(vertices[vertices.size() - 2].dist * 10.0 < 
-               vertices[vertices.size() - 3].dist)
-            {
-                d = vertices[vertices.size() - 3].dist + 
-                    vertices[vertices.size() - 2].dist;
-
-                vertices[vertices.size() - 2] = 
-                    vertices[vertices.size() - 1];
-
-                vertices.remove_last();
-                vertices[vertices.size() - 2].dist = d;
-            }
-        }
-
-        dist = 0;
-        for(i = 0; i < vertices.size(); i++)
-        {
-            vertex_dist& v = vertices[i];
-            d = v.dist;
-            v.dist = dist;
-            dist += d;
-        }
-
-        return (vertices.size() - 1) / dist;
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_double_path::finalize_paths()
-    {
-        if(m_status1 == making_path && m_src_vertices1.size() > 1 &&
-           m_status2 == making_path && m_src_vertices2.size() > 1)
-        {
-            m_kindex1 = finalize_path(m_src_vertices1);
-            m_kindex2 = finalize_path(m_src_vertices2);
-            m_status1 = ready;
-            m_status2 = ready;
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    double trans_double_path::total_length1() const
-    {
-        if(m_base_length >= 1e-10) return m_base_length;
-        return (m_status1 == ready) ? 
-            m_src_vertices1[m_src_vertices1.size() - 1].dist :
-            0.0;
-    }
-
-
-    //------------------------------------------------------------------------
-    double trans_double_path::total_length2() const
-    {
-        if(m_base_length >= 1e-10) return m_base_length;
-        return (m_status2 == ready) ? 
-            m_src_vertices2[m_src_vertices2.size() - 1].dist :
-            0.0;
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_double_path::transform1(const vertex_storage& vertices, 
-                                       double kindex, double kx, 
-                                       double *x, double* y) const
-    {
-        double x1 = 0.0;
-        double y1 = 0.0;
-        double dx = 1.0;
-        double dy = 1.0;
-        double d  = 0.0;
-        double dd = 1.0;
-        *x *= kx;
-        if(*x < 0.0)
-        {
-            // Extrapolation on the left
-            //--------------------------
-            x1 = vertices[0].x;
-            y1 = vertices[0].y;
-            dx = vertices[1].x - x1;
-            dy = vertices[1].y - y1;
-            dd = vertices[1].dist - vertices[0].dist;
-            d  = *x;
-        }
-        else
-        if(*x > vertices[vertices.size() - 1].dist)
-        {
-            // Extrapolation on the right
-            //--------------------------
-            unsigned i = vertices.size() - 2;
-            unsigned j = vertices.size() - 1;
-            x1 = vertices[j].x;
-            y1 = vertices[j].y;
-            dx = x1 - vertices[i].x;
-            dy = y1 - vertices[i].y;
-            dd = vertices[j].dist - vertices[i].dist;
-            d  = *x - vertices[j].dist;
-        }
-        else
-        {
-            // Interpolation
-            //--------------------------
-            unsigned i = 0;
-            unsigned j = vertices.size() - 1;
-            if(m_preserve_x_scale)
-            {
-                unsigned k;
-                for(i = 0; (j - i) > 1; ) 
-                {
-                    if(*x < vertices[k = (i + j) >> 1].dist) 
-                    {
-                        j = k; 
-                    }
-                    else 
-                    {
-                        i = k;
-                    }
-                }
-                d  = vertices[i].dist;
-                dd = vertices[j].dist - d;
-                d  = *x - d;
-            }
-            else
-            {
-                i = unsigned(*x * kindex);
-                j = i + 1;
-                dd = vertices[j].dist - vertices[i].dist;
-                d = ((*x * kindex) - i) * dd;
-            }
-            x1 = vertices[i].x;
-            y1 = vertices[i].y;
-            dx = vertices[j].x - x1;
-            dy = vertices[j].y - y1;
-        }
-        *x = x1 + dx * d / dd;
-        *y = y1 + dy * d / dd;
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_double_path::transform(double *x, double *y) const
-    {
-        if(m_status1 == ready && m_status2 == ready)
-        {
-            if(m_base_length > 1e-10)
-            {
-                *x *= m_src_vertices1[m_src_vertices1.size() - 1].dist / 
-                      m_base_length;
-            }
-
-            double x1 = *x;
-            double y1 = *y;
-            double x2 = *x;
-            double y2 = *y;
-            double dd = m_src_vertices2[m_src_vertices2.size() - 1].dist /
-                        m_src_vertices1[m_src_vertices1.size() - 1].dist;
-
-            transform1(m_src_vertices1, m_kindex1, 1.0, &x1, &y1);
-            transform1(m_src_vertices2, m_kindex2, dd,  &x2, &y2);
-
-            *x = x1 + *y * (x2 - x1) / m_base_height;
-            *y = y1 + *y * (y2 - y1) / m_base_height;
-        }
-    }
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_trans_single_path.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_single_path.cpp
--- 8.0.1-5/renderers/agg/src/agg_trans_single_path.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_single_path.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,202 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include "../include/agg_math.h"
-#include "../include/agg_vertex_sequence.h"
-#include "../include/agg_trans_single_path.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    trans_single_path::trans_single_path() :
-        m_base_length(0.0),
-        m_kindex(0.0),
-        m_status(initial),
-        m_preserve_x_scale(true)
-    {
-    }
-
-    //------------------------------------------------------------------------
-    void trans_single_path::reset()
-    {
-        m_src_vertices.remove_all();
-        m_kindex = 0.0;
-        m_status = initial;
-    }
-
-    //------------------------------------------------------------------------
-    void trans_single_path::move_to(double x, double y)
-    {
-        if(m_status == initial)
-        {
-            m_src_vertices.modify_last(vertex_dist(x, y));
-            m_status = making_path;
-        }
-        else
-        {
-            line_to(x, y);
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void trans_single_path::line_to(double x, double y)
-    {
-        if(m_status == making_path)
-        {
-            m_src_vertices.add(vertex_dist(x, y));
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_single_path::finalize_path()
-    {
-        if(m_status == making_path && m_src_vertices.size() > 1)
-        {
-            unsigned i;
-            double dist;
-            double d;
-
-            m_src_vertices.close(false);
-            if(m_src_vertices.size() > 2)
-            {
-                if(m_src_vertices[m_src_vertices.size() - 2].dist * 10.0 < 
-                   m_src_vertices[m_src_vertices.size() - 3].dist)
-                {
-                    d = m_src_vertices[m_src_vertices.size() - 3].dist + 
-                        m_src_vertices[m_src_vertices.size() - 2].dist;
-
-                    m_src_vertices[m_src_vertices.size() - 2] = 
-                        m_src_vertices[m_src_vertices.size() - 1];
-
-                    m_src_vertices.remove_last();
-                    m_src_vertices[m_src_vertices.size() - 2].dist = d;
-                }
-            }
-
-            dist = 0.0;
-            for(i = 0; i < m_src_vertices.size(); i++)
-            {
-                vertex_dist& v = m_src_vertices[i];
-                double d = v.dist;
-                v.dist = dist;
-                dist += d;
-            }
-            m_kindex = (m_src_vertices.size() - 1) / dist;
-            m_status = ready;
-        }
-    }
-
-
-
-    //------------------------------------------------------------------------
-    double trans_single_path::total_length() const
-    {
-        if(m_base_length >= 1e-10) return m_base_length;
-        return (m_status == ready) ? 
-            m_src_vertices[m_src_vertices.size() - 1].dist :
-            0.0;
-    }
-
-
-    //------------------------------------------------------------------------
-    void trans_single_path::transform(double *x, double *y) const
-    {
-        if(m_status == ready)
-        {
-            if(m_base_length > 1e-10)
-            {
-                *x *= m_src_vertices[m_src_vertices.size() - 1].dist / 
-                      m_base_length;
-            }
-
-            double x1 = 0.0;
-            double y1 = 0.0;
-            double dx = 1.0;
-            double dy = 1.0;
-            double d  = 0.0;
-            double dd = 1.0;
-            if(*x < 0.0)
-            {
-                // Extrapolation on the left
-                //--------------------------
-                x1 = m_src_vertices[0].x;
-                y1 = m_src_vertices[0].y;
-                dx = m_src_vertices[1].x - x1;
-                dy = m_src_vertices[1].y - y1;
-                dd = m_src_vertices[1].dist - m_src_vertices[0].dist;
-                d  = *x;
-            }
-            else
-            if(*x > m_src_vertices[m_src_vertices.size() - 1].dist)
-            {
-                // Extrapolation on the right
-                //--------------------------
-                unsigned i = m_src_vertices.size() - 2;
-                unsigned j = m_src_vertices.size() - 1;
-                x1 = m_src_vertices[j].x;
-                y1 = m_src_vertices[j].y;
-                dx = x1 - m_src_vertices[i].x;
-                dy = y1 - m_src_vertices[i].y;
-                dd = m_src_vertices[j].dist - m_src_vertices[i].dist;
-                d  = *x - m_src_vertices[j].dist;
-            }
-            else
-            {
-                // Interpolation
-                //--------------------------
-                unsigned i = 0;
-                unsigned j = m_src_vertices.size() - 1;
-                if(m_preserve_x_scale)
-                {
-                    unsigned k;
-                    for(i = 0; (j - i) > 1; ) 
-                    {
-                        if(*x < m_src_vertices[k = (i + j) >> 1].dist) 
-                        {
-                            j = k; 
-                        }
-                        else 
-                        {
-                            i = k;
-                        }
-                    }
-                    d  = m_src_vertices[i].dist;
-                    dd = m_src_vertices[j].dist - d;
-                    d  = *x - d;
-                }
-                else
-                {
-                    i = unsigned(*x * m_kindex);
-                    j = i + 1;
-                    dd = m_src_vertices[j].dist - m_src_vertices[i].dist;
-                    d = ((*x * m_kindex) - i) * dd;
-                }
-                x1 = m_src_vertices[i].x;
-                y1 = m_src_vertices[i].y;
-                dx = m_src_vertices[j].x - x1;
-                dy = m_src_vertices[j].y - y1;
-            }
-            double x2 = x1 + dx * d / dd;
-            double y2 = y1 + dy * d / dd;
-            *x = x2 - *y * dy / dd;
-            *y = y2 + *y * dx / dd;
-        }
-    }
-
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_trans_warp_magnifier.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_warp_magnifier.cpp
--- 8.0.1-5/renderers/agg/src/agg_trans_warp_magnifier.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_trans_warp_magnifier.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,70 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_trans_warp_magnifier.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    void trans_warp_magnifier::transform(double* x, double* y) const
-    {
-        double dx = *x - m_xc;
-        double dy = *y - m_yc;
-        double r = sqrt(dx * dx + dy * dy);
-        if(r < m_radius)
-        {
-            *x = m_xc + dx * m_magn;
-            *y = m_yc + dy * m_magn;
-            return;
-        }
-
-        double m = (r + m_radius * (m_magn - 1.0)) / r;
-        *x = m_xc + dx * m;
-        *y = m_yc + dy * m;
-    }
-
-    //------------------------------------------------------------------------
-    void trans_warp_magnifier::inverse_transform(double* x, double* y) const
-    {
-        // New version by Andrew Skalkin
-        //-----------------
-        double dx = *x - m_xc;
-        double dy = *y - m_yc;
-        double r = sqrt(dx * dx + dy * dy);
-
-        if(r < m_radius * m_magn) 
-        {
-            *x = m_xc + dx / m_magn;
-            *y = m_yc + dy / m_magn;
-        }
-        else
-        {
-            double rnew = r - m_radius * (m_magn - 1.0);
-            *x = m_xc + rnew * dx / r; 
-            *y = m_yc + rnew * dy / r;
-        }
-
-        // Old version
-        //-----------------
-        //trans_warp_magnifier t(*this);
-        //t.magnification(1.0 / m_magn);
-        //t.radius(m_radius * m_magn);
-        //t.transform(x, y);
-    }
-
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_vcgen_bspline.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_bspline.cpp
--- 8.0.1-5/renderers/agg/src/agg_vcgen_bspline.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_bspline.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,194 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include "../include/agg_vcgen_bspline.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    vcgen_bspline::vcgen_bspline() :
-        m_src_vertices(),
-        m_spline_x(),
-        m_spline_y(),
-        m_interpolation_step(1.0/50.0),
-        m_closed(0),
-        m_status(initial),
-        m_src_vertex(0)
-    {
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_bspline::remove_all()
-    {
-        m_src_vertices.remove_all();
-        m_closed = 0;
-        m_status = initial;
-        m_src_vertex = 0;
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_bspline::add_vertex(double x, double y, unsigned cmd)
-    {
-        m_status = initial;
-        if(is_move_to(cmd))
-        {
-            m_src_vertices.modify_last(point_d(x, y));
-        }
-        else
-        {
-            if(is_vertex(cmd))
-            {
-                m_src_vertices.add(point_d(x, y));
-            }
-            else
-            {
-                m_closed = get_close_flag(cmd);
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_bspline::rewind(unsigned)
-    {
-        m_cur_abscissa = 0.0;
-        m_max_abscissa = 0.0;
-        m_src_vertex = 0;
-        if(m_status == initial && m_src_vertices.size() > 2)
-        {
-            if(m_closed)
-            {
-                m_spline_x.init(m_src_vertices.size() + 8);
-                m_spline_y.init(m_src_vertices.size() + 8);
-                m_spline_x.add_point(0.0, m_src_vertices.prev(m_src_vertices.size() - 3).x);
-                m_spline_y.add_point(0.0, m_src_vertices.prev(m_src_vertices.size() - 3).y);
-                m_spline_x.add_point(1.0, m_src_vertices[m_src_vertices.size() - 3].x);
-                m_spline_y.add_point(1.0, m_src_vertices[m_src_vertices.size() - 3].y);
-                m_spline_x.add_point(2.0, m_src_vertices[m_src_vertices.size() - 2].x);
-                m_spline_y.add_point(2.0, m_src_vertices[m_src_vertices.size() - 2].y);
-                m_spline_x.add_point(3.0, m_src_vertices[m_src_vertices.size() - 1].x);
-                m_spline_y.add_point(3.0, m_src_vertices[m_src_vertices.size() - 1].y);
-            }
-            else
-            {
-                m_spline_x.init(m_src_vertices.size());
-                m_spline_y.init(m_src_vertices.size());
-            }
-            unsigned i;
-            for(i = 0; i < m_src_vertices.size(); i++)
-            {
-                double x = m_closed ? i + 4 : i;
-                m_spline_x.add_point(x, m_src_vertices[i].x);
-                m_spline_y.add_point(x, m_src_vertices[i].y);
-            }
-            m_cur_abscissa = 0.0;
-            m_max_abscissa = m_src_vertices.size() - 1;
-            if(m_closed)
-            {
-                m_cur_abscissa = 4.0;
-                m_max_abscissa += 5.0;
-                m_spline_x.add_point(m_src_vertices.size() + 4, m_src_vertices[0].x);
-                m_spline_y.add_point(m_src_vertices.size() + 4, m_src_vertices[0].y);
-                m_spline_x.add_point(m_src_vertices.size() + 5, m_src_vertices[1].x);
-                m_spline_y.add_point(m_src_vertices.size() + 5, m_src_vertices[1].y);
-                m_spline_x.add_point(m_src_vertices.size() + 6, m_src_vertices[2].x);
-                m_spline_y.add_point(m_src_vertices.size() + 6, m_src_vertices[2].y);
-                m_spline_x.add_point(m_src_vertices.size() + 7, m_src_vertices.next(2).x);
-                m_spline_y.add_point(m_src_vertices.size() + 7, m_src_vertices.next(2).y);
-            }
-            m_spline_x.prepare();
-            m_spline_y.prepare();
-        }
-        m_status = ready;
-    }
-
-
-
-
-
-
-    //------------------------------------------------------------------------
-    unsigned vcgen_bspline::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_line_to;
-        while(!is_stop(cmd))
-        {
-            switch(m_status)
-            {
-            case initial:
-                rewind(0);
-
-            case ready:
-                if(m_src_vertices.size() < 2)
-                {
-                    cmd = path_cmd_stop;
-                    break;
-                }
-
-                if(m_src_vertices.size() == 2)
-                {
-                    *x = m_src_vertices[m_src_vertex].x;
-                    *y = m_src_vertices[m_src_vertex].y;
-                    m_src_vertex++;
-                    if(m_src_vertex == 1) return path_cmd_move_to;
-                    if(m_src_vertex == 2) return path_cmd_line_to;
-                    cmd = path_cmd_stop;
-                    break;
-                }
-
-                cmd = path_cmd_move_to;
-                m_status = polygon;
-                m_src_vertex = 0;
-
-            case polygon:
-                if(m_cur_abscissa >= m_max_abscissa)
-                {
-                    if(m_closed)
-                    {
-                        m_status = end_poly;
-                        break;
-                    }
-                    else
-                    {
-                        *x = m_src_vertices[m_src_vertices.size() - 1].x;
-                        *y = m_src_vertices[m_src_vertices.size() - 1].y;
-                        m_status = end_poly;
-                        return path_cmd_line_to;
-                    }
-                }
-
-                *x = m_spline_x.get_stateful(m_cur_abscissa);
-                *y = m_spline_y.get_stateful(m_cur_abscissa);
-                m_src_vertex++;
-                m_cur_abscissa += m_interpolation_step;
-                return (m_src_vertex == 1) ? path_cmd_move_to : path_cmd_line_to;
-
-            case end_poly:
-                m_status = stop;
-                return path_cmd_end_poly | m_closed;
-
-            case stop:
-                return path_cmd_stop;
-            }
-        }
-        return cmd;
-    }
-
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_vcgen_contour.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_contour.cpp
--- 8.0.1-5/renderers/agg/src/agg_vcgen_contour.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_contour.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,168 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Contour generator
-//
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_vcgen_contour.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    vcgen_contour::vcgen_contour() :
-        m_stroker(),
-        m_width(1),
-        m_src_vertices(),
-        m_out_vertices(),
-        m_status(initial),
-        m_src_vertex(0),
-        m_closed(0),
-        m_orientation(0),
-        m_auto_detect(false)
-    {
-    }
-
-    //------------------------------------------------------------------------
-    void vcgen_contour::remove_all()
-    {
-        m_src_vertices.remove_all();
-        m_closed = 0;
-        m_orientation = 0;
-        m_status = initial;
-    }
-
-    //------------------------------------------------------------------------
-    void vcgen_contour::add_vertex(double x, double y, unsigned cmd)
-    {
-        m_status = initial;
-        if(is_move_to(cmd))
-        {
-            m_src_vertices.modify_last(vertex_dist(x, y));
-        }
-        else
-        {
-            if(is_vertex(cmd))
-            {
-                m_src_vertices.add(vertex_dist(x, y));
-            }
-            else
-            {
-                if(is_end_poly(cmd))
-                {
-                    m_closed = get_close_flag(cmd);
-                    if(m_orientation == path_flags_none) 
-                    {
-                        m_orientation = get_orientation(cmd);
-                    }
-                }
-            }
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void vcgen_contour::rewind(unsigned)
-    {
-        if(m_status == initial)
-        {
-            m_src_vertices.close(true);
-            if(m_auto_detect)
-            {
-                if(!is_oriented(m_orientation))
-                {
-                    m_orientation = (calc_polygon_area(m_src_vertices) > 0.0) ? 
-                                    path_flags_ccw : 
-                                    path_flags_cw;
-                }
-            }
-            if(is_oriented(m_orientation))
-            {
-                m_stroker.width(is_ccw(m_orientation) ? m_width : -m_width);
-            }
-        }
-        m_status = ready;
-        m_src_vertex = 0;
-    }
-
-    //------------------------------------------------------------------------
-    unsigned vcgen_contour::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_line_to;
-        while(!is_stop(cmd))
-        {
-            switch(m_status)
-            {
-            case initial:
-                rewind(0);
-                // FALLTHROUGH
-
-            case ready:
-                if(m_src_vertices.size() < 2 + unsigned(m_closed != 0))
-                {
-                    cmd = path_cmd_stop;
-                    break;
-                }
-                m_status = outline;
-                cmd = path_cmd_move_to;
-                m_src_vertex = 0;
-                m_out_vertex = 0;
-                // FALLTHROUGH
-
-            case outline:
-                if(m_src_vertex >= m_src_vertices.size())
-                {
-                    m_status = end_poly;
-                    break;
-                }
-                m_stroker.calc_join(m_out_vertices, 
-                                    m_src_vertices.prev(m_src_vertex), 
-                                    m_src_vertices.curr(m_src_vertex), 
-                                    m_src_vertices.next(m_src_vertex), 
-                                    m_src_vertices.prev(m_src_vertex).dist,
-                                    m_src_vertices.curr(m_src_vertex).dist);
-                ++m_src_vertex;
-                m_status = out_vertices;
-                m_out_vertex = 0;
-                // FALLTHROUGH
-
-            case out_vertices:
-                if(m_out_vertex >= m_out_vertices.size())
-                {
-                    m_status = outline;
-                }
-                else
-                {
-                    const point_d& c = m_out_vertices[m_out_vertex++];
-                    *x = c.x;
-                    *y = c.y;
-                    return cmd;
-                }
-                break;
-
-            case end_poly:
-                if(!m_closed) return path_cmd_stop;
-                m_status = stop;
-                return path_cmd_end_poly | path_flags_close | path_flags_ccw;
-
-            case stop:
-                return path_cmd_stop;
-            }
-        }
-        return cmd;
-    }
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_vcgen_dash.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_dash.cpp
--- 8.0.1-5/renderers/agg/src/agg_vcgen_dash.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_dash.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,236 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Line dash generator
-//
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_vcgen_dash.h"
-#include "../include/agg_shorten_path.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    vcgen_dash::vcgen_dash() :
-        m_total_dash_len(0.0),
-        m_num_dashes(0),
-        m_dash_start(0.0),
-        m_shorten(0.0),
-        m_curr_dash_start(0.0),
-        m_curr_dash(0),
-        m_src_vertices(),
-        m_closed(0),
-        m_status(initial),
-        m_src_vertex(0)
-    {
-    }
-
-
-
-    //------------------------------------------------------------------------
-    void vcgen_dash::remove_all_dashes()
-    {
-        m_total_dash_len = 0.0;
-        m_num_dashes = 0;
-        m_curr_dash_start = 0.0;
-        m_curr_dash = 0;
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_dash::add_dash(double dash_len, double gap_len)
-    {
-        if(m_num_dashes < max_dashes-1)
-        {
-            m_total_dash_len += dash_len + gap_len;
-            m_dashes[m_num_dashes++] = dash_len;
-            m_dashes[m_num_dashes++] = gap_len;
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_dash::dash_start(double ds)
-    {
-        m_dash_start = ds;
-        calc_dash_start(fabs(ds));
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_dash::calc_dash_start(double ds)
-    {
-        m_curr_dash = 0;
-        m_curr_dash_start = 0.0;
-        while(ds > 0.0)
-        {
-            if(ds > m_dashes[m_curr_dash])
-            {
-                ds -= m_dashes[m_curr_dash];
-                ++m_curr_dash;
-                m_curr_dash_start = 0.0;
-                if(m_curr_dash >= m_num_dashes) m_curr_dash = 0;
-            }
-            else
-            {
-                m_curr_dash_start = ds;
-                ds = 0.0;
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_dash::remove_all()
-    {
-        m_status = initial;
-        m_src_vertices.remove_all();
-        m_closed = 0;
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_dash::add_vertex(double x, double y, unsigned cmd)
-    {
-        m_status = initial;
-        if(is_move_to(cmd))
-        {
-            m_src_vertices.modify_last(vertex_dist(x, y));
-        }
-        else
-        {
-            if(is_vertex(cmd))
-            {
-                m_src_vertices.add(vertex_dist(x, y));
-            }
-            else
-            {
-                m_closed = get_close_flag(cmd);
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_dash::rewind(unsigned)
-    {
-        if(m_status == initial)
-        {
-            m_src_vertices.close(m_closed != 0);
-            shorten_path(m_src_vertices, m_shorten, m_closed);
-        }
-        m_status = ready;
-        m_src_vertex = 0;
-    }
-
-
-    //------------------------------------------------------------------------
-    unsigned vcgen_dash::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_move_to;
-        while(!is_stop(cmd))
-        {
-            switch(m_status)
-            {
-            case initial:
-                rewind(0);
-                // FALLTHROUGH
-
-            case ready:
-                if(m_num_dashes < 2 || m_src_vertices.size() < 2)
-                {
-                    cmd = path_cmd_stop;
-                    break;
-                }
-                m_status = polyline;
-                m_src_vertex = 1;
-                m_v1 = &m_src_vertices[0];
-                m_v2 = &m_src_vertices[1];
-                m_curr_rest = m_v1->dist;
-                *x = m_v1->x;
-                *y = m_v1->y;
-                if(m_dash_start >= 0.0) calc_dash_start(m_dash_start);
-                return path_cmd_move_to;
-
-            case polyline:
-                {
-                    double dash_rest = m_dashes[m_curr_dash] - m_curr_dash_start;
-
-                    unsigned cmd = (m_curr_dash & 1) ? 
-                                   path_cmd_move_to : 
-                                   path_cmd_line_to;
-
-                    if(m_curr_rest > dash_rest)
-                    {
-                        m_curr_rest -= dash_rest;
-                        ++m_curr_dash;
-                        if(m_curr_dash >= m_num_dashes) m_curr_dash = 0;
-                        m_curr_dash_start = 0.0;
-                        *x = m_v2->x - (m_v2->x - m_v1->x) * m_curr_rest / m_v1->dist;
-                        *y = m_v2->y - (m_v2->y - m_v1->y) * m_curr_rest / m_v1->dist;
-                    }
-                    else
-                    {
-                        m_curr_dash_start += m_curr_rest;
-                        *x = m_v2->x;
-                        *y = m_v2->y;
-                        ++m_src_vertex;
-                        m_v1 = m_v2;
-                        m_curr_rest = m_v1->dist;
-                        if(m_closed)
-                        {
-                            if(m_src_vertex > m_src_vertices.size())
-                            {
-                                m_status = stop;
-                            }
-                            else
-                            {
-                                m_v2 = &m_src_vertices
-                                [
-                                    (m_src_vertex >= m_src_vertices.size()) ? 0 : 
-                                    m_src_vertex
-                                ];
-                            }
-                        }
-                        else
-                        {
-                            if(m_src_vertex >= m_src_vertices.size())
-                            {
-                                m_status = stop;
-                            }
-                            else
-                            {
-                                m_v2 = &m_src_vertices[m_src_vertex];
-                            }
-                        }
-                    }
-                    return cmd;
-                }
-                break;
-
-            case stop:
-                cmd = path_cmd_stop;
-                break;
-            }
-
-        }
-        return path_cmd_stop;
-    }
-
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_vcgen_markers_term.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_markers_term.cpp
--- 8.0.1-5/renderers/agg/src/agg_vcgen_markers_term.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_markers_term.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,103 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Terminal markers generator (arrowhead/arrowtail)
-//
-//----------------------------------------------------------------------------
-
-#include "../include/agg_vcgen_markers_term.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    void vcgen_markers_term::remove_all()
-    {
-        m_markers.remove_all();
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_markers_term::add_vertex(double x, double y, unsigned cmd)
-    {
-        if(is_move_to(cmd))
-        {
-            if(m_markers.size() & 1)
-            {
-                // Initial state, the first coordinate was added.
-                // If two of more calls of start_vertex() occures
-                // we just modify the last one.
-                m_markers.modify_last(coord_type(x, y));
-            }
-            else
-            {
-                m_markers.add(coord_type(x, y));
-            }
-        }
-        else
-        {
-            if(is_vertex(cmd))
-            {
-                if(m_markers.size() & 1)
-                {
-                    // Initial state, the first coordinate was added.
-                    // Add three more points, 0,1,1,0
-                    m_markers.add(coord_type(x, y));
-                    m_markers.add(m_markers[m_markers.size() - 1]);
-                    m_markers.add(m_markers[m_markers.size() - 3]);
-                }
-                else
-                {
-                    if(m_markers.size())
-                    {
-                        // Replace two last points: 0,1,1,0 -> 0,1,2,1
-                        m_markers[m_markers.size() - 1] = m_markers[m_markers.size() - 2];
-                        m_markers[m_markers.size() - 2] = coord_type(x, y);
-                    }
-                }
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_markers_term::rewind(unsigned path_id)
-    {
-        m_curr_id = path_id * 2;
-        m_curr_idx = m_curr_id;
-    }
-
-
-    //------------------------------------------------------------------------
-    unsigned vcgen_markers_term::vertex(double* x, double* y)
-    {
-        if(m_curr_id > 2 || m_curr_idx >= m_markers.size()) 
-        {
-            return path_cmd_stop;
-        }
-        const coord_type& c = m_markers[m_curr_idx];
-        *x = c.x;
-        *y = c.y;
-        if(m_curr_idx & 1)
-        {
-            m_curr_idx += 3;
-            return path_cmd_line_to;
-        }
-        ++m_curr_idx;
-        return path_cmd_move_to;
-    }
-
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_vcgen_smooth_poly1.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_smooth_poly1.cpp
--- 8.0.1-5/renderers/agg/src/agg_vcgen_smooth_poly1.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_smooth_poly1.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,225 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Smooth polygon generator
-//
-//----------------------------------------------------------------------------
-
-#include "../include/agg_vcgen_smooth_poly1.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    vcgen_smooth_poly1::vcgen_smooth_poly1() :
-        m_src_vertices(),
-        m_smooth_value(0.5),
-        m_closed(0),
-        m_status(initial),
-        m_src_vertex(0)
-    {
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_smooth_poly1::remove_all()
-    {
-        m_src_vertices.remove_all();
-        m_closed = 0;
-        m_status = initial;
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_smooth_poly1::add_vertex(double x, double y, unsigned cmd)
-    {
-        m_status = initial;
-        if(is_move_to(cmd))
-        {
-            m_src_vertices.modify_last(vertex_dist(x, y));
-        }
-        else
-        {
-            if(is_vertex(cmd))
-            {
-                m_src_vertices.add(vertex_dist(x, y));
-            }
-            else
-            {
-                m_closed = get_close_flag(cmd);
-            }
-        }
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_smooth_poly1::rewind(unsigned)
-    {
-        if(m_status == initial)
-        {
-            m_src_vertices.close(m_closed != 0);
-        }
-        m_status = ready;
-        m_src_vertex = 0;
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_smooth_poly1::calculate(const vertex_dist& v0, 
-                                       const vertex_dist& v1, 
-                                       const vertex_dist& v2,
-                                       const vertex_dist& v3)
-    {
-
-        double k1 = v0.dist / (v0.dist + v1.dist);
-        double k2 = v1.dist / (v1.dist + v2.dist);
-
-        double xm1 = v0.x + (v2.x - v0.x) * k1;
-        double ym1 = v0.y + (v2.y - v0.y) * k1;
-        double xm2 = v1.x + (v3.x - v1.x) * k2;
-        double ym2 = v1.y + (v3.y - v1.y) * k2;
-
-        m_ctrl1_x = v1.x + m_smooth_value * (v2.x - xm1);
-        m_ctrl1_y = v1.y + m_smooth_value * (v2.y - ym1);
-        m_ctrl2_x = v2.x + m_smooth_value * (v1.x - xm2);
-        m_ctrl2_y = v2.y + m_smooth_value * (v1.y - ym2);
-    }
-
-
-    //------------------------------------------------------------------------
-    unsigned vcgen_smooth_poly1::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_line_to;
-        while(!is_stop(cmd))
-        {
-            switch(m_status)
-            {
-            case initial:
-                rewind(0);
-
-            case ready:
-                if(m_src_vertices.size() <  2)
-                {
-                    cmd = path_cmd_stop;
-                    break;
-                }
-
-                if(m_src_vertices.size() == 2)
-                {
-                    *x = m_src_vertices[m_src_vertex].x;
-                    *y = m_src_vertices[m_src_vertex].y;
-                    m_src_vertex++;
-                    if(m_src_vertex == 1) return path_cmd_move_to;
-                    if(m_src_vertex == 2) return path_cmd_line_to;
-                    cmd = path_cmd_stop;
-                    break;
-                }
-
-                cmd = path_cmd_move_to;
-                m_status = polygon;
-                m_src_vertex = 0;
-
-            case polygon:
-                if(m_closed)
-                {
-                    if(m_src_vertex >= m_src_vertices.size())
-                    {
-                        *x = m_src_vertices[0].x;
-                        *y = m_src_vertices[0].y;
-                        m_status = end_poly;
-                        return path_cmd_curve4;
-                    }
-                }
-                else
-                {
-                    if(m_src_vertex >= m_src_vertices.size() - 1)
-                    {
-                        *x = m_src_vertices[m_src_vertices.size() - 1].x;
-                        *y = m_src_vertices[m_src_vertices.size() - 1].y;
-                        m_status = end_poly;
-                        return path_cmd_curve3;
-                    }
-                }
-
-                calculate(m_src_vertices.prev(m_src_vertex), 
-                          m_src_vertices.curr(m_src_vertex), 
-                          m_src_vertices.next(m_src_vertex),
-                          m_src_vertices.next(m_src_vertex + 1));
-
-                *x = m_src_vertices[m_src_vertex].x;
-                *y = m_src_vertices[m_src_vertex].y;
-                m_src_vertex++;
-
-                if(m_closed)
-                {
-                    m_status = ctrl1;
-                    return ((m_src_vertex == 1) ? 
-                             path_cmd_move_to : 
-                             path_cmd_curve4);
-                }
-                else
-                {
-                    if(m_src_vertex == 1)
-                    {
-                        m_status = ctrl_b;
-                        return path_cmd_move_to;
-                    }
-                    if(m_src_vertex >= m_src_vertices.size() - 1)
-                    {
-                        m_status = ctrl_e;
-                        return path_cmd_curve3;
-                    }
-                    m_status = ctrl1;
-                    return path_cmd_curve4;
-                }
-                break;
-
-            case ctrl_b:
-                *x = m_ctrl2_x;
-                *y = m_ctrl2_y;
-                m_status = polygon;
-                return path_cmd_curve3;
-
-            case ctrl_e:
-                *x = m_ctrl1_x;
-                *y = m_ctrl1_y;
-                m_status = polygon;
-                return path_cmd_curve3;
-
-            case ctrl1:
-                *x = m_ctrl1_x;
-                *y = m_ctrl1_y;
-                m_status = ctrl2;
-                return path_cmd_curve4;
-
-            case ctrl2:
-                *x = m_ctrl2_x;
-                *y = m_ctrl2_y;
-                m_status = polygon;
-                return path_cmd_curve4;
-
-            case end_poly:
-                m_status = stop;
-                return path_cmd_end_poly | m_closed;
-
-            case stop:
-                return path_cmd_stop;
-            }
-        }
-        return cmd;
-    }
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/agg_vcgen_stroke.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_stroke.cpp
--- 8.0.1-5/renderers/agg/src/agg_vcgen_stroke.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vcgen_stroke.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,215 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-//
-// Stroke generator
-//
-//----------------------------------------------------------------------------
-#include <math.h>
-#include "../include/agg_vcgen_stroke.h"
-#include "../include/agg_shorten_path.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    vcgen_stroke::vcgen_stroke() :
-        m_stroker(),
-        m_src_vertices(),
-        m_out_vertices(),
-        m_shorten(0.0),
-        m_closed(0),
-        m_status(initial),
-        m_src_vertex(0),
-        m_out_vertex(0)
-    {
-    }
-
-    //------------------------------------------------------------------------
-    void vcgen_stroke::remove_all()
-    {
-        m_src_vertices.remove_all();
-        m_closed = 0;
-        m_status = initial;
-    }
-
-
-    //------------------------------------------------------------------------
-    void vcgen_stroke::add_vertex(double x, double y, unsigned cmd)
-    {
-        m_status = initial;
-        if(is_move_to(cmd))
-        {
-            m_src_vertices.modify_last(vertex_dist(x, y));
-        }
-        else
-        {
-            if(is_vertex(cmd))
-            {
-                m_src_vertices.add(vertex_dist(x, y));
-            }
-            else
-            {
-                m_closed = get_close_flag(cmd);
-            }
-        }
-    }
-
-    //------------------------------------------------------------------------
-    void vcgen_stroke::rewind(unsigned)
-    {
-        if(m_status == initial)
-        {
-            m_src_vertices.close(m_closed != 0);
-            shorten_path(m_src_vertices, m_shorten, m_closed);
-            if(m_src_vertices.size() < 3) m_closed = 0;
-        }
-        m_status = ready;
-        m_src_vertex = 0;
-        m_out_vertex = 0;
-    }
-
-
-    //------------------------------------------------------------------------
-    unsigned vcgen_stroke::vertex(double* x, double* y)
-    {
-        unsigned cmd = path_cmd_line_to;
-        while(!is_stop(cmd))
-        {
-            switch(m_status)
-            {
-            case initial:
-                rewind(0);
-                // FALLTHROUGH
-
-            case ready:
-                if(m_src_vertices.size() < 2 + unsigned(m_closed != 0))
-                {
-                    cmd = path_cmd_stop;
-                    break;
-                }
-                m_status = m_closed ? outline1 : cap1;
-                cmd = path_cmd_move_to;
-                m_src_vertex = 0;
-                m_out_vertex = 0;
-                break;
-
-            case cap1:
-                m_stroker.calc_cap(m_out_vertices,
-                                   m_src_vertices[0], 
-                                   m_src_vertices[1], 
-                                   m_src_vertices[0].dist);
-                m_src_vertex = 1;
-                m_prev_status = outline1;
-                m_status = out_vertices;
-                m_out_vertex = 0;
-                break;
-
-            case cap2:
-                m_stroker.calc_cap(m_out_vertices,
-                                   m_src_vertices[m_src_vertices.size() - 1], 
-                                   m_src_vertices[m_src_vertices.size() - 2], 
-                                   m_src_vertices[m_src_vertices.size() - 2].dist);
-                m_prev_status = outline2;
-                m_status = out_vertices;
-                m_out_vertex = 0;
-                break;
-
-            case outline1:
-                if(m_closed)
-                {
-                    if(m_src_vertex >= m_src_vertices.size())
-                    {
-                        m_prev_status = close_first;
-                        m_status = end_poly1;
-                        break;
-                    }
-                }
-                else
-                {
-                    if(m_src_vertex >= m_src_vertices.size() - 1)
-                    {
-                        m_status = cap2;
-                        break;
-                    }
-                }
-                m_stroker.calc_join(m_out_vertices, 
-                                    m_src_vertices.prev(m_src_vertex), 
-                                    m_src_vertices.curr(m_src_vertex), 
-                                    m_src_vertices.next(m_src_vertex), 
-                                    m_src_vertices.prev(m_src_vertex).dist,
-                                    m_src_vertices.curr(m_src_vertex).dist);
-                ++m_src_vertex;
-                m_prev_status = m_status;
-                m_status = out_vertices;
-                m_out_vertex = 0;
-                break;
-
-            case close_first:
-                m_status = outline2;
-                cmd = path_cmd_move_to;
-                // FALLTHROUGH
-
-            case outline2:
-                if(m_src_vertex <= unsigned(m_closed == 0))
-                {
-                    m_status = end_poly2;
-                    m_prev_status = stop;
-                    break;
-                }
-
-                --m_src_vertex;
-                m_stroker.calc_join(m_out_vertices,
-                                    m_src_vertices.next(m_src_vertex), 
-                                    m_src_vertices.curr(m_src_vertex), 
-                                    m_src_vertices.prev(m_src_vertex), 
-                                    m_src_vertices.curr(m_src_vertex).dist, 
-                                    m_src_vertices.prev(m_src_vertex).dist);
-
-                m_prev_status = m_status;
-                m_status = out_vertices;
-                m_out_vertex = 0;
-                break;
-
-            case out_vertices:
-                if(m_out_vertex >= m_out_vertices.size())
-                {
-                    m_status = m_prev_status;
-                }
-                else
-                {
-                    const point_d& c = m_out_vertices[m_out_vertex++];
-                    *x = c.x;
-                    *y = c.y;
-                    return cmd;
-                }
-                break;
-
-            case end_poly1:
-                m_status = m_prev_status;
-                return path_cmd_end_poly | path_flags_close | path_flags_ccw;
-
-            case end_poly2:
-                m_status = m_prev_status;
-                return path_cmd_end_poly | path_flags_close | path_flags_cw;
-
-            case stop:
-                cmd = path_cmd_stop;
-                break;
-            }
-        }
-        return cmd;
-    }
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_vpgen_clip_polygon.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vpgen_clip_polygon.cpp
--- 8.0.1-5/renderers/agg/src/agg_vpgen_clip_polygon.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vpgen_clip_polygon.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,133 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include "../include/agg_vpgen_clip_polygon.h"
-#include "../include/agg_clip_liang_barsky.h"
-
-namespace mapserver
-{
-
-    //------------------------------------------------------------------------
-    // Determine the clipping code of the vertex according to the 
-    // Cyrus-Beck line clipping algorithm
-    //
-    //        |        |
-    //  0110  |  0010  | 0011
-    //        |        |
-    // -------+--------+-------- clip_box.y2
-    //        |        |
-    //  0100  |  0000  | 0001
-    //        |        |
-    // -------+--------+-------- clip_box.y1
-    //        |        |
-    //  1100  |  1000  | 1001
-    //        |        |
-    //  clip_box.x1  clip_box.x2
-    //
-    // 
-    unsigned vpgen_clip_polygon::clipping_flags(double x, double y)
-    {
-        if(x < m_clip_box.x1) 
-        {
-            if(y > m_clip_box.y2) return 6;
-            if(y < m_clip_box.y1) return 12;
-            return 4;
-        }
-
-        if(x > m_clip_box.x2) 
-        {
-            if(y > m_clip_box.y2) return 3;
-            if(y < m_clip_box.y1) return 9;
-            return 1;
-        }
-
-        if(y > m_clip_box.y2) return 2;
-        if(y < m_clip_box.y1) return 8;
-
-        return 0;
-    }
-
-    //----------------------------------------------------------------------------
-    void vpgen_clip_polygon::reset()
-    {
-        m_vertex = 0;
-        m_num_vertices = 0;
-    }
-
-    //----------------------------------------------------------------------------
-    void vpgen_clip_polygon::move_to(double x, double y)
-    {
-        m_vertex = 0;
-        m_num_vertices = 0;
-        m_clip_flags = clipping_flags(x, y);
-        if(m_clip_flags == 0)
-        {
-            m_x[0] = x;
-            m_y[0] = y;
-            m_num_vertices = 1;
-        }
-        m_x1  = x;
-        m_y1  = y;
-        m_cmd = path_cmd_move_to;
-    }
-
-
-    //----------------------------------------------------------------------------
-    void vpgen_clip_polygon::line_to(double x, double y)
-    {
-        m_vertex = 0;
-        m_num_vertices = 0;
-        unsigned flags = clipping_flags(x, y);
-
-        if(m_clip_flags == flags)
-        {
-            if(flags == 0)
-            {
-                m_x[0] = x;
-                m_y[0] = y;
-                m_num_vertices = 1;
-            }
-        }
-        else
-        {
-            m_num_vertices = clip_liang_barsky(m_x1, m_y1, 
-                                               x, y, 
-                                               m_clip_box, 
-                                               m_x, m_y);
-        }
-
-        m_clip_flags = flags;
-        m_x1 = x;
-        m_y1 = y;
-    }
-
-
-    //----------------------------------------------------------------------------
-    unsigned vpgen_clip_polygon::vertex(double* x, double* y)
-    {
-        if(m_vertex < m_num_vertices)
-        {
-            *x = m_x[m_vertex];
-            *y = m_y[m_vertex];
-            ++m_vertex;
-            unsigned cmd = m_cmd;
-            m_cmd = path_cmd_line_to;
-            return cmd;
-        }
-        return path_cmd_stop;
-    }
-
-
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_vpgen_clip_polyline.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vpgen_clip_polyline.cpp
--- 8.0.1-5/renderers/agg/src/agg_vpgen_clip_polyline.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vpgen_clip_polyline.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,77 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include "../include/agg_vpgen_clip_polyline.h"
-#include "../include/agg_clip_liang_barsky.h"
-
-namespace mapserver
-{
-    //----------------------------------------------------------------------------
-    void vpgen_clip_polyline::reset()
-    {
-        m_vertex = 0;
-        m_num_vertices = 0;
-        m_move_to = false;
-    }
-
-    //----------------------------------------------------------------------------
-    void vpgen_clip_polyline::move_to(double x, double y)
-    {
-        m_vertex = 0;
-        m_num_vertices = 0;
-        m_x1 = x;
-        m_y1 = y;
-        m_move_to = true;
-    }
-
-    //----------------------------------------------------------------------------
-    void vpgen_clip_polyline::line_to(double x, double y)
-    {
-        double x2 = x;
-        double y2 = y;
-        unsigned flags = clip_line_segment(&m_x1, &m_y1, &x2, &y2, m_clip_box);
-
-        m_vertex = 0;
-        m_num_vertices = 0;
-        if((flags & 4) == 0)
-        {
-            if((flags & 1) != 0 || m_move_to)
-            {
-                m_x[0] = m_x1;
-                m_y[0] = m_y1;
-                m_cmd[0] = path_cmd_move_to;
-                m_num_vertices = 1;
-            }
-            m_x[m_num_vertices] = x2;
-            m_y[m_num_vertices] = y2;
-            m_cmd[m_num_vertices++] = path_cmd_line_to;
-            m_move_to = (flags & 2) != 0;
-        }
-        m_x1 = x;
-        m_y1 = y;
-    }
-
-    //----------------------------------------------------------------------------
-    unsigned vpgen_clip_polyline::vertex(double* x, double* y)
-    {
-        if(m_vertex < m_num_vertices)
-        {
-            *x = m_x[m_vertex];
-            *y = m_y[m_vertex];
-            return m_cmd[m_vertex++];
-        }
-        return path_cmd_stop;
-    }
-}
diff -pruN 8.0.1-5/renderers/agg/src/agg_vpgen_segmentator.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vpgen_segmentator.cpp
--- 8.0.1-5/renderers/agg/src/agg_vpgen_segmentator.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/agg_vpgen_segmentator.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,67 +0,0 @@
-//----------------------------------------------------------------------------
-// Anti-Grain Geometry - Version 2.4
-// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
-//
-// Permission to copy, use, modify, sell and distribute this software 
-// is granted provided this copyright notice appears in all copies. 
-// This software is provided "as is" without express or implied
-// warranty, and with no claim as to its suitability for any purpose.
-//
-//----------------------------------------------------------------------------
-// Contact: mcseem@antigrain.com
-//          mcseemagg@yahoo.com
-//          http://www.antigrain.com
-//----------------------------------------------------------------------------
-
-#include <math.h>
-#include "../include/agg_vpgen_segmentator.h"
-
-namespace mapserver
-{
-
-    void vpgen_segmentator::move_to(double x, double y)
-    {
-        m_x1 = x;
-        m_y1 = y;
-        m_dx = 0.0;
-        m_dy = 0.0;
-        m_dl = 2.0;
-        m_ddl = 2.0;
-        m_cmd = path_cmd_move_to;
-    }
-
-    void vpgen_segmentator::line_to(double x, double y)
-    {
-        m_x1 += m_dx;
-        m_y1 += m_dy;
-        m_dx  = x - m_x1;
-        m_dy  = y - m_y1;
-        double len = sqrt(m_dx * m_dx + m_dy * m_dy) * m_approximation_scale;
-        if(len < 1e-30) len = 1e-30;
-        m_ddl = 1.0 / len;
-        m_dl  = (m_cmd == path_cmd_move_to) ? 0.0 : m_ddl;
-        if(m_cmd == path_cmd_stop) m_cmd = path_cmd_line_to;
-    }
-
-    unsigned vpgen_segmentator::vertex(double* x, double* y)
-    {
-        if(m_cmd == path_cmd_stop) return path_cmd_stop;
-
-        unsigned cmd = m_cmd;
-        m_cmd = path_cmd_line_to;
-        if(m_dl >= 1.0 - m_ddl)
-        {
-            m_dl = 1.0;
-            m_cmd = path_cmd_stop;
-            *x = m_x1 + m_dx;
-            *y = m_y1 + m_dy;
-            return cmd;
-        }
-        *x = m_x1 + m_dx * m_dl;
-        *y = m_y1 + m_dy * m_dl;
-        m_dl += m_ddl;
-        return cmd;
-    }
-
-}
-
diff -pruN 8.0.1-5/renderers/agg/src/autogen.sh 8.2.0~beta1-1~exp1/renderers/agg/src/autogen.sh
--- 8.0.1-5/renderers/agg/src/autogen.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/autogen.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,20 +0,0 @@
-# autogen.sh
-#
-# invoke the auto* tools to create the configureation system
-
-# build aclocal.m4
-aclocal
-
-# build the configure script
-autoconf
-
-# set up libtool
-libtoolize --force
-
-# invoke automake
-automake --foreign --add-missing
-
-# and finally invoke our new configure
-./configure $*
-
-# end
diff -pruN 8.0.1-5/renderers/agg/src/clipper.cpp 8.2.0~beta1-1~exp1/renderers/agg/src/clipper.cpp
--- 8.0.1-5/renderers/agg/src/clipper.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/clipper.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,3310 +0,0 @@
-/*******************************************************************************
-*                                                                              *
-* Author    :  Angus Johnson                                                   *
-* Version   :  4.6.3                                                           *
-* Date      :  11 November 2011                                                *
-* Website   :  http://www.angusj.com                                           *
-* Copyright :  Angus Johnson 2010-2011                                         *
-*                                                                              *
-* License:                                                                     *
-* Use, modification & distribution is subject to Boost Software License Ver 1. *
-* http://www.boost.org/LICENSE_1_0.txt                                         *
-*                                                                              *
-* Attributions:                                                                *
-* The code in this library is an extension of Bala Vatti's clipping algorithm: *
-* "A generic solution to polygon clipping"                                     *
-* Communications of the ACM, Vol 35, Issue 7 (July 1992) pp 56-63.             *
-* http://portal.acm.org/citation.cfm?id=129906                                 *
-*                                                                              *
-* Computer graphics and geometric modeling: implementation and algorithms      *
-* By Max K. Agoston                                                            *
-* Springer; 1 edition (January 4, 2005)                                        *
-* http://books.google.com/books?q=vatti+clipping+agoston                       *
-*                                                                              *
-* See also:                                                                    *
-* "Polygon Offsetting by Computing Winding Numbers"                            *
-* Paper no. DETC2005-85513 pp. 565-575                                         *
-* ASME 2005 International Design Engineering Technical Conferences             *
-* and Computers and Information in Engineering Conference (IDETC/CIE2005)      *
-* September 24-28, 2005 , Long Beach, California, USA                          *
-* http://www.me.berkeley.edu/~mcmains/pubs/DAC05OffsetPolygon.pdf              *
-*                                                                              *
-*******************************************************************************/
-
-/*******************************************************************************
-*                                                                              *
-* This is a translation of the Delphi Clipper library and the naming style     *
-* used has retained a Delphi flavour.                                          *
-*                                                                              *
-*******************************************************************************/
-
-#include "../include/clipper.hpp"
-#include <cassert>
-#include <cmath>
-#include <vector>
-#include <algorithm>
-#include <stdexcept>
-#include <cstring>
-#include <cstdlib>
-#include <ostream>
-
-namespace ClipperLib {
-
-static long64 const loRange = 1518500249;            //sqrt(2^63 -1)/2
-static long64 const hiRange = 6521908912666391106LL; //sqrt(2^127 -1)/2
-static double const pi = 3.141592653589793238;
-enum Direction { dRightToLeft, dLeftToRight };
-enum RangeTest { rtLo, rtHi, rtError };
-
-#define HORIZONTAL (-1.0E+40)
-#define TOLERANCE (1.0e-20)
-#define NEAR_ZERO(val) (((val) > -TOLERANCE) && ((val) < TOLERANCE))
-#define NEAR_EQUAL(a, b) NEAR_ZERO((a) - (b))
-
-inline long64 Abs(long64 val)
-{
-  if (val < 0) return -val; else return val;
-}
-//------------------------------------------------------------------------------
-
-//------------------------------------------------------------------------------
-// Int128 class (enables safe math on signed 64bit integers)
-// eg Int128 val1((long64)9223372036854775807); //ie 2^63 -1
-//    Int128 val2((long64)9223372036854775807);
-//    Int128 val3 = val1 * val2;
-//    val3.AsString => "85070591730234615847396907784232501249" (8.5e+37)
-//------------------------------------------------------------------------------
-
-class Int128
-{
-  public:
-
-    Int128(long64 _lo = 0)
-    {
-      hi = 0;
-      if (_lo < 0) {
-        lo = -_lo;
-        Negate(*this);
-      } else
-          lo = _lo;
-    }
-
-    Int128(const Int128 &val): hi(val.hi), lo(val.lo){}
-
-    Int128& operator=( const Int128& ) = default;
-
-    long64 operator = (const long64 &val)
-    {
-      hi = 0;
-      lo = Abs(val);
-      if (val < 0) Negate(*this);
-      return val;
-    }
-
-    bool operator == (const Int128 &val) const
-      {return (hi == val.hi && lo == val.lo);}
-
-    bool operator != (const Int128 &val) const { return !(*this == val);}
-
-    bool operator > (const Int128 &val) const
-    {
-      if (hi > val.hi) return true;
-      else if (hi < val.hi) return false;
-      else return ulong64(lo) > ulong64(val.lo);
-    }
-
-    bool operator < (const Int128 &val) const
-    {
-      if (hi < val.hi) return true;
-      else if (hi > val.hi) return false;
-      else return ulong64(lo) < ulong64(val.lo);
-    }
-
-    Int128& operator += (const Int128 &rhs)
-    {
-      hi += rhs.hi;
-      lo += rhs.lo;
-      if (ulong64(lo) < ulong64(rhs.lo)) hi++;
-      return *this;
-    }
-
-    Int128 operator + (const Int128 &rhs) const
-    {
-      Int128 result(*this);
-      result+= rhs;
-      return result;
-    }
-
-    Int128& operator -= (const Int128 &rhs)
-    {
-      Int128 tmp(rhs);
-      Negate(tmp);
-      *this += tmp;
-      return *this;
-    }
-
-    Int128 operator - (const Int128 &rhs) const
-    {
-      Int128 result(*this);
-      result-= rhs;
-      return result;
-    }
-
-    Int128 operator * (const Int128 &rhs) const {
-      if ( !(hi == 0 || hi == -1) || !(rhs.hi == 0 || rhs.hi == -1))
-        throw "Int128 operator*: overflow error";
-      bool negate = (hi < 0) != (rhs.hi < 0);
-
-      Int128 tmp(*this);
-      if (tmp.hi < 0) Negate(tmp);
-      ulong64 int1Hi = ulong64(tmp.lo) >> 32;
-      ulong64 int1Lo = ulong64(tmp.lo & 0xFFFFFFFF);
-
-      tmp = rhs;
-      if (tmp.hi < 0) Negate(tmp);
-      ulong64 int2Hi = ulong64(tmp.lo) >> 32;
-      ulong64 int2Lo = ulong64(tmp.lo & 0xFFFFFFFF);
-
-      //nb: see comments in clipper.pas
-      ulong64 a = int1Hi * int2Hi;
-      ulong64 b = int1Lo * int2Lo;
-      ulong64 c = int1Hi * int2Lo + int1Lo * int2Hi;
-
-      tmp.hi = long64(a + (c >> 32));
-      tmp.lo = long64(c << 32);
-      tmp.lo += long64(b);
-      if (ulong64(tmp.lo) < b) tmp.hi++;
-      if (negate) Negate(tmp);
-      return tmp;
-    }
-
-    Int128 operator/ (const Int128 &rhs) const
-    {
-      if (rhs.lo == 0 && rhs.hi == 0)
-        throw "Int128 operator/: divide by zero";
-      bool negate = (rhs.hi < 0) != (hi < 0);
-      Int128 result(*this), denom(rhs);
-      if (result.hi < 0) Negate(result);
-      if (denom.hi < 0)  Negate(denom);
-      if (denom > result) return Int128(0); //result is only a fraction of 1
-      Negate(denom);
-
-      Int128 p(0);
-      for (int i = 0; i < 128; ++i)
-      {
-        p.hi = p.hi << 1;
-        if (p.lo < 0) p.hi++;
-        p.lo = long64(p.lo) << 1;
-        if (result.hi < 0) p.lo++;
-        result.hi = result.hi << 1;
-        if (result.lo < 0) result.hi++;
-        result.lo = long64(result.lo) << 1;
-        Int128 p2(p);
-        p += denom;
-        if (p.hi < 0) p = p2;
-        else result.lo++;
-      }
-      if (negate) Negate(result);
-      return result;
-    }
-
-    double AsDouble() const
-    {
-      const double shift64 = 18446744073709551616.0; //2^64
-      const double bit64 = 9223372036854775808.0;
-      if (hi < 0)
-      {
-        Int128 tmp(*this);
-        Negate(tmp);
-        if (tmp.lo < 0)
-          return (double)tmp.lo - bit64 - tmp.hi * shift64;
-        else
-          return -(double)tmp.lo - tmp.hi * shift64;
-      }
-      else if (lo < 0)
-        return -(double)lo + bit64 + hi * shift64;
-      else
-        return (double)lo + (double)hi * shift64;
-    }
-
-    //for bug testing ...
-    std::string AsString() const
-    {
-      std::string result;
-      unsigned char r = 0;
-      Int128 tmp(0), val(*this);
-      if (hi < 0) Negate(val);
-      result.resize(50);
-      std::string::size_type i = result.size() -1;
-      while (val.hi != 0 || val.lo != 0)
-      {
-        Div10(val, tmp, r);
-        result[i--] = char('0' + r);
-        val = tmp;
-      }
-      if (hi < 0) result[i--] = '-';
-      result.erase(0,i+1);
-      if (result.size() == 0) result = "0";
-      return result;
-    }
-
-private:
-    long64 hi;
-    long64 lo;
-
-    static void Negate(Int128 &val)
-    {
-      if (val.lo == 0)
-      {
-        if( val.hi == 0) return;
-        val.lo = ~val.lo;
-        val.hi = ~val.hi +1;
-      }
-      else
-      {
-        val.lo = ~val.lo +1;
-        val.hi = ~val.hi;
-      }
-    }
-
-    //debugging only ...
-    void Div10(const Int128 val, Int128& result, unsigned char & remainder) const
-    {
-      remainder = 0;
-      result = 0;
-      for (int i = 63; i >= 0; --i)
-      {
-        if ((val.hi & ((long64)1 << i)) != 0)
-          remainder = char((remainder * 2) + 1); else
-          remainder *= char(2);
-        if (remainder >= 10)
-        {
-          result.hi += ((long64)1 << i);
-          remainder -= char(10);
-        }
-      }
-      for (int i = 63; i >= 0; --i)
-      {
-        if ((val.lo & ((long64)1 << i)) != 0)
-          remainder = char((remainder * 2) + 1); else
-          remainder *= char(2);
-        if (remainder >= 10)
-        {
-          result.lo += ((long64)1 << i);
-          remainder -= char(10);
-        }
-      }
-    }
-};
-
-//------------------------------------------------------------------------------
-//------------------------------------------------------------------------------
-
-RangeTest TestRange(const Polygon &pts)
-{
-  RangeTest result = rtLo;
-  for (Polygon::size_type i = 0; i <  pts.size(); ++i)
-  {
-    if (Abs(pts[i].X) > hiRange || Abs(pts[i].Y) > hiRange)
-        return rtError;
-      else if (Abs(pts[i].X) > loRange || Abs(pts[i].Y) > loRange)
-        result = rtHi;
-  }
-  return result;
-}
-//------------------------------------------------------------------------------
-
-bool Orientation(const Polygon &poly)
-{
-  int highI = (int)poly.size() -1;
-  if (highI < 2) return false;
-  bool UseFullInt64Range = false;
-
-  int j = 0, jplus, jminus;
-  for (int i = 0; i <= highI; ++i)
-  {
-    if (Abs(poly[i].X) > hiRange || Abs(poly[i].Y) > hiRange)
-    throw "Coordinate exceeds range bounds.";
-    if (Abs(poly[i].X) > loRange || Abs(poly[i].Y) > loRange)
-    UseFullInt64Range = true;
-    if (poly[i].Y < poly[j].Y) continue;
-    if ((poly[i].Y > poly[j].Y || poly[i].X < poly[j].X)) j = i;
-  };
-  if (j == highI) jplus = 0;
-  else jplus = j +1;
-  if (j == 0) jminus = highI;
-  else jminus = j -1;
-
-  IntPoint vec1, vec2;
-  //get cross product of vectors of the edges adjacent to highest point ...
-  vec1.X = poly[j].X - poly[jminus].X;
-  vec1.Y = poly[j].Y - poly[jminus].Y;
-  vec2.X = poly[jplus].X - poly[j].X;
-  vec2.Y = poly[jplus].Y - poly[j].Y;
-
-  if (UseFullInt64Range)
-  {
-    Int128 cross = Int128(vec1.X) * Int128(vec2.Y) -
-      Int128(vec2.X) * Int128(vec1.Y);
-    return cross > 0;
-  }
-  else
-  {
-    return (vec1.X * vec2.Y - vec2.X * vec1.Y) > 0;
-  }
-}
-//------------------------------------------------------------------------------
-
-bool Orientation(OutRec *outRec, bool UseFullInt64Range)
-{
-  OutPt *opBottom = outRec->pts, *op = outRec->pts->next;
-  while (op != outRec->pts)
-  {
-    if (op->pt.Y >= opBottom->pt.Y)
-    {
-      if (op->pt.Y > opBottom->pt.Y || op->pt.X < opBottom->pt.X)
-      opBottom = op;
-    }
-    op = op->next;
-  }
-
-  IntPoint vec1, vec2;
-  vec1.X = op->pt.X - op->prev->pt.X;
-  vec1.Y = op->pt.Y - op->prev->pt.Y;
-  vec2.X = op->next->pt.X - op->pt.X;
-  vec2.Y = op->next->pt.Y - op->pt.Y;
-
-  if (UseFullInt64Range)
-  {
-    Int128 cross = Int128(vec1.X) * Int128(vec2.Y) - Int128(vec2.X) * Int128(vec1.Y);
-    return cross > 0;
-  }
-  else
-  {
-    return (vec1.X * vec2.Y - vec2.X * vec1.Y) > 0;
-  }
-}
-//------------------------------------------------------------------------------
-
-inline bool PointsEqual( const IntPoint &pt1, const IntPoint &pt2)
-{
-  return ( pt1.X == pt2.X && pt1.Y == pt2.Y );
-}
-//------------------------------------------------------------------------------
-
-double Area(const Polygon &poly)
-{
-  int highI = (int)poly.size() -1;
-  if (highI < 2) return 0;
-  bool UseFullInt64Range;
-  RangeTest rt = TestRange(poly);
-  switch (rt) {
-    case rtLo:
-      UseFullInt64Range = false;
-      break;
-    case rtHi:
-      UseFullInt64Range = true;
-      break;
-    default:
-      throw "Coordinate exceeds range bounds.";
-  }
-
-  if (UseFullInt64Range) {
-    Int128 a(0);
-    a = (Int128(poly[highI].X) * Int128(poly[0].Y)) -
-      Int128(poly[0].X) * Int128(poly[highI].Y);
-    for (int i = 0; i < highI; ++i)
-      a += Int128(poly[i].X) * Int128(poly[i+1].Y) -
-        Int128(poly[i+1].X) * Int128(poly[i].Y);
-    return a.AsDouble() / 2;
-  }
-  else
-  {
-    double a;
-    a = (double)poly[highI].X * poly[0].Y - (double)poly[0].X * poly[highI].Y;
-    for (int i = 0; i < highI; ++i)
-      a += (double)poly[i].X * poly[i+1].Y - (double)poly[i+1].X * poly[i].Y;
-    return a/2;
-  }
-}
-//------------------------------------------------------------------------------
-
-bool PointIsVertex(const IntPoint &pt, OutPt *pp)
-{
-  OutPt *pp2 = pp;
-  do
-  {
-    if (PointsEqual(pp2->pt, pt)) return true;
-    pp2 = pp2->next;
-  }
-  while (pp2 != pp);
-  return false;
-}
-//------------------------------------------------------------------------------
-
-bool PointInPolygon(const IntPoint &pt, OutPt *pp, bool UseFullInt64Range)
-{
-  OutPt *pp2 = pp;
-  bool result = false;
-  if (UseFullInt64Range) {
-    do
-    {
-      if ((((pp2->pt.Y <= pt.Y) && (pt.Y < pp2->prev->pt.Y)) ||
-          ((pp2->prev->pt.Y <= pt.Y) && (pt.Y < pp2->pt.Y))) &&
-          Int128(pt.X - pp2->pt.X) < (Int128(pp2->prev->pt.X - pp2->pt.X) *
-          Int128(pt.Y - pp2->pt.Y)) / Int128(pp2->prev->pt.Y - pp2->pt.Y))
-            result = !result;
-      pp2 = pp2->next;
-    }
-    while (pp2 != pp);
-  }
-  else
-  {
-    do
-    {
-      if ((((pp2->pt.Y <= pt.Y) && (pt.Y < pp2->prev->pt.Y)) ||
-        ((pp2->prev->pt.Y <= pt.Y) && (pt.Y < pp2->pt.Y))) &&
-        (pt.X < (pp2->prev->pt.X - pp2->pt.X) * (pt.Y - pp2->pt.Y) /
-        (pp2->prev->pt.Y - pp2->pt.Y) + pp2->pt.X )) result = !result;
-      pp2 = pp2->next;
-    }
-    while (pp2 != pp);
-  }
-  return result;
-}
-//------------------------------------------------------------------------------
-
-bool SlopesEqual(TEdge &e1, TEdge &e2, bool UseFullInt64Range)
-{
-  if (e1.ybot == e1.ytop) return (e2.ybot == e2.ytop);
-  else if (e1.xbot == e1.xtop) return (e2.xbot == e2.xtop);
-  else if (UseFullInt64Range)
-    return Int128(e1.ytop - e1.ybot) * Int128(e2.xtop - e2.xbot) ==
-      Int128(e1.xtop - e1.xbot) * Int128(e2.ytop - e2.ybot);
-  else return (e1.ytop - e1.ybot)*(e2.xtop - e2.xbot) ==
-      (e1.xtop - e1.xbot)*(e2.ytop - e2.ybot);
-}
-//------------------------------------------------------------------------------
-
-bool SlopesEqual(const IntPoint pt1, const IntPoint pt2,
-  const IntPoint pt3, bool UseFullInt64Range)
-{
-  if (pt1.Y == pt2.Y) return (pt2.Y == pt3.Y);
-  else if (pt1.X == pt2.X) return (pt2.X == pt3.X);
-  else if (UseFullInt64Range)
-    return Int128(pt1.Y-pt2.Y) * Int128(pt2.X-pt3.X) ==
-      Int128(pt1.X-pt2.X) * Int128(pt2.Y-pt3.Y);
-  else return (pt1.Y-pt2.Y)*(pt2.X-pt3.X) == (pt1.X-pt2.X)*(pt2.Y-pt3.Y);
-}
-//------------------------------------------------------------------------------
-
-bool SlopesEqual(const IntPoint pt1, const IntPoint pt2,
-  const IntPoint pt3, const IntPoint pt4, bool UseFullInt64Range)
-{
-  if (pt1.Y == pt2.Y) return (pt3.Y == pt4.Y);
-  else if (pt1.X == pt2.X) return (pt3.X == pt4.X);
-  else if (UseFullInt64Range)
-    return Int128(pt1.Y-pt2.Y) * Int128(pt3.X-pt4.X) ==
-      Int128(pt1.X-pt2.X) * Int128(pt3.Y-pt4.Y);
-  else return (pt1.Y-pt2.Y)*(pt3.X-pt4.X) == (pt1.X-pt2.X)*(pt3.Y-pt4.Y);
-}
-//------------------------------------------------------------------------------
-
-double GetDx(const IntPoint pt1, const IntPoint pt2)
-{
-  if (pt1.Y == pt2.Y) return HORIZONTAL;
-  else return
-    (double)(pt2.X - pt1.X) / (double)(pt2.Y - pt1.Y);
-}
-//---------------------------------------------------------------------------
-
-void SetDx(TEdge &e)
-{
-  if (e.ybot == e.ytop) e.dx = HORIZONTAL;
-  else e.dx =
-    (double)(e.xtop - e.xbot) / (double)(e.ytop - e.ybot);
-}
-//---------------------------------------------------------------------------
-
-void SwapSides(TEdge &edge1, TEdge &edge2)
-{
-  EdgeSide side =  edge1.side;
-  edge1.side = edge2.side;
-  edge2.side = side;
-}
-//------------------------------------------------------------------------------
-
-void SwapPolyIndexes(TEdge &edge1, TEdge &edge2)
-{
-  int outIdx =  edge1.outIdx;
-  edge1.outIdx = edge2.outIdx;
-  edge2.outIdx = outIdx;
-}
-//------------------------------------------------------------------------------
-
-inline long64 Round(double val)
-{
-  if ((val < 0)) return static_cast<long64>(val - 0.5);
-  else return static_cast<long64>(val + 0.5);
-}
-//------------------------------------------------------------------------------
-
-long64 TopX(TEdge &edge, const long64 currentY)
-{
-  if( currentY == edge.ytop ) return edge.xtop;
-  return edge.xbot + Round(edge.dx *(currentY - edge.ybot));
-}
-//------------------------------------------------------------------------------
-
-long64 TopX(const IntPoint pt1, const IntPoint pt2, const long64 currentY)
-{
-  //preconditions: pt1.Y <> pt2.Y and pt1.Y > pt2.Y
-  if (currentY >= pt1.Y) return pt1.X;
-  else if (currentY == pt2.Y) return pt2.X;
-  else if (pt1.X == pt2.X) return pt1.X;
-  else
-  {
-    double q = (double)(pt1.X-pt2.X)/(double)(pt1.Y-pt2.Y);
-    return Round(pt1.X + (currentY - pt1.Y) *q);
-  }
-}
-//------------------------------------------------------------------------------
-
-bool IntersectPoint(TEdge &edge1, TEdge &edge2,
-  IntPoint &ip, bool UseFullInt64Range)
-{
-  double b1, b2;
-  if (SlopesEqual(edge1, edge2, UseFullInt64Range)) return false;
-  else if (NEAR_ZERO(edge1.dx))
-  {
-    ip.X = edge1.xbot;
-    if (NEAR_EQUAL(edge2.dx, HORIZONTAL))
-    {
-      ip.Y = edge2.ybot;
-    } else
-    {
-      b2 = edge2.ybot - (edge2.xbot/edge2.dx);
-      ip.Y = Round(ip.X/edge2.dx + b2);
-    }
-  }
-  else if (NEAR_ZERO(edge2.dx))
-  {
-    ip.X = edge2.xbot;
-    if (NEAR_EQUAL(edge1.dx, HORIZONTAL))
-    {
-      ip.Y = edge1.ybot;
-    } else
-    {
-      b1 = edge1.ybot - (edge1.xbot/edge1.dx);
-      ip.Y = Round(ip.X/edge1.dx + b1);
-    }
-  } else
-  {
-    b1 = edge1.xbot - edge1.ybot * edge1.dx;
-    b2 = edge2.xbot - edge2.ybot * edge2.dx;
-    b2 = (b2-b1)/(edge1.dx - edge2.dx);
-    ip.Y = Round(b2);
-    ip.X = Round(edge1.dx * b2 + b1);
-  }
-
-  return
-    //can be *so close* to the top of one edge that the rounded Y equals one ytop ...
-    (ip.Y == edge1.ytop && ip.Y >= edge2.ytop && edge1.tmpX > edge2.tmpX) ||
-    (ip.Y == edge2.ytop && ip.Y >= edge1.ytop && edge1.tmpX > edge2.tmpX) ||
-    (ip.Y > edge1.ytop && ip.Y > edge2.ytop);
-}
-//------------------------------------------------------------------------------
-
-void ReversePolyPtLinks(OutPt &pp)
-{
-  OutPt *pp1, *pp2;
-  pp1 = &pp;
-  do {
-  pp2 = pp1->next;
-  pp1->next = pp1->prev;
-  pp1->prev = pp2;
-  pp1 = pp2;
-  } while( pp1 != &pp );
-}
-//------------------------------------------------------------------------------
-
-void DisposeOutPts(OutPt*& pp)
-{
-  if (pp == 0) return;
-  pp->prev->next = 0;
-  while( pp )
-  {
-    OutPt *tmpPp = pp;
-    pp = pp->next;
-    delete tmpPp ;
-  }
-}
-//------------------------------------------------------------------------------
-
-void InitEdge(TEdge *e, TEdge *eNext,
-  TEdge *ePrev, const IntPoint &pt, PolyType polyType)
-{
-  std::memset( e, 0, sizeof( TEdge ));
-
-  e->next = eNext;
-  e->prev = ePrev;
-  e->xcurr = pt.X;
-  e->ycurr = pt.Y;
-  if (e->ycurr >= e->next->ycurr)
-  {
-    e->xbot = e->xcurr;
-    e->ybot = e->ycurr;
-    e->xtop = e->next->xcurr;
-    e->ytop = e->next->ycurr;
-    e->windDelta = 1;
-  } else
-  {
-    e->xtop = e->xcurr;
-    e->ytop = e->ycurr;
-    e->xbot = e->next->xcurr;
-    e->ybot = e->next->ycurr;
-    e->windDelta = -1;
-  }
-  SetDx(*e);
-  e->polyType = polyType;
-  e->outIdx = -1;
-}
-//------------------------------------------------------------------------------
-
-inline void SwapX(TEdge &e)
-{
-  //swap horizontal edges' top and bottom x's so they follow the natural
-  //progression of the bounds - ie so their xbots will align with the
-  //adjoining lower edge. [Helpful in the ProcessHorizontal() method.]
-  e.xcurr = e.xtop;
-  e.xtop = e.xbot;
-  e.xbot = e.xcurr;
-}
-//------------------------------------------------------------------------------
-
-void SwapPoints(IntPoint &pt1, IntPoint &pt2)
-{
-  IntPoint tmp = pt1;
-  pt1 = pt2;
-  pt2 = tmp;
-}
-//------------------------------------------------------------------------------
-
-bool GetOverlapSegment(IntPoint pt1a, IntPoint pt1b, IntPoint pt2a,
-  IntPoint pt2b, IntPoint &pt1, IntPoint &pt2)
-{
-  //precondition: segments are colinear.
-  if ( pt1a.Y == pt1b.Y || Abs((pt1a.X - pt1b.X)/(pt1a.Y - pt1b.Y)) > 1 )
-  {
-    if (pt1a.X > pt1b.X) SwapPoints(pt1a, pt1b);
-    if (pt2a.X > pt2b.X) SwapPoints(pt2a, pt2b);
-    if (pt1a.X > pt2a.X) pt1 = pt1a; else pt1 = pt2a;
-    if (pt1b.X < pt2b.X) pt2 = pt1b; else pt2 = pt2b;
-    return pt1.X < pt2.X;
-  } else
-  {
-    if (pt1a.Y < pt1b.Y) SwapPoints(pt1a, pt1b);
-    if (pt2a.Y < pt2b.Y) SwapPoints(pt2a, pt2b);
-    if (pt1a.Y < pt2a.Y) pt1 = pt1a; else pt1 = pt2a;
-    if (pt1b.Y > pt2b.Y) pt2 = pt1b; else pt2 = pt2b;
-    return pt1.Y > pt2.Y;
-  }
-}
-//------------------------------------------------------------------------------
-
-OutPt* PolygonBottom(OutPt* pp)
-{
-  OutPt* p = pp->next;
-  OutPt* result = pp;
-  while (p != pp)
-  {
-    if (p->pt.Y > result->pt.Y) result = p;
-    else if (p->pt.Y == result->pt.Y && p->pt.X < result->pt.X) result = p;
-    p = p->next;
-  }
-  return result;
-}
-//------------------------------------------------------------------------------
-
-bool FindSegment(OutPt* &pp, IntPoint &pt1, IntPoint &pt2)
-{
-  //outPt1 & outPt2 => the overlap segment (if the function returns true)
-  if (!pp) return false;
-  OutPt* pp2 = pp;
-  IntPoint pt1a = pt1, pt2a = pt2;
-  do
-  {
-    if (SlopesEqual(pt1a, pt2a, pp->pt, pp->prev->pt, true) &&
-      SlopesEqual(pt1a, pt2a, pp->pt, true) &&
-      GetOverlapSegment(pt1a, pt2a, pp->pt, pp->prev->pt, pt1, pt2))
-        return true;
-    pp = pp->next;
-  }
-  while (pp != pp2);
-  return false;
-}
-//------------------------------------------------------------------------------
-
-bool Pt3IsBetweenPt1AndPt2(const IntPoint pt1,
-  const IntPoint pt2, const IntPoint pt3)
-{
-  if (PointsEqual(pt1, pt3) || PointsEqual(pt2, pt3)) return true;
-  else if (pt1.X != pt2.X) return (pt1.X < pt3.X) == (pt3.X < pt2.X);
-  else return (pt1.Y < pt3.Y) == (pt3.Y < pt2.Y);
-}
-//------------------------------------------------------------------------------
-
-OutPt* InsertPolyPtBetween(OutPt* p1, OutPt* p2, const IntPoint pt)
-{
-  if (p1 == p2) throw "JoinError";
-  OutPt* result = new OutPt;
-  result->pt = pt;
-  if (p2 == p1->next)
-  {
-    p1->next = result;
-    p2->prev = result;
-    result->next = p2;
-    result->prev = p1;
-  } else
-  {
-    p2->next = result;
-    p1->prev = result;
-    result->next = p1;
-    result->prev = p2;
-  }
-  return result;
-}
-
-//------------------------------------------------------------------------------
-// ClipperBase class methods ...
-//------------------------------------------------------------------------------
-
-ClipperBase::ClipperBase() //constructor
-{
-  m_MinimaList = 0;
-  m_CurrentLM = 0;
-  m_UseFullRange = true;
-}
-//------------------------------------------------------------------------------
-
-ClipperBase::~ClipperBase() //destructor
-{
-  Clear();
-}
-//------------------------------------------------------------------------------
-
-bool ClipperBase::AddPolygon( const Polygon &pg, PolyType polyType)
-{
-  int len = (int)pg.size();
-  if (len < 3) return false;
-  Polygon p(len);
-  p[0] = pg[0];
-  int j = 0;
-
-  long64 maxVal;
-  if (m_UseFullRange) maxVal = hiRange; else maxVal = loRange;
-
-  for (int i = 0; i < len; ++i)
-  {
-    if (Abs(pg[i].X) > maxVal || Abs(pg[i].Y) > maxVal)
-    {
-      if (m_UseFullRange)
-        throw "Coordinate exceeds range bounds";
-      maxVal = hiRange;
-      if (Abs(pg[i].X) > maxVal || Abs(pg[i].Y) > maxVal)
-        throw "Coordinate exceeds range bounds";
-      m_UseFullRange = true;
-    }
-
-    if (i == 0 || PointsEqual(p[j], pg[i])) continue;
-    else if (j > 0 && SlopesEqual(p[j-1], p[j], pg[i], m_UseFullRange))
-    {
-      if (PointsEqual(p[j-1], pg[i])) j--;
-    } else j++;
-    p[j] = pg[i];
-  }
-  if (j < 2) return false;
-
-  len = j+1;
-  for (;;)
-  {
-    //nb: test for point equality before testing slopes ...
-    if (PointsEqual(p[j], p[0])) j--;
-    else if (PointsEqual(p[0], p[1]) ||
-      SlopesEqual(p[j], p[0], p[1], m_UseFullRange))
-      p[0] = p[j--];
-    else if (SlopesEqual(p[j-1], p[j], p[0], m_UseFullRange)) j--;
-    else if (SlopesEqual(p[0], p[1], p[2], m_UseFullRange))
-    {
-      for (int i = 2; i <= j; ++i) p[i-1] = p[i];
-      j--;
-    }
-    //exit loop if nothing is changed or there are too few vertices ...
-    if (j == len-1 || j < 2) break;
-    len = j +1;
-  }
-  // if (len < 3) return false;
-
-  //create a new edge array ...
-  TEdge *edges = new TEdge [len];
-  m_edges.push_back(edges);
-
-  //convert vertices to a double-linked-list of edges and initialize ...
-  edges[0].xcurr = p[0].X;
-  edges[0].ycurr = p[0].Y;
-  InitEdge(&edges[len-1], &edges[0], &edges[len-2], p[len-1], polyType);
-  for (int i = len-2; i > 0; --i)
-    InitEdge(&edges[i], &edges[i+1], &edges[i-1], p[i], polyType);
-  InitEdge(&edges[0], &edges[1], &edges[len-1], p[0], polyType);
-
-  //reset xcurr & ycurr and find 'eHighest' (given the Y axis coordinates
-  //increase downward so the 'highest' edge will have the smallest ytop) ...
-  TEdge *e = &edges[0];
-  TEdge *eHighest = e;
-  do
-  {
-    e->xcurr = e->xbot;
-    e->ycurr = e->ybot;
-    if (e->ytop < eHighest->ytop) eHighest = e;
-    e = e->next;
-  }
-  while ( e != &edges[0]);
-
-  //make sure eHighest is positioned so the following loop works safely ...
-  if (eHighest->windDelta > 0) eHighest = eHighest->next;
-  if (NEAR_EQUAL(eHighest->dx, HORIZONTAL)) eHighest = eHighest->next;
-
-  //finally insert each local minima ...
-  e = eHighest;
-  do {
-    e = AddBoundsToLML(e);
-  }
-  while( e != eHighest );
-  return true;
-}
-//------------------------------------------------------------------------------
-
-void ClipperBase::InsertLocalMinima(LocalMinima *newLm)
-{
-  if( ! m_MinimaList )
-  {
-    m_MinimaList = newLm;
-  }
-  else if( newLm->Y >= m_MinimaList->Y )
-  {
-    newLm->next = m_MinimaList;
-    m_MinimaList = newLm;
-  } else
-  {
-    LocalMinima* tmpLm = m_MinimaList;
-    while( tmpLm->next  && ( newLm->Y < tmpLm->next->Y ) )
-      tmpLm = tmpLm->next;
-    newLm->next = tmpLm->next;
-    tmpLm->next = newLm;
-  }
-}
-//------------------------------------------------------------------------------
-
-TEdge* ClipperBase::AddBoundsToLML(TEdge *e)
-{
-  //Starting at the top of one bound we progress to the bottom where there's
-  //a local minima. We then go to the top of the next bound. These two bounds
-  //form the left and right (or right and left) bounds of the local minima.
-  e->nextInLML = 0;
-  e = e->next;
-  for (;;)
-  {
-    if (NEAR_EQUAL(e->dx, HORIZONTAL))
-    {
-      //nb: proceed through horizontals when approaching from their right,
-      //    but break on horizontal minima if approaching from their left.
-      //    This ensures 'local minima' are always on the left of horizontals.
-      if (e->next->ytop < e->ytop && e->next->xbot > e->prev->xbot) break;
-      // coverity[copy_paste_error]
-      if (e->xtop != e->prev->xbot) SwapX(*e);
-      e->nextInLML = e->prev;
-    }
-    else if (e->ycurr == e->prev->ycurr) break;
-    else e->nextInLML = e->prev;
-    e = e->next;
-  }
-
-  //e and e.prev are now at a local minima ...
-  LocalMinima* newLm = new LocalMinima;
-  newLm->next = 0;
-  newLm->Y = e->prev->ybot;
-
-  if ( NEAR_EQUAL(e->dx, HORIZONTAL) ) //horizontal edges never start a left bound
-  {
-    if (e->xbot != e->prev->xbot) SwapX(*e);
-    newLm->leftBound = e->prev;
-    newLm->rightBound = e;
-  } else if (e->dx < e->prev->dx)
-  {
-    newLm->leftBound = e->prev;
-    newLm->rightBound = e;
-  } else
-  {
-    newLm->leftBound = e;
-    newLm->rightBound = e->prev;
-  }
-  newLm->leftBound->side = esLeft;
-  newLm->rightBound->side = esRight;
-  InsertLocalMinima( newLm );
-
-  for (;;)
-  {
-    if ( e->next->ytop == e->ytop && !NEAR_EQUAL(e->next->dx, HORIZONTAL) ) break;
-    e->nextInLML = e->next;
-    e = e->next;
-    if ( NEAR_EQUAL(e->dx, HORIZONTAL) && e->xbot != e->prev->xtop) SwapX(*e);
-  }
-  return e->next;
-}
-//------------------------------------------------------------------------------
-
-bool ClipperBase::AddPolygons(const Polygons &ppg, PolyType polyType)
-{
-  bool result = true;
-  for (Polygons::size_type i = 0; i < ppg.size(); ++i)
-    if (AddPolygon(ppg[i], polyType)) result = false;
-  return result;
-}
-//------------------------------------------------------------------------------
-
-void ClipperBase::Clear()
-{
-  DisposeLocalMinimaList();
-  for (EdgeList::size_type i = 0; i < m_edges.size(); ++i) delete [] m_edges[i];
-  m_edges.clear();
-  m_UseFullRange = false;
-}
-//------------------------------------------------------------------------------
-
-void ClipperBase::Reset()
-{
-  m_CurrentLM = m_MinimaList;
-  if( !m_CurrentLM ) return; //ie nothing to process
-
-  //reset all edges ...
-  LocalMinima* lm = m_MinimaList;
-  while( lm )
-  {
-    TEdge* e = lm->leftBound;
-    while( e )
-    {
-      e->xcurr = e->xbot;
-      e->ycurr = e->ybot;
-      e->side = esLeft;
-      e->outIdx = -1;
-      e = e->nextInLML;
-    }
-    e = lm->rightBound;
-    while( e )
-    {
-      e->xcurr = e->xbot;
-      e->ycurr = e->ybot;
-      e->side = esRight;
-      e->outIdx = -1;
-      e = e->nextInLML;
-    }
-    lm = lm->next;
-  }
-}
-//------------------------------------------------------------------------------
-
-void ClipperBase::DisposeLocalMinimaList()
-{
-  while( m_MinimaList )
-  {
-    LocalMinima* tmpLm = m_MinimaList->next;
-    delete m_MinimaList;
-    m_MinimaList = tmpLm;
-  }
-  m_CurrentLM = 0;
-}
-//------------------------------------------------------------------------------
-
-void ClipperBase::PopLocalMinima()
-{
-  if( ! m_CurrentLM ) return;
-  m_CurrentLM = m_CurrentLM->next;
-}
-//------------------------------------------------------------------------------
-
-IntRect ClipperBase::GetBounds()
-{
-  IntRect result;
-  LocalMinima* lm = m_MinimaList;
-  if (!lm)
-  {
-    result.left = result.top = result.right = result.bottom = 0;
-    return result;
-  }
-  result.left = lm->leftBound->xbot;
-  result.top = lm->leftBound->ybot;
-  result.right = lm->leftBound->xbot;
-  result.bottom = lm->leftBound->ybot;
-  while (lm)
-  {
-    if (lm->leftBound->ybot > result.bottom)
-      result.bottom = lm->leftBound->ybot;
-    TEdge* e = lm->leftBound;
-    for (;;) {
-      TEdge* bottomE = e;
-      while (e->nextInLML)
-      {
-        if (e->xbot < result.left) result.left = e->xbot;
-        if (e->xbot > result.right) result.right = e->xbot;
-        e = e->nextInLML;
-      }
-      if (e->xbot < result.left) result.left = e->xbot;
-      if (e->xbot > result.right) result.right = e->xbot;
-      if (e->xtop < result.left) result.left = e->xtop;
-      if (e->xtop > result.right) result.right = e->xtop;
-      if (e->ytop < result.top) result.top = e->ytop;
-
-      if (bottomE == lm->leftBound) e = lm->rightBound;
-      else break;
-    }
-    lm = lm->next;
-  }
-  return result;
-}
-
-
-//------------------------------------------------------------------------------
-// TClipper methods ...
-//------------------------------------------------------------------------------
-
-Clipper::Clipper() : ClipperBase() //constructor
-{
-  m_Scanbeam = 0;
-  m_ActiveEdges = 0;
-  m_SortedEdges = 0;
-  m_IntersectNodes = 0;
-  m_ExecuteLocked = false;
-  m_UseFullRange = false;
-  m_ReverseOutput = false;
-}
-//------------------------------------------------------------------------------
-
-Clipper::~Clipper() //destructor
-{
-  Clear();
-  DisposeScanbeamList();
-}
-//------------------------------------------------------------------------------
-
-void Clipper::Clear()
-{
-  if (m_edges.size() == 0) return; //avoids problems with ClipperBase destructor
-  DisposeAllPolyPts();
-  ClipperBase::Clear();
-}
-//------------------------------------------------------------------------------
-
-void Clipper::DisposeScanbeamList()
-{
-  while ( m_Scanbeam ) {
-  Scanbeam* sb2 = m_Scanbeam->next;
-  delete m_Scanbeam;
-  m_Scanbeam = sb2;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::Reset()
-{
-  ClipperBase::Reset();
-  m_Scanbeam = 0;
-  m_ActiveEdges = 0;
-  m_SortedEdges = 0;
-  LocalMinima* lm = m_MinimaList;
-  while (lm)
-  {
-    InsertScanbeam(lm->Y);
-    InsertScanbeam(lm->leftBound->ytop);
-    lm = lm->next;
-  }
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::Execute(ClipType clipType, Polygons &solution,
-    PolyFillType subjFillType, PolyFillType clipFillType)
-{
-  if( m_ExecuteLocked ) return false;
-  m_ExecuteLocked = true;
-  solution.resize(0);
-  m_SubjFillType = subjFillType;
-  m_ClipFillType = clipFillType;
-  m_ClipType = clipType;
-  bool succeeded = ExecuteInternal(false);
-  if (succeeded) BuildResult(solution);
-  m_ExecuteLocked = false;
-  return succeeded;
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::Execute(ClipType clipType, ExPolygons &solution,
-    PolyFillType subjFillType, PolyFillType clipFillType)
-{
-  if( m_ExecuteLocked ) return false;
-  m_ExecuteLocked = true;
-  solution.resize(0);
-  m_SubjFillType = subjFillType;
-  m_ClipFillType = clipFillType;
-  m_ClipType = clipType;
-  bool succeeded = ExecuteInternal(true);
-  if (succeeded) BuildResultEx(solution);
-  m_ExecuteLocked = false;
-  return succeeded;
-}
-//------------------------------------------------------------------------------
-
-bool PolySort(OutRec *or1, OutRec *or2)
-{
-  if (or1 == or2) return false;
-  if (!or1->pts || !or2->pts)
-  {
-    if (or1->pts != or2->pts)
-    {
-      if (or1->pts) return true; else return false;
-    }
-    else return false;
-  }
-  int i1, i2;
-  if (or1->isHole)
-    i1 = or1->FirstLeft->idx; else
-    i1 = or1->idx;
-  if (or2->isHole)
-    i2 = or2->FirstLeft->idx; else
-    i2 = or2->idx;
-  int result = i1 - i2;
-  if (result == 0 && (or1->isHole != or2->isHole))
-  {
-    if (or1->isHole) return false;
-    else return true;
-  }
-  else return result < 0;
-}
-//------------------------------------------------------------------------------
-
-OutRec* FindAppendLinkEnd(OutRec *outRec)
-{
-  while (outRec->AppendLink) outRec = outRec->AppendLink;
-  return outRec;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::FixHoleLinkage(OutRec *outRec)
-{
-  OutRec *tmp;
-  if (outRec->bottomPt)
-    tmp = m_PolyOuts[outRec->bottomPt->idx]->FirstLeft;
-  else
-    tmp = outRec->FirstLeft;
-  if (outRec == tmp) throw clipperException("HoleLinkage error");
-
-  if (tmp)
-  {
-    if (tmp->AppendLink) tmp = FindAppendLinkEnd(tmp);
-    if (tmp == outRec) tmp = 0;
-    else if (tmp->isHole)
-    {
-      FixHoleLinkage(tmp);
-      tmp = tmp->FirstLeft;
-    }
-  }
-  outRec->FirstLeft = tmp;
-  if (!tmp) outRec->isHole = false;
-  outRec->AppendLink = 0;
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::ExecuteInternal(bool fixHoleLinkages)
-{
-  bool succeeded;
-  try {
-    Reset();
-    if (!m_CurrentLM ) return true;
-    long64 botY = PopScanbeam();
-    do {
-      InsertLocalMinimaIntoAEL(botY);
-      ClearHorzJoins();
-      ProcessHorizontals();
-      long64 topY = PopScanbeam();
-      succeeded = ProcessIntersections(botY, topY);
-      if (!succeeded) break;
-      ProcessEdgesAtTopOfScanbeam(topY);
-      botY = topY;
-    } while( m_Scanbeam );
-  }
-  catch(...) {
-    succeeded = false;
-  }
-
-  if (succeeded)
-  {
-    //tidy up output polygons and fix orientations where necessary ...
-    for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
-    {
-      OutRec *outRec = m_PolyOuts[i];
-      if (!outRec->pts) continue;
-      FixupOutPolygon(*outRec);
-      if (!outRec->pts) continue;
-      if (outRec->isHole && fixHoleLinkages) FixHoleLinkage(outRec);
-      if (outRec->isHole ==
-        (m_ReverseOutput ^ Orientation(outRec, m_UseFullRange)))
-          ReversePolyPtLinks(*outRec->pts);
-    }
-
-    JoinCommonEdges(fixHoleLinkages);
-    if (fixHoleLinkages)
-      std::sort(m_PolyOuts.begin(), m_PolyOuts.end(), PolySort);
-  }
-
-  ClearJoins();
-  ClearHorzJoins();
-  return succeeded;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::InsertScanbeam(const long64 Y)
-{
-  if( !m_Scanbeam )
-  {
-    m_Scanbeam = new Scanbeam;
-    m_Scanbeam->next = 0;
-    m_Scanbeam->Y = Y;
-  }
-  else if(  Y > m_Scanbeam->Y )
-  {
-    Scanbeam* newSb = new Scanbeam;
-    newSb->Y = Y;
-    newSb->next = m_Scanbeam;
-    m_Scanbeam = newSb;
-  } else
-  {
-    Scanbeam* sb2 = m_Scanbeam;
-    while( sb2->next  && ( Y <= sb2->next->Y ) ) sb2 = sb2->next;
-    if(  Y == sb2->Y ) return; //ie ignores duplicates
-    Scanbeam* newSb = new Scanbeam;
-    newSb->Y = Y;
-    newSb->next = sb2->next;
-    sb2->next = newSb;
-  }
-}
-//------------------------------------------------------------------------------
-
-long64 Clipper::PopScanbeam()
-{
-  long64 Y = m_Scanbeam->Y;
-  Scanbeam* sb2 = m_Scanbeam;
-  m_Scanbeam = m_Scanbeam->next;
-  delete sb2;
-  return Y;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::DisposeAllPolyPts(){
-  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
-    DisposeOutRec(i);
-  m_PolyOuts.clear();
-}
-//------------------------------------------------------------------------------
-
-void Clipper::DisposeOutRec(PolyOutList::size_type index, bool ignorePts)
-{
-  OutRec *outRec = m_PolyOuts[index];
-  if (!ignorePts && outRec->pts) DisposeOutPts(outRec->pts);
-  delete outRec;
-  m_PolyOuts[index] = 0;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::SetWindingCount(TEdge &edge)
-{
-  TEdge *e = edge.prevInAEL;
-  //find the edge of the same polytype that immediately preceeds 'edge' in AEL
-  while ( e  && e->polyType != edge.polyType ) e = e->prevInAEL;
-  if ( !e )
-  {
-    edge.windCnt = edge.windDelta;
-    edge.windCnt2 = 0;
-    e = m_ActiveEdges; //ie get ready to calc windCnt2
-  } else if ( IsEvenOddFillType(edge) )
-  {
-    //EvenOdd filling ...
-    edge.windCnt = 1;
-    edge.windCnt2 = e->windCnt2;
-    e = e->nextInAEL; //ie get ready to calc windCnt2
-  } else
-  {
-    //nonZero, Positive or Negative filling ...
-    if ( e->windCnt * e->windDelta < 0 )
-    {
-      if (Abs(e->windCnt) > 1)
-      {
-        if (e->windDelta * edge.windDelta < 0) edge.windCnt = e->windCnt;
-        else edge.windCnt = e->windCnt + edge.windDelta;
-      } else
-        edge.windCnt = e->windCnt + e->windDelta + edge.windDelta;
-    } else
-    {
-      if ( Abs(e->windCnt) > 1 && e->windDelta * edge.windDelta < 0)
-        edge.windCnt = e->windCnt;
-      else if ( e->windCnt + edge.windDelta == 0 )
-        edge.windCnt = e->windCnt;
-      else edge.windCnt = e->windCnt + edge.windDelta;
-    }
-    edge.windCnt2 = e->windCnt2;
-    e = e->nextInAEL; //ie get ready to calc windCnt2
-  }
-
-  //update windCnt2 ...
-  if ( IsEvenOddAltFillType(edge) )
-  {
-    //EvenOdd filling ...
-    while ( e != &edge )
-    {
-      edge.windCnt2 = (edge.windCnt2 == 0) ? 1 : 0;
-      e = e->nextInAEL;
-    }
-  } else
-  {
-    //nonZero, Positive or Negative filling ...
-    while ( e != &edge )
-    {
-      edge.windCnt2 += e->windDelta;
-      e = e->nextInAEL;
-    }
-  }
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::IsEvenOddFillType(const TEdge& edge) const
-{
-  if (edge.polyType == ptSubject)
-    return m_SubjFillType == pftEvenOdd; else
-    return m_ClipFillType == pftEvenOdd;
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::IsEvenOddAltFillType(const TEdge& edge) const
-{
-  if (edge.polyType == ptSubject)
-    return m_ClipFillType == pftEvenOdd; else
-    return m_SubjFillType == pftEvenOdd;
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::IsContributing(const TEdge& edge) const
-{
-  PolyFillType pft, pft2;
-  if (edge.polyType == ptSubject)
-  {
-    pft = m_SubjFillType;
-    pft2 = m_ClipFillType;
-  } else
-  {
-    pft = m_ClipFillType;
-    pft2 = m_SubjFillType;
-  }
-
-  switch(pft)
-  {
-    case pftEvenOdd: 
-    case pftNonZero:
-      if (Abs(edge.windCnt) != 1) return false;
-      break;
-    case pftPositive: 
-      if (edge.windCnt != 1) return false;
-      break;
-    default: //pftNegative
-      if (edge.windCnt != -1) return false;
-  }
-
-  switch(m_ClipType)
-  {
-    case ctIntersection:
-      switch(pft2)
-      {
-        case pftEvenOdd: 
-        case pftNonZero: 
-          return (edge.windCnt2 != 0);
-        case pftPositive: 
-          return (edge.windCnt2 > 0);
-        default: 
-          return (edge.windCnt2 < 0);
-      }
-    case ctUnion:
-      switch(pft2)
-      {
-        case pftEvenOdd: 
-        case pftNonZero: 
-          return (edge.windCnt2 == 0);
-        case pftPositive: 
-          return (edge.windCnt2 <= 0);
-        default: 
-          return (edge.windCnt2 >= 0);
-      }
-    case ctDifference:
-      if (edge.polyType == ptSubject)
-        switch(pft2)
-        {
-          case pftEvenOdd: 
-          case pftNonZero: 
-            return (edge.windCnt2 == 0);
-          case pftPositive: 
-            return (edge.windCnt2 <= 0);
-          default: 
-            return (edge.windCnt2 >= 0);
-        }
-      else
-        switch(pft2)
-        {
-          case pftEvenOdd: 
-          case pftNonZero: 
-            return (edge.windCnt2 != 0);
-          case pftPositive: 
-            return (edge.windCnt2 > 0);
-          default: 
-            return (edge.windCnt2 < 0);
-        }
-    default:
-      return true;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AddLocalMinPoly(TEdge *e1, TEdge *e2, const IntPoint &pt)
-{
-  if( NEAR_EQUAL(e2->dx, HORIZONTAL) || ( e1->dx > e2->dx ) )
-  {
-    AddOutPt( e1, e2, pt );
-    e2->outIdx = e1->outIdx;
-    e1->side = esLeft;
-    e2->side = esRight;
-  } else
-  {
-    AddOutPt( e2, e1, pt );
-    e1->outIdx = e2->outIdx;
-    e1->side = esRight;
-    e2->side = esLeft;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AddLocalMaxPoly(TEdge *e1, TEdge *e2, const IntPoint &pt)
-{
-  AddOutPt( e1, 0, pt );
-  if( e1->outIdx == e2->outIdx )
-  {
-    e1->outIdx = -1;
-    e2->outIdx = -1;
-  }
-  else
-    AppendPolygon( e1, e2 );
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AddEdgeToSEL(TEdge *edge)
-{
-  //SEL pointers in PEdge are reused to build a list of horizontal edges.
-  //However, we don't need to worry about order with horizontal edge processing.
-  if( !m_SortedEdges )
-  {
-    m_SortedEdges = edge;
-    edge->prevInSEL = 0;
-    edge->nextInSEL = 0;
-  }
-  else
-  {
-    edge->nextInSEL = m_SortedEdges;
-    edge->prevInSEL = 0;
-    m_SortedEdges->prevInSEL = edge;
-    m_SortedEdges = edge;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::CopyAELToSEL()
-{
-  TEdge* e = m_ActiveEdges;
-  m_SortedEdges = e;
-  if (!m_ActiveEdges) return;
-  m_SortedEdges->prevInSEL = 0;
-  e = e->nextInAEL;
-  while ( e )
-  {
-    e->prevInSEL = e->prevInAEL;
-    e->prevInSEL->nextInSEL = e;
-    e->nextInSEL = 0;
-    e = e->nextInAEL;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AddJoin(TEdge *e1, TEdge *e2, int e1OutIdx, int e2OutIdx)
-{
-  JoinRec* jr = new JoinRec;
-  if (e1OutIdx >= 0)
-    jr->poly1Idx = e1OutIdx; else
-    jr->poly1Idx = e1->outIdx;
-  jr->pt1a = IntPoint(e1->xcurr, e1->ycurr);
-  jr->pt1b = IntPoint(e1->xtop, e1->ytop);
-  if (e2OutIdx >= 0)
-    jr->poly2Idx = e2OutIdx; else
-    jr->poly2Idx = e2->outIdx;
-  jr->pt2a = IntPoint(e2->xcurr, e2->ycurr);
-  jr->pt2b = IntPoint(e2->xtop, e2->ytop);
-  m_Joins.push_back(jr);
-}
-//------------------------------------------------------------------------------
-
-void Clipper::ClearJoins()
-{
-  for (JoinList::size_type i = 0; i < m_Joins.size(); i++)
-    delete m_Joins[i];
-  m_Joins.resize(0);
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AddHorzJoin(TEdge *e, int idx)
-{
-  HorzJoinRec* hj = new HorzJoinRec;
-  hj->edge = e;
-  hj->savedIdx = idx;
-  m_HorizJoins.push_back(hj);
-}
-//------------------------------------------------------------------------------
-
-void Clipper::ClearHorzJoins()
-{
-  for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); i++)
-    delete m_HorizJoins[i];
-  m_HorizJoins.resize(0);
-}
-//------------------------------------------------------------------------------
-
-void Clipper::InsertLocalMinimaIntoAEL( const long64 botY)
-{
-  while(  m_CurrentLM  && ( m_CurrentLM->Y == botY ) )
-  {
-    TEdge* lb = m_CurrentLM->leftBound;
-    TEdge* rb = m_CurrentLM->rightBound;
-
-    InsertEdgeIntoAEL( lb );
-    InsertScanbeam( lb->ytop );
-    InsertEdgeIntoAEL( rb );
-
-    if (IsEvenOddFillType(*lb))
-    {
-      lb->windDelta = 1;
-      rb->windDelta = 1;
-    }
-    else
-    {
-      rb->windDelta = -lb->windDelta;
-    }
-    SetWindingCount( *lb );
-    rb->windCnt = lb->windCnt;
-    rb->windCnt2 = lb->windCnt2;
-
-    if( NEAR_EQUAL(rb->dx, HORIZONTAL) )
-    {
-      //nb: only rightbounds can have a horizontal bottom edge
-      AddEdgeToSEL( rb );
-      InsertScanbeam( rb->nextInLML->ytop );
-    }
-    else
-      InsertScanbeam( rb->ytop );
-
-    if( IsContributing(*lb) )
-      AddLocalMinPoly( lb, rb, IntPoint(lb->xcurr, m_CurrentLM->Y) );
-
-    //if output polygons share an edge, they'll need joining later ...
-    if (lb->outIdx >= 0 && lb->prevInAEL &&
-      lb->prevInAEL->outIdx >= 0 && lb->prevInAEL->xcurr == lb->xbot &&
-       SlopesEqual(*lb, *lb->prevInAEL, m_UseFullRange))
-         AddJoin(lb, lb->prevInAEL);
-
-    //if any output polygons share an edge, they'll need joining later ...
-    if (rb->outIdx >= 0)
-    {
-      if (NEAR_EQUAL(rb->dx, HORIZONTAL))
-      {
-        for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); ++i)
-        {
-          IntPoint pt, pt2; //returned by GetOverlapSegment() but unused here.
-          HorzJoinRec* hj = m_HorizJoins[i];
-          //if horizontals rb and hj.edge overlap, flag for joining later ...
-          if (GetOverlapSegment(IntPoint(hj->edge->xbot, hj->edge->ybot),
-            IntPoint(hj->edge->xtop, hj->edge->ytop),
-            IntPoint(rb->xbot, rb->ybot),
-            IntPoint(rb->xtop, rb->ytop), pt, pt2))
-              AddJoin(hj->edge, rb, hj->savedIdx);
-        }
-      }
-    }
-
-    if( lb->nextInAEL != rb )
-    {
-      if (rb->outIdx >= 0 && rb->prevInAEL->outIdx >= 0 &&
-        SlopesEqual(*rb->prevInAEL, *rb, m_UseFullRange))
-          AddJoin(rb, rb->prevInAEL);
-
-      TEdge* e = lb->nextInAEL;
-      IntPoint pt = IntPoint(lb->xcurr, lb->ycurr);
-      while( e != rb )
-      {
-        if(!e) throw clipperException("InsertLocalMinimaIntoAEL: missing rightbound!");
-        //nb: For calculating winding counts etc, IntersectEdges() assumes
-        //that param1 will be to the right of param2 ABOVE the intersection ...
-        IntersectEdges( rb , e , pt , ipNone); //order important here
-        e = e->nextInAEL;
-      }
-    }
-    PopLocalMinima();
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::DeleteFromAEL(TEdge *e)
-{
-  TEdge* AelPrev = e->prevInAEL;
-  TEdge* AelNext = e->nextInAEL;
-  if(  !AelPrev &&  !AelNext && (e != m_ActiveEdges) ) return; //already deleted
-  if( AelPrev ) AelPrev->nextInAEL = AelNext;
-  else m_ActiveEdges = AelNext;
-  if( AelNext ) AelNext->prevInAEL = AelPrev;
-  e->nextInAEL = 0;
-  e->prevInAEL = 0;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::DeleteFromSEL(TEdge *e)
-{
-  TEdge* SelPrev = e->prevInSEL;
-  TEdge* SelNext = e->nextInSEL;
-  if( !SelPrev &&  !SelNext && (e != m_SortedEdges) ) return; //already deleted
-  if( SelPrev ) SelPrev->nextInSEL = SelNext;
-  else m_SortedEdges = SelNext;
-  if( SelNext ) SelNext->prevInSEL = SelPrev;
-  e->nextInSEL = 0;
-  e->prevInSEL = 0;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::IntersectEdges(TEdge *e1, TEdge *e2,
-     const IntPoint &pt, IntersectProtects protects)
-{
-  //e1 will be to the left of e2 BELOW the intersection. Therefore e1 is before
-  //e2 in AEL except when e1 is being inserted at the intersection point ...
-  bool e1stops = !(ipLeft & protects) &&  !e1->nextInLML &&
-    e1->xtop == pt.X && e1->ytop == pt.Y;
-  bool e2stops = !(ipRight & protects) &&  !e2->nextInLML &&
-    e2->xtop == pt.X && e2->ytop == pt.Y;
-  bool e1Contributing = ( e1->outIdx >= 0 );
-  bool e2contributing = ( e2->outIdx >= 0 );
-
-  //update winding counts...
-  //assumes that e1 will be to the right of e2 ABOVE the intersection
-  if ( e1->polyType == e2->polyType )
-  {
-    if ( IsEvenOddFillType( *e1) )
-    {
-      int oldE1WindCnt = e1->windCnt;
-      e1->windCnt = e2->windCnt;
-      e2->windCnt = oldE1WindCnt;
-    } else
-    {
-      if (e1->windCnt + e2->windDelta == 0 ) e1->windCnt = -e1->windCnt;
-      else e1->windCnt += e2->windDelta;
-      if ( e2->windCnt - e1->windDelta == 0 ) e2->windCnt = -e2->windCnt;
-      else e2->windCnt -= e1->windDelta;
-    }
-  } else
-  {
-    if (!IsEvenOddFillType(*e2)) e1->windCnt2 += e2->windDelta;
-    else e1->windCnt2 = ( e1->windCnt2 == 0 ) ? 1 : 0;
-    if (!IsEvenOddFillType(*e1)) e2->windCnt2 -= e1->windDelta;
-    else e2->windCnt2 = ( e2->windCnt2 == 0 ) ? 1 : 0;
-  }
-
-  PolyFillType e1FillType, e2FillType, e1FillType2, e2FillType2;
-  if (e1->polyType == ptSubject)
-  {
-    e1FillType = m_SubjFillType;
-    e1FillType2 = m_ClipFillType;
-  } else
-  {
-    e1FillType = m_ClipFillType;
-    e1FillType2 = m_SubjFillType;
-  }
-  if (e2->polyType == ptSubject)
-  {
-    e2FillType = m_SubjFillType;
-    e2FillType2 = m_ClipFillType;
-  } else
-  {
-    e2FillType = m_ClipFillType;
-    e2FillType2 = m_SubjFillType;
-  }
-
-  long64 e1Wc, e2Wc;
-  switch (e1FillType)
-  {
-    case pftPositive: e1Wc = e1->windCnt; break;
-    case pftNegative: e1Wc = -e1->windCnt; break;
-    default: e1Wc = Abs(e1->windCnt);
-  }
-  switch(e2FillType)
-  {
-    case pftPositive: e2Wc = e2->windCnt; break;
-    case pftNegative: e2Wc = -e2->windCnt; break;
-    default: e2Wc = Abs(e2->windCnt);
-  }
-
-  if ( e1Contributing && e2contributing )
-  {
-    if ( e1stops || e2stops || 
-      (e1Wc != 0 && e1Wc != 1) || (e2Wc != 0 && e2Wc != 1) ||
-      (e1->polyType != e2->polyType && m_ClipType != ctXor) )
-        AddLocalMaxPoly(e1, e2, pt); 
-    else
-        DoBothEdges( e1, e2, pt );
-  }
-  else if ( e1Contributing )
-  {
-    if ((e2Wc == 0 || e2Wc == 1) && 
-      (m_ClipType != ctIntersection || 
-      e2->polyType == ptSubject || (e2->windCnt2 != 0))) 
-        DoEdge1(e1, e2, pt);
-  }
-  else if ( e2contributing )
-  {
-    if ((e1Wc == 0 || e1Wc == 1) && 
-      (m_ClipType != ctIntersection || 
-      e1->polyType == ptSubject || (e1->windCnt2 != 0))) 
-        DoEdge2(e1, e2, pt);
-  } 
-  else if ( (e1Wc == 0 || e1Wc == 1) && 
-    (e2Wc == 0 || e2Wc == 1) && !e1stops && !e2stops )
-  {
-    //neither edge is currently contributing ...
-
-    long64 e1Wc2, e2Wc2;
-    switch (e1FillType2)
-    {
-      case pftPositive: e1Wc2 = e1->windCnt2; break;
-      case pftNegative : e1Wc2 = -e1->windCnt2; break;
-      default: e1Wc2 = Abs(e1->windCnt2);
-    }
-    switch (e2FillType2)
-    {
-      case pftPositive: e2Wc2 = e2->windCnt2; break;
-      case pftNegative: e2Wc2 = -e2->windCnt2; break;
-      default: e2Wc2 = Abs(e2->windCnt2);
-    }
-
-    if (e1->polyType != e2->polyType)
-        AddLocalMinPoly(e1, e2, pt);
-    else if (e1Wc == 1 && e2Wc == 1)
-      switch( m_ClipType ) {
-        case ctIntersection:
-          if (e1Wc2 > 0 && e2Wc2 > 0)
-            AddLocalMinPoly(e1, e2, pt);
-          break;
-        case ctUnion:
-          if ( e1Wc2 <= 0 && e2Wc2 <= 0 )
-            AddLocalMinPoly(e1, e2, pt);
-          break;
-        case ctDifference:
-          if ((e1->polyType == ptClip && e2->polyType == ptClip && 
-              e1Wc2 > 0 && e2Wc2 > 0) || 
-              (e1->polyType == ptSubject && e2->polyType == ptSubject && 
-              e1Wc2 <= 0 && e2Wc2 <= 0)) 
-                AddLocalMinPoly(e1, e2, pt);
-          break;
-        case ctXor:
-          AddLocalMinPoly(e1, e2, pt);
-      }
-    else
-      SwapSides( *e1, *e2 );
-  }
-
-  if(  (e1stops != e2stops) &&
-    ( (e1stops && (e1->outIdx >= 0)) || (e2stops && (e2->outIdx >= 0)) ) )
-  {
-    SwapSides( *e1, *e2 );
-    SwapPolyIndexes( *e1, *e2 );
-  }
-
-  //finally, delete any non-contributing maxima edges  ...
-  if( e1stops ) DeleteFromAEL( e1 );
-  if( e2stops ) DeleteFromAEL( e2 );
-}
-//------------------------------------------------------------------------------
-
-void Clipper::SetHoleState(TEdge *e, OutRec *outRec)
-{
-  bool isHole = false;
-  TEdge *e2 = e->prevInAEL;
-  while (e2)
-  {
-    if (e2->outIdx >= 0)
-    {
-      isHole = !isHole;
-      if (! outRec->FirstLeft)
-        outRec->FirstLeft = m_PolyOuts[e2->outIdx];
-    }
-    e2 = e2->prevInAEL;
-  }
-  if (isHole) outRec->isHole = true;
-}
-//------------------------------------------------------------------------------
-
-bool GetNextNonDupOutPt(OutPt* pp, OutPt*& next)
-{
-  next = pp->next;
-  while (next != pp && PointsEqual(pp->pt, next->pt))
-    next = next->next;
-  return next != pp;
-}
-//------------------------------------------------------------------------------
-
-bool GetPrevNonDupOutPt(OutPt* pp, OutPt*& prev)
-{
-  prev = pp->prev;
-  while (prev != pp && PointsEqual(pp->pt, prev->pt))
-    prev = prev->prev;
-  return prev != pp;
-}
-//------------------------------------------------------------------------------
-
-OutRec* GetLowermostRec(OutRec *outRec1, OutRec *outRec2)
-{
-  //work out which polygon fragment has the correct hole state ...
-  OutPt *outPt1 = outRec1->bottomPt;
-  OutPt *outPt2 = outRec2->bottomPt;
-  if (outPt1->pt.Y > outPt2->pt.Y) return outRec1;
-  else if (outPt1->pt.Y < outPt2->pt.Y) return outRec2;
-  else if (outPt1->pt.X < outPt2->pt.X) return outRec1;
-  else if (outPt1->pt.X > outPt2->pt.X) return outRec2;
-  else if (outRec1->bottomE2 == 0) return outRec2;
-  else if (outRec2->bottomE2 == 0) return outRec1;
-  else
-  {
-    long64 y1 = std::max(outRec1->bottomE1->ybot, outRec1->bottomE2->ybot);
-    long64 y2 = std::max(outRec2->bottomE1->ybot, outRec2->bottomE2->ybot);
-    if (y2 == y1 || (y1 > outPt1->pt.Y && y2 > outPt1->pt.Y))
-    {
-      double dx1 = std::max(outRec1->bottomE1->dx, outRec1->bottomE2->dx);
-      double dx2 = std::max(outRec2->bottomE1->dx, outRec2->bottomE2->dx);
-      if (dx2 > dx1) return outRec2; else return outRec1;
-    }
-    else if (y2 > y1) return outRec2;
-    else return outRec1;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AppendPolygon(TEdge *e1, TEdge *e2)
-{
-  //get the start and ends of both output polygons ...
-  OutRec *outRec1 = m_PolyOuts[e1->outIdx];
-  OutRec *outRec2 = m_PolyOuts[e2->outIdx];
-  OutRec *holeStateRec = GetLowermostRec(outRec1, outRec2);
-
-  //fixup hole status ...
-  if (holeStateRec == outRec2)
-    outRec1->isHole = outRec2->isHole;
-  else
-    outRec2->isHole = outRec1->isHole;
-
-  OutPt* p1_lft = outRec1->pts;
-  OutPt* p1_rt = p1_lft->prev;
-  OutPt* p2_lft = outRec2->pts;
-  OutPt* p2_rt = p2_lft->prev;
-
-  EdgeSide side;
-  //join e2 poly onto e1 poly and delete pointers to e2 ...
-  if(  e1->side == esLeft )
-  {
-    if(  e2->side == esLeft )
-    {
-      //z y x a b c
-      ReversePolyPtLinks(*p2_lft);
-      p2_lft->next = p1_lft;
-      p1_lft->prev = p2_lft;
-      p1_rt->next = p2_rt;
-      p2_rt->prev = p1_rt;
-      outRec1->pts = p2_rt;
-    } else
-    {
-      //x y z a b c
-      p2_rt->next = p1_lft;
-      p1_lft->prev = p2_rt;
-      p2_lft->prev = p1_rt;
-      p1_rt->next = p2_lft;
-      outRec1->pts = p2_lft;
-    }
-    side = esLeft;
-  } else
-  {
-    if(  e2->side == esRight )
-    {
-      //a b c z y x
-      ReversePolyPtLinks( *p2_lft );
-      p1_rt->next = p2_rt;
-      p2_rt->prev = p1_rt;
-      p2_lft->next = p1_lft;
-      p1_lft->prev = p2_lft;
-    } else
-    {
-      //a b c x y z
-      p1_rt->next = p2_lft;
-      p2_lft->prev = p1_rt;
-      p1_lft->prev = p2_rt;
-      p2_rt->next = p1_lft;
-    }
-    side = esRight;
-  }
-
-  if (holeStateRec == outRec2)
-  {
-    outRec1->bottomPt = outRec2->bottomPt;
-    outRec1->bottomPt->idx = outRec1->idx;
-    outRec1->bottomE1 = outRec2->bottomE1;
-    outRec1->bottomE2 = outRec2->bottomE2;
-
-    if (outRec2->FirstLeft != outRec1)
-      outRec1->FirstLeft = outRec2->FirstLeft;
-  }
-  outRec2->pts = 0;
-  outRec2->bottomPt = 0;
-  outRec2->AppendLink = outRec1;
-  int OKIdx = e1->outIdx;
-  int ObsoleteIdx = e2->outIdx;
-
-  e1->outIdx = -1; //nb: safe because we only get here via AddLocalMaxPoly
-  e2->outIdx = -1;
-
-  TEdge* e = m_ActiveEdges;
-  while( e )
-  {
-    if( e->outIdx == ObsoleteIdx )
-    {
-      e->outIdx = OKIdx;
-      e->side = side;
-      break;
-    }
-    e = e->nextInAEL;
-  }
-
-  for (JoinList::size_type i = 0; i < m_Joins.size(); ++i)
-  {
-      if (m_Joins[i]->poly1Idx == ObsoleteIdx) m_Joins[i]->poly1Idx = OKIdx;
-      if (m_Joins[i]->poly2Idx == ObsoleteIdx) m_Joins[i]->poly2Idx = OKIdx;
-  }
-
-  for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); ++i)
-  {
-      if (m_HorizJoins[i]->savedIdx == ObsoleteIdx)
-        m_HorizJoins[i]->savedIdx = OKIdx;
-  }
-
-}
-//------------------------------------------------------------------------------
-
-OutRec* Clipper::CreateOutRec()
-{
-  OutRec* result = new OutRec;
-  result->isHole = false;
-  result->FirstLeft = 0;
-  result->AppendLink = 0;
-  result->pts = 0;
-  result->bottomPt = 0;
-  return result;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AddOutPt(TEdge *e, TEdge *altE, const IntPoint &pt)
-{
-  bool ToFront = (e->side == esLeft);
-  if(  e->outIdx < 0 )
-  {
-    OutRec *outRec = CreateOutRec();
-    m_PolyOuts.push_back(outRec);
-    outRec->idx = (int)m_PolyOuts.size()-1;
-    e->outIdx = outRec->idx;
-    OutPt* op = new OutPt;
-    outRec->pts = op;
-    outRec->bottomE1 = e;
-    outRec->bottomE2 = altE;
-    outRec->bottomPt = op;
-    op->pt = pt;
-    op->idx = outRec->idx;
-    op->next = op;
-    op->prev = op;
-    SetHoleState(e, outRec);
-  } else
-  {
-    OutRec *outRec = m_PolyOuts[e->outIdx];
-    OutPt* op = outRec->pts;
-    if ((ToFront && PointsEqual(pt, op->pt)) ||
-      (!ToFront && PointsEqual(pt, op->prev->pt))) return;
-    OutPt* op2 = new OutPt;
-    op2->pt = pt;
-    op2->idx = outRec->idx;
-    if (op2->pt.Y == outRec->bottomPt->pt.Y &&
-      op2->pt.X < outRec->bottomPt->pt.X)
-    {
-      outRec->bottomPt = op2;
-      outRec->bottomE1 = e;
-      outRec->bottomE2 = altE;
-    }
-    op2->next = op;
-    op2->prev = op->prev;
-    op2->prev->next = op2;
-    op->prev = op2;
-    if (ToFront) outRec->pts = op2;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::ProcessHorizontals()
-{
-  TEdge* horzEdge = m_SortedEdges;
-  while( horzEdge )
-  {
-    DeleteFromSEL( horzEdge );
-    ProcessHorizontal( horzEdge );
-    horzEdge = m_SortedEdges;
-  }
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::IsTopHorz(const long64 XPos)
-{
-  TEdge* e = m_SortedEdges;
-  while( e )
-  {
-    if(  ( XPos >= std::min(e->xcurr, e->xtop) ) &&
-      ( XPos <= std::max(e->xcurr, e->xtop) ) ) return false;
-    e = e->nextInSEL;
-  }
-  return true;
-}
-//------------------------------------------------------------------------------
-
-bool IsMinima(TEdge *e)
-{
-  return e  && (e->prev->nextInLML != e) && (e->next->nextInLML != e);
-}
-//------------------------------------------------------------------------------
-
-bool IsMaxima(TEdge *e, const long64 Y)
-{
-  return e && e->ytop == Y && !e->nextInLML;
-}
-//------------------------------------------------------------------------------
-
-bool IsIntermediate(TEdge *e, const long64 Y)
-{
-  return e->ytop == Y && e->nextInLML;
-}
-//------------------------------------------------------------------------------
-
-TEdge *GetMaximaPair(TEdge *e)
-{
-  if( !IsMaxima(e->next, e->ytop) || e->next->xtop != e->xtop )
-    return e->prev; else
-    return e->next;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::SwapPositionsInAEL(TEdge *edge1, TEdge *edge2)
-{
-  if(  !edge1->nextInAEL &&  !edge1->prevInAEL ) return;
-  if(  !edge2->nextInAEL &&  !edge2->prevInAEL ) return;
-
-  if(  edge1->nextInAEL == edge2 )
-  {
-    TEdge* next = edge2->nextInAEL;
-    if( next ) next->prevInAEL = edge1;
-    TEdge* prev = edge1->prevInAEL;
-    if( prev ) prev->nextInAEL = edge2;
-    edge2->prevInAEL = prev;
-    edge2->nextInAEL = edge1;
-    edge1->prevInAEL = edge2;
-    edge1->nextInAEL = next;
-  }
-  else if(  edge2->nextInAEL == edge1 )
-  {
-    TEdge* next = edge1->nextInAEL;
-    if( next ) next->prevInAEL = edge2;
-    TEdge* prev = edge2->prevInAEL;
-    if( prev ) prev->nextInAEL = edge1;
-    edge1->prevInAEL = prev;
-    edge1->nextInAEL = edge2;
-    edge2->prevInAEL = edge1;
-    edge2->nextInAEL = next;
-  }
-  else
-  {
-    TEdge* next = edge1->nextInAEL;
-    TEdge* prev = edge1->prevInAEL;
-    edge1->nextInAEL = edge2->nextInAEL;
-    if( edge1->nextInAEL ) edge1->nextInAEL->prevInAEL = edge1;
-    edge1->prevInAEL = edge2->prevInAEL;
-    if( edge1->prevInAEL ) edge1->prevInAEL->nextInAEL = edge1;
-    edge2->nextInAEL = next;
-    if( edge2->nextInAEL ) edge2->nextInAEL->prevInAEL = edge2;
-    edge2->prevInAEL = prev;
-    if( edge2->prevInAEL ) edge2->prevInAEL->nextInAEL = edge2;
-  }
-
-  if( !edge1->prevInAEL ) m_ActiveEdges = edge1;
-  else if( !edge2->prevInAEL ) m_ActiveEdges = edge2;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::SwapPositionsInSEL(TEdge *edge1, TEdge *edge2)
-{
-  if(  !( edge1->nextInSEL ) &&  !( edge1->prevInSEL ) ) return;
-  if(  !( edge2->nextInSEL ) &&  !( edge2->prevInSEL ) ) return;
-
-  if(  edge1->nextInSEL == edge2 )
-  {
-    TEdge* next = edge2->nextInSEL;
-    if( next ) next->prevInSEL = edge1;
-    TEdge* prev = edge1->prevInSEL;
-    if( prev ) prev->nextInSEL = edge2;
-    edge2->prevInSEL = prev;
-    edge2->nextInSEL = edge1;
-    edge1->prevInSEL = edge2;
-    edge1->nextInSEL = next;
-  }
-  else if(  edge2->nextInSEL == edge1 )
-  {
-    TEdge* next = edge1->nextInSEL;
-    if( next ) next->prevInSEL = edge2;
-    TEdge* prev = edge2->prevInSEL;
-    if( prev ) prev->nextInSEL = edge1;
-    edge1->prevInSEL = prev;
-    edge1->nextInSEL = edge2;
-    edge2->prevInSEL = edge1;
-    edge2->nextInSEL = next;
-  }
-  else
-  {
-    TEdge* next = edge1->nextInSEL;
-    TEdge* prev = edge1->prevInSEL;
-    edge1->nextInSEL = edge2->nextInSEL;
-    if( edge1->nextInSEL ) edge1->nextInSEL->prevInSEL = edge1;
-    edge1->prevInSEL = edge2->prevInSEL;
-    if( edge1->prevInSEL ) edge1->prevInSEL->nextInSEL = edge1;
-    edge2->nextInSEL = next;
-    if( edge2->nextInSEL ) edge2->nextInSEL->prevInSEL = edge2;
-    edge2->prevInSEL = prev;
-    if( edge2->prevInSEL ) edge2->prevInSEL->nextInSEL = edge2;
-  }
-
-  if( !edge1->prevInSEL ) m_SortedEdges = edge1;
-  else if( !edge2->prevInSEL ) m_SortedEdges = edge2;
-}
-//------------------------------------------------------------------------------
-
-TEdge* GetNextInAEL(TEdge *e, Direction dir)
-{
-  if( dir == dLeftToRight ) return e->nextInAEL;
-  else return e->prevInAEL;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::ProcessHorizontal(TEdge *horzEdge)
-{
-  Direction dir;
-  long64 horzLeft, horzRight;
-
-  if( horzEdge->xcurr < horzEdge->xtop )
-  {
-    horzLeft = horzEdge->xcurr;
-    horzRight = horzEdge->xtop;
-    dir = dLeftToRight;
-  } else
-  {
-    horzLeft = horzEdge->xtop;
-    horzRight = horzEdge->xcurr;
-    dir = dRightToLeft;
-  }
-
-  TEdge* eMaxPair;
-  if( horzEdge->nextInLML ) eMaxPair = 0;
-  else eMaxPair = GetMaximaPair(horzEdge);
-
-  TEdge* e = GetNextInAEL( horzEdge , dir );
-  while( e )
-  {
-    TEdge* eNext = GetNextInAEL( e, dir );
-
-    if (eMaxPair ||
-      ((dir == dLeftToRight) && (e->xcurr <= horzRight)) ||
-      ((dir == dRightToLeft) && (e->xcurr >= horzLeft)))
-    {
-      //ok, so far it looks like we're still in range of the horizontal edge
-      if ( e->xcurr == horzEdge->xtop && !eMaxPair )
-      {
-        assert(horzEdge->nextInLML);
-        if (SlopesEqual(*e, *horzEdge->nextInLML, m_UseFullRange))
-        {
-          //if output polygons share an edge, they'll need joining later ...
-          if (horzEdge->outIdx >= 0 && e->outIdx >= 0)
-            AddJoin(horzEdge->nextInLML, e, horzEdge->outIdx);
-          break; //we've reached the end of the horizontal line
-        }
-        else if (e->dx < horzEdge->nextInLML->dx)
-        //we really have got to the end of the intermediate horz edge so quit.
-        //nb: More -ve slopes follow more +ve slopes ABOVE the horizontal.
-          break;
-      }
-
-      if( e == eMaxPair )
-      {
-        //horzEdge is evidently a maxima horizontal and we've arrived at its end.
-        if (dir == dLeftToRight)
-          IntersectEdges(horzEdge, e, IntPoint(e->xcurr, horzEdge->ycurr), ipNone);
-        else
-          IntersectEdges(e, horzEdge, IntPoint(e->xcurr, horzEdge->ycurr), ipNone);
-        if (eMaxPair->outIdx >= 0) throw clipperException("ProcessHorizontal error");
-        return;
-      }
-      else if( NEAR_EQUAL(e->dx, HORIZONTAL) &&  !IsMinima(e) && !(e->xcurr > e->xtop) )
-      {
-        //An overlapping horizontal edge. Overlapping horizontal edges are
-        //processed as if layered with the current horizontal edge (horizEdge)
-        //being infinitesimally lower that the next (e). Therfore, we
-        //intersect with e only if e.xcurr is within the bounds of horzEdge ...
-        if( dir == dLeftToRight )
-          IntersectEdges( horzEdge , e, IntPoint(e->xcurr, horzEdge->ycurr),
-            (IsTopHorz( e->xcurr ))? ipLeft : ipBoth );
-        else
-          IntersectEdges( e, horzEdge, IntPoint(e->xcurr, horzEdge->ycurr),
-            (IsTopHorz( e->xcurr ))? ipRight : ipBoth );
-      }
-      else if( dir == dLeftToRight )
-      {
-        IntersectEdges( horzEdge, e, IntPoint(e->xcurr, horzEdge->ycurr),
-          (IsTopHorz( e->xcurr ))? ipLeft : ipBoth );
-      }
-      else
-      {
-        IntersectEdges( e, horzEdge, IntPoint(e->xcurr, horzEdge->ycurr),
-          (IsTopHorz( e->xcurr ))? ipRight : ipBoth );
-      }
-      SwapPositionsInAEL( horzEdge, e );
-    }
-    else if( (dir == dLeftToRight && e->xcurr > horzRight  && m_SortedEdges) ||
-     (dir == dRightToLeft && e->xcurr < horzLeft && m_SortedEdges) ) break;
-    e = eNext;
-  } //end while
-
-  if( horzEdge->nextInLML )
-  {
-    if( horzEdge->outIdx >= 0 )
-      AddOutPt( horzEdge, 0, IntPoint(horzEdge->xtop, horzEdge->ytop));
-    UpdateEdgeIntoAEL( horzEdge );
-  }
-  else
-  {
-    assert(eMaxPair);
-    if ( horzEdge->outIdx >= 0 )
-    {
-      IntersectEdges( horzEdge, eMaxPair,
-          IntPoint(horzEdge->xtop, horzEdge->ycurr), ipBoth);
-    }
-    if (eMaxPair->outIdx >= 0) throw clipperException("ProcessHorizontal error");
-    DeleteFromAEL(eMaxPair);
-    DeleteFromAEL(horzEdge);
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::UpdateEdgeIntoAEL(TEdge *&e)
-{
-  if( !e->nextInLML ) throw
-    clipperException("UpdateEdgeIntoAEL: invalid call");
-  TEdge* AelPrev = e->prevInAEL;
-  TEdge* AelNext = e->nextInAEL;
-  e->nextInLML->outIdx = e->outIdx;
-  if( AelPrev ) AelPrev->nextInAEL = e->nextInLML;
-  else m_ActiveEdges = e->nextInLML;
-  if( AelNext ) AelNext->prevInAEL = e->nextInLML;
-  e->nextInLML->side = e->side;
-  e->nextInLML->windDelta = e->windDelta;
-  e->nextInLML->windCnt = e->windCnt;
-  e->nextInLML->windCnt2 = e->windCnt2;
-  e = e->nextInLML;
-  e->prevInAEL = AelPrev;
-  e->nextInAEL = AelNext;
-  if( !NEAR_EQUAL(e->dx, HORIZONTAL) ) InsertScanbeam( e->ytop );
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::ProcessIntersections(const long64 botY, const long64 topY)
-{
-  if( !m_ActiveEdges ) return true;
-  try {
-    BuildIntersectList(botY, topY);
-    if ( !m_IntersectNodes) return true;
-    if ( FixupIntersections() ) ProcessIntersectList();
-    else return false;
-  }
-  catch(...) {
-    m_SortedEdges = 0;
-    DisposeIntersectNodes();
-    throw clipperException("ProcessIntersections error");
-  }
-  return true;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::DisposeIntersectNodes()
-{
-  while ( m_IntersectNodes )
-  {
-    IntersectNode* iNode = m_IntersectNodes->next;
-    delete m_IntersectNodes;
-    m_IntersectNodes = iNode;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::BuildIntersectList(const long64 botY, const long64 topY)
-{
-  if ( !m_ActiveEdges ) return;
-
-  //prepare for sorting ...
-  TEdge* e = m_ActiveEdges;
-  e->tmpX = TopX( *e, topY );
-  m_SortedEdges = e;
-  m_SortedEdges->prevInSEL = 0;
-  e = e->nextInAEL;
-  while( e )
-  {
-    e->prevInSEL = e->prevInAEL;
-    e->prevInSEL->nextInSEL = e;
-    e->nextInSEL = 0;
-    e->tmpX = TopX( *e, topY );
-    e = e->nextInAEL;
-  }
-
-  //bubblesort ...
-  bool isModified = true;
-  while( isModified && m_SortedEdges )
-  {
-    isModified = false;
-    e = m_SortedEdges;
-    while( e->nextInSEL )
-    {
-      TEdge *eNext = e->nextInSEL;
-      IntPoint pt;
-      if(e->tmpX > eNext->tmpX &&
-        IntersectPoint(*e, *eNext, pt, m_UseFullRange))
-      {
-        if (pt.Y > botY)
-        {
-            pt.Y = botY;
-            pt.X = TopX(*e, pt.Y);
-        }
-        AddIntersectNode( e, eNext, pt );
-        SwapPositionsInSEL(e, eNext);
-        isModified = true;
-      }
-      else
-        e = eNext;
-    }
-    if( e->prevInSEL ) e->prevInSEL->nextInSEL = 0;
-    else break;
-  }
-  m_SortedEdges = 0;
-}
-//------------------------------------------------------------------------------
-
-bool Process1Before2(IntersectNode &node1, IntersectNode &node2)
-{
-  bool result;
-  if (node1.pt.Y == node2.pt.Y)
-  {
-    if (node1.edge1 == node2.edge1 || node1.edge2 == node2.edge1)
-    {
-      result = node2.pt.X > node1.pt.X;
-      if (node2.edge1->dx > 0) return !result; else return result;
-    }
-    else if (node1.edge1 == node2.edge2 || node1.edge2 == node2.edge2)
-    {
-      result = node2.pt.X > node1.pt.X;
-      if (node2.edge2->dx > 0) return !result; else return result;
-    }
-    else return node2.pt.X > node1.pt.X;
-  }
-  else return node1.pt.Y > node2.pt.Y;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::AddIntersectNode(TEdge *e1, TEdge *e2, const IntPoint &pt)
-{
-  IntersectNode* newNode = new IntersectNode;
-  newNode->edge1 = e1;
-  newNode->edge2 = e2;
-  newNode->pt = pt;
-  newNode->next = 0;
-  if( !m_IntersectNodes ) m_IntersectNodes = newNode;
-  else if(  Process1Before2(*newNode, *m_IntersectNodes) )
-  {
-    newNode->next = m_IntersectNodes;
-    m_IntersectNodes = newNode;
-  }
-  else
-  {
-    IntersectNode* iNode = m_IntersectNodes;
-    while( iNode->next  && Process1Before2(*iNode->next, *newNode) )
-        iNode = iNode->next;
-    newNode->next = iNode->next;
-    iNode->next = newNode;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::ProcessIntersectList()
-{
-  while( m_IntersectNodes )
-  {
-    IntersectNode* iNode = m_IntersectNodes->next;
-    {
-      IntersectEdges( m_IntersectNodes->edge1 ,
-        m_IntersectNodes->edge2 , m_IntersectNodes->pt, ipBoth );
-      SwapPositionsInAEL( m_IntersectNodes->edge1 , m_IntersectNodes->edge2 );
-    }
-    delete m_IntersectNodes;
-    m_IntersectNodes = iNode;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::DoMaxima(TEdge *e, long64 topY)
-{
-  TEdge* eMaxPair = GetMaximaPair(e);
-  long64 X = e->xtop;
-  TEdge* eNext = e->nextInAEL;
-  while( eNext != eMaxPair )
-  {
-    if (!eNext) throw clipperException("DoMaxima error");
-    IntersectEdges( e, eNext, IntPoint(X, topY), ipBoth );
-    eNext = eNext->nextInAEL;
-  }
-  if( e->outIdx < 0 && eMaxPair->outIdx < 0 )
-  {
-    DeleteFromAEL( e );
-    DeleteFromAEL( eMaxPair );
-  }
-  else if( e->outIdx >= 0 && eMaxPair->outIdx >= 0 )
-  {
-    IntersectEdges( e, eMaxPair, IntPoint(X, topY), ipNone );
-  }
-  else throw clipperException("DoMaxima error");
-}
-//------------------------------------------------------------------------------
-
-void Clipper::ProcessEdgesAtTopOfScanbeam(const long64 topY)
-{
-  TEdge* e = m_ActiveEdges;
-  while( e )
-  {
-    //1. process maxima, treating them as if they're 'bent' horizontal edges,
-    //   but exclude maxima with horizontal edges. nb: e can't be a horizontal.
-    if( IsMaxima(e, topY) && !NEAR_EQUAL(GetMaximaPair(e)->dx, HORIZONTAL) )
-    {
-      //'e' might be removed from AEL, as may any following edges so ...
-      TEdge* ePrior = e->prevInAEL;
-      DoMaxima(e, topY);
-      if( !ePrior ) e = m_ActiveEdges;
-      else e = ePrior->nextInAEL;
-    }
-    else
-    {
-      //2. promote horizontal edges, otherwise update xcurr and ycurr ...
-      if(  IsIntermediate(e, topY) && NEAR_EQUAL(e->nextInLML->dx, HORIZONTAL) )
-      {
-        if (e->outIdx >= 0)
-        {
-          AddOutPt(e, 0, IntPoint(e->xtop, e->ytop));
-
-          for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); ++i)
-          {
-            IntPoint pt, pt2;
-            HorzJoinRec* hj = m_HorizJoins[i];
-            if (GetOverlapSegment(IntPoint(hj->edge->xbot, hj->edge->ybot),
-              IntPoint(hj->edge->xtop, hj->edge->ytop),
-              IntPoint(e->nextInLML->xbot, e->nextInLML->ybot),
-              IntPoint(e->nextInLML->xtop, e->nextInLML->ytop), pt, pt2))
-                AddJoin(hj->edge, e->nextInLML, hj->savedIdx, e->outIdx);
-          }
-
-          AddHorzJoin(e->nextInLML, e->outIdx);
-        }
-        UpdateEdgeIntoAEL(e);
-        AddEdgeToSEL(e);
-      } else
-      {
-        //this just simplifies horizontal processing ...
-        e->xcurr = TopX( *e, topY );
-        e->ycurr = topY;
-      }
-      e = e->nextInAEL;
-    }
-  }
-
-  //3. Process horizontals at the top of the scanbeam ...
-  ProcessHorizontals();
-
-  //4. Promote intermediate vertices ...
-  e = m_ActiveEdges;
-  while( e )
-  {
-    if( IsIntermediate( e, topY ) )
-    {
-      if( e->outIdx >= 0 ) AddOutPt(e, 0, IntPoint(e->xtop,e->ytop));
-      UpdateEdgeIntoAEL(e);
-
-      //if output polygons share an edge, they'll need joining later ...
-      if (e->outIdx >= 0 && e->prevInAEL && e->prevInAEL->outIdx >= 0 &&
-        e->prevInAEL->xcurr == e->xbot && e->prevInAEL->ycurr == e->ybot &&
-        SlopesEqual(IntPoint(e->xbot,e->ybot), IntPoint(e->xtop, e->ytop),
-          IntPoint(e->xbot,e->ybot),
-          IntPoint(e->prevInAEL->xtop, e->prevInAEL->ytop), m_UseFullRange))
-      {
-        AddOutPt(e->prevInAEL, 0, IntPoint(e->xbot, e->ybot));
-        AddJoin(e, e->prevInAEL);
-      }
-      else if (e->outIdx >= 0 && e->nextInAEL && e->nextInAEL->outIdx >= 0 &&
-        e->nextInAEL->ycurr > e->nextInAEL->ytop &&
-        e->nextInAEL->ycurr < e->nextInAEL->ybot &&
-        e->nextInAEL->xcurr == e->xbot && e->nextInAEL->ycurr == e->ybot &&
-        SlopesEqual(IntPoint(e->xbot,e->ybot), IntPoint(e->xtop, e->ytop),
-          IntPoint(e->xbot,e->ybot),
-          IntPoint(e->nextInAEL->xtop, e->nextInAEL->ytop), m_UseFullRange))
-      {
-        AddOutPt(e->nextInAEL, 0, IntPoint(e->xbot, e->ybot));
-        AddJoin(e, e->nextInAEL);
-      }
-    }
-    e = e->nextInAEL;
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::FixupOutPolygon(OutRec &outRec)
-{
-  //FixupOutPolygon() - removes duplicate points and simplifies consecutive
-  //parallel edges by removing the middle vertex.
-  OutPt *lastOK = 0;
-  outRec.pts = outRec.bottomPt;
-  OutPt *pp = outRec.bottomPt;
-
-  for (;;)
-  {
-    if (pp->prev == pp || pp->prev == pp->next )
-    {
-      DisposeOutPts(pp);
-      outRec.pts = 0;
-      outRec.bottomPt = 0;
-      return;
-    }
-    //test for duplicate points and for same slope (cross-product) ...
-    if ( PointsEqual(pp->pt, pp->next->pt) ||
-      SlopesEqual(pp->prev->pt, pp->pt, pp->next->pt, m_UseFullRange) )
-    {
-      lastOK = 0;
-      OutPt *tmp = pp;
-      if (pp == outRec.bottomPt)
-      {
-          if (tmp->prev->pt.Y > tmp->next->pt.Y)
-            outRec.bottomPt = tmp->prev; else
-            outRec.bottomPt = tmp->next;
-          outRec.pts = outRec.bottomPt;
-          outRec.bottomPt->idx = outRec.idx;
-      }
-      pp->prev->next = pp->next;
-      pp->next->prev = pp->prev;
-      pp = pp->prev;
-      delete tmp;
-    }
-    else if (pp == lastOK) break;
-    else
-    {
-      if (!lastOK) lastOK = pp;
-      pp = pp->next;
-    }
-  }
-}
-//------------------------------------------------------------------------------
-
-void Clipper::BuildResult(Polygons &polys)
-{
-  int k = 0;
-  polys.resize(m_PolyOuts.size());
-  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
-  {
-    if (m_PolyOuts[i]->pts)
-    {
-      Polygon* pg = &polys[k];
-      pg->clear();
-      OutPt* p = m_PolyOuts[i]->pts;
-      do
-      {
-        pg->push_back(p->pt);
-        p = p->next;
-      } while (p != m_PolyOuts[i]->pts);
-      //make sure each polygon has at least 3 vertices ...
-      if (pg->size() < 3) pg->clear(); else k++;
-    }
-  }
-  polys.resize(k);
-}
-//------------------------------------------------------------------------------
-
-void Clipper::BuildResultEx(ExPolygons &polys)
-{
-  PolyOutList::size_type i = 0;
-  int k = 0;
-  polys.resize(0);
-  polys.reserve(m_PolyOuts.size());
-  while (i < m_PolyOuts.size() && m_PolyOuts[i]->pts)
-  {
-    ExPolygon epg;
-    OutPt* p = m_PolyOuts[i]->pts;
-    do {
-      epg.outer.push_back(p->pt);
-      p = p->next;
-    } while (p != m_PolyOuts[i]->pts);
-    i++;
-    //make sure polygons have at least 3 vertices ...
-    if (epg.outer.size() < 3) continue;
-    while (i < m_PolyOuts.size()
-      && m_PolyOuts[i]->pts && m_PolyOuts[i]->isHole)
-    {
-      Polygon pg;
-      p = m_PolyOuts[i]->pts;
-      do {
-        pg.push_back(p->pt);
-        p = p->next;
-      } while (p != m_PolyOuts[i]->pts);
-      epg.holes.push_back(pg);
-      i++;
-    }
-    polys.push_back(epg);
-    k++;
-  }
-  polys.resize(k);
-}
-//------------------------------------------------------------------------------
-
-void SwapIntersectNodes(IntersectNode &int1, IntersectNode &int2)
-{
-  TEdge *e1 = int1.edge1;
-  TEdge *e2 = int1.edge2;
-  IntPoint p = int1.pt;
-
-  int1.edge1 = int2.edge1;
-  int1.edge2 = int2.edge2;
-  int1.pt = int2.pt;
-
-  int2.edge1 = e1;
-  int2.edge2 = e2;
-  int2.pt = p;
-}
-//------------------------------------------------------------------------------
-
-bool Clipper::FixupIntersections()
-{
-  if ( !m_IntersectNodes->next ) return true;
-
-  CopyAELToSEL();
-  IntersectNode *int1 = m_IntersectNodes;
-  IntersectNode *int2 = m_IntersectNodes->next;
-  while (int2)
-  {
-    TEdge *e1 = int1->edge1;
-    TEdge *e2;
-    if (e1->prevInSEL == int1->edge2) e2 = e1->prevInSEL;
-    else if (e1->nextInSEL == int1->edge2) e2 = e1->nextInSEL;
-    else
-    {
-      //The current intersection is out of order, so try and swap it with
-      //a subsequent intersection ...
-      while (int2)
-      {
-        if (int2->edge1->nextInSEL == int2->edge2 ||
-          int2->edge1->prevInSEL == int2->edge2) break;
-        else int2 = int2->next;
-      }
-      if ( !int2 ) return false; //oops!!!
-
-      //found an intersect node that can be swapped ...
-      SwapIntersectNodes(*int1, *int2);
-      e1 = int1->edge1;
-      e2 = int1->edge2;
-    }
-    SwapPositionsInSEL(e1, e2);
-    int1 = int1->next;
-    int2 = int1->next;
-  }
-
-  m_SortedEdges = 0;
-
-  //finally, check the last intersection too ...
-  return (int1->edge1->prevInSEL == int1->edge2 ||
-    int1->edge1->nextInSEL == int1->edge2);
-}
-//------------------------------------------------------------------------------
-
-bool E2InsertsBeforeE1(TEdge &e1, TEdge &e2)
-{
-  if (e2.xcurr == e1.xcurr) return e2.dx > e1.dx;
-  else return e2.xcurr < e1.xcurr;
-}
-//------------------------------------------------------------------------------
-
-void Clipper::InsertEdgeIntoAEL(TEdge *edge)
-{
-  edge->prevInAEL = 0;
-  edge->nextInAEL = 0;
-  if( !m_ActiveEdges )
-  {
-    m_ActiveEdges = edge;
-  }
-  else if( E2InsertsBeforeE1(*m_ActiveEdges, *edge) )
-  {
-    edge->nextInAEL = m_ActiveEdges;
-    m_ActiveEdges->prevInAEL = edge;
-    m_ActiveEdges = edge;
-  } else
-  {
-    TEdge* e = m_ActiveEdges;
-    while( e->nextInAEL  && !E2InsertsBeforeE1(*e->nextInAEL , *edge) )
-      e = e->nextInAEL;
-    edge->nextInAEL = e->nextInAEL;
-    if( e->nextInAEL ) e->nextInAEL->prevInAEL = edge;
-    edge->prevInAEL = e;
-    e->nextInAEL = edge;
-  }
-}
-//----------------------------------------------------------------------
-
-void Clipper::DoEdge1(TEdge *edge1, TEdge *edge2, const IntPoint &pt)
-{
-  AddOutPt(edge1, edge2, pt);
-  SwapSides(*edge1, *edge2);
-  SwapPolyIndexes(*edge1, *edge2);
-}
-//----------------------------------------------------------------------
-
-void Clipper::DoEdge2(TEdge *edge1, TEdge *edge2, const IntPoint &pt)
-{
-  AddOutPt(edge2, edge1, pt);
-  SwapSides(*edge1, *edge2);
-  SwapPolyIndexes(*edge1, *edge2);
-}
-//----------------------------------------------------------------------
-
-void Clipper::DoBothEdges(TEdge *edge1, TEdge *edge2, const IntPoint &pt)
-{
-  AddOutPt(edge1, edge2, pt);
-  AddOutPt(edge2, edge1, pt);
-  SwapSides( *edge1 , *edge2 );
-  SwapPolyIndexes( *edge1 , *edge2 );
-}
-//----------------------------------------------------------------------
-
-void Clipper::CheckHoleLinkages1(OutRec *outRec1, OutRec *outRec2)
-{
-  //when a polygon is split into 2 polygons, make sure any holes the original
-  //polygon contained link to the correct polygon ...
-  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
-  {
-    OutRec *orec = m_PolyOuts[i];
-    if (orec->isHole && orec->bottomPt && orec->FirstLeft == outRec1 &&
-      !PointInPolygon(orec->bottomPt->pt, outRec1->pts, m_UseFullRange))
-        orec->FirstLeft = outRec2;
-  }
-}
-//----------------------------------------------------------------------
-
-void Clipper::CheckHoleLinkages2(OutRec *outRec1, OutRec *outRec2)
-{
-  //if a hole is owned by outRec2 then make it owned by outRec1 ...
-  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
-    if (m_PolyOuts[i]->isHole && m_PolyOuts[i]->bottomPt &&
-      m_PolyOuts[i]->FirstLeft == outRec2)
-        m_PolyOuts[i]->FirstLeft = outRec1;
-}
-//----------------------------------------------------------------------
-
-void Clipper::JoinCommonEdges(bool fixHoleLinkages)
-{
-  for (JoinList::size_type i = 0; i < m_Joins.size(); i++)
-  {
-    JoinRec* j = m_Joins[i];
-    OutRec *outRec1 = m_PolyOuts[j->poly1Idx];
-    OutPt *pp1a = outRec1->pts;
-    OutRec *outRec2 = m_PolyOuts[j->poly2Idx];
-    OutPt *pp2a = outRec2->pts;
-    IntPoint pt1 = j->pt2a, pt2 = j->pt2b;
-    IntPoint pt3 = j->pt1a, pt4 = j->pt1b;
-    if (!FindSegment(pp1a, pt1, pt2)) continue;
-    if (j->poly1Idx == j->poly2Idx)
-    {
-      //we're searching the same polygon for overlapping segments so
-      //segment 2 mustn't be the same as segment 1 ...
-      pp2a = pp1a->next;
-      if (!FindSegment(pp2a, pt3, pt4) || (pp2a == pp1a)) continue;
-    }
-    else if (!FindSegment(pp2a, pt3, pt4)) continue;
-
-    if (!GetOverlapSegment(pt1, pt2, pt3, pt4, pt1, pt2)) continue;
-
-    OutPt *p1, *p2, *p3, *p4;
-    OutPt *prev = pp1a->prev;
-    //get p1 & p2 polypts - the overlap start & endpoints on poly1
-    if (PointsEqual(pp1a->pt, pt1)) p1 = pp1a;
-    else if (PointsEqual(prev->pt, pt1)) p1 = prev;
-    else p1 = InsertPolyPtBetween(pp1a, prev, pt1);
-
-    if (PointsEqual(pp1a->pt, pt2)) p2 = pp1a;
-    else if (PointsEqual(prev->pt, pt2)) p2 = prev;
-    else if ((p1 == pp1a) || (p1 == prev))
-      p2 = InsertPolyPtBetween(pp1a, prev, pt2);
-    else if (Pt3IsBetweenPt1AndPt2(pp1a->pt, p1->pt, pt2))
-      p2 = InsertPolyPtBetween(pp1a, p1, pt2); else
-      p2 = InsertPolyPtBetween(p1, prev, pt2);
-
-    //get p3 & p4 polypts - the overlap start & endpoints on poly2
-    prev = pp2a->prev;
-    if (PointsEqual(pp2a->pt, pt1)) p3 = pp2a;
-    else if (PointsEqual(prev->pt, pt1)) p3 = prev;
-    else p3 = InsertPolyPtBetween(pp2a, prev, pt1);
-
-    if (PointsEqual(pp2a->pt, pt2)) p4 = pp2a;
-    else if (PointsEqual(prev->pt, pt2)) p4 = prev;
-    else if ((p3 == pp2a) || (p3 == prev))
-      p4 = InsertPolyPtBetween(pp2a, prev, pt2);
-    else if (Pt3IsBetweenPt1AndPt2(pp2a->pt, p3->pt, pt2))
-      p4 = InsertPolyPtBetween(pp2a, p3, pt2); else
-      p4 = InsertPolyPtBetween(p3, prev, pt2);
-
-    //p1.pt == p3.pt and p2.pt == p4.pt so join p1 to p3 and p2 to p4 ...
-    if (p1->next == p2 && p3->prev == p4)
-    {
-      p1->next = p3;
-      p3->prev = p1;
-      p2->prev = p4;
-      p4->next = p2;
-    }
-    else if (p1->prev == p2 && p3->next == p4)
-    {
-      p1->prev = p3;
-      p3->next = p1;
-      p2->next = p4;
-      p4->prev = p2;
-    }
-    else
-      continue; //an orientation is probably wrong
-
-    if (j->poly2Idx == j->poly1Idx)
-    {
-      //instead of joining two polygons, we've just created a new one by
-      //splitting one polygon into two.
-      outRec1->pts = PolygonBottom(p1);
-      outRec1->bottomPt = outRec1->pts;
-      outRec1->bottomPt->idx = outRec1->idx;
-      outRec2 = CreateOutRec();
-      m_PolyOuts.push_back(outRec2);
-      outRec2->idx = (int)m_PolyOuts.size()-1;
-      j->poly2Idx = outRec2->idx;
-      outRec2->pts = PolygonBottom(p2);
-      outRec2->bottomPt = outRec2->pts;
-      outRec2->bottomPt->idx = outRec2->idx;
-
-      if (PointInPolygon(outRec2->pts->pt, outRec1->pts, m_UseFullRange))
-      {
-        outRec2->isHole = !outRec1->isHole;
-        outRec2->FirstLeft = outRec1;
-        if (outRec2->isHole == Orientation(outRec2, m_UseFullRange))
-          ReversePolyPtLinks(*outRec2->pts);
-      } else if (PointInPolygon(outRec1->pts->pt, outRec2->pts, m_UseFullRange))
-      {
-        outRec2->isHole = outRec1->isHole;
-        outRec1->isHole = !outRec2->isHole;
-        outRec2->FirstLeft = outRec1->FirstLeft;
-        outRec1->FirstLeft = outRec2;
-        if (outRec1->isHole == Orientation(outRec1, m_UseFullRange))
-          ReversePolyPtLinks(*outRec1->pts);
-      } else
-      {
-        outRec2->isHole = outRec1->isHole;
-        outRec2->FirstLeft = outRec1->FirstLeft;
-        //make sure any contained holes now link to the correct polygon ...
-        if (fixHoleLinkages) CheckHoleLinkages1(outRec1, outRec2);
-      }
-
-      //now fixup any subsequent joins that match this polygon
-      for (JoinList::size_type k = i+1; k < m_Joins.size(); k++)
-      {
-        JoinRec* j2 = m_Joins[k];
-        if (j2->poly1Idx == j->poly1Idx && PointIsVertex(j2->pt1a, p2))
-          j2->poly1Idx = j->poly2Idx;
-        if (j2->poly2Idx == j->poly1Idx && PointIsVertex(j2->pt2a, p2))
-          j2->poly2Idx = j->poly2Idx;
-      }
-
-      //now cleanup redundant edges too ...
-      FixupOutPolygon(*outRec1);
-      FixupOutPolygon(*outRec2);
-    } else
-    {
-      //joined 2 polygons together ...
-
-      //make sure any holes contained by outRec2 now link to outRec1 ...
-      if (fixHoleLinkages) CheckHoleLinkages2(outRec1, outRec2);
-
-      //delete the obsolete pointer ...
-      int OKIdx = outRec1->idx;
-      int ObsoleteIdx = outRec2->idx;
-      outRec2->pts = 0;
-      outRec2->bottomPt = 0;
-      outRec2->AppendLink = outRec1;
-      //holes are practically always joined to outers, not vice versa ...
-      if (outRec1->isHole && !outRec2->isHole) outRec1->isHole = false;
-
-      //now fixup any subsequent Joins that match this polygon
-      for (JoinList::size_type k = i+1; k < m_Joins.size(); k++)
-      {
-        JoinRec* j2 = m_Joins[k];
-        if (j2->poly1Idx == ObsoleteIdx) j2->poly1Idx = OKIdx;
-        if (j2->poly2Idx == ObsoleteIdx) j2->poly2Idx = OKIdx;
-      }
-
-      //now cleanup redundant edges too ...
-      if (outRec1->pts)
-        FixupOutPolygon(*outRec1);
-      else
-        FixupOutPolygon(*outRec2);
-    }
-  }
-}
-//------------------------------------------------------------------------------
-
-void ReversePoints(Polygon& p)
-{
-  std::reverse(p.begin(), p.end());
-}
-//------------------------------------------------------------------------------
-
-void ReversePoints(Polygons& p)
-{
-  for (Polygons::size_type i = 0; i < p.size(); ++i)
-    ReversePoints(p[i]);
-}
-
-//------------------------------------------------------------------------------
-// OffsetPolygon functions ...
-//------------------------------------------------------------------------------
-
-struct DoublePoint
-{
-  double X;
-  double Y;
-  DoublePoint(double x = 0, double y = 0) : X(x), Y(y) {}
-};
-//------------------------------------------------------------------------------
-
-Polygon BuildArc(const IntPoint &pt,
-  const double a1, const double a2, const double r)
-{
-  int steps = std::max(6, int(std::sqrt(std::fabs(r)) * std::fabs(a2 - a1)));
-  Polygon result(steps);
-  int n = steps - 1;
-  double da = (a2 - a1) / n;
-  double a = a1;
-  for (int i = 0; i <= n; ++i)
-  {
-    result[i].X = pt.X + Round(std::cos(a)*r);
-    result[i].Y = pt.Y + Round(std::sin(a)*r);
-    a += da;
-  }
-  return result;
-}
-//------------------------------------------------------------------------------
-
-DoublePoint GetUnitNormal( const IntPoint &pt1, const IntPoint &pt2)
-{
-  if(pt2.X == pt1.X && pt2.Y == pt1.Y) 
-    return DoublePoint(0, 0);
-
-  double dx = (double)(pt2.X - pt1.X);
-  double dy = (double)(pt2.Y - pt1.Y);
-  double f = 1 *1.0/ std::sqrt( dx*dx + dy*dy );
-  dx *= f;
-  dy *= f;
-  return DoublePoint(dy, -dx);
-}
-
-//------------------------------------------------------------------------------
-//------------------------------------------------------------------------------
-
-class PolyOffsetBuilder
-{
-private:
-  Polygons m_p;
-  Polygon* m_curr_poly = nullptr;
-  std::vector<DoublePoint> normals;
-  double m_delta = 0, m_RMin = 0, m_R = 0;
-  size_t m_i = 0, m_j = 0, m_k = 0;
-  static const int buffLength = 128;
-  JoinType m_jointype = jtSquare;
- 
-public:
-
-PolyOffsetBuilder(const Polygons& in_polys, Polygons& out_polys,
-  double delta, JoinType jointype, double MiterLimit)
-{
-    //nb precondition - out_polys != ptsin_polys
-    if (NEAR_ZERO(delta))
-    {
-        out_polys = in_polys;
-        return;
-    }
-
-    this->m_p = in_polys;
-    this->m_delta = delta;
-    this->m_jointype = jointype;
-    if (MiterLimit <= 1) MiterLimit = 1;
-    m_RMin = 2/(MiterLimit*MiterLimit);
- 
-    double deltaSq = delta*delta;
-    out_polys.clear();
-    out_polys.resize(in_polys.size());
-    for (m_i = 0; m_i < in_polys.size(); m_i++)
-    {
-        m_curr_poly = &out_polys[m_i];
-        size_t len = in_polys[m_i].size();
-        if (len > 1 && m_p[m_i][0].X == m_p[m_i][len - 1].X &&
-            m_p[m_i][0].Y == m_p[m_i][len-1].Y) len--;
-
-        //when 'shrinking' polygons - to minimize artefacts
-        //strip those polygons that have an area < pi * delta^2 ...
-        double a1 = Area(in_polys[m_i]);
-        if (delta < 0) { if (a1 > 0 && a1 < deltaSq *pi) len = 0; }
-        else if (a1 < 0 && -a1 < deltaSq *pi) len = 0; //holes have neg. area
-
-        if (len == 0 || (len < 3 && delta <= 0))
-          continue;
-        else if (len == 1)
-        {
-            Polygon arc;
-            arc = BuildArc(in_polys[m_i][len-1], 0, 2 * pi, delta);
-            out_polys[m_i] = arc;
-            continue;
-        }
-
-        //build normals ...
-        normals.clear();
-        normals.resize(len);
-        normals[len-1] = GetUnitNormal(in_polys[m_i][len-1], in_polys[m_i][0]);
-        for (m_j = 0; m_j < len -1; ++m_j)
-            normals[m_j] = GetUnitNormal(in_polys[m_i][m_j], in_polys[m_i][m_j+1]);
-        
-        m_k = len -1;
-        for (m_j = 0; m_j < len; ++m_j)
-        {
-          switch (jointype)
-          {
-            case jtMiter:
-            {
-              m_R = 1 + (normals[m_j].X*normals[m_k].X + 
-                normals[m_j].Y*normals[m_k].Y);
-              if (m_R >= m_RMin) DoMiter(); else DoSquare(MiterLimit);
-              break;
-            }
-            case jtSquare: DoSquare(); break;
-            case jtRound: DoRound(); break;
-          }
-        m_k = m_j;
-        }
-    }
-
-    //finally, clean up untidy corners using Clipper ...
-    Clipper clpr;
-    clpr.AddPolygons(out_polys, ptSubject);
-    if (delta > 0)
-    {
-        if (!clpr.Execute(ctUnion, out_polys, pftPositive, pftPositive))
-            out_polys.clear();
-    }
-    else
-    {
-        IntRect r = clpr.GetBounds();
-        Polygon outer(4);
-        outer[0] = IntPoint(r.left - 10, r.bottom + 10);
-        outer[1] = IntPoint(r.right + 10, r.bottom + 10);
-        outer[2] = IntPoint(r.right + 10, r.top - 10);
-        outer[3] = IntPoint(r.left - 10, r.top - 10);
-
-        clpr.AddPolygon(outer, ptSubject);
-        if (clpr.Execute(ctUnion, out_polys, pftNegative, pftNegative))
-        {
-            out_polys.erase(out_polys.begin());
-            ReversePoints(out_polys);
-
-        } else
-            out_polys.clear();
-    }
-}
-//------------------------------------------------------------------------------
-
-private:
-
-void AddPoint(const IntPoint& pt)
-{
-    Polygon::size_type len = m_curr_poly->size();
-    if (len == m_curr_poly->capacity())
-        m_curr_poly->reserve(len + buffLength);
-    m_curr_poly->push_back(pt);
-}
-//------------------------------------------------------------------------------
-
-void DoSquare(double mul = 1.0)
-{
-    IntPoint pt1 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_k].X * m_delta),
-        (long64)Round(m_p[m_i][m_j].Y + normals[m_k].Y * m_delta));
-    IntPoint pt2 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_j].X * m_delta),
-        (long64)Round(m_p[m_i][m_j].Y + normals[m_j].Y * m_delta));
-    if ((normals[m_k].X * normals[m_j].Y - normals[m_j].X * normals[m_k].Y) * m_delta >= 0)
-    {
-        double a1 = std::atan2(normals[m_k].Y, normals[m_k].X);
-        double a2 = std::atan2(-normals[m_j].Y, -normals[m_j].X);
-        a1 = std::fabs(a2 - a1);
-        if (a1 > pi) a1 = pi * 2 - a1;
-        double dx = std::tan((pi - a1)/4) * std::fabs(m_delta * mul);
-        pt1 = IntPoint((long64)(pt1.X -normals[m_k].Y * dx),
-          (long64)(pt1.Y + normals[m_k].X * dx));
-        AddPoint(pt1);
-        pt2 = IntPoint((long64)(pt2.X + normals[m_j].Y * dx),
-          (long64)(pt2.Y -normals[m_j].X * dx));
-        AddPoint(pt2);
-    }
-    else
-    {
-        AddPoint(pt1);
-        AddPoint(m_p[m_i][m_j]);
-        AddPoint(pt2);
-    }
-}
-//------------------------------------------------------------------------------
-
-void DoMiter()
-{
-    if ((normals[m_k].X * normals[m_j].Y - normals[m_j].X * normals[m_k].Y) * m_delta >= 0)
-    {
-        double q = m_delta / m_R;
-        AddPoint(IntPoint((long64)Round(m_p[m_i][m_j].X + 
-            (normals[m_k].X + normals[m_j].X) * q),
-            (long64)Round(m_p[m_i][m_j].Y + (normals[m_k].Y + normals[m_j].Y) * q)));
-    }
-    else
-    {
-        IntPoint pt1 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_k].X *
-          m_delta), (long64)Round(m_p[m_i][m_j].Y + normals[m_k].Y * m_delta));
-        IntPoint pt2 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_j].X *
-          m_delta), (long64)Round(m_p[m_i][m_j].Y + normals[m_j].Y * m_delta));
-        AddPoint(pt1);
-        AddPoint(m_p[m_i][m_j]);
-        AddPoint(pt2);
-    }
-}
-//------------------------------------------------------------------------------
-
-void DoRound()
-{
-    IntPoint pt1 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_k].X * m_delta),
-        (long64)Round(m_p[m_i][m_j].Y + normals[m_k].Y * m_delta));
-    IntPoint pt2 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_j].X * m_delta),
-        (long64)Round(m_p[m_i][m_j].Y + normals[m_j].Y * m_delta));
-    AddPoint(pt1);
-    //round off reflex angles (ie > 180 deg) unless almost flat (ie < ~10deg).
-    if ((normals[m_k].X*normals[m_j].Y - normals[m_j].X*normals[m_k].Y) * m_delta >= 0)
-    {
-      if (normals[m_j].X * normals[m_k].X + normals[m_j].Y * normals[m_k].Y < 0.985)
-      {
-        double a1 = std::atan2(normals[m_k].Y, normals[m_k].X);
-        double a2 = std::atan2(normals[m_j].Y, normals[m_j].X);
-        if (m_delta > 0 && a2 < a1) a2 += pi *2;
-        else if (m_delta < 0 && a2 > a1) a2 -= pi *2;
-        Polygon arc = BuildArc(m_p[m_i][m_j], a1, a2, m_delta);
-        for (Polygon::size_type m = 0; m < arc.size(); m++)
-          AddPoint(arc[m]);
-      }
-    }
-    else
-      AddPoint(m_p[m_i][m_j]);
-    AddPoint(pt2);
-}
-//--------------------------------------------------------------------------
-
-}; //end PolyOffsetBuilder
-
-//------------------------------------------------------------------------------
-//------------------------------------------------------------------------------
-
-void OffsetPolygons(const Polygons &in_polys, Polygons &out_polys,
-  double delta, JoinType jointype, double MiterLimit)
-{
-  if (&out_polys == &in_polys)
-  {
-    Polygons poly2(in_polys);
-    PolyOffsetBuilder(poly2, out_polys, delta, jointype, MiterLimit);
-  }
-  else PolyOffsetBuilder(in_polys, out_polys, delta, jointype, MiterLimit);
-}
-//------------------------------------------------------------------------------
-
-std::ostream& operator <<(std::ostream &s, IntPoint& p)
-{
-  s << p.X << ' ' << p.Y << "\n";
-  return s;
-}
-//------------------------------------------------------------------------------
-
-std::ostream& operator <<(std::ostream &s, Polygon &p)
-{
-  for (Polygon::size_type i = 0; i < p.size(); i++)
-    s << p[i];
-  s << "\n";
-  return s;
-}
-//------------------------------------------------------------------------------
-
-std::ostream& operator <<(std::ostream &s, Polygons &p)
-{
-  for (Polygons::size_type i = 0; i < p.size(); i++)
-    s << p[i];
-  s << "\n";
-  return s;
-}
-//------------------------------------------------------------------------------
-
-} //ClipperLib namespace
diff -pruN 8.0.1-5/renderers/agg/src/configure.in 8.2.0~beta1-1~exp1/renderers/agg/src/configure.in
--- 8.0.1-5/renderers/agg/src/configure.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/configure.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-AC_INIT(src/agg_arc.cpp) # give me a source file, any source file...
-AM_INIT_AUTOMAKE(agg, 2.0.0)
-
-AC_PROG_LN_S
-AC_PROG_CC
-AC_PROG_CPP
-AC_PROG_CXX
-AC_PROG_LIBTOOL
-
-AC_OUTPUT(
-   Makefile 
-   gpc/Makefile
-   src/Makefile
-   src/ctrl/Makefile
-) 
diff -pruN 8.0.1-5/renderers/agg/src/copying 8.2.0~beta1-1~exp1/renderers/agg/src/copying
--- 8.0.1-5/renderers/agg/src/copying	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/copying	1970-01-01 00:00:00.000000000 +0000
@@ -1,11 +0,0 @@
-The Anti-Grain Geometry Project
-A high quality rendering engine for C++
-http://antigrain.com
-
-Anti-Grain Geometry - Version 2.4 
-Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
-
-Permission to copy, use, modify, sell and distribute this software 
-is granted provided this copyright notice appears in all copies. 
-This software is provided "as is" without express or implied
-warranty, and with no claim as to its suitability for any purpose.
diff -pruN 8.0.1-5/renderers/agg/src/readme 8.2.0~beta1-1~exp1/renderers/agg/src/readme
--- 8.0.1-5/renderers/agg/src/readme	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/agg/src/readme	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-Use automake to build the library. 
-
-If automake is not available you still can use the old make. 
-There is a very simple Makefile that can be used. Note that
-if you use automake it will overwrite Makefile.
diff -pruN 8.0.1-5/renderers/mvt/vector_tile.proto 8.2.0~beta1-1~exp1/renderers/mvt/vector_tile.proto
--- 8.0.1-5/renderers/mvt/vector_tile.proto	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/renderers/mvt/vector_tile.proto	1970-01-01 00:00:00.000000000 +0000
@@ -1,81 +0,0 @@
-//set version statement to avoid warnings thrown in protobuf >= 3
-syntax = "proto2";
-
-package vector_tile;
-
-option optimize_for = LITE_RUNTIME;
-
-message Tile {
-
-        // GeomType is described in section 4.3.4 of the specification
-        enum GeomType {
-             UNKNOWN = 0;
-             POINT = 1;
-             LINESTRING = 2;
-             POLYGON = 3;
-        }
-
-        // Variant type encoding
-        // The use of values is described in section 4.1 of the specification
-        message Value {
-                // Exactly one of these values must be present in a valid message
-                optional string string_value = 1;
-                optional float float_value = 2;
-                optional double double_value = 3;
-                optional int64 int_value = 4;
-                optional uint64 uint_value = 5;
-                optional sint64 sint_value = 6;
-                optional bool bool_value = 7;
-
-                extensions 8 to max;
-        }
-
-        // Features are described in section 4.2 of the specification
-        message Feature {
-                optional uint64 id = 1 [ default = 0 ];
-
-                // Tags of this feature are encoded as repeated pairs of
-                // integers.
-                // A detailed description of tags is located in sections
-                // 4.2 and 4.4 of the specification
-                repeated uint32 tags = 2 [ packed = true ];
-
-                // The type of geometry stored in this feature.
-                optional GeomType type = 3 [ default = UNKNOWN ];
-
-                // Contains a stream of commands and parameters (vertices).
-                // A detailed description on geometry encoding is located in 
-                // section 4.3 of the specification.
-                repeated uint32 geometry = 4 [ packed = true ];
-        }
-
-        // Layers are described in section 4.1 of the specification
-        message Layer {
-                // Any compliant implementation must first read the version
-                // number encoded in this message and choose the correct
-                // implementation for this version number before proceeding to
-                // decode other parts of this message.
-                required uint32 version = 15 [ default = 1 ];
-
-                required string name = 1;
-
-                // The actual features in this tile.
-                repeated Feature features = 2;
-
-                // Dictionary encoding for keys
-                repeated string keys = 3;
-
-                // Dictionary encoding for values
-                repeated Value values = 4;
-
-                // Although this is an "optional" field it is required by the specification.
-                // See https://github.com/mapbox/vector-tile-spec/issues/47
-                optional uint32 extent = 5 [ default = 4096 ];
-
-                extensions 16 to max;
-        }
-
-        repeated Layer layers = 3;
-
-        extensions 16 to 8191;
-}
diff -pruN 8.0.1-5/scalebar.c 8.2.0~beta1-1~exp1/scalebar.c
--- 8.0.1-5/scalebar.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/scalebar.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,69 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Commandline scalebar generating utility, mostly for testing.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-int main(int argc, char *argv[])
-{
-  mapObj *map=NULL;
-  imageObj         *image = NULL;
-
-  msSetup();
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
-    printf("%s\n", msGetVersion());
-    exit(0);
-  }
-
-  /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 3 ) {
-    fprintf(stdout,"Syntax: scalebar [mapfile] [output image]\n" );
-    exit(1);
-  }
-
-  map = msLoadMap(argv[1], NULL, NULL);
-  if(!map) {
-    msWriteError(stderr);
-    exit(1);
-  }
-
-  image = msDrawScalebar(map);
-
-  if(!image) {
-    msWriteError(stderr);
-    exit(1);
-  }
-
-  msSaveImage(map, image, argv[2]);
-  msFreeImage(image);
-
-  msFreeMap(map);
-  return(MS_TRUE);
-}
diff -pruN 8.0.1-5/scripts/cppcheck.sh 8.2.0~beta1-1~exp1/scripts/cppcheck.sh
--- 8.0.1-5/scripts/cppcheck.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/scripts/cppcheck.sh	2024-06-06 20:07:58.000000000 +0000
@@ -15,10 +15,14 @@ case $SCRIPT_DIR in
         ;;
 esac
 
-TOPDIR="$SCRIPT_DIR/.."
+TOPDIR="$SCRIPT_DIR/../src"
 
 CPPCHECK_VERSION="$(cppcheck --version | awk '{print $2}')"
-CPPCHECK_VERSION_GT_2_7=$(expr "$CPPCHECK_VERSION" \>= 2.7 || /bin/true)
+CPPCHECK_VERSION="$(cppcheck --version | awk '{print $2}')"
+CPPCHECK_MAJOR_VERSION=$(echo "$CPPCHECK_VERSION" | cut -d. -f1)
+CPPCHECK_MINOR_VERSION=$(echo "$CPPCHECK_VERSION" | cut -d. -f2)
+CPPCHECK_VERSION=$(("$CPPCHECK_MAJOR_VERSION" * 100 + "$CPPCHECK_MINOR_VERSION"))
+CPPCHECK_VERSION_GT_2_7=$(expr "$CPPCHECK_VERSION" \>= 207 || /bin/true)
 if test "$CPPCHECK_VERSION_GT_2_7" = 1; then
     POSIX="--library=gnu"
 else
diff -pruN 8.0.1-5/scripts/vagrant/mapserver.sh 8.2.0~beta1-1~exp1/scripts/vagrant/mapserver.sh
--- 8.0.1-5/scripts/vagrant/mapserver.sh	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/scripts/vagrant/mapserver.sh	2024-06-06 20:07:58.000000000 +0000
@@ -10,13 +10,13 @@ python -m http.server &> /dev/null &
 cd ..
 
 mkdir build_vagrant
-touch maplexer.l
-touch mapparser.y
-flex --nounistd -Pmsyy -i -omaplexer.c maplexer.l
-yacc -d -omapparser.c mapparser.y
+touch src/maplexer.l
+touch src/mapparser.y
+flex --nounistd -Pmsyy -i -osrc/maplexer.c src/maplexer.l
+yacc -d -osrc/mapparser.c src/mapparser.y
 cd build_vagrant
 cmake   -G "Unix Makefiles" -DWITH_CLIENT_WMS=1 \
-        -DWITH_CLIENT_WFS=1 -DWITH_KML=1 -DWITH_SOS=1 -DWITH_PHP=1 \
+        -DWITH_CLIENT_WFS=1 -DWITH_KML=1 -DWITH_SOS=1 -DWITH_PHPNG=1 \
         -DWITH_PYTHON=1 -DWITH_JAVA=0 -DWITH_PERL=1 -DWITH_THREAD_SAFETY=1 \
         -DWITH_FCGI=0 -DWITH_EXEMPI=1 -DCMAKE_BUILD_TYPE=RelWithDebInfo \
         -DWITH_RSVG=1 -DWITH_CURL=1 -DWITH_FRIBIDI=1 -DWITH_HARFBUZZ=1 \
diff -pruN 8.0.1-5/scripts/vagrant/msautotest.sh 8.2.0~beta1-1~exp1/scripts/vagrant/msautotest.sh
--- 8.0.1-5/scripts/vagrant/msautotest.sh	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/scripts/vagrant/msautotest.sh	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+cd /vagrant/msautotest
+
+# copy custom projection to the PROJ_DATA folder
+sudo cp ./wxs/data/epsg2 /usr/share/proj/
diff -pruN 8.0.1-5/share/ogcapi/templates/html-bootstrap4/collection.html 8.2.0~beta1-1~exp1/share/ogcapi/templates/html-bootstrap4/collection.html
--- 8.0.1-5/share/ogcapi/templates/html-bootstrap4/collection.html	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/share/ogcapi/templates/html-bootstrap4/collection.html	2024-06-06 20:07:58.000000000 +0000
@@ -23,6 +23,23 @@
       </p></div>
     {% endif %}
 
+    {% if existsIn(response, "storageCrs") %}
+    <p>Storage CRS:
+    <a href="{{ response.storageCrs }}">{{ response.storageCrs }}</a>
+    </p>
+    {% endif %}
+
+    {% if existsIn(response, "crs") %}
+    <p>
+    Supported CRS:
+    <ul>
+    {% for href in response.crs %}
+    <li> <a href="{{ href }}">{{ href }}</a></li>
+    {% endfor %}
+    </ul>
+    </p>
+    {% endif %}
+
     <h2>Links</h2>
     <ul>
     {% for link in response.links %}
diff -pruN 8.0.1-5/share/ogcapi/templates/html-plain/collection.html 8.2.0~beta1-1~exp1/share/ogcapi/templates/html-plain/collection.html
--- 8.0.1-5/share/ogcapi/templates/html-plain/collection.html	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/share/ogcapi/templates/html-plain/collection.html	2024-06-06 20:07:58.000000000 +0000
@@ -12,6 +12,20 @@
 </ul>
 {% endif %}
 
+{% if existsIn(response, "storageCrs") %}
+<h2>Storage CRS</h2>
+<a href="{{ response.storageCrs }}">{{ response.storageCrs }}</a>
+{% endif %}
+
+{% if existsIn(response, "crs") %}
+<h2>Supported CRS</h2>
+<ul>
+{% for href in response.crs %}
+<li> <a href="{{ href }}">{{ href }}</a></li>
+{% endfor %}
+</ul>
+{% endif %}
+
 <h2>Links</h2>
 <ul>
 {% for link in response.links %}
diff -pruN 8.0.1-5/shptree.c 8.2.0~beta1-1~exp1/shptree.c
--- 8.0.1-5/shptree.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/shptree.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,156 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Commandline utility to generate .qix shapefile spatial indexes.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include "maptree.h"
-#include <string.h>
-
-
-
-char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension     */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = (int)strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*  Open the .shp and .shx files.  Note that files pulled from      */
-  /*  a PC to Unix with upper case filenames won't work!        */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
-
-  free(pszBasename);
-  return (pszFullname);
-}
-
-
-int main(int argc, char *argv[])
-{
-  shapefileObj shapefile;
-
-  treeObj *tree;
-  int byte_order = MS_NEW_LSB_ORDER, i;
-  int depth=0;
-
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
-    printf("%s\n", msGetVersion());
-    exit(0);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*  Establish the byte order on this machine to decide default        */
-  /*    index format                                                      */
-  /* -------------------------------------------------------------------- */
-  i = 1;
-  /* cppcheck-suppress knownConditionTrueFalse */
-  if( *((uchar *) &i) == 1 )
-    byte_order = MS_NEW_LSB_ORDER;
-  else
-    byte_order = MS_NEW_MSB_ORDER;
-
-
-  if(argc<2) {
-    fprintf(stdout,"Syntax:\n");
-    fprintf(stdout,"    shptree <shpfile> [<depth>] [<index_format>]\n" );
-    fprintf(stdout,"Where:\n");
-    fprintf(stdout," <shpfile> is the name of the .shp file to index.\n");
-    fprintf(stdout," <depth>   (optional) is the maximum depth of the index\n");
-    fprintf(stdout,"           to create, default is 0 meaning that shptree\n");
-    fprintf(stdout,"           will calculate a reasonable default depth.\n");
-    fprintf(stdout," <index_format> (optional) is one of:\n");
-    fprintf(stdout,"           NL: LSB byte order, using new index format\n");
-    fprintf(stdout,"           NM: MSB byte order, using new index format\n");
-    fprintf(stdout,"       The following old format options are deprecated:\n");
-    fprintf(stdout,"           N:  Native byte order\n");
-    fprintf(stdout,"           L:  LSB (intel) byte order\n");
-    fprintf(stdout,"           M:  MSB byte order\n");
-    fprintf(stdout,"       The default index_format on this system is: %s\n\n",
-            (byte_order == MS_NEW_LSB_ORDER) ? "NL" : "NM" );
-    exit(0);
-  }
-
-  if(argc >= 3)
-    depth = atoi(argv[2]);
-
-  if(argc >= 4) {
-    if( !strcasecmp(argv[3],"N" ))
-      byte_order = MS_NATIVE_ORDER;
-    if( !strcasecmp(argv[3],"L" ))
-      byte_order = MS_LSB_ORDER;
-    if( !strcasecmp(argv[3],"M" ))
-      byte_order = MS_MSB_ORDER;
-    if( !strcasecmp(argv[3],"NL" ))
-      byte_order = MS_NEW_LSB_ORDER;
-    if( !strcasecmp(argv[3],"NM" ))
-      byte_order = MS_NEW_MSB_ORDER;
-  }
-
-  if(msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) == -1) {
-    fprintf(stdout, "Error opening shapefile %s.\n", argv[1]);
-    exit(0);
-  }
-
-  printf( "creating index of %s %s format\n",(byte_order < 1 ? "old (deprecated)" :"new"),
-          ((byte_order == MS_NATIVE_ORDER) ? "native" :
-           ((byte_order == MS_LSB_ORDER) || (byte_order == MS_NEW_LSB_ORDER)? " LSB":"MSB")));
-
-  tree = msCreateTree(&shapefile, depth);
-  if(!tree) {
-#if MAX_SUBNODE == 2
-    fprintf(stdout, "Error generating binary tree.\n");
-#else
-    fprintf(stdout, "Error generating quadtree.\n");
-#endif
-    exit(0);
-  }
-
-  msWriteTree(tree, AddFileSuffix(argv[1], MS_INDEX_EXTENSION), byte_order);
-  msDestroyTree(tree);
-
-  /*
-  ** Clean things up
-  */
-  msShapefileClose(&shapefile);
-
-  return(0);
-}
diff -pruN 8.0.1-5/shptreetst.c 8.2.0~beta1-1~exp1/shptreetst.c
--- 8.0.1-5/shptreetst.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/shptreetst.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,179 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Utility program to visualize a quadtree search
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-#include <string.h>
-#ifndef _WIN32
-#include <unistd.h>
-#endif
-#include <stdlib.h>
-#include <limits.h>
-
-
-#ifdef SHPT_POLYGON
-#undef MAPSERVER
-#else
-#define MAPSERVER 1
-#define SHPT_POLYGON MS_SHP_POLYGON
-#endif
-
-
-char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
-  int i;
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension     */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = (int)strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*  Open the .shp and .shx files.  Note that files pulled from      */
-  /*  a PC to Unix with upper case filenames won't work!        */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
-
-  return (pszFullname);
-}
-
-
-int main( int argc, char ** argv )
-
-{
-  SHPTreeHandle qix;
-
-  int i,j;
-  rectObj rect;
-
-  int   pos;
-  ms_bitarray bitmap = NULL;
-
-  /*
-  char  mBigEndian;
-  */
-  treeNodeObj *node = NULL;
-
-
-  /* -------------------------------------------------------------------- */
-  /*      Display a usage message.                                        */
-  /* -------------------------------------------------------------------- */
-  if( argc <= 1 ) {
-    printf( "shptreetst shapefile {minx miny maxx maxy}\n" );
-    exit( 1 );
-  }
-  
-  /*
-  i = 1;
-  if( *((unsigned char *) &i) == 1 )
-    mBigEndian = 0;
-  else
-    mBigEndian = 1;
-  */
-
-  qix = msSHPDiskTreeOpen (AddFileSuffix(argv[1],".qix"), 0 /* no debug*/);
-  if( qix == NULL ) {
-    printf("unable to open index file %s \n", argv[1]);
-    exit(-1);
-  }
-
-  printf ("This %s %s index supports a shapefile with %d shapes, %d depth \n",
-          (qix->version ? "new": "old"), (qix->LSB_order? "LSB": "MSB"), (int) qix->nShapes, (int) qix->nDepth);
-
-  /* -------------------------------------------------------------------- */
-  /*  Skim over the list of shapes, printing all the vertices.  */
-  /* -------------------------------------------------------------------- */
-
-  pos = ftell (qix->fp);
-  j = 0;
-
-  while( pos && j < 20) {
-    j ++;
-    /*      fprintf (stderr,"box %d, at %d pos \n", j, (int) ftell(qix));
-    */
-
-    node = readTreeNode (qix);
-    if (node ) {
-      fprintf (stdout,"shapes %d, node %d, %f,%f,%f,%f \n",(int) node->numshapes,node->numsubnodes,node->rect.minx, node->rect.miny, node->rect.maxx, node->rect.maxy);
-
-    } else {
-      pos = 0;
-    }
-  }
-
-  printf ("read entire file now at quad box rec %d file pos %ld\n", j, ftell (qix->fp));
-
-  j = qix->nShapes;
-  msSHPDiskTreeClose (qix);
-
-  if( argc >= 5 ) {
-    rect.minx = atof (argv[2]);
-    rect.miny = atof (argv[3]);
-    rect.maxx = atof (argv[4]);
-    rect.maxy = atof (argv[5]);
-  } else {
-    if( node == NULL )
-    {
-        printf("node == NULL");
-        return 1;
-    }
-    printf ("using last read box as a search \n");
-    rect.minx =  node->rect.minx;
-    rect.miny =  node->rect.miny;
-    rect.maxx =  node->rect.maxx;
-    rect.maxy =  node->rect.maxy;
-  }
-
-  bitmap = msSearchDiskTree( argv[1], rect, 0 /* no debug*/, j );
-
-  /* j < INT_MAX - 1 test just to please Coverity untrusted bound loop warning */
-  if ( bitmap && j < INT_MAX - 1 ) {
-    printf ("result of rectangle search was \n");
-    for ( i=0; i<j; i++) {
-      if ( msGetBit(bitmap,i) ) {
-        printf(" %d,",i);
-      }
-    }
-  }
-  printf("\n");
-
-
-
-  return(0);
-}
diff -pruN 8.0.1-5/shptreevis.c 8.2.0~beta1-1~exp1/shptreevis.c
--- 8.0.1-5/shptreevis.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/shptreevis.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,246 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Utility program to visualize a quadtree
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-
-#include "mapserver.h"
-#include <string.h>
-#ifndef _WIN32
-#include <unistd.h>
-#endif
-#include <stdlib.h>
-
-
-
-#ifdef SHPT_POLYGON
-#undef MAPSERVER
-#else
-#define MAPSERVER 1
-#define SHPT_POLYGON SHP_POLYGON
-#endif
-
-char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
-  size_t i;
-
-  /* -------------------------------------------------------------------- */
-  /*  Compute the base (layer) name.  If there is any extension     */
-  /*  on the passed in filename we will strip it off.         */
-  /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
-
-  if( pszBasename[i] == '.' )
-    pszBasename[i] = '\0';
-
-  /* -------------------------------------------------------------------- */
-  /*  Open the .shp and .shx files.  Note that files pulled from      */
-  /*  a PC to Unix with upper case filenames won't work!        */
-  /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
-
-  free(pszBasename);
-  return (pszFullname);
-}
-
-
-int main( int argc, char ** argv )
-
-{
-  SHPHandle hSHP;
-  DBFHandle   hDBF;
-  SHPTreeHandle qix;
-
-  char  *myfile = NULL;
-
-  treeNodeObj *node;
-
-#ifdef MAPSERVER
-  shapeObj  shape;
-  lineObj line[3];
-  pointObj  pts[6];
-#else
-  SHPObject *shape;
-  double  X[6], Y[6];
-#endif
-  int   result;
-  
-  /*
-  char  mBigEndian;
-  int   i;
-  */
-
-  int   this_rec;
-
-  /* -------------------------------------------------------------------- */
-  /*      Display a usage message.                                        */
-  /* -------------------------------------------------------------------- */
-  if( argc <= 2 ) {
-    printf( "shptreevis shapefile new_shapefile \n" );
-    exit( 1 );
-  }
-
-  /*
-  i = 1;
-  if( *((unsigned char *) &i) == 1 )
-    mBigEndian = 0;
-  else
-    mBigEndian = 1;
-  */
-
-
-  qix = msSHPDiskTreeOpen (AddFileSuffix(argv[1],".qix"), 0 /* no debug*/);
-  if( qix == NULL ) {
-    printf("unable to open index file %s \n", argv[1]);
-    exit(-1);
-  }
-
-  /* -------------------------------------------------------------------- */
-  /*      Open the passed shapefile.                                      */
-  /* -------------------------------------------------------------------- */
-  myfile = AddFileSuffix(argv[2],".shp");
-
-#ifdef MAPSERVER
-  hSHP = msSHPCreate ( myfile, SHPT_POLYGON );
-  hDBF = msDBFCreate (  AddFileSuffix(argv[2],".dbf") );
-#else
-  hSHP = SHPCreate ( myfile, SHPT_POLYGON );
-  hDBF = DBFCreate (  AddFileSuffix(argv[2],".dbf") );
-#endif
-
-  if ( (!hSHP) || (!hDBF) ) {
-    printf ("create error for %s    ... exiting \n", myfile);
-    exit (-1);
-  }
-
-  /* add fields to dbf */
-#ifdef MAPSERVER
-  msDBFAddField ( hDBF, "ITEMS", FTInteger, 15,0 );
-  msDBFAddField ( hDBF, "SUBNODES", FTInteger, 15,0 );
-  msDBFAddField ( hDBF, "FACTOR", FTInteger, 15,0 );
-#else
-  DBFAddField ( hDBF, "ITEMS", FTInteger, 15,0 );
-  DBFAddField ( hDBF, "SUBNODES", FTInteger, 15,0 );
-  DBFAddField ( hDBF, "FACTOR", FTInteger, 15,0 );
-#endif
-
-#ifndef MAPSERVER
-  SHPClose ( hSHP );
-  hSHP = SHPOpen ( myfile, "r+b" );
-
-  DBFClose (hDBF);
-  hDBF = DBFOpen ( myfile, "r+b");
-#endif
-
-  printf ("This %s %s index supports a shapefile with %d shapes, %d depth \n",
-          (qix->version ? "new": "old"), (qix->LSB_order? "LSB": "MSB"), (int) qix->nShapes, (int) qix->nDepth);
-
-
-  /* -------------------------------------------------------------------- */
-  /*  Skim over the list of shapes, printing all the vertices.  */
-  /* -------------------------------------------------------------------- */
-
-  while( 1 ) {
-    node = readTreeNode (qix);
-    if (node ) {
-
-      this_rec = hDBF->nRecords;
-
-#ifdef  MAPSERVER
-      msDBFWriteIntegerAttribute( hDBF, this_rec, 0, node->numshapes);
-      msDBFWriteIntegerAttribute( hDBF, this_rec, 1, node->numsubnodes);
-#else
-      DBFWriteIntegerAttribute( hDBF, this_rec, 0, node->numshapes);
-      DBFWriteIntegerAttribute( hDBF, this_rec, 1, node->numsubnodes);
-#endif
-
-#ifdef  MAPSERVER
-      shape.numlines = 1;
-      shape.type = SHPT_POLYGON;
-
-      pts[0].x = node->rect.minx;
-      pts[0].y = node->rect.miny;
-      pts[1].x = node->rect.maxx;
-      pts[1].y = node->rect.miny;
-      pts[2].x = node->rect.maxx;
-      pts[2].y = node->rect.maxy;
-      pts[3].x = node->rect.minx;
-      pts[3].y = node->rect.maxy;
-      pts[4].x = node->rect.minx;
-      pts[4].y = node->rect.miny;
-
-      line[0].numpoints = 5;
-      line[0].point = &pts[0];
-      shape.line = &line[0];
-      shape.bounds = node->rect;
-
-      result = msSHPWriteShape ( hSHP, &shape );
-      if ( result < 0 ) {
-        printf ("unable to write shape \n");
-        exit (0);
-      }
-
-#else
-      X[0] = node->rect.minx;
-      X[1] = node->rect.maxx;
-      X[2] = node->rect.maxx;
-      X[3] = node->rect.minx;
-      X[4] = node->rect.minx;
-
-      Y[0] = node->rect.miny;
-      Y[1] = node->rect.miny;
-      Y[2] = node->rect.maxy;
-      Y[3] = node->rect.maxy;
-      Y[4] = node->rect.miny;
-
-      shape = SHPCreateSimpleObject( SHPT_POLYGON, 5, X, Y, NULL);
-      SHPWriteObject(hSHP, -1, shape);
-      SHPDestroyObject ( shape );
-#endif
-    } else
-      break;
-  }
-
-#ifdef MAPSERVER
-  msSHPClose( hSHP );
-  msDBFClose( hDBF );
-#else
-  SHPClose( hSHP );
-  DBFClose( hDBF );
-#endif
-
-  msSHPDiskTreeClose (qix);
-
-  return(0);
-}
diff -pruN 8.0.1-5/sortshp.c 8.2.0~beta1-1~exp1/sortshp.c
--- 8.0.1-5/sortshp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/sortshp.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,244 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Command line utility to sort a shapefile based on a single
- *           attribute in ascending or decending order. Useful for
- *           prioritizing drawing or labeling of shapes.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <math.h>
-#include <string.h>
-
-#include "mapserver.h"
-
-
-
-typedef struct {
-  double number;
-  char string[255];
-  int index;
-} sortStruct;
-
-static int compare_string_descending(const void *a, const void *b)
-{
-  const sortStruct *i = a, *j = b;
-  return(strcmp(j->string, i->string));
-}
-
-static int compare_string_ascending(const void *a, const void *b)
-{
-  const sortStruct *i = a, *j = b;
-  return(strcmp(i->string, j->string));
-}
-
-static int compare_number_descending(const void *a, const void *b)
-{
-  const sortStruct *i = a, *j = b;
-  if(i->number > j->number)
-    return(-1);
-  if(i->number < j->number)
-    return(1);
-  return(0);
-}
-
-static int compare_number_ascending(const void *a, const void *b)
-{
-  const sortStruct *i = a, *j = b;
-  if(i->number > j->number)
-    return(1);
-  if(i->number < j->number)
-    return(-1);
-  return(0);
-}
-
-int main(int argc, char *argv[])
-{
-  SHPHandle    inSHP,outSHP; /* ---- Shapefile file pointers ---- */
-  DBFHandle    inDBF,outDBF; /* ---- DBF file pointers ---- */
-  sortStruct   *array;
-  shapeObj     shape;
-  int          shpType, nShapes;
-  int          fieldNumber=-1; /* ---- Field number of item to be sorted on ---- */
-  DBFFieldType dbfField;
-  char         fName[20];
-  int          fWidth,fnDecimals;
-  char         buffer[1024];
-  int i,j;
-  int num_fields, num_records;
-
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
-    printf("%s\n", msGetVersion());
-    exit(0);
-  }
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Check the number of arguments, return syntax if not correct               */
-  /* ------------------------------------------------------------------------------- */
-  if( argc != 5 ) {
-    fprintf(stderr,"Syntax: sortshp [infile] [outfile] [item] [ascending|descending]\n" );
-    exit(1);
-  }
-
-  msSetErrorFile("stderr", NULL);
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Open the shapefile                                                        */
-  /* ------------------------------------------------------------------------------- */
-  inSHP = msSHPOpen(argv[1], "rb" );
-  if( !inSHP ) {
-    fprintf(stderr,"Unable to open %s shapefile.\n",argv[1]);
-    exit(1);
-  }
-  msSHPGetInfo(inSHP, &nShapes, &shpType);
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Open the dbf file                                                         */
-  /* ------------------------------------------------------------------------------- */
-  snprintf(buffer, sizeof(buffer), "%s.dbf",argv[1]);
-  inDBF = msDBFOpen(buffer,"rb");
-  if( inDBF == NULL ) {
-    fprintf(stderr,"Unable to open %s XBASE file.\n",buffer);
-    exit(1);
-  }
-
-  num_fields = msDBFGetFieldCount(inDBF);
-  num_records = msDBFGetRecordCount(inDBF);
-
-  for(i=0; i<num_fields; i++) {
-    msDBFGetFieldInfo(inDBF,i,fName,NULL,NULL);
-    if(strncasecmp(argv[3],fName,(int)strlen(argv[3])) == 0) { /* ---- Found it ---- */
-      fieldNumber = i;
-      break;
-    }
-  }
-
-  if(fieldNumber < 0) {
-    fprintf(stderr,"Item %s doesn't exist in %s\n",argv[3],buffer);
-    exit(1);
-  }
-
-  array = (sortStruct *)malloc(sizeof(sortStruct)*num_records); /* ---- Allocate the array ---- */
-  if(!array) {
-    fprintf(stderr, "Unable to allocate sort array.\n");
-    exit(1);
-  }
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Load the array to be sorted                                               */
-  /* ------------------------------------------------------------------------------- */
-  dbfField = msDBFGetFieldInfo(inDBF,fieldNumber,NULL,NULL,NULL);
-  switch (dbfField) {
-    case FTString:
-      for(i=0; i<num_records; i++) {
-        strlcpy(array[i].string, msDBFReadStringAttribute( inDBF, i, fieldNumber), sizeof(array[i].string));
-        array[i].index = i;
-      }
-
-      if(*argv[4] == 'd')
-        qsort(array, num_records, sizeof(sortStruct), compare_string_descending);
-      else
-        qsort(array, num_records, sizeof(sortStruct), compare_string_ascending);
-      break;
-    case FTInteger:
-    case FTDouble:
-      for(i=0; i<num_records; i++) {
-        array[i].number = msDBFReadDoubleAttribute( inDBF, i, fieldNumber);
-        array[i].index = i;
-      }
-
-      if(*argv[4] == 'd')
-        qsort(array, num_records, sizeof(sortStruct), compare_number_descending);
-      else
-        qsort(array, num_records, sizeof(sortStruct), compare_number_ascending);
-
-      break;
-    default:
-      fprintf(stderr,"Data type for item %s not supported.\n",argv[3]);
-      exit(1);
-  }
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Setup the output .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
-  outSHP = msSHPCreate(argv[2],shpType);
-  if( outSHP == NULL ) {
-    fprintf( stderr, "Failed to create file '%s'.\n", argv[2] );
-    exit( 1 );
-  }
-
-  sprintf(buffer,"%s.dbf",argv[2]);
-  outDBF = msDBFCreate(buffer);
-  if( outDBF == NULL ) {
-    fprintf( stderr, "Failed to create dbf file '%s'.\n", buffer );
-    exit( 1 );
-  }
-
-  for(i=0; i<num_fields; i++) {
-    dbfField = msDBFGetFieldInfo(inDBF,i,fName,&fWidth,&fnDecimals); /* ---- Get field info from in file ---- */
-    msDBFAddField(outDBF,fName,dbfField,fWidth,fnDecimals);
-  }
-
-  /* ------------------------------------------------------------------------------- */
-  /*       Write the sorted .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
-  for(i=0; i<num_records; i++) { /* ---- For each shape/record ---- */
-
-    for(j=0; j<num_fields; j++) { /* ---- For each .dbf field ---- */
-
-      dbfField = msDBFGetFieldInfo(inDBF,j,fName,&fWidth,&fnDecimals);
-
-      switch (dbfField) {
-        case FTInteger:
-          msDBFWriteIntegerAttribute(outDBF, i, j, msDBFReadIntegerAttribute( inDBF, array[i].index, j));
-          break;
-        case FTDouble:
-          msDBFWriteDoubleAttribute(outDBF, i, j, msDBFReadDoubleAttribute( inDBF, array[i].index, j));
-          break;
-        case FTString:
-          msDBFWriteStringAttribute(outDBF, i, j, msDBFReadStringAttribute( inDBF, array[i].index, j));
-          break;
-        default:
-          fprintf(stderr,"Unsupported data type for field: %s, exiting.\n",fName);
-          exit(0);
-      }
-    }
-
-    msSHPReadShape( inSHP, array[i].index, &shape );
-    msSHPWriteShape( outSHP, &shape );
-    msFreeShape( &shape );
-  }
-
-  free(array);
-
-  msSHPClose(inSHP);
-  msDBFClose(inDBF);
-  msSHPClose(outSHP);
-  msDBFClose(outDBF);
-
-  return(0);
-}
diff -pruN 8.0.1-5/src/apache/CMakeLists.txt 8.2.0~beta1-1~exp1/src/apache/CMakeLists.txt
--- 8.0.1-5/src/apache/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apache/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,45 @@
+add_library(mod_mapserver MODULE mod_mapserver.c)
+target_link_libraries(mod_mapserver ${MAPSERVER_LIBMAPSERVER})
+set_target_properties(mod_mapserver PROPERTIES PREFIX "")
+
+IF(APPLE)
+  if(HTTPD_EXECUTABLE)
+    if(XCODE)
+       SET(CMAKE_C_LINK_FLAGS 
+          "${CMAKE_C_LINK_FLAGS} -bundle_loader ${HTTPD_EXECUTABLE}")
+    else(XCODE)
+       SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS 
+          "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -bundle_loader ${HTTPD_EXECUTABLE}")
+    endif(XCODE)
+  else(HTTPD_EXECUTABLE)
+    if(XCODE)
+       SET(CMAKE_C_LINK_FLAGS 
+          "${CMAKE_C_LINK_FLAGS} -undefined dynamic_lookup")
+    else(XCODE)
+       SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS 
+          "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -Wl,-undefined,dynamic_lookup")
+    endif(XCODE)
+  endif(HTTPD_EXECUTABLE)
+ENDIF(APPLE)
+
+find_package(APACHE)
+if(APACHE_FOUND)
+   include_directories(${APACHE_INCLUDE_DIR})
+else(APACHE_FOUND)
+   report_mandatory_not_found(APACHE)
+endif(APACHE_FOUND)
+
+find_package(APR)
+if(APR_FOUND)
+   include_directories(${APR_INCLUDE_DIR})
+   target_link_libraries(mod_mapserver ${APR_LIBRARY})
+   if(DEFINED APR_CPPFLAGS)
+     add_definitions("${APR_CPPFLAGS}")
+   endif(DEFINED APR_CPPFLAGS)
+else(APR_FOUND)
+   report_mandatory_not_found(APR)
+endif(APR_FOUND)
+
+if(APACHE_MODULE_DIR)
+  INSTALL(TARGETS mod_mapserver DESTINATION ${APACHE_MODULE_DIR})
+endif(APACHE_MODULE_DIR)
diff -pruN 8.0.1-5/src/apache/mod_mapserver.c 8.2.0~beta1-1~exp1/src/apache/mod_mapserver.c
--- 8.0.1-5/src/apache/mod_mapserver.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apache/mod_mapserver.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,446 @@
+/*
+ *  mod_mapserver.c -- Apache sample wms module
+ */
+
+#include "httpd.h"
+#include "http_config.h"
+#include "http_protocol.h"
+#include "http_log.h"
+#include "ap_config.h"
+#include "apr.h"
+#include "apr_strings.h"
+#include "apr_tables.h"
+#include "apr_file_info.h"
+
+#include "../mapserver.h" /* for mapObj */
+#include "../cgiutil.h"
+#include "../apps/mapserv.h"
+
+module AP_MODULE_DECLARE_DATA mapserver_module;
+
+typedef struct {
+  apr_pool_t *config_pool;
+  apr_time_t mtime;
+  char *mapfile_name;
+  char *uri;
+  mapObj *map;
+} mapserver_dir_config;
+
+/* These are the IO redirection hooks. They are mostly copied over from
+ * mapio.c. Note that cbData contains Apache's request_rec!
+ */
+static int msIO_apacheWrite(void *cbData, void *data, int byteCount) {
+  /* simply use the block writing function which is very similiar to fwrite */
+  return ap_rwrite(data, byteCount, (request_rec *)cbData);
+}
+
+static int msIO_apacheError(void *cbData, void *data, int byteCount) {
+  /* error reporting is done through the log file... */
+  ap_log_error(APLOG_MARK, APLOG_ERR, 0, NULL, "%s", (char *)data);
+  return strlen((char *)data);
+}
+
+int msIO_installApacheRedirect(request_rec *r) {
+  msIOContext stdout_ctx, stderr_ctx;
+
+  stdout_ctx.label = "apache";
+  stdout_ctx.write_channel = MS_TRUE;
+  stdout_ctx.readWriteFunc = msIO_apacheWrite;
+  stdout_ctx.cbData = (void *)r;
+
+  stderr_ctx.label = "apache";
+  stderr_ctx.write_channel = MS_TRUE;
+  stderr_ctx.readWriteFunc = msIO_apacheError;
+  stderr_ctx.cbData = (void *)r;
+
+  msIO_installHandlers(NULL, &stdout_ctx, &stderr_ctx);
+
+  return MS_TRUE;
+}
+
+/* The maximum number of arguments we support. The number is taken from
+ * cgiutil.h I think. It is only used for easier param decoding.
+ */
+#define WMS_MAX_ARGS 100
+
+/* This is our simple query decoding function. Should be improved but for now
+ * it works...
+ */
+static int mapserver_decode_args(apr_pool_t *p, char *args, char ***ParamNames,
+                                 char ***ParamValues) {
+  char **argv = NULL;
+  int i;
+  int n;
+  int argc = 0;
+  char *sep;
+
+  /* alloc the name/value pointer list */
+  argv = (char **)apr_pcalloc(p, (WMS_MAX_ARGS + 1) * 2 * sizeof(char *));
+  *ParamNames = argv;
+  *ParamValues = argv + WMS_MAX_ARGS + 1;
+  /* No arguments? Then we're done */
+  if (!args)
+    return 0;
+
+  argv[0] = args;
+
+  /* separate the arguments */
+  for (i = 1, n = 0; args[n] && (i < WMS_MAX_ARGS); n++)
+    if (args[n] == '&') {
+      argv[i++] = args + n + 1;
+      args[n] = '\0';
+    }
+
+  /* eleminate empty args */
+  for (n = 0, i = 0; argv[i]; i++)
+    if (*(argv[i]) != '\0')
+      argv[n++] = argv[i];
+    else
+      argv[i] = NULL;
+
+  /* argument count is the number of non-zero arguments! */
+  argc = n;
+
+  /* split the name/value pairs */
+  for (i = 0; argv[i]; i++) {
+    sep = strchr(argv[i], '=');
+    if (!sep)
+      continue;
+    *sep = '\0';
+    argv[i + WMS_MAX_ARGS + 1] = (char *)apr_pstrdup(p, sep + 1);
+
+    if (ap_unescape_url(argv[i + WMS_MAX_ARGS + 1]) == HTTP_BAD_REQUEST) {
+      ap_log_error(APLOG_MARK, APLOG_ERR, 0, NULL,
+                   "%s: malformed URI, couldn't unescape parm %s", __func__,
+                   argv[i]);
+
+      argv[i + WMS_MAX_ARGS + 1] = NULL;
+    } else {
+      plustospace(argv[i + WMS_MAX_ARGS + 1]);
+    }
+  }
+  return argc;
+}
+
+static char *mapserver_read_post_data(request_rec *r) {
+  int size;
+  long blen, rsize, rpos = 0;
+  char *buffer = NULL;
+  char buf[512];
+
+  if (ap_setup_client_block(r, REQUEST_CHUNKED_ERROR) != OK)
+    return NULL;
+
+  if (!ap_should_client_block(r))
+    return NULL;
+
+  buffer = (char *)apr_palloc(r->pool, r->remaining + 1);
+
+  if (!buffer)
+    return NULL;
+
+  size = r->remaining;
+  buffer[size] = '\0';
+
+  while ((blen = ap_get_client_block(r, buf, sizeof(buf))) > 0) {
+    if (rpos + blen > size) {
+      rsize = blen - rpos;
+    } else {
+      rsize = blen;
+    }
+    memcpy((char *)buffer + rpos, buf, rsize);
+    rpos += rsize;
+  }
+
+  return buffer;
+}
+
+/*
+** Extract Map File name from params and load it.
+** Returns map object or NULL on error.
+*/
+static mapObj *msModuleLoadMap(mapservObj *mapserv,
+                               mapserver_dir_config *conf) {
+  int i;
+  /* OK, here's the magic: we take the mapObj from our stored config.
+   * We will use a copy of it created by msCopyMap since MapServer
+   * modifies the object at several places during request processing
+   */
+  mapObj *map = msNewMapObj();
+  if (!map)
+    return NULL;
+  msCopyMap(map, conf->map);
+
+  /* check for any %variable% substitutions here, also do any map_ changes, we
+   * do this here so WMS/WFS  */
+  /* services can take advantage of these "vendor specific" extensions */
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    /*
+    ** a few CGI variables should be skipped altogether
+    **
+    ** qstring: there is separate per layer validation for attribute queries and
+    *the substitution checks
+    **          below conflict with that so we avoid it here
+    */
+    if (strncasecmp(mapserv->request->ParamNames[i], "qstring", 7) == 0)
+      continue;
+
+    if (strncasecmp(mapserv->request->ParamNames[i], "map_", 4) == 0 ||
+        strncasecmp(mapserv->request->ParamNames[i], "map.", 4) ==
+            0) { /* check to see if there are any additions to the mapfile */
+      if (msUpdateMapFromURL(map, mapserv->request->ParamNames[i],
+                             mapserv->request->ParamValues[i]) != MS_SUCCESS) {
+        msFreeMap(map);
+        return NULL;
+      }
+      continue;
+    }
+  }
+
+  msApplySubstitutions(map, mapserv->request->ParamNames,
+                       mapserv->request->ParamValues,
+                       mapserv->request->NumParams);
+  msApplyDefaultSubstitutions(map);
+
+  /* check to see if a ogc map context is passed as argument. if there */
+  /* is one load it */
+
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "context") == 0) {
+      if (mapserv->request->ParamValues[i] &&
+          strlen(mapserv->request->ParamValues[i]) > 0) {
+        if (strncasecmp(mapserv->request->ParamValues[i], "http", 4) == 0) {
+          if (msGetConfigOption(map, "CGI_CONTEXT_URL"))
+            msLoadMapContextURL(map, mapserv->request->ParamValues[i],
+                                MS_FALSE);
+        } else
+          msLoadMapContext(map, mapserv->request->ParamValues[i], MS_FALSE);
+      }
+    }
+  }
+  /*
+   * RFC-42 HTTP Cookie Forwarding
+   * Here we set the http_cookie_data metadata to handle the
+   * HTTP Cookie Forwarding. The content of this metadata is the cookie
+   * content. In the future, this metadata will probably be replaced
+   * by an object that is part of the mapObject that would contain
+   * information on the application status (such as cookie).
+   */
+  if (mapserv->request->httpcookiedata != NULL) {
+    msInsertHashTable(&(map->web.metadata), "http_cookie_data",
+                      mapserv->request->httpcookiedata);
+  }
+
+  return map;
+}
+
+/***
+ * The main request handler.
+ **/
+static int mapserver_handler(request_rec *r) {
+  /* aquire the apropriate configuration for this directory */
+  mapserver_dir_config *conf;
+  conf = (mapserver_dir_config *)ap_get_module_config(r->per_dir_config,
+                                                      &mapserver_module);
+
+  /* decline the request if there's no map configured */
+  if (!conf || !conf->map)
+    return DECLINED;
+
+  apr_finfo_t mapstat;
+  if (apr_stat(&mapstat, conf->mapfile_name, APR_FINFO_MTIME, r->pool) ==
+      APR_SUCCESS) {
+    if (apr_time_sec(mapstat.mtime) > apr_time_sec(conf->mtime)) {
+      mapObj *newmap = msLoadMap(conf->mapfile_name, NULL);
+      if (newmap) {
+        msFreeMap(conf->map);
+        conf->map = newmap;
+        conf->mtime = mapstat.mtime;
+      } else {
+        ap_log_error(APLOG_MARK, APLOG_WARNING, 0, NULL,
+                     "unable to reload map file %s", conf->mapfile_name);
+      }
+    }
+  } else {
+    ap_log_error(APLOG_MARK, APLOG_WARNING, 0, NULL,
+                 "%s: unable to stat file %s", __func__, conf->mapfile_name);
+  }
+
+  /* make a copy of the URI so we can modify it safely */
+  char *uri = apr_pstrdup(r->pool, r->uri);
+  int len = strlen(uri);
+  int conf_uri_len = strlen(conf->uri);
+
+  /* If the URI points to a subdirectory we want to decline.
+   */
+  if (len > conf_uri_len)
+    return DECLINED;
+
+  int argc = 0;
+  char **ParamNames = NULL;
+  char **ParamValues = NULL;
+  char *post_data = NULL;
+  int szMethod = -1;
+  char *szContentType = NULL;
+  mapservObj *mapserv = NULL;
+
+  /* Try decoding the query string */
+  if (r->method_number == M_GET) {
+    argc = mapserver_decode_args(r->pool, (char *)apr_pstrdup(r->pool, r->args),
+                                 &ParamNames, &ParamValues);
+    szMethod = MS_GET_REQUEST;
+  } else if (r->method_number == M_POST) {
+    szContentType = (char *)apr_table_get(r->headers_in, "Content-Type");
+    post_data = mapserver_read_post_data(r);
+    szMethod = MS_POST_REQUEST;
+    if (strcmp(szContentType, "application/x-www-form-urlencoded") == 0) {
+      argc =
+          mapserver_decode_args(r->pool, (char *)apr_pstrdup(r->pool, r->args),
+                                &ParamNames, &ParamValues);
+    }
+  } else
+    return HTTP_METHOD_NOT_ALLOWED;
+
+  if (!argc && !post_data)
+    return HTTP_BAD_REQUEST;
+
+  /* Now we install the IO redirection.
+   */
+  if (msIO_installApacheRedirect(r) != MS_TRUE)
+    ap_log_error(APLOG_MARK, APLOG_ERR, 0, NULL,
+                 "%s: could not install apache redirect", __func__);
+
+  mapserv = msAllocMapServObj();
+  mapserv->request->NumParams = argc;
+  mapserv->request->ParamNames = ParamNames;
+  mapserv->request->ParamValues = ParamValues;
+  mapserv->request->type = (enum MS_REQUEST_TYPE)szMethod;
+  mapserv->request->postrequest = post_data;
+  mapserv->request->contenttype = szContentType;
+
+  // mapserv->map = msModuleLoadMap(mapserv,conf);
+  mapserv->map = conf->map;
+  if (!mapserv->map) {
+    msCGIWriteError(mapserv);
+    goto end_request;
+  }
+
+  if (msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
+    msCGIWriteError(mapserv);
+    goto end_request;
+  }
+
+end_request:
+  if (mapserv) {
+    mapserv->request->ParamNames = NULL;
+    mapserv->request->ParamValues = NULL;
+    mapserv->request->postrequest = NULL;
+    mapserv->request->contenttype = NULL;
+    mapserv->map = NULL;
+    msFreeMapServObj(mapserv);
+  }
+  msResetErrorList();
+
+  /* Check if status was set inside MapServer functions. If it was, we
+   * return it's value instead of simply OK. This is to support redirects
+   * from maptemplate.c
+   */
+  if (r->status == HTTP_MOVED_TEMPORARILY)
+    return r->status;
+
+  return OK;
+}
+
+/* This function will be called on startup to allow us to register our
+ * handler. We don't do anything else yet...
+ */
+static void mapserver_register_hooks(apr_pool_t *p) {
+  ap_hook_handler(mapserver_handler, NULL, NULL, APR_HOOK_MIDDLE);
+}
+
+/* That's the second part of the overall magic. This function will be called
+ * when the configuration reaches the "WMS_Map" parameter. It will be passed
+ * in as argument and should contain the full path and name of the map file.
+ * We try to load it and store the resulting mapObj in the config of the
+ * current directory. If we fail we throw a message...
+ */
+static const char *mapserver_set_map(cmd_parms *cmd, void *config,
+                                     const char *arg) {
+  mapserver_dir_config *conf = (mapserver_dir_config *)config;
+  /* if the mapObj already exists the WMS_Map was given more than once -
+   * may be the user forgot to comment something out...
+   */
+  if (conf->map) {
+    msWriteError(stderr);
+    return (char *)apr_psprintf(cmd->temp_pool,
+                                "An MAP-file has already been registered for "
+                                "this URI - not accepting '%s'.",
+                                arg);
+  }
+  /* Simply try loading the argument as map file. */
+  conf->mapfile_name = apr_pstrdup(cmd->pool, arg);
+  conf->map = msLoadMap((char *)arg, NULL);
+
+  /* Ooops - we failed. We report it and fail. So beware: Always do a
+   * configcheck before really restarting your web server!
+   */
+
+  if (!conf->map) {
+    msWriteError(stderr);
+    return (char *)apr_psprintf(
+        cmd->temp_pool, "The given MAP-file '%s' could not be loaded", arg);
+  }
+
+  apr_finfo_t status;
+  if (apr_stat(&status, conf->mapfile_name, APR_FINFO_MTIME, cmd->pool) !=
+      APR_SUCCESS) {
+    ap_log_error(APLOG_MARK, APLOG_WARNING, 0, NULL,
+                 "%s: unable to stat file %s", __func__, conf->mapfile_name);
+  }
+  conf->mtime = status.mtime;
+  return NULL;
+}
+
+/* This function creates the (default) directory configuration. Well, we have
+ * no defaults to set so we simply alloc the memory...
+ */
+static void *mapserver_create_dir_config(apr_pool_t *p, char *dir) {
+  mapserver_dir_config *newconf;
+  newconf =
+      (mapserver_dir_config *)apr_pcalloc(p, sizeof(mapserver_dir_config));
+  newconf->config_pool = p;
+  newconf->uri = apr_pstrdup(p, dir);
+  newconf->map = NULL;
+  newconf->mapfile_name = NULL;
+  newconf->mtime = apr_time_from_sec(0);
+
+  if (dir) {
+    int len = strlen(dir);
+    if (len > 1 && dir[len - 1] == '/')
+      newconf->uri[len - 1] = '\0';
+  }
+  return newconf;
+}
+
+/* This structure defines our single config option which takes exactly one
+ * argument.
+ */
+static const command_rec mapserver_options[] = {
+    AP_INIT_TAKE1("Mapfile", mapserver_set_map, NULL, ACCESS_CONF,
+                  "WMS_Map <Path to map file>"),
+    {NULL}};
+
+/* The following structure declares everything Apache needs to treat us as
+ * a module. Merging would mean inheriting from the parent directory but that
+ * doesn't make much sense here since we would only inherit the map file...
+ */
+/* Dispatch list for API hooks */
+module AP_MODULE_DECLARE_DATA mapserver_module = {
+    STANDARD20_MODULE_STUFF,
+    mapserver_create_dir_config, /* create per-dir    config structures */
+    NULL,                        /* merge  per-dir    config structures */
+    NULL,                        /* create per-server config structures */
+    NULL,                        /* merge  per-server config structures */
+    mapserver_options,           /* table of config file commands       */
+    mapserver_register_hooks     /* register hooks                      */
+};
diff -pruN 8.0.1-5/src/apps/coshp.c 8.2.0~beta1-1~exp1/src/apps/coshp.c
--- 8.0.1-5/src/apps/coshp.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/coshp.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,251 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Command line utility to sort a shapefile based on the
+ *           spatial index file.
+ *
+ ******************************************************************************
+ * Copyright (c) 2021 Paul Ramsey <pramsey@cleverelephant.ca>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+#include <string.h>
+
+#include "../mapserver.h"
+
+typedef struct {
+  SHPHandle inSHP, outSHP;
+  DBFHandle inDBF, outDBF;
+  int currentOutRecord;
+  int numDbfFields;
+} writeState;
+
+static char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension     */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = (int)strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*  Open the .shp and .shx files.  Note that files pulled from      */
+  /*  a PC to Unix with upper case filenames won't work!        */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
+
+  free(pszBasename);
+  return (pszFullname);
+}
+
+static int writeShape(writeState *state, int shapeId) {
+  int j = 0;
+  int i = state->currentOutRecord;
+  char fName[20];
+  int fWidth, fnDecimals;
+  shapeObj shape;
+
+  /* Copy the DBF record over */
+  for (j = 0; j < state->numDbfFields; j++) {
+
+    DBFFieldType dbfField =
+        msDBFGetFieldInfo(state->inDBF, j, fName, &fWidth, &fnDecimals);
+
+    switch (dbfField) {
+    case FTInteger:
+      msDBFWriteIntegerAttribute(
+          state->outDBF, i, j,
+          msDBFReadIntegerAttribute(state->inDBF, shapeId, j));
+      break;
+    case FTDouble:
+      msDBFWriteDoubleAttribute(
+          state->outDBF, i, j,
+          msDBFReadDoubleAttribute(state->inDBF, shapeId, j));
+      break;
+    case FTString:
+      msDBFWriteStringAttribute(
+          state->outDBF, i, j,
+          msDBFReadStringAttribute(state->inDBF, shapeId, j));
+      break;
+    default:
+      fprintf(stderr, "Unsupported data type for field: %s, exiting.\n", fName);
+      exit(0);
+    }
+  }
+
+  /* Copy the SHP record over */
+  msSHPReadShape(state->inSHP, shapeId, &shape);
+  msSHPWriteShape(state->outSHP, &shape);
+  msFreeShape(&shape);
+
+  /* Increment output row number */
+  state->currentOutRecord++;
+
+  return MS_SUCCESS;
+}
+
+static int writeNode(writeState *state, treeNodeObj *node) {
+  int i;
+  if (node->ids) {
+    for (i = 0; i < node->numshapes; i++) {
+      int curRec = state->currentOutRecord;
+      writeShape(state, node->ids[i]);
+      node->ids[i] = curRec;
+    }
+  }
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i])
+      writeNode(state, node->subnode[i]);
+  }
+  return MS_SUCCESS;
+}
+
+int main(int argc, char *argv[]) {
+  treeObj *tree;          /* In-memory index */
+  shapefileObj shapefile; /* Input shapefile */
+  SHPHandle outSHP;       /* Output SHP */
+  DBFHandle outDBF;       /* Output DBF */
+  DBFFieldType dbfField;
+  writeState state;
+  int shpType, nShapes;
+  char fName[20];
+  int fWidth, fnDecimals;
+  char buffer[1024];
+  int numFields;
+  int i;
+
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
+    printf("%s\n", msGetVersion());
+    exit(0);
+  }
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Check the number of arguments, return syntax if not correct */
+  /* -------------------------------------------------------------------------------
+   */
+  if (argc != 3) {
+    fprintf(stderr, "Syntax: %s [infile] [outfile]\n", argv[0]);
+    exit(1);
+  }
+
+  msSetErrorFile("stderr", NULL);
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Open the shapefile */
+  /* -------------------------------------------------------------------------------
+   */
+  if (msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) < 0) {
+    fprintf(stdout, "Error opening shapefile %s.\n", argv[1]);
+    exit(0);
+  }
+
+  nShapes = shapefile.numshapes;
+  shpType = shapefile.type;
+  numFields = msDBFGetFieldCount(shapefile.hDBF);
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Index the shapefile (auto-calculate depth) */
+  /* -------------------------------------------------------------------------------
+   */
+  tree = msCreateTree(&shapefile, 0);
+  msTreeTrim(tree);
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Setup the output .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
+  outSHP = msSHPCreate(argv[2], shpType);
+  if (outSHP == NULL) {
+    fprintf(stderr, "Failed to create file '%s'.\n", argv[2]);
+    exit(1);
+  }
+
+  sprintf(buffer, "%s.dbf", argv[2]);
+  outDBF = msDBFCreate(buffer);
+  if (outDBF == NULL) {
+    fprintf(stderr, "Failed to create dbf file '%s'.\n", buffer);
+    exit(1);
+  }
+
+  /* Clone the fields from the input to the output definition */
+  for (i = 0; i < numFields; i++) {
+    dbfField = msDBFGetFieldInfo(
+        shapefile.hDBF, i, fName, &fWidth,
+        &fnDecimals); /* ---- Get field info from in file ---- */
+    msDBFAddField(outDBF, fName, dbfField, fWidth, fnDecimals);
+  }
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Write the sorted .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
+
+  /* Set up writer state */
+  state.inSHP = shapefile.hSHP;
+  state.outSHP = outSHP;
+  state.inDBF = shapefile.hDBF;
+  state.outDBF = outDBF;
+  state.currentOutRecord = 0;
+  state.numDbfFields = numFields;
+
+  writeNode(&state, tree->root);
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Write the spatial index */
+  /* -------------------------------------------------------------------------------
+   */
+  msWriteTree(tree, AddFileSuffix(argv[2], MS_INDEX_EXTENSION),
+              MS_NEW_LSB_ORDER);
+  msDestroyTree(tree);
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Close all files */
+  /* -------------------------------------------------------------------------------
+   */
+  msShapefileClose(&shapefile);
+  msSHPClose(outSHP);
+  msDBFClose(outDBF);
+
+  fprintf(stdout, "Wrote %d spatially sorted shapes into shapefile '%s'\n",
+          nShapes, argv[2]);
+  return (0);
+}
diff -pruN 8.0.1-5/src/apps/coshp.md 8.2.0~beta1-1~exp1/src/apps/coshp.md
--- 8.0.1-5/src/apps/coshp.md	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/coshp.md	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,101 @@
+# MapServer QIX File (aka ShpTree)
+
+https://support.esri.com/en/white-paper/279
+
+## Shape File Model
+
+The shape file consists of three standard components.
+
+* **shp** file contains the binary representations of the shapes (points, lines, polygons)
+* **dbf** file contains the associated attribute information for each shape, one row per shape
+* **shx** includes an ordered list of byte offsets of shapes in the **shp** file
+
+The records in each component are inter-related by their **order of appearance**. The first entry in the **shx** file is the byte offset to the first shape in the shape file, and the first record of the dbf file contains the attributes of the first shape.
+
+In addition to the standard three components, the QIX model adds a fourth component.
+
+* **qix** file contains a binary quad-tree, in which every node in the three includes a bounds, a list of child nodes, and a list of "shape ids" that are contained in that node. The "shape ids" are just the record numbers. So "shape id" **0** corresponds to the first record in the shp/dbf/shx files, and so on.
+
+## Header
+
+There is an **8 byte** header.
+
+* **byte 0, len 3** are file signature string, always "SQT"
+* **byte 3, len 1** signals the byte-order of multi-byte types
+  * [see code](https://github.com/MapServer/MapServer/blob/8af82513f8be8a380acbb5d92f9c5dec360ee5f1/maptree.h#L72-L76)
+  * 1 = LSB (little-endian)
+  * 2 = MSB (big-endian)
+  * 0 = native (the endian of the system that wrote the file (probably LSB))
+* **byte 4, len 1** is the version number
+  * 1 = current version
+* **byte 5, len 3** is reserved for future use
+* **byte 8, len 4** is an **integer** count of number of shapes in the tree
+* **byte 12, len 4** is an **integer** count of depth of the three
+
+All **integer** values may require a byte swap, if the system byte order differs from the file byte order.
+
+## Nodes
+
+Nodes contain an 
+
+* **byte 0, len 4** is an **integer** offset from the just after the numShapes of this node to the start of the next sibling node
+* **byte 4, len 8** is a the **double** minx of the node
+* **byte 12, len 8** is a the **double** miny of the node
+* **byte 20, len 8** is a the **double** maxx of the node
+* **byte 28, len 8** is a the **double** maxy of the node
+* **byte 36, len 4** is an **integer** numShapes, the count of shape ids stored in this node
+* **byte 40, len 4\*numShapes** is an **array of integer** shape ids
+* **btye 40+4\*numShapes, 40+4\*numShapes+4** is an **integer** numChildren number of child nodes under this node
+
+All **integer** and **double** values may require a byte swap, if the system byte order differs from the file byte order.
+
+Note that the **offset** is the distance in bytes from just after the numShapes entry, 40 bytes from the start of the node. Or put another way, "offset + 40" is the distance from the start of **this** node to the start of the **next sibling** node.
+
+## Arrangement of Components
+
+* The file starts with a header.
+* A node and all its descendents always form a contiguous range of the file.
+* A node has at most four children.
+* Both internal and leaf nodes may contain shape ids.
+
+```
+Header
+Node A
+Node AA
+Node AAA
+Node AAB
+Node AAC
+Node AB
+Node ABA
+Node ABB
+Node AC
+Node B
+Node BA
+Node BAA
+Node BAB
+Node BB
+Node C
+```
+
+## Searching
+
+### The Tree
+
+The spatial search will involve a "query box" and will return a list of "shape id".
+
+* Recursively search from the top node.
+* Check that the node box and the query box intersect.
+* If they do not, return.
+* If they do, then add the "shape ids" in the node to the result list.
+* Call the search function on each child node.
+
+You can use the "offset" of each child to find the location of the next child in the set.
+
+Implementation of a reader will probably want to opportunistically load portions of the whole tree into a memory structure, rather than hopping around with random reads. If "distance to next sibling" < some size, load whole subtree into memory and iterate on that.
+
+### For Features
+
+Once the tree search is complete, retrieving the features involves pulling the data from the **shp** and **dbf** files. If the shape file has been "cloud optimized", a query rectangle should involve a minimized number of range requests on the data files, since the order of records should match the order of nodes in the tree.
+
+Analyze the "shape id" list coming out of the tree search, and find contiguous or almost-contiguous ranges of ids. Lookup the [byte offsets](https://www.esri.com/content/dam/esrisites/sitecore-archive/Files/Pdfs/library/whitepapers/pdfs/shapefile.pdf#page=28) from the **shx** file, then retrieve those ranges of data from the **shp** file. The **dbf** file is based on a fixed-length record, so once the header is read, finding the byte offset of a record just involving multiplying the record length by the shape id number.
+
diff -pruN 8.0.1-5/src/apps/legend.c 8.2.0~beta1-1~exp1/src/apps/legend.c
--- 8.0.1-5/src/apps/legend.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/legend.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,65 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Mainline of commandline legend generation test utility.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "../mapserver.h"
+
+int main(int argc, char *argv[]) {
+  mapObj *map = NULL;
+  imageObj *img = NULL;
+
+  msSetup();
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
+    printf("%s\n", msGetVersion());
+    exit(0);
+  }
+
+  if (argc < 3) {
+    fprintf(stdout, "Syntax: legend [mapfile] [output image]\n");
+    exit(0);
+  }
+
+  map = msLoadMap(argv[1], NULL, NULL);
+  if (!map) {
+    msWriteError(stderr);
+    exit(0);
+  }
+
+  img = msDrawLegend(map, MS_FALSE, NULL);
+  if (!img) {
+    msWriteError(stderr);
+    exit(0);
+  }
+
+  msSaveImage(NULL, img, argv[2]);
+
+  msFreeImage(img);
+  msFreeMap(map);
+
+  return (MS_TRUE);
+}
diff -pruN 8.0.1-5/src/apps/map2img.c 8.2.0~beta1-1~exp1/src/apps/map2img.c
--- 8.0.1-5/src/apps/map2img.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/map2img.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,391 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Commandline .map rendering utility, mostly for testing.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <stdbool.h>
+
+#include "../mapserver.h"
+#include "../maptime.h"
+
+#include "limits.h"
+
+/**
+ * Check if the required number of arguments are available for the
+ * parsed option or otherwise print an error message and exit.
+ *
+ * @param option option name for the error message
+ * @param num_required_arguments number of arguments required by option
+ * @param num_remaining_arguments number of arguments following the option
+ * @param config optional config object to free if we exit
+ * @param map optional map object to free if we exit
+ */
+static void hasMoreArgumentsOrExit(const char *option,
+                                   int num_required_arguments,
+                                   int num_remaining_arguments,
+                                   configObj *config, mapObj *map) {
+  if (num_remaining_arguments < num_required_arguments) {
+    if (num_required_arguments == 1)
+      fprintf(stderr, "Argument %s requires an additional argument.\n", option);
+    else
+      fprintf(stderr, "Argument %s needs %i space separated arguments.\n",
+              option, num_required_arguments);
+    msCleanup();
+    msFreeConfig(config);
+    exit(1);
+  }
+}
+
+int main(int argc, char *argv[]) {
+  int i, j, k;
+
+  mapObj *map = NULL;
+  imageObj *image = NULL;
+  configObj *config = NULL;
+
+  char **layers = NULL;
+  int num_layers = 0;
+
+  int layer_found = 0;
+
+  char *outfile = NULL; /* no -o sends image to STDOUT */
+
+  int iterations = 1;
+  int draws = 0;
+
+  /* ---- output version info and exit --- */
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
+    printf("%s\n", msGetVersion());
+    exit(0);
+  }
+
+  /* ---- check the number of arguments, return syntax if not correct ---- */
+  if (argc < 3) {
+    fprintf(stdout, "\nPurpose: convert a mapfile to an image\n\n");
+    fprintf(stdout, "Syntax: map2img -m mapfile [-o image] [-e minx miny maxx "
+                    "maxy] [-s sizex sizey]\n"
+                    "               [-l \"layer1 [layers2...]\"] [-i format]\n"
+                    "               [-all_debug n] [-map_debug n] "
+                    "[-layer_debug n] [-p n] [-c n] [-d layername datavalue]\n"
+                    "               [-conf filename]\n");
+    fprintf(stdout, "  -m mapfile: Map file to operate on - required\n");
+    fprintf(
+        stdout,
+        "  -i format: Override the IMAGETYPE value to pick output format\n");
+    fprintf(stdout, "  -o image: output filename (stdout if not provided)\n");
+    fprintf(stdout, "  -e minx miny maxx maxy: extents to render\n");
+    fprintf(stdout, "  -s sizex sizey: output image size\n");
+    fprintf(stdout, "  -l layers: layers / groups to enable - make sure they "
+                    "are quoted and space separated if more than one listed\n");
+    fprintf(stdout, "  -all_debug n: Set debug level for map and all layers\n");
+    fprintf(stdout, "  -map_debug n: Set map debug level\n");
+    fprintf(stdout, "  -layer_debug layer_name n: Set layer debug level\n");
+    fprintf(stdout, "  -c n: draw map n number of times\n");
+    fprintf(stdout, "  -p n: pause for n seconds after reading the map\n");
+    fprintf(stdout, "  -d layername datavalue: change DATA value for layer\n");
+    fprintf(
+        stdout,
+        "  -conf filename: filename of the MapServer configuration file.\n");
+    exit(0);
+  }
+
+  if (msSetup() != MS_SUCCESS) {
+    msWriteError(stderr);
+    exit(1);
+  }
+
+  bool some_debug_requested = FALSE;
+  const char *config_filename = NULL;
+  for (i = 1; i < argc; i++) {
+    if (strcmp(argv[i], "-c") == 0) { /* user specified number of draws */
+      hasMoreArgumentsOrExit("-c", 1, argc - i - 1, config, map);
+      iterations = atoi(argv[i + 1]);
+      if (iterations < 0 || iterations > INT_MAX - 1) {
+        printf("Invalid number of iterations");
+        return 1;
+      }
+      printf("We will draw %d times...\n", iterations);
+      continue;
+    }
+
+    if (strcmp(argv[i], "-all_debug") == 0) { /* global debug */
+      hasMoreArgumentsOrExit("-all_debug", 1, argc - i - 1, config, map);
+      int debug_level = atoi(argv[++i]);
+
+      some_debug_requested = TRUE;
+
+      msSetGlobalDebugLevel(debug_level);
+
+      continue;
+    }
+
+    if (i < argc - 1 && (strcmp(argv[i], "-map_debug") == 0 ||
+                         strcmp(argv[i], "-layer_debug") == 0)) {
+
+      some_debug_requested = TRUE;
+      continue;
+    }
+
+    if (strcmp(argv[i], "-conf") == 0) {
+      hasMoreArgumentsOrExit("-conf", 1, argc - i - 1, config, map);
+      config_filename = argv[i + 1];
+      ++i;
+      continue;
+    }
+  }
+
+  if (some_debug_requested) {
+    /* Send output to stderr by default */
+    if (msGetErrorFile() == NULL)
+      msSetErrorFile("stderr", NULL);
+  }
+
+  config = msLoadConfig(config_filename);
+
+  for (draws = 0; draws < iterations; draws++) {
+
+    struct mstimeval requeststarttime, requestendtime;
+
+    if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
+      msGettimeofday(&requeststarttime, NULL);
+
+    /* Use PROJ_DATA/PROJ_LIB env vars if set */
+    msProjDataInitFromEnv();
+
+    /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
+    if (msDebugInitFromEnv() != MS_SUCCESS) {
+      msWriteError(stderr);
+      msCleanup();
+      msFreeConfig(config);
+      exit(1);
+    }
+
+    for (i = 1; i < argc;
+         i++) { /* Step though the user arguments, 1st to find map file */
+
+      if (strcmp(argv[i], "-m") == 0) {
+        hasMoreArgumentsOrExit("-m", 1, argc - i - 1, config, map);
+        map = msLoadMap(argv[i + 1], NULL, config);
+        if (!map) {
+          msWriteError(stderr);
+          msCleanup();
+          msFreeConfig(config);
+          exit(1);
+        }
+        msApplyDefaultSubstitutions(map);
+      }
+    }
+
+    if (!map) {
+      fprintf(stderr, "Mapfile (-m) option not specified.\n");
+      msCleanup();
+      msFreeConfig(config);
+      exit(1);
+    }
+
+    for (i = 1; i < argc; i++) { /* Step though the user arguments */
+
+      if (strcmp(argv[i], "-m") == 0) { /* skip it */
+        i += 1;
+      }
+
+      if (strcmp(argv[i], "-p") == 0) {
+        hasMoreArgumentsOrExit("-p", 1, argc - i - 1, config, map);
+        int pause_length = atoi(argv[i + 1]);
+        time_t start_time = time(NULL);
+
+        printf("Start pause of %d seconds.\n", pause_length);
+        while (time(NULL) < start_time + pause_length) {
+        }
+        printf("Done pause.\n");
+
+        i += 1;
+      }
+
+      if (strcmp(argv[i], "-o") == 0) { /* load the output image filename */
+        hasMoreArgumentsOrExit("-o", 1, argc - i - 1, config, map);
+        outfile = argv[i + 1];
+        i += 1;
+      }
+
+      if (strcmp(argv[i], "-i") == 0) {
+        hasMoreArgumentsOrExit("-i", 1, argc - i - 1, config, map);
+        outputFormatObj *format;
+
+        format = msSelectOutputFormat(map, argv[i + 1]);
+
+        if (format == NULL)
+          printf("No such OUTPUTFORMAT as %s.\n", argv[i + 1]);
+        else {
+          msFree((char *)map->imagetype);
+          map->imagetype = msStrdup(argv[i + 1]);
+          msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
+        }
+        i += 1;
+      }
+
+      if (strcmp(argv[i], "-d") == 0) { /* swap layer data */
+        hasMoreArgumentsOrExit("-d", 2, argc - i - 1, config, map);
+        for (j = 0; j < map->numlayers; j++) {
+          if (strcmp(GET_LAYER(map, j)->name, argv[i + 1]) == 0) {
+            free(GET_LAYER(map, j)->data);
+            GET_LAYER(map, j)->data = msStrdup(argv[i + 2]);
+            break;
+          }
+        }
+        i += 2;
+      }
+
+      if (strcmp(argv[i], "-all_debug") == 0) { /* global debug */
+        hasMoreArgumentsOrExit("-all_debug", 1, argc - i - 1, config, map);
+        int debug_level = atoi(argv[++i]);
+
+        /* msSetGlobalDebugLevel() already called. Just need to force debug
+         * level in map and all layers
+         */
+        map->debug = debug_level;
+        for (j = 0; j < map->numlayers; j++) {
+          GET_LAYER(map, j)->debug = debug_level;
+        }
+      }
+
+      if (strcmp(argv[i], "-map_debug") == 0) { /* debug */
+        hasMoreArgumentsOrExit("-map_debug", 1, argc - i - 1, config, map);
+        map->debug = atoi(argv[++i]);
+      }
+
+      if (strcmp(argv[i], "-layer_debug") == 0) { /* debug */
+        hasMoreArgumentsOrExit("-layer_debug", 2, argc - i - 1, config, map);
+        const char *layer_name = argv[++i];
+        int debug_level = atoi(argv[++i]);
+        int got_layer = 0;
+
+        for (j = 0; j < map->numlayers; j++) {
+          if (strcmp(GET_LAYER(map, j)->name, layer_name) == 0) {
+            GET_LAYER(map, j)->debug = debug_level;
+            got_layer = 1;
+          }
+        }
+        if (!got_layer)
+          fprintf(stderr,
+                  " Did not find layer '%s' from -layer_debug switch.\n",
+                  layer_name);
+      }
+
+      if (strcmp(argv[i], "-e") == 0) { /* change extent */
+        hasMoreArgumentsOrExit("-e", 4, argc - i - 1, config, map);
+        map->extent.minx = atof(argv[i + 1]);
+        map->extent.miny = atof(argv[i + 2]);
+        map->extent.maxx = atof(argv[i + 3]);
+        map->extent.maxy = atof(argv[i + 4]);
+        i += 4;
+      }
+
+      if (strcmp(argv[i], "-s") == 0) {
+        hasMoreArgumentsOrExit("-s", 2, argc - i - 1, config, map);
+        msMapSetSize(map, atoi(argv[i + 1]), atoi(argv[i + 2]));
+        i += 2;
+      }
+
+      if (strcmp(argv[i], "-l") == 0) { /* load layer list */
+        hasMoreArgumentsOrExit("-l", 1, argc - i - 1, config, map);
+        layers = msStringSplit(argv[i + 1], ' ', &(num_layers));
+
+        for (j = 0; j < num_layers; j++) { /* loop over -l */
+          layer_found = 0;
+          for (k = 0; k < map->numlayers; k++) {
+            if ((GET_LAYER(map, k)->name &&
+                 strcasecmp(GET_LAYER(map, k)->name, layers[j]) == 0) ||
+                (GET_LAYER(map, k)->group &&
+                 strcasecmp(GET_LAYER(map, k)->group, layers[j]) == 0)) {
+              layer_found = 1;
+              break;
+            }
+          }
+          if (layer_found == 0) {
+            fprintf(stderr, "Layer (-l) \"%s\" not found\n", layers[j]);
+            msFreeCharArray(layers, num_layers);
+            msFreeMap(map);
+            msCleanup();
+            msFreeConfig(config);
+            exit(1);
+          }
+        }
+
+        for (j = 0; j < map->numlayers; j++) {
+          if (GET_LAYER(map, j)->status == MS_DEFAULT)
+            continue;
+          else {
+            GET_LAYER(map, j)->status = MS_OFF;
+            for (k = 0; k < num_layers; k++) {
+              if ((GET_LAYER(map, j)->name &&
+                   strcasecmp(GET_LAYER(map, j)->name, layers[k]) == 0) ||
+                  (GET_LAYER(map, j)->group &&
+                   strcasecmp(GET_LAYER(map, j)->group, layers[k]) == 0)) {
+                GET_LAYER(map, j)->status = MS_ON;
+                break;
+              }
+            }
+          }
+        }
+
+        msFreeCharArray(layers, num_layers);
+
+        i += 1;
+      }
+    }
+
+    image = msDrawMap(map, MS_FALSE);
+
+    if (!image) {
+      msWriteError(stderr);
+
+      msFreeMap(map);
+      msCleanup();
+      msFreeConfig(config);
+      exit(1);
+    }
+
+    if (msSaveImage(map, image, outfile) != MS_SUCCESS) {
+      msWriteError(stderr);
+    }
+
+    msFreeImage(image);
+    msFreeMap(map);
+
+    if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
+      msGettimeofday(&requestendtime, NULL);
+      msDebug("map2img total time: %.3fs\n",
+              (requestendtime.tv_sec + requestendtime.tv_usec / 1.0e6) -
+                  (requeststarttime.tv_sec + requeststarttime.tv_usec / 1.0e6));
+    }
+
+  } /*   for(draws=0; draws<iterations; draws++) { */
+  msCleanup();
+  msFreeConfig(config);
+  return (0);
+} /* ---- END Main Routine ---- */
diff -pruN 8.0.1-5/src/apps/mapserv.c 8.2.0~beta1-1~exp1/src/apps/mapserv.c
--- 8.0.1-5/src/apps/mapserv.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/mapserv.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,330 @@
+/******************************************************************************
+ * $id: mapserv.c 9470 2009-10-16 16:09:31Z sdlime $
+ *
+ * Project:  MapServer
+ * Purpose:  MapServer CGI mainline.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef _XOPEN_SOURCE
+#define _XOPEN_SOURCE 500 // for putenv
+#endif
+
+#include "mapserver-config.h"
+#include <stdbool.h>
+#include <stdlib.h>
+
+#ifdef USE_FASTCGI
+#define NO_FCGI_DEFINES
+#include "fcgi_stdio.h"
+#endif
+
+#include "mapserv.h"
+#include "../mapio.h"
+#include "../maptime.h"
+
+#include "cpl_conv.h"
+
+#ifndef _WIN32
+#include <signal.h>
+#endif
+
+/************************************************************************/
+/*                      FastCGI cleanup functions.                      */
+/************************************************************************/
+
+static int finish_process = 0;
+
+#ifndef _WIN32
+static void msCleanupOnSignal(int nInData) {
+  (void)nInData;
+  finish_process = 1;
+}
+#endif
+
+#ifdef _WIN32
+static void msCleanupOnExit(void) { finish_process = 1; }
+#endif
+
+#ifdef USE_FASTCGI
+
+/************************************************************************/
+/*                           msIO_fcgiRead()                            */
+/*                                                                      */
+/*      This is the default implementation via stdio.                   */
+/************************************************************************/
+
+static int msIO_fcgiRead(void *cbData, void *data, int byteCount)
+
+{
+  return (int)FCGI_fread(data, 1, byteCount, (FCGI_FILE *)cbData);
+}
+
+/************************************************************************/
+/*                           msIO_fcgiWrite()                           */
+/*                                                                      */
+/*      This is the default implementation via stdio.                   */
+/************************************************************************/
+
+static int msIO_fcgiWrite(void *cbData, void *data, int byteCount)
+
+{
+  return (int)FCGI_fwrite(data, 1, byteCount, (FCGI_FILE *)cbData);
+}
+
+/************************************************************************/
+/*                    msIO_installFastCGIRedirect()                     */
+/************************************************************************/
+static int msIO_installFastCGIRedirect()
+
+{
+  msIOContext stdin_ctx, stdout_ctx, stderr_ctx;
+
+  stdin_ctx.label = "fcgi";
+  stdin_ctx.write_channel = MS_FALSE;
+  stdin_ctx.readWriteFunc = msIO_fcgiRead;
+  stdin_ctx.cbData = (void *)FCGI_stdin;
+
+  stdout_ctx.label = "fcgi";
+  stdout_ctx.write_channel = MS_TRUE;
+  stdout_ctx.readWriteFunc = msIO_fcgiWrite;
+  stdout_ctx.cbData = (void *)FCGI_stdout;
+
+  stderr_ctx.label = "fcgi";
+  stderr_ctx.write_channel = MS_TRUE;
+  stderr_ctx.readWriteFunc = msIO_fcgiWrite;
+  stderr_ctx.cbData = (void *)FCGI_stderr;
+
+  msIO_installHandlers(&stdin_ctx, &stdout_ctx, &stderr_ctx);
+
+  return MS_TRUE;
+}
+
+#endif
+/************************************************************************/
+/*                                main()                                */
+/************************************************************************/
+int main(int argc, char *argv[]) {
+  int sendheaders = MS_TRUE;
+  struct mstimeval execstarttime, execendtime;
+  struct mstimeval requeststarttime, requestendtime;
+  mapservObj *mapserv = NULL;
+  configObj *config = NULL;
+
+  /*
+  ** Process -v and -h command line arguments  first end exit. We want to avoid
+  *any error messages
+  ** associated with msLoadConfig() or msSetup().
+  */
+  const char *config_filename = NULL;
+  const bool use_command_line_options = getenv("QUERY_STRING") == NULL;
+  if (use_command_line_options) {
+    /* WARNING:
+     * Do not parse command line arguments (especially those that could have
+     * dangerous consequences if controlled through a web request), without
+     * checking that the QUERY_STRING environment variable is *not* set, because
+     * in a CGI context, command line arguments can be generated from the
+     * content of the QUERY_STRING, and thus cause a security problem. For ex,
+     * "http://example.com/mapserv.cgi?-conf+bar would result in "mapserv.cgi
+     * -conf bar" being invoked. See
+     * https://github.com/MapServer/MapServer/pull/6429#issuecomment-952533589
+     * and https://datatracker.ietf.org/doc/html/rfc3875#section-4.4
+     */
+    for (int iArg = 1; iArg < argc; iArg++) {
+      if (strcmp(argv[iArg], "-v") == 0) {
+        printf("%s\n", msGetVersion());
+        fflush(stdout);
+        exit(0);
+      } else if (strcmp(argv[iArg], "-h") == 0 ||
+                 strcmp(argv[iArg], "--help") == 0) {
+        printf("Usage: mapserv [--help] [-v] [-nh] [QUERY_STRING=value] "
+               "[PATH_INFO=value]\n");
+        printf("                [-conf filename]\n");
+        printf("\n");
+        printf("Options :\n");
+        printf("  -h, --help              Display this help message.\n");
+        printf("  -v                      Display version and exit.\n");
+        printf(
+            "  -nh                     Suppress HTTP headers in CGI mode.\n");
+        printf("  -conf filename          Filename of the MapServer "
+               "configuration file.\n");
+        printf("  QUERY_STRING=value      Set the QUERY_STRING in GET request "
+               "mode.\n");
+        printf("  PATH_INFO=value         Set the PATH_INFO for an API "
+               "request.\n");
+        fflush(stdout);
+        exit(0);
+      } else if (iArg < argc - 1 && strcmp(argv[iArg], "-conf") == 0) {
+        config_filename = argv[iArg + 1];
+        ++iArg;
+      }
+    }
+  }
+
+  config = msLoadConfig(config_filename); // first thing
+  if (config == NULL) {
+#ifdef USE_FASTCGI
+    msIO_installFastCGIRedirect(); // FastCGI setup for error handling here
+    FCGI_Accept();
+#endif
+    msCGIWriteError(mapserv);
+    exit(0);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize mapserver.  This sets up threads, GD and GEOS as     */
+  /*      well as using MS_ERRORFILE and MS_DEBUGLEVEL env vars if set.   */
+  /* -------------------------------------------------------------------- */
+  if (msSetup() != MS_SUCCESS) {
+#ifdef USE_FASTCGI
+    msIO_installFastCGIRedirect(); // FastCGI setup for error handling here
+    FCGI_Accept();
+#endif
+    msCGIWriteError(mapserv);
+    msCleanup();
+    msFreeConfig(config);
+    exit(0);
+  }
+
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&execstarttime, NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*      Process arguments. In normal use as a cgi-bin there are no      */
+  /*      commandline switches, but we provide a few for test/debug       */
+  /*      purposes.                                                       */
+  /* -------------------------------------------------------------------- */
+  if (use_command_line_options) {
+    for (int iArg = 1; iArg < argc; iArg++) {
+      if (strcmp(argv[iArg], "-nh") == 0) {
+        sendheaders = MS_FALSE;
+        msIO_setHeaderEnabled(MS_FALSE);
+      } else if (strncmp(argv[iArg], "QUERY_STRING=", 13) == 0) {
+        /* Debugging hook... pass "QUERY_STRING=..." on the command-line */
+        putenv("REQUEST_METHOD=GET");
+        /* coverity[tainted_string] */
+        putenv(argv[iArg]);
+      } else if (strncmp(argv[iArg], "PATH_INFO=", 10) == 0) {
+        /* Debugging hook for APIs... pass "PATH_INFO=..." on the command-line
+         */
+        putenv("REQUEST_METHOD=GET");
+        /* coverity[tainted_string] */
+        putenv(argv[iArg]);
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup cleanup magic, mainly for FastCGI case.                   */
+  /* -------------------------------------------------------------------- */
+#ifndef _WIN32
+  signal(SIGUSR1, msCleanupOnSignal);
+  signal(SIGTERM, msCleanupOnSignal);
+#endif
+
+#ifdef USE_FASTCGI
+  msIO_installFastCGIRedirect();
+
+  /* In FastCGI case we loop accepting multiple requests.  In normal CGI */
+  /* use we only accept and process one request.  */
+  while (!finish_process && FCGI_Accept() >= 0) {
+#endif /* def USE_FASTCGI */
+
+    /* -------------------------------------------------------------------- */
+    /*      Process a request.                                              */
+    /* -------------------------------------------------------------------- */
+    mapserv = msAllocMapServObj();
+    mapserv->sendheaders = sendheaders; /* override the default if necessary
+                                           (via command line -nh switch) */
+
+    mapserv->request->NumParams =
+        loadParams(mapserv->request, NULL, NULL, 0, NULL);
+    if (msCGIIsAPIRequest(mapserv) == MS_FALSE &&
+        mapserv->request->NumParams == -1) { /* no QUERY_STRING or PATH_INFO */
+      msCGIWriteError(mapserv);
+      goto end_request;
+    }
+
+    mapserv->map = msCGILoadMap(mapserv, config);
+    if (!mapserv->map) {
+      msCGIWriteError(mapserv);
+      goto end_request;
+    }
+
+    if (mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
+      msGettimeofday(&requeststarttime, NULL);
+
+#ifdef USE_FASTCGI
+    if (mapserv->map->debug) {
+      static int nRequestCounter = 1;
+
+      msDebug("CGI Request %d on process %d\n", nRequestCounter, getpid());
+      nRequestCounter++;
+    }
+#endif
+
+    if (mapserv->request->api_path != NULL &&
+        mapserv->request->api_path_length > 1) {
+      // API requests require a map key and a path
+      if (msCGIDispatchAPIRequest(mapserv) != MS_SUCCESS) {
+        msCGIWriteError(mapserv);
+        goto end_request;
+      }
+    } else if (msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
+      msCGIWriteError(mapserv);
+      goto end_request;
+    }
+
+  end_request:
+    if (mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
+      msGettimeofday(&requestendtime, NULL);
+      msDebug("mapserv request processing time (msLoadMap not incl.): %.3fs\n",
+              (requestendtime.tv_sec + requestendtime.tv_usec / 1.0e6) -
+                  (requeststarttime.tv_sec + requeststarttime.tv_usec / 1.0e6));
+    }
+    msFreeMapServObj(mapserv);
+#ifdef USE_FASTCGI
+    /* FCGI_ --- return to top of loop */
+    msResetErrorList();
+    continue;
+  } /* end fastcgi loop */
+#endif
+
+  /* normal case, processing is complete */
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&execendtime, NULL);
+    msDebug("mapserv total execution time: %.3fs\n",
+            (execendtime.tv_sec + execendtime.tv_usec / 1.0e6) -
+                (execstarttime.tv_sec + execstarttime.tv_usec / 1.0e6));
+  }
+  msCleanup();
+  msFreeConfig(config);
+
+#ifdef _WIN32
+  /* flush pending writes to stdout */
+  fflush(stdout);
+#endif
+
+  exit(0);
+}
diff -pruN 8.0.1-5/src/apps/mapserv.h 8.2.0~beta1-1~exp1/src/apps/mapserv.h
--- 8.0.1-5/src/apps/mapserv.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/mapserv.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,75 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Declarations supporting mapserv.c.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPSERV_H
+#define MAPSERV_H
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <process.h>
+#endif
+
+#include <ctype.h>
+#include <time.h>
+
+#include "../maptemplate.h"
+#include "../maptile.h"
+
+#include "../cgiutil.h"
+
+/*
+** Defines
+*/
+#define NUMEXP "[-]?(([0-9]+)|([0-9]*[.][0-9]+)([eE][-+]?[0-9]+)?)"
+#define EXTENT_PADDING .05
+
+/*
+** Macros
+*/
+#define TEMPLATE_TYPE(s)                                                       \
+  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) ||     \
+    (strncmp("ftp://", s, 6)) == 0)                                            \
+       ? MS_URL                                                                \
+       : MS_FILE)
+
+MS_DLL_EXPORT void msCGIWriteError(mapservObj *mapserv);
+MS_DLL_EXPORT mapObj *msCGILoadMap(mapservObj *mapserv, configObj *context);
+int msCGISetMode(mapservObj *mapserv);
+int msCGILoadForm(mapservObj *mapserv);
+int msCGIDispatchBrowseRequest(mapservObj *mapserv);
+int msCGIDispatchCoordinateRequest(mapservObj *mapserv);
+int msCGIDispatchQueryRequest(mapservObj *mapserv);
+int msCGIDispatchImageRequest(mapservObj *mapserv);
+int msCGIDispatchLegendRequest(mapservObj *mapserv);
+int msCGIDispatchLegendIconRequest(mapservObj *mapserv);
+MS_DLL_EXPORT int msCGIDispatchRequest(mapservObj *mapserv);
+
+MS_DLL_EXPORT int msCGIIsAPIRequest(mapservObj *mapserv);
+MS_DLL_EXPORT int msCGIDispatchAPIRequest(mapservObj *mapserv);
+
+#endif /* MAPSERV_H */
diff -pruN 8.0.1-5/src/apps/msencrypt.c 8.2.0~beta1-1~exp1/src/apps/msencrypt.c
--- 8.0.1-5/src/apps/msencrypt.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/msencrypt.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,76 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Command-line encryption utility (see MS-RFC-18)
+ * Author:   Daniel Morissette
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2006 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "../mapserver.h"
+
+void PrintUsage() {
+  printf("Usage: msencrypt <-keygen filename>|<-key filename "
+         "string_to_encrypt>\n");
+}
+
+int main(int argc, char *argv[]) {
+
+  if (argc == 3 && strcmp(argv[1], "-keygen") == 0) {
+
+    /* TODO: Move this to a function */
+    unsigned char pabyKey[16];
+    char szKeyEncoded[50];
+    FILE *fp;
+    msGenerateEncryptionKey(pabyKey);
+    msHexEncode(pabyKey, szKeyEncoded, 16);
+
+    if ((fp = fopen(argv[2], "wt")) != NULL) {
+      fprintf(fp, "%s\n", szKeyEncoded);
+      fclose(fp);
+    } else {
+      printf("ERROR: Failed writing to %s\n", argv[2]);
+      return -1;
+    }
+  } else if (argc == 4 && strcmp(argv[1], "-key") == 0) {
+    unsigned char key[16];
+    char *pszBuf;
+
+    if (msReadEncryptionKeyFromFile(argv[2], key) != MS_SUCCESS) {
+      printf("ERROR: Failed reading key from file %s\n", argv[2]);
+      return -1;
+    }
+
+    pszBuf = (char *)malloc((strlen(argv[3]) * 2 + 17) * sizeof(char));
+    MS_CHECK_ALLOC(pszBuf, (strlen(argv[3]) * 2 + 17) * sizeof(char), -1);
+
+    msEncryptStringWithKey(key, argv[3], pszBuf);
+
+    printf("%s\n", pszBuf);
+    msFree(pszBuf);
+  } else {
+    PrintUsage();
+  }
+
+  return 0;
+}
diff -pruN 8.0.1-5/src/apps/scalebar.c 8.2.0~beta1-1~exp1/src/apps/scalebar.c
--- 8.0.1-5/src/apps/scalebar.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/scalebar.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Commandline scalebar generating utility, mostly for testing.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "../mapserver.h"
+
+int main(int argc, char *argv[]) {
+  mapObj *map = NULL;
+  imageObj *image = NULL;
+
+  msSetup();
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
+    printf("%s\n", msGetVersion());
+    exit(0);
+  }
+
+  /* ---- check the number of arguments, return syntax if not correct ---- */
+  if (argc < 3) {
+    fprintf(stdout, "Syntax: scalebar [mapfile] [output image]\n");
+    exit(1);
+  }
+
+  map = msLoadMap(argv[1], NULL, NULL);
+  if (!map) {
+    msWriteError(stderr);
+    exit(1);
+  }
+
+  image = msDrawScalebar(map);
+
+  if (!image) {
+    msWriteError(stderr);
+    exit(1);
+  }
+
+  msSaveImage(map, image, argv[2]);
+  msFreeImage(image);
+
+  msFreeMap(map);
+  return (MS_TRUE);
+}
diff -pruN 8.0.1-5/src/apps/shptree.c 8.2.0~beta1-1~exp1/src/apps/shptree.c
--- 8.0.1-5/src/apps/shptree.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/shptree.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,159 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Commandline utility to generate .qix shapefile spatial indexes.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "../mapserver.h"
+#include "../maptree.h"
+#include <string.h>
+
+char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension     */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = (int)strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*  Open the .shp and .shx files.  Note that files pulled from      */
+  /*  a PC to Unix with upper case filenames won't work!        */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
+
+  free(pszBasename);
+  return (pszFullname);
+}
+
+int main(int argc, char *argv[]) {
+  shapefileObj shapefile;
+
+  treeObj *tree;
+  int byte_order = MS_NEW_LSB_ORDER, i;
+  int depth = 0;
+
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
+    printf("%s\n", msGetVersion());
+    exit(0);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Establish the byte order on this machine to decide default        */
+  /*    index format                                                      */
+  /* -------------------------------------------------------------------- */
+  i = 1;
+  /* cppcheck-suppress knownConditionTrueFalse */
+  if (*((uchar *)&i) == 1)
+    byte_order = MS_NEW_LSB_ORDER;
+  else
+    byte_order = MS_NEW_MSB_ORDER;
+
+  if (argc < 2) {
+    fprintf(stdout, "Syntax:\n");
+    fprintf(stdout, "    shptree <shpfile> [<depth>] [<index_format>]\n");
+    fprintf(stdout, "Where:\n");
+    fprintf(stdout, " <shpfile> is the name of the .shp file to index.\n");
+    fprintf(stdout,
+            " <depth>   (optional) is the maximum depth of the index\n");
+    fprintf(stdout,
+            "           to create, default is 0 meaning that shptree\n");
+    fprintf(stdout, "           will calculate a reasonable default depth.\n");
+    fprintf(stdout, " <index_format> (optional) is one of:\n");
+    fprintf(stdout, "           NL: LSB byte order, using new index format\n");
+    fprintf(stdout, "           NM: MSB byte order, using new index format\n");
+    fprintf(stdout,
+            "       The following old format options are deprecated:\n");
+    fprintf(stdout, "           N:  Native byte order\n");
+    fprintf(stdout, "           L:  LSB (intel) byte order\n");
+    fprintf(stdout, "           M:  MSB byte order\n");
+    fprintf(stdout, "       The default index_format on this system is: %s\n\n",
+            (byte_order == MS_NEW_LSB_ORDER) ? "NL" : "NM");
+    exit(0);
+  }
+
+  if (argc >= 3)
+    depth = atoi(argv[2]);
+
+  if (argc >= 4) {
+    if (!strcasecmp(argv[3], "N"))
+      byte_order = MS_NATIVE_ORDER;
+    if (!strcasecmp(argv[3], "L"))
+      byte_order = MS_LSB_ORDER;
+    if (!strcasecmp(argv[3], "M"))
+      byte_order = MS_MSB_ORDER;
+    if (!strcasecmp(argv[3], "NL"))
+      byte_order = MS_NEW_LSB_ORDER;
+    if (!strcasecmp(argv[3], "NM"))
+      byte_order = MS_NEW_MSB_ORDER;
+  }
+
+  if (msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) == -1) {
+    fprintf(stdout, "Error opening shapefile %s.\n", argv[1]);
+    exit(0);
+  }
+
+  printf(
+      "creating index of %s %s format\n",
+      (byte_order < 1 ? "old (deprecated)" : "new"),
+      ((byte_order == MS_NATIVE_ORDER)
+           ? "native"
+           : ((byte_order == MS_LSB_ORDER) || (byte_order == MS_NEW_LSB_ORDER)
+                  ? " LSB"
+                  : "MSB")));
+
+  tree = msCreateTree(&shapefile, depth);
+  if (!tree) {
+#if MAX_SUBNODE == 2
+    fprintf(stdout, "Error generating binary tree.\n");
+#else
+    fprintf(stdout, "Error generating quadtree.\n");
+#endif
+    exit(0);
+  }
+
+  msWriteTree(tree, AddFileSuffix(argv[1], MS_INDEX_EXTENSION), byte_order);
+  msDestroyTree(tree);
+
+  /*
+  ** Clean things up
+  */
+  msShapefileClose(&shapefile);
+
+  return (0);
+}
diff -pruN 8.0.1-5/src/apps/shptreetst.c 8.2.0~beta1-1~exp1/src/apps/shptreetst.c
--- 8.0.1-5/src/apps/shptreetst.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/shptreetst.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,178 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Utility program to visualize a quadtree search
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "../mapserver.h"
+#include <string.h>
+#ifndef _WIN32
+#include <unistd.h>
+#endif
+#include <stdlib.h>
+#include <limits.h>
+
+#ifdef SHPT_POLYGON
+#undef MAPSERVER
+#else
+#define MAPSERVER 1
+#define SHPT_POLYGON MS_SHP_POLYGON
+#endif
+
+char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension     */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = (int)strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*  Open the .shp and .shx files.  Note that files pulled from      */
+  /*  a PC to Unix with upper case filenames won't work!        */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
+  msFree(pszBasename);
+
+  return (pszFullname);
+}
+
+int main(int argc, char **argv)
+
+{
+  SHPTreeHandle qix;
+
+  int i, j;
+  rectObj rect;
+
+  int pos;
+  ms_bitarray bitmap = NULL;
+
+  /*
+  char  mBigEndian;
+  */
+  treeNodeObj *node = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Display a usage message.                                        */
+  /* -------------------------------------------------------------------- */
+  if (argc <= 1) {
+    printf("shptreetst shapefile {minx miny maxx maxy}\n");
+    exit(1);
+  }
+
+  /*
+  i = 1;
+  if( *((unsigned char *) &i) == 1 )
+    mBigEndian = 0;
+  else
+    mBigEndian = 1;
+  */
+
+  qix = msSHPDiskTreeOpen(AddFileSuffix(argv[1], ".qix"), 0 /* no debug*/);
+  if (qix == NULL) {
+    printf("unable to open index file %s \n", argv[1]);
+    exit(-1);
+  }
+
+  printf("This %s %s index supports a shapefile with %d shapes, %d depth \n",
+         (qix->version ? "new" : "old"), (qix->LSB_order ? "LSB" : "MSB"),
+         (int)qix->nShapes, (int)qix->nDepth);
+
+  /* -------------------------------------------------------------------- */
+  /*  Skim over the list of shapes, printing all the vertices.  */
+  /* -------------------------------------------------------------------- */
+
+  pos = ftell(qix->fp);
+  j = 0;
+
+  while (pos && j < 20) {
+    j++;
+    /*      fprintf (stderr,"box %d, at %d pos \n", j, (int) ftell(qix));
+     */
+
+    node = readTreeNode(qix);
+    if (node) {
+      fprintf(stdout, "shapes %d, node %d, %f,%f,%f,%f \n",
+              (int)node->numshapes, node->numsubnodes, node->rect.minx,
+              node->rect.miny, node->rect.maxx, node->rect.maxy);
+
+    } else {
+      pos = 0;
+    }
+  }
+
+  printf("read entire file now at quad box rec %d file pos %ld\n", j,
+         ftell(qix->fp));
+
+  j = qix->nShapes;
+  msSHPDiskTreeClose(qix);
+
+  if (argc >= 5) {
+    rect.minx = atof(argv[2]);
+    rect.miny = atof(argv[3]);
+    rect.maxx = atof(argv[4]);
+    rect.maxy = atof(argv[5]);
+  } else {
+    if (node == NULL) {
+      printf("node == NULL");
+      return 1;
+    }
+    printf("using last read box as a search \n");
+    rect.minx = node->rect.minx;
+    rect.miny = node->rect.miny;
+    rect.maxx = node->rect.maxx;
+    rect.maxy = node->rect.maxy;
+  }
+
+  bitmap = msSearchDiskTree(argv[1], rect, 0 /* no debug*/, j);
+
+  /* j < INT_MAX - 1 test just to please Coverity untrusted bound loop warning
+   */
+  if (bitmap && j < INT_MAX - 1) {
+    printf("result of rectangle search was \n");
+    for (i = 0; i < j; i++) {
+      if (msGetBit(bitmap, i)) {
+        printf(" %d,", i);
+      }
+    }
+  }
+  printf("\n");
+
+  return (0);
+}
diff -pruN 8.0.1-5/src/apps/shptreevis.c 8.2.0~beta1-1~exp1/src/apps/shptreevis.c
--- 8.0.1-5/src/apps/shptreevis.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/shptreevis.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,241 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Utility program to visualize a quadtree
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "../mapserver.h"
+#include <string.h>
+#ifndef _WIN32
+#include <unistd.h>
+#endif
+#include <stdlib.h>
+
+#ifdef SHPT_POLYGON
+#undef MAPSERVER
+#else
+#define MAPSERVER 1
+#define SHPT_POLYGON SHP_POLYGON
+#endif
+
+char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
+  size_t i;
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension     */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*  Open the .shp and .shx files.  Note that files pulled from      */
+  /*  a PC to Unix with upper case filenames won't work!        */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
+
+  free(pszBasename);
+  return (pszFullname);
+}
+
+int main(int argc, char **argv)
+
+{
+  SHPHandle hSHP;
+  DBFHandle hDBF;
+  SHPTreeHandle qix;
+
+  char *myfile = NULL;
+
+  treeNodeObj *node;
+
+#ifdef MAPSERVER
+  shapeObj shape;
+  lineObj line[3];
+  pointObj pts[6];
+#else
+  SHPObject *shape;
+  double X[6], Y[6];
+#endif
+  int result;
+
+  /*
+  char  mBigEndian;
+  int   i;
+  */
+
+  int this_rec;
+
+  /* -------------------------------------------------------------------- */
+  /*      Display a usage message.                                        */
+  /* -------------------------------------------------------------------- */
+  if (argc <= 2) {
+    printf("shptreevis shapefile new_shapefile \n");
+    exit(1);
+  }
+
+  /*
+  i = 1;
+  if( *((unsigned char *) &i) == 1 )
+    mBigEndian = 0;
+  else
+    mBigEndian = 1;
+  */
+
+  qix = msSHPDiskTreeOpen(AddFileSuffix(argv[1], ".qix"), 0 /* no debug*/);
+  if (qix == NULL) {
+    printf("unable to open index file %s \n", argv[1]);
+    exit(-1);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Open the passed shapefile.                                      */
+  /* -------------------------------------------------------------------- */
+  myfile = AddFileSuffix(argv[2], ".shp");
+
+#ifdef MAPSERVER
+  hSHP = msSHPCreate(myfile, SHPT_POLYGON);
+  hDBF = msDBFCreate(AddFileSuffix(argv[2], ".dbf"));
+#else
+  hSHP = SHPCreate(myfile, SHPT_POLYGON);
+  hDBF = DBFCreate(AddFileSuffix(argv[2], ".dbf"));
+#endif
+
+  if ((!hSHP) || (!hDBF)) {
+    printf("create error for %s    ... exiting \n", myfile);
+    exit(-1);
+  }
+
+  /* add fields to dbf */
+#ifdef MAPSERVER
+  msDBFAddField(hDBF, "ITEMS", FTInteger, 15, 0);
+  msDBFAddField(hDBF, "SUBNODES", FTInteger, 15, 0);
+  msDBFAddField(hDBF, "FACTOR", FTInteger, 15, 0);
+#else
+  DBFAddField(hDBF, "ITEMS", FTInteger, 15, 0);
+  DBFAddField(hDBF, "SUBNODES", FTInteger, 15, 0);
+  DBFAddField(hDBF, "FACTOR", FTInteger, 15, 0);
+#endif
+
+#ifndef MAPSERVER
+  SHPClose(hSHP);
+  hSHP = SHPOpen(myfile, "r+b");
+
+  DBFClose(hDBF);
+  hDBF = DBFOpen(myfile, "r+b");
+#endif
+
+  printf("This %s %s index supports a shapefile with %d shapes, %d depth \n",
+         (qix->version ? "new" : "old"), (qix->LSB_order ? "LSB" : "MSB"),
+         (int)qix->nShapes, (int)qix->nDepth);
+
+  /* -------------------------------------------------------------------- */
+  /*  Skim over the list of shapes, printing all the vertices.  */
+  /* -------------------------------------------------------------------- */
+
+  while (1) {
+    node = readTreeNode(qix);
+    if (node) {
+
+      this_rec = hDBF->nRecords;
+
+#ifdef MAPSERVER
+      msDBFWriteIntegerAttribute(hDBF, this_rec, 0, node->numshapes);
+      msDBFWriteIntegerAttribute(hDBF, this_rec, 1, node->numsubnodes);
+#else
+      DBFWriteIntegerAttribute(hDBF, this_rec, 0, node->numshapes);
+      DBFWriteIntegerAttribute(hDBF, this_rec, 1, node->numsubnodes);
+#endif
+
+#ifdef MAPSERVER
+      shape.numlines = 1;
+      shape.type = SHPT_POLYGON;
+
+      pts[0].x = node->rect.minx;
+      pts[0].y = node->rect.miny;
+      pts[1].x = node->rect.maxx;
+      pts[1].y = node->rect.miny;
+      pts[2].x = node->rect.maxx;
+      pts[2].y = node->rect.maxy;
+      pts[3].x = node->rect.minx;
+      pts[3].y = node->rect.maxy;
+      pts[4].x = node->rect.minx;
+      pts[4].y = node->rect.miny;
+
+      line[0].numpoints = 5;
+      line[0].point = &pts[0];
+      shape.line = &line[0];
+      shape.bounds = node->rect;
+
+      result = msSHPWriteShape(hSHP, &shape);
+      if (result < 0) {
+        printf("unable to write shape \n");
+        exit(0);
+      }
+
+#else
+      X[0] = node->rect.minx;
+      X[1] = node->rect.maxx;
+      X[2] = node->rect.maxx;
+      X[3] = node->rect.minx;
+      X[4] = node->rect.minx;
+
+      Y[0] = node->rect.miny;
+      Y[1] = node->rect.miny;
+      Y[2] = node->rect.maxy;
+      Y[3] = node->rect.maxy;
+      Y[4] = node->rect.miny;
+
+      shape = SHPCreateSimpleObject(SHPT_POLYGON, 5, X, Y, NULL);
+      SHPWriteObject(hSHP, -1, shape);
+      SHPDestroyObject(shape);
+#endif
+    } else
+      break;
+  }
+
+#ifdef MAPSERVER
+  msSHPClose(hSHP);
+  msDBFClose(hDBF);
+#else
+  SHPClose(hSHP);
+  DBFClose(hDBF);
+#endif
+
+  msSHPDiskTreeClose(qix);
+
+  return (0);
+}
diff -pruN 8.0.1-5/src/apps/sortshp.c 8.2.0~beta1-1~exp1/src/apps/sortshp.c
--- 8.0.1-5/src/apps/sortshp.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/sortshp.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,260 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Command line utility to sort a shapefile based on a single
+ *           attribute in ascending or decending order. Useful for
+ *           prioritizing drawing or labeling of shapes.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+#include <string.h>
+
+#include "../mapserver.h"
+
+typedef struct {
+  double number;
+  char string[255];
+  int index;
+} sortStruct;
+
+static int compare_string_descending(const void *a, const void *b) {
+  const sortStruct *i = a, *j = b;
+  return (strcmp(j->string, i->string));
+}
+
+static int compare_string_ascending(const void *a, const void *b) {
+  const sortStruct *i = a, *j = b;
+  return (strcmp(i->string, j->string));
+}
+
+static int compare_number_descending(const void *a, const void *b) {
+  const sortStruct *i = a, *j = b;
+  if (i->number > j->number)
+    return (-1);
+  if (i->number < j->number)
+    return (1);
+  return (0);
+}
+
+static int compare_number_ascending(const void *a, const void *b) {
+  const sortStruct *i = a, *j = b;
+  if (i->number > j->number)
+    return (1);
+  if (i->number < j->number)
+    return (-1);
+  return (0);
+}
+
+int main(int argc, char *argv[]) {
+  SHPHandle inSHP, outSHP; /* ---- Shapefile file pointers ---- */
+  DBFHandle inDBF, outDBF; /* ---- DBF file pointers ---- */
+  sortStruct *array;
+  shapeObj shape;
+  int shpType, nShapes;
+  int fieldNumber = -1; /* ---- Field number of item to be sorted on ---- */
+  DBFFieldType dbfField;
+  char fName[20];
+  int fWidth, fnDecimals;
+  char buffer[1024];
+  int i, j;
+  int num_fields, num_records;
+
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
+    printf("%s\n", msGetVersion());
+    exit(0);
+  }
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Check the number of arguments, return syntax if not correct */
+  /* -------------------------------------------------------------------------------
+   */
+  if (argc != 5) {
+    fprintf(
+        stderr,
+        "Syntax: sortshp [infile] [outfile] [item] [ascending|descending]\n");
+    exit(1);
+  }
+
+  msSetErrorFile("stderr", NULL);
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Open the shapefile */
+  /* -------------------------------------------------------------------------------
+   */
+  inSHP = msSHPOpen(argv[1], "rb");
+  if (!inSHP) {
+    fprintf(stderr, "Unable to open %s shapefile.\n", argv[1]);
+    exit(1);
+  }
+  msSHPGetInfo(inSHP, &nShapes, &shpType);
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Open the dbf file */
+  /* -------------------------------------------------------------------------------
+   */
+  snprintf(buffer, sizeof(buffer), "%s.dbf", argv[1]);
+  inDBF = msDBFOpen(buffer, "rb");
+  if (inDBF == NULL) {
+    fprintf(stderr, "Unable to open %s XBASE file.\n", buffer);
+    exit(1);
+  }
+
+  num_fields = msDBFGetFieldCount(inDBF);
+  num_records = msDBFGetRecordCount(inDBF);
+
+  for (i = 0; i < num_fields; i++) {
+    msDBFGetFieldInfo(inDBF, i, fName, NULL, NULL);
+    if (strncasecmp(argv[3], fName, (int)strlen(argv[3])) ==
+        0) { /* ---- Found it ---- */
+      fieldNumber = i;
+      break;
+    }
+  }
+
+  if (fieldNumber < 0) {
+    fprintf(stderr, "Item %s doesn't exist in %s\n", argv[3], buffer);
+    exit(1);
+  }
+
+  array = (sortStruct *)malloc(sizeof(sortStruct) *
+                               num_records); /* ---- Allocate the array ---- */
+  if (!array) {
+    fprintf(stderr, "Unable to allocate sort array.\n");
+    exit(1);
+  }
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Load the array to be sorted */
+  /* -------------------------------------------------------------------------------
+   */
+  dbfField = msDBFGetFieldInfo(inDBF, fieldNumber, NULL, NULL, NULL);
+  switch (dbfField) {
+  case FTString:
+    for (i = 0; i < num_records; i++) {
+      strlcpy(array[i].string, msDBFReadStringAttribute(inDBF, i, fieldNumber),
+              sizeof(array[i].string));
+      array[i].index = i;
+    }
+
+    if (*argv[4] == 'd')
+      qsort(array, num_records, sizeof(sortStruct), compare_string_descending);
+    else
+      qsort(array, num_records, sizeof(sortStruct), compare_string_ascending);
+    break;
+  case FTInteger:
+  case FTDouble:
+    for (i = 0; i < num_records; i++) {
+      array[i].number = msDBFReadDoubleAttribute(inDBF, i, fieldNumber);
+      array[i].index = i;
+    }
+
+    if (*argv[4] == 'd')
+      qsort(array, num_records, sizeof(sortStruct), compare_number_descending);
+    else
+      qsort(array, num_records, sizeof(sortStruct), compare_number_ascending);
+
+    break;
+  default:
+    fprintf(stderr, "Data type for item %s not supported.\n", argv[3]);
+    exit(1);
+  }
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Setup the output .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
+  outSHP = msSHPCreate(argv[2], shpType);
+  if (outSHP == NULL) {
+    fprintf(stderr, "Failed to create file '%s'.\n", argv[2]);
+    exit(1);
+  }
+
+  sprintf(buffer, "%s.dbf", argv[2]);
+  outDBF = msDBFCreate(buffer);
+  if (outDBF == NULL) {
+    fprintf(stderr, "Failed to create dbf file '%s'.\n", buffer);
+    exit(1);
+  }
+
+  for (i = 0; i < num_fields; i++) {
+    dbfField = msDBFGetFieldInfo(
+        inDBF, i, fName, &fWidth,
+        &fnDecimals); /* ---- Get field info from in file ---- */
+    msDBFAddField(outDBF, fName, dbfField, fWidth, fnDecimals);
+  }
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Write the sorted .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
+  for (i = 0; i < num_records; i++) { /* ---- For each shape/record ---- */
+
+    for (j = 0; j < num_fields; j++) { /* ---- For each .dbf field ---- */
+
+      dbfField = msDBFGetFieldInfo(inDBF, j, fName, &fWidth, &fnDecimals);
+
+      switch (dbfField) {
+      case FTInteger:
+        msDBFWriteIntegerAttribute(
+            outDBF, i, j, msDBFReadIntegerAttribute(inDBF, array[i].index, j));
+        break;
+      case FTDouble:
+        msDBFWriteDoubleAttribute(
+            outDBF, i, j, msDBFReadDoubleAttribute(inDBF, array[i].index, j));
+        break;
+      case FTString:
+        msDBFWriteStringAttribute(
+            outDBF, i, j, msDBFReadStringAttribute(inDBF, array[i].index, j));
+        break;
+      default:
+        fprintf(stderr, "Unsupported data type for field: %s, exiting.\n",
+                fName);
+        exit(0);
+      }
+    }
+
+    msSHPReadShape(inSHP, array[i].index, &shape);
+    msSHPWriteShape(outSHP, &shape);
+    msFreeShape(&shape);
+  }
+
+  free(array);
+
+  msSHPClose(inSHP);
+  msDBFClose(inDBF);
+  msSHPClose(outSHP);
+  msDBFClose(outDBF);
+
+  return (0);
+}
diff -pruN 8.0.1-5/src/apps/testcopy.c 8.2.0~beta1-1~exp1/src/apps/testcopy.c
--- 8.0.1-5/src/apps/testcopy.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/testcopy.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,81 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Test of msCopyMap()
+ * Author:   Sean Gilles
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "../mapserver.h"
+
+void printAtts(mapObj *, const char *);
+
+int main(int argc, char *argv[]) {
+
+  mapObj *original_map, *clone_map;
+
+  /* ---------------------------------------------------------------------
+   * Test 1: free original before freeing clone
+   * --------------------------------------------------------------------- */
+
+  /* Load map file */
+  original_map = msLoadMap("tests/test.map", NULL);
+
+  if (original_map == NULL) {
+    /* Write errors */
+    msWriteError(stderr);
+    msResetErrorList();
+    exit(0);
+  }
+
+  /* Dump out some attributes */
+  printAtts(original_map, "Original");
+
+  /* Clone it */
+  clone_map = msNewMapObj();
+  msCopyMap(clone_map, original_map);
+
+  /* Write errors */
+  msWriteError(stderr);
+  msResetErrorList();
+
+  /* Free */
+  msFreeMap(original_map);
+
+  /* Dump clone's attributes */
+  printAtts(clone_map, "Clone");
+
+  /* Free clone */
+  msFreeMap(clone_map);
+
+  exit(0);
+}
+
+void printAtts(mapObj *map, const char *title) {
+  printf("\n%s Attributes\n----------------------\n", title);
+  printf("Map Name: %s\n", map->name);
+  printf("Numlayers: %d\n", map->numlayers);
+  printf("Map Fontset Filename: %s\n", map->fontset.filename);
+  printf("Map Symbolset Filename: %s\n", map->symbolset.filename);
+}
diff -pruN 8.0.1-5/src/apps/testexpr.c 8.2.0~beta1-1~exp1/src/apps/testexpr.c
--- 8.0.1-5/src/apps/testexpr.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/testexpr.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,68 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Commandline tester for expression evaluation
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <time.h>
+
+#include "../mapserver.h"
+#include "../mapparser.h"
+#include "../mapfile.h"
+
+extern int msyyparse();
+extern int msyylex();
+extern char *msyystring_buffer;
+
+extern int msyyresult; /* result of parsing, true/false */
+extern int msyystate;
+extern char *msyystring;
+
+int main(int argc, char *argv[]) {
+  int status;
+
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
+    printf("%s\n", msGetVersion());
+    exit(0);
+  }
+
+  /* ---- check the number of arguments, return syntax if not correct ---- */
+  if (argc < 2) {
+    fprintf(stdout, "Syntax: testexpr [string]\n");
+    exit(0);
+  }
+
+  msyystate = MS_TOKENIZE_EXPRESSION;
+  msyystring = argv[1];
+
+  status = msyyparse();
+  if (status != 0)
+    printf("Error parsing expression near %s.\n", msyystring_buffer);
+  else
+    printf("Expression evalulated to: %d.\n", msyyresult);
+
+  exit(0);
+}
diff -pruN 8.0.1-5/src/apps/tile4ms.c 8.2.0~beta1-1~exp1/src/apps/tile4ms.c
--- 8.0.1-5/src/apps/tile4ms.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/apps/tile4ms.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,284 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Create shapefile of rectangles from extents of several shapefiles
+ *           (=tiles)
+ *           Create DBF with file names for shape tiles, in column LOCATION as
+ *           required by mapserv.
+ *           For use with Mapserv tiling capability.
+ * Author:   Herbie Freytag hfreytag@dlwc.nsw.gov.au
+ *
+ * Note:
+ * Resulting shape files do not display in ArcView.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+/*
+ * This is a modified version of Herbie's program that works with MapServer's
+ * shapelib and should be using the MapServer makefile.
+ *
+ */
+
+#include "../mapserver.h"
+#include <string.h>
+
+/***********************************************************************/
+int process_shapefiles(char *metaFileNameP, char *tileFileNameP,
+                       int tile_path_only) {
+  SHPHandle hSHP, tileSHP;
+  rectObj extentRect;
+  lineObj line;
+  shapeObj shapeRect;
+  DBFHandle tileDBF;
+  DBFHandle shpDBF;
+
+  typedef struct DBFFieldDef_struct {
+    DBFFieldType type;
+    char name[12];
+    int width;
+    int decimals;
+  } DBFFieldDef;
+
+  DBFFieldDef *theFields = NULL;
+  char fldname[256];
+  int width;
+  int decimals;
+  int fieldCnt;
+  int i;
+
+  FILE *metaFP = NULL;
+  char *p;
+  char tileshapeName[256];
+  char tiledbfName[256];
+  char shapeFileName[256];
+  int entityNum;
+
+  int tilesFound = 0;
+  int tilesProcessed = 0;
+
+  msInitShape(&shapeRect);
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 5);
+  line.numpoints = 5;
+
+  /* open metafile */
+  /* ------------- */
+  if (NULL == (metaFP = fopen(metaFileNameP, "r"))) {
+    printf("Unable to open:%s\n", metaFileNameP);
+    return (1);
+  }
+
+  /* create new tileindex shapefiles and create a header */
+  /* -------------------------------------------------- */
+  snprintf(tileshapeName, sizeof(tileshapeName), "%s.shp", tileFileNameP);
+
+  if (NULL == (tileSHP = msSHPCreate(tileFileNameP, SHP_POLYGON))) {
+    fclose(metaFP);
+    printf("Unable to create %s.shp (.shx)\n", tileFileNameP);
+    return (1);
+  }
+
+  /* create new tileindex dbf-file */
+  /* ----------------------------- */
+  snprintf(tiledbfName, sizeof(tiledbfName), "%s.dbf", tileFileNameP);
+  if (NULL == (tileDBF = msDBFCreate(tiledbfName))) {
+    fclose(metaFP);
+    msSHPClose(tileSHP);
+    printf("DBFCreate(%s) failed.\n", tiledbfName);
+    return (1);
+  }
+
+  if (msDBFAddField(tileDBF, "LOCATION", FTString, 255, 0) == -1) {
+    fclose(metaFP);
+    msSHPClose(tileSHP);
+    msDBFClose(tileDBF);
+    printf("DBFAddField(fieldname='LOCATION') failed.\n");
+    return (1);
+  }
+
+  /* loop through files listed in metafile */
+  /* ===================================== */
+  while (fgets(shapeFileName, 255, metaFP)) {
+
+    if ((p = strchr(shapeFileName, '\n')) != NULL)
+      *p = '\0';
+
+    if (!strlen(shapeFileName))
+      break;
+
+    tilesFound++;
+
+    /* read the DBFFields for this shapefile */
+    /* and save them if the first, otherwise compare them */
+
+    shpDBF = msDBFOpen(shapeFileName, "rb");
+
+    if (shpDBF == NULL) {
+      printf("Aborted. Unable to open DBF:%s\n", shapeFileName);
+      break;
+    }
+
+    if (theFields == NULL) {
+      fieldCnt = msDBFGetFieldCount(shpDBF);
+      theFields = (DBFFieldDef *)msSmallCalloc(fieldCnt, sizeof(DBFFieldDef));
+      for (i = 0; i < fieldCnt; i++) {
+        theFields[i].type =
+            msDBFGetFieldInfo(shpDBF, i, theFields[i].name, &theFields[i].width,
+                              &theFields[i].decimals);
+        if (theFields[i].type == FTInvalid) {
+          printf("Aborted. DBF Invalid field (%d of %d) file:%s\n", i, fieldCnt,
+                 shapeFileName);
+          break;
+        }
+      }
+    } else {
+      fieldCnt = msDBFGetFieldCount(shpDBF);
+      for (i = 0; i < fieldCnt; i++) {
+        if (theFields[i].type !=
+                msDBFGetFieldInfo(shpDBF, i, fldname, &width, &decimals) ||
+            strcmp(theFields[i].name, fldname) || theFields[i].width != width ||
+            theFields[i].decimals != decimals) {
+          printf("Aborted. DBF fields do not match for file:%s\n",
+                 shapeFileName);
+          break;
+        }
+      }
+    }
+    msDBFClose(shpDBF);
+
+    /* Get rid of .shp extension if it was included. */
+    if (strlen(shapeFileName) > 4 &&
+        (p = shapeFileName + strlen(shapeFileName) - 4) &&
+        strcasecmp(p, ".shp") == 0)
+      *p = '\0';
+
+    if (!strlen(shapeFileName))
+      break;
+
+    /* read extent from shapefile */
+    /* -------------------------- */
+    hSHP = msSHPOpen(shapeFileName, "rb");
+
+    if (hSHP == NULL) {
+      printf("Aborted. Unable to open SHP:%s\n", shapeFileName);
+      break;
+    }
+
+    msSHPReadBounds(hSHP, -1, &extentRect);
+    /* SHPGetInfo(hSHP, &nEntities, &nShapeType, adfBndsMin, adfBndsMax); */
+
+    /* printf("File:  %s Bounds 0/1:
+     * (%15.10lg,%15.10lg)\n\t(%15.10lg,%15.10lg)\n", shapeFileName,
+     * adfBndsMin[0], adfBndsMin[1], adfBndsMax[0], adfBndsMax[1] ); */
+
+    msSHPClose(hSHP);
+
+    /* create rectangle describing current shapefile extent */
+    /* ---------------------------------------------------- */
+
+    line.point[0].x = line.point[4].x = extentRect.minx; /* bottom left */
+    line.point[0].y = line.point[4].y = extentRect.miny;
+    line.point[1].x = extentRect.minx; /* top left */
+    line.point[1].y = extentRect.maxy;
+    line.point[2].x = extentRect.maxx; /* top left */
+    line.point[2].y = extentRect.maxy;
+    line.point[3].x = extentRect.maxx; /* bottom right */
+    line.point[3].y = extentRect.miny;
+
+    /* create and add shape object.  Returns link to entry in DBF file */
+    /* --------------------------------------------------------------- */
+
+    shapeRect.type = MS_SHAPE_POLYGON;
+    msAddLine(&shapeRect, &line);
+    entityNum = msSHPWriteShape(tileSHP, &shapeRect);
+
+    msFreeShape(&shapeRect);
+
+    /* store filepath of current shapefile as attribute of rectangle */
+    /* ------------------------------------------------------------- */
+
+    /* Strip off filename if requested */
+    if (tile_path_only) {
+      char *pszTmp;
+      if ((pszTmp = strrchr(shapeFileName, '/')) != NULL ||
+          (pszTmp = strrchr(shapeFileName, '\\')) != NULL) {
+        *(pszTmp + 1) = '\0'; /* Keep the trailing '/' only. */
+      }
+    }
+
+    msDBFWriteStringAttribute(tileDBF, entityNum, 0, shapeFileName);
+
+    tilesProcessed++;
+  }
+
+  msSHPClose(tileSHP);
+  msDBFClose(tileDBF);
+
+  fclose(metaFP);
+
+  free(line.point);
+  free(theFields);
+
+  printf("Processed %i of %i files\n", tilesProcessed, tilesFound);
+
+  return (0);
+}
+
+/***********************************************************************/
+void print_usage_and_exit(void) {
+
+  printf("\nusage: tile4ms <meta-file> <tile-file> [-tile-path-only]\n");
+  printf("<meta-file>\tINPUT  file containing list of shapefile "
+         "names\n\t\t(complete paths 255 chars max, no extension)\n");
+  printf("<tile-file>\tOUTPUT shape file of extent rectangles and "
+         "names\n\t\tof tiles in <tile-file>.dbf\n");
+  printf("-tile-path-only\tOptional flag.  If specified then only the path to "
+         "the \n\t\tshape files will be stored in the LOCATION "
+         "field\n\t\tinstead of storing the full filename.\n\n");
+  exit(1);
+}
+
+/***********************************************************************/
+int main(int argc, char **argv) {
+  int tile_path_only = 0;
+
+  /* stun user with existence of help  */
+  /* -------------------------------- */
+  if ((argc == 2) && (strstr(argv[1], "-h"))) {
+    print_usage_and_exit();
+  }
+
+  /* check arguments */
+  /* --------------- */
+  if (argc < 3) {
+    print_usage_and_exit();
+  }
+
+  if (argc == 4 && strcmp(argv[3], "-tile-path-only") == 0) {
+    tile_path_only = 1;
+  }
+
+  process_shapefiles(argv[1], argv[2], tile_path_only);
+
+  exit(0);
+}
diff -pruN 8.0.1-5/src/cgiutil.c 8.2.0~beta1-1~exp1/src/cgiutil.c
--- 8.0.1-5/src/cgiutil.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/cgiutil.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,522 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  cgiRequestObj and CGI parameter parsing.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ * Notes: Portions derived from NCSA HTTPd Server's example CGI programs
+ *(util.c).
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+#include "mapserver.h"
+#include "cgiutil.h"
+
+#include "cpl_conv.h"
+
+#define LF 10
+#define CR 13
+
+int readPostBody(cgiRequestObj *request, char **data) {
+  size_t data_max, data_len;
+  int chunk_size;
+
+  (void)request;
+
+  msIO_needBinaryStdin();
+
+  /* -------------------------------------------------------------------- */
+  /*      If the length is provided, read in one gulp.                    */
+  /* -------------------------------------------------------------------- */
+  if (getenv("CONTENT_LENGTH") != NULL) {
+    data_max = (size_t)atoi(getenv("CONTENT_LENGTH"));
+    /* Test for suspicious CONTENT_LENGTH (negative value or SIZE_MAX) */
+    if (data_max >= SIZE_MAX) {
+      // msIO_setHeader("Content-Type","text/html");
+      // msIO_sendHeaders();
+      // msIO_printf("Suspicious Content-Length.\n");
+      msSetError(MS_WEBERR, "Suspicious Content-Length.", "readPostBody()");
+      return MS_FAILURE;
+    }
+    *data = (char *)malloc(data_max + 1);
+    if (*data == NULL) {
+      // msIO_setHeader("Content-Type","text/html");
+      // msIO_sendHeaders();
+      // msIO_printf("malloc() failed, Content-Length: %u unreasonably
+      // large?\n", (unsigned int)data_max );
+      msSetError(MS_WEBERR,
+                 "malloc() failed, Content-Length: %u unreasonably large?",
+                 "readPostBody()", (unsigned int)data_max);
+      return MS_FAILURE;
+    }
+
+    if ((int)msIO_fread(*data, 1, data_max, stdin) < (int)data_max) {
+      // msIO_setHeader("Content-Type","text/html");
+      // msIO_sendHeaders();
+      // msIO_printf("POST body is short\n");
+      msSetError(MS_WEBERR, "POST body is short.", "readPostBody()");
+      return MS_FAILURE;
+    }
+
+    (*data)[data_max] = '\0';
+    return MS_SUCCESS;
+  }
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise read in chunks to the end.                            */
+  /* -------------------------------------------------------------------- */
+#define DATA_ALLOC_SIZE 10000
+
+  data_max = DATA_ALLOC_SIZE;
+  data_len = 0;
+  *data = (char *)msSmallMalloc(data_max + 1);
+  (*data)[data_max] = '\0';
+
+  while ((chunk_size = msIO_fread(*data + data_len, 1, data_max - data_len,
+                                  stdin)) > 0) {
+    data_len += chunk_size;
+
+    if (data_len == data_max) {
+      /* Realloc buffer, making sure we check for possible size_t overflow */
+      if (data_max > SIZE_MAX - (DATA_ALLOC_SIZE + 1)) {
+        // msIO_setHeader("Content-Type","text/html");
+        // msIO_sendHeaders();
+        // msIO_printf("Possible size_t overflow, cannot reallocate input
+        // buffer, POST body too large?\n" );
+        msSetError(MS_WEBERR,
+                   "Possible size_t overflow, cannot reallocate input buffer, "
+                   "POST body too large?",
+                   "readPostBody()");
+        return MS_FAILURE;
+      }
+
+      data_max = data_max + DATA_ALLOC_SIZE;
+      *data = (char *)msSmallRealloc(*data, data_max + 1);
+    }
+  }
+
+  (*data)[data_len] = '\0';
+  return MS_SUCCESS;
+}
+
+static char *msGetEnv(const char *name, void *thread_context) {
+  (void)thread_context;
+  return getenv(name);
+}
+
+int loadParams(cgiRequestObj *request,
+               char *(*getenv2)(const char *, void *thread_context),
+               char *raw_post_data, ms_uint32 raw_post_data_length,
+               void *thread_context) {
+  register int x, m = 0;
+  char *s, *queryString = NULL, *httpCookie = NULL;
+  int debuglevel;
+  int maxParams = MS_DEFAULT_CGI_PARAMS;
+
+  if (getenv2 == NULL)
+    getenv2 = &msGetEnv;
+
+  if (getenv2("REQUEST_METHOD", thread_context) == NULL) {
+    msIO_printf("This script can only be used to decode form results and \n");
+    msIO_printf("should be initiated as a CGI process via a httpd server.\n");
+    msIO_printf("For other options please try using the --help switch.\n");
+    return -1;
+  }
+
+  debuglevel = (int)msGetGlobalDebugLevel();
+
+  if (strcmp(getenv2("REQUEST_METHOD", thread_context), "POST") == 0 &&
+      CPLGetConfigOption("MS_NO_POST", NULL) ==
+          NULL) { /* we've got a post from a form */
+    char *post_data;
+    int data_len;
+    request->type = MS_POST_REQUEST;
+
+    if (request->contenttype == NULL) {
+      s = getenv2("CONTENT_TYPE", thread_context);
+      if (s != NULL) {
+        request->contenttype = msStrdup(s);
+      } else {
+        /* we've to set default Content-Type which is
+         * application/octet-stream according to
+         * W3 RFC 2626 section 7.2.1 */
+        request->contenttype = msStrdup("application/octet-stream");
+      }
+    }
+
+    if (raw_post_data) {
+      post_data = msStrdup(raw_post_data);
+      data_len = raw_post_data_length;
+    } else {
+      if (MS_SUCCESS != readPostBody(request, &post_data))
+        return -1;
+      data_len = strlen(post_data);
+    }
+
+    /* if the content_type is application/x-www-form-urlencoded,
+       we have to parse it like the QUERY_STRING variable */
+    if (strncmp(request->contenttype, "application/x-www-form-urlencoded",
+                strlen("application/x-www-form-urlencoded")) == 0) {
+      while (data_len > 0 && isspace(post_data[data_len - 1]))
+        post_data[--data_len] = '\0';
+
+      while (post_data[0]) {
+        if (m >= maxParams) {
+          maxParams *= 2;
+          request->ParamNames = (char **)msSmallRealloc(
+              request->ParamNames, sizeof(char *) * maxParams);
+          request->ParamValues = (char **)msSmallRealloc(
+              request->ParamValues, sizeof(char *) * maxParams);
+        }
+        request->ParamValues[m] = makeword(post_data, '&');
+        plustospace(request->ParamValues[m]);
+        unescape_url(request->ParamValues[m]);
+        request->ParamNames[m] = makeword(request->ParamValues[m], '=');
+        m++;
+      }
+      free(post_data);
+    } else
+      request->postrequest = post_data;
+
+    /* check the QUERY_STRING even in the post request since it can contain
+       information. Eg a wfs request with  */
+    s = getenv2("QUERY_STRING", thread_context);
+    if (s) {
+      if (debuglevel >= MS_DEBUGLEVEL_DEBUG)
+        msDebug("loadParams() QUERY_STRING: %s\n", s);
+
+      queryString = msStrdup(s);
+      for (x = 0; queryString[0] != '\0'; x++) {
+        if (m >= maxParams) {
+          maxParams *= 2;
+          request->ParamNames = (char **)msSmallRealloc(
+              request->ParamNames, sizeof(char *) * maxParams);
+          request->ParamValues = (char **)msSmallRealloc(
+              request->ParamValues, sizeof(char *) * maxParams);
+        }
+        request->ParamValues[m] = makeword(queryString, '&');
+        plustospace(request->ParamValues[m]);
+        unescape_url(request->ParamValues[m]);
+        request->ParamNames[m] = makeword(request->ParamValues[m], '=');
+        m++;
+      }
+    }
+  } else {
+    if (strcmp(getenv2("REQUEST_METHOD", thread_context), "GET") ==
+        0) { /* we've got a get request */
+      request->type = MS_GET_REQUEST;
+
+      s = getenv2("QUERY_STRING", thread_context);
+      if (s == NULL) {
+        // msIO_setHeader("Content-Type","text/html");
+        // msIO_sendHeaders();
+        // msIO_printf("No query information to decode. QUERY_STRING not
+        // set.\n");
+        msSetError(MS_WEBERR,
+                   "No query information to decode. QUERY_STRING not set.",
+                   "loadParams()");
+        return -1;
+      }
+
+      if (debuglevel >= MS_DEBUGLEVEL_DEBUG)
+        msDebug("loadParams() QUERY_STRING: %s\n", s);
+
+      if (strlen(s) == 0) {
+        // msIO_setHeader("Content-Type","text/html");
+        // msIO_sendHeaders();
+        // msIO_printf("No query information to decode. QUERY_STRING is set, but
+        // empty.\n");
+        msSetError(
+            MS_WEBERR,
+            "No query information to decode. QUERY_STRING is set, but empty.",
+            "loadParams()");
+        return -1;
+      }
+
+      /* don't modify the string returned by getenv2 */
+      queryString = msStrdup(s);
+      for (x = 0; queryString[0] != '\0'; x++) {
+        if (m >= maxParams) {
+          maxParams *= 2;
+          request->ParamNames = (char **)msSmallRealloc(
+              request->ParamNames, sizeof(char *) * maxParams);
+          request->ParamValues = (char **)msSmallRealloc(
+              request->ParamValues, sizeof(char *) * maxParams);
+        }
+        request->ParamValues[m] = makeword(queryString, '&');
+        plustospace(request->ParamValues[m]);
+        unescape_url(request->ParamValues[m]);
+        request->ParamNames[m] = makeword(request->ParamValues[m], '=');
+        m++;
+      }
+    } else {
+      // msIO_setHeader("Content-Type","text/html");
+      // msIO_sendHeaders();
+      // msIO_printf("This script should be referenced with a METHOD of GET or
+      // METHOD of POST.\n");
+      msSetError(MS_WEBERR,
+                 "This script should be referenced with a METHOD of GET or "
+                 "METHOD of POST.",
+                 "loadParams()");
+      return -1;
+    }
+  }
+
+  /* check for any available cookies */
+  s = getenv2("HTTP_COOKIE", thread_context);
+  if (s != NULL) {
+    httpCookie = msStrdup(s);
+    request->httpcookiedata = msStrdup(s);
+    for (x = 0; httpCookie[0] != '\0'; x++) {
+      if (m >= maxParams) {
+        maxParams *= 2;
+        request->ParamNames = (char **)msSmallRealloc(
+            request->ParamNames, sizeof(char *) * maxParams);
+        request->ParamValues = (char **)msSmallRealloc(
+            request->ParamValues, sizeof(char *) * maxParams);
+      }
+      request->ParamValues[m] = makeword(httpCookie, ';');
+      plustospace(request->ParamValues[m]);
+      unescape_url(request->ParamValues[m]);
+      request->ParamNames[m] = makeword_skip(request->ParamValues[m], '=', ' ');
+      m++;
+    }
+  }
+
+  if (queryString)
+    free(queryString);
+  if (httpCookie)
+    free(httpCookie);
+
+  return (m);
+}
+
+void getword(char *word, char *line, char stop) {
+  int x = 0, y;
+
+  for (x = 0; ((line[x]) && (line[x] != stop)); x++)
+    word[x] = line[x];
+
+  word[x] = '\0';
+  if (line[x])
+    ++x;
+  y = 0;
+
+  while ((line[y++] = line[x++]))
+    ;
+}
+
+char *makeword_skip(char *line, char stop, char skip) {
+  int x = 0, y, offset = 0;
+  char *word = (char *)msSmallMalloc(sizeof(char) * (strlen(line) + 1));
+
+  for (x = 0; ((line[x]) && (line[x] == skip)); x++)
+    ;
+  offset = x;
+
+  for (x = offset; ((line[x]) && (line[x] != stop)); x++)
+    word[x - offset] = line[x];
+
+  word[x - offset] = '\0';
+  if (line[x])
+    ++x;
+  y = 0;
+
+  while ((line[y++] = line[x++]))
+    ;
+  return word;
+}
+
+char *makeword(char *line, char stop) {
+  int x = 0, y;
+  char *word = (char *)msSmallMalloc(sizeof(char) * (strlen(line) + 1));
+
+  for (x = 0; ((line[x]) && (line[x] != stop)); x++)
+    word[x] = line[x];
+
+  word[x] = '\0';
+  if (line[x])
+    ++x;
+  y = 0;
+
+  while ((line[y++] = line[x++]))
+    ;
+  return word;
+}
+
+char *fmakeword(FILE *f, char stop, int *cl) {
+  int wsize;
+  char *word;
+  int ll;
+
+  wsize = 102400;
+  ll = 0;
+  word = (char *)msSmallMalloc(sizeof(char) * (wsize + 1));
+
+  while (1) {
+    word[ll] = (char)fgetc(f);
+    if (ll == wsize) {
+      word[ll + 1] = '\0';
+      wsize += 102400;
+      word = (char *)msSmallRealloc(word, sizeof(char) * (wsize + 1));
+    }
+    --(*cl);
+    if ((word[ll] == stop) || (feof(f)) || (!(*cl))) {
+      if (word[ll] != stop)
+        ll++;
+      word[ll] = '\0';
+      word = (char *)msSmallRealloc(word, ll + 1);
+      return word;
+    }
+    ++ll;
+  }
+}
+
+char x2c(char *what) {
+  register char digit;
+
+  digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A') + 10 : (what[0] - '0'));
+  digit *= 16;
+  digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A') + 10 : (what[1] - '0'));
+  return (digit);
+}
+
+void unescape_url(char *url) {
+  register int x, y;
+
+  for (x = 0, y = 0; url[y]; ++x, ++y) {
+    if ((url[x] = url[y]) == '%') {
+      url[x] = x2c(&url[y + 1]);
+      y += 2;
+    }
+  }
+  url[x] = '\0';
+}
+
+void plustospace(char *str) {
+  register int x;
+
+  for (x = 0; str[x]; x++)
+    if (str[x] == '+')
+      str[x] = ' ';
+}
+
+int rind(char *s, char c) {
+  register int x;
+  for (x = strlen(s) - 1; x != -1; x--)
+    if (s[x] == c)
+      return x;
+  return -1;
+}
+
+void send_fd(FILE *f, FILE *fd) {
+  int c;
+
+  while (1) {
+    c = fgetc(f);
+    if (c == EOF)
+      return;
+    fputc((char)c, fd);
+  }
+}
+
+int ind(char *s, char c) {
+  register int x;
+
+  for (x = 0; s[x]; x++)
+    if (s[x] == c)
+      return x;
+
+  return -1;
+}
+
+/*
+** patched version according to CERT advisory...
+*/
+void escape_shell_cmd(char *cmd) {
+  register int x, y, l;
+
+  l = strlen(cmd);
+  for (x = 0; cmd[x]; x++) {
+    if (ind("&;`'\"|*?~<>^()[]{}$\\\n", cmd[x]) != -1) {
+      for (y = l + 1; y > x; y--)
+        cmd[y] = cmd[y - 1];
+      l++; /* length has been increased */
+      cmd[x] = '\\';
+      x++; /* skip the character */
+    }
+  }
+}
+
+/*
+** Allocate a new request holder structure
+*/
+cgiRequestObj *msAllocCgiObj() {
+  cgiRequestObj *request = (cgiRequestObj *)malloc(sizeof(cgiRequestObj));
+
+  if (!request)
+    return NULL;
+
+  request->ParamNames =
+      (char **)msSmallMalloc(MS_DEFAULT_CGI_PARAMS * sizeof(char *));
+  request->ParamValues =
+      (char **)msSmallMalloc(MS_DEFAULT_CGI_PARAMS * sizeof(char *));
+  request->NumParams = 0;
+  request->type = MS_GET_REQUEST;
+  request->contenttype = NULL;
+  request->postrequest = NULL;
+  request->httpcookiedata = NULL;
+
+  request->path_info = NULL;
+  request->api_path = NULL;
+  request->api_path_length = 0;
+
+  return request;
+}
+
+void msFreeCgiObj(cgiRequestObj *request) {
+  msFreeCharArray(request->ParamNames, request->NumParams);
+  msFreeCharArray(request->ParamValues, request->NumParams);
+  request->ParamNames = NULL;
+  request->ParamValues = NULL;
+  request->NumParams = 0;
+  request->type = -1;
+  msFree(request->contenttype);
+  msFree(request->postrequest);
+  msFree(request->httpcookiedata);
+  request->contenttype = NULL;
+  request->postrequest = NULL;
+  request->httpcookiedata = NULL;
+
+  if (request->api_path) {
+    msFreeCharArray(request->api_path, request->api_path_length);
+    request->api_path = NULL;
+    request->api_path_length = 0;
+  }
+
+  msFree(request);
+}
diff -pruN 8.0.1-5/src/cgiutil.h 8.2.0~beta1-1~exp1/src/cgiutil.h
--- 8.0.1-5/src/cgiutil.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/cgiutil.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,112 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  cgiRequestObj and CGI parsing utility related declarations.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ * Notes: Portions derived from NCSA HTTPd Server's example CGI programs
+ *(util.c).
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef CGIUTIL_H
+#define CGIUTIL_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#define MS_DLL_EXPORT __declspec(dllexport)
+#else
+#define MS_DLL_EXPORT
+#endif
+
+/*
+** Misc. defines
+*/
+#define MS_DEFAULT_CGI_PARAMS 100
+
+enum MS_REQUEST_TYPE { MS_GET_REQUEST, MS_POST_REQUEST };
+
+/**
+Class for programming OWS services
+*/
+typedef struct {
+#ifndef SWIG
+  char **ParamNames;
+  char **ParamValues;
+#endif
+
+#ifdef SWIG
+  %immutable;
+#endif
+  int NumParams; ///< The number of querystring parameters
+#ifdef SWIG
+  %mutable;
+#endif
+
+  enum MS_REQUEST_TYPE
+      type; ///< A :ref:`request type constant<mapfile-constants-requesttype>`
+  char *contenttype;    ///< The content type of the request
+  char *postrequest;    ///< Any POST data request
+  char *httpcookiedata; ///< Any cookie data associated with the request
+
+#ifndef SWIG
+  const char *path_info;
+  int api_path_length;
+  char **api_path;
+#endif
+} cgiRequestObj;
+
+/*
+** Function prototypes
+*/
+#ifndef SWIG
+MS_DLL_EXPORT int
+loadParams(cgiRequestObj *request,
+           char *(*getenv2)(const char *, void *thread_context),
+           char *raw_post_data, ms_uint32 raw_post_data_length,
+           void *thread_context);
+MS_DLL_EXPORT void getword(char *, char *, char);
+MS_DLL_EXPORT char *makeword_skip(char *, char, char);
+MS_DLL_EXPORT char *makeword(char *, char);
+MS_DLL_EXPORT char *fmakeword(FILE *, char, int *);
+MS_DLL_EXPORT char x2c(char *);
+MS_DLL_EXPORT void unescape_url(char *);
+MS_DLL_EXPORT void plustospace(char *);
+MS_DLL_EXPORT int rind(char *, char);
+MS_DLL_EXPORT void send_fd(FILE *, FILE *);
+MS_DLL_EXPORT int ind(char *, char);
+MS_DLL_EXPORT void escape_shell_cmd(char *);
+
+MS_DLL_EXPORT cgiRequestObj *msAllocCgiObj(void);
+MS_DLL_EXPORT void msFreeCgiObj(cgiRequestObj *request);
+#endif /*SWIG*/
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* CGIUTIL_H */
diff -pruN 8.0.1-5/src/classobject.c 8.2.0~beta1-1~exp1/src/classobject.c
--- 8.0.1-5/src/classobject.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/classobject.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,197 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Functions for operating on a classObj that don't belong in a
+ *           more specific file such as mapfile.c.
+ *           Adapted from mapobject.c.
+ * Author:   Sean Gillies, sgillies@frii.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2004, Sean Gillies
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+/*
+** Add a label to a classObj (order doesn't matter for labels like it does with
+*styles)
+*/
+int msAddLabelToClass(classObj *class, labelObj *label) {
+  if (!label) {
+    msSetError(MS_CHILDERR, "Can't add a NULL label.", "msAddLabelToClass()");
+    return MS_FAILURE;
+  }
+  if (msGrowClassLabels(class) == NULL)
+    return MS_FAILURE;
+
+  /* msGrowClassLabels will alloc the label, free it in this case */
+  free(class->labels[class->numlabels]);
+  class->labels[class->numlabels] = label;
+  MS_REFCNT_INCR(label);
+  class->numlabels++;
+  return MS_SUCCESS;
+}
+
+/*
+** Remove a label from a classObj.
+*/
+labelObj *msRemoveLabelFromClass(classObj *class, int nLabelIndex) {
+  int i;
+  labelObj *label;
+
+  if (nLabelIndex < 0 || nLabelIndex >= class->numlabels) {
+    msSetError(MS_CHILDERR, "Cannot remove label, invalid index %d",
+               "msRemoveLabelFromClass()", nLabelIndex);
+    return NULL;
+  } else {
+    label = class->labels[nLabelIndex];
+    for (i = nLabelIndex; i < class->numlabels - 1; i++) {
+      class->labels[i] = class->labels[i + 1];
+    }
+    class->labels[class->numlabels - 1] = NULL;
+    class->numlabels--;
+    MS_REFCNT_DECR(label);
+    return label;
+  }
+}
+
+/**
+ * Move the style up inside the array of styles.
+ */
+int msMoveStyleUp(classObj *class, int nStyleIndex) {
+  styleObj *psTmpStyle = NULL;
+  if (class && nStyleIndex < class->numstyles && nStyleIndex > 0) {
+    psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
+    initStyle(psTmpStyle);
+
+    msCopyStyle(psTmpStyle, class->styles[nStyleIndex]);
+
+    msCopyStyle(class->styles[nStyleIndex], class->styles[nStyleIndex - 1]);
+
+    msCopyStyle(class->styles[nStyleIndex - 1], psTmpStyle);
+
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveStyleUp()", nStyleIndex);
+  return (MS_FAILURE);
+}
+
+/**
+ * Move the style down inside the array of styles.
+ */
+int msMoveStyleDown(classObj *class, int nStyleIndex) {
+  styleObj *psTmpStyle = NULL;
+
+  if (class && nStyleIndex < class->numstyles - 1 && nStyleIndex >= 0) {
+    psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
+    initStyle(psTmpStyle);
+
+    msCopyStyle(psTmpStyle, class->styles[nStyleIndex]);
+
+    msCopyStyle(class->styles[nStyleIndex], class->styles[nStyleIndex + 1]);
+
+    msCopyStyle(class->styles[nStyleIndex + 1], psTmpStyle);
+
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveStyleDown()",
+             nStyleIndex);
+  return (MS_FAILURE);
+}
+
+/* Moved here from mapscript.i
+ *
+ * Returns the index at which the style was inserted
+ *
+ */
+int msInsertStyle(classObj *class, styleObj *style, int nStyleIndex) {
+  int i;
+
+  if (!style) {
+    msSetError(MS_CHILDERR, "Can't insert a NULL Style", "msInsertStyle()");
+    return -1;
+  }
+
+  /* Ensure there is room for a new style */
+  if (msGrowClassStyles(class) == NULL) {
+    return -1;
+  }
+  /* Catch attempt to insert past end of styles array */
+  else if (nStyleIndex >= class->numstyles) {
+    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d",
+               "insertStyle()", class->numstyles - 1);
+    return -1;
+  } else if (nStyleIndex < 0) { /* Insert at the end by default */
+    class->styles[class->numstyles] = style;
+    MS_REFCNT_INCR(style);
+    class->numstyles++;
+    return class->numstyles - 1;
+  } else {
+    /* Move styles existing at the specified nStyleIndex or greater */
+    /* to a higher nStyleIndex */
+    for (i = class->numstyles - 1; i >= nStyleIndex; i--) {
+      class->styles[i + 1] = class->styles[i];
+    }
+    class->styles[nStyleIndex] = style;
+    MS_REFCNT_INCR(style);
+    class->numstyles++;
+    return nStyleIndex;
+  }
+}
+
+styleObj *msRemoveStyle(classObj *class, int nStyleIndex) {
+  int i;
+  styleObj *style;
+  if (nStyleIndex < 0 || nStyleIndex >= class->numstyles) {
+    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d",
+               "removeStyle()", nStyleIndex);
+    return NULL;
+  } else {
+    style = class->styles[nStyleIndex];
+    for (i = nStyleIndex; i < class->numstyles - 1; i++) {
+      class->styles[i] = class->styles[i + 1];
+    }
+    class->styles[class->numstyles - 1] = NULL;
+    class->numstyles--;
+    MS_REFCNT_DECR(style);
+    return style;
+  }
+}
+
+/**
+ * Delete the style identified by the index and shift
+ * styles that follows the deleted style.
+ */
+int msDeleteStyle(classObj *class, int nStyleIndex) {
+  if (class && nStyleIndex < class->numstyles && nStyleIndex >= 0) {
+    if (freeStyle(class->styles[nStyleIndex]) == MS_SUCCESS)
+      msFree(class->styles[nStyleIndex]);
+    for (int i = nStyleIndex; i < class->numstyles - 1; i++) {
+      class->styles[i] = class->styles[i + 1];
+    }
+    class->styles[class->numstyles - 1] = NULL;
+    class->numstyles--;
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msDeleteStyle()", nStyleIndex);
+  return (MS_FAILURE);
+}
diff -pruN 8.0.1-5/src/dejavu-sans-condensed.h 8.2.0~beta1-1~exp1/src/dejavu-sans-condensed.h
--- 8.0.1-5/src/dejavu-sans-condensed.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/dejavu-sans-condensed.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,46158 @@
+/*
+Fonts are (c) Bitstream (see below). DejaVu changes are in public domain.
+Glyphs imported from Arev fonts are (c) Tavmjong Bah (see below)
+
+Bitstream Vera Fonts Copyright
+------------------------------
+
+Copyright (c) 2003 by Bitstream, Inc. All Rights Reserved. Bitstream Vera is
+a trademark of Bitstream, Inc.
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of the fonts accompanying this license ("Fonts") and associated
+documentation files (the "Font Software"), to reproduce and distribute the
+Font Software, including without limitation the rights to use, copy, merge,
+publish, distribute, and/or sell copies of the Font Software, and to permit
+persons to whom the Font Software is furnished to do so, subject to the
+following conditions:
+
+The above copyright and trademark notices and this permission notice shall
+be included in all copies of one or more of the Font Software typefaces.
+
+The Font Software may be modified, altered, or added to, and in particular
+the designs of glyphs or characters in the Fonts may be modified and
+additional glyphs or characters may be added to the Fonts, only if the fonts
+are renamed to names not containing either the words "Bitstream" or the word
+"Vera".
+
+This License becomes null and void to the extent applicable to Fonts or Font
+Software that has been modified and is distributed under the "Bitstream
+Vera" names.
+
+The Font Software may be sold as part of a larger software package but no
+copy of one or more of the Font Software typefaces may be sold by itself.
+
+THE FONT SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF COPYRIGHT, PATENT,
+TRADEMARK, OR OTHER RIGHT. IN NO EVENT SHALL BITSTREAM OR THE GNOME
+FOUNDATION BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, INCLUDING
+ANY GENERAL, SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
+WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
+THE USE OR INABILITY TO USE THE FONT SOFTWARE OR FROM OTHER DEALINGS IN THE
+FONT SOFTWARE.
+
+Except as contained in this notice, the names of Gnome, the Gnome
+Foundation, and Bitstream Inc., shall not be used in advertising or
+otherwise to promote the sale, use or other dealings in this Font Software
+without prior written authorization from the Gnome Foundation or Bitstream
+Inc., respectively. For further information, contact: fonts at gnome dot
+org.
+
+Arev Fonts Copyright
+------------------------------
+
+Copyright (c) 2006 by Tavmjong Bah. All Rights Reserved.
+
+Permission is hereby granted, free of charge, to any person obtaining
+a copy of the fonts accompanying this license ("Fonts") and
+associated documentation files (the "Font Software"), to reproduce
+and distribute the modifications to the Bitstream Vera Font Software,
+including without limitation the rights to use, copy, merge, publish,
+distribute, and/or sell copies of the Font Software, and to permit
+persons to whom the Font Software is furnished to do so, subject to
+the following conditions:
+
+The above copyright and trademark notices and this permission notice
+shall be included in all copies of one or more of the Font Software
+typefaces.
+
+The Font Software may be modified, altered, or added to, and in
+particular the designs of glyphs or characters in the Fonts may be
+modified and additional glyphs or characters may be added to the
+Fonts, only if the fonts are renamed to names not containing either
+the words "Tavmjong Bah" or the word "Arev".
+
+This License becomes null and void to the extent applicable to Fonts
+or Font Software that has been modified and is distributed under the
+"Tavmjong Bah Arev" names.
+
+The Font Software may be sold as part of a larger software package but
+no copy of one or more of the Font Software typefaces may be sold by
+itself.
+
+THE FONT SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OF
+MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
+OF COPYRIGHT, PATENT, TRADEMARK, OR OTHER RIGHT. IN NO EVENT SHALL
+TAVMJONG BAH BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+INCLUDING ANY GENERAL, SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL
+DAMAGES, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+FROM, OUT OF THE USE OR INABILITY TO USE THE FONT SOFTWARE OR FROM
+OTHER DEALINGS IN THE FONT SOFTWARE.
+
+Except as contained in this notice, the name of Tavmjong Bah shall not
+be used in advertising or otherwise to promote the sale, use or other
+dealings in this Font Software without prior written authorization
+from Tavmjong Bah. For further information, contact: tavmjong @ free
+. fr.
+*/
+#ifndef _DEJAVU_SANS_CONDENSED_H
+#define _DEJAVU_SANS_CONDENSED_H
+/* to regenerate this file, use the `xxd -i` command */
+unsigned char dejavu_sans_condensed_ttf[] = {
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x13, 0x01, 0x00, 0x00, 0x04, 0x00, 0x30,
+  0x46, 0x46, 0x54, 0x4d, 0x66, 0x09, 0x1f, 0xf9, 0x00, 0x00, 0x01, 0x3c,
+  0x00, 0x00, 0x00, 0x1c, 0x47, 0x44, 0x45, 0x46, 0xc3, 0x10, 0xc5, 0x70,
+  0x00, 0x00, 0x01, 0x58, 0x00, 0x00, 0x01, 0xc2, 0x47, 0x50, 0x4f, 0x53,
+  0xfc, 0xcc, 0xe2, 0x8c, 0x00, 0x00, 0x03, 0x1c, 0x00, 0x00, 0x70, 0xc4,
+  0x47, 0x53, 0x55, 0x42, 0x81, 0x22, 0xfe, 0xaf, 0x00, 0x00, 0x73, 0xe0,
+  0x00, 0x00, 0x0d, 0x50, 0x4f, 0x53, 0x2f, 0x32, 0x8d, 0x18, 0xe6, 0xc7,
+  0x00, 0x00, 0x81, 0x30, 0x00, 0x00, 0x00, 0x56, 0x63, 0x6d, 0x61, 0x70,
+  0x26, 0x77, 0xbd, 0xfb, 0x00, 0x00, 0x81, 0x88, 0x00, 0x00, 0x0e, 0x0e,
+  0x63, 0x76, 0x74, 0x20, 0x00, 0x69, 0x1d, 0x39, 0x00, 0x00, 0x8f, 0x98,
+  0x00, 0x00, 0x01, 0xfe, 0x66, 0x70, 0x67, 0x6d, 0x71, 0x34, 0x76, 0x6a,
+  0x00, 0x00, 0x91, 0x98, 0x00, 0x00, 0x00, 0xab, 0x67, 0x61, 0x73, 0x70,
+  0x00, 0x07, 0x00, 0x07, 0x00, 0x00, 0x92, 0x44, 0x00, 0x00, 0x00, 0x0c,
+  0x67, 0x6c, 0x79, 0x66, 0xbf, 0x93, 0x97, 0x69, 0x00, 0x00, 0x92, 0x50,
+  0x00, 0x06, 0x16, 0x80, 0x68, 0x65, 0x61, 0x64, 0x00, 0x93, 0x52, 0xd5,
+  0x00, 0x06, 0xa8, 0xd0, 0x00, 0x00, 0x00, 0x36, 0x68, 0x68, 0x65, 0x61,
+  0x0c, 0x31, 0x19, 0x73, 0x00, 0x06, 0xa9, 0x08, 0x00, 0x00, 0x00, 0x24,
+  0x68, 0x6d, 0x74, 0x78, 0xd6, 0x38, 0x75, 0x2e, 0x00, 0x06, 0xa9, 0x2c,
+  0x00, 0x00, 0x48, 0x38, 0x6b, 0x65, 0x72, 0x6e, 0x87, 0x38, 0x36, 0x5f,
+  0x00, 0x06, 0xf1, 0x64, 0x00, 0x00, 0x3f, 0xfc, 0x6c, 0x6f, 0x63, 0x61,
+  0x2b, 0x97, 0xe6, 0xcc, 0x00, 0x07, 0x31, 0x60, 0x00, 0x00, 0x48, 0x3c,
+  0x6d, 0x61, 0x78, 0x70, 0x16, 0x7b, 0x04, 0x5b, 0x00, 0x07, 0x79, 0x9c,
+  0x00, 0x00, 0x00, 0x20, 0x6e, 0x61, 0x6d, 0x65, 0xf0, 0xf9, 0x25, 0x82,
+  0x00, 0x07, 0x79, 0xbc, 0x00, 0x00, 0x3d, 0xc5, 0x70, 0x6f, 0x73, 0x74,
+  0x6b, 0x1b, 0xc9, 0x76, 0x00, 0x07, 0xb7, 0x84, 0x00, 0x00, 0xb1, 0xbd,
+  0x70, 0x72, 0x65, 0x70, 0x3b, 0x07, 0xf1, 0x00, 0x00, 0x08, 0x69, 0x44,
+  0x00, 0x00, 0x05, 0x68, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
+  0xc9, 0x89, 0x6f, 0x31, 0x00, 0x00, 0x00, 0x00, 0xce, 0x3f, 0xd8, 0x63,
+  0x00, 0x00, 0x00, 0x00, 0xce, 0x3f, 0xd8, 0x64, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x0e, 0x00, 0x00, 0x01, 0x56, 0x01, 0x5e, 0x00, 0x00, 0x00, 0x02,
+  0x00, 0x36, 0x00, 0x03, 0x02, 0xb0, 0x00, 0x01, 0x02, 0xb1, 0x02, 0xc5,
+  0x00, 0x03, 0x02, 0xc6, 0x02, 0xc6, 0x00, 0x01, 0x02, 0xc7, 0x02, 0xca,
+  0x00, 0x03, 0x02, 0xcb, 0x02, 0xcc, 0x00, 0x01, 0x02, 0xcd, 0x02, 0xd1,
+  0x00, 0x03, 0x02, 0xd2, 0x02, 0xd3, 0x00, 0x01, 0x02, 0xd4, 0x02, 0xe4,
+  0x00, 0x03, 0x02, 0xe5, 0x02, 0xe9, 0x00, 0x01, 0x02, 0xea, 0x02, 0xf3,
+  0x00, 0x03, 0x02, 0xf4, 0x02, 0xf4, 0x00, 0x01, 0x02, 0xf5, 0x02, 0xf5,
+  0x00, 0x03, 0x02, 0xf6, 0x02, 0xf6, 0x00, 0x01, 0x02, 0xf7, 0x02, 0xff,
+  0x00, 0x03, 0x03, 0x00, 0x03, 0x00, 0x00, 0x01, 0x03, 0x01, 0x03, 0x04,
+  0x00, 0x03, 0x03, 0x05, 0x03, 0x05, 0x00, 0x01, 0x03, 0x06, 0x03, 0x06,
+  0x00, 0x03, 0x03, 0x07, 0x03, 0x07, 0x00, 0x01, 0x03, 0x08, 0x03, 0x09,
+  0x00, 0x03, 0x03, 0x0a, 0x03, 0x0a, 0x00, 0x01, 0x03, 0x0b, 0x03, 0x0c,
+  0x00, 0x03, 0x03, 0x0d, 0x04, 0x16, 0x00, 0x01, 0x04, 0x17, 0x04, 0x1b,
+  0x00, 0x03, 0x04, 0x1c, 0x05, 0x49, 0x00, 0x01, 0x05, 0x4a, 0x05, 0x4f,
+  0x00, 0x03, 0x05, 0x50, 0x07, 0x70, 0x00, 0x01, 0x07, 0x71, 0x07, 0x71,
+  0x00, 0x02, 0x07, 0x72, 0x07, 0x7b, 0x00, 0x01, 0x07, 0x7c, 0x07, 0x7e,
+  0x00, 0x02, 0x07, 0x7f, 0x07, 0xd1, 0x00, 0x01, 0x07, 0xd2, 0x07, 0xd2,
+  0x00, 0x02, 0x07, 0xd3, 0x07, 0xe2, 0x00, 0x01, 0x07, 0xe3, 0x07, 0xe9,
+  0x00, 0x03, 0x07, 0xea, 0x07, 0xea, 0x00, 0x02, 0x07, 0xeb, 0x07, 0xee,
+  0x00, 0x01, 0x07, 0xef, 0x07, 0xf0, 0x00, 0x02, 0x07, 0xf1, 0x08, 0x08,
+  0x00, 0x01, 0x08, 0x09, 0x08, 0x0a, 0x00, 0x02, 0x08, 0x0b, 0x08, 0x23,
+  0x00, 0x01, 0x08, 0x24, 0x08, 0x24, 0x00, 0x02, 0x08, 0x25, 0x0f, 0x08,
+  0x00, 0x01, 0x0f, 0x09, 0x0f, 0x0f, 0x00, 0x02, 0x0f, 0x10, 0x0f, 0x10,
+  0x00, 0x01, 0x0f, 0x11, 0x0f, 0x11, 0x00, 0x03, 0x0f, 0x12, 0x0f, 0x12,
+  0x00, 0x01, 0x0f, 0x13, 0x0f, 0x13, 0x00, 0x03, 0x0f, 0x14, 0x10, 0xea,
+  0x00, 0x01, 0x10, 0xeb, 0x10, 0xf5, 0x00, 0x03, 0x10, 0xf6, 0x11, 0x49,
+  0x00, 0x01, 0x11, 0x4a, 0x11, 0x51, 0x00, 0x03, 0x11, 0x52, 0x11, 0xab,
+  0x00, 0x01, 0x11, 0xac, 0x11, 0xac, 0x00, 0x03, 0x11, 0xad, 0x12, 0x0d,
+  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x02,
+  0x00, 0x10, 0x02, 0xb1, 0x02, 0xc6, 0x00, 0x01, 0x02, 0xc7, 0x02, 0xca,
+  0x00, 0x02, 0x02, 0xcd, 0x02, 0xd7, 0x00, 0x02, 0x02, 0xd8, 0x02, 0xd8,
+  0x00, 0x03, 0x02, 0xd9, 0x02, 0xd9, 0x00, 0x04, 0x02, 0xda, 0x02, 0xe4,
+  0x00, 0x02, 0x02, 0xea, 0x02, 0xed, 0x00, 0x02, 0x02, 0xee, 0x02, 0xf5,
+  0x00, 0x01, 0x02, 0xf6, 0x02, 0xf6, 0x00, 0x02, 0x02, 0xf7, 0x02, 0xf7,
+  0x00, 0x01, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x02, 0x02, 0xfb, 0x02, 0xfd,
+  0x00, 0x01, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x02, 0x03, 0x01, 0x03, 0x02,
+  0x00, 0x01, 0x03, 0x03, 0x03, 0x03, 0x00, 0x02, 0x03, 0x04, 0x03, 0x04,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0a, 0x01, 0xd8,
+  0x02, 0x32, 0x00, 0x14, 0x44, 0x46, 0x4c, 0x54, 0x00, 0x7a, 0x61, 0x72,
+  0x61, 0x62, 0x00, 0x86, 0x61, 0x72, 0x6d, 0x6e, 0x00, 0xa8, 0x62, 0x72,
+  0x61, 0x69, 0x00, 0xb4, 0x63, 0x61, 0x6e, 0x73, 0x00, 0xc0, 0x63, 0x68,
+  0x65, 0x72, 0x00, 0xcc, 0x63, 0x79, 0x72, 0x6c, 0x00, 0xd8, 0x67, 0x65,
+  0x6f, 0x72, 0x00, 0xf4, 0x67, 0x72, 0x65, 0x6b, 0x01, 0x00, 0x68, 0x61,
+  0x6e, 0x69, 0x01, 0x10, 0x68, 0x65, 0x62, 0x72, 0x01, 0x1c, 0x6b, 0x61,
+  0x6e, 0x61, 0x01, 0x2a, 0x6c, 0x61, 0x6f, 0x20, 0x01, 0x36, 0x6c, 0x61,
+  0x74, 0x6e, 0x01, 0x42, 0x6d, 0x61, 0x74, 0x68, 0x01, 0x82, 0x6e, 0x6b,
+  0x6f, 0x20, 0x01, 0x8e, 0x6f, 0x67, 0x61, 0x6d, 0x01, 0x9c, 0x72, 0x75,
+  0x6e, 0x72, 0x01, 0xa8, 0x74, 0x66, 0x6e, 0x67, 0x01, 0xb4, 0x74, 0x68,
+  0x61, 0x69, 0x01, 0xc2, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x16, 0x00, 0x03, 0x4b, 0x55, 0x52, 0x20,
+  0x00, 0x16, 0x53, 0x4e, 0x44, 0x20, 0x00, 0x16, 0x55, 0x52, 0x44, 0x20,
+  0x00, 0x16, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x10, 0x00, 0x02, 0x4d, 0x4b, 0x44, 0x20, 0x00, 0x10,
+  0x53, 0x52, 0x42, 0x20, 0x00, 0x10, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
+  0x00, 0x00, 0x00, 0x03, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0x06, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x00, 0x02,
+  0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x34, 0x00, 0x08, 0x49, 0x53, 0x4d, 0x20, 0x00, 0x34, 0x4b, 0x53,
+  0x4d, 0x20, 0x00, 0x34, 0x4c, 0x53, 0x4d, 0x20, 0x00, 0x34, 0x4d, 0x4f,
+  0x4c, 0x20, 0x00, 0x34, 0x4e, 0x53, 0x4d, 0x20, 0x00, 0x34, 0x52, 0x4f,
+  0x4d, 0x20, 0x00, 0x34, 0x53, 0x4b, 0x53, 0x20, 0x00, 0x34, 0x53, 0x53,
+  0x4d, 0x20, 0x00, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x01,
+  0x00, 0x03, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x02, 0x00, 0x00, 0x00, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x07, 0x6b, 0x65,
+  0x72, 0x6e, 0x00, 0x2c, 0x6b, 0x65, 0x72, 0x6e, 0x00, 0x32, 0x6d, 0x61,
+  0x72, 0x6b, 0x00, 0x3a, 0x6d, 0x61, 0x72, 0x6b, 0x00, 0x40, 0x6d, 0x61,
+  0x72, 0x6b, 0x00, 0x48, 0x6d, 0x6b, 0x6d, 0x6b, 0x00, 0x4e, 0x6d, 0x6b,
+  0x6d, 0x6b, 0x00, 0x54, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x05, 0x00, 0x06, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02,
+  0x00, 0x00, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x07, 0x00, 0x10, 0x00, 0x18, 0x00, 0x22, 0x00, 0x2a,
+  0x00, 0x32, 0x00, 0x44, 0x00, 0x4c, 0x00, 0x06, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x44, 0x00, 0x06, 0x00, 0x04, 0x00, 0x02, 0x00, 0xf0, 0x03, 0xd0,
+  0x00, 0x04, 0x00, 0x01, 0x00, 0x01, 0x08, 0x86, 0x00, 0x05, 0x00, 0x00,
+  0x00, 0x01, 0x0f, 0xc0, 0x00, 0x04, 0x00, 0x04, 0x00, 0x06, 0x11, 0x72,
+  0x17, 0x1c, 0x17, 0x9c, 0x1b, 0x3a, 0x2c, 0x8e, 0x44, 0xde, 0x00, 0x02,
+  0x00, 0x00, 0x00, 0x01, 0x46, 0x1c, 0x00, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x6d, 0xca, 0x00, 0x01, 0x00, 0x58, 0x00, 0x4e, 0x00, 0x01, 0x00, 0x62,
+  0x00, 0x0c, 0x00, 0x08, 0x00, 0x12, 0x00, 0x18, 0x00, 0x1e, 0x00, 0x24,
+  0x00, 0x2a, 0x00, 0x30, 0x00, 0x36, 0x00, 0x3c, 0x00, 0x01, 0x01, 0xcc,
+  0x08, 0xfc, 0x00, 0x01, 0x01, 0xcc, 0x09, 0xc4, 0x00, 0x01, 0x01, 0xcc,
+  0x08, 0xfc, 0x00, 0x01, 0x01, 0xcc, 0x08, 0x34, 0x00, 0x01, 0x01, 0xcc,
+  0x09, 0xc4, 0x00, 0x01, 0x01, 0xcc, 0x08, 0x34, 0x00, 0x01, 0x01, 0xcc,
+  0x07, 0xd0, 0x00, 0x01, 0x01, 0xcc, 0x09, 0x60, 0x00, 0x02, 0x00, 0x01,
+  0x11, 0x4a, 0x11, 0x51, 0x00, 0x00, 0x00, 0x02, 0x00, 0x01, 0x11, 0x4a,
+  0x11, 0x51, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x22, 0x00, 0x00,
+  0x00, 0x28, 0x00, 0x00, 0x00, 0x2e, 0x00, 0x00, 0x00, 0x34, 0x00, 0x00,
+  0x00, 0x3a, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x46, 0x00, 0x00,
+  0x00, 0x4c, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0x5a, 0x01, 0x26, 0x00, 0x01, 0x01, 0x94,
+  0x00, 0x0c, 0x00, 0x23, 0x00, 0x48, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x5a,
+  0x00, 0x60, 0x00, 0x66, 0x00, 0x6c, 0x00, 0x72, 0x00, 0x78, 0x00, 0x7e,
+  0x00, 0x84, 0x00, 0x8a, 0x00, 0x90, 0x00, 0x96, 0x00, 0x9c, 0x00, 0xa2,
+  0x00, 0xa8, 0x00, 0xae, 0x00, 0xb4, 0x00, 0xba, 0x00, 0xc0, 0x00, 0xc6,
+  0x00, 0xcc, 0x00, 0xd2, 0x00, 0xd8, 0x00, 0xde, 0x00, 0xe4, 0x00, 0xea,
+  0x00, 0xf0, 0x00, 0xf6, 0x00, 0xfc, 0x01, 0x02, 0x01, 0x08, 0x01, 0x0e,
+  0x01, 0x14, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xde, 0x00, 0x01, 0xfe, 0x34,
+  0xfd, 0xde, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xda, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x89, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x89, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x89, 0x00, 0x01, 0xfe, 0x34,
+  0xfd, 0xda, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x14, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x74, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x74, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x1f, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x3b, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x18, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x15, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x38, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x38, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x38, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0xbf, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xda, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x1f, 0x00, 0x01, 0xfe, 0x35, 0xfe, 0x13, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x0b, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34, 0xfe, 0x0e, 0x00, 0x01, 0xfe, 0x34,
+  0xfe, 0x13, 0x00, 0x01, 0xfe, 0x34, 0xfd, 0xda, 0x00, 0x02, 0x00, 0x08,
+  0x02, 0xc7, 0x02, 0xca, 0x00, 0x00, 0x02, 0xcd, 0x02, 0xd1, 0x00, 0x04,
+  0x02, 0xd4, 0x02, 0xe2, 0x00, 0x09, 0x02, 0xea, 0x02, 0xed, 0x00, 0x18,
+  0x02, 0xf8, 0x02, 0xfa, 0x00, 0x1c, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x1f,
+  0x03, 0x03, 0x03, 0x03, 0x00, 0x21, 0x03, 0x06, 0x03, 0x06, 0x00, 0x22,
+  0x00, 0x02, 0x00, 0x09, 0x02, 0xc7, 0x02, 0xca, 0x00, 0x00, 0x02, 0xcd,
+  0x02, 0xd1, 0x00, 0x04, 0x02, 0xd4, 0x02, 0xd7, 0x00, 0x09, 0x02, 0xda,
+  0x02, 0xe2, 0x00, 0x0d, 0x02, 0xea, 0x02, 0xed, 0x00, 0x16, 0x02, 0xf8,
+  0x02, 0xfa, 0x00, 0x1a, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x1d, 0x03, 0x03,
+  0x03, 0x03, 0x00, 0x1f, 0x03, 0x06, 0x03, 0x06, 0x00, 0x20, 0x00, 0x21,
+  0x00, 0x00, 0x00, 0x86, 0x00, 0x00, 0x00, 0x8c, 0x00, 0x00, 0x00, 0x92,
+  0x00, 0x00, 0x00, 0x98, 0x00, 0x00, 0x00, 0x9e, 0x00, 0x00, 0x00, 0xa4,
+  0x00, 0x00, 0x00, 0xaa, 0x00, 0x00, 0x00, 0xb0, 0x00, 0x00, 0x00, 0xb6,
+  0x00, 0x00, 0x00, 0xbc, 0x00, 0x00, 0x00, 0xc2, 0x00, 0x00, 0x00, 0xc8,
+  0x00, 0x00, 0x00, 0xce, 0x00, 0x00, 0x00, 0xd4, 0x00, 0x00, 0x00, 0xda,
+  0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00, 0xe6, 0x00, 0x00, 0x00, 0xec,
+  0x00, 0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0x00, 0xfe,
+  0x00, 0x00, 0x01, 0x04, 0x00, 0x00, 0x01, 0x0a, 0x00, 0x00, 0x01, 0x10,
+  0x00, 0x00, 0x01, 0x16, 0x00, 0x00, 0x01, 0x1c, 0x00, 0x00, 0x01, 0x22,
+  0x00, 0x00, 0x01, 0x28, 0x00, 0x00, 0x01, 0x2e, 0x00, 0x00, 0x01, 0x34,
+  0x00, 0x00, 0x01, 0x3a, 0x00, 0x00, 0x01, 0x40, 0x00, 0x00, 0x01, 0x46,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x35, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x42, 0x01, 0xde,
+  0x00, 0x01, 0x02, 0x8e, 0x00, 0x0c, 0x00, 0x3a, 0x00, 0x76, 0x00, 0x7c,
+  0x00, 0x82, 0x00, 0x88, 0x00, 0x8e, 0x00, 0x94, 0x00, 0x9a, 0x00, 0xa0,
+  0x00, 0xa6, 0x00, 0xac, 0x00, 0xb2, 0x00, 0xb8, 0x00, 0xbe, 0x00, 0xc4,
+  0x00, 0xca, 0x00, 0xd0, 0x00, 0xd6, 0x00, 0xdc, 0x00, 0xe2, 0x00, 0xe8,
+  0x00, 0xee, 0x00, 0xf4, 0x00, 0xfa, 0x01, 0x00, 0x01, 0x06, 0x01, 0x0c,
+  0x01, 0x12, 0x01, 0x18, 0x01, 0x1e, 0x01, 0x24, 0x01, 0x2a, 0x01, 0x30,
+  0x01, 0x36, 0x01, 0x3c, 0x01, 0x42, 0x01, 0x48, 0x01, 0x4e, 0x01, 0x54,
+  0x01, 0x5a, 0x01, 0x60, 0x01, 0x66, 0x01, 0x6c, 0x01, 0x72, 0x01, 0x78,
+  0x01, 0x7e, 0x01, 0x84, 0x01, 0x8a, 0x01, 0x90, 0x01, 0x96, 0x01, 0x9c,
+  0x01, 0xa2, 0x01, 0xa8, 0x01, 0xae, 0x01, 0xb4, 0x01, 0xba, 0x01, 0xc0,
+  0x01, 0xc6, 0x01, 0xcc, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x3d, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x44, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0xc5, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0xa8, 0x00, 0x01, 0xfe, 0x34, 0x06, 0xa8, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x56, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x44, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x93, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x3d, 0x00, 0x01,
+  0xfe, 0x34, 0x07, 0xd0, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x44, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x44, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
+  0xfe, 0x34, 0x07, 0x04, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0xda, 0x00, 0x01, 0xfe, 0x34, 0x07, 0x04, 0x00, 0x01,
+  0x00, 0x00, 0x07, 0x6e, 0x00, 0x01, 0x00, 0x00, 0x07, 0x6e, 0x00, 0x01,
+  0x00, 0x00, 0x07, 0x6e, 0x00, 0x01, 0x00, 0x00, 0x07, 0x6e, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x68, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x68, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x06, 0x14, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x14, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xdb, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01, 0xfe, 0x34, 0x05, 0xf8, 0x00, 0x01,
+  0xfe, 0x34, 0x06, 0x1e, 0x00, 0x02, 0x00, 0x10, 0x02, 0xb1, 0x02, 0xc2,
+  0x00, 0x00, 0x02, 0xee, 0x02, 0xee, 0x00, 0x12, 0x02, 0xf0, 0x02, 0xf3,
+  0x00, 0x13, 0x02, 0xf5, 0x02, 0xf5, 0x00, 0x17, 0x02, 0xf7, 0x02, 0xf7,
+  0x00, 0x18, 0x02, 0xfb, 0x02, 0xfd, 0x00, 0x19, 0x03, 0x01, 0x03, 0x02,
+  0x00, 0x1c, 0x03, 0x04, 0x03, 0x04, 0x00, 0x1e, 0x03, 0x08, 0x03, 0x09,
+  0x00, 0x1f, 0x03, 0x0b, 0x03, 0x0c, 0x00, 0x21, 0x05, 0x4a, 0x05, 0x4f,
+  0x00, 0x23, 0x07, 0xe3, 0x07, 0xe9, 0x00, 0x29, 0x10, 0xeb, 0x10, 0xeb,
+  0x00, 0x30, 0x10, 0xed, 0x10, 0xed, 0x00, 0x31, 0x10, 0xef, 0x10, 0xf5,
+  0x00, 0x32, 0x11, 0xac, 0x11, 0xac, 0x00, 0x39, 0x00, 0x02, 0x00, 0x0c,
+  0x02, 0xb1, 0x02, 0xc2, 0x00, 0x00, 0x02, 0xee, 0x02, 0xee, 0x00, 0x12,
+  0x02, 0xf0, 0x02, 0xf3, 0x00, 0x13, 0x02, 0xf5, 0x02, 0xf5, 0x00, 0x17,
+  0x02, 0xf7, 0x02, 0xf7, 0x00, 0x18, 0x02, 0xfb, 0x02, 0xfd, 0x00, 0x19,
+  0x03, 0x01, 0x03, 0x02, 0x00, 0x1c, 0x03, 0x04, 0x03, 0x04, 0x00, 0x1e,
+  0x05, 0x4a, 0x05, 0x4f, 0x00, 0x1f, 0x07, 0xe3, 0x07, 0xe9, 0x00, 0x25,
+  0x10, 0xeb, 0x10, 0xf5, 0x00, 0x2c, 0x11, 0xac, 0x11, 0xac, 0x00, 0x37,
+  0x00, 0x38, 0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe8, 0x00, 0x00,
+  0x00, 0xee, 0x00, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x00, 0x00,
+  0x01, 0x00, 0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0c, 0x00, 0x00,
+  0x01, 0x12, 0x00, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x1e, 0x00, 0x00,
+  0x01, 0x24, 0x00, 0x00, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x30, 0x00, 0x00,
+  0x01, 0x36, 0x00, 0x00, 0x01, 0x3c, 0x00, 0x00, 0x01, 0x42, 0x00, 0x00,
+  0x01, 0x48, 0x00, 0x00, 0x01, 0x4e, 0x00, 0x00, 0x01, 0x54, 0x00, 0x00,
+  0x01, 0x5a, 0x00, 0x00, 0x01, 0x60, 0x00, 0x00, 0x01, 0x66, 0x00, 0x00,
+  0x01, 0x6c, 0x00, 0x00, 0x01, 0x72, 0x00, 0x00, 0x01, 0x78, 0x00, 0x00,
+  0x01, 0x7e, 0x00, 0x00, 0x01, 0x84, 0x00, 0x00, 0x01, 0x8a, 0x00, 0x00,
+  0x01, 0x90, 0x00, 0x00, 0x01, 0x96, 0x00, 0x00, 0x01, 0x9c, 0x00, 0x00,
+  0x01, 0xa2, 0x00, 0x00, 0x01, 0xa8, 0x00, 0x00, 0x01, 0xae, 0x00, 0x00,
+  0x01, 0xb4, 0x00, 0x00, 0x01, 0xba, 0x00, 0x00, 0x01, 0xc0, 0x00, 0x00,
+  0x01, 0xc6, 0x00, 0x00, 0x01, 0xcc, 0x00, 0x00, 0x01, 0xd2, 0x00, 0x00,
+  0x01, 0xd8, 0x00, 0x00, 0x01, 0xde, 0x00, 0x00, 0x01, 0xe4, 0x00, 0x00,
+  0x01, 0xea, 0x00, 0x00, 0x01, 0xf0, 0x00, 0x00, 0x01, 0xf6, 0x00, 0x00,
+  0x01, 0xfc, 0x00, 0x00, 0x02, 0x02, 0x00, 0x00, 0x02, 0x08, 0x00, 0x00,
+  0x02, 0x0e, 0x00, 0x00, 0x02, 0x14, 0x00, 0x00, 0x02, 0x1a, 0x00, 0x00,
+  0x02, 0x20, 0x00, 0x00, 0x02, 0x26, 0x00, 0x00, 0x02, 0x2c, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0xb0, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0xb0, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x05, 0x02, 0x00, 0x01, 0xfe, 0x34, 0x05, 0x02, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01,
+  0x06, 0xe6, 0x06, 0xbe, 0x00, 0x01, 0x06, 0xf0, 0x00, 0x0c, 0x00, 0xd6,
+  0x01, 0xae, 0x01, 0xb4, 0x01, 0xba, 0x01, 0xc0, 0x01, 0xc6, 0x01, 0xcc,
+  0x01, 0xd2, 0x01, 0xd8, 0x01, 0xde, 0x01, 0xe4, 0x01, 0xea, 0x01, 0xf0,
+  0x01, 0xf6, 0x01, 0xfc, 0x02, 0x02, 0x02, 0x08, 0x02, 0x0e, 0x02, 0x14,
+  0x02, 0x1a, 0x02, 0x20, 0x02, 0x26, 0x02, 0x2c, 0x02, 0x32, 0x02, 0x38,
+  0x02, 0x3e, 0x02, 0x44, 0x02, 0x4a, 0x02, 0x50, 0x02, 0x56, 0x02, 0x5c,
+  0x02, 0x62, 0x02, 0x68, 0x02, 0x6e, 0x02, 0x74, 0x02, 0x7a, 0x02, 0x80,
+  0x02, 0x86, 0x02, 0x8c, 0x02, 0x92, 0x02, 0x98, 0x02, 0x9e, 0x02, 0xa4,
+  0x02, 0xaa, 0x02, 0xb0, 0x02, 0xb6, 0x02, 0xbc, 0x02, 0xc2, 0x02, 0xc8,
+  0x02, 0xce, 0x02, 0xd4, 0x02, 0xda, 0x02, 0xe0, 0x02, 0xe6, 0x02, 0xec,
+  0x02, 0xf2, 0x02, 0xf8, 0x02, 0xfe, 0x03, 0x04, 0x03, 0x0a, 0x03, 0x10,
+  0x03, 0x16, 0x03, 0x1c, 0x03, 0x22, 0x03, 0x28, 0x03, 0x2e, 0x03, 0x34,
+  0x03, 0x3a, 0x03, 0x40, 0x03, 0x46, 0x03, 0x4c, 0x03, 0x52, 0x03, 0x58,
+  0x03, 0x5e, 0x03, 0x64, 0x03, 0x6a, 0x03, 0x70, 0x03, 0x76, 0x03, 0x7c,
+  0x03, 0x82, 0x03, 0x88, 0x03, 0x8e, 0x03, 0x94, 0x03, 0x9a, 0x03, 0xa0,
+  0x03, 0xa6, 0x03, 0xac, 0x03, 0xb2, 0x03, 0xb8, 0x03, 0xbe, 0x03, 0xc4,
+  0x03, 0xca, 0x03, 0xd0, 0x03, 0xd6, 0x03, 0xdc, 0x03, 0xe2, 0x03, 0xe8,
+  0x03, 0xee, 0x03, 0xf4, 0x03, 0xfa, 0x04, 0x00, 0x04, 0x06, 0x04, 0x0c,
+  0x04, 0x12, 0x04, 0x18, 0x04, 0x1e, 0x04, 0x24, 0x04, 0x2a, 0x04, 0x30,
+  0x04, 0x36, 0x04, 0x3c, 0x04, 0x42, 0x04, 0x48, 0x04, 0x4e, 0x04, 0x54,
+  0x04, 0x5a, 0x04, 0x60, 0x04, 0x66, 0x04, 0x6c, 0x04, 0x72, 0x04, 0x78,
+  0x04, 0x7e, 0x04, 0x84, 0x04, 0x8a, 0x04, 0x90, 0x04, 0x96, 0x04, 0x9c,
+  0x04, 0xa2, 0x04, 0xa8, 0x04, 0xae, 0x04, 0xb4, 0x04, 0xba, 0x04, 0xc0,
+  0x04, 0xc6, 0x04, 0xcc, 0x04, 0xd2, 0x04, 0xd8, 0x04, 0xde, 0x04, 0xe4,
+  0x04, 0xea, 0x04, 0xf0, 0x04, 0xf6, 0x04, 0xfc, 0x05, 0x02, 0x05, 0x08,
+  0x05, 0x0e, 0x05, 0x14, 0x05, 0x1a, 0x05, 0x20, 0x05, 0x26, 0x05, 0x2c,
+  0x05, 0x32, 0x05, 0x38, 0x05, 0x3e, 0x05, 0x44, 0x05, 0x4a, 0x05, 0x50,
+  0x05, 0x56, 0x05, 0x5c, 0x05, 0x62, 0x05, 0x68, 0x05, 0x6e, 0x05, 0x74,
+  0x05, 0x7a, 0x05, 0x80, 0x05, 0x86, 0x05, 0x8c, 0x05, 0x92, 0x05, 0x98,
+  0x05, 0x9e, 0x05, 0xa4, 0x05, 0xaa, 0x05, 0xb0, 0x05, 0xb6, 0x05, 0xbc,
+  0x05, 0xc2, 0x05, 0xc8, 0x05, 0xce, 0x05, 0xd4, 0x05, 0xda, 0x05, 0xe0,
+  0x05, 0xe6, 0x05, 0xec, 0x05, 0xf2, 0x05, 0xf8, 0x05, 0xfe, 0x06, 0x04,
+  0x06, 0x0a, 0x06, 0x10, 0x06, 0x16, 0x06, 0x1c, 0x06, 0x22, 0x06, 0x28,
+  0x06, 0x2e, 0x06, 0x34, 0x06, 0x3a, 0x06, 0x40, 0x06, 0x46, 0x06, 0x4c,
+  0x06, 0x52, 0x06, 0x58, 0x06, 0x5e, 0x06, 0x64, 0x06, 0x6a, 0x06, 0x70,
+  0x06, 0x76, 0x06, 0x7c, 0x06, 0x82, 0x06, 0x88, 0x06, 0x8e, 0x06, 0x94,
+  0x06, 0x9a, 0x06, 0xa0, 0x06, 0xa6, 0x06, 0xac, 0x00, 0x01, 0x03, 0x2a,
+  0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d, 0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d,
+  0x03, 0xe8, 0x00, 0x01, 0x02, 0x76, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2,
+  0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2, 0x03, 0xb6, 0x00, 0x01, 0x01, 0xc2,
+  0x03, 0x52, 0x00, 0x01, 0x01, 0xc2, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2,
+  0x03, 0xb6, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d,
+  0x04, 0x1a, 0x00, 0x01, 0x03, 0x2a, 0x03, 0x52, 0x00, 0x01, 0x01, 0x0d,
+  0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x03, 0x2a,
+  0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d, 0x05, 0x14, 0x00, 0x01, 0x01, 0x0d,
+  0x05, 0x14, 0x00, 0x01, 0x02, 0x49, 0x06, 0x0e, 0x00, 0x01, 0x02, 0x1c,
+  0x05, 0xaa, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xaa, 0x00, 0x01, 0x02, 0x49,
+  0x05, 0xdc, 0x00, 0x01, 0x02, 0x1c, 0x05, 0x78, 0x00, 0x01, 0x02, 0x1c,
+  0x05, 0x78, 0x00, 0x01, 0x02, 0x49, 0x05, 0xdc, 0x00, 0x01, 0x02, 0x1c,
+  0x05, 0x78, 0x00, 0x01, 0x02, 0x1c, 0x05, 0x78, 0x00, 0x01, 0x02, 0x49,
+  0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c, 0x04, 0x7e, 0x00, 0x01, 0x02, 0x1c,
+  0x04, 0x7e, 0x00, 0x01, 0x02, 0x76, 0x02, 0xee, 0x00, 0x01, 0x02, 0x76,
+  0x02, 0xee, 0x00, 0x01, 0x04, 0x42, 0x08, 0x34, 0x00, 0x01, 0x01, 0x31,
+  0x08, 0x34, 0x00, 0x01, 0x01, 0x31, 0x08, 0x34, 0x00, 0x01, 0x02, 0x76,
+  0x03, 0xb6, 0x00, 0x01, 0x01, 0x0d, 0x04, 0xb0, 0x00, 0x01, 0x01, 0x0d,
+  0x04, 0xb0, 0x00, 0x01, 0x02, 0x76, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xef,
+  0x03, 0x52, 0x00, 0x01, 0x01, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x00,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x0e,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x0e, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x0e,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x80, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x80,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x80, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x21,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x21, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x21,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x23,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xb0,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xdd,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xdd, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xdd,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x49,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa,
+  0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x63, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x63,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x63, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x7e,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x7e, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x7e,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x69, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x69,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x69, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xad,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xad, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xad,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd2, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd2,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd2, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
+  0x05, 0xf2, 0x00, 0x01, 0x02, 0x5a, 0x05, 0xf2, 0x00, 0x01, 0x02, 0x5a,
+  0x05, 0xf2, 0x00, 0x01, 0x02, 0x40, 0x05, 0xf2, 0x00, 0x01, 0x02, 0x40,
+  0x05, 0xf2, 0x00, 0x01, 0x02, 0x40, 0x05, 0xf2, 0x00, 0x01, 0x02, 0xb5,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x52,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x52, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x52,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xad, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xad,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xad, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x40,
+  0x05, 0xf2, 0x00, 0x01, 0x02, 0x40, 0x05, 0xf2, 0x00, 0x01, 0x02, 0x40,
+  0x05, 0xf2, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xca,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xca, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe5,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xe5, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe5,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x68, 0x03, 0xe8, 0x00, 0x01, 0x01, 0x68,
+  0x03, 0xe8, 0x00, 0x01, 0x01, 0x95, 0x06, 0x40, 0x00, 0x01, 0x01, 0x95,
+  0x05, 0xaa, 0x00, 0x01, 0x01, 0x95, 0x05, 0xdc, 0x00, 0x01, 0x02, 0x76,
+  0x02, 0xee, 0x00, 0x01, 0x02, 0x76, 0x02, 0xee, 0x00, 0x01, 0x02, 0x76,
+  0x02, 0xee, 0x00, 0x01, 0x02, 0x76, 0x03, 0xe8, 0x00, 0x01, 0x02, 0x76,
+  0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c, 0x03, 0x20, 0x00, 0x01, 0x02, 0xfd,
+  0x04, 0x1a, 0x00, 0x01, 0x02, 0xfd, 0x04, 0x1a, 0x00, 0x01, 0x02, 0x1c,
+  0x03, 0x20, 0x00, 0x01, 0x02, 0x49, 0x03, 0x84, 0x00, 0x01, 0x02, 0x49,
+  0x03, 0x84, 0x00, 0x01, 0x02, 0x1c, 0x03, 0x20, 0x00, 0x01, 0x02, 0xfd,
+  0x04, 0xe2, 0x00, 0x01, 0x02, 0xfd, 0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c,
+  0x03, 0x20, 0x00, 0x01, 0x01, 0xef, 0x03, 0x20, 0x00, 0x01, 0x01, 0xef,
+  0x03, 0x20, 0x00, 0x01, 0x02, 0x1c, 0x03, 0x20, 0x00, 0x01, 0x02, 0x1c,
+  0x04, 0xe2, 0x00, 0x01, 0x02, 0x1c, 0x04, 0xe2, 0x00, 0x01, 0x02, 0x1e,
+  0x06, 0x72, 0x00, 0x01, 0x01, 0x31, 0x06, 0x72, 0x00, 0x01, 0x01, 0x31,
+  0x06, 0x72, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x01, 0xc2,
+  0x06, 0x72, 0x00, 0x01, 0x01, 0xbc, 0x05, 0x78, 0x00, 0x01, 0x02, 0x76,
+  0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2,
+  0x03, 0xb6, 0x00, 0x01, 0x02, 0x76, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2,
+  0x05, 0x46, 0x00, 0x01, 0x01, 0xd2, 0x04, 0xb0, 0x00, 0x01, 0x02, 0x76,
+  0x04, 0x4c, 0x00, 0x01, 0x01, 0xc2, 0x04, 0x4c, 0x00, 0x01, 0x01, 0xd2,
+  0x03, 0xb6, 0x00, 0x01, 0x01, 0xc2, 0x03, 0x52, 0x00, 0x01, 0x01, 0xc2,
+  0x05, 0x46, 0x00, 0x01, 0x01, 0xd2, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xc2,
+  0x03, 0x52, 0x00, 0x01, 0x01, 0xc2, 0x06, 0x40, 0x00, 0x01, 0x01, 0xd2,
+  0x05, 0xaa, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x00, 0x6c,
+  0x05, 0x78, 0x00, 0x01, 0x00, 0x6c, 0x05, 0x78, 0x00, 0x01, 0x01, 0xc2,
+  0x05, 0x78, 0x00, 0x01, 0x00, 0xe1, 0x06, 0x0e, 0x00, 0x01, 0x00, 0xe1,
+  0x06, 0x0e, 0x00, 0x01, 0x02, 0xe6, 0x06, 0x0e, 0x00, 0x01, 0x00, 0xf7,
+  0x06, 0xa4, 0x00, 0x01, 0x00, 0xf7, 0x06, 0xa4, 0x00, 0x01, 0x02, 0x76,
+  0x05, 0xdc, 0x00, 0x01, 0x00, 0xe1, 0x06, 0x0e, 0x00, 0x01, 0x00, 0xe1,
+  0x06, 0x0e, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x00, 0xe1,
+  0x06, 0xa4, 0x00, 0x01, 0x00, 0xe1, 0x06, 0xa4, 0x00, 0x01, 0x01, 0xc2,
+  0x05, 0x78, 0x00, 0x01, 0x00, 0xe1, 0x06, 0xa4, 0x00, 0x01, 0x00, 0xe1,
+  0x06, 0xa4, 0x00, 0x01, 0x01, 0xc2, 0x05, 0x78, 0x00, 0x01, 0x00, 0xf7,
+  0x08, 0x66, 0x00, 0x01, 0x00, 0xf7, 0x08, 0x66, 0x00, 0x01, 0x04, 0x42,
+  0x08, 0x34, 0x00, 0x01, 0x01, 0x31, 0x08, 0x34, 0x00, 0x01, 0x01, 0x31,
+  0x08, 0x34, 0x00, 0x01, 0x04, 0x42, 0x08, 0x66, 0x00, 0x01, 0x01, 0x31,
+  0x08, 0x66, 0x00, 0x01, 0x01, 0x31, 0x08, 0x66, 0x00, 0x01, 0x02, 0x49,
+  0x05, 0x14, 0x00, 0x01, 0x01, 0x31, 0x06, 0x72, 0x00, 0x01, 0x01, 0x31,
+  0x06, 0x72, 0x00, 0x01, 0x02, 0x49, 0x02, 0xee, 0x00, 0x01, 0x01, 0x0d,
+  0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x02, 0x49,
+  0x02, 0xee, 0x00, 0x01, 0x01, 0x0d, 0x04, 0x1a, 0x00, 0x01, 0x01, 0x0d,
+  0x04, 0x1a, 0x00, 0x01, 0x02, 0x76, 0x03, 0xe8, 0x00, 0x01, 0x01, 0x0d,
+  0x05, 0x14, 0x00, 0x01, 0x01, 0x0d, 0x05, 0x14, 0x00, 0x02, 0x00, 0x06,
+  0x10, 0xfc, 0x11, 0x06, 0x00, 0x00, 0x11, 0x08, 0x11, 0x19, 0x00, 0x0b,
+  0x11, 0x35, 0x11, 0x3d, 0x00, 0x1d, 0x11, 0x3f, 0x11, 0x3f, 0x00, 0x26,
+  0x11, 0x52, 0x11, 0xab, 0x00, 0x27, 0x11, 0xb9, 0x12, 0x0d, 0x00, 0x81,
+  0x00, 0x02, 0x00, 0x01, 0x11, 0x4a, 0x11, 0x51, 0x00, 0x00, 0x00, 0x08,
+  0x00, 0x00, 0x00, 0x22, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x2e,
+  0x00, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00, 0x3a, 0x00, 0x00, 0x00, 0x40,
+  0x00, 0x00, 0x00, 0x46, 0x00, 0x00, 0x00, 0x4c, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc,
+  0x04, 0xb0, 0x00, 0x01, 0x01, 0xcc, 0x04, 0xb0, 0x00, 0x01, 0x00, 0x20,
+  0x00, 0x1a, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x0c, 0x00, 0x01, 0x00, 0x04,
+  0x00, 0x01, 0x00, 0x04, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0xa9, 0x00, 0x02, 0x00, 0x09, 0x02, 0xc7, 0x02, 0xca,
+  0x00, 0x00, 0x02, 0xcd, 0x02, 0xd1, 0x00, 0x04, 0x02, 0xd4, 0x02, 0xd7,
+  0x00, 0x09, 0x02, 0xda, 0x02, 0xe4, 0x00, 0x0d, 0x02, 0xea, 0x02, 0xed,
+  0x00, 0x18, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x1c, 0x02, 0xfe, 0x02, 0xff,
+  0x00, 0x1f, 0x03, 0x03, 0x03, 0x03, 0x00, 0x21, 0x03, 0x06, 0x03, 0x06,
+  0x00, 0x22, 0x00, 0x23, 0x00, 0x00, 0x00, 0x8e, 0x00, 0x00, 0x00, 0x94,
+  0x00, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x00, 0xa0, 0x00, 0x00, 0x00, 0xa6,
+  0x00, 0x00, 0x00, 0xac, 0x00, 0x00, 0x00, 0xb2, 0x00, 0x00, 0x00, 0xb8,
+  0x00, 0x00, 0x00, 0xbe, 0x00, 0x00, 0x00, 0xc4, 0x00, 0x00, 0x00, 0xca,
+  0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0x00, 0xd6, 0x00, 0x00, 0x00, 0xdc,
+  0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe8, 0x00, 0x00, 0x00, 0xee,
+  0x00, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x00, 0x00, 0x01, 0x00,
+  0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0c, 0x00, 0x00, 0x01, 0x12,
+  0x00, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x1e, 0x00, 0x00, 0x01, 0x24,
+  0x00, 0x00, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x30, 0x00, 0x00, 0x01, 0x36,
+  0x00, 0x00, 0x01, 0x3c, 0x00, 0x00, 0x01, 0x42, 0x00, 0x00, 0x01, 0x48,
+  0x00, 0x00, 0x01, 0x4e, 0x00, 0x00, 0x01, 0x54, 0x00, 0x00, 0x01, 0x5a,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x35, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff,
+  0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0x05, 0x8c, 0x04, 0xb6,
+  0x00, 0x01, 0x05, 0x94, 0x00, 0x0c, 0x00, 0x95, 0x01, 0x2c, 0x01, 0x32,
+  0x01, 0x38, 0x01, 0x3e, 0x01, 0x44, 0x01, 0x4a, 0x01, 0x50, 0x01, 0x56,
+  0x01, 0x5c, 0x01, 0x62, 0x01, 0x68, 0x01, 0x6e, 0x01, 0x74, 0x01, 0x7a,
+  0x01, 0x80, 0x01, 0x86, 0x01, 0x8c, 0x01, 0x92, 0x01, 0x98, 0x01, 0x9e,
+  0x01, 0xa4, 0x01, 0xaa, 0x01, 0xb0, 0x01, 0xb6, 0x01, 0xbc, 0x01, 0xc2,
+  0x01, 0xc8, 0x01, 0xce, 0x01, 0xd4, 0x01, 0xda, 0x01, 0xe0, 0x01, 0xe6,
+  0x01, 0xec, 0x01, 0xf2, 0x01, 0xf8, 0x01, 0xfe, 0x02, 0x04, 0x02, 0x0a,
+  0x02, 0x10, 0x02, 0x16, 0x02, 0x1c, 0x02, 0x22, 0x02, 0x28, 0x02, 0x2e,
+  0x02, 0x34, 0x02, 0x3a, 0x02, 0x40, 0x02, 0x46, 0x02, 0x4c, 0x02, 0x52,
+  0x02, 0x58, 0x02, 0x5e, 0x02, 0x64, 0x02, 0x6a, 0x02, 0x70, 0x02, 0x76,
+  0x02, 0x7c, 0x02, 0x82, 0x02, 0x88, 0x02, 0x8e, 0x02, 0x94, 0x02, 0x9a,
+  0x02, 0xa0, 0x02, 0xa6, 0x02, 0xac, 0x02, 0xb2, 0x02, 0xb8, 0x02, 0xbe,
+  0x02, 0xc4, 0x02, 0xca, 0x02, 0xd0, 0x02, 0xd6, 0x02, 0xdc, 0x02, 0xe2,
+  0x02, 0xe8, 0x02, 0xee, 0x02, 0xf4, 0x02, 0xfa, 0x03, 0x00, 0x03, 0x06,
+  0x03, 0x0c, 0x03, 0x12, 0x03, 0x18, 0x03, 0x1e, 0x03, 0x24, 0x03, 0x2a,
+  0x03, 0x30, 0x03, 0x36, 0x03, 0x3c, 0x03, 0x42, 0x03, 0x48, 0x03, 0x4e,
+  0x03, 0x54, 0x03, 0x5a, 0x03, 0x60, 0x03, 0x66, 0x03, 0x6c, 0x03, 0x72,
+  0x03, 0x78, 0x03, 0x7e, 0x03, 0x84, 0x03, 0x8a, 0x03, 0x90, 0x03, 0x96,
+  0x03, 0x9c, 0x03, 0xa2, 0x03, 0xa8, 0x03, 0xae, 0x03, 0xb4, 0x03, 0xba,
+  0x03, 0xc0, 0x03, 0xc6, 0x03, 0xcc, 0x03, 0xd2, 0x03, 0xd8, 0x03, 0xde,
+  0x03, 0xe4, 0x03, 0xea, 0x03, 0xf0, 0x03, 0xf6, 0x03, 0xfc, 0x04, 0x02,
+  0x04, 0x08, 0x04, 0x0e, 0x04, 0x14, 0x04, 0x1a, 0x04, 0x20, 0x04, 0x26,
+  0x04, 0x2c, 0x04, 0x32, 0x04, 0x38, 0x04, 0x3e, 0x04, 0x44, 0x04, 0x4a,
+  0x04, 0x50, 0x04, 0x56, 0x04, 0x5c, 0x04, 0x62, 0x04, 0x68, 0x04, 0x6e,
+  0x04, 0x74, 0x04, 0x7a, 0x04, 0x80, 0x04, 0x86, 0x04, 0x8c, 0x04, 0x92,
+  0x04, 0x98, 0x04, 0x9e, 0x04, 0xa4, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0,
+  0x00, 0x02, 0x00, 0x23, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x44,
+  0x00, 0x5d, 0x00, 0x1a, 0x00, 0x9a, 0x00, 0x9a, 0x00, 0x34, 0x00, 0xba,
+  0x00, 0xba, 0x00, 0x35, 0x00, 0xc6, 0x00, 0xc7, 0x00, 0x36, 0x00, 0xd0,
+  0x00, 0xd1, 0x00, 0x38, 0x00, 0xf3, 0x00, 0xf3, 0x00, 0x3a, 0x01, 0x28,
+  0x01, 0x29, 0x00, 0x3b, 0x01, 0x41, 0x01, 0x41, 0x00, 0x3d, 0x01, 0x48,
+  0x01, 0x48, 0x00, 0x3e, 0x01, 0x51, 0x01, 0x52, 0x00, 0x3f, 0x01, 0x59,
+  0x01, 0x59, 0x00, 0x41, 0x01, 0x61, 0x01, 0x61, 0x00, 0x42, 0x01, 0x79,
+  0x01, 0x7b, 0x00, 0x43, 0x02, 0x12, 0x02, 0x12, 0x00, 0x46, 0x02, 0x16,
+  0x02, 0x16, 0x00, 0x47, 0x02, 0x1b, 0x02, 0x1b, 0x00, 0x48, 0x02, 0x1d,
+  0x02, 0x1d, 0x00, 0x49, 0x02, 0x2a, 0x02, 0x2a, 0x00, 0x4a, 0x02, 0x37,
+  0x02, 0x37, 0x00, 0x4b, 0x02, 0x54, 0x02, 0x54, 0x00, 0x4c, 0x05, 0x23,
+  0x05, 0x23, 0x00, 0x4d, 0x05, 0x5a, 0x05, 0x63, 0x00, 0x4e, 0x0e, 0x38,
+  0x0e, 0x3a, 0x00, 0x58, 0x0e, 0x3d, 0x0e, 0x3e, 0x00, 0x5b, 0x0e, 0x44,
+  0x0e, 0x44, 0x00, 0x5d, 0x0e, 0x48, 0x0e, 0x49, 0x00, 0x5e, 0x0e, 0x62,
+  0x0e, 0x65, 0x00, 0x60, 0x0e, 0x6b, 0x0e, 0x75, 0x00, 0x64, 0x0e, 0x78,
+  0x0e, 0x81, 0x00, 0x6f, 0x0e, 0x83, 0x0e, 0x87, 0x00, 0x79, 0x0e, 0x8c,
+  0x0e, 0x8f, 0x00, 0x7e, 0x0e, 0x96, 0x0e, 0xa2, 0x00, 0x82, 0x0e, 0xa4,
+  0x0e, 0xa8, 0x00, 0x8f, 0x11, 0x1c, 0x11, 0x1c, 0x00, 0x94, 0x00, 0x01,
+  0x00, 0x02, 0x0f, 0x11, 0x0f, 0x13, 0x00, 0x02, 0x00, 0x00, 0x00, 0x0a,
+  0x00, 0x00, 0x00, 0x10, 0x00, 0x01, 0x00, 0x00, 0x05, 0xf0, 0x00, 0x01,
+  0x00, 0x00, 0x05, 0xf0, 0x00, 0x01, 0x00, 0x62, 0x00, 0x4e, 0x00, 0x01,
+  0x00, 0x6a, 0x00, 0x0c, 0x00, 0x08, 0x00, 0x12, 0x00, 0x18, 0x00, 0x1e,
+  0x00, 0x24, 0x00, 0x2a, 0x00, 0x30, 0x00, 0x36, 0x00, 0x3c, 0x00, 0x01,
+  0x02, 0x0f, 0x06, 0x14, 0x00, 0x01, 0x02, 0xa1, 0x07, 0x6d, 0x00, 0x01,
+  0x02, 0x53, 0x06, 0x14, 0x00, 0x01, 0x01, 0x02, 0x06, 0x14, 0x00, 0x01,
+  0x02, 0x34, 0x06, 0x14, 0x00, 0x01, 0x02, 0x3d, 0x06, 0x14, 0x00, 0x01,
+  0x02, 0xa1, 0x07, 0x50, 0x00, 0x01, 0x03, 0x97, 0x07, 0x89, 0x00, 0x01,
+  0x00, 0x08, 0x00, 0xc3, 0x00, 0xd0, 0x00, 0xd5, 0x00, 0xed, 0x01, 0x0f,
+  0x01, 0x2d, 0x05, 0x5a, 0x05, 0x5b, 0x00, 0x01, 0x00, 0x02, 0x02, 0xb1,
+  0x02, 0xb2, 0x00, 0x02, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x10,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0x03, 0x8c, 0x02, 0xd6, 0x00, 0x01, 0x03, 0x92, 0x00, 0x0c,
+  0x00, 0x59, 0x00, 0xb4, 0x00, 0xba, 0x00, 0xc0, 0x00, 0xc6, 0x00, 0xcc,
+  0x00, 0xd2, 0x00, 0xd8, 0x00, 0xde, 0x00, 0xe4, 0x00, 0xea, 0x00, 0xf0,
+  0x00, 0xf6, 0x00, 0xfc, 0x01, 0x02, 0x01, 0x08, 0x01, 0x0e, 0x01, 0x14,
+  0x01, 0x1a, 0x01, 0x20, 0x01, 0x26, 0x01, 0x2c, 0x01, 0x32, 0x01, 0x38,
+  0x01, 0x3e, 0x01, 0x44, 0x01, 0x4a, 0x01, 0x50, 0x01, 0x56, 0x01, 0x5c,
+  0x01, 0x62, 0x01, 0x68, 0x01, 0x6e, 0x01, 0x74, 0x01, 0x7a, 0x01, 0x80,
+  0x01, 0x86, 0x01, 0x8c, 0x01, 0x92, 0x01, 0x98, 0x01, 0x9e, 0x01, 0xa4,
+  0x01, 0xaa, 0x01, 0xb0, 0x01, 0xb6, 0x01, 0xbc, 0x01, 0xc2, 0x01, 0xc8,
+  0x01, 0xce, 0x01, 0xd4, 0x01, 0xda, 0x01, 0xe0, 0x01, 0xe6, 0x01, 0xec,
+  0x01, 0xf2, 0x01, 0xf8, 0x01, 0xfe, 0x02, 0x04, 0x02, 0x0a, 0x02, 0x10,
+  0x02, 0x16, 0x02, 0x1c, 0x02, 0x22, 0x02, 0x28, 0x02, 0x2e, 0x02, 0x34,
+  0x02, 0x3a, 0x02, 0x40, 0x02, 0x46, 0x02, 0x4c, 0x02, 0x52, 0x02, 0x58,
+  0x02, 0x5e, 0x02, 0x64, 0x02, 0x6a, 0x02, 0x70, 0x02, 0x76, 0x02, 0x7c,
+  0x02, 0x82, 0x02, 0x88, 0x02, 0x8e, 0x02, 0x94, 0x02, 0x9a, 0x02, 0xa0,
+  0x02, 0xa6, 0x02, 0xac, 0x02, 0xb2, 0x02, 0xb8, 0x02, 0xbe, 0x02, 0xc4,
+  0x00, 0x01, 0x04, 0x7f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf7, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0xf5, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x0d, 0x00, 0x00, 0x00, 0x01, 0x01, 0x0d, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5e, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00,
+  0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x28, 0x00, 0x00, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x00, 0xfa, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x01, 0xf6, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe1, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01, 0x04, 0x7f, 0xfe, 0x80,
+  0x00, 0x01, 0x03, 0x6f, 0xfe, 0x80, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x7d, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01, 0x95, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x16, 0x00, 0x00, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x05, 0xd5, 0x00, 0x00,
+  0x00, 0x01, 0x04, 0xec, 0x00, 0x00, 0x00, 0x01, 0x05, 0x96, 0x00, 0x00,
+  0x00, 0x01, 0x04, 0xbd, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe8, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x85, 0x00, 0x00, 0x00, 0x01, 0x01, 0x0d, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5e, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0xf6, 0x00, 0x00, 0x00, 0x01, 0x01, 0x69, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x3d, 0xfe, 0x52, 0x00, 0x01, 0x00, 0x59, 0x00, 0x24,
+  0x00, 0x26, 0x00, 0x27, 0x00, 0x28, 0x00, 0x2b, 0x00, 0x2c, 0x00, 0x30,
+  0x00, 0x31, 0x00, 0x32, 0x00, 0x36, 0x00, 0x38, 0x00, 0x3d, 0x00, 0x44,
+  0x00, 0x46, 0x00, 0x47, 0x00, 0x48, 0x00, 0x4b, 0x00, 0x4c, 0x00, 0x50,
+  0x00, 0x51, 0x00, 0x52, 0x00, 0x56, 0x00, 0x58, 0x00, 0x5d, 0x00, 0x8e,
+  0x00, 0x8f, 0x00, 0x90, 0x00, 0x91, 0x00, 0x9a, 0x00, 0xae, 0x00, 0xaf,
+  0x00, 0xb0, 0x00, 0xb1, 0x00, 0xba, 0x00, 0xc3, 0x00, 0xc6, 0x00, 0xc7,
+  0x00, 0xd5, 0x00, 0xea, 0x00, 0xeb, 0x00, 0xec, 0x00, 0xed, 0x00, 0xee,
+  0x00, 0xef, 0x00, 0xf2, 0x00, 0xf3, 0x01, 0x0f, 0x01, 0x2d, 0x01, 0x48,
+  0x01, 0x51, 0x01, 0x52, 0x01, 0x59, 0x01, 0x61, 0x01, 0x79, 0x01, 0x7a,
+  0x01, 0x7b, 0x01, 0x91, 0x01, 0x92, 0x01, 0xca, 0x01, 0xcb, 0x01, 0xcc,
+  0x01, 0xcd, 0x02, 0x12, 0x02, 0x16, 0x02, 0x1b, 0x02, 0x1d, 0x02, 0x2a,
+  0x02, 0x37, 0x02, 0x54, 0x05, 0x7e, 0x05, 0x7f, 0x06, 0x18, 0x06, 0x19,
+  0x0e, 0x38, 0x0e, 0x44, 0x0e, 0x6c, 0x0e, 0x6d, 0x0e, 0x6e, 0x0e, 0x6f,
+  0x0e, 0x7e, 0x0e, 0x7f, 0x0e, 0x9c, 0x0e, 0x9d, 0x0e, 0xa0, 0x0e, 0xa1,
+  0x0e, 0xa2, 0x0e, 0xa7, 0x11, 0x1c, 0x11, 0xb8, 0x00, 0x01, 0x00, 0x01,
+  0x02, 0xd8, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x01, 0xfe, 0x48,
+  0x00, 0x00, 0x00, 0x01, 0x0f, 0xba, 0x0d, 0x8e, 0x00, 0x01, 0x0f, 0xf4,
+  0x00, 0x0c, 0x01, 0xb0, 0x03, 0x62, 0x03, 0x68, 0x03, 0x6e, 0x03, 0x74,
+  0x03, 0x7a, 0x03, 0x80, 0x03, 0x86, 0x03, 0x8c, 0x03, 0x92, 0x03, 0x98,
+  0x03, 0x9e, 0x03, 0xa4, 0x03, 0xaa, 0x03, 0xb0, 0x03, 0xb6, 0x03, 0xbc,
+  0x03, 0xc2, 0x03, 0xc8, 0x03, 0xce, 0x03, 0xd4, 0x03, 0xda, 0x03, 0xe0,
+  0x03, 0xe6, 0x03, 0xec, 0x03, 0xf2, 0x03, 0xf8, 0x03, 0xfe, 0x04, 0x04,
+  0x04, 0x0a, 0x04, 0x10, 0x04, 0x16, 0x04, 0x1c, 0x04, 0x22, 0x04, 0x28,
+  0x04, 0x2e, 0x04, 0x34, 0x04, 0x3a, 0x04, 0x40, 0x04, 0x46, 0x04, 0x4c,
+  0x04, 0x52, 0x04, 0x58, 0x04, 0x5e, 0x04, 0x64, 0x04, 0x6a, 0x04, 0x70,
+  0x04, 0x76, 0x04, 0x7c, 0x04, 0x82, 0x04, 0x88, 0x04, 0x8e, 0x04, 0x94,
+  0x04, 0x9a, 0x04, 0xa0, 0x04, 0xa6, 0x04, 0xac, 0x04, 0xb2, 0x04, 0xb8,
+  0x04, 0xbe, 0x04, 0xc4, 0x04, 0xca, 0x04, 0xd0, 0x04, 0xd6, 0x04, 0xdc,
+  0x04, 0xe2, 0x04, 0xe8, 0x04, 0xee, 0x04, 0xf4, 0x04, 0xfa, 0x05, 0x00,
+  0x05, 0x06, 0x05, 0x0c, 0x05, 0x12, 0x05, 0x18, 0x05, 0x1e, 0x05, 0x24,
+  0x05, 0x2a, 0x05, 0x30, 0x05, 0x36, 0x05, 0x3c, 0x05, 0x42, 0x05, 0x48,
+  0x05, 0x4e, 0x05, 0x54, 0x05, 0x5a, 0x05, 0x60, 0x05, 0x66, 0x05, 0x6c,
+  0x05, 0x72, 0x05, 0x78, 0x05, 0x7e, 0x05, 0x84, 0x05, 0x8a, 0x05, 0x90,
+  0x05, 0x96, 0x05, 0x9c, 0x05, 0xa2, 0x05, 0xa8, 0x05, 0xae, 0x05, 0xb4,
+  0x05, 0xba, 0x05, 0xc0, 0x05, 0xc6, 0x05, 0xcc, 0x05, 0xd2, 0x05, 0xd8,
+  0x05, 0xde, 0x05, 0xe4, 0x05, 0xea, 0x05, 0xf0, 0x05, 0xf6, 0x05, 0xfc,
+  0x06, 0x02, 0x06, 0x08, 0x06, 0x0e, 0x06, 0x14, 0x06, 0x1a, 0x06, 0x20,
+  0x06, 0x26, 0x06, 0x2c, 0x06, 0x32, 0x06, 0x38, 0x06, 0x3e, 0x06, 0x44,
+  0x06, 0x4a, 0x06, 0x50, 0x06, 0x56, 0x06, 0x5c, 0x06, 0x62, 0x06, 0x68,
+  0x06, 0x6e, 0x06, 0x74, 0x06, 0x7a, 0x06, 0x80, 0x06, 0x86, 0x06, 0x8c,
+  0x06, 0x92, 0x06, 0x98, 0x06, 0x9e, 0x06, 0xa4, 0x06, 0xaa, 0x06, 0xb0,
+  0x06, 0xb6, 0x06, 0xbc, 0x06, 0xc2, 0x06, 0xc8, 0x06, 0xce, 0x06, 0xd4,
+  0x06, 0xda, 0x06, 0xe0, 0x06, 0xe6, 0x06, 0xec, 0x06, 0xf2, 0x06, 0xf8,
+  0x06, 0xfe, 0x07, 0x04, 0x07, 0x0a, 0x07, 0x10, 0x07, 0x16, 0x07, 0x1c,
+  0x07, 0x22, 0x07, 0x28, 0x07, 0x2e, 0x07, 0x34, 0x07, 0x3a, 0x07, 0x40,
+  0x07, 0x46, 0x07, 0x4c, 0x07, 0x52, 0x07, 0x58, 0x07, 0x5e, 0x07, 0x64,
+  0x07, 0x6a, 0x07, 0x70, 0x07, 0x76, 0x07, 0x7c, 0x07, 0x82, 0x07, 0x88,
+  0x07, 0x8e, 0x07, 0x94, 0x07, 0x9a, 0x07, 0xa0, 0x07, 0xa6, 0x07, 0xac,
+  0x07, 0xb2, 0x07, 0xb8, 0x07, 0xbe, 0x07, 0xc4, 0x07, 0xca, 0x07, 0xd0,
+  0x07, 0xd6, 0x07, 0xdc, 0x07, 0xe2, 0x07, 0xe8, 0x07, 0xee, 0x07, 0xf4,
+  0x07, 0xfa, 0x08, 0x00, 0x08, 0x06, 0x08, 0x0c, 0x08, 0x12, 0x08, 0x18,
+  0x08, 0x1e, 0x08, 0x24, 0x08, 0x2a, 0x08, 0x30, 0x08, 0x36, 0x08, 0x3c,
+  0x08, 0x42, 0x08, 0x48, 0x08, 0x4e, 0x08, 0x54, 0x08, 0x5a, 0x08, 0x60,
+  0x08, 0x66, 0x08, 0x6c, 0x08, 0x72, 0x08, 0x78, 0x08, 0x7e, 0x08, 0x84,
+  0x08, 0x8a, 0x08, 0x90, 0x08, 0x96, 0x08, 0x9c, 0x08, 0xa2, 0x08, 0xa8,
+  0x08, 0xae, 0x08, 0xb4, 0x08, 0xba, 0x08, 0xc0, 0x08, 0xc6, 0x08, 0xcc,
+  0x08, 0xd2, 0x08, 0xd8, 0x08, 0xde, 0x08, 0xe4, 0x08, 0xea, 0x08, 0xf0,
+  0x08, 0xf6, 0x08, 0xfc, 0x09, 0x02, 0x09, 0x08, 0x09, 0x0e, 0x09, 0x14,
+  0x09, 0x1a, 0x09, 0x20, 0x09, 0x26, 0x09, 0x2c, 0x09, 0x32, 0x09, 0x38,
+  0x09, 0x3e, 0x09, 0x44, 0x09, 0x4a, 0x09, 0x50, 0x09, 0x56, 0x09, 0x5c,
+  0x09, 0x62, 0x09, 0x68, 0x09, 0x6e, 0x09, 0x74, 0x09, 0x7a, 0x09, 0x80,
+  0x09, 0x86, 0x09, 0x8c, 0x09, 0x92, 0x09, 0x98, 0x09, 0x9e, 0x09, 0xa4,
+  0x09, 0xaa, 0x09, 0xb0, 0x09, 0xb6, 0x09, 0xbc, 0x09, 0xc2, 0x09, 0xc8,
+  0x09, 0xce, 0x09, 0xd4, 0x09, 0xda, 0x09, 0xe0, 0x09, 0xe6, 0x09, 0xec,
+  0x09, 0xf2, 0x09, 0xf8, 0x09, 0xfe, 0x0a, 0x04, 0x0a, 0x0a, 0x0a, 0x10,
+  0x0a, 0x16, 0x0a, 0x1c, 0x0a, 0x22, 0x0a, 0x28, 0x0a, 0x2e, 0x0a, 0x34,
+  0x0a, 0x3a, 0x0a, 0x40, 0x0a, 0x46, 0x0a, 0x4c, 0x0a, 0x52, 0x0a, 0x58,
+  0x0a, 0x5e, 0x0a, 0x64, 0x0a, 0x6a, 0x0a, 0x70, 0x0a, 0x76, 0x0a, 0x7c,
+  0x0a, 0x82, 0x0a, 0x88, 0x0a, 0x8e, 0x0a, 0x94, 0x0a, 0x9a, 0x0a, 0xa0,
+  0x0a, 0xa6, 0x0a, 0xac, 0x0a, 0xb2, 0x0a, 0xb8, 0x0a, 0xbe, 0x0a, 0xc4,
+  0x0a, 0xca, 0x0a, 0xd0, 0x0a, 0xd6, 0x0a, 0xdc, 0x0a, 0xe2, 0x0a, 0xe8,
+  0x0a, 0xee, 0x0a, 0xf4, 0x0a, 0xfa, 0x0b, 0x00, 0x0b, 0x06, 0x0b, 0x0c,
+  0x0b, 0x12, 0x0b, 0x18, 0x0b, 0x1e, 0x0b, 0x24, 0x0b, 0x2a, 0x0b, 0x30,
+  0x0b, 0x36, 0x0b, 0x3c, 0x0b, 0x42, 0x0b, 0x48, 0x0b, 0x4e, 0x0b, 0x54,
+  0x0b, 0x5a, 0x0b, 0x60, 0x0b, 0x66, 0x0b, 0x6c, 0x0b, 0x72, 0x0b, 0x78,
+  0x0b, 0x7e, 0x0b, 0x84, 0x0b, 0x8a, 0x0b, 0x90, 0x0b, 0x96, 0x0b, 0x9c,
+  0x0b, 0xa2, 0x0b, 0xa8, 0x0b, 0xae, 0x0b, 0xb4, 0x0b, 0xba, 0x0b, 0xc0,
+  0x0b, 0xc6, 0x0b, 0xcc, 0x0b, 0xd2, 0x0b, 0xd8, 0x0b, 0xde, 0x0b, 0xe4,
+  0x0b, 0xea, 0x0b, 0xf0, 0x0b, 0xf6, 0x0b, 0xfc, 0x0c, 0x02, 0x0c, 0x08,
+  0x0c, 0x0e, 0x0c, 0x14, 0x0c, 0x1a, 0x0c, 0x20, 0x0c, 0x26, 0x0c, 0x2c,
+  0x0c, 0x32, 0x0c, 0x38, 0x0c, 0x3e, 0x0c, 0x44, 0x0c, 0x4a, 0x0c, 0x50,
+  0x0c, 0x56, 0x0c, 0x5c, 0x0c, 0x62, 0x0c, 0x68, 0x0c, 0x6e, 0x0c, 0x74,
+  0x0c, 0x7a, 0x0c, 0x80, 0x0c, 0x86, 0x0c, 0x8c, 0x0c, 0x92, 0x0c, 0x98,
+  0x0c, 0x9e, 0x0c, 0xa4, 0x0c, 0xaa, 0x0c, 0xb0, 0x0c, 0xb6, 0x0c, 0xbc,
+  0x0c, 0xc2, 0x0c, 0xc8, 0x0c, 0xce, 0x0c, 0xd4, 0x0c, 0xda, 0x0c, 0xe0,
+  0x0c, 0xe6, 0x0c, 0xec, 0x0c, 0xf2, 0x0c, 0xf8, 0x0c, 0xfe, 0x0d, 0x04,
+  0x0d, 0x0a, 0x0d, 0x10, 0x0d, 0x16, 0x0d, 0x1c, 0x0d, 0x22, 0x0d, 0x28,
+  0x0d, 0x2e, 0x0d, 0x34, 0x0d, 0x3a, 0x0d, 0x40, 0x0d, 0x46, 0x0d, 0x4c,
+  0x0d, 0x52, 0x0d, 0x58, 0x0d, 0x5e, 0x0d, 0x64, 0x0d, 0x6a, 0x0d, 0x70,
+  0x0d, 0x76, 0x0d, 0x7c, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf7, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xa1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x03, 0x06, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xb5, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x0f, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x56, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1a, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xa9, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x51, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x03, 0x8f, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x85, 0x00, 0x00, 0x00, 0x01, 0x02, 0x33, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x77, 0x00, 0x00, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x71, 0x00, 0x00, 0x00, 0x01, 0x02, 0x60, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x28, 0x00, 0x00, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x1b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x03, 0x84, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x01, 0xee, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x25, 0x00, 0x00, 0x00, 0x01, 0x02, 0x23, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x7f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00, 0x00, 0x01,
+  0x04, 0x7f, 0xfe, 0x80, 0x00, 0x01, 0x03, 0x6f, 0xfe, 0x80, 0x00, 0x01,
+  0x02, 0xa1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x28, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x88, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x48, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x02, 0x34, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x1b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x71, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x28, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7d, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x17, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x00, 0xfa, 0xfe, 0x7a, 0x00, 0x01,
+  0x02, 0x23, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0xf3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xa3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x52, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x0f, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x02, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x33, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x23, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x46, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x8d, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x4b, 0x00, 0x00, 0x00, 0x01, 0x01, 0x95, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x18, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x25, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x16, 0x00, 0x00, 0x00, 0x01, 0x02, 0x16, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x06, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x06, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x2c, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x2c, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x25, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x25, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x3d, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0xec, 0x00, 0x00, 0x00, 0x01, 0x01, 0x59, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x70, 0x00, 0x00, 0x00, 0x01, 0x01, 0xcb, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xa3, 0xfe, 0x52, 0x00, 0x01,
+  0x03, 0x84, 0x00, 0x00, 0x00, 0x01, 0x03, 0x84, 0xfe, 0x52, 0x00, 0x01,
+  0x03, 0x84, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x48, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x48, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x48, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x04, 0x18, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0xfc, 0x00, 0x00, 0x00, 0x01, 0x01, 0xfc, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xfc, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xff, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x24, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x5c, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x35, 0x00, 0x00, 0x00, 0x01, 0x02, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x15, 0x00, 0x00, 0x00, 0x01, 0x01, 0xef, 0xfe, 0x52, 0x00, 0x01,
+  0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0xbf, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xfa, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0xd9, 0xfe, 0x52, 0x00, 0x01, 0x01, 0xc2, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0x26, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x01, 0xe1, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0x84, 0x00, 0x00, 0x00, 0x01, 0x02, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x84, 0x00, 0x00, 0x00, 0x01, 0x02, 0x01, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x24, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x0d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x5f, 0xff, 0xf6, 0x00, 0x01, 0x01, 0x02, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x66, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x22, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x47, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x84, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x01, 0x00, 0x00, 0x00, 0x01, 0x03, 0x97, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x97, 0xfe, 0x52, 0x00, 0x01, 0x03, 0x97, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xf3, 0xfe, 0x52, 0x00, 0x01, 0x04, 0x19, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xd0, 0xfe, 0x52, 0x00, 0x01, 0x00, 0xfa, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x3e, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x0f, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb5, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe4, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x18, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xe3, 0x00, 0x00, 0x00, 0x01, 0x02, 0x06, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x1c, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xb7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x41, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x01, 0x85, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x76, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe0, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x4e, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x18, 0x00, 0x00, 0x00, 0x01, 0x02, 0x29, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x01, 0xcb, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x1c, 0x00, 0x00, 0x00, 0x01, 0x02, 0x21, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xa1, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x28, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0x89, 0x00, 0x01,
+  0x02, 0x28, 0xfe, 0x89, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0xbf, 0x00, 0x01,
+  0x02, 0x28, 0xfe, 0xbf, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0x74, 0x00, 0x01,
+  0x02, 0x28, 0xfe, 0x74, 0x00, 0x01, 0x02, 0xa1, 0xfe, 0x15, 0x00, 0x01,
+  0x02, 0x28, 0xfe, 0x15, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x01, 0x10, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0x00, 0x00, 0x00, 0x01, 0x03, 0x37, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xb7, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf7, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0xd5, 0x00, 0x00, 0x00, 0x01, 0x02, 0xfd, 0xfe, 0x52, 0x00, 0x01,
+  0x03, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0xda, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xa7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x94, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xda, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe2, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xd3, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xbf, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x03, 0x2a, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x3c, 0x00, 0x00, 0x00, 0x01, 0x03, 0x08, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xad, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3a, 0xfe, 0x52, 0x00, 0x01,
+  0x03, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe2, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xc4, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7f, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x33, 0x00, 0x00, 0x00, 0x01, 0x03, 0xde, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xc7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7f, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xc1, 0x00, 0x08, 0x00, 0x01, 0x02, 0x5a, 0x00, 0x07, 0x00, 0x01,
+  0x01, 0x56, 0x00, 0x00, 0x00, 0x01, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x09, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xaf, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x0e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x71, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x56, 0x00, 0x00, 0x00, 0x01, 0x02, 0x56, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x18, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb5, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x1a, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x76, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x7c, 0xff, 0xe4, 0x00, 0x01, 0x02, 0x21, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x02, 0xf3, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x21, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb5, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x5f, 0x00, 0x00, 0x00, 0x01, 0x01, 0xfc, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x34, 0x00, 0x00, 0x00, 0x01, 0x01, 0xa5, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x51, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x77, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0xb5, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x48, 0xfe, 0x52, 0x00, 0x01,
+  0x03, 0x1e, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x5b, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x0f, 0xfe, 0x56, 0x00, 0x01, 0x01, 0xe3, 0x00, 0x00, 0x00, 0x01,
+  0x04, 0x80, 0x00, 0x00, 0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0xc5, 0x00, 0x00, 0x00, 0x01, 0x03, 0x74, 0x00, 0x00, 0x00, 0x01,
+  0x04, 0x4a, 0x00, 0x00, 0x00, 0x01, 0x03, 0x6f, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x96, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1d, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x96, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1d, 0xff, 0xf6, 0x00, 0x01,
+  0x03, 0x96, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1d, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x69, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x39, 0x00, 0x00, 0x00, 0x01, 0x01, 0x69, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x83, 0x00, 0x00, 0x00, 0x01, 0x01, 0x83, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xe8, 0x00, 0x00, 0x00, 0x01, 0x02, 0x85, 0x00, 0x00, 0x00, 0x01,
+  0x04, 0xe3, 0x00, 0x00, 0x00, 0x01, 0x03, 0xaa, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
+  0x03, 0x4c, 0x00, 0x00, 0x00, 0x01, 0x03, 0x63, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0xd6, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0xab, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0xbe, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x62, 0xfe, 0x52, 0x00, 0x01,
+  0x01, 0xc4, 0xfe, 0x52, 0x00, 0x01, 0x02, 0xa9, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x03, 0x06, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0xfe, 0x52, 0x00, 0x01, 0x02, 0x5b, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa9, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x62, 0x00, 0x00, 0x00, 0x01, 0x02, 0x3d, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0x51, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xee, 0x00, 0x00, 0x00, 0x01, 0x03, 0x0f, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0x4b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x11, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0xfc, 0x00, 0x00, 0x00, 0x01, 0x03, 0x1a, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x10, 0x00, 0x00, 0x00, 0x01, 0x04, 0x51, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xa9, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xe9, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb9, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xb9, 0x00, 0x00, 0x00, 0x01, 0x03, 0x06, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x69, 0x00, 0x00, 0x00, 0x01, 0x01, 0x68, 0xfe, 0x52, 0x00, 0x01,
+  0x02, 0xb5, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa8, 0x00, 0x00, 0x00, 0x01,
+  0x03, 0xb0, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd5, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x40, 0x00, 0x00, 0x00, 0x01, 0x02, 0x8c, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xfd, 0x00, 0x00, 0x00, 0x01, 0x02, 0x9a, 0x00, 0x00, 0x00, 0x01,
+  0x04, 0x05, 0x00, 0x00, 0x00, 0x01, 0x02, 0xe6, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x8b, 0x00, 0x00, 0x00, 0x01, 0x02, 0x6e, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x37, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x02, 0x49, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x49, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x01, 0x02, 0xfe, 0x52, 0x00, 0x01, 0x01, 0x62, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x01, 0x99, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0x3d, 0xfe, 0x52, 0x00, 0x02, 0x00, 0x5c, 0x00, 0x13, 0x00, 0x1c,
+  0x00, 0x00, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x0a, 0x00, 0x44, 0x00, 0x5d,
+  0x00, 0x24, 0x00, 0x8e, 0x00, 0x91, 0x00, 0x3e, 0x00, 0x9a, 0x00, 0x9a,
+  0x00, 0x42, 0x00, 0xa8, 0x00, 0xa8, 0x00, 0x43, 0x00, 0xae, 0x00, 0xb2,
+  0x00, 0x44, 0x00, 0xba, 0x00, 0xba, 0x00, 0x49, 0x00, 0xc3, 0x00, 0xc3,
+  0x00, 0x4a, 0x00, 0xc6, 0x00, 0xc7, 0x00, 0x4b, 0x00, 0xd0, 0x00, 0xd1,
+  0x00, 0x4d, 0x00, 0xd5, 0x00, 0xd5, 0x00, 0x4f, 0x00, 0xe9, 0x00, 0xef,
+  0x00, 0x50, 0x00, 0xf2, 0x00, 0xf3, 0x00, 0x57, 0x00, 0xfa, 0x00, 0xfa,
+  0x00, 0x59, 0x01, 0x0d, 0x01, 0x0d, 0x00, 0x5a, 0x01, 0x0f, 0x01, 0x0f,
+  0x00, 0x5b, 0x01, 0x28, 0x01, 0x29, 0x00, 0x5c, 0x01, 0x2d, 0x01, 0x2d,
+  0x00, 0x5e, 0x01, 0x41, 0x01, 0x41, 0x00, 0x5f, 0x01, 0x45, 0x01, 0x45,
+  0x00, 0x60, 0x01, 0x48, 0x01, 0x48, 0x00, 0x61, 0x01, 0x4e, 0x01, 0x4e,
+  0x00, 0x62, 0x01, 0x51, 0x01, 0x52, 0x00, 0x63, 0x01, 0x54, 0x01, 0x54,
+  0x00, 0x65, 0x01, 0x59, 0x01, 0x59, 0x00, 0x66, 0x01, 0x61, 0x01, 0x61,
+  0x00, 0x67, 0x01, 0x6c, 0x01, 0x6c, 0x00, 0x68, 0x01, 0x76, 0x01, 0x76,
+  0x00, 0x69, 0x01, 0x79, 0x01, 0x7b, 0x00, 0x6a, 0x01, 0x91, 0x01, 0x92,
+  0x00, 0x6d, 0x01, 0xca, 0x01, 0xcd, 0x00, 0x6f, 0x01, 0xf6, 0x01, 0xf8,
+  0x00, 0x73, 0x02, 0x05, 0x02, 0x0c, 0x00, 0x76, 0x02, 0x0e, 0x02, 0x4a,
+  0x00, 0x7e, 0x02, 0x4c, 0x02, 0x67, 0x00, 0xbb, 0x02, 0x69, 0x02, 0x6b,
+  0x00, 0xd7, 0x02, 0x6d, 0x02, 0x6d, 0x00, 0xda, 0x03, 0x46, 0x03, 0x46,
+  0x00, 0xdb, 0x03, 0x49, 0x03, 0x49, 0x00, 0xdc, 0x03, 0x4c, 0x03, 0x4c,
+  0x00, 0xdd, 0x03, 0x88, 0x03, 0x88, 0x00, 0xde, 0x03, 0x9a, 0x03, 0x9a,
+  0x00, 0xdf, 0x03, 0xea, 0x03, 0xeb, 0x00, 0xe0, 0x04, 0x06, 0x04, 0x07,
+  0x00, 0xe2, 0x04, 0x22, 0x04, 0x22, 0x00, 0xe4, 0x04, 0x33, 0x04, 0x33,
+  0x00, 0xe5, 0x04, 0x36, 0x04, 0x36, 0x00, 0xe6, 0x04, 0x7c, 0x04, 0x7d,
+  0x00, 0xe7, 0x04, 0xba, 0x04, 0xbb, 0x00, 0xe9, 0x04, 0xbd, 0x04, 0xc2,
+  0x00, 0xeb, 0x04, 0xc5, 0x04, 0xcd, 0x00, 0xf1, 0x04, 0xd1, 0x04, 0xd5,
+  0x00, 0xfa, 0x04, 0xd9, 0x04, 0xde, 0x00, 0xff, 0x05, 0x23, 0x05, 0x23,
+  0x01, 0x05, 0x05, 0x5a, 0x05, 0x63, 0x01, 0x06, 0x05, 0x7e, 0x05, 0x7f,
+  0x01, 0x10, 0x06, 0x18, 0x06, 0x19, 0x01, 0x12, 0x06, 0x4a, 0x06, 0x4b,
+  0x01, 0x14, 0x07, 0xec, 0x07, 0xec, 0x01, 0x16, 0x07, 0xf4, 0x07, 0xf7,
+  0x01, 0x17, 0x07, 0xf9, 0x07, 0xfb, 0x01, 0x1b, 0x07, 0xfe, 0x07, 0xfe,
+  0x01, 0x1e, 0x08, 0x01, 0x08, 0x06, 0x01, 0x1f, 0x08, 0x0d, 0x08, 0x0d,
+  0x01, 0x25, 0x08, 0x11, 0x08, 0x11, 0x01, 0x26, 0x08, 0x15, 0x08, 0x16,
+  0x01, 0x27, 0x08, 0x18, 0x08, 0x1a, 0x01, 0x29, 0x08, 0x1c, 0x08, 0x1c,
+  0x01, 0x2c, 0x08, 0x1e, 0x08, 0x22, 0x01, 0x2d, 0x08, 0x25, 0x08, 0x28,
+  0x01, 0x32, 0x0a, 0x1d, 0x0a, 0x1d, 0x01, 0x36, 0x0e, 0x2b, 0x0e, 0x2b,
+  0x01, 0x37, 0x0e, 0x2d, 0x0e, 0x2e, 0x01, 0x38, 0x0e, 0x30, 0x0e, 0x41,
+  0x01, 0x3a, 0x0e, 0x43, 0x0e, 0x45, 0x01, 0x4c, 0x0e, 0x48, 0x0e, 0x49,
+  0x01, 0x4f, 0x0e, 0x62, 0x0e, 0x65, 0x01, 0x51, 0x0e, 0x67, 0x0e, 0x68,
+  0x01, 0x55, 0x0e, 0x6a, 0x0e, 0x75, 0x01, 0x57, 0x0e, 0x78, 0x0e, 0x87,
+  0x01, 0x63, 0x0e, 0x8c, 0x0e, 0x8f, 0x01, 0x73, 0x0e, 0x95, 0x0e, 0xa8,
+  0x01, 0x77, 0x0f, 0x93, 0x0f, 0xa5, 0x01, 0x8b, 0x0f, 0xbd, 0x0f, 0xbd,
+  0x01, 0x9e, 0x0f, 0xbf, 0x0f, 0xbf, 0x01, 0x9f, 0x0f, 0xf4, 0x0f, 0xfd,
+  0x01, 0xa0, 0x11, 0x1c, 0x11, 0x1d, 0x01, 0xaa, 0x11, 0x34, 0x11, 0x34,
+  0x01, 0xac, 0x11, 0x3e, 0x11, 0x3e, 0x01, 0xad, 0x11, 0x48, 0x11, 0x48,
+  0x01, 0xae, 0x11, 0xb8, 0x11, 0xb8, 0x01, 0xaf, 0x00, 0x02, 0x00, 0x09,
+  0x02, 0xc7, 0x02, 0xca, 0x00, 0x00, 0x02, 0xcd, 0x02, 0xd1, 0x00, 0x04,
+  0x02, 0xd4, 0x02, 0xd7, 0x00, 0x09, 0x02, 0xda, 0x02, 0xe4, 0x00, 0x0d,
+  0x02, 0xea, 0x02, 0xed, 0x00, 0x18, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x1c,
+  0x02, 0xfe, 0x02, 0xff, 0x00, 0x1f, 0x03, 0x03, 0x03, 0x03, 0x00, 0x21,
+  0x03, 0x06, 0x03, 0x06, 0x00, 0x22, 0x00, 0x23, 0x00, 0x00, 0x00, 0x8e,
+  0x00, 0x00, 0x00, 0x94, 0x00, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x00, 0xa0,
+  0x00, 0x00, 0x00, 0xa6, 0x00, 0x00, 0x00, 0xac, 0x00, 0x00, 0x00, 0xb2,
+  0x00, 0x00, 0x00, 0xb8, 0x00, 0x00, 0x00, 0xbe, 0x00, 0x00, 0x00, 0xc4,
+  0x00, 0x00, 0x00, 0xca, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0x00, 0xd6,
+  0x00, 0x00, 0x00, 0xdc, 0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe8,
+  0x00, 0x00, 0x00, 0xee, 0x00, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xfa,
+  0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0c,
+  0x00, 0x00, 0x01, 0x12, 0x00, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x1e,
+  0x00, 0x00, 0x01, 0x24, 0x00, 0x00, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x30,
+  0x00, 0x00, 0x01, 0x36, 0x00, 0x00, 0x01, 0x3c, 0x00, 0x00, 0x01, 0x42,
+  0x00, 0x00, 0x01, 0x48, 0x00, 0x00, 0x01, 0x4e, 0x00, 0x00, 0x01, 0x54,
+  0x00, 0x00, 0x01, 0x5a, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0x00, 0x00, 0x00, 0x01,
+  0xfe, 0x34, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xfe, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x35, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x34, 0xff, 0xff, 0x00, 0x01, 0xfe, 0x34, 0xff, 0xff, 0x00, 0x01,
+  0x15, 0x68, 0x12, 0xca, 0x00, 0x01, 0x15, 0xb4, 0x00, 0x0c, 0x02, 0x53,
+  0x04, 0xa8, 0x04, 0xae, 0x04, 0xb4, 0x04, 0xba, 0x04, 0xc0, 0x04, 0xc6,
+  0x04, 0xcc, 0x04, 0xd2, 0x04, 0xd8, 0x04, 0xde, 0x04, 0xe4, 0x04, 0xea,
+  0x04, 0xf0, 0x04, 0xf6, 0x04, 0xfc, 0x05, 0x02, 0x05, 0x08, 0x05, 0x0e,
+  0x05, 0x14, 0x05, 0x1a, 0x05, 0x20, 0x05, 0x26, 0x05, 0x2c, 0x05, 0x32,
+  0x05, 0x38, 0x05, 0x3e, 0x05, 0x44, 0x05, 0x4a, 0x05, 0x50, 0x05, 0x56,
+  0x05, 0x5c, 0x05, 0x62, 0x05, 0x68, 0x05, 0x6e, 0x05, 0x74, 0x05, 0x7a,
+  0x05, 0x80, 0x05, 0x88, 0x05, 0x8e, 0x05, 0x96, 0x05, 0x9c, 0x05, 0xa4,
+  0x05, 0xaa, 0x05, 0xb0, 0x05, 0xb6, 0x05, 0xbc, 0x05, 0xc2, 0x05, 0xc8,
+  0x05, 0xce, 0x05, 0xd4, 0x05, 0xda, 0x05, 0xe2, 0x05, 0xe8, 0x05, 0xee,
+  0x05, 0xf4, 0x05, 0xfa, 0x06, 0x00, 0x06, 0x08, 0x06, 0x0e, 0x06, 0x14,
+  0x06, 0x1a, 0x06, 0x20, 0x06, 0x26, 0x06, 0x2c, 0x06, 0x32, 0x06, 0x38,
+  0x06, 0x3e, 0x06, 0x46, 0x06, 0x4c, 0x06, 0x52, 0x06, 0x5a, 0x06, 0x60,
+  0x06, 0x66, 0x06, 0x6c, 0x06, 0x74, 0x06, 0x7a, 0x06, 0x80, 0x06, 0x86,
+  0x06, 0x8c, 0x06, 0x92, 0x06, 0x98, 0x06, 0x9e, 0x06, 0xa4, 0x06, 0xaa,
+  0x06, 0xb0, 0x06, 0xb6, 0x06, 0xbc, 0x06, 0xc2, 0x06, 0xc8, 0x06, 0xce,
+  0x06, 0xd4, 0x06, 0xda, 0x06, 0xe0, 0x06, 0xe6, 0x06, 0xec, 0x06, 0xf2,
+  0x06, 0xf8, 0x06, 0xfe, 0x07, 0x04, 0x07, 0x0a, 0x07, 0x10, 0x07, 0x16,
+  0x07, 0x1c, 0x07, 0x22, 0x07, 0x28, 0x07, 0x2e, 0x07, 0x34, 0x07, 0x3a,
+  0x07, 0x40, 0x07, 0x46, 0x07, 0x4c, 0x07, 0x52, 0x07, 0x58, 0x07, 0x5e,
+  0x07, 0x64, 0x07, 0x6a, 0x07, 0x70, 0x07, 0x76, 0x07, 0x7c, 0x07, 0x82,
+  0x07, 0x88, 0x07, 0x8e, 0x07, 0x94, 0x07, 0x9a, 0x07, 0xa0, 0x07, 0xa6,
+  0x07, 0xac, 0x07, 0xb2, 0x07, 0xb8, 0x07, 0xbe, 0x07, 0xc4, 0x07, 0xca,
+  0x07, 0xd0, 0x07, 0xd6, 0x07, 0xdc, 0x07, 0xe2, 0x07, 0xe8, 0x07, 0xee,
+  0x07, 0xf6, 0x07, 0xfc, 0x08, 0x02, 0x08, 0x08, 0x08, 0x0e, 0x08, 0x14,
+  0x08, 0x1a, 0x08, 0x22, 0x08, 0x28, 0x08, 0x2e, 0x08, 0x34, 0x08, 0x3a,
+  0x08, 0x40, 0x08, 0x46, 0x08, 0x4c, 0x08, 0x52, 0x08, 0x58, 0x08, 0x5e,
+  0x08, 0x64, 0x08, 0x6a, 0x08, 0x70, 0x08, 0x76, 0x08, 0x7c, 0x08, 0x82,
+  0x08, 0x88, 0x08, 0x8e, 0x08, 0x94, 0x08, 0x9a, 0x08, 0xa0, 0x08, 0xa6,
+  0x08, 0xac, 0x08, 0xb2, 0x08, 0xb8, 0x08, 0xc0, 0x08, 0xc6, 0x08, 0xcc,
+  0x08, 0xd2, 0x08, 0xd8, 0x08, 0xde, 0x08, 0xe4, 0x08, 0xea, 0x08, 0xf0,
+  0x08, 0xf6, 0x08, 0xfc, 0x09, 0x02, 0x09, 0x08, 0x09, 0x0e, 0x09, 0x14,
+  0x09, 0x1a, 0x09, 0x20, 0x09, 0x26, 0x09, 0x2c, 0x09, 0x32, 0x09, 0x38,
+  0x09, 0x3e, 0x09, 0x44, 0x09, 0x4a, 0x09, 0x50, 0x09, 0x56, 0x09, 0x5c,
+  0x09, 0x62, 0x09, 0x68, 0x09, 0x6e, 0x09, 0x74, 0x09, 0x7a, 0x09, 0x80,
+  0x09, 0x86, 0x09, 0x8c, 0x09, 0x92, 0x09, 0x98, 0x09, 0x9e, 0x09, 0xa4,
+  0x09, 0xaa, 0x09, 0xb0, 0x09, 0xb6, 0x09, 0xbc, 0x09, 0xc2, 0x09, 0xc8,
+  0x09, 0xce, 0x09, 0xd4, 0x09, 0xda, 0x09, 0xe0, 0x09, 0xe6, 0x09, 0xec,
+  0x09, 0xf2, 0x09, 0xf8, 0x09, 0xfe, 0x0a, 0x04, 0x0a, 0x0a, 0x0a, 0x12,
+  0x0a, 0x18, 0x0a, 0x1e, 0x0a, 0x24, 0x0a, 0x2a, 0x0a, 0x30, 0x0a, 0x36,
+  0x0a, 0x3c, 0x0a, 0x42, 0x0a, 0x48, 0x0a, 0x4e, 0x0a, 0x54, 0x0a, 0x5a,
+  0x0a, 0x60, 0x0a, 0x66, 0x0a, 0x6c, 0x0a, 0x72, 0x0a, 0x78, 0x0a, 0x7e,
+  0x0a, 0x84, 0x0a, 0x8a, 0x0a, 0x90, 0x0a, 0x96, 0x0a, 0x9c, 0x0a, 0xa2,
+  0x0a, 0xa8, 0x0a, 0xae, 0x0a, 0xb4, 0x0a, 0xba, 0x0a, 0xc0, 0x0a, 0xc6,
+  0x0a, 0xcc, 0x0a, 0xd2, 0x0a, 0xd8, 0x0a, 0xde, 0x0a, 0xe4, 0x0a, 0xea,
+  0x0a, 0xf0, 0x0a, 0xf6, 0x0a, 0xfc, 0x0b, 0x02, 0x0b, 0x08, 0x0b, 0x0e,
+  0x0b, 0x14, 0x0b, 0x1a, 0x0b, 0x20, 0x0b, 0x26, 0x0b, 0x2c, 0x0b, 0x32,
+  0x0b, 0x38, 0x0b, 0x3e, 0x0b, 0x44, 0x0b, 0x4a, 0x0b, 0x50, 0x0b, 0x56,
+  0x0b, 0x5c, 0x0b, 0x62, 0x0b, 0x68, 0x0b, 0x6e, 0x0b, 0x74, 0x0b, 0x7a,
+  0x0b, 0x80, 0x0b, 0x86, 0x0b, 0x8c, 0x0b, 0x92, 0x0b, 0x98, 0x0b, 0x9e,
+  0x0b, 0xa4, 0x0b, 0xaa, 0x0b, 0xb0, 0x0b, 0xb6, 0x0b, 0xbc, 0x0b, 0xc2,
+  0x0b, 0xc8, 0x0b, 0xce, 0x0b, 0xd4, 0x0b, 0xda, 0x0b, 0xe0, 0x0b, 0xe6,
+  0x0b, 0xec, 0x0b, 0xf2, 0x0b, 0xf8, 0x0b, 0xfe, 0x0c, 0x04, 0x0c, 0x0a,
+  0x0c, 0x10, 0x0c, 0x16, 0x0c, 0x1c, 0x0c, 0x22, 0x0c, 0x28, 0x0c, 0x2e,
+  0x0c, 0x34, 0x0c, 0x3a, 0x0c, 0x40, 0x0c, 0x46, 0x0c, 0x4c, 0x0c, 0x52,
+  0x0c, 0x58, 0x0c, 0x5e, 0x0c, 0x64, 0x0c, 0x6a, 0x0c, 0x70, 0x0c, 0x76,
+  0x0c, 0x7c, 0x0c, 0x82, 0x0c, 0x88, 0x0c, 0x8e, 0x0c, 0x94, 0x0c, 0x9a,
+  0x0c, 0xa0, 0x0c, 0xa6, 0x0c, 0xac, 0x0c, 0xb2, 0x0c, 0xb8, 0x0c, 0xbe,
+  0x0c, 0xc4, 0x0c, 0xca, 0x0c, 0xd0, 0x0c, 0xd6, 0x0c, 0xdc, 0x0c, 0xe2,
+  0x0c, 0xe8, 0x0c, 0xee, 0x0c, 0xf4, 0x0c, 0xfa, 0x0d, 0x00, 0x0d, 0x06,
+  0x0d, 0x0c, 0x0d, 0x12, 0x0d, 0x18, 0x0d, 0x1e, 0x0d, 0x24, 0x0d, 0x2a,
+  0x0d, 0x30, 0x0d, 0x36, 0x0d, 0x3c, 0x0d, 0x42, 0x0d, 0x48, 0x0d, 0x4e,
+  0x0d, 0x54, 0x0d, 0x5a, 0x0d, 0x60, 0x0d, 0x66, 0x0d, 0x6c, 0x0d, 0x72,
+  0x0d, 0x78, 0x0d, 0x7e, 0x0d, 0x84, 0x0d, 0x8a, 0x0d, 0x90, 0x0d, 0x96,
+  0x0d, 0x9c, 0x0d, 0xa2, 0x0d, 0xa8, 0x0d, 0xae, 0x0d, 0xb4, 0x0d, 0xba,
+  0x0d, 0xc0, 0x0d, 0xc6, 0x0d, 0xcc, 0x0d, 0xd2, 0x0d, 0xd8, 0x0d, 0xde,
+  0x0d, 0xe4, 0x0d, 0xea, 0x0d, 0xf0, 0x0d, 0xf6, 0x0d, 0xfc, 0x0e, 0x02,
+  0x0e, 0x08, 0x0e, 0x0e, 0x0e, 0x14, 0x0e, 0x1a, 0x0e, 0x20, 0x0e, 0x26,
+  0x0e, 0x2c, 0x0e, 0x32, 0x0e, 0x38, 0x0e, 0x3e, 0x0e, 0x44, 0x0e, 0x4a,
+  0x0e, 0x50, 0x0e, 0x56, 0x0e, 0x5c, 0x0e, 0x62, 0x0e, 0x68, 0x0e, 0x6e,
+  0x0e, 0x74, 0x0e, 0x7a, 0x0e, 0x80, 0x0e, 0x86, 0x0e, 0x8c, 0x0e, 0x92,
+  0x0e, 0x98, 0x0e, 0x9e, 0x0e, 0xa4, 0x0e, 0xaa, 0x0e, 0xb0, 0x0e, 0xb6,
+  0x0e, 0xbc, 0x0e, 0xc2, 0x0e, 0xc8, 0x0e, 0xce, 0x0e, 0xd4, 0x0e, 0xda,
+  0x0e, 0xe2, 0x0e, 0xe8, 0x0e, 0xee, 0x0e, 0xf4, 0x0e, 0xfa, 0x0f, 0x00,
+  0x0f, 0x06, 0x0f, 0x0c, 0x0f, 0x12, 0x0f, 0x18, 0x0f, 0x1e, 0x0f, 0x26,
+  0x0f, 0x2c, 0x0f, 0x32, 0x0f, 0x38, 0x0f, 0x3e, 0x0f, 0x44, 0x0f, 0x4a,
+  0x0f, 0x50, 0x0f, 0x56, 0x0f, 0x5c, 0x0f, 0x62, 0x0f, 0x68, 0x0f, 0x6e,
+  0x0f, 0x74, 0x0f, 0x7a, 0x0f, 0x80, 0x0f, 0x86, 0x0f, 0x8c, 0x0f, 0x92,
+  0x0f, 0x98, 0x0f, 0x9e, 0x0f, 0xa4, 0x0f, 0xaa, 0x0f, 0xb0, 0x0f, 0xb6,
+  0x0f, 0xbc, 0x0f, 0xc2, 0x0f, 0xc8, 0x0f, 0xce, 0x0f, 0xd4, 0x0f, 0xda,
+  0x0f, 0xe0, 0x0f, 0xe6, 0x0f, 0xec, 0x0f, 0xf2, 0x0f, 0xf8, 0x0f, 0xfe,
+  0x10, 0x04, 0x10, 0x0a, 0x10, 0x10, 0x10, 0x16, 0x10, 0x1c, 0x10, 0x22,
+  0x10, 0x28, 0x10, 0x2e, 0x10, 0x34, 0x10, 0x3a, 0x10, 0x40, 0x10, 0x46,
+  0x10, 0x4c, 0x10, 0x52, 0x10, 0x58, 0x10, 0x5e, 0x10, 0x64, 0x10, 0x6a,
+  0x10, 0x72, 0x10, 0x78, 0x10, 0x7e, 0x10, 0x84, 0x10, 0x8a, 0x10, 0x90,
+  0x10, 0x96, 0x10, 0x9c, 0x10, 0xa2, 0x10, 0xa8, 0x10, 0xae, 0x10, 0xb4,
+  0x10, 0xba, 0x10, 0xc0, 0x10, 0xc6, 0x10, 0xcc, 0x10, 0xd2, 0x10, 0xd8,
+  0x10, 0xde, 0x10, 0xe4, 0x10, 0xea, 0x10, 0xf2, 0x10, 0xf8, 0x10, 0xfe,
+  0x11, 0x04, 0x11, 0x0a, 0x11, 0x10, 0x11, 0x16, 0x11, 0x1c, 0x11, 0x22,
+  0x11, 0x28, 0x11, 0x2e, 0x11, 0x34, 0x11, 0x3c, 0x11, 0x42, 0x11, 0x48,
+  0x11, 0x4e, 0x11, 0x54, 0x11, 0x5a, 0x11, 0x60, 0x11, 0x66, 0x11, 0x6c,
+  0x11, 0x72, 0x11, 0x78, 0x11, 0x7e, 0x11, 0x84, 0x11, 0x8a, 0x11, 0x90,
+  0x11, 0x96, 0x11, 0x9c, 0x11, 0xa2, 0x11, 0xa8, 0x11, 0xae, 0x11, 0xb4,
+  0x11, 0xba, 0x11, 0xc0, 0x11, 0xc6, 0x11, 0xcc, 0x11, 0xd2, 0x11, 0xd8,
+  0x11, 0xde, 0x11, 0xe4, 0x11, 0xea, 0x11, 0xf0, 0x11, 0xf6, 0x11, 0xfc,
+  0x12, 0x02, 0x12, 0x08, 0x12, 0x0e, 0x12, 0x14, 0x12, 0x1a, 0x12, 0x20,
+  0x12, 0x26, 0x12, 0x2c, 0x12, 0x32, 0x12, 0x38, 0x12, 0x3e, 0x12, 0x44,
+  0x12, 0x4a, 0x12, 0x50, 0x12, 0x56, 0x12, 0x5c, 0x12, 0x62, 0x12, 0x68,
+  0x12, 0x6e, 0x12, 0x74, 0x12, 0x7a, 0x12, 0x80, 0x12, 0x86, 0x12, 0x8c,
+  0x12, 0x92, 0x12, 0x98, 0x12, 0x9e, 0x12, 0xa4, 0x12, 0xaa, 0x12, 0xb0,
+  0x12, 0xb6, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xf7, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x06, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x10, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0f,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x51, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x34,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x8f, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x85,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x33, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x77,
+  0x05, 0xf0, 0x00, 0x02, 0x02, 0x0f, 0x04, 0x7b, 0x00, 0x23, 0x00, 0x01,
+  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x60, 0x04, 0x7b, 0x00, 0x17,
+  0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x53, 0x04, 0x7b,
+  0x00, 0x12, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x2c,
+  0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x02,
+  0x06, 0x2f, 0x00, 0x01, 0x01, 0x02, 0x06, 0x2f, 0x00, 0x01, 0x00, 0xfa,
+  0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x84,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x02, 0x02, 0x34,
+  0x04, 0x7b, 0x00, 0x0c, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01,
+  0x02, 0x30, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01,
+  0x01, 0xef, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0, 0x00, 0x02,
+  0x02, 0x3d, 0x04, 0x7b, 0x00, 0x14, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x23, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x7f, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
+  0x00, 0x02, 0x02, 0x34, 0x04, 0x7b, 0x00, 0x1a, 0x00, 0x01, 0x00, 0xfa,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x0f,
+  0x04, 0x7b, 0x00, 0x23, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01,
+  0x03, 0x4c, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x2f, 0x05, 0xf0, 0x00, 0x02,
+  0x01, 0x00, 0x04, 0x7b, 0x00, 0x04, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x03, 0xab, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xb0, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x1f, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xf7, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x7d, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x1b, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0x06, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x78, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0x10, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x10, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0xfb, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x41, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x79, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xef, 0x04, 0x7b,
+  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x63, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x33, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x77, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x77, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x53, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x47, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0xf3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b,
+  0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x4b, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x0f, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0x02, 0x06, 0x2f, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x33, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x23, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x46, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x8d, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x02, 0x01, 0x9f, 0x04, 0x7b, 0x00, 0x03, 0x00, 0x01, 0x02, 0x62,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x97,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x16,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x16, 0x04, 0x7b, 0x00, 0x02, 0x02, 0x0f,
+  0x04, 0x7c, 0x00, 0x08, 0x00, 0x01, 0x02, 0x06, 0x04, 0x7b, 0x00, 0x01,
+  0x02, 0x06, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x04, 0x7b, 0x00, 0x01,
+  0x01, 0x02, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x2c, 0x05, 0xf0, 0x00, 0x01,
+  0x02, 0x2c, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01,
+  0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01,
+  0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01,
+  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x01, 0x06, 0x2f, 0x00, 0x01,
+  0x00, 0xec, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x59, 0x04, 0x7b, 0x00, 0x01,
+  0x01, 0x70, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xcb, 0x05, 0xf0, 0x00, 0x01,
+  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01,
+  0x03, 0x84, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x01,
+  0x03, 0x84, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01,
+  0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x02,
+  0x02, 0x34, 0x04, 0x7b, 0x00, 0x0e, 0x00, 0x01, 0x04, 0x18, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x9e, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xfa, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xfa, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x24, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x31, 0x04, 0x7b,
+  0x00, 0x01, 0x01, 0x5b, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x01, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x15, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xef, 0x04, 0x7b,
+  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xbf, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xd9, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x21, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x26, 0x04, 0x7b,
+  0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
+  0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
+  0x00, 0x01, 0x01, 0x84, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x01, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0x84, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x01, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x24, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x0d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x5f, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x06, 0x2f,
+  0x00, 0x01, 0x02, 0x66, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x2c, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x84, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x01, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xf3, 0x05, 0xf0, 0x00, 0x01, 0x04, 0x19, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0xd0, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x0f, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3e, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
+  0x00, 0x02, 0x02, 0x0f, 0x04, 0x7c, 0x00, 0x08, 0x00, 0x01, 0x02, 0x0a,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
+  0x05, 0xf0, 0x00, 0x01, 0x00, 0xf4, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5f,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x46,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0xe0, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x0a,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x31,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x35,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x2c,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0xe4, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x65,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x60,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x07, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3e,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x3e, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5c,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x35, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x07,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02,
+  0x06, 0x2f, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x62,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0xc0, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xf4,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x51, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x10,
+  0x05, 0xf0, 0x00, 0x01, 0x04, 0x59, 0x05, 0xf0, 0x00, 0x01, 0x04, 0x00,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x76,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x56, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1b,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x03, 0xe0,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x23,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xf7,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x34, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x30,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x18, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x85,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x6d,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0xd9, 0x05, 0xf0, 0x00, 0x01, 0x03, 0xd9,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x1c, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x2c,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x13,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x96,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x58,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x24, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x0a,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xaa, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x4b,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x3e, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x06,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x35,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xac, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xb7,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x5a, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x23, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x13,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5a,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x10, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x4b,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x4b, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xd2,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xcd, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0x86, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xaa,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x35, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0xef, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02,
+  0x06, 0x2f, 0x00, 0x01, 0x01, 0x02, 0x06, 0x2f, 0x00, 0x01, 0x01, 0x02,
+  0x06, 0x2f, 0x00, 0x01, 0x03, 0x94, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x8d,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0x15, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5a,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x5c, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x07,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0xc1, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0c,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xaa,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x2a, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd1,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0xe0, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3a,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xda, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0xe0, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3a,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xc5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd4,
+  0x05, 0xfa, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xcf, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x52,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x62,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0xe0, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3e,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x35,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x35,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0xb1, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0e,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x34,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x10, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5f,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xb7,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x0a, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x85,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xac,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x35,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xac, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x41,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe4,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0xab, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x18,
+  0x04, 0x83, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe3,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x06, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x62,
+  0x04, 0x7b, 0x00, 0x01, 0x00, 0xfc, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xb7,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x41, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0x85, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x76,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x76, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x76,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0xab, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe0,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x4e, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x4e,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x29,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x25, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x21,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xe1,
+  0x04, 0x7b, 0x00, 0x01, 0x01, 0xcb, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfc,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xac,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xa1,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa1,
+  0x05, 0xf0, 0x00, 0x01, 0x03, 0x97, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x37,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0xb7, 0x05, 0xf0, 0x00, 0x02, 0x02, 0xf7,
+  0x05, 0xf0, 0x00, 0x16, 0x00, 0x01, 0x03, 0xd5, 0x05, 0xf0, 0x00, 0x01,
+  0x02, 0xfd, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0f, 0x05, 0xf0, 0x00, 0x01,
+  0x01, 0x98, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xa7, 0x05, 0xf0, 0x00, 0x01,
+  0x02, 0x94, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xda, 0x05, 0xf0, 0x00, 0x01,
+  0x02, 0xe2, 0x05, 0xe2, 0x00, 0x01, 0x02, 0xd3, 0x04, 0x7b, 0x00, 0x01,
+  0x02, 0xbf, 0x05, 0xf0, 0x00, 0x02, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x0c,
+  0x00, 0x01, 0x03, 0x2a, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x3c, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0x08, 0x05, 0xe2, 0x00, 0x01, 0x02, 0xad, 0x05, 0xe2,
+  0x00, 0x01, 0x02, 0x3a, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0f, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xe2, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x82, 0x04, 0x44,
+  0x00, 0x01, 0x02, 0x7f, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x33, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0xde, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xc7, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x7f, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xc1, 0x05, 0xe7,
+  0x00, 0x01, 0x02, 0x5a, 0x05, 0xe7, 0x00, 0x01, 0x01, 0x56, 0x06, 0x31,
+  0x00, 0x01, 0x02, 0xab, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x09, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0xaf, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x0e, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x18, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfd, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x77, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x76, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x7c, 0x05, 0xd3,
+  0x00, 0x01, 0x02, 0x21, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x8f, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xf3, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x21, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5f, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x65, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x34, 0x04, 0x7b, 0x00, 0x01, 0x01, 0xa5, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x51, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x77, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0x1e, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0,
+  0x00, 0x02, 0x02, 0x0f, 0x04, 0x7b, 0x00, 0x08, 0x00, 0x01, 0x01, 0xe3,
+  0x04, 0x7b, 0x00, 0x01, 0x04, 0x80, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x6f,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0xc5, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x74,
+  0x04, 0x7b, 0x00, 0x01, 0x04, 0x4a, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x6f,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x96, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1d,
+  0x04, 0x7b, 0x00, 0x01, 0x03, 0x96, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1d,
+  0x04, 0x71, 0x00, 0x01, 0x03, 0x96, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1d,
+  0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x01,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x0c, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x69,
+  0x05, 0xf0, 0x00, 0x01, 0x01, 0x39, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x83,
+  0x05, 0xf0, 0x00, 0x01, 0x02, 0xe8, 0x05, 0xf0, 0x00, 0x02, 0x02, 0x85,
+  0x04, 0x7b, 0x00, 0x00, 0x00, 0x01, 0x04, 0xe3, 0x05, 0xf0, 0x00, 0x01,
+  0x03, 0xaa, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0, 0x00, 0x01,
+  0x02, 0x62, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x4c, 0x05, 0xf0, 0x00, 0x01,
+  0x03, 0x63, 0x04, 0x7b, 0x00, 0x01, 0x02, 0xd6, 0x05, 0xf0, 0x00, 0x01,
+  0x02, 0x30, 0x04, 0x7b, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01,
+  0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x01, 0xab, 0x05, 0xf0, 0x00, 0x02,
+  0x01, 0x00, 0x04, 0x7b, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa4, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x6d, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xc4, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x06, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x2c, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x5b, 0x05, 0xf0,
+  0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x48, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x3d, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xe1, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x51, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xef, 0x04, 0x7b, 0x00, 0x01, 0x03, 0x0f, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0x4b, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x11, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0xfc, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x1a, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0x10, 0x07, 0x88, 0x00, 0x01, 0x04, 0x51, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa3, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xe9, 0x06, 0x04, 0x00, 0x01, 0x02, 0xb9, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xb9, 0x05, 0xf0, 0x00, 0x01, 0x03, 0x06, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0x69, 0x05, 0xf0, 0x00, 0x01, 0x01, 0x68, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xb5, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa8, 0x05, 0xf0,
+  0x00, 0x01, 0x03, 0xb0, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xd5, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x40, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x8c, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0xfd, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x9a, 0x05, 0xf0,
+  0x00, 0x01, 0x04, 0x05, 0x05, 0xf7, 0x00, 0x01, 0x02, 0xe6, 0x05, 0xf7,
+  0x00, 0x01, 0x02, 0x8b, 0x05, 0xf7, 0x00, 0x01, 0x02, 0x6e, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x1f, 0x04, 0x7b, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x37, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0x49, 0x05, 0xf0,
+  0x00, 0x01, 0x02, 0x49, 0x05, 0xf0, 0x00, 0x01, 0x02, 0xa9, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0x01, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
+  0x00, 0x01, 0x02, 0x9f, 0x05, 0xf0, 0x00, 0x01, 0x00, 0xfa, 0x05, 0xf0,
+  0x00, 0x01, 0x01, 0x02, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x02, 0x04, 0x7b,
+  0x00, 0x01, 0x01, 0x02, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x99, 0x05, 0xf0,
+  0x00, 0x02, 0x03, 0x43, 0x00, 0x6a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6f,
+  0x00, 0x13, 0x00, 0x1c, 0x00, 0x00, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x0a,
+  0x00, 0x44, 0x00, 0x5d, 0x00, 0x24, 0x00, 0x9a, 0x00, 0x9a, 0x00, 0x3e,
+  0x00, 0xa8, 0x00, 0xa9, 0x00, 0x3f, 0x00, 0xb2, 0x00, 0xb2, 0x00, 0x41,
+  0x00, 0xba, 0x00, 0xba, 0x00, 0x42, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0x43,
+  0x00, 0xc6, 0x00, 0xc7, 0x00, 0x44, 0x00, 0xd1, 0x00, 0xd1, 0x00, 0x46,
+  0x00, 0xe8, 0x00, 0xe9, 0x00, 0x47, 0x00, 0xf3, 0x00, 0xf3, 0x00, 0x49,
+  0x00, 0xfa, 0x00, 0xfa, 0x00, 0x4a, 0x01, 0x0d, 0x01, 0x0d, 0x00, 0x4b,
+  0x01, 0x15, 0x01, 0x15, 0x00, 0x4c, 0x01, 0x28, 0x01, 0x29, 0x00, 0x4d,
+  0x01, 0x35, 0x01, 0x35, 0x00, 0x4f, 0x01, 0x41, 0x01, 0x42, 0x00, 0x50,
+  0x01, 0x45, 0x01, 0x45, 0x00, 0x52, 0x01, 0x48, 0x01, 0x49, 0x00, 0x53,
+  0x01, 0x4e, 0x01, 0x4e, 0x00, 0x55, 0x01, 0x50, 0x01, 0x56, 0x00, 0x56,
+  0x01, 0x58, 0x01, 0x59, 0x00, 0x5d, 0x01, 0x5b, 0x01, 0x5d, 0x00, 0x5f,
+  0x01, 0x5f, 0x01, 0x5f, 0x00, 0x62, 0x01, 0x61, 0x01, 0x61, 0x00, 0x63,
+  0x01, 0x66, 0x01, 0x66, 0x00, 0x64, 0x01, 0x69, 0x01, 0x6a, 0x00, 0x65,
+  0x01, 0x6c, 0x01, 0x70, 0x00, 0x67, 0x01, 0x74, 0x01, 0x7b, 0x00, 0x6c,
+  0x01, 0xac, 0x01, 0xac, 0x00, 0x74, 0x01, 0xf6, 0x01, 0xf9, 0x00, 0x75,
+  0x02, 0x05, 0x02, 0x0c, 0x00, 0x79, 0x02, 0x0e, 0x02, 0x4a, 0x00, 0x81,
+  0x02, 0x4c, 0x02, 0x67, 0x00, 0xbe, 0x02, 0x69, 0x02, 0x6b, 0x00, 0xda,
+  0x02, 0x6d, 0x02, 0x6d, 0x00, 0xdd, 0x03, 0x45, 0x03, 0x5d, 0x00, 0xde,
+  0x03, 0x64, 0x03, 0x65, 0x00, 0xf7, 0x03, 0x69, 0x03, 0x69, 0x00, 0xf9,
+  0x03, 0x6b, 0x03, 0x6b, 0x00, 0xfa, 0x03, 0x6d, 0x03, 0x6d, 0x00, 0xfb,
+  0x03, 0x6f, 0x03, 0x6f, 0x00, 0xfc, 0x03, 0x77, 0x03, 0x77, 0x00, 0xfd,
+  0x03, 0x84, 0x03, 0x8a, 0x00, 0xfe, 0x03, 0x8c, 0x03, 0x8c, 0x01, 0x05,
+  0x03, 0x90, 0x03, 0x90, 0x01, 0x06, 0x03, 0x98, 0x03, 0x9a, 0x01, 0x07,
+  0x03, 0x9d, 0x03, 0x9e, 0x01, 0x0a, 0x03, 0xa3, 0x03, 0xac, 0x01, 0x0c,
+  0x03, 0xae, 0x03, 0xcc, 0x01, 0x16, 0x03, 0xce, 0x03, 0xe3, 0x01, 0x35,
+  0x03, 0xe8, 0x03, 0xef, 0x01, 0x4b, 0x03, 0xf3, 0x04, 0x01, 0x01, 0x53,
+  0x04, 0x04, 0x04, 0x09, 0x01, 0x62, 0x04, 0x22, 0x04, 0x23, 0x01, 0x68,
+  0x04, 0x2a, 0x04, 0x2b, 0x01, 0x6a, 0x04, 0x2e, 0x04, 0x36, 0x01, 0x6c,
+  0x04, 0x40, 0x04, 0x40, 0x01, 0x75, 0x04, 0x4d, 0x04, 0x4d, 0x01, 0x76,
+  0x04, 0x58, 0x04, 0x58, 0x01, 0x77, 0x04, 0x5e, 0x04, 0x5e, 0x01, 0x78,
+  0x04, 0x62, 0x04, 0x62, 0x01, 0x79, 0x04, 0x7c, 0x04, 0x7d, 0x01, 0x7a,
+  0x04, 0x8b, 0x04, 0x8b, 0x01, 0x7c, 0x04, 0x92, 0x04, 0x93, 0x01, 0x7d,
+  0x04, 0xa7, 0x04, 0xa7, 0x01, 0x7f, 0x04, 0xb2, 0x04, 0xb3, 0x01, 0x80,
+  0x04, 0xb5, 0x04, 0xb5, 0x01, 0x82, 0x04, 0xb7, 0x04, 0xb7, 0x01, 0x83,
+  0x04, 0xba, 0x04, 0xc2, 0x01, 0x84, 0x04, 0xc5, 0x04, 0xce, 0x01, 0x8d,
+  0x04, 0xd1, 0x04, 0xd5, 0x01, 0x97, 0x04, 0xd8, 0x04, 0xde, 0x01, 0x9c,
+  0x04, 0xe2, 0x04, 0xe2, 0x01, 0xa3, 0x05, 0x23, 0x05, 0x23, 0x01, 0xa4,
+  0x05, 0x5c, 0x05, 0x63, 0x01, 0xa5, 0x06, 0x4a, 0x06, 0x4b, 0x01, 0xad,
+  0x07, 0xec, 0x07, 0xec, 0x01, 0xaf, 0x07, 0xf4, 0x07, 0xf7, 0x01, 0xb0,
+  0x07, 0xf9, 0x07, 0xfb, 0x01, 0xb4, 0x07, 0xfe, 0x07, 0xfe, 0x01, 0xb7,
+  0x08, 0x01, 0x08, 0x06, 0x01, 0xb8, 0x08, 0x0d, 0x08, 0x0d, 0x01, 0xbe,
+  0x08, 0x11, 0x08, 0x11, 0x01, 0xbf, 0x08, 0x15, 0x08, 0x16, 0x01, 0xc0,
+  0x08, 0x18, 0x08, 0x1a, 0x01, 0xc2, 0x08, 0x1c, 0x08, 0x1c, 0x01, 0xc5,
+  0x08, 0x1e, 0x08, 0x22, 0x01, 0xc6, 0x08, 0x25, 0x08, 0x28, 0x01, 0xcb,
+  0x0a, 0x1d, 0x0a, 0x1d, 0x01, 0xcf, 0x0e, 0x2b, 0x0e, 0x45, 0x01, 0xd0,
+  0x0e, 0x48, 0x0e, 0x49, 0x01, 0xeb, 0x0e, 0x62, 0x0e, 0x65, 0x01, 0xed,
+  0x0e, 0x67, 0x0e, 0x68, 0x01, 0xf1, 0x0e, 0x6a, 0x0e, 0x75, 0x01, 0xf3,
+  0x0e, 0x78, 0x0e, 0x87, 0x01, 0xff, 0x0e, 0x89, 0x0e, 0x89, 0x02, 0x0f,
+  0x0e, 0x8b, 0x0e, 0x8f, 0x02, 0x10, 0x0e, 0x94, 0x0e, 0xa8, 0x02, 0x15,
+  0x0f, 0x93, 0x0f, 0xa5, 0x02, 0x2a, 0x0f, 0xbd, 0x0f, 0xbd, 0x02, 0x3d,
+  0x0f, 0xbf, 0x0f, 0xbf, 0x02, 0x3e, 0x0f, 0xf4, 0x0f, 0xfd, 0x02, 0x3f,
+  0x11, 0x1b, 0x11, 0x1d, 0x02, 0x49, 0x11, 0x34, 0x11, 0x34, 0x02, 0x4c,
+  0x11, 0x3e, 0x11, 0x3e, 0x02, 0x4d, 0x11, 0x42, 0x11, 0x42, 0x02, 0x4e,
+  0x11, 0x45, 0x11, 0x46, 0x02, 0x4f, 0x11, 0x48, 0x11, 0x48, 0x02, 0x51,
+  0x11, 0xb8, 0x11, 0xb8, 0x02, 0x52, 0x00, 0x02, 0x00, 0x0c, 0x02, 0xb1,
+  0x02, 0xc5, 0x00, 0x00, 0x02, 0xee, 0x02, 0xf3, 0x00, 0x15, 0x02, 0xf5,
+  0x02, 0xf5, 0x00, 0x1b, 0x02, 0xf7, 0x02, 0xf7, 0x00, 0x1c, 0x02, 0xfb,
+  0x02, 0xfd, 0x00, 0x1d, 0x03, 0x01, 0x03, 0x02, 0x00, 0x20, 0x03, 0x04,
+  0x03, 0x04, 0x00, 0x22, 0x04, 0x17, 0x04, 0x1b, 0x00, 0x23, 0x05, 0x4a,
+  0x05, 0x4f, 0x00, 0x28, 0x07, 0xe3, 0x07, 0xe9, 0x00, 0x2e, 0x10, 0xeb,
+  0x10, 0xf5, 0x00, 0x35, 0x11, 0xac, 0x11, 0xac, 0x00, 0x40, 0x00, 0x41,
+  0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x01, 0x0e, 0x00, 0x00, 0x01, 0x16,
+  0x00, 0x00, 0x01, 0x1e, 0x00, 0x00, 0x01, 0x24, 0x00, 0x00, 0x01, 0x2a,
+  0x00, 0x00, 0x01, 0x30, 0x00, 0x00, 0x01, 0x36, 0x00, 0x00, 0x01, 0x3e,
+  0x00, 0x00, 0x01, 0x46, 0x00, 0x00, 0x01, 0x4c, 0x00, 0x00, 0x01, 0x52,
+  0x00, 0x00, 0x01, 0x58, 0x00, 0x00, 0x01, 0x60, 0x00, 0x00, 0x01, 0x66,
+  0x00, 0x00, 0x01, 0x6c, 0x00, 0x00, 0x01, 0x72, 0x00, 0x00, 0x01, 0x78,
+  0x00, 0x00, 0x01, 0x7e, 0x00, 0x00, 0x01, 0x84, 0x00, 0x00, 0x01, 0x8a,
+  0x00, 0x00, 0x01, 0x90, 0x00, 0x00, 0x01, 0x96, 0x00, 0x00, 0x01, 0x9c,
+  0x00, 0x00, 0x01, 0xa2, 0x00, 0x00, 0x01, 0xa8, 0x00, 0x00, 0x01, 0xae,
+  0x00, 0x00, 0x01, 0xb4, 0x00, 0x00, 0x01, 0xba, 0x00, 0x00, 0x01, 0xc0,
+  0x00, 0x00, 0x01, 0xc6, 0x00, 0x00, 0x01, 0xcc, 0x00, 0x00, 0x01, 0xd2,
+  0x00, 0x00, 0x01, 0xd8, 0x00, 0x00, 0x01, 0xde, 0x00, 0x00, 0x01, 0xe4,
+  0x00, 0x00, 0x01, 0xea, 0x00, 0x00, 0x01, 0xf0, 0x00, 0x00, 0x01, 0xf6,
+  0x00, 0x00, 0x01, 0xfc, 0x00, 0x00, 0x02, 0x02, 0x00, 0x00, 0x02, 0x08,
+  0x00, 0x00, 0x02, 0x0e, 0x00, 0x00, 0x02, 0x14, 0x00, 0x00, 0x02, 0x1a,
+  0x00, 0x00, 0x02, 0x20, 0x00, 0x00, 0x02, 0x26, 0x00, 0x00, 0x02, 0x2c,
+  0x00, 0x00, 0x02, 0x32, 0x00, 0x00, 0x02, 0x38, 0x00, 0x00, 0x02, 0x3e,
+  0x00, 0x00, 0x02, 0x46, 0x00, 0x00, 0x02, 0x4e, 0x00, 0x00, 0x02, 0x54,
+  0x00, 0x00, 0x02, 0x5a, 0x00, 0x00, 0x02, 0x60, 0x00, 0x00, 0x02, 0x66,
+  0x00, 0x00, 0x02, 0x6c, 0x00, 0x00, 0x02, 0x72, 0x00, 0x00, 0x02, 0x78,
+  0x00, 0x00, 0x02, 0x7e, 0x00, 0x00, 0x02, 0x84, 0x00, 0x00, 0x02, 0x8a,
+  0x00, 0x00, 0x02, 0x90, 0x00, 0x00, 0x02, 0x96, 0x00, 0x02, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x04, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x04,
+  0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x02, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x04, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x08,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x07, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0xb0,
+  0x03, 0x6f, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x72, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x72, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0xb0,
+  0x04, 0x72, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfd, 0xcd, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0xa6,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x6e, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x48,
+  0x04, 0x7b, 0x00, 0x01, 0xfd, 0x39, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x02, 0xfe, 0x34,
+  0x04, 0x7b, 0x00, 0x0c, 0x00, 0x02, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x10,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b,
+  0x00, 0x01, 0xfe, 0x34, 0x04, 0x7b, 0x00, 0x01, 0x01, 0x3e, 0x00, 0xfe,
+  0x00, 0x01, 0x01, 0x44, 0x00, 0x0c, 0x00, 0x1e, 0x00, 0x3e, 0x00, 0x44,
+  0x00, 0x4a, 0x00, 0x50, 0x00, 0x56, 0x00, 0x5c, 0x00, 0x62, 0x00, 0x68,
+  0x00, 0x6e, 0x00, 0x74, 0x00, 0x7a, 0x00, 0x80, 0x00, 0x86, 0x00, 0x8c,
+  0x00, 0x92, 0x00, 0x98, 0x00, 0x9e, 0x00, 0xa4, 0x00, 0xaa, 0x00, 0xb0,
+  0x00, 0xb6, 0x00, 0xbc, 0x00, 0xc2, 0x00, 0xc8, 0x00, 0xce, 0x00, 0xd4,
+  0x00, 0xda, 0x00, 0xe0, 0x00, 0xe6, 0x00, 0xec, 0x00, 0x01, 0x04, 0x5c,
+  0x00, 0x00, 0x00, 0x01, 0x03, 0x60, 0x00, 0x00, 0x00, 0x01, 0x01, 0x35,
+  0x00, 0x00, 0x00, 0x01, 0x02, 0xd7, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa3,
+  0x00, 0x00, 0x00, 0x01, 0x02, 0x59, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77,
+  0xff, 0xfe, 0x00, 0x01, 0x03, 0x54, 0x00, 0x00, 0x00, 0x01, 0x03, 0x14,
+  0x00, 0x00, 0x00, 0x01, 0x01, 0x1e, 0x00, 0x00, 0x00, 0x01, 0x02, 0x35,
+  0x00, 0x00, 0x00, 0x01, 0x03, 0xb1, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe1,
+  0xfe, 0x56, 0x00, 0x01, 0x01, 0xe1, 0x00, 0x00, 0x00, 0x01, 0x02, 0xd7,
+  0x00, 0x00, 0x00, 0x01, 0x02, 0x35, 0x00, 0x00, 0x00, 0x01, 0x01, 0x1e,
+  0x00, 0x00, 0x00, 0x01, 0x02, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x35,
+  0x00, 0x00, 0x00, 0x01, 0x02, 0xd7, 0x00, 0x00, 0x00, 0x01, 0x02, 0x77,
+  0x00, 0x00, 0x00, 0x01, 0x02, 0x53, 0x00, 0x00, 0x00, 0x01, 0x02, 0x47,
+  0xfe, 0x52, 0x00, 0x01, 0x02, 0x46, 0x00, 0x00, 0x00, 0x01, 0x01, 0x95,
+  0x00, 0x00, 0x00, 0x01, 0x01, 0x23, 0x00, 0x00, 0x00, 0x01, 0x02, 0x35,
+  0x00, 0x00, 0x00, 0x01, 0x01, 0xe1, 0xfe, 0x52, 0x00, 0x01, 0x04, 0xb6,
+  0x00, 0x00, 0x00, 0x01, 0x01, 0x23, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1e,
+  0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x32, 0x00, 0x38, 0x00, 0x3c,
+  0x00, 0x3d, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c, 0x00, 0x52, 0x00, 0x58,
+  0x00, 0x5c, 0x00, 0x5d, 0x00, 0x9a, 0x00, 0xba, 0x00, 0xf3, 0x01, 0x48,
+  0x01, 0x59, 0x01, 0x61, 0x01, 0x79, 0x01, 0x7a, 0x01, 0x7b, 0x02, 0x12,
+  0x02, 0x16, 0x02, 0x2a, 0x02, 0x37, 0x02, 0x54, 0x0e, 0x38, 0x11, 0x1c,
+  0x00, 0x01, 0x00, 0x01, 0x02, 0xd9, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06,
+  0x00, 0x01, 0xfe, 0x29, 0x00, 0x00, 0x00, 0x02, 0x26, 0xf0, 0x00, 0x04,
+  0x00, 0x00, 0x21, 0x30, 0x23, 0x20, 0x00, 0x35, 0x00, 0x50, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4b, 0x00, 0x72,
+  0x00, 0x39, 0x00, 0x4b, 0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0xff, 0x88,
+  0xff, 0xad, 0xff, 0x9a, 0xff, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26,
+  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4b, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
+  0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61,
+  0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
+  0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75,
+  0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61, 0x00, 0x00, 0xff, 0x61, 0xff, 0x75,
+  0xff, 0xad, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x03, 0x00, 0x2f, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0xff, 0xb7, 0x00, 0x00,
+  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00,
+  0xff, 0x90, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0x90, 0xff, 0x90,
+  0xff, 0xad, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xc9, 0xff, 0x44, 0x00, 0x00,
+  0x00, 0x00, 0xfe, 0xb7, 0xff, 0x61, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7,
+  0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x44, 0xff, 0x90, 0x00, 0x00, 0xff, 0xb7, 0xff, 0x90, 0xff, 0x44,
+  0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0xb7,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xdc, 0xff, 0xb7,
+  0x00, 0x00, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00,
+  0xfe, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xd3, 0xff, 0xd3, 0xff, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xc1, 0xff, 0xb7, 0x00, 0x00,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xc1,
+  0xff, 0x90, 0x00, 0x00, 0xff, 0x29, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0xff, 0xc9, 0x00, 0x00,
+  0xff, 0xb7, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x9a,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0x7d, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x90, 0xff, 0xdc, 0xff, 0x9a, 0x00, 0x00, 0xff, 0x9a,
+  0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xc1, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x2f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xe6,
+  0xff, 0x9a, 0xff, 0x1f, 0xff, 0x44, 0x00, 0x00, 0xfe, 0xf0, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xfe, 0x61, 0xfd, 0xe6, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x39, 0xff, 0xad, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x7d,
+  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
+  0xff, 0x44, 0x00, 0x00, 0xff, 0xd3, 0xfe, 0xc1, 0x00, 0x00, 0xff, 0x7d,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0xff, 0xa4, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00,
+  0xff, 0xdc, 0xff, 0xb7, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xa4, 0xff, 0xb7, 0x00, 0x00, 0xff, 0xb7,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x26, 0x00, 0x26, 0xfe, 0xb7, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0x7d, 0x00, 0x00,
+  0xff, 0xad, 0xff, 0xb7, 0xff, 0xc1, 0xff, 0xad, 0x00, 0x00, 0xff, 0x9a,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x6b, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0x00, 0x00,
+  0xff, 0x7d, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x90, 0xff, 0x90, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x9a,
+  0xff, 0xd3, 0xff, 0xa4, 0x00, 0x00, 0xff, 0xa4, 0xff, 0xa4, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0x7d,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44, 0xff, 0x0d,
+  0xff, 0x1f, 0xff, 0x61, 0x00, 0x00, 0xff, 0x88, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xfe, 0xad, 0xfe, 0xa4, 0x00, 0x00, 0xfe, 0xa4, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xa4, 0xfe, 0xd3, 0xfe, 0xad,
+  0x00, 0x00, 0xfe, 0xc9, 0x00, 0x00, 0xfe, 0xad, 0x00, 0x00, 0xfe, 0xc1,
+  0xff, 0x44, 0xff, 0x90, 0x00, 0x00, 0xff, 0x88, 0xff, 0x11, 0xfe, 0xe0,
+  0x00, 0x00, 0xfe, 0xf4, 0xfe, 0xe7, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xa4,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xfe, 0xf8, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x88, 0xfe, 0xf8, 0xff, 0x59, 0xff, 0x7d,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc9, 0xff, 0x4e, 0xff, 0x90,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0xff, 0x61, 0x00, 0x00, 0xff, 0x61,
+  0xff, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xfe, 0xe6, 0x00, 0x00, 0xff, 0xad, 0xff, 0x15,
+  0xff, 0x88, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x7d, 0x00, 0x00, 0x00, 0x00, 0xff, 0x88, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0xff, 0x88, 0xff, 0xa4, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0xff, 0x90, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x88,
+  0x00, 0x00, 0xff, 0x88, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xfe, 0xf8, 0x00, 0x00,
+  0xff, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x7d, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xa4,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b,
+  0x00, 0x00, 0xff, 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x61, 0xff, 0xad,
+  0xff, 0xd3, 0x00, 0x00, 0xff, 0x0d, 0xfe, 0x61, 0xfe, 0xf0, 0xff, 0x61,
+  0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xe6, 0x00, 0x00,
+  0x00, 0x00, 0xfe, 0xf0, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00,
+  0x00, 0x00, 0xfe, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x15,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x1f, 0xff, 0x6b,
+  0x00, 0x00, 0xff, 0x90, 0xfe, 0xe6, 0xfe, 0xf0, 0x00, 0x00, 0xfe, 0xf0,
+  0xff, 0x15, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x90, 0xff, 0xdc, 0xfe, 0xf8, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0x6b, 0xff, 0xb7, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xb7, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x41, 0x00, 0x00, 0xff, 0x15, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xb7,
+  0x00, 0x00, 0xff, 0xb7, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b, 0xff, 0x90,
+  0xff, 0xa4, 0x00, 0x00, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x6b, 0xff, 0xb7, 0xff, 0x7d, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x44,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0xd3, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xd3, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc9, 0x00, 0x00,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3,
+  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x56, 0xfe, 0xc9, 0x00, 0x00,
+  0xff, 0xc9, 0xff, 0x61, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0xfe, 0xf0, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44, 0xff, 0x90, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1,
+  0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0xfe, 0xdc, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xfe, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0xff, 0x90,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x97, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xb7, 0xff, 0xb7, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0x44,
+  0x00, 0x00, 0xff, 0x4e, 0xff, 0x90, 0xff, 0x90, 0xff, 0x1f, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xd3, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00,
+  0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad,
+  0x00, 0x00, 0xff, 0x75, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0xff, 0xdc, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad,
+  0xff, 0x61, 0xff, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xf8, 0xff, 0x03,
+  0x00, 0x2f, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x39,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0xff, 0x7d,
+  0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00,
+  0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75, 0xff, 0xb7, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
+  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90,
+  0xfe, 0xf8, 0xff, 0x03, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
+  0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61,
+  0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x03, 0x00, 0x2f, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xad, 0xff, 0xa4,
+  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x6b,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x44, 0x00, 0x00,
+  0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0x90,
+  0xff, 0xad, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xa4, 0xff, 0x90, 0xff, 0xb7, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc,
+  0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x61,
+  0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00, 0xff, 0x61, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xb7, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0x00, 0x00, 0xff, 0x75,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0x61,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad, 0xff, 0x61, 0xff, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x02, 0x00, 0x2f, 0x00, 0x00,
+  0xff, 0xd3, 0xff, 0xdc, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0xff, 0x7d, 0xff, 0x90, 0x00, 0x00,
+  0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc, 0xff, 0xdc,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0x88, 0xff, 0xad,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x39,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0xff, 0xdc, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0xad,
+  0xff, 0x61, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xfe, 0xf8, 0xff, 0x02,
+  0x00, 0x2f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xd3, 0xff, 0xc9, 0xff, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x7d, 0xff, 0x44, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd3, 0xff, 0xdc, 0xff, 0xd3,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0xff, 0xd3,
+  0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xc9, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x56,
+  0xfe, 0xc9, 0x00, 0x00, 0xff, 0x44, 0xff, 0x0d, 0xff, 0x1f, 0xff, 0x61,
+  0x00, 0x00, 0xff, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xad, 0xfe, 0xa4,
+  0x00, 0x00, 0xfe, 0xa4, 0x00, 0x00, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00,
+  0x00, 0x00, 0xfe, 0xa4, 0xfe, 0xd3, 0xfe, 0xad, 0x00, 0x00, 0xfe, 0xc9,
+  0x00, 0x00, 0xfe, 0xad, 0x00, 0x00, 0xfe, 0xc1, 0xff, 0x44, 0xff, 0x90,
+  0x00, 0x00, 0xff, 0x88, 0xfe, 0xad, 0xfe, 0xa4, 0x00, 0x00, 0xfe, 0xa4,
+  0xfe, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xa4, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xd3, 0xfe, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xd3, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x4b, 0x00, 0x72, 0x00, 0x39, 0x00, 0x4b, 0x00, 0x00, 0xff, 0x44,
+  0x00, 0x00, 0xff, 0x88, 0xff, 0xad, 0xff, 0x9a, 0xff, 0x0d, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xc9, 0x00, 0x00, 0x00, 0x00, 0xff, 0xdc,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xf8, 0xff, 0xc1, 0xff, 0xb7,
+  0xff, 0xc1, 0xff, 0xc1, 0xff, 0xb7, 0xff, 0xc1, 0xff, 0xb7, 0xff, 0xb7,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x88,
+  0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x90, 0xff, 0x6b,
+  0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xb7,
+  0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x7d, 0xff, 0xb7,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0x6b, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26,
+  0xff, 0xb7, 0xff, 0x90, 0xff, 0xb7, 0xff, 0xb7, 0xff, 0xb7, 0x00, 0x2f,
+  0xff, 0x90, 0xff, 0x90, 0x00, 0x00, 0xfe, 0xe6, 0x00, 0x00, 0xfe, 0x88,
+  0xff, 0x03, 0xff, 0xb7, 0xfe, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xb7, 0xff, 0xb7, 0xff, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x15, 0xff, 0x3c, 0x00, 0x00, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x26, 0xff, 0x90, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0xff, 0xb7,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xb7, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x52, 0x00, 0x10,
+  0x00, 0x10, 0x00, 0x01, 0x00, 0x24, 0x00, 0x24, 0x00, 0x02, 0x00, 0x25,
+  0x00, 0x25, 0x00, 0x03, 0x00, 0x26, 0x00, 0x26, 0x00, 0x04, 0x00, 0x27,
+  0x00, 0x27, 0x00, 0x05, 0x00, 0x29, 0x00, 0x29, 0x00, 0x06, 0x00, 0x2a,
+  0x00, 0x2a, 0x00, 0x07, 0x00, 0x2b, 0x00, 0x2b, 0x00, 0x08, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x09, 0x00, 0x2e, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x2f,
+  0x00, 0x2f, 0x00, 0x0b, 0x00, 0x32, 0x00, 0x32, 0x00, 0x0c, 0x00, 0x33,
+  0x00, 0x33, 0x00, 0x0d, 0x00, 0x34, 0x00, 0x34, 0x00, 0x0e, 0x00, 0x35,
+  0x00, 0x35, 0x00, 0x0f, 0x00, 0x36, 0x00, 0x36, 0x00, 0x10, 0x00, 0x37,
+  0x00, 0x37, 0x00, 0x11, 0x00, 0x38, 0x00, 0x38, 0x00, 0x12, 0x00, 0x39,
+  0x00, 0x39, 0x00, 0x13, 0x00, 0x3a, 0x00, 0x3a, 0x00, 0x14, 0x00, 0x3b,
+  0x00, 0x3b, 0x00, 0x15, 0x00, 0x3c, 0x00, 0x3c, 0x00, 0x16, 0x00, 0x3d,
+  0x00, 0x3d, 0x00, 0x17, 0x00, 0x48, 0x00, 0x48, 0x00, 0x18, 0x00, 0x49,
+  0x00, 0x49, 0x00, 0x19, 0x00, 0x4e, 0x00, 0x4e, 0x00, 0x1a, 0x00, 0x51,
+  0x00, 0x51, 0x00, 0x1b, 0x00, 0x52, 0x00, 0x52, 0x00, 0x1c, 0x00, 0x55,
+  0x00, 0x55, 0x00, 0x1d, 0x00, 0x59, 0x00, 0x59, 0x00, 0x1e, 0x00, 0x5a,
+  0x00, 0x5a, 0x00, 0x1f, 0x00, 0x5b, 0x00, 0x5b, 0x00, 0x20, 0x00, 0x5c,
+  0x00, 0x5c, 0x00, 0x21, 0x00, 0x6d, 0x00, 0x6d, 0x00, 0x22, 0x00, 0x7d,
+  0x00, 0x7d, 0x00, 0x23, 0x00, 0x82, 0x00, 0x82, 0x00, 0x24, 0x00, 0x83,
+  0x00, 0x84, 0x00, 0x25, 0x00, 0x85, 0x00, 0x85, 0x00, 0x26, 0x00, 0x86,
+  0x00, 0x86, 0x00, 0x25, 0x00, 0x88, 0x00, 0x88, 0x00, 0x27, 0x00, 0x89,
+  0x00, 0x89, 0x00, 0x28, 0x00, 0x92, 0x00, 0x92, 0x00, 0x05, 0x00, 0x94,
+  0x00, 0x98, 0x00, 0x0c, 0x00, 0x9b, 0x00, 0x9e, 0x00, 0x12, 0x00, 0x9f,
+  0x00, 0x9f, 0x00, 0x16, 0x00, 0xa0, 0x00, 0xa0, 0x00, 0x29, 0x00, 0xa1,
+  0x00, 0xa1, 0x00, 0x2a, 0x00, 0xaa, 0x00, 0xad, 0x00, 0x18, 0x00, 0xb2,
+  0x00, 0xb2, 0x00, 0x2b, 0x00, 0xb3, 0x00, 0xb3, 0x00, 0x1b, 0x00, 0xb4,
+  0x00, 0xb8, 0x00, 0x1c, 0x00, 0xbf, 0x00, 0xbf, 0x00, 0x21, 0x00, 0xc1,
+  0x00, 0xc1, 0x00, 0x21, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x2c, 0x00, 0xc4,
+  0x00, 0xc4, 0x00, 0x2c, 0x00, 0xc6, 0x00, 0xc6, 0x00, 0x2d, 0x00, 0xc8,
+  0x00, 0xc8, 0x00, 0x28, 0x00, 0xce, 0x00, 0xce, 0x00, 0x28, 0x00, 0xd0,
+  0x00, 0xd0, 0x00, 0x05, 0x00, 0xd2, 0x00, 0xd2, 0x00, 0x2e, 0x00, 0xdd,
+  0x00, 0xdd, 0x00, 0x18, 0x00, 0xe0, 0x00, 0xe0, 0x00, 0x07, 0x00, 0xfb,
+  0x00, 0xfb, 0x00, 0x0b, 0x00, 0xff, 0x00, 0xff, 0x00, 0x0b, 0x01, 0x02,
+  0x01, 0x02, 0x00, 0x2f, 0x01, 0x0a, 0x01, 0x0a, 0x00, 0x1b, 0x01, 0x16,
+  0x01, 0x16, 0x00, 0x0f, 0x01, 0x17, 0x01, 0x17, 0x00, 0x1d, 0x01, 0x1a,
+  0x01, 0x1a, 0x00, 0x0f, 0x01, 0x1b, 0x01, 0x1b, 0x00, 0x30, 0x01, 0x20,
+  0x01, 0x20, 0x00, 0x10, 0x01, 0x22, 0x01, 0x22, 0x00, 0x10, 0x01, 0x26,
+  0x01, 0x26, 0x00, 0x31, 0x01, 0x30, 0x01, 0x30, 0x00, 0x12, 0x01, 0x3a,
+  0x01, 0x3a, 0x00, 0x16, 0x01, 0x3f, 0x01, 0x3f, 0x00, 0x17, 0x07, 0x45,
+  0x07, 0x45, 0x00, 0x32, 0x07, 0x51, 0x07, 0x51, 0x00, 0x33, 0x07, 0x53,
+  0x07, 0x53, 0x00, 0x34, 0x0e, 0x60, 0x0e, 0x60, 0x00, 0x11, 0x0e, 0x78,
+  0x0e, 0x78, 0x00, 0x0a, 0x0e, 0x79, 0x0e, 0x79, 0x00, 0x1a, 0x00, 0x02,
+  0x00, 0xa2, 0x00, 0x10, 0x00, 0x10, 0x00, 0x01, 0x00, 0x11, 0x00, 0x11,
+  0x00, 0x02, 0x00, 0x1d, 0x00, 0x1d, 0x00, 0x03, 0x00, 0x24, 0x00, 0x24,
+  0x00, 0x04, 0x00, 0x25, 0x00, 0x25, 0x00, 0x05, 0x00, 0x26, 0x00, 0x26,
+  0x00, 0x06, 0x00, 0x27, 0x00, 0x27, 0x00, 0x07, 0x00, 0x29, 0x00, 0x29,
+  0x00, 0x08, 0x00, 0x2a, 0x00, 0x2a, 0x00, 0x09, 0x00, 0x2b, 0x00, 0x2b,
+  0x00, 0x08, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x0a, 0x00, 0x2e, 0x00, 0x2f,
+  0x00, 0x08, 0x00, 0x32, 0x00, 0x32, 0x00, 0x0b, 0x00, 0x33, 0x00, 0x33,
+  0x00, 0x08, 0x00, 0x34, 0x00, 0x34, 0x00, 0x0c, 0x00, 0x35, 0x00, 0x35,
+  0x00, 0x08, 0x00, 0x36, 0x00, 0x36, 0x00, 0x0d, 0x00, 0x37, 0x00, 0x37,
+  0x00, 0x0e, 0x00, 0x38, 0x00, 0x38, 0x00, 0x0f, 0x00, 0x39, 0x00, 0x39,
+  0x00, 0x10, 0x00, 0x3a, 0x00, 0x3a, 0x00, 0x11, 0x00, 0x3b, 0x00, 0x3b,
+  0x00, 0x12, 0x00, 0x3c, 0x00, 0x3c, 0x00, 0x13, 0x00, 0x3d, 0x00, 0x3d,
+  0x00, 0x14, 0x00, 0x44, 0x00, 0x44, 0x00, 0x15, 0x00, 0x46, 0x00, 0x46,
+  0x00, 0x16, 0x00, 0x47, 0x00, 0x47, 0x00, 0x17, 0x00, 0x48, 0x00, 0x48,
+  0x00, 0x18, 0x00, 0x49, 0x00, 0x49, 0x00, 0x19, 0x00, 0x4a, 0x00, 0x4b,
+  0x00, 0x1a, 0x00, 0x4c, 0x00, 0x4c, 0x00, 0x1b, 0x00, 0x4f, 0x00, 0x4f,
+  0x00, 0x1c, 0x00, 0x50, 0x00, 0x50, 0x00, 0x1a, 0x00, 0x51, 0x00, 0x51,
+  0x00, 0x1d, 0x00, 0x52, 0x00, 0x52, 0x00, 0x1e, 0x00, 0x54, 0x00, 0x54,
+  0x00, 0x17, 0x00, 0x55, 0x00, 0x55, 0x00, 0x1f, 0x00, 0x56, 0x00, 0x56,
+  0x00, 0x20, 0x00, 0x57, 0x00, 0x57, 0x00, 0x21, 0x00, 0x58, 0x00, 0x58,
+  0x00, 0x22, 0x00, 0x59, 0x00, 0x59, 0x00, 0x23, 0x00, 0x5a, 0x00, 0x5a,
+  0x00, 0x24, 0x00, 0x5b, 0x00, 0x5b, 0x00, 0x25, 0x00, 0x5c, 0x00, 0x5c,
+  0x00, 0x26, 0x00, 0x6d, 0x00, 0x6d, 0x00, 0x27, 0x00, 0x7d, 0x00, 0x7d,
+  0x00, 0x28, 0x00, 0x82, 0x00, 0x86, 0x00, 0x04, 0x00, 0x88, 0x00, 0x88,
+  0x00, 0x29, 0x00, 0x89, 0x00, 0x89, 0x00, 0x2a, 0x00, 0x94, 0x00, 0x98,
+  0x00, 0x0b, 0x00, 0x9b, 0x00, 0x9e, 0x00, 0x0f, 0x00, 0x9f, 0x00, 0x9f,
+  0x00, 0x13, 0x00, 0xa0, 0x00, 0xa1, 0x00, 0x08, 0x00, 0xa2, 0x00, 0xa2,
+  0x00, 0x2b, 0x00, 0xa3, 0x00, 0xa3, 0x00, 0x15, 0x00, 0xa4, 0x00, 0xa7,
+  0x00, 0x2b, 0x00, 0xa9, 0x00, 0xa9, 0x00, 0x16, 0x00, 0xaa, 0x00, 0xaa,
+  0x00, 0x2c, 0x00, 0xab, 0x00, 0xab, 0x00, 0x18, 0x00, 0xac, 0x00, 0xad,
+  0x00, 0x2c, 0x00, 0xb2, 0x00, 0xb2, 0x00, 0x2d, 0x00, 0xb3, 0x00, 0xb3,
+  0x00, 0x1d, 0x00, 0xb4, 0x00, 0xb4, 0x00, 0x2e, 0x00, 0xb5, 0x00, 0xb5,
+  0x00, 0x1e, 0x00, 0xb6, 0x00, 0xb8, 0x00, 0x2e, 0x00, 0xbb, 0x00, 0xbb,
+  0x00, 0x2f, 0x00, 0xbc, 0x00, 0xbc, 0x00, 0x22, 0x00, 0xbd, 0x00, 0xbe,
+  0x00, 0x2f, 0x00, 0xbf, 0x00, 0xbf, 0x00, 0x26, 0x00, 0xc1, 0x00, 0xc1,
+  0x00, 0x26, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x30, 0x00, 0xc3, 0x00, 0xc3,
+  0x00, 0x31, 0x00, 0xc4, 0x00, 0xc4, 0x00, 0x30, 0x00, 0xc5, 0x00, 0xc5,
+  0x00, 0x31, 0x00, 0xc6, 0x00, 0xc6, 0x00, 0x30, 0x00, 0xc7, 0x00, 0xc7,
+  0x00, 0x31, 0x00, 0xc8, 0x00, 0xc8, 0x00, 0x06, 0x00, 0xc9, 0x00, 0xc9,
+  0x00, 0x32, 0x00, 0xca, 0x00, 0xca, 0x00, 0x33, 0x00, 0xcb, 0x00, 0xcb,
+  0x00, 0x34, 0x00, 0xcc, 0x00, 0xcc, 0x00, 0x33, 0x00, 0xcd, 0x00, 0xcd,
+  0x00, 0x35, 0x00, 0xce, 0x00, 0xce, 0x00, 0x06, 0x00, 0xcf, 0x00, 0xcf,
+  0x00, 0x32, 0x00, 0xd0, 0x00, 0xd0, 0x00, 0x07, 0x00, 0xd1, 0x00, 0xd1,
+  0x00, 0x36, 0x00, 0xd3, 0x00, 0xd3, 0x00, 0x37, 0x00, 0xd5, 0x00, 0xd5,
+  0x00, 0x38, 0x00, 0xd7, 0x00, 0xd7, 0x00, 0x38, 0x00, 0xd9, 0x00, 0xd9,
+  0x00, 0x38, 0x00, 0xdb, 0x00, 0xdb, 0x00, 0x38, 0x00, 0xdd, 0x00, 0xdd,
+  0x00, 0x18, 0x00, 0xde, 0x00, 0xde, 0x00, 0x33, 0x00, 0xe0, 0x00, 0xe0,
+  0x00, 0x39, 0x00, 0xe1, 0x00, 0xe1, 0x00, 0x1a, 0x00, 0xe2, 0x00, 0xe2,
+  0x00, 0x33, 0x00, 0xe4, 0x00, 0xe4, 0x00, 0x3a, 0x00, 0xf1, 0x00, 0xf1,
+  0x00, 0x3b, 0x00, 0xf5, 0x00, 0xf5, 0x00, 0x3b, 0x00, 0xfb, 0x00, 0xfb,
+  0x00, 0x08, 0x00, 0xff, 0x00, 0xff, 0x00, 0x08, 0x01, 0x0a, 0x01, 0x0a,
+  0x00, 0x1d, 0x01, 0x0e, 0x01, 0x0e, 0x00, 0x33, 0x01, 0x0f, 0x01, 0x0f,
+  0x00, 0x3c, 0x01, 0x10, 0x01, 0x10, 0x00, 0x33, 0x01, 0x11, 0x01, 0x11,
+  0x00, 0x3c, 0x01, 0x12, 0x01, 0x12, 0x00, 0x3d, 0x01, 0x13, 0x01, 0x13,
+  0x00, 0x3c, 0x01, 0x16, 0x01, 0x16, 0x00, 0x08, 0x01, 0x17, 0x01, 0x17,
+  0x00, 0x1f, 0x01, 0x19, 0x01, 0x19, 0x00, 0x3b, 0x01, 0x1a, 0x01, 0x1a,
+  0x00, 0x08, 0x01, 0x1b, 0x01, 0x1b, 0x00, 0x1f, 0x01, 0x1c, 0x01, 0x1c,
+  0x00, 0x0d, 0x01, 0x1e, 0x01, 0x1e, 0x00, 0x0d, 0x01, 0x20, 0x01, 0x20,
+  0x00, 0x0d, 0x01, 0x21, 0x01, 0x21, 0x00, 0x20, 0x01, 0x22, 0x01, 0x22,
+  0x00, 0x0d, 0x01, 0x23, 0x01, 0x23, 0x00, 0x20, 0x01, 0x24, 0x01, 0x24,
+  0x00, 0x3e, 0x01, 0x25, 0x01, 0x25, 0x00, 0x35, 0x01, 0x26, 0x01, 0x26,
+  0x00, 0x0e, 0x01, 0x27, 0x01, 0x27, 0x00, 0x21, 0x01, 0x28, 0x01, 0x28,
+  0x00, 0x3f, 0x01, 0x2b, 0x01, 0x2b, 0x00, 0x40, 0x01, 0x2d, 0x01, 0x2d,
+  0x00, 0x40, 0x01, 0x2f, 0x01, 0x2f, 0x00, 0x40, 0x01, 0x30, 0x01, 0x30,
+  0x00, 0x0f, 0x01, 0x31, 0x01, 0x31, 0x00, 0x22, 0x01, 0x33, 0x01, 0x33,
+  0x00, 0x40, 0x01, 0x35, 0x01, 0x35, 0x00, 0x40, 0x01, 0x36, 0x01, 0x36,
+  0x00, 0x41, 0x01, 0x37, 0x01, 0x37, 0x00, 0x42, 0x01, 0x38, 0x01, 0x38,
+  0x00, 0x43, 0x01, 0x39, 0x01, 0x39, 0x00, 0x44, 0x01, 0x3a, 0x01, 0x3a,
+  0x00, 0x13, 0x01, 0x3f, 0x01, 0x3f, 0x00, 0x14, 0x01, 0x88, 0x01, 0x88,
+  0x00, 0x34, 0x01, 0xac, 0x01, 0xac, 0x00, 0x45, 0x01, 0xad, 0x01, 0xad,
+  0x00, 0x46, 0x01, 0xae, 0x01, 0xae, 0x00, 0x45, 0x01, 0xaf, 0x01, 0xaf,
+  0x00, 0x46, 0x01, 0xda, 0x01, 0xda, 0x00, 0x0d, 0x01, 0xdc, 0x01, 0xdc,
+  0x00, 0x47, 0x01, 0xdd, 0x01, 0xdd, 0x00, 0x34, 0x01, 0xf0, 0x01, 0xf0,
+  0x00, 0x33, 0x01, 0xf1, 0x01, 0xf1, 0x00, 0x48, 0x01, 0xf3, 0x01, 0xf3,
+  0x00, 0x34, 0x01, 0xf4, 0x01, 0xf4, 0x00, 0x49, 0x01, 0xf5, 0x01, 0xf5,
+  0x00, 0x4a, 0x05, 0xd0, 0x05, 0xd0, 0x00, 0x41, 0x05, 0xd1, 0x05, 0xd1,
+  0x00, 0x4b, 0x05, 0xd2, 0x05, 0xd2, 0x00, 0x4c, 0x05, 0xd3, 0x05, 0xd3,
+  0x00, 0x42, 0x05, 0xd4, 0x05, 0xd4, 0x00, 0x41, 0x05, 0xd5, 0x05, 0xd5,
+  0x00, 0x42, 0x06, 0x42, 0x06, 0x42, 0x00, 0x43, 0x06, 0x43, 0x06, 0x43,
+  0x00, 0x44, 0x07, 0x51, 0x07, 0x51, 0x00, 0x4d, 0x07, 0x52, 0x07, 0x52,
+  0x00, 0x4e, 0x07, 0x53, 0x07, 0x53, 0x00, 0x4f, 0x0e, 0x78, 0x0e, 0x78,
+  0x00, 0x08, 0x00, 0x01, 0x00, 0x61, 0x00, 0x10, 0x00, 0x24, 0x00, 0x25,
+  0x00, 0x26, 0x00, 0x27, 0x00, 0x29, 0x00, 0x2a, 0x00, 0x2b, 0x00, 0x2d,
+  0x00, 0x2e, 0x00, 0x2f, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00, 0x35,
+  0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39, 0x00, 0x3a, 0x00, 0x3b,
+  0x00, 0x3c, 0x00, 0x3d, 0x00, 0x48, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x51,
+  0x00, 0x52, 0x00, 0x55, 0x00, 0x59, 0x00, 0x5a, 0x00, 0x5b, 0x00, 0x5c,
+  0x00, 0x6d, 0x00, 0x7d, 0x00, 0x82, 0x00, 0x83, 0x00, 0x84, 0x00, 0x85,
+  0x00, 0x86, 0x00, 0x88, 0x00, 0x89, 0x00, 0x92, 0x00, 0x94, 0x00, 0x95,
+  0x00, 0x96, 0x00, 0x97, 0x00, 0x98, 0x00, 0x9b, 0x00, 0x9c, 0x00, 0x9d,
+  0x00, 0x9e, 0x00, 0x9f, 0x00, 0xa0, 0x00, 0xa1, 0x00, 0xaa, 0x00, 0xab,
+  0x00, 0xac, 0x00, 0xad, 0x00, 0xb2, 0x00, 0xb3, 0x00, 0xb4, 0x00, 0xb5,
+  0x00, 0xb6, 0x00, 0xb7, 0x00, 0xb8, 0x00, 0xbf, 0x00, 0xc1, 0x00, 0xc2,
+  0x00, 0xc4, 0x00, 0xc6, 0x00, 0xc8, 0x00, 0xce, 0x00, 0xd0, 0x00, 0xd2,
+  0x00, 0xdd, 0x00, 0xe0, 0x00, 0xfb, 0x00, 0xff, 0x01, 0x02, 0x01, 0x0a,
+  0x01, 0x16, 0x01, 0x17, 0x01, 0x1a, 0x01, 0x1b, 0x01, 0x20, 0x01, 0x22,
+  0x01, 0x26, 0x01, 0x30, 0x01, 0x3a, 0x01, 0x3f, 0x07, 0x45, 0x07, 0x51,
+  0x07, 0x53, 0x0e, 0x60, 0x0e, 0x78, 0x0e, 0x79, 0x00, 0x02, 0x00, 0x60,
+  0x00, 0x04, 0x00, 0x00, 0x00, 0x24, 0x00, 0x58, 0x00, 0x05, 0x00, 0x02,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xd8, 0x00, 0x00, 0xff, 0xb1,
+  0x00, 0x00, 0xff, 0xa3, 0x00, 0x00, 0xff, 0x9c, 0x00, 0x01, 0x0e, 0xaa,
+  0x00, 0x17, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x03, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x01, 0x0e, 0xc2, 0x00, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x04,
+  0x0e, 0xaa, 0x0e, 0xae, 0x00, 0x00, 0x0e, 0xb0, 0x0e, 0xb4, 0x00, 0x05,
+  0x0e, 0xb6, 0x0e, 0xba, 0x00, 0x0a, 0x0e, 0xbc, 0x0e, 0xc0, 0x00, 0x0f,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x0a, 0x01, 0xf0, 0x02, 0x9e, 0x00, 0x14,
+  0x44, 0x46, 0x4c, 0x54, 0x00, 0x7a, 0x61, 0x72, 0x61, 0x62, 0x00, 0x88,
+  0x61, 0x72, 0x6d, 0x6e, 0x00, 0xa6, 0x62, 0x72, 0x61, 0x69, 0x00, 0xb2,
+  0x63, 0x61, 0x6e, 0x73, 0x00, 0xbe, 0x63, 0x68, 0x65, 0x72, 0x00, 0xca,
+  0x63, 0x79, 0x72, 0x6c, 0x00, 0xd6, 0x67, 0x65, 0x6f, 0x72, 0x00, 0xf8,
+  0x67, 0x72, 0x65, 0x6b, 0x01, 0x04, 0x68, 0x61, 0x6e, 0x69, 0x01, 0x14,
+  0x68, 0x65, 0x62, 0x72, 0x01, 0x20, 0x6b, 0x61, 0x6e, 0x61, 0x01, 0x2c,
+  0x6c, 0x61, 0x6f, 0x20, 0x01, 0x38, 0x6c, 0x61, 0x74, 0x6e, 0x01, 0x44,
+  0x6d, 0x61, 0x74, 0x68, 0x01, 0x9e, 0x6e, 0x6b, 0x6f, 0x20, 0x01, 0xaa,
+  0x6f, 0x67, 0x61, 0x6d, 0x01, 0xb6, 0x72, 0x75, 0x6e, 0x72, 0x01, 0xc2,
+  0x74, 0x66, 0x6e, 0x67, 0x01, 0xce, 0x74, 0x68, 0x61, 0x69, 0x01, 0xda,
+  0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x03,
+  0x00, 0x06, 0x00, 0x16, 0x00, 0x03, 0x4b, 0x55, 0x52, 0x20, 0x00, 0x16,
+  0x53, 0x4e, 0x44, 0x20, 0x00, 0x16, 0x55, 0x52, 0x44, 0x20, 0x00, 0x16,
+  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
+  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x10, 0x00, 0x02,
+  0x4d, 0x4b, 0x44, 0x20, 0x00, 0x18, 0x53, 0x52, 0x42, 0x20, 0x00, 0x18,
+  0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x05, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x02, 0x00, 0x05, 0x00, 0x0a, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x03, 0x00, 0x01, 0x00, 0x05, 0x00, 0x0c, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x04, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x01, 0x00, 0x03, 0x00, 0x34,
+  0x00, 0x08, 0x49, 0x53, 0x4d, 0x20, 0x00, 0x46, 0x4b, 0x53, 0x4d, 0x20,
+  0x00, 0x46, 0x4c, 0x53, 0x4d, 0x20, 0x00, 0x46, 0x4d, 0x4f, 0x4c, 0x20,
+  0x00, 0x34, 0x4e, 0x53, 0x4d, 0x20, 0x00, 0x46, 0x52, 0x4f, 0x4d, 0x20,
+  0x00, 0x34, 0x53, 0x4b, 0x53, 0x20, 0x00, 0x46, 0x53, 0x53, 0x4d, 0x20,
+  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x02, 0x00, 0x05,
+  0x00, 0x07, 0x00, 0x08, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x07, 0x00, 0x02, 0x00, 0x05, 0x00, 0x07, 0x00, 0x08, 0x00, 0x09,
+  0x00, 0x0b, 0x00, 0x0d, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x01, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
+  0x00, 0x01, 0x00, 0x03, 0x00, 0x0e, 0x20, 0x52, 0x51, 0x44, 0x00, 0x56,
+  0x61, 0x61, 0x6c, 0x74, 0x00, 0x5c, 0x61, 0x61, 0x6c, 0x74, 0x00, 0x62,
+  0x63, 0x63, 0x6d, 0x70, 0x00, 0x68, 0x63, 0x63, 0x6d, 0x70, 0x00, 0x6e,
+  0x63, 0x63, 0x6d, 0x70, 0x00, 0x76, 0x64, 0x6c, 0x69, 0x67, 0x00, 0x7e,
+  0x64, 0x6c, 0x69, 0x67, 0x00, 0x84, 0x68, 0x6c, 0x69, 0x67, 0x00, 0x8a,
+  0x6c, 0x69, 0x67, 0x61, 0x00, 0x90, 0x6c, 0x6f, 0x63, 0x6c, 0x00, 0x96,
+  0x6c, 0x6f, 0x63, 0x6c, 0x00, 0x9c, 0x73, 0x61, 0x6c, 0x74, 0x00, 0xa2,
+  0x73, 0x61, 0x6c, 0x74, 0x00, 0xa8, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0d,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x03, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x03, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x00, 0x01, 0x00, 0x07, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x08, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0c, 0x00, 0x16,
+  0x00, 0x2e, 0x00, 0x36, 0x00, 0x3e, 0x00, 0x46, 0x00, 0x60, 0x00, 0x68,
+  0x00, 0x70, 0x00, 0x78, 0x00, 0x80, 0x00, 0x88, 0x00, 0x90, 0x00, 0x98,
+  0x00, 0xa0, 0x00, 0xa8, 0x00, 0xb0, 0x00, 0xb8, 0x00, 0xc0, 0x00, 0xc8,
+  0x00, 0xd0, 0x00, 0xd8, 0x00, 0xe0, 0x00, 0xe8, 0x00, 0x06, 0x00, 0x09,
+  0x00, 0x01, 0x00, 0xc2, 0x00, 0x06, 0x00, 0x01, 0x00, 0x01, 0x01, 0x12,
+  0x00, 0x06, 0x00, 0x00, 0x00, 0x01, 0x01, 0x3e, 0x00, 0x06, 0x00, 0x00,
+  0x00, 0x0a, 0x04, 0xb2, 0x05, 0x0a, 0x05, 0x62, 0x05, 0xba, 0x06, 0x12,
+  0x06, 0x6a, 0x06, 0xac, 0x06, 0xf4, 0x07, 0x3c, 0x07, 0x84, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x07, 0xac, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x07, 0xb0, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x07, 0xb4, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x01, 0x07, 0xe8, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
+  0x07, 0xf8, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x08, 0x08, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x08, 0x9c, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x08, 0xba, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x08, 0xd8, 0x00, 0x03,
+  0x00, 0x00, 0x00, 0x01, 0x08, 0xee, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x09, 0x20, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x09, 0x52, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x09, 0x88, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x09, 0x90, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x09, 0x98, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x09, 0xa0, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x09, 0xa8, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x09, 0xb0, 0x00, 0x02,
+  0x00, 0x10, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x02, 0x00, 0x00,
+  0x00, 0x30, 0x00, 0x02, 0x00, 0x02, 0x07, 0x42, 0x07, 0x42, 0x00, 0x00,
+  0x11, 0x52, 0x11, 0xab, 0x00, 0x01, 0x00, 0x02, 0x00, 0x02, 0x07, 0x42,
+  0x07, 0x42, 0x00, 0x01, 0x11, 0x52, 0x11, 0xab, 0x00, 0x01, 0x00, 0x03,
+  0x00, 0x08, 0x00, 0x14, 0x00, 0x1e, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x02, 0x00, 0x12, 0x00, 0x16, 0x00, 0x1e, 0x00, 0x1e,
+  0x00, 0x03, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x02, 0x00, 0x16, 0x00, 0x8c,
+  0x00, 0x8c, 0x00, 0x8c, 0x00, 0x05, 0x00, 0x00, 0x03, 0x0c, 0x03, 0x44,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x39, 0x00, 0x4c, 0x00, 0x4d,
+  0x00, 0xf1, 0x02, 0x0b, 0x02, 0x2a, 0x02, 0x5f, 0x02, 0xb1, 0x02, 0xb2,
+  0x02, 0xb3, 0x02, 0xb4, 0x02, 0xb5, 0x02, 0xb6, 0x02, 0xb7, 0x02, 0xb8,
+  0x02, 0xb9, 0x02, 0xba, 0x02, 0xbb, 0x02, 0xbc, 0x02, 0xbd, 0x02, 0xbe,
+  0x02, 0xbf, 0x02, 0xc0, 0x02, 0xc1, 0x02, 0xc2, 0x02, 0xc3, 0x02, 0xc4,
+  0x02, 0xc5, 0x02, 0xee, 0x02, 0xef, 0x02, 0xf0, 0x02, 0xf1, 0x02, 0xf2,
+  0x02, 0xf3, 0x02, 0xf4, 0x02, 0xf5, 0x02, 0xf7, 0x02, 0xfb, 0x02, 0xfc,
+  0x02, 0xfd, 0x03, 0x01, 0x03, 0x02, 0x03, 0x04, 0x03, 0x87, 0x03, 0xea,
+  0x03, 0xec, 0x04, 0x17, 0x04, 0x18, 0x04, 0x19, 0x04, 0x1a, 0x05, 0x7d,
+  0x06, 0x1b, 0x07, 0xe3, 0x07, 0xe4, 0x07, 0xe5, 0x07, 0xe6, 0x08, 0x31,
+  0x08, 0x32, 0x00, 0x02, 0x00, 0x6a, 0x00, 0x24, 0x00, 0x3d, 0x00, 0x03,
+  0x00, 0x45, 0x00, 0x45, 0x00, 0x03, 0x00, 0x47, 0x00, 0x47, 0x00, 0x03,
+  0x00, 0x49, 0x00, 0x49, 0x00, 0x03, 0x00, 0x4b, 0x00, 0x4b, 0x00, 0x03,
+  0x00, 0x4c, 0x00, 0x4d, 0x00, 0x01, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x03,
+  0x00, 0x57, 0x00, 0x57, 0x00, 0x03, 0x00, 0x82, 0x00, 0x98, 0x00, 0x03,
+  0x00, 0x9a, 0x00, 0xa1, 0x00, 0x03, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x03,
+  0x00, 0xc4, 0x00, 0xc4, 0x00, 0x03, 0x00, 0xc6, 0x00, 0xc6, 0x00, 0x03,
+  0x00, 0xc8, 0x00, 0xc8, 0x00, 0x03, 0x00, 0xca, 0x00, 0xca, 0x00, 0x03,
+  0x00, 0xcc, 0x00, 0xcc, 0x00, 0x03, 0x00, 0xce, 0x00, 0xce, 0x00, 0x03,
+  0x00, 0xd0, 0x00, 0xd0, 0x00, 0x03, 0x00, 0xd2, 0x00, 0xd2, 0x00, 0x03,
+  0x00, 0xd4, 0x00, 0xd4, 0x00, 0x03, 0x00, 0xd6, 0x00, 0xd6, 0x00, 0x03,
+  0x00, 0xd8, 0x00, 0xd8, 0x00, 0x03, 0x00, 0xda, 0x00, 0xda, 0x00, 0x03,
+  0x00, 0xdc, 0x00, 0xdc, 0x00, 0x03, 0x00, 0xde, 0x00, 0xde, 0x00, 0x03,
+  0x00, 0xe0, 0x00, 0xe0, 0x00, 0x03, 0x00, 0xe2, 0x00, 0xe2, 0x00, 0x03,
+  0x00, 0xe4, 0x00, 0xe4, 0x00, 0x03, 0x00, 0xe6, 0x00, 0xea, 0x00, 0x03,
+  0x00, 0xec, 0x00, 0xec, 0x00, 0x03, 0x00, 0xee, 0x00, 0xee, 0x00, 0x03,
+  0x00, 0xf0, 0x00, 0xf0, 0x00, 0x03, 0x00, 0xf1, 0x00, 0xf1, 0x00, 0x01,
+  0x00, 0xf2, 0x00, 0xf2, 0x00, 0x03, 0x00, 0xf4, 0x00, 0xf4, 0x00, 0x03,
+  0x00, 0xf6, 0x00, 0xf6, 0x00, 0x03, 0x00, 0xf8, 0x00, 0xf8, 0x00, 0x03,
+  0x00, 0xfb, 0x01, 0x05, 0x00, 0x03, 0x01, 0x07, 0x01, 0x07, 0x00, 0x03,
+  0x01, 0x09, 0x01, 0x09, 0x00, 0x03, 0x01, 0x0c, 0x01, 0x0c, 0x00, 0x03,
+  0x01, 0x0e, 0x01, 0x0e, 0x00, 0x03, 0x01, 0x10, 0x01, 0x10, 0x00, 0x03,
+  0x01, 0x12, 0x01, 0x12, 0x00, 0x03, 0x01, 0x14, 0x01, 0x14, 0x00, 0x03,
+  0x01, 0x16, 0x01, 0x16, 0x00, 0x03, 0x01, 0x18, 0x01, 0x18, 0x00, 0x03,
+  0x01, 0x1a, 0x01, 0x1a, 0x00, 0x03, 0x01, 0x1c, 0x01, 0x1c, 0x00, 0x03,
+  0x01, 0x1e, 0x01, 0x1e, 0x00, 0x03, 0x01, 0x20, 0x01, 0x20, 0x00, 0x03,
+  0x01, 0x22, 0x01, 0x22, 0x00, 0x03, 0x01, 0x24, 0x01, 0x24, 0x00, 0x03,
+  0x01, 0x26, 0x01, 0x26, 0x00, 0x03, 0x01, 0x28, 0x01, 0x28, 0x00, 0x03,
+  0x01, 0x2a, 0x01, 0x2a, 0x00, 0x03, 0x01, 0x2c, 0x01, 0x2c, 0x00, 0x03,
+  0x01, 0x2e, 0x01, 0x2e, 0x00, 0x03, 0x01, 0x30, 0x01, 0x30, 0x00, 0x03,
+  0x01, 0x32, 0x01, 0x32, 0x00, 0x03, 0x01, 0x34, 0x01, 0x34, 0x00, 0x03,
+  0x01, 0x36, 0x01, 0x36, 0x00, 0x03, 0x01, 0x38, 0x01, 0x38, 0x00, 0x03,
+  0x01, 0x3a, 0x01, 0x3b, 0x00, 0x03, 0x01, 0x3d, 0x01, 0x3d, 0x00, 0x03,
+  0x01, 0x3f, 0x01, 0x3f, 0x00, 0x03, 0x01, 0x41, 0x01, 0x41, 0x00, 0x03,
+  0x01, 0x48, 0x01, 0x48, 0x00, 0x03, 0x01, 0x52, 0x01, 0x52, 0x00, 0x03,
+  0x01, 0x54, 0x01, 0x54, 0x00, 0x03, 0x01, 0x56, 0x01, 0x56, 0x00, 0x03,
+  0x01, 0x79, 0x01, 0x7a, 0x00, 0x03, 0x01, 0x8f, 0x01, 0x8f, 0x00, 0x03,
+  0x01, 0x91, 0x01, 0x93, 0x00, 0x03, 0x01, 0x95, 0x01, 0x95, 0x00, 0x03,
+  0x01, 0xa4, 0x01, 0xa4, 0x00, 0x03, 0x01, 0xac, 0x01, 0xac, 0x00, 0x03,
+  0x01, 0xae, 0x01, 0xae, 0x00, 0x03, 0x01, 0xda, 0x01, 0xda, 0x00, 0x03,
+  0x01, 0xdc, 0x01, 0xdc, 0x00, 0x03, 0x01, 0xf0, 0x01, 0xf0, 0x00, 0x03,
+  0x01, 0xf4, 0x01, 0xf4, 0x00, 0x03, 0x02, 0x0b, 0x02, 0x0b, 0x00, 0x01,
+  0x02, 0x2a, 0x02, 0x2a, 0x00, 0x01, 0x02, 0x5f, 0x02, 0x5f, 0x00, 0x01,
+  0x02, 0xb1, 0x02, 0xc5, 0x00, 0x02, 0x02, 0xc7, 0x02, 0xca, 0x00, 0x04,
+  0x02, 0xcd, 0x02, 0xe4, 0x00, 0x04, 0x02, 0xea, 0x02, 0xed, 0x00, 0x04,
+  0x02, 0xee, 0x02, 0xf5, 0x00, 0x02, 0x02, 0xf6, 0x02, 0xf6, 0x00, 0x04,
+  0x02, 0xf7, 0x02, 0xf7, 0x00, 0x02, 0x02, 0xf8, 0x02, 0xfa, 0x00, 0x04,
+  0x02, 0xfb, 0x02, 0xfd, 0x00, 0x02, 0x02, 0xfe, 0x02, 0xff, 0x00, 0x04,
+  0x03, 0x01, 0x03, 0x02, 0x00, 0x02, 0x03, 0x03, 0x03, 0x03, 0x00, 0x04,
+  0x03, 0x04, 0x03, 0x04, 0x00, 0x02, 0x03, 0x87, 0x03, 0x87, 0x00, 0x01,
+  0x03, 0xea, 0x03, 0xea, 0x00, 0x01, 0x03, 0xec, 0x03, 0xec, 0x00, 0x01,
+  0x04, 0x17, 0x04, 0x1a, 0x00, 0x02, 0x05, 0x7d, 0x05, 0x7d, 0x00, 0x01,
+  0x06, 0x1b, 0x06, 0x1b, 0x00, 0x01, 0x07, 0xe3, 0x07, 0xe6, 0x00, 0x02,
+  0x08, 0x31, 0x08, 0x32, 0x00, 0x01, 0x00, 0x03, 0x00, 0x08, 0x00, 0x16,
+  0x00, 0x26, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x04,
+  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x0f, 0x00, 0x03, 0x00, 0x08, 0x00, 0x16, 0x00, 0x26, 0x00, 0x01,
+  0x00, 0x03, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0e,
+  0x00, 0x02, 0x00, 0x04, 0x00, 0x03, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x0e, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x02,
+  0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24, 0x00, 0x03, 0x00, 0x00,
+  0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02,
+  0x00, 0x02, 0x02, 0xa7, 0x02, 0xa7, 0x00, 0x01, 0x02, 0xa8, 0x02, 0xab,
+  0x00, 0x02, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x10, 0x00, 0x01, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x10, 0x00, 0x02, 0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24,
+  0x00, 0x03, 0x00, 0x00, 0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01,
+  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x02, 0xa7, 0x00, 0x05, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x11,
+  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x11, 0x00, 0x02, 0x00, 0x12, 0x00, 0x1c,
+  0x00, 0x24, 0x00, 0x24, 0x00, 0x03, 0x00, 0x00, 0x00, 0x34, 0x00, 0x46,
+  0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x02, 0xa7, 0x00, 0x05,
+  0x00, 0x02, 0x00, 0x02, 0x00, 0x01, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x12, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x12, 0x00, 0x02,
+  0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24, 0x00, 0x03, 0x00, 0x00,
+  0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x02, 0xa7, 0x00, 0x05, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x02, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x13, 0x00, 0x01, 0x00, 0x04,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x13, 0x00, 0x02, 0x00, 0x12, 0x00, 0x1c, 0x00, 0x24, 0x00, 0x24,
+  0x00, 0x03, 0x00, 0x00, 0x00, 0x34, 0x00, 0x46, 0x00, 0x02, 0x00, 0x01,
+  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x02, 0xa7, 0x02, 0xaa, 0x00, 0x02,
+  0x02, 0xab, 0x02, 0xab, 0x00, 0x01, 0x00, 0x01, 0x00, 0x04, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x14,
+  0x00, 0x01, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x14, 0x00, 0x02, 0x00, 0x12, 0x00, 0x18,
+  0x00, 0x18, 0x00, 0x28, 0x00, 0x03, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x01, 0x02, 0xa7, 0x00, 0x02, 0x00, 0x02, 0x02, 0xa7,
+  0x02, 0xa7, 0x00, 0x01, 0x0e, 0xaa, 0x0e, 0xad, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
+  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
+  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x03,
+  0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xa8,
+  0x00, 0x02, 0x00, 0x03, 0x02, 0xa8, 0x02, 0xa8, 0x00, 0x01, 0x0e, 0xae,
+  0x0e, 0xae, 0x00, 0x02, 0x0e, 0xb0, 0x0e, 0xb2, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
+  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
+  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x03,
+  0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xa9,
+  0x00, 0x02, 0x00, 0x03, 0x02, 0xa9, 0x02, 0xa9, 0x00, 0x01, 0x0e, 0xb3,
+  0x0e, 0xb4, 0x00, 0x02, 0x0e, 0xb6, 0x0e, 0xb7, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
+  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
+  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x03,
+  0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xaa,
+  0x00, 0x02, 0x00, 0x03, 0x02, 0xaa, 0x02, 0xaa, 0x00, 0x01, 0x0e, 0xb8,
+  0x0e, 0xba, 0x00, 0x02, 0x0e, 0xbc, 0x0e, 0xbc, 0x00, 0x02, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04, 0x00, 0x01,
+  0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x15,
+  0x00, 0x02, 0x00, 0x12, 0x00, 0x18, 0x00, 0x18, 0x00, 0x28, 0x00, 0x03,
+  0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0xab,
+  0x00, 0x02, 0x00, 0x02, 0x02, 0xab, 0x02, 0xab, 0x00, 0x01, 0x0e, 0xbd,
+  0x0e, 0xc0, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x04, 0x00, 0x01, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x15, 0x00, 0x01, 0x00, 0x06, 0x0b, 0x43,
+  0x00, 0x01, 0x00, 0x01, 0x03, 0xc5, 0x00, 0x01, 0x00, 0x06, 0x10, 0x0f,
+  0x00, 0x01, 0x00, 0x01, 0x01, 0x0c, 0x00, 0x01, 0x00, 0x36, 0x00, 0x01,
+  0x00, 0x08, 0x00, 0x05, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x1c, 0x00, 0x22,
+  0x00, 0x28, 0x0f, 0x0d, 0x00, 0x03, 0x00, 0x49, 0x00, 0x4f, 0x0f, 0x0c,
+  0x00, 0x03, 0x00, 0x49, 0x00, 0x4c, 0x0f, 0x0b, 0x00, 0x02, 0x00, 0x4f,
+  0x0f, 0x0a, 0x00, 0x02, 0x00, 0x4c, 0x0f, 0x09, 0x00, 0x02, 0x00, 0x49,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x49, 0x00, 0x01, 0x00, 0x12, 0x00, 0x01,
+  0x00, 0x08, 0x00, 0x01, 0x00, 0x04, 0x0f, 0x0f, 0x00, 0x02, 0x00, 0x57,
+  0x00, 0x01, 0x00, 0x01, 0x00, 0x56, 0x00, 0x01, 0x00, 0x12, 0x00, 0x01,
+  0x00, 0x08, 0x00, 0x01, 0x00, 0x04, 0x0f, 0x0e, 0x00, 0x02, 0x00, 0x57,
+  0x00, 0x01, 0x00, 0x01, 0x01, 0x41, 0x00, 0x01, 0x00, 0x88, 0x00, 0x08,
+  0x00, 0x16, 0x00, 0x28, 0x00, 0x3a, 0x00, 0x46, 0x00, 0x50, 0x00, 0x5a,
+  0x00, 0x66, 0x00, 0x72, 0x00, 0x02, 0x00, 0x06, 0x00, 0x0c, 0x07, 0x7e,
+  0x00, 0x02, 0x00, 0x22, 0x07, 0x71, 0x00, 0x02, 0x00, 0x04, 0x00, 0x02,
+  0x00, 0x06, 0x00, 0x0c, 0x07, 0x7d, 0x00, 0x02, 0x00, 0x04, 0x07, 0x7c,
+  0x00, 0x02, 0x00, 0x22, 0x00, 0x01, 0x00, 0x04, 0x08, 0x24, 0x00, 0x03,
+  0x00, 0x24, 0x00, 0x3b, 0x00, 0x01, 0x00, 0x04, 0x07, 0xd2, 0x00, 0x02,
+  0x00, 0x56, 0x00, 0x01, 0x00, 0x04, 0x08, 0x09, 0x00, 0x02, 0x00, 0x30,
+  0x00, 0x01, 0x00, 0x04, 0x08, 0x0a, 0x00, 0x03, 0x00, 0x28, 0x00, 0x2f,
+  0x00, 0x01, 0x00, 0x04, 0x07, 0xea, 0x00, 0x03, 0x00, 0x12, 0x00, 0x46,
+  0x00, 0x02, 0x00, 0x06, 0x00, 0x0e, 0x07, 0xf0, 0x00, 0x03, 0x00, 0x12,
+  0x00, 0x58, 0x07, 0xef, 0x00, 0x03, 0x00, 0x12, 0x00, 0x52, 0x00, 0x01,
+  0x00, 0x08, 0x00, 0x04, 0x00, 0x22, 0x00, 0x29, 0x00, 0x35, 0x00, 0x36,
+  0x00, 0x37, 0x00, 0x44, 0x00, 0x46, 0x00, 0x02, 0x00, 0x14, 0x00, 0x07,
+  0x03, 0x67, 0x03, 0x66, 0x03, 0x68, 0x03, 0x64, 0x03, 0x65, 0x03, 0x6a,
+  0x03, 0x69, 0x00, 0x01, 0x00, 0x07, 0x03, 0x23, 0x03, 0x39, 0x03, 0x3f,
+  0x03, 0x46, 0x03, 0x4c, 0x03, 0x54, 0x03, 0x5a, 0x00, 0x02, 0x00, 0x14,
+  0x00, 0x07, 0x03, 0x67, 0x03, 0x66, 0x03, 0x68, 0x03, 0x64, 0x03, 0x65,
+  0x03, 0x6a, 0x03, 0x69, 0x00, 0x01, 0x00, 0x07, 0x03, 0x23, 0x03, 0x39,
+  0x03, 0x3f, 0x03, 0x46, 0x03, 0x4c, 0x03, 0x54, 0x03, 0x5a, 0x00, 0x02,
+  0x00, 0x10, 0x00, 0x05, 0x11, 0x48, 0x11, 0x34, 0x02, 0x13, 0x11, 0x3e,
+  0x11, 0x1b, 0x00, 0x01, 0x00, 0x05, 0x00, 0x2c, 0x00, 0x2d, 0x00, 0x44,
+  0x00, 0x4f, 0x01, 0x0c, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x06, 0x00, 0x12,
+  0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x26, 0x00, 0x01,
+  0x11, 0x48, 0x00, 0x01, 0x11, 0x34, 0x00, 0x01, 0x02, 0x13, 0x00, 0x01,
+  0x11, 0x3e, 0x00, 0x01, 0x11, 0xb8, 0x00, 0x01, 0x11, 0x1b, 0x00, 0x01,
+  0x00, 0x06, 0x00, 0x2c, 0x00, 0x2d, 0x00, 0x44, 0x00, 0x4f, 0x00, 0x5c,
+  0x01, 0x0c, 0x00, 0x02, 0x00, 0x1e, 0x00, 0x0c, 0x10, 0xee, 0x10, 0xec,
+  0x10, 0xef, 0x10, 0xed, 0x10, 0xf2, 0x10, 0xf3, 0x10, 0xeb, 0x11, 0xac,
+  0x10, 0xf4, 0x10, 0xf0, 0x10, 0xf5, 0x10, 0xf1, 0x00, 0x01, 0x00, 0x0c,
+  0x02, 0xb1, 0x02, 0xb2, 0x02, 0xb3, 0x02, 0xb4, 0x02, 0xb7, 0x02, 0xb8,
+  0x02, 0xb9, 0x02, 0xbb, 0x02, 0xbc, 0x02, 0xbd, 0x02, 0xc0, 0x02, 0xc2,
+  0x00, 0x02, 0x00, 0x20, 0x00, 0x0d, 0x00, 0xf3, 0x01, 0xf9, 0x11, 0x42,
+  0x02, 0x21, 0x11, 0x1c, 0x11, 0x1d, 0x01, 0xf9, 0x00, 0xf3, 0x01, 0xf9,
+  0x11, 0x45, 0x11, 0x46, 0x11, 0x43, 0x11, 0x44, 0x00, 0x01, 0x00, 0x0d,
+  0x00, 0x4c, 0x00, 0x4d, 0x00, 0xf1, 0x02, 0x0b, 0x02, 0x2a, 0x02, 0x5f,
+  0x03, 0x87, 0x03, 0xea, 0x03, 0xec, 0x05, 0x7d, 0x06, 0x1b, 0x08, 0x31,
+  0x08, 0x32, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x02, 0x00, 0x02, 0x00, 0x01,
+  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x07,
+  0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x06, 0x0c, 0x0c, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab,
+  0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x11, 0x00, 0x02, 0x00, 0x01,
+  0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x06, 0x0c, 0x16,
+  0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00, 0x00, 0x02,
+  0x00, 0x10, 0x00, 0x05, 0x0e, 0xc2, 0x0e, 0xc2, 0x0e, 0xc2, 0x0e, 0xc2,
+  0x0e, 0xc2, 0x00, 0x02, 0x00, 0x01, 0x02, 0xa7, 0x02, 0xab, 0x00, 0x00,
+  0x00, 0x01, 0x03, 0xa6, 0x01, 0x90, 0x00, 0x04, 0x00, 0x00, 0x05, 0x33,
+  0x05, 0x99, 0x00, 0x00, 0x01, 0x1e, 0x05, 0x33, 0x05, 0x99, 0x00, 0x00,
+  0x03, 0xd7, 0x00, 0x66, 0x02, 0x12, 0x00, 0x00, 0x02, 0x0b, 0x06, 0x06,
+  0x03, 0x08, 0x04, 0x02, 0x02, 0x04, 0xe0, 0x00, 0x02, 0xff, 0x52, 0x00,
+  0xfd, 0xff, 0x02, 0x24, 0x00, 0x21, 0x04, 0x00, 0x20, 0x00, 0x50, 0x66,
+  0x45, 0x64, 0x00, 0x40, 0x00, 0x20, 0xff, 0xff, 0x06, 0x14, 0xfe, 0x14,
+  0x01, 0x9a, 0x07, 0x6d, 0x01, 0xe3, 0x60, 0x00, 0x01, 0xff, 0xdf, 0xff,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x03,
+  0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x04, 0x8c,
+  0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x04, 0x00, 0x03, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x2c, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x04, 0x8c,
+  0x00, 0x04, 0x04, 0x60, 0x00, 0x00, 0x01, 0x14, 0x01, 0x00, 0x00, 0x07,
+  0x00, 0x14, 0x00, 0x00, 0x00, 0x7e, 0x02, 0xe9, 0x02, 0xee, 0x02, 0xf3,
+  0x02, 0xf7, 0x03, 0x4f, 0x03, 0x53, 0x03, 0x58, 0x03, 0x5a, 0x03, 0x62,
+  0x03, 0x77, 0x03, 0x7e, 0x03, 0x8a, 0x03, 0x8c, 0x03, 0xa1, 0x05, 0x25,
+  0x1d, 0x14, 0x1d, 0x23, 0x1d, 0x2e, 0x1d, 0x5b, 0x1d, 0x6a, 0x1d, 0x78,
+  0x1d, 0x7b, 0x1d, 0x7d, 0x1d, 0x85, 0x1d, 0xbf, 0x1d, 0xc9, 0x1e, 0xfb,
+  0x1f, 0x15, 0x1f, 0x1d, 0x1f, 0x45, 0x1f, 0x4d, 0x1f, 0x57, 0x1f, 0x59,
+  0x1f, 0x5b, 0x1f, 0x5d, 0x1f, 0x7d, 0x1f, 0xb4, 0x1f, 0xc4, 0x1f, 0xd3,
+  0x1f, 0xdb, 0x1f, 0xef, 0x1f, 0xf4, 0x1f, 0xfe, 0x20, 0x64, 0x20, 0x71,
+  0x20, 0x8e, 0x20, 0x9c, 0x20, 0xb5, 0x20, 0xba, 0x20, 0xd1, 0x20, 0xd7,
+  0x20, 0xdc, 0x20, 0xe1, 0x21, 0x09, 0x21, 0x49, 0x21, 0x4b, 0x21, 0x4e,
+  0x21, 0x85, 0x21, 0x89, 0x23, 0x11, 0x23, 0x19, 0x23, 0x21, 0x23, 0x28,
+  0x23, 0x2c, 0x23, 0x75, 0x23, 0x7a, 0x23, 0x7d, 0x23, 0x87, 0x23, 0x94,
+  0x23, 0xae, 0x23, 0xcf, 0x23, 0xe3, 0x23, 0xe5, 0x23, 0xe8, 0x24, 0x23,
+  0x24, 0x69, 0x26, 0x9c, 0x26, 0xb8, 0x26, 0xc3, 0x26, 0xe2, 0x27, 0x04,
+  0x27, 0x09, 0x27, 0x27, 0x27, 0x4b, 0x27, 0x4d, 0x27, 0x52, 0x27, 0x56,
+  0x27, 0x5e, 0x27, 0x94, 0x27, 0xaf, 0x27, 0xbe, 0x27, 0xc6, 0x27, 0xe0,
+  0x27, 0xeb, 0x28, 0xff, 0x29, 0x07, 0x29, 0x0b, 0x29, 0x41, 0x29, 0x84,
+  0x29, 0xd5, 0x29, 0xeb, 0x29, 0xfb, 0x2a, 0x02, 0x2a, 0x1c, 0x2a, 0x2f,
+  0x2a, 0x6b, 0x2a, 0xa0, 0x2a, 0xba, 0x2a, 0xfa, 0x2b, 0x1a, 0x2b, 0x24,
+  0x2b, 0x54, 0x2c, 0x77, 0x2c, 0x7f, 0xa7, 0x16, 0xa7, 0x1f, 0xa7, 0x2b,
+  0xa7, 0x41, 0xa7, 0x4b, 0xa7, 0x53, 0xa7, 0x57, 0xa7, 0x67, 0xa7, 0x83,
+  0xa7, 0x8e, 0xa7, 0x91, 0xa7, 0xaa, 0xa7, 0xff, 0xef, 0x19, 0xf0, 0x03,
+  0xf4, 0x26, 0xf4, 0x41, 0xf6, 0xc5, 0xfb, 0x06, 0xfe, 0x23, 0xff, 0xfd,
+  0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0xa0, 0x02, 0xec,
+  0x02, 0xf3, 0x02, 0xf7, 0x03, 0x00, 0x03, 0x51, 0x03, 0x57, 0x03, 0x5a,
+  0x03, 0x5c, 0x03, 0x70, 0x03, 0x7a, 0x03, 0x84, 0x03, 0x8c, 0x03, 0x8e,
+  0x03, 0xa3, 0x1d, 0x00, 0x1d, 0x16, 0x1d, 0x26, 0x1d, 0x30, 0x1d, 0x5d,
+  0x1d, 0x77, 0x1d, 0x7b, 0x1d, 0x7d, 0x1d, 0x85, 0x1d, 0x9b, 0x1d, 0xc4,
+  0x1e, 0x00, 0x1f, 0x00, 0x1f, 0x18, 0x1f, 0x20, 0x1f, 0x48, 0x1f, 0x50,
+  0x1f, 0x59, 0x1f, 0x5b, 0x1f, 0x5d, 0x1f, 0x5f, 0x1f, 0x80, 0x1f, 0xb6,
+  0x1f, 0xc6, 0x1f, 0xd6, 0x1f, 0xdd, 0x1f, 0xf2, 0x1f, 0xf6, 0x20, 0x00,
+  0x20, 0x6a, 0x20, 0x74, 0x20, 0x90, 0x20, 0xa0, 0x20, 0xb8, 0x20, 0xd0,
+  0x20, 0xd6, 0x20, 0xdb, 0x20, 0xe1, 0x21, 0x00, 0x21, 0x0b, 0x21, 0x4b,
+  0x21, 0x4e, 0x21, 0x50, 0x21, 0x89, 0x21, 0x90, 0x23, 0x18, 0x23, 0x1c,
+  0x23, 0x24, 0x23, 0x2b, 0x23, 0x73, 0x23, 0x7a, 0x23, 0x7d, 0x23, 0x87,
+  0x23, 0x94, 0x23, 0x9b, 0x23, 0xce, 0x23, 0xe3, 0x23, 0xe5, 0x23, 0xe8,
+  0x24, 0x22, 0x24, 0x60, 0x25, 0x00, 0x26, 0xa0, 0x26, 0xc0, 0x26, 0xe2,
+  0x27, 0x01, 0x27, 0x06, 0x27, 0x0c, 0x27, 0x29, 0x27, 0x4d, 0x27, 0x4f,
+  0x27, 0x56, 0x27, 0x58, 0x27, 0x61, 0x27, 0x98, 0x27, 0xb1, 0x27, 0xc5,
+  0x27, 0xe0, 0x27, 0xe6, 0x27, 0xf0, 0x29, 0x06, 0x29, 0x0a, 0x29, 0x40,
+  0x29, 0x83, 0x29, 0xce, 0x29, 0xeb, 0x29, 0xfa, 0x2a, 0x00, 0x2a, 0x0c,
+  0x2a, 0x2f, 0x2a, 0x6a, 0x2a, 0x7d, 0x2a, 0xae, 0x2a, 0xf9, 0x2b, 0x00,
+  0x2b, 0x1f, 0x2b, 0x53, 0x2c, 0x60, 0x2c, 0x79, 0xa7, 0x08, 0xa7, 0x1b,
+  0xa7, 0x22, 0xa7, 0x30, 0xa7, 0x46, 0xa7, 0x4e, 0xa7, 0x56, 0xa7, 0x64,
+  0xa7, 0x80, 0xa7, 0x89, 0xa7, 0x90, 0xa7, 0xa0, 0xa7, 0xfa, 0xef, 0x00,
+  0xf0, 0x00, 0xf4, 0x00, 0xf4, 0x28, 0xf6, 0xc5, 0xfb, 0x00, 0xfe, 0x20,
+  0xff, 0xf9, 0xff, 0xff, 0x00, 0x00, 0xff, 0xe3, 0xff, 0xc2, 0xff, 0xc0,
+  0xff, 0xbc, 0xff, 0xb9, 0xff, 0xb1, 0xff, 0xb0, 0xff, 0xad, 0xff, 0xac,
+  0xff, 0xab, 0xff, 0x9e, 0xff, 0x9c, 0xff, 0x97, 0xff, 0x96, 0xff, 0x95,
+  0xff, 0x94, 0xe7, 0xba, 0xe7, 0xb9, 0xe7, 0xb7, 0xe7, 0xb6, 0xe7, 0xb5,
+  0xe7, 0xa9, 0xe7, 0xa7, 0xe7, 0xa6, 0xe7, 0x9f, 0xe7, 0x8a, 0xe7, 0x86,
+  0xe7, 0x50, 0xe7, 0x4c, 0xe7, 0x4a, 0xe7, 0x48, 0xe7, 0x46, 0xe7, 0x44,
+  0xe7, 0x43, 0xe7, 0x42, 0xe7, 0x41, 0xe7, 0x40, 0xe7, 0x3e, 0xe7, 0x3d,
+  0xe7, 0x3c, 0xe7, 0x3a, 0xe7, 0x39, 0xe7, 0x37, 0xe7, 0x36, 0xe7, 0x35,
+  0xe7, 0x30, 0xe7, 0x2e, 0xe7, 0x2d, 0xe7, 0x2a, 0xe7, 0x28, 0xe7, 0x13,
+  0xe7, 0x0f, 0xe7, 0x0c, 0xe7, 0x08, 0xe6, 0xea, 0xe6, 0xe9, 0xe6, 0xe8,
+  0xe6, 0xe6, 0xe6, 0xe5, 0xe6, 0xe2, 0xe6, 0xdc, 0xe6, 0xd6, 0xe6, 0xd4,
+  0xe6, 0xd2, 0xe6, 0xd0, 0xe6, 0x8a, 0xe6, 0x86, 0xe6, 0x84, 0xe6, 0x7b,
+  0xe6, 0x6f, 0xe6, 0x69, 0xe6, 0x4a, 0xe6, 0x37, 0xe6, 0x36, 0xe6, 0x34,
+  0xe5, 0xfb, 0xe5, 0xbf, 0xe5, 0x29, 0xe5, 0x26, 0xe5, 0x1f, 0xe5, 0x01,
+  0xe4, 0xe3, 0xe4, 0xe2, 0xe4, 0xe0, 0xe4, 0xdf, 0xe4, 0xde, 0xe4, 0xdd,
+  0xe4, 0xda, 0xe4, 0xd9, 0xe4, 0xd7, 0xe4, 0xd4, 0xe4, 0xd3, 0xe4, 0xcd,
+  0xe4, 0xb4, 0xe4, 0xaf, 0xe4, 0xab, 0xe4, 0xa5, 0xe4, 0xa3, 0xe4, 0x6f,
+  0xe4, 0x2e, 0xe3, 0xe5, 0xe3, 0xd0, 0xe3, 0xc2, 0xe3, 0xbe, 0xe3, 0xb5,
+  0xe3, 0xa3, 0xe3, 0x69, 0xe3, 0x58, 0xe3, 0x4b, 0xe3, 0x0d, 0xe3, 0x08,
+  0xe3, 0x04, 0xe2, 0xd6, 0xe1, 0xcb, 0xe1, 0xca, 0x67, 0x42, 0x67, 0x3e,
+  0x67, 0x3c, 0x67, 0x38, 0x67, 0x34, 0x67, 0x32, 0x67, 0x30, 0x67, 0x24,
+  0x67, 0x0c, 0x67, 0x07, 0x67, 0x06, 0x66, 0xf8, 0x66, 0xa9, 0x1f, 0xa9,
+  0x1e, 0xc3, 0x1a, 0xc7, 0x1a, 0xc6, 0x18, 0x43, 0x14, 0x09, 0x10, 0xf0,
+  0x0f, 0x1b, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x07, 0x78,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x9e, 0x00, 0x00, 0x00, 0x20,
+  0x00, 0x00, 0x00, 0x7e, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xa0,
+  0x00, 0x00, 0x02, 0xe9, 0x00, 0x00, 0x00, 0x62, 0x00, 0x00, 0x02, 0xec,
+  0x00, 0x00, 0x02, 0xee, 0x00, 0x00, 0x02, 0xac, 0x00, 0x00, 0x02, 0xf3,
+  0x00, 0x00, 0x02, 0xf3, 0x00, 0x00, 0x02, 0xaf, 0x00, 0x00, 0x02, 0xf7,
+  0x00, 0x00, 0x02, 0xf7, 0x00, 0x00, 0x02, 0xb0, 0x00, 0x00, 0x03, 0x00,
+  0x00, 0x00, 0x03, 0x4f, 0x00, 0x00, 0x02, 0xb1, 0x00, 0x00, 0x03, 0x51,
+  0x00, 0x00, 0x03, 0x53, 0x00, 0x00, 0x03, 0x01, 0x00, 0x00, 0x03, 0x57,
+  0x00, 0x00, 0x03, 0x58, 0x00, 0x00, 0x03, 0x04, 0x00, 0x00, 0x03, 0x5a,
+  0x00, 0x00, 0x03, 0x5a, 0x00, 0x00, 0x03, 0x06, 0x00, 0x00, 0x03, 0x5c,
+  0x00, 0x00, 0x03, 0x62, 0x00, 0x00, 0x03, 0x07, 0x00, 0x00, 0x03, 0x70,
+  0x00, 0x00, 0x03, 0x77, 0x00, 0x00, 0x03, 0x0e, 0x00, 0x00, 0x03, 0x7a,
+  0x00, 0x00, 0x03, 0x7e, 0x00, 0x00, 0x03, 0x16, 0x00, 0x00, 0x03, 0x84,
+  0x00, 0x00, 0x03, 0x8a, 0x00, 0x00, 0x03, 0x1b, 0x00, 0x00, 0x03, 0x8c,
+  0x00, 0x00, 0x03, 0x8c, 0x00, 0x00, 0x03, 0x22, 0x00, 0x00, 0x03, 0x8e,
+  0x00, 0x00, 0x03, 0xa1, 0x00, 0x00, 0x03, 0x23, 0x00, 0x00, 0x03, 0xa3,
+  0x00, 0x00, 0x05, 0x25, 0x00, 0x00, 0x03, 0x37, 0x00, 0x00, 0x1d, 0x00,
+  0x00, 0x00, 0x1d, 0x14, 0x00, 0x00, 0x04, 0xba, 0x00, 0x00, 0x1d, 0x16,
+  0x00, 0x00, 0x1d, 0x23, 0x00, 0x00, 0x04, 0xcf, 0x00, 0x00, 0x1d, 0x26,
+  0x00, 0x00, 0x1d, 0x2e, 0x00, 0x00, 0x04, 0xdd, 0x00, 0x00, 0x1d, 0x30,
+  0x00, 0x00, 0x1d, 0x5b, 0x00, 0x00, 0x04, 0xe6, 0x00, 0x00, 0x1d, 0x5d,
+  0x00, 0x00, 0x1d, 0x6a, 0x00, 0x00, 0x05, 0x12, 0x00, 0x00, 0x1d, 0x77,
+  0x00, 0x00, 0x1d, 0x78, 0x00, 0x00, 0x05, 0x20, 0x00, 0x00, 0x1d, 0x7b,
+  0x00, 0x00, 0x1d, 0x7b, 0x00, 0x00, 0x05, 0x22, 0x00, 0x00, 0x1d, 0x7d,
+  0x00, 0x00, 0x1d, 0x7d, 0x00, 0x00, 0x05, 0x23, 0x00, 0x00, 0x1d, 0x85,
+  0x00, 0x00, 0x1d, 0x85, 0x00, 0x00, 0x05, 0x24, 0x00, 0x00, 0x1d, 0x9b,
+  0x00, 0x00, 0x1d, 0xbf, 0x00, 0x00, 0x05, 0x25, 0x00, 0x00, 0x1d, 0xc4,
+  0x00, 0x00, 0x1d, 0xc9, 0x00, 0x00, 0x05, 0x4a, 0x00, 0x00, 0x1e, 0x00,
+  0x00, 0x00, 0x1e, 0xfb, 0x00, 0x00, 0x05, 0x50, 0x00, 0x00, 0x1f, 0x00,
+  0x00, 0x00, 0x1f, 0x15, 0x00, 0x00, 0x06, 0x4c, 0x00, 0x00, 0x1f, 0x18,
+  0x00, 0x00, 0x1f, 0x1d, 0x00, 0x00, 0x06, 0x62, 0x00, 0x00, 0x1f, 0x20,
+  0x00, 0x00, 0x1f, 0x45, 0x00, 0x00, 0x06, 0x68, 0x00, 0x00, 0x1f, 0x48,
+  0x00, 0x00, 0x1f, 0x4d, 0x00, 0x00, 0x06, 0x8e, 0x00, 0x00, 0x1f, 0x50,
+  0x00, 0x00, 0x1f, 0x57, 0x00, 0x00, 0x06, 0x94, 0x00, 0x00, 0x1f, 0x59,
+  0x00, 0x00, 0x1f, 0x59, 0x00, 0x00, 0x06, 0x9c, 0x00, 0x00, 0x1f, 0x5b,
+  0x00, 0x00, 0x1f, 0x5b, 0x00, 0x00, 0x06, 0x9d, 0x00, 0x00, 0x1f, 0x5d,
+  0x00, 0x00, 0x1f, 0x5d, 0x00, 0x00, 0x06, 0x9e, 0x00, 0x00, 0x1f, 0x5f,
+  0x00, 0x00, 0x1f, 0x7d, 0x00, 0x00, 0x06, 0x9f, 0x00, 0x00, 0x1f, 0x80,
+  0x00, 0x00, 0x1f, 0xb4, 0x00, 0x00, 0x06, 0xbe, 0x00, 0x00, 0x1f, 0xb6,
+  0x00, 0x00, 0x1f, 0xc4, 0x00, 0x00, 0x06, 0xf3, 0x00, 0x00, 0x1f, 0xc6,
+  0x00, 0x00, 0x1f, 0xd3, 0x00, 0x00, 0x07, 0x02, 0x00, 0x00, 0x1f, 0xd6,
+  0x00, 0x00, 0x1f, 0xdb, 0x00, 0x00, 0x07, 0x10, 0x00, 0x00, 0x1f, 0xdd,
+  0x00, 0x00, 0x1f, 0xef, 0x00, 0x00, 0x07, 0x16, 0x00, 0x00, 0x1f, 0xf2,
+  0x00, 0x00, 0x1f, 0xf4, 0x00, 0x00, 0x07, 0x29, 0x00, 0x00, 0x1f, 0xf6,
+  0x00, 0x00, 0x1f, 0xfe, 0x00, 0x00, 0x07, 0x2c, 0x00, 0x00, 0x20, 0x00,
+  0x00, 0x00, 0x20, 0x64, 0x00, 0x00, 0x07, 0x35, 0x00, 0x00, 0x20, 0x6a,
+  0x00, 0x00, 0x20, 0x71, 0x00, 0x00, 0x07, 0x9a, 0x00, 0x00, 0x20, 0x74,
+  0x00, 0x00, 0x20, 0x8e, 0x00, 0x00, 0x07, 0xa2, 0x00, 0x00, 0x20, 0x90,
+  0x00, 0x00, 0x20, 0x9c, 0x00, 0x00, 0x07, 0xbd, 0x00, 0x00, 0x20, 0xa0,
+  0x00, 0x00, 0x20, 0xb5, 0x00, 0x00, 0x07, 0xca, 0x00, 0x00, 0x20, 0xb8,
+  0x00, 0x00, 0x20, 0xba, 0x00, 0x00, 0x07, 0xe0, 0x00, 0x00, 0x20, 0xd0,
+  0x00, 0x00, 0x20, 0xd1, 0x00, 0x00, 0x07, 0xe3, 0x00, 0x00, 0x20, 0xd6,
+  0x00, 0x00, 0x20, 0xd7, 0x00, 0x00, 0x07, 0xe5, 0x00, 0x00, 0x20, 0xdb,
+  0x00, 0x00, 0x20, 0xdc, 0x00, 0x00, 0x07, 0xe7, 0x00, 0x00, 0x20, 0xe1,
+  0x00, 0x00, 0x20, 0xe1, 0x00, 0x00, 0x07, 0xe9, 0x00, 0x00, 0x21, 0x00,
+  0x00, 0x00, 0x21, 0x09, 0x00, 0x00, 0x07, 0xea, 0x00, 0x00, 0x21, 0x0b,
+  0x00, 0x00, 0x21, 0x49, 0x00, 0x00, 0x07, 0xf4, 0x00, 0x00, 0x21, 0x4b,
+  0x00, 0x00, 0x21, 0x4b, 0x00, 0x00, 0x08, 0x33, 0x00, 0x00, 0x21, 0x4e,
+  0x00, 0x00, 0x21, 0x4e, 0x00, 0x00, 0x08, 0x34, 0x00, 0x00, 0x21, 0x50,
+  0x00, 0x00, 0x21, 0x85, 0x00, 0x00, 0x08, 0x35, 0x00, 0x00, 0x21, 0x89,
+  0x00, 0x00, 0x21, 0x89, 0x00, 0x00, 0x08, 0x6b, 0x00, 0x00, 0x21, 0x90,
+  0x00, 0x00, 0x23, 0x11, 0x00, 0x00, 0x08, 0x6c, 0x00, 0x00, 0x23, 0x18,
+  0x00, 0x00, 0x23, 0x19, 0x00, 0x00, 0x09, 0xee, 0x00, 0x00, 0x23, 0x1c,
+  0x00, 0x00, 0x23, 0x21, 0x00, 0x00, 0x09, 0xf0, 0x00, 0x00, 0x23, 0x24,
+  0x00, 0x00, 0x23, 0x28, 0x00, 0x00, 0x09, 0xf6, 0x00, 0x00, 0x23, 0x2b,
+  0x00, 0x00, 0x23, 0x2c, 0x00, 0x00, 0x09, 0xfb, 0x00, 0x00, 0x23, 0x73,
+  0x00, 0x00, 0x23, 0x75, 0x00, 0x00, 0x09, 0xfd, 0x00, 0x00, 0x23, 0x7a,
+  0x00, 0x00, 0x23, 0x7a, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x23, 0x7d,
+  0x00, 0x00, 0x23, 0x7d, 0x00, 0x00, 0x0a, 0x01, 0x00, 0x00, 0x23, 0x87,
+  0x00, 0x00, 0x23, 0x87, 0x00, 0x00, 0x0a, 0x02, 0x00, 0x00, 0x23, 0x94,
+  0x00, 0x00, 0x23, 0x94, 0x00, 0x00, 0x0a, 0x03, 0x00, 0x00, 0x23, 0x9b,
+  0x00, 0x00, 0x23, 0xae, 0x00, 0x00, 0x0a, 0x04, 0x00, 0x00, 0x23, 0xce,
+  0x00, 0x00, 0x23, 0xcf, 0x00, 0x00, 0x0a, 0x18, 0x00, 0x00, 0x23, 0xe3,
+  0x00, 0x00, 0x23, 0xe3, 0x00, 0x00, 0x0a, 0x1a, 0x00, 0x00, 0x23, 0xe5,
+  0x00, 0x00, 0x23, 0xe5, 0x00, 0x00, 0x0a, 0x1b, 0x00, 0x00, 0x23, 0xe8,
+  0x00, 0x00, 0x23, 0xe8, 0x00, 0x00, 0x0a, 0x1c, 0x00, 0x00, 0x24, 0x22,
+  0x00, 0x00, 0x24, 0x23, 0x00, 0x00, 0x0a, 0x1d, 0x00, 0x00, 0x24, 0x60,
+  0x00, 0x00, 0x24, 0x69, 0x00, 0x00, 0x0a, 0x1f, 0x00, 0x00, 0x25, 0x00,
+  0x00, 0x00, 0x26, 0x9c, 0x00, 0x00, 0x0a, 0x29, 0x00, 0x00, 0x26, 0xa0,
+  0x00, 0x00, 0x26, 0xb8, 0x00, 0x00, 0x0b, 0xc6, 0x00, 0x00, 0x26, 0xc0,
+  0x00, 0x00, 0x26, 0xc3, 0x00, 0x00, 0x0b, 0xdf, 0x00, 0x00, 0x26, 0xe2,
+  0x00, 0x00, 0x26, 0xe2, 0x00, 0x00, 0x0b, 0xe3, 0x00, 0x00, 0x27, 0x01,
+  0x00, 0x00, 0x27, 0x04, 0x00, 0x00, 0x0b, 0xe4, 0x00, 0x00, 0x27, 0x06,
+  0x00, 0x00, 0x27, 0x09, 0x00, 0x00, 0x0b, 0xe8, 0x00, 0x00, 0x27, 0x0c,
+  0x00, 0x00, 0x27, 0x27, 0x00, 0x00, 0x0b, 0xec, 0x00, 0x00, 0x27, 0x29,
+  0x00, 0x00, 0x27, 0x4b, 0x00, 0x00, 0x0c, 0x08, 0x00, 0x00, 0x27, 0x4d,
+  0x00, 0x00, 0x27, 0x4d, 0x00, 0x00, 0x0c, 0x2b, 0x00, 0x00, 0x27, 0x4f,
+  0x00, 0x00, 0x27, 0x52, 0x00, 0x00, 0x0c, 0x2c, 0x00, 0x00, 0x27, 0x56,
+  0x00, 0x00, 0x27, 0x56, 0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x27, 0x58,
+  0x00, 0x00, 0x27, 0x5e, 0x00, 0x00, 0x0c, 0x31, 0x00, 0x00, 0x27, 0x61,
+  0x00, 0x00, 0x27, 0x94, 0x00, 0x00, 0x0c, 0x38, 0x00, 0x00, 0x27, 0x98,
+  0x00, 0x00, 0x27, 0xaf, 0x00, 0x00, 0x0c, 0x6c, 0x00, 0x00, 0x27, 0xb1,
+  0x00, 0x00, 0x27, 0xbe, 0x00, 0x00, 0x0c, 0x84, 0x00, 0x00, 0x27, 0xc5,
+  0x00, 0x00, 0x27, 0xc6, 0x00, 0x00, 0x0c, 0x92, 0x00, 0x00, 0x27, 0xe0,
+  0x00, 0x00, 0x27, 0xe0, 0x00, 0x00, 0x0c, 0x94, 0x00, 0x00, 0x27, 0xe6,
+  0x00, 0x00, 0x27, 0xeb, 0x00, 0x00, 0x0c, 0x95, 0x00, 0x00, 0x27, 0xf0,
+  0x00, 0x00, 0x28, 0xff, 0x00, 0x00, 0x0c, 0x9b, 0x00, 0x00, 0x29, 0x06,
+  0x00, 0x00, 0x29, 0x07, 0x00, 0x00, 0x0d, 0xab, 0x00, 0x00, 0x29, 0x0a,
+  0x00, 0x00, 0x29, 0x0b, 0x00, 0x00, 0x0d, 0xad, 0x00, 0x00, 0x29, 0x40,
+  0x00, 0x00, 0x29, 0x41, 0x00, 0x00, 0x0d, 0xaf, 0x00, 0x00, 0x29, 0x83,
+  0x00, 0x00, 0x29, 0x84, 0x00, 0x00, 0x0d, 0xb1, 0x00, 0x00, 0x29, 0xce,
+  0x00, 0x00, 0x29, 0xd5, 0x00, 0x00, 0x0d, 0xb3, 0x00, 0x00, 0x29, 0xeb,
+  0x00, 0x00, 0x29, 0xeb, 0x00, 0x00, 0x0d, 0xbb, 0x00, 0x00, 0x29, 0xfa,
+  0x00, 0x00, 0x29, 0xfb, 0x00, 0x00, 0x0d, 0xbc, 0x00, 0x00, 0x2a, 0x00,
+  0x00, 0x00, 0x2a, 0x02, 0x00, 0x00, 0x0d, 0xbe, 0x00, 0x00, 0x2a, 0x0c,
+  0x00, 0x00, 0x2a, 0x1c, 0x00, 0x00, 0x0d, 0xc1, 0x00, 0x00, 0x2a, 0x2f,
+  0x00, 0x00, 0x2a, 0x2f, 0x00, 0x00, 0x0d, 0xd2, 0x00, 0x00, 0x2a, 0x6a,
+  0x00, 0x00, 0x2a, 0x6b, 0x00, 0x00, 0x0d, 0xd3, 0x00, 0x00, 0x2a, 0x7d,
+  0x00, 0x00, 0x2a, 0xa0, 0x00, 0x00, 0x0d, 0xd5, 0x00, 0x00, 0x2a, 0xae,
+  0x00, 0x00, 0x2a, 0xba, 0x00, 0x00, 0x0d, 0xf9, 0x00, 0x00, 0x2a, 0xf9,
+  0x00, 0x00, 0x2a, 0xfa, 0x00, 0x00, 0x0e, 0x06, 0x00, 0x00, 0x2b, 0x00,
+  0x00, 0x00, 0x2b, 0x1a, 0x00, 0x00, 0x0e, 0x08, 0x00, 0x00, 0x2b, 0x1f,
+  0x00, 0x00, 0x2b, 0x24, 0x00, 0x00, 0x0e, 0x23, 0x00, 0x00, 0x2b, 0x53,
+  0x00, 0x00, 0x2b, 0x54, 0x00, 0x00, 0x0e, 0x29, 0x00, 0x00, 0x2c, 0x60,
+  0x00, 0x00, 0x2c, 0x77, 0x00, 0x00, 0x0e, 0x2b, 0x00, 0x00, 0x2c, 0x79,
+  0x00, 0x00, 0x2c, 0x7f, 0x00, 0x00, 0x0e, 0x43, 0x00, 0x00, 0xa7, 0x08,
+  0x00, 0x00, 0xa7, 0x16, 0x00, 0x00, 0x0e, 0x4a, 0x00, 0x00, 0xa7, 0x1b,
+  0x00, 0x00, 0xa7, 0x1f, 0x00, 0x00, 0x0e, 0x59, 0x00, 0x00, 0xa7, 0x22,
+  0x00, 0x00, 0xa7, 0x2b, 0x00, 0x00, 0x0e, 0x5e, 0x00, 0x00, 0xa7, 0x30,
+  0x00, 0x00, 0xa7, 0x41, 0x00, 0x00, 0x0e, 0x68, 0x00, 0x00, 0xa7, 0x46,
+  0x00, 0x00, 0xa7, 0x4b, 0x00, 0x00, 0x0e, 0x7a, 0x00, 0x00, 0xa7, 0x4e,
+  0x00, 0x00, 0xa7, 0x53, 0x00, 0x00, 0x0e, 0x80, 0x00, 0x00, 0xa7, 0x56,
+  0x00, 0x00, 0xa7, 0x57, 0x00, 0x00, 0x0e, 0x86, 0x00, 0x00, 0xa7, 0x64,
+  0x00, 0x00, 0xa7, 0x67, 0x00, 0x00, 0x0e, 0x88, 0x00, 0x00, 0xa7, 0x80,
+  0x00, 0x00, 0xa7, 0x83, 0x00, 0x00, 0x0e, 0x8c, 0x00, 0x00, 0xa7, 0x89,
+  0x00, 0x00, 0xa7, 0x8e, 0x00, 0x00, 0x0e, 0x90, 0x00, 0x00, 0xa7, 0x90,
+  0x00, 0x00, 0xa7, 0x91, 0x00, 0x00, 0x0e, 0x96, 0x00, 0x00, 0xa7, 0xa0,
+  0x00, 0x00, 0xa7, 0xaa, 0x00, 0x00, 0x0e, 0x98, 0x00, 0x00, 0xa7, 0xfa,
+  0x00, 0x00, 0xa7, 0xff, 0x00, 0x00, 0x0e, 0xa3, 0x00, 0x00, 0xef, 0x00,
+  0x00, 0x00, 0xef, 0x19, 0x00, 0x00, 0x0e, 0xa9, 0x00, 0x00, 0xf0, 0x00,
+  0x00, 0x00, 0xf0, 0x03, 0x00, 0x00, 0x0e, 0xc3, 0x00, 0x00, 0xf4, 0x00,
+  0x00, 0x00, 0xf4, 0x26, 0x00, 0x00, 0x0e, 0xc7, 0x00, 0x00, 0xf4, 0x28,
+  0x00, 0x00, 0xf4, 0x41, 0x00, 0x00, 0x0e, 0xee, 0x00, 0x00, 0xf6, 0xc5,
+  0x00, 0x00, 0xf6, 0xc5, 0x00, 0x00, 0x0f, 0x08, 0x00, 0x00, 0xfb, 0x00,
+  0x00, 0x00, 0xfb, 0x06, 0x00, 0x00, 0x0f, 0x09, 0x00, 0x00, 0xfe, 0x20,
+  0x00, 0x00, 0xfe, 0x23, 0x00, 0x00, 0x0f, 0x10, 0x00, 0x00, 0xff, 0xf9,
+  0x00, 0x00, 0xff, 0xfd, 0x00, 0x00, 0x0f, 0x14, 0x00, 0x01, 0x03, 0x00,
+  0x00, 0x01, 0x03, 0x1e, 0x00, 0x00, 0x0f, 0x19, 0x00, 0x01, 0x03, 0x20,
+  0x00, 0x01, 0x03, 0x23, 0x00, 0x00, 0x0f, 0x38, 0x00, 0x01, 0xd3, 0x00,
+  0x00, 0x01, 0xd3, 0x56, 0x00, 0x00, 0x0f, 0x3c, 0x00, 0x01, 0xd5, 0x38,
+  0x00, 0x01, 0xd5, 0x39, 0x00, 0x00, 0x0f, 0x93, 0x00, 0x01, 0xd5, 0x3b,
+  0x00, 0x01, 0xd5, 0x3e, 0x00, 0x00, 0x0f, 0x95, 0x00, 0x01, 0xd5, 0x40,
+  0x00, 0x01, 0xd5, 0x44, 0x00, 0x00, 0x0f, 0x99, 0x00, 0x01, 0xd5, 0x46,
+  0x00, 0x01, 0xd5, 0x46, 0x00, 0x00, 0x0f, 0x9e, 0x00, 0x01, 0xd5, 0x4a,
+  0x00, 0x01, 0xd5, 0x50, 0x00, 0x00, 0x0f, 0x9f, 0x00, 0x01, 0xd5, 0x52,
+  0x00, 0x01, 0xd5, 0x6b, 0x00, 0x00, 0x0f, 0xa6, 0x00, 0x01, 0xd5, 0xa0,
+  0x00, 0x01, 0xd5, 0xd3, 0x00, 0x00, 0x0f, 0xc0, 0x00, 0x01, 0xd7, 0xd8,
+  0x00, 0x01, 0xd7, 0xeb, 0x00, 0x00, 0x0f, 0xf4, 0x00, 0x01, 0xf0, 0x30,
+  0x00, 0x01, 0xf0, 0x93, 0x00, 0x00, 0x10, 0x08, 0x00, 0x01, 0xf0, 0xa0,
+  0x00, 0x01, 0xf0, 0xae, 0x00, 0x00, 0x10, 0x6c, 0x00, 0x01, 0xf0, 0xb1,
+  0x00, 0x01, 0xf0, 0xbe, 0x00, 0x00, 0x10, 0x7b, 0x00, 0x01, 0xf0, 0xc1,
+  0x00, 0x01, 0xf0, 0xcf, 0x00, 0x00, 0x10, 0x89, 0x00, 0x01, 0xf0, 0xd1,
+  0x00, 0x01, 0xf0, 0xdf, 0x00, 0x00, 0x10, 0x98, 0x00, 0x01, 0xf4, 0x2d,
+  0x00, 0x01, 0xf4, 0x2e, 0x00, 0x00, 0x10, 0xa7, 0x00, 0x01, 0xf4, 0x31,
+  0x00, 0x01, 0xf4, 0x31, 0x00, 0x00, 0x10, 0xa9, 0x00, 0x01, 0xf4, 0x35,
+  0x00, 0x01, 0xf4, 0x35, 0x00, 0x00, 0x10, 0xaa, 0x00, 0x01, 0xf6, 0x00,
+  0x00, 0x01, 0xf6, 0x23, 0x00, 0x00, 0x10, 0xab, 0x00, 0x01, 0xf6, 0x25,
+  0x00, 0x01, 0xf6, 0x2b, 0x00, 0x00, 0x10, 0xcf, 0x00, 0x01, 0xf6, 0x2d,
+  0x00, 0x01, 0xf6, 0x40, 0x00, 0x00, 0x10, 0xd6, 0x00, 0x06, 0x02, 0x0a,
+  0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03,
+  0x00, 0x04, 0x00, 0x05, 0x00, 0x06, 0x00, 0x07, 0x00, 0x08, 0x00, 0x09,
+  0x00, 0x0a, 0x00, 0x0b, 0x00, 0x0c, 0x00, 0x0d, 0x00, 0x0e, 0x00, 0x0f,
+  0x00, 0x10, 0x00, 0x11, 0x00, 0x12, 0x00, 0x13, 0x00, 0x14, 0x00, 0x15,
+  0x00, 0x16, 0x00, 0x17, 0x00, 0x18, 0x00, 0x19, 0x00, 0x1a, 0x00, 0x1b,
+  0x00, 0x1c, 0x00, 0x1d, 0x00, 0x1e, 0x00, 0x1f, 0x00, 0x20, 0x00, 0x21,
+  0x00, 0x22, 0x00, 0x23, 0x00, 0x24, 0x00, 0x25, 0x00, 0x26, 0x00, 0x27,
+  0x00, 0x28, 0x00, 0x29, 0x00, 0x2a, 0x00, 0x2b, 0x00, 0x2c, 0x00, 0x2d,
+  0x00, 0x2e, 0x00, 0x2f, 0x00, 0x30, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33,
+  0x00, 0x34, 0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39,
+  0x00, 0x3a, 0x00, 0x3b, 0x00, 0x3c, 0x00, 0x3d, 0x00, 0x3e, 0x00, 0x3f,
+  0x00, 0x40, 0x00, 0x41, 0x00, 0x42, 0x00, 0x43, 0x00, 0x44, 0x00, 0x45,
+  0x00, 0x46, 0x00, 0x47, 0x00, 0x48, 0x00, 0x49, 0x00, 0x4a, 0x00, 0x4b,
+  0x00, 0x4c, 0x00, 0x4d, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x50, 0x00, 0x51,
+  0x00, 0x52, 0x00, 0x53, 0x00, 0x54, 0x00, 0x55, 0x00, 0x56, 0x00, 0x57,
+  0x00, 0x58, 0x00, 0x59, 0x00, 0x5a, 0x00, 0x5b, 0x00, 0x5c, 0x00, 0x5d,
+  0x00, 0x5e, 0x00, 0x5f, 0x00, 0x60, 0x00, 0x61, 0x00, 0x00, 0x00, 0x86,
+  0x00, 0x87, 0x00, 0x89, 0x00, 0x8b, 0x00, 0x93, 0x00, 0x98, 0x00, 0x9e,
+  0x00, 0xa3, 0x00, 0xa2, 0x00, 0xa4, 0x00, 0xa6, 0x00, 0xa5, 0x00, 0xa7,
+  0x00, 0xa9, 0x00, 0xab, 0x00, 0xaa, 0x00, 0xac, 0x00, 0xad, 0x00, 0xaf,
+  0x00, 0xae, 0x00, 0xb0, 0x00, 0xb1, 0x00, 0xb3, 0x00, 0xb5, 0x00, 0xb4,
+  0x00, 0xb6, 0x00, 0xb8, 0x00, 0xb7, 0x00, 0xbc, 0x00, 0xbb, 0x00, 0xbd,
+  0x00, 0xbe, 0x07, 0x55, 0x00, 0x72, 0x00, 0x64, 0x00, 0x65, 0x00, 0x69,
+  0x07, 0x57, 0x00, 0x78, 0x00, 0xa1, 0x00, 0x70, 0x00, 0x6b, 0x08, 0x0b,
+  0x00, 0x76, 0x00, 0x6a, 0x09, 0x3c, 0x00, 0x88, 0x00, 0x9a, 0x08, 0xfa,
+  0x00, 0x73, 0x09, 0x40, 0x09, 0x41, 0x00, 0x67, 0x00, 0x77, 0x08, 0xde,
+  0x08, 0xed, 0x08, 0xeb, 0x03, 0x54, 0x09, 0x07, 0x00, 0x6c, 0x00, 0x7c,
+  0x03, 0x3d, 0x00, 0xa8, 0x00, 0xba, 0x00, 0x81, 0x00, 0x63, 0x00, 0x6e,
+  0x08, 0xf6, 0x01, 0x54, 0x09, 0x24, 0x08, 0xe2, 0x00, 0x6d, 0x00, 0x7d,
+  0x07, 0x5b, 0x00, 0x62, 0x00, 0x82, 0x00, 0x85, 0x00, 0x97, 0x01, 0x14,
+  0x01, 0x15, 0x07, 0x48, 0x07, 0x49, 0x07, 0x51, 0x07, 0x52, 0x07, 0x4d,
+  0x07, 0x4e, 0x00, 0xb9, 0x0a, 0xf3, 0x00, 0xc1, 0x01, 0x3a, 0x07, 0x79,
+  0x07, 0xd6, 0x07, 0x6e, 0x07, 0x6f, 0x0f, 0x0a, 0x0f, 0x0b, 0x07, 0x56,
+  0x00, 0x79, 0x07, 0x4f, 0x07, 0x53, 0x07, 0x65, 0x00, 0x84, 0x00, 0x8c,
+  0x00, 0x83, 0x00, 0x8d, 0x00, 0x8a, 0x00, 0x8f, 0x00, 0x90, 0x00, 0x91,
+  0x00, 0x8e, 0x00, 0x95, 0x00, 0x96, 0x00, 0x00, 0x00, 0x94, 0x00, 0x9c,
+  0x00, 0x9d, 0x00, 0x9b, 0x00, 0xf3, 0x02, 0x88, 0x02, 0x9e, 0x00, 0x71,
+  0x02, 0x9a, 0x02, 0x9b, 0x02, 0x9c, 0x00, 0x7a, 0x02, 0x9f, 0x02, 0x9d,
+  0x02, 0x89, 0x00, 0x00, 0x01, 0x35, 0x00, 0xb8, 0x00, 0xcb, 0x00, 0xcb,
+  0x00, 0xc1, 0x00, 0xaa, 0x00, 0x9c, 0x01, 0xa6, 0x00, 0xb8, 0x00, 0x66,
+  0x00, 0x00, 0x00, 0x71, 0x00, 0xcb, 0x00, 0xa0, 0x02, 0xb2, 0x00, 0x85,
+  0x00, 0x75, 0x00, 0xb8, 0x00, 0xc3, 0x01, 0xcb, 0x01, 0x89, 0x02, 0x2d,
+  0x00, 0xcb, 0x00, 0xa6, 0x00, 0xf0, 0x00, 0xd3, 0x00, 0xaa, 0x00, 0x87,
+  0x00, 0xcb, 0x03, 0xaa, 0x04, 0x00, 0x01, 0x4a, 0x00, 0x33, 0x00, 0xcb,
+  0x00, 0x00, 0x00, 0xd9, 0x05, 0x02, 0x00, 0xf4, 0x01, 0x54, 0x00, 0xb4,
+  0x00, 0x9c, 0x01, 0x39, 0x01, 0x14, 0x01, 0x39, 0x07, 0x06, 0x04, 0x00,
+  0x04, 0x4e, 0x04, 0xb4, 0x04, 0x52, 0x04, 0xb8, 0x04, 0xe7, 0x04, 0xcd,
+  0x00, 0x37, 0x04, 0x73, 0x04, 0xcd, 0x04, 0x60, 0x04, 0x73, 0x01, 0x33,
+  0x03, 0xa2, 0x05, 0x56, 0x05, 0xa6, 0x05, 0x56, 0x05, 0x39, 0x03, 0xc5,
+  0x02, 0x12, 0x00, 0xc9, 0x00, 0x1f, 0x00, 0xb8, 0x01, 0xdf, 0x00, 0x73,
+  0x00, 0xba, 0x03, 0xe9, 0x03, 0x33, 0x03, 0xbc, 0x04, 0x44, 0x04, 0x0e,
+  0x00, 0xdf, 0x03, 0xcd, 0x03, 0xaa, 0x00, 0xe5, 0x03, 0xaa, 0x04, 0x04,
+  0x00, 0x00, 0x00, 0xcb, 0x00, 0x8f, 0x00, 0xa4, 0x00, 0x7b, 0x00, 0xb8,
+  0x00, 0x14, 0x01, 0x6f, 0x00, 0x7f, 0x02, 0x7b, 0x02, 0x52, 0x00, 0x8f,
+  0x00, 0xc7, 0x05, 0xcd, 0x00, 0x9a, 0x00, 0x9a, 0x00, 0x6f, 0x00, 0xcb,
+  0x00, 0xcd, 0x01, 0x9e, 0x01, 0xd3, 0x00, 0xf0, 0x00, 0xba, 0x01, 0x83,
+  0x00, 0xd5, 0x00, 0x98, 0x03, 0x04, 0x02, 0x48, 0x00, 0x9e, 0x01, 0xd5,
+  0x00, 0xc1, 0x00, 0xcb, 0x00, 0xf6, 0x00, 0x83, 0x03, 0x54, 0x02, 0x7f,
+  0x00, 0x00, 0x03, 0x33, 0x02, 0x66, 0x00, 0xd3, 0x00, 0xc7, 0x00, 0xa4,
+  0x00, 0xcd, 0x00, 0x8f, 0x00, 0x9a, 0x00, 0x73, 0x04, 0x00, 0x05, 0xd5,
+  0x01, 0x0a, 0x00, 0xfe, 0x02, 0x2b, 0x00, 0xa4, 0x00, 0xb4, 0x00, 0x9c,
+  0x00, 0x00, 0x00, 0x62, 0x00, 0x9c, 0x00, 0x00, 0x00, 0x1d, 0x03, 0x2d,
+  0x05, 0xd5, 0x05, 0xd5, 0x05, 0xd5, 0x05, 0xf0, 0x00, 0x7f, 0x00, 0x7b,
+  0x00, 0x54, 0x00, 0xa4, 0x06, 0xb8, 0x06, 0x14, 0x07, 0x23, 0x01, 0xd3,
+  0x00, 0xb8, 0x00, 0xcb, 0x00, 0xa6, 0x01, 0xc3, 0x01, 0xec, 0x06, 0x93,
+  0x00, 0xa0, 0x00, 0xd3, 0x03, 0x5c, 0x03, 0x71, 0x03, 0xdb, 0x01, 0x85,
+  0x04, 0x23, 0x04, 0xa8, 0x04, 0x48, 0x00, 0x8f, 0x01, 0x39, 0x01, 0x14,
+  0x01, 0x39, 0x03, 0x60, 0x00, 0x8f, 0x05, 0xd5, 0x01, 0x9a, 0x06, 0x14,
+  0x07, 0x23, 0x06, 0x66, 0x01, 0x79, 0x04, 0x60, 0x04, 0x60, 0x04, 0x60,
+  0x04, 0x7b, 0x00, 0x9c, 0x00, 0x00, 0x02, 0x77, 0x04, 0x60, 0x01, 0xaa,
+  0x00, 0xe9, 0x04, 0x60, 0x07, 0x62, 0x00, 0x7b, 0x00, 0xc5, 0x00, 0x7f,
+  0x02, 0x7b, 0x00, 0x00, 0x00, 0xb4, 0x02, 0x52, 0x05, 0xcd, 0x00, 0x66,
+  0x00, 0xbc, 0x00, 0x66, 0x00, 0x77, 0x06, 0x10, 0x00, 0xcd, 0x01, 0x3b,
+  0x01, 0x85, 0x03, 0x89, 0x00, 0x8f, 0x00, 0x7b, 0x00, 0x00, 0x00, 0x1d,
+  0x00, 0xcd, 0x07, 0x4a, 0x04, 0x2f, 0x00, 0x9c, 0x00, 0x9c, 0x00, 0x00,
+  0x07, 0x7d, 0x00, 0x6f, 0x00, 0x00, 0x00, 0x6f, 0x03, 0x35, 0x00, 0x6a,
+  0x00, 0x6f, 0x00, 0x7b, 0x00, 0xae, 0x00, 0xb2, 0x00, 0x2d, 0x03, 0x96,
+  0x00, 0x8f, 0x02, 0x7b, 0x00, 0xf6, 0x00, 0x83, 0x03, 0x54, 0x06, 0x37,
+  0x05, 0xf6, 0x00, 0x8f, 0x00, 0x9c, 0x04, 0xe1, 0x02, 0x66, 0x00, 0x8f,
+  0x01, 0x8d, 0x02, 0xf6, 0x00, 0xcd, 0x03, 0x44, 0x00, 0x29, 0x00, 0x66,
+  0x04, 0xee, 0x00, 0x73, 0x00, 0x00, 0x14, 0x00, 0x00, 0x96, 0x00, 0x00,
+  0xb7, 0x07, 0x06, 0x05, 0x04, 0x03, 0x02, 0x01, 0x00, 0x2c, 0x20, 0x10,
+  0xb0, 0x02, 0x25, 0x49, 0x64, 0xb0, 0x40, 0x51, 0x58, 0x20, 0xc8, 0x59,
+  0x21, 0x2d, 0x2c, 0xb0, 0x02, 0x25, 0x49, 0x64, 0xb0, 0x40, 0x51, 0x58,
+  0x20, 0xc8, 0x59, 0x21, 0x2d, 0x2c, 0x20, 0x10, 0x07, 0x20, 0xb0, 0x00,
+  0x50, 0xb0, 0x0d, 0x79, 0x20, 0xb8, 0xff, 0xff, 0x50, 0x58, 0x04, 0x1b,
+  0x05, 0x59, 0xb0, 0x05, 0x1c, 0xb0, 0x03, 0x25, 0x08, 0xb0, 0x04, 0x25,
+  0x23, 0xe1, 0x20, 0xb0, 0x00, 0x50, 0xb0, 0x0d, 0x79, 0x20, 0xb8, 0xff,
+  0xff, 0x50, 0x58, 0x04, 0x1b, 0x05, 0x59, 0xb0, 0x05, 0x1c, 0xb0, 0x03,
+  0x25, 0x08, 0xe1, 0x2d, 0x2c, 0x4b, 0x50, 0x58, 0x20, 0xb0, 0xfd, 0x45,
+  0x44, 0x59, 0x21, 0x2d, 0x2c, 0xb0, 0x02, 0x25, 0x45, 0x60, 0x44, 0x2d,
+  0x2c, 0x4b, 0x53, 0x58, 0xb0, 0x02, 0x25, 0xb0, 0x02, 0x25, 0x45, 0x44,
+  0x59, 0x21, 0x21, 0x2d, 0x2c, 0x45, 0x44, 0x2d, 0x2c, 0xb0, 0x02, 0x25,
+  0xb0, 0x02, 0x25, 0x49, 0xb0, 0x05, 0x25, 0xb0, 0x05, 0x25, 0x49, 0x60,
+  0xb0, 0x20, 0x63, 0x68, 0x20, 0x8a, 0x10, 0x8a, 0x23, 0x3a, 0x8a, 0x10,
+  0x65, 0x3a, 0x2d, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x08, 0x00, 0x02,
+  0xff, 0xff, 0x00, 0x03, 0x00, 0x02, 0x00, 0x5b, 0xfe, 0x96, 0x03, 0xf6,
+  0x05, 0xa4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x13, 0x11, 0x21, 0x11,
+  0x25, 0x21, 0x11, 0x21, 0x5c, 0x03, 0x99, 0xfc, 0xce, 0x02, 0xcc, 0xfd,
+  0x34, 0xfe, 0x96, 0x07, 0x0e, 0xf8, 0xf2, 0x72, 0x06, 0x29, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x16, 0x00, 0x00, 0x01, 0xcd, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x09, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23, 0x11, 0x33, 0x11, 0x03,
+  0x23, 0x03, 0x01, 0x16, 0xb7, 0xb7, 0xb7, 0x12, 0x92, 0x13, 0xfe, 0xfe,
+  0x05, 0xd5, 0xfd, 0x71, 0xfe, 0x9b, 0x01, 0x65, 0x00, 0x02, 0x00, 0xb1,
+  0x03, 0xaa, 0x02, 0x9f, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x01, 0x4a, 0x99, 0x01,
+  0xed, 0x98, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0xd5, 0x02, 0x2b,
+  0x00, 0x02, 0x00, 0x8e, 0x00, 0x00, 0x05, 0x7c, 0x05, 0xbe, 0x00, 0x03,
+  0x00, 0x1f, 0x00, 0x00, 0x01, 0x21, 0x03, 0x21, 0x0b, 0x01, 0x21, 0x13,
+  0x33, 0x03, 0x21, 0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x03, 0x23, 0x13,
+  0x21, 0x03, 0x23, 0x13, 0x21, 0x35, 0x21, 0x13, 0x21, 0x35, 0x21, 0x13,
+  0x03, 0xae, 0xfe, 0xfa, 0x4b, 0x01, 0x07, 0x3d, 0x5d, 0x01, 0x06, 0x5f,
+  0x90, 0x5d, 0x01, 0x19, 0xfe, 0xc4, 0x4a, 0x01, 0x1f, 0xfe, 0xbe, 0x5d,
+  0x90, 0x5c, 0xfe, 0xf9, 0x5d, 0x91, 0x5e, 0xfe, 0xe4, 0x01, 0x3d, 0x4c,
+  0xfe, 0xde, 0x01, 0x45, 0x5c, 0x03, 0x85, 0xfe, 0xb2, 0x03, 0x87, 0xfe,
+  0x61, 0x01, 0x9f, 0xfe, 0x61, 0x9a, 0xfe, 0xb2, 0x99, 0xfe, 0x62, 0x01,
+  0x9e, 0xfe, 0x62, 0x01, 0x9e, 0x99, 0x01, 0x4e, 0x9a, 0x01, 0x9f, 0x00,
+  0x00, 0x03, 0x00, 0x99, 0xfe, 0xd3, 0x03, 0xfc, 0x06, 0x14, 0x00, 0x21,
+  0x00, 0x28, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x23, 0x03, 0x2e, 0x01, 0x27,
+  0x35, 0x1e, 0x01, 0x17, 0x11, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x35,
+  0x33, 0x15, 0x1e, 0x01, 0x17, 0x15, 0x2e, 0x01, 0x27, 0x11, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x07, 0x03, 0x11, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17,
+  0x11, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x02, 0x6f, 0x5a, 0x01, 0x5f, 0xbd,
+  0x5f, 0x5c, 0xbc, 0x64, 0xc7, 0xb5, 0xc4, 0xb8, 0x5a, 0x53, 0x9d, 0x4b,
+  0x4b, 0x9d, 0x53, 0xcc, 0xc1, 0xcd, 0xc0, 0x5a, 0x69, 0x6d, 0x65, 0xcb,
+  0x72, 0x74, 0x6f, 0xfe, 0xd3, 0x01, 0x2d, 0x02, 0x2d, 0x2d, 0xb4, 0x40,
+  0x41, 0x01, 0x01, 0xc8, 0x24, 0xac, 0x96, 0xa3, 0xbc, 0x0e, 0xeb, 0xe8,
+  0x04, 0x1f, 0x1b, 0xaf, 0x2a, 0x2e, 0x04, 0xfe, 0x55, 0x23, 0xb4, 0x9c,
+  0xa9, 0xc3, 0x0f, 0x03, 0x00, 0x01, 0x9a, 0x0d, 0x6a, 0x58, 0x56, 0x60,
+  0xd5, 0xfe, 0x4f, 0x11, 0x6e, 0x5a, 0x58, 0x68, 0x00, 0x05, 0x00, 0x65,
+  0xff, 0xe3, 0x06, 0x72, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
+  0x00, 0x27, 0x00, 0x33, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x25, 0x33, 0x01, 0x23, 0x13, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x05, 0x3c,
+  0x4e, 0x59, 0x59, 0x4e, 0x4d, 0x59, 0x59, 0x4d, 0x8e, 0xa8, 0xa9, 0x8d,
+  0x90, 0xa7, 0xa8, 0xfc, 0xee, 0x4d, 0x59, 0x58, 0x4e, 0x4f, 0x59, 0x5a,
+  0x02, 0xdf, 0x90, 0xfc, 0xb7, 0x90, 0x1c, 0x8f, 0xa9, 0xa9, 0x8f, 0x8f,
+  0xa6, 0xa7, 0x02, 0x91, 0x94, 0x84, 0x82, 0x95, 0x95, 0x82, 0x83, 0x95,
+  0x7f, 0xdc, 0xbb, 0xbb, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x02, 0x61, 0x95,
+  0x82, 0x84, 0x94, 0x94, 0x84, 0x81, 0x96, 0x7f, 0xf9, 0xf3, 0x06, 0x0d,
+  0xdb, 0xbb, 0xbd, 0xda, 0xdb, 0xbc, 0xba, 0xdc, 0x00, 0x02, 0x00, 0x74,
+  0xff, 0xe3, 0x05, 0x65, 0x05, 0xf0, 0x00, 0x09, 0x00, 0x30, 0x00, 0x00,
+  0x01, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x09, 0x01,
+  0x3e, 0x01, 0x37, 0x33, 0x06, 0x02, 0x07, 0x13, 0x23, 0x27, 0x0e, 0x01,
+  0x23, 0x22, 0x00, 0x35, 0x34, 0x36, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x36,
+  0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x16, 0x01, 0xc0, 0x52, 0x4c, 0xbf, 0x90, 0x55, 0x96, 0x41, 0xfe, 0xa2,
+  0x01, 0xc9, 0x35, 0x3c, 0x05, 0xa8, 0x0b, 0x5e, 0x53, 0xfb, 0xe3, 0x81,
+  0x5d, 0xce, 0x76, 0xd8, 0xfe, 0xec, 0x79, 0x78, 0x2b, 0x2d, 0xc8, 0xa5,
+  0x4b, 0x95, 0x4c, 0x4e, 0x8e, 0x3e, 0x5e, 0x76, 0x35, 0x03, 0x23, 0x51,
+  0xa1, 0x58, 0x92, 0xc2, 0x3f, 0x40, 0x02, 0x8f, 0xfd, 0xf8, 0x59, 0xcb,
+  0x72, 0x84, 0xfe, 0xfe, 0x7e, 0xfe, 0xe3, 0x93, 0x59, 0x57, 0x01, 0x13,
+  0xd7, 0x80, 0xe1, 0x63, 0x3f, 0x7d, 0x3c, 0xa2, 0xc5, 0x24, 0x24, 0xb6,
+  0x2f, 0x31, 0x6f, 0x58, 0x33, 0x67, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb1,
+  0x03, 0xaa, 0x01, 0x4b, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x01, 0x4a, 0x99, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0x00,
+  0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x3c, 0x06, 0x12, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x23, 0x26, 0x02,
+  0x35, 0x34, 0x12, 0x37, 0x02, 0x3c, 0x79, 0x75, 0x76, 0x78, 0x90, 0x88,
+  0x86, 0x86, 0x88, 0x06, 0x12, 0xe6, 0xfe, 0x3e, 0xe7, 0xe7, 0xfe, 0x3b,
+  0xe5, 0xeb, 0x01, 0xc6, 0xe0, 0xdf, 0x01, 0xc4, 0xec, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x93, 0xfe, 0xf2, 0x02, 0x31, 0x06, 0x12, 0x00, 0x0d,
+  0x00, 0x00, 0x13, 0x33, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x23, 0x36,
+  0x12, 0x35, 0x34, 0x02, 0x94, 0x90, 0x87, 0x86, 0x86, 0x87, 0x90, 0x77,
+  0x76, 0x76, 0x06, 0x12, 0xec, 0xfe, 0x3c, 0xdf, 0xe0, 0xfe, 0x3a, 0xeb,
+  0xe5, 0x01, 0xc5, 0xe7, 0xe7, 0x01, 0xc2, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0x02, 0x4a, 0x03, 0x63, 0x05, 0xf0, 0x00, 0x11, 0x00, 0x00, 0x01, 0x0d,
+  0x01, 0x07, 0x25, 0x11, 0x23, 0x11, 0x05, 0x27, 0x2d, 0x01, 0x37, 0x05,
+  0x11, 0x33, 0x11, 0x25, 0x03, 0x63, 0xfe, 0xbd, 0x01, 0x43, 0x35, 0xfe,
+  0xd2, 0x66, 0xfe, 0xd1, 0x34, 0x01, 0x43, 0xfe, 0xbd, 0x34, 0x01, 0x2f,
+  0x66, 0x01, 0x2e, 0x04, 0xdf, 0xc2, 0xc3, 0x62, 0xcb, 0xfe, 0x87, 0x01,
+  0x79, 0xcb, 0x62, 0xc3, 0xc2, 0x63, 0xcb, 0x01, 0x79, 0xfe, 0x87, 0xcb,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x03, 0x50, 0x01, 0xf5, 0xfe, 0x0b, 0x97, 0xfe, 0x0a, 0x01,
+  0xf6, 0x05, 0x04, 0xfd, 0xd3, 0xaa, 0xfd, 0xd3, 0x02, 0x2d, 0xaa, 0x02,
+  0x2d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8e, 0xff, 0x12, 0x01, 0x96,
+  0x00, 0xfe, 0x00, 0x05, 0x00, 0x00, 0x37, 0x33, 0x15, 0x03, 0x23, 0x13,
+  0xd8, 0xbe, 0x94, 0x74, 0x4a, 0xfe, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40, 0x02, 0x83, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x01, 0xe5, 0xfe, 0x1b, 0x02,
+  0x83, 0xa4, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc5, 0x00, 0x00, 0x01, 0x83,
+  0x00, 0xfe, 0x00, 0x03, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23, 0xc5, 0xbe,
+  0xbe, 0xfe, 0xfe, 0x00, 0x00, 0x01, 0x00, 0x00, 0xff, 0x42, 0x02, 0x6d,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x01, 0xd4,
+  0x99, 0xfe, 0x2c, 0x99, 0x05, 0xd5, 0xf9, 0x6d, 0x00, 0x02, 0x00, 0x79,
+  0xff, 0xe3, 0x04, 0x1b, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02,
+  0x27, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
+  0x02, 0x4a, 0x8c, 0x8e, 0x8e, 0x8c, 0x8d, 0x8d, 0x8d, 0x8d, 0xe2, 0xee,
+  0xee, 0xe2, 0xe2, 0xee, 0xee, 0x05, 0x50, 0xfe, 0xcd, 0xfe, 0xcc, 0xfe,
+  0xcd, 0xfe, 0xcd, 0x01, 0x33, 0x01, 0x33, 0x01, 0x34, 0x01, 0x33, 0xa0,
+  0xfe, 0x73, 0xfe, 0x86, 0xfe, 0x87, 0xfe, 0x73, 0x01, 0x8d, 0x01, 0x79,
+  0x01, 0x7a, 0x01, 0x8d, 0x00, 0x01, 0x00, 0xca, 0x00, 0x00, 0x03, 0xeb,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x00, 0x37, 0x21, 0x11, 0x05, 0x35, 0x25,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0xe5, 0x01, 0x29, 0xfe, 0xbc, 0x01, 0x42,
+  0xb6, 0x01, 0x29, 0xfc, 0xfa, 0xaa, 0x04, 0x73, 0x48, 0xb8, 0x48, 0xfa,
+  0xd5, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0xdd,
+  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x00, 0x25, 0x21, 0x15, 0x21, 0x35, 0x36,
+  0x00, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
+  0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x02, 0x01,
+  0x62, 0x02, 0x7a, 0xfc, 0xab, 0x67, 0x01, 0x66, 0x2e, 0x57, 0x45, 0x96,
+  0x79, 0x55, 0xbe, 0x6c, 0x6e, 0xbf, 0x4f, 0xd1, 0xf8, 0x3e, 0x52, 0x17,
+  0xf1, 0xaa, 0xaa, 0xaa, 0x77, 0x01, 0x91, 0x3a, 0x6d, 0x97, 0x49, 0x77,
+  0x96, 0x42, 0x43, 0xcc, 0x31, 0x32, 0xe8, 0xc2, 0x5c, 0xa5, 0x70, 0x1d,
+  0xfe, 0xeb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8c, 0xff, 0xe3, 0x04, 0x02,
+  0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x04,
+  0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x02,
+  0xec, 0x82, 0x93, 0xfe, 0xef, 0xfc, 0x55, 0xb3, 0x60, 0x4c, 0xb4, 0x62,
+  0xab, 0xb3, 0xa6, 0x95, 0x9c, 0xa3, 0x86, 0x8f, 0x93, 0x89, 0x4b, 0xaa,
+  0x67, 0x67, 0xb5, 0x50, 0xcf, 0xf2, 0x80, 0x03, 0x25, 0x1f, 0xc4, 0x90,
+  0xdd, 0xf2, 0x25, 0x25, 0xc3, 0x31, 0x32, 0x96, 0x8f, 0x84, 0x95, 0xa6,
+  0x77, 0x70, 0x73, 0x7b, 0x24, 0x26, 0xb4, 0x20, 0x20, 0xd1, 0xb2, 0x7c,
+  0xab, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x04, 0x2e,
+  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x21, 0x03,
+  0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x21, 0x35, 0x02, 0xb9,
+  0xfe, 0x35, 0x01, 0xcb, 0x30, 0xe5, 0xbf, 0xbf, 0xb5, 0xfd, 0xa1, 0x05,
+  0x25, 0xfc, 0xe3, 0x03, 0xcd, 0xfc, 0x33, 0xa8, 0xfe, 0xa0, 0x01, 0x60,
+  0xc3, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8e, 0xff, 0xe3, 0x03, 0xf4,
+  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x3e,
+  0x01, 0x33, 0x32, 0x00, 0x15, 0x14, 0x00, 0x23, 0x22, 0x26, 0x27, 0x35,
+  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0xc7, 0x02, 0xca, 0xfd, 0xdc, 0x28, 0x4f, 0x28, 0xe1, 0x01, 0x07, 0xfe,
+  0xf2, 0xf6, 0x55, 0xaf, 0x5e, 0x51, 0xad, 0x60, 0x9c, 0xb6, 0xb6, 0x9c,
+  0x49, 0x91, 0x4b, 0x05, 0xd5, 0xaa, 0xfe, 0x92, 0x0f, 0x0f, 0xfe, 0xee,
+  0xea, 0xf1, 0xfe, 0xf5, 0x20, 0x20, 0xcb, 0x31, 0x30, 0xb6, 0x9c, 0x9c,
+  0xb6, 0x24, 0x26, 0x00, 0x00, 0x02, 0x00, 0x80, 0xff, 0xe3, 0x04, 0x21,
+  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01,
+  0x23, 0x22, 0x02, 0x03, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x15, 0x14, 0x02,
+  0x23, 0x22, 0x02, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x02, 0x60, 0x7a,
+  0x8f, 0x8f, 0x7a, 0x7b, 0x8f, 0x8f, 0xee, 0x44, 0x8c, 0x44, 0xb4, 0xbe,
+  0x0d, 0x35, 0xa0, 0x60, 0xcb, 0xeb, 0xf5, 0xcc, 0xe9, 0xf6, 0x01, 0x2e,
+  0x00, 0xff, 0x44, 0x8c, 0x03, 0x3b, 0xba, 0xa2, 0xa1, 0xbb, 0xbb, 0xa1,
+  0xa2, 0xba, 0x02, 0x79, 0xb8, 0x24, 0x26, 0xfe, 0xf2, 0xfe, 0xef, 0x57,
+  0x5d, 0xfe, 0xef, 0xeb, 0xe6, 0xfe, 0xea, 0x01, 0x8d, 0x01, 0x79, 0x01,
+  0x62, 0x01, 0xa5, 0x1e, 0x00, 0x01, 0x00, 0x97, 0x00, 0x00, 0x03, 0xf8,
+  0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x23, 0x01,
+  0x21, 0x97, 0x03, 0x60, 0xfe, 0x18, 0xbd, 0x01, 0xca, 0xfd, 0x7b, 0x05,
+  0xd5, 0x56, 0xfa, 0x81, 0x05, 0x2b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x7d,
+  0xff, 0xe3, 0x04, 0x17, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x23, 0x00, 0x2f,
+  0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x25, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x13, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x02, 0x4a, 0x82, 0x94, 0x94, 0x82, 0x82, 0x95, 0x95, 0xfe,
+  0xc8, 0x75, 0x82, 0xe5, 0xc8, 0xc9, 0xe4, 0x82, 0x74, 0x83, 0x93, 0xef,
+  0xde, 0xde, 0xef, 0x94, 0x41, 0x82, 0x76, 0x75, 0x84, 0x84, 0x75, 0x76,
+  0x82, 0x02, 0xc5, 0x9a, 0x87, 0x87, 0x9a, 0x9b, 0x86, 0x87, 0x9a, 0x56,
+  0x20, 0xb2, 0x80, 0xb3, 0xd0, 0xd0, 0xb3, 0x80, 0xb2, 0x20, 0x22, 0xc6,
+  0x8f, 0xd9, 0xe8, 0xe8, 0xd9, 0x8f, 0xc6, 0x01, 0x61, 0x74, 0x82, 0x82,
+  0x74, 0x74, 0x82, 0x82, 0x00, 0x02, 0x00, 0x74, 0xff, 0xe3, 0x04, 0x14,
+  0x05, 0xf0, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00, 0x37, 0x35, 0x1e, 0x01,
+  0x33, 0x32, 0x12, 0x13, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x35, 0x34, 0x12,
+  0x33, 0x32, 0x12, 0x11, 0x10, 0x00, 0x23, 0x22, 0x26, 0x01, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0xca, 0x45, 0x8c,
+  0x44, 0xb4, 0xbe, 0x0d, 0x34, 0xa0, 0x61, 0xca, 0xeb, 0xf5, 0xcb, 0xe9,
+  0xf6, 0xfe, 0xd3, 0xff, 0x45, 0x8c, 0x01, 0x1e, 0x7b, 0x8f, 0x8f, 0x7b,
+  0x7a, 0x8f, 0x8f, 0x1f, 0xb8, 0x24, 0x26, 0x01, 0x0d, 0x01, 0x12, 0x56,
+  0x5c, 0x01, 0x0f, 0xeb, 0xe6, 0x01, 0x16, 0xfe, 0x73, 0xfe, 0x86, 0xfe,
+  0x9f, 0xfe, 0x5b, 0x1e, 0x02, 0x97, 0xba, 0xa2, 0xa1, 0xbb, 0xbb, 0xa1,
+  0xa2, 0xba, 0x00, 0x00, 0x00, 0x02, 0x00, 0xd8, 0x00, 0x00, 0x01, 0x96,
+  0x04, 0x23, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23,
+  0x11, 0x33, 0x15, 0x23, 0xd8, 0xbe, 0xbe, 0xbe, 0xbe, 0xfe, 0xfe, 0x04,
+  0x23, 0xfe, 0x00, 0x00, 0x00, 0x02, 0x00, 0x8e, 0xff, 0x12, 0x01, 0x96,
+  0x04, 0x23, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23,
+  0x11, 0x33, 0x15, 0x03, 0x23, 0x13, 0xd8, 0xbe, 0xbe, 0xbe, 0x94, 0x74,
+  0x4a, 0x04, 0x23, 0xfe, 0xfd, 0xd9, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x5e, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x06,
+  0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45, 0xfc, 0x5f,
+  0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82, 0x03, 0xf0, 0xfe, 0x91, 0xfe, 0x93,
+  0xb6, 0x01, 0xd1, 0xa6, 0x01, 0xd1, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x01, 0x60, 0x05, 0x46, 0x03, 0xa2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfb,
+  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x5e, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x06,
+  0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0xc3, 0x04, 0x82,
+  0xfb, 0x7e, 0x03, 0x9f, 0x03, 0xf0, 0xb6, 0xfe, 0x2f, 0xa6, 0xfe, 0x2f,
+  0xb6, 0x01, 0x6d, 0x00, 0x00, 0x02, 0x00, 0x84, 0x00, 0x00, 0x03, 0x52,
+  0x05, 0xf0, 0x00, 0x03, 0x00, 0x24, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23,
+  0x13, 0x23, 0x35, 0x34, 0x36, 0x3f, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x0f, 0x01, 0x0e, 0x01, 0x07, 0x0e, 0x01, 0x15, 0x01, 0x60, 0xb7,
+  0xb7, 0xb1, 0xac, 0x33, 0x51, 0x51, 0x33, 0x2e, 0x76, 0x61, 0x47, 0xa1,
+  0x58, 0x55, 0xae, 0x5c, 0xa6, 0xc9, 0x41, 0x51, 0x4f, 0x2b, 0x23, 0x07,
+  0x05, 0x06, 0xfe, 0xfe, 0x01, 0x91, 0x9a, 0x65, 0x82, 0x56, 0x59, 0x35,
+  0x5e, 0x31, 0x59, 0x6e, 0x46, 0x43, 0xbc, 0x39, 0x38, 0xc2, 0x9f, 0x4c,
+  0x89, 0x56, 0x56, 0x2f, 0x35, 0x19, 0x15, 0x3c, 0x34, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x79, 0xfe, 0x9c, 0x06, 0xb3, 0x05, 0xa2, 0x00, 0x0b,
+  0x00, 0x4c, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x27, 0x26, 0x24, 0x23, 0x22, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14,
+  0x12, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x17, 0x06, 0x04, 0x23,
+  0x22, 0x24, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x24, 0x33,
+  0x32, 0x04, 0x17, 0x1e, 0x01, 0x15, 0x10, 0x00, 0x07, 0x02, 0xae, 0x80,
+  0x6f, 0x6f, 0x7f, 0x82, 0x6e, 0x6d, 0x80, 0x01, 0xea, 0x36, 0x8b, 0x5d,
+  0x9b, 0xc1, 0xc2, 0x9a, 0x5d, 0x8c, 0x35, 0x81, 0x83, 0x95, 0x39, 0x39,
+  0x5e, 0xfe, 0xf3, 0x9e, 0x6f, 0xcc, 0x56, 0x8d, 0xa0, 0x68, 0x62, 0x5e,
+  0xf9, 0x8d, 0x74, 0xe0, 0x5e, 0x51, 0x71, 0xfe, 0xf7, 0x89, 0xa6, 0xfe,
+  0xd8, 0x73, 0x73, 0x78, 0x7a, 0x71, 0x74, 0x01, 0x31, 0xaa, 0xbe, 0x01,
+  0x47, 0x6f, 0x43, 0x47, 0xfe, 0xe2, 0xfc, 0x02, 0x19, 0x8f, 0xa3, 0xa4,
+  0x8e, 0x8c, 0xa5, 0xa4, 0xfe, 0x48, 0x4d, 0x49, 0xf9, 0xc8, 0xc8, 0xfa,
+  0x4b, 0x4c, 0x83, 0xfd, 0x20, 0x16, 0xdf, 0xb1, 0x6b, 0xbc, 0x50, 0x83,
+  0x8b, 0x41, 0x40, 0x66, 0xfe, 0xb5, 0xc1, 0x9f, 0xfe, 0xea, 0x6a, 0x68,
+  0x6d, 0x57, 0x51, 0x6f, 0x61, 0x67, 0x83, 0x7d, 0x7d, 0x01, 0x49, 0xbd,
+  0xb6, 0x01, 0x4a, 0x7d, 0x7f, 0x87, 0xae, 0xa0, 0x62, 0xe6, 0x7b, 0xfe,
+  0xf9, 0xfe, 0xd0, 0x06, 0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00, 0x01, 0x03, 0x21, 0x01,
+  0x33, 0x01, 0x23, 0x03, 0x21, 0x03, 0x23, 0x02, 0x76, 0xf7, 0x01, 0xef,
+  0xfe, 0xa1, 0xcf, 0x02, 0x00, 0xbd, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0, 0x05,
+  0x0e, 0xfd, 0x19, 0x03, 0xae, 0xfa, 0x2b, 0x01, 0x7f, 0xfe, 0x81, 0x00,
+  0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x11, 0x00, 0x20, 0x00, 0x00, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14,
+  0x06, 0x23, 0x21, 0x01, 0x6b, 0x01, 0x23, 0x93, 0x8d, 0x8d, 0x93, 0xfe,
+  0xdd, 0x01, 0x0d, 0x85, 0x83, 0x83, 0x85, 0xfe, 0x3d, 0x01, 0xd0, 0xd0,
+  0xe1, 0x73, 0x70, 0x87, 0x94, 0xf5, 0xe2, 0xfe, 0x1e, 0x02, 0xc9, 0xfd,
+  0xdd, 0x87, 0x8b, 0x8c, 0x85, 0x02, 0x66, 0xfe, 0x3e, 0x6f, 0x72, 0x71,
+  0x70, 0xa6, 0xc0, 0xb1, 0x89, 0xa2, 0x14, 0x20, 0xcb, 0x98, 0xc8, 0xda,
+  0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
+  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x32, 0x16, 0x04, 0xa3, 0x5c, 0xd0, 0x75, 0xe6, 0xf5, 0xf5,
+  0xe6, 0x75, 0xd0, 0x5c, 0x5f, 0xd6, 0x76, 0xfe, 0xce, 0xfe, 0xa2, 0x01,
+  0x5e, 0x01, 0x32, 0x78, 0xd6, 0x05, 0x62, 0xd5, 0x5f, 0x5e, 0xfe, 0xc7,
+  0xfe, 0xd8, 0xfe, 0xd9, 0xfe, 0xc7, 0x5e, 0x5f, 0xd3, 0x48, 0x48, 0x01,
+  0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f, 0x47, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x11, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x25, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x01, 0x6b, 0xdb, 0x01, 0x16, 0x01,
+  0x03, 0xfe, 0xfd, 0xfe, 0xea, 0xfe, 0x6f, 0x01, 0x75, 0x01, 0x87, 0x01,
+  0x6d, 0xfe, 0x91, 0xfe, 0x7b, 0xfe, 0x8b, 0x05, 0x2f, 0xfb, 0x77, 0x01,
+  0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17, 0xa6, 0xfe, 0x97, 0xfe, 0x80,
+  0xfe, 0x7e, 0xfe, 0x96, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0xb5, 0x03, 0x51, 0xfd, 0x65, 0x02,
+  0x80, 0xfd, 0x80, 0x02, 0xac, 0xfc, 0x9e, 0x05, 0xd5, 0xaa, 0xfe, 0x46,
+  0xaa, 0xfd, 0xe3, 0xaa, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xba,
+  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x11, 0x23, 0xb5, 0x03, 0x04, 0xfd, 0xb2, 0x02, 0x15, 0xfd,
+  0xeb, 0xb6, 0x05, 0xd5, 0xaa, 0xfe, 0x48, 0xaa, 0xfd, 0x37, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe, 0x05, 0xf0, 0x00, 0x1d,
+  0x00, 0x00, 0x25, 0x11, 0x21, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23,
+  0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36, 0x04, 0x49, 0xfe, 0xd7,
+  0x01, 0xdd, 0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01,
+  0x3b, 0x83, 0xed, 0x64, 0x65, 0xe3, 0x7d, 0xf6, 0xf8, 0xf8, 0xf6, 0x61,
+  0x97, 0xd5, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53, 0x55, 0x01, 0x99, 0x01,
+  0x6d, 0x01, 0x6e, 0x01, 0x99, 0x48, 0x46, 0xd7, 0x5f, 0x60, 0xfe, 0xce,
+  0xfe, 0xd1, 0xfe, 0xd2, 0xfe, 0xce, 0x25, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6,
+  0x02, 0x94, 0xb6, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02,
+  0x64, 0xfa, 0x2b, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x01, 0x6b, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x23, 0xb5, 0xb6, 0xb6, 0x05, 0xd5, 0xfa, 0x2b, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xa0, 0xfe, 0x66, 0x01, 0x6b, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x36, 0x35, 0xb5, 0xb6, 0xb9, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x05, 0xd5,
+  0xfa, 0x93, 0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5, 0xb6, 0x02,
+  0x5b, 0xea, 0xfd, 0x65, 0x02, 0xca, 0xef, 0xfd, 0x7b, 0xb6, 0x05, 0xd5,
+  0xfd, 0x89, 0x02, 0x77, 0xfd, 0x48, 0xfc, 0xe3, 0x02, 0xcf, 0xfd, 0x31,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x21, 0xb5, 0xb6, 0x02, 0x8e,
+  0xfc, 0xbc, 0x05, 0xd5, 0xfa, 0xd5, 0xaa, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x21,
+  0x09, 0x01, 0x21, 0x11, 0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5,
+  0x01, 0x0f, 0x01, 0x57, 0x01, 0x58, 0x01, 0x0f, 0xb1, 0xfe, 0xa5, 0xb6,
+  0xfe, 0xa5, 0xb0, 0x05, 0xd5, 0xfc, 0x08, 0x03, 0xf8, 0xfa, 0x2b, 0x05,
+  0x1f, 0xfc, 0x00, 0x04, 0x00, 0xfa, 0xe1, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33,
+  0x01, 0x11, 0x33, 0x11, 0x23, 0x01, 0x11, 0x23, 0xb5, 0xf5, 0x02, 0x54,
+  0xb0, 0xf5, 0xfd, 0xac, 0xb0, 0x05, 0xd5, 0xfb, 0x1f, 0x04, 0xe1, 0xfa,
+  0x2b, 0x04, 0xe1, 0xfb, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02,
+  0x27, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x02, 0xd6, 0xc6, 0xe9, 0xe9, 0xc6, 0xc6, 0xe8, 0xe8, 0xc6, 0x01, 0x1b,
+  0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad, 0x01, 0x53,
+  0x05, 0x4c, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48,
+  0x01, 0x1a, 0x01, 0x1b, 0x01, 0x48, 0xa4, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe,
+  0x9f, 0xfe, 0x5b, 0x01, 0xa4, 0x01, 0x62, 0x01, 0x62, 0x01, 0xa5, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23,
+  0x01, 0x6b, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xfe, 0x66, 0x01, 0x9a, 0xe2,
+  0xe7, 0xe7, 0xe2, 0xe4, 0xb6, 0x05, 0x2f, 0xfd, 0xcf, 0x92, 0x87, 0x86,
+  0x92, 0xa6, 0xe3, 0xdb, 0xdd, 0xe2, 0xfd, 0xa8, 0x00, 0x02, 0x00, 0x67,
+  0xfe, 0xf8, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x1d, 0x00, 0x00,
+  0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02,
+  0x1b, 0x01, 0x23, 0x27, 0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x02, 0x02, 0xd6, 0xc6, 0xe9, 0xe9, 0xc6,
+  0xc6, 0xe8, 0xe8, 0x39, 0xef, 0xdb, 0xc7, 0x1e, 0x1f, 0x0f, 0xfe, 0xe5,
+  0xfe, 0xad, 0x01, 0x53, 0x01, 0x1b, 0x01, 0x1b, 0x01, 0x52, 0xbc, 0x05,
+  0x4c, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48, 0x01,
+  0x1a, 0x01, 0x1b, 0x01, 0x48, 0xfa, 0xcf, 0xfe, 0xdd, 0xef, 0x02, 0x02,
+  0x01, 0xa5, 0x01, 0x61, 0x01, 0x62, 0x01, 0xa5, 0xfe, 0x5b, 0xfe, 0x9e,
+  0xfe, 0xfc, 0xfe, 0x8e, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
+  0x05, 0xd5, 0x00, 0x13, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17,
+  0x13, 0x23, 0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4, 0xac, 0x42, 0x7d, 0x6c,
+  0xc6, 0xb6, 0x01, 0x9a, 0xe7, 0xe2, 0x75, 0xfd, 0xc8, 0xe4, 0x84, 0x86,
+  0x86, 0x84, 0x02, 0xbc, 0x16, 0x90, 0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96,
+  0x62, 0xfd, 0x89, 0x05, 0xd5, 0xd6, 0xd8, 0x8d, 0xba, 0x02, 0x4f, 0xfd,
+  0xee, 0x87, 0x83, 0x83, 0x85, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x79,
+  0xff, 0xe3, 0x04, 0x2c, 0x05, 0xf0, 0x00, 0x27, 0x00, 0x00, 0x01, 0x15,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01,
+  0x15, 0x14, 0x04, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x03, 0xda, 0x67, 0xb8, 0x55, 0x95, 0xa1, 0x6b, 0x96, 0x6d,
+  0xcc, 0xc1, 0xfe, 0xfb, 0xfd, 0x60, 0xd7, 0x73, 0x6f, 0xd4, 0x67, 0x9b,
+  0xaa, 0x7a, 0x8b, 0x6e, 0xcc, 0xb5, 0xfb, 0xdc, 0x5f, 0xc4, 0x05, 0xa4,
+  0xc5, 0x37, 0x36, 0x80, 0x76, 0x63, 0x65, 0x1f, 0x19, 0x2b, 0xd9, 0xb6,
+  0xd9, 0xe0, 0x30, 0x2f, 0xd0, 0x45, 0x46, 0x88, 0x7e, 0x6e, 0x7c, 0x1f,
+  0x18, 0x2d, 0xc0, 0xab, 0xc6, 0xe4, 0x26, 0x00, 0x00, 0x01, 0xff, 0xfa,
+  0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x00, 0x03, 0x21,
+  0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x05, 0x04, 0x70, 0xfe, 0x23, 0xb6,
+  0xfe, 0x23, 0x05, 0xd5, 0xaa, 0xfa, 0xd5, 0x05, 0x2b, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11,
+  0x33, 0x11, 0x10, 0x00, 0x23, 0x22, 0x00, 0x11, 0xa0, 0xb7, 0x9d, 0xaf,
+  0xaf, 0x9c, 0xb7, 0xfe, 0xfc, 0xfe, 0xff, 0xfe, 0xfc, 0x05, 0xd5, 0xfc,
+  0x75, 0xf0, 0xd3, 0xd3, 0xf0, 0x03, 0x8b, 0xfc, 0x5c, 0xfe, 0xdc, 0xfe,
+  0xd6, 0x01, 0x2a, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x21, 0x01,
+  0x33, 0x09, 0x01, 0x33, 0x01, 0x02, 0x0f, 0xfd, 0xff, 0xbe, 0x01, 0xaa,
+  0x01, 0xab, 0xbd, 0xfe, 0x00, 0x05, 0xd5, 0xfb, 0x17, 0x04, 0xe9, 0xfa,
+  0x2b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
+  0x05, 0xd5, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x09,
+  0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0x23, 0x3d, 0xb8, 0x01, 0x1a, 0x01,
+  0x1a, 0xcc, 0x01, 0x1b, 0x01, 0x1a, 0xb8, 0xfe, 0xaf, 0xe5, 0xfe, 0xe5,
+  0xfe, 0xe1, 0xe4, 0x05, 0xd5, 0xfb, 0x12, 0x04, 0xee, 0xfb, 0x12, 0x04,
+  0xee, 0xfa, 0x2b, 0x05, 0x10, 0xfa, 0xf0, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
+  0x09, 0x01, 0x33, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x01, 0x74, 0xc3,
+  0x01, 0x4e, 0x01, 0x50, 0xc3, 0xfe, 0x50, 0x01, 0xcd, 0xc3, 0xfe, 0x86,
+  0xfe, 0x83, 0xc4, 0x01, 0xe0, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0xfd,
+  0x33, 0xfc, 0xf8, 0x02, 0x7b, 0xfd, 0x85, 0x03, 0x1d, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x00, 0x03, 0x33, 0x09, 0x01, 0x33, 0x01, 0x11, 0x23, 0x11, 0x04,
+  0xc4, 0x01, 0x74, 0x01, 0x72, 0xc4, 0xfe, 0x24, 0xb6, 0x05, 0xd5, 0xfd,
+  0x9a, 0x02, 0x66, 0xfc, 0xf2, 0xfd, 0x39, 0x02, 0xc7, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x00, 0x09,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15, 0x21, 0x35, 0x01, 0x21,
+  0x68, 0x04, 0x1f, 0xfc, 0xaf, 0x03, 0x66, 0xfb, 0xb7, 0x03, 0x51, 0xfc,
+  0xc4, 0x05, 0xd5, 0x9a, 0xfb, 0x6f, 0xaa, 0x9a, 0x04, 0x91, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c, 0x06, 0x14, 0x00, 0x07,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x9e, 0x01,
+  0x7e, 0xd8, 0xd8, 0xfe, 0x82, 0x06, 0x14, 0x8f, 0xf9, 0xfc, 0x8f, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0xff, 0x42, 0x02, 0x6d, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x01, 0x23, 0x01, 0x99, 0x01, 0xd4, 0x99, 0xfe, 0x2c,
+  0x05, 0xd5, 0xf9, 0x6d, 0x06, 0x93, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb3,
+  0xfe, 0xf2, 0x02, 0x31, 0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x33, 0x11, 0x23, 0x35, 0x02, 0x31, 0xfe, 0x82, 0xd7, 0xd7,
+  0x06, 0x14, 0xf8, 0xde, 0x8f, 0x06, 0x04, 0x8f, 0x00, 0x01, 0x00, 0xc3,
+  0x03, 0xa8, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01,
+  0x23, 0x09, 0x01, 0x23, 0x01, 0x03, 0x5c, 0x01, 0xe9, 0xb5, 0xfe, 0x74,
+  0xfe, 0x74, 0xb5, 0x01, 0xe9, 0x05, 0xd5, 0xfd, 0xd3, 0x01, 0x8b, 0xfe,
+  0x75, 0x02, 0x2d, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x1d, 0x03, 0xac,
+  0xfe, 0xac, 0x00, 0x03, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35, 0x03, 0xac,
+  0xfc, 0x42, 0xfe, 0xac, 0x8f, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99,
+  0x04, 0xf0, 0x02, 0x49, 0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x13,
+  0x23, 0x01, 0x01, 0x4a, 0xfe, 0x8a, 0xfe, 0xdb, 0x06, 0x66, 0xfe, 0x8a,
+  0x01, 0x76, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x25, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x37, 0x11, 0x23, 0x35, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x78,
+  0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0xa6, 0xa6, 0x38, 0xa9, 0x7b, 0x9b,
+  0xb6, 0xe3, 0xe2, 0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51,
+  0xdb, 0xd8, 0x02, 0x33, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x4c,
+  0xfd, 0x81, 0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b,
+  0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x1c, 0x00, 0x00,
+  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26,
+  0x27, 0x15, 0x23, 0x11, 0x33, 0x03, 0x81, 0x96, 0x83, 0x84, 0x96, 0x96,
+  0x84, 0x83, 0x96, 0xfd, 0xcd, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8,
+  0x6f, 0x9f, 0x34, 0xa7, 0xa7, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
+  0xe7, 0xe7, 0x02, 0x52, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
+  0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x06, 0x14, 0x00, 0x00, 0x01, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x15,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37,
+  0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16,
+  0x03, 0x83, 0x46, 0x8d, 0x48, 0xa2, 0xb2, 0xb2, 0xa2, 0x48, 0x8d, 0x46,
+  0x45, 0x95, 0x53, 0xe4, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x4d, 0x92, 0x04,
+  0x35, 0xac, 0x2b, 0x2b, 0xe3, 0xcd, 0xcd, 0xe3, 0x2b, 0x2b, 0xaa, 0x24,
+  0x24, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x3a, 0x23, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xeb, 0x06, 0x14, 0x00, 0x10,
+  0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01,
+  0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0xa6,
+  0xa6, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0xfe, 0x00,
+  0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x03, 0xb6, 0x02, 0x5e,
+  0xf9, 0xec, 0xa8, 0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01,
+  0x44, 0x61, 0xfe, 0x15, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x00, 0x14,
+  0x00, 0x1b, 0x00, 0x00, 0x01, 0x15, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36,
+  0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32,
+  0x12, 0x07, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x04, 0x0c, 0xfd, 0x06,
+  0x0b, 0xb9, 0xa4, 0x60, 0xb3, 0x58, 0x59, 0xbb, 0x60, 0xf2, 0xfe, 0xe7,
+  0x01, 0x0b, 0xe3, 0xcb, 0xed, 0xa6, 0x02, 0x94, 0x7a, 0x8b, 0xa7, 0x0c,
+  0x02, 0x5e, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a, 0x2c, 0x01, 0x38,
+  0x01, 0x0a, 0x01, 0x13, 0x01, 0x43, 0xfe, 0xdd, 0xc4, 0x97, 0xb4, 0xae,
+  0x9e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac,
+  0x06, 0x14, 0x00, 0x13, 0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d,
+  0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34,
+  0x36, 0x33, 0x02, 0xac, 0x9e, 0x5a, 0x45, 0x01, 0x11, 0xfe, 0xef, 0xa6,
+  0x9f, 0x9f, 0x9c, 0xaa, 0x06, 0x14, 0x99, 0x50, 0x68, 0x63, 0x8f, 0xfc,
+  0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0xab, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xfe, 0x56, 0x03, 0xeb, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x28, 0x00, 0x00,
+  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x17, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33,
+  0x32, 0x16, 0x17, 0x35, 0x33, 0x03, 0x45, 0x95, 0x86, 0x85, 0x94, 0x94,
+  0x85, 0x86, 0x95, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a,
+  0xa3, 0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe2, 0xba, 0x70, 0xa0, 0x33,
+  0xa6, 0x02, 0x3d, 0xc8, 0xdc, 0xdc, 0xc8, 0xc7, 0xdc, 0xdc, 0xeb, 0xfe,
+  0xe2, 0xfe, 0xe9, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd, 0xbf, 0x5b, 0x63,
+  0x62, 0x01, 0x3a, 0x01, 0x03, 0x01, 0x04, 0x01, 0x3a, 0x62, 0x63, 0xaa,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x11, 0x33, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x03, 0xf4,
+  0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3,
+  0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87,
+  0x06, 0x14, 0xfd, 0x9e, 0x65, 0x64, 0xef, 0x00, 0x00, 0x02, 0x00, 0xad,
+  0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x23, 0x11, 0x33, 0x15, 0x23, 0xae, 0xa5, 0xa5, 0xa5,
+  0xa5, 0x04, 0x60, 0xfb, 0xa0, 0x06, 0x14, 0xe9, 0x00, 0x02, 0xff, 0xde,
+  0xfe, 0x56, 0x01, 0x54, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
+  0x11, 0x33, 0x15, 0x23, 0xae, 0xa5, 0x92, 0xa3, 0x3f, 0x2c, 0x5e, 0x45,
+  0xa5, 0xa5, 0x04, 0x60, 0xfb, 0x8c, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x06,
+  0x28, 0xe9, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x26,
+  0x06, 0x14, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09,
+  0x01, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xa7, 0x01, 0xee, 0xd4, 0xfd, 0xe9,
+  0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa7, 0x06, 0x14, 0xfc, 0x69, 0x01, 0xe3,
+  0xfd, 0xf4, 0xfd, 0xac, 0x02, 0x23, 0xfd, 0xdd, 0x00, 0x01, 0x00, 0xad,
+  0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x23, 0xae, 0xa5, 0xa5, 0x06, 0x14, 0xf9, 0xec, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67, 0x04, 0x7b, 0x00, 0x22,
+  0x00, 0x00, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0x03, 0xbe, 0x3f, 0xac, 0x75, 0x9e, 0xab, 0xa7, 0x66, 0x6a, 0x80,
+  0x96, 0xa6, 0x67, 0x6b, 0x7f, 0x95, 0xa7, 0xa7, 0x39, 0x9e, 0x6d, 0x6e,
+  0x9a, 0x03, 0x89, 0x7c, 0x76, 0xf5, 0xe2, 0xfd, 0x5c, 0x02, 0x9e, 0xa1,
+  0x9c, 0xbe, 0xa4, 0xfd, 0x87, 0x02, 0x9e, 0xa2, 0x9b, 0xbf, 0xa3, 0xfd,
+  0x87, 0x04, 0x60, 0xae, 0x67, 0x62, 0x7c, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0xf4, 0x04, 0x7b, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
+  0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86,
+  0x9b, 0xa7, 0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3, 0x02, 0xa4, 0xfd, 0x5c,
+  0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x65,
+  0x64, 0xef, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x12, 0x11,
+  0x10, 0x02, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x02, 0x34, 0x85, 0x9b,
+  0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x85, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xf5,
+  0xf5, 0x03, 0xdf, 0xe7, 0xc9, 0xc9, 0xe7, 0xe8, 0xc8, 0xc7, 0xe9, 0x9c,
+  0xfe, 0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x39, 0x01, 0x13,
+  0x01, 0x14, 0x01, 0x38, 0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e,
+  0x04, 0x7b, 0x00, 0x10, 0x00, 0x1c, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11,
+  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
+  0x26, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x01, 0x4e, 0xa7, 0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8,
+  0x6f, 0x9f, 0x01, 0xff, 0x96, 0x83, 0x84, 0x96, 0x96, 0x84, 0x83, 0x96,
+  0xa8, 0xfd, 0xae, 0x06, 0x0a, 0xaa, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8,
+  0xfe, 0xf8, 0xfe, 0xbc, 0x61, 0x01, 0xeb, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
+  0xe7, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb,
+  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01, 0x0e, 0x01, 0x23,
+  0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11,
+  0x23, 0x01, 0x11, 0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x02,
+  0x34, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0xa6,
+  0xa6, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0xfd, 0xae,
+  0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0x64,
+  0xaa, 0xf9, 0xf6, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x02, 0xf6,
+  0x04, 0x7b, 0x00, 0x11, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
+  0x02, 0xf6, 0x1c, 0x42, 0x27, 0x8d, 0x96, 0xa7, 0xa7, 0x34, 0xa8, 0x77,
+  0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11, 0xcb, 0xbe, 0xfd, 0xb2, 0x04,
+  0x60, 0xae, 0x66, 0x63, 0x05, 0x05, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe3, 0x03, 0x67, 0x04, 0x7b, 0x00, 0x27, 0x00, 0x00, 0x01, 0x15,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x03, 0x30, 0x46, 0x97, 0x51, 0x7b, 0x7c, 0x59, 0x85, 0x38,
+  0xb1, 0x94, 0xde, 0xc2, 0x51, 0xb0, 0x61, 0x5c, 0xb2, 0x57, 0x75, 0x7e,
+  0x5b, 0x9a, 0x39, 0x9a, 0x89, 0xca, 0xb9, 0x5c, 0xa2, 0x04, 0x3f, 0xae,
+  0x28, 0x28, 0x54, 0x54, 0x40, 0x49, 0x21, 0x0e, 0x2a, 0x99, 0x89, 0x9c,
+  0xb6, 0x23, 0x23, 0xbe, 0x35, 0x35, 0x59, 0x51, 0x4b, 0x50, 0x25, 0x0f,
+  0x24, 0x95, 0x82, 0x9e, 0xac, 0x1e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31,
+  0x00, 0x00, 0x02, 0xa7, 0x05, 0x9e, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
+  0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55, 0xfe, 0xab,
+  0x43, 0x67, 0xab, 0xab, 0xbf, 0x92, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2,
+  0x8f, 0xfd, 0xa0, 0x89, 0x4e, 0x9a, 0x9f, 0xd2, 0x02, 0x60, 0x8f, 0x01,
+  0x3e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
+  0x04, 0x7b, 0x00, 0x13, 0x00, 0x14, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0x01, 0x9d, 0xa5, 0x70, 0x6f, 0x87, 0x9b, 0xa6,
+  0xa6, 0x3c, 0x9f, 0x6a, 0xad, 0xb4, 0x01, 0xa0, 0x01, 0xba, 0x02, 0xa6,
+  0xfd, 0x61, 0x9f, 0x9f, 0xbe, 0xa4, 0x02, 0x7b, 0xfb, 0xa0, 0xac, 0x66,
+  0x63, 0xf0, 0x03, 0xa8, 0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
+  0x04, 0x60, 0x00, 0x06, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01,
+  0x23, 0x37, 0xaf, 0x01, 0x3b, 0x01, 0x3b, 0xb0, 0xfe, 0x86, 0xe1, 0x04,
+  0x60, 0xfc, 0x54, 0x03, 0xac, 0xfb, 0xa0, 0x00, 0x00, 0x01, 0x00, 0x4d,
+  0x00, 0x00, 0x05, 0x97, 0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33,
+  0x1b, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x4d,
+  0xa6, 0xcf, 0xce, 0xc3, 0xcf, 0xce, 0xa6, 0xfe, 0xf8, 0xc3, 0xd9, 0xda,
+  0xc3, 0x04, 0x60, 0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96, 0x03, 0x6a, 0xfb,
+  0xa0, 0x03, 0x96, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x35,
+  0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x02,
+  0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01, 0x03, 0xf4, 0xfe,
+  0x93, 0x01, 0x7f, 0xc3, 0xfe, 0xdb, 0xfe, 0xda, 0xc3, 0x01, 0x88, 0xfe,
+  0x99, 0xc4, 0x01, 0x0b, 0x01, 0x0b, 0x04, 0x60, 0xfd, 0xdf, 0xfd, 0xc1,
+  0x01, 0xb8, 0xfe, 0x48, 0x02, 0x4a, 0x02, 0x16, 0xfe, 0x71, 0x01, 0x8f,
+  0x00, 0x01, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x0f,
+  0x00, 0x00, 0x05, 0x0e, 0x01, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x3f,
+  0x01, 0x01, 0x33, 0x09, 0x01, 0x33, 0x02, 0x51, 0x46, 0x85, 0x70, 0x84,
+  0x61, 0x44, 0x4c, 0x2e, 0x1e, 0xfe, 0x68, 0xaf, 0x01, 0x3b, 0x01, 0x3b,
+  0xb0, 0x68, 0xc8, 0x7a, 0x9a, 0x48, 0x86, 0x54, 0x04, 0x4e, 0xfc, 0x94,
+  0x03, 0x6c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79,
+  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15,
+  0x21, 0x35, 0x01, 0x21, 0x66, 0x03, 0x12, 0xfd, 0x92, 0x02, 0x6e, 0xfc,
+  0xd7, 0x02, 0x6f, 0xfd, 0xa8, 0x04, 0x60, 0xa8, 0xfc, 0xdb, 0x93, 0xa8,
+  0x03, 0x25, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe6, 0xfe, 0xb2, 0x03, 0xaf,
+  0x06, 0x14, 0x00, 0x24, 0x00, 0x00, 0x05, 0x15, 0x23, 0x22, 0x26, 0x3d,
+  0x01, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34,
+  0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x14, 0x06, 0x07,
+  0x1e, 0x01, 0x1d, 0x01, 0x14, 0x16, 0x33, 0x03, 0xae, 0x38, 0xe0, 0x98,
+  0x61, 0x80, 0x37, 0x37, 0x81, 0x60, 0x98, 0xe0, 0x38, 0x3d, 0x7f, 0x4d,
+  0x52, 0x63, 0x64, 0x51, 0x4d, 0x7f, 0xbe, 0x90, 0x94, 0xdd, 0xef, 0x97,
+  0x74, 0x8f, 0x73, 0x95, 0xf0, 0xdd, 0x93, 0x8f, 0x58, 0x8d, 0xf8, 0x9d,
+  0x8e, 0x19, 0x1b, 0x8e, 0x9c, 0xf8, 0x8d, 0x58, 0x00, 0x01, 0x00, 0xea,
+  0xfe, 0x1d, 0x01, 0x83, 0x06, 0x1d, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x01, 0x83, 0x99, 0x06, 0x1d, 0xf8, 0x00, 0x08, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xe6, 0xfe, 0xb2, 0x03, 0xaf, 0x06, 0x14, 0x00, 0x24,
+  0x00, 0x00, 0x17, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34, 0x36, 0x37, 0x2e,
+  0x01, 0x3d, 0x01, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x1d,
+  0x01, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x14,
+  0x06, 0x2b, 0x01, 0xe6, 0x3f, 0x7e, 0x4d, 0x51, 0x64, 0x64, 0x51, 0x4d,
+  0x7e, 0x3f, 0x39, 0xe0, 0x97, 0x61, 0x7f, 0x38, 0x38, 0x7f, 0x61, 0x97,
+  0xe0, 0x39, 0xbe, 0x56, 0x8f, 0xf8, 0x9c, 0x8e, 0x1b, 0x19, 0x8e, 0x9d,
+  0xf8, 0x8e, 0x57, 0x8f, 0x93, 0xdd, 0xf0, 0x95, 0x73, 0x8f, 0x74, 0x97,
+  0xef, 0xdd, 0x94, 0x00, 0x00, 0x01, 0x00, 0xc3, 0x01, 0xd3, 0x05, 0x46,
+  0x03, 0x31, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
+  0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
+  0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x0a, 0x05, 0x06, 0x0d, 0x8c,
+  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x08, 0x05, 0x07,
+  0x0d, 0x8b, 0x55, 0x4d, 0x98, 0x03, 0x31, 0xb2, 0x4f, 0x44, 0x3b, 0x04,
+  0x02, 0x03, 0x05, 0x3e, 0x4d, 0x53, 0xb2, 0x4f, 0x45, 0x3c, 0x04, 0x02,
+  0x03, 0x05, 0x3e, 0x4c, 0x00, 0x02, 0x01, 0x16, 0x00, 0x00, 0x01, 0xcd,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33,
+  0x11, 0x23, 0x11, 0x13, 0x33, 0x13, 0x01, 0xcd, 0xb7, 0xb7, 0xb7, 0x13,
+  0x92, 0x12, 0x04, 0xd7, 0xfe, 0xfa, 0x2b, 0x02, 0x8f, 0x01, 0x65, 0xfe,
+  0x9b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9a, 0xfe, 0xc7, 0x03, 0xba,
+  0x05, 0x98, 0x00, 0x06, 0x00, 0x21, 0x00, 0x00, 0x25, 0x11, 0x0e, 0x01,
+  0x15, 0x14, 0x16, 0x01, 0x15, 0x2e, 0x01, 0x27, 0x03, 0x3e, 0x01, 0x37,
+  0x15, 0x0e, 0x01, 0x07, 0x11, 0x23, 0x11, 0x26, 0x02, 0x11, 0x10, 0x12,
+  0x37, 0x11, 0x33, 0x13, 0x1e, 0x01, 0x02, 0x62, 0x84, 0x94, 0x94, 0x01,
+  0xdb, 0x43, 0x7a, 0x3d, 0x01, 0x3f, 0x7b, 0x41, 0x3a, 0x7c, 0x45, 0x5c,
+  0xd9, 0xee, 0xee, 0xd9, 0x5c, 0x01, 0x42, 0x7b, 0x83, 0x03, 0x58, 0x12,
+  0xe2, 0xb8, 0xb9, 0xe2, 0x03, 0xa1, 0xac, 0x29, 0x2a, 0x03, 0xfc, 0xa0,
+  0x05, 0x2a, 0x27, 0xaa, 0x1e, 0x23, 0x07, 0xfe, 0xe4, 0x01, 0x20, 0x14,
+  0x01, 0x33, 0x01, 0x01, 0x01, 0x02, 0x01, 0x32, 0x16, 0x01, 0x1f, 0xfe,
+  0xe1, 0x04, 0x21, 0x00, 0x00, 0x01, 0x00, 0x74, 0x00, 0x00, 0x03, 0xf2,
+  0x05, 0xf0, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x35, 0x33,
+  0x11, 0x23, 0x35, 0x33, 0x35, 0x10, 0x36, 0x33, 0x32, 0x16, 0x03, 0xe0,
+  0x45, 0x7a, 0x37, 0x85, 0x69, 0x01, 0x60, 0xfe, 0xa0, 0x01, 0xf6, 0xfc,
+  0x82, 0xd4, 0xb3, 0xb3, 0xc1, 0xd1, 0x37, 0x88, 0x05, 0xb4, 0xb6, 0x29,
+  0x29, 0x9b, 0xd4, 0xd7, 0x8f, 0xfe, 0x2f, 0xaa, 0xaa, 0x01, 0xd1, 0x8f,
+  0xee, 0x01, 0x05, 0xf3, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x54,
+  0x00, 0x52, 0x04, 0x43, 0x04, 0xb2, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x00,
+  0x01, 0x37, 0x17, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07,
+  0x27, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x07, 0x27, 0x37, 0x2e, 0x01,
+  0x35, 0x34, 0x36, 0x37, 0x27, 0x37, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x16,
+  0x13, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x03, 0x22, 0xba, 0x67, 0xba, 0x22, 0x20, 0x22, 0x24, 0xbc, 0x67, 0xba,
+  0x35, 0x68, 0x37, 0x34, 0x6c, 0x37, 0xbb, 0x65, 0xba, 0x21, 0x22, 0x22,
+  0x23, 0xbb, 0x68, 0xba, 0x32, 0x68, 0x3a, 0x36, 0x69, 0x53, 0x8c, 0x66,
+  0x65, 0x8e, 0x8d, 0x66, 0x65, 0x8d, 0x03, 0xe1, 0xd1, 0x73, 0xce, 0x3b,
+  0x77, 0x3e, 0x3f, 0x73, 0x39, 0xcf, 0x71, 0xcf, 0x28, 0x26, 0x25, 0x25,
+  0xcf, 0x73, 0xce, 0x3e, 0x76, 0x3a, 0x40, 0x74, 0x38, 0xce, 0x73, 0xcf,
+  0x27, 0x25, 0x24, 0xfe, 0x7c, 0x70, 0x9a, 0x9a, 0x70, 0x72, 0x9c, 0x9d,
+  0x00, 0x01, 0x00, 0x49, 0x00, 0x00, 0x04, 0x4a, 0x05, 0xd5, 0x00, 0x18,
+  0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x35, 0x27,
+  0x21, 0x35, 0x33, 0x01, 0x33, 0x09, 0x01, 0x33, 0x01, 0x33, 0x15, 0x21,
+  0x07, 0x15, 0x21, 0x04, 0x18, 0xfe, 0x8d, 0xb5, 0xfe, 0x8a, 0x01, 0x76,
+  0x4c, 0xfe, 0xd6, 0xed, 0xfe, 0xe3, 0xab, 0x01, 0x55, 0x01, 0x53, 0xac,
+  0xfe, 0xe2, 0xed, 0xfe, 0xd7, 0x4c, 0x01, 0x75, 0x01, 0xc7, 0xfe, 0x39,
+  0x01, 0xc7, 0x7b, 0x33, 0x9b, 0x7b, 0x02, 0x4a, 0xfd, 0x44, 0x02, 0xbc,
+  0xfd, 0xb6, 0x7b, 0x9b, 0x33, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xea,
+  0xfe, 0xa2, 0x01, 0x83, 0x05, 0x98, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x11, 0x23, 0x11, 0x13, 0x11, 0x23, 0x11, 0x01, 0x83, 0x99, 0x99,
+  0x99, 0x01, 0x98, 0xfd, 0x0a, 0x02, 0xf6, 0x04, 0x00, 0xfd, 0x0a, 0x02,
+  0xf6, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x52, 0xff, 0x3d, 0x03, 0x45,
+  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x17, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
+  0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35,
+  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x2e, 0x01, 0x35,
+  0x34, 0x36, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x01,
+  0x55, 0x39, 0x37, 0x7d, 0xe1, 0x38, 0x38, 0x81, 0xb8, 0x4b, 0x80, 0x33,
+  0x57, 0x61, 0xb9, 0x18, 0x0c, 0xbe, 0x76, 0x53, 0x54, 0x38, 0x34, 0xb8,
+  0x9c, 0x41, 0x8b, 0x4f, 0x4e, 0x85, 0x34, 0x5c, 0x66, 0xc7, 0x16, 0xc1,
+  0x73, 0x53, 0x52, 0x35, 0x35, 0xb4, 0x96, 0x41, 0x8a, 0x03, 0xa8, 0x2e,
+  0x5a, 0x2e, 0x4c, 0x85, 0x87, 0x2d, 0x5b, 0x2e, 0x4b, 0x88, 0x02, 0x93,
+  0xa4, 0x27, 0x27, 0x50, 0x47, 0x5a, 0x73, 0x0f, 0x08, 0x77, 0x9a, 0x65,
+  0x5a, 0x8c, 0x35, 0x34, 0x6d, 0x40, 0x8e, 0xa8, 0x1d, 0x1d, 0xa4, 0x27,
+  0x27, 0x54, 0x4c, 0x66, 0x7b, 0x0e, 0x78, 0x99, 0x66, 0x5b, 0x8f, 0x31,
+  0x2c, 0x70, 0x45, 0x82, 0x9f, 0x1d, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc1,
+  0x05, 0x46, 0x02, 0xd9, 0x06, 0x10, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x02, 0x21, 0xb7, 0xb7,
+  0xfe, 0xa1, 0xb6, 0xb6, 0x06, 0x10, 0xca, 0xca, 0xca, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xfe, 0x00, 0x00, 0x06, 0x35, 0x05, 0xcd, 0x00, 0x17,
+  0x00, 0x2f, 0x00, 0x49, 0x00, 0x00, 0x01, 0x32, 0x16, 0x17, 0x16, 0x12,
+  0x15, 0x14, 0x02, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26, 0x02,
+  0x35, 0x34, 0x12, 0x37, 0x3e, 0x01, 0x17, 0x22, 0x06, 0x07, 0x0e, 0x01,
+  0x15, 0x14, 0x16, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x3e, 0x01,
+  0x35, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x03, 0x9a, 0x88, 0xed,
+  0x62, 0x62, 0x61, 0x61, 0x62, 0x62, 0xed, 0x88, 0x89, 0xed, 0x62, 0x62,
+  0x61, 0x61, 0x62, 0x62, 0xed, 0x89, 0x76, 0xcc, 0x54, 0x55, 0x56, 0x56,
+  0x55, 0x54, 0xcc, 0x76, 0x76, 0xcd, 0x54, 0x54, 0x54, 0x55, 0x53, 0x54,
+  0xcd, 0x97, 0x3c, 0x75, 0x3b, 0x86, 0x97, 0x9a, 0x8c, 0x3a, 0x6d, 0x3c,
+  0x3d, 0x7b, 0x3f, 0xc2, 0xe2, 0xe2, 0xc2, 0x42, 0x7a, 0x05, 0xcd, 0x6e,
+  0x6d, 0x6d, 0xfe, 0xfa, 0x9a, 0x98, 0xfe, 0xfb, 0x6d, 0x6d, 0x6e, 0x6e,
+  0x6d, 0x6d, 0x01, 0x05, 0x98, 0x9a, 0x01, 0x06, 0x6d, 0x6d, 0x6e, 0x67,
+  0x5e, 0x5e, 0x5e, 0xe5, 0x82, 0x81, 0xe3, 0x5e, 0x5e, 0x5f, 0x5f, 0x5e,
+  0x5d, 0xe2, 0x83, 0x85, 0xe3, 0x5d, 0x5e, 0x5e, 0xf5, 0x81, 0x21, 0x20,
+  0xaf, 0x9d, 0x9f, 0xae, 0x1f, 0x22, 0x7f, 0x1d, 0x1c, 0xf4, 0xd0, 0xd1,
+  0xf2, 0x1c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67, 0x01, 0xd5, 0x02, 0xe9,
+  0x05, 0xf0, 0x00, 0x03, 0x00, 0x1e, 0x00, 0x29, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x01, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
+  0x3e, 0x01, 0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x3d, 0x01, 0x7d, 0x02, 0x6b, 0xfd, 0x95, 0x02, 0x69, 0x86,
+  0x27, 0x82, 0x53, 0x74, 0x88, 0xab, 0xaa, 0xa3, 0x69, 0x69, 0x38, 0x7a,
+  0x3e, 0x42, 0x83, 0x3e, 0xa4, 0xa1, 0xf8, 0x91, 0x71, 0x58, 0x4a, 0x5d,
+  0x75, 0x02, 0x50, 0x7b, 0x02, 0xb8, 0xfe, 0x40, 0x70, 0x3f, 0x44, 0x87,
+  0x71, 0x87, 0x8a, 0x04, 0x5b, 0x5b, 0x22, 0x22, 0x7f, 0x1c, 0x1c, 0xb0,
+  0xf0, 0x43, 0x4f, 0x40, 0x4d, 0x90, 0x72, 0x1d, 0x00, 0x02, 0x00, 0x8e,
+  0x00, 0x8d, 0x03, 0xbb, 0x04, 0x23, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
+  0x01, 0x15, 0x09, 0x01, 0x15, 0x01, 0x35, 0x13, 0x15, 0x09, 0x01, 0x15,
+  0x01, 0x35, 0x03, 0xbb, 0xfe, 0xf1, 0x01, 0x0f, 0xfe, 0x5a, 0x1f, 0xfe,
+  0xf1, 0x01, 0x0f, 0xfe, 0x5a, 0x04, 0x23, 0xbf, 0xfe, 0xf4, 0xfe, 0xf4,
+  0xbf, 0x01, 0xa2, 0x52, 0x01, 0xa2, 0xbf, 0xfe, 0xf4, 0xfe, 0xf4, 0xbf,
+  0x01, 0xa2, 0x52, 0x00, 0x00, 0x01, 0x00, 0xc3, 0x01, 0x1f, 0x05, 0x46,
+  0x03, 0x5e, 0x00, 0x05, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0xc3, 0x04, 0x82, 0x97, 0xfc, 0x15, 0x03, 0x5e, 0xfd, 0xc1, 0x01, 0x95,
+  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40, 0x02, 0x83, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x01, 0xe5, 0xfe, 0x1b, 0x02,
+  0x83, 0xa4, 0x00, 0x00, 0x00, 0x04, 0x00, 0xfe, 0x00, 0x00, 0x06, 0x35,
+  0x05, 0xcd, 0x00, 0x17, 0x00, 0x2f, 0x00, 0x38, 0x00, 0x4c, 0x00, 0x00,
+  0x01, 0x22, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x1e, 0x01,
+  0x33, 0x32, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x2e, 0x01,
+  0x27, 0x32, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x0e, 0x01,
+  0x23, 0x22, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x3e, 0x01,
+  0x13, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x1f, 0x01, 0x23, 0x27, 0x2e, 0x01,
+  0x2b, 0x01, 0x11, 0x23, 0x11, 0x03, 0x9a, 0x76, 0xcc, 0x54, 0x55, 0x56,
+  0x56, 0x55, 0x54, 0xcc, 0x76, 0x76, 0xcd, 0x54, 0x54, 0x54, 0x55, 0x53,
+  0x54, 0xcd, 0x76, 0x88, 0xed, 0x62, 0x62, 0x61, 0x61, 0x62, 0x62, 0xed,
+  0x88, 0x89, 0xed, 0x62, 0x62, 0x61, 0x61, 0x62, 0x62, 0xed, 0x70, 0x6e,
+  0x6e, 0x63, 0x4f, 0x50, 0x5b, 0x9e, 0x9d, 0x5f, 0x56, 0x15, 0x3d, 0x29,
+  0x7b, 0x9a, 0x75, 0x35, 0x41, 0x31, 0x3b, 0x8c, 0x05, 0x66, 0x5e, 0x5e,
+  0x5e, 0xe5, 0x82, 0x81, 0xe3, 0x5e, 0x5e, 0x5f, 0x5f, 0x5e, 0x5d, 0xe2,
+  0x83, 0x85, 0xe3, 0x5d, 0x5e, 0x5e, 0x67, 0x6e, 0x6d, 0x6d, 0xfe, 0xfa,
+  0x9a, 0x98, 0xfe, 0xfb, 0x6d, 0x6d, 0x6e, 0x6e, 0x6d, 0x6d, 0x01, 0x05,
+  0x98, 0x9a, 0x01, 0x06, 0x6d, 0x6d, 0x6e, 0xfe, 0x62, 0xfe, 0xec, 0x3e,
+  0x4b, 0x4c, 0x3f, 0x67, 0x77, 0x79, 0x56, 0x70, 0x11, 0x08, 0x4d, 0x49,
+  0xdf, 0xd1, 0x60, 0x33, 0xfe, 0x9c, 0x03, 0x44, 0x00, 0x01, 0x00, 0xbf,
+  0x05, 0x62, 0x02, 0xda, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0xc0, 0x02, 0x1a, 0xfd, 0xe6, 0x05, 0xf6, 0x94, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xaf, 0x03, 0x75, 0x02, 0xeb, 0x05, 0xf0, 0x00, 0x0b,
+  0x00, 0x1a, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0xcd, 0x48, 0x63, 0x63,
+  0x48, 0x48, 0x63, 0x64, 0x47, 0x39, 0x6b, 0x26, 0x2a, 0x29, 0xa6, 0x79,
+  0x79, 0xa2, 0xa5, 0x05, 0x6f, 0x6f, 0x50, 0x4f, 0x6d, 0x6d, 0x4f, 0x4f,
+  0x70, 0x81, 0x31, 0x2e, 0x2d, 0x72, 0x42, 0x84, 0xb7, 0xb4, 0x87, 0x86,
+  0xba, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
+  0x05, 0x04, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15,
+  0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x01, 0x21, 0x15, 0x21,
+  0x03, 0x50, 0x01, 0xf5, 0xfe, 0x0b, 0x97, 0xfe, 0x0a, 0x01, 0xf6, 0xfe,
+  0x0a, 0x04, 0x82, 0xfb, 0x7e, 0x05, 0x04, 0xfe, 0x7d, 0xaa, 0xfe, 0x7d,
+  0x01, 0x83, 0xaa, 0x01, 0x83, 0xfb, 0xa6, 0xaa, 0x00, 0x01, 0x00, 0x54,
+  0x02, 0x9c, 0x02, 0x6f, 0x05, 0xf0, 0x00, 0x18, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x01, 0x06, 0xf1,
+  0x01, 0x7e, 0xfd, 0xe6, 0x1e, 0x39, 0x01, 0x36, 0x5e, 0x4d, 0x2e, 0x6e,
+  0x41, 0x45, 0x78, 0x33, 0x83, 0x9c, 0xfe, 0xd7, 0x33, 0x03, 0x0e, 0x72,
+  0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23, 0x23, 0x7b, 0x1c,
+  0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00, 0x01, 0x00, 0x58,
+  0x02, 0x8d, 0x02, 0x86, 0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x01, 0x1e,
+  0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x01, 0xd8, 0x52, 0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f,
+  0x2f, 0x6b, 0x3c, 0x62, 0x6c, 0x63, 0x62, 0x4d, 0x55, 0x54, 0x57, 0x5a,
+  0x55, 0x24, 0x5c, 0x49, 0x42, 0x73, 0x32, 0x81, 0x98, 0x51, 0x04, 0x60,
+  0x12, 0x6d, 0x52, 0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46,
+  0x4a, 0x4c, 0x6c, 0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11, 0x12,
+  0x76, 0x63, 0x45, 0x60, 0x00, 0x01, 0x01, 0x4d, 0x04, 0xee, 0x02, 0xfd,
+  0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x02, 0x4a,
+  0xb3, 0xfe, 0xdb, 0x8a, 0x06, 0x66, 0xfe, 0x88, 0x00, 0x01, 0x00, 0x9c,
+  0xfe, 0x56, 0x04, 0x68, 0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x13, 0x11,
+  0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27,
+  0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x11, 0x9d, 0xa5, 0x7c, 0x7a, 0x85,
+  0x86, 0xa6, 0x1f, 0x22, 0x08, 0x1c, 0x1a, 0x25, 0x42, 0x1f, 0x3e, 0x4a,
+  0x0e, 0x2d, 0x82, 0x59, 0x5b, 0x81, 0x26, 0xfe, 0x56, 0x06, 0x0a, 0xfd,
+  0x48, 0x91, 0x94, 0xa8, 0xa8, 0x02, 0x8d, 0xfc, 0xa2, 0x3c, 0x39, 0x0b,
+  0x0c, 0x94, 0x17, 0x16, 0x4e, 0x50, 0x4f, 0x4f, 0x4e, 0x4e, 0xfd, 0xd7,
+  0x00, 0x01, 0x00, 0x8e, 0xff, 0x3b, 0x03, 0xcd, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x2e,
+  0x01, 0x35, 0x34, 0x36, 0x02, 0x3a, 0x01, 0x93, 0x7f, 0xab, 0x80, 0xc1,
+  0xd4, 0xea, 0x05, 0xd5, 0xf9, 0x66, 0x06, 0x1f, 0xf9, 0xe1, 0x03, 0x4e,
+  0x11, 0xdd, 0xb8, 0xbe, 0xe8, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc5,
+  0x02, 0x48, 0x01, 0x83, 0x03, 0x46, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
+  0x15, 0x23, 0xc5, 0xbe, 0xbe, 0x03, 0x46, 0xfe, 0x00, 0x01, 0x01, 0x05,
+  0xfe, 0x75, 0x02, 0x7b, 0x00, 0x00, 0x00, 0x13, 0x00, 0x00, 0x21, 0x1e,
+  0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x02, 0x18, 0x32, 0x30, 0x6c, 0x6a,
+  0x29, 0x4e, 0x27, 0x1e, 0x43, 0x2a, 0x35, 0x36, 0x26, 0x29, 0x3e, 0x69,
+  0x30, 0x59, 0x5b, 0x0c, 0x0c, 0x83, 0x11, 0x0f, 0x30, 0x2e, 0x1e, 0x57,
+  0x3d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b, 0x02, 0x9c, 0x02, 0x7f,
+  0x05, 0xdf, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33, 0x11, 0x07, 0x35, 0x37,
+  0x33, 0x11, 0x33, 0x15, 0x21, 0x8c, 0xb8, 0xc9, 0xcf, 0x7c, 0xb8, 0xfe,
+  0x0e, 0x03, 0x0a, 0x02, 0x63, 0x29, 0x74, 0x27, 0xfd, 0x2b, 0x6e, 0x00,
+  0x00, 0x03, 0x00, 0x56, 0x01, 0xd5, 0x03, 0x0e, 0x05, 0xf0, 0x00, 0x03,
+  0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x17, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x7d, 0x02,
+  0x6b, 0xfd, 0x95, 0x01, 0x36, 0xa1, 0xb9, 0xb9, 0xa1, 0xa1, 0xbc, 0xbc,
+  0xa1, 0x5f, 0x71, 0x72, 0x5e, 0x5e, 0x71, 0x70, 0x02, 0x50, 0x7b, 0x04,
+  0x1b, 0xdd, 0xbf, 0xbf, 0xdb, 0xdc, 0xbe, 0xbf, 0xdd, 0x73, 0xa1, 0x88,
+  0x85, 0xa0, 0xa0, 0x85, 0x89, 0xa0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
+  0x00, 0x8d, 0x03, 0xdb, 0x04, 0x23, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
+  0x13, 0x01, 0x15, 0x01, 0x35, 0x09, 0x01, 0x25, 0x01, 0x15, 0x01, 0x35,
+  0x09, 0x01, 0xae, 0x01, 0xa6, 0xfe, 0x5a, 0x01, 0x0f, 0xfe, 0xf1, 0x01,
+  0x86, 0x01, 0xa6, 0xfe, 0x5a, 0x01, 0x0f, 0xfe, 0xf1, 0x04, 0x23, 0xfe,
+  0x5e, 0x52, 0xfe, 0x5e, 0xbf, 0x01, 0x0c, 0x01, 0x0c, 0xbf, 0xfe, 0x5e,
+  0x52, 0xfe, 0x5e, 0xbf, 0x01, 0x0c, 0x01, 0x0c, 0xff, 0xff, 0x00, 0x7b,
+  0xff, 0xe3, 0x06, 0xc0, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
+  0x10, 0x27, 0x07, 0xa2, 0x04, 0x17, 0xfd, 0x64, 0x10, 0x07, 0x07, 0x79,
+  0x02, 0xe3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0x86,
+  0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x74,
+  0x04, 0x17, 0xfd, 0x64, 0x10, 0x07, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x58, 0xff, 0xe3, 0x06, 0xc0, 0x05, 0xf0, 0x10, 0x26,
+  0x00, 0x75, 0x00, 0x00, 0x10, 0x27, 0x07, 0xa2, 0x04, 0x17, 0xfd, 0x64,
+  0x10, 0x07, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x00, 0x02, 0x00, 0x80,
+  0xff, 0xe3, 0x03, 0x4e, 0x05, 0xd5, 0x00, 0x20, 0x00, 0x24, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x14, 0x06, 0x0f, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x3f, 0x01, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x35, 0x13, 0x23, 0x35,
+  0x33, 0x01, 0xc2, 0xab, 0x31, 0x52, 0x50, 0x35, 0x2e, 0x76, 0x62, 0x47,
+  0xa2, 0x56, 0x55, 0xac, 0x5d, 0xa6, 0xc9, 0x41, 0x50, 0x50, 0x2b, 0x22,
+  0x07, 0x07, 0x05, 0xb0, 0xb5, 0xb5, 0x04, 0x44, 0x9c, 0x65, 0x82, 0x57,
+  0x58, 0x35, 0x5e, 0x31, 0x59, 0x6e, 0x46, 0x43, 0xbc, 0x39, 0x38, 0xc2,
+  0x9f, 0x4c, 0x89, 0x56, 0x56, 0x2f, 0x35, 0x19, 0x15, 0x3c, 0x36, 0x01,
+  0x0e, 0xfe, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x07, 0x6b, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee,
+  0x04, 0x43, 0x01, 0x75, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x07, 0x6b, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec,
+  0x04, 0x43, 0x01, 0x75, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x07, 0x6d, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x11, 0x07, 0x10, 0xef,
+  0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x5e, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xed, 0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x4e, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x43, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x07, 0x6d, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x21, 0x00, 0x00, 0x01, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x0b, 0x01,
+  0x21, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x07, 0x01, 0x23, 0x03, 0x21, 0x03, 0x23, 0x02, 0xff, 0x50, 0x39,
+  0x3a, 0x4e, 0x4f, 0x39, 0x39, 0x50, 0x89, 0xf5, 0x01, 0xeb, 0xfe, 0x82,
+  0x37, 0x38, 0x8f, 0x68, 0x67, 0x91, 0x39, 0x36, 0x01, 0xdf, 0xbd, 0x7b,
+  0xfd, 0xa2, 0x7a, 0xc0, 0x06, 0x5a, 0x3f, 0x59, 0x57, 0x41, 0x3f, 0x58,
+  0x58, 0xfe, 0xf3, 0xfd, 0x19, 0x03, 0x4e, 0x29, 0x73, 0x49, 0x73, 0xa0,
+  0xa1, 0x72, 0x46, 0x76, 0x29, 0xfa, 0x8b, 0x01, 0x7f, 0xfe, 0x81, 0x00,
+  0x00, 0x02, 0x00, 0x07, 0x00, 0x00, 0x06, 0x8e, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x13, 0x00, 0x00, 0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x03, 0x23, 0x01, 0x17, 0x01, 0x21, 0x11,
+  0x06, 0x7c, 0xfd, 0x66, 0x02, 0x80, 0xfd, 0x80, 0x02, 0xac, 0xfc, 0x9d,
+  0xfe, 0x25, 0x90, 0xb9, 0x02, 0x33, 0x7d, 0xfe, 0xd7, 0x01, 0x9d, 0x05,
+  0xd5, 0xaa, 0xfe, 0x46, 0xaa, 0xfd, 0xe3, 0xaa, 0x01, 0x7f, 0xfe, 0x81,
+  0x05, 0xd5, 0x9e, 0xfc, 0xf0, 0x03, 0x10, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xfe, 0x75, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x26, 0x00, 0x26, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x7a, 0x01, 0x0f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xee, 0x04, 0x28, 0x01, 0x75, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xec, 0x04, 0x28, 0x01, 0x75, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xef, 0x04, 0x28, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x4e, 0x12, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x28, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x01, 0x8e,
+  0x07, 0x6b, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee,
+  0x02, 0xde, 0x01, 0x75, 0xff, 0xff, 0x00, 0x91, 0x00, 0x00, 0x01, 0xe9,
+  0x07, 0x6b, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec,
+  0x02, 0xde, 0x01, 0x75, 0xff, 0xff, 0xff, 0xfe, 0x00, 0x00, 0x02, 0x24,
+  0x07, 0x6d, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xef,
+  0x02, 0xde, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0x00, 0x00, 0x02, 0x1c, 0x07, 0x4e, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xeb, 0x02, 0xde, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x05, 0x28, 0x05, 0xd5, 0x00, 0x0c,
+  0x00, 0x19, 0x00, 0x00, 0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x29,
+  0x01, 0x11, 0x23, 0x35, 0x33, 0x13, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0xbe, 0x01, 0x76, 0x01, 0x86, 0x01,
+  0x6d, 0xfe, 0x92, 0xfe, 0x7b, 0xfe, 0x8a, 0xb5, 0xb5, 0xb7, 0x01, 0x2e,
+  0xfe, 0xd2, 0xda, 0x01, 0x16, 0x01, 0x03, 0xfe, 0xfd, 0xfe, 0xea, 0x05,
+  0xd5, 0xfe, 0x97, 0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x02, 0xbc, 0x90,
+  0x01, 0xe3, 0xfe, 0x1d, 0x90, 0xfd, 0xea, 0x01, 0x18, 0x01, 0x2e, 0x01,
+  0x2c, 0x01, 0x17, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae,
+  0x07, 0x5e, 0x12, 0x26, 0x00, 0x31, 0x00, 0x00, 0x11, 0x07, 0x10, 0xed,
+  0x04, 0x7e, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xee, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xec, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xef, 0x04, 0xa3, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x5e, 0x12, 0x26,
+  0x00, 0x32, 0x00, 0x00, 0x11, 0x07, 0x10, 0xed, 0x04, 0xa3, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x07, 0x4e, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb,
+  0x04, 0xa3, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xfc,
+  0x00, 0x3f, 0x05, 0x0d, 0x04, 0xc5, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x02,
+  0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x37, 0x09, 0x01, 0x05, 0x0c, 0xfe,
+  0x65, 0x01, 0x9b, 0x6b, 0xfe, 0x63, 0xfe, 0x63, 0x6a, 0x01, 0x9a, 0xfe,
+  0x66, 0x6a, 0x01, 0x9d, 0x01, 0x9d, 0x04, 0x4c, 0xfe, 0x35, 0xfe, 0x37,
+  0x79, 0x01, 0xcb, 0xfe, 0x35, 0x79, 0x01, 0xc9, 0x01, 0xcb, 0x79, 0xfe,
+  0x35, 0x01, 0xcb, 0x00, 0x00, 0x03, 0x00, 0x5b, 0xff, 0xba, 0x05, 0x4f,
+  0x06, 0x17, 0x00, 0x09, 0x00, 0x13, 0x00, 0x2b, 0x00, 0x00, 0x09, 0x01,
+  0x1e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x23,
+  0x22, 0x02, 0x11, 0x14, 0x16, 0x17, 0x07, 0x26, 0x02, 0x35, 0x10, 0x00,
+  0x21, 0x32, 0x16, 0x17, 0x37, 0x17, 0x07, 0x16, 0x12, 0x15, 0x10, 0x00,
+  0x21, 0x22, 0x26, 0x27, 0x07, 0x27, 0x04, 0x3d, 0xfd, 0x7b, 0x38, 0x91,
+  0x55, 0xc6, 0xe8, 0x24, 0x6c, 0x37, 0x91, 0x56, 0xc6, 0xe9, 0x23, 0x23,
+  0x78, 0x46, 0x47, 0x01, 0x53, 0x01, 0x1b, 0x75, 0xc7, 0x4e, 0x92, 0x5c,
+  0x99, 0x46, 0x48, 0xfe, 0xae, 0xfe, 0xe5, 0x73, 0xc7, 0x52, 0x92, 0x5c,
+  0x04, 0x58, 0xfc, 0xb2, 0x40, 0x43, 0x01, 0x48, 0x01, 0x1a, 0x70, 0xb8,
+  0xb8, 0x40, 0x43, 0xfe, 0xb8, 0xfe, 0xe5, 0x70, 0xbc, 0x44, 0x9e, 0x66,
+  0x01, 0x08, 0xa0, 0x01, 0x62, 0x01, 0xa5, 0x4d, 0x4b, 0xbf, 0x59, 0xc6,
+  0x67, 0xfe, 0xf6, 0x9e, 0xfe, 0x9f, 0xfe, 0x5b, 0x4b, 0x4b, 0xbf, 0x58,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6b, 0x12, 0x26,
+  0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee, 0x04, 0x70, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6b, 0x12, 0x26,
+  0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec, 0x04, 0x70, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6d, 0x12, 0x26,
+  0x00, 0x38, 0x00, 0x00, 0x11, 0x07, 0x10, 0xef, 0x04, 0x70, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x07, 0x4e, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb,
+  0x04, 0x70, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc,
+  0x00, 0x00, 0x04, 0x6a, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xec, 0x04, 0x01, 0x01, 0x75, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11,
+  0x23, 0x13, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0xb5, 0xb6,
+  0xe4, 0xe2, 0xe7, 0xe7, 0xe2, 0xe4, 0xb6, 0xb6, 0xe4, 0x7f, 0x8b, 0x8a,
+  0x80, 0x05, 0xd5, 0xfe, 0xf8, 0xe1, 0xdc, 0xdc, 0xe2, 0xfe, 0xae, 0x04,
+  0x27, 0xfd, 0xd1, 0x92, 0x86, 0x86, 0x91, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xff, 0xe3, 0x04, 0x35, 0x06, 0x14, 0x00, 0x2f, 0x00, 0x00, 0x13, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x17, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x1f, 0x01,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34,
+  0x36, 0x37, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0xa7, 0xd7,
+  0xc5, 0xbb, 0xc5, 0x03, 0x88, 0x97, 0x34, 0x3a, 0x34, 0x95, 0x56, 0xca,
+  0xbe, 0x3a, 0x7a, 0x42, 0x48, 0x7e, 0x3b, 0x68, 0x6c, 0x35, 0x5b, 0x53,
+  0x56, 0x4e, 0x96, 0x88, 0x07, 0x76, 0x66, 0x75, 0x7a, 0xa9, 0x04, 0x71,
+  0xc8, 0xdb, 0xe8, 0xe0, 0x08, 0x73, 0x60, 0x2f, 0x51, 0x2a, 0x25, 0x6a,
+  0x8e, 0x64, 0xac, 0xb7, 0x19, 0x18, 0xa4, 0x1e, 0x1d, 0x5f, 0x5b, 0x3f,
+  0x54, 0x3e, 0x37, 0x3b, 0x87, 0x5b, 0x7f, 0xac, 0x1d, 0x67, 0x70, 0x8b,
+  0x83, 0xfb, 0x93, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x00, 0x43,
+  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x00, 0x76,
+  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x88,
+  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x06, 0x37, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x9e,
+  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x06, 0x10, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a,
+  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x07, 0x06, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x9c,
+  0x4a, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xb1,
+  0x04, 0x7b, 0x00, 0x06, 0x00, 0x33, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x07, 0x03, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x1d,
+  0x01, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b,
+  0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x03, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d,
+  0x01, 0x06, 0x0a, 0x01, 0x94, 0x7b, 0x8a, 0xa7, 0x0c, 0x3d, 0x42, 0xbf,
+  0x77, 0xcb, 0xee, 0xfd, 0x06, 0x0b, 0xb8, 0xa4, 0x5e, 0xb4, 0x5a, 0x5a,
+  0xbb, 0x60, 0x96, 0xdf, 0x45, 0x42, 0xc3, 0x80, 0xaa, 0xbd, 0xe3, 0xe2,
+  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0x80, 0xc0, 0xd7,
+  0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0x02, 0x94, 0x97, 0xb4, 0xae, 0x9e,
+  0x01, 0x30, 0x5a, 0x5e, 0xfe, 0xdd, 0xfa, 0x5a, 0xbf, 0xc8, 0x35, 0x35,
+  0xae, 0x2a, 0x2c, 0x79, 0x77, 0x78, 0x78, 0xbb, 0xa8, 0xbd, 0xc0, 0x12,
+  0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0x60, 0xfe, 0x18, 0x66, 0x7b,
+  0x62, 0x73, 0xd9, 0xb4, 0x29, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x75, 0x03, 0x84, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x46, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x7a, 0x00, 0x81, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x43, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x76, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x11, 0x06, 0x02, 0x88, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x10, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x11, 0x06, 0x00, 0x6a, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xcc,
+  0x00, 0x00, 0x01, 0x7c, 0x06, 0x66, 0x10, 0x27, 0x00, 0x43, 0xff, 0x34,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x81,
+  0x00, 0x00, 0x02, 0x31, 0x06, 0x66, 0x10, 0x27, 0x00, 0x76, 0xff, 0x34,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe1,
+  0x00, 0x00, 0x02, 0x20, 0x06, 0x66, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00,
+  0x11, 0x07, 0x02, 0x88, 0xff, 0x34, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xf5, 0x00, 0x00, 0x02, 0x0c, 0x06, 0x10, 0x12, 0x26,
+  0x00, 0xf3, 0x00, 0x00, 0x11, 0x07, 0x00, 0x6a, 0xff, 0x34, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x06, 0x14, 0x00, 0x0e, 0x00, 0x28, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23,
+  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13,
+  0x16, 0x12, 0x15, 0x14, 0x00, 0x23, 0x22, 0x02, 0x11, 0x34, 0x12, 0x33,
+  0x32, 0x16, 0x17, 0x27, 0x05, 0x27, 0x37, 0x27, 0x33, 0x17, 0x25, 0x17,
+  0x05, 0x02, 0xf2, 0x2d, 0x4f, 0x25, 0x96, 0xa7, 0x9d, 0x83, 0x83, 0x9c,
+  0x30, 0x08, 0x71, 0x67, 0xff, 0x00, 0xcf, 0xd0, 0xfe, 0xf8, 0xc7, 0x10,
+  0x2f, 0x26, 0x8f, 0xfe, 0xe1, 0x1e, 0xfd, 0xa3, 0xcd, 0x72, 0x01, 0x2c,
+  0x1e, 0xfe, 0xf6, 0x03, 0x93, 0x11, 0x10, 0xd8, 0xc3, 0xbc, 0xde, 0xde,
+  0xbc, 0x7a, 0xbc, 0x01, 0x26, 0x8f, 0xfe, 0xe0, 0xad, 0xff, 0xfe, 0xc9,
+  0x01, 0x37, 0x00, 0xff, 0xfa, 0x01, 0x37, 0x05, 0x05, 0xb4, 0x6b, 0x63,
+  0x5c, 0xcc, 0x91, 0x6f, 0x61, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0xf4, 0x06, 0x37, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x9e, 0x00, 0x89, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x43, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x76, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x11, 0x06, 0x02, 0x88, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x37, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x11, 0x06, 0x02, 0x9e, 0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x10, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x11, 0x06, 0x00, 0x6a, 0x68, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0x00, 0x96, 0x05, 0x46, 0x04, 0x6f, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x01, 0x21,
+  0x15, 0x21, 0x02, 0x96, 0xdd, 0xdd, 0xdd, 0xdd, 0xfe, 0x2d, 0x04, 0x82,
+  0xfb, 0x7e, 0x04, 0x6f, 0xf6, 0xfe, 0x12, 0xf5, 0x02, 0x41, 0xaa, 0x00,
+  0x00, 0x03, 0x00, 0x40, 0xff, 0xa2, 0x04, 0x26, 0x04, 0xbc, 0x00, 0x09,
+  0x00, 0x13, 0x00, 0x2b, 0x00, 0x00, 0x09, 0x01, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x16, 0x17, 0x07, 0x2e, 0x01, 0x35, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17,
+  0x37, 0x17, 0x07, 0x1e, 0x01, 0x15, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27,
+  0x07, 0x27, 0x03, 0x2e, 0xfe, 0x4a, 0x25, 0x5d, 0x3a, 0x85, 0x9a, 0x12,
+  0x52, 0x26, 0x5d, 0x38, 0x88, 0x98, 0x11, 0x12, 0x70, 0x31, 0x30, 0xf5,
+  0xd9, 0x54, 0x8f, 0x3c, 0x7d, 0x56, 0x83, 0x2f, 0x31, 0xf7, 0xd8, 0x56,
+  0x91, 0x39, 0x7d, 0x56, 0x03, 0x21, 0xfd, 0xb0, 0x2a, 0x28, 0xe8, 0xc8,
+  0x4f, 0x75, 0x9a, 0x29, 0x29, 0xeb, 0xd3, 0x48, 0x6e, 0x2e, 0x97, 0x4d,
+  0xc5, 0x77, 0x01, 0x14, 0x01, 0x38, 0x33, 0x34, 0xa8, 0x4f, 0xb3, 0x4d,
+  0xc6, 0x78, 0xfe, 0xed, 0xfe, 0xc7, 0x34, 0x33, 0xa8, 0x4e, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x10, 0x06, 0x00, 0x43, 0x6f, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76, 0x6f, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x02, 0x88, 0x6f, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x10, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a, 0x6f, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x5c, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76, 0x55, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x10,
+  0x00, 0x1c, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11, 0x33, 0x11, 0x3e, 0x01,
+  0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26, 0x01, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x01, 0x4e, 0xa7,
+  0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x01, 0xff,
+  0x96, 0x83, 0x84, 0x96, 0x96, 0x84, 0x83, 0x96, 0xa8, 0xfd, 0xae, 0x07,
+  0xbe, 0xfd, 0xa2, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8, 0xfe,
+  0xbc, 0x61, 0x01, 0xeb, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x10, 0x12, 0x26,
+  0x00, 0x5c, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a, 0x55, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0xaa, 0x01, 0x3b, 0x13, 0x06, 0x00, 0x24, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x05, 0xf6, 0x10, 0x26, 0x00, 0x71, 0x43, 0x00, 0x13, 0x06, 0x00, 0x44,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x07, 0x92, 0x10, 0x27, 0x02, 0x9a, 0x00, 0xb9, 0x01, 0x4a, 0x13, 0x06,
+  0x00, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
+  0xff, 0xe3, 0x03, 0xc3, 0x06, 0x1f, 0x10, 0x26, 0x02, 0x9a, 0x47, 0xd7,
+  0x13, 0x06, 0x00, 0x44, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0xfe, 0x75, 0x05, 0x15, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x9d, 0x02, 0x9a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
+  0xfe, 0x75, 0x04, 0x0d, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x9d, 0x01, 0x92, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa4, 0x07, 0x6b, 0x12, 0x26, 0x00, 0x26, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xec, 0x04, 0xa8, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0x84, 0x06, 0x66, 0x12, 0x26, 0x00, 0x46, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x76, 0x7b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa4, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0xc4,
+  0x01, 0x75, 0x13, 0x06, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x46, 0x00, 0x00, 0x10, 0x07, 0x02, 0x88, 0x00, 0x94, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x07, 0x50, 0x10, 0x27,
+  0x10, 0xf3, 0x04, 0xc4, 0x01, 0x75, 0x12, 0x06, 0x00, 0x26, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x06, 0x14, 0x10, 0x27,
+  0x02, 0xb8, 0x04, 0x2d, 0x00, 0x00, 0x12, 0x06, 0x00, 0x46, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x07, 0x6d, 0x12, 0x26,
+  0x00, 0x26, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x04, 0xa8, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x46, 0x00, 0x00, 0x10, 0x06, 0x02, 0x89,
+  0x7b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x1f,
+  0x07, 0x6d, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x6e, 0x01, 0x75, 0x12, 0x06,
+  0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x05, 0x46,
+  0x06, 0x14, 0x12, 0x26, 0x00, 0x47, 0x00, 0x00, 0x11, 0x07, 0x10, 0xea,
+  0x04, 0x92, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x09,
+  0x00, 0x00, 0x05, 0x28, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x92, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x76, 0x06, 0x14, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x33, 0x15,
+  0x33, 0x15, 0x23, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
+  0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0xfe, 0xdb, 0x01, 0x25, 0xa6,
+  0x8a, 0x8a, 0xa6, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f,
+  0xfe, 0x00, 0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x03, 0xb6,
+  0x01, 0x4e, 0x7d, 0x93, 0x93, 0x7d, 0xfa, 0xfc, 0xa8, 0x64, 0x61, 0x01,
+  0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0xfe, 0x15, 0xcb, 0xe7,
+  0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x33, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x71, 0x00, 0x91, 0x01, 0x3d, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x05, 0xf6, 0x10, 0x27, 0x00, 0x71, 0x00, 0x87,
+  0x00, 0x00, 0x13, 0x06, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xf2, 0x04, 0x2a, 0x01, 0x75, 0x13, 0x06, 0x00, 0x28, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
+  0x06, 0x48, 0x10, 0x27, 0x02, 0x9a, 0x00, 0x87, 0x00, 0x00, 0x13, 0x06,
+  0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x28,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x04, 0x21,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x75, 0x04, 0x19, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x9d, 0x01, 0x9e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x75, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x9d, 0x01, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x67, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xf0, 0x04, 0x2f, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x61, 0x12, 0x26,
+  0x00, 0x48, 0x00, 0x00, 0x11, 0x07, 0x02, 0x89, 0x00, 0x85, 0xff, 0xfb,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe,
+  0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0xd3, 0x01, 0x75, 0x13, 0x06,
+  0x00, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x03, 0xeb, 0x06, 0x66, 0x10, 0x26, 0x02, 0x88, 0x5e, 0x00,
+  0x13, 0x06, 0x00, 0x4a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xfe, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x2a, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf2, 0x04, 0x98, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x03, 0xeb, 0x06, 0x48, 0x12, 0x26, 0x00, 0x4a, 0x00, 0x00,
+  0x10, 0x06, 0x02, 0x9a, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xfe, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0xd3,
+  0x01, 0x75, 0x13, 0x06, 0x00, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27,
+  0x02, 0xb8, 0x03, 0xf9, 0x00, 0x00, 0x12, 0x06, 0x00, 0x4a, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xfe, 0x01, 0x04, 0xfe, 0x05, 0xf0, 0x10, 0x27,
+  0x02, 0xd7, 0x04, 0xd4, 0xff, 0xed, 0x12, 0x06, 0x00, 0x2a, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb, 0x06, 0x34, 0x10, 0x27,
+  0x02, 0xc3, 0x03, 0x7c, 0x01, 0x0c, 0x12, 0x06, 0x00, 0x4a, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xef, 0x04, 0x82, 0x01, 0x75, 0x13, 0x06, 0x00, 0x2b, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe7, 0x00, 0x00, 0x03, 0xf4,
+  0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x02, 0xc7, 0x01, 0x75, 0x13, 0x06,
+  0x00, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0xe4, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x21, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23, 0x11, 0x23,
+  0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x17, 0x15, 0x21, 0x35,
+  0x01, 0x4c, 0xb6, 0x02, 0x94, 0xb6, 0x98, 0x98, 0xb6, 0xfd, 0x6c, 0xb6,
+  0x97, 0x97, 0xb6, 0x02, 0x94, 0x05, 0xd5, 0xe0, 0xe0, 0xe0, 0xa4, 0xfb,
+  0xaf, 0x02, 0xc7, 0xfd, 0x39, 0x04, 0x51, 0xa4, 0xa4, 0xe0, 0xe0, 0x00,
+  0x00, 0x01, 0x00, 0x6c, 0x00, 0x00, 0x04, 0x29, 0x06, 0x14, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x21, 0x15, 0x21,
+  0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x04, 0x29, 0xa6, 0x6f, 0x70, 0x86,
+  0x9b, 0xa7, 0x70, 0x70, 0xa7, 0x01, 0x3d, 0xfe, 0xc3, 0x3b, 0xa2, 0x69,
+  0xad, 0xb3, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4,
+  0xfd, 0x87, 0x04, 0xf6, 0xa4, 0x7a, 0x7a, 0xa4, 0xfe, 0xbc, 0x65, 0x64,
+  0xef, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe6, 0x00, 0x00, 0x02, 0x39,
+  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x02, 0xdd, 0x01, 0x75, 0x13, 0x06,
+  0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xd7,
+  0x00, 0x00, 0x02, 0x2a, 0x06, 0x37, 0x10, 0x27, 0x02, 0x9e, 0xff, 0x34,
+  0x00, 0x00, 0x13, 0x06, 0x00, 0xf3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x02, 0x1d, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0xff, 0x43, 0x01, 0x3b, 0x13, 0x06, 0x00, 0x2c, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf3, 0x00, 0x00, 0x02, 0x0e,
+  0x05, 0xf5, 0x10, 0x27, 0x00, 0x71, 0xff, 0x34, 0xff, 0xff, 0x13, 0x06,
+  0x00, 0xf3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf6,
+  0x00, 0x00, 0x02, 0x2a, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x02, 0xdd,
+  0x01, 0x75, 0x13, 0x06, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xe6, 0x00, 0x00, 0x02, 0x1b, 0x06, 0x48, 0x10, 0x27,
+  0x02, 0x9a, 0xff, 0x34, 0x00, 0x00, 0x13, 0x06, 0x00, 0xf3, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xfe, 0x75, 0x01, 0xef,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0x9d, 0xff, 0x74, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0xfe, 0x75, 0x01, 0xd7,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0x9d, 0xff, 0x5c, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6d,
+  0x07, 0x50, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf3,
+  0x02, 0xde, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
+  0x00, 0x00, 0x01, 0x54, 0x04, 0x7b, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x23, 0x13, 0xae, 0xa5, 0xa5, 0x52, 0x04, 0x60, 0xfb,
+  0xa0, 0x04, 0x7b, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x66, 0x03, 0x8b,
+  0x05, 0xd5, 0x10, 0x27, 0x00, 0x2d, 0x02, 0x20, 0x00, 0x00, 0x11, 0x06,
+  0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0xfe, 0x56, 0x03, 0x53, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x01, 0xff,
+  0x00, 0x00, 0x11, 0x06, 0x00, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xa0, 0xfe, 0x66, 0x02, 0x23, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xef, 0x02, 0xdd, 0x01, 0x75, 0x13, 0x06, 0x00, 0x2d, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x02, 0x20,
+  0x06, 0x66, 0x10, 0x27, 0x02, 0x88, 0xff, 0x34, 0x00, 0x00, 0x13, 0x06,
+  0x01, 0xf9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x1e, 0x04, 0xe0, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x98,
+  0x00, 0x0a, 0x12, 0x06, 0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x1e, 0x04, 0x26, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x35,
+  0x00, 0x0a, 0x12, 0x06, 0x00, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x26, 0x04, 0x60, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xa7, 0x01,
+  0xee, 0xd4, 0xfd, 0xe9, 0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa7, 0x04, 0x60,
+  0xfe, 0x1b, 0x01, 0xe5, 0xfd, 0xf2, 0xfd, 0xae, 0x02, 0x21, 0xfd, 0xdf,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x07, 0x6c, 0x10, 0x27,
+  0x10, 0xec, 0x03, 0x16, 0x01, 0x76, 0x12, 0x06, 0x00, 0x2f, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x02, 0x10, 0x07, 0x6c, 0x10, 0x27,
+  0x10, 0xec, 0x03, 0x04, 0x01, 0x76, 0x13, 0x06, 0x00, 0x4f, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x1e, 0x03, 0xf9,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x25, 0x00, 0x0a, 0x12, 0x06,
+  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7a, 0xfe, 0x1e, 0x01, 0x83,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0xd7, 0x02, 0xce, 0x00, 0x0a, 0x13, 0x06,
+  0x00, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x27, 0x10, 0xea, 0x02, 0x5c,
+  0xff, 0xc3, 0x12, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0x00, 0x00, 0x02, 0xb4, 0x06, 0x14, 0x10, 0x27, 0x10, 0xea, 0x02, 0x00,
+  0x00, 0x02, 0x11, 0x06, 0x00, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x27,
+  0x00, 0x79, 0x01, 0xf9, 0x00, 0x77, 0x12, 0x06, 0x00, 0x2f, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x02, 0x44, 0x06, 0x14, 0x10, 0x27,
+  0x00, 0x79, 0x00, 0xc1, 0x00, 0x73, 0x11, 0x06, 0x00, 0x4f, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xf3, 0x00, 0x00, 0x04, 0x03,
+  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x25, 0x17, 0x01,
+  0x11, 0x21, 0x15, 0x21, 0x11, 0x07, 0x27, 0x37, 0xbe, 0xb7, 0x01, 0x19,
+  0x48, 0xfe, 0x9f, 0x02, 0x8e, 0xfc, 0xbb, 0x85, 0x46, 0xcb, 0x05, 0xd5,
+  0xfd, 0x98, 0xdb, 0x6f, 0xfe, 0xee, 0xfd, 0xe3, 0xaa, 0x02, 0x3b, 0x6a,
+  0x6e, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x02, 0x0e,
+  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x37, 0x17, 0x07,
+  0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0xb3, 0xa6, 0x70, 0x45, 0xb5, 0xa6,
+  0x6f, 0x42, 0xb1, 0x06, 0x14, 0xfd, 0xa6, 0x5a, 0x6a, 0x8d, 0xfc, 0xe3,
+  0x02, 0x9a, 0x58, 0x6a, 0x8d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xae, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x4b,
+  0x01, 0x76, 0x13, 0x06, 0x00, 0x31, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4, 0x06, 0x6d, 0x10, 0x26,
+  0x00, 0x76, 0x3c, 0x07, 0x13, 0x06, 0x00, 0x51, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x1e, 0x04, 0xae, 0x05, 0xd5, 0x10, 0x27,
+  0x02, 0xd7, 0x04, 0x80, 0x00, 0x0a, 0x12, 0x06, 0x00, 0x31, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x1e, 0x03, 0xf4, 0x04, 0x7b, 0x10, 0x27,
+  0x02, 0xd7, 0x04, 0x1c, 0x00, 0x0a, 0x12, 0x06, 0x00, 0x51, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x5f, 0x12, 0x26,
+  0x00, 0x31, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x04, 0x76, 0x01, 0x67,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89,
+  0x7f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb8, 0x00, 0x00, 0x05, 0x27,
+  0x05, 0xd5, 0x10, 0x27, 0x00, 0x51, 0x01, 0x33, 0x00, 0x00, 0x10, 0x06,
+  0x02, 0x7e, 0x18, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x97,
+  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x10, 0x21, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12, 0x19,
+  0x01, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x03,
+  0xe2, 0xfe, 0xeb, 0xa1, 0xc1, 0xb6, 0xb6, 0x46, 0x5e, 0x60, 0x89, 0xcd,
+  0xd1, 0x49, 0x49, 0xa3, 0x4e, 0x2c, 0x5c, 0x47, 0x03, 0x7f, 0x01, 0xac,
+  0xff, 0xde, 0xfc, 0xb2, 0x05, 0xd5, 0xf1, 0x86, 0x43, 0x43, 0xfe, 0xc1,
+  0xfe, 0xcc, 0xfc, 0x6f, 0xd5, 0x61, 0x60, 0x9c, 0x5a, 0xa0, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x04, 0x7b, 0x00, 0x1f,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23,
+  0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x03, 0xf4,
+  0x4a, 0x49, 0xa3, 0xe5, 0xd2, 0x5f, 0x22, 0x22, 0x70, 0x6f, 0x86, 0x9b,
+  0xa7, 0xa7, 0x3b, 0x50, 0x51, 0x6a, 0xad, 0x59, 0x5a, 0x02, 0xa4, 0xfd,
+  0x48, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x02, 0xb2, 0x9f, 0x9e,
+  0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x01, 0x0a, 0x01, 0x3b, 0x13, 0x06, 0x00, 0x32, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x05, 0xf5, 0x10, 0x26, 0x00, 0x71, 0x68, 0xff, 0x13, 0x06, 0x00, 0x52,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x04, 0xa3, 0x01, 0x75, 0x13, 0x06,
+  0x00, 0x32, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x48, 0x10, 0x26, 0x02, 0x9a, 0x68, 0x00,
+  0x13, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6b, 0x10, 0x27, 0x10, 0xf4, 0x04, 0xa3,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x27, 0x02, 0x9f, 0x00, 0x90,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x02, 0x00, 0x67,
+  0x00, 0x00, 0x07, 0x3e, 0x05, 0xd5, 0x00, 0x10, 0x00, 0x19, 0x00, 0x00,
+  0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x17, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x33, 0x07, 0x2e, 0xfd, 0x64, 0x02, 0x80, 0xfd, 0x80, 0x02, 0xac,
+  0xfc, 0x42, 0xfe, 0x7a, 0xfe, 0x6e, 0x01, 0x92, 0x01, 0x86, 0x5c, 0x74,
+  0xfe, 0xdf, 0xfe, 0xe0, 0x01, 0x20, 0x01, 0x21, 0x74, 0x05, 0xd5, 0xaa,
+  0xfe, 0x46, 0xaa, 0xfd, 0xe3, 0xaa, 0x01, 0x7c, 0x01, 0x70, 0x01, 0x6d,
+  0x01, 0x7c, 0xaa, 0xfe, 0xe1, 0xfe, 0xe0, 0xfe, 0xdf, 0xfe, 0xdf, 0x00,
+  0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x06, 0xfd, 0x04, 0x7b, 0x00, 0x06,
+  0x00, 0x27, 0x00, 0x33, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x07, 0x05, 0x15, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10,
+  0x12, 0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x25, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x06, 0x56,
+  0x02, 0x94, 0x7b, 0x8a, 0xa6, 0x0d, 0x02, 0xf4, 0xfd, 0x07, 0x0b, 0xb7,
+  0xa5, 0x5f, 0xb4, 0x59, 0x5a, 0xbc, 0x5f, 0x90, 0xda, 0x49, 0x40, 0xbc,
+  0x7e, 0xd9, 0xf5, 0xf5, 0xd9, 0x7e, 0xbe, 0x3c, 0x46, 0xd1, 0x80, 0xcc,
+  0xed, 0xfb, 0x38, 0x85, 0x9b, 0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x02, 0x94,
+  0x98, 0xb3, 0xae, 0x9e, 0x35, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a,
+  0x2c, 0x6e, 0x6d, 0x6e, 0x6d, 0x01, 0x39, 0x01, 0x13, 0x01, 0x14, 0x01,
+  0x38, 0x6f, 0x6c, 0x6b, 0x70, 0xfe, 0xdd, 0x87, 0xe7, 0xc9, 0xc9, 0xe7,
+  0xe8, 0xc8, 0xc7, 0xe9, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
+  0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x20, 0x01, 0x76, 0x12, 0x06,
+  0x00, 0x35, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x39,
+  0x06, 0x6d, 0x10, 0x26, 0x00, 0x76, 0x3b, 0x07, 0x12, 0x06, 0x00, 0x55,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x1e, 0x04, 0xcc,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x8e, 0x00, 0x0a, 0x12, 0x06,
+  0x00, 0x35, 0x00, 0x00, 0xff, 0xff, 0x00, 0x75, 0xfe, 0x1e, 0x02, 0xf6,
+  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd7, 0x02, 0xc9, 0x00, 0x0a, 0x12, 0x06,
+  0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
+  0x07, 0x5f, 0x12, 0x26, 0x00, 0x35, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0,
+  0x04, 0x0a, 0x01, 0x67, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0x05, 0x06, 0x66, 0x12, 0x26, 0x00, 0x55, 0x00, 0x00,
+  0x11, 0x06, 0x02, 0x89, 0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x20,
+  0x01, 0x76, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
+  0xff, 0xe3, 0x03, 0x67, 0x06, 0x6d, 0x10, 0x26, 0x00, 0x76, 0x3c, 0x07,
+  0x12, 0x06, 0x00, 0x56, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0x1e,
+  0x01, 0x75, 0x13, 0x06, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x06, 0x66, 0x10, 0x26,
+  0x02, 0x88, 0x21, 0x00, 0x13, 0x06, 0x00, 0x56, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x79, 0xfe, 0x75, 0x04, 0x2c, 0x05, 0xf0, 0x12, 0x26,
+  0x00, 0x36, 0x00, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x7d, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xfe, 0x75, 0x03, 0x67, 0x04, 0x7b, 0x12, 0x26,
+  0x00, 0x56, 0x00, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x15, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6d, 0x12, 0x26,
+  0x00, 0x36, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x04, 0x17, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x56, 0x00, 0x00, 0x11, 0x07, 0x02, 0xbd,
+  0x03, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
+  0xfe, 0x75, 0x04, 0x6c, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x7a, 0x48, 0x00,
+  0x12, 0x06, 0x00, 0x37, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31,
+  0xfe, 0x75, 0x02, 0xa7, 0x05, 0x9e, 0x10, 0x26, 0x00, 0x7a, 0xe4, 0x00,
+  0x12, 0x06, 0x00, 0x57, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
+  0x00, 0x00, 0x04, 0x6c, 0x07, 0x5f, 0x12, 0x26, 0x00, 0x37, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xf0, 0x04, 0x01, 0x01, 0x67, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x31, 0x00, 0x00, 0x02, 0xb2, 0x06, 0x82, 0x12, 0x26,
+  0x00, 0x57, 0x00, 0x00, 0x11, 0x07, 0x10, 0xea, 0x01, 0xfe, 0x00, 0x70,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x33,
+  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x21, 0x05, 0x04,
+  0x70, 0xfe, 0x23, 0xef, 0xef, 0xb6, 0xef, 0xef, 0xfe, 0x23, 0x05, 0xd5,
+  0xaa, 0xfd, 0xc0, 0xaa, 0xfd, 0xbf, 0x02, 0x41, 0xaa, 0x02, 0x40, 0x00,
+  0x00, 0x01, 0x00, 0x31, 0x00, 0x00, 0x02, 0xa7, 0x05, 0x9e, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15,
+  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01,
+  0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55,
+  0xfe, 0xab, 0x01, 0x55, 0xfe, 0xab, 0x21, 0x22, 0x67, 0xab, 0xab, 0xbf,
+  0x49, 0x49, 0x79, 0x79, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2, 0x8f, 0xe9,
+  0x8e, 0xe9, 0x89, 0x27, 0x27, 0x9a, 0x50, 0x4f, 0xd2, 0xe9, 0x8e, 0xe9,
+  0x8f, 0x01, 0x3e, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0x70, 0x01, 0x75, 0x13, 0x06,
+  0x00, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c,
+  0xff, 0xe3, 0x03, 0xe9, 0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x76, 0x00,
+  0x13, 0x06, 0x00, 0x58, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
+  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x31, 0x10, 0x27, 0x00, 0x71, 0x00, 0xd6,
+  0x01, 0x3b, 0x13, 0x06, 0x00, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x05, 0xf5, 0x10, 0x26,
+  0x00, 0x71, 0x76, 0xff, 0x13, 0x06, 0x00, 0x58, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xf2, 0x04, 0x70, 0x01, 0x75, 0x13, 0x06, 0x00, 0x38, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
+  0x06, 0x48, 0x10, 0x26, 0x02, 0x9a, 0x76, 0x00, 0x13, 0x06, 0x00, 0x58,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x07, 0x6f, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9c,
+  0x00, 0xd8, 0x00, 0x69, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
+  0x06, 0xca, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x02, 0x9c,
+  0x70, 0xc4, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x07, 0x6b, 0x10, 0x27, 0x10, 0xf4, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
+  0x00, 0x38, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xef,
+  0x06, 0x66, 0x10, 0x27, 0x02, 0x9f, 0x00, 0x9e, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x75, 0x04, 0xa5,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9d,
+  0x00, 0xe1, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x75, 0x04, 0x6b,
+  0x04, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9d,
+  0x01, 0xf0, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
+  0x07, 0x74, 0x10, 0x27, 0x10, 0xef, 0x05, 0x5c, 0x01, 0x7c, 0x13, 0x06,
+  0x00, 0x3a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d,
+  0x00, 0x00, 0x05, 0x97, 0x06, 0x6d, 0x10, 0x27, 0x02, 0x88, 0x01, 0x24,
+  0x00, 0x07, 0x13, 0x06, 0x00, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x07, 0x74, 0x10, 0x27,
+  0x10, 0xef, 0x04, 0x00, 0x01, 0x7c, 0x13, 0x06, 0x00, 0x3c, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x06, 0x6d, 0x10, 0x26, 0x02, 0x88, 0x55, 0x07, 0x13, 0x06, 0x00, 0x5c,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
+  0x07, 0x4e, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb,
+  0x04, 0x01, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
+  0x00, 0x00, 0x04, 0x9c, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x20,
+  0x01, 0x76, 0x12, 0x06, 0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
+  0x00, 0x00, 0x03, 0x79, 0x06, 0x6d, 0x10, 0x26, 0x00, 0x76, 0x3c, 0x07,
+  0x12, 0x06, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
+  0x00, 0x00, 0x04, 0x9c, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x45,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
+  0x00, 0x00, 0x03, 0x79, 0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xae,
+  0x00, 0x00, 0x13, 0x06, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x07, 0x6d, 0x12, 0x26,
+  0x00, 0x3d, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf0, 0x04, 0x45, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x5d, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89, 0x18, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac, 0x06, 0x14, 0x00, 0x10,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x01, 0x6f, 0xa6, 0x9f, 0x9f,
+  0x9c, 0xaa, 0x9d, 0x9e, 0x5a, 0x22, 0x23, 0x03, 0xd1, 0x8f, 0x4e, 0xbb,
+  0xab, 0x99, 0x28, 0x29, 0x67, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x1c,
+  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x0f, 0x00, 0x2c, 0x00, 0x00,
+  0x01, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x15, 0x23, 0x11,
+  0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x21, 0x15, 0x21, 0x03, 0x81, 0x4b,
+  0x4b, 0x83, 0x84, 0x4b, 0x4b, 0x4b, 0x4b, 0x84, 0x83, 0x4b, 0x4b, 0xfd,
+  0xcd, 0x34, 0x50, 0x4f, 0x6f, 0xb8, 0x72, 0x73, 0x73, 0x72, 0xb8, 0x6f,
+  0x4f, 0x50, 0x34, 0xa7, 0x8a, 0x8a, 0xa7, 0x01, 0x24, 0xfe, 0xdc, 0x02,
+  0x2f, 0xcb, 0x74, 0x73, 0x73, 0x74, 0xcb, 0xcb, 0x74, 0x73, 0x73, 0x74,
+  0x02, 0x52, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0xfe, 0xf8, 0xfe, 0xf8, 0xa2,
+  0xa2, 0x31, 0x30, 0x64, 0xa8, 0x05, 0x04, 0x7d, 0x93, 0x93, 0x7d, 0x00,
+  0x00, 0x03, 0xff, 0xa1, 0x00, 0x00, 0x04, 0xc8, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x11, 0x00, 0x29, 0x00, 0x00, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x01, 0x11, 0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14,
+  0x06, 0x23, 0x21, 0x11, 0x22, 0x06, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x36,
+  0x01, 0xc5, 0x01, 0x23, 0x93, 0x8d, 0x8d, 0x93, 0xfe, 0xdd, 0x01, 0x0d,
+  0x85, 0x83, 0x83, 0x85, 0xfe, 0x3d, 0x01, 0xd0, 0xd0, 0xe1, 0x73, 0x70,
+  0x87, 0x94, 0xf5, 0xe2, 0xfe, 0x1e, 0x77, 0x6a, 0x8c, 0xac, 0x02, 0xc9,
+  0xfd, 0xdd, 0x87, 0x8b, 0x8c, 0x85, 0x02, 0x66, 0xfe, 0x3e, 0x6f, 0x72,
+  0x71, 0x70, 0xa6, 0xc0, 0xb1, 0x89, 0xa2, 0x14, 0x20, 0xcb, 0x98, 0xc8,
+  0xda, 0x05, 0x30, 0x5f, 0x69, 0x31, 0x46, 0xb5, 0xa3, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x06,
+  0x03, 0xa5, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0xe3, 0x04, 0x2e,
+  0x06, 0x14, 0x00, 0x16, 0x00, 0x26, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x15, 0x23, 0x11, 0x21, 0x15, 0x25, 0x01, 0x34, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x01,
+  0x4e, 0x34, 0x50, 0x4f, 0x6f, 0xb8, 0x72, 0x73, 0x73, 0x72, 0xb8, 0x6f,
+  0x4f, 0x50, 0x34, 0xa7, 0x02, 0xfa, 0xfd, 0xad, 0x02, 0x33, 0x4b, 0x4b,
+  0x83, 0x84, 0x4b, 0x4b, 0x4b, 0x4b, 0x84, 0x83, 0x4b, 0x4b, 0x03, 0xb6,
+  0x64, 0x30, 0x31, 0xa2, 0xa2, 0xfe, 0xf8, 0xfe, 0xf8, 0xa2, 0xa2, 0x31,
+  0x30, 0x64, 0xa8, 0x06, 0x14, 0xa6, 0x01, 0xfc, 0xc0, 0xcb, 0x74, 0x73,
+  0x73, 0x74, 0xcb, 0xcb, 0x74, 0x73, 0x73, 0x74, 0x00, 0x02, 0x00, 0x00,
+  0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11, 0x21, 0x32, 0x37, 0x36, 0x01,
+  0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x23, 0x01,
+  0x03, 0xae, 0x47, 0x46, 0x93, 0xfe, 0xdd, 0x01, 0x23, 0x93, 0x46, 0x47,
+  0xfd, 0xbd, 0x01, 0x2c, 0xe2, 0xf5, 0xf5, 0xe2, 0xfe, 0x1e, 0xb5, 0x01,
+  0x19, 0x01, 0xb7, 0x8b, 0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x04, 0xa8,
+  0xfd, 0x9a, 0xda, 0xde, 0xdd, 0xda, 0x04, 0x44, 0x01, 0x91, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x00, 0xff, 0xe3, 0x04, 0x2e, 0x06, 0x15, 0x00, 0x12,
+  0x00, 0x1e, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10,
+  0x02, 0x23, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x23, 0x01, 0x33, 0x01,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x01,
+  0x4e, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xa7,
+  0xa7, 0x01, 0x05, 0x49, 0x02, 0x33, 0x96, 0x83, 0x84, 0x96, 0x96, 0x84,
+  0x83, 0x96, 0x03, 0xb6, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
+  0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x04, 0x44, 0x01, 0xd1, 0xfc, 0x1a, 0xcb,
+  0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x19, 0x00, 0x00, 0x13, 0x3e,
+  0x01, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x22, 0x26, 0x27, 0x35,
+  0x1e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x06, 0x07,
+  0x68, 0x5d, 0xd5, 0x79, 0x01, 0x31, 0x01, 0x5f, 0xfe, 0xa1, 0xfe, 0xcf,
+  0x77, 0xd5, 0x5f, 0x5b, 0xd0, 0x75, 0xe7, 0xf4, 0xf4, 0xe7, 0x75, 0xd0,
+  0x5b, 0x05, 0x62, 0x47, 0x47, 0xfe, 0x61, 0xfe, 0x98, 0xfe, 0x99, 0xfe,
+  0x61, 0x48, 0x48, 0xd3, 0x5f, 0x5e, 0x01, 0x39, 0x01, 0x27, 0x01, 0x28,
+  0x01, 0x39, 0x5e, 0x5f, 0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x05, 0xb8,
+  0x07, 0x64, 0x00, 0x24, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x17, 0x16, 0x17, 0x36, 0x37,
+  0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x04, 0xa3, 0x5c, 0xd0, 0x75,
+  0xe6, 0xf5, 0xf5, 0xe6, 0x75, 0xd0, 0x5c, 0x5f, 0xd6, 0x76, 0xfe, 0xce,
+  0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x32, 0x56, 0x8c, 0x0c, 0x0b, 0x0e, 0x4b,
+  0x5c, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x05, 0x62, 0xd5, 0x5f, 0x5e, 0xfe,
+  0xc7, 0xfe, 0xd8, 0xfe, 0xd9, 0xfe, 0xc7, 0x5e, 0x5f, 0xd3, 0x48, 0x48,
+  0x01, 0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f, 0x24, 0x03, 0x04, 0xc3,
+  0x62, 0x7a, 0xaa, 0x96, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x52,
+  0x06, 0x14, 0x00, 0x22, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x17, 0x35, 0x34, 0x36, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x06, 0x03, 0x83, 0x46, 0x8d, 0x48, 0xa2, 0xb2,
+  0xb2, 0xa2, 0x48, 0x8d, 0x46, 0x45, 0x95, 0x53, 0xe4, 0xfe, 0xf4, 0x01,
+  0x0f, 0xeb, 0x40, 0x3f, 0x91, 0xa3, 0x3e, 0x2b, 0x5e, 0x45, 0x04, 0x7e,
+  0xf5, 0x2b, 0x2b, 0xe3, 0xcd, 0xcd, 0xe3, 0x2b, 0x2b, 0xaa, 0x24, 0x24,
+  0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x3a, 0x0c, 0x0f, 0xd6, 0xc0,
+  0x9c, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x09, 0x00, 0x00, 0x05, 0x28,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x92, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa1,
+  0x00, 0x00, 0x05, 0x79, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x1a, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x25, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x11, 0x22, 0x06, 0x1d, 0x01, 0x23,
+  0x35, 0x34, 0x36, 0x01, 0xc5, 0xdb, 0x01, 0x16, 0x01, 0x03, 0xfe, 0xfd,
+  0xfe, 0xea, 0xfe, 0x6f, 0x01, 0x75, 0x01, 0x87, 0x01, 0x6d, 0xfe, 0x91,
+  0xfe, 0x7b, 0xfe, 0x8b, 0x77, 0x6a, 0x8c, 0xac, 0x05, 0x2f, 0xfb, 0x77,
+  0x01, 0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17, 0xa6, 0xfe, 0x97, 0xfe,
+  0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x05, 0x30, 0x5f, 0x69, 0x31, 0x46, 0xb5,
+  0xa3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e,
+  0x05, 0xd5, 0x00, 0x07, 0x00, 0x14, 0x00, 0x00, 0x01, 0x10, 0x29, 0x01,
+  0x11, 0x21, 0x22, 0x06, 0x11, 0x21, 0x11, 0x21, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x33, 0x21, 0x11, 0x21, 0x01, 0x75, 0x01, 0x20, 0x01, 0x23, 0xfe,
+  0xdd, 0x93, 0x8d, 0x02, 0xf9, 0xfe, 0x1e, 0xe2, 0xf5, 0xf5, 0xe2, 0x01,
+  0x2c, 0xfd, 0xbd, 0x01, 0xb7, 0xfe, 0xef, 0x02, 0x23, 0x87, 0x03, 0x93,
+  0xfa, 0x2b, 0xda, 0xde, 0xdd, 0xda, 0x01, 0xc0, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0xeb, 0x06, 0x14, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x00,
+  0x13, 0x35, 0x21, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
+  0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x11, 0x01, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0xf2, 0x02, 0xf9, 0xa6, 0x34,
+  0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0xfd, 0xcc, 0x96,
+  0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x05, 0x6e, 0xa6, 0xf9, 0xec,
+  0xa8, 0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61,
+  0x64, 0x01, 0xb9, 0xfc, 0xc0, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7,
+  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x02, 0x04, 0x63, 0x00, 0x19,
+  0x00, 0x27, 0x00, 0x00, 0x25, 0x16, 0x15, 0x10, 0x21, 0x22, 0x27, 0x35,
+  0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x11, 0x10, 0x12,
+  0x33, 0x32, 0x12, 0x03, 0x14, 0x02, 0x03, 0x36, 0x26, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x3e, 0x01, 0x03, 0x14, 0x8d, 0xfe,
+  0x73, 0xc7, 0x6c, 0x5c, 0xdd, 0xde, 0xee, 0xbb, 0x69, 0x80, 0xf6, 0xd8,
+  0xd7, 0xf8, 0x01, 0x8c, 0x23, 0x01, 0x9a, 0x85, 0x85, 0x9b, 0xa9, 0x72,
+  0x39, 0x2e, 0x59, 0x63, 0x42, 0x4f, 0x8d, 0xfe, 0xf0, 0x46, 0x99, 0x46,
+  0x75, 0x5c, 0x30, 0x25, 0x70, 0x87, 0x01, 0x0f, 0x01, 0x0f, 0x01, 0x39,
+  0xfe, 0xc7, 0xfe, 0xed, 0x9c, 0xfe, 0xfc, 0x01, 0xa0, 0xcb, 0xe5, 0xe8,
+  0xc3, 0xc2, 0xc7, 0x0b, 0x06, 0x0e, 0x2a, 0xdc, 0x00, 0x01, 0x00, 0x75,
+  0x00, 0x00, 0x03, 0xd8, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x03, 0xd8,
+  0xfc, 0x9e, 0x02, 0xac, 0xfd, 0x80, 0x02, 0x80, 0xfd, 0x64, 0x05, 0xd5,
+  0xfa, 0x2b, 0xaa, 0x02, 0x1d, 0xaa, 0x01, 0xba, 0xaa, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x69, 0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x13,
+  0x00, 0x1a, 0x00, 0x00, 0x13, 0x21, 0x10, 0x02, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x37, 0x16, 0x12, 0x33, 0x32, 0x12, 0x37, 0x69, 0x04, 0x1b, 0xf8, 0xf6,
+  0x7e, 0xe2, 0x65, 0x64, 0xec, 0x84, 0x01, 0x3b, 0x01, 0x63, 0xfe, 0xae,
+  0xfe, 0xe5, 0xfe, 0xd8, 0xfe, 0xbb, 0xc6, 0x0c, 0xe5, 0xb6, 0xb6, 0xe6,
+  0x0b, 0x03, 0x0c, 0x01, 0x0c, 0x01, 0x32, 0x60, 0x5f, 0xd7, 0x46, 0x48,
+  0xfe, 0x67, 0xfe, 0x92, 0xfe, 0x9f, 0xfe, 0x5b, 0x01, 0xb7, 0xcc, 0xc3,
+  0xfe, 0xe4, 0x01, 0x1c, 0xc3, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x93,
+  0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x01, 0x2e,
+  0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23,
+  0x22, 0x06, 0x15, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x24,
+  0x35, 0x34, 0x36, 0x01, 0xa9, 0x76, 0x80, 0xf1, 0xcf, 0x50, 0xb5, 0x68,
+  0x67, 0xab, 0x4a, 0x89, 0x93, 0x8e, 0x86, 0xa4, 0x9c, 0x95, 0xa7, 0xb4,
+  0xab, 0x62, 0xb4, 0x4b, 0x5f, 0xb3, 0x55, 0xfc, 0xfe, 0xef, 0x92, 0x03,
+  0x25, 0x21, 0xab, 0x7c, 0xb2, 0xd1, 0x20, 0x20, 0xb4, 0x26, 0x24, 0x7b,
+  0x73, 0x70, 0x77, 0xa6, 0x95, 0x84, 0x8f, 0x96, 0x32, 0x31, 0xc3, 0x25,
+  0x25, 0xf2, 0xdd, 0x90, 0xc4, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xa0,
+  0xfe, 0x66, 0x03, 0xba, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x36, 0x35, 0xb5, 0x03, 0x04, 0xfd, 0xb2, 0x02, 0x15, 0xfd,
+  0xeb, 0xb9, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x05, 0xd5, 0xaa, 0xfe, 0x48,
+  0xaa, 0xfd, 0x9f, 0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0x8b, 0xfe, 0x56, 0x02, 0xac, 0x06, 0x14, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21,
+  0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x23,
+  0x35, 0x33, 0x35, 0x34, 0x36, 0x33, 0x02, 0xac, 0x9e, 0x5a, 0x45, 0x01,
+  0x11, 0xfe, 0xef, 0x9c, 0xab, 0x9c, 0x9e, 0x59, 0x46, 0x9f, 0x9f, 0x9c,
+  0xaa, 0x06, 0x14, 0x99, 0x50, 0x68, 0x63, 0x8f, 0xfb, 0xeb, 0xbb, 0xab,
+  0x99, 0x50, 0x68, 0x04, 0x2a, 0x8f, 0x4e, 0xbb, 0xab, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x05, 0xef, 0x07, 0x64, 0x00, 0x26,
+  0x00, 0x00, 0x25, 0x11, 0x21, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x34, 0x36, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11,
+  0x10, 0x12, 0x33, 0x32, 0x36, 0x04, 0x49, 0xfe, 0xd7, 0x01, 0xdd, 0x69,
+  0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01, 0x3b, 0x51, 0x93,
+  0x3e, 0xb5, 0xcc, 0x45, 0x38, 0x79, 0x63, 0x65, 0xe3, 0x7d, 0xf6, 0xf8,
+  0xf8, 0xf6, 0x61, 0x97, 0xd5, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53, 0x55,
+  0x01, 0x99, 0x01, 0x6d, 0x01, 0x6e, 0x01, 0x99, 0x19, 0x19, 0xbc, 0xea,
+  0xaa, 0x96, 0xc2, 0xd7, 0x5f, 0x60, 0xfe, 0xce, 0xfe, 0xd1, 0xfe, 0xd2,
+  0xfe, 0xce, 0x25, 0x00, 0x00, 0x02, 0x00, 0x07, 0xfe, 0x52, 0x04, 0xeb,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x25, 0x00, 0x00, 0x01, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x13, 0x01, 0x33, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x33, 0x02, 0x79,
+  0x31, 0x27, 0x19, 0x1c, 0x2e, 0x27, 0x28, 0x2e, 0x1c, 0x19, 0x28, 0x31,
+  0x01, 0xa9, 0xc8, 0xfd, 0xf5, 0x5d, 0x3c, 0x2a, 0x44, 0x5a, 0x8b, 0x8b,
+  0x5b, 0x43, 0x29, 0x3d, 0x5d, 0xfd, 0xf4, 0xc8, 0xfe, 0xfd, 0x20, 0x14,
+  0x42, 0x39, 0x49, 0x79, 0x5c, 0x5c, 0x79, 0x49, 0x39, 0x42, 0x14, 0x20,
+  0x03, 0x7a, 0x03, 0x5e, 0xfb, 0xcf, 0xc8, 0xae, 0x77, 0x42, 0x8b, 0x41,
+  0x57, 0x57, 0x41, 0x8b, 0x42, 0x77, 0xae, 0xc8, 0x04, 0x31, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x8d, 0x06, 0x14, 0x00, 0x2a,
+  0x00, 0x00, 0x25, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x35,
+  0x16, 0x17, 0x16, 0x11, 0x14, 0x00, 0x2b, 0x01, 0x22, 0x26, 0x35, 0x11,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x11, 0x3e,
+  0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x16, 0x33, 0x04, 0xc4, 0x86,
+  0x4c, 0x4e, 0x42, 0x38, 0x6d, 0xca, 0x62, 0x64, 0xfe, 0xfd, 0xc7, 0x3f,
+  0xa9, 0x8d, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0xa1, 0x6a, 0xad,
+  0xb3, 0x44, 0x5e, 0x9c, 0x62, 0x65, 0x9b, 0xde, 0x70, 0x5f, 0x21, 0x94,
+  0x1d, 0x8f, 0x91, 0xfe, 0xec, 0xf5, 0xfe, 0xe6, 0xc8, 0xce, 0x01, 0x08,
+  0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x06, 0x14, 0xfd, 0x9e, 0x65, 0x64,
+  0xef, 0xe8, 0xfe, 0xf2, 0x93, 0x67, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x02, 0x7f, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x11, 0xb5, 0xb6,
+  0x63, 0x78, 0x39, 0x45, 0xcd, 0xb8, 0x05, 0xd5, 0xfc, 0x2d, 0xc2, 0x96,
+  0xaa, 0xf4, 0x01, 0x0e, 0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x02, 0x17,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x15, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0xac, 0xac, 0xb6, 0xac,
+  0xac, 0x05, 0xd5, 0xfd, 0x16, 0xaa, 0xfd, 0xbf, 0x02, 0x41, 0xaa, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x5f, 0x05, 0xf0, 0x00, 0x17,
+  0x00, 0x00, 0x01, 0x23, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x09, 0x01,
+  0x23, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x05, 0x5e, 0x99, 0x41, 0x23, 0x3f, 0x21, 0xfe, 0x14, 0x02,
+  0xca, 0xef, 0xfd, 0x7b, 0xb6, 0xb6, 0x02, 0x2e, 0x4c, 0x66, 0x7a, 0x4d,
+  0x4c, 0x04, 0x48, 0x79, 0x36, 0x50, 0x23, 0xfd, 0xf9, 0xfc, 0xe3, 0x02,
+  0xcf, 0xfd, 0x31, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x43, 0x4f, 0x5c, 0x5b,
+  0x6e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa6, 0x00, 0x00, 0x04, 0x26,
+  0x06, 0x14, 0x00, 0x12, 0x00, 0x00, 0x13, 0x34, 0x36, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x06, 0x15, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
+  0x23, 0xa6, 0x93, 0xa3, 0xac, 0x97, 0x5f, 0x44, 0x01, 0xee, 0xd4, 0xfd,
+  0xe9, 0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa7, 0x04, 0x7e, 0xd6, 0xc0, 0x9c,
+  0x61, 0x99, 0xfd, 0xff, 0x01, 0xe3, 0xfd, 0xf4, 0xfd, 0xac, 0x02, 0x23,
+  0xfd, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x01, 0xf3,
+  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x15, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xae, 0xa5, 0xa0, 0xa0, 0xa5, 0xa5,
+  0xa5, 0x06, 0x14, 0xfd, 0x38, 0x90, 0xfd, 0x44, 0x02, 0xbc, 0x90, 0x00,
+  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x0f,
+  0x00, 0x00, 0x33, 0x01, 0x27, 0x05, 0x27, 0x25, 0x27, 0x33, 0x17, 0x25,
+  0x17, 0x05, 0x01, 0x23, 0x09, 0x01, 0x37, 0x01, 0xba, 0x40, 0xfe, 0xf2,
+  0x1e, 0x01, 0x0b, 0x43, 0xb4, 0x2f, 0x01, 0x1a, 0x1e, 0xfe, 0xe8, 0x01,
+  0xbc, 0xb0, 0xfe, 0xe6, 0xfe, 0xa4, 0x04, 0x32, 0xbc, 0x65, 0x63, 0x63,
+  0xc5, 0x8a, 0x68, 0x61, 0x68, 0xfa, 0xd7, 0x03, 0x3c, 0xfc, 0xc4, 0x00,
+  0x00, 0x01, 0x00, 0xa0, 0xff, 0xe3, 0x06, 0x70, 0x05, 0xd5, 0x00, 0x27,
+  0x00, 0x00, 0x25, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33,
+  0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35,
+  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x03, 0x49, 0x3f, 0xac, 0x75, 0x9e,
+  0x55, 0x56, 0xb7, 0x23, 0x33, 0x6a, 0x80, 0x96, 0xb6, 0x34, 0x33, 0x6b,
+  0x6f, 0x4a, 0x4b, 0xb7, 0xb7, 0x39, 0x9e, 0x6d, 0x6e, 0x4d, 0x4c, 0xd5,
+  0x7c, 0x76, 0x7b, 0x7a, 0xe2, 0x04, 0x1b, 0xfb, 0xef, 0xba, 0x35, 0x4e,
+  0xbe, 0xa4, 0x03, 0xec, 0xfb, 0xef, 0xa2, 0x4e, 0x4d, 0x5f, 0x60, 0xa3,
+  0x03, 0xec, 0xfa, 0x29, 0xae, 0x67, 0x62, 0x3e, 0x3e, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xa0, 0xfe, 0x66, 0x04, 0xae, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11, 0x23, 0x01, 0x11, 0x10,
+  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0xb5, 0xf5, 0x02, 0x54,
+  0xb0, 0xf5, 0xfd, 0xac, 0xb8, 0xcc, 0x40, 0x38, 0x79, 0x63, 0x05, 0xd5,
+  0xfb, 0x1f, 0x04, 0xe1, 0xfa, 0x2b, 0x04, 0xe1, 0xfb, 0x87, 0xfe, 0xf2,
+  0xf4, 0xaa, 0x96, 0xc2, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x04, 0x7b, 0x10, 0x06, 0x03, 0x4b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x19,
+  0x00, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x01, 0x22, 0x02, 0x07, 0x21, 0x26, 0x02, 0x01, 0x1a, 0x01,
+  0x33, 0x32, 0x12, 0x13, 0x68, 0x01, 0x53, 0x01, 0x1b, 0x01, 0x1b, 0x01,
+  0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad, 0x02, 0x6f, 0xb6,
+  0xe6, 0x0b, 0x03, 0x4e, 0x0c, 0xe5, 0xfd, 0x9a, 0x07, 0xe2, 0xc6, 0xc6,
+  0xe0, 0x07, 0x02, 0xe9, 0x01, 0x62, 0x01, 0xa5, 0xfe, 0x5b, 0xfe, 0x9f,
+  0xfe, 0x9e, 0xfe, 0x5b, 0x01, 0xa4, 0x03, 0xc5, 0xfe, 0xe4, 0xc3, 0xc3,
+  0x01, 0x1c, 0xfd, 0x7a, 0xfe, 0xff, 0xfe, 0xc2, 0x01, 0x3d, 0x01, 0x02,
+  0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81, 0x06, 0x14, 0x10, 0x26,
+  0x00, 0x32, 0xf5, 0x00, 0x10, 0x07, 0x02, 0xcc, 0x05, 0x11, 0x01, 0x34,
+  0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58, 0x04, 0xeb, 0x10, 0x27,
+  0x02, 0xcc, 0x03, 0xe9, 0x00, 0x0b, 0x10, 0x06, 0x00, 0x52, 0x04, 0x00,
+  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x06, 0x21, 0x05, 0xf0, 0x00, 0x14,
+  0x00, 0x1f, 0x00, 0x00, 0x21, 0x11, 0x34, 0x26, 0x23, 0x11, 0x06, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x17, 0x21, 0x32, 0x16, 0x19,
+  0x01, 0x01, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x37, 0x11, 0x26,
+  0x05, 0x6b, 0x63, 0x6e, 0xa9, 0xfe, 0xe4, 0xfe, 0xe6, 0xfe, 0xad, 0x01,
+  0x53, 0x01, 0x1b, 0x65, 0x57, 0x01, 0x0a, 0xcc, 0xb9, 0xfc, 0xb5, 0xc6,
+  0xe9, 0xe9, 0xc6, 0x9e, 0x73, 0x7c, 0x03, 0xd3, 0xc2, 0x96, 0xfb, 0x8b,
+  0xd3, 0x01, 0xa4, 0x01, 0x62, 0x01, 0x62, 0x01, 0xa5, 0x1b, 0xf4, 0xfe,
+  0xf2, 0xfc, 0x2d, 0x05, 0x4c, 0xfe, 0xb8, 0xfe, 0xe6, 0xfe, 0xe5, 0xfe,
+  0xb8, 0x67, 0x04, 0x18, 0x46, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0xd1, 0x04, 0x7b, 0x00, 0x16, 0x00, 0x21, 0x00, 0x00,
+  0x01, 0x11, 0x34, 0x27, 0x26, 0x23, 0x11, 0x06, 0x23, 0x22, 0x02, 0x11,
+  0x10, 0x12, 0x33, 0x32, 0x17, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x01,
+  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x11, 0x26, 0x04, 0x2a,
+  0x22, 0x22, 0x5e, 0x7c, 0xd8, 0xd9, 0xf5, 0xf5, 0xd9, 0x5a, 0x4a, 0xc2,
+  0xa3, 0x4a, 0x49, 0xfd, 0x64, 0x85, 0x9b, 0x9a, 0x86, 0x74, 0x3a, 0x4c,
+  0xfe, 0x56, 0x04, 0x74, 0x99, 0x31, 0x30, 0xfc, 0xbc, 0x9d, 0x01, 0x39,
+  0x01, 0x13, 0x01, 0x14, 0x01, 0x38, 0x1b, 0x60, 0x60, 0xd6, 0xfb, 0x8c,
+  0x05, 0x89, 0xe7, 0xc9, 0xc9, 0xe7, 0x3a, 0x02, 0xf0, 0x36, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xa1, 0x00, 0x00, 0x04, 0x73, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23,
+  0x11, 0x22, 0x06, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x36, 0x01, 0xc5, 0xe4,
+  0x7f, 0x8b, 0x8b, 0x7f, 0xfe, 0x66, 0x01, 0x9a, 0xe2, 0xe7, 0xe7, 0xe2,
+  0xe4, 0xb6, 0x77, 0x6a, 0x8c, 0xac, 0x05, 0x2f, 0xfd, 0xcf, 0x92, 0x87,
+  0x86, 0x92, 0xa6, 0xe3, 0xdb, 0xdd, 0xe2, 0xfd, 0xa8, 0x05, 0x30, 0x5f,
+  0x69, 0x31, 0x46, 0xb5, 0xa3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa6,
+  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00,
+  0x25, 0x11, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06,
+  0x1d, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
+  0x26, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x01, 0x4e, 0xa8, 0x93, 0xa3, 0xe5, 0xd0, 0x5f, 0x44, 0x34, 0x9f,
+  0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x01, 0xff, 0x96, 0x83, 0x84,
+  0x96, 0x96, 0x84, 0x83, 0x96, 0xa8, 0xfd, 0xae, 0x06, 0x28, 0xd6, 0xc0,
+  0x9c, 0x61, 0x99, 0xc8, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
+  0xfe, 0xbc, 0x61, 0x01, 0xeb, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7,
+  0x00, 0x02, 0x00, 0xb4, 0xfe, 0xf8, 0x04, 0xcc, 0x05, 0xd5, 0x00, 0x15,
+  0x00, 0x1d, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17, 0x13, 0x23, 0x03, 0x2e,
+  0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x03, 0x32,
+  0x3b, 0x6e, 0x38, 0xb9, 0xc4, 0xac, 0x42, 0x7d, 0x6c, 0xc6, 0xb6, 0xb6,
+  0xe4, 0xe7, 0xe2, 0x75, 0xfd, 0xc8, 0xe4, 0x7f, 0x8b, 0x8a, 0x80, 0x01,
+  0xb4, 0x16, 0x90, 0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96, 0x62, 0xfe, 0x91,
+  0x05, 0xd5, 0xfe, 0xf8, 0xd6, 0xd8, 0x8d, 0xba, 0x02, 0x4f, 0xfd, 0xd1,
+  0x92, 0x01, 0x0c, 0x91, 0x00, 0x01, 0x00, 0x66, 0xff, 0xe3, 0x04, 0x19,
+  0x05, 0xf0, 0x00, 0x21, 0x00, 0x00, 0x13, 0x36, 0x20, 0x16, 0x10, 0x06,
+  0x0f, 0x01, 0x0e, 0x01, 0x14, 0x16, 0x33, 0x32, 0x37, 0x15, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x34,
+  0x27, 0x26, 0x20, 0x07, 0xb8, 0xcd, 0x01, 0x98, 0xfb, 0xb5, 0xcc, 0x6e,
+  0x8b, 0x7a, 0xaa, 0x9b, 0xcb, 0xdf, 0xe9, 0xc1, 0xfd, 0x83, 0x82, 0xc1,
+  0xcc, 0x6d, 0x96, 0x36, 0x35, 0x50, 0x51, 0xfe, 0xc4, 0xcd, 0x05, 0xa4,
+  0x4c, 0xe4, 0xfe, 0x8f, 0xc0, 0x2d, 0x18, 0x1f, 0x7c, 0xec, 0x88, 0x8b,
+  0xd0, 0x5f, 0x70, 0x70, 0xd9, 0xb6, 0xd9, 0x2b, 0x19, 0x1f, 0x32, 0x33,
+  0xd9, 0x40, 0x40, 0x6d, 0x00, 0x01, 0x00, 0x5a, 0xff, 0xe3, 0x03, 0x5d,
+  0x04, 0x7b, 0x00, 0x27, 0x00, 0x00, 0x13, 0x3e, 0x01, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x0f, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3f,
+  0x01, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x90, 0x44,
+  0xa2, 0x5c, 0xba, 0xc9, 0x89, 0x9a, 0x39, 0x9a, 0x5b, 0x7e, 0x75, 0x57,
+  0xb3, 0x5b, 0x61, 0xaf, 0x51, 0xc3, 0xde, 0x94, 0xb1, 0x39, 0x85, 0x58,
+  0x7b, 0x7c, 0x51, 0x97, 0x46, 0x04, 0x3f, 0x1e, 0x1e, 0xac, 0x9e, 0x82,
+  0x95, 0x24, 0x0f, 0x25, 0x50, 0x4b, 0x51, 0x59, 0x35, 0x35, 0xbe, 0x23,
+  0x23, 0xb6, 0x9c, 0x89, 0x99, 0x2a, 0x0e, 0x21, 0x49, 0x40, 0x54, 0x54,
+  0x28, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
+  0x05, 0xd5, 0x10, 0x06, 0x03, 0x37, 0x00, 0x00, 0x00, 0x02, 0xff, 0x0d,
+  0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x16, 0x00, 0x1f, 0x00, 0x00,
+  0x01, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x11,
+  0x23, 0x22, 0x35, 0x34, 0x21, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x25,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x33, 0x01, 0x52, 0x45, 0x59,
+  0x9e, 0x9c, 0xaa, 0x9d, 0xab, 0xf3, 0x01, 0x11, 0xa3, 0x49, 0x30, 0x10,
+  0xac, 0xfe, 0xac, 0x08, 0x0e, 0x1e, 0x63, 0x70, 0x03, 0x02, 0x6b, 0x04,
+  0x6a, 0xfb, 0x3d, 0x68, 0x50, 0x99, 0xab, 0xbb, 0x04, 0xae, 0xd2, 0xd8,
+  0x60, 0x40, 0x6f, 0x9b, 0x9a, 0x2c, 0x18, 0x30, 0x41, 0x33, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x31, 0xfe, 0x56, 0x02, 0xa7, 0x05, 0x9e, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01,
+  0x15, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01,
+  0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55,
+  0xfe, 0xab, 0x43, 0x67, 0xab, 0x94, 0xa2, 0x3f, 0x2b, 0x60, 0x22, 0x22,
+  0xc0, 0x96, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2, 0x8f, 0xfd, 0xa0, 0x89,
+  0x4e, 0xae, 0xd6, 0xc0, 0x9c, 0x30, 0x31, 0x99, 0x14, 0x9f, 0xd2, 0x02,
+  0x60, 0x8f, 0x01, 0x3e, 0x00, 0x01, 0x00, 0x15, 0x00, 0x00, 0x04, 0x6c,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23,
+  0x11, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x36, 0x01, 0x83,
+  0x02, 0xe8, 0xfe, 0x23, 0xb6, 0x55, 0x77, 0x6a, 0x8c, 0xac, 0x05, 0xd5,
+  0xaa, 0xfa, 0xd5, 0x05, 0x2b, 0x5a, 0x69, 0x31, 0x46, 0xb5, 0xa3, 0x00,
+  0x00, 0x01, 0x00, 0x31, 0x00, 0x00, 0x02, 0xa7, 0x06, 0x14, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x15, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x01, 0x52, 0x01, 0x55, 0xfe, 0xab,
+  0x43, 0x67, 0xab, 0xab, 0xbf, 0x92, 0x79, 0x79, 0x9d, 0xaa, 0x9c, 0x9e,
+  0x59, 0x45, 0x04, 0xc3, 0x63, 0x8f, 0xfd, 0xa0, 0x89, 0x4e, 0x9a, 0x9f,
+  0xd2, 0x02, 0x60, 0x8f, 0x4e, 0xbb, 0xab, 0x99, 0x51, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xfa, 0xfe, 0x66, 0x04, 0x6c, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x26, 0x19, 0x01, 0x21, 0x05, 0x04, 0x70, 0xfe, 0x23, 0x63,
+  0x79, 0x39, 0x47, 0xcc, 0xb8, 0xfe, 0x23, 0x05, 0xd5, 0xaa, 0xfb, 0x3d,
+  0xc2, 0x96, 0xaa, 0xf4, 0x01, 0x0e, 0x04, 0xc3, 0xff, 0xff, 0x00, 0x9b,
+  0xff, 0xf7, 0x05, 0xbc, 0x06, 0x14, 0x10, 0x26, 0x00, 0x38, 0xfc, 0x14,
+  0x10, 0x07, 0x02, 0xcc, 0x05, 0x4d, 0x01, 0x34, 0xff, 0xff, 0x00, 0x9e,
+  0xff, 0xe3, 0x04, 0xdf, 0x04, 0xeb, 0x10, 0x27, 0x02, 0xcc, 0x04, 0x70,
+  0x00, 0x0b, 0x10, 0x06, 0x00, 0x58, 0x02, 0x00, 0x00, 0x01, 0x00, 0x46,
+  0xff, 0xe3, 0x05, 0x3b, 0x05, 0xca, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x21,
+  0x16, 0x12, 0x15, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x37,
+  0x21, 0x35, 0x21, 0x15, 0x06, 0x02, 0x15, 0x14, 0x12, 0x33, 0x32, 0x12,
+  0x35, 0x34, 0x02, 0x27, 0x35, 0x21, 0x05, 0x3a, 0xfe, 0xe0, 0x91, 0x80,
+  0xfe, 0xa6, 0xfe, 0xef, 0xfe, 0xed, 0xfe, 0xa8, 0x82, 0x8e, 0xfe, 0xe1,
+  0x02, 0x1c, 0xa0, 0xb3, 0xee, 0xc3, 0xc2, 0xee, 0xb2, 0xa0, 0x02, 0x1c,
+  0x05, 0x18, 0x8d, 0xfe, 0xd8, 0xc2, 0xfe, 0xcb, 0xfe, 0x77, 0x01, 0x8a,
+  0x01, 0x3e, 0xb8, 0x01, 0x2a, 0x8b, 0xb2, 0xb2, 0x61, 0xfe, 0xb4, 0xca,
+  0xef, 0xfe, 0xdd, 0x01, 0x22, 0xf0, 0xca, 0x01, 0x4c, 0x61, 0xb2, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xff, 0xe1, 0x04, 0xeb, 0x05, 0xd5, 0x00, 0x1b,
+  0x00, 0x00, 0x25, 0x32, 0x12, 0x35, 0x34, 0x27, 0x26, 0x27, 0x35, 0x17,
+  0x16, 0x12, 0x15, 0x10, 0x07, 0x06, 0x21, 0x27, 0x26, 0x27, 0x26, 0x19,
+  0x01, 0x33, 0x11, 0x14, 0x16, 0x33, 0x02, 0x7f, 0xc2, 0xee, 0x59, 0x3b,
+  0x63, 0xa2, 0x90, 0x80, 0xad, 0xac, 0xfe, 0xee, 0x45, 0xd1, 0x57, 0x5d,
+  0xb6, 0x63, 0x78, 0x8d, 0x01, 0x22, 0xf0, 0xca, 0xa6, 0x6d, 0x57, 0x44,
+  0x01, 0x8d, 0xfe, 0xd8, 0xc2, 0xfe, 0xcb, 0xc5, 0xc4, 0x02, 0x06, 0x74,
+  0x7a, 0x01, 0x0e, 0x03, 0xf0, 0xfc, 0x10, 0xc2, 0x96, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xfc, 0x00, 0x00, 0x05, 0x58, 0x05, 0xf0, 0x00, 0x17,
+  0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x07, 0x01, 0x11, 0x23, 0x11, 0x01,
+  0x33, 0x09, 0x01, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x23, 0x35,
+  0x34, 0x26, 0x04, 0x5b, 0x33, 0x13, 0x22, 0x0f, 0xfe, 0xaa, 0xb6, 0xfe,
+  0x24, 0xc4, 0x01, 0x74, 0x01, 0x2d, 0x51, 0x93, 0x7a, 0x4d, 0x4c, 0x99,
+  0x42, 0x05, 0x47, 0x0e, 0x18, 0x19, 0xfd, 0xbf, 0xfd, 0x39, 0x02, 0xc7,
+  0x03, 0x0e, 0xfd, 0x9a, 0x01, 0xf9, 0x88, 0x5c, 0x5b, 0x6e, 0x83, 0x79,
+  0x36, 0x50, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36, 0xfe, 0x56, 0x05, 0x43,
+  0x04, 0x7b, 0x00, 0x1f, 0x00, 0x00, 0x05, 0x0e, 0x01, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x36, 0x3f, 0x01, 0x01, 0x33, 0x01, 0x13, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x16, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x07, 0x02, 0x51, 0x46, 0x85, 0x70, 0x84, 0x61, 0x44, 0x4c, 0x2e,
+  0x1e, 0xfe, 0x68, 0xaf, 0x01, 0x3b, 0xfe, 0x13, 0x2b, 0x4f, 0x7a, 0x76,
+  0xa6, 0xa0, 0x49, 0x33, 0x33, 0x25, 0x12, 0x09, 0x68, 0xc8, 0x7a, 0x9a,
+  0x48, 0x86, 0x54, 0x04, 0x4e, 0xfc, 0x94, 0x02, 0xc0, 0x34, 0x33, 0x60,
+  0xbf, 0x86, 0x72, 0x72, 0x3a, 0x54, 0x2a, 0x14, 0x19, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x33, 0x15, 0x21, 0x01, 0x21, 0x15,
+  0x21, 0x35, 0x01, 0x21, 0x35, 0x21, 0x01, 0x21, 0x68, 0x04, 0x1f, 0xfe,
+  0x98, 0xfd, 0xfe, 0x9b, 0xfe, 0x7f, 0x03, 0x66, 0xfb, 0xb7, 0x01, 0x8d,
+  0xfe, 0xf3, 0x01, 0x75, 0x01, 0x5c, 0xfc, 0xc4, 0x05, 0xd5, 0x9a, 0xfe,
+  0x11, 0x90, 0xfd, 0xee, 0xaa, 0x9a, 0x02, 0x22, 0x90, 0x01, 0xdf, 0x00,
+  0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79, 0x04, 0x60, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x03, 0x33, 0x15, 0x21, 0x01, 0x21, 0x15,
+  0x21, 0x35, 0x01, 0x23, 0x35, 0x21, 0x13, 0x21, 0x66, 0x03, 0x12, 0xe2,
+  0xaf, 0xfe, 0xe2, 0xfe, 0xe3, 0x02, 0x6e, 0xfc, 0xd7, 0x01, 0x0d, 0xbe,
+  0x01, 0x2e, 0xf2, 0xfd, 0xa8, 0x04, 0x60, 0xa8, 0xfe, 0xdc, 0x90, 0xfe,
+  0x8f, 0x93, 0xa8, 0x01, 0x5c, 0x90, 0x01, 0x39, 0x00, 0x01, 0x00, 0x90,
+  0xff, 0xc1, 0x04, 0x79, 0x05, 0xd5, 0x00, 0x22, 0x00, 0x00, 0x25, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x35,
+  0x21, 0x15, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x02, 0x64, 0xad,
+  0x59, 0x5a, 0x53, 0x54, 0x94, 0x9d, 0x01, 0x5b, 0xfd, 0x49, 0x03, 0x9a,
+  0xfe, 0x8e, 0x5f, 0x73, 0x58, 0x4e, 0x49, 0x89, 0x89, 0xfc, 0x6b, 0x70,
+  0x72, 0x78, 0x5f, 0x72, 0x72, 0x6b, 0x4b, 0x4b, 0x8f, 0x86, 0x49, 0x4a,
+  0x98, 0x01, 0xea, 0xaa, 0x9a, 0xfe, 0x16, 0x38, 0x2a, 0x6d, 0x68, 0x8a,
+  0xdc, 0x7a, 0x79, 0x13, 0x12, 0x25, 0xc3, 0x31, 0x19, 0x19, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x52, 0xff, 0xc1, 0x04, 0x3c, 0x05, 0xd5, 0x00, 0x22,
+  0x00, 0x00, 0x25, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x01, 0x35,
+  0x21, 0x15, 0x21, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x02, 0x68, 0x7b, 0x71, 0x73, 0x5f, 0x79, 0x71, 0x70, 0x6c, 0xfc,
+  0x88, 0x89, 0x49, 0x4d, 0x58, 0x73, 0x60, 0xfe, 0x8e, 0x03, 0x9a, 0xfd,
+  0x49, 0x01, 0x5a, 0x9c, 0x95, 0x54, 0x52, 0x5a, 0x59, 0x6b, 0x19, 0x19,
+  0x31, 0xc3, 0x25, 0x12, 0x13, 0x79, 0x7a, 0xdc, 0x8a, 0x68, 0x6d, 0x2a,
+  0x38, 0x01, 0xea, 0x9a, 0xaa, 0xfe, 0x16, 0x98, 0x4a, 0x49, 0x86, 0x8f,
+  0x4b, 0x4b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5d, 0xfe, 0x4c, 0x03, 0xd3,
+  0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x09, 0x01, 0x35, 0x21, 0x15, 0x21,
+  0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32,
+  0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23, 0x22, 0x24, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x02, 0x1f, 0xfe, 0x8e, 0x03, 0x12, 0xfd, 0xa8, 0x01,
+  0x83, 0x9c, 0x95, 0x54, 0x53, 0x5a, 0x5a, 0xab, 0x62, 0xb4, 0x4b, 0x5f,
+  0x5a, 0x59, 0x55, 0xfc, 0xfe, 0xef, 0x48, 0x4e, 0x58, 0x73, 0x01, 0xdc,
+  0x01, 0xdc, 0xa8, 0x93, 0xfe, 0x0d, 0xa6, 0x4a, 0x4b, 0x84, 0x8f, 0x4b,
+  0x4b, 0x32, 0x31, 0xc3, 0x25, 0x13, 0x12, 0xf2, 0xdd, 0x8a, 0x68, 0x6d,
+  0x2a, 0x38, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xfe, 0x56, 0x03, 0x84,
+  0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x01, 0x32, 0x37, 0x36, 0x37, 0x15,
+  0x06, 0x07, 0x06, 0x23, 0x20, 0x11, 0x34, 0x25, 0x24, 0x35, 0x34, 0x23,
+  0x30, 0x21, 0x01, 0x21, 0x35, 0x21, 0x15, 0x01, 0x20, 0x15, 0x10, 0x05,
+  0x06, 0x15, 0x14, 0x02, 0x3f, 0x4c, 0x45, 0x47, 0x49, 0x4e, 0x48, 0x4e,
+  0x57, 0xfe, 0x50, 0x01, 0x6d, 0x01, 0x00, 0xd4, 0xfe, 0xfc, 0x01, 0xb4,
+  0xfd, 0xa8, 0x03, 0x12, 0xfe, 0xc2, 0x01, 0x4a, 0xfe, 0x5e, 0xcb, 0xfe,
+  0xee, 0x15, 0x15, 0x2c, 0xb3, 0x20, 0x0d, 0x0e, 0x01, 0x19, 0xee, 0x35,
+  0x25, 0x62, 0x7c, 0x02, 0x38, 0x93, 0xa8, 0xfe, 0x64, 0xe5, 0xfe, 0xec,
+  0x31, 0x18, 0x61, 0x8b, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0xdd,
+  0x05, 0xf0, 0x00, 0x24, 0x00, 0x00, 0x25, 0x21, 0x15, 0x21, 0x35, 0x01,
+  0x37, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x33, 0x15, 0x23, 0x07, 0x01, 0x62, 0x02, 0x7a, 0xfc,
+  0xab, 0x01, 0x1b, 0x67, 0xfe, 0xca, 0x01, 0xb1, 0x56, 0x21, 0x23, 0x4a,
+  0x4c, 0x79, 0x55, 0x5f, 0x5f, 0x6c, 0x6e, 0xbf, 0x4f, 0xd1, 0xf8, 0x1f,
+  0x1c, 0x42, 0x5e, 0xd5, 0x2b, 0xaa, 0xaa, 0xaa, 0x01, 0x40, 0x75, 0x90,
+  0x6d, 0x48, 0x4c, 0x49, 0x77, 0x4b, 0x4b, 0x21, 0x21, 0x43, 0xcc, 0x31,
+  0x32, 0xe8, 0xc2, 0x5c, 0x52, 0x49, 0x60, 0x90, 0x31, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x53, 0xff, 0xc1, 0x04, 0x7a, 0x05, 0xd5, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x10, 0x20, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x11, 0x25, 0x36, 0x17, 0x16, 0x10, 0x0f, 0x01, 0x06, 0x07,
+  0x06, 0x20, 0x24, 0x35, 0x01, 0x09, 0x02, 0xbc, 0xa7, 0x94, 0xfe, 0x2b,
+  0x03, 0x44, 0xfd, 0x72, 0x01, 0x4e, 0xe6, 0x92, 0x49, 0x35, 0x1a, 0x11,
+  0x29, 0x89, 0xfd, 0xfd, 0xfe, 0xef, 0x01, 0x90, 0xfe, 0xdb, 0x01, 0x25,
+  0x86, 0x93, 0x03, 0x2c, 0xaa, 0xfe, 0x25, 0x01, 0x01, 0xd0, 0x68, 0xfe,
+  0xe0, 0x56, 0x29, 0x1d, 0x24, 0x79, 0xf2, 0xdd, 0x00, 0x01, 0x00, 0x5d,
+  0xfe, 0x4c, 0x03, 0xd3, 0x04, 0x60, 0x00, 0x1a, 0x00, 0x00, 0x17, 0x16,
+  0x33, 0x20, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x33, 0x32, 0x1e, 0x01, 0x10, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x5e, 0x98, 0xba, 0x01, 0x6d, 0xa6, 0x95, 0xfe, 0xc3, 0x02, 0xc9,
+  0xfd, 0xdc, 0xc7, 0x5f, 0xcd, 0x95, 0x35, 0x19, 0x12, 0x28, 0x89, 0xfc,
+  0xa9, 0xbe, 0xa7, 0x63, 0x01, 0x25, 0x86, 0x93, 0x03, 0x2c, 0xaa, 0xfe,
+  0x26, 0x63, 0xd4, 0xfe, 0xe0, 0x56, 0x29, 0x1d, 0x24, 0x79, 0x4a, 0x00,
+  0x00, 0x01, 0x00, 0x4f, 0xff, 0xe3, 0x03, 0x48, 0x05, 0x9e, 0x00, 0x24,
+  0x00, 0x00, 0x01, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x13, 0x23, 0x35, 0x33, 0x11, 0x33,
+  0x11, 0x33, 0x15, 0x01, 0xea, 0x01, 0x99, 0x64, 0x62, 0x63, 0x7c, 0xf7,
+  0x4d, 0x49, 0x48, 0x45, 0x42, 0x4b, 0x47, 0x48, 0xa1, 0x59, 0x33, 0x01,
+  0x34, 0x4d, 0xad, 0x38, 0x02, 0xce, 0xce, 0xb5, 0xd0, 0x03, 0xe6, 0x7d,
+  0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d, 0x9d, 0x12, 0x11, 0x23, 0xac, 0x28,
+  0x18, 0x16, 0x72, 0x41, 0x85, 0x62, 0x4c, 0x72, 0x01, 0x0f, 0xa4, 0x01,
+  0x14, 0xfe, 0xec, 0xa4, 0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e,
+  0x04, 0x7b, 0x00, 0x0e, 0x00, 0x17, 0x00, 0x00, 0x05, 0x11, 0x23, 0x11,
+  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x10, 0x01,
+  0x00, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x01, 0x4e, 0xa7, 0xa7,
+  0x2f, 0x79, 0x49, 0xbd, 0xa6, 0x45, 0x46, 0xfd, 0x21, 0x02, 0x33, 0x33,
+  0x32, 0x6c, 0xc6, 0x9c, 0x7a, 0xfe, 0xd0, 0x06, 0x0a, 0xaa, 0x42, 0x52,
+  0x31, 0x70, 0x71, 0x99, 0xfe, 0x57, 0xfe, 0xe4, 0x01, 0x90, 0xf9, 0x85,
+  0x42, 0x41, 0xef, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x01, 0x6b,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0xb5, 0xb6,
+  0xb6, 0x05, 0xd5, 0xf8, 0x81, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x56, 0x02, 0xd7, 0x05, 0xd5, 0x10, 0x27, 0x01, 0x82, 0x01, 0x6c,
+  0x00, 0x00, 0x10, 0x06, 0x01, 0x82, 0x00, 0x00, 0x00, 0x01, 0x00, 0x12,
+  0xfe, 0x56, 0x03, 0x40, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
+  0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x01, 0x4e, 0xb6, 0x01, 0x3c, 0xfe,
+  0xc4, 0x01, 0x3c, 0xfe, 0xc4, 0xb6, 0xfe, 0xc4, 0x01, 0x3c, 0xfe, 0xc4,
+  0x01, 0x3c, 0x05, 0xd5, 0xfd, 0x97, 0xa8, 0xf0, 0xaa, 0xfd, 0x2c, 0x02,
+  0xd4, 0xaa, 0xf0, 0xa8, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6c,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x04, 0x9f, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x09, 0xbc, 0x07, 0x6d, 0x10, 0x27, 0x01, 0x3f, 0x05, 0x1f,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x08, 0xb8, 0x06, 0x66, 0x10, 0x27, 0x01, 0x40, 0x05, 0x40,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x07, 0xb6, 0x06, 0x66, 0x10, 0x27, 0x01, 0x40, 0x04, 0x3d,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x66, 0x05, 0x87, 0x05, 0xd5, 0x10, 0x27, 0x00, 0x2d, 0x04, 0x1c,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x56, 0x05, 0x48, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x03, 0xf4,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0xfe, 0x56, 0x02, 0xa4, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x01, 0x51,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x66, 0x06, 0x41, 0x05, 0xd5, 0x10, 0x27, 0x00, 0x2d, 0x04, 0xd6,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x56, 0x06, 0x0c, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x04, 0xb8,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x05, 0x48, 0x06, 0x14, 0x10, 0x27, 0x00, 0x4d, 0x03, 0xf4,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xf0, 0x04, 0x45, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x44, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89, 0x51, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfe, 0x00, 0x00, 0x02, 0x24, 0x07, 0x6d, 0x12, 0x26,
+  0x00, 0x2c, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0, 0x02, 0xde, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe3, 0x00, 0x00, 0x02, 0x22,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00, 0x11, 0x07, 0x02, 0x89,
+  0xff, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf0, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x11, 0x06, 0x02, 0x89, 0x6a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
+  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xf0, 0x04, 0x77, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x11, 0x06, 0x02, 0x89, 0x6a, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x33, 0x10, 0x26,
+  0x11, 0x1e, 0x2b, 0x00, 0x12, 0x06, 0x00, 0x38, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0x6f, 0x01, 0x3b, 0x12, 0x06, 0x00, 0xbe, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x5a, 0x12, 0x26,
+  0x00, 0x38, 0x00, 0x00, 0x10, 0x06, 0x11, 0x21, 0x31, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x22, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x11, 0x21, 0xff, 0xc5, 0xfe, 0xc8,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x5a, 0x12, 0x26,
+  0x00, 0x38, 0x00, 0x00, 0x10, 0x06, 0x11, 0x26, 0x2b, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x22, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x11, 0x26, 0xff, 0xca, 0xfe, 0xc8,
+  0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5, 0x08, 0x60, 0x12, 0x26,
+  0x00, 0x38, 0x00, 0x00, 0x10, 0x06, 0x11, 0x22, 0x2b, 0x06, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x07, 0x22, 0x12, 0x26,
+  0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x11, 0x22, 0xff, 0xc5, 0xfe, 0xc8,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x06,
+  0x02, 0x1b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x08, 0x33, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x1e,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x07, 0x31, 0x12, 0x26, 0x00, 0xa6, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71,
+  0x00, 0x4a, 0x01, 0x3b, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x08, 0x33, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x20,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x06, 0xf4, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x11, 0x20,
+  0xff, 0x9e, 0xfe, 0xc1, 0xff, 0xff, 0x00, 0x07, 0x00, 0x00, 0x06, 0x8e,
+  0x07, 0x34, 0x10, 0x27, 0x00, 0x71, 0x02, 0x8e, 0x01, 0x3e, 0x12, 0x06,
+  0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xb1,
+  0x05, 0xf2, 0x10, 0x27, 0x00, 0x71, 0x01, 0xb7, 0xff, 0xfc, 0x12, 0x06,
+  0x00, 0xa8, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x6a,
+  0x05, 0xf0, 0x00, 0x25, 0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x23, 0x15,
+  0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17,
+  0x15, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36,
+  0x37, 0x35, 0x23, 0x35, 0x33, 0x35, 0x21, 0x35, 0x04, 0xfd, 0x6d, 0x6d,
+  0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01, 0x3b, 0x83,
+  0xed, 0x64, 0x65, 0xe3, 0x7d, 0xf6, 0xf8, 0xf8, 0xf6, 0x61, 0x97, 0x3c,
+  0xe4, 0xe4, 0xfe, 0xd7, 0x03, 0x0c, 0xfe, 0xd6, 0x58, 0xff, 0x53, 0x55,
+  0x01, 0x99, 0x01, 0x6d, 0x01, 0x6e, 0x01, 0x99, 0x48, 0x46, 0xd7, 0x5f,
+  0x60, 0xfe, 0xce, 0xfe, 0xd1, 0xfe, 0xd2, 0xfe, 0xce, 0x25, 0x27, 0xb5,
+  0x58, 0x84, 0xa6, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x7b,
+  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x34, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x17, 0x14, 0x07, 0x33,
+  0x15, 0x23, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
+  0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x36, 0x3d, 0x01, 0x0e,
+  0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35,
+  0x33, 0x03, 0x45, 0x95, 0x86, 0x85, 0x94, 0x94, 0x85, 0x86, 0x95, 0xa6,
+  0x11, 0xa1, 0xb3, 0x1c, 0x34, 0x72, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e,
+  0x4a, 0xa3, 0x51, 0x13, 0x0f, 0xfd, 0xc4, 0x02, 0x57, 0x14, 0x33, 0xa0,
+  0x70, 0xba, 0xe2, 0xe2, 0xba, 0x70, 0xa0, 0x33, 0xa6, 0x02, 0x3d, 0xc8,
+  0xdc, 0xdc, 0xc8, 0xc7, 0xdc, 0xdc, 0xeb, 0x6e, 0x58, 0x46, 0x5d, 0x40,
+  0x8c, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0x5f, 0x17, 0x1c, 0x45, 0x47, 0x5e,
+  0x5b, 0x63, 0x62, 0x01, 0x3a, 0x01, 0x03, 0x01, 0x04, 0x01, 0x3a, 0x62,
+  0x63, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe,
+  0x07, 0x6d, 0x12, 0x26, 0x00, 0x2a, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf0,
+  0x04, 0xc3, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x03, 0xeb, 0x06, 0x63, 0x10, 0x26, 0x02, 0x89, 0x43, 0xfd,
+  0x12, 0x06, 0x00, 0x4a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xe0, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x2b,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0xff, 0xeb,
+  0x00, 0x00, 0x04, 0x26, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x4e, 0x00, 0x00,
+  0x11, 0x07, 0x10, 0xf0, 0x02, 0xcb, 0x01, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xfe, 0x75, 0x05, 0x44, 0x05, 0xf0, 0x10, 0x27,
+  0x02, 0x9d, 0x01, 0x15, 0x00, 0x00, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x26,
+  0x02, 0x9d, 0x73, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xfe, 0x75, 0x05, 0x44, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x01, 0x0a, 0x01, 0x3b, 0x12, 0x06, 0x01, 0xac, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x03, 0x05, 0xf5, 0x10, 0x26,
+  0x00, 0x71, 0x68, 0xff, 0x12, 0x06, 0x01, 0xad, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x90, 0xff, 0xc1, 0x04, 0x79, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xf0, 0x04, 0x45, 0x01, 0x75, 0x12, 0x06, 0x01, 0x79, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0xc4, 0x06, 0x66, 0x10, 0x26,
+  0x02, 0x89, 0x18, 0x00, 0x10, 0x06, 0x02, 0x54, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x02, 0x27, 0x06, 0x66, 0x10, 0x27,
+  0x02, 0x89, 0xff, 0x3b, 0x00, 0x00, 0x11, 0x06, 0x01, 0xf9, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x09, 0xbc,
+  0x05, 0xd5, 0x10, 0x27, 0x00, 0x3d, 0x05, 0x1f, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x08, 0xb8,
+  0x05, 0xd5, 0x10, 0x27, 0x00, 0x5d, 0x05, 0x40, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x07, 0xb6,
+  0x06, 0x14, 0x10, 0x27, 0x00, 0x5d, 0x04, 0x3d, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe,
+  0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x98, 0x01, 0x76, 0x12, 0x06,
+  0x00, 0x2a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb,
+  0x06, 0x63, 0x12, 0x26, 0x00, 0x4a, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76,
+  0x18, 0xfd, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xff, 0xe3, 0x07, 0x5c,
+  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
+  0x11, 0x14, 0x17, 0x16, 0x17, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11,
+  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x21, 0x11, 0x23,
+  0xb5, 0xb6, 0x02, 0x94, 0xb6, 0x38, 0x37, 0x8a, 0x85, 0x3b, 0x38, 0xb6,
+  0x5a, 0x57, 0xfd, 0xf8, 0x5d, 0x5a, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd,
+  0x9c, 0x02, 0x64, 0xfb, 0xec, 0x9f, 0x50, 0x4e, 0x01, 0x4f, 0x4b, 0xa4,
+  0x02, 0x9f, 0xfd, 0x5a, 0xdf, 0x80, 0x78, 0x78, 0x76, 0xe9, 0x01, 0x0d,
+  0xfd, 0x39, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x82,
+  0x05, 0xf0, 0x00, 0x0e, 0x00, 0x17, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11,
+  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x10, 0x01,
+  0x00, 0x11, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x01, 0x6b, 0xb6, 0xb6,
+  0x32, 0x83, 0x4e, 0xcb, 0xb3, 0x4a, 0x4c, 0xfc, 0xe9, 0x02, 0x5d, 0x36,
+  0x36, 0x75, 0xd5, 0xa7, 0x9c, 0xfd, 0xba, 0x07, 0x7f, 0xb9, 0x48, 0x57,
+  0x35, 0x78, 0x7a, 0xa4, 0xfe, 0x37, 0xfe, 0xce, 0x01, 0xae, 0x01, 0x0c,
+  0x8f, 0x47, 0x46, 0xfe, 0xff, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xae, 0x07, 0x6b, 0x10, 0x27, 0x10, 0xee, 0x04, 0x9b,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0xf4, 0x06, 0x64, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x43, 0x00, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x73, 0x12, 0x26, 0x00, 0x87, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xec, 0x05, 0xb9, 0x01, 0x7d, 0xff, 0xff, 0x00, 0x6e,
+  0xff, 0xe3, 0x04, 0x60, 0x07, 0x73, 0x12, 0x26, 0x00, 0xa7, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xec, 0x05, 0x54, 0x01, 0x7d, 0xff, 0xff, 0x00, 0x07,
+  0x00, 0x00, 0x06, 0x8e, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x05, 0xb9,
+  0x01, 0x76, 0x12, 0x06, 0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
+  0xff, 0xe3, 0x06, 0xb1, 0x06, 0x63, 0x12, 0x26, 0x00, 0xa8, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x76, 0x01, 0x41, 0xff, 0xfd, 0xff, 0xff, 0x00, 0x5b,
+  0xff, 0xba, 0x05, 0x4f, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x7e,
+  0x01, 0x76, 0x12, 0x06, 0x00, 0x9a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x40,
+  0xff, 0xa2, 0x04, 0x26, 0x06, 0x63, 0x12, 0x26, 0x00, 0xba, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x76, 0x19, 0xfd, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x70, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf5, 0x04, 0x68, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x6e,
+  0xff, 0xe3, 0x03, 0xc3, 0x06, 0x64, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x22,
+  0xff, 0xfe, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x36, 0x12, 0x26, 0x00, 0x24, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf1, 0x04, 0x43, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x6e,
+  0xff, 0xe3, 0x03, 0xc3, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x03, 0xf4,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x70, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf5, 0x04, 0x2e, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x63, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x41,
+  0xff, 0xfd, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x07, 0x36, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf1, 0x04, 0x2f, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x04, 0x32,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0xff, 0xaf,
+  0x00, 0x00, 0x02, 0x35, 0x07, 0x70, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf5, 0x03, 0x03, 0x01, 0x7a, 0xff, 0xff, 0xff, 0xc9,
+  0x00, 0x00, 0x02, 0x41, 0x06, 0x63, 0x10, 0x27, 0x02, 0xc0, 0x03, 0x0f,
+  0xff, 0xfd, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0x00, 0x00, 0x02, 0x38, 0x07, 0x36, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf1, 0x02, 0xeb, 0x01, 0x3e, 0xff, 0xff, 0xff, 0xe5,
+  0x00, 0x00, 0x02, 0x1a, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x02, 0xd4,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0x70, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf5, 0x04, 0xba, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x64, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x29,
+  0xff, 0xfe, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0x36, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf1, 0x04, 0x99, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x04, 0x22,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb3,
+  0x00, 0x00, 0x04, 0xcc, 0x07, 0x70, 0x12, 0x26, 0x00, 0x35, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf5, 0x04, 0x06, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x75,
+  0x00, 0x00, 0x02, 0xf6, 0x06, 0x63, 0x10, 0x27, 0x02, 0xc0, 0x03, 0xbb,
+  0xff, 0xfd, 0x12, 0x06, 0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xcc, 0x07, 0x36, 0x12, 0x26, 0x00, 0x35, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf1, 0x04, 0x0d, 0x01, 0x3e, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0x08, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x03, 0xc2,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
+  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x70, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf5, 0x04, 0x93, 0x01, 0x7a, 0xff, 0xff, 0x00, 0x9c,
+  0xff, 0xe3, 0x03, 0xe9, 0x06, 0x64, 0x10, 0x27, 0x02, 0xc0, 0x04, 0x58,
+  0xff, 0xfe, 0x12, 0x06, 0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0,
+  0xff, 0xe3, 0x04, 0xa5, 0x07, 0x36, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf1, 0x04, 0x6e, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x9c,
+  0xff, 0xe3, 0x03, 0xe9, 0x06, 0x48, 0x10, 0x27, 0x02, 0xc2, 0x04, 0x34,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x14, 0x04, 0x2c, 0x05, 0xf0, 0x10, 0x27, 0x02, 0xd7, 0x04, 0x04,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
+  0xfe, 0x14, 0x03, 0x67, 0x04, 0x7b, 0x10, 0x27, 0x02, 0xd7, 0x03, 0xc1,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x56, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
+  0xfe, 0x14, 0x04, 0x6c, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd7, 0x03, 0xe4,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31,
+  0xfe, 0x14, 0x02, 0xa7, 0x05, 0x9e, 0x10, 0x27, 0x02, 0xd7, 0x03, 0x9a,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x57, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8c,
+  0xfe, 0x52, 0x04, 0x02, 0x05, 0xf0, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x04,
+  0x11, 0x14, 0x0e, 0x03, 0x07, 0x35, 0x36, 0x24, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x37, 0x3e, 0x03, 0x35, 0x34, 0x2e,
+  0x03, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x14,
+  0x0e, 0x02, 0x02, 0xec, 0x01, 0x15, 0x64, 0xa6, 0xe7, 0xfa, 0x8a, 0xb4,
+  0x01, 0x13, 0xa6, 0x53, 0x70, 0x65, 0x56, 0x67, 0x93, 0xdf, 0x36, 0x5c,
+  0x5e, 0x37, 0x20, 0x31, 0x44, 0x41, 0x22, 0xa5, 0xdb, 0xd7, 0xb9, 0x76,
+  0xb7, 0x70, 0x15, 0x34, 0x63, 0x02, 0xa2, 0x43, 0xfe, 0xdb, 0x70, 0xce,
+  0xa0, 0x88, 0x60, 0x22, 0xa0, 0x37, 0x8c, 0x99, 0x9d, 0x4f, 0x65, 0x84,
+  0x33, 0x48, 0xab, 0x6a, 0x1a, 0x41, 0x63, 0x8b, 0x52, 0x37, 0x56, 0x33,
+  0x22, 0x0c, 0xb8, 0xbe, 0xa4, 0x56, 0xb6, 0x80, 0x3c, 0x66, 0x71, 0x74,
+  0x00, 0x01, 0x00, 0x3f, 0xfe, 0x4f, 0x03, 0x5d, 0x04, 0x7b, 0x00, 0x34,
+  0x00, 0x00, 0x01, 0x1e, 0x03, 0x15, 0x14, 0x0e, 0x05, 0x07, 0x35, 0x3e,
+  0x04, 0x35, 0x34, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x37, 0x3e, 0x04,
+  0x35, 0x34, 0x2e, 0x03, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x33, 0x32,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x02, 0x63, 0x3f, 0x65, 0x38, 0x1d, 0x3b,
+  0x61, 0x89, 0x8d, 0xa1, 0x87, 0x42, 0x92, 0xdc, 0x8e, 0x5a, 0x24, 0x6b,
+  0x53, 0x36, 0x38, 0xc3, 0xc9, 0x1f, 0x3a, 0x4f, 0x38, 0x29, 0x1c, 0x2c,
+  0x3d, 0x3a, 0x20, 0x3e, 0x97, 0x84, 0xef, 0x79, 0x65, 0xa5, 0x69, 0x5d,
+  0x01, 0xcd, 0x08, 0x44, 0x5a, 0x58, 0x25, 0x4b, 0x8a, 0x6c, 0x61, 0x46,
+  0x3d, 0x27, 0x0f, 0x82, 0x2e, 0x60, 0x5b, 0x62, 0x5b, 0x33, 0x58, 0x70,
+  0x19, 0x56, 0x8b, 0x55, 0x0d, 0x20, 0x3c, 0x45, 0x66, 0x39, 0x2c, 0x46,
+  0x2a, 0x1b, 0x0a, 0x3b, 0x5a, 0x9a, 0x85, 0x47, 0x92, 0x61, 0x6e, 0x99,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xf0, 0x04, 0x84, 0x01, 0x75, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xf1, 0x00, 0x00, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xf0, 0x02, 0xd1, 0x01, 0x75, 0x13, 0x06, 0x00, 0x4b, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x97,
+  0x05, 0xf0, 0x00, 0x13, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x17, 0x32, 0x12, 0x19,
+  0x01, 0x23, 0x03, 0xe2, 0x8b, 0x8a, 0xa1, 0xc1, 0xb6, 0xb6, 0x48, 0xb9,
+  0x8c, 0xcd, 0xd1, 0xb4, 0x03, 0x7f, 0xd7, 0xd5, 0xff, 0xde, 0xfc, 0xb2,
+  0x05, 0xd5, 0xf1, 0x87, 0x86, 0x01, 0xfe, 0xc1, 0xfe, 0xcc, 0xfa, 0xd9,
+  0x00, 0x03, 0x00, 0x65, 0xff, 0x70, 0x05, 0xa4, 0x06, 0x14, 0x00, 0x07,
+  0x00, 0x28, 0x00, 0x34, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34,
+  0x27, 0x22, 0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06,
+  0x07, 0x23, 0x36, 0x37, 0x26, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x11, 0x33, 0x00,
+  0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x10, 0x27, 0x26, 0x20, 0x07, 0x04,
+  0x3d, 0x10, 0x21, 0x90, 0x2f, 0x2f, 0xb5, 0x63, 0x7a, 0xdc, 0xfe, 0xcc,
+  0x42, 0x30, 0x1e, 0x16, 0xb0, 0x1a, 0x3c, 0x2b, 0x34, 0x4f, 0x50, 0x70,
+  0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50, 0x4f, 0x34, 0xa6, 0xfd,
+  0x26, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x4c, 0x4c, 0x4b, 0xfe, 0xf9, 0x4c,
+  0x82, 0x05, 0xaf, 0x2d, 0x01, 0x20, 0xb8, 0xce, 0xfe, 0xbf, 0x0f, 0x48,
+  0x3a, 0x45, 0x93, 0x3c, 0x24, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0x02, 0x10,
+  0xa2, 0xa2, 0x31, 0x30, 0x64, 0x02, 0x5e, 0xfc, 0xe6, 0xfe, 0x6a, 0x74,
+  0x73, 0x73, 0x74, 0x01, 0x96, 0x74, 0x73, 0x73, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0xa2, 0x05, 0xf0, 0x00, 0x0c, 0x00, 0x3b, 0x00, 0x00,
+  0x01, 0x22, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35, 0x34,
+  0x26, 0x03, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x27, 0x35, 0x32, 0x17, 0x16, 0x15, 0x14, 0x06,
+  0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x20, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
+  0x02, 0x84, 0xa6, 0x60, 0x60, 0x60, 0x60, 0x01, 0x4b, 0x60, 0x61, 0xbf,
+  0xdc, 0x75, 0x99, 0x56, 0x35, 0xb8, 0x97, 0x55, 0x57, 0x45, 0x62, 0x75,
+  0xcd, 0x87, 0x7d, 0x99, 0x88, 0x9a, 0x56, 0x56, 0x8c, 0x8c, 0xfd, 0xf5,
+  0x8c, 0x8c, 0x56, 0x57, 0x9a, 0x9a, 0x3c, 0x4c, 0x75, 0x68, 0xe7, 0x02,
+  0xc5, 0x4d, 0x4d, 0xfe, 0xf2, 0x4d, 0x4d, 0x4d, 0x4e, 0x86, 0x87, 0x9a,
+  0x02, 0x27, 0x03, 0x7c, 0x4f, 0x45, 0x48, 0x2d, 0x41, 0x41, 0x88, 0x9e,
+  0x2b, 0x4d, 0x08, 0x64, 0x68, 0x61, 0xba, 0x80, 0xb2, 0x20, 0x22, 0x63,
+  0x63, 0x8f, 0xd9, 0x74, 0x74, 0x74, 0x74, 0xd9, 0x8f, 0x63, 0x63, 0x22,
+  0x1f, 0x46, 0x59, 0x58, 0x82, 0x53, 0x4a, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x00, 0x05, 0x0f, 0x00, 0x0d, 0x00, 0x34, 0x00, 0x00,
+  0x01, 0x22, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x13, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x20, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x02, 0x32, 0x81, 0x4b, 0x4a, 0x4a, 0x4b,
+  0x01, 0x03, 0x4b, 0x4b, 0x4b, 0x4a, 0xe5, 0x34, 0x2f, 0x41, 0x75, 0x84,
+  0x49, 0x49, 0x77, 0x77, 0xfe, 0x43, 0x77, 0x77, 0x93, 0x84, 0x82, 0x35,
+  0x2f, 0x39, 0x91, 0x27, 0x42, 0x41, 0x75, 0x76, 0x41, 0x43, 0x28, 0x02,
+  0xc5, 0x4d, 0x4d, 0xfe, 0xf2, 0x4d, 0x4d, 0x4d, 0x4e, 0x86, 0x87, 0x4d,
+  0x4d, 0x02, 0x4a, 0x40, 0x62, 0x99, 0x40, 0x59, 0x20, 0x22, 0x63, 0x63,
+  0x8f, 0xd9, 0x74, 0x74, 0x74, 0x74, 0xd9, 0x8f, 0xc6, 0x22, 0x23, 0x56,
+  0x4b, 0x8e, 0x59, 0x49, 0x41, 0xe8, 0x41, 0x41, 0x41, 0x41, 0x74, 0x77,
+  0x3e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x52, 0xfe, 0x56, 0x04, 0x9c,
+  0x05, 0xd5, 0x00, 0x15, 0x00, 0x00, 0x05, 0x10, 0x07, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x21, 0x35, 0x01, 0x21, 0x35,
+  0x21, 0x15, 0x01, 0x21, 0x04, 0x9c, 0x8e, 0x41, 0x67, 0xe4, 0xd1, 0x5f,
+  0x22, 0x22, 0xfc, 0x5d, 0x03, 0x51, 0xfc, 0xc4, 0x04, 0x1f, 0xfc, 0xaf,
+  0x03, 0x66, 0x14, 0xfe, 0xdf, 0x50, 0x25, 0x9c, 0x30, 0x31, 0x99, 0x14,
+  0x9a, 0x04, 0x91, 0xaa, 0x9a, 0xfb, 0x6f, 0x00, 0x00, 0x01, 0x00, 0x4f,
+  0xfe, 0x56, 0x03, 0x79, 0x04, 0x60, 0x00, 0x15, 0x00, 0x00, 0x05, 0x10,
+  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x21,
+  0x35, 0x01, 0x21, 0x35, 0x21, 0x15, 0x01, 0x21, 0x03, 0x78, 0x8e, 0x41,
+  0x66, 0xe5, 0xd2, 0x5e, 0x22, 0x23, 0xfd, 0x7c, 0x02, 0x6f, 0xfd, 0xa8,
+  0x03, 0x12, 0xfd, 0x92, 0x02, 0x6e, 0x14, 0xfe, 0xdf, 0x50, 0x25, 0x9c,
+  0x30, 0x31, 0x99, 0x14, 0xa8, 0x03, 0x25, 0x93, 0xa8, 0xfc, 0xdb, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x50, 0x10, 0x27,
+  0x10, 0xf3, 0x04, 0x43, 0x01, 0x75, 0x12, 0x06, 0x00, 0x24, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x14, 0x10, 0x27,
+  0x02, 0xb8, 0x03, 0xdc, 0x00, 0x00, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x75, 0x04, 0x17, 0x05, 0xd5, 0x12, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x00, 0x7a, 0x00, 0x92, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26,
+  0x00, 0x48, 0x00, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x6f, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x33, 0x12, 0x26,
+  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x1e, 0x58, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x31, 0x12, 0x26,
+  0x00, 0xb8, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71, 0x00, 0x68, 0x01, 0x3b,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x33, 0x12, 0x26,
+  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x25, 0x5e, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0xe9, 0x12, 0x26,
+  0x00, 0x52, 0x00, 0x00, 0x10, 0x07, 0x11, 0x25, 0xff, 0xbc, 0xfe, 0xb6,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x50, 0x10, 0x27,
+  0x10, 0xf3, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x14, 0x10, 0x27,
+  0x02, 0xb8, 0x04, 0x01, 0x00, 0x00, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x33, 0x12, 0x26,
+  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x20, 0x5f, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x31, 0x12, 0x26,
+  0x01, 0xf1, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71, 0x00, 0x68, 0x01, 0x3b,
+  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0x66, 0x01, 0x3b, 0x12, 0x06, 0x00, 0x3c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x05, 0xf5, 0x10, 0x26,
+  0x00, 0x71, 0x55, 0xff, 0x12, 0x06, 0x00, 0x5c, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x7c, 0xff, 0x70, 0x03, 0x06, 0x06, 0x0e, 0x00, 0x07,
+  0x00, 0x19, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x22,
+  0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06, 0x07, 0x23,
+  0x36, 0x37, 0x26, 0x37, 0x11, 0x33, 0x01, 0xa0, 0x0f, 0x21, 0x90, 0x2e,
+  0x2f, 0xb6, 0x63, 0x7a, 0xdc, 0xfe, 0xcc, 0x42, 0x2f, 0x1f, 0x15, 0xb1,
+  0x1a, 0x3d, 0x2d, 0x01, 0xa6, 0x82, 0x05, 0xaf, 0x2d, 0x01, 0x20, 0xb8,
+  0xce, 0xfe, 0xbf, 0x0f, 0x48, 0x3a, 0x45, 0x93, 0x3c, 0x5a, 0x05, 0x30,
+  0x00, 0x02, 0x00, 0xa7, 0xff, 0x70, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x07,
+  0x00, 0x2b, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x22,
+  0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06, 0x07, 0x23,
+  0x36, 0x37, 0x26, 0x37, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11,
+  0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x04, 0x46, 0x10, 0x21, 0x90, 0x2f, 0x2f, 0xb5, 0x63, 0x7a, 0xdc, 0xfe,
+  0xcc, 0x42, 0x30, 0x1e, 0x16, 0xb0, 0x1a, 0x3c, 0x2c, 0x01, 0x70, 0x6f,
+  0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0x50, 0x51, 0x6a, 0xad, 0x59, 0x5a, 0x82,
+  0x05, 0xaf, 0x2d, 0x01, 0x20, 0xb8, 0xce, 0xfe, 0xbf, 0x0f, 0x48, 0x3a,
+  0x45, 0x93, 0x3c, 0x5a, 0x01, 0xc0, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87,
+  0x04, 0x60, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78, 0xe8, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x31, 0xff, 0x70, 0x03, 0x0b, 0x05, 0x9e, 0x00, 0x07,
+  0x00, 0x21, 0x00, 0x00, 0x25, 0x16, 0x33, 0x32, 0x35, 0x34, 0x27, 0x22,
+  0x07, 0x36, 0x33, 0x32, 0x15, 0x10, 0x21, 0x22, 0x27, 0x06, 0x07, 0x23,
+  0x36, 0x37, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21,
+  0x15, 0x21, 0x01, 0xa4, 0x10, 0x21, 0x90, 0x2f, 0x2f, 0xb5, 0x62, 0x7b,
+  0xdb, 0xfe, 0xcd, 0x42, 0x31, 0x1d, 0x16, 0xb0, 0x1a, 0x3c, 0x2c, 0x79,
+  0x79, 0xa7, 0x01, 0x55, 0xfe, 0xab, 0x82, 0x05, 0xaf, 0x2d, 0x01, 0x20,
+  0xb8, 0xce, 0xfe, 0xbf, 0x0f, 0x48, 0x3a, 0x45, 0x93, 0x3c, 0x5a, 0x02,
+  0xf3, 0x8f, 0x01, 0x3e, 0xfe, 0xc2, 0x8f, 0x00, 0x00, 0x01, 0xff, 0xde,
+  0xfe, 0x56, 0x01, 0x54, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0xae, 0xa5,
+  0x92, 0xa3, 0x3f, 0x2c, 0x5e, 0x45, 0x04, 0x60, 0xfb, 0x8c, 0xd6, 0xc0,
+  0x9c, 0x61, 0x99, 0x00, 0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x06, 0xcb,
+  0x06, 0x14, 0x00, 0x09, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x00, 0x00, 0x10,
+  0x17, 0x16, 0x20, 0x36, 0x10, 0x26, 0x20, 0x07, 0x13, 0x32, 0x17, 0x11,
+  0x33, 0x11, 0x36, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x27, 0x15,
+  0x23, 0x35, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x00, 0x10,
+  0x27, 0x26, 0x20, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0x01, 0x11,
+  0x4a, 0x4c, 0x01, 0x07, 0x97, 0x97, 0xfe, 0xf9, 0x4c, 0xa7, 0xdc, 0x67,
+  0xa7, 0x66, 0xdc, 0xb7, 0xe6, 0xe6, 0xb7, 0xdc, 0x66, 0xa7, 0x67, 0xdc,
+  0xb7, 0x73, 0x72, 0x72, 0x73, 0x04, 0xd4, 0x4b, 0x4b, 0xfe, 0xf9, 0x4c,
+  0x4a, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x02, 0xfa, 0xfe, 0x6a, 0x74, 0x73,
+  0xe7, 0x01, 0x96, 0xe7, 0x73, 0x01, 0x0d, 0xc5, 0x02, 0x5e, 0xfd, 0xa2,
+  0xc5, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0xc5, 0xa8, 0xa8, 0xc5, 0xa2,
+  0xa2, 0x02, 0x10, 0xa2, 0xa2, 0xfc, 0xe9, 0x01, 0x96, 0x74, 0x73, 0x73,
+  0x74, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
+  0xfe, 0x56, 0x06, 0xcb, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x25, 0x00, 0x2f,
+  0x00, 0x00, 0x00, 0x10, 0x27, 0x26, 0x20, 0x07, 0x06, 0x10, 0x17, 0x16,
+  0x20, 0x37, 0x03, 0x22, 0x27, 0x11, 0x23, 0x11, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x35, 0x33, 0x15, 0x36, 0x33,
+  0x32, 0x12, 0x10, 0x02, 0x00, 0x10, 0x17, 0x16, 0x20, 0x36, 0x10, 0x26,
+  0x20, 0x07, 0x06, 0x1f, 0x4b, 0x4b, 0xfe, 0xf9, 0x4c, 0x4a, 0x4a, 0x4c,
+  0x01, 0x07, 0x4b, 0xa6, 0xdc, 0x66, 0xa7, 0x67, 0xdc, 0xb7, 0x73, 0x72,
+  0x72, 0x73, 0xb7, 0xdc, 0x67, 0xa7, 0x66, 0xdc, 0xb7, 0xe6, 0xe6, 0xfb,
+  0x2c, 0x4a, 0x4c, 0x01, 0x07, 0x97, 0x97, 0xfe, 0xf9, 0x4c, 0x01, 0x64,
+  0x01, 0x96, 0x74, 0x73, 0x73, 0x74, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0xfe,
+  0xf3, 0xc5, 0xfd, 0xae, 0x02, 0x52, 0xc5, 0xa2, 0xa2, 0x02, 0x10, 0xa2,
+  0xa2, 0xc5, 0xaa, 0xaa, 0xc5, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x03,
+  0x17, 0xfe, 0x6a, 0x74, 0x73, 0xe7, 0x01, 0x96, 0xe7, 0x73, 0x00, 0x00,
+  0x00, 0x03, 0xff, 0xfd, 0xff, 0xba, 0x04, 0xf0, 0x06, 0x17, 0x00, 0x12,
+  0x00, 0x16, 0x00, 0x19, 0x00, 0x00, 0x01, 0x33, 0x13, 0x01, 0x17, 0x09,
+  0x01, 0x23, 0x03, 0x21, 0x0f, 0x01, 0x23, 0x07, 0x27, 0x23, 0x37, 0x27,
+  0x37, 0x01, 0x03, 0x33, 0x01, 0x03, 0x21, 0x03, 0x02, 0x0f, 0xcf, 0x78,
+  0x01, 0x3e, 0x5c, 0xfe, 0x98, 0x01, 0x56, 0xbd, 0x7b, 0xfe, 0x0e, 0xb9,
+  0x2d, 0x3f, 0x35, 0x4a, 0x02, 0x01, 0x12, 0x2b, 0x02, 0x4e, 0xf7, 0x14,
+  0x01, 0x4b, 0xab, 0x01, 0x3b, 0x60, 0x05, 0xd5, 0xfe, 0xa1, 0x01, 0xa1,
+  0x59, 0xfe, 0x27, 0xfc, 0x1b, 0x01, 0x7f, 0xf1, 0x8e, 0x46, 0x46, 0x01,
+  0x11, 0x38, 0x04, 0xc4, 0xfd, 0x19, 0x01, 0xb1, 0xfe, 0x4f, 0x01, 0x1f,
+  0x00, 0x02, 0x00, 0x0a, 0xff, 0xba, 0x04, 0xfd, 0x06, 0x17, 0x00, 0x22,
+  0x00, 0x2c, 0x00, 0x00, 0x17, 0x27, 0x13, 0x26, 0x11, 0x10, 0x37, 0x36,
+  0x21, 0x32, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07, 0x15, 0x26, 0x27, 0x01,
+  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06,
+  0x23, 0x20, 0x27, 0x13, 0x01, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x11,
+  0x14, 0x67, 0x5c, 0xc6, 0x69, 0xaf, 0xaf, 0x01, 0x32, 0x78, 0x6a, 0x37,
+  0x35, 0x5a, 0x5c, 0x59, 0x29, 0x2c, 0xfd, 0x42, 0x08, 0x0a, 0x7a, 0xe6,
+  0x75, 0x69, 0x67, 0x5c, 0x5f, 0x6b, 0x6b, 0x76, 0xfe, 0xd5, 0xaf, 0x34,
+  0x02, 0x8f, 0x01, 0x69, 0x75, 0xe6, 0x7a, 0x7b, 0x46, 0x58, 0x01, 0x05,
+  0xbb, 0x01, 0x17, 0x01, 0x68, 0xcf, 0xd0, 0x24, 0x12, 0x1b, 0x78, 0x59,
+  0x76, 0xbb, 0x2b, 0x21, 0xfc, 0x66, 0x0d, 0x0c, 0x9d, 0x2f, 0x2f, 0x5f,
+  0xd3, 0x48, 0x24, 0x24, 0xc7, 0x01, 0x15, 0x03, 0x5c, 0x2f, 0x9c, 0x9d,
+  0xfe, 0xd8, 0xad, 0x00, 0x00, 0x02, 0x00, 0x08, 0xff, 0xa2, 0x03, 0xee,
+  0x04, 0xbc, 0x00, 0x22, 0x00, 0x2b, 0x00, 0x00, 0x17, 0x27, 0x37, 0x26,
+  0x35, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07,
+  0x15, 0x26, 0x27, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x15, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x13, 0x01, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x5e, 0x56, 0xaa, 0x4c, 0x88, 0x87, 0xeb, 0x4d,
+  0x49, 0x29, 0x29, 0x50, 0x55, 0x6a, 0x16, 0x16, 0xfe, 0x0b, 0x06, 0x05,
+  0x59, 0xa2, 0x48, 0x46, 0x47, 0x46, 0x45, 0x4a, 0x4b, 0x53, 0xd8, 0x85,
+  0x32, 0x01, 0xbc, 0x3f, 0x40, 0xa2, 0x59, 0x59, 0x5e, 0x4e, 0xe6, 0x8d,
+  0xcc, 0x01, 0x12, 0x9d, 0x9d, 0x11, 0x0a, 0x10, 0x6c, 0x4f, 0x8f, 0x55,
+  0x0e, 0x0b, 0xfd, 0x5e, 0x08, 0x08, 0x71, 0x15, 0x16, 0x2b, 0xaa, 0x24,
+  0x12, 0x12, 0x90, 0x01, 0x05, 0x02, 0x56, 0x11, 0x71, 0x72, 0xcd, 0x67,
+  0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x21, 0x15, 0x21,
+  0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0xac, 0xac, 0x02, 0x8e, 0xfc, 0xbc,
+  0xac, 0xac, 0x05, 0xd5, 0xfd, 0x77, 0x90, 0xfd, 0xee, 0xaa, 0x02, 0xbc,
+  0x90, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb9, 0xff, 0xba, 0x04, 0xad,
+  0x06, 0x17, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x00, 0x01, 0x15, 0x23, 0x01,
+  0x11, 0x23, 0x11, 0x01, 0x27, 0x01, 0x11, 0x21, 0x35, 0x21, 0x37, 0x17,
+  0x09, 0x01, 0x21, 0x04, 0x6b, 0x2f, 0xfe, 0x52, 0xb6, 0xfe, 0x3e, 0x5c,
+  0x02, 0x1e, 0xfe, 0x23, 0x04, 0x23, 0x32, 0x5c, 0xfd, 0xe2, 0x01, 0x0e,
+  0xfe, 0xf2, 0x05, 0x69, 0x3e, 0xfd, 0xcc, 0xfd, 0x09, 0x02, 0x07, 0xfd,
+  0xb3, 0x58, 0x02, 0xc7, 0x02, 0x52, 0xaa, 0x42, 0x59, 0xfe, 0x0b, 0x01,
+  0x62, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xfe, 0x10, 0x03, 0xb1,
+  0x04, 0x7b, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x2f, 0x01,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
+  0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x1f, 0x01, 0x16, 0x33, 0x15,
+  0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x02, 0xbc, 0x2d, 0x2e,
+  0x9a, 0x39, 0x9a, 0x44, 0x45, 0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x46, 0x97,
+  0x51, 0x7b, 0x3e, 0x3e, 0x2c, 0x2d, 0x85, 0x38, 0xb3, 0x48, 0x4a, 0x6e,
+  0x4f, 0x77, 0x90, 0x84, 0x26, 0x44, 0x23, 0x4c, 0x66, 0x40, 0x50, 0xd5,
+  0x1c, 0x20, 0x0e, 0x10, 0x57, 0x61, 0x5c, 0x59, 0x59, 0x57, 0x75, 0x3f,
+  0x3f, 0x01, 0x27, 0x4b, 0x28, 0x28, 0x25, 0x0f, 0x24, 0x4a, 0x4b, 0x82,
+  0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x2a, 0x2a, 0x54, 0x40, 0x25,
+  0x24, 0x21, 0x0e, 0x2c, 0x4b, 0x4c, 0x89, 0x9c, 0x5b, 0x40, 0x13, 0x9f,
+  0x7e, 0x24, 0x9a, 0x3d, 0x26, 0x5b, 0xf3, 0x1e, 0x10, 0x03, 0x02, 0x12,
+  0x23, 0xbe, 0x35, 0x1a, 0x1b, 0x2d, 0x2c, 0x00, 0x00, 0x01, 0x00, 0x4f,
+  0xfe, 0x10, 0x03, 0xc8, 0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x01, 0x16, 0x17, 0x13, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x27, 0x26, 0x2f, 0x01, 0x26, 0x2b, 0x01, 0x3d, 0x01, 0x01, 0x21, 0x66,
+  0x03, 0x12, 0xfd, 0x93, 0x53, 0x2c, 0xee, 0x84, 0x26, 0x44, 0x62, 0x85,
+  0x4b, 0x67, 0x40, 0x50, 0xd5, 0x37, 0x51, 0x55, 0x02, 0x6f, 0xfd, 0xa8,
+  0x04, 0x60, 0xa8, 0xfc, 0xdd, 0x10, 0x31, 0xfe, 0xf8, 0x7e, 0x24, 0x9a,
+  0x3d, 0x26, 0x5b, 0xf3, 0x3f, 0x9c, 0x0c, 0x03, 0x25, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x48, 0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x18,
+  0x00, 0x00, 0x01, 0x23, 0x11, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x2b, 0x01, 0x22, 0x06, 0x07, 0x35, 0x36, 0x3b, 0x01, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x02, 0x4f, 0x23, 0xb6, 0xd9, 0x7f, 0x8b, 0x8b, 0x7f,
+  0xe4, 0x3e, 0x9e, 0x47, 0x89, 0x9a, 0xe4, 0xdc, 0xed, 0xee, 0x02, 0x5a,
+  0xfd, 0xa6, 0x03, 0x00, 0x91, 0x87, 0x88, 0x8f, 0x2a, 0x2c, 0xb6, 0x46,
+  0xdc, 0xe1, 0xd7, 0xe7, 0x00, 0x01, 0x00, 0x48, 0x00, 0x00, 0x03, 0x34,
+  0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x11, 0x23, 0x01, 0x11, 0x5a, 0x7f, 0x8a,
+  0x44, 0x4c, 0x79, 0x42, 0x4d, 0x4e, 0x46, 0x89, 0x9a, 0xe2, 0x70, 0x77,
+  0xbf, 0xaf, 0xb5, 0x01, 0xa6, 0x91, 0x87, 0x8d, 0x41, 0x48, 0x15, 0x15,
+  0x2b, 0xb6, 0x46, 0x6e, 0x74, 0xdb, 0xd5, 0xe5, 0xfe, 0xfc, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x0c,
+  0x00, 0x15, 0x00, 0x28, 0x00, 0x00, 0x01, 0x15, 0x21, 0x15, 0x21, 0x15,
+  0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x11, 0x21, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x23, 0x35, 0x33, 0x01,
+  0x6b, 0x01, 0x38, 0xfe, 0xc8, 0x01, 0x23, 0x93, 0x8d, 0x8d, 0x93, 0xfe,
+  0xdd, 0x01, 0x0d, 0x85, 0x83, 0x83, 0x85, 0xfe, 0x3d, 0x01, 0xd0, 0xd0,
+  0xe1, 0x73, 0x70, 0x87, 0x94, 0xf5, 0xe2, 0xfe, 0x1e, 0xac, 0xac, 0x02,
+  0xc9, 0xc9, 0x90, 0xca, 0x87, 0x8b, 0x8c, 0x85, 0x02, 0x66, 0xfe, 0x3e,
+  0x6f, 0x72, 0x71, 0x70, 0xa6, 0xc0, 0xb1, 0x89, 0xa2, 0x14, 0x20, 0xcb,
+  0x98, 0xc8, 0xda, 0x01, 0x70, 0x90, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0a,
+  0xff, 0xe3, 0x05, 0x3a, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x1d, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x10,
+  0x00, 0x23, 0x22, 0x00, 0x11, 0x35, 0x23, 0x35, 0x33, 0x05, 0x21, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0xa0, 0xb7, 0x02, 0x97, 0xb7, 0x94,
+  0x94, 0xfe, 0xfc, 0xfe, 0xff, 0xfe, 0xfc, 0x95, 0x95, 0x03, 0x4e, 0xfd,
+  0x69, 0x9d, 0xaf, 0xaf, 0x9c, 0x05, 0xd5, 0xfd, 0x96, 0x02, 0x6a, 0xfd,
+  0x96, 0xa4, 0x96, 0xfe, 0xdc, 0xfe, 0xd6, 0x01, 0x2a, 0x01, 0x24, 0x96,
+  0xa4, 0xa4, 0x7d, 0xf0, 0xd3, 0xd3, 0xf0, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x03, 0x30, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xb4, 0xff, 0x42, 0x04, 0x17, 0x06, 0x93, 0x00, 0x13,
+  0x00, 0x17, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x33, 0x07, 0x33, 0x15, 0x23,
+  0x03, 0x33, 0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x07, 0x23, 0x37, 0x23,
+  0x11, 0x21, 0x01, 0x13, 0x23, 0x11, 0x1b, 0x01, 0x21, 0x11, 0x03, 0x59,
+  0x99, 0x3b, 0x4f, 0x83, 0x88, 0xf0, 0xfe, 0xdc, 0xa6, 0x01, 0xf6, 0xfd,
+  0xd5, 0x3a, 0x99, 0x3a, 0x9e, 0x02, 0x69, 0xfe, 0x6a, 0xa6, 0xc3, 0xf7,
+  0x88, 0xfe, 0x81, 0x06, 0x93, 0xbe, 0xaa, 0xfe, 0x46, 0xaa, 0xfd, 0xe3,
+  0xaa, 0xbe, 0xbe, 0x05, 0xd5, 0xfa, 0xd5, 0x02, 0x1d, 0xfd, 0xe3, 0x02,
+  0xc7, 0x01, 0xba, 0xfe, 0x46, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65,
+  0xff, 0x42, 0x04, 0x0c, 0x05, 0x1e, 0x00, 0x05, 0x00, 0x26, 0x00, 0x2d,
+  0x00, 0x31, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x03, 0x05, 0x15,
+  0x21, 0x03, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x27, 0x07, 0x23, 0x13, 0x26, 0x27, 0x26, 0x11, 0x10, 0x00, 0x33, 0x32,
+  0x17, 0x37, 0x33, 0x07, 0x16, 0x17, 0x16, 0x05, 0x13, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x1b, 0x01, 0x23, 0x16, 0x03, 0x66, 0x02, 0x4a, 0x0d, 0x0e,
+  0x64, 0x01, 0x71, 0xfe, 0x5a, 0x86, 0x43, 0x57, 0x60, 0xb3, 0x58, 0x59,
+  0xbb, 0x60, 0x6f, 0x5a, 0x47, 0x99, 0x62, 0x1e, 0x19, 0x8d, 0x01, 0x0b,
+  0xe3, 0x32, 0x2d, 0x3f, 0x99, 0x53, 0x34, 0x2a, 0x76, 0xfd, 0xf6, 0x79,
+  0x12, 0x13, 0x8b, 0xa7, 0x0c, 0x51, 0x64, 0xbb, 0x0a, 0x02, 0x94, 0x97,
+  0x5a, 0x10, 0x0d, 0xfe, 0xf2, 0x36, 0x5a, 0xfe, 0x97, 0x1c, 0x34, 0x34,
+  0xae, 0x2a, 0x2c, 0x21, 0xc2, 0x01, 0x09, 0x17, 0x1d, 0x9c, 0x01, 0x0a,
+  0x01, 0x13, 0x01, 0x43, 0x09, 0xac, 0xe0, 0x22, 0x32, 0x92, 0xc5, 0x01,
+  0x4a, 0x02, 0xae, 0x9e, 0xfe, 0x63, 0x01, 0x0e, 0xac, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xa0, 0xfe, 0x66, 0x02, 0x17, 0x05, 0xd5, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x23, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x36, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x02, 0x17,
+  0xac, 0xb9, 0xcc, 0x45, 0x38, 0x79, 0x63, 0xac, 0xac, 0xb6, 0xac, 0x02,
+  0x77, 0xfd, 0xf1, 0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x02, 0x0f, 0xa6,
+  0x02, 0xb8, 0xfd, 0x48, 0x00, 0x02, 0xff, 0xde, 0xfe, 0x56, 0x01, 0xe6,
+  0x06, 0x14, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33,
+  0x15, 0x23, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
+  0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x15, 0x23, 0xae, 0xa5, 0x93, 0x93,
+  0x92, 0xa3, 0x3f, 0x2c, 0x5e, 0x45, 0xa3, 0xa3, 0xa5, 0xa5, 0x04, 0x60,
+  0xfe, 0x08, 0xa4, 0xfe, 0x28, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x01, 0xd8,
+  0xa4, 0x03, 0xac, 0xe9, 0x00, 0x02, 0x00, 0x67, 0xfe, 0x66, 0x06, 0x05,
+  0x05, 0xf1, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00, 0x01, 0x35, 0x33, 0x11,
+  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x11, 0x35, 0x0e, 0x01,
+  0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x01, 0x10, 0x12,
+  0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x04, 0x3b, 0xb0,
+  0x63, 0x79, 0x3e, 0x45, 0xcd, 0xb8, 0x46, 0xd4, 0x95, 0xf2, 0xfe, 0xce,
+  0x01, 0x32, 0xf2, 0x95, 0xd4, 0xfd, 0x2f, 0xd3, 0xb8, 0xb8, 0xd4, 0xd4,
+  0xb8, 0xb8, 0xd3, 0x04, 0xed, 0xe8, 0xfa, 0x93, 0xc2, 0x96, 0xaa, 0xf4,
+  0x01, 0x0e, 0x7f, 0x84, 0x80, 0x01, 0xab, 0x01, 0x5c, 0x01, 0x5c, 0x01,
+  0xab, 0x80, 0xfd, 0x78, 0xfe, 0xe3, 0xfe, 0xbb, 0x01, 0x45, 0x01, 0x1d,
+  0x01, 0x1d, 0x01, 0x45, 0xfe, 0xbb, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0xba, 0x04, 0x7b, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00,
+  0x01, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
+  0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11, 0x14, 0x16, 0x3b,
+  0x01, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x04, 0xba, 0x3f, 0xa3, 0x93, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
+  0xb7, 0x70, 0x9f, 0x34, 0xa6, 0x44, 0x5f, 0x2c, 0xfc, 0x57, 0x96, 0x83,
+  0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0xfe, 0x56, 0xc0, 0xd6, 0xbc, 0x64,
+  0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0x64, 0xaa,
+  0xfb, 0x8c, 0x99, 0x61, 0x03, 0x3d, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7,
+  0xe7, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x04, 0xcc,
+  0x05, 0xd5, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17,
+  0x13, 0x23, 0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x23, 0x35,
+  0x33, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4,
+  0xac, 0x42, 0x7d, 0x6c, 0xc6, 0xb6, 0xac, 0xac, 0x01, 0x9a, 0xe7, 0xe2,
+  0x75, 0xfd, 0xc8, 0xe4, 0x84, 0x86, 0x86, 0x84, 0x02, 0xbc, 0x16, 0x90,
+  0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0x89, 0x02, 0x77, 0xa6,
+  0x02, 0xb8, 0xd6, 0xd8, 0x8d, 0xba, 0x02, 0x4f, 0xfd, 0xee, 0x87, 0x83,
+  0x83, 0x85, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0c, 0x00, 0x00, 0x02, 0xf6,
+  0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x01, 0x15, 0x23, 0x11, 0x23, 0x11,
+  0x23, 0x35, 0x33, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x1f,
+  0x01, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x01, 0xe8, 0x9a, 0xa7, 0x9a,
+  0x9a, 0xa7, 0x34, 0xa8, 0x77, 0x11, 0x2a, 0x19, 0x01, 0x1c, 0x42, 0x27,
+  0x8d, 0x96, 0x02, 0x68, 0xa4, 0xfe, 0x3c, 0x01, 0xc4, 0xa4, 0x01, 0xf8,
+  0xae, 0x66, 0x63, 0x05, 0x05, 0xbd, 0x12, 0x11, 0xce, 0xa1, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xf7, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x14, 0x00, 0x00, 0x03, 0x33, 0x17, 0x21, 0x37, 0x33, 0x07, 0x33,
+  0x15, 0x23, 0x03, 0x11, 0x23, 0x11, 0x03, 0x23, 0x35, 0x33, 0x05, 0x21,
+  0x17, 0x04, 0xc4, 0x88, 0x01, 0xd7, 0x87, 0xc4, 0x88, 0x8c, 0xf0, 0xf0,
+  0xb6, 0xf0, 0xf1, 0x8d, 0x02, 0x38, 0xfe, 0xf0, 0x88, 0x05, 0xd5, 0xe0,
+  0xe0, 0xe0, 0xa4, 0xfe, 0x76, 0xfd, 0x39, 0x02, 0xc7, 0x01, 0x8a, 0xa4,
+  0xa4, 0xe2, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09, 0xfe, 0x56, 0x04, 0x3d,
+  0x04, 0x60, 0x00, 0x18, 0x00, 0x1b, 0x00, 0x00, 0x05, 0x0e, 0x01, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x36, 0x3f, 0x01, 0x03, 0x21, 0x35, 0x33, 0x03,
+  0x33, 0x13, 0x21, 0x13, 0x33, 0x03, 0x33, 0x15, 0x21, 0x2b, 0x01, 0x13,
+  0x02, 0x51, 0x46, 0x85, 0x70, 0x84, 0x61, 0x44, 0x4c, 0x2e, 0x1e, 0xb9,
+  0xfe, 0xf4, 0xd8, 0xab, 0xaf, 0xa6, 0x01, 0x2b, 0xa5, 0xb0, 0xa7, 0xd7,
+  0xfe, 0xf5, 0xad, 0xc5, 0x62, 0x68, 0xc8, 0x7a, 0x9a, 0x48, 0x86, 0x54,
+  0x01, 0xf2, 0x8f, 0x01, 0xcd, 0xfe, 0x33, 0x01, 0xcd, 0xfe, 0x33, 0x8f,
+  0xfe, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xf0,
+  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x25, 0x00, 0x00, 0x01, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x07, 0x11, 0x33, 0x15, 0x3e,
+  0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x01, 0xe7,
+  0xc9, 0x9a, 0x74, 0x64, 0x89, 0xa7, 0xa5, 0xa5, 0x39, 0xa9, 0x7a, 0x9b,
+  0xb7, 0xe4, 0xe2, 0xe8, 0x96, 0x88, 0x57, 0xa4, 0x4b, 0x5b, 0xab, 0x51,
+  0xda, 0xd8, 0x02, 0x2b, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x4c,
+  0x02, 0x7f, 0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b,
+  0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0xeb, 0x04, 0x7b, 0x00, 0x10, 0x00, 0x1c, 0x00, 0x00,
+  0x01, 0x35, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
+  0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0xa6, 0xa6, 0x34, 0x9f, 0x70,
+  0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0xfe, 0x00, 0x96, 0x83, 0x84, 0x97,
+  0x97, 0x84, 0x83, 0x96, 0x03, 0xb6, 0xaa, 0xfb, 0xa0, 0xa8, 0x64, 0x61,
+  0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0xfe, 0x15, 0xcb,
+  0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xff, 0xe3, 0x04, 0x2d, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x1c, 0x00, 0x00,
+  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26,
+  0x27, 0x15, 0x23, 0x11, 0x33, 0x03, 0x81, 0x96, 0x83, 0x84, 0x97, 0x97,
+  0x84, 0x83, 0x96, 0xfd, 0xcc, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7,
+  0x70, 0x9f, 0x34, 0xa6, 0xa6, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
+  0xe7, 0xe7, 0x02, 0x52, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe, 0xf8,
+  0xfe, 0xbc, 0x61, 0x64, 0xaa, 0x04, 0x60, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x00,
+  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26,
+  0x27, 0x15, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06,
+  0x15, 0x03, 0x81, 0x96, 0x83, 0x84, 0x96, 0x96, 0x84, 0x83, 0x96, 0xfd,
+  0xcd, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xa7,
+  0xa1, 0x95, 0xe5, 0xd2, 0x51, 0x52, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb,
+  0xcb, 0xe7, 0xe7, 0x02, 0x52, 0x64, 0x61, 0xfe, 0xbc, 0xfe, 0xf8, 0xfe,
+  0xf8, 0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x04, 0x7e, 0xc3, 0xd3, 0x9c, 0x7d,
+  0x7d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90,
+  0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x13, 0x3e, 0x01, 0x33, 0x32, 0x00,
+  0x11, 0x10, 0x00, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x72, 0x46, 0x94, 0x54,
+  0xe4, 0x01, 0x0c, 0xfe, 0xf1, 0xec, 0x4d, 0x91, 0x45, 0x46, 0x8e, 0x48,
+  0xa1, 0xb2, 0xb2, 0xa1, 0x48, 0x8e, 0x46, 0x04, 0x33, 0x24, 0x24, 0xfe,
+  0xc2, 0xfe, 0xf2, 0xfe, 0xee, 0xfe, 0xc6, 0x23, 0x23, 0xac, 0x2b, 0x2b,
+  0xe3, 0xcd, 0xcd, 0xe3, 0x2b, 0x2b, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0x73, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x27, 0x00, 0x2f, 0x00, 0x00,
+  0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x06, 0x15, 0x23, 0x34, 0x37, 0x26, 0x27, 0x26, 0x11, 0x10,
+  0x00, 0x33, 0x32, 0x16, 0x01, 0x16, 0x33, 0x32, 0x35, 0x34, 0x23, 0x22,
+  0x03, 0x83, 0x46, 0x8d, 0x48, 0xa2, 0xb2, 0x59, 0x06, 0x06, 0x23, 0x38,
+  0x42, 0x5f, 0x92, 0x43, 0x39, 0x55, 0x4b, 0x8c, 0x48, 0x41, 0x06, 0x89,
+  0x0a, 0x32, 0x2b, 0x86, 0x01, 0x0f, 0xeb, 0x4d, 0x92, 0xfe, 0xaf, 0x34,
+  0x46, 0x83, 0x77, 0x5b, 0x04, 0x35, 0xac, 0x2b, 0x2b, 0xe3, 0xcd, 0xcd,
+  0x72, 0x08, 0x06, 0x51, 0x2c, 0x33, 0x48, 0x3d, 0x59, 0x7d, 0x2f, 0x29,
+  0x11, 0x39, 0x44, 0x68, 0x51, 0x23, 0x33, 0xa1, 0x01, 0x0c, 0x01, 0x12,
+  0x01, 0x3a, 0x23, 0xfc, 0x3a, 0x13, 0x39, 0x4b, 0x00, 0x02, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0xba, 0x06, 0x14, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00,
+  0x01, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
+  0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x11, 0x33, 0x11, 0x14, 0x16, 0x3b,
+  0x01, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x04, 0xba, 0x3f, 0xa3, 0x93, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
+  0xb7, 0x70, 0x9f, 0x34, 0xa6, 0x44, 0x5f, 0x2c, 0xfc, 0x57, 0x96, 0x83,
+  0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0xfe, 0x56, 0xc0, 0xd6, 0xbc, 0x64,
+  0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0x64, 0x02,
+  0x5e, 0xf9, 0xd8, 0x99, 0x61, 0x03, 0x3d, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb,
+  0xe7, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x05, 0x27,
+  0x06, 0x14, 0x00, 0x18, 0x00, 0x24, 0x00, 0x00, 0x01, 0x35, 0x34, 0x36,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x35, 0x0e, 0x01,
+  0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x45, 0x93,
+  0xa3, 0xab, 0x98, 0x5f, 0x44, 0xa6, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
+  0xb7, 0x70, 0x9f, 0xfe, 0x00, 0x96, 0x83, 0x84, 0x97, 0x97, 0x84, 0x83,
+  0x96, 0x03, 0xb6, 0xc8, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xfb, 0x82, 0xa8,
+  0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61, 0xfe,
+  0x15, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x22, 0x00, 0x00,
+  0x13, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06,
+  0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x21, 0x37, 0x05, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x66,
+  0x76, 0x76, 0xcc, 0xe3, 0x85, 0x86, 0x8d, 0x8d, 0xf1, 0x60, 0xbb, 0x5a,
+  0x59, 0x5a, 0x59, 0x5f, 0xa5, 0x5c, 0x5c, 0x0b, 0xfd, 0x07, 0xa5, 0x02,
+  0x4f, 0x0d, 0x54, 0x52, 0x8b, 0x7a, 0x4a, 0x4b, 0x02, 0x5e, 0xfa, 0x92,
+  0x91, 0xa1, 0xa2, 0xfe, 0xed, 0xfe, 0xf6, 0x9c, 0x9c, 0x2c, 0x2a, 0xae,
+  0x34, 0x1a, 0x1a, 0x63, 0x64, 0xbe, 0x90, 0x01, 0x9e, 0x57, 0x57, 0x5a,
+  0x5a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
+  0x04, 0x7b, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x35, 0x21, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x00, 0x11,
+  0x10, 0x00, 0x23, 0x22, 0x02, 0x37, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37,
+  0x66, 0x02, 0xf9, 0x0b, 0xb8, 0xa5, 0x5f, 0xb3, 0x59, 0x5a, 0xbb, 0x60,
+  0xf1, 0x01, 0x1a, 0xfe, 0xf5, 0xe3, 0xcc, 0xec, 0xa5, 0x02, 0x95, 0x7a,
+  0x8b, 0xa6, 0x0d, 0x02, 0x00, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a,
+  0x2c, 0xfe, 0xc8, 0xfe, 0xf6, 0xfe, 0xed, 0xfe, 0xbd, 0x01, 0x23, 0xc4,
+  0x97, 0xb4, 0xae, 0x9e, 0x00, 0x02, 0x00, 0x6f, 0xff, 0xe3, 0x05, 0xde,
+  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x34, 0x00, 0x00, 0x25, 0x36, 0x27, 0x36,
+  0x27, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x01, 0x16, 0x15, 0x10, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x26, 0x27, 0x26, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x37,
+  0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26,
+  0x35, 0x02, 0xf9, 0x5c, 0x02, 0x01, 0x09, 0xfd, 0xd5, 0x1b, 0x1d, 0x4a,
+  0x7a, 0x97, 0x01, 0x3d, 0x1c, 0x86, 0x85, 0xe3, 0xcd, 0x75, 0x54, 0x18,
+  0x02, 0xb1, 0x11, 0x18, 0x44, 0xbd, 0x61, 0x57, 0x5a, 0x59, 0x5a, 0xbb,
+  0x60, 0xf1, 0x8d, 0x20, 0x18, 0xb7, 0xa6, 0x22, 0x22, 0x5e, 0x27, 0x39,
+  0x9d, 0x4f, 0x4a, 0xd6, 0x8a, 0xcf, 0x3e, 0x38, 0xfe, 0x9c, 0x45, 0x23,
+  0x5a, 0x02, 0x90, 0x60, 0x76, 0xfe, 0xed, 0xa2, 0xa1, 0x91, 0x67, 0x9c,
+  0x01, 0xbb, 0x27, 0x23, 0x64, 0x01, 0x01, 0x19, 0x1a, 0x34, 0xae, 0x2a,
+  0x2c, 0x9c, 0x23, 0x29, 0x75, 0x94, 0x99, 0x31, 0x30, 0x9c, 0x60, 0x5a,
+  0xc8, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
+  0x04, 0x7c, 0x12, 0x06, 0x03, 0x49, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x04, 0x7c, 0x12, 0x06, 0x03, 0xcb, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x77, 0xff, 0xe3, 0x05, 0x8d, 0x04, 0x7c, 0x00, 0x3e,
+  0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x37, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x27, 0x26, 0x35, 0x05, 0x06, 0x02, 0x7b, 0x70, 0x7c, 0xe8, 0xd6, 0x48,
+  0x4d, 0x4b, 0x51, 0x40, 0x4c, 0x4d, 0x53, 0x88, 0x4d, 0x4b, 0x46, 0x41,
+  0x7b, 0x85, 0x8b, 0x69, 0x3c, 0x3d, 0x3f, 0x3e, 0x6b, 0x40, 0x49, 0x48,
+  0x57, 0x58, 0x99, 0x45, 0xb0, 0x66, 0x55, 0x0e, 0xd4, 0xa6, 0x22, 0x22,
+  0x5f, 0x26, 0x39, 0x9d, 0x4f, 0x4a, 0xfe, 0xfd, 0x3a, 0x02, 0x5c, 0x18,
+  0x92, 0x6c, 0xad, 0xb6, 0x0e, 0x0e, 0x1c, 0xab, 0x25, 0x13, 0x12, 0x38,
+  0x38, 0x5a, 0x58, 0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e,
+  0x0d, 0x0d, 0x1d, 0xa7, 0x18, 0x18, 0x4e, 0x42, 0x6a, 0x86, 0x94, 0x99,
+  0x31, 0x30, 0x9c, 0x60, 0x5a, 0xc8, 0xa6, 0x46, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x4b, 0x04, 0x7c, 0x00, 0x1a, 0x00, 0x2f, 0x00, 0x00,
+  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x37, 0x36,
+  0x02, 0xa6, 0xe2, 0x57, 0x59, 0x59, 0x5e, 0xbd, 0x88, 0x4c, 0x4c, 0x46,
+  0x41, 0x7b, 0x86, 0x8c, 0x68, 0x3d, 0x3d, 0x3f, 0x3e, 0x5e, 0xb1, 0x65,
+  0x67, 0x36, 0x36, 0x65, 0x70, 0x7c, 0xe8, 0xd7, 0xfe, 0xe6, 0xfe, 0xf4,
+  0x87, 0x88, 0x03, 0xdc, 0x6e, 0x72, 0xcd, 0xd0, 0x6f, 0x74, 0x38, 0x38,
+  0x5a, 0x58, 0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e, 0xa0,
+  0x4e, 0x4f, 0x8d, 0x5d, 0x40, 0x41, 0x18, 0x18, 0x92, 0x6c, 0xad, 0xb6,
+  0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x9d, 0x9e, 0x00, 0x01, 0xff, 0xde,
+  0xfe, 0x56, 0x01, 0xe6, 0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x33, 0x15, 0x23, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x36, 0x35, 0x11, 0x23, 0x35, 0x33, 0xae, 0xa5, 0x93, 0x93, 0x92, 0xa3,
+  0x3f, 0x2c, 0x5e, 0x45, 0xa3, 0xa3, 0x04, 0x60, 0xfe, 0x08, 0xa4, 0xfe,
+  0x28, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x01, 0xd8, 0xa4, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x05, 0x26, 0x06, 0x14, 0x00, 0x0b,
+  0x00, 0x30, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x17, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35,
+  0x1e, 0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02,
+  0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x34, 0x36, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x06, 0x15, 0x03, 0x45, 0x95, 0x86, 0x85, 0x94, 0x94,
+  0x85, 0x86, 0x95, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a,
+  0xa3, 0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe2, 0xba, 0x70, 0xa0, 0x33,
+  0x93, 0xa3, 0xab, 0x98, 0x5f, 0x44, 0x02, 0x3d, 0xc8, 0xdc, 0xdc, 0xc8,
+  0xc7, 0xdc, 0xdc, 0xeb, 0xfe, 0xe2, 0xfe, 0xe9, 0x1d, 0x1e, 0xb3, 0x2c,
+  0x2a, 0xbd, 0xbf, 0x5b, 0x63, 0x62, 0x01, 0x3a, 0x01, 0x03, 0x01, 0x04,
+  0x01, 0x3a, 0x62, 0x63, 0xc8, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb, 0x04, 0x60, 0x00, 0x0a,
+  0x00, 0x23, 0x00, 0x00, 0x01, 0x11, 0x21, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x17, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e,
+  0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x11,
+  0x34, 0x12, 0x33, 0x21, 0x03, 0x45, 0xfe, 0xcc, 0x79, 0x87, 0x94, 0x85,
+  0x86, 0x95, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a, 0xa3,
+  0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe2, 0xba, 0x01, 0xe9, 0x02, 0x3d,
+  0x01, 0x88, 0xcd, 0xbb, 0xc7, 0xdc, 0xdc, 0xeb, 0xfe, 0xe2, 0xfe, 0xe9,
+  0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd, 0xbf, 0x5b, 0x63, 0x62, 0x01, 0x3a,
+  0x01, 0x03, 0xf9, 0x01, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0xe1, 0x04, 0x7b, 0x00, 0x1d, 0x00, 0x00, 0x25, 0x11,
+  0x23, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00,
+  0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x03, 0x4b, 0x8b, 0x01, 0x21, 0x5b, 0xc2, 0x6e,
+  0xe4, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x5e, 0xb1, 0x54, 0x55, 0xad, 0x59,
+  0xa2, 0xb2, 0xb2, 0xa2, 0x47, 0x6f, 0x9e, 0x01, 0x11, 0x8c, 0xfd, 0xf0,
+  0x24, 0x24, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x3a, 0x37, 0x37,
+  0xaa, 0x3e, 0x3e, 0xe3, 0xcd, 0xcd, 0xe3, 0x0f, 0x00, 0x02, 0x00, 0x56,
+  0xfe, 0x52, 0x03, 0xf4, 0x04, 0x60, 0x00, 0x13, 0x00, 0x23, 0x00, 0x00,
+  0x09, 0x01, 0x33, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x33, 0x01, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x02, 0x25, 0x01, 0x22, 0xad, 0xfe, 0x88, 0x5f, 0x23, 0x35, 0x87, 0x87,
+  0x87, 0x87, 0x35, 0x23, 0x5f, 0xfe, 0x88, 0xad, 0x01, 0x22, 0x3c, 0x1c,
+  0x19, 0x19, 0x24, 0x34, 0x34, 0x24, 0x19, 0x19, 0x1c, 0x01, 0xe8, 0x02,
+  0x78, 0xfc, 0xdc, 0xb1, 0x53, 0x80, 0x63, 0x81, 0x82, 0x82, 0x81, 0x63,
+  0x80, 0x53, 0xb1, 0x03, 0x24, 0xfa, 0x8e, 0x1b, 0x18, 0x2d, 0x45, 0x49,
+  0x64, 0x63, 0x63, 0x64, 0x49, 0x45, 0x2d, 0x18, 0x1b, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x56, 0xff, 0xe3, 0x03, 0xf4, 0x04, 0x60, 0x00, 0x13,
+  0x00, 0x23, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x33,
+  0x01, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x02, 0x25, 0x01, 0x0b, 0xc4, 0xfe, 0x99, 0x41,
+  0x27, 0x3e, 0x87, 0x87, 0x87, 0x87, 0x3e, 0x27, 0x41, 0xfe, 0x99, 0xc4,
+  0x01, 0x0b, 0x3c, 0x1c, 0x19, 0x23, 0x1c, 0x32, 0x32, 0x1c, 0x23, 0x19,
+  0x1c, 0x02, 0xd1, 0x01, 0x8f, 0xfd, 0xea, 0x62, 0x4c, 0x78, 0x3e, 0x82,
+  0x81, 0x81, 0x82, 0x3e, 0x78, 0x4c, 0x62, 0x02, 0x16, 0xfc, 0x1f, 0x1b,
+  0x18, 0x2d, 0x21, 0x40, 0x32, 0x46, 0x46, 0x32, 0x40, 0x21, 0x2d, 0x18,
+  0x1b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9c, 0xfe, 0x56, 0x03, 0xe9,
+  0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x11, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x9d, 0xa5, 0x70, 0x6f, 0x87, 0x9b, 0xa6, 0xa6, 0x3c, 0x9f,
+  0x6a, 0xad, 0xb4, 0x01, 0xba, 0x02, 0xa6, 0xfd, 0x61, 0x9f, 0x9f, 0xbe,
+  0xa4, 0x02, 0x7b, 0xf9, 0xf6, 0x02, 0x56, 0x66, 0x63, 0xf0, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d,
+  0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86,
+  0x9b, 0xa7, 0x93, 0xa3, 0xe5, 0xd0, 0x5f, 0x45, 0x3b, 0xa1, 0x6a, 0xad,
+  0xb3, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd,
+  0x87, 0x04, 0x7e, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xcc, 0x65, 0x64, 0xef,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x21,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36,
+  0x35, 0x11, 0x10, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x36,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x36, 0x33, 0x32, 0x16,
+  0x03, 0xf4, 0x93, 0xa3, 0xe5, 0xd2, 0x5f, 0x44, 0xdf, 0x86, 0x9b, 0xa7,
+  0x93, 0xa3, 0xe5, 0xd0, 0x5f, 0x45, 0x76, 0xd0, 0xad, 0xb3, 0x02, 0xa4,
+  0xfd, 0x48, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0x02, 0xb2, 0x01, 0x3d, 0xbe,
+  0xa4, 0xfd, 0x87, 0x04, 0x7e, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xcc, 0xc9,
+  0xef, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0c, 0x00, 0x00, 0x01, 0xe8,
+  0x06, 0x14, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33,
+  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x15, 0x23,
+  0xaf, 0xa5, 0x94, 0x94, 0xa5, 0xa2, 0xa2, 0xa5, 0xa5, 0x04, 0x60, 0xfe,
+  0x08, 0xa4, 0xfe, 0x3c, 0x01, 0xc4, 0xa4, 0x03, 0xac, 0xe9, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x30, 0x04, 0x60, 0x10, 0x06,
+  0x03, 0x4d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x68, 0x00, 0x00, 0x02, 0x44,
+  0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x23, 0x11,
+  0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x68, 0x01, 0xdc, 0x98, 0x98, 0xfe,
+  0x24, 0x9f, 0x03, 0xbc, 0xa4, 0xa4, 0xfc, 0xe8, 0xa4, 0xa4, 0x03, 0x18,
+  0x00, 0x01, 0x00, 0x43, 0x00, 0x00, 0x02, 0x96, 0x06, 0x14, 0x00, 0x23,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x11, 0x23, 0x11, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x01, 0x1d, 0xa6, 0x01, 0x02, 0x0f, 0x0c, 0x22, 0x10, 0x10,
+  0x02, 0x71, 0x02, 0x2e, 0x2e, 0x52, 0x12, 0x11, 0xa6, 0x05, 0x05, 0x0f,
+  0x0c, 0x22, 0x10, 0x10, 0x02, 0x70, 0x01, 0x2e, 0x2e, 0x52, 0x16, 0x14,
+  0x06, 0x14, 0xfc, 0xed, 0x01, 0x01, 0x09, 0x25, 0x24, 0x52, 0x87, 0x49,
+  0x4a, 0x04, 0xfd, 0x85, 0x03, 0x02, 0x04, 0x03, 0x09, 0x25, 0x24, 0x52,
+  0x87, 0x49, 0x4a, 0x06, 0x00, 0x02, 0x00, 0x45, 0x00, 0x00, 0x02, 0xff,
+  0x06, 0x14, 0x00, 0x11, 0x00, 0x18, 0x00, 0x00, 0x01, 0x33, 0x11, 0x33,
+  0x15, 0x23, 0x11, 0x23, 0x11, 0x34, 0x27, 0x23, 0x22, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x14, 0x33, 0x01, 0x78, 0xa6,
+  0xe1, 0xe1, 0xa6, 0x01, 0x37, 0xfc, 0x01, 0x01, 0xdd, 0x30, 0x25, 0x0e,
+  0x15, 0x31, 0x46, 0x01, 0x53, 0x06, 0x14, 0xfc, 0xfe, 0xa0, 0xfd, 0x8e,
+  0x02, 0x54, 0x0f, 0x0f, 0xbd, 0xf6, 0x19, 0xfa, 0x84, 0x4b, 0x39, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x02, 0x23, 0x06, 0x14, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
+  0x35, 0x11, 0x01, 0x53, 0x37, 0x6c, 0x2c, 0x3f, 0xac, 0x89, 0x06, 0x14,
+  0xf9, 0xce, 0x7c, 0x74, 0x9c, 0xcc, 0xca, 0x06, 0x28, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0xfe, 0x4c, 0x04, 0xb1, 0x06, 0x14, 0x00, 0x24,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
+  0x11, 0x21, 0x15, 0x02, 0xf0, 0x5e, 0x74, 0x59, 0x4d, 0x49, 0xfe, 0xee,
+  0xfc, 0x55, 0x59, 0x5a, 0x5f, 0x4c, 0xb4, 0x62, 0xaa, 0x5a, 0x5a, 0x53,
+  0x52, 0x96, 0x9d, 0x01, 0x83, 0xfd, 0xac, 0xa5, 0xa5, 0x03, 0x0e, 0x01,
+  0xdc, 0x38, 0x2b, 0x6c, 0x68, 0x8a, 0xdd, 0xf2, 0x12, 0x13, 0x25, 0xc3,
+  0x31, 0x32, 0x4b, 0x4b, 0x8f, 0x84, 0x4b, 0x4a, 0xa6, 0x01, 0xf3, 0xfc,
+  0x33, 0x06, 0x14, 0xfe, 0x4c, 0xa8, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xff, 0xe6, 0x06, 0x67, 0x04, 0x62, 0x00, 0x26, 0x00, 0x00, 0x25, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x03, 0x50, 0x3d, 0x58, 0x56, 0x75, 0x9e, 0xab, 0xa7, 0x66, 0x6a,
+  0x80, 0x4b, 0x4b, 0xa6, 0x67, 0x6b, 0x7f, 0x95, 0xa7, 0xa7, 0x37, 0x51,
+  0x4f, 0x6d, 0x6d, 0x4e, 0x4c, 0xd8, 0x79, 0x3d, 0x3c, 0xf6, 0xe2, 0x02,
+  0xa4, 0xfd, 0x62, 0xa2, 0x9c, 0x60, 0x5e, 0xa4, 0x02, 0x7a, 0xfd, 0x62,
+  0xa2, 0x9c, 0xc0, 0xa2, 0x02, 0x7a, 0xfb, 0x9e, 0xb0, 0x65, 0x33, 0x32,
+  0x3e, 0x3e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x06, 0x67,
+  0x04, 0x62, 0x00, 0x26, 0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
+  0x23, 0x11, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x03, 0x50, 0x3d,
+  0x58, 0x56, 0x75, 0x9e, 0xab, 0xa7, 0x66, 0x6a, 0x80, 0x4b, 0x4b, 0xa6,
+  0x67, 0x6b, 0x7f, 0x95, 0xa7, 0xa7, 0x37, 0x51, 0x4f, 0x6d, 0x6d, 0x4e,
+  0x4c, 0xd8, 0x79, 0x3d, 0x3c, 0xf6, 0xe2, 0x02, 0xa4, 0xfd, 0x62, 0xa2,
+  0x9c, 0x60, 0x5e, 0xa4, 0x02, 0x7a, 0xfd, 0x62, 0xa2, 0x9c, 0xc0, 0xa2,
+  0x02, 0x7a, 0xf9, 0xf4, 0x02, 0x5a, 0x65, 0x33, 0x32, 0x3e, 0x3e, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x06, 0x67, 0x04, 0x7b, 0x00, 0x30,
+  0x00, 0x00, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x14,
+  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x03, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x16, 0x03, 0xbe, 0x3f, 0xac, 0x75, 0x9e, 0x55, 0x56, 0x4a,
+  0x49, 0xa3, 0xe4, 0xd1, 0x5f, 0x22, 0x22, 0x01, 0x66, 0x6a, 0x80, 0x96,
+  0xa6, 0x33, 0x34, 0x6b, 0x7f, 0x4a, 0x4b, 0xa7, 0xa7, 0x39, 0x9e, 0x6d,
+  0x6e, 0x4c, 0x4e, 0x03, 0x89, 0x7c, 0x76, 0x7b, 0x7a, 0xe2, 0xfd, 0x48,
+  0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x02, 0xb2, 0xa1, 0x9c, 0xbe,
+  0xa4, 0xfd, 0x87, 0x02, 0x9e, 0xa2, 0x4e, 0x4d, 0x5f, 0x60, 0xa3, 0xfd,
+  0x87, 0x04, 0x60, 0xae, 0x67, 0x62, 0x3e, 0x3e, 0x00, 0x01, 0xff, 0xde,
+  0xfe, 0x56, 0x03, 0xfa, 0x04, 0x7b, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x14, 0x06, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x03, 0xfa, 0xa6, 0x6f, 0x70, 0x86, 0x9c, 0x92, 0xa3, 0x3f,
+  0x2c, 0x5e, 0x45, 0xa6, 0x3c, 0xa1, 0x69, 0xae, 0xb2, 0x02, 0xa4, 0xfd,
+  0x5c, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x73, 0xd6, 0xc0, 0x9c,
+  0x61, 0x99, 0x04, 0x74, 0xae, 0x65, 0x64, 0xef, 0x00, 0x01, 0x00, 0xa7,
+  0xfe, 0x56, 0x04, 0xc3, 0x04, 0x7b, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x26,
+  0x35, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
+  0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x17, 0x16, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x03, 0x98, 0x4a, 0x70, 0x6f, 0x86, 0x9b, 0xa7,
+  0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3, 0x22, 0x22, 0x5e, 0x2d, 0x3f, 0xa3,
+  0xfe, 0xb6, 0x60, 0xd6, 0x02, 0xb2, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87,
+  0x04, 0x60, 0xae, 0x65, 0x64, 0xef, 0xe8, 0xfd, 0x48, 0x99, 0x31, 0x30,
+  0x9c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa1, 0x00, 0x00, 0x03, 0xf4,
+  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
+  0x23, 0x01, 0x11, 0x23, 0xa1, 0xf5, 0x01, 0xad, 0xb1, 0xf5, 0xfe, 0x53,
+  0xb1, 0x04, 0x60, 0xfc, 0x79, 0x03, 0x87, 0xfb, 0xa0, 0x03, 0x6c, 0xfc,
+  0x94, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x04, 0x7b, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x00, 0x01, 0x22,
+  0x06, 0x07, 0x21, 0x2e, 0x01, 0x03, 0x32, 0x36, 0x35, 0x21, 0x14, 0x16,
+  0x13, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
+  0x02, 0x32, 0x84, 0x86, 0x10, 0x02, 0x35, 0x10, 0x86, 0x84, 0x87, 0x97,
+  0xfd, 0xc5, 0x97, 0x87, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xf5, 0xf5, 0x03,
+  0xdf, 0xc1, 0x7f, 0x7f, 0xc1, 0xfc, 0xa0, 0xe8, 0x94, 0x94, 0xe8, 0x03,
+  0xfc, 0xfe, 0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x39, 0x01,
+  0x13, 0x01, 0x14, 0x01, 0x38, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0x00, 0x00, 0x05, 0x87, 0x04, 0x60, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00,
+  0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x20,
+  0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x21, 0x17, 0x23, 0x22, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x05, 0x7a, 0xfe, 0x0c, 0x01, 0xe0,
+  0xfe, 0x20, 0x02, 0x01, 0xfd, 0x31, 0xfe, 0xdb, 0x96, 0x97, 0x97, 0x96,
+  0x01, 0x25, 0x26, 0x22, 0xd8, 0x6c, 0x6c, 0x6c, 0x6c, 0xd8, 0x22, 0x04,
+  0x60, 0x9a, 0xfe, 0xdd, 0x9b, 0xfe, 0x94, 0x9c, 0x8e, 0x8f, 0x01, 0x14,
+  0x01, 0x12, 0x8e, 0x8f, 0x82, 0x6c, 0x6b, 0xd8, 0xd9, 0x6c, 0x6d, 0x00,
+  0x00, 0x02, 0x00, 0x85, 0xff, 0xdc, 0x04, 0xb8, 0x04, 0x7c, 0x00, 0x13,
+  0x00, 0x24, 0x00, 0x00, 0x01, 0x15, 0x14, 0x16, 0x32, 0x37, 0x36, 0x35,
+  0x10, 0x02, 0x20, 0x02, 0x11, 0x14, 0x17, 0x16, 0x32, 0x36, 0x3d, 0x01,
+  0x05, 0x10, 0x00, 0x20, 0x00, 0x11, 0x14, 0x06, 0x07, 0x06, 0x22, 0x26,
+  0x27, 0x0e, 0x01, 0x22, 0x26, 0x02, 0xf4, 0x56, 0x61, 0x22, 0x42, 0xbc,
+  0xfe, 0x97, 0xb6, 0x42, 0x22, 0x60, 0x56, 0xfe, 0x37, 0x01, 0x22, 0x01,
+  0xec, 0x01, 0x25, 0x34, 0x2a, 0x57, 0xc2, 0x91, 0x0b, 0x10, 0x8e, 0xc0,
+  0xc2, 0x02, 0x94, 0xc4, 0xa3, 0xb5, 0x30, 0x5b, 0x9d, 0x01, 0x0f, 0x01,
+  0x31, 0xfe, 0xd0, 0xfe, 0xf0, 0x9d, 0x5b, 0x30, 0xb5, 0xa3, 0xc4, 0xc8,
+  0x01, 0x54, 0x01, 0x5c, 0xfe, 0xa4, 0xfe, 0x80, 0x6c, 0xb2, 0x36, 0x70,
+  0xa3, 0x75, 0x79, 0x9f, 0xed, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x64,
+  0xfe, 0x56, 0x04, 0x56, 0x06, 0x14, 0x12, 0x06, 0x03, 0x69, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0xff, 0xe5, 0x02, 0x4f, 0x04, 0x60, 0x00, 0x0e,
+  0x00, 0x00, 0x25, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x16, 0x33, 0x32, 0x36,
+  0x35, 0x11, 0x33, 0x11, 0x23, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32, 0x01,
+  0x36, 0x4f, 0x8d, 0x96, 0xa6, 0xa6, 0xae, 0xc9, 0x0a, 0xbd, 0x23, 0xcb,
+  0xbe, 0x02, 0x4e, 0xfb, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0xff, 0xe5, 0x02, 0x4f, 0x06, 0x0a, 0x00, 0x0e, 0x00, 0x00, 0x25, 0x06,
+  0x23, 0x22, 0x2f, 0x01, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
+  0x23, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32, 0x01, 0x36, 0x4f, 0x8f, 0x94,
+  0xa6, 0xa6, 0xae, 0xc9, 0x0a, 0xbd, 0x23, 0xce, 0xbb, 0x03, 0xf8, 0xf9,
+  0xf6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0xfe, 0x56, 0x03, 0x1e,
+  0x04, 0x60, 0x00, 0x16, 0x00, 0x00, 0x25, 0x06, 0x23, 0x22, 0x2f, 0x01,
+  0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x26, 0x35, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32, 0x01,
+  0x36, 0x4f, 0x8d, 0x96, 0xa6, 0x45, 0x5e, 0x2c, 0x3f, 0xa2, 0x93, 0xae,
+  0xc9, 0x0a, 0xbd, 0x23, 0xcb, 0xbe, 0x02, 0x4e, 0xfb, 0x8c, 0x99, 0x61,
+  0x9c, 0xc0, 0xd6, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0x58, 0x02, 0xf6,
+  0x04, 0x7b, 0x00, 0x11, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
+  0x02, 0xf6, 0x1c, 0x42, 0x27, 0x8d, 0x96, 0xa7, 0xa7, 0x34, 0xa8, 0x77,
+  0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11, 0xcb, 0xbe, 0xfc, 0x0a, 0x06,
+  0x08, 0xae, 0x66, 0x63, 0x05, 0x05, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xfe, 0x56, 0x02, 0xf6, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x15, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x26, 0x35, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
+  0x02, 0xf6, 0x1c, 0x42, 0x27, 0x8e, 0x96, 0x44, 0x5f, 0xd2, 0xe5, 0xa3,
+  0x93, 0xa7, 0x34, 0xa8, 0x77, 0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11,
+  0xcb, 0xbe, 0xfd, 0x9e, 0x99, 0x61, 0x9c, 0xc0, 0xd6, 0x04, 0x74, 0xae,
+  0x66, 0x63, 0x05, 0x05, 0x00, 0x01, 0x00, 0x76, 0x00, 0x00, 0x03, 0x25,
+  0x04, 0x7b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x21, 0x35,
+  0x33, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x01, 0xb0,
+  0x94, 0xfe, 0x33, 0x93, 0x93, 0xa3, 0xe5, 0xd2, 0x5f, 0x44, 0x02, 0xe5,
+  0xfd, 0xbf, 0xa4, 0xa4, 0x02, 0x41, 0xd6, 0xc0, 0x9c, 0x61, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x68, 0x00, 0x00, 0x03, 0x25, 0x04, 0x7b, 0x00, 0x0f,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x34, 0x26,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x02, 0x83, 0xa2, 0xfe, 0x24, 0x94,
+  0x44, 0x5f, 0xd2, 0xe5, 0xa3, 0x93, 0x02, 0xe5, 0xfd, 0xbf, 0xa4, 0xa4,
+  0x02, 0x41, 0x99, 0x61, 0x9c, 0xc0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x22, 0x04, 0x60, 0x00, 0x13, 0x00, 0x1c, 0x00, 0x00,
+  0x01, 0x1e, 0x01, 0x17, 0x13, 0x23, 0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11,
+  0x23, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x02, 0xc5, 0x2b, 0x68, 0x2d, 0x9d, 0xb0,
+  0x92, 0x42, 0x6f, 0x49, 0x98, 0xa7, 0x01, 0x5e, 0xc4, 0xc0, 0x64, 0xfe,
+  0x29, 0xb2, 0x6b, 0x73, 0x6a, 0x74, 0x02, 0x0d, 0x0a, 0x74, 0x5d, 0xfe,
+  0xce, 0x01, 0x1f, 0x80, 0x3a, 0xfe, 0x27, 0x04, 0x60, 0x9e, 0xa5, 0x69,
+  0x8c, 0x01, 0x9d, 0xfe, 0xaf, 0x56, 0x4e, 0x4d, 0x60, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x22, 0x04, 0x60, 0x00, 0x13,
+  0x00, 0x1c, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x32, 0x36, 0x37, 0x13,
+  0x33, 0x03, 0x0e, 0x01, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21,
+  0x13, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0xa7, 0xa7, 0x98,
+  0x49, 0x6f, 0x42, 0x92, 0xb0, 0x9d, 0x2d, 0x68, 0x2b, 0x60, 0x64, 0xc0,
+  0xc4, 0xfe, 0xa2, 0xa7, 0xb2, 0x74, 0x6a, 0x73, 0x6b, 0x04, 0x60, 0xfe,
+  0x27, 0x3a, 0x80, 0x01, 0x1f, 0xfe, 0xce, 0x5d, 0x74, 0x0a, 0x1b, 0x8c,
+  0x69, 0xa5, 0x9e, 0x01, 0xec, 0xfe, 0xaf, 0x60, 0x4d, 0x4e, 0x56, 0x00,
+  0x00, 0x01, 0x00, 0x63, 0xfe, 0x56, 0x03, 0x67, 0x04, 0x7b, 0x00, 0x30,
+  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x1f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x15,
+  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36,
+  0x33, 0x32, 0x16, 0x03, 0x30, 0x46, 0x97, 0x51, 0x7b, 0x7c, 0x59, 0x85,
+  0x38, 0xb1, 0x94, 0xde, 0xc2, 0x5b, 0x4f, 0x12, 0x44, 0x5e, 0xd2, 0xe4,
+  0xa3, 0x93, 0xb7, 0xae, 0x75, 0x7e, 0x5b, 0x9a, 0x39, 0x9a, 0x89, 0xca,
+  0xb9, 0x5c, 0xa2, 0x04, 0x3f, 0xae, 0x28, 0x28, 0x54, 0x54, 0x40, 0x49,
+  0x21, 0x0e, 0x2a, 0x99, 0x89, 0x9c, 0xb6, 0x11, 0x04, 0x0c, 0x99, 0x61,
+  0x9c, 0xc0, 0xd6, 0xfb, 0x6a, 0x59, 0x51, 0x4b, 0x50, 0x25, 0x0f, 0x24,
+  0x95, 0x82, 0x9e, 0xac, 0x1e, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xdc,
+  0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x13, 0x00, 0x00, 0x17, 0x11,
+  0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11, 0x14, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0xab, 0x9d, 0xaa, 0x9c, 0x9e, 0x59,
+  0x45, 0x93, 0xa3, 0x3f, 0x2c, 0x5f, 0x43, 0x14, 0x04, 0xc2, 0xbb, 0xab,
+  0x99, 0x50, 0x68, 0xfb, 0x29, 0xd6, 0xc0, 0x9c, 0x61, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xdc, 0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x20,
+  0x00, 0x00, 0x13, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06,
+  0x15, 0x11, 0x15, 0x33, 0x15, 0x23, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x36, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x23, 0x35, 0xab,
+  0x9d, 0xaa, 0x9c, 0x9e, 0x59, 0x45, 0x92, 0x92, 0x93, 0xa3, 0x3f, 0x2c,
+  0x5f, 0x43, 0xa2, 0xa2, 0x9e, 0x04, 0x60, 0x4e, 0xbb, 0xab, 0x99, 0x50,
+  0x68, 0xfd, 0xa8, 0x03, 0xa4, 0xfe, 0x28, 0xd6, 0xc0, 0x9c, 0x61, 0x99,
+  0x01, 0xd8, 0xa4, 0x01, 0x69, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31,
+  0xfe, 0x56, 0x02, 0xe3, 0x04, 0x65, 0x00, 0x13, 0x00, 0x00, 0x05, 0x11,
+  0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x16,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x01, 0x6e, 0x45, 0x59, 0x9e, 0x9c,
+  0xaa, 0x9d, 0x43, 0x5f, 0x2c, 0x3f, 0xa3, 0x93, 0x14, 0x03, 0x28, 0x68,
+  0x50, 0x99, 0xab, 0xbb, 0xfc, 0xed, 0x99, 0x61, 0x9c, 0xc0, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0x0d, 0xfe, 0x56, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x16,
+  0x00, 0x1f, 0x00, 0x00, 0x21, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x23,
+  0x20, 0x35, 0x34, 0x3b, 0x01, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x06, 0x15, 0x03, 0x23, 0x22, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x01, 0x52, 0xa4, 0xac, 0x10, 0x30, 0x49, 0xa3, 0xfe, 0xef, 0xf3, 0xab,
+  0x9d, 0xaa, 0x9c, 0x9e, 0x59, 0x45, 0xb0, 0xa1, 0x6b, 0x02, 0x03, 0x70,
+  0x63, 0x1e, 0x0e, 0x9b, 0x6f, 0x40, 0x60, 0xd8, 0xd2, 0x04, 0xae, 0xbb,
+  0xab, 0x99, 0x50, 0x68, 0xfa, 0xa3, 0x33, 0x41, 0x30, 0x18, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x31, 0xfe, 0xc0, 0x02, 0xa7, 0x04, 0x5e, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x34, 0x26, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x16, 0x15, 0x11, 0x33, 0x15, 0x23, 0x11, 0x01, 0x87,
+  0xfe, 0xab, 0x01, 0x55, 0x44, 0x67, 0xaa, 0xaa, 0xbf, 0x92, 0x7a, 0x7a,
+  0xfe, 0xc0, 0x01, 0x3e, 0x8f, 0x02, 0x60, 0x89, 0x4e, 0x9a, 0x9f, 0xd2,
+  0xfd, 0xa0, 0x8f, 0xfe, 0xc2, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31,
+  0xfe, 0x56, 0x02, 0xab, 0x05, 0x9e, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
+  0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52, 0x01, 0x55, 0xfe, 0xab,
+  0x44, 0x5e, 0xb6, 0xc9, 0xa3, 0x93, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2,
+  0x8f, 0xfc, 0x1b, 0x99, 0x61, 0x9c, 0xc0, 0xd6, 0x03, 0xe5, 0x8f, 0x01,
+  0x3e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0xff, 0xe3, 0x04, 0x91,
+  0x04, 0x60, 0x00, 0x16, 0x00, 0x1e, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x35, 0x0e, 0x01,
+  0x23, 0x22, 0x26, 0x3d, 0x01, 0x23, 0x35, 0x05, 0x21, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x9d, 0xa5, 0x02, 0x01, 0xa6, 0xa7, 0xa7, 0xa6, 0x3c,
+  0x9f, 0x6a, 0xad, 0xb4, 0x9d, 0x03, 0x42, 0xfe, 0x00, 0x70, 0x6f, 0x81,
+  0xa0, 0x02, 0x68, 0x01, 0xf8, 0xfe, 0x08, 0x01, 0xf8, 0xfe, 0x08, 0xa4,
+  0xfe, 0x3c, 0xac, 0x66, 0x63, 0xf0, 0xe7, 0x0a, 0xa4, 0xa5, 0x02, 0x9f,
+  0x9f, 0xba, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe2, 0x04, 0x11,
+  0x04, 0x60, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x23, 0x1e, 0x01, 0x15, 0x14,
+  0x00, 0x23, 0x22, 0x00, 0x35, 0x34, 0x36, 0x37, 0x23, 0x35, 0x21, 0x15,
+  0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27,
+  0x37, 0x21, 0x04, 0x10, 0xd4, 0x57, 0x73, 0xff, 0x00, 0xca, 0xcb, 0xff,
+  0x00, 0x73, 0x57, 0xd5, 0x01, 0x8e, 0x5c, 0x7b, 0x9f, 0x81, 0x82, 0x9e,
+  0x7a, 0x5c, 0x01, 0x01, 0x88, 0x03, 0xbc, 0x48, 0xeb, 0x98, 0xeb, 0xfe,
+  0xdc, 0x01, 0x24, 0xeb, 0x98, 0xeb, 0x48, 0xa4, 0xdc, 0x42, 0xd7, 0x8b,
+  0x9f, 0xc2, 0xc2, 0x9f, 0x8b, 0xd7, 0x42, 0xdc, 0x00, 0x01, 0x00, 0xad,
+  0x00, 0x00, 0x03, 0xed, 0x04, 0x62, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x14,
+  0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14,
+  0x17, 0x16, 0x37, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x35,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x03, 0xec, 0x7f, 0x83, 0xc8, 0x3f, 0xa3,
+  0x49, 0x49, 0xa5, 0x23, 0x24, 0x5c, 0x2e, 0x82, 0x9e, 0x42, 0x42, 0x63,
+  0x5d, 0x50, 0x96, 0x2e, 0x1e, 0x02, 0x0f, 0xee, 0x8f, 0x92, 0x60, 0x60,
+  0xd6, 0x02, 0xca, 0xfd, 0x36, 0x99, 0x31, 0x32, 0x02, 0xc4, 0x9e, 0xe8,
+  0x65, 0x63, 0x1e, 0x96, 0x08, 0x30, 0x5b, 0xab, 0x73, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x06,
+  0x00, 0x00, 0x33, 0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0x37, 0x01, 0x7a,
+  0xe1, 0x01, 0x7a, 0xb0, 0xfe, 0xc5, 0xfe, 0xc5, 0x04, 0x60, 0xfb, 0xa0,
+  0x03, 0xac, 0xfc, 0x54, 0x00, 0x01, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
+  0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x21, 0x23, 0x0b, 0x01, 0x23, 0x0b,
+  0x01, 0x23, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x05, 0x96, 0xa6, 0xce, 0xcf,
+  0xc3, 0xcf, 0xce, 0xa6, 0x01, 0x08, 0xc3, 0xd9, 0xda, 0xc3, 0x03, 0x6a,
+  0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96, 0x04, 0x60, 0xfc, 0x6a, 0x03, 0x96,
+  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x11,
+  0x00, 0x00, 0x33, 0x01, 0x36, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x07, 0x06, 0x0f, 0x01, 0x01, 0x23, 0x09, 0x01, 0x37, 0x01, 0xbb, 0x47,
+  0x41, 0x43, 0x70, 0x84, 0x61, 0x45, 0x25, 0x29, 0x2b, 0x1e, 0x01, 0x98,
+  0xb0, 0xfe, 0xc4, 0xfe, 0xc6, 0x04, 0xd2, 0xc7, 0x3e, 0x3d, 0x9a, 0x24,
+  0x23, 0x87, 0x5e, 0xfb, 0xb2, 0x03, 0x6c, 0xfc, 0x94, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5b, 0x00, 0x00, 0x03, 0xfa, 0x04, 0x60, 0x00, 0x08,
+  0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01, 0x11, 0x23, 0x11, 0x5c,
+  0xc3, 0x01, 0x08, 0x01, 0x10, 0xc3, 0xfe, 0x87, 0xb7, 0x04, 0x60, 0xfe,
+  0x38, 0x01, 0xc8, 0xfd, 0x90, 0xfe, 0x10, 0x01, 0xf0, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x4f, 0xfe, 0x56, 0x04, 0x46, 0x04, 0x60, 0x00, 0x13,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15, 0x14, 0x16, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x21, 0x35, 0x01, 0x21, 0x66, 0x03,
+  0x12, 0xfd, 0x92, 0x02, 0x6e, 0x45, 0x5e, 0x2b, 0x40, 0xa2, 0x93, 0xfd,
+  0x7e, 0x02, 0x6f, 0xfd, 0xa8, 0x04, 0x60, 0xa8, 0xfc, 0xdb, 0xa7, 0x99,
+  0x61, 0x9c, 0xc0, 0xd6, 0x14, 0xa8, 0x03, 0x25, 0x00, 0x02, 0x00, 0x4f,
+  0xff, 0x91, 0x03, 0x79, 0x04, 0x60, 0x00, 0x1a, 0x00, 0x21, 0x00, 0x00,
+  0x13, 0x21, 0x15, 0x01, 0x33, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x16, 0x07, 0x06, 0x2b, 0x01, 0x06, 0x15, 0x23, 0x34, 0x37, 0x21,
+  0x35, 0x01, 0x21, 0x01, 0x33, 0x32, 0x35, 0x34, 0x07, 0x06, 0x66, 0x03,
+  0x12, 0xfd, 0x92, 0x9d, 0x1e, 0x4c, 0x3b, 0x56, 0x77, 0x34, 0x22, 0x01,
+  0x38, 0x49, 0x72, 0x5e, 0x03, 0x8a, 0x03, 0xfe, 0xba, 0x02, 0x6f, 0xfd,
+  0xa8, 0x01, 0xcc, 0x32, 0x7c, 0x3f, 0x4f, 0x04, 0x60, 0xa8, 0xfc, 0xdb,
+  0xa2, 0x47, 0x37, 0x57, 0x39, 0x57, 0x60, 0x2f, 0x3d, 0x33, 0x3c, 0x3b,
+  0x34, 0xa8, 0x03, 0x25, 0xfc, 0xc6, 0x36, 0x5d, 0x02, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0xc4, 0x04, 0x60, 0x00, 0x20,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x35, 0x21, 0x15, 0x02,
+  0x03, 0x5f, 0x73, 0x59, 0x4d, 0x49, 0xfe, 0xee, 0xfc, 0x54, 0x59, 0x5a,
+  0x60, 0x4c, 0xb4, 0x62, 0xab, 0x59, 0x5a, 0x53, 0x54, 0x94, 0x9d, 0x01,
+  0x83, 0xfd, 0xa8, 0x03, 0x13, 0x01, 0xdc, 0x38, 0x2a, 0x6d, 0x68, 0x8a,
+  0xdd, 0xf2, 0x12, 0x13, 0x25, 0xc3, 0x31, 0x32, 0x4b, 0x4b, 0x8f, 0x84,
+  0x4b, 0x4a, 0xa6, 0x01, 0xf3, 0x93, 0xa8, 0x00, 0x00, 0x02, 0x00, 0x62,
+  0xfe, 0x4c, 0x03, 0xfb, 0x04, 0x60, 0x00, 0x24, 0x00, 0x2d, 0x00, 0x00,
+  0x01, 0x20, 0x37, 0x36, 0x05, 0x16, 0x17, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x2b, 0x01, 0x35, 0x01, 0x21, 0x35, 0x21, 0x15, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x15, 0x23, 0x34, 0x27, 0x30, 0x07,
+  0x06, 0x37, 0x26, 0x23, 0x22, 0x07, 0x14, 0x33, 0x32, 0x37, 0x01, 0xb6,
+  0xfe, 0xd3, 0x02, 0x01, 0x01, 0x0d, 0xdd, 0x8e, 0x0b, 0x53, 0x54, 0x94,
+  0x9d, 0x01, 0x83, 0xfd, 0xa8, 0x03, 0x13, 0xfe, 0x8e, 0x5e, 0x74, 0x5a,
+  0x4c, 0x49, 0x23, 0x5a, 0x8a, 0x24, 0x12, 0x88, 0x08, 0x70, 0xb1, 0x76,
+  0x01, 0x8e, 0xab, 0x59, 0xfe, 0x4c, 0xbd, 0xfb, 0x05, 0x04, 0x3b, 0x2a,
+  0x31, 0x85, 0x4a, 0x4a, 0xa6, 0x01, 0xf3, 0x93, 0xa8, 0xfe, 0x24, 0x38,
+  0x2b, 0x6c, 0x67, 0x8b, 0x71, 0x55, 0x65, 0xa4, 0x52, 0x38, 0x11, 0x79,
+  0xfa, 0x2a, 0x4b, 0x2f, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f,
+  0x00, 0x00, 0x03, 0x48, 0x06, 0x12, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
+  0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x11, 0x23, 0x01, 0x32, 0x39, 0xad, 0x4d, 0x34, 0x01, 0x33, 0x59,
+  0xa1, 0x48, 0x47, 0x47, 0x46, 0x45, 0x48, 0x49, 0x4d, 0xf7, 0x7d, 0x62,
+  0x62, 0x64, 0x99, 0xb6, 0x03, 0x1e, 0x72, 0x4c, 0x62, 0x85, 0x41, 0x72,
+  0x16, 0x15, 0x2b, 0xac, 0x23, 0x11, 0x12, 0x9d, 0x7d, 0xba, 0xaa, 0x73,
+  0x77, 0x1e, 0xfd, 0x74, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48,
+  0x06, 0x12, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x33, 0x02,
+  0x64, 0xb6, 0x99, 0x65, 0x61, 0x63, 0x7c, 0xf7, 0x4d, 0x48, 0x49, 0x45,
+  0x46, 0x48, 0x46, 0x48, 0xa1, 0x59, 0x33, 0x01, 0x34, 0x4d, 0xad, 0x03,
+  0x1e, 0xfc, 0xe2, 0x02, 0x8c, 0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d, 0x9d,
+  0x12, 0x11, 0x23, 0xac, 0x2b, 0x15, 0x16, 0x72, 0x41, 0x85, 0x62, 0x4c,
+  0x72, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48,
+  0x06, 0x12, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x13, 0x33, 0x11, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x34, 0x27, 0x26, 0x23, 0x01,
+  0x32, 0x01, 0xb6, 0x99, 0x64, 0x62, 0x62, 0x7d, 0xf7, 0x4d, 0x49, 0x48,
+  0x45, 0x46, 0x47, 0x47, 0x48, 0xa1, 0x59, 0x33, 0x01, 0x34, 0x4d, 0xad,
+  0x02, 0xf4, 0x03, 0x1e, 0xfd, 0x74, 0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d,
+  0x9d, 0x12, 0x11, 0x23, 0xac, 0x2b, 0x15, 0x16, 0x72, 0x41, 0x85, 0x62,
+  0x4c, 0x72, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0x48,
+  0x06, 0x14, 0x00, 0x23, 0x00, 0x00, 0x13, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
+  0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x4f, 0x63, 0x7c, 0xf7, 0x4d, 0x48,
+  0x49, 0x45, 0x42, 0x4c, 0x46, 0x48, 0x9f, 0x5b, 0x34, 0x34, 0x5c, 0x9e,
+  0x48, 0x46, 0x48, 0x46, 0x45, 0x49, 0x48, 0x4d, 0xf7, 0x7c, 0x63, 0x04,
+  0x40, 0xba, 0x7d, 0x9d, 0x12, 0x11, 0x23, 0xac, 0x28, 0x18, 0x16, 0x72,
+  0x41, 0x85, 0xfb, 0xe0, 0x85, 0x41, 0x72, 0x16, 0x15, 0x2b, 0xac, 0x23,
+  0x11, 0x12, 0x9d, 0x7d, 0xba, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x22,
+  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x06, 0x22, 0x27, 0x26, 0x00, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20, 0x12,
+  0x11, 0x10, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x10,
+  0x00, 0x02, 0x70, 0x1e, 0x1d, 0x2b, 0x2a, 0x1e, 0x1d, 0x3b, 0x55, 0x1d,
+  0x1e, 0x01, 0x2c, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0xfe, 0x52,
+  0x01, 0x1b, 0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad,
+  0x01, 0x53, 0x02, 0xe9, 0x2e, 0x22, 0x22, 0x22, 0x22, 0x2e, 0x2f, 0x42,
+  0x21, 0x21, 0x02, 0x92, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8,
+  0x01, 0x48, 0x01, 0x1a, 0x01, 0x1b, 0x01, 0xec, 0xfe, 0x5b, 0xfe, 0x9e,
+  0xfe, 0x9f, 0xfe, 0x5b, 0x01, 0xa4, 0x02, 0xc4, 0x01, 0xa5, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xd2, 0x04, 0x60, 0x10, 0x06,
+  0x03, 0xc6, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x4b,
+  0x04, 0x7c, 0x00, 0x1a, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
+  0x20, 0x17, 0x16, 0x11, 0x10, 0x00, 0x21, 0x22, 0x26, 0x35, 0x34, 0x36,
+  0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x02, 0x0b, 0x6b, 0x3e,
+  0x3f, 0x3d, 0x3c, 0x69, 0x8b, 0x85, 0x7b, 0x41, 0x46, 0x4b, 0x4d, 0x88,
+  0xbd, 0x5d, 0x59, 0x59, 0x57, 0xef, 0x01, 0x3e, 0x88, 0x88, 0xfe, 0xf4,
+  0xfe, 0xe5, 0xd6, 0xe8, 0x7c, 0x70, 0x65, 0x36, 0x36, 0x66, 0x66, 0x03,
+  0xdc, 0x2e, 0x2e, 0x40, 0x46, 0x2d, 0x2c, 0x98, 0x33, 0x38, 0x58, 0x5a,
+  0x38, 0x38, 0x74, 0x6f, 0xd0, 0xcd, 0x72, 0x6e, 0xa0, 0x9e, 0x9d, 0xfe,
+  0xee, 0xfe, 0xf2, 0xfe, 0xc2, 0xb6, 0xad, 0x6c, 0x92, 0x18, 0x18, 0x41,
+  0x40, 0x5d, 0x8d, 0x4f, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
+  0xff, 0xe3, 0x05, 0x37, 0x06, 0x14, 0x00, 0x27, 0x00, 0x00, 0x25, 0x11,
+  0x23, 0x35, 0x21, 0x11, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00,
+  0x33, 0x32, 0x16, 0x17, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x06, 0x15, 0x11, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x03, 0x4b, 0x8b, 0x01, 0x21, 0x5b, 0xc2, 0x6e, 0xe4, 0xfe,
+  0xf4, 0x01, 0x0f, 0xeb, 0x32, 0x5e, 0x2c, 0x93, 0xa3, 0xe5, 0xd0, 0x5f,
+  0x45, 0x55, 0xad, 0x59, 0xa2, 0xb2, 0xb2, 0xa2, 0x47, 0x6f, 0x9e, 0x01,
+  0x11, 0x8c, 0xfd, 0xf0, 0x24, 0x24, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12,
+  0x01, 0x3a, 0x0f, 0x0f, 0x21, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xfe, 0xe5,
+  0x3e, 0x3e, 0xe3, 0xcd, 0xcd, 0xe3, 0x0f, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x0e, 0x04, 0x60, 0x10, 0x06, 0x03, 0xd1, 0x00, 0x00,
+  0x00, 0x03, 0xff, 0x0d, 0xfe, 0x56, 0x01, 0xf7, 0x06, 0x14, 0x00, 0x03,
+  0x00, 0x12, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x15, 0x33,
+  0x11, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x23, 0x20, 0x35, 0x34, 0x3b,
+  0x01, 0x07, 0x23, 0x22, 0x15, 0x14, 0x33, 0x32, 0x37, 0x36, 0xae, 0xa5,
+  0xa5, 0xa5, 0xa3, 0xaa, 0x10, 0x32, 0x43, 0xa9, 0xfe, 0xef, 0xf3, 0xae,
+  0x08, 0xa5, 0x69, 0x73, 0x56, 0x26, 0x1a, 0x06, 0x14, 0xe9, 0xcb, 0xfb,
+  0xa0, 0x8b, 0x78, 0x47, 0x60, 0xdd, 0xcd, 0x8b, 0x42, 0x41, 0x30, 0x20,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x4c, 0x04, 0x26, 0x04, 0x60, 0x00, 0x0a,
+  0x00, 0x00, 0x01, 0x23, 0x11, 0x01, 0x23, 0x09, 0x01, 0x33, 0x01, 0x11,
+  0x33, 0x04, 0x26, 0xa6, 0xfe, 0x11, 0xd3, 0x02, 0x16, 0xfd, 0xd3, 0xd8,
+  0x02, 0x01, 0xa6, 0xfe, 0x4c, 0x03, 0x97, 0xfe, 0x1d, 0x02, 0x0c, 0x02,
+  0x54, 0xfd, 0xdd, 0x02, 0x23, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0x8d, 0x04, 0x60, 0x00, 0x05, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x21, 0x15, 0x21, 0xa7, 0xa6, 0x02, 0x3f, 0xfd, 0x1b, 0x04, 0x60,
+  0xfc, 0x33, 0x93, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x05, 0x60,
+  0x06, 0x12, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01, 0x0e, 0x01, 0x23,
+  0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x34, 0x36,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x01, 0x11, 0x96,
+  0x83, 0x84, 0x97, 0x97, 0x84, 0x83, 0x96, 0x02, 0x34, 0x34, 0x9f, 0x70,
+  0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0x93, 0xa3, 0xe4, 0xd0, 0x5e,
+  0x45, 0xa7, 0x02, 0x2f, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0xfd,
+  0xae, 0x64, 0x61, 0x01, 0x44, 0x01, 0x08, 0x01, 0x08, 0x01, 0x44, 0x61,
+  0x64, 0xc6, 0xd6, 0xc0, 0x9c, 0x61, 0x99, 0xf9, 0xda, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48, 0x06, 0x12, 0x00, 0x24,
+  0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x26, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11,
+  0x23, 0x35, 0x33, 0x01, 0x32, 0x39, 0xac, 0x4e, 0x34, 0x01, 0x33, 0x59,
+  0xa1, 0x48, 0x47, 0x47, 0x46, 0x45, 0x48, 0x49, 0x4d, 0xf7, 0x7d, 0x62,
+  0x62, 0x64, 0x99, 0xd0, 0xd0, 0xb6, 0xce, 0xcd, 0x03, 0x1e, 0x72, 0x4c,
+  0x62, 0x85, 0x41, 0x72, 0x16, 0x15, 0x2b, 0xac, 0x23, 0x11, 0x12, 0x9d,
+  0x7d, 0xba, 0xaa, 0x73, 0x77, 0x1e, 0xd4, 0xa4, 0xfe, 0xec, 0x01, 0x14,
+  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x48,
+  0x06, 0x12, 0x00, 0x24, 0x00, 0x00, 0x13, 0x35, 0x33, 0x35, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x3b, 0x01,
+  0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0xde, 0xd0, 0x99, 0x65, 0x61,
+  0x63, 0x7c, 0xf7, 0x4d, 0x48, 0x49, 0x45, 0x47, 0x47, 0x46, 0x48, 0xa1,
+  0x59, 0x33, 0x01, 0x34, 0x4d, 0xad, 0x38, 0xce, 0xce, 0xb6, 0x01, 0x14,
+  0xa4, 0xd4, 0x1e, 0x77, 0x73, 0xaa, 0xba, 0x7d, 0x9d, 0x12, 0x11, 0x23,
+  0xac, 0x2b, 0x15, 0x16, 0x72, 0x41, 0x85, 0x62, 0x4c, 0x72, 0xfe, 0x9a,
+  0xa4, 0xfe, 0xec, 0x01, 0x14, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
+  0xff, 0xe3, 0x06, 0xfd, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x26, 0x00, 0x29,
+  0x00, 0x00, 0x00, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x10, 0x27, 0x26,
+  0x20, 0x07, 0x25, 0x11, 0x33, 0x11, 0x21, 0x15, 0x01, 0x21, 0x15, 0x21,
+  0x2b, 0x01, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x11, 0x01, 0x01, 0x11, 0x4a, 0x4c,
+  0x01, 0x07, 0x4b, 0x4c, 0x4c, 0x4b, 0xfe, 0xf9, 0x4c, 0x01, 0xea, 0xa6,
+  0x03, 0x11, 0xfd, 0x92, 0x02, 0x6e, 0xfc, 0xef, 0x18, 0x8e, 0x34, 0x4f,
+  0x50, 0x70, 0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50, 0x4f, 0xda,
+  0x02, 0x57, 0x02, 0xfa, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x74, 0x01, 0x96,
+  0x74, 0x73, 0x73, 0x48, 0x02, 0x5e, 0xfe, 0x4c, 0xa8, 0xfc, 0xdb, 0x93,
+  0xa8, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0x02, 0x10, 0xa2, 0xa2, 0x31, 0x30,
+  0x4d, 0xfc, 0xf9, 0x03, 0x07, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xfe, 0x4c, 0x07, 0x4d, 0x06, 0x14, 0x00, 0x34, 0x00, 0x40, 0x00, 0x00,
+  0x01, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x11, 0x33, 0x11, 0x21, 0x15,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x2b, 0x01, 0x35, 0x01, 0x04, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36,
+  0x10, 0x27, 0x26, 0x20, 0x07, 0x03, 0xeb, 0xa6, 0x34, 0x4f, 0x50, 0x70,
+  0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50, 0x4f, 0x34, 0xa6, 0x03,
+  0x12, 0xfe, 0x8e, 0x60, 0x73, 0x58, 0x4e, 0x48, 0xfe, 0xef, 0xfc, 0x55,
+  0x59, 0x5a, 0x5f, 0x4b, 0xb4, 0x62, 0xab, 0x5a, 0x5a, 0x53, 0x54, 0x95,
+  0x9c, 0x01, 0x83, 0xfa, 0xce, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x4c, 0x4c,
+  0x4b, 0xfe, 0xf9, 0x4c, 0x03, 0xcd, 0xfc, 0x33, 0xa8, 0x64, 0x30, 0x31,
+  0xa2, 0xa2, 0x02, 0x10, 0xa2, 0xa2, 0x31, 0x30, 0x64, 0x02, 0x5e, 0xfe,
+  0x4c, 0xa8, 0xfe, 0x24, 0x38, 0x2a, 0x6d, 0x68, 0x8a, 0xdd, 0xf2, 0x12,
+  0x13, 0x25, 0xc3, 0x31, 0x32, 0x4b, 0x4b, 0x8f, 0x84, 0x4b, 0x4a, 0xa6,
+  0x01, 0xf3, 0xd3, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x74, 0x01, 0x96, 0x74,
+  0x73, 0x73, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65, 0xff, 0x91, 0x06, 0xfc,
+  0x06, 0x14, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x33, 0x00, 0x3a, 0x00, 0x00,
+  0x00, 0x10, 0x17, 0x16, 0x20, 0x37, 0x36, 0x10, 0x27, 0x26, 0x20, 0x07,
+  0x25, 0x11, 0x01, 0x25, 0x21, 0x15, 0x01, 0x33, 0x12, 0x33, 0x32, 0x15,
+  0x16, 0x21, 0x23, 0x06, 0x15, 0x23, 0x34, 0x37, 0x21, 0x23, 0x35, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x11, 0x33, 0x01, 0x33, 0x32, 0x35, 0x34, 0x23, 0x06, 0x01,
+  0x11, 0x4a, 0x4c, 0x01, 0x07, 0x4b, 0x4c, 0x4c, 0x4b, 0xfe, 0xf9, 0x4c,
+  0x02, 0x90, 0x02, 0x56, 0xfd, 0xaa, 0x03, 0x10, 0xfd, 0x92, 0x9d, 0x36,
+  0xc5, 0xcd, 0x01, 0xfe, 0xd4, 0x25, 0x03, 0x8a, 0x03, 0xfe, 0xba, 0x8d,
+  0x34, 0x4f, 0x50, 0x70, 0xb7, 0x73, 0x72, 0x72, 0x73, 0xb7, 0x70, 0x50,
+  0x4f, 0x34, 0xa6, 0x01, 0xca, 0x12, 0x9c, 0x3f, 0x4f, 0x02, 0xfa, 0xfe,
+  0x6a, 0x74, 0x73, 0x73, 0x74, 0x01, 0x96, 0x74, 0x73, 0x73, 0x5f, 0xfc,
+  0xfa, 0x03, 0x06, 0x93, 0xa8, 0xfc, 0xdb, 0x01, 0x20, 0xf6, 0xbd, 0x33,
+  0x3c, 0x3b, 0x34, 0xa8, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0x02, 0x10, 0xa2,
+  0xa2, 0x31, 0x30, 0x64, 0x02, 0x5e, 0xfa, 0x7f, 0x36, 0x5b, 0x02, 0x00,
+  0x00, 0x01, 0x00, 0x31, 0x00, 0x00, 0x05, 0xa0, 0x05, 0x9e, 0x00, 0x37,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x17, 0x16, 0x33,
+  0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35,
+  0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x52,
+  0x01, 0x55, 0xfe, 0xab, 0x21, 0x22, 0x67, 0x02, 0x07, 0x75, 0x3f, 0x3f,
+  0x55, 0xa0, 0x39, 0x9a, 0x89, 0xc9, 0xba, 0x5c, 0xa2, 0x44, 0x46, 0x97,
+  0x51, 0x7c, 0x7b, 0x58, 0x85, 0x39, 0xb2, 0x93, 0x70, 0x44, 0xed, 0xfd,
+  0xfd, 0xbf, 0x49, 0x49, 0x79, 0x79, 0x05, 0x9e, 0xfe, 0xc2, 0x8f, 0xfd,
+  0xa0, 0x89, 0x27, 0x27, 0x2d, 0x2c, 0x34, 0x49, 0x4d, 0x2a, 0x0f, 0x24,
+  0x95, 0x82, 0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x54, 0x54, 0x40,
+  0x49, 0x21, 0x0e, 0x2c, 0x97, 0x89, 0x92, 0x65, 0x3e, 0x50, 0x4f, 0xd2,
+  0x02, 0x60, 0x8f, 0x01, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x31,
+  0xfe, 0x56, 0x04, 0x88, 0x06, 0x14, 0x00, 0x26, 0x00, 0x2f, 0x00, 0x00,
+  0x01, 0x11, 0x21, 0x30, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x07, 0x06, 0x15, 0x13, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x3d, 0x01, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23,
+  0x35, 0x33, 0x11, 0x01, 0x02, 0x11, 0x21, 0x11, 0x14, 0x17, 0x16, 0x33,
+  0x01, 0x52, 0x01, 0x52, 0x4e, 0x49, 0xb0, 0x9c, 0x9e, 0x59, 0x22, 0x24,
+  0x02, 0x49, 0x49, 0xa3, 0x3f, 0x2c, 0x5e, 0x22, 0x23, 0xab, 0xbf, 0x49,
+  0x49, 0x79, 0x79, 0x01, 0xfb, 0x02, 0xfe, 0xae, 0x21, 0x22, 0x67, 0x05,
+  0x9e, 0xfe, 0xc2, 0x4e, 0xb5, 0x5b, 0x56, 0x99, 0x28, 0x28, 0x68, 0xfb,
+  0x29, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x14, 0x50, 0x4f, 0xd2,
+  0x02, 0x60, 0x8f, 0x01, 0x3e, 0xfa, 0xfc, 0x01, 0xa2, 0x01, 0x95, 0xfd,
+  0xa0, 0x89, 0x27, 0x27, 0x00, 0x03, 0x00, 0x31, 0xff, 0x70, 0x05, 0x35,
+  0x05, 0x9e, 0x00, 0x2d, 0x00, 0x39, 0x00, 0x44, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x15, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x10, 0x1f, 0x01, 0x36, 0x33, 0x20, 0x17, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x06, 0x15, 0x07, 0x34, 0x37, 0x23, 0x22,
+  0x27, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x05, 0x26, 0x35, 0x10,
+  0x37, 0x21, 0x11, 0x14, 0x17, 0x16, 0x33, 0x01, 0x52, 0x01, 0x55, 0x86,
+  0xe5, 0x4d, 0x49, 0x48, 0x45, 0x46, 0x47, 0x47, 0x48, 0xa1, 0x59, 0x59,
+  0x59, 0x07, 0x48, 0xb9, 0x01, 0x0d, 0x01, 0x5b, 0x44, 0x8d, 0x4b, 0x42,
+  0x02, 0x8a, 0x06, 0xfa, 0xbf, 0x49, 0x49, 0x79, 0x79, 0x02, 0xe8, 0x3c,
+  0x4a, 0x56, 0x13, 0x1c, 0x01, 0x01, 0x76, 0x67, 0x24, 0x04, 0xfe, 0xf4,
+  0x73, 0x7d, 0xfe, 0xbd, 0x21, 0x22, 0x67, 0x05, 0x9e, 0xfe, 0xc2, 0x7a,
+  0x95, 0x11, 0x12, 0x23, 0xac, 0x2b, 0x16, 0x15, 0x71, 0x72, 0xfe, 0x66,
+  0x72, 0x09, 0xab, 0xf6, 0x76, 0x29, 0x1e, 0x12, 0x32, 0x4c, 0x03, 0x4f,
+  0x41, 0x50, 0x4f, 0xd2, 0x02, 0x60, 0x8f, 0x01, 0x3e, 0xfa, 0xf9, 0x18,
+  0x07, 0x0b, 0x27, 0x4b, 0x56, 0x0a, 0x09, 0x9d, 0xf8, 0x01, 0x07, 0x9b,
+  0xfd, 0xa0, 0x89, 0x27, 0x27, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a,
+  0xfe, 0x56, 0x05, 0xcb, 0x06, 0x14, 0x00, 0x35, 0x00, 0x00, 0x01, 0x11,
+  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23,
+  0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x07, 0x06, 0x1d, 0x01, 0x21, 0x3b, 0x01, 0x15, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x05, 0xca, 0x4a, 0x48, 0xa3, 0xe5, 0xd2, 0x5e,
+  0x22, 0x23, 0x70, 0x6f, 0x87, 0x9a, 0xa7, 0xfe, 0xf1, 0xa6, 0x9f, 0x9f,
+  0x4e, 0x4e, 0xaa, 0x9d, 0x9e, 0x5a, 0x23, 0x22, 0x01, 0x0f, 0x02, 0xa5,
+  0x3b, 0x50, 0x51, 0x69, 0xae, 0x59, 0x59, 0x02, 0xa4, 0xfd, 0x48, 0xd6,
+  0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x02, 0xb2, 0x9f, 0x9e, 0xbe, 0xa4,
+  0xfd, 0x87, 0x03, 0xd1, 0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0x55,
+  0x56, 0x99, 0x28, 0x28, 0x68, 0x63, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78,
+  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x04, 0xbb, 0x06, 0x14, 0x00, 0x27,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26,
+  0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01,
+  0x15, 0x14, 0x07, 0x06, 0x23, 0x21, 0xae, 0xa5, 0x01, 0xca, 0x75, 0x3f,
+  0x3f, 0x54, 0xa0, 0x3a, 0x9a, 0x89, 0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x46,
+  0x97, 0x51, 0x7b, 0x7b, 0x58, 0x85, 0x39, 0xb2, 0x92, 0x6f, 0x45, 0xec,
+  0xfd, 0x94, 0x06, 0x14, 0xfa, 0x86, 0x2d, 0x2c, 0x34, 0x49, 0x4d, 0x2a,
+  0x0f, 0x24, 0x95, 0x82, 0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x54,
+  0x54, 0x40, 0x49, 0x21, 0x0e, 0x2c, 0x97, 0x89, 0x92, 0x65, 0x3e, 0x00,
+  0x00, 0x02, 0x00, 0xad, 0x00, 0x00, 0x04, 0x65, 0x06, 0x14, 0x00, 0x0a,
+  0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x01, 0x21, 0x15,
+  0x21, 0x2b, 0x01, 0x13, 0x11, 0x01, 0xae, 0xa5, 0x03, 0x12, 0xfd, 0x91,
+  0x02, 0x6f, 0xfc, 0xee, 0x17, 0x8e, 0xa5, 0x02, 0x58, 0x06, 0x14, 0xfe,
+  0x4c, 0xa8, 0xfc, 0xdb, 0x93, 0x03, 0xcd, 0xfc, 0xf9, 0x03, 0x07, 0x00,
+  0x00, 0x02, 0x00, 0x30, 0xff, 0xe2, 0x03, 0x85, 0x05, 0x1f, 0x00, 0x0c,
+  0x00, 0x19, 0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x1b, 0x01, 0x33,
+  0x03, 0x23, 0x0b, 0x01, 0x23, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x1b, 0x01,
+  0x33, 0x03, 0x23, 0x0b, 0x01, 0x23, 0x31, 0x68, 0x83, 0x81, 0x7b, 0x83,
+  0x81, 0x69, 0xa7, 0x7a, 0x89, 0x89, 0x7b, 0xa6, 0x68, 0x83, 0x81, 0x7b,
+  0x83, 0x81, 0x69, 0xa7, 0x7a, 0x89, 0x89, 0x7b, 0x02, 0x55, 0xfe, 0x17,
+  0x01, 0xe9, 0xfe, 0x17, 0x01, 0xe9, 0xfd, 0x8d, 0x02, 0x02, 0xfd, 0xfe,
+  0x05, 0x3d, 0xfe, 0x17, 0x01, 0xe9, 0xfe, 0x17, 0x01, 0xe9, 0xfd, 0x8d,
+  0x02, 0x02, 0xfd, 0xfe, 0x00, 0x02, 0x00, 0x30, 0x00, 0xad, 0x03, 0x85,
+  0x05, 0x1f, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23,
+  0x31, 0x03, 0x54, 0x81, 0xfd, 0xad, 0x80, 0x03, 0x54, 0x81, 0xfd, 0xad,
+  0x80, 0x02, 0x55, 0xfe, 0x58, 0x01, 0x05, 0xfe, 0xfb, 0x04, 0x72, 0xfe,
+  0x58, 0x01, 0x05, 0xfe, 0xfb, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0xfe, 0x4a, 0x04, 0x1c, 0x06, 0x14, 0x00, 0x19, 0x00, 0x00, 0x25, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x11, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x16, 0x15, 0x11, 0x10, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23,
+  0x03, 0x75, 0x77, 0xcf, 0xae, 0xb2, 0x44, 0x5f, 0x2c, 0x3f, 0xa3, 0x93,
+  0xdf, 0x86, 0x9b, 0xa6, 0xa6, 0xac, 0xc9, 0xef, 0xe8, 0x02, 0xc4, 0x99,
+  0x61, 0x9c, 0xc0, 0xd6, 0xfd, 0x42, 0xfe, 0xc3, 0xbe, 0xa4, 0x02, 0x79,
+  0xf9, 0xec, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0xfe, 0x56, 0x04, 0xeb,
+  0x06, 0x14, 0x00, 0x21, 0x00, 0x00, 0x25, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x11, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x16, 0x15, 0x11, 0x10,
+  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x06, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x26, 0x27, 0x03, 0x75, 0x77, 0xcf, 0xae, 0xb2, 0x44, 0x5f,
+  0x2c, 0x3f, 0xa3, 0x93, 0xdf, 0x86, 0x9b, 0xa6, 0x03, 0x48, 0x5d, 0x2d,
+  0x3f, 0xa4, 0x8e, 0x04, 0xac, 0xc9, 0xef, 0xe8, 0x02, 0xc4, 0x99, 0x61,
+  0x9c, 0xc0, 0xd6, 0xfd, 0x42, 0xfe, 0xc3, 0xbe, 0xa4, 0x02, 0x79, 0xfb,
+  0x8e, 0x94, 0x66, 0x9c, 0xb9, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x02, 0x9c, 0x02, 0x7e, 0x06, 0x03, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
+  0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x7d, 0x68, 0x46, 0x47, 0x54,
+  0x61, 0x6a, 0x6a, 0x25, 0x65, 0x43, 0x6d, 0x70, 0x04, 0x17, 0xfe, 0x85,
+  0x01, 0x77, 0x59, 0x59, 0x6b, 0x5c, 0xfe, 0x9e, 0x03, 0x67, 0xfe, 0xab,
+  0x38, 0x38, 0x86, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x7e,
+  0x06, 0x03, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x36, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x06, 0x1d, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x7d,
+  0x68, 0x46, 0x47, 0x54, 0x61, 0x6a, 0x5d, 0x67, 0x90, 0x84, 0x3b, 0x2b,
+  0x25, 0x65, 0x43, 0x6d, 0x70, 0x04, 0x17, 0xfe, 0x85, 0x01, 0x77, 0x59,
+  0x59, 0x6b, 0x5c, 0xfe, 0x9e, 0x02, 0x84, 0x78, 0x6b, 0x57, 0x36, 0x56,
+  0x72, 0x38, 0x38, 0x86, 0x00, 0x02, 0xff, 0xeb, 0x01, 0xad, 0x00, 0xd7,
+  0x06, 0x03, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x13, 0x33, 0x11, 0x14,
+  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
+  0x15, 0x23, 0x6e, 0x68, 0x2f, 0x2d, 0x67, 0x28, 0x1c, 0x3c, 0x15, 0x16,
+  0x68, 0x68, 0x05, 0x0f, 0xfd, 0x82, 0x78, 0x36, 0x36, 0x58, 0x1b, 0x1b,
+  0x56, 0x03, 0x72, 0x82, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x01, 0xdd,
+  0x05, 0x1e, 0x00, 0x11, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
+  0x01, 0xdd, 0x11, 0x2a, 0x19, 0x58, 0x5e, 0x6a, 0x6a, 0x20, 0x69, 0x4c,
+  0x0b, 0x1a, 0x10, 0x04, 0xaf, 0x0a, 0x09, 0x71, 0x6b, 0xfe, 0xb6, 0x02,
+  0x73, 0x61, 0x39, 0x37, 0x02, 0x03, 0x00, 0x00, 0x00, 0x01, 0x00, 0x40,
+  0x02, 0x8d, 0x01, 0xb4, 0x05, 0x0f, 0x00, 0x11, 0x00, 0x00, 0x13, 0x1e,
+  0x01, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01,
+  0x23, 0x22, 0x26, 0x27, 0x41, 0x11, 0x29, 0x19, 0x59, 0x5e, 0x69, 0x69,
+  0x20, 0x69, 0x4c, 0x0b, 0x1a, 0x10, 0x02, 0xfc, 0x0a, 0x09, 0x71, 0x6b,
+  0x01, 0x4a, 0xfd, 0x8d, 0x61, 0x39, 0x37, 0x02, 0x03, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x40, 0x01, 0xad, 0x02, 0x37, 0x05, 0x0f, 0x00, 0x1b,
+  0x00, 0x00, 0x13, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
+  0x15, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x02, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0x27, 0x41, 0x11, 0x29, 0x19, 0x59, 0x5e, 0x69,
+  0x2b, 0x3b, 0x1c, 0x28, 0x66, 0x5d, 0x20, 0x69, 0x4c, 0x0b, 0x1a, 0x10,
+  0x02, 0xfc, 0x0a, 0x09, 0x71, 0x6b, 0x01, 0x4a, 0xfd, 0x8d, 0x0b, 0x56,
+  0x36, 0x58, 0x6c, 0x78, 0x0b, 0x61, 0x39, 0x37, 0x02, 0x03, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x1c, 0x02, 0x9c, 0x02, 0x4e, 0x05, 0x0f, 0x00, 0x16,
+  0x00, 0x21, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x2b,
+  0x01, 0x11, 0x33, 0x11, 0x33, 0x32, 0x37, 0x36, 0x3f, 0x01, 0x33, 0x07,
+  0x06, 0x07, 0x06, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x2b, 0x01, 0x01, 0x72, 0x3c, 0x3f, 0x3c, 0x3d, 0x7c, 0xdb, 0x68, 0x61,
+  0x36, 0x22, 0x21, 0x24, 0x5c, 0x6f, 0x64, 0x1d, 0x1e, 0x1f, 0xfe, 0xf5,
+  0x71, 0x43, 0x23, 0x25, 0x25, 0x23, 0x43, 0x71, 0x03, 0xe9, 0x0f, 0x4e,
+  0x3b, 0x5b, 0x2d, 0x2d, 0x02, 0x73, 0xfe, 0xf7, 0x15, 0x14, 0x3f, 0xa1,
+  0xab, 0x35, 0x1e, 0x1e, 0xff, 0x00, 0x17, 0x18, 0x2f, 0x2e, 0x18, 0x19,
+  0x00, 0x01, 0x00, 0x30, 0x02, 0x9c, 0x03, 0x85, 0x05, 0x0f, 0x00, 0x0c,
+  0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x23,
+  0x0b, 0x01, 0x23, 0x31, 0x68, 0x83, 0x81, 0x7b, 0x83, 0x81, 0x69, 0xa7,
+  0x7a, 0x89, 0x89, 0x7b, 0x05, 0x0f, 0xfe, 0x17, 0x01, 0xe9, 0xfe, 0x17,
+  0x01, 0xe9, 0xfd, 0x8d, 0x02, 0x02, 0xfd, 0xfe, 0x00, 0x01, 0x00, 0x22,
+  0x01, 0xad, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x11, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3f, 0x01, 0x01,
+  0x33, 0x1b, 0x01, 0x33, 0x01, 0x76, 0x2d, 0x2a, 0x29, 0x46, 0x54, 0x3d,
+  0x2b, 0x18, 0x18, 0x1d, 0x13, 0xfe, 0xfe, 0x6f, 0xc7, 0xc6, 0x6e, 0x02,
+  0x62, 0x70, 0x22, 0x23, 0x57, 0x14, 0x14, 0x4b, 0x2f, 0x02, 0x69, 0xfe,
+  0x16, 0x01, 0xea, 0x00, 0xff, 0xff, 0x00, 0x90, 0x04, 0x74, 0x01, 0x76,
+  0x06, 0x66, 0x10, 0x06, 0x03, 0x12, 0x00, 0x00, 0xff, 0xff, 0x00, 0x90,
+  0x04, 0x74, 0x02, 0xc5, 0x06, 0x66, 0x10, 0x26, 0x03, 0x12, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x12, 0x01, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c,
+  0x03, 0xe9, 0x01, 0xa5, 0x05, 0xd5, 0x10, 0x06, 0x07, 0x4d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa0, 0x03, 0xfe, 0x01, 0xa8, 0x05, 0xd5, 0x10, 0x06,
+  0x07, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb0, 0x04, 0xee, 0x01, 0xb9,
+  0x06, 0xda, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15, 0x13, 0x23, 0x03, 0x35,
+  0x01, 0x6e, 0x4a, 0x74, 0x94, 0x06, 0xda, 0xac, 0xfe, 0xc0, 0x01, 0x40,
+  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x03, 0xef, 0x01, 0x60,
+  0x06, 0x14, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x35, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x35, 0x32, 0x17, 0x16, 0x14, 0x07, 0x06, 0x69, 0x3a, 0x4f,
+  0x4f, 0x3a, 0x68, 0x48, 0x47, 0x47, 0x48, 0x03, 0xef, 0x7b, 0x58, 0x40,
+  0x3f, 0x58, 0x7b, 0x50, 0x4f, 0xe6, 0x50, 0x50, 0x00, 0x01, 0x00, 0x69,
+  0x03, 0xef, 0x01, 0x60, 0x06, 0x14, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x22,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x33, 0x15, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x01, 0x60, 0x68, 0x48, 0x47, 0x47, 0x48, 0x68, 0x3a, 0x4f, 0x4f,
+  0x3a, 0x03, 0xef, 0x50, 0x50, 0xe6, 0x4f, 0x50, 0x7b, 0x58, 0x3f, 0x40,
+  0x58, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x49,
+  0x06, 0x02, 0x00, 0x1c, 0x00, 0x00, 0x13, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x11, 0x23, 0xf8,
+  0x24, 0x6c, 0x32, 0x20, 0x01, 0x1f, 0x39, 0x65, 0x2e, 0x2c, 0x2d, 0x2c,
+  0x2b, 0x2e, 0x2e, 0x30, 0x9d, 0x4e, 0x3d, 0x3d, 0x3f, 0x60, 0x74, 0x04,
+  0x5b, 0x40, 0x2a, 0x37, 0x4b, 0x24, 0x40, 0x0c, 0x0c, 0x18, 0x60, 0x14,
+  0x09, 0x0a, 0x58, 0x46, 0x68, 0x5f, 0x40, 0x43, 0x11, 0xfe, 0x93, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x49, 0x06, 0x02, 0x00, 0x1c,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x33, 0x01, 0xb9, 0x72, 0x61, 0x40,
+  0x3d, 0x3e, 0x4f, 0x9b, 0x30, 0x2e, 0x2e, 0x2b, 0x2c, 0x2d, 0x2c, 0x2d,
+  0x66, 0x38, 0x20, 0x01, 0x21, 0x31, 0x6d, 0x04, 0x5b, 0xfe, 0x41, 0x01,
+  0x6d, 0x11, 0x43, 0x40, 0x5f, 0x68, 0x46, 0x58, 0x0a, 0x09, 0x14, 0x60,
+  0x18, 0x0c, 0x0c, 0x40, 0x24, 0x4b, 0x37, 0x2a, 0x40, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xf0, 0x04, 0x32, 0x02, 0xaa, 0x06, 0xb0, 0x00, 0x06,
+  0x00, 0x00, 0x13, 0x25, 0x15, 0x0d, 0x01, 0x15, 0x25, 0xf0, 0x01, 0xb9,
+  0xfe, 0xbd, 0x01, 0x43, 0xfe, 0x47, 0x05, 0xbb, 0xf5, 0x8b, 0xb4, 0xb4,
+  0x8b, 0xf5, 0x00, 0x00, 0x00, 0x01, 0x00, 0xf0, 0x04, 0x32, 0x02, 0xaa,
+  0x06, 0xb0, 0x00, 0x06, 0x00, 0x00, 0x01, 0x05, 0x35, 0x2d, 0x01, 0x35,
+  0x05, 0x02, 0xa9, 0xfe, 0x47, 0x01, 0x43, 0xfe, 0xbd, 0x01, 0xb9, 0x05,
+  0x27, 0xf5, 0x8b, 0xb4, 0xb4, 0x8b, 0xf5, 0x00, 0x00, 0x01, 0x00, 0xad,
+  0x04, 0x7c, 0x02, 0xec, 0x06, 0x66, 0x00, 0x06, 0x00, 0x00, 0x01, 0x33,
+  0x13, 0x23, 0x0b, 0x01, 0x23, 0x01, 0x8a, 0x85, 0xdd, 0x7d, 0xa2, 0xa2,
+  0x7d, 0x06, 0x66, 0xfe, 0x16, 0x01, 0x67, 0xfe, 0x99, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0x04, 0x7c, 0x02, 0xec, 0x06, 0x66, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x01, 0x8a, 0xdc,
+  0x7d, 0xa2, 0xa2, 0x7d, 0xdd, 0x04, 0x7c, 0x01, 0xea, 0xfe, 0x99, 0x01,
+  0x67, 0xfe, 0x16, 0x00, 0x00, 0x01, 0x00, 0xad, 0x04, 0xee, 0x02, 0xec,
+  0x06, 0x66, 0x00, 0x06, 0x00, 0x00, 0x01, 0x33, 0x13, 0x23, 0x27, 0x07,
+  0x23, 0x01, 0x8a, 0x85, 0xdd, 0x7d, 0xa2, 0xa2, 0x7d, 0x06, 0x66, 0xfe,
+  0x88, 0xf5, 0xf5, 0x00, 0x00, 0x01, 0x00, 0xad, 0x04, 0xee, 0x02, 0xec,
+  0x06, 0x66, 0x00, 0x06, 0x00, 0x00, 0x01, 0x03, 0x33, 0x17, 0x37, 0x33,
+  0x03, 0x01, 0x8a, 0xdc, 0x7d, 0xa2, 0xa2, 0x7d, 0xdd, 0x04, 0xee, 0x01,
+  0x78, 0xf5, 0xf5, 0xfe, 0x88, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0,
+  0x03, 0xe7, 0x01, 0x3b, 0x06, 0x12, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x01, 0x3b, 0x7a, 0x06, 0x12, 0xfd, 0xd5, 0x02, 0x2b, 0x00,
+  0xff, 0xff, 0x00, 0xbf, 0x05, 0x62, 0x02, 0xda, 0x05, 0xf6, 0x10, 0x06,
+  0x00, 0x71, 0x00, 0x00, 0x00, 0x01, 0x01, 0x4d, 0x04, 0xee, 0x02, 0xfd,
+  0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x02, 0x4a,
+  0xb3, 0xfe, 0xdb, 0x8a, 0x06, 0x66, 0xfe, 0x88, 0x00, 0x01, 0x00, 0x99,
+  0x04, 0xf0, 0x02, 0x49, 0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x13,
+  0x23, 0x01, 0x01, 0x4a, 0xfe, 0x8a, 0xfe, 0xdb, 0x06, 0x66, 0xfe, 0x8a,
+  0x01, 0x76, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0, 0xfe, 0xd1, 0x01, 0x3b,
+  0x00, 0xfc, 0x00, 0x03, 0x00, 0x00, 0x25, 0x11, 0x23, 0x11, 0x01, 0x3b,
+  0x7a, 0xfc, 0xfd, 0xd5, 0x02, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xbf,
+  0xfe, 0xc0, 0x02, 0xda, 0xff, 0x54, 0x10, 0x07, 0x00, 0x71, 0x00, 0x00,
+  0xf9, 0x5e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99, 0xfe, 0x1c, 0x02, 0x49,
+  0xff, 0x92, 0x00, 0x03, 0x00, 0x00, 0x05, 0x13, 0x23, 0x01, 0x01, 0x4a,
+  0xfe, 0x8a, 0xfe, 0xdb, 0x6e, 0xfe, 0x8a, 0x01, 0x76, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x4d, 0xfe, 0x1c, 0x02, 0xfd, 0xff, 0x94, 0x00, 0x03,
+  0x00, 0x00, 0x05, 0x33, 0x01, 0x23, 0x02, 0x4a, 0xb3, 0xfe, 0xdb, 0x8a,
+  0x6c, 0xfe, 0x88, 0x00, 0x00, 0x02, 0x00, 0x63, 0x00, 0x00, 0x01, 0xa6,
+  0x04, 0x23, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x01, 0x03, 0x21, 0x03,
+  0x13, 0x21, 0x01, 0x04, 0xa0, 0x01, 0x41, 0xa1, 0xa1, 0xfe, 0xbf, 0x02,
+  0xd9, 0x01, 0x4a, 0xfd, 0x27, 0xfe, 0xb6, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0x02, 0xd9, 0x01, 0xa6, 0x04, 0x23, 0x00, 0x02, 0x00, 0x00, 0x01, 0x03,
+  0x21, 0x01, 0x04, 0xa0, 0x01, 0x41, 0x02, 0xd9, 0x01, 0x4a, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x69, 0x01, 0xfe, 0x01, 0x60, 0x04, 0x23, 0x10, 0x07,
+  0x02, 0x80, 0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
+  0x01, 0xfe, 0x01, 0x60, 0x04, 0x23, 0x10, 0x07, 0x02, 0x81, 0x00, 0x00,
+  0xfe, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x02, 0x01, 0xd4, 0x02, 0x98,
+  0x03, 0x96, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35, 0x33, 0x11,
+  0x33, 0x11, 0x02, 0x97, 0xfe, 0x6b, 0x87, 0x87, 0x02, 0x6a, 0x96, 0x96,
+  0x01, 0x2c, 0xfe, 0xd4, 0x00, 0x01, 0x01, 0x02, 0x01, 0xd4, 0x02, 0x98,
+  0x03, 0x96, 0x00, 0x07, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x23, 0x11,
+  0x23, 0x11, 0x01, 0x02, 0x01, 0x95, 0x87, 0x87, 0x03, 0x00, 0x96, 0x96,
+  0xfe, 0xd4, 0x01, 0x2c, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xff, 0x02, 0x75,
+  0x03, 0x55, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x33, 0x15,
+  0x23, 0x15, 0x23, 0x35, 0x23, 0x35, 0x01, 0x24, 0x87, 0xc9, 0xc9, 0x87,
+  0xca, 0x02, 0x75, 0xe0, 0xe0, 0x96, 0xe0, 0xe0, 0x96, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x01, 0xef, 0x02, 0x75, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x01, 0xef, 0xfe, 0x6b, 0x01, 0x95,
+  0x01, 0xdf, 0x96, 0x00, 0x00, 0x01, 0x00, 0xb3, 0x05, 0x29, 0x02, 0xe7,
+  0x06, 0x48, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x37, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x26, 0xb3, 0x6a, 0x0a, 0x57,
+  0x4f, 0x4d, 0x57, 0x0b, 0x6a, 0x08, 0x8f, 0x82, 0x83, 0x8e, 0x06, 0x48,
+  0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x00, 0x00, 0x01, 0x01, 0x71,
+  0x05, 0x44, 0x02, 0x29, 0x06, 0x10, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33,
+  0x15, 0x23, 0x01, 0x71, 0xb8, 0xb8, 0x06, 0x10, 0xcc, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xd6, 0x04, 0xe1, 0x02, 0xc4, 0x07, 0x06, 0x00, 0x0b,
+  0x00, 0x17, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x02, 0x56, 0x50, 0x39, 0x3b, 0x4e, 0x4e, 0x3b,
+  0x39, 0x50, 0x6d, 0x8f, 0x67, 0x68, 0x8f, 0x8f, 0x68, 0x67, 0x8f, 0x05,
+  0xf4, 0x3f, 0x58, 0x57, 0x40, 0x41, 0x57, 0x58, 0x40, 0x73, 0xa0, 0xa0,
+  0x73, 0x73, 0x9f, 0x9f, 0x00, 0x01, 0x01, 0x2a, 0xfe, 0x75, 0x02, 0x7b,
+  0x00, 0x00, 0x00, 0x13, 0x00, 0x00, 0x21, 0x33, 0x0e, 0x01, 0x15, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x01, 0x8c, 0x6b, 0x28, 0x27, 0x31, 0x31, 0x1d, 0x38, 0x1b,
+  0x22, 0x3d, 0x1b, 0x6e, 0x67, 0x2f, 0x3d, 0x58, 0x1f, 0x2e, 0x2e, 0x0f,
+  0x0f, 0x85, 0x0a, 0x0a, 0x57, 0x5d, 0x30, 0x69, 0x00, 0x01, 0x00, 0xa3,
+  0x05, 0x1d, 0x02, 0xf6, 0x06, 0x37, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x27,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x33, 0x32, 0x16,
+  0x1f, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x33, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x01, 0xc9, 0x33, 0x14, 0x1e, 0x0b, 0x23, 0x20, 0x02, 0x70,
+  0x02, 0x5b, 0x52, 0x23, 0x39, 0x21, 0x34, 0x14, 0x1d, 0x0c, 0x22, 0x21,
+  0x01, 0x71, 0x02, 0x5c, 0x52, 0x22, 0x3a, 0x05, 0x5a, 0x37, 0x14, 0x13,
+  0x49, 0x52, 0x87, 0x93, 0x1c, 0x21, 0x37, 0x14, 0x13, 0x49, 0x52, 0x87,
+  0x93, 0x1c, 0x00, 0x00, 0x00, 0x02, 0x00, 0xd8, 0x04, 0xee, 0x03, 0x50,
+  0x06, 0x66, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x03, 0x23,
+  0x03, 0x33, 0x03, 0x23, 0x02, 0xb0, 0xa0, 0xdf, 0x7a, 0x74, 0x99, 0xc9,
+  0x7b, 0x06, 0x66, 0xfe, 0x88, 0x01, 0x78, 0xfe, 0x88, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xff, 0x01, 0xde, 0x02, 0x69, 0x04, 0x08, 0x00, 0x0f,
+  0x00, 0x00, 0x03, 0x37, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x07, 0x01, 0xfa, 0xa6, 0x22, 0x22, 0x5f,
+  0x26, 0x39, 0x9e, 0x4e, 0x4a, 0xf9, 0x03, 0x64, 0xa4, 0x94, 0x99, 0x31,
+  0x30, 0x9c, 0x60, 0x5a, 0xc8, 0xa2, 0x00, 0x00, 0x00, 0x01, 0x00, 0xd7,
+  0x04, 0xee, 0x02, 0xc2, 0x06, 0x66, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x27,
+  0x07, 0x23, 0x37, 0x27, 0x33, 0x17, 0x37, 0x33, 0x07, 0x17, 0x02, 0x20,
+  0x53, 0x54, 0xa2, 0xa3, 0xa3, 0xa2, 0x54, 0x53, 0xa2, 0xa4, 0xa4, 0x04,
+  0xee, 0x61, 0x61, 0xbb, 0xbd, 0x60, 0x60, 0xbd, 0xbb, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x69, 0x01, 0xab, 0x02, 0xb1, 0x05, 0x0f, 0x00, 0x0d,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x16, 0x15, 0x14, 0x23, 0x22, 0x35, 0x34,
+  0x37, 0x03, 0x33, 0x17, 0x37, 0x33, 0x01, 0x06, 0x15, 0x14, 0x33, 0x32,
+  0x35, 0x34, 0x01, 0xd1, 0xa1, 0xda, 0xf1, 0xa3, 0xe1, 0x7c, 0xab, 0xa5,
+  0x7b, 0xfe, 0xdd, 0x7b, 0x7a, 0x74, 0x03, 0xdc, 0xf9, 0xb4, 0x84, 0x84,
+  0xbf, 0xf2, 0x01, 0x2f, 0xe0, 0xe0, 0xfe, 0x8a, 0xae, 0x98, 0x4d, 0x4d,
+  0x89, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6d, 0x02, 0x9c, 0x00, 0xd7,
+  0x06, 0x03, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x6e, 0x68,
+  0x68, 0x06, 0x03, 0xfc, 0x99, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x02, 0x9c, 0x02, 0x4f, 0x05, 0x2f, 0x00, 0x32, 0x00, 0x00, 0x01, 0x15,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f,
+  0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x02, 0x2c, 0x2c, 0x30, 0x2e, 0x34, 0x4e, 0x27, 0x26, 0x1b, 0x1c,
+  0x54, 0x24, 0x71, 0x2d, 0x2e, 0x46, 0x45, 0x7b, 0x33, 0x38, 0x37, 0x3d,
+  0x3a, 0x39, 0x37, 0x37, 0x4a, 0x4f, 0x1d, 0x19, 0x64, 0x24, 0x61, 0x2b,
+  0x2b, 0x40, 0x3f, 0x75, 0x39, 0x34, 0x33, 0x05, 0x0d, 0x61, 0x16, 0x0b,
+  0x0b, 0x17, 0x18, 0x2f, 0x24, 0x14, 0x15, 0x12, 0x08, 0x18, 0x2a, 0x2b,
+  0x4d, 0x57, 0x33, 0x33, 0x0a, 0x0a, 0x13, 0x6b, 0x1e, 0x0f, 0x0f, 0x32,
+  0x2d, 0x2a, 0x17, 0x14, 0x17, 0x08, 0x15, 0x29, 0x2a, 0x49, 0x58, 0x30,
+  0x31, 0x09, 0x08, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0xd1,
+  0x05, 0x0f, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x03, 0x13, 0x23, 0x27, 0x07,
+  0x23, 0x13, 0x03, 0x33, 0x17, 0x37, 0x02, 0xc5, 0xe5, 0xf1, 0x7b, 0xb9,
+  0xb8, 0x7c, 0xf7, 0xe2, 0x7b, 0xa9, 0xa8, 0x05, 0x0f, 0xfe, 0xcf, 0xfe,
+  0xbe, 0xf6, 0xf6, 0x01, 0x48, 0x01, 0x2b, 0xdf, 0xdf, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x49, 0x06, 0x02, 0x10, 0x06,
+  0x02, 0x83, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
+  0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x02, 0x53, 0xfe, 0x6e, 0x02, 0x0c, 0x04, 0xd0, 0x88, 0xfa, 0xa8, 0x00,
+  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07,
+  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x02, 0x53,
+  0xfe, 0x6e, 0x01, 0x92, 0x7a, 0x03, 0x9c, 0x88, 0x01, 0x34, 0xfa, 0xa8,
+  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07,
+  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x02, 0x53,
+  0xfe, 0x6e, 0x01, 0x92, 0x7a, 0x02, 0x68, 0x88, 0x02, 0x68, 0xfa, 0xa8,
+  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07,
+  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x02, 0x53,
+  0xfe, 0x6e, 0x01, 0x92, 0x7a, 0x01, 0x34, 0x88, 0x03, 0x9c, 0xfa, 0xa8,
+  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x05,
+  0x00, 0x00, 0x25, 0x11, 0x33, 0x11, 0x21, 0x35, 0x02, 0x53, 0x7a, 0xfd,
+  0xf4, 0x88, 0x04, 0xd0, 0xfa, 0xa8, 0x88, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0xfd, 0xec, 0x02, 0xec, 0xff, 0xd6, 0x10, 0x07, 0x02, 0x87, 0x00, 0x00,
+  0xf9, 0x70, 0x00, 0x00, 0xff, 0xff, 0x00, 0xbf, 0x04, 0xe2, 0x02, 0xda,
+  0x06, 0x76, 0x12, 0x27, 0x00, 0x71, 0x00, 0x00, 0x00, 0x80, 0x12, 0x06,
+  0x00, 0x71, 0x00, 0x80, 0xff, 0xff, 0x00, 0x9c, 0x03, 0xe9, 0x03, 0x16,
+  0x05, 0xd5, 0x12, 0x06, 0x07, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xd6,
+  0xfe, 0x14, 0x02, 0xc4, 0x00, 0x39, 0x10, 0x07, 0x02, 0x9c, 0x00, 0x00,
+  0xf9, 0x33, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa3, 0xfe, 0x76, 0x02, 0xf6,
+  0xff, 0x90, 0x00, 0x21, 0x00, 0x00, 0x01, 0x27, 0x26, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x1f,
+  0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x01, 0xc9, 0x33, 0x14, 0x0f, 0x0f, 0x0b, 0x23,
+  0x10, 0x10, 0x02, 0x70, 0x02, 0x2e, 0x2d, 0x52, 0x23, 0x39, 0x21, 0x34,
+  0x14, 0x0f, 0x0e, 0x0c, 0x22, 0x10, 0x11, 0x01, 0x71, 0x02, 0x2e, 0x2e,
+  0x52, 0x22, 0x3a, 0xfe, 0xb3, 0x37, 0x14, 0x0a, 0x09, 0x25, 0x24, 0x52,
+  0x87, 0x49, 0x4a, 0x1c, 0x21, 0x37, 0x14, 0x0a, 0x09, 0x25, 0x24, 0x52,
+  0x87, 0x49, 0x4a, 0x1c, 0x00, 0x02, 0xfc, 0xfd, 0x04, 0x7b, 0xfe, 0xad,
+  0x06, 0x66, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00, 0x01, 0x13, 0x23, 0x09,
+  0x01, 0xfd, 0xaf, 0xfe, 0x8a, 0xfe, 0xdb, 0x01, 0x35, 0x06, 0x66, 0xfe,
+  0x8a, 0x01, 0x76, 0xfe, 0x15, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0xb2,
+  0x04, 0x7b, 0xff, 0x62, 0x06, 0x66, 0x00, 0x03, 0x00, 0x04, 0x00, 0x00,
+  0x01, 0x33, 0x01, 0x23, 0x17, 0xfe, 0xae, 0xb4, 0xfe, 0xda, 0x8a, 0x81,
+  0x06, 0x66, 0xfe, 0x88, 0x73, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x14,
+  0x04, 0x7b, 0xff, 0x53, 0x06, 0x66, 0x00, 0x06, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x33, 0x13, 0x23, 0x27, 0x07, 0x23, 0x05, 0xfd, 0xf1, 0x85, 0xdc,
+  0x7d, 0xa2, 0xa2, 0x7d, 0x01, 0x1f, 0x06, 0x66, 0xfe, 0x88, 0xf5, 0xf5,
+  0x73, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x08, 0x05, 0x1d, 0xff, 0x5b,
+  0x06, 0x37, 0x10, 0x07, 0x02, 0x9e, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0x29, 0x05, 0x62, 0xff, 0x44, 0x05, 0xf6, 0x10, 0x07,
+  0x00, 0x71, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0x54,
+  0x05, 0x7c, 0x00, 0x12, 0x06, 0x0b, 0x10, 0x07, 0x07, 0x73, 0xfc, 0x66,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x12, 0x05, 0x29, 0xff, 0x46,
+  0x06, 0x48, 0x10, 0x07, 0x02, 0x9a, 0xfc, 0x5f, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0xfd, 0xde, 0x04, 0x7b, 0xfe, 0x85, 0x06, 0x14, 0x00, 0x03,
+  0x00, 0x04, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x17, 0xfd, 0xdf, 0xa5,
+  0xa5, 0x54, 0x06, 0x14, 0xe9, 0xb0, 0x00, 0x00, 0x00, 0x03, 0xfd, 0x27,
+  0x04, 0x7b, 0xff, 0x3f, 0x06, 0x10, 0x00, 0x03, 0x00, 0x07, 0x00, 0x08,
+  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x05, 0xfe,
+  0x88, 0xb6, 0xb6, 0xfe, 0xa0, 0xb7, 0xb7, 0x01, 0x0b, 0x06, 0x10, 0xca,
+  0xca, 0xca, 0xcb, 0x00, 0x00, 0x01, 0xfd, 0x7e, 0x04, 0xf2, 0xff, 0x12,
+  0x06, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x36, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x15, 0x23, 0x35, 0x34, 0x36, 0x3f,
+  0x01, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0xfd, 0x7e, 0x65, 0x5e,
+  0x5e, 0x73, 0x50, 0x27, 0x20, 0x03, 0x07, 0x6b, 0x1c, 0x2d, 0x29, 0x29,
+  0x38, 0x40, 0x51, 0x5a, 0x06, 0x48, 0x33, 0x55, 0x43, 0x3d, 0x41, 0x20,
+  0x1a, 0x09, 0x10, 0x20, 0x0c, 0x28, 0x36, 0x25, 0x22, 0x22, 0x28, 0x15,
+  0x24, 0x34, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x3a, 0x04, 0xe1, 0xff, 0x28,
+  0x07, 0x06, 0x10, 0x07, 0x02, 0x9c, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0x42, 0x04, 0xee, 0xff, 0xba, 0x06, 0x66, 0x10, 0x07,
+  0x02, 0x9f, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x17,
+  0x04, 0x7b, 0xff, 0x56, 0x06, 0x66, 0x00, 0x06, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03, 0x07, 0xfd, 0xf4, 0xdc, 0x7d,
+  0xa2, 0xa2, 0x7d, 0xdd, 0x46, 0x04, 0xee, 0x01, 0x78, 0xf5, 0xf5, 0xfe,
+  0x88, 0x73, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xf6, 0x04, 0xec, 0xfe, 0x71,
+  0x06, 0xa8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0xfe, 0x70,
+  0x7a, 0x06, 0xa8, 0xfe, 0x44, 0x01, 0xbc, 0x00, 0xff, 0xff, 0xfd, 0x3e,
+  0x04, 0xec, 0xff, 0x28, 0x06, 0xa8, 0x10, 0x27, 0x02, 0xbe, 0xff, 0x48,
+  0x00, 0x00, 0x10, 0x07, 0x02, 0xbe, 0x00, 0xb8, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0xfc, 0xba, 0x04, 0xee, 0xff, 0x32, 0x06, 0x66, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x01, 0x13, 0x23, 0x03, 0x21, 0x13, 0x23, 0x03,
+  0xfd, 0x5a, 0xb9, 0x7a, 0xdf, 0x01, 0xcd, 0xab, 0x7b, 0xc9, 0x06, 0x66,
+  0xfe, 0x88, 0x01, 0x78, 0xfe, 0x88, 0x01, 0x78, 0xff, 0xff, 0xfd, 0x12,
+  0x05, 0x29, 0xff, 0x46, 0x07, 0x56, 0x10, 0x27, 0x02, 0xb8, 0x00, 0x00,
+  0x01, 0x42, 0x10, 0x07, 0x02, 0x9a, 0xfc, 0x5f, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x12, 0x05, 0x29, 0xff, 0x46, 0x06, 0x48, 0x00, 0x0c,
+  0x00, 0x00, 0x03, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e,
+  0x01, 0x20, 0x16, 0xba, 0x6a, 0x0a, 0x58, 0x4e, 0x4d, 0x57, 0x0c, 0x6a,
+  0x09, 0x8f, 0x01, 0x04, 0x8f, 0x05, 0x29, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f,
+  0x90, 0x90, 0x00, 0x00, 0x00, 0x01, 0xfe, 0x4f, 0x03, 0xe9, 0xff, 0x57,
+  0x05, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x23, 0x13, 0x33, 0xf3, 0xbe,
+  0x94, 0x74, 0x03, 0xe9, 0x01, 0x3f, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xce,
+  0x04, 0xc2, 0xfe, 0xa8, 0x06, 0xc1, 0x00, 0x08, 0x00, 0x00, 0x01, 0x10,
+  0x23, 0x35, 0x16, 0x35, 0x23, 0x35, 0x33, 0xfe, 0xa8, 0xda, 0x65, 0x64,
+  0xd9, 0x05, 0xc3, 0xfe, 0xff, 0x7b, 0x03, 0x89, 0xfe, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0xce, 0x04, 0xc2, 0xfe, 0xa8, 0x06, 0xc1, 0x00, 0x08,
+  0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x23, 0x14, 0x37, 0x15, 0x22, 0xfd,
+  0xce, 0xd9, 0x64, 0x65, 0xda, 0x05, 0xc3, 0xfe, 0xfe, 0x89, 0x03, 0x7b,
+  0x00, 0x01, 0xff, 0x86, 0x04, 0x9a, 0x00, 0x7a, 0x06, 0x12, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x33, 0x03, 0x23, 0x3a, 0xb4, 0x6a, 0x8a, 0x06, 0x12,
+  0xfe, 0x88, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xfd, 0xfd, 0xdf, 0xfe, 0xad,
+  0xff, 0x55, 0x10, 0x07, 0x00, 0x43, 0xfc, 0x65, 0xf8, 0xef, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0xb2, 0xfd, 0xdd, 0xff, 0x62, 0xff, 0x55, 0x10, 0x07,
+  0x00, 0x76, 0xfc, 0x65, 0xf8, 0xef, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x6d,
+  0xfe, 0x14, 0xfe, 0x6a, 0xff, 0xce, 0x00, 0x07, 0x00, 0x00, 0x01, 0x23,
+  0x35, 0x33, 0x35, 0x33, 0x11, 0x23, 0xfd, 0xfd, 0x90, 0x90, 0x6c, 0x6c,
+  0xfe, 0xb5, 0x78, 0xa1, 0xfe, 0x46, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xfd,
+  0xfe, 0x14, 0xfe, 0xfa, 0xff, 0xce, 0x00, 0x07, 0x00, 0x00, 0x05, 0x33,
+  0x15, 0x33, 0x15, 0x23, 0x15, 0x23, 0xfd, 0xfd, 0x6c, 0x90, 0x90, 0x6c,
+  0x32, 0xa1, 0x78, 0xa1, 0x00, 0x01, 0xfe, 0x7f, 0x05, 0x86, 0x00, 0x39,
+  0x07, 0x70, 0x00, 0x05, 0x00, 0x00, 0x03, 0x21, 0x35, 0x21, 0x11, 0x23,
+  0x42, 0xfe, 0xc2, 0x01, 0xb9, 0x7b, 0x06, 0xe8, 0x88, 0xfe, 0x16, 0x00,
+  0x00, 0x01, 0xff, 0x0b, 0x03, 0x6b, 0x00, 0x6f, 0x04, 0xe0, 0x00, 0x13,
+  0x00, 0x00, 0x03, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x27, 0x33, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0xf5, 0x37,
+  0x4f, 0x1c, 0x2a, 0x29, 0x0e, 0x0d, 0x78, 0x09, 0x09, 0x4f, 0x53, 0x2b,
+  0x5f, 0x03, 0xd7, 0x77, 0x2d, 0x2b, 0x37, 0x36, 0x20, 0x3e, 0x1f, 0x26,
+  0x44, 0x1e, 0x7a, 0x73, 0x35, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xc0,
+  0xfe, 0x12, 0xfe, 0x81, 0xff, 0xbe, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x15, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33,
+  0xfe, 0x81, 0x51, 0x70, 0x70, 0x51, 0x24, 0x30, 0x30, 0x24, 0xfe, 0x12,
+  0x7d, 0x5a, 0x59, 0x7c, 0x78, 0x35, 0x27, 0x28, 0x35, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x56, 0xfe, 0x14, 0xff, 0x10, 0xff, 0x4d, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35, 0x33, 0xfe, 0x70,
+  0xa0, 0xfe, 0x47, 0x9f, 0x7a, 0xfe, 0x9c, 0x88, 0x88, 0xb1, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x56, 0xfe, 0x14, 0xff, 0x10, 0xff, 0x4d, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x23, 0x35, 0x21, 0x15, 0x23, 0x15, 0x23, 0xfd, 0xf6,
+  0x9f, 0x01, 0xb9, 0xa0, 0x7a, 0xfe, 0xc5, 0x88, 0x88, 0xb1, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x6d, 0xfe, 0x14, 0xfe, 0xfa, 0xff, 0xce, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23,
+  0x15, 0x23, 0xfd, 0xfd, 0x90, 0x90, 0x6c, 0x90, 0x90, 0x6c, 0xfe, 0xb5,
+  0x78, 0xa1, 0xa1, 0x78, 0xa1, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x56,
+  0xfe, 0x88, 0xff, 0x10, 0xff, 0x10, 0x00, 0x03, 0x00, 0x00, 0x01, 0x35,
+  0x21, 0x15, 0xfd, 0x57, 0x01, 0xb9, 0xfe, 0x88, 0x88, 0x88, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0xba, 0xfe, 0x56, 0xff, 0xd5, 0x00, 0x80, 0x00, 0x0d,
+  0x00, 0x00, 0x27, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x3d, 0x01, 0x2b, 0x4a, 0x49, 0xa3, 0xe4, 0xd1, 0x5f, 0x22,
+  0x22, 0x80, 0x94, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31, 0x99, 0x94, 0x00,
+  0x00, 0x01, 0xfd, 0xb7, 0xfe, 0x56, 0xff, 0xd3, 0x00, 0x80, 0x00, 0x0d,
+  0x00, 0x00, 0x25, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0xfd, 0xb8, 0xa6, 0x22, 0x22, 0x5e, 0xd2, 0xe4,
+  0xa3, 0x49, 0x4a, 0x80, 0x94, 0x99, 0x31, 0x30, 0x9c, 0x60, 0x60, 0xd6,
+  0x00, 0x01, 0xfd, 0xde, 0xfe, 0x89, 0xfe, 0x85, 0xff, 0x73, 0x00, 0x03,
+  0x00, 0x00, 0x05, 0x33, 0x15, 0x23, 0xfd, 0xdf, 0xa5, 0xa5, 0x8d, 0xea,
+  0xff, 0xff, 0xfd, 0x26, 0xfe, 0x89, 0xff, 0x3d, 0xff, 0x53, 0x10, 0x07,
+  0x00, 0x6a, 0xfc, 0x65, 0xf9, 0x43, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x70,
+  0xfe, 0x12, 0xfe, 0xf2, 0xff, 0xbe, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x37, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16,
+  0xfe, 0x85, 0x31, 0x23, 0x24, 0x2f, 0x2f, 0x24, 0x23, 0x31, 0x6d, 0x70,
+  0x51, 0x51, 0x6f, 0x6f, 0x51, 0x51, 0x70, 0xfe, 0xea, 0x26, 0x36, 0x35,
+  0x27, 0x28, 0x35, 0x36, 0x26, 0x5a, 0x7d, 0x7d, 0x5a, 0x59, 0x7c, 0x7c,
+  0x00, 0x01, 0xfd, 0xac, 0xfe, 0x14, 0xfe, 0xb4, 0xff, 0x54, 0x00, 0x03,
+  0x00, 0x00, 0x05, 0x33, 0x03, 0x23, 0xfd, 0xf6, 0xbe, 0x94, 0x74, 0xac,
+  0xfe, 0xc0, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x6c, 0xfe, 0x75, 0xfe, 0xe1,
+  0x00, 0x00, 0x10, 0x07, 0x00, 0x7a, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0x91, 0xfe, 0x75, 0xfe, 0xe1, 0x00, 0x00, 0x10, 0x07,
+  0x02, 0x9d, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xf6,
+  0xfe, 0x14, 0xfe, 0x71, 0xff, 0xa0, 0x00, 0x03, 0x00, 0x00, 0x05, 0x11,
+  0x23, 0x11, 0xfe, 0x70, 0x7a, 0x60, 0xfe, 0x74, 0x01, 0x8c, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x3e, 0xfe, 0x50, 0xff, 0x2f, 0xff, 0x9a, 0x00, 0x07,
+  0x00, 0x00, 0x07, 0x11, 0x23, 0x35, 0x23, 0x15, 0x23, 0x11, 0xd2, 0x7b,
+  0xf9, 0x7c, 0x66, 0xfe, 0xb6, 0xc2, 0xc2, 0x01, 0x4a, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfc, 0xbf, 0xfe, 0x39, 0xff, 0xa3, 0xff, 0x58, 0x00, 0x14,
+  0x00, 0x00, 0x01, 0x06, 0x23, 0x22, 0x03, 0x34, 0x35, 0x33, 0x16, 0x33,
+  0x32, 0x37, 0x33, 0x16, 0x17, 0x32, 0x37, 0x33, 0x02, 0x07, 0x22, 0xfe,
+  0x31, 0x36, 0x68, 0xc4, 0x0f, 0x69, 0x0c, 0x5e, 0x5b, 0x0e, 0x6a, 0x0b,
+  0x5e, 0x5b, 0x0e, 0x6a, 0x0d, 0xc6, 0x68, 0xfe, 0x8b, 0x52, 0x01, 0x1a,
+  0x02, 0x03, 0x96, 0x96, 0x95, 0x01, 0x96, 0xfe, 0xe2, 0x01, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0x17, 0xfe, 0x14, 0xff, 0x56, 0xff, 0x8c, 0x11, 0x07,
+  0x02, 0x89, 0xfc, 0x6a, 0xf9, 0x26, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x12,
+  0xfe, 0x14, 0xff, 0x51, 0xff, 0x8c, 0x11, 0x07, 0x02, 0x88, 0xfc, 0x65,
+  0xf9, 0x26, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x12, 0xfe, 0x39, 0xff, 0x46,
+  0xff, 0x58, 0x10, 0x07, 0x02, 0x9a, 0xfc, 0x5f, 0xf9, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x12, 0xfe, 0x36, 0xff, 0x46, 0xff, 0x55, 0x00, 0x0c,
+  0x00, 0x00, 0x03, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e,
+  0x01, 0x20, 0x16, 0xba, 0x6a, 0x0a, 0x58, 0x4e, 0x4d, 0x57, 0x0c, 0x6a,
+  0x09, 0x8f, 0x01, 0x04, 0x8f, 0xfe, 0x36, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f,
+  0x90, 0x90, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x08, 0xfe, 0x39, 0xff, 0x5b,
+  0xff, 0x53, 0x10, 0x07, 0x02, 0x9e, 0xfc, 0x65, 0xf9, 0x1c, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0x29, 0xfe, 0xc0, 0xff, 0x44, 0xff, 0x54, 0x10, 0x07,
+  0x02, 0x8f, 0xfc, 0x6a, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0x54,
+  0xfe, 0x1d, 0x00, 0x12, 0xfe, 0xac, 0x10, 0x07, 0x00, 0x42, 0xfc, 0x66,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0x54, 0xfe, 0x1d, 0x00, 0x12,
+  0xff, 0xee, 0x10, 0x07, 0x07, 0x4c, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfb, 0xfe, 0x01, 0xec, 0xff, 0xb6, 0x03, 0x0c, 0x00, 0x1b,
+  0x00, 0x00, 0x03, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x4b, 0x43, 0x81, 0x47, 0x51, 0x66,
+  0x13, 0x0a, 0x46, 0x5c, 0x2e, 0x47, 0x7f, 0x42, 0x46, 0x84, 0x4a, 0x30,
+  0x5a, 0x43, 0x0a, 0x13, 0x69, 0x53, 0x3f, 0x7c, 0x03, 0x0c, 0xae, 0x3b,
+  0x37, 0x33, 0x0a, 0x04, 0x21, 0x18, 0x3b, 0x3f, 0xae, 0x3c, 0x36, 0x16,
+  0x1f, 0x05, 0x0a, 0x37, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xb8,
+  0x01, 0xc4, 0xff, 0x94, 0x02, 0x68, 0x00, 0x03, 0x00, 0x00, 0x03, 0x15,
+  0x21, 0x35, 0x6c, 0xfe, 0x25, 0x02, 0x68, 0xa4, 0xa4, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfb, 0x6e, 0x01, 0xc4, 0x00, 0x00, 0x02, 0x68, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0xfb, 0x6f, 0x04, 0x90, 0x01, 0xc4,
+  0xa4, 0xa4, 0x00, 0x00, 0x00, 0x01, 0xfb, 0xdd, 0xff, 0xa2, 0xff, 0xc3,
+  0x04, 0xbc, 0x00, 0x03, 0x00, 0x00, 0x05, 0x27, 0x01, 0x17, 0xfc, 0x34,
+  0x56, 0x03, 0x8f, 0x56, 0x5e, 0x4e, 0x04, 0xcc, 0x4f, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfa, 0xa9, 0xff, 0xba, 0xff, 0x9d, 0x06, 0x17, 0x00, 0x03,
+  0x00, 0x00, 0x05, 0x27, 0x01, 0x17, 0xfb, 0x06, 0x5c, 0x04, 0x96, 0x5c,
+  0x46, 0x58, 0x06, 0x05, 0x59, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xe7,
+  0xfe, 0x12, 0xfe, 0xa9, 0xff, 0xbe, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x35, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0xfd, 0xe8, 0x51, 0x6f, 0x6f, 0x51, 0x24, 0x2f, 0x2f, 0x24, 0x42, 0x7d,
+  0x5a, 0x59, 0x7c, 0x78, 0x35, 0x27, 0x28, 0x35, 0x00, 0x01, 0xfd, 0x3f,
+  0xfe, 0x5b, 0xff, 0x30, 0xff, 0xa5, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x15, 0x33, 0x35, 0x33, 0x11, 0xfd, 0x3f, 0x7c, 0xf9, 0x7b, 0xfe,
+  0x5b, 0x01, 0x4a, 0xc2, 0xc2, 0xfe, 0xb6, 0x00, 0x00, 0x02, 0xfd, 0x6a,
+  0xfe, 0x14, 0xff, 0x00, 0xff, 0xd6, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x05, 0x11, 0x21, 0x11, 0x01, 0x35, 0x23, 0x15, 0xff, 0x00, 0xfe, 0x6a,
+  0x01, 0x2a, 0xbe, 0x2a, 0xfe, 0x3e, 0x01, 0xc2, 0xfe, 0xb6, 0xd2, 0xd2,
+  0x00, 0x01, 0xfc, 0xbf, 0xfe, 0x39, 0xff, 0xa3, 0xff, 0x58, 0x00, 0x14,
+  0x00, 0x00, 0x05, 0x36, 0x33, 0x32, 0x13, 0x14, 0x15, 0x23, 0x26, 0x23,
+  0x22, 0x07, 0x23, 0x26, 0x27, 0x22, 0x07, 0x23, 0x12, 0x37, 0x32, 0xfe,
+  0x31, 0x36, 0x68, 0xc4, 0x0f, 0x69, 0x0c, 0x5e, 0x5b, 0x0e, 0x6a, 0x0b,
+  0x5e, 0x5b, 0x0e, 0x6a, 0x0d, 0xc6, 0x68, 0xfa, 0x52, 0xfe, 0xe6, 0x02,
+  0x03, 0x96, 0x96, 0x95, 0x01, 0x96, 0x01, 0x1e, 0x01, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x73, 0x04, 0xf3, 0xff, 0x02, 0x06, 0xad, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07,
+  0x17, 0x07, 0xfe, 0x3a, 0x70, 0x56, 0x70, 0x70, 0x56, 0x70, 0x71, 0x56,
+  0x70, 0x70, 0x56, 0x05, 0x70, 0x7d, 0x60, 0x7d, 0x7d, 0x60, 0x7d, 0x7d,
+  0x60, 0x7d, 0x7d, 0x60, 0x00, 0x01, 0xfe, 0x38, 0x04, 0xc2, 0xff, 0x37,
+  0x06, 0xd2, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36,
+  0x37, 0x15, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27,
+  0xfe, 0x70, 0x1e, 0x19, 0x84, 0x79, 0x49, 0x42, 0x08, 0x0b, 0x10, 0x32,
+  0x1d, 0x19, 0x84, 0x79, 0x49, 0x42, 0x08, 0x0b, 0x10, 0x05, 0xc7, 0x1c,
+  0x30, 0x1c, 0x50, 0x51, 0x02, 0x6e, 0x02, 0x1b, 0x1c, 0x0a, 0x0c, 0x0f,
+  0x0e, 0x2b, 0x1c, 0x30, 0x1c, 0x50, 0x51, 0x02, 0x6e, 0x02, 0x1b, 0x1c,
+  0x0a, 0x0c, 0x0f, 0x0e, 0xff, 0xff, 0xfc, 0x54, 0x04, 0x3a, 0x00, 0x12,
+  0x06, 0x0b, 0x10, 0x27, 0x07, 0x73, 0xfc, 0x66, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x73, 0xfc, 0x66, 0xfe, 0xbe, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xfd,
+  0x04, 0xf0, 0xfe, 0xad, 0x06, 0x66, 0x10, 0x07, 0x00, 0x43, 0xfc, 0x65,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0xb2, 0x04, 0xee, 0xff, 0x62,
+  0x06, 0x66, 0x10, 0x07, 0x00, 0x76, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0x08, 0x05, 0x1d, 0xff, 0x5b, 0x06, 0x37, 0x10, 0x07,
+  0x02, 0x9e, 0xfc, 0x65, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0xce,
+  0x04, 0xc2, 0xfe, 0xa8, 0x06, 0xc1, 0x10, 0x06, 0x02, 0xc4, 0x00, 0x00,
+  0xff, 0xff, 0xfd, 0x36, 0x05, 0x46, 0xff, 0x72, 0x07, 0xd2, 0x10, 0x07,
+  0x03, 0x1c, 0xfc, 0x75, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfd, 0xff,
+  0xfe, 0x56, 0xfe, 0xc5, 0xff, 0xa4, 0x10, 0x07, 0x03, 0x16, 0xfc, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x26, 0x05, 0x1d, 0xff, 0x41,
+  0x06, 0x49, 0x00, 0x07, 0x00, 0x00, 0x03, 0x23, 0x35, 0x21, 0x15, 0x23,
+  0x11, 0x21, 0xc0, 0x87, 0xfe, 0xf4, 0x87, 0x02, 0x1a, 0x05, 0x1d, 0x96,
+  0x96, 0x01, 0x2c, 0x00, 0x00, 0x02, 0xfd, 0x68, 0xfe, 0x32, 0xfe, 0xfe,
+  0xff, 0xb8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21,
+  0x35, 0x21, 0x35, 0x21, 0xfe, 0xfe, 0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b,
+  0x01, 0x95, 0xfe, 0x32, 0x78, 0x96, 0x78, 0x00, 0x00, 0x02, 0xfd, 0x5f,
+  0xfe, 0x14, 0xff, 0x07, 0xff, 0xa0, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x05, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0xfd, 0x60, 0x87, 0x87,
+  0x01, 0x20, 0x87, 0x87, 0x60, 0xfe, 0x74, 0x01, 0x8c, 0xfe, 0x74, 0x00,
+  0x00, 0x01, 0xfd, 0x68, 0xfe, 0x14, 0xfe, 0xfe, 0xff, 0xd6, 0x00, 0x05,
+  0x00, 0x00, 0x05, 0x21, 0x11, 0x23, 0x11, 0x21, 0xfd, 0x69, 0x01, 0x95,
+  0x87, 0xfe, 0xf2, 0x2a, 0xfe, 0x3e, 0x01, 0x2c, 0x00, 0x01, 0xfd, 0x0a,
+  0x04, 0xee, 0xff, 0x5d, 0x06, 0x66, 0x00, 0x27, 0x00, 0x00, 0x01, 0x37,
+  0x33, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x07, 0x23, 0x37, 0x26, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0xfe, 0x32, 0x3c, 0x62, 0x60, 0x09, 0x14, 0x0f, 0x0b, 0x23,
+  0x10, 0x10, 0x02, 0x70, 0x02, 0x2e, 0x2d, 0x52, 0x23, 0x1c, 0x1b, 0x1e,
+  0x3b, 0x63, 0x60, 0x0c, 0x12, 0x0e, 0x0c, 0x22, 0x10, 0x11, 0x01, 0x71,
+  0x02, 0x2e, 0x2e, 0x52, 0x22, 0x1d, 0x1b, 0x05, 0xff, 0x67, 0xa9, 0x09,
+  0x0e, 0x0a, 0x24, 0x25, 0x52, 0x87, 0x4a, 0x49, 0x0e, 0x0d, 0x1d, 0x67,
+  0xa8, 0x0b, 0x0d, 0x0a, 0x24, 0x25, 0x52, 0x87, 0x4a, 0x49, 0x0e, 0x0d,
+  0x00, 0x03, 0xfd, 0x0a, 0x04, 0x89, 0xff, 0x5d, 0x06, 0xcc, 0x00, 0x1d,
+  0x00, 0x21, 0x00, 0x25, 0x00, 0x00, 0x01, 0x27, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x1d, 0x01, 0x23, 0x34, 0x36, 0x33, 0x32, 0x16, 0x1f, 0x01, 0x1e,
+  0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x26,
+  0x07, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0xfe, 0x30, 0x34, 0x16,
+  0x1c, 0x0b, 0x20, 0x24, 0x71, 0x5d, 0x4d, 0x21, 0x37, 0x2b, 0x33, 0x15,
+  0x1e, 0x0e, 0x1d, 0x24, 0x70, 0x02, 0x5c, 0x4c, 0x1e, 0x36, 0xd0, 0x87,
+  0x87, 0xbd, 0x87, 0x87, 0x05, 0x68, 0x21, 0x0e, 0x0b, 0x32, 0x2d, 0x06,
+  0x65, 0x76, 0x10, 0x1b, 0x1e, 0x0d, 0x0c, 0x33, 0x29, 0x06, 0x64, 0x77,
+  0x10, 0x2e, 0x96, 0x02, 0x43, 0x96, 0x00, 0x00, 0xff, 0xff, 0xfd, 0x0a,
+  0x04, 0xc5, 0xff, 0x5d, 0x06, 0x90, 0x10, 0x22, 0x10, 0xed, 0x00, 0xb7,
+  0x10, 0x03, 0x10, 0xed, 0x00, 0x00, 0x00, 0xa7, 0x00, 0x01, 0xfc, 0xbf,
+  0xfe, 0x28, 0xff, 0xa7, 0xff, 0xc2, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x37,
+  0x21, 0x17, 0x23, 0x27, 0x37, 0x33, 0x07, 0x21, 0x27, 0x33, 0x17, 0x07,
+  0xfe, 0x98, 0x77, 0xfe, 0x49, 0x77, 0x72, 0x9d, 0x9d, 0x72, 0x77, 0x01,
+  0xb7, 0x77, 0x71, 0x9e, 0x9e, 0xfe, 0x28, 0x9b, 0x9b, 0xcd, 0xcd, 0x9b,
+  0x9b, 0xcd, 0xcd, 0x00, 0x00, 0x01, 0xfd, 0x7a, 0xfe, 0x14, 0xfe, 0xec,
+  0xff, 0xa4, 0x00, 0x08, 0x00, 0x00, 0x01, 0x23, 0x35, 0x07, 0x35, 0x37,
+  0x17, 0x15, 0x27, 0xfe, 0x60, 0x5a, 0x8b, 0xb8, 0xb9, 0x8c, 0xfe, 0x14,
+  0xe7, 0x84, 0x7e, 0xaf, 0xaf, 0x7e, 0x84, 0x00, 0x00, 0x01, 0xfd, 0xb8,
+  0x04, 0xe1, 0xfe, 0xae, 0x07, 0x06, 0x00, 0x10, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0xfe, 0xae, 0x3a, 0x26, 0x27, 0x27, 0x26, 0x3a, 0x67,
+  0x46, 0x48, 0x48, 0x46, 0x67, 0x06, 0x8b, 0x01, 0x2a, 0x2c, 0x40, 0x41,
+  0x2b, 0x2b, 0x01, 0x7b, 0x01, 0x4f, 0x50, 0xe6, 0x50, 0x4e, 0x01, 0x00,
+  0xff, 0xff, 0xfd, 0x12, 0x04, 0x60, 0xff, 0x46, 0x06, 0xd8, 0x10, 0x27,
+  0x02, 0xc2, 0x00, 0x00, 0x00, 0x90, 0x10, 0x06, 0x02, 0xb8, 0x00, 0xe5,
+  0xff, 0xff, 0xfd, 0x73, 0xfe, 0x14, 0xff, 0x02, 0xff, 0xce, 0x10, 0x07,
+  0x02, 0xee, 0x00, 0x00, 0xf9, 0x21, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xb8,
+  0x04, 0xe1, 0xfe, 0xae, 0x07, 0x06, 0x00, 0x12, 0x00, 0x00, 0x01, 0x30,
+  0x35, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x30, 0x35, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0xfd, 0xb9, 0x66, 0x47, 0x48, 0x48, 0x47,
+  0x66, 0x39, 0x26, 0x28, 0x28, 0x26, 0x06, 0x8b, 0x7b, 0x01, 0x4e, 0x50,
+  0xe6, 0x50, 0x4f, 0x01, 0x7b, 0x01, 0x2b, 0x2b, 0x41, 0x40, 0x2c, 0x2a,
+  0xff, 0xff, 0xff, 0x43, 0x05, 0x44, 0xff, 0xfb, 0x06, 0x10, 0x10, 0x07,
+  0x02, 0x9b, 0xfd, 0xd2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xfc, 0xe8,
+  0xfe, 0x12, 0xff, 0x7e, 0xff, 0xbf, 0x00, 0x07, 0x00, 0x15, 0x00, 0x1d,
+  0x00, 0x00, 0x00, 0x16, 0x32, 0x3e, 0x01, 0x26, 0x22, 0x06, 0x37, 0x36,
+  0x32, 0x16, 0x14, 0x06, 0x22, 0x27, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32,
+  0x12, 0x36, 0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0xfd, 0x55, 0x30, 0x47,
+  0x2f, 0x02, 0x31, 0x47, 0x30, 0xde, 0x38, 0xa3, 0x70, 0x70, 0xa4, 0x37,
+  0x38, 0xa3, 0x70, 0x70, 0xa3, 0xe5, 0x31, 0x31, 0x47, 0x30, 0x30, 0xfe,
+  0xc3, 0x35, 0x35, 0x4d, 0x37, 0x35, 0x6d, 0x3f, 0x7c, 0xb3, 0x7d, 0x41,
+  0x40, 0x7d, 0xb3, 0x7c, 0xfe, 0xce, 0x36, 0x4d, 0x36, 0x35, 0x4f, 0x35,
+  0xff, 0xff, 0xfc, 0xcb, 0xfe, 0x1b, 0x03, 0x35, 0xff, 0x85, 0x10, 0x07,
+  0x07, 0x74, 0xfd, 0x1b, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xcb,
+  0x06, 0x6b, 0x03, 0x35, 0x07, 0xd5, 0x10, 0x07, 0x07, 0x74, 0xfd, 0x1b,
+  0x08, 0x50, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xcb, 0x06, 0xd7, 0x03, 0x35,
+  0x07, 0x6b, 0x00, 0x03, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0xfc, 0xcb,
+  0x06, 0x6a, 0xf9, 0x96, 0x07, 0x6b, 0x94, 0x00, 0x00, 0x01, 0xfc, 0xcb,
+  0xfe, 0xc0, 0x03, 0x35, 0xff, 0x54, 0x00, 0x03, 0x00, 0x00, 0x05, 0x21,
+  0x15, 0x21, 0xfc, 0xcb, 0x06, 0x6a, 0xf9, 0x96, 0xac, 0x94, 0x00, 0x00,
+  0x00, 0x01, 0xfd, 0x72, 0x06, 0x0d, 0x02, 0x8e, 0x07, 0x27, 0x00, 0x23,
+  0x00, 0x00, 0x03, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
+  0x23, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x04, 0x81, 0x19, 0x48, 0x27, 0x21, 0x5a, 0x30, 0x3f, 0x05,
+  0x91, 0x03, 0x66, 0x65, 0xb4, 0x52, 0x38, 0x34, 0x51, 0x81, 0x19, 0x48,
+  0x27, 0x21, 0x57, 0x33, 0x40, 0x04, 0x91, 0x03, 0x66, 0x65, 0xb4, 0x52,
+  0x38, 0x34, 0x06, 0x4a, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x30, 0x47, 0x87,
+  0x4a, 0x49, 0x0e, 0x0d, 0x22, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x2c, 0x4b,
+  0x87, 0x4a, 0x49, 0x0e, 0x0d, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xcb,
+  0x06, 0x04, 0x03, 0x35, 0x07, 0x6e, 0x10, 0x07, 0x07, 0x75, 0xfd, 0x1b,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xd1, 0xfe, 0x28, 0x03, 0x38,
+  0xff, 0xc2, 0x00, 0x08, 0x00, 0x00, 0x01, 0x35, 0x21, 0x27, 0x33, 0x17,
+  0x07, 0x23, 0x37, 0xfc, 0xd2, 0x05, 0xcd, 0x76, 0x71, 0x9e, 0x9e, 0x71,
+  0x76, 0xfe, 0xc3, 0x64, 0x9b, 0xcd, 0xcd, 0x9b, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x00, 0x05, 0xd5, 0x10, 0x06, 0x0e, 0x40, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x03, 0x6f, 0x04, 0x60, 0x10, 0x06,
+  0x0e, 0x41, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x80,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xb5, 0x04, 0xcb, 0xb6, 0xfe, 0xac,
+  0xb7, 0xfe, 0xac, 0xb6, 0x05, 0xd5, 0xfc, 0xf4, 0x02, 0x62, 0xfa, 0xd5,
+  0x05, 0x2b, 0xfd, 0x9e, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf5,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0xb5, 0x03, 0x3f, 0xa5, 0xa7, 0xa6,
+  0xa7, 0xa6, 0x05, 0xd5, 0xfc, 0xf4, 0x02, 0x62, 0xfa, 0xd5, 0x05, 0x2b,
+  0xfd, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x90, 0x04, 0x74, 0x01, 0x76,
+  0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x1b, 0x01, 0x33, 0x03, 0x90, 0x3a,
+  0xac, 0x64, 0x04, 0x74, 0x01, 0xf2, 0xfe, 0x0e, 0x00, 0x01, 0x00, 0x90,
+  0xfe, 0x56, 0x01, 0x76, 0x00, 0x48, 0x00, 0x03, 0x00, 0x00, 0x25, 0x03,
+  0x23, 0x13, 0x01, 0x76, 0x3b, 0xab, 0x63, 0x48, 0xfe, 0x0e, 0x01, 0xf2,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x10, 0x06,
+  0x03, 0xac, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
+  0x04, 0x60, 0x10, 0x06, 0x03, 0xcc, 0x00, 0x00, 0x00, 0x01, 0x01, 0x8a,
+  0xfe, 0x56, 0x02, 0x51, 0xff, 0xa4, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x23,
+  0x22, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01,
+  0x02, 0x50, 0x85, 0x17, 0x18, 0x12, 0x86, 0x09, 0x0b, 0x0d, 0x1f, 0xfe,
+  0x56, 0x21, 0x1a, 0x2e, 0xe5, 0xe5, 0x0e, 0x0c, 0x0d, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90, 0x04, 0x7b, 0x10, 0x06,
+  0x02, 0x16, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
+  0x04, 0x7b, 0x10, 0x27, 0x00, 0x79, 0x01, 0x2e, 0xff, 0x84, 0x10, 0x06,
+  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90,
+  0x04, 0x7b, 0x10, 0x27, 0x00, 0x79, 0x00, 0x80, 0xff, 0x84, 0x10, 0x06,
+  0x02, 0x16, 0x00, 0x00, 0xff, 0xff, 0x00, 0x8e, 0xff, 0x12, 0x01, 0x96,
+  0x04, 0x23, 0x12, 0x06, 0x00, 0x1e, 0x00, 0x00, 0x00, 0x01, 0x01, 0x4d,
+  0x04, 0xee, 0x02, 0xfd, 0x06, 0x66, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33,
+  0x01, 0x23, 0x02, 0x4a, 0xb3, 0xfe, 0xdb, 0x8a, 0x06, 0x66, 0xfe, 0x88,
+  0xff, 0xff, 0x00, 0xc1, 0x05, 0x46, 0x02, 0xfd, 0x07, 0xd2, 0x12, 0x26,
+  0x00, 0x6a, 0x00, 0x00, 0x11, 0x07, 0x03, 0x1b, 0x00, 0x00, 0x01, 0x6c,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0xf7, 0x00, 0x00, 0x10, 0x06,
+  0x03, 0x26, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc5, 0x02, 0x48, 0x01, 0x83,
+  0x03, 0x46, 0x12, 0x06, 0x00, 0x79, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe9,
+  0x00, 0x00, 0x04, 0xea, 0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0x9c,
+  0x00, 0x00, 0x10, 0x07, 0x03, 0x2a, 0x00, 0xd3, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xf4, 0x00, 0x00, 0x05, 0x83, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x1b, 0xfe, 0xa6, 0x00, 0x00, 0x10, 0x07, 0x03, 0x2c, 0x00, 0xcd,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3e,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0xa1, 0x00, 0x00, 0x10, 0x07,
+  0x03, 0x2e, 0x00, 0xd3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf3,
+  0xff, 0xe3, 0x05, 0x68, 0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0xa6,
+  0x00, 0x00, 0x10, 0x06, 0x03, 0x34, 0x24, 0x00, 0xff, 0xff, 0xff, 0xe4,
+  0x00, 0x00, 0x05, 0xe9, 0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0xfe, 0x96,
+  0x00, 0x00, 0x10, 0x07, 0x03, 0x39, 0x01, 0x7f, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xde, 0x00, 0x00, 0x05, 0x6b, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x1b, 0xfe, 0x91, 0x00, 0x00, 0x10, 0x06, 0x03, 0x3d, 0x31, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x40, 0x07, 0xd2, 0x10, 0x27,
+  0x03, 0x1c, 0xff, 0x43, 0x00, 0x00, 0x12, 0x06, 0x03, 0x4d, 0x0e, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x25, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0xb5, 0x03, 0x44, 0xfd, 0x72, 0x05, 0xd5, 0xaa,
+  0xfa, 0xd5, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x05, 0xd5, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x21, 0x05,
+  0x01, 0x33, 0x01, 0x02, 0x76, 0xfe, 0x8f, 0x02, 0xe3, 0xfc, 0x26, 0x02,
+  0x01, 0xcf, 0x02, 0x00, 0x05, 0x0e, 0xfb, 0x9a, 0xa8, 0x05, 0xd5, 0xfa,
+  0x2b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
+  0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x3d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x2b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x05, 0xf0, 0x00, 0x03, 0x00, 0x12, 0x00, 0x21, 0x00, 0x00, 0x01, 0x21,
+  0x15, 0x21, 0x01, 0x22, 0x07, 0x06, 0x11, 0x10, 0x12, 0x33, 0x32, 0x37,
+  0x36, 0x11, 0x10, 0x27, 0x26, 0x27, 0x20, 0x00, 0x11, 0x10, 0x07, 0x06,
+  0x21, 0x20, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x01, 0x98, 0x02, 0x7b,
+  0xfd, 0x85, 0x01, 0x3e, 0xc6, 0x74, 0x75, 0xe9, 0xc6, 0xc6, 0x74, 0x74,
+  0x74, 0x74, 0xc6, 0x01, 0x1b, 0x01, 0x52, 0xa9, 0xa9, 0xfe, 0xe5, 0xfe,
+  0xe5, 0xaa, 0xa9, 0xa9, 0xaa, 0x03, 0x70, 0xaa, 0x02, 0x86, 0xa4, 0xa4,
+  0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0xa4, 0xa4, 0x01, 0x1a, 0x01, 0x1b,
+  0xa4, 0xa4, 0xa4, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0x9f, 0xd2, 0xd3, 0xd2,
+  0xd2, 0x01, 0x62, 0x01, 0x62, 0xd3, 0xd2, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x01, 0x6b, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x2c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x2e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x33, 0x23, 0x01, 0x33, 0x01, 0x23,
+  0x01, 0xce, 0xc0, 0x02, 0x01, 0xcf, 0x02, 0x00, 0xbd, 0xfe, 0x55, 0x05,
+  0xd5, 0xfa, 0x2b, 0x05, 0x0e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x30, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x31, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf2,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
+  0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x01, 0x13,
+  0x02, 0x80, 0xfd, 0x80, 0x5e, 0x03, 0x3d, 0xfc, 0xc3, 0x03, 0x3d, 0xfc,
+  0xc3, 0x03, 0x71, 0xaa, 0x03, 0x0e, 0xaa, 0xfb, 0x7f, 0xaa, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06,
+  0x00, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6,
+  0x05, 0xd5, 0x12, 0x06, 0x03, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x25, 0x21, 0x15, 0x21, 0x35, 0x09, 0x01, 0x35, 0x21, 0x15,
+  0x21, 0x01, 0x01, 0x86, 0x02, 0x91, 0xfc, 0x9e, 0x01, 0xaf, 0xfe, 0x51,
+  0x03, 0x51, 0xfd, 0x80, 0x01, 0xaf, 0xaa, 0xaa, 0xaa, 0x02, 0x70, 0x02,
+  0x11, 0xaa, 0xaa, 0xfd, 0xf3, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa,
+  0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x37, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x3c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67, 0x00, 0x00, 0x05, 0x44,
+  0x05, 0xd5, 0x00, 0x08, 0x00, 0x11, 0x00, 0x27, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x33, 0x36, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x03, 0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36,
+  0x37, 0x35, 0x33, 0x15, 0x16, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x07,
+  0x15, 0x23, 0x02, 0x7b, 0x87, 0x58, 0x75, 0x75, 0x58, 0x87, 0xb6, 0x87,
+  0x58, 0x74, 0x74, 0x58, 0x87, 0xb6, 0xdb, 0x8e, 0xaa, 0xaa, 0x8d, 0xdc,
+  0xb6, 0xdc, 0x8d, 0xa9, 0xa9, 0x8d, 0xdc, 0xb6, 0x04, 0x8e, 0x15, 0x57,
+  0x73, 0xc6, 0xc5, 0x73, 0x57, 0x15, 0x15, 0x57, 0x73, 0xc5, 0xc6, 0x73,
+  0x57, 0x15, 0xfc, 0x10, 0x16, 0x86, 0xa0, 0x01, 0x0f, 0x01, 0x0f, 0xa1,
+  0x87, 0x16, 0x9f, 0x9f, 0x17, 0x86, 0xa1, 0xfe, 0xf1, 0xfe, 0xf2, 0xa1,
+  0x86, 0x17, 0x9d, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
+  0x00, 0x00, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x21, 0x36,
+  0x27, 0x22, 0x27, 0x26, 0x03, 0x11, 0x33, 0x11, 0x10, 0x17, 0x16, 0x17,
+  0x11, 0x33, 0x11, 0x36, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x02, 0x07,
+  0x06, 0x23, 0x06, 0x17, 0x02, 0x7b, 0x01, 0x01, 0xc0, 0xaa, 0xa5, 0x04,
+  0xbf, 0x75, 0x63, 0x7c, 0xb6, 0x7d, 0x63, 0x74, 0xc0, 0x05, 0xa5, 0xa9,
+  0xc1, 0x01, 0x01, 0x86, 0xb0, 0xd2, 0xcc, 0x01, 0x68, 0x01, 0x99, 0xfe,
+  0x67, 0xfe, 0xe6, 0xa4, 0x8c, 0x0e, 0x03, 0xf1, 0xfc, 0x0f, 0x0e, 0x8c,
+  0xa4, 0x01, 0x1a, 0x01, 0x99, 0xfe, 0x67, 0xfe, 0x98, 0xcc, 0xd2, 0x48,
+  0xee, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x46, 0x00, 0x00, 0x05, 0x3b,
+  0x05, 0xe7, 0x00, 0x26, 0x00, 0x00, 0x25, 0x15, 0x21, 0x35, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x02, 0x15, 0x14, 0x17, 0x16,
+  0x17, 0x15, 0x21, 0x35, 0x21, 0x26, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36,
+  0x21, 0x20, 0x17, 0x16, 0x11, 0x14, 0x07, 0x06, 0x07, 0x05, 0x3a, 0xfd,
+  0xe4, 0xa0, 0x59, 0x59, 0x77, 0x77, 0xc2, 0xc3, 0xee, 0x59, 0x5a, 0xa0,
+  0xfd, 0xe4, 0x01, 0x1f, 0x8e, 0x41, 0x41, 0xac, 0xac, 0x01, 0x13, 0x01,
+  0x11, 0xad, 0xad, 0x40, 0x40, 0x91, 0xb2, 0xb2, 0xb2, 0x61, 0xa6, 0xa6,
+  0xca, 0xf0, 0x91, 0x91, 0xfe, 0xdd, 0xef, 0xca, 0xa6, 0xa6, 0x61, 0xb2,
+  0xb2, 0x8b, 0x95, 0x95, 0xb8, 0x01, 0x3e, 0xc5, 0xc5, 0xc5, 0xc4, 0xfe,
+  0xcb, 0xc2, 0x94, 0x94, 0x8d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0x00, 0x00, 0x02, 0x1c, 0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x02, 0xde,
+  0x01, 0x75, 0x13, 0x06, 0x03, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x07, 0x4e, 0x10, 0x27,
+  0x10, 0xeb, 0x03, 0xff, 0x01, 0x75, 0x13, 0x06, 0x03, 0x39, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
+  0x06, 0x66, 0x12, 0x26, 0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x03, 0x1b,
+  0x63, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
+  0x06, 0x66, 0x10, 0x26, 0x03, 0x1b, 0x48, 0x00, 0x12, 0x06, 0x03, 0x49,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x1b, 0x00, 0xb2, 0x00, 0x00, 0x12, 0x06,
+  0x03, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x56,
+  0x06, 0x66, 0x12, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x03, 0x1b,
+  0xff, 0x59, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
+  0x07, 0xd2, 0x12, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x03, 0x1c,
+  0x18, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
+  0x04, 0x79, 0x00, 0x0d, 0x00, 0x2a, 0x00, 0x00, 0x01, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x1b, 0x01,
+  0x33, 0x03, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11, 0x10, 0x37,
+  0x36, 0x33, 0x20, 0x02, 0xf9, 0x27, 0x29, 0xa0, 0x78, 0x37, 0x46, 0x43,
+  0x45, 0x6d, 0x79, 0x40, 0x94, 0x59, 0x94, 0xb9, 0x24, 0x08, 0x20, 0x25,
+  0x1d, 0x4f, 0x63, 0x55, 0x4b, 0x25, 0x10, 0x29, 0x54, 0x29, 0x80, 0xd3,
+  0x67, 0x69, 0x72, 0x7f, 0xb2, 0x01, 0x18, 0x02, 0x09, 0xe7, 0xed, 0x6e,
+  0x8a, 0xb6, 0xdc, 0x69, 0x6b, 0xd5, 0x01, 0xe7, 0x01, 0x25, 0xfd, 0xa1,
+  0xdb, 0x31, 0x29, 0x30, 0x9c, 0x54, 0x2a, 0x58, 0x6f, 0x57, 0x29, 0x98,
+  0x9d, 0x01, 0x13, 0x01, 0x26, 0x8a, 0x9a, 0x00, 0x00, 0x02, 0x00, 0xac,
+  0xfe, 0x56, 0x04, 0x14, 0x06, 0x21, 0x00, 0x0e, 0x00, 0x1c, 0x00, 0x00,
+  0x25, 0x11, 0x23, 0x11, 0x10, 0x21, 0x20, 0x11, 0x10, 0x07, 0x16, 0x11,
+  0x10, 0x21, 0x22, 0x03, 0x16, 0x33, 0x20, 0x11, 0x10, 0x05, 0x35, 0x20,
+  0x11, 0x34, 0x23, 0x22, 0x11, 0x01, 0x53, 0xa6, 0x01, 0x7f, 0x01, 0x87,
+  0x9b, 0xfc, 0xfe, 0x4e, 0xbf, 0x50, 0x64, 0xb1, 0x01, 0x04, 0xfe, 0x5e,
+  0x01, 0x47, 0xd3, 0xeb, 0x45, 0xfe, 0x11, 0x06, 0x03, 0x01, 0xc8, 0xfe,
+  0x7f, 0xfe, 0xee, 0x64, 0x5a, 0xfe, 0xf5, 0xfe, 0x26, 0x01, 0x4a, 0xad,
+  0x01, 0x3a, 0x01, 0x1a, 0x16, 0xaa, 0x01, 0x40, 0xdb, 0xfe, 0xc8, 0x00,
+  0x00, 0x01, 0x00, 0x1c, 0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x0e,
+  0x00, 0x00, 0x01, 0x13, 0x01, 0x33, 0x01, 0x11, 0x23, 0x11, 0x01, 0x26,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x01, 0x45, 0xdc, 0x01, 0x3b, 0xb0, 0xfe,
+  0x68, 0xa5, 0xfe, 0xf7, 0x27, 0x56, 0x2c, 0x3f, 0xb1, 0x03, 0xb0, 0xfd,
+  0x4c, 0x03, 0x64, 0xfb, 0xa0, 0xfe, 0x56, 0x01, 0xaa, 0x03, 0x44, 0x7e,
+  0x9e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
+  0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x11, 0x34, 0x37, 0x36, 0x37, 0x26, 0x35, 0x10, 0x21, 0x32,
+  0x17, 0x01, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x03, 0x88, 0x5c, 0xd7, 0xe4, 0xee,
+  0xba, 0x6a, 0x80, 0x7b, 0x7c, 0xd8, 0xd7, 0x7c, 0x7b, 0x7b, 0x30, 0x43,
+  0x8c, 0x01, 0x8d, 0xc7, 0x6c, 0xfe, 0x48, 0x3d, 0x31, 0x4e, 0x4d, 0x4d,
+  0x86, 0x85, 0x9a, 0x51, 0x58, 0x71, 0x3a, 0x05, 0x11, 0x46, 0x75, 0x5c,
+  0x30, 0x25, 0x70, 0x87, 0xfe, 0xeb, 0xfe, 0xf7, 0x9c, 0x9d, 0x9d, 0x9c,
+  0x01, 0x13, 0xcc, 0xa5, 0x40, 0x24, 0x4f, 0x8d, 0x01, 0x10, 0x46, 0xfe,
+  0x28, 0x1d, 0x49, 0x71, 0xcc, 0xcb, 0x72, 0x73, 0xe8, 0xbe, 0xc7, 0x60,
+  0x67, 0x0b, 0x06, 0x00, 0x00, 0x01, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
+  0x04, 0x7c, 0x00, 0x32, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x01, 0x64, 0x65,
+  0x36, 0x36, 0x66, 0x66, 0xb0, 0x45, 0x99, 0x58, 0x57, 0x48, 0x49, 0x40,
+  0x6b, 0x3e, 0x3f, 0x3d, 0x3c, 0x69, 0x8b, 0x85, 0x7b, 0x41, 0x46, 0x4b,
+  0x4d, 0x88, 0x53, 0x4d, 0x4c, 0x40, 0x51, 0x4b, 0x4d, 0x48, 0xd6, 0x74,
+  0x74, 0x7c, 0x02, 0x5c, 0x18, 0x41, 0x40, 0x5d, 0x8d, 0x4f, 0x4e, 0x18,
+  0x18, 0xa7, 0x1d, 0x0d, 0x0d, 0x2e, 0x2e, 0x40, 0x46, 0x2d, 0x2c, 0x98,
+  0x33, 0x38, 0x58, 0x5a, 0x38, 0x38, 0x12, 0x13, 0x25, 0xab, 0x1c, 0x0e,
+  0x0e, 0x5b, 0x5b, 0xad, 0x6c, 0x92, 0x00, 0x00, 0x00, 0x01, 0x00, 0x60,
+  0xfe, 0x52, 0x03, 0x93, 0x06, 0x14, 0x00, 0x1d, 0x00, 0x00, 0x25, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x23, 0x20, 0x03, 0x10, 0x01, 0x21, 0x35, 0x21,
+  0x15, 0x00, 0x11, 0x10, 0x02, 0x83, 0x76, 0x47, 0x4c, 0x42, 0x49, 0x92,
+  0x3e, 0x26, 0x1d, 0x1d, 0x1d, 0x33, 0xfd, 0xde, 0x01, 0x02, 0x02, 0xfe,
+  0x21, 0x03, 0x0f, 0xfd, 0x75, 0x7f, 0x01, 0x4b, 0x4f, 0x78, 0x73, 0x50,
+  0x57, 0x4b, 0x4c, 0x05, 0x2c, 0x23, 0x25, 0x35, 0x2c, 0x2a, 0x02, 0x33,
+  0x01, 0xec, 0x01, 0x59, 0xb9, 0xb9, 0xfe, 0x94, 0xfe, 0x27, 0xfe, 0x69,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x04, 0x7b, 0x00, 0x15,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0x51, 0x50,
+  0x6a, 0xad, 0x59, 0x5a, 0x02, 0xa4, 0xfb, 0xb2, 0x04, 0x48, 0x9f, 0x9e,
+  0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x65, 0x32, 0x32, 0x77, 0x78,
+  0x00, 0x03, 0x00, 0x65, 0xff, 0xe9, 0x04, 0x03, 0x06, 0x24, 0x00, 0x08,
+  0x00, 0x11, 0x00, 0x21, 0x00, 0x00, 0x01, 0x21, 0x12, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x13, 0x02, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x03,
+  0x01, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x11, 0x10, 0x37, 0x36, 0x03, 0x52, 0xfd, 0xc3, 0x0e, 0x3e, 0x4d, 0x86,
+  0x87, 0x4b, 0x42, 0x08, 0x1a, 0x30, 0x4d, 0x85, 0x8a, 0x48, 0x3a, 0x11,
+  0x01, 0x1d, 0xd8, 0x7c, 0x7b, 0x7b, 0x7c, 0xd8, 0xd9, 0x7a, 0x7b, 0x7b,
+  0x7a, 0x02, 0xc6, 0xfe, 0xd5, 0x7f, 0x9c, 0x9d, 0x8a, 0x01, 0xc9, 0x01,
+  0x1c, 0x64, 0x9e, 0x9c, 0x7e, 0xfe, 0xfc, 0x02, 0xb4, 0xd4, 0xd3, 0xfe,
+  0x8a, 0xfe, 0x8b, 0xd4, 0xd5, 0xd5, 0xd4, 0x01, 0x75, 0x01, 0x76, 0xd3,
+  0xd4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x95, 0x00, 0x00, 0x02, 0x30,
+  0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x03, 0x01, 0x40, 0x1e, 0x20,
+  0x62, 0x50, 0x64, 0xa2, 0x4a, 0x4a, 0x01, 0x04, 0x60, 0xfd, 0x2b, 0x91,
+  0x2e, 0x30, 0x9c, 0x60, 0x62, 0xd4, 0x02, 0xca, 0x00, 0x01, 0x00, 0xab,
+  0x00, 0x00, 0x04, 0x12, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0xac, 0xab,
+  0x01, 0xb3, 0xc9, 0xfe, 0x73, 0x01, 0xcb, 0xca, 0xfe, 0x8b, 0x7b, 0xab,
+  0x04, 0x60, 0xfe, 0x2f, 0x01, 0xd1, 0xfe, 0x5a, 0xfd, 0x46, 0x02, 0x42,
+  0x81, 0xfe, 0x3f, 0x00, 0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
+  0x06, 0x14, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23,
+  0x01, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x17, 0x16, 0x02, 0x3b, 0x01, 0xd1,
+  0xb0, 0xfe, 0xe6, 0xfe, 0xa4, 0xaf, 0x01, 0xba, 0x43, 0x2a, 0x60, 0x57,
+  0x69, 0xcc, 0x05, 0x65, 0xfa, 0x9b, 0x03, 0x3c, 0xfc, 0xc4, 0x04, 0x32,
+  0xc6, 0x7e, 0x9e, 0x02, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c,
+  0xfe, 0x56, 0x04, 0x68, 0x04, 0x60, 0x10, 0x06, 0x00, 0x77, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x42, 0x00, 0x00, 0x03, 0xb0, 0x04, 0x60, 0x00, 0x15,
+  0x00, 0x00, 0x21, 0x01, 0x33, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36, 0x27,
+  0x26, 0x27, 0x33, 0x31, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x01, 0x76, 0xfe, 0xcd, 0xb2, 0x01, 0x04, 0x6c, 0x5a, 0x45, 0x03, 0x02,
+  0x16, 0x19, 0x60, 0xa8, 0x3e, 0x29, 0x26, 0x7a, 0xa0, 0x6e, 0x04, 0x60,
+  0xfc, 0x54, 0x7c, 0xac, 0x81, 0x70, 0x35, 0x64, 0x77, 0x83, 0x59, 0x7c,
+  0x72, 0x4e, 0xc4, 0xaf, 0xe4, 0x74, 0x00, 0x00, 0x00, 0x01, 0x00, 0x60,
+  0xfe, 0x52, 0x03, 0x9b, 0x06, 0x14, 0x00, 0x26, 0x00, 0x00, 0x25, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x23, 0x20, 0x11, 0x10, 0x25, 0x26, 0x11, 0x34,
+  0x37, 0x23, 0x35, 0x21, 0x15, 0x20, 0x11, 0x14, 0x05, 0x15, 0x24, 0x13,
+  0x12, 0x02, 0x91, 0x77, 0x47, 0x4b, 0x42, 0x49, 0x92, 0x3e, 0x26, 0x1d,
+  0x1d, 0x1c, 0x34, 0xfd, 0xcf, 0x01, 0x2c, 0xfc, 0xc6, 0xbb, 0x02, 0xc6,
+  0xfd, 0xca, 0x01, 0xdb, 0xfd, 0xff, 0x02, 0x01, 0x7f, 0x01, 0x4b, 0x4f,
+  0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c, 0x05, 0x2c, 0x23, 0x25, 0x35, 0x2c,
+  0x2a, 0x01, 0xb5, 0x01, 0x2c, 0x58, 0x24, 0x01, 0x04, 0xc5, 0x52, 0xb9,
+  0xb9, 0xfe, 0xdd, 0xbf, 0x09, 0xaa, 0x16, 0xfe, 0xbc, 0xfe, 0xf1, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x12, 0x06,
+  0x00, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0x42, 0xff, 0xd9, 0x04, 0x23,
+  0x04, 0x60, 0x00, 0x17, 0x00, 0x00, 0x13, 0x21, 0x15, 0x23, 0x11, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
+  0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x43, 0x03, 0xc5, 0x7f, 0x2d, 0x31,
+  0x0d, 0x28, 0x06, 0x1f, 0x43, 0x21, 0x6c, 0x53, 0xfe, 0x8c, 0xa9, 0x80,
+  0x04, 0x60, 0xb8, 0xfd, 0x50, 0x48, 0x3f, 0x05, 0x01, 0x85, 0x0d, 0x0c,
+  0x83, 0xb0, 0x02, 0x9c, 0xfc, 0x58, 0x03, 0xa8, 0x00, 0x02, 0x00, 0xa7,
+  0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x00,
+  0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
+  0x26, 0x27, 0x11, 0x23, 0x11, 0x34, 0x05, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0xf8, 0x37, 0x88, 0x35, 0xa4, 0xb8,
+  0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xa7, 0x02, 0xda, 0x96, 0x83, 0x84,
+  0x96, 0x96, 0x84, 0x83, 0x96, 0x03, 0x98, 0x66, 0x5a, 0x23, 0xfe, 0xbc,
+  0xfe, 0xf8, 0xfe, 0xf8, 0xfe, 0xbc, 0x61, 0x64, 0xfd, 0xae, 0x03, 0xcf,
+  0xe7, 0xdd, 0xcb, 0xe7, 0xe7, 0xcb, 0xcb, 0xe7, 0xe7, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x65, 0xfe, 0x52, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x24,
+  0x00, 0x00, 0x05, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x17,
+  0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x02, 0x64, 0xf2, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x4d,
+  0x92, 0x44, 0x46, 0x8d, 0x48, 0xa2, 0xb2, 0xb2, 0x9e, 0x76, 0x48, 0x4c,
+  0x43, 0x49, 0x92, 0x3e, 0x26, 0x1d, 0x1d, 0x1c, 0x1d, 0x01, 0x3e, 0x01,
+  0x0e, 0x01, 0x12, 0x01, 0x3a, 0x23, 0x23, 0xac, 0x2b, 0x2b, 0xe3, 0xcd,
+  0xcd, 0xe3, 0x4c, 0x4f, 0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c, 0x05, 0x2c,
+  0x23, 0x25, 0x35, 0x2c, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x5b, 0x04, 0x60, 0x00, 0x0d, 0x00, 0x1e, 0x00, 0x00,
+  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x27, 0x21, 0x15, 0x23, 0x16, 0x15, 0x10, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x02, 0x34, 0x89, 0x49, 0x4e,
+  0x9a, 0x86, 0x85, 0x9a, 0x4d, 0x47, 0x8b, 0x02, 0x26, 0xb9, 0x62, 0x7b,
+  0x7c, 0xd8, 0xd9, 0x7a, 0x7b, 0x7b, 0x66, 0x03, 0xce, 0x6e, 0x73, 0xbe,
+  0xc9, 0xe7, 0xe8, 0xc8, 0xb7, 0x7a, 0x6e, 0x92, 0xb8, 0x9c, 0xdd, 0xfe,
+  0xed, 0x9c, 0x9d, 0x9d, 0x9c, 0x01, 0x13, 0x01, 0x15, 0x9b, 0x81, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x03, 0xfc, 0x04, 0x60, 0x00, 0x11,
+  0x00, 0x00, 0x25, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35,
+  0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x14, 0x02, 0x9c, 0x20, 0x62,
+  0x50, 0x64, 0xa2, 0x4a, 0x4a, 0xfe, 0x86, 0x03, 0xa2, 0xfe, 0x82, 0xcc,
+  0x30, 0x9c, 0x60, 0x62, 0xd4, 0x02, 0x12, 0xb8, 0xb8, 0xfd, 0xe3, 0x91,
+  0x00, 0x01, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x04, 0x60, 0x00, 0x1c,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x36, 0x27, 0x26, 0x27, 0x33, 0x31, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x27, 0x22, 0x27, 0x26, 0x35, 0x03, 0x01, 0x30, 0x2e, 0x31, 0x60,
+  0x87, 0x5e, 0x36, 0x0d, 0x07, 0x1b, 0x19, 0x5f, 0xa7, 0x3f, 0x29, 0x25,
+  0x73, 0x8c, 0xe5, 0xa1, 0x5a, 0x59, 0x01, 0x04, 0x60, 0xfd, 0x2b, 0x87,
+  0x40, 0x45, 0xd0, 0x76, 0xbb, 0x66, 0x80, 0x77, 0x83, 0x5a, 0x7b, 0x73,
+  0x9a, 0xfd, 0xbb, 0xe4, 0x01, 0x78, 0x76, 0xc5, 0x02, 0xca, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x64, 0xfe, 0x56, 0x04, 0x56, 0x04, 0x68, 0x00, 0x0a,
+  0x00, 0x29, 0x00, 0x00, 0x01, 0x22, 0x15, 0x11, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23,
+  0x11, 0x23, 0x11, 0x22, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x37, 0x15,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x11, 0x10, 0x02, 0xea,
+  0x3a, 0x55, 0x55, 0x4d, 0x4d, 0x40, 0x30, 0x7e, 0x73, 0x7b, 0x7b, 0x75,
+  0xb6, 0xa5, 0xb4, 0x77, 0x7b, 0x7b, 0x5b, 0x95, 0x3b, 0x34, 0x4e, 0x4d,
+  0x46, 0x65, 0x03, 0xcb, 0x91, 0xfd, 0x52, 0x68, 0x5d, 0xdf, 0xd0, 0x70,
+  0x5b, 0x9d, 0x84, 0x8d, 0xfe, 0xd9, 0xfe, 0xf1, 0xa1, 0x98, 0xfe, 0x6e,
+  0x01, 0x91, 0x99, 0x9c, 0x01, 0x13, 0x01, 0x1e, 0x92, 0x6d, 0x1c, 0xa3,
+  0x17, 0x4e, 0x73, 0xbe, 0xca, 0x73, 0x67, 0x02, 0xaf, 0x01, 0x2e, 0x00,
+  0x00, 0x01, 0x00, 0x35, 0xfe, 0x55, 0x03, 0xf4, 0x04, 0x61, 0x00, 0x17,
+  0x00, 0x00, 0x05, 0x03, 0x01, 0x23, 0x01, 0x03, 0x26, 0x2b, 0x01, 0x35,
+  0x17, 0x16, 0x17, 0x13, 0x01, 0x33, 0x01, 0x13, 0x16, 0x3b, 0x01, 0x15,
+  0x27, 0x26, 0x02, 0x92, 0x85, 0xfe, 0xeb, 0xc3, 0x01, 0x87, 0xa4, 0x2c,
+  0x8b, 0x2c, 0x3f, 0xe8, 0x3a, 0x86, 0x01, 0x14, 0xc4, 0xfe, 0x79, 0xa4,
+  0x2c, 0x8b, 0x2c, 0x3f, 0xe9, 0xfa, 0x01, 0x7f, 0xfd, 0xd0, 0x03, 0x18,
+  0x01, 0xd7, 0x7e, 0x9e, 0x02, 0x07, 0xa7, 0xfe, 0x81, 0x02, 0x30, 0xfc,
+  0xe8, 0xfe, 0x29, 0x7e, 0x9e, 0x02, 0x07, 0x00, 0x00, 0x01, 0x00, 0x64,
+  0xfe, 0x56, 0x04, 0x56, 0x04, 0x60, 0x00, 0x1b, 0x00, 0x00, 0x05, 0x26,
+  0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x17, 0x11, 0x33,
+  0x11, 0x36, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x07,
+  0x11, 0x23, 0x02, 0x0b, 0xd0, 0x60, 0x76, 0xa7, 0x4d, 0x43, 0x6f, 0xa5,
+  0x76, 0x3c, 0x4c, 0xa8, 0x76, 0x6a, 0xc6, 0xa5, 0x19, 0x25, 0x61, 0x77,
+  0xf3, 0x02, 0x89, 0xfd, 0x7e, 0xb7, 0x4c, 0x42, 0x0e, 0x03, 0xd5, 0xfc,
+  0x2c, 0x0e, 0x42, 0x54, 0xaf, 0x02, 0x81, 0xfd, 0x78, 0xfc, 0x6e, 0x63,
+  0x23, 0xfe, 0x6e, 0x00, 0x00, 0x01, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
+  0x04, 0x60, 0x00, 0x1a, 0x00, 0x00, 0x05, 0x20, 0x11, 0x34, 0x13, 0x33,
+  0x02, 0x15, 0x10, 0x33, 0x32, 0x11, 0x33, 0x10, 0x33, 0x32, 0x11, 0x34,
+  0x03, 0x33, 0x12, 0x15, 0x10, 0x21, 0x22, 0x03, 0x02, 0x01, 0xef, 0xfe,
+  0x8b, 0x8b, 0xb2, 0x81, 0xc8, 0xb7, 0x99, 0xb7, 0xc7, 0x80, 0xb2, 0x8c,
+  0xfe, 0x8a, 0xf5, 0x1d, 0x25, 0x1d, 0x02, 0x52, 0xeb, 0x01, 0x40, 0xfe,
+  0xc0, 0xf0, 0xfe, 0x4f, 0x02, 0x1a, 0xfd, 0xe6, 0x01, 0xb1, 0xf0, 0x01,
+  0x40, 0xfe, 0xc0, 0xeb, 0xfd, 0xae, 0x01, 0x2b, 0xfe, 0xd5, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x3e, 0x06, 0x10, 0x12, 0x26,
+  0x03, 0x4d, 0x0e, 0x00, 0x10, 0x07, 0x00, 0x6a, 0xff, 0x43, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x10, 0x10, 0x26,
+  0x00, 0x6a, 0x1a, 0x00, 0x12, 0x06, 0x03, 0x59, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x1b, 0x70, 0x00, 0x12, 0x06, 0x03, 0x53, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x1b, 0x1f, 0x00, 0x12, 0x06, 0x03, 0x59, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x12, 0x26,
+  0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x03, 0x1b, 0x01, 0x36, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x0c,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09, 0x02, 0x23, 0x13, 0x01,
+  0x11, 0x23, 0xb5, 0xb6, 0x02, 0x5b, 0xea, 0xfd, 0x65, 0x02, 0xca, 0xfe,
+  0xb7, 0x79, 0xf5, 0xfd, 0x59, 0xb6, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x77,
+  0xfd, 0x48, 0xfc, 0xe3, 0xfe, 0x56, 0x01, 0x84, 0x02, 0xf5, 0xfd, 0x31,
+  0x00, 0x03, 0x00, 0x96, 0xff, 0xe9, 0x03, 0xdf, 0x06, 0x24, 0x00, 0x0a,
+  0x00, 0x1b, 0x00, 0x27, 0x00, 0x00, 0x01, 0x32, 0x36, 0x37, 0x36, 0x37,
+  0x34, 0x23, 0x22, 0x07, 0x06, 0x01, 0x16, 0x15, 0x14, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x02, 0x37, 0x36, 0x17, 0x1e, 0x01, 0x12, 0x06, 0x07, 0x06,
+  0x23, 0x10, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x34, 0x26, 0x01, 0x45,
+  0x48, 0xb7, 0x3d, 0x6c, 0x01, 0xb7, 0x6e, 0x53, 0x31, 0x01, 0xbd, 0xdd,
+  0x35, 0x72, 0xfe, 0x40, 0x7d, 0x64, 0x02, 0x6c, 0x79, 0xbd, 0x94, 0xc4,
+  0x02, 0x54, 0xe2, 0x50, 0xc9, 0x34, 0x48, 0x9d, 0x81, 0x4e, 0x16, 0x9b,
+  0x03, 0x70, 0x04, 0x3d, 0x6c, 0x93, 0xde, 0xba, 0x6c, 0xfe, 0xc7, 0xa7,
+  0xe9, 0x82, 0x5f, 0xd5, 0xd5, 0xa8, 0x03, 0x2c, 0xbe, 0xd5, 0x01, 0x01,
+  0xe2, 0xfe, 0xe5, 0xb6, 0x96, 0x14, 0xfe, 0xea, 0x80, 0xb0, 0x9c, 0x2d,
+  0xd1, 0x9e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe9, 0x04, 0x03,
+  0x06, 0x24, 0x00, 0x0a, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x20, 0x27, 0x26, 0x11,
+  0x34, 0x36, 0x33, 0x32, 0x12, 0x10, 0x00, 0x20, 0x02, 0x11, 0x17, 0x15,
+  0x10, 0x12, 0x20, 0x12, 0x03, 0x50, 0x2c, 0x3c, 0x86, 0x4a, 0x6c, 0x6c,
+  0x43, 0xf7, 0xfe, 0xeb, 0x76, 0xbd, 0xbb, 0x9d, 0xc4, 0xdd, 0xff, 0x00,
+  0xfe, 0x53, 0xf0, 0xa9, 0x9e, 0x01, 0x11, 0x94, 0x03, 0x70, 0xf6, 0x7e,
+  0xaa, 0x89, 0x5a, 0xaa, 0x5a, 0x37, 0xaa, 0x41, 0x69, 0x01, 0x36, 0xa0,
+  0xde, 0xfe, 0x64, 0xfc, 0xfc, 0xfe, 0x65, 0x01, 0xb6, 0x01, 0xd2, 0x01,
+  0xa0, 0xfe, 0xf3, 0xfe, 0xbd, 0x01, 0x42, 0x00, 0x00, 0x01, 0x00, 0x4e,
+  0x00, 0x00, 0x04, 0xc9, 0x05, 0xdf, 0x00, 0x20, 0x00, 0x00, 0x01, 0x06,
+  0x03, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x27, 0x02, 0x27, 0x26, 0x22,
+  0x07, 0x35, 0x36, 0x32, 0x17, 0x04, 0x13, 0x12, 0x25, 0x36, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x03, 0xd9, 0x90, 0x4a, 0x26,
+  0xb7, 0x26, 0x49, 0x90, 0x46, 0x6b, 0x24, 0x1c, 0x64, 0x4d, 0x01, 0x22,
+  0x41, 0x60, 0x01, 0x03, 0x22, 0x56, 0x25, 0x4b, 0x0f, 0x17, 0x44, 0x77,
+  0x05, 0x11, 0x48, 0xfe, 0xf3, 0x8d, 0xa5, 0xfd, 0x76, 0x02, 0x8a, 0xa5,
+  0x8d, 0x01, 0x0d, 0x48, 0x23, 0x09, 0xaa, 0x0a, 0x0d, 0x30, 0xfe, 0x72,
+  0x01, 0x7b, 0x43, 0x09, 0x20, 0x40, 0x5b, 0x29, 0x2f, 0x42, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xe4, 0x00, 0x00, 0x05, 0xf8, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x1b, 0xfe, 0x96, 0x00, 0x00, 0x10, 0x07, 0x03, 0x66, 0x01, 0x2e,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4e, 0x00, 0x00, 0x04, 0xc9,
+  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x04, 0x4b, 0x01, 0x75, 0x12, 0x06,
+  0x03, 0x66, 0x00, 0x00, 0x00, 0x03, 0x00, 0x64, 0xfe, 0x56, 0x04, 0x56,
+  0x06, 0x14, 0x00, 0x15, 0x00, 0x1e, 0x00, 0x27, 0x00, 0x00, 0x01, 0x11,
+  0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x11, 0x23, 0x11, 0x22,
+  0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x33, 0x11, 0x13, 0x32, 0x37, 0x36,
+  0x37, 0x36, 0x27, 0x26, 0x23, 0x03, 0x11, 0x22, 0x07, 0x06, 0x17, 0x16,
+  0x17, 0x16, 0x02, 0xb0, 0xb3, 0x78, 0x7b, 0x7b, 0x78, 0xb3, 0xa5, 0xb4,
+  0x77, 0x7b, 0x7b, 0x77, 0xb4, 0xa5, 0x65, 0x45, 0x4c, 0x01, 0x01, 0x4e,
+  0x45, 0x65, 0xa5, 0x66, 0x45, 0x4e, 0x01, 0x01, 0x4c, 0x45, 0x06, 0x14,
+  0xfe, 0x63, 0x99, 0x9c, 0xfe, 0xed, 0xfe, 0xed, 0x9c, 0x99, 0xfe, 0x6f,
+  0x01, 0x91, 0x99, 0x9c, 0x01, 0x13, 0x01, 0x13, 0x9c, 0x99, 0x01, 0x9d,
+  0xfa, 0x77, 0x67, 0x73, 0xca, 0xc8, 0x75, 0x67, 0xfc, 0xb8, 0x03, 0x48,
+  0x67, 0x75, 0xc8, 0xca, 0x73, 0x67, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3a,
+  0xff, 0xe3, 0x05, 0xc9, 0x04, 0x60, 0x00, 0x10, 0x00, 0x1e, 0x00, 0x00,
+  0x13, 0x35, 0x21, 0x15, 0x23, 0x16, 0x15, 0x10, 0x25, 0x26, 0x03, 0x02,
+  0x23, 0x20, 0x11, 0x34, 0x37, 0x29, 0x01, 0x06, 0x15, 0x10, 0x33, 0x32,
+  0x03, 0x33, 0x02, 0x37, 0x36, 0x11, 0x34, 0x3a, 0x05, 0x8e, 0x84, 0x46,
+  0xfe, 0x8a, 0xf4, 0x1e, 0x25, 0xee, 0xfe, 0x8b, 0x45, 0x03, 0xce, 0xfc,
+  0xe9, 0x40, 0xc8, 0xbb, 0x04, 0x99, 0x04, 0xbb, 0xc7, 0x03, 0xa8, 0xb8,
+  0xb8, 0xcf, 0xa4, 0xfd, 0xad, 0x01, 0x01, 0x01, 0x2a, 0xfe, 0xd5, 0x02,
+  0x52, 0xa4, 0xcf, 0xd1, 0xa7, 0xfe, 0x4f, 0x02, 0x1a, 0xfd, 0xe3, 0x03,
+  0x03, 0x01, 0xae, 0xa7, 0x00, 0x01, 0x00, 0x64, 0xfe, 0x5b, 0x04, 0x53,
+  0x04, 0x67, 0x00, 0x39, 0x00, 0x00, 0x05, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x07, 0x02, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x01, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32, 0x17, 0x04, 0x11,
+  0x14, 0x07, 0x37, 0x12, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x01, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x02, 0x07, 0x06, 0x22, 0x27,
+  0x35, 0x16, 0x33, 0x32, 0x03, 0x93, 0xdd, 0x1e, 0x09, 0x0c, 0xaa, 0x57,
+  0xb4, 0x31, 0x1f, 0x31, 0x01, 0x07, 0x37, 0x0c, 0x18, 0x7f, 0x34, 0x52,
+  0x3a, 0x52, 0x17, 0x19, 0x01, 0x00, 0x1a, 0xaa, 0x56, 0xb4, 0x32, 0x1f,
+  0x31, 0xfe, 0xf9, 0x37, 0x0c, 0x18, 0x7f, 0x34, 0x51, 0x22, 0xb8, 0x3f,
+  0x92, 0x54, 0x56, 0x41, 0x94, 0x0a, 0x20, 0xf0, 0x49, 0x81, 0x35, 0x6c,
+  0xfe, 0xf7, 0x7c, 0x22, 0x4f, 0x9a, 0x01, 0x09, 0x8a, 0x7a, 0x3a, 0x36,
+  0x68, 0x6c, 0xe0, 0x30, 0x04, 0x27, 0xfe, 0xc3, 0x5b, 0x4d, 0x6c, 0x01,
+  0x09, 0x7c, 0x22, 0x4f, 0x9a, 0xfe, 0xf7, 0x8a, 0x7a, 0x3a, 0x36, 0x68,
+  0x6c, 0xfd, 0xe0, 0x66, 0x24, 0x31, 0xa0, 0x31, 0x00, 0x02, 0x00, 0x67,
+  0xfe, 0x58, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x11, 0x00, 0x1f, 0x00, 0x00,
+  0x05, 0x11, 0x23, 0x11, 0x26, 0x27, 0x26, 0x10, 0x37, 0x36, 0x21, 0x20,
+  0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x02, 0x20, 0x07, 0x06, 0x11, 0x10,
+  0x17, 0x16, 0x20, 0x37, 0x36, 0x11, 0x10, 0x27, 0x03, 0x2a, 0xa6, 0xe2,
+  0x90, 0xaa, 0xaa, 0xa9, 0x01, 0x1b, 0x01, 0x1b, 0xa9, 0xa9, 0xa9, 0x8f,
+  0x6f, 0xfe, 0x74, 0x74, 0x75, 0x75, 0x74, 0x01, 0x8c, 0x74, 0x74, 0x74,
+  0x18, 0xfe, 0x70, 0x01, 0x90, 0x1a, 0xb3, 0xd2, 0x02, 0xc4, 0xd3, 0xd2,
+  0xd2, 0xd3, 0xfe, 0x9e, 0xfe, 0x9f, 0xd2, 0xb3, 0x05, 0x49, 0xa4, 0xa4,
+  0xfe, 0xe5, 0xfe, 0xe6, 0xa4, 0xa4, 0xa4, 0xa4, 0x01, 0x1a, 0x01, 0x1b,
+  0xa4, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x03,
+  0x04, 0x7b, 0x00, 0x0d, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
+  0x10, 0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x03, 0x11,
+  0x23, 0x11, 0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x33, 0x32, 0x12,
+  0x11, 0x10, 0x07, 0x06, 0x02, 0x34, 0x85, 0x4d, 0x4e, 0x4d, 0x4d, 0x86,
+  0x85, 0x9a, 0x4d, 0x4d, 0x34, 0x99, 0xab, 0x60, 0x7b, 0x7b, 0x7a, 0xd9,
+  0xd8, 0xf7, 0x7b, 0x60, 0x03, 0xdf, 0x73, 0x74, 0xfe, 0x6e, 0x74, 0x73,
+  0xe8, 0xc8, 0xc7, 0x74, 0x75, 0xfc, 0x09, 0xfe, 0x6e, 0x01, 0x92, 0x1b,
+  0x7d, 0x9c, 0x01, 0x13, 0x01, 0x14, 0x9c, 0x9c, 0xfe, 0xc8, 0xfe, 0xec,
+  0xfe, 0xed, 0x9c, 0x7b, 0x00, 0x01, 0x00, 0x7d, 0xfe, 0x52, 0x04, 0x34,
+  0x05, 0xd5, 0x00, 0x24, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x11, 0x10,
+  0x17, 0x16, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x34,
+  0x35, 0x16, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x20, 0x27, 0x26,
+  0x11, 0x10, 0x37, 0x36, 0x29, 0x01, 0x15, 0x02, 0xf2, 0xf2, 0x56, 0x6f,
+  0x52, 0x62, 0xb4, 0x6e, 0x50, 0x4b, 0x42, 0x48, 0x93, 0x3e, 0x26, 0x1d,
+  0x1d, 0x1c, 0x34, 0xfe, 0xe0, 0x80, 0x86, 0xa7, 0x7c, 0x01, 0x52, 0x01,
+  0x42, 0x05, 0x2b, 0x77, 0x98, 0xfe, 0xcd, 0xfe, 0xb5, 0x7f, 0x98, 0x54,
+  0x4f, 0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c, 0x05, 0x2c, 0x23, 0x25, 0x35,
+  0x2c, 0x2a, 0xcb, 0xd6, 0x01, 0x65, 0x01, 0x4e, 0xed, 0xb1, 0xaa, 0x00,
+  0x00, 0x01, 0x00, 0x65, 0xfe, 0x52, 0x03, 0xe3, 0x04, 0x60, 0x00, 0x20,
+  0x00, 0x00, 0x05, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x21, 0x15, 0x21,
+  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x34, 0x35, 0x16, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x02,
+  0x2a, 0xb8, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x01, 0x82, 0xfe, 0x86, 0xa2,
+  0xb2, 0xb2, 0x64, 0x75, 0x48, 0x4c, 0x43, 0x48, 0x92, 0x3e, 0x26, 0x1c,
+  0x1c, 0x1d, 0x1d, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x12, 0x01, 0x1f, 0x9c,
+  0xc7, 0xce, 0xcd, 0xe3, 0x4c, 0x4f, 0x78, 0x73, 0x50, 0x57, 0x4b, 0x4c,
+  0x05, 0x2c, 0x23, 0x25, 0x35, 0x2c, 0x2a, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0xba, 0x05, 0xd5, 0x12, 0x06, 0x00, 0x29, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0x53, 0xfe, 0x56, 0x02, 0xf3, 0x06, 0x14, 0x00, 0x27,
+  0x00, 0x00, 0x33, 0x11, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x21, 0x15,
+  0x21, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0xd6, 0x7b, 0x56, 0x98, 0x2c, 0x2d,
+  0x2c, 0x2e, 0x20, 0x25, 0x25, 0x28, 0x6c, 0x34, 0x43, 0x01, 0x21, 0xfe,
+  0xdf, 0x7d, 0x59, 0x9b, 0x34, 0x2e, 0x2d, 0x2a, 0x2c, 0x2d, 0x2d, 0x2b,
+  0x4f, 0x39, 0x4a, 0x04, 0x82, 0xa0, 0x8e, 0x64, 0x09, 0x09, 0x12, 0xa4,
+  0x1c, 0x0e, 0x0f, 0x3e, 0x51, 0x6f, 0xfe, 0xc9, 0x8f, 0xfd, 0x3f, 0x92,
+  0xa5, 0x73, 0x0a, 0x0b, 0x16, 0xa4, 0x1f, 0x10, 0x11, 0x4b, 0x5f, 0x00,
+  0x00, 0x01, 0x00, 0xa1, 0xff, 0xfc, 0x04, 0x59, 0x05, 0xd5, 0x00, 0x17,
+  0x00, 0x00, 0x01, 0x03, 0x01, 0x03, 0x06, 0x17, 0x16, 0x37, 0x15, 0x22,
+  0x27, 0x26, 0x37, 0x13, 0x01, 0x13, 0x36, 0x27, 0x26, 0x07, 0x35, 0x32,
+  0x17, 0x16, 0x01, 0xfd, 0x63, 0x02, 0xbe, 0xd2, 0x23, 0x18, 0x3b, 0x76,
+  0xcf, 0x49, 0x55, 0x11, 0x8b, 0xfd, 0x52, 0x9b, 0x23, 0x19, 0x3b, 0x76,
+  0xcf, 0x49, 0x55, 0x04, 0x87, 0xfe, 0x5b, 0x01, 0x7e, 0xfd, 0x2c, 0x60,
+  0x2a, 0x6c, 0x23, 0xbd, 0x46, 0x52, 0xb6, 0x01, 0xda, 0xfe, 0x91, 0x02,
+  0x90, 0x60, 0x2a, 0x6c, 0x23, 0xbd, 0x46, 0x52, 0x00, 0x01, 0x00, 0xab,
+  0x00, 0x00, 0x04, 0x14, 0x06, 0x13, 0x00, 0x07, 0x00, 0x00, 0x01, 0x03,
+  0x23, 0x13, 0x21, 0x13, 0x33, 0x03, 0x04, 0x14, 0xfd, 0xa5, 0xcb, 0xfd,
+  0x6f, 0xfd, 0xa5, 0xcb, 0x03, 0x70, 0xfc, 0x90, 0x02, 0xc6, 0x03, 0x4d,
+  0xfd, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x66, 0xfe, 0x56, 0x05, 0xbd,
+  0x05, 0xf0, 0x00, 0x21, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x06, 0x07,
+  0x35, 0x36, 0x21, 0x20, 0x13, 0x12, 0x11, 0x10, 0x03, 0x23, 0x12, 0x11,
+  0x10, 0x27, 0x06, 0x07, 0x06, 0x15, 0x11, 0x23, 0x36, 0x11, 0x34, 0x3f,
+  0x01, 0x02, 0x21, 0x22, 0x02, 0x16, 0x99, 0xb9, 0x5d, 0xbb, 0x01, 0x5b,
+  0x01, 0xaa, 0xd5, 0xc1, 0xde, 0xca, 0xea, 0x4a, 0x4a, 0x55, 0x3a, 0xb8,
+  0x02, 0xa3, 0xa9, 0xbb, 0xfe, 0xc6, 0x2b, 0x05, 0x3a, 0xfd, 0x8c, 0x02,
+  0x49, 0x4b, 0x69, 0xc6, 0xcf, 0xfe, 0xce, 0xfe, 0xec, 0xfd, 0xc2, 0xfe,
+  0x58, 0xfe, 0x92, 0x01, 0x4c, 0x01, 0xca, 0x01, 0xd1, 0x7d, 0x2f, 0x4d,
+  0x34, 0xd0, 0xfd, 0xc6, 0x21, 0x02, 0x14, 0xf7, 0x8f, 0x8d, 0x01, 0x04,
+  0x00, 0x01, 0x00, 0x6b, 0xfe, 0x90, 0x04, 0x21, 0x04, 0x78, 0x00, 0x16,
+  0x00, 0x00, 0x01, 0x03, 0x23, 0x01, 0x26, 0x27, 0x01, 0x23, 0x01, 0x26,
+  0x27, 0x26, 0x23, 0x35, 0x20, 0x17, 0x16, 0x13, 0x12, 0x11, 0x23, 0x10,
+  0x27, 0x03, 0x16, 0xd7, 0xa6, 0x01, 0x40, 0x0d, 0x2d, 0xfe, 0x73, 0xa7,
+  0x01, 0xe9, 0x58, 0x2a, 0xa9, 0xbe, 0x01, 0x0f, 0xda, 0xc9, 0x9b, 0x69,
+  0x98, 0x56, 0x01, 0x34, 0xfe, 0xcc, 0x01, 0xc0, 0x23, 0x4d, 0xfd, 0xd0,
+  0x02, 0xb0, 0x7f, 0x21, 0x84, 0xa4, 0xd8, 0xc8, 0xfe, 0x50, 0xfe, 0xdf,
+  0xfe, 0x89, 0x01, 0x5e, 0xf6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
+  0xfe, 0x4b, 0x06, 0x52, 0x05, 0xd5, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x10,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x37,
+  0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11,
+  0x34, 0x13, 0x36, 0x37, 0x33, 0x06, 0x03, 0x06, 0x15, 0x10, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x11, 0x34, 0x27, 0x02, 0x27, 0x33, 0x16, 0x17, 0x12,
+  0x06, 0x51, 0x37, 0x3d, 0xc5, 0xa2, 0xf8, 0x6a, 0x7e, 0x58, 0x7c, 0x6d,
+  0xb9, 0x93, 0x5c, 0x3d, 0x5a, 0x24, 0x23, 0x5a, 0x5b, 0x83, 0xbe, 0x6d,
+  0x6e, 0x5a, 0x35, 0x53, 0xe0, 0x4b, 0x7a, 0x3c, 0x41, 0x42, 0x70, 0x67,
+  0x40, 0x40, 0xb3, 0x3f, 0x3f, 0x69, 0x78, 0x3b, 0x40, 0x3c, 0x7a, 0x4c,
+  0xe1, 0x56, 0x32, 0x5a, 0x02, 0xe0, 0xfe, 0xef, 0xcb, 0xe6, 0xa6, 0x88,
+  0x64, 0x2a, 0x17, 0x85, 0x18, 0x30, 0x51, 0x80, 0x17, 0x41, 0x5e, 0xad,
+  0xad, 0x5e, 0x5e, 0xb1, 0xb4, 0x01, 0x98, 0xc9, 0x01, 0x0e, 0x9f, 0x7f,
+  0x46, 0xfe, 0xbf, 0x9f, 0xb7, 0xfe, 0xcd, 0x6b, 0x6d, 0x69, 0x68, 0xc6,
+  0xf1, 0xf1, 0xc6, 0x68, 0x69, 0x6d, 0x77, 0x01, 0x27, 0xb7, 0x9f, 0x01,
+  0x41, 0x46, 0x82, 0x9c, 0xfe, 0xeb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x79,
+  0xfe, 0x55, 0x05, 0x8a, 0x04, 0x60, 0x00, 0x25, 0x00, 0x00, 0x21, 0x26,
+  0x03, 0x02, 0x23, 0x20, 0x11, 0x34, 0x13, 0x33, 0x02, 0x15, 0x10, 0x17,
+  0x16, 0x03, 0x33, 0x02, 0x37, 0x36, 0x11, 0x34, 0x03, 0x33, 0x12, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36,
+  0x04, 0x14, 0xf8, 0x1a, 0x20, 0xf3, 0xfe, 0x8b, 0x79, 0xc4, 0x81, 0xc8,
+  0xbc, 0x05, 0x99, 0x03, 0xba, 0xc7, 0x80, 0xc4, 0x7a, 0x33, 0x5e, 0xb2,
+  0x8a, 0xbd, 0x61, 0x64, 0x52, 0x49, 0x7d, 0xb3, 0x01, 0x01, 0x0d, 0xfe,
+  0xed, 0x02, 0x3a, 0xeb, 0x01, 0x40, 0xfe, 0xc0, 0xf0, 0xfe, 0x97, 0x01,
+  0x01, 0x01, 0xd4, 0xfe, 0x2b, 0x02, 0x02, 0x01, 0x68, 0xf0, 0x01, 0x40,
+  0xfe, 0xc0, 0xeb, 0xd1, 0x84, 0xf4, 0x9e, 0x7b, 0x49, 0x25, 0x10, 0x6c,
+  0x0b, 0x2b, 0x3f, 0x00, 0x00, 0x01, 0x00, 0x67, 0xfe, 0x56, 0x04, 0xc1,
+  0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x11, 0x14,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x23, 0x11,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11, 0x10, 0x13, 0x36, 0x25,
+  0x02, 0xa1, 0xa2, 0x56, 0x78, 0x63, 0x58, 0xb0, 0xb0, 0x58, 0x5a, 0xc3,
+  0xc3, 0x3e, 0x5d, 0x5e, 0x99, 0xe6, 0x8d, 0x91, 0xa7, 0x88, 0x01, 0x0a,
+  0x05, 0x4a, 0x12, 0x84, 0xb9, 0xfe, 0xee, 0xf9, 0xab, 0x98, 0x98, 0x99,
+  0x01, 0x0b, 0x02, 0xec, 0xf8, 0x81, 0x02, 0x90, 0x84, 0x40, 0x3f, 0xd5,
+  0xdd, 0x01, 0x47, 0x01, 0x36, 0x01, 0x08, 0xd5, 0x01, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x18, 0x04, 0x7b, 0x00, 0x1c,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37,
+  0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x02, 0x4a, 0x8b, 0x48, 0x66,
+  0x54, 0x4b, 0x01, 0x2b, 0x4b, 0x4c, 0xa6, 0xa6, 0x34, 0x4f, 0x51, 0x81,
+  0xc4, 0x78, 0x7b, 0x8e, 0x72, 0xe4, 0x03, 0xfd, 0x0e, 0x63, 0x8d, 0xd0,
+  0xbd, 0x81, 0x74, 0x73, 0x74, 0xcb, 0x02, 0x31, 0xf9, 0xf6, 0x02, 0x52,
+  0x64, 0x30, 0x31, 0xa2, 0xa8, 0xf8, 0xec, 0xc8, 0xa2, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x4b, 0x05, 0x4c, 0x05, 0xd5, 0x00, 0x25,
+  0x00, 0x00, 0x01, 0x20, 0x17, 0x16, 0x11, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33,
+  0x11, 0x36, 0x37, 0x36, 0x02, 0xf8, 0x01, 0x09, 0x9f, 0xab, 0x36, 0x3c,
+  0x99, 0xaf, 0xd9, 0xa7, 0x41, 0x58, 0x79, 0x70, 0xc4, 0x88, 0x7b, 0x27,
+  0x31, 0x71, 0x68, 0xb8, 0xb7, 0x68, 0x65, 0xb6, 0xb6, 0x46, 0x5e, 0x5f,
+  0x04, 0x7b, 0xb3, 0xc2, 0xfe, 0xfd, 0xcc, 0xa1, 0xb2, 0x80, 0x93, 0x45,
+  0x35, 0x0c, 0x85, 0x16, 0x32, 0x57, 0x7a, 0x6d, 0x68, 0x7f, 0xc0, 0x9d,
+  0x96, 0x86, 0x81, 0x7e, 0xde, 0xfe, 0x27, 0x05, 0xd5, 0xfd, 0x9a, 0x87,
+  0x42, 0x43, 0x00, 0x00, 0x00, 0x02, 0x00, 0x28, 0xff, 0xe3, 0x04, 0x1d,
+  0x04, 0x9a, 0x00, 0x17, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x27, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x36, 0x37,
+  0x17, 0x06, 0x02, 0xdb, 0x73, 0x7e, 0x1c, 0x32, 0x1a, 0x21, 0x1a, 0x0f,
+  0x0c, 0x0a, 0x0e, 0x16, 0x17, 0x1f, 0x1d, 0x1b, 0x17, 0x40, 0x35, 0x42,
+  0x20, 0xf0, 0x61, 0x72, 0x64, 0xee, 0x7f, 0x59, 0x44, 0x2f, 0x3b, 0x49,
+  0x4c, 0x7a, 0x56, 0x74, 0x4a, 0x39, 0x52, 0x8d, 0x47, 0x44, 0x2c, 0x19,
+  0x1c, 0x3e, 0x6a, 0x5c, 0x40, 0x24, 0x41, 0x2d, 0x3a, 0x2b, 0x25, 0x1b,
+  0x1a, 0x1c, 0x29, 0x38, 0x48, 0x5b, 0x55, 0xbd, 0x81, 0x33, 0x26, 0x7a,
+  0x31, 0x03, 0x44, 0x98, 0x16, 0x0b, 0x21, 0x1a, 0x20, 0x1b, 0x21, 0x20,
+  0x15, 0x1c, 0x11, 0x14, 0x06, 0x05, 0x19, 0x14, 0x31, 0x18, 0x32, 0xc0,
+  0xd4, 0xb0, 0x9c, 0x88, 0x2e, 0x23, 0x41, 0x93, 0x4c, 0x2e, 0x23, 0x5e,
+  0x59, 0x7f, 0x8c, 0x71, 0x19, 0x17, 0x34, 0x2b, 0x26, 0x02, 0x01, 0x0a,
+  0x07, 0x22, 0x1a, 0x48, 0x34, 0x42, 0x3b, 0x3b, 0x3d, 0x2f, 0x3f, 0x22,
+  0x2b, 0x9f, 0x56, 0x68, 0x50, 0x92, 0x00, 0x00, 0x00, 0x01, 0x00, 0x47,
+  0xfe, 0x56, 0x04, 0x8a, 0x05, 0xf6, 0x00, 0x21, 0x00, 0x00, 0x05, 0x06,
+  0x23, 0x20, 0x01, 0x00, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x23, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x02, 0x01, 0x16, 0x33, 0x20, 0x37, 0x04, 0x7b, 0xe7, 0xf7,
+  0xfe, 0xd0, 0xfe, 0xda, 0x02, 0x74, 0xa1, 0x62, 0x62, 0x59, 0x93, 0xa2,
+  0x55, 0x1f, 0x16, 0xd8, 0x28, 0x4d, 0x93, 0xfc, 0xf7, 0x91, 0x92, 0x92,
+  0xee, 0xfe, 0x48, 0x8d, 0xbf, 0x01, 0x0c, 0xd1, 0xec, 0xbe, 0x01, 0xa3,
+  0x01, 0xf1, 0xdb, 0x84, 0x9c, 0x8d, 0x65, 0x5d, 0x92, 0x36, 0x3f, 0xa1,
+  0x66, 0xc2, 0x90, 0x91, 0xf1, 0xd8, 0xb6, 0xfe, 0xf2, 0xfe, 0x85, 0xb5,
+  0xb3, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0xfe, 0x56, 0x03, 0xf9,
+  0x04, 0x7b, 0x00, 0x20, 0x00, 0x00, 0x01, 0x06, 0x23, 0x22, 0x01, 0x00,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x16,
+  0x33, 0x32, 0x37, 0x03, 0xec, 0xc4, 0xd2, 0xf7, 0xfe, 0xfb, 0x02, 0x08,
+  0x96, 0x53, 0x53, 0x4b, 0x7d, 0x8a, 0x48, 0x1b, 0x12, 0xb7, 0x21, 0x41,
+  0x7e, 0xd6, 0xd1, 0xf8, 0x7c, 0x9e, 0xfe, 0x5e, 0x82, 0x98, 0xe4, 0xb1,
+  0xfe, 0xef, 0x99, 0x01, 0x79, 0x01, 0x59, 0xc2, 0x6b, 0x7d, 0x6f, 0x53,
+  0x4b, 0x75, 0x2c, 0x32, 0x81, 0x52, 0x9c, 0xe8, 0xc2, 0xa4, 0x9c, 0xc5,
+  0xfe, 0xe0, 0xba, 0x90, 0x00, 0x02, 0x00, 0x67, 0x00, 0x00, 0x05, 0x24,
+  0x05, 0xef, 0x00, 0x02, 0x00, 0x35, 0x00, 0x00, 0x25, 0x21, 0x09, 0x03,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x1b, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x09, 0x01,
+  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x21, 0x35, 0x33, 0x32, 0x37, 0x36,
+  0x01, 0xab, 0x02, 0x2f, 0xfe, 0xec, 0xfe, 0x45, 0x01, 0x5a, 0xfe, 0xf9,
+  0x11, 0x17, 0x1f, 0x39, 0x16, 0x14, 0x3e, 0x1e, 0x1c, 0x1c, 0x1a, 0x66,
+  0x44, 0x27, 0x2b, 0xe8, 0xee, 0x2f, 0x23, 0x44, 0x66, 0x1a, 0x1b, 0x1d,
+  0x1e, 0x3d, 0x15, 0x16, 0x36, 0x22, 0x11, 0x17, 0xfe, 0xf0, 0x01, 0x4f,
+  0x05, 0x06, 0x1a, 0x3e, 0x40, 0xfb, 0x4a, 0x3f, 0x41, 0x18, 0x0a, 0xaa,
+  0x01, 0xca, 0xfe, 0x68, 0x02, 0x3d, 0x01, 0xbb, 0x1d, 0x1a, 0x22, 0x04,
+  0x0a, 0xbb, 0x0b, 0x05, 0x05, 0x43, 0x28, 0x46, 0xfe, 0x81, 0x01, 0x7f,
+  0x4b, 0x23, 0x43, 0x05, 0x05, 0x0b, 0xbb, 0x0a, 0x04, 0x22, 0x11, 0x26,
+  0xfe, 0x45, 0xfd, 0xc3, 0x09, 0x08, 0x21, 0xaa, 0xaa, 0x21, 0x0f, 0x00,
+  0x00, 0x02, 0x00, 0x30, 0x00, 0x00, 0x04, 0x51, 0x04, 0x7b, 0x00, 0x02,
+  0x00, 0x35, 0x00, 0x00, 0x25, 0x21, 0x03, 0x09, 0x01, 0x03, 0x26, 0x27,
+  0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x1b, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x15, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x01, 0x16, 0x17,
+  0x16, 0x3b, 0x01, 0x15, 0x21, 0x35, 0x33, 0x32, 0x37, 0x36, 0x01, 0x71,
+  0x01, 0x9e, 0xcd, 0xfe, 0x85, 0x01, 0x1a, 0xd7, 0x13, 0x10, 0x1a, 0x30,
+  0x13, 0x11, 0x35, 0x1a, 0x18, 0x17, 0x16, 0x76, 0x39, 0x22, 0x24, 0xb1,
+  0xb1, 0x24, 0x22, 0x39, 0x76, 0x16, 0x17, 0x18, 0x1a, 0x35, 0x11, 0x13,
+  0x30, 0x1a, 0x10, 0x13, 0xdd, 0x01, 0x0f, 0x05, 0x05, 0x16, 0x35, 0x41,
+  0xfb, 0xe1, 0x41, 0x34, 0x17, 0x05, 0x9e, 0x01, 0x38, 0xfe, 0xee, 0x01,
+  0xa4, 0x01, 0x3d, 0x1c, 0x0e, 0x19, 0x03, 0x07, 0x8d, 0x08, 0x04, 0x04,
+  0x33, 0x1e, 0x35, 0xfe, 0xfa, 0x01, 0x06, 0x35, 0x1e, 0x33, 0x04, 0x04,
+  0x08, 0x8d, 0x07, 0x03, 0x19, 0x0e, 0x1c, 0xfe, 0xb8, 0xfe, 0x67, 0x08,
+  0x05, 0x19, 0x9e, 0x9e, 0x19, 0x05, 0x00, 0x00, 0x00, 0x02, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa2, 0x06, 0x10, 0x00, 0x1d, 0x00, 0x2b, 0x00, 0x00,
+  0x01, 0x24, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x00, 0x10,
+  0x00, 0x23, 0x20, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x21, 0x32, 0x37,
+  0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x12, 0x10, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x02, 0xd9, 0xfe, 0xf4,
+  0x4f, 0x32, 0x14, 0x49, 0x4d, 0x6e, 0x75, 0xdd, 0x01, 0x13, 0xfe, 0xed,
+  0xed, 0xfe, 0xed, 0x94, 0x92, 0x7d, 0x6f, 0x01, 0x85, 0x67, 0x87, 0x90,
+  0x43, 0x54, 0x88, 0x62, 0x80, 0xb4, 0xa7, 0xa9, 0x5e, 0x5e, 0x5e, 0x5b,
+  0xac, 0xa9, 0x58, 0x05, 0x2d, 0x02, 0x73, 0x4a, 0xa0, 0x56, 0x22, 0x31,
+  0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x9c, 0x9b, 0x01, 0x50, 0x01, 0xde,
+  0xd2, 0xbb, 0x0a, 0x0a, 0x27, 0xb1, 0x24, 0x08, 0x06, 0xfc, 0x41, 0x01,
+  0x82, 0xe6, 0x73, 0x74, 0xc0, 0xbd, 0x78, 0x73, 0x73, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xec, 0x06, 0x10, 0x00, 0x1f,
+  0x00, 0x2f, 0x00, 0x00, 0x01, 0x26, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x11,
+  0x10, 0x37, 0x36, 0x21, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06,
+  0x13, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x02, 0x58, 0xcc, 0x42, 0x27, 0x12, 0x25, 0x5a,
+  0x52, 0x6c, 0xb8, 0x72, 0x74, 0x74, 0x72, 0xc5, 0xe6, 0x7b, 0x7a, 0x68,
+  0x5d, 0x01, 0x2d, 0x56, 0x53, 0x4a, 0x40, 0x53, 0x3f, 0x51, 0x98, 0x4b,
+  0x4c, 0x83, 0x86, 0x4e, 0x4f, 0x4f, 0x4c, 0x88, 0x85, 0x4a, 0x4b, 0x05,
+  0x37, 0x02, 0x78, 0x4a, 0xa9, 0x46, 0x36, 0x31, 0xa2, 0xa2, 0xfd, 0xf0,
+  0xa2, 0xa2, 0x9c, 0x9b, 0x01, 0x50, 0x01, 0xde, 0xd2, 0xbb, 0x0a, 0x0a,
+  0x27, 0xa7, 0x27, 0x05, 0x06, 0xfc, 0xf8, 0xcd, 0x72, 0x73, 0x73, 0x74,
+  0xcb, 0xc7, 0x78, 0x73, 0x73, 0x74, 0x00, 0x00, 0x00, 0x01, 0x00, 0x27,
+  0xfe, 0x56, 0x04, 0x3f, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x35, 0x23, 0x11, 0x23, 0x11, 0x23, 0x15, 0x23, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x04, 0x3e, 0xb6, 0xfa, 0xb6, 0xfa, 0xb6, 0x01, 0xb0, 0xb6,
+  0x04, 0x60, 0xfe, 0xf2, 0x64, 0xfa, 0xa0, 0x05, 0x60, 0x64, 0x01, 0x0e,
+  0x01, 0x75, 0xfe, 0x8b, 0x00, 0x01, 0x00, 0x31, 0xfe, 0x55, 0x03, 0xac,
+  0x05, 0xcf, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x23, 0x35, 0x23, 0x11,
+  0x23, 0x11, 0x23, 0x15, 0x23, 0x11, 0x21, 0x11, 0x33, 0x11, 0x03, 0xac,
+  0x9c, 0xce, 0xa7, 0xce, 0x9b, 0x01, 0x69, 0xa7, 0x04, 0x5f, 0xff, 0x00,
+  0x70, 0xfa, 0x86, 0x05, 0x7a, 0x70, 0x01, 0x00, 0x01, 0x70, 0xfe, 0x90,
+  0x00, 0x01, 0x00, 0x64, 0xff, 0xf2, 0x04, 0x53, 0x04, 0x67, 0x00, 0x33,
+  0x00, 0x00, 0x01, 0x02, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x01, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32, 0x17,
+  0x04, 0x11, 0x14, 0x07, 0x37, 0x12, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14,
+  0x01, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x15, 0x06, 0x23,
+  0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x01, 0xf1, 0x57, 0xb4, 0x31, 0x1f,
+  0x31, 0x01, 0x07, 0x37, 0x0c, 0x18, 0x7f, 0x34, 0x52, 0x3a, 0x52, 0x17,
+  0x19, 0x01, 0x00, 0x1a, 0xaa, 0x56, 0xb4, 0x32, 0x1f, 0x31, 0xfe, 0xf9,
+  0x37, 0x0c, 0x18, 0x7f, 0x34, 0x51, 0x39, 0x52, 0x17, 0x19, 0xff, 0x00,
+  0x1a, 0x01, 0x99, 0xfe, 0xf7, 0x7c, 0x22, 0x4f, 0x9a, 0x01, 0x09, 0x8a,
+  0x7a, 0x3a, 0x36, 0x68, 0x6c, 0xe0, 0x30, 0x04, 0x25, 0xfe, 0xc1, 0x5b,
+  0x4d, 0x6c, 0x01, 0x09, 0x7c, 0x22, 0x4f, 0x9a, 0xfe, 0xf7, 0x8a, 0x7a,
+  0x3a, 0x36, 0x68, 0x6c, 0xe0, 0x30, 0x04, 0x25, 0x01, 0x3f, 0x5b, 0x4d,
+  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x00, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x12, 0x29,
+  0x01, 0x15, 0x21, 0x20, 0x11, 0x24, 0x10, 0x27, 0x26, 0x20, 0x07, 0x06,
+  0x10, 0x17, 0x16, 0x20, 0x37, 0xa7, 0x51, 0x31, 0x8e, 0x35, 0xa4, 0xb8,
+  0x72, 0x73, 0x73, 0x72, 0xb8, 0x6c, 0x52, 0x50, 0x34, 0x04, 0x01, 0x04,
+  0x01, 0xc2, 0xfe, 0x4c, 0xfe, 0x43, 0x02, 0xda, 0x4a, 0x4c, 0xfe, 0xf9,
+  0x4b, 0x4b, 0x4b, 0x4b, 0x01, 0x07, 0x4c, 0x02, 0x25, 0xd0, 0xa3, 0x62,
+  0x5e, 0x23, 0xa2, 0xa2, 0xfd, 0xf0, 0xa2, 0xa2, 0x31, 0x30, 0x64, 0xfe,
+  0x58, 0xaa, 0x02, 0xda, 0x34, 0x01, 0x96, 0x74, 0x73, 0x73, 0x74, 0xfe,
+  0x6a, 0x74, 0x73, 0x73, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
+  0x04, 0x7b, 0x12, 0x06, 0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde,
+  0xfe, 0x56, 0x01, 0x54, 0x06, 0x14, 0x12, 0x06, 0x00, 0x4d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06,
+  0x01, 0x61, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x76,
+  0x04, 0x7b, 0x00, 0x21, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x3f,
+  0x01, 0x15, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x03, 0x76, 0x22, 0x21, 0x59, 0x60, 0xa4, 0x5c,
+  0x56, 0x10, 0x02, 0x62, 0xfd, 0x9e, 0x10, 0x56, 0x5c, 0xa4, 0x74, 0x45,
+  0x43, 0x48, 0x5d, 0x60, 0xf2, 0x8c, 0x8d, 0x8d, 0x8c, 0xf2, 0x5b, 0x62,
+  0x24, 0x24, 0x03, 0xae, 0x0d, 0x0a, 0x1a, 0x63, 0x5c, 0xa9, 0x90, 0xa9,
+  0x5c, 0x63, 0x1a, 0x19, 0xa7, 0x12, 0x16, 0x9c, 0x9c, 0x02, 0x28, 0x9c,
+  0x9c, 0x16, 0x08, 0x0c, 0x00, 0x01, 0x00, 0xb0, 0xff, 0xe3, 0x03, 0xc1,
+  0x04, 0x7b, 0x00, 0x21, 0x00, 0x00, 0x13, 0x35, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x26, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0xb0, 0x24, 0x24, 0x62, 0x5b, 0xf2, 0x8c, 0x8d,
+  0x8d, 0x8c, 0xf2, 0x60, 0x5d, 0x48, 0x43, 0x45, 0x74, 0xa4, 0x5c, 0x56,
+  0x10, 0xfd, 0x9e, 0x02, 0x62, 0x10, 0x56, 0x5c, 0xa4, 0x60, 0x59, 0x21,
+  0x03, 0xae, 0xa3, 0x0c, 0x08, 0x16, 0x9c, 0x9c, 0xfd, 0xd8, 0x9c, 0x9c,
+  0x16, 0x12, 0xa7, 0x19, 0x1a, 0x63, 0x5c, 0xa9, 0x90, 0xa9, 0x5c, 0x63,
+  0x1a, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0xa0, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x12, 0x06, 0x00, 0xc0, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x06,
+  0x00, 0x26, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83,
+  0x05, 0xd5, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x21, 0x09, 0x01, 0x21, 0x11,
+  0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5, 0x01, 0x0f, 0x01, 0x57,
+  0x01, 0x58, 0x01, 0x0f, 0xb1, 0xfe, 0xa5, 0xb6, 0xfe, 0xa5, 0xb0, 0x05,
+  0xd5, 0xfe, 0x21, 0x01, 0xdf, 0xfa, 0x2b, 0x05, 0x1f, 0xfe, 0x19, 0x01,
+  0xe7, 0xfa, 0xe1, 0x00, 0x00, 0x01, 0x00, 0x72, 0xfe, 0x56, 0x04, 0x3b,
+  0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x11,
+  0x23, 0x11, 0x03, 0x23, 0x03, 0x11, 0x23, 0x72, 0x00, 0xff, 0xe5, 0xe6,
+  0x00, 0xff, 0xa7, 0xf8, 0x8a, 0xf9, 0xa7, 0x04, 0x60, 0xfe, 0x7b, 0x01,
+  0x85, 0xfb, 0xa0, 0x03, 0xb2, 0xfe, 0x60, 0x01, 0xa0, 0xfa, 0xa4, 0x00,
+  0x00, 0x02, 0x00, 0x4c, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x1b,
+  0x00, 0x27, 0x00, 0x00, 0x17, 0x11, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x11,
+  0x21, 0x15, 0x21, 0x15, 0x23, 0x35, 0x23, 0x35, 0x00, 0x10, 0x27, 0x26,
+  0x20, 0x07, 0x06, 0x10, 0x17, 0x16, 0x20, 0x37, 0xa7, 0x51, 0x37, 0x88,
+  0x35, 0xa4, 0xb8, 0x72, 0x73, 0x73, 0x72, 0xb8, 0x6f, 0x4f, 0x50, 0x34,
+  0x01, 0xb4, 0xfe, 0x4c, 0xa7, 0x5b, 0x03, 0x35, 0x4a, 0x4c, 0xfe, 0xf9,
+  0x4b, 0x4b, 0x4b, 0x4b, 0x01, 0x07, 0x4c, 0x90, 0x02, 0xb5, 0xe7, 0x8c,
+  0x66, 0x5a, 0x23, 0xa2, 0xa2, 0xfd, 0xf0, 0xa2, 0xa2, 0x31, 0x30, 0x64,
+  0xfe, 0xc8, 0xaa, 0x70, 0x70, 0xaa, 0x01, 0xf4, 0x01, 0x96, 0x74, 0x73,
+  0x73, 0x74, 0xfe, 0x6a, 0x74, 0x73, 0x73, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x06, 0x01, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x26,
+  0x03, 0x8d, 0x00, 0x00, 0x10, 0x07, 0x00, 0x79, 0x01, 0xfb, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x10, 0x27,
+  0x00, 0x79, 0x00, 0xcd, 0x00, 0x00, 0x12, 0x06, 0x03, 0x91, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x6b, 0x12, 0x26,
+  0x03, 0xa9, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee, 0x04, 0x70, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x4e, 0x12, 0x26,
+  0x03, 0xa9, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x27, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0xfe, 0x66, 0x05, 0x1b,
+  0x05, 0xd5, 0x00, 0x1b, 0x00, 0x00, 0x25, 0x10, 0x06, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11,
+  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x21, 0x32, 0x16, 0x15, 0x05, 0x1b,
+  0xb8, 0xcd, 0x44, 0x37, 0x79, 0x64, 0x70, 0x6f, 0xfe, 0xad, 0xb6, 0xfe,
+  0x7d, 0x04, 0x16, 0xfe, 0x23, 0x01, 0x78, 0xa7, 0xc8, 0x68, 0xfe, 0xf2,
+  0xf4, 0xaa, 0x96, 0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x05, 0x2b,
+  0xaa, 0xaa, 0xfe, 0x46, 0xe9, 0xee, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0xf9, 0x07, 0x6b, 0x12, 0x26, 0x03, 0xa7, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xec, 0x04, 0x36, 0x01, 0x75, 0x00, 0x01, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x18, 0x00, 0x00, 0x01, 0x15,
+  0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x17, 0x15, 0x26,
+  0x23, 0x22, 0x02, 0x07, 0x21, 0x15, 0x21, 0x16, 0x12, 0x33, 0x32, 0x04,
+  0xa3, 0xbf, 0xf0, 0xfe, 0xd2, 0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x2e, 0xf4,
+  0xbb, 0xbe, 0xe6, 0xee, 0xd6, 0x14, 0x02, 0xce, 0xfd, 0x32, 0x14, 0xd6,
+  0xee, 0xe6, 0x01, 0x46, 0xd3, 0x90, 0x01, 0x9f, 0x01, 0x68, 0x01, 0x67,
+  0x01, 0x9f, 0x8e, 0xd5, 0xbd, 0xfe, 0xe3, 0xef, 0xaa, 0xef, 0xfe, 0xe4,
+  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x05, 0xf0, 0x12, 0x06,
+  0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6b,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0x00, 0x00, 0x02, 0x1c, 0x07, 0x4e, 0x10, 0x06, 0x00, 0x91, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xa0, 0xfe, 0x66, 0x01, 0x6b, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x2d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4b, 0x00, 0x00, 0x07, 0x5e,
+  0x05, 0xd5, 0x00, 0x14, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x21, 0x15, 0x10,
+  0x02, 0x05, 0x35, 0x36, 0x12, 0x11, 0x35, 0x21, 0x11, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x21, 0x25, 0x20, 0x11, 0x34, 0x26, 0x2b, 0x01,
+  0x11, 0x03, 0xfe, 0xfe, 0x4c, 0xb4, 0xfe, 0xb6, 0xc3, 0x86, 0x03, 0x1f,
+  0xd3, 0xe2, 0xf5, 0xf5, 0xe2, 0xfe, 0x77, 0x01, 0x80, 0x01, 0x20, 0x8e,
+  0x92, 0xca, 0x05, 0x2b, 0xb8, 0xfd, 0xca, 0xfd, 0xfb, 0x38, 0xaa, 0x2f,
+  0x01, 0xa6, 0x02, 0x58, 0xfe, 0xfd, 0x9a, 0xda, 0xdd, 0xde, 0xda, 0xa6,
+  0x01, 0x11, 0x8b, 0x87, 0xfd, 0xdd, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x07, 0x05, 0x05, 0xd5, 0x00, 0x12, 0x00, 0x1b, 0x00, 0x00,
+  0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11,
+  0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x01, 0x34, 0x26, 0x2b, 0x01,
+  0x11, 0x33, 0x32, 0x36, 0x03, 0xa5, 0xfd, 0xc6, 0xb6, 0xb6, 0x02, 0x3a,
+  0xb6, 0xd3, 0xe2, 0xf4, 0xf4, 0xe2, 0x01, 0x17, 0x8e, 0x92, 0xca, 0xca,
+  0x90, 0x90, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64,
+  0xfd, 0x9a, 0xda, 0xde, 0xdd, 0xda, 0x01, 0xb7, 0x8b, 0x87, 0xfd, 0xdd,
+  0x87, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0x00, 0x00, 0x05, 0x1b,
+  0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x11, 0x23,
+  0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x15,
+  0x21, 0x11, 0x03, 0xac, 0xa7, 0xc8, 0xb5, 0x70, 0x6f, 0xfe, 0xad, 0xb6,
+  0xfe, 0x7d, 0x04, 0x16, 0xfe, 0x23, 0x03, 0x71, 0xe9, 0xee, 0xfe, 0x66,
+  0x01, 0x8a, 0x9f, 0x9e, 0xfd, 0x39, 0x05, 0x2b, 0xaa, 0xaa, 0xfe, 0x46,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xf9, 0x07, 0x6b, 0x12, 0x26,
+  0x03, 0xae, 0x00, 0x00, 0x10, 0x07, 0x10, 0xec, 0x04, 0x70, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x6b, 0x12, 0x26,
+  0x03, 0xac, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee, 0x04, 0x68, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xf2, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x23, 0x02, 0x68, 0xfe, 0x4d, 0xb6, 0x02, 0x94, 0xb6, 0xfe, 0x4d,
+  0x9a, 0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0x2b, 0xfe, 0xbf, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x24, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e,
+  0x05, 0xd5, 0x00, 0x08, 0x00, 0x15, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23,
+  0x21, 0x11, 0x21, 0x32, 0x36, 0x13, 0x15, 0x21, 0x11, 0x21, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x03, 0xae, 0x8d, 0x93, 0xfe, 0xdd,
+  0x01, 0x23, 0x93, 0x8d, 0x62, 0xfd, 0x5b, 0x01, 0x2c, 0xe2, 0xf5, 0xed,
+  0xea, 0xfe, 0x1e, 0x01, 0xb7, 0x8b, 0x87, 0xfd, 0xdd, 0x87, 0x04, 0xa8,
+  0xa6, 0xfe, 0x40, 0xda, 0xde, 0xdd, 0xda, 0x05, 0xd5, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x25, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9,
+  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0xb5, 0x03, 0x44, 0xfd, 0x72, 0x05, 0xd5, 0xaa, 0xfa, 0xd5, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x5a, 0xfe, 0xbf, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x07,
+  0x00, 0x17, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06,
+  0x05, 0x36, 0x37, 0x12, 0x19, 0x01, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11,
+  0x21, 0x11, 0x23, 0x11, 0x01, 0xa4, 0x02, 0x52, 0xfe, 0x4c, 0x65, 0x15,
+  0xfe, 0xd3, 0x78, 0x23, 0x57, 0x03, 0x1f, 0x99, 0x99, 0xfc, 0x48, 0x99,
+  0xaa, 0x04, 0x81, 0xd4, 0xfe, 0x0d, 0xfe, 0xb5, 0x44, 0x2b, 0x3f, 0x78,
+  0x01, 0x34, 0x02, 0x26, 0x01, 0x1a, 0xfa, 0xd5, 0xfe, 0x15, 0x01, 0x41,
+  0xfe, 0xbf, 0x01, 0xeb, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00, 0x00, 0x01, 0x00, 0x24,
+  0x00, 0x00, 0x07, 0x9e, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x03, 0x11, 0x23, 0x11, 0x03,
+  0x01, 0x23, 0x09, 0x01, 0x33, 0x01, 0x03, 0x86, 0xb6, 0x02, 0x65, 0xdd,
+  0xfe, 0x15, 0x02, 0x0a, 0xbd, 0xfe, 0x44, 0xe8, 0xb6, 0xe8, 0xfe, 0x44,
+  0xbe, 0x02, 0x0a, 0xfe, 0x16, 0xdc, 0x02, 0x66, 0x05, 0xd5, 0xfd, 0x1e,
+  0x02, 0xe2, 0xfd, 0xb3, 0xfc, 0x78, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16,
+  0x01, 0xea, 0x01, 0x17, 0xfc, 0xff, 0x03, 0x88, 0x02, 0x4d, 0xfd, 0x1e,
+  0x00, 0x01, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x25, 0x05, 0xf0, 0x00, 0x28,
+  0x00, 0x00, 0x01, 0x32, 0x04, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15,
+  0x14, 0x04, 0x23, 0x22, 0x24, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x02, 0x0e, 0xde, 0x01, 0x19,
+  0x80, 0x76, 0x83, 0x92, 0xfe, 0xc1, 0xd7, 0x6d, 0xff, 0x00, 0x27, 0x89,
+  0x98, 0x70, 0xa9, 0xbb, 0xa6, 0xb0, 0xb7, 0xbe, 0xa2, 0x8e, 0x93, 0xb2,
+  0x79, 0x52, 0xb9, 0x66, 0xd4, 0x05, 0xf0, 0xd1, 0xb2, 0x7c, 0xab, 0x21,
+  0x1f, 0xc4, 0x90, 0xe6, 0xe9, 0x42, 0x1c, 0xd0, 0x59, 0x2b, 0x90, 0x95,
+  0x84, 0x95, 0xa6, 0x77, 0x70, 0x73, 0x7b, 0x18, 0x4d, 0xc5, 0x28, 0x22,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x01, 0x23, 0x11, 0x33, 0x11, 0x01,
+  0x04, 0xae, 0xb0, 0xfd, 0xac, 0xf5, 0xb0, 0x02, 0x54, 0x05, 0xd5, 0xfa,
+  0x2b, 0x04, 0xe1, 0xfb, 0x1f, 0x05, 0xd5, 0xfb, 0x1f, 0x04, 0xe1, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x6d, 0x12, 0x26,
+  0x03, 0xac, 0x00, 0x00, 0x11, 0x07, 0x10, 0xf2, 0x04, 0x76, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xf9,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09,
+  0x01, 0x23, 0x01, 0x03, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x89, 0xea, 0xfd,
+  0xf8, 0x02, 0x23, 0xc6, 0xfe, 0x2d, 0xf5, 0xb6, 0x05, 0xd5, 0xfd, 0x1e,
+  0x02, 0xe2, 0xfd, 0xb2, 0xfc, 0x79, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16,
+  0x00, 0x01, 0x00, 0x4b, 0x00, 0x00, 0x04, 0xb5, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x12, 0x11, 0x35, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x4c, 0xc3, 0x38, 0x4e, 0x03, 0x1f,
+  0xb6, 0xfe, 0x4c, 0x5c, 0x58, 0xaa, 0x2f, 0xa4, 0x01, 0x02, 0x02, 0x58,
+  0xfe, 0xfa, 0x2b, 0x05, 0x2b, 0xb8, 0xfd, 0xca, 0xfe, 0xf8, 0xfd, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06, 0x00, 0x32, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x04, 0xb5,
+  0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfa, 0x2b, 0x05, 0x2b, 0xfa, 0xd5,
+  0x05, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x12, 0x06, 0x00, 0x26, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x37, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44,
+  0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x3f, 0x01, 0x01, 0x33, 0x09, 0x01, 0x33,
+  0x02, 0x4e, 0x13, 0x1d, 0x47, 0xe2, 0x45, 0x38, 0x6b, 0x2a, 0x19, 0x10,
+  0x29, 0xfe, 0x51, 0xc3, 0x01, 0x4e, 0x01, 0x4f, 0xc4, 0xb5, 0x32, 0x26,
+  0x5d, 0xaa, 0x1b, 0x11, 0x2a, 0x6a, 0x04, 0x6b, 0xfc, 0x94, 0x03, 0x6c,
+  0x00, 0x03, 0x00, 0x6c, 0x00, 0x00, 0x05, 0xc6, 0x05, 0xd5, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16,
+  0x17, 0x33, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x03, 0x24, 0x00, 0x11,
+  0x10, 0x00, 0x25, 0x35, 0x33, 0x15, 0x04, 0x00, 0x11, 0x10, 0x00, 0x05,
+  0x15, 0x23, 0x02, 0xbf, 0xc3, 0xcf, 0xcf, 0xc3, 0xb7, 0xc3, 0xcd, 0xcd,
+  0xc3, 0xb7, 0xfe, 0xe3, 0xfe, 0xcb, 0x01, 0x35, 0x01, 0x1d, 0xb7, 0x01,
+  0x1d, 0x01, 0x33, 0xfe, 0xcd, 0xfe, 0xe3, 0xb7, 0x04, 0xa2, 0x14, 0xcc,
+  0xc5, 0xc5, 0xcb, 0x14, 0x14, 0xcb, 0xc5, 0xc5, 0xcc, 0x14, 0xfc, 0x10,
+  0x17, 0x01, 0x2b, 0x01, 0x09, 0x01, 0x09, 0x01, 0x2d, 0x17, 0x8b, 0x8b,
+  0x17, 0xfe, 0xd5, 0xfe, 0xf5, 0xfe, 0xf7, 0xfe, 0xd5, 0x17, 0xb2, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x06,
+  0x00, 0x3b, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x4f,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x04, 0xb5, 0xfc, 0x00, 0xb6, 0x02,
+  0x94, 0xb6, 0x99, 0x99, 0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0xd5,
+  0xfe, 0x15, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x04, 0x3b,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x21, 0x11, 0x21, 0x22, 0x26, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x21, 0x11, 0x33, 0x11, 0x03, 0x84,
+  0xfe, 0x89, 0xa8, 0xc7, 0xb4, 0x70, 0x70, 0x01, 0x52, 0xb7, 0x02, 0x64,
+  0xe9, 0xee, 0x01, 0x9a, 0xfe, 0x76, 0x9f, 0x9e, 0x02, 0xc7, 0xfa, 0x2b,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x06, 0xff, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x25, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x04, 0x34, 0x02, 0x14, 0xb6, 0xf9, 0xb7, 0xb6, 0x02, 0x14,
+  0xb5, 0xaa, 0x05, 0x2b, 0xfa, 0x2b, 0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x07, 0x98, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x06, 0xfe, 0xf9, 0xb7, 0xb6, 0x02,
+  0x14, 0xb5, 0x02, 0x14, 0xb6, 0x99, 0x99, 0x05, 0xd5, 0xfa, 0xd5, 0x05,
+  0x2b, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0xd5, 0xfe, 0x15, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x05, 0x7c, 0x05, 0xd5, 0x00, 0x0c,
+  0x00, 0x17, 0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x01, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11,
+  0x21, 0x32, 0x37, 0x36, 0x01, 0xc3, 0xfe, 0x73, 0x02, 0x43, 0x01, 0x2c,
+  0xe2, 0xf5, 0xf5, 0xe2, 0x01, 0x17, 0x47, 0x46, 0x93, 0xfe, 0xdd, 0x01,
+  0x23, 0x91, 0x48, 0x47, 0x05, 0x2b, 0xaa, 0xfd, 0x9a, 0xda, 0xde, 0xdd,
+  0xda, 0x01, 0xb7, 0x8b, 0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0xa6, 0x05, 0xd5, 0x10, 0x26,
+  0x03, 0xc0, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x04, 0x3b, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x0a,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11, 0x21,
+  0x32, 0x37, 0x36, 0x01, 0x33, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x21, 0x03, 0xae, 0x47, 0x46, 0x93, 0xfe, 0xdd, 0x01, 0x23, 0x93,
+  0x46, 0x47, 0xfd, 0x07, 0xb6, 0x01, 0x2c, 0xe2, 0xf5, 0xf5, 0xe2, 0xfe,
+  0x1e, 0x01, 0xb7, 0x8b, 0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x04, 0xa8,
+  0xfd, 0x9a, 0xda, 0xde, 0xdd, 0xda, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe3, 0x04, 0xa0, 0x05, 0xf0, 0x00, 0x18, 0x00, 0x00, 0x13, 0x16,
+  0x33, 0x32, 0x12, 0x37, 0x21, 0x35, 0x21, 0x26, 0x02, 0x23, 0x22, 0x07,
+  0x35, 0x36, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x22, 0x27, 0x64,
+  0xbe, 0xe6, 0xee, 0xd6, 0x14, 0xfd, 0x32, 0x02, 0xce, 0x14, 0xd6, 0xee,
+  0xe6, 0xbe, 0xbb, 0xf4, 0x01, 0x2d, 0x01, 0x60, 0xfe, 0xa0, 0xfe, 0xd3,
+  0xf0, 0xbf, 0x01, 0x46, 0xbd, 0x01, 0x1c, 0xef, 0xaa, 0xef, 0x01, 0x1d,
+  0xbd, 0xd5, 0x8e, 0xfe, 0x61, 0xfe, 0x99, 0xfe, 0x98, 0xfe, 0x61, 0x90,
+  0x00, 0x02, 0x00, 0xbd, 0xff, 0xe3, 0x07, 0x5f, 0x05, 0xf0, 0x00, 0x0f,
+  0x00, 0x26, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x11, 0x10, 0x27, 0x26, 0x01, 0x12, 0x37, 0x36,
+  0x21, 0x20, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26,
+  0x03, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x04, 0xf1, 0xc6, 0x74, 0x75,
+  0x75, 0x74, 0xc6, 0xc6, 0x74, 0x74, 0x74, 0x74, 0xfc, 0xce, 0x0d, 0xa2,
+  0xa2, 0x01, 0x1b, 0x01, 0x1b, 0xa9, 0xa9, 0xa9, 0xa9, 0xfe, 0xe5, 0xfe,
+  0xe5, 0xa2, 0xa2, 0x0d, 0xfe, 0xef, 0xb6, 0xb6, 0x05, 0x4c, 0xa4, 0xa4,
+  0xfe, 0xe5, 0xfe, 0xe6, 0xa4, 0xa4, 0xa4, 0xa4, 0x01, 0x1a, 0x01, 0x1b,
+  0xa4, 0xa4, 0xfd, 0xf3, 0x01, 0x18, 0xcd, 0xcc, 0xd2, 0xd3, 0xfe, 0x9e,
+  0xfe, 0x9f, 0xd2, 0xd3, 0xcd, 0xcd, 0x01, 0x18, 0xfd, 0x6b, 0x05, 0xd5,
+  0xfd, 0x6a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x7a, 0x00, 0x00, 0x04, 0x4c,
+  0x05, 0xd5, 0x00, 0x08, 0x00, 0x16, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
+  0x21, 0x11, 0x21, 0x22, 0x06, 0x03, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36,
+  0x33, 0x21, 0x11, 0x23, 0x11, 0x23, 0x01, 0x01, 0x72, 0x86, 0x83, 0x01,
+  0x1b, 0xfe, 0xe5, 0x83, 0x86, 0xf8, 0x01, 0x70, 0x5a, 0xe7, 0xea, 0xe8,
+  0x01, 0xd1, 0xb6, 0xf3, 0xfe, 0x9d, 0x04, 0x27, 0x83, 0x87, 0x02, 0x12,
+  0x85, 0xfb, 0x56, 0x02, 0x8d, 0x1a, 0xa9, 0xd7, 0xce, 0xe0, 0xfa, 0x2b,
+  0x02, 0x77, 0xfd, 0x89, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x04, 0x7b, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64,
+  0xff, 0xe3, 0x04, 0x0c, 0x06, 0x37, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x00,
+  0x01, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x03, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x24, 0x37, 0x36, 0x37, 0x17, 0x06, 0x0f, 0x01,
+  0x06, 0x07, 0x06, 0x0f, 0x01, 0x36, 0x17, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x02, 0x3d, 0xd8, 0xf7, 0xf7, 0xd8,
+  0xd9, 0xef, 0x06, 0x06, 0x04, 0x34, 0x52, 0x01, 0x1b, 0xee, 0x6e, 0x30,
+  0x2e, 0x2c, 0x28, 0xe1, 0x72, 0x44, 0xb3, 0x11, 0x07, 0x75, 0xbe, 0x85,
+  0x9b, 0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x04, 0x7b, 0xfe, 0xc8, 0xfe, 0xec,
+  0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x30, 0x01, 0x1c, 0xe5, 0x77, 0x29, 0xa0,
+  0x76, 0xb9, 0xa0, 0x02, 0x01, 0x11, 0x92, 0x14, 0x01, 0x11, 0x09, 0x2c,
+  0x75, 0x99, 0x38, 0x77, 0x9c, 0xe7, 0xc9, 0xc9, 0xe7, 0xe8, 0xc8, 0xc7,
+  0xe9, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xd2,
+  0x04, 0x60, 0x00, 0x08, 0x00, 0x11, 0x00, 0x20, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x11, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21, 0x01, 0x4d, 0xec, 0x71, 0x77,
+  0x77, 0x71, 0xec, 0xda, 0x5d, 0x77, 0x77, 0x5d, 0xfe, 0x80, 0x01, 0x8b,
+  0xb1, 0xbf, 0x62, 0x5f, 0x72, 0x7e, 0xcf, 0xc1, 0xfe, 0x66, 0x02, 0x04,
+  0xfe, 0x8f, 0x5f, 0x5a, 0x5a, 0x5e, 0x01, 0xc9, 0xfe, 0xca, 0x53, 0x4a,
+  0x4a, 0x4f, 0x93, 0x90, 0x85, 0x67, 0x79, 0x0f, 0x18, 0x98, 0x72, 0x96,
+  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x6f,
+  0x04, 0x60, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0xa7, 0x02, 0xc7, 0xfd, 0xe0, 0x04, 0x60, 0x93, 0xfc, 0x33, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x60, 0xfe, 0xe5, 0x04, 0x9b, 0x04, 0x60, 0x00, 0x06,
+  0x00, 0x16, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x15, 0x10, 0x07, 0x05,
+  0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21,
+  0x11, 0x23, 0x11, 0x01, 0x8f, 0x01, 0xe0, 0xfe, 0xa4, 0x6a, 0xfe, 0xf5,
+  0x52, 0x24, 0x58, 0x02, 0xaa, 0x84, 0x84, 0xfc, 0xcf, 0x85, 0x93, 0x03,
+  0x3a, 0x8c, 0xfe, 0x64, 0xdc, 0x36, 0x28, 0x55, 0xd3, 0x01, 0xa9, 0xd4,
+  0xfc, 0x33, 0xfe, 0x52, 0x01, 0x1b, 0xfe, 0xe5, 0x01, 0xae, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x06,
+  0x00, 0x48, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f, 0x00, 0x00, 0x06, 0x3e,
+  0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33, 0x11, 0x01, 0x33, 0x09,
+  0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x27, 0x01, 0x23, 0x09, 0x01,
+  0x33, 0x01, 0x02, 0xec, 0xa5, 0x01, 0xb8, 0xc0, 0xfe, 0x97, 0x01, 0x9e,
+  0xb2, 0xfe, 0xad, 0xa8, 0xa5, 0xa8, 0xfe, 0xac, 0xb1, 0x01, 0x9e, 0xfe,
+  0x96, 0xc1, 0x01, 0xb8, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e, 0xfe, 0x51,
+  0xfd, 0x4f, 0x02, 0x36, 0xc9, 0xfe, 0x93, 0x01, 0x6d, 0xc9, 0xfd, 0xca,
+  0x02, 0xb1, 0x01, 0xaf, 0xfd, 0xf2, 0x00, 0x00, 0x00, 0x01, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x04, 0x7c, 0x00, 0x28, 0x00, 0x00, 0x01, 0x1e,
+  0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x02, 0x7b, 0x70, 0x7c, 0xe8, 0xd6, 0x48, 0x98, 0x51,
+  0x40, 0x99, 0x53, 0x88, 0x98, 0x87, 0x7b, 0x85, 0x8b, 0x69, 0x79, 0x7d,
+  0x6b, 0x40, 0x91, 0x57, 0x58, 0x99, 0x45, 0xb0, 0xcc, 0x6c, 0x02, 0x5c,
+  0x18, 0x92, 0x6c, 0xad, 0xb6, 0x1c, 0x1c, 0xab, 0x25, 0x25, 0x70, 0x5a,
+  0x58, 0x6b, 0x98, 0x59, 0x46, 0x40, 0x5c, 0x1a, 0x1d, 0xa7, 0x18, 0x18,
+  0x9d, 0x8d, 0x5d, 0x81, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
+  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x01, 0x23,
+  0x11, 0x33, 0x11, 0x01, 0x04, 0x06, 0xa4, 0xfe, 0x1a, 0xd5, 0xa5, 0x01,
+  0xe5, 0x04, 0x60, 0xfb, 0xa0, 0x03, 0x83, 0xfc, 0x7d, 0x04, 0x60, 0xfc,
+  0x7f, 0x03, 0x81, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
+  0x06, 0x14, 0x12, 0x26, 0x03, 0xcc, 0x00, 0x00, 0x11, 0x07, 0x02, 0x9a,
+  0x00, 0x8a, 0xff, 0xcc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x1d, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0xa7, 0xa5,
+  0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0xb3, 0xb9, 0xfe, 0x9a, 0xb1, 0xa5,
+  0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e, 0xfe, 0x4f, 0xfd, 0x51, 0x02, 0x35,
+  0xc8, 0xfe, 0x93, 0x00, 0x00, 0x01, 0x00, 0x44, 0x00, 0x00, 0x04, 0x02,
+  0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x36, 0x11,
+  0x35, 0x21, 0x11, 0x23, 0x11, 0x21, 0x15, 0x10, 0x07, 0x06, 0x44, 0xa4,
+  0x33, 0x3d, 0x02, 0xa9, 0xa5, 0xfe, 0xa1, 0x4f, 0x54, 0x99, 0x1c, 0x7e,
+  0xb1, 0x01, 0xc5, 0xb7, 0xfb, 0xa0, 0x03, 0xcd, 0x6f, 0xfe, 0x50, 0xc2,
+  0xcf, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8,
+  0x04, 0x60, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x11,
+  0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xf3, 0x01, 0x1e, 0x01,
+  0x1f, 0xf0, 0xa6, 0xfe, 0xe9, 0xa5, 0xfe, 0xe9, 0xa7, 0x04, 0x60, 0xfd,
+  0x12, 0x02, 0xee, 0xfb, 0xa0, 0x03, 0xb0, 0xfd, 0x27, 0x02, 0xd9, 0xfc,
+  0x50, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x0e,
+  0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
+  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xa7, 0xa7, 0x02, 0x19, 0xa7, 0xa7,
+  0xfd, 0xe7, 0xa7, 0x04, 0x60, 0xfe, 0x37, 0x01, 0xc9, 0xfb, 0xa0, 0x02,
+  0x04, 0xfd, 0xfc, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x04, 0x7b, 0x12, 0x06, 0x00, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x0e, 0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x04, 0x0e, 0xa7, 0xfd, 0xe7, 0xa7,
+  0x04, 0x60, 0xfb, 0xa0, 0x03, 0xcd, 0xfc, 0x33, 0x04, 0x60, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x12, 0x06,
+  0x00, 0x53, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
+  0x04, 0x7b, 0x12, 0x06, 0x00, 0x46, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0x00, 0x00, 0x03, 0xfc, 0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x36, 0x03, 0xc6, 0xfe, 0x6e, 0xa3,
+  0xfe, 0x6f, 0x04, 0x60, 0x93, 0xfc, 0x33, 0x03, 0xcd, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x12, 0x06,
+  0x00, 0x5c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x64, 0xfe, 0x56, 0x05, 0xc4,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x28, 0x00, 0x33, 0x00, 0x00, 0x01, 0x14,
+  0x16, 0x33, 0x32, 0x37, 0x11, 0x26, 0x23, 0x22, 0x06, 0x01, 0x11, 0x0e,
+  0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x11,
+  0x33, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
+  0x26, 0x27, 0x11, 0x01, 0x34, 0x26, 0x23, 0x22, 0x07, 0x11, 0x16, 0x33,
+  0x32, 0x36, 0x01, 0x11, 0x82, 0x6f, 0x58, 0x67, 0x67, 0x58, 0x6f, 0x82,
+  0x01, 0xb0, 0x34, 0x75, 0x4b, 0x97, 0xd1, 0xd1, 0x97, 0x4b, 0x75, 0x34,
+  0xa6, 0x33, 0x76, 0x4b, 0x96, 0xd2, 0xd2, 0x96, 0x4b, 0x76, 0x33, 0x01,
+  0xb0, 0x82, 0x6f, 0x58, 0x67, 0x67, 0x58, 0x6f, 0x82, 0x02, 0x2f, 0xeb,
+  0xc7, 0xa8, 0x02, 0x14, 0xa8, 0xc7, 0xfb, 0x3c, 0x02, 0x39, 0x5e, 0x4e,
+  0x01, 0x35, 0x01, 0x13, 0x01, 0x13, 0x01, 0x3d, 0x4c, 0x5e, 0x02, 0x04,
+  0xfd, 0xfc, 0x5e, 0x4c, 0xfe, 0xc3, 0xfe, 0xed, 0xfe, 0xed, 0xfe, 0xcb,
+  0x4e, 0x5e, 0xfd, 0xc7, 0x03, 0xd9, 0xeb, 0xc7, 0xa8, 0xfd, 0xec, 0xa8,
+  0xc7, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07,
+  0x04, 0x60, 0x12, 0x06, 0x00, 0x5b, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xfe, 0xe5, 0x04, 0x92, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01,
+  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x04, 0x0e,
+  0xfc, 0x99, 0xa7, 0x02, 0x19, 0xa7, 0x84, 0x84, 0x04, 0x60, 0xfc, 0x33,
+  0x03, 0xcd, 0xfc, 0x33, 0xfe, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87,
+  0x00, 0x00, 0x03, 0x9a, 0x04, 0x60, 0x00, 0x11, 0x00, 0x00, 0x21, 0x11,
+  0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33,
+  0x21, 0x11, 0x33, 0x11, 0x02, 0xf4, 0xfe, 0xcb, 0x89, 0x5c, 0x53, 0xa6,
+  0x2e, 0x30, 0x5e, 0x01, 0x0b, 0xa6, 0x01, 0xd7, 0x5f, 0x56, 0xb8, 0x01,
+  0x1c, 0xfe, 0xf5, 0x75, 0x3b, 0x3b, 0x01, 0xf6, 0xfb, 0xa0, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x05, 0xf0, 0x04, 0x60, 0x00, 0x0b,
+  0x00, 0x00, 0x25, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x03, 0x9e, 0x01, 0xab, 0xa6, 0xfa, 0xb8, 0xa7, 0x01, 0xaa,
+  0xa6, 0x93, 0x03, 0xcd, 0xfb, 0xa0, 0x04, 0x60, 0xfc, 0x33, 0x03, 0xcd,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x06, 0x74, 0x04, 0x60, 0x00, 0x0f,
+  0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x05, 0xef, 0xfa, 0xb8, 0xa7, 0x01,
+  0xaa, 0xa6, 0x01, 0xab, 0xa6, 0x85, 0x85, 0x04, 0x60, 0xfc, 0x33, 0x03,
+  0xcd, 0xfc, 0x33, 0x03, 0xcd, 0xfc, 0x33, 0xfe, 0x52, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x37, 0x00, 0x00, 0x04, 0xaa, 0x04, 0x60, 0x00, 0x0c,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21,
+  0x11, 0x21, 0x35, 0x21, 0x11, 0x17, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x03, 0x19, 0xc1, 0xcf, 0xcf, 0xc1, 0xfe, 0x65, 0xfe, 0xba,
+  0x01, 0xed, 0xed, 0xed, 0xed, 0x71, 0x76, 0x76, 0x02, 0x97, 0xa3, 0xa8,
+  0xa8, 0xa4, 0x03, 0xcd, 0x93, 0xfe, 0x37, 0x93, 0xfe, 0x8f, 0x5f, 0x5a,
+  0x5a, 0x5e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x05, 0x0c,
+  0x04, 0x7b, 0x10, 0x27, 0x00, 0xf3, 0x03, 0xb8, 0x00, 0x00, 0x10, 0x06,
+  0x03, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xd2,
+  0x04, 0x60, 0x00, 0x08, 0x00, 0x13, 0x00, 0x00, 0x01, 0x34, 0x26, 0x2b,
+  0x01, 0x11, 0x33, 0x32, 0x36, 0x01, 0x33, 0x11, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x21, 0x03, 0x21, 0x76, 0x71, 0xec, 0xec, 0x71, 0x76,
+  0xfd, 0x86, 0xa7, 0xf3, 0xc1, 0xcf, 0xcf, 0xc1, 0xfe, 0x66, 0x01, 0x4c,
+  0x5a, 0x5e, 0xfe, 0x8f, 0x5f, 0x03, 0x6e, 0xfe, 0x37, 0xa3, 0xa8, 0xa8,
+  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
+  0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x37, 0x16, 0x33, 0x32, 0x36, 0x37,
+  0x21, 0x35, 0x21, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33, 0x32,
+  0x00, 0x11, 0x10, 0x00, 0x23, 0x22, 0x27, 0x66, 0x8e, 0x8d, 0x85, 0xbc,
+  0x12, 0xfe, 0x00, 0x01, 0xfa, 0x0b, 0x8f, 0xb3, 0x8a, 0x91, 0x8d, 0x95,
+  0xec, 0x01, 0x0f, 0xfe, 0xf8, 0xe7, 0xaa, 0x84, 0xd5, 0x56, 0xab, 0xda,
+  0x93, 0x69, 0xdf, 0x56, 0xac, 0x46, 0xfe, 0xc3, 0xfe, 0xf1, 0xfe, 0xf2,
+  0xfe, 0xc2, 0x48, 0x00, 0x00, 0x02, 0x00, 0xad, 0xff, 0xe3, 0x05, 0xab,
+  0x04, 0x7b, 0x00, 0x0b, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x01, 0x36, 0x12, 0x33,
+  0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x27, 0x23, 0x11, 0x23,
+  0x11, 0x33, 0x11, 0x03, 0xdc, 0x85, 0x9b, 0x9a, 0x86, 0x84, 0x9b, 0x9b,
+  0xfd, 0xb3, 0x11, 0xe0, 0xd8, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xec, 0x09,
+  0xbb, 0xa5, 0xa5, 0x03, 0xdf, 0xe7, 0xc9, 0xc9, 0xe7, 0xe8, 0xc8, 0xc7,
+  0xe9, 0xfe, 0xc2, 0xbe, 0x01, 0x1c, 0xfe, 0xc8, 0xfe, 0xec, 0xfe, 0xed,
+  0xfe, 0xc7, 0x01, 0x2e, 0xf8, 0xfd, 0xf7, 0x04, 0x60, 0xfe, 0x41, 0x00,
+  0x00, 0x02, 0x00, 0x68, 0x00, 0x00, 0x03, 0xb9, 0x04, 0x60, 0x00, 0x08,
+  0x00, 0x16, 0x00, 0x00, 0x01, 0x14, 0x16, 0x3b, 0x01, 0x11, 0x23, 0x22,
+  0x06, 0x03, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x23,
+  0x11, 0x23, 0x01, 0x01, 0x54, 0x73, 0x6b, 0xe0, 0xe0, 0x6b, 0x73, 0xec,
+  0x01, 0x34, 0x68, 0x8b, 0xc2, 0xc3, 0x01, 0x8a, 0xa6, 0xce, 0xfe, 0xd7,
+  0x03, 0x1d, 0x53, 0x5e, 0x01, 0x61, 0x5c, 0xfc, 0x8f, 0x01, 0xeb, 0x1a,
+  0x89, 0x8f, 0xa2, 0xa1, 0xfb, 0xa0, 0x01, 0xd9, 0xfe, 0x27, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x6b, 0x12, 0x26,
+  0x03, 0xc9, 0x00, 0x00, 0x10, 0x06, 0x00, 0x43, 0x51, 0x05, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x10, 0x12, 0x26,
+  0x03, 0xc9, 0x00, 0x00, 0x11, 0x07, 0x00, 0x6a, 0x00, 0x87, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a, 0xfe, 0x56, 0x04, 0x1c,
+  0x06, 0x14, 0x00, 0x1f, 0x00, 0x00, 0x13, 0x23, 0x35, 0x33, 0x11, 0x33,
+  0x11, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x11, 0x14,
+  0x00, 0x07, 0x35, 0x36, 0x12, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0xc9, 0x9f, 0x9f, 0xa6, 0x01, 0xe7, 0xfe, 0x19, 0x3c, 0xa0,
+  0x6a, 0xa4, 0xc2, 0xfe, 0xcb, 0xc1, 0x6e, 0xdc, 0x6f, 0x70, 0x8a, 0x97,
+  0xa6, 0x03, 0xd1, 0x8f, 0x01, 0xb4, 0xfe, 0x4c, 0x8f, 0xfe, 0x6d, 0x65,
+  0x64, 0xe9, 0xfe, 0xea, 0xe2, 0xfe, 0x59, 0x29, 0x8c, 0x16, 0x01, 0x2e,
+  0xd2, 0xd0, 0x9f, 0xc4, 0x9e, 0xfe, 0xfb, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0x76, 0x06, 0x6d, 0x12, 0x26, 0x03, 0xc7, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x76, 0x78, 0x07, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x18, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x15, 0x26, 0x23, 0x22, 0x06, 0x07, 0x21, 0x15, 0x21, 0x1e, 0x01,
+  0x33, 0x32, 0x37, 0x15, 0x06, 0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x02,
+  0x60, 0x96, 0x8d, 0x91, 0x8a, 0xb4, 0x8f, 0x0a, 0x01, 0xf9, 0xfe, 0x01,
+  0x11, 0xbd, 0x85, 0x8d, 0x8e, 0x84, 0xaa, 0xe8, 0xfe, 0xf9, 0x01, 0x0f,
+  0x04, 0x7b, 0x46, 0xac, 0x56, 0xdf, 0x69, 0x93, 0xda, 0xab, 0x56, 0xaa,
+  0x48, 0x01, 0x3e, 0x01, 0x0e, 0x01, 0x0f, 0x01, 0x3d, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x04, 0x7b, 0x12, 0x06,
+  0x00, 0x56, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54,
+  0x06, 0x14, 0x12, 0x06, 0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf5,
+  0x00, 0x00, 0x02, 0x0c, 0x06, 0x10, 0x10, 0x06, 0x00, 0xb1, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x01, 0x54, 0x06, 0x14, 0x12, 0x06,
+  0x00, 0x4d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x44, 0x00, 0x00, 0x06, 0x13,
+  0x04, 0x60, 0x00, 0x16, 0x00, 0x1f, 0x00, 0x00, 0x33, 0x35, 0x36, 0x37,
+  0x36, 0x11, 0x35, 0x21, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
+  0x21, 0x11, 0x21, 0x15, 0x10, 0x07, 0x06, 0x25, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x2b, 0x01, 0x11, 0x44, 0xa4, 0x33, 0x3d, 0x02, 0x8f, 0x9a, 0xc1,
+  0xd0, 0xd0, 0xc0, 0xfe, 0xbe, 0xfe, 0xbe, 0x4f, 0x55, 0x03, 0x20, 0x71,
+  0x77, 0x77, 0x71, 0x93, 0x99, 0x1c, 0x7e, 0xb1, 0x01, 0xc5, 0xb7, 0xfe,
+  0x37, 0xa3, 0xa8, 0xa8, 0xa4, 0x03, 0xcd, 0x6f, 0xfe, 0x50, 0xc2, 0xcf,
+  0x76, 0x5f, 0x5a, 0x5a, 0x5e, 0xfe, 0x8f, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0x00, 0x00, 0x06, 0x0c, 0x04, 0x60, 0x00, 0x12, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x21,
+  0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x01, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x2b, 0x01, 0x11, 0x03, 0xe0, 0x9a, 0xc0, 0xd1, 0xd0, 0xc0, 0xfe,
+  0xbe, 0xfe, 0x15, 0xa7, 0xa7, 0x01, 0xeb, 0x01, 0x39, 0x72, 0x77, 0x77,
+  0x72, 0x92, 0x04, 0x60, 0xfe, 0x37, 0xa3, 0xa8, 0xa8, 0xa4, 0x02, 0x04,
+  0xfd, 0xfc, 0x04, 0x60, 0xfe, 0x37, 0x01, 0xc9, 0xfc, 0x33, 0x5f, 0x5a,
+  0x5a, 0x5e, 0xfe, 0x8f, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x04, 0x15,
+  0x06, 0x14, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x23, 0x35, 0x33, 0x11, 0x33,
+  0x11, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11,
+  0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0xc9, 0x9f,
+  0x9f, 0xa6, 0x01, 0xe7, 0xfe, 0x19, 0x3c, 0xa1, 0x69, 0xaa, 0xb6, 0xa6,
+  0x6f, 0x70, 0x89, 0x98, 0xa6, 0x03, 0xd1, 0x8f, 0x01, 0xb4, 0xfe, 0x4c,
+  0x8f, 0xfe, 0x6d, 0x65, 0x64, 0xea, 0xed, 0xfe, 0xd0, 0x01, 0x2a, 0x9f,
+  0x9e, 0xc1, 0xa1, 0xfe, 0xfb, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x1d, 0x06, 0x6d, 0x12, 0x26, 0x03, 0xce, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x76, 0x64, 0x07, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x07, 0x06, 0x6b, 0x12, 0x26, 0x03, 0xcc, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x43, 0x54, 0x05, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36,
+  0xfe, 0x56, 0x04, 0x0c, 0x06, 0x14, 0x12, 0x26, 0x03, 0xd7, 0x00, 0x00,
+  0x10, 0x06, 0x02, 0x9a, 0x55, 0xcc, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xfe, 0xe5, 0x04, 0x0e, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01,
+  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x23, 0x02, 0x18,
+  0xfe, 0x8f, 0xa7, 0x02, 0x19, 0xa7, 0xfe, 0x8f, 0x85, 0x04, 0x60, 0xfc,
+  0x33, 0x03, 0xcd, 0xfb, 0xa0, 0xfe, 0xe5, 0x00, 0x00, 0x01, 0x00, 0x67,
+  0xff, 0xe3, 0x06, 0x52, 0x05, 0xd5, 0x00, 0x34, 0x00, 0x00, 0x05, 0x22,
+  0x27, 0x26, 0x11, 0x34, 0x13, 0x36, 0x37, 0x33, 0x06, 0x03, 0x06, 0x15,
+  0x10, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x11, 0x34, 0x27, 0x02, 0x27, 0x33,
+  0x16, 0x17, 0x12, 0x15, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x06, 0x07, 0x06, 0x02, 0x01, 0xbe, 0x6d, 0x6e, 0x5a, 0x35, 0x53, 0xe0,
+  0x4b, 0x7a, 0x3c, 0x41, 0x42, 0x70, 0x67, 0x40, 0x40, 0xb3, 0x3f, 0x3f,
+  0x69, 0x78, 0x3b, 0x40, 0x3c, 0x7a, 0x4c, 0xe1, 0x56, 0x32, 0x5a, 0x6e,
+  0x6f, 0xbc, 0x84, 0x5a, 0x5a, 0x24, 0x23, 0x5a, 0x5b, 0x1d, 0xb1, 0xb4,
+  0x01, 0x98, 0xc9, 0x01, 0x0e, 0x9f, 0x7f, 0x46, 0xfe, 0xbf, 0x9f, 0xb7,
+  0xfe, 0xcd, 0x6b, 0x6d, 0x69, 0x68, 0xc6, 0xf1, 0xf1, 0xc6, 0x68, 0x69,
+  0x6d, 0x77, 0x01, 0x27, 0xb7, 0x9f, 0x01, 0x41, 0x46, 0x82, 0x9c, 0xfe,
+  0xe7, 0xbe, 0xfe, 0x66, 0xb2, 0xb1, 0x5e, 0x5e, 0xad, 0xad, 0x5e, 0x5e,
+  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a, 0x04, 0x60, 0x10, 0x06,
+  0x03, 0x5d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x1b, 0x00, 0x00, 0x05, 0x20,
+  0x05, 0xd5, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15, 0x21, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x21, 0x35, 0x21, 0x35, 0x33,
+  0x15, 0x21, 0x15, 0x13, 0x34, 0x27, 0x26, 0x23, 0x21, 0x11, 0x21, 0x32,
+  0x37, 0x36, 0x02, 0x1c, 0x01, 0x2d, 0xe1, 0xf5, 0xf5, 0xe1, 0xfe, 0x1d,
+  0xfe, 0xb5, 0x01, 0x4b, 0xb6, 0x01, 0x4c, 0xf8, 0x48, 0x46, 0x92, 0xfe,
+  0xdc, 0x01, 0x24, 0x92, 0x46, 0x48, 0x04, 0x51, 0xe2, 0xda, 0xde, 0xdd,
+  0xda, 0x04, 0x51, 0xa4, 0xe0, 0xe0, 0xa4, 0xfd, 0x66, 0x8b, 0x44, 0x43,
+  0xfd, 0xdd, 0x44, 0x43, 0x00, 0x02, 0x00, 0x1b, 0x00, 0x00, 0x04, 0x6a,
+  0x06, 0x14, 0x00, 0x07, 0x00, 0x19, 0x00, 0x00, 0x24, 0x34, 0x26, 0x2b,
+  0x01, 0x11, 0x33, 0x32, 0x05, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x33, 0x32, 0x16, 0x10, 0x06, 0x23, 0x03, 0xb9,
+  0x76, 0x71, 0xec, 0xec, 0x71, 0xfd, 0xfd, 0xfe, 0xdb, 0x01, 0x25, 0xa6,
+  0x01, 0x7e, 0xfe, 0x82, 0xf3, 0xc1, 0xd0, 0xd0, 0xc1, 0xf2, 0xb4, 0x5e,
+  0xfe, 0x8f, 0x93, 0x03, 0xcd, 0x93, 0x01, 0xb4, 0xfe, 0x4c, 0x93, 0xfe,
+  0xca, 0xa3, 0xfe, 0xb0, 0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xbd,
+  0xff, 0xe3, 0x06, 0x66, 0x05, 0xf0, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x33, 0x11, 0x33, 0x12, 0x37, 0x36, 0x21, 0x32, 0x17, 0x16,
+  0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x21, 0x15,
+  0x21, 0x12, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07,
+  0x06, 0x23, 0x20, 0x27, 0x26, 0x03, 0x01, 0x74, 0xb6, 0xb6, 0xbd, 0x1b,
+  0x8d, 0xaf, 0x01, 0x32, 0x78, 0x6a, 0x6c, 0x5d, 0x5c, 0x67, 0x69, 0x75,
+  0xe6, 0x7a, 0x5d, 0x17, 0x02, 0x6d, 0xfd, 0x8c, 0x07, 0x74, 0x7b, 0xe5,
+  0x75, 0x69, 0x67, 0x5c, 0x5f, 0x6b, 0x6b, 0x76, 0xfe, 0xce, 0xaf, 0xa7,
+  0x08, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c, 0x01, 0x08, 0xa7,
+  0xd0, 0x24, 0x23, 0x47, 0xd5, 0x5f, 0x2f, 0x2f, 0x9c, 0x77, 0xc6, 0xaa,
+  0xfe, 0xf3, 0x94, 0x9d, 0x2f, 0x2f, 0x5f, 0xd3, 0x48, 0x24, 0x24, 0xcf,
+  0xc6, 0x01, 0x4f, 0x00, 0x00, 0x01, 0x00, 0xad, 0xff, 0xe3, 0x04, 0xf5,
+  0x04, 0x7b, 0x00, 0x23, 0x00, 0x00, 0x01, 0x32, 0x17, 0x15, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x15, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x23, 0x11, 0x23, 0x11,
+  0x33, 0x11, 0x33, 0x36, 0x37, 0x36, 0x03, 0xd1, 0x96, 0x8d, 0x91, 0x8a,
+  0xcf, 0x53, 0x1f, 0x0b, 0x01, 0x9e, 0xfe, 0x5b, 0x0c, 0x8e, 0x4d, 0x6c,
+  0x8d, 0x8e, 0x84, 0xa9, 0xf3, 0x85, 0x6e, 0x09, 0x85, 0xa5, 0xa5, 0x89,
+  0x15, 0x6e, 0x87, 0x04, 0x7b, 0x46, 0xac, 0x56, 0xb4, 0x41, 0x57, 0x8f,
+  0xf4, 0x5e, 0x33, 0x56, 0xaa, 0x48, 0xad, 0x90, 0xe4, 0xfd, 0xfc, 0x04,
+  0x60, 0xfe, 0x33, 0xca, 0x80, 0x9e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e,
+  0x00, 0x00, 0x06, 0x46, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x00,
+  0x21, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23, 0x03, 0x23, 0x01, 0x33,
+  0x13, 0x09, 0x01, 0x06, 0x46, 0xcb, 0xfa, 0xfb, 0xb6, 0xfd, 0xfa, 0xcb,
+  0x02, 0xb5, 0xcf, 0x9f, 0xfe, 0xf9, 0xfe, 0xf9, 0x02, 0x1b, 0xfd, 0xe5,
+  0x02, 0x1b, 0xfd, 0xe5, 0x05, 0xd5, 0xfc, 0xf3, 0x02, 0x37, 0xfd, 0xc9,
+  0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x05, 0x76, 0x04, 0x60, 0x00, 0x0b,
+  0x00, 0x0e, 0x00, 0x00, 0x21, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23,
+  0x03, 0x23, 0x01, 0x33, 0x13, 0x0b, 0x01, 0x05, 0x76, 0xb0, 0xd4, 0xcc,
+  0xa6, 0xce, 0xd5, 0xaf, 0x02, 0x4c, 0xb0, 0x82, 0xda, 0xdb, 0x01, 0x95,
+  0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b, 0x04, 0x60, 0xfd, 0xb9, 0x01, 0xa1,
+  0xfe, 0x5f, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x08, 0x2c,
+  0x05, 0xd5, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00, 0x21, 0x23, 0x03, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x03, 0x23, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
+  0x11, 0x21, 0x01, 0x33, 0x13, 0x09, 0x01, 0x08, 0x2c, 0xcb, 0xfa, 0xfb,
+  0xb6, 0xfd, 0xfa, 0xcb, 0x01, 0x4b, 0xfe, 0x2c, 0xb6, 0xb6, 0x02, 0x22,
+  0x01, 0x1c, 0xcf, 0x9f, 0xfe, 0xf9, 0xfe, 0xf9, 0x02, 0x1b, 0xfd, 0xe5,
+  0x02, 0x1b, 0xfd, 0xe5, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c,
+  0x02, 0x64, 0xfc, 0xf3, 0x02, 0x37, 0xfd, 0xc9, 0x00, 0x02, 0x00, 0xad,
+  0x00, 0x00, 0x07, 0x08, 0x04, 0x60, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00,
+  0x21, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23, 0x03, 0x23, 0x01, 0x21,
+  0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x01, 0x33, 0x13, 0x0b, 0x01, 0x07,
+  0x08, 0xb0, 0xd4, 0xcc, 0xa6, 0xce, 0xd4, 0xb0, 0x01, 0x00, 0xfe, 0x93,
+  0xa5, 0xa5, 0x01, 0xb8, 0x01, 0x02, 0xaf, 0x83, 0xdb, 0xdb, 0x01, 0x95,
+  0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b, 0x01, 0xe7, 0xfe, 0x19, 0x04, 0x60,
+  0xfe, 0x17, 0x01, 0xe9, 0xfd, 0xb9, 0x01, 0xa1, 0xfe, 0x5f, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x67, 0x00, 0x00, 0x05, 0x44, 0x05, 0xd5, 0x00, 0x17,
+  0x00, 0x1a, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x11,
+  0x23, 0x10, 0x37, 0x36, 0x37, 0x01, 0x21, 0x01, 0x16, 0x17, 0x16, 0x11,
+  0x23, 0x10, 0x27, 0x26, 0x27, 0x01, 0x21, 0x03, 0x30, 0xb6, 0x84, 0x5a,
+  0x75, 0xbf, 0xaa, 0x6c, 0x99, 0xfe, 0x7c, 0x04, 0x90, 0xfe, 0x7b, 0x94,
+  0x68, 0xa9, 0xbf, 0x74, 0x56, 0xdf, 0x01, 0x1e, 0xfd, 0xc3, 0x02, 0x59,
+  0xfd, 0xa7, 0x02, 0x59, 0x1c, 0x7e, 0xa4, 0xfe, 0xe5, 0x01, 0x62, 0xd2,
+  0x86, 0x31, 0x02, 0xea, 0xfd, 0x13, 0x32, 0x82, 0xd2, 0xfe, 0x9e, 0x01,
+  0x1e, 0xa1, 0x7a, 0xca, 0x02, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x60,
+  0x00, 0x00, 0x04, 0x09, 0x04, 0x60, 0x00, 0x02, 0x00, 0x1a, 0x00, 0x00,
+  0x01, 0x21, 0x13, 0x09, 0x01, 0x16, 0x17, 0x16, 0x11, 0x23, 0x34, 0x27,
+  0x26, 0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x15, 0x23, 0x10, 0x37,
+  0x36, 0x37, 0x01, 0x02, 0xf1, 0xfe, 0x87, 0xbc, 0x01, 0xd4, 0xfe, 0xdc,
+  0x60, 0x44, 0x7b, 0xb0, 0x4d, 0x34, 0x4e, 0xa5, 0x4b, 0x32, 0x4e, 0xae,
+  0x7b, 0x43, 0x61, 0xfe, 0xdb, 0x03, 0xb6, 0xfe, 0x96, 0x02, 0x14, 0xfd,
+  0xcc, 0x26, 0x56, 0x9c, 0xfe, 0xec, 0xc7, 0x74, 0x4f, 0x1a, 0xfe, 0x5c,
+  0x01, 0xa2, 0x1a, 0x4b, 0x74, 0xc9, 0x01, 0x14, 0x9c, 0x55, 0x27, 0x02,
+  0x34, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x06, 0xfe,
+  0x05, 0xd5, 0x00, 0x1e, 0x00, 0x21, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01,
+  0x16, 0x17, 0x16, 0x11, 0x23, 0x10, 0x27, 0x26, 0x27, 0x11, 0x23, 0x11,
+  0x06, 0x07, 0x06, 0x11, 0x23, 0x10, 0x37, 0x36, 0x37, 0x21, 0x11, 0x23,
+  0x11, 0x33, 0x11, 0x05, 0x01, 0x21, 0x03, 0x8a, 0xfe, 0xc3, 0x04, 0x90,
+  0xfe, 0x7b, 0x94, 0x68, 0xa9, 0xbf, 0x74, 0x56, 0x8a, 0xb6, 0x84, 0x5a,
+  0x75, 0xc0, 0xab, 0x4c, 0x63, 0xfd, 0xf0, 0xb6, 0xb6, 0x03, 0x2a, 0x01,
+  0x1e, 0xfd, 0xc3, 0x03, 0x71, 0x02, 0x64, 0xfd, 0x13, 0x32, 0x82, 0xd2,
+  0xfe, 0x9e, 0x01, 0x1e, 0xa1, 0x7a, 0x20, 0xfd, 0xa7, 0x02, 0x59, 0x1c,
+  0x7e, 0xa4, 0xfe, 0xe5, 0x01, 0x62, 0xd2, 0x5f, 0x34, 0xfd, 0x39, 0x05,
+  0xd5, 0xfd, 0x9c, 0x6e, 0x02, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
+  0x00, 0x00, 0x05, 0x90, 0x04, 0x60, 0x00, 0x1e, 0x00, 0x21, 0x00, 0x00,
+  0x01, 0x03, 0x21, 0x01, 0x16, 0x17, 0x16, 0x11, 0x23, 0x34, 0x27, 0x26,
+  0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x15, 0x23, 0x10, 0x37, 0x36,
+  0x37, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x21, 0x13, 0x02, 0xe5,
+  0xfd, 0x03, 0xa8, 0xfe, 0xdb, 0x61, 0x43, 0x7b, 0xaf, 0x4d, 0x35, 0x4d,
+  0xa6, 0x4a, 0x33, 0x4d, 0xaf, 0x7b, 0x19, 0x1c, 0xfe, 0xb6, 0xa5, 0xa5,
+  0x03, 0x26, 0xfe, 0x87, 0xbc, 0x02, 0x77, 0x01, 0xe9, 0xfd, 0xcc, 0x26,
+  0x56, 0x9c, 0xfe, 0xec, 0xc7, 0x74, 0x4f, 0x1a, 0xfe, 0x5c, 0x01, 0xa2,
+  0x1a, 0x4b, 0x74, 0xc9, 0x01, 0x14, 0x9c, 0x1f, 0x18, 0xfe, 0x19, 0x04,
+  0x60, 0xfe, 0x17, 0x01, 0x3f, 0xfe, 0x96, 0x00, 0x00, 0x01, 0x00, 0x67,
+  0xfe, 0x56, 0x04, 0x02, 0x07, 0x7a, 0x00, 0x53, 0x00, 0x00, 0x01, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x23, 0x22, 0x15, 0x14, 0x33, 0x32, 0x37,
+  0x36, 0x17, 0x16, 0x17, 0x15, 0x26, 0x23, 0x22, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x23, 0x35, 0x32, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
+  0x21, 0x22, 0x07, 0x35, 0x36, 0x37, 0x03, 0x33, 0x13, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22, 0x0f,
+  0x01, 0x16, 0x17, 0x16, 0x15, 0x10, 0x07, 0x16, 0x17, 0x16, 0x04, 0x01,
+  0x67, 0x89, 0xb2, 0x3e, 0xa7, 0x20, 0x56, 0xc6, 0x3b, 0x73, 0x68, 0x1d,
+  0x58, 0x4c, 0x3d, 0x69, 0x35, 0xe3, 0x36, 0x70, 0x43, 0x92, 0x2f, 0x39,
+  0x69, 0x01, 0x3c, 0x5e, 0x3f, 0x3a, 0xa8, 0x4f, 0xe0, 0x10, 0x4d, 0x15,
+  0x93, 0x49, 0x6a, 0xfe, 0xe4, 0x94, 0xc8, 0x90, 0x74, 0x8f, 0x67, 0x90,
+  0x60, 0x1b, 0x0d, 0x15, 0x15, 0x1f, 0x3c, 0x17, 0x1f, 0x23, 0x09, 0x0e,
+  0x1f, 0x2d, 0x51, 0x96, 0x58, 0x67, 0xf6, 0x7f, 0x4a, 0x4c, 0x01, 0xbe,
+  0xcf, 0x67, 0x88, 0x08, 0x82, 0x72, 0x0c, 0x0b, 0x02, 0x07, 0x25, 0xa7,
+  0x27, 0x1b, 0x2c, 0x61, 0x92, 0x7a, 0x51, 0x5e, 0x58, 0x52, 0x6a, 0xbd,
+  0x37, 0x19, 0xa6, 0x02, 0x26, 0x36, 0x8d, 0xee, 0x4a, 0xb4, 0x2d, 0x0d,
+  0x01, 0x83, 0xfe, 0x83, 0xde, 0x40, 0x18, 0x27, 0x12, 0x1b, 0x0a, 0x57,
+  0x05, 0x02, 0x6f, 0xca, 0x18, 0x57, 0x64, 0xa7, 0xfe, 0xfd, 0x45, 0x1e,
+  0x5c, 0x60, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51, 0xfe, 0x74, 0x03, 0x68,
+  0x06, 0x06, 0x00, 0x4f, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x23, 0x22, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x33, 0x32,
+  0x17, 0x15, 0x26, 0x23, 0x22, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x10,
+  0x33, 0x21, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x22, 0x23, 0x35,
+  0x32, 0x17, 0x32, 0x33, 0x20, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x35, 0x36, 0x37, 0x03, 0x33, 0x13, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x15, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x04, 0x15, 0x14, 0x07, 0x16,
+  0x17, 0x16, 0x03, 0x67, 0x6a, 0x62, 0x92, 0x3d, 0x97, 0x17, 0x48, 0x58,
+  0x1e, 0x23, 0x28, 0xa0, 0x29, 0x59, 0x4f, 0x35, 0x59, 0x2c, 0xbd, 0x2d,
+  0x5e, 0x39, 0x7b, 0xb0, 0x01, 0x0e, 0x51, 0x63, 0x46, 0x36, 0x66, 0x05,
+  0xa0, 0x0a, 0x1d, 0x1d, 0x13, 0x01, 0x16, 0x54, 0x41, 0x53, 0x82, 0xa6,
+  0x71, 0x5c, 0x8f, 0x68, 0x90, 0x5f, 0x2a, 0x13, 0x27, 0x49, 0x17, 0x20,
+  0x2d, 0x0e, 0x1e, 0x2e, 0x51, 0x01, 0x11, 0xd1, 0x64, 0x40, 0x48, 0x01,
+  0x52, 0x9e, 0x5e, 0x56, 0x08, 0x81, 0x61, 0x1b, 0x09, 0x24, 0x27, 0x8b,
+  0x22, 0x17, 0x25, 0x52, 0x97, 0x01, 0x0c, 0x60, 0x59, 0x4c, 0x38, 0x2b,
+  0x08, 0x98, 0x01, 0xa0, 0x51, 0x2a, 0x21, 0x37, 0xa7, 0x1f, 0x0b, 0x01,
+  0x83, 0xfe, 0x83, 0xde, 0x63, 0x17, 0x32, 0x0a, 0x57, 0x07, 0x6f, 0xca,
+  0x2f, 0xf2, 0xc4, 0x32, 0x16, 0x40, 0x49, 0x00, 0x00, 0x01, 0x00, 0x0e,
+  0x00, 0x00, 0x06, 0x15, 0x05, 0xd5, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x01, 0x23, 0x11, 0x23, 0x11, 0x23,
+  0x01, 0x33, 0x01, 0x33, 0x11, 0x33, 0x11, 0x33, 0x13, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x06, 0x14, 0x34, 0x17, 0x1c, 0x22, 0x1a, 0x3b, 0x36,
+  0xff, 0x00, 0xe1, 0xb6, 0xe1, 0xfe, 0x86, 0xb0, 0x01, 0x3b, 0x70, 0xb6,
+  0x71, 0xd0, 0x47, 0x5d, 0x3c, 0x74, 0x2e, 0x32, 0x05, 0x14, 0x07, 0x03,
+  0x19, 0x38, 0xa1, 0xfd, 0x0a, 0xfe, 0xca, 0x01, 0x36, 0x04, 0x60, 0xfc,
+  0x54, 0x03, 0xeb, 0xfc, 0x13, 0x02, 0x72, 0xd4, 0x50, 0x33, 0x10, 0x00,
+  0x00, 0x01, 0x00, 0x2d, 0xfe, 0x56, 0x06, 0x22, 0x06, 0x1e, 0x00, 0x1c,
+  0x00, 0x00, 0x01, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x01, 0x33, 0x01, 0x33, 0x11, 0x33, 0x11, 0x33,
+  0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x06, 0x22, 0x35, 0x16, 0x1d,
+  0x21, 0x1a, 0x3c, 0x36, 0xff, 0xe1, 0xa5, 0xe1, 0xfe, 0x86, 0xaf, 0x01,
+  0x3c, 0x70, 0xa5, 0x70, 0xd1, 0x46, 0x5e, 0x3b, 0x74, 0x2e, 0x33, 0x03,
+  0xde, 0x07, 0x03, 0x19, 0x38, 0xa1, 0xfd, 0x0a, 0xfe, 0x56, 0x01, 0xaa,
+  0x04, 0x60, 0xfc, 0x54, 0x05, 0x6a, 0xfa, 0x94, 0x02, 0x72, 0xd4, 0x50,
+  0x33, 0x10, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x05, 0xf0, 0x12, 0x06, 0x01, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x12, 0x06, 0x02, 0x37, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x8a, 0x05, 0xf0, 0x00, 0x12,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x07, 0x01, 0x23, 0x01, 0x33, 0x09, 0x01, 0x12, 0x36, 0x05, 0x18, 0x39,
+  0x39, 0x3e, 0x14, 0x16, 0x42, 0x1e, 0x40, 0x4c, 0xfe, 0xa8, 0xcf, 0xfd,
+  0xff, 0xbe, 0x01, 0xaa, 0x01, 0x19, 0x67, 0x9d, 0x05, 0xf0, 0x15, 0xbb,
+  0x0a, 0x04, 0x22, 0x43, 0xdd, 0xfc, 0x14, 0x05, 0xd5, 0xfb, 0x17, 0x03,
+  0x3d, 0x01, 0x32, 0x95, 0x00, 0x01, 0x00, 0x2d, 0x00, 0x00, 0x04, 0x9c,
+  0x04, 0x7b, 0x00, 0x13, 0x00, 0x00, 0x01, 0x32, 0x17, 0x15, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x07, 0x01, 0x23, 0x01, 0x33, 0x01, 0x13, 0x36,
+  0x37, 0x36, 0x04, 0x3c, 0x2e, 0x32, 0x34, 0x11, 0x23, 0x21, 0x1a, 0x3b,
+  0x36, 0xff, 0x00, 0xe1, 0xfe, 0x86, 0xaf, 0x01, 0x3c, 0xd0, 0x48, 0x5c,
+  0x3c, 0x04, 0x7b, 0x10, 0x8d, 0x07, 0x03, 0x19, 0x37, 0xa2, 0xfd, 0x0a,
+  0x04, 0x60, 0xfc, 0x54, 0x02, 0x70, 0xd5, 0x4f, 0x33, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x8a, 0x07, 0x70, 0x10, 0x27,
+  0x10, 0xf5, 0x04, 0x67, 0x01, 0x7a, 0x12, 0x06, 0x04, 0x08, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x2d, 0x00, 0x00, 0x04, 0x9c, 0x06, 0x66, 0x10, 0x27,
+  0x02, 0xc0, 0x04, 0x48, 0x00, 0x00, 0x12, 0x06, 0x04, 0x09, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x67, 0xfe, 0x56, 0x06, 0xee, 0x05, 0xf0, 0x00, 0x11,
+  0x00, 0x1e, 0x00, 0x2c, 0x00, 0x00, 0x09, 0x01, 0x06, 0x07, 0x06, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x13, 0x01, 0x33, 0x1b, 0x01,
+  0x01, 0x10, 0x07, 0x02, 0x20, 0x03, 0x26, 0x10, 0x37, 0x12, 0x20, 0x13,
+  0x16, 0x03, 0x10, 0x27, 0x26, 0x20, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x06, 0xee, 0xfe, 0x45, 0x4a, 0x3f, 0x42, 0x70, 0x84,
+  0x61, 0x44, 0x26, 0x22, 0x32, 0x6f, 0xfe, 0xc6, 0xaf, 0xe4, 0xe3, 0xfd,
+  0x86, 0x56, 0x71, 0xfe, 0x33, 0x72, 0x56, 0x56, 0x72, 0x01, 0xcd, 0x71,
+  0x56, 0xc0, 0x19, 0x32, 0xfe, 0xbc, 0x35, 0x19, 0x1a, 0x34, 0x01, 0x44,
+  0x33, 0x18, 0x04, 0x60, 0xfb, 0x38, 0xcb, 0x3a, 0x3d, 0x9a, 0x24, 0x21,
+  0x89, 0x01, 0x37, 0x03, 0x6b, 0xfd, 0x8a, 0x02, 0x76, 0xfe, 0x8a, 0xfe,
+  0xdd, 0xd0, 0xfe, 0xec, 0x01, 0x13, 0xd1, 0x02, 0x44, 0xd1, 0x01, 0x14,
+  0xfe, 0xed, 0xd1, 0xfe, 0xde, 0x01, 0x06, 0x72, 0xea, 0xea, 0x74, 0xfe,
+  0xfb, 0xfe, 0xfc, 0x74, 0xea, 0xea, 0x72, 0x00, 0x00, 0x03, 0x00, 0x65,
+  0xfe, 0x56, 0x06, 0x4c, 0x04, 0x7b, 0x00, 0x11, 0x00, 0x1f, 0x00, 0x25,
+  0x00, 0x00, 0x09, 0x01, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x37, 0x13, 0x01, 0x33, 0x1b, 0x01, 0x00, 0x10, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x02, 0x10,
+  0x23, 0x22, 0x10, 0x33, 0x06, 0x4c, 0xfe, 0x45, 0x4a, 0x3f, 0x42, 0x70,
+  0x84, 0x61, 0x44, 0x26, 0x22, 0x32, 0x6f, 0xfe, 0xc6, 0xaf, 0xe4, 0xe3,
+  0xfd, 0xb6, 0x55, 0x67, 0xb8, 0xba, 0x68, 0x56, 0x56, 0x68, 0xba, 0xb8,
+  0x67, 0x5a, 0xc5, 0xca, 0xca, 0x04, 0x60, 0xfb, 0x38, 0xcb, 0x3a, 0x3d,
+  0x9a, 0x24, 0x21, 0x89, 0x01, 0x37, 0x03, 0x6b, 0xfd, 0x8a, 0x02, 0x76,
+  0xfe, 0xab, 0xfe, 0x48, 0xa7, 0xc9, 0xc8, 0xa6, 0x01, 0xbc, 0xa6, 0xc8,
+  0xc9, 0xfc, 0xcd, 0x03, 0x60, 0xfc, 0xa0, 0x00, 0x00, 0x02, 0x00, 0x67,
+  0xff, 0xe3, 0x06, 0x76, 0x05, 0xf0, 0x00, 0x29, 0x00, 0x52, 0x00, 0x00,
+  0x25, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x07, 0x23, 0x20, 0x27, 0x26, 0x10,
+  0x37, 0x36, 0x21, 0x33, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x33, 0x20, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x21,
+  0x23, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03,
+  0xed, 0x1b, 0xd4, 0x66, 0x74, 0x74, 0x66, 0xd4, 0x1b, 0x0a, 0x0d, 0x14,
+  0x18, 0x18, 0x37, 0x18, 0x18, 0x14, 0x0e, 0x09, 0x2a, 0xd3, 0x67, 0x75,
+  0x75, 0x67, 0xd3, 0x2a, 0x09, 0x0e, 0x14, 0x18, 0x18, 0x37, 0x18, 0x18,
+  0x14, 0x0e, 0xe4, 0x2a, 0xfe, 0xc4, 0x88, 0xaa, 0xaa, 0x88, 0x01, 0x3c,
+  0x29, 0x0a, 0x0e, 0x14, 0x18, 0x18, 0x37, 0x18, 0x1c, 0x10, 0x0e, 0x0a,
+  0x1a, 0x01, 0x3b, 0x89, 0xa9, 0xa9, 0x89, 0xfe, 0xc5, 0x1a, 0x09, 0x0f,
+  0x14, 0x18, 0x18, 0x37, 0x18, 0x1c, 0x10, 0x0e, 0xc2, 0x91, 0xa4, 0xf2,
+  0xf3, 0xa4, 0x91, 0x14, 0x0e, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x10,
+  0x12, 0x91, 0xa4, 0xf3, 0xf2, 0xa4, 0x91, 0x12, 0x10, 0x15, 0x0c, 0x0b,
+  0x0b, 0x0c, 0x15, 0x10, 0xa1, 0xaa, 0xd2, 0x02, 0x74, 0xd3, 0xaa, 0x15,
+  0x0f, 0x15, 0x0c, 0x0b, 0x0b, 0x0e, 0x13, 0x11, 0x13, 0xaa, 0xd3, 0xfe,
+  0xc6, 0xfe, 0xc7, 0xd2, 0xab, 0x13, 0x11, 0x15, 0x0c, 0x0b, 0x0b, 0x0e,
+  0x13, 0x11, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x05, 0x11,
+  0x04, 0x7b, 0x00, 0x26, 0x00, 0x50, 0x00, 0x00, 0x25, 0x33, 0x32, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x06, 0x07, 0x0e, 0x01, 0x22,
+  0x26, 0x27, 0x26, 0x27, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x3b, 0x01, 0x36, 0x37, 0x3e, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x07,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0x1a, 0x28, 0x91, 0x41, 0x4d, 0x4d,
+  0x39, 0x99, 0x28, 0x06, 0x0a, 0x10, 0x27, 0x2f, 0x28, 0x10, 0x09, 0x06,
+  0x29, 0x92, 0x40, 0x4e, 0x4d, 0x41, 0x92, 0x29, 0x06, 0x09, 0x10, 0x28,
+  0x2f, 0x13, 0x19, 0x0b, 0x09, 0xb5, 0x2a, 0xe7, 0x6c, 0x7b, 0x7b, 0x68,
+  0xeb, 0x2a, 0x06, 0x08, 0x0c, 0x18, 0x14, 0x2f, 0x13, 0x19, 0x0b, 0x09,
+  0x06, 0x29, 0xe8, 0x6c, 0x7b, 0x7b, 0x69, 0xeb, 0x29, 0x06, 0x09, 0x0b,
+  0x19, 0x13, 0x2f, 0x14, 0x18, 0x0c, 0x08, 0xa4, 0x60, 0x74, 0xb7, 0xa7,
+  0x83, 0x61, 0x0b, 0x0a, 0x11, 0x14, 0x14, 0x11, 0x0a, 0x0b, 0x5f, 0x74,
+  0xb8, 0xbc, 0x70, 0x5f, 0x0b, 0x0a, 0x11, 0x14, 0x0a, 0x0c, 0x0f, 0x0a,
+  0x93, 0x89, 0x9c, 0xee, 0xe9, 0xa2, 0x88, 0x0a, 0x0a, 0x0f, 0x0c, 0x0a,
+  0x0a, 0x0c, 0x0f, 0x0a, 0x0a, 0x88, 0x9c, 0xef, 0xe8, 0xa2, 0x89, 0x0a,
+  0x0a, 0x0f, 0x0c, 0x0a, 0x0a, 0x0c, 0x0f, 0x0a, 0x00, 0x03, 0x00, 0x6a,
+  0xff, 0xe3, 0x08, 0x15, 0x07, 0x74, 0x00, 0x34, 0x00, 0x3d, 0x00, 0x4b,
+  0x00, 0x00, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x23, 0x22, 0x0f, 0x01, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x15, 0x10, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x11, 0x34,
+  0x27, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x01, 0x10, 0x23, 0x35, 0x16,
+  0x35, 0x23, 0x35, 0x33, 0x17, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
+  0x35, 0x36, 0x37, 0x36, 0x33, 0x20, 0x08, 0x14, 0x5c, 0x68, 0xd3, 0x51,
+  0x64, 0x57, 0x56, 0x6e, 0x6c, 0x6e, 0x6f, 0xae, 0x63, 0x52, 0xd3, 0x68,
+  0x5c, 0x3c, 0x40, 0x64, 0xe0, 0x71, 0x52, 0x4c, 0xe6, 0x7c, 0x54, 0x44,
+  0x44, 0x5c, 0x8d, 0x8b, 0x5a, 0x44, 0x43, 0x53, 0x7c, 0xe7, 0x4d, 0x52,
+  0x71, 0xe1, 0x64, 0x3f, 0x3c, 0xfc, 0xa2, 0xda, 0x79, 0x78, 0xd9, 0xe4,
+  0x6a, 0x15, 0x92, 0x54, 0x52, 0x84, 0x7a, 0x7d, 0x42, 0x6c, 0x70, 0x01,
+  0x07, 0x01, 0xfe, 0xf2, 0x8b, 0x9e, 0x44, 0x40, 0x40, 0x44, 0x44, 0x80,
+  0x44, 0x9d, 0x8b, 0xf2, 0xc6, 0xe2, 0xec, 0x98, 0x6b, 0xf3, 0xe2, 0xb6,
+  0xfe, 0xba, 0x36, 0x33, 0x33, 0x36, 0x36, 0x33, 0x33, 0x36, 0x01, 0x46,
+  0xb6, 0xe2, 0xf3, 0x6b, 0x98, 0xec, 0xe2, 0x03, 0x0a, 0xfe, 0xf5, 0x67,
+  0x03, 0x9d, 0x9e, 0x11, 0x9b, 0x2f, 0x4b, 0x17, 0x86, 0x27, 0x2a, 0x43,
+  0x00, 0x03, 0x00, 0x88, 0xff, 0xe3, 0x06, 0xde, 0x06, 0x10, 0x00, 0x21,
+  0x00, 0x2a, 0x00, 0x38, 0x00, 0x00, 0x01, 0x12, 0x11, 0x10, 0x21, 0x22,
+  0x24, 0x22, 0x04, 0x23, 0x20, 0x11, 0x10, 0x13, 0x33, 0x02, 0x15, 0x10,
+  0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x33,
+  0x32, 0x11, 0x34, 0x03, 0x25, 0x10, 0x23, 0x35, 0x16, 0x35, 0x23, 0x35,
+  0x33, 0x17, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37,
+  0x36, 0x33, 0x20, 0x06, 0x62, 0x7c, 0xfe, 0x9a, 0x4c, 0xfe, 0xf3, 0xd8,
+  0xfe, 0xf2, 0x4a, 0xfe, 0x9a, 0x7c, 0xb2, 0x83, 0xbb, 0x38, 0x41, 0x6c,
+  0x13, 0x5a, 0xe3, 0x5a, 0x12, 0x6d, 0x42, 0x39, 0xbb, 0x84, 0xfe, 0x7b,
+  0xd9, 0x78, 0x77, 0xd8, 0xe4, 0x6a, 0x15, 0x91, 0x54, 0x52, 0x84, 0x7b,
+  0x7d, 0x43, 0x6b, 0x70, 0x01, 0x07, 0x03, 0xc5, 0xfe, 0xe3, 0xfe, 0xeb,
+  0xfe, 0x50, 0xe2, 0xe2, 0x01, 0xb1, 0x01, 0x14, 0x01, 0x1d, 0xfe, 0xb9,
+  0xfa, 0xfe, 0xfb, 0x38, 0x5b, 0x0c, 0x37, 0x37, 0x0c, 0x5b, 0x38, 0x01,
+  0x07, 0xf8, 0x01, 0x47, 0xa4, 0xfe, 0xf5, 0x67, 0x03, 0x9d, 0x9e, 0x11,
+  0x9b, 0x2f, 0x4b, 0x17, 0x86, 0x27, 0x2a, 0x43, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x06, 0x52, 0x07, 0x33, 0x10, 0x27, 0x11, 0xb5, 0x00, 0x59,
+  0x01, 0x53, 0x10, 0x06, 0x03, 0xf4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x05, 0xe0, 0x10, 0x26, 0x11, 0xb5, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0xf5, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67,
+  0xfe, 0x56, 0x04, 0xa4, 0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x21, 0x23,
+  0x20, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x21, 0x32, 0x17, 0x16, 0x17,
+  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16,
+  0x33, 0x21, 0x11, 0x23, 0x03, 0x94, 0x9c, 0xfe, 0xc7, 0xa8, 0xaf, 0xaf,
+  0xaf, 0x01, 0x32, 0x78, 0x6a, 0x6c, 0x5d, 0x5c, 0x67, 0x69, 0x75, 0xe6,
+  0x7a, 0x7b, 0x7b, 0x88, 0xd8, 0x01, 0x47, 0xb5, 0xc6, 0xd0, 0x01, 0x53,
+  0x01, 0x68, 0xcf, 0xd0, 0x24, 0x23, 0x47, 0xd5, 0x5f, 0x2f, 0x2f, 0x9c,
+  0x9d, 0xfe, 0xd8, 0xfe, 0xd3, 0x82, 0x94, 0xfd, 0xb0, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x65, 0xfe, 0x56, 0x03, 0x84, 0x04, 0x7b, 0x00, 0x1d,
+  0x00, 0x00, 0x21, 0x22, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x3b, 0x01, 0x11, 0x23, 0x11, 0x02, 0x56, 0xeb, 0x7f,
+  0x86, 0x88, 0x87, 0xeb, 0x4d, 0x49, 0x49, 0x44, 0x46, 0x47, 0x46, 0x48,
+  0xa2, 0x59, 0x59, 0x59, 0x59, 0xa2, 0xdc, 0xb5, 0x96, 0x9f, 0xfa, 0x01,
+  0x12, 0x9d, 0x9d, 0x11, 0x12, 0x23, 0xac, 0x2b, 0x16, 0x15, 0x71, 0x72,
+  0xcd, 0xb9, 0x72, 0x71, 0xfd, 0xc3, 0x01, 0xaa, 0x00, 0x01, 0x00, 0x35,
+  0xff, 0xa5, 0x03, 0x69, 0x03, 0xa7, 0x00, 0x13, 0x00, 0x00, 0x01, 0x07,
+  0x27, 0x07, 0x17, 0x07, 0x27, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37,
+  0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x03, 0x69, 0x5a, 0xc2, 0x5f, 0xc2,
+  0x5a, 0xc2, 0x70, 0x9d, 0x71, 0xc3, 0x5a, 0xc3, 0x5e, 0xc2, 0x5a, 0xc2,
+  0x5e, 0x9d, 0x5e, 0x02, 0x11, 0xae, 0x7d, 0xb5, 0x7d, 0xae, 0x7d, 0xd8,
+  0x64, 0xd8, 0x7d, 0xae, 0x7d, 0xb5, 0x7d, 0xae, 0x7d, 0xb5, 0x64, 0xb5,
+  0x00, 0x01, 0xfc, 0x44, 0x04, 0xde, 0xff, 0x55, 0x06, 0x7a, 0x00, 0x2f,
+  0x00, 0x00, 0x01, 0x21, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x21, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0xfe, 0xda, 0xfe, 0x61, 0x09, 0x0a, 0x11, 0x12, 0x17, 0x15,
+  0x33, 0x15, 0x17, 0x12, 0x11, 0x0a, 0x09, 0x09, 0x0a, 0x11, 0x12, 0x17,
+  0x15, 0x1a, 0x01, 0x9e, 0x09, 0x0a, 0x11, 0x12, 0x17, 0x15, 0x33, 0x15,
+  0x17, 0x12, 0x12, 0x09, 0x09, 0x09, 0x0a, 0x11, 0x12, 0x17, 0x15, 0x05,
+  0x67, 0x1b, 0x19, 0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x0a, 0x0b, 0x13, 0x12,
+  0x1b, 0x19, 0x1b, 0x1c, 0x19, 0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x1b, 0x19,
+  0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x0a, 0x0b, 0x13, 0x15, 0x18, 0x19, 0x1c,
+  0x1b, 0x19, 0x1b, 0x12, 0x13, 0x0b, 0x0a, 0x00, 0x00, 0x01, 0xfd, 0x53,
+  0x05, 0x29, 0x00, 0x09, 0x06, 0x4d, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x23,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x20,
+  0x08, 0x6a, 0x15, 0x92, 0x53, 0x52, 0x84, 0x7b, 0x7d, 0x43, 0x6b, 0x70,
+  0x01, 0x07, 0x05, 0x29, 0x9b, 0x2f, 0x4b, 0x17, 0x86, 0x27, 0x2a, 0x43,
+  0x00, 0x01, 0xfd, 0xed, 0x04, 0xc2, 0xfe, 0xc8, 0x06, 0x61, 0x00, 0x08,
+  0x00, 0x00, 0x01, 0x22, 0x11, 0x35, 0x33, 0x15, 0x23, 0x14, 0x37, 0xfe,
+  0xc8, 0xda, 0xd9, 0x78, 0x79, 0x04, 0xc2, 0x01, 0x0b, 0x94, 0x9e, 0x9d,
+  0x03, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xed, 0x04, 0xc2, 0xfe, 0xc8,
+  0x06, 0x61, 0x00, 0x08, 0x00, 0x00, 0x01, 0x10, 0x23, 0x35, 0x16, 0x35,
+  0x23, 0x35, 0x33, 0xfe, 0xc8, 0xda, 0x78, 0x77, 0xd9, 0x05, 0xcd, 0xfe,
+  0xf5, 0x67, 0x03, 0x9d, 0x9e, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfa, 0x69,
+  0x04, 0xd9, 0x00, 0x09, 0x06, 0x4d, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x12,
+  0x21, 0x32, 0x05, 0x04, 0x25, 0x15, 0x24, 0x27, 0x24, 0x27, 0x26, 0x07,
+  0xfa, 0x69, 0x79, 0x01, 0x84, 0x67, 0x01, 0x25, 0x01, 0x13, 0x01, 0x03,
+  0xfe, 0x89, 0xd7, 0xfe, 0xf6, 0x5c, 0xc6, 0x89, 0x05, 0x01, 0x01, 0x4c,
+  0x7b, 0x74, 0x01, 0x86, 0x17, 0x5c, 0x71, 0x07, 0x0c, 0xcf, 0x00, 0x00,
+  0x00, 0x08, 0xf8, 0xa7, 0xfe, 0x90, 0x02, 0xf3, 0x07, 0x60, 0x00, 0x0c,
+  0x00, 0x19, 0x00, 0x26, 0x00, 0x33, 0x00, 0x40, 0x00, 0x4d, 0x00, 0x5a,
+  0x00, 0x67, 0x00, 0x00, 0x01, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07,
+  0x23, 0x3e, 0x01, 0x20, 0x16, 0x01, 0x23, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x05, 0x23, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x01, 0x23, 0x2e, 0x01, 0x23,
+  0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x05, 0x23, 0x2e, 0x01,
+  0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x01, 0x23, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x05, 0x23,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16, 0x01,
+  0x23, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x20, 0x16,
+  0xfe, 0xe6, 0x6a, 0x0a, 0x57, 0x4e, 0x4e, 0x56, 0x0c, 0x6a, 0x09, 0x8e,
+  0x01, 0x05, 0x8e, 0x02, 0xe6, 0x6a, 0x0a, 0x57, 0x4f, 0x4d, 0x57, 0x0b,
+  0x6a, 0x08, 0x8f, 0x01, 0x05, 0x8e, 0xfa, 0x50, 0x6a, 0x0a, 0x58, 0x4e,
+  0x4d, 0x57, 0x0c, 0x6a, 0x09, 0x8f, 0x01, 0x04, 0x8f, 0x05, 0xc2, 0x6a,
+  0x0a, 0x57, 0x4f, 0x4d, 0x57, 0x0b, 0x6a, 0x08, 0x8f, 0x01, 0x05, 0x8e,
+  0xfa, 0x50, 0x6a, 0x0a, 0x58, 0x4e, 0x4d, 0x57, 0x0c, 0x6a, 0x09, 0x8f,
+  0x01, 0x04, 0x8f, 0x06, 0xf1, 0x6a, 0x0a, 0x57, 0x4f, 0x4d, 0x56, 0x0c,
+  0x6a, 0x09, 0x8e, 0x01, 0x05, 0x8e, 0xf7, 0xf1, 0x6a, 0x0a, 0x57, 0x4e,
+  0x4e, 0x56, 0x0c, 0x6a, 0x09, 0x8e, 0x01, 0x05, 0x8e, 0x04, 0x15, 0x6a,
+  0x0a, 0x57, 0x4e, 0x4e, 0x56, 0x0c, 0x6a, 0x09, 0x8e, 0x01, 0x05, 0x8e,
+  0x06, 0x41, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0xfe, 0x51, 0x4b,
+  0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x8f, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f,
+  0x90, 0x90, 0xfa, 0x01, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x8f,
+  0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x02, 0x29, 0x4b, 0x4b, 0x4a,
+  0x4c, 0x8f, 0x90, 0x90, 0x8f, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90,
+  0xfb, 0x98, 0x4b, 0x4b, 0x4a, 0x4c, 0x8f, 0x90, 0x90, 0x00, 0x00, 0x00,
+  0x00, 0x08, 0xf9, 0x1c, 0xfd, 0xc3, 0x02, 0x7c, 0x08, 0x2d, 0x00, 0x05,
+  0x00, 0x0b, 0x00, 0x11, 0x00, 0x17, 0x00, 0x1d, 0x00, 0x23, 0x00, 0x29,
+  0x00, 0x2f, 0x00, 0x00, 0x27, 0x37, 0x17, 0x13, 0x07, 0x03, 0x01, 0x07,
+  0x27, 0x03, 0x37, 0x13, 0x01, 0x27, 0x37, 0x25, 0x17, 0x05, 0x01, 0x17,
+  0x07, 0x05, 0x27, 0x25, 0x01, 0x35, 0x33, 0x05, 0x15, 0x2d, 0x01, 0x15,
+  0x23, 0x25, 0x35, 0x05, 0x01, 0x23, 0x35, 0x13, 0x33, 0x0b, 0x01, 0x33,
+  0x15, 0x03, 0x23, 0x13, 0x60, 0x87, 0x6d, 0x64, 0x53, 0x98, 0xfb, 0xeb,
+  0x87, 0x6d, 0x64, 0x53, 0x98, 0x04, 0x9c, 0x87, 0x6e, 0x01, 0x33, 0x53,
+  0xff, 0x00, 0xfa, 0xde, 0x86, 0x6d, 0xfe, 0xcb, 0x52, 0x01, 0x00, 0x05,
+  0xbd, 0x9a, 0x01, 0x20, 0xfe, 0xe0, 0xf9, 0x7c, 0x9b, 0xfe, 0xe0, 0x01,
+  0x20, 0x03, 0xef, 0xbe, 0x94, 0x74, 0x4a, 0xbe, 0xbe, 0x93, 0x75, 0x4a,
+  0x5a, 0x96, 0x79, 0xfe, 0xa9, 0x5c, 0x01, 0x1d, 0x05, 0xb5, 0x96, 0x79,
+  0x01, 0x57, 0x5c, 0xfe, 0xe3, 0xfe, 0xf1, 0x95, 0x7a, 0x6e, 0x5b, 0xa9,
+  0xfb, 0x77, 0x96, 0x79, 0x6f, 0x5c, 0xa8, 0x02, 0x18, 0xd4, 0xa4, 0x82,
+  0x52, 0xd4, 0xd4, 0xa4, 0x82, 0x52, 0x02, 0xdf, 0xac, 0x01, 0x40, 0xfe,
+  0xc0, 0xf8, 0xc2, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x56, 0x05, 0x63, 0x07, 0x6d, 0x10, 0x26, 0x11, 0xb6, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf2, 0x04, 0x76, 0x01, 0x75, 0xff, 0xff, 0x00, 0xad,
+  0xfe, 0x56, 0x04, 0xb3, 0x06, 0x14, 0x10, 0x26, 0x11, 0xb7, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x9a, 0x00, 0x90, 0xff, 0xcc, 0x00, 0x02, 0x00, 0x1d,
+  0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00,
+  0x01, 0x15, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x21, 0x11, 0x23,
+  0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x01, 0x34, 0x27, 0x26, 0x23,
+  0x21, 0x11, 0x21, 0x32, 0x37, 0x36, 0x01, 0x6b, 0x01, 0x2c, 0xe2, 0xf5,
+  0xf5, 0xe2, 0xfe, 0x1e, 0x97, 0x97, 0xb6, 0x97, 0x01, 0xac, 0x47, 0x46,
+  0x93, 0xfe, 0xdd, 0x01, 0x23, 0x93, 0x46, 0x47, 0x04, 0x51, 0xe2, 0xda,
+  0xde, 0xdd, 0xda, 0x04, 0x51, 0xa4, 0xe0, 0xe0, 0xa4, 0xfd, 0x66, 0x8b,
+  0x44, 0x43, 0xfd, 0xdd, 0x44, 0x43, 0x00, 0x00, 0x00, 0x02, 0x00, 0x22,
+  0x00, 0x00, 0x03, 0xd8, 0x05, 0x9e, 0x00, 0x0a, 0x00, 0x1e, 0x00, 0x00,
+  0x01, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x33, 0x32, 0x37, 0x36, 0x01,
+  0x11, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x21, 0x11, 0x23,
+  0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0x03, 0x27, 0x37, 0x3d, 0x73,
+  0xed, 0xed, 0x74, 0x3c, 0x37, 0xfe, 0x2c, 0xf4, 0xbb, 0x6d, 0x69, 0x69,
+  0x67, 0xc1, 0xfe, 0x67, 0x8c, 0x8c, 0xa5, 0x8e, 0x01, 0x4c, 0x5e, 0x2a,
+  0x2e, 0xfe, 0x97, 0x2e, 0x2b, 0x02, 0xdf, 0xfe, 0xca, 0x55, 0x52, 0xfe,
+  0xb0, 0x52, 0x52, 0x03, 0xd1, 0x8f, 0x01, 0x3e, 0xfe, 0xc2, 0x8f, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x65, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x1c, 0x00, 0x00, 0x01, 0x17, 0x07, 0x27, 0x06, 0x2b, 0x01, 0x11,
+  0x23, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x27, 0x36, 0x37, 0x34,
+  0x26, 0x2b, 0x01, 0x11, 0x33, 0x32, 0x37, 0x27, 0x37, 0x03, 0xe6, 0x7e,
+  0x5f, 0x84, 0x71, 0xc1, 0xe4, 0xb6, 0x01, 0x9a, 0xe2, 0x73, 0x74, 0xcb,
+  0x0b, 0x01, 0x8b, 0x7f, 0xe4, 0xe4, 0x67, 0x40, 0xc2, 0x60, 0x03, 0x23,
+  0x75, 0x7e, 0x7b, 0x53, 0xfd, 0xa8, 0x05, 0xd5, 0x71, 0x72, 0xdb, 0x92,
+  0x2d, 0x2c, 0x39, 0x86, 0x92, 0xfd, 0xcf, 0x2f, 0xb4, 0x7e, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x10,
+  0x00, 0x29, 0x00, 0x00, 0x25, 0x27, 0x37, 0x17, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x20, 0x07, 0x06, 0x10, 0x17, 0x16, 0x33, 0x32, 0x1f, 0x01, 0x07,
+  0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x11, 0x23, 0x11, 0x33, 0x15,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x02, 0xd9,
+  0x7e, 0x63, 0x7c, 0x47, 0x4a, 0x4c, 0xfe, 0xf9, 0x4b, 0x4b, 0x4b, 0x4b,
+  0x84, 0x3f, 0xfe, 0x85, 0x64, 0x86, 0x4f, 0x61, 0x6f, 0x4f, 0x50, 0x34,
+  0xa7, 0xa7, 0x34, 0x50, 0x4f, 0x6f, 0xb8, 0x72, 0x73, 0x73, 0x0b, 0x98,
+  0xa7, 0x5d, 0xa5, 0x73, 0xc5, 0xcb, 0x74, 0x73, 0x74, 0x73, 0xfe, 0x6a,
+  0x74, 0x73, 0x14, 0xae, 0x5d, 0xb3, 0x2e, 0x30, 0x31, 0x64, 0xfd, 0xae,
+  0x06, 0x0a, 0xaa, 0x64, 0x30, 0x31, 0xa2, 0xa2, 0xfd, 0xf0, 0xa2, 0x0f,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x07, 0x07, 0x00, 0x07,
+  0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0xb5, 0x02,
+  0xab, 0x99, 0xfd, 0x72, 0x05, 0xd5, 0x01, 0x32, 0xfe, 0x24, 0xfa, 0xd5,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x6f, 0x05, 0x9a, 0x00, 0x07,
+  0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0xa7, 0x02,
+  0x43, 0x84, 0xfd, 0xdf, 0x04, 0x60, 0x01, 0x3a, 0xfe, 0x33, 0xfc, 0x33,
+  0x00, 0x01, 0x00, 0x3f, 0x00, 0x00, 0x04, 0x71, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x21, 0x11, 0x23, 0x35, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x01, 0x2d, 0xed, 0xed, 0x03, 0x44, 0xfd, 0x71,
+  0x01, 0xed, 0xfe, 0x13, 0x02, 0x94, 0xaa, 0x02, 0x97, 0xaa, 0xfe, 0x13,
+  0xaa, 0xfd, 0x6c, 0x00, 0x00, 0x01, 0x00, 0x32, 0x00, 0x00, 0x03, 0xe7,
+  0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x21, 0x11, 0x23, 0x35, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x1f, 0xed, 0xed,
+  0x02, 0xc7, 0xfd, 0xdf, 0x01, 0x76, 0xfe, 0x8a, 0x01, 0xf4, 0xaa, 0x01,
+  0xc2, 0x9d, 0xfe, 0xdb, 0xaa, 0xfe, 0x0c, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0xfe, 0x66, 0x04, 0x52, 0x05, 0xd5, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11,
+  0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34,
+  0x26, 0x23, 0x01, 0x6b, 0xb6, 0x03, 0x44, 0xfd, 0x72, 0x01, 0x77, 0xa7,
+  0x66, 0x62, 0xb7, 0xce, 0x44, 0x38, 0x78, 0x33, 0x31, 0x6f, 0x70, 0x02,
+  0xc7, 0xfd, 0x39, 0x05, 0xd5, 0xaa, 0xfe, 0x46, 0x77, 0x72, 0xee, 0xfe,
+  0xce, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b, 0xc2, 0x01, 0x22, 0x9f, 0x9e,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xa4, 0x04, 0x60, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x32,
+  0x17, 0x16, 0x15, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x11, 0x34, 0x27, 0x26, 0x23, 0x01, 0x4d, 0xa6, 0x02,
+  0xc7, 0xfd, 0xdf, 0xe1, 0xed, 0x3f, 0x4a, 0x4a, 0x49, 0xa3, 0xae, 0x9b,
+  0x63, 0x1e, 0x22, 0x22, 0x2c, 0x79, 0x01, 0xe7, 0xfe, 0x19, 0x04, 0x60,
+  0xaa, 0xfe, 0xc1, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd6, 0x60, 0x60, 0x9c,
+  0x30, 0x37, 0x93, 0x01, 0x08, 0xaa, 0x20, 0x29, 0x00, 0x01, 0x00, 0x24,
+  0xfe, 0xbf, 0x07, 0xb6, 0x05, 0xd5, 0x00, 0x17, 0x00, 0x00, 0x01, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x03,
+  0x11, 0x23, 0x11, 0x03, 0x01, 0x23, 0x09, 0x01, 0x33, 0x01, 0x03, 0x86,
+  0xb6, 0x02, 0x65, 0xdd, 0xfe, 0x15, 0x01, 0xa8, 0x7b, 0xb2, 0x24, 0xfe,
+  0x44, 0xe8, 0xb6, 0xe8, 0xfe, 0x44, 0xbe, 0x02, 0x0a, 0xfe, 0x16, 0xdc,
+  0x02, 0x66, 0x05, 0xd5, 0xfd, 0x1e, 0x02, 0xe2, 0xfd, 0xb3, 0xfd, 0x22,
+  0xfe, 0x15, 0x01, 0x41, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x01, 0xea,
+  0x01, 0x17, 0xfc, 0xff, 0x03, 0x88, 0x02, 0x4d, 0xfd, 0x1e, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x3f, 0xfe, 0xe5, 0x06, 0x50, 0x04, 0x60, 0x00, 0x17,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23,
+  0x11, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x27, 0x01, 0x23, 0x09, 0x01,
+  0x33, 0x01, 0x02, 0xec, 0xa5, 0x01, 0xb8, 0xc0, 0xfe, 0x97, 0x01, 0x42,
+  0x6e, 0xa6, 0x1e, 0xfe, 0xad, 0xa8, 0xa5, 0xa8, 0xfe, 0xac, 0xb1, 0x01,
+  0x9e, 0xfe, 0x96, 0xc1, 0x01, 0xb8, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e,
+  0xfe, 0x51, 0xfd, 0xe8, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x36, 0xc9, 0xfe,
+  0x93, 0x01, 0x6d, 0xc9, 0xfd, 0xca, 0x02, 0xb1, 0x01, 0xaf, 0xfd, 0xf2,
+  0xff, 0xff, 0x00, 0x79, 0xfe, 0x75, 0x04, 0x25, 0x05, 0xf0, 0x10, 0x26,
+  0x00, 0x7a, 0x33, 0x00, 0x12, 0x06, 0x03, 0xab, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x77, 0xfe, 0x75, 0x03, 0x68, 0x04, 0x7c, 0x10, 0x26,
+  0x00, 0x7a, 0xd3, 0x00, 0x12, 0x06, 0x03, 0xcb, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x22, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23,
+  0x11, 0x23, 0x01, 0x03, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x89, 0xea, 0xfd,
+  0xf8, 0x01, 0xbc, 0x90, 0xb1, 0x3e, 0xfe, 0x2d, 0xf5, 0xb6, 0x05, 0xd5,
+  0xfd, 0x1e, 0x02, 0xe2, 0xfd, 0xb2, 0xfd, 0x23, 0xfe, 0x15, 0x01, 0x41,
+  0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xfe, 0xe5, 0x04, 0x3b, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x07,
+  0x11, 0x23, 0xa7, 0xa5, 0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0x52, 0x80,
+  0xa6, 0x32, 0xfe, 0x9a, 0xb1, 0xa5, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e,
+  0xfe, 0x4f, 0xfd, 0xea, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x35, 0xc8, 0xfe,
+  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xf9,
+  0x05, 0xd5, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33, 0x11, 0x37, 0x11, 0x33,
+  0x15, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x11, 0x07, 0x11,
+  0x23, 0xb5, 0xb6, 0x9b, 0x5a, 0x01, 0x94, 0xea, 0xfd, 0xf8, 0x02, 0x23,
+  0xc6, 0xfe, 0x2d, 0x5a, 0x9b, 0xb6, 0x05, 0xd5, 0xfd, 0x1e, 0xb1, 0x01,
+  0x54, 0xee, 0x01, 0xcb, 0xfd, 0xb2, 0xfc, 0x79, 0x03, 0x01, 0xfe, 0x25,
+  0x01, 0x75, 0xb1, 0xfe, 0x16, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x1d, 0x04, 0x60, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x37, 0x35, 0x33, 0x15, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
+  0x23, 0x35, 0x07, 0x11, 0x23, 0xa7, 0xa5, 0x56, 0x5b, 0x01, 0x22, 0xcc,
+  0xfe, 0x7e, 0x01, 0xb3, 0xb9, 0xfe, 0x9a, 0x5b, 0x56, 0xa5, 0x04, 0x60,
+  0xfd, 0xf2, 0x61, 0xdd, 0x76, 0x01, 0x46, 0xfe, 0x4f, 0xfd, 0x51, 0x02,
+  0x35, 0xfe, 0xc5, 0xd4, 0x61, 0xfe, 0x93, 0x00, 0x00, 0x01, 0x00, 0x1d,
+  0x00, 0x00, 0x04, 0xf9, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
+  0x15, 0x33, 0x15, 0x23, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x03,
+  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0x97, 0x97, 0x02, 0x89,
+  0xea, 0xfd, 0xf8, 0x02, 0x23, 0xc6, 0xfe, 0x2d, 0xf5, 0xb6, 0x97, 0x97,
+  0x05, 0xd5, 0xe0, 0x90, 0xfe, 0x8e, 0x02, 0xe2, 0xfd, 0xb2, 0xfc, 0x79,
+  0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x04, 0x65, 0x90, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0x1d, 0x06, 0x14, 0x00, 0x13,
+  0x00, 0x00, 0x13, 0x33, 0x15, 0x21, 0x15, 0x21, 0x11, 0x01, 0x33, 0x09,
+  0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xa7, 0xa5,
+  0x01, 0x40, 0xfe, 0xc0, 0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0xb3, 0xb9,
+  0xfe, 0x9a, 0xb1, 0xa5, 0x70, 0x70, 0x06, 0x14, 0x7a, 0x7d, 0xfd, 0x35,
+  0x02, 0x0e, 0xfe, 0x4f, 0xfd, 0x51, 0x02, 0x35, 0xc8, 0xfe, 0x93, 0x05,
+  0x1d, 0x7d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2d, 0x00, 0x00, 0x06, 0x07,
+  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x21, 0x11, 0x01, 0x33, 0x09,
+  0x01, 0x23, 0x01, 0x03, 0x11, 0x23, 0x11, 0x21, 0x2d, 0x02, 0x4c, 0x02,
+  0x89, 0xea, 0xfd, 0xf8, 0x02, 0x23, 0xc6, 0xfe, 0x2d, 0xf5, 0xb6, 0xfe,
+  0x6a, 0x05, 0xd5, 0xfd, 0x1e, 0x02, 0xe2, 0xfd, 0xb2, 0xfc, 0x79, 0x03,
+  0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x05, 0x2b, 0x00, 0x00, 0x01, 0x00, 0x25,
+  0x00, 0x00, 0x04, 0xf5, 0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x21,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23, 0x11, 0x21,
+  0x26, 0x01, 0xff, 0x01, 0xd3, 0xcc, 0xfe, 0x7e, 0x01, 0xb3, 0xb9, 0xfe,
+  0x9a, 0xb1, 0xa5, 0xfe, 0xa6, 0x04, 0x60, 0xfd, 0xf2, 0x02, 0x0e, 0xfe,
+  0x4f, 0xfd, 0x51, 0x02, 0x35, 0xc8, 0xfe, 0x93, 0x03, 0xc6, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x6a, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23,
+  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x94, 0xb6, 0xb5,
+  0xb5, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfa,
+  0xd5, 0xfe, 0x15, 0x01, 0x41, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0xfe, 0xe5, 0x04, 0xba, 0x04, 0x60, 0x00, 0x0f,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23,
+  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0xae, 0xa5, 0x02, 0x1b, 0xa6, 0xa6,
+  0xa6, 0xa6, 0xfd, 0xe5, 0xa5, 0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0xfc,
+  0x39, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x04, 0xfd, 0xfc, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x07, 0x44, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x94, 0x03, 0x44, 0xfd, 0x72,
+  0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xaa, 0xfa,
+  0xd5, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad,
+  0x00, 0x00, 0x06, 0x36, 0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23,
+  0xae, 0xa5, 0x02, 0x1b, 0x02, 0xc7, 0xfd, 0xdf, 0xa6, 0xfd, 0xe5, 0xa5,
+  0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0xaa, 0xfc, 0x4a, 0x02, 0x04, 0xfd,
+  0xfc, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x07, 0x9c,
+  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x21, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23,
+  0x04, 0xb5, 0xb6, 0xfd, 0x6c, 0xb6, 0x04, 0x00, 0x01, 0x77, 0xa8, 0x66,
+  0x62, 0xb8, 0xcd, 0x45, 0x38, 0x79, 0x32, 0x32, 0x70, 0x6f, 0x02, 0xc7,
+  0xfd, 0x39, 0x05, 0x2b, 0xfa, 0xd5, 0x05, 0xd5, 0xfd, 0x9c, 0x77, 0x72,
+  0xee, 0xfe, 0xce, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b, 0xc2, 0x01, 0x22,
+  0x9f, 0x9e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x06, 0x6b,
+  0x04, 0x60, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x21, 0x11, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x14, 0x07,
+  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x27,
+  0x26, 0x07, 0x04, 0x14, 0xa6, 0xfd, 0xe5, 0xa5, 0x03, 0x66, 0xe1, 0xed,
+  0x3f, 0x49, 0x49, 0x49, 0xa3, 0xae, 0x9b, 0x63, 0x1e, 0x22, 0x22, 0x2c,
+  0x79, 0x01, 0xe7, 0xfe, 0x19, 0x03, 0xc6, 0xfc, 0x3a, 0x04, 0x60, 0xfe,
+  0x17, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x37,
+  0x93, 0x01, 0x08, 0xa4, 0x26, 0x2e, 0x05, 0x00, 0x00, 0x02, 0x00, 0x67,
+  0xff, 0xe3, 0x06, 0x45, 0x05, 0xf1, 0x00, 0x41, 0x00, 0x59, 0x00, 0x00,
+  0x25, 0x2e, 0x03, 0x35, 0x34, 0x3e, 0x04, 0x33, 0x32, 0x1e, 0x04, 0x15,
+  0x14, 0x0e, 0x02, 0x07, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
+  0x01, 0x23, 0x22, 0x2e, 0x02, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01,
+  0x02, 0x35, 0x34, 0x12, 0x3e, 0x01, 0x37, 0x15, 0x0e, 0x03, 0x15, 0x14,
+  0x1e, 0x02, 0x33, 0x32, 0x36, 0x37, 0x3e, 0x03, 0x35, 0x34, 0x2e, 0x04,
+  0x23, 0x22, 0x0e, 0x04, 0x15, 0x14, 0x1e, 0x02, 0x03, 0xc0, 0x33, 0x61,
+  0x4a, 0x2d, 0x11, 0x26, 0x3d, 0x57, 0x74, 0x4b, 0x46, 0x71, 0x57, 0x3f,
+  0x29, 0x13, 0x18, 0x38, 0x60, 0x49, 0x22, 0x5e, 0x35, 0x38, 0x5b, 0x2e,
+  0x2a, 0x6c, 0x37, 0x22, 0x49, 0x4c, 0x4f, 0x26, 0x3c, 0xaf, 0x6d, 0x99,
+  0xf1, 0xa9, 0x59, 0x51, 0x9b, 0xde, 0x8e, 0x68, 0x9a, 0x64, 0x33, 0x36,
+  0x6f, 0xab, 0x74, 0x4a, 0x73, 0x9f, 0x39, 0x4b, 0x2b, 0x12, 0x0a, 0x15,
+  0x20, 0x2b, 0x38, 0x22, 0x2c, 0x41, 0x2e, 0x1e, 0x10, 0x06, 0x24, 0x3b,
+  0x4c, 0xae, 0x31, 0x89, 0xaa, 0xc4, 0x6b, 0x42, 0x8a, 0x83, 0x74, 0x57,
+  0x32, 0x32, 0x54, 0x70, 0x7b, 0x7f, 0x3a, 0x53, 0xb4, 0xb2, 0xaa, 0x4a,
+  0x1a, 0x15, 0x13, 0x1a, 0xa8, 0x17, 0x12, 0x08, 0x14, 0x23, 0x1b, 0x26,
+  0x34, 0x74, 0xcf, 0x01, 0x1d, 0xa8, 0xa0, 0x01, 0x10, 0xcb, 0x7d, 0x0e,
+  0xa7, 0x16, 0x66, 0x9a, 0xcd, 0x7c, 0x7d, 0xde, 0xa7, 0x62, 0x19, 0x6d,
+  0x3a, 0x86, 0x8e, 0x91, 0x45, 0x2f, 0x66, 0x63, 0x59, 0x43, 0x28, 0x2b,
+  0x47, 0x5b, 0x60, 0x5f, 0x26, 0x62, 0xab, 0x8e, 0x6e, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0xec, 0x04, 0x7a, 0x00, 0x3f,
+  0x00, 0x50, 0x00, 0x00, 0x13, 0x34, 0x3e, 0x02, 0x37, 0x15, 0x0e, 0x03,
+  0x15, 0x14, 0x1e, 0x02, 0x33, 0x32, 0x36, 0x37, 0x2e, 0x03, 0x35, 0x34,
+  0x3e, 0x02, 0x33, 0x32, 0x1e, 0x02, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01,
+  0x33, 0x32, 0x3e, 0x02, 0x37, 0x15, 0x0e, 0x03, 0x23, 0x22, 0x26, 0x27,
+  0x0e, 0x03, 0x23, 0x22, 0x2e, 0x02, 0x05, 0x3e, 0x03, 0x35, 0x34, 0x2e,
+  0x02, 0x23, 0x22, 0x0e, 0x02, 0x15, 0x14, 0x66, 0x43, 0x81, 0xbc, 0x79,
+  0x54, 0x7c, 0x52, 0x29, 0x2d, 0x57, 0x7c, 0x4f, 0x23, 0x4e, 0x19, 0x21,
+  0x38, 0x2b, 0x18, 0x24, 0x48, 0x69, 0x45, 0x3b, 0x65, 0x48, 0x29, 0x53,
+  0x56, 0x20, 0x3d, 0x1b, 0x18, 0x29, 0x25, 0x25, 0x16, 0x0f, 0x22, 0x28,
+  0x33, 0x21, 0x31, 0x75, 0x3d, 0x1b, 0x3f, 0x41, 0x40, 0x1c, 0x7a, 0xbe,
+  0x83, 0x44, 0x03, 0x00, 0x1f, 0x28, 0x18, 0x0a, 0x14, 0x1e, 0x24, 0x10,
+  0x17, 0x28, 0x1e, 0x11, 0x02, 0x28, 0x83, 0xd8, 0x9c, 0x58, 0x03, 0x9b,
+  0x06, 0x46, 0x72, 0x98, 0x58, 0x62, 0xa0, 0x72, 0x3e, 0x0b, 0x11, 0x25,
+  0x67, 0x78, 0x82, 0x40, 0x5d, 0x9f, 0x73, 0x41, 0x39, 0x68, 0x92, 0x59,
+  0x9b, 0xf1, 0x5e, 0x13, 0x0a, 0x04, 0x0a, 0x13, 0x0f, 0x9d, 0x0a, 0x11,
+  0x0c, 0x07, 0x1c, 0x2c, 0x12, 0x1b, 0x12, 0x09, 0x54, 0x99, 0xd6, 0xb8,
+  0x26, 0x5e, 0x64, 0x63, 0x2b, 0x4b, 0x69, 0x42, 0x1f, 0x26, 0x48, 0x69,
+  0x43, 0xf7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xfe, 0x75, 0x04, 0xa4,
+  0x05, 0xf0, 0x10, 0x27, 0x00, 0x7a, 0x01, 0x0f, 0x00, 0x00, 0x12, 0x06,
+  0x03, 0xb5, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x03, 0x84,
+  0x04, 0x7b, 0x10, 0x27, 0x00, 0x7a, 0x00, 0x81, 0x00, 0x00, 0x12, 0x06,
+  0x03, 0xd5, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0xfe, 0xbf, 0x04, 0x6c,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23,
+  0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x02, 0x8e, 0xb5, 0xb5, 0xb6, 0xfe,
+  0x23, 0x04, 0x70, 0xfe, 0x23, 0xaa, 0xfe, 0x15, 0x01, 0x41, 0x05, 0x2b,
+  0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36, 0xfe, 0xe5, 0x03, 0xfc,
+  0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23,
+  0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x02, 0x6a, 0xa6, 0xa6, 0xa3, 0xfe,
+  0x6f, 0x03, 0xc6, 0xfe, 0x6e, 0x99, 0xfe, 0x4c, 0x01, 0x1b, 0x03, 0xb6,
+  0xaa, 0xaa, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0xfe, 0x56, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x08, 0x00, 0x00, 0x25, 0x11,
+  0x23, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x02, 0x7e, 0xaf, 0xfe, 0x68,
+  0xaf, 0x01, 0x3b, 0x01, 0x3b, 0xb0, 0x12, 0xfe, 0x44, 0x01, 0xbc, 0x04,
+  0x4e, 0xfc, 0x94, 0x03, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfc,
+  0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x00, 0x10, 0x00, 0x00, 0x01, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x01, 0x33, 0x09, 0x01, 0x33,
+  0x01, 0x15, 0x33, 0x03, 0x7c, 0xee, 0xb6, 0xed, 0xed, 0xfe, 0x24, 0xc4,
+  0x01, 0x74, 0x01, 0x72, 0xc4, 0xfe, 0x24, 0xee, 0x01, 0x73, 0xfe, 0x8d,
+  0x01, 0x73, 0xaa, 0xaa, 0x03, 0x0e, 0xfd, 0x9a, 0x02, 0x66, 0xfc, 0xf2,
+  0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x04, 0x60, 0x00, 0x10, 0x00, 0x00, 0x09, 0x01, 0x15, 0x33, 0x15, 0x23,
+  0x15, 0x23, 0x35, 0x23, 0x35, 0x33, 0x35, 0x01, 0x33, 0x09, 0x01, 0x04,
+  0x0c, 0xfe, 0x72, 0xec, 0xec, 0xaf, 0xf6, 0xf6, 0xfe, 0x68, 0xaf, 0x01,
+  0x3b, 0x01, 0x3b, 0x04, 0x60, 0xfb, 0xb2, 0x58, 0xaa, 0xba, 0xba, 0xaa,
+  0x58, 0x04, 0x4e, 0xfc, 0x94, 0x03, 0x6c, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0xfe, 0xbf, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x33,
+  0x11, 0x23, 0x11, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01,
+  0x33, 0x01, 0x04, 0x50, 0x65, 0xb1, 0x12, 0xfe, 0x86, 0xfe, 0x83, 0xc4,
+  0x01, 0xe0, 0xfe, 0x5d, 0xc3, 0x01, 0x4e, 0x01, 0x50, 0xc3, 0xfe, 0x50,
+  0xaa, 0xfe, 0x15, 0x01, 0x41, 0x02, 0x7b, 0xfd, 0x85, 0x03, 0x1d, 0x02,
+  0xb8, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x33, 0x00, 0x00, 0x01, 0x00, 0x35,
+  0xfe, 0xe5, 0x04, 0x07, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x33,
+  0x11, 0x23, 0x11, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01,
+  0x33, 0x01, 0x03, 0xa1, 0x65, 0xa5, 0x1e, 0xfe, 0xdb, 0xfe, 0xda, 0xc3,
+  0x01, 0x88, 0xfe, 0x99, 0xc4, 0x01, 0x0b, 0x01, 0x0b, 0xc4, 0xfe, 0x93,
+  0x99, 0xfe, 0x4c, 0x01, 0x1b, 0x01, 0xb8, 0xfe, 0x48, 0x02, 0x4a, 0x02,
+  0x16, 0xfe, 0x71, 0x01, 0x8f, 0xfd, 0xdf, 0x00, 0x00, 0x01, 0xff, 0xfa,
+  0xfe, 0xbf, 0x06, 0x8d, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21,
+  0x15, 0x21, 0x02, 0x8d, 0x02, 0x95, 0xb6, 0xb5, 0xb5, 0xfc, 0x00, 0xfe,
+  0x23, 0x04, 0x70, 0xfe, 0x23, 0xaa, 0x05, 0x2b, 0xfa, 0xd5, 0xfe, 0x15,
+  0x01, 0x41, 0x05, 0x2b, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x04,
+  0xfe, 0xe5, 0x05, 0xa2, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21,
+  0x15, 0x21, 0x02, 0x39, 0x02, 0x1e, 0xa5, 0xa6, 0xa6, 0xfc, 0x9a, 0xfe,
+  0x6e, 0x03, 0xc6, 0xfe, 0x6f, 0x99, 0x03, 0xc7, 0xfc, 0x39, 0xfe, 0x4c,
+  0x01, 0x1b, 0x03, 0xb6, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0xfe, 0xbf, 0x04, 0xf0, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x25, 0x33,
+  0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33,
+  0x11, 0x14, 0x16, 0x33, 0x21, 0x11, 0x33, 0x04, 0x3b, 0xb5, 0xb5, 0xb7,
+  0xfe, 0x89, 0xa8, 0x65, 0x62, 0xb4, 0x70, 0x70, 0x01, 0x52, 0xb7, 0xaa,
+  0xfe, 0x15, 0x01, 0x41, 0x02, 0xc7, 0x77, 0x72, 0xee, 0x01, 0x37, 0xfe,
+  0xd9, 0x9f, 0x9e, 0x02, 0x64, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87,
+  0xfe, 0xe5, 0x04, 0x40, 0x04, 0x60, 0x00, 0x15, 0x00, 0x00, 0x25, 0x33,
+  0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x33,
+  0x15, 0x14, 0x17, 0x16, 0x33, 0x21, 0x11, 0x33, 0x03, 0x9a, 0xa5, 0xa5,
+  0xa6, 0xfe, 0xcb, 0x89, 0x5c, 0x53, 0xa6, 0x2e, 0x30, 0x5e, 0x01, 0x0b,
+  0xa6, 0x99, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x09, 0x5f, 0x56, 0xb8, 0xea,
+  0xd3, 0x75, 0x3b, 0x3b, 0x01, 0xbe, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0x00, 0x00, 0x04, 0x3b, 0x05, 0xd5, 0x00, 0x18, 0x00, 0x00, 0x01, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x11,
+  0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x02,
+  0x42, 0x35, 0xa8, 0x65, 0x62, 0xb4, 0x70, 0x70, 0x10, 0x81, 0xc1, 0xb7,
+  0xb7, 0xc1, 0x81, 0x02, 0xc7, 0x77, 0x72, 0xee, 0x01, 0x37, 0xfe, 0xd9,
+  0x9f, 0x9e, 0x01, 0x39, 0xfe, 0xc7, 0x02, 0x64, 0xfa, 0x2b, 0x02, 0xc7,
+  0xfe, 0xcf, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0x9a,
+  0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x33, 0x11,
+  0x33, 0x11, 0x23, 0x11, 0x23, 0x15, 0x23, 0x35, 0x23, 0x22, 0x27, 0x26,
+  0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x01, 0xc6, 0x90, 0x9e, 0xa6,
+  0xa6, 0x9e, 0x90, 0x07, 0x89, 0x5c, 0x53, 0xa6, 0x2e, 0x27, 0x02, 0xa4,
+  0xc2, 0xc4, 0x01, 0xbe, 0xfb, 0xa0, 0x02, 0x09, 0xc4, 0xc4, 0x5f, 0x56,
+  0xb8, 0xea, 0xd3, 0x75, 0x3b, 0x30, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0x00, 0x00, 0x04, 0x3b, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11,
+  0x23, 0x11, 0x01, 0x54, 0x01, 0x78, 0xa7, 0xc8, 0xb5, 0x70, 0x6f, 0xfe,
+  0xad, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0xe9, 0xee, 0xfe, 0x66, 0x01, 0x8a,
+  0x9f, 0x9e, 0xfd, 0x39, 0x05, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x12, 0xff, 0xe3, 0x06, 0x5f, 0x05, 0xf0, 0x00, 0x22,
+  0x00, 0x2a, 0x00, 0x00, 0x01, 0x12, 0x37, 0x36, 0x21, 0x20, 0x17, 0x16,
+  0x13, 0x21, 0x10, 0x12, 0x33, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06,
+  0x23, 0x20, 0x27, 0x26, 0x03, 0x06, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15,
+  0x14, 0x17, 0x16, 0x25, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x01,
+  0x87, 0x1e, 0x87, 0xa9, 0x01, 0x1b, 0x01, 0x23, 0xa3, 0xa8, 0x01, 0xfb,
+  0xe5, 0xf6, 0xf7, 0x7d, 0xe3, 0x65, 0x64, 0x76, 0x77, 0x83, 0xfe, 0xc4,
+  0xb1, 0xa9, 0x09, 0x99, 0x6a, 0x6e, 0x99, 0x43, 0x3c, 0x01, 0x20, 0x03,
+  0x4f, 0x16, 0x58, 0x75, 0xfe, 0x74, 0x73, 0x57, 0x03, 0x6d, 0x01, 0x0a,
+  0xa7, 0xd2, 0xd2, 0xdb, 0xfe, 0x84, 0xfe, 0xf4, 0xfe, 0xce, 0x60, 0x5f,
+  0xd7, 0x46, 0x24, 0x24, 0xcd, 0xc2, 0x01, 0x55, 0x01, 0x67, 0x6b, 0xdf,
+  0x4c, 0x3e, 0xa0, 0x41, 0x39, 0x02, 0xbf, 0x7c, 0xa4, 0xa4, 0x7c, 0x00,
+  0x00, 0x02, 0x00, 0x0d, 0xff, 0xe3, 0x04, 0xdc, 0x04, 0x7b, 0x00, 0x25,
+  0x00, 0x2e, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1d,
+  0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x01, 0x36, 0x82, 0x50, 0x56, 0x8c, 0x2b, 0x33, 0x43,
+  0x17, 0x69, 0x83, 0xe6, 0xcb, 0x76, 0x77, 0xfd, 0x06, 0x0b, 0x5c, 0x5d,
+  0xa4, 0x60, 0x5a, 0x59, 0x58, 0x5d, 0x5a, 0x63, 0x5b, 0xf2, 0x8c, 0x85,
+  0x02, 0xf9, 0x02, 0x49, 0x4b, 0x7a, 0x8b, 0x54, 0x53, 0x0c, 0x02, 0x04,
+  0x52, 0x5a, 0xac, 0x46, 0x31, 0x97, 0x21, 0x26, 0xc5, 0x82, 0xa1, 0x91,
+  0x92, 0xfa, 0x5a, 0xbe, 0x64, 0x63, 0x1a, 0x1a, 0x34, 0xae, 0x2c, 0x14,
+  0x16, 0x9c, 0x94, 0x01, 0x81, 0x97, 0x5a, 0x5a, 0x57, 0x57, 0x9e, 0x00,
+  0x00, 0x02, 0x00, 0x12, 0xfe, 0x87, 0x06, 0x5f, 0x05, 0xf0, 0x00, 0x07,
+  0x00, 0x2d, 0x00, 0x00, 0x01, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06,
+  0x07, 0x12, 0x37, 0x36, 0x21, 0x20, 0x17, 0x16, 0x13, 0x21, 0x10, 0x12,
+  0x33, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23, 0x11,
+  0x26, 0x27, 0x26, 0x03, 0x06, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15, 0x14,
+  0x17, 0x16, 0x02, 0x4a, 0x03, 0x4f, 0x16, 0x58, 0x75, 0xfe, 0x74, 0x73,
+  0x57, 0xd9, 0x1e, 0x87, 0xa9, 0x01, 0x1b, 0x01, 0x23, 0xa3, 0xa8, 0x01,
+  0xfb, 0xe5, 0xf6, 0xf7, 0x7d, 0xe3, 0x65, 0x64, 0x76, 0x62, 0x6c, 0xa0,
+  0xe9, 0x90, 0xa9, 0x09, 0x99, 0x6a, 0x6e, 0x99, 0x43, 0x3c, 0x03, 0x6d,
+  0xbf, 0x7c, 0xa4, 0xa4, 0x7c, 0xbf, 0x01, 0x0a, 0xa7, 0xd2, 0xd2, 0xdb,
+  0xfe, 0x84, 0xfe, 0xf4, 0xfe, 0xce, 0x60, 0x5f, 0xd7, 0x46, 0x24, 0x1e,
+  0x05, 0xfe, 0xa3, 0x01, 0x63, 0x20, 0xa6, 0xc3, 0x01, 0x54, 0x01, 0x67,
+  0x6b, 0xdf, 0x4c, 0x3e, 0xa0, 0x41, 0x39, 0x00, 0x00, 0x02, 0x00, 0x0d,
+  0xfe, 0xb7, 0x04, 0xdc, 0x04, 0x7b, 0x00, 0x08, 0x00, 0x31, 0x00, 0x00,
+  0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x22, 0x27,
+  0x26, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23, 0x11, 0x26,
+  0x27, 0x26, 0x04, 0x36, 0x02, 0x49, 0x4b, 0x7a, 0x8b, 0x54, 0x53, 0x0c,
+  0xb2, 0x82, 0x50, 0x56, 0x8c, 0x2b, 0x33, 0x43, 0x17, 0x69, 0x83, 0xe6,
+  0xcb, 0x76, 0x77, 0xfd, 0x06, 0x0b, 0x5c, 0x5d, 0xa4, 0x60, 0x5a, 0x59,
+  0x58, 0x5d, 0x5a, 0x47, 0x42, 0x96, 0xae, 0x6f, 0x85, 0x02, 0x94, 0x97,
+  0x5a, 0x5a, 0x57, 0x57, 0x9e, 0x8f, 0x52, 0x5a, 0xac, 0x46, 0x31, 0x97,
+  0x21, 0x26, 0xc5, 0x82, 0xa1, 0x91, 0x92, 0xfa, 0x5a, 0xbe, 0x64, 0x63,
+  0x1a, 0x1a, 0x34, 0xae, 0x2c, 0x14, 0x10, 0x04, 0xfe, 0xd2, 0x01, 0x33,
+  0x1a, 0x7b, 0x94, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6b,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x24,
+  0x00, 0x00, 0x07, 0x9e, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x05, 0xb8,
+  0x01, 0x75, 0x12, 0x06, 0x03, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f,
+  0x00, 0x00, 0x06, 0x3e, 0x06, 0x48, 0x10, 0x27, 0x02, 0x9a, 0x01, 0x7e,
+  0x00, 0x00, 0x12, 0x06, 0x03, 0xca, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0xfe, 0x66, 0x04, 0xb0, 0x05, 0xd5, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11, 0x33,
+  0x11, 0x01, 0x33, 0x02, 0x65, 0x7d, 0xa7, 0x66, 0x62, 0xb7, 0xce, 0x44,
+  0x38, 0x78, 0x33, 0x31, 0x6f, 0x70, 0xfe, 0xae, 0xb6, 0xb6, 0x02, 0x5b,
+  0xea, 0x03, 0x71, 0x77, 0x72, 0xee, 0xfe, 0xce, 0xfe, 0xf2, 0xf4, 0xaa,
+  0x4b, 0x4b, 0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x05, 0xd5, 0xfd,
+  0x89, 0x02, 0x77, 0x00, 0x00, 0x01, 0x00, 0xab, 0xfe, 0x56, 0x04, 0x14,
+  0x04, 0x60, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01,
+  0x33, 0x02, 0x21, 0x12, 0xeb, 0x41, 0x4a, 0x4a, 0x49, 0xa3, 0xad, 0x9a,
+  0x63, 0x1e, 0x22, 0x22, 0x27, 0x7e, 0xea, 0xa6, 0xa6, 0x01, 0xee, 0xd4,
+  0x02, 0x77, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd6, 0x60, 0x60, 0x9c, 0x30,
+  0x37, 0x93, 0x01, 0x08, 0xa6, 0x24, 0x29, 0xfe, 0x19, 0x04, 0x60, 0xfe,
+  0x1d, 0x01, 0xe3, 0x00, 0x00, 0x01, 0x00, 0x30, 0xfe, 0x56, 0x05, 0x6a,
+  0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x15, 0x10,
+  0x03, 0x06, 0x05, 0x35, 0x36, 0x37, 0x12, 0x19, 0x01, 0x21, 0x11, 0x33,
+  0x15, 0x01, 0x23, 0x04, 0xb4, 0xb6, 0xfe, 0x4c, 0x77, 0x58, 0xfe, 0xb6,
+  0xbe, 0x3d, 0x69, 0x03, 0x1f, 0xb5, 0xfe, 0xb7, 0x79, 0x05, 0x2b, 0xd4,
+  0xfe, 0x18, 0xfe, 0xaa, 0xfd, 0x38, 0xa7, 0x2e, 0xa8, 0x01, 0x25, 0x02,
+  0x35, 0x01, 0x1a, 0xfa, 0xd5, 0xaa, 0xfe, 0x56, 0x00, 0x01, 0x00, 0x29,
+  0xfe, 0x56, 0x04, 0xa7, 0x04, 0x60, 0x00, 0x14, 0x00, 0x00, 0x25, 0x33,
+  0x15, 0x01, 0x23, 0x13, 0x23, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x05,
+  0x35, 0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x04, 0x01, 0xa6, 0xfe, 0xfb,
+  0x6f, 0xce, 0xa5, 0xfe, 0xa1, 0x6a, 0x54, 0xfe, 0xea, 0xa1, 0x36, 0x58,
+  0x02, 0xa9, 0x99, 0x99, 0xfe, 0x56, 0x01, 0xaa, 0x03, 0xc7, 0x86, 0xfe,
+  0x92, 0xfe, 0xfc, 0xcf, 0x1d, 0x99, 0x1b, 0x7f, 0xcf, 0x01, 0xa7, 0xd4,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x14,
+  0x00, 0x00, 0x25, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x03,
+  0xff, 0xfd, 0x6c, 0xb6, 0xb6, 0x02, 0x94, 0xb6, 0xb9, 0xcd, 0x44, 0x38,
+  0x78, 0x33, 0x31, 0x68, 0x02, 0x5f, 0xfd, 0x39, 0x05, 0xd5, 0xfd, 0x9c,
+  0x02, 0x64, 0xfa, 0x93, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x04, 0x14, 0x04, 0x60, 0x00, 0x15,
+  0x00, 0x00, 0x05, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
+  0x03, 0x6e, 0xfd, 0xe5, 0xa5, 0xa5, 0x02, 0x1b, 0xa6, 0x4a, 0x49, 0xa3,
+  0xad, 0x9b, 0x62, 0x1e, 0x22, 0x14, 0x02, 0x18, 0xfd, 0xfc, 0x04, 0x60,
+  0xfe, 0x33, 0x01, 0xcd, 0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x37,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x05, 0x6a, 0x05, 0xd5, 0x00, 0x10,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0xb5, 0xb6, 0xfd, 0x6c,
+  0xb6, 0xb6, 0x02, 0x94, 0xb6, 0xb5, 0xfe, 0xb7, 0x79, 0x02, 0xc7, 0xfd,
+  0x39, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfa, 0xd5, 0xaa, 0xfe, 0x56,
+  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x04, 0xba, 0x04, 0x60, 0x00, 0x10,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0x14, 0xa6, 0xfd, 0xe5,
+  0xa5, 0xa5, 0x02, 0x1b, 0xa6, 0xa6, 0xfe, 0xfb, 0x6f, 0x02, 0x04, 0xfd,
+  0xfc, 0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0xfc, 0x39, 0x99, 0xfe, 0x56,
+  0x00, 0x01, 0x00, 0x9d, 0xfe, 0xbf, 0x04, 0x3b, 0x05, 0xd5, 0x00, 0x14,
+  0x00, 0x00, 0x25, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11,
+  0x14, 0x16, 0x33, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x03,
+  0x84, 0xfe, 0x89, 0xa8, 0x65, 0x62, 0xb4, 0x70, 0x70, 0x01, 0x52, 0xb7,
+  0xb7, 0xb5, 0xaa, 0x02, 0x1d, 0x77, 0x72, 0xee, 0x01, 0x37, 0xfe, 0xd9,
+  0x9f, 0x9e, 0x02, 0x64, 0xfa, 0x2b, 0xfe, 0xbf, 0x01, 0xeb, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x87, 0xfe, 0xe5, 0x03, 0x9a, 0x04, 0x60, 0x00, 0x15,
+  0x00, 0x00, 0x25, 0x11, 0x21, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11,
+  0x02, 0xf4, 0xfe, 0xcb, 0x89, 0x5c, 0x53, 0xa6, 0x2e, 0x30, 0x5e, 0x01,
+  0x0b, 0xa6, 0xa6, 0xa6, 0x99, 0x01, 0x70, 0x5f, 0x56, 0xb8, 0xea, 0xd3,
+  0x75, 0x3b, 0x3b, 0x01, 0xbe, 0xfb, 0xa0, 0xfe, 0xe5, 0x01, 0xb4, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x06, 0x38, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x00, 0x25, 0x33, 0x15, 0x01, 0x23, 0x01, 0x23, 0x11, 0x01, 0x23,
+  0x01, 0x11, 0x23, 0x11, 0x21, 0x09, 0x01, 0x21, 0x05, 0x82, 0xb5, 0xfe,
+  0xb7, 0x79, 0x01, 0x0d, 0xb1, 0xfe, 0xa5, 0xb6, 0xfe, 0xa5, 0xb0, 0x01,
+  0x0f, 0x01, 0x57, 0x01, 0x58, 0x01, 0x0f, 0xaa, 0xaa, 0xfe, 0x56, 0x01,
+  0xaa, 0x05, 0x1f, 0xfc, 0x00, 0x04, 0x00, 0xfa, 0xe1, 0x05, 0xd5, 0xfc,
+  0x08, 0x03, 0xf8, 0x00, 0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x05, 0x67,
+  0x04, 0x60, 0x00, 0x11, 0x00, 0x00, 0x25, 0x33, 0x15, 0x01, 0x23, 0x13,
+  0x23, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0x11, 0x33, 0x09, 0x01, 0x33,
+  0x04, 0xc1, 0xa5, 0xfe, 0xfb, 0x6e, 0xce, 0xa0, 0xfe, 0xe9, 0xa5, 0xfe,
+  0xe9, 0xa0, 0xec, 0x01, 0x1e, 0x01, 0x1f, 0xea, 0x99, 0x99, 0xfe, 0x56,
+  0x01, 0xaa, 0x03, 0xb0, 0xfd, 0x27, 0x02, 0xd9, 0xfc, 0x50, 0x04, 0x60,
+  0xfd, 0x12, 0x02, 0xee, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54,
+  0x06, 0x14, 0x12, 0x06, 0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x92, 0x10, 0x27, 0x02, 0x9a, 0x00, 0xb9,
+  0x01, 0x4a, 0x13, 0x06, 0x03, 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x1f, 0x10, 0x26,
+  0x02, 0x9a, 0x47, 0xd7, 0x13, 0x06, 0x03, 0xc4, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x4e, 0x12, 0x26,
+  0x03, 0xa4, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0x43, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x06, 0x10, 0x12, 0x26, 0x03, 0xc4, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a,
+  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x07, 0x00, 0x00, 0x06, 0x8e,
+  0x05, 0xd5, 0x12, 0x06, 0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
+  0xff, 0xe3, 0x06, 0xb1, 0x04, 0x7b, 0x12, 0x06, 0x00, 0xa8, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xf2, 0x04, 0x2a, 0x01, 0x75, 0x13, 0x06, 0x03, 0xa9, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
+  0x06, 0x48, 0x10, 0x27, 0x02, 0x9a, 0x00, 0x87, 0x00, 0x00, 0x13, 0x06,
+  0x03, 0xc9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
+  0xff, 0xe3, 0x05, 0x44, 0x05, 0xf0, 0x12, 0x06, 0x01, 0x51, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x06,
+  0x02, 0x1b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69, 0xff, 0xe3, 0x05, 0x44,
+  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x04, 0x9d, 0x01, 0x75, 0x12, 0x06,
+  0x04, 0x6c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c,
+  0x06, 0x10, 0x10, 0x26, 0x00, 0x6a, 0x4c, 0x00, 0x12, 0x06, 0x04, 0x6d,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x24, 0x00, 0x00, 0x07, 0x9e,
+  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x05, 0xaf, 0x01, 0x75, 0x12, 0x06,
+  0x03, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f, 0x00, 0x00, 0x06, 0x3e,
+  0x06, 0x10, 0x10, 0x27, 0x00, 0x6a, 0x01, 0x75, 0x00, 0x00, 0x12, 0x06,
+  0x03, 0xca, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x25,
+  0x07, 0x4e, 0x10, 0x27, 0x10, 0xeb, 0x04, 0x13, 0x01, 0x75, 0x12, 0x06,
+  0x03, 0xab, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
+  0x06, 0x10, 0x10, 0x26, 0x00, 0x6a, 0x34, 0x00, 0x12, 0x06, 0x03, 0xcb,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x90, 0xff, 0xc1, 0x04, 0x79,
+  0x05, 0xd5, 0x12, 0x06, 0x01, 0x79, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
+  0xfe, 0x4c, 0x03, 0xc4, 0x04, 0x60, 0x12, 0x06, 0x02, 0x54, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0xdc, 0x01, 0x3b, 0x12, 0x06, 0x03, 0xac, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07, 0x05, 0xf5, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0x83, 0xff, 0xff, 0x12, 0x06, 0x03, 0xcc, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x07, 0x4e, 0x10, 0x27,
+  0x10, 0xeb, 0x04, 0x76, 0x01, 0x75, 0x12, 0x06, 0x03, 0xac, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07, 0x06, 0x10, 0x10, 0x27,
+  0x00, 0x6a, 0x00, 0x83, 0x00, 0x00, 0x12, 0x06, 0x03, 0xcc, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x4e, 0x12, 0x26,
+  0x03, 0xb2, 0x00, 0x00, 0x11, 0x07, 0x10, 0xeb, 0x04, 0xa3, 0x01, 0x75,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x06, 0x10, 0x12, 0x26, 0x03, 0xd2, 0x00, 0x00, 0x11, 0x06, 0x00, 0x6a,
+  0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x05, 0xf0, 0x12, 0x06, 0x01, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x12, 0x06, 0x02, 0x37, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x07, 0x4e, 0x12, 0x26,
+  0x04, 0x7c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xeb, 0x04, 0xa3, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x10, 0x12, 0x26,
+  0x04, 0x7d, 0x00, 0x00, 0x10, 0x06, 0x00, 0x6a, 0x68, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x04, 0xa0, 0x07, 0x4e, 0x10, 0x27,
+  0x10, 0xeb, 0x03, 0xf6, 0x01, 0x75, 0x12, 0x06, 0x03, 0xc1, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x06, 0x10, 0x10, 0x26,
+  0x00, 0x6a, 0xe5, 0x00, 0x12, 0x06, 0x03, 0xe1, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0x67, 0x01, 0x3b, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x05, 0xf5, 0x10, 0x26,
+  0x00, 0x71, 0x55, 0xff, 0x12, 0x06, 0x03, 0xd7, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x4e, 0x10, 0x27,
+  0x10, 0xeb, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x10, 0x10, 0x26,
+  0x00, 0x6a, 0x55, 0x00, 0x12, 0x06, 0x03, 0xd7, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x1f, 0x00, 0x00, 0x04, 0x44, 0x07, 0x6b, 0x10, 0x27,
+  0x10, 0xf4, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06, 0x03, 0xb7, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c, 0x06, 0x66, 0x10, 0x26,
+  0x02, 0x9f, 0x55, 0x00, 0x12, 0x06, 0x03, 0xd7, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9d, 0x00, 0x00, 0x04, 0x3b, 0x07, 0x4e, 0x10, 0x27,
+  0x10, 0xeb, 0x04, 0x51, 0x01, 0x75, 0x12, 0x06, 0x03, 0xbb, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x87, 0x00, 0x00, 0x03, 0x9a, 0x06, 0x10, 0x10, 0x26,
+  0x00, 0x6a, 0x55, 0x00, 0x12, 0x06, 0x03, 0xdb, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x09,
+  0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11,
+  0xb5, 0x03, 0x44, 0xfd, 0x72, 0xb5, 0xb5, 0x05, 0xd5, 0xaa, 0xfb, 0x7f,
+  0xfe, 0x15, 0x01, 0x41, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x03, 0x6f,
+  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x33, 0x11, 0x23, 0x11, 0xa7, 0x02, 0xc7, 0xfd, 0xdf, 0xa6, 0xa6, 0x04,
+  0x60, 0xaa, 0xfc, 0xe3, 0xfe, 0x4c, 0x01, 0x1b, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0xa6, 0x07, 0x4e, 0x12, 0x26, 0x03, 0xbf, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xeb, 0x05, 0x25, 0x01, 0x75, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x05, 0x0c, 0x06, 0x10, 0x12, 0x26, 0x03, 0xdf, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x6a, 0x00, 0xee, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f,
+  0xfe, 0x56, 0x04, 0x71, 0x05, 0xd5, 0x00, 0x19, 0x00, 0x00, 0x21, 0x11,
+  0x23, 0x35, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x21, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35,
+  0x01, 0x2d, 0xed, 0xed, 0x03, 0x44, 0xfd, 0x71, 0x01, 0xed, 0xfe, 0x13,
+  0x01, 0x45, 0x40, 0x49, 0xac, 0xe5, 0xd2, 0x5e, 0x45, 0x02, 0x94, 0xaa,
+  0x02, 0x97, 0xaa, 0xfe, 0x13, 0xaa, 0xfd, 0xec, 0x94, 0xc8, 0x60, 0x6e,
+  0x9c, 0x61, 0xad, 0x00, 0x00, 0x01, 0x00, 0x32, 0xfe, 0x56, 0x03, 0xe7,
+  0x04, 0x60, 0x00, 0x19, 0x00, 0x00, 0x21, 0x11, 0x23, 0x35, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x14, 0x07,
+  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x01, 0x1f, 0xed, 0xed,
+  0x02, 0xc7, 0xfd, 0xdf, 0x01, 0x76, 0xfe, 0x8a, 0x01, 0x49, 0x3f, 0x4a,
+  0xad, 0xe4, 0xd2, 0x5f, 0x43, 0x01, 0xf4, 0xaa, 0x01, 0xc2, 0x9d, 0xfe,
+  0xdb, 0xaa, 0xfe, 0x8c, 0x94, 0xc8, 0x60, 0x6e, 0x9c, 0x61, 0xad, 0x00,
+  0x00, 0x01, 0x00, 0x36, 0xfe, 0x66, 0x04, 0xa6, 0x05, 0xd5, 0x00, 0x17,
+  0x00, 0x00, 0x25, 0x16, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x37, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01,
+  0x33, 0x01, 0x04, 0xa6, 0x01, 0x02, 0x0e, 0x4a, 0x5c, 0xcd, 0x45, 0x38,
+  0x7a, 0x31, 0x24, 0x0a, 0xfe, 0x88, 0xfe, 0x83, 0xc4, 0x01, 0xe0, 0xfe,
+  0x5d, 0xc3, 0x01, 0x4e, 0x01, 0x50, 0xc3, 0xfe, 0x50, 0x1a, 0x02, 0x18,
+  0xbe, 0x62, 0x7a, 0xaa, 0x4b, 0x35, 0x73, 0x02, 0x78, 0xfd, 0x85, 0x03,
+  0x1d, 0x02, 0xb8, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x33, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x35, 0xfe, 0x56, 0x03, 0xf4, 0x04, 0x60, 0x00, 0x17,
+  0x00, 0x00, 0x09, 0x02, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35,
+  0x32, 0x37, 0x3e, 0x01, 0x35, 0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09,
+  0x01, 0x03, 0xf4, 0xfe, 0x93, 0x01, 0x47, 0x18, 0x3c, 0x49, 0xb1, 0xad,
+  0xb0, 0x17, 0x47, 0x2f, 0xfe, 0xde, 0xfe, 0xda, 0xc3, 0x01, 0x88, 0xfe,
+  0x99, 0xc4, 0x01, 0x0b, 0x01, 0x0b, 0x04, 0x60, 0xfd, 0xdf, 0xfe, 0x17,
+  0x26, 0x39, 0xcd, 0x61, 0x73, 0x9c, 0x03, 0x0a, 0x6d, 0x98, 0x01, 0xb4,
+  0xfe, 0x48, 0x02, 0x4a, 0x02, 0x16, 0xfe, 0x71, 0x01, 0x8f, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01, 0x21, 0x15, 0x21, 0x01,
+  0x23, 0x09, 0x01, 0x23, 0x01, 0x21, 0x35, 0x21, 0x74, 0xc3, 0x01, 0x4e,
+  0x01, 0x50, 0xc3, 0xfe, 0x7a, 0x01, 0x4e, 0xfe, 0xb5, 0x01, 0xa0, 0xc3,
+  0xfe, 0x86, 0xfe, 0x83, 0xc4, 0x01, 0xa5, 0xfe, 0xb1, 0x01, 0x6e, 0x05,
+  0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x77, 0x90, 0xfd, 0x44, 0x02, 0x7b,
+  0xfd, 0x85, 0x02, 0xbc, 0x90, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x35,
+  0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01,
+  0x33, 0x09, 0x01, 0x33, 0x01, 0x33, 0x15, 0x21, 0x01, 0x23, 0x09, 0x01,
+  0x23, 0x01, 0x21, 0x35, 0x01, 0x8b, 0xfe, 0xcb, 0xc4, 0x01, 0x0b, 0x01,
+  0x0b, 0xc4, 0xfe, 0xcc, 0xf2, 0xfe, 0xfd, 0x01, 0x57, 0xc3, 0xfe, 0xdb,
+  0xfe, 0xda, 0xc3, 0x01, 0x59, 0xfe, 0xfc, 0x02, 0x94, 0x01, 0xcc, 0xfe,
+  0x71, 0x01, 0x8f, 0xfe, 0x34, 0x90, 0xfd, 0xfc, 0x01, 0xb8, 0xfe, 0x48,
+  0x02, 0x04, 0x90, 0x00, 0x00, 0x02, 0x00, 0x82, 0x00, 0x00, 0x04, 0x3c,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16,
+  0x33, 0x21, 0x11, 0x21, 0x22, 0x07, 0x06, 0x01, 0x11, 0x21, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x01, 0x42, 0x47, 0x47, 0x92, 0x01,
+  0x24, 0xfe, 0xdc, 0x92, 0x47, 0x47, 0x02, 0xfa, 0xfe, 0x1d, 0xe2, 0xf5,
+  0xf5, 0xe2, 0x01, 0x2d, 0x01, 0xb7, 0x8a, 0x43, 0x44, 0x02, 0x23, 0x43,
+  0x44, 0x03, 0x93, 0xfa, 0x2b, 0xda, 0xdd, 0xde, 0xda, 0x02, 0x66, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x03, 0x90, 0x04, 0x60, 0x00, 0x0a,
+  0x00, 0x16, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x11, 0x23,
+  0x22, 0x07, 0x06, 0x01, 0x11, 0x21, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36,
+  0x3b, 0x01, 0x11, 0x01, 0x16, 0x38, 0x3b, 0x74, 0xed, 0xed, 0x73, 0x3c,
+  0x38, 0x02, 0x7a, 0xfe, 0x66, 0xc0, 0x68, 0x68, 0x68, 0x6d, 0xbb, 0xf4,
+  0x01, 0x4c, 0x5a, 0x2b, 0x2e, 0x01, 0x69, 0x2e, 0x2a, 0x02, 0xb6, 0xfb,
+  0xa0, 0x52, 0x52, 0x01, 0x50, 0x52, 0x55, 0x01, 0xc5, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x82, 0xff, 0xe3, 0x06, 0x8a, 0x05, 0xd5, 0x00, 0x0c,
+  0x00, 0x30, 0x00, 0x00, 0x01, 0x21, 0x22, 0x07, 0x06, 0x10, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x13, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x33, 0x11, 0x14,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x03, 0x86, 0xfe, 0xdc, 0x92, 0x47, 0x47,
+  0x47, 0x56, 0x74, 0xa2, 0x43, 0x4e, 0x1e, 0x0b, 0x0d, 0x2e, 0x5f, 0x55,
+  0x63, 0xd6, 0x74, 0x7b, 0xf5, 0xe2, 0x01, 0x2d, 0xb5, 0x38, 0x2f, 0x65,
+  0x5f, 0x35, 0x38, 0xb6, 0x63, 0x5e, 0xc1, 0xc3, 0x5c, 0x2c, 0x02, 0xc9,
+  0x43, 0x44, 0xfe, 0xea, 0x50, 0x5f, 0x6d, 0x7d, 0x9f, 0xfe, 0xdd, 0x1d,
+  0x1c, 0x60, 0x36, 0x31, 0x81, 0x89, 0xca, 0xde, 0xda, 0x02, 0x66, 0xfb,
+  0xec, 0x8f, 0x5b, 0x4a, 0x4a, 0x4f, 0x9b, 0x02, 0x9f, 0xfd, 0x5a, 0xe0,
+  0x7f, 0x78, 0x78, 0x39, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x05, 0xce,
+  0x04, 0x60, 0x00, 0x0d, 0x00, 0x30, 0x00, 0x00, 0x01, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x13, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01,
+  0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
+  0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x02, 0xea, 0xed,
+  0x73, 0x3c, 0x38, 0x3b, 0x39, 0x60, 0x85, 0x53, 0x28, 0x2c, 0x3c, 0x54,
+  0x54, 0x7b, 0x9b, 0x5b, 0x5b, 0x68, 0x6d, 0xbb, 0xf4, 0xa6, 0x38, 0x36,
+  0x5f, 0x5d, 0x36, 0x38, 0xa6, 0x5a, 0x5e, 0xb9, 0xbe, 0x5a, 0x1c, 0x02,
+  0x02, 0x2e, 0x2a, 0x5e, 0x5c, 0x3a, 0x39, 0x6d, 0x34, 0x9c, 0xfe, 0xf6,
+  0x6c, 0x30, 0x31, 0x61, 0x60, 0xa6, 0xaa, 0x52, 0x55, 0x01, 0xc5, 0xfd,
+  0x61, 0x9f, 0x50, 0x4f, 0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe, 0xb8, 0xec,
+  0x73, 0x78, 0x78, 0x25, 0x00, 0x01, 0x00, 0xb4, 0xff, 0xe3, 0x06, 0x50,
+  0x05, 0xf0, 0x00, 0x37, 0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x03, 0x4c, 0x53, 0x53, 0x95, 0x9c, 0xa3, 0x86, 0x48, 0x47,
+  0x49, 0x4a, 0x89, 0x4b, 0xaa, 0x67, 0x67, 0x5a, 0x5b, 0x50, 0xcf, 0x79,
+  0x79, 0x40, 0x40, 0x76, 0x82, 0x4a, 0x49, 0x39, 0x2f, 0x64, 0x5f, 0x35,
+  0x39, 0xb6, 0x64, 0x5d, 0xc2, 0xc3, 0x5c, 0x2b, 0x19, 0x1e, 0x01, 0xb2,
+  0x84, 0x4a, 0x4b, 0xa6, 0x3b, 0x3c, 0x70, 0x73, 0x3d, 0x3e, 0x24, 0x26,
+  0xb4, 0x20, 0x10, 0x10, 0x68, 0x69, 0xb2, 0x7c, 0x55, 0x56, 0x21, 0x1f,
+  0x62, 0x62, 0x90, 0x80, 0x5b, 0x4a, 0x4a, 0x4f, 0x9b, 0x02, 0x9f, 0xfd,
+  0x5a, 0xe0, 0x7f, 0x78, 0x78, 0x38, 0x50, 0x61, 0x00, 0x01, 0x00, 0x99,
+  0xff, 0xe3, 0x05, 0xa6, 0x04, 0x7c, 0x00, 0x35, 0x00, 0x00, 0x01, 0x34,
+  0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x02, 0xc4, 0x46, 0x41, 0x7b, 0x85, 0x8b, 0x69,
+  0x3c, 0x3d, 0x3f, 0x3e, 0x6b, 0x40, 0x49, 0x48, 0x57, 0x58, 0x99, 0x45,
+  0xb0, 0x66, 0x66, 0x36, 0x36, 0x65, 0x75, 0x39, 0x3e, 0x38, 0x37, 0x5e,
+  0x5e, 0x36, 0x38, 0xa5, 0x5a, 0x5d, 0xba, 0xb3, 0x65, 0x58, 0x01, 0x38,
+  0x66, 0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e, 0x0d, 0x0d,
+  0x1d, 0xa7, 0x18, 0x18, 0x4e, 0x4f, 0x8d, 0x5d, 0x40, 0x41, 0x18, 0x19,
+  0x48, 0x4f, 0x48, 0x58, 0x44, 0x45, 0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe,
+  0xb8, 0xec, 0x73, 0x78, 0x75, 0x65, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0xfe, 0x56, 0x04, 0xb6, 0x05, 0xf0, 0x00, 0x29, 0x00, 0x00, 0x21, 0x23,
+  0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15,
+  0x11, 0x33, 0x11, 0x23, 0x04, 0x01, 0xb5, 0x53, 0x53, 0x95, 0x9c, 0xa3,
+  0x86, 0x48, 0x47, 0x49, 0x4a, 0x89, 0x4b, 0xaa, 0x67, 0x67, 0x5a, 0x5b,
+  0x50, 0xcf, 0x79, 0x79, 0x40, 0x40, 0x76, 0x82, 0x4a, 0x49, 0xb5, 0xb5,
+  0x01, 0xb1, 0x85, 0x4a, 0x4b, 0xa6, 0x3b, 0x3c, 0x70, 0x73, 0x3d, 0x3e,
+  0x24, 0x26, 0xb4, 0x20, 0x10, 0x10, 0x68, 0x69, 0xb2, 0x7c, 0x55, 0x56,
+  0x21, 0x1f, 0x62, 0x61, 0x92, 0xfe, 0xf9, 0xfd, 0xac, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x99, 0xfe, 0x56, 0x04, 0x10, 0x04, 0x7c, 0x00, 0x29,
+  0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x34, 0x27, 0x26,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x03, 0x67, 0xa9, 0xa6,
+  0xa6, 0x46, 0x41, 0x7b, 0x85, 0x8b, 0x69, 0x3c, 0x3d, 0x3f, 0x3e, 0x6b,
+  0x40, 0x49, 0x48, 0x57, 0x58, 0x99, 0x45, 0xb0, 0x66, 0x66, 0x36, 0x36,
+  0x65, 0x72, 0x3c, 0x3e, 0x99, 0xfd, 0xbd, 0x01, 0xaa, 0x01, 0x46, 0x58,
+  0x38, 0x33, 0x98, 0x2c, 0x2d, 0x46, 0x40, 0x2e, 0x2e, 0x0d, 0x0d, 0x1d,
+  0xa7, 0x18, 0x18, 0x4e, 0x4f, 0x8d, 0x5d, 0x40, 0x41, 0x18, 0x18, 0x49,
+  0x4b, 0x6a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x30, 0xff, 0xe3, 0x07, 0x03,
+  0x05, 0xd5, 0x00, 0x21, 0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x35, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x05, 0x35, 0x36,
+  0x37, 0x12, 0x19, 0x01, 0x04, 0xb4, 0x39, 0x2f, 0x64, 0x5f, 0x35, 0x39,
+  0xb6, 0x63, 0x5e, 0xc2, 0xc0, 0x5f, 0x63, 0xfe, 0x4c, 0x77, 0x58, 0xfe,
+  0xb6, 0xbe, 0x3d, 0x69, 0x05, 0xd5, 0xfb, 0xec, 0x8f, 0x5b, 0x4a, 0x4a,
+  0x4f, 0x9b, 0x02, 0x9f, 0xfd, 0x5a, 0xe0, 0x7f, 0x78, 0x78, 0x7d, 0xe2,
+  0x03, 0x71, 0xd4, 0xfe, 0x18, 0xfe, 0xaa, 0xfd, 0x38, 0xa7, 0x2e, 0xa8,
+  0x01, 0x25, 0x02, 0x35, 0x01, 0x1a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x29,
+  0xff, 0xe3, 0x06, 0x3d, 0x04, 0x60, 0x00, 0x20, 0x00, 0x00, 0x01, 0x11,
+  0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06,
+  0x05, 0x35, 0x36, 0x37, 0x36, 0x11, 0x35, 0x04, 0x01, 0x6e, 0x5d, 0x5d,
+  0x36, 0x38, 0xa6, 0x5a, 0x5e, 0xb9, 0xb4, 0x64, 0x58, 0xfe, 0xa1, 0x6a,
+  0x54, 0xfe, 0xea, 0xa1, 0x36, 0x58, 0x04, 0x60, 0xfd, 0x04, 0x57, 0x8a,
+  0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe, 0xb8, 0xec, 0x73, 0x78, 0x75, 0x65,
+  0x7b, 0x02, 0x8f, 0x86, 0xfe, 0x92, 0xfe, 0xfc, 0xcf, 0x1d, 0x99, 0x1b,
+  0x7f, 0xcf, 0x01, 0xa7, 0xd4, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xff, 0xe3, 0x07, 0x5c, 0x05, 0xd5, 0x12, 0x06, 0x01, 0xb8, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0xff, 0xe3, 0x06, 0x50, 0x04, 0x60, 0x00, 0x1c,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
+  0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x21,
+  0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x04, 0x14, 0x6e, 0x5c, 0x5e,
+  0x36, 0x38, 0xa6, 0x5a, 0x5e, 0xba, 0xb3, 0x64, 0x59, 0xfd, 0xe5, 0xa5,
+  0xa5, 0x02, 0x1b, 0x04, 0x60, 0xfd, 0x04, 0x57, 0x8a, 0x4f, 0x52, 0x9d,
+  0x01, 0x41, 0xfe, 0xb8, 0xec, 0x73, 0x78, 0x75, 0x65, 0x7b, 0xcc, 0xfd,
+  0xfc, 0x04, 0x60, 0xfe, 0x33, 0x01, 0xcd, 0x00, 0x00, 0x01, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xfc, 0x05, 0xf0, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x20, 0x27, 0x26, 0x10, 0x37, 0x36, 0x21,
+  0x20, 0x17, 0x15, 0x26, 0x23, 0x20, 0x11, 0x10, 0x21, 0x32, 0x36, 0x35,
+  0x11, 0x33, 0x04, 0xfb, 0x5a, 0x28, 0x7b, 0x70, 0x88, 0xfe, 0xbf, 0xb1,
+  0xac, 0xab, 0xb2, 0x01, 0x41, 0x01, 0x0a, 0xca, 0xca, 0xfb, 0xfe, 0x12,
+  0x01, 0xee, 0xc2, 0x6f, 0xb5, 0x01, 0xba, 0xe0, 0x7f, 0x39, 0x21, 0x1e,
+  0xd2, 0xcc, 0x02, 0xd0, 0xcd, 0xd2, 0x8e, 0xd7, 0xbf, 0xfd, 0x9f, 0xfd,
+  0xa0, 0x94, 0xa4, 0x01, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0xd9, 0x04, 0x7b, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x10,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x10,
+  0x17, 0x16, 0x33, 0x32, 0x11, 0x35, 0x33, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x66, 0x83, 0x87, 0xf0, 0xbc, 0xa7, 0xab, 0xb0, 0xaa, 0x59,
+  0x51, 0x51, 0x59, 0xaa, 0xcb, 0xa6, 0xb5, 0xce, 0xea, 0x86, 0x80, 0x02,
+  0x2f, 0x01, 0x0e, 0x9d, 0xa1, 0x6e, 0xaa, 0x7c, 0x7c, 0x72, 0xfe, 0x7c,
+  0x72, 0x7c, 0x01, 0x3e, 0xbe, 0xc5, 0xec, 0xe7, 0xa6, 0x9e, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xfa, 0xff, 0xe3, 0x04, 0xdc, 0x05, 0xd5, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11,
+  0x21, 0x35, 0x21, 0x15, 0x02, 0x8e, 0x39, 0x2f, 0x64, 0x5e, 0x35, 0x39,
+  0xb6, 0x63, 0x5e, 0xc1, 0xc1, 0x5e, 0x63, 0xfe, 0x23, 0x04, 0x70, 0x05,
+  0x2b, 0xfc, 0x96, 0x8f, 0x5b, 0x4a, 0x4a, 0x4f, 0x9b, 0x02, 0x9f, 0xfd,
+  0x5a, 0xe0, 0x7f, 0x78, 0x78, 0x7d, 0xe2, 0x03, 0x71, 0xaa, 0xaa, 0x00,
+  0x00, 0x01, 0x00, 0x04, 0xff, 0xe3, 0x04, 0x77, 0x04, 0x60, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11,
+  0x21, 0x35, 0x21, 0x15, 0x02, 0x39, 0x38, 0x37, 0x5e, 0x5e, 0x36, 0x37,
+  0xa6, 0x5a, 0x5e, 0xb9, 0xb3, 0x65, 0x58, 0xfe, 0x6e, 0x03, 0xc6, 0x03,
+  0xb6, 0xfd, 0xae, 0x56, 0x46, 0x45, 0x4f, 0x52, 0x9d, 0x01, 0x41, 0xfe,
+  0xb8, 0xec, 0x73, 0x78, 0x75, 0x65, 0x7b, 0x02, 0x7e, 0xaa, 0xaa, 0x00,
+  0xff, 0xff, 0x00, 0x93, 0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x12, 0x06,
+  0x01, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77, 0xff, 0xe3, 0x03, 0x68,
+  0x04, 0x7c, 0x12, 0x06, 0x03, 0x49, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b,
+  0xfe, 0x66, 0x04, 0xb5, 0x05, 0xd5, 0x00, 0x18, 0x00, 0x00, 0x33, 0x35,
+  0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x21, 0x15, 0x10, 0x03, 0x06, 0x4c,
+  0xc7, 0x34, 0x4e, 0x03, 0x1f, 0xb8, 0xcd, 0x45, 0x39, 0x78, 0x32, 0x31,
+  0xfe, 0x4c, 0x5c, 0x58, 0xaa, 0x30, 0xa3, 0xf6, 0x02, 0x64, 0xfe, 0xfa,
+  0x93, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4c, 0xc1, 0x04, 0xc3, 0xb8, 0xfd,
+  0xca, 0xfe, 0xf8, 0xfd, 0x00, 0x01, 0x00, 0x44, 0xfe, 0x56, 0x04, 0x02,
+  0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x36, 0x11,
+  0x35, 0x21, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x11, 0x21, 0x15, 0x10, 0x07, 0x06, 0x44, 0xa8, 0x2f, 0x3d, 0x02,
+  0xa9, 0x93, 0xa2, 0x40, 0x2d, 0x57, 0x29, 0x23, 0xfe, 0xa1, 0x4f, 0x54,
+  0x99, 0x1d, 0x7d, 0xa6, 0x01, 0xd0, 0xb7, 0xfb, 0x8c, 0xd6, 0xc0, 0x9c,
+  0x30, 0x29, 0xa1, 0x03, 0xe1, 0x6f, 0xfe, 0x50, 0xc2, 0xcf, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x4b, 0x00, 0x00, 0x08, 0x33, 0x05, 0xd5, 0x00, 0x17,
+  0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x12, 0x11, 0x35, 0x21, 0x09, 0x01,
+  0x33, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x21, 0x15, 0x10,
+  0x03, 0x06, 0x4c, 0xc3, 0x38, 0x4e, 0x03, 0x20, 0x01, 0x4e, 0x01, 0x50,
+  0xc3, 0xfe, 0x50, 0x01, 0xcd, 0xc3, 0xfe, 0x86, 0xfe, 0x83, 0xc4, 0x01,
+  0xdf, 0xfe, 0xc4, 0xfd, 0xf2, 0x5c, 0x58, 0xaa, 0x2f, 0xa4, 0x01, 0x02,
+  0x02, 0x58, 0xfe, 0xfd, 0xd5, 0x02, 0x2b, 0xfd, 0x33, 0xfc, 0xf8, 0x02,
+  0x7b, 0xfd, 0x85, 0x03, 0x1d, 0x02, 0x0e, 0xb8, 0xfd, 0xca, 0xfe, 0xf8,
+  0xfd, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x44, 0x00, 0x00, 0x06, 0xed,
+  0x04, 0x60, 0x00, 0x18, 0x00, 0x00, 0x09, 0x02, 0x23, 0x09, 0x01, 0x23,
+  0x09, 0x01, 0x21, 0x15, 0x10, 0x07, 0x06, 0x05, 0x35, 0x36, 0x37, 0x36,
+  0x11, 0x35, 0x21, 0x17, 0x09, 0x01, 0x06, 0xda, 0xfe, 0x94, 0x01, 0x7f,
+  0xc3, 0xfe, 0xda, 0xfe, 0xdb, 0xc3, 0x01, 0x87, 0xfe, 0xfc, 0xfe, 0x5e,
+  0x4f, 0x54, 0xfe, 0xea, 0xa4, 0x33, 0x3d, 0x02, 0xa9, 0x01, 0x01, 0x0a,
+  0x01, 0x0b, 0x04, 0x60, 0xfd, 0xdf, 0xfd, 0xc1, 0x01, 0xb8, 0xfe, 0x48,
+  0x02, 0x4a, 0x01, 0x83, 0x6f, 0xfe, 0x50, 0xc2, 0xcf, 0x1d, 0x99, 0x1c,
+  0x7e, 0xb1, 0x01, 0xc5, 0xb7, 0x03, 0xfe, 0x74, 0x01, 0x8f, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x06, 0x38, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x1a, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x01, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32, 0x16, 0x15,
+  0x14, 0x07, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x6b, 0xe4, 0x7f, 0x8b,
+  0x8b, 0x7f, 0x01, 0x6d, 0x73, 0xfa, 0xe4, 0xb6, 0x01, 0x9a, 0xe2, 0xe7,
+  0x05, 0x01, 0x44, 0xc3, 0xfe, 0x50, 0x01, 0xcd, 0xc3, 0x05, 0x2f, 0xfd,
+  0xcf, 0x92, 0x87, 0x86, 0x92, 0xfd, 0xb3, 0x8a, 0xfd, 0xa8, 0x05, 0xd5,
+  0xe3, 0xdb, 0x30, 0x2a, 0x02, 0x18, 0xfd, 0x33, 0xfc, 0xf8, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xfe, 0x56, 0x05, 0xfe, 0x04, 0x7b, 0x00, 0x18,
+  0x00, 0x20, 0x00, 0x00, 0x09, 0x02, 0x23, 0x01, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x26, 0x27, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x01, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
+  0x05, 0xeb, 0xfe, 0x93, 0x01, 0x80, 0xc4, 0xfe, 0xea, 0x17, 0x53, 0x72,
+  0xb8, 0x6f, 0x9f, 0x34, 0xa7, 0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0x72, 0x4c,
+  0x1a, 0x01, 0x07, 0xfe, 0x5a, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07,
+  0x04, 0x60, 0xfd, 0xdf, 0xfd, 0xc1, 0x01, 0xa1, 0xa8, 0x74, 0xa2, 0x61,
+  0x64, 0xfd, 0xae, 0x06, 0x0a, 0xaa, 0x64, 0x61, 0xa2, 0x6b, 0x97, 0x01,
+  0x89, 0xfd, 0x04, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x7a, 0x00, 0x00, 0x06, 0xf6, 0x05, 0xd5, 0x00, 0x15,
+  0x00, 0x1d, 0x00, 0x00, 0x33, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x23, 0x01, 0x12, 0x10, 0x16, 0x33, 0x21, 0x11, 0x21, 0x22, 0x7a, 0x01,
+  0x70, 0x5a, 0xe7, 0xea, 0xe8, 0x04, 0x6b, 0xfd, 0x66, 0x02, 0x7e, 0xfd,
+  0x82, 0x02, 0xaa, 0xfc, 0x9e, 0xf1, 0xfe, 0x9d, 0x32, 0x86, 0x83, 0x01,
+  0x19, 0xfe, 0xe7, 0x83, 0x02, 0x8d, 0x1a, 0xa9, 0xd7, 0xce, 0xe0, 0xaa,
+  0xfe, 0x46, 0xaa, 0xfd, 0xe3, 0xaa, 0x02, 0x77, 0xfd, 0x89, 0x04, 0xaa,
+  0xfe, 0xfa, 0x87, 0x02, 0x12, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x68,
+  0xff, 0xe3, 0x06, 0xb8, 0x04, 0x7b, 0x00, 0x1f, 0x00, 0x26, 0x00, 0x2f,
+  0x00, 0x00, 0x01, 0x15, 0x21, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x23, 0x01, 0x23, 0x01, 0x2e,
+  0x01, 0x35, 0x34, 0x36, 0x33, 0x21, 0x36, 0x33, 0x32, 0x12, 0x07, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x07, 0x25, 0x14, 0x16, 0x3b, 0x01, 0x11, 0x23,
+  0x22, 0x06, 0x06, 0xb8, 0xfd, 0x06, 0x0b, 0xb9, 0xa4, 0x60, 0xb3, 0x58,
+  0x59, 0xbb, 0x60, 0xf2, 0x8d, 0x89, 0x03, 0xce, 0xfe, 0xd7, 0xb3, 0x01,
+  0x34, 0x68, 0x8b, 0xc2, 0xc3, 0x02, 0x28, 0x4d, 0x5d, 0xcb, 0xed, 0xa6,
+  0x02, 0x94, 0x7a, 0x8b, 0xa7, 0x0c, 0xfd, 0x90, 0x73, 0x6b, 0xe0, 0xe0,
+  0x6b, 0x73, 0x02, 0x5e, 0x5a, 0xbe, 0xc7, 0x34, 0x34, 0xae, 0x2a, 0x2c,
+  0x9c, 0x98, 0xc2, 0xfe, 0x27, 0x01, 0xeb, 0x1a, 0x89, 0x8f, 0xa2, 0xa1,
+  0x1b, 0xfe, 0xdd, 0xc4, 0x97, 0xb4, 0xae, 0x9e, 0x8a, 0x53, 0x5e, 0x01,
+  0x61, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xfe, 0xf8, 0x05, 0x44,
+  0x05, 0xf0, 0x10, 0x06, 0x00, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x03, 0xeb, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x54, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
+  0x04, 0x60, 0x10, 0x06, 0x00, 0x5a, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xf9, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x01, 0x33,
+  0x17, 0x37, 0x33, 0x01, 0x17, 0x23, 0x27, 0x07, 0x01, 0x23, 0x01, 0x03,
+  0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x27, 0x02, 0x2c, 0x7a, 0x88, 0xc6,
+  0xea, 0xfe, 0xc6, 0xb4, 0x80, 0x74, 0x8e, 0x02, 0x23, 0xc6, 0xfe, 0x2d,
+  0xf5, 0xb6, 0xb6, 0x01, 0x84, 0xc5, 0x05, 0x8a, 0x97, 0xe2, 0xfe, 0x9b,
+  0xc8, 0x80, 0xa1, 0xfc, 0x79, 0x03, 0x01, 0xfe, 0xe9, 0xfe, 0x16, 0x05,
+  0xd5, 0xfd, 0x1e, 0x01, 0xb8, 0xdc, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x1d, 0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
+  0x17, 0x37, 0x33, 0x07, 0x17, 0x23, 0x27, 0x07, 0x01, 0x23, 0x01, 0x07,
+  0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x01, 0xfc, 0x7e, 0x3b, 0x6a, 0xcc,
+  0xcf, 0x84, 0x80, 0x44, 0x73, 0x01, 0xb3, 0xb9, 0xfe, 0x9a, 0xb1, 0xa5,
+  0xa5, 0x01, 0x2a, 0x04, 0x29, 0x40, 0x77, 0xe9, 0x93, 0x4c, 0x81, 0xfd,
+  0x51, 0x02, 0x35, 0xc8, 0xfe, 0x93, 0x04, 0x60, 0xfd, 0xf2, 0x01, 0x50,
+  0x00, 0x01, 0x00, 0x4b, 0xfe, 0x66, 0x07, 0x9b, 0x05, 0xd5, 0x00, 0x25,
+  0x00, 0x00, 0x33, 0x35, 0x36, 0x37, 0x12, 0x11, 0x35, 0x21, 0x11, 0x21,
+  0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x15, 0x10, 0x03, 0x06, 0x4c, 0xc3, 0x38, 0x4e, 0x03, 0x1f, 0x01, 0x78,
+  0xa7, 0x66, 0x62, 0xb8, 0xcd, 0x44, 0x37, 0x79, 0x32, 0x32, 0x70, 0x6f,
+  0xfe, 0xad, 0xb6, 0xfe, 0x4c, 0x5c, 0x58, 0xaa, 0x2f, 0xa4, 0x01, 0x02,
+  0x02, 0x58, 0xfe, 0xfd, 0x9c, 0x77, 0x72, 0xee, 0xfe, 0xce, 0xfe, 0xf2,
+  0xf4, 0xaa, 0x4b, 0x4b, 0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x05,
+  0x2b, 0xb8, 0xfd, 0xca, 0xfe, 0xf8, 0xfd, 0x00, 0x00, 0x01, 0x00, 0x44,
+  0xfe, 0x56, 0x06, 0x58, 0x04, 0x60, 0x00, 0x27, 0x00, 0x00, 0x33, 0x35,
+  0x36, 0x37, 0x36, 0x11, 0x35, 0x21, 0x11, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x15, 0x10,
+  0x07, 0x06, 0x44, 0xa4, 0x33, 0x3d, 0x02, 0xa9, 0xe1, 0xed, 0x3f, 0x4a,
+  0x4a, 0x49, 0xa3, 0xae, 0x9b, 0x63, 0x1e, 0x22, 0x22, 0x28, 0x7d, 0xea,
+  0xa5, 0xfe, 0xa1, 0x4f, 0x54, 0x99, 0x1c, 0x7e, 0xb1, 0x01, 0xc5, 0xb7,
+  0xfe, 0x17, 0x47, 0x51, 0xe5, 0xfe, 0xf2, 0xd5, 0x61, 0x60, 0x9c, 0x30,
+  0x37, 0x93, 0x01, 0x08, 0xa6, 0x24, 0x29, 0xfe, 0x19, 0x03, 0xcd, 0x6f,
+  0xfe, 0x50, 0xc2, 0xcf, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x07, 0x9c,
+  0x05, 0xd5, 0x00, 0x21, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
+  0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6, 0x02, 0x94, 0xb6, 0x01, 0x77, 0xa8,
+  0x66, 0x62, 0xb8, 0xcd, 0x45, 0x38, 0x79, 0x32, 0x32, 0x70, 0x6f, 0xfe,
+  0xad, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfd,
+  0x9c, 0x77, 0x72, 0xee, 0xfe, 0xce, 0xfe, 0xf2, 0xf4, 0xaa, 0x4b, 0x4b,
+  0xc2, 0x01, 0x22, 0x9f, 0x9e, 0xfd, 0x39, 0x02, 0xc7, 0xfd, 0x39, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x06, 0x65, 0x04, 0x60, 0x00, 0x23,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
+  0x36, 0x35, 0x11, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21,
+  0x11, 0x23, 0xa7, 0xa7, 0x02, 0x19, 0xa7, 0xe1, 0xec, 0x3f, 0x4a, 0x4a,
+  0x49, 0xa2, 0xae, 0x9b, 0x63, 0x1d, 0x23, 0x23, 0x27, 0x7d, 0xea, 0xa7,
+  0xfd, 0xe7, 0xa7, 0x04, 0x60, 0xfe, 0x37, 0x01, 0xc9, 0xfe, 0x17, 0x47,
+  0x51, 0xe5, 0xfe, 0xf2, 0xd5, 0x61, 0x60, 0x9c, 0x30, 0x37, 0x93, 0x01,
+  0x08, 0xa6, 0x24, 0x29, 0xfe, 0x19, 0x02, 0x04, 0xfd, 0xfc, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x6a, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x33, 0x11,
+  0x23, 0x11, 0x03, 0xff, 0xfd, 0x6c, 0xb6, 0x04, 0x00, 0xb5, 0xb5, 0x05,
+  0x2b, 0xfa, 0xd5, 0x05, 0xd5, 0xfa, 0xd5, 0xfe, 0x15, 0x01, 0x41, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0xb4, 0x04, 0x60, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x04, 0x0e, 0xa5, 0xa5, 0xa7, 0xfd, 0xe7, 0xa7, 0x04, 0x60,
+  0xfc, 0x39, 0xfe, 0x4c, 0x01, 0x1b, 0x03, 0xcd, 0xfc, 0x33, 0x04, 0x60,
+  0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x00, 0x07,
+  0x00, 0x0a, 0x00, 0x00, 0x21, 0x23, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33,
+  0x01, 0x21, 0x03, 0x04, 0x0c, 0xb0, 0x5b, 0xfe, 0x41, 0x5c, 0xaf, 0x01,
+  0x7a, 0xe1, 0xfe, 0xe3, 0x01, 0x59, 0xad, 0x01, 0x13, 0xfe, 0xed, 0x04,
+  0x60, 0xfd, 0x47, 0x02, 0x05, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09,
+  0x00, 0x00, 0x04, 0xd2, 0x04, 0x60, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00,
+  0x33, 0x01, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15,
+  0x21, 0x11, 0x21, 0x03, 0x01, 0x03, 0x33, 0x11, 0x0a, 0x01, 0xaa, 0x03,
+  0x12, 0xfe, 0x2a, 0x01, 0xc2, 0xfe, 0x3e, 0x01, 0xe2, 0xfd, 0x77, 0xfe,
+  0xde, 0x68, 0x01, 0x71, 0xd1, 0xea, 0x04, 0x60, 0x94, 0xfe, 0xd3, 0x94,
+  0xfe, 0x88, 0x93, 0x01, 0x13, 0xfe, 0xed, 0x03, 0xcd, 0xfd, 0xda, 0x02,
+  0x26, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xb1,
+  0x04, 0x7b, 0x00, 0x34, 0x00, 0x3d, 0x00, 0x4a, 0x00, 0x00, 0x25, 0x0e,
+  0x01, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x21, 0x2e, 0x01, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x3e,
+  0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x25, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x1d,
+  0x01, 0x03, 0xa0, 0x43, 0xbf, 0x76, 0xcc, 0x76, 0x77, 0x02, 0xf9, 0x0b,
+  0xb7, 0xa5, 0x5e, 0x5a, 0x5a, 0x5a, 0x5a, 0xbc, 0x5f, 0x96, 0x70, 0x70,
+  0x45, 0x41, 0xc3, 0x81, 0xaa, 0x5e, 0x5f, 0x73, 0x71, 0xe2, 0xe8, 0x4b,
+  0x4b, 0x88, 0x57, 0xa3, 0x4c, 0x5b, 0x56, 0x55, 0x51, 0x80, 0x5f, 0x61,
+  0xfd, 0x45, 0x01, 0x4b, 0x4a, 0x7b, 0x8a, 0x52, 0x54, 0x0d, 0x01, 0x45,
+  0xc8, 0x9b, 0x3a, 0x3a, 0x64, 0x8a, 0x52, 0x54, 0x9b, 0x5a, 0x5e, 0x91,
+  0x92, 0xfa, 0x5a, 0xbf, 0xc8, 0x1b, 0x1a, 0x35, 0xae, 0x2a, 0x2c, 0x3d,
+  0x3c, 0x77, 0x78, 0x78, 0x5d, 0x5e, 0xa8, 0xbd, 0x60, 0x60, 0x12, 0x7f,
+  0x46, 0x45, 0x2e, 0x2e, 0xaa, 0x27, 0x14, 0x13, 0x30, 0x30, 0x01, 0x87,
+  0x97, 0x5a, 0x5a, 0x57, 0x57, 0x9e, 0x60, 0x66, 0x7b, 0x62, 0x3a, 0x39,
+  0x6d, 0x6c, 0xb4, 0x29, 0x00, 0x03, 0x00, 0x37, 0x00, 0x00, 0x03, 0xd2,
+  0x04, 0x60, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x23, 0x00, 0x00, 0x25, 0x32,
+  0x35, 0x34, 0x2b, 0x01, 0x15, 0x33, 0x15, 0x23, 0x15, 0x01, 0x34, 0x2b,
+  0x01, 0x11, 0x33, 0x32, 0x37, 0x14, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06,
+  0x23, 0x21, 0x35, 0x23, 0x35, 0x33, 0x11, 0x21, 0x32, 0x16, 0x02, 0x39,
+  0xe8, 0xe8, 0xec, 0xc6, 0xc6, 0x01, 0xae, 0xd4, 0xda, 0xda, 0xd4, 0xa7,
+  0xc1, 0x72, 0x7e, 0xcf, 0xc1, 0xfe, 0x66, 0x6f, 0x6f, 0x01, 0x8b, 0xb1,
+  0xbf, 0x99, 0xb5, 0xb4, 0x66, 0xa4, 0x5f, 0x02, 0x9d, 0x91, 0xfe, 0xda,
+  0xaa, 0xd0, 0x1f, 0x18, 0x98, 0x72, 0x96, 0xa4, 0xf8, 0xa4, 0x02, 0xc4,
+  0x90, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
+  0x04, 0x7b, 0x10, 0x06, 0x00, 0x46, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0xf7, 0x04, 0x60, 0x00, 0x08, 0x00, 0x11, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x25, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x01, 0x4e, 0x7f, 0xc3, 0xb7, 0xb7,
+  0xc3, 0xfe, 0xda, 0x01, 0x18, 0x01, 0x26, 0x01, 0x11, 0xfe, 0xed, 0xfe,
+  0xdc, 0xfe, 0xe8, 0x03, 0xcd, 0xfc, 0xc7, 0xc7, 0xd6, 0xd5, 0xc7, 0x93,
+  0xfe, 0xf1, 0xfe, 0xe0, 0xfe, 0xdf, 0xfe, 0xf0, 0x00, 0x02, 0x00, 0x20,
+  0x00, 0x00, 0x03, 0xf7, 0x04, 0x60, 0x00, 0x0c, 0x00, 0x19, 0x00, 0x00,
+  0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x11, 0x23, 0x35,
+  0x33, 0x21, 0x15, 0x23, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b,
+  0x01, 0x11, 0xa7, 0x01, 0x18, 0x01, 0x26, 0x01, 0x11, 0xfe, 0xed, 0xfe,
+  0xdc, 0xfe, 0xe8, 0x87, 0x87, 0x01, 0x55, 0xae, 0x7f, 0xc3, 0xb7, 0xb7,
+  0xc3, 0x7f, 0x04, 0x60, 0xfe, 0xf1, 0xfe, 0xe0, 0xfe, 0xdf, 0xfe, 0xf0,
+  0x01, 0xf5, 0xa4, 0xa4, 0xfe, 0x9f, 0xc7, 0xd6, 0xd5, 0xc7, 0xfe, 0xcc,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x31, 0x04, 0x60, 0x00, 0x0b,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0xa7, 0x02, 0x7e, 0xfe, 0x2a, 0x01, 0xc1, 0xfe, 0x3f, 0x01,
+  0xe1, 0xfd, 0x77, 0x04, 0x60, 0x94, 0xfe, 0xd3, 0x94, 0xfe, 0x88, 0x93,
+  0x00, 0x01, 0x00, 0x75, 0xff, 0xe3, 0x03, 0x65, 0x04, 0x7c, 0x00, 0x31,
+  0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x02, 0x79, 0x65, 0x36, 0x36, 0x67, 0x66, 0xb0,
+  0x45, 0x99, 0x58, 0x57, 0x48, 0x49, 0x40, 0x6b, 0x3e, 0x40, 0x3e, 0x3c,
+  0x68, 0x8c, 0x85, 0x7c, 0x40, 0x47, 0x4c, 0x4c, 0x88, 0x54, 0x4d, 0x4c,
+  0x40, 0x51, 0x4c, 0x4c, 0x48, 0xd6, 0xe8, 0x7c, 0x02, 0x03, 0x18, 0x41,
+  0x40, 0x5d, 0x8d, 0x4f, 0x4e, 0x18, 0x18, 0xa7, 0x1d, 0x0d, 0x0d, 0x2e,
+  0x2e, 0x40, 0x46, 0x2d, 0x2c, 0x98, 0x33, 0x38, 0x58, 0x5a, 0x38, 0x38,
+  0x12, 0x13, 0x25, 0xab, 0x1c, 0x0e, 0x0e, 0xb6, 0xad, 0x6c, 0x92, 0x00,
+  0x00, 0x02, 0x00, 0xad, 0xfe, 0x4c, 0x01, 0x54, 0x04, 0x60, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x11, 0x35, 0x33, 0x15,
+  0xae, 0xa5, 0xa5, 0xa5, 0x04, 0x60, 0xfb, 0xa0, 0xfe, 0x4c, 0xe9, 0xe9,
+  0x00, 0x01, 0x00, 0x00, 0xff, 0xe3, 0x02, 0x3c, 0x04, 0x60, 0x00, 0x10,
+  0x00, 0x00, 0x3d, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11,
+  0x33, 0x11, 0x10, 0x06, 0x23, 0x22, 0x26, 0x3d, 0x84, 0x46, 0x5d, 0x29,
+  0x27, 0x88, 0x8f, 0xa7, 0x40, 0x81, 0x3d, 0xb9, 0x3c, 0x3d, 0x4d, 0x46,
+  0xd7, 0x02, 0x79, 0xfd, 0x87, 0xfe, 0xe6, 0xea, 0x2c, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x26, 0x04, 0x60, 0x10, 0x06,
+  0x00, 0xfa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x03, 0x96,
+  0x04, 0x7b, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x11, 0x37, 0x17, 0x07,
+  0x11, 0x21, 0x15, 0x21, 0x11, 0x07, 0x27, 0x37, 0xa7, 0xa7, 0x7b, 0x45,
+  0xc0, 0x02, 0x48, 0xfd, 0x11, 0x63, 0x42, 0xa5, 0x04, 0x7b, 0xfe, 0x64,
+  0x61, 0x6a, 0x97, 0xfe, 0x6b, 0xaa, 0x01, 0xbc, 0x4e, 0x6a, 0x83, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8, 0x04, 0x60, 0x10, 0x06,
+  0x03, 0xd0, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x07,
+  0x04, 0x60, 0x10, 0x06, 0x03, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90, 0x04, 0x7b, 0x10, 0x06,
+  0x02, 0x16, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0x00, 0x2d, 0x04, 0x89,
+  0x04, 0x31, 0x00, 0x0a, 0x00, 0x16, 0x00, 0x00, 0x01, 0x34, 0x26, 0x20,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x14, 0x00, 0x23, 0x22,
+  0x00, 0x35, 0x34, 0x00, 0x33, 0x32, 0x00, 0x03, 0xfc, 0xd0, 0xfe, 0x96,
+  0xd0, 0xd1, 0xb4, 0xb3, 0xd2, 0x8c, 0xfe, 0xe7, 0xf8, 0xf8, 0xfe, 0xe7,
+  0x01, 0x19, 0xf8, 0xf8, 0x01, 0x19, 0x02, 0x2f, 0x94, 0xac, 0xab, 0x95,
+  0x93, 0xac, 0xac, 0x93, 0xf0, 0xfe, 0xee, 0x01, 0x12, 0xf0, 0xf1, 0x01,
+  0x11, 0xfe, 0xef, 0x00, 0x00, 0x01, 0x00, 0x65, 0x00, 0x74, 0x04, 0x89,
+  0x03, 0xea, 0x00, 0x18, 0x00, 0x00, 0x25, 0x23, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x20, 0x06, 0x15, 0x14, 0x16, 0x17, 0x23, 0x2e, 0x01, 0x35, 0x34,
+  0x00, 0x33, 0x32, 0x00, 0x11, 0x14, 0x06, 0x04, 0x49, 0x9b, 0x27, 0x27,
+  0xcd, 0xfe, 0x8f, 0xcc, 0x27, 0x27, 0x9a, 0x20, 0x20, 0x01, 0x1e, 0xf3,
+  0xf7, 0x01, 0x1a, 0x1f, 0x74, 0x4e, 0x9d, 0x50, 0xb3, 0xc6, 0xc6, 0xb3,
+  0x50, 0x9d, 0x4e, 0x4d, 0xa5, 0x5d, 0xfd, 0x01, 0x2a, 0xfe, 0xd3, 0xfe,
+  0xfa, 0x55, 0xa2, 0x00, 0x00, 0x03, 0x00, 0x2d, 0x00, 0x05, 0x04, 0xc6,
+  0x04, 0x59, 0x00, 0x09, 0x00, 0x13, 0x00, 0x2b, 0x00, 0x00, 0x09, 0x01,
+  0x0e, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x3e, 0x01, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x27, 0x3e, 0x01, 0x33, 0x32, 0x00,
+  0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x00,
+  0x35, 0x34, 0x36, 0x37, 0x27, 0x37, 0x03, 0x53, 0xfd, 0xec, 0x26, 0x24,
+  0xd1, 0xb4, 0x47, 0x69, 0x8b, 0x25, 0x24, 0xd3, 0xbe, 0x41, 0x63, 0x29,
+  0x88, 0x45, 0xb1, 0x6c, 0xf8, 0x01, 0x19, 0x2e, 0x2f, 0x97, 0x47, 0xa1,
+  0x45, 0xb2, 0x6c, 0xf8, 0xfe, 0xe6, 0x2f, 0x2e, 0x97, 0x46, 0x01, 0x18,
+  0x01, 0xe7, 0x29, 0x67, 0x41, 0x93, 0xac, 0x14, 0x5c, 0x2a, 0x67, 0x3e,
+  0x97, 0xa9, 0x13, 0x14, 0x7d, 0x36, 0x36, 0xfe, 0xef, 0xf1, 0x5d, 0x9f,
+  0x43, 0x8b, 0x5f, 0x92, 0x35, 0x36, 0x01, 0x12, 0xf0, 0x60, 0xa1, 0x3f,
+  0x8b, 0x60, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65, 0xff, 0xe3, 0x06, 0xfd,
+  0x04, 0x7b, 0x00, 0x26, 0x00, 0x2f, 0x00, 0x3d, 0x00, 0x00, 0x13, 0x35,
+  0x21, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x11, 0x10,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x0e, 0x01, 0x23, 0x22, 0x27,
+  0x26, 0x37, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x01, 0x32,
+  0x37, 0x36, 0x10, 0x27, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x66, 0x02, 0xf9, 0x0b, 0x5c, 0x5b, 0xa5, 0x5f, 0xb4, 0x59, 0x5a, 0xbc,
+  0x5f, 0x90, 0xda, 0x49, 0x40, 0x5d, 0x5f, 0x7e, 0xd9, 0x7a, 0x7b, 0x7b,
+  0x7a, 0xd9, 0x7e, 0x5f, 0x5f, 0x3c, 0x46, 0xd1, 0x80, 0xcc, 0x77, 0x76,
+  0xa6, 0x02, 0x4a, 0x4a, 0x7b, 0x8a, 0x52, 0x54, 0x0d, 0x01, 0xd4, 0x85,
+  0x4d, 0x4e, 0x4d, 0x4d, 0x86, 0x85, 0x9a, 0x4d, 0x4d, 0x02, 0x00, 0x5a,
+  0xbe, 0x64, 0x63, 0x34, 0x34, 0xae, 0x2a, 0x2c, 0x6e, 0x6d, 0x6e, 0x36,
+  0x37, 0x9d, 0x9c, 0xfe, 0xed, 0xfe, 0xec, 0x9c, 0x9c, 0x37, 0x38, 0x6c,
+  0x6b, 0x70, 0x91, 0x92, 0xc4, 0x98, 0x5a, 0x59, 0x57, 0x57, 0x9e, 0xfe,
+  0xb4, 0x73, 0x74, 0x01, 0x92, 0x74, 0x73, 0xe8, 0xc8, 0xc7, 0x74, 0x75,
+  0x00, 0x01, 0x00, 0x65, 0x02, 0x2f, 0x04, 0x03, 0x04, 0x7b, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x23, 0x10, 0x12,
+  0x33, 0x32, 0x12, 0x11, 0x03, 0x53, 0x9a, 0x85, 0x85, 0x9b, 0xae, 0xf5,
+  0xd9, 0xd8, 0xf7, 0x02, 0x2f, 0xc7, 0xe9, 0xe7, 0xc9, 0x01, 0x14, 0x01,
+  0x38, 0xfe, 0xc8, 0xfe, 0xec, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x02, 0x2f, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x35, 0x33, 0x10, 0x02, 0x23, 0x22, 0x02, 0x11,
+  0x01, 0x15, 0x9b, 0x84, 0x86, 0x9a, 0xaf, 0xf6, 0xd9, 0xd8, 0xf6, 0x02,
+  0x2f, 0xc7, 0xe9, 0xe7, 0xc9, 0xfe, 0xec, 0xfe, 0xc8, 0x01, 0x38, 0x01,
+  0x14, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x87, 0x00, 0x00, 0x03, 0x6b,
+  0x04, 0x60, 0x00, 0x07, 0x00, 0x11, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32,
+  0x36, 0x34, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16, 0x10, 0x06, 0x2b, 0x01,
+  0x11, 0x23, 0x01, 0x2d, 0xe7, 0x52, 0x59, 0x59, 0x52, 0xfe, 0x74, 0x01,
+  0x8c, 0xa9, 0xae, 0xae, 0xa9, 0xe7, 0xa5, 0x03, 0xc5, 0xfe, 0x98, 0x5e,
+  0xac, 0x5e, 0x9b, 0xaa, 0xfe, 0xb6, 0xaa, 0xfe, 0x3e, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x03, 0xa8, 0x04, 0x60, 0x00, 0x16,
+  0x00, 0x21, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x33,
+  0x21, 0x11, 0x23, 0x11, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x23, 0x13,
+  0x36, 0x37, 0x36, 0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x3b, 0x01, 0x01, 0x89, 0x5f, 0x65, 0x60, 0x62, 0xc3, 0x01, 0x5d, 0xa6,
+  0x99, 0x57, 0x35, 0x35, 0x39, 0x92, 0xaf, 0x9d, 0x2f, 0x2f, 0x30, 0x01,
+  0xa9, 0xb3, 0x6b, 0x38, 0x3a, 0x3a, 0x38, 0x6b, 0xb3, 0x02, 0x0d, 0x1b,
+  0x8c, 0x69, 0xa2, 0x51, 0x50, 0xfb, 0xa0, 0x01, 0xd9, 0x25, 0x24, 0x71,
+  0xfe, 0xe1, 0x01, 0x32, 0x5e, 0x36, 0x36, 0x01, 0xc9, 0x2a, 0x2a, 0x54,
+  0x53, 0x2b, 0x2b, 0x00, 0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x03, 0xa8,
+  0x04, 0x60, 0x00, 0x16, 0x00, 0x21, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
+  0x27, 0x03, 0x33, 0x13, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x11, 0x33, 0x11,
+  0x21, 0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x01, 0x89, 0x31, 0x30, 0x2f, 0x2f,
+  0x9d, 0xaf, 0x92, 0x39, 0x35, 0x35, 0x57, 0x99, 0xa6, 0xfe, 0xa3, 0xc3,
+  0x62, 0x60, 0x65, 0x01, 0xd7, 0xb3, 0x6b, 0x38, 0x3a, 0x3a, 0x38, 0x6b,
+  0x02, 0x53, 0x11, 0x36, 0x36, 0x5e, 0x01, 0x32, 0xfe, 0xe1, 0x71, 0x24,
+  0x25, 0x01, 0xd9, 0xfb, 0xa0, 0x50, 0x51, 0xa2, 0x69, 0x8c, 0xfe, 0x63,
+  0x01, 0x51, 0x2b, 0x2b, 0x53, 0x54, 0x2a, 0x2a, 0xff, 0xff, 0x00, 0x36,
+  0x00, 0x00, 0x03, 0xfc, 0x04, 0x60, 0x10, 0x06, 0x03, 0xd6, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0xff, 0xe0, 0x03, 0xac, 0x04, 0x60, 0x00, 0x0f,
+  0x00, 0x00, 0x24, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x06, 0x20,
+  0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x01, 0xb5, 0xe9, 0x67, 0xa7, 0xc4,
+  0xfe, 0x83, 0xc4, 0xa7, 0x7d, 0x8e, 0xa2, 0x02, 0xb3, 0xfd, 0x3b, 0xdb,
+  0xe0, 0xe0, 0xdb, 0x02, 0xc5, 0xfd, 0x4d, 0xa2, 0x00, 0x01, 0x00, 0x9c,
+  0x00, 0x4c, 0x04, 0xa7, 0x03, 0xf6, 0x00, 0x13, 0x00, 0x00, 0x25, 0x21,
+  0x35, 0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15,
+  0x23, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x02, 0xff, 0xfd, 0x9e, 0x02, 0x5b,
+  0x90, 0x8f, 0xab, 0x94, 0xfd, 0xc5, 0x03, 0xf0, 0x9b, 0x5c, 0x59, 0xd8,
+  0x4c, 0xb8, 0x7c, 0x7c, 0x96, 0xac, 0xb8, 0xb8, 0x42, 0xb2, 0x74, 0xc2,
+  0xc8, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x9c, 0x00, 0x4e, 0x06, 0x2c,
+  0x03, 0xf8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x35,
+  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x05, 0x21, 0x35, 0x21, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15, 0x23, 0x1e, 0x01, 0x15,
+  0x14, 0x06, 0x9d, 0xb5, 0xb5, 0xb5, 0x03, 0x32, 0xfd, 0x9d, 0x02, 0x5c,
+  0x8f, 0x90, 0xac, 0x93, 0xfd, 0xc4, 0x03, 0xf0, 0x9a, 0x5b, 0x5a, 0xd8,
+  0x02, 0x78, 0xcc, 0xcc, 0xfe, 0x7a, 0xca, 0xca, 0xa4, 0xb8, 0x7c, 0x7c,
+  0x94, 0xae, 0xb8, 0xb8, 0x44, 0xb0, 0x76, 0xc0, 0xc8, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x2a, 0xfe, 0x18, 0x04, 0x33, 0x04, 0x7b, 0x00, 0x26,
+  0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x23, 0x21, 0x35,
+  0x21, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15, 0x23, 0x1e,
+  0x01, 0x15, 0x14, 0x07, 0x06, 0x03, 0x59, 0x6f, 0x6b, 0x6e, 0x6f, 0xcb,
+  0xfd, 0x9f, 0x02, 0x5b, 0x91, 0x8d, 0xab, 0x94, 0xfd, 0xc6, 0x02, 0x5b,
+  0x92, 0x45, 0x47, 0x57, 0x55, 0x93, 0xfd, 0xc6, 0x03, 0xf0, 0x9c, 0x5c,
+  0x59, 0x38, 0x38, 0x01, 0x0c, 0x45, 0xc0, 0x82, 0xaf, 0x5f, 0x5f, 0xb9,
+  0x72, 0x75, 0x8f, 0xa6, 0xb9, 0x39, 0x39, 0x77, 0x8d, 0x53, 0x53, 0xb9,
+  0xb9, 0x3f, 0xb0, 0x79, 0x7a, 0x56, 0x55, 0x00, 0xff, 0xff, 0x00, 0x36,
+  0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x10, 0x06, 0x00, 0x59, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97, 0x04, 0x60, 0x10, 0x06,
+  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79,
+  0x04, 0x60, 0x10, 0x06, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6c,
+  0xff, 0xe3, 0x03, 0x5b, 0x04, 0x60, 0x00, 0x17, 0x00, 0x00, 0x37, 0x16,
+  0x33, 0x32, 0x36, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x13, 0x25, 0x35, 0x21,
+  0x15, 0x03, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x20, 0x27, 0x7c, 0x91,
+  0xbe, 0x73, 0x77, 0x6f, 0x63, 0x72, 0xef, 0xfe, 0x0c, 0x02, 0xb3, 0xef,
+  0x3f, 0x88, 0x64, 0xce, 0xfe, 0xa4, 0xb5, 0xbd, 0x42, 0x64, 0xbb, 0x64,
+  0x90, 0x01, 0x3e, 0x01, 0x93, 0x93, 0xfe, 0xc2, 0x4a, 0x9f, 0x6d, 0xa0,
+  0xb6, 0x37, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa1, 0x00, 0x00, 0x03, 0x96,
+  0x04, 0x7b, 0x00, 0x05, 0x00, 0x00, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0xa1, 0x02, 0xf5, 0xfd, 0xc1, 0x04, 0x7b, 0xaa, 0xfc, 0x2f, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c, 0x04, 0x60, 0x10, 0x06,
+  0x02, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x87, 0x00, 0x00, 0x03, 0x88,
+  0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x03, 0x88, 0xa4, 0xfe, 0x48, 0xa4, 0x04, 0x60, 0xfb, 0xa0,
+  0x03, 0xb7, 0xfc, 0x49, 0x04, 0x60, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87,
+  0x00, 0x00, 0x03, 0x6b, 0x04, 0x60, 0x10, 0x06, 0x04, 0xd1, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x51, 0x00, 0x00, 0x03, 0xef, 0x04, 0x60, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x36, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11,
+  0x10, 0x07, 0x06, 0x07, 0x15, 0x23, 0x35, 0x26, 0x27, 0x26, 0x19, 0x01,
+  0x33, 0x11, 0x14, 0x17, 0x16, 0x17, 0x01, 0xcd, 0xa5, 0x4d, 0x33, 0x4e,
+  0xae, 0x7a, 0x62, 0xa0, 0xa5, 0x9e, 0x62, 0x7c, 0xb0, 0x4e, 0x33, 0x4b,
+  0x04, 0x60, 0xfd, 0x31, 0x1a, 0x4d, 0x73, 0xc9, 0x01, 0x2c, 0xfe, 0xd4,
+  0xfe, 0xec, 0x9c, 0x7d, 0x19, 0xee, 0xee, 0x19, 0x7d, 0x9c, 0x01, 0x14,
+  0x01, 0x2c, 0xfe, 0xd4, 0xc7, 0x75, 0x4d, 0x1a, 0xff, 0xff, 0x00, 0x44,
+  0x00, 0x00, 0x04, 0x02, 0x04, 0x60, 0x10, 0x06, 0x03, 0xcf, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x09, 0x02, 0x9c, 0x03, 0x11, 0x05, 0xe0, 0x00, 0x02,
+  0x00, 0x0a, 0x00, 0x00, 0x01, 0x03, 0x21, 0x03, 0x33, 0x01, 0x23, 0x27,
+  0x21, 0x07, 0x23, 0x01, 0x8d, 0x9c, 0x01, 0x38, 0xdd, 0x82, 0x01, 0x43,
+  0x77, 0x4d, 0xfe, 0x82, 0x4d, 0x79, 0x05, 0x71, 0xfe, 0x60, 0x02, 0x0f,
+  0xfc, 0xbc, 0xd6, 0xd6, 0x00, 0x02, 0x00, 0x04, 0x02, 0x9c, 0x04, 0x21,
+  0x05, 0xe0, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x01, 0x15, 0x21, 0x15,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x35, 0x21, 0x07, 0x23, 0x01,
+  0x17, 0x03, 0x21, 0x11, 0x04, 0x16, 0xfe, 0x5c, 0x01, 0x93, 0xfe, 0x6d,
+  0x01, 0xaf, 0xfd, 0xde, 0xfe, 0xd5, 0x5b, 0x75, 0x01, 0x63, 0x4e, 0xbb,
+  0x01, 0x05, 0x05, 0xe0, 0x5f, 0xf8, 0x5f, 0xfe, 0xd1, 0x5f, 0xd6, 0xd6,
+  0x03, 0x44, 0x58, 0xfe, 0x49, 0x01, 0xb7, 0x00, 0x00, 0x03, 0x00, 0x72,
+  0x02, 0x9c, 0x02, 0xcb, 0x05, 0xe0, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x26,
+  0x00, 0x00, 0x13, 0x11, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x23, 0x03, 0x15, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
+  0x25, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x23, 0x21, 0xe5, 0xb7, 0x5d, 0x2c, 0x2d, 0x2d, 0x2c,
+  0x5d, 0xb7, 0xa9, 0x54, 0x29, 0x29, 0x29, 0x29, 0x54, 0xfe, 0xe4, 0x01,
+  0x25, 0x82, 0x47, 0x48, 0x25, 0x24, 0x47, 0x55, 0x5e, 0x9b, 0x8e, 0xfe,
+  0xd0, 0x04, 0x2b, 0xfe, 0xce, 0x26, 0x26, 0x4d, 0x4f, 0x25, 0x25, 0x01,
+  0x58, 0xfc, 0x1f, 0x1f, 0x40, 0x3f, 0x20, 0x1f, 0x5d, 0x36, 0x35, 0x64,
+  0x4c, 0x2e, 0x2d, 0x0b, 0x12, 0x72, 0x55, 0x70, 0x7a, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x72, 0x02, 0x9c, 0x03, 0x3a, 0x05, 0xe0, 0x00, 0x0a,
+  0x00, 0x15, 0x00, 0x00, 0x13, 0x11, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x23, 0x27, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x2b, 0x01, 0xe5, 0x8a, 0xaf, 0x52, 0x51, 0x51, 0x52, 0xaf, 0xfd, 0xeb,
+  0xf7, 0x72, 0x73, 0x73, 0x74, 0xf5, 0xeb, 0x05, 0x83, 0xfd, 0x76, 0x4e,
+  0x4f, 0xa9, 0xa8, 0x4e, 0x4e, 0x5d, 0x65, 0x65, 0xd7, 0xd8, 0x66, 0x65,
+  0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0x94, 0x05, 0xe0, 0x00, 0x0b,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x72, 0x02, 0x17, 0xfe, 0x5c, 0x01, 0x93, 0xfe, 0x6d, 0x01,
+  0xaf, 0xfd, 0xde, 0x05, 0xe0, 0x5f, 0xf8, 0x5f, 0xfe, 0xd1, 0x5f, 0x00,
+  0x00, 0x01, 0x00, 0x4a, 0x02, 0x9c, 0x02, 0x6d, 0x05, 0xe0, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x35,
+  0x21, 0x35, 0x02, 0x6c, 0xfd, 0xdf, 0x01, 0xae, 0xfe, 0x6d, 0x01, 0x93,
+  0xfe, 0x5c, 0x05, 0xe0, 0xfc, 0xbc, 0x5f, 0x01, 0x2f, 0x5f, 0xf8, 0x5f,
+  0x00, 0x01, 0x00, 0x40, 0x02, 0x8c, 0x03, 0x25, 0x05, 0xef, 0x00, 0x24,
+  0x00, 0x00, 0x01, 0x35, 0x23, 0x35, 0x21, 0x11, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x36, 0x02, 0xb3, 0xbb, 0x01, 0x2d, 0x43, 0x50, 0x4f, 0x5b,
+  0xc7, 0x70, 0x70, 0x70, 0x70, 0xc7, 0x53, 0x4a, 0x4a, 0x3f, 0x3f, 0x48,
+  0x47, 0x4e, 0x9c, 0x4e, 0x4e, 0x4e, 0x4e, 0x9c, 0x3c, 0x5f, 0x03, 0x13,
+  0xe1, 0x5d, 0xfe, 0x99, 0x2f, 0x17, 0x18, 0x72, 0x73, 0xcc, 0xcd, 0x73,
+  0x72, 0x14, 0x14, 0x27, 0x79, 0x35, 0x1b, 0x1b, 0x55, 0x56, 0xaa, 0xa9,
+  0x56, 0x55, 0x14, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf8,
+  0x05, 0xe0, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33,
+  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x72, 0x73, 0x01, 0x9f, 0x74, 0x74,
+  0xfe, 0x61, 0x73, 0x05, 0xe0, 0xfe, 0xa9, 0x01, 0x57, 0xfc, 0xbc, 0x01,
+  0x8e, 0xfe, 0x72, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x00, 0xe5,
+  0x05, 0xe0, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x72, 0x73,
+  0x73, 0x05, 0xe0, 0xfc, 0xbc, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xc3,
+  0x01, 0xb6, 0x00, 0xe5, 0x05, 0xe0, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x72,
+  0x73, 0x3b, 0x3a, 0x80, 0x2c, 0x24, 0x4b, 0x3f, 0x05, 0xe0, 0xfc, 0xf6,
+  0x97, 0x44, 0x45, 0x60, 0x54, 0x6c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72,
+  0x02, 0x9c, 0x03, 0x12, 0x05, 0xe0, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x72, 0x73, 0x01,
+  0x7b, 0x94, 0xfe, 0x5c, 0x01, 0xc2, 0x97, 0xfe, 0x6a, 0x73, 0x05, 0xe0,
+  0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe, 0x6d,
+  0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0x81, 0x05, 0xe0, 0x00, 0x05,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x21, 0x72, 0x73, 0x01, 0x9c,
+  0xfd, 0xf1, 0x05, 0xe0, 0xfd, 0x1b, 0x5f, 0x00, 0x00, 0x01, 0x00, 0x72,
+  0x02, 0x9c, 0x03, 0x79, 0x05, 0xe0, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33,
+  0x1b, 0x01, 0x33, 0x11, 0x23, 0x11, 0x03, 0x23, 0x03, 0x11, 0x23, 0x72,
+  0xaa, 0xd8, 0xda, 0xaa, 0x6f, 0xda, 0x73, 0xdb, 0x6f, 0x05, 0xe0, 0xfd,
+  0xc7, 0x02, 0x39, 0xfc, 0xbc, 0x02, 0xde, 0xfd, 0xc3, 0x02, 0x3d, 0xfd,
+  0x22, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf4,
+  0x05, 0xe0, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
+  0x23, 0x01, 0x11, 0x23, 0x72, 0x9a, 0x01, 0x78, 0x6f, 0x9b, 0xfe, 0x89,
+  0x6f, 0x05, 0xe0, 0xfd, 0x45, 0x02, 0xbb, 0xfc, 0xbc, 0x02, 0xbb, 0xfd,
+  0x45, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf4,
+  0x05, 0xe0, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x01, 0x23,
+  0x11, 0x33, 0x11, 0x01, 0x02, 0xf3, 0x6f, 0xfe, 0x88, 0x9a, 0x6f, 0x01,
+  0x77, 0x05, 0xe0, 0xfc, 0xbc, 0x02, 0xbb, 0xfd, 0x45, 0x03, 0x44, 0xfd,
+  0x45, 0x02, 0xbb, 0x00, 0x00, 0x02, 0x00, 0x40, 0x02, 0x8c, 0x03, 0x51,
+  0x05, 0xef, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x24, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x20, 0x27, 0x26, 0x10,
+  0x01, 0xc9, 0x7c, 0x4a, 0x49, 0x49, 0x4a, 0x7c, 0x7d, 0x49, 0x49, 0x49,
+  0x49, 0xfe, 0xd1, 0x01, 0x64, 0x6b, 0x6b, 0x6b, 0x6b, 0xfe, 0x9c, 0x6b,
+  0x6b, 0x05, 0x93, 0x5b, 0x5c, 0x9f, 0x9e, 0x5c, 0x5b, 0x5b, 0x5c, 0x9e,
+  0x9f, 0x5c, 0x5b, 0x5c, 0x76, 0x76, 0xc6, 0xc5, 0x76, 0x76, 0x75, 0x76,
+  0x01, 0x8c, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0xeb,
+  0x05, 0xef, 0x00, 0x0f, 0x00, 0x40, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x03, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x27, 0x35, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x01, 0x95, 0x67, 0x3d, 0x3d, 0x3d, 0x3d, 0x67, 0x68, 0x3e, 0x3c,
+  0x3c, 0x3c, 0x8a, 0x4a, 0x31, 0x30, 0x36, 0x22, 0x73, 0x5f, 0x36, 0x37,
+  0x2b, 0x3e, 0x4a, 0x82, 0x54, 0x50, 0x31, 0x30, 0x56, 0x61, 0x36, 0x37,
+  0x59, 0x57, 0xa6, 0xa5, 0xb0, 0x37, 0x37, 0x61, 0x61, 0x26, 0x31, 0x4a,
+  0x42, 0x92, 0x04, 0x29, 0x2b, 0x2b, 0x4c, 0x4b, 0x2c, 0x2b, 0x2b, 0x2c,
+  0x4b, 0x4c, 0x2b, 0x2b, 0x01, 0x35, 0x02, 0x23, 0x23, 0x2c, 0x26, 0x29,
+  0x19, 0x24, 0x25, 0x4c, 0x59, 0x18, 0x2b, 0x04, 0x38, 0x3a, 0x36, 0x69,
+  0x47, 0x32, 0x32, 0x12, 0x13, 0x37, 0x38, 0x50, 0x79, 0x41, 0x41, 0x82,
+  0x79, 0x50, 0x38, 0x37, 0x13, 0x12, 0x27, 0x32, 0x31, 0x49, 0x2e, 0x2a,
+  0x00, 0x02, 0x00, 0x72, 0x02, 0x9c, 0x02, 0x95, 0x05, 0xe0, 0x00, 0x09,
+  0x00, 0x15, 0x00, 0x00, 0x13, 0x11, 0x33, 0x32, 0x37, 0x36, 0x34, 0x27,
+  0x26, 0x23, 0x25, 0x21, 0x32, 0x17, 0x16, 0x14, 0x07, 0x06, 0x2b, 0x01,
+  0x11, 0x23, 0xe5, 0x90, 0x50, 0x2b, 0x2c, 0x2c, 0x2b, 0x50, 0xfe, 0xfd,
+  0x01, 0x03, 0x8e, 0x49, 0x49, 0x49, 0x49, 0x8e, 0x90, 0x73, 0x05, 0x83,
+  0xfe, 0xc6, 0x29, 0x29, 0x96, 0x29, 0x29, 0x5d, 0x3f, 0x40, 0xf6, 0x40,
+  0x3f, 0xfe, 0xb0, 0x00, 0x00, 0x02, 0x00, 0x72, 0x02, 0x9c, 0x03, 0x06,
+  0x05, 0xe0, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16,
+  0x1f, 0x01, 0x23, 0x27, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x11, 0x23, 0x11,
+  0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x11, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x02, 0x04, 0x25, 0x22, 0x23, 0x23, 0x74,
+  0x7a, 0x6d, 0x2a, 0x27, 0x28, 0x44, 0x7c, 0x73, 0x01, 0x03, 0x91, 0x48,
+  0x47, 0x25, 0x26, 0xfe, 0x9b, 0x90, 0x52, 0x55, 0x55, 0x52, 0x04, 0x24,
+  0x0c, 0x29, 0x28, 0x47, 0xe4, 0xd6, 0x54, 0x1c, 0x1b, 0xfe, 0x9f, 0x03,
+  0x44, 0x3c, 0x3c, 0x79, 0x4f, 0x34, 0x34, 0x01, 0x4b, 0xfe, 0xd7, 0x4c,
+  0x49, 0x4a, 0x4a, 0x00, 0x00, 0x01, 0xff, 0xfc, 0x02, 0x9c, 0x02, 0xc9,
+  0x05, 0xe0, 0x00, 0x07, 0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x04, 0x02, 0xcd, 0xfe, 0xd3, 0x73, 0xfe, 0xd3, 0x05, 0xe0,
+  0x5f, 0xfd, 0x1b, 0x02, 0xe5, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64,
+  0x02, 0x8c, 0x02, 0xed, 0x05, 0xe0, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14,
+  0x07, 0x06, 0x20, 0x27, 0x26, 0x35, 0x65, 0x73, 0x63, 0x6e, 0x6f, 0x31,
+  0x31, 0x73, 0x52, 0x52, 0xfe, 0xc0, 0x52, 0x52, 0x05, 0xe0, 0xfe, 0x04,
+  0x86, 0x76, 0x3b, 0x3b, 0x86, 0x01, 0xfc, 0xfd, 0xf6, 0xa3, 0x54, 0x53,
+  0x53, 0x54, 0xa3, 0x00, 0x00, 0x01, 0x00, 0x26, 0x02, 0x9c, 0x04, 0x57,
+  0x05, 0xe0, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x1b,
+  0x01, 0x33, 0x03, 0x23, 0x0b, 0x01, 0x23, 0x27, 0x73, 0xb2, 0xb1, 0x81,
+  0xb2, 0xb2, 0x75, 0xd6, 0x90, 0xb2, 0xb5, 0x90, 0x05, 0xe0, 0xfd, 0x3d,
+  0x02, 0xc3, 0xfd, 0x3d, 0x02, 0xc3, 0xfc, 0xbc, 0x02, 0xd6, 0xfd, 0x2a,
+  0x00, 0x02, 0x00, 0x45, 0x02, 0x8c, 0x02, 0x5e, 0x05, 0x1e, 0x00, 0x0c,
+  0x00, 0x2b, 0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x3d, 0x01, 0x37, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x01, 0x8e, 0x7e, 0x31, 0x31, 0x4a, 0x3e, 0x57, 0x34, 0x35, 0x68, 0x68,
+  0x24, 0x35, 0x36, 0x4c, 0x63, 0x73, 0x90, 0x8f, 0x92, 0x5f, 0x56, 0x36,
+  0x34, 0x33, 0x30, 0x3a, 0x36, 0x35, 0x33, 0x8a, 0x44, 0x44, 0x03, 0xd7,
+  0x1c, 0x1d, 0x45, 0x37, 0x40, 0x3d, 0x3d, 0x64, 0x17, 0x2b, 0xfe, 0x9a,
+  0x5f, 0x39, 0x1b, 0x1b, 0x6c, 0x5b, 0x69, 0x6c, 0x0a, 0x47, 0x4e, 0x0d,
+  0x0d, 0x1a, 0x60, 0x15, 0x0b, 0x0b, 0x46, 0x47, 0x00, 0x02, 0x00, 0x45,
+  0x02, 0x8c, 0x02, 0x5e, 0x05, 0x1e, 0x00, 0x0c, 0x00, 0x2d, 0x00, 0x00,
+  0x01, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x1d,
+  0x01, 0x07, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x16,
+  0x7e, 0x31, 0x31, 0x4a, 0x3f, 0x56, 0x34, 0x35, 0x69, 0x69, 0x24, 0x35,
+  0x36, 0x4c, 0x62, 0x3a, 0x39, 0x48, 0x47, 0x8f, 0x92, 0x5f, 0x56, 0x36,
+  0x34, 0x33, 0x30, 0x3a, 0x36, 0x36, 0x32, 0x8a, 0x44, 0x45, 0x03, 0xd3,
+  0x1c, 0x1d, 0x45, 0x37, 0x40, 0x3d, 0x3c, 0x65, 0x17, 0x2b, 0x01, 0x66,
+  0x5f, 0x39, 0x1b, 0x1b, 0x36, 0x36, 0x5a, 0x6a, 0x36, 0x36, 0x0a, 0x47,
+  0x4e, 0x0d, 0x0d, 0x1a, 0x60, 0x15, 0x0c, 0x0a, 0x46, 0x47, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x78, 0x05, 0x1e, 0x00, 0x13,
+  0x00, 0x1f, 0x00, 0x00, 0x01, 0x35, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x04, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x34, 0x27, 0x26, 0x22, 0x07,
+  0x02, 0x0f, 0x69, 0x69, 0x21, 0x31, 0x33, 0x46, 0x73, 0x49, 0x48, 0x48,
+  0x49, 0x73, 0x46, 0x33, 0x31, 0xfe, 0xbe, 0x2f, 0x2f, 0xa6, 0x30, 0x2f,
+  0x2f, 0x30, 0xa6, 0x2f, 0x04, 0xb0, 0x5f, 0xfd, 0x8d, 0x5e, 0x38, 0x1b,
+  0x1b, 0x5a, 0x5b, 0x01, 0x28, 0x5b, 0x5a, 0x1b, 0x1b, 0xa1, 0xe4, 0x41,
+  0x40, 0x40, 0x41, 0xe4, 0x41, 0x40, 0x40, 0x00, 0x00, 0x03, 0x00, 0x45,
+  0x02, 0x8c, 0x04, 0x38, 0x05, 0x1e, 0x00, 0x33, 0x00, 0x3c, 0x00, 0x4a,
+  0x00, 0x00, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x21,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x2b, 0x01, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37,
+  0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x25, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x3f, 0x01, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x1d, 0x01, 0x02, 0x49, 0x2a, 0x79, 0x4b, 0x7f, 0x4b,
+  0x4c, 0x01, 0xe0, 0x06, 0x3a, 0x3a, 0x68, 0x3a, 0x72, 0x39, 0x39, 0x3b,
+  0x3b, 0x3b, 0x60, 0x46, 0x46, 0x2c, 0x29, 0x3d, 0x3d, 0x52, 0x6b, 0x77,
+  0x48, 0x47, 0x8f, 0x92, 0x2f, 0x30, 0x55, 0x37, 0x67, 0x2f, 0x38, 0x6c,
+  0x34, 0x50, 0x78, 0xfe, 0x47, 0x01, 0x2e, 0x2f, 0x4d, 0x57, 0x35, 0x34,
+  0x08, 0xcd, 0x7f, 0x30, 0x31, 0x25, 0x24, 0x3f, 0x57, 0x35, 0x34, 0x02,
+  0xf3, 0x33, 0x34, 0x51, 0x52, 0x8c, 0x32, 0x6b, 0x38, 0x38, 0x1e, 0x1d,
+  0x61, 0x18, 0x0c, 0x0c, 0x22, 0x21, 0x43, 0x43, 0x22, 0x21, 0x68, 0x5e,
+  0x6a, 0x36, 0x36, 0x0a, 0x47, 0x27, 0x27, 0x1a, 0x1a, 0x60, 0x15, 0x16,
+  0x36, 0xda, 0x54, 0x32, 0x33, 0x31, 0x31, 0x58, 0x36, 0x1c, 0x1d, 0x45,
+  0x37, 0x20, 0x20, 0x3d, 0x3c, 0x65, 0x17, 0x00, 0x00, 0x02, 0x00, 0x69,
+  0x02, 0x8c, 0x02, 0xa2, 0x06, 0x03, 0x00, 0x0b, 0x00, 0x1d, 0x00, 0x00,
+  0x00, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x14, 0x17, 0x16, 0x32, 0x37,
+  0x01, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x15, 0x23, 0x11, 0x33, 0x02, 0x35, 0x2f, 0x2f, 0xa6, 0x30,
+  0x2e, 0x2e, 0x30, 0xa6, 0x2f, 0xfe, 0xcd, 0x20, 0x65, 0x45, 0x74, 0x48,
+  0x48, 0x48, 0x48, 0x74, 0x45, 0x65, 0x20, 0x6a, 0x6a, 0x03, 0x63, 0xe4,
+  0x40, 0x41, 0x41, 0x40, 0xe4, 0x40, 0x41, 0x41, 0x01, 0x8d, 0x38, 0x36,
+  0x5a, 0x5b, 0xfe, 0xd8, 0x5b, 0x5a, 0x36, 0x38, 0x5e, 0x03, 0x67, 0x00,
+  0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x78, 0x06, 0x03, 0x00, 0x13,
+  0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x04, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x34, 0x27, 0x26, 0x22, 0x07,
+  0x02, 0x0f, 0x69, 0x69, 0x21, 0x31, 0x33, 0x46, 0x73, 0x48, 0x49, 0x49,
+  0x48, 0x73, 0x46, 0x33, 0x31, 0xfe, 0xbe, 0x2f, 0x2f, 0xa6, 0x30, 0x2f,
+  0x2f, 0x30, 0xa6, 0x2f, 0x04, 0xb0, 0x01, 0x53, 0xfc, 0x99, 0x5e, 0x38,
+  0x1b, 0x1b, 0x5a, 0x5b, 0x01, 0x28, 0x5b, 0x5a, 0x1b, 0x1b, 0xa1, 0xe4,
+  0x40, 0x41, 0x41, 0x40, 0xe4, 0x40, 0x41, 0x41, 0x00, 0x02, 0x00, 0x3f,
+  0x02, 0x8c, 0x02, 0x8d, 0x05, 0x1e, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x00,
+  0x01, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x07, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
+  0x02, 0x8c, 0xfe, 0x21, 0x07, 0x3a, 0x3a, 0x68, 0x3c, 0x39, 0x37, 0x38,
+  0x38, 0x3b, 0x3b, 0x3d, 0x98, 0x58, 0x59, 0x54, 0x54, 0x8f, 0x80, 0x4b,
+  0x4a, 0x68, 0x01, 0x2f, 0x2e, 0x4e, 0x57, 0x34, 0x35, 0x08, 0x03, 0xef,
+  0x32, 0x6a, 0x38, 0x38, 0x0f, 0x0e, 0x1d, 0x61, 0x18, 0x0c, 0x0c, 0x57,
+  0x57, 0x95, 0x9a, 0x5b, 0x5a, 0x51, 0x52, 0x6d, 0x54, 0x33, 0x32, 0x31,
+  0x30, 0x58, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x8d,
+  0x05, 0x1e, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x35, 0x21, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x37, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37,
+  0x40, 0x01, 0xe0, 0x07, 0x75, 0x67, 0x3d, 0x70, 0x38, 0x39, 0x76, 0x3c,
+  0x98, 0xb1, 0xa8, 0x8f, 0x80, 0x95, 0x68, 0x01, 0x5e, 0x4d, 0x58, 0x69,
+  0x07, 0x03, 0xbb, 0x32, 0x6b, 0x6f, 0x1d, 0x1d, 0x61, 0x18, 0x18, 0xae,
+  0x95, 0x9a, 0xb5, 0xa3, 0x6d, 0x54, 0x65, 0x62, 0x58, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x4b, 0x02, 0x8c, 0x02, 0x25, 0x05, 0x1f, 0x00, 0x32,
+  0x00, 0x00, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0xe0, 0x40, 0x22, 0x21, 0x41, 0x3f, 0x6f,
+  0x2b, 0x31, 0x30, 0x37, 0x37, 0x5b, 0x28, 0x43, 0x28, 0x28, 0x27, 0x26,
+  0x42, 0x58, 0x54, 0x4e, 0x29, 0x2c, 0x30, 0x30, 0x55, 0x35, 0x31, 0x2f,
+  0x29, 0x33, 0x30, 0x30, 0x2e, 0x87, 0x91, 0x26, 0x28, 0x03, 0xee, 0x0e,
+  0x24, 0x24, 0x34, 0x4f, 0x2c, 0x2c, 0x07, 0x07, 0x0d, 0x5e, 0x11, 0x0e,
+  0x19, 0x1a, 0x24, 0x27, 0x19, 0x19, 0x55, 0x1d, 0x1f, 0x31, 0x33, 0x1f,
+  0x20, 0x0b, 0x0a, 0x15, 0x60, 0x10, 0x07, 0x08, 0x66, 0x61, 0x3c, 0x29,
+  0x29, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x49, 0x02, 0x8c, 0x02, 0x24,
+  0x05, 0x1f, 0x00, 0x31, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x8f, 0x3f, 0x44,
+  0x41, 0x40, 0x6e, 0x2b, 0x31, 0x30, 0x38, 0x37, 0x2d, 0x2e, 0x29, 0x43,
+  0x4f, 0x26, 0x26, 0x42, 0x58, 0x54, 0x4d, 0x29, 0x2d, 0x30, 0x31, 0x55,
+  0x34, 0x31, 0x30, 0x28, 0x33, 0x5f, 0x2e, 0x86, 0x4a, 0x49, 0x27, 0x27,
+  0x03, 0xbc, 0x0d, 0x48, 0x34, 0x4f, 0x2d, 0x2b, 0x06, 0x07, 0x0e, 0x5d,
+  0x10, 0x07, 0x08, 0x34, 0x24, 0x27, 0x19, 0x19, 0x55, 0x1c, 0x20, 0x31,
+  0x32, 0x20, 0x1f, 0x0a, 0x0b, 0x14, 0x60, 0x0f, 0x10, 0x33, 0x33, 0x61,
+  0x3c, 0x29, 0x29, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x01, 0xad, 0x02, 0x78,
+  0x05, 0x1e, 0x00, 0x0d, 0x00, 0x31, 0x00, 0x00, 0x00, 0x34, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x17, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x35, 0x33, 0x02, 0x0f,
+  0x2e, 0x2f, 0x55, 0x53, 0x2f, 0x2f, 0x2f, 0x2f, 0x53, 0x55, 0x2f, 0x97,
+  0x48, 0x48, 0x95, 0x37, 0x31, 0x31, 0x2e, 0x2e, 0x2d, 0x2d, 0x2e, 0x67,
+  0x33, 0x33, 0x20, 0x32, 0x33, 0x46, 0x75, 0x47, 0x48, 0x48, 0x47, 0x75,
+  0x46, 0x33, 0x32, 0x20, 0x69, 0x03, 0x6d, 0xe0, 0x3d, 0x3e, 0x3e, 0x3d,
+  0xe0, 0x3d, 0x3e, 0x3e, 0x46, 0xa0, 0x4e, 0x4f, 0x09, 0x08, 0x10, 0x65,
+  0x19, 0x0c, 0x0b, 0x34, 0x35, 0x6b, 0x33, 0x37, 0x1c, 0x1b, 0x58, 0x58,
+  0x01, 0x22, 0x58, 0x58, 0x1b, 0x1c, 0x37, 0x5f, 0x00, 0x02, 0x00, 0x6d,
+  0x01, 0xa8, 0x00, 0xd7, 0x05, 0x0f, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x23, 0x15, 0x35, 0x33, 0x15, 0x6e, 0x68, 0x68, 0x68,
+  0x05, 0x0f, 0xfd, 0x8d, 0xf4, 0x82, 0x82, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x02, 0x9c, 0x02, 0x9d, 0x06, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x69, 0x6a, 0x01,
+  0x37, 0x85, 0xfe, 0xaf, 0x01, 0x5f, 0x88, 0xfe, 0xbe, 0x6a, 0x06, 0x03,
+  0xfd, 0xfe, 0x01, 0x0e, 0xfe, 0xdb, 0xfe, 0xb2, 0x01, 0x32, 0xfe, 0xce,
+  0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x04, 0x09, 0x05, 0x1e, 0x00, 0x22,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x3e,
+  0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x02, 0x6d, 0x68, 0x41, 0x44, 0x50, 0x5d, 0x6a, 0x6a, 0x23, 0x64,
+  0x45, 0x44, 0x61, 0x18, 0x27, 0x6d, 0x49, 0x64, 0x6b, 0x68, 0x41, 0x43,
+  0x50, 0x5f, 0x03, 0xfe, 0xfe, 0x9e, 0x01, 0x77, 0x5b, 0x57, 0x6b, 0x5c,
+  0xfe, 0x9e, 0x02, 0x73, 0x61, 0x39, 0x37, 0x45, 0x42, 0x45, 0x42, 0x89,
+  0x7e, 0xfe, 0x85, 0x01, 0x77, 0x5a, 0x58, 0x6b, 0x00, 0x01, 0x00, 0x69,
+  0x01, 0xad, 0x02, 0x7e, 0x05, 0x1e, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x11,
+  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x02, 0x7d, 0x2f, 0x2e, 0x66, 0x90, 0x84,
+  0x3c, 0x2b, 0x46, 0x47, 0x54, 0x61, 0x6a, 0x6a, 0x25, 0x32, 0x33, 0x43,
+  0x6d, 0x38, 0x38, 0x04, 0x17, 0xfe, 0x7a, 0x78, 0x36, 0x36, 0x58, 0x36,
+  0x56, 0x01, 0x82, 0x59, 0x59, 0x6b, 0x5c, 0xfe, 0x9e, 0x02, 0x73, 0x61,
+  0x38, 0x1c, 0x1c, 0x42, 0x44, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f,
+  0x02, 0x8c, 0x02, 0x88, 0x05, 0x1e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x27, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
+  0x01, 0x64, 0x54, 0x62, 0x61, 0x55, 0x53, 0x61, 0x61, 0x53, 0x87, 0x9c,
+  0x9c, 0x87, 0x89, 0x9b, 0x9b, 0x04, 0xc7, 0x81, 0x71, 0x71, 0x81, 0x82,
+  0x70, 0x6f, 0x83, 0x57, 0xae, 0x9b, 0x9a, 0xaf, 0xaf, 0x9a, 0x9b, 0xae,
+  0x00, 0x01, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x37, 0x05, 0x1e, 0x00, 0x20,
+  0x00, 0x00, 0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x40,
+  0x2b, 0x2e, 0x2e, 0x31, 0x94, 0x55, 0x55, 0x54, 0x54, 0x90, 0x34, 0x30,
+  0x2e, 0x2c, 0x2c, 0x2d, 0x2c, 0x2e, 0x65, 0x38, 0x38, 0x38, 0x38, 0x65,
+  0x2e, 0x2c, 0x2d, 0x2c, 0x04, 0xf7, 0x14, 0x0a, 0x09, 0x58, 0x58, 0x99,
+  0x97, 0x59, 0x59, 0x0a, 0x0a, 0x14, 0x5f, 0x18, 0x0c, 0x0c, 0x3f, 0x40,
+  0xe6, 0x40, 0x3f, 0x0c, 0x0c, 0x18, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f,
+  0x03, 0xd5, 0x02, 0x88, 0x05, 0x1e, 0x00, 0x10, 0x00, 0x00, 0x01, 0x34,
+  0x27, 0x26, 0x22, 0x07, 0x06, 0x15, 0x23, 0x34, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x30, 0x02, 0x18, 0x30, 0x31, 0xa7, 0x31, 0x31, 0x6e, 0x9b,
+  0x89, 0x87, 0x4f, 0x4d, 0x03, 0xd5, 0x6f, 0x42, 0x41, 0x41, 0x40, 0x71,
+  0x9b, 0xae, 0x57, 0x57, 0x9b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f,
+  0x02, 0x8c, 0x02, 0x88, 0x03, 0xd5, 0x00, 0x10, 0x00, 0x00, 0x13, 0x14,
+  0x17, 0x16, 0x32, 0x37, 0x36, 0x35, 0x33, 0x14, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x35, 0x30, 0xaf, 0x30, 0x31, 0xa7, 0x31, 0x31, 0x6e, 0x9b, 0x88,
+  0x88, 0x4e, 0x4e, 0x03, 0xd5, 0x6f, 0x42, 0x41, 0x41, 0x40, 0x71, 0x9b,
+  0xae, 0x57, 0x57, 0x9b, 0x00, 0x02, 0x00, 0x69, 0x01, 0xad, 0x02, 0xa2,
+  0x05, 0x1e, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x11, 0x23, 0x11,
+  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06, 0x23,
+  0x22, 0x26, 0x24, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x14, 0x17, 0x16,
+  0x32, 0x37, 0xd3, 0x6a, 0x6a, 0x20, 0x65, 0x45, 0x74, 0x48, 0x48, 0x48,
+  0x48, 0x74, 0x45, 0x65, 0x01, 0x42, 0x2f, 0x2f, 0xa6, 0x30, 0x2e, 0x2e,
+  0x30, 0xa6, 0x2f, 0x02, 0xfa, 0xfe, 0xb3, 0x03, 0x62, 0x5f, 0x38, 0x36,
+  0x5a, 0x5b, 0xfe, 0xd8, 0x5b, 0x5a, 0x36, 0xa1, 0xe4, 0x40, 0x41, 0x41,
+  0x40, 0xe4, 0x40, 0x41, 0x41, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1f,
+  0x02, 0x9c, 0x01, 0xac, 0x05, 0xc1, 0x00, 0x14, 0x00, 0x00, 0x13, 0x15,
+  0x33, 0x15, 0x23, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
+  0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x35, 0xd4, 0xd8, 0xd8, 0x2c, 0x40,
+  0x6c, 0x6c, 0x78, 0x2e, 0x2e, 0x4c, 0x4c, 0x05, 0xc1, 0xb2, 0x50, 0xfe,
+  0xac, 0x4d, 0x2c, 0x56, 0x2d, 0x2c, 0x76, 0x01, 0x54, 0x50, 0xb2, 0x00,
+  0x00, 0x01, 0x00, 0x63, 0x02, 0x8c, 0x02, 0x77, 0x05, 0x0f, 0x00, 0x16,
+  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x63, 0x68, 0x23, 0x24, 0x46, 0x54, 0x31, 0x31, 0x69, 0x69, 0x26,
+  0x32, 0x32, 0x43, 0x6d, 0x71, 0x03, 0x94, 0x01, 0x7b, 0xfe, 0x88, 0x59,
+  0x2c, 0x2d, 0x36, 0x35, 0x5c, 0x01, 0x63, 0xfd, 0x8d, 0x60, 0x39, 0x1c,
+  0x1b, 0x86, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0x02, 0xc7, 0x02, 0xee,
+  0x04, 0xd4, 0x00, 0x16, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x32, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x21, 0x35, 0x21, 0x15, 0x23, 0x1e,
+  0x01, 0x15, 0x14, 0x07, 0x06, 0x01, 0xe3, 0xfe, 0x80, 0x01, 0x7c, 0x5b,
+  0x2d, 0x2d, 0x36, 0x36, 0x5d, 0xfe, 0x98, 0x02, 0x7b, 0x62, 0x3a, 0x38,
+  0x44, 0x44, 0x02, 0xc7, 0x67, 0x23, 0x22, 0x46, 0x53, 0x31, 0x30, 0x67,
+  0x67, 0x25, 0x64, 0x41, 0x6c, 0x38, 0x38, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x02, 0x8d, 0x04, 0x09, 0x05, 0x10, 0x00, 0x28, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x26, 0x02, 0x16, 0x27, 0x36, 0x37, 0x4a, 0x63, 0x6c, 0x6a,
+  0x20, 0x20, 0x42, 0x51, 0x30, 0x2f, 0x68, 0x20, 0x21, 0x43, 0x50, 0x2f,
+  0x30, 0x68, 0x68, 0x24, 0x32, 0x32, 0x44, 0x46, 0x61, 0x03, 0x15, 0x45,
+  0x21, 0x22, 0x8a, 0x7f, 0x01, 0x7a, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x36,
+  0x34, 0x5c, 0x01, 0x63, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x36, 0x36, 0x5a,
+  0x01, 0x63, 0xfd, 0x8d, 0x62, 0x3b, 0x1b, 0x1c, 0x46, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x22, 0x02, 0x9c, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x06,
+  0x00, 0x00, 0x13, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x23, 0x22, 0x6f, 0xc7,
+  0xc6, 0x6e, 0xed, 0x8e, 0x05, 0x0f, 0xfd, 0xf2, 0x02, 0x0e, 0xfd, 0x8d,
+  0x00, 0x02, 0x00, 0x6c, 0x01, 0xad, 0x02, 0x92, 0x06, 0x0b, 0x00, 0x0e,
+  0x00, 0x1c, 0x00, 0x00, 0x13, 0x11, 0x23, 0x11, 0x10, 0x33, 0x32, 0x17,
+  0x16, 0x07, 0x16, 0x17, 0x12, 0x21, 0x26, 0x27, 0x16, 0x33, 0x32, 0x35,
+  0x34, 0x05, 0x35, 0x16, 0x35, 0x34, 0x23, 0x22, 0x15, 0xd5, 0x68, 0xf1,
+  0xf6, 0x01, 0x01, 0x63, 0x9e, 0x01, 0x01, 0xfe, 0xed, 0x77, 0x34, 0x3f,
+  0x71, 0xa3, 0xfe, 0xf8, 0xcf, 0x85, 0x95, 0x02, 0xc3, 0xfe, 0xea, 0x03,
+  0x5e, 0x01, 0x00, 0xd8, 0x99, 0x38, 0x33, 0x95, 0xfe, 0xf6, 0x01, 0xb8,
+  0x61, 0xb0, 0x9e, 0x0c, 0x5f, 0x04, 0xb7, 0x7b, 0xaf, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x12, 0x01, 0xad, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x0e,
+  0x00, 0x00, 0x1b, 0x02, 0x33, 0x01, 0x15, 0x23, 0x35, 0x03, 0x26, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0xcc, 0x8c, 0xc6, 0x6e, 0xff, 0x00, 0x68, 0xa7,
+  0x19, 0x36, 0x1c, 0x28, 0x6f, 0x04, 0xad, 0xfe, 0x7c, 0x01, 0xe6, 0xfd,
+  0x8d, 0xef, 0xef, 0x01, 0xd4, 0x47, 0x58, 0x00, 0x00, 0x02, 0x00, 0x3f,
+  0x02, 0x8c, 0x02, 0x88, 0x05, 0xef, 0x00, 0x1b, 0x00, 0x2b, 0x00, 0x00,
+  0x01, 0x26, 0x23, 0x22, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x20, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x35,
+  0x34, 0x33, 0x32, 0x17, 0x01, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x02, 0x3a, 0x3b, 0x87,
+  0x90, 0x96, 0x76, 0x42, 0x51, 0x4d, 0x4f, 0xfe, 0xf1, 0x4e, 0x4e, 0x4e,
+  0x1e, 0x2a, 0x58, 0xfa, 0x7d, 0x45, 0xfe, 0xea, 0x26, 0x1f, 0x31, 0x30,
+  0x31, 0x55, 0x53, 0x61, 0x33, 0x37, 0x48, 0x24, 0x05, 0x72, 0x28, 0x42,
+  0x34, 0x1a, 0x15, 0x3f, 0x4b, 0x9c, 0x94, 0x57, 0x58, 0x58, 0x57, 0x9a,
+  0x72, 0x5d, 0x24, 0x14, 0x2c, 0x4f, 0x98, 0x27, 0xfe, 0xf8, 0x11, 0x28,
+  0x40, 0xe4, 0x3f, 0x41, 0x82, 0x6a, 0x70, 0x36, 0x39, 0x06, 0x04, 0x00,
+  0x00, 0x02, 0x00, 0x3f, 0x01, 0xad, 0x02, 0xbc, 0x05, 0x14, 0x00, 0x0a,
+  0x00, 0x29, 0x00, 0x00, 0x01, 0x22, 0x15, 0x11, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x15, 0x23, 0x35, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x15,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x11, 0x34, 0x01, 0xd6,
+  0x25, 0x37, 0x35, 0x31, 0x32, 0x28, 0x1e, 0x4f, 0x49, 0x4d, 0x4d, 0x49,
+  0x74, 0x68, 0x71, 0x4b, 0x4d, 0x4d, 0x3a, 0x5d, 0x25, 0x21, 0x30, 0x30,
+  0x2c, 0x3f, 0x04, 0xbc, 0x51, 0xfe, 0x7f, 0x3a, 0x35, 0x7d, 0x74, 0x3f,
+  0x33, 0x58, 0x4a, 0x4f, 0xa5, 0x98, 0x5a, 0x55, 0xe2, 0xe1, 0x55, 0x58,
+  0x9a, 0xa0, 0x52, 0x3d, 0x10, 0x5c, 0x0c, 0x2c, 0x41, 0x6a, 0x71, 0x40,
+  0x3a, 0x01, 0x81, 0xa9, 0x00, 0x01, 0x00, 0x21, 0x01, 0xad, 0x02, 0x7e,
+  0x05, 0x10, 0x00, 0x17, 0x00, 0x00, 0x01, 0x27, 0x03, 0x23, 0x13, 0x03,
+  0x26, 0x2b, 0x01, 0x35, 0x17, 0x16, 0x1f, 0x01, 0x13, 0x33, 0x03, 0x13,
+  0x16, 0x3b, 0x01, 0x15, 0x27, 0x26, 0x01, 0x9f, 0x55, 0xad, 0x7c, 0xf7,
+  0x68, 0x1c, 0x57, 0x1c, 0x28, 0x93, 0x24, 0x54, 0xae, 0x7b, 0xf5, 0x66,
+  0x1c, 0x57, 0x1c, 0x27, 0x93, 0x02, 0x10, 0xd7, 0xfe, 0xc6, 0x01, 0xbc,
+  0x01, 0x07, 0x47, 0x58, 0x01, 0x04, 0x5d, 0xd7, 0x01, 0x3a, 0xfe, 0x44,
+  0xfe, 0xf8, 0x46, 0x59, 0x02, 0x04, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6d,
+  0x00, 0x00, 0x00, 0xd7, 0x03, 0x67, 0x12, 0x07, 0x07, 0xa1, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x01, 0xdd,
+  0x02, 0x82, 0x12, 0x07, 0x02, 0x75, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xff, 0xf0, 0x02, 0x77, 0x02, 0x73, 0x12, 0x07,
+  0x05, 0x0e, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x22,
+  0x00, 0x00, 0x02, 0x8d, 0x02, 0x73, 0x12, 0x07, 0x05, 0x11, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c, 0xff, 0x11, 0x02, 0x92,
+  0x03, 0x6f, 0x12, 0x07, 0x05, 0x12, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x12, 0xff, 0x11, 0x02, 0x8d, 0x02, 0x73, 0x12, 0x07,
+  0x05, 0x13, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6c,
+  0xff, 0x11, 0x02, 0xa4, 0x02, 0x82, 0x00, 0x10, 0x00, 0x1c, 0x00, 0x00,
+  0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26,
+  0x27, 0x11, 0x23, 0x11, 0x34, 0x05, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0xa0, 0x22, 0x56, 0x21, 0x68, 0x73, 0x90,
+  0x90, 0x73, 0x47, 0x63, 0x22, 0x68, 0x01, 0xcb, 0x5f, 0x52, 0x52, 0x60,
+  0x60, 0x52, 0x52, 0x5f, 0x02, 0x03, 0x39, 0x32, 0x14, 0xb5, 0xfe, 0xd8,
+  0xb6, 0x37, 0x38, 0xfe, 0xb3, 0x02, 0x22, 0x81, 0x7b, 0x71, 0x82, 0x82,
+  0x71, 0x72, 0x81, 0x81, 0xff, 0xff, 0x00, 0x3f, 0xff, 0x11, 0x02, 0xbc,
+  0x02, 0x78, 0x12, 0x07, 0x05, 0x15, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x21, 0xff, 0x11, 0x02, 0x7e, 0x02, 0x74, 0x12, 0x07,
+  0x05, 0x16, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xfe, 0x56, 0x04, 0x2d, 0x04, 0x7b, 0x00, 0x1c, 0x00, 0x28, 0x00, 0x00,
+  0x13, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x1d, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23,
+  0x22, 0x26, 0x27, 0x15, 0x23, 0x13, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0xa7, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49,
+  0x8e, 0x4a, 0xa3, 0xa2, 0x33, 0xa0, 0x70, 0xba, 0xe2, 0xe3, 0xb9, 0x70,
+  0xa0, 0x33, 0xa6, 0xa6, 0x95, 0x86, 0x85, 0x94, 0x94, 0x85, 0x86, 0x95,
+  0x02, 0x46, 0x01, 0x1e, 0x01, 0x17, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd,
+  0xbf, 0x5b, 0x63, 0x62, 0xfe, 0xc6, 0xfe, 0xfd, 0xfe, 0xfc, 0xfe, 0xc6,
+  0x62, 0x63, 0xaa, 0x02, 0x23, 0xc8, 0xdc, 0xdc, 0xc8, 0xc7, 0xdc, 0xdc,
+  0xff, 0xff, 0x00, 0x72, 0x02, 0x9c, 0x02, 0xf8, 0x05, 0xe0, 0x10, 0x06,
+  0x04, 0xea, 0x00, 0x00, 0x00, 0x01, 0x00, 0x68, 0x00, 0x00, 0x02, 0x44,
+  0x04, 0x60, 0x00, 0x13, 0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x23, 0x11,
+  0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35,
+  0x33, 0x11, 0x68, 0x01, 0xdc, 0x98, 0x98, 0x98, 0x98, 0xfe, 0x24, 0x9f,
+  0x9f, 0x9f, 0x03, 0xbc, 0xa4, 0xa4, 0xfe, 0xac, 0xa4, 0xfe, 0xe0, 0xa4,
+  0xa4, 0x01, 0x20, 0xa4, 0x01, 0x54, 0x00, 0x00, 0x00, 0x03, 0x00, 0x2d,
+  0xfe, 0x56, 0x04, 0xa1, 0x04, 0x7b, 0x00, 0x19, 0x00, 0x22, 0x00, 0x2b,
+  0x00, 0x00, 0x25, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x15,
+  0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x23, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x01, 0x21, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x01, 0x4e,
+  0xa7, 0x7a, 0x7a, 0xa7, 0x34, 0x9f, 0x6f, 0xb7, 0x73, 0x5c, 0x13, 0x77,
+  0x74, 0x0a, 0x68, 0x73, 0xb7, 0x6f, 0x9f, 0x01, 0xfe, 0xfd, 0xcf, 0x07,
+  0x43, 0x4b, 0x84, 0x83, 0x4c, 0x42, 0xfd, 0xda, 0x02, 0x29, 0x0e, 0x37,
+  0x4c, 0x83, 0x84, 0x4b, 0x38, 0xa8, 0xfd, 0xae, 0x03, 0xae, 0x90, 0x01,
+  0xcc, 0xaa, 0x64, 0x61, 0xa2, 0x82, 0xc3, 0x90, 0xea, 0x95, 0xa2, 0x61,
+  0x01, 0xc0, 0xae, 0x66, 0x74, 0x74, 0x66, 0x01, 0x3e, 0x84, 0x56, 0x74,
+  0x74, 0x56, 0x00, 0x00, 0x00, 0x01, 0x00, 0x82, 0xfe, 0x56, 0x01, 0xf8,
+  0x06, 0x14, 0x00, 0x10, 0x00, 0x00, 0x25, 0x15, 0x14, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x27, 0x37, 0x23, 0x11, 0x33, 0x11, 0x01,
+  0xf7, 0x93, 0xa2, 0x40, 0x2c, 0x5f, 0x22, 0x26, 0x03, 0x01, 0xa5, 0xa5,
+  0x9a, 0xae, 0xd6, 0xc0, 0x9c, 0x30, 0x36, 0x94, 0x14, 0x06, 0x14, 0xfa,
+  0x86, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x78,
+  0x05, 0x1e, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x00, 0x13, 0x15, 0x23, 0x11,
+  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x24, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x14,
+  0x17, 0x16, 0x32, 0x37, 0xa8, 0x68, 0x68, 0x22, 0x32, 0x32, 0x46, 0x73,
+  0x48, 0x49, 0x49, 0x48, 0x73, 0x46, 0x32, 0x32, 0x01, 0x42, 0x30, 0x2f,
+  0xa5, 0x30, 0x30, 0x30, 0x30, 0xa5, 0x2f, 0x02, 0xfa, 0x5f, 0x02, 0x73,
+  0x5e, 0x38, 0x1b, 0x1b, 0x5a, 0x5b, 0xfe, 0xd8, 0x5b, 0x5a, 0x1b, 0x1b,
+  0xa1, 0xe4, 0x41, 0x40, 0x40, 0x41, 0xe4, 0x41, 0x40, 0x40, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x37, 0x05, 0x1e, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x14,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x16, 0x02, 0x36, 0x2c, 0x2c,
+  0x2d, 0x2d, 0x66, 0x38, 0x38, 0x38, 0x38, 0x66, 0x2d, 0x2d, 0x2c, 0x2c,
+  0x2b, 0x5e, 0x35, 0x8f, 0xa9, 0xab, 0x94, 0x30, 0x2e, 0x2e, 0x04, 0xf7,
+  0x60, 0x18, 0x0c, 0x0c, 0x40, 0x3f, 0xe6, 0x3f, 0x40, 0x0c, 0x0c, 0x18,
+  0x5f, 0x14, 0x14, 0xb2, 0x97, 0x99, 0xb0, 0x09, 0x0a, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x3f, 0x02, 0x4b, 0x02, 0x37, 0x05, 0x1e, 0x00, 0x07,
+  0x00, 0x2b, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x35, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x07, 0x34, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x14, 0x17, 0x16, 0x17, 0x36, 0x33, 0x32, 0x17, 0x16, 0x23, 0x22,
+  0x01, 0x37, 0x22, 0x2b, 0x53, 0x01, 0x4a, 0x3a, 0x2f, 0x04, 0x56, 0x07,
+  0x20, 0x1c, 0x54, 0xab, 0x94, 0x2f, 0x2f, 0x2c, 0x2d, 0x2a, 0x2f, 0x2c,
+  0x2d, 0x66, 0x38, 0x38, 0x38, 0x02, 0x06, 0x2f, 0x6f, 0xa9, 0x01, 0x01,
+  0xbd, 0x2e, 0x02, 0xee, 0x0b, 0x20, 0x2a, 0x9a, 0x20, 0x26, 0x02, 0x3b,
+  0x2f, 0x13, 0x1d, 0x5a, 0x96, 0x99, 0xb0, 0x09, 0x0a, 0x14, 0x60, 0x17,
+  0x0d, 0x0c, 0x3f, 0x40, 0xe6, 0x40, 0x02, 0x05, 0x62, 0x8a, 0x69, 0x00,
+  0x00, 0x02, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x88, 0x06, 0x03, 0x00, 0x11,
+  0x00, 0x2e, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x37, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x27, 0x07, 0x27, 0x37, 0x27, 0x33, 0x17,
+  0x37, 0x17, 0x07, 0x01, 0xdb, 0x1d, 0x18, 0x19, 0x17, 0x5f, 0x34, 0x35,
+  0x63, 0x53, 0x51, 0x63, 0x0f, 0x0f, 0x05, 0x47, 0x21, 0x20, 0x51, 0x50,
+  0x82, 0x84, 0xa0, 0x9c, 0x7e, 0x0a, 0x0f, 0x0e, 0x19, 0x5a, 0xb5, 0x13,
+  0x9f, 0x67, 0x82, 0x48, 0xbc, 0x13, 0xa7, 0x04, 0x9c, 0x0a, 0x04, 0x05,
+  0x3d, 0x3c, 0x6d, 0x6a, 0x7c, 0x7c, 0x6a, 0x44, 0x35, 0x34, 0xa5, 0x50,
+  0x51, 0x50, 0x61, 0x8f, 0x57, 0x57, 0xae, 0x8f, 0x8c, 0xae, 0x02, 0x01,
+  0x03, 0x65, 0x3c, 0x38, 0x33, 0x72, 0x51, 0x3e, 0x36, 0x37, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x4b, 0x02, 0x8c, 0x02, 0x25, 0x05, 0x1f, 0x00, 0x31,
+  0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x06, 0x01, 0x90, 0x47, 0x26, 0x28, 0x49, 0x4a, 0x87,
+  0x2d, 0x30, 0x30, 0x32, 0x28, 0x30, 0x30, 0x35, 0x55, 0x31, 0x2f, 0x2c,
+  0x29, 0x4d, 0x54, 0x57, 0x42, 0x4d, 0x28, 0x27, 0x43, 0x29, 0x2e, 0x2d,
+  0x37, 0x37, 0x61, 0x2b, 0x6f, 0x40, 0x41, 0x44, 0x03, 0xee, 0x0d, 0x29,
+  0x29, 0x3c, 0x61, 0x33, 0x33, 0x08, 0x07, 0x10, 0x60, 0x15, 0x0a, 0x0b,
+  0x20, 0x1f, 0x33, 0x31, 0x1f, 0x1d, 0x55, 0x32, 0x27, 0x24, 0x1a, 0x19,
+  0x07, 0x07, 0x11, 0x5e, 0x0d, 0x0e, 0x2c, 0x2c, 0x4f, 0x34, 0x48, 0x00,
+  0x00, 0x01, 0x00, 0x1b, 0x02, 0x9c, 0x01, 0xb0, 0x06, 0x03, 0x00, 0x15,
+  0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x1d, 0x01, 0x33, 0x15,
+  0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36, 0x33,
+  0x01, 0xaf, 0x64, 0x38, 0x16, 0x16, 0xac, 0xac, 0x69, 0x63, 0x63, 0x32,
+  0x31, 0x6b, 0x06, 0x03, 0x55, 0x17, 0x16, 0x3a, 0x38, 0x50, 0xfd, 0xdd,
+  0x02, 0x23, 0x50, 0x2c, 0x69, 0x2f, 0x30, 0x00, 0x00, 0x01, 0xff, 0xeb,
+  0x01, 0xad, 0x01, 0x3a, 0x05, 0x0f, 0x00, 0x15, 0x00, 0x00, 0x13, 0x15,
+  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01,
+  0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0xd6, 0x2f, 0x2d, 0x67,
+  0x28, 0x1c, 0x3c, 0x15, 0x16, 0x67, 0x67, 0x68, 0x63, 0x02, 0x9c, 0x0b,
+  0x78, 0x36, 0x36, 0x58, 0x1b, 0x1c, 0x55, 0x0b, 0x50, 0x02, 0x23, 0xfd,
+  0xdd, 0x50, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x01, 0xad, 0x02, 0x78,
+  0x05, 0x0f, 0x00, 0x0c, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x35, 0x23, 0x22,
+  0x07, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x13, 0x11, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x33, 0x02, 0x0f, 0xb2, 0x53, 0x2f, 0x2f, 0x2f,
+  0x2f, 0x53, 0x55, 0x2f, 0x2e, 0x69, 0x48, 0x48, 0x95, 0x37, 0x31, 0x31,
+  0x2e, 0x2e, 0x2d, 0x2d, 0x2e, 0x67, 0x33, 0x33, 0x20, 0x32, 0x33, 0x46,
+  0x75, 0x47, 0x48, 0x48, 0x47, 0x75, 0x03, 0xdd, 0xeb, 0x3e, 0x3d, 0xe0,
+  0x3d, 0x3e, 0x3e, 0x3d, 0x01, 0xa2, 0xfd, 0xdb, 0xa0, 0x4e, 0x4f, 0x08,
+  0x09, 0x10, 0x65, 0x19, 0x0c, 0x0b, 0x34, 0x35, 0x6b, 0x33, 0x37, 0x1c,
+  0x1b, 0x58, 0x58, 0x91, 0x82, 0x58, 0x58, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0x01, 0xad, 0x02, 0x77, 0x05, 0x0f, 0x00, 0x16, 0x00, 0x00, 0x13, 0x11,
+  0x33, 0x11, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
+  0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x63, 0x68, 0x23,
+  0x24, 0x46, 0x54, 0x31, 0x31, 0x69, 0x69, 0x26, 0x33, 0x31, 0x43, 0x6d,
+  0x71, 0x03, 0x94, 0x01, 0x7b, 0xfe, 0x88, 0x59, 0x2c, 0x2d, 0x36, 0x35,
+  0x5c, 0x01, 0x63, 0xfc, 0x9e, 0x01, 0x4f, 0x39, 0x1c, 0x1b, 0x86, 0x00,
+  0x00, 0x02, 0x00, 0x41, 0x02, 0x9c, 0x01, 0x6e, 0x06, 0x03, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x00, 0x13, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15,
+  0x23, 0x15, 0x23, 0x35, 0x11, 0x33, 0x15, 0x23, 0x42, 0x66, 0x69, 0x5c,
+  0x5c, 0x69, 0x69, 0x69, 0x03, 0x99, 0x5c, 0x01, 0x1a, 0xfe, 0xe6, 0x5c,
+  0xfd, 0xfd, 0x02, 0x6a, 0x82, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6d,
+  0x02, 0x9c, 0x01, 0x58, 0x05, 0x0f, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x11,
+  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x11, 0xd6,
+  0x15, 0x15, 0x3d, 0x1b, 0x28, 0x66, 0x5c, 0x05, 0x0f, 0xfe, 0x70, 0x55,
+  0x1c, 0x1b, 0x57, 0x6c, 0x77, 0x01, 0x90, 0x00, 0x00, 0x01, 0x00, 0x41,
+  0x02, 0x9c, 0x01, 0x6e, 0x05, 0x0f, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35,
+  0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x42, 0x01,
+  0x2b, 0x5f, 0x5f, 0xfe, 0xd5, 0x64, 0x04, 0xb3, 0x5c, 0x5c, 0xfe, 0x45,
+  0x5c, 0x5c, 0x01, 0xbb, 0x00, 0x01, 0x00, 0x41, 0x02, 0x9c, 0x01, 0x6e,
+  0x05, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x23, 0x15,
+  0x33, 0x15, 0x23, 0x15, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35, 0x23, 0x35,
+  0x33, 0x35, 0x42, 0x01, 0x2b, 0x5f, 0x5f, 0x5f, 0x5f, 0xfe, 0xd5, 0x64,
+  0x64, 0x64, 0x04, 0xb3, 0x5c, 0x5c, 0xbe, 0x5c, 0xa1, 0x5c, 0x5c, 0xa1,
+  0x5c, 0xbe, 0x00, 0x00, 0x00, 0x03, 0xff, 0x67, 0x01, 0xad, 0x01, 0x3d,
+  0x06, 0x03, 0x00, 0x03, 0x00, 0x12, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x33,
+  0x15, 0x23, 0x03, 0x22, 0x35, 0x34, 0x3b, 0x01, 0x11, 0x33, 0x11, 0x33,
+  0x15, 0x23, 0x06, 0x07, 0x06, 0x27, 0x23, 0x22, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x6e, 0x68, 0x68, 0x5b, 0xac, 0x99, 0x6e, 0x68, 0x67, 0x6d,
+  0x0a, 0x1f, 0x2d, 0x12, 0x67, 0x44, 0x02, 0x02, 0x46, 0x3c, 0x15, 0x0a,
+  0x06, 0x03, 0x82, 0xfc, 0x2c, 0x7c, 0x73, 0x02, 0x73, 0xfd, 0x8d, 0x57,
+  0x3f, 0x23, 0x35, 0x98, 0x1d, 0x24, 0x1b, 0x0d, 0x00, 0x01, 0x00, 0x6d,
+  0x01, 0xad, 0x01, 0x58, 0x06, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x11,
+  0x33, 0x11, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
+  0x35, 0x6e, 0x68, 0x15, 0x15, 0x3d, 0x1b, 0x28, 0x66, 0x5c, 0x02, 0xe4,
+  0x03, 0x1f, 0xfc, 0xe1, 0x53, 0x56, 0x1b, 0x1b, 0x58, 0x6c, 0x78, 0x00,
+  0x00, 0x01, 0x00, 0x51, 0x01, 0xad, 0x01, 0x3d, 0x06, 0x03, 0x00, 0x11,
+  0x00, 0x00, 0x01, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x27, 0x37, 0x23, 0x11, 0x33, 0x11, 0x01, 0x3d, 0x2e, 0x2f,
+  0x66, 0x28, 0x1c, 0x3b, 0x16, 0x18, 0x03, 0x02, 0x68, 0x68, 0x02, 0xf2,
+  0x61, 0x78, 0x36, 0x36, 0x58, 0x1b, 0x1e, 0x53, 0x0b, 0x03, 0x67, 0xfc,
+  0xef, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0x02, 0x9c, 0x02, 0x43,
+  0x05, 0x1e, 0x00, 0x05, 0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x15, 0x21,
+  0x66, 0x72, 0x01, 0x6b, 0xfe, 0x23, 0x05, 0x1e, 0xfd, 0xdd, 0x5f, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0x01, 0xad, 0x04, 0x09, 0x05, 0x1e, 0x00, 0x34,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
+  0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x26, 0x37, 0x34,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x02, 0x5c, 0x27, 0x37, 0x36,
+  0x49, 0x64, 0x35, 0x36, 0x5c, 0x66, 0x91, 0x84, 0x3c, 0x2b, 0x01, 0x01,
+  0x41, 0x43, 0x50, 0x2f, 0x30, 0x68, 0x21, 0x20, 0x44, 0x50, 0x2f, 0x2e,
+  0x6a, 0x6a, 0x23, 0x32, 0x32, 0x45, 0x44, 0x31, 0x30, 0x04, 0x97, 0x45,
+  0x21, 0x21, 0x45, 0x44, 0x7e, 0xfe, 0x7a, 0x78, 0x6c, 0x58, 0x36, 0x56,
+  0x30, 0xe8, 0x3d, 0x2d, 0x5a, 0x58, 0x35, 0x36, 0x5c, 0xfe, 0x9e, 0x01,
+  0x77, 0x5b, 0x2c, 0x2b, 0x35, 0x36, 0x5c, 0xfe, 0x9e, 0x02, 0x73, 0x61,
+  0x39, 0x1c, 0x1b, 0x22, 0x23, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x01, 0xad, 0x04, 0x09, 0x05, 0x10, 0x00, 0x28, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x26, 0x02, 0x16, 0x27, 0x36, 0x37, 0x4a, 0x63, 0x6c, 0x6a,
+  0x20, 0x20, 0x42, 0x51, 0x30, 0x2f, 0x68, 0x20, 0x21, 0x43, 0x50, 0x2f,
+  0x30, 0x68, 0x68, 0x24, 0x32, 0x32, 0x44, 0x46, 0x61, 0x03, 0x15, 0x45,
+  0x22, 0x21, 0x8a, 0x7e, 0x01, 0x7b, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x35,
+  0x35, 0x5c, 0x01, 0x63, 0xfe, 0x89, 0x5b, 0x2b, 0x2c, 0x36, 0x35, 0x5b,
+  0x01, 0x63, 0xfc, 0x9d, 0x01, 0x51, 0x3a, 0x1b, 0x1c, 0x46, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xeb, 0x01, 0xad, 0x02, 0x82, 0x05, 0x1e, 0x00, 0x1f,
+  0x00, 0x00, 0x13, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36,
+  0x35, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
+  0x23, 0x11, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0xd6, 0x2f,
+  0x2d, 0x67, 0x28, 0x1c, 0x3c, 0x2b, 0x68, 0x26, 0x65, 0x42, 0x6e, 0x38,
+  0x39, 0x69, 0x23, 0x24, 0x46, 0x55, 0x30, 0x31, 0x02, 0x91, 0x78, 0x36,
+  0x36, 0x58, 0x36, 0x56, 0x02, 0x7e, 0x61, 0x38, 0x38, 0x42, 0x44, 0x81,
+  0xfe, 0x85, 0x01, 0x77, 0x59, 0x2c, 0x2d, 0x35, 0x36, 0x5c, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0x01, 0xad, 0x03, 0x00, 0x05, 0x1e, 0x00, 0x20,
+  0x00, 0x00, 0x01, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11,
+  0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x02,
+  0x15, 0x23, 0x23, 0x47, 0x54, 0x31, 0x30, 0x6a, 0x6a, 0x25, 0x32, 0x33,
+  0x43, 0x6d, 0x38, 0x38, 0x2b, 0x3c, 0x1c, 0x28, 0x66, 0x2e, 0x2f, 0x04,
+  0x13, 0x59, 0x2c, 0x2d, 0x35, 0x36, 0x5c, 0xfe, 0x9e, 0x02, 0x73, 0x61,
+  0x38, 0x1c, 0x1c, 0x42, 0x44, 0x81, 0xfe, 0x7a, 0x56, 0x36, 0x58, 0x36,
+  0x36, 0x78, 0x00, 0x00, 0x00, 0x01, 0x00, 0x65, 0x02, 0x9c, 0x02, 0x7e,
+  0x05, 0x1e, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
+  0x23, 0x01, 0x11, 0x23, 0x66, 0x9a, 0x01, 0x0e, 0x6f, 0x9a, 0xfe, 0xf1,
+  0x6e, 0x05, 0x1e, 0xfe, 0x07, 0x01, 0xf9, 0xfd, 0x7e, 0x01, 0xfa, 0xfe,
+  0x06, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x3f, 0x02, 0x8c, 0x02, 0x88,
+  0x05, 0x1e, 0x00, 0x0f, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x16, 0x22, 0x07, 0x06, 0x07, 0x21, 0x26, 0x27, 0x17, 0x21,
+  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x01, 0x64, 0x87, 0x4f, 0x4d,
+  0x4d, 0x4f, 0x87, 0x89, 0x4d, 0x4e, 0x4e, 0x4d, 0xdc, 0xa7, 0x31, 0x2a,
+  0x06, 0x01, 0x69, 0x06, 0x2a, 0x2c, 0xfe, 0x9e, 0x0a, 0x22, 0x31, 0x55,
+  0x53, 0x31, 0x22, 0x05, 0x1e, 0x57, 0x57, 0x9b, 0x9a, 0x57, 0x58, 0x58,
+  0x57, 0x9a, 0x9b, 0x57, 0x57, 0x57, 0x40, 0x39, 0x5c, 0x5b, 0x38, 0xef,
+  0x45, 0x2d, 0x41, 0x41, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x3f,
+  0x01, 0xae, 0x02, 0x88, 0x06, 0x03, 0x00, 0x1d, 0x00, 0x26, 0x00, 0x2e,
+  0x00, 0x00, 0x01, 0x23, 0x35, 0x21, 0x15, 0x23, 0x15, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x17, 0x11, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x03, 0x11, 0x06, 0x07, 0x06, 0x14, 0x17,
+  0x16, 0x01, 0x2e, 0x88, 0x01, 0x78, 0x88, 0x65, 0x3f, 0x4d, 0x4d, 0x3f,
+  0x65, 0x88, 0xfe, 0x88, 0x88, 0x64, 0x3c, 0x4e, 0x4e, 0x3c, 0x64, 0x68,
+  0x30, 0x22, 0x30, 0x30, 0x22, 0x98, 0x2f, 0x20, 0x31, 0x30, 0x21, 0x05,
+  0xa7, 0x5c, 0x5c, 0x8c, 0x0e, 0x46, 0x57, 0x9b, 0x9a, 0x57, 0x47, 0x0e,
+  0x85, 0x5c, 0x5c, 0x86, 0x0e, 0x46, 0x57, 0x9a, 0x9b, 0x57, 0x45, 0x0f,
+  0x5b, 0xfe, 0x2a, 0x0e, 0x2c, 0x41, 0x70, 0x6f, 0x41, 0x2d, 0xfe, 0x39,
+  0x01, 0xd4, 0x0e, 0x2a, 0x41, 0xe2, 0x40, 0x2b, 0x00, 0x01, 0x00, 0x3f,
+  0x01, 0xad, 0x02, 0x25, 0x05, 0x1e, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x15,
+  0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x15,
+  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x3d, 0x02, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x2e,
+  0x01, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16, 0x02, 0x02, 0x2c, 0x60,
+  0x32, 0x4e, 0x26, 0x28, 0x1c, 0x1c, 0x54, 0x24, 0x6e, 0x2f, 0x2f, 0x45,
+  0x46, 0x7b, 0x33, 0x38, 0x0c, 0x2c, 0x3b, 0x84, 0x90, 0x66, 0x2e, 0x2f,
+  0x3a, 0x38, 0x38, 0x37, 0x4a, 0x4f, 0x1c, 0x1d, 0x61, 0x25, 0x60, 0x56,
+  0x3f, 0x3f, 0x75, 0x3a, 0x67, 0x04, 0xfd, 0x62, 0x17, 0x16, 0x17, 0x18,
+  0x2f, 0x24, 0x15, 0x14, 0x12, 0x08, 0x18, 0x2b, 0x2a, 0x4d, 0x57, 0x33,
+  0x33, 0x09, 0x03, 0x07, 0x56, 0x36, 0x58, 0x36, 0x36, 0x78, 0x22, 0x6a,
+  0x1d, 0x0f, 0x0f, 0x32, 0x2d, 0x2a, 0x17, 0x16, 0x15, 0x08, 0x14, 0x54,
+  0x49, 0x58, 0x30, 0x30, 0x10, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xeb,
+  0x01, 0xad, 0x01, 0x9d, 0x06, 0x03, 0x00, 0x17, 0x00, 0x00, 0x13, 0x02,
+  0x03, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x15,
+  0x13, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x6e, 0x01,
+  0x01, 0x32, 0x2d, 0x6e, 0x63, 0x64, 0x38, 0x15, 0x17, 0x02, 0x2f, 0x2d,
+  0x67, 0x28, 0x1c, 0x3c, 0x2b, 0x02, 0x91, 0x01, 0x5d, 0x01, 0x4d, 0x65,
+  0x33, 0x30, 0x55, 0x17, 0x16, 0x3a, 0xfd, 0x4a, 0x78, 0x36, 0x36, 0x58,
+  0x36, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1f, 0x01, 0xad, 0x01, 0xac,
+  0x05, 0xc1, 0x00, 0x1f, 0x00, 0x00, 0x13, 0x15, 0x33, 0x15, 0x23, 0x11,
+  0x14, 0x16, 0x3b, 0x01, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x36, 0x3d, 0x01, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23, 0x35,
+  0x33, 0x35, 0xd4, 0xd8, 0xd8, 0x2c, 0x40, 0x6c, 0x2f, 0x2e, 0x67, 0x27,
+  0x1b, 0x3c, 0x2b, 0x03, 0x78, 0x2e, 0x2e, 0x4c, 0x4c, 0x05, 0xc1, 0xb2,
+  0x50, 0xfe, 0xac, 0x4d, 0x2c, 0x61, 0x78, 0x36, 0x36, 0x58, 0x36, 0x56,
+  0x0b, 0x2d, 0x2c, 0x76, 0x01, 0x54, 0x50, 0xb2, 0x00, 0x02, 0x00, 0x54,
+  0x02, 0x8c, 0x03, 0x35, 0x05, 0x0f, 0x00, 0x17, 0x00, 0x21, 0x00, 0x00,
+  0x13, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15,
+  0x23, 0x15, 0x23, 0x35, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x3d, 0x01,
+  0x29, 0x01, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x55, 0x63,
+  0x68, 0x01, 0x43, 0x69, 0x69, 0x69, 0x69, 0x27, 0x32, 0x32, 0x42, 0x6d,
+  0x71, 0x01, 0xaa, 0xfe, 0xbe, 0x23, 0x23, 0x46, 0x55, 0x31, 0x2c, 0x03,
+  0x99, 0x5c, 0x01, 0x1a, 0xfe, 0xe6, 0x01, 0x1a, 0xfe, 0xe6, 0x5c, 0xfd,
+  0x60, 0x39, 0x1c, 0x1b, 0x86, 0x82, 0x05, 0x02, 0x59, 0x2c, 0x2d, 0x36,
+  0x2f, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3f, 0x02, 0x8b, 0x02, 0x90,
+  0x05, 0x0f, 0x00, 0x26, 0x00, 0x00, 0x13, 0x35, 0x33, 0x15, 0x06, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x27, 0x35, 0x33, 0x15, 0x23, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x20, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x40, 0xfb, 0x3e,
+  0x24, 0x25, 0x32, 0x32, 0x51, 0x52, 0x31, 0x33, 0x26, 0x28, 0x38, 0xf6,
+  0x85, 0x40, 0x20, 0x1f, 0x51, 0x50, 0xff, 0x00, 0x50, 0x51, 0x1e, 0x1e,
+  0x43, 0x04, 0xb3, 0x5c, 0x7b, 0x27, 0x3a, 0x3f, 0x4b, 0x59, 0x37, 0x36,
+  0x36, 0x37, 0x59, 0x52, 0x38, 0x3e, 0x23, 0x7b, 0x5c, 0x38, 0x3f, 0x3e,
+  0x4c, 0x83, 0x52, 0x52, 0x51, 0x52, 0x80, 0x52, 0x3c, 0x3d, 0x3a, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0x02, 0x8a, 0x02, 0x51, 0x05, 0x0f, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x16, 0x01, 0x5d,
+  0x49, 0x41, 0x69, 0x3d, 0x3e, 0x78, 0x78, 0x3f, 0x3d, 0x6a, 0x40, 0x02,
+  0xe2, 0x50, 0x5a, 0x01, 0x83, 0xfe, 0x73, 0x7b, 0x3e, 0x3f, 0x3f, 0x3e,
+  0x7b, 0x01, 0x8d, 0xfe, 0x7d, 0x5a, 0x50, 0x00, 0x00, 0x01, 0x00, 0x6d,
+  0x02, 0x9c, 0x02, 0x79, 0x05, 0x0f, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x33,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x26, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3f, 0x01, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x26, 0x01, 0x43, 0xb7, 0x41, 0x1f, 0x1f, 0x50,
+  0x51, 0x80, 0x28, 0x66, 0x5c, 0x68, 0x15, 0x17, 0x3b, 0x1d, 0x51, 0x32,
+  0x31, 0x24, 0x2d, 0x35, 0x2b, 0x04, 0xc4, 0x38, 0x3f, 0x3e, 0x4c, 0x83,
+  0x52, 0x52, 0x6c, 0x77, 0x01, 0x90, 0xfe, 0x70, 0x55, 0x1c, 0x1c, 0x01,
+  0x01, 0x36, 0x37, 0x59, 0x51, 0x38, 0x43, 0x1f, 0x18, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x22, 0x02, 0x9c, 0x02, 0x8d, 0x05, 0x0f, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x13, 0x33, 0x02, 0x8c, 0x6e,
+  0xc6, 0xc7, 0x6f, 0xef, 0x8e, 0x02, 0x9c, 0x02, 0x0e, 0xfd, 0xf2, 0x02,
+  0x73, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31, 0x02, 0x9c, 0x02, 0x30,
+  0x05, 0x0f, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15,
+  0x21, 0x35, 0x01, 0x21, 0x40, 0x01, 0xf0, 0xfe, 0x77, 0x01, 0x89, 0xfe,
+  0x02, 0x01, 0x88, 0xfe, 0x86, 0x05, 0x0f, 0x5e, 0xfe, 0x3d, 0x52, 0x5e,
+  0x01, 0xc3, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31, 0x01, 0xad, 0x02, 0xb1,
+  0x05, 0x0f, 0x00, 0x16, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x15,
+  0x23, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d,
+  0x01, 0x21, 0x35, 0x01, 0x21, 0x40, 0x01, 0xf0, 0xfe, 0x77, 0x01, 0x89,
+  0x01, 0x15, 0x15, 0x3d, 0x1a, 0x27, 0x67, 0x5c, 0xfe, 0x6c, 0x01, 0x88,
+  0xfe, 0x86, 0x05, 0x0f, 0x5e, 0xfe, 0x3d, 0x52, 0x0b, 0x56, 0x1b, 0x1b,
+  0x58, 0x6c, 0x78, 0x0b, 0x5e, 0x01, 0xc3, 0x00, 0x00, 0x02, 0x00, 0x31,
+  0x02, 0x5e, 0x02, 0x30, 0x05, 0x0f, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x06, 0x15, 0x23, 0x34, 0x37, 0x23, 0x35, 0x01, 0x21, 0x35, 0x21,
+  0x15, 0x01, 0x33, 0x36, 0x33, 0x32, 0x15, 0x14, 0x23, 0x27, 0x33, 0x32,
+  0x35, 0x34, 0x23, 0x06, 0x01, 0x56, 0x02, 0x56, 0x02, 0xce, 0x01, 0x88,
+  0xfe, 0x86, 0x01, 0xf0, 0xfe, 0x77, 0x63, 0x23, 0x7c, 0x81, 0xbd, 0x0b,
+  0x0b, 0x63, 0x28, 0x32, 0x02, 0x9c, 0x1d, 0x21, 0x21, 0x1d, 0x5e, 0x01,
+  0xc3, 0x52, 0x5e, 0xfe, 0x3d, 0xa2, 0x8a, 0x6a, 0x52, 0x1f, 0x33, 0x01,
+  0x00, 0x01, 0x00, 0x31, 0x01, 0xa8, 0x02, 0x60, 0x05, 0x0f, 0x00, 0x21,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x13, 0x21, 0x35, 0x21, 0x15,
+  0x01, 0x44, 0x3c, 0x49, 0x38, 0x31, 0x2e, 0x57, 0x56, 0x9f, 0x35, 0x39,
+  0x38, 0x3c, 0x2f, 0x72, 0x3e, 0x6c, 0x37, 0x39, 0x34, 0x34, 0x5e, 0x63,
+  0xf4, 0xfe, 0x86, 0x01, 0xef, 0x03, 0xa7, 0x20, 0x17, 0x3d, 0x3b, 0x4d,
+  0x7c, 0x43, 0x44, 0x0a, 0x0b, 0x14, 0x6d, 0x1b, 0x1c, 0x2a, 0x2a, 0x50,
+  0x4a, 0x2a, 0x29, 0x5d, 0x01, 0x18, 0x52, 0x5e, 0x00, 0x03, 0x00, 0x3f,
+  0x02, 0x8f, 0x02, 0x88, 0x06, 0x0c, 0x00, 0x08, 0x00, 0x10, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x21, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x13, 0x32, 0x17, 0x16, 0x10,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x10, 0x37, 0x36, 0x02, 0x18, 0xfe, 0x97,
+  0x05, 0x2a, 0x31, 0x55, 0x53, 0x31, 0x2a, 0x05, 0x09, 0x26, 0x31, 0xa7,
+  0x31, 0x27, 0x08, 0xb4, 0x87, 0x4f, 0x4d, 0x4d, 0x4f, 0x87, 0x89, 0x9b,
+  0x4d, 0x4e, 0x04, 0x2a, 0x80, 0x4d, 0x57, 0x58, 0x4d, 0xde, 0x6d, 0x47,
+  0x59, 0x58, 0x46, 0x6f, 0x01, 0x83, 0x76, 0x77, 0xfe, 0x5e, 0x77, 0x77,
+  0xee, 0x01, 0xa2, 0x77, 0x76, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xb8,
+  0x04, 0xee, 0xff, 0xaf, 0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x35, 0x21, 0x37, 0x33, 0xfe, 0xd2, 0xfd, 0xe6, 0x01, 0xe2, 0x97, 0x7d,
+  0x04, 0xee, 0x94, 0xe4, 0x00, 0x01, 0xfc, 0xb8, 0x04, 0xee, 0xff, 0xaf,
+  0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x03, 0x33, 0x17, 0x21, 0x15,
+  0xfd, 0x95, 0xdd, 0x7d, 0x98, 0x01, 0xe1, 0x04, 0xee, 0x01, 0x78, 0xe4,
+  0x94, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xb8, 0x04, 0xee, 0xff, 0xaf,
+  0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x13, 0x23, 0x27, 0x21, 0x35,
+  0xfe, 0xd2, 0xdc, 0x7d, 0x97, 0xfe, 0x1e, 0x06, 0x66, 0xfe, 0x88, 0xe4,
+  0x94, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfc, 0xb8, 0x04, 0xee, 0xff, 0xaf,
+  0x06, 0x66, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x07, 0x23,
+  0xfd, 0x95, 0x02, 0x19, 0xfe, 0x1f, 0x98, 0x7d, 0x06, 0x66, 0x94, 0xe4,
+  0x00, 0x01, 0xfc, 0xa1, 0x04, 0xee, 0xff, 0xc5, 0x06, 0x66, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x33, 0x13, 0x23, 0x27, 0x07, 0x23, 0x03, 0x33, 0x17,
+  0xfe, 0x63, 0x85, 0xdd, 0x7d, 0xa2, 0xa2, 0x86, 0xdc, 0x7d, 0xa2, 0x06,
+  0x66, 0xfe, 0x88, 0xf5, 0xf5, 0x01, 0x78, 0xf5, 0x00, 0x01, 0xfc, 0xa1,
+  0x04, 0xee, 0xff, 0xc5, 0x06, 0x66, 0x00, 0x09, 0x00, 0x00, 0x01, 0x17,
+  0x37, 0x33, 0x03, 0x23, 0x27, 0x07, 0x23, 0x13, 0xfe, 0x04, 0xa2, 0xa2,
+  0x7d, 0xdd, 0x85, 0xa2, 0xa2, 0x7d, 0xdc, 0x06, 0x66, 0xf5, 0xf5, 0xfe,
+  0x88, 0xf5, 0xf5, 0x01, 0x78, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0xfe, 0x13, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd6, 0x04, 0x43,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e,
+  0xfe, 0x13, 0x03, 0xc3, 0x04, 0x7b, 0x10, 0x27, 0x02, 0xd6, 0x03, 0xe5,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x6e, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x43,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x25, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa5,
+  0xff, 0xe3, 0x04, 0x2e, 0x07, 0x52, 0x10, 0x27, 0x02, 0xb8, 0x02, 0xc7,
+  0x01, 0x3e, 0x12, 0x06, 0x00, 0x45, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x89, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x25, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x04, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x89, 0x04, 0x2e, 0x06, 0x14, 0x12, 0x26, 0x00, 0x45, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x04, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0xc0, 0x04, 0x6e, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x25, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x8f, 0x00, 0x88, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0xc0, 0x04, 0x2e, 0x06, 0x14, 0x12, 0x26, 0x00, 0x45, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x8f, 0x00, 0x81, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xfe, 0x75, 0x04, 0xa4, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0xc4,
+  0x01, 0x76, 0x12, 0x06, 0x00, 0x89, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x75, 0x03, 0x84, 0x06, 0x66, 0x12, 0x26, 0x00, 0xa9, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x76, 0x3c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x1f, 0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x6e,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x03, 0xeb, 0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x05, 0x65,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x8a, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x6e,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x8a, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd4, 0x03, 0xf5,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0xc1, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xe2, 0x04, 0x6e,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0xc1, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27, 0x02, 0xe2, 0x03, 0xf5,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x77, 0x05, 0x1f, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x27, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x7a, 0x52, 0x02, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x75, 0x03, 0xeb, 0x06, 0x14, 0x12, 0x26, 0x00, 0x47, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x7a, 0xf7, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x15, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xde, 0x04, 0x6e,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x15, 0x03, 0xeb, 0x06, 0x14, 0x10, 0x27, 0x02, 0xde, 0x03, 0xf5,
+  0x00, 0x01, 0x12, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x08, 0x5a, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x06, 0x11, 0x24, 0xf0, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x07, 0x5e, 0x10, 0x27, 0x11, 0x24, 0xff, 0xdd,
+  0xff, 0x04, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x17, 0x08, 0x5a, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x06, 0x11, 0x23, 0xee, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x07, 0x5e, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x10, 0x07, 0x11, 0x23, 0xff, 0xdb, 0xff, 0x04, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x4b, 0x04, 0x17, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xde, 0x04, 0x39, 0x00, 0x37, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x4b, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xde, 0x04, 0x38, 0x00, 0x37, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x76, 0x04, 0x17, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xb0, 0x00, 0xa1, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x76, 0x04, 0x0c, 0x04, 0x7b, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xb0, 0x00, 0x8c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x75, 0x04, 0x17, 0x07, 0x6d, 0x10, 0x27, 0x10, 0xf2, 0x04, 0x2a,
+  0x01, 0x75, 0x12, 0x26, 0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x00, 0x7a,
+  0x00, 0xab, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x75, 0x04, 0x0c,
+  0x06, 0x48, 0x12, 0x26, 0x00, 0x48, 0x00, 0x00, 0x10, 0x26, 0x02, 0x9a,
+  0x7a, 0x00, 0x10, 0x06, 0x00, 0x7a, 0x44, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0xba, 0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x04,
+  0x01, 0x74, 0x12, 0x06, 0x00, 0x29, 0x00, 0x00, 0xff, 0xff, 0x00, 0x2a,
+  0x00, 0x00, 0x02, 0xac, 0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x03, 0x7d,
+  0x01, 0x75, 0x12, 0x06, 0x00, 0x49, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xfe, 0x07, 0x18, 0x12, 0x26, 0x00, 0x2a, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x8b, 0x01, 0x13, 0x01, 0x22, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x03, 0xeb, 0x05, 0xf6, 0x12, 0x26, 0x00, 0x4a, 0x00, 0x00,
+  0x10, 0x06, 0x02, 0x8b, 0x42, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xb6, 0x07, 0x4e, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x92,
+  0x01, 0x73, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa5,
+  0x00, 0x00, 0x03, 0xf4, 0x07, 0x52, 0x10, 0x27, 0x02, 0xb8, 0x02, 0xc7,
+  0x01, 0x3e, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x89, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x82,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x89, 0x03, 0xf4, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x1a,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xb6, 0x07, 0x50, 0x12, 0x26, 0x00, 0x2b, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x6a, 0x00, 0xee, 0x01, 0x40, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xf4, 0x07, 0x4e, 0x10, 0x27, 0x02, 0xb9, 0x02, 0xc7,
+  0x01, 0x3e, 0x12, 0x06, 0x00, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0f,
+  0xfe, 0x74, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2b, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x7a, 0xff, 0x09, 0xff, 0xff, 0xff, 0xff, 0x00, 0x01,
+  0xfe, 0x74, 0x03, 0xf4, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4b, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x7a, 0xfe, 0xfc, 0xff, 0xff, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x39, 0x04, 0xb6, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2b, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xdf, 0x04, 0x89, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x39, 0x03, 0xf4, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4b, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xdf, 0x04, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,
+  0xfe, 0x76, 0x02, 0x52, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xb0, 0xff, 0x5c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xd7,
+  0xfe, 0x76, 0x02, 0x2a, 0x06, 0x14, 0x10, 0x27, 0x02, 0xb0, 0xff, 0x34,
+  0x00, 0x00, 0x12, 0x06, 0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x02, 0x1d, 0x08, 0x5a, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x11, 0x21, 0xfe, 0x9c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf5,
+  0x00, 0x00, 0x02, 0x0c, 0x07, 0x16, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00,
+  0x10, 0x07, 0x11, 0x21, 0xfe, 0x8a, 0xfe, 0xbc, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xe0, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0x65,
+  0x01, 0x76, 0x12, 0x06, 0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x26, 0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x03, 0x04,
+  0x01, 0x76, 0x12, 0x06, 0x00, 0x4e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x89, 0x04, 0xe0, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2e, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x04, 0x60, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x89, 0x04, 0x26, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4e, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x04, 0x1c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0xc0, 0x04, 0xe0, 0x05, 0xd5, 0x12, 0x26, 0x00, 0x2e, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x8f, 0x00, 0xf2, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0xc0, 0x04, 0x26, 0x06, 0x14, 0x12, 0x26, 0x00, 0x4e, 0x00, 0x00,
+  0x10, 0x06, 0x02, 0x8f, 0x6a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x89, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x24,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x89, 0x01, 0x5e, 0x06, 0x14, 0x10, 0x27, 0x02, 0xd4, 0x02, 0xd6,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0x4f, 0x0a, 0x00, 0xff, 0xff, 0x00, 0x02,
+  0xfe, 0x8a, 0x03, 0xf9, 0x07, 0x6b, 0x10, 0x27, 0x02, 0xb5, 0x02, 0xd9,
+  0x01, 0x75, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x23, 0x00, 0x01, 0x12, 0x06,
+  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfd, 0xfe, 0x89, 0x02, 0x18,
+  0x07, 0x31, 0x10, 0x27, 0x00, 0x71, 0xff, 0x3e, 0x01, 0x3b, 0x10, 0x06,
+  0x05, 0x87, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0xc0, 0x03, 0xf9,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x2f, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f,
+  0x00, 0x80, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf5, 0xfe, 0xc0, 0x02, 0x10,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0x8f, 0xff, 0x36, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x14, 0x03, 0xf9,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0x88, 0x00, 0x88, 0xf9, 0x26, 0x12, 0x06,
+  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe1, 0xfe, 0x14, 0x02, 0x20,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0x88, 0xff, 0x34, 0xf9, 0x26, 0x12, 0x06,
+  0x00, 0x4f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83,
+  0x07, 0x6c, 0x10, 0x27, 0x10, 0xec, 0x04, 0xe8, 0x01, 0x76, 0x12, 0x06,
+  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x50, 0x00, 0x00, 0x10, 0x07, 0x00, 0x76,
+  0x01, 0x6c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83,
+  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0xeb, 0x01, 0x74, 0x12, 0x06,
+  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x05, 0x52, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x50, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x05, 0x83,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0xe8, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x06, 0x67,
+  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd4, 0x05, 0x4f, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x50, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae,
+  0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x76, 0x01, 0x75, 0x12, 0x06,
+  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x03, 0xf4,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x04, 0x15, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0xae,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x7e, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x03, 0xf4,
+  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x1a, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0xc0, 0x04, 0xae,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x31, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f,
+  0x00, 0xde, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0xc0, 0x03, 0xf4,
+  0x04, 0x7b, 0x12, 0x26, 0x00, 0x51, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
+  0x7e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0xfe, 0x14, 0x04, 0xae,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0x88, 0x00, 0xe5, 0xf9, 0x26, 0x12, 0x06,
+  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x14, 0x03, 0xf4,
+  0x04, 0x7b, 0x10, 0x27, 0x02, 0x88, 0x00, 0x86, 0xf9, 0x26, 0x12, 0x06,
+  0x00, 0x51, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x08, 0x5a, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x29,
+  0x5c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x07, 0x0c, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00, 0x10, 0x07, 0x11, 0x29,
+  0xff, 0xba, 0xfe, 0xb2, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x08, 0x56, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x27,
+  0x61, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x07, 0x0f, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00, 0x10, 0x27, 0x00, 0x6a,
+  0x00, 0x64, 0x00, 0xff, 0x10, 0x07, 0x10, 0xed, 0x04, 0x00, 0x00, 0x12,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x5a, 0x12, 0x26,
+  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x24, 0x5f, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x5e, 0x10, 0x26,
+  0x00, 0x52, 0x00, 0x00, 0x10, 0x07, 0x11, 0x24, 0xff, 0xbc, 0xff, 0x04,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44, 0x08, 0x5a, 0x12, 0x26,
+  0x00, 0x32, 0x00, 0x00, 0x10, 0x06, 0x11, 0x23, 0x5e, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x07, 0x5e, 0x10, 0x27,
+  0x11, 0x23, 0xff, 0xc0, 0xff, 0x04, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19, 0x07, 0x6c, 0x10, 0x27,
+  0x10, 0xec, 0x04, 0x28, 0x01, 0x76, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0x53, 0x00, 0x00, 0x10, 0x06, 0x00, 0x76, 0x2d, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x19, 0x07, 0x4f, 0x10, 0x27,
+  0x10, 0xf3, 0x04, 0x10, 0x01, 0x74, 0x12, 0x06, 0x00, 0x33, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x10, 0x27,
+  0x02, 0xb8, 0x04, 0x2f, 0x00, 0x00, 0x12, 0x06, 0x00, 0x53, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc, 0x07, 0x4e, 0x10, 0x27,
+  0x10, 0xf3, 0x04, 0x10, 0x01, 0x73, 0x12, 0x06, 0x00, 0x35, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x02, 0xf6, 0x06, 0x14, 0x10, 0x27,
+  0x02, 0xb8, 0x03, 0xae, 0x00, 0x00, 0x12, 0x06, 0x00, 0x55, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0xcc, 0x05, 0xd5, 0x10, 0x27,
+  0x02, 0xd4, 0x04, 0x0a, 0x00, 0x00, 0x10, 0x06, 0x00, 0x35, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x02, 0xf6, 0x04, 0x7b, 0x10, 0x27,
+  0x02, 0xd4, 0x02, 0xd0, 0x00, 0x00, 0x10, 0x06, 0x00, 0x55, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0xcc, 0x07, 0x31, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0x70, 0x01, 0x3b, 0x10, 0x06, 0x05, 0xaa, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x89, 0x02, 0xf6, 0x05, 0xf5, 0x10, 0x26,
+  0x00, 0x71, 0x15, 0xff, 0x10, 0x06, 0x05, 0xab, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0xc0, 0x04, 0xcc, 0x05, 0xd5, 0x12, 0x26,
+  0x00, 0x35, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f, 0x00, 0xce, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x4b, 0xfe, 0xc0, 0x02, 0xf6, 0x04, 0x7b, 0x12, 0x26,
+  0x00, 0x55, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f, 0x8c, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x07, 0x4f, 0x10, 0x27,
+  0x10, 0xf3, 0x04, 0x3f, 0x01, 0x74, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x06, 0x14, 0x10, 0x27,
+  0x02, 0xb8, 0x03, 0xbd, 0x00, 0x00, 0x12, 0x06, 0x00, 0x56, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x79, 0xfe, 0x89, 0x04, 0x2c, 0x05, 0xf0, 0x10, 0x27,
+  0x02, 0xd4, 0x04, 0x16, 0x00, 0x00, 0x10, 0x06, 0x00, 0x36, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xfe, 0x8a, 0x03, 0x67, 0x04, 0x7b, 0x10, 0x27,
+  0x02, 0xd4, 0x03, 0xbb, 0x00, 0x01, 0x12, 0x06, 0x00, 0x56, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xec, 0x04, 0x65, 0x01, 0x76, 0x10, 0x27, 0x10, 0xf3, 0x03, 0x47,
+  0x01, 0x92, 0x12, 0x06, 0x00, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
+  0xff, 0xe3, 0x03, 0x7f, 0x06, 0x66, 0x12, 0x26, 0x00, 0x56, 0x00, 0x00,
+  0x10, 0x26, 0x02, 0x9b, 0x98, 0x56, 0x10, 0x07, 0x00, 0x76, 0x00, 0x82,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x04, 0x2c,
+  0x08, 0x57, 0x10, 0x26, 0x11, 0x28, 0xe7, 0x00, 0x12, 0x06, 0x00, 0x36,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
+  0x07, 0xc9, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xc2, 0x01, 0xb5, 0x12, 0x06,
+  0x01, 0x23, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x89, 0x04, 0x2c,
+  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x25, 0x01, 0x74, 0x12, 0x06,
+  0x05, 0xb2, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xfe, 0x8a, 0x03, 0x67,
+  0x05, 0xde, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xbd, 0xff, 0xca, 0x12, 0x06,
+  0x05, 0xb3, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c,
+  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x00, 0x01, 0x74, 0x12, 0x06,
+  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0x00, 0x00, 0x02, 0xa7,
+  0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x02, 0xcb, 0x01, 0x75, 0x12, 0x06,
+  0x00, 0x57, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0xfe, 0x89, 0x04, 0x6c,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x03, 0xff, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0xfe, 0x89, 0x02, 0xa7,
+  0x05, 0x9e, 0x10, 0x27, 0x02, 0xd4, 0x03, 0x84, 0x00, 0x00, 0x10, 0x06,
+  0x00, 0x57, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0xfe, 0xc0, 0x04, 0x6c,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x37, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
+  0x58, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0xfe, 0xc0, 0x02, 0xd0,
+  0x05, 0x9e, 0x10, 0x26, 0x02, 0x8f, 0xf5, 0x00, 0x12, 0x06, 0x00, 0x57,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfa, 0xfe, 0x14, 0x04, 0x6c,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0x88, 0x00, 0x67, 0xf9, 0x26, 0x12, 0x06,
+  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31, 0xfe, 0x14, 0x02, 0xd6,
+  0x05, 0x9e, 0x10, 0x27, 0x02, 0x88, 0xff, 0xea, 0xf9, 0x26, 0x12, 0x06,
+  0x00, 0x57, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x89, 0x04, 0xa5,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd5, 0x04, 0x72, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x38, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x89, 0x03, 0xe9,
+  0x04, 0x7b, 0x10, 0x27, 0x02, 0xd5, 0x04, 0x08, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x76, 0x04, 0xa5,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xb0,
+  0x00, 0xda, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x76, 0x03, 0xe9,
+  0x04, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xb0,
+  0x00, 0x81, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x4b, 0x04, 0xa5,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xde,
+  0x04, 0x63, 0x00, 0x37, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x4b, 0x03, 0xe9,
+  0x04, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xde,
+  0x04, 0x03, 0x00, 0x37, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x08, 0x5a, 0x10, 0x26, 0x11, 0x29, 0x29, 0x00, 0x12, 0x06, 0x00, 0x38,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
+  0x07, 0xec, 0x10, 0x26, 0x01, 0x2b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x76,
+  0x00, 0x87, 0x01, 0x86, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x08, 0x34, 0x10, 0x26, 0x11, 0x1f, 0x2d, 0x00, 0x12, 0x06, 0x00, 0x38,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
+  0x06, 0xf4, 0x10, 0x27, 0x11, 0x1f, 0xff, 0xce, 0xfe, 0xc0, 0x12, 0x06,
+  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x07, 0x7d, 0x12, 0x26, 0x00, 0x39, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9e,
+  0x00, 0xd5, 0x01, 0x46, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
+  0x06, 0x37, 0x12, 0x26, 0x00, 0x59, 0x00, 0x00, 0x10, 0x06, 0x02, 0x9e,
+  0x62, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde,
+  0x05, 0xd5, 0x10, 0x26, 0x00, 0x39, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x89, 0x04, 0x0c,
+  0x04, 0x60, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x03, 0xee, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
+  0x07, 0x72, 0x10, 0x27, 0x10, 0xee, 0x05, 0x5c, 0x01, 0x7c, 0x12, 0x06,
+  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
+  0x06, 0x6b, 0x10, 0x27, 0x00, 0x43, 0x00, 0xee, 0x00, 0x05, 0x12, 0x06,
+  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
+  0x07, 0x72, 0x10, 0x27, 0x10, 0xec, 0x05, 0x5c, 0x01, 0x7c, 0x12, 0x06,
+  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
+  0x06, 0x6d, 0x10, 0x27, 0x00, 0x76, 0x01, 0x5f, 0x00, 0x07, 0x12, 0x06,
+  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
+  0x07, 0x4e, 0x10, 0x27, 0x00, 0x6a, 0x01, 0xc3, 0x01, 0x3e, 0x12, 0x06,
+  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
+  0x06, 0x10, 0x10, 0x27, 0x00, 0x6a, 0x01, 0x24, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3,
+  0x07, 0x4e, 0x10, 0x27, 0x10, 0xf3, 0x05, 0x5c, 0x01, 0x73, 0x12, 0x06,
+  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x04, 0xc0, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x5a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3d, 0xfe, 0x89, 0x06, 0xe3,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x3a, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x05, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d, 0xfe, 0x89, 0x05, 0x97,
+  0x04, 0x60, 0x12, 0x26, 0x00, 0x5a, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0xc3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
+  0x07, 0x4f, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x4f, 0x01, 0x73, 0x12, 0x06,
+  0x00, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xf2, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x5b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
+  0x07, 0x4e, 0x12, 0x26, 0x00, 0x3b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x6a,
+  0x00, 0xb6, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07,
+  0x06, 0x10, 0x12, 0x26, 0x00, 0x5b, 0x00, 0x00, 0x10, 0x06, 0x00, 0x6a,
+  0x5c, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
+  0x07, 0x50, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06,
+  0x00, 0x3c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x06, 0x14, 0x10, 0x27, 0x02, 0xb8, 0x03, 0xf0, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c,
+  0x07, 0x6d, 0x10, 0x27, 0x10, 0xef, 0x04, 0x45, 0x01, 0x75, 0x12, 0x06,
+  0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0x00, 0x00, 0x03, 0x79,
+  0x06, 0x66, 0x12, 0x26, 0x00, 0x5d, 0x00, 0x00, 0x10, 0x06, 0x02, 0x88,
+  0x17, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52, 0xfe, 0x89, 0x04, 0x9c,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x3d, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0x5d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0xfe, 0x89, 0x03, 0x79,
+  0x04, 0x60, 0x12, 0x26, 0x00, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x03, 0xc6, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52, 0xfe, 0xc0, 0x04, 0x9c,
+  0x05, 0xd5, 0x12, 0x26, 0x00, 0x3d, 0x00, 0x00, 0x10, 0x07, 0x02, 0x8f,
+  0x00, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f, 0xfe, 0xc0, 0x03, 0x79,
+  0x04, 0x60, 0x12, 0x26, 0x00, 0x5d, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
+  0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0xc0, 0x03, 0xf4,
+  0x06, 0x14, 0x12, 0x26, 0x00, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f,
+  0x5c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x02, 0xa7,
+  0x07, 0x4e, 0x12, 0x26, 0x00, 0x57, 0x00, 0x00, 0x10, 0x07, 0x00, 0x6a,
+  0xff, 0x42, 0x01, 0x3e, 0xff, 0xff, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x97,
+  0x07, 0x06, 0x12, 0x26, 0x00, 0x5a, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9c,
+  0x01, 0x22, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x07, 0x06, 0x12, 0x26, 0x00, 0x5c, 0x00, 0x00, 0x10, 0x06, 0x02, 0x9c,
+  0x74, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x04, 0xd8,
+  0x06, 0x14, 0x12, 0x26, 0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x02, 0x80,
+  0x03, 0x77, 0x00, 0x00, 0xff, 0xff, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac,
+  0x07, 0x89, 0x10, 0x27, 0x02, 0xb8, 0x03, 0x7d, 0x01, 0x75, 0x12, 0x06,
+  0x01, 0x41, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x02, 0xac,
+  0x06, 0x14, 0x00, 0x18, 0x00, 0x00, 0x21, 0x23, 0x11, 0x07, 0x27, 0x37,
+  0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x11, 0x37, 0x17, 0x05, 0x01, 0x6f, 0xa6, 0x85, 0x42,
+  0xc7, 0x9f, 0x9f, 0x9c, 0xaa, 0x9d, 0x9e, 0x5a, 0x23, 0x22, 0xc1, 0x43,
+  0xfe, 0xfc, 0x02, 0x14, 0x68, 0x6a, 0x9d, 0x01, 0x1e, 0x8f, 0x4e, 0xbb,
+  0xab, 0x99, 0x28, 0x29, 0x67, 0xfe, 0x74, 0x98, 0x69, 0xcf, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac, 0x06, 0x14, 0x00, 0x17,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33,
+  0x36, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06, 0x07, 0x33,
+  0x15, 0x23, 0x01, 0x6f, 0xa6, 0x9f, 0x9f, 0x9f, 0xa1, 0x0c, 0x40, 0x4e,
+  0xaa, 0x9d, 0x9e, 0x5a, 0x23, 0x1b, 0x05, 0xe4, 0xe6, 0x03, 0x45, 0x8f,
+  0x8c, 0x8f, 0x89, 0x46, 0x56, 0x99, 0x28, 0x20, 0x44, 0x8f, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa0, 0xff, 0xe3, 0x05, 0x22, 0x05, 0xf2, 0x00, 0x37,
+  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x0e, 0x03, 0x15, 0x11, 0x23, 0x11,
+  0x34, 0x3e, 0x03, 0x33, 0x32, 0x04, 0x17, 0x22, 0x06, 0x15, 0x14, 0x1e,
+  0x05, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x2e, 0x07, 0x35, 0x34, 0x36, 0x03, 0x9c, 0x62, 0x9c,
+  0x3a, 0x5c, 0x55, 0x3a, 0x22, 0xb7, 0x34, 0x5a, 0x81, 0x95, 0x5a, 0xc3,
+  0x01, 0x11, 0x32, 0xba, 0xe8, 0x3d, 0x5f, 0x74, 0x74, 0x60, 0x3c, 0xee,
+  0xbe, 0xa2, 0xb5, 0x62, 0x9f, 0x64, 0x58, 0x88, 0x25, 0x3f, 0x52, 0x5a,
+  0x5a, 0x52, 0x3f, 0x25, 0xc9, 0x04, 0xf4, 0x5a, 0x18, 0x40, 0x68, 0xa7,
+  0x6f, 0xfc, 0x88, 0x03, 0x91, 0x83, 0xcf, 0x8b, 0x5c, 0x28, 0xc5, 0xbd,
+  0x7d, 0x5f, 0x2d, 0x43, 0x2d, 0x2d, 0x3e, 0x54, 0x8c, 0x5c, 0xa4, 0xc9,
+  0x5f, 0xd0, 0x45, 0x46, 0x76, 0x58, 0x35, 0x50, 0x33, 0x29, 0x20, 0x24,
+  0x32, 0x42, 0x67, 0x43, 0x8f, 0xbb, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x05, 0xf0, 0x10, 0x06, 0x03, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x27,
+  0x02, 0xd4, 0x04, 0x3e, 0x00, 0x00, 0x12, 0x06, 0x00, 0x24, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xfe, 0x89, 0x03, 0xc3, 0x04, 0x7b, 0x10, 0x27,
+  0x02, 0xd4, 0x03, 0xb7, 0x00, 0x00, 0x12, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0xf0, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x04, 0x43, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0x7b, 0x12, 0x26,
+  0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x03, 0xe5, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x3a, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2a, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x04, 0x37, 0x06, 0xc5, 0x10, 0x27,
+  0x11, 0x2a, 0xff, 0xa1, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x3a, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2b, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x06, 0xc6, 0x10, 0x26,
+  0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x11, 0x2b, 0xff, 0x9f, 0xfe, 0x8c,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x5b, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x31, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x04, 0x27, 0x06, 0xe6, 0x10, 0x27,
+  0x11, 0x31, 0xff, 0xa1, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x75, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2c, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x00, 0x10, 0x27,
+  0x11, 0x2c, 0xff, 0xa1, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde, 0x07, 0x6d, 0x12, 0x26,
+  0x00, 0x84, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x37, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xfe, 0x89, 0x03, 0xc3, 0x06, 0x66, 0x12, 0x26,
+  0x00, 0xa4, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x03, 0xb8, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x5a, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2e, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x04, 0x10, 0x27,
+  0x11, 0x2e, 0xff, 0x9c, 0xfe, 0xaa, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x5a, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2f, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x04, 0x10, 0x27,
+  0x11, 0x2f, 0xff, 0x9d, 0xfe, 0xaa, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x8b, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x30, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x35, 0x10, 0x27,
+  0x11, 0x30, 0xff, 0x9f, 0xfe, 0xaa, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x08, 0x59, 0x12, 0x26,
+  0x00, 0x24, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2d, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3, 0x07, 0x03, 0x10, 0x26,
+  0x00, 0x44, 0x00, 0x00, 0x10, 0x07, 0x11, 0x2d, 0xff, 0x9d, 0xfe, 0xaa,
+  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x89, 0x04, 0xde, 0x07, 0x92, 0x12, 0x26,
+  0x00, 0xc4, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x46, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6e, 0xfe, 0x89, 0x03, 0xc3, 0x06, 0x1f, 0x12, 0x26,
+  0x00, 0xc5, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x03, 0xc8, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0x17, 0x05, 0xd5, 0x10, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x28, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0x89, 0x04, 0x0c, 0x04, 0x7b, 0x10, 0x26,
+  0x00, 0x48, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x17, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0xf0, 0x12, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x04, 0x28, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x7b, 0x12, 0x26,
+  0x00, 0x48, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba, 0x04, 0x18, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x07, 0x5e, 0x10, 0x27,
+  0x10, 0xed, 0x04, 0x28, 0x01, 0x75, 0x12, 0x06, 0x00, 0x28, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0x37, 0x10, 0x27,
+  0x02, 0x9e, 0x00, 0x88, 0x00, 0x00, 0x12, 0x06, 0x00, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x96, 0x08, 0x3a, 0x12, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2a, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x6b, 0x06, 0xc5, 0x10, 0x27,
+  0x11, 0x2a, 0xff, 0xd5, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x08, 0x3a, 0x12, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2b, 0xf0, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x06, 0xc6, 0x10, 0x27,
+  0x11, 0x2b, 0xff, 0xd5, 0xfe, 0x8c, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x77, 0x08, 0x5b, 0x12, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x31, 0xf0, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x5c, 0x06, 0xe6, 0x10, 0x26,
+  0x00, 0x48, 0x00, 0x00, 0x10, 0x07, 0x11, 0x31, 0xff, 0xd5, 0xfe, 0x8b,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x08, 0x75, 0x12, 0x26,
+  0x00, 0x28, 0x00, 0x00, 0x10, 0x06, 0x11, 0x2c, 0xec, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x0c, 0x07, 0x00, 0x10, 0x27,
+  0x11, 0x2c, 0xff, 0xd6, 0xfe, 0x8b, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0x89, 0x04, 0x17, 0x07, 0x6d, 0x12, 0x26,
+  0x00, 0x8c, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4, 0x04, 0x28, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0x89, 0x04, 0x0c, 0x06, 0x66, 0x10, 0x27,
+  0x02, 0xd4, 0x04, 0x17, 0x00, 0x00, 0x10, 0x26, 0x06, 0x09, 0x00, 0x00,
+  0x10, 0x06, 0x02, 0x88, 0x7d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x51,
+  0x00, 0x00, 0x01, 0xe5, 0x07, 0xf0, 0x12, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xba, 0x02, 0xd3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x3d,
+  0x00, 0x00, 0x01, 0xd1, 0x06, 0x7c, 0x12, 0x26, 0x00, 0xf3, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xba, 0x02, 0xbf, 0x00, 0x01, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x89, 0x01, 0x6b, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x00, 0xab,
+  0xfe, 0x89, 0x01, 0x54, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x02, 0xcd, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xfe, 0x89, 0x05, 0x44, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x04, 0xa3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x89, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x04, 0x01, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x07, 0xf0, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xba, 0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x7b, 0x12, 0x26, 0x00, 0x52, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xba, 0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x08, 0x3a, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x06, 0x11, 0x2a, 0x61, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x53, 0x06, 0xc5, 0x10, 0x27, 0x11, 0x2a, 0xff, 0xbd,
+  0xfe, 0x8b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x08, 0x3a, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x06, 0x11, 0x2b, 0x5f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0xc6, 0x10, 0x27, 0x11, 0x2b, 0xff, 0xbc,
+  0xfe, 0x8c, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x08, 0x5b, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x06, 0x11, 0x31, 0x5f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x44, 0x06, 0xe6, 0x10, 0x27, 0x11, 0x31, 0xff, 0xbd,
+  0xfe, 0x8b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x05, 0x44, 0x08, 0x75, 0x12, 0x26, 0x00, 0x32, 0x00, 0x00,
+  0x10, 0x06, 0x11, 0x2c, 0x5b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x07, 0x00, 0x10, 0x27, 0x11, 0x2c, 0xff, 0xbd,
+  0xfe, 0x8b, 0x10, 0x06, 0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xfe, 0x89, 0x05, 0x44, 0x07, 0x6d, 0x12, 0x26, 0x00, 0x96, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x04, 0xa3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x89, 0x04, 0x03, 0x06, 0x66, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x01,
+  0x00, 0x00, 0x10, 0x26, 0x06, 0x1d, 0x00, 0x00, 0x10, 0x06, 0x02, 0x88,
+  0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
+  0x07, 0x6b, 0x10, 0x27, 0x10, 0xec, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06,
+  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
+  0x06, 0x66, 0x10, 0x26, 0x00, 0x76, 0x68, 0x00, 0x12, 0x06, 0x01, 0x63,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
+  0x07, 0x6b, 0x10, 0x27, 0x10, 0xee, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06,
+  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
+  0x06, 0x66, 0x10, 0x26, 0x00, 0x43, 0x68, 0x00, 0x12, 0x06, 0x01, 0x63,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
+  0x07, 0xf0, 0x12, 0x26, 0x01, 0x62, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x04, 0xa3, 0x01, 0x75, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
+  0x06, 0x7b, 0x12, 0x26, 0x01, 0x63, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xff, 0xe3, 0x05, 0x81,
+  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0xa3, 0x01, 0x75, 0x12, 0x06,
+  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xff, 0xe3, 0x04, 0x58,
+  0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x68, 0x00, 0x12, 0x06, 0x01, 0x63,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5c, 0xfe, 0x89, 0x05, 0x81,
+  0x06, 0x14, 0x12, 0x26, 0x01, 0x62, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0xa3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6a, 0xfe, 0x89, 0x04, 0x58,
+  0x04, 0xeb, 0x12, 0x26, 0x01, 0x63, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0x01, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xfe, 0x89, 0x04, 0xa5,
+  0x05, 0xd5, 0x10, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0x76, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9c, 0xfe, 0x89, 0x03, 0xe9,
+  0x04, 0x7b, 0x10, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0x08, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x07, 0xf0, 0x12, 0x26, 0x00, 0x38, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x04, 0x70, 0x01, 0x75, 0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9,
+  0x06, 0x7b, 0x12, 0x26, 0x00, 0x58, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
+  0x07, 0x6b, 0x10, 0x27, 0x10, 0xec, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
+  0x01, 0x71, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
+  0x06, 0x66, 0x10, 0x26, 0x00, 0x76, 0x6f, 0x00, 0x12, 0x06, 0x01, 0x72,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
+  0x07, 0x6b, 0x10, 0x27, 0x10, 0xee, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
+  0x01, 0x71, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
+  0x06, 0x66, 0x10, 0x26, 0x00, 0x43, 0x6f, 0x00, 0x12, 0x06, 0x01, 0x72,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
+  0x07, 0xf0, 0x12, 0x26, 0x01, 0x71, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x04, 0x70, 0x01, 0x75, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
+  0x06, 0x7b, 0x12, 0x26, 0x01, 0x72, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x04, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xff, 0xf7, 0x05, 0xbc,
+  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0x70, 0x01, 0x75, 0x12, 0x06,
+  0x01, 0x71, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xff, 0xe3, 0x04, 0xdf,
+  0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x73, 0x00, 0x12, 0x06, 0x01, 0x72,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9b, 0xfe, 0x89, 0x05, 0xbc,
+  0x06, 0x14, 0x12, 0x26, 0x01, 0x71, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0x76, 0x00, 0x00, 0xff, 0xff, 0x00, 0x9e, 0xfe, 0x89, 0x04, 0xdf,
+  0x04, 0xeb, 0x12, 0x26, 0x01, 0x72, 0x00, 0x00, 0x10, 0x07, 0x02, 0xd4,
+  0x04, 0x08, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
+  0x07, 0x72, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x10, 0x07, 0x10, 0xee,
+  0x04, 0x00, 0x01, 0x7c, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x06, 0x6b, 0x12, 0x26, 0x00, 0x5c, 0x00, 0x00, 0x10, 0x06, 0x00, 0x43,
+  0x1e, 0x05, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0xfe, 0x89, 0x04, 0x6a,
+  0x05, 0xd5, 0x10, 0x27, 0x02, 0xd4, 0x04, 0x04, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x3c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x04, 0x60, 0x10, 0x27, 0x02, 0xd4, 0x04, 0xe8, 0x00, 0x00, 0x12, 0x06,
+  0x00, 0x5c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
+  0x07, 0xf7, 0x12, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x04, 0x00, 0x01, 0x7c, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x06, 0x82, 0x12, 0x26, 0x00, 0x5c, 0x00, 0x00, 0x10, 0x07, 0x02, 0xba,
+  0x03, 0xf0, 0x00, 0x07, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a,
+  0x07, 0x5e, 0x10, 0x27, 0x10, 0xed, 0x04, 0x00, 0x01, 0x75, 0x12, 0x06,
+  0x00, 0x3c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x06, 0x37, 0x10, 0x26, 0x02, 0x9e, 0x6b, 0x00, 0x12, 0x06, 0x00, 0x5c,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x80,
+  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x33, 0x11, 0x33, 0x11, 0x33,
+  0x11, 0x21, 0x15, 0x21, 0xb5, 0xb6, 0xd1, 0xb5, 0x02, 0x8f, 0xfb, 0x35,
+  0x05, 0xd5, 0xfa, 0xd5, 0x05, 0x2b, 0xfa, 0xd5, 0xaa, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x1c, 0x00, 0x00, 0x03, 0x54, 0x06, 0x14, 0x00, 0x13,
+  0x00, 0x00, 0x13, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xae, 0xa5,
+  0xca, 0xa5, 0x91, 0x91, 0xa5, 0xca, 0xa5, 0x91, 0x91, 0x06, 0x14, 0x93,
+  0x93, 0x93, 0x7d, 0xfa, 0xfc, 0x05, 0x04, 0xfa, 0xfc, 0x05, 0x04, 0x7d,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x06, 0xfc, 0x65, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x34, 0x41, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x07, 0x07, 0x09, 0x00, 0x85, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x77, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0a, 0x77, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0x00, 0x90, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0b, 0x6a, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26,
+  0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x18, 0x3d, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x26, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xff, 0x39, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x26, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xff, 0x0e, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0x42, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x26, 0x01, 0x64, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00,
+  0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x06, 0x42, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x26, 0x01, 0x64, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x05, 0x7b, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x26, 0x00, 0x9d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x05, 0xb6,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x26, 0x00, 0xd8, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x05, 0x0a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x26, 0x2c, 0x00,
+  0x10, 0x07, 0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
+  0x00, 0x00, 0x05, 0x4a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x26, 0x6c, 0x00,
+  0x10, 0x07, 0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x06, 0x61, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
+  0x10, 0x06, 0x06, 0xfc, 0x3d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x06, 0x61, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x34, 0x33, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x09, 0x1d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x16, 0x21, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x80, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x0a, 0x47, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x9d, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x17, 0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x04, 0xa9, 0x06, 0x61, 0x10, 0x27, 0x03, 0x2a, 0x00, 0x92,
+  0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x04, 0xa9, 0x06, 0x61, 0x10, 0x27,
+  0x03, 0x2a, 0x00, 0x92, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0x7f,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x02, 0x68, 0x00, 0x00, 0x10, 0x06,
+  0x07, 0x09, 0x89, 0x00, 0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x06, 0x8f,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x02, 0x78, 0x00, 0x00, 0x10, 0x06,
+  0x07, 0x16, 0x94, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x06, 0x03,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x01, 0xeb, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x0a, 0xff, 0x64, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0x00, 0x00, 0x06, 0x39, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x02, 0x21,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0x00, 0x95, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0x00, 0x92, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x73, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x65, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0a, 0x77, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0x00, 0x9d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0b, 0x00, 0x8c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x06, 0x07, 0x18, 0x7a, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x05, 0x52, 0x06, 0x61, 0x10, 0x27,
+  0x03, 0x2c, 0x00, 0x9d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x05, 0x4f,
+  0x06, 0x61, 0x10, 0x27, 0x03, 0x2c, 0x00, 0x9a, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0x00, 0x00, 0x07, 0x1d, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2c, 0x02, 0x68,
+  0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0x00, 0x00, 0x07, 0x23, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2c, 0x02, 0x6d,
+  0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x06, 0xb0, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2c, 0x01, 0xfb,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0xdc, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x2c, 0x02, 0x27, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x06, 0x04,
+  0x07, 0x6d, 0x10, 0x27, 0x03, 0x2c, 0x01, 0x4f, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
+  0x00, 0x00, 0x06, 0x1d, 0x07, 0x6d, 0x10, 0x27, 0x03, 0x2c, 0x01, 0x67,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x8b, 0x00, 0x00, 0x02, 0x30, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xff, 0x2c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x82, 0x00, 0x00, 0x02, 0x30, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xff, 0x24, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xb8, 0x00, 0x00, 0x02, 0x74, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x09, 0xff, 0x3d, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xc1, 0x00, 0x00, 0x02, 0x80, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x16, 0xff, 0x50, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x9b, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x62, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xd7, 0x00, 0x00, 0x02, 0xa3, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x50, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xd0, 0x00, 0x00, 0x02, 0x30, 0x07, 0x6d, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0b, 0xff, 0x2c, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xcb, 0x00, 0x00, 0x02, 0x30, 0x07, 0x6d, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x28, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x02, 0x08, 0x06, 0x61, 0x10, 0x27,
+  0x03, 0x2e, 0x00, 0x9d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x01, 0xfd,
+  0x06, 0x61, 0x10, 0x27, 0x03, 0x2e, 0x00, 0x92, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0x00, 0x00, 0x03, 0xde, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x02, 0x72,
+  0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0x00, 0x00, 0x03, 0xde, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x02, 0x72,
+  0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x03, 0x67, 0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x01, 0xfc,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x03, 0x9d, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x2e, 0x02, 0x32, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x02, 0xd2,
+  0x07, 0x6d, 0x10, 0x27, 0x03, 0x2e, 0x01, 0x67, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
+  0x00, 0x00, 0x02, 0xd9, 0x07, 0x6d, 0x10, 0x27, 0x03, 0x2e, 0x01, 0x6d,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x06, 0xfc, 0x6c, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x34, 0x63, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x5b, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x4c, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x53, 0x00, 0x00, 0x10, 0x06, 0x07, 0x0a, 0x7a, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x53, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0x00, 0x82, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0xff, 0xe3, 0x05, 0x63, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x34, 0x20, 0x00, 0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0xff, 0xe3, 0x05, 0xb4, 0x06, 0x61, 0x10, 0x26,
+  0x03, 0x34, 0x70, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0xff, 0xe3, 0x07, 0x7b, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x34, 0x02, 0x37, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00,
+  0xff, 0xff, 0x00, 0x05, 0xff, 0xe3, 0x07, 0x84, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x34, 0x02, 0x40, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0xff, 0xe3, 0x06, 0x5b, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x34, 0x01, 0x17, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0xff, 0xe3, 0x06, 0x95,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x34, 0x01, 0x52, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x61, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x06, 0xfc, 0x37, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x61, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x34, 0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x09, 0x23, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x16, 0x1e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x0a, 0x56, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x17, 0x4e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x0b, 0x32, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x18, 0x16, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x05, 0xa9, 0x06, 0x61, 0x10, 0x27, 0x03, 0x39, 0x01, 0x3f,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x07, 0x33, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x39, 0x02, 0xc9, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x07, 0x4e, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x39, 0x02, 0xe4, 0x00, 0x00, 0x10, 0x07, 0x07, 0x17, 0xff, 0x7e,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x06, 0x7b,
+  0x07, 0x6d, 0x10, 0x27, 0x03, 0x39, 0x02, 0x11, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x18, 0xff, 0x60, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfc, 0x01, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x34, 0x01, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x09, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x16, 0x01, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x0a, 0x01, 0x7a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x17, 0x01, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x0b, 0x01, 0x40, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x18, 0x01, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x05, 0x81, 0x06, 0x61, 0x10, 0x26, 0x03, 0x3d, 0x46, 0x00,
+  0x10, 0x07, 0x06, 0xfc, 0xfe, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x05, 0xcd, 0x06, 0x61, 0x10, 0x27, 0x03, 0x3d, 0x00, 0x92,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x07, 0x92, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x3d, 0x02, 0x57, 0x00, 0x00, 0x10, 0x06, 0x07, 0x09, 0x89, 0x00,
+  0xff, 0xff, 0x00, 0x05, 0x00, 0x00, 0x07, 0x9d, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x3d, 0x02, 0x62, 0x00, 0x00, 0x10, 0x06, 0x07, 0x16, 0x94, 0x00,
+  0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x06, 0x8a, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x3d, 0x01, 0x4f, 0x00, 0x00, 0x10, 0x07, 0x07, 0x0a, 0xff, 0x64,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x06, 0xba,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x3d, 0x01, 0x7f, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x17, 0xff, 0x7e, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0x00, 0x00, 0x06, 0x5d, 0x07, 0x6d, 0x10, 0x27, 0x03, 0x3d, 0x01, 0x22,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x0b, 0xff, 0x62, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x03, 0x00, 0x00, 0x06, 0x95, 0x07, 0x6d, 0x10, 0x27,
+  0x03, 0x3d, 0x01, 0x5a, 0x00, 0x00, 0x10, 0x07, 0x07, 0x18, 0xff, 0x60,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
+  0x06, 0x66, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00, 0x10, 0x06, 0x07, 0x28,
+  0x68, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
+  0x06, 0x66, 0x10, 0x06, 0x03, 0x40, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x26, 0x03, 0x49, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x28, 0x4c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x77,
+  0xff, 0xe3, 0x03, 0x68, 0x06, 0x66, 0x10, 0x06, 0x03, 0x41, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0x00, 0xb2, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x06,
+  0x03, 0x42, 0x00, 0x00, 0xff, 0xff, 0xff, 0x98, 0x00, 0x00, 0x02, 0x30,
+  0x06, 0x66, 0x10, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28,
+  0xff, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x56,
+  0x06, 0x66, 0x10, 0x06, 0x03, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x26, 0x03, 0x53, 0x00, 0x00,
+  0x10, 0x06, 0x07, 0x28, 0x6f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x06, 0x66, 0x10, 0x06, 0x03, 0x60, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x26,
+  0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x07, 0x28, 0x2b, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0, 0x06, 0x66, 0x10, 0x06,
+  0x03, 0x61, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
+  0x06, 0x66, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28,
+  0x01, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
+  0x06, 0x66, 0x10, 0x06, 0x03, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26, 0x06, 0x4c, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x61, 0x10, 0x26, 0x06, 0x4d, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x4e, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x4f, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x50, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0x51, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x52, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x53, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0xfe, 0x56, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26, 0x06, 0x54, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0xfe, 0x56, 0x04, 0xde, 0x06, 0x61, 0x10, 0x26, 0x06, 0x55, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0xfe, 0x56, 0x06, 0x42, 0x06, 0x66, 0x10, 0x26, 0x06, 0x56, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x0c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0xfe, 0x56, 0x06, 0x42, 0x06, 0x66, 0x10, 0x26, 0x06, 0x57, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x0c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x05, 0x7b, 0x06, 0x66, 0x10, 0x26, 0x06, 0x58, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x01, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0xfe, 0x56, 0x05, 0xb6, 0x06, 0x66, 0x10, 0x26, 0x06, 0x59, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x01, 0x7f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x05, 0x0a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x5a, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x00, 0xd4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
+  0xfe, 0x56, 0x05, 0x4a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x5b, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x01, 0x13, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26, 0x06, 0x68, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x61, 0x10, 0x26, 0x06, 0x69, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6a, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6b, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6c, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x66, 0x10, 0x26, 0x06, 0x6d, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x6e, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x6f, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x05, 0x52, 0x06, 0x61, 0x10, 0x26, 0x06, 0x70, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x01, 0x75, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x05, 0x4f, 0x06, 0x61, 0x10, 0x26, 0x06, 0x71, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x01, 0x72, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0xfe, 0x56, 0x07, 0x1d, 0x06, 0x66, 0x10, 0x26, 0x06, 0x72, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x03, 0x40, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0xfe, 0x56, 0x07, 0x23, 0x06, 0x66, 0x10, 0x26, 0x06, 0x73, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x03, 0x45, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x06, 0xb0, 0x06, 0x66, 0x10, 0x26, 0x06, 0x74, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0xd3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0xfe, 0x56, 0x06, 0xdc, 0x06, 0x66, 0x10, 0x26, 0x06, 0x75, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x06, 0x04, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x76, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x27, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
+  0xfe, 0x56, 0x06, 0x1d, 0x07, 0x6d, 0x10, 0x26, 0x06, 0x77, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x3f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa0, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa1, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa2, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa3, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa4, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xa5, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xa6, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xfe, 0x56, 0x05, 0x8a, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xa7, 0x00, 0x00,
+  0x10, 0x07, 0x03, 0x16, 0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x05, 0x81, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa8, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x01, 0x39, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x05, 0xcd, 0x06, 0x61, 0x10, 0x26, 0x06, 0xa9, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x01, 0x85, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0xfe, 0x56, 0x07, 0x92, 0x06, 0x66, 0x10, 0x26, 0x06, 0xaa, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x03, 0x4a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x05,
+  0xfe, 0x56, 0x07, 0x9d, 0x06, 0x66, 0x10, 0x26, 0x06, 0xab, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x03, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x06, 0x8a, 0x06, 0x66, 0x10, 0x26, 0x06, 0xac, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x42, 0x00, 0x00, 0xff, 0xff, 0x00, 0x04,
+  0xfe, 0x56, 0x06, 0xba, 0x06, 0x66, 0x10, 0x26, 0x06, 0xad, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x72, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06,
+  0xfe, 0x56, 0x06, 0x5d, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xae, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x15, 0x00, 0x00, 0xff, 0xff, 0x00, 0x03,
+  0xfe, 0x56, 0x06, 0x95, 0x07, 0x6d, 0x10, 0x26, 0x06, 0xaf, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x02, 0x4e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe7, 0x04, 0x67, 0x06, 0x48, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
+  0x10, 0x06, 0x02, 0x9a, 0x6e, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe7, 0x04, 0x67, 0x05, 0xf6, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
+  0x10, 0x06, 0x00, 0x71, 0x6d, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x06, 0xb0, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x04, 0x79, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x66, 0x10, 0x26, 0x03, 0x40, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe7, 0x04, 0x67, 0x06, 0x37, 0x10, 0x26, 0x03, 0x45, 0x00, 0x00,
+  0x10, 0x06, 0x06, 0xfd, 0x63, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x67, 0x06, 0x37, 0x10, 0x26, 0x06, 0xf3, 0x00, 0x00,
+  0x10, 0x06, 0x03, 0x16, 0x41, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x26, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf2, 0x04, 0x41, 0x01, 0x75, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x07, 0x31, 0x10, 0x26, 0x03, 0x26, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x71, 0x00, 0xaa, 0x01, 0x3b, 0xff, 0xff, 0xff, 0xfc,
+  0x00, 0x00, 0x05, 0x19, 0x06, 0x66, 0x10, 0x26, 0x03, 0x26, 0x3b, 0x00,
+  0x10, 0x07, 0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x06, 0x66, 0x10, 0x06, 0x03, 0x1d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0xfe, 0x56, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x26,
+  0x03, 0x26, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfb, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x5f, 0x04, 0xc2, 0x02, 0x39, 0x06, 0x61, 0x10, 0x06,
+  0x06, 0xfc, 0x00, 0x00, 0xff, 0xff, 0x01, 0x8a, 0xfe, 0x56, 0x02, 0x51,
+  0xff, 0xa4, 0x10, 0x06, 0x03, 0x16, 0x00, 0x00, 0x00, 0x01, 0x01, 0x5f,
+  0x04, 0xc2, 0x02, 0x39, 0x06, 0x61, 0x00, 0x08, 0x00, 0x00, 0x01, 0x10,
+  0x23, 0x35, 0x16, 0x35, 0x23, 0x35, 0x33, 0x02, 0x39, 0xda, 0x79, 0x78,
+  0xd9, 0x05, 0xcd, 0xfe, 0xf5, 0x67, 0x03, 0x9d, 0x9e, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa3, 0x05, 0x1d, 0x02, 0xf6, 0x06, 0x37, 0x10, 0x06,
+  0x02, 0x9e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa3, 0x05, 0x46, 0x02, 0xf6,
+  0x07, 0x6d, 0x10, 0x27, 0x10, 0xed, 0x03, 0x9a, 0x01, 0x84, 0x12, 0x06,
+  0x00, 0x6a, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x06, 0x66, 0x10, 0x26, 0x06, 0xb4, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x04, 0x7b, 0x10, 0x26, 0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x06, 0x66, 0x10, 0x26, 0x03, 0x42, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x06, 0x37, 0x10, 0x26, 0x03, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfd,
+  0x00, 0x82, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x06, 0x37, 0x10, 0x26, 0x07, 0x02, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0xff, 0x4c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x05, 0x56,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x2a, 0x01, 0x3f, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe9,
+  0x00, 0x00, 0x04, 0xea, 0x06, 0x66, 0x10, 0x06, 0x03, 0x1f, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x05, 0xff, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x2c, 0x01, 0x49, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0xff, 0x63,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf4, 0x00, 0x00, 0x05, 0x83,
+  0x06, 0x66, 0x10, 0x06, 0x03, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0xfe, 0x56, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x26, 0x03, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x00, 0xe6, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b,
+  0x04, 0xc2, 0x03, 0x37, 0x06, 0x66, 0x10, 0x27, 0x06, 0xfc, 0xff, 0x1c,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0x00, 0xee, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa2, 0x04, 0xc2, 0x03, 0x39, 0x06, 0x66, 0x10, 0x27,
+  0x06, 0xfc, 0xff, 0x43, 0x00, 0x00, 0x10, 0x06, 0x07, 0x33, 0x3b, 0x00,
+  0xff, 0xff, 0x00, 0xa3, 0x04, 0xc2, 0x02, 0xf6, 0x07, 0x6d, 0x10, 0x27,
+  0x10, 0xed, 0x03, 0x9a, 0x01, 0x84, 0x10, 0x06, 0x06, 0xfc, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xed, 0x00, 0x00, 0x02, 0x30, 0x06, 0x48, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x02, 0x9a, 0xff, 0x3a, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xe5, 0x00, 0x00, 0x02, 0x30, 0x05, 0xf6, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71, 0xff, 0x26, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xdc, 0x00, 0x00, 0x02, 0x30, 0x07, 0xd2, 0x10, 0x26,
+  0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x07, 0x26, 0xff, 0x43, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x04, 0x00, 0x00, 0x02, 0x40, 0x07, 0xd2, 0x10, 0x06,
+  0x03, 0x25, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe6, 0x00, 0x00, 0x02, 0x39,
+  0x06, 0x37, 0x10, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfd,
+  0xff, 0x43, 0x00, 0x00, 0xff, 0xff, 0xff, 0xe8, 0x00, 0x00, 0x02, 0x3b,
+  0x07, 0x6d, 0x10, 0x26, 0x03, 0x4d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfe,
+  0xff, 0x45, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf6, 0x00, 0x00, 0x02, 0x2a,
+  0x07, 0x6d, 0x10, 0x26, 0x03, 0x2e, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf2,
+  0x02, 0xdd, 0x01, 0x75, 0xff, 0xff, 0x00, 0x02, 0x00, 0x00, 0x02, 0x1d,
+  0x07, 0x31, 0x10, 0x26, 0x03, 0x2e, 0x00, 0x00, 0x10, 0x07, 0x00, 0x71,
+  0xff, 0x43, 0x01, 0x3b, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x02, 0xb7,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x2e, 0x01, 0x4c, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0x3e, 0x06, 0x66, 0x10, 0x06, 0x03, 0x21, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x71, 0x04, 0xc2, 0x03, 0x31, 0x06, 0x66, 0x10, 0x27,
+  0x07, 0x34, 0xff, 0x12, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0x00, 0xe8,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0x04, 0xc2, 0x03, 0x53,
+  0x06, 0x66, 0x10, 0x27, 0x07, 0x34, 0xff, 0x27, 0x00, 0x00, 0x10, 0x06,
+  0x07, 0x33, 0x56, 0x00, 0xff, 0xff, 0x00, 0xa3, 0x04, 0xc2, 0x02, 0xf6,
+  0x07, 0x6d, 0x10, 0x27, 0x10, 0xed, 0x03, 0x9a, 0x01, 0x84, 0x10, 0x06,
+  0x07, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
+  0x06, 0x48, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x02, 0x9a,
+  0x23, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
+  0x05, 0xf6, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x00, 0x71,
+  0x20, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
+  0x07, 0xd2, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00, 0x10, 0x06, 0x07, 0x26,
+  0x18, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86, 0xff, 0xe3, 0x03, 0xc0,
+  0x07, 0xd2, 0x10, 0x06, 0x03, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x61, 0x10, 0x26, 0x03, 0x55, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfc, 0x00, 0xa8, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x04, 0x2e, 0x06, 0x61, 0x10, 0x26, 0x03, 0x55, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x34, 0x00, 0x9f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x06, 0x37, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x06, 0xfd, 0x23, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x86,
+  0xff, 0xe3, 0x03, 0xc0, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x59, 0x00, 0x00,
+  0x10, 0x06, 0x06, 0xfe, 0x17, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc,
+  0x00, 0x00, 0x04, 0x6a, 0x07, 0x6d, 0x10, 0x26, 0x03, 0x39, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf2, 0x04, 0x04, 0x01, 0x75, 0xff, 0xff, 0xff, 0xfc,
+  0x00, 0x00, 0x04, 0x6a, 0x07, 0x31, 0x10, 0x26, 0x03, 0x39, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x71, 0x00, 0x74, 0x01, 0x3b, 0xff, 0xff, 0xff, 0xfc,
+  0x00, 0x00, 0x06, 0x1a, 0x06, 0x66, 0x10, 0x27, 0x03, 0x39, 0x01, 0xb0,
+  0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xe4, 0x00, 0x00, 0x05, 0xe9, 0x06, 0x66, 0x10, 0x06,
+  0x03, 0x23, 0x00, 0x00, 0xff, 0xff, 0x00, 0x06, 0x00, 0x00, 0x04, 0xb0,
+  0x06, 0x61, 0x10, 0x27, 0x03, 0x36, 0x00, 0x97, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x34, 0xfe, 0xa7, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x05, 0x46, 0x02, 0xd9, 0x07, 0xd2, 0x12, 0x26, 0x00, 0x6a, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x28, 0x00, 0x00, 0x01, 0x6c, 0xff, 0xff, 0x00, 0xc1,
+  0x05, 0x46, 0x02, 0xfd, 0x07, 0xd2, 0x10, 0x06, 0x03, 0x1c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x04, 0xf0, 0x02, 0x49, 0x06, 0x66, 0x10, 0x06,
+  0x00, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
+  0x06, 0x66, 0x10, 0x26, 0x06, 0xbc, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
+  0x04, 0x60, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
+  0x06, 0x66, 0x10, 0x26, 0x03, 0x62, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a,
+  0x06, 0x37, 0x10, 0x26, 0x03, 0x5d, 0x00, 0x00, 0x10, 0x07, 0x06, 0xfd,
+  0x01, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79, 0xfe, 0x56, 0x05, 0x8a,
+  0x06, 0x37, 0x10, 0x26, 0x07, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x03, 0x16,
+  0x01, 0x36, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xe3, 0x06, 0x5f,
+  0x06, 0x66, 0x10, 0x27, 0x03, 0x34, 0x01, 0x1c, 0x00, 0x00, 0x10, 0x07,
+  0x07, 0x28, 0xff, 0x63, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf3,
+  0xff, 0xe3, 0x05, 0x68, 0x06, 0x66, 0x10, 0x06, 0x03, 0x22, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x06, 0x5e, 0x06, 0x66, 0x10, 0x27,
+  0x03, 0x3d, 0x01, 0x24, 0x00, 0x00, 0x10, 0x07, 0x07, 0x28, 0xff, 0x63,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde, 0x00, 0x00, 0x05, 0x6b,
+  0x06, 0x66, 0x10, 0x06, 0x03, 0x24, 0x00, 0x00, 0xff, 0xff, 0x00, 0x46,
+  0xfe, 0x56, 0x05, 0x3b, 0x05, 0xe7, 0x10, 0x26, 0x03, 0x3d, 0x00, 0x00,
+  0x10, 0x07, 0x06, 0xfb, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x01, 0x4d,
+  0x04, 0xee, 0x02, 0xfd, 0x06, 0x66, 0x10, 0x06, 0x00, 0x76, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x5f, 0x04, 0xc2, 0x02, 0x39, 0x06, 0x61, 0x00, 0x08,
+  0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x23, 0x14, 0x37, 0x15, 0x22, 0x01,
+  0x5f, 0xd9, 0x78, 0x79, 0xda, 0x05, 0xcd, 0x94, 0x9e, 0x9d, 0x03, 0x67,
+  0x00, 0x01, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40, 0x02, 0x83, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x01, 0xe5, 0xfe, 0x1b, 0x02,
+  0x83, 0xa4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5a, 0x01, 0xdf, 0x02, 0x40,
+  0x02, 0x83, 0x12, 0x06, 0x07, 0x45, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0x01, 0xe9, 0x04, 0x3b, 0x02, 0x79, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x5a, 0x03, 0xe1, 0xfc, 0x1f, 0x02, 0x79, 0x90, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x01, 0xe9, 0x03, 0x40, 0x02, 0x79, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x02, 0xe6, 0xfd, 0x1a, 0x02,
+  0x79, 0x90, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x01, 0xe9, 0x06, 0xda,
+  0x02, 0x79, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x5a, 0x06,
+  0x7f, 0xf9, 0x81, 0x02, 0x79, 0x90, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0x01, 0xe9, 0x07, 0x34, 0x02, 0x79, 0x00, 0x03, 0x00, 0x00, 0x11, 0x21,
+  0x15, 0x21, 0x07, 0x33, 0xf8, 0xcd, 0x02, 0x79, 0x90, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xea, 0xfe, 0x1d, 0x02, 0xac, 0x06, 0x1d, 0x10, 0x26,
+  0x00, 0x5f, 0x00, 0x00, 0x10, 0x07, 0x00, 0x5f, 0x01, 0x29, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xee, 0xfe, 0x1d, 0x03, 0xac, 0xff, 0xee, 0x10, 0x26,
+  0x00, 0x42, 0x00, 0x00, 0x10, 0x07, 0x00, 0x42, 0x00, 0x00, 0x01, 0x42,
+  0x00, 0x01, 0x00, 0x9c, 0x03, 0xe9, 0x01, 0xa5, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x23, 0x35, 0x13, 0x33, 0x03, 0x01, 0x5a, 0xbd, 0x93,
+  0x74, 0x4a, 0x03, 0xe9, 0xad, 0x01, 0x3f, 0xfe, 0xc1, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa0, 0x03, 0xfe, 0x01, 0xa8, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x00, 0x13, 0x33, 0x15, 0x03, 0x23, 0x13, 0xea, 0xbe, 0x94, 0x74,
+  0x4a, 0x05, 0xd5, 0x98, 0xfe, 0xc1, 0x01, 0x3f, 0x00, 0x01, 0x00, 0x9c,
+  0xff, 0x12, 0x01, 0xa5, 0x00, 0xfe, 0x00, 0x05, 0x00, 0x00, 0x37, 0x33,
+  0x15, 0x03, 0x23, 0x13, 0xe6, 0xbe, 0x93, 0x74, 0x49, 0xfe, 0xac, 0xfe,
+  0xc0, 0x01, 0x40, 0x00, 0x00, 0x01, 0x00, 0xa0, 0x03, 0xfe, 0x01, 0xa8,
+  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15, 0x13, 0x23, 0x03, 0x35,
+  0x01, 0x5e, 0x4a, 0x74, 0x94, 0x05, 0xd5, 0x98, 0xfe, 0xc1, 0x01, 0x3f,
+  0x98, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9c, 0x03, 0xe9, 0x03, 0x16,
+  0x05, 0xd5, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23, 0x35, 0x13,
+  0x33, 0x03, 0x05, 0x23, 0x35, 0x13, 0x33, 0x03, 0x01, 0x5a, 0xbd, 0x93,
+  0x74, 0x4a, 0x01, 0x72, 0xbe, 0x93, 0x74, 0x49, 0x03, 0xe9, 0xad, 0x01,
+  0x3f, 0xfe, 0xc1, 0xad, 0xad, 0x01, 0x3f, 0xfe, 0xc1, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x9c, 0x03, 0xe9, 0x03, 0x16, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x15, 0x03, 0x23, 0x13, 0x25, 0x33,
+  0x15, 0x03, 0x23, 0x13, 0xe6, 0xbe, 0x93, 0x74, 0x49, 0x01, 0x71, 0xbe,
+  0x93, 0x74, 0x49, 0x05, 0xd5, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0xac, 0xac,
+  0xfe, 0xc0, 0x01, 0x40, 0x00, 0x02, 0x00, 0x9c, 0xff, 0x12, 0x03, 0x16,
+  0x00, 0xfe, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33, 0x15, 0x03,
+  0x23, 0x13, 0x25, 0x33, 0x15, 0x03, 0x23, 0x13, 0x02, 0x57, 0xbe, 0x93,
+  0x74, 0x49, 0xfe, 0x8f, 0xbe, 0x93, 0x74, 0x49, 0xfe, 0xac, 0xfe, 0xc0,
+  0x01, 0x40, 0xac, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0x00, 0x02, 0x00, 0x9c,
+  0x03, 0xe9, 0x03, 0x16, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00,
+  0x01, 0x15, 0x13, 0x23, 0x03, 0x35, 0x21, 0x15, 0x13, 0x23, 0x03, 0x35,
+  0x01, 0x5a, 0x4a, 0x74, 0x93, 0x02, 0x2f, 0x49, 0x74, 0x93, 0x05, 0xd5,
+  0xad, 0xfe, 0xc1, 0x01, 0x3f, 0xad, 0xad, 0xfe, 0xc1, 0x01, 0x3f, 0xad,
+  0x00, 0x01, 0x00, 0x33, 0xff, 0x3b, 0x03, 0x67, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x35, 0x21, 0x01, 0x7e, 0x9e, 0x01, 0x4a, 0xfe, 0xb6, 0x9e, 0xfe, 0xb5,
+  0x01, 0x4b, 0x05, 0xd5, 0xfe, 0x5c, 0x99, 0xfb, 0xa3, 0x04, 0x5d, 0x99,
+  0x00, 0x01, 0x00, 0x33, 0xff, 0x3b, 0x03, 0x67, 0x05, 0xd5, 0x00, 0x13,
+  0x00, 0x00, 0x25, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21,
+  0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x03, 0x66,
+  0xfe, 0xb6, 0x9e, 0xfe, 0xb5, 0x01, 0x4b, 0xfe, 0xb5, 0x01, 0x4b, 0x9e,
+  0x01, 0x4a, 0xfe, 0xb6, 0x01, 0x4a, 0xdf, 0xfe, 0x5c, 0x01, 0xa4, 0x9a,
+  0x02, 0x1f, 0x99, 0x01, 0xa4, 0xfe, 0x5c, 0x99, 0xfd, 0xe1, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x14, 0x01, 0xd1, 0x03, 0x2b, 0x04, 0x21, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x01, 0x14, 0x9c, 0x71, 0x70, 0x9a, 0x9b, 0x70, 0x71, 0x9b,
+  0x02, 0xfa, 0x7c, 0xab, 0xab, 0x7c, 0x7d, 0xac, 0xac, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x14, 0x01, 0x81, 0x03, 0x73, 0x04, 0x71, 0x00, 0x02,
+  0x00, 0x00, 0x01, 0x11, 0x01, 0x01, 0x14, 0x02, 0x5f, 0x01, 0x81, 0x02,
+  0xf0, 0xfe, 0x88, 0x00, 0x00, 0x01, 0x00, 0xd4, 0x00, 0x00, 0x01, 0x95,
+  0x00, 0xfe, 0x00, 0x03, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23, 0xd4, 0xc0,
+  0xc0, 0xfe, 0xfe, 0x00, 0x00, 0x02, 0x00, 0xd4, 0x00, 0x00, 0x03, 0xfa,
+  0x00, 0xfe, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23,
+  0x25, 0x33, 0x15, 0x23, 0x03, 0x3a, 0xc0, 0xc0, 0xfd, 0x9a, 0xc0, 0xc0,
+  0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x03, 0x00, 0xd4, 0x00, 0x00, 0x06, 0x5f,
+  0x00, 0xfe, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x33,
+  0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x03, 0x3a,
+  0xbf, 0xbf, 0x02, 0x65, 0xc0, 0xc0, 0xfb, 0x35, 0xc0, 0xc0, 0xfe, 0xfe,
+  0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x01, 0x00, 0xc6, 0x02, 0x6b, 0x01, 0x84,
+  0x03, 0x69, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0xc6, 0xbe,
+  0xbe, 0x03, 0x69, 0xfe, 0x00, 0x07, 0x00, 0x65, 0xff, 0xe3, 0x09, 0x45,
+  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x27, 0x00, 0x33,
+  0x00, 0x3f, 0x00, 0x4b, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x21, 0x33, 0x01, 0x23, 0x13, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x01, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x17, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x08, 0x0f,
+  0x4f, 0x5a, 0x5a, 0x4f, 0x4c, 0x59, 0x59, 0x4c, 0x8e, 0xa7, 0xa8, 0x8d,
+  0x90, 0xa8, 0xa9, 0xfa, 0x1b, 0x8f, 0xa9, 0xa9, 0x8f, 0x8f, 0xa6, 0xa7,
+  0x03, 0xbb, 0x90, 0xfc, 0xb7, 0x90, 0x1c, 0x4d, 0x59, 0x58, 0x4e, 0x4f,
+  0x59, 0x5a, 0x03, 0x53, 0x8e, 0xa8, 0xa9, 0x8d, 0x90, 0xa7, 0xa8, 0x8f,
+  0x4e, 0x59, 0x59, 0x4e, 0x4d, 0x59, 0x59, 0x02, 0x91, 0x94, 0x84, 0x82,
+  0x95, 0x95, 0x82, 0x83, 0x95, 0x7f, 0xdc, 0xbb, 0xbb, 0xdb, 0xdb, 0xbb,
+  0xbc, 0xdb, 0x02, 0xe0, 0xdb, 0xbb, 0xbd, 0xda, 0xdb, 0xbc, 0xba, 0xdc,
+  0xf9, 0xf3, 0x05, 0x8e, 0x95, 0x82, 0x84, 0x94, 0x94, 0x84, 0x81, 0x96,
+  0xfd, 0x9f, 0xdc, 0xbb, 0xbb, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x7f, 0x94,
+  0x84, 0x82, 0x95, 0x95, 0x82, 0x83, 0x95, 0x00, 0x00, 0x09, 0x00, 0x65,
+  0xff, 0xe3, 0x0c, 0x1a, 0x05, 0xf0, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22,
+  0x00, 0x2d, 0x00, 0x37, 0x00, 0x3b, 0x00, 0x45, 0x00, 0x50, 0x00, 0x5c,
+  0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x27, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x05, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x27, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
+  0x00, 0x20, 0x16, 0x15, 0x14, 0x06, 0x20, 0x26, 0x35, 0x34, 0x25, 0x33,
+  0x01, 0x23, 0x12, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34,
+  0x01, 0x32, 0x16, 0x10, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x17,
+  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x0a,
+  0xe4, 0x4e, 0x5a, 0x5a, 0x4e, 0x4d, 0x59, 0x59, 0x4d, 0x8e, 0xa8, 0xa8,
+  0x8e, 0x90, 0xa7, 0xa8, 0xfd, 0xba, 0x4f, 0x5a, 0x5a, 0x4f, 0x4c, 0x59,
+  0x59, 0x4c, 0x8e, 0xa7, 0xa8, 0x8d, 0x90, 0xa8, 0xa9, 0xf9, 0x8d, 0x01,
+  0x1d, 0xa9, 0xa9, 0xfe, 0xe2, 0xa6, 0x04, 0x62, 0x90, 0xfc, 0xb7, 0x90,
+  0x6a, 0x9b, 0x59, 0x58, 0x9d, 0x59, 0x02, 0xf9, 0x8e, 0xa8, 0xa9, 0x8d,
+  0x90, 0xa7, 0xa8, 0x8f, 0x4e, 0x59, 0x59, 0x4e, 0x4d, 0x59, 0x59, 0x02,
+  0x91, 0x94, 0x84, 0x82, 0x95, 0x95, 0x82, 0x83, 0x95, 0x7f, 0xdc, 0xfe,
+  0x8a, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x7f, 0x94, 0x84, 0x82, 0x95, 0x95,
+  0x82, 0x83, 0x95, 0x7f, 0xdc, 0xfe, 0x8a, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb,
+  0x02, 0xe0, 0xdb, 0xbb, 0xbd, 0xda, 0xdb, 0xbc, 0xba, 0xdc, 0xf9, 0xf3,
+  0x05, 0x8e, 0x95, 0x82, 0x84, 0x94, 0x94, 0x84, 0x81, 0xfe, 0x35, 0xdc,
+  0xfe, 0x8a, 0xdb, 0xdb, 0xbb, 0xbc, 0xdb, 0x7f, 0x94, 0x84, 0x82, 0x95,
+  0x95, 0x82, 0x83, 0x95, 0x00, 0x01, 0x00, 0x24, 0x04, 0x60, 0x01, 0x77,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x1b, 0x01, 0x33, 0x01, 0x24, 0x9c,
+  0xb6, 0xfe, 0xfc, 0x04, 0x60, 0x01, 0x75, 0xfe, 0x8b, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x02, 0x85, 0x05, 0xd5, 0x10, 0x26,
+  0x07, 0x67, 0x00, 0x00, 0x10, 0x07, 0x07, 0x67, 0x01, 0x0e, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x03, 0x93, 0x05, 0xd5, 0x10, 0x27,
+  0x07, 0x67, 0x01, 0x0e, 0x00, 0x00, 0x10, 0x26, 0x07, 0x67, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x67, 0x02, 0x1c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x24,
+  0x04, 0x60, 0x01, 0x77, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x23,
+  0x01, 0x33, 0x01, 0x76, 0x4e, 0xfe, 0xfc, 0xb7, 0x04, 0x60, 0x01, 0x75,
+  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x02, 0x85, 0x05, 0xd5, 0x10, 0x26,
+  0x07, 0x6a, 0x00, 0x00, 0x10, 0x07, 0x07, 0x6a, 0x01, 0x0e, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x03, 0x93, 0x05, 0xd5, 0x10, 0x26,
+  0x07, 0x6a, 0x00, 0x00, 0x10, 0x27, 0x07, 0x6a, 0x02, 0x1c, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x6a, 0x01, 0x0e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
+  0xfe, 0x1d, 0x02, 0x67, 0xff, 0xc3, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
+  0x27, 0x07, 0x23, 0x01, 0x02, 0x67, 0x85, 0xa9, 0xa9, 0x86, 0x01, 0x30,
+  0xfe, 0x1d, 0xf9, 0xf9, 0x01, 0xa6, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8e,
+  0x00, 0x8d, 0x02, 0x35, 0x04, 0x23, 0x00, 0x06, 0x00, 0x00, 0x01, 0x15,
+  0x09, 0x01, 0x15, 0x01, 0x35, 0x02, 0x34, 0xfe, 0xf1, 0x01, 0x0f, 0xfe,
+  0x5a, 0x04, 0x23, 0xbf, 0xfe, 0xf4, 0xfe, 0xf4, 0xbf, 0x01, 0xa2, 0x52,
+  0x00, 0x01, 0x00, 0xad, 0x00, 0x8d, 0x02, 0x54, 0x04, 0x23, 0x00, 0x06,
+  0x00, 0x00, 0x13, 0x01, 0x15, 0x01, 0x35, 0x09, 0x01, 0xae, 0x01, 0xa6,
+  0xfe, 0x5a, 0x01, 0x0f, 0xfe, 0xf1, 0x04, 0x23, 0xfe, 0x5e, 0x52, 0xfe,
+  0x5e, 0xbf, 0x01, 0x0c, 0x01, 0x0c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xaf,
+  0x00, 0x04, 0x05, 0x54, 0x05, 0xcc, 0x12, 0x26, 0x00, 0x99, 0x00, 0x4b,
+  0x10, 0x27, 0x00, 0x11, 0xff, 0xea, 0x02, 0x4e, 0x10, 0x27, 0x00, 0x11,
+  0x01, 0xe1, 0x00, 0x04, 0x10, 0x27, 0x00, 0x11, 0x03, 0xd0, 0x02, 0x4e,
+  0x10, 0x07, 0x00, 0x11, 0x01, 0xe1, 0x04, 0xce, 0xff, 0xff, 0x00, 0x84,
+  0x00, 0x00, 0x02, 0xfb, 0x05, 0xd5, 0x10, 0x27, 0x00, 0x04, 0xff, 0x6e,
+  0x00, 0x00, 0x10, 0x07, 0x00, 0x04, 0x01, 0x2e, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x84, 0x00, 0x00, 0x03, 0x52, 0x05, 0xf0, 0x00, 0x17,
+  0x00, 0x1b, 0x00, 0x24, 0x00, 0x00, 0x01, 0x23, 0x11, 0x06, 0x07, 0x06,
+  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x0f, 0x01,
+  0x0e, 0x01, 0x07, 0x0e, 0x01, 0x15, 0x03, 0x33, 0x15, 0x23, 0x13, 0x11,
+  0x37, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x02, 0x11, 0xac, 0x1c, 0x1d,
+  0x50, 0x58, 0x55, 0xae, 0x5c, 0xa6, 0xc9, 0x41, 0x51, 0x4f, 0x2b, 0x23,
+  0x07, 0x05, 0x06, 0xb1, 0xb7, 0xb7, 0xb1, 0x29, 0x33, 0x2e, 0x3b, 0x21,
+  0x01, 0x91, 0x03, 0xad, 0x08, 0x0d, 0x23, 0x43, 0xbc, 0x39, 0x38, 0xc2,
+  0x9f, 0x4c, 0x89, 0x56, 0x56, 0x2f, 0x35, 0x19, 0x15, 0x3c, 0x34, 0xfe,
+  0xf2, 0xfe, 0x05, 0x42, 0xfe, 0x52, 0x2d, 0x35, 0x5e, 0x31, 0x59, 0x37,
+  0x1f, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x05, 0x7c, 0x03, 0xac,
+  0x06, 0x0b, 0x10, 0x07, 0x00, 0x42, 0x00, 0x00, 0x07, 0x5f, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xaf, 0xfe, 0x1b, 0x06, 0x1a, 0xff, 0x85, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x32, 0x24, 0x37, 0x15, 0x06, 0x04, 0x23, 0x22, 0x24,
+  0x27, 0x35, 0x16, 0x04, 0x02, 0xe4, 0xd0, 0x01, 0x97, 0xcf, 0xd4, 0xfe,
+  0x67, 0xc9, 0xc9, 0xfe, 0x69, 0xd4, 0xcf, 0x01, 0x95, 0xfe, 0xb5, 0x68,
+  0x68, 0x7e, 0x76, 0x76, 0x75, 0x77, 0x7e, 0x69, 0x67, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xaf, 0x06, 0x04, 0x06, 0x1a, 0x07, 0x6e, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x32, 0x04, 0x17, 0x15, 0x26, 0x24, 0x23, 0x22, 0x04,
+  0x07, 0x35, 0x36, 0x24, 0x02, 0xe4, 0xc9, 0x01, 0x99, 0xd4, 0xcf, 0xfe,
+  0x69, 0xd0, 0xd0, 0xfe, 0x6b, 0xcf, 0xd4, 0x01, 0x97, 0x07, 0x6e, 0x76,
+  0x76, 0x7e, 0x68, 0x68, 0x67, 0x69, 0x7e, 0x77, 0x75, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xb2, 0xfe, 0x1d, 0x02, 0x0f, 0x01, 0xd5, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x33, 0x09, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x01, 0xb6,
+  0x58, 0xfe, 0xff, 0x01, 0x01, 0x58, 0xd5, 0xd5, 0x59, 0x01, 0xd5, 0xfe,
+  0x24, 0xfe, 0x24, 0x01, 0x8a, 0xfe, 0x76, 0x00, 0xff, 0xff, 0x00, 0x36,
+  0xff, 0xc5, 0x06, 0xfd, 0x06, 0x83, 0x10, 0x27, 0x00, 0x0d, 0x00, 0x00,
+  0xfd, 0x7b, 0x10, 0x27, 0x00, 0x0d, 0x03, 0x9a, 0xfd, 0x7b, 0x10, 0x07,
+  0x00, 0x0d, 0x01, 0xcd, 0x00, 0x93, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc6,
+  0x02, 0x81, 0x02, 0xe2, 0x03, 0x5f, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0xc7, 0x02, 0x1a, 0xfd, 0xe6, 0x03, 0x5f, 0xde, 0x00, 0x00,
+  0x00, 0x01, 0xfe, 0xae, 0xff, 0xe3, 0x02, 0x86, 0x05, 0xf0, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x33, 0x01, 0x23, 0x01, 0xf5, 0x90, 0xfc, 0xb9, 0x90,
+  0x05, 0xf0, 0xf9, 0xf3, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c,
+  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x15, 0x21, 0x11,
+  0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x01, 0x44, 0xd8, 0xfe, 0x82, 0x01,
+  0x7e, 0xd8, 0xd8, 0x02, 0x5e, 0xfd, 0x23, 0x8f, 0x07, 0x22, 0x8f, 0xfd,
+  0x23, 0x4a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c,
+  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35, 0x33, 0x11, 0x23, 0x35,
+  0x21, 0x11, 0x21, 0x35, 0x33, 0x11, 0x9e, 0xd8, 0xd8, 0x01, 0x7e, 0xfe,
+  0x82, 0xd8, 0x02, 0x5e, 0x4a, 0x02, 0xdd, 0x8f, 0xf8, 0xde, 0x8f, 0x02,
+  0xdd, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x42, 0x00, 0x00, 0x06, 0x62,
+  0x05, 0xf0, 0x10, 0x26, 0x00, 0x22, 0xbe, 0x00, 0x10, 0x07, 0x00, 0x22,
+  0x03, 0x10, 0x00, 0x00, 0xff, 0xff, 0x00, 0x84, 0x00, 0x00, 0x04, 0xc3,
+  0x05, 0xf0, 0x10, 0x26, 0x00, 0x22, 0x00, 0x00, 0x10, 0x07, 0x00, 0x04,
+  0x02, 0xf6, 0x00, 0x00, 0xff, 0xff, 0x00, 0x84, 0x00, 0x00, 0x04, 0xc3,
+  0x05, 0xf0, 0x10, 0x27, 0x00, 0x04, 0xff, 0x6e, 0x00, 0x00, 0x10, 0x07,
+  0x00, 0x22, 0x01, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0xff, 0x05, 0x03, 0x3b, 0x04, 0x5d, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x16,
+  0x33, 0x32, 0x37, 0x07, 0x01, 0x23, 0x13, 0x06, 0x20, 0x27, 0x5a, 0x8b,
+  0xd2, 0xe2, 0xa1, 0x07, 0xfe, 0xfd, 0x89, 0xee, 0x6a, 0xfe, 0xe3, 0xb4,
+  0x04, 0x5d, 0x10, 0x10, 0x80, 0xfb, 0x28, 0x04, 0xae, 0x0f, 0x0f, 0x00,
+  0x00, 0x01, 0x00, 0xd4, 0xff, 0x3b, 0x04, 0x14, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x11, 0x23, 0x11,
+  0x23, 0x11, 0x23, 0x11, 0x02, 0x68, 0xc1, 0xea, 0xd3, 0xc2, 0x80, 0xab,
+  0x7f, 0x05, 0xd5, 0xe8, 0xbe, 0xb8, 0xdd, 0x11, 0xfc, 0xb2, 0x06, 0x1f,
+  0xf9, 0xe1, 0x06, 0x9a, 0x00, 0x02, 0x00, 0xc2, 0x01, 0xc2, 0x02, 0xd8,
+  0x04, 0x12, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33, 0x11, 0x07,
+  0x2b, 0x01, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x02, 0x3a, 0x9d, 0x9d,
+  0x6a, 0x02, 0x71, 0x9b, 0x9c, 0x72, 0x04, 0x12, 0xfd, 0xb1, 0x01, 0xac,
+  0x7d, 0x7c, 0xab, 0x00, 0x00, 0x02, 0x00, 0xc2, 0x01, 0xc2, 0x02, 0xd8,
+  0x04, 0x12, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x27, 0x11, 0x3b,
+  0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x01, 0x60, 0x9e, 0x9e,
+  0x6a, 0x72, 0x9b, 0x9b, 0x70, 0x02, 0x01, 0xc2, 0x01, 0x02, 0x4f, 0xab,
+  0x7c, 0x7d, 0xac, 0x00, 0xff, 0xff, 0x00, 0x36, 0xff, 0xc5, 0x03, 0x63,
+  0x03, 0x6b, 0x12, 0x07, 0x00, 0x0d, 0x00, 0x00, 0xfd, 0x7b, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x00, 0xff, 0x12, 0x02, 0x09, 0x04, 0x23, 0x00, 0x03,
+  0x00, 0x09, 0x00, 0x00, 0x01, 0x15, 0x23, 0x35, 0x13, 0x15, 0x13, 0x23,
+  0x03, 0x35, 0x01, 0xbe, 0xbe, 0xbe, 0x4a, 0x74, 0x94, 0x04, 0x23, 0xfe,
+  0xfe, 0xfc, 0xdb, 0xac, 0xfe, 0xc0, 0x01, 0x40, 0xac, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xaf, 0xfe, 0x1b, 0x06, 0x1a, 0x07, 0x6e, 0x10, 0x26,
+  0x07, 0x74, 0x00, 0x00, 0x10, 0x06, 0x07, 0x75, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0xff, 0xf2, 0x03, 0x63, 0x07, 0x6f, 0x12, 0x27,
+  0x00, 0x0d, 0x00, 0x00, 0xfd, 0xa8, 0x10, 0x07, 0x00, 0x0d, 0x00, 0x00,
+  0x01, 0x7f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x82, 0xff, 0x42, 0x02, 0xf0,
+  0x05, 0xd5, 0x10, 0x27, 0x00, 0x12, 0x00, 0x82, 0x00, 0x00, 0x10, 0x27,
+  0x00, 0x11, 0x01, 0x66, 0x00, 0x00, 0x10, 0x07, 0x00, 0x11, 0xff, 0xdd,
+  0x04, 0x48, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x01, 0xd3, 0x06, 0xda,
+  0x03, 0x31, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
+  0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
+  0x06, 0xd9, 0x8e, 0xcf, 0x83, 0x86, 0xd4, 0x0e, 0x08, 0x09, 0x14, 0xd2,
+  0x7e, 0x77, 0xc6, 0x85, 0x8e, 0xcf, 0x84, 0x9e, 0xbd, 0x0d, 0x07, 0x0b,
+  0x13, 0xd1, 0x7e, 0x75, 0xc2, 0x03, 0x31, 0xb2, 0x4f, 0x44, 0x3b, 0x04,
+  0x02, 0x02, 0x06, 0x3e, 0x4d, 0x53, 0xb2, 0x4f, 0x45, 0x3c, 0x04, 0x02,
+  0x03, 0x05, 0x3e, 0x4c, 0xff, 0xff, 0xff, 0xaf, 0xfe, 0x14, 0x06, 0x1a,
+  0xff, 0x7e, 0x10, 0x07, 0x07, 0x75, 0x00, 0x00, 0xf8, 0x10, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x18, 0x00, 0xc8, 0x04, 0xf0, 0x05, 0x0d, 0x00, 0x17,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21,
+  0x27, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x07, 0x21, 0x15, 0x21,
+  0x17, 0x07, 0x03, 0x4c, 0x90, 0xe0, 0x66, 0xe0, 0xfe, 0xc3, 0x01, 0x3d,
+  0xe0, 0x65, 0xe1, 0x90, 0xe1, 0x66, 0xe1, 0x01, 0x3e, 0xfe, 0xc2, 0xe1,
+  0x66, 0x02, 0x29, 0xfe, 0x9f, 0x01, 0x60, 0xf9, 0x72, 0xf9, 0xa0, 0xfa,
+  0x72, 0xfb, 0x01, 0x62, 0xfe, 0x9e, 0xfa, 0x71, 0xfa, 0xa0, 0xf9, 0x72,
+  0x00, 0x03, 0x00, 0xe1, 0x01, 0x32, 0x03, 0x57, 0x04, 0xb6, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x35, 0x33, 0x15, 0x01, 0x35,
+  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0xe1, 0xb4, 0x01, 0x0e, 0xb4, 0xb4,
+  0xb4, 0x02, 0x90, 0xc8, 0xc8, 0xfe, 0xa2, 0xc8, 0xc8, 0x02, 0xbc, 0xc8,
+  0xc8, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x24, 0x04, 0x60, 0x04, 0xa1,
+  0x05, 0xd5, 0x10, 0x27, 0x07, 0x67, 0x01, 0x0e, 0x00, 0x00, 0x10, 0x26,
+  0x07, 0x67, 0x00, 0x00, 0x10, 0x27, 0x07, 0x67, 0x03, 0x2a, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x67, 0x02, 0x1c, 0x00, 0x00, 0x00, 0x04, 0x01, 0x42,
+  0x01, 0x00, 0x04, 0xc7, 0x04, 0xe8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x00, 0x01, 0x35, 0x33, 0x15, 0x21, 0x35, 0x33, 0x15,
+  0x01, 0x35, 0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x42, 0xb4, 0x02,
+  0x1c, 0xb4, 0xfd, 0xe4, 0xb4, 0xb4, 0xb4, 0x02, 0x90, 0xc8, 0xc8, 0xc8,
+  0xc8, 0xfe, 0x70, 0xc8, 0xc8, 0x03, 0x20, 0xc8, 0xc8, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x01, 0x42, 0x00, 0xf6, 0x04, 0xc7, 0x04, 0xde, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x01, 0x35,
+  0x33, 0x15, 0x13, 0x35, 0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x35,
+  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x02, 0xaa, 0xb4, 0xb4, 0xb4, 0xb4,
+  0xb4, 0xfc, 0x8e, 0xb4, 0xc6, 0xb4, 0x02, 0x86, 0xc8, 0xc8, 0xfe, 0x70,
+  0xc8, 0xc8, 0x03, 0x20, 0xc8, 0xc8, 0xfc, 0xf4, 0xc8, 0xc8, 0x03, 0x0c,
+  0xc8, 0xc8, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc5, 0x00, 0x00, 0x01, 0x83,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23,
+  0x11, 0x33, 0x15, 0x23, 0xc5, 0xbe, 0xbe, 0xbe, 0xbe, 0x05, 0xd5, 0xfe,
+  0xfc, 0x27, 0xfe, 0x00, 0x00, 0x04, 0x00, 0x5a, 0xfe, 0xe5, 0x05, 0x64,
+  0x06, 0xef, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
+  0x13, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x01, 0x33, 0x15, 0x23,
+  0x11, 0x33, 0x15, 0x23, 0x5a, 0xbe, 0xbe, 0x04, 0x4c, 0xbe, 0xbe, 0xfd,
+  0xda, 0xbe, 0xbe, 0xbe, 0xbe, 0x03, 0x69, 0xfe, 0xfe, 0xfe, 0x04, 0x84,
+  0xfe, 0xf9, 0xf2, 0xfe, 0x00, 0x05, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x1b,
+  0x00, 0x00, 0x25, 0x35, 0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x35,
+  0x33, 0x15, 0x03, 0x35, 0x33, 0x15, 0x01, 0x11, 0x23, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x04, 0x12, 0xb4, 0xb4, 0xb4, 0xfc,
+  0x8e, 0xb4, 0xc6, 0xb4, 0x01, 0x56, 0x90, 0xfd, 0xa9, 0x02, 0x57, 0x90,
+  0x02, 0x58, 0xf6, 0xc8, 0xc8, 0x03, 0x20, 0xc8, 0xc8, 0xfc, 0xf4, 0xc8,
+  0xc8, 0x03, 0x0c, 0xc8, 0xc8, 0xfe, 0x84, 0xfd, 0x66, 0x02, 0x9a, 0xa0,
+  0x02, 0x9b, 0xfd, 0x65, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc5,
+  0x00, 0x50, 0x01, 0x83, 0x05, 0x3e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x11, 0x33,
+  0x15, 0x23, 0xc5, 0xbe, 0xbe, 0xbe, 0xbe, 0xbe, 0xbe, 0x05, 0x3e, 0xfe,
+  0xfd, 0x0e, 0xfe, 0x02, 0xf6, 0xfe, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc5,
+  0x00, 0x11, 0x01, 0x83, 0x05, 0x77, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23,
+  0x11, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0xc5, 0xbe, 0xbe, 0xbe,
+  0xbe, 0xbe, 0xbe, 0xbe, 0xbe, 0x02, 0x89, 0xfe, 0x03, 0xec, 0xfe, 0xfc,
+  0x96, 0xfe, 0x03, 0xf0, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4e,
+  0x02, 0x8d, 0x02, 0xa3, 0x05, 0xf0, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x00,
+  0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x01, 0xd4, 0xb6, 0x2d, 0x2e, 0x2e, 0x2d, 0xb6, 0x2d, 0x2e,
+  0x2e, 0x88, 0x91, 0x99, 0x99, 0x91, 0x92, 0x99, 0x99, 0x05, 0x97, 0x56,
+  0x56, 0xac, 0xad, 0x56, 0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde,
+  0xd3, 0xd4, 0xde, 0xde, 0xd4, 0xd3, 0xde, 0x00, 0x00, 0x02, 0x00, 0x6d,
+  0x02, 0x9c, 0x00, 0xd7, 0x06, 0x03, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x23, 0x11, 0x33, 0x15, 0x23, 0x6e, 0x68, 0x68, 0x68,
+  0x68, 0x05, 0x0f, 0xfd, 0x8d, 0x03, 0x67, 0x82, 0x00, 0x02, 0x00, 0x38,
+  0x02, 0x9c, 0x02, 0xa9, 0x05, 0xdf, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x00,
+  0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35,
+  0x21, 0x35, 0x01, 0xad, 0xfe, 0xea, 0x01, 0x16, 0x13, 0x95, 0x79, 0x79,
+  0x82, 0xfe, 0x8c, 0x05, 0x66, 0xfe, 0x5d, 0x02, 0x1c, 0xfd, 0xe4, 0x6d,
+  0xba, 0xba, 0x79, 0x00, 0x00, 0x01, 0x00, 0x5b, 0x02, 0x8d, 0x02, 0x8b,
+  0x05, 0xdf, 0x00, 0x20, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x80, 0x01, 0xcb, 0xfe, 0xa0, 0x19, 0x1a, 0x19, 0x1a,
+  0x90, 0x55, 0x55, 0x58, 0x56, 0x9e, 0x36, 0x72, 0x3b, 0x33, 0x38, 0x38,
+  0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f, 0x5e, 0x30, 0x05, 0xdf, 0x5f, 0xcc,
+  0x09, 0x04, 0x04, 0x4d, 0x4c, 0x83, 0x87, 0x4b, 0x4a, 0x12, 0x12, 0x71,
+  0x1b, 0x0e, 0x0d, 0x66, 0xae, 0x66, 0x14, 0x15, 0x00, 0x02, 0x00, 0x52,
+  0x02, 0x8d, 0x02, 0xa8, 0x05, 0xf0, 0x00, 0x0f, 0x00, 0x2f, 0x00, 0x00,
+  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x01, 0x88, 0x50, 0x2e, 0x2e, 0x2e, 0x2e, 0x50, 0x4e, 0x2e, 0x2e, 0x2e,
+  0x2e, 0x9a, 0x2c, 0x2d, 0x2d, 0x2c, 0x74, 0x3d, 0x3d, 0x09, 0x22, 0x33,
+  0x35, 0x3d, 0x82, 0x4c, 0x4c, 0x50, 0x4e, 0x82, 0x97, 0x9e, 0x61, 0x61,
+  0xa4, 0x2c, 0x2d, 0x2d, 0x04, 0x6d, 0x34, 0x35, 0x5b, 0x5a, 0x34, 0x35,
+  0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14, 0x0a, 0x0b,
+  0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f, 0x4f, 0x4e,
+  0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x00, 0x00, 0x01, 0x00, 0x61,
+  0x02, 0x9c, 0x02, 0x8d, 0x05, 0xdf, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x01, 0x23, 0x01, 0x21, 0x61, 0x02, 0x2b, 0xfe, 0xc7, 0x7a, 0x01,
+  0x27, 0xfe, 0x61, 0x05, 0xdf, 0x30, 0xfc, 0xed, 0x02, 0xe4, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x50, 0x02, 0x8d, 0x02, 0xa2, 0x05, 0xf0, 0x00, 0x0c,
+  0x00, 0x2a, 0x00, 0x3a, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x36, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x01, 0xcd, 0xa8, 0x2f, 0x30, 0x5f, 0x54,
+  0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01, 0x02, 0x4a,
+  0x48, 0x29, 0x2a, 0x4b, 0x51, 0x33, 0x2f, 0x4c, 0x4e, 0x8e, 0x8f, 0x4c,
+  0x4e, 0x30, 0x31, 0x28, 0x2a, 0x2a, 0x4c, 0x49, 0x2c, 0x2b, 0x2b, 0x2a,
+  0x4b, 0x4a, 0x2c, 0x2a, 0x04, 0x2a, 0x2c, 0x2b, 0x4b, 0x4c, 0x56, 0x2c,
+  0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48, 0x64, 0x74, 0x3a, 0x3a,
+  0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37, 0x50, 0x79, 0x41, 0x41,
+  0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f, 0x26, 0x25, 0x25, 0x24,
+  0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4a,
+  0x02, 0x8d, 0x02, 0x9f, 0x05, 0xf0, 0x00, 0x1f, 0x00, 0x2e, 0x00, 0x00,
+  0x13, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x82,
+  0x2d, 0x2d, 0x2d, 0x2b, 0x74, 0x3d, 0x3c, 0x09, 0x1f, 0x36, 0x33, 0x3e,
+  0x82, 0x97, 0x4e, 0x4f, 0x83, 0x96, 0x4e, 0x4f, 0x60, 0x61, 0xa4, 0x2c,
+  0x2d, 0x2d, 0xb8, 0x4f, 0x5c, 0x2e, 0x2e, 0x4f, 0x4d, 0x30, 0x2e, 0x2e,
+  0x2e, 0x02, 0xae, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b,
+  0x1a, 0x98, 0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76,
+  0x08, 0x09, 0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a,
+  0x5c, 0x34, 0x34, 0x00, 0x00, 0x01, 0x00, 0x7b, 0x02, 0x9c, 0x03, 0x52,
+  0x05, 0x6b, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x02, 0x16, 0x01, 0x3c, 0xfe, 0xc4,
+  0x5f, 0xfe, 0xc4, 0x01, 0x3c, 0x05, 0x6b, 0xfe, 0xc8, 0x5f, 0xfe, 0xc8,
+  0x01, 0x38, 0x5f, 0x01, 0x38, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b,
+  0x03, 0xd4, 0x03, 0x52, 0x04, 0x33, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x7b, 0x02, 0xd7, 0xfd, 0x29, 0x04, 0x33, 0x5f, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x7b, 0x03, 0x61, 0x03, 0x52, 0x04, 0xa5, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x7b, 0x02, 0xd7, 0xfd, 0x29, 0x02, 0xd7, 0xfd, 0x29, 0x04, 0xa5, 0x5e,
+  0x87, 0x5f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0x02, 0x05, 0x01, 0x68,
+  0x06, 0x02, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x10, 0x16, 0x17,
+  0x23, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x68, 0x4c, 0x49,
+  0x49, 0x4c, 0x5b, 0x55, 0x2a, 0x2a, 0x2a, 0x2a, 0x55, 0x06, 0x02, 0x81,
+  0xfc, 0xfe, 0xfe, 0xfe, 0x80, 0x83, 0x80, 0x7f, 0xfa, 0x7f, 0x7e, 0x84,
+  0x00, 0x01, 0x00, 0x5c, 0x02, 0x05, 0x01, 0x61, 0x06, 0x02, 0x00, 0x0f,
+  0x00, 0x00, 0x13, 0x33, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x23,
+  0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x5d, 0x5b, 0x55, 0x2a, 0x2a, 0x2a,
+  0x2a, 0x55, 0x5b, 0x4b, 0x25, 0x26, 0x26, 0x25, 0x06, 0x02, 0x84, 0x7e,
+  0x7f, 0xfa, 0x7f, 0x80, 0x83, 0x80, 0x7f, 0x7f, 0x01, 0x02, 0x7e, 0x7e,
+  0x00, 0x01, 0x00, 0x69, 0x02, 0x9c, 0x02, 0x7e, 0x05, 0x1e, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x02, 0x7d,
+  0x68, 0x46, 0x47, 0x54, 0x61, 0x6a, 0x6a, 0x25, 0x65, 0x43, 0x6d, 0x70,
+  0x04, 0x17, 0xfe, 0x85, 0x01, 0x77, 0x59, 0x59, 0x6b, 0x5c, 0xfe, 0x9e,
+  0x02, 0x73, 0x61, 0x38, 0x38, 0x86, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4e,
+  0xff, 0xf1, 0x02, 0xa3, 0x03, 0x54, 0x12, 0x07, 0x07, 0xa0, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b, 0x00, 0x00, 0x02, 0x7f,
+  0x03, 0x43, 0x12, 0x07, 0x00, 0x7b, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x54, 0x00, 0x00, 0x02, 0x6f, 0x03, 0x54, 0x12, 0x07,
+  0x00, 0x74, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x58,
+  0xff, 0xf1, 0x02, 0x86, 0x03, 0x54, 0x12, 0x07, 0x00, 0x75, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x38, 0x00, 0x00, 0x02, 0xa9,
+  0x03, 0x43, 0x12, 0x07, 0x07, 0xa2, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x5b, 0xff, 0xf1, 0x02, 0x8b, 0x03, 0x43, 0x12, 0x07,
+  0x07, 0xa3, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x52,
+  0xff, 0xf1, 0x02, 0xa8, 0x03, 0x54, 0x12, 0x07, 0x07, 0xa4, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x61, 0x00, 0x00, 0x02, 0x8d,
+  0x03, 0x43, 0x12, 0x07, 0x07, 0xa5, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x50, 0xff, 0xf1, 0x02, 0xa2, 0x03, 0x54, 0x12, 0x07,
+  0x07, 0xa6, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4a,
+  0xff, 0xf1, 0x02, 0x9f, 0x03, 0x54, 0x12, 0x07, 0x07, 0xa7, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b, 0x00, 0x00, 0x03, 0x52,
+  0x02, 0xcf, 0x12, 0x07, 0x07, 0xa8, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x7b, 0x01, 0x38, 0x03, 0x52, 0x01, 0x97, 0x12, 0x07,
+  0x07, 0xa9, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7b,
+  0x00, 0xc5, 0x03, 0x52, 0x02, 0x09, 0x12, 0x07, 0x07, 0xaa, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0x69, 0x01, 0x68,
+  0x03, 0x66, 0x12, 0x07, 0x07, 0xab, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x5c, 0xff, 0x69, 0x01, 0x61, 0x03, 0x66, 0x12, 0x07,
+  0x07, 0xac, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x45,
+  0xff, 0xf0, 0x02, 0x5e, 0x02, 0x82, 0x12, 0x07, 0x04, 0xf9, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f, 0xff, 0xf0, 0x02, 0x8d,
+  0x02, 0x82, 0x12, 0x07, 0x04, 0xff, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x3f, 0xff, 0xf0, 0x02, 0x88, 0x02, 0x82, 0x12, 0x07,
+  0x05, 0x08, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
+  0x00, 0x00, 0x02, 0xd1, 0x02, 0x73, 0x12, 0x07, 0x02, 0xa5, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x3f, 0xff, 0xf0, 0x02, 0x8d,
+  0x02, 0x82, 0x12, 0x07, 0x05, 0x00, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x02, 0x7e, 0x03, 0x67, 0x12, 0x07,
+  0x02, 0x72, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
+  0x00, 0x00, 0x02, 0x9d, 0x03, 0x67, 0x12, 0x07, 0x05, 0x05, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6d, 0x00, 0x00, 0x00, 0xd7,
+  0x03, 0x67, 0x12, 0x07, 0x02, 0xa3, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x04, 0x09, 0x02, 0x82, 0x12, 0x07,
+  0x05, 0x06, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69,
+  0x00, 0x00, 0x02, 0x7e, 0x02, 0x82, 0x12, 0x07, 0x07, 0xad, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x69, 0xff, 0x11, 0x02, 0xa2,
+  0x02, 0x82, 0x12, 0x07, 0x05, 0x0c, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x69, 0x00, 0x00, 0x02, 0x4f, 0x02, 0x93, 0x12, 0x07,
+  0x02, 0xa4, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x1f,
+  0x00, 0x00, 0x01, 0xac, 0x03, 0x25, 0x12, 0x07, 0x05, 0x0d, 0x00, 0x00,
+  0xfd, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4d, 0x00, 0x00, 0x06, 0x03,
+  0x05, 0xd6, 0x00, 0x23, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x00,
+  0x10, 0x00, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x10, 0x16, 0x33, 0x32, 0x36, 0x37, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x03, 0x7a, 0x47, 0xa0, 0x59, 0xe5,
+  0xfe, 0xf8, 0x01, 0x08, 0xe5, 0x5b, 0x9f, 0x46, 0x44, 0x9c, 0x58, 0xad,
+  0xb8, 0xb8, 0xad, 0x58, 0x9c, 0x44, 0x02, 0x7d, 0xfe, 0x0b, 0x01, 0xe1,
+  0xfe, 0x1f, 0x02, 0x01, 0xfd, 0x77, 0x01, 0xb8, 0x36, 0x36, 0x01, 0x37,
+  0x02, 0x1c, 0x01, 0x37, 0x35, 0x36, 0x9f, 0x47, 0x46, 0xea, 0xfe, 0x44,
+  0xea, 0x46, 0x47, 0x02, 0x0a, 0x80, 0xfe, 0xb5, 0x80, 0xfe, 0x6b, 0x80,
+  0x00, 0x03, 0x00, 0x67, 0xff, 0xa6, 0x04, 0x45, 0x06, 0x39, 0x00, 0x27,
+  0x00, 0x2e, 0x00, 0x34, 0x00, 0x00, 0x01, 0x16, 0x17, 0x37, 0x33, 0x07,
+  0x16, 0x17, 0x15, 0x26, 0x27, 0x01, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
+  0x01, 0x23, 0x22, 0x27, 0x07, 0x23, 0x37, 0x26, 0x27, 0x07, 0x23, 0x37,
+  0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x3f, 0x01, 0x33, 0x07, 0x06,
+  0x07, 0x06, 0x11, 0x14, 0x17, 0x01, 0x26, 0x27, 0x01, 0x16, 0x17, 0x03,
+  0x11, 0x3a, 0x38, 0x1b, 0x8c, 0x2b, 0x24, 0x22, 0x35, 0x39, 0xfe, 0xe1,
+  0x10, 0x6b, 0xbe, 0x54, 0x58, 0xc2, 0x6d, 0x18, 0x18, 0x10, 0x8b, 0x16,
+  0x3a, 0x34, 0x22, 0x8b, 0x3a, 0x11, 0x0f, 0xa0, 0xa0, 0x90, 0xed, 0x13,
+  0x8d, 0xcd, 0x82, 0x4f, 0x71, 0x4a, 0x01, 0xfc, 0x38, 0x3d, 0xfe, 0xe1,
+  0x30, 0x3a, 0x05, 0xeb, 0x08, 0x13, 0x69, 0xa5, 0x16, 0x1c, 0xd5, 0x3c,
+  0x29, 0xfb, 0x97, 0x5e, 0x5f, 0xd3, 0x48, 0x48, 0x02, 0x3f, 0x57, 0x12,
+  0x1e, 0x87, 0xe6, 0x12, 0x15, 0xcf, 0x01, 0x67, 0x01, 0x68, 0xd0, 0xb9,
+  0x14, 0x4b, 0xfc, 0x1f, 0x70, 0x9d, 0xfe, 0xd8, 0xee, 0x94, 0x03, 0xcb,
+  0x13, 0x04, 0xfb, 0x95, 0x28, 0x15, 0x00, 0x00, 0x00, 0x01, 0x00, 0x56,
+  0xff, 0xe4, 0x04, 0x3b, 0x05, 0xf0, 0x00, 0x2c, 0x00, 0x00, 0x25, 0x36,
+  0x37, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10,
+  0x17, 0x16, 0x17, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x1f,
+  0x01, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x02, 0xdd, 0x57, 0x4f, 0x5f,
+  0x54, 0x57, 0xc3, 0x6d, 0xfe, 0xe9, 0xfe, 0xbe, 0x01, 0x42, 0x01, 0x17,
+  0x6e, 0xc4, 0x55, 0x54, 0xbe, 0x6b, 0xd3, 0xe0, 0x70, 0x54, 0x8a, 0x89,
+  0x2b, 0x8a, 0x63, 0x0e, 0x22, 0x15, 0x01, 0x18, 0x36, 0x20, 0x73, 0x7d,
+  0x8a, 0x07, 0x27, 0x2f, 0x5f, 0xd3, 0x48, 0x47, 0x01, 0x9e, 0x01, 0x67,
+  0x01, 0x68, 0x01, 0x9f, 0x47, 0x47, 0xd5, 0x5f, 0x5e, 0xfe, 0xc7, 0xfe,
+  0xd8, 0xfe, 0xd9, 0x9c, 0x75, 0x1e, 0x03, 0x5d, 0x9d, 0x5c, 0x59, 0x04,
+  0x05, 0xaa, 0x10, 0x0f, 0xb6, 0xab, 0x00, 0x00, 0x00, 0x01, 0x00, 0x77,
+  0x00, 0x00, 0x04, 0x51, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x15, 0x23, 0x11,
+  0x23, 0x11, 0x23, 0x35, 0x01, 0x4c, 0x03, 0x04, 0xfd, 0xb2, 0x02, 0x15,
+  0xfd, 0xeb, 0xe1, 0xe1, 0xb6, 0xd4, 0x01, 0x7e, 0x04, 0x57, 0xaa, 0xfe,
+  0x48, 0xaa, 0xfe, 0xb5, 0x45, 0xfe, 0xc7, 0x01, 0x39, 0x45, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x74, 0x00, 0x00, 0x03, 0xf2, 0x05, 0xf0, 0x00, 0x23,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35,
+  0x33, 0x35, 0x23, 0x35, 0x33, 0x35, 0x10, 0x36, 0x33, 0x32, 0x16, 0x17,
+  0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x15,
+  0x21, 0x15, 0x01, 0xfc, 0x01, 0xf6, 0xfc, 0x82, 0xd4, 0xab, 0xab, 0xb3,
+  0xb3, 0xc1, 0xd1, 0x37, 0x88, 0x47, 0x45, 0x7a, 0x37, 0x85, 0x69, 0x01,
+  0x60, 0xfe, 0xa0, 0x01, 0x68, 0x01, 0xec, 0xfe, 0xbe, 0xaa, 0xaa, 0x01,
+  0x42, 0x8f, 0x8f, 0x8f, 0x5f, 0x01, 0x05, 0xf3, 0x1f, 0x1d, 0xb6, 0x29,
+  0x29, 0x9b, 0xd4, 0x48, 0x8f, 0x8f, 0x8f, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xff, 0x42, 0x06, 0x67, 0x05, 0x1e, 0x00, 0x2b, 0x00, 0x00, 0x05, 0x23,
+  0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11,
+  0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x13, 0x33,
+  0x07, 0x36, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x02, 0x84, 0x99, 0x01, 0x49, 0x05,
+  0x2e, 0x34, 0x6b, 0x7f, 0x4a, 0x4b, 0xa7, 0xa7, 0x38, 0x50, 0x4f, 0x6d,
+  0x6e, 0x4c, 0x31, 0x21, 0x78, 0x99, 0x4f, 0x52, 0x6c, 0x9e, 0xab, 0xa7,
+  0x66, 0x6a, 0x80, 0x96, 0xa6, 0xbe, 0x03, 0x78, 0x8d, 0x47, 0x4d, 0x5f,
+  0x61, 0xa2, 0xfd, 0x87, 0x04, 0x60, 0xae, 0x66, 0x32, 0x31, 0x3e, 0x26,
+  0x3e, 0x01, 0x45, 0xd6, 0x33, 0xf6, 0xe1, 0xfd, 0x5c, 0x02, 0x9e, 0xa1,
+  0x9c, 0xbe, 0xa4, 0xfd, 0x87, 0x01, 0x1d, 0x00, 0x00, 0x05, 0x00, 0x69,
+  0x00, 0x00, 0x04, 0xfa, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x06, 0x00, 0x22,
+  0x00, 0x26, 0x00, 0x29, 0x00, 0x00, 0x01, 0x27, 0x15, 0x13, 0x27, 0x23,
+  0x15, 0x03, 0x33, 0x13, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15,
+  0x33, 0x15, 0x23, 0x11, 0x23, 0x03, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35,
+  0x33, 0x35, 0x23, 0x35, 0x33, 0x05, 0x17, 0x33, 0x35, 0x03, 0x17, 0x35,
+  0x02, 0x10, 0x47, 0xa4, 0x33, 0x71, 0xb1, 0xf5, 0xbe, 0xcf, 0xb0, 0xb0,
+  0xb0, 0xb0, 0xb0, 0xf4, 0xbe, 0xcf, 0xb1, 0xaf, 0xaf, 0xaf, 0xaf, 0x01,
+  0xde, 0x32, 0x72, 0x47, 0x47, 0x03, 0xaf, 0xce, 0xce, 0xfe, 0xf2, 0x93,
+  0x93, 0x03, 0x34, 0xfd, 0xda, 0x02, 0x26, 0xfd, 0xda, 0x7b, 0x93, 0x7b,
+  0xfd, 0xda, 0x02, 0x26, 0xfd, 0xda, 0x02, 0x26, 0x7b, 0x93, 0x7b, 0x7b,
+  0x93, 0x93, 0xfe, 0xf2, 0xce, 0xce, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0xff, 0xe3, 0x08, 0xd3, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x50, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x06, 0x07,
+  0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32, 0x17, 0x16, 0x17, 0x33,
+  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x35,
+  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01,
+  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x27, 0x35, 0x23, 0x22, 0x26, 0x35, 0x11, 0x01, 0x60, 0xd7,
+  0x78, 0x82, 0x82, 0x78, 0x01, 0xad, 0x05, 0x66, 0x6e, 0xd4, 0xd7, 0xab,
+  0x01, 0x82, 0xd4, 0x6e, 0x4f, 0x15, 0x49, 0x9d, 0x01, 0x41, 0xfe, 0xbf,
+  0x3f, 0x62, 0x9a, 0x56, 0xa8, 0x52, 0x6e, 0x77, 0x56, 0x91, 0x36, 0x90,
+  0x81, 0xbe, 0xae, 0x57, 0x98, 0x41, 0x43, 0x8e, 0x4d, 0x74, 0x74, 0x54,
+  0x7d, 0x35, 0xa7, 0x8b, 0xd2, 0xb6, 0x4d, 0xa5, 0x5b, 0x9a, 0xb5, 0x89,
+  0x05, 0x2f, 0xfd, 0xcf, 0x92, 0x87, 0x86, 0x92, 0xfe, 0xcc, 0xc8, 0x6a,
+  0x71, 0xfd, 0xa8, 0x05, 0xd5, 0x71, 0x52, 0x88, 0x01, 0x3e, 0xfe, 0xc2,
+  0x8f, 0xfd, 0xa0, 0x89, 0x4e, 0x23, 0x35, 0x35, 0x59, 0x51, 0x4b, 0x50,
+  0x25, 0x0f, 0x24, 0x95, 0x82, 0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28,
+  0x54, 0x54, 0x40, 0x49, 0x21, 0x0e, 0x2a, 0x99, 0x89, 0x9c, 0xb6, 0x23,
+  0x23, 0x01, 0x9f, 0xd2, 0x02, 0x60, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0xff, 0xe3, 0x07, 0x62, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x45, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x01, 0x17, 0x23, 0x03,
+  0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x07, 0x1e, 0x01, 0x1f, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32,
+  0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f,
+  0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x6b,
+  0xe4, 0x84, 0x86, 0x86, 0x84, 0x02, 0x79, 0x04, 0xc4, 0xac, 0x42, 0x7d,
+  0x6c, 0xc6, 0xb6, 0x01, 0x9a, 0xe7, 0xe2, 0x75, 0x71, 0x3b, 0x6e, 0x38,
+  0x52, 0x58, 0x57, 0x59, 0x57, 0x75, 0x7e, 0x5b, 0x9a, 0x39, 0x9a, 0x89,
+  0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x46, 0x97, 0x51, 0x7c, 0x7b, 0x58, 0x86,
+  0x38, 0xb1, 0x94, 0xde, 0xc3, 0x51, 0x57, 0x28, 0x05, 0x2f, 0xfd, 0xee,
+  0x87, 0x01, 0x06, 0x85, 0xfa, 0xd8, 0x07, 0x01, 0x7f, 0x96, 0x62, 0xfd,
+  0x89, 0x05, 0xd5, 0xd6, 0xd8, 0x8d, 0xba, 0x24, 0x16, 0x90, 0x7e, 0xb4,
+  0x33, 0x19, 0x1b, 0x59, 0x51, 0x4b, 0x50, 0x25, 0x0f, 0x24, 0x95, 0x82,
+  0x9e, 0xac, 0x1e, 0x1e, 0xae, 0x28, 0x28, 0x54, 0x54, 0x40, 0x49, 0x21,
+  0x0e, 0x2a, 0x99, 0x89, 0x9c, 0xb6, 0x12, 0x08, 0x00, 0x06, 0x00, 0x35,
+  0x00, 0x00, 0x06, 0xea, 0x05, 0xd5, 0x00, 0x1f, 0x00, 0x22, 0x00, 0x26,
+  0x00, 0x29, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x13, 0x27, 0x23, 0x35,
+  0x33, 0x27, 0x33, 0x17, 0x21, 0x37, 0x33, 0x17, 0x21, 0x37, 0x33, 0x07,
+  0x33, 0x15, 0x23, 0x07, 0x33, 0x15, 0x23, 0x03, 0x23, 0x03, 0x23, 0x03,
+  0x23, 0x03, 0x23, 0x35, 0x05, 0x1b, 0x01, 0x01, 0x17, 0x21, 0x37, 0x01,
+  0x1b, 0x02, 0x07, 0x33, 0x27, 0x21, 0x17, 0x21, 0x37, 0xa4, 0x1b, 0x54,
+  0x34, 0x2c, 0xb8, 0x2b, 0x01, 0xde, 0x2b, 0xcc, 0x2c, 0x01, 0xdd, 0x2c,
+  0xb8, 0x2c, 0x33, 0x53, 0x1a, 0x6d, 0x8e, 0xca, 0xe5, 0xc4, 0xb0, 0xc6,
+  0xe4, 0xca, 0x8f, 0x04, 0x47, 0x94, 0x94, 0xfe, 0x9d, 0x1a, 0x01, 0x69,
+  0x1a, 0xfb, 0x9d, 0x94, 0x95, 0xce, 0x1a, 0x70, 0x19, 0xfd, 0x91, 0x1a,
+  0x01, 0x69, 0x1b, 0x04, 0x0f, 0x75, 0x8f, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2,
+  0xc2, 0x8f, 0x75, 0x8f, 0xfc, 0x80, 0x03, 0x80, 0xfc, 0x80, 0x03, 0x80,
+  0x8f, 0x8f, 0xfd, 0x67, 0x02, 0x99, 0x01, 0x04, 0x75, 0x75, 0xfe, 0xfc,
+  0xfd, 0x67, 0x02, 0x99, 0x01, 0x04, 0x75, 0x75, 0x75, 0x75, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x55, 0xff, 0xe3, 0x05, 0x59, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x1b, 0x00, 0x00, 0x13, 0x25, 0x32, 0x12, 0x19, 0x01, 0x23, 0x11,
+  0x34, 0x26, 0x23, 0x21, 0x11, 0x23, 0x29, 0x01, 0x22, 0x02, 0x19, 0x01,
+  0x33, 0x11, 0x14, 0x16, 0x33, 0x21, 0x03, 0x33, 0x56, 0x01, 0xd3, 0xe5,
+  0xec, 0xa6, 0x8d, 0x9e, 0xfe, 0xd2, 0xa5, 0x04, 0xff, 0xfe, 0x31, 0xe6,
+  0xec, 0xa6, 0x8d, 0x9f, 0x01, 0x31, 0x04, 0xa6, 0x05, 0xd2, 0x03, 0xfe,
+  0xd6, 0xfe, 0xdc, 0xfe, 0x91, 0x01, 0x56, 0xf0, 0xd3, 0xfa, 0xb2, 0x01,
+  0x2a, 0x01, 0x24, 0x01, 0x6f, 0xfe, 0xaa, 0xf0, 0xd3, 0x05, 0x4e, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xfe, 0xc0, 0x04, 0x76, 0x06, 0x14, 0x10, 0x26,
+  0x00, 0xd3, 0x00, 0x00, 0x10, 0x06, 0x02, 0x8f, 0x7c, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0xff, 0xe3, 0x04, 0x1b, 0x05, 0xf0, 0x00, 0x31,
+  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x21, 0x07,
+  0x21, 0x06, 0x14, 0x15, 0x1c, 0x01, 0x17, 0x21, 0x07, 0x21, 0x1e, 0x01,
+  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x03, 0x23,
+  0x37, 0x33, 0x34, 0x26, 0x35, 0x34, 0x36, 0x35, 0x23, 0x37, 0x33, 0x12,
+  0x00, 0x33, 0x32, 0x16, 0x04, 0x1a, 0x52, 0x98, 0x5c, 0x8d, 0xb6, 0x1c,
+  0x02, 0x07, 0x32, 0xfe, 0x1c, 0x02, 0x02, 0x01, 0x92, 0x33, 0xfe, 0xb0,
+  0x1c, 0xb6, 0x8d, 0x5c, 0x98, 0x52, 0x50, 0xa6, 0x57, 0xd5, 0xfe, 0xea,
+  0x24, 0xbe, 0x32, 0x7d, 0x01, 0x01, 0xaf, 0x32, 0x8c, 0x24, 0x01, 0x17,
+  0xd4, 0x59, 0xa6, 0x05, 0x62, 0xd5, 0x69, 0x5a, 0xc8, 0xbb, 0x7b, 0x18,
+  0x2e, 0x23, 0x20, 0x2e, 0x18, 0x7b, 0xbb, 0xca, 0x5a, 0x69, 0xd3, 0x48,
+  0x48, 0x01, 0x22, 0x01, 0x03, 0x7b, 0x17, 0x2f, 0x20, 0x23, 0x2f, 0x17,
+  0x7b, 0x01, 0x01, 0x01, 0x22, 0x47, 0x00, 0x00, 0x00, 0x01, 0x00, 0x24,
+  0x00, 0x00, 0x04, 0x94, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x13, 0x11,
+  0x33, 0x11, 0x01, 0x33, 0x01, 0x21, 0x15, 0x21, 0x01, 0x23, 0x01, 0x11,
+  0x23, 0x11, 0x23, 0x35, 0xac, 0xaa, 0x02, 0x36, 0xdb, 0xfd, 0xc0, 0x01,
+  0x7f, 0xfe, 0x83, 0x02, 0x6b, 0xe0, 0xfd, 0xa2, 0xaa, 0x88, 0x03, 0x54,
+  0x02, 0x81, 0xfd, 0x89, 0x02, 0x77, 0xfd, 0x7f, 0x73, 0xfd, 0x1f, 0x02,
+  0xcf, 0xfd, 0x31, 0x02, 0xe1, 0x73, 0x00, 0x00, 0x00, 0x01, 0x00, 0x12,
+  0x00, 0x00, 0x04, 0x83, 0x05, 0xd5, 0x00, 0x17, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x37, 0x17, 0x05, 0x15, 0x37, 0x17,
+  0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x25, 0x35, 0x07, 0x27, 0x01, 0xef,
+  0xfe, 0x23, 0x04, 0x71, 0xfe, 0x23, 0xce, 0x48, 0xfe, 0xea, 0xcf, 0x48,
+  0xfe, 0xe9, 0xb7, 0xd0, 0x45, 0x01, 0x15, 0xd1, 0x45, 0x03, 0x8d, 0x01,
+  0x9e, 0xaa, 0xaa, 0xfe, 0xf1, 0xa1, 0x6f, 0xd8, 0x88, 0xa2, 0x6f, 0xd9,
+  0xfd, 0xb8, 0x01, 0xba, 0xa1, 0x6e, 0xd9, 0x88, 0xa2, 0x6e, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0xbb, 0xfe, 0x39, 0x08, 0xae, 0x05, 0xf0, 0x00, 0x16,
+  0x00, 0x2d, 0x00, 0x62, 0x00, 0x77, 0x00, 0x83, 0x00, 0x00, 0x01, 0x27,
+  0x13, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x22, 0x07,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x05, 0x36, 0x37, 0x13,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x3e, 0x01, 0x37, 0x36, 0x33,
+  0x32, 0x04, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x2f,
+  0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33,
+  0x32, 0x01, 0x03, 0x06, 0x07, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x01, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x06, 0x54,
+  0xa6, 0x91, 0x1f, 0x38, 0x2c, 0x87, 0x57, 0x43, 0x6e, 0x22, 0x3a, 0x2b,
+  0x2c, 0x49, 0x52, 0x4e, 0x32, 0x37, 0x2b, 0x1b, 0xde, 0x4e, 0x2c, 0x0b,
+  0x0e, 0x09, 0x15, 0x1c, 0x38, 0x21, 0x36, 0x15, 0x12, 0x11, 0x10, 0x1a,
+  0x0b, 0x16, 0x12, 0xfa, 0x5a, 0x0b, 0x0a, 0xa2, 0x2a, 0x1d, 0x1f, 0x16,
+  0x13, 0x0f, 0x9d, 0x18, 0x5a, 0x3c, 0x6b, 0x9e, 0xb6, 0x01, 0x0f, 0x55,
+  0x4c, 0x4a, 0x19, 0x17, 0x3c, 0x20, 0x57, 0x37, 0x3e, 0x44, 0x56, 0x43,
+  0x38, 0x29, 0x2e, 0x58, 0x1d, 0x3a, 0x0d, 0x0e, 0x10, 0x13, 0x46, 0x53,
+  0x69, 0x45, 0x45, 0x77, 0x5e, 0x42, 0x01, 0xb4, 0xa0, 0x16, 0x13, 0x24,
+  0x4b, 0x2e, 0x33, 0x30, 0x61, 0x8a, 0x34, 0x27, 0x1a, 0x15, 0x1b, 0x1c,
+  0x32, 0x77, 0xfd, 0x8d, 0x24, 0x2b, 0x22, 0x0c, 0x0c, 0x15, 0x14, 0x1d,
+  0x29, 0xfe, 0x39, 0x29, 0x02, 0xd0, 0x97, 0x69, 0x52, 0x6d, 0x3a, 0x33,
+  0x58, 0x92, 0x77, 0x64, 0x67, 0x37, 0x3f, 0x20, 0x17, 0x32, 0x01, 0xf8,
+  0x6a, 0x1a, 0x37, 0x23, 0x3d, 0x35, 0x28, 0x36, 0x24, 0x20, 0x1b, 0x36,
+  0x32, 0x39, 0x54, 0x2f, 0x14, 0x0c, 0x0b, 0xb7, 0x28, 0x32, 0x03, 0x4d,
+  0x0a, 0x14, 0x16, 0x21, 0x1d, 0x3a, 0x35, 0x53, 0x7d, 0x24, 0x40, 0x7b,
+  0x6d, 0x62, 0xf5, 0x81, 0x71, 0x8c, 0x82, 0x7e, 0x45, 0x73, 0x2f, 0x34,
+  0x18, 0x1d, 0x09, 0x0a, 0x2d, 0x13, 0x26, 0x0a, 0x0a, 0x22, 0x17, 0x54,
+  0x41, 0x42, 0x60, 0x5d, 0x85, 0x03, 0x92, 0xfc, 0x9b, 0x7c, 0x40, 0x1b,
+  0x38, 0x16, 0x19, 0x86, 0x6e, 0x52, 0x80, 0x6b, 0x63, 0x64, 0x5d, 0x61,
+  0x43, 0x9c, 0xfb, 0xa0, 0x22, 0x0e, 0x0e, 0x0f, 0x18, 0x0f, 0x0e, 0x00,
+  0x00, 0x02, 0x00, 0x29, 0xff, 0xe3, 0x04, 0x1a, 0x05, 0xf0, 0x00, 0x29,
+  0x00, 0x35, 0x00, 0x00, 0x13, 0x27, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x35, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x25, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0xa6, 0x7d,
+  0x85, 0x64, 0x6f, 0x3a, 0x4f, 0x1f, 0x2b, 0x31, 0xcc, 0x48, 0x50, 0x7b,
+  0x68, 0x57, 0x4c, 0x61, 0xa3, 0x71, 0x5f, 0xe3, 0x78, 0x52, 0x42, 0x6b,
+  0x7b, 0x62, 0x66, 0x43, 0x2d, 0x30, 0x2d, 0x01, 0xf8, 0x3d, 0x18, 0x20,
+  0x2d, 0x2f, 0x1e, 0x16, 0x02, 0x04, 0x60, 0xf0, 0x4e, 0x6b, 0x42, 0xb1,
+  0xfe, 0xac, 0x58, 0x60, 0x60, 0x53, 0xb1, 0xe3, 0xab, 0xa3, 0xbf, 0xc2,
+  0x86, 0x71, 0xa2, 0x4a, 0x3c, 0x93, 0x58, 0x72, 0x7e, 0x68, 0x46, 0xd9,
+  0x6c, 0xaf, 0x56, 0x31, 0x3f, 0x3f, 0x30, 0x57, 0xa6, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x3d, 0x00, 0x00, 0x04, 0x2c, 0x05, 0xd5, 0x00, 0x1d,
+  0x00, 0x24, 0x00, 0x2b, 0x00, 0x31, 0x00, 0x00, 0x13, 0x35, 0x23, 0x35,
+  0x33, 0x11, 0x21, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x23, 0x16, 0x14,
+  0x07, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11,
+  0x23, 0x35, 0x05, 0x21, 0x15, 0x33, 0x32, 0x37, 0x36, 0x01, 0x21, 0x26,
+  0x27, 0x26, 0x2b, 0x01, 0x05, 0x21, 0x15, 0x21, 0x36, 0x34, 0x88, 0x4a,
+  0x4a, 0x01, 0x9a, 0xe2, 0x74, 0x45, 0x1c, 0x52, 0x40, 0x01, 0x01, 0x3f,
+  0x50, 0x1c, 0x46, 0x74, 0xe2, 0xe4, 0xb6, 0x4b, 0x02, 0xcd, 0xfe, 0x34,
+  0xe4, 0x7f, 0x45, 0x15, 0xfe, 0x43, 0x01, 0xcc, 0x0f, 0x15, 0x45, 0x7f,
+  0xe4, 0x01, 0xec, 0xfe, 0x14, 0x01, 0xec, 0x02, 0x03, 0xec, 0x56, 0x74,
+  0x01, 0x1f, 0x71, 0x44, 0x6a, 0x74, 0x15, 0x2c, 0x15, 0x74, 0x6b, 0x44,
+  0x71, 0xfd, 0xa8, 0x03, 0x78, 0x74, 0x74, 0x7a, 0x49, 0x16, 0x01, 0x59,
+  0x1b, 0x15, 0x49, 0xed, 0x56, 0x15, 0x2c, 0x00, 0x00, 0x02, 0x00, 0x53,
+  0xff, 0x5b, 0x04, 0x39, 0x06, 0x78, 0x00, 0x24, 0x00, 0x2d, 0x00, 0x00,
+  0x05, 0x23, 0x35, 0x26, 0x27, 0x26, 0x11, 0x10, 0x37, 0x36, 0x37, 0x35,
+  0x33, 0x15, 0x16, 0x17, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x27, 0x11,
+  0x36, 0x37, 0x36, 0x37, 0x11, 0x23, 0x35, 0x21, 0x11, 0x06, 0x07, 0x06,
+  0x07, 0x27, 0x11, 0x06, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16, 0x02, 0xad,
+  0x7e, 0xc9, 0x7b, 0x97, 0x97, 0x7b, 0xc9, 0x7e, 0x5e, 0x57, 0x65, 0x54,
+  0x55, 0x61, 0x58, 0x60, 0x46, 0x39, 0x41, 0x33, 0x6c, 0x01, 0x05, 0x59,
+  0x6c, 0x5e, 0x69, 0x7e, 0x78, 0x47, 0x64, 0x64, 0x47, 0xa5, 0x8f, 0x1f,
+  0xa7, 0xcc, 0x01, 0x6d, 0x01, 0x6e, 0xcd, 0xa6, 0x1f, 0x8f, 0x89, 0x04,
+  0x1f, 0x24, 0x46, 0xd7, 0x5f, 0x30, 0x2c, 0x04, 0xfb, 0x3f, 0x02, 0x11,
+  0x12, 0x27, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53, 0x2a, 0x25, 0x05, 0xb2,
+  0x04, 0xa7, 0x20, 0x6c, 0x99, 0xfe, 0xd1, 0xfe, 0xd2, 0x99, 0x6c, 0x00,
+  0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x04, 0x85, 0x05, 0xd5, 0x00, 0x17,
+  0x00, 0x1b, 0x00, 0x1e, 0x00, 0x00, 0x13, 0x35, 0x21, 0x13, 0x33, 0x13,
+  0x21, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x13, 0x23, 0x03, 0x21, 0x03,
+  0x23, 0x13, 0x23, 0x35, 0x33, 0x37, 0x33, 0x07, 0x21, 0x2f, 0x01, 0x33,
+  0x03, 0x2e, 0x01, 0x12, 0xa3, 0xce, 0xa3, 0x01, 0x12, 0xeb, 0x40, 0xab,
+  0x84, 0xa2, 0xbc, 0x9a, 0xfe, 0x39, 0x99, 0xc0, 0xa3, 0x83, 0xaa, 0x42,
+  0xad, 0x3c, 0x01, 0x7f, 0x3e, 0xe1, 0xbd, 0x5e, 0x03, 0x52, 0x7b, 0x02,
+  0x08, 0xfd, 0xf8, 0x7b, 0xcf, 0x7b, 0xfd, 0xf8, 0x02, 0x08, 0xfd, 0xf8,
+  0x02, 0x08, 0x7b, 0xcf, 0xcf, 0xcf, 0x7b, 0x01, 0x41, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0xff, 0xe3, 0x05, 0x2a, 0x05, 0xf0, 0x00, 0x36,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x07, 0x33, 0x15, 0x23, 0x06, 0x0f, 0x01, 0x21,
+  0x15, 0x21, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
+  0x01, 0x23, 0x22, 0x24, 0x35, 0x34, 0x37, 0x23, 0x35, 0x01, 0x39, 0x04,
+  0x14, 0x42, 0x74, 0xfe, 0x62, 0x03, 0x37, 0x0b, 0x0b, 0x36, 0xa2, 0x94,
+  0x56, 0xb7, 0x68, 0x67, 0xc4, 0x5f, 0xdc, 0xfb, 0x16, 0x9d, 0xe9, 0x5c,
+  0xc3, 0x3c, 0x02, 0x44, 0xfc, 0xb2, 0x2d, 0xa9, 0x9c, 0x67, 0xd4, 0x6f,
+  0x73, 0xd8, 0x5f, 0xfd, 0xfe, 0xfa, 0x11, 0x98, 0x02, 0xa1, 0x07, 0x16,
+  0x4a, 0x2c, 0x7b, 0x08, 0x09, 0x2b, 0x6b, 0x76, 0x80, 0x36, 0x37, 0xc5,
+  0x26, 0x26, 0xe4, 0xc6, 0x55, 0x42, 0x7b, 0x5c, 0x2a, 0x0d, 0x7b, 0x3b,
+  0x5e, 0x7e, 0x88, 0x46, 0x45, 0xd0, 0x2f, 0x30, 0xe0, 0xd9, 0x4b, 0x3f,
+  0x7b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x94, 0xfe, 0xd3, 0x04, 0x01,
+  0x06, 0x14, 0x00, 0x1f, 0x00, 0x2a, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01,
+  0x23, 0x11, 0x32, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23,
+  0x11, 0x26, 0x27, 0x26, 0x11, 0x35, 0x10, 0x37, 0x36, 0x37, 0x35, 0x33,
+  0x15, 0x16, 0x17, 0x16, 0x01, 0x03, 0x06, 0x07, 0x06, 0x07, 0x06, 0x17,
+  0x16, 0x17, 0x16, 0x04, 0x00, 0x53, 0x97, 0x5b, 0x5b, 0x97, 0x53, 0x51,
+  0x53, 0x4f, 0x52, 0x5a, 0xa6, 0x69, 0xbe, 0xbf, 0x6d, 0xa0, 0x5b, 0x54,
+  0x4f, 0x53, 0xfe, 0xb0, 0x01, 0x52, 0x3c, 0x6a, 0x0e, 0x0c, 0x0c, 0x17,
+  0x61, 0x3c, 0x04, 0xa4, 0xd5, 0x69, 0x5a, 0xfb, 0xf1, 0x5a, 0x69, 0xd3,
+  0x48, 0x24, 0x22, 0x02, 0xfe, 0xf0, 0x01, 0x15, 0x16, 0x76, 0xd6, 0x01,
+  0x39, 0x11, 0x01, 0x42, 0xcb, 0x74, 0x17, 0xe8, 0xe2, 0x02, 0x22, 0x24,
+  0xfb, 0xa4, 0x03, 0xf9, 0x16, 0x43, 0x75, 0xaa, 0xa1, 0x66, 0xb4, 0x6c,
+  0x43, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x12, 0x00, 0x00, 0x04, 0x83,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x12, 0x04, 0x71, 0xfb,
+  0x8f, 0x04, 0x71, 0xfe, 0x23, 0xb7, 0xfe, 0x23, 0x05, 0xd5, 0xaa, 0x78,
+  0xaa, 0xfb, 0xf7, 0x04, 0x09, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5f,
+  0x00, 0x00, 0x04, 0x38, 0x05, 0xd5, 0x00, 0x26, 0x00, 0x00, 0x13, 0x37,
+  0x21, 0x07, 0x21, 0x16, 0x17, 0x21, 0x07, 0x23, 0x06, 0x07, 0x06, 0x07,
+  0x16, 0x17, 0x16, 0x17, 0x13, 0x23, 0x03, 0x26, 0x27, 0x26, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x37, 0x21, 0x26, 0x27, 0x26,
+  0x23, 0x5f, 0x32, 0x03, 0xa6, 0x31, 0xfe, 0xc1, 0x47, 0x13, 0x01, 0x16,
+  0x31, 0xde, 0x05, 0x36, 0x3b, 0x70, 0x3a, 0x38, 0x34, 0x3b, 0xb8, 0xc3,
+  0xac, 0x44, 0x3d, 0x3f, 0x6c, 0xc6, 0xe5, 0x83, 0x43, 0x3d, 0x06, 0xfd,
+  0xf7, 0x32, 0x01, 0xcc, 0x10, 0x28, 0x43, 0x83, 0x05, 0x5a, 0x7b, 0x7b,
+  0x4e, 0x81, 0x7b, 0x7e, 0x55, 0x5d, 0x24, 0x16, 0x48, 0x44, 0x82, 0xfe,
+  0x68, 0x01, 0x7f, 0x97, 0x30, 0x31, 0xa6, 0x43, 0x3e, 0x72, 0x7b, 0x43,
+  0x34, 0x58, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09, 0x00, 0x05, 0x04, 0xad,
+  0x05, 0xda, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x10, 0x07, 0x06, 0x21, 0x23,
+  0x11, 0x07, 0x27, 0x25, 0x35, 0x07, 0x27, 0x25, 0x11, 0x33, 0x11, 0x37,
+  0x17, 0x05, 0x15, 0x37, 0x17, 0x05, 0x11, 0x20, 0x00, 0x11, 0x04, 0xad,
+  0xb8, 0xb7, 0xfe, 0x7b, 0x9b, 0xcf, 0x46, 0x01, 0x15, 0xd1, 0x44, 0x01,
+  0x15, 0xb6, 0xcf, 0x48, 0xfe, 0xe9, 0xd1, 0x48, 0xfe, 0xe7, 0x01, 0x16,
+  0x01, 0x02, 0x02, 0xf1, 0xfe, 0x7e, 0xb5, 0xb5, 0x02, 0x1e, 0xa1, 0x6e,
+  0xd8, 0x89, 0xa2, 0x6e, 0xd9, 0x01, 0xe4, 0xfe, 0xaa, 0xa2, 0x6f, 0xd9,
+  0x88, 0xa3, 0x6f, 0xda, 0xfd, 0xfb, 0x01, 0x18, 0x01, 0x2e, 0x00, 0x00,
+  0x00, 0x01, 0xfc, 0x76, 0x05, 0x15, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x13, 0x33, 0x07, 0x21, 0x15, 0xfc, 0x77, 0xc4, 0x71,
+  0x77, 0x02, 0x9b, 0x05, 0x15, 0x00, 0xff, 0x9b, 0x64, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xfc, 0x9d, 0x05, 0x15, 0xff, 0xf7, 0x06, 0x14, 0x00, 0x05,
+  0x00, 0x00, 0x03, 0x21, 0x35, 0x21, 0x27, 0x33, 0x09, 0xfc, 0xa6, 0x02,
+  0x9b, 0x77, 0x72, 0x05, 0x15, 0x64, 0x9b, 0x00, 0x00, 0x01, 0xfc, 0x9d,
+  0x04, 0x7a, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x08, 0x00, 0x00, 0x03, 0x21,
+  0x17, 0x23, 0x27, 0x37, 0x33, 0x07, 0x21, 0x30, 0xfd, 0x65, 0x77, 0x71,
+  0x9e, 0x9e, 0x71, 0x77, 0x02, 0x9b, 0x05, 0x15, 0x9b, 0xcd, 0xcd, 0x9b,
+  0x00, 0x01, 0xfc, 0x9d, 0x04, 0x7a, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x08,
+  0x00, 0x00, 0x01, 0x35, 0x21, 0x27, 0x33, 0x17, 0x07, 0x23, 0x37, 0xfc,
+  0x9d, 0x02, 0x9b, 0x77, 0x72, 0x9d, 0x9d, 0x72, 0x77, 0x05, 0x15, 0x64,
+  0x9b, 0xcd, 0xcd, 0x9b, 0x00, 0x04, 0xfc, 0x77, 0x04, 0x7b, 0xff, 0xee,
+  0x06, 0x10, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0c, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23,
+  0x17, 0xfc, 0x78, 0xb6, 0xb6, 0x02, 0xbf, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7,
+  0xb7, 0x5c, 0x06, 0x10, 0xca, 0xca, 0xca, 0xca, 0xca, 0xcb, 0x00, 0x00,
+  0x00, 0x05, 0xfb, 0xc8, 0x04, 0x7b, 0x00, 0x9f, 0x06, 0x10, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x10, 0x00, 0x00, 0x03, 0x33,
+  0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x25, 0x33,
+  0x15, 0x23, 0x05, 0x18, 0xb6, 0xb6, 0xfb, 0xe0, 0xb7, 0xb7, 0x02, 0xc0,
+  0xb6, 0xb6, 0xfe, 0xa0, 0xb7, 0xb7, 0x01, 0x0b, 0x06, 0x10, 0xca, 0xca,
+  0xca, 0xca, 0xca, 0xca, 0xca, 0xcb, 0x00, 0x00, 0x00, 0x01, 0xfc, 0x9d,
+  0x04, 0x7a, 0xff, 0xd1, 0x06, 0x14, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x17,
+  0x23, 0x27, 0x37, 0x33, 0x07, 0x21, 0x27, 0x33, 0x17, 0x07, 0x23, 0x37,
+  0xfd, 0x35, 0x77, 0x71, 0x9e, 0x9e, 0x71, 0x77, 0x02, 0x03, 0x77, 0x72,
+  0x9d, 0x9d, 0x72, 0x77, 0x05, 0x15, 0x9b, 0xcd, 0xcd, 0x9b, 0x9b, 0xcd,
+  0xcd, 0x9b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x3c, 0xff, 0xcf, 0x07, 0x10,
+  0x06, 0x04, 0x00, 0x0a, 0x00, 0x24, 0x00, 0x28, 0x00, 0x42, 0x00, 0x00,
+  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x37,
+  0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
+  0x17, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0x25, 0x33, 0x01, 0x23, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x01, 0xda, 0x90, 0x64, 0x4a,
+  0x41, 0x5c, 0x72, 0xa9, 0xa9, 0x03, 0x89, 0x62, 0x7f, 0x96, 0xb9, 0xb2,
+  0x98, 0x64, 0x5d, 0x3d, 0x74, 0x59, 0x53, 0x85, 0x40, 0xaf, 0xad, 0x02,
+  0x6c, 0xc2, 0xfc, 0xa4, 0xc3, 0x05, 0x18, 0x54, 0x64, 0x33, 0x6d, 0x7b,
+  0x7b, 0x6d, 0x33, 0x64, 0x54, 0x41, 0x76, 0x41, 0xb6, 0xd4, 0xd6, 0xbc,
+  0x3c, 0x73, 0x03, 0xf6, 0x42, 0x52, 0x43, 0x49, 0x94, 0x82, 0x0a, 0x4d,
+  0xfe, 0x0d, 0x3e, 0x05, 0x4f, 0x9e, 0x81, 0x96, 0x9b, 0x06, 0x57, 0x5c,
+  0x20, 0x37, 0xb2, 0x24, 0x1e, 0xca, 0xfa, 0xf9, 0xcb, 0x03, 0x84, 0xb2,
+  0x34, 0x1e, 0x9c, 0x94, 0x93, 0x9d, 0x1f, 0x34, 0xb1, 0x22, 0x1b, 0xfa,
+  0xd1, 0xd4, 0xf9, 0x1b, 0x00, 0x04, 0x00, 0x3c, 0xff, 0xcf, 0x07, 0x32,
+  0x06, 0x04, 0x00, 0x20, 0x00, 0x2b, 0x00, 0x45, 0x00, 0x49, 0x00, 0x00,
+  0x01, 0x2e, 0x01, 0x34, 0x36, 0x04, 0x17, 0x15, 0x27, 0x26, 0x23, 0x22,
+  0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x14, 0x06, 0x23, 0x26, 0x27,
+  0x35, 0x17, 0x16, 0x33, 0x32, 0x35, 0x34, 0x26, 0x27, 0x01, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x37, 0x11, 0x23, 0x35,
+  0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x17, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x25, 0x33,
+  0x01, 0x23, 0x05, 0xb4, 0x7a, 0x72, 0xa6, 0x01, 0x2d, 0x6e, 0x21, 0x64,
+  0x74, 0xa2, 0x35, 0x5e, 0x2b, 0x8a, 0x7b, 0xb5, 0x99, 0x9e, 0x82, 0x21,
+  0x84, 0x7d, 0xa0, 0x37, 0x6f, 0xfb, 0xfb, 0x90, 0x64, 0x4a, 0x41, 0x5c,
+  0x72, 0xa9, 0xa9, 0x03, 0x89, 0x62, 0x7f, 0x96, 0xb9, 0xb2, 0x98, 0x64,
+  0x5d, 0x3d, 0x74, 0x59, 0x53, 0x85, 0x40, 0xaf, 0xad, 0x02, 0x6c, 0xc2,
+  0xfc, 0xa4, 0xc3, 0x01, 0x7d, 0x1c, 0x7c, 0xef, 0x8e, 0x01, 0x34, 0xbc,
+  0x12, 0x39, 0x64, 0x24, 0x2c, 0x18, 0x0a, 0x21, 0x7f, 0xf3, 0x95, 0x06,
+  0x35, 0xca, 0x13, 0x4c, 0x66, 0x2c, 0x31, 0x1b, 0x02, 0x84, 0x42, 0x52,
+  0x43, 0x49, 0x94, 0x82, 0x0a, 0x4d, 0xfe, 0x0d, 0x3e, 0x05, 0x4f, 0x9e,
+  0x81, 0x96, 0x9b, 0x06, 0x57, 0x5c, 0x20, 0x37, 0xb2, 0x24, 0x1e, 0xca,
+  0xfa, 0xf9, 0xcb, 0x00, 0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4,
+  0x05, 0xf0, 0x00, 0x18, 0x00, 0x21, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01,
+  0x23, 0x22, 0x07, 0x11, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01,
+  0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x01, 0x11, 0x06,
+  0x07, 0x06, 0x11, 0x10, 0x17, 0x16, 0x04, 0xa3, 0x50, 0xd1, 0x88, 0x92,
+  0x6d, 0x6d, 0x92, 0x88, 0xd1, 0x50, 0x5f, 0xd6, 0x76, 0xfe, 0xce, 0xfe,
+  0xa2, 0x01, 0x5e, 0x01, 0x32, 0x78, 0xd6, 0xfd, 0x56, 0x1f, 0x1c, 0x8d,
+  0x8d, 0x1c, 0x05, 0x62, 0x76, 0x41, 0x5a, 0x34, 0xfb, 0x2d, 0x34, 0x5a,
+  0x42, 0x75, 0x48, 0x48, 0x01, 0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f,
+  0x47, 0xfb, 0x13, 0x04, 0x5b, 0x1b, 0x21, 0xac, 0xfe, 0xba, 0xfe, 0xbb,
+  0xac, 0x21, 0x00, 0x00, 0xff, 0xff, 0x00, 0xaf, 0xff, 0xe3, 0x07, 0x96,
+  0x05, 0xf0, 0x10, 0x26, 0x00, 0x72, 0x00, 0x00, 0x10, 0x07, 0x00, 0x26,
+  0x02, 0xf2, 0x00, 0x00, 0x00, 0x02, 0xff, 0xda, 0x00, 0x00, 0x04, 0x96,
+  0x05, 0xd5, 0x00, 0x08, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x17, 0x11, 0x35, 0x33, 0x15, 0x16, 0x17, 0x16,
+  0x17, 0x15, 0x26, 0x27, 0x26, 0x27, 0x11, 0x36, 0x37, 0x36, 0x37, 0x15,
+  0x06, 0x07, 0x06, 0x07, 0x15, 0x21, 0x15, 0x21, 0x35, 0x26, 0x27, 0x26,
+  0x11, 0x10, 0x37, 0x36, 0x01, 0x52, 0x42, 0x2e, 0x59, 0x59, 0x2e, 0x42,
+  0xb5, 0x33, 0x30, 0x49, 0x45, 0x47, 0x46, 0x31, 0x33, 0x33, 0x31, 0x46,
+  0x47, 0x46, 0x4a, 0x2e, 0x33, 0x02, 0x8f, 0xfc, 0xbc, 0x91, 0x61, 0x86,
+  0x88, 0x5f, 0x04, 0xb3, 0x1d, 0x3a, 0x72, 0xcd, 0xcd, 0x71, 0x3b, 0x1d,
+  0x03, 0xd4, 0x7a, 0x6e, 0x04, 0x0b, 0x12, 0x23, 0xac, 0x2b, 0x16, 0x0f,
+  0x04, 0xfc, 0xa4, 0x04, 0x10, 0x15, 0x2b, 0xaa, 0x24, 0x12, 0x0b, 0x04,
+  0x2a, 0xaa, 0xde, 0x20, 0x72, 0x9f, 0x01, 0x0e, 0x01, 0x12, 0x9d, 0x6e,
+  0x00, 0x04, 0x00, 0x36, 0xff, 0xcf, 0x07, 0x1b, 0x06, 0x04, 0x00, 0x19,
+  0x00, 0x1d, 0x00, 0x28, 0x00, 0x32, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x25, 0x33,
+  0x01, 0x23, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x10,
+  0x26, 0x24, 0x20, 0x16, 0x15, 0x14, 0x06, 0x20, 0x26, 0x35, 0x34, 0x02,
+  0xb9, 0x55, 0x64, 0x32, 0x6d, 0x7b, 0x7b, 0x6d, 0x32, 0x64, 0x55, 0x42,
+  0x75, 0x42, 0xb6, 0xd4, 0xd6, 0xbc, 0x3d, 0x73, 0x02, 0x94, 0xc2, 0xfc,
+  0xa4, 0xc3, 0x03, 0xfa, 0x57, 0x6a, 0x6a, 0x57, 0x56, 0x6b, 0x6b, 0xfe,
+  0xfc, 0x01, 0x5c, 0xc4, 0xc4, 0xfe, 0xa4, 0xc3, 0x05, 0x97, 0xb2, 0x34,
+  0x1e, 0x9c, 0x94, 0x93, 0x9d, 0x1f, 0x34, 0xb1, 0x22, 0x1d, 0xfc, 0xd1,
+  0xd4, 0xf9, 0x1b, 0x4b, 0xf9, 0xcb, 0x03, 0x04, 0x9e, 0x92, 0x91, 0x9f,
+  0xa0, 0x01, 0x20, 0xa0, 0x9d, 0xf8, 0xd5, 0xd4, 0xf8, 0xf8, 0xd4, 0xd5,
+  0x00, 0x03, 0x00, 0x36, 0xff, 0xcf, 0x07, 0x79, 0x06, 0x04, 0x00, 0x13,
+  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x25, 0x33, 0x01, 0x23, 0x04, 0xd3, 0xa9, 0x49,
+  0x48, 0x59, 0x69, 0xa9, 0xa9, 0x05, 0x82, 0x56, 0x8e, 0x91, 0xfd, 0xe6,
+  0x55, 0x64, 0x32, 0x6d, 0x7b, 0x7b, 0x6d, 0x32, 0x64, 0x55, 0x42, 0x75,
+  0x42, 0xb6, 0xd4, 0xd6, 0xbc, 0x3d, 0x73, 0x02, 0x94, 0xc2, 0xfc, 0xa4,
+  0xc3, 0x01, 0x4c, 0x02, 0x10, 0xfd, 0xf5, 0x72, 0x69, 0x81, 0x75, 0x01,
+  0xf0, 0xfc, 0x90, 0x44, 0x09, 0x50, 0xc1, 0x04, 0xff, 0xb2, 0x34, 0x1e,
+  0x9c, 0x94, 0x93, 0x9d, 0x1f, 0x34, 0xb1, 0x22, 0x1d, 0xfc, 0xd1, 0xd4,
+  0xf9, 0x1b, 0x4b, 0xf9, 0xcb, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x93,
+  0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x10, 0x06, 0x01, 0x52, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xfe, 0xd6, 0x04, 0xa0, 0x04, 0xe3, 0x10, 0x07,
+  0x03, 0xc1, 0x00, 0x00, 0xfe, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xaf,
+  0x00, 0x00, 0x06, 0x6f, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x72, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x29, 0x02, 0xb6, 0x00, 0x00, 0x00, 0x01, 0x00, 0x41,
+  0xff, 0xe3, 0x06, 0xcb, 0x05, 0xfb, 0x00, 0x6f, 0x00, 0x00, 0x01, 0x0f,
+  0x01, 0x11, 0x21, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x11, 0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x21, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x19, 0x01, 0x22, 0x07, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x16, 0x03, 0x5f, 0x02, 0x61, 0x01, 0xc6, 0x24, 0x33, 0x3b, 0x44,
+  0x59, 0x6f, 0x37, 0x12, 0x22, 0x19, 0x21, 0x12, 0x14, 0x1a, 0x21, 0x2b,
+  0x2e, 0x1e, 0x24, 0x17, 0x14, 0x17, 0x24, 0x17, 0x1e, 0x27, 0x14, 0x32,
+  0x1a, 0x2e, 0x33, 0x1c, 0x21, 0x31, 0x1a, 0x57, 0x61, 0x40, 0x35, 0x32,
+  0x1a, 0x19, 0x0c, 0xfe, 0x44, 0x2d, 0x30, 0x53, 0x9c, 0xa6, 0x5e, 0x3c,
+  0x2e, 0x27, 0x23, 0x30, 0x0e, 0x10, 0x0a, 0x14, 0x08, 0x23, 0x3b, 0x52,
+  0x49, 0x3f, 0x20, 0x22, 0x7b, 0x53, 0x5a, 0x23, 0x40, 0x09, 0x01, 0x08,
+  0x09, 0x11, 0x21, 0x1e, 0x15, 0x1a, 0x12, 0x09, 0x07, 0x71, 0x43, 0x67,
+  0x71, 0x85, 0x27, 0x97, 0x05, 0xea, 0x1f, 0x31, 0xfd, 0xbc, 0xd1, 0x8c,
+  0x98, 0x49, 0x67, 0x14, 0x29, 0x1d, 0x2a, 0x1a, 0x21, 0x1c, 0x26, 0x21,
+  0x28, 0x44, 0x3b, 0x77, 0xd6, 0xfe, 0xbd, 0xa5, 0x82, 0x7d, 0x2c, 0x16,
+  0x37, 0x35, 0x3b, 0x21, 0x5f, 0x27, 0x5d, 0x37, 0x3a, 0x79, 0x7d, 0xa9,
+  0x5b, 0xb4, 0xcf, 0x9e, 0xa3, 0x5c, 0xae, 0x40, 0x34, 0x3e, 0x23, 0x2c,
+  0x0f, 0x12, 0x21, 0x2c, 0x0b, 0x27, 0x51, 0x46, 0xaa, 0xa7, 0x00, 0xff,
+  0x02, 0x6a, 0x16, 0x1a, 0x28, 0x4a, 0x47, 0x1f, 0x34, 0x10, 0x24, 0x24,
+  0x2c, 0x10, 0x2a, 0x1d, 0x12, 0x29, 0x2f, 0x39, 0x84, 0x79, 0x4b, 0x23,
+  0x25, 0x06, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0xfe, 0xf9, 0x04, 0xfe,
+  0x05, 0xd9, 0x00, 0x50, 0x00, 0x00, 0x05, 0x37, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x16, 0x17, 0x16, 0x07, 0x02, 0x07, 0x26, 0x27, 0x26,
+  0x22, 0x07, 0x27, 0x36, 0x33, 0x32, 0x17, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x16, 0x17, 0x16, 0x37, 0x36,
+  0x37, 0x15, 0x0e, 0x02, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x36, 0x37, 0x32, 0x17, 0x16, 0x15, 0x10, 0x07, 0x02,
+  0x23, 0x22, 0x02, 0xd9, 0x5f, 0x24, 0x4f, 0x21, 0x1c, 0x1f, 0x19, 0x17,
+  0x10, 0x0c, 0x18, 0x19, 0x2d, 0x3f, 0x75, 0x4a, 0x9f, 0x3e, 0x2a, 0x0a,
+  0x0c, 0x16, 0xb6, 0x47, 0x2a, 0x2f, 0x30, 0x3f, 0x69, 0x14, 0xaa, 0x48,
+  0x4c, 0x52, 0x49, 0x3f, 0x52, 0x2b, 0x2b, 0x66, 0x62, 0xbe, 0x71, 0x8c,
+  0x18, 0x1f, 0x05, 0x82, 0x43, 0x42, 0x70, 0x1e, 0x35, 0x42, 0x3f, 0x67,
+  0x35, 0x1c, 0x1c, 0x63, 0x91, 0xd5, 0xda, 0x8d, 0x35, 0x55, 0xfc, 0x4b,
+  0x55, 0xcd, 0x8c, 0x51, 0x1f, 0x1f, 0x37, 0x39, 0x7d, 0x77, 0xb2, 0x96,
+  0x5e, 0x6c, 0x2e, 0x47, 0x89, 0x79, 0x72, 0x5c, 0x5b, 0x34, 0xfe, 0xfa,
+  0x4f, 0x39, 0x25, 0x23, 0x69, 0x23, 0xde, 0x5e, 0x4d, 0x58, 0x3b, 0x80,
+  0xa5, 0x79, 0x76, 0x40, 0x63, 0x8d, 0x84, 0x93, 0x7d, 0x07, 0x01, 0x1a,
+  0x02, 0x65, 0x2e, 0x49, 0x44, 0x5c, 0x1a, 0x16, 0x37, 0x49, 0x3b, 0x3e,
+  0x32, 0x56, 0xe7, 0xa7, 0x89, 0x75, 0xd3, 0xb0, 0xfe, 0xa2, 0xd3, 0xfe,
+  0xfe, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x6a,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x25, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x04, 0x59, 0xb6, 0xfc, 0x00, 0xb6,
+  0xfe, 0xf0, 0x01, 0x6a, 0x01, 0xe0, 0x01, 0x6a, 0xfe, 0x96, 0xfe, 0x20,
+  0xfe, 0x96, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x0d,
+  0x64, 0xfd, 0x88, 0x02, 0x78, 0xfa, 0x2b, 0x02, 0xdb, 0xfd, 0x25, 0x00,
+  0x00, 0x01, 0x00, 0x40, 0x00, 0x00, 0x04, 0x14, 0x06, 0x14, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x03, 0x23, 0x13, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x03, 0x23, 0x01, 0x33, 0x03, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x04, 0x03, 0x76, 0xa7, 0x76, 0x08, 0x0a, 0x60,
+  0x55, 0x86, 0xc3, 0x1d, 0x6d, 0xa5, 0x01, 0x11, 0xa5, 0x6b, 0x3f, 0xc4,
+  0x6c, 0x85, 0x93, 0x08, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9d, 0x2f, 0x48,
+  0x15, 0x54, 0x5e, 0xc8, 0xa6, 0xfd, 0x93, 0x06, 0x14, 0xfd, 0x9c, 0x5e,
+  0x6d, 0xa0, 0x91, 0x24, 0x52, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51,
+  0x00, 0x00, 0x04, 0x14, 0x06, 0x14, 0x00, 0x19, 0x00, 0x00, 0x01, 0x33,
+  0x07, 0x25, 0x17, 0x05, 0x03, 0x36, 0x33, 0x32, 0x16, 0x07, 0x03, 0x23,
+  0x13, 0x12, 0x23, 0x22, 0x06, 0x07, 0x03, 0x23, 0x13, 0x07, 0x27, 0x37,
+  0x01, 0x61, 0xa6, 0x28, 0x01, 0x65, 0x0d, 0xfe, 0x7b, 0x2f, 0x99, 0xd0,
+  0xae, 0x88, 0x29, 0x76, 0xa5, 0x75, 0x37, 0xdf, 0x86, 0xbc, 0x1d, 0x6e,
+  0xa7, 0xc9, 0xbc, 0x0d, 0xdd, 0x06, 0x14, 0xea, 0x7c, 0x61, 0x88, 0xfe,
+  0xf5, 0xc9, 0xef, 0xe8, 0xfd, 0x5c, 0x02, 0x9e, 0x01, 0x3d, 0xbe, 0xa4,
+  0xfd, 0x87, 0x04, 0x7f, 0x42, 0x63, 0x4c, 0x00, 0x00, 0x01, 0x00, 0x35,
+  0xff, 0xe1, 0x03, 0x1c, 0x05, 0xf0, 0x00, 0x39, 0x00, 0x00, 0x01, 0x0f,
+  0x01, 0x11, 0x10, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x35, 0x11, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x14, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x03, 0x1c, 0x1b, 0x5e,
+  0xae, 0x75, 0x80, 0x63, 0x36, 0x32, 0x0f, 0x17, 0x1f, 0x19, 0x1c, 0x07,
+  0x0a, 0x0a, 0x18, 0x12, 0x35, 0x43, 0x49, 0x38, 0x1e, 0x1c, 0x70, 0x51,
+  0x57, 0x28, 0x2f, 0x06, 0x12, 0x1c, 0x14, 0x15, 0x18, 0x14, 0x24, 0x50,
+  0x45, 0x7d, 0x86, 0xa3, 0x1e, 0x70, 0x05, 0xe3, 0x2c, 0x16, 0xfc, 0xfe,
+  0xfe, 0x86, 0xc2, 0x82, 0x3c, 0x37, 0x44, 0x39, 0x0f, 0x1b, 0x23, 0x07,
+  0x37, 0x2e, 0x1b, 0x13, 0x4d, 0x3d, 0x86, 0x84, 0xbe, 0x03, 0x11, 0x1a,
+  0x1d, 0x2e, 0x31, 0x3f, 0x1b, 0x16, 0x04, 0x40, 0x09, 0x27, 0x1f, 0x12,
+  0x16, 0x28, 0x4d, 0x7f, 0x58, 0x49, 0x28, 0x27, 0x0d, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x5f, 0xff, 0xe3, 0x04, 0xbf, 0x05, 0xf0, 0x00, 0x21,
+  0x00, 0x32, 0x00, 0x00, 0x3f, 0x01, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x23, 0x22, 0x13, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x23, 0x22, 0x07, 0x5f, 0x7e, 0x64, 0x6a, 0x33,
+  0x77, 0x81, 0x1e, 0x6d, 0x5a, 0x40, 0x38, 0x48, 0x48, 0xc0, 0x48, 0x48,
+  0x2f, 0xb5, 0xa8, 0xda, 0x30, 0x74, 0x78, 0x32, 0x55, 0x63, 0x62, 0x7f,
+  0x6f, 0x72, 0x6e, 0x73, 0x70, 0x71, 0xb4, 0x7d, 0x64, 0x81, 0xc0, 0x81,
+  0x6e, 0x73, 0x5a, 0xa5, 0x27, 0x50, 0x56, 0x89, 0x61, 0x4b, 0x7e, 0x70,
+  0x92, 0x6d, 0x64, 0xa0, 0x8c, 0x8b, 0x79, 0x6b, 0x94, 0x62, 0xbc, 0x5e,
+  0xf2, 0xde, 0x4f, 0x50, 0x05, 0x36, 0x38, 0x31, 0x2f, 0x3a, 0xaa, 0x3a,
+  0x62, 0x3a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3d, 0xff, 0xe3, 0x04, 0xe3,
+  0x05, 0xf2, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x17, 0x16, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x23, 0x35, 0x22, 0x07, 0x06, 0x07,
+  0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x13, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x17, 0x33, 0x32, 0x01, 0xac, 0xe8,
+  0x63, 0x51, 0x4a, 0x36, 0x5d, 0x4d, 0x3c, 0x08, 0x27, 0x16, 0x63, 0x6d,
+  0x6d, 0x2f, 0x5b, 0x50, 0x80, 0xeb, 0x4a, 0x3d, 0x32, 0x2f, 0x0c, 0x30,
+  0x42, 0x17, 0x2c, 0x22, 0x2b, 0x31, 0x0a, 0x05, 0x1f, 0x1e, 0x3a, 0x59,
+  0xbc, 0x66, 0x40, 0x3c, 0x0d, 0x25, 0x1c, 0x27, 0x1a, 0x0c, 0x0a, 0x06,
+  0x25, 0x2e, 0x33, 0x44, 0x29, 0x20, 0x20, 0x04, 0x03, 0x12, 0x14, 0x22,
+  0x32, 0x3b, 0x02, 0x0e, 0x38, 0x01, 0x5f, 0x6e, 0x30, 0x18, 0x19, 0x56,
+  0x42, 0x9a, 0x52, 0x1e, 0x0e, 0x84, 0x0e, 0xe4, 0x6e, 0x79, 0x23, 0x1f,
+  0x48, 0x89, 0x08, 0x42, 0x3f, 0x84, 0x18, 0xc1, 0x58, 0x21, 0x24, 0x18,
+  0x39, 0x42, 0x01, 0x7f, 0xa9, 0x84, 0x80, 0x4d, 0x77, 0x3e, 0x37, 0x6c,
+  0x1a, 0x10, 0x2e, 0x1b, 0x0b, 0x3b, 0x37, 0x25, 0x2c, 0x3b, 0x28, 0xd3,
+  0xa7, 0xbd, 0x75, 0x79, 0x2c, 0x44, 0x30, 0x03, 0x00, 0x02, 0xff, 0xe6,
+  0xff, 0xe3, 0x02, 0x8a, 0x05, 0xf0, 0x00, 0x1c, 0x00, 0x26, 0x00, 0x00,
+  0x01, 0x16, 0x33, 0x32, 0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x07, 0x23, 0x36, 0x37, 0x26, 0x35, 0x34, 0x37, 0x12, 0x37, 0x36, 0x33,
+  0x32, 0x15, 0x06, 0x07, 0x02, 0x01, 0x12, 0x13, 0x36, 0x35, 0x34, 0x23,
+  0x06, 0x03, 0x06, 0x01, 0x12, 0x24, 0x4f, 0x34, 0x43, 0x78, 0x36, 0x3f,
+  0x44, 0x3f, 0x8d, 0x38, 0x44, 0x8c, 0x61, 0x48, 0x09, 0x1c, 0x69, 0x5e,
+  0x41, 0x6e, 0x71, 0x01, 0x10, 0x41, 0xfe, 0xd9, 0xa8, 0x33, 0x1b, 0x16,
+  0x62, 0x58, 0x18, 0x01, 0x0c, 0xc8, 0x73, 0x66, 0x35, 0x39, 0x8b, 0x6e,
+  0x93, 0x89, 0x4e, 0x55, 0x98, 0x98, 0x02, 0x3b, 0x75, 0x51, 0xad, 0x4e,
+  0x5d, 0xfe, 0x83, 0xfe, 0xf7, 0x01, 0x5c, 0x01, 0x16, 0x93, 0x26, 0x45,
+  0x57, 0xfd, 0xfa, 0x91, 0x00, 0x02, 0x00, 0x1c, 0xff, 0xe3, 0x05, 0x7f,
+  0x06, 0x14, 0x00, 0x1f, 0x00, 0x27, 0x00, 0x00, 0x13, 0x33, 0x15, 0x33,
+  0x35, 0x33, 0x15, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12,
+  0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23,
+  0x11, 0x23, 0x35, 0x33, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
+  0xae, 0xa5, 0xa6, 0xa6, 0x02, 0x6d, 0xfd, 0x93, 0x35, 0x9f, 0x6f, 0xb7,
+  0xe6, 0xe6, 0xb7, 0x6f, 0x9f, 0x35, 0xa6, 0xa6, 0xa5, 0x91, 0x91, 0x04,
+  0x25, 0x97, 0xfe, 0xfa, 0x97, 0x97, 0x01, 0x06, 0x06, 0x14, 0x93, 0x93,
+  0x93, 0x7d, 0xfe, 0xb2, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc,
+  0x61, 0x64, 0xa8, 0x05, 0x04, 0xfa, 0xfc, 0x05, 0x04, 0x7d, 0xfb, 0xe3,
+  0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x00, 0x00, 0x02, 0x00, 0xb2,
+  0x00, 0x00, 0x05, 0x12, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00,
+  0x25, 0x01, 0x23, 0x09, 0x01, 0x21, 0x01, 0x11, 0x33, 0x11, 0x21, 0x01,
+  0x11, 0x23, 0x04, 0x9c, 0xfd, 0x62, 0xd6, 0x02, 0x9e, 0xfc, 0xed, 0x01,
+  0x7c, 0x02, 0x88, 0x5a, 0xfe, 0x84, 0xfd, 0x78, 0x5a, 0x64, 0x05, 0x0d,
+  0xfa, 0xf3, 0x05, 0x71, 0xfb, 0x1f, 0x04, 0xe1, 0xfa, 0x2b, 0x04, 0xe1,
+  0xfb, 0x1f, 0x00, 0x00, 0x00, 0x04, 0x00, 0x30, 0x00, 0x00, 0x06, 0xfb,
+  0x05, 0xd5, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x00,
+  0x33, 0x35, 0x32, 0x35, 0x11, 0x33, 0x01, 0x11, 0x34, 0x36, 0x33, 0x15,
+  0x22, 0x15, 0x11, 0x23, 0x01, 0x11, 0x14, 0x06, 0x01, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x03, 0x35, 0x21, 0x15,
+  0x31, 0x84, 0xf5, 0x02, 0x54, 0x8d, 0xa7, 0x84, 0xf5, 0xfd, 0xac, 0x8d,
+  0x04, 0x66, 0x82, 0x5c, 0x5d, 0x81, 0x81, 0x5d, 0x5c, 0x82, 0x7e, 0x33,
+  0x2d, 0x2d, 0x33, 0x33, 0x2d, 0x2d, 0x33, 0x7e, 0x01, 0xbc, 0xaa, 0x6b,
+  0x04, 0xc0, 0xfb, 0x1f, 0x03, 0xcc, 0x80, 0x95, 0xaa, 0x6b, 0xfb, 0x40,
+  0x04, 0xe1, 0xfc, 0x34, 0x80, 0x95, 0x02, 0x6e, 0x8a, 0xbf, 0xbf, 0x8a,
+  0x8a, 0xbf, 0xbf, 0x8a, 0x4e, 0x67, 0x67, 0x4e, 0x4e, 0x67, 0x67, 0xfd,
+  0x44, 0x7b, 0x7b, 0x00, 0x00, 0x04, 0x00, 0xfe, 0x00, 0x00, 0x06, 0x35,
+  0x05, 0xca, 0x00, 0x0c, 0x00, 0x19, 0x00, 0x22, 0x00, 0x2d, 0x00, 0x00,
+  0x01, 0x16, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21,
+  0x20, 0x06, 0x23, 0x22, 0x00, 0x11, 0x12, 0x00, 0x33, 0x32, 0x00, 0x11,
+  0x10, 0x27, 0x05, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x25,
+  0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x05, 0x70,
+  0xc4, 0xfe, 0x76, 0xfe, 0xf0, 0xfe, 0xed, 0xfe, 0x7d, 0x05, 0x01, 0x88,
+  0x01, 0x13, 0x01, 0x13, 0x25, 0xee, 0xec, 0xfe, 0xac, 0x04, 0x01, 0x50,
+  0xec, 0xec, 0x01, 0x54, 0xa9, 0xfe, 0x0b, 0xa0, 0x59, 0x61, 0x61, 0x59,
+  0xfe, 0xe1, 0x01, 0x1f, 0x9f, 0xa2, 0xa2, 0x9f, 0xa0, 0x7f, 0x04, 0xf1,
+  0xdb, 0xfe, 0xce, 0xfe, 0xd0, 0xfe, 0x4c, 0x01, 0xb4, 0x01, 0x30, 0x01,
+  0x30, 0x01, 0xb6, 0x65, 0xfe, 0x85, 0xfe, 0xf9, 0xfe, 0xfb, 0xfe, 0x87,
+  0x01, 0x79, 0x01, 0x05, 0x01, 0x09, 0xbb, 0x77, 0xfe, 0xaf, 0x58, 0x51,
+  0x50, 0x58, 0x64, 0x89, 0x83, 0x85, 0x87, 0xfe, 0x98, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x63, 0xfe, 0x3b, 0x04, 0xbd, 0x03, 0xf6, 0x00, 0x30,
+  0x00, 0x3c, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x17, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x36,
+  0x37, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
+  0x01, 0x12, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x10,
+  0x37, 0x26, 0x35, 0x34, 0x37, 0x03, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x01, 0xfc, 0x7a, 0x1c, 0x52, 0x9a, 0xc5,
+  0x77, 0x76, 0x3f, 0x41, 0x8c, 0x6d, 0x9d, 0x5a, 0x45, 0x10, 0x08, 0x25,
+  0x66, 0x6e, 0x54, 0x3e, 0x23, 0x1c, 0x43, 0xaa, 0xfe, 0xc2, 0x7a, 0x3e,
+  0x50, 0x76, 0x66, 0x34, 0x39, 0xc9, 0x2a, 0xd1, 0x85, 0x74, 0x1c, 0x2b,
+  0x29, 0x3b, 0x19, 0x1d, 0x03, 0xc6, 0x82, 0xbe, 0x4d, 0x6b, 0x65, 0x94,
+  0xbd, 0x4c, 0x50, 0xab, 0xda, 0xd7, 0xa7, 0x3c, 0x2b, 0x1d, 0x28, 0x8c,
+  0x68, 0xc3, 0x7c, 0x48, 0x3d, 0xfe, 0x79, 0xfe, 0xde, 0x7c, 0x9d, 0x6e,
+  0x8e, 0x3d, 0x42, 0x86, 0x01, 0x0b, 0xfc, 0x9e, 0x7f, 0xee, 0xa4, 0xfc,
+  0xef, 0xc6, 0x7b, 0x75, 0x2e, 0x46, 0x01, 0x2f, 0x34, 0x5f, 0x4e, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x0b, 0x00, 0x16, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x21, 0x32, 0x37, 0x11, 0x26, 0x23, 0x25, 0x21, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x21, 0x01, 0x11, 0x36, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x01, 0x0e, 0xb6, 0x5a, 0x01, 0x10, 0x15, 0x15,
+  0x15, 0x15, 0xfd, 0x86, 0x02, 0x4f, 0xe1, 0xe8, 0xe8, 0xe2, 0xe4, 0xfe,
+  0x96, 0x03, 0x02, 0x36, 0x29, 0x54, 0x53, 0x28, 0x05, 0x71, 0xfa, 0xf3,
+  0x05, 0x0d, 0xfd, 0x6a, 0x02, 0x02, 0x92, 0x02, 0x64, 0xdb, 0xd3, 0xd5,
+  0xda, 0xfd, 0x88, 0x05, 0x5a, 0xfd, 0x99, 0x16, 0x29, 0x56, 0x9f, 0x9e,
+  0x56, 0x29, 0x00, 0x00, 0x00, 0x04, 0x00, 0x67, 0xfe, 0xf8, 0x05, 0x44,
+  0x05, 0xf0, 0x00, 0x11, 0x00, 0x19, 0x00, 0x21, 0x00, 0x29, 0x00, 0x00,
+  0x25, 0x13, 0x23, 0x27, 0x07, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x02, 0x25, 0x16, 0x32, 0x37, 0x11, 0x26,
+  0x22, 0x07, 0x03, 0x11, 0x06, 0x07, 0x06, 0x10, 0x17, 0x16, 0x01, 0x11,
+  0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x03, 0xd5, 0xef, 0xdb, 0xc7, 0x2e,
+  0x0f, 0x0f, 0xfe, 0xe5, 0xfe, 0xad, 0x01, 0x53, 0x01, 0x1b, 0x01, 0x1b,
+  0x01, 0x52, 0xbc, 0xfd, 0x74, 0x61, 0xf5, 0x61, 0x61, 0xf5, 0x61, 0x5f,
+  0x20, 0x1d, 0x8b, 0x8b, 0x1d, 0x02, 0x94, 0x20, 0x1c, 0x8b, 0x8b, 0x1c,
+  0x1b, 0xfe, 0xdd, 0xef, 0x03, 0x01, 0x01, 0xa5, 0x01, 0x61, 0x01, 0x62,
+  0x01, 0xa5, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0xfc, 0xfe, 0x8e, 0x0b, 0x32,
+  0x32, 0x04, 0xd7, 0x32, 0x32, 0xfb, 0x6a, 0x04, 0x54, 0x1d, 0x25, 0xb6,
+  0xfd, 0x9c, 0xb5, 0x25, 0x04, 0x35, 0xfb, 0xaf, 0x1d, 0x24, 0xb6, 0x02,
+  0x63, 0xb6, 0x24, 0x00, 0x00, 0x02, 0x00, 0x3b, 0xff, 0xee, 0x05, 0x80,
+  0x06, 0x32, 0x00, 0x0c, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x11, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x13, 0x03, 0x27,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x35, 0x11, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x1e,
+  0x01, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x21, 0x36, 0x3f, 0x01, 0x15, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x17, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x02, 0xef, 0x1b, 0x37,
+  0x81, 0x54, 0x5e, 0x4a, 0x19, 0x53, 0x50, 0x87, 0xb9, 0x4d, 0x1c, 0x2e,
+  0x2b, 0x3f, 0x8f, 0xa7, 0x63, 0x32, 0x35, 0x18, 0x16, 0x20, 0x17, 0x14,
+  0x18, 0x10, 0x13, 0x0f, 0x17, 0x3f, 0x5c, 0x4b, 0x33, 0x1e, 0x1d, 0xcf,
+  0x75, 0x36, 0x09, 0x01, 0x0f, 0x1a, 0x20, 0x30, 0x1a, 0x27, 0x5d, 0xaa,
+  0x01, 0x05, 0x1b, 0x35, 0x36, 0xa3, 0x7c, 0x76, 0x2e, 0x4f, 0x63, 0x5d,
+  0x8b, 0x51, 0x4a, 0x6f, 0x17, 0x28, 0x1a, 0x1c, 0x1f, 0x10, 0x1c, 0x20,
+  0x33, 0x38, 0x35, 0x44, 0x1d, 0x49, 0x05, 0xa1, 0xfd, 0x49, 0x07, 0x61,
+  0x67, 0xc2, 0xa3, 0x53, 0x1b, 0x14, 0x0f, 0xfb, 0x16, 0x01, 0xe6, 0x09,
+  0xc0, 0x88, 0x89, 0x44, 0xa3, 0x35, 0x40, 0x37, 0x2a, 0x1a, 0x18, 0x16,
+  0x1a, 0x1f, 0x27, 0x10, 0x1a, 0x53, 0x3a, 0x79, 0x7d, 0x9e, 0x03, 0x2a,
+  0x82, 0x37, 0x48, 0x19, 0x30, 0x09, 0x35, 0x0f, 0x23, 0x21, 0x1f, 0x18,
+  0x2c, 0x49, 0x91, 0x6c, 0xbb, 0x0d, 0x1d, 0x1c, 0x40, 0x1c, 0x1f, 0x33,
+  0x58, 0xa7, 0xbf, 0x6e, 0x68, 0x30, 0xde, 0xcd, 0x7b, 0x1f, 0x1f, 0x28,
+  0x32, 0x18, 0x72, 0x3a, 0x3d, 0x1f, 0x4f, 0x00, 0x00, 0x02, 0x00, 0x4a,
+  0xff, 0xe3, 0x05, 0xc8, 0x05, 0xf1, 0x00, 0x49, 0x00, 0x58, 0x00, 0x00,
+  0x05, 0x26, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x15, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x16, 0x17, 0x14, 0x17, 0x16,
+  0x32, 0x37, 0x36, 0x35, 0x11, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x14, 0x17, 0x16, 0x33, 0x17, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
+  0x37, 0x17, 0x01, 0x16, 0x15, 0x11, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x04, 0x82, 0x4a, 0x14, 0x24, 0x47, 0x26,
+  0x53, 0x6c, 0x5c, 0x5d, 0x7e, 0x7f, 0x5c, 0x5c, 0x28, 0x2a, 0x39, 0x3a,
+  0x81, 0x39, 0x3a, 0x3a, 0x39, 0x52, 0x49, 0x3b, 0x39, 0x39, 0x3a, 0x4a,
+  0x31, 0x88, 0x5c, 0x5c, 0x5c, 0x5c, 0x88, 0x92, 0x5b, 0x1b, 0x0e, 0xbe,
+  0xa8, 0x65, 0x2a, 0x21, 0x71, 0x3a, 0x3c, 0x70, 0x34, 0x2c, 0x21, 0x18,
+  0x1d, 0x28, 0x82, 0x26, 0xfc, 0xfa, 0x12, 0x8b, 0x82, 0x45, 0x43, 0x43,
+  0x16, 0x1c, 0x39, 0x5c, 0x1d, 0xb7, 0x9f, 0x8c, 0x5b, 0xa6, 0x2b, 0x38,
+  0xc7, 0xce, 0x76, 0x75, 0x75, 0x76, 0xb0, 0x0c, 0x0c, 0x7a, 0x56, 0x57,
+  0x57, 0x57, 0x96, 0x02, 0x9b, 0x95, 0x58, 0x57, 0x57, 0x56, 0xca, 0x56,
+  0x57, 0x5c, 0x75, 0x76, 0x9c, 0x9d, 0x75, 0x75, 0x75, 0x23, 0x20, 0x62,
+  0x57, 0x0e, 0x31, 0xb1, 0x57, 0x7b, 0x7c, 0x5e, 0x31, 0x24, 0x68, 0x7b,
+  0x83, 0x80, 0x76, 0x43, 0x5b, 0x04, 0x53, 0x4b, 0x5c, 0xfe, 0x95, 0x47,
+  0x43, 0x68, 0x66, 0x79, 0x97, 0x20, 0x0a, 0x2f, 0x00, 0x05, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x94, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x26,
+  0x00, 0x2e, 0x00, 0x32, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x2b, 0x01,
+  0x16, 0x17, 0x13, 0x33, 0x03, 0x1e, 0x01, 0x17, 0x13, 0x21, 0x03, 0x2e,
+  0x01, 0x2b, 0x01, 0x11, 0x21, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x01, 0x11, 0x21, 0x32, 0x37, 0x11, 0x26, 0x23, 0x17, 0x11, 0x36,
+  0x37, 0x36, 0x10, 0x27, 0x26, 0x25, 0x11, 0x33, 0x11, 0x04, 0x7c, 0x45,
+  0x3d, 0x3e, 0x6c, 0x29, 0x46, 0x5b, 0x80, 0xb3, 0xed, 0x2f, 0x66, 0x38,
+  0xb8, 0xfe, 0x74, 0xab, 0x43, 0x7d, 0x6c, 0x12, 0xfe, 0x96, 0x02, 0x63,
+  0xe7, 0xe2, 0x69, 0x2c, 0xfd, 0xd3, 0x01, 0x24, 0x16, 0x15, 0x15, 0x16,
+  0x89, 0x3b, 0x26, 0x51, 0x50, 0x26, 0xfd, 0x07, 0xb6, 0x01, 0x7f, 0x97,
+  0x30, 0x31, 0x2f, 0xc9, 0xfe, 0xe5, 0x02, 0x4f, 0x19, 0x84, 0x7e, 0xfe,
+  0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0x89, 0x05, 0xd5, 0xd6, 0xd8, 0xd0,
+  0x62, 0x29, 0x02, 0xa5, 0xfd, 0x6a, 0x02, 0x02, 0x92, 0x02, 0x17, 0xfd,
+  0x99, 0x16, 0x29, 0x56, 0x01, 0x3e, 0x55, 0x29, 0x2d, 0xfa, 0xf3, 0x05,
+  0x0d, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x98, 0x00, 0x00, 0x05, 0xdd,
+  0x05, 0xd5, 0x00, 0x08, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11,
+  0x21, 0x32, 0x16, 0x15, 0x14, 0x07, 0x17, 0x37, 0x33, 0x09, 0x01, 0x23,
+  0x0b, 0x01, 0x23, 0x01, 0x01, 0x4e, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0x01,
+  0x04, 0x68, 0x9c, 0xe4, 0xb6, 0x01, 0x9a, 0xe2, 0xe8, 0x46, 0x9c, 0xab,
+  0xd1, 0xfe, 0xec, 0x01, 0x22, 0xd1, 0xbb, 0xbe, 0xd1, 0x01, 0x28, 0x05,
+  0x2f, 0xfd, 0xcf, 0x92, 0x87, 0x86, 0x92, 0xfd, 0x5f, 0x36, 0xfd, 0xa8,
+  0x05, 0xd5, 0xe3, 0xdb, 0xac, 0x6b, 0xdb, 0xea, 0xfe, 0x86, 0xfe, 0x6b,
+  0x01, 0x04, 0xfe, 0xfc, 0x01, 0x95, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xff, 0x25, 0x04, 0xcc, 0x06, 0xc7, 0x00, 0x05, 0x00, 0x24, 0x00, 0x2b,
+  0x00, 0x2e, 0x00, 0x00, 0x01, 0x11, 0x33, 0x13, 0x26, 0x23, 0x13, 0x16,
+  0x17, 0x16, 0x17, 0x13, 0x23, 0x03, 0x26, 0x27, 0x26, 0x27, 0x01, 0x27,
+  0x37, 0x23, 0x11, 0x21, 0x32, 0x17, 0x37, 0x25, 0x37, 0x05, 0x07, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x06, 0x0b, 0x01, 0x36, 0x37, 0x36, 0x35, 0x34,
+  0x01, 0x13, 0x23, 0x01, 0x6b, 0xbc, 0xb4, 0x39, 0x53, 0xe3, 0x3b, 0x37,
+  0x34, 0x3b, 0xb9, 0xc4, 0xac, 0x43, 0x3e, 0x30, 0x4d, 0xfe, 0xd0, 0x64,
+  0x3f, 0x54, 0x01, 0x9a, 0x72, 0x55, 0x0a, 0xfe, 0xdb, 0x27, 0x01, 0x8a,
+  0x32, 0x19, 0x14, 0x71, 0x75, 0x70, 0x96, 0x4b, 0x2e, 0x43, 0xfe, 0x12,
+  0x80, 0x80, 0x05, 0x2f, 0xfd, 0xee, 0x01, 0xf8, 0x1a, 0xfd, 0x8d, 0x16,
+  0x48, 0x44, 0x82, 0xfe, 0x68, 0x01, 0x7f, 0x97, 0x30, 0x26, 0x09, 0xfc,
+  0xb0, 0x2c, 0xaf, 0x05, 0xd5, 0x1a, 0x1b, 0x82, 0x6f, 0xae, 0x8c, 0x10,
+  0x13, 0x6b, 0xd8, 0x8d, 0xba, 0x01, 0xe7, 0xfe, 0x5d, 0x0f, 0x2d, 0x44,
+  0x83, 0x62, 0xfc, 0x87, 0x01, 0x67, 0x00, 0x00, 0x00, 0x02, 0x00, 0xe9,
+  0x03, 0x8b, 0x05, 0x8b, 0x05, 0xd8, 0x00, 0x27, 0x00, 0x34, 0x00, 0x00,
+  0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x37, 0x33, 0x1b, 0x01, 0x33, 0x11, 0x23, 0x11,
+  0x03, 0x23, 0x03, 0x11, 0x23, 0x02, 0x9c, 0x4d, 0x4e, 0x23, 0x3b, 0x3f,
+  0x2a, 0x3e, 0x32, 0x65, 0x5f, 0x82, 0x7e, 0x2f, 0x67, 0x40, 0x52, 0x5a,
+  0x2a, 0x3e, 0x44, 0x32, 0x39, 0x32, 0x65, 0x59, 0x7c, 0x70, 0x2e, 0x5e,
+  0xbb, 0xa6, 0x91, 0x92, 0xa5, 0x7c, 0x7e, 0x79, 0x7f, 0x7c, 0x05, 0xb7,
+  0x59, 0x22, 0x13, 0x2a, 0x2f, 0x28, 0x20, 0x0b, 0x09, 0x12, 0x56, 0x41,
+  0x4f, 0x5b, 0x13, 0x15, 0x60, 0x2a, 0x18, 0x2c, 0x32, 0x2c, 0x2a, 0x0a,
+  0x09, 0x12, 0x4d, 0x3d, 0x48, 0x5c, 0x0f, 0x05, 0xfe, 0xac, 0x01, 0x54,
+  0xfd, 0xc8, 0x01, 0x94, 0xfe, 0xd8, 0x01, 0x28, 0xfe, 0x6c, 0x00, 0x00,
+  0x00, 0x03, 0xff, 0xfc, 0x00, 0x00, 0x07, 0x5f, 0x04, 0x60, 0x00, 0x07,
+  0x00, 0x13, 0x00, 0x19, 0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x05, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x01, 0x33, 0x11, 0x21, 0x15, 0x21, 0x04, 0x03, 0x55, 0xfe,
+  0x99, 0x88, 0xfe, 0x9a, 0x02, 0x97, 0x02, 0x31, 0xfe, 0x46, 0x01, 0xa7,
+  0xfe, 0x59, 0x01, 0xc4, 0xfd, 0xc5, 0x02, 0xa4, 0x77, 0x01, 0xb0, 0xfd,
+  0xd9, 0x04, 0x60, 0x80, 0xfc, 0x20, 0x03, 0xe0, 0x60, 0x66, 0xfe, 0xf7,
+  0x66, 0xfe, 0xbb, 0x66, 0x03, 0x80, 0xfc, 0xe6, 0x66, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x09, 0x03, 0x93, 0x05, 0xa6, 0x05, 0xd5, 0x00, 0x0c,
+  0x00, 0x14, 0x00, 0x00, 0x01, 0x1b, 0x01, 0x33, 0x11, 0x23, 0x11, 0x03,
+  0x23, 0x03, 0x11, 0x23, 0x11, 0x23, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23,
+  0x35, 0x03, 0xdc, 0x9d, 0x93, 0x99, 0x65, 0xb0, 0x31, 0xb7, 0x67, 0x65,
+  0xb7, 0x67, 0xb4, 0x05, 0xd5, 0xff, 0x00, 0x01, 0x00, 0xfd, 0xbe, 0x01,
+  0xe4, 0xfe, 0xd1, 0x01, 0x2f, 0xfe, 0x1c, 0x02, 0x42, 0x5e, 0xfe, 0x1c,
+  0x01, 0xe4, 0x5e, 0x00, 0x00, 0x01, 0x00, 0x0e, 0xff, 0x22, 0x04, 0xde,
+  0x06, 0xc4, 0x00, 0x10, 0x00, 0x00, 0x01, 0x13, 0x25, 0x37, 0x05, 0x01,
+  0x13, 0x01, 0x33, 0x01, 0x23, 0x0b, 0x01, 0x27, 0x09, 0x01, 0x33, 0x01,
+  0xa8, 0xe7, 0xfe, 0xdb, 0x27, 0x01, 0x8b, 0xfe, 0xc4, 0x96, 0x01, 0xab,
+  0xbd, 0xfe, 0x00, 0xcf, 0x8e, 0xe3, 0x64, 0x01, 0x0f, 0xfe, 0xc5, 0xbe,
+  0x03, 0x4d, 0x02, 0x86, 0x82, 0x6f, 0xae, 0xfc, 0x90, 0xfe, 0x46, 0x04,
+  0xe9, 0xfa, 0x2b, 0x01, 0x9e, 0xfd, 0x84, 0x2c, 0x02, 0xf5, 0x03, 0x92,
+  0x00, 0x02, 0x00, 0x52, 0x00, 0x00, 0x05, 0x0a, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x0d, 0x00, 0x00, 0x25, 0x01, 0x23, 0x01, 0x03, 0x21, 0x15, 0x01,
+  0x21, 0x15, 0x21, 0x35, 0x01, 0x21, 0x01, 0x9a, 0x02, 0xe6, 0xd3, 0xfd,
+  0x1b, 0x60, 0x04, 0x8d, 0xfd, 0x1a, 0x02, 0xfb, 0xfb, 0x49, 0x02, 0xe5,
+  0xfd, 0x30, 0x64, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x71, 0x64, 0xfa, 0xf3,
+  0x64, 0x64, 0x05, 0x0d, 0x00, 0x01, 0x00, 0x4f, 0xfe, 0x4c, 0x03, 0xc4,
+  0x06, 0x14, 0x00, 0x1f, 0x00, 0x00, 0x17, 0x16, 0x20, 0x36, 0x35, 0x34,
+  0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x35, 0x01, 0x21, 0x35, 0x21, 0x15,
+  0x01, 0x21, 0x15, 0x01, 0x32, 0x1e, 0x01, 0x15, 0x10, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x4f, 0x99, 0x01, 0x79, 0xae, 0xa7, 0x94, 0xf5, 0x01, 0xc5,
+  0xfe, 0x3b, 0x01, 0xc5, 0xfd, 0xfd, 0x02, 0xd4, 0xfe, 0x56, 0x01, 0xaa,
+  0xfe, 0x56, 0x9a, 0xc9, 0x96, 0x7f, 0xa7, 0xe8, 0xa8, 0xbf, 0xa7, 0x63,
+  0xa3, 0xcc, 0x86, 0x93, 0xa6, 0x01, 0x65, 0x93, 0x01, 0x65, 0x93, 0xa8,
+  0xfe, 0xb0, 0xa8, 0xfe, 0xb0, 0x61, 0xd4, 0x8a, 0xfe, 0xd3, 0x66, 0x86,
+  0x4a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x46, 0x00, 0x00, 0x05, 0x3b,
+  0x05, 0xe7, 0x10, 0x06, 0x03, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x46,
+  0xff, 0xe3, 0x05, 0x3b, 0x05, 0xca, 0x10, 0x06, 0x01, 0x73, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x15, 0xfe, 0xce, 0x04, 0x20, 0x06, 0x44, 0x00, 0x55,
+  0x00, 0x00, 0x01, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x37, 0x33, 0x06, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x32, 0x36, 0x33, 0x32, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x17, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x10,
+  0x03, 0x06, 0x21, 0x22, 0x27, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x27, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x01, 0x66, 0x56, 0x70, 0x6d, 0x5f, 0x1f, 0x2c,
+  0x49, 0x16, 0x73, 0x87, 0x17, 0x53, 0x20, 0x16, 0x89, 0x1f, 0x1f, 0x1f,
+  0x20, 0x75, 0x27, 0x4c, 0x0f, 0x40, 0x0f, 0x40, 0x53, 0x16, 0x36, 0x75,
+  0x77, 0x61, 0x02, 0x40, 0x2c, 0xe2, 0x5b, 0x21, 0x9f, 0xd9, 0xfe, 0xf4,
+  0x67, 0x58, 0x01, 0x04, 0x0e, 0x16, 0x20, 0x2b, 0x3e, 0x15, 0x43, 0x4f,
+  0x49, 0x36, 0x45, 0x10, 0x0a, 0x16, 0x1b, 0x3a, 0x89, 0x69, 0x43, 0x22,
+  0x23, 0x0f, 0x12, 0x1e, 0x5d, 0x9e, 0x61, 0x54, 0x02, 0xa8, 0x8a, 0x09,
+  0x79, 0x6a, 0x8d, 0x2e, 0x23, 0x2e, 0x0b, 0x0b, 0x23, 0x19, 0x21, 0xd3,
+  0x3c, 0x23, 0x21, 0x05, 0x06, 0x16, 0x18, 0x3b, 0x47, 0xa3, 0x81, 0x84,
+  0x42, 0x03, 0x0e, 0x98, 0x77, 0x80, 0xfe, 0xeb, 0xfe, 0xfa, 0xc8, 0x18,
+  0x87, 0x1c, 0x2c, 0x10, 0x18, 0x3c, 0x24, 0x3d, 0x2c, 0x23, 0x23, 0x16,
+  0x77, 0x55, 0x19, 0x1e, 0x74, 0x4b, 0x79, 0x79, 0x98, 0x56, 0x3f, 0x40,
+  0x21, 0x6a, 0x2e, 0x00, 0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x01, 0xd6,
+  0x04, 0x60, 0x00, 0x0d, 0x00, 0x00, 0x21, 0x11, 0x34, 0x27, 0x26, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x01, 0x2d, 0x1f, 0x20,
+  0x62, 0x4f, 0x63, 0xa4, 0x48, 0x4a, 0x02, 0xd5, 0x91, 0x2e, 0x30, 0x9c,
+  0x60, 0x62, 0xd4, 0xfd, 0x36, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x2e, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde, 0x07, 0x6d, 0x10, 0x06,
+  0x00, 0x87, 0x00, 0x00, 0x00, 0x03, 0x00, 0x52, 0x00, 0x00, 0x05, 0x49,
+  0x06, 0x2e, 0x00, 0x32, 0x00, 0x3f, 0x00, 0x52, 0x00, 0x00, 0x01, 0x17,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x29, 0x01, 0x37, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x35, 0x11, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x14,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x3f, 0x01, 0x17, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x05, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23,
+  0x11, 0x14, 0x03, 0x05, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x03, 0xff, 0x07,
+  0x98, 0x55, 0x56, 0x6d, 0xc6, 0xfe, 0xd4, 0xfd, 0xb4, 0x36, 0x86, 0x79,
+  0x33, 0x1a, 0x1c, 0xa6, 0x75, 0x45, 0x0a, 0x0b, 0x11, 0x1e, 0x27, 0x17,
+  0x0f, 0x22, 0x65, 0x90, 0xee, 0x89, 0x08, 0xb2, 0x83, 0x80, 0x2c, 0x41,
+  0x5c, 0x44, 0xfe, 0xaf, 0xb8, 0x66, 0x4a, 0x3e, 0x26, 0x5b, 0x61, 0x79,
+  0xfc, 0x01, 0x39, 0x7b, 0x61, 0x5d, 0x2c, 0x4f, 0x4e, 0x29, 0x4c, 0x45,
+  0x6a, 0x44, 0x41, 0x1c, 0x2a, 0x4f, 0x03, 0x54, 0x10, 0x61, 0x5e, 0x80,
+  0xae, 0x7d, 0xda, 0x75, 0x86, 0x3b, 0x8b, 0x84, 0xd3, 0x02, 0x83, 0x82,
+  0x49, 0x4d, 0x0b, 0x3d, 0x05, 0x2c, 0x0d, 0x33, 0x13, 0x21, 0x16, 0x23,
+  0x56, 0x86, 0x74, 0x9f, 0x27, 0x49, 0x40, 0x1c, 0x1f, 0x33, 0x48, 0x6c,
+  0x9a, 0x68, 0x4a, 0x33, 0x70, 0x52, 0x81, 0x75, 0x46, 0x2a, 0x1b, 0x18,
+  0xfd, 0xc2, 0x1d, 0xfd, 0x28, 0x02, 0x1a, 0x1d, 0x30, 0x58, 0xb9, 0x72,
+  0x56, 0x2c, 0x18, 0x18, 0x06, 0xec, 0x6e, 0xce, 0x00, 0x01, 0x00, 0x75,
+  0xff, 0xe8, 0x04, 0xb2, 0x05, 0xf0, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x17,
+  0x36, 0x25, 0x1e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x37, 0x15, 0x06, 0x07,
+  0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x1e, 0x01,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x37, 0x22, 0x07, 0x06, 0x15, 0x10, 0x17, 0x16, 0x25, 0x37, 0x15,
+  0x06, 0x07, 0x06, 0x24, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x02, 0x10, 0x40, 0x89, 0x01, 0x11, 0x0a, 0x24, 0x0a, 0x0f, 0x0e, 0x14,
+  0x5f, 0x7e, 0x5e, 0x35, 0x69, 0x25, 0x1b, 0x15, 0x0a, 0x03, 0x0d, 0x0d,
+  0x0e, 0x3f, 0x67, 0xb3, 0x17, 0x51, 0x42, 0x1f, 0x29, 0x1e, 0x11, 0x70,
+  0x42, 0x5f, 0x9f, 0xc8, 0x01, 0x46, 0xe8, 0xc2, 0x5b, 0xad, 0xfe, 0xb4,
+  0x75, 0x53, 0x2a, 0x2b, 0x55, 0xac, 0x05, 0x35, 0x23, 0x6c, 0x72, 0x1c,
+  0x77, 0x1f, 0x28, 0x0f, 0x16, 0x21, 0x2e, 0x44, 0x0e, 0x24, 0xbb, 0x0d,
+  0x22, 0x1c, 0x39, 0x42, 0x47, 0x16, 0x33, 0x32, 0x4b, 0x25, 0x8d, 0x46,
+  0x6e, 0x1f, 0x23, 0x16, 0x49, 0x23, 0x74, 0x33, 0xb9, 0x74, 0x52, 0x5d,
+  0x86, 0xda, 0xfe, 0xb9, 0xb0, 0xe1, 0x26, 0x7f, 0x39, 0x88, 0x4b, 0x28,
+  0x56, 0x82, 0x5c, 0x8f, 0x91, 0xb5, 0xd1, 0xbd, 0x93, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x70, 0xff, 0xe7, 0x05, 0xb7, 0x05, 0x2d, 0x00, 0x1a,
+  0x00, 0x29, 0x00, 0x00, 0x25, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
+  0x33, 0x06, 0x07, 0x06, 0x20, 0x24, 0x02, 0x35, 0x34, 0x12, 0x24, 0x33,
+  0x32, 0x04, 0x12, 0x15, 0x21, 0x22, 0x15, 0x35, 0x14, 0x33, 0x21, 0x32,
+  0x35, 0x11, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x01, 0x68,
+  0x3c, 0x54, 0x87, 0x01, 0x29, 0x89, 0x5f, 0x46, 0x63, 0x55, 0x80, 0xa1,
+  0xfe, 0xa1, 0xfe, 0xbf, 0xb3, 0xb5, 0x01, 0x43, 0xac, 0xaa, 0x01, 0x43,
+  0xb5, 0xfb, 0xc3, 0x11, 0x11, 0x03, 0x35, 0x12, 0x3f, 0x56, 0x88, 0x8f,
+  0x90, 0x89, 0x56, 0x3d, 0xe4, 0x4d, 0x33, 0x54, 0x54, 0x3c, 0x60, 0x78,
+  0x47, 0x5a, 0xb3, 0x01, 0x41, 0xaf, 0xb0, 0x01, 0x45, 0xae, 0xae, 0xfe,
+  0xbb, 0xb0, 0x13, 0x49, 0x13, 0x13, 0x01, 0x70, 0x50, 0x33, 0x52, 0x51,
+  0x34, 0x4f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x4e, 0xff, 0xe3, 0x03, 0xf0,
+  0x04, 0x44, 0x00, 0x1c, 0x00, 0x25, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x00, 0x33, 0x20, 0x11, 0x14, 0x07,
+  0x06, 0x37, 0x36, 0x35, 0x34, 0x23, 0x22, 0x06, 0x03, 0x20, 0x01, 0x0e,
+  0x04, 0x1f, 0x35, 0x8e, 0x69, 0x33, 0x5c, 0x15, 0x7a, 0x24, 0x86, 0x5e,
+  0xfe, 0x8d, 0x64, 0x46, 0x0e, 0x2c, 0x01, 0x30, 0xd8, 0x01, 0x60, 0xb8,
+  0xbd, 0x61, 0x64, 0xcc, 0x78, 0xa8, 0x33, 0x01, 0x21, 0x01, 0x98, 0x26,
+  0x22, 0x5e, 0x3e, 0x6e, 0x23, 0x3f, 0x51, 0x7f, 0x59, 0x3e, 0x99, 0x6b,
+  0x9b, 0x44, 0x4d, 0xfd, 0x01, 0x34, 0xfe, 0xeb, 0xc7, 0x67, 0x69, 0xe0,
+  0x4d, 0x71, 0xab, 0xcc, 0xfe, 0xed, 0x00, 0x00, 0x00, 0x01, 0x00, 0x91,
+  0xff, 0xe3, 0x04, 0x13, 0x05, 0xf0, 0x00, 0x45, 0x00, 0x00, 0x01, 0x17,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x3f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x17, 0x16, 0x33, 0x15, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x03, 0xbd, 0x55, 0x1c,
+  0x0e, 0xa0, 0xe2, 0x81, 0x5e, 0x62, 0x3e, 0x55, 0x78, 0x62, 0xa1, 0x01,
+  0x61, 0x37, 0x47, 0x59, 0x6f, 0xd9, 0x7a, 0x4c, 0x2e, 0x29, 0x2d, 0x1e,
+  0x25, 0x15, 0x0c, 0x1a, 0x17, 0x21, 0x27, 0x5c, 0x57, 0x3a, 0x57, 0x48,
+  0x2a, 0x51, 0x56, 0x70, 0x9a, 0x6f, 0x6b, 0x34, 0x62, 0x57, 0x51, 0xae,
+  0x74, 0x6a, 0x38, 0x0b, 0x01, 0x49, 0x68, 0x41, 0x11, 0xac, 0x22, 0x25,
+  0x40, 0x5f, 0xa9, 0xae, 0x8a, 0x6c, 0x18, 0x15, 0x24, 0x3d, 0x50, 0x94,
+  0x8b, 0x63, 0x7a, 0x53, 0x32, 0x56, 0x4e, 0x2d, 0x32, 0x16, 0x0e, 0x21,
+  0x1c, 0x24, 0x2b, 0x1f, 0x25, 0x24, 0x2b, 0x40, 0x65, 0x97, 0x7d, 0x4e,
+  0x30, 0x17, 0x1a, 0x36, 0x1e, 0x1d, 0x39, 0x6e, 0x99, 0xa6, 0x61, 0x5b,
+  0x75, 0x3e, 0x5f, 0x00, 0x00, 0x01, 0x00, 0x4b, 0xff, 0xdf, 0x05, 0x76,
+  0x06, 0x0b, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x17, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x11, 0x21, 0x07, 0x23, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x3d,
+  0x01, 0x21, 0x37, 0x21, 0x11, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x1f, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x21, 0x32, 0x17, 0x37, 0x15, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x05, 0x56, 0x20, 0x50, 0x23, 0x34, 0x23, 0x31, 0xcb, 0x39, 0x01, 0x1d,
+  0x37, 0xe6, 0x25, 0x26, 0x46, 0xb2, 0xf1, 0x73, 0x56, 0x2e, 0x1b, 0x18,
+  0x29, 0x1c, 0x0c, 0x10, 0x14, 0x11, 0x18, 0x3c, 0x54, 0x61, 0x6f, 0x38,
+  0x1a, 0x1e, 0xfe, 0xbb, 0x23, 0x01, 0x22, 0x57, 0x38, 0xae, 0x63, 0x40,
+  0x06, 0x12, 0x16, 0x20, 0x17, 0x22, 0x20, 0x1c, 0x6c, 0x96, 0x01, 0x15,
+  0x20, 0x3c, 0x8a, 0xa9, 0x80, 0x2c, 0x13, 0x2c, 0x1d, 0x05, 0xf2, 0x13,
+  0xa3, 0x4b, 0x14, 0x3d, 0x19, 0xfd, 0xdc, 0x44, 0x63, 0x98, 0x84, 0x80,
+  0x4b, 0xca, 0x5f, 0x34, 0x42, 0x28, 0x1f, 0x1a, 0x0b, 0x14, 0x30, 0x33,
+  0x1a, 0x42, 0x7b, 0x3e, 0x63, 0x65, 0x82, 0xb9, 0x44, 0x02, 0x49, 0x18,
+  0x6e, 0x46, 0x54, 0x3d, 0x1f, 0x49, 0x2c, 0x1a, 0x1f, 0x1f, 0x1f, 0x46,
+  0xb4, 0x77, 0xa7, 0x08, 0x37, 0x4b, 0x2e, 0x16, 0x09, 0x30, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xba, 0x05, 0xd5, 0x00, 0x09,
+  0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33,
+  0x03, 0xb9, 0xfc, 0xfc, 0x02, 0x4e, 0xfd, 0xeb, 0x02, 0x15, 0xb6, 0xaa,
+  0x01, 0xb8, 0xaa, 0x02, 0xc9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x33,
+  0xff, 0xc7, 0x07, 0x6f, 0x06, 0x02, 0x00, 0x6b, 0x00, 0x00, 0x01, 0x11,
+  0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x17, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x11, 0x34, 0x02, 0x37, 0x06,
+  0x03, 0x02, 0x03, 0x07, 0x27, 0x02, 0x03, 0x26, 0x27, 0x26, 0x27, 0x11,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x36, 0x35, 0x11,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x33, 0x16, 0x13, 0x12, 0x13, 0x17, 0x12, 0x37, 0x12,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x06, 0x28,
+  0x14, 0x14, 0x27, 0x18, 0x1a, 0x2f, 0x24, 0x2a, 0x23, 0x26, 0x23, 0x3f,
+  0x56, 0x8f, 0x33, 0x32, 0x10, 0x05, 0x07, 0x05, 0x9d, 0x6d, 0x6e, 0x32,
+  0x57, 0x12, 0x35, 0x5c, 0x32, 0x35, 0x38, 0x3f, 0x2e, 0x29, 0x55, 0x48,
+  0x5a, 0x46, 0x3d, 0x26, 0x1a, 0x16, 0x1f, 0x32, 0x1a, 0x19, 0x3a, 0x27,
+  0x60, 0x1e, 0x19, 0x41, 0x5e, 0x40, 0x36, 0x37, 0x12, 0x2a, 0x0e, 0x15,
+  0x19, 0x21, 0x56, 0x6c, 0x81, 0x5f, 0x06, 0x94, 0x65, 0x65, 0x2e, 0x0a,
+  0x4b, 0x71, 0x73, 0x8d, 0x88, 0xa0, 0x3c, 0x23, 0x1a, 0x10, 0x1b, 0x28,
+  0x20, 0x07, 0x14, 0x06, 0x0a, 0x04, 0x16, 0x18, 0x1a, 0x17, 0x26, 0x05,
+  0x1d, 0xfd, 0x35, 0xdc, 0x80, 0x81, 0x2f, 0x16, 0x2c, 0x2c, 0x40, 0x21,
+  0x3b, 0x44, 0x61, 0x39, 0x37, 0x9e, 0x54, 0x02, 0x01, 0x1e, 0x01, 0x91,
+  0x1f, 0xb3, 0xfe, 0xc4, 0xfe, 0xc9, 0xfe, 0x56, 0x4d, 0x0f, 0x01, 0xe6,
+  0x01, 0x3b, 0xa9, 0x6e, 0x77, 0x46, 0xfe, 0x0f, 0xed, 0xbb, 0xb3, 0x5e,
+  0x4f, 0x3f, 0x2f, 0x2c, 0x25, 0x21, 0x18, 0x3b, 0x3e, 0x6a, 0x79, 0x74,
+  0x9f, 0x02, 0xd6, 0x58, 0x3c, 0x3b, 0x7d, 0x03, 0x66, 0x3f, 0x45, 0x27,
+  0x5f, 0x6e, 0xa5, 0xfe, 0xfa, 0xfe, 0xf4, 0xfe, 0xb1, 0x0b, 0x01, 0x48,
+  0xf4, 0x01, 0x02, 0x97, 0x98, 0x27, 0x1d, 0x1d, 0x27, 0x10, 0x23, 0x09,
+  0x16, 0x0d, 0x1d, 0x04, 0x18, 0x16, 0x2e, 0x00, 0x00, 0x02, 0x00, 0x5d,
+  0xff, 0xe7, 0x02, 0xf6, 0x03, 0x29, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x34, 0x26, 0x23, 0x22, 0x02, 0x15, 0x14, 0x16, 0x33, 0x32, 0x12,
+  0x03, 0x32, 0x16, 0x15, 0x14, 0x02, 0x23, 0x22, 0x26, 0x35, 0x34, 0x12,
+  0x02, 0x65, 0x4e, 0x47, 0x63, 0x7f, 0x4e, 0x48, 0x62, 0x7f, 0xaf, 0x89,
+  0xb7, 0xc7, 0x92, 0x89, 0xb6, 0xc6, 0x01, 0xf7, 0x74, 0x7d, 0xfe, 0xfe,
+  0xcf, 0x74, 0x7b, 0x01, 0x04, 0x01, 0xfd, 0xd8, 0xa3, 0xc6, 0xfe, 0xff,
+  0xd8, 0xa3, 0xc6, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5c,
+  0xff, 0xe3, 0x05, 0x21, 0x05, 0xf0, 0x00, 0x34, 0x00, 0x00, 0x09, 0x01,
+  0x16, 0x15, 0x14, 0x07, 0x34, 0x27, 0x01, 0x07, 0x06, 0x1f, 0x01, 0x16,
+  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x26,
+  0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x37, 0x14, 0x17, 0x01, 0x13,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x14, 0x1f, 0x01, 0x16, 0x15, 0x14, 0x07,
+  0x34, 0x2f, 0x01, 0x03, 0x64, 0x01, 0x63, 0x59, 0x81, 0x2d, 0xfd, 0x48,
+  0x8c, 0x37, 0x3b, 0x9b, 0x5a, 0x37, 0x4e, 0x3e, 0xdc, 0xb0, 0x2a, 0x58,
+  0x30, 0x7e, 0x8b, 0xd9, 0x59, 0x81, 0x2d, 0x02, 0x2e, 0xfd, 0x68, 0x59,
+  0x81, 0x2d, 0xa4, 0x59, 0x81, 0x2d, 0x11, 0x02, 0xd0, 0xfe, 0x75, 0x63,
+  0x31, 0x82, 0x4c, 0x53, 0x32, 0x03, 0x05, 0x9c, 0x3f, 0x42, 0xac, 0x64,
+  0xd6, 0x2c, 0x3e, 0x38, 0x3f, 0x5d, 0x1d, 0x2f, 0x63, 0x36, 0xbc, 0x8d,
+  0x9b, 0xf1, 0x63, 0x31, 0x82, 0x4c, 0x53, 0x32, 0xfd, 0x96, 0x01, 0x19,
+  0x74, 0x63, 0x31, 0x82, 0x4c, 0x53, 0x32, 0xb6, 0x63, 0x31, 0x82, 0x4c,
+  0x53, 0x32, 0x12, 0x00, 0x00, 0x01, 0xff, 0xfb, 0xff, 0xe3, 0x04, 0xb4,
+  0x05, 0xf1, 0x00, 0x30, 0x00, 0x00, 0x01, 0x11, 0x33, 0x16, 0x15, 0x14,
+  0x0f, 0x01, 0x0e, 0x01, 0x23, 0x21, 0x22, 0x2e, 0x01, 0x35, 0x34, 0x3f,
+  0x01, 0x3e, 0x01, 0x33, 0x21, 0x11, 0x34, 0x27, 0x2e, 0x01, 0x23, 0x21,
+  0x22, 0x2e, 0x03, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x1e, 0x02,
+  0x33, 0x21, 0x32, 0x16, 0x04, 0x45, 0x47, 0x27, 0x1b, 0x79, 0x0f, 0x12,
+  0x1f, 0xfc, 0x5b, 0x13, 0x16, 0x15, 0x1e, 0x78, 0x0f, 0x12, 0x21, 0x03,
+  0x2a, 0x12, 0x12, 0x22, 0x39, 0xfd, 0xbf, 0x35, 0x30, 0x41, 0x1a, 0x14,
+  0x04, 0x0e, 0x12, 0x17, 0x0b, 0x0a, 0x26, 0x1c, 0x19, 0x02, 0x8e, 0x50,
+  0x52, 0x04, 0xb6, 0xfc, 0x23, 0x04, 0x24, 0x14, 0x1b, 0x87, 0x12, 0x06,
+  0x02, 0x14, 0x12, 0x10, 0x22, 0x86, 0x10, 0x06, 0x03, 0x78, 0x32, 0x0d,
+  0x10, 0x06, 0x04, 0x18, 0x31, 0x5b, 0x47, 0x28, 0x20, 0x14, 0x20, 0x1e,
+  0x1f, 0x04, 0x57, 0x00, 0x00, 0x01, 0x00, 0x18, 0xff, 0xb8, 0x02, 0xee,
+  0x05, 0xf0, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x21, 0x32, 0x17, 0x16, 0x14,
+  0x0e, 0x01, 0x07, 0x1e, 0x01, 0x12, 0x10, 0x07, 0x06, 0x23, 0x22, 0x26,
+  0x2f, 0x01, 0x0e, 0x01, 0x23, 0x21, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x3e,
+  0x01, 0x33, 0x21, 0x11, 0x21, 0x22, 0x26, 0x35, 0x34, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x01, 0x32, 0x01, 0x2e, 0x62, 0x1b, 0x11, 0x0b, 0x2b,
+  0x22, 0x02, 0x02, 0x37, 0x09, 0x16, 0x28, 0x14, 0x10, 0x06, 0x0c, 0x5a,
+  0x10, 0x28, 0xfe, 0x95, 0x3f, 0x1f, 0x78, 0x0f, 0x12, 0x20, 0x01, 0x5e,
+  0xfe, 0xdb, 0x62, 0x40, 0x12, 0x29, 0x0a, 0x15, 0x2a, 0x0e, 0x05, 0x8f,
+  0x37, 0x23, 0x2a, 0x28, 0x2f, 0x0a, 0x1a, 0x82, 0xfd, 0x24, 0xfe, 0xfb,
+  0x22, 0x53, 0x1e, 0x1f, 0x61, 0x65, 0x0e, 0x28, 0x10, 0x21, 0x87, 0x10,
+  0x06, 0x03, 0xcd, 0x71, 0x7e, 0x42, 0x19, 0x1e, 0x3b, 0x06, 0x02, 0x00,
+  0x00, 0x01, 0x00, 0x4d, 0xff, 0xb8, 0x04, 0x41, 0x05, 0xf0, 0x00, 0x26,
+  0x00, 0x00, 0x01, 0x21, 0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32,
+  0x17, 0x1e, 0x02, 0x33, 0x21, 0x32, 0x1e, 0x02, 0x15, 0x14, 0x0e, 0x01,
+  0x07, 0x1e, 0x01, 0x17, 0x12, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26,
+  0x27, 0x26, 0x35, 0x03, 0xa3, 0xfd, 0x4c, 0x62, 0x40, 0x04, 0x0e, 0x12,
+  0x17, 0x0b, 0x0b, 0x25, 0x1c, 0x19, 0x02, 0xbd, 0x2f, 0x40, 0x18, 0x05,
+  0x0b, 0x2b, 0x21, 0x02, 0x01, 0x04, 0x33, 0x09, 0x15, 0x29, 0x15, 0x10,
+  0x0b, 0x0a, 0x04, 0xa6, 0x71, 0x7e, 0x28, 0x1f, 0x14, 0x1f, 0x1e, 0x20,
+  0x04, 0x1f, 0x30, 0x1a, 0x0b, 0x10, 0x28, 0x2f, 0x0a, 0x1a, 0x82, 0x26,
+  0xfd, 0x4a, 0x93, 0x73, 0x21, 0x53, 0x27, 0x44, 0x51, 0x49, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x3f, 0x00, 0x00, 0x02, 0x8f, 0x06, 0x14, 0x00, 0x0b,
+  0x00, 0x15, 0x00, 0x00, 0x13, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x01, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23,
+  0x35, 0x21, 0xa9, 0x65, 0x49, 0x47, 0x64, 0x64, 0x47, 0x49, 0x65, 0x01,
+  0x5d, 0x88, 0xfd, 0xb1, 0x88, 0x88, 0x01, 0xc7, 0x05, 0x54, 0x51, 0x6f,
+  0x6f, 0x51, 0x4f, 0x6f, 0x6e, 0xfb, 0x75, 0x79, 0x79, 0x03, 0x35, 0x79,
+  0x00, 0x02, 0x00, 0x51, 0xff, 0xd5, 0x06, 0x97, 0x05, 0x3b, 0x00, 0x09,
+  0x00, 0x1b, 0x00, 0x00, 0x12, 0x10, 0x00, 0x33, 0x32, 0x00, 0x10, 0x00,
+  0x23, 0x22, 0x05, 0x01, 0x15, 0x07, 0x1e, 0x01, 0x15, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x04, 0xe5, 0x01, 0x27, 0xfe,
+  0xfe, 0x01, 0x28, 0xfe, 0xd8, 0xfe, 0xfe, 0x03, 0x85, 0x01, 0x06, 0xd7,
+  0x01, 0x02, 0xfe, 0x85, 0xfe, 0xc2, 0xfe, 0xc2, 0xfe, 0x85, 0x01, 0x7b,
+  0x01, 0x3e, 0xea, 0x01, 0x4e, 0x03, 0x65, 0xfe, 0x48, 0xfe, 0xfd, 0x01,
+  0x03, 0x01, 0xb8, 0x01, 0x01, 0xc2, 0x01, 0x0a, 0xf4, 0xdd, 0x21, 0x23,
+  0x10, 0xfe, 0xc5, 0xfe, 0x87, 0x01, 0x79, 0x01, 0x3b, 0x01, 0x3a, 0x01,
+  0x78, 0xd1, 0x00, 0x00, 0x00, 0x04, 0x00, 0x87, 0x00, 0x00, 0x08, 0x5e,
+  0x04, 0x60, 0x00, 0x09, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x20, 0x00, 0x00,
+  0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x01, 0x03,
+  0x21, 0x03, 0x33, 0x01, 0x23, 0x27, 0x21, 0x07, 0x23, 0x01, 0x33, 0x1b,
+  0x01, 0x33, 0x09, 0x01, 0x23, 0x0b, 0x01, 0x23, 0x01, 0x88, 0x02, 0x43,
+  0xfe, 0x45, 0x01, 0x8f, 0xfe, 0x71, 0x88, 0x03, 0x29, 0xa3, 0x01, 0x46,
+  0xe6, 0x87, 0x01, 0x52, 0x7c, 0x51, 0xfe, 0x70, 0x51, 0x7e, 0x03, 0x74,
+  0x81, 0xdc, 0xde, 0x81, 0xfe, 0xe3, 0x01, 0x30, 0x82, 0xf9, 0xfb, 0x82,
+  0x01, 0x3d, 0x04, 0x60, 0x80, 0xfe, 0xb6, 0x7f, 0xfd, 0xe9, 0x03, 0x08,
+  0xfe, 0x43, 0x02, 0x35, 0xfc, 0x80, 0xe6, 0xe6, 0x03, 0x80, 0xfe, 0xb3,
+  0x01, 0x4d, 0xfe, 0x52, 0xfe, 0x2e, 0x01, 0x7d, 0xfe, 0x83, 0x01, 0xde,
+  0x00, 0x03, 0x00, 0x20, 0xff, 0xf0, 0x04, 0xee, 0x04, 0x60, 0x00, 0x0f,
+  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x25, 0x35, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x11, 0x23, 0x11, 0x14, 0x16, 0x17, 0x16, 0x32, 0x03, 0x16,
+  0x33, 0x32, 0x37, 0x15, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23,
+  0x11, 0x21, 0x11, 0x23, 0x22, 0x06, 0x15, 0x23, 0x34, 0x36, 0x33, 0x21,
+  0x15, 0x23, 0x11, 0x14, 0x01, 0x33, 0x11, 0x23, 0x04, 0x94, 0x7c, 0x27,
+  0x17, 0x08, 0x0d, 0x79, 0x15, 0x12, 0x33, 0xcb, 0x50, 0x07, 0x61, 0x24,
+  0x41, 0x69, 0x76, 0xe4, 0x26, 0x13, 0x96, 0xfe, 0xd3, 0x37, 0x51, 0x2d,
+  0x5a, 0x67, 0x95, 0x03, 0xa7, 0xa4, 0xfd, 0x6a, 0x79, 0x79, 0x5a, 0x34,
+  0x40, 0x27, 0x21, 0x38, 0xa2, 0x02, 0x0c, 0xfd, 0xd6, 0xa6, 0x7a, 0x19,
+  0x45, 0x01, 0x42, 0xaf, 0x0a, 0xf1, 0x10, 0xca, 0x62, 0xfd, 0x01, 0xe3,
+  0xfc, 0x04, 0x03, 0xfc, 0x4c, 0x73, 0xa8, 0x7b, 0x64, 0xfe, 0x12, 0x59,
+  0xfe, 0xaf, 0x03, 0x98, 0x00, 0x02, 0x00, 0x00, 0xfe, 0x73, 0x04, 0xd1,
+  0x04, 0x7b, 0x00, 0x08, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x16, 0x13, 0x12,
+  0x11, 0x33, 0x10, 0x03, 0x02, 0x03, 0x10, 0x03, 0x02, 0x23, 0x22, 0x07,
+  0x23, 0x34, 0x37, 0x36, 0x33, 0x20, 0x13, 0x12, 0x13, 0x33, 0x02, 0x03,
+  0x02, 0x11, 0x01, 0xa8, 0x9c, 0x4d, 0x3e, 0x75, 0x3e, 0x61, 0x2f, 0x3f,
+  0x7e, 0xb1, 0x98, 0x16, 0x5a, 0x40, 0x49, 0xdc, 0x01, 0x89, 0x7b, 0x63,
+  0x90, 0x75, 0xb7, 0x3c, 0x3f, 0x04, 0x1d, 0xc1, 0xfe, 0x5c, 0xfe, 0xa7,
+  0xfe, 0x78, 0x01, 0x9f, 0x01, 0x42, 0x01, 0xfd, 0xfa, 0xbe, 0x02, 0x1b,
+  0x01, 0x2a, 0x02, 0x57, 0x9f, 0x62, 0x4f, 0x5a, 0xfd, 0x3d, 0x01, 0x9a,
+  0x01, 0x0e, 0xfe, 0x8f, 0xfe, 0xc9, 0xfe, 0xbe, 0xfd, 0xfd, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xac, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x25, 0x15, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0x0e, 0xb6, 0x02, 0xe7, 0xfd, 0x73, 0xfe, 0x96, 0x05,
+  0x71, 0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0x8f, 0x05, 0xd5, 0x00,
+  0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x68, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x01, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x04, 0x58,
+  0xb5, 0xfc, 0x02, 0xb6, 0x03, 0xa2, 0xfe, 0x97, 0xfe, 0x21, 0xfe, 0x96,
+  0x04, 0xb2, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x0d,
+  0xfa, 0x8f, 0x05, 0x71, 0xfa, 0x8f, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x16,
+  0xfe, 0x77, 0x05, 0xb2, 0x05, 0xc1, 0x00, 0x05, 0x00, 0x11, 0x00, 0x00,
+  0x09, 0x02, 0x23, 0x09, 0x02, 0x15, 0x21, 0x09, 0x01, 0x21, 0x15, 0x21,
+  0x35, 0x09, 0x01, 0x35, 0x01, 0x7c, 0x02, 0xc1, 0xfd, 0x53, 0xea, 0x02,
+  0xad, 0xfd, 0x3f, 0x05, 0x08, 0xfc, 0x7d, 0x02, 0xad, 0xfd, 0x3f, 0x03,
+  0xae, 0xfa, 0x65, 0x02, 0xba, 0xfd, 0x62, 0xfe, 0xda, 0x03, 0x59, 0x03,
+  0x2a, 0xfc, 0xd6, 0xfc, 0xa7, 0x06, 0xe7, 0x64, 0xfc, 0xd6, 0xfc, 0xa7,
+  0x63, 0x63, 0x03, 0x53, 0x03, 0x15, 0x7f, 0x00, 0x00, 0x01, 0x00, 0x92,
+  0xff, 0xe3, 0x05, 0x29, 0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x12, 0x11, 0x10,
+  0x02, 0x23, 0x22, 0x06, 0x01, 0x47, 0x01, 0x29, 0xfe, 0x23, 0x69, 0xfe,
+  0x90, 0x01, 0x3b, 0x01, 0x63, 0xfe, 0x9d, 0xfe, 0xc5, 0x84, 0xec, 0x64,
+  0x65, 0xe2, 0x7d, 0xf7, 0xf8, 0xf8, 0xf7, 0x60, 0x97, 0x04, 0xfe, 0xfe,
+  0x6f, 0xa6, 0x02, 0x81, 0x53, 0x55, 0xfe, 0x67, 0xfe, 0x93, 0xfe, 0x92,
+  0xfe, 0x67, 0x48, 0x46, 0xd7, 0x5f, 0x60, 0x01, 0x32, 0x01, 0x2f, 0x01,
+  0x2e, 0x01, 0x32, 0x25, 0x00, 0x01, 0x00, 0x07, 0x00, 0x00, 0x03, 0x4c,
+  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x35, 0x21,
+  0x03, 0x4b, 0xb5, 0xfd, 0x71, 0x03, 0x44, 0x05, 0x2b, 0xaa, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x06, 0x00, 0x00, 0x03, 0x4b, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x03, 0x4a, 0xfc, 0xbc,
+  0x02, 0x8f, 0x05, 0xd5, 0xfa, 0x2b, 0xaa, 0x05, 0x2b, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xfc, 0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x00, 0x21, 0x23, 0x09, 0x01, 0x23, 0x01, 0x11, 0x33, 0x11, 0x04,
+  0x6a, 0xc4, 0xfe, 0x8c, 0xfe, 0x8e, 0xc4, 0x01, 0xdc, 0xb6, 0x02, 0x66,
+  0xfd, 0x9a, 0x03, 0x0e, 0x02, 0xc7, 0xfd, 0x39, 0x00, 0x04, 0x00, 0x4e,
+  0x00, 0x00, 0x05, 0xa9, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x13, 0x00, 0x17,
+  0x00, 0x22, 0x00, 0x00, 0x01, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x02,
+  0x00, 0x29, 0x01, 0x01, 0x05, 0x03, 0x33, 0x32, 0x37, 0x13, 0x26, 0x23,
+  0x21, 0x03, 0x33, 0x13, 0x05, 0x03, 0x36, 0x37, 0x36, 0x13, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x03, 0x23, 0x01, 0x86, 0x98, 0x68, 0x15, 0x43, 0xfe,
+  0x52, 0xfe, 0x7b, 0xfe, 0x30, 0x01, 0x05, 0x01, 0x59, 0xe2, 0x59, 0xdd,
+  0x9b, 0xcc, 0x85, 0xdd, 0xfe, 0x97, 0xe2, 0xb6, 0xe2, 0x02, 0x6a, 0xb8,
+  0x18, 0x17, 0xbb, 0x3a, 0x12, 0x5c, 0x10, 0x05, 0xd5, 0xb5, 0x7c, 0xdf,
+  0x63, 0x76, 0xfe, 0x7e, 0xfe, 0x96, 0x05, 0xd5, 0x64, 0xfa, 0xf3, 0x41,
+  0x04, 0x8b, 0x41, 0xfa, 0xf3, 0x05, 0x0d, 0x78, 0xfb, 0xe3, 0x10, 0x13,
+  0x9d, 0x01, 0x50, 0x66, 0x55, 0xc2, 0x6d, 0x13, 0x00, 0x04, 0x00, 0x51,
+  0xff, 0xe3, 0x05, 0x1c, 0x06, 0x14, 0x00, 0x0a, 0x00, 0x1f, 0x00, 0x23,
+  0x00, 0x32, 0x00, 0x00, 0x13, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x13,
+  0x06, 0x07, 0x06, 0x01, 0x21, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22, 0x02,
+  0x35, 0x34, 0x37, 0x36, 0x00, 0x33, 0x32, 0x17, 0x16, 0x17, 0x13, 0x21,
+  0x07, 0x03, 0x33, 0x13, 0x01, 0x03, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0xd0, 0x1c, 0x26, 0x1d, 0x30,
+  0x9e, 0x3c, 0x32, 0x6b, 0x03, 0x1f, 0xfe, 0xd3, 0x1e, 0x46, 0x58, 0x58,
+  0x70, 0xb7, 0x8e, 0x1f, 0x1f, 0x01, 0x1e, 0xb7, 0x70, 0x47, 0x47, 0x23,
+  0x6a, 0x01, 0x2d, 0xe5, 0xee, 0x78, 0xef, 0xfd, 0x7a, 0xab, 0x16, 0x17,
+  0x95, 0x6b, 0x6c, 0x1c, 0x1c, 0x33, 0x31, 0x95, 0x17, 0x02, 0x74, 0x9e,
+  0x4b, 0x73, 0x4f, 0x3d, 0x20, 0x03, 0x86, 0x20, 0x3d, 0x82, 0xfc, 0xed,
+  0xa8, 0x64, 0x30, 0x31, 0x01, 0x0c, 0x94, 0x50, 0xb2, 0xb2, 0x01, 0x44,
+  0x31, 0x30, 0x64, 0x02, 0x5e, 0x64, 0xfa, 0xac, 0x05, 0x54, 0xfe, 0x64,
+  0xfc, 0x36, 0x03, 0x82, 0x82, 0x9f, 0x9e, 0x4a, 0x74, 0x68, 0x69, 0x00,
+  0x00, 0x03, 0x00, 0x51, 0xff, 0xe3, 0x04, 0x1e, 0x04, 0x7b, 0x00, 0x0a,
+  0x00, 0x28, 0x00, 0x32, 0x00, 0x00, 0x13, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x17, 0x13, 0x06, 0x07, 0x06, 0x13, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x12,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x0f, 0x01, 0x21, 0x37,
+  0x21, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0xc4, 0x0b, 0x47,
+  0x13, 0x1b, 0x91, 0x22, 0x1f, 0x90, 0x97, 0x40, 0x55, 0x6d, 0x72, 0x51,
+  0x53, 0x15, 0x60, 0x61, 0x62, 0x60, 0xf2, 0x70, 0x51, 0x0d, 0x30, 0xa3,
+  0xa1, 0xe3, 0xcd, 0x5c, 0x3f, 0x0e, 0x11, 0xfd, 0xce, 0x12, 0x01, 0xcd,
+  0x0a, 0x34, 0x46, 0x98, 0x43, 0x3c, 0x02, 0x30, 0x3c, 0x37, 0x8d, 0x68,
+  0x1d, 0x16, 0x03, 0x3a, 0x15, 0x1c, 0x82, 0xfd, 0x4a, 0x15, 0x1f, 0x16,
+  0x28, 0x75, 0x2a, 0x16, 0x16, 0x9c, 0x6f, 0xa6, 0x44, 0x4d, 0x01, 0x13,
+  0xa2, 0xa1, 0x91, 0x63, 0x93, 0x46, 0x50, 0x5a, 0x64, 0x38, 0x32, 0x76,
+  0x52, 0x73, 0x11, 0x00, 0x00, 0x03, 0x00, 0x47, 0x00, 0x00, 0x02, 0x41,
+  0x06, 0x14, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33,
+  0x07, 0x23, 0x03, 0x33, 0x13, 0x23, 0x13, 0x21, 0x13, 0x21, 0x01, 0x9b,
+  0xa6, 0x29, 0xa6, 0xbf, 0x79, 0xa0, 0x79, 0x21, 0xfe, 0xd3, 0xc4, 0x01,
+  0x2d, 0x06, 0x14, 0xe9, 0xfb, 0x39, 0x03, 0x98, 0xfc, 0x04, 0x04, 0x60,
+  0x00, 0x03, 0xff, 0x2d, 0xfe, 0x56, 0x02, 0x41, 0x06, 0x14, 0x00, 0x03,
+  0x00, 0x0c, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x33, 0x07, 0x23, 0x03, 0x13,
+  0x23, 0x03, 0x06, 0x07, 0x36, 0x37, 0x36, 0x05, 0x23, 0x37, 0x33, 0x32,
+  0x37, 0x36, 0x37, 0x13, 0x21, 0x03, 0x06, 0x07, 0x06, 0x01, 0x9b, 0xa6,
+  0x29, 0xa6, 0x5c, 0xb6, 0x79, 0xbb, 0x1f, 0x30, 0x41, 0x2d, 0x43, 0xfe,
+  0xf9, 0xc6, 0x12, 0x2d, 0x5e, 0x2b, 0x2b, 0x1a, 0xd1, 0x01, 0x2d, 0xc8,
+  0x25, 0x5a, 0x5b, 0x06, 0x14, 0xe9, 0xfa, 0xbf, 0x04, 0x12, 0xfb, 0xd0,
+  0xb5, 0x54, 0x0f, 0x30, 0x48, 0xf4, 0x64, 0x30, 0x31, 0x99, 0x04, 0xac,
+  0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x35,
+  0xff, 0xe3, 0x05, 0x26, 0x05, 0xf0, 0x00, 0x26, 0x00, 0x30, 0x00, 0x00,
+  0x09, 0x01, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x12, 0x37, 0x03, 0x33, 0x17,
+  0x3e, 0x01, 0x33, 0x32, 0x00, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x03, 0x5b, 0xfe, 0x36, 0x35, 0x40, 0xa8, 0x68, 0x54, 0xfb, 0xe3,
+  0x81, 0x5d, 0xcd, 0x76, 0xd9, 0x01, 0x14, 0x79, 0x79, 0x2c, 0x2d, 0xc8,
+  0xa6, 0x4b, 0x94, 0x4c, 0x4e, 0x8e, 0x3d, 0x5f, 0x76, 0x36, 0x2e, 0x51,
+  0x4d, 0xbf, 0x90, 0x55, 0x96, 0x42, 0x02, 0x40, 0x02, 0x08, 0x59, 0xcb,
+  0x72, 0x84, 0x01, 0x02, 0x7e, 0x01, 0x1f, 0x95, 0x59, 0x57, 0xfe, 0xed,
+  0xd7, 0x80, 0xe1, 0x63, 0x3f, 0x7d, 0x3c, 0xa2, 0xc5, 0x24, 0x24, 0xb6,
+  0x2f, 0x31, 0x6f, 0x58, 0x33, 0x67, 0xce, 0x51, 0xa1, 0x58, 0x92, 0xc2,
+  0x3f, 0x40, 0x00, 0x00, 0x00, 0x01, 0x00, 0x48, 0x00, 0x00, 0x03, 0x2e,
+  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x03, 0x2e, 0xfd, 0x1b, 0x02, 0x3f, 0xfe, 0x3a,
+  0x01, 0xc6, 0x04, 0x60, 0xfb, 0xa0, 0x93, 0x01, 0x6f, 0x93, 0x01, 0xcb,
+  0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0xa4, 0x05, 0xf0, 0x10, 0x27,
+  0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0xa5, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
+  0xff, 0xe3, 0x06, 0xb6, 0x05, 0xf0, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3,
+  0x00, 0x00, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa7,
+  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x09, 0x9d,
+  0x05, 0xf0, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x26,
+  0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x7b, 0x04, 0x17, 0xfd, 0x64,
+  0x10, 0x07, 0x07, 0xa0, 0x06, 0xfa, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
+  0xff, 0xe3, 0x06, 0x9c, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
+  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x00, 0x75,
+  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x54, 0xff, 0xe3, 0x06, 0x9c,
+  0x05, 0xf0, 0x10, 0x26, 0x00, 0x74, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
+  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x00, 0x75, 0x04, 0x17, 0xfd, 0x64,
+  0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0xa2, 0x05, 0xf0, 0x10, 0x26,
+  0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0xa3, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x54,
+  0xff, 0xe3, 0x06, 0xa2, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x74, 0x00, 0x00,
+  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa3,
+  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x58, 0xff, 0xe3, 0x06, 0xa2,
+  0x05, 0xf0, 0x10, 0x26, 0x00, 0x75, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
+  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa3, 0x04, 0x17, 0xfd, 0x64,
+  0xff, 0xff, 0x00, 0x38, 0xff, 0xe3, 0x06, 0xa2, 0x05, 0xf0, 0x10, 0x26,
+  0x07, 0xa2, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0xa3, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
+  0xff, 0xe3, 0x06, 0xbf, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
+  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa4,
+  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x5b, 0xff, 0xe3, 0x06, 0xbf,
+  0x05, 0xf0, 0x10, 0x26, 0x07, 0xa3, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
+  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa4, 0x04, 0x17, 0xfd, 0x64,
+  0xff, 0xff, 0x00, 0x7b, 0xff, 0xe3, 0x06, 0xb8, 0x05, 0xf0, 0x10, 0x26,
+  0x00, 0x7b, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0xa6, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x58,
+  0xff, 0xe3, 0x06, 0xb8, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x75, 0x00, 0x00,
+  0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa6,
+  0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x5b, 0xff, 0xe3, 0x06, 0xb8,
+  0x05, 0xf0, 0x10, 0x26, 0x07, 0xa3, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79,
+  0x02, 0xe3, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa6, 0x04, 0x17, 0xfd, 0x64,
+  0xff, 0xff, 0x00, 0x61, 0xff, 0xe3, 0x06, 0xb8, 0x05, 0xf0, 0x10, 0x26,
+  0x07, 0xa5, 0x00, 0x00, 0x10, 0x27, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0xa6, 0x04, 0x17, 0xfd, 0x64, 0xff, 0xff, 0x00, 0x7b,
+  0xff, 0xe3, 0x05, 0x69, 0x05, 0xf0, 0x10, 0x26, 0x00, 0x7b, 0x00, 0x00,
+  0x10, 0x07, 0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x01, 0x6b, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x2c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x02, 0xd7, 0x05, 0xd5, 0x10, 0x26,
+  0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x01, 0x6c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x42, 0x05, 0xd5, 0x10, 0x26,
+  0x00, 0x2c, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c, 0x01, 0x6c, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x2c, 0x02, 0xd7, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x06, 0x96, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x2c, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x39, 0x01, 0xb8, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x39, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x05, 0xf0, 0x05, 0xd5, 0x10, 0x26,
+  0x00, 0x39, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x04, 0x84, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x0e, 0x00, 0x00, 0x07, 0x5b, 0x05, 0xd5, 0x10, 0x26,
+  0x00, 0x39, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c, 0x04, 0x84, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x2c, 0x05, 0xf0, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x08, 0xc7, 0x05, 0xd5, 0x10, 0x26, 0x00, 0x39, 0x00, 0x00,
+  0x10, 0x27, 0x00, 0x2c, 0x04, 0x84, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c,
+  0x05, 0xf0, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x07, 0x5c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x06, 0x62, 0x05, 0xd5, 0x10, 0x26,
+  0x00, 0x2c, 0x00, 0x00, 0x10, 0x07, 0x00, 0x3b, 0x01, 0xac, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x06, 0x03,
+  0x05, 0xd5, 0x10, 0x26, 0x00, 0x3b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c,
+  0x04, 0x98, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x07, 0x6f,
+  0x05, 0xd5, 0x10, 0x26, 0x00, 0x3b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x2c,
+  0x04, 0x98, 0x00, 0x00, 0x10, 0x07, 0x00, 0x2c, 0x06, 0x04, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4,
+  0x05, 0xf0, 0x10, 0x06, 0x00, 0x26, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x30, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54,
+  0x06, 0x14, 0x10, 0x06, 0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0x00, 0x00, 0x02, 0x9f, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x4c, 0x01, 0x4b, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0x00, 0x00, 0x03, 0xea, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
+  0x10, 0x27, 0x00, 0x4c, 0x01, 0x4b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x4c,
+  0x02, 0x96, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x05, 0xa1,
+  0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00, 0x10, 0x07, 0x00, 0x59,
+  0x01, 0x95, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
+  0x04, 0x60, 0x10, 0x06, 0x00, 0x59, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36,
+  0x00, 0x00, 0x05, 0x2b, 0x06, 0x14, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x4c, 0x03, 0xd7, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36,
+  0x00, 0x00, 0x06, 0x76, 0x06, 0x14, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00,
+  0x10, 0x27, 0x00, 0x4c, 0x03, 0xd7, 0x00, 0x00, 0x10, 0x07, 0x00, 0x4c,
+  0x05, 0x22, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x07, 0xc1,
+  0x06, 0x14, 0x10, 0x26, 0x00, 0x59, 0x00, 0x00, 0x10, 0x27, 0x00, 0x4c,
+  0x03, 0xd7, 0x00, 0x00, 0x10, 0x27, 0x00, 0x4c, 0x05, 0x22, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x4c, 0x06, 0x6d, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0x00, 0x00, 0x05, 0xa9, 0x06, 0x14, 0x10, 0x26, 0x00, 0x4c, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x5b, 0x01, 0xa2, 0x00, 0x00, 0xff, 0xff, 0x00, 0x35,
+  0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x10, 0x06, 0x00, 0x5b, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x05, 0x3f, 0x06, 0x14, 0x10, 0x26,
+  0x00, 0x5b, 0x00, 0x00, 0x10, 0x07, 0x00, 0x4c, 0x03, 0xec, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x06, 0x8a, 0x06, 0x14, 0x10, 0x26,
+  0x00, 0x5b, 0x00, 0x00, 0x10, 0x27, 0x00, 0x4c, 0x03, 0xec, 0x00, 0x00,
+  0x10, 0x07, 0x00, 0x4c, 0x05, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0xad,
+  0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x10, 0x06, 0x00, 0x4f, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x10, 0x06,
+  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xeb,
+  0x06, 0x14, 0x10, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x06, 0x67, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x50, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x6c, 0x00, 0x00, 0x08, 0x8b, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x16, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x29, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x01, 0x33, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x23, 0x03, 0x11, 0x23, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x05, 0x96, 0x01, 0x87, 0x01, 0x6d, 0xfe, 0x91, 0xfe, 0x7b,
+  0xfd, 0xcb, 0xfe, 0x7b, 0xfe, 0x91, 0x01, 0x6d, 0x01, 0x87, 0x01, 0x75,
+  0xdc, 0x01, 0x16, 0x01, 0x02, 0xfe, 0xfe, 0xfe, 0xea, 0xdc, 0xb5, 0xdc,
+  0xfe, 0xea, 0xfe, 0xfe, 0x01, 0x02, 0x01, 0x16, 0x05, 0xd5, 0xfe, 0x97,
+  0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x01, 0x6a, 0x01, 0x82, 0x01, 0x80,
+  0x01, 0x69, 0xfa, 0xd1, 0x01, 0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17,
+  0xfb, 0x77, 0x04, 0x89, 0xfe, 0xe9, 0xfe, 0xd4, 0xfe, 0xd2, 0xfe, 0xe8,
+  0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x01, 0x15, 0x33, 0x20, 0x00, 0x11,
+  0x10, 0x00, 0x21, 0x23, 0x15, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
+  0x03, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x29, 0x01, 0x01, 0x6b, 0xdb, 0x01, 0x16, 0x01,
+  0x03, 0xfe, 0xfd, 0xfe, 0xea, 0xdb, 0x41, 0xe6, 0xd8, 0xd9, 0xe5, 0x41,
+  0x46, 0x8f, 0x84, 0x84, 0x8f, 0xfc, 0x01, 0x75, 0x01, 0x87, 0x01, 0x6d,
+  0xfe, 0x91, 0xfe, 0x7b, 0xfe, 0x8b, 0x01, 0x59, 0xb3, 0x01, 0x18, 0x01,
+  0x2e, 0x01, 0x2c, 0x01, 0x17, 0xb2, 0xc2, 0xcf, 0xd0, 0xc3, 0x02, 0x9e,
+  0xfd, 0xe8, 0x81, 0x8c, 0x8a, 0x81, 0x01, 0xde, 0xfe, 0x97, 0xfe, 0x80,
+  0xfe, 0x7e, 0xfe, 0x96, 0x00, 0x05, 0x00, 0x6c, 0x00, 0x00, 0x08, 0x8b,
+  0x05, 0xd5, 0x00, 0x11, 0x00, 0x1a, 0x00, 0x28, 0x00, 0x31, 0x00, 0x43,
+  0x00, 0x00, 0x01, 0x15, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01,
+  0x15, 0x33, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x03, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x2b, 0x01, 0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x29, 0x01, 0x20, 0x00, 0x11, 0x10, 0x00, 0x01, 0x11, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x13, 0x35, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x33, 0x35, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x04, 0xd6,
+  0x41, 0xe7, 0xd8, 0xd9, 0xe6, 0x41, 0xdc, 0x01, 0x16, 0x01, 0x02, 0xfe,
+  0xfe, 0xfe, 0xea, 0xdc, 0x47, 0x8f, 0x84, 0x84, 0x8f, 0x47, 0xc0, 0xfd,
+  0xcb, 0xfe, 0x7b, 0xfe, 0x91, 0x01, 0x6d, 0x01, 0x87, 0x02, 0x35, 0x01,
+  0x87, 0x01, 0x6d, 0xfe, 0x91, 0xfd, 0x06, 0x47, 0x8f, 0x84, 0x84, 0x8f,
+  0x47, 0xdc, 0xfe, 0xea, 0xfe, 0xfe, 0x01, 0x02, 0x01, 0x16, 0xdc, 0x41,
+  0xe6, 0xd9, 0xd8, 0xe7, 0x05, 0x2f, 0xb2, 0xc2, 0xcf, 0xd0, 0xc3, 0xb3,
+  0x01, 0x18, 0x01, 0x2e, 0x01, 0x2c, 0x01, 0x17, 0xfc, 0xb0, 0x81, 0x8c,
+  0x8a, 0x81, 0xfc, 0x09, 0x01, 0x6a, 0x01, 0x82, 0x01, 0x80, 0x01, 0x69,
+  0xfe, 0x97, 0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x01, 0xdf, 0x02, 0x18,
+  0x81, 0x8a, 0x8c, 0x81, 0x02, 0x9e, 0xb2, 0xfe, 0xe9, 0xfe, 0xd4, 0xfe,
+  0xd2, 0xfe, 0xe8, 0xb3, 0xc3, 0xd0, 0xcf, 0xc2, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x10, 0x06, 0x01, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90, 0x04, 0x7b, 0x10, 0x06,
+  0x02, 0x16, 0x00, 0x00, 0x00, 0x01, 0x00, 0x67, 0xfe, 0x56, 0x04, 0xa4,
+  0x05, 0xf0, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x36, 0x37, 0x11, 0x23, 0x11, 0x06,
+  0x07, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x04,
+  0xa3, 0x5c, 0xd0, 0x75, 0xe6, 0xf5, 0xf5, 0xe6, 0x75, 0xd0, 0x5c, 0xb5,
+  0x0a, 0x0b, 0x6b, 0x76, 0xfe, 0xce, 0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x32,
+  0x78, 0xd6, 0x05, 0x62, 0xd5, 0x5f, 0x5e, 0xfe, 0xc7, 0xfe, 0xd8, 0xfe,
+  0xd9, 0xfe, 0xc7, 0x5e, 0x5f, 0xfd, 0x10, 0x01, 0xb9, 0x04, 0x04, 0x24,
+  0x01, 0x9f, 0x01, 0x67, 0x01, 0x68, 0x01, 0x9f, 0x47, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x4e, 0xff, 0xe3, 0x06, 0x9c, 0x05, 0xf0, 0x10, 0x27,
+  0x07, 0x79, 0x02, 0xe3, 0x00, 0x00, 0x10, 0x27, 0x00, 0x75, 0x04, 0x17,
+  0xfd, 0x64, 0x10, 0x06, 0x07, 0xa0, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x13, 0x35,
+  0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c,
+  0xd2, 0x04, 0x49, 0xfb, 0xb7, 0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89,
+  0x78, 0xe9, 0xaa, 0xe9, 0x78, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x79,
+  0x00, 0x00, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x09, 0x00, 0x00, 0x01, 0x33,
+  0x01, 0x07, 0x27, 0x11, 0x23, 0x11, 0x07, 0x27, 0x02, 0xdc, 0x51, 0x01,
+  0x61, 0x6c, 0xd1, 0x99, 0xd3, 0x6c, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea,
+  0xfb, 0x3c, 0x04, 0xc4, 0xea, 0x78, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x01, 0x15,
+  0x01, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x05, 0xae, 0xfe, 0x9f,
+  0x6c, 0xd1, 0xfb, 0xb7, 0x04, 0x49, 0xd1, 0x6c, 0x02, 0xaf, 0x5a, 0xfe,
+  0x77, 0x78, 0xe9, 0xaa, 0xe9, 0x78, 0x00, 0x00, 0x00, 0x01, 0x01, 0x79,
+  0xff, 0xf9, 0x04, 0x8e, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x05, 0x23,
+  0x01, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x03, 0x2d, 0x51, 0xfe,
+  0x9d, 0x6c, 0xd3, 0x99, 0xd1, 0x6c, 0x07, 0x01, 0x8a, 0x78, 0xea, 0x04,
+  0xc4, 0xfb, 0x3c, 0xea, 0x78, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x35,
+  0x01, 0x17, 0x07, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
+  0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x03, 0x5c, 0xd1, 0x6c, 0x01,
+  0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfc, 0xa4, 0xd2, 0x6c, 0x02, 0x55, 0x5a,
+  0x01, 0x89, 0x78, 0xe9, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78,
+  0xe9, 0xe9, 0x78, 0x00, 0x00, 0x01, 0x01, 0x79, 0xff, 0xef, 0x04, 0x8e,
+  0x05, 0xdc, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11,
+  0x37, 0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x11, 0x07, 0x27, 0x02, 0xdc,
+  0x51, 0x01, 0x61, 0x6c, 0xd1, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9d,
+  0x6c, 0xd3, 0xd3, 0x6c, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea, 0xfc, 0x43,
+  0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0xea, 0x03, 0xbd, 0xea, 0x78,
+  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x37, 0x21, 0x15, 0x21, 0x01, 0x07, 0x01, 0x11, 0x23,
+  0x01, 0x03, 0x39, 0x01, 0xf4, 0xfe, 0xd7, 0x03, 0x08, 0x6c, 0xfc, 0xf8,
+  0x98, 0x04, 0x74, 0x3f, 0xa9, 0xfc, 0xa2, 0x78, 0x03, 0x5e, 0xfe, 0xb6,
+  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x17, 0x11, 0x23, 0x11, 0x01, 0x27, 0x01, 0x21, 0x35,
+  0x04, 0xd6, 0x39, 0x98, 0xfc, 0xf8, 0x6c, 0x03, 0x08, 0xfe, 0xd7, 0x04,
+  0xb3, 0x3f, 0xfd, 0xd4, 0x01, 0x4a, 0xfc, 0xa2, 0x78, 0x03, 0x5e, 0xa9,
+  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
+  0x00, 0x00, 0x25, 0x07, 0x21, 0x35, 0x21, 0x01, 0x37, 0x01, 0x11, 0x33,
+  0x05, 0x0f, 0x39, 0xfe, 0x0c, 0x01, 0x29, 0xfc, 0xf8, 0x6c, 0x03, 0x08,
+  0x98, 0x73, 0x3f, 0xa9, 0x03, 0x5e, 0x78, 0xfc, 0xa2, 0x01, 0x4a, 0x00,
+  0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x09,
+  0x00, 0x00, 0x25, 0x27, 0x11, 0x33, 0x11, 0x01, 0x17, 0x01, 0x21, 0x15,
+  0x01, 0x3c, 0x39, 0x98, 0x03, 0x08, 0x6c, 0xfc, 0xf8, 0x01, 0x29, 0x34,
+  0x3f, 0x02, 0x2c, 0xfe, 0xb6, 0x03, 0x5e, 0x78, 0xfc, 0xa2, 0xa9, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x11,
+  0x00, 0x00, 0x01, 0x03, 0x27, 0x13, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01,
+  0x17, 0x07, 0x21, 0x13, 0x17, 0x03, 0x21, 0x15, 0x03, 0xd5, 0xb4, 0x85,
+  0x88, 0xfe, 0x32, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x02,
+  0x27, 0xb4, 0x85, 0x88, 0x01, 0x71, 0x02, 0x2d, 0xfe, 0xa5, 0x55, 0x01,
+  0x06, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x5b,
+  0x55, 0xfe, 0xfa, 0xaa, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x11, 0x00, 0x00, 0x01, 0x13, 0x17, 0x03, 0x21, 0x27,
+  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x03, 0x27, 0x13, 0x21, 0x35,
+  0x02, 0x33, 0xb4, 0x86, 0x88, 0x01, 0xcd, 0xd1, 0x6c, 0x01, 0x61, 0xfe,
+  0x9f, 0x6c, 0xd1, 0xfd, 0xda, 0xb4, 0x86, 0x88, 0xfe, 0x8f, 0x02, 0xd7,
+  0x01, 0x5b, 0x55, 0xfe, 0xfa, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77,
+  0x78, 0xe9, 0xfe, 0xa5, 0x55, 0x01, 0x06, 0xaa, 0x00, 0x01, 0x00, 0x27,
+  0x00, 0xd3, 0x05, 0xf5, 0x03, 0x50, 0x00, 0x34, 0x00, 0x00, 0x01, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x11, 0x23, 0x11, 0x37,
+  0x21, 0x15, 0x05, 0x01, 0xbc, 0x1f, 0x2b, 0x24, 0x33, 0x2f, 0x28, 0x2b,
+  0x3f, 0x13, 0x1f, 0x36, 0x35, 0x46, 0x43, 0x4f, 0x52, 0x40, 0x49, 0x32,
+  0x36, 0x1f, 0x8e, 0x13, 0x1f, 0x1e, 0x2d, 0x25, 0x32, 0x30, 0x27, 0x2b,
+  0x20, 0x20, 0x13, 0x1b, 0x39, 0x2d, 0x4e, 0x40, 0x52, 0x4f, 0x43, 0x46,
+  0x35, 0x90, 0x98, 0x38, 0x01, 0xf5, 0xfe, 0xd7, 0x01, 0xf4, 0x21, 0x15,
+  0x13, 0x13, 0x15, 0x46, 0x30, 0x4f, 0x3c, 0x3a, 0x22, 0x20, 0x20, 0x25,
+  0x37, 0x3c, 0x4f, 0x41, 0x30, 0x23, 0x21, 0x17, 0x13, 0x13, 0x14, 0x24,
+  0x23, 0x30, 0x49, 0x42, 0x35, 0x27, 0x20, 0x20, 0x22, 0x3a, 0xa0, 0xfe,
+  0xb6, 0x02, 0x2c, 0x3f, 0xa9, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x13,
+  0x00, 0xd3, 0x05, 0xe1, 0x03, 0x50, 0x00, 0x34, 0x00, 0x00, 0x01, 0x37,
+  0x25, 0x35, 0x21, 0x17, 0x11, 0x23, 0x11, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x27, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x04, 0x4d, 0x90, 0xfe, 0xd7, 0x01, 0xf4, 0x39, 0x98,
+  0x90, 0x35, 0x47, 0x42, 0x4f, 0x52, 0x40, 0x4e, 0x2e, 0x38, 0x1c, 0x13,
+  0x1f, 0x21, 0x2a, 0x28, 0x2f, 0x33, 0x25, 0x2d, 0x1d, 0x20, 0x13, 0x8d,
+  0x1e, 0x36, 0x32, 0x4a, 0x40, 0x52, 0x4f, 0x42, 0x47, 0x35, 0x36, 0x1e,
+  0x13, 0x3f, 0x2b, 0x28, 0x30, 0x32, 0x25, 0x2a, 0x01, 0xf4, 0xa0, 0x01,
+  0xa9, 0x3f, 0xfd, 0xd4, 0x01, 0x4a, 0xa0, 0x3a, 0x22, 0x20, 0x20, 0x27,
+  0x35, 0x42, 0x49, 0x30, 0x23, 0x24, 0x14, 0x13, 0x13, 0x17, 0x21, 0x23,
+  0x30, 0x41, 0x4f, 0x3c, 0x37, 0x25, 0x20, 0x20, 0x22, 0x3a, 0x3c, 0x4f,
+  0x30, 0x46, 0x15, 0x13, 0x13, 0x15, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x11, 0x00, 0x00, 0x13, 0x01,
+  0x17, 0x07, 0x33, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01,
+  0x23, 0x17, 0x07, 0x01, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0xd8, 0x01, 0x3e,
+  0x6c, 0xd2, 0x02, 0x99, 0xfd, 0x67, 0xd2, 0x6c, 0xfe, 0xc2, 0xd8, 0xd2,
+  0x6c, 0xfe, 0x9e, 0x02, 0xaf, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x61, 0x78,
+  0xe9, 0xaa, 0xe9, 0x78, 0x01, 0x61, 0xe9, 0x78, 0x01, 0x89, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x90, 0x05, 0xdc, 0x00, 0x11,
+  0x00, 0x00, 0x09, 0x01, 0x07, 0x27, 0x15, 0x01, 0x07, 0x27, 0x11, 0x23,
+  0x11, 0x07, 0x27, 0x01, 0x35, 0x07, 0x27, 0x01, 0x03, 0x2d, 0x01, 0x62,
+  0x6c, 0xd2, 0x01, 0x3e, 0x6c, 0xd2, 0x99, 0xd1, 0x6c, 0x01, 0x3d, 0xd1,
+  0x6c, 0x01, 0x61, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea, 0xf0, 0xfe, 0x9e,
+  0x78, 0xea, 0xfd, 0x1c, 0x02, 0xe4, 0xea, 0x78, 0x01, 0x62, 0xf0, 0xea,
+  0x78, 0x01, 0x8a, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x23, 0x01,
+  0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x33, 0x27, 0x37, 0x01,
+  0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xd8, 0xfe, 0xc3, 0x6c, 0xd1, 0xfd,
+  0x67, 0x02, 0x99, 0xd1, 0x6c, 0x01, 0x3d, 0xd8, 0xd1, 0x6c, 0x01, 0x61,
+  0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0xfe, 0x9f, 0x78, 0xe9, 0xaa, 0xe9,
+  0x78, 0xfe, 0x9f, 0xe9, 0x78, 0xfe, 0x77, 0x00, 0x00, 0x01, 0x01, 0x7a,
+  0xff, 0xf9, 0x04, 0x90, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x05, 0x01,
+  0x37, 0x17, 0x35, 0x01, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01,
+  0x15, 0x37, 0x17, 0x01, 0x02, 0xde, 0xfe, 0x9d, 0x6c, 0xd3, 0xfe, 0xc1,
+  0x6c, 0xd3, 0x98, 0xd1, 0x6c, 0xfe, 0xc3, 0xd1, 0x6c, 0xfe, 0x9f, 0x07,
+  0x01, 0x8a, 0x78, 0xea, 0xf0, 0x01, 0x62, 0x78, 0xea, 0x02, 0xe4, 0xfd,
+  0x1c, 0xea, 0x78, 0xfe, 0x9e, 0xf0, 0xea, 0x78, 0xfe, 0x76, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0e,
+  0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21, 0x01, 0x17, 0x09, 0x01,
+  0x07, 0x01, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x02, 0x9f,
+  0x01, 0x3e, 0x6c, 0xfe, 0xe2, 0x01, 0x1e, 0x6c, 0xfe, 0xc2, 0xfd, 0x61,
+  0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x61, 0x78,
+  0xfe, 0xc2, 0xfe, 0xc2, 0x78, 0x01, 0x61, 0xe9, 0x78, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0e,
+  0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x01, 0x27, 0x09, 0x01, 0x37,
+  0x01, 0x21, 0x27, 0x37, 0x01, 0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfd,
+  0x61, 0xfe, 0xc2, 0x6c, 0x01, 0x1f, 0xfe, 0xe1, 0x6c, 0x01, 0x3e, 0x02,
+  0x9f, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0xfe,
+  0x9f, 0x78, 0x01, 0x3e, 0x01, 0x3e, 0x78, 0xfe, 0x9f, 0xe9, 0x78, 0xfe,
+  0x77, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0,
+  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x17, 0x07, 0x01, 0x35,
+  0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x23, 0x05, 0x06, 0xfc, 0x50,
+  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x03, 0xb0, 0x99, 0x99,
+  0x02, 0x2d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01,
+  0x59, 0xfc, 0xa4, 0x00, 0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x8e,
+  0x05, 0xdc, 0x00, 0x0d, 0x00, 0x00, 0x25, 0x11, 0x07, 0x27, 0x01, 0x33,
+  0x01, 0x07, 0x27, 0x11, 0x21, 0x15, 0x21, 0x35, 0x02, 0xb8, 0xd1, 0x6c,
+  0x01, 0x61, 0x51, 0x01, 0x61, 0x6c, 0xd1, 0x01, 0x37, 0xfc, 0xfa, 0xaa,
+  0x04, 0x1a, 0xea, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78, 0xea, 0xfb, 0xe6,
+  0xaa, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
+  0x11, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x04, 0xb2, 0xfc, 0x50,
+  0x99, 0x99, 0x03, 0xb0, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0x02,
+  0x2d, 0xfe, 0xa7, 0x03, 0x5c, 0xfe, 0xa7, 0xe9, 0x78, 0xfe, 0x77, 0x5a,
+  0xfe, 0x77, 0x78, 0x00, 0x00, 0x01, 0x01, 0x7a, 0xff, 0xf9, 0x04, 0x8e,
+  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x15, 0x21,
+  0x11, 0x37, 0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x02, 0xb8, 0xfe, 0xca,
+  0x03, 0x06, 0xfe, 0xc9, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9f, 0x6c,
+  0xd1, 0x05, 0x2b, 0xaa, 0xaa, 0xfb, 0xe6, 0xea, 0x78, 0xfe, 0x76, 0x01,
+  0x8a, 0x78, 0xea, 0x00, 0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x8e,
+  0x05, 0xdc, 0x00, 0x13, 0x00, 0x00, 0x01, 0x37, 0x17, 0x01, 0x21, 0x15,
+  0x21, 0x35, 0x21, 0x01, 0x37, 0x17, 0x11, 0x07, 0x27, 0x01, 0x33, 0x01,
+  0x07, 0x27, 0x03, 0x51, 0xd1, 0x6c, 0xfe, 0x9f, 0x01, 0x5b, 0xfc, 0xfa,
+  0x01, 0x5a, 0xfe, 0x9f, 0x6c, 0xd1, 0xd1, 0x6c, 0x01, 0x61, 0x51, 0x01,
+  0x61, 0x6c, 0xd1, 0x01, 0xc2, 0xea, 0x78, 0xfe, 0x76, 0xaa, 0xaa, 0x01,
+  0x8a, 0x78, 0xea, 0x03, 0x02, 0xea, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78,
+  0xea, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0x9f,
+  0x04, 0x86, 0x00, 0x25, 0x00, 0x00, 0x01, 0x35, 0x32, 0x17, 0x16, 0x17,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21, 0x17,
+  0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x20, 0x37, 0x36, 0x37, 0x3e,
+  0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x04, 0x91, 0x38, 0x2f,
+  0x2d, 0x2a, 0x27, 0x28, 0x26, 0x29, 0x23, 0x34, 0x2c, 0x1d, 0xfc, 0xa7,
+  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0xaa, 0x01, 0xa9,
+  0x14, 0x16, 0x11, 0x10, 0x12, 0x11, 0x11, 0x11, 0x16, 0x14, 0x03, 0xdc,
+  0xaa, 0x16, 0x15, 0x2d, 0x29, 0x6f, 0x3d, 0x3c, 0x6a, 0x2e, 0x28, 0x1a,
+  0x16, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x0a, 0x0a,
+  0x12, 0x11, 0x31, 0x1a, 0x1b, 0x2e, 0x14, 0x12, 0x0a, 0x0a, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x6a, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x86, 0x00, 0x29,
+  0x00, 0x00, 0x01, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x21, 0x27, 0x37, 0x01, 0x15,
+  0x01, 0x27, 0x37, 0x21, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x01, 0x77, 0x18, 0x14,
+  0x15, 0x12, 0x10, 0x09, 0x09, 0x09, 0x0b, 0x0e, 0x12, 0x15, 0x14, 0x18,
+  0x03, 0x3b, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfc, 0xc5,
+  0x3a, 0x2c, 0x35, 0x23, 0x28, 0x13, 0x14, 0x14, 0x15, 0x26, 0x2b, 0x2d,
+  0x2f, 0x37, 0x03, 0xdc, 0x0a, 0x0a, 0x12, 0x11, 0x1a, 0x17, 0x1b, 0x1a,
+  0x17, 0x1c, 0x0f, 0x12, 0x0a, 0x0a, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
+  0x77, 0x78, 0xe9, 0x16, 0x1a, 0x28, 0x2e, 0x34, 0x36, 0x3c, 0x3d, 0x36,
+  0x39, 0x29, 0x2d, 0x15, 0x16, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0x9f, 0x04, 0x86, 0x00, 0x18, 0x00, 0x3e, 0x00, 0x00,
+  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x15, 0x07, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x2b, 0x01, 0x15, 0x23, 0x35, 0x21, 0x17, 0x07, 0x01, 0x35,
+  0x01, 0x17, 0x07, 0x04, 0x1c, 0x75, 0x18, 0x14, 0x16, 0x11, 0x10, 0x09,
+  0x09, 0x09, 0x09, 0x10, 0x11, 0x16, 0x14, 0x30, 0x14, 0x16, 0x11, 0x0e,
+  0x0b, 0x09, 0x98, 0x14, 0x14, 0x27, 0x2b, 0x2c, 0x2f, 0x38, 0x3b, 0x2c,
+  0x34, 0x23, 0x29, 0x12, 0x14, 0x14, 0x14, 0x27, 0x2a, 0x2d, 0x2f, 0x38,
+  0x75, 0x98, 0xfd, 0xd2, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2,
+  0x02, 0xd7, 0x0a, 0x0a, 0x12, 0x11, 0x1a, 0x17, 0x1a, 0x1b, 0x17, 0x1a,
+  0x11, 0x12, 0x0a, 0x0a, 0x0a, 0x0a, 0x12, 0x0f, 0x1c, 0x17, 0x1b, 0x82,
+  0x82, 0x3d, 0x36, 0x39, 0x29, 0x2d, 0x15, 0x16, 0x16, 0x1a, 0x28, 0x2e,
+  0x34, 0x36, 0x3d, 0x3c, 0x36, 0x39, 0x29, 0x2d, 0x15, 0x16, 0xdc, 0xdc,
+  0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x6a, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x86, 0x00, 0x18,
+  0x00, 0x3e, 0x00, 0x00, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x33, 0x29, 0x01, 0x27, 0x37, 0x01, 0x15, 0x01,
+  0x27, 0x37, 0x21, 0x15, 0x23, 0x35, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x01, 0xec, 0x09, 0x0b, 0x0e,
+  0x11, 0x16, 0x13, 0x31, 0x14, 0x15, 0x12, 0x10, 0x09, 0x09, 0x09, 0x09,
+  0x10, 0x12, 0x15, 0x14, 0x18, 0x01, 0x0d, 0x02, 0x2e, 0xd1, 0x6c, 0x01,
+  0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfd, 0xd2, 0x98, 0x75, 0x37, 0x2f, 0x2d,
+  0x2b, 0x26, 0x15, 0x14, 0x14, 0x13, 0x28, 0x23, 0x35, 0x2c, 0x3a, 0x38,
+  0x2f, 0x2d, 0x2a, 0x27, 0x15, 0x13, 0x02, 0xd7, 0x82, 0x1b, 0x17, 0x1c,
+  0x0f, 0x12, 0x0a, 0x0a, 0x0a, 0x0a, 0x12, 0x11, 0x1a, 0x17, 0x1b, 0x1a,
+  0x17, 0x1a, 0x11, 0x12, 0x0a, 0x0a, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
+  0x77, 0x78, 0xe9, 0xdc, 0xdc, 0x16, 0x15, 0x2d, 0x29, 0x39, 0x36, 0x3c,
+  0x3d, 0x36, 0x34, 0x2e, 0x28, 0x1a, 0x16, 0x16, 0x15, 0x2d, 0x29, 0x39,
+  0x36, 0x3d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x58, 0x00, 0x00, 0x01, 0x23, 0x17, 0x07, 0x01, 0x35,
+  0x01, 0x17, 0x07, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x32, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x32, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x3b, 0x01, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x5f, 0x09, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x09, 0x2b,
+  0x21, 0x1f, 0x20, 0x0a, 0x15, 0x18, 0x16, 0x09, 0x09, 0x05, 0x0e, 0x1d,
+  0x1e, 0x22, 0x23, 0x28, 0x2b, 0x21, 0x23, 0x1d, 0x1d, 0x0e, 0x04, 0x09,
+  0x09, 0x16, 0x18, 0x16, 0x09, 0x23, 0x1d, 0x23, 0x28, 0x09, 0xd1, 0x6c,
+  0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0x09, 0x0c, 0x0a, 0x0c, 0x09, 0x1c,
+  0x24, 0x23, 0x51, 0x22, 0x24, 0x1c, 0x1e, 0x0e, 0x04, 0x09, 0x09, 0x0b,
+  0x0a, 0x19, 0x0a, 0x0c, 0x09, 0x08, 0x05, 0x0d, 0x1f, 0x1c, 0x24, 0x22,
+  0x51, 0x23, 0x24, 0x1c, 0x09, 0x0b, 0x0a, 0x02, 0x2d, 0xe9, 0x78, 0x01,
+  0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x12, 0x12, 0x24, 0x0a, 0x0c, 0x0c,
+  0x0a, 0x0c, 0x0d, 0x2d, 0x23, 0x25, 0x11, 0x12, 0x12, 0x14, 0x22, 0x26,
+  0x2a, 0x0d, 0x0c, 0x0a, 0x0c, 0x0c, 0x0a, 0x27, 0x0f, 0x12, 0xe9, 0x78,
+  0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x06, 0x06, 0x0a, 0x22, 0x14,
+  0x12, 0x12, 0x14, 0x22, 0x26, 0x2a, 0x0d, 0x0c, 0x0a, 0x06, 0x06, 0x06,
+  0x06, 0x0a, 0x09, 0x10, 0x2a, 0x26, 0x22, 0x14, 0x12, 0x12, 0x14, 0x22,
+  0x0a, 0x06, 0x06, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xbe, 0x05, 0xaf,
+  0x04, 0x46, 0x00, 0x17, 0x00, 0x00, 0x25, 0x27, 0x13, 0x21, 0x17, 0x07,
+  0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x13, 0x17, 0x03, 0x21, 0x27, 0x37,
+  0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x02, 0xc2, 0x90, 0x64, 0xfe, 0xc0,
+  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0x78, 0x79, 0x90,
+  0x65, 0x01, 0x40, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe,
+  0x88, 0xbe, 0x3a, 0x01, 0x35, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89,
+  0x78, 0xe9, 0x01, 0x6f, 0x3a, 0xfe, 0xcb, 0xe9, 0x78, 0xfe, 0x77, 0x5a,
+  0xfe, 0x77, 0x78, 0xe9, 0x00, 0x01, 0x01, 0x0c, 0xff, 0xfc, 0x05, 0x0e,
+  0x05, 0xd8, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x13, 0x17, 0x03, 0x01,
+  0x03, 0x37, 0x17, 0x01, 0x27, 0x01, 0x37, 0x13, 0x03, 0xa2, 0xfd, 0x6a,
+  0x8e, 0x96, 0x55, 0x02, 0x96, 0xae, 0xf2, 0x58, 0xfe, 0x67, 0x50, 0xfe,
+  0xe1, 0x7d, 0xab, 0x04, 0x08, 0xfe, 0x58, 0x03, 0x78, 0x1d, 0xfd, 0xee,
+  0x01, 0xa8, 0xfb, 0xb8, 0xbe, 0x8b, 0xfe, 0xc0, 0x10, 0x01, 0xc8, 0x62,
+  0xfe, 0xf1, 0x00, 0x00, 0x00, 0x01, 0x01, 0x37, 0x00, 0x00, 0x04, 0x89,
+  0x05, 0xf2, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x17,
+  0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x04, 0x88, 0x99, 0xfe, 0x44, 0xd2,
+  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x04, 0x91, 0xfb, 0x6f, 0x03,
+  0xe7, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x81, 0x00, 0x00, 0x04, 0xd2, 0x05, 0xf2, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
+  0x11, 0x23, 0x01, 0x81, 0x02, 0x55, 0xd2, 0x6c, 0x01, 0x62, 0xfe, 0x9e,
+  0x6c, 0xd2, 0xfe, 0x44, 0x99, 0x04, 0x91, 0xe9, 0x78, 0xfe, 0x77, 0x5a,
+  0xfe, 0x77, 0x78, 0xe9, 0xfc, 0x19, 0x00, 0x00, 0x00, 0x01, 0x01, 0x37,
+  0xff, 0xe3, 0x04, 0x89, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
+  0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x04, 0x88,
+  0xfd, 0xab, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0xbc,
+  0x99, 0x01, 0x44, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9,
+  0x03, 0xe7, 0x00, 0x00, 0x00, 0x01, 0x01, 0x81, 0xff, 0xe3, 0x04, 0xd2,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x27,
+  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x01, 0x81, 0x99, 0x01, 0xbc, 0xd2,
+  0x6c, 0x01, 0x62, 0xfe, 0x9e, 0x6c, 0xd2, 0x01, 0x44, 0x04, 0x91, 0xfc,
+  0x19, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0xad, 0xff, 0xf9, 0x05, 0x79, 0x04, 0xd4, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x37, 0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x11,
+  0x21, 0x35, 0x04, 0x3b, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9e, 0x6c,
+  0xd2, 0xfe, 0x0b, 0x04, 0xd4, 0xfc, 0x3d, 0xe9, 0x78, 0xfe, 0x77, 0x01,
+  0x89, 0x78, 0xe9, 0x03, 0x19, 0xaa, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0xcc, 0x04, 0xb9, 0x05, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
+  0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x04, 0xb9,
+  0xfc, 0x9d, 0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x02, 0xca,
+  0x99, 0x02, 0x2d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9,
+  0x02, 0x2c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x28, 0x01, 0xa0, 0x05, 0xc2,
+  0x05, 0x58, 0x00, 0x26, 0x00, 0x00, 0x01, 0x37, 0x17, 0x01, 0x23, 0x01,
+  0x37, 0x17, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x23, 0x34, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x02, 0x00, 0xd1,
+  0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9d, 0x6c, 0xd3, 0x29, 0x29, 0x53, 0x51,
+  0x63, 0x61, 0xe6, 0x62, 0x63, 0x51, 0x52, 0x29, 0x29, 0x99, 0x3b, 0x3b,
+  0x36, 0x4e, 0x42, 0xac, 0x46, 0x4a, 0x39, 0x3a, 0x1f, 0x1e, 0x02, 0xb8,
+  0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0xea, 0x32, 0x7f, 0x70, 0x6b,
+  0x5f, 0x56, 0x31, 0x2e, 0x2e, 0x31, 0x56, 0x5f, 0x6b, 0x70, 0x7f, 0x5d,
+  0xa2, 0x42, 0x3b, 0x27, 0x21, 0x21, 0x23, 0x3f, 0x40, 0x53, 0x51, 0x5d,
+  0x00, 0x01, 0x00, 0x47, 0x01, 0xa0, 0x05, 0xe0, 0x05, 0x58, 0x00, 0x26,
+  0x00, 0x00, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22,
+  0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x1d, 0x01, 0x37,
+  0x17, 0x01, 0x23, 0x01, 0x37, 0x04, 0x08, 0x1d, 0x20, 0x39, 0x3a, 0x4a,
+  0x46, 0xab, 0x43, 0x4d, 0x36, 0x3b, 0x3c, 0x99, 0x29, 0x29, 0x53, 0x51,
+  0x63, 0x61, 0xe6, 0x62, 0x63, 0x51, 0x52, 0x29, 0x29, 0xd3, 0x6c, 0xfe,
+  0x9d, 0x51, 0xfe, 0xa0, 0x6c, 0x02, 0xb8, 0x32, 0x5d, 0x51, 0x53, 0x40,
+  0x3f, 0x23, 0x21, 0x21, 0x27, 0x3b, 0x42, 0xa2, 0x5d, 0x7f, 0x70, 0x6b,
+  0x5f, 0x56, 0x31, 0x2e, 0x2e, 0x31, 0x56, 0x5f, 0x6b, 0x70, 0x7f, 0x32,
+  0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0x00, 0x00, 0x02, 0x00, 0xc7,
+  0x00, 0x34, 0x05, 0xac, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00,
+  0x13, 0x35, 0x21, 0x15, 0x05, 0x37, 0x21, 0x15, 0x21, 0x01, 0x07, 0x01,
+  0x11, 0x23, 0xc8, 0x04, 0xe4, 0xfb, 0x57, 0x39, 0x01, 0xf4, 0xfe, 0xd7,
+  0x03, 0x08, 0x6c, 0xfc, 0xf8, 0x98, 0x05, 0x72, 0x63, 0x63, 0xfe, 0x3f,
+  0xa9, 0xfc, 0xa2, 0x78, 0x03, 0x5e, 0xfe, 0xb6, 0x00, 0x02, 0x00, 0x64,
+  0xff, 0xa1, 0x05, 0xa4, 0x05, 0x63, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x00,
+  0x13, 0x35, 0x21, 0x27, 0x37, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x01,
+  0x27, 0x37, 0x01, 0x21, 0x17, 0x07, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11,
+  0x01, 0x17, 0x07, 0x21, 0x65, 0x03, 0xaa, 0xd3, 0x6c, 0x01, 0x63, 0x99,
+  0x99, 0xfe, 0x9d, 0x6c, 0xd3, 0x01, 0x95, 0xfc, 0x56, 0xd2, 0x6c, 0xfe,
+  0x9e, 0x99, 0x99, 0x01, 0x62, 0x6c, 0xd2, 0x03, 0xaa, 0x01, 0x01, 0xaa,
+  0xe8, 0x78, 0xfe, 0x78, 0x01, 0x4e, 0xfd, 0x08, 0x01, 0x50, 0xfe, 0x78,
+  0x78, 0xe8, 0x02, 0x58, 0xe8, 0x78, 0x01, 0x88, 0xfe, 0xb0, 0x02, 0xf8,
+  0xfe, 0xb2, 0x01, 0x88, 0x78, 0xe8, 0x00, 0x00, 0x00, 0x01, 0x00, 0xbd,
+  0x00, 0x7f, 0x05, 0x7d, 0x05, 0x70, 0x00, 0x36, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36,
+  0x37, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x11, 0x23, 0x11,
+  0x37, 0x21, 0x15, 0x21, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0xcf, 0x3e, 0x1c, 0x1e, 0x3b, 0x3c,
+  0x36, 0x4d, 0x43, 0xab, 0x46, 0x4a, 0x39, 0x3c, 0x3b, 0x1e, 0x1e, 0x3c,
+  0x1f, 0x99, 0x39, 0x01, 0xf5, 0xfe, 0xd7, 0x1f, 0x51, 0x2b, 0x29, 0x29,
+  0x2b, 0x51, 0x4b, 0x69, 0x5c, 0x78, 0x73, 0x61, 0x65, 0x4f, 0x51, 0x2b,
+  0x29, 0x29, 0x29, 0x53, 0x04, 0x2b, 0x42, 0x51, 0x51, 0x5d, 0x5a, 0xa2,
+  0x42, 0x3b, 0x27, 0x21, 0x21, 0x23, 0x3f, 0x42, 0xa2, 0x5a, 0x5d, 0x51,
+  0x51, 0x42, 0x23, 0xfe, 0xb6, 0x02, 0x2c, 0x40, 0xaa, 0x23, 0x5a, 0x70,
+  0x70, 0x7f, 0x7c, 0x70, 0x71, 0x59, 0x53, 0x34, 0x2e, 0x2e, 0x30, 0x57,
+  0x59, 0x71, 0x70, 0x7c, 0x7f, 0x70, 0x6b, 0x5f, 0x00, 0x01, 0x00, 0x8d,
+  0x00, 0x7f, 0x05, 0x4d, 0x05, 0x70, 0x00, 0x36, 0x00, 0x00, 0x01, 0x37,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3f,
+  0x01, 0x21, 0x35, 0x21, 0x17, 0x11, 0x23, 0x11, 0x07, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e,
+  0x01, 0x35, 0x34, 0x27, 0x26, 0x04, 0x3c, 0x6c, 0x52, 0x29, 0x29, 0x29,
+  0x2b, 0x50, 0x50, 0x64, 0x62, 0x73, 0x77, 0x5d, 0x69, 0x4b, 0x50, 0x2b,
+  0x2a, 0x2a, 0x2a, 0x51, 0x1f, 0xfe, 0xd7, 0x01, 0xf5, 0x39, 0x99, 0x1f,
+  0x3c, 0x1e, 0x1e, 0x3b, 0x3c, 0x3a, 0x49, 0x47, 0xaa, 0x43, 0x4d, 0x36,
+  0x3c, 0x3b, 0x1d, 0x1d, 0x04, 0x2b, 0x78, 0x5f, 0x6b, 0x70, 0x7f, 0x7c,
+  0x70, 0x71, 0x59, 0x57, 0x30, 0x2e, 0x2e, 0x34, 0x53, 0x59, 0x71, 0x70,
+  0x7c, 0x7f, 0x70, 0x70, 0x5a, 0x23, 0xaa, 0x40, 0xfd, 0xd4, 0x01, 0x4a,
+  0x23, 0x42, 0x51, 0x51, 0x5d, 0x5a, 0xa2, 0x42, 0x3f, 0x23, 0x21, 0x21,
+  0x27, 0x3b, 0x42, 0xa2, 0x5a, 0x5d, 0x51, 0x51, 0x00, 0x01, 0x00, 0x5a,
+  0x02, 0x2d, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x06, 0x00, 0x00, 0x13, 0x35,
+  0x01, 0x17, 0x07, 0x21, 0x15, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x04, 0x49,
+  0x02, 0x2d, 0x82, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0xa0, 0x02, 0xd7, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x17, 0x07, 0x01, 0x5a, 0x05, 0x45, 0xfb, 0xb7, 0xd2, 0x6c,
+  0xfe, 0x9e, 0x02, 0xd7, 0xaa, 0xe9, 0x78, 0x01, 0x89, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0xb7, 0x00, 0x00, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x23, 0x02, 0xb8, 0x75,
+  0x01, 0x61, 0x6c, 0xd1, 0x99, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea, 0xfb,
+  0x3c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x03, 0x51,
+  0x05, 0xdc, 0x00, 0x06, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27,
+  0x01, 0x03, 0x51, 0x99, 0xd3, 0x6c, 0x01, 0x63, 0x05, 0xdc, 0xfa, 0x24,
+  0x04, 0xc4, 0xea, 0x78, 0x01, 0x8a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x02, 0x2d, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x06, 0x00, 0x00, 0x01, 0x21,
+  0x35, 0x21, 0x27, 0x37, 0x01, 0x05, 0xae, 0xfa, 0xbb, 0x04, 0x49, 0xd1,
+  0x6c, 0x01, 0x61, 0x02, 0x2d, 0xaa, 0xe9, 0x78, 0xfe, 0x77, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x02, 0xd7, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x35, 0x05, 0xae, 0xfe,
+  0x9f, 0x6c, 0xd1, 0xfb, 0xb7, 0x02, 0xd7, 0x82, 0xfe, 0x77, 0x78, 0xe9,
+  0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0xb7, 0x00, 0x00, 0x04, 0x8e,
+  0x05, 0xdc, 0x00, 0x06, 0x00, 0x00, 0x21, 0x11, 0x33, 0x11, 0x37, 0x17,
+  0x01, 0x02, 0xb8, 0x99, 0xd1, 0x6c, 0xfe, 0x9f, 0x05, 0xdc, 0xfb, 0x3c,
+  0xea, 0x78, 0xfe, 0x76, 0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x03, 0x51,
+  0x05, 0xdc, 0x00, 0x06, 0x00, 0x00, 0x21, 0x23, 0x01, 0x37, 0x17, 0x11,
+  0x33, 0x03, 0x51, 0x75, 0xfe, 0x9d, 0x6c, 0xd3, 0x99, 0x01, 0x8a, 0x78,
+  0xea, 0x04, 0xc4, 0x00, 0xff, 0xff, 0x00, 0x5a, 0xff, 0xa0, 0x05, 0xaf,
+  0x05, 0x64, 0x10, 0x27, 0x08, 0x6c, 0x00, 0x00, 0xfe, 0xd4, 0x10, 0x07,
+  0x08, 0x6e, 0x00, 0x00, 0x01, 0x2c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6b,
+  0xff, 0xf9, 0x05, 0x9c, 0x05, 0xdc, 0x10, 0x27, 0x08, 0x6f, 0x01, 0x0e,
+  0x00, 0x00, 0x10, 0x07, 0x08, 0x6d, 0xfe, 0xf2, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x5a, 0xff, 0xa0, 0x05, 0xaf, 0x05, 0x64, 0x10, 0x27,
+  0x08, 0x6e, 0x00, 0x00, 0xfe, 0xd4, 0x10, 0x07, 0x08, 0x6c, 0x00, 0x00,
+  0x01, 0x2c, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0xff, 0xa0, 0x05, 0xa0,
+  0x05, 0x64, 0x00, 0x11, 0x00, 0x00, 0x01, 0x03, 0x35, 0x01, 0x17, 0x07,
+  0x21, 0x15, 0x21, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01, 0x35,
+  0x01, 0x40, 0xe6, 0x01, 0x62, 0x6c, 0xd2, 0x04, 0x49, 0xfb, 0xb7, 0xc2,
+  0xc2, 0x04, 0x49, 0xfb, 0xb7, 0xd2, 0x6c, 0xfe, 0x9e, 0x02, 0x82, 0x00,
+  0xff, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0xd7, 0xd7, 0xaa, 0xe9, 0x78,
+  0x01, 0x89, 0x5a, 0x00, 0x00, 0x01, 0x00, 0x6c, 0x00, 0x00, 0x05, 0x9d,
+  0x05, 0xdc, 0x00, 0x11, 0x00, 0x00, 0x01, 0x13, 0x33, 0x01, 0x07, 0x27,
+  0x11, 0x23, 0x11, 0x07, 0x27, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x33,
+  0x03, 0x04, 0xe5, 0x51, 0x01, 0x62, 0x6c, 0xd2, 0x99, 0xc1, 0xc2, 0x99,
+  0xd1, 0x6c, 0x01, 0x61, 0x51, 0x04, 0xdc, 0x01, 0x00, 0xfe, 0x76, 0x78,
+  0xea, 0xfb, 0x3c, 0x04, 0xc4, 0xd8, 0xd8, 0xfb, 0x3c, 0x04, 0xc4, 0xea,
+  0x78, 0x01, 0x8a, 0x00, 0x00, 0x01, 0x00, 0x6a, 0xff, 0xa0, 0x05, 0xb0,
+  0x05, 0x64, 0x00, 0x11, 0x00, 0x00, 0x01, 0x17, 0x15, 0x01, 0x27, 0x37,
+  0x21, 0x35, 0x21, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x15,
+  0x04, 0xca, 0xe5, 0xfe, 0x9f, 0x6c, 0xd1, 0xfb, 0xb7, 0x04, 0x49, 0xc1,
+  0xc1, 0xfb, 0xb7, 0x04, 0x49, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x82, 0xff,
+  0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xaa, 0xd7, 0xd7, 0xaa, 0xe9, 0x78, 0xfe,
+  0x77, 0x5a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6c, 0xff, 0xf9, 0x05, 0x9d,
+  0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x25, 0x03, 0x23, 0x01, 0x37, 0x17,
+  0x11, 0x33, 0x11, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x23,
+  0x03, 0x04, 0xe6, 0x51, 0xfe, 0x9f, 0x6c, 0xd1, 0x99, 0xc2, 0xc1, 0x99,
+  0xd2, 0x6c, 0xfe, 0x9e, 0x51, 0xf9, 0xff, 0x00, 0x01, 0x8a, 0x78, 0xea,
+  0x04, 0xc4, 0xfb, 0x3c, 0xd8, 0xd8, 0x04, 0xc4, 0xfb, 0x3c, 0xea, 0x78,
+  0xfe, 0x76, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5a, 0x00, 0x0e, 0x05, 0xaf,
+  0x04, 0xf6, 0x10, 0x27, 0x08, 0x9d, 0x00, 0x00, 0xff, 0x42, 0x10, 0x07,
+  0x08, 0x98, 0x00, 0x00, 0x00, 0xbe, 0x00, 0x00, 0xff, 0xff, 0x00, 0x5a,
+  0x00, 0x0e, 0x05, 0xaf, 0x04, 0xf6, 0x10, 0x27, 0x08, 0x99, 0x00, 0x00,
+  0xff, 0x42, 0x10, 0x07, 0x08, 0x9c, 0x00, 0x00, 0x00, 0xbe, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x04,
+  0x00, 0x1a, 0x00, 0x00, 0x01, 0x21, 0x07, 0x17, 0x21, 0x25, 0x07, 0x21,
+  0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
+  0x07, 0x21, 0x37, 0x17, 0x07, 0x21, 0x15, 0x03, 0x92, 0xfd, 0xd6, 0x5e,
+  0x5e, 0x01, 0xbd, 0x01, 0x08, 0x6d, 0x01, 0xdf, 0xfd, 0xe3, 0x69, 0x75,
+  0x42, 0xfe, 0xee, 0x54, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x01,
+  0xfc, 0x69, 0x75, 0x42, 0x01, 0x33, 0x02, 0xeb, 0x69, 0x69, 0xd2, 0xd2,
+  0x78, 0xca, 0x4b, 0x7f, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78,
+  0x5d, 0xca, 0x4b, 0x7f, 0x78, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x5a,
+  0x00, 0xc1, 0x05, 0xaf, 0x04, 0x43, 0x00, 0x17, 0x00, 0x1c, 0x00, 0x21,
+  0x00, 0x00, 0x25, 0x27, 0x37, 0x23, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
+  0x07, 0x21, 0x37, 0x17, 0x07, 0x33, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27,
+  0x37, 0x21, 0x13, 0x07, 0x21, 0x37, 0x27, 0x29, 0x01, 0x07, 0x17, 0x21,
+  0x02, 0xba, 0x7f, 0x37, 0x9e, 0x54, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c,
+  0x54, 0x01, 0x32, 0x49, 0x7f, 0x38, 0x9e, 0x53, 0x6c, 0x01, 0x61, 0xfe,
+  0x9f, 0x6c, 0x53, 0xfe, 0xce, 0x6c, 0x44, 0x01, 0x76, 0x5f, 0x5f, 0xfe,
+  0x3e, 0xfe, 0x8a, 0x5e, 0x5e, 0x01, 0x32, 0xc1, 0x34, 0xac, 0x5d, 0x78,
+  0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d, 0xe0, 0x34, 0xac, 0x5d, 0x78,
+  0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x5d, 0x01, 0x4a, 0xd2, 0x69, 0x69,
+  0x69, 0x69, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x04, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x21, 0x37, 0x27,
+  0x21, 0x05, 0x37, 0x21, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21, 0x27, 0x37,
+  0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x02,
+  0x77, 0x02, 0x29, 0x5f, 0x5f, 0xfe, 0x44, 0xfe, 0xf7, 0x6d, 0xfe, 0x21,
+  0x02, 0x1d, 0x6a, 0x74, 0x41, 0x01, 0x11, 0x53, 0x6c, 0x01, 0x61, 0xfe,
+  0x9f, 0x6c, 0x53, 0xfe, 0x05, 0x69, 0x76, 0x42, 0xfe, 0xcd, 0x02, 0x19,
+  0x69, 0x69, 0xd2, 0xd2, 0x78, 0xca, 0x4b, 0x7f, 0x5d, 0x78, 0xfe, 0x77,
+  0x5a, 0xfe, 0x77, 0x78, 0x5d, 0xca, 0x4b, 0x7f, 0x78, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0e,
+  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
+  0x07, 0x21, 0x15, 0x21, 0x07, 0x01, 0x68, 0x04, 0x37, 0xfc, 0x35, 0x54,
+  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x03, 0xcb, 0xfb, 0xc9, 0x5e,
+  0x02, 0x19, 0x78, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d,
+  0x78, 0x69, 0x00, 0x00, 0x00, 0x01, 0x01, 0x7a, 0x00, 0x00, 0x04, 0x90,
+  0x05, 0xdc, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27,
+  0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x23, 0x11, 0x27, 0x02, 0xa6, 0x6c,
+  0x53, 0x6c, 0x01, 0x61, 0x51, 0x01, 0x62, 0x6c, 0x54, 0x6c, 0x5e, 0x04,
+  0xb0, 0xfb, 0x50, 0x04, 0x38, 0x5e, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78,
+  0x5e, 0xfb, 0xc8, 0x04, 0xb0, 0x68, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x37,
+  0x27, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
+  0x35, 0x04, 0xa0, 0x5f, 0x5f, 0xfb, 0xc9, 0x03, 0xcb, 0x53, 0x6c, 0x01,
+  0x61, 0xfe, 0x9f, 0x6c, 0x53, 0xfc, 0x35, 0x02, 0x19, 0x69, 0x69, 0x78,
+  0x5d, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x5d, 0x78, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x7a, 0xff, 0xf9, 0x04, 0x90, 0x05, 0xd5, 0x00, 0x0e,
+  0x00, 0x00, 0x01, 0x17, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x23,
+  0x01, 0x37, 0x17, 0x11, 0x33, 0x02, 0xa6, 0x5f, 0x5e, 0x6c, 0x54, 0x6c,
+  0xfe, 0x9e, 0x51, 0xfe, 0x9f, 0x6c, 0x53, 0x6c, 0x01, 0x25, 0x68, 0x68,
+  0x04, 0xb0, 0xfb, 0xc8, 0x5e, 0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0x5e,
+  0x04, 0x38, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x05, 0x00, 0x15, 0x00, 0x00, 0x01, 0x21, 0x37, 0x27,
+  0x21, 0x07, 0x05, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21,
+  0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x01, 0x68, 0x03, 0x38, 0x5f, 0x5f,
+  0xfc, 0xc8, 0x5e, 0x03, 0x2a, 0xfd, 0xa0, 0x54, 0x6c, 0xfe, 0x9e, 0x01,
+  0x62, 0x6c, 0x54, 0x02, 0x60, 0x53, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
+  0x02, 0x19, 0x69, 0x69, 0x69, 0xe1, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01,
+  0x89, 0x78, 0x5d, 0x5d, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x00,
+  0x00, 0x02, 0x01, 0x7a, 0xff, 0xf0, 0x04, 0x8f, 0x05, 0xdc, 0x00, 0x05,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x11, 0x17, 0x37, 0x11, 0x27, 0x03, 0x11,
+  0x07, 0x27, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x37, 0x17, 0x01, 0x23,
+  0x01, 0x37, 0x02, 0xa6, 0x5e, 0x5f, 0x5f, 0xca, 0x54, 0x6c, 0x01, 0x62,
+  0x51, 0x01, 0x61, 0x6c, 0x53, 0x53, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9e,
+  0x6c, 0x04, 0xb0, 0xfc, 0x6c, 0x69, 0x69, 0x03, 0x94, 0x69, 0xfc, 0x7b,
+  0x02, 0xa4, 0x5d, 0x78, 0x01, 0x89, 0xfe, 0x77, 0x78, 0x5d, 0xfd, 0x5c,
+  0x5d, 0x78, 0xfe, 0x77, 0x01, 0x89, 0x78, 0x00, 0x00, 0x01, 0x01, 0x03,
+  0xff, 0xd1, 0x05, 0x6a, 0x04, 0xb3, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01,
+  0x07, 0x01, 0x15, 0x23, 0x11, 0x37, 0x21, 0x15, 0x23, 0x01, 0x07, 0x01,
+  0x23, 0x01, 0x9b, 0x02, 0xfb, 0x4c, 0xfd, 0x51, 0x98, 0x39, 0x01, 0xf4,
+  0x76, 0x02, 0xaf, 0x4c, 0xfd, 0x04, 0x86, 0x03, 0x76, 0xfc, 0xb0, 0x55,
+  0x02, 0xfb, 0x84, 0x02, 0x2c, 0x3f, 0xa9, 0xfd, 0x05, 0x55, 0x03, 0x50,
+  0x00, 0x01, 0x00, 0xa9, 0xff, 0xd1, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x0e,
+  0x00, 0x00, 0x01, 0x35, 0x23, 0x01, 0x27, 0x01, 0x23, 0x35, 0x21, 0x17,
+  0x11, 0x23, 0x35, 0x01, 0x27, 0x04, 0x77, 0x86, 0xfd, 0x05, 0x4d, 0x02,
+  0xaf, 0x76, 0x01, 0xf4, 0x39, 0x98, 0xfd, 0x51, 0x4c, 0x03, 0x76, 0x94,
+  0xfc, 0xb0, 0x55, 0x02, 0xfb, 0xa9, 0x3f, 0xfd, 0xd4, 0x84, 0xfd, 0x05,
+  0x55, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa9, 0x00, 0x34, 0x05, 0x10,
+  0x05, 0x16, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01, 0x37, 0x01, 0x35, 0x33,
+  0x11, 0x07, 0x21, 0x35, 0x33, 0x01, 0x37, 0x01, 0x33, 0x04, 0x77, 0xfd,
+  0x05, 0x4c, 0x02, 0xaf, 0x98, 0x39, 0xfe, 0x0c, 0x76, 0xfd, 0x51, 0x4d,
+  0x02, 0xfb, 0x86, 0x01, 0x71, 0x03, 0x50, 0x55, 0xfd, 0x05, 0x84, 0xfd,
+  0xd4, 0x3f, 0xa9, 0x02, 0xfb, 0x55, 0xfc, 0xb0, 0x00, 0x01, 0x01, 0x03,
+  0x00, 0x34, 0x05, 0x6a, 0x05, 0x16, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x15,
+  0x33, 0x01, 0x17, 0x01, 0x33, 0x15, 0x21, 0x27, 0x11, 0x33, 0x15, 0x01,
+  0x17, 0x01, 0x9b, 0x86, 0x02, 0xfc, 0x4c, 0xfd, 0x51, 0x76, 0xfe, 0x0c,
+  0x39, 0x98, 0x02, 0xaf, 0x4c, 0x01, 0x71, 0x94, 0x03, 0x50, 0x55, 0xfd,
+  0x05, 0xa9, 0x3f, 0x02, 0x2c, 0x84, 0x02, 0xfb, 0x55, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0f,
+  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x17, 0x21, 0x15, 0x21, 0x07, 0x01,
+  0x35, 0x01, 0x17, 0x21, 0x15, 0x21, 0x01, 0x40, 0x04, 0x5f, 0xfb, 0xa1,
+  0x7c, 0x03, 0xe3, 0xfc, 0x89, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x03,
+  0x77, 0xfc, 0x1d, 0x02, 0xbe, 0x78, 0x8a, 0x78, 0x78, 0x01, 0x89, 0x5a,
+  0x01, 0x89, 0x78, 0x78, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x27, 0x21,
+  0x35, 0x21, 0x37, 0x01, 0x15, 0x01, 0x27, 0x21, 0x35, 0x21, 0x04, 0xc9,
+  0xfb, 0xa0, 0x04, 0x60, 0x7c, 0xfc, 0x1c, 0x03, 0x78, 0x6c, 0x01, 0x61,
+  0xfe, 0x9f, 0x6c, 0xfc, 0x88, 0x03, 0xe4, 0x02, 0x46, 0x78, 0x8a, 0x78,
+  0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0x78, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x18, 0x00, 0x00, 0x01, 0x23,
+  0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x23, 0x17, 0x07, 0x01, 0x35,
+  0x01, 0x17, 0x07, 0x33, 0x17, 0x37, 0x17, 0x37, 0x17, 0x37, 0x17, 0x05,
+  0x9f, 0x24, 0x3f, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x63, 0x59, 0xd2, 0x6c,
+  0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x7d, 0x3f, 0xa2, 0xa2, 0xa2, 0xa2,
+  0xa2, 0x63, 0x02, 0x2d, 0x46, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x6e, 0xe9,
+  0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x46, 0xb4, 0xb4, 0xb4,
+  0xb4, 0xb4, 0x6e, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x18, 0x00, 0x00, 0x13, 0x35, 0x37, 0x17, 0x37, 0x17,
+  0x37, 0x17, 0x37, 0x33, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x23,
+  0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x69, 0x63, 0xa2, 0xa2, 0xa2,
+  0xa2, 0xa2, 0x3f, 0x7d, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1,
+  0x59, 0x63, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x3f, 0x02, 0x2d, 0xaa, 0x6e,
+  0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
+  0x77, 0x78, 0xe9, 0x6e, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x33, 0x01, 0x07, 0x27, 0x11, 0x21, 0x15, 0x21, 0x15,
+  0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35,
+  0x21, 0x11, 0x07, 0x27, 0x02, 0xdc, 0x51, 0x01, 0x61, 0x6c, 0xd1, 0x01,
+  0x0a, 0xfe, 0xf6, 0x01, 0x0a, 0xfe, 0xf6, 0x99, 0xfe, 0xf7, 0x01, 0x09,
+  0xfe, 0xf7, 0x01, 0x09, 0xd3, 0x6c, 0x05, 0xdc, 0xfe, 0x76, 0x78, 0xea,
+  0xfe, 0x8e, 0xaa, 0xaa, 0xaa, 0xfe, 0xac, 0x01, 0x54, 0xaa, 0xaa, 0xaa,
+  0x01, 0x72, 0xea, 0x78, 0x00, 0x01, 0x01, 0x79, 0xff, 0xf9, 0x04, 0x8e,
+  0x05, 0xd5, 0x00, 0x19, 0x00, 0x00, 0x05, 0x23, 0x01, 0x37, 0x17, 0x11,
+  0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15,
+  0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x37, 0x17, 0x03, 0x2b, 0x51, 0xfe,
+  0x9f, 0x6c, 0xd1, 0xfe, 0xf6, 0x01, 0x0a, 0xfe, 0xf6, 0x01, 0x0a, 0x99,
+  0x01, 0x09, 0xfe, 0xf7, 0x01, 0x09, 0xfe, 0xf7, 0xd3, 0x6c, 0x07, 0x01,
+  0x8a, 0x78, 0xea, 0x01, 0x72, 0xaa, 0xaa, 0xaa, 0x01, 0x54, 0xfe, 0xac,
+  0xaa, 0xaa, 0xaa, 0xfe, 0x8e, 0xea, 0x78, 0x00, 0x00, 0x03, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x17, 0x07,
+  0x01, 0x35, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x5a, 0x01, 0x62, 0x6c,
+  0xd2, 0x01, 0x4c, 0xfe, 0xb4, 0xd2, 0x6c, 0x01, 0x7f, 0xe6, 0x99, 0xe5,
+  0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0xe9, 0x78, 0x01, 0x61,
+  0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x03, 0x01, 0x79, 0x00, 0x00, 0x04, 0x90,
+  0x05, 0xdc, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x01, 0x33,
+  0x01, 0x07, 0x27, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x33, 0x15, 0x23,
+  0x15, 0x33, 0x11, 0x23, 0x02, 0xdc, 0x51, 0x01, 0x62, 0x6c, 0xd2, 0x99,
+  0xd3, 0x6c, 0x01, 0x3f, 0x99, 0x99, 0x99, 0x99, 0x05, 0xdc, 0xfe, 0x76,
+  0x78, 0xea, 0xfe, 0x8e, 0x01, 0x72, 0xea, 0x78, 0xfe, 0x56, 0xfe, 0xaa,
+  0xff, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01,
+  0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x25, 0x33, 0x15, 0x23,
+  0x27, 0x15, 0x23, 0x35, 0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0xb4,
+  0x01, 0x4c, 0xd1, 0x6c, 0x01, 0x61, 0xfc, 0x3a, 0xe5, 0xe5, 0x99, 0xe6,
+  0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0xaa, 0xe9, 0x78, 0xfe, 0x77, 0x28,
+  0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x03, 0x01, 0x79, 0xff, 0xf9, 0x04, 0x90,
+  0x05, 0xd5, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x05, 0x01,
+  0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x03, 0x35, 0x33, 0x15,
+  0x03, 0x11, 0x33, 0x11, 0x02, 0xdc, 0xfe, 0x9d, 0x6c, 0xd3, 0x99, 0xd2,
+  0x6c, 0xfe, 0x9e, 0x75, 0x99, 0x99, 0x99, 0x07, 0x01, 0x8a, 0x78, 0xea,
+  0x01, 0x72, 0xfe, 0x8e, 0xea, 0x78, 0xfe, 0x76, 0x03, 0x34, 0xfe, 0xfe,
+  0x01, 0xa8, 0x01, 0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x60,
+  0x00, 0xcb, 0x05, 0xa0, 0x04, 0x39, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x15,
+  0x21, 0x17, 0x07, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x01, 0x17, 0x07,
+  0x05, 0x9f, 0xfc, 0x56, 0xd3, 0x6c, 0xfe, 0x9d, 0x99, 0x99, 0x01, 0x63,
+  0x6c, 0xd3, 0x02, 0xd7, 0xaa, 0xea, 0x78, 0x01, 0x8a, 0xfe, 0x7e, 0x03,
+  0x5c, 0xfe, 0x80, 0x01, 0x8a, 0x78, 0xea, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x00, 0xcb, 0x05, 0xa9, 0x04, 0x39, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x21,
+  0x27, 0x37, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x01, 0x27, 0x37, 0x21,
+  0x69, 0x03, 0xaa, 0xd3, 0x6c, 0x01, 0x63, 0x99, 0x99, 0xfe, 0x9d, 0x6c,
+  0xd3, 0xfc, 0x56, 0x02, 0xd7, 0xea, 0x78, 0xfe, 0x76, 0x01, 0x80, 0xfc,
+  0xa4, 0x01, 0x82, 0xfe, 0x76, 0x78, 0xea, 0x00, 0x00, 0x02, 0x00, 0x31,
+  0x00, 0x86, 0x05, 0xa0, 0x04, 0x7e, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
+  0x01, 0x03, 0x13, 0x35, 0x21, 0x11, 0x21, 0x13, 0x09, 0x01, 0x11, 0x21,
+  0x11, 0x21, 0x01, 0xa1, 0xf0, 0xf0, 0x03, 0xa4, 0xfc, 0x5c, 0x5a, 0xfe,
+  0x37, 0x01, 0xc9, 0x03, 0xa4, 0xfc, 0x5c, 0x03, 0x8c, 0xfe, 0xf6, 0xfe,
+  0xf6, 0x83, 0x01, 0x0e, 0xfd, 0x7d, 0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef,
+  0xfe, 0x2a, 0x00, 0x00, 0x00, 0x02, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce,
+  0x06, 0x08, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x0b, 0x01, 0x33,
+  0x11, 0x33, 0x11, 0x05, 0x09, 0x01, 0x23, 0x11, 0x21, 0x11, 0x03, 0xf4,
+  0xf0, 0xef, 0x76, 0xf3, 0xfd, 0xbd, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0xfe,
+  0x59, 0x04, 0x70, 0x01, 0x0a, 0xfe, 0xf6, 0xfb, 0xf4, 0x04, 0x0c, 0x64,
+  0x01, 0xfc, 0xfe, 0x04, 0xfb, 0xf4, 0x04, 0x0c, 0x00, 0x02, 0x00, 0x40,
+  0x00, 0x86, 0x05, 0xaf, 0x04, 0x7e, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
+  0x01, 0x15, 0x21, 0x11, 0x21, 0x15, 0x13, 0x01, 0x11, 0x21, 0x11, 0x21,
+  0x11, 0x01, 0x04, 0x3f, 0xfc, 0x5c, 0x03, 0xa4, 0xf0, 0xfe, 0xb6, 0xfc,
+  0x5c, 0x03, 0xa4, 0x01, 0xc9, 0x03, 0x8c, 0x83, 0xfe, 0xf2, 0x83, 0x01,
+  0x0a, 0xfe, 0x04, 0x01, 0x11, 0x01, 0xd6, 0x01, 0x11, 0xfe, 0x04, 0x00,
+  0x00, 0x02, 0x01, 0x3b, 0xff, 0xcd, 0x04, 0xce, 0x05, 0xd5, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x01, 0x23, 0x11, 0x23, 0x11, 0x23, 0x13, 0x01,
+  0x33, 0x11, 0x21, 0x11, 0x33, 0x01, 0x03, 0xf4, 0x76, 0xf3, 0x76, 0xef,
+  0xfe, 0x37, 0xf6, 0x01, 0xa7, 0xf5, 0xfe, 0x37, 0x01, 0x65, 0x04, 0x0c,
+  0xfb, 0xf4, 0xfe, 0xf6, 0x01, 0x6e, 0x04, 0x0c, 0xfb, 0xf4, 0xfe, 0x04,
+  0x00, 0x04, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23,
+  0x09, 0x01, 0x23, 0x03, 0x11, 0x33, 0x0b, 0x01, 0x33, 0x11, 0x01, 0x11,
+  0x21, 0x11, 0x05, 0x23, 0x15, 0x33, 0x03, 0xd8, 0xfe, 0x59, 0xf6, 0x01,
+  0xc9, 0x01, 0xc9, 0xf5, 0x5a, 0x76, 0xf0, 0xef, 0x76, 0x01, 0x4d, 0xfe,
+  0x59, 0x01, 0x4d, 0xf3, 0xf3, 0x02, 0x24, 0x01, 0xe8, 0x01, 0xfc, 0xfe,
+  0x04, 0xfe, 0x7c, 0x01, 0xe8, 0x01, 0x0a, 0xfe, 0xf6, 0xfe, 0x18, 0xfe,
+  0xd4, 0xfe, 0xa4, 0x01, 0x5c, 0x64, 0x94, 0x00, 0x00, 0x02, 0x01, 0x3b,
+  0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00,
+  0x29, 0x01, 0x11, 0x33, 0x11, 0x23, 0x09, 0x01, 0x23, 0x11, 0x33, 0x05,
+  0x23, 0x15, 0x21, 0x35, 0x23, 0x11, 0x33, 0x0b, 0x01, 0x33, 0x04, 0x8c,
+  0xfc, 0xf1, 0xb4, 0xf6, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0xb4, 0xfd, 0xff,
+  0xb4, 0x02, 0x5b, 0xb4, 0x76, 0xf0, 0xef, 0x76, 0x01, 0x5c, 0x02, 0xb0,
+  0x01, 0xfc, 0xfe, 0x04, 0xfd, 0x50, 0x64, 0x94, 0x94, 0x03, 0x78, 0x01,
+  0x0a, 0xfe, 0xf6, 0x00, 0x00, 0x03, 0x01, 0x20, 0x00, 0x00, 0x04, 0xe9,
+  0x06, 0x08, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x19, 0x00, 0x00, 0x25, 0x23,
+  0x15, 0x21, 0x35, 0x23, 0x11, 0x33, 0x27, 0x21, 0x07, 0x33, 0x01, 0x21,
+  0x11, 0x33, 0x11, 0x21, 0x09, 0x01, 0x21, 0x11, 0x33, 0x01, 0x33, 0x27,
+  0x02, 0x8b, 0xb4, 0x02, 0x5b, 0xb4, 0x91, 0x5a, 0xfe, 0x9f, 0x5a, 0x91,
+  0x02, 0x01, 0xfc, 0xf1, 0xb4, 0xfe, 0xef, 0x01, 0xe4, 0x01, 0xe4, 0xfe,
+  0xf0, 0xb4, 0xfe, 0x10, 0xd1, 0x69, 0xf8, 0x94, 0x94, 0x03, 0x5a, 0x64,
+  0x64, 0xfb, 0xae, 0x01, 0x5c, 0x02, 0x92, 0x02, 0x1a, 0xfd, 0xe6, 0xfd,
+  0x6e, 0x03, 0xaa, 0x74, 0x00, 0x03, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce,
+  0x06, 0x08, 0x00, 0x06, 0x00, 0x11, 0x00, 0x18, 0x00, 0x00, 0x25, 0x23,
+  0x15, 0x21, 0x11, 0x07, 0x33, 0x01, 0x21, 0x11, 0x33, 0x11, 0x23, 0x09,
+  0x01, 0x23, 0x11, 0x33, 0x01, 0x11, 0x21, 0x35, 0x23, 0x11, 0x33, 0x02,
+  0x7d, 0xa6, 0x01, 0x00, 0xc2, 0x68, 0x02, 0x0f, 0xfc, 0xf1, 0xa6, 0xe8,
+  0x01, 0xc9, 0x01, 0xc9, 0xe8, 0xa7, 0xfe, 0xa5, 0x01, 0x01, 0xa7, 0x69,
+  0xf8, 0x94, 0x04, 0xe4, 0xd8, 0xfb, 0x90, 0x01, 0x5c, 0x02, 0xb0, 0x01,
+  0xfc, 0xfe, 0x04, 0xfd, 0x50, 0x03, 0xec, 0xfb, 0x1c, 0x94, 0x03, 0x78,
+  0x00, 0x03, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x06,
+  0x00, 0x11, 0x00, 0x17, 0x00, 0x00, 0x25, 0x11, 0x33, 0x0b, 0x01, 0x33,
+  0x11, 0x05, 0x21, 0x11, 0x23, 0x13, 0x23, 0x09, 0x01, 0x23, 0x13, 0x23,
+  0x03, 0x33, 0x0b, 0x01, 0x33, 0x37, 0x03, 0x7e, 0x76, 0xf0, 0xef, 0x76,
+  0x01, 0x4d, 0xfe, 0x59, 0xf6, 0xfc, 0xfc, 0x01, 0xc9, 0x01, 0xc9, 0xfc,
+  0xfc, 0xf5, 0x61, 0x7d, 0xf0, 0xef, 0x7c, 0x73, 0x64, 0x02, 0xf4, 0x01,
+  0x0a, 0xfe, 0xf6, 0xfd, 0x0c, 0x64, 0x02, 0xf4, 0x01, 0x18, 0x01, 0xfc,
+  0xfe, 0x04, 0xfe, 0xe8, 0x01, 0x7c, 0x01, 0x0a, 0xfe, 0xf6, 0x80, 0x00,
+  0x00, 0x03, 0x01, 0x3b, 0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x0a,
+  0x00, 0x19, 0x00, 0x1f, 0x00, 0x00, 0x25, 0x23, 0x15, 0x21, 0x35, 0x23,
+  0x11, 0x33, 0x0b, 0x01, 0x33, 0x01, 0x21, 0x11, 0x33, 0x11, 0x23, 0x13,
+  0x23, 0x09, 0x01, 0x23, 0x13, 0x23, 0x11, 0x33, 0x01, 0x33, 0x0b, 0x01,
+  0x33, 0x37, 0x02, 0x8b, 0xb4, 0x02, 0x5b, 0xb4, 0x76, 0xf0, 0xef, 0x76,
+  0x02, 0x01, 0xfc, 0xf1, 0xb4, 0xf6, 0xfc, 0xfc, 0x01, 0xc9, 0x01, 0xc9,
+  0xfc, 0xfc, 0xf5, 0xb4, 0xfe, 0xeb, 0x7d, 0xf0, 0xef, 0x7c, 0x73, 0xf8,
+  0x94, 0x94, 0x02, 0x60, 0x01, 0x0a, 0xfe, 0xf6, 0xfc, 0xa8, 0x01, 0x5c,
+  0x01, 0x98, 0x01, 0x18, 0x01, 0xfc, 0xfe, 0x04, 0xfe, 0xe8, 0xfe, 0x68,
+  0x03, 0x14, 0x01, 0x0a, 0xfe, 0xf6, 0x80, 0x00, 0x00, 0x02, 0x00, 0x69,
+  0x00, 0x86, 0x05, 0xd7, 0x04, 0x7e, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00,
+  0x37, 0x11, 0x21, 0x15, 0x21, 0x11, 0x09, 0x01, 0x11, 0x21, 0x15, 0x03,
+  0x35, 0x23, 0x11, 0x33, 0x35, 0x21, 0x15, 0x13, 0x03, 0x15, 0x69, 0x01,
+  0x39, 0x02, 0x6c, 0x01, 0xc9, 0xfe, 0x37, 0xfd, 0x94, 0x5a, 0x85, 0x85,
+  0x03, 0x20, 0xef, 0xef, 0xcf, 0x03, 0x66, 0xc8, 0x01, 0x11, 0xfe, 0x04,
+  0xfe, 0x04, 0x01, 0x11, 0xc8, 0x02, 0x3a, 0xc8, 0xfd, 0x62, 0xc8, 0x83,
+  0x01, 0x0a, 0x01, 0x0a, 0x83, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6d,
+  0x00, 0x00, 0x05, 0xac, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x0f, 0x00, 0x00,
+  0x01, 0x15, 0x21, 0x11, 0x23, 0x11, 0x01, 0x37, 0x21, 0x15, 0x21, 0x01,
+  0x07, 0x01, 0x11, 0x23, 0x05, 0xac, 0xfb, 0x1b, 0x59, 0x01, 0x05, 0x39,
+  0x01, 0xf4, 0xfe, 0xd7, 0x03, 0x08, 0x6c, 0xfc, 0xf8, 0x98, 0x05, 0xd5,
+  0x63, 0xfa, 0x8e, 0x05, 0xd5, 0xfe, 0x9f, 0x3f, 0xa9, 0xfc, 0xa2, 0x78,
+  0x03, 0x5e, 0xfe, 0xb6, 0x00, 0x02, 0x00, 0x6d, 0x00, 0x00, 0x05, 0xac,
+  0x05, 0xd5, 0x00, 0x05, 0x00, 0x0f, 0x00, 0x00, 0x33, 0x35, 0x21, 0x11,
+  0x33, 0x11, 0x01, 0x07, 0x21, 0x35, 0x21, 0x01, 0x37, 0x01, 0x11, 0x33,
+  0x6e, 0x04, 0xe5, 0x59, 0xfe, 0xfb, 0x39, 0xfe, 0x0c, 0x01, 0x29, 0xfc,
+  0xf8, 0x6c, 0x03, 0x08, 0x98, 0x63, 0x05, 0x72, 0xfa, 0x2b, 0x01, 0x61,
+  0x3f, 0xa9, 0x03, 0x5e, 0x78, 0xfc, 0xa2, 0x01, 0x4a, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x3b, 0xff, 0xcd, 0x04, 0xce, 0x06, 0x08, 0x00, 0x09,
+  0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x33, 0x0b, 0x01, 0x33, 0x11, 0x23,
+  0x1b, 0x01, 0x27, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23, 0x09, 0x01, 0x23,
+  0x03, 0x7e, 0x76, 0xf0, 0xef, 0x76, 0x76, 0xef, 0xf0, 0x1c, 0xf5, 0xfe,
+  0x37, 0xfe, 0x37, 0xf6, 0xf6, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0x01, 0x65,
+  0x03, 0x0b, 0x01, 0x0a, 0xfe, 0xf6, 0xfc, 0xf5, 0xfe, 0xf6, 0x01, 0x0a,
+  0x64, 0xfe, 0x04, 0x01, 0xfc, 0x02, 0x43, 0x01, 0xfc, 0xfe, 0x04, 0x00,
+  0x00, 0x03, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x29,
+  0x00, 0x35, 0x00, 0x41, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x27, 0x37, 0x01,
+  0x24, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x26, 0x27, 0x26, 0x27,
+  0x13, 0x21, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36,
+  0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0xc4, 0x05, 0x09, 0x18, 0x2d,
+  0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3d, 0x29, 0x2d, 0x18, 0x09, 0x06, 0xab,
+  0xab, 0x06, 0x09, 0x18, 0x2d, 0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3c, 0x2a,
+  0x2d, 0x18, 0x09, 0x05, 0x01, 0x3c, 0xd1, 0x6c, 0x01, 0x61, 0xfc, 0xbc,
+  0x4a, 0x1f, 0x25, 0x16, 0x17, 0x0d, 0x01, 0x47, 0x0f, 0x16, 0x1a, 0x20,
+  0x5d, 0xfe, 0xbc, 0x0d, 0x16, 0x1b, 0x20, 0x1f, 0x4a, 0x20, 0x20, 0x1a,
+  0x17, 0x02, 0x55, 0xfe, 0x77, 0x78, 0xe9, 0x18, 0x18, 0x40, 0x32, 0x31,
+  0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x40, 0x18, 0x18, 0xaa, 0x1a, 0x19,
+  0x40, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x40, 0x19, 0x1a,
+  0xe9, 0x78, 0xfe, 0x77, 0x9d, 0x0f, 0x12, 0x1a, 0x1c, 0x1e, 0x23, 0x17,
+  0x1c, 0x10, 0xfe, 0xf0, 0x1d, 0x1a, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c,
+  0x1a, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6b, 0xff, 0xf9, 0x05, 0x9c,
+  0x05, 0xdc, 0x10, 0x27, 0x08, 0x6d, 0x01, 0x0e, 0x00, 0x00, 0x10, 0x07,
+  0x08, 0x6f, 0xfe, 0xf2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0xfe, 0x74, 0x05, 0xaf, 0x06, 0x90, 0x00, 0x19, 0x00, 0x00, 0x01, 0x07,
+  0x17, 0x15, 0x01, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x21, 0x35,
+  0x21, 0x27, 0x37, 0x21, 0x35, 0x21, 0x27, 0x37, 0x01, 0x15, 0x07, 0x17,
+  0x05, 0xae, 0xe5, 0xe5, 0xfe, 0x9f, 0x6c, 0xd1, 0xfb, 0xb7, 0x04, 0x49,
+  0xc1, 0xc1, 0xfb, 0xb7, 0x04, 0x49, 0xc1, 0xc1, 0xfb, 0xb7, 0x04, 0x49,
+  0xd1, 0x6c, 0x01, 0x61, 0xe5, 0xe5, 0x02, 0x55, 0xff, 0xff, 0x5a, 0xfe,
+  0x77, 0x78, 0xe9, 0xaa, 0xd7, 0xd7, 0xaa, 0xd7, 0xd7, 0xaa, 0xe9, 0x78,
+  0xfe, 0x77, 0x5a, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0xc0, 0x05, 0xa0, 0x04, 0x44, 0x00, 0x11, 0x00, 0x00, 0x13, 0x35,
+  0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0xfb, 0x99,
+  0x01, 0xb5, 0xfe, 0x4b, 0x99, 0xfe, 0x05, 0xd2, 0x6c, 0x02, 0x55, 0x5a,
+  0x01, 0x89, 0x78, 0xe9, 0x01, 0x6d, 0xfe, 0x93, 0xaa, 0xfe, 0x93, 0x01,
+  0x6d, 0xe9, 0x78, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xc0, 0x05, 0xaf,
+  0x04, 0x44, 0x00, 0x11, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x11,
+  0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x27, 0x37, 0x01,
+  0x05, 0xae, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0x06, 0x99, 0xfe, 0x4a, 0x01,
+  0xb6, 0x99, 0x01, 0xfa, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x55, 0xfe, 0x77,
+  0x78, 0xe9, 0xfe, 0x93, 0x01, 0x6d, 0xaa, 0x01, 0x6d, 0xfe, 0x93, 0xe9,
+  0x78, 0xfe, 0x77, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xc0, 0x05, 0xaf,
+  0x04, 0x44, 0x00, 0x17, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x27,
+  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x11, 0x23, 0x11, 0x21, 0x17,
+  0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x02, 0xb8, 0x99, 0x01, 0x61, 0xd1,
+  0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0x9f, 0x99, 0xfe, 0x9e,
+  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x02, 0xd7, 0x01, 0x6d,
+  0xfe, 0x93, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xfe,
+  0x93, 0x01, 0x6d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0xc0, 0x05, 0xa0, 0x04, 0x44, 0x00, 0x19,
+  0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x33,
+  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23,
+  0x11, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x01, 0x7d, 0x99,
+  0x99, 0x99, 0x01, 0x01, 0xfe, 0xff, 0x99, 0x99, 0x99, 0xfe, 0x83, 0xd2,
+  0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01, 0x6d, 0xfe, 0x93,
+  0x01, 0x6d, 0xfe, 0x93, 0xaa, 0xfe, 0x93, 0x01, 0x6d, 0xfe, 0x93, 0x01,
+  0x6d, 0xe9, 0x78, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xc0, 0x05, 0xaf,
+  0x04, 0x44, 0x00, 0x19, 0x00, 0x00, 0x09, 0x01, 0x27, 0x37, 0x21, 0x11,
+  0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x33, 0x11, 0x21, 0x27, 0x37, 0x01, 0x05, 0xae, 0xfe, 0x9f,
+  0x6c, 0xd1, 0xfe, 0x84, 0x99, 0x99, 0x99, 0xfe, 0xfe, 0x01, 0x02, 0x99,
+  0x99, 0x99, 0x01, 0x7c, 0xd1, 0x6c, 0x01, 0x61, 0x02, 0x55, 0xfe, 0x77,
+  0x78, 0xe9, 0xfe, 0x93, 0x01, 0x6d, 0xfe, 0x93, 0x01, 0x6d, 0xaa, 0x01,
+  0x6d, 0xfe, 0x93, 0x01, 0x6d, 0xfe, 0x93, 0xe9, 0x78, 0xfe, 0x77, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0xc0, 0x05, 0xaf, 0x04, 0x44, 0x00, 0x1f,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x27,
+  0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11,
+  0x23, 0x11, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x02, 0x59,
+  0x7e, 0x5a, 0x7e, 0x01, 0x03, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
+  0xd1, 0xfe, 0xfd, 0x7e, 0x5a, 0x7e, 0xfe, 0xfd, 0xd2, 0x6c, 0xfe, 0x9e,
+  0x01, 0x62, 0x6c, 0xd2, 0x02, 0xd7, 0x01, 0x6d, 0xfe, 0x93, 0x01, 0x6d,
+  0xfe, 0x93, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xfe,
+  0x93, 0x01, 0x6d, 0xfe, 0x93, 0x01, 0x6d, 0xe9, 0x78, 0x01, 0x89, 0x5a,
+  0x01, 0x89, 0x78, 0xe9, 0x00, 0x02, 0x00, 0x31, 0x00, 0xc4, 0x05, 0xa0,
+  0x04, 0x40, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x07, 0x05,
+  0x11, 0x09, 0x01, 0x11, 0x21, 0x15, 0x01, 0x7b, 0xe1, 0x01, 0x29, 0xfe,
+  0x6f, 0x01, 0x91, 0x03, 0xdc, 0x01, 0x88, 0x01, 0xf4, 0xfa, 0x41, 0xfe,
+  0x83, 0x01, 0xbe, 0x01, 0xbe, 0xfe, 0x83, 0x82, 0x00, 0x02, 0x00, 0x69,
+  0x00, 0xc4, 0x05, 0xd7, 0x04, 0x40, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00,
+  0x01, 0x37, 0x27, 0x03, 0x21, 0x35, 0x21, 0x11, 0x09, 0x01, 0x04, 0x8e,
+  0xe0, 0xe0, 0x48, 0xfc, 0x23, 0x03, 0xdd, 0x01, 0x91, 0xfe, 0x6f, 0x01,
+  0x88, 0xfa, 0xfa, 0xfe, 0xc5, 0x82, 0x01, 0x7d, 0xfe, 0x42, 0xfe, 0x42,
+  0x00, 0x03, 0x00, 0x31, 0x00, 0xc4, 0x05, 0xd7, 0x04, 0x40, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x37, 0x27, 0x01, 0x11, 0x07,
+  0x05, 0x21, 0x11, 0x09, 0x01, 0x11, 0x21, 0x11, 0x09, 0x01, 0x04, 0x8e,
+  0xe0, 0xe0, 0xfc, 0xed, 0xe1, 0x03, 0xac, 0xfd, 0x7d, 0xfe, 0x6f, 0x01,
+  0x91, 0x02, 0x83, 0x01, 0x91, 0xfe, 0x6f, 0x01, 0x88, 0xfa, 0xfa, 0xfe,
+  0x0c, 0x01, 0xf4, 0xfa, 0x41, 0xfe, 0x83, 0x01, 0xbe, 0x01, 0xbe, 0xfe,
+  0x83, 0x01, 0x7d, 0xfe, 0x42, 0xfe, 0x42, 0x00, 0x00, 0x02, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00,
+  0x25, 0x13, 0x21, 0x13, 0x01, 0x33, 0x13, 0x21, 0x13, 0x33, 0x01, 0x02,
+  0x76, 0xf8, 0xfe, 0x11, 0x90, 0xfd, 0xff, 0xc0, 0x7a, 0x02, 0x5e, 0x7b,
+  0xbd, 0xfe, 0x00, 0xc7, 0x02, 0xe7, 0xfc, 0x52, 0x05, 0xd5, 0xfe, 0x81,
+  0x01, 0x7f, 0xfa, 0x2b, 0x00, 0x01, 0x00, 0x79, 0xff, 0xe3, 0x03, 0xfd,
+  0x05, 0xf0, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x10, 0x12, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x23, 0x26, 0x27, 0x26, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12,
+  0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x23, 0x22, 0x02,
+  0x7a, 0xee, 0xe2, 0xe2, 0x78, 0x3b, 0x1e, 0xb6, 0x10, 0x19, 0x47, 0x8d,
+  0x8c, 0x8e, 0x8e, 0x8c, 0x8d, 0x47, 0x19, 0x10, 0xb6, 0x1e, 0x3b, 0x78,
+  0xe2, 0xe2, 0xee, 0x02, 0xe9, 0x01, 0x7a, 0x01, 0x8d, 0xc6, 0x63, 0x90,
+  0x49, 0x37, 0x99, 0xfe, 0xcd, 0xfe, 0xcc, 0xfe, 0xcc, 0xfe, 0xcd, 0x99,
+  0x37, 0x49, 0x90, 0x63, 0xc5, 0x01, 0x8c, 0x00, 0x00, 0x02, 0x00, 0x55,
+  0xff, 0xe3, 0x03, 0x64, 0x05, 0x4c, 0x00, 0x20, 0x00, 0x30, 0x00, 0x00,
+  0x05, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x35, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x02, 0x07, 0x06, 0x01, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x01, 0x89, 0x7f, 0x52, 0x62, 0x56, 0x59, 0xa0, 0x69, 0x53, 0x31,
+  0x21, 0x0c, 0x1d, 0x40, 0xa9, 0x40, 0x63, 0x68, 0x5e, 0xf1, 0x67, 0x30,
+  0x17, 0x39, 0x92, 0x74, 0xfe, 0xe1, 0x28, 0x2a, 0x41, 0x3a, 0x2e, 0x40,
+  0x30, 0x28, 0x14, 0x51, 0x8a, 0x77, 0x34, 0x21, 0x1d, 0x55, 0x65, 0xb7,
+  0xbe, 0x94, 0x98, 0x49, 0x2b, 0x48, 0x51, 0x5c, 0x87, 0x4e, 0xad, 0x2c,
+  0xa8, 0x1f, 0xf6, 0x74, 0xad, 0x71, 0x83, 0xfe, 0xb8, 0x9c, 0x7a, 0x01,
+  0x53, 0x64, 0x36, 0x39, 0x2d, 0x3e, 0x65, 0x53, 0x59, 0xd7, 0xae, 0x6c,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x21, 0x35, 0x04, 0x17, 0xfc, 0x9e, 0x02, 0xac, 0xfd, 0x54, 0x02, 0xac,
+  0xfd, 0x54, 0x05, 0xd5, 0xfa, 0x2b, 0xaa, 0x01, 0xec, 0xaa, 0x01, 0xeb,
+  0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0xff, 0xa2, 0x04, 0x17,
+  0x06, 0x35, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x07, 0x23, 0x37, 0x23, 0x35, 0x33, 0x13, 0x21, 0x35, 0x21, 0x13,
+  0x21, 0x35, 0x21, 0x37, 0x33, 0x0f, 0x01, 0x03, 0x33, 0x11, 0x01, 0x03,
+  0x21, 0x11, 0x04, 0x17, 0xfd, 0x90, 0x1a, 0x99, 0x1a, 0x59, 0x89, 0x88,
+  0xfe, 0xef, 0x01, 0x40, 0x89, 0xfe, 0x37, 0x01, 0xf8, 0x1b, 0x99, 0x1b,
+  0x2f, 0x89, 0xd3, 0xfe, 0xff, 0x89, 0x01, 0x8a, 0x05, 0xd5, 0xfa, 0x2b,
+  0x5e, 0x5e, 0xaa, 0x01, 0xec, 0xaa, 0x01, 0xeb, 0xaa, 0x60, 0x60, 0xaa,
+  0xfe, 0x15, 0x01, 0xeb, 0xfd, 0x6b, 0xfe, 0x14, 0x01, 0xec, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x8b, 0xff, 0xec, 0x05, 0xbb, 0x05, 0xae, 0x00, 0x1b,
+  0x00, 0x28, 0x00, 0x36, 0x00, 0x00, 0x01, 0x37, 0x33, 0x07, 0x16, 0x17,
+  0x16, 0x10, 0x02, 0x04, 0x23, 0x22, 0x27, 0x26, 0x27, 0x07, 0x23, 0x37,
+  0x26, 0x27, 0x26, 0x10, 0x12, 0x24, 0x33, 0x32, 0x17, 0x16, 0x09, 0x01,
+  0x27, 0x26, 0x23, 0x22, 0x04, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x09,
+  0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x24, 0x37, 0x36, 0x37, 0x26, 0x27,
+  0x26, 0x04, 0x87, 0x50, 0x60, 0x73, 0x5e, 0x3e, 0x5a, 0xb4, 0xfe, 0xc3,
+  0xa6, 0xa9, 0x9e, 0x32, 0x2c, 0x71, 0x5e, 0x99, 0x39, 0x2a, 0x59, 0xb2,
+  0x01, 0x3c, 0xa9, 0xa6, 0x9f, 0x10, 0xfd, 0x1b, 0x02, 0xa9, 0x0d, 0x83,
+  0x89, 0x8b, 0xfe, 0xfa, 0x4a, 0x48, 0x01, 0x01, 0x48, 0x21, 0x03, 0x10,
+  0xfd, 0x51, 0x23, 0x29, 0x82, 0x8b, 0x89, 0x01, 0x06, 0x4a, 0x4a, 0x01,
+  0x01, 0x4a, 0x34, 0x05, 0x3b, 0x6e, 0x9d, 0x53, 0x7a, 0xb2, 0xfe, 0x80,
+  0xfe, 0x9d, 0xbe, 0x5f, 0x1e, 0x27, 0x9c, 0xd2, 0x42, 0x54, 0xb1, 0x01,
+  0x80, 0x01, 0x63, 0xbe, 0x5f, 0x0a, 0xfb, 0xe9, 0x03, 0xa5, 0x08, 0x4e,
+  0x9d, 0x93, 0x91, 0x9b, 0x9b, 0x91, 0x40, 0x03, 0x44, 0xfc, 0x52, 0x1f,
+  0x18, 0x4f, 0x9d, 0x93, 0x91, 0x9b, 0x9b, 0x91, 0x67, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xfa, 0x00, 0x00, 0x04, 0xd7, 0x05, 0xc1, 0x00, 0x02,
+  0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01, 0x33, 0x01, 0x21, 0x02,
+  0x68, 0xfe, 0x87, 0x02, 0xf1, 0xfe, 0x24, 0xc9, 0x02, 0x09, 0xfb, 0x25,
+  0x04, 0xee, 0xfb, 0xc4, 0x05, 0x0f, 0xfa, 0x3f, 0x00, 0x02, 0xff, 0xfa,
+  0x00, 0x00, 0x04, 0xd7, 0x05, 0xc1, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00,
+  0x25, 0x01, 0x21, 0x09, 0x01, 0x21, 0x01, 0x02, 0x68, 0x01, 0x78, 0xfd,
+  0x0f, 0x01, 0x15, 0xfd, 0xf7, 0x04, 0xdb, 0xfd, 0xf7, 0xd3, 0x04, 0x3c,
+  0xfa, 0xf1, 0x05, 0xc1, 0xfa, 0x3f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x02, 0x35,
+  0x34, 0x12, 0x24, 0x33, 0x21, 0x15, 0x21, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x21, 0x15, 0x01, 0x35, 0x06, 0x39, 0x43, 0x7d, 0x7c, 0x85, 0x02,
+  0x73, 0xfd, 0x8d, 0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02,
+  0x73, 0xfd, 0x8d, 0x85, 0x7c, 0x7d, 0x43, 0x3a, 0x08, 0x04, 0x76, 0x02,
+  0x73, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0x01, 0x60, 0xbb,
+  0xb9, 0x01, 0x60, 0xc8, 0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0,
+  0x00, 0x03, 0x00, 0x9d, 0xfe, 0xe5, 0x05, 0xa9, 0x06, 0xaf, 0x00, 0x1e,
+  0x00, 0x26, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21,
+  0x03, 0x21, 0x15, 0x21, 0x03, 0x16, 0x33, 0x21, 0x15, 0x21, 0x22, 0x27,
+  0x03, 0x27, 0x13, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x24, 0x3b,
+  0x01, 0x01, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x13, 0x37, 0x13, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x06, 0x15, 0x04, 0x5c, 0x87, 0x42, 0x01, 0x07,
+  0xfe, 0xc5, 0xa6, 0x01, 0xe1, 0xfd, 0xea, 0x9e, 0x20, 0x21, 0x02, 0x73,
+  0xfd, 0x8d, 0x3b, 0x38, 0x5a, 0x87, 0x56, 0x28, 0x27, 0xa0, 0xaa, 0xaa,
+  0x01, 0x40, 0xad, 0xd2, 0xfd, 0x2e, 0x3f, 0x4c, 0x74, 0x1a, 0x1a, 0x90,
+  0x36, 0xa5, 0x9e, 0x85, 0x7c, 0x70, 0x50, 0x42, 0x06, 0xaf, 0x37, 0xca,
+  0x9f, 0xfe, 0x04, 0xa0, 0xfe, 0x1d, 0x05, 0x9f, 0x0b, 0xfe, 0xee, 0x37,
+  0x01, 0x08, 0x13, 0x18, 0x63, 0x01, 0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8,
+  0xfc, 0xc5, 0x4a, 0x78, 0x91, 0x48, 0x10, 0x0d, 0x01, 0xb8, 0xa0, 0x01,
+  0xfc, 0x4e, 0x47, 0x92, 0x78, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x16, 0x00, 0x00, 0x25, 0x20,
+  0x24, 0x35, 0x34, 0x24, 0x29, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x07,
+  0x21, 0x15, 0x21, 0x16, 0x17, 0x16, 0x33, 0x21, 0x15, 0x02, 0xda, 0xfe,
+  0xf6, 0xfe, 0xf3, 0x01, 0x0d, 0x01, 0x0a, 0x01, 0x8e, 0xfe, 0x72, 0xd1,
+  0x5e, 0x46, 0x1b, 0x03, 0x1e, 0xfc, 0xe2, 0x21, 0x40, 0x67, 0xc8, 0x01,
+  0x8e, 0x9b, 0xf6, 0xf0, 0xf0, 0xf6, 0x8e, 0x01, 0x01, 0x4f, 0x3a, 0x85,
+  0x8e, 0x91, 0x30, 0x51, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x21, 0x35, 0x21, 0x32, 0x04, 0x12, 0x15,
+  0x14, 0x02, 0x04, 0x23, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x21, 0x35, 0x05, 0x11, 0x06, 0x39, 0x43, 0x7e, 0x7b, 0x85, 0xfd,
+  0x8d, 0x02, 0x73, 0xad, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1, 0xad, 0xfd,
+  0x8d, 0x02, 0x73, 0x85, 0x7b, 0x7d, 0x44, 0x3a, 0x08, 0xfb, 0x8a, 0x03,
+  0x27, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0xfe, 0xa0, 0xbb,
+  0xb9, 0xfe, 0xa0, 0xc8, 0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0,
+  0x00, 0x03, 0x00, 0x9d, 0xfe, 0xe5, 0x05, 0xa9, 0x06, 0xaf, 0x00, 0x1e,
+  0x00, 0x26, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x27, 0x37, 0x21, 0x35, 0x21,
+  0x13, 0x21, 0x35, 0x21, 0x13, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x17,
+  0x13, 0x17, 0x03, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x04, 0x2b,
+  0x01, 0x01, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x07, 0x03, 0x33,
+  0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x01, 0xea, 0x87, 0x41, 0xfe, 0xfa,
+  0x01, 0x3a, 0xa7, 0xfe, 0x1f, 0x02, 0x15, 0x9f, 0x21, 0x20, 0xfd, 0x8d,
+  0x02, 0x73, 0x3a, 0x39, 0x5a, 0x87, 0x56, 0x27, 0x28, 0x9f, 0xab, 0xab,
+  0xfe, 0xc1, 0xad, 0xd3, 0x02, 0xd3, 0x3f, 0x4c, 0x75, 0x1a, 0x1a, 0x90,
+  0x35, 0xa6, 0x9f, 0x84, 0x7c, 0x71, 0x50, 0x42, 0xfe, 0xe5, 0x37, 0xca,
+  0x9f, 0x01, 0xfc, 0xa0, 0x01, 0xe3, 0x05, 0x9f, 0x0b, 0x01, 0x12, 0x37,
+  0xfe, 0xf8, 0x13, 0x18, 0x63, 0xfe, 0xa0, 0xbb, 0xb9, 0xfe, 0xa0, 0xc8,
+  0x03, 0x3b, 0x4a, 0x78, 0x91, 0x48, 0x10, 0x0d, 0xfe, 0x48, 0xa0, 0xfe,
+  0x04, 0x4e, 0x47, 0x92, 0x78, 0x5d, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x16, 0x00, 0x00, 0x01, 0x20,
+  0x04, 0x15, 0x14, 0x04, 0x29, 0x01, 0x35, 0x25, 0x32, 0x37, 0x36, 0x37,
+  0x21, 0x35, 0x05, 0x26, 0x27, 0x26, 0x07, 0x21, 0x35, 0x02, 0x51, 0x01,
+  0x0a, 0x01, 0x0d, 0xfe, 0xf3, 0xfe, 0xf6, 0xfe, 0x72, 0x01, 0x8e, 0xd1,
+  0x5e, 0x46, 0x1b, 0xfc, 0xe2, 0x03, 0x1e, 0x22, 0x3f, 0x68, 0xc7, 0xfe,
+  0x72, 0x04, 0x67, 0xf6, 0xf1, 0xef, 0xf6, 0x8e, 0x01, 0x50, 0x3a, 0x85,
+  0x8e, 0x01, 0x91, 0x31, 0x52, 0x01, 0x8e, 0x00, 0x00, 0x01, 0x01, 0x0e,
+  0x00, 0x00, 0x03, 0x87, 0x03, 0xe2, 0x00, 0x03, 0x00, 0x00, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0x0e, 0x02, 0x79, 0x03, 0xe2, 0xfc, 0x1e, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x8c, 0xfe, 0x77, 0x04, 0xe6, 0x05, 0xc1, 0x00, 0x07,
+  0x00, 0x00, 0x13, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x8c, 0x04,
+  0x5a, 0xd8, 0xfd, 0x56, 0xd8, 0x05, 0xc1, 0xf8, 0xb6, 0x06, 0x7d, 0xf9,
+  0x83, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8c, 0xfe, 0x77, 0x04, 0xe6,
+  0x05, 0xc1, 0x00, 0x07, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x8c, 0xd8, 0x02, 0xaa, 0xd8, 0xfe, 0x77, 0x07, 0x4a, 0xf9,
+  0x83, 0x06, 0x7d, 0xf8, 0xb6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x16,
+  0xfe, 0x77, 0x04, 0xb6, 0x05, 0xc1, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x09, 0x01, 0x21, 0x15, 0x21, 0x35, 0x09, 0x01, 0x32, 0x04,
+  0x6c, 0xfc, 0xa1, 0x02, 0x5c, 0xfd, 0x90, 0x03, 0x8a, 0xfb, 0x61, 0x02,
+  0x8d, 0xfd, 0x8f, 0x05, 0xc1, 0xc1, 0xfd, 0x33, 0xfd, 0x04, 0xc0, 0x95,
+  0x03, 0x21, 0x02, 0xe3, 0x00, 0x01, 0x00, 0xc3, 0x02, 0x2d, 0x05, 0x46,
+  0x02, 0xd7, 0x00, 0x03, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0xc3, 0x04,
+  0x82, 0xfb, 0x7e, 0x02, 0xd7, 0xaa, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
+  0x21, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21,
+  0x01, 0x35, 0x21, 0x15, 0x03, 0x50, 0x97, 0xfe, 0x0a, 0x01, 0xf6, 0x97,
+  0x01, 0xf5, 0xfe, 0x0b, 0xfd, 0x73, 0x04, 0x82, 0x01, 0x83, 0xaa, 0x01,
+  0x83, 0xfe, 0x7d, 0xaa, 0x02, 0xd7, 0xaa, 0xaa, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x00, 0x05, 0x46, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
+  0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x19,
+  0x01, 0x33, 0x15, 0x23, 0x03, 0x50, 0x01, 0xf5, 0xfe, 0x0b, 0x97, 0xfe,
+  0x0a, 0x01, 0xf6, 0x97, 0x97, 0x04, 0xa0, 0xfe, 0x05, 0xaa, 0xfe, 0x05,
+  0x01, 0xfb, 0xaa, 0x01, 0xfb, 0x01, 0x35, 0xcc, 0xff, 0xff, 0x00, 0x00,
+  0xff, 0x42, 0x02, 0x6d, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x12, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x62, 0xff, 0x92, 0x03, 0xd0, 0x06, 0x25, 0x10, 0x07,
+  0x00, 0x3f, 0x01, 0x63, 0x00, 0x50, 0x00, 0x00, 0x00, 0x01, 0x00, 0xeb,
+  0x00, 0x00, 0x05, 0x1e, 0x05, 0x04, 0x00, 0x11, 0x00, 0x00, 0x01, 0x25,
+  0x37, 0x05, 0x11, 0x33, 0x11, 0x25, 0x17, 0x0d, 0x01, 0x07, 0x25, 0x11,
+  0x23, 0x11, 0x05, 0x27, 0x02, 0x6c, 0xfe, 0x7f, 0x4d, 0x01, 0x81, 0x97,
+  0x01, 0x81, 0x4c, 0xfe, 0x7f, 0x01, 0x81, 0x4c, 0xfe, 0x7f, 0x97, 0xfe,
+  0x7f, 0x4d, 0x02, 0x82, 0xf7, 0x93, 0xf7, 0x01, 0xef, 0xfe, 0x11, 0xf7,
+  0x93, 0xf7, 0xf7, 0x93, 0xf7, 0xfe, 0x11, 0x01, 0xef, 0xf7, 0x93, 0x00,
+  0xff, 0xff, 0x01, 0x23, 0x01, 0x47, 0x03, 0x5f, 0x03, 0xc2, 0x10, 0x07,
+  0x00, 0x72, 0x00, 0x74, 0xfd, 0xd2, 0x00, 0x00, 0xff, 0xff, 0x01, 0x35,
+  0x01, 0x59, 0x03, 0x4d, 0x03, 0xa9, 0x10, 0x06, 0x07, 0x57, 0x21, 0x88,
+  0x00, 0x01, 0x00, 0x36, 0xff, 0xd7, 0x04, 0x97, 0x06, 0x7d, 0x00, 0x0a,
+  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x01, 0x23, 0x01, 0x07, 0x27, 0x25,
+  0x13, 0x03, 0xec, 0xaa, 0x67, 0xfd, 0xe9, 0x3b, 0xfe, 0xe1, 0x71, 0x16,
+  0x00, 0xff, 0xe6, 0x06, 0x7d, 0x60, 0xf9, 0xba, 0x03, 0x73, 0x2d, 0x50,
+  0x62, 0xfd, 0x3b, 0x00, 0xff, 0xff, 0x00, 0x36, 0xff, 0xd7, 0x04, 0x97,
+  0x07, 0x76, 0x12, 0x26, 0x08, 0xf6, 0x00, 0x00, 0x10, 0x07, 0x00, 0x75,
+  0x00, 0x68, 0x01, 0x86, 0xff, 0xff, 0x00, 0x36, 0xff, 0xd7, 0x04, 0x97,
+  0x07, 0x65, 0x12, 0x26, 0x08, 0xf6, 0x00, 0x00, 0x10, 0x07, 0x07, 0xa2,
+  0x00, 0x68, 0x01, 0x86, 0x00, 0x02, 0x00, 0xc6, 0x00, 0xe5, 0x04, 0x5f,
+  0x03, 0xe5, 0x00, 0x0b, 0x00, 0x31, 0x00, 0x00, 0x01, 0x32, 0x37, 0x02,
+  0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x05, 0x15, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x36,
+  0x37, 0x36, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07, 0x12, 0x33, 0x01, 0xda,
+  0x95, 0x59, 0x72, 0x7c, 0x5a, 0x2e, 0x30, 0x30, 0x33, 0x02, 0xda, 0x46,
+  0x41, 0x31, 0x31, 0x2e, 0x1c, 0x2c, 0x3d, 0x35, 0x41, 0x69, 0x79, 0x50,
+  0x55, 0x55, 0x4a, 0x81, 0x42, 0x30, 0x39, 0x27, 0x24, 0x24, 0x3c, 0x35,
+  0x42, 0x68, 0x44, 0x3a, 0x85, 0x68, 0x72, 0x7b, 0x01, 0x6b, 0xf0, 0x01,
+  0x06, 0x48, 0x4d, 0x66, 0x70, 0x45, 0x46, 0x02, 0x84, 0x1e, 0x1b, 0x3f,
+  0x24, 0x54, 0x78, 0x35, 0x40, 0x65, 0x6a, 0xaf, 0xa8, 0x72, 0x65, 0x1e,
+  0x21, 0x39, 0x33, 0x45, 0x78, 0x35, 0x40, 0x83, 0xf0, 0xfe, 0xfa, 0x00,
+  0x00, 0x03, 0x00, 0xc6, 0x00, 0xe5, 0x05, 0x3a, 0x03, 0xe5, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x25, 0x32, 0x37, 0x02, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0x22, 0x07, 0x12, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x03, 0x48, 0x1c, 0x2c, 0x3d, 0x35,
+  0x42, 0x68, 0x79, 0x50, 0x55, 0x55, 0x4b, 0x80, 0x42, 0x30, 0x39, 0x27,
+  0x24, 0x24, 0x3c, 0x35, 0x43, 0x67, 0x7a, 0x50, 0x54, 0x54, 0x4c, 0x80,
+  0x41, 0x31, 0x31, 0xfe, 0x64, 0x95, 0x59, 0x72, 0x7c, 0x5a, 0x2e, 0x31,
+  0x31, 0x33, 0x02, 0xa0, 0x86, 0x67, 0x71, 0x7c, 0x5a, 0x2e, 0x31, 0x31,
+  0x32, 0x01, 0x5d, 0x24, 0x54, 0x78, 0x35, 0x40, 0x65, 0x6a, 0xaf, 0xa8,
+  0x72, 0x65, 0x1e, 0x21, 0x39, 0x33, 0x45, 0x78, 0x35, 0x40, 0x65, 0x6a,
+  0xaf, 0xa8, 0x72, 0x65, 0x1e, 0x1b, 0x4d, 0xf0, 0x01, 0x06, 0x48, 0x4d,
+  0x66, 0x70, 0x45, 0x46, 0x01, 0xf4, 0xf0, 0xfe, 0xfa, 0x48, 0x4d, 0x66,
+  0x70, 0x45, 0x46, 0x00, 0x00, 0x01, 0x00, 0xfe, 0x00, 0xcb, 0x05, 0x0a,
+  0x05, 0x49, 0x00, 0x05, 0x00, 0x00, 0x25, 0x21, 0x11, 0x33, 0x11, 0x21,
+  0x05, 0x0a, 0xfb, 0xf5, 0x99, 0x03, 0x72, 0xcb, 0x04, 0x7e, 0xfc, 0x2c,
+  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x00, 0x25, 0x15, 0x21, 0x01, 0x33, 0x01, 0x05, 0xa8, 0xfa, 0xf6,
+  0x03, 0x59, 0xda, 0xfd, 0x1d, 0xca, 0xca, 0x05, 0xd5, 0xfa, 0xf5, 0x00,
+  0x00, 0x02, 0x00, 0x9d, 0xff, 0x94, 0x05, 0xa9, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x1b, 0x00, 0x00, 0x25, 0x26, 0x27, 0x26, 0x27, 0x01, 0x13, 0x01,
+  0x33, 0x01, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x16, 0x15, 0x23,
+  0x34, 0x27, 0x21, 0x01, 0x26, 0x27, 0x37, 0x16, 0x03, 0xf0, 0x23, 0x43,
+  0x3a, 0x4e, 0xfe, 0xec, 0xcc, 0x01, 0x3d, 0xda, 0xfe, 0x78, 0x65, 0x4a,
+  0x54, 0x26, 0x01, 0x36, 0xfe, 0xe8, 0x04, 0x7e, 0x05, 0xfc, 0x8d, 0x01,
+  0xd8, 0x1b, 0x1c, 0x48, 0x1a, 0xca, 0x8b, 0x86, 0x73, 0x5e, 0xfe, 0x1e,
+  0x02, 0xe3, 0x02, 0x28, 0xfd, 0x52, 0x73, 0x93, 0xa7, 0xb0, 0xca, 0x35,
+  0x37, 0x37, 0x35, 0x03, 0x36, 0x15, 0x14, 0x75, 0x13, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xd5, 0xff, 0xfa, 0x05, 0x46, 0x05, 0xd1, 0x00, 0x17,
+  0x00, 0x1d, 0x00, 0x00, 0x09, 0x01, 0x37, 0x01, 0x26, 0x27, 0x37, 0x16,
+  0x17, 0x25, 0x15, 0x05, 0x16, 0x07, 0x15, 0x06, 0x07, 0x05, 0x15, 0x25,
+  0x06, 0x07, 0x27, 0x36, 0x13, 0x09, 0x01, 0x36, 0x37, 0x36, 0x03, 0x1a,
+  0xfd, 0xbb, 0x02, 0x02, 0x4d, 0x17, 0x1a, 0x7d, 0x1a, 0x17, 0x01, 0xa5,
+  0xfe, 0xaf, 0x3f, 0x06, 0x06, 0x40, 0x01, 0x5e, 0xfe, 0x54, 0x19, 0x1b,
+  0x78, 0x1c, 0x6c, 0xfe, 0x14, 0x01, 0xe4, 0x2f, 0x04, 0x06, 0x01, 0x34,
+  0x01, 0x52, 0xc0, 0x01, 0x57, 0x21, 0x1e, 0x4c, 0x21, 0x24, 0xee, 0xd2,
+  0xbe, 0xb3, 0xc6, 0x09, 0xa1, 0x93, 0xbf, 0xd2, 0xf1, 0x26, 0x21, 0x4c,
+  0x20, 0x02, 0xe9, 0xfe, 0xe7, 0xfe, 0xf0, 0x7b, 0x81, 0x9e, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x84, 0xfe, 0x4a, 0x02, 0x15, 0x06, 0x2b, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x01, 0x85, 0x90, 0x90, 0x06, 0x2b,
+  0xf8, 0x1f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5b, 0xfe, 0x4a, 0x03, 0x3f,
+  0x06, 0x2b, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x37, 0x17,
+  0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x85, 0x90, 0xe2, 0x48, 0xfe,
+  0xd6, 0x90, 0xe4, 0x45, 0x02, 0x56, 0x03, 0xd5, 0xfc, 0x9c, 0xb0, 0x6f,
+  0xe7, 0xfc, 0x29, 0x03, 0x67, 0xb1, 0x6e, 0x00, 0x00, 0x02, 0x00, 0xf4,
+  0xfe, 0x4a, 0x02, 0xa5, 0x06, 0x2b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0xf5, 0x90, 0x90, 0x01,
+  0x20, 0x90, 0x90, 0x06, 0x2b, 0xf8, 0x1f, 0x07, 0xe1, 0xf8, 0x1f, 0x00,
+  0x00, 0x01, 0x00, 0x5b, 0xfe, 0x4a, 0x03, 0x3f, 0x06, 0x2b, 0x00, 0x13,
+  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17,
+  0x07, 0x11, 0x23, 0x11, 0x07, 0x11, 0x23, 0x11, 0x07, 0x27, 0xf5, 0x90,
+  0x90, 0x90, 0x52, 0x48, 0x9a, 0x90, 0x90, 0x90, 0x54, 0x45, 0x01, 0xe6,
+  0x04, 0x45, 0xfc, 0x2b, 0x71, 0x03, 0x64, 0xfd, 0x0c, 0x40, 0x6f, 0x78,
+  0xfb, 0xba, 0x03, 0xd7, 0x70, 0xfc, 0x99, 0x02, 0xf7, 0x41, 0x6e, 0x00,
+  0x00, 0x01, 0x00, 0xed, 0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x06,
+  0x00, 0x00, 0x33, 0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0xee, 0x01, 0x44,
+  0xe2, 0x01, 0x44, 0xb0, 0xfe, 0xfb, 0xfe, 0xfa, 0x04, 0xa2, 0xfb, 0x5e,
+  0x03, 0xac, 0xfc, 0x54, 0x00, 0x01, 0x00, 0xed, 0x00, 0x00, 0x04, 0x58,
+  0x04, 0xa2, 0x00, 0x06, 0x00, 0x00, 0x13, 0x33, 0x09, 0x01, 0x33, 0x01,
+  0x23, 0xee, 0xaf, 0x01, 0x06, 0x01, 0x05, 0xb0, 0xfe, 0xbc, 0xe2, 0x04,
+  0xa2, 0xfc, 0x54, 0x03, 0xac, 0xfb, 0x5e, 0x00, 0x00, 0x01, 0x00, 0xed,
+  0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x11, 0x00, 0x00, 0x13, 0x10,
+  0x12, 0x33, 0x32, 0x12, 0x19, 0x01, 0x23, 0x11, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x15, 0x11, 0x23, 0xee, 0xdc, 0xd9, 0xd8, 0xdd, 0x9b, 0x85, 0x95,
+  0x95, 0x86, 0x9a, 0x02, 0x50, 0x01, 0x28, 0x01, 0x2a, 0xfe, 0xd6, 0xfe,
+  0xd8, 0xfd, 0xb0, 0x02, 0x37, 0xf4, 0xd3, 0xd3, 0xf4, 0xfd, 0xc9, 0x00,
+  0x00, 0x01, 0x00, 0xed, 0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x11, 0x33, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0xee, 0x9a, 0x86, 0x95,
+  0x95, 0x85, 0x9b, 0xdd, 0xd8, 0xd9, 0xdc, 0x02, 0x52, 0x02, 0x50, 0xfd,
+  0xc9, 0xf4, 0xd3, 0xd3, 0xf4, 0x02, 0x37, 0xfd, 0xb0, 0xfe, 0xd8, 0xfe,
+  0xd6, 0x01, 0x2a, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
+  0x06, 0x0e, 0x00, 0x15, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x32, 0x16, 0x17,
+  0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37,
+  0x16, 0x33, 0x32, 0x37, 0x01, 0xb3, 0x07, 0x92, 0x88, 0x71, 0x12, 0x85,
+  0x10, 0x33, 0x40, 0x07, 0x3a, 0x08, 0x91, 0x88, 0x72, 0x12, 0x85, 0x10,
+  0x33, 0x40, 0x07, 0x04, 0xe2, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf,
+  0xfa, 0xb0, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x69, 0xfe, 0x4d, 0x05, 0x46, 0x06, 0x0e, 0x10, 0x26,
+  0x09, 0x07, 0x00, 0x00, 0x10, 0x07, 0x09, 0x07, 0x01, 0xee, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x69, 0xfe, 0x4d, 0x07, 0x34, 0x06, 0x0e, 0x10, 0x26,
+  0x09, 0x07, 0x00, 0x00, 0x10, 0x27, 0x09, 0x07, 0x01, 0xee, 0x00, 0x00,
+  0x10, 0x07, 0x09, 0x07, 0x03, 0xdc, 0x00, 0x00, 0x00, 0x03, 0x00, 0x69,
+  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x2d, 0x00, 0x36, 0x00, 0x3f,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x07,
+  0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16,
+  0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x13, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x03, 0x13, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0xb3, 0x07, 0x4b, 0x47, 0x42,
+  0x46, 0x40, 0x31, 0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0c, 0x59, 0x3b,
+  0x63, 0x63, 0x4d, 0x68, 0x0d, 0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32,
+  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b,
+  0x69, 0x7c, 0x37, 0x28, 0x3e, 0x40, 0x21, 0x28, 0xaa, 0x14, 0x37, 0x28,
+  0x40, 0x43, 0x21, 0x04, 0xe2, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f,
+  0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0x92, 0x9c, 0x6f, 0x55, 0x13,
+  0xfe, 0xbe, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01,
+  0x31, 0x18, 0x49, 0x6f, 0x9b, 0x9c, 0x73, 0x56, 0x13, 0xfd, 0x9b, 0x10,
+  0x2f, 0x48, 0x67, 0x6a, 0x47, 0x24, 0x12, 0xfe, 0x34, 0x01, 0xd6, 0x11,
+  0x2e, 0x4a, 0x68, 0x67, 0x48, 0x24, 0x00, 0x00, 0x00, 0x04, 0x00, 0x69,
+  0xfe, 0x4d, 0x05, 0x46, 0x06, 0x0e, 0x00, 0x4d, 0x00, 0x51, 0x00, 0x5a,
+  0x00, 0x63, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x21, 0x13, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x03, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x21, 0x03,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
+  0x37, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x13, 0x21,
+  0x13, 0x21, 0x03, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01,
+  0x03, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0xb3, 0x07, 0x4b,
+  0x47, 0x42, 0x46, 0x40, 0x31, 0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0c,
+  0x01, 0x57, 0x0e, 0x07, 0x4b, 0x47, 0x42, 0x46, 0x40, 0x31, 0x12, 0x85,
+  0x0f, 0x34, 0x40, 0x07, 0x0c, 0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68, 0x0d,
+  0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32, 0x12, 0x86, 0x0f, 0x33, 0x40,
+  0x07, 0x0d, 0xfe, 0xa8, 0x0d, 0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32,
+  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b,
+  0x69, 0x7b, 0x01, 0x58, 0x16, 0xfe, 0xa8, 0xab, 0x14, 0x37, 0x28, 0x40,
+  0x43, 0x21, 0x02, 0xbf, 0x13, 0x36, 0x28, 0x3e, 0x40, 0x21, 0x04, 0xe2,
+  0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xe2, 0x01,
+  0x37, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xd6,
+  0x18, 0x4b, 0x7c, 0x92, 0x9c, 0x6f, 0x55, 0x13, 0xfe, 0xbe, 0xa7, 0x44,
+  0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x24, 0xfe, 0xc3, 0xa7,
+  0x44, 0x41, 0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x30, 0x19, 0x49,
+  0x6f, 0x9b, 0x9c, 0x73, 0x56, 0x13, 0xfd, 0x92, 0x01, 0xf1, 0xfe, 0x21,
+  0x01, 0xd6, 0x11, 0x2e, 0x4a, 0x68, 0x67, 0x48, 0x24, 0x01, 0xba, 0xfe,
+  0x2b, 0x10, 0x2f, 0x48, 0x67, 0x6a, 0x47, 0x24, 0x00, 0x05, 0x00, 0x69,
+  0xfe, 0x4d, 0x07, 0x34, 0x06, 0x0e, 0x00, 0x6d, 0x00, 0x71, 0x00, 0x75,
+  0x00, 0x7e, 0x00, 0x87, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x21, 0x13, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
+  0x03, 0x21, 0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x07,
+  0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16,
+  0x33, 0x32, 0x37, 0x13, 0x21, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x21, 0x03, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x13, 0x21, 0x03,
+  0x29, 0x01, 0x13, 0x21, 0x03, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x01, 0x03, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0xb3,
+  0x07, 0x4b, 0x47, 0x42, 0x46, 0x40, 0x31, 0x12, 0x85, 0x10, 0x33, 0x40,
+  0x07, 0x0c, 0x01, 0x57, 0x0e, 0x07, 0x4b, 0x47, 0x42, 0x46, 0x40, 0x31,
+  0x12, 0x85, 0x0f, 0x34, 0x40, 0x07, 0x0c, 0x01, 0x57, 0x0e, 0x07, 0x4b,
+  0x47, 0x42, 0x46, 0x40, 0x32, 0x11, 0x85, 0x0f, 0x34, 0x3f, 0x08, 0x0c,
+  0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68, 0x0d, 0x07, 0x4b, 0x47, 0x43, 0x45,
+  0x40, 0x32, 0x11, 0x85, 0x0f, 0x33, 0x40, 0x07, 0x0d, 0xfe, 0xa8, 0x0d,
+  0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32, 0x12, 0x86, 0x0f, 0x33, 0x40,
+  0x07, 0x0d, 0xfe, 0xa8, 0x0d, 0x08, 0x4a, 0x47, 0x43, 0x45, 0x40, 0x32,
+  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b,
+  0x69, 0x03, 0xc1, 0x16, 0xfe, 0xa8, 0x15, 0xfe, 0x11, 0x01, 0x58, 0x16,
+  0xfe, 0xa8, 0xab, 0x14, 0x37, 0x28, 0x40, 0x43, 0x21, 0x04, 0xad, 0x13,
+  0x36, 0x28, 0x3e, 0x40, 0x21, 0x04, 0xe2, 0xa7, 0x44, 0x41, 0x46, 0x37,
+  0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xe2, 0x01, 0x37, 0xa7, 0x44, 0x41, 0x46,
+  0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xe2, 0x01, 0x37, 0xa7, 0x44, 0x41,
+  0x46, 0x37, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0x92,
+  0x9c, 0x6f, 0x55, 0x13, 0xfe, 0xbe, 0xa7, 0x44, 0x41, 0x46, 0x37, 0x8c,
+  0x0f, 0x82, 0xaf, 0x01, 0x24, 0xfe, 0xc3, 0xa7, 0x44, 0x41, 0x46, 0x37,
+  0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x24, 0xfe, 0xc3, 0xa7, 0x44, 0x41, 0x46,
+  0x37, 0x8c, 0x0f, 0x82, 0xaf, 0x01, 0x30, 0x19, 0x49, 0x6f, 0x9b, 0x9c,
+  0x73, 0x56, 0x13, 0xfd, 0x92, 0x01, 0xf1, 0xfe, 0x0f, 0x01, 0xf1, 0xfe,
+  0x21, 0x01, 0xd6, 0x11, 0x2e, 0x4a, 0x68, 0x67, 0x48, 0x24, 0x01, 0xba,
+  0xfe, 0x2b, 0x10, 0x2f, 0x48, 0x67, 0x6a, 0x47, 0x24, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0xfe, 0x4c, 0x03, 0xc3, 0x06, 0x0f, 0x00, 0x33,
+  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x1d,
+  0x01, 0x37, 0x17, 0x07, 0x23, 0x27, 0x37, 0x17, 0x35, 0x34, 0x27, 0x26,
+  0x27, 0x03, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
+  0x37, 0x13, 0x06, 0x07, 0x06, 0x15, 0x23, 0x34, 0x37, 0x36, 0x37, 0x13,
+  0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x02, 0xd2, 0x10, 0x34, 0x3f, 0x07,
+  0x0e, 0x50, 0x38, 0x6c, 0x54, 0x41, 0xab, 0x31, 0xa9, 0x41, 0x53, 0x47,
+  0x2e, 0x28, 0x27, 0x08, 0x8f, 0x41, 0x47, 0x74, 0x12, 0x85, 0x10, 0x35,
+  0x3e, 0x07, 0x27, 0x3a, 0x2a, 0x4d, 0x5c, 0x62, 0x4e, 0x61, 0x10, 0x07,
+  0x90, 0x40, 0x48, 0x73, 0x12, 0x04, 0xf6, 0x82, 0xaf, 0xfe, 0xb3, 0x18,
+  0x3f, 0x75, 0x9c, 0x1e, 0x5d, 0x48, 0xbd, 0xbd, 0x48, 0x5d, 0x1e, 0x73,
+  0x4d, 0x33, 0x0b, 0xfc, 0x67, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf,
+  0x03, 0x88, 0x10, 0x2e, 0x56, 0x72, 0x9b, 0x6d, 0x56, 0x11, 0x01, 0x5f,
+  0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x03, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0xb4,
+  0x06, 0x0e, 0x00, 0x08, 0x00, 0x11, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x13,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x25, 0x34, 0x27, 0x03, 0x3e,
+  0x01, 0x37, 0x27, 0x37, 0x13, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17,
+  0x16, 0x15, 0x37, 0x17, 0x07, 0x06, 0x07, 0x06, 0x07, 0x03, 0x0e, 0x01,
+  0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x01,
+  0x8b, 0x14, 0x37, 0x28, 0x40, 0x43, 0x21, 0x01, 0x5a, 0x89, 0x14, 0x37,
+  0x49, 0x08, 0x79, 0x41, 0x61, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x50, 0x44,
+  0x62, 0x41, 0x41, 0x97, 0x17, 0x36, 0x4d, 0x68, 0x0d, 0x08, 0x8f, 0x89,
+  0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64,
+  0x4b, 0x69, 0x0e, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x01, 0x4a, 0x01, 0xd6,
+  0x11, 0x2e, 0x4a, 0x67, 0x68, 0x48, 0x24, 0xe6, 0x99, 0x3b, 0xfe, 0x2b,
+  0x10, 0x65, 0x13, 0x88, 0x48, 0x02, 0x5d, 0x82, 0xaf, 0xfe, 0xd6, 0x16,
+  0x4d, 0x6f, 0x7c, 0x48, 0x48, 0xa7, 0x43, 0x3f, 0x5a, 0x13, 0xfe, 0xbe,
+  0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0x01, 0x31, 0x18, 0x49, 0x6f,
+  0x9b, 0x9c, 0x73, 0x56, 0x13, 0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f, 0x00,
+  0x00, 0x03, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0xb6, 0x06, 0x0e, 0x00, 0x08,
+  0x00, 0x12, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x13, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x01, 0x2e, 0x01, 0x27, 0x03, 0x3e, 0x01, 0x37, 0x07,
+  0x27, 0x13, 0x26, 0x23, 0x22, 0x07, 0x03, 0x1e, 0x01, 0x1f, 0x01, 0x07,
+  0x27, 0x14, 0x06, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16,
+  0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x01, 0x8b, 0x14, 0x37, 0x28, 0x40,
+  0x43, 0x21, 0x01, 0x49, 0x20, 0x30, 0x28, 0x14, 0x37, 0x5f, 0x06, 0x4b,
+  0x40, 0xa0, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x59, 0x7d, 0x10, 0x94, 0x41,
+  0x44, 0xae, 0x68, 0x0d, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35,
+  0x3e, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b, 0x69, 0x0e, 0x07, 0x8f,
+  0x89, 0x73, 0x12, 0x01, 0x4a, 0x01, 0xd6, 0x11, 0x2e, 0x4a, 0x67, 0x68,
+  0x48, 0x24, 0x01, 0x36, 0x42, 0x30, 0x12, 0xfe, 0x2b, 0x10, 0x82, 0x40,
+  0x54, 0x48, 0x02, 0xef, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x9d, 0x3f, 0xa4,
+  0x48, 0x4b, 0x7c, 0xc0, 0x13, 0xfe, 0xbe, 0xa5, 0x87, 0x7a, 0x8f, 0x0f,
+  0x82, 0xaf, 0x01, 0x31, 0x18, 0x49, 0x6f, 0x9b, 0x9c, 0x73, 0x56, 0x13,
+  0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c,
+  0x00, 0xcd, 0x04, 0x28, 0x04, 0xd5, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xa8,
+  0xfe, 0x85, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xa5, 0xfe, 0x85, 0x10, 0x07,
+  0x09, 0xa1, 0x01, 0x26, 0x01, 0x8f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c,
+  0x00, 0xcd, 0x04, 0x28, 0x04, 0xd5, 0x10, 0x27, 0x09, 0xa1, 0x01, 0x26,
+  0xfe, 0x85, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xa5, 0x01, 0x8f, 0x10, 0x07,
+  0x09, 0xa1, 0xff, 0xa8, 0x01, 0x8f, 0x00, 0x00, 0xff, 0xff, 0x00, 0x90,
+  0x00, 0xcd, 0x01, 0x4f, 0x04, 0xd6, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xcc,
+  0x01, 0x90, 0x10, 0x07, 0x09, 0xa1, 0xff, 0xcc, 0xfe, 0x85, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x6c, 0x00, 0xcd, 0x04, 0x28, 0x04, 0xd5, 0x10, 0x27,
+  0x09, 0xa1, 0x02, 0xa5, 0x01, 0x8f, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xa8,
+  0x01, 0x8f, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xa5, 0xfe, 0x85, 0x10, 0x07,
+  0x09, 0xa1, 0xff, 0xa8, 0xfe, 0x85, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3,
+  0x02, 0x2d, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xdf,
+  0x01, 0x24, 0x10, 0x06, 0x08, 0xee, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x05, 0x21,
+  0x15, 0x21, 0x04, 0x87, 0xbe, 0xbe, 0x01, 0xbe, 0xbe, 0xfc, 0x3b, 0x03,
+  0x03, 0xfc, 0xfd, 0x01, 0x9d, 0xfe, 0x03, 0xcb, 0xfe, 0x95, 0xaa, 0x00,
+  0xff, 0xff, 0x00, 0xc2, 0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
+  0x08, 0xee, 0x00, 0x00, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfd, 0xfe, 0x57,
+  0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe, 0x01, 0x24, 0x10, 0x27, 0x09, 0xa1,
+  0x03, 0xc2, 0xfe, 0x57, 0x10, 0x07, 0x09, 0xa1, 0x03, 0xc3, 0x01, 0x24,
+  0xff, 0xff, 0x00, 0xc3, 0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
+  0x09, 0x18, 0x00, 0x00, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xde, 0xfe, 0x57,
+  0x10, 0x07, 0x09, 0xa1, 0x01, 0xdf, 0x01, 0x24, 0x00, 0x01, 0x00, 0xc3,
+  0x01, 0xd3, 0x05, 0x46, 0x03, 0x32, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x33, 0x32, 0x36, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09,
+  0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63,
+  0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55, 0x4d, 0x98, 0x03, 0x32, 0xb3,
+  0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e,
+  0x45, 0x3b, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b, 0x00, 0x01, 0x00, 0xc3,
+  0x01, 0xd3, 0x05, 0x46, 0x03, 0x32, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x1e,
+  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16,
+  0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x26, 0x27, 0xc3, 0x5d, 0x98, 0x4e, 0x54, 0x8c, 0x0d, 0x05,
+  0x05, 0x0a, 0x84, 0x63, 0x58, 0xa1, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b,
+  0x0e, 0x05, 0x06, 0x09, 0x84, 0x63, 0x57, 0xa1, 0x5f, 0x03, 0x32, 0x55,
+  0x4b, 0x3d, 0x06, 0x02, 0x02, 0x05, 0x3b, 0x45, 0x4e, 0xb3, 0x54, 0x4c,
+  0x3d, 0x06, 0x02, 0x03, 0x04, 0x3b, 0x45, 0x4e, 0x00, 0x01, 0x00, 0x91,
+  0x01, 0x31, 0x05, 0x77, 0x03, 0xd4, 0x00, 0x29, 0x00, 0x00, 0x01, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x15, 0x1e, 0x01, 0x33, 0x15, 0x22, 0x2e, 0x01,
+  0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x2e, 0x01, 0x23, 0x37, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0x02, 0xe7, 0x49, 0x8f, 0x40, 0x4a, 0x5a, 0x01,
+  0x5e, 0x46, 0x5f, 0x8c, 0x53, 0x5a, 0x80, 0x63, 0x6c, 0xaf, 0x37, 0x3a,
+  0x9e, 0x41, 0x4a, 0x5a, 0x02, 0x5e, 0x46, 0x01, 0x5e, 0x8d, 0x53, 0x5a,
+  0x80, 0x63, 0x6c, 0xb1, 0x02, 0x2e, 0x74, 0x74, 0x6c, 0x48, 0x3d, 0x59,
+  0x9b, 0x4f, 0x9a, 0x48, 0x4c, 0xa2, 0x5c, 0x7d, 0x58, 0x5b, 0x8d, 0x6c,
+  0x48, 0x3d, 0x59, 0x9b, 0x4f, 0x9a, 0x48, 0x4c, 0xa2, 0x5c, 0x7d, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x57, 0x05, 0x46, 0x04, 0xad, 0x00, 0x11,
+  0x00, 0x00, 0x01, 0x02, 0x23, 0x22, 0x03, 0x02, 0x27, 0x22, 0x03, 0x23,
+  0x12, 0x33, 0x32, 0x13, 0x12, 0x17, 0x32, 0x13, 0x05, 0x45, 0x6f, 0xe2,
+  0xcf, 0x59, 0x5c, 0x5c, 0x68, 0x50, 0x99, 0x6f, 0xe2, 0xcf, 0x5a, 0x5b,
+  0x5c, 0x68, 0x50, 0x02, 0xd7, 0xfd, 0x80, 0x01, 0xd6, 0x01, 0xdc, 0x01,
+  0xfe, 0x23, 0x02, 0x80, 0xfe, 0x2a, 0xfe, 0x24, 0x01, 0x01, 0xdd, 0x00,
+  0x00, 0x01, 0x00, 0xbb, 0x00, 0x00, 0x01, 0xf8, 0x05, 0x02, 0x00, 0x1d,
+  0x00, 0x00, 0x21, 0x23, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x35, 0x34, 0x26, 0x27, 0x33, 0x1e, 0x01, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x16, 0x01, 0xf8, 0xa2, 0x46,
+  0x3d, 0x34, 0x03, 0x04, 0x02, 0x05, 0x36, 0x44, 0x4c, 0xa2, 0x46, 0x3e,
+  0x35, 0x05, 0x02, 0x02, 0x05, 0x36, 0x43, 0x68, 0xb4, 0x60, 0x6e, 0x92,
+  0x0a, 0x08, 0x06, 0x0e, 0x9c, 0x5e, 0x58, 0xac, 0x62, 0x6a, 0xb2, 0x62,
+  0x6e, 0x92, 0x0c, 0x04, 0x06, 0x10, 0x9a, 0x5e, 0x56, 0xaa, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x9d, 0x05, 0x46, 0x04, 0x6c, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x13, 0x17, 0x03, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e,
+  0x01, 0x23, 0x22, 0x27, 0x03, 0x27, 0x02, 0x9c, 0x5a, 0x3c, 0x50, 0x9a,
+  0x59, 0x5f, 0xa1, 0x57, 0x54, 0x6c, 0x9c, 0x8b, 0x97, 0x5b, 0x3e, 0x4d,
+  0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x56, 0x6d, 0x9a, 0x8b, 0x02, 0x53, 0x20,
+  0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x2b, 0x01, 0x7e, 0x46, 0xfe, 0x8c, 0x20,
+  0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x2c, 0xfe, 0x85, 0x46, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x01, 0x10, 0x05, 0x46, 0x03, 0xa2, 0x00, 0x1c,
+  0x00, 0x20, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15,
+  0x21, 0x05, 0x45, 0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c,
+  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x09, 0x05, 0x05,
+  0x0e, 0x8b, 0x55, 0x4d, 0x98, 0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x02,
+  0x6f, 0xb3, 0x4e, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3,
+  0x4e, 0x45, 0x3b, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b, 0x01, 0x88, 0xa8,
+  0x00, 0x02, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x03, 0xf4, 0x00, 0x1a,
+  0x00, 0x1e, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15, 0x21, 0x05, 0x45,
+  0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a,
+  0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98,
+  0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xf4, 0xb2, 0x4f, 0x45, 0x3b,
+  0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x09,
+  0x3d, 0x4b, 0xfe, 0x6b, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x62, 0x05, 0x46, 0x04, 0xd3, 0x00, 0x25, 0x00, 0x26, 0x00, 0x00,
+  0x01, 0x03, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x27, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x23, 0x35, 0x21,
+  0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f,
+  0x01, 0x13, 0x01, 0x04, 0x83, 0xb7, 0x1c, 0x21, 0x41, 0x53, 0x9d, 0x0b,
+  0x5e, 0xa1, 0x58, 0x3b, 0x48, 0x82, 0x02, 0x5c, 0xfd, 0x3e, 0xa7, 0x7b,
+  0x61, 0xff, 0x01, 0x70, 0xa6, 0x83, 0x50, 0x50, 0x9a, 0x59, 0x5f, 0xa1,
+  0x57, 0x63, 0x85, 0x2d, 0xd7, 0xfd, 0xbe, 0x04, 0x6f, 0xfe, 0xe9, 0x0b,
+  0x2d, 0x58, 0x22, 0xb2, 0x4f, 0x45, 0x16, 0xba, 0xaa, 0xfe, 0x64, 0x9a,
+  0xaa, 0xf3, 0x38, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x16, 0x01, 0x49,
+  0xfc, 0x8d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46,
+  0x04, 0xc1, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x00, 0x01, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36,
+  0x01, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x05, 0x45, 0x5e, 0xa2,
+  0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f,
+  0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0xfb, 0xdb,
+  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0xc1, 0xb2, 0x4f,
+  0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b,
+  0x06, 0x07, 0x3f, 0x4b, 0xfe, 0x6b, 0xaa, 0xcb, 0xaa, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x18, 0x05, 0x46, 0x04, 0xc1, 0x00, 0x1a,
+  0x00, 0x2e, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x23, 0x35, 0x21, 0x37, 0x21,
+  0x35, 0x21, 0x37, 0x17, 0x07, 0x33, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21,
+  0x07, 0x27, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x10, 0x05, 0x0d,
+  0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14,
+  0x8b, 0x55, 0x4d, 0x98, 0xfc, 0xab, 0xd0, 0x01, 0x6d, 0xbc, 0xfd, 0xd7,
+  0x02, 0xca, 0x7e, 0x64, 0x11, 0xe7, 0xfe, 0x77, 0xbb, 0x02, 0x44, 0xfd,
+  0x1b, 0x95, 0x64, 0x04, 0xc1, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06,
+  0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0xfc,
+  0x4c, 0xaa, 0xcb, 0xaa, 0x8a, 0x73, 0x17, 0xaa, 0xcb, 0xaa, 0xa0, 0x73,
+  0x00, 0x01, 0x00, 0xc3, 0xff, 0xf6, 0x05, 0x46, 0x05, 0x42, 0x00, 0x2e,
+  0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x27, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07,
+  0x27, 0x37, 0x23, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x37, 0x27, 0x26,
+  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x37,
+  0x17, 0x03, 0xf2, 0x09, 0x08, 0x43, 0x57, 0x42, 0x66, 0x5e, 0xa1, 0x58,
+  0x23, 0x27, 0x52, 0x01, 0xf3, 0xfd, 0xbb, 0x62, 0x02, 0xa7, 0xfd, 0x08,
+  0x5e, 0x83, 0x37, 0xe0, 0x01, 0x32, 0x62, 0xfe, 0x6c, 0x01, 0xe6, 0x6a,
+  0x2d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x59,
+  0x78, 0x84, 0x04, 0x22, 0x01, 0x25, 0x1e, 0x5d, 0xb2, 0x4f, 0x45, 0x07,
+  0xab, 0xaa, 0xcb, 0xaa, 0xc2, 0x4e, 0x74, 0xaa, 0xcb, 0xaa, 0xda, 0x14,
+  0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x25, 0xfa, 0x4e, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x01, 0x10, 0x05, 0x46, 0x03, 0xf4, 0x00, 0x1d,
+  0x00, 0x3b, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x33, 0x32, 0x36, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09,
+  0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63,
+  0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa1,
+  0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59,
+  0x5f, 0xa1, 0x57, 0x63, 0x85, 0x08, 0x05, 0x06, 0x0e, 0x8b, 0x55, 0x4d,
+  0x98, 0x02, 0x6f, 0xb3, 0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d,
+  0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x3b, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b,
+  0x01, 0xda, 0xb2, 0x4f, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c,
+  0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x04, 0x02, 0x03, 0x06, 0x3d, 0x4b, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x05, 0x05, 0x46, 0x04, 0xff, 0x00, 0x34,
+  0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x27, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x2f, 0x01, 0x03, 0x27, 0x13, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
+  0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
+  0x3e, 0x01, 0x32, 0x1f, 0x01, 0x13, 0x17, 0x03, 0xa9, 0x33, 0x27, 0x4d,
+  0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x39, 0x45, 0x42, 0x84, 0x51, 0x4d, 0x98,
+  0x5d, 0x5e, 0xa1, 0x58, 0x76, 0x70, 0x11, 0x7f, 0x94, 0x7c, 0x33, 0x27,
+  0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x3a, 0x45, 0x41, 0x83, 0x51, 0x50,
+  0x9a, 0x59, 0x5f, 0xa1, 0xae, 0x91, 0x10, 0x7f, 0x93, 0x03, 0x61, 0x0d,
+  0x4b, 0x55, 0xb2, 0x4f, 0x45, 0x14, 0xbb, 0x38, 0x4b, 0x55, 0xb3, 0x4e,
+  0x45, 0x3b, 0x09, 0xfe, 0x98, 0x40, 0x01, 0x5e, 0x0d, 0x4c, 0x54, 0xb3,
+  0x4e, 0x45, 0x14, 0xbb, 0x38, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x07,
+  0x01, 0x66, 0x40, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46,
+  0x04, 0xc9, 0x00, 0x1a, 0x00, 0x35, 0x00, 0x39, 0x00, 0x00, 0x01, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36,
+  0x13, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33,
+  0x32, 0x36, 0x01, 0x21, 0x15, 0x21, 0x05, 0x45, 0x5e, 0xa2, 0x57, 0x63,
+  0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57,
+  0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa2, 0x57,
+  0x65, 0x81, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1,
+  0x57, 0x63, 0x85, 0x0d, 0x14, 0xb2, 0x2e, 0x4d, 0x98, 0xfb, 0xdb, 0x04,
+  0x82, 0xfb, 0x7e, 0x03, 0x4c, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06,
+  0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0x01,
+  0xd2, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2,
+  0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0xfc, 0xee, 0xaa, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0x00, 0x79, 0x05, 0x46, 0x04, 0xd1, 0x00, 0x1a,
+  0x00, 0x35, 0x00, 0x50, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
+  0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
+  0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36,
+  0x05, 0x45, 0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54,
+  0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55,
+  0x4d, 0x98, 0x5d, 0x5e, 0xa2, 0x57, 0x63, 0x83, 0x10, 0x05, 0x0d, 0x8c,
+  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14, 0x8b,
+  0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa2, 0x57, 0x65, 0x81, 0x10, 0x05, 0x0d,
+  0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x0d, 0x14,
+  0xb2, 0x2e, 0x4d, 0x98, 0x01, 0xd7, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02,
+  0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b,
+  0x01, 0xd2, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53,
+  0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x07, 0x3f, 0x4b, 0x01, 0xd2, 0xb2, 0x4f,
+  0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b,
+  0x06, 0x07, 0x3f, 0x4b, 0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46,
+  0x04, 0xc1, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x00, 0x13, 0x1e,
+  0x01, 0x33, 0x32, 0x3f, 0x02, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
+  0x01, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x23, 0x22, 0x26, 0x27,
+  0x01, 0x15, 0x21, 0x35, 0x01, 0x15, 0x21, 0x35, 0xc3, 0x5d, 0x98, 0x4e,
+  0x54, 0x8c, 0x13, 0x0e, 0x84, 0x63, 0x58, 0xa1, 0x5e, 0x58, 0x9b, 0x4f,
+  0x55, 0x8b, 0x0e, 0x05, 0x0f, 0x84, 0x63, 0x57, 0xa1, 0x5f, 0x04, 0x82,
+  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0xc1, 0x55, 0x4b, 0x3f, 0x07,
+  0x06, 0x3b, 0x45, 0x4e, 0xb2, 0x53, 0x4c, 0x3d, 0x06, 0x02, 0x07, 0x3b,
+  0x45, 0x4f, 0xfe, 0xc8, 0xaa, 0xaa, 0xfe, 0x8b, 0xaa, 0xaa, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc2, 0x00, 0xd7, 0x05, 0x46, 0x04, 0x2b, 0x00, 0x09,
+  0x00, 0x13, 0x00, 0x00, 0x01, 0x20, 0x25, 0x35, 0x04, 0x05, 0x20, 0x25,
+  0x15, 0x04, 0x05, 0x20, 0x05, 0x15, 0x24, 0x25, 0x04, 0x05, 0x35, 0x24,
+  0x03, 0x05, 0xfe, 0xfe, 0xfe, 0xbf, 0x01, 0x43, 0x01, 0x00, 0x01, 0x09,
+  0x01, 0x36, 0xfe, 0xc5, 0xfe, 0xfd, 0x01, 0x07, 0x01, 0x38, 0xfe, 0xc6,
+  0xfe, 0xfb, 0xfe, 0xfd, 0xfe, 0xc0, 0x01, 0x44, 0x02, 0xd3, 0xa6, 0xb2,
+  0x95, 0x11, 0xa6, 0xb2, 0x97, 0xb3, 0xa6, 0xb2, 0x97, 0x0f, 0x02, 0xa4,
+  0xb2, 0x97, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x36, 0x05, 0x46,
+  0x04, 0xce, 0x00, 0x1c, 0x00, 0x39, 0x00, 0x00, 0x25, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x21, 0x15, 0x23, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x35, 0x21, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x13, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x35, 0x33, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x15,
+  0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x03, 0x05, 0x3c, 0x29, 0x32, 0x1b,
+  0x18, 0x04, 0x01, 0x72, 0xef, 0x0d, 0x1a, 0x31, 0x4d, 0x50, 0xb9, 0x51,
+  0x4d, 0x31, 0x1b, 0x0b, 0xf0, 0x01, 0x73, 0x04, 0x18, 0x1b, 0x32, 0x29,
+  0x3d, 0x3d, 0x29, 0x32, 0x1b, 0x18, 0x04, 0xfe, 0x8d, 0xf0, 0x0b, 0x1b,
+  0x31, 0x4d, 0x51, 0xb9, 0x50, 0x4d, 0x31, 0x1a, 0x0d, 0xef, 0xfe, 0x8e,
+  0x04, 0x18, 0x1b, 0x32, 0x29, 0xd9, 0x04, 0x1e, 0x2c, 0x43, 0x45, 0x5b,
+  0xa8, 0x3c, 0x30, 0x5b, 0x32, 0x33, 0x33, 0x32, 0x5b, 0x33, 0x39, 0xa8,
+  0x5c, 0x44, 0x44, 0x2b, 0x1e, 0x03, 0x4e, 0x04, 0x1e, 0x2b, 0x44, 0x44,
+  0x5c, 0xa8, 0x39, 0x33, 0x5b, 0x32, 0x33, 0x33, 0x32, 0x5b, 0x30, 0x3c,
+  0xa8, 0x5b, 0x45, 0x43, 0x2c, 0x1e, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x01, 0x60, 0x05, 0x46, 0x04, 0xce, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00,
+  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x35, 0x33, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x15, 0x21,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x15, 0x21, 0x03, 0x05, 0x3d,
+  0x29, 0x32, 0x1b, 0x18, 0x04, 0xfe, 0x8d, 0xf0, 0x0b, 0x1b, 0x31, 0x4d,
+  0x51, 0xb9, 0x50, 0x4d, 0x31, 0x1a, 0x0d, 0xef, 0xfe, 0x8e, 0x04, 0x18,
+  0x1b, 0x32, 0x29, 0xfd, 0x82, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x2b, 0x04,
+  0x1e, 0x2b, 0x44, 0x44, 0x5c, 0xa8, 0x39, 0x33, 0x5b, 0x32, 0x33, 0x33,
+  0x32, 0x5b, 0x30, 0x3c, 0xa8, 0x5b, 0x45, 0x43, 0x2c, 0x1e, 0xfd, 0xe3,
+  0xaa, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
+  0x04, 0xff, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xe0, 0x01, 0xb9, 0x10, 0x06,
+  0x00, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0x00, 0x02, 0x05, 0x46,
+  0x04, 0xff, 0x10, 0x27, 0x09, 0xa1, 0x01, 0xde, 0xfd, 0xba, 0x10, 0x26,
+  0x00, 0x20, 0x00, 0x00, 0x10, 0x07, 0x09, 0xa1, 0x01, 0xdf, 0x01, 0xb9,
+  0xff, 0xff, 0x00, 0xc3, 0x00, 0x05, 0x05, 0x48, 0x04, 0xff, 0x10, 0x27,
+  0x09, 0xa1, 0xff, 0xfe, 0x01, 0xb9, 0x10, 0x26, 0x00, 0x20, 0x00, 0x00,
+  0x10, 0x07, 0x09, 0xa1, 0x03, 0xc5, 0xfd, 0xbd, 0xff, 0xff, 0x00, 0xc3,
+  0x00, 0x05, 0x05, 0x47, 0x04, 0xff, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe,
+  0xfd, 0xbd, 0x10, 0x26, 0x00, 0x20, 0x02, 0x00, 0x10, 0x07, 0x09, 0xa1,
+  0x03, 0xc3, 0x01, 0xb9, 0xff, 0xff, 0x00, 0xba, 0x01, 0x36, 0x06, 0x7a,
+  0x03, 0xcf, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xf5, 0xfe, 0xee, 0x10, 0x27,
+  0x09, 0xa1, 0xff, 0xf5, 0x00, 0x89, 0x10, 0x07, 0x00, 0x20, 0x01, 0x35,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb8, 0x01, 0x36, 0x06, 0x7b,
+  0x03, 0xcc, 0x10, 0x26, 0x00, 0x20, 0xf5, 0x00, 0x10, 0x27, 0x09, 0xa1,
+  0x04, 0xf8, 0x00, 0x86, 0x10, 0x07, 0x09, 0xa1, 0x04, 0xf8, 0xfe, 0xee,
+  0x00, 0x02, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x03, 0xa2, 0x00, 0x09,
+  0x00, 0x1b, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x17, 0x33, 0x36, 0x35,
+  0x26, 0x27, 0x17, 0x21, 0x15, 0x21, 0x35, 0x21, 0x26, 0x35, 0x34, 0x37,
+  0x21, 0x35, 0x21, 0x15, 0x21, 0x16, 0x17, 0x14, 0x02, 0x9c, 0x2f, 0x2e,
+  0xda, 0x2f, 0x01, 0x2e, 0x7e, 0x01, 0x52, 0xfb, 0x7e, 0x01, 0x58, 0x16,
+  0x18, 0xfe, 0xa6, 0x04, 0x82, 0xfe, 0xaf, 0x17, 0x01, 0x02, 0xfa, 0x30,
+  0x49, 0x47, 0x30, 0x30, 0x47, 0x47, 0x32, 0xf0, 0xaa, 0xaa, 0x3f, 0x38,
+  0x3e, 0x3b, 0xa8, 0xa8, 0x1a, 0x5f, 0x38, 0x00, 0x00, 0x04, 0x00, 0xc3,
+  0x01, 0x60, 0x05, 0x46, 0x06, 0x15, 0x00, 0x03, 0x00, 0x07, 0x00, 0x11,
+  0x00, 0x20, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x34, 0x26, 0x27, 0x32,
+  0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0x45,
+  0x41, 0x5a, 0x5a, 0x83, 0x5a, 0x5b, 0x41, 0x35, 0x60, 0x24, 0x25, 0x26,
+  0x98, 0x6d, 0x6f, 0x93, 0x96, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0x44,
+  0x62, 0x46, 0x45, 0x60, 0x60, 0x8b, 0x62, 0x71, 0x2b, 0x28, 0x28, 0x64,
+  0x3a, 0x73, 0xa1, 0x9e, 0x76, 0x76, 0xa3, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0x01, 0x60, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x11,
+  0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x01, 0x32,
+  0x17, 0x15, 0x26, 0x23, 0x06, 0x07, 0x35, 0x36, 0xc3, 0x04, 0x82, 0xfb,
+  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0x42, 0xe7, 0xca, 0xca, 0xe7, 0xe5,
+  0xce, 0xd2, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x03, 0xeb, 0x97, 0xb2, 0x97,
+  0x02, 0x95, 0xb2, 0x97, 0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
+  0x06, 0x7f, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x01, 0x13, 0x33, 0x13, 0x23, 0x0b,
+  0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x01, 0x07,
+  0xea, 0xa2, 0xe9, 0x8f, 0xab, 0xa5, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x02,
+  0x82, 0x02, 0x9d, 0xfd, 0x63, 0x01, 0xd9, 0xfe, 0x27, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x06, 0x7f, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x01, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x23, 0xc3, 0x04, 0x82,
+  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x01, 0x07, 0x96, 0xa5, 0xab, 0x8f,
+  0xe9, 0xa2, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x05, 0x1f, 0xfe, 0x27, 0x01,
+  0xd9, 0xfd, 0x63, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
+  0x06, 0xca, 0x00, 0x03, 0x00, 0x07, 0x00, 0x11, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x07,
+  0x13, 0x27, 0x07, 0x13, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
+  0x7e, 0xe1, 0x01, 0x0d, 0x54, 0x55, 0x01, 0x0c, 0xda, 0x55, 0xdc, 0xdb,
+  0x54, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0x4e, 0x01, 0x1c, 0xfe, 0xe4,
+  0xb0, 0xfe, 0xe4, 0xb0, 0xb0, 0x01, 0x1c, 0x00, 0x00, 0x04, 0x00, 0xc3,
+  0x01, 0x60, 0x05, 0x46, 0x06, 0xd4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0a,
+  0x00, 0x0e, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x01, 0x03, 0x21, 0x03, 0x33, 0x01, 0x21, 0xc3, 0x04, 0x82, 0xfb, 0x7e,
+  0x04, 0x82, 0xfb, 0x7e, 0x02, 0x42, 0x95, 0x01, 0x2c, 0xc8, 0x64, 0x01,
+  0x04, 0xfd, 0x94, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0xc0, 0xfe, 0x4e,
+  0x02, 0x66, 0xfd, 0x1f, 0x00, 0x07, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46,
+  0x06, 0x1c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x30, 0x00, 0x37,
+  0x00, 0x47, 0x00, 0x4f, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x33, 0x15, 0x23,
+  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x33, 0x03, 0x15,
+  0x21, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x07, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x15, 0x27, 0x35, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22,
+  0x26, 0x34, 0x36, 0x33, 0x32, 0x16, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34,
+  0x26, 0x22, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04,
+  0x2d, 0x38, 0x21, 0x18, 0x62, 0x62, 0x3c, 0x39, 0x39, 0x39, 0x3d, 0xd6,
+  0xfe, 0xee, 0x46, 0x3b, 0x23, 0x41, 0x1f, 0x20, 0x43, 0x23, 0x57, 0x65,
+  0x60, 0x52, 0x49, 0x55, 0x3c, 0x36, 0x2c, 0x31, 0x41, 0xb3, 0x3c, 0x3c,
+  0x12, 0x3a, 0x28, 0x41, 0x53, 0x53, 0x41, 0x28, 0x3a, 0xb9, 0x36, 0x5f,
+  0x36, 0x36, 0x5f, 0x03, 0xa2, 0xa8, 0xf0, 0xaa, 0x04, 0xbc, 0x37, 0x1e,
+  0x24, 0x24, 0x33, 0xfe, 0xa0, 0x01, 0x60, 0x33, 0x1c, 0x44, 0x3d, 0xfe,
+  0xaa, 0x20, 0x44, 0x48, 0x13, 0x12, 0x3e, 0x0f, 0x10, 0x70, 0x60, 0x63,
+  0x74, 0x69, 0x47, 0x36, 0x42, 0x3f, 0x39, 0x69, 0xda, 0xfd, 0xd0, 0x3d,
+  0x24, 0x23, 0x74, 0xbe, 0x75, 0x23, 0x67, 0x93, 0x53, 0x53, 0x93, 0x53,
+  0x00, 0x03, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x06, 0x14, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x2a, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x23, 0x11,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0x5c,
+  0x1e, 0x54, 0x38, 0x4d, 0x52, 0x50, 0x32, 0x33, 0x3e, 0x49, 0x50, 0x32,
+  0x34, 0x3d, 0x48, 0x51, 0x51, 0x1b, 0x4d, 0x35, 0x35, 0x4a, 0x03, 0xa2,
+  0xa8, 0xf0, 0xaa, 0x04, 0x3d, 0x3d, 0x3a, 0x78, 0x6f, 0xfe, 0xb5, 0x01,
+  0x48, 0x4f, 0x4d, 0x5d, 0x51, 0xfe, 0xca, 0x01, 0x48, 0x50, 0x4c, 0x5e,
+  0x50, 0xfe, 0xca, 0x02, 0x25, 0x55, 0x32, 0x30, 0x3d, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xc3, 0x01, 0x60, 0x05, 0x46, 0x06, 0xda, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x2c, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x15, 0x21, 0x01, 0x33, 0x15, 0x23, 0x37, 0x23, 0x35, 0x34,
+  0x36, 0x3f, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x0f, 0x01, 0x0e,
+  0x01, 0x07, 0x0e, 0x01, 0x15, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
+  0xfb, 0x7e, 0x01, 0xfc, 0x5b, 0x5b, 0x58, 0x56, 0x1a, 0x28, 0x29, 0x19,
+  0x17, 0x3b, 0x30, 0x24, 0x50, 0x2c, 0x2a, 0x57, 0x2e, 0x53, 0x65, 0x21,
+  0x28, 0x28, 0x15, 0x12, 0x03, 0x03, 0x03, 0x03, 0xa2, 0xa8, 0xf0, 0xaa,
+  0x03, 0x01, 0x7f, 0xc8, 0x4e, 0x32, 0x41, 0x2b, 0x2c, 0x1b, 0x2f, 0x18,
+  0x2d, 0x37, 0x23, 0x21, 0x5e, 0x1c, 0x1c, 0x61, 0x4f, 0x26, 0x45, 0x2b,
+  0x2b, 0x17, 0x1b, 0x0d, 0x0a, 0x1e, 0x1a, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0x00, 0x27, 0x05, 0x46, 0x04, 0xdd, 0x00, 0x13, 0x00, 0x00, 0x13, 0x21,
+  0x13, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27,
+  0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0xc3, 0x02, 0xb7, 0xe6, 0x71, 0x9d,
+  0x01, 0x11, 0xfe, 0x74, 0xaf, 0x02, 0x3b, 0xfd, 0x47, 0xe8, 0x70, 0x9c,
+  0xfe, 0xf3, 0x01, 0x8b, 0xaf, 0xfd, 0xc6, 0x03, 0xa2, 0x01, 0x3b, 0x66,
+  0xd5, 0xa8, 0xf0, 0xaa, 0xfe, 0xc7, 0x66, 0xd3, 0xaa, 0xf0, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0x00, 0xb8, 0x05, 0x46, 0x04, 0x4c, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04,
+  0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x02, 0xd7, 0xaa, 0x02, 0x1f,
+  0xaa, 0xfd, 0xc0, 0xaa, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xce, 0x05, 0x46,
+  0x05, 0x34, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x37, 0x17,
+  0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21,
+  0x07, 0x27, 0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x03, 0x39,
+  0xfd, 0x8a, 0x02, 0xc9, 0x73, 0x8a, 0x49, 0x01, 0x05, 0xfe, 0xa7, 0x66,
+  0x01, 0xbf, 0xfd, 0xf0, 0x63, 0x02, 0x73, 0xfd, 0x38, 0x74, 0x8a, 0x4a,
+  0xfe, 0xfa, 0x01, 0x5b, 0x64, 0xfe, 0x41, 0x02, 0x11, 0x03, 0xa2, 0xaa,
+  0xe8, 0x54, 0x94, 0xaa, 0xcb, 0xaa, 0xcb, 0xaa, 0xea, 0x54, 0x96, 0xaa,
+  0xcb, 0xaa, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
+  0x05, 0x09, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
+  0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
+  0x11, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
+  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x94, 0xaa,
+  0x02, 0x1f, 0xaa, 0xfc, 0x4b, 0xaa, 0x02, 0x1f, 0xaa, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x06,
+  0x00, 0x0a, 0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x09, 0x01, 0x21,
+  0x15, 0x21, 0x05, 0x45, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82,
+  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xf8, 0xfe, 0xeb, 0xfe, 0xee,
+  0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0xfc, 0x02, 0xaa, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x06,
+  0x00, 0x0a, 0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x09, 0x01,
+  0x15, 0x21, 0x35, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x61, 0x01, 0x21,
+  0xfb, 0x7e, 0x03, 0xf8, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01,
+  0x12, 0xfd, 0xc7, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4,
+  0xff, 0x56, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e,
+  0x00, 0x00, 0x33, 0x21, 0x15, 0x21, 0x09, 0x02, 0x15, 0x01, 0x35, 0x09,
+  0x01, 0x21, 0x15, 0x21, 0xc4, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc,
+  0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
+  0x7e, 0xaa, 0x05, 0x15, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa,
+  0x01, 0x6f, 0xfc, 0x02, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4,
+  0xff, 0x56, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e,
+  0x00, 0x00, 0x21, 0x15, 0x21, 0x35, 0x11, 0x35, 0x01, 0x15, 0x01, 0x35,
+  0x09, 0x01, 0x15, 0x21, 0x35, 0x05, 0x46, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
+  0x7e, 0x03, 0x60, 0x01, 0x22, 0xfb, 0x7e, 0xaa, 0xaa, 0x04, 0x6b, 0xb0,
+  0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0xfd, 0xc7, 0xaa, 0xaa,
+  0x00, 0x02, 0x00, 0xc4, 0xfe, 0xb1, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x13,
+  0x00, 0x1a, 0x00, 0x00, 0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21,
+  0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
+  0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x01, 0xf0, 0xfe, 0xd4, 0x01, 0xab,
+  0x56, 0xfd, 0xff, 0x02, 0x81, 0x7b, 0x7c, 0x24, 0x01, 0x2e, 0xfe, 0x52,
+  0x56, 0x02, 0x04, 0xfd, 0x7d, 0x7c, 0x7c, 0x03, 0x7b, 0xfc, 0xa0, 0x03,
+  0x60, 0xfb, 0x7e, 0x04, 0x82, 0xaa, 0xaa, 0x73, 0xaa, 0xa4, 0x73, 0x31,
+  0xaa, 0x73, 0xaa, 0xa5, 0x74, 0x05, 0x46, 0xfe, 0xeb, 0xfe, 0xee, 0xb2,
+  0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc4,
+  0xfe, 0xb1, 0x05, 0x46, 0x05, 0x1b, 0x00, 0x13, 0x00, 0x1a, 0x00, 0x00,
+  0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21,
+  0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x01, 0x35, 0x01, 0x15,
+  0x01, 0x35, 0x01, 0x01, 0xf0, 0xfe, 0xd4, 0x01, 0xab, 0x56, 0xfd, 0xff,
+  0x02, 0x81, 0x7b, 0x7c, 0x24, 0x01, 0x2e, 0xfe, 0x52, 0x56, 0x02, 0x04,
+  0xfd, 0x7d, 0x7c, 0x7c, 0xfe, 0xf9, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60,
+  0xaa, 0xaa, 0x73, 0xaa, 0xa4, 0x73, 0x31, 0xaa, 0x73, 0xaa, 0xa5, 0x74,
+  0x05, 0x46, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00,
+  0x00, 0x02, 0x00, 0x85, 0x00, 0x2e, 0x07, 0x04, 0x04, 0xdf, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x09,
+  0x01, 0x15, 0x01, 0x35, 0x01, 0x07, 0x04, 0xfd, 0x19, 0x02, 0xe7, 0xfc,
+  0x36, 0x03, 0xca, 0xfd, 0x4c, 0xfd, 0x18, 0x02, 0xe8, 0xfc, 0x36, 0x03,
+  0xca, 0x04, 0x11, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08, 0x9f, 0x02,
+  0x0a, 0xce, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08, 0x9f, 0x02, 0x0a,
+  0x00, 0x02, 0x00, 0x85, 0x00, 0x2e, 0x07, 0x04, 0x04, 0xdf, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x03,
+  0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x86, 0x03, 0xca, 0xfc, 0x36, 0x02,
+  0xe7, 0x33, 0x03, 0xca, 0xfc, 0x36, 0x02, 0xe7, 0x04, 0x11, 0xce, 0xfd,
+  0xf6, 0x9f, 0xfd, 0xf8, 0xc5, 0x01, 0x8e, 0x01, 0x90, 0xce, 0xfd, 0xf6,
+  0x9f, 0xfd, 0xf8, 0xc5, 0x01, 0x8e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9e,
+  0xfe, 0xf2, 0x02, 0xb9, 0x06, 0x12, 0x00, 0x19, 0x00, 0x27, 0x00, 0x00,
+  0x01, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16,
+  0x17, 0x21, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x26, 0x27, 0x13, 0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x27, 0x06, 0x07,
+  0x06, 0x10, 0x17, 0x16, 0x02, 0x3c, 0x26, 0x1f, 0x50, 0x2f, 0x43, 0x43,
+  0x2f, 0x50, 0x1f, 0x26, 0xfe, 0xe0, 0x25, 0x1f, 0x50, 0x2f, 0x43, 0x43,
+  0x2f, 0x50, 0x1f, 0x25, 0x90, 0x13, 0x0f, 0x3b, 0x3a, 0x10, 0x13, 0x14,
+  0x10, 0x3a, 0x3b, 0x0f, 0x06, 0x12, 0x47, 0x46, 0xa3, 0x9e, 0xe2, 0xdf,
+  0xe0, 0xe3, 0x9e, 0xa2, 0x47, 0x47, 0x47, 0x47, 0xa2, 0x9e, 0xe3, 0xe0,
+  0xdf, 0xe2, 0x9e, 0xa3, 0x46, 0x47, 0xfa, 0x32, 0x3b, 0x3b, 0xe2, 0x01,
+  0xce, 0xe1, 0x3b, 0x3c, 0x3c, 0x3b, 0xe1, 0xfe, 0x32, 0xe2, 0x3b, 0x00,
+  0x00, 0x01, 0x00, 0xc2, 0x00, 0x1a, 0x05, 0x46, 0x04, 0xe8, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x35, 0x36, 0x3f, 0x01, 0x26, 0x25, 0x35,
+  0x04, 0x37, 0x13, 0x17, 0x07, 0x36, 0x37, 0x15, 0x06, 0x0f, 0x01, 0x16,
+  0x05, 0x15, 0x24, 0x07, 0x03, 0x27, 0x02, 0x1b, 0xa2, 0xb5, 0xee, 0xca,
+  0x5b, 0xf0, 0xfe, 0xdc, 0x01, 0x86, 0xe6, 0xb1, 0x85, 0x79, 0xa4, 0xb5,
+  0xec, 0xcd, 0x5a, 0xf5, 0x01, 0x1f, 0xfe, 0x79, 0xe6, 0xb0, 0x86, 0x01,
+  0x5d, 0x29, 0x5d, 0xb2, 0x6f, 0x26, 0xb6, 0x0e, 0x97, 0xb2, 0xaf, 0x0a,
+  0x01, 0x62, 0x52, 0xf4, 0x29, 0x60, 0xb2, 0x71, 0x25, 0xb5, 0x0d, 0x98,
+  0xb2, 0xaf, 0x0b, 0xfe, 0x9f, 0x52, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x05, 0x05, 0x46, 0x05, 0x64, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x00,
+  0x01, 0x05, 0x15, 0x25, 0x03, 0x27, 0x13, 0x25, 0x35, 0x01, 0x13, 0x17,
+  0x07, 0x25, 0x15, 0x05, 0x07, 0x0d, 0x01, 0x03, 0x40, 0x02, 0x05, 0xfd,
+  0xbb, 0x8a, 0x7a, 0x85, 0xfe, 0x42, 0x02, 0xcc, 0x9b, 0x7b, 0x62, 0x01,
+  0x02, 0xfe, 0xa1, 0xb4, 0xfe, 0x72, 0x01, 0x1d, 0x01, 0xdf, 0xcb, 0xb6,
+  0xea, 0xfe, 0xbd, 0x40, 0x01, 0x36, 0xb4, 0xa6, 0x01, 0x20, 0x01, 0x6f,
+  0x40, 0xe6, 0x68, 0xb6, 0x8b, 0x47, 0x9d, 0x70, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0xa0, 0x05, 0x46, 0x04, 0xff, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x00,
+  0x01, 0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x05, 0x15, 0x01, 0x03, 0x27,
+  0x37, 0x05, 0x35, 0x25, 0x37, 0x2d, 0x01, 0x02, 0xc8, 0xfd, 0xfb, 0x02,
+  0x46, 0x89, 0x7a, 0x84, 0x01, 0xbd, 0xfd, 0x35, 0x9c, 0x7a, 0x62, 0xfe,
+  0xfd, 0x01, 0x5f, 0xb4, 0x01, 0x8e, 0xfe, 0xe4, 0x03, 0x25, 0xcb, 0xb6,
+  0xea, 0x01, 0x43, 0x40, 0xfe, 0xca, 0xb4, 0xa6, 0xfe, 0xe0, 0xfe, 0x91,
+  0x40, 0xe6, 0x68, 0xb6, 0x8b, 0x47, 0x9d, 0x70, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x2f, 0x05, 0x46, 0x05, 0x56, 0x00, 0x02, 0x00, 0x1a, 0x00, 0x00,
+  0x01, 0x0d, 0x01, 0x03, 0x21, 0x35, 0x21, 0x13, 0x25, 0x35, 0x25, 0x13,
+  0x17, 0x07, 0x25, 0x15, 0x05, 0x03, 0x05, 0x15, 0x25, 0x03, 0x21, 0x15,
+  0x21, 0x07, 0x27, 0x03, 0x37, 0xfe, 0xae, 0x01, 0x11, 0xdc, 0xfe, 0xa9,
+  0x01, 0x91, 0x6c, 0xfe, 0x03, 0x02, 0xb6, 0x6a, 0x94, 0x41, 0x01, 0x0f,
+  0xfe, 0xaf, 0x67, 0x01, 0xb8, 0xfe, 0x12, 0x5c, 0x02, 0x4a, 0xfd, 0x7d,
+  0x45, 0x93, 0x03, 0x4f, 0x6c, 0x55, 0xfd, 0x72, 0xaa, 0x01, 0x43, 0xa2,
+  0xaa, 0xdd, 0x01, 0x40, 0x3d, 0xc7, 0x56, 0xb0, 0x6c, 0xfe, 0xd1, 0x8c,
+  0xb2, 0x9e, 0xfe, 0xed, 0xaa, 0xd1, 0x3d, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x2f, 0x05, 0x46, 0x05, 0x56, 0x00, 0x02, 0x00, 0x1a, 0x00, 0x00,
+  0x01, 0x37, 0x27, 0x01, 0x23, 0x35, 0x21, 0x37, 0x05, 0x35, 0x25, 0x37,
+  0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x05, 0x15, 0x05, 0x03, 0x21, 0x15,
+  0x21, 0x07, 0x27, 0x03, 0x36, 0xee, 0xc0, 0xfe, 0x4d, 0xee, 0x01, 0x27,
+  0x4e, 0xfe, 0x8b, 0x01, 0xb7, 0x52, 0xfd, 0xf7, 0x02, 0x3f, 0x77, 0x94,
+  0x73, 0x01, 0xab, 0xfd, 0xaf, 0x62, 0x02, 0xb3, 0xfd, 0x14, 0x46, 0x94,
+  0x02, 0x97, 0x4c, 0x3e, 0xfc, 0xdf, 0xaa, 0xec, 0x77, 0xb2, 0x8b, 0xf5,
+  0xa7, 0xb0, 0xb7, 0x01, 0x65, 0x3d, 0xfe, 0xa8, 0x88, 0xaa, 0xbd, 0xfe,
+  0xd8, 0xaa, 0xd1, 0x3d, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x90, 0x05, 0x46,
+  0x04, 0xa8, 0x00, 0x1d, 0x00, 0x24, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33,
+  0x32, 0x36, 0x13, 0x09, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f,
+  0xa1, 0x57, 0x63, 0x84, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b,
+  0x58, 0x5e, 0xa1, 0x58, 0x63, 0x84, 0x0a, 0x04, 0x06, 0x0d, 0x8c, 0x54,
+  0x4e, 0x98, 0x5c, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xf0,
+  0xb4, 0x4e, 0x44, 0x3a, 0x04, 0x04, 0x02, 0x06, 0x3c, 0x4c, 0x54, 0xb4,
+  0x4e, 0x44, 0x3a, 0x06, 0x02, 0x02, 0x06, 0x3c, 0x4a, 0x03, 0x5e, 0xfe,
+  0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc4, 0xff, 0xb0, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x1b,
+  0x00, 0x22, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x2e,
+  0x01, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x17, 0x1e, 0x01, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x35, 0x01, 0x15,
+  0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x0b,
+  0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x63, 0x85, 0x09,
+  0x0b, 0x0d, 0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdc, 0x04, 0x82, 0xfb, 0x7e,
+  0x03, 0x61, 0x01, 0x0e, 0xb2, 0x4e, 0x46, 0x3c, 0x04, 0x04, 0x06, 0x3e,
+  0x4c, 0x54, 0xb2, 0x4e, 0x46, 0x3c, 0x04, 0x04, 0x06, 0x3e, 0x4c, 0x03,
+  0x3e, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46, 0x05, 0x50, 0x00, 0x31,
+  0x00, 0x34, 0x00, 0x00, 0x25, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
+  0x01, 0x33, 0x32, 0x17, 0x13, 0x25, 0x35, 0x25, 0x13, 0x17, 0x07, 0x25,
+  0x15, 0x05, 0x03, 0x05, 0x15, 0x25, 0x03, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x2f, 0x01, 0x07, 0x27, 0x01, 0x0d, 0x01, 0x02, 0x2d, 0x1b,
+  0x0c, 0x4f, 0x9b, 0x58, 0x5e, 0xa1, 0x58, 0x22, 0x27, 0x60, 0xfd, 0xff,
+  0x02, 0xbb, 0x69, 0x95, 0x3f, 0x01, 0x08, 0xfe, 0xb4, 0x67, 0x01, 0xb3,
+  0xfe, 0x17, 0x60, 0x06, 0x0a, 0x04, 0x06, 0x0d, 0x8c, 0x54, 0x4e, 0x98,
+  0x5d, 0x5f, 0xa1, 0x57, 0x63, 0x84, 0x09, 0x06, 0x05, 0x0e, 0x1f, 0x48,
+  0x95, 0x01, 0x51, 0xfe, 0xaa, 0x01, 0x13, 0x2d, 0x03, 0x4c, 0x54, 0xb4,
+  0x4e, 0x44, 0x07, 0x01, 0x1d, 0xa3, 0xaa, 0xde, 0x01, 0x39, 0x41, 0xbb,
+  0x54, 0xb0, 0x6a, 0xfe, 0xcd, 0x8a, 0xb2, 0x9c, 0xfe, 0xe3, 0x02, 0x06,
+  0x02, 0x02, 0x06, 0x3c, 0x4a, 0x56, 0xb4, 0x4e, 0x44, 0x3a, 0x04, 0x04,
+  0x02, 0x06, 0x0d, 0xd8, 0x3c, 0x03, 0xec, 0x6e, 0x57, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x2f, 0x05, 0x46, 0x05, 0x56, 0x00, 0x31,
+  0x00, 0x34, 0x00, 0x00, 0x01, 0x05, 0x15, 0x05, 0x07, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x27, 0x37, 0x06,
+  0x07, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36, 0x3f, 0x01, 0x05, 0x35, 0x25,
+  0x37, 0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x37, 0x27, 0x03, 0xa1, 0x01,
+  0xa4, 0xfd, 0xb6, 0x54, 0x2b, 0x30, 0x0a, 0x04, 0x06, 0x0d, 0x8c, 0x54,
+  0x4e, 0x98, 0x5d, 0x5f, 0xa1, 0x57, 0x63, 0x84, 0x09, 0x06, 0x05, 0x0e,
+  0x41, 0x34, 0x5e, 0x94, 0x4e, 0x32, 0x32, 0x4d, 0x58, 0x5e, 0x51, 0x45,
+  0x4b, 0x36, 0xfe, 0x8a, 0x01, 0xb8, 0x55, 0xfd, 0xf3, 0x02, 0x43, 0x73,
+  0x94, 0xd1, 0xe8, 0xb9, 0x03, 0xbf, 0x86, 0xaa, 0xbb, 0xf7, 0x0d, 0x16,
+  0x04, 0x02, 0x02, 0x06, 0x3e, 0x4c, 0x54, 0xb2, 0x4e, 0x46, 0x3c, 0x04,
+  0x02, 0x02, 0x06, 0x1d, 0x0f, 0xfe, 0xf1, 0x3d, 0xdf, 0x09, 0x18, 0x26,
+  0x54, 0xb2, 0x4e, 0x23, 0x1e, 0x04, 0xa1, 0x77, 0xb2, 0x8b, 0xf4, 0xa8,
+  0xb0, 0xb8, 0x01, 0x66, 0x3d, 0xfd, 0x80, 0x4a, 0x3b, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xbb, 0xff, 0x4e, 0x05, 0x46, 0x05, 0x7d, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x13, 0x35, 0x01, 0x15, 0x01, 0x35, 0x09, 0x03,
+  0x15, 0x01, 0x35, 0x01, 0xc4, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x01,
+  0x19, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x02, 0x27, 0xb0,
+  0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x03, 0xbb, 0xfe, 0xeb,
+  0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x02, 0x00, 0xbb,
+  0xff, 0x4e, 0x05, 0x46, 0x05, 0x7d, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x00,
+  0x09, 0x02, 0x15, 0x01, 0x35, 0x09, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35,
+  0x01, 0x05, 0x3d, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xfb,
+  0x87, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x02, 0x27, 0xfe, 0xeb, 0xfe,
+  0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x01, 0xf6, 0xb0, 0xfe, 0x91,
+  0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00, 0x03, 0x00, 0xbb,
+  0xfe, 0x6d, 0x05, 0x46, 0x06, 0x60, 0x00, 0x02, 0x00, 0x1e, 0x00, 0x21,
+  0x00, 0x00, 0x2d, 0x02, 0x03, 0x25, 0x35, 0x25, 0x13, 0x17, 0x03, 0x25,
+  0x15, 0x05, 0x03, 0x05, 0x15, 0x25, 0x07, 0x05, 0x15, 0x05, 0x03, 0x27,
+  0x13, 0x05, 0x35, 0x25, 0x13, 0x25, 0x35, 0x05, 0x13, 0x0d, 0x01, 0x02,
+  0xf8, 0x01, 0x2c, 0xfe, 0xfa, 0x57, 0xfd, 0xf4, 0x02, 0x7c, 0x51, 0x95,
+  0x3e, 0x01, 0x5e, 0xfe, 0x7a, 0x3a, 0x01, 0xc0, 0xfe, 0x1d, 0x1a, 0x02,
+  0x06, 0xfd, 0x8c, 0x51, 0x96, 0x3e, 0xfe, 0x9b, 0x01, 0x8d, 0x39, 0xfe,
+  0x3a, 0x01, 0xe9, 0x62, 0xfe, 0xce, 0x01, 0x0d, 0xb3, 0x5f, 0x54, 0x01,
+  0x57, 0xa7, 0xaa, 0xca, 0x01, 0x88, 0x26, 0xfe, 0xd4, 0x6f, 0xb0, 0x7d,
+  0xfe, 0xe4, 0x8e, 0xb2, 0x9a, 0x81, 0xa5, 0xaa, 0xc8, 0xfe, 0x77, 0x26,
+  0x01, 0x2d, 0x72, 0xb2, 0x7e, 0x01, 0x18, 0x91, 0xb0, 0x9b, 0x01, 0xde,
+  0x62, 0x55, 0x00, 0x00, 0x00, 0x03, 0x00, 0xbb, 0xfe, 0x6d, 0x05, 0x46,
+  0x06, 0x60, 0x00, 0x02, 0x00, 0x05, 0x00, 0x21, 0x00, 0x00, 0x01, 0x07,
+  0x17, 0x01, 0x37, 0x2f, 0x01, 0x25, 0x35, 0x05, 0x13, 0x17, 0x03, 0x05,
+  0x15, 0x05, 0x07, 0x25, 0x15, 0x05, 0x07, 0x05, 0x15, 0x25, 0x03, 0x27,
+  0x13, 0x25, 0x35, 0x25, 0x37, 0x05, 0x35, 0x25, 0x02, 0x7a, 0x9d, 0x89,
+  0x01, 0x29, 0x95, 0x83, 0x94, 0xfd, 0xb7, 0x02, 0x6c, 0x58, 0x95, 0x5a,
+  0x01, 0x83, 0xfe, 0x21, 0x1e, 0x01, 0xf4, 0xfd, 0xe5, 0x28, 0x02, 0x43,
+  0xfd, 0x9b, 0x57, 0x96, 0x59, 0xfe, 0x77, 0x01, 0xe6, 0x1e, 0xfe, 0x05,
+  0x02, 0x22, 0x01, 0x44, 0x32, 0x2c, 0x02, 0xa3, 0x2f, 0x2a, 0x2f, 0xbc,
+  0xb0, 0xc5, 0x01, 0xa8, 0x26, 0xfe, 0x4f, 0x7b, 0xaa, 0x98, 0x94, 0x9f,
+  0xb0, 0xad, 0xc2, 0xb8, 0xb2, 0xc4, 0xfe, 0x5b, 0x26, 0x01, 0xae, 0x7d,
+  0xaa, 0x9a, 0x94, 0xa2, 0xb2, 0xad, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0xff, 0xb2, 0x05, 0x46, 0x05, 0x50, 0x00, 0x0a, 0x00, 0x00, 0x01, 0x00,
+  0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x05, 0x45, 0xfe,
+  0x9a, 0xfe, 0x27, 0x01, 0xd5, 0x01, 0x6a, 0xfe, 0x97, 0xfc, 0xe7, 0x03,
+  0x1b, 0x01, 0x67, 0x04, 0x61, 0xfe, 0x81, 0x61, 0x5e, 0xfe, 0x7e, 0xef,
+  0x02, 0x00, 0x7c, 0xa6, 0x7c, 0x02, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0xff, 0xb2, 0x05, 0x46, 0x05, 0x50, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x35,
+  0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0xc3, 0x01, 0x67,
+  0x03, 0x1b, 0xfc, 0xe7, 0xfe, 0x97, 0x01, 0x6a, 0x01, 0xd5, 0xfe, 0x27,
+  0x04, 0x61, 0xef, 0xfe, 0x00, 0x7c, 0xa6, 0x7c, 0xfe, 0x00, 0xef, 0x01,
+  0x82, 0x5e, 0x61, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46,
+  0x05, 0x57, 0x00, 0x05, 0x00, 0x10, 0x00, 0x00, 0x21, 0x15, 0x00, 0x25,
+  0x35, 0x04, 0x01, 0x00, 0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24,
+  0x01, 0x05, 0x45, 0xfe, 0x90, 0xfc, 0xee, 0x03, 0x01, 0x01, 0x81, 0xfe,
+  0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe, 0xa7, 0xfc, 0xd7, 0x03,
+  0x29, 0x01, 0x59, 0xd7, 0x01, 0xbe, 0x91, 0xae, 0x85, 0x02, 0xdf, 0xfe,
+  0xe5, 0x5d, 0x5d, 0xfe, 0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01,
+  0x80, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46,
+  0x05, 0x57, 0x00, 0x05, 0x00, 0x10, 0x00, 0x00, 0x33, 0x00, 0x25, 0x15,
+  0x04, 0x01, 0x11, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25,
+  0x24, 0xc3, 0x01, 0x81, 0x03, 0x01, 0xfc, 0xee, 0xfe, 0x90, 0x01, 0x59,
+  0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7, 0x01, 0x59, 0x01, 0xac, 0xfe, 0x54,
+  0x01, 0xa1, 0x85, 0xae, 0x91, 0xfe, 0x42, 0x05, 0x57, 0xd7, 0xfe, 0x80,
+  0x7c, 0xa6, 0x84, 0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x52, 0x05, 0x46, 0x05, 0x57, 0x00, 0x1d,
+  0x00, 0x28, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x00,
+  0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x05, 0x45, 0x5e,
+  0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a,
+  0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55,
+  0x4d, 0x98, 0x5d, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe,
+  0xa7, 0xfc, 0xd7, 0x03, 0x29, 0x01, 0x59, 0xb1, 0xb3, 0x4e, 0x45, 0x3b,
+  0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x3b, 0x05,
+  0x02, 0x02, 0x06, 0x3d, 0x4b, 0x04, 0x24, 0xfe, 0xe5, 0x5d, 0x5d, 0xfe,
+  0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01, 0x80, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x52, 0x05, 0x46, 0x05, 0x57, 0x00, 0x1d,
+  0x00, 0x28, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x35,
+  0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0x05, 0x45, 0x5e,
+  0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a,
+  0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55,
+  0x4d, 0x98, 0xfb, 0xdb, 0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7,
+  0x01, 0x59, 0x01, 0xac, 0xfe, 0x54, 0xb1, 0xb3, 0x4e, 0x45, 0x3b, 0x04,
+  0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x3b, 0x05, 0x02,
+  0x02, 0x06, 0x3d, 0x4b, 0x04, 0x24, 0xd7, 0xfe, 0x80, 0x7c, 0xa6, 0x84,
+  0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x83, 0x05, 0x46, 0x06, 0x1d, 0x00, 0x15, 0x00, 0x1a, 0x00, 0x00,
+  0x01, 0x26, 0x25, 0x35, 0x24, 0x25, 0x01, 0x17, 0x03, 0x36, 0x37, 0x15,
+  0x06, 0x07, 0x03, 0x04, 0x17, 0x15, 0x02, 0x25, 0x03, 0x27, 0x01, 0x06,
+  0x07, 0x16, 0x17, 0x02, 0xa3, 0xd8, 0xfe, 0xf8, 0x01, 0x96, 0x01, 0x25,
+  0x01, 0x01, 0x76, 0xa7, 0x8e, 0x69, 0xa7, 0xc1, 0x7d, 0x01, 0x06, 0xdf,
+  0xcc, 0xfe, 0xa8, 0xd3, 0x76, 0x01, 0x47, 0x88, 0x91, 0x71, 0x6a, 0x01,
+  0xb0, 0x55, 0x29, 0xa6, 0x3f, 0xa5, 0x02, 0x65, 0x4b, 0xfe, 0x74, 0x75,
+  0x95, 0xef, 0xb3, 0x75, 0xfe, 0xd4, 0x7f, 0xed, 0xef, 0x01, 0x22, 0xa6,
+  0xfe, 0x09, 0x4b, 0x03, 0x0a, 0x39, 0x1e, 0x17, 0x27, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xe5, 0x05, 0x46, 0x05, 0x7f, 0x00, 0x15,
+  0x00, 0x1a, 0x00, 0x00, 0x01, 0x16, 0x05, 0x15, 0x04, 0x05, 0x01, 0x27,
+  0x13, 0x06, 0x07, 0x35, 0x36, 0x37, 0x13, 0x24, 0x27, 0x35, 0x12, 0x05,
+  0x13, 0x17, 0x01, 0x36, 0x37, 0x26, 0x27, 0x03, 0x65, 0xd8, 0x01, 0x08,
+  0xfe, 0x6a, 0xfe, 0xdc, 0xfe, 0xfe, 0x76, 0xa7, 0x8e, 0x69, 0xa8, 0xc0,
+  0x7e, 0xfe, 0xf9, 0xdf, 0xcd, 0x01, 0x57, 0xd4, 0x75, 0xfe, 0xb9, 0x88,
+  0x91, 0x70, 0x6a, 0x03, 0x52, 0x55, 0x29, 0xa6, 0x3f, 0xa5, 0xfd, 0x9b,
+  0x4b, 0x01, 0x8c, 0x75, 0x95, 0xef, 0xb3, 0x75, 0x01, 0x2c, 0x7f, 0xed,
+  0xef, 0xfe, 0xde, 0xa6, 0x01, 0xf7, 0x4b, 0xfc, 0xf6, 0x39, 0x1e, 0x17,
+  0x27, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb7, 0x00, 0xa3, 0x05, 0x51,
+  0x04, 0x5f, 0x00, 0x13, 0x00, 0x00, 0x25, 0x21, 0x22, 0x02, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x21, 0x05, 0x51, 0xfd, 0x15, 0xb6, 0xf8, 0x7c, 0x7c, 0xb4, 0x02,
+  0xed, 0xfd, 0x13, 0x7a, 0xab, 0x54, 0x57, 0x7a, 0x02, 0xed, 0xa3, 0x01,
+  0x16, 0xc8, 0xc6, 0x8d, 0x8b, 0x96, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x00,
+  0x00, 0x01, 0x00, 0xb7, 0x00, 0xa3, 0x05, 0x51, 0x04, 0x5f, 0x00, 0x13,
+  0x00, 0x00, 0x37, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0x21, 0x35, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x02, 0x23, 0xb8, 0x02,
+  0xec, 0x7b, 0x56, 0x55, 0xab, 0x7b, 0xfd, 0x14, 0x02, 0xec, 0xb4, 0x7d,
+  0x7c, 0xf9, 0xb5, 0xa3, 0x96, 0x60, 0x5e, 0x8a, 0x88, 0xc0, 0x96, 0x8b,
+  0x8d, 0xc6, 0xc8, 0xfe, 0xea, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb7,
+  0xff, 0x3b, 0x05, 0x51, 0x05, 0xcf, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00,
+  0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x1b, 0x01,
+  0x33, 0x03, 0x21, 0x15, 0x21, 0x03, 0x21, 0x15, 0x21, 0x03, 0x23, 0x13,
+  0x22, 0x02, 0x35, 0x34, 0x37, 0x36, 0x33, 0x03, 0x45, 0xe1, 0x7a, 0xab,
+  0x54, 0x57, 0x7a, 0x2b, 0xdf, 0x67, 0x99, 0x67, 0x01, 0x4a, 0xfe, 0x8d,
+  0xb6, 0x02, 0x29, 0xfd, 0xae, 0x65, 0x99, 0x65, 0xb4, 0xfa, 0x7c, 0x7c,
+  0xb4, 0x03, 0xc9, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x03, 0x26, 0x01, 0x70,
+  0xfe, 0x90, 0x96, 0xfd, 0x70, 0x96, 0xfe, 0x98, 0x01, 0x68, 0x01, 0x16,
+  0xc8, 0xc6, 0x8d, 0x8b, 0x00, 0x02, 0x00, 0xb7, 0xff, 0x33, 0x05, 0x51,
+  0x05, 0xc7, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x0b, 0x01, 0x23, 0x13, 0x21, 0x35,
+  0x21, 0x13, 0x21, 0x35, 0x21, 0x13, 0x33, 0x03, 0x32, 0x12, 0x15, 0x14,
+  0x07, 0x06, 0x23, 0x02, 0xc3, 0xe1, 0x7b, 0xab, 0x55, 0x56, 0x7b, 0x2b,
+  0xdf, 0x67, 0x99, 0x67, 0xfe, 0xb7, 0x01, 0x72, 0xb6, 0xfd, 0xd8, 0x02,
+  0x52, 0x64, 0x99, 0x64, 0xb4, 0xfa, 0x7c, 0x7d, 0xb4, 0x01, 0x39, 0xc0,
+  0x88, 0x8a, 0x5e, 0x60, 0xfc, 0xda, 0xfe, 0x90, 0x01, 0x70, 0x96, 0x02,
+  0x90, 0x96, 0x01, 0x68, 0xfe, 0x98, 0xfe, 0xea, 0xc8, 0xc6, 0x8d, 0x8b,
+  0x00, 0x02, 0x00, 0xab, 0x00, 0x00, 0x05, 0x46, 0x04, 0xe8, 0x00, 0x03,
+  0x00, 0x18, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x01, 0x21, 0x22, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x21, 0xda, 0x04, 0x6b, 0xfb, 0x95, 0x04, 0x6b,
+  0xfd, 0x14, 0xb5, 0x7c, 0x7d, 0x7d, 0x7c, 0xb4, 0x02, 0xed, 0xfd, 0x13,
+  0x7b, 0xab, 0x56, 0x56, 0x7a, 0x02, 0xed, 0x96, 0x96, 0x01, 0x2c, 0x8b,
+  0x8b, 0xc8, 0xc6, 0x8d, 0x8b, 0x96, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x5e, 0x04, 0xe8, 0x00, 0x03,
+  0x00, 0x18, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x11, 0x35, 0x21, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x23, 0xc3, 0x04, 0x6c, 0xfb, 0x94, 0x02, 0xed,
+  0x7a, 0x57, 0x55, 0xab, 0x7b, 0xfd, 0x13, 0x02, 0xed, 0xb4, 0x7c, 0x7d,
+  0x7d, 0x7c, 0xb5, 0x96, 0x96, 0x01, 0x2c, 0x96, 0x60, 0x5e, 0x8a, 0x88,
+  0xc0, 0x96, 0x8b, 0x8d, 0xc6, 0xc8, 0x8b, 0x8b, 0x00, 0x02, 0x00, 0xab,
+  0xff, 0x13, 0x05, 0x46, 0x05, 0xd7, 0x00, 0x09, 0x00, 0x27, 0x00, 0x00,
+  0x01, 0x21, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x02, 0x21, 0x15,
+  0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x23, 0x35, 0x21, 0x37,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x37, 0x17, 0x07,
+  0x21, 0x15, 0x21, 0x03, 0x6f, 0xfe, 0xe9, 0x7b, 0xab, 0x56, 0x56, 0x7a,
+  0x23, 0x8d, 0x02, 0x3d, 0xfd, 0x8b, 0x37, 0x02, 0xac, 0xfd, 0x1c, 0x58,
+  0x79, 0x45, 0xfb, 0x01, 0x32, 0x38, 0xa7, 0x75, 0x7d, 0x7d, 0x7c, 0xb4,
+  0x01, 0x4f, 0x58, 0x79, 0x44, 0x01, 0x11, 0xfe, 0xb7, 0x04, 0x52, 0xc0,
+  0x88, 0x8a, 0x5e, 0x60, 0x96, 0x96, 0x96, 0xed, 0x35, 0xb8, 0x96, 0x96,
+  0x08, 0x83, 0x8b, 0xc8, 0xc6, 0x8d, 0x8b, 0xef, 0x37, 0xb8, 0x96, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x13, 0x05, 0x5e, 0x05, 0xd7, 0x00, 0x09,
+  0x00, 0x27, 0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x2f, 0x01, 0x21, 0x35, 0x21, 0x37, 0x17, 0x07, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
+  0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x03, 0x08, 0xa8, 0x7a,
+  0x57, 0x55, 0x55, 0x3b, 0x4e, 0x89, 0xfd, 0x54, 0x02, 0xe4, 0x58, 0x79,
+  0x4c, 0x66, 0x4e, 0x7d, 0x7d, 0x7c, 0xb5, 0xde, 0x38, 0x02, 0x96, 0xfd,
+  0x32, 0x58, 0x79, 0x45, 0xfe, 0xee, 0x01, 0x49, 0x38, 0xfe, 0x7f, 0x01,
+  0xb8, 0x01, 0xc2, 0x60, 0x5e, 0x8a, 0x88, 0x60, 0x43, 0x14, 0x09, 0x96,
+  0xef, 0x37, 0xcb, 0x20, 0x58, 0x8d, 0xc6, 0xc8, 0x8b, 0x8b, 0x96, 0x96,
+  0xed, 0x35, 0xb8, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0x00, 0xab,
+  0xff, 0x6a, 0x05, 0x46, 0x04, 0xe9, 0x00, 0x0b, 0x00, 0x20, 0x00, 0x00,
+  0x29, 0x01, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
+  0x01, 0x21, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x15,
+  0x21, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x21, 0x02, 0x7d, 0xfe,
+  0x5d, 0x02, 0x08, 0x66, 0x6c, 0x28, 0x01, 0xb9, 0xfd, 0xe1, 0x65, 0x6c,
+  0x02, 0xf0, 0xfd, 0x14, 0xb5, 0x7c, 0x7d, 0x7d, 0x7c, 0xb4, 0x02, 0xed,
+  0xfd, 0x13, 0x7b, 0xab, 0x56, 0x56, 0x7a, 0x02, 0xed, 0x96, 0x96, 0x5a,
+  0x3c, 0x96, 0x96, 0x5a, 0x01, 0x69, 0x8b, 0x8b, 0xc8, 0xc6, 0x8d, 0x8b,
+  0x96, 0xc0, 0x88, 0x8a, 0x5e, 0x60, 0x00, 0x00, 0x00, 0x02, 0x00, 0xab,
+  0xff, 0x6a, 0x05, 0x46, 0x04, 0xe9, 0x00, 0x0b, 0x00, 0x20, 0x00, 0x00,
+  0x29, 0x01, 0x35, 0x21, 0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
+  0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x21, 0x35,
+  0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x02, 0x7d, 0xfe,
+  0x5d, 0x02, 0x08, 0x66, 0x6c, 0x28, 0x01, 0xb9, 0xfd, 0xe1, 0x65, 0x6c,
+  0xfe, 0x56, 0x02, 0xed, 0x7a, 0x57, 0x55, 0xab, 0x7b, 0xfd, 0x13, 0x02,
+  0xed, 0xb4, 0x7c, 0x7d, 0x7d, 0x7c, 0xb5, 0x96, 0x96, 0x5a, 0x3c, 0x96,
+  0x96, 0x5a, 0x01, 0x69, 0x96, 0x60, 0x5e, 0x8a, 0x88, 0xc0, 0x96, 0x8b,
+  0x8d, 0xc6, 0xc8, 0x8b, 0x8b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xed,
+  0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x00, 0x11, 0x00, 0x1b, 0x00, 0x00,
+  0x13, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33,
+  0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x37, 0x35, 0x37, 0x17, 0x07, 0x21,
+  0x15, 0x21, 0x17, 0x07, 0xee, 0x9a, 0x86, 0x95, 0x95, 0x85, 0x9b, 0xdd,
+  0xd8, 0xd9, 0xdc, 0xd6, 0xb0, 0x36, 0x68, 0x01, 0x3f, 0xfe, 0xc1, 0x68,
+  0x36, 0x02, 0x52, 0x02, 0x50, 0xfd, 0xc9, 0xf4, 0xd3, 0xd3, 0xf4, 0x02,
+  0x37, 0xfd, 0xb0, 0xfe, 0xd8, 0xfe, 0xd6, 0x01, 0x2a, 0xca, 0x2d, 0xc5,
+  0x3c, 0x75, 0x55, 0x74, 0x3c, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xed,
+  0x00, 0x00, 0x04, 0x58, 0x04, 0xa2, 0x10, 0x26, 0x09, 0x06, 0x00, 0x00,
+  0x10, 0x07, 0x09, 0xa1, 0x01, 0x7e, 0xff, 0x33, 0x00, 0x02, 0x00, 0xed,
+  0x00, 0x05, 0x04, 0x58, 0x04, 0xa7, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x00,
+  0x13, 0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33,
+  0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x01, 0x15, 0x33, 0x15, 0x23, 0x15,
+  0x23, 0x35, 0x23, 0x35, 0x33, 0x35, 0xee, 0x9a, 0x86, 0x95, 0x95, 0x85,
+  0x9b, 0xdd, 0xd8, 0xd9, 0xdc, 0x01, 0xe2, 0x99, 0x99, 0x5b, 0x99, 0x99,
+  0x02, 0x57, 0x02, 0x50, 0xfd, 0xc9, 0xf4, 0xd3, 0xd3, 0xf4, 0x02, 0x37,
+  0xfd, 0xb0, 0xfe, 0xd8, 0xfe, 0xd6, 0x01, 0x2a, 0x01, 0xe1, 0xab, 0x64,
+  0xab, 0xab, 0x64, 0xab, 0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
+  0x04, 0x8b, 0x00, 0x07, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0xe9, 0xfb, 0x7e, 0x04,
+  0x8b, 0xaa, 0xfc, 0xc9, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0x00, 0x00, 0x05, 0x46, 0x04, 0x8b, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x05, 0x45, 0xfb, 0x7e, 0x03, 0xe9,
+  0xfc, 0x17, 0x04, 0x8b, 0xfb, 0x75, 0xaa, 0x03, 0x37, 0xaa, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x56, 0x05, 0x46, 0x05, 0x0b, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x15, 0x21, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0xe9, 0xfb,
+  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x05, 0x0b, 0xaa, 0xfc, 0xc9, 0xaa, 0x80,
+  0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x56, 0x05, 0x46,
+  0x05, 0x0b, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x21, 0x35, 0x01, 0x15, 0x21, 0x35, 0x05, 0x45, 0xfb, 0x7e,
+  0x03, 0xe9, 0xfc, 0x17, 0x04, 0x82, 0xfb, 0x7e, 0x05, 0x0b, 0xfb, 0x75,
+  0xaa, 0x03, 0x37, 0xaa, 0xfa, 0xf5, 0xaa, 0xaa, 0x00, 0x01, 0x00, 0xc3,
+  0x00, 0x00, 0x04, 0xdb, 0x05, 0x02, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x04, 0xdb, 0x99, 0xfd, 0x1a, 0x99,
+  0x05, 0x02, 0xfa, 0xfe, 0x04, 0x58, 0xfb, 0xa8, 0x05, 0x02, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x04, 0xdb, 0x05, 0x02, 0x00, 0x07,
+  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0xc3, 0x99,
+  0x02, 0xe6, 0x99, 0x05, 0x02, 0xfb, 0xa8, 0x04, 0x58, 0xfa, 0xfe, 0x00,
+  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x19,
+  0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x05, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x03, 0x64,
+  0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0,
+  0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8,
+  0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6,
+  0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a, 0x58, 0x01, 0x9f, 0x01, 0x40,
+  0xfe, 0xc0, 0x99, 0xfe, 0xbf, 0x01, 0x41, 0x04, 0x8e, 0x27, 0x27, 0x4c,
+  0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c,
+  0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63,
+  0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63,
+  0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x84, 0xfe, 0x9b, 0xaa,
+  0xfe, 0x9b, 0x01, 0x65, 0xaa, 0x01, 0x65, 0x00, 0x00, 0x03, 0x00, 0xa8,
+  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x37,
+  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x77,
+  0x03, 0x1a, 0xfc, 0xe6, 0x01, 0xed, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45,
+  0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44,
+  0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c,
+  0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c,
+  0x5a, 0x58, 0x02, 0xd7, 0xaa, 0x02, 0x61, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
+  0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
+  0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77, 0x76,
+  0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x77,
+  0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa8,
+  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x19, 0x00, 0x33, 0x00, 0x3f,
+  0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x07, 0x17, 0x07, 0x27, 0x07,
+  0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x03, 0x64, 0xc0, 0x54, 0x53, 0x44,
+  0x45, 0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46,
+  0x44, 0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c,
+  0x2c, 0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c,
+  0x2c, 0x2c, 0x5a, 0x58, 0x02, 0xa2, 0xe4, 0xe3, 0x6c, 0xe3, 0xe3, 0x6d,
+  0xe4, 0xe3, 0x6c, 0xe3, 0xe3, 0x04, 0x8e, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
+  0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
+  0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77, 0x76,
+  0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x77,
+  0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0xfe, 0xbe, 0xfc, 0xfc, 0x78, 0xfc,
+  0xfd, 0x79, 0xfc, 0xfc, 0x78, 0xfc, 0xfd, 0x00, 0x00, 0x03, 0x00, 0xa8,
+  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x37,
+  0x00, 0x00, 0x09, 0x01, 0x17, 0x01, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0xb5,
+  0x02, 0x32, 0x6c, 0xfd, 0xce, 0x01, 0x43, 0xc0, 0x54, 0x53, 0x44, 0x45,
+  0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44,
+  0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c,
+  0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c,
+  0x2c, 0x5a, 0x58, 0x01, 0x86, 0x02, 0x70, 0x78, 0xfd, 0x90, 0x03, 0x80,
+  0x27, 0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27,
+  0x27, 0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd,
+  0x64, 0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64,
+  0x64, 0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00,
+  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x1d, 0x00, 0x37, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x12, 0x22,
+  0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27,
+  0x24, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x02, 0xa5, 0xbe, 0xbe, 0xbf, 0xc0, 0x54, 0x53, 0x44, 0x45,
+  0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44,
+  0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c,
+  0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c,
+  0x2c, 0x5a, 0x58, 0x03, 0x01, 0xfe, 0x02, 0x8b, 0x27, 0x27, 0x4c, 0x4d,
+  0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d,
+  0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77,
+  0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76,
+  0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00, 0x04, 0x00, 0xa8,
+  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x09, 0x00, 0x18, 0x00, 0x32,
+  0x00, 0x4c, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36,
+  0x34, 0x26, 0x27, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01,
+  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e,
+  0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x04, 0x48,
+  0x63, 0x63, 0x90, 0x63, 0x64, 0x47, 0x3a, 0x6a, 0x27, 0x29, 0x2a, 0xa7,
+  0x79, 0x79, 0xa2, 0xa5, 0xd8, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45,
+  0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46,
+  0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c,
+  0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a,
+  0x58, 0x03, 0x41, 0x6f, 0x50, 0x4f, 0x6d, 0x6d, 0x9e, 0x70, 0x81, 0x31,
+  0x2e, 0x2d, 0x72, 0x42, 0x84, 0xb7, 0xb4, 0x87, 0x86, 0xba, 0xcc, 0x27,
+  0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27,
+  0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64,
+  0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64,
+  0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x11,
+  0x00, 0x2b, 0x00, 0x45, 0x00, 0x00, 0x01, 0x0d, 0x01, 0x07, 0x25, 0x11,
+  0x23, 0x11, 0x05, 0x27, 0x2d, 0x01, 0x37, 0x05, 0x11, 0x33, 0x11, 0x25,
+  0x02, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27,
+  0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x04, 0x72, 0xfe, 0xdd, 0x01, 0x23, 0x2f, 0xfe,
+  0xef, 0x5c, 0xfe, 0xf0, 0x2f, 0x01, 0x23, 0xfe, 0xdd, 0x2f, 0x01, 0x10,
+  0x5c, 0x01, 0x11, 0xdf, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45, 0x45,
+  0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46, 0x44,
+  0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c, 0x59,
+  0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a, 0x58,
+  0x03, 0x31, 0xaf, 0xb0, 0x58, 0xb7, 0xfe, 0xad, 0x01, 0x53, 0xb7, 0x58,
+  0xb0, 0xaf, 0x59, 0xb7, 0x01, 0x53, 0xfe, 0xad, 0xb7, 0x01, 0x04, 0x27,
+  0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27,
+  0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64,
+  0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64,
+  0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x21, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x15, 0x21, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01,
+  0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0xe4, 0x02, 0x40,
+  0xfd, 0xc0, 0x02, 0x40, 0xfd, 0xc0, 0x01, 0x80, 0xc0, 0x54, 0x53, 0x44,
+  0x45, 0x45, 0x45, 0x45, 0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46,
+  0x44, 0x44, 0x46, 0x44, 0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c,
+  0x2c, 0x2c, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c,
+  0x2c, 0x2c, 0x5a, 0x58, 0x03, 0x6a, 0x88, 0xc0, 0x88, 0x02, 0xf4, 0x27,
+  0x27, 0x4c, 0x4d, 0xb8, 0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27,
+  0x27, 0x4c, 0x4d, 0xb8, 0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64,
+  0x62, 0x63, 0x77, 0x76, 0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64,
+  0x62, 0x63, 0x76, 0x77, 0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x19,
+  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x32, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x21,
+  0x15, 0x21, 0x03, 0x64, 0xc0, 0x54, 0x53, 0x44, 0x45, 0x45, 0x45, 0x45,
+  0x44, 0x53, 0x54, 0xc0, 0x54, 0x53, 0x44, 0x46, 0x44, 0x44, 0x46, 0x44,
+  0x53, 0xfe, 0xd0, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x2c, 0x2c, 0x2c, 0x59,
+  0x58, 0xd7, 0xf8, 0xd6, 0x58, 0x5a, 0x2c, 0x2c, 0x2c, 0x2c, 0x5a, 0x58,
+  0x32, 0x02, 0x41, 0xfd, 0xbf, 0x04, 0x8e, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
+  0x6d, 0x6a, 0xb8, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0xb8,
+  0x6a, 0x6d, 0xb8, 0x4d, 0x4c, 0x27, 0xbd, 0x64, 0x62, 0x63, 0x77, 0x76,
+  0x8c, 0x89, 0x77, 0x76, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x77,
+  0x89, 0x8c, 0x76, 0x77, 0x63, 0x62, 0xfe, 0x17, 0xaa, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21,
+  0x11, 0x21, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x01, 0x2f, 0x03, 0xaa, 0xfb, 0xcf, 0x04, 0xb8, 0xfb, 0x48,
+  0x02, 0xa9, 0x01, 0x40, 0xfe, 0xc0, 0x99, 0xfe, 0xbf, 0x01, 0x41, 0x04,
+  0x89, 0xfb, 0xf0, 0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x04, 0x59, 0xfe, 0x9b,
+  0xaa, 0xfe, 0x9b, 0x01, 0x65, 0xaa, 0x01, 0x65, 0x00, 0x03, 0x00, 0xa8,
+  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x03, 0x11, 0x21, 0x11, 0x25, 0x21,
+  0x11, 0x21, 0x01, 0x77, 0x03, 0x1a, 0xfc, 0xe6, 0x48, 0x03, 0xaa, 0xfb,
+  0xcf, 0x04, 0xb8, 0xfb, 0x48, 0x02, 0xd7, 0xaa, 0x02, 0x5c, 0xfb, 0xf0,
+  0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa8,
+  0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13,
+  0x00, 0x00, 0x09, 0x02, 0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x37, 0x09,
+  0x01, 0x25, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x04, 0xb7, 0xfe,
+  0xb9, 0x01, 0x47, 0x6d, 0xfe, 0xba, 0xfe, 0xba, 0x6c, 0x01, 0x46, 0xfe,
+  0xba, 0x6c, 0x01, 0x46, 0x01, 0x46, 0xfc, 0xe5, 0x03, 0xaa, 0xfb, 0xcf,
+  0x04, 0xb8, 0xfb, 0x48, 0x03, 0xec, 0xfe, 0x96, 0xfe, 0x96, 0x78, 0x01,
+  0x6a, 0xfe, 0x95, 0x79, 0x01, 0x6a, 0x01, 0x6a, 0x79, 0xfe, 0x95, 0x01,
+  0x6b, 0x24, 0xfb, 0xf0, 0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x01, 0x11,
+  0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x02, 0xa5, 0xbe, 0xbe, 0xfe, 0x8a,
+  0x03, 0xaa, 0xfb, 0xcf, 0x04, 0xb8, 0xfb, 0x48, 0x03, 0x01, 0xfe, 0x02,
+  0x86, 0xfb, 0xf0, 0x04, 0x10, 0x9b, 0xfa, 0xbf, 0x00, 0x01, 0x00, 0x9d,
+  0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07, 0x00, 0x00, 0x33, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x9e, 0x72, 0x04, 0x99, 0xfb, 0x67,
+  0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
+  0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x05, 0xa9, 0x72, 0xfb, 0x67, 0x04,
+  0x99, 0x72, 0x02, 0x90, 0x7f, 0x02, 0x8b, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15,
+  0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x05, 0xa8, 0xfd, 0xb4, 0x73, 0xfd,
+  0xb5, 0x05, 0x9a, 0x7f, 0xfa, 0xe5, 0x05, 0x1b, 0x7f, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07,
+  0x00, 0x00, 0x33, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x9e, 0x02,
+  0x4b, 0x73, 0x02, 0x4c, 0x7f, 0x05, 0x1b, 0xfa, 0xe5, 0x7f, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x03, 0x23, 0x05, 0x9a, 0x00, 0x07,
+  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x9e, 0x72,
+  0x02, 0x13, 0xfd, 0xed, 0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70, 0x00,
+  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x03, 0x23, 0x05, 0x9a, 0x00, 0x0b,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x01, 0x10, 0x72, 0x72, 0x02, 0x13, 0xfd, 0xed, 0x02, 0x13,
+  0xfd, 0xed, 0x05, 0x9a, 0xfe, 0x24, 0x7f, 0xe4, 0x7f, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x0b,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x15, 0x21, 0x01, 0x10, 0x72, 0x72, 0x04, 0x99, 0xfb, 0x67, 0x04, 0x99,
+  0xfb, 0x67, 0x05, 0x9a, 0xfe, 0x24, 0x7f, 0xe4, 0x7f, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x00, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x21, 0x23, 0x11, 0x33, 0x01, 0xdd, 0x72, 0x03, 0x5a, 0xfc, 0xa6, 0xfe,
+  0xc1, 0x72, 0x72, 0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70, 0x05, 0x9a,
+  0x00, 0x03, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9, 0x05, 0x9a, 0x00, 0x03,
+  0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x01, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x23, 0x11, 0x33, 0x01, 0x10,
+  0x72, 0x72, 0x02, 0x0c, 0x73, 0x02, 0x1a, 0xfd, 0xe6, 0xfe, 0xc0, 0x72,
+  0x72, 0x05, 0x9a, 0xfa, 0x66, 0x05, 0x9a, 0xfd, 0x75, 0x7f, 0xfd, 0x70,
+  0x05, 0x9a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d, 0x00, 0x00, 0x05, 0xa9,
+  0x05, 0x9a, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x21, 0x23, 0x11, 0x33,
+  0x01, 0x23, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x01, 0x10, 0x72, 0x72, 0x01, 0x3f, 0x72, 0x72, 0x03, 0x5a, 0xfc, 0xa6,
+  0x03, 0x5a, 0xfc, 0xa6, 0x05, 0x9a, 0xfa, 0x66, 0x05, 0x9a, 0xfe, 0x24,
+  0x7f, 0xe4, 0x7f, 0x00, 0x00, 0x01, 0x00, 0x9d, 0xff, 0xaf, 0x05, 0xa9,
+  0x05, 0xeb, 0x00, 0x0f, 0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x21, 0x01,
+  0x17, 0x01, 0x21, 0x15, 0x21, 0x01, 0x27, 0x01, 0x21, 0x11, 0x9e, 0x72,
+  0x01, 0xef, 0x01, 0x32, 0x67, 0xfe, 0xe5, 0x02, 0x2c, 0xfd, 0x9f, 0xfe,
+  0xcd, 0x68, 0x01, 0x1d, 0xfe, 0x46, 0x05, 0x9a, 0xfd, 0x75, 0x02, 0xdc,
+  0x35, 0xfd, 0x59, 0x7f, 0xfd, 0x1f, 0x36, 0x02, 0xab, 0xfd, 0x70, 0x00,
+  0x00, 0x02, 0x00, 0x9d, 0xff, 0xaf, 0x05, 0xa9, 0x05, 0xeb, 0x00, 0x13,
+  0x00, 0x17, 0x00, 0x00, 0x01, 0x17, 0x03, 0x21, 0x15, 0x21, 0x07, 0x21,
+  0x15, 0x21, 0x03, 0x27, 0x13, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21,
+  0x03, 0x37, 0x21, 0x15, 0x04, 0x31, 0x67, 0xd2, 0x01, 0xe3, 0xfd, 0xe8,
+  0x5f, 0x02, 0x77, 0xfd, 0x54, 0xe8, 0x68, 0xd2, 0xfe, 0x91, 0x72, 0x72,
+  0x02, 0x38, 0x94, 0x5f, 0xfd, 0xfd, 0x05, 0xeb, 0x35, 0xfe, 0x08, 0x7f,
+  0xe4, 0x7f, 0xfd, 0xd3, 0x36, 0x01, 0xf7, 0xfe, 0x24, 0x05, 0x9a, 0xfe,
+  0x24, 0xfe, 0x9d, 0xe4, 0xe4, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d,
+  0xff, 0xaf, 0x05, 0xa9, 0x05, 0xeb, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00,
+  0x01, 0x17, 0x01, 0x21, 0x15, 0x21, 0x01, 0x27, 0x01, 0x21, 0x11, 0x23,
+  0x11, 0x33, 0x11, 0x21, 0x01, 0x23, 0x11, 0x33, 0x04, 0xf5, 0x67, 0xfe,
+  0xe5, 0x01, 0x68, 0xfe, 0x63, 0xfe, 0xcd, 0x67, 0x01, 0x1d, 0xfe, 0xc0,
+  0x72, 0x72, 0x01, 0x75, 0xfd, 0x4c, 0x72, 0x72, 0x05, 0xeb, 0x35, 0xfd,
+  0x59, 0x7f, 0xfd, 0x1f, 0x36, 0x02, 0xab, 0xfd, 0x70, 0x05, 0x9a, 0xfd,
+  0x75, 0xfc, 0xf1, 0x05, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x9d,
+  0xff, 0xaf, 0x05, 0xa9, 0x05, 0xeb, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x21, 0x13, 0x17, 0x03, 0x21,
+  0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27, 0x13, 0x23, 0x01, 0x23,
+  0x11, 0x33, 0x01, 0x37, 0x21, 0x15, 0x02, 0x4f, 0x72, 0x72, 0x01, 0xc2,
+  0xe9, 0x67, 0xd2, 0x01, 0x1a, 0xfe, 0xb1, 0x5f, 0x01, 0xae, 0xfe, 0x1d,
+  0xe8, 0x68, 0xd2, 0xf9, 0xfe, 0xc1, 0x72, 0x72, 0x02, 0x6d, 0x5f, 0xfe,
+  0x73, 0x05, 0x9a, 0xfe, 0x24, 0x02, 0x2d, 0x35, 0xfe, 0x08, 0x7f, 0xe4,
+  0x7f, 0xfd, 0xd3, 0x36, 0x01, 0xf7, 0xfe, 0x24, 0x05, 0x9a, 0xfc, 0xc1,
+  0xe4, 0xe4, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xa7, 0x05, 0x37,
+  0x05, 0x5d, 0x00, 0x2a, 0x00, 0x00, 0x13, 0x35, 0x24, 0x25, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x27, 0x36, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x05, 0x04, 0x17, 0x16, 0x15, 0x14, 0x06, 0x23,
+  0x22, 0x27, 0x37, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
+  0x24, 0xc3, 0x01, 0x72, 0x01, 0x20, 0xb4, 0x5b, 0x37, 0x45, 0x38, 0x48,
+  0x32, 0x67, 0x51, 0x90, 0x7a, 0x9f, 0x85, 0xcd, 0xfe, 0xaf, 0x01, 0x51,
+  0xcd, 0x85, 0x9f, 0x7a, 0x90, 0x51, 0x67, 0x32, 0x48, 0x38, 0x45, 0x37,
+  0x5b, 0xb4, 0xfe, 0xe0, 0x02, 0x2e, 0xa8, 0x28, 0x59, 0x37, 0x4f, 0x30,
+  0x3c, 0x30, 0x3a, 0x3e, 0x7e, 0x6a, 0xa0, 0x79, 0x9f, 0x5b, 0x8c, 0x3c,
+  0x3c, 0x8c, 0x5b, 0x9f, 0x79, 0xa0, 0x6a, 0x7e, 0x3e, 0x3a, 0x30, 0x3c,
+  0x30, 0x4f, 0x37, 0x59, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xa7, 0x05, 0x37,
+  0x05, 0x5d, 0x00, 0x2a, 0x00, 0x00, 0x01, 0x04, 0x05, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x25, 0x24, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32,
+  0x17, 0x07, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x04,
+  0x05, 0x05, 0x37, 0xfe, 0x8e, 0xfe, 0xe0, 0xb4, 0x5b, 0x37, 0x45, 0x38,
+  0x48, 0x32, 0x67, 0x51, 0x90, 0x7a, 0x9f, 0x85, 0xcd, 0x01, 0x51, 0xfe,
+  0xaf, 0xcd, 0x85, 0x9f, 0x7a, 0x90, 0x51, 0x67, 0x32, 0x48, 0x38, 0x45,
+  0x37, 0x5b, 0xb4, 0x01, 0x20, 0x01, 0x72, 0x02, 0x2e, 0x28, 0x59, 0x37,
+  0x4f, 0x30, 0x3c, 0x30, 0x3a, 0x3e, 0x7e, 0x6a, 0xa0, 0x79, 0x9f, 0x5b,
+  0x8c, 0x3c, 0x3c, 0x8c, 0x5b, 0x9f, 0x79, 0xa0, 0x6a, 0x7e, 0x3e, 0x3a,
+  0x30, 0x3c, 0x30, 0x4f, 0x37, 0x59, 0x28, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x1e, 0x05, 0x46, 0x04, 0xe6, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00,
+  0x01, 0x11, 0x09, 0x02, 0x35, 0x01, 0x04, 0xac, 0xfc, 0xf8, 0x03, 0xa1,
+  0xfb, 0x7e, 0x04, 0x82, 0x01, 0x20, 0x02, 0xc4, 0xfe, 0x9e, 0xfd, 0x9c,
+  0x02, 0x11, 0xa6, 0x02, 0x11, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x1e, 0x05, 0x46, 0x04, 0xe6, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00,
+  0x09, 0x02, 0x03, 0x11, 0x01, 0x15, 0x01, 0x5c, 0x03, 0x08, 0xfc, 0xf8,
+  0x99, 0x04, 0x82, 0x01, 0x20, 0x01, 0x62, 0x01, 0x62, 0xfc, 0x3a, 0x04,
+  0xc8, 0xfd, 0xef, 0xa6, 0x00, 0x03, 0x00, 0xc3, 0xff, 0x9e, 0x05, 0x46,
+  0x05, 0x64, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x00, 0x17, 0x35,
+  0x21, 0x15, 0x03, 0x11, 0x09, 0x02, 0x35, 0x01, 0xc3, 0x04, 0x82, 0x99,
+  0xfc, 0xf8, 0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82, 0x62, 0xaa, 0xaa, 0x02,
+  0x00, 0x02, 0xc4, 0xfe, 0x9e, 0xfd, 0x9c, 0x02, 0x11, 0xa6, 0x02, 0x11,
+  0x00, 0x03, 0x00, 0xc3, 0xff, 0x9e, 0x05, 0x46, 0x05, 0x64, 0x00, 0x03,
+  0x00, 0x06, 0x00, 0x0a, 0x00, 0x00, 0x17, 0x35, 0x21, 0x15, 0x09, 0x02,
+  0x03, 0x11, 0x01, 0x15, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0x08, 0xfc,
+  0xf8, 0x99, 0x04, 0x82, 0x62, 0xaa, 0xaa, 0x02, 0x00, 0x01, 0x62, 0x01,
+  0x62, 0xfc, 0x3a, 0x04, 0xc8, 0xfd, 0xef, 0xa6, 0x00, 0x02, 0x00, 0x6c,
+  0x01, 0x67, 0x06, 0xc7, 0x03, 0xa2, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x00,
+  0x01, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x27, 0x26, 0x27, 0x21, 0x06,
+  0x07, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x17, 0x16, 0x17, 0x21, 0x36,
+  0x04, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x05, 0x0f, 0x4b, 0xd3,
+  0x99, 0x96, 0xda, 0x49, 0x2e, 0x11, 0xfd, 0x96, 0x12, 0x2e, 0x4c, 0xd9,
+  0x92, 0x95, 0xd4, 0x4e, 0x2f, 0x11, 0x02, 0x6a, 0x12, 0xfc, 0xc1, 0x67,
+  0x47, 0x47, 0x68, 0x47, 0x03, 0x4f, 0x53, 0xa8, 0xef, 0xa4, 0x51, 0x33,
+  0x43, 0x42, 0x33, 0x52, 0xa2, 0xf2, 0xa7, 0x55, 0x34, 0x43, 0x44, 0x0e,
+  0x50, 0x72, 0x4f, 0x4f, 0x71, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6c,
+  0x01, 0x67, 0x06, 0xc7, 0x03, 0xa2, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x00,
+  0x01, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x17, 0x16, 0x17, 0x21, 0x36,
+  0x37, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x27, 0x26, 0x27, 0x21, 0x06,
+  0x24, 0x32, 0x36, 0x34, 0x26, 0x22, 0x06, 0x14, 0x02, 0x24, 0x4b, 0xd3,
+  0x99, 0x96, 0xda, 0x49, 0x2e, 0x11, 0x02, 0x6a, 0x12, 0x2e, 0x4c, 0xd9,
+  0x92, 0x95, 0xd4, 0x4e, 0x2f, 0x11, 0xfd, 0x96, 0x12, 0x03, 0x3f, 0x67,
+  0x47, 0x47, 0x67, 0x48, 0x01, 0xba, 0x53, 0xa8, 0xef, 0xa4, 0x51, 0x33,
+  0x43, 0x42, 0x33, 0x52, 0xa2, 0xf2, 0xa7, 0x55, 0x34, 0x43, 0x44, 0x0e,
+  0x50, 0x72, 0x4f, 0x4f, 0x71, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x58,
+  0x01, 0x67, 0x05, 0xb1, 0x03, 0xa2, 0x00, 0x0d, 0x00, 0x15, 0x00, 0x00,
+  0x13, 0x37, 0x21, 0x36, 0x37, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x24, 0x26, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x58, 0x01,
+  0x03, 0x60, 0x11, 0x2c, 0x52, 0xd4, 0x94, 0x92, 0xd9, 0x4b, 0x2f, 0x11,
+  0x01, 0x71, 0x47, 0x68, 0x48, 0x48, 0x68, 0x47, 0x02, 0x2e, 0xa8, 0x44,
+  0x2f, 0x59, 0xa7, 0xf2, 0xa2, 0x52, 0x33, 0x42, 0x8e, 0x50, 0x51, 0x71,
+  0x4f, 0x4f, 0x00, 0x00, 0x00, 0x04, 0x00, 0x6c, 0xff, 0xa0, 0x05, 0x9c,
+  0x05, 0x64, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
+  0x01, 0x33, 0x11, 0x23, 0x05, 0x21, 0x15, 0x21, 0x03, 0x23, 0x11, 0x33,
+  0x25, 0x21, 0x35, 0x21, 0x02, 0xb9, 0x97, 0x97, 0x01, 0x0a, 0x01, 0xd9,
+  0xfe, 0x27, 0x73, 0x97, 0x97, 0xfe, 0xf5, 0xfe, 0x28, 0x01, 0xd8, 0x05,
+  0x64, 0xfd, 0xf3, 0x80, 0xaa, 0xfd, 0x73, 0x02, 0x0d, 0x80, 0xaa, 0x00,
+  0x00, 0x01, 0x00, 0xd6, 0x00, 0x00, 0x02, 0xea, 0x05, 0x9b, 0x00, 0x07,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x23, 0x35, 0x21, 0x15, 0x23, 0x02, 0x19,
+  0x72, 0xd1, 0x02, 0x13, 0xd0, 0x05, 0x1c, 0x7f, 0x7f, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x92, 0x05, 0xec, 0x00, 0x03,
+  0x00, 0x0a, 0x00, 0x00, 0x33, 0x35, 0x21, 0x15, 0x01, 0x33, 0x09, 0x01,
+  0x33, 0x01, 0x23, 0xb4, 0x03, 0xdd, 0xfc, 0x5c, 0xb0, 0x01, 0x06, 0x01,
+  0x05, 0xb0, 0xfe, 0xbb, 0xe1, 0xaa, 0xaa, 0x05, 0xec, 0xfc, 0x54, 0x03,
+  0xac, 0xfb, 0x5e, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x92,
+  0x05, 0xec, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
+  0x13, 0x01, 0x33, 0x01, 0x23, 0x09, 0x01, 0xb4, 0x03, 0xdd, 0xfc, 0x23,
+  0x39, 0x01, 0x45, 0xe1, 0x01, 0x45, 0xb0, 0xfe, 0xfb, 0xfe, 0xfa, 0x05,
+  0xec, 0xaa, 0xfa, 0xbe, 0x04, 0xa2, 0xfb, 0x5e, 0x03, 0xac, 0xfc, 0x54,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x92, 0x05, 0xec, 0x00, 0x03,
+  0x00, 0x0a, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x17, 0x33, 0x09, 0x01,
+  0x33, 0x01, 0x23, 0xb4, 0x03, 0xdd, 0xfc, 0x23, 0x39, 0xb0, 0x01, 0x06,
+  0x01, 0x05, 0xb0, 0xfe, 0xbb, 0xe1, 0x05, 0xec, 0xaa, 0xa0, 0xfc, 0x54,
+  0x03, 0xac, 0xfb, 0x5e, 0x00, 0x02, 0x00, 0xfe, 0x00, 0x00, 0x05, 0x0a,
+  0x04, 0x7e, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00, 0x29, 0x01, 0x11, 0x33,
+  0x11, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x17, 0x33, 0x01, 0x11, 0x21,
+  0x26, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x05, 0x0a, 0xfb, 0xf5, 0x99, 0x51,
+  0x4d, 0x95, 0xd6, 0x3f, 0x21, 0x10, 0xf9, 0xfc, 0x8e, 0x02, 0x0b, 0x0e,
+  0x18, 0x37, 0xba, 0x80, 0x39, 0x04, 0x7e, 0xfe, 0xeb, 0x12, 0x25, 0x46,
+  0xee, 0xa4, 0x56, 0x5a, 0x02, 0x44, 0xfd, 0xbc, 0x41, 0x3f, 0x8f, 0xce,
+  0x3d, 0x1b, 0x00, 0x00, 0x00, 0x02, 0x00, 0xfe, 0x00, 0x00, 0x05, 0x0a,
+  0x04, 0x7e, 0x00, 0x02, 0x00, 0x07, 0x00, 0x00, 0x09, 0x01, 0x21, 0x05,
+  0x35, 0x01, 0x33, 0x11, 0x04, 0x71, 0xfd, 0x27, 0x02, 0xd9, 0xfc, 0x8e,
+  0x03, 0x72, 0x99, 0x03, 0xd4, 0xfc, 0xd6, 0xaa, 0xaa, 0x03, 0xd4, 0xfb,
+  0x82, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xfa, 0xfe, 0x77, 0x05, 0xee,
+  0x05, 0xc1, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23,
+  0x01, 0x03, 0x58, 0x02, 0x95, 0xb6, 0xfd, 0xbd, 0xfd, 0xbd, 0xb6, 0x02,
+  0x93, 0x05, 0xc1, 0xf8, 0xb6, 0x06, 0x77, 0xf9, 0x89, 0x07, 0x4a, 0x00,
+  0x00, 0x01, 0xff, 0xfa, 0xfe, 0x77, 0x05, 0xee, 0x05, 0xc1, 0x00, 0x06,
+  0x00, 0x00, 0x09, 0x01, 0x33, 0x09, 0x01, 0x33, 0x01, 0x02, 0x90, 0xfd,
+  0x6b, 0xb6, 0x02, 0x43, 0x02, 0x43, 0xb6, 0xfd, 0x6d, 0xfe, 0x77, 0x07,
+  0x4a, 0xf9, 0x89, 0x06, 0x77, 0xf8, 0xb6, 0x00, 0x00, 0x01, 0x00, 0x7e,
+  0xfe, 0x77, 0x05, 0x6a, 0x05, 0xc1, 0x00, 0x10, 0x00, 0x00, 0x01, 0x22,
+  0x04, 0x15, 0x11, 0x23, 0x11, 0x10, 0x00, 0x20, 0x00, 0x19, 0x01, 0x23,
+  0x11, 0x34, 0x24, 0x02, 0xf4, 0xc5, 0xfe, 0xea, 0x9b, 0x01, 0x90, 0x01,
+  0xcc, 0x01, 0x90, 0x9b, 0xfe, 0xec, 0x05, 0x1d, 0xe3, 0xfc, 0xfb, 0x39,
+  0x04, 0xe0, 0x01, 0x42, 0x01, 0x28, 0xfe, 0xd8, 0xfe, 0xbe, 0xfb, 0x20,
+  0x04, 0xc7, 0xfa, 0xe5, 0x00, 0x01, 0x00, 0x7e, 0xfe, 0x77, 0x05, 0x6a,
+  0x05, 0xc1, 0x00, 0x10, 0x00, 0x00, 0x05, 0x32, 0x24, 0x35, 0x11, 0x33,
+  0x11, 0x10, 0x00, 0x20, 0x00, 0x19, 0x01, 0x33, 0x11, 0x14, 0x04, 0x02,
+  0xf4, 0xc5, 0x01, 0x16, 0x9b, 0xfe, 0x70, 0xfe, 0x34, 0xfe, 0x70, 0x9b,
+  0x01, 0x14, 0xe5, 0xe3, 0xfc, 0x04, 0xc7, 0xfb, 0x20, 0xfe, 0xbe, 0xfe,
+  0xd8, 0x01, 0x28, 0x01, 0x42, 0x04, 0xe0, 0xfb, 0x39, 0xfa, 0xe5, 0x00,
+  0xff, 0xff, 0x00, 0x05, 0xfe, 0x23, 0x03, 0x8a, 0x06, 0x75, 0x12, 0x06,
+  0x0a, 0xf3, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc5, 0x02, 0x48, 0x01, 0x83,
+  0x03, 0x46, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0xc5, 0xbe,
+  0xbe, 0x03, 0x46, 0xfe, 0x00, 0x01, 0x00, 0xe0, 0x01, 0x31, 0x03, 0xa2,
+  0x04, 0x19, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x07,
+  0x13, 0x27, 0x07, 0x13, 0xe0, 0x01, 0x0d, 0x54, 0x55, 0x01, 0x0c, 0xda,
+  0x54, 0xdb, 0xdb, 0x54, 0x02, 0xfd, 0x01, 0x1c, 0xfe, 0xe4, 0xb0, 0xfe,
+  0xe4, 0xb0, 0xb0, 0x01, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0x00, 0x1e, 0x05, 0x46, 0x04, 0xe7, 0x00, 0x03, 0x00, 0x07, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x03, 0x21,
+  0x35, 0x21, 0x01, 0x37, 0x09, 0x01, 0x17, 0x01, 0x21, 0x15, 0x21, 0x01,
+  0x07, 0x09, 0x01, 0x27, 0x02, 0x96, 0xdd, 0xdd, 0xdd, 0xdd, 0x4a, 0xfe,
+  0x77, 0x01, 0x89, 0xfe, 0xb0, 0x6c, 0x01, 0x9c, 0x01, 0x9c, 0x6c, 0xfe,
+  0xb1, 0x01, 0x88, 0xfe, 0x78, 0x01, 0x4f, 0x6c, 0xfe, 0x64, 0xfe, 0x64,
+  0x6c, 0x01, 0x13, 0xf5, 0x04, 0xc9, 0xf6, 0xfe, 0x3c, 0xaa, 0x01, 0x75,
+  0x78, 0xfe, 0x36, 0x01, 0xca, 0x78, 0xfe, 0x8b, 0xaa, 0xfe, 0x8b, 0x78,
+  0x01, 0xca, 0xfe, 0x36, 0x78, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x05, 0x00, 0x08, 0x00, 0x0b,
+  0x00, 0x00, 0x17, 0x11, 0x09, 0x01, 0x11, 0x01, 0x27, 0x01, 0x11, 0x09,
+  0x01, 0x11, 0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0x8c, 0xfe, 0x4e,
+  0x02, 0xc9, 0x01, 0xb2, 0x3e, 0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50, 0xfa,
+  0x80, 0x02, 0x4e, 0x71, 0x01, 0x5e, 0xfd, 0x44, 0x01, 0x5e, 0xfe, 0xa2,
+  0x02, 0xc6, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70,
+  0x05, 0x42, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x15, 0x09, 0x01,
+  0x11, 0x09, 0x01, 0x15, 0x01, 0x21, 0x01, 0x11, 0x06, 0x70, 0xfd, 0x2a,
+  0xfd, 0x29, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0xb5, 0xfe, 0xe9, 0xfe, 0x4e,
+  0xa2, 0xe0, 0x02, 0x4e, 0xfd, 0xb2, 0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50,
+  0xdd, 0xfe, 0x1c, 0x01, 0x5e, 0xfd, 0x44, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x00,
+  0x13, 0x35, 0x09, 0x01, 0x11, 0x09, 0x01, 0x35, 0x01, 0x21, 0x01, 0x11,
+  0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0xfd, 0x29, 0x02, 0x4b, 0x01,
+  0x17, 0x01, 0xb2, 0x04, 0x62, 0xe0, 0xfd, 0xb2, 0x02, 0x4e, 0xfa, 0x80,
+  0x02, 0x50, 0xfd, 0xb0, 0xdd, 0x01, 0xe4, 0xfe, 0xa2, 0x02, 0xbc, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x07,
+  0x00, 0x00, 0x17, 0x35, 0x09, 0x01, 0x35, 0x01, 0x15, 0x01, 0xc3, 0x02,
+  0x4b, 0xfd, 0xb5, 0x05, 0xad, 0xfd, 0x2a, 0x3e, 0xe0, 0x01, 0xe1, 0x01,
+  0xe2, 0xdd, 0xfb, 0x5d, 0xdd, 0x02, 0x50, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x07, 0x00, 0x00, 0x05, 0x09,
+  0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x06, 0x70, 0xfd, 0x2a, 0xfd, 0x29,
+  0x05, 0xad, 0xfd, 0xb5, 0x02, 0x4b, 0x3e, 0x02, 0x50, 0xfd, 0xb0, 0xdd,
+  0x04, 0xa3, 0xdd, 0xfe, 0x1e, 0xfe, 0x1f, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x01, 0x60, 0x05, 0x46, 0x03, 0xf4, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x00,
+  0x13, 0x1e, 0x01, 0x33, 0x32, 0x3f, 0x02, 0x36, 0x33, 0x32, 0x16, 0x17,
+  0x15, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x01, 0x15, 0x21, 0x35, 0xc3, 0x5d, 0x98, 0x4e, 0x54, 0x8c,
+  0x13, 0x0e, 0x84, 0x63, 0x58, 0xa1, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b,
+  0x0e, 0x05, 0x0f, 0x84, 0x63, 0x57, 0xa1, 0x5f, 0x04, 0x82, 0xfb, 0x7e,
+  0x03, 0xf4, 0x55, 0x4b, 0x3d, 0x09, 0x06, 0x3b, 0x45, 0x4e, 0xb2, 0x53,
+  0x4c, 0x3d, 0x06, 0x02, 0x07, 0x3b, 0x45, 0x4f, 0xfe, 0xc8, 0xaa, 0xaa,
+  0x00, 0x01, 0x00, 0x59, 0x00, 0x00, 0x04, 0xed, 0x04, 0xa2, 0x00, 0x0a,
+  0x00, 0x00, 0x13, 0x33, 0x00, 0x13, 0x12, 0x01, 0x33, 0x00, 0x03, 0x23,
+  0x02, 0x59, 0xc2, 0x01, 0x4f, 0x39, 0x42, 0x01, 0x46, 0xc2, 0xfe, 0x65,
+  0x5b, 0xa8, 0x5b, 0x04, 0xa2, 0xfe, 0x90, 0xfe, 0x25, 0x01, 0xda, 0x01,
+  0x71, 0xfe, 0x81, 0xfc, 0xdd, 0x03, 0x23, 0x00, 0x00, 0x01, 0x00, 0x59,
+  0x00, 0x00, 0x04, 0xed, 0x04, 0xa2, 0x00, 0x0a, 0x00, 0x00, 0x33, 0x00,
+  0x13, 0x33, 0x12, 0x01, 0x23, 0x00, 0x03, 0x02, 0x01, 0x59, 0x01, 0x9b,
+  0x5b, 0xa8, 0x5b, 0x01, 0x9b, 0xc2, 0xfe, 0xba, 0x42, 0x39, 0xfe, 0xb1,
+  0x01, 0x7f, 0x03, 0x23, 0xfc, 0xdd, 0xfe, 0x81, 0x01, 0x71, 0x01, 0xda,
+  0xfe, 0x25, 0xfe, 0x90, 0x00, 0x02, 0x00, 0xab, 0xff, 0xfa, 0x05, 0x46,
+  0x05, 0x0a, 0x00, 0x13, 0x00, 0x29, 0x00, 0x00, 0x01, 0x21, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x35,
+  0x34, 0x36, 0x33, 0x21, 0x11, 0x21, 0x22, 0x27, 0x26, 0x11, 0x10, 0x37,
+  0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x21, 0x05, 0x45, 0xfd, 0xad, 0x34, 0x24, 0x24, 0x48, 0x34, 0x02,
+  0x53, 0xfd, 0xac, 0x73, 0x51, 0x50, 0xa0, 0x74, 0x02, 0x54, 0xfd, 0xad,
+  0xf4, 0xa9, 0xaa, 0xaa, 0xa7, 0xf4, 0x02, 0x55, 0xfd, 0xac, 0xb4, 0x7c,
+  0x7d, 0x7d, 0x7c, 0xb5, 0x02, 0x53, 0x03, 0x0c, 0x28, 0x29, 0x39, 0x3a,
+  0x50, 0xaa, 0x5a, 0x58, 0x82, 0x80, 0xb4, 0xfc, 0x44, 0xbd, 0xbe, 0x01,
+  0x0d, 0x01, 0x0c, 0xbf, 0xbd, 0xaa, 0x8b, 0x8d, 0xc6, 0xc8, 0x8b, 0x8b,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0xfa, 0x05, 0x5e, 0x05, 0x0a, 0x00, 0x13,
+  0x00, 0x29, 0x00, 0x00, 0x13, 0x35, 0x21, 0x32, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x21, 0x35, 0x21, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23,
+  0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x21,
+  0x35, 0x21, 0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0xc3, 0x02,
+  0x54, 0x74, 0xa0, 0x50, 0x51, 0x73, 0xfd, 0xac, 0x02, 0x53, 0x34, 0x48,
+  0x24, 0x24, 0x34, 0xfd, 0xad, 0x02, 0x53, 0xb5, 0x7c, 0x7d, 0x7d, 0x7c,
+  0xb4, 0xfd, 0xac, 0x02, 0x55, 0xf4, 0xa7, 0xaa, 0xaa, 0xa9, 0xf4, 0x03,
+  0x0c, 0xaa, 0xb4, 0x80, 0x82, 0x58, 0x5a, 0xaa, 0x50, 0x3a, 0x39, 0x29,
+  0x28, 0xfc, 0xee, 0xaa, 0x8b, 0x8b, 0xc8, 0xc6, 0x8d, 0x8b, 0xaa, 0xbd,
+  0xbf, 0xfe, 0xf4, 0xfe, 0xf3, 0xbe, 0xbd, 0x00, 0x00, 0x02, 0x00, 0xbd,
+  0x00, 0x00, 0x05, 0x4c, 0x05, 0x4e, 0x00, 0x11, 0x00, 0x24, 0x00, 0x00,
+  0x21, 0x11, 0x34, 0x26, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x16, 0x15, 0x11, 0x21, 0x11, 0x10, 0x00, 0x20, 0x17,
+  0x16, 0x19, 0x01, 0x23, 0x11, 0x34, 0x27, 0x26, 0x20, 0x07, 0x06, 0x15,
+  0x11, 0x03, 0x80, 0x48, 0x68, 0x48, 0x99, 0x51, 0x4f, 0x75, 0x73, 0xa2,
+  0xfc, 0xa4, 0x01, 0x56, 0x01, 0xe2, 0xad, 0xa9, 0x99, 0x7c, 0x7e, 0xfe,
+  0x98, 0x7c, 0x7e, 0x02, 0xc6, 0x3a, 0x50, 0x50, 0x3a, 0xfd, 0x3a, 0x02,
+  0xc8, 0x80, 0x5a, 0x58, 0xb2, 0x80, 0xfd, 0x38, 0x02, 0xc6, 0x01, 0x10,
+  0x01, 0x78, 0xbc, 0xba, 0xfe, 0xf0, 0xfd, 0x38, 0x02, 0xc8, 0xc8, 0x8a,
+  0x8a, 0x8a, 0x8a, 0xca, 0xfd, 0x3a, 0x00, 0x00, 0x00, 0x02, 0x00, 0xbd,
+  0xff, 0xe3, 0x05, 0x4c, 0x05, 0x31, 0x00, 0x11, 0x00, 0x24, 0x00, 0x00,
+  0x01, 0x11, 0x14, 0x16, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x11, 0x21, 0x11, 0x10, 0x00, 0x20, 0x27,
+  0x26, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35,
+  0x11, 0x02, 0x88, 0x48, 0x68, 0x48, 0x99, 0x51, 0x4f, 0x75, 0x73, 0xa2,
+  0x03, 0x5c, 0xfe, 0xaa, 0xfe, 0x1e, 0xad, 0xa9, 0x99, 0x7c, 0x7e, 0x01,
+  0x68, 0x7c, 0x7e, 0x05, 0x31, 0xfd, 0x3a, 0x3a, 0x50, 0x50, 0x3a, 0x02,
+  0xc6, 0xfd, 0x38, 0x80, 0x5a, 0x58, 0xb2, 0x80, 0x02, 0xc8, 0xfd, 0x3a,
+  0xfe, 0xf0, 0xfe, 0x88, 0xbc, 0xba, 0x01, 0x10, 0x02, 0xc8, 0xfd, 0x38,
+  0xc8, 0x8a, 0x8a, 0x8a, 0x8a, 0xca, 0x02, 0xc6, 0x00, 0x01, 0x01, 0x56,
+  0x00, 0x00, 0x04, 0xb3, 0x05, 0xd5, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x34,
+  0x27, 0x26, 0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x06, 0x15, 0x11, 0x23,
+  0x11, 0x34, 0x37, 0x36, 0x37, 0x11, 0x33, 0x11, 0x16, 0x17, 0x16, 0x15,
+  0x11, 0x23, 0x04, 0x19, 0x51, 0x34, 0x43, 0x99, 0x44, 0x34, 0x51, 0x99,
+  0x7e, 0x61, 0x83, 0x99, 0x84, 0x61, 0x7c, 0x99, 0x02, 0x9f, 0x80, 0x59,
+  0x3a, 0x14, 0xfc, 0x3a, 0x03, 0xc6, 0x13, 0x3a, 0x5a, 0x80, 0xfd, 0x61,
+  0x02, 0x9d, 0xc8, 0x8c, 0x6c, 0x17, 0x01, 0x61, 0xfe, 0x9f, 0x17, 0x6c,
+  0x8a, 0xc8, 0xfd, 0x61, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x34, 0x05, 0x46,
+  0x05, 0xd5, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x00, 0x05, 0x23, 0x11, 0x23,
+  0x11, 0x23, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x33,
+  0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21,
+  0x27, 0x35, 0x23, 0x15, 0x03, 0xea, 0x99, 0x99, 0x99, 0xfe, 0xa4, 0x01,
+  0x5c, 0xfe, 0xa4, 0x01, 0x5c, 0x99, 0x99, 0x99, 0x01, 0x5b, 0xfe, 0xa5,
+  0x01, 0x5b, 0xfe, 0xa5, 0x99, 0x99, 0xcc, 0x02, 0x2c, 0xfd, 0xd4, 0x02,
+  0x2c, 0xaa, 0xf0, 0xa8, 0x02, 0x33, 0xfd, 0xcd, 0x02, 0x33, 0xfd, 0xcd,
+  0xa8, 0xf0, 0xaa, 0xaa, 0xf0, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x5e, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x23, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x04, 0x2d,
+  0xbe, 0xbe, 0x01, 0x18, 0xfc, 0x5f, 0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82,
+  0x03, 0x00, 0xfe, 0x01, 0xee, 0xfe, 0x91, 0xfe, 0x93, 0xb6, 0x01, 0xd1,
+  0xa6, 0x01, 0xd1, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x5e, 0x05, 0x46,
+  0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23,
+  0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x01, 0x1d, 0xbe, 0xbe, 0x5a,
+  0x04, 0x82, 0xfb, 0x7e, 0x03, 0x9f, 0x03, 0x00, 0xfe, 0x01, 0xee, 0xb6,
+  0xfe, 0x2f, 0xa6, 0xfe, 0x2f, 0xb6, 0x01, 0x6d, 0x00, 0x03, 0x00, 0x85,
+  0x00, 0x2e, 0x09, 0xb8, 0x04, 0xdf, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x14,
+  0x00, 0x00, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x09, 0x01, 0x15,
+  0x01, 0x35, 0x01, 0x05, 0x09, 0x01, 0x15, 0x01, 0x35, 0x01, 0x09, 0xb8,
+  0xfd, 0x18, 0x02, 0xe8, 0xfc, 0x35, 0x03, 0xcb, 0xfd, 0x4c, 0xfd, 0x19,
+  0x02, 0xe7, 0xfc, 0x36, 0x03, 0xca, 0xfd, 0x4b, 0xfd, 0x19, 0x02, 0xe7,
+  0xfc, 0x36, 0x03, 0xca, 0x04, 0x11, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02,
+  0x08, 0x9f, 0x02, 0x0a, 0xce, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08,
+  0x9f, 0x02, 0x0a, 0xce, 0xfe, 0x70, 0xfe, 0x72, 0xc5, 0x02, 0x08, 0x9f,
+  0x02, 0x0a, 0x00, 0x00, 0x00, 0x03, 0x00, 0x85, 0x00, 0x2e, 0x09, 0xb8,
+  0x04, 0xdf, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x00, 0x13, 0x35,
+  0x01, 0x15, 0x01, 0x35, 0x01, 0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01,
+  0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x85, 0x03, 0xca, 0xfc, 0x36,
+  0x02, 0xe8, 0x33, 0x03, 0xca, 0xfc, 0x36, 0x02, 0xe8, 0x35, 0x03, 0xcb,
+  0xfc, 0x35, 0x02, 0xe8, 0x04, 0x11, 0xce, 0xfd, 0xf6, 0x9f, 0xfd, 0xf8,
+  0xc5, 0x01, 0x8e, 0x01, 0x90, 0xce, 0xfd, 0xf6, 0x9f, 0xfd, 0xf8, 0xc5,
+  0x01, 0x8e, 0x01, 0x90, 0xce, 0xfd, 0xf6, 0x9f, 0xfd, 0xf8, 0xc5, 0x01,
+  0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0x2e, 0x05, 0x46,
+  0x06, 0xd4, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x00, 0x13, 0x09,
+  0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0x11, 0x09, 0x01,
+  0x15, 0x01, 0x35, 0x01, 0xc3, 0x03, 0x61, 0xfc, 0x9f, 0x04, 0x82, 0xfb,
+  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xa0, 0x03, 0x60, 0xfb,
+  0x7e, 0x04, 0x82, 0xfe, 0xde, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90,
+  0xaa, 0xfe, 0x91, 0x03, 0xfe, 0xaa, 0x03, 0x4e, 0xfe, 0xeb, 0xfe, 0xee,
+  0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0xfe, 0x2e, 0x05, 0x46, 0x06, 0xd4, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11,
+  0x00, 0x00, 0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x35, 0x21,
+  0x15, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45, 0xfb, 0x7e,
+  0x04, 0x82, 0xfc, 0x9f, 0xfe, 0xdf, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
+  0xfb, 0x7e, 0x03, 0x60, 0xfe, 0xde, 0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70,
+  0xb2, 0xfe, 0xee, 0x02, 0x39, 0xaa, 0xaa, 0x03, 0xf8, 0xb0, 0xfe, 0x91,
+  0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0x00, 0x00, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x00,
+  0x25, 0x15, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x35, 0x21, 0x15, 0x05,
+  0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xa0, 0xfe, 0xde, 0x04, 0x82, 0xb0,
+  0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x02, 0x39, 0xaa,
+  0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46,
+  0x04, 0xa8, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x00, 0x37, 0x09, 0x01, 0x35,
+  0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0xc3, 0x03, 0x61, 0xfc, 0x9f,
+  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xb0, 0x01,
+  0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe, 0x91, 0x03, 0xfe, 0xaa,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46, 0x05, 0x57, 0x00, 0x05,
+  0x00, 0x10, 0x00, 0x00, 0x01, 0x00, 0x05, 0x35, 0x24, 0x01, 0x11, 0x15,
+  0x00, 0x25, 0x35, 0x24, 0x01, 0x15, 0x00, 0x05, 0x04, 0x05, 0x45, 0xfe,
+  0x7f, 0xfc, 0xff, 0x03, 0x12, 0x01, 0x70, 0xfe, 0xa7, 0xfc, 0xd7, 0x03,
+  0x29, 0x01, 0x59, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x04, 0x80, 0xfe,
+  0x5f, 0x85, 0xae, 0x91, 0x01, 0xbe, 0xfa, 0xa9, 0xd7, 0x01, 0x80, 0x7c,
+  0xa6, 0x84, 0x01, 0x78, 0xd7, 0xfe, 0xe5, 0x5d, 0x5d, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0x29, 0x05, 0x46, 0x05, 0x57, 0x00, 0x05,
+  0x00, 0x10, 0x00, 0x00, 0x13, 0x35, 0x00, 0x05, 0x15, 0x24, 0x01, 0x00,
+  0x25, 0x24, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0xc3, 0x01, 0x70,
+  0x03, 0x12, 0xfc, 0xff, 0xfe, 0x7f, 0x01, 0x59, 0x01, 0xac, 0xfe, 0x54,
+  0xfe, 0xa7, 0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7, 0x04, 0x80,
+  0xd7, 0xfe, 0x42, 0x91, 0xae, 0x85, 0xfd, 0x21, 0x01, 0x1b, 0x5d, 0x5d,
+  0x01, 0x1b, 0xd7, 0xfe, 0x88, 0x84, 0xa6, 0x7c, 0xfe, 0x80, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x93, 0x05, 0x46, 0x06, 0x1d, 0x00, 0x21,
+  0x00, 0x26, 0x00, 0x00, 0x21, 0x15, 0x02, 0x25, 0x01, 0x27, 0x13, 0x26,
+  0x27, 0x35, 0x16, 0x17, 0x37, 0x26, 0x25, 0x35, 0x24, 0x25, 0x13, 0x17,
+  0x03, 0x36, 0x37, 0x15, 0x06, 0x0f, 0x01, 0x04, 0x17, 0x15, 0x26, 0x25,
+  0x07, 0x04, 0x01, 0x37, 0x06, 0x07, 0x16, 0x05, 0x45, 0xf2, 0xfe, 0x59,
+  0xff, 0x00, 0x76, 0xf4, 0xa7, 0xc0, 0xe6, 0xc4, 0x39, 0xd8, 0xfe, 0xf5,
+  0x01, 0x8a, 0x01, 0x1b, 0xde, 0x75, 0x95, 0xaa, 0x75, 0xb4, 0xcc, 0x5e,
+  0x01, 0x01, 0xdd, 0xc4, 0xfe, 0xa6, 0x39, 0x01, 0x70, 0xfe, 0x88, 0x2b,
+  0x66, 0x6b, 0x55, 0xd7, 0x01, 0x25, 0xa4, 0xfd, 0xa1, 0x4b, 0x02, 0x41,
+  0x36, 0x23, 0xae, 0x28, 0x41, 0x87, 0x46, 0x2b, 0xa6, 0x3c, 0x7a, 0x02,
+  0x0c, 0x4b, 0xfe, 0x9f, 0x64, 0x82, 0xd7, 0x94, 0x60, 0xdf, 0x67, 0xb6,
+  0xd7, 0xd6, 0x87, 0x88, 0x94, 0x01, 0xe2, 0x66, 0x23, 0x17, 0x12, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x93, 0x05, 0x46, 0x06, 0x1d, 0x00, 0x21,
+  0x00, 0x26, 0x00, 0x00, 0x13, 0x35, 0x16, 0x05, 0x13, 0x17, 0x03, 0x16,
+  0x17, 0x15, 0x04, 0x0f, 0x01, 0x24, 0x25, 0x15, 0x04, 0x05, 0x03, 0x27,
+  0x13, 0x06, 0x07, 0x35, 0x36, 0x3f, 0x01, 0x04, 0x07, 0x35, 0x36, 0x25,
+  0x37, 0x24, 0x05, 0x07, 0x36, 0x37, 0x26, 0xc3, 0xe2, 0x01, 0xa8, 0xf9,
+  0x75, 0xea, 0xac, 0xc8, 0xfe, 0xd9, 0xea, 0x50, 0x01, 0x0b, 0x01, 0x56,
+  0xfe, 0x65, 0xfe, 0xd8, 0xd6, 0x76, 0x81, 0x8b, 0x69, 0x96, 0xce, 0x5a,
+  0xfe, 0xea, 0xa8, 0xf7, 0x01, 0x22, 0x32, 0xfe, 0xc1, 0x01, 0xc4, 0x0c,
+  0x21, 0x20, 0x1b, 0x04, 0x80, 0xd7, 0xfb, 0x8c, 0x02, 0x4d, 0x4b, 0xfd,
+  0xd6, 0x2e, 0x1f, 0xa6, 0x30, 0x51, 0xbd, 0x74, 0x3b, 0xae, 0x4c, 0x9e,
+  0xfe, 0x05, 0x4b, 0x01, 0x31, 0x67, 0x7f, 0xd7, 0xa2, 0x76, 0xd5, 0x7d,
+  0xb7, 0xd7, 0xcb, 0x69, 0x77, 0x69, 0x90, 0x1b, 0x08, 0x07, 0x06, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xdf, 0x05, 0x46, 0x06, 0x23, 0x00, 0x17,
+  0x00, 0x1b, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x03, 0x21,
+  0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27, 0x37, 0x21, 0x35, 0x21,
+  0x37, 0x21, 0x11, 0x21, 0x03, 0x13, 0x21, 0x11, 0x03, 0xdf, 0x90, 0x4f,
+  0x01, 0x25, 0xfe, 0xa4, 0xc7, 0x02, 0x23, 0xfd, 0xa6, 0x2a, 0x02, 0x84,
+  0xfd, 0x46, 0x62, 0x90, 0x4f, 0xfe, 0xdb, 0x01, 0x5c, 0x29, 0xfe, 0x7b,
+  0x02, 0xba, 0xfe, 0xc7, 0xfe, 0x16, 0x06, 0x23, 0x3a, 0xf5, 0xaa, 0xfd,
+  0x98, 0xaa, 0x80, 0xaa, 0xfe, 0xd1, 0x3a, 0xf5, 0xaa, 0x80, 0x03, 0xbc,
+  0xfc, 0xee, 0x02, 0x68, 0xfd, 0x98, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xfe, 0xdf, 0x05, 0x46, 0x06, 0x23, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x17, 0x07, 0x21, 0x11, 0x21, 0x07, 0x21, 0x15, 0x21, 0x03, 0x27,
+  0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x13, 0x21, 0x35, 0x21,
+  0x17, 0x03, 0x21, 0x11, 0x03, 0xdf, 0x90, 0x4f, 0x01, 0x25, 0xfd, 0xa6,
+  0x2a, 0x02, 0x84, 0xfd, 0x46, 0x62, 0x90, 0x4f, 0xfe, 0xdb, 0x01, 0x5c,
+  0x29, 0xfe, 0x7b, 0x01, 0xbc, 0xc7, 0xfd, 0x7d, 0x02, 0xba, 0x6c, 0xc7,
+  0x01, 0x8a, 0x06, 0x23, 0x3a, 0xf5, 0xfc, 0x44, 0x80, 0xaa, 0xfe, 0xd1,
+  0x3a, 0xf5, 0xaa, 0x80, 0xaa, 0x02, 0x68, 0xaa, 0xaa, 0xfd, 0x98, 0x02,
+  0x68, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3, 0xff, 0x3f, 0x05, 0x46,
+  0x04, 0xf4, 0x00, 0x14, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35,
+  0x21, 0x37, 0x21, 0xc3, 0x04, 0x82, 0xfc, 0x17, 0x03, 0xe9, 0xfe, 0x80,
+  0x18, 0x45, 0x01, 0xad, 0xfd, 0xe7, 0x84, 0x7d, 0x46, 0xfe, 0x52, 0x02,
+  0x1a, 0x51, 0xfd, 0x95, 0x04, 0xf4, 0xaa, 0xfd, 0x98, 0xaa, 0x13, 0x6d,
+  0xaa, 0xcf, 0x62, 0x6d, 0xaa, 0x80, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0xff, 0x3f, 0x05, 0x46, 0x04, 0xf4, 0x00, 0x14, 0x00, 0x00, 0x25, 0x15,
+  0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x21, 0x17, 0x07, 0x05, 0x45, 0xfd, 0xe7, 0x84,
+  0x7d, 0x46, 0xfe, 0x52, 0x02, 0x1a, 0x51, 0xfd, 0x95, 0x03, 0xe9, 0xfc,
+  0x17, 0x04, 0x82, 0xfe, 0x80, 0x18, 0x45, 0xb8, 0xaa, 0xcf, 0x62, 0x6d,
+  0xaa, 0x80, 0xaa, 0x02, 0x68, 0xaa, 0xfc, 0x44, 0x13, 0x6d, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xe5, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x1b,
+  0x00, 0x22, 0x00, 0x00, 0x25, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
+  0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37,
+  0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27, 0x09, 0x02, 0x15, 0x01,
+  0x35, 0x01, 0x02, 0x9c, 0x59, 0x3d, 0x4f, 0x9b, 0x58, 0x5e, 0xa1, 0x58,
+  0x54, 0x6c, 0x63, 0x8b, 0x5e, 0x5b, 0x3d, 0x4e, 0x98, 0x5d, 0x5f, 0xa1,
+  0x57, 0x57, 0x6d, 0x61, 0x8c, 0x03, 0x07, 0xfc, 0xa0, 0x03, 0x60, 0xfb,
+  0x7e, 0x04, 0x82, 0x11, 0x1f, 0x4c, 0x54, 0xb4, 0x4e, 0x44, 0x2a, 0xf3,
+  0x46, 0xe9, 0x20, 0x4a, 0x56, 0xb4, 0x4e, 0x44, 0x2b, 0xf0, 0x46, 0x04,
+  0xcd, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xe5, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x1b,
+  0x00, 0x22, 0x00, 0x00, 0x25, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
+  0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37,
+  0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27, 0x01, 0x35, 0x01, 0x15,
+  0x01, 0x35, 0x01, 0x02, 0x9c, 0x59, 0x3d, 0x4f, 0x9b, 0x58, 0x5e, 0xa1,
+  0x58, 0x54, 0x6c, 0x63, 0x8b, 0x5e, 0x5b, 0x3d, 0x4e, 0x98, 0x5d, 0x5f,
+  0xa1, 0x57, 0x57, 0x6d, 0x61, 0x8c, 0xfe, 0x85, 0x04, 0x82, 0xfb, 0x7e,
+  0x03, 0x60, 0x11, 0x1f, 0x4c, 0x54, 0xb4, 0x4e, 0x44, 0x2a, 0xf3, 0x46,
+  0xe9, 0x20, 0x4a, 0x56, 0xb4, 0x4e, 0x44, 0x2b, 0xf0, 0x46, 0x04, 0xcd,
+  0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xa6, 0x05, 0x46, 0x05, 0x57, 0x00, 0x1b,
+  0x00, 0x26, 0x00, 0x00, 0x05, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
+  0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37,
+  0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27, 0x01, 0x00, 0x05, 0x04,
+  0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x02, 0x9c, 0x5a, 0x3c, 0x50,
+  0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x54, 0x6c, 0x63, 0x8c, 0x5f, 0x5b, 0x3e,
+  0x4d, 0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x56, 0x6d, 0x62, 0x8b, 0x03, 0x07,
+  0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe, 0xa7, 0xfc, 0xd7,
+  0x03, 0x29, 0x01, 0x59, 0x2e, 0x20, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x2b,
+  0xf3, 0x46, 0xe9, 0x20, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x2c, 0xf1, 0x46,
+  0x05, 0x94, 0xfe, 0xe5, 0x5d, 0x5d, 0xfe, 0xe5, 0xd7, 0x01, 0x78, 0x84,
+  0xa6, 0x7c, 0x01, 0x80, 0x00, 0x02, 0x00, 0xca, 0xfe, 0xa2, 0x05, 0x4d,
+  0x05, 0x57, 0x00, 0x1b, 0x00, 0x26, 0x00, 0x00, 0x05, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16,
+  0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07, 0x27,
+  0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0x02,
+  0xa3, 0x59, 0x3d, 0x4f, 0x9b, 0x59, 0x5f, 0xa1, 0x57, 0x54, 0x6d, 0x62,
+  0x8c, 0x5f, 0x5b, 0x3e, 0x4e, 0x98, 0x5c, 0x5e, 0xa1, 0x58, 0x56, 0x6d,
+  0x61, 0x8c, 0xfe, 0x85, 0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7,
+  0x01, 0x59, 0x01, 0xad, 0xfe, 0x53, 0x33, 0x20, 0x4c, 0x54, 0xb3, 0x4e,
+  0x45, 0x2b, 0xf4, 0x46, 0xea, 0x20, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x2c,
+  0xf0, 0x46, 0x05, 0x98, 0xd7, 0xfe, 0x80, 0x7c, 0xa6, 0x84, 0xfe, 0x88,
+  0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0xfe, 0xf6, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x12,
+  0x00, 0x00, 0x01, 0x17, 0x03, 0x37, 0x11, 0x25, 0x03, 0x27, 0x13, 0x25,
+  0x35, 0x01, 0x13, 0x11, 0x07, 0x03, 0x27, 0x13, 0x05, 0x04, 0x6a, 0x8e,
+  0x76, 0xc3, 0xfd, 0xf4, 0xc6, 0x8e, 0xc6, 0xfe, 0x18, 0x02, 0xf8, 0xf1,
+  0x7d, 0xbb, 0x8e, 0x82, 0xfe, 0x3c, 0x06, 0x0c, 0x40, 0xfe, 0xc1, 0x59,
+  0xfb, 0x38, 0xf0, 0xfd, 0xe8, 0x40, 0x02, 0x19, 0xe0, 0xa6, 0x01, 0x5c,
+  0xfc, 0xef, 0x02, 0xc4, 0x39, 0xfe, 0x04, 0x40, 0x01, 0x61, 0xce, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0xfe, 0xf6, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x12, 0x00, 0x00, 0x01, 0x27, 0x13, 0x07, 0x11, 0x05,
+  0x13, 0x17, 0x03, 0x05, 0x15, 0x01, 0x03, 0x11, 0x37, 0x13, 0x17, 0x03,
+  0x25, 0x01, 0x9f, 0x8e, 0x75, 0xc3, 0x02, 0x0d, 0xc5, 0x8e, 0xc6, 0x01,
+  0xe8, 0xfd, 0x09, 0xf2, 0x7d, 0xbc, 0x8e, 0x82, 0x01, 0xc3, 0xfe, 0xf6,
+  0x40, 0x01, 0x3f, 0x59, 0x04, 0xc8, 0xf0, 0x02, 0x18, 0x40, 0xfd, 0xe7,
+  0xe0, 0xa6, 0xfe, 0xa4, 0x03, 0x11, 0xfd, 0x3c, 0x39, 0x01, 0xfc, 0x40,
+  0xfe, 0x9f, 0xce, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0x7d, 0x05, 0x46,
+  0x06, 0x85, 0x00, 0x03, 0x00, 0x17, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x11,
+  0x07, 0x03, 0x01, 0x35, 0x21, 0x13, 0x25, 0x35, 0x01, 0x13, 0x17, 0x03,
+  0x37, 0x11, 0x25, 0x03, 0x21, 0x15, 0x21, 0x03, 0x27, 0x37, 0x01, 0x13,
+  0x05, 0x04, 0xac, 0x7f, 0xbb, 0xfd, 0x51, 0x01, 0x56, 0x90, 0xfe, 0x1a,
+  0x02, 0xf5, 0xae, 0x8e, 0x74, 0xc5, 0xfd, 0xf2, 0x78, 0x02, 0x86, 0xfd,
+  0x3b, 0x6a, 0x8e, 0x52, 0x01, 0x0a, 0x81, 0xfe, 0x3f, 0x01, 0x9e, 0x02,
+  0xc4, 0x3a, 0xfe, 0x05, 0xfd, 0x71, 0xaa, 0x01, 0x86, 0xdf, 0xa6, 0x01,
+  0x5b, 0x01, 0xd7, 0x40, 0xfe, 0xc5, 0x5a, 0xfb, 0x38, 0xf1, 0xfe, 0xbb,
+  0xaa, 0xfe, 0xdf, 0x40, 0xe1, 0x02, 0xd0, 0x01, 0x5f, 0xcd, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xbf, 0xfe, 0x7d, 0x05, 0x42, 0x06, 0x85, 0x00, 0x13,
+  0x00, 0x17, 0x00, 0x1a, 0x00, 0x00, 0x37, 0x11, 0x01, 0x13, 0x17, 0x03,
+  0x05, 0x15, 0x01, 0x03, 0x21, 0x15, 0x21, 0x03, 0x27, 0x37, 0x23, 0x35,
+  0x33, 0x37, 0x13, 0x25, 0x11, 0x37, 0x01, 0x03, 0x25, 0xc0, 0x02, 0x61,
+  0xd2, 0x8e, 0xd2, 0x01, 0x93, 0xfd, 0x80, 0x76, 0x02, 0xf6, 0xfc, 0xcb,
+  0x6b, 0x8e, 0x53, 0xa7, 0xe6, 0x54, 0xec, 0xfe, 0x73, 0xf4, 0x01, 0x27,
+  0x60, 0x01, 0x4c, 0x9c, 0x04, 0xc8, 0xfe, 0xe9, 0x02, 0x38, 0x40, 0xfd,
+  0xc7, 0xb9, 0xa6, 0xfe, 0xdb, 0xfe, 0xc0, 0xaa, 0xfe, 0xdf, 0x40, 0xe1,
+  0xaa, 0xe4, 0x02, 0x81, 0xb5, 0xfd, 0x3c, 0x70, 0x01, 0x5e, 0xfe, 0xfc,
+  0x98, 0x00, 0x00, 0x00, 0xff, 0xff, 0x03, 0x3a, 0xff, 0x42, 0x03, 0xf9,
+  0x05, 0xb8, 0x10, 0x27, 0x09, 0xa1, 0x02, 0x75, 0xfc, 0xfa, 0x10, 0x27,
+  0x09, 0xa1, 0x02, 0x75, 0x02, 0x72, 0x10, 0x07, 0x09, 0xa1, 0x02, 0x75,
+  0xff, 0xb6, 0x00, 0x00, 0xff, 0xff, 0x00, 0xd4, 0x01, 0xfe, 0x06, 0x5e,
+  0x02, 0xfc, 0x10, 0x26, 0x09, 0xa1, 0x0f, 0xb6, 0x10, 0x27, 0x09, 0xa1,
+  0x02, 0x75, 0xff, 0xb6, 0x10, 0x07, 0x09, 0xa1, 0x04, 0xdb, 0xff, 0xb6,
+  0xff, 0xff, 0x00, 0xd4, 0xff, 0x42, 0x06, 0x5e, 0x05, 0xb8, 0x10, 0x27,
+  0x09, 0xa1, 0x00, 0x0f, 0xfc, 0xfa, 0x10, 0x27, 0x09, 0xa1, 0x04, 0xdb,
+  0x02, 0x72, 0x10, 0x07, 0x09, 0xa1, 0x02, 0x75, 0xff, 0xb6, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xd4, 0xff, 0x42, 0x06, 0x5e, 0x05, 0xb8, 0x10, 0x27,
+  0x09, 0xa1, 0x04, 0xdb, 0xfc, 0xfa, 0x10, 0x27, 0x09, 0xa1, 0x00, 0x0f,
+  0x02, 0x72, 0x10, 0x07, 0x09, 0xa1, 0x02, 0x75, 0xff, 0xb6, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x4f, 0xff, 0xec, 0x06, 0xe4, 0x05, 0xae, 0x00, 0x21,
+  0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x24, 0x33, 0x21,
+  0x15, 0x21, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x27, 0x26,
+  0x01, 0xdf, 0xfe, 0x70, 0x01, 0x8e, 0x0d, 0x46, 0x54, 0x01, 0x41, 0xad,
+  0x02, 0x72, 0xfd, 0x8d, 0x85, 0x7c, 0x7c, 0x44, 0x3a, 0x07, 0x04, 0x75,
+  0xfb, 0x8d, 0x06, 0x39, 0x43, 0x7d, 0x7c, 0x85, 0x02, 0x73, 0xfd, 0x8e,
+  0xad, 0xfe, 0xbf, 0x54, 0x41, 0x02, 0x73, 0xa0, 0x94, 0x8f, 0xb0, 0xc8,
+  0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0, 0x4a, 0x78, 0x8b, 0x4e,
+  0x4c, 0x01, 0x9f, 0xc6, 0xb0, 0x85, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x16,
+  0x12, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x02, 0x10, 0x12, 0x24,
+  0x33, 0x21, 0x15, 0x21, 0x0e, 0x01, 0x02, 0x07, 0x21, 0x11, 0x33, 0x11,
+  0x23, 0x11, 0x01, 0x35, 0x06, 0x7b, 0xfa, 0x85, 0x02, 0x73, 0xfd, 0x8d,
+  0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02, 0x73, 0xfd, 0x8d,
+  0x85, 0xf9, 0x7d, 0x08, 0x03, 0xe6, 0x90, 0x90, 0x02, 0x73, 0x4a, 0xfe,
+  0xfd, 0x9a, 0x01, 0x9f, 0xc6, 0x01, 0x60, 0x01, 0x74, 0x01, 0x60, 0xc8,
+  0x9f, 0x01, 0x9c, 0xfe, 0xfe, 0x5d, 0x01, 0x10, 0xfd, 0x40, 0x01, 0x10,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x19,
+  0x00, 0x00, 0x25, 0x20, 0x24, 0x10, 0x24, 0x29, 0x01, 0x15, 0x21, 0x22,
+  0x07, 0x06, 0x07, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35, 0x21, 0x16, 0x17,
+  0x16, 0x33, 0x21, 0x15, 0x02, 0xda, 0xfe, 0xf6, 0xfe, 0xf3, 0x01, 0x0d,
+  0x01, 0x0a, 0x01, 0x8e, 0xfe, 0x72, 0xcf, 0x60, 0x47, 0x1a, 0x02, 0x9e,
+  0x80, 0x80, 0xfd, 0x62, 0x22, 0x3f, 0x66, 0xc9, 0x01, 0x8e, 0x9b, 0xf6,
+  0x01, 0xe0, 0xf6, 0x8e, 0x51, 0x3b, 0x84, 0xac, 0xfe, 0x1a, 0xac, 0x91,
+  0x30, 0x51, 0x8e, 0x00, 0xff, 0xff, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
+  0x07, 0x48, 0x10, 0x26, 0x08, 0xe4, 0x00, 0x00, 0x10, 0x07, 0x09, 0xa1,
+  0x01, 0xff, 0x04, 0x02, 0x00, 0x02, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
+  0x06, 0xd2, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24, 0x02, 0x35, 0x34, 0x12,
+  0x24, 0x33, 0x21, 0x15, 0x21, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21,
+  0x15, 0x11, 0x21, 0x35, 0x21, 0x01, 0x35, 0x06, 0x39, 0x43, 0x7d, 0x7c,
+  0x85, 0x02, 0x73, 0xfd, 0x8d, 0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40,
+  0xad, 0x02, 0x73, 0xfd, 0x8d, 0x85, 0x7c, 0x7d, 0x43, 0x3a, 0x08, 0x04,
+  0x76, 0xfb, 0x2e, 0x04, 0xd2, 0x02, 0x73, 0x4a, 0x78, 0x8b, 0x4e, 0x4c,
+  0x01, 0x9f, 0xc6, 0x01, 0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8, 0x9f, 0x01,
+  0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0, 0x03, 0xbf, 0xa0, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x9b, 0x04, 0x68, 0x05, 0x7d, 0x00, 0x16,
+  0x00, 0x1a, 0x00, 0x00, 0x25, 0x20, 0x24, 0x35, 0x34, 0x24, 0x29, 0x01,
+  0x15, 0x05, 0x06, 0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x16, 0x17, 0x16,
+  0x33, 0x21, 0x15, 0x11, 0x21, 0x35, 0x21, 0x02, 0xda, 0xfe, 0xf6, 0xfe,
+  0xf3, 0x01, 0x0d, 0x01, 0x0a, 0x01, 0x8e, 0xfe, 0x72, 0xd1, 0x5e, 0x46,
+  0x1b, 0x03, 0x1e, 0xfc, 0xe2, 0x21, 0x40, 0x67, 0xc8, 0x01, 0x8e, 0xfc,
+  0x7e, 0x03, 0x82, 0x9b, 0xf6, 0xf0, 0xf0, 0xf6, 0x8e, 0x01, 0x01, 0x4f,
+  0x3a, 0x85, 0x8e, 0x91, 0x30, 0x51, 0x8e, 0x04, 0x56, 0x8c, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x9d, 0xfe, 0xda, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1c,
+  0x00, 0x20, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21,
+  0x15, 0x21, 0x22, 0x24, 0x02, 0x35, 0x34, 0x12, 0x24, 0x33, 0x21, 0x15,
+  0x21, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x15, 0x11, 0x21, 0x35,
+  0x21, 0x01, 0x35, 0x06, 0x39, 0x43, 0x7d, 0x7c, 0x85, 0x02, 0x73, 0xfd,
+  0x8d, 0xad, 0xfe, 0xc0, 0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02, 0x73, 0xfd,
+  0x8d, 0x85, 0x7c, 0x7d, 0x43, 0x3a, 0x08, 0x04, 0x76, 0xfb, 0x2e, 0x04,
+  0xd2, 0x02, 0x73, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0x01,
+  0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8, 0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78,
+  0x5d, 0xa0, 0xfc, 0x67, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0xff, 0xec, 0x05, 0xa9, 0x05, 0xae, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x21,
+  0x15, 0x21, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x15, 0x21, 0x22, 0x24,
+  0x02, 0x35, 0x34, 0x12, 0x24, 0x33, 0x21, 0x15, 0x21, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x21, 0x15, 0x21, 0x01, 0x35, 0x04, 0x73, 0xfb, 0xbc,
+  0x10, 0x43, 0x7d, 0x7c, 0x85, 0x02, 0x73, 0xfd, 0x8d, 0xad, 0xfe, 0xc0,
+  0xaa, 0xaa, 0x01, 0x40, 0xad, 0x02, 0x73, 0xfd, 0x8d, 0x85, 0x7c, 0x7d,
+  0x43, 0x0d, 0x0b, 0x04, 0x4c, 0xfb, 0x8d, 0x02, 0x73, 0xa0, 0x22, 0x8b,
+  0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0x01, 0x60, 0xbb, 0xb9, 0x01, 0x60, 0xc8,
+  0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x1b, 0x1a, 0xa0, 0x00, 0x01, 0x00, 0x4f,
+  0xff, 0xec, 0x06, 0xe4, 0x05, 0xae, 0x00, 0x21, 0x00, 0x00, 0x01, 0x21,
+  0x15, 0x21, 0x06, 0x07, 0x06, 0x04, 0x23, 0x21, 0x35, 0x21, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x21, 0x35, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x27, 0x21, 0x35, 0x21, 0x32, 0x04, 0x17, 0x16, 0x05, 0x54, 0x01, 0x90,
+  0xfe, 0x72, 0x0d, 0x46, 0x54, 0xfe, 0xbf, 0xac, 0xfd, 0x8d, 0x02, 0x73,
+  0x85, 0x7c, 0x7c, 0x44, 0x3a, 0x07, 0xfb, 0x8b, 0x04, 0x74, 0x07, 0x39,
+  0x43, 0x7d, 0x7c, 0x85, 0xfd, 0x8d, 0x02, 0x73, 0xac, 0x01, 0x41, 0x54,
+  0x41, 0x03, 0x27, 0xa0, 0x94, 0x8f, 0xb0, 0xc8, 0x9f, 0x01, 0x4d, 0x4f,
+  0x8a, 0x78, 0x5d, 0xa0, 0x4a, 0x78, 0x8b, 0x4e, 0x4c, 0x01, 0x9f, 0xc6,
+  0xb0, 0x85, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
+  0x05, 0xae, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x26, 0x02, 0x26, 0x27, 0x21,
+  0x35, 0x21, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x21, 0x35, 0x21,
+  0x3e, 0x01, 0x12, 0x37, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x05, 0x11,
+  0x06, 0x7c, 0xf9, 0x85, 0xfd, 0x8d, 0x02, 0x73, 0xad, 0x01, 0x3f, 0xab,
+  0xab, 0xfe, 0xc1, 0xad, 0xfd, 0x8d, 0x02, 0x73, 0x85, 0xf8, 0x7e, 0x08,
+  0xfc, 0x1a, 0x90, 0x90, 0x03, 0x27, 0x4a, 0x01, 0x03, 0x9a, 0x01, 0x9f,
+  0xc6, 0xfe, 0xa0, 0xfe, 0x8c, 0xfe, 0xa0, 0xc8, 0x9f, 0x01, 0x9c, 0x01,
+  0x02, 0x5d, 0xfe, 0xf0, 0x02, 0xc0, 0xfe, 0xf0, 0x00, 0x01, 0x00, 0xc3,
+  0x00, 0x9b, 0x04, 0x68, 0x04, 0x67, 0x00, 0x19, 0x00, 0x00, 0x01, 0x20,
+  0x04, 0x10, 0x04, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x37, 0x21,
+  0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x26, 0x27, 0x26, 0x23, 0x25, 0x35,
+  0x02, 0x51, 0x01, 0x0a, 0x01, 0x0d, 0xfe, 0xf3, 0xfe, 0xf6, 0xfe, 0x72,
+  0x01, 0x8e, 0xcf, 0x60, 0x46, 0x1b, 0xfd, 0x62, 0x80, 0x80, 0x02, 0x9e,
+  0x21, 0x40, 0x67, 0xc8, 0xfe, 0x72, 0x04, 0x67, 0xf6, 0xfe, 0x20, 0xf6,
+  0x8e, 0x51, 0x3a, 0x85, 0xac, 0x01, 0xe6, 0xac, 0x91, 0x30, 0x50, 0x01,
+  0x8e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d, 0xff, 0xec, 0x05, 0xa9,
+  0x06, 0xd2, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x21, 0x35, 0x21, 0x32, 0x04, 0x12, 0x15, 0x14, 0x02,
+  0x04, 0x23, 0x21, 0x35, 0x21, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x21,
+  0x35, 0x01, 0x21, 0x35, 0x21, 0x05, 0x11, 0x06, 0x39, 0x43, 0x7e, 0x7b,
+  0x85, 0xfd, 0x8d, 0x02, 0x73, 0xad, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1,
+  0xad, 0xfd, 0x8d, 0x02, 0x73, 0x85, 0x7b, 0x7d, 0x44, 0x3a, 0x08, 0xfb,
+  0x8a, 0x04, 0xd1, 0xfb, 0x2f, 0x04, 0xd1, 0x03, 0x27, 0x4a, 0x78, 0x8b,
+  0x4e, 0x4c, 0x01, 0x9f, 0xc6, 0xfe, 0xa0, 0xbb, 0xb9, 0xfe, 0xa0, 0xc8,
+  0x9f, 0x01, 0x4d, 0x4f, 0x8a, 0x78, 0x5d, 0xa0, 0x03, 0x0b, 0xa0, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x9b, 0x04, 0x68, 0x05, 0x7d, 0x00, 0x16,
+  0x00, 0x1a, 0x00, 0x00, 0x01, 0x20, 0x04, 0x15, 0x14, 0x04, 0x29, 0x01,
+  0x35, 0x25, 0x32, 0x37, 0x36, 0x37, 0x21, 0x35, 0x05, 0x26, 0x27, 0x26,
+  0x07, 0x21, 0x35, 0x25, 0x21, 0x35, 0x21, 0x02, 0x51, 0x01, 0x0a, 0x01,
+  0x0d, 0xfe, 0xf3, 0xfe, 0xf6, 0xfe, 0x72, 0x01, 0x8e, 0xd1, 0x5e, 0x46,
+  0x1b, 0xfc, 0xe2, 0x03, 0x1e, 0x22, 0x3f, 0x68, 0xc7, 0xfe, 0x72, 0x03,
+  0x82, 0xfc, 0x7e, 0x03, 0x82, 0x04, 0x67, 0xf6, 0xf1, 0xef, 0xf6, 0x8e,
+  0x01, 0x50, 0x3a, 0x85, 0x8e, 0x01, 0x91, 0x31, 0x52, 0x01, 0x8e, 0x8a,
+  0x8c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x83,
+  0x05, 0xc2, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x15, 0x21,
+  0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x05, 0x82, 0xfb, 0xda, 0x04, 0x26,
+  0xfb, 0x41, 0x04, 0xbf, 0xfb, 0xda, 0x04, 0x26, 0x02, 0x82, 0xfe, 0x28,
+  0xaa, 0x05, 0xc2, 0xaa, 0xfe, 0x14, 0x00, 0x00, 0x00, 0x03, 0x00, 0x42,
+  0xff, 0xdc, 0x04, 0x15, 0x04, 0x1c, 0x00, 0x13, 0x00, 0x1b, 0x00, 0x23,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x37, 0x17, 0x07, 0x16, 0x15, 0x14, 0x00,
+  0x23, 0x22, 0x27, 0x07, 0x27, 0x37, 0x26, 0x35, 0x34, 0x00, 0x05, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x1f, 0x01, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x27, 0x02, 0x2a, 0xa8, 0x80, 0x6a, 0x59, 0x6a, 0x63, 0xfe, 0xe3,
+  0xc7, 0xa5, 0x7f, 0x6a, 0x59, 0x69, 0x64, 0x01, 0x1c, 0x01, 0x94, 0x5a,
+  0x74, 0x91, 0xd2, 0x40, 0x59, 0x59, 0x71, 0x93, 0xd2, 0x3e, 0x04, 0x17,
+  0x71, 0x76, 0x63, 0x76, 0x8d, 0xba, 0xdd, 0xfe, 0xc4, 0x6f, 0x76, 0x63,
+  0x76, 0x8d, 0xba, 0xdf, 0x01, 0x3c, 0xd5, 0x48, 0xe9, 0xa5, 0x80, 0x63,
+  0x62, 0x47, 0xe9, 0xa3, 0x80, 0x62, 0x00, 0x00, 0x00, 0x01, 0x00, 0x66,
+  0x01, 0x4c, 0x03, 0xe4, 0x03, 0x8c, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x01, 0x35, 0x05, 0x11, 0x01, 0x15, 0x02, 0x5f, 0xfe, 0x08, 0x01, 0x84,
+  0x01, 0xf8, 0x02, 0x7a, 0xfe, 0xd2, 0x01, 0x4a, 0xc2, 0xfa, 0x01, 0x2e,
+  0xfe, 0xb6, 0xc2, 0x00, 0x00, 0x02, 0x00, 0x83, 0x00, 0x00, 0x04, 0x0f,
+  0x04, 0xc4, 0x00, 0x04, 0x00, 0x09, 0x00, 0x00, 0x33, 0x11, 0x09, 0x01,
+  0x11, 0x25, 0x21, 0x11, 0x09, 0x01, 0x83, 0x01, 0xc6, 0x01, 0xc6, 0xfd,
+  0x0a, 0x02, 0x60, 0xfe, 0xd0, 0xfe, 0xd0, 0x02, 0xa0, 0x02, 0x24, 0xfd,
+  0xdc, 0xfd, 0x60, 0xaa, 0x01, 0xd5, 0x01, 0x79, 0xfe, 0x87, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x79, 0x03, 0xda, 0x04, 0x8e, 0x05, 0xdc, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x03, 0x27, 0x01, 0x33, 0x01, 0x07, 0x03, 0x02, 0xdc,
+  0xf7, 0x6c, 0x01, 0x63, 0x51, 0x01, 0x61, 0x6c, 0xf5, 0x04, 0xea, 0xfe,
+  0xf0, 0x78, 0x01, 0x8a, 0xfe, 0x76, 0x78, 0x01, 0x10, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x79, 0x00, 0x00, 0x04, 0x8e, 0x02, 0x02, 0x00, 0x07,
+  0x00, 0x00, 0x25, 0x33, 0x13, 0x17, 0x01, 0x23, 0x01, 0x37, 0x02, 0xdc,
+  0x51, 0xf5, 0x6c, 0xfe, 0x9f, 0x51, 0xfe, 0x9d, 0x6c, 0xf2, 0x01, 0x10,
+  0x78, 0xfe, 0x76, 0x01, 0x8a, 0x78, 0x00, 0x00, 0xff, 0xff, 0x01, 0x79,
+  0x00, 0x00, 0x04, 0x8e, 0x03, 0x3f, 0x10, 0x26, 0x11, 0x49, 0x00, 0x00,
+  0x10, 0x07, 0x09, 0xdf, 0x00, 0x00, 0xfc, 0x26, 0xff, 0xff, 0x01, 0x79,
+  0x00, 0x00, 0x04, 0x8e, 0x04, 0x1b, 0x10, 0x27, 0x11, 0x49, 0x00, 0x00,
+  0x00, 0xdc, 0x10, 0x26, 0x11, 0x49, 0x00, 0xd7, 0x10, 0x07, 0x09, 0xdf,
+  0x00, 0x00, 0xfc, 0x26, 0x00, 0x01, 0x01, 0x1b, 0xff, 0xc5, 0x02, 0x69,
+  0x06, 0x4e, 0x00, 0x19, 0x00, 0x00, 0x01, 0x17, 0x06, 0x14, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x14, 0x17, 0x16, 0x14, 0x07, 0x27, 0x36, 0x34, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x34, 0x27, 0x26, 0x34, 0x01, 0x8b, 0x6e, 0x45,
+  0x45, 0x6f, 0x6f, 0x45, 0x45, 0x6f, 0x6f, 0x6e, 0x45, 0x45, 0x6f, 0x6f,
+  0x45, 0x45, 0x6f, 0x06, 0x4e, 0x76, 0x4f, 0x70, 0x50, 0x81, 0xf8, 0x81,
+  0x50, 0x6f, 0x50, 0x81, 0xf9, 0x81, 0x76, 0x4f, 0x70, 0x50, 0x81, 0xf8,
+  0x81, 0x50, 0x70, 0x50, 0x81, 0xf8, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e,
+  0xfe, 0xf2, 0x02, 0x1c, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x23, 0x11, 0x23, 0x9e, 0x01, 0x7e, 0xd8, 0xa6, 0x06, 0x14, 0x8f,
+  0xf9, 0x6d, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb3, 0xfe, 0xf2, 0x02, 0x31,
+  0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x23, 0x35,
+  0x02, 0x31, 0xa6, 0xd8, 0x06, 0x14, 0xf8, 0xde, 0x06, 0x93, 0x8f, 0x00,
+  0x00, 0x01, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0x1c, 0x06, 0x14, 0x00, 0x05,
+  0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x33, 0x15, 0x9e, 0xa6, 0xd8, 0xfe,
+  0xf2, 0x07, 0x22, 0xf9, 0x6d, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb3,
+  0xfe, 0xf2, 0x02, 0x31, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x35, 0x33, 0x11, 0x33, 0x02, 0x31, 0xfe, 0x82, 0xd8, 0xa6, 0xfe, 0xf2,
+  0x8f, 0x06, 0x93, 0x00, 0x00, 0x02, 0x02, 0xa8, 0xff, 0x62, 0x05, 0x78,
+  0x02, 0x82, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x11, 0x23,
+  0x13, 0x35, 0x21, 0x15, 0x02, 0xa8, 0x82, 0x82, 0xb4, 0x02, 0x1c, 0x01,
+  0xba, 0xfd, 0xa8, 0x02, 0x90, 0x90, 0x90, 0x00, 0x00, 0x02, 0x00, 0x5a,
+  0xff, 0x62, 0x03, 0x2a, 0x02, 0x82, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x15, 0x21, 0x35, 0x05, 0x33, 0x11, 0x23, 0x02, 0x76, 0xfd, 0xe4,
+  0x02, 0x4e, 0x82, 0x82, 0x02, 0x82, 0x90, 0x90, 0xc8, 0xfd, 0xa8, 0x00,
+  0x00, 0x02, 0x02, 0xa8, 0x01, 0xf2, 0x05, 0x78, 0x05, 0x12, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x25, 0x23, 0x11, 0x33,
+  0x03, 0x5c, 0x02, 0x1c, 0xfd, 0xb2, 0x82, 0x82, 0x01, 0xf2, 0x90, 0x90,
+  0xc8, 0x02, 0x58, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x01, 0xf2, 0x03, 0x2a,
+  0x05, 0x12, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35,
+  0x25, 0x23, 0x11, 0x33, 0x02, 0x76, 0xfd, 0xe4, 0x02, 0xd0, 0x82, 0x82,
+  0x02, 0x82, 0x90, 0x90, 0x38, 0x02, 0x58, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0x01, 0x1f, 0x05, 0x46, 0x03, 0x5e, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15,
+  0x21, 0x11, 0x23, 0x11, 0x05, 0x45, 0xfc, 0x15, 0x97, 0x03, 0x5e, 0xaa,
+  0xfe, 0x6b, 0x02, 0x3f, 0x00, 0x02, 0x00, 0x05, 0x01, 0x02, 0x03, 0xad,
+  0x05, 0x12, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x24, 0x05, 0x02,
+  0x13, 0x04, 0x25, 0x12, 0x03, 0x12, 0x03, 0x04, 0x25, 0x02, 0x13, 0x24,
+  0x7e, 0x01, 0x5a, 0x01, 0x5b, 0x7c, 0x7c, 0xfe, 0xa5, 0xfe, 0xa6, 0x7c,
+  0xf5, 0xa6, 0xa6, 0x01, 0xd4, 0x01, 0xd3, 0xa5, 0xa5, 0xfe, 0x2c, 0x01,
+  0x8a, 0x89, 0x89, 0x01, 0x80, 0x01, 0x82, 0x8a, 0x8a, 0xfe, 0x7e, 0xfd,
+  0xf8, 0x01, 0xf4, 0x02, 0x1c, 0xb1, 0xb1, 0xfe, 0x0c, 0xfd, 0xe5, 0xb1,
+  0x00, 0x06, 0x00, 0xde, 0x00, 0x01, 0x06, 0x55, 0x06, 0x13, 0x00, 0x03,
+  0x00, 0x31, 0x00, 0x3b, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x59, 0x00, 0x00,
+  0x01, 0x21, 0x11, 0x21, 0x11, 0x15, 0x14, 0x06, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x3b, 0x01, 0x11, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x32, 0x16,
+  0x1d, 0x01, 0x21, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x2b, 0x01, 0x11, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x3d, 0x01, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x14, 0x16, 0x33,
+  0x13, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x01,
+  0x33, 0x32, 0x36, 0x34, 0x26, 0x22, 0x06, 0x15, 0x11, 0x15, 0x14, 0x16,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x14, 0x01, 0x0b, 0xfe, 0xf5,
+  0xa6, 0xea, 0xa6, 0xa6, 0x72, 0x99, 0x99, 0x72, 0xa6, 0xa6, 0xea, 0xa6,
+  0x01, 0x0b, 0xa6, 0x75, 0x76, 0xa5, 0xa5, 0x73, 0x99, 0x99, 0x73, 0xa5,
+  0xa5, 0x76, 0x75, 0xa6, 0xfe, 0x70, 0x58, 0x3e, 0x3d, 0x58, 0x58, 0x3e,
+  0x95, 0x95, 0x3e, 0x58, 0x58, 0x3e, 0x3d, 0x58, 0x02, 0x15, 0x96, 0x3e,
+  0x58, 0x58, 0x7c, 0x58, 0x58, 0x7c, 0x58, 0x58, 0x3e, 0x02, 0x76, 0x01,
+  0x28, 0xfe, 0x44, 0xaa, 0x80, 0xb7, 0xb8, 0x83, 0x80, 0xba, 0x01, 0x28,
+  0xba, 0x81, 0x82, 0xb8, 0xb7, 0x80, 0xaa, 0xaa, 0x80, 0xb7, 0xb8, 0x82,
+  0x81, 0xba, 0xfe, 0xd8, 0xba, 0x80, 0x83, 0xb8, 0xb7, 0x80, 0xaa, 0x02,
+  0x50, 0xa7, 0x45, 0x61, 0x61, 0x8a, 0x62, 0xfd, 0xb0, 0x62, 0x44, 0x45,
+  0x62, 0x62, 0x44, 0x02, 0xf7, 0x62, 0x8a, 0x61, 0x61, 0x45, 0xfd, 0x09,
+  0xa7, 0x44, 0x62, 0x62, 0x45, 0x44, 0x62, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0x01, 0x1f, 0x05, 0x46, 0x03, 0x5e, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x11, 0x33, 0x11, 0x21, 0x05, 0x45, 0xfb, 0x7e, 0x97, 0x03, 0xeb, 0x01,
+  0x1f, 0x02, 0x3f, 0xfe, 0x6b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e,
+  0x03, 0x67, 0x02, 0xe8, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x11, 0x23, 0x11, 0x21, 0x02, 0xe7, 0xfe, 0x39, 0x82, 0x02, 0x49, 0x05,
+  0x84, 0xfd, 0xe3, 0x02, 0xad, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x78,
+  0x03, 0x67, 0x02, 0xc2, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x13, 0x35,
+  0x21, 0x11, 0x23, 0x11, 0x79, 0x02, 0x49, 0x82, 0x05, 0x84, 0x90, 0xfd,
+  0x53, 0x02, 0x1d, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xff, 0x70, 0x02, 0xe8,
+  0x02, 0x1d, 0x00, 0x05, 0x00, 0x00, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11,
+  0x02, 0xe7, 0xfd, 0xb7, 0x82, 0x90, 0x02, 0xad, 0xfd, 0xe3, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x78, 0xff, 0x70, 0x02, 0xc2, 0x02, 0x1d, 0x00, 0x05,
+  0x00, 0x00, 0x33, 0x21, 0x11, 0x33, 0x11, 0x21, 0x79, 0x01, 0xc7, 0x82,
+  0xfd, 0xb7, 0x02, 0x1d, 0xfd, 0x53, 0x00, 0x00, 0x00, 0x01, 0x01, 0x83,
+  0xfe, 0x00, 0x03, 0x95, 0x07, 0x6c, 0x00, 0x19, 0x00, 0x00, 0x01, 0x11,
+  0x34, 0x37, 0x1a, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x03, 0x02, 0x15, 0x30, 0x11,
+  0x01, 0x84, 0x03, 0x0a, 0xab, 0xb6, 0x48, 0x5a, 0x39, 0x32, 0x27, 0x19,
+  0x15, 0x0e, 0x05, 0x08, 0x0f, 0x5d, 0x10, 0x07, 0xfe, 0x00, 0x05, 0x08,
+  0x24, 0x81, 0x02, 0x03, 0x01, 0xbc, 0x54, 0x41, 0x36, 0x3f, 0x13, 0x10,
+  0x26, 0x0f, 0x48, 0xfd, 0x95, 0xfe, 0xd3, 0x02, 0xfa, 0x98, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x25, 0xfe, 0x1a, 0x02, 0x37, 0x07, 0x89, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x11, 0x14, 0x07, 0x0a, 0x01, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x13,
+  0x12, 0x35, 0x30, 0x11, 0x02, 0x36, 0x03, 0x0a, 0xab, 0xb6, 0x48, 0x5a,
+  0x39, 0x32, 0x27, 0x19, 0x15, 0x0e, 0x05, 0x08, 0x0f, 0x5d, 0x10, 0x07,
+  0x07, 0x89, 0xfa, 0xf5, 0x24, 0x81, 0xfd, 0xfd, 0xfe, 0x44, 0x54, 0x41,
+  0x36, 0x3f, 0x13, 0x10, 0x26, 0x0f, 0x48, 0x02, 0x6b, 0x01, 0x2d, 0x02,
+  0x05, 0x6b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x8c, 0x01, 0xd0, 0x07, 0xc0,
+  0x04, 0x9a, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x09, 0x01,
+  0x27, 0x01, 0x33, 0x01, 0x07, 0x01, 0x25, 0x21, 0x35, 0x29, 0x02, 0x15,
+  0x21, 0x03, 0xfe, 0xfe, 0x55, 0x6c, 0x02, 0x17, 0x50, 0x02, 0x15, 0x6c,
+  0xfe, 0x57, 0xfe, 0xb3, 0xfd, 0x8b, 0x02, 0x75, 0x02, 0x49, 0x02, 0x76,
+  0xfd, 0x8a, 0x03, 0xa8, 0xfe, 0x28, 0x78, 0x02, 0x52, 0xfd, 0xae, 0x78,
+  0x01, 0xd8, 0x48, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x8c,
+  0x00, 0x00, 0x07, 0xc0, 0x04, 0x9a, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00,
+  0x13, 0x21, 0x01, 0x21, 0x15, 0x21, 0x01, 0x21, 0x25, 0x21, 0x15, 0x21,
+  0x8c, 0x02, 0x75, 0x02, 0x9a, 0x02, 0x25, 0xfd, 0x8b, 0xfd, 0x66, 0xfd,
+  0xdb, 0x04, 0xbe, 0x02, 0x76, 0xfd, 0x8a, 0x04, 0x9a, 0xfc, 0x10, 0xaa,
+  0x03, 0xf0, 0xaa, 0xaa, 0x00, 0x05, 0x00, 0x8c, 0x00, 0x00, 0x0a, 0x2e,
+  0x06, 0x14, 0x00, 0x04, 0x00, 0x09, 0x00, 0x0c, 0x00, 0x0f, 0x00, 0x15,
+  0x00, 0x00, 0x33, 0x11, 0x21, 0x09, 0x02, 0x11, 0x33, 0x09, 0x01, 0x29,
+  0x01, 0x09, 0x01, 0x21, 0x09, 0x03, 0x33, 0x09, 0x01, 0x8c, 0x06, 0xe5,
+  0x02, 0xbd, 0xfd, 0x43, 0xf9, 0xa1, 0x7e, 0x02, 0x38, 0xfd, 0xc8, 0x04,
+  0x6f, 0xfc, 0x4f, 0x01, 0xd9, 0xfe, 0x27, 0x03, 0xb1, 0xfe, 0x28, 0x02,
+  0x94, 0xfd, 0xc9, 0x02, 0x37, 0x7f, 0x02, 0x37, 0xfd, 0xc9, 0x06, 0x14,
+  0xfc, 0xf6, 0xfc, 0xf6, 0x05, 0x80, 0xfb, 0x14, 0x02, 0x76, 0x02, 0x76,
+  0xfd, 0xf3, 0xfd, 0x21, 0x02, 0x0d, 0x02, 0xdf, 0xfd, 0x8a, 0xfd, 0x8a,
+  0x02, 0x74, 0x02, 0x78, 0x00, 0x05, 0x00, 0x8c, 0x00, 0x00, 0x07, 0xc0,
+  0x06, 0x14, 0x00, 0x03, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x13,
+  0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x01, 0x11, 0x33, 0x09, 0x01, 0x29,
+  0x01, 0x09, 0x01, 0x21, 0x09, 0x03, 0x33, 0x11, 0x8c, 0x07, 0x34, 0xf9,
+  0x52, 0x7e, 0x02, 0x38, 0xfd, 0xc8, 0x04, 0x6f, 0xfc, 0x4f, 0x01, 0xd9,
+  0xfe, 0x27, 0x03, 0xb1, 0xfe, 0x28, 0x02, 0x94, 0xfd, 0xc9, 0x02, 0x37,
+  0x7f, 0x06, 0x14, 0xf9, 0xec, 0x05, 0x80, 0xfb, 0x14, 0x02, 0x76, 0x02,
+  0x76, 0xfd, 0xf3, 0xfd, 0x21, 0x02, 0x0d, 0x02, 0xdf, 0xfd, 0x8a, 0xfd,
+  0x8a, 0x04, 0xec, 0x00, 0x00, 0x2b, 0x00, 0x6c, 0x00, 0x00, 0x09, 0xf9,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
+  0x00, 0x47, 0x00, 0x53, 0x00, 0x5f, 0x00, 0x6b, 0x00, 0x77, 0x00, 0x83,
+  0x00, 0x8f, 0x00, 0x9b, 0x00, 0xa7, 0x00, 0xb3, 0x00, 0xbf, 0x00, 0xcb,
+  0x00, 0xd7, 0x00, 0xe3, 0x00, 0xef, 0x00, 0xfb, 0x01, 0x07, 0x01, 0x13,
+  0x01, 0x1f, 0x01, 0x2b, 0x01, 0x37, 0x01, 0x43, 0x01, 0x4f, 0x01, 0x5b,
+  0x01, 0x67, 0x01, 0x73, 0x01, 0x7f, 0x01, 0x8b, 0x01, 0x97, 0x01, 0xa3,
+  0x01, 0xaf, 0x01, 0xbb, 0x01, 0xc7, 0x01, 0xd3, 0x01, 0xe4, 0x01, 0xf0,
+  0x01, 0xfc, 0x02, 0x08, 0x00, 0x00, 0x01, 0x21, 0x32, 0x15, 0x11, 0x14,
+  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x11, 0x14, 0x33, 0x21, 0x32,
+  0x35, 0x11, 0x34, 0x23, 0x21, 0x22, 0x13, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x25, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x25, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x27, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x27, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x07, 0x32, 0x15, 0x11, 0x14, 0x2b,
+  0x01, 0x22, 0x3d, 0x01, 0x34, 0x23, 0x22, 0x3d, 0x01, 0x34, 0x33, 0x13,
+  0x15, 0x14, 0x2b, 0x01, 0x22, 0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x17,
+  0x15, 0x14, 0x2b, 0x01, 0x22, 0x3d, 0x01, 0x34, 0x3b, 0x01, 0x32, 0x05,
+  0x22, 0x3d, 0x01, 0x34, 0x33, 0x21, 0x32, 0x1d, 0x01, 0x14, 0x23, 0x01,
+  0x33, 0x07, 0xff, 0xc6, 0xc6, 0xf8, 0x01, 0xc7, 0x84, 0x43, 0x07, 0xff,
+  0x41, 0x41, 0xf8, 0x01, 0x43, 0xe9, 0x21, 0x42, 0x22, 0x22, 0x42, 0x21,
+  0xc9, 0x21, 0x44, 0x20, 0x20, 0x44, 0x21, 0x01, 0x29, 0x21, 0x43, 0x21,
+  0x21, 0x43, 0x21, 0xfe, 0x72, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7,
+  0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0x01, 0x8d, 0x21, 0x43, 0x21, 0x21,
+  0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43,
+  0x21, 0x21, 0x43, 0x21, 0xc7, 0x22, 0x42, 0x21, 0x21, 0x42, 0x22, 0xc7,
+  0x22, 0x42, 0x21, 0x21, 0x42, 0x22, 0x01, 0x66, 0x21, 0xe2, 0x22, 0x22,
+  0xe2, 0x21, 0xf9, 0x09, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21,
+  0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x22, 0x42, 0x21, 0x21, 0x42, 0x22,
+  0xc6, 0x22, 0x42, 0x21, 0x21, 0x42, 0x22, 0xc7, 0x22, 0x42, 0x21, 0x21,
+  0x42, 0x22, 0xc7, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0xc6, 0x21, 0x42,
+  0x22, 0x22, 0x42, 0x21, 0xc7, 0x21, 0x42, 0x22, 0x22, 0x42, 0x21, 0x20,
+  0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43,
+  0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21,
+  0x21, 0x43, 0x21, 0xc6, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21,
+  0x42, 0x22, 0x22, 0x42, 0x21, 0xc7, 0x21, 0x42, 0x22, 0x22, 0x42, 0x21,
+  0xc6, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0x21, 0x21, 0x43, 0x21, 0x21,
+  0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43,
+  0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc6,
+  0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc7, 0x21, 0x43, 0x21, 0x21, 0x43,
+  0x21, 0xc7, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0xc7, 0x22, 0x42, 0x22,
+  0x22, 0x42, 0x22, 0xc7, 0x22, 0x42, 0x22, 0x22, 0x42, 0x22, 0x01, 0x01,
+  0x21, 0x7e, 0x21, 0x21, 0x7e, 0x21, 0x21, 0x21, 0x21, 0xde, 0x26, 0x20,
+  0x21, 0x21, 0x85, 0x21, 0x43, 0x21, 0x21, 0x43, 0x21, 0xc9, 0x21, 0x44,
+  0x20, 0x20, 0x44, 0x21, 0xfa, 0x48, 0x22, 0x22, 0x03, 0x9d, 0x21, 0x21,
+  0x05, 0xd5, 0xdd, 0xfb, 0xe5, 0xdd, 0xdd, 0x04, 0x1b, 0xdd, 0xdd, 0xfb,
+  0xe5, 0x4a, 0x4a, 0x04, 0x1b, 0x4a, 0xfc, 0x1c, 0x49, 0x25, 0x25, 0x49,
+  0x26, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0xb7, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0xb7, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0xb7, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0xb4, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0xdb, 0x25, 0xfe, 0xde, 0x25, 0x25, 0x95, 0x20, 0x25, 0x49, 0x25,
+  0xfd, 0x48, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x25, 0x4a,
+  0x25, 0x94, 0x25, 0x4a, 0x25, 0x25, 0x4a, 0x25, 0x00, 0x05, 0x00, 0x00,
+  0x00, 0x00, 0x09, 0xa2, 0x06, 0x14, 0x00, 0x04, 0x00, 0x09, 0x00, 0x0c,
+  0x00, 0x0f, 0x00, 0x15, 0x00, 0x00, 0x29, 0x01, 0x09, 0x01, 0x21, 0x07,
+  0x23, 0x09, 0x01, 0x33, 0x09, 0x02, 0x11, 0x09, 0x01, 0x03, 0x23, 0x09,
+  0x01, 0x33, 0x01, 0x09, 0xa2, 0xf9, 0x1b, 0xfd, 0x44, 0x02, 0xbc, 0x06,
+  0xe5, 0x85, 0x7f, 0xfd, 0xc9, 0x02, 0x37, 0x7f, 0xfb, 0x12, 0x01, 0xd9,
+  0x01, 0xd8, 0xfe, 0x28, 0xfe, 0x27, 0xbb, 0x80, 0xfd, 0xc9, 0x02, 0x37,
+  0x80, 0x02, 0x37, 0x03, 0x0a, 0x03, 0x0a, 0x94, 0xfd, 0x8a, 0xfd, 0x8a,
+  0x04, 0xec, 0xfd, 0xf3, 0x02, 0x0d, 0xfb, 0x14, 0x02, 0x0d, 0xfd, 0xf3,
+  0x04, 0xec, 0xfd, 0x88, 0xfd, 0x8c, 0x02, 0x76, 0x00, 0x05, 0x00, 0x87,
+  0xff, 0x46, 0x05, 0xc3, 0x05, 0xfc, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x0f,
+  0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x13, 0x09, 0x01, 0x11, 0x09, 0x01,
+  0x03, 0x11, 0x09, 0x01, 0x11, 0x01, 0x03, 0x37, 0x01, 0x07, 0x11, 0x17,
+  0x01, 0x27, 0x01, 0x33, 0x11, 0x23, 0xee, 0x02, 0x37, 0x02, 0x37, 0xfd,
+  0xc9, 0xfd, 0xc9, 0x67, 0x02, 0x9e, 0x02, 0x9d, 0xfd, 0x63, 0x23, 0x34,
+  0x01, 0xae, 0x33, 0x33, 0xfe, 0x52, 0x34, 0xfe, 0x52, 0x67, 0x67, 0x01,
+  0x35, 0xfe, 0x95, 0x01, 0x6b, 0x02, 0xd8, 0x01, 0x6b, 0xfe, 0x95, 0xfc,
+  0xe6, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4, 0xfe, 0x53, 0x05,
+  0x41, 0x63, 0xfe, 0xec, 0x63, 0xfe, 0x5c, 0x63, 0xfe, 0xec, 0x63, 0x02,
+  0xfa, 0xfd, 0xd8, 0x00, 0xff, 0xff, 0x00, 0x95, 0x00, 0x00, 0x02, 0x30,
+  0x04, 0x60, 0x10, 0x06, 0x03, 0x4d, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x10, 0x06, 0x03, 0x55, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x79, 0xff, 0xe3, 0x05, 0x8a, 0x04, 0x60, 0x10, 0x06,
+  0x03, 0x5d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe7, 0x04, 0x67,
+  0x04, 0x79, 0x10, 0x06, 0x03, 0x45, 0x00, 0x00, 0x00, 0x01, 0x00, 0x17,
+  0xfe, 0x2e, 0x05, 0x5d, 0x00, 0xd0, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21,
+  0x11, 0x21, 0x15, 0x23, 0x11, 0x21, 0x11, 0x23, 0x35, 0x21, 0x01, 0x8c,
+  0x02, 0x5c, 0x01, 0x74, 0xdc, 0xfc, 0x74, 0xdd, 0x01, 0x75, 0xfe, 0xd8,
+  0x01, 0xf8, 0xaa, 0xfe, 0x08, 0x01, 0xf8, 0xaa, 0x00, 0x02, 0x00, 0x8c,
+  0x00, 0x00, 0x07, 0xe5, 0x05, 0xfb, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00,
+  0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x01, 0x21,
+  0x35, 0x21, 0x05, 0x35, 0x21, 0x15, 0x05, 0x4b, 0x01, 0x9d, 0xd1, 0x6c,
+  0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0xfe, 0xb3, 0xfd, 0x66, 0xfd, 0x8b,
+  0x02, 0x25, 0x02, 0x99, 0x02, 0x76, 0x04, 0x9a, 0xe9, 0x78, 0xfe, 0x77,
+  0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xfc, 0x10, 0xaa, 0xaa, 0xaa, 0xaa, 0x00,
+  0x00, 0x02, 0x00, 0x1f, 0x00, 0x00, 0x06, 0x2a, 0x05, 0xd0, 0x00, 0x05,
+  0x00, 0x0b, 0x00, 0x00, 0x25, 0x21, 0x09, 0x01, 0x21, 0x09, 0x03, 0x21,
+  0x09, 0x01, 0x01, 0xdd, 0x02, 0x8f, 0x01, 0x48, 0xfe, 0xb8, 0xfd, 0x71,
+  0xfe, 0xb8, 0x01, 0x0d, 0xfe, 0x7e, 0x01, 0x82, 0x03, 0x05, 0x01, 0x83,
+  0xfe, 0x7e, 0x72, 0x02, 0x76, 0x02, 0x76, 0xfd, 0x8a, 0xfd, 0x18, 0x02,
+  0xe8, 0x02, 0xe8, 0xfd, 0x18, 0xfd, 0x18, 0x00, 0x00, 0x01, 0x00, 0x9e,
+  0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x92, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23,
+  0x35, 0x10, 0x13, 0x12, 0x13, 0x33, 0x02, 0x03, 0x02, 0x11, 0x01, 0x4e,
+  0xb0, 0x90, 0xa8, 0x95, 0x90, 0xea, 0x51, 0x72, 0xfd, 0xfc, 0xea, 0x03,
+  0x97, 0x01, 0xe2, 0x02, 0x30, 0x01, 0x03, 0xfd, 0xf3, 0xfe, 0x86, 0xfd,
+  0xee, 0xfc, 0xed, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x01, 0x4e,
+  0x07, 0x89, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0x9e, 0xb0,
+  0xb0, 0x07, 0x89, 0xf6, 0x73, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e,
+  0xfe, 0x14, 0x02, 0xfc, 0x07, 0x89, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x15,
+  0x10, 0x13, 0x12, 0x13, 0x23, 0x02, 0x03, 0x02, 0x11, 0x35, 0x01, 0x4e,
+  0x72, 0x84, 0xb7, 0x90, 0xbb, 0x82, 0x90, 0x07, 0x89, 0xea, 0xfc, 0xa5,
+  0xfe, 0x57, 0xfe, 0x14, 0xfe, 0x65, 0x01, 0x45, 0x01, 0xee, 0x02, 0x26,
+  0x03, 0x32, 0xea, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x02, 0xfc,
+  0x07, 0x92, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35, 0x10, 0x03, 0x02, 0x03,
+  0x33, 0x12, 0x13, 0x12, 0x11, 0x15, 0x02, 0x4c, 0x73, 0x51, 0xea, 0x90,
+  0x96, 0xa7, 0x90, 0xfd, 0xfc, 0xea, 0x03, 0x13, 0x02, 0x12, 0x01, 0x79,
+  0x02, 0x0e, 0xfe, 0xfd, 0xfd, 0xd0, 0xfe, 0x1e, 0xfc, 0x69, 0xea, 0x00,
+  0x00, 0x01, 0x02, 0x4b, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x89, 0x00, 0x04,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x30, 0x02, 0xfb, 0xaf, 0x07, 0x89,
+  0xf6, 0x73, 0x09, 0x8d, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0x14, 0x02, 0xfc,
+  0x07, 0x89, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33, 0x15, 0x10, 0x03, 0x02,
+  0x03, 0x23, 0x12, 0x13, 0x12, 0x11, 0x02, 0x4c, 0xaf, 0x90, 0x81, 0xbc,
+  0x90, 0xb7, 0x84, 0x73, 0x07, 0x89, 0xea, 0xfc, 0xcd, 0xfd, 0xdb, 0xfe,
+  0x12, 0xfe, 0xbb, 0x01, 0x9b, 0x01, 0xec, 0x01, 0xa9, 0x03, 0x5b, 0x00,
+  0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x6d, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x23, 0x11, 0x21, 0x15, 0x21, 0x01, 0x4e, 0xb0, 0x02,
+  0x5d, 0xfe, 0x53, 0xfd, 0xfc, 0x09, 0x71, 0xc3, 0x00, 0x01, 0x00, 0x9e,
+  0xfd, 0xfc, 0x01, 0x4e, 0x07, 0x89, 0x00, 0x03, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x23, 0x9e, 0xb0, 0xb0, 0x07, 0x89, 0xf6, 0x73, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x9e, 0xfe, 0x14, 0x02, 0xfc, 0x07, 0x89, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x4e, 0x01, 0xad,
+  0xfd, 0xa3, 0x07, 0x89, 0xf7, 0x4e, 0xc3, 0x09, 0x75, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x9e, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x6d, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x02, 0x4c, 0xfe, 0x52,
+  0x02, 0x5d, 0xfd, 0xfc, 0x08, 0xae, 0xc3, 0xf6, 0x8f, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0x4b, 0xfd, 0xfc, 0x02, 0xfc, 0x07, 0x7a, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x02, 0x4c, 0xaf, 0xaf, 0x07, 0x7a,
+  0xf6, 0x82, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0x14, 0x02, 0xfc,
+  0x07, 0x7a, 0x00, 0x05, 0x00, 0x00, 0x01, 0x33, 0x11, 0x21, 0x35, 0x21,
+  0x02, 0x4c, 0xaf, 0xfd, 0xa3, 0x01, 0xae, 0x07, 0x7a, 0xf6, 0x9a, 0xc3,
+  0x00, 0x01, 0x02, 0x5f, 0xfd, 0xea, 0x04, 0xd0, 0x07, 0x6d, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x23, 0x11, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x07, 0x06, 0x15, 0x03, 0x07, 0xa7, 0x63, 0x6d, 0xa8, 0xf7, 0xfd,
+  0x5b, 0x3d, 0x33, 0xfd, 0xea, 0x07, 0x75, 0xdf, 0x91, 0x9e, 0xb0, 0x66,
+  0x57, 0x99, 0x00, 0x00, 0x00, 0x01, 0x00, 0x97, 0xfd, 0xfc, 0x03, 0x07,
+  0x07, 0x86, 0x00, 0x18, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x19, 0x01,
+  0x23, 0x11, 0x10, 0x27, 0x26, 0x2f, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36,
+  0x19, 0x01, 0x33, 0x11, 0x10, 0x07, 0x06, 0x02, 0x52, 0x34, 0x26, 0x5b,
+  0xa7, 0x64, 0x43, 0xeb, 0x37, 0x37, 0xe9, 0x45, 0x64, 0xa7, 0x5b, 0x24,
+  0x02, 0xc1, 0x20, 0x3d, 0x93, 0xfe, 0x43, 0xfd, 0xe8, 0x02, 0x0c, 0x01,
+  0xb7, 0x5f, 0x41, 0x04, 0x01, 0xbb, 0x45, 0x63, 0x01, 0xb3, 0x02, 0x0c,
+  0xfd, 0xe8, 0xfe, 0x48, 0x98, 0x3c, 0x00, 0x00, 0x00, 0x01, 0x02, 0x5f,
+  0xfe, 0x14, 0x04, 0xd0, 0x07, 0x86, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11,
+  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11,
+  0x03, 0x07, 0x33, 0x3d, 0x5b, 0xfd, 0xf7, 0xa6, 0x6f, 0x63, 0x07, 0x86,
+  0xf8, 0x94, 0x9a, 0x56, 0x66, 0xb0, 0x9e, 0x8f, 0xe1, 0x07, 0x64, 0x00,
+  0x00, 0x01, 0x02, 0x5f, 0xfd, 0xf4, 0x03, 0x07, 0x07, 0x8c, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x23, 0x11, 0x33, 0x03, 0x07, 0xa7, 0xa7, 0xfd, 0xf4,
+  0x09, 0x98, 0x00, 0x00, 0x00, 0x01, 0x00, 0x97, 0xfd, 0xea, 0x03, 0x07,
+  0x07, 0x6d, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x34, 0x27, 0x26, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x02, 0x60, 0x34, 0x3d,
+  0x5b, 0xfd, 0xf8, 0xa7, 0x6d, 0x64, 0xfd, 0xea, 0x07, 0x7d, 0x99, 0x57,
+  0x66, 0xb0, 0x9e, 0x91, 0xdf, 0xf8, 0x8b, 0x00, 0x00, 0x01, 0x02, 0x5f,
+  0xfd, 0xfc, 0x04, 0xd0, 0x07, 0x86, 0x00, 0x18, 0x00, 0x00, 0x01, 0x26,
+  0x27, 0x26, 0x19, 0x01, 0x33, 0x11, 0x10, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x07, 0x06, 0x07, 0x06, 0x19, 0x01, 0x23, 0x11, 0x10, 0x37, 0x36, 0x03,
+  0x14, 0x36, 0x24, 0x5a, 0xa7, 0x63, 0x45, 0xe9, 0x37, 0x37, 0xeb, 0x43,
+  0x63, 0xa7, 0x5a, 0x26, 0x02, 0xc1, 0x21, 0x3c, 0x98, 0x01, 0xb8, 0x02,
+  0x18, 0xfd, 0xf4, 0xfe, 0x4d, 0x63, 0x45, 0xbb, 0x01, 0x04, 0x41, 0x5f,
+  0xfe, 0x49, 0xfd, 0xf4, 0x02, 0x18, 0x01, 0xbd, 0x93, 0x3d, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x97, 0xfe, 0x14, 0x03, 0x07, 0x07, 0x86, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x02, 0x60, 0xa7, 0x64, 0x6f, 0xa5, 0xf8, 0xfd,
+  0x5b, 0x3d, 0x34, 0x07, 0x86, 0xf8, 0x9c, 0xe1, 0x8f, 0x9e, 0xb0, 0x66,
+  0x56, 0x9a, 0x00, 0x00, 0x00, 0x01, 0x01, 0x83, 0xfe, 0x00, 0x02, 0x37,
+  0x07, 0x89, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x01, 0x84,
+  0xb2, 0xfe, 0x00, 0x09, 0x89, 0xf6, 0x77, 0x00, 0x00, 0x02, 0x00, 0x31,
+  0x00, 0x86, 0x05, 0xa0, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x11, 0x00, 0x00,
+  0x25, 0x09, 0x01, 0x11, 0x21, 0x11, 0x21, 0x03, 0x21, 0x03, 0x35, 0x03,
+  0x13, 0x35, 0x21, 0x13, 0x23, 0x03, 0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9,
+  0x01, 0xfe, 0x01, 0xa7, 0x01, 0xfc, 0x5c, 0x5a, 0xf0, 0xf0, 0x03, 0xa4,
+  0x01, 0xf3, 0x01, 0x86, 0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0x02, 0x68,
+  0xfb, 0xc2, 0x01, 0x72, 0x83, 0xfe, 0xf6, 0xfe, 0xf6, 0x83, 0x03, 0x76,
+  0xfd, 0x98, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x27,
+  0x04, 0xc4, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x01, 0x21, 0x09, 0x01,
+  0x21, 0x11, 0x21, 0x06, 0x26, 0xfa, 0x81, 0x02, 0xbf, 0x02, 0xc0, 0xfa,
+  0x81, 0x05, 0x7f, 0x02, 0xa0, 0x02, 0x24, 0xfb, 0x3c, 0x01, 0xf8, 0x00,
+  0x00, 0x04, 0x00, 0x87, 0xff, 0x46, 0x05, 0xc3, 0x05, 0xfc, 0x00, 0x05,
+  0x00, 0x0b, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x00, 0x13, 0x09, 0x01, 0x11,
+  0x09, 0x01, 0x03, 0x11, 0x09, 0x01, 0x11, 0x01, 0x00, 0x14, 0x17, 0x16,
+  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x26, 0x27, 0x26,
+  0x22, 0x07, 0x06, 0x07, 0x02, 0x10, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x10,
+  0x0e, 0x01, 0x22, 0x26, 0xee, 0x02, 0x37, 0x02, 0x37, 0xfd, 0xc9, 0xfd,
+  0xc9, 0x67, 0x02, 0x9e, 0x02, 0x9d, 0xfd, 0x63, 0xfe, 0x96, 0x30, 0x31,
+  0x53, 0x53, 0xc5, 0x53, 0x53, 0x31, 0x30, 0x30, 0x31, 0x53, 0x53, 0xc5,
+  0x53, 0x53, 0x31, 0x97, 0x7c, 0xd7, 0xfc, 0xd6, 0x7c, 0x7c, 0xd6, 0xfc,
+  0xd7, 0x01, 0x35, 0xfe, 0x95, 0x01, 0x6b, 0x02, 0xd8, 0x01, 0x6b, 0xfe,
+  0x95, 0xfc, 0xe6, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4, 0xfe,
+  0x53, 0x03, 0xc8, 0xda, 0x5d, 0x5c, 0x36, 0x36, 0x36, 0x36, 0x5c, 0x5d,
+  0xda, 0x5d, 0x5c, 0x36, 0x36, 0x36, 0x36, 0x5c, 0xfe, 0xaa, 0x01, 0x18,
+  0xee, 0x8a, 0x8a, 0xee, 0xfe, 0xe8, 0xee, 0x8a, 0x8a, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x05, 0x00, 0x9a, 0x05, 0x85, 0x03, 0x8e, 0x10, 0x06,
+  0x0a, 0xda, 0x00, 0x00, 0x00, 0x03, 0x00, 0x50, 0xfe, 0xf7, 0x04, 0x54,
+  0x02, 0x5a, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x20, 0x00, 0x00, 0x00, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36, 0x35, 0x34, 0x2f,
+  0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
+  0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x03, 0x85, 0xb6, 0x2d, 0x2e,
+  0x2e, 0x2d, 0xb6, 0x2d, 0x2e, 0x2e, 0x88, 0x91, 0x99, 0x99, 0x91, 0x92,
+  0x99, 0x99, 0xfe, 0x81, 0xc9, 0xcf, 0x7b, 0x02, 0x01, 0x56, 0x56, 0xac,
+  0xad, 0x56, 0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4,
+  0xde, 0xde, 0xd4, 0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27,
+  0xfc, 0xbd, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8e, 0xff, 0xe3, 0x04, 0x2e,
+  0x06, 0x14, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x33,
+  0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x07,
+  0x27, 0x25, 0x35, 0x33, 0x15, 0x25, 0x17, 0x05, 0x00, 0x10, 0x26, 0x20,
+  0x06, 0x10, 0x16, 0x20, 0x01, 0x4e, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5,
+  0xb8, 0x6f, 0x9f, 0x34, 0xa7, 0xfa, 0x1e, 0x01, 0x18, 0xa7, 0x01, 0x06,
+  0x1e, 0xfe, 0xdc, 0x02, 0x33, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07,
+  0x03, 0xb6, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x64,
+  0xa8, 0x04, 0xe6, 0x5d, 0x63, 0x68, 0xc0, 0x83, 0x61, 0x61, 0x6d, 0xfc,
+  0x40, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x00, 0x01, 0x00, 0x83,
+  0xfe, 0x2e, 0x04, 0x0f, 0x00, 0xd0, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21,
+  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x01, 0x1b, 0x02, 0x5c, 0x98, 0xfc,
+  0x74, 0x98, 0xfe, 0xd8, 0x01, 0xf8, 0xfd, 0x5e, 0x02, 0xa2, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
+  0x00, 0x1b, 0x00, 0x26, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x01, 0x33,
+  0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x05, 0xec, 0xfe,
+  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
+  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
+  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x01, 0x56, 0xc3,
+  0xd5, 0xe8, 0x91, 0xc4, 0xfd, 0xd5, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41,
+  0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8,
+  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
+  0xb1, 0xfe, 0xb9, 0xfd, 0xff, 0x02, 0x7e, 0x2b, 0x98, 0x2f, 0xfc, 0xe6,
+  0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
+  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x38, 0x00, 0x00, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
+  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22,
+  0x04, 0x02, 0x01, 0x21, 0x15, 0x21, 0x35, 0x3e, 0x01, 0x37, 0x3e, 0x01,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x07, 0x0e, 0x01, 0x05, 0xec, 0xfe, 0x6c, 0xfe,
+  0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c,
+  0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01, 0x67, 0xa4,
+  0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x02, 0x13, 0x01, 0x89, 0xfd,
+  0x9f, 0x4a, 0xec, 0x1e, 0x37, 0x2b, 0x56, 0x46, 0x35, 0x77, 0x67, 0x57,
+  0x83, 0x36, 0x93, 0xb1, 0x2b, 0x38, 0x0f, 0xa0, 0x02, 0xea, 0xfe, 0xc1,
+  0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe,
+  0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01,
+  0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0xfd, 0xff, 0x8e, 0x81, 0x4d, 0xf1, 0x22,
+  0x3f, 0x55, 0x28, 0x3f, 0x4e, 0x26, 0x3a, 0xab, 0x24, 0x1f, 0x97, 0x7d,
+  0x3a, 0x69, 0x46, 0x12, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x44,
+  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
+  0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
+  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x05, 0x1e, 0x01, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x05,
+  0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c,
+  0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01,
+  0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x03,
+  0x59, 0x0c, 0x6a, 0xc2, 0xb0, 0x39, 0x7b, 0x4f, 0x52, 0x70, 0x3e, 0x69,
+  0x67, 0x60, 0x59, 0x7e, 0x83, 0x50, 0x50, 0x53, 0x52, 0x2f, 0x6d, 0x60,
+  0x55, 0x7b, 0x37, 0x91, 0xad, 0x5d, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41,
+  0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8,
+  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
+  0xb1, 0xfe, 0xb9, 0x96, 0x03, 0x81, 0x5d, 0x8d, 0x9c, 0x17, 0x1b, 0xa8,
+  0x30, 0x1c, 0x4f, 0x4c, 0x47, 0x4e, 0x8c, 0x3c, 0x3a, 0x3c, 0x3f, 0x15,
+  0x20, 0x97, 0x18, 0x14, 0x89, 0x73, 0x51, 0x72, 0x00, 0x04, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x1e,
+  0x00, 0x29, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
+  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x25, 0x03, 0x33, 0x03,
+  0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x21, 0x35, 0x05, 0xec,
+  0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab,
+  0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00,
+  0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x02, 0x78,
+  0xf2, 0xf2, 0x15, 0xb9, 0x7f, 0x7f, 0xa4, 0xfe, 0x70, 0x02, 0xea, 0xfe,
+  0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6,
+  0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3,
+  0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x4f, 0xfe, 0x82, 0x02, 0x48, 0xfd,
+  0xb8, 0x8d, 0xd3, 0xd3, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x39,
+  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
+  0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
+  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x01, 0x21, 0x15, 0x21, 0x15, 0x06,
+  0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35,
+  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01,
+  0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff,
+  0x01, 0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3,
+  0x01, 0x6f, 0x02, 0x03, 0xfe, 0x98, 0x03, 0x39, 0x1b, 0x9f, 0xba, 0xc0,
+  0xab, 0x39, 0x78, 0x4f, 0x55, 0x6c, 0x3d, 0x5d, 0x6a, 0x6a, 0x5d, 0x2d,
+  0x5b, 0x50, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f,
+  0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70,
+  0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x01,
+  0x19, 0x8e, 0xab, 0x01, 0x0a, 0xb0, 0x95, 0x98, 0xac, 0x14, 0x18, 0xac,
+  0x2f, 0x1b, 0x61, 0x55, 0x56, 0x61, 0x14, 0x25, 0x00, 0x04, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x27,
+  0x00, 0x40, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
+  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x05, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01,
+  0x23, 0x22, 0x06, 0x07, 0x06, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x12, 0x33, 0x32, 0x16, 0x05, 0xec, 0xfe,
+  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
+  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
+  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x02, 0x5d, 0x46,
+  0x53, 0x53, 0x46, 0x46, 0x53, 0x53, 0xbf, 0x4b, 0x58, 0x2a, 0x6b, 0x72,
+  0x05, 0x08, 0x73, 0x46, 0x90, 0xa8, 0xaf, 0x90, 0xa6, 0xad, 0xd2, 0xb4,
+  0x30, 0x60, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f,
+  0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70,
+  0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x9f,
+  0x62, 0x5b, 0x5a, 0x62, 0x62, 0x5a, 0x5b, 0x62, 0x01, 0x9d, 0x9c, 0x23,
+  0x16, 0x94, 0x50, 0x0b, 0x3d, 0xb1, 0x94, 0x91, 0xb3, 0xfd, 0xe7, 0xda,
+  0x01, 0x0b, 0x13, 0x00, 0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
+  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x22, 0x00, 0x00, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
+  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22,
+  0x04, 0x02, 0x01, 0x21, 0x15, 0x01, 0x23, 0x01, 0x21, 0x05, 0xec, 0xfe,
+  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
+  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
+  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0x01, 0x46, 0x02,
+  0x67, 0xfe, 0xb8, 0xad, 0x01, 0x2f, 0xfe, 0x5f, 0x02, 0xea, 0xfe, 0xc1,
+  0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe,
+  0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01,
+  0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0x01, 0x19, 0x4b, 0xfc, 0xa3, 0x03, 0x1a,
+  0x00, 0x05, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
+  0x00, 0x1b, 0x00, 0x27, 0x00, 0x3f, 0x00, 0x4b, 0x00, 0x00, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
+  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22,
+  0x04, 0x02, 0x05, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x25, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c,
+  0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67,
+  0x00, 0xff, 0x01, 0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe,
+  0xd9, 0xa3, 0x02, 0x6a, 0x4c, 0x55, 0x55, 0x4c, 0x4b, 0x56, 0x56, 0xfe,
+  0xe6, 0x04, 0x5f, 0xa4, 0x8e, 0x8d, 0xa4, 0x5f, 0x03, 0x0d, 0x6a, 0xaa,
+  0x9c, 0x9c, 0xab, 0x6a, 0x4f, 0x48, 0x46, 0x43, 0x4a, 0x4a, 0x43, 0x46,
+  0x48, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6,
+  0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01,
+  0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0xe6, 0x50,
+  0x49, 0x49, 0x50, 0x51, 0x48, 0x49, 0x50, 0x49, 0x01, 0x76, 0x53, 0x74,
+  0x88, 0x88, 0x74, 0x53, 0x76, 0x01, 0x03, 0x83, 0x5c, 0x8a, 0x97, 0x97,
+  0x8a, 0x5c, 0x83, 0xc1, 0x3d, 0x42, 0x42, 0x3d, 0x3e, 0x42, 0x42, 0x00,
+  0x00, 0x04, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
+  0x00, 0x1b, 0x00, 0x34, 0x00, 0x40, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02,
+  0x01, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x36, 0x06, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x02, 0x23, 0x22,
+  0x26, 0x13, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x16, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9,
+  0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00,
+  0xff, 0x01, 0x00, 0x01, 0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9,
+  0xa3, 0x01, 0x68, 0x4c, 0x57, 0x2a, 0x6b, 0x72, 0x05, 0x09, 0x74, 0x47,
+  0x8f, 0xa7, 0xae, 0x90, 0xa7, 0xac, 0xd2, 0xb4, 0x30, 0x60, 0xc3, 0x47,
+  0x52, 0x52, 0x47, 0x46, 0x53, 0x53, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41,
+  0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xc8,
+  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
+  0xb1, 0xfe, 0xb9, 0xfd, 0x8b, 0x9c, 0x24, 0x15, 0x93, 0x4f, 0x0d, 0x3c,
+  0xaf, 0x94, 0x91, 0xb4, 0xfd, 0xe8, 0xda, 0xfe, 0xf6, 0x13, 0x01, 0xb4,
+  0x62, 0x5b, 0x5b, 0x62, 0x62, 0x5b, 0x5b, 0x62, 0x00, 0x05, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x26,
+  0x00, 0x32, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x13, 0x33,
+  0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x01, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x05, 0xec, 0xfe,
+  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
+  0x01, 0x4c, 0xb9, 0xfa, 0xe8, 0x01, 0x67, 0x00, 0xff, 0x01, 0x00, 0x01,
+  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9c, 0xfe, 0xd9, 0xa3, 0xb8, 0x8e, 0x9b,
+  0xaa, 0x69, 0x8f, 0xfe, 0x6b, 0x02, 0xb7, 0x3a, 0x3e, 0x3e, 0x3a, 0x39,
+  0x3e, 0x3e, 0x39, 0x75, 0x7a, 0x7a, 0x75, 0x76, 0x7b, 0x7b, 0x02, 0xea,
+  0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6,
+  0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c,
+  0xb3, 0x01, 0x47, 0xb1, 0xb1, 0xfe, 0xb9, 0xfe, 0x3e, 0x02, 0x3e, 0x27,
+  0x89, 0x2a, 0xfd, 0x36, 0x80, 0x02, 0xde, 0x97, 0xa3, 0xa2, 0x97, 0x97,
+  0xa2, 0xa3, 0x97, 0x7b, 0xe4, 0xd1, 0xd0, 0xe4, 0xe4, 0xd0, 0xd1, 0xe4,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x12, 0x04, 0x7a, 0x01, 0xf0, 0xac,
+  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68,
+  0x02, 0xf2, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x04,
+  0x7a, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x00, 0x00, 0x01, 0x01, 0xe2,
+  0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x11, 0x01, 0xe2, 0x90, 0xfd, 0x96, 0x0a, 0x32, 0xf5, 0xce, 0x00,
+  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x01, 0x20, 0xfd, 0x96,
+  0x0a, 0x32, 0xf5, 0xce, 0x00, 0x03, 0xff, 0xee, 0x01, 0xf0, 0x04, 0x68,
+  0x02, 0x9c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35,
+  0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x03, 0x52,
+  0x01, 0x16, 0xfd, 0x3d, 0x01, 0x0b, 0xfd, 0x3e, 0x01, 0x15, 0x01, 0xf0,
+  0xac, 0xac, 0xac, 0xac, 0xac, 0xac, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee,
+  0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x03, 0x52, 0x01, 0x16, 0xfd, 0x3d, 0x01, 0x0b, 0xfd, 0x3e,
+  0x01, 0x15, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58, 0xfe, 0xa8,
+  0x01, 0x58, 0xfe, 0xa8, 0x00, 0x03, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73,
+  0x07, 0xc8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x01, 0xe2,
+  0x90, 0x90, 0x90, 0x90, 0x90, 0xfd, 0x96, 0x03, 0x0c, 0xfc, 0xf4, 0x03,
+  0xc0, 0x02, 0xb2, 0xfd, 0x4e, 0x03, 0x66, 0x03, 0x0c, 0xfc, 0xf4, 0x00,
+  0x00, 0x03, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11,
+  0x21, 0x11, 0x01, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x01, 0x20, 0xfe, 0xe0,
+  0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20, 0xfd, 0x96, 0x03, 0x0c, 0xfc, 0xf4,
+  0x03, 0xc0, 0x02, 0xb2, 0xfd, 0x4e, 0x03, 0x66, 0x03, 0x0c, 0xfc, 0xf4,
+  0x00, 0x04, 0xff, 0xed, 0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x35, 0x33, 0x15,
+  0x33, 0x35, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15,
+  0x13, 0xa9, 0xa2, 0xa1, 0xa2, 0xa1, 0xa2, 0xaa, 0x01, 0xf0, 0xac, 0xac,
+  0xac, 0xac, 0xac, 0xac, 0xac, 0xac, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
+  0x01, 0x9a, 0x04, 0x69, 0x02, 0xf2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x00, 0x03, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x12, 0xa9, 0xa2, 0xa1,
+  0xa2, 0xa0, 0xa2, 0xab, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58,
+  0xfe, 0xa8, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58, 0xfe, 0xa8, 0x00, 0x00,
+  0x00, 0x04, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
+  0x03, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
+  0x01, 0xe2, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x05, 0x96, 0x02,
+  0x32, 0xfd, 0xce, 0xf8, 0x00, 0x02, 0x32, 0xfd, 0xce, 0x05, 0x73, 0x01,
+  0xd9, 0xfe, 0x27, 0xfd, 0x73, 0x01, 0xd9, 0xfe, 0x27, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
+  0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11,
+  0x01, 0x9a, 0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20,
+  0xfe, 0xe0, 0x01, 0x20, 0x05, 0x96, 0x02, 0x32, 0xfd, 0xce, 0xf8, 0x00,
+  0x02, 0x32, 0xfd, 0xce, 0x05, 0x73, 0x01, 0xd9, 0xfe, 0x27, 0xfd, 0x73,
+  0x01, 0xd9, 0xfe, 0x27, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
+  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x01, 0xe2, 0x02, 0x86, 0xfe, 0x0a, 0xfd, 0x96, 0x05, 0x06, 0xac, 0xfb,
+  0xa6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
+  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x01, 0xe2, 0x02, 0x86, 0xfe, 0x0a, 0xfd, 0x96, 0x05, 0x5c, 0xfe, 0xa8,
+  0xfb, 0xfc, 0x00, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
+  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x01, 0x9a, 0x02, 0xce, 0xfe, 0x52, 0xfd, 0x96, 0x05, 0x06, 0xac, 0xfb,
+  0xa6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
+  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x01, 0x9a, 0x02, 0xce, 0xfe, 0x52, 0xfd, 0x96, 0x05, 0x5c, 0xfe, 0xa8,
+  0xfb, 0xfc, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73,
+  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x01, 0xe2, 0xfe, 0x0c, 0x02, 0x84, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xfa,
+  0xfa, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73,
+  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x01, 0xe2, 0xfe, 0x0c, 0x02, 0x84, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58,
+  0xfa, 0xa4, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
+  0x02, 0x9c, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x01, 0x9a, 0xfe, 0x54, 0x02, 0xcc, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xfa,
+  0xfa, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
+  0x02, 0xf2, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x01, 0x9a, 0xfe, 0x54, 0x02, 0xcc, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58,
+  0xfa, 0xa4, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0x01, 0xf0, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x05, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15,
+  0x01, 0xe2, 0x90, 0x01, 0xf6, 0x01, 0xf0, 0x05, 0xd8, 0xfa, 0xd4, 0xac,
+  0x00, 0x01, 0x01, 0xe2, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x01, 0xe2, 0x90, 0x01,
+  0xf6, 0x01, 0x9a, 0x06, 0x2e, 0xfb, 0x2a, 0xfe, 0xa8, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x9a, 0x01, 0xf0, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x01, 0x9a, 0x01, 0x20,
+  0x01, 0xae, 0x01, 0xf0, 0x05, 0xd8, 0xfa, 0xd4, 0xac, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x9a, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x01, 0x20,
+  0x01, 0xae, 0x01, 0x9a, 0x06, 0x2e, 0xfb, 0x2a, 0xfe, 0xa8, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x05,
+  0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x12, 0x01, 0xf4, 0x90,
+  0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa, 0x28, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x01, 0x9a, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x05, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x33, 0x11, 0x12, 0x01, 0xf4, 0x90, 0x01, 0x9a, 0x01, 0x58,
+  0x04, 0xd6, 0xf9, 0xd2, 0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0xbb,
+  0x07, 0xc8, 0x00, 0x05, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x12, 0x01, 0xac, 0x01, 0x20, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa, 0x28,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x05,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x21, 0x11, 0x12, 0x01, 0xac, 0x01,
+  0x20, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xf9, 0xd2, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2,
+  0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x0a, 0x32, 0xfa, 0xd4, 0xac,
+  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0xe2, 0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x0a,
+  0x32, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0x01, 0x9a,
+  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0x48, 0x01,
+  0x20, 0x01, 0xae, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0x05, 0xd8, 0xfa,
+  0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x01, 0x9a, 0x48, 0x90, 0x01, 0xf6, 0xfe, 0x52,
+  0xfd, 0x96, 0x05, 0x06, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00,
+  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a,
+  0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96, 0x0a, 0x32, 0xfa, 0xd4,
+  0xac, 0xfb, 0xa6, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x01, 0xe2, 0x48, 0x01, 0x20, 0x01, 0xae, 0xfe,
+  0x0a, 0xfd, 0x96, 0x04, 0x04, 0x06, 0x2e, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb,
+  0xfc, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0x48, 0x90, 0x01, 0xf6, 0xfe, 0x52,
+  0xfd, 0x96, 0x05, 0x5c, 0x04, 0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc,
+  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a,
+  0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96, 0x0a, 0x32, 0xfb, 0x2a,
+  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73,
+  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x33, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0x90, 0xfd, 0x96, 0x04,
+  0x5a, 0xac, 0x05, 0x2c, 0xf5, 0xce, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4,
+  0x90, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xf5, 0xce, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11,
+  0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xac, 0x01, 0x20, 0x48, 0xfd, 0x96, 0x04,
+  0x5a, 0xac, 0x05, 0x2c, 0xfa, 0x28, 0xfb, 0xa6, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x01, 0x9a, 0xfe, 0x54,
+  0x01, 0xf4, 0x90, 0x48, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xfa,
+  0xd4, 0xfa, 0xfa, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
+  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0xfd, 0x96,
+  0x04, 0x5a, 0xac, 0x05, 0x2c, 0xf5, 0xce, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x01, 0xe2, 0xfe, 0x0c,
+  0x01, 0xac, 0x01, 0x20, 0x48, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04,
+  0xd6, 0xf9, 0xd2, 0xfb, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x01, 0x9a, 0xfe, 0x54,
+  0x01, 0xf4, 0x90, 0x48, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6,
+  0xfb, 0x2a, 0xfa, 0xa4, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0xbb,
+  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0xfd, 0x96,
+  0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xf5, 0xce, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x04, 0x7a,
+  0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xac, 0xfb, 0xa6, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11,
+  0x01, 0xe2, 0xfe, 0x0c, 0x02, 0x84, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96,
+  0x04, 0x04, 0x01, 0x58, 0x56, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c,
+  0x01, 0xf4, 0x02, 0x86, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x56,
+  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x02, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x04, 0x7a, 0xfe, 0x0a, 0xfd, 0x96,
+  0x04, 0x04, 0x01, 0x58, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x04, 0x7a,
+  0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xac, 0xfb, 0xa6, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11,
+  0x01, 0x9a, 0xfe, 0x54, 0x02, 0xcc, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96,
+  0x04, 0x04, 0x01, 0x58, 0x56, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54,
+  0x01, 0xac, 0x02, 0xce, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x56,
+  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x02, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x04, 0x7a, 0xfe, 0x52, 0xfd, 0x96,
+  0x04, 0x04, 0x01, 0x58, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee,
+  0x01, 0xf0, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x03, 0x35,
+  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x01, 0xf4, 0x90, 0x01, 0xf6,
+  0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x01, 0xff, 0xee,
+  0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x12, 0x01, 0xf4, 0x90,
+  0x01, 0xf6, 0xfe, 0x0a, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfa, 0xd4,
+  0xac, 0x56, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x21, 0x35, 0x12, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfd, 0x7a,
+  0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0x56, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x12, 0x01,
+  0xf4, 0x90, 0x01, 0xf6, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a,
+  0xfe, 0xa8, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x15, 0x12, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0x01, 0xf0, 0xac,
+  0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x12, 0x01, 0xac, 0x01,
+  0x20, 0x01, 0xae, 0xfe, 0x52, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfa,
+  0xd4, 0xac, 0x56, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x21, 0x35, 0x12, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0xfd,
+  0x32, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0x56, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x07,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x12, 0x01,
+  0xac, 0x01, 0x20, 0x01, 0xae, 0x01, 0x9a, 0x01, 0x58, 0x04, 0xd6, 0xfb,
+  0x2a, 0xfe, 0xa8, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x02, 0x72, 0x90, 0xfe, 0x0c, 0x01,
+  0xf4, 0x90, 0x01, 0xf6, 0x01, 0xf0, 0xfb, 0xa6, 0x04, 0x5a, 0xac, 0x05,
+  0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4,
+  0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04,
+  0xd6, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0xe2,
+  0xfe, 0x0c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x04,
+  0x5a, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe,
+  0x0a, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a, 0xfe,
+  0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xac,
+  0x01, 0x20, 0x01, 0xae, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05,
+  0x2c, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a,
+  0xfe, 0x54, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe, 0x52, 0xfd, 0x96, 0x04,
+  0x5a, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x21, 0x15,
+  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae,
+  0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0xac,
+  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x21, 0x15, 0x21, 0x15, 0x23, 0x11, 0x01, 0xe2, 0xfe, 0x0c,
+  0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0x48, 0xfd, 0x96, 0x04,
+  0x04, 0x01, 0x58, 0x04, 0xd6, 0xfa, 0xd4, 0xac, 0x56, 0xfb, 0xfc, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x35, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x01, 0xe2, 0x48, 0xfe, 0x54, 0x01, 0xac, 0x01,
+  0x20, 0x01, 0xae, 0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x04, 0x56, 0xac, 0x05,
+  0x2c, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x21, 0x15, 0x21, 0x11,
+  0x01, 0x9a, 0xfe, 0x54, 0x01, 0xf4, 0x90, 0x48, 0x01, 0xae, 0xfe, 0x52,
+  0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a, 0x56, 0xac,
+  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35,
+  0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54,
+  0x01, 0xac, 0x48, 0x90, 0x01, 0xf6, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a,
+  0xac, 0x56, 0x04, 0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae,
+  0xfe, 0x0a, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfb, 0x2a,
+  0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xf4,
+  0x90, 0x01, 0xf6, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58, 0x04,
+  0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0x9a,
+  0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96,
+  0x04, 0x04, 0x01, 0x58, 0x04, 0xd6, 0xfa, 0xd4, 0xac, 0xfb, 0xa6, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x20, 0x01, 0xae,
+  0xfe, 0x52, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xfb, 0x2a, 0xfe,
+  0xa8, 0xfb, 0xfc, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x01, 0x9a, 0xfe, 0x54, 0x01, 0xac,
+  0x01, 0x20, 0x01, 0xae, 0xfe, 0x52, 0xfd, 0x96, 0x04, 0x04, 0x01, 0x58,
+  0x04, 0xd6, 0xfb, 0x2a, 0xfe, 0xa8, 0xfb, 0xfc, 0x00, 0x02, 0xff, 0xee,
+  0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x03, 0x35, 0x21, 0x15, 0x33, 0x35, 0x21, 0x15, 0x12, 0x01, 0xf4, 0x90,
+  0x01, 0xf6, 0x01, 0xf0, 0xac, 0xac, 0xac, 0xac, 0x00, 0x02, 0xff, 0xee,
+  0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x02, 0x72, 0x01, 0xf6,
+  0xfb, 0x86, 0x01, 0xf4, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x01, 0x58,
+  0xfe, 0xa8, 0x00, 0x00, 0x00, 0x02, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73,
+  0x07, 0xc8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
+  0x03, 0x11, 0x33, 0x11, 0x01, 0xe2, 0x90, 0x90, 0x90, 0x02, 0xf2, 0x04,
+  0xd6, 0xfb, 0x2a, 0xfa, 0xa4, 0x04, 0x04, 0xfb, 0xfc, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11,
+  0x01, 0x9a, 0x01, 0x20, 0xfe, 0xe0, 0x01, 0x20, 0x02, 0xf2, 0x04, 0xd6,
+  0xfb, 0x2a, 0xfa, 0xa4, 0x04, 0x04, 0xfb, 0xfc, 0x00, 0x02, 0xff, 0xee,
+  0x01, 0x44, 0x04, 0x68, 0x03, 0x48, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x03, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x12, 0x04, 0x7a, 0xfb,
+  0x86, 0x04, 0x7a, 0x02, 0x9c, 0xac, 0xac, 0xfe, 0xa8, 0xac, 0xac, 0x00,
+  0x00, 0x02, 0x01, 0x52, 0xfd, 0x96, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x01, 0x52, 0x90, 0x90, 0x90, 0xfd, 0x96, 0x0a, 0x32, 0xf5, 0xce, 0x0a,
+  0x32, 0xf5, 0xce, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
+  0x03, 0x48, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x15,
+  0x21, 0x15, 0x21, 0x11, 0x01, 0xe2, 0x02, 0x86, 0xfe, 0x0a, 0x01, 0xf6,
+  0xfe, 0x0a, 0xfd, 0x96, 0x05, 0xb2, 0xac, 0xac, 0xac, 0xfc, 0x52, 0x00,
+  0x00, 0x01, 0x01, 0x52, 0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11,
+  0x01, 0x52, 0x03, 0x16, 0xfe, 0x9a, 0x90, 0x90, 0xfd, 0x96, 0x05, 0x06,
+  0xac, 0xfb, 0xa6, 0x04, 0x5a, 0xfb, 0xa6, 0x00, 0x00, 0x02, 0x01, 0x52,
+  0xfd, 0x96, 0x04, 0x68, 0x03, 0x48, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00,
+  0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x01, 0x52, 0x03, 0x16, 0xfd, 0x7a, 0x90, 0x01, 0xf6, 0xfe, 0x9a, 0xfd,
+  0x96, 0x05, 0xb2, 0xac, 0xfa, 0xfa, 0x04, 0x5a, 0xac, 0xfc, 0x52, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73, 0x03, 0x48, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11,
+  0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0xfe, 0x0c, 0x02, 0x84, 0xfd, 0x96,
+  0x03, 0xae, 0xac, 0xac, 0xac, 0xfa, 0x4e, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x03, 0x03, 0x02, 0x9c, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35,
+  0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x12, 0x03, 0x14, 0x90,
+  0x90, 0x90, 0x01, 0xf0, 0xac, 0xfa, 0xfa, 0x04, 0x5a, 0xfb, 0xa6, 0x04,
+  0x5a, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0xfd, 0x96, 0x03, 0x03,
+  0x03, 0x48, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x02, 0x72, 0xfd, 0x7c,
+  0x03, 0x14, 0xfe, 0x50, 0xfe, 0x9c, 0x01, 0xf4, 0xfd, 0x96, 0x05, 0x06,
+  0xac, 0xfa, 0x4e, 0x03, 0xae, 0xac, 0xfb, 0xa6, 0x00, 0x01, 0x01, 0xe2,
+  0x01, 0x44, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x01, 0xe2, 0x90, 0x01,
+  0xf6, 0xfe, 0x0a, 0x01, 0xf6, 0x01, 0x44, 0x06, 0x84, 0xfb, 0x80, 0xac,
+  0xac, 0xac, 0x00, 0x00, 0x00, 0x01, 0x01, 0x52, 0x01, 0xf0, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x01, 0x52, 0x90, 0x90, 0x90, 0x01, 0x66, 0x01,
+  0xf0, 0x05, 0xd8, 0xfa, 0xd4, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x52, 0x01, 0x44, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05,
+  0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15, 0x01, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x02, 0x72, 0x90, 0x01, 0x66, 0xfc, 0xea, 0x90,
+  0x02, 0x86, 0x02, 0x9c, 0x05, 0x2c, 0xfb, 0x80, 0xac, 0xfe, 0xa8, 0x06,
+  0x84, 0xfa, 0x28, 0xac, 0x00, 0x01, 0xff, 0xee, 0x01, 0x44, 0x02, 0x73,
+  0x07, 0xc8, 0x00, 0x09, 0x00, 0x00, 0x03, 0x35, 0x21, 0x35, 0x21, 0x35,
+  0x21, 0x11, 0x33, 0x11, 0x12, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0xf4, 0x90,
+  0x01, 0x44, 0xac, 0xac, 0xac, 0x04, 0x80, 0xf9, 0x7c, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x09,
+  0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x12, 0x01, 0x64, 0x90, 0x90, 0x90, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa,
+  0xd4, 0x05, 0x2c, 0xfa, 0x28, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0x01, 0x44, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00,
+  0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x12, 0x01, 0x64, 0x90, 0xfe, 0x0c, 0x02, 0x84, 0x90, 0x02, 0x9c, 0xac,
+  0x04, 0x80, 0xfa, 0xd4, 0xfe, 0xa8, 0xac, 0x05, 0xd8, 0xf9, 0x7c, 0x00,
+  0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15,
+  0x21, 0x11, 0x01, 0xe2, 0x90, 0x01, 0xf6, 0xfe, 0x0a, 0x01, 0xf6, 0xfe,
+  0x0a, 0xfd, 0x96, 0x0a, 0x32, 0xfb, 0x80, 0xac, 0xac, 0xac, 0xfc, 0x52,
+  0x00, 0x02, 0x01, 0x52, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x03,
+  0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x01, 0x52, 0x90, 0x90, 0x90, 0x01, 0x66, 0xfe,
+  0x9a, 0xfd, 0x96, 0x0a, 0x32, 0xf5, 0xce, 0x0a, 0x32, 0xfa, 0xd4, 0xac,
+  0xfb, 0xa6, 0x00, 0x00, 0x00, 0x03, 0x01, 0x52, 0xfd, 0x96, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15,
+  0x21, 0x11, 0x02, 0x72, 0x90, 0x01, 0x66, 0xfc, 0xea, 0x90, 0x90, 0x01,
+  0xf6, 0xfe, 0x9a, 0x02, 0x9c, 0x05, 0x2c, 0xfb, 0x80, 0xac, 0xfa, 0xfa,
+  0x0a, 0x32, 0xf5, 0xce, 0x04, 0x5a, 0xac, 0xfc, 0x52, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x02, 0x73, 0x07, 0xc8, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11,
+  0x33, 0x11, 0x01, 0xe2, 0xfe, 0x0c, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0xf4,
+  0x90, 0xfd, 0x96, 0x03, 0xae, 0xac, 0xac, 0xac, 0x04, 0x80, 0xf5, 0xce,
+  0x00, 0x02, 0xff, 0xee, 0xfd, 0x96, 0x03, 0x03, 0x07, 0xc8, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x33, 0x11, 0x01, 0x52, 0xfe, 0x9c, 0x01, 0x64, 0x90, 0x90,
+  0x90, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0x05, 0x2c, 0xf5, 0xce, 0x0a, 0x32,
+  0xf5, 0xce, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee, 0xfd, 0x96, 0x03, 0x03,
+  0x07, 0xc8, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x35,
+  0x21, 0x11, 0x33, 0x11, 0x03, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x12, 0x01, 0x64, 0x90, 0x90, 0xfe, 0x9c, 0x01, 0xf4, 0x90,
+  0x90, 0x02, 0x9c, 0xac, 0x04, 0x80, 0xfa, 0xd4, 0xfa, 0xfa, 0x03, 0xae,
+  0xac, 0xfb, 0xa6, 0x0a, 0x32, 0xf5, 0xce, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x03, 0x48, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00,
+  0x01, 0x11, 0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x01, 0x35, 0x21, 0x15,
+  0x01, 0xe2, 0xfe, 0x0c, 0x04, 0x7a, 0xfe, 0x0a, 0xfd, 0x7c, 0x04, 0x7a,
+  0xfd, 0x96, 0x03, 0xae, 0xac, 0xac, 0xfc, 0x52, 0x05, 0x06, 0xac, 0xac,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x0b,
+  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11,
+  0x23, 0x11, 0x12, 0x04, 0x7a, 0xfe, 0x9a, 0x90, 0x90, 0x90, 0x01, 0xf0,
+  0xac, 0xac, 0xfb, 0xa6, 0x04, 0x5a, 0xfb, 0xa6, 0x04, 0x5a, 0x00, 0x00,
+  0x00, 0x03, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x03, 0x48, 0x00, 0x03,
+  0x00, 0x09, 0x00, 0x0f, 0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x12, 0x04,
+  0x7a, 0xfc, 0xea, 0xfe, 0x9c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe, 0x9a,
+  0x02, 0x9c, 0xac, 0xac, 0xfa, 0xfa, 0x03, 0xae, 0xac, 0xfb, 0xa6, 0x04,
+  0x5a, 0xac, 0xfc, 0x52, 0x00, 0x02, 0xff, 0xee, 0x01, 0x44, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x03, 0x35, 0x21, 0x15,
+  0x01, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x04, 0x7a, 0xfb,
+  0x86, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0x01, 0x44, 0xac, 0xac, 0x01, 0x58,
+  0xac, 0x04, 0x80, 0xfb, 0x80, 0xac, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x01, 0xf0, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x03, 0x35,
+  0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x01,
+  0x64, 0x90, 0x90, 0x90, 0x01, 0x66, 0x01, 0xf0, 0xac, 0x05, 0x2c, 0xfa,
+  0xd4, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee,
+  0x01, 0x44, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x09, 0x00, 0x0f,
+  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x33, 0x11, 0x21, 0x15, 0x12, 0x04, 0x7a, 0xfb, 0x86, 0x01,
+  0x64, 0x90, 0x90, 0x90, 0x01, 0x66, 0x01, 0x44, 0xac, 0xac, 0x01, 0x58,
+  0xac, 0x04, 0x80, 0xfa, 0xd4, 0x05, 0x2c, 0xfb, 0x80, 0xac, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x01, 0xe2,
+  0xfe, 0x0c, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0xf4, 0x90, 0x01, 0xf6, 0xfe,
+  0x0a, 0x01, 0xf6, 0xfe, 0x0a, 0xfd, 0x96, 0x03, 0xae, 0xac, 0xac, 0xac,
+  0x04, 0x80, 0xfb, 0x80, 0xac, 0xac, 0xac, 0xfc, 0x52, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x13,
+  0x00, 0x00, 0x03, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x12, 0x01,
+  0x64, 0x90, 0x90, 0x90, 0x01, 0x66, 0xfe, 0x9a, 0x90, 0x90, 0x90, 0x01,
+  0xf0, 0xac, 0x05, 0x2c, 0xfa, 0xd4, 0x05, 0x2c, 0xfa, 0xd4, 0xac, 0xfb,
+  0xa6, 0x04, 0x5a, 0xfb, 0xa6, 0x04, 0x5a, 0x00, 0x00, 0x04, 0xff, 0xee,
+  0xfd, 0x96, 0x04, 0x68, 0x07, 0xc8, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x11,
+  0x00, 0x17, 0x00, 0x00, 0x01, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x01, 0x35, 0x21, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x02, 0x72, 0x01, 0xf6, 0xfe, 0x9a, 0xfe, 0x50,
+  0xfe, 0x9c, 0x01, 0xf4, 0xfe, 0x0c, 0x01, 0x64, 0x90, 0x90, 0x90, 0x01,
+  0x66, 0xfd, 0x96, 0x04, 0x5a, 0xac, 0xfc, 0x52, 0x03, 0xae, 0xac, 0xfb,
+  0xa6, 0x05, 0x06, 0xac, 0x04, 0x80, 0xfa, 0xd4, 0x05, 0x2c, 0xfb, 0x80,
+  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x04, 0x68,
+  0x02, 0x9c, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x11, 0x34, 0x37, 0x36, 0x33,
+  0x21, 0x15, 0x21, 0x22, 0x06, 0x15, 0x11, 0x01, 0xe2, 0x49, 0x52, 0x97,
+  0x01, 0x54, 0xfe, 0xac, 0x50, 0x52, 0xfd, 0x96, 0x03, 0x60, 0xa1, 0x7f,
+  0x86, 0xac, 0x7e, 0x7c, 0xfc, 0xa0, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfd, 0x96, 0x02, 0x73, 0x02, 0x9c, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11,
+  0x34, 0x27, 0x26, 0x23, 0x21, 0x35, 0x21, 0x32, 0x17, 0x16, 0x15, 0x11,
+  0x01, 0xe2, 0x29, 0x29, 0x50, 0xfe, 0xae, 0x01, 0x52, 0x98, 0x51, 0x49,
+  0xfd, 0x96, 0x03, 0x60, 0x7e, 0x3d, 0x3f, 0xac, 0x86, 0x78, 0xa8, 0xfc,
+  0xa0, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0x73,
+  0x07, 0xc8, 0x00, 0x0c, 0x00, 0x00, 0x03, 0x35, 0x21, 0x32, 0x36, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x23, 0x12, 0x01, 0x52, 0x50, 0x52,
+  0x90, 0x49, 0x51, 0x98, 0x01, 0xf0, 0xac, 0x7e, 0x7c, 0x04, 0x32, 0xfb,
+  0xce, 0xa8, 0x78, 0x86, 0x00, 0x01, 0x01, 0xe2, 0x01, 0xf0, 0x04, 0x68,
+  0x07, 0xc8, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x21, 0x22, 0x27, 0x26, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x21, 0x04, 0x68, 0xfe, 0xac, 0x97,
+  0x52, 0x49, 0x90, 0x52, 0x50, 0x01, 0x54, 0x01, 0xf0, 0x86, 0x78, 0xa8,
+  0x04, 0x32, 0xfb, 0xce, 0x7c, 0x7e, 0x00, 0x00, 0x00, 0x01, 0xff, 0x9d,
+  0xfd, 0x96, 0x04, 0xb8, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x03, 0x01,
+  0x33, 0x01, 0x62, 0x04, 0x7a, 0xa0, 0xfb, 0x86, 0xfd, 0x96, 0x0a, 0x32,
+  0xf5, 0xce, 0x00, 0x00, 0x00, 0x01, 0xff, 0x9d, 0xfd, 0x96, 0x04, 0xb8,
+  0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x23, 0x01, 0x33, 0x04, 0xb8,
+  0xa0, 0xfb, 0x86, 0xa0, 0xfd, 0x96, 0x0a, 0x32, 0x00, 0x01, 0xff, 0x9d,
+  0xfd, 0x96, 0x04, 0xb8, 0x07, 0xc8, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23,
+  0x09, 0x01, 0x23, 0x09, 0x01, 0x33, 0x09, 0x01, 0x33, 0x01, 0x04, 0xb8,
+  0xa0, 0xfe, 0x12, 0xfe, 0x14, 0xa0, 0x02, 0x3d, 0xfd, 0xc3, 0xa0, 0x01,
+  0xec, 0x01, 0xee, 0xa0, 0xfd, 0xc3, 0xfd, 0x96, 0x04, 0x63, 0xfb, 0x9d,
+  0x05, 0x19, 0x05, 0x19, 0xfb, 0x9d, 0x04, 0x63, 0xfa, 0xe7, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0xf0, 0x02, 0x3d, 0x02, 0x9c, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x35, 0x21, 0x15, 0x12, 0x02, 0x4e, 0x01, 0xf0, 0xac,
+  0xac, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe2, 0x02, 0x46, 0x02, 0x73,
+  0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x01, 0xe2,
+  0x90, 0x02, 0x46, 0x05, 0x82, 0xfa, 0x7e, 0x00, 0x00, 0x01, 0x02, 0x3c,
+  0x01, 0xf0, 0x04, 0x68, 0x02, 0x9c, 0x00, 0x03, 0x00, 0x00, 0x01, 0x35,
+  0x21, 0x15, 0x02, 0x3c, 0x02, 0x2c, 0x01, 0xf0, 0xac, 0xac, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0xe2, 0xfd, 0x96, 0x02, 0x73, 0x02, 0x46, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x01, 0xe2, 0x90, 0xfd, 0x96, 0x04,
+  0xb0, 0xfb, 0x50, 0x00, 0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x02, 0x3d,
+  0x02, 0xf2, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x02,
+  0x4e, 0x01, 0x9a, 0x01, 0x58, 0xfe, 0xa8, 0x00, 0x00, 0x01, 0x01, 0x9a,
+  0x02, 0x46, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x01, 0x9a, 0x01, 0x20, 0x02, 0x46, 0x05, 0x82, 0xfa, 0x7e,
+  0x00, 0x01, 0x02, 0x3c, 0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x02, 0x3c, 0x02, 0x2c, 0x01, 0x9a,
+  0x01, 0x58, 0xfe, 0xa8, 0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb,
+  0x02, 0x46, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x9a,
+  0x01, 0x20, 0xfd, 0x96, 0x04, 0xb0, 0xfb, 0x50, 0x00, 0x01, 0xff, 0xee,
+  0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x03, 0x35,
+  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x12, 0x02, 0x4e, 0x02, 0x2c, 0xfd,
+  0xd4, 0x01, 0xf0, 0xac, 0x56, 0xfe, 0xa8, 0x56, 0x00, 0x01, 0x01, 0x9a,
+  0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x01, 0x9a, 0x48, 0x90, 0x48, 0xfd,
+  0x96, 0x04, 0xb0, 0x05, 0x82, 0xfa, 0x7e, 0xfb, 0x50, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x01, 0x9a, 0x04, 0x68, 0x02, 0xf2, 0x00, 0x07,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x12, 0x02,
+  0x4e, 0x02, 0x2c, 0xfd, 0xd4, 0x01, 0x9a, 0x01, 0x58, 0x56, 0xac, 0x56,
+  0x00, 0x01, 0x01, 0x9a, 0xfd, 0x96, 0x02, 0xbb, 0x07, 0xc8, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x01, 0xe2,
+  0x48, 0x01, 0x20, 0x48, 0xfd, 0x96, 0x04, 0xb0, 0x05, 0x82, 0xfa, 0x7e,
+  0xfb, 0x50, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x02, 0x14, 0x05, 0x9c,
+  0x06, 0x28, 0x10, 0x07, 0x0a, 0xad, 0x00, 0x00, 0x04, 0x14, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0xff, 0x05, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x01,
+  0x05, 0xfe, 0xfb, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
+  0xff, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05,
+  0xae, 0xfe, 0x00, 0x01, 0xf6, 0xfe, 0x0a, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x05, 0x9c, 0x01, 0x0f, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x03, 0x0f, 0xfc, 0xf1, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x02, 0x14, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x04,
+  0x14, 0xfb, 0xec, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
+  0x03, 0x19, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05,
+  0xae, 0xfe, 0x00, 0x05, 0x19, 0xfa, 0xe7, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x05, 0x9c, 0x04, 0x1e, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x06, 0x1e, 0xf9, 0xe2, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x05, 0x23, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05, 0xae, 0xfe, 0x00, 0x07,
+  0x23, 0xf8, 0xdd, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
+  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x05,
+  0xae, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x04, 0xe6, 0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x12, 0x04, 0xf8, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x04, 0x30, 0x06, 0x28, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x04, 0x42, 0xfe, 0x00, 0x08,
+  0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x03, 0x7b,
+  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x03,
+  0x8c, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x02, 0xc5, 0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x12, 0x02, 0xd6, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x02, 0x0f, 0x06, 0x28, 0x00, 0x03,
+  0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x02, 0x20, 0xfe, 0x00, 0x08,
+  0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x01, 0x59,
+  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x01,
+  0x6b, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x00, 0xa3, 0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
+  0x33, 0x11, 0x12, 0xb5, 0xfe, 0x00, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00,
+  0xff, 0xff, 0x02, 0xc4, 0xfe, 0x00, 0x05, 0x9b, 0x06, 0x28, 0x10, 0x07,
+  0x0a, 0xb5, 0x02, 0xd6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0xff, 0xee,
+  0xfe, 0x00, 0x04, 0xe6, 0x06, 0x28, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23,
+  0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x33, 0x11, 0x13, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11,
+  0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x13, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11,
+  0x13, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x04, 0x30, 0xb6, 0xfc,
+  0x73, 0xb5, 0xb6, 0xb6, 0xfc, 0x74, 0xb5, 0x03, 0x8d, 0xb6, 0xfc, 0x73,
+  0xb5, 0xb6, 0xb6, 0xfc, 0x74, 0xb5, 0x03, 0x8d, 0xb6, 0xfc, 0x73, 0xb5,
+  0xb6, 0xb6, 0xfc, 0x74, 0xb5, 0xfe, 0x00, 0x01, 0x05, 0xfe, 0xfb, 0x01,
+  0x05, 0xfe, 0xfb, 0x01, 0x6d, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe,
+  0xfb, 0x01, 0x6e, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x01,
+  0x6d, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x6e, 0x01,
+  0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x6d, 0x01, 0x05, 0xfe,
+  0xfb, 0x01, 0x05, 0xfe, 0xfb, 0x00, 0x00, 0x00, 0x00, 0x20, 0xff, 0xee,
+  0xfe, 0x00, 0x05, 0x96, 0x06, 0x28, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x17,
+  0x00, 0x1f, 0x00, 0x27, 0x00, 0x2f, 0x00, 0x37, 0x00, 0x3f, 0x00, 0x47,
+  0x00, 0x4f, 0x00, 0x57, 0x00, 0x5f, 0x00, 0x67, 0x00, 0x6f, 0x00, 0x77,
+  0x00, 0x7f, 0x00, 0x87, 0x00, 0x8f, 0x00, 0x97, 0x00, 0x9f, 0x00, 0xa7,
+  0x00, 0xaf, 0x00, 0xb7, 0x00, 0xbf, 0x00, 0xc7, 0x00, 0xcf, 0x00, 0xd7,
+  0x00, 0xdf, 0x00, 0xe7, 0x00, 0xef, 0x00, 0xf7, 0x00, 0xff, 0x00, 0x00,
+  0x13, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x01, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x01, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17,
+  0x05, 0x07, 0x23, 0x27, 0x35, 0x37, 0x33, 0x17, 0x05, 0x07, 0x23, 0x27,
+  0x35, 0x37, 0x33, 0x17, 0xa3, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
+  0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x04,
+  0x04, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfc,
+  0x78, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04,
+  0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x01,
+  0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfb, 0x0e, 0x05, 0xac, 0x04,
+  0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
+  0x69, 0x04, 0xac, 0x04, 0x04, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05,
+  0x05, 0xac, 0x04, 0xfc, 0x78, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
+  0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x05,
+  0x05, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfb,
+  0x0e, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04,
+  0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x04, 0x04, 0xac, 0x04, 0x01,
+  0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfc, 0x78, 0x05, 0xac, 0x04,
+  0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
+  0x69, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05,
+  0x05, 0xac, 0x04, 0xfb, 0x0e, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01,
+  0x6a, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x04,
+  0x04, 0xac, 0x04, 0x01, 0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0xfc,
+  0x78, 0x05, 0xac, 0x04, 0x04, 0xac, 0x05, 0x01, 0x6a, 0x05, 0xac, 0x04,
+  0x04, 0xac, 0x05, 0x01, 0x69, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x01,
+  0x6a, 0x04, 0xac, 0x05, 0x05, 0xac, 0x04, 0x05, 0x28, 0x05, 0x05, 0xfb,
+  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
+  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe, 0x00, 0x05, 0x05,
+  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
+  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe, 0x00, 0x05,
+  0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05,
+  0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe, 0x00,
+  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
+  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfe,
+  0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
+  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
+  0xfe, 0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05,
+  0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05,
+  0x05, 0xfe, 0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
+  0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb,
+  0x05, 0x05, 0xfe, 0x00, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
+  0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05, 0xfb, 0x05, 0x05,
+  0xfb, 0x05, 0x05, 0x00, 0x00, 0x07, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
+  0x06, 0x28, 0x00, 0x19, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x25, 0x00, 0x29,
+  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x03, 0x11, 0x33, 0x11, 0x23, 0x11,
+  0x33, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x19, 0x01, 0x33, 0x11, 0x23,
+  0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23,
+  0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0x12, 0xb5, 0xb5, 0xb5,
+  0xb5, 0xb5, 0x02, 0x21, 0xb6, 0x02, 0x22, 0xb6, 0xb6, 0xfd, 0xde, 0xb5,
+  0xb5, 0xb5, 0x02, 0xd7, 0xb6, 0xb6, 0xfe, 0x94, 0xb6, 0xb6, 0xfe, 0x95,
+  0xb5, 0xb5, 0x02, 0xd7, 0xb6, 0xb6, 0xfe, 0x94, 0xb6, 0xb6, 0xfe, 0x00,
+  0x01, 0x6d, 0x01, 0x05, 0x01, 0xd6, 0x01, 0x05, 0x01, 0xd6, 0x01, 0x05,
+  0xfe, 0xfb, 0x01, 0x05, 0xf7, 0xd8, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05,
+  0xfe, 0xfb, 0x05, 0xb6, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfd, 0x8d,
+  0x01, 0x05, 0xfd, 0x8e, 0x01, 0x05, 0xfe, 0xfb, 0x01, 0x05, 0xfd, 0x8d,
+  0x01, 0x05, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x05, 0x23, 0x05, 0x9c,
+  0x06, 0x28, 0x10, 0x07, 0x0a, 0xaa, 0x00, 0x00, 0x07, 0x23, 0x00, 0x00,
+  0xff, 0xff, 0x04, 0xe5, 0xfe, 0x00, 0x05, 0x9b, 0x06, 0x28, 0x10, 0x07,
+  0x0a, 0xb8, 0x04, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x02, 0xc6, 0x02, 0x14, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x12, 0x02, 0xd7, 0xfe, 0x00, 0x04, 0x14, 0xfb, 0xec, 0x00,
+  0x00, 0x01, 0x02, 0xc4, 0xfe, 0x00, 0x05, 0x9c, 0x02, 0x14, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x02, 0xc4, 0x02, 0xd8, 0xfe, 0x00,
+  0x04, 0x14, 0xfb, 0xec, 0x00, 0x01, 0xff, 0xee, 0x02, 0x14, 0x02, 0xc6,
+  0x06, 0x28, 0x00, 0x03, 0x00, 0x00, 0x03, 0x11, 0x21, 0x11, 0x12, 0x02,
+  0xd7, 0x02, 0x14, 0x04, 0x14, 0xfb, 0xec, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x11, 0x21, 0x11, 0x21, 0x05, 0x9c, 0xfa, 0x52, 0x02, 0xd7, 0x02, 0xd7,
+  0xfe, 0x00, 0x08, 0x28, 0xfb, 0xec, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x07, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x12, 0x02, 0xd7, 0x02, 0xd7, 0xfd,
+  0x28, 0x02, 0x14, 0x04, 0x14, 0xfb, 0xec, 0xfb, 0xec, 0x04, 0x14, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x05, 0x9c, 0xfd, 0x29,
+  0xfd, 0x29, 0x06, 0x28, 0xfb, 0xec, 0xfb, 0xec, 0x08, 0x28, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05,
+  0x00, 0x00, 0x03, 0x21, 0x11, 0x21, 0x11, 0x21, 0x12, 0x05, 0xae, 0xfd,
+  0x28, 0xfd, 0x2a, 0x06, 0x28, 0xf7, 0xd8, 0x04, 0x14, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0xc4, 0x02, 0x14, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x02, 0xc4, 0x02, 0xd8, 0x02, 0x14,
+  0x04, 0x14, 0xfb, 0xec, 0x00, 0x01, 0xff, 0xee, 0xfe, 0x00, 0x05, 0x9c,
+  0x06, 0x28, 0x00, 0x07, 0x00, 0x00, 0x03, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x11, 0x21, 0x12, 0x02, 0xd6, 0x02, 0xd8, 0xfd, 0x29, 0xfd, 0x29, 0x02,
+  0x14, 0x04, 0x14, 0xfb, 0xec, 0xfb, 0xec, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0xfe, 0x00, 0x05, 0x9c, 0x06, 0x28, 0x00, 0x05, 0x00, 0x00, 0x03, 0x11,
+  0x21, 0x11, 0x21, 0x11, 0x12, 0x02, 0xd6, 0x02, 0xd8, 0xfe, 0x00, 0x04,
+  0x14, 0x04, 0x14, 0xf7, 0xd8, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x00, 0x17, 0x11,
+  0x21, 0x11, 0xa7, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
+  0x01, 0x0e, 0x04, 0xb2, 0xfb, 0x4e, 0x67, 0x05, 0x7f, 0x8a, 0x05, 0x3c,
+  0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
+  0x25, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x21, 0x22, 0x15,
+  0x03, 0x11, 0x10, 0x29, 0x01, 0x20, 0x19, 0x01, 0x10, 0x29, 0x01, 0x20,
+  0x01, 0x0e, 0xcd, 0x03, 0x17, 0xce, 0xce, 0xfc, 0xe9, 0xcd, 0x67, 0x01,
+  0x34, 0x03, 0x17, 0x01, 0x34, 0xfe, 0xcc, 0xfc, 0xe9, 0xfe, 0xcc, 0x5a,
+  0xe4, 0xe4, 0x03, 0x74, 0xe4, 0xe4, 0xfc, 0x8c, 0x03, 0x74, 0x01, 0x56,
+  0xfe, 0xaa, 0xfc, 0x8c, 0xfe, 0xaa, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x10, 0x27, 0x0a, 0xd3, 0x00, 0xf6,
+  0x00, 0x00, 0x10, 0x06, 0x0a, 0xca, 0x00, 0x00, 0x00, 0x06, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
+  0x25, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21,
+  0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0x35, 0x21, 0xa7, 0x05, 0x7f, 0xfa,
+  0xe8, 0x04, 0xb2, 0xfb, 0x4e, 0x04, 0xb2, 0xfb, 0x4e, 0x04, 0xb2, 0xfb,
+  0x4e, 0x04, 0xb2, 0xfb, 0x4e, 0x04, 0xb2, 0xfb, 0x4e, 0xfc, 0x06, 0x20,
+  0xf9, 0xe0, 0x72, 0xb0, 0x72, 0xb2, 0x72, 0xb0, 0x72, 0xb2, 0x72, 0xb0,
+  0x00, 0x06, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00,
+  0x17, 0x11, 0x21, 0x11, 0x25, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23,
+  0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23, 0x01, 0x33, 0x11, 0x23,
+  0xa7, 0x05, 0x7f, 0xfe, 0xfe, 0x9e, 0x9e, 0xfe, 0xf9, 0xa0, 0xa0, 0xfe,
+  0xfb, 0x9e, 0x9e, 0xfe, 0xf9, 0xa0, 0xa0, 0xfe, 0xfb, 0x9f, 0x9f, 0xfc,
+  0x06, 0x20, 0xf9, 0xe0, 0x74, 0x05, 0x38, 0xfa, 0xc8, 0x05, 0x38, 0xfa,
+  0xc8, 0x05, 0x38, 0xfa, 0xc8, 0x05, 0x38, 0xfa, 0xc8, 0x05, 0x38, 0x00,
+  0x00, 0x1a, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
+  0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33,
+  0x00, 0x37, 0x00, 0x3b, 0x00, 0x3f, 0x00, 0x43, 0x00, 0x47, 0x00, 0x4b,
+  0x00, 0x4f, 0x00, 0x53, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
+  0x00, 0x67, 0x00, 0x00, 0x05, 0x33, 0x35, 0x23, 0x05, 0x33, 0x35, 0x23,
+  0x05, 0x33, 0x35, 0x23, 0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
+  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
+  0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
+  0x11, 0x33, 0x35, 0x23, 0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
+  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x01, 0x33, 0x35, 0x23,
+  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
+  0x01, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23,
+  0x11, 0x33, 0x35, 0x23, 0x11, 0x33, 0x35, 0x23, 0x01, 0x11, 0x21, 0x11,
+  0x02, 0x11, 0xa0, 0xa0, 0x01, 0x07, 0x9e, 0x9e, 0x01, 0x05, 0xa0, 0xa0,
+  0xfc, 0xf1, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d, 0x9d,
+  0x01, 0x03, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0x01, 0x07,
+  0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x9e, 0x01, 0x05, 0xa0, 0xa0,
+  0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0xa0, 0x01, 0x07, 0x9c, 0x9c, 0x9c, 0x9c,
+  0x9c, 0x9c, 0x9c, 0x9c, 0x9c, 0x9c, 0xfb, 0x83, 0x05, 0x7f, 0x88, 0xae,
+  0xae, 0xae, 0xae, 0xae, 0x03, 0xdc, 0xae, 0xfe, 0x2e, 0xb2, 0xfe, 0x2c,
+  0xb0, 0xfe, 0x2c, 0xb2, 0xfe, 0x2e, 0xae, 0x03, 0xdc, 0xae, 0xfe, 0x2e,
+  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0x02, 0xb8, 0xae, 0xfe, 0x2e,
+  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0x02, 0xb8, 0xae, 0xfe, 0x2e,
+  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0x02, 0xb8, 0xae, 0xfe, 0x2e,
+  0xb2, 0xfe, 0x2c, 0xb0, 0xfe, 0x2c, 0xb2, 0xfe, 0x2e, 0xae, 0xfe, 0xde,
+  0x06, 0x20, 0xf9, 0xe0, 0x00, 0x08, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
+  0x05, 0x24, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x14,
+  0x00, 0x18, 0x00, 0x1c, 0x00, 0x1f, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
+  0x01, 0x15, 0x33, 0x03, 0x15, 0x01, 0x33, 0x01, 0x15, 0x01, 0x37, 0x01,
+  0x15, 0x01, 0x37, 0x35, 0x01, 0x33, 0x01, 0x35, 0x01, 0x33, 0x01, 0x35,
+  0x01, 0x33, 0x17, 0x35, 0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0xcb, 0xcb, 0x01,
+  0x5d, 0xe2, 0xfd, 0xc1, 0x02, 0xd1, 0xe2, 0xfc, 0x4d, 0x04, 0x45, 0x6d,
+  0xfb, 0xbb, 0x92, 0x03, 0xb3, 0xfd, 0x2f, 0x91, 0x02, 0x40, 0xfe, 0xa2,
+  0x92, 0xcc, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x01, 0x54, 0xe2, 0x02, 0x7f,
+  0xfc, 0xfe, 0x7d, 0x04, 0x1c, 0xfc, 0xfc, 0xdf, 0x01, 0x05, 0x3c, 0x7f,
+  0xfb, 0x42, 0x01, 0x7f, 0x04, 0xbd, 0xfb, 0xe4, 0xfc, 0x03, 0x20, 0xfd,
+  0x81, 0xfc, 0x01, 0x83, 0xe2, 0xe2, 0x00, 0x00, 0x00, 0x08, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a,
+  0x00, 0x0e, 0x00, 0x14, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x1f, 0x00, 0x00,
+  0x17, 0x11, 0x21, 0x11, 0x25, 0x33, 0x35, 0x05, 0x33, 0x01, 0x35, 0x01,
+  0x17, 0x01, 0x35, 0x01, 0x17, 0x01, 0x35, 0x23, 0x01, 0x35, 0x01, 0x23,
+  0x01, 0x35, 0x01, 0x23, 0x01, 0x35, 0x37, 0x23, 0xa7, 0x05, 0x7f, 0xfe,
+  0xce, 0xcc, 0xfd, 0xc0, 0xe2, 0x01, 0x5e, 0xfc, 0x4d, 0xe2, 0x02, 0xd1,
+  0xfb, 0x4e, 0x6d, 0x04, 0x45, 0x6d, 0xfb, 0xbb, 0x03, 0xb3, 0xe2, 0xfd,
+  0x2f, 0x02, 0x3f, 0xe2, 0xfe, 0xa3, 0xcb, 0xcb, 0xfc, 0x06, 0x20, 0xf9,
+  0xe0, 0x72, 0xe2, 0xe2, 0x01, 0x83, 0xfc, 0xfd, 0x81, 0x01, 0x03, 0x21,
+  0xfc, 0xfb, 0xe4, 0x01, 0x04, 0xbe, 0x7f, 0xfb, 0x43, 0xa1, 0x04, 0x1c,
+  0xfc, 0xe0, 0xa1, 0x02, 0x7f, 0xfe, 0x7d, 0xa1, 0xe2, 0x00, 0x00, 0x00,
+  0x00, 0x1a, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x04,
+  0x00, 0x09, 0x00, 0x0e, 0x00, 0x12, 0x00, 0x17, 0x00, 0x1c, 0x00, 0x20,
+  0x00, 0x24, 0x00, 0x28, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x39,
+  0x00, 0x3d, 0x00, 0x41, 0x00, 0x46, 0x00, 0x4b, 0x00, 0x4f, 0x00, 0x53,
+  0x00, 0x57, 0x00, 0x5c, 0x00, 0x61, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x6f,
+  0x00, 0x73, 0x00, 0x00, 0x01, 0x17, 0x37, 0x27, 0x23, 0x11, 0x17, 0x37,
+  0x27, 0x07, 0x01, 0x17, 0x37, 0x27, 0x23, 0x03, 0x17, 0x37, 0x27, 0x03,
+  0x17, 0x37, 0x27, 0x07, 0x01, 0x17, 0x37, 0x27, 0x23, 0x03, 0x17, 0x37,
+  0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37,
+  0x35, 0x23, 0x03, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17,
+  0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x03, 0x33,
+  0x37, 0x27, 0x07, 0x01, 0x17, 0x37, 0x35, 0x27, 0x01, 0x17, 0x37, 0x27,
+  0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17, 0x33, 0x37,
+  0x27, 0x01, 0x17, 0x37, 0x35, 0x27, 0x01, 0x17, 0x37, 0x27, 0x01, 0x17,
+  0x33, 0x37, 0x27, 0x05, 0x17, 0x33, 0x35, 0x27, 0x01, 0x11, 0x21, 0x11,
+  0x01, 0x0e, 0x2d, 0x70, 0x30, 0x6d, 0x2d, 0x71, 0x71, 0x2d, 0x01, 0x2e,
+  0x71, 0x71, 0x2f, 0x84, 0xe8, 0x71, 0x70, 0x71, 0xe5, 0x2d, 0x71, 0x71,
+  0x2d, 0x02, 0xa1, 0x72, 0x71, 0x30, 0x83, 0xe9, 0x71, 0x71, 0x71, 0xfe,
+  0xd6, 0x71, 0x70, 0x71, 0xfe, 0xd6, 0x71, 0x72, 0x72, 0x03, 0x2f, 0x70,
+  0x2d, 0x6d, 0xe9, 0x6f, 0x71, 0x6f, 0xfe, 0xd4, 0x70, 0x71, 0x6f, 0xfe,
+  0xd6, 0x70, 0x70, 0x70, 0xfe, 0xd6, 0x70, 0x71, 0x6f, 0xfe, 0xd4, 0x71,
+  0x70, 0x70, 0xe6, 0x6e, 0x2f, 0x70, 0x2d, 0x04, 0x14, 0x71, 0x2d, 0x2e,
+  0xfe, 0xd6, 0x71, 0x71, 0x71, 0xfe, 0xd6, 0x72, 0x6f, 0x71, 0xfe, 0xd7,
+  0x71, 0x72, 0x72, 0xfe, 0xd5, 0x2f, 0x85, 0x2e, 0x71, 0x02, 0x75, 0x70,
+  0x2e, 0x2e, 0xfe, 0xd7, 0x71, 0x70, 0x71, 0xfe, 0xd6, 0x2f, 0x84, 0x30,
+  0x71, 0x01, 0x02, 0x2f, 0x6e, 0x2e, 0xfb, 0x15, 0x05, 0x7f, 0x04, 0x33,
+  0x31, 0x7c, 0x34, 0xfd, 0xe4, 0x32, 0x7e, 0x7e, 0x31, 0x01, 0x4f, 0x7e,
+  0x7e, 0x34, 0xfe, 0xff, 0x7e, 0x7c, 0x7e, 0xfc, 0xcc, 0x31, 0x7e, 0x7d,
+  0x31, 0x02, 0xec, 0x7e, 0x7e, 0x34, 0xfe, 0xfd, 0x7d, 0x7d, 0x7e, 0xfe,
+  0xb5, 0x7e, 0x7d, 0x7d, 0xfe, 0xb6, 0x7e, 0x7e, 0x7e, 0x01, 0xec, 0x7c,
+  0x31, 0x7f, 0xfe, 0xfd, 0x7c, 0x7e, 0x7c, 0xfe, 0xb4, 0x7d, 0x7e, 0x7c,
+  0xfe, 0xb6, 0x7c, 0x7c, 0x7c, 0xfe, 0xb5, 0x7c, 0x7e, 0x7c, 0xfe, 0xb4,
+  0x7c, 0x7d, 0x7d, 0xfe, 0x81, 0x34, 0x7c, 0x31, 0x02, 0xed, 0x7e, 0x32,
+  0x99, 0x31, 0xfe, 0xb4, 0x7e, 0x7e, 0x7e, 0xfe, 0xb5, 0x7e, 0x7c, 0x7e,
+  0xfe, 0xb5, 0x7e, 0x7e, 0x7e, 0xfe, 0xb4, 0x34, 0x34, 0x7e, 0x01, 0x1e,
+  0x7e, 0x31, 0x99, 0x31, 0xfe, 0xb5, 0x7d, 0x7c, 0x7e, 0xfe, 0xb5, 0x34,
+  0x34, 0x7e, 0x7e, 0x34, 0x7f, 0x31, 0xfe, 0xde, 0x06, 0x20, 0xf9, 0xe0,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x16, 0x04, 0x3a, 0x04, 0x12, 0x00, 0x03,
+  0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0xa7, 0x03, 0x93, 0x16, 0x03, 0xfc,
+  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x16, 0x04, 0x3a,
+  0x04, 0x12, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21,
+  0x03, 0x11, 0x21, 0x11, 0x01, 0x0e, 0x02, 0xc5, 0xfd, 0x3b, 0x67, 0x03,
+  0x93, 0x88, 0x03, 0x18, 0xfc, 0x76, 0x03, 0xfc, 0xfc, 0x04, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0x00, 0x9a, 0x06, 0x27, 0x03, 0x8e, 0x00, 0x03,
+  0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x06, 0x26, 0xfa, 0x81, 0x05, 0x7f,
+  0x9a, 0x02, 0xf4, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x9a, 0x06, 0x27,
+  0x03, 0x8e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
+  0x05, 0x21, 0x11, 0x21, 0x05, 0xc0, 0xfb, 0x4e, 0x05, 0x18, 0xfa, 0x81,
+  0x05, 0x7f, 0x01, 0x0c, 0x02, 0x10, 0xfd, 0xf0, 0x72, 0x02, 0xf4, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0xff, 0x06, 0x03, 0x4f, 0x05, 0x22, 0x00, 0x03,
+  0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0xa7, 0x02, 0xa8, 0xfa, 0x06, 0x1c,
+  0xf9, 0xe4, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x06, 0x03, 0x4f,
+  0x05, 0x22, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21,
+  0x03, 0x11, 0x21, 0x11, 0x01, 0x0e, 0x01, 0xda, 0xfe, 0x26, 0x67, 0x02,
+  0xa8, 0x88, 0x05, 0x38, 0xfa, 0x56, 0x06, 0x1c, 0xf9, 0xe4, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0x00, 0x9a, 0x05, 0x85, 0x03, 0x8e, 0x00, 0x03,
+  0x00, 0x00, 0x25, 0x21, 0x01, 0x21, 0x04, 0x22, 0xfb, 0xe3, 0x01, 0x63,
+  0x04, 0x1c, 0x9a, 0x02, 0xf4, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05,
+  0x00, 0x9a, 0x05, 0x85, 0x03, 0x8e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x13, 0x21, 0x03, 0x05, 0x21, 0x01, 0x21, 0x03, 0xf2, 0xf5, 0xfc,
+  0xb1, 0xf6, 0x03, 0x80, 0xfb, 0xe3, 0x01, 0x63, 0x04, 0x1c, 0x01, 0x0c,
+  0x02, 0x10, 0xfd, 0xf0, 0x72, 0x02, 0xf4, 0x00, 0x00, 0x01, 0x00, 0x05,
+  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x17, 0x09,
+  0x01, 0x05, 0x02, 0xbf, 0x02, 0xc0, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00,
+  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x00, 0x17, 0x21, 0x09, 0x03, 0x9f, 0x04, 0x4b, 0xfd,
+  0xda, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0x8a, 0x04, 0xca, 0xfa, 0xc4,
+  0x06, 0x20, 0xf9, 0xe0, 0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
+  0x04, 0x12, 0x00, 0x02, 0x00, 0x00, 0x37, 0x09, 0x01, 0x05, 0x01, 0xca,
+  0x01, 0xc9, 0x16, 0x03, 0xfc, 0xfc, 0x04, 0x00, 0x00, 0x02, 0x00, 0x05,
+  0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00,
+  0x37, 0x21, 0x09, 0x03, 0x9f, 0x02, 0x5f, 0xfe, 0xd1, 0xfe, 0x36, 0x01,
+  0xca, 0x01, 0xc9, 0x88, 0x02, 0xa6, 0xfc, 0xe8, 0x03, 0xfc, 0xfc, 0x04,
+  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x00, 0x17, 0x11, 0x01, 0x05, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0xfc,
+  0xf0, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x17, 0x09, 0x01, 0x03,
+  0x11, 0x01, 0x6c, 0x04, 0x4b, 0xfb, 0xb5, 0x67, 0x05, 0x7f, 0x52, 0x02,
+  0x66, 0x02, 0x66, 0xfa, 0x8a, 0x06, 0x20, 0xfc, 0xf0, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02,
+  0x00, 0x00, 0x37, 0x11, 0x01, 0x05, 0x03, 0x93, 0x16, 0x03, 0xfc, 0xfe,
+  0x02, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
+  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x37, 0x09, 0x01, 0x03,
+  0x11, 0x01, 0x6c, 0x02, 0x5f, 0xfd, 0xa1, 0x67, 0x03, 0x93, 0xc1, 0x01,
+  0x53, 0x01, 0x53, 0xfc, 0xaf, 0x03, 0xfc, 0xfe, 0x02, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85, 0x04, 0x12, 0x00, 0x02,
+  0x00, 0x00, 0x37, 0x11, 0x01, 0x05, 0x05, 0x7f, 0x16, 0x03, 0xfc, 0xfe,
+  0x02, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85,
+  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x37, 0x09, 0x01, 0x03,
+  0x11, 0x01, 0x6c, 0x04, 0x18, 0xfb, 0xe8, 0x67, 0x05, 0x7f, 0xc1, 0x01,
+  0x53, 0x01, 0x53, 0xfc, 0xaf, 0x03, 0xfc, 0xfe, 0x02, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x00, 0x13, 0x21, 0x01, 0x05, 0x05, 0x7f, 0xfd, 0x40, 0x05, 0x24,
+  0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x09, 0x01, 0x25,
+  0x21, 0x01, 0x9f, 0x02, 0x25, 0x02, 0x26, 0xfb, 0x1b, 0x05, 0x7f, 0xfd,
+  0x40, 0x04, 0xb2, 0xfb, 0x36, 0x04, 0xca, 0x72, 0xf9, 0xe0, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02,
+  0x00, 0x00, 0x13, 0x21, 0x01, 0x05, 0x03, 0x93, 0xfe, 0x37, 0x04, 0x12,
+  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
+  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x09, 0x01, 0x25,
+  0x21, 0x01, 0x9f, 0x01, 0x30, 0x01, 0x2f, 0xfd, 0x07, 0x03, 0x93, 0xfe,
+  0x37, 0x03, 0xa0, 0xfd, 0x5a, 0x02, 0xa6, 0x72, 0xfc, 0x04, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x00, 0x13, 0x01, 0x11, 0x05, 0x05, 0x7f, 0x02, 0x14, 0x03, 0x10,
+  0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x01, 0x11, 0x09,
+  0x01, 0x11, 0xd3, 0x04, 0x4b, 0xfa, 0xe7, 0x05, 0x7f, 0x02, 0x14, 0xfd,
+  0x9a, 0x04, 0xcc, 0xfd, 0x9a, 0x03, 0x10, 0xf9, 0xe0, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98, 0x04, 0x12, 0x00, 0x02,
+  0x00, 0x00, 0x13, 0x01, 0x11, 0x05, 0x03, 0x93, 0x02, 0x14, 0x01, 0xfe,
+  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x03, 0x98,
+  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x13, 0x01, 0x11, 0x09,
+  0x01, 0x11, 0xd3, 0x02, 0x5e, 0xfc, 0xd4, 0x03, 0x93, 0x02, 0x14, 0xfe,
+  0xad, 0x02, 0xa6, 0xfe, 0xad, 0x01, 0xfe, 0xfc, 0x04, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85, 0x04, 0x12, 0x00, 0x02,
+  0x00, 0x00, 0x13, 0x01, 0x11, 0x05, 0x05, 0x7f, 0x02, 0x14, 0x01, 0xfe,
+  0xfc, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0x00, 0x16, 0x05, 0x85,
+  0x04, 0x12, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x09, 0x01, 0x11, 0x09,
+  0x01, 0x11, 0x01, 0x06, 0x04, 0x18, 0xfa, 0xe7, 0x05, 0x7f, 0x02, 0x14,
+  0xfe, 0xad, 0x02, 0xa6, 0xfe, 0xad, 0x01, 0xfe, 0xfc, 0x04, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x09, 0x02, 0x05, 0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40,
+  0x02, 0x14, 0x03, 0x10, 0xfc, 0xf0, 0xfc, 0xf0, 0x00, 0x02, 0x00, 0x05,
+  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x09, 0x06, 0x8e, 0x02, 0x36, 0x02, 0x37, 0xfd, 0xc9, 0xfd, 0x41,
+  0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40, 0x02, 0x14, 0xfd, 0x88, 0x02, 0x78,
+  0x02, 0x78, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0, 0xfc, 0xf0, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x0b, 0x01, 0x1e, 0x01, 0xa6,
+  0x01, 0xa6, 0xfe, 0x5a, 0xfd, 0xca, 0x02, 0x36, 0x02, 0x37, 0xfd, 0xc9,
+  0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40, 0x02, 0x14, 0x01, 0xd7,
+  0xfe, 0x29, 0xfe, 0x29, 0x01, 0xd7, 0xfd, 0x88, 0x02, 0x78, 0x02, 0x78,
+  0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0, 0xfc, 0xf0, 0x00, 0x03, 0x00, 0x64,
+  0xfe, 0xff, 0x05, 0xe4, 0x05, 0x29, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x29,
+  0x00, 0x00, 0x24, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x00, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
+  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x00, 0x10, 0x25, 0x36, 0x33, 0x32,
+  0x17, 0x04, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x01, 0x5b, 0xe5, 0x71,
+  0x73, 0x73, 0x71, 0xe5, 0xe5, 0x71, 0x73, 0x73, 0x71, 0xfe, 0x8e, 0x01,
+  0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96, 0x96,
+  0x94, 0xfe, 0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe,
+  0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xef, 0x02, 0x4a, 0x92, 0x4a, 0x4a, 0x92,
+  0xfd, 0xb6, 0x92, 0x4a, 0x4a, 0x03, 0x36, 0xfd, 0x02, 0xc0, 0x60, 0x60,
+  0xc0, 0x02, 0xfe, 0xc0, 0x60, 0x60, 0xfb, 0xff, 0x03, 0x84, 0xe2, 0x71,
+  0x71, 0xe2, 0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x00, 0x00, 0x02, 0x00, 0x05,
+  0xfe, 0x23, 0x03, 0x8a, 0x06, 0x75, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x09, 0x07, 0x01, 0xc7, 0xfe, 0xa6, 0x01, 0x5a, 0x01, 0x5b, 0xfe, 0xa5,
+  0x01, 0xc2, 0xfe, 0x3e, 0xfe, 0x3e, 0x05, 0x81, 0xfc, 0xcf, 0xfc, 0xc7,
+  0x03, 0x39, 0x04, 0x25, 0xfb, 0xdb, 0xfb, 0xd3, 0x04, 0x2d, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4, 0x05, 0x29, 0x00, 0x0d,
+  0x00, 0x1b, 0x00, 0x00, 0x12, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
+  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x00, 0x10, 0x25, 0x36, 0x33, 0x32,
+  0x17, 0x04, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0xce, 0x01, 0x2c, 0x94,
+  0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96, 0x96, 0x94, 0xfe,
+  0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe, 0xa0, 0xb0,
+  0xb0, 0xb0, 0xaf, 0x03, 0x93, 0xfd, 0x02, 0xc0, 0x60, 0x60, 0xc0, 0x02,
+  0xfe, 0xc0, 0x60, 0x60, 0xfb, 0xff, 0x03, 0x84, 0xe2, 0x71, 0x71, 0xe2,
+  0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x66,
+  0xff, 0x01, 0x05, 0xe2, 0x05, 0x27, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d,
+  0x00, 0x27, 0x00, 0x2f, 0x00, 0x37, 0x00, 0x3f, 0x00, 0x47, 0x00, 0x00,
+  0x25, 0x16, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x27, 0x05, 0x36,
+  0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x07, 0x13, 0x26, 0x27, 0x26,
+  0x27, 0x37, 0x16, 0x17, 0x16, 0x17, 0x25, 0x06, 0x07, 0x06, 0x07, 0x27,
+  0x36, 0x37, 0x36, 0x37, 0x13, 0x16, 0x32, 0x37, 0x17, 0x06, 0x22, 0x27,
+  0x01, 0x36, 0x34, 0x27, 0x37, 0x16, 0x14, 0x07, 0x01, 0x26, 0x22, 0x07,
+  0x27, 0x36, 0x32, 0x17, 0x01, 0x06, 0x14, 0x17, 0x07, 0x26, 0x34, 0x37,
+  0x01, 0x39, 0x27, 0x35, 0x29, 0x33, 0x2c, 0x3f, 0x34, 0x43, 0x30, 0x03,
+  0x78, 0x32, 0x29, 0x2f, 0x2d, 0x5a, 0x35, 0x3e, 0x33, 0x40, 0x8c, 0x27,
+  0x35, 0x29, 0x32, 0x2b, 0x40, 0x33, 0x43, 0x30, 0xfc, 0x89, 0x33, 0x29,
+  0x35, 0x27, 0x5a, 0x2c, 0x47, 0x34, 0x3f, 0xd5, 0x44, 0x8b, 0x44, 0x23,
+  0x56, 0xad, 0x56, 0x02, 0xf6, 0x0e, 0x0e, 0x63, 0x12, 0x12, 0xfd, 0xdd,
+  0x44, 0x8b, 0x44, 0x23, 0x56, 0xad, 0x56, 0xfd, 0x0c, 0x0f, 0x0f, 0x63,
+  0x12, 0x12, 0x8f, 0x3c, 0x31, 0x26, 0x20, 0x6a, 0x28, 0x30, 0x3d, 0x4a,
+  0x75, 0x20, 0x26, 0x2c, 0x41, 0x3d, 0x4e, 0x3a, 0x30, 0x28, 0x04, 0x27,
+  0x3c, 0x31, 0x26, 0x20, 0x6a, 0x28, 0x30, 0x3d, 0x4a, 0x75, 0x20, 0x26,
+  0x31, 0x3c, 0x3e, 0x45, 0x42, 0x30, 0x28, 0xfa, 0xd4, 0x16, 0x16, 0x6e,
+  0x1b, 0x1b, 0x02, 0x5f, 0x49, 0xa0, 0x49, 0x27, 0x5b, 0xca, 0x5b, 0x03,
+  0x4a, 0x16, 0x16, 0x6e, 0x1b, 0x1b, 0xfd, 0xa1, 0x49, 0xa0, 0x49, 0x27,
+  0x5b, 0xca, 0x5b, 0x00, 0x00, 0x06, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4,
+  0x05, 0x29, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x25, 0x00, 0x2f,
+  0x00, 0x33, 0x00, 0x00, 0x36, 0x10, 0x25, 0x36, 0x33, 0x32, 0x17, 0x04,
+  0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x13, 0x11, 0x16, 0x17, 0x16, 0x17,
+  0x11, 0x06, 0x07, 0x06, 0x07, 0x06, 0x10, 0x17, 0x01, 0x11, 0x16, 0x33,
+  0x32, 0x37, 0x11, 0x26, 0x23, 0x22, 0x17, 0x11, 0x36, 0x37, 0x36, 0x37,
+  0x11, 0x26, 0x27, 0x26, 0x17, 0x11, 0x36, 0x10, 0x65, 0x01, 0x60, 0xaf,
+  0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0x0a,
+  0x14, 0x17, 0x3a, 0x3b, 0x3b, 0x3a, 0x17, 0x7b, 0x9a, 0x9a, 0x01, 0x6d,
+  0x28, 0x27, 0x28, 0x28, 0x28, 0x28, 0x27, 0xdd, 0x3b, 0x39, 0x18, 0x15,
+  0x15, 0x18, 0x39, 0xcc, 0x99, 0x52, 0x03, 0x84, 0xe2, 0x71, 0x71, 0xe2,
+  0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x04, 0xc5, 0xfb, 0xbe, 0x0f, 0x0f, 0x25,
+  0x17, 0x04, 0xf6, 0x17, 0x25, 0x0f, 0x6d, 0xb1, 0xfd, 0xdc, 0xb1, 0x04,
+  0x5b, 0xfa, 0xd0, 0x07, 0x07, 0x05, 0x30, 0x07, 0x24, 0xfb, 0x0a, 0x17,
+  0x25, 0x0f, 0x10, 0x04, 0x40, 0x10, 0x0f, 0x25, 0xa2, 0xfc, 0x7c, 0xb1,
+  0x02, 0x22, 0x00, 0x00, 0x00, 0x04, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4,
+  0x05, 0x29, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x29, 0x00, 0x37, 0x00, 0x00,
+  0x00, 0x10, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x10, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x02, 0x10, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x10, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x00, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
+  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x00, 0x10, 0x25, 0x36, 0x33, 0x32,
+  0x17, 0x04, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x02, 0x56, 0x67, 0x33,
+  0x34, 0x34, 0x33, 0x67, 0x67, 0x33, 0x34, 0x34, 0x33, 0xd5, 0x9e, 0x4f,
+  0x4f, 0x4f, 0x4f, 0x9e, 0x9e, 0x4f, 0x4f, 0x4f, 0x4f, 0xfe, 0x48, 0x01,
+  0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96, 0x96,
+  0x94, 0xfe, 0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0xfe,
+  0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0x02, 0x98, 0xfe, 0xf8, 0x42, 0x21, 0x21,
+  0x42, 0x01, 0x08, 0x42, 0x21, 0x21, 0xfe, 0x6f, 0x01, 0x96, 0x65, 0x33,
+  0x33, 0x65, 0xfe, 0x6a, 0x65, 0x33, 0x33, 0x02, 0xaf, 0xfd, 0x02, 0xc0,
+  0x60, 0x60, 0xc0, 0x02, 0xfe, 0xc0, 0x60, 0x60, 0xfb, 0xff, 0x03, 0x84,
+  0xe2, 0x71, 0x71, 0xe2, 0xfc, 0x7c, 0xe2, 0x71, 0x71, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x17,
+  0x00, 0x00, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x65, 0x5e, 0x5e, 0xa4, 0xa3, 0xbd, 0xbc, 0xa3, 0xa3, 0x5e,
+  0x5f, 0x5f, 0x5e, 0xa3, 0xa3, 0xbc, 0xbd, 0xa3, 0xa4, 0x5e, 0x5e, 0x02,
+  0x12, 0xd1, 0xb6, 0xb5, 0x69, 0x69, 0x69, 0x69, 0xb5, 0xb6, 0xd1, 0xd1,
+  0xb6, 0xb5, 0x69, 0x69, 0x69, 0x69, 0xb5, 0xb6, 0x00, 0x02, 0x00, 0x64,
+  0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d, 0x00, 0x15, 0x00, 0x00,
+  0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23,
+  0x22, 0x24, 0x05, 0x32, 0x37, 0x24, 0x10, 0x25, 0x26, 0x23, 0x65, 0xbc,
+  0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd,
+  0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96,
+  0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e,
+  0xfe, 0x95, 0xd2, 0xd2, 0x61, 0x60, 0xc0, 0x02, 0xfe, 0xc0, 0x60, 0x00,
+  0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d,
+  0x00, 0x15, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
+  0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x01, 0x22, 0x07, 0x04, 0x10, 0x05,
+  0x16, 0x33, 0x65, 0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd, 0xbd,
+  0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0xfe, 0xd4,
+  0x01, 0x2c, 0x94, 0x96, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2,
+  0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x04, 0xdd, 0x60, 0xc0,
+  0xfd, 0x02, 0xc0, 0x60, 0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
+  0x05, 0x20, 0x00, 0x0d, 0x00, 0x16, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24,
+  0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x01, 0x10,
+  0x25, 0x26, 0x23, 0x22, 0x07, 0x04, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd,
+  0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x04,
+  0x59, 0xfe, 0xd4, 0x94, 0x96, 0x96, 0x94, 0xfe, 0xd4, 0x01, 0x41, 0x01,
+  0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2,
+  0xd2, 0x02, 0x3e, 0x01, 0x7f, 0xc0, 0x60, 0x60, 0xc0, 0xfe, 0x81, 0x00,
+  0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d,
+  0x00, 0x16, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
+  0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x03, 0x10, 0x05, 0x16, 0x33, 0x32,
+  0x37, 0x24, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd,
+  0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x53, 0x01, 0x2c, 0x94, 0x96,
+  0x96, 0x94, 0x01, 0x2c, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2,
+  0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x02, 0x3e, 0xfe, 0x81,
+  0xc0, 0x60, 0x60, 0xc0, 0x01, 0x7f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64,
+  0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0b, 0x00, 0x18, 0x00, 0x00,
+  0x12, 0x10, 0x12, 0x24, 0x20, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24,
+  0x01, 0x22, 0x07, 0x04, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24, 0x11,
+  0x21, 0x65, 0xbc, 0x01, 0x47, 0x01, 0x79, 0x01, 0x46, 0xbd, 0xbd, 0xfe,
+  0xba, 0xfe, 0x87, 0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0xfe, 0xd4, 0x01,
+  0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfd, 0xaa, 0x01, 0x41, 0x01,
+  0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2,
+  0xd2, 0x04, 0xdd, 0x60, 0xc0, 0xfd, 0x02, 0xc0, 0x60, 0x60, 0xc0, 0x01,
+  0x7f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
+  0x05, 0x20, 0x00, 0x0b, 0x00, 0x11, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24,
+  0x20, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x01, 0x22, 0x07, 0x04,
+  0x11, 0x21, 0x65, 0xbc, 0x01, 0x47, 0x01, 0x79, 0x01, 0x46, 0xbd, 0xbd,
+  0xfe, 0xba, 0xfe, 0x87, 0xfe, 0xb9, 0x02, 0x03, 0x96, 0x94, 0xfe, 0xd4,
+  0x02, 0x56, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95,
+  0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x04, 0xdd, 0x60, 0xc0, 0xfe, 0x81,
+  0x00, 0x01, 0x00, 0x64, 0xfe, 0xff, 0x03, 0x24, 0x05, 0x29, 0x00, 0x07,
+  0x00, 0x00, 0x36, 0x10, 0x25, 0x36, 0x33, 0x11, 0x22, 0x27, 0x65, 0x01,
+  0x60, 0xaf, 0xb0, 0xb0, 0xaf, 0x52, 0x03, 0x84, 0xe2, 0x71, 0xf9, 0xd6,
+  0x71, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0xff, 0x03, 0x67,
+  0x05, 0x29, 0x00, 0x07, 0x00, 0x00, 0x00, 0x10, 0x05, 0x06, 0x23, 0x11,
+  0x32, 0x17, 0x03, 0x66, 0xfe, 0xa0, 0xaf, 0xb0, 0xb0, 0xaf, 0x03, 0xd6,
+  0xfc, 0x7c, 0xe2, 0x71, 0x06, 0x2a, 0x71, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xff, 0xec, 0x05, 0x0b, 0x06, 0x28, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00,
+  0x01, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01,
+  0x11, 0x21, 0x11, 0x01, 0xce, 0x9a, 0xe2, 0x9a, 0x9a, 0x6f, 0x72, 0x9b,
+  0xfe, 0xd9, 0x04, 0x64, 0x02, 0xfa, 0x7d, 0xac, 0xac, 0x7d, 0x7c, 0xab,
+  0xab, 0xfc, 0x76, 0x06, 0x3c, 0xf9, 0xc4, 0x00, 0x00, 0x03, 0x00, 0xa7,
+  0xfe, 0x00, 0x06, 0x55, 0x06, 0x28, 0x00, 0x0d, 0x00, 0x1b, 0x00, 0x1f,
+  0x00, 0x00, 0x24, 0x10, 0x25, 0x36, 0x33, 0x32, 0x17, 0x04, 0x10, 0x05,
+  0x06, 0x23, 0x22, 0x27, 0x00, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24,
+  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x01, 0x11, 0x21, 0x11, 0x01, 0x28,
+  0x01, 0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0xfe, 0xd4, 0x94, 0x96,
+  0x96, 0x94, 0xfe, 0x6b, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60,
+  0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xfe, 0x88, 0x05, 0xae, 0x95, 0x02,
+  0xfe, 0xc0, 0x60, 0x60, 0xc0, 0xfd, 0x02, 0xc0, 0x60, 0x60, 0x04, 0x01,
+  0xfc, 0x7c, 0xe2, 0x71, 0x71, 0xe2, 0x03, 0x84, 0xe2, 0x71, 0x71, 0xf9,
+  0x48, 0x08, 0x28, 0xf7, 0xd8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0x02, 0x14, 0x06, 0x55, 0x06, 0x28, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
+  0x13, 0x11, 0x21, 0x11, 0x23, 0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x04,
+  0x11, 0x29, 0x01, 0x10, 0x25, 0x36, 0x33, 0x32, 0x17, 0x04, 0xa7, 0x05,
+  0xae, 0x17, 0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xfe, 0xa0, 0x05, 0x15,
+  0xfb, 0x54, 0x01, 0x2c, 0x95, 0x95, 0x95, 0x95, 0x01, 0x2c, 0x02, 0x14,
+  0x04, 0x14, 0xfb, 0xec, 0x01, 0xc2, 0xe2, 0x71, 0x71, 0xe2, 0xfe, 0x3e,
+  0x01, 0x7e, 0xc1, 0x60, 0x60, 0xc1, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xfe, 0x00, 0x06, 0x55, 0x02, 0x14, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
+  0x13, 0x11, 0x33, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24, 0x11, 0x33,
+  0x11, 0x01, 0x21, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27, 0x24, 0xa7, 0x18,
+  0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01, 0x60, 0x17, 0xfa, 0xd3, 0x04,
+  0xac, 0xfe, 0xd4, 0x95, 0x95, 0x95, 0x95, 0xfe, 0xd4, 0xfe, 0x00, 0x04,
+  0x14, 0xfe, 0x3e, 0xe2, 0x71, 0x71, 0xe2, 0x01, 0xc2, 0xfb, 0xec, 0x04,
+  0x14, 0xfe, 0x82, 0xc1, 0x60, 0x60, 0xc1, 0x00, 0x00, 0x01, 0x00, 0x05,
+  0x02, 0x14, 0x02, 0xc5, 0x05, 0x29, 0x00, 0x09, 0x00, 0x00, 0x13, 0x10,
+  0x25, 0x36, 0x33, 0x15, 0x22, 0x07, 0x04, 0x11, 0x05, 0x01, 0x60, 0xb0,
+  0xaf, 0x95, 0x95, 0xfe, 0xd5, 0x02, 0x14, 0x01, 0xc2, 0xe2, 0x71, 0x76,
+  0x60, 0xc0, 0xfe, 0x81, 0x00, 0x01, 0x00, 0x05, 0x02, 0x14, 0x02, 0xc5,
+  0x05, 0x29, 0x00, 0x09, 0x00, 0x00, 0x13, 0x32, 0x17, 0x04, 0x11, 0x23,
+  0x10, 0x25, 0x26, 0x23, 0x05, 0xb0, 0xaf, 0x01, 0x60, 0x69, 0xfe, 0xd4,
+  0x94, 0x96, 0x05, 0x29, 0x71, 0xe2, 0xfe, 0x3e, 0x01, 0x7f, 0xc0, 0x60,
+  0x00, 0x01, 0x00, 0x05, 0xfe, 0xff, 0x02, 0xc5, 0x02, 0x14, 0x00, 0x09,
+  0x00, 0x00, 0x13, 0x35, 0x32, 0x37, 0x24, 0x11, 0x33, 0x10, 0x05, 0x06,
+  0x05, 0x96, 0x94, 0x01, 0x2c, 0x69, 0xfe, 0xa0, 0xaf, 0xfe, 0xff, 0x76,
+  0x60, 0xc0, 0x01, 0x7f, 0xfe, 0x3e, 0xe2, 0x71, 0x00, 0x01, 0x00, 0x05,
+  0xfe, 0xff, 0x02, 0xc5, 0x02, 0x14, 0x00, 0x09, 0x00, 0x00, 0x01, 0x22,
+  0x27, 0x24, 0x11, 0x33, 0x10, 0x05, 0x16, 0x33, 0x02, 0xc4, 0xaf, 0xb0,
+  0xfe, 0xa0, 0x6a, 0x01, 0x2b, 0x95, 0x95, 0xfe, 0xff, 0x71, 0xe2, 0x01,
+  0xc2, 0xfe, 0x81, 0xc0, 0x60, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64,
+  0x02, 0x14, 0x05, 0xe4, 0x05, 0x29, 0x00, 0x11, 0x00, 0x00, 0x13, 0x10,
+  0x25, 0x36, 0x33, 0x32, 0x17, 0x04, 0x11, 0x23, 0x10, 0x25, 0x26, 0x23,
+  0x22, 0x07, 0x04, 0x11, 0x65, 0x01, 0x60, 0xaf, 0xb0, 0xb0, 0xb0, 0x01,
+  0x60, 0x6a, 0xfe, 0xd4, 0x94, 0x96, 0x96, 0x94, 0xfe, 0xd4, 0x02, 0x14,
+  0x01, 0xc2, 0xe2, 0x71, 0x71, 0xe2, 0xfe, 0x3e, 0x01, 0x7f, 0xc0, 0x60,
+  0x60, 0xc0, 0xfe, 0x81, 0x00, 0x01, 0x00, 0x64, 0xfe, 0xff, 0x05, 0xe4,
+  0x02, 0x14, 0x00, 0x12, 0x00, 0x00, 0x13, 0x30, 0x33, 0x10, 0x05, 0x16,
+  0x33, 0x32, 0x37, 0x24, 0x11, 0x33, 0x10, 0x05, 0x06, 0x23, 0x22, 0x27,
+  0x24, 0x65, 0x69, 0x01, 0x2c, 0x94, 0x96, 0x96, 0x94, 0x01, 0x2c, 0x6a,
+  0xfe, 0xa0, 0xb0, 0xb0, 0xb0, 0xaf, 0xfe, 0xa0, 0x02, 0x14, 0xfe, 0x81,
+  0xc0, 0x60, 0x60, 0xc0, 0x01, 0x7f, 0xfe, 0x3e, 0xe2, 0x71, 0x71, 0xe2,
+  0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x00, 0x17, 0x01, 0x11, 0x05, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0xf9,
+  0xe0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x17, 0x11, 0x01, 0x05, 0x05, 0x7f,
+  0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05,
+  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x17, 0x11,
+  0x21, 0x05, 0x05, 0x7f, 0xfc, 0x06, 0x20, 0x00, 0x00, 0x01, 0x00, 0x05,
+  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x00, 0x13, 0x21,
+  0x11, 0x05, 0x05, 0x7f, 0x05, 0x24, 0xf9, 0xe0, 0x00, 0x02, 0x01, 0x14,
+  0x01, 0xd1, 0x03, 0x2b, 0x04, 0x21, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x00,
+  0x01, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x22, 0x26, 0x01, 0x49,
+  0x7d, 0xb4, 0x7c, 0x7c, 0x59, 0x5b, 0x7d, 0x35, 0x9c, 0x71, 0x70, 0x9a,
+  0x9b, 0xe1, 0x9b, 0x02, 0xfa, 0x64, 0x8a, 0x8a, 0x64, 0x63, 0x89, 0x89,
+  0x63, 0x7c, 0xab, 0xab, 0x7c, 0x7d, 0xac, 0xac, 0x00, 0x02, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfd,
+  0x40, 0x02, 0x5a, 0xfd, 0xa6, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05,
+  0x3c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
+  0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
+  0x25, 0x21, 0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0x02, 0x58, 0xfd,
+  0xa8, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05, 0x3c, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x06, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0xa7,
+  0x05, 0x7f, 0xfa, 0xe8, 0x04, 0xb2, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72,
+  0x05, 0x3c, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
+  0x05, 0x24, 0x00, 0x03, 0x00, 0x06, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11,
+  0x25, 0x01, 0x21, 0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0x04, 0xb2, 0xfb, 0x4e,
+  0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05, 0x3c, 0x00, 0x03, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x01, 0x21,
+  0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfd, 0x74, 0x02, 0x26, 0xfd, 0xda, 0xfd,
+  0x74, 0x02, 0x25, 0xfd, 0xdb, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x05,
+  0x3c, 0xfa, 0xc4, 0x05, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x05,
+  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x07, 0x00, 0x0a, 0x00, 0x0d,
+  0x00, 0x00, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x21,
+  0x09, 0x03, 0x02, 0x3f, 0x4e, 0x70, 0x4d, 0x4d, 0x71, 0xfe, 0x13, 0x04,
+  0x4b, 0xfd, 0xda, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0x01, 0x2c, 0x7c,
+  0x56, 0x56, 0x7c, 0x56, 0xfe, 0xa0, 0x04, 0xca, 0xfa, 0xc4, 0x06, 0x20,
+  0xf9, 0xe0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x05, 0x21, 0x09, 0x03,
+  0x02, 0xc4, 0x02, 0x26, 0xfd, 0xda, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0,
+  0x8a, 0x04, 0xca, 0xfa, 0xc4, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x00, 0x17, 0x21, 0x11, 0x09, 0x02, 0x9f, 0x02, 0x25,
+  0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0x8a, 0x04, 0xca, 0xfa, 0xc4, 0x06,
+  0x20, 0xf9, 0xe0, 0x00, 0x00, 0x02, 0x00, 0x64, 0xfe, 0x00, 0x07, 0xaa,
+  0x06, 0x28, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00, 0x12, 0x10, 0x01, 0x16,
+  0x20, 0x37, 0x00, 0x10, 0x01, 0x26, 0x20, 0x07, 0x00, 0x10, 0x01, 0x36,
+  0x20, 0x17, 0x00, 0x10, 0x01, 0x06, 0x20, 0x27, 0xd9, 0x01, 0x98, 0xcb,
+  0x01, 0x97, 0xcb, 0x01, 0x98, 0xfe, 0x68, 0xcb, 0xfe, 0x69, 0xcb, 0xfd,
+  0xf4, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xfe, 0x2f, 0xe9,
+  0xfe, 0x2f, 0xe9, 0x04, 0x1e, 0xfb, 0xec, 0xfe, 0xfb, 0x83, 0x83, 0x01,
+  0x05, 0x04, 0x14, 0x01, 0x05, 0x83, 0x83, 0xfa, 0x9d, 0x04, 0xa8, 0x01,
+  0x2a, 0x96, 0x96, 0xfe, 0xd6, 0xfb, 0x58, 0xfe, 0xd6, 0x96, 0x96, 0x00,
+  0x00, 0x03, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x05,
+  0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x03, 0x11, 0x21, 0x11, 0x01, 0x21, 0x11, 0x21, 0x01, 0x0e, 0x04, 0xb2,
+  0xfd, 0xda, 0xfd, 0x74, 0x67, 0x05, 0x7f, 0xfa, 0xe8, 0x02, 0x25, 0xfd,
+  0xdb, 0x8a, 0x05, 0x3c, 0xfd, 0x29, 0xfd, 0x29, 0x06, 0x20, 0xf9, 0xe0,
+  0x03, 0x49, 0x02, 0x65, 0x00, 0x03, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
+  0x05, 0x24, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21,
+  0x11, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
+  0x01, 0x0e, 0x02, 0x8c, 0x02, 0x26, 0xfb, 0x4e, 0x67, 0x05, 0x7f, 0xfa,
+  0xe8, 0x02, 0x25, 0xfd, 0xdb, 0x02, 0x4d, 0xfd, 0x29, 0x05, 0x3c, 0xfa,
+  0x52, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x02, 0x65, 0x00, 0x03, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0d,
+  0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
+  0x25, 0x21, 0x11, 0x21, 0x01, 0x0e, 0x02, 0x25, 0x02, 0x8d, 0xfb, 0x4e,
+  0x67, 0x05, 0x7f, 0xfd, 0x74, 0x02, 0x26, 0xfd, 0xda, 0x8a, 0x02, 0xd7,
+  0x02, 0x65, 0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0, 0x72, 0x02, 0x65, 0x00,
+  0x00, 0x03, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x05,
+  0x00, 0x09, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x03, 0x11, 0x21, 0x11, 0x01, 0x21, 0x11, 0x21, 0x01, 0x0e, 0x04, 0xb2,
+  0xfd, 0x73, 0xfd, 0xdb, 0x67, 0x05, 0x7f, 0xfd, 0x74, 0x02, 0x26, 0xfd,
+  0xda, 0x8a, 0x02, 0x65, 0x02, 0xd7, 0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0,
+  0x03, 0x49, 0x02, 0x65, 0x00, 0x03, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
+  0x05, 0x20, 0x00, 0x0d, 0x00, 0x13, 0x00, 0x20, 0x00, 0x00, 0x12, 0x10,
+  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24,
+  0x01, 0x06, 0x07, 0x04, 0x03, 0x21, 0x05, 0x12, 0x05, 0x16, 0x33, 0x32,
+  0x37, 0x24, 0x10, 0x25, 0x26, 0x27, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd,
+  0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x01,
+  0xcf, 0x7b, 0x7b, 0xfe, 0xeb, 0x15, 0x02, 0x20, 0xfd, 0xe0, 0x15, 0x01,
+  0x15, 0x95, 0x95, 0x95, 0x95, 0x01, 0x2c, 0xfe, 0xd4, 0x7b, 0x7c, 0x01,
+  0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe,
+  0x95, 0xd2, 0xd2, 0x04, 0xda, 0x0e, 0x4f, 0xb2, 0xfe, 0xac, 0x72, 0xfe,
+  0xac, 0xb2, 0x60, 0x60, 0xc1, 0x02, 0xfc, 0xc1, 0x4f, 0x0e, 0xfd, 0x2b,
+  0x00, 0x03, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d,
+  0x00, 0x1a, 0x00, 0x20, 0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32,
+  0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24, 0x05, 0x36, 0x37, 0x24,
+  0x10, 0x25, 0x26, 0x23, 0x22, 0x07, 0x04, 0x03, 0x21, 0x05, 0x12, 0x05,
+  0x16, 0x17, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd,
+  0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x02, 0x36, 0x7c, 0x7b, 0x01,
+  0x2c, 0xfe, 0xd4, 0x95, 0x95, 0x95, 0x95, 0xfe, 0xeb, 0x15, 0x02, 0x87,
+  0xfd, 0x79, 0x15, 0x01, 0x15, 0x7b, 0x7b, 0x01, 0x41, 0x01, 0xa2, 0x01,
+  0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x5e,
+  0x0e, 0x4f, 0xc1, 0x02, 0xfc, 0xc1, 0x60, 0x60, 0xb2, 0xfe, 0xac, 0x72,
+  0xfe, 0xac, 0xb2, 0x4f, 0x0e, 0x02, 0x63, 0x00, 0x00, 0x03, 0x00, 0x64,
+  0xff, 0x04, 0x05, 0xe4, 0x05, 0x20, 0x00, 0x0d, 0x00, 0x1a, 0x00, 0x20,
+  0x00, 0x00, 0x12, 0x10, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02,
+  0x04, 0x23, 0x22, 0x24, 0x02, 0x10, 0x05, 0x16, 0x17, 0x11, 0x21, 0x02,
+  0x25, 0x26, 0x23, 0x22, 0x07, 0x01, 0x36, 0x37, 0x24, 0x13, 0x21, 0x65,
+  0xbc, 0x01, 0x47, 0xbd, 0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc,
+  0xbd, 0xfe, 0xb9, 0x53, 0x01, 0x2c, 0x7b, 0x7b, 0x02, 0x88, 0x14, 0xfe,
+  0xea, 0x95, 0x95, 0x95, 0x95, 0x01, 0x5d, 0x7c, 0x7b, 0x01, 0x16, 0x14,
+  0xfd, 0xdf, 0x01, 0x41, 0x01, 0xa2, 0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95,
+  0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2, 0x03, 0xbc, 0xfd, 0x04, 0xc1, 0x4f,
+  0x0e, 0x02, 0xd5, 0x01, 0x54, 0xb2, 0x60, 0x60, 0xfb, 0x25, 0x0e, 0x4f,
+  0xb2, 0x01, 0x54, 0x00, 0x00, 0x03, 0x00, 0x64, 0xff, 0x04, 0x05, 0xe4,
+  0x05, 0x20, 0x00, 0x0d, 0x00, 0x1a, 0x00, 0x20, 0x00, 0x00, 0x12, 0x10,
+  0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x23, 0x22, 0x24,
+  0x02, 0x10, 0x05, 0x16, 0x33, 0x32, 0x37, 0x24, 0x13, 0x21, 0x11, 0x06,
+  0x07, 0x01, 0x02, 0x25, 0x26, 0x27, 0x11, 0x65, 0xbc, 0x01, 0x47, 0xbd,
+  0xbc, 0x01, 0x46, 0xbd, 0xbd, 0xfe, 0xba, 0xbc, 0xbd, 0xfe, 0xb9, 0x53,
+  0x01, 0x2c, 0x95, 0x95, 0x95, 0x95, 0x01, 0x16, 0x14, 0xfd, 0x78, 0x7b,
+  0x7b, 0x03, 0x7e, 0x14, 0xfe, 0xea, 0x7b, 0x7c, 0x01, 0x41, 0x01, 0xa2,
+  0x01, 0x6b, 0xd2, 0xd2, 0xfe, 0x95, 0xfe, 0x5e, 0xfe, 0x95, 0xd2, 0xd2,
+  0x03, 0xbc, 0xfd, 0x04, 0xc1, 0x60, 0x60, 0xb2, 0x01, 0x54, 0x02, 0xd5,
+  0x0e, 0x4f, 0xfd, 0xfa, 0x01, 0x54, 0xb2, 0x4f, 0x0e, 0xfd, 0x9d, 0x00,
+  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x00, 0x37, 0x01, 0x21, 0x03, 0x11, 0x21, 0x6c, 0x04,
+  0x18, 0xfb, 0xe8, 0x67, 0x05, 0x7f, 0x20, 0x04, 0x92, 0xfa, 0x52, 0x06,
+  0x20, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x09, 0x01, 0x11, 0x25,
+  0x21, 0x11, 0x01, 0x06, 0x04, 0x18, 0xfa, 0xe7, 0x05, 0x7f, 0x04, 0xb2,
+  0xfb, 0x6e, 0x04, 0x92, 0x72, 0xf9, 0xe0, 0x00, 0x00, 0x02, 0x00, 0x05,
+  0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00,
+  0x17, 0x21, 0x01, 0x03, 0x11, 0x01, 0x6c, 0x04, 0x18, 0xfb, 0xe8, 0x67,
+  0x05, 0x7f, 0x8a, 0x04, 0x92, 0xfa, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xff, 0x79, 0x05, 0x53, 0x04, 0xaf, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x05, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
+  0x01, 0x0e, 0x03, 0xde, 0xfc, 0x22, 0x67, 0x04, 0xac, 0x15, 0x04, 0x52,
+  0xfb, 0x3c, 0x05, 0x36, 0xfa, 0xca, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xff, 0x79, 0x05, 0x53, 0x04, 0xaf, 0x00, 0x03, 0x00, 0x00, 0x17, 0x11,
+  0x21, 0x11, 0xa7, 0x04, 0xac, 0x87, 0x05, 0x36, 0xfa, 0xca, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xff, 0xdd, 0x04, 0x9f, 0x04, 0x4b, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x25, 0x21, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11,
+  0x01, 0x0e, 0x03, 0x2a, 0xfc, 0xd6, 0x67, 0x03, 0xf8, 0x4f, 0x03, 0x8a,
+  0xfc, 0x04, 0x04, 0x6e, 0xfb, 0x92, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xff, 0xdd, 0x04, 0x9f, 0x04, 0x4b, 0x00, 0x03, 0x00, 0x00, 0x17, 0x11,
+  0x21, 0x11, 0xa7, 0x03, 0xf8, 0x23, 0x04, 0x6e, 0xfb, 0x92, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x00, 0x05, 0x21, 0x11, 0x09, 0x01, 0x11, 0x01, 0x06,
+  0x04, 0x18, 0xfa, 0xe7, 0x05, 0x7f, 0x8a, 0x04, 0x92, 0xfa, 0xfc, 0x06,
+  0x20, 0xf9, 0xe0, 0x00, 0x00, 0x09, 0x00, 0x99, 0x00, 0x00, 0x05, 0xda,
+  0x05, 0xd5, 0x00, 0x07, 0x00, 0x0c, 0x00, 0x13, 0x00, 0x22, 0x00, 0x2a,
+  0x00, 0x32, 0x00, 0x3a, 0x00, 0x41, 0x00, 0x49, 0x00, 0x00, 0x01, 0x33,
+  0x17, 0x11, 0x07, 0x23, 0x27, 0x11, 0x05, 0x17, 0x15, 0x07, 0x27, 0x25,
+  0x17, 0x07, 0x23, 0x26, 0x27, 0x35, 0x05, 0x32, 0x1f, 0x01, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01, 0x21, 0x17,
+  0x15, 0x07, 0x21, 0x27, 0x35, 0x25, 0x21, 0x17, 0x15, 0x07, 0x21, 0x27,
+  0x35, 0x03, 0x33, 0x16, 0x17, 0x15, 0x07, 0x27, 0x35, 0x25, 0x33, 0x17,
+  0x15, 0x07, 0x27, 0x35, 0x25, 0x33, 0x17, 0x11, 0x07, 0x23, 0x27, 0x11,
+  0x03, 0x1b, 0x45, 0x05, 0x05, 0x45, 0x06, 0x01, 0xff, 0x34, 0xdf, 0x37,
+  0xfd, 0x4a, 0xe3, 0x37, 0x03, 0xb4, 0x29, 0x01, 0xf8, 0xbc, 0x50, 0x0c,
+  0xac, 0x3f, 0x2a, 0x9d, 0x58, 0x20, 0xa5, 0x3c, 0xfd, 0x90, 0x01, 0x31,
+  0x06, 0x06, 0xfe, 0xcf, 0x05, 0x04, 0x03, 0x01, 0x36, 0x07, 0x07, 0xfe,
+  0xca, 0x06, 0x3f, 0x02, 0x79, 0x66, 0x37, 0xdf, 0xfd, 0xf0, 0x03, 0x35,
+  0xde, 0x37, 0x01, 0xe5, 0x45, 0x05, 0x05, 0x45, 0x06, 0x05, 0xd5, 0x06,
+  0xfe, 0xa2, 0x06, 0x06, 0x01, 0x5e, 0x9b, 0x3f, 0x03, 0xfe, 0x3f, 0xee,
+  0xfe, 0x40, 0xc7, 0x37, 0x04, 0xb5, 0xe1, 0x60, 0xbd, 0x64, 0x17, 0xa7,
+  0x3f, 0x5c, 0xb5, 0x67, 0x1b, 0xfe, 0xed, 0x06, 0x4f, 0x06, 0x06, 0x4f,
+  0x06, 0x06, 0x4f, 0x06, 0x06, 0x4f, 0xfe, 0xe8, 0x82, 0x79, 0x03, 0x3e,
+  0xfd, 0x04, 0x2a, 0x3c, 0x03, 0xfe, 0x3f, 0x04, 0x76, 0x06, 0xfe, 0xa2,
+  0x06, 0x06, 0x01, 0x5e, 0x00, 0x01, 0x00, 0x5d, 0xff, 0xfb, 0x06, 0xd5,
+  0x02, 0xe1, 0x00, 0x22, 0x00, 0x00, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x36,
+  0x33, 0x16, 0x15, 0x14, 0x07, 0x16, 0x1d, 0x01, 0x06, 0x23, 0x21, 0x35,
+  0x32, 0x37, 0x36, 0x3b, 0x01, 0x27, 0x34, 0x3f, 0x01, 0x17, 0x27, 0x34,
+  0x3f, 0x01, 0x32, 0x17, 0x36, 0x04, 0x76, 0x14, 0xc3, 0x69, 0x13, 0x23,
+  0x31, 0x7a, 0x1f, 0x5d, 0x11, 0x48, 0xf9, 0xe2, 0x33, 0x79, 0x29, 0x2f,
+  0x1d, 0x0a, 0x90, 0x23, 0x26, 0x05, 0xb8, 0x3c, 0x2b, 0x2a, 0x6c, 0x02,
+  0xe1, 0xe8, 0x56, 0x23, 0x1b, 0x6d, 0x31, 0x34, 0x17, 0x48, 0x1a, 0x65,
+  0x09, 0xae, 0x27, 0x31, 0x6c, 0x31, 0x04, 0x04, 0x0c, 0x93, 0x5a, 0x08,
+  0x2b, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x1b,
+  0x05, 0xd5, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x33, 0x17, 0x15, 0x33, 0x20,
+  0x13, 0x16, 0x1d, 0x01, 0x23, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07,
+  0x15, 0x14, 0x07, 0x27, 0x26, 0x23, 0x11, 0x14, 0x0f, 0x01, 0x22, 0x2f,
+  0x01, 0x35, 0x37, 0x33, 0x17, 0x15, 0x16, 0x3b, 0x01, 0x32, 0x3f, 0x01,
+  0x11, 0x22, 0x07, 0x06, 0x23, 0x27, 0x35, 0x37, 0x23, 0x26, 0x27, 0x23,
+  0x22, 0x0f, 0x01, 0x23, 0x35, 0x36, 0x37, 0x36, 0x21, 0x35, 0x03, 0x30,
+  0x34, 0x06, 0x02, 0x01, 0x8c, 0xfc, 0x26, 0x01, 0x14, 0x11, 0x20, 0x33,
+  0x28, 0x87, 0x64, 0x08, 0x1d, 0x88, 0x7b, 0x5f, 0x1b, 0x52, 0x21, 0x02,
+  0x05, 0x27, 0x05, 0x09, 0x38, 0x09, 0x32, 0x12, 0x05, 0xbe, 0x4d, 0x10,
+  0x0c, 0x06, 0x06, 0x04, 0x3c, 0xb1, 0x3d, 0x59, 0x1e, 0x12, 0x03, 0x34,
+  0xad, 0xd7, 0x01, 0x19, 0x05, 0xd5, 0x06, 0x7d, 0xfe, 0x1a, 0x56, 0x0d,
+  0x08, 0x0f, 0x2e, 0x18, 0x65, 0x33, 0x0f, 0x02, 0x42, 0x3d, 0xfd, 0x53,
+  0x65, 0x18, 0x02, 0x60, 0x1c, 0x1a, 0x06, 0x06, 0x0c, 0x65, 0x39, 0x2a,
+  0x02, 0xa4, 0x3d, 0x39, 0x06, 0x0c, 0x33, 0x40, 0x1b, 0x3d, 0x12, 0x02,
+  0x90, 0xda, 0xdf, 0x7d, 0x00, 0x1a, 0x00, 0x99, 0xff, 0xff, 0x05, 0xdc,
+  0x07, 0x6b, 0x00, 0x0d, 0x00, 0x15, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x43,
+  0x00, 0x60, 0x00, 0x8c, 0x00, 0xb7, 0x00, 0xe3, 0x01, 0x0e, 0x01, 0x3a,
+  0x01, 0x64, 0x01, 0x90, 0x01, 0xbb, 0x01, 0xe6, 0x02, 0x0f, 0x02, 0x3b,
+  0x02, 0x65, 0x02, 0x6d, 0x02, 0x75, 0x02, 0x7d, 0x02, 0xa9, 0x02, 0xd3,
+  0x02, 0xfd, 0x03, 0x27, 0x03, 0x53, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32,
+  0x37, 0x33, 0x06, 0x07, 0x26, 0x27, 0x33, 0x16, 0x33, 0x32, 0x37, 0x26,
+  0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x07, 0x26, 0x27, 0x36, 0x37, 0x16,
+  0x17, 0x06, 0x03, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x27, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x32,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x33, 0x06, 0x13, 0x36, 0x37, 0x32, 0x1f, 0x01, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x20, 0x24, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x37, 0x01, 0x17, 0x27,
+  0x26, 0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f,
+  0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23,
+  0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27,
+  0x26, 0x35, 0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01,
+  0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14,
+  0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06,
+  0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32,
+  0x05, 0x17, 0x27, 0x26, 0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32,
+  0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01,
+  0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34,
+  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x13, 0x17, 0x27, 0x26,
+  0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17,
+  0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35,
+  0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35,
+  0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x33, 0x32, 0x0f, 0x01, 0x37,
+  0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23,
+  0x22, 0x2f, 0x01, 0x17, 0x14, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23,
+  0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x01,
+  0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14,
+  0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x14,
+  0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27,
+  0x26, 0x35, 0x34, 0x33, 0x32, 0x05, 0x17, 0x27, 0x34, 0x33, 0x32, 0x15,
+  0x07, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15,
+  0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07,
+  0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33,
+  0x32, 0x03, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32,
+  0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01,
+  0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34,
+  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x05, 0x17, 0x27, 0x26,
+  0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17,
+  0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22, 0x35,
+  0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35,
+  0x34, 0x33, 0x32, 0x1f, 0x01, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36,
+  0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x14, 0x23, 0x22, 0x2f,
+  0x01, 0x17, 0x14, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x34,
+  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x37, 0x17, 0x27, 0x34,
+  0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01,
+  0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x23, 0x22,
+  0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26,
+  0x35, 0x34, 0x33, 0x32, 0x37, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37,
+  0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23,
+  0x22, 0x2f, 0x01, 0x17, 0x16, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22,
+  0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x13, 0x26,
+  0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x05, 0x26, 0x27, 0x36, 0x37, 0x16,
+  0x17, 0x06, 0x17, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x01, 0x17,
+  0x27, 0x26, 0x33, 0x32, 0x15, 0x07, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14,
+  0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16,
+  0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01,
+  0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x32, 0x0f,
+  0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15,
+  0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x14, 0x22, 0x35, 0x37, 0x07, 0x06,
+  0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32,
+  0x05, 0x17, 0x27, 0x26, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32, 0x15,
+  0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01, 0x17,
+  0x16, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34, 0x3f, 0x01,
+  0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x01, 0x17, 0x27, 0x26, 0x32, 0x0f,
+  0x01, 0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15,
+  0x14, 0x23, 0x22, 0x2f, 0x01, 0x17, 0x16, 0x22, 0x35, 0x37, 0x07, 0x06,
+  0x23, 0x22, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32,
+  0x01, 0x17, 0x27, 0x26, 0x33, 0x32, 0x0f, 0x01, 0x37, 0x36, 0x33, 0x32,
+  0x15, 0x14, 0x0f, 0x01, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x2f, 0x01,
+  0x17, 0x16, 0x23, 0x22, 0x35, 0x37, 0x07, 0x06, 0x23, 0x22, 0x35, 0x34,
+  0x3f, 0x01, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x03, 0x96, 0x07, 0x07,
+  0x3c, 0x16, 0x17, 0x05, 0x73, 0x71, 0x08, 0x15, 0x21, 0x36, 0x07, 0x6e,
+  0x26, 0x01, 0x03, 0x26, 0x23, 0x03, 0x03, 0xf9, 0x25, 0x02, 0x02, 0x27,
+  0x24, 0x03, 0x03, 0x3a, 0x22, 0x02, 0x03, 0x23, 0x21, 0x01, 0x01, 0xb6,
+  0x70, 0xde, 0x9e, 0x9c, 0xe0, 0x70, 0x5b, 0x7d, 0x02, 0x03, 0x36, 0x28,
+  0x3b, 0x71, 0x54, 0x52, 0x7d, 0x3c, 0x28, 0x32, 0x82, 0x13, 0x17, 0x85,
+  0x77, 0x2c, 0x02, 0x4a, 0x44, 0x12, 0x16, 0x64, 0x4e, 0x80, 0xff, 0xfe,
+  0x92, 0xff, 0x00, 0x80, 0x53, 0x6a, 0x12, 0x12, 0x44, 0x44, 0xfd, 0xe5,
+  0x25, 0x05, 0x01, 0x0d, 0x10, 0x02, 0x05, 0x24, 0x03, 0x04, 0x0e, 0x07,
+  0x2b, 0x2a, 0x08, 0x0e, 0x04, 0x03, 0x24, 0x05, 0x01, 0x0f, 0x0c, 0x04,
+  0x24, 0x02, 0x05, 0x0c, 0x08, 0x29, 0x2c, 0x06, 0x0d, 0x05, 0x01, 0x0a,
+  0x21, 0x05, 0x02, 0x1b, 0x02, 0x05, 0x21, 0x04, 0x03, 0x0d, 0x06, 0x28,
+  0x26, 0x06, 0x0b, 0x04, 0x03, 0x1f, 0x03, 0x01, 0x0c, 0x0c, 0x04, 0x20,
+  0x03, 0x03, 0x0c, 0x07, 0x25, 0x26, 0x07, 0x0d, 0x03, 0x03, 0x0f, 0x21,
+  0x05, 0x02, 0x0d, 0x0e, 0x01, 0x06, 0x21, 0x03, 0x05, 0x0b, 0x06, 0x27,
+  0x25, 0x07, 0x0a, 0x06, 0x02, 0x20, 0x05, 0x01, 0x0e, 0x0b, 0x04, 0x20,
+  0x03, 0x03, 0x0d, 0x08, 0x25, 0x26, 0x07, 0x0d, 0x03, 0x5c, 0x21, 0x06,
+  0x01, 0x1b, 0x02, 0x06, 0x22, 0x03, 0x04, 0x0c, 0x06, 0x27, 0x25, 0x07,
+  0x0b, 0x06, 0x01, 0x21, 0x05, 0x01, 0x0d, 0x0c, 0x05, 0x20, 0x03, 0x04,
+  0x0b, 0x07, 0x25, 0x26, 0x07, 0x0c, 0x04, 0xfc, 0x37, 0x11, 0x02, 0x01,
+  0x06, 0x07, 0x01, 0x02, 0x12, 0x01, 0x01, 0x08, 0x03, 0x16, 0x15, 0x04,
+  0x08, 0x01, 0x01, 0x11, 0x01, 0x06, 0x05, 0x02, 0x11, 0x02, 0x03, 0x05,
+  0x03, 0x15, 0x16, 0x02, 0x07, 0x01, 0x02, 0xc8, 0x12, 0x02, 0x01, 0x10,
+  0x01, 0x03, 0x13, 0x02, 0x02, 0x08, 0x04, 0x17, 0x16, 0x04, 0x07, 0x02,
+  0x02, 0x13, 0x03, 0x0e, 0x02, 0x12, 0x02, 0x02, 0x07, 0x03, 0x17, 0x17,
+  0x04, 0x08, 0x02, 0xfd, 0x0e, 0x12, 0x04, 0x06, 0x08, 0x04, 0x11, 0x03,
+  0x02, 0x07, 0x05, 0x14, 0x14, 0x04, 0x06, 0x02, 0x03, 0x11, 0x03, 0x01,
+  0x08, 0x06, 0x04, 0x12, 0x02, 0x02, 0x06, 0x03, 0x14, 0x14, 0x04, 0x07,
+  0x02, 0x53, 0x12, 0x04, 0x01, 0x0f, 0x01, 0x03, 0x11, 0x03, 0x02, 0x06,
+  0x03, 0x15, 0x14, 0x04, 0x06, 0x02, 0x03, 0x11, 0x03, 0x01, 0x07, 0x07,
+  0x03, 0x11, 0x02, 0x02, 0x07, 0x05, 0x13, 0x13, 0x05, 0x07, 0x02, 0x01,
+  0x00, 0x11, 0x02, 0x01, 0x0f, 0x01, 0x03, 0x11, 0x01, 0x03, 0x07, 0x04,
+  0x14, 0x13, 0x05, 0x07, 0x03, 0x01, 0x11, 0x03, 0x01, 0x08, 0x06, 0x02,
+  0x11, 0x02, 0x01, 0x07, 0x04, 0x14, 0x15, 0x03, 0x07, 0x01, 0x64, 0x11,
+  0x02, 0x02, 0x0f, 0x01, 0x03, 0x12, 0x01, 0x02, 0x07, 0x03, 0x15, 0x15,
+  0x03, 0x07, 0x02, 0x01, 0x11, 0x02, 0x06, 0x06, 0x02, 0x11, 0x02, 0x03,
+  0x05, 0x04, 0x13, 0x14, 0x03, 0x05, 0x03, 0xde, 0x13, 0x02, 0x06, 0x08,
+  0x01, 0x03, 0x14, 0x01, 0x04, 0x07, 0x05, 0x17, 0x16, 0x06, 0x07, 0x04,
+  0x02, 0x12, 0x02, 0x01, 0x08, 0x06, 0x02, 0x13, 0x02, 0x02, 0x07, 0x04,
+  0x16, 0x17, 0x03, 0x07, 0x02, 0x52, 0x13, 0x02, 0x01, 0x10, 0x01, 0x04,
+  0x14, 0x02, 0x02, 0x07, 0x03, 0x17, 0x16, 0x04, 0x07, 0x02, 0x02, 0x14,
+  0x03, 0x01, 0x0e, 0x02, 0x13, 0x01, 0x03, 0x07, 0x04, 0x17, 0x18, 0x03,
+  0x08, 0x02, 0x9c, 0x21, 0x02, 0x02, 0x25, 0x1f, 0x03, 0x03, 0xfe, 0xd8,
+  0x22, 0x02, 0x03, 0x23, 0x21, 0x01, 0x01, 0xe3, 0x22, 0x02, 0x02, 0x25,
+  0x1f, 0x03, 0x03, 0x01, 0x3d, 0x20, 0x05, 0x01, 0x0d, 0x0d, 0x06, 0x20,
+  0x03, 0x05, 0x0b, 0x06, 0x26, 0x25, 0x07, 0x0b, 0x05, 0x03, 0x20, 0x04,
+  0x02, 0x0d, 0x0c, 0x05, 0x20, 0x03, 0x04, 0x0d, 0x08, 0x26, 0x27, 0x07,
+  0x0d, 0x04, 0xfc, 0xb3, 0x12, 0x02, 0x01, 0x10, 0x01, 0x04, 0x13, 0x03,
+  0x02, 0x08, 0x04, 0x17, 0x16, 0x04, 0x07, 0x02, 0x03, 0x13, 0x04, 0x0e,
+  0x02, 0x12, 0x02, 0x02, 0x07, 0x03, 0x17, 0x18, 0x03, 0x08, 0x02, 0xfe,
+  0x7c, 0x14, 0x03, 0x01, 0x10, 0x01, 0x02, 0x13, 0x01, 0x02, 0x07, 0x02,
+  0x18, 0x17, 0x03, 0x07, 0x02, 0x01, 0x13, 0x01, 0x01, 0x0e, 0x03, 0x14,
+  0x01, 0x02, 0x08, 0x05, 0x16, 0x17, 0x04, 0x08, 0x02, 0x03, 0xc5, 0x14,
+  0x03, 0x01, 0x10, 0x01, 0x03, 0x13, 0x02, 0x02, 0x07, 0x02, 0x18, 0x17,
+  0x03, 0x07, 0x02, 0x02, 0x13, 0x02, 0x01, 0x0e, 0x03, 0x14, 0x01, 0x03,
+  0x07, 0x05, 0x16, 0x17, 0x04, 0x08, 0x02, 0xfc, 0xa4, 0x22, 0x05, 0x02,
+  0x0d, 0x0e, 0x02, 0x05, 0x21, 0x03, 0x05, 0x0b, 0x06, 0x27, 0x25, 0x07,
+  0x0a, 0x06, 0x02, 0x20, 0x04, 0x01, 0x0d, 0x0b, 0x04, 0x21, 0x02, 0x03,
+  0x0d, 0x07, 0x26, 0x26, 0x08, 0x0e, 0x03, 0x03, 0x89, 0x01, 0x26, 0x45,
+  0x05, 0x07, 0x43, 0x26, 0x56, 0x02, 0x2a, 0x2c, 0x03, 0x03, 0x29, 0x2d,
+  0x04, 0x02, 0x29, 0x2d, 0x03, 0x03, 0x2a, 0x2c, 0xfe, 0x12, 0x02, 0x25,
+  0x26, 0x02, 0x02, 0x25, 0x26, 0x9e, 0x66, 0x93, 0x91, 0xd0, 0xd0, 0x91,
+  0x93, 0x66, 0x55, 0x20, 0x33, 0x48, 0x68, 0x66, 0x65, 0x65, 0x66, 0x68,
+  0x48, 0x32, 0x1e, 0x01, 0xd9, 0x70, 0x18, 0x75, 0x13, 0x5e, 0xe8, 0x51,
+  0x18, 0x10, 0x1c, 0x46, 0x73, 0xa5, 0xa3, 0xe6, 0xe6, 0xa3, 0xa5, 0x73,
+  0x4b, 0x1a, 0x0f, 0x16, 0x51, 0xe8, 0x47, 0xfd, 0x68, 0x21, 0x39, 0x0f,
+  0x0f, 0x39, 0x21, 0x04, 0x11, 0x0b, 0x03, 0x15, 0x16, 0x03, 0x0c, 0x0f,
+  0x02, 0x21, 0x37, 0x10, 0x10, 0x37, 0x21, 0x02, 0x0f, 0x0c, 0x03, 0x16,
+  0x15, 0x03, 0x0b, 0x11, 0x01, 0xd1, 0x1f, 0x34, 0x0d, 0x0d, 0x34, 0x1f,
+  0x03, 0x10, 0x07, 0x05, 0x14, 0x13, 0x03, 0x09, 0x0e, 0x02, 0x1e, 0x32,
+  0x0f, 0x0f, 0x32, 0x1e, 0x02, 0x0e, 0x09, 0x03, 0x13, 0x14, 0x05, 0x07,
+  0x10, 0x4b, 0x1f, 0x34, 0x0e, 0x0e, 0x34, 0x1f, 0x03, 0x10, 0x07, 0x03,
+  0x15, 0x13, 0x04, 0x09, 0x0e, 0x02, 0x1e, 0x32, 0x0e, 0x0e, 0x32, 0x1e,
+  0x02, 0x0e, 0x09, 0x04, 0x13, 0x15, 0x03, 0x07, 0x10, 0x01, 0x1b, 0x1e,
+  0x32, 0x0e, 0x0e, 0x32, 0x1e, 0x02, 0x0e, 0x09, 0x04, 0x13, 0x14, 0x03,
+  0x09, 0x0f, 0x03, 0x1d, 0x31, 0x0e, 0x0e, 0x31, 0x1d, 0x03, 0x0f, 0x09,
+  0x03, 0x14, 0x13, 0x04, 0x09, 0x0e, 0x02, 0x9a, 0x10, 0x1c, 0x06, 0x06,
+  0x1c, 0x10, 0x01, 0x07, 0x06, 0x02, 0x09, 0x0b, 0x02, 0x04, 0x08, 0x02,
+  0x0e, 0x19, 0x07, 0x07, 0x19, 0x0e, 0x02, 0x08, 0x04, 0x02, 0x0b, 0x09,
+  0x02, 0x06, 0x07, 0xfe, 0xe3, 0x11, 0x1d, 0x0a, 0x0a, 0x1d, 0x11, 0x03,
+  0x0a, 0x05, 0x01, 0x0d, 0x0a, 0x03, 0x06, 0x07, 0x01, 0x11, 0x1e, 0x07,
+  0x07, 0x1e, 0x11, 0x01, 0x07, 0x06, 0x03, 0x0a, 0x0d, 0x01, 0x05, 0x0a,
+  0xa8, 0x10, 0x1c, 0x07, 0x07, 0x1c, 0x10, 0x02, 0x07, 0x06, 0x02, 0x09,
+  0x0b, 0x02, 0x05, 0x08, 0x02, 0x0f, 0x1a, 0x08, 0x08, 0x1a, 0x0f, 0x02,
+  0x08, 0x05, 0x02, 0x0b, 0x09, 0x02, 0x06, 0x07, 0x01, 0x18, 0x10, 0x1c,
+  0x06, 0x06, 0x1c, 0x10, 0x02, 0x08, 0x04, 0x03, 0x0a, 0x0a, 0x02, 0x05,
+  0x07, 0x01, 0x0f, 0x19, 0x08, 0x08, 0x19, 0x0f, 0x01, 0x07, 0x05, 0x02,
+  0x0a, 0x0a, 0x03, 0x04, 0x08, 0x18, 0x0f, 0x1b, 0x07, 0x07, 0x1b, 0x0f,
+  0x02, 0x08, 0x05, 0x01, 0x0a, 0x0b, 0x01, 0x06, 0x07, 0x01, 0x10, 0x1b,
+  0x08, 0x08, 0x1b, 0x10, 0x01, 0x07, 0x06, 0x01, 0x0b, 0x0a, 0x01, 0x06,
+  0x07, 0xa1, 0x0f, 0x1b, 0x07, 0x07, 0x1b, 0x0f, 0x01, 0x07, 0x04, 0x01,
+  0x0c, 0x0a, 0x01, 0x0c, 0x01, 0x0f, 0x1b, 0x07, 0x07, 0x1b, 0x0f, 0x01,
+  0x0c, 0x01, 0x0a, 0x0c, 0x01, 0x04, 0x07, 0x37, 0x12, 0x1f, 0x07, 0x07,
+  0x1f, 0x12, 0x01, 0x08, 0x05, 0x02, 0x0c, 0x0c, 0x02, 0x05, 0x08, 0x01,
+  0x12, 0x1d, 0x0a, 0x0a, 0x1d, 0x12, 0x01, 0x08, 0x05, 0x02, 0x0c, 0x0c,
+  0x02, 0x05, 0x08, 0xd9, 0x12, 0x1f, 0x07, 0x07, 0x1f, 0x12, 0x01, 0x08,
+  0x05, 0x02, 0x0b, 0x0c, 0x02, 0x05, 0x0a, 0x03, 0x10, 0x1c, 0x09, 0x09,
+  0x1c, 0x10, 0x03, 0x0a, 0x05, 0x02, 0x0c, 0x0b, 0x02, 0x06, 0x07, 0xfa,
+  0xe0, 0x02, 0x25, 0x26, 0x02, 0x02, 0x25, 0x26, 0xe2, 0x02, 0x25, 0x27,
+  0x02, 0x03, 0x25, 0x26, 0x02, 0x02, 0x25, 0x27, 0x02, 0x03, 0x25, 0x26,
+  0x01, 0x81, 0x1d, 0x32, 0x0e, 0x0e, 0x32, 0x1d, 0x03, 0x0f, 0x09, 0x03,
+  0x13, 0x14, 0x03, 0x0a, 0x0e, 0x04, 0x1b, 0x2f, 0x0f, 0x0f, 0x2f, 0x1b,
+  0x04, 0x0e, 0x0a, 0x03, 0x14, 0x13, 0x03, 0x09, 0x0f, 0x02, 0x67, 0x12,
+  0x1e, 0x08, 0x08, 0x1e, 0x12, 0x01, 0x0a, 0x04, 0x02, 0x0b, 0x0c, 0x02,
+  0x06, 0x08, 0x02, 0x11, 0x1d, 0x09, 0x09, 0x1d, 0x11, 0x02, 0x08, 0x06,
+  0x02, 0x0c, 0x0b, 0x02, 0x04, 0x0a, 0xfb, 0x12, 0x1f, 0x07, 0x07, 0x1f,
+  0x12, 0x01, 0x08, 0x05, 0x03, 0x0b, 0x0c, 0x02, 0x05, 0x09, 0x01, 0x12,
+  0x1c, 0x0a, 0x0a, 0x1c, 0x12, 0x01, 0x09, 0x05, 0x02, 0x0c, 0x0b, 0x03,
+  0x05, 0x08, 0x01, 0x82, 0x11, 0x1e, 0x08, 0x08, 0x1e, 0x11, 0x02, 0x08,
+  0x07, 0x01, 0x0b, 0x0c, 0x02, 0x05, 0x09, 0x01, 0x11, 0x1c, 0x09, 0x09,
+  0x1c, 0x11, 0x01, 0x09, 0x05, 0x02, 0x0c, 0x0b, 0x01, 0x07, 0x08, 0xfd,
+  0x7f, 0x1f, 0x34, 0x0e, 0x0e, 0x34, 0x1f, 0x03, 0x10, 0x07, 0x04, 0x14,
+  0x13, 0x03, 0x0a, 0x0e, 0x03, 0x1d, 0x32, 0x0e, 0x0e, 0x32, 0x1d, 0x03,
+  0x0e, 0x0a, 0x03, 0x13, 0x14, 0x04, 0x07, 0x10, 0x00, 0x0f, 0x00, 0x75,
+  0x00, 0x00, 0x05, 0xff, 0x07, 0x0b, 0x00, 0x17, 0x00, 0x2d, 0x00, 0x3e,
+  0x00, 0x4f, 0x00, 0x60, 0x00, 0x71, 0x00, 0x82, 0x00, 0x93, 0x00, 0xa4,
+  0x00, 0xb5, 0x00, 0xc6, 0x00, 0xd7, 0x00, 0xe8, 0x00, 0xf9, 0x01, 0x0a,
+  0x00, 0x00, 0x01, 0x16, 0x15, 0x14, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x2b,
+  0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x3f, 0x02, 0x36, 0x33, 0x32, 0x33,
+  0x16, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x33, 0x32,
+  0x3f, 0x01, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x26, 0x23, 0x22, 0x07, 0x13,
+  0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01,
+  0x35, 0x34, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x13, 0x32, 0x17,
+  0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34,
+  0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d,
+  0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x3d, 0x01, 0x34, 0x37, 0x36,
+  0x03, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f,
+  0x01, 0x35, 0x34, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37, 0x32,
+  0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35,
+  0x34, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16,
+  0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x25, 0x32, 0x17, 0x16, 0x1d, 0x01,
+  0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x32, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01,
+  0x35, 0x34, 0x37, 0x36, 0x02, 0x0a, 0x29, 0x17, 0x12, 0x2d, 0x13, 0x56,
+  0x6f, 0x14, 0x2f, 0x22, 0x2a, 0x36, 0x25, 0x0b, 0x5a, 0x7b, 0x03, 0x03,
+  0x38, 0xec, 0x47, 0x08, 0x05, 0x0c, 0x0d, 0x1b, 0x27, 0x2f, 0x41, 0x2e,
+  0x4a, 0x04, 0x1d, 0x1c, 0x2c, 0x31, 0x44, 0xdf, 0x1a, 0x0d, 0x07, 0x18,
+  0x0a, 0x0b, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0x97, 0x1a, 0x0d, 0x07, 0x18,
+  0x09, 0x0c, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0x7c, 0x19, 0x0e, 0x06, 0x17,
+  0x09, 0x0d, 0x1f, 0x0d, 0x01, 0x17, 0x0c, 0x8c, 0x19, 0x0d, 0x07, 0x18,
+  0x09, 0x0c, 0x20, 0x0c, 0x01, 0x17, 0x0c, 0x02, 0x1a, 0x0d, 0x07, 0x18,
+  0x09, 0x0d, 0x1f, 0x0d, 0x17, 0x0c, 0xab, 0x1b, 0x0d, 0x06, 0x17, 0x0a,
+  0x0c, 0x20, 0x0c, 0x01, 0x18, 0x0c, 0x01, 0x62, 0x19, 0x0e, 0x06, 0x17,
+  0x09, 0x0d, 0x1f, 0x0d, 0x01, 0x17, 0x0c, 0xaf, 0x1a, 0x0d, 0x07, 0x18,
+  0x0a, 0x0b, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0xae, 0x1a, 0x0e, 0x06, 0x17,
+  0x0a, 0x0c, 0x20, 0x0c, 0x01, 0x18, 0x0b, 0xfd, 0x9a, 0x1a, 0x0d, 0x07,
+  0x18, 0x0a, 0x0b, 0x21, 0x0b, 0x01, 0x17, 0x0c, 0xf6, 0x1a, 0x0d, 0x06,
+  0x17, 0x09, 0x0d, 0x1f, 0x0d, 0x01, 0x18, 0x0b, 0x01, 0x05, 0x1b, 0x0d,
+  0x06, 0x17, 0x0a, 0x0c, 0x20, 0x0c, 0x01, 0x18, 0x0b, 0xea, 0x19, 0x0d,
+  0x06, 0x17, 0x09, 0x0c, 0x20, 0x0d, 0x01, 0x18, 0x0c, 0x02, 0x20, 0x37,
+  0x51, 0x3d, 0x4b, 0x47, 0x3c, 0x1a, 0x73, 0x07, 0x2d, 0x38, 0x50, 0x5a,
+  0x79, 0x39, 0x0e, 0x7a, 0x0c, 0x80, 0x5f, 0x65, 0x22, 0x22, 0x16, 0x10,
+  0x12, 0x23, 0x2f, 0x32, 0x64, 0x74, 0x1a, 0x1b, 0x30, 0x26, 0x32, 0x01,
+  0x6a, 0x1f, 0x0c, 0x0f, 0x06, 0x1f, 0x12, 0x07, 0x2c, 0x0e, 0x03, 0x1f,
+  0x14, 0x08, 0x01, 0x3a, 0x1e, 0x0c, 0x0f, 0x07, 0x1e, 0x13, 0x08, 0x2e,
+  0x0c, 0x05, 0x1e, 0x14, 0x08, 0x01, 0x34, 0x1f, 0x0c, 0x0e, 0x07, 0x1e,
+  0x14, 0x07, 0x2e, 0x0c, 0x05, 0x1e, 0x14, 0x08, 0x01, 0x3d, 0x1f, 0x0c,
+  0x0f, 0x06, 0x1f, 0x12, 0x07, 0x2c, 0x0d, 0x04, 0x1f, 0x14, 0x08, 0xfd,
+  0x02, 0x1f, 0x0c, 0x0f, 0x06, 0x1f, 0x12, 0x07, 0x2c, 0x0e, 0x03, 0x20,
+  0x13, 0x08, 0xfe, 0xfc, 0x1f, 0x0c, 0x0e, 0x06, 0x20, 0x12, 0x07, 0x2d,
+  0x0d, 0x04, 0x1f, 0x13, 0x08, 0x02, 0x07, 0x1e, 0x0c, 0x0f, 0x07, 0x1e,
+  0x13, 0x07, 0x2d, 0x0c, 0x05, 0x1e, 0x15, 0x07, 0xfa, 0x1e, 0x0c, 0x0f,
+  0x07, 0x1e, 0x13, 0x07, 0x2d, 0x0c, 0x05, 0x1e, 0x15, 0x07, 0x01, 0x04,
+  0x20, 0x0c, 0x0e, 0x06, 0x1f, 0x12, 0x08, 0x2d, 0x0d, 0x04, 0x1f, 0x13,
+  0x09, 0xfb, 0x0c, 0x1e, 0x0c, 0x0f, 0x07, 0x1e, 0x13, 0x08, 0x2e, 0x0c,
+  0x05, 0x1e, 0x14, 0x08, 0xd3, 0x1e, 0x0c, 0x0e, 0x07, 0x1e, 0x14, 0x07,
+  0x2e, 0x0c, 0x05, 0x1e, 0x14, 0x07, 0xe7, 0x1f, 0x0c, 0x0e, 0x06, 0x20,
+  0x12, 0x07, 0x2c, 0x0e, 0x03, 0x20, 0x13, 0x08, 0xca, 0x1f, 0x0c, 0x0e,
+  0x06, 0x20, 0x12, 0x07, 0x2d, 0x0d, 0x03, 0x20, 0x13, 0x08, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x77, 0xff, 0xf7, 0x05, 0xfd, 0x05, 0xc9, 0x00, 0x09,
+  0x00, 0x00, 0x13, 0x21, 0x1b, 0x01, 0x21, 0x01, 0x13, 0x09, 0x01, 0x13,
+  0x78, 0x02, 0x1b, 0xa7, 0xa8, 0x02, 0x1b, 0xfe, 0x4c, 0xa7, 0xfe, 0x4a,
+  0xfe, 0x4b, 0xa6, 0x03, 0x90, 0x02, 0x39, 0xfd, 0xc7, 0xfe, 0x9f, 0xfd,
+  0xc8, 0x01, 0x60, 0xfe, 0xa0, 0x02, 0x38, 0x00, 0x00, 0x02, 0x00, 0x77,
+  0xff, 0xf7, 0x05, 0xfd, 0x05, 0xc9, 0x00, 0x09, 0x00, 0x13, 0x00, 0x00,
+  0x13, 0x21, 0x1b, 0x01, 0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x37, 0x03,
+  0x09, 0x01, 0x03, 0x01, 0x21, 0x0b, 0x01, 0x21, 0x78, 0x02, 0x1b, 0xa7,
+  0xa8, 0x02, 0x1b, 0xfe, 0x4c, 0xa7, 0xfe, 0x4a, 0xfe, 0x4b, 0xa6, 0x3d,
+  0x7e, 0x01, 0x50, 0x01, 0x5a, 0x89, 0x01, 0x67, 0xfe, 0x4b, 0x83, 0x80,
+  0xfe, 0x49, 0x03, 0x90, 0x02, 0x39, 0xfd, 0xc7, 0xfe, 0x9f, 0xfd, 0xc8,
+  0x01, 0x60, 0xfe, 0xa0, 0x02, 0x38, 0x15, 0xfe, 0x4e, 0x01, 0x0c, 0xfe,
+  0xe6, 0x01, 0xc2, 0x01, 0x18, 0x01, 0xb7, 0xfe, 0x49, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x99, 0x00, 0x04, 0x03, 0x87, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x00, 0x01, 0x16, 0x17, 0x14, 0x07, 0x09, 0x01, 0x37, 0x13, 0x25,
+  0x37, 0x01, 0x26, 0x35, 0x34, 0x37, 0x01, 0x36, 0x03, 0x52, 0x33, 0x02,
+  0x08, 0xfd, 0xbd, 0x01, 0xbc, 0x4e, 0x22, 0xfe, 0x65, 0xc9, 0xfe, 0x14,
+  0x11, 0x3b, 0x02, 0x51, 0x09, 0x05, 0xd5, 0x02, 0x36, 0x24, 0x0c, 0xfd,
+  0x85, 0xfd, 0xf4, 0xe6, 0xfe, 0x38, 0x27, 0x5e, 0x02, 0x34, 0x17, 0x17,
+  0x1b, 0x3f, 0x02, 0x86, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdb, 0x05, 0xd9, 0x00, 0x19, 0x00, 0x00, 0x13, 0x21,
+  0x32, 0x15, 0x14, 0x07, 0x09, 0x01, 0x37, 0x13, 0x25, 0x37, 0x01, 0x26,
+  0x35, 0x34, 0x37, 0x01, 0x21, 0x11, 0x06, 0x07, 0x26, 0x27, 0x11, 0x36,
+  0xd5, 0x04, 0xc2, 0x3a, 0x19, 0xfd, 0xfb, 0x01, 0xb6, 0x50, 0x21, 0xfe,
+  0x60, 0xd0, 0xfe, 0x24, 0x0e, 0x2f, 0x01, 0xb4, 0xfc, 0x18, 0x01, 0x41,
+  0x3f, 0x01, 0x01, 0x05, 0xd9, 0x53, 0x22, 0x1b, 0xfd, 0xc5, 0xfe, 0x1b,
+  0xd5, 0xfe, 0x3d, 0x22, 0x6c, 0x02, 0x16, 0x10, 0x2d, 0x1c, 0x32, 0x01,
+  0xdf, 0xfa, 0xfc, 0x44, 0x01, 0x01, 0x43, 0x05, 0x5b, 0x39, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd8, 0x00, 0x0d,
+  0x00, 0x19, 0x00, 0x26, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x05, 0x10, 0x00, 0x20,
+  0x00, 0x11, 0x34, 0x02, 0x24, 0x20, 0x04, 0x02, 0x05, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x05, 0xdb, 0xfe,
+  0x76, 0xfe, 0xe8, 0xfe, 0xea, 0xfe, 0x76, 0xb5, 0x01, 0x44, 0xa7, 0xaa,
+  0x01, 0x44, 0xb4, 0xfb, 0x00, 0x01, 0x62, 0x01, 0xf8, 0x01, 0x63, 0xa2,
+  0xfe, 0xdc, 0xfe, 0xce, 0xfe, 0xdd, 0xa2, 0x03, 0x07, 0x62, 0x46, 0x45,
+  0x63, 0x2d, 0x51, 0x54, 0x52, 0x2c, 0x02, 0xec, 0xfe, 0xc9, 0xfe, 0x4b,
+  0x01, 0xb5, 0x01, 0x37, 0xc2, 0x01, 0x69, 0xc1, 0xc1, 0xfe, 0x99, 0xc4,
+  0xfe, 0xe8, 0xfe, 0x77, 0x01, 0x89, 0x01, 0x18, 0xb1, 0x01, 0x42, 0xae,
+  0xae, 0xfe, 0xbe, 0xb1, 0x4e, 0x6d, 0x6d, 0x4e, 0x31, 0x5a, 0x30, 0x30,
+  0x5a, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x70, 0x00, 0x00, 0x05, 0xf6,
+  0x05, 0xd1, 0x00, 0x0a, 0x00, 0x16, 0x00, 0x43, 0x00, 0x00, 0x00, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x25, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x25, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x24, 0x20, 0x04, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
+  0x10, 0x06, 0x23, 0x22, 0x26, 0x10, 0x37, 0x36, 0x37, 0x26, 0x35, 0x34,
+  0x00, 0x21, 0x20, 0x00, 0x15, 0x14, 0x05, 0x1f, 0x85, 0x5d, 0x5d, 0x43,
+  0x41, 0x5e, 0xfc, 0x0c, 0x41, 0x5e, 0x5e, 0x41, 0x43, 0x5d, 0x5d, 0x03,
+  0xae, 0x17, 0x14, 0x52, 0xa4, 0x75, 0x74, 0xa4, 0x51, 0x49, 0x64, 0x6d,
+  0xfe, 0xd2, 0xfe, 0x50, 0xfe, 0xd2, 0x6d, 0x71, 0x4e, 0x51, 0xa4, 0x75,
+  0x73, 0xa5, 0x52, 0x11, 0x11, 0x6e, 0x01, 0x93, 0x01, 0x21, 0x01, 0x24,
+  0x01, 0x93, 0x01, 0xe9, 0x67, 0x4a, 0x49, 0x67, 0x67, 0x49, 0x4a, 0x67,
+  0x67, 0x4a, 0x49, 0x68, 0x68, 0x49, 0x4a, 0x67, 0x55, 0x11, 0x16, 0x5c,
+  0x82, 0x81, 0xb7, 0xb7, 0x81, 0x82, 0x5c, 0x51, 0x09, 0x73, 0x99, 0xb4,
+  0xfd, 0xfd, 0xb4, 0x99, 0x72, 0x04, 0x57, 0x5c, 0xfe, 0xfc, 0xb7, 0xb7,
+  0x01, 0x04, 0x5c, 0x11, 0x0f, 0x8e, 0xb6, 0xf8, 0x01, 0x5e, 0xfe, 0xa2,
+  0xf8, 0xb1, 0x00, 0x00, 0x00, 0x03, 0x00, 0x70, 0x00, 0x00, 0x05, 0xf6,
+  0x05, 0xc9, 0x00, 0x0a, 0x00, 0x16, 0x00, 0x41, 0x00, 0x00, 0x01, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x25, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x01, 0x14, 0x00,
+  0x21, 0x20, 0x00, 0x35, 0x34, 0x37, 0x26, 0x27, 0x26, 0x10, 0x36, 0x33,
+  0x32, 0x16, 0x10, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x04, 0x20, 0x24,
+  0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x10, 0x36, 0x33, 0x32, 0x16, 0x10,
+  0x07, 0x06, 0x07, 0x16, 0x05, 0x7c, 0x5e, 0x41, 0x43, 0x5d, 0x5d, 0x85,
+  0x5d, 0xfc, 0xac, 0x5d, 0x43, 0x41, 0x5e, 0x5e, 0x41, 0x43, 0x5d, 0x03,
+  0xb9, 0xfe, 0x6d, 0xfe, 0xdc, 0xfe, 0xdf, 0xfe, 0x6d, 0x6e, 0x11, 0x11,
+  0x52, 0xa5, 0x73, 0x75, 0xa4, 0x51, 0x4e, 0x71, 0x6d, 0x01, 0x2e, 0x01,
+  0xb0, 0x01, 0x2e, 0x6d, 0x64, 0x49, 0x51, 0xa4, 0x74, 0x75, 0xa4, 0x52,
+  0x14, 0x17, 0x68, 0x04, 0x91, 0x49, 0x68, 0x68, 0x49, 0x4a, 0x67, 0x67,
+  0x4a, 0x4a, 0x67, 0x67, 0x4a, 0x49, 0x67, 0x67, 0xfe, 0x0c, 0xf7, 0xfe,
+  0xa3, 0x01, 0x5d, 0xf7, 0xb4, 0x8d, 0x0f, 0x12, 0x5b, 0x01, 0x02, 0xb6,
+  0xb6, 0xfe, 0xfe, 0x5b, 0x58, 0x03, 0x72, 0x97, 0xb4, 0xfb, 0xfb, 0xb4,
+  0x98, 0x71, 0x09, 0x51, 0x5c, 0x01, 0x02, 0xb6, 0xb6, 0xfe, 0xfe, 0x5c,
+  0x16, 0x11, 0x8b, 0x00, 0x00, 0x02, 0x00, 0x70, 0xff, 0xfd, 0x04, 0x65,
+  0x05, 0xc6, 0x00, 0x0b, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x37, 0x16, 0x17, 0x16,
+  0x10, 0x00, 0x23, 0x22, 0x00, 0x10, 0x00, 0x33, 0x32, 0x17, 0x13, 0x17,
+  0x02, 0x45, 0x80, 0xb5, 0xb5, 0x80, 0x80, 0xb5, 0xb3, 0xab, 0x11, 0x10,
+  0x89, 0xfe, 0xed, 0xc4, 0xc1, 0xfe, 0xec, 0x01, 0x11, 0xc4, 0x57, 0x4b,
+  0xf3, 0x8b, 0x03, 0x5f, 0xc8, 0x90, 0x8e, 0xc9, 0xc9, 0x8e, 0x90, 0xc8,
+  0x3b, 0x10, 0x13, 0x99, 0xfe, 0x50, 0xfe, 0xcf, 0x01, 0x31, 0x01, 0xb0,
+  0x01, 0x32, 0x1d, 0x01, 0xd3, 0x59, 0x00, 0x00, 0x00, 0x03, 0x00, 0x70,
+  0x00, 0x01, 0x06, 0xdb, 0x05, 0xc9, 0x00, 0x08, 0x00, 0x11, 0x00, 0x31,
+  0x00, 0x00, 0x01, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x26, 0x00,
+  0x22, 0x06, 0x14, 0x16, 0x33, 0x32, 0x36, 0x34, 0x01, 0x16, 0x15, 0x14,
+  0x02, 0x23, 0x22, 0x02, 0x35, 0x34, 0x12, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x37, 0x26, 0x35, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x02, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x01, 0xfb, 0x6c, 0x98, 0x98, 0xd8, 0x98, 0x97,
+  0x03, 0x54, 0xda, 0x97, 0x97, 0x6d, 0x6c, 0x98, 0xfd, 0x11, 0x23, 0xe8,
+  0xa4, 0xa3, 0xe8, 0xe6, 0xa5, 0xa6, 0x73, 0x02, 0x02, 0xc6, 0x19, 0xe5,
+  0xa5, 0xa6, 0xe6, 0xe7, 0xa5, 0xa3, 0x74, 0x0a, 0x0a, 0x02, 0xda, 0xa9,
+  0xf0, 0xa9, 0xa9, 0xf0, 0xa9, 0x02, 0x5a, 0xa9, 0xf0, 0xa9, 0xa9, 0xf0,
+  0xfd, 0xe4, 0x54, 0x64, 0xb5, 0xfe, 0xff, 0x01, 0x01, 0xb5, 0xb7, 0x01,
+  0x01, 0x80, 0x03, 0x02, 0x89, 0x49, 0x55, 0xb7, 0x01, 0x01, 0xfe, 0xff,
+  0xb7, 0xb5, 0xfe, 0xff, 0x81, 0x0b, 0x0c, 0x00, 0x00, 0x0e, 0x00, 0x7e,
+  0x00, 0x00, 0x08, 0x7a, 0x05, 0xd5, 0x00, 0x23, 0x00, 0x35, 0x00, 0x41,
+  0x00, 0x4d, 0x00, 0x59, 0x00, 0x65, 0x00, 0x72, 0x00, 0x80, 0x00, 0x8d,
+  0x00, 0x9a, 0x00, 0xa7, 0x00, 0xb5, 0x00, 0xc5, 0x00, 0xd9, 0x00, 0x00,
+  0x01, 0x33, 0x04, 0x17, 0x16, 0x15, 0x06, 0x23, 0x22, 0x27, 0x25, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x35, 0x34, 0x27, 0x21, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x05, 0x06, 0x23, 0x22, 0x27, 0x34, 0x37, 0x36,
+  0x01, 0x35, 0x33, 0x15, 0x14, 0x17, 0x16, 0x19, 0x01, 0x21, 0x11, 0x10,
+  0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x03, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x05, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x27, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x11, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x02, 0x16, 0x06, 0x07, 0x06, 0x26,
+  0x27, 0x26, 0x36, 0x37, 0x36, 0x33, 0x32, 0x01, 0x16, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x26, 0x27, 0x26, 0x36, 0x37, 0x36, 0x16, 0x01, 0x1e, 0x01,
+  0x0e, 0x01, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x3e, 0x01, 0x04, 0x1e,
+  0x01, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x24,
+  0x36, 0x16, 0x17, 0x16, 0x06, 0x07, 0x06, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x25, 0x36, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x26, 0x27,
+  0x26, 0x36, 0x01, 0x3e, 0x01, 0x17, 0x1e, 0x01, 0x07, 0x0e, 0x01, 0x23,
+  0x22, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x17,
+  0x1e, 0x01, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x2e, 0x01,
+  0x35, 0x34, 0x04, 0x78, 0x08, 0x02, 0x1f, 0xe7, 0xf4, 0x20, 0x5d, 0x06,
+  0x06, 0xfe, 0x92, 0x36, 0x0b, 0x3d, 0x1f, 0xfc, 0x0d, 0x1f, 0x3d, 0x0b,
+  0x37, 0xfe, 0x92, 0x07, 0x05, 0x5c, 0x21, 0xf5, 0xe6, 0x02, 0xf8, 0x81,
+  0xd9, 0xd0, 0xfa, 0x02, 0xd1, 0xd8, 0x82, 0x9a, 0xd4, 0x95, 0x97, 0xd3,
+  0xd2, 0x98, 0x96, 0xd3, 0x02, 0x34, 0x76, 0x55, 0x54, 0x76, 0x76, 0x54,
+  0x55, 0x76, 0x90, 0x1c, 0x16, 0x15, 0x1d, 0x1d, 0x15, 0x16, 0x1c, 0x1c,
+  0x16, 0x15, 0x1d, 0x1d, 0x15, 0x16, 0x1c, 0xbc, 0x18, 0x06, 0x11, 0x11,
+  0x29, 0x0d, 0x0c, 0x07, 0x11, 0x0d, 0x10, 0x04, 0x01, 0x72, 0x0d, 0x06,
+  0x12, 0x0d, 0x10, 0x04, 0x18, 0x0e, 0x0c, 0x07, 0x11, 0x11, 0x29, 0xfe,
+  0x3e, 0x16, 0x12, 0x0d, 0x26, 0x13, 0x14, 0x10, 0x02, 0x08, 0x25, 0x02,
+  0x1c, 0x27, 0x0f, 0x02, 0x08, 0x24, 0x14, 0x14, 0x13, 0x06, 0x08, 0xfd,
+  0xea, 0x27, 0x26, 0x07, 0x06, 0x12, 0x14, 0x15, 0x25, 0x08, 0x02, 0x02,
+  0x3f, 0x14, 0x24, 0x08, 0x02, 0x0f, 0x14, 0x13, 0x27, 0x06, 0x06, 0x13,
+  0xfe, 0x46, 0x0d, 0x29, 0x11, 0x11, 0x08, 0x0e, 0x0c, 0x19, 0x04, 0x10,
+  0x0d, 0x11, 0x05, 0x01, 0x57, 0x0e, 0x18, 0x04, 0x10, 0x0d, 0x12, 0x04,
+  0x0b, 0x0c, 0x18, 0x05, 0x10, 0x0d, 0x11, 0x04, 0x05, 0xd5, 0x11, 0x9b,
+  0xa4, 0xaa, 0x99, 0x01, 0x8c, 0x12, 0x2b, 0x13, 0x19, 0x47, 0x20, 0x17,
+  0x03, 0x03, 0x17, 0x20, 0x47, 0x18, 0x14, 0x2b, 0x12, 0x8c, 0x01, 0x99,
+  0xaa, 0xa4, 0x99, 0xfe, 0x76, 0x4b, 0x98, 0x4b, 0x39, 0x5f, 0xfe, 0xe2,
+  0xfe, 0x16, 0x01, 0xea, 0x01, 0x1e, 0x5f, 0x39, 0x4b, 0x98, 0x4b, 0xfd,
+  0xdd, 0xa7, 0xea, 0xea, 0xa7, 0xa6, 0xec, 0xec, 0xa5, 0x5d, 0x84, 0x84,
+  0x5d, 0x5f, 0x83, 0x83, 0xde, 0x16, 0x22, 0x22, 0x16, 0x18, 0x22, 0x22,
+  0xfd, 0x73, 0x18, 0x21, 0x21, 0x18, 0x17, 0x22, 0x22, 0x02, 0x57, 0x26,
+  0x2e, 0x0d, 0x0f, 0x07, 0x13, 0x14, 0x2d, 0x0f, 0x0a, 0xfd, 0xec, 0x13,
+  0x2e, 0x0f, 0x0a, 0x04, 0x14, 0x13, 0x2d, 0x0e, 0x0d, 0x06, 0x01, 0x61,
+  0x08, 0x29, 0x2c, 0x15, 0x06, 0x07, 0x22, 0x0d, 0x09, 0x09, 0x16, 0x15,
+  0xc3, 0x0e, 0x22, 0x0d, 0x08, 0x09, 0x16, 0x15, 0x08, 0x07, 0x29, 0x17,
+  0x16, 0x06, 0x0e, 0x14, 0x16, 0x18, 0x29, 0x08, 0x06, 0x15, 0x16, 0x09,
+  0x08, 0x0d, 0xec, 0x07, 0x15, 0x16, 0x09, 0x08, 0x0d, 0x21, 0x08, 0x07,
+  0x15, 0x16, 0x16, 0x29, 0xfe, 0x94, 0x12, 0x07, 0x0d, 0x0e, 0x2f, 0x11,
+  0x14, 0x04, 0x0a, 0x0f, 0x1c, 0x05, 0x11, 0x02, 0x0c, 0x13, 0x04, 0x0a,
+  0x0f, 0x1b, 0x04, 0x12, 0x10, 0x13, 0x04, 0x0c, 0x0d, 0x1c, 0x05, 0x11,
+  0x00, 0x10, 0x00, 0x82, 0x00, 0x00, 0x08, 0x7f, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x1d, 0x00, 0x25, 0x00, 0x2d, 0x00, 0x35, 0x00, 0x41, 0x00, 0x4d,
+  0x00, 0x59, 0x00, 0x64, 0x00, 0x70, 0x00, 0x7c, 0x00, 0x88, 0x00, 0x94,
+  0x00, 0xa6, 0x00, 0xca, 0x00, 0xf0, 0x00, 0x00, 0x01, 0x35, 0x23, 0x15,
+  0x06, 0x07, 0x06, 0x15, 0x11, 0x21, 0x11, 0x34, 0x27, 0x26, 0x27, 0x35,
+  0x23, 0x15, 0x07, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x16, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x02, 0x22,
+  0x06, 0x14, 0x16, 0x32, 0x36, 0x34, 0x02, 0x22, 0x06, 0x14, 0x16, 0x32,
+  0x36, 0x34, 0x03, 0x0e, 0x01, 0x17, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27,
+  0x2e, 0x01, 0x01, 0x0e, 0x01, 0x17, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27,
+  0x2e, 0x01, 0x01, 0x06, 0x16, 0x17, 0x16, 0x36, 0x37, 0x36, 0x26, 0x27,
+  0x26, 0x06, 0x05, 0x06, 0x16, 0x17, 0x16, 0x3e, 0x01, 0x26, 0x27, 0x26,
+  0x06, 0x05, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27, 0x2e, 0x01, 0x07, 0x0e,
+  0x01, 0x25, 0x1e, 0x01, 0x37, 0x3e, 0x01, 0x27, 0x2e, 0x01, 0x07, 0x0e,
+  0x01, 0x01, 0x16, 0x36, 0x37, 0x36, 0x26, 0x27, 0x26, 0x06, 0x07, 0x06,
+  0x16, 0x01, 0x16, 0x36, 0x37, 0x36, 0x26, 0x27, 0x26, 0x06, 0x07, 0x06,
+  0x16, 0x13, 0x35, 0x33, 0x15, 0x14, 0x17, 0x16, 0x19, 0x01, 0x21, 0x11,
+  0x10, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x25, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x05, 0x23, 0x22, 0x27, 0x36, 0x37, 0x36, 0x25,
+  0x16, 0x32, 0x37, 0x04, 0x17, 0x16, 0x17, 0x06, 0x2b, 0x01, 0x25, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x05, 0x16, 0x33, 0x32, 0x37, 0x26, 0x27, 0x24,
+  0x25, 0x27, 0x15, 0x23, 0x04, 0x05, 0x06, 0x07, 0x16, 0x33, 0x32, 0x37,
+  0x25, 0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x37, 0x03, 0x88, 0x2c,
+  0x0e, 0xb7, 0xaf, 0x05, 0x0d, 0xb0, 0xb6, 0x07, 0x33, 0xeb, 0x95, 0xce,
+  0xcf, 0x94, 0x93, 0xd0, 0xcf, 0xe6, 0xa5, 0x74, 0x74, 0xa5, 0x74, 0xa9,
+  0x29, 0x1d, 0x1d, 0x29, 0x1d, 0x1d, 0x29, 0x1d, 0x1d, 0x29, 0x1d, 0xf3,
+  0x10, 0x07, 0x0b, 0x0e, 0x28, 0x11, 0x11, 0x05, 0x0c, 0x0b, 0x29, 0x01,
+  0x37, 0x11, 0x07, 0x0c, 0x0d, 0x28, 0x11, 0x11, 0x06, 0x0c, 0x0c, 0x28,
+  0xfe, 0x2f, 0x06, 0x14, 0x13, 0x14, 0x24, 0x07, 0x06, 0x12, 0x15, 0x14,
+  0x24, 0x02, 0x0c, 0x06, 0x12, 0x14, 0x13, 0x25, 0x0c, 0x12, 0x14, 0x12,
+  0x25, 0xfd, 0xe6, 0x07, 0x24, 0x15, 0x14, 0x12, 0x06, 0x07, 0x24, 0x14,
+  0x13, 0x14, 0x02, 0x19, 0x06, 0x26, 0x12, 0x14, 0x12, 0x06, 0x06, 0x25,
+  0x13, 0x14, 0x12, 0xfe, 0x6b, 0x11, 0x29, 0x0b, 0x0e, 0x07, 0x11, 0x11,
+  0x28, 0x0e, 0x0b, 0x07, 0x01, 0x58, 0x11, 0x28, 0x0c, 0x0c, 0x06, 0x11,
+  0x11, 0x28, 0x0d, 0x0c, 0x07, 0x4d, 0x79, 0xca, 0xc2, 0xfa, 0x68, 0xc3,
+  0xca, 0x79, 0xfe, 0xcb, 0x17, 0x43, 0x1a, 0x35, 0xfe, 0xaf, 0x09, 0x6d,
+  0x3b, 0x0c, 0xdf, 0xe0, 0x02, 0x09, 0x15, 0x2b, 0x16, 0x02, 0x08, 0xe0,
+  0xdf, 0x0b, 0x3a, 0x6c, 0x09, 0xfe, 0xae, 0x35, 0x1a, 0x43, 0x17, 0x17,
+  0x23, 0x30, 0x1c, 0x1c, 0x01, 0x25, 0x0d, 0x0e, 0x42, 0x38, 0x09, 0xd4,
+  0xfe, 0xe6, 0xfe, 0x54, 0x2b, 0x31, 0xfe, 0x53, 0xfe, 0xe6, 0xd4, 0x08,
+  0x37, 0x43, 0x0d, 0x0e, 0x01, 0x25, 0x1c, 0x1c, 0x30, 0x22, 0x03, 0xc2,
+  0x40, 0x8e, 0x40, 0x31, 0x41, 0xf1, 0xfe, 0x65, 0x01, 0x9b, 0xf1, 0x41,
+  0x31, 0x40, 0x8e, 0x40, 0x48, 0xe7, 0xa3, 0xa4, 0xe6, 0xe6, 0xa4, 0xa3,
+  0xe7, 0xad, 0x81, 0xb8, 0x80, 0x80, 0xb8, 0x01, 0x14, 0x20, 0x2e, 0x20,
+  0x20, 0x2e, 0xfd, 0xb5, 0x20, 0x2e, 0x20, 0x20, 0x2e, 0x02, 0x45, 0x0d,
+  0x2d, 0x13, 0x12, 0x08, 0x0d, 0x0f, 0x2d, 0x13, 0x11, 0x07, 0xfd, 0xff,
+  0x0e, 0x2d, 0x13, 0x13, 0x07, 0x0f, 0x0d, 0x2c, 0x13, 0x13, 0x07, 0x01,
+  0x31, 0x16, 0x29, 0x07, 0x07, 0x14, 0x17, 0x16, 0x29, 0x07, 0x07, 0x16,
+  0xd5, 0x15, 0x29, 0x07, 0x07, 0x15, 0x2c, 0x28, 0x08, 0x07, 0x14, 0x39,
+  0x17, 0x14, 0x07, 0x07, 0x29, 0x15, 0x16, 0x16, 0x07, 0x08, 0x28, 0xa9,
+  0x15, 0x16, 0x07, 0x07, 0x29, 0x16, 0x15, 0x16, 0x07, 0x07, 0x29, 0xfe,
+  0x75, 0x0f, 0x07, 0x13, 0x13, 0x2d, 0x0d, 0x0e, 0x07, 0x13, 0x13, 0x2c,
+  0x01, 0xe6, 0x0d, 0x08, 0x12, 0x13, 0x2d, 0x0d, 0x0f, 0x08, 0x12, 0x13,
+  0x2d, 0x01, 0x20, 0x47, 0x9c, 0x37, 0x37, 0x57, 0xfe, 0xf5, 0xfe, 0x36,
+  0x01, 0xca, 0x01, 0x0b, 0x57, 0x37, 0x37, 0x9c, 0x47, 0xe5, 0x06, 0x12,
+  0x20, 0x44, 0x26, 0x1a, 0x26, 0x0b, 0xa5, 0xcb, 0xc7, 0x65, 0x8b, 0x11,
+  0x01, 0x01, 0x11, 0x8b, 0x65, 0xc7, 0xcb, 0xa5, 0x0b, 0x26, 0x1a, 0x26,
+  0x44, 0x20, 0x12, 0x06, 0x1c, 0x12, 0x22, 0x28, 0x3d, 0x16, 0x15, 0x14,
+  0x13, 0x88, 0x06, 0x97, 0x9d, 0x70, 0x81, 0x19, 0x01, 0x01, 0x19, 0x81,
+  0x70, 0x9d, 0x97, 0x06, 0x88, 0x13, 0x14, 0x15, 0x16, 0x3d, 0x28, 0x22,
+  0x12, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa5, 0x00, 0x00, 0x05, 0xd0,
+  0x05, 0xd5, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x17, 0x11,
+  0x07, 0x21, 0x27, 0x11, 0x17, 0x11, 0x21, 0x11, 0xab, 0x05, 0x1e, 0x07,
+  0x07, 0xfa, 0xe2, 0x05, 0x63, 0x04, 0x63, 0x05, 0xd5, 0x07, 0xfa, 0x38,
+  0x06, 0x06, 0x05, 0xc8, 0x68, 0xfb, 0x08, 0x04, 0xf8, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xa4, 0x00, 0x00, 0x05, 0xd1, 0x05, 0xd5, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x22, 0x00, 0x00, 0x13, 0x21, 0x17, 0x11, 0x07, 0x21,
+  0x27, 0x11, 0x17, 0x11, 0x21, 0x11, 0x07, 0x15, 0x06, 0x07, 0x00, 0x03,
+  0x06, 0x23, 0x06, 0x23, 0x02, 0x2b, 0x01, 0x35, 0x37, 0x32, 0x17, 0x33,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0xaa, 0x05, 0x21, 0x06, 0x06, 0xfa, 0xdf,
+  0x05, 0x64, 0x04, 0x63, 0x7a, 0x44, 0x25, 0xfe, 0xda, 0x38, 0x05, 0x0f,
+  0x69, 0x0c, 0x5b, 0xb8, 0x15, 0x92, 0x88, 0x41, 0x06, 0x2e, 0x38, 0x59,
+  0x8b, 0x57, 0x05, 0xd5, 0x06, 0xfa, 0x38, 0x07, 0x07, 0x05, 0xc8, 0x68,
+  0xfb, 0x08, 0x04, 0xf8, 0x9e, 0x06, 0x41, 0x3a, 0xfe, 0x46, 0xfe, 0xbd,
+  0x3b, 0x2f, 0x01, 0x02, 0x07, 0x49, 0x83, 0xa6, 0x74, 0xb3, 0xbb, 0x78,
+  0x00, 0x03, 0x00, 0xa4, 0x00, 0x00, 0x05, 0xd1, 0x05, 0xd5, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x1a, 0x00, 0x00, 0x13, 0x21, 0x17, 0x11, 0x07, 0x21,
+  0x27, 0x11, 0x17, 0x11, 0x21, 0x11, 0x05, 0x09, 0x01, 0x17, 0x09, 0x01,
+  0x15, 0x07, 0x01, 0x23, 0x01, 0x23, 0x27, 0x09, 0x01, 0xaa, 0x05, 0x21,
+  0x06, 0x06, 0xfa, 0xdf, 0x05, 0x64, 0x04, 0x63, 0xfc, 0x5e, 0x01, 0x72,
+  0x01, 0x6e, 0x56, 0xfe, 0x91, 0x01, 0x6f, 0x52, 0xfe, 0x8e, 0x04, 0xfe,
+  0x92, 0x04, 0x51, 0x01, 0x6e, 0xfe, 0x92, 0x05, 0xd5, 0x06, 0xfa, 0x38,
+  0x07, 0x07, 0x05, 0xc8, 0x68, 0xfb, 0x08, 0x04, 0xf8, 0x86, 0xfe, 0x69,
+  0x01, 0x97, 0x5b, 0xfe, 0x65, 0xfe, 0x66, 0x03, 0x5b, 0x01, 0x97, 0xfe,
+  0x6c, 0x5b, 0x01, 0x9a, 0x01, 0x9b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x8a,
+  0x00, 0xa0, 0x03, 0x4a, 0x05, 0x40, 0x00, 0x14, 0x00, 0x00, 0x13, 0x33,
+  0x01, 0x36, 0x13, 0x32, 0x37, 0x33, 0x17, 0x09, 0x01, 0x15, 0x07, 0x01,
+  0x23, 0x01, 0x23, 0x27, 0x01, 0x00, 0x35, 0xd9, 0x04, 0x01, 0x0c, 0x0a,
+  0xfd, 0x04, 0x05, 0x04, 0x4d, 0xfe, 0xf0, 0x01, 0x10, 0x4f, 0xfe, 0xf2,
+  0x02, 0xfe, 0xf1, 0x03, 0x4e, 0x01, 0x12, 0xfe, 0xee, 0x05, 0x40, 0xfe,
+  0x0b, 0x08, 0x01, 0xde, 0x0f, 0x55, 0xfe, 0x04, 0xfe, 0x07, 0x03, 0x53,
+  0x01, 0xf7, 0xfe, 0x0b, 0x56, 0x01, 0xf9, 0x01, 0xf5, 0x07, 0x00, 0x00,
+  0x00, 0x08, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x43, 0x07, 0x76, 0x00, 0x08,
+  0x00, 0x11, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x2c, 0x00, 0x35, 0x00, 0x3e,
+  0x00, 0x7e, 0x00, 0x00, 0x01, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01,
+  0x34, 0x01, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x25, 0x33,
+  0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x17, 0x33, 0x06, 0x2b, 0x01,
+  0x26, 0x3d, 0x01, 0x34, 0x01, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01,
+  0x34, 0x05, 0x33, 0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x17, 0x33,
+  0x06, 0x2b, 0x01, 0x26, 0x3d, 0x01, 0x34, 0x25, 0x33, 0x17, 0x15, 0x33,
+  0x20, 0x13, 0x16, 0x1d, 0x01, 0x23, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22,
+  0x07, 0x15, 0x14, 0x07, 0x27, 0x26, 0x23, 0x11, 0x14, 0x0f, 0x01, 0x22,
+  0x2f, 0x01, 0x35, 0x37, 0x33, 0x17, 0x15, 0x16, 0x3b, 0x01, 0x32, 0x3f,
+  0x01, 0x11, 0x22, 0x07, 0x06, 0x23, 0x27, 0x35, 0x37, 0x23, 0x26, 0x27,
+  0x23, 0x22, 0x0f, 0x01, 0x23, 0x35, 0x36, 0x37, 0x36, 0x21, 0x35, 0x01,
+  0xa7, 0x03, 0x1b, 0x53, 0x06, 0x34, 0x02, 0x1a, 0x02, 0x1a, 0x53, 0x06,
+  0x33, 0x01, 0xe8, 0x02, 0x1b, 0x53, 0x05, 0x34, 0xde, 0x04, 0x1b, 0x53,
+  0x05, 0x35, 0x01, 0xe8, 0x03, 0x1a, 0x54, 0x05, 0x35, 0x01, 0x09, 0x02,
+  0x19, 0x54, 0x06, 0x34, 0x52, 0x03, 0x1b, 0x53, 0x05, 0x34, 0xfd, 0xe6,
+  0x34, 0x06, 0x02, 0x01, 0x8c, 0xfc, 0x26, 0x01, 0x14, 0x11, 0x20, 0x33,
+  0x28, 0x87, 0x64, 0x08, 0x1d, 0x88, 0x7b, 0x5f, 0x1b, 0x52, 0x21, 0x02,
+  0x05, 0x27, 0x05, 0x09, 0x38, 0x09, 0x32, 0x12, 0x05, 0xbe, 0x4d, 0x10,
+  0x0c, 0x06, 0x06, 0x04, 0x3c, 0xb1, 0x3d, 0x59, 0x1e, 0x12, 0x03, 0x34,
+  0xad, 0xd7, 0x01, 0x19, 0x06, 0x01, 0xcf, 0x0a, 0x23, 0x02, 0x38, 0x01,
+  0x64, 0xcf, 0x08, 0x23, 0x03, 0x37, 0xe3, 0xcf, 0x08, 0x24, 0x03, 0x36,
+  0xb9, 0xcf, 0x08, 0x24, 0x02, 0x38, 0x01, 0x3b, 0xce, 0x07, 0x24, 0x03,
+  0x37, 0x69, 0xcf, 0x07, 0x24, 0x03, 0x37, 0xeb, 0xcf, 0x09, 0x23, 0x02,
+  0x39, 0x9a, 0x05, 0x70, 0xfe, 0x50, 0x4c, 0x0c, 0x07, 0x0d, 0x29, 0x16,
+  0x5a, 0x2e, 0x0d, 0x02, 0x3b, 0x36, 0xfd, 0x9f, 0x5a, 0x15, 0x02, 0x56,
+  0x18, 0x17, 0x06, 0x06, 0x0a, 0x5a, 0x33, 0x25, 0x02, 0x59, 0x36, 0x33,
+  0x05, 0x0b, 0x2e, 0x38, 0x19, 0x37, 0x10, 0x02, 0x80, 0xc2, 0xc6, 0x70,
+  0x00, 0x09, 0x00, 0x88, 0x00, 0x00, 0x05, 0xeb, 0x05, 0xd9, 0x00, 0x0b,
+  0x00, 0x11, 0x00, 0x1c, 0x00, 0x33, 0x00, 0x44, 0x00, 0x4d, 0x00, 0x79,
+  0x00, 0x7f, 0x00, 0x8f, 0x00, 0x00, 0x01, 0x14, 0x15, 0x14, 0x17, 0x21,
+  0x36, 0x37, 0x34, 0x23, 0x21, 0x06, 0x13, 0x16, 0x17, 0x21, 0x36, 0x3f,
+  0x01, 0x06, 0x07, 0x36, 0x37, 0x36, 0x35, 0x34, 0x35, 0x26, 0x23, 0x27,
+  0x06, 0x07, 0x33, 0x32, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x33,
+  0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x23, 0x01, 0x33,
+  0x14, 0x06, 0x07, 0x14, 0x16, 0x17, 0x23, 0x26, 0x27, 0x26, 0x27, 0x34,
+  0x35, 0x34, 0x36, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x21, 0x16,
+  0x05, 0x36, 0x37, 0x32, 0x17, 0x15, 0x14, 0x05, 0x07, 0x17, 0x14, 0x07,
+  0x21, 0x26, 0x3d, 0x01, 0x37, 0x35, 0x24, 0x2f, 0x01, 0x35, 0x36, 0x33,
+  0x16, 0x17, 0x26, 0x11, 0x34, 0x33, 0x21, 0x16, 0x15, 0x33, 0x32, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x27, 0x01, 0x16, 0x17, 0x21,
+  0x36, 0x37, 0x01, 0x06, 0x07, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x35, 0x33, 0x1e, 0x01, 0x15, 0x01, 0x06, 0x0d, 0x04, 0x0e, 0x0a,
+  0x03, 0x1b, 0xfc, 0x10, 0x19, 0x38, 0x05, 0x0e, 0x03, 0x8f, 0x0c, 0x08,
+  0x41, 0x08, 0x34, 0x4e, 0x2c, 0x1a, 0x01, 0x1d, 0x33, 0x02, 0x01, 0x31,
+  0x35, 0x3e, 0x28, 0x49, 0x1d, 0x2d, 0x07, 0x34, 0x22, 0x11, 0x61, 0x31,
+  0x1a, 0x16, 0x6c, 0xfd, 0x78, 0x08, 0x58, 0x01, 0x7a, 0x04, 0x08, 0x11,
+  0x62, 0x1e, 0x08, 0x63, 0xfe, 0xf9, 0xa5, 0xaa, 0x9d, 0x9f, 0x1f, 0x53,
+  0xfc, 0x9e, 0x21, 0x02, 0xf2, 0xe4, 0x5c, 0x10, 0x06, 0xfe, 0xbc, 0x71,
+  0x02, 0x0f, 0xfe, 0x26, 0x0f, 0x03, 0xfe, 0x8e, 0x2c, 0x03, 0x03, 0x11,
+  0x4c, 0xc1, 0xb5, 0x30, 0x03, 0xf7, 0x1d, 0x31, 0x81, 0x4e, 0x1f, 0x65,
+  0x30, 0x3c, 0x06, 0x10, 0xfc, 0x8d, 0x06, 0x09, 0x03, 0xd6, 0x0a, 0x03,
+  0xfe, 0xbc, 0x05, 0x11, 0x39, 0x0a, 0x05, 0x02, 0x48, 0x33, 0x05, 0x09,
+  0x39, 0x02, 0xb4, 0x06, 0x07, 0x37, 0x48, 0x34, 0x58, 0x16, 0x04, 0xfe,
+  0xcd, 0x1a, 0x12, 0x16, 0x16, 0xc7, 0x6d, 0x86, 0x01, 0x4d, 0x37, 0x52,
+  0x06, 0x05, 0x11, 0x56, 0x1c, 0x20, 0x2f, 0x82, 0x4d, 0x28, 0x01, 0x3d,
+  0x48, 0x3a, 0x0d, 0x1f, 0x2c, 0x71, 0x4c, 0x55, 0x44, 0x03, 0x29, 0x38,
+  0x88, 0x57, 0x71, 0x6b, 0xb1, 0x92, 0x65, 0x2d, 0x50, 0x05, 0x06, 0x65,
+  0x78, 0xfa, 0xf3, 0x0d, 0x0b, 0x10, 0x97, 0x4e, 0x57, 0x18, 0x0a, 0x0a,
+  0x0a, 0x10, 0x3d, 0x24, 0x0a, 0x0f, 0x08, 0x07, 0x10, 0x06, 0x02, 0x02,
+  0x55, 0x12, 0x0d, 0x04, 0x0b, 0x09, 0x14, 0xfe, 0x01, 0x2f, 0x30, 0x02,
+  0x18, 0x63, 0x9b, 0x99, 0x29, 0x16, 0x48, 0x04, 0x01, 0x3f, 0x1a, 0x12,
+  0x13, 0x19, 0x01, 0xf5, 0x32, 0x1c, 0x40, 0x5b, 0x6e, 0x44, 0x46, 0x38,
+  0x54, 0x24, 0x2e, 0x4a, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9a,
+  0x00, 0x01, 0x05, 0xdb, 0x05, 0xd9, 0x00, 0x07, 0x00, 0x0c, 0x00, 0x00,
+  0x09, 0x01, 0x13, 0x07, 0x21, 0x27, 0x13, 0x09, 0x01, 0x03, 0x21, 0x03,
+  0x01, 0x03, 0x41, 0x02, 0x4e, 0x4b, 0x02, 0xfa, 0xc8, 0x05, 0x4f, 0x02,
+  0x55, 0xfe, 0x05, 0x44, 0x04, 0x75, 0x40, 0xfe, 0x07, 0x05, 0xd9, 0xfe,
+  0x77, 0xfb, 0xb4, 0x03, 0x06, 0x04, 0x4c, 0x01, 0x86, 0xfe, 0x35, 0xfc,
+  0x5f, 0x03, 0xa1, 0x01, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9a,
+  0x00, 0x00, 0x05, 0xdb, 0x05, 0xd0, 0x00, 0x09, 0x00, 0x00, 0x09, 0x01,
+  0x13, 0x17, 0x07, 0x21, 0x27, 0x13, 0x00, 0x37, 0x03, 0x3f, 0x02, 0x4b,
+  0x4e, 0x02, 0x02, 0xfa, 0xc8, 0x05, 0x51, 0x02, 0x3e, 0x12, 0x05, 0xd0,
+  0xfe, 0x77, 0xfb, 0xbf, 0x03, 0x03, 0x06, 0x04, 0x44, 0x01, 0x80, 0x06,
+  0x00, 0x01, 0x00, 0x8f, 0x00, 0x00, 0x05, 0xe6, 0x05, 0xd4, 0x00, 0x53,
+  0x00, 0x00, 0x01, 0x03, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16,
+  0x32, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x03, 0x25, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x03, 0x16, 0x15, 0x10, 0x07, 0x23, 0x36, 0x11, 0x34, 0x27, 0x03,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36,
+  0x35, 0x34, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x03, 0x1f, 0xc2, 0x43, 0x4f, 0x22, 0x22, 0x4f, 0x3b, 0x27,
+  0x3c, 0x34, 0x53, 0x32, 0x0c, 0x52, 0xb3, 0x01, 0x24, 0x46, 0x40, 0x34,
+  0x2f, 0x20, 0x1f, 0x3f, 0x06, 0x10, 0x61, 0x21, 0x0b, 0x0a, 0x1e, 0x33,
+  0x39, 0x1e, 0x20, 0x5f, 0x44, 0xbb, 0x08, 0x64, 0x56, 0x84, 0x07, 0xb9,
+  0x46, 0x5e, 0x20, 0x1e, 0x39, 0x32, 0x1f, 0x0b, 0x09, 0x21, 0x61, 0x11,
+  0x06, 0x3f, 0x20, 0x1f, 0x30, 0x32, 0x41, 0x46, 0x03, 0x08, 0x01, 0x34,
+  0x68, 0x6f, 0x6b, 0x40, 0x16, 0x52, 0x52, 0x72, 0x2a, 0x25, 0x7f, 0x74,
+  0xfe, 0xeb, 0x65, 0x1c, 0x11, 0x0c, 0x1b, 0x42, 0x42, 0x15, 0x15, 0x39,
+  0x27, 0x1d, 0x11, 0x37, 0x2a, 0x1f, 0x24, 0x25, 0x1b, 0x29, 0x0c, 0x22,
+  0x66, 0x01, 0x16, 0x58, 0x53, 0xfe, 0xdd, 0xe7, 0xf2, 0x01, 0x35, 0x45,
+  0x49, 0xfe, 0xea, 0x66, 0x22, 0x0c, 0x29, 0x1b, 0x25, 0x23, 0x1e, 0x2c,
+  0x37, 0x11, 0x1d, 0x27, 0x39, 0x15, 0x14, 0x43, 0x42, 0x1b, 0x0c, 0x11,
+  0x1c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x99, 0x01, 0x1e, 0x05, 0xdb,
+  0x04, 0x98, 0x00, 0x3e, 0x00, 0x45, 0x00, 0x00, 0x01, 0x16, 0x17, 0x14,
+  0x07, 0x06, 0x07, 0x16, 0x13, 0x33, 0x17, 0x07, 0x23, 0x06, 0x07, 0x22,
+  0x27, 0x34, 0x33, 0x16, 0x33, 0x32, 0x33, 0x32, 0x37, 0x26, 0x27, 0x23,
+  0x22, 0x07, 0x16, 0x15, 0x06, 0x05, 0x24, 0x03, 0x34, 0x37, 0x16, 0x17,
+  0x15, 0x07, 0x14, 0x17, 0x32, 0x37, 0x12, 0x25, 0x16, 0x1d, 0x01, 0x14,
+  0x07, 0x36, 0x37, 0x32, 0x35, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x03,
+  0x06, 0x15, 0x14, 0x17, 0x35, 0x26, 0x05, 0x16, 0x64, 0x12, 0x42, 0x9f,
+  0x12, 0xe7, 0x31, 0x18, 0x11, 0x29, 0x03, 0x0f, 0x89, 0x58, 0x16, 0x12,
+  0x0e, 0x33, 0x02, 0x01, 0x45, 0x0c, 0xec, 0x06, 0x03, 0x76, 0x3d, 0x79,
+  0x08, 0xfe, 0xd3, 0xfd, 0xd7, 0x28, 0x3b, 0x2e, 0x07, 0x0b, 0x65, 0x50,
+  0x0c, 0x30, 0x01, 0x0c, 0xb0, 0x25, 0x53, 0x5a, 0x37, 0x41, 0x46, 0x34,
+  0x22, 0x79, 0x01, 0xce, 0x1d, 0x04, 0x98, 0x05, 0x73, 0x57, 0x19, 0x24,
+  0x2c, 0x1b, 0xfe, 0xf0, 0x4a, 0x0d, 0xae, 0x09, 0x5d, 0x54, 0x2d, 0x4d,
+  0x4d, 0xf1, 0x6d, 0x40, 0x65, 0xf6, 0x10, 0x03, 0x01, 0x64, 0x3a, 0x09,
+  0x03, 0x2c, 0x17, 0x27, 0x5a, 0x0c, 0x4d, 0x01, 0xde, 0x14, 0x06, 0xa0,
+  0x08, 0x27, 0x63, 0x4d, 0x14, 0x26, 0x54, 0x29, 0x24, 0x24, 0x0d, 0x3c,
+  0xfe, 0xa5, 0x08, 0x09, 0x84, 0x49, 0x03, 0xb5, 0x00, 0x01, 0x00, 0x9a,
+  0x00, 0xe7, 0x05, 0xdb, 0x04, 0x8d, 0x00, 0x32, 0x00, 0x00, 0x25, 0x21,
+  0x22, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x33, 0x37, 0x23, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x3b, 0x01, 0x37, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x21, 0x37, 0x21, 0x22, 0x26, 0x35,
+  0x34, 0x3e, 0x01, 0x33, 0x21, 0x36, 0x37, 0x36, 0x33, 0x21, 0x32, 0x16,
+  0x15, 0x05, 0x97, 0xfd, 0x95, 0x27, 0x37, 0x19, 0x17, 0x10, 0x11, 0x31,
+  0x03, 0x7a, 0x2a, 0x17, 0x1c, 0x1a, 0x2d, 0x18, 0xa2, 0x01, 0xe8, 0x3d,
+  0x38, 0x1b, 0x16, 0x12, 0x14, 0x01, 0x30, 0x02, 0xfd, 0x4f, 0x26, 0x38,
+  0x1a, 0x2d, 0x17, 0x02, 0xdb, 0x07, 0x0f, 0x1c, 0x26, 0x01, 0x51, 0x26,
+  0x37, 0xe7, 0x3e, 0x2b, 0x1b, 0x32, 0x0d, 0x0a, 0x03, 0x0c, 0x02, 0x1a,
+  0x1e, 0x2c, 0x1b, 0x32, 0x1c, 0x0a, 0x3d, 0x2c, 0x1a, 0x32, 0x0e, 0x0b,
+  0x02, 0x0a, 0x3d, 0x2c, 0x1b, 0x33, 0x1a, 0x16, 0x11, 0x1f, 0x3e, 0x2c,
+  0x00, 0x01, 0x00, 0x9a, 0x00, 0xe7, 0x05, 0xdb, 0x04, 0x8d, 0x00, 0x32,
+  0x00, 0x00, 0x13, 0x34, 0x36, 0x33, 0x21, 0x32, 0x17, 0x16, 0x17, 0x21,
+  0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x21, 0x17, 0x21, 0x16, 0x17,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x32, 0x1e, 0x01,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x23, 0x17, 0x33, 0x16, 0x17, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x23, 0x21, 0x9b, 0x38, 0x25, 0x01, 0x51, 0x27, 0x1b,
+  0x0f, 0x07, 0x02, 0xdb, 0x17, 0x2d, 0x1a, 0x37, 0x27, 0xfd, 0x50, 0x01,
+  0x01, 0x31, 0x13, 0x12, 0x17, 0x19, 0x37, 0x3d, 0xe7, 0xa2, 0x18, 0x2d,
+  0x19, 0x1b, 0x16, 0x2c, 0x79, 0x04, 0x30, 0x11, 0x10, 0x16, 0x1a, 0x37,
+  0x26, 0xfd, 0x94, 0x04, 0x23, 0x2c, 0x3e, 0x1f, 0x11, 0x16, 0x1a, 0x33,
+  0x1b, 0x2c, 0x3d, 0x0a, 0x02, 0x0b, 0x0e, 0x32, 0x1a, 0x2c, 0x3d, 0x0a,
+  0x1c, 0x32, 0x1b, 0x2c, 0x1e, 0x1a, 0x02, 0x0c, 0x03, 0x0a, 0x0d, 0x32,
+  0x1b, 0x2b, 0x3e, 0x00, 0x00, 0x02, 0x00, 0xa0, 0x00, 0xd4, 0x05, 0xd6,
+  0x04, 0x8d, 0x00, 0x22, 0x00, 0x44, 0x00, 0x00, 0x25, 0x13, 0x34, 0x26,
+  0x23, 0x21, 0x22, 0x07, 0x21, 0x30, 0x23, 0x22, 0x14, 0x33, 0x21, 0x07,
+  0x21, 0x22, 0x15, 0x14, 0x33, 0x21, 0x07, 0x23, 0x22, 0x15, 0x14, 0x3b,
+  0x01, 0x07, 0x23, 0x22, 0x15, 0x14, 0x33, 0x07, 0x26, 0x27, 0x36, 0x37,
+  0x33, 0x37, 0x23, 0x26, 0x27, 0x36, 0x37, 0x33, 0x37, 0x21, 0x22, 0x27,
+  0x36, 0x37, 0x21, 0x37, 0x21, 0x26, 0x27, 0x36, 0x33, 0x21, 0x36, 0x37,
+  0x21, 0x32, 0x16, 0x15, 0x03, 0x05, 0x6e, 0x41, 0x2b, 0x1e, 0xfe, 0xc3,
+  0x31, 0x15, 0xfd, 0x2a, 0x03, 0x48, 0x4b, 0x02, 0xb2, 0x0b, 0xfe, 0xc1,
+  0x4b, 0x4b, 0x01, 0x1b, 0x08, 0xc7, 0x4b, 0x4b, 0x9c, 0x11, 0x38, 0x4a,
+  0x4a, 0x19, 0x53, 0x01, 0x01, 0x53, 0x43, 0x03, 0x99, 0x54, 0x01, 0x01,
+  0x54, 0xcd, 0x01, 0xfe, 0xe6, 0x54, 0x01, 0x01, 0x54, 0x01, 0x44, 0x04,
+  0xfd, 0x50, 0x53, 0x01, 0x01, 0x53, 0x02, 0xdb, 0x1d, 0x3b, 0x01, 0x51,
+  0x25, 0x38, 0x43, 0xf1, 0x03, 0x15, 0x25, 0x33, 0x39, 0x92, 0x4c, 0x4b,
+  0x49, 0x4f, 0x4b, 0x48, 0x4c, 0x4b, 0x49, 0x1d, 0x01, 0x68, 0x67, 0x01,
+  0x0e, 0x01, 0x68, 0x67, 0x01, 0x13, 0x68, 0x67, 0x01, 0x0f, 0x01, 0x68,
+  0x67, 0x45, 0x02, 0x3f, 0x2d, 0xfc, 0xb3, 0x00, 0x00, 0x02, 0x00, 0x84,
+  0x00, 0x00, 0x03, 0xde, 0x05, 0xca, 0x00, 0x21, 0x00, 0x44, 0x00, 0x00,
+  0x37, 0x05, 0x32, 0x36, 0x35, 0x11, 0x34, 0x27, 0x11, 0x36, 0x23, 0x22,
+  0x15, 0x11, 0x27, 0x11, 0x34, 0x23, 0x22, 0x15, 0x11, 0x27, 0x35, 0x34,
+  0x23, 0x22, 0x1d, 0x01, 0x27, 0x35, 0x34, 0x23, 0x22, 0x15, 0x27, 0x36,
+  0x37, 0x16, 0x17, 0x15, 0x17, 0x35, 0x36, 0x37, 0x16, 0x17, 0x15, 0x17,
+  0x11, 0x34, 0x37, 0x16, 0x17, 0x11, 0x17, 0x11, 0x36, 0x37, 0x16, 0x15,
+  0x11, 0x16, 0x17, 0x11, 0x14, 0x06, 0x23, 0x25, 0x13, 0x9f, 0x02, 0xc6,
+  0x21, 0x2f, 0x35, 0x02, 0x42, 0x42, 0x44, 0x45, 0x41, 0x47, 0x43, 0x41,
+  0x45, 0x43, 0x42, 0x1a, 0x01, 0x5e, 0x5c, 0x01, 0x0d, 0x01, 0x5d, 0x5d,
+  0x01, 0x10, 0x5f, 0x5c, 0x01, 0x0e, 0x01, 0x5d, 0x5d, 0x3d, 0x02, 0x38,
+  0x28, 0xfd, 0x06, 0x01, 0x73, 0x4a, 0x31, 0x20, 0x01, 0x62, 0x36, 0x16,
+  0x03, 0x27, 0x53, 0x53, 0xfd, 0x02, 0x0d, 0x01, 0x63, 0x52, 0x52, 0xfe,
+  0xc4, 0x09, 0xdf, 0x53, 0x53, 0xae, 0x12, 0x3f, 0x53, 0x53, 0x1c, 0x5c,
+  0x01, 0x01, 0x5c, 0x4b, 0x04, 0xac, 0x5c, 0x01, 0x01, 0x5c, 0xe4, 0x03,
+  0x01, 0x3b, 0x5c, 0x01, 0x01, 0x5c, 0xfe, 0x96, 0x04, 0x02, 0xfd, 0x5d,
+  0x01, 0x01, 0x5d, 0xfc, 0xd4, 0x21, 0x41, 0xfe, 0x8a, 0x2a, 0x3e, 0x4b,
+  0x02, 0x9b, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9f, 0x00, 0xd3, 0x05, 0xd6,
+  0x04, 0x8d, 0x00, 0x21, 0x00, 0x43, 0x00, 0x00, 0x25, 0x32, 0x35, 0x34,
+  0x2b, 0x01, 0x27, 0x33, 0x32, 0x35, 0x34, 0x2b, 0x01, 0x27, 0x21, 0x32,
+  0x35, 0x34, 0x23, 0x21, 0x27, 0x21, 0x32, 0x34, 0x2b, 0x01, 0x21, 0x26,
+  0x23, 0x21, 0x22, 0x06, 0x15, 0x13, 0x07, 0x03, 0x34, 0x36, 0x33, 0x21,
+  0x16, 0x17, 0x21, 0x32, 0x17, 0x06, 0x07, 0x21, 0x17, 0x21, 0x16, 0x17,
+  0x06, 0x23, 0x21, 0x17, 0x33, 0x16, 0x17, 0x06, 0x07, 0x23, 0x17, 0x33,
+  0x16, 0x17, 0x06, 0x07, 0x03, 0x61, 0x4b, 0x4b, 0x39, 0x10, 0x9d, 0x4a,
+  0x4a, 0xc9, 0x08, 0x01, 0x1c, 0x4a, 0x4a, 0xfe, 0xc1, 0x0c, 0x02, 0xb1,
+  0x4b, 0x47, 0x04, 0xfd, 0x2a, 0x14, 0x30, 0xfe, 0xc1, 0x1d, 0x2c, 0x43,
+  0x24, 0x44, 0x38, 0x26, 0x01, 0x51, 0x3a, 0x1e, 0x02, 0xda, 0x54, 0x01,
+  0x01, 0x54, 0xfd, 0x50, 0x04, 0x01, 0x45, 0x53, 0x01, 0x01, 0x53, 0xfe,
+  0xe5, 0x03, 0xcd, 0x53, 0x01, 0x01, 0x53, 0x9b, 0x04, 0x43, 0x53, 0x01,
+  0x01, 0x53, 0xf1, 0x49, 0x4b, 0x4c, 0x48, 0x4b, 0x4f, 0x49, 0x4b, 0x4c,
+  0x92, 0x39, 0x33, 0x25, 0xfc, 0xeb, 0x1e, 0x03, 0x4e, 0x2d, 0x3f, 0x02,
+  0x45, 0x67, 0x68, 0x01, 0x0f, 0x01, 0x67, 0x68, 0x13, 0x01, 0x67, 0x68,
+  0x01, 0x0e, 0x01, 0x67, 0x69, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x84,
+  0xff, 0xf9, 0x03, 0xde, 0x05, 0xc2, 0x00, 0x21, 0x00, 0x43, 0x00, 0x00,
+  0x13, 0x14, 0x33, 0x32, 0x3d, 0x01, 0x37, 0x15, 0x14, 0x33, 0x32, 0x3d,
+  0x01, 0x37, 0x11, 0x14, 0x33, 0x32, 0x35, 0x11, 0x37, 0x11, 0x14, 0x33,
+  0x32, 0x27, 0x11, 0x36, 0x35, 0x11, 0x34, 0x26, 0x23, 0x05, 0x27, 0x25,
+  0x32, 0x16, 0x15, 0x11, 0x06, 0x07, 0x11, 0x14, 0x07, 0x26, 0x27, 0x11,
+  0x07, 0x11, 0x06, 0x07, 0x26, 0x35, 0x11, 0x07, 0x15, 0x06, 0x07, 0x26,
+  0x27, 0x35, 0x07, 0x15, 0x06, 0x07, 0x26, 0x27, 0x9f, 0x42, 0x43, 0x45,
+  0x41, 0x43, 0x47, 0x41, 0x45, 0x44, 0x42, 0x42, 0x02, 0x35, 0x2f, 0x21,
+  0xfd, 0x3a, 0x1b, 0x02, 0xfa, 0x28, 0x38, 0x02, 0x3d, 0x5d, 0x5d, 0x01,
+  0x0e, 0x01, 0x5c, 0x5f, 0x10, 0x01, 0x5d, 0x5d, 0x01, 0x0d, 0x01, 0x5c,
+  0x5e, 0x01, 0x02, 0xb3, 0x53, 0x53, 0x3d, 0x14, 0xae, 0x53, 0x53, 0xdd,
+  0x09, 0xfe, 0xc6, 0x53, 0x53, 0x01, 0x62, 0x0d, 0xfd, 0x01, 0x53, 0x53,
+  0x03, 0x27, 0x17, 0x36, 0x01, 0x61, 0x21, 0x30, 0x4a, 0x29, 0x4b, 0x3e,
+  0x2a, 0xfe, 0x8a, 0x42, 0x20, 0xfc, 0xd4, 0x5c, 0x01, 0x01, 0x5c, 0x02,
+  0xfc, 0x04, 0xfe, 0x98, 0x5d, 0x01, 0x01, 0x5d, 0x01, 0x3a, 0x02, 0xe4,
+  0x5d, 0x01, 0x01, 0x5d, 0xab, 0x04, 0x4a, 0x5d, 0x01, 0x01, 0x5d, 0x00,
+  0x00, 0x1d, 0x00, 0x70, 0x00, 0x00, 0x06, 0x04, 0x05, 0xd8, 0x00, 0x4f,
+  0x00, 0x80, 0x00, 0x8b, 0x00, 0x95, 0x00, 0xa4, 0x00, 0xb3, 0x00, 0xba,
+  0x00, 0xc1, 0x00, 0xd6, 0x00, 0xdc, 0x00, 0xe3, 0x00, 0xe7, 0x00, 0xeb,
+  0x00, 0xef, 0x00, 0xf3, 0x00, 0xf7, 0x00, 0xfb, 0x00, 0xff, 0x01, 0x03,
+  0x01, 0x07, 0x01, 0x0b, 0x01, 0x1a, 0x01, 0x26, 0x01, 0x2a, 0x01, 0x2e,
+  0x01, 0x32, 0x01, 0x36, 0x01, 0x3a, 0x01, 0x3e, 0x00, 0x00, 0x01, 0x20,
+  0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x17, 0x15, 0x14, 0x07, 0x33, 0x36,
+  0x35, 0x36, 0x3b, 0x01, 0x32, 0x15, 0x16, 0x1d, 0x01, 0x06, 0x23, 0x27,
+  0x06, 0x07, 0x15, 0x17, 0x37, 0x16, 0x15, 0x14, 0x07, 0x14, 0x2b, 0x01,
+  0x22, 0x2f, 0x01, 0x06, 0x23, 0x22, 0x27, 0x06, 0x15, 0x06, 0x2b, 0x01,
+  0x22, 0x35, 0x26, 0x35, 0x34, 0x37, 0x17, 0x37, 0x35, 0x25, 0x07, 0x22,
+  0x27, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x1f, 0x01, 0x35, 0x27,
+  0x37, 0x26, 0x35, 0x36, 0x37, 0x36, 0x01, 0x14, 0x17, 0x33, 0x35, 0x26,
+  0x35, 0x36, 0x3b, 0x01, 0x17, 0x07, 0x17, 0x15, 0x07, 0x15, 0x14, 0x17,
+  0x16, 0x1d, 0x01, 0x17, 0x33, 0x37, 0x34, 0x37, 0x36, 0x35, 0x27, 0x37,
+  0x35, 0x27, 0x37, 0x16, 0x1d, 0x01, 0x07, 0x17, 0x36, 0x3d, 0x01, 0x34,
+  0x27, 0x26, 0x2b, 0x01, 0x20, 0x07, 0x06, 0x05, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x2b, 0x01, 0x22, 0x27, 0x34, 0x21, 0x16, 0x17, 0x06, 0x23, 0x22,
+  0x27, 0x34, 0x35, 0x34, 0x13, 0x33, 0x36, 0x33, 0x17, 0x36, 0x35, 0x26,
+  0x35, 0x26, 0x23, 0x06, 0x07, 0x06, 0x15, 0x25, 0x06, 0x23, 0x06, 0x15,
+  0x17, 0x37, 0x16, 0x17, 0x35, 0x34, 0x27, 0x26, 0x35, 0x26, 0x05, 0x17,
+  0x15, 0x07, 0x26, 0x35, 0x34, 0x37, 0x16, 0x15, 0x14, 0x07, 0x27, 0x35,
+  0x03, 0x16, 0x33, 0x36, 0x37, 0x26, 0x35, 0x34, 0x37, 0x06, 0x07, 0x06,
+  0x2b, 0x01, 0x26, 0x27, 0x26, 0x27, 0x16, 0x15, 0x14, 0x37, 0x16, 0x17,
+  0x33, 0x35, 0x26, 0x05, 0x15, 0x32, 0x3f, 0x01, 0x22, 0x07, 0x05, 0x15,
+  0x17, 0x35, 0x25, 0x15, 0x37, 0x35, 0x05, 0x15, 0x17, 0x35, 0x33, 0x15,
+  0x37, 0x27, 0x07, 0x15, 0x37, 0x27, 0x07, 0x15, 0x33, 0x35, 0x33, 0x15,
+  0x33, 0x35, 0x07, 0x15, 0x17, 0x35, 0x17, 0x15, 0x33, 0x35, 0x07, 0x15,
+  0x33, 0x35, 0x05, 0x27, 0x07, 0x15, 0x16, 0x15, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x26, 0x35, 0x06, 0x25, 0x07, 0x16, 0x15, 0x14, 0x17, 0x32,
+  0x3f, 0x01, 0x26, 0x23, 0x07, 0x25, 0x07, 0x17, 0x35, 0x07, 0x15, 0x17,
+  0x35, 0x27, 0x15, 0x17, 0x35, 0x17, 0x15, 0x37, 0x35, 0x37, 0x15, 0x37,
+  0x35, 0x37, 0x15, 0x37, 0x35, 0x03, 0x4a, 0x01, 0x12, 0x83, 0x35, 0x5b,
+  0x05, 0x16, 0x05, 0x90, 0x28, 0x20, 0x07, 0x39, 0x3f, 0x18, 0x38, 0x50,
+  0xe0, 0x37, 0xd2, 0x3f, 0x56, 0x45, 0x3a, 0x05, 0x2e, 0x3e, 0xac, 0x44,
+  0x9b, 0x9d, 0x41, 0xbc, 0x2e, 0x28, 0x0c, 0x33, 0x44, 0x50, 0x44, 0xce,
+  0xfe, 0xee, 0x61, 0x3e, 0x07, 0x40, 0x03, 0x23, 0x1e, 0x2b, 0x36, 0x78,
+  0x17, 0x0b, 0x60, 0x1f, 0xed, 0x5d, 0xfe, 0xbe, 0x3e, 0x07, 0x1c, 0x0a,
+  0x0b, 0x0c, 0x11, 0x0b, 0x1c, 0x11, 0x8a, 0x3e, 0x5b, 0x50, 0x72, 0xb1,
+  0x1d, 0x17, 0x1e, 0x0c, 0x1c, 0x17, 0x1c, 0x05, 0x40, 0xca, 0x73, 0x65,
+  0x22, 0xfe, 0xcf, 0x5e, 0x12, 0x01, 0x4c, 0x29, 0x02, 0x32, 0x51, 0x06,
+  0x46, 0x20, 0x01, 0xa0, 0xb7, 0x06, 0x22, 0x56, 0x3b, 0x3d, 0xd4, 0x05,
+  0xfc, 0x16, 0x5c, 0x1c, 0x3f, 0x06, 0x12, 0x19, 0x2f, 0xe0, 0xfc, 0x85,
+  0x0f, 0x0d, 0x2f, 0x2a, 0x55, 0x39, 0xd9, 0x5b, 0xb7, 0x16, 0x02, 0x27,
+  0x0d, 0x2e, 0x22, 0x6e, 0x3f, 0x24, 0x2d, 0xf0, 0x29, 0xc0, 0xc4, 0x26,
+  0x01, 0x1a, 0x21, 0x19, 0x44, 0x68, 0x32, 0xac, 0x0b, 0x06, 0x29, 0x14,
+  0x0e, 0x12, 0x17, 0x05, 0x08, 0x01, 0x60, 0x0e, 0x02, 0x17, 0x0c, 0x15,
+  0xfe, 0xba, 0x10, 0x01, 0x07, 0x17, 0xfe, 0xf4, 0x16, 0xb8, 0x18, 0x02,
+  0x3f, 0x14, 0x02, 0x68, 0x1d, 0x12, 0x16, 0x94, 0x16, 0x68, 0x16, 0x45,
+  0x1d, 0xfe, 0x2d, 0x67, 0x06, 0x3e, 0x05, 0x0d, 0x11, 0x3f, 0x8c, 0x1e,
+  0x11, 0xa7, 0x02, 0xc0, 0x10, 0xcc, 0x2e, 0x12, 0x0b, 0x38, 0x05, 0x1c,
+  0x56, 0xfd, 0xe0, 0x03, 0x1a, 0x16, 0x16, 0x65, 0x17, 0xb7, 0x19, 0x0d,
+  0x17, 0x12, 0x17, 0x05, 0xd8, 0xc1, 0x6c, 0x54, 0x45, 0x72, 0x66, 0x5e,
+  0x06, 0x35, 0x2e, 0x3e, 0x3d, 0x39, 0x7c, 0x35, 0x22, 0x18, 0x2d, 0x07,
+  0x6c, 0x29, 0x12, 0x64, 0x0d, 0x12, 0x2c, 0x26, 0x3e, 0x76, 0x76, 0x5d,
+  0x63, 0x63, 0x63, 0x19, 0x57, 0x70, 0x43, 0x2d, 0x2b, 0x0d, 0x0d, 0x64,
+  0x12, 0x95, 0x07, 0x38, 0x0d, 0x1b, 0x42, 0x70, 0x70, 0x3e, 0x06, 0x57,
+  0x5d, 0x6f, 0xd8, 0xe6, 0x61, 0x1d, 0xfe, 0x78, 0x76, 0x75, 0x50, 0x70,
+  0x38, 0x32, 0x13, 0x2c, 0x8e, 0x44, 0xa8, 0x0c, 0x5e, 0x1e, 0x38, 0x2c,
+  0x18, 0x0d, 0x1a, 0x5e, 0x42, 0x24, 0x4b, 0xbb, 0x9c, 0x12, 0x2b, 0x14,
+  0x0b, 0x22, 0x31, 0xae, 0x18, 0x52, 0x5b, 0x2b, 0xd2, 0x65, 0x2a, 0xf1,
+  0x3b, 0xd0, 0x0d, 0x32, 0x0b, 0x0d, 0x9b, 0x9b, 0x57, 0x0a, 0x51, 0x97,
+  0x9b, 0x03, 0x02, 0x50, 0xfe, 0x12, 0x82, 0x05, 0x08, 0x0a, 0x49, 0x26,
+  0x3f, 0x09, 0x67, 0x70, 0x13, 0xeb, 0x6f, 0x25, 0x19, 0x0b, 0x05, 0x12,
+  0x77, 0x0d, 0x5e, 0x19, 0x53, 0x41, 0x24, 0x0d, 0x07, 0x9f, 0x32, 0x0c,
+  0x39, 0x69, 0x2d, 0x35, 0x6e, 0x30, 0x08, 0x32, 0xa2, 0xfe, 0x86, 0xc7,
+  0x0e, 0xbf, 0x0a, 0x0c, 0x41, 0x69, 0x26, 0xae, 0x49, 0x16, 0x59, 0x5e,
+  0x50, 0x5d, 0x44, 0x13, 0x9b, 0x25, 0x88, 0x5c, 0x3f, 0x3f, 0x5c, 0x4f,
+  0x57, 0x43, 0x0d, 0x2c, 0x05, 0x2c, 0x05, 0x31, 0x0a, 0x2f, 0x0f, 0x32,
+  0x05, 0x31, 0x31, 0x08, 0x2f, 0x06, 0x3d, 0x02, 0x3b, 0x06, 0x37, 0x37,
+  0x37, 0x37, 0x3d, 0x33, 0x05, 0x32, 0x0e, 0x31, 0x38, 0x07, 0x31, 0x31,
+  0x7b, 0x05, 0x05, 0x13, 0x39, 0x30, 0x38, 0x68, 0x4e, 0x1d, 0x25, 0x1e,
+  0x62, 0x5c, 0x44, 0x68, 0x2c, 0x0f, 0x29, 0x68, 0x3f, 0x12, 0x05, 0xcc,
+  0x31, 0x06, 0x37, 0x49, 0x32, 0x06, 0x31, 0x21, 0x31, 0x07, 0x32, 0x18,
+  0x32, 0x06, 0x32, 0x04, 0x32, 0x05, 0x33, 0x0a, 0x32, 0x07, 0x31, 0x00,
+  0x00, 0x01, 0x00, 0x9a, 0x00, 0x00, 0x05, 0xdb, 0x05, 0xd8, 0x00, 0x26,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x01, 0x07, 0x14,
+  0x17, 0x25, 0x32, 0x17, 0x15, 0x14, 0x23, 0x05, 0x22, 0x27, 0x26, 0x3d,
+  0x01, 0x34, 0x37, 0x00, 0x37, 0x36, 0x35, 0x34, 0x27, 0x23, 0x05, 0x22,
+  0x27, 0x35, 0x34, 0x37, 0x33, 0x03, 0xd5, 0x81, 0x65, 0x2f, 0x6f, 0xfd,
+  0xae, 0x0a, 0x57, 0x03, 0x16, 0x46, 0x08, 0x5e, 0xfc, 0xf7, 0x91, 0x61,
+  0x18, 0x7d, 0x02, 0x2f, 0x12, 0x0a, 0x58, 0x0a, 0xfd, 0x09, 0x33, 0x0a,
+  0x58, 0x0d, 0x05, 0xd8, 0x8d, 0x4d, 0x4f, 0x8a, 0x62, 0xfd, 0xa0, 0x3e,
+  0x59, 0x1a, 0xd1, 0x61, 0x03, 0x59, 0xc6, 0xae, 0x35, 0x38, 0x18, 0x8a,
+  0x6c, 0x02, 0x37, 0x1b, 0x1b, 0x16, 0x50, 0x20, 0xcc, 0x50, 0x1e, 0x40,
+  0x0c, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0xd8, 0x00, 0x11, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3c, 0x00, 0x46,
+  0x00, 0x58, 0x00, 0x00, 0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x05, 0x06,
+  0x2b, 0x01, 0x20, 0x03, 0x26, 0x3d, 0x01, 0x10, 0x01, 0x36, 0x05, 0x26,
+  0x23, 0x20, 0x03, 0x06, 0x15, 0x10, 0x17, 0x16, 0x33, 0x20, 0x13, 0x36,
+  0x3d, 0x01, 0x10, 0x25, 0x26, 0x01, 0x23, 0x22, 0x27, 0x13, 0x16, 0x3b,
+  0x01, 0x32, 0x37, 0x13, 0x06, 0x01, 0x06, 0x1d, 0x01, 0x21, 0x35, 0x10,
+  0x25, 0x36, 0x37, 0x13, 0x06, 0x25, 0x16, 0x17, 0x21, 0x26, 0x27, 0x26,
+  0x27, 0x13, 0x16, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b,
+  0x01, 0x22, 0x27, 0x26, 0x3d, 0x01, 0x34, 0x37, 0x36, 0x03, 0x2e, 0x01,
+  0x59, 0xee, 0x66, 0xfe, 0xe3, 0xae, 0xbf, 0x1d, 0xfe, 0xaa, 0xec, 0x59,
+  0x01, 0x30, 0xa7, 0x01, 0xe8, 0x96, 0x96, 0xfe, 0xf2, 0xd4, 0x71, 0xfb,
+  0xa0, 0xc9, 0x01, 0x33, 0xd2, 0x50, 0xfe, 0xce, 0x04, 0xfe, 0xf2, 0x19,
+  0x97, 0x7f, 0xbc, 0x2b, 0x32, 0x08, 0x2d, 0x29, 0xbf, 0x7f, 0xfe, 0xfd,
+  0x56, 0xfe, 0x82, 0x01, 0x02, 0x10, 0x11, 0xbd, 0x06, 0x02, 0x45, 0x56,
+  0x03, 0xfe, 0x80, 0x01, 0x1c, 0x1e, 0x27, 0xbd, 0x71, 0xfe, 0x75, 0x49,
+  0x33, 0x16, 0x3d, 0x25, 0x29, 0x07, 0x48, 0x33, 0x12, 0x41, 0x23, 0x05,
+  0xd8, 0xfe, 0x8d, 0xaf, 0xd6, 0xfe, 0xb0, 0xfd, 0x93, 0x01, 0x83, 0xae,
+  0xb2, 0x1c, 0x01, 0x53, 0x01, 0x02, 0x84, 0xac, 0x5d, 0xfe, 0xd9, 0xb1,
+  0xc2, 0xfe, 0xc4, 0xe2, 0x8a, 0x01, 0x5a, 0x96, 0xa6, 0x0f, 0x01, 0x59,
+  0xe0, 0x04, 0xfb, 0x48, 0x59, 0x01, 0x6f, 0x1f, 0x1d, 0xfe, 0x92, 0x58,
+  0x03, 0x28, 0x49, 0x5f, 0x05, 0x10, 0x01, 0x20, 0xdb, 0x0d, 0x0c, 0xfe,
+  0x92, 0x04, 0x8f, 0x91, 0xb0, 0x3b, 0x2e, 0x32, 0x19, 0x01, 0x6c, 0x4f,
+  0xfe, 0xcf, 0x50, 0x25, 0x2e, 0x47, 0x36, 0x1f, 0x52, 0x25, 0x26, 0x05,
+  0x49, 0x38, 0x1c, 0x00, 0x00, 0x06, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x1b,
+  0x05, 0xd8, 0x00, 0x0f, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x4e, 0x00, 0x6c,
+  0x00, 0x8d, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x36, 0x37,
+  0x16, 0x15, 0x14, 0x06, 0x07, 0x26, 0x35, 0x34, 0x03, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x26, 0x27, 0x36, 0x33, 0x32, 0x16, 0x17, 0x06, 0x01, 0x14,
+  0x16, 0x17, 0x06, 0x07, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x16, 0x01, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x16, 0x33,
+  0x32, 0x37, 0x17, 0x06, 0x15, 0x14, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x01,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x33, 0x16, 0x17, 0x16, 0x11, 0x15,
+  0x2e, 0x01, 0x23, 0x06, 0x07, 0x27, 0x36, 0x35, 0x34, 0x27, 0x35, 0x36,
+  0x37, 0x36, 0x35, 0x34, 0x26, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3b,
+  0x01, 0x27, 0x26, 0x27, 0x12, 0x37, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16,
+  0x1f, 0x01, 0x06, 0x15, 0x14, 0x17, 0x07, 0x26, 0x2b, 0x01, 0x22, 0x23,
+  0x22, 0x06, 0x03, 0xcc, 0x3d, 0x41, 0x01, 0x21, 0x20, 0x02, 0x6d, 0x4d,
+  0x09, 0x0c, 0x39, 0x44, 0x07, 0x52, 0x37, 0x1e, 0x13, 0x4e, 0x69, 0x06,
+  0x78, 0x42, 0x16, 0xfe, 0x57, 0x52, 0x3f, 0x03, 0x0e, 0x5e, 0x64, 0x02,
+  0x26, 0x03, 0x61, 0x62, 0x96, 0x29, 0x2d, 0x94, 0x52, 0x01, 0x37, 0x6b,
+  0x53, 0x57, 0x6f, 0x73, 0x4c, 0x48, 0x32, 0xa5, 0x34, 0x2b, 0x19, 0x3e,
+  0x1f, 0x1d, 0x1c, 0x1a, 0x3a, 0x18, 0x32, 0x38, 0x90, 0x3e, 0x48, 0xfe,
+  0xc9, 0x92, 0x53, 0x0f, 0x3e, 0x03, 0x5f, 0x6c, 0xaf, 0x0b, 0xbd, 0x65,
+  0xa5, 0x75, 0x3f, 0x01, 0x39, 0xa3, 0x4c, 0x30, 0x16, 0xfb, 0xf9, 0x04,
+  0x6d, 0x62, 0xa2, 0x10, 0x02, 0x27, 0x02, 0x0f, 0xf9, 0xa0, 0x1e, 0x22,
+  0x5b, 0xac, 0x01, 0x3c, 0x02, 0x3a, 0x65, 0x96, 0x0c, 0x03, 0x04, 0x73,
+  0xa0, 0x01, 0x91, 0x28, 0x8b, 0x41, 0x0c, 0x0c, 0x0e, 0x05, 0x13, 0x12,
+  0x5f, 0xc3, 0x25, 0x18, 0x19, 0x0e, 0x02, 0x0d, 0x23, 0x04, 0x2b, 0x16,
+  0x1c, 0x42, 0x05, 0x37, 0x21, 0xfe, 0xea, 0x4e, 0x8f, 0x20, 0x26, 0x22,
+  0x2e, 0xcb, 0x4f, 0x10, 0x0f, 0x06, 0xfd, 0xb2, 0x53, 0x06, 0x24, 0xaa,
+  0x02, 0x58, 0x45, 0x2f, 0x4b, 0x28, 0x41, 0x61, 0x5d, 0x64, 0x4c, 0x50,
+  0x2a, 0x18, 0x17, 0x27, 0x46, 0x43, 0x61, 0x59, 0x72, 0x3d, 0x05, 0xa0,
+  0x43, 0xd9, 0x34, 0x34, 0x6d, 0x6f, 0x0a, 0x43, 0x82, 0xfe, 0xff, 0x0a,
+  0x9d, 0xb6, 0x0a, 0x93, 0x28, 0x07, 0x07, 0x46, 0x19, 0x4b, 0x1f, 0x9c,
+  0x57, 0x59, 0x1a, 0x8e, 0xfc, 0x46, 0x18, 0x19, 0x95, 0xa1, 0x76, 0x02,
+  0x62, 0x89, 0x01, 0x0e, 0x70, 0x68, 0xb4, 0x27, 0x55, 0x44, 0x98, 0x27,
+  0x52, 0x1d, 0x3c, 0x09, 0x0a, 0x24, 0x88, 0x93, 0x00, 0x17, 0x00, 0x5a,
+  0xff, 0xfc, 0x04, 0x77, 0x05, 0xd1, 0x00, 0x07, 0x00, 0x1d, 0x00, 0x23,
+  0x00, 0x2b, 0x00, 0x3f, 0x00, 0x56, 0x00, 0x6d, 0x00, 0x83, 0x00, 0xa2,
+  0x00, 0xad, 0x00, 0xb2, 0x00, 0xb7, 0x00, 0xbc, 0x00, 0xc1, 0x00, 0xc9,
+  0x00, 0xd0, 0x00, 0xd5, 0x00, 0xda, 0x00, 0xdf, 0x00, 0xe5, 0x00, 0xed,
+  0x00, 0xf4, 0x01, 0x23, 0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x33, 0x32,
+  0x37, 0x26, 0x17, 0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x37, 0x27, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x06, 0x07, 0x26, 0x27, 0x36, 0x35, 0x34,
+  0x01, 0x06, 0x07, 0x23, 0x26, 0x37, 0x03, 0x16, 0x33, 0x32, 0x35, 0x34,
+  0x27, 0x26, 0x13, 0x15, 0x06, 0x23, 0x22, 0x27, 0x35, 0x26, 0x35, 0x36,
+  0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x04, 0x07, 0x23, 0x26, 0x27, 0x15,
+  0x27, 0x35, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x04,
+  0x15, 0x14, 0x07, 0x27, 0x36, 0x35, 0x34, 0x27, 0x34, 0x03, 0x15, 0x27,
+  0x35, 0x24, 0x27, 0x36, 0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x17, 0x06,
+  0x04, 0x17, 0x06, 0x07, 0x27, 0x36, 0x35, 0x34, 0x07, 0x26, 0x27, 0x36,
+  0x37, 0x16, 0x17, 0x06, 0x15, 0x14, 0x04, 0x17, 0x06, 0x07, 0x26, 0x27,
+  0x36, 0x35, 0x34, 0x27, 0x15, 0x27, 0x13, 0x15, 0x27, 0x35, 0x24, 0x35,
+  0x36, 0x37, 0x33, 0x32, 0x17, 0x07, 0x17, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x23, 0x22, 0x15, 0x14, 0x04, 0x17, 0x06, 0x07, 0x26, 0x27, 0x36, 0x27,
+  0x36, 0x01, 0x14, 0x1e, 0x01, 0x33, 0x26, 0x34, 0x37, 0x22, 0x0e, 0x01,
+  0x05, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16,
+  0x17, 0x37, 0x26, 0x27, 0x16, 0x07, 0x37, 0x26, 0x27, 0x14, 0x15, 0x14,
+  0x07, 0x17, 0x35, 0x34, 0x27, 0x06, 0x07, 0x17, 0x36, 0x35, 0x34, 0x05,
+  0x17, 0x36, 0x37, 0x06, 0x07, 0x17, 0x36, 0x37, 0x06, 0x07, 0x17, 0x36,
+  0x37, 0x06, 0x1f, 0x01, 0x35, 0x34, 0x37, 0x06, 0x17, 0x37, 0x26, 0x35,
+  0x34, 0x35, 0x06, 0x15, 0x3f, 0x01, 0x26, 0x27, 0x14, 0x15, 0x14, 0x17,
+  0x15, 0x27, 0x35, 0x26, 0x23, 0x22, 0x07, 0x22, 0x27, 0x36, 0x25, 0x16,
+  0x17, 0x16, 0x33, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01,
+  0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x31, 0x14, 0x31,
+  0x15, 0x36, 0x37, 0x04, 0x17, 0x06, 0x23, 0x26, 0x23, 0x22, 0x03, 0x02,
+  0x04, 0x0a, 0x0b, 0x16, 0x09, 0x47, 0x06, 0x07, 0x3c, 0x31, 0x17, 0x14,
+  0x52, 0x61, 0x20, 0x37, 0x0a, 0x0c, 0xb8, 0x0b, 0x01, 0x7f, 0x3f, 0x8e,
+  0xf7, 0xfe, 0xae, 0x56, 0x1c, 0x0d, 0x01, 0x4d, 0x5d, 0x18, 0x0c, 0x09,
+  0x05, 0x1f, 0xd8, 0x0a, 0x18, 0x1e, 0x03, 0x9d, 0x04, 0x3a, 0x29, 0x28,
+  0x37, 0x01, 0x17, 0x02, 0x0e, 0x17, 0x68, 0x43, 0xfc, 0x04, 0x02, 0x73,
+  0x2f, 0x4e, 0x9d, 0x01, 0x8a, 0x65, 0x2c, 0x3e, 0x01, 0x48, 0x43, 0xfe,
+  0xb7, 0x02, 0x04, 0x66, 0x45, 0x5f, 0xba, 0x01, 0x09, 0x02, 0x37, 0x02,
+  0x04, 0x87, 0x5e, 0x93, 0xe4, 0xf2, 0x05, 0x01, 0x65, 0x41, 0x42, 0x93,
+  0x01, 0xe0, 0x02, 0x03, 0x9d, 0x1e, 0x34, 0x9e, 0xaa, 0x43, 0x43, 0x43,
+  0xfe, 0xa7, 0x0c, 0xb8, 0x08, 0x37, 0x2e, 0x62, 0x53, 0x15, 0x15, 0x33,
+  0x3b, 0x07, 0x07, 0x25, 0x02, 0x89, 0x06, 0x06, 0x9d, 0x39, 0x64, 0xed,
+  0x02, 0x0b, 0xfe, 0x9e, 0x10, 0x1d, 0x11, 0x0e, 0x0e, 0x10, 0x1e, 0x10,
+  0x01, 0x8d, 0x69, 0x27, 0x19, 0x57, 0x88, 0x68, 0x22, 0x26, 0x56, 0x71,
+  0x48, 0x0f, 0x2c, 0x37, 0x75, 0x30, 0x01, 0x37, 0x23, 0x5d, 0x13, 0x36,
+  0x37, 0x2d, 0x2f, 0x36, 0x27, 0xfd, 0x5d, 0x19, 0x28, 0x68, 0x52, 0x28,
+  0x26, 0x22, 0x68, 0x5a, 0x12, 0x2c, 0x0f, 0x48, 0x4b, 0x0e, 0x38, 0x2e,
+  0x43, 0x3a, 0x37, 0x14, 0x23, 0x5d, 0x36, 0x2f, 0x2d, 0xce, 0x43, 0x29,
+  0x40, 0x20, 0x26, 0xf0, 0x50, 0x4c, 0x01, 0x3c, 0x14, 0x50, 0x02, 0x01,
+  0x03, 0x02, 0x12, 0x14, 0x14, 0x25, 0x26, 0x25, 0x15, 0x14, 0x12, 0x03,
+  0x02, 0x4f, 0x15, 0x01, 0x3b, 0x4c, 0x50, 0xf0, 0x26, 0x21, 0x3d, 0x04,
+  0x20, 0x08, 0x04, 0x09, 0x0a, 0x14, 0x3f, 0x02, 0x18, 0x05, 0x17, 0x19,
+  0x3e, 0x02, 0x04, 0x7d, 0x3e, 0x20, 0x11, 0x09, 0x14, 0x2a, 0x30, 0xfc,
+  0x74, 0x22, 0x3c, 0x48, 0x23, 0x03, 0xa6, 0x0b, 0x08, 0x05, 0x09, 0x09,
+  0xfc, 0x2d, 0x38, 0x1a, 0x38, 0x29, 0x1e, 0x36, 0x31, 0x18, 0x0d, 0x06,
+  0x15, 0x15, 0x29, 0x36, 0x66, 0x38, 0xad, 0x5a, 0x0d, 0x5c, 0x2b, 0x48,
+  0x44, 0x20, 0x13, 0x09, 0x1a, 0x27, 0x2a, 0x3e, 0x4a, 0x2e, 0x0e, 0x0b,
+  0x11, 0x1d, 0x05, 0x05, 0x17, 0x01, 0x99, 0x8c, 0x0d, 0x89, 0x26, 0x62,
+  0x35, 0x16, 0x14, 0x07, 0x0f, 0x1d, 0x02, 0x02, 0x34, 0x43, 0x55, 0x45,
+  0x20, 0x1b, 0x27, 0x1a, 0x27, 0xa4, 0x21, 0x60, 0x39, 0x1e, 0x0c, 0x07,
+  0x21, 0x2c, 0x28, 0x4d, 0x54, 0x45, 0x15, 0x0f, 0x0b, 0x1e, 0x2a, 0x21,
+  0x1d, 0x85, 0x0c, 0x02, 0x04, 0x7f, 0x08, 0x7d, 0x15, 0x71, 0x7e, 0x04,
+  0x3d, 0x18, 0x17, 0x05, 0x18, 0x02, 0x2f, 0x2b, 0x29, 0x66, 0x5b, 0x14,
+  0x10, 0x0f, 0x1c, 0x34, 0x1f, 0x02, 0x66, 0x12, 0x20, 0x11, 0x21, 0x42,
+  0x22, 0x11, 0x20, 0x3c, 0x40, 0x30, 0x26, 0x39, 0x15, 0x63, 0x3f, 0x22,
+  0x56, 0x2b, 0x80, 0x47, 0x13, 0x6f, 0x4d, 0x93, 0x4b, 0x08, 0x7e, 0x61,
+  0x11, 0x0f, 0x84, 0x3f, 0x0b, 0x0c, 0x7d, 0x62, 0x89, 0x39, 0x19, 0x65,
+  0x5c, 0x0d, 0x50, 0x26, 0x30, 0x40, 0x11, 0x6b, 0x22, 0x3f, 0x63, 0x2a,
+  0x89, 0x13, 0x47, 0x80, 0x45, 0x89, 0x08, 0x06, 0x4a, 0x8e, 0x58, 0x8d,
+  0x0b, 0x3f, 0x84, 0x0f, 0x11, 0x65, 0x7d, 0x04, 0x19, 0x39, 0x89, 0x0d,
+  0x0d, 0x5c, 0xab, 0xce, 0x06, 0xc2, 0x34, 0x0c, 0xa5, 0x5c, 0x06, 0x36,
+  0x1e, 0x01, 0x18, 0x01, 0x02, 0x0a, 0x27, 0x16, 0x15, 0x27, 0x16, 0x16,
+  0x27, 0x15, 0x16, 0x27, 0x0a, 0x02, 0x01, 0x01, 0x16, 0x1e, 0x36, 0x06,
+  0x5c, 0xa5, 0x0d, 0x00, 0x00, 0x02, 0x00, 0x99, 0x00, 0x00, 0x04, 0xc7,
+  0x05, 0xd9, 0x00, 0x08, 0x00, 0x28, 0x00, 0x00, 0x01, 0x26, 0x27, 0x06,
+  0x07, 0x16, 0x17, 0x36, 0x35, 0x03, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17,
+  0x15, 0x14, 0x07, 0x33, 0x32, 0x37, 0x11, 0x26, 0x2b, 0x02, 0x11, 0x14,
+  0x17, 0x21, 0x36, 0x35, 0x11, 0x2b, 0x01, 0x22, 0x07, 0x11, 0x16, 0x33,
+  0x03, 0x20, 0x02, 0x6d, 0x6d, 0x01, 0x07, 0x67, 0x6f, 0xb1, 0x6b, 0x0b,
+  0x03, 0xb5, 0xb6, 0x03, 0x76, 0x93, 0xa3, 0x9c, 0x98, 0xa1, 0x05, 0x94,
+  0x59, 0xfe, 0xc9, 0x59, 0x97, 0x06, 0xa1, 0x98, 0x9d, 0xa2, 0x04, 0xde,
+  0xb1, 0x02, 0x02, 0xb1, 0x8e, 0x71, 0x58, 0x9f, 0xfe, 0xf1, 0x65, 0xb8,
+  0xf3, 0x02, 0x02, 0xf3, 0x0e, 0xb7, 0x58, 0x63, 0xfe, 0xf7, 0x36, 0xfe,
+  0x0c, 0xb5, 0xae, 0xae, 0xb5, 0x01, 0xf4, 0x36, 0x01, 0x09, 0x63, 0x00,
+  0x00, 0x03, 0x00, 0x99, 0xff, 0xfd, 0x04, 0x14, 0x05, 0xd9, 0x00, 0x03,
+  0x00, 0x20, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x15, 0x33, 0x35, 0x27, 0x35,
+  0x33, 0x15, 0x33, 0x15, 0x23, 0x15, 0x33, 0x05, 0x15, 0x21, 0x11, 0x17,
+  0x15, 0x27, 0x03, 0x23, 0x11, 0x27, 0x35, 0x17, 0x11, 0x21, 0x35, 0x21,
+  0x35, 0x23, 0x35, 0x13, 0x33, 0x11, 0x33, 0x35, 0x23, 0x35, 0x23, 0x15,
+  0x23, 0x15, 0x33, 0x01, 0xf5, 0xb6, 0xa5, 0x9a, 0x71, 0x71, 0x08, 0x01,
+  0x6c, 0xfe, 0x8c, 0x81, 0x7a, 0x01, 0xa0, 0x79, 0x79, 0xfe, 0x93, 0x01,
+  0x6d, 0x6a, 0x94, 0x40, 0xf1, 0xf1, 0x40, 0xf0, 0xf0, 0x05, 0x40, 0x3c,
+  0x3c, 0x33, 0x66, 0x66, 0xa2, 0x58, 0x01, 0xaf, 0xfd, 0xe8, 0x8b, 0x9c,
+  0x85, 0xfe, 0xee, 0x01, 0xbc, 0x86, 0x9b, 0x82, 0x01, 0x71, 0xb0, 0x58,
+  0xa2, 0xfc, 0xcf, 0x01, 0xbb, 0x47, 0x63, 0x63, 0x47, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x99, 0x00, 0x00, 0x05, 0x0c, 0x07, 0x4a, 0x00, 0x07,
+  0x00, 0x20, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23,
+  0x01, 0x11, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x37,
+  0x33, 0x09, 0x01, 0x23, 0x03, 0x11, 0x23, 0x11, 0x03, 0x23, 0x09, 0x01,
+  0x33, 0x02, 0xd7, 0xbc, 0x69, 0x72, 0x72, 0x69, 0xfe, 0xb0, 0x01, 0x50,
+  0xba, 0xbf, 0xbf, 0xba, 0xbc, 0xc4, 0xc6, 0xfe, 0x90, 0x01, 0x83, 0xc5,
+  0xd7, 0x95, 0xe5, 0xc5, 0x01, 0x8b, 0xfe, 0x96, 0xc6, 0x06, 0xa7, 0xfd,
+  0xd8, 0x90, 0x01, 0x08, 0x90, 0xfc, 0x04, 0x04, 0x9f, 0xdf, 0xd8, 0xd9,
+  0xde, 0xfe, 0xcd, 0xed, 0xfe, 0x42, 0xfe, 0x28, 0x01, 0x06, 0xfe, 0xfa,
+  0x01, 0x17, 0xfe, 0xe9, 0x01, 0xe1, 0x01, 0xb5, 0x00, 0x01, 0x00, 0x99,
+  0x00, 0x00, 0x03, 0x54, 0x05, 0xd7, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x33,
+  0x17, 0x15, 0x33, 0x17, 0x15, 0x07, 0x23, 0x15, 0x21, 0x17, 0x15, 0x07,
+  0x21, 0x11, 0x07, 0x23, 0x27, 0x11, 0x21, 0x27, 0x35, 0x37, 0x21, 0x35,
+  0x23, 0x27, 0x35, 0x37, 0x33, 0x35, 0x01, 0xa8, 0x9a, 0x05, 0x95, 0x04,
+  0x04, 0x95, 0x01, 0x07, 0x05, 0x05, 0xfe, 0xf9, 0x05, 0x9a, 0x06, 0xfe,
+  0xfc, 0x05, 0x05, 0x01, 0x04, 0x92, 0x05, 0x05, 0x92, 0x05, 0xd7, 0x05,
+  0x9b, 0x06, 0x94, 0x06, 0x71, 0x06, 0x98, 0x05, 0xfc, 0x82, 0x05, 0x05,
+  0x03, 0x7e, 0x05, 0x98, 0x06, 0x71, 0x06, 0x94, 0x06, 0x9b, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x99, 0xff, 0xfd, 0x05, 0xdc, 0x05, 0xd5, 0x00, 0x2b,
+  0x00, 0x00, 0x01, 0x21, 0x17, 0x15, 0x07, 0x23, 0x11, 0x21, 0x35, 0x37,
+  0x33, 0x17, 0x11, 0x07, 0x23, 0x27, 0x35, 0x21, 0x11, 0x33, 0x17, 0x15,
+  0x07, 0x21, 0x27, 0x35, 0x37, 0x33, 0x11, 0x21, 0x15, 0x07, 0x23, 0x27,
+  0x11, 0x37, 0x33, 0x17, 0x15, 0x21, 0x11, 0x23, 0x27, 0x35, 0x02, 0x75,
+  0x01, 0x8a, 0x06, 0x06, 0x90, 0x02, 0x02, 0x06, 0x5f, 0x05, 0x05, 0x5f,
+  0x06, 0xfd, 0xfe, 0x90, 0x06, 0x06, 0xfe, 0x76, 0x05, 0x05, 0x99, 0xfd,
+  0xfd, 0x05, 0x68, 0x05, 0x05, 0x68, 0x05, 0x02, 0x03, 0x99, 0x05, 0x05,
+  0xd5, 0x06, 0x77, 0x06, 0xfd, 0xd1, 0xa1, 0x06, 0x06, 0xfe, 0x49, 0x06,
+  0x06, 0x9e, 0xfd, 0xc8, 0x06, 0x6a, 0x06, 0x06, 0x6a, 0x06, 0x02, 0x38,
+  0x9e, 0x06, 0x06, 0x01, 0xb7, 0x06, 0x06, 0xa1, 0x02, 0x2f, 0x06, 0x77,
+  0x00, 0x02, 0x00, 0xa0, 0x00, 0x00, 0x05, 0xd6, 0x05, 0xd8, 0x00, 0x1b,
+  0x00, 0x2c, 0x00, 0x00, 0x01, 0x33, 0x32, 0x17, 0x23, 0x27, 0x20, 0x03,
+  0x06, 0x15, 0x10, 0x05, 0x16, 0x33, 0x37, 0x15, 0x06, 0x07, 0x06, 0x2b,
+  0x01, 0x20, 0x03, 0x26, 0x35, 0x10, 0x25, 0x36, 0x01, 0x33, 0x32, 0x17,
+  0x33, 0x15, 0x07, 0x16, 0x15, 0x27, 0x07, 0x23, 0x35, 0x37, 0x27, 0x35,
+  0x33, 0x03, 0x40, 0x12, 0xc7, 0xbd, 0x05, 0xd7, 0xfe, 0xcb, 0xbc, 0x55,
+  0x01, 0x34, 0x7b, 0x8c, 0xe7, 0x90, 0x7c, 0x49, 0x30, 0x19, 0xfe, 0xb5,
+  0xd6, 0x77, 0x01, 0x5f, 0x9b, 0x02, 0x3f, 0x03, 0x05, 0x38, 0xbc, 0x97,
+  0x3a, 0x9f, 0x98, 0x03, 0x3c, 0x9b, 0xc0, 0x05, 0xd8, 0x92, 0x36, 0xfe,
+  0xca, 0x9e, 0xb9, 0xfe, 0x92, 0xd6, 0x47, 0x32, 0x06, 0x6b, 0x1a, 0x0b,
+  0x01, 0x3e, 0xc0, 0xe9, 0x01, 0xaa, 0xee, 0x59, 0xfe, 0x33, 0xc9, 0x03,
+  0x7e, 0xbb, 0x11, 0x7c, 0x7c, 0x03, 0xc9, 0x7e, 0x03, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd, 0x05, 0xd9, 0x00, 0x16,
+  0x00, 0x4f, 0x00, 0x62, 0x00, 0x73, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32,
+  0x37, 0x16, 0x33, 0x32, 0x37, 0x35, 0x33, 0x17, 0x15, 0x14, 0x0f, 0x01,
+  0x22, 0x27, 0x06, 0x23, 0x22, 0x27, 0x34, 0x17, 0x33, 0x16, 0x17, 0x32,
+  0x15, 0x03, 0x33, 0x24, 0x11, 0x34, 0x27, 0x35, 0x16, 0x11, 0x15, 0x10,
+  0x07, 0x06, 0x07, 0x15, 0x16, 0x3b, 0x01, 0x15, 0x06, 0x2b, 0x01, 0x22,
+  0x07, 0x27, 0x23, 0x22, 0x27, 0x35, 0x33, 0x32, 0x37, 0x35, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x10, 0x3f, 0x01, 0x15, 0x06, 0x15, 0x10, 0x05, 0x35,
+  0x03, 0x35, 0x37, 0x32, 0x27, 0x15, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x15, 0x23, 0x26, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36, 0x33, 0x34, 0x25,
+  0x16, 0x17, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x07, 0x34, 0x37, 0x36,
+  0x3d, 0x01, 0x10, 0x25, 0x02, 0x9f, 0x19, 0x39, 0x2a, 0x1d, 0x22, 0x27,
+  0x3c, 0x13, 0x04, 0x02, 0x3e, 0x1b, 0x28, 0x1f, 0x1e, 0x28, 0x49, 0x0f,
+  0xa0, 0x02, 0x2d, 0x1f, 0x07, 0x09, 0x02, 0x01, 0x07, 0x63, 0xc7, 0xc9,
+  0x45, 0x2a, 0x48, 0x95, 0x17, 0x69, 0x41, 0x74, 0x14, 0x3e, 0x3d, 0x82,
+  0x32, 0x7b, 0x36, 0x6d, 0x4e, 0x50, 0x70, 0x20, 0x5a, 0xb4, 0x1d, 0x69,
+  0x01, 0x08, 0x10, 0x03, 0x1f, 0xe6, 0x55, 0x3b, 0x78, 0x83, 0x02, 0x8e,
+  0x54, 0x22, 0xf1, 0x6d, 0x20, 0x02, 0x3b, 0x77, 0x75, 0x9e, 0x95, 0x50,
+  0x1c, 0x31, 0x52, 0xfe, 0xf4, 0x05, 0xd9, 0x4b, 0x30, 0x30, 0x44, 0x07,
+  0x28, 0x05, 0x3b, 0x1b, 0x04, 0x2c, 0x2c, 0x65, 0x22, 0x87, 0x40, 0x0b,
+  0x05, 0xfc, 0x20, 0xe4, 0x01, 0x70, 0xc2, 0xcf, 0x03, 0xd7, 0xfe, 0xeb,
+  0x24, 0xfe, 0xf1, 0xdd, 0x42, 0x16, 0x05, 0x28, 0x05, 0x21, 0x63, 0x63,
+  0x1c, 0x05, 0x2a, 0x03, 0x40, 0x72, 0x4a, 0xb1, 0xb1, 0x01, 0x01, 0xe6,
+  0x1f, 0x05, 0xc0, 0xe2, 0xfe, 0xa7, 0xf5, 0x02, 0x03, 0x26, 0x16, 0xa9,
+  0x2a, 0x06, 0x45, 0x63, 0xcc, 0xef, 0xe9, 0xd6, 0x02, 0x4a, 0xe9, 0x6b,
+  0x67, 0x01, 0x0c, 0xcd, 0x46, 0x04, 0x02, 0x1e, 0x70, 0xb7, 0xd8, 0x2f,
+  0xd4, 0xb6, 0x51, 0x06, 0x07, 0x52, 0xaf, 0xbf, 0x02, 0x01, 0x6d, 0xf4,
+  0x00, 0x03, 0x00, 0x99, 0x00, 0x00, 0x04, 0x85, 0x05, 0xd9, 0x00, 0x5b,
+  0x00, 0x66, 0x00, 0x6e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x0f, 0x01, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x17, 0x23, 0x15, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x37, 0x33, 0x16, 0x11, 0x10, 0x03, 0x26, 0x23, 0x22, 0x15,
+  0x14, 0x17, 0x16, 0x15, 0x14, 0x15, 0x06, 0x23, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x15, 0x14, 0x15, 0x14, 0x17, 0x14, 0x23, 0x22, 0x35, 0x36,
+  0x3d, 0x01, 0x06, 0x15, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x34, 0x36, 0x35,
+  0x34, 0x23, 0x22, 0x07, 0x02, 0x11, 0x34, 0x37, 0x33, 0x17, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x17, 0x35, 0x23, 0x35, 0x26, 0x35, 0x34, 0x37, 0x2f,
+  0x01, 0x36, 0x03, 0x14, 0x17, 0x33, 0x36, 0x35, 0x34, 0x27, 0x06, 0x07,
+  0x06, 0x25, 0x06, 0x15, 0x14, 0x17, 0x36, 0x35, 0x34, 0x02, 0x8f, 0x3c,
+  0x49, 0x11, 0x0d, 0x72, 0x2e, 0x32, 0xb8, 0x01, 0x6c, 0x6d, 0x80, 0x79,
+  0x71, 0x13, 0x05, 0xd2, 0x86, 0x6c, 0x47, 0x32, 0x6c, 0x1b, 0x0c, 0x26,
+  0x0a, 0x08, 0x28, 0x06, 0x35, 0x54, 0x48, 0x5e, 0x64, 0x48, 0x8a, 0x07,
+  0x33, 0x05, 0x25, 0x0d, 0x87, 0x29, 0x4a, 0x68, 0x8b, 0xcd, 0x05, 0x13,
+  0x71, 0xc1, 0x38, 0x6d, 0x6b, 0xb7, 0xd6, 0x16, 0x0e, 0x4e, 0xb9, 0x79,
+  0x04, 0x3f, 0x1a, 0x50, 0x2e, 0x24, 0x01, 0x4b, 0x1f, 0x3b, 0x81, 0x05,
+  0xd9, 0x4b, 0x0f, 0x7c, 0x2e, 0x50, 0x51, 0x55, 0xc7, 0x62, 0x4b, 0x78,
+  0x81, 0x9d, 0xc6, 0xb0, 0x72, 0x13, 0xa5, 0xfe, 0xfe, 0xfe, 0xe0, 0xfe,
+  0xc9, 0xae, 0x2d, 0x1c, 0x93, 0x26, 0x2a, 0x02, 0x03, 0x3b, 0x02, 0x22,
+  0xee, 0x31, 0x96, 0x03, 0x04, 0x46, 0x71, 0x3b, 0x3c, 0x74, 0x4d, 0x92,
+  0x5d, 0xbf, 0x23, 0x3b, 0x40, 0xa4, 0x22, 0x2b, 0xad, 0x01, 0x21, 0x01,
+  0x4d, 0xe9, 0xa6, 0x13, 0x79, 0xae, 0xfb, 0xa3, 0x2f, 0x12, 0x78, 0x4b,
+  0x5c, 0xcc, 0xbe, 0x67, 0x7c, 0x12, 0x48, 0xfd, 0xff, 0x92, 0x4a, 0x69,
+  0x8b, 0x53, 0x7e, 0x19, 0x4a, 0x3f, 0xa2, 0x73, 0x63, 0x89, 0x66, 0x3d,
+  0xa8, 0x98, 0x00, 0x00, 0x00, 0x01, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdb,
+  0x05, 0xd7, 0x00, 0x32, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x17, 0x07, 0x23, 0x27, 0x06, 0x23, 0x22, 0x27, 0x15, 0x03, 0x23,
+  0x26, 0x27, 0x36, 0x01, 0x36, 0x33, 0x16, 0x33, 0x32, 0x37, 0x27, 0x07,
+  0x23, 0x26, 0x27, 0x13, 0x04, 0x15, 0x07, 0x16, 0x17, 0x35, 0x36, 0x3d,
+  0x01, 0x34, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x36, 0x03, 0x84, 0xd5,
+  0xbc, 0x87, 0x70, 0xae, 0x7e, 0x02, 0xa7, 0x94, 0xc3, 0x9a, 0x80, 0xea,
+  0x03, 0xb7, 0x04, 0x17, 0x01, 0x37, 0x15, 0x07, 0x65, 0x8f, 0xac, 0x87,
+  0xc3, 0x61, 0x05, 0xa9, 0x08, 0xd2, 0x00, 0xff, 0x72, 0xcf, 0x1a, 0x3c,
+  0xe2, 0x7c, 0x6b, 0x21, 0x58, 0x6c, 0x99, 0x05, 0xd7, 0xbd, 0x9b, 0xd7,
+  0xc9, 0x8a, 0x94, 0x83, 0xaa, 0x6e, 0x58, 0x03, 0xfe, 0x31, 0x8d, 0x07,
+  0x19, 0x01, 0x98, 0x1d, 0x55, 0x68, 0xc6, 0x73, 0x74, 0x0c, 0x01, 0x02,
+  0x0e, 0x05, 0x9f, 0xaf, 0x0e, 0x02, 0x5a, 0x7c, 0x24, 0xfe, 0x65, 0x45,
+  0x37, 0x8f, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0xd8, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x21,
+  0x00, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x13, 0x14, 0x17, 0x01, 0x03, 0x06, 0x00, 0x13, 0x16, 0x17,
+  0x1b, 0x01, 0x36, 0x37, 0x09, 0x01, 0x36, 0x35, 0x34, 0x00, 0x27, 0x11,
+  0x99, 0x01, 0x8a, 0x01, 0x17, 0x01, 0x18, 0x01, 0x89, 0xfe, 0x77, 0xfe,
+  0xe8, 0xfe, 0xe9, 0xfe, 0x76, 0x89, 0x6d, 0x01, 0x7f, 0x02, 0xb0, 0xfe,
+  0xc6, 0x9c, 0x9e, 0xad, 0x01, 0x56, 0xb8, 0x9a, 0xfe, 0xae, 0x01, 0x8f,
+  0x65, 0xfe, 0xc4, 0xbd, 0x02, 0xea, 0x01, 0x37, 0x01, 0xb7, 0xfe, 0x49,
+  0xfe, 0xc9, 0xfe, 0xca, 0xfe, 0x4c, 0x01, 0xb4, 0x01, 0x36, 0xe5, 0x78,
+  0x01, 0xf5, 0x01, 0xc2, 0x04, 0xfe, 0xa3, 0xfd, 0x62, 0xb1, 0x06, 0x02,
+  0x68, 0xfd, 0x96, 0x08, 0xa4, 0x01, 0xb6, 0xfe, 0x97, 0x70, 0xf5, 0xf9,
+  0x01, 0x5d, 0x04, 0xfe, 0x42, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd8, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x28,
+  0x00, 0x34, 0x00, 0x00, 0x01, 0x15, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x05,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x05,
+  0x34, 0x26, 0x22, 0x06, 0x15, 0x14, 0x16, 0x32, 0x36, 0x25, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x3a, 0x09,
+  0xb1, 0x82, 0x84, 0xb4, 0xfe, 0x8c, 0xff, 0x00, 0xfe, 0xfb, 0xfe, 0xa2,
+  0x12, 0x16, 0x9f, 0x86, 0x81, 0xb2, 0x01, 0x9c, 0x37, 0x22, 0x26, 0x36,
+  0x36, 0x26, 0x24, 0x35, 0xfd, 0x8b, 0x35, 0x4a, 0x34, 0x34, 0x4a, 0x35,
+  0x03, 0x81, 0xfe, 0x77, 0xfe, 0xe8, 0xfe, 0xe9, 0xfe, 0x76, 0x01, 0x8a,
+  0x01, 0x17, 0x01, 0x18, 0x01, 0x89, 0x02, 0xf8, 0x1a, 0x8e, 0xc1, 0xcf,
+  0x9a, 0x01, 0x16, 0x01, 0x98, 0xfe, 0x7b, 0xfe, 0xc9, 0xac, 0xb2, 0xc0,
+  0x9e, 0x29, 0x3a, 0x3a, 0x29, 0x2a, 0x3c, 0x3c, 0x2a, 0x2a, 0x3c, 0x3c,
+  0x2a, 0x29, 0x3a, 0x3c, 0x27, 0xfe, 0xca, 0xfe, 0x4c, 0x01, 0xb4, 0x01,
+  0x36, 0x01, 0x37, 0x01, 0xb7, 0xfe, 0x49, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x07, 0x0b, 0xb3,
+  0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd,
+  0x05, 0xd4, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x01, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0c,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26,
+  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85,
+  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
+  0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb4,
+  0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26,
+  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x85,
+  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb3,
+  0x00, 0x00, 0x05, 0x0d, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0xd5, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
+  0x00, 0x00, 0x02, 0x85, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d,
+  0x00, 0x0a, 0x00, 0x79, 0xff, 0xea, 0x05, 0xfb, 0x05, 0xe1, 0x00, 0x0c,
+  0x00, 0x40, 0x00, 0x46, 0x00, 0x4c, 0x00, 0x52, 0x00, 0x58, 0x00, 0x5e,
+  0x00, 0x64, 0x00, 0x6a, 0x00, 0x70, 0x00, 0x00, 0x00, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x36, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x05, 0x26, 0x34,
+  0x37, 0x33, 0x36, 0x37, 0x27, 0x36, 0x37, 0x17, 0x36, 0x37, 0x35, 0x36,
+  0x32, 0x17, 0x15, 0x16, 0x17, 0x37, 0x16, 0x17, 0x07, 0x16, 0x17, 0x33,
+  0x16, 0x14, 0x07, 0x23, 0x06, 0x07, 0x17, 0x06, 0x07, 0x27, 0x06, 0x07,
+  0x15, 0x06, 0x23, 0x27, 0x35, 0x26, 0x27, 0x07, 0x26, 0x27, 0x37, 0x26,
+  0x27, 0x01, 0x36, 0x37, 0x03, 0x06, 0x07, 0x05, 0x16, 0x17, 0x37, 0x26,
+  0x27, 0x01, 0x36, 0x37, 0x27, 0x06, 0x07, 0x25, 0x16, 0x17, 0x37, 0x26,
+  0x27, 0x01, 0x26, 0x27, 0x07, 0x16, 0x17, 0x25, 0x06, 0x07, 0x17, 0x36,
+  0x37, 0x05, 0x06, 0x07, 0x13, 0x36, 0x37, 0x25, 0x26, 0x27, 0x07, 0x16,
+  0x17, 0x02, 0xa8, 0x2c, 0x2a, 0x3c, 0x3c, 0x54, 0x2b, 0x2a, 0x3b, 0x3c,
+  0x2a, 0xfd, 0xbf, 0x19, 0x19, 0x65, 0x18, 0x60, 0x4c, 0x0e, 0x59, 0x4a,
+  0x6f, 0xaf, 0x23, 0x46, 0x24, 0xa4, 0x7c, 0x47, 0x5b, 0x10, 0x4d, 0x5f,
+  0x19, 0x65, 0x19, 0x19, 0x65, 0x12, 0x66, 0x4d, 0x10, 0x5b, 0x47, 0x7d,
+  0xa3, 0x24, 0x23, 0x46, 0xa3, 0x7c, 0x49, 0x57, 0x10, 0x49, 0x5d, 0x18,
+  0x01, 0xc8, 0x1e, 0x20, 0x0b, 0x80, 0x58, 0x01, 0x5a, 0x25, 0x1a, 0xa4,
+  0x5a, 0x7e, 0xfe, 0xd1, 0x07, 0x14, 0xb7, 0x44, 0x15, 0x02, 0xab, 0x16,
+  0x05, 0xf7, 0x11, 0x49, 0xfd, 0xad, 0x12, 0x09, 0xf5, 0x14, 0x44, 0x02,
+  0x6e, 0x07, 0x14, 0xb8, 0x4a, 0x0f, 0xfe, 0x9c, 0x1e, 0x21, 0x0b, 0x7e,
+  0x5a, 0xfe, 0xa5, 0x1a, 0x23, 0xa6, 0x5a, 0x7f, 0x03, 0x26, 0x84, 0x2f,
+  0x2f, 0x5e, 0x84, 0x30, 0x30, 0x30, 0xc3, 0x27, 0x4e, 0x27, 0xb7, 0x7c,
+  0x50, 0x5f, 0x10, 0x50, 0x66, 0x1e, 0x70, 0x1c, 0x1c, 0x70, 0x16, 0x6f,
+  0x51, 0x0f, 0x60, 0x51, 0x79, 0xb9, 0x27, 0x4e, 0x27, 0xb0, 0x83, 0x50,
+  0x5c, 0x0b, 0x51, 0x67, 0x1d, 0x70, 0x1c, 0x1c, 0x70, 0x17, 0x6d, 0x51,
+  0x0b, 0x5c, 0x50, 0x79, 0xba, 0x01, 0x2c, 0x13, 0x0a, 0x01, 0x0d, 0x16,
+  0x4d, 0xaa, 0x0a, 0x13, 0xc6, 0x4e, 0x15, 0xfe, 0x3e, 0x26, 0x1a, 0xab,
+  0x60, 0x82, 0x37, 0x1e, 0x22, 0x0a, 0x7f, 0x62, 0xfe, 0x4b, 0x1e, 0x2a,
+  0x11, 0x8c, 0x56, 0xf4, 0x26, 0x22, 0xac, 0x67, 0x7b, 0x89, 0x12, 0x0b,
+  0xfe, 0xf0, 0x1e, 0x4d, 0xa5, 0x09, 0x14, 0xc2, 0x4d, 0x1e, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a,
+  0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36,
+  0x20, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x07,
+  0x02, 0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08,
+  0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
+  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x20, 0x2e, 0xa4, 0x01, 0xd0,
+  0xa4, 0x2d, 0x21, 0x67, 0x1a, 0x23, 0x80, 0xfe, 0x94, 0x80, 0x23, 0x1a,
+  0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51,
+  0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
+  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd,
+  0x25, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x8d,
+  0x28, 0x2b, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3d,
+  0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x13, 0x37, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07,
+  0x06, 0x20, 0x27, 0x26, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34,
+  0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc,
+  0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
+  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
+  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x67,
+  0x1a, 0x23, 0x80, 0x01, 0x6c, 0x80, 0x23, 0x1a, 0x67, 0x21, 0x2d, 0xa4,
+  0xfe, 0x30, 0xa4, 0x2e, 0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53,
+  0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75, 0x02,
+  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
+  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
+  0xc0, 0xfe, 0x40, 0xfd, 0xaa, 0x47, 0x2b, 0x27, 0x8e, 0x8e, 0x27, 0x2c,
+  0x48, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x21,
+  0x00, 0x31, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x05, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x22, 0x06, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x25, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x27, 0x06,
+  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
+  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x49, 0x35, 0x34, 0x4b, 0x4b, 0x68,
+  0x4a, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
+  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x4e, 0x20, 0x2e, 0xa4,
+  0x01, 0xd0, 0xa4, 0x2d, 0x21, 0x67, 0x1a, 0x23, 0x80, 0xfe, 0x94, 0x80,
+  0x23, 0x1a, 0x03, 0xfd, 0x3a, 0x53, 0x52, 0x76, 0x51, 0x51, 0x3b, 0x3a,
+  0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0xfe, 0xb2, 0x01, 0x75, 0x02, 0x0f,
+  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x5b, 0x38,
+  0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x8e, 0x27, 0x2b,
+  0x00, 0x0a, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0xd8, 0x00, 0x07,
+  0x00, 0x0c, 0x00, 0x13, 0x00, 0x22, 0x00, 0x2a, 0x00, 0x32, 0x00, 0x3a,
+  0x00, 0x41, 0x00, 0x49, 0x00, 0x58, 0x00, 0x00, 0x01, 0x33, 0x17, 0x11,
+  0x07, 0x23, 0x27, 0x11, 0x05, 0x17, 0x15, 0x07, 0x27, 0x25, 0x17, 0x07,
+  0x23, 0x26, 0x27, 0x35, 0x05, 0x32, 0x1f, 0x01, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01, 0x21, 0x17, 0x15, 0x07,
+  0x21, 0x27, 0x35, 0x25, 0x21, 0x17, 0x15, 0x07, 0x21, 0x27, 0x35, 0x03,
+  0x33, 0x16, 0x17, 0x15, 0x07, 0x27, 0x35, 0x25, 0x33, 0x17, 0x15, 0x07,
+  0x27, 0x35, 0x25, 0x33, 0x17, 0x11, 0x07, 0x23, 0x27, 0x11, 0x03, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x27, 0x26, 0x23,
+  0x22, 0x03, 0x1b, 0x46, 0x05, 0x05, 0x46, 0x06, 0x02, 0x00, 0x34, 0xdf,
+  0x37, 0xfd, 0x48, 0xe4, 0x38, 0x03, 0xb4, 0x28, 0x01, 0xf8, 0xc2, 0x53,
+  0x0b, 0xb0, 0x41, 0x2b, 0xa3, 0x5b, 0x21, 0xaa, 0x3f, 0xfd, 0x90, 0x01,
+  0x32, 0x05, 0x05, 0xfe, 0xce, 0x05, 0x04, 0x05, 0x01, 0x37, 0x06, 0x06,
+  0xfe, 0xc9, 0x06, 0x40, 0x03, 0x79, 0x66, 0x37, 0xdf, 0xfd, 0xef, 0x03,
+  0x35, 0xdf, 0x36, 0x01, 0xe5, 0x46, 0x05, 0x05, 0x46, 0x06, 0x20, 0x75,
+  0x16, 0x3e, 0x70, 0x1d, 0x2c, 0x79, 0x08, 0x39, 0x84, 0x23, 0x05, 0xd8,
+  0x06, 0xfe, 0xa1, 0x06, 0x06, 0x01, 0x5f, 0x9c, 0x3e, 0x03, 0xff, 0x3f,
+  0xee, 0xfe, 0x40, 0xc7, 0x37, 0x04, 0xb5, 0xe2, 0x60, 0xbd, 0x64, 0x18,
+  0xa8, 0x40, 0x5c, 0xb4, 0x68, 0x1b, 0xfe, 0xed, 0x06, 0x50, 0x06, 0x06,
+  0x50, 0x06, 0x06, 0x50, 0x06, 0x06, 0x50, 0xfe, 0xe7, 0x82, 0x79, 0x03,
+  0x3f, 0xfd, 0x04, 0x2b, 0x3c, 0x03, 0xfe, 0x3e, 0x04, 0x77, 0x06, 0xfe,
+  0xa1, 0x06, 0x06, 0x01, 0x5f, 0x02, 0x56, 0x47, 0x7b, 0x3f, 0x2c, 0x72,
+  0x11, 0x43, 0x82, 0x41, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x93,
+  0x00, 0x00, 0x05, 0xdd, 0x05, 0xd7, 0x00, 0x17, 0x00, 0x2b, 0x00, 0x00,
+  0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x01, 0x06, 0x2b, 0x01, 0x22, 0x27,
+  0x35, 0x36, 0x37, 0x36, 0x11, 0x10, 0x25, 0x26, 0x27, 0x35, 0x34, 0x37,
+  0x17, 0x15, 0x04, 0x11, 0x10, 0x05, 0x07, 0x15, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x36, 0x3d, 0x01, 0x10, 0x01, 0x26, 0x23, 0x03, 0x25, 0x01, 0x63,
+  0xf5, 0x5f, 0xfe, 0x9c, 0xa1, 0x9f, 0x2c, 0x2a, 0x49, 0xf9, 0x71, 0x8b,
+  0xfe, 0xd4, 0x7b, 0x53, 0x86, 0x24, 0x01, 0x9b, 0xfe, 0xd1, 0x27, 0x05,
+  0x4e, 0x8e, 0xd2, 0x4a, 0x1a, 0xfe, 0xc7, 0x92, 0x8f, 0x05, 0xd7, 0xfe,
+  0x87, 0xad, 0xc6, 0xfe, 0x78, 0xfe, 0xff, 0x62, 0x0f, 0x06, 0x4f, 0xb1,
+  0xca, 0x01, 0x0c, 0x01, 0x90, 0xe0, 0x50, 0x10, 0x03, 0x0b, 0x0e, 0x3e,
+  0x03, 0xc5, 0xfe, 0x14, 0xfe, 0x6e, 0xe8, 0x18, 0x04, 0x53, 0x98, 0xf4,
+  0x5d, 0x5d, 0x09, 0x01, 0x3d, 0x01, 0x05, 0x66, 0x00, 0x02, 0x00, 0x99,
+  0x00, 0x00, 0x03, 0xe2, 0x05, 0xd8, 0x00, 0x17, 0x00, 0x2b, 0x00, 0x00,
+  0x21, 0x20, 0x03, 0x26, 0x35, 0x10, 0x01, 0x36, 0x3b, 0x01, 0x32, 0x17,
+  0x15, 0x06, 0x07, 0x06, 0x11, 0x10, 0x05, 0x16, 0x17, 0x15, 0x14, 0x07,
+  0x27, 0x35, 0x24, 0x11, 0x10, 0x25, 0x37, 0x35, 0x23, 0x22, 0x07, 0x06,
+  0x07, 0x06, 0x1d, 0x01, 0x10, 0x01, 0x16, 0x33, 0x03, 0x51, 0xfe, 0x9c,
+  0xf5, 0x5f, 0x01, 0x64, 0xa1, 0xa0, 0x2c, 0x29, 0x48, 0xf8, 0x71, 0x8b,
+  0x01, 0x2d, 0x7a, 0x54, 0x86, 0x24, 0xfe, 0x64, 0x01, 0x2f, 0x27, 0x05,
+  0x4e, 0x8f, 0xd0, 0x4b, 0x19, 0x01, 0x37, 0x94, 0x8e, 0x01, 0x79, 0xad,
+  0xc6, 0x01, 0x88, 0x01, 0x01, 0x63, 0x0f, 0x07, 0x4f, 0xb1, 0xcb, 0xfe,
+  0xf5, 0xfe, 0x70, 0xe1, 0x4f, 0x10, 0x04, 0x0a, 0x0e, 0x3e, 0x03, 0xc5,
+  0x01, 0xed, 0x01, 0x91, 0xe8, 0x18, 0x03, 0x53, 0x96, 0xf5, 0x5c, 0x5e,
+  0x09, 0xfe, 0xc2, 0xfe, 0xfc, 0x66, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d,
+  0xff, 0x30, 0x03, 0xce, 0x05, 0xdb, 0x00, 0x31, 0x00, 0x3e, 0x00, 0x00,
+  0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x15, 0x37, 0x15,
+  0x07, 0x15, 0x23, 0x27, 0x23, 0x35, 0x33, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x3d, 0x01, 0x33, 0x15, 0x14,
+  0x17, 0x16, 0x17, 0x33, 0x36, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x23, 0x06, 0x07, 0x06, 0x10, 0x16, 0x33, 0x32, 0x36,
+  0x10, 0x27, 0x26, 0x03, 0x12, 0x24, 0x20, 0x78, 0x77, 0x61, 0x81, 0xc3,
+  0xc6, 0x74, 0x01, 0xb5, 0xb5, 0x01, 0x85, 0x62, 0x77, 0x77, 0x21, 0x24,
+  0x24, 0x21, 0x77, 0x7f, 0x52, 0x4d, 0x69, 0x22, 0x69, 0x4c, 0x52, 0x80,
+  0x78, 0x20, 0xef, 0x22, 0x69, 0x4d, 0x52, 0xa5, 0x75, 0x72, 0xa5, 0x52,
+  0x4c, 0x04, 0x56, 0x1a, 0x24, 0x83, 0xbd, 0xbc, 0x7c, 0x64, 0x0e, 0xd1,
+  0x02, 0x64, 0x01, 0xca, 0xcb, 0x62, 0xd1, 0x0d, 0x65, 0x7c, 0xbc, 0xbd,
+  0x83, 0x24, 0x1a, 0x19, 0x25, 0x83, 0xbc, 0x08, 0x0a, 0x82, 0x5a, 0x53,
+  0x07, 0x07, 0x53, 0x5a, 0x82, 0x0a, 0x08, 0xbc, 0x83, 0x25, 0x5f, 0x06,
+  0x54, 0x59, 0xfe, 0xfc, 0xaa, 0xaa, 0x01, 0x04, 0x59, 0x54, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x9d, 0xfe, 0xff, 0x04, 0xa9, 0x05, 0xda, 0x00, 0x0b,
+  0x00, 0x23, 0x00, 0x00, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x01, 0x26, 0x35, 0x34, 0x00, 0x33, 0x32, 0x00,
+  0x10, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23,
+  0x35, 0x33, 0x11, 0x26, 0x02, 0xa3, 0x94, 0xcf, 0xcf, 0x94, 0x91, 0xd2,
+  0xd2, 0xfe, 0x02, 0x98, 0x01, 0x2e, 0xd7, 0xd4, 0x01, 0x31, 0x98, 0x7a,
+  0xa2, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xa3, 0x05, 0x27, 0xe4, 0xa4, 0xa3,
+  0xd8, 0xd8, 0xa3, 0xa4, 0xe4, 0xfc, 0xed, 0x9d, 0xee, 0xef, 0x01, 0x4c,
+  0xfe, 0xb4, 0xfe, 0x22, 0x9c, 0x7e, 0x12, 0xfe, 0xf8, 0x7c, 0xfe, 0xff,
+  0x01, 0x01, 0x7c, 0x01, 0x09, 0x11, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d,
+  0xff, 0xe3, 0x04, 0xa9, 0x06, 0xbe, 0x00, 0x0b, 0x00, 0x23, 0x00, 0x00,
+  0x25, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x01, 0x16, 0x15, 0x14, 0x00, 0x23, 0x22, 0x00, 0x10, 0x37, 0x36, 0x37,
+  0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x16,
+  0x02, 0xa3, 0x94, 0xcf, 0xcf, 0x94, 0x91, 0xd2, 0xd2, 0x01, 0xfe, 0x98,
+  0xfe, 0xd2, 0xd7, 0xd4, 0xfe, 0xcf, 0x98, 0x7a, 0xa2, 0xf4, 0xf4, 0xa2,
+  0xf5, 0xf5, 0xa3, 0x96, 0xe4, 0xa4, 0xa3, 0xd8, 0xd8, 0xa3, 0xa4, 0xe4,
+  0x03, 0x13, 0x9d, 0xee, 0xef, 0xfe, 0xb4, 0x01, 0x4c, 0x01, 0xde, 0x9c,
+  0x7e, 0x12, 0x01, 0x08, 0x7c, 0x01, 0x01, 0xfe, 0xff, 0x7c, 0xfe, 0xf7,
+  0x11, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x91, 0xff, 0xe3, 0x05, 0xfb,
+  0x05, 0xc3, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x22, 0x06, 0x10,
+  0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x13, 0x06, 0x23, 0x22, 0x00, 0x10,
+  0x00, 0x17, 0x16, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x07, 0x11, 0x01,
+  0x16, 0x15, 0x14, 0x02, 0x97, 0x93, 0xd0, 0xd0, 0x93, 0x91, 0xd3, 0xd3,
+  0xe2, 0x97, 0xdc, 0xd3, 0xfe, 0xce, 0x01, 0x36, 0xcf, 0xcd, 0x65, 0x01,
+  0x45, 0xfe, 0xb2, 0x7e, 0x01, 0xbd, 0x81, 0xfe, 0xbe, 0x65, 0x03, 0x96,
+  0xe4, 0xfe, 0xb8, 0xd8, 0xd8, 0x01, 0x48, 0xe4, 0xfc, 0xf1, 0xa4, 0x01,
+  0x3d, 0x01, 0xdc, 0x01, 0x55, 0x09, 0x08, 0x67, 0x01, 0x5c, 0x8e, 0xfe,
+  0x14, 0x8f, 0x01, 0x75, 0xfe, 0xa4, 0x92, 0xc1, 0xe8, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x31, 0x00, 0x00, 0x05, 0x42, 0x05, 0xd8, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x35, 0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x06, 0x1d,
+  0x01, 0x23, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x07, 0x33, 0x11,
+  0x33, 0x11, 0x23, 0x11, 0x21, 0x35, 0x02, 0xbf, 0x6e, 0x99, 0x98, 0x6f,
+  0x6d, 0x9a, 0x87, 0xe8, 0xa6, 0xa8, 0xe8, 0x62, 0xcd, 0x88, 0x88, 0xfc,
+  0x77, 0x02, 0x13, 0x01, 0xab, 0xf2, 0xab, 0xab, 0x79, 0x02, 0xb9, 0x01,
+  0x04, 0xfe, 0xfc, 0xb9, 0xa8, 0x7b, 0x03, 0xc5, 0xfa, 0x28, 0x01, 0x7c,
+  0x97, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x93, 0x00, 0x00, 0x04, 0xe0,
+  0x05, 0xd8, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33, 0x35, 0x33,
+  0x15, 0x33, 0x15, 0x23, 0x11, 0x36, 0x33, 0x32, 0x12, 0x15, 0x14, 0x06,
+  0x1d, 0x01, 0x23, 0x34, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x23, 0x01, 0xf3, 0x60, 0x60, 0x88, 0xa1, 0xa1, 0x64, 0x89, 0xa0,
+  0xd7, 0x7e, 0x87, 0x7e, 0x8b, 0x64, 0x63, 0x8b, 0x88, 0x04, 0x8d, 0x97,
+  0xb4, 0xb4, 0x97, 0xfe, 0x7d, 0x6d, 0xfe, 0xfe, 0xbb, 0x5a, 0xe5, 0x79,
+  0x02, 0x84, 0xee, 0x48, 0x7b, 0xa9, 0xaa, 0x7a, 0xfe, 0x46, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xdf, 0x00, 0x00, 0x05, 0x94, 0x05, 0xd8, 0x00, 0x0a,
+  0x00, 0x31, 0x00, 0x00, 0x00, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x27, 0x16, 0x17, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x11, 0x21, 0x11, 0x21, 0x35, 0x33, 0x11, 0x23,
+  0x35, 0x21, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x21, 0x15, 0x23,
+  0x11, 0x33, 0x15, 0x21, 0x11, 0x21, 0x03, 0x6c, 0x65, 0x47, 0x47, 0x32,
+  0x32, 0x47, 0x34, 0x37, 0x2b, 0x44, 0x89, 0x62, 0x60, 0x8a, 0x45, 0x2a,
+  0x38, 0xfe, 0xfd, 0xfe, 0xec, 0x8c, 0x8c, 0x01, 0x14, 0x01, 0x03, 0x88,
+  0x01, 0x03, 0x01, 0x12, 0x89, 0x89, 0xfe, 0xee, 0xfe, 0xfd, 0x01, 0x8c,
+  0x4f, 0x37, 0x39, 0x4e, 0x4e, 0x39, 0x37, 0xc2, 0x12, 0x30, 0x4c, 0xd8,
+  0x99, 0x99, 0xd8, 0x4c, 0x31, 0x11, 0x01, 0x8c, 0xfe, 0x4b, 0x97, 0x02,
+  0xd3, 0x98, 0xfe, 0x4a, 0x01, 0xb6, 0xfe, 0x4a, 0x01, 0xb6, 0x98, 0xfd,
+  0x2d, 0x97, 0x01, 0xb5, 0x00, 0x01, 0x00, 0xea, 0x00, 0x00, 0x05, 0x8a,
+  0x05, 0xd8, 0x00, 0x3c, 0x00, 0x00, 0x25, 0x15, 0x23, 0x35, 0x23, 0x35,
+  0x33, 0x35, 0x26, 0x27, 0x26, 0x27, 0x35, 0x07, 0x27, 0x37, 0x33, 0x17,
+  0x15, 0x27, 0x15, 0x33, 0x15, 0x23, 0x16, 0x17, 0x16, 0x17, 0x11, 0x07,
+  0x27, 0x37, 0x33, 0x17, 0x15, 0x27, 0x11, 0x36, 0x37, 0x36, 0x3d, 0x01,
+  0x33, 0x35, 0x07, 0x27, 0x37, 0x33, 0x17, 0x15, 0x27, 0x15, 0x33, 0x15,
+  0x06, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x03, 0x7f, 0x88, 0x9f, 0x9f,
+  0x95, 0x6e, 0x87, 0x01, 0x81, 0x01, 0x82, 0x89, 0x82, 0x82, 0x02, 0x02,
+  0x01, 0x5e, 0x46, 0x5d, 0x83, 0x01, 0x84, 0x88, 0x82, 0x82, 0x5b, 0x45,
+  0x5f, 0x01, 0x81, 0x01, 0x82, 0x89, 0x82, 0x82, 0x01, 0x01, 0x87, 0x6e,
+  0x94, 0x9d, 0xbb, 0xbb, 0xbb, 0x97, 0x8b, 0x16, 0x7a, 0x96, 0xd7, 0x54,
+  0x8e, 0x8c, 0x99, 0x99, 0x8c, 0x8e, 0x54, 0x02, 0x97, 0x68, 0x4f, 0x14,
+  0x02, 0xca, 0x8d, 0x8b, 0x9a, 0x9a, 0x8b, 0x8d, 0xfd, 0x37, 0x14, 0x4e,
+  0x6a, 0x96, 0x01, 0x59, 0x8e, 0x8c, 0x99, 0x99, 0x8c, 0x8e, 0x59, 0x04,
+  0xd3, 0x96, 0x79, 0x17, 0x8b, 0x97, 0x00, 0x00, 0x00, 0x02, 0x01, 0xba,
+  0x00, 0x00, 0x04, 0xb9, 0x05, 0xd8, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x00,
+  0x01, 0x21, 0x20, 0x17, 0x16, 0x15, 0x10, 0x07, 0x06, 0x23, 0x21, 0x11,
+  0x21, 0x17, 0x15, 0x07, 0x21, 0x27, 0x11, 0x17, 0x11, 0x21, 0x32, 0x37,
+  0x36, 0x37, 0x34, 0x27, 0x26, 0x23, 0x01, 0xc2, 0x01, 0x70, 0x01, 0x10,
+  0x5a, 0x1d, 0xe2, 0x35, 0x31, 0xfe, 0xcc, 0x02, 0x3b, 0x07, 0x07, 0xfd,
+  0x4a, 0x07, 0x82, 0x01, 0x26, 0x75, 0x40, 0x0f, 0x07, 0x92, 0x21, 0x49,
+  0x05, 0xd8, 0xd0, 0x4d, 0x5f, 0xfe, 0xf6, 0x5c, 0x11, 0xfd, 0xad, 0x08,
+  0x82, 0x08, 0x08, 0x05, 0xc7, 0x83, 0xfe, 0x24, 0x82, 0x1a, 0x50, 0xa4,
+  0x3c, 0x10, 0x00, 0x00, 0x00, 0x01, 0x00, 0x53, 0x00, 0x00, 0x06, 0x20,
+  0x05, 0xda, 0x00, 0x24, 0x00, 0x00, 0x21, 0x10, 0x00, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x17, 0x23, 0x26, 0x35, 0x34, 0x36, 0x33, 0x20, 0x13, 0x16,
+  0x17, 0x36, 0x37, 0x12, 0x21, 0x32, 0x16, 0x15, 0x14, 0x07, 0x23, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x00, 0x11, 0x03, 0x01, 0xfe, 0xfe, 0x98,
+  0x74, 0x1f, 0x4c, 0x79, 0x53, 0x92, 0x84, 0x01, 0x4f, 0x75, 0x08, 0x04,
+  0x04, 0x07, 0x77, 0x01, 0x4e, 0x84, 0x92, 0x54, 0x78, 0x4c, 0x1f, 0x75,
+  0x97, 0xfe, 0xff, 0x02, 0x58, 0x03, 0x05, 0xc5, 0x22, 0x80, 0x80, 0x84,
+  0xa1, 0x84, 0xbb, 0xfc, 0xfb, 0x31, 0x28, 0x28, 0x31, 0x03, 0x05, 0xbb,
+  0x84, 0xa1, 0x84, 0x80, 0x81, 0x22, 0xc4, 0xfc, 0xfb, 0xfd, 0xa8, 0x00,
+  0x00, 0x02, 0x00, 0xa4, 0x00, 0x00, 0x05, 0xd0, 0x05, 0xd8, 0x00, 0x08,
+  0x00, 0x2e, 0x00, 0x00, 0x01, 0x22, 0x06, 0x10, 0x16, 0x20, 0x36, 0x10,
+  0x26, 0x27, 0x36, 0x37, 0x3e, 0x02, 0x33, 0x15, 0x22, 0x02, 0x07, 0x06,
+  0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x00, 0x23, 0x22, 0x00, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x02, 0x23, 0x35, 0x32, 0x1e, 0x01,
+  0x17, 0x16, 0x03, 0x39, 0x84, 0xb9, 0xb9, 0x01, 0x09, 0xba, 0xb9, 0x86,
+  0x76, 0x45, 0x4d, 0x57, 0x91, 0xa7, 0x6f, 0x96, 0x76, 0x13, 0x15, 0x2a,
+  0x26, 0x84, 0xfe, 0xf6, 0xbe, 0xbb, 0xfe, 0xf6, 0x85, 0x25, 0x2b, 0x16,
+  0x13, 0x74, 0x9a, 0x6d, 0xa6, 0xa8, 0x40, 0x4d, 0x45, 0x03, 0x5c, 0xcf,
+  0xfe, 0xda, 0xce, 0xce, 0x01, 0x26, 0xcf, 0x96, 0x05, 0x3d, 0x42, 0xb4,
+  0xae, 0x6c, 0xfe, 0xc8, 0x6c, 0x13, 0x0f, 0x1e, 0x29, 0x95, 0xd2, 0xd1,
+  0xfe, 0xd9, 0x01, 0x27, 0xd1, 0xd2, 0x95, 0x2a, 0x1e, 0x0e, 0x13, 0x6c,
+  0x01, 0x38, 0x6c, 0xae, 0xb4, 0x42, 0x3d, 0x00, 0x00, 0x02, 0x00, 0xac,
+  0x00, 0x00, 0x05, 0xc6, 0x05, 0xda, 0x00, 0x13, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x26, 0x27, 0x35, 0x04, 0x20, 0x25, 0x15, 0x06, 0x07, 0x11, 0x16,
+  0x17, 0x15, 0x24, 0x20, 0x05, 0x35, 0x36, 0x3f, 0x01, 0x36, 0x33, 0x17,
+  0x11, 0x06, 0x23, 0x27, 0x01, 0xdd, 0x97, 0x99, 0x01, 0x38, 0x02, 0xac,
+  0x01, 0x35, 0x9f, 0x95, 0x95, 0x9f, 0xfe, 0xcb, 0xfd, 0x54, 0xfe, 0xc8,
+  0x99, 0x97, 0x89, 0x68, 0x6a, 0xd1, 0x68, 0x69, 0xd2, 0x04, 0xfc, 0x16,
+  0x34, 0x94, 0x5a, 0x5a, 0x97, 0x2f, 0x18, 0xfb, 0xe2, 0x17, 0x2f, 0x98,
+  0x5b, 0x5b, 0x94, 0x35, 0x15, 0x0c, 0x0d, 0x0d, 0x04, 0x07, 0x0d, 0x0d,
+  0x00, 0x04, 0x00, 0xcf, 0x00, 0x40, 0x05, 0xa5, 0x05, 0x6f, 0x00, 0x08,
+  0x00, 0x1d, 0x00, 0x26, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x22, 0x06, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x34, 0x01, 0x2c, 0x01, 0x27, 0x35, 0x16, 0x04,
+  0x33, 0x32, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x10, 0x07,
+  0x0e, 0x01, 0x01, 0x32, 0x36, 0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0x01,
+  0x0c, 0x01, 0x17, 0x15, 0x26, 0x24, 0x23, 0x22, 0x17, 0x16, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x3e, 0x01, 0x04, 0xbb, 0xab,
+  0x76, 0x76, 0x56, 0x54, 0x78, 0xfe, 0x88, 0xfe, 0xe7, 0xfe, 0xb9, 0x8a,
+  0xe4, 0x01, 0x47, 0x35, 0x75, 0x07, 0x76, 0xb9, 0x84, 0x86, 0xb9, 0x5d,
+  0x42, 0xdd, 0xfd, 0xe6, 0x55, 0x78, 0x78, 0xa9, 0x79, 0x78, 0x01, 0x01,
+  0x01, 0x19, 0x01, 0x48, 0x89, 0xe3, 0xfe, 0xba, 0x34, 0x78, 0x07, 0x76,
+  0xb8, 0x85, 0x86, 0xb9, 0x5e, 0x41, 0xdd, 0x02, 0xb8, 0x84, 0xbe, 0x85,
+  0x85, 0xbe, 0xfe, 0x0c, 0x02, 0x28, 0x2b, 0x7c, 0x54, 0x16, 0x1a, 0x6c,
+  0xa7, 0x93, 0xcf, 0xcf, 0xfe, 0xda, 0x67, 0x4d, 0x4c, 0x02, 0xb6, 0x84,
+  0xbe, 0x84, 0x84, 0xbe, 0x84, 0x02, 0x78, 0x02, 0x29, 0x2b, 0x7b, 0x54,
+  0x15, 0x1a, 0x6c, 0xa6, 0x94, 0xcf, 0xcf, 0x94, 0x92, 0x67, 0x4d, 0x4d,
+  0x00, 0x02, 0x01, 0x01, 0x00, 0x00, 0x05, 0x73, 0x05, 0xd8, 0x00, 0x13,
+  0x00, 0x4d, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x27, 0x2e, 0x01,
+  0x23, 0x22, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x1e, 0x01, 0x33, 0x32,
+  0x13, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x00, 0x15, 0x16, 0x17,
+  0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x00, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x32, 0x35, 0x34, 0x26, 0x02, 0x52,
+  0x44, 0x2c, 0x0c, 0x1a, 0x66, 0x23, 0x20, 0x20, 0x43, 0x2c, 0x0c, 0x1b,
+  0x64, 0x23, 0x20, 0x2b, 0xc9, 0xa2, 0x9a, 0xc4, 0xfe, 0xfc, 0x03, 0x79,
+  0x40, 0x5a, 0x3a, 0x72, 0x64, 0x59, 0x82, 0x01, 0x03, 0x94, 0x77, 0x72,
+  0x87, 0x29, 0x17, 0x21, 0x08, 0x1d, 0x2e, 0x68, 0x32, 0x33, 0x36, 0x9b,
+  0x2b, 0x14, 0x19, 0x2e, 0x69, 0x31, 0x32, 0x44, 0x43, 0x07, 0x45, 0x01,
+  0x8c, 0x1d, 0x71, 0x27, 0x23, 0x23, 0x4b, 0x32, 0x0e, 0x1e, 0x6f, 0x27,
+  0x23, 0x24, 0x4c, 0x31, 0x02, 0xf0, 0xa1, 0xc9, 0xdd, 0xb0, 0xbb, 0xfe,
+  0x0a, 0xb4, 0x7c, 0x03, 0x58, 0x48, 0x77, 0x79, 0x6f, 0xc7, 0x01, 0xe1,
+  0xc2, 0x86, 0xa5, 0x9b, 0x81, 0x3c, 0x91, 0x3e, 0x62, 0x80, 0x11, 0x57,
+  0x44, 0x73, 0x2d, 0x16, 0x4b, 0x78, 0x36, 0x38, 0x3c, 0x3c, 0x72, 0x2e,
+  0x15, 0x29, 0x0d, 0x1a, 0xb8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x62,
+  0xfe, 0x8f, 0x06, 0x12, 0x05, 0xd8, 0x00, 0x3a, 0x00, 0x44, 0x00, 0x00,
+  0x01, 0x32, 0x16, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x1d, 0x01, 0x3e,
+  0x01, 0x33, 0x32, 0x16, 0x11, 0x10, 0x01, 0x16, 0x17, 0x23, 0x26, 0x27,
+  0x06, 0x07, 0x35, 0x36, 0x37, 0x27, 0x11, 0x34, 0x35, 0x10, 0x27, 0x0e,
+  0x01, 0x07, 0x11, 0x23, 0x11, 0x10, 0x26, 0x2b, 0x02, 0x22, 0x06, 0x07,
+  0x11, 0x23, 0x11, 0x34, 0x27, 0x33, 0x16, 0x17, 0x3e, 0x01, 0x01, 0x11,
+  0x36, 0x13, 0x34, 0x26, 0x2b, 0x01, 0x22, 0x06, 0x02, 0x64, 0x39, 0x6b,
+  0x24, 0xb2, 0x44, 0x37, 0x4a, 0x2b, 0x76, 0x3d, 0x36, 0x5a, 0xfe, 0xa9,
+  0x01, 0x84, 0x97, 0x2a, 0x42, 0x97, 0x9d, 0xac, 0x6f, 0x08, 0x29, 0x34,
+  0x78, 0x39, 0x88, 0x1c, 0x1f, 0x01, 0x01, 0x25, 0xa1, 0x11, 0x86, 0x89,
+  0x80, 0x6a, 0x20, 0x15, 0xa5, 0x02, 0x7d, 0xe8, 0x16, 0x29, 0x19, 0x03,
+  0x1b, 0x81, 0x05, 0xd8, 0xc6, 0x80, 0x77, 0xcf, 0xa7, 0xdb, 0xca, 0x7d,
+  0x77, 0xe8, 0xfe, 0xef, 0xfe, 0x68, 0xfe, 0xbf, 0x5e, 0xc1, 0x29, 0xa1,
+  0x65, 0x07, 0x74, 0x1c, 0x57, 0xd9, 0x03, 0x57, 0x12, 0x11, 0x01, 0x19,
+  0x01, 0x01, 0xd9, 0xc8, 0xfc, 0x61, 0x03, 0x9a, 0x01, 0x41, 0x6a, 0xe2,
+  0xd7, 0xfc, 0x74, 0x04, 0x41, 0xbe, 0xbf, 0x4f, 0xb0, 0x5d, 0xbc, 0xfc,
+  0x92, 0xfd, 0xd0, 0xfa, 0x01, 0x52, 0xc1, 0x8b, 0xce, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x99, 0x00, 0x6b, 0x05, 0xdb, 0x05, 0x39, 0x00, 0x03,
+  0x00, 0x23, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x01, 0x21, 0x35, 0x21,
+  0x26, 0x35, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x07, 0x21, 0x15,
+  0x21, 0x35, 0x23, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x22, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x17, 0x9a, 0x05, 0x40, 0xfa, 0xc0, 0x01, 0xf5, 0xfe,
+  0x0b, 0x01, 0x3e, 0x3c, 0xe8, 0xa6, 0xa7, 0xe9, 0x3d, 0x01, 0x5d, 0xfd,
+  0xeb, 0x01, 0x10, 0x0f, 0x4e, 0x99, 0xdc, 0x99, 0x4d, 0x0e, 0x11, 0x01,
+  0x03, 0x98, 0x01, 0x8f, 0x98, 0x68, 0x83, 0xb9, 0x01, 0x03, 0xfe, 0xfd,
+  0xb9, 0x83, 0x68, 0x98, 0x98, 0x0d, 0x11, 0x55, 0x79, 0x7a, 0xaa, 0xaa,
+  0x7a, 0x79, 0x55, 0x11, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3e,
+  0xff, 0x3c, 0x06, 0x38, 0x05, 0xd8, 0x00, 0x38, 0x00, 0x00, 0x01, 0x14,
+  0x16, 0x17, 0x33, 0x35, 0x33, 0x17, 0x07, 0x27, 0x35, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x03, 0x34, 0x35, 0x10, 0x27, 0x0e, 0x01, 0x07, 0x11, 0x23,
+  0x11, 0x10, 0x26, 0x2b, 0x02, 0x22, 0x06, 0x07, 0x11, 0x23, 0x11, 0x34,
+  0x27, 0x33, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x3e, 0x01,
+  0x33, 0x32, 0x16, 0x1d, 0x01, 0x13, 0x04, 0x80, 0x5d, 0x50, 0x50, 0x03,
+  0xb7, 0xb7, 0x03, 0x50, 0xb7, 0x3d, 0x28, 0x07, 0x13, 0x29, 0x34, 0x78,
+  0x39, 0x88, 0x1c, 0x1f, 0x01, 0x01, 0x25, 0xa1, 0x11, 0x86, 0x89, 0x80,
+  0x6a, 0x20, 0x15, 0xa5, 0x3e, 0x39, 0x6b, 0x24, 0xb2, 0x44, 0x37, 0x4a,
+  0x01, 0x01, 0x0f, 0x6f, 0x7d, 0x01, 0x76, 0xad, 0xaf, 0x04, 0x76, 0x78,
+  0x4a, 0x76, 0x03, 0x16, 0x12, 0x11, 0x01, 0x19, 0x01, 0x01, 0xd9, 0xc8,
+  0xfc, 0x61, 0x03, 0x9a, 0x01, 0x41, 0x6a, 0xe2, 0xd7, 0xfc, 0x74, 0x04,
+  0x41, 0xbe, 0xbf, 0x4f, 0xb0, 0x5d, 0xbc, 0xc6, 0x80, 0x77, 0xcf, 0xa7,
+  0xdb, 0xca, 0xfd, 0x84, 0x00, 0x01, 0x00, 0x98, 0xff, 0xff, 0x05, 0xdc,
+  0x05, 0xd8, 0x00, 0x14, 0x00, 0x00, 0x01, 0x11, 0x09, 0x01, 0x07, 0x09,
+  0x01, 0x2f, 0x02, 0x09, 0x01, 0x3f, 0x02, 0x09, 0x01, 0x21, 0x35, 0x21,
+  0x11, 0x05, 0x53, 0xfd, 0x85, 0x01, 0x1d, 0x61, 0xfe, 0xe3, 0xfe, 0x82,
+  0x01, 0x5f, 0x01, 0x01, 0x7e, 0xfe, 0xe2, 0x01, 0x60, 0x01, 0x01, 0x1d,
+  0x02, 0x7a, 0xfe, 0x37, 0x02, 0xb3, 0x02, 0xd8, 0x01, 0xfc, 0xfd, 0x3f,
+  0xfe, 0xc3, 0x6c, 0x01, 0x3d, 0xfe, 0x58, 0x01, 0x6a, 0x01, 0x01, 0xa8,
+  0x01, 0x3d, 0x01, 0x6a, 0x01, 0xfe, 0xc3, 0x02, 0xc1, 0x98, 0xfd, 0x00,
+  0x00, 0x02, 0x00, 0xac, 0x00, 0x00, 0x05, 0xc6, 0x05, 0xd8, 0x00, 0x29,
+  0x00, 0x31, 0x00, 0x00, 0x01, 0x32, 0x12, 0x37, 0x36, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x27, 0x0e, 0x01, 0x07, 0x23, 0x35, 0x37,
+  0x36, 0x13, 0x26, 0x02, 0x23, 0x22, 0x02, 0x15, 0x14, 0x15, 0x07, 0x34,
+  0x02, 0x27, 0x35, 0x32, 0x16, 0x13, 0x36, 0x37, 0x3e, 0x01, 0x01, 0x16,
+  0x33, 0x32, 0x37, 0x26, 0x27, 0x22, 0x02, 0xfe, 0x60, 0x49, 0x17, 0x62,
+  0xaf, 0x6d, 0x8a, 0x81, 0x80, 0x8b, 0x6e, 0x28, 0x71, 0x7c, 0x97, 0x8a,
+  0x6e, 0x5e, 0x2c, 0x3a, 0x34, 0x21, 0x8a, 0x8f, 0x7e, 0x77, 0x84, 0x91,
+  0x24, 0x29, 0x29, 0x25, 0x6e, 0x01, 0x34, 0x54, 0x75, 0x91, 0x08, 0x06,
+  0x8f, 0x89, 0x05, 0xd8, 0xfc, 0x9e, 0x04, 0xdd, 0xbe, 0x67, 0x91, 0xab,
+  0x85, 0xa0, 0xd7, 0x04, 0x76, 0x01, 0x04, 0x01, 0x78, 0x10, 0x03, 0x15,
+  0xfe, 0x2d, 0xc3, 0x0f, 0x0e, 0x02, 0xfd, 0x01, 0xf0, 0x06, 0x61, 0xde,
+  0xfe, 0xed, 0xc9, 0x58, 0x5b, 0x96, 0xfc, 0x26, 0x91, 0xc5, 0x9d, 0x13,
+  0x00, 0x02, 0x00, 0x9e, 0x01, 0x39, 0x05, 0xd6, 0x04, 0xa2, 0x00, 0x27,
+  0x00, 0x51, 0x00, 0x00, 0x13, 0x00, 0x33, 0x32, 0x17, 0x16, 0x32, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x32, 0x37, 0x36, 0x33, 0x32, 0x13, 0x07, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x23, 0x22, 0x06, 0x23, 0x27, 0x11, 0x00, 0x33, 0x32,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x33, 0x32, 0x13, 0x07, 0x26, 0x23, 0x22, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x22, 0x06,
+  0x23, 0x27, 0x9e, 0x01, 0x25, 0x67, 0x29, 0x0c, 0x15, 0x65, 0x9b, 0x32,
+  0x31, 0x15, 0x18, 0x66, 0x4e, 0x26, 0x25, 0x70, 0x62, 0x55, 0x38, 0x56,
+  0x2e, 0x36, 0x4d, 0x65, 0x16, 0x1a, 0x35, 0x31, 0x4b, 0x4e, 0x32, 0x32,
+  0x17, 0x15, 0x31, 0x31, 0xe8, 0x05, 0x30, 0x01, 0x24, 0x68, 0x28, 0x0d,
+  0x15, 0x33, 0x31, 0x4e, 0x4e, 0x63, 0x15, 0x18, 0x32, 0x34, 0x4d, 0x27,
+  0x24, 0x71, 0x62, 0x55, 0x38, 0x56, 0x2e, 0x36, 0x4e, 0x31, 0x33, 0x17,
+  0x19, 0x35, 0x31, 0x4c, 0x4d, 0x33, 0x31, 0x17, 0x15, 0x63, 0xe7, 0x05,
+  0x30, 0x01, 0x9d, 0x01, 0x0f, 0x28, 0x47, 0x8e, 0x47, 0x47, 0x47, 0x24,
+  0xfe, 0xc4, 0x33, 0xb9, 0x35, 0x4c, 0x4b, 0x4e, 0x43, 0x47, 0x48, 0x46,
+  0xd5, 0x62, 0x01, 0xd9, 0x01, 0x0d, 0x27, 0x46, 0x46, 0x48, 0x48, 0x46,
+  0x46, 0x23, 0xfe, 0xc5, 0x32, 0xb9, 0x36, 0x4d, 0x4c, 0x4e, 0x44, 0x47,
+  0x48, 0x48, 0xd5, 0x61, 0x00, 0x01, 0x01, 0x20, 0x00, 0x00, 0x05, 0x53,
+  0x05, 0xd8, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x07, 0x02, 0x03, 0x07, 0x00,
+  0x13, 0x21, 0x35, 0x21, 0x02, 0x01, 0x17, 0x12, 0x13, 0x33, 0x12, 0x13,
+  0x37, 0x00, 0x03, 0x21, 0x07, 0x21, 0x12, 0x01, 0x27, 0x02, 0x03, 0x03,
+  0xa6, 0xd9, 0x1d, 0xfa, 0x94, 0x01, 0x14, 0x18, 0xfe, 0xf6, 0x01, 0x0a,
+  0x19, 0xfe, 0xec, 0x95, 0xfa, 0x1d, 0xda, 0x1c, 0xfb, 0x95, 0xfe, 0xeb,
+  0x18, 0x01, 0x0a, 0x01, 0xfe, 0xf5, 0x1a, 0x01, 0x15, 0x96, 0xfb, 0x1c,
+  0x02, 0x99, 0x03, 0xfe, 0xae, 0xfe, 0xbf, 0x03, 0x01, 0x5f, 0x01, 0x37,
+  0xac, 0x01, 0x36, 0x01, 0x60, 0x03, 0xfe, 0xc0, 0xfe, 0xad, 0x01, 0x53,
+  0x01, 0x40, 0x03, 0xfe, 0xa0, 0xfe, 0xca, 0xac, 0xfe, 0xc9, 0xfe, 0xa1,
+  0x03, 0x01, 0x41, 0x01, 0x52, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0xc0, 0x05, 0xd8, 0x00, 0x0f, 0x00, 0x20, 0x00, 0x24,
+  0x00, 0x54, 0x00, 0x64, 0x00, 0x00, 0x01, 0x36, 0x37, 0x26, 0x27, 0x26,
+  0x22, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x21, 0x33, 0x21,
+  0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06,
+  0x07, 0x16, 0x17, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x26, 0x27, 0x2e,
+  0x01, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x35, 0x34, 0x36, 0x37,
+  0x36, 0x37, 0x35, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15, 0x23,
+  0x15, 0x16, 0x17, 0x1e, 0x01, 0x1d, 0x01, 0x36, 0x33, 0x32, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x01, 0x14, 0x1e, 0x01, 0x33,
+  0x32, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x02,
+  0xfb, 0x01, 0x02, 0x20, 0x2e, 0x42, 0x8c, 0x85, 0x4b, 0x49, 0x43, 0x14,
+  0x14, 0x01, 0x35, 0x7f, 0x01, 0x34, 0x16, 0x13, 0x43, 0x49, 0x4b, 0x84,
+  0x47, 0x46, 0x42, 0x2f, 0x1f, 0x02, 0x01, 0xfe, 0x6c, 0x02, 0xa9, 0xfd,
+  0x0d, 0x26, 0x22, 0x3e, 0x61, 0x63, 0xb2, 0x5e, 0x48, 0x44, 0x20, 0x1d,
+  0x0c, 0x0e, 0x61, 0x61, 0x5f, 0x61, 0x61, 0x0e, 0x0c, 0x1c, 0x21, 0x45,
+  0x47, 0x5d, 0xb2, 0x64, 0x62, 0x3d, 0x23, 0x25, 0xfe, 0x0d, 0x17, 0x29,
+  0x14, 0x16, 0x28, 0x16, 0x16, 0x28, 0x16, 0x14, 0x29, 0x17, 0x03, 0xc7,
+  0x03, 0x03, 0x2b, 0x1c, 0x29, 0x51, 0x95, 0x50, 0x51, 0x92, 0x28, 0x0e,
+  0x08, 0x08, 0x0e, 0x28, 0x92, 0x51, 0x50, 0x95, 0x51, 0x29, 0x1c, 0x2b,
+  0x03, 0x03, 0xfd, 0xb8, 0xfe, 0xd1, 0x01, 0x2f, 0xfe, 0x81, 0x01, 0x7f,
+  0x0d, 0x16, 0x36, 0xc4, 0x6b, 0x6c, 0xc5, 0x6a, 0x1f, 0x02, 0x24, 0x3f,
+  0x12, 0x07, 0x04, 0x36, 0x46, 0x57, 0x57, 0x46, 0x36, 0x04, 0x07, 0x12,
+  0x3f, 0x24, 0x02, 0x1f, 0x6a, 0xc5, 0x6c, 0x6b, 0xc4, 0x36, 0x16, 0x0d,
+  0xfe, 0x81, 0x04, 0x7d, 0x19, 0x2b, 0x19, 0x19, 0x2b, 0x19, 0x18, 0x2d,
+  0x17, 0x17, 0x2d, 0x00, 0x00, 0x08, 0x00, 0xcb, 0x00, 0x00, 0x05, 0xa9,
+  0x05, 0xd8, 0x00, 0x48, 0x00, 0x4e, 0x00, 0x52, 0x00, 0x68, 0x00, 0x7c,
+  0x00, 0x90, 0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x26, 0x27, 0x34,
+  0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x13, 0x03, 0x22,
+  0x27, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x1b,
+  0x01, 0x26, 0x27, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06,
+  0x07, 0x1b, 0x01, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01,
+  0x15, 0x06, 0x07, 0x03, 0x13, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32,
+  0x1e, 0x01, 0x15, 0x06, 0x23, 0x03, 0x11, 0x21, 0x11, 0x01, 0x35, 0x07,
+  0x21, 0x27, 0x1d, 0x02, 0x21, 0x35, 0x01, 0x17, 0x03, 0x36, 0x37, 0x3e,
+  0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x1e,
+  0x01, 0x33, 0x32, 0x37, 0x01, 0x17, 0x03, 0x36, 0x37, 0x3e, 0x01, 0x34,
+  0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x37,
+  0x01, 0x37, 0x13, 0x16, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23,
+  0x22, 0x0e, 0x01, 0x14, 0x16, 0x17, 0x16, 0x17, 0x01, 0x33, 0x03, 0x32,
+  0x37, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x17, 0x16, 0x17, 0x01, 0x37, 0x13, 0x16, 0x33, 0x32, 0x3e,
+  0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x16,
+  0x17, 0x16, 0x17, 0x01, 0x2c, 0x56, 0x0b, 0x1b, 0x30, 0x1a, 0x19, 0x31,
+  0x19, 0x03, 0x34, 0xd7, 0x2e, 0x4b, 0x10, 0x1a, 0x30, 0x1b, 0x1a, 0x2f,
+  0x1a, 0x01, 0x2a, 0xaa, 0x27, 0x3c, 0x02, 0x1b, 0x30, 0x18, 0x1a, 0x30,
+  0x1b, 0x03, 0x3c, 0x22, 0xa6, 0x29, 0x1a, 0x31, 0x18, 0x1b, 0x31, 0x1a,
+  0x0a, 0x4e, 0x52, 0xe7, 0x27, 0x1a, 0x30, 0x19, 0x1b, 0x30, 0x1a, 0x0c,
+  0x59, 0x90, 0xfc, 0xf9, 0x02, 0xd4, 0xa3, 0xfe, 0xb9, 0xa4, 0x02, 0x8e,
+  0xfd, 0x4c, 0x45, 0xd0, 0x06, 0x07, 0x10, 0x12, 0x12, 0x1f, 0x12, 0x11,
+  0x1f, 0x13, 0x12, 0x20, 0x11, 0x06, 0x08, 0x01, 0x17, 0x7a, 0xa8, 0x05,
+  0x05, 0x0f, 0x11, 0x11, 0x20, 0x10, 0x12, 0x1f, 0x12, 0x11, 0x20, 0x12,
+  0x06, 0x07, 0x01, 0x82, 0x68, 0x56, 0x05, 0x04, 0x11, 0x21, 0x12, 0x13,
+  0x20, 0x11, 0x10, 0x20, 0x12, 0x12, 0x10, 0x07, 0x06, 0xfe, 0xbe, 0x5a,
+  0x2b, 0x11, 0x0e, 0x10, 0x13, 0x14, 0x1f, 0x11, 0x10, 0x22, 0x11, 0x11,
+  0x12, 0x0c, 0x0e, 0x01, 0x0b, 0x5e, 0x95, 0x0a, 0x0a, 0x11, 0x1f, 0x12,
+  0x12, 0x1f, 0x11, 0x12, 0x20, 0x11, 0x11, 0x10, 0x04, 0x03, 0x03, 0xfb,
+  0x02, 0x5f, 0x1c, 0x33, 0x1c, 0x1c, 0x33, 0x1c, 0x40, 0x16, 0xfe, 0x06,
+  0x02, 0xbe, 0x5d, 0x1c, 0x32, 0x1c, 0x1c, 0x32, 0x1c, 0x2d, 0x22, 0xfd,
+  0x14, 0x03, 0x34, 0x1e, 0x30, 0x1c, 0x34, 0x1a, 0x1a, 0x34, 0x1c, 0x36,
+  0x18, 0xfc, 0xca, 0x02, 0xe4, 0x2f, 0x2a, 0x1b, 0x33, 0x1c, 0x1c, 0x33,
+  0x1b, 0x55, 0x10, 0xfd, 0x4a, 0x02, 0x03, 0x22, 0x2b, 0x1c, 0x33, 0x1b,
+  0x1b, 0x33, 0x1c, 0x5e, 0xfe, 0x31, 0xfd, 0xd1, 0x02, 0x2f, 0xfe, 0xdf,
+  0xe1, 0x4b, 0x3d, 0xd3, 0x30, 0xa4, 0xa4, 0x01, 0x54, 0x2a, 0x02, 0x0e,
+  0x03, 0x04, 0x0a, 0x23, 0x13, 0x14, 0x23, 0x14, 0x14, 0x23, 0x14, 0x13,
+  0x23, 0x14, 0x01, 0xfd, 0xf8, 0x20, 0x02, 0xf9, 0x02, 0x03, 0x0a, 0x23,
+  0x26, 0x24, 0x13, 0x13, 0x24, 0x26, 0x23, 0x14, 0x01, 0xfd, 0x13, 0x1b,
+  0x02, 0xd1, 0x01, 0x14, 0x23, 0x26, 0x24, 0x13, 0x13, 0x24, 0x26, 0x23,
+  0x0a, 0x05, 0x02, 0xfd, 0x0a, 0x03, 0x42, 0x0a, 0x0a, 0x23, 0x14, 0x13,
+  0x23, 0x14, 0x14, 0x23, 0x13, 0x14, 0x23, 0x0a, 0x08, 0x02, 0xfc, 0xda,
+  0x2a, 0x01, 0xea, 0x03, 0x15, 0x22, 0x14, 0x13, 0x24, 0x13, 0x13, 0x24,
+  0x13, 0x14, 0x22, 0x0b, 0x02, 0x02, 0x00, 0x00, 0x00, 0x05, 0x01, 0x32,
+  0xff, 0xfe, 0x05, 0x41, 0x05, 0xd6, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x27,
+  0x00, 0x2d, 0x00, 0x32, 0x00, 0x00, 0x01, 0x33, 0x15, 0x33, 0x35, 0x33,
+  0x15, 0x23, 0x15, 0x07, 0x11, 0x17, 0x15, 0x33, 0x15, 0x21, 0x35, 0x33,
+  0x35, 0x37, 0x33, 0x11, 0x23, 0x27, 0x35, 0x23, 0x35, 0x33, 0x15, 0x33,
+  0x01, 0x35, 0x21, 0x15, 0x01, 0x37, 0x35, 0x21, 0x15, 0x17, 0x11, 0x07,
+  0x15, 0x21, 0x35, 0x27, 0x35, 0x11, 0x37, 0x21, 0x11, 0x02, 0xba, 0xfa,
+  0x9a, 0xf3, 0x68, 0x53, 0x53, 0x68, 0xfb, 0xf2, 0x67, 0x54, 0x01, 0x01,
+  0x54, 0x67, 0xee, 0x99, 0x02, 0x55, 0xfc, 0x56, 0x02, 0xf6, 0x4a, 0xfd,
+  0x2b, 0x49, 0x41, 0x02, 0xc5, 0x43, 0x01, 0xfd, 0xbe, 0x05, 0xd6, 0x9b,
+  0x9b, 0xa2, 0x90, 0x96, 0xfd, 0xb7, 0x95, 0x8f, 0xa3, 0xa3, 0x8f, 0x98,
+  0x02, 0x45, 0x97, 0x90, 0xa2, 0x9b, 0xfa, 0xfb, 0x37, 0x37, 0x03, 0xea,
+  0x83, 0x5f, 0x5f, 0x83, 0xfd, 0x76, 0x74, 0x80, 0x80, 0x74, 0x34, 0x02,
+  0x21, 0x02, 0xfd, 0xdd, 0x00, 0x04, 0x01, 0x8a, 0x00, 0x00, 0x04, 0xeb,
+  0x05, 0xd8, 0x00, 0x37, 0x00, 0x43, 0x00, 0x51, 0x00, 0x5e, 0x00, 0x00,
+  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x35,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x3e,
+  0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x15, 0x06, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x13, 0x21, 0x1b, 0x01, 0x35, 0x33, 0x35,
+  0x23, 0x35, 0x23, 0x15, 0x23, 0x15, 0x33, 0x15, 0x13, 0x36, 0x35, 0x34,
+  0x2e, 0x01, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x03, 0x21, 0x00, 0x14,
+  0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x02,
+  0x84, 0x1c, 0x1c, 0x08, 0x0a, 0x36, 0x21, 0x25, 0x01, 0x01, 0x25, 0x27,
+  0x46, 0x19, 0x1b, 0x17, 0x0f, 0x14, 0x28, 0x46, 0x26, 0x25, 0x46, 0x29,
+  0x13, 0x0f, 0x17, 0x19, 0x1a, 0x46, 0x27, 0x26, 0x01, 0x01, 0x26, 0x21,
+  0x34, 0x0a, 0x07, 0x1c, 0x1d, 0x02, 0x02, 0xfe, 0xfc, 0xa0, 0xf4, 0xf1,
+  0x9b, 0x9b, 0x6a, 0x9b, 0x9b, 0x92, 0x36, 0x29, 0x45, 0x4b, 0x46, 0x28,
+  0x38, 0xc7, 0x02, 0x49, 0xfe, 0x76, 0x1a, 0x30, 0x34, 0x31, 0x1a, 0x1b,
+  0x31, 0x19, 0x1a, 0x2f, 0x01, 0x94, 0x35, 0x39, 0x3c, 0x35, 0x11, 0x0e,
+  0x26, 0x3f, 0x48, 0x50, 0x04, 0x50, 0x49, 0x4b, 0x2a, 0x0e, 0x0a, 0x12,
+  0x1d, 0x27, 0x29, 0x2b, 0x4b, 0x2a, 0x2a, 0x4b, 0x2b, 0x29, 0x27, 0x1d,
+  0x13, 0x09, 0x0e, 0x2a, 0x4b, 0x49, 0x50, 0x04, 0x50, 0x48, 0x3e, 0x26,
+  0x0f, 0x11, 0x35, 0x3c, 0x3a, 0x36, 0x03, 0x04, 0xfe, 0x75, 0x01, 0x94,
+  0x01, 0x4e, 0x7c, 0x6c, 0x7c, 0x7c, 0x6c, 0x7c, 0xfe, 0xb2, 0x2d, 0x49,
+  0x2b, 0x4e, 0x29, 0x29, 0x4e, 0x2b, 0x40, 0x36, 0xfe, 0xac, 0x05, 0x19,
+  0x3a, 0x35, 0x1c, 0x1c, 0x35, 0x3a, 0x35, 0x1b, 0x1b, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x01, 0x2f, 0x00, 0x00, 0x05, 0x46, 0x05, 0xd8, 0x00, 0x29,
+  0x00, 0x35, 0x00, 0x3e, 0x00, 0x6f, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34,
+  0x26, 0x35, 0x34, 0x37, 0x16, 0x15, 0x14, 0x07, 0x00, 0x13, 0x21, 0x26,
+  0x35, 0x34, 0x00, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x07, 0x27, 0x07, 0x26,
+  0x27, 0x36, 0x35, 0x34, 0x27, 0x36, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x37,
+  0x16, 0x17, 0x03, 0x36, 0x3b, 0x01, 0x06, 0x15, 0x14, 0x2b, 0x01, 0x22,
+  0x27, 0x35, 0x03, 0x17, 0x14, 0x07, 0x23, 0x22, 0x3d, 0x01, 0x36, 0x13,
+  0x26, 0x27, 0x06, 0x15, 0x14, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16,
+  0x15, 0x14, 0x07, 0x16, 0x17, 0x37, 0x07, 0x36, 0x37, 0x36, 0x37, 0x16,
+  0x15, 0x14, 0x00, 0x15, 0x14, 0x17, 0x25, 0x02, 0x01, 0x32, 0x35, 0x23,
+  0x36, 0x35, 0x34, 0x26, 0x27, 0x06, 0x15, 0x14, 0x16, 0x15, 0x14, 0x07,
+  0x02, 0xce, 0x04, 0x14, 0x3f, 0x6e, 0x07, 0x01, 0xb9, 0x28, 0xfc, 0x97,
+  0x0c, 0x01, 0x63, 0x51, 0x32, 0x2a, 0x8e, 0x08, 0x28, 0x7d, 0x1c, 0x47,
+  0x02, 0x2b, 0x41, 0x13, 0x07, 0x1e, 0x5e, 0x30, 0x91, 0x21, 0x56, 0x06,
+  0x27, 0x3e, 0x13, 0x07, 0x04, 0x05, 0x06, 0x41, 0x09, 0x19, 0x25, 0xc2,
+  0x1f, 0x45, 0x17, 0x1a, 0x0a, 0x35, 0x27, 0x03, 0x42, 0x16, 0x5d, 0x57,
+  0x1f, 0x79, 0x1a, 0x5f, 0x49, 0x0a, 0xfe, 0xa9, 0x0a, 0x03, 0x14, 0x23,
+  0xfe, 0x43, 0x01, 0x04, 0x1c, 0x0b, 0x46, 0x1b, 0x10, 0x08, 0x04, 0xe8,
+  0x08, 0x0b, 0x15, 0x2b, 0x0e, 0x31, 0x5e, 0x68, 0x67, 0x1a, 0x1b, 0xfe,
+  0xbd, 0xfc, 0x6f, 0x38, 0x3a, 0xa0, 0x01, 0x28, 0x40, 0x06, 0x73, 0x03,
+  0x8e, 0x12, 0x16, 0x1e, 0x2e, 0x50, 0xf9, 0xc0, 0x1e, 0x1c, 0x6d, 0x7a,
+  0x20, 0x13, 0x05, 0x1b, 0x6e, 0x1b, 0x78, 0xfe, 0xeb, 0x3f, 0x2e, 0x23,
+  0x31, 0x1e, 0x0f, 0xfe, 0x70, 0x23, 0x34, 0x0f, 0x1e, 0x17, 0x31, 0x02,
+  0xa7, 0x60, 0x26, 0x3e, 0x25, 0x1b, 0x21, 0x12, 0x10, 0x0f, 0x61, 0x63,
+  0x2c, 0x2c, 0xc5, 0xc0, 0x4c, 0x18, 0x48, 0x4a, 0x0a, 0x90, 0x04, 0xad,
+  0x1e, 0x1e, 0x78, 0xfe, 0xec, 0x7d, 0x36, 0x34, 0x01, 0x03, 0x37, 0x01,
+  0x7c, 0x01, 0x0a, 0x2b, 0x0c, 0x4f, 0x4a, 0x4a, 0x29, 0x13, 0x21, 0x13,
+  0x11, 0x0f, 0x00, 0x00, 0x00, 0x04, 0x01, 0x11, 0xff, 0xff, 0x05, 0x62,
+  0x05, 0xd7, 0x00, 0x0d, 0x00, 0x1d, 0x00, 0x50, 0x00, 0x5b, 0x00, 0x00,
+  0x00, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23,
+  0x22, 0x06, 0x13, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x35, 0x34,
+  0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x01, 0x15, 0x21, 0x35, 0x07, 0x26,
+  0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36,
+  0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e,
+  0x01, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x07, 0x27, 0x26, 0x27,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x02, 0x79, 0x34, 0x5b,
+  0x31, 0x34, 0x5b, 0x32, 0x33, 0x5c, 0x32, 0x30, 0x5b, 0x56, 0x0f, 0x19,
+  0x0d, 0x0f, 0x19, 0x0e, 0x0e, 0x1a, 0x0e, 0x0c, 0x1a, 0x0f, 0x02, 0x1f,
+  0xfc, 0x43, 0x4a, 0x0a, 0x94, 0x84, 0x22, 0x24, 0x1b, 0x13, 0x26, 0x4c,
+  0x46, 0x18, 0x1a, 0x17, 0x0e, 0x14, 0x27, 0x46, 0x25, 0x24, 0x47, 0x28,
+  0x13, 0x0f, 0x17, 0x19, 0x1b, 0x43, 0x4e, 0x25, 0x14, 0x1b, 0x22, 0x22,
+  0x84, 0x96, 0x0b, 0x53, 0x03, 0x3a, 0x3e, 0xdd, 0x73, 0x74, 0xdc, 0x3d,
+  0x3a, 0x04, 0x03, 0xc1, 0x70, 0x64, 0x38, 0x38, 0x64, 0x70, 0x67, 0x36,
+  0x36, 0x01, 0x0e, 0x10, 0x1b, 0x0f, 0x0f, 0x1b, 0x10, 0x0f, 0x1c, 0x10,
+  0x10, 0x1c, 0xfa, 0xbb, 0x01, 0x01, 0x01, 0x39, 0x3a, 0xa0, 0x01, 0x25,
+  0x4e, 0x15, 0x0f, 0x1d, 0x26, 0x4b, 0x52, 0x53, 0x97, 0x2a, 0x0e, 0x0a,
+  0x13, 0x1d, 0x27, 0x54, 0x4d, 0x2a, 0x2a, 0x4d, 0x54, 0x27, 0x1d, 0x14,
+  0x09, 0x0e, 0x2a, 0x97, 0x53, 0x52, 0x4b, 0x26, 0x1d, 0x10, 0x14, 0x4e,
+  0xfe, 0xdb, 0xa0, 0x3a, 0x39, 0x84, 0x7d, 0x71, 0x79, 0x83, 0x83, 0x79,
+  0x71, 0x7d, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0x00, 0x00, 0x05, 0xc0,
+  0x05, 0xd8, 0x00, 0x0f, 0x00, 0x20, 0x00, 0x24, 0x00, 0x54, 0x00, 0x64,
+  0x00, 0x68, 0x00, 0x79, 0x00, 0x8a, 0x00, 0x00, 0x01, 0x36, 0x37, 0x26,
+  0x27, 0x26, 0x22, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x21,
+  0x33, 0x21, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x16, 0x17, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x26,
+  0x27, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x35, 0x34,
+  0x36, 0x37, 0x36, 0x37, 0x35, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33,
+  0x15, 0x23, 0x15, 0x16, 0x17, 0x1e, 0x01, 0x1d, 0x01, 0x36, 0x33, 0x32,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x01, 0x14, 0x1e,
+  0x01, 0x33, 0x32, 0x3e, 0x01, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e,
+  0x01, 0x01, 0x15, 0x21, 0x35, 0x37, 0x23, 0x26, 0x27, 0x2e, 0x01, 0x35,
+  0x34, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x06, 0x15, 0x33, 0x34,
+  0x27, 0x36, 0x37, 0x36, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07,
+  0x06, 0x07, 0x23, 0x02, 0xfb, 0x01, 0x02, 0x20, 0x2e, 0x42, 0x8c, 0x85,
+  0x4b, 0x49, 0x43, 0x14, 0x14, 0x01, 0x35, 0x7f, 0x01, 0x34, 0x16, 0x13,
+  0x43, 0x49, 0x4b, 0x84, 0x47, 0x46, 0x42, 0x2f, 0x1f, 0x02, 0x01, 0xfe,
+  0x6c, 0x02, 0xa9, 0xfd, 0x0d, 0x26, 0x22, 0x3e, 0x61, 0x63, 0xb2, 0x5e,
+  0x48, 0x44, 0x20, 0x1d, 0x0c, 0x0e, 0x61, 0x61, 0x5f, 0x61, 0x61, 0x0e,
+  0x0c, 0x1c, 0x21, 0x45, 0x47, 0x5d, 0xb2, 0x64, 0x62, 0x3d, 0x23, 0x25,
+  0xfe, 0x0d, 0x17, 0x29, 0x14, 0x16, 0x28, 0x16, 0x16, 0x28, 0x16, 0x14,
+  0x29, 0x17, 0x01, 0x7a, 0xfd, 0xb5, 0xb9, 0xfc, 0x10, 0x0f, 0x37, 0x3c,
+  0x3e, 0x6b, 0x39, 0x38, 0x37, 0x25, 0x1a, 0x02, 0xd9, 0x02, 0x1a, 0x25,
+  0x37, 0x37, 0x3b, 0x6b, 0x3d, 0x3b, 0x37, 0x11, 0x10, 0xfb, 0x03, 0xc7,
+  0x03, 0x03, 0x2b, 0x1c, 0x29, 0x51, 0x95, 0x50, 0x51, 0x92, 0x28, 0x0e,
+  0x08, 0x08, 0x0e, 0x28, 0x92, 0x51, 0x50, 0x95, 0x51, 0x29, 0x1c, 0x2b,
+  0x03, 0x03, 0xfd, 0xb8, 0xfe, 0xd1, 0x01, 0x2f, 0xfe, 0x81, 0x01, 0x7f,
+  0x0d, 0x16, 0x36, 0xc4, 0x6b, 0x6c, 0xc5, 0x6a, 0x1f, 0x02, 0x24, 0x3f,
+  0x12, 0x07, 0x04, 0x36, 0x46, 0x57, 0x57, 0x46, 0x36, 0x04, 0x07, 0x12,
+  0x3f, 0x24, 0x02, 0x1f, 0x6a, 0xc5, 0x6c, 0x6b, 0xc4, 0x36, 0x16, 0x0d,
+  0xfe, 0x81, 0x04, 0x7d, 0x19, 0x2b, 0x19, 0x19, 0x2b, 0x19, 0x18, 0x2d,
+  0x17, 0x17, 0x2d, 0xfc, 0xb6, 0xc8, 0xc8, 0xce, 0x07, 0x0c, 0x21, 0x79,
+  0x43, 0x42, 0x7b, 0x43, 0x21, 0x17, 0x24, 0x03, 0x02, 0x02, 0x03, 0x24,
+  0x17, 0x21, 0x43, 0x7b, 0x42, 0x43, 0x79, 0x21, 0x0c, 0x07, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xcb, 0x00, 0x00, 0x05, 0xa9, 0x05, 0xd8, 0x00, 0x48,
+  0x00, 0x4c, 0x00, 0x50, 0x00, 0x00, 0x01, 0x26, 0x27, 0x34, 0x3e, 0x01,
+  0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x13, 0x03, 0x22, 0x27, 0x34,
+  0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x1b, 0x01, 0x26,
+  0x27, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06, 0x07, 0x1b,
+  0x01, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15, 0x06,
+  0x07, 0x03, 0x13, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01,
+  0x15, 0x06, 0x23, 0x03, 0x11, 0x21, 0x11, 0x05, 0x35, 0x21, 0x15, 0x01,
+  0x35, 0x21, 0x15, 0x01, 0x2c, 0x56, 0x0b, 0x1b, 0x30, 0x1a, 0x19, 0x31,
+  0x19, 0x03, 0x34, 0xd7, 0x2e, 0x4b, 0x10, 0x1a, 0x30, 0x1b, 0x1a, 0x2f,
+  0x1a, 0x01, 0x2a, 0xaa, 0x27, 0x3c, 0x02, 0x1b, 0x30, 0x18, 0x1a, 0x30,
+  0x1b, 0x03, 0x3c, 0x22, 0xa6, 0x29, 0x1a, 0x31, 0x18, 0x1b, 0x31, 0x1a,
+  0x0a, 0x4e, 0x52, 0xe7, 0x27, 0x1a, 0x30, 0x19, 0x1b, 0x30, 0x1a, 0x0c,
+  0x59, 0x90, 0xfc, 0xf9, 0x02, 0xd4, 0xfd, 0x72, 0x02, 0x8e, 0xfd, 0x72,
+  0x03, 0xfb, 0x02, 0x5f, 0x1c, 0x33, 0x1c, 0x1c, 0x33, 0x1c, 0x40, 0x16,
+  0xfe, 0x06, 0x02, 0xbe, 0x5d, 0x1c, 0x32, 0x1c, 0x1c, 0x32, 0x1c, 0x2d,
+  0x22, 0xfd, 0x14, 0x03, 0x34, 0x1e, 0x30, 0x1c, 0x34, 0x1a, 0x1a, 0x34,
+  0x1c, 0x36, 0x18, 0xfc, 0xca, 0x02, 0xe4, 0x2f, 0x2a, 0x1b, 0x33, 0x1c,
+  0x1c, 0x33, 0x1b, 0x55, 0x10, 0xfd, 0x4a, 0x02, 0x03, 0x22, 0x2b, 0x1c,
+  0x33, 0x1b, 0x1b, 0x33, 0x1c, 0x5e, 0xfe, 0x31, 0xfd, 0xd1, 0x02, 0x2f,
+  0xcb, 0x4e, 0x4e, 0xfe, 0xd6, 0x4f, 0x4f, 0x00, 0x00, 0x04, 0x01, 0x32,
+  0xff, 0xfe, 0x05, 0x41, 0x05, 0xd6, 0x00, 0x03, 0x00, 0x07, 0x00, 0x25,
+  0x00, 0x29, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
+  0x13, 0x33, 0x15, 0x33, 0x35, 0x33, 0x15, 0x23, 0x15, 0x07, 0x11, 0x17,
+  0x15, 0x33, 0x15, 0x21, 0x35, 0x33, 0x35, 0x37, 0x33, 0x11, 0x23, 0x27,
+  0x35, 0x23, 0x35, 0x33, 0x15, 0x33, 0x01, 0x35, 0x21, 0x15, 0x04, 0x5a,
+  0xfd, 0xc0, 0x02, 0x83, 0xfd, 0x3b, 0xe2, 0xfa, 0x9a, 0xf3, 0x68, 0x53,
+  0x53, 0x68, 0xfb, 0xf2, 0x67, 0x54, 0x01, 0x01, 0x54, 0x67, 0xee, 0x99,
+  0x02, 0x55, 0xfc, 0x56, 0x04, 0x84, 0x5e, 0x5e, 0xfc, 0x2f, 0x6f, 0x6f,
+  0x05, 0x23, 0x9b, 0x9b, 0xa2, 0x90, 0x96, 0xfd, 0xb7, 0x95, 0x8f, 0xa3,
+  0xa3, 0x8f, 0x98, 0x02, 0x45, 0x97, 0x90, 0xa2, 0x9b, 0xfa, 0xfb, 0x37,
+  0x37, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x8a, 0x00, 0x00, 0x04, 0xeb,
+  0x05, 0xd8, 0x00, 0x34, 0x00, 0x40, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x26, 0x27, 0x26, 0x27, 0x35, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x33, 0x32, 0x1e, 0x01, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x15, 0x06,
+  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x13, 0x21, 0x13,
+  0x26, 0x01, 0x35, 0x33, 0x35, 0x23, 0x35, 0x23, 0x15, 0x23, 0x15, 0x33,
+  0x15, 0x02, 0x68, 0x1c, 0x08, 0x0a, 0x36, 0x21, 0x25, 0x01, 0x01, 0x25,
+  0x27, 0x46, 0x19, 0x1b, 0x17, 0x0f, 0x14, 0x28, 0x46, 0x26, 0x25, 0x46,
+  0x29, 0x13, 0x0f, 0x17, 0x19, 0x1a, 0x46, 0x27, 0x26, 0x01, 0x01, 0x26,
+  0x21, 0x34, 0x0a, 0x07, 0x1c, 0x1d, 0xfa, 0xfc, 0xa0, 0xf4, 0x16, 0x01,
+  0x07, 0x9b, 0x9b, 0x6a, 0x9b, 0x9b, 0x02, 0x02, 0x3c, 0x35, 0x11, 0x0e,
+  0x26, 0x3f, 0x48, 0x50, 0x04, 0x50, 0x49, 0x4b, 0x2a, 0x0e, 0x0a, 0x12,
+  0x1d, 0x27, 0x29, 0x2b, 0x4b, 0x2a, 0x2a, 0x4b, 0x2b, 0x29, 0x27, 0x1d,
+  0x13, 0x09, 0x0e, 0x2a, 0x4b, 0x49, 0x50, 0x04, 0x50, 0x48, 0x3e, 0x26,
+  0x0f, 0x11, 0x35, 0x3c, 0x3a, 0x36, 0xfe, 0x6e, 0x01, 0x94, 0x35, 0x01,
+  0x19, 0x7c, 0x6c, 0x7c, 0x7c, 0x6c, 0x7c, 0x00, 0x00, 0x04, 0x01, 0x2a,
+  0x00, 0x00, 0x05, 0x4a, 0x05, 0xd8, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x48,
+  0x00, 0x4e, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x26, 0x35, 0x34, 0x37,
+  0x1e, 0x01, 0x15, 0x14, 0x07, 0x33, 0x14, 0x23, 0x00, 0x13, 0x21, 0x26,
+  0x35, 0x34, 0x00, 0x35, 0x34, 0x27, 0x06, 0x2b, 0x01, 0x06, 0x23, 0x22,
+  0x23, 0x37, 0x07, 0x26, 0x27, 0x36, 0x35, 0x34, 0x27, 0x36, 0x37, 0x36,
+  0x35, 0x34, 0x26, 0x35, 0x34, 0x37, 0x16, 0x17, 0x07, 0x15, 0x16, 0x3b,
+  0x01, 0x32, 0x35, 0x34, 0x37, 0x23, 0x22, 0x07, 0x03, 0x15, 0x14, 0x3b,
+  0x01, 0x36, 0x35, 0x27, 0x22, 0x01, 0x17, 0x00, 0x13, 0x33, 0x02, 0x02,
+  0xc7, 0x21, 0x1b, 0x35, 0x4c, 0x0e, 0x1f, 0x03, 0x01, 0x01, 0xe2, 0x29,
+  0xfc, 0x97, 0x0c, 0x01, 0x6c, 0x01, 0x3b, 0x69, 0x09, 0x51, 0x5d, 0x03,
+  0x03, 0x2b, 0x60, 0x67, 0x18, 0x4f, 0x02, 0x2b, 0x59, 0x03, 0x28, 0x12,
+  0x5d, 0x33, 0x99, 0x03, 0x07, 0x13, 0x3f, 0x26, 0x05, 0x57, 0x21, 0x67,
+  0x19, 0x09, 0x41, 0x07, 0x38, 0x01, 0x9c, 0x2f, 0x01, 0x51, 0x06, 0x45,
+  0x29, 0x04, 0xe6, 0x17, 0x27, 0x19, 0x39, 0x16, 0x2e, 0x1e, 0x51, 0x59,
+  0x0d, 0x2f, 0x0c, 0x01, 0xfe, 0xac, 0xfc, 0x6f, 0x38, 0x3a, 0xa0, 0x01,
+  0x1b, 0x71, 0x08, 0x07, 0xa7, 0x92, 0x68, 0x50, 0x1c, 0x53, 0xe5, 0xbe,
+  0x1b, 0x1a, 0x6d, 0x68, 0x0a, 0x09, 0x1c, 0x1a, 0x23, 0x25, 0x42, 0x1b,
+  0x7a, 0xff, 0x10, 0x1e, 0x31, 0x22, 0x30, 0x40, 0xfe, 0x29, 0x18, 0x1d,
+  0x0f, 0x35, 0x22, 0x02, 0x40, 0x59, 0xfe, 0xf3, 0xfd, 0x04, 0x03, 0x52,
+  0x00, 0x01, 0x01, 0x11, 0xff, 0xff, 0x05, 0x62, 0x05, 0xd7, 0x00, 0x2e,
+  0x00, 0x00, 0x05, 0x26, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x3e,
+  0x01, 0x33, 0x32, 0x1e, 0x01, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x1e,
+  0x01, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
+  0x07, 0x01, 0x1c, 0x0a, 0x94, 0x84, 0x22, 0x24, 0x1b, 0x13, 0x26, 0x4c,
+  0x46, 0x18, 0x1a, 0x17, 0x0e, 0x14, 0x27, 0x46, 0x25, 0x24, 0x47, 0x28,
+  0x13, 0x0f, 0x17, 0x19, 0x1b, 0x43, 0x4e, 0x25, 0x14, 0x1b, 0x22, 0x22,
+  0x84, 0x96, 0x0b, 0x01, 0x39, 0x3a, 0xa0, 0x01, 0x25, 0x4e, 0x15, 0x0f,
+  0x1d, 0x26, 0x4b, 0x52, 0x53, 0x97, 0x2a, 0x0e, 0x0a, 0x13, 0x1d, 0x27,
+  0x54, 0x4d, 0x2a, 0x2a, 0x4d, 0x54, 0x27, 0x1d, 0x14, 0x09, 0x0e, 0x2a,
+  0x97, 0x53, 0x52, 0x4b, 0x26, 0x1d, 0x10, 0x14, 0x4e, 0xfe, 0xdb, 0xa0,
+  0x3a, 0x39, 0x00, 0x00, 0x00, 0x01, 0x01, 0x22, 0x00, 0x00, 0x05, 0x51,
+  0x05, 0xd4, 0x00, 0x23, 0x00, 0x00, 0x01, 0x16, 0x13, 0x12, 0x17, 0x16,
+  0x1d, 0x01, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x23, 0x15, 0x10, 0x17,
+  0x23, 0x35, 0x36, 0x11, 0x27, 0x23, 0x07, 0x06, 0x23, 0x22, 0x2f, 0x01,
+  0x35, 0x34, 0x37, 0x00, 0x3f, 0x01, 0x03, 0x3c, 0x55, 0xc2, 0xd5, 0x06,
+  0x23, 0x92, 0x30, 0x39, 0x8b, 0x55, 0x26, 0x4a, 0xc1, 0x4d, 0x03, 0x22,
+  0x2b, 0x4c, 0x72, 0xa9, 0x44, 0x08, 0xa8, 0x01, 0x1b, 0x51, 0x02, 0x05,
+  0xd4, 0xa7, 0xfe, 0xec, 0xfe, 0xea, 0x39, 0x55, 0x50, 0x28, 0xa7, 0x60,
+  0x16, 0xdd, 0x0c, 0xfe, 0xe5, 0x96, 0x06, 0x97, 0x01, 0x1d, 0x03, 0x58,
+  0x85, 0xd1, 0x49, 0x2e, 0xb7, 0xcb, 0x01, 0x82, 0xa5, 0x03, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa6, 0x00, 0x01, 0x05, 0xce, 0x05, 0xd1, 0x00, 0x18,
+  0x00, 0x32, 0x00, 0x00, 0x01, 0x32, 0x13, 0x16, 0x15, 0x32, 0x37, 0x12,
+  0x33, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x10, 0x07, 0x00, 0x07, 0x23, 0x01,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x03, 0x15, 0x14, 0x17, 0x01, 0x33, 0x01,
+  0x36, 0x3d, 0x01, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x06, 0x15, 0x23,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x01, 0xf3, 0xc4, 0x68, 0x19,
+  0x06, 0x0c, 0x64, 0xd4, 0xbc, 0x6e, 0x22, 0xc7, 0xfe, 0x6a, 0x36, 0x05,
+  0xfd, 0xdc, 0x6c, 0xb4, 0x48, 0xce, 0xbc, 0x01, 0xab, 0x03, 0x02, 0x04,
+  0x5e, 0xaa, 0x40, 0x34, 0xee, 0x4d, 0x09, 0x06, 0x40, 0x5b, 0xaa, 0x9d,
+  0x60, 0x22, 0x05, 0xd1, 0xfe, 0xed, 0x50, 0x18, 0x46, 0x01, 0x35, 0xd3,
+  0x4e, 0x50, 0x0d, 0xfe, 0xfe, 0xe7, 0xfd, 0xd9, 0x42, 0x02, 0xed, 0xb2,
+  0xb6, 0xd2, 0x7c, 0x2d, 0xfe, 0x8f, 0x10, 0xdb, 0xe4, 0xfd, 0xbc, 0x02,
+  0xbb, 0xa1, 0x97, 0x26, 0xac, 0x70, 0x1c, 0xfe, 0x41, 0x26, 0x1a, 0x4e,
+  0xd1, 0xe0, 0xb1, 0x46, 0x00, 0x02, 0x01, 0x35, 0x00, 0x00, 0x05, 0x3d,
+  0x05, 0xd4, 0x00, 0x08, 0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x15, 0x00,
+  0x07, 0x26, 0x01, 0x26, 0x35, 0x09, 0x04, 0x03, 0x3a, 0x02, 0x03, 0xfe,
+  0x19, 0x1c, 0x0d, 0xfe, 0x48, 0x3f, 0x02, 0x01, 0xfe, 0x35, 0x01, 0xce,
+  0x01, 0xce, 0xfe, 0x88, 0x05, 0xd4, 0xfd, 0x1a, 0x07, 0xfd, 0x3b, 0x22,
+  0x0b, 0x02, 0x80, 0x56, 0x0d, 0x02, 0x96, 0xfd, 0x67, 0xfd, 0x64, 0x02,
+  0x9c, 0x02, 0x1e, 0x00, 0x00, 0x01, 0x00, 0xcd, 0x00, 0x00, 0x05, 0xa7,
+  0x05, 0xd4, 0x00, 0x37, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x14,
+  0x0f, 0x01, 0x33, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x22, 0x03, 0x23, 0x15, 0x10, 0x17, 0x15, 0x23, 0x27, 0x36,
+  0x11, 0x35, 0x23, 0x02, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x3b, 0x01, 0x32, 0x17, 0x33, 0x35, 0x26, 0x27, 0x26, 0x3d, 0x01, 0x34,
+  0x37, 0x36, 0x03, 0x3b, 0xc1, 0x5b, 0x0b, 0x03, 0x6c, 0x36, 0x03, 0x42,
+  0x4c, 0x11, 0xd6, 0x57, 0x14, 0xbc, 0x24, 0x40, 0xda, 0x5a, 0x03, 0x4a,
+  0xbb, 0x06, 0x4d, 0x03, 0x5a, 0xdd, 0xab, 0x5c, 0x17, 0xde, 0x3b, 0x2e,
+  0x08, 0x4d, 0x47, 0x02, 0x4b, 0x1a, 0x36, 0xc1, 0x40, 0x05, 0xd4, 0xe3,
+  0x34, 0x38, 0x75, 0xa0, 0x3c, 0x1c, 0xca, 0x42, 0x3c, 0xcd, 0x68, 0x0c,
+  0x06, 0x01, 0x12, 0x09, 0xfe, 0xa9, 0x6d, 0x06, 0x06, 0x80, 0x01, 0x4d,
+  0x03, 0xfe, 0xeb, 0xc9, 0x44, 0x3a, 0xe9, 0x53, 0x0c, 0x1c, 0x03, 0x47,
+  0x45, 0x6e, 0x51, 0x0e, 0xc9, 0x68, 0x13, 0x00, 0x00, 0x03, 0x01, 0x21,
+  0x00, 0x01, 0x05, 0x53, 0x05, 0xd5, 0x00, 0x22, 0x00, 0x3c, 0x00, 0x42,
+  0x00, 0x00, 0x01, 0x16, 0x01, 0x16, 0x1d, 0x01, 0x14, 0x07, 0x06, 0x2b,
+  0x01, 0x22, 0x27, 0x23, 0x15, 0x10, 0x17, 0x23, 0x35, 0x36, 0x11, 0x23,
+  0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x35, 0x37, 0x35, 0x34, 0x37,
+  0x00, 0x37, 0x06, 0x01, 0x06, 0x15, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x32,
+  0x37, 0x33, 0x32, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x37, 0x36, 0x3d, 0x01,
+  0x34, 0x27, 0x02, 0x03, 0x33, 0x26, 0x27, 0x22, 0x07, 0x03, 0x3b, 0x71,
+  0x01, 0x59, 0x4e, 0xa3, 0x1f, 0x2b, 0x14, 0x82, 0x59, 0x25, 0x4a, 0xc1,
+  0x4d, 0x26, 0x32, 0x4c, 0x5f, 0x14, 0x90, 0x49, 0x16, 0x02, 0xba, 0x01,
+  0x05, 0x55, 0x6f, 0xfe, 0xd0, 0x49, 0x09, 0x85, 0x14, 0x25, 0x0e, 0x6b,
+  0x56, 0xa5, 0x07, 0x1b, 0x4b, 0x5d, 0x11, 0x7b, 0x3b, 0x09, 0xb7, 0xcf,
+  0x80, 0x39, 0x0c, 0x0d, 0x06, 0x0e, 0x05, 0xd5, 0xe1, 0xfe, 0x36, 0x8b,
+  0x86, 0x03, 0xd1, 0x4e, 0x10, 0xda, 0x0d, 0xfe, 0xe8, 0x9b, 0x06, 0x97,
+  0x01, 0x23, 0x65, 0x75, 0xae, 0x42, 0x3f, 0x0d, 0x03, 0xc8, 0xd4, 0x01,
+  0x67, 0x49, 0xc7, 0xfe, 0x6f, 0x82, 0x85, 0xbb, 0x35, 0x09, 0xda, 0x46,
+  0x94, 0xa7, 0x28, 0x1e, 0x1f, 0xb0, 0xcf, 0x01, 0x1f, 0xfb, 0x70, 0x17,
+  0x5a, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa3, 0x00, 0x00, 0x05, 0xd2,
+  0x05, 0xd4, 0x00, 0x17, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x33,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x01, 0x23,
+  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01, 0xf1, 0xb7, 0x68, 0x26, 0x02,
+  0x02, 0x20, 0x52, 0x62, 0x79, 0xbc, 0x72, 0x1d, 0xbc, 0xfe, 0x24, 0x05,
+  0xfe, 0x06, 0x97, 0xb3, 0x4b, 0x05, 0xd4, 0xeb, 0x5d, 0x31, 0xa2, 0x6b,
+  0x6c, 0xe0, 0x53, 0x49, 0xfa, 0xe3, 0xfd, 0x85, 0x02, 0xb1, 0xcd, 0xda,
+  0xd3, 0x7c, 0x2d, 0x00, 0x00, 0x01, 0x01, 0x35, 0x00, 0x00, 0x05, 0x3d,
+  0x05, 0xd4, 0x00, 0x08, 0x00, 0x00, 0x09, 0x01, 0x16, 0x15, 0x01, 0x26,
+  0x01, 0x34, 0x37, 0x03, 0x3a, 0x01, 0xc5, 0x3e, 0xfd, 0xfd, 0x0b, 0xfe,
+  0x07, 0x64, 0x05, 0xd4, 0xfd, 0x73, 0x55, 0x0d, 0xfd, 0x1b, 0x08, 0x02,
+  0xdd, 0x0e, 0x8a, 0x00, 0x00, 0x03, 0x00, 0xcd, 0x00, 0x00, 0x05, 0xa8,
+  0x05, 0xdc, 0x00, 0x32, 0x00, 0x60, 0x00, 0x67, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x16, 0x15, 0x14, 0x0f, 0x01, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x22, 0x03, 0x23, 0x15, 0x10, 0x17, 0x15,
+  0x23, 0x27, 0x36, 0x11, 0x35, 0x23, 0x02, 0x23, 0x22, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x26, 0x27, 0x35, 0x34, 0x37,
+  0x36, 0x03, 0x14, 0x1f, 0x01, 0x15, 0x26, 0x2b, 0x01, 0x22, 0x0f, 0x01,
+  0x14, 0x17, 0x16, 0x33, 0x32, 0x13, 0x36, 0x37, 0x33, 0x16, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x34, 0x2f, 0x01, 0x23, 0x22, 0x07,
+  0x35, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x13,
+  0x14, 0x07, 0x33, 0x35, 0x26, 0x35, 0x03, 0x3f, 0xb6, 0x5e, 0x17, 0x67,
+  0x14, 0x1c, 0x37, 0x25, 0xdf, 0x53, 0x0e, 0xbd, 0x1e, 0x42, 0xd9, 0x5c,
+  0x03, 0x4a, 0xbc, 0x05, 0x4c, 0x02, 0x5a, 0xde, 0xad, 0x5c, 0x17, 0xdf,
+  0x3c, 0x2e, 0x22, 0x37, 0x1c, 0x59, 0x1a, 0xc3, 0x40, 0xd8, 0x98, 0x0b,
+  0x61, 0x6a, 0x08, 0xdb, 0x37, 0x06, 0x7b, 0x36, 0x47, 0xbd, 0x66, 0x0f,
+  0x13, 0x07, 0x21, 0x4b, 0x51, 0x8e, 0x97, 0x4d, 0x0a, 0xe3, 0x31, 0x05,
+  0x6b, 0x60, 0x74, 0x1d, 0x17, 0xa8, 0x30, 0x25, 0xa6, 0x4b, 0xed, 0x19,
+  0x36, 0x19, 0x05, 0xdc, 0xce, 0x46, 0x39, 0x84, 0xa6, 0x17, 0x06, 0xd7,
+  0x38, 0x3a, 0xd3, 0x64, 0x0c, 0x07, 0x01, 0x14, 0x09, 0xfe, 0xa7, 0x6d,
+  0x06, 0x06, 0x80, 0x01, 0x4f, 0x04, 0xfe, 0xe8, 0xcb, 0x45, 0x3a, 0xeb,
+  0x52, 0x0c, 0x06, 0x70, 0xb1, 0x26, 0xcb, 0x69, 0x13, 0xfe, 0xb3, 0x9b,
+  0xcc, 0x0c, 0x03, 0x09, 0xd4, 0x43, 0x94, 0x5d, 0x26, 0x01, 0x27, 0x1b,
+  0x41, 0x78, 0x86, 0x85, 0xbe, 0x2e, 0x2b, 0x06, 0xde, 0x30, 0x03, 0x09,
+  0x03, 0x89, 0x6e, 0x4d, 0x2c, 0xb6, 0x57, 0x10, 0xc8, 0xfb, 0xce, 0x1c,
+  0x60, 0x03, 0x63, 0x16, 0x00, 0x04, 0x00, 0xc2, 0xff, 0xfe, 0x05, 0xb2,
+  0x05, 0xd4, 0x00, 0x10, 0x00, 0x21, 0x00, 0x31, 0x00, 0x4d, 0x00, 0x00,
+  0x01, 0x33, 0x14, 0x06, 0x07, 0x14, 0x16, 0x17, 0x23, 0x26, 0x27, 0x26,
+  0x27, 0x30, 0x35, 0x34, 0x36, 0x25, 0x33, 0x14, 0x06, 0x07, 0x14, 0x16,
+  0x13, 0x23, 0x26, 0x27, 0x26, 0x27, 0x34, 0x35, 0x34, 0x36, 0x05, 0x33,
+  0x14, 0x06, 0x07, 0x14, 0x16, 0x17, 0x23, 0x26, 0x27, 0x26, 0x27, 0x35,
+  0x34, 0x36, 0x13, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x04, 0x20, 0x24, 0x26,
+  0x35, 0x34, 0x36, 0x37, 0x33, 0x06, 0x07, 0x06, 0x14, 0x16, 0x04, 0x20,
+  0x24, 0x36, 0x34, 0x27, 0x26, 0x27, 0x02, 0x37, 0x0c, 0x83, 0x02, 0xb8,
+  0x06, 0x0b, 0x1b, 0x92, 0x2b, 0x0e, 0x95, 0x01, 0x20, 0x0c, 0x83, 0x02,
+  0xb9, 0x05, 0x0c, 0x1a, 0x92, 0x2c, 0x0d, 0x95, 0x01, 0x37, 0x0b, 0x83,
+  0x02, 0xb9, 0x05, 0x0c, 0x19, 0x93, 0x2c, 0x0d, 0x95, 0x28, 0x97, 0xab,
+  0xa6, 0xfe, 0xd2, 0xfe, 0xb8, 0xfe, 0xd3, 0xa7, 0xaa, 0x98, 0x02, 0x76,
+  0x43, 0x4d, 0x96, 0x01, 0x10, 0x01, 0x29, 0x01, 0x10, 0x96, 0x4e, 0x44,
+  0x76, 0x05, 0x39, 0x3f, 0x9b, 0x63, 0x82, 0x79, 0xc9, 0xa6, 0x74, 0x33,
+  0x5a, 0x0e, 0x72, 0x88, 0xed, 0x60, 0xed, 0x97, 0xc5, 0xbb, 0xfe, 0xce,
+  0xfb, 0xb2, 0x4e, 0x8b, 0x08, 0x09, 0xb1, 0xd1, 0x5b, 0x4f, 0xc4, 0x7d,
+  0xa1, 0x9a, 0xfd, 0xd0, 0x91, 0x42, 0x72, 0x0e, 0x91, 0xad, 0xfe, 0x1e,
+  0x31, 0xb1, 0x61, 0x60, 0xb0, 0x62, 0x62, 0xb0, 0x60, 0x61, 0xb1, 0x31,
+  0x29, 0x45, 0x4d, 0xa8, 0x98, 0x55, 0x55, 0x98, 0xa8, 0x4d, 0x45, 0x29,
+  0x00, 0x01, 0x00, 0x9a, 0xff, 0xf6, 0x02, 0x72, 0x05, 0xd5, 0x00, 0x11,
+  0x00, 0x00, 0x01, 0x33, 0x17, 0x11, 0x14, 0x0f, 0x01, 0x23, 0x22, 0x2f,
+  0x01, 0x34, 0x3f, 0x01, 0x32, 0x17, 0x33, 0x11, 0x02, 0x2a, 0x41, 0x07,
+  0xb1, 0x2b, 0x20, 0xbe, 0x1a, 0x03, 0xbe, 0x1d, 0x5a, 0x50, 0x04, 0x05,
+  0xd5, 0x08, 0xfa, 0xfd, 0xa3, 0x2d, 0x04, 0x85, 0x1f, 0x82, 0x18, 0x05,
+  0x40, 0x04, 0xd4, 0x00, 0x00, 0x01, 0x00, 0x9a, 0xff, 0xf6, 0x03, 0xfe,
+  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x33, 0x17, 0x15, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x23, 0x27, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
+  0x11, 0x14, 0x07, 0x23, 0x22, 0x35, 0x34, 0x37, 0x33, 0x32, 0x17, 0x11,
+  0x02, 0x1c, 0x4e, 0x08, 0x18, 0x9c, 0xd8, 0x6e, 0x04, 0x1b, 0x37, 0xcd,
+  0x53, 0x16, 0xca, 0x33, 0xda, 0xbf, 0x14, 0x57, 0x50, 0x05, 0xd5, 0x07,
+  0x27, 0x36, 0x3f, 0x46, 0x8a, 0x92, 0x60, 0x20, 0x31, 0x54, 0x46, 0x47,
+  0x2a, 0x1a, 0xfb, 0xd6, 0x99, 0x2d, 0xa8, 0x83, 0x17, 0x40, 0x04, 0xd6,
+  0x00, 0x01, 0x01, 0x52, 0xff, 0x2f, 0x05, 0x22, 0x05, 0xd5, 0x00, 0x1e,
+  0x00, 0x00, 0x01, 0x05, 0x17, 0x11, 0x14, 0x07, 0x23, 0x22, 0x3d, 0x01,
+  0x34, 0x3f, 0x01, 0x32, 0x17, 0x11, 0x25, 0x11, 0x14, 0x0f, 0x01, 0x23,
+  0x22, 0x3d, 0x01, 0x34, 0x3f, 0x01, 0x32, 0x17, 0x11, 0x02, 0xb0, 0x02,
+  0x6e, 0x03, 0xad, 0x30, 0xc0, 0x9f, 0x23, 0x4e, 0x49, 0xfe, 0x13, 0x88,
+  0x3c, 0x17, 0xc3, 0x99, 0x27, 0x50, 0x48, 0x05, 0xd5, 0xca, 0x04, 0xfa,
+  0xed, 0x9b, 0x2a, 0xa4, 0x04, 0x7e, 0x16, 0x03, 0x3a, 0x04, 0x0b, 0xa9,
+  0xfb, 0xdb, 0x89, 0x38, 0x08, 0x9b, 0x07, 0x7a, 0x22, 0x04, 0x43, 0x04,
+  0xd3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa9, 0xff, 0xf6, 0x05, 0xcb,
+  0x05, 0xd5, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x17, 0x11, 0x14,
+  0x07, 0x22, 0x27, 0x34, 0x37, 0x32, 0x17, 0x33, 0x11, 0x21, 0x11, 0x06,
+  0x07, 0x23, 0x22, 0x35, 0x34, 0x37, 0x32, 0x17, 0x11, 0x17, 0x15, 0x21,
+  0x35, 0x05, 0xc7, 0x03, 0xeb, 0xd1, 0x10, 0xd1, 0x62, 0x47, 0x03, 0xfc,
+  0xfb, 0x07, 0xda, 0x04, 0xe8, 0xd5, 0x5a, 0x4f, 0x4f, 0x03, 0x05, 0x05,
+  0xd5, 0x04, 0xfb, 0x12, 0xd5, 0x15, 0xa4, 0x8a, 0x0e, 0x3b, 0x02, 0x95,
+  0xfd, 0x5a, 0xcf, 0x24, 0xb1, 0x7d, 0x10, 0x40, 0x04, 0xe1, 0xcf, 0x9c,
+  0x9c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa2, 0xff, 0xfa, 0x02, 0xd2,
+  0x05, 0xd9, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00, 0x13, 0x33, 0x17, 0x11,
+  0x33, 0x36, 0x33, 0x16, 0x13, 0x02, 0x05, 0x27, 0x11, 0x13, 0x11, 0x24,
+  0x11, 0x34, 0x35, 0x34, 0x27, 0x22, 0xa8, 0x29, 0x04, 0x03, 0x99, 0x83,
+  0xcc, 0x12, 0x1a, 0xfd, 0xee, 0x03, 0x32, 0x01, 0x79, 0x86, 0x6b, 0x05,
+  0xd9, 0x06, 0xfc, 0x3f, 0xed, 0x03, 0xfe, 0xff, 0xfe, 0x57, 0x58, 0x03,
+  0x05, 0xd6, 0xfb, 0xd4, 0xfe, 0x9d, 0x63, 0x01, 0x31, 0x0d, 0x0c, 0x94,
+  0x08, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9a, 0x00, 0x00, 0x01, 0xf8,
+  0x05, 0xd9, 0x00, 0x0d, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33, 0x17, 0x11,
+  0x25, 0x17, 0x11, 0x07, 0x23, 0x27, 0x11, 0x05, 0x23, 0x11, 0x13, 0x11,
+  0x33, 0x25, 0x11, 0x23, 0x9f, 0x25, 0x06, 0x01, 0x2c, 0x02, 0x04, 0x24,
+  0x04, 0xfe, 0xd1, 0x02, 0x2f, 0x01, 0x01, 0x01, 0x02, 0x05, 0xd9, 0x05,
+  0xfe, 0x2f, 0xa1, 0x02, 0xfb, 0x63, 0x05, 0x05, 0x01, 0xe5, 0xa0, 0x04,
+  0x8a, 0xfd, 0x99, 0xfe, 0x7d, 0x90, 0x01, 0x7f, 0x00, 0x02, 0x00, 0x9b,
+  0x00, 0x00, 0x02, 0xe2, 0x05, 0xd9, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00,
+  0x01, 0x33, 0x17, 0x11, 0x37, 0x17, 0x15, 0x06, 0x07, 0x11, 0x37, 0x15,
+  0x06, 0x07, 0x11, 0x07, 0x23, 0x27, 0x11, 0x05, 0x11, 0x07, 0x23, 0x27,
+  0x11, 0x07, 0x35, 0x34, 0x37, 0x11, 0x23, 0x07, 0x35, 0x37, 0x11, 0x37,
+  0x33, 0x17, 0x11, 0x25, 0x11, 0x01, 0x11, 0x25, 0x11, 0x02, 0x46, 0x2a,
+  0x04, 0x6b, 0x03, 0x03, 0x6b, 0x6e, 0x01, 0x6d, 0x04, 0x2a, 0x04, 0xfe,
+  0xfd, 0x05, 0x26, 0x04, 0x74, 0x74, 0x02, 0x72, 0x74, 0x04, 0x26, 0x05,
+  0x01, 0x03, 0xfe, 0xfd, 0x01, 0x03, 0x05, 0xd9, 0x05, 0xfe, 0xd0, 0x3c,
+  0x02, 0x8d, 0x07, 0x3c, 0xfe, 0x8b, 0x37, 0x87, 0x04, 0x43, 0xfe, 0xd7,
+  0x04, 0x04, 0x01, 0x11, 0x8c, 0xfe, 0xa6, 0x04, 0x04, 0x01, 0x41, 0x3c,
+  0x8e, 0x06, 0x3c, 0x01, 0x7b, 0x38, 0x8b, 0x41, 0x01, 0x1f, 0x04, 0x04,
+  0xfe, 0xfa, 0x86, 0x01, 0x4d, 0xfd, 0x96, 0xfe, 0x87, 0x8b, 0x01, 0x74,
+  0x00, 0x01, 0x00, 0x9a, 0x00, 0x00, 0x04, 0xc8, 0x05, 0xd9, 0x00, 0x48,
+  0x00, 0x00, 0x01, 0x23, 0x30, 0x23, 0x22, 0x07, 0x23, 0x22, 0x27, 0x35,
+  0x36, 0x35, 0x34, 0x27, 0x35, 0x36, 0x37, 0x33, 0x16, 0x3b, 0x01, 0x35,
+  0x34, 0x27, 0x35, 0x36, 0x37, 0x33, 0x16, 0x32, 0x37, 0x33, 0x16, 0x17,
+  0x15, 0x06, 0x1d, 0x01, 0x33, 0x32, 0x37, 0x33, 0x16, 0x17, 0x15, 0x06,
+  0x15, 0x14, 0x17, 0x15, 0x06, 0x2b, 0x01, 0x26, 0x2b, 0x02, 0x11, 0x14,
+  0x17, 0x15, 0x06, 0x07, 0x23, 0x26, 0x22, 0x07, 0x23, 0x26, 0x27, 0x35,
+  0x36, 0x35, 0x02, 0x71, 0x98, 0x03, 0xa1, 0x48, 0x33, 0x15, 0x0a, 0x59,
+  0x59, 0x02, 0x1c, 0x34, 0x4a, 0xa3, 0x97, 0x76, 0x02, 0x1b, 0x34, 0x28,
+  0x7e, 0x29, 0x34, 0x1a, 0x03, 0x76, 0x92, 0xa3, 0x4b, 0x32, 0x1e, 0x02,
+  0x59, 0x59, 0x0a, 0x16, 0x32, 0x48, 0xa1, 0x04, 0x93, 0x76, 0x03, 0x1a,
+  0x34, 0x29, 0x7e, 0x28, 0x34, 0x1b, 0x02, 0x76, 0x03, 0x11, 0x5a, 0x23,
+  0x3b, 0x31, 0x37, 0x46, 0x2d, 0x3a, 0x1d, 0x03, 0x83, 0xaf, 0xb5, 0x53,
+  0x38, 0x21, 0x02, 0x63, 0x63, 0x02, 0x21, 0x38, 0x53, 0xb5, 0xaf, 0x83,
+  0x03, 0x1d, 0x3a, 0x2d, 0x46, 0x37, 0x31, 0x3b, 0x23, 0x5a, 0xfe, 0x52,
+  0xb5, 0x53, 0x39, 0x20, 0x02, 0x63, 0x63, 0x02, 0x20, 0x39, 0x53, 0xb5,
+  0x00, 0x06, 0x00, 0x76, 0x00, 0x00, 0x05, 0x0d, 0x05, 0xd9, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x3b, 0x00, 0x47, 0x00, 0x00,
+  0x01, 0x06, 0x07, 0x16, 0x17, 0x37, 0x35, 0x05, 0x15, 0x17, 0x36, 0x37,
+  0x26, 0x27, 0x01, 0x26, 0x27, 0x06, 0x07, 0x17, 0x33, 0x03, 0x23, 0x07,
+  0x16, 0x17, 0x36, 0x37, 0x03, 0x33, 0x37, 0x16, 0x17, 0x06, 0x07, 0x27,
+  0x23, 0x11, 0x17, 0x06, 0x07, 0x26, 0x27, 0x37, 0x11, 0x23, 0x07, 0x26,
+  0x27, 0x36, 0x37, 0x17, 0x33, 0x35, 0x27, 0x36, 0x37, 0x16, 0x17, 0x0f,
+  0x01, 0x15, 0x23, 0x15, 0x33, 0x11, 0x33, 0x11, 0x33, 0x35, 0x23, 0x35,
+  0x01, 0x1c, 0x14, 0x2c, 0x2b, 0x15, 0x55, 0x02, 0xa2, 0x55, 0x14, 0x2b,
+  0x2b, 0x14, 0xfe, 0xac, 0x28, 0x2a, 0x28, 0x28, 0x3d, 0x28, 0x01, 0x28,
+  0x3c, 0x28, 0x28, 0x29, 0x29, 0x07, 0xcd, 0xbc, 0x09, 0x6d, 0x6d, 0x09,
+  0xbc, 0xcd, 0x72, 0x60, 0x5e, 0x5e, 0x5d, 0x71, 0xcd, 0xbc, 0x09, 0x6e,
+  0x6e, 0x09, 0xbc, 0xcd, 0x71, 0x5d, 0x5f, 0x5d, 0x60, 0x72, 0x63, 0x68,
+  0x68, 0x31, 0x68, 0x68, 0x03, 0xb4, 0x2d, 0x2e, 0x2c, 0x2d, 0x43, 0x2e,
+  0x01, 0x2e, 0x43, 0x2e, 0x2c, 0x2e, 0x2d, 0x01, 0x6e, 0x17, 0x2f, 0x2f,
+  0x17, 0x5f, 0xfc, 0x52, 0x5f, 0x17, 0x2f, 0x2f, 0x17, 0x02, 0xf7, 0x7e,
+  0x69, 0x6a, 0x68, 0x68, 0x7e, 0xfe, 0x4e, 0xd0, 0x0b, 0x79, 0x79, 0x0b,
+  0xd0, 0x01, 0xb2, 0x7e, 0x68, 0x69, 0x69, 0x69, 0x7e, 0xd6, 0xd1, 0x0b,
+  0x7a, 0x7a, 0x0b, 0xd1, 0x73, 0x9f, 0x2e, 0xfe, 0x80, 0x01, 0x80, 0x2e,
+  0x9f, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x9a, 0x00, 0x00, 0x05, 0xdb,
+  0x05, 0xac, 0x00, 0x14, 0x00, 0x23, 0x00, 0x2e, 0x00, 0x36, 0x00, 0x43,
+  0x00, 0x4d, 0x00, 0x68, 0x00, 0x77, 0x00, 0x8c, 0x00, 0x97, 0x00, 0xa6,
+  0x00, 0xaf, 0x00, 0x00, 0x01, 0x21, 0x32, 0x1f, 0x01, 0x37, 0x33, 0x32,
+  0x15, 0x03, 0x21, 0x27, 0x35, 0x36, 0x37, 0x35, 0x02, 0x27, 0x26, 0x3d,
+  0x01, 0x07, 0x33, 0x32, 0x17, 0x16, 0x15, 0x02, 0x07, 0x23, 0x24, 0x27,
+  0x35, 0x12, 0x37, 0x36, 0x17, 0x15, 0x13, 0x07, 0x15, 0x33, 0x37, 0x07,
+  0x26, 0x2f, 0x01, 0x01, 0x17, 0x13, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x01,
+  0x16, 0x13, 0x17, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x26, 0x03, 0x35,
+  0x17, 0x13, 0x33, 0x32, 0x3f, 0x01, 0x34, 0x2f, 0x01, 0x06, 0x25, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x07, 0x23, 0x27, 0x02, 0x0f, 0x01, 0x17, 0x07,
+  0x23, 0x26, 0x03, 0x26, 0x3d, 0x01, 0x34, 0x3f, 0x01, 0x23, 0x27, 0x35,
+  0x37, 0x17, 0x15, 0x17, 0x33, 0x15, 0x14, 0x07, 0x15, 0x16, 0x17, 0x13,
+  0x33, 0x17, 0x35, 0x27, 0x01, 0x33, 0x17, 0x15, 0x21, 0x32, 0x37, 0x33,
+  0x17, 0x15, 0x06, 0x03, 0x06, 0x2b, 0x01, 0x15, 0x07, 0x23, 0x02, 0x3d,
+  0x01, 0x27, 0x17, 0x11, 0x07, 0x21, 0x22, 0x2f, 0x01, 0x35, 0x34, 0x37,
+  0x05, 0x07, 0x17, 0x33, 0x35, 0x34, 0x3b, 0x01, 0x32, 0x3f, 0x01, 0x21,
+  0x26, 0x3d, 0x01, 0x05, 0x06, 0x07, 0x15, 0x14, 0x1f, 0x01, 0x33, 0x11,
+  0x02, 0xd7, 0x01, 0x64, 0x34, 0x1a, 0x45, 0x58, 0x08, 0x04, 0x9c, 0xfe,
+  0xc7, 0x04, 0x10, 0x4a, 0xa9, 0x0e, 0x29, 0x66, 0x15, 0x64, 0x32, 0x1b,
+  0x9e, 0x0f, 0x02, 0xfe, 0xf1, 0x04, 0x8e, 0x0f, 0x28, 0xf7, 0xb5, 0x13,
+  0xb5, 0x56, 0x19, 0x66, 0x0e, 0x12, 0xfd, 0x67, 0xd8, 0x90, 0x37, 0x46,
+  0x19, 0x4b, 0x28, 0x03, 0x3f, 0x10, 0x86, 0x04, 0x48, 0x14, 0x21, 0x83,
+  0x0b, 0xa2, 0x31, 0x8c, 0x78, 0x30, 0x21, 0x02, 0x2b, 0x56, 0xcd, 0xfd,
+  0x5e, 0x12, 0x08, 0x69, 0x2e, 0x04, 0x05, 0x5a, 0xa2, 0x0d, 0x03, 0x04,
+  0x06, 0x03, 0x14, 0x9b, 0x12, 0x4c, 0x12, 0x01, 0x5a, 0x04, 0x73, 0x10,
+  0x03, 0x68, 0x01, 0x8c, 0xb4, 0x02, 0x19, 0x56, 0x02, 0x3e, 0x04, 0x05,
+  0x01, 0x4e, 0x25, 0x21, 0x02, 0x04, 0x05, 0xb1, 0x16, 0x1f, 0xaf, 0x05,
+  0x07, 0x9b, 0x4a, 0x08, 0x05, 0xfe, 0xf4, 0x68, 0x2c, 0x05, 0x4f, 0x02,
+  0x1c, 0x55, 0x55, 0x05, 0x07, 0xd0, 0x14, 0x2a, 0x5e, 0xfe, 0x94, 0x07,
+  0xfd, 0xf2, 0x37, 0x05, 0x51, 0x1b, 0xf3, 0x05, 0xac, 0x47, 0x86, 0x38,
+  0x07, 0xfe, 0xd4, 0x05, 0x05, 0x11, 0x2a, 0x05, 0x01, 0x46, 0x14, 0x16,
+  0x04, 0x05, 0x0d, 0x80, 0x31, 0x0a, 0xfe, 0xc6, 0x11, 0xac, 0x08, 0x02,
+  0x01, 0x1a, 0x08, 0x2e, 0x17, 0x02, 0xfe, 0x9d, 0x0f, 0x03, 0xad, 0x0d,
+  0xc5, 0x0d, 0x05, 0xfe, 0xd1, 0x8a, 0x01, 0x17, 0x90, 0x66, 0xfe, 0xf5,
+  0x11, 0xfe, 0xef, 0x29, 0x14, 0x4d, 0x43, 0x12, 0x0b, 0x01, 0x3d, 0x05,
+  0x0f, 0xfe, 0xea, 0x67, 0x1a, 0x39, 0x45, 0xa2, 0x81, 0x6b, 0xd7, 0x4f,
+  0x0d, 0x05, 0x39, 0xfe, 0xcb, 0x21, 0x15, 0x28, 0x05, 0x1b, 0x01, 0x2d,
+  0x1a, 0x1f, 0x07, 0x1c, 0x83, 0x29, 0x3b, 0x05, 0x05, 0x26, 0x05, 0x0d,
+  0x02, 0x08, 0xc6, 0x0a, 0x1a, 0xfe, 0x01, 0x5d, 0x08, 0x03, 0xac, 0xfe,
+  0xd4, 0x05, 0x74, 0x21, 0x05, 0x02, 0x15, 0xfe, 0xb1, 0x1d, 0x79, 0x05,
+  0x01, 0x22, 0x0d, 0x03, 0xb3, 0x07, 0xfe, 0xa5, 0x05, 0x86, 0x26, 0x0d,
+  0x32, 0x7c, 0x0c, 0xac, 0xaa, 0x08, 0x1c, 0x62, 0xb3, 0x01, 0x14, 0x08,
+  0x1d, 0x61, 0x24, 0x0a, 0x55, 0x2b, 0x06, 0x01, 0x15, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x0a,
+  0x00, 0x23, 0x00, 0x38, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x33, 0x11, 0x07,
+  0x35, 0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x05, 0x26, 0x35, 0x34, 0x3f,
+  0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23,
+  0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03,
+  0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27,
+  0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36,
+  0x37, 0x36, 0x02, 0x8c, 0x9a, 0xa7, 0xb6, 0x72, 0x9a, 0xfe, 0x4b, 0xfe,
+  0x28, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f,
+  0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd,
+  0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a,
+  0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59,
+  0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a,
+  0x01, 0xea, 0x01, 0x9a, 0x1a, 0x61, 0x1e, 0xfe, 0x01, 0x5c, 0xb8, 0x4d,
+  0x4f, 0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13,
+  0x23, 0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97,
+  0x95, 0x46, 0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe,
+  0x5d, 0x42, 0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff,
+  0x6b, 0x23, 0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4,
+  0x41, 0x21, 0x1b, 0x00, 0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
+  0x05, 0xd9, 0x00, 0x1c, 0x00, 0x35, 0x00, 0x4a, 0x00, 0x5f, 0x00, 0x00,
+  0x01, 0x21, 0x15, 0x21, 0x35, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x07, 0x0e, 0x01, 0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x27,
+  0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23, 0x15, 0x27,
+  0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03, 0x37, 0x13,
+  0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27, 0x37, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36, 0x37, 0x36,
+  0x03, 0x07, 0x01, 0x32, 0xfe, 0x26, 0x39, 0xb9, 0x16, 0x2c, 0x21, 0x43,
+  0x36, 0x2a, 0x5d, 0x50, 0x44, 0x65, 0x2b, 0x73, 0x8a, 0x22, 0x2b, 0x0d,
+  0x7d, 0xfd, 0x56, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07,
+  0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29,
+  0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d,
+  0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3,
+  0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23,
+  0x32, 0x2a, 0x01, 0xd2, 0x5d, 0x55, 0x31, 0x9e, 0x15, 0x29, 0x38, 0x1a,
+  0x28, 0x33, 0x18, 0x26, 0x6e, 0x19, 0x14, 0x63, 0x51, 0x26, 0x44, 0x2d,
+  0x0d, 0x6d, 0xfe, 0xba, 0x4d, 0x4f, 0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe,
+  0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b,
+  0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b, 0x37, 0x11, 0x13, 0x34,
+  0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41, 0x36, 0x04, 0x9e, 0x01,
+  0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac, 0x28, 0x01, 0x09, 0x6b,
+  0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b, 0x00, 0x04, 0x00, 0x8c,
+  0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x28, 0x00, 0x41, 0x00, 0x56,
+  0x00, 0x6b, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x26, 0x35,
+  0x34, 0x3f, 0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06,
+  0x07, 0x23, 0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x03, 0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37,
+  0x03, 0x27, 0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27,
+  0x13, 0x36, 0x37, 0x36, 0x03, 0xeb, 0x09, 0x56, 0x9c, 0x8d, 0x2e, 0x61,
+  0x3f, 0x41, 0x5b, 0x2f, 0x55, 0x53, 0x4e, 0x47, 0x64, 0x68, 0x41, 0x40,
+  0x43, 0x42, 0x25, 0x56, 0x4e, 0x44, 0x62, 0x2c, 0x74, 0x8b, 0x4b, 0xfc,
+  0xc6, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f,
+  0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd,
+  0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a,
+  0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59,
+  0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a,
+  0x02, 0xbe, 0x02, 0x53, 0x3c, 0x5c, 0x65, 0x0e, 0x12, 0x6c, 0x1e, 0x12,
+  0x32, 0x33, 0x2d, 0x32, 0x5b, 0x27, 0x26, 0x27, 0x29, 0x0e, 0x14, 0x62,
+  0x0f, 0x0d, 0x59, 0x4b, 0x34, 0x4a, 0xfe, 0x18, 0x4d, 0x4f, 0x48, 0x4b,
+  0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c,
+  0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b,
+  0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41,
+  0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac,
+  0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b,
+  0x00, 0x05, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x02,
+  0x00, 0x0d, 0x00, 0x26, 0x00, 0x3b, 0x00, 0x50, 0x00, 0x00, 0x01, 0x03,
+  0x33, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x21, 0x35,
+  0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27,
+  0x26, 0x25, 0x06, 0x07, 0x23, 0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x03, 0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16,
+  0x1f, 0x01, 0x37, 0x03, 0x27, 0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x07, 0x03, 0x27, 0x13, 0x36, 0x37, 0x36, 0x03, 0x57, 0xcf, 0xcf, 0x12,
+  0x9f, 0x6d, 0x6d, 0x8d, 0xfe, 0xa8, 0xfe, 0xb5, 0x28, 0x23, 0x4b, 0x38,
+  0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d,
+  0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd,
+  0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99,
+  0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39,
+  0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a, 0x03, 0x52, 0xfe, 0xff, 0x01,
+  0x8a, 0xfe, 0x76, 0x5f, 0x8e, 0x8e, 0x60, 0xfe, 0x84, 0x4d, 0x4f, 0x48,
+  0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20,
+  0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46,
+  0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42,
+  0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23,
+  0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21,
+  0x1b, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
+  0x05, 0xd9, 0x00, 0x1d, 0x00, 0x36, 0x00, 0x4b, 0x00, 0x60, 0x00, 0x00,
+  0x01, 0x21, 0x15, 0x21, 0x15, 0x06, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x01, 0x26, 0x35, 0x34, 0x3f, 0x01,
+  0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23, 0x15,
+  0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03, 0x37,
+  0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27, 0x37,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36, 0x37,
+  0x36, 0x02, 0x75, 0x01, 0x96, 0xfe, 0xe5, 0x02, 0x2c, 0x15, 0x7d, 0x92,
+  0x96, 0x87, 0x2d, 0x5e, 0x3f, 0x45, 0x54, 0x2f, 0x4a, 0x54, 0x54, 0x4a,
+  0x23, 0x48, 0x3f, 0xfe, 0x3f, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37,
+  0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44,
+  0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16,
+  0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38,
+  0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a,
+  0xd9, 0x23, 0x32, 0x2a, 0x03, 0xd0, 0x5f, 0x70, 0x01, 0x07, 0x74, 0x63,
+  0x64, 0x72, 0x0e, 0x0f, 0x72, 0x1f, 0x12, 0x40, 0x38, 0x39, 0x40, 0x0d,
+  0x19, 0xfe, 0x53, 0x4d, 0x4f, 0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff,
+  0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61,
+  0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b, 0x37, 0x11, 0x13, 0x34, 0x48,
+  0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41, 0x36, 0x04, 0x9e, 0x01, 0x92,
+  0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe,
+  0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b, 0x00, 0x00, 0x05, 0x00, 0x8c,
+  0x00, 0x20, 0x05, 0xe8, 0x05, 0xd9, 0x00, 0x09, 0x00, 0x22, 0x00, 0x3b,
+  0x00, 0x50, 0x00, 0x65, 0x00, 0x00, 0x01, 0x22, 0x06, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07,
+  0x06, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x33, 0x32, 0x16, 0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x27,
+  0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23, 0x15, 0x27,
+  0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03, 0x37, 0x13,
+  0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27, 0x37, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36, 0x37, 0x36,
+  0x03, 0x2c, 0x32, 0x3d, 0x3d, 0x32, 0x34, 0x3b, 0x3b, 0x8a, 0x37, 0x3f,
+  0x1f, 0x4e, 0x53, 0x03, 0x06, 0x54, 0x32, 0x69, 0x7a, 0x7f, 0x69, 0x78,
+  0x7e, 0x98, 0x84, 0x22, 0x45, 0xfc, 0xfb, 0x28, 0x23, 0x4b, 0x38, 0xd4,
+  0x16, 0x37, 0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe,
+  0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3,
+  0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56,
+  0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f,
+  0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a, 0x02, 0xbc, 0x41, 0x76, 0x40, 0x40,
+  0x76, 0x41, 0x01, 0x0e, 0x66, 0x16, 0x0e, 0x60, 0x35, 0x07, 0x28, 0x73,
+  0x61, 0x5f, 0x74, 0xa5, 0x96, 0x8f, 0xae, 0x0c, 0xfc, 0xfd, 0x4d, 0x4f,
+  0x48, 0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23,
+  0x20, 0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95,
+  0x46, 0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d,
+  0x42, 0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b,
+  0x23, 0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41,
+  0x21, 0x1b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
+  0x05, 0xd9, 0x00, 0x06, 0x00, 0x1f, 0x00, 0x34, 0x00, 0x49, 0x00, 0x00,
+  0x01, 0x21, 0x15, 0x03, 0x23, 0x13, 0x21, 0x01, 0x26, 0x35, 0x34, 0x3f,
+  0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25, 0x06, 0x07, 0x23,
+  0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x03,
+  0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01, 0x37, 0x03, 0x27,
+  0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03, 0x27, 0x13, 0x36,
+  0x37, 0x36, 0x02, 0x5f, 0x01, 0xce, 0xf5, 0x84, 0xe5, 0xfe, 0xc6, 0xfe,
+  0x55, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16, 0x37, 0x59, 0x07, 0x15, 0x1f,
+  0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d, 0x44, 0x33, 0x29, 0x04, 0xfd,
+  0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34, 0x16, 0x07, 0x2d, 0xb5, 0x7a,
+  0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c, 0x38, 0x16, 0xd3, 0x36, 0x59,
+  0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8, 0x7a, 0xd9, 0x23, 0x32, 0x2a,
+  0x03, 0xba, 0x32, 0xfd, 0xb9, 0x02, 0x1a, 0xfd, 0x7b, 0x4d, 0x4f, 0x48,
+  0x4b, 0x92, 0x24, 0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20,
+  0x2c, 0x01, 0x9f, 0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46,
+  0x0b, 0x37, 0x11, 0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42,
+  0x41, 0x36, 0x04, 0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23,
+  0xac, 0x28, 0x01, 0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21,
+  0x1b, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x8c, 0x00, 0x20, 0x05, 0xe8,
+  0x05, 0xd9, 0x00, 0x18, 0x00, 0x2d, 0x00, 0x42, 0x00, 0x00, 0x37, 0x26,
+  0x35, 0x34, 0x3f, 0x01, 0x27, 0x37, 0x13, 0x27, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x21, 0x15, 0x21, 0x22, 0x27, 0x26, 0x25,
+  0x06, 0x07, 0x23, 0x15, 0x27, 0x37, 0x15, 0x33, 0x36, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x03, 0x37, 0x13, 0x16, 0x15, 0x14, 0x01, 0x16, 0x1f, 0x01,
+  0x37, 0x03, 0x27, 0x37, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x03,
+  0x27, 0x13, 0x36, 0x37, 0x36, 0xb4, 0x28, 0x23, 0x4b, 0x38, 0xd4, 0x16,
+  0x37, 0x59, 0x07, 0x15, 0x1f, 0x54, 0x0e, 0x0e, 0x01, 0x6d, 0xfe, 0x4d,
+  0x44, 0x33, 0x29, 0x04, 0xfd, 0x4d, 0x9d, 0x97, 0xbd, 0xbd, 0xb3, 0x34,
+  0x16, 0x07, 0x2d, 0xb5, 0x7a, 0xdb, 0x21, 0xfd, 0x35, 0x99, 0x56, 0x4c,
+  0x38, 0x16, 0xd3, 0x36, 0x59, 0x1f, 0x2e, 0x07, 0x06, 0x39, 0x2f, 0xb8,
+  0x7a, 0xd9, 0x23, 0x32, 0x2a, 0xd6, 0x4d, 0x4f, 0x48, 0x4b, 0x92, 0x24,
+  0x6b, 0xfe, 0xff, 0x24, 0xac, 0x14, 0x13, 0x23, 0x20, 0x2c, 0x01, 0x9f,
+  0x21, 0x1b, 0x61, 0x93, 0x0a, 0x49, 0x97, 0x95, 0x46, 0x0b, 0x37, 0x11,
+  0x13, 0x34, 0x48, 0x01, 0x60, 0x4f, 0xfe, 0x5d, 0x42, 0x41, 0x36, 0x04,
+  0x9e, 0x01, 0x92, 0x91, 0x24, 0xfe, 0xff, 0x6b, 0x23, 0xac, 0x28, 0x01,
+  0x09, 0x6b, 0xfe, 0xa1, 0x4e, 0x01, 0xa4, 0x41, 0x21, 0x1b, 0x00, 0x00,
+  0x00, 0x06, 0x00, 0x9a, 0x00, 0x00, 0x05, 0xd9, 0x05, 0xa1, 0x00, 0x10,
+  0x00, 0x1a, 0x00, 0x27, 0x00, 0x39, 0x00, 0x48, 0x00, 0x52, 0x00, 0x00,
+  0x01, 0x21, 0x32, 0x1f, 0x01, 0x37, 0x33, 0x15, 0x02, 0x07, 0x21, 0x35,
+  0x36, 0x37, 0x03, 0x26, 0x23, 0x07, 0x32, 0x1f, 0x01, 0x03, 0x26, 0x27,
+  0x12, 0x37, 0x36, 0x01, 0x12, 0x15, 0x17, 0x14, 0x07, 0x06, 0x2b, 0x01,
+  0x26, 0x03, 0x36, 0x37, 0x05, 0x12, 0x17, 0x27, 0x02, 0x0f, 0x01, 0x17,
+  0x23, 0x03, 0x27, 0x36, 0x37, 0x36, 0x35, 0x27, 0x35, 0x33, 0x01, 0x33,
+  0x15, 0x21, 0x32, 0x37, 0x33, 0x14, 0x03, 0x06, 0x2b, 0x01, 0x15, 0x23,
+  0x03, 0x27, 0x17, 0x11, 0x07, 0x21, 0x22, 0x2f, 0x01, 0x34, 0x37, 0x02,
+  0xd9, 0x01, 0x5f, 0x34, 0x1e, 0x42, 0x5a, 0x05, 0x8d, 0x0f, 0xfe, 0xcc,
+  0x57, 0x04, 0xb2, 0x1f, 0x0c, 0x5c, 0x5f, 0x26, 0x2c, 0xae, 0xf0, 0x19,
+  0x86, 0x14, 0x2c, 0x03, 0x05, 0x95, 0x02, 0x58, 0x0d, 0x24, 0x71, 0x0c,
+  0x9e, 0x16, 0xb5, 0xfc, 0xd3, 0x9a, 0x02, 0x65, 0xad, 0x03, 0x03, 0x04,
+  0x04, 0xb5, 0x07, 0x03, 0x48, 0x18, 0x5a, 0xcd, 0x02, 0x8f, 0x02, 0x01,
+  0x63, 0x1d, 0x1b, 0x03, 0xb5, 0x15, 0x1c, 0xb8, 0x04, 0x98, 0x54, 0x04,
+  0x04, 0xfe, 0xfb, 0x69, 0x2a, 0x04, 0x4b, 0x05, 0xa1, 0x54, 0x7d, 0x37,
+  0x02, 0xfe, 0xed, 0x15, 0x05, 0x35, 0x09, 0x01, 0x62, 0x1a, 0x05, 0x5c,
+  0x56, 0xfe, 0xb6, 0x9a, 0x13, 0x01, 0x04, 0x1c, 0x2f, 0xfe, 0x56, 0xfe,
+  0xea, 0x17, 0x27, 0x66, 0x3a, 0x08, 0x0f, 0x01, 0x3a, 0x17, 0x70, 0x1b,
+  0xfe, 0xe0, 0x0d, 0x3f, 0xfe, 0xb6, 0x10, 0x29, 0x1d, 0x01, 0x5c, 0x20,
+  0x1f, 0x80, 0x29, 0x0b, 0x39, 0x03, 0xfe, 0xa5, 0x73, 0x1a, 0x09, 0xfe,
+  0xa4, 0x17, 0x73, 0x01, 0x25, 0xb0, 0x06, 0xfe, 0xa9, 0x05, 0x80, 0x30,
+  0x30, 0x82, 0x00, 0x00, 0x00, 0x07, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd,
+  0x05, 0xd9, 0x00, 0x13, 0x00, 0x25, 0x00, 0x32, 0x00, 0x3c, 0x00, 0x4a,
+  0x00, 0x5c, 0x00, 0x65, 0x00, 0x00, 0x01, 0x33, 0x20, 0x13, 0x16, 0x1d,
+  0x01, 0x10, 0x05, 0x06, 0x2b, 0x01, 0x20, 0x03, 0x26, 0x3d, 0x01, 0x10,
+  0x25, 0x36, 0x17, 0x15, 0x32, 0x1f, 0x01, 0x15, 0x06, 0x07, 0x15, 0x33,
+  0x36, 0x37, 0x23, 0x07, 0x26, 0x27, 0x26, 0x23, 0x01, 0x16, 0x33, 0x36,
+  0x13, 0x26, 0x23, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x05, 0x15, 0x13,
+  0x33, 0x32, 0x37, 0x34, 0x2f, 0x01, 0x22, 0x05, 0x17, 0x06, 0x07, 0x14,
+  0x1f, 0x01, 0x33, 0x34, 0x3f, 0x01, 0x33, 0x17, 0x27, 0x01, 0x07, 0x16,
+  0x17, 0x33, 0x35, 0x37, 0x33, 0x32, 0x3f, 0x01, 0x35, 0x23, 0x06, 0x23,
+  0x21, 0x27, 0x35, 0x05, 0x06, 0x1d, 0x01, 0x14, 0x1f, 0x01, 0x33, 0x11,
+  0x03, 0x2e, 0x19, 0x01, 0x63, 0xdb, 0x57, 0xfe, 0x97, 0x92, 0xa5, 0x03,
+  0xfe, 0x7b, 0xd0, 0x4b, 0x01, 0x1c, 0xab, 0x7c, 0x22, 0x2e, 0x6d, 0x19,
+  0x34, 0xfc, 0x09, 0x77, 0x03, 0x4a, 0x47, 0x11, 0x13, 0x17, 0xfd, 0xc7,
+  0xda, 0x08, 0x04, 0x86, 0x3c, 0x14, 0x1a, 0x2d, 0x56, 0x30, 0x46, 0x0b,
+  0x02, 0x40, 0x8a, 0x6a, 0x58, 0x18, 0x5b, 0x25, 0x0c, 0xfc, 0x38, 0x48,
+  0x44, 0x09, 0x7d, 0x1a, 0x02, 0x19, 0x80, 0x08, 0x44, 0x7d, 0x01, 0xc6,
+  0x79, 0x05, 0x74, 0x03, 0x06, 0x9a, 0x21, 0x37, 0x5f, 0x03, 0x13, 0x1f,
+  0xfe, 0xe4, 0x06, 0xfe, 0x20, 0x3b, 0x60, 0x17, 0xe3, 0x05, 0xd9, 0xfe,
+  0x92, 0xae, 0xcf, 0x06, 0xfe, 0x4f, 0xeb, 0x4c, 0x01, 0x86, 0xa8, 0xa3,
+  0x35, 0x01, 0x5f, 0xf1, 0x83, 0x93, 0x03, 0x6b, 0xce, 0x03, 0x16, 0x1f,
+  0x03, 0x08, 0xf0, 0x2c, 0x89, 0x16, 0x0c, 0xfe, 0xdf, 0x8b, 0x0f, 0x01,
+  0x01, 0x7e, 0x12, 0x79, 0x7d, 0x1f, 0xde, 0x03, 0xfe, 0xf4, 0x8a, 0x2f,
+  0x9d, 0x4d, 0x3c, 0x34, 0x7b, 0x31, 0x16, 0xe8, 0x3b, 0x43, 0x19, 0xf8,
+  0x2c, 0xf1, 0xfe, 0xe5, 0xfb, 0x03, 0xec, 0x5b, 0x06, 0x80, 0xb1, 0x03,
+  0x10, 0x06, 0x5f, 0x65, 0x69, 0x27, 0x0c, 0x5b, 0x29, 0x04, 0x01, 0x24,
+  0x00, 0x08, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdd, 0x05, 0xd9, 0x00, 0x0f,
+  0x00, 0x20, 0x00, 0x2f, 0x00, 0x3a, 0x00, 0x42, 0x00, 0x52, 0x00, 0x60,
+  0x00, 0x6a, 0x00, 0x00, 0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x05, 0x06,
+  0x23, 0x20, 0x03, 0x26, 0x35, 0x10, 0x25, 0x36, 0x01, 0x10, 0x05, 0x16,
+  0x3b, 0x01, 0x20, 0x13, 0x36, 0x35, 0x10, 0x25, 0x26, 0x23, 0x20, 0x03,
+  0x06, 0x01, 0x21, 0x32, 0x1f, 0x01, 0x37, 0x15, 0x06, 0x07, 0x23, 0x35,
+  0x37, 0x26, 0x2f, 0x01, 0x23, 0x32, 0x1f, 0x01, 0x03, 0x23, 0x26, 0x27,
+  0x36, 0x37, 0x36, 0x01, 0x16, 0x1d, 0x01, 0x06, 0x2b, 0x01, 0x03, 0x25,
+  0x33, 0x17, 0x07, 0x23, 0x27, 0x23, 0x02, 0x07, 0x15, 0x26, 0x03, 0x27,
+  0x34, 0x37, 0x27, 0x01, 0x33, 0x15, 0x21, 0x32, 0x37, 0x15, 0x03, 0x07,
+  0x23, 0x07, 0x15, 0x23, 0x27, 0x25, 0x21, 0x17, 0x11, 0x07, 0x23, 0x22,
+  0x2f, 0x01, 0x36, 0x03, 0x3c, 0x01, 0x6e, 0xd6, 0x5c, 0xfe, 0xaa, 0x93,
+  0xbc, 0xfe, 0x87, 0xd0, 0x55, 0x01, 0x61, 0x99, 0xfe, 0x2d, 0x01, 0x3e,
+  0x8e, 0x99, 0x2b, 0x01, 0x44, 0xce, 0x53, 0xfe, 0xba, 0x90, 0xa6, 0xfe,
+  0xa2, 0xc9, 0x52, 0x02, 0x1e, 0x01, 0x1b, 0x30, 0x15, 0x34, 0x49, 0x62,
+  0x18, 0xf5, 0x46, 0x84, 0x17, 0x19, 0x45, 0x52, 0x1b, 0x28, 0x8a, 0x03,
+  0xcc, 0x10, 0x6b, 0x19, 0x28, 0x02, 0x5f, 0x7b, 0x13, 0x61, 0x5a, 0x8c,
+  0xfd, 0x29, 0xf8, 0x83, 0x03, 0x03, 0x46, 0x03, 0x95, 0x05, 0x0b, 0x8d,
+  0x02, 0x4e, 0x46, 0x02, 0xb0, 0x06, 0x01, 0x26, 0x12, 0x16, 0x9c, 0x15,
+  0x98, 0x05, 0x06, 0x79, 0xfe, 0xaf, 0x01, 0x0d, 0x06, 0x06, 0xdc, 0x49,
+  0x23, 0x06, 0x01, 0x05, 0xd9, 0xfe, 0x97, 0xb2, 0xd4, 0xfe, 0x58, 0xe9,
+  0x59, 0x01, 0x74, 0xa2, 0xdb, 0x01, 0xa9, 0xeb, 0x54, 0xfd, 0x12, 0xfe,
+  0x70, 0xd8, 0x58, 0x01, 0x59, 0xa5, 0xc5, 0x01, 0x8c, 0xe0, 0x53, 0xfe,
+  0xa6, 0x9f, 0x01, 0x6d, 0x45, 0x62, 0x2c, 0x03, 0xcc, 0x23, 0x03, 0x34,
+  0xfe, 0x27, 0x0c, 0x46, 0x56, 0xfe, 0xfe, 0x7f, 0x10, 0xd5, 0x1a, 0x20,
+  0xfe, 0xa7, 0xe2, 0x21, 0x17, 0x82, 0x01, 0x09, 0x59, 0xf4, 0x03, 0x31,
+  0xfe, 0xea, 0x15, 0x1a, 0x0b, 0x01, 0x12, 0x11, 0x1c, 0x8d, 0x31, 0xfe,
+  0xec, 0x5f, 0x14, 0x06, 0xfe, 0xdc, 0x09, 0x06, 0x55, 0xee, 0x8c, 0x05,
+  0xfe, 0xeb, 0x05, 0x67, 0x2c, 0x31, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdd, 0x05, 0xd9, 0x00, 0x07, 0x00, 0x17, 0x00, 0x1f,
+  0x00, 0x41, 0x00, 0x52, 0x00, 0x00, 0x01, 0x16, 0x17, 0x32, 0x37, 0x26,
+  0x27, 0x06, 0x01, 0x20, 0x13, 0x16, 0x15, 0x10, 0x05, 0x06, 0x23, 0x20,
+  0x03, 0x26, 0x35, 0x10, 0x25, 0x36, 0x01, 0x06, 0x07, 0x16, 0x33, 0x36,
+  0x37, 0x26, 0x01, 0x15, 0x23, 0x06, 0x2b, 0x01, 0x2e, 0x01, 0x35, 0x34,
+  0x35, 0x34, 0x35, 0x34, 0x36, 0x37, 0x32, 0x17, 0x36, 0x33, 0x1e, 0x01,
+  0x15, 0x14, 0x15, 0x14, 0x15, 0x14, 0x06, 0x07, 0x23, 0x22, 0x27, 0x23,
+  0x25, 0x10, 0x05, 0x16, 0x3b, 0x01, 0x20, 0x13, 0x36, 0x35, 0x10, 0x25,
+  0x26, 0x23, 0x20, 0x03, 0x06, 0x01, 0x95, 0x02, 0xa5, 0x81, 0x57, 0x4e,
+  0x92, 0x9d, 0x01, 0xa5, 0x01, 0x6e, 0xd6, 0x5c, 0xfe, 0xaa, 0x93, 0xbc,
+  0xfe, 0x87, 0xd0, 0x55, 0x01, 0x61, 0x99, 0x01, 0xb1, 0x92, 0x4e, 0x57,
+  0x81, 0xa5, 0x02, 0x02, 0xfe, 0x5a, 0x03, 0x6a, 0xa0, 0x0d, 0x7e, 0x6d,
+  0x8c, 0x7a, 0x8d, 0x72, 0x73, 0x8e, 0x7a, 0x8c, 0x6d, 0x7e, 0x0d, 0xa0,
+  0x6b, 0x02, 0xfd, 0x83, 0x01, 0x3e, 0x8e, 0x99, 0x2b, 0x01, 0x44, 0xce,
+  0x53, 0xfe, 0xba, 0x90, 0xa6, 0xfe, 0xa2, 0xc9, 0x52, 0x02, 0xf4, 0xcd,
+  0x02, 0xcb, 0xc2, 0x04, 0x03, 0x02, 0x26, 0xfe, 0x97, 0xb2, 0xd4, 0xfe,
+  0x58, 0xe9, 0x59, 0x01, 0x74, 0xa2, 0xdb, 0x01, 0xa9, 0xeb, 0x54, 0xfd,
+  0xdd, 0x04, 0xc2, 0xcb, 0x02, 0xcd, 0xbf, 0xfe, 0xf3, 0x1c, 0xbd, 0x0f,
+  0xb9, 0x50, 0x07, 0x08, 0x04, 0x05, 0x74, 0x99, 0x01, 0xaa, 0xaa, 0x01,
+  0x99, 0x74, 0x05, 0x04, 0x08, 0x07, 0x50, 0xb9, 0x0f, 0xbd, 0x61, 0xfe,
+  0x70, 0xd8, 0x58, 0x01, 0x59, 0xa5, 0xc5, 0x01, 0x8c, 0xe0, 0x53, 0xfe,
+  0xa6, 0x9f, 0x00, 0x00, 0x00, 0x02, 0x01, 0x12, 0x00, 0x02, 0x05, 0x61,
+  0x05, 0xd9, 0x00, 0x18, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x32, 0x15, 0x06,
+  0x07, 0x17, 0x33, 0x32, 0x17, 0x07, 0x23, 0x17, 0x21, 0x16, 0x13, 0x37,
+  0x17, 0x06, 0x07, 0x26, 0x03, 0x21, 0x22, 0x03, 0x34, 0x01, 0x06, 0x23,
+  0x22, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x14,
+  0x1e, 0x01, 0x32, 0x36, 0x37, 0x17, 0x06, 0x02, 0x57, 0x8a, 0x01, 0x73,
+  0x16, 0xf7, 0x0b, 0x0e, 0x03, 0xf8, 0x0b, 0x01, 0x91, 0x0a, 0x7f, 0x79,
+  0x2b, 0x05, 0xf6, 0x0e, 0x87, 0xfe, 0x53, 0x0b, 0x4c, 0x01, 0xc5, 0x65,
+  0x6f, 0x70, 0xcb, 0x71, 0x3a, 0x1e, 0x2a, 0x24, 0x16, 0x02, 0x4a, 0x89,
+  0x96, 0x88, 0x25, 0x3e, 0x29, 0x05, 0xd9, 0x8e, 0xa3, 0x02, 0xe6, 0x92,
+  0x04, 0x65, 0x06, 0xfe, 0x72, 0x28, 0x8d, 0x08, 0x59, 0x18, 0x01, 0xad,
+  0x03, 0x24, 0x85, 0xfa, 0x68, 0x3f, 0x7d, 0xe1, 0x7d, 0x7c, 0x72, 0x3c,
+  0x2e, 0xd9, 0x3c, 0x43, 0x53, 0x98, 0x53, 0x53, 0x4c, 0xa9, 0x32, 0x00,
+  0x00, 0x03, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd, 0x05, 0xcd, 0x00, 0x16,
+  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11,
+  0x21, 0x02, 0xa4, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13,
+  0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xe3,
+  0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x02, 0xe9, 0x2a, 0x1c,
+  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15,
+  0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0x42, 0x05, 0xcd, 0xfa, 0x33, 0xa5,
+  0x04, 0x83, 0x00, 0x00, 0x00, 0x04, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd,
+  0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
+  0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x01, 0x8d, 0x11, 0x12, 0x1c, 0x19,
+  0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
+  0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
+  0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
+  0xfc, 0xcc, 0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x01, 0xae,
+  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c,
+  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x02, 0x9c, 0x2a, 0x1c, 0x1e,
+  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
+  0x13, 0x14, 0x1f, 0x1b, 0xfc, 0x0c, 0x05, 0xcd, 0xfa, 0x33, 0xa5, 0x04,
+  0x83, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd,
+  0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c,
+  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x01, 0x8d, 0x11, 0x12, 0x1c,
+  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
+  0x19, 0x1b, 0x13, 0x11, 0x01, 0x17, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
+  0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13,
+  0x11, 0x01, 0x17, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13,
+  0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfc, 0xcc,
+  0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x01, 0xae, 0x2a, 0x1c,
+  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15,
+  0x13, 0x13, 0x14, 0x1f, 0x1b, 0x01, 0x66, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
+  0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14,
+  0x1f, 0x1b, 0x01, 0x61, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f,
+  0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfc,
+  0x0c, 0x05, 0xcd, 0xfa, 0x33, 0xa5, 0x04, 0x83, 0x00, 0x06, 0x00, 0x87,
+  0x00, 0x00, 0x05, 0xbd, 0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x44,
+  0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
+  0x01, 0x8d, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11,
+  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11,
+  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c,
+  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xd2, 0x11, 0x12, 0x1c, 0x19,
+  0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
+  0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
+  0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
+  0xfc, 0xcc, 0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x04, 0x1f,
+  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c,
+  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0xba, 0x2a, 0x1c, 0x1e,
+  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
+  0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14,
+  0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b,
+  0x02, 0x9c, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b,
+  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfc, 0x0c, 0x05,
+  0xcd, 0xfa, 0x33, 0xa5, 0x04, 0x83, 0x00, 0x00, 0x00, 0x07, 0x00, 0x87,
+  0x00, 0x00, 0x05, 0xbd, 0x05, 0xcd, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x44,
+  0x00, 0x5b, 0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11,
+  0x21, 0x01, 0x8d, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
+  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e,
+  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12,
+  0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xd2, 0x11, 0x12, 0x1c,
+  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
+  0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26,
+  0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13,
+  0x11, 0xfe, 0xe9, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13,
+  0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xe3,
+  0x05, 0x36, 0xfb, 0x5f, 0x04, 0x0c, 0xfb, 0xf4, 0x04, 0x1f, 0x2a, 0x1c,
+  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15,
+  0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0xba, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
+  0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14,
+  0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b,
+  0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x02, 0x9c,
+  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c,
+  0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfe, 0xf5, 0x2a, 0x1c, 0x1e,
+  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13,
+  0x13, 0x14, 0x1f, 0x1b, 0xfd, 0x42, 0x05, 0xcd, 0xfa, 0x33, 0xa5, 0x04,
+  0x83, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x87, 0x00, 0x00, 0x05, 0xbd,
+  0x05, 0xcd, 0x00, 0x17, 0x00, 0x2f, 0x00, 0x46, 0x00, 0x5d, 0x00, 0x74,
+  0x00, 0x8b, 0x00, 0x8f, 0x00, 0x93, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
+  0x03, 0xba, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11,
+  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0xfd, 0xd3,
+  0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12,
+  0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19,
+  0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
+  0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11, 0x12, 0x1c, 0x18, 0x27, 0x26, 0x19,
+  0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11,
+  0xfd, 0xd2, 0x11, 0x12, 0x1c, 0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0x11,
+  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x02, 0x2e, 0x11,
+  0x12, 0x1c, 0x18, 0x27, 0x26, 0x19, 0x1b, 0x13, 0x11, 0x11, 0x12, 0x1c,
+  0x19, 0x4c, 0x19, 0x1b, 0x13, 0x11, 0xfc, 0xcc, 0x05, 0x36, 0xfb, 0x5f,
+  0x04, 0x0c, 0xfb, 0xf4, 0x02, 0xe9, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13,
+  0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f,
+  0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b,
+  0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x01, 0x93, 0x2a,
+  0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e,
+  0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfd, 0x56, 0x2a, 0x1c, 0x1e, 0x15,
+  0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13,
+  0x14, 0x1f, 0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f,
+  0x1b, 0x2b, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x03,
+  0x00, 0x2a, 0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0x2b, 0x2a,
+  0x1c, 0x1e, 0x15, 0x13, 0x13, 0x14, 0x1f, 0x1b, 0xfb, 0xda, 0x05, 0xcd,
+  0xfa, 0x33, 0xa5, 0x04, 0x83, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x99,
+  0x00, 0x01, 0x05, 0xdc, 0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1b, 0x00, 0x29,
+  0x00, 0x00, 0x01, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x02,
+  0x10, 0x12, 0x24, 0x01, 0x14, 0x12, 0x04, 0x20, 0x24, 0x12, 0x35, 0x34,
+  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x04, 0x34, 0x3e, 0x01, 0x33, 0x32,
+  0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x03, 0x3a, 0xa9, 0x01,
+  0x42, 0xb6, 0xb1, 0xfe, 0xbf, 0xfe, 0xa3, 0xfe, 0xbe, 0xb1, 0xb5, 0x01,
+  0x41, 0xfe, 0x57, 0x9d, 0x01, 0x1c, 0x01, 0x36, 0x01, 0x1c, 0x9d, 0xa1,
+  0xfe, 0xe3, 0x96, 0x97, 0xfe, 0xe3, 0xa0, 0x03, 0x38, 0x1e, 0x36, 0x1e,
+  0x1d, 0x36, 0x1f, 0x20, 0x36, 0x1c, 0x1e, 0x35, 0x05, 0xd9, 0xc1, 0xfe,
+  0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63, 0x01, 0x86, 0x01,
+  0x68, 0xc1, 0xfd, 0x14, 0xad, 0xfe, 0xc5, 0xae, 0xae, 0x01, 0x3b, 0xad,
+  0xac, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1, 0xcd, 0x42, 0x3c, 0x21, 0x21,
+  0x3c, 0x42, 0x3d, 0x20, 0x20, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99,
+  0x00, 0x01, 0x05, 0xdc, 0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1b, 0x00, 0x29,
+  0x00, 0x36, 0x00, 0x00, 0x01, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20,
+  0x24, 0x02, 0x10, 0x12, 0x24, 0x01, 0x14, 0x12, 0x04, 0x20, 0x24, 0x12,
+  0x35, 0x34, 0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x04, 0x34, 0x3e, 0x01,
+  0x33, 0x32, 0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x24, 0x32,
+  0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01, 0x34, 0x36, 0x03,
+  0x3a, 0xa9, 0x01, 0x42, 0xb6, 0xb1, 0xfe, 0xbf, 0xfe, 0xa3, 0xfe, 0xbe,
+  0xb1, 0xb5, 0x01, 0x41, 0xfe, 0x57, 0x9d, 0x01, 0x1c, 0x01, 0x36, 0x01,
+  0x1c, 0x9d, 0xa1, 0xfe, 0xe3, 0x96, 0x97, 0xfe, 0xe3, 0xa0, 0x03, 0x38,
+  0x1e, 0x36, 0x1e, 0x1d, 0x36, 0x1f, 0x20, 0x36, 0x1c, 0x1e, 0x35, 0xfd,
+  0x85, 0x3a, 0x36, 0x1f, 0x1f, 0x36, 0x1d, 0x1d, 0x36, 0x1f, 0x20, 0x05,
+  0xd9, 0xc1, 0xfe, 0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63,
+  0x01, 0x86, 0x01, 0x68, 0xc1, 0xfd, 0x14, 0xad, 0xfe, 0xc5, 0xae, 0xae,
+  0x01, 0x3b, 0xad, 0xac, 0x01, 0x3f, 0xab, 0xab, 0xfe, 0xc1, 0xcd, 0x42,
+  0x3c, 0x21, 0x21, 0x3c, 0x42, 0x3d, 0x20, 0x20, 0xdc, 0x20, 0x3d, 0x42,
+  0x3c, 0x21, 0x21, 0x3c, 0x42, 0x3d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x99,
+  0x00, 0x01, 0x05, 0xdc, 0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1a, 0x00, 0x00,
+  0x01, 0x32, 0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x02, 0x10, 0x12,
+  0x24, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01,
+  0x14, 0x1e, 0x01, 0x03, 0x3a, 0xa9, 0x01, 0x42, 0xb6, 0xb1, 0xfe, 0xbf,
+  0xfe, 0xa3, 0xfe, 0xbe, 0xb1, 0xb5, 0x01, 0x41, 0x02, 0x01, 0x1c, 0x36,
+  0x20, 0x1f, 0x36, 0x1d, 0x1e, 0x36, 0x1e, 0x1f, 0x35, 0x05, 0xd9, 0xc1,
+  0xfe, 0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63, 0x01, 0x86,
+  0x01, 0x68, 0xc1, 0xfc, 0x96, 0x20, 0x3d, 0x42, 0x3c, 0x21, 0x21, 0x3c,
+  0x42, 0x3d, 0x20, 0x00, 0x00, 0x03, 0x00, 0x99, 0x00, 0x01, 0x05, 0xdc,
+  0x05, 0xd9, 0x00, 0x0c, 0x00, 0x1a, 0x00, 0x27, 0x00, 0x00, 0x01, 0x32,
+  0x04, 0x12, 0x10, 0x02, 0x04, 0x20, 0x24, 0x02, 0x10, 0x12, 0x24, 0x01,
+  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x14, 0x1e,
+  0x01, 0x24, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01,
+  0x22, 0x06, 0x03, 0x3a, 0xa9, 0x01, 0x42, 0xb6, 0xb1, 0xfe, 0xbf, 0xfe,
+  0xa3, 0xfe, 0xbe, 0xb1, 0xb5, 0x01, 0x41, 0x02, 0x01, 0x1c, 0x36, 0x20,
+  0x1f, 0x36, 0x1d, 0x1e, 0x36, 0x1e, 0x1f, 0x35, 0xfc, 0xfb, 0x1f, 0x36,
+  0x1d, 0x1d, 0x36, 0x1f, 0x1f, 0x36, 0x3a, 0x35, 0x05, 0xd9, 0xc1, 0xfe,
+  0x98, 0xfe, 0x7a, 0xfe, 0x9d, 0xc6, 0xc6, 0x01, 0x63, 0x01, 0x86, 0x01,
+  0x68, 0xc1, 0xfc, 0x96, 0x20, 0x3d, 0x42, 0x3c, 0x21, 0x21, 0x3c, 0x42,
+  0x3d, 0x20, 0x9f, 0x42, 0x3c, 0x21, 0x21, 0x3c, 0x42, 0x3d, 0x20, 0x20,
+  0x00, 0x01, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x00, 0xc8, 0x00, 0x03,
+  0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x99, 0x05, 0x42, 0xfa, 0xbe, 0xc8,
+  0xc8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x00, 0xc8, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21,
+  0x25, 0x21, 0x15, 0x21, 0x99, 0x02, 0x23, 0xfd, 0xdd, 0x03, 0x1f, 0x02,
+  0x23, 0xfd, 0xdd, 0xc8, 0xc8, 0xc8, 0xc8, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4d, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
+  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x85, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4d, 0x12, 0x26, 0x0b, 0xb3, 0x00, 0x00,
+  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x85, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4e, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x03, 0x4e, 0x12, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x00, 0x02, 0x01, 0x35,
+  0x00, 0x06, 0x05, 0x3d, 0x05, 0xd9, 0x00, 0x11, 0x00, 0x2a, 0x00, 0x00,
+  0x01, 0x36, 0x33, 0x32, 0x04, 0x33, 0x32, 0x37, 0x11, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x2f, 0x01, 0x23, 0x35, 0x33, 0x15, 0x23,
+  0x15, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x11, 0x06, 0x23,
+  0x22, 0x24, 0x23, 0x22, 0x07, 0x11, 0x23, 0x01, 0xd3, 0x2f, 0x36, 0x73,
+  0x01, 0x2d, 0xa8, 0x3f, 0x41, 0x2f, 0x30, 0x96, 0x9f, 0x7d, 0xac, 0x2d,
+  0x31, 0x12, 0x59, 0x44, 0xf3, 0x45, 0x30, 0x2e, 0xae, 0x9a, 0x98, 0x91,
+  0x47, 0x43, 0x5f, 0x5c, 0x9a, 0xfe, 0xe3, 0x74, 0x48, 0x3f, 0x56, 0x02,
+  0x9f, 0x11, 0xa3, 0x0c, 0x02, 0x62, 0x0a, 0x5f, 0x7e, 0x09, 0x02, 0x5d,
+  0x35, 0x35, 0x1a, 0x08, 0x78, 0x5c, 0x15, 0xfd, 0x0d, 0x1c, 0x9a, 0x1e,
+  0xfd, 0xc6, 0x00, 0x00, 0x00, 0x01, 0x01, 0x35, 0x00, 0x06, 0x05, 0x3d,
+  0x05, 0xd9, 0x00, 0x18, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33, 0x15, 0x23,
+  0x15, 0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x32, 0x37, 0x11, 0x06, 0x23,
+  0x22, 0x24, 0x23, 0x22, 0x07, 0x11, 0x23, 0x01, 0x7a, 0x44, 0xf3, 0x45,
+  0x30, 0x2e, 0xae, 0x9a, 0x98, 0x91, 0x47, 0x43, 0x5f, 0x5c, 0x9a, 0xfe,
+  0xe3, 0x74, 0x48, 0x3f, 0x56, 0x05, 0xa4, 0x35, 0x35, 0x1a, 0x08, 0x78,
+  0x5c, 0x15, 0xfd, 0x0d, 0x1c, 0x9a, 0x1e, 0xfd, 0xc6, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5f, 0x00, 0x01, 0x06, 0x15, 0x05, 0xda, 0x00, 0x1f,
+  0x00, 0x00, 0x09, 0x01, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x17,
+  0x07, 0x09, 0x01, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x16, 0x13, 0x09,
+  0x01, 0x17, 0x01, 0x07, 0x03, 0x27, 0x07, 0x03, 0x27, 0x01, 0x02, 0xe4,
+  0xfe, 0xd4, 0xa6, 0xb3, 0xa8, 0x2a, 0x7d, 0x26, 0xa7, 0xb1, 0xa6, 0x01,
+  0x2c, 0x01, 0x2c, 0xa6, 0xb2, 0xa6, 0x28, 0x7a, 0x28, 0x3f, 0x1f, 0xfe,
+  0xf1, 0xfe, 0xd5, 0xa0, 0x01, 0x1f, 0xa7, 0xf3, 0xa1, 0xa0, 0xf3, 0xa6,
+  0x01, 0x1e, 0x02, 0x7e, 0x01, 0x51, 0xbb, 0xc7, 0xbb, 0x2c, 0x8a, 0x2c,
+  0xba, 0xc8, 0xba, 0xfe, 0xb0, 0x01, 0x4f, 0xbb, 0xc8, 0xbb, 0x2d, 0x8a,
+  0x2c, 0x71, 0xfe, 0x74, 0x01, 0x35, 0xfe, 0xaf, 0xb3, 0xfe, 0xf0, 0xb9,
+  0x01, 0x40, 0xb4, 0xb4, 0xfe, 0xc0, 0xb9, 0x01, 0x10, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xb2, 0xff, 0xec, 0x05, 0xc2, 0x05, 0xdb, 0x00, 0x0f,
+  0x00, 0x52, 0x00, 0x00, 0x01, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01,
+  0x35, 0x34, 0x2e, 0x01, 0x23, 0x22, 0x0e, 0x01, 0x13, 0x15, 0x23, 0x06,
+  0x23, 0x22, 0x27, 0x35, 0x23, 0x15, 0x23, 0x22, 0x24, 0x27, 0x26, 0x27,
+  0x07, 0x03, 0x05, 0x07, 0x30, 0x17, 0x16, 0x17, 0x16, 0x17, 0x11, 0x21,
+  0x35, 0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x33, 0x32,
+  0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x15, 0x21, 0x15, 0x21, 0x11,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x27, 0x25, 0x03, 0x27, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x02, 0xc2, 0x23, 0x41, 0x22, 0x24, 0x40, 0x24, 0x25,
+  0x40, 0x23, 0x22, 0x40, 0x24, 0xcc, 0x07, 0x22, 0x23, 0x02, 0x03, 0x06,
+  0x07, 0x98, 0xfe, 0xea, 0x4d, 0x0f, 0x0b, 0x4f, 0x1a, 0x01, 0x14, 0x4e,
+  0x06, 0x41, 0x77, 0x62, 0x6a, 0xfe, 0xae, 0x01, 0x52, 0x18, 0x16, 0x38,
+  0x3d, 0x3e, 0x70, 0x3b, 0x3b, 0x70, 0x40, 0x3f, 0x36, 0x19, 0x17, 0x01,
+  0x48, 0xfe, 0xb8, 0x5a, 0x54, 0x77, 0x43, 0x02, 0x02, 0x4e, 0x01, 0x15,
+  0x1b, 0x4e, 0x0b, 0x0f, 0x4e, 0x8b, 0x67, 0x04, 0xd6, 0x27, 0x48, 0x27,
+  0x27, 0x48, 0x27, 0x28, 0x48, 0x27, 0x27, 0x48, 0xfa, 0xf2, 0x01, 0x03,
+  0x01, 0x02, 0x02, 0x60, 0x58, 0x11, 0x10, 0x41, 0x01, 0x4b, 0x7c, 0x40,
+  0x06, 0x58, 0x31, 0x28, 0x07, 0x02, 0xd4, 0x81, 0x33, 0x08, 0x0e, 0x22,
+  0x7c, 0x88, 0x7d, 0x44, 0x44, 0x7d, 0x88, 0x7c, 0x22, 0x0e, 0x09, 0x32,
+  0x81, 0xfd, 0x2f, 0x0a, 0x22, 0x31, 0x58, 0x03, 0x03, 0x40, 0x7c, 0xfe,
+  0xb5, 0x41, 0x10, 0x11, 0x58, 0x31, 0x23, 0x00, 0x00, 0x01, 0x00, 0xf2,
+  0x00, 0x00, 0x05, 0x83, 0x05, 0xd6, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x13,
+  0x36, 0x37, 0x33, 0x06, 0x07, 0x17, 0x16, 0x17, 0x0e, 0x01, 0x07, 0x26,
+  0x2f, 0x01, 0x06, 0x07, 0x27, 0x36, 0x37, 0x0b, 0x01, 0x16, 0x17, 0x07,
+  0x26, 0x27, 0x07, 0x06, 0x07, 0x22, 0x26, 0x27, 0x36, 0x3f, 0x01, 0x26,
+  0x27, 0x33, 0x16, 0x17, 0x13, 0x01, 0x27, 0x09, 0x01, 0x07, 0x03, 0x7f,
+  0xfa, 0x43, 0x19, 0x51, 0x16, 0x54, 0x8d, 0x37, 0x02, 0x05, 0x36, 0x27,
+  0x40, 0x03, 0x8e, 0x5c, 0x52, 0x23, 0x5c, 0x3b, 0xdc, 0xd9, 0x3b, 0x5b,
+  0x22, 0x53, 0x5e, 0x8c, 0x01, 0x39, 0x24, 0x43, 0x04, 0x01, 0x39, 0x8c,
+  0x54, 0x17, 0x53, 0x18, 0x44, 0xfa, 0xfe, 0x19, 0x1d, 0x02, 0x47, 0x02,
+  0x49, 0x1d, 0x02, 0xbd, 0xfe, 0xd0, 0x3b, 0x3c, 0x75, 0x49, 0xb6, 0x03,
+  0x40, 0x2a, 0x22, 0x01, 0x04, 0x4f, 0xa8, 0x38, 0x08, 0x42, 0x11, 0x31,
+  0x01, 0x22, 0xfe, 0xde, 0x31, 0x11, 0x42, 0x08, 0x38, 0xa8, 0x48, 0x0b,
+  0x1d, 0x24, 0x4c, 0x03, 0xb6, 0x49, 0x75, 0x3c, 0x3b, 0x01, 0x30, 0x02,
+  0x84, 0x95, 0xfd, 0x3a, 0x02, 0xc6, 0x95, 0x00, 0x00, 0x05, 0x00, 0x70,
+  0xff, 0xec, 0x03, 0x73, 0x05, 0xdb, 0x00, 0x07, 0x00, 0x1a, 0x00, 0x2e,
+  0x00, 0x4f, 0x00, 0x60, 0x00, 0x00, 0x01, 0x16, 0x33, 0x32, 0x35, 0x34,
+  0x27, 0x26, 0x13, 0x15, 0x06, 0x23, 0x22, 0x27, 0x35, 0x26, 0x35, 0x34,
+  0x37, 0x17, 0x06, 0x15, 0x14, 0x04, 0x07, 0x23, 0x26, 0x03, 0x24, 0x35,
+  0x34, 0x37, 0x15, 0x06, 0x15, 0x14, 0x04, 0x17, 0x06, 0x07, 0x35, 0x36,
+  0x35, 0x34, 0x27, 0x11, 0x27, 0x13, 0x11, 0x27, 0x11, 0x24, 0x27, 0x36,
+  0x37, 0x32, 0x33, 0x32, 0x17, 0x07, 0x17, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x23, 0x22, 0x15, 0x14, 0x04, 0x17, 0x06, 0x05, 0x35, 0x36, 0x27, 0x34,
+  0x35, 0x34, 0x25, 0x27, 0x03, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x33,
+  0x32, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x01, 0x32, 0x19, 0x0c, 0x0a,
+  0x05, 0x20, 0xe0, 0x0b, 0x18, 0x20, 0x02, 0xa3, 0x93, 0x01, 0x3a, 0x01,
+  0x22, 0x01, 0x0e, 0x19, 0xb1, 0xfe, 0xfe, 0xf3, 0x9a, 0x01, 0xf5, 0x03,
+  0x04, 0xf8, 0xa3, 0xb1, 0x45, 0x45, 0x45, 0xfe, 0x9d, 0x04, 0x0c, 0xc0,
+  0x04, 0x02, 0x3b, 0x2f, 0x64, 0x55, 0x15, 0x18, 0x33, 0x3d, 0x08, 0x06,
+  0x28, 0x02, 0xa4, 0x05, 0x06, 0xfe, 0xba, 0xf6, 0x01, 0xff, 0x00, 0x45,
+  0x05, 0x13, 0x15, 0x15, 0x26, 0x14, 0x15, 0x25, 0x16, 0x15, 0x13, 0x04,
+  0xa4, 0x0c, 0x09, 0x06, 0x0a, 0x0b, 0xfb, 0x94, 0x42, 0x1d, 0x40, 0x30,
+  0x22, 0x40, 0x52, 0x1a, 0x2f, 0x18, 0x18, 0x2f, 0x3e, 0x77, 0x41, 0x01,
+  0xb7, 0x26, 0x6f, 0x63, 0x2f, 0x44, 0x26, 0x33, 0x2e, 0x59, 0x61, 0x51,
+  0x2f, 0x35, 0x22, 0x31, 0x27, 0x22, 0xfe, 0xb4, 0x13, 0x03, 0x01, 0xfe,
+  0x81, 0x10, 0x01, 0x75, 0x13, 0x8a, 0x90, 0x05, 0x45, 0x1e, 0x19, 0x06,
+  0x1b, 0x02, 0x36, 0x32, 0x2f, 0x75, 0x8a, 0x10, 0x3d, 0x20, 0x3d, 0x01,
+  0x02, 0x21, 0x6d, 0x07, 0x01, 0x2d, 0x0b, 0x2e, 0x18, 0x19, 0x2e, 0x18,
+  0x18, 0x2e, 0x19, 0x18, 0x2e, 0x0b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6c,
+  0xff, 0xec, 0x06, 0x07, 0x05, 0xdb, 0x00, 0x04, 0x00, 0x09, 0x00, 0x37,
+  0x00, 0x00, 0x25, 0x0b, 0x01, 0x16, 0x32, 0x25, 0x0b, 0x01, 0x16, 0x32,
+  0x01, 0x33, 0x32, 0x1d, 0x01, 0x14, 0x2b, 0x01, 0x13, 0x06, 0x07, 0x0e,
+  0x01, 0x23, 0x22, 0x2e, 0x01, 0x3d, 0x01, 0x13, 0x21, 0x13, 0x15, 0x14,
+  0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x27, 0x13, 0x23, 0x26, 0x3d, 0x01,
+  0x34, 0x3b, 0x01, 0x37, 0x17, 0x33, 0x1b, 0x01, 0x33, 0x37, 0x05, 0xbc,
+  0xf8, 0xf9, 0x7d, 0xf9, 0xfd, 0x6e, 0xf8, 0xf8, 0x7c, 0xf8, 0x02, 0xbc,
+  0xc0, 0x33, 0x25, 0xaf, 0xf9, 0x02, 0x2b, 0x2b, 0x9b, 0x56, 0x54, 0x9a,
+  0x55, 0xf5, 0xfd, 0x92, 0xf6, 0x54, 0x9b, 0xa9, 0x9c, 0x2c, 0x2a, 0x01,
+  0xf7, 0xb7, 0x1d, 0x33, 0xc2, 0x2f, 0x2e, 0xe3, 0x74, 0x74, 0xe3, 0x2f,
+  0xed, 0x03, 0x3c, 0xfc, 0xc4, 0x26, 0x26, 0x03, 0x3c, 0xfc, 0xc4, 0x26,
+  0x03, 0xd1, 0x2a, 0x19, 0x28, 0xfc, 0xc7, 0x44, 0x3e, 0x3f, 0x47, 0x47,
+  0x7a, 0x42, 0x08, 0x03, 0x36, 0xfc, 0xca, 0x06, 0x43, 0x7b, 0x47, 0x47,
+  0x3f, 0x3e, 0x44, 0x03, 0x39, 0x11, 0x1c, 0x0f, 0x2f, 0x9b, 0x9b, 0x01,
+  0x43, 0xfe, 0xbd, 0x9b, 0x00, 0x02, 0x00, 0x70, 0x00, 0x00, 0x06, 0x03,
+  0x05, 0xdb, 0x00, 0x1a, 0x00, 0x26, 0x00, 0x00, 0x01, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x06, 0x03, 0x27, 0x12, 0x01,
+  0x13, 0x23, 0x03, 0x21, 0x11, 0x23, 0x03, 0x21, 0x03, 0x23, 0x13, 0x02,
+  0x8a, 0xa5, 0x8f, 0x30, 0x2d, 0xb5, 0x44, 0x1f, 0x0f, 0x27, 0x71, 0x44,
+  0x3f, 0x2b, 0x8d, 0x4a, 0x1e, 0x33, 0x23, 0x2b, 0x46, 0x92, 0xb4, 0x6c,
+  0xcf, 0x04, 0x6f, 0x55, 0x72, 0x4c, 0xfe, 0xff, 0x7c, 0x01, 0xfe, 0xff,
+  0x4d, 0x73, 0x56, 0x05, 0x87, 0x54, 0x09, 0x27, 0xa6, 0x4e, 0x51, 0x39,
+  0x3b, 0x8d, 0x3a, 0x23, 0x38, 0xb3, 0x48, 0x4c, 0x22, 0x43, 0xfe, 0xdf,
+  0x44, 0x01, 0x99, 0xfd, 0x7c, 0xfd, 0xa6, 0x01, 0xd7, 0xfe, 0x29, 0x01,
+  0xd7, 0xfe, 0x29, 0x02, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x0b,
+  0x00, 0x00, 0x05, 0x68, 0x05, 0xdb, 0x00, 0x0d, 0x00, 0x35, 0x00, 0x00,
+  0x00, 0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23,
+  0x22, 0x06, 0x13, 0x15, 0x3b, 0x01, 0x32, 0x36, 0x37, 0x14, 0x04, 0x07,
+  0x06, 0x07, 0x23, 0x26, 0x3d, 0x01, 0x26, 0x24, 0x03, 0x1e, 0x01, 0x33,
+  0x32, 0x37, 0x33, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32,
+  0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x02, 0x9c, 0x2d, 0x52, 0x2b, 0x2d,
+  0x52, 0x2d, 0x2f, 0x51, 0x2c, 0x2a, 0x52, 0xa8, 0x05, 0x03, 0x87, 0xcb,
+  0x9b, 0xfe, 0x58, 0x23, 0x2f, 0x02, 0x26, 0x27, 0x04, 0xfe, 0x40, 0x4f,
+  0xb3, 0xd4, 0x74, 0x0c, 0x0c, 0x06, 0x3b, 0x36, 0x46, 0x4e, 0x4f, 0x8d,
+  0x96, 0x8e, 0x51, 0x4f, 0x47, 0x33, 0x04, 0xc4, 0x64, 0x59, 0x32, 0x32,
+  0x59, 0x64, 0x5b, 0x30, 0x30, 0xfe, 0x2d, 0x9c, 0xbf, 0x26, 0xe7, 0x9a,
+  0x97, 0x88, 0xf5, 0xa8, 0x9a, 0x14, 0x84, 0x8f, 0x01, 0x31, 0x02, 0xe9,
+  0x01, 0x9b, 0x07, 0x23, 0x2b, 0x9c, 0xac, 0x9e, 0x55, 0x55, 0x9e, 0xac,
+  0x9c, 0x2b, 0x20, 0x00, 0x00, 0x03, 0x00, 0xae, 0xff, 0xdd, 0x05, 0xc6,
+  0x05, 0xd0, 0x00, 0x3f, 0x00, 0x47, 0x00, 0x4f, 0x00, 0x00, 0x00, 0x32,
+  0x1f, 0x01, 0x16, 0x17, 0x37, 0x16, 0x17, 0x07, 0x16, 0x17, 0x37, 0x16,
+  0x17, 0x07, 0x16, 0x14, 0x07, 0x17, 0x06, 0x07, 0x27, 0x06, 0x07, 0x17,
+  0x06, 0x07, 0x27, 0x06, 0x0f, 0x01, 0x06, 0x22, 0x2f, 0x01, 0x26, 0x27,
+  0x07, 0x26, 0x27, 0x37, 0x26, 0x27, 0x07, 0x26, 0x27, 0x37, 0x26, 0x34,
+  0x37, 0x27, 0x36, 0x37, 0x17, 0x36, 0x37, 0x27, 0x36, 0x37, 0x17, 0x36,
+  0x3f, 0x01, 0x12, 0x20, 0x02, 0x10, 0x12, 0x20, 0x12, 0x10, 0x04, 0x14,
+  0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x03, 0x13, 0x4f, 0x26, 0x18, 0x3c,
+  0x3a, 0x71, 0x45, 0x39, 0x4b, 0x2a, 0x1e, 0x94, 0x21, 0x0f, 0x85, 0x03,
+  0x03, 0x85, 0x0f, 0x21, 0x94, 0x1e, 0x2a, 0x4b, 0x39, 0x45, 0x71, 0x3a,
+  0x3c, 0x18, 0x26, 0x4f, 0x27, 0x18, 0x3c, 0x39, 0x72, 0x44, 0x3a, 0x4c,
+  0x2b, 0x1d, 0x95, 0x21, 0x0e, 0x85, 0x04, 0x04, 0x85, 0x0e, 0x21, 0x95,
+  0x1d, 0x2b, 0x4c, 0x3a, 0x44, 0x72, 0x39, 0x3c, 0x18, 0xf2, 0xfe, 0xb8,
+  0xe8, 0xe8, 0x01, 0x48, 0xe8, 0xff, 0x00, 0x52, 0x73, 0x52, 0x52, 0x73,
+  0x05, 0xd0, 0x05, 0xbb, 0x0d, 0x1e, 0x84, 0x2d, 0x40, 0x9c, 0x32, 0x3c,
+  0x1f, 0x54, 0x5c, 0x45, 0x23, 0x44, 0x23, 0x46, 0x5b, 0x54, 0x1f, 0x3c,
+  0x33, 0x9b, 0x40, 0x2e, 0x84, 0x1d, 0x0e, 0xba, 0x06, 0x06, 0xba, 0x0e,
+  0x1d, 0x84, 0x2e, 0x40, 0x9b, 0x32, 0x3d, 0x1f, 0x54, 0x5b, 0x46, 0x23,
+  0x44, 0x23, 0x45, 0x5c, 0x54, 0x1f, 0x3c, 0x33, 0x9b, 0x40, 0x2d, 0x83,
+  0x1d, 0x0d, 0xbb, 0xfe, 0xc4, 0xfe, 0xfd, 0xfe, 0x95, 0xfe, 0xfe, 0x01,
+  0x02, 0x01, 0x6b, 0x75, 0x80, 0x5b, 0x5b, 0x80, 0x5b, 0x00, 0x00, 0x00,
+  0x00, 0x0f, 0x00, 0xeb, 0xff, 0xed, 0x05, 0x88, 0x05, 0xdd, 0x00, 0x09,
+  0x00, 0x0e, 0x00, 0x13, 0x00, 0x18, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x2c,
+  0x00, 0x31, 0x00, 0x36, 0x00, 0x3b, 0x00, 0x40, 0x00, 0x48, 0x00, 0x4f,
+  0x00, 0x5b, 0x00, 0x9f, 0x00, 0x00, 0x00, 0x14, 0x1e, 0x01, 0x33, 0x26,
+  0x34, 0x37, 0x22, 0x06, 0x05, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16, 0x17,
+  0x37, 0x26, 0x27, 0x16, 0x17, 0x37, 0x26, 0x27, 0x16, 0x07, 0x37, 0x26,
+  0x27, 0x14, 0x15, 0x14, 0x07, 0x17, 0x35, 0x34, 0x27, 0x06, 0x07, 0x17,
+  0x36, 0x35, 0x34, 0x05, 0x17, 0x36, 0x37, 0x06, 0x07, 0x17, 0x36, 0x37,
+  0x06, 0x07, 0x17, 0x36, 0x37, 0x06, 0x1f, 0x01, 0x26, 0x37, 0x06, 0x17,
+  0x37, 0x26, 0x35, 0x34, 0x37, 0x06, 0x15, 0x3f, 0x01, 0x26, 0x27, 0x06,
+  0x15, 0x14, 0x05, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x27, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x33,
+  0x32, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x33, 0x14, 0x23, 0x15,
+  0x16, 0x17, 0x16, 0x17, 0x36, 0x37, 0x04, 0x17, 0x06, 0x23, 0x26, 0x22,
+  0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x03, 0x15, 0x06, 0x23, 0x22,
+  0x2f, 0x01, 0x03, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x26, 0x23, 0x22,
+  0x07, 0x22, 0x27, 0x36, 0x25, 0x16, 0x17, 0x36, 0x37, 0x36, 0x03, 0x01,
+  0x0f, 0x1c, 0x10, 0x0d, 0x0d, 0x0f, 0x1d, 0x01, 0xc1, 0x63, 0x26, 0x17,
+  0x52, 0x82, 0x63, 0x21, 0x23, 0x51, 0x6c, 0x45, 0x0e, 0x2b, 0x36, 0x6f,
+  0x2e, 0x01, 0x35, 0x22, 0x59, 0x13, 0x36, 0x36, 0x2b, 0x2d, 0x34, 0x24,
+  0xfc, 0xce, 0x18, 0x26, 0x62, 0x4e, 0x25, 0x23, 0x21, 0x64, 0x57, 0x12,
+  0x2c, 0x0e, 0x44, 0x48, 0x0e, 0x35, 0x01, 0x2d, 0x3f, 0x36, 0x35, 0x14,
+  0x01, 0x22, 0x59, 0x34, 0x2d, 0x2a, 0x01, 0x01, 0x00, 0x32, 0x44, 0x44,
+  0x32, 0x2f, 0x46, 0x45, 0x51, 0x02, 0x02, 0x11, 0x13, 0x13, 0x23, 0x13,
+  0x12, 0x22, 0x14, 0x13, 0x11, 0x02, 0x03, 0x01, 0x01, 0x2f, 0x25, 0x03,
+  0x02, 0x48, 0x14, 0x01, 0x2d, 0x48, 0x4d, 0xe4, 0x24, 0x3e, 0x19, 0x04,
+  0x2f, 0x24, 0x2f, 0x01, 0x0a, 0x14, 0x17, 0x07, 0x01, 0x02, 0x2e, 0x24,
+  0x2e, 0x02, 0x1c, 0x24, 0x1f, 0x24, 0xe5, 0x4c, 0x48, 0x01, 0x2c, 0x13,
+  0x4a, 0x06, 0x09, 0x24, 0x05, 0xa0, 0x22, 0x1f, 0x12, 0x20, 0x42, 0x22,
+  0x11, 0x76, 0x3e, 0x30, 0x26, 0x38, 0x14, 0x61, 0x3e, 0x21, 0x55, 0x2a,
+  0x7e, 0x45, 0x13, 0x6d, 0x4c, 0x91, 0x4b, 0x08, 0x7d, 0x60, 0x11, 0x10,
+  0x81, 0x3f, 0x0a, 0x0c, 0x7b, 0x61, 0x88, 0x37, 0x1a, 0x63, 0x5b, 0x0d,
+  0x4f, 0x26, 0x30, 0x3e, 0x10, 0x6a, 0x21, 0x3e, 0x61, 0x29, 0x86, 0x13,
+  0x45, 0x7e, 0x43, 0x88, 0x08, 0x4b, 0x91, 0x57, 0x8b, 0x0a, 0x3d, 0x7b,
+  0x14, 0x15, 0x64, 0x7b, 0x03, 0x1a, 0x37, 0x88, 0x0e, 0x0d, 0x5b, 0x2b,
+  0x4d, 0x35, 0x37, 0x4c, 0x4c, 0x37, 0x35, 0x4d, 0x2d, 0x5a, 0x01, 0x02,
+  0x0a, 0x27, 0x2a, 0x27, 0x15, 0x15, 0x27, 0x2a, 0x27, 0x0a, 0x02, 0x01,
+  0x01, 0x59, 0x09, 0x28, 0x03, 0x04, 0x80, 0x35, 0x06, 0x5b, 0xa3, 0x0c,
+  0x0c, 0x14, 0x15, 0x4a, 0x35, 0x28, 0x09, 0xfc, 0xd6, 0x5c, 0x16, 0x1c,
+  0x64, 0x03, 0x1c, 0x09, 0x28, 0x35, 0x4a, 0x12, 0x11, 0x11, 0x0c, 0xa3,
+  0x5b, 0x06, 0x34, 0x8c, 0x0a, 0x09, 0x27, 0x00, 0x00, 0x0f, 0x00, 0xea,
+  0x00, 0x00, 0x05, 0x8a, 0x05, 0xd3, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x2f,
+  0x00, 0x37, 0x00, 0x4f, 0x00, 0x5f, 0x00, 0x9f, 0x00, 0xab, 0x00, 0xb3,
+  0x00, 0xbb, 0x00, 0xcb, 0x00, 0xd3, 0x00, 0xdb, 0x00, 0xe3, 0x00, 0xef,
+  0x00, 0x00, 0x01, 0x32, 0x1e, 0x01, 0x15, 0x14, 0x0e, 0x01, 0x23, 0x22,
+  0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x07, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x33, 0x36, 0x37, 0x26, 0x25, 0x06,
+  0x07, 0x16, 0x17, 0x32, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x27, 0x06, 0x27, 0x16, 0x15, 0x14, 0x07, 0x36, 0x37, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x13, 0x16,
+  0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x05, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x15, 0x36,
+  0x33, 0x32, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x23,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x23, 0x22, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x32, 0x33, 0x32, 0x05, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x16, 0x17, 0x36, 0x17, 0x06, 0x07, 0x16, 0x17, 0x16,
+  0x17, 0x26, 0x25, 0x06, 0x07, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x36,
+  0x37, 0x36, 0x07, 0x06, 0x07, 0x16, 0x17, 0x26, 0x35, 0x34, 0x17, 0x16,
+  0x17, 0x36, 0x37, 0x26, 0x27, 0x26, 0x17, 0x16, 0x17, 0x36, 0x37, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x26, 0x03, 0x3a, 0x11, 0x21, 0x12, 0x12, 0x21, 0x11, 0x12, 0x20,
+  0x12, 0x12, 0x20, 0xca, 0x47, 0x40, 0x73, 0x2e, 0x21, 0x07, 0x15, 0x4d,
+  0x08, 0x08, 0x59, 0x89, 0x0d, 0x01, 0xb2, 0x05, 0x0d, 0x8a, 0x59, 0x08,
+  0x07, 0x4d, 0x15, 0x07, 0x21, 0x2f, 0x72, 0x40, 0x44, 0x01, 0x01, 0x33,
+  0x2f, 0x2f, 0x62, 0x2b, 0x2c, 0x2d, 0x2d, 0x2c, 0x2b, 0x2d, 0x2a, 0x02,
+  0x02, 0x29, 0x2e, 0x2b, 0x2e, 0x2c, 0x2c, 0x2d, 0x2a, 0x03, 0x16, 0x0e,
+  0x05, 0x47, 0x3f, 0x71, 0x30, 0x22, 0x07, 0x15, 0x4d, 0x08, 0x0a, 0x5b,
+  0xfd, 0xef, 0x01, 0x1e, 0x6c, 0x38, 0x38, 0x6a, 0x1f, 0x93, 0x65, 0x03,
+  0x04, 0x68, 0x1d, 0x0b, 0x20, 0x32, 0x7b, 0x01, 0x7c, 0x32, 0x1e, 0x0b,
+  0x1c, 0x6a, 0x06, 0x63, 0x93, 0x01, 0x1f, 0x34, 0x35, 0x3a, 0x3a, 0x36,
+  0x34, 0x1f, 0x92, 0x63, 0x05, 0x6c, 0x1c, 0x0a, 0x1e, 0x30, 0x7c, 0x7a,
+  0x31, 0x1f, 0x0a, 0x1d, 0x67, 0x04, 0x02, 0x65, 0x01, 0xee, 0x18, 0x29,
+  0x2b, 0x2c, 0x2e, 0x2a, 0x29, 0x19, 0x4d, 0x4d, 0x4c, 0x53, 0x36, 0x38,
+  0x1e, 0x21, 0x1e, 0x1d, 0x04, 0xfe, 0xb9, 0x08, 0x05, 0x1e, 0x1f, 0x1f,
+  0x1f, 0x38, 0x60, 0x86, 0x5a, 0x09, 0x09, 0x4d, 0x14, 0x08, 0x22, 0x31,
+  0x70, 0x3f, 0x47, 0x05, 0x08, 0x33, 0x2e, 0x2e, 0x33, 0x01, 0x33, 0x05,
+  0x08, 0x36, 0x38, 0x20, 0x1e, 0x20, 0xc1, 0x38, 0x36, 0x08, 0x04, 0x1d,
+  0x1e, 0x21, 0x51, 0x4b, 0x4d, 0x18, 0x29, 0x2a, 0x2f, 0x2e, 0x2a, 0x29,
+  0x17, 0x4d, 0x03, 0x35, 0x13, 0x24, 0x15, 0x14, 0x23, 0x14, 0x14, 0x23,
+  0x14, 0x15, 0x24, 0x13, 0xd9, 0x35, 0x39, 0x67, 0x54, 0x3b, 0x26, 0x12,
+  0x0e, 0x27, 0x04, 0x39, 0x5a, 0x5e, 0x5e, 0x5a, 0x39, 0x04, 0x27, 0x0e,
+  0x12, 0x27, 0x3a, 0x54, 0x67, 0x39, 0xa7, 0x27, 0x28, 0x27, 0x27, 0x26,
+  0x28, 0x29, 0x49, 0x1e, 0x1c, 0x1c, 0x1a, 0x1a, 0x1c, 0x1c, 0x1e, 0x38,
+  0x3a, 0x39, 0x38, 0x1e, 0x1c, 0x1d, 0x1a, 0x1a, 0x1d, 0x1c, 0x1e, 0x38,
+  0x39, 0x3a, 0x01, 0x0c, 0x5a, 0x5f, 0x35, 0x39, 0x65, 0x55, 0x3b, 0x27,
+  0x13, 0x0e, 0x28, 0x01, 0x05, 0x09, 0x02, 0xb3, 0xc0, 0xc0, 0xb3, 0x02,
+  0x3a, 0x02, 0x38, 0x14, 0x1b, 0x2e, 0x3e, 0x65, 0x75, 0x01, 0x76, 0x63,
+  0x3e, 0x2d, 0x1b, 0x14, 0x37, 0x03, 0x3a, 0xb0, 0x62, 0x63, 0x63, 0x62,
+  0xb0, 0x3b, 0x04, 0x37, 0x14, 0x1a, 0x2d, 0x3f, 0x63, 0x77, 0x75, 0x64,
+  0x3f, 0x2f, 0x1a, 0x14, 0x38, 0x02, 0x4b, 0xa2, 0x57, 0x5a, 0x5a, 0x57,
+  0xa2, 0x20, 0x2a, 0x2a, 0x10, 0x19, 0x1d, 0x12, 0x14, 0x15, 0x14, 0x44,
+  0x40, 0x40, 0x44, 0x14, 0x15, 0x14, 0x12, 0x1d, 0x2b, 0x38, 0x05, 0x01,
+  0x28, 0x0f, 0x13, 0x27, 0x3a, 0x54, 0x65, 0x39, 0x35, 0x5e, 0x9d, 0x26,
+  0x29, 0x28, 0x26, 0x27, 0x27, 0x28, 0xd6, 0x44, 0x41, 0x19, 0x1d, 0x12,
+  0x14, 0x14, 0x3a, 0x1d, 0x19, 0x41, 0x44, 0x15, 0x14, 0x14, 0x2e, 0x2a,
+  0x21, 0x9e, 0x59, 0x5b, 0x5b, 0x59, 0x9e, 0x21, 0x00, 0x07, 0x00, 0xea,
+  0x00, 0x00, 0x05, 0x89, 0x05, 0xd6, 0x00, 0x0b, 0x00, 0x14, 0x00, 0x21,
+  0x00, 0x2d, 0x00, 0x78, 0x00, 0x86, 0x00, 0x94, 0x00, 0x00, 0x01, 0x14,
+  0x17, 0x36, 0x37, 0x26, 0x27, 0x36, 0x37, 0x26, 0x27, 0x06, 0x05, 0x34,
+  0x26, 0x15, 0x06, 0x15, 0x16, 0x17, 0x36, 0x25, 0x06, 0x15, 0x14, 0x17,
+  0x36, 0x37, 0x2e, 0x01, 0x27, 0x06, 0x15, 0x14, 0x25, 0x34, 0x27, 0x06,
+  0x07, 0x16, 0x17, 0x06, 0x07, 0x16, 0x17, 0x36, 0x03, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x26, 0x27, 0x36, 0x37, 0x16, 0x17, 0x36, 0x37, 0x26,
+  0x35, 0x34, 0x3f, 0x01, 0x15, 0x16, 0x15, 0x14, 0x07, 0x1e, 0x01, 0x17,
+  0x36, 0x37, 0x16, 0x17, 0x06, 0x07, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x06, 0x23, 0x26,
+  0x27, 0x06, 0x07, 0x06, 0x07, 0x23, 0x26, 0x27, 0x35, 0x26, 0x27, 0x06,
+  0x07, 0x22, 0x27, 0x36, 0x37, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x06,
+  0x14, 0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x25, 0x32, 0x1e, 0x01, 0x14, 0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01,
+  0x34, 0x3e, 0x01, 0x03, 0x6d, 0x23, 0x31, 0x28, 0x2e, 0x08, 0x03, 0x2d,
+  0x21, 0x2a, 0x2b, 0xfe, 0xf9, 0x25, 0x28, 0x07, 0x32, 0x13, 0x01, 0xaf,
+  0x01, 0x0f, 0x37, 0x03, 0x03, 0x25, 0x01, 0x20, 0xfe, 0xf5, 0x2b, 0x26,
+  0x27, 0x2e, 0x03, 0x0d, 0x29, 0x2d, 0x2d, 0x23, 0xef, 0x32, 0x1d, 0x0c,
+  0x09, 0x1c, 0x51, 0x5b, 0x02, 0x02, 0xa4, 0x99, 0x4b, 0x28, 0x2c, 0x23,
+  0x94, 0x01, 0x94, 0x23, 0x24, 0x2a, 0x04, 0x4d, 0x97, 0xa6, 0x01, 0x02,
+  0x5c, 0x50, 0x1d, 0x05, 0x0d, 0x1a, 0x38, 0x18, 0x12, 0x33, 0x33, 0x15,
+  0x1d, 0x1f, 0x2d, 0x01, 0x0c, 0x3b, 0x2d, 0x35, 0x3f, 0x56, 0x16, 0x1d,
+  0x1d, 0x4f, 0x3c, 0x38, 0x2d, 0x3d, 0x0b, 0x01, 0x2e, 0x1e, 0x1c, 0x15,
+  0x33, 0x34, 0x12, 0x2f, 0x5e, 0xaa, 0x5d, 0x5d, 0xa9, 0x5f, 0x61, 0xab,
+  0x59, 0x5b, 0xaa, 0x01, 0x05, 0x4b, 0x8f, 0x52, 0x4f, 0x8f, 0x4e, 0x4e,
+  0x8f, 0x4f, 0x51, 0x8f, 0x02, 0x84, 0xa3, 0xa7, 0x0f, 0x23, 0x65, 0x8d,
+  0xaa, 0x6a, 0x1c, 0x0f, 0x70, 0xcd, 0x4d, 0x63, 0x01, 0x4e, 0x54, 0x76,
+  0x4a, 0x4b, 0x72, 0x1b, 0x19, 0x5a, 0x31, 0x56, 0x6c, 0x4c, 0x57, 0x02,
+  0x4d, 0x49, 0x09, 0x11, 0xa9, 0x70, 0x0d, 0x1e, 0x6a, 0xaa, 0x85, 0x6b,
+  0x25, 0x0f, 0xa7, 0x01, 0x6e, 0x41, 0x0d, 0x56, 0x02, 0x02, 0x7b, 0x77,
+  0x02, 0x06, 0x77, 0x19, 0x11, 0x5b, 0x31, 0x87, 0xf4, 0x01, 0x01, 0xf4,
+  0x87, 0x31, 0x5b, 0x0d, 0x1a, 0x03, 0x77, 0x06, 0x02, 0x77, 0x7b, 0x02,
+  0x02, 0x56, 0x0d, 0x40, 0x1e, 0x23, 0x66, 0xdc, 0x64, 0x2d, 0x23, 0x4a,
+  0x4d, 0x0c, 0x37, 0x42, 0x2f, 0x15, 0x22, 0x89, 0x89, 0x22, 0x01, 0x14,
+  0x30, 0x43, 0x37, 0x0c, 0x4e, 0x4b, 0x22, 0x2c, 0x64, 0xdc, 0x66, 0x23,
+  0x88, 0xce, 0xbd, 0x68, 0x68, 0xbd, 0xce, 0xbf, 0x67, 0x67, 0x51, 0x55,
+  0xa0, 0xae, 0x9d, 0x58, 0x58, 0x9d, 0xae, 0xa0, 0x55, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x5a, 0x00, 0x00, 0x06, 0x1b, 0x05, 0xd4, 0x00, 0x07,
+  0x00, 0x0d, 0x00, 0x15, 0x00, 0x25, 0x00, 0x00, 0x01, 0x33, 0x01, 0x15,
+  0x21, 0x27, 0x23, 0x00, 0x17, 0x01, 0x15, 0x21, 0x35, 0x00, 0x07, 0x32,
+  0x15, 0x02, 0x23, 0x22, 0x03, 0x36, 0x13, 0x32, 0x1e, 0x01, 0x15, 0x14,
+  0x0e, 0x01, 0x23, 0x22, 0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x03, 0x42,
+  0x07, 0x02, 0xd1, 0xfa, 0x4f, 0x07, 0x08, 0x02, 0xcc, 0x14, 0xfd, 0xab,
+  0x04, 0xb3, 0xfd, 0xbc, 0x12, 0x46, 0x2f, 0x17, 0x14, 0x31, 0x17, 0x2d,
+  0x11, 0x22, 0x13, 0x12, 0x23, 0x11, 0x12, 0x20, 0x13, 0x13, 0x20, 0x05,
+  0xd4, 0xfa, 0x35, 0x09, 0x09, 0x05, 0xaa, 0x9b, 0xfb, 0x4f, 0x11, 0x09,
+  0x04, 0x9d, 0xc2, 0x44, 0xfd, 0x9b, 0x02, 0x6e, 0x3b, 0xfd, 0x0d, 0x14,
+  0x24, 0x15, 0x14, 0x24, 0x14, 0x14, 0x24, 0x14, 0x15, 0x24, 0x14, 0x00,
+  0x00, 0x01, 0x00, 0x99, 0x00, 0x04, 0x04, 0x76, 0x05, 0xd8, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x33, 0x17, 0x15, 0x01, 0x14, 0x33, 0x04, 0x15, 0x17,
+  0x01, 0x27, 0x35, 0x00, 0x35, 0x34, 0x23, 0x24, 0x2f, 0x01, 0x04, 0x56,
+  0x0c, 0x13, 0xfd, 0xcd, 0x52, 0x01, 0x5c, 0x06, 0xfc, 0xb0, 0x0d, 0x02,
+  0x46, 0x6b, 0xfe, 0xb8, 0x0f, 0x06, 0x05, 0xd8, 0x15, 0x07, 0xfd, 0xe2,
+  0x47, 0x53, 0x0e, 0x47, 0xfd, 0x55, 0x15, 0x07, 0x02, 0x57, 0x0d, 0x47,
+  0x4a, 0x11, 0x47, 0x00, 0x00, 0x05, 0x00, 0x9d, 0xfe, 0xff, 0x06, 0x9e,
+  0x05, 0xda, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x31, 0x00, 0x3d, 0x00, 0x43,
+  0x00, 0x00, 0x01, 0x26, 0x10, 0x00, 0x33, 0x32, 0x17, 0x36, 0x33, 0x32,
+  0x00, 0x10, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11,
+  0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x26, 0x13, 0x22, 0x06,
+  0x10, 0x16, 0x33, 0x32, 0x37, 0x26, 0x10, 0x37, 0x26, 0x13, 0x06, 0x07,
+  0x11, 0x21, 0x11, 0x26, 0x37, 0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23,
+  0x22, 0x07, 0x16, 0x10, 0x05, 0x36, 0x10, 0x27, 0x06, 0x10, 0x01, 0x36,
+  0x98, 0x01, 0x2e, 0xd7, 0x8a, 0x70, 0x71, 0x8b, 0xd5, 0x01, 0x30, 0x97,
+  0x7b, 0xa2, 0xf5, 0xf5, 0xa2, 0xfe, 0xac, 0xa2, 0xf5, 0xf5, 0xa3, 0xf4,
+  0x94, 0xcf, 0xcf, 0x94, 0x39, 0x33, 0x7c, 0x7d, 0x33, 0xc1, 0x4f, 0x5b,
+  0x01, 0x54, 0x5c, 0x41, 0x33, 0x39, 0x90, 0xd3, 0xd3, 0x90, 0x3a, 0x35,
+  0x7e, 0xfe, 0xf5, 0x69, 0x69, 0x68, 0x02, 0x14, 0x9d, 0x01, 0xdd, 0x01,
+  0x4c, 0x46, 0x46, 0xfe, 0xb4, 0xfe, 0x22, 0x9c, 0x7e, 0x12, 0xfe, 0xf8,
+  0x7c, 0xfe, 0xff, 0x01, 0x01, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x09,
+  0x11, 0x03, 0x91, 0xe4, 0xfe, 0xb9, 0xd8, 0x11, 0x95, 0x01, 0xae, 0x9d,
+  0x12, 0xfc, 0x94, 0x2d, 0x0a, 0xfe, 0xf8, 0x01, 0x09, 0x0a, 0xa5, 0x10,
+  0xd8, 0x01, 0x47, 0xe4, 0x12, 0x9d, 0xfe, 0x50, 0x38, 0x6c, 0x01, 0x47,
+  0x72, 0x72, 0xfe, 0xb9, 0x00, 0x05, 0x00, 0x91, 0xfe, 0x5b, 0x07, 0x5f,
+  0x05, 0xc3, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x2c, 0x00, 0x38, 0x00, 0x3e,
+  0x00, 0x00, 0x01, 0x26, 0x20, 0x06, 0x10, 0x17, 0x16, 0x17, 0x36, 0x00,
+  0x37, 0x26, 0x01, 0x14, 0x00, 0x20, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x10, 0x00, 0x04, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x21, 0x11, 0x07,
+  0x11, 0x01, 0x16, 0x03, 0x01, 0x16, 0x17, 0x16, 0x17, 0x01, 0x23, 0x03,
+  0x06, 0x00, 0x07, 0x16, 0x17, 0x16, 0x20, 0x36, 0x10, 0x27, 0x26, 0x01,
+  0x32, 0x36, 0x35, 0x22, 0x06, 0x03, 0x92, 0x6a, 0xfe, 0xdc, 0xd0, 0x68,
+  0x2a, 0x31, 0x0f, 0x01, 0x17, 0xb8, 0x19, 0x02, 0x44, 0xfe, 0xd6, 0xfe,
+  0x51, 0x99, 0x69, 0x20, 0x79, 0x61, 0x99, 0x01, 0x36, 0x01, 0x9d, 0x64,
+  0x01, 0x45, 0xfe, 0xb2, 0x7e, 0x01, 0xbd, 0x01, 0x63, 0x80, 0xfe, 0xbe,
+  0x64, 0x86, 0xfe, 0xbe, 0x3a, 0x18, 0x66, 0x3d, 0x01, 0x45, 0xf8, 0xde,
+  0x0d, 0xfe, 0xef, 0xc8, 0x1a, 0x2f, 0x68, 0x01, 0x25, 0xd2, 0x69, 0x29,
+  0xfd, 0xcb, 0x91, 0xd3, 0x94, 0xcc, 0x03, 0x24, 0x72, 0xe4, 0xfe, 0xb8,
+  0x6c, 0x2c, 0x1a, 0xce, 0x01, 0x33, 0x07, 0x36, 0xfd, 0x90, 0xe8, 0xfe,
+  0xbd, 0x9f, 0x6c, 0x92, 0x25, 0x65, 0x9e, 0x01, 0xdc, 0x01, 0x55, 0x11,
+  0x67, 0x01, 0x5c, 0x8e, 0xfe, 0x78, 0xfe, 0x14, 0x8f, 0x01, 0x75, 0xfe,
+  0xa4, 0x92, 0x03, 0x76, 0xfe, 0xa4, 0x53, 0x63, 0x1b, 0x3f, 0x01, 0x5c,
+  0xfe, 0x37, 0xcc, 0xfe, 0xd7, 0x0b, 0x3d, 0x31, 0x6c, 0xd8, 0x01, 0x48,
+  0x72, 0x2d, 0xfe, 0xc9, 0xd8, 0xa4, 0xe0, 0x00, 0x00, 0x04, 0x00, 0x9d,
+  0xfe, 0x83, 0x07, 0xfc, 0x06, 0xd9, 0x00, 0x05, 0x00, 0x2d, 0x00, 0x39,
+  0x00, 0x45, 0x00, 0x00, 0x00, 0x02, 0x17, 0x36, 0x10, 0x27, 0x01, 0x14,
+  0x00, 0x23, 0x22, 0x27, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23,
+  0x11, 0x23, 0x35, 0x33, 0x11, 0x26, 0x27, 0x26, 0x10, 0x00, 0x33, 0x32,
+  0x17, 0x36, 0x17, 0x16, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x07, 0x11,
+  0x01, 0x16, 0x25, 0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x37, 0x26, 0x10,
+  0x37, 0x26, 0x01, 0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x22, 0x07,
+  0x16, 0x10, 0x03, 0x37, 0x01, 0x67, 0x69, 0x69, 0x03, 0x02, 0xfe, 0xd4,
+  0xdb, 0x8a, 0x72, 0x4e, 0x5a, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xa3, 0x79,
+  0x98, 0x01, 0x2e, 0xd7, 0x88, 0x6f, 0x74, 0x8a, 0xce, 0x64, 0x01, 0x46,
+  0xfe, 0xb1, 0x7e, 0x01, 0xbd, 0x80, 0xfe, 0xbe, 0x65, 0xfc, 0x04, 0x94,
+  0xcf, 0xcf, 0x94, 0x39, 0x33, 0x7b, 0x7d, 0x34, 0x01, 0x50, 0x33, 0x38,
+  0x92, 0xd3, 0xd3, 0x92, 0x3a, 0x34, 0x7e, 0x03, 0xc8, 0xfe, 0xb8, 0x6c,
+  0x6c, 0x01, 0x47, 0x72, 0xfe, 0xeb, 0xe7, 0xfe, 0xbc, 0x45, 0x2c, 0x0a,
+  0xfe, 0xf8, 0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x09, 0x11, 0x7e,
+  0x9d, 0x01, 0xdd, 0x01, 0x4c, 0x44, 0x4a, 0x06, 0x08, 0x67, 0x01, 0x5c,
+  0x8e, 0xfe, 0x14, 0x8f, 0x01, 0x75, 0xfe, 0xa4, 0x92, 0xc6, 0xe4, 0xfe,
+  0xb9, 0xd8, 0x11, 0x95, 0x01, 0xac, 0x9f, 0x12, 0xfd, 0x0d, 0x10, 0xd8,
+  0x01, 0x48, 0xe4, 0x12, 0x9d, 0xfe, 0x4f, 0x00, 0x00, 0x02, 0x00, 0x9d,
+  0xfe, 0xff, 0x06, 0x07, 0x07, 0x55, 0x00, 0x07, 0x00, 0x28, 0x00, 0x00,
+  0x00, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20, 0x36, 0x05, 0x26, 0x10, 0x00,
+  0x33, 0x32, 0x17, 0x01, 0x21, 0x37, 0x21, 0x11, 0x07, 0x11, 0x01, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11,
+  0x23, 0x35, 0x33, 0x11, 0x26, 0x04, 0x06, 0xd2, 0xfe, 0xdb, 0xcf, 0xcf,
+  0x01, 0x25, 0xd2, 0xfd, 0x30, 0x98, 0x01, 0x2e, 0xd7, 0xad, 0x86, 0x01,
+  0x44, 0xfe, 0xb2, 0x7e, 0x01, 0xbd, 0x81, 0xfe, 0xbe, 0x64, 0x98, 0x7a,
+  0xa2, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xa3, 0x04, 0x43, 0xe4, 0xe4, 0xfe,
+  0xb9, 0xd8, 0xd8, 0xe8, 0x9d, 0x01, 0xdd, 0x01, 0x4c, 0x6e, 0x01, 0x5b,
+  0x8e, 0xfe, 0x14, 0x8f, 0x01, 0x75, 0xfe, 0xa4, 0x92, 0xc2, 0xef, 0x9c,
+  0x7e, 0x12, 0xfe, 0xf8, 0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x09,
+  0x11, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xf2, 0xff, 0xe3, 0x05, 0x3c,
+  0x06, 0xf4, 0x00, 0x2b, 0x00, 0x44, 0x00, 0x00, 0x01, 0x07, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x37, 0x27, 0x37, 0x17, 0x13, 0x07, 0x27, 0x25, 0x13, 0x07,
+  0x27, 0x03, 0x17, 0x07, 0x01, 0x16, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36,
+  0x34, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06,
+  0x14, 0x17, 0x16, 0x17, 0x16, 0x03, 0xbe, 0x3f, 0x2d, 0x1f, 0x3d, 0x1f,
+  0x22, 0x21, 0x20, 0x70, 0x58, 0x4e, 0x56, 0x51, 0x51, 0x55, 0x35, 0x3d,
+  0x1f, 0x22, 0x22, 0x21, 0x76, 0x51, 0x50, 0x53, 0x35, 0x2e, 0x3f, 0xe4,
+  0x33, 0xe5, 0x78, 0xca, 0x34, 0x01, 0x9f, 0xad, 0x7d, 0x54, 0x78, 0xe4,
+  0x34, 0xfd, 0x8c, 0x37, 0x71, 0x37, 0x36, 0x51, 0x18, 0x16, 0x16, 0x15,
+  0x2a, 0x26, 0x72, 0x6d, 0x39, 0x36, 0x50, 0x19, 0x16, 0x16, 0x15, 0x2a,
+  0x24, 0x04, 0x00, 0xaa, 0x21, 0x24, 0x48, 0x53, 0x5c, 0xb4, 0x5b, 0x56,
+  0x83, 0x2a, 0x25, 0x25, 0x27, 0x3e, 0x48, 0x53, 0x5d, 0xb3, 0x5e, 0x58,
+  0x82, 0x26, 0x25, 0x0c, 0xab, 0x69, 0x8a, 0x69, 0x01, 0x44, 0x5e, 0x8b,
+  0xbf, 0xfe, 0x32, 0x39, 0xe1, 0xfe, 0xbd, 0x69, 0x8b, 0xfc, 0xfc, 0x1a,
+  0x19, 0x19, 0x5c, 0x3d, 0x3c, 0x80, 0x3c, 0x39, 0x32, 0x2d, 0x31, 0x19,
+  0x19, 0x58, 0x3f, 0x3a, 0x84, 0x3c, 0x39, 0x31, 0x2a, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xba, 0xfe, 0xa3, 0x05, 0x57, 0x07, 0x12, 0x00, 0x3d,
+  0x00, 0x58, 0x00, 0x00, 0x01, 0x36, 0x32, 0x17, 0x13, 0x07, 0x27, 0x25,
+  0x13, 0x07, 0x27, 0x03, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x07, 0x15, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x23,
+  0x35, 0x33, 0x35, 0x26, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36,
+  0x37, 0x36, 0x37, 0x27, 0x07, 0x27, 0x37, 0x27, 0x07, 0x27, 0x13, 0x05,
+  0x07, 0x27, 0x17, 0x37, 0x17, 0x07, 0x17, 0x22, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x02, 0xa3, 0x2f,
+  0x65, 0x30, 0xa1, 0xcb, 0x33, 0x01, 0x9f, 0xad, 0x7e, 0x54, 0xa1, 0x2a,
+  0x24, 0x3e, 0x40, 0x40, 0x3e, 0x3a, 0x51, 0x28, 0x36, 0xf7, 0xf7, 0x87,
+  0xf8, 0xf8, 0x33, 0x2c, 0x4d, 0x3d, 0x3e, 0x40, 0x3f, 0x3f, 0x23, 0x2c,
+  0x1c, 0xe5, 0x33, 0xe5, 0x4c, 0x54, 0x7e, 0xad, 0x01, 0xa0, 0x33, 0xcc,
+  0x4c, 0xe4, 0x35, 0xe5, 0x7c, 0x40, 0x2f, 0x38, 0x27, 0x29, 0x2c, 0x2c,
+  0x29, 0x2a, 0x35, 0x33, 0x7c, 0x30, 0x38, 0x26, 0x2a, 0x2c, 0x2c, 0x2a,
+  0x2a, 0x34, 0x34, 0x04, 0x87, 0x0c, 0x0c, 0x01, 0x9e, 0x5c, 0x8a, 0xbf,
+  0xfe, 0x32, 0x3a, 0xe2, 0xfe, 0x61, 0x1d, 0x28, 0x45, 0xab, 0x62, 0x5f,
+  0xab, 0x45, 0x40, 0x28, 0x14, 0x0a, 0xb8, 0x96, 0xf0, 0xf0, 0x96, 0xb8,
+  0x09, 0x15, 0x25, 0x43, 0x45, 0xab, 0x5f, 0x62, 0xa9, 0x47, 0x28, 0x1e,
+  0x48, 0x69, 0x8a, 0x6a, 0xcb, 0xe2, 0x3a, 0x01, 0xce, 0xbf, 0x8a, 0x5c,
+  0xcb, 0x69, 0x8a, 0x6a, 0xd3, 0x18, 0x1c, 0x2b, 0x2e, 0x77, 0x42, 0x41,
+  0x77, 0x2e, 0x2f, 0x18, 0x18, 0x18, 0x1c, 0x2b, 0x2e, 0x77, 0x41, 0x42,
+  0x77, 0x2e, 0x2f, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x59,
+  0xff, 0xe3, 0x04, 0xaf, 0x06, 0xf4, 0x00, 0x2b, 0x00, 0x46, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x15, 0x23, 0x15, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x23,
+  0x35, 0x33, 0x11, 0x07, 0x27, 0x09, 0x01, 0x07, 0x03, 0x32, 0x37, 0x36,
+  0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07,
+  0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x03,
+  0x48, 0xf7, 0xf7, 0x36, 0x28, 0x51, 0x3a, 0x3e, 0x40, 0x40, 0x3e, 0x3d,
+  0x4e, 0x4a, 0x58, 0x5c, 0x46, 0x51, 0x39, 0x3e, 0x40, 0x40, 0x3e, 0x3d,
+  0x4d, 0x2c, 0x33, 0xf8, 0xf8, 0x9b, 0x60, 0x01, 0x3e, 0x01, 0x3f, 0x60,
+  0xdf, 0x3c, 0x34, 0x34, 0x2a, 0x2a, 0x2c, 0x2c, 0x2a, 0x26, 0x38, 0x30,
+  0x7c, 0x33, 0x35, 0x2a, 0x29, 0x2c, 0x2c, 0x29, 0x27, 0x38, 0x2f, 0x05,
+  0xd5, 0xfe, 0xe7, 0x96, 0x91, 0x0a, 0x14, 0x28, 0x40, 0x45, 0xab, 0x5f,
+  0x62, 0xab, 0x45, 0x43, 0x25, 0x23, 0x23, 0x28, 0x40, 0x45, 0xab, 0x62,
+  0x5f, 0xab, 0x45, 0x43, 0x25, 0x15, 0x09, 0x91, 0x96, 0x01, 0x19, 0xad,
+  0x6b, 0x01, 0x61, 0xfe, 0x9f, 0x6a, 0xfb, 0x50, 0x18, 0x18, 0x2f, 0x2e,
+  0x77, 0x42, 0x41, 0x77, 0x2e, 0x2b, 0x1c, 0x18, 0x18, 0x18, 0x2f, 0x2e,
+  0x77, 0x41, 0x42, 0x77, 0x2e, 0x2b, 0x1c, 0x18, 0x00, 0x02, 0x00, 0x08,
+  0x01, 0x10, 0x05, 0xf8, 0x04, 0xc4, 0x00, 0x2b, 0x00, 0x46, 0x00, 0x00,
+  0x01, 0x23, 0x11, 0x23, 0x11, 0x23, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01,
+  0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33, 0x11,
+  0x33, 0x11, 0x33, 0x27, 0x37, 0x09, 0x01, 0x27, 0x25, 0x14, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27,
+  0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x04,
+  0xf5, 0xc6, 0x87, 0x4c, 0x0a, 0x12, 0x24, 0x39, 0x3e, 0x9a, 0x56, 0x58,
+  0x9a, 0x3e, 0x3c, 0x21, 0x20, 0x20, 0x24, 0x39, 0x3e, 0x9a, 0x58, 0x56,
+  0x9a, 0x3e, 0x3c, 0x21, 0x13, 0x09, 0x4c, 0x87, 0xc6, 0x9c, 0x61, 0x01,
+  0x3d, 0xfe, 0xc3, 0x60, 0xfc, 0x35, 0x16, 0x15, 0x2b, 0x29, 0x6b, 0x3b,
+  0x3b, 0x6b, 0x2a, 0x26, 0x19, 0x16, 0x16, 0x15, 0x2a, 0x2a, 0x6b, 0x3b,
+  0x3b, 0x6b, 0x29, 0x27, 0x19, 0x16, 0x02, 0x9f, 0xfe, 0xed, 0x01, 0x13,
+  0x3c, 0x2d, 0x5a, 0x40, 0x45, 0x47, 0x47, 0x45, 0x44, 0x56, 0x52, 0x62,
+  0x66, 0x4e, 0x5a, 0x40, 0x45, 0x47, 0x47, 0x45, 0x44, 0x56, 0x31, 0x38,
+  0x01, 0x13, 0xfe, 0xed, 0xac, 0x6b, 0xfe, 0x9e, 0xfe, 0x9e, 0x6a, 0xf8,
+  0x43, 0x39, 0x3a, 0x2f, 0x2e, 0x31, 0x31, 0x2e, 0x2b, 0x3e, 0x35, 0x8a,
+  0x39, 0x3a, 0x2f, 0x2e, 0x31, 0x31, 0x2e, 0x2b, 0x3e, 0x35, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x58, 0x01, 0x10, 0x04, 0xb0, 0x04, 0xc5, 0x00, 0x0b,
+  0x00, 0x17, 0x00, 0x00, 0x01, 0x34, 0x12, 0x33, 0x32, 0x12, 0x15, 0x14,
+  0x02, 0x23, 0x22, 0x02, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x01, 0x59, 0xfb, 0xb0, 0xb1, 0xfb, 0xfb, 0xb1,
+  0xb0, 0xfb, 0x89, 0xaa, 0x78, 0x78, 0xaa, 0xaa, 0x78, 0x78, 0xaa, 0x02,
+  0xeb, 0xc4, 0x01, 0x16, 0xfe, 0xea, 0xc4, 0xc5, 0xfe, 0xea, 0x01, 0x16,
+  0xc2, 0x85, 0xbd, 0xbd, 0x85, 0x86, 0xbd, 0xbd, 0x00, 0x01, 0x01, 0x58,
+  0x01, 0x10, 0x04, 0xb0, 0x04, 0xc5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x34,
+  0x12, 0x33, 0x32, 0x12, 0x15, 0x14, 0x02, 0x23, 0x22, 0x02, 0x01, 0x59,
+  0xfb, 0xb0, 0xb1, 0xfb, 0xfb, 0xb1, 0xb0, 0xfb, 0x02, 0xeb, 0xc4, 0x01,
+  0x16, 0xfe, 0xea, 0xc4, 0xc5, 0xfe, 0xea, 0x01, 0x16, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0xc7, 0x01, 0x8d, 0x04, 0x41, 0x04, 0x4b, 0x00, 0x0b,
+  0x00, 0x17, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x01, 0xc7, 0xbb, 0x82, 0x83, 0xba, 0xba, 0x83,
+  0x82, 0xbb, 0x89, 0x6a, 0x4a, 0x4b, 0x69, 0x69, 0x4b, 0x4a, 0x6a, 0x02,
+  0xec, 0x92, 0xcd, 0xcd, 0x92, 0x91, 0xce, 0xce, 0x90, 0x53, 0x75, 0x75,
+  0x53, 0x53, 0x76, 0x76, 0x00, 0x04, 0x01, 0x40, 0x01, 0x8d, 0x04, 0xc8,
+  0x04, 0x4b, 0x00, 0x13, 0x00, 0x21, 0x00, 0x29, 0x00, 0x37, 0x00, 0x00,
+  0x01, 0x34, 0x36, 0x33, 0x32, 0x17, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x27, 0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33,
+  0x32, 0x33, 0x26, 0x35, 0x34, 0x37, 0x26, 0x23, 0x22, 0x06, 0x25, 0x06,
+  0x15, 0x14, 0x17, 0x36, 0x35, 0x34, 0x37, 0x16, 0x15, 0x14, 0x07, 0x32,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x01, 0x40, 0xbb, 0x82,
+  0x4a, 0x3d, 0x3d, 0x4a, 0x83, 0xba, 0xba, 0x83, 0x4a, 0x3d, 0x3d, 0x4a,
+  0x82, 0xbb, 0x89, 0x69, 0x4b, 0x06, 0x04, 0x39, 0x38, 0x04, 0x05, 0x4b,
+  0x69, 0x01, 0x3b, 0x2d, 0x2d, 0x2d, 0x51, 0x38, 0x39, 0x05, 0x05, 0x4b,
+  0x69, 0x69, 0x4b, 0x04, 0x02, 0xec, 0x92, 0xcd, 0x20, 0x20, 0xcd, 0x92,
+  0x91, 0xce, 0x21, 0x21, 0xce, 0x90, 0x53, 0x75, 0x58, 0x71, 0x70, 0x57,
+  0x01, 0x76, 0x32, 0x38, 0x4d, 0x4c, 0x38, 0x38, 0x4c, 0x4d, 0x7b, 0x57,
+  0x70, 0x71, 0x58, 0x75, 0x53, 0x53, 0x76, 0x00, 0x00, 0x05, 0x00, 0x4b,
+  0x01, 0x5a, 0x05, 0xbd, 0x04, 0x7a, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x38,
+  0x00, 0x52, 0x00, 0x6d, 0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x00, 0x22,
+  0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x2f,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x04, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35,
+  0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e,
+  0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x02, 0xc1, 0x87, 0x87,
+  0x01, 0xe7, 0x4a, 0x20, 0x25, 0x15, 0x1a, 0x1b, 0x1c, 0x19, 0x1a, 0x20,
+  0x20, 0x4a, 0x1f, 0x21, 0x1a, 0x1a, 0x1b, 0x1d, 0x18, 0x1a, 0x21, 0x44,
+  0x43, 0x34, 0x3d, 0x29, 0x2d, 0x30, 0x30, 0x2d, 0x2c, 0x3a, 0x36, 0x85,
+  0x34, 0x3c, 0x2a, 0x2d, 0x2f, 0x2f, 0x2d, 0x2c, 0x3a, 0x37, 0xfd, 0x69,
+  0x4a, 0x20, 0x25, 0x15, 0x1a, 0x1b, 0x1c, 0x19, 0x1a, 0x20, 0x20, 0x4a,
+  0x1f, 0x20, 0x1b, 0x1a, 0x1b, 0x1d, 0x18, 0x1b, 0x20, 0x44, 0x43, 0x34,
+  0x3d, 0x29, 0x2d, 0x30, 0x30, 0x2d, 0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3c,
+  0x2a, 0x2d, 0x2f, 0x2f, 0x2d, 0x2c, 0x3a, 0x37, 0x04, 0x7a, 0xfc, 0xe0,
+  0x02, 0x5a, 0x0f, 0x12, 0x1a, 0x1f, 0x46, 0x29, 0x28, 0x4a, 0x1b, 0x1c,
+  0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29, 0x4b, 0x1a, 0x1c,
+  0x10, 0xa5, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x49, 0x46, 0x7f, 0x32, 0x31,
+  0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x46, 0x49, 0x7f, 0x32, 0x31,
+  0x1b, 0x1a, 0x96, 0x0f, 0x12, 0x1a, 0x1f, 0x46, 0x29, 0x28, 0x4a, 0x1b,
+  0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29, 0x4b, 0x1a,
+  0x1c, 0x10, 0xa5, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x49, 0x46, 0x7f, 0x32,
+  0x31, 0x1b, 0x1a, 0x1a, 0x1e, 0x2e, 0x32, 0x7f, 0x46, 0x49, 0x7f, 0x32,
+  0x31, 0x1b, 0x1a, 0x00, 0x00, 0x03, 0x00, 0x09, 0x01, 0x8d, 0x06, 0x00,
+  0x04, 0x4a, 0x00, 0x37, 0x00, 0x51, 0x00, 0x6b, 0x00, 0x00, 0x01, 0x3e,
+  0x01, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e,
+  0x01, 0x27, 0x21, 0x0e, 0x01, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x24, 0x22, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x24, 0x22, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37,
+  0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x03, 0x92,
+  0x06, 0x1f, 0x31, 0x2c, 0x3a, 0x36, 0x41, 0x44, 0x34, 0x3c, 0x2a, 0x2d,
+  0x2f, 0x2f, 0x2d, 0x2c, 0x3a, 0x37, 0x84, 0x34, 0x3d, 0x29, 0x30, 0x21,
+  0x05, 0xfe, 0xe4, 0x05, 0x23, 0x2e, 0x2c, 0x39, 0x37, 0x84, 0x35, 0x3c,
+  0x29, 0x2d, 0x30, 0x30, 0x2d, 0x2c, 0x39, 0x37, 0x41, 0x44, 0x34, 0x3c,
+  0x29, 0x31, 0x20, 0x06, 0x02, 0x73, 0x4a, 0x1f, 0x21, 0x1a, 0x1a, 0x1b,
+  0x1b, 0x1a, 0x1a, 0x21, 0x1f, 0x4a, 0x20, 0x20, 0x1a, 0x1a, 0x1b, 0x1b,
+  0x1a, 0x1a, 0x20, 0xfc, 0x5e, 0x4a, 0x1f, 0x25, 0x16, 0x1a, 0x1b, 0x1c,
+  0x19, 0x1a, 0x21, 0x1f, 0x4a, 0x20, 0x20, 0x1a, 0x1a, 0x1b, 0x1d, 0x18,
+  0x1a, 0x20, 0x03, 0x35, 0x1f, 0x5b, 0x35, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
+  0x2e, 0x32, 0x7f, 0x49, 0x46, 0x7f, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
+  0x2e, 0x34, 0x60, 0x18, 0x1d, 0x5d, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
+  0x2e, 0x32, 0x7f, 0x46, 0x49, 0x7f, 0x32, 0x31, 0x1b, 0x1a, 0x1a, 0x1e,
+  0x2e, 0x35, 0x5b, 0x1f, 0x7f, 0x0f, 0x10, 0x1c, 0x1f, 0x46, 0x29, 0x28,
+  0x47, 0x1e, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29,
+  0x46, 0x1f, 0x1c, 0x10, 0x0f, 0x0f, 0x12, 0x1a, 0x1f, 0x46, 0x29, 0x28,
+  0x4a, 0x1b, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29,
+  0x4b, 0x1a, 0x1c, 0x10, 0x00, 0x02, 0x00, 0xbd, 0x01, 0xe6, 0x05, 0x73,
+  0x04, 0x52, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x35, 0x25, 0x07,
+  0x15, 0x17, 0x01, 0x25, 0x05, 0x11, 0x05, 0x25, 0x04, 0xec, 0xfd, 0x1e,
+  0xc6, 0xc6, 0xfe, 0xb3, 0x01, 0x4d, 0x03, 0x69, 0xfc, 0x97, 0xfe, 0xb3,
+  0x02, 0xd7, 0x8a, 0x65, 0x4d, 0xba, 0x4d, 0x01, 0x5e, 0x82, 0x78, 0xfe,
+  0x84, 0x78, 0x82, 0x00, 0x00, 0x02, 0x01, 0x85, 0x00, 0x56, 0x04, 0x83,
+  0x05, 0x96, 0x00, 0x15, 0x00, 0x29, 0x00, 0x00, 0x01, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x35, 0x37, 0x35, 0x23, 0x15, 0x17, 0x15, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x1f, 0x02, 0x23, 0x03, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x27, 0x35, 0x21, 0x15, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x03, 0x1b, 0x55, 0x6a, 0x49, 0x21, 0x46, 0x34, 0xb4, 0x34, 0x46,
+  0x20, 0x4a, 0x6a, 0x56, 0x92, 0xf8, 0x94, 0x6e, 0x57, 0x4c, 0x27, 0x4f,
+  0x02, 0x06, 0x4f, 0x28, 0x4b, 0x58, 0x6f, 0x01, 0x11, 0xb4, 0xdf, 0x34,
+  0x62, 0x5c, 0x29, 0x31, 0xa2, 0x25, 0x3d, 0x3d, 0x25, 0xa2, 0x31, 0x29,
+  0x5c, 0x62, 0x34, 0xdf, 0xb4, 0xbb, 0x01, 0x3a, 0xea, 0x60, 0xbe, 0x5c,
+  0x4b, 0x19, 0x44, 0xfa, 0xfa, 0x44, 0x19, 0x4b, 0x5c, 0xbe, 0x60, 0xea,
+  0x00, 0x02, 0x00, 0x9d, 0xfe, 0xff, 0x04, 0xa9, 0x05, 0xda, 0x00, 0x07,
+  0x00, 0x15, 0x00, 0x00, 0x00, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20, 0x36,
+  0x05, 0x26, 0x10, 0x00, 0x20, 0x00, 0x10, 0x07, 0x06, 0x07, 0x11, 0x23,
+  0x11, 0x26, 0x04, 0x06, 0xd2, 0xfe, 0xdb, 0xcf, 0xcf, 0x01, 0x25, 0xd2,
+  0xfd, 0x30, 0x98, 0x01, 0x2e, 0x01, 0xab, 0x01, 0x31, 0x98, 0x7a, 0xa2,
+  0xa2, 0xa3, 0x04, 0x43, 0xe4, 0xe4, 0xfe, 0xb9, 0xd8, 0xd8, 0xe8, 0x9d,
+  0x01, 0xdd, 0x01, 0x4c, 0xfe, 0xb4, 0xfe, 0x22, 0x9c, 0x7e, 0x12, 0xfd,
+  0x7b, 0x02, 0x86, 0x11, 0x00, 0x01, 0x01, 0x36, 0xfe, 0xff, 0x04, 0xa8,
+  0x05, 0xda, 0x00, 0x1a, 0x00, 0x00, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35,
+  0x33, 0x11, 0x16, 0x33, 0x32, 0x36, 0x10, 0x26, 0x20, 0x07, 0x27, 0x36,
+  0x20, 0x00, 0x10, 0x07, 0x06, 0x07, 0x11, 0x33, 0x15, 0x02, 0xf5, 0xa3,
+  0xf5, 0xf5, 0x24, 0x2f, 0x91, 0xd0, 0xd0, 0xfe, 0xdb, 0x71, 0x6a, 0x98,
+  0x01, 0xab, 0x01, 0x2f, 0x97, 0x7b, 0xa1, 0xf4, 0xfe, 0xff, 0x01, 0x01,
+  0x7c, 0x01, 0xb2, 0x07, 0xd8, 0x01, 0x47, 0xe4, 0x6a, 0x74, 0xa6, 0xfe,
+  0xb4, 0xfe, 0x20, 0x9a, 0x7e, 0x12, 0xfe, 0xf8, 0x7c, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x9e, 0xfe, 0xff, 0x04, 0xa8, 0x05, 0xda, 0x00, 0x13,
+  0x00, 0x17, 0x00, 0x00, 0x13, 0x09, 0x02, 0x11, 0x32, 0x33, 0x15, 0x22,
+  0x23, 0x11, 0x22, 0x23, 0x11, 0x22, 0x23, 0x35, 0x32, 0x33, 0x11, 0x37,
+  0x09, 0x02, 0x9e, 0x02, 0x05, 0x02, 0x05, 0xfe, 0x50, 0x7a, 0x7a, 0x7a,
+  0x7a, 0x51, 0x51, 0x7b, 0x7a, 0x7a, 0x7b, 0x4d, 0x01, 0x2b, 0xfe, 0xd5,
+  0xfe, 0xd5, 0x03, 0x9f, 0x02, 0x3b, 0xfd, 0xc5, 0xfd, 0xe9, 0xfe, 0xf4,
+  0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x0c, 0xa8, 0x01, 0x6f, 0x01,
+  0x4a, 0xfe, 0xb6, 0x00, 0x00, 0x01, 0x00, 0x9e, 0xfe, 0xff, 0x04, 0xa8,
+  0x05, 0xda, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x37, 0x17, 0x11, 0x33, 0x11,
+  0x37, 0x17, 0x01, 0x21, 0x15, 0x21, 0x13, 0x07, 0x27, 0x11, 0x33, 0x15,
+  0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x07, 0x27, 0x13, 0x21,
+  0x35, 0x21, 0x01, 0x00, 0x6f, 0xe4, 0xa1, 0xe3, 0x6f, 0xff, 0x00, 0x01,
+  0x62, 0xfe, 0xa4, 0xfa, 0x6e, 0xe4, 0xf5, 0xf5, 0xa2, 0xf5, 0xf5, 0xe4,
+  0x6e, 0xfa, 0xfe, 0xa4, 0x01, 0x62, 0x04, 0xf9, 0x7a, 0xfd, 0x01, 0x64,
+  0xfe, 0x9d, 0xfc, 0x7a, 0xfe, 0xe4, 0x7c, 0xfe, 0xeb, 0x7b, 0xfd, 0xfd,
+  0xae, 0x7c, 0xfe, 0xff, 0x01, 0x01, 0x7c, 0x02, 0x52, 0xfd, 0x7b, 0x01,
+  0x15, 0x7c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6c, 0xff, 0x0f, 0x05, 0xb2,
+  0x05, 0x25, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x00, 0x01, 0x15,
+  0x21, 0x09, 0x01, 0x21, 0x35, 0x21, 0x09, 0x01, 0x03, 0x11, 0x23, 0x11,
+  0x01, 0x33, 0x17, 0x37, 0x33, 0x15, 0x23, 0x09, 0x01, 0x23, 0x05, 0xb2,
+  0xfe, 0xf1, 0xfe, 0x6c, 0xfe, 0x6c, 0xfe, 0xf1, 0x01, 0x78, 0x01, 0x2b,
+  0x01, 0x2b, 0xd9, 0x9b, 0xfe, 0x9e, 0xea, 0xc1, 0xc1, 0xea, 0x80, 0xfe,
+  0xd5, 0xfe, 0xd5, 0x80, 0x01, 0x4a, 0x7c, 0xfe, 0x41, 0x01, 0xbf, 0x7c,
+  0xfe, 0xb6, 0x01, 0x4a, 0x03, 0xdb, 0xfd, 0xa6, 0x02, 0x5a, 0xfd, 0x74,
+  0xd5, 0xd5, 0x7c, 0xfe, 0xb6, 0x01, 0x4a, 0x00, 0x00, 0x02, 0x01, 0x66,
+  0xff, 0x2c, 0x04, 0x49, 0x05, 0xaf, 0x00, 0x07, 0x00, 0x1c, 0x00, 0x00,
+  0x24, 0x14, 0x16, 0x32, 0x36, 0x34, 0x26, 0x22, 0x02, 0x26, 0x10, 0x37,
+  0x36, 0x37, 0x11, 0x33, 0x11, 0x25, 0x17, 0x0d, 0x01, 0x07, 0x25, 0x11,
+  0x16, 0x17, 0x16, 0x10, 0x06, 0x01, 0xef, 0x69, 0x96, 0x69, 0x69, 0x96,
+  0x38, 0xba, 0x5e, 0x41, 0x53, 0x9b, 0x01, 0x08, 0x4d, 0xfe, 0xbd, 0x01,
+  0x43, 0x4d, 0xfe, 0xf8, 0x50, 0x3f, 0x5e, 0xba, 0xdd, 0xa6, 0x75, 0x75,
+  0xa6, 0x76, 0xfd, 0xd9, 0xce, 0x01, 0x23, 0x67, 0x47, 0x16, 0x03, 0xce,
+  0xfe, 0xce, 0xad, 0x94, 0xd1, 0xd2, 0x94, 0xae, 0xfe, 0xd2, 0x16, 0x45,
+  0x67, 0xfe, 0xdd, 0xce, 0x00, 0x01, 0x01, 0x23, 0xfe, 0xff, 0x03, 0xe9,
+  0x05, 0xda, 0x00, 0x1e, 0x00, 0x00, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35,
+  0x33, 0x11, 0x26, 0x27, 0x26, 0x35, 0x10, 0x25, 0x36, 0x37, 0x36, 0x17,
+  0x06, 0x07, 0x06, 0x15, 0x10, 0x17, 0x16, 0x17, 0x06, 0x27, 0x15, 0x33,
+  0x15, 0x02, 0xf4, 0xa2, 0xf5, 0xf5, 0x8c, 0x5c, 0x46, 0x01, 0x0b, 0x54,
+  0x9c, 0x41, 0x35, 0xb7, 0x58, 0x68, 0xe1, 0x4e, 0x4d, 0x43, 0x63, 0xf5,
+  0xfe, 0xff, 0x01, 0x01, 0x7c, 0x01, 0x33, 0x4c, 0x98, 0x75, 0xa1, 0x01,
+  0x2e, 0xb9, 0x3a, 0x10, 0x07, 0x17, 0x3b, 0x85, 0x9d, 0xc4, 0xfe, 0xcd,
+  0xa2, 0x38, 0x0f, 0x25, 0x13, 0xff, 0x7c, 0x00, 0x00, 0x03, 0x00, 0x4d,
+  0x00, 0x08, 0x05, 0xbb, 0x04, 0x6d, 0x00, 0x0f, 0x00, 0x1d, 0x00, 0x33,
+  0x00, 0x00, 0x13, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01,
+  0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x00, 0x20, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x1e, 0x01, 0x15,
+  0x11, 0x14, 0x06, 0x07, 0x06, 0x21, 0x20, 0x27, 0x2e, 0x01, 0x35, 0x11,
+  0x34, 0x36, 0x37, 0x36, 0x21, 0x20, 0xa7, 0x9a, 0xba, 0x02, 0x13, 0xb9,
+  0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x03, 0x41, 0xfd, 0xed,
+  0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x9a, 0x28, 0x67, 0x65,
+  0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65, 0x65,
+  0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x02, 0x1d, 0x93, 0x60, 0x56, 0x68, 0x68,
+  0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20, 0x02, 0x0b, 0x68, 0x56,
+  0x63, 0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x63, 0x56, 0x59, 0x39, 0x88,
+  0x51, 0xfe, 0xa2, 0x4e, 0x88, 0x39, 0x73, 0x73, 0x39, 0x88, 0x4e, 0x01,
+  0x5e, 0x51, 0x88, 0x39, 0x73, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x4d,
+  0x00, 0x08, 0x05, 0xbb, 0x05, 0xcb, 0x00, 0x0d, 0x00, 0x1d, 0x00, 0x2d,
+  0x00, 0x45, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x15, 0x14, 0x17, 0x16, 0x20,
+  0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x15,
+  0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x01, 0x1e, 0x01, 0x15, 0x19, 0x01, 0x14, 0x06, 0x07, 0x06,
+  0x21, 0x20, 0x27, 0x2e, 0x01, 0x35, 0x19, 0x01, 0x34, 0x36, 0x37, 0x36,
+  0x21, 0x20, 0x04, 0x0e, 0xfd, 0xed, 0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13,
+  0xb9, 0x9a, 0x9a, 0xfb, 0xe0, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x29,
+  0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x26, 0x9a, 0xba, 0x02, 0x13, 0xb9,
+  0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x04, 0x22, 0x67, 0x65,
+  0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65, 0x65,
+  0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x05, 0x67, 0x68, 0x56, 0x63, 0x60, 0x56,
+  0x68, 0x68, 0x56, 0x60, 0x63, 0x56, 0xfe, 0x7c, 0x93, 0x60, 0x56, 0x68,
+  0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20, 0xfe, 0xc1, 0x93,
+  0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20,
+  0x03, 0x5a, 0x39, 0x88, 0x51, 0xfe, 0xa2, 0xfe, 0xa2, 0x4e, 0x88, 0x39,
+  0x73, 0x73, 0x39, 0x88, 0x4e, 0x01, 0x5e, 0x01, 0x5e, 0x51, 0x88, 0x39,
+  0x73, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x4d, 0x00, 0x08, 0x05, 0xbb,
+  0x04, 0x6d, 0x00, 0x0b, 0x00, 0x21, 0x00, 0x31, 0x00, 0x3f, 0x00, 0x55,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16,
+  0x21, 0x20, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x03, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01, 0x06, 0x07,
+  0x06, 0x20, 0x27, 0x26, 0x00, 0x20, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x37, 0x1e, 0x01, 0x15, 0x11, 0x14,
+  0x06, 0x07, 0x06, 0x21, 0x20, 0x27, 0x2e, 0x01, 0x35, 0x11, 0x34, 0x36,
+  0x37, 0x36, 0x21, 0x20, 0x04, 0xec, 0x1c, 0x32, 0xa6, 0xf4, 0xf6, 0xa3,
+  0x35, 0x1b, 0xd4, 0x01, 0x15, 0x01, 0x13, 0xfd, 0xf9, 0x01, 0xea, 0xa4,
+  0x34, 0x1c, 0x19, 0x02, 0x17, 0x1c, 0x34, 0xa6, 0xfe, 0x16, 0xa3, 0x35,
+  0x1b, 0x1b, 0x01, 0x01, 0x19, 0x1c, 0x34, 0xc4, 0x9a, 0xba, 0x02, 0x13,
+  0xb9, 0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x03, 0x41, 0xfd,
+  0xed, 0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x9a, 0x28, 0x67,
+  0x65, 0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65,
+  0x65, 0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x01, 0x64, 0x1b, 0x1c, 0x5d, 0x5d,
+  0x1e, 0x1a, 0x63, 0x02, 0xa3, 0x5d, 0x1d, 0x1c, 0x19, 0x0e, 0x0e, 0x16,
+  0x1c, 0x1d, 0x5d, 0x5d, 0x1e, 0x1b, 0x18, 0x0c, 0x0f, 0x18, 0x1c, 0x1d,
+  0xfe, 0xd5, 0x93, 0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c,
+  0x78, 0x78, 0x20, 0x02, 0x0b, 0x68, 0x56, 0x63, 0x60, 0x56, 0x68, 0x68,
+  0x56, 0x60, 0x63, 0x56, 0x59, 0x39, 0x88, 0x51, 0xfe, 0xa2, 0x4e, 0x88,
+  0x39, 0x73, 0x73, 0x39, 0x88, 0x4e, 0x01, 0x5e, 0x51, 0x88, 0x39, 0x73,
+  0x00, 0x07, 0x00, 0x4d, 0x00, 0x08, 0x05, 0xbb, 0x05, 0xcb, 0x00, 0x15,
+  0x00, 0x21, 0x00, 0x2d, 0x00, 0x3b, 0x00, 0x4b, 0x00, 0x5b, 0x00, 0x73,
+  0x00, 0x00, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16, 0x21, 0x20,
+  0x17, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16, 0x21, 0x20,
+  0x02, 0x20, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x01, 0x15, 0x14, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3d, 0x01,
+  0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x15, 0x14, 0x17, 0x16, 0x20,
+  0x37, 0x36, 0x3d, 0x01, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x01, 0x1e,
+  0x01, 0x15, 0x19, 0x01, 0x14, 0x06, 0x07, 0x06, 0x21, 0x20, 0x27, 0x2e,
+  0x01, 0x35, 0x19, 0x01, 0x34, 0x36, 0x37, 0x36, 0x21, 0x20, 0x02, 0x10,
+  0x01, 0xea, 0xa4, 0x34, 0x1c, 0x19, 0x02, 0x17, 0x1c, 0x34, 0xa6, 0xfe,
+  0x16, 0xa3, 0x35, 0x1b, 0x1b, 0x01, 0x01, 0x19, 0x1c, 0x34, 0x03, 0x81,
+  0x1c, 0x32, 0xa6, 0xf4, 0xf6, 0xa3, 0x35, 0x1b, 0xd4, 0x01, 0x15, 0x01,
+  0x13, 0xd5, 0x1c, 0x32, 0xa6, 0xf4, 0xf6, 0xa3, 0x35, 0x1b, 0xd4, 0x01,
+  0x15, 0x01, 0x13, 0x09, 0xfd, 0xed, 0xba, 0x9a, 0x9a, 0xba, 0x02, 0x13,
+  0xb9, 0x9a, 0x9a, 0xfb, 0xe0, 0x9a, 0xba, 0x02, 0x13, 0xb9, 0x9a, 0x29,
+  0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x26, 0x9a, 0xba, 0x02, 0x13, 0xb9,
+  0x9a, 0x29, 0x33, 0xd8, 0xfd, 0xae, 0xd5, 0x39, 0x04, 0x22, 0x67, 0x65,
+  0x65, 0x65, 0xcf, 0xfe, 0xe2, 0xfe, 0xe6, 0xd0, 0x68, 0x65, 0x65, 0x65,
+  0xcf, 0x01, 0x1e, 0x01, 0x1a, 0x05, 0x03, 0x5d, 0x1d, 0x1c, 0x19, 0x0e,
+  0x0e, 0x16, 0x1c, 0x1d, 0x5d, 0x5d, 0x1e, 0x1b, 0x18, 0x0c, 0x0f, 0x18,
+  0x1c, 0x1d, 0xfe, 0x1c, 0x1b, 0x1c, 0x5d, 0x5d, 0x1e, 0x1a, 0x63, 0xfc,
+  0x1b, 0x1c, 0x5d, 0x5d, 0x1e, 0x1a, 0x63, 0x04, 0x65, 0x68, 0x56, 0x63,
+  0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x63, 0x56, 0xfe, 0x7c, 0x93, 0x60,
+  0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78, 0x78, 0x20, 0xfe,
+  0xc1, 0x93, 0x60, 0x56, 0x68, 0x68, 0x56, 0x60, 0x92, 0x22, 0x1c, 0x78,
+  0x78, 0x20, 0x03, 0x5a, 0x39, 0x88, 0x51, 0xfe, 0xa2, 0xfe, 0xa2, 0x4e,
+  0x88, 0x39, 0x73, 0x73, 0x39, 0x88, 0x4e, 0x01, 0x5e, 0x01, 0x5e, 0x51,
+  0x88, 0x39, 0x73, 0x00, 0x00, 0x03, 0x00, 0x9d, 0xff, 0xe3, 0x04, 0xa9,
+  0x06, 0xbe, 0x00, 0x0b, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x13, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x00, 0x23, 0x22, 0x00, 0x10, 0x37, 0x36, 0x37,
+  0x0b, 0x01, 0x35, 0x09, 0x01, 0x15, 0x0b, 0x01, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x02, 0xa3, 0x3a, 0x57, 0x55,
+  0x3c, 0x3f, 0x52, 0x55, 0x15, 0xa3, 0x79, 0x98, 0xfe, 0xd2, 0xd7, 0xd4,
+  0xfe, 0xcf, 0x98, 0x7a, 0xa2, 0x01, 0xed, 0x01, 0x3f, 0x01, 0x3f, 0xee,
+  0x51, 0x94, 0xcf, 0xcf, 0x94, 0x91, 0xd2, 0xd2, 0x01, 0x7d, 0x5b, 0x44,
+  0x3e, 0x58, 0x55, 0x41, 0x42, 0x5d, 0x02, 0xbb, 0x11, 0x7e, 0x9d, 0xee,
+  0xef, 0xfe, 0xb4, 0x01, 0x4c, 0x01, 0xde, 0x9c, 0x7e, 0x12, 0x01, 0x67,
+  0xfe, 0xfa, 0xc7, 0x01, 0x5d, 0xfe, 0xa3, 0xc7, 0x01, 0x05, 0xfa, 0xf7,
+  0xe4, 0xa4, 0xa3, 0xd8, 0xd8, 0xa3, 0xa4, 0xe4, 0x00, 0x03, 0x00, 0x13,
+  0x01, 0x85, 0x05, 0xc8, 0x05, 0x14, 0x00, 0x50, 0x00, 0x6a, 0x00, 0x85,
+  0x00, 0x00, 0x01, 0x27, 0x23, 0x22, 0x27, 0x26, 0x07, 0x06, 0x14, 0x07,
+  0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x1f, 0x01, 0x16, 0x33,
+  0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x26, 0x27, 0x26, 0x27, 0x26, 0x2f,
+  0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x3e, 0x01, 0x37, 0x36,
+  0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x0e, 0x01, 0x07, 0x06,
+  0x17, 0x16, 0x1f, 0x01, 0x21, 0x32, 0x17, 0x16, 0x17, 0x21, 0x17, 0x25,
+  0x16, 0x33, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x34, 0x27, 0x26, 0x27,
+  0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x14, 0x17, 0x1e,
+  0x01, 0x01, 0x26, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x14, 0x17,
+  0x16, 0x17, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x34,
+  0x27, 0x26, 0x27, 0x26, 0x03, 0x6c, 0xc1, 0x67, 0x9d, 0x19, 0x26, 0x03,
+  0x01, 0x09, 0x0b, 0x2c, 0x20, 0x19, 0x27, 0x20, 0x21, 0x20, 0x17, 0x13,
+  0x15, 0x10, 0x0b, 0x0b, 0x2c, 0x20, 0x1a, 0x26, 0x1f, 0x09, 0x50, 0x58,
+  0x51, 0x21, 0x0d, 0x13, 0x22, 0x02, 0x03, 0x06, 0x0c, 0x0b, 0x14, 0x46,
+  0x4b, 0x2d, 0x2c, 0x17, 0x19, 0x0e, 0x11, 0x0b, 0x0c, 0x2f, 0x1c, 0x20,
+  0x41, 0x40, 0x18, 0x1c, 0x0c, 0x10, 0x0b, 0x08, 0x1b, 0x03, 0x04, 0x1e,
+  0x25, 0x62, 0x4a, 0x01, 0x64, 0xd0, 0x47, 0x5b, 0x10, 0xfd, 0xa5, 0xbf,
+  0xfc, 0x72, 0x13, 0x12, 0x16, 0x0e, 0x13, 0x1a, 0x05, 0x04, 0x0b, 0x08,
+  0x0e, 0x0f, 0x28, 0x0f, 0x12, 0x12, 0x13, 0x17, 0x07, 0x05, 0x0c, 0x08,
+  0x1c, 0x01, 0x11, 0x10, 0x15, 0x19, 0x0b, 0x13, 0x1b, 0x03, 0x05, 0x0b,
+  0x09, 0x0e, 0x0d, 0x27, 0x12, 0x14, 0x10, 0x13, 0x19, 0x04, 0x06, 0x0c,
+  0x09, 0x0d, 0x0a, 0x01, 0x85, 0xcd, 0x06, 0x08, 0x0d, 0x08, 0x29, 0x17,
+  0x20, 0x2e, 0x0d, 0x0b, 0x0f, 0x0e, 0x19, 0x15, 0x24, 0x1d, 0x4a, 0x1e,
+  0x20, 0x2e, 0x0d, 0x0b, 0x03, 0x25, 0x27, 0x03, 0x05, 0x1c, 0x07, 0x08,
+  0x2e, 0x13, 0x13, 0x13, 0x44, 0x22, 0x14, 0x14, 0x18, 0x1b, 0x1e, 0x26,
+  0x42, 0x1d, 0x20, 0x31, 0x0a, 0x0b, 0x1e, 0x18, 0x1e, 0x1c, 0x24, 0x43,
+  0x1e, 0x17, 0x1d, 0x07, 0x0d, 0x16, 0x1a, 0x6d, 0x52, 0x20, 0x29, 0x4b,
+  0xcf, 0x79, 0x09, 0x05, 0x07, 0x18, 0x10, 0x11, 0x1f, 0x17, 0x12, 0x0d,
+  0x10, 0x10, 0x06, 0x06, 0x17, 0x11, 0x11, 0x20, 0x16, 0x12, 0x1c, 0x02,
+  0xb5, 0x09, 0x05, 0x07, 0x19, 0x0f, 0x11, 0x21, 0x15, 0x12, 0x0e, 0x0d,
+  0x12, 0x05, 0x07, 0x19, 0x0e, 0x12, 0x20, 0x16, 0x12, 0x0e, 0x09, 0x00,
+  0x00, 0x03, 0x00, 0x4d, 0x01, 0x21, 0x05, 0xa5, 0x04, 0xb5, 0x00, 0x15,
+  0x00, 0x64, 0x00, 0x7a, 0x00, 0x00, 0x12, 0x32, 0x36, 0x37, 0x3e, 0x01,
+  0x35, 0x34, 0x26, 0x27, 0x2e, 0x01, 0x22, 0x06, 0x07, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x17, 0x16, 0x01, 0x05, 0x06, 0x23, 0x22, 0x27, 0x25, 0x07,
+  0x0e, 0x01, 0x15, 0x14, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x3b, 0x01, 0x32, 0x37, 0x3e, 0x02, 0x34, 0x2e, 0x01, 0x27, 0x26,
+  0x2b, 0x01, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06,
+  0x15, 0x14, 0x16, 0x1f, 0x01, 0x25, 0x36, 0x33, 0x32, 0x17, 0x24, 0x22,
+  0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x1e, 0x01, 0x32, 0x36,
+  0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0xe4, 0x29, 0x22, 0x0f,
+  0x0f, 0x0e, 0x0e, 0x0f, 0x0f, 0x22, 0x29, 0x22, 0x0f, 0x0f, 0x0f, 0x0f,
+  0x0f, 0x0f, 0x02, 0xb4, 0x02, 0x2e, 0x27, 0x62, 0x49, 0xc5, 0xfe, 0xb5,
+  0x5f, 0x87, 0x48, 0x0f, 0x19, 0x19, 0x14, 0x24, 0x1d, 0x47, 0x1d, 0x1f,
+  0x19, 0x18, 0x1b, 0x1a, 0x19, 0x14, 0x24, 0x1d, 0x09, 0x57, 0x4d, 0x5c,
+  0x18, 0x22, 0x16, 0x16, 0x22, 0x18, 0x58, 0x51, 0x30, 0x30, 0x1d, 0x24,
+  0x14, 0x19, 0x1a, 0x1b, 0x18, 0x19, 0x1f, 0x1d, 0x47, 0x1d, 0x24, 0x14,
+  0x19, 0x19, 0x0f, 0x48, 0x87, 0x5f, 0x01, 0x4b, 0xc5, 0x49, 0x62, 0x27,
+  0xfb, 0x69, 0x29, 0x22, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x22, 0x29,
+  0x22, 0x0f, 0x0f, 0x0e, 0x0e, 0x0f, 0x0f, 0x01, 0x71, 0x0e, 0x0d, 0x0e,
+  0x1f, 0x13, 0x12, 0x1f, 0x0e, 0x0d, 0x0e, 0x0e, 0x0d, 0x0e, 0x1f, 0x12,
+  0x13, 0x1f, 0x0e, 0x0d, 0x01, 0x6c, 0xfc, 0x3f, 0x57, 0x92, 0x2c, 0x3e,
+  0x0e, 0x0e, 0x08, 0x26, 0x19, 0x23, 0x3c, 0x1a, 0x15, 0x10, 0x0d, 0x0d,
+  0x0e, 0x17, 0x15, 0x41, 0x23, 0x22, 0x3c, 0x1a, 0x15, 0x10, 0x0d, 0x22,
+  0x09, 0x1a, 0x28, 0x10, 0x28, 0x1a, 0x09, 0x22, 0x0d, 0x10, 0x15, 0x1a,
+  0x3c, 0x22, 0x23, 0x41, 0x15, 0x17, 0x0e, 0x0d, 0x0d, 0x10, 0x15, 0x1a,
+  0x3c, 0x23, 0x19, 0x26, 0x08, 0x0e, 0x0e, 0x3e, 0x2c, 0x92, 0x57, 0x3f,
+  0x7e, 0x0e, 0x0d, 0x0e, 0x1f, 0x13, 0x12, 0x1f, 0x0e, 0x0d, 0x0e, 0x0e,
+  0x0d, 0x0e, 0x1f, 0x12, 0x13, 0x1f, 0x0e, 0x0d, 0x00, 0x03, 0x00, 0x13,
+  0x00, 0xc0, 0x05, 0xc8, 0x04, 0x4f, 0x00, 0x4f, 0x00, 0x6a, 0x00, 0x85,
+  0x00, 0x00, 0x01, 0x33, 0x07, 0x21, 0x06, 0x07, 0x06, 0x23, 0x21, 0x07,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x0e, 0x01, 0x22, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x27, 0x2e, 0x01,
+  0x27, 0x26, 0x23, 0x22, 0x0f, 0x01, 0x06, 0x23, 0x22, 0x27, 0x2e, 0x01,
+  0x27, 0x26, 0x34, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x17, 0x1e,
+  0x01, 0x17, 0x16, 0x14, 0x17, 0x16, 0x37, 0x36, 0x3b, 0x01, 0x25, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x33, 0x32,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x23,
+  0x22, 0x13, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x2e, 0x01, 0x27,
+  0x26, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x1e, 0x01,
+  0x17, 0x16, 0x33, 0x32, 0x03, 0x6c, 0xc0, 0xbf, 0x02, 0x5b, 0x10, 0x5b,
+  0x47, 0xd0, 0xfe, 0x9c, 0x4a, 0x5a, 0x2d, 0x1a, 0x1e, 0x08, 0x0b, 0x10,
+  0x0c, 0x1c, 0x18, 0x40, 0x41, 0x20, 0x1c, 0x32, 0x09, 0x0b, 0x11, 0x0b,
+  0x1c, 0x17, 0x08, 0x51, 0x4b, 0x46, 0x14, 0x0b, 0x0c, 0x06, 0x03, 0x02,
+  0x1a, 0x1b, 0x08, 0x26, 0x51, 0x58, 0x2c, 0x2d, 0x1f, 0x27, 0x19, 0x20,
+  0x2c, 0x0b, 0x0b, 0x10, 0x10, 0x2f, 0x20, 0x21, 0x20, 0x27, 0x19, 0x20,
+  0x2c, 0x0b, 0x09, 0x01, 0x06, 0x23, 0x16, 0xa0, 0x67, 0xfd, 0xf3, 0x12,
+  0x0e, 0x08, 0x0e, 0x0c, 0x05, 0x07, 0x14, 0x16, 0x0f, 0x15, 0x13, 0x25,
+  0x0e, 0x0e, 0x08, 0x0c, 0x05, 0x07, 0x13, 0x18, 0x0f, 0x15, 0x12, 0xec,
+  0x13, 0x0e, 0x08, 0x0e, 0x0c, 0x06, 0x06, 0x19, 0x11, 0x10, 0x14, 0x13,
+  0x26, 0x0d, 0x0e, 0x09, 0x0b, 0x05, 0x06, 0x1b, 0x10, 0x12, 0x12, 0x0d,
+  0x04, 0x4f, 0xcf, 0x4b, 0x29, 0x20, 0x52, 0x64, 0x23, 0x14, 0x0f, 0x06,
+  0x1e, 0x17, 0x21, 0x3e, 0x26, 0x1c, 0x1e, 0x18, 0x1e, 0x0b, 0x0a, 0x33,
+  0x1e, 0x22, 0x39, 0x2a, 0x1b, 0x1e, 0x18, 0x04, 0x24, 0x22, 0x44, 0x13,
+  0x13, 0x13, 0x2e, 0x08, 0x07, 0x16, 0x0b, 0x03, 0x27, 0x14, 0x14, 0x0b,
+  0x0e, 0x2d, 0x20, 0x20, 0x44, 0x21, 0x20, 0x32, 0x0e, 0x0f, 0x0b, 0x0d,
+  0x2e, 0x20, 0x17, 0x2c, 0x05, 0x0e, 0x09, 0x06, 0x54, 0x08, 0x0e, 0x08,
+  0x18, 0x13, 0x25, 0x0f, 0x11, 0x15, 0x08, 0x06, 0x12, 0x0e, 0x0d, 0x12,
+  0x16, 0x23, 0x0e, 0x12, 0x15, 0x08, 0x05, 0xfd, 0x3a, 0x09, 0x0d, 0x08,
+  0x18, 0x13, 0x26, 0x0f, 0x10, 0x19, 0x05, 0x05, 0x12, 0x0d, 0x0e, 0x12,
+  0x13, 0x28, 0x0c, 0x11, 0x19, 0x05, 0x05, 0x00, 0x00, 0x09, 0x00, 0x41,
+  0x00, 0xf4, 0x05, 0xf0, 0x04, 0xe8, 0x00, 0x5a, 0x00, 0x78, 0x00, 0x96,
+  0x00, 0xb4, 0x00, 0xd2, 0x00, 0xfe, 0x01, 0x2d, 0x01, 0x34, 0x01, 0x48,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x26, 0x2b, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x16, 0x1f, 0x01, 0x25, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x0d, 0x01, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x25,
+  0x07, 0x06, 0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x37, 0x36, 0x02, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x12, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x12, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x05, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x37, 0x36, 0x03, 0x2d, 0x01, 0x26, 0x23, 0x22, 0x07,
+  0x05, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x07,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x25, 0x05, 0x16, 0x33, 0x32, 0x37, 0x25, 0x26,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x02, 0x0e, 0x0a, 0x07, 0x07,
+  0x0a, 0x08, 0x16, 0x49, 0x53, 0x3c, 0x29, 0x28, 0x21, 0x24, 0x1f, 0x11,
+  0x10, 0x10, 0x0e, 0x24, 0x19, 0x2a, 0x26, 0x2b, 0x29, 0x28, 0x27, 0x1e,
+  0x24, 0x0c, 0x10, 0x05, 0x2a, 0x80, 0x4f, 0x01, 0x3a, 0xcc, 0x52, 0x7b,
+  0x33, 0x07, 0x1b, 0xfe, 0x35, 0x01, 0xcb, 0x1b, 0x07, 0x36, 0x78, 0x52,
+  0xcc, 0xfe, 0xc6, 0x4f, 0x80, 0x2a, 0x05, 0x10, 0x11, 0x1f, 0x20, 0x25,
+  0x2b, 0x26, 0x2e, 0x23, 0x25, 0x1f, 0x25, 0x0c, 0x10, 0x10, 0x0e, 0x22,
+  0x19, 0x2c, 0x26, 0x2b, 0x3c, 0x4a, 0x52, 0x15, 0xfa, 0x19, 0x0a, 0x0b,
+  0x08, 0x09, 0x03, 0x03, 0x03, 0x03, 0x09, 0x08, 0x0b, 0x0a, 0x19, 0x0a,
+  0x0a, 0x09, 0x08, 0x03, 0x03, 0x03, 0x03, 0x08, 0x09, 0x0a, 0x0a, 0x19,
+  0x0a, 0x0b, 0x08, 0x09, 0x03, 0x03, 0x03, 0x03, 0x09, 0x08, 0x0b, 0x0a,
+  0x19, 0x0a, 0x0a, 0x09, 0x08, 0x03, 0x03, 0x03, 0x03, 0x08, 0x09, 0x0a,
+  0x2d, 0x2d, 0x13, 0x12, 0x10, 0x11, 0x08, 0x08, 0x08, 0x08, 0x11, 0x10,
+  0x12, 0x13, 0x2d, 0x13, 0x13, 0x10, 0x11, 0x08, 0x08, 0x08, 0x08, 0x11,
+  0x10, 0x13, 0x13, 0x2d, 0x13, 0x12, 0x10, 0x11, 0x08, 0x08, 0x08, 0x08,
+  0x11, 0x10, 0x12, 0x13, 0x2d, 0x13, 0x13, 0x10, 0x11, 0x08, 0x08, 0x08,
+  0x08, 0x11, 0x10, 0x13, 0x01, 0x5f, 0x21, 0x86, 0x23, 0x14, 0x0a, 0x0e,
+  0x0a, 0x05, 0x0c, 0x0b, 0x19, 0x12, 0x22, 0x1c, 0x42, 0x1c, 0x1d, 0x18,
+  0x16, 0x0e, 0x0b, 0x0b, 0x0c, 0x18, 0x12, 0x23, 0x1c, 0x21, 0x3c, 0x53,
+  0x5a, 0x1b, 0x10, 0x15, 0x06, 0x20, 0x19, 0xaa, 0x01, 0xbc, 0x02, 0x22,
+  0x26, 0x54, 0x47, 0xc3, 0xfe, 0xb6, 0x86, 0x10, 0x0f, 0x15, 0x12, 0x19,
+  0x5e, 0x4f, 0x3c, 0x21, 0x1c, 0x23, 0x12, 0x18, 0x0c, 0x0b, 0x0b, 0x0e,
+  0x16, 0x18, 0x1d, 0x1c, 0x42, 0x1c, 0x22, 0x12, 0x19, 0x0b, 0x0c, 0x05,
+  0x0a, 0x0e, 0x0b, 0x01, 0x6b, 0x01, 0x02, 0xc3, 0x47, 0x54, 0x26, 0xfe,
+  0x14, 0xc4, 0x04, 0x06, 0x08, 0x08, 0x14, 0x08, 0x08, 0x05, 0x05, 0x05,
+  0x05, 0x08, 0x08, 0x14, 0x08, 0x08, 0x06, 0x02, 0xd9, 0x08, 0x0d, 0x0e,
+  0x07, 0x06, 0x0a, 0x20, 0x10, 0x0d, 0x22, 0x1c, 0x29, 0x26, 0x60, 0x26,
+  0x22, 0x27, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1f, 0x24, 0x22, 0x2f, 0x27,
+  0x1d, 0x12, 0x09, 0x3c, 0x25, 0x8b, 0x5a, 0x53, 0x0d, 0x11, 0x1f, 0x0c,
+  0xcf, 0xcf, 0x0c, 0x25, 0x0d, 0x0b, 0x53, 0x5a, 0x8b, 0x25, 0x3c, 0x09,
+  0x18, 0x17, 0x2f, 0x27, 0x2a, 0x1d, 0x20, 0x0e, 0x10, 0x10, 0x11, 0x1c,
+  0x22, 0x25, 0x35, 0x22, 0x2d, 0x28, 0x24, 0x23, 0x1b, 0x13, 0x10, 0x20,
+  0x09, 0xfe, 0xd2, 0x04, 0x05, 0x08, 0x07, 0x07, 0x04, 0x08, 0x07, 0x05,
+  0x06, 0x08, 0x07, 0x05, 0x04, 0x04, 0x05, 0x08, 0x07, 0x07, 0x04, 0x07,
+  0x08, 0x05, 0x06, 0x08, 0x07, 0x05, 0x02, 0x3b, 0x04, 0x05, 0x08, 0x07,
+  0x07, 0x04, 0x07, 0x08, 0x05, 0x06, 0x08, 0x07, 0x05, 0x04, 0x04, 0x05,
+  0x08, 0x07, 0x07, 0x04, 0x08, 0x07, 0x05, 0x06, 0x08, 0x07, 0x05, 0xfd,
+  0x82, 0x07, 0x08, 0x0e, 0x10, 0x11, 0x12, 0x16, 0x15, 0x12, 0x11, 0x10,
+  0x0e, 0x08, 0x07, 0x07, 0x08, 0x0e, 0x10, 0x11, 0x12, 0x15, 0x16, 0x12,
+  0x11, 0x10, 0x0e, 0x08, 0x02, 0x38, 0x07, 0x08, 0x0e, 0x10, 0x11, 0x12,
+  0x15, 0x16, 0x12, 0x11, 0x10, 0x0e, 0x08, 0x07, 0x07, 0x08, 0x0e, 0x10,
+  0x11, 0x12, 0x16, 0x15, 0x12, 0x11, 0x10, 0x0e, 0x08, 0x5c, 0x0f, 0x3d,
+  0x07, 0x04, 0x06, 0x08, 0x0e, 0x0a, 0x18, 0x0e, 0x17, 0x21, 0x1c, 0x1b,
+  0x19, 0x13, 0x10, 0x0c, 0x0c, 0x0e, 0x16, 0x13, 0x20, 0x1c, 0x21, 0x20,
+  0x1c, 0x1b, 0x19, 0x13, 0x10, 0x0c, 0x22, 0x0a, 0x0e, 0x11, 0x08, 0x18,
+  0x11, 0xfe, 0xf2, 0xc2, 0xf7, 0x2f, 0x56, 0x92, 0x43, 0x1e, 0x1e, 0x0f,
+  0x0e, 0x0a, 0x22, 0x0c, 0x10, 0x13, 0x19, 0x1b, 0x1c, 0x20, 0x21, 0x1c,
+  0x20, 0x13, 0x16, 0x0e, 0x0c, 0x0c, 0x10, 0x13, 0x19, 0x1b, 0x1c, 0x21,
+  0x17, 0x0d, 0x19, 0x0a, 0x14, 0x02, 0x02, 0x5b, 0x75, 0x56, 0x2f, 0xe1,
+  0x2b, 0x16, 0x09, 0x09, 0x06, 0x05, 0x05, 0x06, 0x09, 0x09, 0x16, 0x09,
+  0x09, 0x06, 0x05, 0x05, 0x06, 0x09, 0x00, 0x00, 0x00, 0x03, 0x00, 0x4d,
+  0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x61, 0x00, 0x75, 0x00, 0x87,
+  0x00, 0x00, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17,
+  0x15, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06,
+  0x20, 0x27, 0x2e, 0x02, 0x35, 0x34, 0x36, 0x37, 0x26, 0x35, 0x34, 0x37,
+  0x12, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x07,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x16, 0x17,
+  0x16, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x36, 0x37, 0x36, 0x35, 0x34, 0x01, 0xde, 0x03, 0x0b, 0x13, 0x11, 0x12,
+  0x16, 0x64, 0x00, 0xff, 0x6d, 0x6c, 0x58, 0x5a, 0x57, 0x55, 0x5c, 0x56,
+  0x6e, 0x6c, 0x7c, 0x78, 0x70, 0x6b, 0x58, 0x5a, 0x58, 0x46, 0x27, 0x60,
+  0x67, 0x63, 0x6a, 0x61, 0x7f, 0x7e, 0x8c, 0x8b, 0x80, 0x78, 0x68, 0x65,
+  0x67, 0x63, 0x69, 0x63, 0x7d, 0x7f, 0xfe, 0xe6, 0x7c, 0x26, 0x3d, 0x21,
+  0x1d, 0x19, 0x03, 0x61, 0xa3, 0x98, 0x49, 0x05, 0x0f, 0x21, 0x1e, 0x08,
+  0x31, 0x26, 0x1c, 0x3d, 0x39, 0x0f, 0x10, 0x14, 0x1e, 0x30, 0x23, 0x10,
+  0x0f, 0x44, 0x15, 0x24, 0x2d, 0x17, 0x14, 0x03, 0x29, 0x05, 0x10, 0x01,
+  0x0a, 0x11, 0x18, 0x1f, 0x1d, 0x11, 0x03, 0x03, 0x18, 0x01, 0x75, 0x37,
+  0x14, 0x0f, 0x13, 0x0c, 0x1b, 0x09, 0x19, 0x09, 0x34, 0x0f, 0x1a, 0x1b,
+  0x01, 0x37, 0x06, 0x1e, 0x1b, 0x1c, 0x32, 0x12, 0x13, 0x0b, 0x33, 0x33,
+  0x31, 0x63, 0x64, 0xed, 0x88, 0x8d, 0xe8, 0x69, 0x60, 0x34, 0x33, 0x33,
+  0x31, 0x63, 0x64, 0xed, 0x8d, 0x87, 0xbc, 0x3e, 0x98, 0x6d, 0x01, 0x10,
+  0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x3b, 0x38, 0x72, 0x6f,
+  0xfe, 0xec, 0xa1, 0x98, 0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x12,
+  0x42, 0x56, 0x30, 0x2f, 0x4d, 0x1f, 0x10, 0x0f, 0xcd, 0xef, 0x01, 0x90,
+  0x08, 0x14, 0x38, 0x3a, 0x44, 0x40, 0x2a, 0x1f, 0x7c, 0x73, 0x61, 0x20,
+  0x16, 0x1b, 0x1e, 0x09, 0x2d, 0x46, 0x28, 0x1c, 0x37, 0x0c, 0x22, 0x2a,
+  0x3d, 0x38, 0x19, 0x26, 0x08, 0x15, 0x0f, 0x30, 0x21, 0x32, 0x1d, 0x1c,
+  0x01, 0x06, 0x04, 0x20, 0x16, 0x11, 0x0c, 0x31, 0x2d, 0x35, 0x24, 0x26,
+  0x0c, 0x0a, 0x12, 0x36, 0x3a, 0x42, 0x34, 0x00, 0x00, 0x06, 0x00, 0x4d,
+  0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x0d, 0x00, 0x1a, 0x00, 0x28,
+  0x00, 0x42, 0x00, 0x5c, 0x00, 0x77, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x27,
+  0x25, 0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x13, 0x26,
+  0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x13, 0x36, 0x33, 0x32, 0x17, 0x13,
+  0x05, 0x0e, 0x01, 0x07, 0x25, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35,
+  0x34, 0x26, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36,
+  0x37, 0x36, 0x37, 0x13, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14,
+  0x16, 0x17, 0x1e, 0x01, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x32, 0x17, 0x16, 0x17, 0x16, 0x12,
+  0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26,
+  0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x36, 0x01, 0x7e, 0x38, 0x23,
+  0x05, 0x01, 0x0c, 0x07, 0x22, 0x21, 0x1d, 0x2c, 0x12, 0x07, 0xdb, 0x21,
+  0x28, 0x27, 0x5e, 0x26, 0x29, 0x20, 0x3f, 0x2e, 0x31, 0x33, 0x2d, 0x7a,
+  0x01, 0x0c, 0x02, 0x25, 0x39, 0xfe, 0xb6, 0x0d, 0x0d, 0x2c, 0x1d, 0x20,
+  0x22, 0xfd, 0x38, 0x18, 0x18, 0x14, 0x13, 0x14, 0x14, 0x13, 0x14, 0x18,
+  0x18, 0x38, 0x17, 0x18, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x18, 0x33,
+  0x78, 0x70, 0x6b, 0x58, 0x5a, 0x58, 0x59, 0x59, 0x56, 0xda, 0xf6, 0x6d,
+  0x6c, 0x58, 0x5a, 0x57, 0x55, 0x5c, 0x56, 0x6e, 0x6c, 0x7c, 0x8b, 0x80,
+  0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x63, 0x7d, 0x7f, 0xfe, 0xea, 0x80,
+  0x79, 0x67, 0x65, 0x68, 0x63, 0x6a, 0x61, 0x7f, 0x7e, 0x01, 0x77, 0x49,
+  0x5f, 0x0f, 0xfd, 0x1e, 0x22, 0x32, 0x5b, 0x24, 0x20, 0x16, 0x09, 0x01,
+  0x01, 0xa3, 0x22, 0x14, 0x13, 0x13, 0x14, 0x22, 0x01, 0x83, 0x09, 0x09,
+  0xfe, 0x0b, 0xfd, 0x07, 0x67, 0x49, 0x83, 0x04, 0x06, 0x16, 0x20, 0x24,
+  0x5b, 0x32, 0x21, 0x76, 0x0b, 0x0c, 0x15, 0x17, 0x35, 0x1f, 0x1e, 0x35,
+  0x17, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x17, 0x35, 0x1e, 0x1f, 0x35,
+  0x17, 0x15, 0x0c, 0x02, 0x15, 0x33, 0x31, 0x63, 0x64, 0xed, 0x8d, 0x85,
+  0xf1, 0x63, 0x61, 0x66, 0x33, 0x31, 0x63, 0x64, 0xed, 0x88, 0x8d, 0xe8,
+  0x69, 0x60, 0x34, 0x33, 0x64, 0x3b, 0x38, 0x72, 0x6f, 0xfe, 0xec, 0xa1,
+  0x98, 0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x38, 0x72, 0x6f, 0x01,
+  0x14, 0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x6c, 0x00, 0x2c, 0x05, 0xa1, 0x05, 0xaa, 0x00, 0x2d,
+  0x00, 0x00, 0x13, 0x35, 0x37, 0x27, 0x33, 0x17, 0x36, 0x25, 0x02, 0x03,
+  0x33, 0x17, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x17, 0x33, 0x32,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x07, 0x33, 0x15, 0x23, 0x07,
+  0x33, 0x15, 0x23, 0x07, 0x23, 0x12, 0x13, 0x24, 0x27, 0x07, 0x23, 0x37,
+  0x85, 0x21, 0x3a, 0x5a, 0x83, 0x84, 0x01, 0x01, 0x30, 0x99, 0x6e, 0x68,
+  0x85, 0x4d, 0x5a, 0x8a, 0x53, 0x88, 0xee, 0x3f, 0x2b, 0x1d, 0x1d, 0x2b,
+  0x3f, 0xee, 0x88, 0x53, 0x8a, 0x5a, 0x4d, 0x85, 0x68, 0x6e, 0x99, 0x30,
+  0xfe, 0xff, 0x84, 0x83, 0x5a, 0x3a, 0x02, 0xd7, 0x28, 0x05, 0xda, 0xc9,
+  0x0d, 0x0a, 0x01, 0x14, 0x01, 0x6a, 0x96, 0x50, 0x82, 0x50, 0xc6, 0x1a,
+  0x11, 0x2c, 0x11, 0x1a, 0xc6, 0x50, 0x82, 0x50, 0x96, 0x01, 0x60, 0x01,
+  0x1e, 0x0b, 0x0c, 0xc9, 0xda, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x76,
+  0x00, 0xdc, 0x05, 0x92, 0x04, 0xf9, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x22,
+  0x00, 0x29, 0x00, 0x2d, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x01, 0x11, 0x01,
+  0x16, 0x15, 0x14, 0x05, 0x01, 0x21, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x01, 0x11, 0x01, 0x26, 0x35, 0x34,
+  0x01, 0x11, 0x21, 0x11, 0x03, 0x91, 0x01, 0x8c, 0xfb, 0xcf, 0x01, 0x8c,
+  0x06, 0x07, 0x1a, 0x21, 0x1f, 0x4a, 0x20, 0x26, 0x14, 0x07, 0x2b, 0x01,
+  0x83, 0xfe, 0x7d, 0x02, 0xfe, 0xc3, 0xfe, 0x72, 0x04, 0x31, 0xfe, 0x72,
+  0x06, 0x06, 0x1a, 0x20, 0x20, 0x4a, 0x1f, 0x21, 0x1a, 0x06, 0x2c, 0xfe,
+  0x7e, 0x01, 0x82, 0x03, 0xfe, 0x27, 0x05, 0x1b, 0x03, 0x68, 0x01, 0x2c,
+  0xfe, 0xd4, 0x09, 0x08, 0x1c, 0x10, 0x0f, 0x0f, 0x13, 0x19, 0x09, 0xaa,
+  0xfe, 0xde, 0x02, 0x8d, 0xfe, 0xdd, 0x11, 0x12, 0x13, 0x6b, 0xfe, 0xd3,
+  0x01, 0x2d, 0x08, 0x07, 0x1c, 0x10, 0x0f, 0x0f, 0x10, 0x1c, 0x07, 0xaa,
+  0x01, 0x22, 0xfd, 0x73, 0x01, 0x21, 0x13, 0x13, 0x12, 0xfd, 0xdf, 0x04,
+  0x1d, 0xfb, 0xe3, 0x00, 0x00, 0x04, 0x01, 0x87, 0x00, 0x00, 0x04, 0x0a,
+  0x05, 0xef, 0x00, 0x50, 0x00, 0xd0, 0x00, 0xe3, 0x00, 0xf3, 0x00, 0x00,
+  0x01, 0x34, 0x37, 0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x33, 0x17, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x1f, 0x01, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x03, 0x14, 0x15, 0x14, 0x1f, 0x01,
+  0x16, 0x15, 0x14, 0x07, 0x17, 0x16, 0x07, 0x06, 0x1d, 0x01, 0x21, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x27, 0x26, 0x01, 0x26, 0x23,
+  0x22, 0x0f, 0x01, 0x14, 0x0f, 0x01, 0x06, 0x0f, 0x01, 0x27, 0x26, 0x2f,
+  0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x1f, 0x02, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
+  0x07, 0x06, 0x07, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x26, 0x27, 0x26, 0x27, 0x26, 0x3f, 0x01, 0x36, 0x27, 0x26,
+  0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x17, 0x16,
+  0x17, 0x16, 0x1f, 0x01, 0x16, 0x15, 0x07, 0x21, 0x27, 0x34, 0x37, 0x36,
+  0x3d, 0x01, 0x27, 0x36, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x35, 0x13,
+  0x34, 0x35, 0x34, 0x27, 0x01, 0x07, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x07,
+  0x06, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x2f, 0x01, 0x01, 0x88, 0x21, 0x15, 0x0f, 0x2f, 0x0c, 0x29, 0x01,
+  0x02, 0x04, 0x18, 0x24, 0x1b, 0x12, 0x1f, 0x15, 0x18, 0x20, 0x0f, 0x10,
+  0x2b, 0x0f, 0x43, 0x44, 0x22, 0x0d, 0x0d, 0x10, 0x06, 0x05, 0x09, 0x04,
+  0x0b, 0x05, 0x01, 0x01, 0x1c, 0x18, 0x25, 0x32, 0x1a, 0x0b, 0x01, 0x09,
+  0x01, 0x08, 0x02, 0x02, 0x03, 0x01, 0x03, 0x01, 0x14, 0x02, 0xfe, 0x15,
+  0x04, 0x09, 0x21, 0x2b, 0x18, 0x10, 0x02, 0x46, 0x03, 0x23, 0x20, 0x03,
+  0x05, 0x0a, 0x1f, 0x05, 0x13, 0x31, 0x16, 0x08, 0x27, 0x0f, 0x29, 0x44,
+  0x18, 0x12, 0x0f, 0x0d, 0x0f, 0x07, 0x07, 0x1b, 0x0b, 0x11, 0x56, 0x7a,
+  0x56, 0x54, 0x04, 0x12, 0x05, 0x03, 0x14, 0x10, 0x05, 0x03, 0x2b, 0x67,
+  0x2f, 0x06, 0x26, 0x1b, 0x11, 0x0b, 0x06, 0x05, 0x02, 0x07, 0x2c, 0x24,
+  0x0c, 0x07, 0x29, 0x2d, 0x01, 0x13, 0x0d, 0x01, 0x30, 0x15, 0x16, 0x30,
+  0x09, 0x02, 0x19, 0x70, 0x2a, 0x05, 0x07, 0x0c, 0x02, 0x06, 0x02, 0x07,
+  0x06, 0x0d, 0x1a, 0x24, 0x0c, 0x0e, 0x15, 0x10, 0x2c, 0x08, 0x03, 0x01,
+  0x09, 0x07, 0x03, 0x09, 0x53, 0x01, 0x01, 0x01, 0x80, 0x01, 0x0b, 0x0c,
+  0x02, 0x03, 0x08, 0x05, 0x0b, 0x02, 0xfe, 0x32, 0x10, 0x20, 0x34, 0x32,
+  0x0f, 0x03, 0x01, 0x10, 0x09, 0x0a, 0x03, 0x02, 0x0b, 0x04, 0x06, 0x61,
+  0x73, 0x0e, 0x02, 0x4a, 0x23, 0x0d, 0x0a, 0x0e, 0x08, 0x03, 0x0b, 0x07,
+  0x0a, 0x6c, 0x02, 0xeb, 0x37, 0x31, 0x07, 0x1f, 0x5d, 0x18, 0x17, 0x01,
+  0x01, 0x2f, 0x7e, 0x5b, 0x23, 0x3c, 0x24, 0x1c, 0x1b, 0x20, 0x05, 0x0c,
+  0x1a, 0x6f, 0xbb, 0x5f, 0x25, 0x15, 0x10, 0x40, 0x2c, 0x1f, 0x10, 0x86,
+  0x3a, 0x06, 0x0b, 0x0a, 0x06, 0x06, 0x24, 0x22, 0x1e, 0x3b, 0x1a, 0x12,
+  0x76, 0x52, 0x15, 0x12, 0xfe, 0xd4, 0x07, 0x09, 0x18, 0x1d, 0x16, 0x24,
+  0x58, 0x24, 0x2b, 0x7c, 0x19, 0x89, 0x13, 0x8d, 0x89, 0xb6, 0x12, 0x21,
+  0x35, 0x44, 0x58, 0x26, 0x50, 0x59, 0x3b, 0x02, 0xb6, 0x39, 0x44, 0x6f,
+  0x1e, 0x36, 0xc2, 0x1d, 0x06, 0x0f, 0x0b, 0x0d, 0x62, 0x27, 0x6e, 0x95,
+  0x32, 0x0f, 0x0c, 0x0b, 0x06, 0x0b, 0x1f, 0x38, 0x1a, 0x33, 0xfe, 0x65,
+  0x46, 0x5d, 0x0c, 0x08, 0x13, 0x04, 0x01, 0x14, 0x06, 0x07, 0x34, 0x54,
+  0x26, 0x03, 0x1f, 0x16, 0x0a, 0x07, 0x0c, 0x16, 0x26, 0x20, 0x12, 0x0c,
+  0x2f, 0x35, 0x30, 0x24, 0x3f, 0x2d, 0x20, 0x02, 0x31, 0x40, 0x1b, 0x11,
+  0x26, 0x11, 0x06, 0x05, 0x10, 0x09, 0x33, 0x6c, 0x0f, 0x0a, 0x17, 0x17,
+  0x4b, 0x0f, 0x0b, 0x0a, 0x05, 0x19, 0x03, 0x05, 0x0d, 0x43, 0x04, 0x22,
+  0x50, 0x31, 0x16, 0xd6, 0x09, 0x0b, 0x9f, 0xb7, 0x3a, 0x30, 0x33, 0x3c,
+  0x08, 0x44, 0x3a, 0x35, 0x58, 0x49, 0x2e, 0x29, 0x06, 0x07, 0x01, 0x44,
+  0x04, 0x07, 0x13, 0x26, 0xfe, 0x5b, 0x14, 0x2b, 0x2d, 0x31, 0x3a, 0x0d,
+  0x0c, 0x11, 0x10, 0x09, 0x09, 0x15, 0x17, 0x09, 0x05, 0x71, 0x12, 0x14,
+  0x2f, 0x41, 0x38, 0x09, 0x12, 0x0a, 0x0a, 0x12, 0x11, 0x0b, 0x06, 0x67,
+  0x00, 0x08, 0x00, 0x26, 0x00, 0xa9, 0x05, 0xc6, 0x05, 0x6c, 0x00, 0x06,
+  0x00, 0x39, 0x00, 0x4c, 0x00, 0x70, 0x00, 0x7b, 0x00, 0x7f, 0x00, 0x89,
+  0x00, 0x8d, 0x00, 0x00, 0x13, 0x16, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01,
+  0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x0f,
+  0x01, 0x13, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x07, 0x17, 0x16, 0x33, 0x32, 0x37, 0x33, 0x16, 0x15, 0x14, 0x07, 0x23,
+  0x35, 0x06, 0x25, 0x36, 0x37, 0x36, 0x37, 0x01, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x0f, 0x01, 0x16, 0x15, 0x14, 0x07, 0x36, 0x01, 0x22, 0x2f,
+  0x01, 0x07, 0x14, 0x07, 0x36, 0x37, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x07, 0x16, 0x15, 0x14, 0x07, 0x32, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x06, 0x37, 0x16, 0x15,
+  0x14, 0x07, 0x15, 0x33, 0x36, 0x35, 0x34, 0x27, 0x05, 0x36, 0x37, 0x0f,
+  0x01, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x36, 0x35, 0x34, 0x05, 0x07,
+  0x37, 0x26, 0xc2, 0x19, 0x12, 0x0d, 0x0e, 0x03, 0x18, 0x2a, 0x62, 0x2b,
+  0x1a, 0x22, 0x87, 0x43, 0x1d, 0x5a, 0x4a, 0x22, 0x50, 0xed, 0x74, 0x06,
+  0x0d, 0x3e, 0x19, 0x17, 0x54, 0x6e, 0x3a, 0x3c, 0x1f, 0x20, 0x2f, 0x38,
+  0x89, 0x29, 0x35, 0x21, 0x1b, 0x0c, 0xab, 0xb8, 0x27, 0x24, 0x31, 0x05,
+  0xcb, 0x50, 0x38, 0xdf, 0x62, 0xfd, 0x0f, 0x1e, 0x1b, 0x07, 0x05, 0x01,
+  0x2c, 0x20, 0x0f, 0x1c, 0x50, 0xd4, 0x30, 0x1f, 0x12, 0x2a, 0x27, 0x24,
+  0x03, 0x4d, 0x2f, 0x17, 0xd9, 0x68, 0x4b, 0x39, 0x4f, 0x0e, 0x21, 0x4c,
+  0x74, 0x38, 0x16, 0x1f, 0x12, 0x67, 0x43, 0x39, 0x43, 0x24, 0x57, 0x29,
+  0x2a, 0x2f, 0x7c, 0x26, 0x2d, 0x16, 0x43, 0x2d, 0x29, 0x8e, 0x2b, 0x38,
+  0xfd, 0x05, 0x4b, 0x0c, 0x92, 0x51, 0x65, 0x2b, 0x1c, 0x27, 0x15, 0xfe,
+  0xc3, 0x2c, 0x54, 0x06, 0x01, 0xf0, 0x03, 0x27, 0x1f, 0x1f, 0x20, 0x10,
+  0xfe, 0xc7, 0x0e, 0x05, 0x10, 0x08, 0x3b, 0x63, 0x73, 0x01, 0x0c, 0x12,
+  0x20, 0x1a, 0x2f, 0xe8, 0x5e, 0x22, 0x7c, 0x59, 0x2f, 0x1a, 0x0d, 0x34,
+  0xab, 0x32, 0x38, 0x19, 0x1d, 0xdb, 0x87, 0x1d, 0x1e, 0x83, 0xb4, 0xcf,
+  0x95, 0x6c, 0x25, 0xe9, 0x25, 0x6f, 0x1d, 0x0f, 0x01, 0x74, 0x1e, 0x0e,
+  0xe9, 0x35, 0x6f, 0x41, 0x3d, 0x27, 0x59, 0x24, 0x09, 0x01, 0x61, 0x10,
+  0x9d, 0x85, 0xa3, 0x54, 0x02, 0x2a, 0x0d, 0x16, 0x12, 0x10, 0x27, 0x01,
+  0x27, 0x47, 0x2b, 0x2d, 0x0d, 0x0b, 0x0c, 0x06, 0x25, 0x5f, 0x6b, 0x6a,
+  0x7e, 0x07, 0x1d, 0x72, 0x8d, 0x7d, 0x6a, 0x4c, 0x60, 0xd0, 0x86, 0x7c,
+  0xef, 0x5c, 0x67, 0xc3, 0x4b, 0x1a, 0x40, 0x2f, 0x1e, 0x14, 0x03, 0x2e,
+  0x38, 0x35, 0x96, 0x63, 0x28, 0x24, 0x00, 0x00, 0x00, 0x07, 0x00, 0xa3,
+  0x00, 0x9a, 0x05, 0x37, 0x05, 0xaf, 0x00, 0x13, 0x00, 0x19, 0x00, 0x20,
+  0x00, 0x28, 0x00, 0x32, 0x00, 0x4c, 0x00, 0x53, 0x00, 0x00, 0x01, 0x3e,
+  0x01, 0x35, 0x34, 0x2f, 0x01, 0x06, 0x23, 0x14, 0x07, 0x06, 0x23, 0x14,
+  0x07, 0x17, 0x16, 0x33, 0x32, 0x36, 0x01, 0x3f, 0x01, 0x0f, 0x02, 0x13,
+  0x37, 0x01, 0x13, 0x25, 0x01, 0x13, 0x05, 0x01, 0x33, 0x32, 0x35, 0x34,
+  0x27, 0x01, 0x00, 0x36, 0x35, 0x34, 0x27, 0x01, 0x07, 0x01, 0x16, 0x33,
+  0x01, 0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x0e,
+  0x01, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37,
+  0x3e, 0x01, 0x17, 0x07, 0x01, 0x16, 0x33, 0x32, 0x27, 0x04, 0xa1, 0x07,
+  0x0b, 0x01, 0x36, 0x14, 0x1b, 0x31, 0x30, 0x42, 0x14, 0xd5, 0x07, 0x07,
+  0x09, 0x17, 0xfc, 0xda, 0x89, 0x0c, 0x83, 0x8a, 0x0c, 0x76, 0xef, 0x02,
+  0x3d, 0xa6, 0xfd, 0xa9, 0xfd, 0xc4, 0x0f, 0x01, 0x91, 0x01, 0xd8, 0x02,
+  0x39, 0x02, 0xfd, 0xfb, 0x01, 0x7a, 0x31, 0x06, 0xfe, 0x2f, 0x66, 0x01,
+  0xd2, 0x0f, 0x0d, 0xfd, 0xb0, 0x0c, 0x1c, 0x0e, 0x0c, 0x09, 0x0d, 0x0f,
+  0x05, 0x05, 0x11, 0x0d, 0x0c, 0x1a, 0x10, 0x0c, 0x08, 0x0d, 0x0e, 0x03,
+  0x05, 0x12, 0x28, 0x72, 0x02, 0x04, 0x0a, 0x09, 0x34, 0x01, 0x01, 0x40,
+  0x08, 0x1c, 0x0a, 0x05, 0x08, 0xee, 0x17, 0x48, 0x36, 0x37, 0x1c, 0x18,
+  0x3b, 0x02, 0x0b, 0x02, 0xf9, 0x98, 0x92, 0x0d, 0x98, 0x92, 0x01, 0x7a,
+  0x12, 0xfd, 0x83, 0xfd, 0x68, 0xb8, 0x02, 0x7c, 0x01, 0x09, 0x14, 0xfd,
+  0xf3, 0x38, 0x0a, 0x0c, 0x02, 0x3e, 0xfc, 0xb6, 0x36, 0x21, 0x0f, 0x11,
+  0x02, 0x06, 0x71, 0xfd, 0xfa, 0x06, 0x02, 0xea, 0x0d, 0x15, 0x05, 0x04,
+  0x11, 0x0d, 0x0a, 0x0e, 0x10, 0x1f, 0x0d, 0x0e, 0x14, 0x05, 0x04, 0x0e,
+  0x10, 0x0b, 0x0d, 0x10, 0x1e, 0xf4, 0x0e, 0xfd, 0xc2, 0x02, 0x42, 0x00,
+  0x00, 0x07, 0x00, 0x2f, 0x01, 0x96, 0x05, 0xe7, 0x04, 0x3e, 0x00, 0x11,
+  0x00, 0x17, 0x00, 0x1e, 0x00, 0x25, 0x00, 0x2b, 0x00, 0x3f, 0x00, 0x46,
+  0x00, 0x00, 0x00, 0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x14, 0x07, 0x16,
+  0x14, 0x07, 0x16, 0x15, 0x37, 0x36, 0x37, 0x36, 0x05, 0x35, 0x27, 0x07,
+  0x15, 0x17, 0x03, 0x37, 0x21, 0x09, 0x01, 0x21, 0x27, 0x01, 0x21, 0x36,
+  0x35, 0x34, 0x27, 0x21, 0x00, 0x34, 0x27, 0x21, 0x15, 0x21, 0x24, 0x34,
+  0x36, 0x37, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07,
+  0x0e, 0x01, 0x22, 0x26, 0x27, 0x26, 0x17, 0x07, 0x21, 0x36, 0x35, 0x34,
+  0x27, 0x05, 0x13, 0x07, 0x06, 0x04, 0x09, 0xbd, 0x13, 0x2e, 0x2e, 0x13,
+  0xbd, 0x09, 0x04, 0x06, 0xfc, 0x16, 0x55, 0x54, 0x54, 0x9d, 0x9d, 0x02,
+  0xfd, 0x02, 0x1c, 0xfd, 0xe4, 0xfd, 0x03, 0x9d, 0x01, 0x28, 0x02, 0x6f,
+  0x16, 0x1f, 0xfd, 0x52, 0x02, 0xf6, 0x2d, 0xfd, 0x9a, 0x02, 0x66, 0xfc,
+  0xc7, 0x06, 0x08, 0x06, 0x10, 0x12, 0x10, 0x07, 0x07, 0x06, 0x06, 0x07,
+  0x07, 0x10, 0x12, 0x10, 0x06, 0x08, 0xb2, 0x48, 0x02, 0xae, 0x1f, 0x16,
+  0x02, 0xde, 0x18, 0x15, 0x09, 0x07, 0x06, 0x7e, 0x21, 0x14, 0x38, 0x90,
+  0x38, 0x14, 0x21, 0x7e, 0x06, 0x07, 0x09, 0x4b, 0xd8, 0x70, 0x70, 0xd8,
+  0x70, 0x01, 0x68, 0xc8, 0xfe, 0xac, 0xfe, 0xac, 0xc8, 0x01, 0x2c, 0x19,
+  0x17, 0x1b, 0x19, 0xfe, 0xc4, 0x70, 0x18, 0xa0, 0x3c, 0x28, 0x23, 0x0f,
+  0x0e, 0x10, 0x10, 0x0e, 0x0f, 0x23, 0x28, 0x23, 0x0f, 0x0e, 0x10, 0x10,
+  0x0e, 0x0f, 0x69, 0x64, 0x19, 0x1b, 0x17, 0x19, 0x00, 0x07, 0x00, 0xa3,
+  0x00, 0x9a, 0x05, 0x37, 0x05, 0xaf, 0x00, 0x13, 0x00, 0x19, 0x00, 0x20,
+  0x00, 0x28, 0x00, 0x32, 0x00, 0x4c, 0x00, 0x53, 0x00, 0x00, 0x01, 0x2e,
+  0x01, 0x23, 0x22, 0x0f, 0x01, 0x16, 0x15, 0x32, 0x17, 0x16, 0x15, 0x32,
+  0x17, 0x37, 0x36, 0x35, 0x34, 0x26, 0x01, 0x27, 0x1f, 0x02, 0x27, 0x07,
+  0x27, 0x03, 0x01, 0x25, 0x03, 0x01, 0x27, 0x17, 0x01, 0x36, 0x35, 0x34,
+  0x2b, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x01, 0x17, 0x01, 0x36, 0x35,
+  0x01, 0x2e, 0x01, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x1e,
+  0x01, 0x17, 0x1e, 0x01, 0x17, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x27,
+  0x2e, 0x01, 0x13, 0x01, 0x36, 0x23, 0x22, 0x07, 0x01, 0x04, 0xa1, 0x08,
+  0x17, 0x09, 0x07, 0x07, 0xd5, 0x14, 0x42, 0x30, 0x31, 0x1b, 0x14, 0x36,
+  0x01, 0x0b, 0xfc, 0xcb, 0x84, 0x0c, 0x8a, 0x83, 0x0c, 0x97, 0xb2, 0x0f,
+  0x02, 0x3c, 0x02, 0x57, 0xa6, 0xfd, 0xc3, 0x10, 0x0c, 0x02, 0x05, 0x02,
+  0x39, 0x02, 0x21, 0x31, 0x1e, 0x0d, 0x0f, 0xfe, 0x2e, 0x66, 0x01, 0xd1,
+  0x06, 0xfd, 0x61, 0x0c, 0x12, 0x05, 0x03, 0x0e, 0x0d, 0x08, 0x0c, 0x10,
+  0x1a, 0x0c, 0x0d, 0x11, 0x05, 0x05, 0x0f, 0x0d, 0x09, 0x0c, 0x0e, 0x1c,
+  0x10, 0x01, 0xd8, 0x01, 0x34, 0x09, 0x0a, 0xfd, 0xfc, 0x05, 0x09, 0x09,
+  0x0b, 0x02, 0x3b, 0x18, 0x1c, 0x37, 0x36, 0x48, 0x17, 0xee, 0x08, 0x05,
+  0x0a, 0x1c, 0xfd, 0x18, 0x0d, 0x92, 0x98, 0x0d, 0x92, 0xd5, 0xc6, 0x01,
+  0x09, 0x02, 0x7c, 0xb8, 0xfd, 0x68, 0xfd, 0x83, 0xec, 0x7f, 0x02, 0x3e,
+  0x0c, 0x0a, 0x38, 0x88, 0x36, 0x06, 0xfd, 0xfa, 0x71, 0x02, 0x06, 0x11,
+  0x0f, 0xfd, 0x6d, 0x0e, 0x1e, 0x10, 0x0d, 0x0b, 0x10, 0x0e, 0x04, 0x05,
+  0x14, 0x0e, 0x0d, 0x1f, 0x10, 0x0e, 0x0a, 0x0d, 0x11, 0x04, 0x05, 0x15,
+  0x01, 0x0f, 0x02, 0x0c, 0x42, 0x02, 0xfd, 0xc2, 0x00, 0x02, 0x00, 0x4f,
+  0x01, 0x7b, 0x05, 0x73, 0x04, 0x5b, 0x00, 0x25, 0x00, 0x47, 0x00, 0x00,
+  0x12, 0x10, 0x27, 0x32, 0x33, 0x20, 0x25, 0x01, 0x15, 0x25, 0x2e, 0x01,
+  0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x14, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x32, 0x37, 0x3e, 0x01, 0x37, 0x25, 0x15, 0x01, 0x24, 0x21,
+  0x22, 0x23, 0x12, 0x14, 0x07, 0x32, 0x33, 0x32, 0x05, 0x25, 0x05, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x05, 0x25, 0x04, 0x23, 0x22, 0x23,
+  0x7c, 0x2d, 0x07, 0x07, 0x01, 0x07, 0x01, 0xe2, 0x02, 0x2d, 0xfd, 0xf9,
+  0x05, 0x0c, 0x11, 0x0b, 0x1b, 0x0c, 0x0d, 0x09, 0x0a, 0x0a, 0x0c, 0x08,
+  0x09, 0x0d, 0x0c, 0x1b, 0x0b, 0x11, 0x0c, 0x05, 0x02, 0x07, 0xfd, 0xd3,
+  0xfe, 0x1e, 0xfe, 0xf9, 0x07, 0x07, 0x8a, 0x15, 0x04, 0x04, 0xa0, 0x01,
+  0xda, 0x01, 0x8b, 0xfe, 0xc0, 0x14, 0x19, 0x17, 0x38, 0x17, 0x18, 0x14,
+  0x14, 0x14, 0x14, 0x14, 0x14, 0x18, 0x17, 0x38, 0x17, 0x19, 0x14, 0x01,
+  0x40, 0xfe, 0x75, 0xfe, 0x26, 0xa0, 0x04, 0x04, 0x02, 0x49, 0x01, 0x44,
+  0x60, 0x6e, 0xfe, 0xed, 0x53, 0x1c, 0x08, 0x10, 0x08, 0x06, 0x06, 0x06,
+  0x0a, 0x09, 0x1d, 0x20, 0x1f, 0x07, 0x0a, 0x06, 0x06, 0x06, 0x08, 0x10,
+  0x08, 0x1c, 0x53, 0xfe, 0xed, 0x6e, 0x01, 0x47, 0x8a, 0x59, 0x6e, 0xb9,
+  0x18, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x17, 0x35, 0x3e, 0x35, 0x17,
+  0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x18, 0xb9, 0x6e, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x7c, 0x01, 0xad, 0x05, 0x73, 0x04, 0x29, 0x00, 0x28,
+  0x00, 0x00, 0x01, 0x25, 0x15, 0x01, 0x24, 0x23, 0x22, 0x23, 0x36, 0x34,
+  0x27, 0x32, 0x33, 0x32, 0x25, 0x01, 0x15, 0x25, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x03, 0x84, 0x01, 0xef, 0xfd,
+  0xd3, 0xfe, 0x21, 0xdf, 0x06, 0x06, 0x2d, 0x2d, 0x06, 0x06, 0xdf, 0x01,
+  0xdf, 0x02, 0x2d, 0xfe, 0x11, 0x06, 0x0e, 0x0c, 0x11, 0x0f, 0x26, 0x0f,
+  0x10, 0x0d, 0x0d, 0x0e, 0x0e, 0x0d, 0x0d, 0x10, 0x0f, 0x26, 0x0f, 0x11,
+  0x0c, 0x0e, 0x02, 0xc5, 0x1c, 0x21, 0xfe, 0xed, 0x6e, 0x60, 0xe0, 0x60,
+  0x6e, 0xfe, 0xed, 0x21, 0x1d, 0x11, 0x0f, 0x0e, 0x08, 0x08, 0x08, 0x08,
+  0x0e, 0x0f, 0x23, 0x15, 0x14, 0x23, 0x0f, 0x0e, 0x08, 0x08, 0x08, 0x08,
+  0x0e, 0x0f, 0x00, 0x00, 0x00, 0x01, 0x01, 0x14, 0x00, 0xc6, 0x04, 0xcf,
+  0x05, 0x0a, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x12, 0x13, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x00, 0x01,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x01,
+  0x98, 0x23, 0x12, 0x24, 0x0f, 0x0c, 0x0c, 0xfd, 0xd7, 0x38, 0x7a, 0x1c,
+  0x14, 0x1d, 0xfe, 0xa4, 0xfe, 0xd7, 0x14, 0x40, 0x41, 0x0c, 0x1f, 0x29,
+  0x2f, 0x3f, 0x27, 0x02, 0x8e, 0x40, 0x78, 0x14, 0x01, 0xc2, 0x01, 0x16,
+  0x48, 0x0c, 0x09, 0x0e, 0x29, 0xfe, 0x30, 0xfd, 0xfc, 0x24, 0x06, 0x0f,
+  0x8a, 0x99, 0x27, 0x2a, 0x27, 0x18, 0x00, 0x00, 0x00, 0x01, 0x00, 0xd5,
+  0x00, 0xb2, 0x05, 0x32, 0x05, 0x0c, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x12, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x00, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x33, 0x01, 0x98, 0x23, 0x12, 0x24, 0x0f, 0x0c,
+  0x0c, 0xfd, 0xd7, 0x5b, 0x57, 0x72, 0x17, 0x0a, 0x14, 0xfd, 0xbd, 0x6f,
+  0x26, 0x88, 0x2d, 0x32, 0x15, 0x33, 0x41, 0x3f, 0x57, 0x2b, 0x03, 0x1a,
+  0x40, 0x78, 0x14, 0x01, 0x9d, 0xaf, 0x4a, 0x08, 0x03, 0x16, 0x12, 0x1b,
+  0xfd, 0x1e, 0xde, 0x4c, 0x1a, 0x0c, 0x8d, 0xb2, 0x86, 0x31, 0x20, 0x2c,
+  0x00, 0x01, 0x00, 0xe9, 0x00, 0x94, 0x05, 0x20, 0x05, 0x41, 0x00, 0x0b,
+  0x00, 0x00, 0x09, 0x01, 0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x37, 0x09,
+  0x01, 0x17, 0x03, 0x83, 0x01, 0x9b, 0x7f, 0xfe, 0x65, 0xfe, 0x65, 0x80,
+  0x01, 0x9b, 0xfe, 0x65, 0x80, 0x01, 0x9b, 0x01, 0x9c, 0x7f, 0x02, 0xea,
+  0xfe, 0x37, 0x8d, 0x01, 0xc9, 0xfe, 0x37, 0x8d, 0x01, 0xc9, 0x01, 0xc9,
+  0x8d, 0xfe, 0x38, 0x01, 0xc9, 0x8d, 0x00, 0x00, 0x00, 0x01, 0x00, 0x9d,
+  0x00, 0x3f, 0x05, 0x6b, 0x05, 0x96, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x0b,
+  0x04, 0x1c, 0x01, 0x4f, 0xfe, 0xe8, 0xfe, 0xb1, 0xfe, 0xb1, 0xfe, 0xe9,
+  0x01, 0x4e, 0xfe, 0xb2, 0x01, 0x17, 0x01, 0x4f, 0x01, 0x4f, 0x01, 0x18,
+  0x02, 0xea, 0xfe, 0x8c, 0xfe, 0xc9, 0x01, 0x74, 0xfe, 0x8c, 0x01, 0x37,
+  0x01, 0x74, 0x01, 0x74, 0x01, 0x37, 0xfe, 0x8c, 0x01, 0x75, 0xfe, 0xc9,
+  0x00, 0x01, 0x00, 0xd8, 0xff, 0xee, 0x05, 0x0d, 0x05, 0xdc, 0x00, 0x42,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x0f, 0x01,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x03,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x12, 0x13,
+  0x02, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x04, 0x79, 0x09,
+  0x0e, 0x10, 0x10, 0x1a, 0x0f, 0x0e, 0x17, 0x0e, 0x13, 0xbc, 0xb0, 0x49,
+  0x81, 0x0a, 0x1b, 0x1c, 0x03, 0x14, 0x17, 0x0b, 0x17, 0x12, 0x6c, 0x73,
+  0x9b, 0xc8, 0x1d, 0x44, 0x21, 0x03, 0x2e, 0x0a, 0x04, 0x19, 0xb7, 0xcd,
+  0x6d, 0x24, 0x09, 0x11, 0x11, 0x0e, 0x0e, 0x14, 0x08, 0x0c, 0x10, 0x1a,
+  0x1c, 0x09, 0x31, 0x4f, 0x80, 0xb8, 0x15, 0x05, 0xdc, 0x10, 0x10, 0x1a,
+  0x33, 0x1b, 0x11, 0x15, 0x1b, 0x17, 0xe2, 0xfe, 0xf1, 0xc6, 0xef, 0x14,
+  0x0c, 0x17, 0x19, 0x16, 0x0c, 0x14, 0x1e, 0x10, 0x12, 0x1a, 0x9a, 0xd0,
+  0xe0, 0xfe, 0x8a, 0x36, 0x2a, 0x1c, 0x3d, 0x50, 0x1f, 0x0e, 0x2a, 0x01,
+  0x3e, 0x01, 0x0a, 0x01, 0x22, 0x9d, 0x23, 0x0a, 0x0e, 0x1a, 0x1a, 0x1d,
+  0x11, 0x0c, 0x10, 0x1e, 0xa8, 0x98, 0xb8, 0xcc, 0x18, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xe2, 0x00, 0x00, 0x05, 0x6e, 0x05, 0xea, 0x00, 0x52,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x36, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x03, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x02, 0x07, 0x06, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x27,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x26, 0x03, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x12, 0x37,
+  0x36, 0x04, 0xcc, 0x1a, 0x18, 0x12, 0x07, 0x18, 0x09, 0x1c, 0x0d, 0x0d,
+  0x0f, 0xd9, 0xd3, 0x85, 0x85, 0x0f, 0x1a, 0x12, 0x22, 0x02, 0x0c, 0x16,
+  0x1d, 0x20, 0x1b, 0x07, 0x0d, 0x20, 0x18, 0x15, 0x18, 0x50, 0x6d, 0xcf,
+  0x4f, 0x0f, 0x13, 0x02, 0x10, 0x0f, 0x0e, 0x02, 0x12, 0x10, 0x16, 0x1a,
+  0x21, 0x1b, 0x08, 0x08, 0x10, 0x15, 0x75, 0xb1, 0x6e, 0x59, 0x14, 0x15,
+  0x0e, 0x14, 0x17, 0x2c, 0x01, 0x09, 0x15, 0x0f, 0x27, 0x0c, 0x5f, 0x87,
+  0xd0, 0xe0, 0x0b, 0x05, 0xea, 0x1e, 0x16, 0x3a, 0x01, 0x05, 0x0c, 0x0e,
+  0x0d, 0x15, 0x28, 0x10, 0xdb, 0xfe, 0xc7, 0xcc, 0xa2, 0x12, 0x18, 0x31,
+  0x1a, 0x11, 0x02, 0x11, 0x23, 0x3a, 0x18, 0x12, 0x0b, 0x1b, 0x1c, 0x5f,
+  0xbf, 0xfe, 0xfb, 0x87, 0x1a, 0x24, 0x1f, 0x0d, 0x0c, 0x1e, 0x23, 0x11,
+  0x1b, 0x2d, 0x03, 0x0d, 0x18, 0x18, 0x15, 0x1f, 0xb0, 0xd4, 0xbd, 0x01,
+  0x0b, 0x3d, 0x1c, 0x1a, 0x31, 0x20, 0x27, 0x0e, 0x19, 0x32, 0x1a, 0xc4,
+  0xba, 0x01, 0x08, 0xda, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x64,
+  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11,
+  0x21, 0x11, 0x25, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x11, 0x21, 0x03, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x21,
+  0x11, 0x33, 0x03, 0xca, 0xfe, 0x74, 0xfe, 0x81, 0x01, 0x7f, 0x01, 0x8c,
+  0x01, 0x80, 0xfe, 0xc8, 0x01, 0x92, 0xfe, 0x6e, 0xfd, 0xe4, 0xfe, 0x6f,
+  0x01, 0x91, 0x02, 0x1c, 0xb4, 0x01, 0x92, 0xfe, 0x6e, 0xb4, 0xfe, 0x6f,
+  0x01, 0x91, 0xb4, 0x03, 0xc6, 0x01, 0xab, 0xfe, 0x55, 0xfe, 0x48, 0xfe,
+  0x56, 0x01, 0xaa, 0x01, 0xb8, 0x50, 0xfd, 0xa8, 0xfe, 0x42, 0x01, 0xbe,
+  0x02, 0x58, 0x01, 0xbf, 0xfd, 0x79, 0xc8, 0xfe, 0x42, 0x01, 0xbe, 0xc8,
+  0x01, 0xbf, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x03, 0xb8, 0x01, 0xec, 0xfe, 0x14,
+  0xfe, 0x98, 0xfe, 0x15, 0x01, 0xeb, 0x01, 0x68, 0x03, 0xb2, 0xfe, 0x70,
+  0xfd, 0xde, 0x02, 0x22, 0x01, 0x90, 0x02, 0x23, 0x00, 0x02, 0x00, 0x64,
+  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
+  0x01, 0x33, 0x35, 0x23, 0x37, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x35, 0x21, 0x11, 0x33, 0x02, 0x99, 0xd6, 0xd6, 0xd7, 0x02, 0x34, 0xfd,
+  0xcc, 0xd8, 0xfd, 0xcd, 0x02, 0x33, 0xd8, 0x02, 0x73, 0xee, 0x01, 0xf0,
+  0xfd, 0x8e, 0x02, 0x72, 0xf0, 0x02, 0x73, 0x00, 0x00, 0x02, 0x00, 0x64,
+  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
+  0x01, 0x21, 0x11, 0x21, 0x25, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x11, 0x21, 0x11, 0x21, 0x02, 0x51, 0x01, 0x66, 0xfe, 0x9a, 0x01, 0x67,
+  0x01, 0xec, 0xfe, 0x14, 0xfe, 0x98, 0xfe, 0x15, 0x01, 0xeb, 0x01, 0x68,
+  0x02, 0x23, 0x01, 0x8e, 0x01, 0xfe, 0x70, 0xfd, 0xde, 0x02, 0x22, 0x01,
+  0x90, 0x02, 0x23, 0x00, 0x00, 0x01, 0x01, 0x30, 0x00, 0x00, 0x04, 0xd9,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x03, 0x70, 0x01, 0x68, 0xfe, 0x98,
+  0xd8, 0xfe, 0x98, 0x01, 0x68, 0xd8, 0x04, 0x45, 0xf0, 0xfc, 0xab, 0x03,
+  0x55, 0xf0, 0x01, 0x90, 0x00, 0x02, 0x00, 0xf1, 0x00, 0x00, 0x04, 0xe2,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x33, 0x17, 0x11,
+  0x21, 0x11, 0x21, 0x27, 0x11, 0x23, 0x27, 0x11, 0x21, 0x11, 0x21, 0x17,
+  0x07, 0x11, 0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x33, 0x11, 0x21, 0x35,
+  0x03, 0xd3, 0x87, 0x87, 0xfe, 0xf2, 0xfe, 0xb3, 0x87, 0x87, 0x87, 0x01,
+  0x0e, 0x01, 0x4d, 0x87, 0xb4, 0xc6, 0xfe, 0xf2, 0x01, 0x0e, 0xc6, 0x01,
+  0x0e, 0x04, 0xa9, 0x96, 0xfe, 0x8e, 0xfd, 0x5f, 0x96, 0x02, 0x0b, 0x96,
+  0x01, 0x72, 0x01, 0x2c, 0x96, 0xfa, 0x01, 0x2c, 0xfe, 0xd4, 0xdc, 0xfd,
+  0x5f, 0x02, 0xa1, 0xdc, 0x00, 0x03, 0x01, 0x1e, 0x00, 0x00, 0x04, 0xeb,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x27, 0x33,
+  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x03, 0x33,
+  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33, 0x03, 0xa6,
+  0xfe, 0xbc, 0xfc, 0xfc, 0x01, 0x44, 0xfc, 0xb4, 0xfc, 0xfc, 0xfe, 0x2c,
+  0xfc, 0xfc, 0x01, 0xd4, 0x90, 0xfc, 0xfc, 0xb4, 0xfc, 0xfc, 0xb4, 0x04,
+  0x6d, 0x01, 0x18, 0xfe, 0xe8, 0xfe, 0x84, 0xfd, 0x5f, 0x02, 0xa1, 0x01,
+  0x7c, 0x50, 0xfd, 0xe4, 0xfd, 0x5f, 0x02, 0xa1, 0x02, 0x1c, 0x01, 0x18,
+  0xfe, 0x48, 0xdc, 0xfd, 0x5f, 0x02, 0xa1, 0xdc, 0x01, 0x18, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x4b,
+  0x00, 0x00, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x07,
+  0x11, 0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x3b, 0x01, 0x35, 0x34,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x27, 0x21, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x1d, 0x01, 0x33, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x35, 0x37, 0x11, 0x27, 0x26, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x2b, 0x01,
+  0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x17, 0x21, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x02, 0xc1, 0x6f, 0x5a, 0xa1, 0x42,
+  0x3b, 0x28, 0x20, 0x2d, 0x16, 0x17, 0x20, 0x26, 0x3d, 0x3e, 0xa1, 0x5e,
+  0x6f, 0x45, 0x40, 0x3c, 0x55, 0x4a, 0x19, 0x48, 0x04, 0x09, 0x31, 0x30,
+  0x4a, 0x56, 0x3c, 0x42, 0x42, 0x6e, 0x5e, 0xa1, 0x3e, 0x3d, 0x26, 0x21,
+  0x2d, 0x17, 0x16, 0x21, 0x27, 0x3c, 0x3f, 0xa4, 0x5a, 0x6e, 0x44, 0x40,
+  0x3c, 0x56, 0x4a, 0x18, 0x49, 0xfb, 0xf7, 0x30, 0x31, 0x4a, 0x55, 0x3c,
+  0x42, 0x43, 0x02, 0xa0, 0x4b, 0x49, 0x42, 0x60, 0x4f, 0x1b, 0x54, 0x04,
+  0x7c, 0x38, 0x37, 0x4f, 0x5c, 0x46, 0x47, 0x4b, 0x7a, 0x64, 0xb6, 0x47,
+  0x42, 0x2b, 0x25, 0x32, 0x19, 0x19, 0x25, 0x2b, 0x42, 0x49, 0xb4, 0x64,
+  0x7a, 0x4b, 0x47, 0x46, 0x5c, 0x4f, 0x1b, 0x54, 0xfb, 0x84, 0x38, 0x37,
+  0x4f, 0x60, 0x42, 0x48, 0x4c, 0x7b, 0x64, 0xb6, 0x47, 0x42, 0x2b, 0x25,
+  0x32, 0x19, 0x19, 0x25, 0x2b, 0x42, 0x49, 0xb4, 0x64, 0x00, 0x00, 0x00,
+  0x00, 0x08, 0x00, 0xa8, 0xff, 0xe5, 0x05, 0x61, 0x05, 0xf3, 0x00, 0x0b,
+  0x00, 0x11, 0x00, 0x14, 0x00, 0x17, 0x00, 0x1a, 0x00, 0x1d, 0x00, 0x20,
+  0x00, 0x23, 0x00, 0x00, 0x01, 0x13, 0x21, 0x03, 0x13, 0x21, 0x0b, 0x01,
+  0x21, 0x13, 0x03, 0x21, 0x17, 0x03, 0x13, 0x21, 0x13, 0x0b, 0x01, 0x07,
+  0x33, 0x1f, 0x01, 0x37, 0x03, 0x07, 0x33, 0x05, 0x23, 0x17, 0x03, 0x27,
+  0x07, 0x13, 0x37, 0x23, 0x03, 0x04, 0xca, 0x01, 0x92, 0xca, 0xca, 0xfe,
+  0x6e, 0xca, 0xc9, 0xfe, 0x6d, 0xca, 0xca, 0x01, 0x93, 0x34, 0x96, 0x96,
+  0x01, 0x2b, 0x95, 0x95, 0x96, 0x61, 0xc2, 0x9c, 0x62, 0x61, 0x61, 0x62,
+  0xc3, 0xfe, 0xa1, 0xc2, 0x61, 0xfd, 0x62, 0x61, 0x61, 0x62, 0xc3, 0x05,
+  0xf3, 0xfe, 0x7c, 0xfe, 0x7d, 0xfe, 0x7d, 0xfe, 0x7c, 0x01, 0x84, 0x01,
+  0x83, 0x01, 0x83, 0x64, 0xfe, 0xe1, 0xfe, 0xe0, 0x01, 0x20, 0x01, 0x1f,
+  0x01, 0x1f, 0xbb, 0x64, 0xbb, 0xbb, 0xfe, 0x7d, 0xbc, 0x63, 0xbc, 0x01,
+  0x1f, 0xbc, 0xbc, 0x01, 0x84, 0xbb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b,
+  0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x43, 0x00, 0x00, 0x01, 0x35,
+  0x34, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x1d, 0x01, 0x33, 0x32, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x2b, 0x01, 0x15, 0x14, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x3d, 0x01, 0x23, 0x22, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x33, 0x02, 0xd7, 0x44, 0x28, 0x31, 0x32,
+  0x6c, 0x33, 0x30, 0x27, 0x45, 0x1d, 0xa7, 0x6e, 0x3f, 0x6a, 0x5a, 0x2c,
+  0x2b, 0x2b, 0x2c, 0x5a, 0x6a, 0x3f, 0x6e, 0xa7, 0x1d, 0x45, 0x27, 0x30,
+  0x33, 0x6c, 0x32, 0x31, 0x28, 0x44, 0x1d, 0xa7, 0x6e, 0x3f, 0x6a, 0x5a,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x5a, 0x6a, 0x3f, 0x6e, 0xa7, 0x03, 0x1c, 0x20,
+  0xba, 0x7a, 0x46, 0x76, 0x64, 0x30, 0x30, 0x30, 0x30, 0x64, 0x76, 0x46,
+  0x7a, 0xba, 0x20, 0x4c, 0x2c, 0x36, 0x38, 0x78, 0x38, 0x36, 0x2c, 0x4c,
+  0x20, 0xbb, 0x79, 0x46, 0x76, 0x64, 0x30, 0x31, 0x31, 0x30, 0x64, 0x76,
+  0x46, 0x79, 0xbb, 0x20, 0x4c, 0x2c, 0x36, 0x38, 0x78, 0x38, 0x36, 0x2c,
+  0x4c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4d, 0xff, 0xe7, 0x05, 0xbb,
+  0x05, 0xf0, 0x00, 0x83, 0x00, 0x00, 0x01, 0x26, 0x27, 0x23, 0x06, 0x07,
+  0x06, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x33, 0x36, 0x37, 0x36, 0x37, 0x35, 0x26, 0x27, 0x26, 0x27, 0x2e,
+  0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x15, 0x16,
+  0x17, 0x16, 0x17, 0x33, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x06, 0x07, 0x06, 0x07,
+  0x15, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x35, 0x26, 0x02, 0xb5, 0x0e, 0x09, 0xbf, 0x02,
+  0x09, 0x12, 0x1a, 0x1d, 0x4a, 0x29, 0x29, 0x49, 0x1d, 0x1c, 0x10, 0x10,
+  0x10, 0x10, 0x1c, 0x1d, 0x49, 0x29, 0x29, 0x4a, 0x1d, 0x1e, 0x0e, 0x08,
+  0x03, 0xbf, 0x09, 0x0e, 0x0f, 0x13, 0x0e, 0x12, 0x26, 0x1b, 0x1e, 0x1e,
+  0x1e, 0x1e, 0x1d, 0x24, 0x24, 0x53, 0x24, 0x24, 0x1c, 0x1e, 0x1f, 0x1f,
+  0x1e, 0x1f, 0x21, 0x15, 0x0c, 0x13, 0x0f, 0x0f, 0x09, 0xbf, 0x02, 0x08,
+  0x0e, 0x1e, 0x1d, 0x4a, 0x29, 0x29, 0x4a, 0x1d, 0x1c, 0x10, 0x0f, 0x0f,
+  0x10, 0x1c, 0x1d, 0x4a, 0x29, 0x29, 0x4a, 0x1d, 0x1a, 0x12, 0x09, 0x01,
+  0xbf, 0x09, 0x0f, 0x0f, 0x13, 0x0c, 0x15, 0x21, 0x1f, 0x1e, 0x1f, 0x1f,
+  0x1e, 0x1c, 0x24, 0x24, 0x53, 0x24, 0x24, 0x1d, 0x1e, 0x1e, 0x1e, 0x1e,
+  0x1b, 0x26, 0x12, 0x0e, 0x13, 0x02, 0x93, 0x11, 0x15, 0x10, 0x14, 0x2a,
+  0x1e, 0x21, 0x22, 0x22, 0x21, 0x20, 0x28, 0x28, 0x5c, 0x28, 0x28, 0x20,
+  0x21, 0x22, 0x22, 0x21, 0x23, 0x25, 0x17, 0x0d, 0x15, 0x11, 0x10, 0x0a,
+  0xd5, 0x02, 0x0a, 0x14, 0x1d, 0x20, 0x52, 0x2e, 0x2d, 0x52, 0x20, 0x1f,
+  0x12, 0x11, 0x11, 0x12, 0x1f, 0x20, 0x52, 0x2d, 0x2e, 0x52, 0x20, 0x22,
+  0x0f, 0x09, 0x03, 0xd5, 0x0a, 0x10, 0x11, 0x15, 0x0d, 0x17, 0x25, 0x23,
+  0x21, 0x22, 0x22, 0x21, 0x20, 0x28, 0x28, 0x5c, 0x28, 0x28, 0x20, 0x21,
+  0x22, 0x22, 0x21, 0x1e, 0x2a, 0x14, 0x10, 0x15, 0x11, 0x10, 0x0a, 0xd4,
+  0x03, 0x09, 0x0f, 0x22, 0x20, 0x52, 0x2e, 0x2d, 0x52, 0x20, 0x1f, 0x12,
+  0x11, 0x11, 0x12, 0x1f, 0x20, 0x52, 0x2d, 0x2e, 0x52, 0x20, 0x1d, 0x14,
+  0x0a, 0x02, 0xd4, 0x0a, 0x00, 0x01, 0x00, 0x4a, 0xff, 0xe3, 0x05, 0xbe,
+  0x05, 0xf0, 0x00, 0x83, 0x00, 0x00, 0x01, 0x34, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x15, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x3e,
+  0x01, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x2e, 0x01,
+  0x23, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35,
+  0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x22, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x02, 0xd7, 0x27, 0x21, 0x0c, 0x0f,
+  0x15, 0x09, 0x24, 0x24, 0x25, 0x23, 0x1c, 0x35, 0x29, 0x67, 0x2b, 0x30,
+  0x21, 0x22, 0x26, 0x26, 0x22, 0x09, 0x18, 0x07, 0x12, 0x25, 0x23, 0x3d,
+  0x5b, 0x1e, 0x0c, 0x0b, 0x10, 0x09, 0x23, 0x5a, 0x32, 0x34, 0x59, 0x22,
+  0x20, 0x16, 0x13, 0x13, 0x16, 0x20, 0x22, 0x59, 0x34, 0x32, 0x5a, 0x23,
+  0x09, 0x10, 0x0b, 0x0c, 0x25, 0x57, 0x3a, 0x2b, 0x1d, 0x0c, 0x0e, 0x17,
+  0x09, 0x23, 0x25, 0x26, 0x22, 0x21, 0x30, 0x2a, 0x67, 0x2a, 0x31, 0x20,
+  0x23, 0x25, 0x24, 0x24, 0x09, 0x16, 0x0f, 0x0b, 0x23, 0x25, 0x39, 0x59,
+  0x23, 0x0c, 0x0b, 0x10, 0x09, 0x22, 0x5a, 0x33, 0x34, 0x58, 0x23, 0x1d,
+  0x19, 0x13, 0x13, 0x16, 0x20, 0x23, 0x58, 0x34, 0x37, 0x56, 0x22, 0x09,
+  0x10, 0x05, 0x12, 0x24, 0x58, 0x03, 0x1c, 0x43, 0x63, 0x22, 0x0e, 0x0c,
+  0x12, 0x0a, 0x26, 0x64, 0x38, 0x3a, 0x62, 0x26, 0x20, 0x1c, 0x16, 0x16,
+  0x18, 0x24, 0x26, 0x62, 0x3a, 0x3d, 0x5f, 0x26, 0x0a, 0x12, 0x06, 0x14,
+  0x28, 0x61, 0x3f, 0x2f, 0x21, 0x0d, 0x10, 0x19, 0x0a, 0x27, 0x29, 0x2a,
+  0x26, 0x24, 0x36, 0x2f, 0x72, 0x2f, 0x36, 0x24, 0x26, 0x2a, 0x29, 0x27,
+  0x0a, 0x19, 0x10, 0x0d, 0x27, 0x29, 0x44, 0x65, 0x21, 0x0d, 0x0c, 0x12,
+  0x0a, 0x27, 0x64, 0x38, 0x3a, 0x62, 0x26, 0x24, 0x18, 0x15, 0x15, 0x18,
+  0x24, 0x26, 0x62, 0x3a, 0x38, 0x64, 0x27, 0x0a, 0x12, 0x0c, 0x0d, 0x29,
+  0x61, 0x40, 0x29, 0x27, 0x0e, 0x10, 0x18, 0x0a, 0x28, 0x28, 0x2a, 0x26,
+  0x20, 0x3a, 0x2e, 0x72, 0x30, 0x36, 0x24, 0x26, 0x2a, 0x2a, 0x26, 0x0a,
+  0x1a, 0x08, 0x14, 0x28, 0x28, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b,
+  0xff, 0xe5, 0x05, 0xbd, 0x05, 0xf2, 0x01, 0x30, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x11, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x21, 0x11, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x16, 0x17, 0x11, 0x21, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x21, 0x11, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x2e,
+  0x01, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x03, 0x04, 0x1b, 0x15, 0x18, 0x10, 0x12, 0x0a, 0x09,
+  0x09, 0x0a, 0x12, 0x0a, 0x12, 0x17, 0x19, 0x1b, 0x16, 0x17, 0x11, 0x12,
+  0x0a, 0x09, 0x09, 0x0a, 0x24, 0x16, 0x17, 0x1a, 0x1b, 0x15, 0x16, 0x12,
+  0x0d, 0x09, 0x01, 0x09, 0x0f, 0x0d, 0x11, 0x0a, 0x0a, 0x14, 0x11, 0x12,
+  0x17, 0x17, 0x19, 0x1a, 0x17, 0x17, 0x12, 0x11, 0x0a, 0x0a, 0x0a, 0x07,
+  0x08, 0x12, 0x16, 0x17, 0x19, 0x1d, 0x14, 0x17, 0x12, 0x11, 0x0b, 0x09,
+  0x09, 0x0b, 0x11, 0x14, 0x15, 0x17, 0x1a, 0x19, 0x17, 0x16, 0x12, 0x08,
+  0x07, 0x0a, 0x14, 0x11, 0x0f, 0x1a, 0x17, 0x1a, 0x16, 0x1a, 0x17, 0x12,
+  0x11, 0x0a, 0x0a, 0x0a, 0x0a, 0x11, 0x0d, 0x0f, 0xfe, 0xf8, 0x08, 0x0d,
+  0x0f, 0x1a, 0x15, 0x1b, 0x1a, 0x16, 0x17, 0x11, 0x12, 0x0a, 0x09, 0x09,
+  0x0a, 0x12, 0x10, 0x18, 0x15, 0x1b, 0x17, 0x19, 0x12, 0x0a, 0x11, 0x0a,
+  0x0a, 0x0a, 0x0a, 0x12, 0x10, 0x18, 0x15, 0x36, 0x15, 0x18, 0x10, 0x12,
+  0x0a, 0x0a, 0x0a, 0x0a, 0x11, 0x0a, 0x12, 0x15, 0x1a, 0x1c, 0x14, 0x18,
+  0x11, 0x12, 0x0a, 0x09, 0x09, 0x0a, 0x12, 0x11, 0x18, 0x15, 0x1b, 0x18,
+  0x2f, 0x12, 0x0c, 0x08, 0xfe, 0xf9, 0x0f, 0x0c, 0x13, 0x08, 0x0a, 0x0a,
+  0x09, 0x12, 0x14, 0x15, 0x17, 0x19, 0x1b, 0x16, 0x17, 0x12, 0x11, 0x0b,
+  0x08, 0x08, 0x08, 0x09, 0x14, 0x15, 0x17, 0x19, 0x1a, 0x17, 0x17, 0x12,
+  0x11, 0x0a, 0x09, 0x09, 0x0a, 0x11, 0x0f, 0x1a, 0x17, 0x1a, 0x19, 0x17,
+  0x17, 0x12, 0x09, 0x08, 0x08, 0x08, 0x0b, 0x11, 0x12, 0x17, 0x16, 0x1b,
+  0x19, 0x17, 0x17, 0x12, 0x12, 0x09, 0x0a, 0x0a, 0x0a, 0x11, 0x0c, 0x0f,
+  0x01, 0x07, 0x09, 0x0c, 0x12, 0x17, 0x15, 0x1a, 0x1b, 0x15, 0x18, 0x24,
+  0x09, 0x09, 0x09, 0x09, 0x12, 0x12, 0x18, 0x14, 0x1c, 0x1a, 0x15, 0x12,
+  0x0a, 0x12, 0x0a, 0x09, 0x09, 0x0a, 0x12, 0x11, 0x18, 0x14, 0x05, 0xf2,
+  0x0b, 0x0c, 0x12, 0x14, 0x1a, 0x19, 0x1d, 0x1c, 0x19, 0x1a, 0x14, 0x0a,
+  0x08, 0x0a, 0x0a, 0x0c, 0x12, 0x14, 0x1a, 0x19, 0x1d, 0x1f, 0x17, 0x19,
+  0x28, 0x0b, 0x0a, 0x0a, 0x0c, 0x13, 0x0d, 0x11, 0xfe, 0xdb, 0x0a, 0x0e,
+  0x14, 0x19, 0x17, 0x1e, 0x1d, 0x32, 0x14, 0x14, 0x0b, 0x0a, 0x0a, 0x0b,
+  0x14, 0x13, 0x1a, 0x18, 0x1e, 0x1c, 0x19, 0x14, 0x0b, 0x14, 0x0b, 0x0a,
+  0x0a, 0x0b, 0x14, 0x12, 0x1b, 0x18, 0x1d, 0x1e, 0x18, 0x1b, 0x12, 0x16,
+  0x09, 0x0a, 0x0a, 0x0b, 0x14, 0x0b, 0x14, 0x19, 0x1c, 0x1a, 0x36, 0x13,
+  0x11, 0x0d, 0x0b, 0x0b, 0x0a, 0x14, 0x14, 0x1a, 0x18, 0x1d, 0x1e, 0x17,
+  0x19, 0x14, 0x0e, 0x0a, 0xfe, 0xda, 0x12, 0x0d, 0x10, 0x0e, 0x0b, 0x0b,
+  0x0b, 0x13, 0x14, 0x1a, 0x19, 0x1c, 0x1d, 0x19, 0x1a, 0x14, 0x12, 0x0c,
+  0x0b, 0x0b, 0x08, 0x09, 0x13, 0x1a, 0x19, 0x1c, 0x1d, 0x1a, 0x19, 0x14,
+  0x13, 0x0c, 0x0a, 0x0a, 0x0c, 0x13, 0x14, 0x19, 0x1a, 0x1d, 0x1c, 0x19,
+  0x1a, 0x13, 0x09, 0x08, 0x0b, 0x0b, 0x0c, 0x12, 0x14, 0x1a, 0x19, 0x1d,
+  0x1c, 0x19, 0x1a, 0x14, 0x13, 0x0b, 0x0b, 0x16, 0x13, 0x0d, 0x12, 0x01,
+  0x25, 0x09, 0x0e, 0x17, 0x16, 0x18, 0x1e, 0x1c, 0x19, 0x1a, 0x13, 0x16,
+  0x09, 0x0a, 0x0a, 0x0b, 0x14, 0x12, 0x1b, 0x17, 0x1e, 0x1d, 0x19, 0x13,
+  0x0c, 0x16, 0x09, 0x0a, 0x0a, 0x0b, 0x14, 0x12, 0x1b, 0x17, 0x3c, 0x17,
+  0x1b, 0x13, 0x11, 0x0d, 0x0b, 0x0b, 0x0a, 0x14, 0x0b, 0x14, 0x18, 0x1d,
+  0x1e, 0x17, 0x1b, 0x12, 0x14, 0x0b, 0x0b, 0x0b, 0x0b, 0x14, 0x13, 0x1a,
+  0x18, 0x1d, 0x1e, 0x17, 0x1a, 0x13, 0x0e, 0x0a, 0x01, 0x25, 0x11, 0x0d,
+  0x13, 0x0c, 0x0a, 0x0a, 0x0b, 0x28, 0x19, 0x1a, 0x1c, 0x19, 0x1d, 0x1a,
+  0x14, 0x12, 0x0c, 0x0a, 0x0a, 0x08, 0x0a, 0x14, 0x1a, 0x19, 0x1c, 0x1d,
+  0x19, 0x1a, 0x14, 0x12, 0x0c, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4e,
+  0xff, 0xe3, 0x05, 0xbc, 0x05, 0xf5, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x32,
+  0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
+  0x33, 0x22, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x34, 0x02, 0x27, 0x26,
+  0x27, 0x26, 0x4e, 0x8c, 0x7f, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x62,
+  0x7f, 0x7e, 0x8c, 0x8c, 0x7e, 0x7f, 0x62, 0x69, 0x63, 0x67, 0x65, 0x68,
+  0x78, 0x7f, 0x02, 0xec, 0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14, 0xa1, 0x9d,
+  0xfe, 0xf0, 0x77, 0x6e, 0x3c, 0x3b, 0x3b, 0x3c, 0x6e, 0x77, 0xfe, 0xf0,
+  0x9d, 0xa1, 0x01, 0x14, 0x6f, 0x72, 0x38, 0x3b, 0x00, 0x02, 0x00, 0x4e,
+  0xff, 0xe3, 0x05, 0xbc, 0x05, 0xf5, 0x00, 0x1b, 0x00, 0x37, 0x00, 0x00,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x34, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x14, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x21, 0x32, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35,
+  0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x33, 0x22, 0x07, 0x06, 0x07, 0x06,
+  0x02, 0x15, 0x34, 0x02, 0x27, 0x26, 0x27, 0x26, 0x01, 0x41, 0x5b, 0x53,
+  0x4e, 0x43, 0x42, 0x43, 0x40, 0x45, 0x3f, 0x52, 0x52, 0x5c, 0x5c, 0x52,
+  0x52, 0x3f, 0x45, 0x40, 0x43, 0x42, 0x43, 0x4e, 0x53, 0xfe, 0xb2, 0x8c,
+  0x7f, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x62, 0x7f, 0x7e, 0x8c, 0x8c,
+  0x7e, 0x7f, 0x62, 0x69, 0x63, 0x67, 0x65, 0x68, 0x78, 0x7f, 0x02, 0xec,
+  0x26, 0x25, 0x4a, 0x48, 0xb3, 0x69, 0x66, 0xb1, 0x4d, 0x48, 0x27, 0x26,
+  0x26, 0x27, 0x48, 0x4d, 0xb1, 0x66, 0x69, 0xb3, 0x48, 0x4a, 0x25, 0x26,
+  0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14, 0xa1, 0x9d, 0xfe, 0xf0, 0x77, 0x6e,
+  0x3c, 0x3b, 0x3b, 0x3c, 0x6e, 0x77, 0xfe, 0xf0, 0x9d, 0xa1, 0x01, 0x14,
+  0x6f, 0x72, 0x38, 0x3b, 0x00, 0x02, 0x00, 0x2a, 0xff, 0xec, 0x05, 0xdf,
+  0x05, 0xf3, 0x00, 0x09, 0x00, 0x13, 0x00, 0x00, 0x13, 0x25, 0x09, 0x01,
+  0x05, 0x01, 0x13, 0x25, 0x05, 0x13, 0x01, 0x03, 0x21, 0x01, 0x03, 0x09,
+  0x01, 0x03, 0x01, 0x21, 0x2a, 0x01, 0xd9, 0x01, 0x01, 0x01, 0x02, 0x01,
+  0xd8, 0xfe, 0xc9, 0x21, 0xfe, 0x3c, 0xfe, 0x3c, 0x22, 0x01, 0xa2, 0xac,
+  0xfd, 0xd3, 0x01, 0xc2, 0xac, 0x01, 0xc3, 0x01, 0xc3, 0xac, 0x01, 0xc2,
+  0xfd, 0xd3, 0x03, 0xa5, 0x83, 0x01, 0xcb, 0xfe, 0x35, 0x83, 0xfe, 0x61,
+  0xfd, 0xe6, 0xca, 0xca, 0x02, 0x1a, 0x03, 0xec, 0xfd, 0xb3, 0xfe, 0x94,
+  0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01, 0x6c, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x4d, 0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x09,
+  0x00, 0x24, 0x00, 0x00, 0x01, 0x03, 0x21, 0x01, 0x03, 0x09, 0x01, 0x03,
+  0x01, 0x21, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02,
+  0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34,
+  0x12, 0x37, 0x36, 0x37, 0x36, 0x03, 0x04, 0x9b, 0xfe, 0x0b, 0x01, 0x95,
+  0x9b, 0x01, 0x96, 0x01, 0x96, 0x9b, 0x01, 0x95, 0xfe, 0x0b, 0x9b, 0x8b,
+  0x80, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x63, 0x7d, 0x7f, 0xfe, 0xea,
+  0x80, 0x79, 0x67, 0x65, 0x68, 0x63, 0x6a, 0x61, 0x7f, 0x7e, 0x05, 0xea,
+  0xfd, 0xee, 0xfe, 0xb8, 0xfd, 0xef, 0x01, 0x48, 0xfe, 0xb8, 0x02, 0x11,
+  0x01, 0x48, 0x02, 0x18, 0x3b, 0x38, 0x72, 0x6f, 0xfe, 0xec, 0xa1, 0x98,
+  0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14,
+  0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x00, 0x02, 0x00, 0x2b,
+  0xff, 0xed, 0x05, 0xde, 0x05, 0xf2, 0x00, 0x1d, 0x00, 0x27, 0x00, 0x00,
+  0x00, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x13, 0x21, 0x01, 0x13, 0x09,
+  0x01, 0x13, 0x01, 0x21, 0x03, 0x40, 0x78, 0x33, 0x34, 0x2b, 0x2b, 0x15,
+  0x15, 0x15, 0x15, 0x2b, 0x2b, 0x34, 0x33, 0x78, 0x34, 0x33, 0x2b, 0x2c,
+  0x14, 0x16, 0x16, 0x14, 0x2c, 0x2b, 0x33, 0x70, 0xac, 0x02, 0x2d, 0xfe,
+  0x3e, 0xac, 0xfe, 0x3d, 0xfe, 0x3d, 0xac, 0xfe, 0x3e, 0x02, 0x2d, 0x03,
+  0xe4, 0x18, 0x1a, 0x2d, 0x32, 0x38, 0x3b, 0x42, 0x41, 0x3b, 0x38, 0x32,
+  0x2d, 0x1a, 0x18, 0x18, 0x1a, 0x2d, 0x32, 0x38, 0x3b, 0x41, 0x42, 0x3b,
+  0x38, 0x32, 0x2d, 0x1a, 0x02, 0x26, 0xfd, 0xb3, 0xfe, 0x94, 0xfd, 0xb4,
+  0x01, 0x6b, 0xfe, 0x95, 0x02, 0x4c, 0x01, 0x6c, 0x00, 0x03, 0x00, 0x2a,
+  0xff, 0xec, 0x05, 0xdf, 0x05, 0xf3, 0x00, 0x09, 0x00, 0x27, 0x00, 0x31,
+  0x00, 0x00, 0x13, 0x25, 0x09, 0x01, 0x05, 0x01, 0x13, 0x25, 0x05, 0x13,
+  0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x13, 0x03, 0x21, 0x01, 0x03, 0x09,
+  0x01, 0x03, 0x01, 0x21, 0x2a, 0x01, 0xd9, 0x01, 0x01, 0x01, 0x02, 0x01,
+  0xd8, 0xfe, 0xc9, 0x21, 0xfe, 0x3c, 0xfe, 0x3c, 0x22, 0x01, 0x66, 0x78,
+  0x34, 0x33, 0x2b, 0x2c, 0x14, 0x16, 0x16, 0x14, 0x2c, 0x2b, 0x33, 0x34,
+  0x78, 0x33, 0x34, 0x2b, 0x2b, 0x15, 0x15, 0x15, 0x15, 0x2b, 0x2b, 0x34,
+  0x6f, 0xac, 0xfd, 0xd3, 0x01, 0xc2, 0xac, 0x01, 0xc3, 0x01, 0xc3, 0xac,
+  0x01, 0xc2, 0xfd, 0xd3, 0x03, 0xa5, 0x83, 0x01, 0xcb, 0xfe, 0x35, 0x83,
+  0xfe, 0x61, 0xfd, 0xe6, 0xca, 0xca, 0x02, 0x1a, 0x01, 0xde, 0x18, 0x1a,
+  0x2d, 0x32, 0x38, 0x3b, 0x42, 0x41, 0x3b, 0x38, 0x32, 0x2d, 0x1a, 0x18,
+  0x18, 0x1a, 0x2d, 0x32, 0x38, 0x3b, 0x41, 0x42, 0x3b, 0x38, 0x32, 0x2d,
+  0x1a, 0x02, 0x26, 0xfd, 0xb3, 0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6b, 0xfe,
+  0x95, 0x02, 0x4c, 0x01, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x2b,
+  0xff, 0xed, 0x05, 0xde, 0x05, 0xf2, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x13, 0x21, 0x07, 0x13, 0x27, 0x07, 0x13, 0x27, 0x21,
+  0x13, 0x03, 0x21, 0x01, 0x03, 0x09, 0x01, 0x03, 0x01, 0x21, 0x03, 0x13,
+  0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x01, 0x21, 0x03, 0x04, 0x57, 0x01,
+  0x16, 0xe1, 0x55, 0xe1, 0xe1, 0x56, 0xe1, 0x01, 0x16, 0x56, 0x80, 0xfe,
+  0x5d, 0x01, 0x52, 0x81, 0x01, 0x52, 0x01, 0x53, 0x82, 0x01, 0x52, 0xfe,
+  0x5e, 0x81, 0xac, 0x02, 0x2d, 0xfe, 0x3e, 0xac, 0xfe, 0x3d, 0xfe, 0x3d,
+  0xac, 0xfe, 0x3e, 0x02, 0x2d, 0x04, 0x49, 0xfe, 0xd9, 0xb6, 0xfe, 0xda,
+  0xb6, 0xb6, 0x01, 0x26, 0xb6, 0x01, 0xfb, 0xfe, 0x47, 0xfe, 0xef, 0xfe,
+  0x47, 0x01, 0x11, 0xfe, 0xef, 0x01, 0xb9, 0x01, 0x11, 0x02, 0x8e, 0xfd,
+  0xb3, 0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01,
+  0x6c, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x2b, 0xff, 0xed, 0x05, 0xde,
+  0x05, 0xf2, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x17,
+  0x33, 0x07, 0x17, 0x27, 0x07, 0x37, 0x27, 0x33, 0x1b, 0x01, 0x21, 0x01,
+  0x13, 0x09, 0x01, 0x13, 0x01, 0x21, 0x37, 0x03, 0x21, 0x05, 0x03, 0x25,
+  0x05, 0x03, 0x25, 0x21, 0x03, 0x04, 0x22, 0x70, 0x5a, 0x22, 0x5a, 0x5a,
+  0x22, 0x5a, 0x70, 0x22, 0xac, 0x02, 0x2d, 0xfe, 0x3e, 0xac, 0xfe, 0x3d,
+  0xfe, 0x3d, 0xac, 0xfe, 0x3e, 0x02, 0x2d, 0xac, 0x67, 0xfe, 0xaf, 0x01,
+  0x11, 0x69, 0x01, 0x10, 0x01, 0x11, 0x69, 0x01, 0x10, 0xfe, 0xb0, 0x03,
+  0x49, 0x76, 0x49, 0x76, 0x49, 0x49, 0x76, 0x49, 0x03, 0x1f, 0xfd, 0xb3,
+  0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01, 0x6c,
+  0xfb, 0xfe, 0x9d, 0xdb, 0xfe, 0x9d, 0xdb, 0xdb, 0x01, 0x63, 0xdb, 0x00,
+  0x00, 0x06, 0x00, 0x2b, 0xff, 0xed, 0x05, 0xde, 0x05, 0xf2, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x18, 0x00, 0x00,
+  0x25, 0x01, 0x35, 0x25, 0x01, 0x37, 0x01, 0x03, 0x27, 0x25, 0x21, 0x07,
+  0x0b, 0x01, 0x17, 0x11, 0x13, 0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x01,
+  0x21, 0x01, 0xb1, 0x01, 0x52, 0xfd, 0xdd, 0x01, 0x52, 0xd1, 0x01, 0x55,
+  0x82, 0xd1, 0x02, 0x23, 0xfe, 0x5e, 0x81, 0x01, 0x80, 0x80, 0xac, 0x02,
+  0x2d, 0xfe, 0x3e, 0xac, 0xfe, 0x3d, 0xfe, 0x3d, 0xac, 0xfe, 0x3e, 0x02,
+  0x2d, 0x99, 0x01, 0x11, 0xf3, 0xc7, 0xfe, 0xef, 0x4b, 0xfd, 0xfb, 0x01,
+  0xb9, 0x4b, 0xc7, 0xc6, 0x02, 0x80, 0xfe, 0x47, 0xc6, 0x03, 0x53, 0xfd,
+  0xb3, 0xfe, 0x94, 0xfd, 0xb4, 0x01, 0x6c, 0xfe, 0x94, 0x02, 0x4c, 0x01,
+  0x6c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x2d, 0x00, 0x18, 0x05, 0xdf,
+  0x05, 0xb7, 0x00, 0x0d, 0x00, 0x17, 0x00, 0x00, 0x09, 0x01, 0x13, 0x27,
+  0x25, 0x01, 0x27, 0x13, 0x01, 0x21, 0x13, 0x17, 0x13, 0x21, 0x01, 0x03,
+  0x21, 0x05, 0x03, 0x01, 0x05, 0x03, 0x01, 0x21, 0x05, 0xdf, 0xfe, 0x6b,
+  0x9b, 0x92, 0xfe, 0xd3, 0xfe, 0x93, 0x92, 0x9b, 0xfe, 0x6b, 0x01, 0xf5,
+  0x9b, 0x92, 0x8b, 0x01, 0x73, 0xfd, 0x70, 0x79, 0xfe, 0x7b, 0x01, 0x3b,
+  0x79, 0x01, 0x3c, 0x01, 0x3c, 0x79, 0x01, 0x3b, 0xfe, 0x7b, 0x03, 0x71,
+  0xfe, 0xb8, 0xfd, 0xef, 0x34, 0xf3, 0xfe, 0xd9, 0x34, 0x02, 0x11, 0x01,
+  0x48, 0x02, 0x12, 0x34, 0xfe, 0x22, 0x01, 0x68, 0xfe, 0x64, 0xff, 0xfe,
+  0x64, 0x00, 0xff, 0xff, 0x01, 0x9c, 0x00, 0xff, 0x00, 0x01, 0x00, 0x76,
+  0x00, 0x00, 0x05, 0x92, 0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x25, 0x13, 0x0d, 0x01, 0x03, 0x25, 0x11, 0x21, 0x11, 0x05,
+  0x03, 0x2d, 0x01, 0x13, 0x02, 0x74, 0x01, 0x20, 0x01, 0x6e, 0x90, 0xfe,
+  0x92, 0x01, 0x6e, 0x90, 0xfe, 0x92, 0xfe, 0xe0, 0xfe, 0x93, 0x90, 0x01,
+  0x6c, 0xfe, 0x94, 0x90, 0x04, 0x00, 0x01, 0xd5, 0xfe, 0x2a, 0xeb, 0xfe,
+  0xeb, 0xea, 0xeb, 0xfe, 0xeb, 0xeb, 0xfe, 0x2a, 0x01, 0xd6, 0xeb, 0x01,
+  0x15, 0xeb, 0xea, 0x01, 0x15, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x88,
+  0x00, 0x00, 0x05, 0x80, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x17, 0x00, 0x00,
+  0x01, 0x07, 0x17, 0x33, 0x37, 0x27, 0x05, 0x01, 0x37, 0x01, 0x11, 0x33,
+  0x11, 0x01, 0x17, 0x09, 0x01, 0x07, 0x01, 0x11, 0x23, 0x11, 0x01, 0x27,
+  0x02, 0x99, 0x6c, 0x6c, 0xd6, 0x6c, 0x6c, 0xfe, 0xbd, 0xfe, 0x5d, 0x6c,
+  0x01, 0xa3, 0xd8, 0x01, 0xa4, 0x6c, 0xfe, 0x5c, 0x01, 0xa4, 0x6c, 0xfe,
+  0x5c, 0xd8, 0xfe, 0x5d, 0x6c, 0x03, 0xb9, 0xce, 0xd0, 0xd0, 0xce, 0xce,
+  0x01, 0x0d, 0xd0, 0xfe, 0xf2, 0x02, 0x1b, 0xfd, 0xe5, 0x01, 0x0e, 0xd0,
+  0xfe, 0xf3, 0xfe, 0xf2, 0xd0, 0x01, 0x0d, 0xfd, 0xe6, 0x02, 0x1a, 0xfe,
+  0xf3, 0xd0, 0x00, 0x00, 0x00, 0x01, 0x00, 0x64, 0x00, 0x00, 0x05, 0xa4,
+  0x05, 0xd5, 0x00, 0x17, 0x00, 0x00, 0x09, 0x01, 0x07, 0x01, 0x11, 0x23,
+  0x11, 0x01, 0x27, 0x01, 0x21, 0x35, 0x21, 0x01, 0x37, 0x01, 0x11, 0x33,
+  0x11, 0x01, 0x17, 0x01, 0x21, 0x15, 0x03, 0x72, 0x01, 0x8d, 0x40, 0xfe,
+  0x72, 0x5a, 0xfe, 0x72, 0x3f, 0x01, 0x8d, 0xfd, 0xce, 0x02, 0x33, 0xfe,
+  0x72, 0x3f, 0x01, 0x8e, 0x5a, 0x01, 0x8e, 0x40, 0xfe, 0x71, 0x02, 0x34,
+  0x02, 0xb8, 0xfe, 0x46, 0x47, 0x01, 0xbb, 0xfd, 0x8e, 0x02, 0x71, 0xfe,
+  0x46, 0x47, 0x01, 0xba, 0x64, 0x01, 0xbb, 0x47, 0xfe, 0x46, 0x02, 0x71,
+  0xfd, 0x8f, 0x01, 0xba, 0x47, 0xfe, 0x45, 0x64, 0x00, 0x01, 0x00, 0x39,
+  0xff, 0xe3, 0x05, 0xab, 0x05, 0xf0, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x13,
+  0x09, 0x01, 0x0d, 0x01, 0x09, 0x01, 0x0b, 0x01, 0x09, 0x01, 0x2d, 0x01,
+  0x09, 0x01, 0x02, 0xf2, 0x47, 0x01, 0xa5, 0xfe, 0xc1, 0x02, 0x0c, 0xfd,
+  0xf4, 0x01, 0x3f, 0xfe, 0x5b, 0x47, 0x47, 0xfe, 0x5b, 0x01, 0x3f, 0xfd,
+  0xf5, 0x02, 0x0b, 0xfe, 0xc1, 0x01, 0xa5, 0x05, 0xf0, 0xfd, 0xb9, 0x01,
+  0x64, 0xfe, 0x2c, 0x50, 0x4f, 0xfe, 0x2c, 0x01, 0x64, 0xfd, 0xb9, 0x02,
+  0x47, 0xfe, 0x9c, 0x01, 0xd4, 0x4f, 0x50, 0x01, 0xd4, 0xfe, 0x9c, 0x00,
+  0x00, 0x09, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x02,
+  0x00, 0x05, 0x00, 0x08, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x11, 0x00, 0x14,
+  0x00, 0x17, 0x00, 0x27, 0x00, 0x00, 0x01, 0x05, 0x03, 0x05, 0x25, 0x05,
+  0x01, 0x03, 0x25, 0x03, 0x13, 0x03, 0x01, 0x25, 0x13, 0x25, 0x05, 0x25,
+  0x01, 0x13, 0x05, 0x13, 0x03, 0x13, 0x11, 0x13, 0x25, 0x03, 0x0d, 0x01,
+  0x13, 0x25, 0x0b, 0x01, 0x05, 0x13, 0x2d, 0x01, 0x03, 0x05, 0x04, 0x76,
+  0xfe, 0xfa, 0x6b, 0x02, 0x0a, 0xfe, 0xf8, 0xfe, 0xfe, 0x01, 0x71, 0x6f,
+  0xfe, 0xfe, 0x01, 0x6b, 0x6b, 0xfe, 0x8e, 0x01, 0x06, 0x6b, 0xfd, 0xf6,
+  0x01, 0x08, 0x01, 0x02, 0xfe, 0x8f, 0x6f, 0x01, 0x02, 0x01, 0x6b, 0x6b,
+  0x8f, 0x01, 0x5d, 0x93, 0x01, 0x60, 0xfe, 0xa0, 0x93, 0xfe, 0xa3, 0x8f,
+  0x8f, 0xfe, 0xa3, 0x94, 0xfe, 0xa0, 0x01, 0x60, 0x94, 0x01, 0x5d, 0x04,
+  0x85, 0x7b, 0xfe, 0xe0, 0x01, 0x78, 0x78, 0xfe, 0x65, 0x01, 0x23, 0x77,
+  0xfd, 0xbc, 0x01, 0x25, 0x01, 0x1f, 0xfe, 0x66, 0x7b, 0x01, 0x1f, 0x01,
+  0x77, 0x77, 0x01, 0x9c, 0xfe, 0xdd, 0x78, 0x02, 0x45, 0xfe, 0xdb, 0xfe,
+  0xe0, 0x03, 0x06, 0xfe, 0x79, 0xa4, 0xfe, 0x7c, 0xa0, 0x9f, 0xfe, 0x7c,
+  0xa4, 0xfe, 0x79, 0x01, 0x87, 0xa4, 0x01, 0x84, 0x9f, 0xa0, 0x01, 0x84,
+  0xa4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa8, 0xff, 0xe3, 0x05, 0x61,
+  0x05, 0xf0, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x13, 0x25, 0x09, 0x01, 0x25,
+  0x0b, 0x01, 0x05, 0x09, 0x01, 0x05, 0x03, 0x04, 0x65, 0x01, 0xf7, 0xfe,
+  0x6e, 0x01, 0x92, 0xfe, 0x09, 0x65, 0x65, 0xfe, 0x09, 0x01, 0x93, 0xfe,
+  0x6d, 0x01, 0xf7, 0x05, 0xf0, 0xfd, 0xbc, 0xc1, 0xfe, 0x7d, 0xfe, 0x7d,
+  0xc1, 0xfd, 0xbb, 0x02, 0x45, 0xc1, 0x01, 0x83, 0x01, 0x83, 0xc1, 0x00,
+  0x00, 0x01, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x0f,
+  0x00, 0x00, 0x01, 0x13, 0x01, 0x03, 0x0d, 0x01, 0x13, 0x01, 0x0b, 0x01,
+  0x01, 0x13, 0x2d, 0x01, 0x03, 0x01, 0x03, 0x04, 0x66, 0x01, 0x86, 0xf5,
+  0x01, 0xc2, 0xfe, 0x3e, 0xf5, 0xfe, 0x7a, 0x66, 0x66, 0xfe, 0x7a, 0xf6,
+  0xfe, 0x3e, 0x01, 0xc2, 0xf6, 0x01, 0x86, 0x05, 0xf0, 0xfe, 0x0b, 0x01,
+  0x12, 0xfe, 0x4e, 0x72, 0x71, 0xfe, 0x4e, 0x01, 0x12, 0xfe, 0x0b, 0x01,
+  0xf5, 0xfe, 0xee, 0x01, 0xb2, 0x71, 0x72, 0x01, 0xb2, 0xfe, 0xee, 0x00,
+  0x00, 0x01, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x0f,
+  0x00, 0x00, 0x01, 0x13, 0x25, 0x03, 0x0d, 0x01, 0x13, 0x25, 0x0b, 0x01,
+  0x05, 0x13, 0x2d, 0x01, 0x03, 0x05, 0x03, 0x04, 0x99, 0x01, 0x53, 0x7b,
+  0x01, 0x48, 0xfe, 0xb8, 0x7b, 0xfe, 0xad, 0x99, 0x99, 0xfe, 0xad, 0x7b,
+  0xfe, 0xb9, 0x01, 0x47, 0x7b, 0x01, 0x53, 0x05, 0xf0, 0xfe, 0x94, 0x89,
+  0xfe, 0x87, 0xab, 0xaa, 0xfe, 0x87, 0x89, 0xfe, 0x94, 0x01, 0x6c, 0x89,
+  0x01, 0x79, 0xaa, 0xab, 0x01, 0x79, 0x89, 0x00, 0x00, 0x01, 0x00, 0x4b,
+  0xff, 0xe3, 0x05, 0xbd, 0x05, 0xf0, 0x00, 0x17, 0x00, 0x00, 0x01, 0x13,
+  0x37, 0x03, 0x25, 0x03, 0x0d, 0x01, 0x13, 0x25, 0x13, 0x27, 0x0b, 0x01,
+  0x07, 0x13, 0x05, 0x13, 0x2d, 0x01, 0x03, 0x05, 0x03, 0x17, 0x03, 0x04,
+  0x69, 0xf3, 0x3f, 0x01, 0x3f, 0xd7, 0x01, 0x34, 0xfe, 0xcc, 0xd7, 0xfe,
+  0xc1, 0x3f, 0xf3, 0x69, 0x68, 0xf4, 0x40, 0xfe, 0xc0, 0xd7, 0xfe, 0xcd,
+  0x01, 0x33, 0xd7, 0x01, 0x40, 0x40, 0xf4, 0x05, 0xf0, 0xfe, 0xa9, 0xef,
+  0xfe, 0x9d, 0x47, 0xfe, 0xf1, 0x73, 0x74, 0xfe, 0xf1, 0x47, 0xfe, 0x9d,
+  0xef, 0xfe, 0xa9, 0x01, 0x57, 0xef, 0x01, 0x63, 0x47, 0x01, 0x0f, 0x74,
+  0x73, 0x01, 0x0f, 0x47, 0x01, 0x63, 0xef, 0x00, 0x00, 0x01, 0x00, 0x64,
+  0x00, 0x00, 0x05, 0xa4, 0x05, 0xd5, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x11,
+  0x33, 0x11, 0x13, 0x17, 0x03, 0x01, 0x17, 0x01, 0x25, 0x17, 0x05, 0x21,
+  0x15, 0x21, 0x05, 0x07, 0x25, 0x01, 0x07, 0x01, 0x13, 0x07, 0x03, 0x11,
+  0x23, 0x11, 0x03, 0x27, 0x13, 0x01, 0x27, 0x01, 0x05, 0x27, 0x25, 0x21,
+  0x35, 0x21, 0x25, 0x37, 0x05, 0x01, 0x37, 0x01, 0x03, 0x37, 0x02, 0xce,
+  0x6c, 0x99, 0x64, 0x99, 0x01, 0x1b, 0x4c, 0xfe, 0xe5, 0x01, 0x72, 0x2a,
+  0xfe, 0x8c, 0x01, 0x92, 0xfe, 0x72, 0x01, 0x70, 0x2a, 0xfe, 0x8e, 0x01,
+  0x1b, 0x4c, 0xfe, 0xe6, 0x98, 0x64, 0x99, 0x6c, 0x99, 0x64, 0x99, 0xfe,
+  0xe6, 0x4d, 0x01, 0x1b, 0xfe, 0x8e, 0x2a, 0x01, 0x72, 0xfe, 0x71, 0x01,
+  0x91, 0xfe, 0x8c, 0x2a, 0x01, 0x70, 0xfe, 0xe7, 0x4d, 0x01, 0x19, 0x98,
+  0x64, 0x04, 0x17, 0x01, 0xbe, 0xfe, 0x45, 0x01, 0x99, 0x2e, 0xfe, 0x66,
+  0x01, 0x3a, 0x55, 0xfe, 0xc5, 0xab, 0x6f, 0xab, 0x78, 0xaa, 0x6f, 0xac,
+  0xfe, 0xc4, 0x55, 0x01, 0x39, 0xfe, 0x67, 0x2e, 0x01, 0x98, 0xfe, 0x46,
+  0x01, 0xbc, 0xfe, 0x66, 0x2e, 0x01, 0x9b, 0xfe, 0xc5, 0x55, 0x01, 0x3a,
+  0xaa, 0x6f, 0xaa, 0x78, 0xab, 0x6f, 0xa9, 0x01, 0x39, 0x55, 0xfe, 0xc7,
+  0x01, 0x99, 0x2e, 0x00, 0x00, 0x01, 0x00, 0x96, 0xff, 0xe3, 0x05, 0x73,
+  0x05, 0xf0, 0x00, 0x9b, 0x00, 0x00, 0x01, 0x35, 0x34, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d, 0x01,
+  0x17, 0x16, 0x17, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x22,
+  0x23, 0x22, 0x0f, 0x01, 0x16, 0x15, 0x14, 0x07, 0x17, 0x16, 0x33, 0x32,
+  0x3b, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x0f, 0x01,
+  0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x3d, 0x01, 0x26, 0x27, 0x26, 0x27, 0x07, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x33, 0x32, 0x3f, 0x01, 0x26, 0x35,
+  0x34, 0x37, 0x27, 0x26, 0x23, 0x22, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x1f, 0x01, 0x36, 0x37, 0x36, 0x02, 0xd6, 0x43, 0x28, 0x31, 0x32,
+  0x6c, 0x33, 0x30, 0x27, 0x45, 0x0f, 0x1c, 0x15, 0x09, 0x66, 0x3a, 0x23,
+  0x3d, 0x36, 0x2e, 0x14, 0x13, 0x40, 0x1b, 0x12, 0x04, 0x0d, 0x4e, 0x38,
+  0x45, 0x0a, 0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04, 0x05, 0x0b, 0x5c, 0x75,
+  0x0a, 0x09, 0x0a, 0x45, 0x38, 0x4e, 0x0d, 0x04, 0x12, 0x1b, 0x40, 0x13,
+  0x14, 0x2e, 0x36, 0x3d, 0x23, 0x3c, 0x63, 0x0d, 0x18, 0x16, 0x0f, 0x45,
+  0x27, 0x30, 0x33, 0x6c, 0x32, 0x31, 0x28, 0x45, 0x08, 0x07, 0x1a, 0x15,
+  0x0d, 0x63, 0x3c, 0x23, 0x3c, 0x36, 0x2f, 0x14, 0x13, 0x40, 0x1b, 0x12,
+  0x05, 0x0c, 0x4f, 0x38, 0x44, 0x0b, 0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04,
+  0x03, 0x0a, 0x5a, 0x76, 0x09, 0x0a, 0x0b, 0x44, 0x38, 0x4f, 0x0c, 0x05,
+  0x12, 0x1b, 0x40, 0x13, 0x14, 0x2f, 0x36, 0x3c, 0x23, 0x3e, 0x61, 0x0a,
+  0x18, 0x1a, 0x07, 0x03, 0x94, 0x0c, 0x80, 0x77, 0x46, 0x4e, 0x64, 0x30,
+  0x31, 0x31, 0x30, 0x64, 0x4e, 0x46, 0x79, 0x7e, 0x0c, 0x06, 0x0e, 0x17,
+  0x06, 0x44, 0x7a, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34, 0x23, 0x2c, 0x16,
+  0x18, 0x47, 0x32, 0x24, 0x3a, 0x07, 0x13, 0x14, 0x15, 0x14, 0x07, 0x3b,
+  0x24, 0x32, 0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18, 0x07, 0x23, 0x27,
+  0x49, 0x7e, 0x3f, 0x08, 0x19, 0x09, 0x06, 0x0f, 0x7f, 0x79, 0x46, 0x4e,
+  0x64, 0x30, 0x31, 0x31, 0x30, 0x64, 0x4e, 0x46, 0x79, 0x7f, 0x0f, 0x03,
+  0x03, 0x0d, 0x15, 0x08, 0x3f, 0x7e, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34,
+  0x23, 0x2c, 0x16, 0x18, 0x47, 0x32, 0x24, 0x3a, 0x07, 0x14, 0x16, 0x14,
+  0x13, 0x07, 0x3a, 0x24, 0x32, 0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18,
+  0x07, 0x23, 0x27, 0x49, 0x82, 0x3b, 0x06, 0x19, 0x0b, 0x03, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x96, 0xff, 0xe3, 0x05, 0x73, 0x05, 0xf0, 0x00, 0x19,
+  0x00, 0xb5, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01,
+  0x35, 0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x35, 0x34, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d, 0x01,
+  0x17, 0x16, 0x17, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x22,
+  0x23, 0x22, 0x0f, 0x01, 0x16, 0x15, 0x14, 0x07, 0x17, 0x16, 0x33, 0x32,
+  0x3b, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x0f, 0x01,
+  0x15, 0x14, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x3d, 0x01, 0x26, 0x27, 0x26, 0x27, 0x07, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x33, 0x32, 0x3f, 0x01, 0x26, 0x35,
+  0x34, 0x37, 0x27, 0x26, 0x23, 0x22, 0x2b, 0x01, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x1f, 0x01, 0x36, 0x37, 0x36, 0x03, 0x17, 0x26, 0x0f, 0x10, 0x0d,
+  0x0d, 0x0e, 0x0e, 0x0d, 0x0d, 0x10, 0x0f, 0x26, 0x0f, 0x11, 0x0c, 0x0e,
+  0x0d, 0x0d, 0x0e, 0x0c, 0x11, 0x50, 0x43, 0x28, 0x31, 0x32, 0x6c, 0x33,
+  0x30, 0x27, 0x45, 0x0f, 0x1c, 0x15, 0x09, 0x66, 0x3a, 0x23, 0x3d, 0x36,
+  0x2e, 0x14, 0x13, 0x40, 0x1b, 0x12, 0x04, 0x0d, 0x4e, 0x38, 0x45, 0x0a,
+  0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04, 0x05, 0x0b, 0x5c, 0x75, 0x0a, 0x09,
+  0x0a, 0x45, 0x38, 0x4e, 0x0d, 0x04, 0x12, 0x1b, 0x40, 0x13, 0x14, 0x2e,
+  0x36, 0x3d, 0x23, 0x3c, 0x63, 0x0d, 0x18, 0x16, 0x0f, 0x45, 0x27, 0x30,
+  0x33, 0x6c, 0x32, 0x31, 0x28, 0x45, 0x08, 0x07, 0x1a, 0x15, 0x0d, 0x63,
+  0x3c, 0x23, 0x3c, 0x36, 0x2f, 0x14, 0x13, 0x40, 0x1b, 0x12, 0x05, 0x0c,
+  0x4f, 0x38, 0x44, 0x0b, 0x0a, 0x09, 0x76, 0x5a, 0x0b, 0x04, 0x03, 0x0a,
+  0x5a, 0x76, 0x09, 0x0a, 0x0b, 0x44, 0x38, 0x4f, 0x0c, 0x05, 0x12, 0x1b,
+  0x40, 0x13, 0x14, 0x2f, 0x36, 0x3c, 0x23, 0x3e, 0x61, 0x0a, 0x18, 0x1a,
+  0x07, 0x03, 0x50, 0x08, 0x08, 0x0e, 0x0f, 0x23, 0x15, 0x14, 0x23, 0x0f,
+  0x0e, 0x08, 0x08, 0x08, 0x08, 0x0e, 0x0f, 0x23, 0x14, 0x15, 0x23, 0x0f,
+  0x0e, 0x08, 0x4c, 0x0c, 0x80, 0x77, 0x46, 0x4e, 0x64, 0x30, 0x31, 0x31,
+  0x30, 0x64, 0x4e, 0x46, 0x79, 0x7e, 0x0c, 0x06, 0x0e, 0x17, 0x06, 0x44,
+  0x7a, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34, 0x23, 0x2c, 0x16, 0x18, 0x47,
+  0x32, 0x24, 0x3a, 0x07, 0x13, 0x14, 0x15, 0x14, 0x07, 0x3b, 0x24, 0x32,
+  0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18, 0x07, 0x23, 0x27, 0x49, 0x7e,
+  0x3f, 0x08, 0x19, 0x09, 0x06, 0x0f, 0x7f, 0x79, 0x46, 0x4e, 0x64, 0x30,
+  0x31, 0x31, 0x30, 0x64, 0x4e, 0x46, 0x79, 0x7f, 0x0f, 0x03, 0x03, 0x0d,
+  0x15, 0x08, 0x3f, 0x7e, 0x49, 0x27, 0x23, 0x07, 0x18, 0x34, 0x23, 0x2c,
+  0x16, 0x18, 0x47, 0x32, 0x24, 0x3a, 0x07, 0x14, 0x16, 0x14, 0x13, 0x07,
+  0x3a, 0x24, 0x32, 0x47, 0x18, 0x16, 0x2c, 0x23, 0x34, 0x18, 0x07, 0x23,
+  0x27, 0x49, 0x82, 0x3b, 0x06, 0x19, 0x0b, 0x03, 0x00, 0x01, 0x00, 0x90,
+  0xff, 0xe3, 0x05, 0x77, 0x05, 0xf0, 0x00, 0x68, 0x00, 0x00, 0x01, 0x17,
+  0x32, 0x3f, 0x01, 0x27, 0x26, 0x23, 0x07, 0x22, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x35, 0x34,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x14, 0x07, 0x06, 0x1d,
+  0x01, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x0e, 0x01, 0x23, 0x27, 0x22, 0x0f, 0x01, 0x17, 0x16, 0x33, 0x37, 0x32,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x2f, 0x01, 0x15, 0x14, 0x17, 0x16, 0x14, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x3d, 0x01, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x3e, 0x01, 0x01, 0x89, 0x8f, 0x49, 0x1e,
+  0x2a, 0x2a, 0x1c, 0x4d, 0x87, 0x51, 0x92, 0x10, 0x0a, 0x16, 0x26, 0x63,
+  0x12, 0x46, 0x8a, 0x27, 0x40, 0x32, 0x2b, 0x5f, 0x3a, 0x31, 0x4a, 0x97,
+  0x4a, 0x30, 0x39, 0x60, 0x2b, 0x2b, 0x48, 0x2c, 0x84, 0x46, 0x12, 0xa0,
+  0x0a, 0x11, 0x91, 0x4c, 0x8e, 0x48, 0x20, 0x2b, 0x2b, 0x1c, 0x4e, 0x87,
+  0x51, 0x91, 0x11, 0x0a, 0x17, 0x28, 0x61, 0x13, 0x47, 0x39, 0x4f, 0x26,
+  0x40, 0x33, 0x2b, 0x60, 0x39, 0x30, 0x4a, 0x9b, 0x46, 0x31, 0x3a, 0x5f,
+  0x2b, 0x2e, 0x44, 0x2b, 0x86, 0x46, 0x12, 0xa0, 0x0b, 0x11, 0x91, 0x02,
+  0xc4, 0x0a, 0x14, 0x1c, 0x1b, 0x12, 0x07, 0x5d, 0x48, 0x2c, 0x60, 0x2c,
+  0x48, 0x20, 0x06, 0x59, 0x63, 0xa2, 0x21, 0x1c, 0x37, 0x37, 0x99, 0x5c,
+  0xca, 0x34, 0x4f, 0x4f, 0x34, 0xd0, 0x56, 0x8f, 0x41, 0x37, 0x1c, 0x1c,
+  0xa7, 0x67, 0x55, 0x06, 0x33, 0x9a, 0x27, 0x2c, 0x48, 0x5e, 0x0a, 0x14,
+  0x1b, 0x1c, 0x12, 0x07, 0x5d, 0x48, 0x2c, 0x60, 0x2c, 0x4c, 0x1c, 0x06,
+  0x26, 0x33, 0x63, 0xa2, 0x21, 0x1c, 0x37, 0x37, 0x99, 0x5c, 0xca, 0x34,
+  0x4f, 0x4f, 0x37, 0xcd, 0x56, 0x8f, 0x41, 0x37, 0x1c, 0x1e, 0xa5, 0x66,
+  0x56, 0x06, 0x34, 0x9a, 0x26, 0x2c, 0x48, 0x5e, 0x00, 0x04, 0x00, 0x90,
+  0xff, 0xe3, 0x05, 0x77, 0x05, 0xf0, 0x00, 0x0e, 0x00, 0x99, 0x00, 0xb1,
+  0x00, 0xc9, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x13, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x15, 0x14,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x3d, 0x01, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x33, 0x32, 0x3f, 0x01, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x35, 0x34, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d,
+  0x01, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x05, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x36, 0x25, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x23, 0x22, 0x03, 0x04, 0x19, 0x33, 0x21, 0x1b, 0x2c, 0x4c, 0x2c, 0x1b,
+  0x22, 0x32, 0x97, 0x10, 0x30, 0x5b, 0x1d, 0x21, 0x10, 0x0f, 0x51, 0x3f,
+  0x52, 0x11, 0x0a, 0x17, 0x27, 0x62, 0x12, 0x13, 0x33, 0x3b, 0x4b, 0x2a,
+  0x39, 0x43, 0x10, 0x4e, 0x39, 0x30, 0x4a, 0x4c, 0x4f, 0x46, 0x31, 0x3a,
+  0x4d, 0x10, 0x40, 0x3b, 0x2c, 0x49, 0x3c, 0x32, 0x14, 0x12, 0x63, 0x26,
+  0x16, 0x0a, 0x10, 0x53, 0x3f, 0x51, 0x0e, 0x10, 0x22, 0x1c, 0x5b, 0x30,
+  0x10, 0x10, 0x2e, 0x5b, 0x1d, 0x23, 0x10, 0x0e, 0x51, 0x3f, 0x51, 0x12,
+  0x0b, 0x17, 0x26, 0x63, 0x12, 0x14, 0x32, 0x3c, 0x4a, 0x2b, 0x38, 0x43,
+  0x10, 0x4d, 0x3a, 0x31, 0x4a, 0x97, 0x4a, 0x30, 0x39, 0x4e, 0x10, 0x40,
+  0x3c, 0x2c, 0x49, 0x3b, 0x33, 0x13, 0x12, 0x62, 0x27, 0x17, 0x0a, 0x11,
+  0x52, 0x3f, 0x51, 0x0f, 0x10, 0x22, 0x1e, 0x5b, 0x2e, 0xfe, 0xbc, 0x3d,
+  0x3a, 0x1b, 0x1a, 0x08, 0x0a, 0x2f, 0x36, 0x35, 0x07, 0x04, 0x0c, 0x13,
+  0x37, 0x09, 0x0b, 0x1c, 0x27, 0x3f, 0x16, 0x21, 0x01, 0xac, 0x41, 0x20,
+  0x17, 0x3f, 0x26, 0x1c, 0x0b, 0x09, 0x38, 0x13, 0x0c, 0x05, 0x06, 0x35,
+  0x36, 0x30, 0x09, 0x08, 0x1a, 0x1b, 0x3b, 0x03, 0xd3, 0x63, 0x4a, 0x32,
+  0x51, 0x44, 0x1a, 0x2b, 0x2b, 0x1a, 0x44, 0x51, 0x32, 0x4a, 0xfe, 0xb4,
+  0x0b, 0x20, 0x03, 0x01, 0x28, 0x35, 0x48, 0x2c, 0x27, 0x39, 0x2c, 0x4a,
+  0x1e, 0x06, 0x26, 0x30, 0x66, 0x89, 0x29, 0x0a, 0x14, 0x54, 0x7c, 0x5c,
+  0x60, 0x6a, 0x34, 0x4f, 0x4f, 0x37, 0x67, 0x60, 0x5c, 0x7c, 0x54, 0x14,
+  0x0a, 0x27, 0x8b, 0x67, 0x2f, 0x26, 0x06, 0x20, 0x48, 0x2c, 0x39, 0x27,
+  0x2c, 0x49, 0x34, 0x28, 0x01, 0x03, 0x20, 0x0b, 0x0b, 0x1f, 0x03, 0x01,
+  0x28, 0x33, 0x4a, 0x2c, 0x26, 0x39, 0x2d, 0x48, 0x20, 0x06, 0x26, 0x30,
+  0x66, 0x89, 0x29, 0x0a, 0x14, 0x54, 0x7c, 0x5c, 0x60, 0x6a, 0x34, 0x4f,
+  0x4f, 0x34, 0x6a, 0x60, 0x5c, 0x7c, 0x54, 0x14, 0x0a, 0x27, 0x8b, 0x67,
+  0x2f, 0x26, 0x06, 0x1e, 0x4a, 0x2c, 0x39, 0x27, 0x2c, 0x48, 0x35, 0x28,
+  0x01, 0x03, 0x1f, 0x80, 0x12, 0x04, 0x01, 0x22, 0x22, 0x27, 0x18, 0x15,
+  0x21, 0x17, 0x24, 0x15, 0x04, 0x19, 0x28, 0x3a, 0x55, 0x4a, 0x4a, 0x55,
+  0x3a, 0x28, 0x19, 0x04, 0x15, 0x24, 0x17, 0x21, 0x15, 0x18, 0x27, 0x22,
+  0x22, 0x01, 0x04, 0x00, 0x00, 0x02, 0x00, 0x63, 0x00, 0x00, 0x05, 0xa6,
+  0x05, 0xad, 0x00, 0x19, 0x00, 0x77, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37,
+  0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x27,
+  0x0e, 0x01, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01,
+  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e,
+  0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x03, 0x45, 0x82, 0x37,
+  0x37, 0x2e, 0x2f, 0x2e, 0x2e, 0x2f, 0x2e, 0x37, 0x37, 0x82, 0x37, 0x38,
+  0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x38, 0x6c, 0x38, 0x21, 0x32, 0x30,
+  0x31, 0x31, 0x2b, 0x29, 0x25, 0x27, 0x24, 0x28, 0x21, 0x33, 0x2a, 0x52,
+  0x18, 0x2b, 0x1e, 0x28, 0x24, 0x28, 0x24, 0x29, 0x2b, 0x2d, 0x6d, 0x2a,
+  0x33, 0x21, 0x2b, 0x1a, 0x05, 0x04, 0x22, 0x24, 0x29, 0x2b, 0x2d, 0x6d,
+  0x2a, 0x33, 0x21, 0x29, 0x24, 0x2a, 0x23, 0x22, 0x20, 0x14, 0x4e, 0x2b,
+  0x34, 0x1f, 0x29, 0x24, 0x28, 0x25, 0x28, 0x2b, 0x2d, 0x35, 0x38, 0x2a,
+  0x35, 0x25, 0x07, 0x18, 0x28, 0x24, 0x29, 0x2b, 0x2d, 0x35, 0x38, 0x2a,
+  0x33, 0x21, 0x28, 0x24, 0x18, 0x04, 0x0b, 0x1a, 0x1c, 0x30, 0x36, 0x7b,
+  0x49, 0x46, 0x7b, 0x36, 0x30, 0x1c, 0x1a, 0x1a, 0x1c, 0x30, 0x36, 0x7b,
+  0x46, 0x49, 0x7b, 0x36, 0x30, 0x1c, 0x13, 0x35, 0x10, 0x17, 0x17, 0x14,
+  0x2b, 0x27, 0x67, 0x3e, 0x3a, 0x63, 0x2e, 0x26, 0x19, 0x15, 0x05, 0x17,
+  0x22, 0x2e, 0x63, 0x3b, 0x3d, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
+  0x26, 0x31, 0x4e, 0x25, 0x26, 0x57, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
+  0x26, 0x2e, 0x63, 0x3a, 0x3e, 0x6b, 0x23, 0x22, 0x15, 0x04, 0x15, 0x1b,
+  0x24, 0x2e, 0x63, 0x3a, 0x3e, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
+  0x2c, 0x0e, 0x42, 0x3a, 0x3e, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15, 0x19,
+  0x26, 0x2e, 0x63, 0x3b, 0x3d, 0x3f, 0x00, 0x00, 0x00, 0x06, 0x00, 0x63,
+  0x00, 0x00, 0x05, 0xa6, 0x05, 0xad, 0x00, 0x5c, 0x00, 0x76, 0x00, 0x8d,
+  0x00, 0xa6, 0x00, 0xbd, 0x00, 0xd6, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36,
+  0x37, 0x36, 0x37, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x2e, 0x01,
+  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e,
+  0x01, 0x15, 0x14, 0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x2e, 0x01, 0x02, 0x32, 0x17, 0x16, 0x17, 0x37, 0x36,
+  0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0x1f, 0x01, 0x36, 0x37, 0x13, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x27, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x03, 0x26, 0x35, 0x34, 0x36, 0x37,
+  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x01, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x2f,
+  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x13, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x0f, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x03, 0x04, 0x04, 0x1a, 0x2c,
+  0x21, 0x32, 0x2b, 0x6c, 0x2e, 0x2b, 0x28, 0x25, 0x28, 0x24, 0x29, 0x1d,
+  0x2c, 0x19, 0x51, 0x2b, 0x32, 0x21, 0x29, 0x24, 0x28, 0x25, 0x2b, 0x28,
+  0x36, 0x2c, 0x35, 0x2d, 0x22, 0x37, 0x06, 0x18, 0x24, 0x28, 0x22, 0x32,
+  0x2a, 0x70, 0x2a, 0x33, 0x21, 0x28, 0x24, 0x18, 0x06, 0x38, 0x21, 0x32,
+  0x30, 0x31, 0x31, 0x2b, 0x29, 0x25, 0x27, 0x24, 0x28, 0x21, 0x33, 0x2a,
+  0x52, 0x18, 0x2b, 0x1e, 0x28, 0x24, 0x28, 0x24, 0x29, 0x2b, 0x2d, 0x6d,
+  0x2a, 0x33, 0x21, 0x2b, 0x1a, 0x46, 0x82, 0x37, 0x07, 0x06, 0x0d, 0x0c,
+  0x17, 0x18, 0x17, 0x1c, 0x1b, 0x41, 0x1b, 0x1d, 0x16, 0x19, 0x16, 0x02,
+  0x16, 0x06, 0x07, 0x3d, 0x20, 0x1d, 0x3b, 0x2a, 0x1b, 0x18, 0x5d, 0x16,
+  0x19, 0x16, 0x19, 0x16, 0x1d, 0x1b, 0x41, 0x1b, 0x1d, 0x16, 0x16, 0x03,
+  0xc0, 0x03, 0x2a, 0x26, 0x6c, 0x07, 0x06, 0x20, 0x1c, 0x20, 0x1b, 0x1d,
+  0x16, 0x16, 0x19, 0x16, 0x19, 0x16, 0x1d, 0x13, 0x03, 0x02, 0x00, 0x1f,
+  0x20, 0x15, 0x17, 0x1d, 0x1a, 0x41, 0x1b, 0x1d, 0x17, 0x18, 0x16, 0x19,
+  0x15, 0x5d, 0x18, 0x1b, 0x2b, 0x3b, 0x1d, 0xdd, 0x48, 0x48, 0x12, 0x1d,
+  0x17, 0x18, 0x17, 0x1a, 0x15, 0x17, 0x1d, 0x1a, 0x21, 0x1c, 0x1f, 0x07,
+  0x07, 0x6c, 0x26, 0x2a, 0xf8, 0x25, 0x4e, 0x31, 0x26, 0x19, 0x15, 0x15,
+  0x14, 0x2b, 0x27, 0x67, 0x3d, 0x3b, 0x63, 0x2e, 0x22, 0x17, 0x05, 0x15,
+  0x19, 0x26, 0x2e, 0x63, 0x3a, 0x3e, 0x67, 0x27, 0x2e, 0x11, 0x17, 0x17,
+  0x10, 0x35, 0x0d, 0x3f, 0x3d, 0x3b, 0x63, 0x2e, 0x26, 0x19, 0x15, 0x15,
+  0x19, 0x26, 0x2e, 0x63, 0x3b, 0x3d, 0x3f, 0x0d, 0x35, 0x10, 0x17, 0x17,
+  0x14, 0x2b, 0x27, 0x67, 0x3e, 0x3a, 0x63, 0x2e, 0x26, 0x19, 0x15, 0x05,
+  0x17, 0x22, 0x2e, 0x63, 0x3b, 0x3d, 0x67, 0x27, 0x2b, 0x14, 0x15, 0x15,
+  0x19, 0x26, 0x31, 0x4e, 0x03, 0x38, 0x1a, 0x03, 0x04, 0x47, 0x47, 0x14,
+  0x24, 0x3e, 0x1b, 0x18, 0x0e, 0x0d, 0x0d, 0x0e, 0x18, 0x1b, 0x3e, 0x24,
+  0x14, 0x0c, 0x82, 0x04, 0x03, 0xfd, 0x63, 0x06, 0x0e, 0x1e, 0x2e, 0x1e,
+  0x2c, 0x62, 0x17, 0x42, 0x24, 0x23, 0x3e, 0x1b, 0x18, 0x0e, 0x0d, 0x0d,
+  0x0e, 0x18, 0x18, 0x09, 0x01, 0xba, 0x16, 0x17, 0x49, 0x72, 0x30, 0x43,
+  0x04, 0x03, 0x0d, 0x0d, 0x0e, 0x18, 0x18, 0x3e, 0x27, 0x23, 0x3e, 0x1b,
+  0x18, 0x0e, 0x09, 0xfe, 0xc2, 0x4c, 0x4d, 0x18, 0x18, 0x0e, 0x0d, 0x0d,
+  0x0e, 0x18, 0x1b, 0x3e, 0x23, 0x24, 0x42, 0x17, 0x62, 0x2c, 0x1e, 0x2e,
+  0x1e, 0x0e, 0x01, 0x24, 0x0a, 0x0a, 0x09, 0x0e, 0x18, 0x1b, 0x3e, 0x23,
+  0x27, 0x3e, 0x18, 0x18, 0x0e, 0x0d, 0x0d, 0x03, 0x04, 0x43, 0x30, 0x72,
+  0x49, 0x17, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x4b, 0xff, 0xe3, 0x05, 0xbd,
+  0x05, 0xf0, 0x00, 0x29, 0x00, 0x54, 0x00, 0xbd, 0x00, 0xe6, 0x01, 0x11,
+  0x01, 0x3a, 0x01, 0x65, 0x01, 0x7f, 0x01, 0xa9, 0x01, 0xd3, 0x00, 0x00,
+  0x01, 0x26, 0x27, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x36, 0x37,
+  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x25, 0x06, 0x07, 0x17, 0x16, 0x33,
+  0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x26, 0x27, 0x2e, 0x01,
+  0x23, 0x22, 0x0f, 0x01, 0x16, 0x17, 0x37, 0x36, 0x33, 0x32, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23, 0x22,
+  0x23, 0x01, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x16, 0x17, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x23, 0x1e, 0x01, 0x15, 0x14,
+  0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x14, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x0e, 0x01,
+  0x23, 0x22, 0x27, 0x2e, 0x01, 0x27, 0x26, 0x34, 0x36, 0x37, 0x22, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x01, 0x26,
+  0x27, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x07, 0x26, 0x27, 0x2e, 0x01, 0x27,
+  0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x3f, 0x01, 0x26, 0x27, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x15, 0x16, 0x17, 0x1e, 0x02, 0x33, 0x32, 0x36, 0x37,
+  0x36, 0x37, 0x01, 0x16, 0x17, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x26,
+  0x27, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x06, 0x0f, 0x01,
+  0x16, 0x17, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x37, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x0e, 0x01, 0x07, 0x06, 0x07, 0x03, 0x06, 0x07,
+  0x17, 0x16, 0x17, 0x1e, 0x01, 0x17, 0x06, 0x07, 0x0e, 0x01, 0x07, 0x06,
+  0x07, 0x2e, 0x01, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x07, 0x17, 0x16, 0x17,
+  0x1e, 0x01, 0x33, 0x32, 0x3e, 0x01, 0x37, 0x36, 0x37, 0x34, 0x26, 0x27,
+  0x26, 0x27, 0x01, 0x36, 0x37, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x14, 0x16, 0x17, 0x16, 0x1f, 0x01,
+  0x36, 0x37, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x1e, 0x01, 0x17, 0x16, 0x17, 0x04, 0x22, 0x07,
+  0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32,
+  0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x13,
+  0x06, 0x07, 0x17, 0x16, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3f, 0x01, 0x26, 0x27, 0x07,
+  0x06, 0x15, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x27, 0x03, 0x16, 0x17, 0x37, 0x36, 0x35, 0x34,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
+  0x14, 0x1f, 0x01, 0x36, 0x37, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x02,
+  0x01, 0x05, 0x02, 0xcd, 0x10, 0x08, 0x09, 0x17, 0x09, 0x07, 0x06, 0x03,
+  0x03, 0x06, 0x07, 0x09, 0x15, 0x0b, 0x08, 0x10, 0xcd, 0x02, 0x05, 0xb9,
+  0x21, 0x12, 0x19, 0x2f, 0x14, 0x12, 0x0a, 0x09, 0x09, 0x0a, 0x12, 0x14,
+  0x2f, 0x19, 0x12, 0x21, 0x02, 0xca, 0x02, 0x05, 0x6b, 0x6b, 0x10, 0x1b,
+  0x2f, 0x14, 0x12, 0x0b, 0x09, 0x09, 0x0b, 0x12, 0x14, 0x2f, 0x1b, 0x10,
+  0x08, 0xce, 0x05, 0x02, 0x6d, 0x6c, 0x06, 0x0f, 0x14, 0x09, 0x07, 0x05,
+  0x04, 0x04, 0x05, 0x07, 0x0b, 0x16, 0x0b, 0x06, 0x04, 0xfc, 0x35, 0x21,
+  0x1f, 0x10, 0x0e, 0x1d, 0x1e, 0x24, 0x25, 0x28, 0x27, 0x4c, 0x21, 0x1e,
+  0x1e, 0x1d, 0x24, 0x24, 0x53, 0x24, 0x24, 0x1c, 0x1e, 0x1f, 0x22, 0x4b,
+  0x26, 0x29, 0x25, 0x24, 0x1d, 0x1a, 0x12, 0x0f, 0x1d, 0x23, 0x32, 0x45,
+  0x1e, 0x20, 0x0d, 0x0f, 0x0f, 0x10, 0x1d, 0x19, 0x4d, 0x2d, 0x21, 0x1d,
+  0x0f, 0x0f, 0x3a, 0x24, 0x25, 0x29, 0x29, 0x4a, 0x20, 0x1f, 0x1e, 0x1c,
+  0x24, 0x24, 0x53, 0x24, 0x24, 0x1d, 0x1e, 0x1e, 0x24, 0x47, 0x29, 0x28,
+  0x25, 0x24, 0x3b, 0x0e, 0x10, 0x1f, 0x20, 0x2d, 0x48, 0x1f, 0x1f, 0x0e,
+  0x0e, 0x0e, 0x10, 0x1d, 0x1f, 0x45, 0x01, 0x94, 0x12, 0x0e, 0x80, 0x0a,
+  0x05, 0x07, 0x16, 0x0d, 0x0c, 0x0a, 0x0a, 0x11, 0x05, 0x04, 0x09, 0x08,
+  0x05, 0x0d, 0xa2, 0x0d, 0x0a, 0xa5, 0x1e, 0x0d, 0x13, 0x13, 0x01, 0x09,
+  0x09, 0x26, 0x2f, 0x1a, 0x1d, 0x2d, 0x13, 0x0c, 0x11, 0x01, 0xba, 0x0e,
+  0x09, 0x60, 0x61, 0x0b, 0x14, 0x13, 0x01, 0x09, 0x09, 0x13, 0x13, 0x2f,
+  0x1a, 0x1c, 0x2e, 0x13, 0x0c, 0x05, 0x69, 0x12, 0x0f, 0x44, 0x44, 0x04,
+  0x09, 0x15, 0x0c, 0x0c, 0x0a, 0x0b, 0x09, 0x08, 0x04, 0x04, 0x01, 0x01,
+  0x0a, 0x07, 0x05, 0x03, 0x95, 0x0a, 0x0c, 0xa2, 0x0c, 0x06, 0x06, 0x0a,
+  0x01, 0x01, 0x04, 0x04, 0x11, 0x0b, 0x0a, 0x0c, 0x0c, 0x15, 0x08, 0x05,
+  0x0a, 0x80, 0x10, 0x11, 0x5f, 0x11, 0x0d, 0x12, 0x2e, 0x1c, 0x1a, 0x2f,
+  0x26, 0x09, 0x09, 0x01, 0x13, 0x13, 0x0c, 0x1e, 0xfd, 0xc8, 0x10, 0x11,
+  0x37, 0x37, 0x0b, 0x14, 0x2d, 0x1d, 0x1a, 0x2f, 0x13, 0x13, 0x09, 0x09,
+  0x01, 0x13, 0x14, 0x0c, 0x08, 0xb9, 0x09, 0x0d, 0x56, 0x56, 0x04, 0x09,
+  0x09, 0x04, 0x05, 0x08, 0x09, 0x0a, 0x0a, 0x0c, 0x0f, 0x14, 0x07, 0x05,
+  0x02, 0x01, 0x52, 0x4a, 0x1f, 0x21, 0x1a, 0x1a, 0x1b, 0x1b, 0x1a, 0x1a,
+  0x21, 0x1f, 0x4a, 0x20, 0x20, 0x1a, 0x1a, 0x1b, 0x1b, 0x1a, 0x1a, 0x20,
+  0x02, 0x13, 0x13, 0x18, 0x02, 0x09, 0x08, 0x09, 0x0a, 0x0b, 0x18, 0x0a,
+  0x0a, 0x09, 0x08, 0x09, 0x02, 0x18, 0x14, 0x13, 0x32, 0x09, 0x13, 0x13,
+  0x13, 0x18, 0x16, 0x36, 0x17, 0x17, 0x13, 0x14, 0x13, 0x09, 0x59, 0x14,
+  0x13, 0x1d, 0x1e, 0x13, 0x14, 0x13, 0x17, 0x17, 0x36, 0x16, 0x18, 0x13,
+  0x13, 0x13, 0x02, 0x38, 0x14, 0x14, 0x0d, 0x0d, 0x09, 0x08, 0x09, 0x0a,
+  0x0a, 0x18, 0x0b, 0x0a, 0x09, 0x0a, 0x07, 0x01, 0x02, 0x9a, 0x16, 0x16,
+  0x1c, 0x02, 0x0a, 0x0a, 0x0a, 0x0a, 0x0c, 0x1a, 0x0c, 0x0c, 0x0a, 0x08,
+  0x0a, 0x02, 0x1a, 0x16, 0x14, 0x38, 0x0a, 0x14, 0x16, 0x16, 0x1a, 0x18,
+  0x3c, 0x1a, 0x1a, 0x14, 0x16, 0x16, 0x0a, 0x64, 0x18, 0x14, 0x21, 0x21,
+  0x16, 0x16, 0x14, 0x1a, 0x1a, 0x3c, 0x18, 0x1a, 0x16, 0x16, 0x14, 0x02,
+  0x3e, 0x17, 0x15, 0x0e, 0x0e, 0x0a, 0x08, 0x0a, 0x0c, 0x0c, 0x0c, 0x0e,
+  0x0c, 0x0a, 0x0a, 0x0c, 0x08, 0x01, 0x22, 0x25, 0x55, 0x56, 0x2a, 0x29,
+  0x20, 0x21, 0x10, 0x10, 0x21, 0x24, 0x33, 0x52, 0x20, 0x1f, 0x12, 0x11,
+  0x11, 0x12, 0x1f, 0x20, 0x52, 0x33, 0x26, 0x1f, 0x10, 0x10, 0x21, 0x1c,
+  0x2d, 0x28, 0x2d, 0x25, 0x5a, 0x26, 0x20, 0x22, 0x23, 0x25, 0x28, 0x2e,
+  0x32, 0x24, 0x28, 0x20, 0x1e, 0x26, 0x26, 0x53, 0x2b, 0x2c, 0x29, 0x29,
+  0x41, 0x10, 0x10, 0x21, 0x24, 0x33, 0x52, 0x20, 0x1f, 0x12, 0x11, 0x11,
+  0x12, 0x1f, 0x20, 0x52, 0x33, 0x27, 0x1e, 0x10, 0x10, 0x41, 0x29, 0x29,
+  0x58, 0x54, 0x24, 0x22, 0x22, 0x23, 0x25, 0x28, 0x60, 0x24, 0x28, 0x20,
+  0x22, 0x20, 0xfe, 0x1c, 0x0b, 0x0d, 0xb4, 0x0d, 0x06, 0x08, 0x0a, 0x01,
+  0x01, 0x04, 0x05, 0x12, 0x0c, 0x0c, 0x0d, 0x0d, 0x18, 0x09, 0x06, 0x0a,
+  0x8e, 0x11, 0x13, 0x69, 0x13, 0x0e, 0x14, 0x33, 0x1f, 0x1d, 0x1b, 0x19,
+  0x2b, 0x14, 0x15, 0x14, 0x0e, 0x21, 0x02, 0x78, 0x12, 0x13, 0x3d, 0x3d,
+  0x0d, 0x15, 0x33, 0x1f, 0x1d, 0x1b, 0x19, 0x16, 0x15, 0x14, 0x15, 0x15,
+  0x0d, 0x09, 0xcd, 0x0c, 0x0e, 0x5f, 0x60, 0x05, 0x0b, 0x08, 0x01, 0x01,
+  0x04, 0x05, 0x09, 0x09, 0x0c, 0x0c, 0x0d, 0x10, 0x16, 0x09, 0x05, 0x02,
+  0xfe, 0x1d, 0x13, 0x11, 0x8e, 0x0a, 0x06, 0x08, 0x19, 0x0d, 0x0d, 0x0c,
+  0x0c, 0x12, 0x05, 0x04, 0x01, 0x01, 0x09, 0x09, 0x06, 0x0d, 0xb4, 0x0e,
+  0x0a, 0xb9, 0x21, 0x0e, 0x14, 0x15, 0x14, 0x2b, 0x19, 0x1b, 0x1d, 0x1f,
+  0x33, 0x14, 0x0e, 0x13, 0x01, 0xeb, 0x0f, 0x0b, 0x6b, 0x6b, 0x0d, 0x15,
+  0x15, 0x14, 0x15, 0x16, 0x19, 0x1b, 0x1d, 0x1f, 0x33, 0x15, 0x0d, 0x05,
+  0x75, 0x13, 0x12, 0x4b, 0x4a, 0x05, 0x0b, 0x17, 0x0d, 0x0d, 0x0c, 0x0c,
+  0x09, 0x09, 0x05, 0x04, 0x01, 0x01, 0x0a, 0x09, 0x05, 0x03, 0xdf, 0x0f,
+  0x10, 0x1c, 0x1f, 0x46, 0x29, 0x28, 0x47, 0x1e, 0x1c, 0x10, 0x0f, 0x0f,
+  0x10, 0x1c, 0x1e, 0x47, 0x28, 0x29, 0x46, 0x1f, 0x1c, 0x10, 0xfe, 0x24,
+  0x06, 0x02, 0xe4, 0x11, 0x08, 0x0b, 0x19, 0x0a, 0x09, 0x05, 0x05, 0x05,
+  0x05, 0x09, 0x0a, 0x17, 0x0d, 0x08, 0x11, 0xe4, 0x02, 0x06, 0xcd, 0x25,
+  0x13, 0x1d, 0x33, 0x16, 0x14, 0x0c, 0x0b, 0x0b, 0x0c, 0x14, 0x16, 0x33,
+  0x1d, 0x13, 0x25, 0x03, 0x1a, 0x02, 0x06, 0x77, 0x77, 0x12, 0x1e, 0x33,
+  0x16, 0x14, 0x0c, 0x0b, 0x0b, 0x0c, 0x14, 0x16, 0x33, 0x1e, 0x12, 0x09,
+  0xe5, 0x06, 0x02, 0x78, 0x79, 0x07, 0x0f, 0x16, 0x0a, 0x09, 0x05, 0x05,
+  0x05, 0x05, 0x09, 0x0c, 0x17, 0x0c, 0x07, 0x05, 0x00, 0x04, 0x00, 0x4d,
+  0xff, 0xe3, 0x05, 0xbb, 0x05, 0xf0, 0x00, 0x19, 0x00, 0x33, 0x00, 0x4e,
+  0x00, 0x5e, 0x00, 0x00, 0x00, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15,
+  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01,
+  0x35, 0x34, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x32, 0x17, 0x16, 0x17, 0x1e,
+  0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x2e, 0x01, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
+  0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x36, 0x17,
+  0x03, 0x25, 0x13, 0x0d, 0x01, 0x03, 0x25, 0x1b, 0x01, 0x05, 0x03, 0x2d,
+  0x01, 0x13, 0x05, 0x03, 0x3b, 0x6e, 0x2e, 0x2f, 0x27, 0x27, 0x26, 0x26,
+  0x27, 0x27, 0x2f, 0x2e, 0x6e, 0x2e, 0x30, 0x26, 0x27, 0x27, 0x27, 0x27,
+  0x26, 0x30, 0x65, 0x4e, 0x3e, 0x45, 0x31, 0x33, 0x39, 0x37, 0x35, 0x34,
+  0x42, 0x41, 0x99, 0x3d, 0x46, 0x30, 0x33, 0x39, 0x37, 0x35, 0x33, 0x43,
+  0x41, 0x4a, 0x8b, 0x80, 0x78, 0x68, 0x65, 0x67, 0x63, 0x69, 0x63, 0x7d,
+  0x7f, 0xfe, 0xea, 0x80, 0x79, 0x67, 0x65, 0x68, 0x63, 0x6a, 0x61, 0x7f,
+  0x7e, 0x8c, 0x8d, 0xfe, 0xa5, 0x93, 0xfe, 0xa4, 0x01, 0x5c, 0x93, 0x01,
+  0x5b, 0x8d, 0x8e, 0x01, 0x5a, 0x93, 0x01, 0x5d, 0xfe, 0xa3, 0x93, 0xfe,
+  0xa6, 0x04, 0x13, 0x16, 0x18, 0x28, 0x2e, 0x68, 0x3c, 0x3b, 0x68, 0x2e,
+  0x28, 0x18, 0x16, 0x16, 0x18, 0x28, 0x2e, 0x68, 0x3b, 0x3c, 0x68, 0x2e,
+  0x28, 0x18, 0x86, 0x1f, 0x22, 0x36, 0x38, 0x96, 0x54, 0x4e, 0x96, 0x3b,
+  0x39, 0x1f, 0x1f, 0x1f, 0x22, 0x36, 0x38, 0x96, 0xa2, 0x96, 0x3b, 0x39,
+  0x1f, 0x1f, 0x01, 0x6d, 0x3b, 0x38, 0x72, 0x6f, 0xfe, 0xec, 0xa1, 0x98,
+  0xfe, 0xf0, 0x77, 0x70, 0x3a, 0x3b, 0x3b, 0x38, 0x72, 0x6f, 0x01, 0x14,
+  0x9c, 0x9d, 0x01, 0x10, 0x77, 0x6e, 0x3c, 0x3b, 0x08, 0xfe, 0x7d, 0xa3,
+  0xfe, 0x7f, 0x9e, 0x9d, 0xfe, 0x7f, 0xa3, 0xfe, 0x7d, 0x01, 0x83, 0xa3,
+  0x01, 0x81, 0x9d, 0x9e, 0x01, 0x81, 0xa3, 0x00, 0x00, 0x07, 0x00, 0x90,
+  0xff, 0xe3, 0x05, 0x77, 0x05, 0xf0, 0x00, 0x08, 0x00, 0x93, 0x00, 0x9c,
+  0x00, 0xa7, 0x00, 0xb2, 0x00, 0xc1, 0x00, 0xd0, 0x00, 0x00, 0x01, 0x11,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x13, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x2f, 0x01, 0x15, 0x14,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x3d, 0x01, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x33, 0x32, 0x3f, 0x01, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x35, 0x34, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x1d,
+  0x01, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x23,
+  0x22, 0x0f, 0x01, 0x11, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x13,
+  0x25, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x01, 0x05,
+  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x13, 0x25, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x33, 0x32,
+  0x0d, 0x01, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x23, 0x22, 0x03, 0x04, 0x26, 0x2c, 0x1b, 0x22, 0x32, 0x97, 0x10,
+  0x30, 0x5b, 0x1d, 0x21, 0x10, 0x0f, 0x51, 0x3f, 0x52, 0x11, 0x0a, 0x17,
+  0x27, 0x62, 0x12, 0x13, 0x33, 0x3b, 0x4b, 0x2a, 0x39, 0x43, 0x10, 0x4e,
+  0x39, 0x30, 0x4a, 0x4c, 0x4f, 0x46, 0x31, 0x3a, 0x4d, 0x10, 0x40, 0x3b,
+  0x2c, 0x49, 0x3c, 0x32, 0x14, 0x12, 0x63, 0x26, 0x16, 0x0a, 0x10, 0x53,
+  0x3f, 0x51, 0x0e, 0x10, 0x22, 0x1c, 0x5b, 0x30, 0x10, 0x10, 0x2e, 0x5b,
+  0x1d, 0x23, 0x10, 0x0e, 0x51, 0x3f, 0x51, 0x12, 0x0b, 0x17, 0x26, 0x63,
+  0x12, 0x14, 0x32, 0x3c, 0x4a, 0x2b, 0x38, 0x43, 0x10, 0x4d, 0x3a, 0x31,
+  0x4a, 0x97, 0x4a, 0x30, 0x39, 0x4e, 0x10, 0x40, 0x3c, 0x2c, 0x49, 0x3b,
+  0x33, 0x13, 0x12, 0x62, 0x27, 0x17, 0x0a, 0x11, 0x52, 0x3f, 0x51, 0x0f,
+  0x10, 0x22, 0x1e, 0x5b, 0x2e, 0x8e, 0x26, 0x2c, 0x1b, 0x21, 0x33, 0x9d,
+  0x01, 0x58, 0x13, 0x38, 0x09, 0x0b, 0x1c, 0x26, 0x3f, 0x17, 0x20, 0xfe,
+  0x53, 0xfe, 0xa9, 0x13, 0x37, 0x09, 0x0b, 0x1c, 0x27, 0x3f, 0x16, 0x21,
+  0x40, 0xfe, 0xa9, 0x0c, 0x04, 0x07, 0x35, 0x36, 0x2f, 0x0a, 0x08, 0x1a,
+  0x1b, 0x3a, 0x01, 0xa9, 0x01, 0x58, 0x0c, 0x05, 0x06, 0x35, 0x36, 0x30,
+  0x09, 0x08, 0x1a, 0x1b, 0x3b, 0x03, 0xd3, 0x01, 0xb9, 0x2b, 0x1a, 0x44,
+  0x51, 0x32, 0x4a, 0xfe, 0xb4, 0x0b, 0x20, 0x03, 0x01, 0x28, 0x35, 0x48,
+  0x2c, 0x27, 0x39, 0x2c, 0x4a, 0x1e, 0x06, 0x26, 0x30, 0x66, 0x89, 0x29,
+  0x0a, 0x14, 0x54, 0x7c, 0x5c, 0x60, 0x6a, 0x34, 0x4f, 0x4f, 0x37, 0x67,
+  0x60, 0x5c, 0x7c, 0x54, 0x14, 0x0a, 0x27, 0x8b, 0x67, 0x2f, 0x26, 0x06,
+  0x20, 0x48, 0x2c, 0x39, 0x27, 0x2c, 0x49, 0x34, 0x28, 0x01, 0x03, 0x20,
+  0x0b, 0x0b, 0x1f, 0x03, 0x01, 0x28, 0x33, 0x4a, 0x2c, 0x26, 0x39, 0x2d,
+  0x48, 0x20, 0x06, 0x26, 0x30, 0x66, 0x89, 0x29, 0x0a, 0x14, 0x54, 0x7c,
+  0x5c, 0x60, 0x6a, 0x34, 0x4f, 0x4f, 0x34, 0x6a, 0x60, 0x5c, 0x7c, 0x54,
+  0x14, 0x0a, 0x27, 0x8b, 0x67, 0x2f, 0x26, 0x06, 0x1e, 0x4a, 0x2c, 0x39,
+  0x27, 0x2c, 0x48, 0x35, 0x28, 0x01, 0x03, 0x1f, 0xf5, 0xfe, 0x47, 0x2b,
+  0x1a, 0x44, 0x51, 0x32, 0x4a, 0x01, 0xc1, 0xdd, 0x24, 0x15, 0x04, 0x19,
+  0x28, 0x3a, 0x55, 0xfe, 0xcd, 0xdd, 0x24, 0x15, 0x04, 0x19, 0x28, 0x3a,
+  0x55, 0x01, 0x33, 0xdd, 0x17, 0x21, 0x15, 0x18, 0x27, 0x22, 0x22, 0x01,
+  0x04, 0xfb, 0xdd, 0x17, 0x21, 0x15, 0x18, 0x27, 0x22, 0x22, 0x01, 0x04,
+  0x00, 0x01, 0x00, 0xa3, 0x00, 0x00, 0x05, 0x65, 0x05, 0xd5, 0x00, 0x41,
+  0x00, 0x00, 0x01, 0x27, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x35, 0x33,
+  0x15, 0x17, 0x11, 0x27, 0x37, 0x17, 0x35, 0x33, 0x15, 0x37, 0x17, 0x07,
+  0x11, 0x37, 0x35, 0x33, 0x15, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x07,
+  0x17, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x15, 0x23, 0x35, 0x27, 0x11,
+  0x17, 0x07, 0x27, 0x15, 0x23, 0x35, 0x07, 0x27, 0x37, 0x11, 0x07, 0x15,
+  0x23, 0x35, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x02, 0x98, 0xd8, 0xae,
+  0x36, 0x78, 0xb0, 0x36, 0xb0, 0x6c, 0xd8, 0xae, 0x36, 0x78, 0x6c, 0x79,
+  0x36, 0xaf, 0xd8, 0x6c, 0xb1, 0x36, 0xb1, 0x79, 0x36, 0xaf, 0xd8, 0xd8,
+  0xaf, 0x36, 0x79, 0xb1, 0x36, 0xb1, 0x6c, 0xd8, 0xaf, 0x36, 0x79, 0x6c,
+  0x78, 0x36, 0xae, 0xd8, 0x6c, 0xb0, 0x36, 0xb0, 0x78, 0x36, 0xae, 0x02,
+  0xeb, 0x8a, 0x70, 0x68, 0x4d, 0x72, 0x68, 0x72, 0x9b, 0xe0, 0x8b, 0x01,
+  0x16, 0x6f, 0x68, 0x4d, 0xe3, 0xe3, 0x4d, 0x68, 0x6f, 0xfe, 0xeb, 0x8a,
+  0xe0, 0x9b, 0x72, 0x68, 0x72, 0x4d, 0x68, 0x70, 0x8a, 0x8b, 0x70, 0x68,
+  0x4d, 0x72, 0x68, 0x72, 0x9b, 0xe0, 0x8b, 0xfe, 0xea, 0x6f, 0x68, 0x4d,
+  0xe3, 0xe3, 0x4d, 0x68, 0x6f, 0x01, 0x16, 0x8b, 0xe0, 0x9b, 0x72, 0x68,
+  0x72, 0x4d, 0x68, 0x70, 0x00, 0x07, 0x00, 0x8c, 0x00, 0x00, 0x05, 0x7c,
+  0x05, 0xd5, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x25, 0x00, 0x29, 0x00, 0x2d,
+  0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x01, 0x33, 0x11, 0x25, 0x11, 0x37,
+  0x17, 0x07, 0x0d, 0x01, 0x17, 0x07, 0x27, 0x11, 0x25, 0x11, 0x23, 0x11,
+  0x05, 0x11, 0x07, 0x27, 0x37, 0x2d, 0x01, 0x27, 0x37, 0x17, 0x11, 0x05,
+  0x07, 0x15, 0x17, 0x35, 0x25, 0x07, 0x15, 0x37, 0x05, 0x07, 0x17, 0x37,
+  0x25, 0x07, 0x17, 0x37, 0x05, 0x07, 0x15, 0x3f, 0x01, 0x15, 0x17, 0x35,
+  0x02, 0xce, 0x6c, 0x01, 0x06, 0xef, 0x36, 0xf0, 0x01, 0x07, 0xfe, 0xfa,
+  0xef, 0x36, 0xef, 0xfe, 0xfa, 0x6c, 0xfe, 0xfa, 0xee, 0x36, 0xee, 0xfe,
+  0xfa, 0x01, 0x07, 0xef, 0x36, 0xee, 0x01, 0x06, 0x9a, 0x9a, 0x01, 0x06,
+  0x9a, 0x9a, 0xfe, 0x2b, 0x9b, 0x9a, 0x9a, 0x01, 0x71, 0x99, 0x9a, 0x9a,
+  0xfe, 0x2a, 0x9a, 0x9a, 0x6c, 0x9a, 0x05, 0xd5, 0xfe, 0xcc, 0xa9, 0xfe,
+  0xb0, 0x9a, 0x68, 0x9a, 0xa8, 0xa8, 0x99, 0x68, 0x9a, 0xfe, 0xaf, 0xa9,
+  0xfe, 0xcd, 0x01, 0x33, 0xa9, 0x01, 0x51, 0x9a, 0x68, 0x99, 0xa8, 0xa8,
+  0x9a, 0x68, 0x9a, 0x01, 0x50, 0xa9, 0x27, 0xc5, 0x63, 0xc5, 0x63, 0x63,
+  0xc5, 0x63, 0x68, 0x63, 0x62, 0x62, 0x63, 0x63, 0x62, 0x62, 0x67, 0x63,
+  0xc6, 0x63, 0xc6, 0xc6, 0x63, 0xc6, 0x00, 0x00, 0x00, 0x01, 0x00, 0x75,
+  0x00, 0x04, 0x05, 0x92, 0x05, 0xd5, 0x00, 0x41, 0x00, 0x00, 0x01, 0x33,
+  0x15, 0x37, 0x17, 0x07, 0x11, 0x37, 0x11, 0x33, 0x15, 0x37, 0x17, 0x07,
+  0x17, 0x07, 0x27, 0x07, 0x17, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x15,
+  0x23, 0x11, 0x27, 0x11, 0x17, 0x07, 0x27, 0x15, 0x23, 0x35, 0x07, 0x27,
+  0x37, 0x11, 0x07, 0x11, 0x23, 0x35, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17,
+  0x37, 0x27, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x35, 0x33, 0x11, 0x17,
+  0x11, 0x27, 0x37, 0x17, 0x02, 0xce, 0x6c, 0x7e, 0x5a, 0xd8, 0xf1, 0xb4,
+  0x50, 0x36, 0x52, 0x7e, 0x5a, 0xd8, 0xf0, 0xf1, 0xd8, 0x5a, 0x7e, 0x50,
+  0x36, 0x53, 0xb4, 0xed, 0xd8, 0x5a, 0x7e, 0x6c, 0x7e, 0x5a, 0xd8, 0xee,
+  0xb4, 0x52, 0x36, 0x4f, 0x7e, 0x5a, 0xd8, 0xf0, 0xee, 0xd8, 0x5a, 0x7e,
+  0x53, 0x36, 0x50, 0xb4, 0xf2, 0xd8, 0x5a, 0x7e, 0x05, 0xd5, 0x68, 0x51,
+  0xad, 0x8b, 0xfe, 0xce, 0x9b, 0x01, 0x15, 0xa2, 0x34, 0x68, 0x35, 0x51,
+  0xad, 0x8a, 0x99, 0x9b, 0x8b, 0xad, 0x51, 0x34, 0x68, 0x35, 0xa1, 0x01,
+  0x15, 0x98, 0xfe, 0xd0, 0x8b, 0xad, 0x51, 0x68, 0x65, 0x51, 0xad, 0x8b,
+  0x01, 0x35, 0x99, 0xfe, 0xeb, 0xa1, 0x35, 0x68, 0x33, 0x51, 0xae, 0x8b,
+  0x9a, 0x99, 0x8b, 0xad, 0x51, 0x35, 0x68, 0x33, 0xa1, 0xfe, 0xeb, 0x9b,
+  0x01, 0x36, 0x8b, 0xad, 0x51, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x90,
+  0xff, 0xe5, 0x05, 0x78, 0x05, 0xf0, 0x00, 0x87, 0x00, 0x00, 0x01, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x07,
+  0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x27, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x0e, 0x01, 0x22, 0x2e,
+  0x01, 0x34, 0x36, 0x37, 0x36, 0x37, 0x11, 0x07, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x37, 0x27, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x17, 0x11, 0x26, 0x27, 0x2e, 0x01,
+  0x34, 0x36, 0x37, 0x36, 0x33, 0x32, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06,
+  0x07, 0x11, 0x37, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x05, 0x5f, 0x19, 0x19, 0x18, 0x29, 0x2b, 0x2f, 0x31, 0x29,
+  0x12, 0x0f, 0xd9, 0xd9, 0x0f, 0x12, 0x29, 0x31, 0x2f, 0x2b, 0x29, 0x18,
+  0x19, 0x19, 0x19, 0x28, 0x2b, 0x2f, 0x2e, 0x2c, 0x2b, 0x18, 0x17, 0x03,
+  0xd9, 0x13, 0x11, 0x2a, 0x30, 0x30, 0x53, 0x61, 0x53, 0x31, 0x31, 0x29,
+  0x11, 0x13, 0xd9, 0x04, 0x17, 0x19, 0x2a, 0x2a, 0x30, 0x31, 0x29, 0x29,
+  0x19, 0x18, 0x18, 0x19, 0x29, 0x2a, 0x60, 0x2a, 0x11, 0x0f, 0xd9, 0xd9,
+  0x0e, 0x12, 0x2c, 0x2e, 0x31, 0x52, 0x31, 0x18, 0x19, 0x29, 0x2a, 0x30,
+  0x2e, 0x2c, 0x2a, 0x19, 0x17, 0x04, 0xd9, 0x13, 0x11, 0x29, 0x31, 0x31,
+  0x29, 0x2a, 0x30, 0x31, 0x53, 0x30, 0x30, 0x2a, 0x11, 0x13, 0xd9, 0x03,
+  0x17, 0x17, 0x2c, 0x29, 0x31, 0x2f, 0x2b, 0x2d, 0x04, 0x6d, 0x36, 0x2e,
+  0x35, 0x2f, 0x2e, 0x1b, 0x1b, 0x1b, 0x0b, 0x0f, 0x8b, 0x8c, 0x0f, 0x0b,
+  0x1b, 0x1b, 0x1b, 0x2e, 0x2f, 0x35, 0x34, 0x2f, 0x2f, 0x1b, 0x1b, 0x1b,
+  0x1a, 0x2f, 0x2e, 0x36, 0x16, 0x15, 0x8c, 0xfe, 0xe9, 0x07, 0x0b, 0x1b,
+  0x5c, 0x6c, 0x5c, 0x36, 0x36, 0x5c, 0x6c, 0x5c, 0x1b, 0x0b, 0x07, 0x01,
+  0x17, 0x8c, 0x15, 0x16, 0x36, 0x2e, 0x2f, 0x1a, 0x1b, 0x1b, 0x1a, 0x2f,
+  0x2e, 0x36, 0x35, 0x2f, 0x2e, 0x1b, 0x1b, 0x1b, 0x0b, 0x0f, 0x8c, 0x8b,
+  0x0f, 0x0b, 0x1b, 0x36, 0x5c, 0x6c, 0x2e, 0x2f, 0x1a, 0x1b, 0x1b, 0x1a,
+  0x2f, 0x2e, 0x36, 0x16, 0x15, 0x8c, 0x01, 0x17, 0x07, 0x0b, 0x1b, 0x5c,
+  0x6c, 0x5c, 0x1b, 0x1b, 0x36, 0x5c, 0x6c, 0x5c, 0x1b, 0x0b, 0x07, 0xfe,
+  0xe9, 0x8c, 0x15, 0x16, 0x36, 0x2e, 0x2d, 0x1c, 0x1b, 0x1b, 0x1e, 0x00,
+  0x00, 0x09, 0x00, 0x57, 0xff, 0xe5, 0x05, 0xb2, 0x05, 0xd7, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x2e, 0x00, 0x45,
+  0x00, 0x5c, 0x00, 0x73, 0x00, 0x00, 0x00, 0x14, 0x06, 0x22, 0x26, 0x34,
+  0x36, 0x32, 0x09, 0x01, 0x37, 0x09, 0x02, 0x37, 0x09, 0x02, 0x27, 0x09,
+  0x02, 0x27, 0x01, 0x13, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x03, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x03, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x05, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03,
+  0x8b, 0x4f, 0x70, 0x4f, 0x4f, 0x70, 0x01, 0x7d, 0xfe, 0xa3, 0x4d, 0x01,
+  0x5c, 0xfd, 0x59, 0xfe, 0xa5, 0x4d, 0x01, 0x5a, 0x02, 0x5b, 0xfe, 0xa4,
+  0x4d, 0x01, 0x5d, 0xfd, 0xf1, 0xfe, 0xa6, 0x4d, 0x01, 0x5b, 0xa6, 0x33,
+  0x0e, 0x14, 0x04, 0x01, 0x02, 0x03, 0x0d, 0x15, 0x67, 0x14, 0x0e, 0x02,
+  0x02, 0x01, 0x03, 0x15, 0x0d, 0x34, 0x34, 0x0d, 0x15, 0x03, 0x01, 0x02,
+  0x02, 0x0e, 0x14, 0x67, 0x15, 0x0d, 0x03, 0x02, 0x01, 0x04, 0x14, 0x0e,
+  0x8f, 0x36, 0x16, 0x21, 0x3d, 0x1a, 0x4a, 0x3e, 0x1b, 0x3b, 0x1d, 0x2c,
+  0x2c, 0x1d, 0x3b, 0x1b, 0x3e, 0x4a, 0x1a, 0x3d, 0x21, 0x16, 0x01, 0xbb,
+  0x36, 0x15, 0x22, 0x3d, 0x1a, 0x4a, 0x3e, 0x1b, 0x3a, 0x1d, 0x2c, 0x2c,
+  0x1d, 0x3a, 0x1b, 0x3e, 0x4a, 0x1a, 0x3d, 0x22, 0x15, 0x03, 0x2c, 0x7c,
+  0x58, 0x58, 0x7c, 0x58, 0xfd, 0x2e, 0x01, 0x84, 0x55, 0xfe, 0x7c, 0x02,
+  0x4a, 0x01, 0x81, 0x55, 0xfe, 0x7e, 0x01, 0x2d, 0xfe, 0x7c, 0x55, 0x01,
+  0x84, 0xfd, 0x0d, 0xfe, 0x7e, 0x55, 0x01, 0x81, 0x01, 0x2e, 0x3c, 0x18,
+  0x25, 0x44, 0x1d, 0x52, 0x45, 0x1e, 0x41, 0x20, 0x31, 0x31, 0x20, 0x41,
+  0x1e, 0x45, 0x52, 0x1d, 0x44, 0x25, 0x18, 0xfe, 0x14, 0x3c, 0x18, 0x25,
+  0x44, 0x1d, 0x52, 0x45, 0x1e, 0x41, 0x20, 0x31, 0x31, 0x20, 0x41, 0x1e,
+  0x45, 0x52, 0x1d, 0x44, 0x25, 0x18, 0x01, 0x14, 0x39, 0x0f, 0x17, 0x04,
+  0x01, 0x02, 0x03, 0x0f, 0x17, 0x72, 0x17, 0x0f, 0x03, 0x02, 0x01, 0x04,
+  0x17, 0x0f, 0x39, 0x39, 0x0f, 0x17, 0x04, 0x01, 0x02, 0x03, 0x0f, 0x17,
+  0x72, 0x17, 0x0f, 0x03, 0x02, 0x01, 0x04, 0x17, 0x0f, 0x00, 0x00, 0x00,
+  0x00, 0x09, 0x00, 0x57, 0xff, 0xe5, 0x05, 0xb2, 0x05, 0xd7, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x2b, 0x00, 0x3f,
+  0x00, 0x53, 0x00, 0x67, 0x00, 0x00, 0x00, 0x14, 0x06, 0x22, 0x26, 0x34,
+  0x36, 0x32, 0x09, 0x01, 0x17, 0x09, 0x02, 0x17, 0x09, 0x02, 0x07, 0x09,
+  0x02, 0x07, 0x01, 0x02, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x12,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x00, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x24, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x03,
+  0xcf, 0x77, 0xa8, 0x76, 0x76, 0xa8, 0xfd, 0xab, 0x01, 0x0b, 0x4d, 0xfe,
+  0xf5, 0x02, 0x5d, 0x01, 0x0c, 0x4c, 0xfe, 0xf5, 0xfd, 0x56, 0x01, 0x0b,
+  0x4d, 0xfe, 0xf5, 0x02, 0xf7, 0x01, 0x0b, 0x4c, 0xfe, 0xf4, 0x07, 0x11,
+  0x13, 0x23, 0x29, 0x63, 0x2a, 0x23, 0x13, 0x11, 0x11, 0x13, 0x23, 0x2a,
+  0x63, 0x29, 0x23, 0x13, 0x11, 0x11, 0x13, 0x23, 0x29, 0x63, 0x2a, 0x23,
+  0x13, 0x11, 0x11, 0x13, 0x23, 0x2a, 0x63, 0x29, 0x23, 0x13, 0xfd, 0x63,
+  0x65, 0x2c, 0x32, 0x1f, 0x24, 0x24, 0x1f, 0x32, 0x2c, 0x65, 0x2c, 0x31,
+  0x20, 0x24, 0x24, 0x20, 0x31, 0x03, 0xdf, 0x65, 0x2c, 0x32, 0x1f, 0x24,
+  0x24, 0x1f, 0x32, 0x2c, 0x65, 0x2c, 0x31, 0x20, 0x24, 0x24, 0x20, 0x31,
+  0x03, 0x4b, 0xba, 0x84, 0x84, 0xba, 0x84, 0xfd, 0x38, 0x01, 0x29, 0x55,
+  0xfe, 0xd7, 0x03, 0x4c, 0x01, 0x29, 0x55, 0xfe, 0xd7, 0x01, 0x7e, 0xfe,
+  0xd7, 0x55, 0x01, 0x29, 0xfd, 0x5e, 0xfe, 0xd7, 0x55, 0x01, 0x29, 0x03,
+  0x49, 0x70, 0x31, 0x37, 0x23, 0x28, 0x28, 0x23, 0x37, 0x31, 0x70, 0x31,
+  0x37, 0x23, 0x28, 0x28, 0x23, 0x37, 0xfb, 0xb3, 0x70, 0x31, 0x37, 0x23,
+  0x28, 0x28, 0x23, 0x37, 0x31, 0x70, 0x31, 0x37, 0x23, 0x28, 0x28, 0x23,
+  0x37, 0x02, 0x59, 0x13, 0x15, 0x27, 0x2e, 0x6e, 0x2e, 0x27, 0x15, 0x13,
+  0x13, 0x15, 0x27, 0x2e, 0x6e, 0x2e, 0x27, 0x15, 0x13, 0x13, 0x15, 0x27,
+  0x2e, 0x6e, 0x2e, 0x27, 0x15, 0x13, 0x13, 0x15, 0x27, 0x2e, 0x6e, 0x2e,
+  0x27, 0x15, 0x00, 0x00, 0x00, 0x09, 0x00, 0x4b, 0xff, 0xe5, 0x05, 0xbd,
+  0x05, 0xf2, 0x00, 0x0c, 0x00, 0x18, 0x00, 0x25, 0x00, 0x32, 0x00, 0x3f,
+  0x00, 0x4b, 0x00, 0x57, 0x00, 0x5f, 0x00, 0x6b, 0x00, 0x00, 0x01, 0x14,
+  0x07, 0x06, 0x2b, 0x01, 0x25, 0x35, 0x25, 0x33, 0x32, 0x17, 0x16, 0x05,
+  0x34, 0x36, 0x3b, 0x01, 0x05, 0x15, 0x05, 0x23, 0x22, 0x27, 0x26, 0x01,
+  0x16, 0x15, 0x14, 0x0f, 0x01, 0x01, 0x27, 0x13, 0x37, 0x36, 0x33, 0x32,
+  0x01, 0x26, 0x35, 0x34, 0x3f, 0x01, 0x01, 0x17, 0x03, 0x07, 0x06, 0x23,
+  0x22, 0x03, 0x36, 0x33, 0x32, 0x1f, 0x01, 0x13, 0x07, 0x01, 0x27, 0x26,
+  0x35, 0x34, 0x01, 0x06, 0x22, 0x2f, 0x01, 0x03, 0x37, 0x01, 0x17, 0x16,
+  0x15, 0x14, 0x00, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x03, 0x23, 0x03, 0x35,
+  0x34, 0x37, 0x12, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x02, 0x22,
+  0x27, 0x26, 0x3d, 0x01, 0x13, 0x33, 0x13, 0x15, 0x14, 0x07, 0x05, 0xbd,
+  0x19, 0x1a, 0x24, 0x09, 0xfe, 0x8a, 0x01, 0x76, 0x09, 0x23, 0x1b, 0x19,
+  0xfa, 0x8f, 0x32, 0x24, 0x09, 0x01, 0x76, 0xfe, 0x8a, 0x09, 0x22, 0x1b,
+  0x19, 0x04, 0xa5, 0x1b, 0x19, 0x06, 0xfe, 0xd8, 0x40, 0xe8, 0x06, 0x1a,
+  0x25, 0x25, 0xfc, 0x40, 0x1a, 0x18, 0x07, 0x01, 0x28, 0x40, 0xe9, 0x06,
+  0x19, 0x25, 0x24, 0x1c, 0x1a, 0x26, 0x24, 0x1a, 0x06, 0xe9, 0x40, 0xfe,
+  0xd8, 0x07, 0x18, 0x03, 0xf4, 0x1b, 0x49, 0x1a, 0x06, 0xe8, 0x40, 0x01,
+  0x28, 0x06, 0x19, 0xfd, 0xd3, 0x4a, 0x1b, 0x1a, 0x2d, 0x5a, 0x2d, 0x1a,
+  0xc7, 0x4f, 0x70, 0x4f, 0x4f, 0x70, 0x13, 0x4a, 0x1b, 0x1a, 0x2d, 0x5a,
+  0x2d, 0x1a, 0x02, 0xec, 0x2a, 0x1e, 0x1c, 0x32, 0x64, 0x32, 0x1e, 0x1e,
+  0x28, 0x28, 0x3c, 0x32, 0x64, 0x32, 0x1c, 0x1e, 0x02, 0x4d, 0x1d, 0x2a,
+  0x27, 0x1d, 0x07, 0xfe, 0xfe, 0x46, 0x01, 0x49, 0x07, 0x1c, 0xfb, 0x9b,
+  0x1d, 0x2a, 0x27, 0x1d, 0x07, 0x01, 0x02, 0x46, 0xfe, 0xb7, 0x07, 0x1c,
+  0x04, 0x65, 0x1e, 0x1c, 0x07, 0xfe, 0xb7, 0x46, 0x01, 0x02, 0x07, 0x1b,
+  0x29, 0x2a, 0xfb, 0xd6, 0x1e, 0x1c, 0x07, 0x01, 0x49, 0x46, 0xfe, 0xfe,
+  0x07, 0x1b, 0x29, 0x2a, 0x05, 0x0d, 0x1d, 0x1c, 0x28, 0x0a, 0xfe, 0x61,
+  0x01, 0x9f, 0x0a, 0x27, 0x1d, 0xfd, 0x55, 0x7c, 0x58, 0x58, 0x7c, 0x58,
+  0xfc, 0x63, 0x1d, 0x1c, 0x28, 0x0a, 0x01, 0x9f, 0xfe, 0x61, 0x0a, 0x27,
+  0x1d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4b, 0xff, 0xe5, 0x05, 0xbd,
+  0x05, 0xf2, 0x00, 0x6c, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x03, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x01, 0x25, 0x36, 0x33, 0x32, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x25, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x03, 0x13, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x13, 0x03, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x05, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x05, 0x01,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x16, 0x17, 0x16, 0x17,
+  0x01, 0x03, 0x26, 0x35, 0x34, 0x37, 0x36, 0x03, 0x04, 0x27, 0x2a, 0x20,
+  0x05, 0x46, 0x01, 0x00, 0x12, 0x02, 0x2f, 0x2d, 0x3c, 0x1b, 0x1b, 0x2e,
+  0x09, 0x17, 0xfe, 0xa2, 0x01, 0xaf, 0x17, 0x0a, 0x45, 0x1e, 0x2a, 0x2a,
+  0x20, 0x43, 0x06, 0x21, 0xfe, 0x57, 0x01, 0x63, 0x19, 0x02, 0x2e, 0x1b,
+  0x1b, 0x3c, 0x27, 0x35, 0x09, 0x10, 0xfb, 0x46, 0x05, 0x20, 0x2a, 0x4d,
+  0x2b, 0x1f, 0x04, 0x46, 0xfb, 0x10, 0x09, 0x2f, 0x2d, 0x3b, 0x1c, 0x1b,
+  0x2f, 0x02, 0x19, 0x01, 0x62, 0xfe, 0x58, 0x22, 0x06, 0x43, 0x20, 0x29,
+  0x29, 0x1f, 0x44, 0x0b, 0x16, 0x01, 0xaf, 0xfe, 0xa2, 0x16, 0x09, 0x2f,
+  0x1b, 0x1c, 0x3b, 0x21, 0x3b, 0x02, 0x13, 0x00, 0xff, 0x46, 0x04, 0x1f,
+  0x2a, 0x05, 0xf2, 0x2f, 0x23, 0x4a, 0x07, 0x1f, 0xfe, 0x22, 0x01, 0x89,
+  0x1d, 0x01, 0x35, 0x1f, 0x1e, 0x43, 0x37, 0x2f, 0x09, 0x12, 0xfe, 0xe9,
+  0x4e, 0x04, 0x22, 0x2e, 0x58, 0x2e, 0x24, 0x06, 0x4d, 0xfe, 0xe5, 0x16,
+  0x01, 0x35, 0x31, 0x43, 0x1e, 0x1f, 0x35, 0x09, 0x19, 0x01, 0x85, 0xfe,
+  0x22, 0x1f, 0x07, 0x4a, 0x23, 0x2f, 0x2f, 0x23, 0x4a, 0x0e, 0x1e, 0x01,
+  0xd8, 0xfe, 0x7b, 0x19, 0x09, 0x35, 0x1f, 0x1e, 0x43, 0x4c, 0x1a, 0x01,
+  0x16, 0x01, 0x1b, 0x4d, 0x06, 0x24, 0x2e, 0x58, 0x2e, 0x22, 0x04, 0x4e,
+  0x01, 0x17, 0x12, 0x09, 0x35, 0x31, 0x43, 0x1e, 0x1f, 0x14, 0x21, 0x01,
+  0x1d, 0xfe, 0x77, 0x01, 0xd8, 0x1e, 0x0e, 0x4a, 0x23, 0x2f, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x5b, 0xff, 0xec, 0x06, 0x19, 0x05, 0xe8, 0x00, 0x0d,
+  0x00, 0x23, 0x00, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
+  0x02, 0x24, 0x23, 0x22, 0x04, 0x02, 0x01, 0x06, 0x23, 0x20, 0x00, 0x11,
+  0x34, 0x12, 0x24, 0x33, 0x32, 0x17, 0x36, 0x33, 0x32, 0x04, 0x12, 0x15,
+  0x10, 0x00, 0x21, 0x22, 0xa6, 0x01, 0x68, 0x00, 0xff, 0x01, 0x00, 0x01,
+  0x67, 0xa4, 0xfe, 0xd9, 0x9c, 0x9b, 0xfe, 0xd8, 0xa4, 0x02, 0x93, 0x16,
+  0x17, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0x17, 0x16, 0x17,
+  0x16, 0xae, 0x01, 0x4c, 0xb9, 0xfe, 0x6b, 0xfe, 0xe2, 0x16, 0x02, 0xea,
+  0xfe, 0xe4, 0xfe, 0x70, 0x01, 0x90, 0x01, 0x1c, 0xb3, 0x01, 0x47, 0xb1,
+  0xb1, 0xfe, 0xb9, 0xfc, 0x51, 0x02, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01,
+  0x72, 0xc6, 0x02, 0x02, 0xc6, 0xfe, 0x90, 0xc8, 0xfe, 0xc1, 0xfe, 0x41,
+  0x00, 0x02, 0x00, 0x6d, 0xff, 0x9c, 0x06, 0x07, 0x05, 0xd4, 0x00, 0x03,
+  0x00, 0x0b, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11, 0x17, 0x23, 0x11, 0x21,
+  0x15, 0x33, 0x11, 0x21, 0x05, 0x62, 0xfb, 0x56, 0x10, 0x5a, 0x05, 0x3f,
+  0x5a, 0xfa, 0xc1, 0x53, 0x05, 0x2e, 0xfa, 0xd2, 0x53, 0x05, 0xd4, 0x64,
+  0xfa, 0x2c, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6d, 0x00, 0x00, 0x06, 0x07,
+  0x06, 0x38, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11,
+  0x25, 0x15, 0x21, 0x11, 0x33, 0x35, 0x21, 0x11, 0x05, 0x62, 0xfb, 0x56,
+  0x04, 0xf5, 0xfa, 0xc1, 0x5a, 0x05, 0x3f, 0x53, 0x05, 0x2e, 0xfa, 0xd2,
+  0x11, 0x64, 0x05, 0xd4, 0x64, 0xfa, 0x2c, 0x00, 0x00, 0x02, 0x00, 0x6d,
+  0xff, 0x9c, 0x06, 0x07, 0x05, 0xd4, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00,
+  0x25, 0x11, 0x21, 0x11, 0x07, 0x11, 0x21, 0x17, 0x11, 0x21, 0x05, 0x62,
+  0xfb, 0x56, 0x4a, 0x05, 0x3f, 0x5a, 0xfa, 0xdc, 0x53, 0x05, 0x2e, 0xfa,
+  0xd2, 0x53, 0x05, 0xd4, 0x82, 0xfa, 0x4a, 0x00, 0x00, 0x02, 0x00, 0x6d,
+  0x00, 0x00, 0x06, 0x07, 0x06, 0x38, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00,
+  0x25, 0x11, 0x21, 0x11, 0x05, 0x21, 0x11, 0x37, 0x21, 0x11, 0x05, 0x62,
+  0xfb, 0x56, 0x04, 0xf5, 0xfa, 0xc1, 0x75, 0x05, 0x24, 0x53, 0x05, 0x2e,
+  0xfa, 0xd2, 0x53, 0x05, 0xd4, 0x64, 0xfa, 0x4a, 0x00, 0x04, 0x00, 0x99,
+  0xff, 0xfb, 0x05, 0xdc, 0x05, 0xd3, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x00, 0x13, 0x09, 0x0e, 0x99, 0x01, 0x31, 0x01, 0x31,
+  0xfe, 0xcf, 0x01, 0xaf, 0x01, 0x32, 0x01, 0x30, 0xfe, 0xd0, 0xfd, 0x60,
+  0x01, 0x31, 0x01, 0x31, 0xfe, 0xcf, 0xfe, 0xcf, 0x01, 0x31, 0x01, 0x31,
+  0xfe, 0xcf, 0x02, 0xe9, 0x01, 0x53, 0xfe, 0xad, 0xfe, 0xad, 0x01, 0x53,
+  0x01, 0x52, 0xfe, 0xae, 0xfe, 0xab, 0x02, 0xea, 0x01, 0x55, 0xfe, 0xab,
+  0xfe, 0xae, 0xfe, 0x22, 0x01, 0x53, 0xfe, 0xad, 0xfe, 0xad, 0x00, 0x00,
+  0x00, 0x01, 0x02, 0xb7, 0xfe, 0x14, 0x03, 0x51, 0x06, 0x14, 0x00, 0x03,
+  0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x03, 0x51, 0x99, 0x06, 0x14, 0xf8,
+  0x00, 0x08, 0x00, 0x00, 0x00, 0x01, 0x02, 0x6b, 0xfe, 0x14, 0x03, 0x9e,
+  0x06, 0x14, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x03, 0x9d,
+  0xfe, 0xce, 0x06, 0x14, 0xf8, 0x00, 0x08, 0x00, 0x00, 0x01, 0x01, 0xd2,
+  0xfe, 0x14, 0x04, 0x37, 0x06, 0x14, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x11, 0x04, 0x36, 0xfd, 0x9c, 0x06, 0x14, 0xf8, 0x00, 0x08, 0x00,
+  0x00, 0x01, 0x00, 0x9c, 0x03, 0x28, 0x01, 0xe6, 0x05, 0xd5, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x21, 0x11, 0x13, 0x33, 0x03, 0x33, 0x01, 0xe6, 0xfe,
+  0xb7, 0x93, 0x74, 0x4a, 0x8c, 0x03, 0x28, 0x01, 0x6e, 0x01, 0x3f, 0xfe,
+  0xc1, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6c, 0x03, 0x28, 0x01, 0xb6,
+  0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21, 0x11, 0x03, 0x23, 0x13,
+  0x23, 0x6c, 0x01, 0x49, 0x93, 0x74, 0x4a, 0x8c, 0x05, 0xd5, 0xfe, 0x92,
+  0xfe, 0xc1, 0x01, 0x3f, 0xff, 0xff, 0x00, 0x9c, 0x03, 0x28, 0x03, 0x74,
+  0x05, 0xd5, 0x10, 0x26, 0x0c, 0x34, 0x00, 0x00, 0x10, 0x07, 0x0c, 0x34,
+  0x01, 0x8e, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6c, 0x03, 0x28, 0x03, 0x44,
+  0x05, 0xd5, 0x10, 0x26, 0x0c, 0x35, 0x00, 0x00, 0x10, 0x07, 0x0c, 0x35,
+  0x01, 0x8e, 0x00, 0x00, 0x00, 0x02, 0x01, 0x1e, 0xff, 0x42, 0x05, 0x8f,
+  0x06, 0xcf, 0x00, 0x44, 0x00, 0x48, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x07, 0x06, 0x07, 0x0e, 0x01, 0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32,
+  0x37, 0x36, 0x37, 0x3e, 0x01, 0x35, 0x11, 0x21, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x33, 0x21, 0x35, 0x37, 0x15, 0x21, 0x07, 0x23, 0x11, 0x14, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x01, 0x11, 0x23, 0x11, 0x02, 0x94, 0x1c,
+  0x17, 0x18, 0x14, 0x13, 0x15, 0x15, 0x13, 0x14, 0x18, 0x17, 0x18, 0x19,
+  0x11, 0x11, 0x0f, 0x0f, 0x0e, 0x11, 0x0e, 0x12, 0x0f, 0x15, 0x56, 0x38,
+  0x41, 0x29, 0x31, 0x2f, 0xfe, 0xec, 0xc8, 0xe4, 0xea, 0xc2, 0x01, 0x14,
+  0x7f, 0x01, 0x32, 0x7e, 0xb4, 0x48, 0x38, 0x3c, 0x48, 0x46, 0xa0, 0x3d,
+  0x40, 0x28, 0x2d, 0x2a, 0x2c, 0x2b, 0x22, 0x3d, 0x33, 0x01, 0x7e, 0xab,
+  0x01, 0xd0, 0x0b, 0x0c, 0x15, 0x14, 0x38, 0x1f, 0x1e, 0x38, 0x14, 0x15,
+  0x0c, 0x0b, 0x09, 0x08, 0x10, 0x10, 0x27, 0x2e, 0x2a, 0x0e, 0x12, 0x06,
+  0x09, 0x1b, 0x21, 0x2d, 0x38, 0x81, 0x44, 0x01, 0x5f, 0xee, 0xb8, 0xbe,
+  0xe8, 0xc8, 0x32, 0xfa, 0x7b, 0xfb, 0xdb, 0x6a, 0xb7, 0x40, 0x46, 0x27,
+  0x25, 0x19, 0x1a, 0x2e, 0x33, 0x72, 0x40, 0x4d, 0x64, 0x37, 0x2b, 0x1d,
+  0x18, 0x01, 0x34, 0x02, 0x56, 0xfd, 0xaa, 0x00, 0x00, 0x02, 0x01, 0x74,
+  0xff, 0xdd, 0x04, 0x94, 0x05, 0xf0, 0x00, 0x15, 0x00, 0x2f, 0x00, 0x00,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x12, 0x32,
+  0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37,
+  0x03, 0x04, 0x90, 0x6d, 0x26, 0x27, 0x23, 0x23, 0x7b, 0xa0, 0x75, 0x78,
+  0x9d, 0x7a, 0x23, 0x22, 0x21, 0x2c, 0x54, 0x71, 0x70, 0x2f, 0x2f, 0x28,
+  0x29, 0x26, 0x26, 0x29, 0x28, 0x2f, 0x2f, 0x70, 0x2e, 0x30, 0x28, 0x28,
+  0x27, 0x27, 0x28, 0x28, 0x30, 0x05, 0xf0, 0x28, 0x0e, 0x2b, 0x26, 0x61,
+  0x34, 0x7c, 0x64, 0x83, 0xce, 0xce, 0x83, 0x66, 0x7a, 0x34, 0x61, 0x26,
+  0x24, 0x15, 0x28, 0xfc, 0x46, 0x16, 0x18, 0x2a, 0x2e, 0x6a, 0x3d, 0x3c,
+  0x6a, 0x2e, 0x2a, 0x18, 0x16, 0x16, 0x18, 0x2a, 0x2e, 0x6a, 0x3c, 0x3d,
+  0x6a, 0x2e, 0x2a, 0x18, 0x00, 0x02, 0x01, 0x2c, 0xff, 0xdd, 0x04, 0xdc,
+  0x05, 0xf0, 0x00, 0x21, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e,
+  0x01, 0x15, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x1e, 0x01, 0x15, 0x14, 0x07, 0x06, 0x02, 0x32, 0x17, 0x16, 0x17, 0x1e,
+  0x01, 0x15, 0x14, 0x06, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x03, 0x04, 0x6e, 0xef,
+  0x7a, 0x23, 0x22, 0x21, 0x2c, 0x29, 0x61, 0x29, 0x2b, 0x22, 0x21, 0x24,
+  0x24, 0x22, 0x22, 0x2a, 0x29, 0x62, 0x28, 0x2c, 0x21, 0x23, 0x23, 0x7b,
+  0xef, 0xa6, 0x70, 0x2f, 0x2f, 0x28, 0x29, 0x26, 0x26, 0x29, 0x28, 0x2f,
+  0x2f, 0x70, 0x2e, 0x30, 0x28, 0x28, 0x27, 0x27, 0x28, 0x28, 0x30, 0x02,
+  0xad, 0xc4, 0xa1, 0x53, 0x83, 0x34, 0x61, 0x26, 0x24, 0x15, 0x14, 0x14,
+  0x14, 0x25, 0x25, 0x60, 0x36, 0x36, 0x60, 0x25, 0x25, 0x14, 0x14, 0x14,
+  0x15, 0x24, 0x26, 0x61, 0x34, 0x84, 0x52, 0xa1, 0xfe, 0xc5, 0x16, 0x18,
+  0x2a, 0x2e, 0x6a, 0x3d, 0x3c, 0x6a, 0x2e, 0x2a, 0x18, 0x16, 0x16, 0x18,
+  0x2a, 0x2e, 0x6a, 0x3c, 0x3d, 0x6a, 0x2e, 0x2a, 0x18, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x63, 0x00, 0xab, 0x05, 0xa6, 0x05, 0x28, 0x00, 0x21,
+  0x00, 0x00, 0x25, 0x26, 0x25, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x34, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x07, 0x04,
+  0x03, 0x04, 0x7b, 0xfe, 0x89, 0xaf, 0x31, 0x32, 0x30, 0x3e, 0x3a, 0x8b,
+  0x3a, 0x3e, 0x30, 0x30, 0x33, 0x34, 0x2f, 0x31, 0x3d, 0x3b, 0x8a, 0x3b,
+  0x3e, 0x2f, 0x32, 0x31, 0xae, 0xfe, 0x89, 0xab, 0xef, 0xf2, 0x71, 0xb2,
+  0x4b, 0x8a, 0x36, 0x34, 0x1e, 0x1c, 0x1c, 0x1d, 0x35, 0x34, 0x89, 0x4e,
+  0x4e, 0x89, 0x34, 0x35, 0x1d, 0x1c, 0x1c, 0x1e, 0x34, 0x36, 0x8a, 0x4b,
+  0xb4, 0x6f, 0xf2, 0x00, 0x00, 0x01, 0x01, 0x35, 0xff, 0xfe, 0x05, 0x3f,
+  0x05, 0xd6, 0x00, 0x23, 0x00, 0x00, 0x01, 0x06, 0x03, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01,
+  0x33, 0x22, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x33, 0x32, 0x17, 0x12, 0x05, 0x3f, 0xd6, 0xda, 0x67, 0xa0,
+  0x43, 0x7c, 0x30, 0x2f, 0x1b, 0x19, 0x19, 0x19, 0x31, 0x2e, 0x7b, 0x46,
+  0x46, 0x7b, 0x2e, 0x31, 0x19, 0x19, 0x19, 0x1b, 0x2f, 0x30, 0x7c, 0x43,
+  0xa2, 0x65, 0xda, 0x02, 0xea, 0x8a, 0xfe, 0x60, 0xc2, 0x36, 0x38, 0x34,
+  0x46, 0x40, 0x4e, 0x4c, 0x42, 0x44, 0x36, 0x34, 0x3a, 0x38, 0x36, 0x36,
+  0x44, 0x40, 0x4e, 0x4c, 0x42, 0x44, 0x36, 0x36, 0x38, 0xc2, 0xfe, 0x5e,
+  0x00, 0x02, 0x00, 0x71, 0x00, 0x2a, 0x05, 0x37, 0x05, 0x9e, 0x00, 0x0d,
+  0x00, 0x69, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x06, 0x07, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x15, 0x14, 0x05, 0x06, 0x15, 0x14, 0x33, 0x32, 0x37, 0x36,
+  0x33, 0x32, 0x15, 0x14, 0x21, 0x22, 0x27, 0x26, 0x35, 0x10, 0x33, 0x32,
+  0x17, 0x36, 0x37, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x1f, 0x01, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x03, 0x3b, 0x09, 0x1a, 0x16, 0x30, 0x1b, 0x14, 0x11, 0x27,
+  0x42, 0x64, 0x13, 0x29, 0x54, 0x4e, 0x6f, 0x36, 0x28, 0xfe, 0xea, 0x8a,
+  0x5f, 0x68, 0x0f, 0x2d, 0x31, 0x39, 0xfe, 0xe4, 0xb7, 0xa8, 0xb2, 0xeb,
+  0x5c, 0x49, 0x45, 0x0e, 0x5b, 0xcf, 0x3e, 0x42, 0x4b, 0x39, 0x24, 0x26,
+  0x17, 0x21, 0x12, 0x1d, 0x16, 0x0d, 0x68, 0x54, 0x6a, 0x5d, 0x2d, 0x44,
+  0x25, 0x26, 0x46, 0x44, 0x2c, 0x2e, 0x0e, 0x36, 0x4d, 0x45, 0x25, 0x29,
+  0x13, 0x26, 0x13, 0x1c, 0x32, 0x3b, 0x26, 0x12, 0x81, 0x56, 0x6c, 0x3a,
+  0x04, 0x67, 0x30, 0x2c, 0x3f, 0x29, 0x21, 0x12, 0x0f, 0x1b, 0x3a, 0x22,
+  0x39, 0x8c, 0x4a, 0x4f, 0x43, 0x51, 0x3e, 0x5e, 0xda, 0x76, 0x3a, 0x4d,
+  0x63, 0x2a, 0x84, 0x5a, 0x9c, 0x99, 0xa3, 0xfe, 0x01, 0x65, 0x8d, 0x97,
+  0x43, 0x30, 0xaa, 0x33, 0x4e, 0x33, 0x35, 0x25, 0x26, 0x1d, 0x17, 0x14,
+  0x1c, 0x2d, 0x19, 0x4b, 0x74, 0x5c, 0x4b, 0x25, 0x39, 0x53, 0x1f, 0x20,
+  0x3e, 0x42, 0x57, 0x4e, 0x3d, 0x11, 0x21, 0x24, 0x1f, 0x3f, 0x12, 0x24,
+  0x15, 0x38, 0x1c, 0x28, 0x46, 0x21, 0x35, 0x7b, 0x5e, 0x3f, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x90, 0x01, 0x5a, 0x05, 0x78, 0x04, 0x84, 0x00, 0x09,
+  0x00, 0x51, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36,
+  0x35, 0x34, 0x01, 0x20, 0x35, 0x34, 0x37, 0x26, 0x27, 0x26, 0x2b, 0x01,
+  0x16, 0x07, 0x06, 0x07, 0x16, 0x33, 0x32, 0x37, 0x16, 0x15, 0x14, 0x23,
+  0x22, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x32,
+  0x17, 0x16, 0x17, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x13, 0x16,
+  0x33, 0x32, 0x35, 0x34, 0x27, 0x26, 0x35, 0x34, 0x33, 0x32, 0x15, 0x14,
+  0x07, 0x06, 0x01, 0xaf, 0x39, 0x28, 0x3c, 0x18, 0x47, 0x38, 0x37, 0x01,
+  0xcb, 0xfe, 0xb0, 0x6b, 0x2c, 0x30, 0x22, 0x22, 0x03, 0x01, 0x43, 0x57,
+  0x5a, 0x17, 0x3c, 0x27, 0x24, 0x07, 0x82, 0x61, 0x12, 0x20, 0x23, 0x1b,
+  0x5b, 0x45, 0x39, 0x0d, 0x21, 0x1f, 0x37, 0x41, 0x58, 0x0b, 0x81, 0x3b,
+  0x04, 0x37, 0x25, 0x27, 0x32, 0x1c, 0x37, 0x29, 0x62, 0xc3, 0x33, 0x16,
+  0x5b, 0x58, 0x0b, 0x0a, 0x48, 0x3c, 0xdf, 0x9e, 0x03, 0x3e, 0x0e, 0x24,
+  0x33, 0x67, 0x1d, 0x3a, 0x38, 0x34, 0x04, 0xfe, 0x21, 0xfe, 0x45, 0x42,
+  0x37, 0x1c, 0x14, 0x57, 0x50, 0x66, 0x0f, 0x47, 0x2b, 0x1e, 0x31, 0x4b,
+  0xab, 0x48, 0x8e, 0x50, 0x3c, 0x02, 0x12, 0x12, 0x12, 0x0e, 0x11, 0x46,
+  0x66, 0x1d, 0x23, 0x26, 0x54, 0x27, 0x19, 0x13, 0x14, 0x30, 0x50, 0x2b,
+  0x41, 0x27, 0x1d, 0xfe, 0x93, 0x9a, 0x3c, 0x1e, 0x12, 0x11, 0x1b, 0x3c,
+  0x51, 0xad, 0x62, 0x46, 0x00, 0x01, 0x01, 0x68, 0xfe, 0xe4, 0x04, 0xab,
+  0x06, 0x27, 0x00, 0x20, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x15,
+  0x22, 0x07, 0x06, 0x02, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x33, 0x04, 0xaa, 0xa7, 0x98, 0x91, 0x7c, 0x79, 0x3f, 0x3d,
+  0x3d, 0x3a, 0x7e, 0x76, 0x97, 0x98, 0xa7, 0x62, 0x5d, 0x57, 0x95, 0x24,
+  0x24, 0x24, 0x24, 0x4b, 0x46, 0x5b, 0x59, 0x66, 0xfe, 0xe4, 0x47, 0x43,
+  0x89, 0x85, 0xa7, 0xa4, 0xbb, 0xbd, 0xa9, 0x9d, 0x8f, 0x86, 0x46, 0x47,
+  0x2f, 0x43, 0x3e, 0xfe, 0xfa, 0x9b, 0x9c, 0xb8, 0xb1, 0x9c, 0x9b, 0x83,
+  0x7d, 0x44, 0x43, 0x00, 0x00, 0x01, 0x01, 0x68, 0xfe, 0xe4, 0x04, 0xab,
+  0x06, 0x27, 0x00, 0x22, 0x00, 0x00, 0x01, 0x30, 0x35, 0x32, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x02, 0x27, 0x26, 0x23,
+  0x30, 0x35, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x01, 0x69, 0x67, 0x59, 0x5b, 0x46, 0x4a,
+  0x24, 0x24, 0x24, 0x24, 0x95, 0x56, 0x5e, 0x62, 0xa7, 0x98, 0x97, 0x77,
+  0x7e, 0x39, 0x3d, 0x3d, 0x3f, 0x78, 0x7d, 0x91, 0x98, 0xfe, 0xe4, 0x2f,
+  0x43, 0x44, 0x7d, 0x83, 0x9b, 0x9c, 0xb1, 0xb8, 0x9c, 0x9b, 0x01, 0x06,
+  0x3e, 0x43, 0x2f, 0x47, 0x46, 0x86, 0x8f, 0x9d, 0xa9, 0xbd, 0xbb, 0xa4,
+  0xa7, 0x85, 0x89, 0x43, 0x47, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe6,
+  0xfe, 0xf1, 0x04, 0x23, 0x06, 0x11, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x06,
+  0x02, 0x10, 0x12, 0x17, 0x21, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x04,
+  0x22, 0x78, 0x75, 0x76, 0x77, 0xfe, 0xd2, 0x87, 0x86, 0x85, 0x88, 0x06,
+  0x11, 0xe6, 0xfe, 0x3e, 0xfe, 0x32, 0xfe, 0x3b, 0xe5, 0xeb, 0x01, 0xc6,
+  0xe0, 0xdf, 0x01, 0xc4, 0xec, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0xe6,
+  0xfe, 0xf1, 0x04, 0x23, 0x06, 0x11, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x30,
+  0x21, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x21, 0x36, 0x12, 0x10, 0x02,
+  0x01, 0xe7, 0x01, 0x2e, 0x88, 0x85, 0x86, 0x87, 0xfe, 0xd2, 0x78, 0x75,
+  0x74, 0x06, 0x11, 0xec, 0xfe, 0x3c, 0xdf, 0xe0, 0xfe, 0x3a, 0xeb, 0xe5,
+  0x01, 0xc5, 0x01, 0xce, 0x01, 0xc2, 0x00, 0x00, 0x00, 0x01, 0x01, 0x8c,
+  0xfe, 0x14, 0x04, 0x5f, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x09, 0x01, 0x21, 0x01, 0x04, 0x5f, 0xfe, 0xf9, 0xfe, 0x35, 0x01, 0xcb,
+  0x01, 0x07, 0xfe, 0x33, 0xfe, 0x14, 0x04, 0x00, 0x04, 0x00, 0xfc, 0x00,
+  0x00, 0x01, 0x01, 0xab, 0xfe, 0x14, 0x04, 0x7d, 0x06, 0x14, 0x00, 0x05,
+  0x00, 0x00, 0x09, 0x02, 0x21, 0x09, 0x01, 0x01, 0xac, 0x01, 0xcb, 0xfe,
+  0x35, 0x01, 0x05, 0x01, 0xcb, 0xfe, 0x35, 0xfe, 0x14, 0x04, 0x00, 0x04,
+  0x00, 0xfc, 0x00, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x05,
+  0xfe, 0x14, 0x04, 0xef, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x09, 0x01, 0x21, 0x01, 0x04, 0xef, 0xfe, 0x69, 0xfd, 0xae, 0x02, 0x52,
+  0x01, 0x97, 0xfd, 0xa3, 0xfe, 0x14, 0x04, 0x00, 0x04, 0x00, 0xfc, 0x00,
+  0x00, 0x01, 0x01, 0x19, 0xfe, 0x14, 0x05, 0x03, 0x06, 0x14, 0x00, 0x05,
+  0x00, 0x00, 0x09, 0x02, 0x21, 0x09, 0x01, 0x01, 0x1a, 0x02, 0x5c, 0xfd,
+  0xa4, 0x01, 0x96, 0x02, 0x52, 0xfd, 0xae, 0xfe, 0x14, 0x04, 0x00, 0x04,
+  0x00, 0xfc, 0x00, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x32,
+  0xfe, 0x14, 0x04, 0xb9, 0x06, 0x14, 0x00, 0x05, 0x00, 0x00, 0x01, 0x21,
+  0x09, 0x01, 0x21, 0x01, 0x04, 0xb9, 0xfe, 0x45, 0xfe, 0x35, 0x01, 0xcb,
+  0x01, 0xbb, 0xfe, 0x33, 0xfe, 0x14, 0x04, 0x00, 0x04, 0x00, 0xfc, 0x00,
+  0x00, 0x01, 0x01, 0x51, 0xfe, 0x14, 0x04, 0xd7, 0x06, 0x14, 0x00, 0x05,
+  0x00, 0x00, 0x09, 0x02, 0x21, 0x09, 0x01, 0x01, 0x52, 0x01, 0xcb, 0xfe,
+  0x35, 0x01, 0xb9, 0x01, 0xcb, 0xfe, 0x35, 0xfe, 0x14, 0x04, 0x00, 0x04,
+  0x00, 0xfc, 0x00, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x7d,
+  0xfe, 0x13, 0x03, 0xdb, 0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x05, 0x17,
+  0x07, 0x03, 0x11, 0x13, 0x17, 0x07, 0x03, 0x04, 0xd6, 0x5f, 0xfe, 0xfe,
+  0x5f, 0xd6, 0x95, 0xee, 0x6a, 0x01, 0x1a, 0x05, 0xcd, 0x01, 0x1a, 0x6a,
+  0xee, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x2e, 0xfe, 0x13, 0x03, 0x8c,
+  0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x01, 0x27, 0x37, 0x13, 0x11, 0x03,
+  0x27, 0x37, 0x03, 0x04, 0xd6, 0x5f, 0xfe, 0xfe, 0x5f, 0xd6, 0x04, 0xbc,
+  0xee, 0x6a, 0xfe, 0xe6, 0xfa, 0x33, 0xfe, 0xe6, 0x6a, 0xee, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x42, 0xfe, 0xb2, 0x04, 0x92, 0x06, 0x14, 0x00, 0x24,
+  0x00, 0x00, 0x05, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x34, 0x26, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34, 0x36, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x06, 0x1d, 0x01, 0x14, 0x06, 0x07, 0x1e, 0x01, 0x1d, 0x01,
+  0x14, 0x16, 0x33, 0x04, 0x91, 0xbf, 0xe0, 0x98, 0x61, 0x80, 0x37, 0x37,
+  0x81, 0x60, 0x98, 0xe0, 0xbf, 0x3d, 0x7f, 0x4d, 0x52, 0x63, 0x64, 0x51,
+  0x4d, 0x7f, 0xbe, 0x90, 0x94, 0xdd, 0xef, 0x97, 0x74, 0x8f, 0x73, 0x95,
+  0xf0, 0xdd, 0x93, 0x8f, 0x58, 0x8d, 0xf8, 0x9d, 0x8e, 0x19, 0x1b, 0x8e,
+  0x9c, 0xf8, 0x8d, 0x58, 0x00, 0x01, 0x01, 0x77, 0xfe, 0xb2, 0x04, 0xc7,
+  0x06, 0x14, 0x00, 0x24, 0x00, 0x00, 0x05, 0x33, 0x32, 0x36, 0x3d, 0x01,
+  0x34, 0x36, 0x37, 0x2e, 0x01, 0x3d, 0x01, 0x34, 0x26, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x16, 0x1d, 0x01, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x06, 0x1d, 0x01, 0x14, 0x06, 0x2b, 0x01, 0x01, 0x77, 0x3d, 0x7f, 0x4e,
+  0x51, 0x64, 0x63, 0x52, 0x4e, 0x7f, 0x3d, 0xbf, 0xe0, 0x98, 0x61, 0x80,
+  0x37, 0x37, 0x7f, 0x62, 0x98, 0xe0, 0xbf, 0xbe, 0x58, 0x8d, 0xf8, 0x9c,
+  0x8e, 0x1b, 0x19, 0x8e, 0x9d, 0xf8, 0x8d, 0x58, 0x8f, 0x93, 0xdd, 0xf0,
+  0x95, 0x73, 0x8f, 0x74, 0x97, 0xef, 0xdd, 0x94, 0x00, 0x02, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x18, 0x00, 0x00,
+  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
+  0x04, 0x12, 0x01, 0x21, 0x35, 0x23, 0x11, 0x23, 0x07, 0x15, 0x37, 0x11,
+  0x23, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9,
+  0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfc, 0x3e, 0x02, 0x2b, 0xc4,
+  0x91, 0xe8, 0xd5, 0xc3, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf,
+  0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfd, 0x5c, 0x8e,
+  0x03, 0x1a, 0x2f, 0x98, 0x2b, 0xfd, 0x82, 0x00, 0x00, 0x02, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x2a, 0x00, 0x00,
+  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
+  0x04, 0x12, 0x05, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x0e, 0x01,
+  0x07, 0x15, 0x21, 0x35, 0x21, 0x3e, 0x01, 0x05, 0xec, 0xfe, 0x6c, 0xfe,
+  0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c,
+  0xb9, 0xfe, 0x1b, 0x38, 0x2b, 0xb1, 0x93, 0x36, 0x83, 0x57, 0x67, 0x77,
+  0x35, 0x46, 0x56, 0x2b, 0x37, 0x1e, 0xec, 0x4a, 0x02, 0x61, 0xfe, 0x77,
+  0x71, 0xa0, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f,
+  0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xe9, 0x46, 0x69, 0x3a, 0x7d,
+  0x97, 0x1f, 0x24, 0xab, 0x3a, 0x26, 0x4e, 0x3f, 0x28, 0x55, 0x3f, 0x22,
+  0xf1, 0x4d, 0x81, 0x8e, 0x74, 0xa7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x36, 0x00, 0x00,
+  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
+  0x04, 0x12, 0x25, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x15, 0x3e, 0x01,
+  0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x27, 0x32, 0x36, 0x05, 0xec, 0xfe, 0x6c, 0xfe,
+  0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c,
+  0xb9, 0xfe, 0xa2, 0xad, 0x91, 0x37, 0x7b, 0x55, 0x60, 0x6d, 0x2f, 0x52,
+  0x53, 0x50, 0x50, 0x83, 0x7e, 0x59, 0x60, 0x67, 0x69, 0x3e, 0x70, 0x52,
+  0x4f, 0x7b, 0x39, 0xb0, 0xc2, 0x6a, 0x0c, 0x04, 0x5d, 0x02, 0xea, 0xfe,
+  0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6,
+  0xfe, 0x90, 0x18, 0x73, 0x89, 0x14, 0x18, 0x97, 0x20, 0x15, 0x3f, 0x3c,
+  0x3a, 0x3c, 0x8c, 0x4e, 0x47, 0x4c, 0x4f, 0x1c, 0x30, 0xa8, 0x1b, 0x17,
+  0x9c, 0x8d, 0x5d, 0x81, 0x03, 0x72, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x10, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
+  0x33, 0x32, 0x04, 0x12, 0x01, 0x23, 0x13, 0x01, 0x15, 0x21, 0x15, 0x33,
+  0x35, 0x33, 0x35, 0x23, 0x11, 0x23, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1,
+  0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9,
+  0xfd, 0x60, 0xf2, 0xf2, 0xfe, 0x70, 0x01, 0x90, 0xa4, 0x7f, 0x7f, 0xb9,
+  0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01,
+  0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfe, 0xbc, 0x01, 0x7e, 0xfe, 0x83, 0x8e,
+  0xd3, 0xd3, 0x8d, 0x02, 0x48, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x2b, 0x00, 0x00,
+  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32,
+  0x04, 0x12, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x37, 0x35, 0x21, 0x35, 0x21, 0x05, 0xec, 0xfe, 0x6c,
+  0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01,
+  0x4c, 0xb9, 0xfc, 0x57, 0x50, 0x5b, 0x2d, 0x5d, 0x6a, 0x6a, 0x5d, 0x3d,
+  0x6c, 0x55, 0x4f, 0x78, 0x39, 0xab, 0xc0, 0xba, 0x9f, 0x1b, 0x39, 0x03,
+  0x01, 0x68, 0xfd, 0xfd, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf,
+  0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xf3, 0x25, 0x14,
+  0x61, 0x56, 0x55, 0x61, 0x1b, 0x2f, 0xac, 0x18, 0x14, 0xac, 0x98, 0x95,
+  0xb0, 0x0a, 0x01, 0xab, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88,
+  0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d, 0x00, 0x19, 0x00, 0x32,
+  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24,
+  0x33, 0x32, 0x04, 0x12, 0x01, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x03, 0x22, 0x02, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x37, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0x17, 0x35, 0x2e, 0x01, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe,
+  0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfd,
+  0xde, 0x53, 0x46, 0x46, 0x53, 0x53, 0x46, 0x46, 0x53, 0x66, 0xb4, 0xd2,
+  0xad, 0xa6, 0x90, 0xaf, 0xa8, 0x90, 0x46, 0x73, 0x08, 0x05, 0x72, 0x6b,
+  0x2a, 0x58, 0x4b, 0x42, 0x60, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01,
+  0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfe, 0x8f,
+  0x5a, 0x62, 0x62, 0x5a, 0x5b, 0x62, 0x62, 0x02, 0x2a, 0xfe, 0xf5, 0xda,
+  0xe7, 0xfd, 0xb3, 0x91, 0x94, 0xb1, 0x3d, 0x0b, 0x50, 0x94, 0x16, 0x23,
+  0x9c, 0x18, 0x13, 0x00, 0x00, 0x02, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
+  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x25, 0x21,
+  0x01, 0x33, 0x01, 0x35, 0x21, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe,
+  0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfc,
+  0x2e, 0x01, 0xa1, 0xfe, 0xd1, 0xad, 0x01, 0x48, 0xfd, 0x99, 0x02, 0xea,
+  0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6,
+  0xc6, 0xfe, 0x90, 0x76, 0xfc, 0xe6, 0x03, 0x5d, 0x4b, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
+  0x00, 0x19, 0x00, 0x31, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x01, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x05, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x17, 0x0e, 0x01, 0x01, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x05, 0xec,
+  0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab,
+  0xae, 0x01, 0x4c, 0xb9, 0xfd, 0xf3, 0x56, 0x4b, 0x4c, 0x55, 0x55, 0x4c,
+  0x4b, 0x56, 0xfe, 0x18, 0xab, 0x9c, 0x9c, 0xaa, 0x6a, 0x0d, 0x03, 0x5f,
+  0xa4, 0x8d, 0x8e, 0xa4, 0x5f, 0x04, 0x0e, 0x6a, 0x01, 0x47, 0x43, 0x4a,
+  0x4a, 0x43, 0x46, 0x48, 0x48, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01,
+  0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfe, 0x6c,
+  0x48, 0x51, 0x50, 0x49, 0x49, 0x50, 0x50, 0x49, 0x8a, 0x97, 0x97, 0x8a,
+  0x5c, 0x83, 0x03, 0x01, 0x76, 0x53, 0x74, 0x88, 0x88, 0x74, 0x53, 0x76,
+  0x01, 0x03, 0x83, 0x01, 0xc4, 0x42, 0x3e, 0x3d, 0x42, 0x42, 0x3d, 0x3e,
+  0x42, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec,
+  0x05, 0xe8, 0x00, 0x0d, 0x00, 0x26, 0x00, 0x32, 0x00, 0x00, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12,
+  0x01, 0x32, 0x12, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x07, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e,
+  0x01, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x05, 0xec, 0xfe, 0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9,
+  0x01, 0x4c, 0xab, 0xae, 0x01, 0x4c, 0xb9, 0xfd, 0x22, 0xb4, 0xd2, 0xac,
+  0xa7, 0x90, 0xae, 0xa7, 0x8f, 0x47, 0x74, 0x09, 0x05, 0x72, 0x6b, 0x2a,
+  0x57, 0x4c, 0x42, 0x60, 0x36, 0x53, 0x46, 0x47, 0x52, 0x52, 0x47, 0x46,
+  0x53, 0x02, 0xea, 0xfe, 0xc1, 0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6,
+  0x01, 0x72, 0xc6, 0xc6, 0xfe, 0x90, 0xfd, 0x4b, 0x01, 0x0a, 0xda, 0xe8,
+  0xfd, 0xb4, 0x91, 0x94, 0xaf, 0x3c, 0x0d, 0x4f, 0x93, 0x15, 0x24, 0x9c,
+  0x18, 0x13, 0x02, 0x84, 0x5b, 0x62, 0x62, 0x5b, 0x5b, 0x62, 0x62, 0x00,
+  0x00, 0x04, 0x00, 0x88, 0xff, 0xec, 0x05, 0xec, 0x05, 0xe8, 0x00, 0x0d,
+  0x00, 0x18, 0x00, 0x24, 0x00, 0x30, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x34, 0x12, 0x24, 0x33, 0x32, 0x04, 0x12, 0x01, 0x21,
+  0x35, 0x23, 0x11, 0x23, 0x07, 0x15, 0x37, 0x11, 0x23, 0x01, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x05, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x05, 0xec, 0xfe,
+  0x6c, 0xfe, 0xe1, 0xfe, 0xe4, 0xfe, 0x6c, 0xb9, 0x01, 0x4c, 0xab, 0xae,
+  0x01, 0x4c, 0xb9, 0xfb, 0xa0, 0x01, 0x95, 0x8f, 0x69, 0xaa, 0x9b, 0x8e,
+  0x03, 0x2e, 0x3e, 0x39, 0x3a, 0x3e, 0x3e, 0x3a, 0x39, 0x3e, 0xfe, 0x98,
+  0x7b, 0x76, 0x75, 0x7a, 0x7a, 0x75, 0x76, 0x7b, 0x02, 0xea, 0xfe, 0xc1,
+  0xfe, 0x41, 0x01, 0xbf, 0x01, 0x3f, 0xc6, 0x01, 0x72, 0xc6, 0xc6, 0xfe,
+  0x90, 0xfd, 0xa9, 0x80, 0x02, 0xca, 0x2a, 0x89, 0x27, 0xfd, 0xc2, 0x01,
+  0x24, 0xa2, 0x97, 0x97, 0xa2, 0xa3, 0x97, 0x97, 0xa3, 0xd0, 0xe4, 0xe4,
+  0xd0, 0xd1, 0xe4, 0xe4, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
+  0x06, 0x3d, 0x00, 0x19, 0x00, 0x24, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x20,
+  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
+  0x01, 0x33, 0x11, 0x05, 0x35, 0x25, 0x33, 0x11, 0x33, 0x15, 0x21, 0x12,
+  0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07,
+  0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36,
+  0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64,
+  0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64,
+  0x62, 0x77, 0xfd, 0xe2, 0xed, 0xfe, 0xfe, 0x01, 0x01, 0x91, 0xee, 0xfd,
+  0x95, 0x7f, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
+  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
+  0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe,
+  0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97,
+  0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfb, 0x7d, 0x03, 0x8f, 0x39, 0x93,
+  0x3a, 0xfb, 0xdd, 0x88, 0x05, 0xa8, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
+  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
+  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
+  0x00, 0x36, 0x00, 0x50, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06,
+  0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
+  0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x01, 0x21, 0x15, 0x21,
+  0x35, 0x36, 0x00, 0x37, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x0e,
+  0x01, 0x02, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07,
+  0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12,
+  0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62,
+  0x62, 0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62,
+  0x62, 0x64, 0x62, 0x77, 0xfe, 0x59, 0x01, 0xfb, 0xfd, 0x56, 0x53, 0x01,
+  0x1d, 0x25, 0x46, 0x37, 0x78, 0x60, 0x48, 0x95, 0x56, 0x57, 0x99, 0x3f,
+  0xa8, 0xc7, 0x32, 0x42, 0x12, 0xc1, 0xa7, 0x01, 0x39, 0x89, 0x87, 0x6f,
+  0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70,
+  0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f,
+  0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36,
+  0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfb,
+  0x80, 0x88, 0x88, 0x5f, 0x01, 0x41, 0x2e, 0x58, 0x78, 0x3b, 0x5f, 0x78,
+  0x35, 0x35, 0xa3, 0x27, 0x28, 0xba, 0x9b, 0x49, 0x84, 0x5a, 0x17, 0xde,
+  0x04, 0x56, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4,
+  0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1,
+  0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08,
+  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19, 0x00, 0x42, 0x00, 0x5c,
+  0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12,
+  0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34,
+  0x02, 0x27, 0x26, 0x27, 0x03, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x00, 0x20, 0x17,
+  0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03,
+  0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77,
+  0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77,
+  0x68, 0x68, 0x76, 0xda, 0xca, 0x44, 0x8f, 0x4d, 0x3d, 0x90, 0x4e, 0x89,
+  0x8f, 0x85, 0x77, 0x7d, 0x83, 0x6c, 0x71, 0x75, 0x6e, 0x3b, 0x89, 0x53,
+  0x4a, 0x9a, 0x40, 0xa7, 0xc0, 0x66, 0xfe, 0x6a, 0x01, 0x39, 0x89, 0x87,
+  0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87,
+  0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f,
+  0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39,
+  0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36,
+  0xfd, 0x79, 0x19, 0x9c, 0x74, 0xb0, 0xc2, 0x1e, 0x1d, 0x9c, 0x27, 0x28,
+  0x78, 0x72, 0x6a, 0x77, 0x85, 0x5f, 0x5a, 0x5c, 0x62, 0x1d, 0x1e, 0x90,
+  0x17, 0x1c, 0xa7, 0x8e, 0x64, 0x88, 0x03, 0x09, 0x40, 0x3e, 0x7d, 0x7e,
+  0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e,
+  0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00,
+  0x00, 0x04, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
+  0x00, 0x1c, 0x00, 0x27, 0x00, 0x41, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06,
+  0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37,
+  0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x07, 0x01,
+  0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x21, 0x35,
+  0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06,
+  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37,
+  0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62,
+  0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62,
+  0x64, 0x62, 0x77, 0xc7, 0xfe, 0x90, 0x01, 0x70, 0x26, 0xb6, 0x9a, 0x9a,
+  0x90, 0xfe, 0x1a, 0x01, 0x0e, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e,
+  0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f,
+  0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7,
+  0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f,
+  0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xed, 0xfd, 0x82,
+  0x03, 0x0b, 0xfc, 0xf5, 0x86, 0xfe, 0xe6, 0x01, 0x1a, 0x9c, 0x03, 0xf2,
+  0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d,
+  0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c,
+  0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
+  0x06, 0x3d, 0x00, 0x19, 0x00, 0x37, 0x00, 0x51, 0x00, 0x00, 0x00, 0x20,
+  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
+  0x05, 0x21, 0x15, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16,
+  0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27,
+  0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb,
+  0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01, 0x15,
+  0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfd, 0xe0, 0x02,
+  0x3b, 0xfe, 0x4a, 0x20, 0x40, 0x1f, 0xb4, 0xd2, 0xd8, 0xc5, 0x43, 0x8c,
+  0x4b, 0x44, 0x86, 0x4e, 0x7c, 0x92, 0x92, 0x7c, 0x3b, 0x74, 0x3c, 0x81,
+  0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89,
+  0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05,
+  0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f,
+  0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01,
+  0x09, 0x6f, 0x6f, 0x36, 0x63, 0x88, 0xfe, 0xdb, 0x0c, 0x0c, 0xdb, 0xbb,
+  0xc1, 0xd6, 0x1a, 0x19, 0xa3, 0x29, 0x25, 0x92, 0x7d, 0x7c, 0x92, 0x1d,
+  0x1e, 0x03, 0x58, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe,
+  0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac,
+  0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00, 0x04, 0x00, 0x08,
+  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19, 0x00, 0x25, 0x00, 0x3e,
+  0x00, 0x58, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15,
+  0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12,
+  0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x13, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x07, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x02, 0x11, 0x10, 0x12, 0x33, 0x32, 0x16, 0x00, 0x20, 0x17, 0x16, 0x17,
+  0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26,
+  0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe,
+  0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01,
+  0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfe, 0xf4,
+  0x61, 0x73, 0x73, 0x61, 0x62, 0x73, 0x73, 0xbf, 0x37, 0x6f, 0x36, 0x90,
+  0x98, 0x0b, 0x2a, 0x80, 0x4d, 0xa2, 0xbc, 0xc4, 0xa3, 0xba, 0xc5, 0xf2,
+  0xcb, 0x37, 0x70, 0xfe, 0x88, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e,
+  0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f,
+  0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7,
+  0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f,
+  0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfd, 0x8b, 0x95,
+  0x82, 0x80, 0x96, 0x96, 0x80, 0x82, 0x95, 0x01, 0xfa, 0x93, 0x1d, 0x1e,
+  0xd8, 0xda, 0x45, 0x4b, 0xdb, 0xbc, 0xb8, 0xde, 0x01, 0x3e, 0x01, 0x2d,
+  0x01, 0x1d, 0x01, 0x4f, 0x18, 0x01, 0x00, 0x40, 0x3e, 0x7d, 0x7e, 0xfe,
+  0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d,
+  0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
+  0x00, 0x20, 0x00, 0x3a, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06,
+  0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
+  0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x05, 0x21, 0x15, 0x01,
+  0x23, 0x01, 0x21, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
+  0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35,
+  0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62,
+  0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62,
+  0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfd, 0xa0, 0x02, 0xb3, 0xfe, 0x7a,
+  0x98, 0x01, 0x70, 0xfd, 0xfb, 0xc1, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72,
+  0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71,
+  0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe,
+  0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f,
+  0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0x60, 0x45,
+  0xfb, 0x9a, 0x04, 0x23, 0x01, 0x85, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
+  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
+  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19,
+  0x00, 0x23, 0x00, 0x39, 0x00, 0x45, 0x00, 0x5f, 0x00, 0x00, 0x00, 0x20,
+  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
+  0x01, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x35, 0x34, 0x26, 0x27, 0x2e,
+  0x01, 0x35, 0x34, 0x36, 0x20, 0x16, 0x15, 0x14, 0x06, 0x07, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x20, 0x26, 0x35, 0x34, 0x36, 0x13, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x12, 0x20, 0x17, 0x16,
+  0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
+  0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f,
+  0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79,
+  0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfe,
+  0xfc, 0x67, 0x77, 0x77, 0xcf, 0x77, 0x76, 0xfa, 0x5e, 0x68, 0xb7, 0x01,
+  0x41, 0xb7, 0x68, 0x5e, 0x69, 0x76, 0xbe, 0xfe, 0x9b, 0xbf, 0x77, 0x33,
+  0x69, 0x5e, 0x5e, 0x6a, 0x6a, 0x5e, 0x5e, 0x69, 0x2c, 0x01, 0x39, 0x89,
+  0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89,
+  0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36,
+  0x6f, 0x6f, 0xfe, 0xf7, 0x9c, 0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39,
+  0x39, 0x36, 0x6f, 0x6f, 0x01, 0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f,
+  0x36, 0xfd, 0x2c, 0x7b, 0xd8, 0x7b, 0x7c, 0x6b, 0x6c, 0x7b, 0x45, 0x1a,
+  0x8e, 0x67, 0x8f, 0xa6, 0xa6, 0x8f, 0x67, 0x8e, 0x1a, 0x1b, 0x9e, 0x73,
+  0xad, 0xba, 0xba, 0xad, 0x73, 0x9e, 0x01, 0x1a, 0x5c, 0x68, 0x68, 0x5c,
+  0x5d, 0x68, 0x68, 0x01, 0xd0, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1,
+  0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01,
+  0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x04, 0x00, 0x08,
+  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x19, 0x00, 0x32, 0x00, 0x3e,
+  0x00, 0x58, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15,
+  0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12,
+  0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x01, 0x35, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x37, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32,
+  0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x02, 0x20, 0x17, 0x16, 0x17,
+  0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26,
+  0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x8f, 0xfe,
+  0xeb, 0x79, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0x79, 0x01,
+  0x15, 0x78, 0x77, 0x62, 0x64, 0x62, 0x62, 0x64, 0x62, 0x77, 0xfd, 0xe3,
+  0x37, 0x70, 0x36, 0x90, 0x98, 0x0b, 0x2a, 0x80, 0x4e, 0xa2, 0xbb, 0xc4,
+  0xa2, 0xbc, 0xc4, 0xf1, 0xcc, 0x37, 0x70, 0xe4, 0x63, 0x72, 0x72, 0x63,
+  0x61, 0x73, 0x73, 0x42, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e,
+  0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f,
+  0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0xfe, 0xf7, 0x9c,
+  0x97, 0xfe, 0xf7, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x01,
+  0x09, 0x97, 0x9c, 0x01, 0x09, 0x6f, 0x6f, 0x36, 0xfb, 0x0e, 0x93, 0x1d,
+  0x1e, 0xd7, 0xdb, 0x44, 0x4a, 0xd9, 0xbc, 0xb8, 0xde, 0xfe, 0xc3, 0xfe,
+  0xd1, 0xfe, 0xe6, 0xfe, 0xaf, 0x18, 0x02, 0x12, 0x95, 0x82, 0x81, 0x95,
+  0x95, 0x81, 0x82, 0x95, 0x03, 0x95, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
+  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
+  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x1d,
+  0x00, 0x2b, 0x00, 0x38, 0x00, 0x43, 0x00, 0x61, 0x00, 0x00, 0x00, 0x20,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x27, 0x26, 0x27, 0x07, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x27, 0x2e, 0x01, 0x20, 0x17, 0x16, 0x11, 0x10,
+  0x07, 0x06, 0x20, 0x02, 0x11, 0x10, 0x37, 0x01, 0x33, 0x11, 0x07, 0x35,
+  0x37, 0x33, 0x11, 0x33, 0x15, 0x21, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
+  0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x03, 0x8f, 0xfe, 0xeb, 0x79, 0x77, 0x62, 0x64, 0x30, 0x32, 0x32, 0x30,
+  0x64, 0x62, 0x77, 0x79, 0x01, 0x15, 0x78, 0x77, 0x62, 0x64, 0x30, 0x32,
+  0x32, 0x30, 0x64, 0x62, 0x77, 0x1a, 0x4b, 0x28, 0x27, 0x4e, 0x4c, 0x4e,
+  0x4d, 0x27, 0x26, 0xd7, 0x01, 0x13, 0x49, 0x48, 0x48, 0x49, 0xfe, 0xed,
+  0x90, 0x48, 0xfe, 0x61, 0x7f, 0x87, 0x86, 0x74, 0x76, 0xfe, 0x98, 0xeb,
+  0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x36, 0x38, 0x38, 0x36, 0x72, 0x6f,
+  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x36, 0x39, 0x39, 0x36,
+  0x71, 0x70, 0x87, 0x05, 0xd9, 0x39, 0x36, 0x6f, 0x6f, 0x83, 0x86, 0x9c,
+  0x97, 0x86, 0x83, 0x6f, 0x6f, 0x36, 0x39, 0x39, 0x36, 0x6f, 0x6f, 0x83,
+  0x86, 0x97, 0x9c, 0x86, 0x83, 0x6f, 0x6f, 0x36, 0xcb, 0x7b, 0x7a, 0xf7,
+  0xf5, 0xf6, 0xf6, 0xf5, 0xf3, 0x7e, 0x7b, 0x80, 0x9f, 0x9e, 0xfe, 0xd1,
+  0xfe, 0xd3, 0x9f, 0x9f, 0x01, 0x3e, 0x01, 0x2d, 0x01, 0x2c, 0xa1, 0xfc,
+  0x67, 0x03, 0x8f, 0x25, 0x93, 0x26, 0xfb, 0xdd, 0x88, 0x05, 0xa8, 0x40,
+  0x3e, 0x7d, 0x7e, 0x95, 0x97, 0xb1, 0xac, 0x97, 0x95, 0x7e, 0x7d, 0x3e,
+  0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x95, 0x97, 0xac, 0xb1, 0x97, 0x95, 0x7e,
+  0x7d, 0x3e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
+  0x06, 0x3d, 0x00, 0x0a, 0x00, 0x24, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35,
+  0x23, 0x11, 0x23, 0x05, 0x15, 0x25, 0x11, 0x02, 0x20, 0x17, 0x16, 0x17,
+  0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26,
+  0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x01, 0xe9, 0x02,
+  0x6b, 0xee, 0x91, 0xfe, 0xff, 0x01, 0x02, 0x6e, 0x01, 0x39, 0x89, 0x87,
+  0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87,
+  0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x01, 0x1d, 0x88, 0x88, 0x04,
+  0x23, 0x3a, 0x93, 0x39, 0xfc, 0x71, 0x05, 0x20, 0x40, 0x3e, 0x7d, 0x7e,
+  0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e,
+  0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00,
+  0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x1c,
+  0x00, 0x36, 0x00, 0x00, 0x01, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x07, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x07, 0x06, 0x00, 0x07, 0x15, 0x21, 0x35, 0x00, 0x20, 0x17,
+  0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x02,
+  0x60, 0xaf, 0xc1, 0x12, 0x42, 0x32, 0xc7, 0xa8, 0x3f, 0x99, 0x57, 0x56,
+  0x99, 0x44, 0x60, 0x78, 0x37, 0x46, 0x25, 0xfe, 0xe3, 0x53, 0x02, 0xaa,
+  0xfe, 0x0d, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
+  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
+  0x87, 0x01, 0x20, 0xc7, 0xde, 0x17, 0x5a, 0x84, 0x49, 0x9b, 0xba, 0x28,
+  0x27, 0xa3, 0x35, 0x35, 0x78, 0x5f, 0x3b, 0x78, 0x58, 0x2e, 0xfe, 0xbf,
+  0x5f, 0x88, 0x88, 0x05, 0x1d, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1,
+  0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01,
+  0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x02, 0x00, 0x08,
+  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x28, 0x00, 0x42, 0x00, 0x00,
+  0x01, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x15, 0x3e,
+  0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12,
+  0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26,
+  0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x9f, 0x5f, 0x66, 0xc1,
+  0xa6, 0x40, 0x91, 0x53, 0x53, 0x89, 0x3b, 0x6e, 0x75, 0x71, 0x6c, 0x83,
+  0x7d, 0x77, 0x85, 0x8f, 0x89, 0x4e, 0x90, 0x3d, 0x4d, 0x8f, 0x44, 0xca,
+  0xda, 0x76, 0xfe, 0x61, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e,
+  0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f,
+  0x71, 0x70, 0x87, 0x03, 0x19, 0x1b, 0x88, 0x64, 0x8e, 0xa7, 0x19, 0x1a,
+  0x90, 0x1e, 0x1d, 0x62, 0x5c, 0x5a, 0x5f, 0x85, 0x77, 0x6a, 0x72, 0x78,
+  0x28, 0x27, 0x9c, 0x1d, 0x1e, 0xc2, 0xb0, 0x74, 0x9c, 0x03, 0x3d, 0x40,
+  0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e,
+  0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e,
+  0x7d, 0x3e, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
+  0x06, 0x3d, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x27, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x09, 0x01, 0x15, 0x21, 0x11, 0x33, 0x11, 0x33, 0x35, 0x23, 0x11,
+  0x24, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06,
+  0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37,
+  0x36, 0x37, 0x03, 0x40, 0xfe, 0x90, 0x01, 0x4a, 0xfe, 0x40, 0x01, 0xe6,
+  0x90, 0x9a, 0x9a, 0xfe, 0x98, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e,
+  0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f,
+  0x6f, 0x71, 0x70, 0x87, 0x04, 0xb3, 0xfd, 0x82, 0x03, 0x0b, 0xfd, 0x0b,
+  0x9c, 0xfe, 0xe6, 0x01, 0x1a, 0x86, 0x03, 0x0b, 0xfd, 0x40, 0x3e, 0x7d,
+  0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40,
+  0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e,
+  0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x1d,
+  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x15, 0x1e, 0x01, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x11, 0x21, 0x35, 0x00, 0x20,
+  0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06,
+  0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37,
+  0x01, 0xe7, 0x3c, 0x74, 0x3b, 0x7c, 0x92, 0x92, 0x7c, 0x4e, 0x89, 0x41,
+  0x4b, 0x8c, 0x43, 0xc5, 0xd8, 0xd2, 0xb4, 0x1f, 0x40, 0x20, 0x01, 0xb6,
+  0xfe, 0x46, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
+  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
+  0x87, 0x05, 0x3d, 0xfd, 0xa8, 0x1e, 0x1d, 0x92, 0x7c, 0x7d, 0x92, 0x27,
+  0x27, 0xa3, 0x19, 0x1a, 0xd6, 0xc1, 0xbb, 0xdb, 0x0c, 0x0c, 0x01, 0x25,
+  0x88, 0x01, 0x00, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe,
+  0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac,
+  0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08,
+  0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x0b, 0x00, 0x24, 0x00, 0x3e,
+  0x00, 0x00, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x36, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x02, 0x11, 0x10, 0x12, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x17, 0x00, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
+  0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35,
+  0x34, 0x12, 0x37, 0x36, 0x37, 0x02, 0xfb, 0x62, 0x73, 0x73, 0x62, 0x61,
+  0x73, 0x73, 0x01, 0x82, 0x3c, 0x70, 0x37, 0xcb, 0xf2, 0xc5, 0xba, 0xa3,
+  0xc4, 0xbc, 0xa2, 0x4d, 0x80, 0x2a, 0x0b, 0x98, 0x90, 0x36, 0x6f, 0x37,
+  0xfe, 0x4c, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f,
+  0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70,
+  0x87, 0x03, 0x2b, 0x95, 0x82, 0x80, 0x96, 0x96, 0x80, 0x82, 0x95, 0x01,
+  0xfa, 0x18, 0x18, 0xfe, 0xaf, 0xfe, 0xe5, 0xfe, 0xd3, 0xfe, 0xc2, 0xde,
+  0xb8, 0xbc, 0xdb, 0x4b, 0x45, 0xda, 0xd8, 0x1e, 0x1d, 0x01, 0xab, 0x40,
+  0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e,
+  0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e,
+  0x7d, 0x3e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
+  0x06, 0x3d, 0x00, 0x06, 0x00, 0x20, 0x00, 0x00, 0x01, 0x15, 0x21, 0x01,
+  0x33, 0x01, 0x35, 0x24, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14,
+  0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35,
+  0x34, 0x12, 0x37, 0x36, 0x37, 0x01, 0xa7, 0x02, 0x05, 0xfe, 0x90, 0x98,
+  0x01, 0x86, 0xfe, 0x0e, 0x01, 0x39, 0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e,
+  0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f,
+  0x71, 0x70, 0x87, 0x05, 0x40, 0x88, 0xfb, 0xdd, 0x04, 0x66, 0x45, 0xfd,
+  0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d,
+  0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c,
+  0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x04, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
+  0x06, 0x3d, 0x00, 0x09, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x45, 0x00, 0x00,
+  0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x27, 0x0e,
+  0x01, 0x15, 0x14, 0x16, 0x20, 0x36, 0x35, 0x34, 0x26, 0x27, 0x3e, 0x01,
+  0x35, 0x34, 0x26, 0x20, 0x06, 0x15, 0x14, 0x16, 0x37, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x12, 0x20, 0x17, 0x16,
+  0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27,
+  0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x03, 0x03,
+  0x69, 0x76, 0x77, 0xcf, 0x77, 0x77, 0x2a, 0x69, 0x77, 0xbf, 0x01, 0x65,
+  0xbe, 0x76, 0x69, 0x5e, 0x68, 0xb7, 0xfe, 0xbf, 0xb7, 0x68, 0x28, 0x69,
+  0x5e, 0x5e, 0x6a, 0x6a, 0x5e, 0x5e, 0x69, 0x2c, 0x01, 0x39, 0x89, 0x87,
+  0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89, 0x87,
+  0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x02, 0xcc, 0x7b, 0x6c, 0x6b,
+  0x7c, 0x7b, 0xd8, 0x7b, 0x45, 0x1b, 0x9e, 0x73, 0xad, 0xba, 0xba, 0xad,
+  0x73, 0x9e, 0x1b, 0x1a, 0x8e, 0x67, 0x8f, 0xa6, 0xa6, 0x8f, 0x67, 0x8e,
+  0xe5, 0x5d, 0x68, 0x68, 0x5d, 0x5c, 0x68, 0x68, 0x02, 0x89, 0x40, 0x3e,
+  0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40,
+  0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d,
+  0x3e, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01,
+  0x06, 0x3d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x3e, 0x00, 0x00, 0x25, 0x1e,
+  0x01, 0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x01,
+  0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x00,
+  0x20, 0x17, 0x16, 0x17, 0x16, 0x12, 0x15, 0x14, 0x02, 0x07, 0x06, 0x07,
+  0x06, 0x20, 0x27, 0x26, 0x27, 0x26, 0x02, 0x35, 0x34, 0x12, 0x37, 0x36,
+  0x37, 0x01, 0xea, 0x3d, 0x70, 0x37, 0xcc, 0xf1, 0xc4, 0xbc, 0xa2, 0xc4,
+  0xbc, 0xa1, 0x4e, 0x80, 0x2a, 0x0b, 0x98, 0x90, 0x36, 0x70, 0x37, 0x01,
+  0x21, 0x61, 0x73, 0x73, 0x61, 0x63, 0x72, 0x72, 0xfe, 0xfa, 0x01, 0x39,
+  0x89, 0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7,
+  0x89, 0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0xae, 0x18, 0x18,
+  0x01, 0x51, 0x01, 0x1a, 0x01, 0x2f, 0x01, 0x3d, 0xde, 0xb8, 0xbc, 0xd9,
+  0x4a, 0x44, 0xdb, 0xd7, 0x1e, 0x1d, 0x01, 0x67, 0x95, 0x82, 0x81, 0x95,
+  0x95, 0x81, 0x82, 0x95, 0x03, 0x95, 0x40, 0x3e, 0x7d, 0x7e, 0xfe, 0xd4,
+  0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40, 0x40, 0x3e, 0x7d, 0x7e,
+  0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d, 0x3e, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x08, 0xff, 0x96, 0x06, 0x01, 0x06, 0x3d, 0x00, 0x0b,
+  0x00, 0x15, 0x00, 0x20, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x3e, 0x01, 0x20, 0x02, 0x11,
+  0x10, 0x12, 0x20, 0x12, 0x11, 0x10, 0x01, 0x15, 0x21, 0x35, 0x23, 0x11,
+  0x23, 0x07, 0x15, 0x37, 0x11, 0x12, 0x20, 0x17, 0x16, 0x17, 0x16, 0x12,
+  0x15, 0x14, 0x02, 0x07, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x27, 0x26,
+  0x02, 0x35, 0x34, 0x12, 0x37, 0x36, 0x37, 0x04, 0x23, 0x5b, 0x5a, 0x5a,
+  0x5b, 0x5a, 0x5a, 0x5a, 0xeb, 0xfe, 0xde, 0x98, 0x98, 0x01, 0x22, 0x99,
+  0xfc, 0x03, 0x01, 0x95, 0x91, 0x74, 0xa1, 0xa2, 0x87, 0x01, 0x39, 0x89,
+  0x87, 0x6f, 0x72, 0x6e, 0x6e, 0x72, 0x6f, 0x87, 0x89, 0xfe, 0xc7, 0x89,
+  0x87, 0x70, 0x71, 0x6f, 0x6f, 0x71, 0x70, 0x87, 0x04, 0xd5, 0xf5, 0xf7,
+  0xf5, 0xf6, 0xf6, 0xf5, 0xf7, 0xf5, 0x80, 0xfe, 0xc3, 0xfe, 0xd1, 0xfe,
+  0xd3, 0xfe, 0xc2, 0x01, 0x3e, 0x01, 0x2d, 0x01, 0x2f, 0xfd, 0x05, 0x88,
+  0x88, 0x04, 0x23, 0x26, 0x93, 0x25, 0xfc, 0x71, 0x05, 0x20, 0x40, 0x3e,
+  0x7d, 0x7e, 0xfe, 0xd4, 0xb1, 0xac, 0xfe, 0xd4, 0x7e, 0x7d, 0x3e, 0x40,
+  0x40, 0x3e, 0x7d, 0x7e, 0x01, 0x2c, 0xac, 0xb1, 0x01, 0x2c, 0x7e, 0x7d,
+  0x3e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0x9a, 0x05, 0xaf,
+  0x04, 0x6a, 0x00, 0x08, 0x00, 0x00, 0x09, 0x01, 0x21, 0x01, 0x21, 0x35,
+  0x21, 0x01, 0x21, 0x05, 0xae, 0xfe, 0x49, 0xfe, 0xe0, 0x01, 0x4b, 0xfc,
+  0x47, 0x03, 0xb9, 0xfe, 0xb5, 0x01, 0x20, 0x02, 0x82, 0xfe, 0x18, 0x01,
+  0x70, 0xf0, 0x01, 0x70, 0x00, 0x01, 0x00, 0xe2, 0x00, 0x70, 0x04, 0xe9,
+  0x04, 0xe9, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01, 0x37, 0x01, 0x1b, 0x01,
+  0x25, 0x03, 0x92, 0xfd, 0x51, 0x98, 0x02, 0x70, 0xbe, 0x3f, 0xfd, 0x93,
+  0x01, 0x8b, 0x02, 0xb4, 0xaa, 0xfd, 0x05, 0x01, 0x34, 0xfd, 0x4e, 0x47,
+  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x05, 0x35, 0x05, 0x03, 0x09, 0x01, 0x04, 0x07, 0xfc,
+  0x62, 0x03, 0x9e, 0x3d, 0x01, 0xe4, 0xfe, 0x1c, 0x02, 0x3c, 0x32, 0xf0,
+  0x32, 0x01, 0x70, 0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x00, 0x01, 0x00, 0xe2,
+  0x00, 0x1b, 0x04, 0xe9, 0x04, 0x94, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01,
+  0x27, 0x01, 0x2d, 0x01, 0x03, 0x03, 0xeb, 0xfd, 0x90, 0x98, 0x02, 0xaf,
+  0xfe, 0xe9, 0x02, 0x6d, 0x3f, 0x03, 0x16, 0xfd, 0x05, 0xaa, 0x02, 0xb4,
+  0xd4, 0x47, 0xfd, 0x4e, 0x00, 0x01, 0x00, 0x69, 0x01, 0x08, 0x05, 0xaf,
+  0x03, 0xfc, 0x00, 0x08, 0x00, 0x00, 0x13, 0x21, 0x03, 0x04, 0x05, 0x04,
+  0x05, 0x13, 0x21, 0x69, 0x02, 0x75, 0x97, 0x01, 0x39, 0x02, 0x2e, 0xfd,
+  0xd2, 0xfe, 0xc7, 0x97, 0xfd, 0x8b, 0x02, 0xbe, 0x01, 0x3e, 0xfc, 0x7e,
+  0x7e, 0xfc, 0x01, 0x3e, 0x00, 0x01, 0x00, 0x69, 0x00, 0x75, 0x05, 0x81,
+  0x04, 0x8f, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x14, 0x06, 0x07, 0x01, 0x06,
+  0x07, 0x06, 0x22, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x3f, 0x01,
+  0x21, 0x22, 0x2e, 0x02, 0x34, 0x3e, 0x02, 0x33, 0x21, 0x27, 0x2e, 0x01,
+  0x35, 0x34, 0x36, 0x37, 0x3e, 0x01, 0x32, 0x17, 0x16, 0x17, 0x01, 0x16,
+  0x05, 0x80, 0x12, 0x0f, 0xfe, 0x98, 0x0e, 0x16, 0x14, 0x2e, 0x28, 0x10,
+  0x10, 0x11, 0x12, 0x0f, 0xa7, 0xfc, 0xda, 0x18, 0x27, 0x21, 0x11, 0x11,
+  0x21, 0x27, 0x18, 0x03, 0x26, 0xa7, 0x0f, 0x12, 0x11, 0x10, 0x10, 0x28,
+  0x2e, 0x14, 0x16, 0x0e, 0x01, 0x68, 0x11, 0x02, 0x9b, 0x32, 0x2e, 0x11,
+  0xfe, 0x70, 0x10, 0x0b, 0x0a, 0x14, 0x11, 0x13, 0x2c, 0x19, 0x1a, 0x2e,
+  0x11, 0xba, 0x14, 0x22, 0x2e, 0x32, 0x2e, 0x22, 0x14, 0xba, 0x11, 0x2e,
+  0x1a, 0x19, 0x2c, 0x13, 0x11, 0x14, 0x0a, 0x0b, 0x10, 0xfe, 0x70, 0x13,
+  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x11, 0x09, 0x01, 0x04, 0x24, 0xfc,
+  0x45, 0x03, 0xbb, 0x01, 0x8a, 0xfe, 0x76, 0x02, 0x5a, 0x50, 0x01, 0x8e,
+  0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x06, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x11, 0x09,
+  0x01, 0x04, 0x24, 0xfc, 0x45, 0x03, 0xbb, 0x01, 0x8a, 0xfe, 0x76, 0x02,
+  0x14, 0xdc, 0x01, 0x48, 0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x04, 0x00, 0x69,
+  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x12, 0x00, 0x00, 0x01, 0x23, 0x11, 0x33, 0x01, 0x23, 0x11, 0x33,
+  0x03, 0x23, 0x11, 0x33, 0x01, 0x21, 0x11, 0x21, 0x35, 0x09, 0x01, 0x02,
+  0x73, 0xd8, 0xd8, 0xfe, 0xe0, 0x6c, 0x6c, 0xb4, 0x36, 0x36, 0x03, 0x85,
+  0xfe, 0x97, 0x01, 0x69, 0x01, 0x8a, 0xfe, 0x76, 0x01, 0xba, 0x01, 0x90,
+  0xfe, 0x70, 0x01, 0x90, 0xfe, 0x70, 0x01, 0x90, 0xfe, 0x70, 0x01, 0x90,
+  0xee, 0xfe, 0x4a, 0xfe, 0x4a, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x69,
+  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x10,
+  0x00, 0x14, 0x00, 0x00, 0x01, 0x35, 0x12, 0x17, 0x06, 0x03, 0x35, 0x21,
+  0x11, 0x03, 0x23, 0x11, 0x33, 0x01, 0x23, 0x11, 0x33, 0x03, 0x23, 0x11,
+  0x33, 0x04, 0x24, 0xa6, 0xe4, 0xe4, 0xa6, 0xfe, 0x97, 0x48, 0xd8, 0xd8,
+  0xfe, 0xe0, 0x6c, 0x6c, 0xb4, 0x36, 0x36, 0x03, 0xae, 0x8a, 0xfe, 0xce,
+  0x84, 0x84, 0xfe, 0xce, 0x8a, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0x58, 0xfd,
+  0xa8, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0x58, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x00, 0x86, 0x05, 0xd7, 0x04, 0x7e, 0x00, 0x06, 0x00, 0x00, 0x09, 0x02,
+  0x11, 0x21, 0x11, 0x21, 0x04, 0x0e, 0x01, 0xc9, 0xfe, 0x37, 0xfc, 0x5b,
+  0x03, 0xa5, 0x04, 0x7e, 0xfe, 0x04, 0xfe, 0x04, 0x01, 0x11, 0x01, 0xd6,
+  0x00, 0x02, 0x00, 0xcd, 0x00, 0xc0, 0x05, 0xaf, 0x04, 0x44, 0x00, 0x02,
+  0x00, 0x06, 0x00, 0x00, 0x01, 0x21, 0x01, 0x13, 0x09, 0x02, 0x02, 0xce,
+  0x01, 0xfe, 0xfd, 0x0f, 0x87, 0xfe, 0x6b, 0x04, 0xe1, 0xfb, 0x1f, 0x02,
+  0x82, 0x01, 0x0f, 0xfe, 0xf1, 0x01, 0xc2, 0xfe, 0x3e, 0xfe, 0x3e, 0x00,
+  0x00, 0x02, 0x00, 0xcd, 0x00, 0xc0, 0x05, 0xaf, 0x04, 0x44, 0x00, 0x02,
+  0x00, 0x06, 0x00, 0x00, 0x01, 0x03, 0x01, 0x21, 0x09, 0x02, 0x02, 0xce,
+  0xf3, 0x02, 0xf1, 0xfd, 0x96, 0xfe, 0x6b, 0x04, 0xe1, 0xfb, 0x1f, 0x02,
+  0x82, 0xfe, 0xf1, 0x01, 0x0f, 0x01, 0xc2, 0xfe, 0x3e, 0xfe, 0x3e, 0x00,
+  0x00, 0x01, 0x00, 0xcd, 0xff, 0xf8, 0x05, 0xaf, 0x05, 0x0c, 0x00, 0x03,
+  0x00, 0x00, 0x09, 0x03, 0x02, 0x08, 0xfe, 0xc5, 0x04, 0xe1, 0xfb, 0x1f,
+  0x02, 0x82, 0x02, 0x8a, 0xfd, 0x76, 0xfd, 0x76, 0x00, 0x01, 0x00, 0x69,
+  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x62, 0x00, 0x14, 0x00, 0x00, 0x13, 0x11,
+  0x14, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x21, 0x35, 0x09, 0x01, 0x35,
+  0x21, 0x20, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x69, 0x21, 0x1f, 0x20, 0x26,
+  0x26, 0x0b, 0x03, 0x04, 0x01, 0x8a, 0xfe, 0x76, 0xfe, 0x79, 0xfe, 0x78,
+  0x26, 0x26, 0x20, 0x1f, 0x21, 0x02, 0x82, 0x01, 0xe0, 0x30, 0x55, 0x25,
+  0x21, 0x13, 0x12, 0xc6, 0xfe, 0x4a, 0xfe, 0x4a, 0xc6, 0x12, 0x13, 0x21,
+  0x25, 0x55, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xa2, 0x05, 0xaf,
+  0x04, 0x38, 0x00, 0x14, 0x00, 0x00, 0x13, 0x34, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x21, 0x35, 0x09, 0x01, 0x35, 0x21, 0x20, 0x07, 0x06, 0x07,
+  0x0e, 0x01, 0x15, 0x69, 0x21, 0x1f, 0x20, 0x26, 0x26, 0x0b, 0x03, 0x04,
+  0x01, 0x8a, 0xfe, 0x76, 0xfe, 0x79, 0xfe, 0x78, 0x26, 0x26, 0x20, 0x1f,
+  0x21, 0x02, 0x82, 0x30, 0x55, 0x25, 0x21, 0x13, 0x12, 0xc6, 0xfe, 0x4a,
+  0xfe, 0x4a, 0xc6, 0x12, 0x13, 0x21, 0x25, 0x55, 0x30, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0xba, 0xff, 0xf1, 0x04, 0x5d, 0x05, 0x13, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x11, 0x09, 0x01, 0x03, 0x08, 0xfe,
+  0xb3, 0x01, 0x4d, 0x01, 0x55, 0xfe, 0xab, 0x01, 0x56, 0x02, 0x58, 0x01,
+  0x65, 0xfd, 0x6f, 0xfd, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x08, 0x00, 0x00, 0x01, 0x35,
+  0x12, 0x05, 0x04, 0x03, 0x35, 0x21, 0x11, 0x03, 0x9d, 0x82, 0x01, 0x8f,
+  0xfe, 0x71, 0x82, 0xfc, 0xcc, 0x03, 0x9a, 0x9e, 0xfe, 0xce, 0x84, 0x84,
+  0xfe, 0xce, 0x9e, 0x02, 0x30, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
+  0x00, 0x9a, 0x05, 0x82, 0x04, 0x6a, 0x00, 0x08, 0x00, 0x0f, 0x00, 0x00,
+  0x25, 0x35, 0x21, 0x11, 0x21, 0x35, 0x33, 0x09, 0x01, 0x03, 0x15, 0x09,
+  0x01, 0x15, 0x21, 0x11, 0x02, 0xe9, 0xfd, 0x80, 0x02, 0x80, 0xe1, 0x01,
+  0xb7, 0xfe, 0x49, 0x99, 0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x80, 0x9a, 0xee,
+  0x01, 0xf4, 0xee, 0xfe, 0x18, 0xfe, 0x18, 0x01, 0x3e, 0xee, 0x01, 0x98,
+  0x01, 0x98, 0xee, 0xfe, 0xac, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
+  0x00, 0x9a, 0x05, 0x82, 0x04, 0x6a, 0x00, 0x08, 0x00, 0x0f, 0x00, 0x00,
+  0x25, 0x35, 0x21, 0x11, 0x21, 0x35, 0x33, 0x09, 0x01, 0x03, 0x15, 0x09,
+  0x01, 0x15, 0x21, 0x11, 0x02, 0xe9, 0xfd, 0x80, 0x02, 0x80, 0xe1, 0x01,
+  0xb7, 0xfe, 0x49, 0x12, 0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x80, 0x9a, 0xee,
+  0x01, 0xf4, 0xee, 0xfe, 0x18, 0xfe, 0x18, 0x01, 0x3e, 0xee, 0x01, 0x98,
+  0x01, 0x98, 0xee, 0xfe, 0xac, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x26,
+  0x00, 0x18, 0x05, 0xb8, 0x04, 0xb0, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00,
+  0x13, 0x01, 0x21, 0x37, 0x33, 0x13, 0x15, 0x01, 0x23, 0x35, 0x37, 0x21,
+  0x01, 0x07, 0x01, 0x03, 0x07, 0x21, 0x03, 0x27, 0x01, 0x03, 0x02, 0xf5,
+  0x7c, 0x5a, 0xc2, 0xfd, 0x6f, 0x87, 0x14, 0xfd, 0x74, 0x03, 0x6f, 0x7c,
+  0x02, 0x43, 0x9a, 0x7d, 0xfd, 0x0c, 0xb1, 0x01, 0xce, 0x01, 0xf4, 0xee,
+  0xfd, 0xfe, 0xc8, 0xfe, 0x32, 0xc8, 0x26, 0x01, 0x18, 0xee, 0x01, 0x98,
+  0x01, 0x98, 0xee, 0xfe, 0xac, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x26,
+  0x00, 0x18, 0x05, 0xb8, 0x04, 0xb0, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00,
+  0x13, 0x35, 0x21, 0x27, 0x35, 0x33, 0x01, 0x15, 0x03, 0x23, 0x27, 0x21,
+  0x01, 0x21, 0x13, 0x21, 0x17, 0x13, 0x01, 0x27, 0x02, 0x8c, 0x14, 0x87,
+  0x02, 0x91, 0xc2, 0x5a, 0x7c, 0xfd, 0x0b, 0x02, 0x6c, 0xfd, 0x0b, 0xb1,
+  0x02, 0xf4, 0x7d, 0x9a, 0xfd, 0xbd, 0x02, 0xfa, 0xc8, 0x26, 0xc8, 0xfe,
+  0x32, 0xc8, 0xfd, 0xfe, 0xee, 0x01, 0xa4, 0xfe, 0xac, 0xee, 0x01, 0x98,
+  0x01, 0x98, 0x00, 0x00, 0x00, 0x02, 0x00, 0xf9, 0x00, 0x00, 0x05, 0x94,
+  0x04, 0x98, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x00, 0x21, 0x27, 0x21, 0x27,
+  0x11, 0x21, 0x35, 0x33, 0x01, 0x17, 0x01, 0x03, 0x15, 0x09, 0x01, 0x15,
+  0x21, 0x11, 0x03, 0x79, 0x47, 0xfe, 0x21, 0x5a, 0x02, 0x26, 0x63, 0x01,
+  0xb7, 0x5a, 0xfe, 0x49, 0x75, 0x01, 0x6f, 0xfe, 0x91, 0xfd, 0xda, 0x9e,
+  0xc8, 0x02, 0x94, 0x9e, 0xfe, 0x18, 0xc8, 0xfe, 0x18, 0x01, 0xb6, 0x9e,
+  0x01, 0x98, 0x01, 0x98, 0x9e, 0xfe, 0x0c, 0x00, 0x00, 0x02, 0x00, 0xf9,
+  0x00, 0x00, 0x05, 0x94, 0x04, 0x98, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x00,
+  0x01, 0x33, 0x01, 0x07, 0x01, 0x23, 0x35, 0x21, 0x11, 0x37, 0x21, 0x13,
+  0x21, 0x11, 0x21, 0x15, 0x09, 0x01, 0x03, 0x79, 0x63, 0x01, 0xb7, 0x5a,
+  0xfe, 0x49, 0x63, 0xfd, 0xda, 0x5a, 0x01, 0xdf, 0x35, 0xfd, 0xda, 0x02,
+  0x26, 0x01, 0x6f, 0xfe, 0x91, 0x04, 0x98, 0xfe, 0x18, 0xc8, 0xfe, 0x18,
+  0x9e, 0x02, 0x94, 0xc8, 0xfe, 0xe8, 0xfe, 0x0c, 0x9e, 0x01, 0x98, 0x01,
+  0x98, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x72, 0x00, 0x64, 0x05, 0xc1,
+  0x04, 0x98, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x00, 0x13, 0x03, 0x21, 0x35,
+  0x33, 0x01, 0x17, 0x01, 0x23, 0x27, 0x35, 0x21, 0x27, 0x13, 0x07, 0x21,
+  0x15, 0x09, 0x01, 0x15, 0x21, 0xf9, 0x87, 0x03, 0x07, 0x63, 0x01, 0xb7,
+  0x2d, 0xfe, 0x49, 0x63, 0x2d, 0xfd, 0x26, 0x2d, 0xda, 0x66, 0x02, 0xdb,
+  0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x25, 0x02, 0xb0, 0x01, 0x4a, 0x9e, 0xfe,
+  0x18, 0x64, 0xfe, 0x18, 0x63, 0x3b, 0x64, 0x01, 0x4a, 0xfa, 0x9e, 0x01,
+  0x98, 0x01, 0x98, 0x9e, 0x00, 0x02, 0x00, 0x72, 0x00, 0x64, 0x05, 0xc1,
+  0x04, 0x98, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x00, 0x13, 0x03, 0x37, 0x21,
+  0x35, 0x37, 0x33, 0x01, 0x07, 0x01, 0x23, 0x35, 0x21, 0x13, 0x07, 0x21,
+  0x15, 0x09, 0x01, 0x15, 0x21, 0xf9, 0x87, 0x2d, 0x02, 0xda, 0x2d, 0x63,
+  0x01, 0xb7, 0x2d, 0xfe, 0x49, 0x63, 0xfc, 0xf9, 0xda, 0x66, 0x02, 0xdb,
+  0x01, 0x6f, 0xfe, 0x91, 0xfd, 0x25, 0x02, 0x4c, 0x01, 0x4a, 0x64, 0x3b,
+  0x63, 0xfe, 0x18, 0x64, 0xfe, 0x18, 0x9e, 0x01, 0x4a, 0xfa, 0x9e, 0x01,
+  0x98, 0x01, 0x98, 0x9e, 0x00, 0x01, 0x01, 0x1c, 0xff, 0xd8, 0x05, 0x31,
+  0x04, 0xaf, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x21, 0x15, 0x09, 0x01,
+  0x15, 0x01, 0x1c, 0x24, 0x3c, 0x51, 0x62, 0x64, 0x71, 0x6d, 0x69, 0x5e,
+  0x55, 0x51, 0x52, 0x4f, 0x54, 0x4e, 0x65, 0x64, 0xdf, 0x68, 0x5f, 0x54,
+  0x39, 0x25, 0x02, 0x1c, 0x01, 0x9c, 0xfe, 0x64, 0x03, 0x6e, 0x47, 0x43,
+  0x5a, 0x2e, 0x2f, 0x2f, 0x2b, 0x5d, 0x59, 0xdd, 0x80, 0x7a, 0xda, 0x5f,
+  0x58, 0x30, 0x2f, 0x2f, 0x2b, 0x5d, 0x3e, 0x49, 0x9e, 0x01, 0xca, 0x01,
+  0xca, 0x9e, 0x00, 0x00, 0x00, 0x09, 0x00, 0x75, 0x01, 0x42, 0x05, 0xaf,
+  0x03, 0xc2, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x1e,
+  0x00, 0x22, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x07,
+  0x33, 0x37, 0x23, 0x07, 0x33, 0x37, 0x23, 0x07, 0x33, 0x37, 0x23, 0x07,
+  0x33, 0x37, 0x23, 0x35, 0x03, 0x21, 0x13, 0x21, 0x11, 0x16, 0x17, 0x06,
+  0x07, 0x11, 0x21, 0x03, 0x21, 0x01, 0x33, 0x27, 0x23, 0x17, 0x33, 0x27,
+  0x23, 0x17, 0x33, 0x27, 0x23, 0x17, 0x33, 0x27, 0x23, 0x02, 0x97, 0x90,
+  0x36, 0x90, 0xa2, 0x90, 0x36, 0x90, 0xa2, 0x90, 0x36, 0x90, 0xa2, 0x90,
+  0x36, 0x90, 0x6c, 0xa8, 0x01, 0xe6, 0xa8, 0x01, 0x60, 0x9c, 0xaf, 0xaf,
+  0x9c, 0xfe, 0xa0, 0xa8, 0xfe, 0x1a, 0x02, 0x22, 0x36, 0x90, 0x36, 0x24,
+  0x36, 0x90, 0x36, 0x24, 0x36, 0x90, 0x36, 0x24, 0x36, 0x90, 0x36, 0x02,
+  0x5a, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0x50, 0x01, 0x18,
+  0xfe, 0xe8, 0x01, 0x16, 0xbc, 0x82, 0x82, 0xbc, 0x01, 0x16, 0xfe, 0xe8,
+  0x01, 0x68, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x94, 0x00, 0x70, 0x04, 0xe9, 0x05, 0x3e, 0x00, 0x0c,
+  0x00, 0x10, 0x00, 0x14, 0x00, 0x00, 0x01, 0x37, 0x06, 0x15, 0x14, 0x17,
+  0x26, 0x23, 0x22, 0x07, 0x37, 0x27, 0x37, 0x09, 0x01, 0x23, 0x01, 0x25,
+  0x11, 0x01, 0x11, 0x04, 0x2b, 0x9e, 0x06, 0x25, 0x7f, 0x94, 0x3b, 0x3f,
+  0x9d, 0xe4, 0x32, 0xfe, 0x4d, 0x01, 0x7f, 0xff, 0xfe, 0x81, 0x01, 0x33,
+  0x01, 0x7e, 0x01, 0x7b, 0xb0, 0x46, 0x43, 0xa3, 0x8f, 0x2a, 0x07, 0xb0,
+  0xfe, 0x39, 0x01, 0x6f, 0xfe, 0x58, 0x01, 0xa8, 0x3a, 0x01, 0x1b, 0xfe,
+  0x57, 0xfe, 0xe6, 0x00, 0x00, 0x03, 0x00, 0x69, 0x01, 0x62, 0x05, 0xaf,
+  0x03, 0xa2, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x00, 0x01, 0x35,
+  0x16, 0x17, 0x06, 0x07, 0x35, 0x21, 0x35, 0x05, 0x21, 0x07, 0x21, 0x13,
+  0x27, 0x21, 0x17, 0x04, 0x7e, 0x8b, 0xa5, 0xa5, 0x8b, 0xfe, 0xbc, 0xfd,
+  0xe3, 0x02, 0x1c, 0xb4, 0xfd, 0xe4, 0xb4, 0xb4, 0x02, 0x1c, 0xb4, 0x02,
+  0xaa, 0xf8, 0xbc, 0x64, 0x64, 0xbc, 0xf8, 0x50, 0x52, 0xc8, 0x01, 0x1a,
+  0xc8, 0xc8, 0x00, 0x00, 0x00, 0x03, 0x00, 0x96, 0xff, 0xc5, 0x04, 0xe9,
+  0x04, 0x94, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x14, 0x00, 0x00, 0x01, 0x27,
+  0x16, 0x33, 0x32, 0x37, 0x06, 0x15, 0x14, 0x17, 0x27, 0x07, 0x27, 0x09,
+  0x01, 0x11, 0x01, 0x03, 0x23, 0x01, 0x21, 0x03, 0xf8, 0x9d, 0x3f, 0x3b,
+  0x94, 0x7f, 0x25, 0x06, 0x9e, 0xe5, 0x32, 0xfe, 0xb5, 0x01, 0x7e, 0xfe,
+  0x82, 0x34, 0xff, 0x01, 0x7e, 0x00, 0xff, 0x03, 0xc1, 0xb0, 0x07, 0x2a,
+  0x90, 0xa2, 0x43, 0x46, 0xb0, 0xff, 0x39, 0xfe, 0x1d, 0x01, 0xa8, 0xfe,
+  0xe5, 0xfe, 0x58, 0x01, 0x55, 0x01, 0xa8, 0x00, 0x00, 0x01, 0x00, 0x96,
+  0x00, 0x70, 0x04, 0xe9, 0x05, 0x3e, 0x00, 0x2a, 0x00, 0x00, 0x25, 0x26,
+  0x23, 0x22, 0x07, 0x3e, 0x01, 0x37, 0x27, 0x26, 0x27, 0x26, 0x22, 0x06,
+  0x07, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x37, 0x26, 0x35, 0x34,
+  0x36, 0x37, 0x01, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x17, 0x01, 0x3e,
+  0x01, 0x37, 0x06, 0x15, 0x14, 0x04, 0xe8, 0x80, 0x95, 0x3b, 0x3e, 0x40,
+  0x74, 0x15, 0x95, 0x96, 0x1f, 0x22, 0x46, 0x44, 0x19, 0xfe, 0x82, 0x21,
+  0x4e, 0x2a, 0x28, 0x2b, 0x13, 0x05, 0x12, 0x21, 0x1e, 0x01, 0x7e, 0x1d,
+  0x16, 0x0c, 0x0e, 0x06, 0x01, 0x24, 0x03, 0x30, 0x41, 0x06, 0x70, 0x2a,
+  0x07, 0x47, 0x36, 0x03, 0xa6, 0xa6, 0x0e, 0x0f, 0x1e, 0x1c, 0x01, 0xa8,
+  0x24, 0x22, 0x12, 0x08, 0x21, 0x30, 0x2c, 0x30, 0x59, 0x22, 0xfe, 0x57,
+  0x21, 0x46, 0x26, 0x27, 0x26, 0x23, 0x07, 0xfe, 0xbb, 0x17, 0x81, 0x47,
+  0x47, 0x43, 0xa3, 0x00, 0x00, 0x01, 0x00, 0x69, 0x01, 0x61, 0x05, 0xaf,
+  0x03, 0xa3, 0x00, 0x27, 0x00, 0x00, 0x01, 0x06, 0x07, 0x34, 0x36, 0x37,
+  0x23, 0x22, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x21, 0x34, 0x36, 0x37,
+  0x36, 0x3f, 0x01, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x21, 0x14, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x33, 0x21, 0x2e, 0x01, 0x35, 0x16, 0x05, 0xae,
+  0xa4, 0x8c, 0x30, 0x0c, 0xd3, 0xd3, 0x1f, 0x21, 0x1a, 0x19, 0x1c, 0xfd,
+  0xe4, 0x22, 0x1e, 0x1c, 0x2a, 0x13, 0x13, 0x2a, 0x1c, 0x1e, 0x22, 0x02,
+  0x1c, 0x1c, 0x19, 0x1a, 0x21, 0x1f, 0x09, 0x01, 0x9d, 0x0c, 0x30, 0x8c,
+  0x02, 0x82, 0x65, 0xbc, 0x65, 0x81, 0x13, 0x0f, 0x10, 0x1c, 0x1b, 0x4a,
+  0x28, 0x30, 0x59, 0x21, 0x1f, 0x15, 0x09, 0x1b, 0x15, 0x1f, 0x22, 0x58,
+  0x30, 0x28, 0x4a, 0x1b, 0x1c, 0x10, 0x0f, 0x13, 0x81, 0x65, 0xbc, 0x00,
+  0x00, 0x01, 0x00, 0x96, 0xff, 0xc6, 0x04, 0xe9, 0x04, 0x94, 0x00, 0x2a,
+  0x00, 0x00, 0x01, 0x06, 0x15, 0x14, 0x17, 0x2e, 0x01, 0x27, 0x07, 0x06,
+  0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x01, 0x2e, 0x01, 0x35, 0x34, 0x3f,
+  0x01, 0x27, 0x06, 0x23, 0x22, 0x26, 0x27, 0x01, 0x1e, 0x01, 0x32, 0x37,
+  0x36, 0x37, 0x01, 0x2e, 0x01, 0x27, 0x16, 0x33, 0x32, 0x04, 0xe8, 0x24,
+  0x06, 0x41, 0x30, 0x03, 0x97, 0x96, 0x0b, 0x0c, 0x1a, 0x19, 0xfe, 0x82,
+  0x1e, 0x21, 0x12, 0x07, 0x1f, 0x2b, 0x28, 0x2b, 0x4f, 0x1f, 0x01, 0x7e,
+  0x19, 0x44, 0x46, 0x22, 0x1f, 0x07, 0x01, 0x24, 0x15, 0x74, 0x40, 0x3e,
+  0x3b, 0x95, 0x04, 0x94, 0x8e, 0xa3, 0x43, 0x47, 0x47, 0x81, 0x17, 0xa8,
+  0xa8, 0x1f, 0x26, 0x27, 0x26, 0x4b, 0x1c, 0xfe, 0x57, 0x22, 0x59, 0x30,
+  0x2c, 0x30, 0x15, 0x04, 0x12, 0x24, 0x22, 0x01, 0xa8, 0x1c, 0x1e, 0x0f,
+  0x0e, 0x07, 0x01, 0x45, 0x03, 0x36, 0x47, 0x07, 0x00, 0x03, 0x00, 0x67,
+  0x00, 0xac, 0x05, 0xaf, 0x04, 0x58, 0x00, 0x14, 0x00, 0x27, 0x00, 0x3c,
+  0x00, 0x00, 0x01, 0x36, 0x25, 0x06, 0x03, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x37, 0x36, 0x24,
+  0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x04, 0x05, 0x04, 0x05,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x26, 0x27, 0x2e, 0x01, 0x35,
+  0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x12, 0x17, 0x24, 0x03, 0xc4, 0xdd, 0x01, 0x0d, 0xcc, 0x6e, 0x0a, 0x13,
+  0x14, 0x19, 0x17, 0x38, 0x17, 0x18, 0x14, 0x13, 0x15, 0x15, 0x13, 0x14,
+  0xfc, 0xbc, 0x1c, 0x19, 0x1a, 0x20, 0x20, 0x49, 0x20, 0x01, 0x3e, 0x03,
+  0x0f, 0xfc, 0xdb, 0xfe, 0xd8, 0x20, 0x49, 0x20, 0x25, 0x15, 0x1b, 0x03,
+  0x42, 0x18, 0x14, 0x13, 0x15, 0x15, 0x13, 0x14, 0x18, 0x17, 0x38, 0x17,
+  0x19, 0x14, 0x10, 0x0d, 0x6c, 0xce, 0xfe, 0xb9, 0x01, 0xce, 0x62, 0x51,
+  0x75, 0xfe, 0xfd, 0x1d, 0x14, 0x15, 0x0c, 0x0b, 0x0b, 0x0c, 0x15, 0x14,
+  0x38, 0x1f, 0x1e, 0x38, 0x14, 0x15, 0x97, 0x52, 0x4b, 0x1a, 0x1c, 0x10,
+  0x0f, 0x0e, 0x85, 0x36, 0x38, 0x83, 0x0e, 0x0f, 0x12, 0x1a, 0x1f, 0x01,
+  0x23, 0x0c, 0x15, 0x14, 0x38, 0x1e, 0x1f, 0x38, 0x14, 0x15, 0x0c, 0x0b,
+  0x0b, 0x0c, 0x15, 0x11, 0x20, 0xfe, 0xfe, 0x76, 0x63, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x87, 0x01, 0x1f, 0x05, 0x9d, 0x03, 0xe5, 0x00, 0x1a,
+  0x00, 0x2a, 0x00, 0x00, 0x13, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x05, 0x04, 0x07, 0x0e, 0x01, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x25, 0x2e, 0x01, 0x35, 0x34,
+  0x36, 0x37, 0x16, 0x17, 0x06, 0x07, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x87,
+  0x3b, 0x1a, 0x1d, 0x12, 0x23, 0x24, 0x26, 0x2a, 0x30, 0x2f, 0x36, 0x2e,
+  0x92, 0x01, 0x69, 0xfe, 0x97, 0x92, 0x33, 0x62, 0x2e, 0x2d, 0x23, 0x34,
+  0x13, 0x1a, 0x15, 0x1a, 0x03, 0x9f, 0x21, 0x21, 0x21, 0x21, 0x59, 0xe2,
+  0xe2, 0x59, 0x21, 0x21, 0x21, 0x02, 0x82, 0x26, 0x3a, 0x3f, 0x13, 0x24,
+  0x12, 0x13, 0x13, 0x16, 0x20, 0x66, 0x4c, 0x4c, 0x66, 0x23, 0x26, 0x13,
+  0x1d, 0x19, 0x23, 0x2f, 0x3a, 0x26, 0x27, 0x58, 0x32, 0x33, 0x58, 0x27,
+  0xf1, 0x72, 0x72, 0xf1, 0x27, 0x58, 0x33, 0x32, 0x58, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x91, 0x01, 0x56, 0x05, 0x94, 0x03, 0xae, 0x00, 0x63,
+  0x00, 0x00, 0x00, 0x14, 0x06, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3f, 0x01, 0x36, 0x35, 0x34, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x06, 0x07, 0x06, 0x0f,
+  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21, 0x22, 0x2e, 0x02, 0x34,
+  0x3f, 0x01, 0x36, 0x34, 0x2f, 0x01, 0x26, 0x34, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x21, 0x32, 0x17, 0x16, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x35,
+  0x34, 0x2f, 0x01, 0x26, 0x35, 0x34, 0x36, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x1f, 0x01, 0x16, 0x05, 0x93, 0x05, 0x05, 0xd8, 0x04, 0x08,
+  0x06, 0x0f, 0x06, 0x06, 0x06, 0x05, 0x06, 0x03, 0x18, 0x03, 0x05, 0x06,
+  0x04, 0x07, 0x08, 0x06, 0xfe, 0x07, 0x06, 0x06, 0x06, 0x04, 0x04, 0x51,
+  0x05, 0x02, 0x06, 0x07, 0x05, 0x07, 0xfd, 0xd9, 0x07, 0x0d, 0x0b, 0x05,
+  0x02, 0x35, 0x35, 0x01, 0x69, 0x02, 0x05, 0x06, 0x05, 0x06, 0x07, 0x07,
+  0x02, 0x27, 0x07, 0x05, 0x08, 0x05, 0x02, 0x05, 0x51, 0x04, 0x04, 0x06,
+  0x06, 0x06, 0x07, 0xfe, 0x06, 0x08, 0x07, 0x04, 0x06, 0x05, 0x03, 0x18,
+  0x03, 0x06, 0x05, 0x06, 0x06, 0x06, 0x0f, 0x06, 0x08, 0x04, 0xd8, 0x05,
+  0x02, 0x8b, 0x12, 0x0e, 0x06, 0xf0, 0x04, 0x05, 0x03, 0x03, 0x04, 0x05,
+  0x06, 0x0e, 0x09, 0x04, 0x0b, 0x63, 0x0b, 0x05, 0x07, 0x0f, 0x06, 0x05,
+  0x03, 0x04, 0x03, 0x04, 0x05, 0x05, 0x08, 0xb4, 0x0a, 0x03, 0x05, 0x04,
+  0x03, 0x06, 0x0c, 0x0e, 0x12, 0x06, 0x75, 0x75, 0x14, 0x02, 0xe8, 0x06,
+  0x12, 0x0e, 0x06, 0x05, 0x04, 0x03, 0x03, 0x03, 0x06, 0x03, 0x0a, 0xb4,
+  0x08, 0x05, 0x05, 0x04, 0x03, 0x04, 0x03, 0x05, 0x06, 0x0f, 0x07, 0x05,
+  0x0b, 0x63, 0x0b, 0x04, 0x09, 0x0e, 0x06, 0x05, 0x04, 0x03, 0x03, 0x05,
+  0x04, 0xf0, 0x06, 0x00, 0x00, 0x01, 0x00, 0x91, 0x00, 0xf1, 0x05, 0x94,
+  0x04, 0x13, 0x00, 0x63, 0x00, 0x00, 0x00, 0x14, 0x06, 0x07, 0x01, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x35, 0x34, 0x3f, 0x01,
+  0x36, 0x35, 0x34, 0x26, 0x27, 0x26, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07,
+  0x06, 0x07, 0x06, 0x0f, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21,
+  0x22, 0x2e, 0x02, 0x34, 0x3f, 0x01, 0x36, 0x34, 0x27, 0x03, 0x26, 0x34,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x21, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x13, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x32, 0x37, 0x36,
+  0x37, 0x3e, 0x01, 0x35, 0x34, 0x2f, 0x01, 0x26, 0x35, 0x34, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x01, 0x16, 0x05, 0x93, 0x05,
+  0x05, 0xfe, 0x98, 0x05, 0x07, 0x06, 0x0f, 0x06, 0x06, 0x06, 0x05, 0x06,
+  0x03, 0x4e, 0x03, 0x05, 0x06, 0x04, 0x07, 0x08, 0x06, 0x53, 0x07, 0x06,
+  0x07, 0x05, 0x04, 0x04, 0x6c, 0x05, 0x02, 0x06, 0x07, 0x05, 0x07, 0xfd,
+  0xac, 0x07, 0x0d, 0x0b, 0x05, 0x03, 0x42, 0x42, 0x01, 0x8d, 0x02, 0x05,
+  0x06, 0x05, 0x06, 0x07, 0x07, 0x02, 0x54, 0x07, 0x05, 0x08, 0x05, 0x03,
+  0x04, 0x75, 0x04, 0x04, 0x05, 0x07, 0x06, 0x07, 0x53, 0x06, 0x08, 0x07,
+  0x04, 0x06, 0x05, 0x03, 0x4e, 0x03, 0x06, 0x05, 0x06, 0x06, 0x06, 0x0f,
+  0x06, 0x07, 0x05, 0x01, 0x68, 0x05, 0x02, 0x8b, 0x12, 0x0f, 0x05, 0xfe,
+  0x98, 0x05, 0x04, 0x03, 0x03, 0x04, 0x05, 0x06, 0x0e, 0x09, 0x07, 0x08,
+  0xdb, 0x08, 0x08, 0x07, 0x0f, 0x06, 0x05, 0x03, 0x04, 0x03, 0x04, 0x05,
+  0x05, 0x08, 0xf0, 0x0a, 0x03, 0x05, 0x04, 0x03, 0x06, 0x0c, 0x0e, 0x12,
+  0x06, 0x93, 0x93, 0x14, 0x02, 0x01, 0x38, 0x06, 0x12, 0x0e, 0x06, 0x05,
+  0x04, 0x03, 0x03, 0x03, 0x06, 0x03, 0x0a, 0xfe, 0xfc, 0x08, 0x05, 0x05,
+  0x04, 0x03, 0x04, 0x03, 0x05, 0x06, 0x0f, 0x07, 0x08, 0x08, 0xdb, 0x08,
+  0x07, 0x09, 0x0e, 0x06, 0x05, 0x04, 0x03, 0x03, 0x04, 0x05, 0xfe, 0x98,
+  0x05, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x69, 0x00, 0xa6, 0x05, 0xaf,
+  0x04, 0x5e, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x27, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x07, 0x23, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26,
+  0x2f, 0x01, 0x33, 0x16, 0x17, 0x16, 0x01, 0x23, 0x3e, 0x01, 0x37, 0x21,
+  0x35, 0x21, 0x0e, 0x01, 0x03, 0x1e, 0x01, 0x17, 0x21, 0x35, 0x21, 0x2e,
+  0x01, 0x27, 0x05, 0xae, 0x7a, 0x4b, 0x7e, 0x42, 0x61, 0x29, 0x29, 0x90,
+  0x22, 0x40, 0x40, 0x22, 0x90, 0x12, 0x40, 0x61, 0x41, 0x7f, 0x4b, 0xfe,
+  0x04, 0x5e, 0x11, 0x31, 0x26, 0xfd, 0x27, 0x03, 0x82, 0x63, 0x44, 0x0c,
+  0x0c, 0x44, 0x63, 0xfc, 0x7e, 0x02, 0xd9, 0x26, 0x31, 0x11, 0x02, 0x82,
+  0x4f, 0x55, 0x8f, 0xa9, 0x6e, 0x6d, 0xa4, 0x27, 0x36, 0x36, 0x27, 0xa4,
+  0x31, 0xaa, 0xa4, 0x94, 0x55, 0xfd, 0xd5, 0x3d, 0x85, 0x48, 0x64, 0x8e,
+  0xb7, 0x03, 0x8f, 0x29, 0xb7, 0x8e, 0x64, 0x48, 0x85, 0x3d, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x63, 0xfe, 0xb2, 0x02, 0x88, 0x06, 0x26, 0x00, 0x19,
+  0x00, 0x00, 0x01, 0x2a, 0x01, 0x27, 0x24, 0x03, 0x26, 0x00, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x27, 0x36, 0x37, 0x36, 0x15, 0x14, 0x00, 0x07, 0x06,
+  0x05, 0x16, 0x36, 0x37, 0x02, 0x88, 0x08, 0x5e, 0x31, 0xfe, 0x74, 0x02,
+  0x01, 0x01, 0x49, 0x04, 0x03, 0x54, 0x34, 0x29, 0x7a, 0x2d, 0xc0, 0xc8,
+  0xfe, 0xd2, 0x07, 0x0b, 0x01, 0x00, 0x4a, 0x3e, 0x12, 0xfe, 0xb2, 0x0b,
+  0x53, 0x01, 0x52, 0xae, 0x03, 0xf5, 0x51, 0x4f, 0x89, 0x31, 0xd8, 0x01,
+  0x01, 0xcc, 0xa1, 0xfc, 0x4c, 0x8f, 0xdc, 0x48, 0x15, 0x01, 0x02, 0x00,
+  0x00, 0x01, 0x00, 0x47, 0xfe, 0xb2, 0x02, 0x6d, 0x06, 0x26, 0x00, 0x19,
+  0x00, 0x00, 0x13, 0x35, 0x1e, 0x01, 0x37, 0x24, 0x27, 0x26, 0x00, 0x35,
+  0x34, 0x17, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x06, 0x00, 0x07,
+  0x02, 0x05, 0x06, 0x22, 0x47, 0x12, 0x3e, 0x4a, 0x01, 0x00, 0x0b, 0x06,
+  0xfe, 0xd1, 0xc8, 0xc0, 0x2d, 0x7a, 0x28, 0x35, 0x54, 0x03, 0x04, 0x01,
+  0x49, 0x01, 0x02, 0xfe, 0x74, 0x31, 0x5e, 0xfe, 0xb2, 0x8f, 0x02, 0x01,
+  0x15, 0x48, 0xdc, 0x8f, 0x03, 0xb4, 0xa1, 0xcc, 0x01, 0x01, 0xd8, 0x31,
+  0x89, 0x4f, 0x51, 0xfc, 0x0b, 0xae, 0xfe, 0xae, 0x53, 0x0b, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x05, 0xfe, 0x23, 0x03, 0x8a, 0x06, 0x75, 0x00, 0x03,
+  0x00, 0x06, 0x00, 0x09, 0x00, 0x00, 0x09, 0x05, 0x21, 0x09, 0x01, 0x21,
+  0x01, 0xc6, 0x01, 0xc3, 0xfe, 0x3d, 0xfe, 0x3f, 0x01, 0xc1, 0xfe, 0xbc,
+  0x02, 0x8a, 0xfe, 0xba, 0x01, 0x46, 0xfd, 0x76, 0x06, 0x75, 0xfb, 0xdb,
+  0xfb, 0xd3, 0x04, 0x2d, 0x03, 0x31, 0xfd, 0x08, 0xfc, 0x8e, 0x03, 0x00,
+  0x00, 0x02, 0x00, 0x9e, 0xfe, 0xf2, 0x02, 0xdf, 0x06, 0x14, 0x00, 0x03,
+  0x00, 0x0b, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x25, 0x21, 0x15, 0x23,
+  0x11, 0x33, 0x15, 0x21, 0xf8, 0xb4, 0xfe, 0xf2, 0x02, 0x40, 0xd8, 0xd8,
+  0xfd, 0xc0, 0x05, 0xb0, 0xf9, 0xa6, 0x06, 0x5a, 0x64, 0x64, 0xf9, 0xa6,
+  0x64, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x9d, 0xfe, 0xf2, 0x02, 0xde,
+  0x06, 0x14, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x23, 0x11, 0x33,
+  0x13, 0x11, 0x21, 0x35, 0x33, 0x11, 0x23, 0x35, 0x02, 0x84, 0xb4, 0xb4,
+  0x5a, 0xfd, 0xc0, 0xd8, 0xd8, 0x05, 0xb0, 0xf9, 0xa6, 0x06, 0xbe, 0xf8,
+  0xde, 0x64, 0x06, 0x5a, 0x64, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa4,
+  0xfe, 0xf2, 0x02, 0x3c, 0x06, 0x12, 0x00, 0x05, 0x00, 0x00, 0x1b, 0x01,
+  0x33, 0x03, 0x13, 0x23, 0xa5, 0xfd, 0x9a, 0xfe, 0xfe, 0x9a, 0x02, 0x82,
+  0x03, 0x90, 0xfc, 0x70, 0xfc, 0x70, 0x00, 0x00, 0x00, 0x01, 0x00, 0x93,
+  0xfe, 0xf2, 0x02, 0x2b, 0x06, 0x12, 0x00, 0x05, 0x00, 0x00, 0x01, 0x03,
+  0x23, 0x13, 0x03, 0x33, 0x02, 0x2a, 0xfd, 0x99, 0xfd, 0xfd, 0x99, 0x02,
+  0x82, 0xfc, 0x70, 0x03, 0x90, 0x03, 0x90, 0x00, 0xff, 0xff, 0x00, 0xa4,
+  0xfe, 0xf2, 0x03, 0x6e, 0x06, 0x12, 0x10, 0x26, 0x0c, 0x97, 0x00, 0x00,
+  0x10, 0x07, 0x0c, 0x97, 0x01, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0x93,
+  0xfe, 0xf2, 0x03, 0x5d, 0x06, 0x12, 0x10, 0x26, 0x0c, 0x98, 0x00, 0x00,
+  0x10, 0x07, 0x0c, 0x98, 0x01, 0x32, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51,
+  0x00, 0x00, 0x05, 0xb9, 0x05, 0xdc, 0x00, 0x16, 0x00, 0x00, 0x09, 0x01,
+  0x07, 0x27, 0x11, 0x23, 0x11, 0x27, 0x11, 0x23, 0x11, 0x27, 0x07, 0x11,
+  0x23, 0x11, 0x07, 0x11, 0x23, 0x11, 0x07, 0x27, 0x01, 0x03, 0x2e, 0x02,
+  0x8a, 0x6c, 0x52, 0x6c, 0xbe, 0x6c, 0x5f, 0x5f, 0x6c, 0xbd, 0x6c, 0x53,
+  0x6c, 0x02, 0x8a, 0x05, 0xdc, 0xfd, 0x2c, 0x78, 0x5c, 0xfd, 0x14, 0x03,
+  0x65, 0xd3, 0xfb, 0xc8, 0x04, 0xb0, 0x68, 0x68, 0xfb, 0x50, 0x04, 0x38,
+  0xd3, 0xfc, 0x9b, 0x02, 0xec, 0x5c, 0x78, 0x02, 0xd4, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x50, 0xff, 0xf9, 0x05, 0xb7, 0x05, 0xd5, 0x00, 0x16,
+  0x00, 0x00, 0x05, 0x01, 0x37, 0x17, 0x11, 0x33, 0x11, 0x17, 0x11, 0x33,
+  0x11, 0x17, 0x37, 0x11, 0x33, 0x11, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17,
+  0x01, 0x02, 0xda, 0xfd, 0x76, 0x6c, 0x53, 0x6c, 0xbd, 0x6c, 0x5f, 0x60,
+  0x6c, 0xbd, 0x6c, 0x52, 0x6c, 0xfd, 0x77, 0x07, 0x02, 0xd4, 0x78, 0x5c,
+  0x02, 0xec, 0xfc, 0x9b, 0xd3, 0x04, 0x38, 0xfb, 0x50, 0x68, 0x68, 0x04,
+  0xb0, 0xfb, 0xc8, 0xd3, 0x03, 0x65, 0xfd, 0x14, 0x5c, 0x78, 0xfd, 0x2c,
+  0x00, 0x01, 0x00, 0x47, 0x00, 0x6c, 0x05, 0xde, 0x05, 0x44, 0x00, 0x3d,
+  0x00, 0x00, 0x01, 0x30, 0x37, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x22, 0x07,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x37, 0x17, 0x01, 0x23, 0x01, 0x37,
+  0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x02, 0x28, 0x6b, 0x39, 0x4a, 0x46, 0xab, 0x43,
+  0x4d, 0x36, 0x3c, 0x3b, 0x1e, 0x1f, 0x3a, 0x39, 0x4a, 0x46, 0xab, 0x43,
+  0x4d, 0x36, 0x3c, 0x1d, 0x15, 0x06, 0xd1, 0x6c, 0xfe, 0x9f, 0x51, 0xfe,
+  0x9d, 0x6c, 0xd2, 0x07, 0x20, 0x2c, 0x50, 0x4b, 0x69, 0x5c, 0x78, 0x73,
+  0x61, 0x66, 0x4e, 0x52, 0x2a, 0x29, 0x29, 0x2a, 0x52, 0x4a, 0x6a, 0x5c,
+  0x78, 0x73, 0x61, 0x60, 0x01, 0x21, 0x78, 0x3f, 0x23, 0x21, 0x21, 0x27,
+  0x3b, 0x42, 0xa2, 0x5d, 0x59, 0x51, 0x53, 0x40, 0x3f, 0x23, 0x21, 0x21,
+  0x27, 0x3b, 0x42, 0x51, 0x39, 0x3f, 0xea, 0x78, 0xfe, 0x76, 0x01, 0x8a,
+  0x78, 0xe9, 0x60, 0x58, 0x71, 0x59, 0x53, 0x34, 0x2e, 0x2e, 0x30, 0x57,
+  0x59, 0x71, 0x70, 0x7b, 0x7f, 0x70, 0x71, 0x59, 0x53, 0x34, 0x2e, 0x2e,
+  0x2d, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x47, 0x00, 0x7c, 0x05, 0xde,
+  0x05, 0x54, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x37,
+  0x17, 0x01, 0x23, 0x01, 0x37, 0x17, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x15, 0x14, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x32, 0x37, 0x36, 0x37, 0x03, 0xfd, 0x55, 0x5f, 0x62,
+  0x73, 0x78, 0x5c, 0x69, 0x4b, 0x50, 0x2c, 0x29, 0x29, 0x2c, 0x50, 0x4f,
+  0x65, 0x61, 0x73, 0x78, 0x5d, 0x68, 0x4c, 0x50, 0x2b, 0x20, 0x08, 0xd1,
+  0x6c, 0xfe, 0x9e, 0x51, 0xfe, 0x9f, 0x6c, 0xd1, 0x07, 0x14, 0x1e, 0x3b,
+  0x36, 0x4e, 0x42, 0xac, 0x46, 0x4a, 0x39, 0x3a, 0x1f, 0x1e, 0x3c, 0x3b,
+  0x36, 0x4d, 0x43, 0xab, 0x46, 0x4a, 0x3a, 0x01, 0x31, 0x5a, 0x2d, 0x2e,
+  0x2e, 0x34, 0x53, 0x59, 0x71, 0x70, 0x7f, 0x7b, 0x70, 0x71, 0x59, 0x57,
+  0x30, 0x2e, 0x2e, 0x34, 0x53, 0x59, 0x71, 0x58, 0x60, 0xe9, 0x78, 0xfe,
+  0x76, 0x01, 0x8a, 0x78, 0xea, 0x3f, 0x39, 0x51, 0x42, 0x3b, 0x27, 0x21,
+  0x21, 0x23, 0x3f, 0x40, 0x53, 0x51, 0x59, 0x5d, 0xa2, 0x42, 0x3b, 0x27,
+  0x21, 0x21, 0x23, 0x3f, 0x00, 0x03, 0x00, 0x69, 0xff, 0xe3, 0x07, 0xfb,
+  0x05, 0x24, 0x00, 0x25, 0x00, 0x39, 0x00, 0x4d, 0x00, 0x00, 0x01, 0x15,
+  0x01, 0x27, 0x37, 0x21, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36, 0x37,
+  0x3e, 0x01, 0x32, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x21, 0x27, 0x37,
+  0x24, 0x22, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x11, 0x33,
+  0x11, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x23,
+  0x11, 0x21, 0x16, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x32, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x07, 0xfb, 0xfe, 0x9e, 0x6c, 0xd2, 0xfe, 0xc3,
+  0x0a, 0x1d, 0x2d, 0x59, 0x58, 0xd6, 0xf8, 0xd7, 0x58, 0x59, 0x2c, 0x1e,
+  0x0a, 0xaa, 0xaa, 0x09, 0x1f, 0x2c, 0x59, 0x58, 0xd7, 0xf8, 0xd6, 0x58,
+  0x59, 0x2d, 0x1e, 0x09, 0x01, 0x3d, 0xd2, 0x6c, 0xfd, 0x32, 0xc1, 0x53,
+  0x53, 0x44, 0x46, 0x22, 0x15, 0x08, 0x01, 0x83, 0x99, 0x01, 0x83, 0x08,
+  0x14, 0x23, 0x45, 0x44, 0x53, 0x01, 0x1b, 0xfe, 0x7d, 0x99, 0xfe, 0x7d,
+  0x09, 0x14, 0x22, 0x46, 0x44, 0x53, 0x53, 0xc1, 0x54, 0x53, 0x44, 0x45,
+  0x23, 0x13, 0x02, 0xaf, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x5a, 0x51, 0x76,
+  0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x76, 0x51, 0x5a, 0xaa, 0x5b, 0x52,
+  0x77, 0x63, 0x62, 0x64, 0x64, 0x62, 0x63, 0x77, 0x52, 0x5b, 0xe9, 0x78,
+  0x56, 0x27, 0x27, 0x4c, 0x4d, 0x5c, 0x37, 0x3d, 0x01, 0x65, 0xfe, 0x9b,
+  0x3d, 0x37, 0x5c, 0x4d, 0x4c, 0x27, 0xfd, 0xc6, 0xfe, 0x9b, 0x01, 0x65,
+  0x3b, 0x36, 0x5c, 0x4d, 0x4c, 0x27, 0x27, 0x27, 0x27, 0x4c, 0x4d, 0x5c,
+  0x36, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea,
+  0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21,
+  0x15, 0x21, 0x17, 0x07, 0x5a, 0x01, 0x62, 0x6c, 0xd2, 0x08, 0x93, 0xf7,
+  0x6d, 0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0xaa, 0xe9,
+  0x78, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9,
+  0x04, 0x38, 0x00, 0x09, 0x00, 0x00, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21,
+  0x35, 0x21, 0x27, 0x37, 0x09, 0xf8, 0xfe, 0x9f, 0x6c, 0xd1, 0xf7, 0x6d,
+  0x08, 0x93, 0xd1, 0x6c, 0x02, 0xaf, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xaa,
+  0xe9, 0x78, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xf9,
+  0x04, 0x38, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x35, 0x01, 0x17, 0x07, 0x21,
+  0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x17, 0x07, 0x5a, 0x01,
+  0x62, 0x6c, 0xd2, 0x07, 0xa6, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
+  0xd1, 0xf8, 0x5a, 0xd2, 0x6c, 0x02, 0x55, 0x5a, 0x01, 0x89, 0x78, 0xe9,
+  0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0xe9, 0x78, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea, 0x04, 0x38, 0x00, 0x0e,
+  0x00, 0x00, 0x01, 0x21, 0x15, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17,
+  0x07, 0x21, 0x15, 0x21, 0x07, 0x01, 0x68, 0x08, 0x81, 0xf7, 0xeb, 0x54,
+  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x08, 0x15, 0xf7, 0x7f, 0x5e,
+  0x02, 0x19, 0x78, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d,
+  0x78, 0x69, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9,
+  0x04, 0x38, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x37, 0x27, 0x21, 0x35, 0x21,
+  0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x35, 0x08, 0xea, 0x5f,
+  0x5f, 0xf7, 0x7f, 0x08, 0x15, 0x53, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c,
+  0x53, 0xf7, 0xeb, 0x02, 0x19, 0x69, 0x69, 0x78, 0x5d, 0x78, 0xfe, 0x77,
+  0x5a, 0xfe, 0x77, 0x78, 0x5d, 0x78, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
+  0x00, 0xcc, 0x09, 0xf9, 0x04, 0x38, 0x00, 0x05, 0x00, 0x15, 0x00, 0x00,
+  0x01, 0x21, 0x37, 0x27, 0x21, 0x07, 0x05, 0x21, 0x17, 0x07, 0x01, 0x35,
+  0x01, 0x17, 0x07, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x01, 0x68,
+  0x07, 0x82, 0x5f, 0x5f, 0xf8, 0x7e, 0x5e, 0x07, 0x74, 0xf9, 0x56, 0x54,
+  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x06, 0xaa, 0x53, 0x6c, 0x01,
+  0x61, 0xfe, 0x9f, 0x6c, 0x02, 0x19, 0x69, 0x69, 0x69, 0xe1, 0x5d, 0x78,
+  0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d, 0x5d, 0x78, 0xfe, 0x77, 0x5a,
+  0xfe, 0x77, 0x78, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea,
+  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x17, 0x07, 0x01, 0x35,
+  0x01, 0x17, 0x07, 0x21, 0x11, 0x33, 0x11, 0x23, 0x09, 0x50, 0xf8, 0x06,
+  0xd2, 0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0xd2, 0x07, 0xfa, 0x99, 0x99,
+  0x02, 0x2d, 0xe9, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0xe9, 0x01,
+  0x59, 0xfc, 0xa4, 0x00, 0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9,
+  0x04, 0x38, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11,
+  0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x01, 0x02, 0x99, 0x99,
+  0x07, 0xfa, 0xd1, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0xd1, 0x02, 0x2d,
+  0xfe, 0xa7, 0x03, 0x5c, 0xfe, 0xa7, 0xe9, 0x78, 0xfe, 0x77, 0x5a, 0xfe,
+  0x77, 0x78, 0xe9, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0xcc, 0x09, 0xea,
+  0x04, 0x38, 0x00, 0x0d, 0x00, 0x12, 0x00, 0x00, 0x01, 0x21, 0x17, 0x07,
+  0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x35, 0x33, 0x11, 0x23, 0x11, 0x35,
+  0x21, 0x07, 0x17, 0x09, 0x50, 0xf8, 0x84, 0x54, 0x6c, 0xfe, 0x9e, 0x01,
+  0x62, 0x6c, 0x54, 0x07, 0x7c, 0x99, 0x99, 0xf8, 0x18, 0x5e, 0x5e, 0x01,
+  0xa1, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89, 0x78, 0x5d, 0xcd, 0xfc,
+  0xa4, 0x01, 0x45, 0xd2, 0x69, 0x69, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
+  0x00, 0xcc, 0x09, 0xf9, 0x04, 0x38, 0x00, 0x0d, 0x00, 0x12, 0x00, 0x00,
+  0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27, 0x37, 0x21, 0x15, 0x23,
+  0x11, 0x33, 0x11, 0x15, 0x21, 0x37, 0x27, 0x01, 0x02, 0x07, 0x7c, 0x53,
+  0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0x53, 0xf8, 0x84, 0x99, 0x99, 0x07,
+  0xe8, 0x5f, 0x5f, 0x03, 0x63, 0x5d, 0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77,
+  0x78, 0x5d, 0xcd, 0x03, 0x5c, 0xfe, 0xbb, 0xd2, 0x69, 0x69, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0x00, 0xcc, 0x09, 0xf9, 0x04, 0x38, 0x00, 0x25,
+  0x00, 0x00, 0x13, 0x17, 0x37, 0x17, 0x37, 0x17, 0x37, 0x17, 0x37, 0x17,
+  0x37, 0x17, 0x37, 0x17, 0x37, 0x33, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27,
+  0x37, 0x23, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27, 0x07, 0x27,
+  0x07, 0x27, 0x07, 0x27, 0x69, 0x3f, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2,
+  0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x3f, 0x7d, 0xd1, 0x6c, 0x01, 0x61,
+  0xfe, 0x9f, 0x6c, 0xd1, 0x59, 0x63, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2,
+  0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0xa2, 0x3f, 0x02, 0xd7, 0x46, 0xb4, 0xb4,
+  0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0xe9,
+  0x78, 0xfe, 0x77, 0x5a, 0xfe, 0x77, 0x78, 0xe9, 0x6e, 0xb4, 0xb4, 0xb4,
+  0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0xb4, 0x46, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x05, 0x14, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x02, 0xdd, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x02, 0x1c,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x02, 0x1c, 0x01, 0xd3, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x02, 0x1c,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x03, 0x2a, 0x05, 0x14, 0x04, 0x38, 0x06, 0x40, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x05, 0x14, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0x02, 0xdd, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
+  0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x02, 0xdd, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0x00, 0xa7, 0x04, 0x38,
+  0x01, 0xd3, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0x00, 0xa7, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x03, 0x2a, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0x00, 0xa7, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c, 0xff, 0x9c, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x02, 0x1c,
+  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x02, 0x1c, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x02, 0x1c, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
+  0xfe, 0x70, 0x04, 0x38, 0xff, 0x9c, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38,
+  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x03, 0x2a, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0xff, 0x9c, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x01, 0xd3, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x01, 0xd3, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x04, 0x09, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x04, 0x09, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e,
+  0xfe, 0x70, 0x04, 0x38, 0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x00, 0xa7, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07, 0x11, 0x33, 0x03, 0x2a,
+  0xfe, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x0e, 0xfe, 0x70, 0x04, 0x38,
+  0x06, 0x40, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x01, 0x0e, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a, 0x05, 0x14, 0x10, 0x27,
+  0x11, 0x33, 0x03, 0x2a, 0x02, 0xdd, 0x10, 0x27, 0x11, 0x33, 0x03, 0x2a,
+  0x00, 0xa7, 0x10, 0x27, 0x11, 0x33, 0x01, 0x0e, 0xfe, 0x70, 0x10, 0x07,
+  0x11, 0x33, 0x03, 0x2a, 0xfe, 0x70, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
+  0x00, 0xcc, 0x05, 0xa0, 0x04, 0x38, 0x00, 0x0d, 0x00, 0x12, 0x00, 0x00,
+  0x01, 0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x35, 0x33,
+  0x11, 0x23, 0x11, 0x35, 0x21, 0x07, 0x17, 0x05, 0x06, 0xfc, 0xce, 0x54,
+  0x6c, 0xfe, 0x9e, 0x01, 0x62, 0x6c, 0x54, 0x03, 0x32, 0x99, 0x99, 0xfc,
+  0x62, 0x5e, 0x5e, 0x01, 0xa1, 0x5d, 0x78, 0x01, 0x89, 0x5a, 0x01, 0x89,
+  0x78, 0x5d, 0xcd, 0xfc, 0xa4, 0x01, 0x45, 0xd2, 0x69, 0x69, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x69, 0x00, 0xcc, 0x05, 0xaf, 0x04, 0x38, 0x00, 0x0d,
+  0x00, 0x12, 0x00, 0x00, 0x01, 0x21, 0x27, 0x37, 0x01, 0x15, 0x01, 0x27,
+  0x37, 0x21, 0x15, 0x23, 0x11, 0x33, 0x11, 0x15, 0x21, 0x37, 0x27, 0x01,
+  0x02, 0x03, 0x32, 0x53, 0x6c, 0x01, 0x61, 0xfe, 0x9f, 0x6c, 0x53, 0xfc,
+  0xce, 0x99, 0x99, 0x03, 0x9e, 0x5f, 0x5f, 0x03, 0x63, 0x5d, 0x78, 0xfe,
+  0x77, 0x5a, 0xfe, 0x77, 0x78, 0x5d, 0xcd, 0x03, 0x5c, 0xfe, 0xbb, 0xd2,
+  0x69, 0x69, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe6, 0x00, 0x00, 0x05, 0x22,
+  0x05, 0xdc, 0x00, 0x11, 0x00, 0x00, 0x13, 0x01, 0x33, 0x01, 0x07, 0x27,
+  0x11, 0x23, 0x11, 0x27, 0x11, 0x23, 0x11, 0x07, 0x11, 0x23, 0x11, 0x07,
+  0xe6, 0x01, 0xf6, 0x51, 0x01, 0xf5, 0x6c, 0x53, 0x6c, 0xbd, 0x6c, 0xbd,
+  0x6c, 0x53, 0x03, 0xae, 0x02, 0x2e, 0xfd, 0xd2, 0x78, 0x5c, 0xfc, 0x6e,
+  0x04, 0x0a, 0xd3, 0xfb, 0x23, 0x04, 0xdd, 0xd3, 0xfb, 0xf6, 0x03, 0x92,
+  0x5c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe6, 0xff, 0xf9, 0x05, 0x22,
+  0x05, 0xd5, 0x00, 0x11, 0x00, 0x00, 0x13, 0x37, 0x17, 0x11, 0x33, 0x11,
+  0x17, 0x11, 0x33, 0x11, 0x37, 0x11, 0x33, 0x11, 0x37, 0x17, 0x01, 0x23,
+  0xe6, 0x6c, 0x53, 0x6c, 0xbd, 0x6c, 0xbd, 0x6c, 0x53, 0x6c, 0xfe, 0x0b,
+  0x51, 0x02, 0x27, 0x78, 0x5c, 0x03, 0x92, 0xfb, 0xf6, 0xd3, 0x04, 0xdd,
+  0xfb, 0x23, 0xd3, 0x04, 0x0a, 0xfc, 0x6e, 0x5c, 0x78, 0xfd, 0xd2, 0x00,
+  0x00, 0x02, 0x00, 0x47, 0x00, 0x80, 0x04, 0xa4, 0x06, 0xb5, 0x00, 0x1e,
+  0x00, 0x3d, 0x00, 0x00, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x10, 0x37, 0x36, 0x37, 0x36, 0x37, 0x01, 0x17, 0x07, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x10, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x03,
+  0x30, 0x17, 0x07, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x02, 0x77, 0x72, 0x65, 0x60, 0x56,
+  0x4d, 0x2d, 0x29, 0x29, 0x2d, 0x4d, 0x58, 0x67, 0x01, 0x61, 0x6c, 0xd1,
+  0x56, 0x4f, 0x61, 0x55, 0x4e, 0x2c, 0x29, 0x29, 0x2c, 0x4e, 0x55, 0x61,
+  0x64, 0x42, 0xd2, 0x6c, 0xfe, 0xda, 0x50, 0x3e, 0x39, 0x1f, 0x1e, 0x1e,
+  0x23, 0x35, 0x3b, 0x92, 0x54, 0x50, 0x49, 0x4b, 0x39, 0x39, 0x1f, 0x1e,
+  0x1e, 0x23, 0x35, 0x3b, 0x49, 0x34, 0x80, 0x2e, 0x2d, 0x5c, 0x5a, 0x6e,
+  0x6c, 0x01, 0x00, 0x6c, 0x6e, 0x5a, 0x5f, 0x2e, 0x01, 0x89, 0x78, 0xe9,
+  0x08, 0x24, 0x2d, 0x5c, 0x5a, 0x6e, 0x6c, 0xff, 0x00, 0x6c, 0x6e, 0x5a,
+  0x5c, 0x2d, 0x2e, 0x04, 0x29, 0xe8, 0x78, 0x01, 0x46, 0x21, 0x46, 0x40,
+  0x52, 0x4e, 0xbe, 0x4a, 0x56, 0x3c, 0x42, 0x42, 0x21, 0x23, 0x40, 0x40,
+  0x52, 0x4e, 0xbe, 0x4a, 0x56, 0x3c, 0x42, 0x21, 0x17, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x47, 0x00, 0x80, 0x04, 0xa4, 0x06, 0xb5, 0x00, 0x1e,
+  0x00, 0x3c, 0x00, 0x00, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26,
+  0x10, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x37, 0x27, 0x37, 0x01, 0x16,
+  0x17, 0x16, 0x17, 0x16, 0x10, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x03,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x14, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x36, 0x37, 0x36, 0x37, 0x36, 0x34, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x01, 0x27, 0x02, 0x73, 0x6e, 0x65, 0x60, 0x56, 0x4d,
+  0x2d, 0x29, 0x29, 0x2d, 0x4d, 0x56, 0x60, 0x4f, 0x57, 0xd2, 0x6c, 0x01,
+  0x61, 0x67, 0x58, 0x4e, 0x2c, 0x29, 0x29, 0x2c, 0x4e, 0x55, 0x61, 0x64,
+  0xa0, 0x38, 0x34, 0x49, 0x3b, 0x35, 0x23, 0x1e, 0x1e, 0x1f, 0x39, 0x3a,
+  0x4a, 0x49, 0x50, 0x54, 0x92, 0x3b, 0x35, 0x23, 0x1e, 0x1e, 0x1f, 0x39,
+  0x3e, 0x4f, 0xfe, 0xd9, 0x6c, 0x80, 0x2e, 0x2d, 0x5c, 0x5a, 0x6e, 0x6c,
+  0x01, 0x00, 0x6c, 0x6e, 0x5a, 0x5c, 0x2d, 0x24, 0x08, 0xe9, 0x78, 0xfe,
+  0x77, 0x2e, 0x5f, 0x5a, 0x6e, 0x6c, 0xff, 0x00, 0x6c, 0x6e, 0x5a, 0x5c,
+  0x2d, 0x2e, 0x04, 0x29, 0x07, 0x17, 0x21, 0x42, 0x3c, 0x56, 0x4a, 0xbe,
+  0x4e, 0x52, 0x40, 0x40, 0x23, 0x21, 0x42, 0x42, 0x3c, 0x56, 0x4a, 0xbe,
+  0x4e, 0x52, 0x40, 0x46, 0x21, 0xfe, 0xba, 0x78, 0x00, 0x02, 0x00, 0xe6,
+  0xfe, 0xb2, 0x04, 0x63, 0x06, 0x14, 0x00, 0x10, 0x00, 0x2e, 0x00, 0x00,
+  0x01, 0x15, 0x14, 0x16, 0x17, 0x26, 0x35, 0x11, 0x34, 0x37, 0x0e, 0x01,
+  0x1d, 0x01, 0x10, 0x07, 0x16, 0x01, 0x15, 0x23, 0x22, 0x06, 0x15, 0x11,
+  0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x3d, 0x01, 0x34, 0x26,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x34, 0x36, 0x33, 0x02,
+  0x59, 0x44, 0x9e, 0x2d, 0x2b, 0x9e, 0x42, 0x9b, 0x9b, 0x02, 0x09, 0x2f,
+  0x7e, 0x4d, 0x4d, 0x7e, 0x2f, 0xec, 0xe0, 0x97, 0x61, 0x80, 0x38, 0x38,
+  0x80, 0x61, 0x97, 0xe0, 0x01, 0x12, 0xef, 0x98, 0x6d, 0x07, 0x47, 0x9d,
+  0x04, 0xd0, 0xa1, 0x42, 0x07, 0x6b, 0x98, 0xf0, 0xfe, 0xee, 0x3e, 0x44,
+  0x03, 0xf4, 0x64, 0x57, 0x8e, 0xfb, 0x30, 0x8d, 0x58, 0x64, 0x94, 0xdd,
+  0xef, 0x97, 0x74, 0x8f, 0x73, 0x95, 0xf0, 0xdd, 0x93, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xe6, 0xfe, 0xb2, 0x04, 0x63, 0x06, 0x14, 0x00, 0x10,
+  0x00, 0x2e, 0x00, 0x00, 0x01, 0x10, 0x37, 0x26, 0x11, 0x35, 0x34, 0x26,
+  0x27, 0x16, 0x15, 0x11, 0x14, 0x07, 0x3e, 0x01, 0x35, 0x01, 0x33, 0x32,
+  0x16, 0x1d, 0x01, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x06, 0x1d,
+  0x01, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x34,
+  0x26, 0x2b, 0x01, 0x02, 0xf0, 0x9b, 0x9b, 0x42, 0x9f, 0x2c, 0x2d, 0x9e,
+  0x44, 0xfd, 0xf6, 0xed, 0xe0, 0x97, 0x61, 0x7f, 0x38, 0x38, 0x7f, 0x61,
+  0x97, 0xe0, 0xed, 0x30, 0x7e, 0x4d, 0x4d, 0x7e, 0x30, 0x01, 0x12, 0x01,
+  0x0e, 0x44, 0x3e, 0x01, 0x12, 0xf0, 0x98, 0x6b, 0x07, 0x42, 0xa1, 0xfb,
+  0x30, 0x9d, 0x47, 0x07, 0x6d, 0x98, 0x05, 0xf1, 0x93, 0xdd, 0xf0, 0x95,
+  0x73, 0x8f, 0x74, 0x97, 0xef, 0xdd, 0x94, 0x64, 0x58, 0x8d, 0x04, 0xd0,
+  0x8e, 0x57, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x32, 0x05, 0x46,
+  0x05, 0xf9, 0x00, 0x02, 0x00, 0x06, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x00,
+  0x05, 0x11, 0x09, 0x02, 0x35, 0x01, 0x05, 0x09, 0x01, 0x03, 0x11, 0x01,
+  0x15, 0x04, 0xac, 0xfd, 0x00, 0x03, 0x99, 0xfb, 0x7e, 0x04, 0x82, 0xfc,
+  0x17, 0x03, 0x01, 0xfc, 0xff, 0x99, 0x04, 0x82, 0xcc, 0x02, 0x64, 0xfe,
+  0xce, 0xfd, 0xcc, 0x01, 0xe1, 0xa6, 0x01, 0xe1, 0x07, 0x01, 0x32, 0x01,
+  0x32, 0xfc, 0x9a, 0x04, 0x68, 0xfe, 0x1f, 0xa6, 0x00, 0x03, 0x00, 0xc3,
+  0x00, 0x1e, 0x06, 0x70, 0x04, 0xe6, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a,
+  0x00, 0x00, 0x25, 0x23, 0x11, 0x33, 0x01, 0x11, 0x09, 0x02, 0x35, 0x01,
+  0x06, 0x70, 0x99, 0x99, 0xfe, 0x3c, 0xfc, 0xf8, 0x03, 0xa1, 0xfb, 0x7e,
+  0x04, 0x82, 0x1e, 0x04, 0xc8, 0xfc, 0x3a, 0x02, 0xc4, 0xfe, 0x9e, 0xfd,
+  0x9c, 0x02, 0x11, 0xa6, 0x02, 0x11, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0x00, 0x1e, 0x06, 0x70, 0x04, 0xe6, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0a,
+  0x00, 0x00, 0x37, 0x11, 0x33, 0x11, 0x09, 0x02, 0x03, 0x11, 0x01, 0x15,
+  0xc3, 0x99, 0x01, 0x2b, 0x03, 0x08, 0xfc, 0xf8, 0x99, 0x04, 0x82, 0x1e,
+  0x04, 0xc8, 0xfb, 0x38, 0x01, 0x02, 0x01, 0x62, 0x01, 0x62, 0xfc, 0x3a,
+  0x04, 0xc8, 0xfd, 0xef, 0xa6, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x05, 0x00, 0x08, 0x00, 0x00,
+  0x17, 0x11, 0x09, 0x01, 0x11, 0x01, 0x37, 0x01, 0x11, 0xc3, 0x02, 0xd7,
+  0x02, 0xd6, 0xfd, 0x2a, 0x8b, 0x01, 0xb2, 0x3e, 0x05, 0x80, 0xfd, 0xb0,
+  0x02, 0x50, 0xfa, 0x80, 0x02, 0x4e, 0x71, 0xfe, 0xa2, 0x02, 0xc6, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x05,
+  0x00, 0x08, 0x00, 0x00, 0x17, 0x11, 0x09, 0x01, 0x11, 0x01, 0x27, 0x01,
+  0x11, 0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0x8c, 0xfe, 0x4e, 0x3e,
+  0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50, 0xfa, 0x80, 0x02, 0x4e, 0x71, 0x01,
+  0x5e, 0xfd, 0x44, 0x00, 0x00, 0x01, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70,
+  0x05, 0x42, 0x00, 0x05, 0x00, 0x00, 0x17, 0x11, 0x09, 0x01, 0x11, 0x01,
+  0xc3, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0x3e, 0x05, 0x80, 0xfd, 0xb0,
+  0x02, 0x50, 0xfa, 0x80, 0x02, 0x4e, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc3,
+  0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x08, 0x00, 0x00, 0x25, 0x15,
+  0x09, 0x01, 0x11, 0x09, 0x01, 0x15, 0x01, 0x06, 0x70, 0xfd, 0x2a, 0xfd,
+  0x29, 0x02, 0xd7, 0x02, 0xd6, 0xfd, 0xb5, 0xa2, 0xe0, 0x02, 0x4e, 0xfd,
+  0xb2, 0x05, 0x80, 0xfd, 0xb0, 0x02, 0x50, 0xdd, 0xfe, 0x1c, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0xff, 0xc2, 0x06, 0x70, 0x05, 0x42, 0x00, 0x08,
+  0x00, 0x00, 0x13, 0x35, 0x09, 0x01, 0x11, 0x09, 0x01, 0x35, 0x01, 0xc3,
+  0x02, 0xd7, 0x02, 0xd6, 0xfd, 0x2a, 0xfd, 0x29, 0x02, 0x4b, 0x04, 0x62,
+  0xe0, 0xfd, 0xb2, 0x02, 0x4e, 0xfa, 0x80, 0x02, 0x50, 0xfd, 0xb0, 0xdd,
+  0x01, 0xe4, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05, 0xfe, 0x23, 0x03, 0x8a,
+  0x06, 0x75, 0x00, 0x03, 0x00, 0x00, 0x09, 0x03, 0x01, 0xc7, 0x01, 0xc2,
+  0xfe, 0x3e, 0xfe, 0x3e, 0x06, 0x75, 0xfb, 0xdb, 0xfb, 0xd3, 0x04, 0x2d,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x13,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15,
+  0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x01, 0xd8,
+  0x97, 0x01, 0x2b, 0x97, 0x01, 0x14, 0xfe, 0xec, 0x97, 0xfe, 0xd5, 0x97,
+  0xfe, 0xeb, 0x02, 0xd7, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3,
+  0xaa, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xaa, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xc3, 0x00, 0x00, 0x05, 0x46, 0x05, 0x04, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11, 0x23, 0x11,
+  0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x01, 0x7e, 0x97, 0xa4, 0x97, 0xa4,
+  0x97, 0xba, 0xba, 0x97, 0xa4, 0x97, 0xa4, 0x97, 0xbb, 0x02, 0xd7, 0x02,
+  0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0xaa,
+  0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d, 0xfd, 0xd3, 0x02, 0x2d,
+  0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x34, 0xfe, 0x6b, 0x06, 0xff,
+  0x05, 0xfb, 0x00, 0x03, 0x00, 0x1d, 0x00, 0x37, 0x00, 0x00, 0x01, 0x21,
+  0x11, 0x21, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12,
+  0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34,
+  0x02, 0x27, 0x26, 0x27, 0x24, 0x20, 0x04, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x04, 0x20, 0x24, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x11, 0x01, 0x11, 0xfe, 0xef,
+  0x01, 0x19, 0xfe, 0xe0, 0x7e, 0x7c, 0x66, 0x69, 0x66, 0x66, 0x69, 0x66,
+  0x7c, 0x7e, 0x01, 0x20, 0x7e, 0x7b, 0x67, 0x68, 0x66, 0x66, 0x68, 0x67,
+  0x7b, 0xfe, 0x3e, 0x01, 0x67, 0x01, 0x33, 0x80, 0x80, 0x40, 0x3f, 0x3f,
+  0x40, 0x80, 0x80, 0xfe, 0xcd, 0xfe, 0x99, 0xfe, 0xcd, 0x80, 0x80, 0x40,
+  0x3f, 0x3f, 0x40, 0x80, 0x80, 0x02, 0xe8, 0xfe, 0x92, 0x03, 0xc8, 0x3b,
+  0x3a, 0x72, 0x73, 0xfe, 0xec, 0xa3, 0x9f, 0xfe, 0xec, 0x73, 0x72, 0x3a,
+  0x3b, 0x3b, 0x3a, 0x72, 0x73, 0x01, 0x14, 0x9f, 0xa3, 0x01, 0x14, 0x73,
+  0x72, 0x3a, 0xf4, 0x90, 0x8d, 0x8e, 0xac, 0xaa, 0xc9, 0xc5, 0xac, 0xaa,
+  0x8e, 0x8d, 0x90, 0x90, 0x8d, 0x8e, 0xaa, 0xac, 0xc5, 0xc9, 0xaa, 0xac,
+  0x8e, 0x8d, 0x00, 0x00, 0x00, 0x03, 0x00, 0x34, 0xfe, 0x6b, 0x06, 0xff,
+  0x05, 0xfb, 0x00, 0x19, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x20,
+  0x07, 0x06, 0x07, 0x06, 0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x37, 0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27,
+  0x24, 0x20, 0x04, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x04, 0x20, 0x24, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x05, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x04, 0x2a, 0xfe, 0xe0, 0x7e, 0x7c, 0x66, 0x69, 0x66, 0x66,
+  0x69, 0x66, 0x7c, 0x7e, 0x01, 0x20, 0x7e, 0x7b, 0x67, 0x68, 0x66, 0x66,
+  0x68, 0x67, 0x7b, 0xfe, 0x3e, 0x01, 0x67, 0x01, 0x33, 0x80, 0x80, 0x40,
+  0x3f, 0x3f, 0x40, 0x80, 0x80, 0xfe, 0xcd, 0xfe, 0x99, 0xfe, 0xcd, 0x80,
+  0x80, 0x40, 0x3f, 0x3f, 0x40, 0x80, 0x73, 0x02, 0x3f, 0x02, 0x4c, 0xfd,
+  0xb4, 0x97, 0xfd, 0xb4, 0x02, 0x4c, 0x05, 0x42, 0x3b, 0x3a, 0x72, 0x73,
+  0xfe, 0xec, 0xa3, 0x9f, 0xfe, 0xec, 0x73, 0x72, 0x3a, 0x3b, 0x3b, 0x3a,
+  0x72, 0x73, 0x01, 0x14, 0x9f, 0xa3, 0x01, 0x14, 0x73, 0x72, 0x3a, 0xf4,
+  0x90, 0x8d, 0x8e, 0xac, 0xaa, 0xc9, 0xc5, 0xac, 0xaa, 0x8e, 0x8d, 0x90,
+  0x90, 0x8d, 0x8e, 0xaa, 0xac, 0xc5, 0xc9, 0xaa, 0xac, 0x8e, 0x80, 0x4b,
+  0xfd, 0x73, 0xaa, 0xfd, 0x73, 0x02, 0x8d, 0xaa, 0x02, 0x8d, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x34, 0xfe, 0x6b, 0x06, 0xff, 0x05, 0xfb, 0x00, 0x19,
+  0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x20, 0x07, 0x06, 0x07, 0x06,
+  0x02, 0x15, 0x14, 0x12, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
+  0x36, 0x12, 0x35, 0x34, 0x02, 0x27, 0x26, 0x27, 0x24, 0x20, 0x04, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x04, 0x20, 0x24,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x17, 0x09,
+  0x01, 0x17, 0x09, 0x01, 0x07, 0x09, 0x01, 0x27, 0x09, 0x01, 0x04, 0x2a,
+  0xfe, 0xe0, 0x7e, 0x7c, 0x66, 0x69, 0x66, 0x66, 0x69, 0x66, 0x7c, 0x7e,
+  0x01, 0x20, 0x7e, 0x7b, 0x67, 0x68, 0x66, 0x66, 0x68, 0x67, 0x7b, 0xfe,
+  0x3e, 0x01, 0x67, 0x01, 0x33, 0x80, 0x80, 0x40, 0x3f, 0x3f, 0x40, 0x80,
+  0x80, 0xfe, 0xcd, 0xfe, 0x99, 0xfe, 0xcd, 0x80, 0x80, 0x40, 0x3f, 0x3f,
+  0x40, 0x80, 0x73, 0x53, 0x01, 0xa0, 0x01, 0xa0, 0x6c, 0xfe, 0x60, 0x01,
+  0xa0, 0x6b, 0xfe, 0x60, 0xfe, 0x61, 0x6d, 0x01, 0xa0, 0xfe, 0x60, 0x05,
+  0x42, 0x3b, 0x3a, 0x72, 0x73, 0xfe, 0xec, 0xa3, 0x9f, 0xfe, 0xec, 0x73,
+  0x72, 0x3a, 0x3b, 0x3b, 0x3a, 0x72, 0x73, 0x01, 0x14, 0x9f, 0xa3, 0x01,
+  0x14, 0x73, 0x72, 0x3a, 0xf4, 0x90, 0x8d, 0x8e, 0xac, 0xaa, 0xc9, 0xc5,
+  0xac, 0xaa, 0x8e, 0x8d, 0x90, 0x90, 0x8d, 0x8e, 0xaa, 0xac, 0xc5, 0xc9,
+  0xaa, 0xac, 0x8e, 0x80, 0xe8, 0xfe, 0x33, 0x01, 0xcd, 0x78, 0xfe, 0x32,
+  0xfe, 0x33, 0x77, 0x01, 0xcd, 0xfe, 0x33, 0x78, 0x01, 0xce, 0x01, 0xcd,
+  0xff, 0xff, 0x00, 0x69, 0xfe, 0x4d, 0x09, 0x22, 0x06, 0x0e, 0x10, 0x27,
+  0x09, 0x07, 0x05, 0xca, 0x00, 0x00, 0x10, 0x26, 0x09, 0x07, 0x00, 0x00,
+  0x10, 0x27, 0x09, 0x07, 0x01, 0xee, 0x00, 0x00, 0x10, 0x07, 0x09, 0x07,
+  0x03, 0xdc, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
+  0x06, 0x0e, 0x00, 0x1d, 0x00, 0x00, 0x17, 0x16, 0x33, 0x32, 0x37, 0x13,
+  0x23, 0x35, 0x33, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23,
+  0x22, 0x07, 0x03, 0x33, 0x15, 0x23, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27,
+  0xee, 0x10, 0x35, 0x3e, 0x07, 0x1d, 0xf7, 0xfe, 0x17, 0x07, 0x8f, 0x89,
+  0x73, 0x12, 0x85, 0x0f, 0x36, 0x3e, 0x07, 0x16, 0xf7, 0xfe, 0x1d, 0x08,
+  0x8f, 0x89, 0x73, 0x12, 0x9b, 0x82, 0xaf, 0x02, 0x9a, 0xaa, 0x02, 0x0c,
+  0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0xfe, 0x0d, 0xaa, 0xfd, 0x4d,
+  0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
+  0x06, 0x0e, 0x00, 0x25, 0x00, 0x00, 0x17, 0x16, 0x33, 0x32, 0x37, 0x13,
+  0x23, 0x35, 0x33, 0x37, 0x21, 0x35, 0x21, 0x13, 0x3e, 0x01, 0x32, 0x16,
+  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x33, 0x15, 0x23, 0x07, 0x21,
+  0x15, 0x21, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0xee, 0x10, 0x35, 0x3e,
+  0x07, 0x14, 0xee, 0xf5, 0x0b, 0xff, 0x00, 0x01, 0x07, 0x0e, 0x07, 0x8f,
+  0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0xed, 0xf5, 0x0a,
+  0x00, 0xff, 0xfe, 0xf9, 0x14, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x9b, 0x82,
+  0xaf, 0x01, 0xce, 0xaa, 0xf0, 0xa8, 0x01, 0x40, 0xa5, 0x87, 0x7a, 0x8f,
+  0x0f, 0x82, 0xaf, 0xfe, 0xd9, 0xa8, 0xf0, 0xaa, 0xfe, 0x19, 0xa5, 0x87,
+  0x7a, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
+  0x06, 0x0e, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03,
+  0x25, 0x15, 0x05, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33,
+  0x32, 0x37, 0x13, 0x05, 0x35, 0x25, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17,
+  0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x17, 0x01, 0x22, 0xfe, 0xd7, 0x1c,
+  0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x18, 0xfe,
+  0xde, 0x01, 0x29, 0x1c, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x04, 0xf6, 0x82,
+  0xaf, 0xfd, 0xe7, 0xb6, 0xa0, 0xba, 0xfd, 0x6d, 0xa5, 0x87, 0x7a, 0x8f,
+  0x0f, 0x82, 0xaf, 0x02, 0x19, 0xb6, 0xa0, 0xba, 0x02, 0x93, 0xa5, 0x87,
+  0x7a, 0x8f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
+  0x06, 0x0e, 0x00, 0x2a, 0x00, 0x33, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
+  0x07, 0x03, 0x16, 0x17, 0x07, 0x26, 0x27, 0x03, 0x36, 0x37, 0x17, 0x06,
+  0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37,
+  0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x13, 0x3e, 0x01,
+  0x32, 0x16, 0x17, 0x01, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x89, 0x42, 0x66, 0x24, 0x48,
+  0x14, 0x1d, 0x13, 0x38, 0x31, 0x3d, 0x0d, 0x08, 0x8f, 0x89, 0x73, 0x12,
+  0x85, 0x10, 0x35, 0x3e, 0x07, 0x0e, 0x54, 0x42, 0x63, 0x64, 0x4b, 0x69,
+  0x0e, 0x07, 0x8f, 0x89, 0x73, 0x12, 0xfe, 0x34, 0x14, 0x37, 0x28, 0x40,
+  0x43, 0x21, 0x04, 0xf6, 0x82, 0xaf, 0xfe, 0xd6, 0x29, 0x88, 0x41, 0x48,
+  0x21, 0xfe, 0x2b, 0x06, 0x11, 0x70, 0x24, 0x09, 0xfe, 0xbe, 0xa5, 0x87,
+  0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0x01, 0x31, 0x18, 0x49, 0x6f, 0x9b, 0x9c,
+  0x73, 0x56, 0x13, 0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f, 0xfc, 0x45, 0x01,
+  0xd6, 0x11, 0x2e, 0x4a, 0x67, 0x68, 0x48, 0x24, 0x00, 0x01, 0x00, 0x69,
+  0xfe, 0x4d, 0x03, 0xc3, 0x06, 0x0e, 0x00, 0x32, 0x00, 0x00, 0x01, 0x26,
+  0x23, 0x22, 0x07, 0x03, 0x36, 0x37, 0x36, 0x3d, 0x01, 0x07, 0x27, 0x37,
+  0x33, 0x17, 0x07, 0x27, 0x15, 0x14, 0x07, 0x06, 0x07, 0x03, 0x0e, 0x01,
+  0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x26, 0x27, 0x26,
+  0x35, 0x33, 0x14, 0x17, 0x16, 0x17, 0x13, 0x3e, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x27, 0x3a, 0x2a, 0x4e, 0x54,
+  0x41, 0xaa, 0x31, 0xa9, 0x41, 0x53, 0x62, 0x4d, 0x62, 0x0f, 0x08, 0x90,
+  0x88, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3d, 0x08, 0x0f, 0x52, 0x38, 0x6b,
+  0x5c, 0x48, 0x2e, 0x27, 0x28, 0x07, 0x90, 0x88, 0x42, 0x30, 0x13, 0x04,
+  0xf6, 0x82, 0xaf, 0xfc, 0x78, 0x10, 0x2f, 0x55, 0x72, 0x1e, 0x5d, 0x48,
+  0xbd, 0xbd, 0x48, 0x5d, 0x1e, 0x9c, 0x6c, 0x56, 0x11, 0xfe, 0xa1, 0xa5,
+  0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0x01, 0x4d, 0x19, 0x3e, 0x77, 0x9a,
+  0x72, 0x4e, 0x33, 0x0b, 0x03, 0x99, 0xa5, 0x87, 0x46, 0x34, 0x8f, 0x00,
+  0x00, 0x02, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x03,
+  0x00, 0x21, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x03, 0x13, 0x21, 0x11,
+  0x21, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
+  0x03, 0x21, 0x11, 0x21, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16,
+  0x33, 0x32, 0x01, 0x87, 0xbd, 0xbd, 0x0f, 0x10, 0x01, 0x51, 0xfe, 0xc8,
+  0x12, 0x07, 0x92, 0x88, 0x71, 0x12, 0x85, 0x10, 0x33, 0x3f, 0x08, 0x0c,
+  0x01, 0x19, 0xfe, 0xc4, 0x0b, 0x08, 0x98, 0x82, 0x71, 0x12, 0x85, 0x10,
+  0x33, 0x40, 0x02, 0xa6, 0xfe, 0xfd, 0xea, 0x01, 0x72, 0x02, 0x30, 0x01,
+  0xae, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xf5, 0xfc, 0xbc,
+  0xfe, 0xff, 0xad, 0x7f, 0x7d, 0x8c, 0x0f, 0x82, 0x00, 0x02, 0x00, 0x69,
+  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x03, 0x00, 0x2b, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x23, 0x13, 0x06, 0x07, 0x13, 0x3e, 0x01, 0x32, 0x16,
+  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x10, 0x07,
+  0x06, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
+  0x37, 0x13, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26, 0x01, 0x87, 0xbd, 0xbd,
+  0x59, 0x25, 0x1c, 0x14, 0x07, 0x92, 0x88, 0x71, 0x12, 0x85, 0x10, 0x33,
+  0x40, 0x07, 0x0c, 0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68, 0x0d, 0x08, 0x91,
+  0x88, 0x72, 0x12, 0x85, 0x10, 0x33, 0x3f, 0x08, 0x14, 0x24, 0x31, 0x63,
+  0x7a, 0x85, 0x02, 0xa6, 0xfe, 0x01, 0x7e, 0x02, 0x05, 0x01, 0xc3, 0xa7,
+  0x85, 0x7c, 0x8d, 0x0f, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0xfe,
+  0xd2, 0x6f, 0x55, 0x13, 0xfe, 0xbe, 0xa7, 0x85, 0x7d, 0x8c, 0x0f, 0x82,
+  0xaf, 0x01, 0xb6, 0x10, 0x93, 0xd8, 0x7f, 0x00, 0x00, 0x02, 0x00, 0x69,
+  0xfe, 0x4d, 0x03, 0xff, 0x06, 0x0e, 0x00, 0x03, 0x00, 0x2e, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x23, 0x01, 0x16, 0x33, 0x32, 0x37, 0x13, 0x16, 0x17,
+  0x16, 0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x07, 0x13, 0x3e, 0x01, 0x32,
+  0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x36, 0x33, 0x32, 0x16,
+  0x10, 0x06, 0x23, 0x22, 0x27, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x02,
+  0x4e, 0xbd, 0xbd, 0xfe, 0xa0, 0x10, 0x35, 0x3e, 0x07, 0x18, 0x29, 0x32,
+  0x65, 0xb2, 0x87, 0x7c, 0x65, 0xc0, 0x4b, 0x16, 0x05, 0x92, 0x88, 0x73,
+  0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0d, 0x35, 0x3d, 0x98, 0xb9, 0xc6,
+  0x8b, 0x4e, 0x42, 0x0f, 0x08, 0x90, 0x88, 0x73, 0x12, 0x02, 0xae, 0xfe,
+  0xfd, 0xb5, 0x82, 0xaf, 0x02, 0x33, 0x3e, 0x1c, 0x36, 0x91, 0xd1, 0x8f,
+  0xa1, 0x02, 0x5d, 0xa4, 0x88, 0x7a, 0x8f, 0x0f, 0x82, 0xaf, 0xfe, 0xcb,
+  0x13, 0xe9, 0xfe, 0xd2, 0xdb, 0x21, 0xfe, 0xa3, 0xa5, 0x87, 0x7a, 0x8f,
+  0x00, 0x03, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x03,
+  0x00, 0x0b, 0x00, 0x31, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x16, 0x36,
+  0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0x03, 0x16, 0x33, 0x32, 0x37, 0x13,
+  0x26, 0x27, 0x26, 0x10, 0x37, 0x36, 0x37, 0x13, 0x3e, 0x01, 0x32, 0x16,
+  0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17, 0x16, 0x10, 0x07,
+  0x06, 0x07, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x01, 0x82, 0xbe, 0xbe,
+  0xb7, 0x85, 0x7c, 0xc1, 0x81, 0x80, 0x92, 0x10, 0x35, 0x3e, 0x07, 0x0e,
+  0x54, 0x42, 0x63, 0x64, 0x4b, 0x69, 0x0e, 0x07, 0x8f, 0x89, 0x73, 0x12,
+  0x85, 0x10, 0x35, 0x3e, 0x07, 0x0c, 0x59, 0x3b, 0x63, 0x63, 0x4d, 0x68,
+  0x0d, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x02, 0xb0, 0xfe, 0x7a, 0x90, 0xd1,
+  0x8f, 0x91, 0xcf, 0x90, 0xfe, 0x2d, 0x82, 0xaf, 0x01, 0x31, 0x18, 0x49,
+  0x6f, 0x01, 0x37, 0x73, 0x56, 0x13, 0x01, 0x3c, 0xa4, 0x88, 0x7a, 0x8f,
+  0x0f, 0x82, 0xaf, 0xfe, 0xd6, 0x18, 0x4b, 0x7c, 0xfe, 0xd2, 0x6f, 0x55,
+  0x13, 0xfe, 0xbe, 0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x00, 0x03, 0x00, 0x69,
+  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x25,
+  0x00, 0x00, 0x37, 0x11, 0x21, 0x13, 0x3e, 0x01, 0x32, 0x16, 0x17, 0x07,
+  0x26, 0x23, 0x22, 0x07, 0x03, 0x33, 0x11, 0x21, 0x03, 0x0e, 0x01, 0x22,
+  0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x1b, 0x01, 0x03, 0x33, 0x11,
+  0x21, 0x23, 0x11, 0x33, 0x89, 0x01, 0x1b, 0x0f, 0x07, 0x92, 0x88, 0x71,
+  0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0d, 0xfc, 0xfe, 0xe3, 0x0c, 0x08,
+  0x98, 0x80, 0x73, 0x12, 0x85, 0x10, 0x33, 0x40, 0x07, 0x0c, 0xb1, 0x15,
+  0x9a, 0xfe, 0xe5, 0x9a, 0x84, 0x9b, 0x02, 0xfe, 0x01, 0x49, 0xa7, 0x85,
+  0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfe, 0xd0, 0xfd, 0x02, 0xfe, 0xde, 0xad,
+  0x7f, 0x7b, 0x8e, 0x0f, 0x82, 0xaf, 0x01, 0x09, 0x02, 0x74, 0xfe, 0x16,
+  0x01, 0xea, 0xfe, 0x16, 0x00, 0x01, 0xff, 0xc4, 0xfe, 0x4d, 0x03, 0xfc,
+  0x06, 0x0e, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03,
+  0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x35, 0x36, 0x37, 0x26, 0x27, 0x23,
+  0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13,
+  0x21, 0x17, 0x07, 0x01, 0x35, 0x01, 0x17, 0x07, 0x21, 0x13, 0x3e, 0x01,
+  0x32, 0x17, 0x16, 0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x16, 0xf3,
+  0x5a, 0x7d, 0x82, 0x55, 0x56, 0x07, 0x07, 0x56, 0xfa, 0x1d, 0x08, 0x8f,
+  0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3d, 0x08, 0x1d, 0xfe, 0xf9, 0xa8,
+  0x56, 0xfe, 0xe5, 0x01, 0x1b, 0x56, 0xa8, 0x01, 0x0c, 0x19, 0x07, 0x8f,
+  0x89, 0x42, 0x30, 0x13, 0x04, 0xf6, 0x82, 0xaf, 0xfd, 0xef, 0x8f, 0xc6,
+  0x8c, 0x88, 0x04, 0x65, 0x62, 0x06, 0xfd, 0x49, 0xa5, 0x87, 0x7a, 0x8f,
+  0x0f, 0x82, 0xaf, 0x02, 0x9e, 0xba, 0x60, 0x01, 0x3a, 0x48, 0x01, 0x3a,
+  0x60, 0xba, 0x02, 0x2a, 0xa5, 0x87, 0x46, 0x34, 0x8f, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x23,
+  0x00, 0x00, 0x01, 0x26, 0x23, 0x22, 0x07, 0x03, 0x37, 0x17, 0x07, 0x17,
+  0x07, 0x27, 0x03, 0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32,
+  0x37, 0x13, 0x07, 0x27, 0x37, 0x27, 0x37, 0x17, 0x13, 0x3e, 0x01, 0x32,
+  0x16, 0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x12, 0x8d, 0x6c, 0xe2,
+  0xe2, 0x6c, 0x9f, 0x16, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35,
+  0x3e, 0x07, 0x15, 0x8f, 0x6e, 0xe5, 0xe3, 0x6c, 0xa0, 0x15, 0x07, 0x8f,
+  0x89, 0x73, 0x12, 0x04, 0xf6, 0x82, 0xaf, 0xfe, 0x58, 0x9d, 0x79, 0xfc,
+  0xfc, 0x78, 0xb0, 0xfd, 0xf4, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf,
+  0x01, 0xe2, 0xa0, 0x79, 0xfc, 0xfc, 0x78, 0xb3, 0x01, 0xd8, 0xa5, 0x87,
+  0x7a, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x00, 0x69, 0xfe, 0x4d, 0x03, 0x57,
+  0x06, 0x0e, 0x00, 0x2a, 0x00, 0x00, 0x17, 0x16, 0x33, 0x32, 0x37, 0x13,
+  0x06, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11, 0x34, 0x36, 0x37, 0x13, 0x3e,
+  0x01, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07, 0x03, 0x16, 0x17,
+  0x16, 0x15, 0x11, 0x23, 0x11, 0x34, 0x27, 0x03, 0x0e, 0x01, 0x22, 0x26,
+  0x27, 0xee, 0x10, 0x35, 0x3e, 0x07, 0x29, 0x3b, 0x1d, 0x2e, 0x6d, 0x8b,
+  0x6d, 0x0d, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07,
+  0x0c, 0x51, 0x38, 0x4e, 0x6d, 0x70, 0x28, 0x08, 0x8f, 0x89, 0x73, 0x12,
+  0x9b, 0x82, 0xaf, 0x03, 0xa6, 0x10, 0x32, 0x50, 0x9c, 0xfe, 0xc8, 0x01,
+  0x49, 0xcf, 0xbc, 0x11, 0x01, 0x2b, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82,
+  0xaf, 0xfe, 0xe6, 0x18, 0x45, 0x61, 0xd6, 0xfe, 0xb7, 0x01, 0x38, 0xf3,
+  0x32, 0xfc, 0x4a, 0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x00, 0x01, 0x00, 0x69,
+  0xfe, 0x4d, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x27, 0x00, 0x00, 0x01, 0x26,
+  0x23, 0x22, 0x07, 0x03, 0x36, 0x19, 0x01, 0x33, 0x11, 0x10, 0x07, 0x03,
+  0x0e, 0x01, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37, 0x13, 0x26,
+  0x27, 0x26, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x13, 0x3e, 0x01, 0x32,
+  0x16, 0x17, 0x02, 0xd2, 0x10, 0x35, 0x3e, 0x07, 0x26, 0x84, 0x6d, 0xf6,
+  0x0f, 0x08, 0x8f, 0x89, 0x73, 0x12, 0x85, 0x10, 0x35, 0x3e, 0x07, 0x0f,
+  0x53, 0x39, 0x4d, 0x6d, 0x71, 0x27, 0x07, 0x8f, 0x89, 0x73, 0x12, 0x04,
+  0xf6, 0x82, 0xaf, 0xfc, 0x8d, 0x26, 0x01, 0x07, 0x01, 0x38, 0xfe, 0xb7,
+  0xfe, 0x8c, 0x27, 0xfe, 0xa2, 0xa5, 0x87, 0x7a, 0x8f, 0x0f, 0x82, 0xaf,
+  0x01, 0x4c, 0x17, 0x46, 0x61, 0xd6, 0x01, 0x49, 0xfe, 0xc8, 0xf5, 0x31,
+  0x03, 0x85, 0xa5, 0x87, 0x7a, 0x8f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x69,
+  0xfe, 0x4d, 0x03, 0x60, 0x06, 0xf9, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
+  0x03, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37,
+  0x01, 0x15, 0x21, 0x35, 0x01, 0xb3, 0x07, 0x92, 0x43, 0x45, 0x71, 0x12,
+  0x85, 0x10, 0x33, 0x40, 0x07, 0x3a, 0x08, 0x91, 0x45, 0x43, 0x72, 0x12,
+  0x85, 0x10, 0x33, 0x40, 0x07, 0x01, 0xe8, 0xfd, 0x3e, 0x04, 0xe2, 0xa7,
+  0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfa, 0xb0, 0xa7, 0x85, 0x7d, 0x8c,
+  0x0f, 0x82, 0xaf, 0x07, 0x67, 0xa0, 0xa0, 0x00, 0x00, 0x02, 0x00, 0x60,
+  0xfd, 0x62, 0x03, 0x57, 0x06, 0x0e, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x07, 0x26, 0x23, 0x22, 0x07,
+  0x03, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x27, 0x37, 0x16, 0x33, 0x32, 0x37,
+  0x01, 0x35, 0x21, 0x15, 0x01, 0xb3, 0x07, 0x92, 0x43, 0x45, 0x71, 0x12,
+  0x85, 0x10, 0x33, 0x40, 0x07, 0x3a, 0x08, 0x91, 0x45, 0x43, 0x72, 0x12,
+  0x85, 0x10, 0x33, 0x40, 0x07, 0xfe, 0xe8, 0x02, 0xc3, 0x04, 0xe2, 0xa7,
+  0x85, 0x7d, 0x8c, 0x0f, 0x82, 0xaf, 0xfa, 0xb0, 0xa7, 0x85, 0x7d, 0x8c,
+  0x0f, 0x82, 0xaf, 0xfd, 0xd0, 0xa0, 0xa0, 0x00, 0xff, 0xff, 0x00, 0xfc,
+  0x00, 0x3f, 0x05, 0x0d, 0x04, 0xc5, 0x10, 0x06, 0x00, 0x99, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xc3, 0x01, 0xd3, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
+  0x09, 0x18, 0x00, 0x00, 0x10, 0x07, 0x09, 0xa1, 0x01, 0xdf, 0x01, 0x24,
+  0xff, 0xff, 0x00, 0xc3, 0x00, 0x9f, 0x05, 0x46, 0x04, 0x6a, 0x10, 0x26,
+  0x09, 0x18, 0x00, 0x00, 0x10, 0x27, 0x09, 0xa1, 0x00, 0xd0, 0xfe, 0x57,
+  0x10, 0x07, 0x09, 0xa1, 0x02, 0xed, 0x01, 0x24, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x04, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
+  0x05, 0x15, 0x01, 0x35, 0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45,
+  0xfb, 0x7e, 0x04, 0x82, 0xfc, 0x5f, 0x03, 0xa1, 0xfb, 0x7e, 0x04, 0x82,
+  0x46, 0xb6, 0x01, 0xd1, 0xb6, 0x02, 0x65, 0xfe, 0x91, 0xfe, 0x93, 0xb6,
+  0x01, 0xd1, 0xa6, 0x01, 0xd1, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x04, 0x05, 0x46, 0x04, 0xa6, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
+  0x17, 0x01, 0x15, 0x01, 0x11, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0xc3,
+  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xa1, 0x46, 0x01,
+  0xd1, 0xb6, 0xfe, 0x2f, 0x04, 0xec, 0xb6, 0xfe, 0x2f, 0xa6, 0xfe, 0x2f,
+  0xb6, 0x01, 0x6d, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x47,
+  0x04, 0xa6, 0x10, 0x27, 0x09, 0xa1, 0x03, 0xc4, 0xff, 0xbb, 0x10, 0x06,
+  0x0d, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
+  0x04, 0xa6, 0x10, 0x26, 0x09, 0xa1, 0xfe, 0xbb, 0x10, 0x06, 0x0d, 0xd6,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
+  0x05, 0x27, 0x10, 0x27, 0x09, 0xa1, 0x00, 0xf4, 0x01, 0xe1, 0x10, 0x06,
+  0x0d, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
+  0x05, 0x27, 0x10, 0x27, 0x09, 0xa1, 0x02, 0xcd, 0x01, 0xe1, 0x10, 0x06,
+  0x0d, 0xd6, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x47,
+  0x06, 0x12, 0x10, 0x27, 0x09, 0xa1, 0x03, 0xc4, 0x02, 0xcc, 0x10, 0x06,
+  0x0d, 0xd5, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3, 0xff, 0x04, 0x05, 0x46,
+  0x06, 0x0d, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe, 0x02, 0xc7, 0x10, 0x06,
+  0x0d, 0xd6, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0xf1, 0x05, 0x46,
+  0x05, 0x4e, 0x00, 0x1c, 0x00, 0x3a, 0x00, 0x41, 0x00, 0x00, 0x25, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x1e, 0x01, 0x17, 0x16,
+  0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x09, 0x01,
+  0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x63, 0x83, 0x09,
+  0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x63,
+  0x85, 0x09, 0x0b, 0x0d, 0x8c, 0x55, 0x4d, 0x97, 0x5e, 0x5f, 0xa1, 0x58,
+  0x63, 0x83, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e,
+  0xa2, 0x56, 0x63, 0x85, 0x09, 0x04, 0x07, 0x0d, 0x8c, 0x55, 0x4d, 0x97,
+  0x5d, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x50, 0xb3, 0x4e,
+  0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x45,
+  0x3b, 0x05, 0x04, 0x06, 0x3d, 0x4b, 0x01, 0x9b, 0xb2, 0x50, 0x44, 0x3a,
+  0x04, 0x04, 0x02, 0x06, 0x3c, 0x4c, 0x52, 0xb2, 0x4e, 0x44, 0x3a, 0x04,
+  0x02, 0x04, 0x06, 0x3c, 0x4a, 0x03, 0x5e, 0xfe, 0xeb, 0xfe, 0xee, 0xb2,
+  0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0xfe, 0xf1, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x1c, 0x00, 0x3a, 0x00, 0x41,
+  0x00, 0x00, 0x25, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
+  0x1e, 0x01, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35,
+  0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x36, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1,
+  0x58, 0x63, 0x83, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58,
+  0x5e, 0xa2, 0x56, 0x63, 0x85, 0x09, 0x0b, 0x0d, 0x8c, 0x55, 0x4d, 0x97,
+  0x5e, 0x5f, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x06, 0x05, 0x0e, 0x8b, 0x55,
+  0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x63, 0x85, 0x09, 0x04, 0x07, 0x0d,
+  0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60,
+  0x50, 0xb3, 0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54,
+  0xb3, 0x4e, 0x45, 0x3b, 0x05, 0x04, 0x06, 0x3d, 0x4b, 0x01, 0x9b, 0xb2,
+  0x50, 0x44, 0x3a, 0x04, 0x04, 0x02, 0x06, 0x3c, 0x4c, 0x52, 0xb2, 0x4e,
+  0x44, 0x3a, 0x04, 0x02, 0x04, 0x06, 0x3c, 0x4a, 0x03, 0x5e, 0xb0, 0xfe,
+  0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x08, 0x05, 0x46, 0x04, 0xa8, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00,
+  0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21,
+  0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x03, 0x4e, 0x87, 0x51, 0x01, 0xc1,
+  0xfd, 0xed, 0x78, 0x87, 0x51, 0xfe, 0x3f, 0x02, 0x13, 0x02, 0x6f, 0xfc,
+  0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x01, 0xa2, 0x50, 0xa8, 0xaa,
+  0xf8, 0x50, 0xa8, 0xaa, 0x03, 0x4e, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01,
+  0x70, 0xaa, 0x01, 0x6f, 0x00, 0x02, 0x00, 0xc3, 0xff, 0x08, 0x05, 0x46,
+  0x04, 0xa8, 0x00, 0x0b, 0x00, 0x12, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21,
+  0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21, 0x01, 0x35, 0x01, 0x15,
+  0x01, 0x35, 0x01, 0x03, 0x4e, 0x87, 0x51, 0x01, 0xc1, 0xfd, 0xed, 0x78,
+  0x87, 0x51, 0xfe, 0x3f, 0x02, 0x13, 0xfd, 0xed, 0x04, 0x82, 0xfb, 0x7e,
+  0x03, 0x60, 0x01, 0xa2, 0x50, 0xa8, 0xaa, 0xf8, 0x50, 0xa8, 0xaa, 0x03,
+  0x4e, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x5f, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x36,
+  0x00, 0x3d, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
+  0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36,
+  0x17, 0x16, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x13,
+  0x09, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x3d,
+  0x4b, 0x2e, 0x7e, 0x4e, 0x4d, 0x97, 0x5e, 0x5f, 0xa1, 0x58, 0x62, 0x84,
+  0x07, 0x53, 0x94, 0x50, 0x39, 0x2b, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56,
+  0x3e, 0x4b, 0x2e, 0x7d, 0x4e, 0x4f, 0x9b, 0x58, 0x5e, 0x51, 0x62, 0x45,
+  0x84, 0x64, 0x07, 0x52, 0x93, 0x50, 0x3a, 0x2c, 0x4d, 0x97, 0x5d, 0xfc,
+  0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0x01, 0x96, 0xb2, 0x50, 0x44,
+  0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b, 0x03, 0xe9, 0x40,
+  0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82, 0x34, 0x4c, 0x52,
+  0xb2, 0x4e, 0x22, 0x2a, 0x08, 0x0e, 0x2c, 0x03, 0xe9, 0x40, 0xe3, 0x0f,
+  0x4a, 0x03, 0x5e, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01,
+  0x6f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3, 0xfe, 0x5f, 0x05, 0x46,
+  0x05, 0x4e, 0x00, 0x35, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x27, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x2f, 0x01, 0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16, 0x33,
+  0x32, 0x36, 0x01, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f,
+  0xa1, 0x58, 0x3d, 0x4b, 0x2e, 0x7e, 0x4e, 0x4d, 0x97, 0x5e, 0x5f, 0xa1,
+  0x58, 0x62, 0x84, 0x07, 0x53, 0x94, 0x50, 0x39, 0x2b, 0x4f, 0x9b, 0x58,
+  0x5e, 0xa2, 0x56, 0x3e, 0x4b, 0x2e, 0x7d, 0x4e, 0x4f, 0x9b, 0x58, 0x5e,
+  0xa2, 0x56, 0x63, 0x85, 0x07, 0x52, 0x93, 0x50, 0x3a, 0x2c, 0x4d, 0x97,
+  0xfb, 0xdb, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x01, 0x96, 0xb2, 0x50,
+  0x44, 0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b, 0x03, 0xe9,
+  0x40, 0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82, 0x34, 0x4c,
+  0x52, 0xb2, 0x4e, 0x44, 0x3a, 0x03, 0xe9, 0x40, 0xe3, 0x0f, 0x4a, 0x03,
+  0x5e, 0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xc3, 0xfd, 0x84, 0x05, 0x46, 0x06, 0x54, 0x00, 0x06,
+  0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x01, 0x15, 0x01, 0x35,
+  0x01, 0x15, 0x05, 0x01, 0x21, 0x35, 0x21, 0x01, 0x2d, 0x01, 0x35, 0x01,
+  0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0x05, 0x45, 0xfb, 0x7e, 0x04, 0x82,
+  0xfc, 0xe4, 0x03, 0x1c, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x1d,
+  0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
+  0x03, 0xfb, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xfd, 0x5c,
+  0xaa, 0xfb, 0x5e, 0xd5, 0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0x03,
+  0x7e, 0xaa, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfd, 0x84, 0x05, 0x46,
+  0x06, 0x54, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00,
+  0x13, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11, 0x35, 0x21, 0x15, 0x11,
+  0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01, 0x35, 0x21, 0x15, 0xc3, 0x03,
+  0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04,
+  0x82, 0xfc, 0xe4, 0xfe, 0x9a, 0x04, 0x82, 0x03, 0xfb, 0xd5, 0xd2, 0xb2,
+  0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xe1, 0xaa, 0xaa, 0xfc, 0x08, 0xb0,
+  0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0x01, 0xf9, 0xaa, 0xaa, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0xff, 0x02, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x1a,
+  0x00, 0x1e, 0x00, 0x25, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
+  0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15, 0x21,
+  0x09, 0x02, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x63,
+  0x83, 0x0f, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56,
+  0x63, 0x85, 0x0d, 0x14, 0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdc, 0x04, 0x82,
+  0xfb, 0x7e, 0x04, 0x81, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82,
+  0x01, 0x96, 0xb2, 0x50, 0x44, 0x3a, 0x08, 0x02, 0x06, 0x3c, 0x4b, 0x53,
+  0xb2, 0x4e, 0x44, 0x3a, 0x06, 0x0a, 0x3c, 0x4a, 0xfe, 0x6c, 0xaa, 0x05,
+  0x9c, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0xff, 0x02, 0x05, 0x46, 0x05, 0x4e, 0x00, 0x1a,
+  0x00, 0x1e, 0x00, 0x25, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22,
+  0x2f, 0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
+  0x33, 0x32, 0x1f, 0x02, 0x16, 0x33, 0x32, 0x36, 0x01, 0x21, 0x15, 0x21,
+  0x03, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x46, 0x5f, 0xa1, 0x58,
+  0x63, 0x83, 0x0f, 0x05, 0x0e, 0x8b, 0x55, 0x4f, 0x9b, 0x58, 0x5e, 0xa2,
+  0x56, 0x63, 0x85, 0x0d, 0x14, 0x8c, 0x55, 0x4d, 0x97, 0xfb, 0xdc, 0x04,
+  0x82, 0xfb, 0x7e, 0x01, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0x01, 0x96,
+  0xb2, 0x50, 0x44, 0x3a, 0x08, 0x02, 0x06, 0x3c, 0x4b, 0x53, 0xb2, 0x4e,
+  0x44, 0x3a, 0x06, 0x0a, 0x3c, 0x4a, 0xfe, 0x6c, 0xaa, 0x05, 0x9c, 0xb0,
+  0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x03, 0x00, 0xc3,
+  0xfe, 0x12, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x1a, 0x00, 0x21, 0x00, 0x28,
+  0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27,
+  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02,
+  0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01,
+  0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63,
+  0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57,
+  0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0xfb, 0x7e, 0x04,
+  0x82, 0xfc, 0xe4, 0xfe, 0x9a, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb,
+  0x7e, 0x02, 0xbe, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d, 0x4c,
+  0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x09, 0x3d, 0x4b, 0x01, 0x4a, 0xb0,
+  0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xfa, 0x3a, 0xd5, 0xd2, 0xb2,
+  0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0xfe, 0x12, 0x05, 0x46, 0x06, 0x0c, 0x00, 0x1a, 0x00, 0x21, 0x00, 0x28,
+  0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01, 0x26, 0x27,
+  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x1f, 0x02,
+  0x16, 0x33, 0x32, 0x36, 0x01, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01,
+  0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63,
+  0x83, 0x10, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57,
+  0x63, 0x85, 0x0d, 0x14, 0x8b, 0x55, 0x4d, 0x98, 0xfb, 0xdb, 0x03, 0x1d,
+  0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
+  0xfc, 0xe4, 0x02, 0xbe, 0xb2, 0x4f, 0x45, 0x3b, 0x07, 0x02, 0x06, 0x3d,
+  0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x06, 0x09, 0x3d, 0x4b, 0x01, 0x4a,
+  0xd5, 0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfb, 0xbf, 0xb0, 0x01,
+  0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3,
+  0xfe, 0x2c, 0x05, 0x46, 0x05, 0xd7, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11,
+  0x00, 0x15, 0x00, 0x00, 0x13, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11,
+  0x35, 0x21, 0x15, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01, 0x35,
+  0x21, 0x15, 0xc3, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04,
+  0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xe4, 0xfe, 0x9a, 0x04, 0x82, 0x01,
+  0x25, 0xd5, 0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xe1, 0xaa,
+  0xaa, 0x04, 0x28, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xf9,
+  0xd9, 0xaa, 0xaa, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x2c, 0x05, 0x46,
+  0x05, 0xd7, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00,
+  0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x01, 0x21, 0x35, 0x21, 0x01,
+  0x2d, 0x01, 0x35, 0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21, 0x05, 0x45,
+  0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xe4, 0x03, 0x1c, 0xfb, 0x7e, 0x04, 0x82,
+  0xfb, 0x7e, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
+  0xfb, 0x7e, 0x04, 0x82, 0x01, 0x25, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30,
+  0xb2, 0xd2, 0xfd, 0x5c, 0xaa, 0x03, 0x7e, 0xd5, 0xd2, 0xb2, 0xfe, 0xd0,
+  0xaa, 0xfe, 0xd1, 0xfb, 0x5e, 0xaa, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3,
+  0xfe, 0x36, 0x05, 0x46, 0x05, 0xee, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x09,
+  0x01, 0x35, 0x09, 0x01, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11, 0x35,
+  0x01, 0x15, 0x05, 0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0xe4, 0x03, 0x1c,
+  0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x1d, 0xfc, 0xe3, 0x04, 0x82,
+  0xfb, 0x7e, 0x04, 0x82, 0x03, 0x95, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30,
+  0xb2, 0xd2, 0xfd, 0x56, 0x01, 0x2f, 0xb0, 0xfe, 0xd1, 0xfd, 0xa6, 0xd5,
+  0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xd0, 0xb0, 0x01, 0x2f,
+  0xb0, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x36, 0x05, 0x46,
+  0x05, 0xee, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00,
+  0x13, 0x2d, 0x01, 0x35, 0x01, 0x15, 0x01, 0x11, 0x35, 0x01, 0x15, 0x11,
+  0x15, 0x01, 0x35, 0x01, 0x15, 0x05, 0x09, 0x01, 0x35, 0x01, 0xc3, 0x03,
+  0x1d, 0xfc, 0xe3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04,
+  0x82, 0xfc, 0xe4, 0x03, 0x1c, 0xfb, 0x7e, 0x04, 0x82, 0x03, 0x95, 0xd5,
+  0xd2, 0xb2, 0xfe, 0xd0, 0xaa, 0xfe, 0xd1, 0xfe, 0xdb, 0xb0, 0x01, 0x2f,
+  0xb0, 0xfd, 0x27, 0xb0, 0x01, 0x2f, 0xaa, 0x01, 0x30, 0xb2, 0xd2, 0xfd,
+  0x4b, 0x01, 0x2f, 0xb0, 0xfe, 0xd1, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x84, 0x05, 0x46, 0x05, 0x26, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
+  0x09, 0x01, 0x35, 0x01, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15, 0x01, 0x05,
+  0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfc, 0x5f, 0x04,
+  0x70, 0xfe, 0x2f, 0xb6, 0x01, 0xd1, 0xfb, 0x14, 0xb6, 0x01, 0xd1, 0xa6,
+  0x01, 0xd1, 0xb6, 0xfe, 0x93, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc3,
+  0xff, 0x84, 0x05, 0x46, 0x05, 0x26, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
+  0x13, 0x35, 0x01, 0x15, 0x09, 0x02, 0x35, 0x01, 0x15, 0x01, 0xc3, 0x04,
+  0x82, 0xfb, 0x7e, 0x03, 0xa1, 0xfc, 0x5f, 0x04, 0x82, 0xfb, 0x7e, 0x04,
+  0x70, 0xb6, 0xfe, 0x2f, 0xb6, 0xfd, 0x9b, 0x01, 0x6f, 0x01, 0x6d, 0xb6,
+  0xfe, 0x2f, 0xa6, 0xfe, 0x2f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3,
+  0xff, 0x84, 0x05, 0x47, 0x05, 0x26, 0x10, 0x27, 0x09, 0xa1, 0x03, 0xc4,
+  0xfe, 0xee, 0x10, 0x06, 0x0d, 0xed, 0x00, 0x00, 0xff, 0xff, 0x00, 0xc3,
+  0xff, 0x84, 0x05, 0x46, 0x05, 0x26, 0x10, 0x27, 0x09, 0xa1, 0xff, 0xfe,
+  0xfe, 0xe4, 0x10, 0x06, 0x0d, 0xee, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4,
+  0xff, 0xb6, 0x05, 0x46, 0x05, 0x7b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e,
+  0x00, 0x00, 0x13, 0x35, 0x21, 0x15, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15,
+  0x09, 0x01, 0x35, 0x21, 0x15, 0xc4, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
+  0xfc, 0xa0, 0xfe, 0xde, 0x04, 0x82, 0x04, 0xd1, 0xaa, 0xaa, 0xfb, 0x95,
+  0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x02, 0x39, 0xaa,
+  0xaa, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc4, 0xff, 0xb6, 0x05, 0x46,
+  0x05, 0x7b, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x21,
+  0x35, 0x21, 0x09, 0x02, 0x35, 0x01, 0x15, 0x09, 0x01, 0x21, 0x35, 0x21,
+  0x05, 0x46, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0xfc, 0xa0,
+  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0x04, 0xd1,
+  0xaa, 0xfa, 0xeb, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe,
+  0x91, 0x03, 0xfe, 0xaa, 0x00, 0x03, 0x00, 0xc3, 0xff, 0xc0, 0x05, 0x46,
+  0x05, 0xcd, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x35,
+  0x01, 0x15, 0x01, 0x35, 0x01, 0x15, 0x11, 0x15, 0x01, 0x35, 0x01, 0x15,
+  0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82,
+  0xfc, 0xa0, 0x03, 0xab, 0xb2, 0x01, 0x70, 0xb2, 0xfd, 0x4e, 0xb2, 0x01,
+  0x70, 0xb2, 0xfc, 0x97, 0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe,
+  0xee, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0xff, 0xc0, 0x05, 0x46,
+  0x05, 0xcd, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01,
+  0x35, 0x01, 0x11, 0x01, 0x35, 0x09, 0x03, 0x35, 0x01, 0x15, 0x01, 0x05,
+  0x45, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03,
+  0x60, 0xfc, 0xa0, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0xab, 0x01, 0x70, 0xb2,
+  0xfe, 0x90, 0xfe, 0x0c, 0x01, 0x70, 0xb2, 0xfe, 0x90, 0xfd, 0x55, 0x01,
+  0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe, 0x91, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x11, 0x05, 0x46, 0x05, 0x28, 0x00, 0x1b,
+  0x00, 0x22, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37,
+  0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x03, 0x15, 0x01, 0x35,
+  0x01, 0x15, 0x01, 0x05, 0x46, 0x5e, 0x97, 0x4d, 0x55, 0x8c, 0x0d, 0x0b,
+  0x09, 0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b, 0x0e,
+  0x0b, 0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0x01, 0xfb, 0x7e, 0x04, 0x82,
+  0xfc, 0xa0, 0x03, 0xca, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04, 0x3c, 0x46,
+  0x4e, 0xb2, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04, 0x3c, 0x46, 0x4e, 0xfc,
+  0x45, 0xb0, 0x01, 0x6f, 0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0x00, 0x30, 0x05, 0x46, 0x05, 0x28, 0x00, 0x1b,
+  0x00, 0x22, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37,
+  0x3e, 0x01, 0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x09, 0x02, 0x35, 0x01,
+  0x15, 0x01, 0x05, 0x46, 0x5e, 0x97, 0x4d, 0x55, 0x8c, 0x0d, 0x0b, 0x09,
+  0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b, 0x0e, 0x0b,
+  0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0xfb, 0x7d, 0x03, 0x61, 0xfc, 0x9f,
+  0x04, 0x82, 0xfb, 0x7e, 0x03, 0xca, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04,
+  0x3c, 0x46, 0x4e, 0xb2, 0x54, 0x4c, 0x3e, 0x06, 0x04, 0x04, 0x3c, 0x46,
+  0x4e, 0xfc, 0x64, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe,
+  0x91, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3, 0xfe, 0x98, 0x05, 0x46,
+  0x05, 0xd4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x24, 0x00, 0x2b, 0x00, 0x00,
+  0x17, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x13, 0x2e, 0x01, 0x23,
+  0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e,
+  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16,
+  0x17, 0x03, 0x15, 0x01, 0x35, 0x01, 0x15, 0x01, 0xc3, 0x04, 0x82, 0xfb,
+  0x7e, 0x04, 0x82, 0x01, 0x5e, 0x97, 0x4d, 0x55, 0x8c, 0x0d, 0x0b, 0x09,
+  0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55, 0x8b, 0x0e, 0x05,
+  0x06, 0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0x01, 0xfb, 0x7e, 0x04, 0x82,
+  0xfc, 0xa0, 0x3e, 0xaa, 0xaa, 0xfe, 0xd6, 0xaa, 0xaa, 0x05, 0xdc, 0x56,
+  0x4a, 0x3c, 0x06, 0x04, 0x06, 0x3a, 0x44, 0x4e, 0xb4, 0x54, 0x4c, 0x3c,
+  0x06, 0x02, 0x04, 0x04, 0x3a, 0x44, 0x4e, 0xfc, 0x44, 0xb0, 0x01, 0x6f,
+  0xaa, 0x01, 0x70, 0xb2, 0xfe, 0xee, 0x00, 0x00, 0x00, 0x04, 0x00, 0xc3,
+  0xfe, 0x98, 0x05, 0x46, 0x05, 0xd4, 0x00, 0x03, 0x00, 0x07, 0x00, 0x24,
+  0x00, 0x2b, 0x00, 0x00, 0x17, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
+  0x13, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x16, 0x17, 0x09, 0x02, 0x35, 0x01, 0x15, 0x01, 0xc3,
+  0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0x01, 0x5e, 0x97, 0x4d, 0x55, 0x8c,
+  0x0d, 0x0b, 0x09, 0x85, 0x63, 0x56, 0xa2, 0x5e, 0x58, 0x9b, 0x4f, 0x55,
+  0x8b, 0x0e, 0x05, 0x06, 0x09, 0x83, 0x63, 0x58, 0xa1, 0x5f, 0xfb, 0x7d,
+  0x03, 0x60, 0xfc, 0xa0, 0x04, 0x82, 0xfb, 0x7e, 0x3e, 0xaa, 0xaa, 0xfe,
+  0xd6, 0xaa, 0xaa, 0x05, 0xdc, 0x56, 0x4a, 0x3c, 0x06, 0x04, 0x06, 0x3a,
+  0x44, 0x4e, 0xb4, 0x54, 0x4c, 0x3c, 0x06, 0x02, 0x04, 0x04, 0x3a, 0x44,
+  0x4e, 0xfc, 0x44, 0x01, 0x15, 0x01, 0x12, 0xb2, 0xfe, 0x90, 0xaa, 0xfe,
+  0x91, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3, 0x00, 0x66, 0x05, 0x46,
+  0x04, 0xce, 0x00, 0x03, 0x00, 0x20, 0x00, 0x24, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x21, 0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x21, 0x35, 0x33,
+  0x36, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x33,
+  0x15, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x15, 0x21, 0xc3,
+  0x04, 0x82, 0xfb, 0x7e, 0x02, 0x42, 0x3c, 0x2a, 0x32, 0x1b, 0x18, 0x04,
+  0xfe, 0x8d, 0xf0, 0x0b, 0x1a, 0x31, 0x4e, 0x51, 0xb9, 0x50, 0x4d, 0x32,
+  0x19, 0x0d, 0xef, 0xfe, 0x8e, 0x03, 0x19, 0x1b, 0x32, 0x29, 0xfd, 0x82,
+  0x04, 0x82, 0xfb, 0x7e, 0x02, 0x5a, 0xaa, 0x02, 0x7b, 0x04, 0x1e, 0x2b,
+  0x44, 0x44, 0x5c, 0xa8, 0x39, 0x33, 0x5b, 0x32, 0x33, 0x33, 0x32, 0x5b,
+  0x30, 0x3c, 0xa8, 0x5b, 0x45, 0x43, 0x2c, 0x1e, 0xfc, 0xe9, 0xaa, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0xcf, 0x05, 0x46, 0x05, 0x57, 0x00, 0x03,
+  0x00, 0x0e, 0x00, 0x00, 0x37, 0x21, 0x15, 0x21, 0x01, 0x00, 0x05, 0x04,
+  0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e,
+  0x04, 0x82, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59, 0xfe, 0xa7,
+  0xfc, 0xd7, 0x03, 0x29, 0x01, 0x59, 0x79, 0xaa, 0x04, 0xb1, 0xfe, 0xe5,
+  0x5d, 0x5d, 0xfe, 0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01, 0x80,
+  0x00, 0x02, 0x00, 0xc3, 0xff, 0xcf, 0x05, 0x46, 0x05, 0x57, 0x00, 0x03,
+  0x00, 0x0f, 0x00, 0x00, 0x25, 0x15, 0x21, 0x35, 0x11, 0x35, 0x00, 0x05,
+  0x30, 0x15, 0x04, 0x01, 0x35, 0x00, 0x25, 0x24, 0x05, 0x45, 0xfb, 0x7e,
+  0x01, 0x59, 0x03, 0x29, 0xfc, 0xd7, 0xfe, 0xa7, 0x01, 0x59, 0x01, 0xac,
+  0xfe, 0x54, 0x79, 0xaa, 0xaa, 0x04, 0x07, 0xd7, 0xfe, 0x80, 0x7c, 0xa6,
+  0x84, 0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x02, 0x00, 0xc3,
+  0xfe, 0xd7, 0x05, 0x46, 0x05, 0x57, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x00,
+  0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27, 0x37, 0x21, 0x35, 0x21,
+  0x01, 0x00, 0x05, 0x04, 0x01, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x03,
+  0x4e, 0x87, 0x51, 0x01, 0xc1, 0xfd, 0xed, 0x78, 0x87, 0x51, 0xfe, 0x3f,
+  0x02, 0x13, 0x02, 0x6f, 0xfe, 0xa7, 0xfe, 0x54, 0x01, 0xac, 0x01, 0x59,
+  0xfe, 0xa7, 0xfc, 0xd7, 0x03, 0x29, 0x01, 0x59, 0x01, 0x71, 0x50, 0xa8,
+  0xaa, 0xf8, 0x50, 0xa8, 0xaa, 0x04, 0x07, 0xfe, 0xe5, 0x5d, 0x5d, 0xfe,
+  0xe5, 0xd7, 0x01, 0x78, 0x84, 0xa6, 0x7c, 0x01, 0x80, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0xd7, 0x05, 0x46, 0x05, 0x57, 0x00, 0x0b,
+  0x00, 0x16, 0x00, 0x00, 0x01, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
+  0x37, 0x21, 0x35, 0x21, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35,
+  0x00, 0x25, 0x24, 0x03, 0x4e, 0x87, 0x51, 0x01, 0xc1, 0xfd, 0xed, 0x78,
+  0x87, 0x51, 0xfe, 0x3f, 0x02, 0x13, 0xfd, 0xed, 0x01, 0x59, 0x03, 0x29,
+  0xfc, 0xd7, 0xfe, 0xa7, 0x01, 0x59, 0x01, 0xac, 0xfe, 0x54, 0x01, 0x71,
+  0x50, 0xa8, 0xaa, 0xf8, 0x50, 0xa8, 0xaa, 0x04, 0x07, 0xd7, 0xfe, 0x80,
+  0x7c, 0xa6, 0x84, 0xfe, 0x88, 0xd7, 0x01, 0x1b, 0x5d, 0x5d, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0xff, 0x09, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x12, 0x00, 0x00, 0x37, 0x35, 0x21, 0x15, 0x01, 0x35,
+  0x21, 0x15, 0x11, 0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24,
+  0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfe, 0xec, 0xfe, 0x0f,
+  0x01, 0xea, 0x01, 0x1b, 0xfe, 0xc6, 0xfc, 0xb8, 0x03, 0x48, 0x01, 0x3a,
+  0x33, 0xaa, 0xaa, 0xfe, 0xd6, 0xaa, 0xaa, 0x05, 0x6b, 0xfe, 0xe5, 0x2d,
+  0x51, 0xf7, 0xd7, 0x01, 0x74, 0x58, 0xa6, 0x56, 0x01, 0x76, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0xff, 0x09, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x12, 0x00, 0x00, 0x37, 0x35, 0x21, 0x15, 0x01, 0x35,
+  0x21, 0x15, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x24, 0x25,
+  0x24, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x01, 0x3a,
+  0x03, 0x48, 0xfc, 0xb8, 0xfe, 0xc6, 0x01, 0x1b, 0x01, 0xea, 0xfe, 0x10,
+  0x33, 0xaa, 0xaa, 0xfe, 0xd6, 0xaa, 0xaa, 0x05, 0x6b, 0xd7, 0xfe, 0x8a,
+  0x56, 0xa6, 0x58, 0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x71, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x13,
+  0x00, 0x1e, 0x00, 0x00, 0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21,
+  0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
+  0x01, 0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x01,
+  0xef, 0xfe, 0xd4, 0x01, 0xab, 0x56, 0xfd, 0xff, 0x02, 0x81, 0x7b, 0x7d,
+  0x25, 0x01, 0x2e, 0xfe, 0x52, 0x56, 0x02, 0x04, 0xfd, 0x7d, 0x7c, 0x7c,
+  0x03, 0x7b, 0xfe, 0xec, 0xfe, 0x0f, 0x01, 0xea, 0x01, 0x1b, 0xfe, 0xc6,
+  0xfc, 0xb8, 0x03, 0x48, 0x01, 0x3a, 0xea, 0xaa, 0x73, 0xaa, 0xa4, 0x73,
+  0x31, 0xaa, 0x73, 0xaa, 0xa5, 0x74, 0x05, 0x8f, 0xfe, 0xe5, 0x2d, 0x51,
+  0xf7, 0xd7, 0x01, 0x74, 0x58, 0xa6, 0x56, 0x01, 0x76, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfe, 0x71, 0x05, 0x46, 0x05, 0x4b, 0x00, 0x13,
+  0x00, 0x1e, 0x00, 0x00, 0x05, 0x21, 0x35, 0x21, 0x37, 0x21, 0x35, 0x21,
+  0x37, 0x17, 0x07, 0x21, 0x15, 0x21, 0x07, 0x21, 0x15, 0x21, 0x07, 0x27,
+  0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x24, 0x25, 0x24, 0x01,
+  0xef, 0xfe, 0xd4, 0x01, 0xab, 0x56, 0xfd, 0xff, 0x02, 0x81, 0x7b, 0x7d,
+  0x25, 0x01, 0x2e, 0xfe, 0x52, 0x56, 0x02, 0x04, 0xfd, 0x7d, 0x7c, 0x7c,
+  0xfe, 0xf9, 0x01, 0x3a, 0x03, 0x48, 0xfc, 0xb8, 0xfe, 0xc6, 0x01, 0x1b,
+  0x01, 0xea, 0xfe, 0x10, 0xea, 0xaa, 0x73, 0xaa, 0xa4, 0x73, 0x31, 0xaa,
+  0x73, 0xaa, 0xa5, 0x74, 0x05, 0x8f, 0xd7, 0xfe, 0x8a, 0x56, 0xa6, 0x58,
+  0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0xfe, 0x79, 0x05, 0x46, 0x05, 0x8b, 0x00, 0x1d, 0x00, 0x3a, 0x00, 0x45,
+  0x00, 0x00, 0x05, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x37, 0x36, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3e,
+  0x01, 0x13, 0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01,
+  0x05, 0x45, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c,
+  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa0, 0x58, 0x57, 0x91, 0x09, 0x05, 0x05,
+  0x0e, 0x8b, 0x55, 0x4d, 0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09,
+  0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63,
+  0x85, 0x08, 0x05, 0x06, 0x0e, 0x99, 0x8e, 0x9e, 0x5d, 0xfe, 0xec, 0xfe,
+  0x0f, 0x01, 0xea, 0x01, 0x1b, 0xfe, 0xc6, 0xfc, 0xb8, 0x03, 0x48, 0x01,
+  0x3a, 0x28, 0xb3, 0x4e, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c,
+  0x54, 0xb3, 0x4e, 0x39, 0x0c, 0x06, 0x41, 0x05, 0x02, 0x02, 0x06, 0x3d,
+  0x4b, 0x01, 0x9a, 0xb2, 0x4f, 0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d,
+  0x4c, 0x53, 0xb2, 0x4e, 0x45, 0x3b, 0x04, 0x02, 0x03, 0x06, 0x43, 0x0c,
+  0x45, 0x03, 0xec, 0xfe, 0xe5, 0x2d, 0x51, 0xf7, 0xd7, 0x01, 0x74, 0x58,
+  0xa6, 0x56, 0x01, 0x76, 0x00, 0x03, 0x00, 0xc3, 0xfe, 0x79, 0x05, 0x46,
+  0x05, 0x8b, 0x00, 0x1d, 0x00, 0x3a, 0x00, 0x45, 0x00, 0x00, 0x05, 0x15,
+  0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x37, 0x36, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x33, 0x32, 0x36, 0x13, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3e, 0x01, 0x01, 0x35, 0x00,
+  0x05, 0x15, 0x04, 0x01, 0x35, 0x24, 0x25, 0x24, 0x05, 0x45, 0x5e, 0xa1,
+  0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c, 0x54, 0x50, 0x9a, 0x59,
+  0x5f, 0xa0, 0x58, 0x57, 0x91, 0x09, 0x05, 0x05, 0x0e, 0x8b, 0x55, 0x4d,
+  0x98, 0x5d, 0x5e, 0xa1, 0x58, 0x63, 0x83, 0x09, 0x07, 0x05, 0x0d, 0x8c,
+  0x54, 0x50, 0x9a, 0x59, 0x5f, 0xa1, 0x57, 0x63, 0x85, 0x08, 0x05, 0x06,
+  0x0e, 0x99, 0x8e, 0x9e, 0xfb, 0xdb, 0x01, 0x3a, 0x03, 0x48, 0xfc, 0xb8,
+  0xfe, 0xc6, 0x01, 0x1b, 0x01, 0xea, 0xfe, 0x10, 0x28, 0xb3, 0x4e, 0x45,
+  0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x54, 0xb3, 0x4e, 0x39, 0x0c,
+  0x06, 0x41, 0x05, 0x02, 0x02, 0x06, 0x3d, 0x4b, 0x01, 0x9a, 0xb2, 0x4f,
+  0x45, 0x3b, 0x04, 0x03, 0x02, 0x06, 0x3d, 0x4c, 0x53, 0xb2, 0x4e, 0x45,
+  0x3b, 0x04, 0x02, 0x03, 0x06, 0x43, 0x0c, 0x45, 0x03, 0xec, 0xd7, 0xfe,
+  0x8a, 0x56, 0xa6, 0x58, 0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc3, 0xfd, 0xed, 0x05, 0x46, 0x05, 0x8b, 0x00, 0x36,
+  0x00, 0x41, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x07,
+  0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x2f, 0x01,
+  0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x36, 0x37, 0x36,
+  0x17, 0x16, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16, 0x33, 0x32, 0x36, 0x13,
+  0x00, 0x05, 0x04, 0x05, 0x15, 0x00, 0x25, 0x35, 0x24, 0x01, 0x05, 0x46,
+  0x5f, 0xa1, 0x58, 0x3d, 0x4b, 0x2e, 0x7e, 0x4e, 0x4d, 0x97, 0x5e, 0x5f,
+  0xa1, 0x58, 0x62, 0x84, 0x07, 0x53, 0x94, 0x50, 0x39, 0x2b, 0x4f, 0x9b,
+  0x58, 0x5e, 0xa2, 0x56, 0x3e, 0x4b, 0x2e, 0x7d, 0x4e, 0x4f, 0x9b, 0x58,
+  0x5e, 0x51, 0x62, 0x45, 0x84, 0x64, 0x07, 0x52, 0x93, 0x50, 0x3a, 0x2c,
+  0x4d, 0x97, 0x5d, 0xfe, 0xec, 0xfe, 0x0f, 0x01, 0xea, 0x01, 0x1b, 0xfe,
+  0xc6, 0xfc, 0xb8, 0x03, 0x48, 0x01, 0x3a, 0x01, 0x24, 0xb2, 0x50, 0x44,
+  0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b, 0x03, 0xe9, 0x40,
+  0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82, 0x34, 0x4c, 0x52,
+  0xb2, 0x4e, 0x22, 0x2a, 0x08, 0x0e, 0x2c, 0x03, 0xe9, 0x40, 0xe3, 0x0f,
+  0x4a, 0x03, 0xe6, 0xfe, 0xe5, 0x2d, 0x51, 0xf7, 0xd7, 0x01, 0x74, 0x58,
+  0xa6, 0x56, 0x01, 0x76, 0x00, 0x02, 0x00, 0xc3, 0xfd, 0xed, 0x05, 0x46,
+  0x05, 0x8b, 0x00, 0x36, 0x00, 0x41, 0x00, 0x00, 0x01, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x27, 0x07, 0x16, 0x33, 0x32, 0x36, 0x37, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x2f, 0x01, 0x07, 0x27, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x37, 0x26, 0x23, 0x22, 0x06, 0x07,
+  0x35, 0x36, 0x37, 0x36, 0x17, 0x16, 0x1f, 0x01, 0x37, 0x17, 0x07, 0x16,
+  0x33, 0x32, 0x36, 0x01, 0x35, 0x00, 0x05, 0x15, 0x04, 0x01, 0x35, 0x24,
+  0x25, 0x24, 0x05, 0x46, 0x5f, 0xa1, 0x58, 0x3d, 0x4b, 0x2e, 0x7e, 0x4e,
+  0x4d, 0x97, 0x5e, 0x5f, 0xa1, 0x58, 0x62, 0x84, 0x07, 0x53, 0x94, 0x50,
+  0x39, 0x2b, 0x4f, 0x9b, 0x58, 0x5e, 0xa2, 0x56, 0x3e, 0x4b, 0x2e, 0x7d,
+  0x4e, 0x4f, 0x9b, 0x58, 0x5e, 0x51, 0x62, 0x45, 0x84, 0x64, 0x07, 0x52,
+  0x93, 0x50, 0x3a, 0x2c, 0x4d, 0x97, 0xfb, 0xdb, 0x01, 0x3a, 0x03, 0x48,
+  0xfc, 0xb8, 0xfe, 0xc6, 0x01, 0x1b, 0x01, 0xea, 0xfe, 0x10, 0x01, 0x24,
+  0xb2, 0x50, 0x44, 0x17, 0x83, 0x34, 0x4b, 0x55, 0xb3, 0x4e, 0x45, 0x3b,
+  0x03, 0xe9, 0x40, 0xe2, 0x10, 0x4c, 0x54, 0xb3, 0x4e, 0x45, 0x17, 0x82,
+  0x34, 0x4c, 0x52, 0xb2, 0x4e, 0x22, 0x2a, 0x08, 0x0e, 0x2c, 0x03, 0xe9,
+  0x40, 0xe3, 0x0f, 0x4a, 0x03, 0xe6, 0xd7, 0xfe, 0x8a, 0x56, 0xa6, 0x58,
+  0xfe, 0x8c, 0xd7, 0xf7, 0x51, 0x2d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xc3,
+  0xfe, 0xa1, 0x05, 0x46, 0x04, 0xae, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0e,
+  0x00, 0x00, 0x37, 0x01, 0x15, 0x01, 0x11, 0x01, 0x15, 0x09, 0x03, 0x15,
+  0x01, 0x35, 0x01, 0xc3, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e,
+  0x04, 0x82, 0xfc, 0xa0, 0x03, 0x60, 0xfb, 0x7e, 0x04, 0x82, 0xc3, 0xfe,
+  0x90, 0xb2, 0x01, 0x70, 0x01, 0xf4, 0xfe, 0x90, 0xb2, 0x01, 0x70, 0x02,
+  0xab, 0xfe, 0xeb, 0xfe, 0xee, 0xb2, 0x01, 0x70, 0xaa, 0x01, 0x6f, 0x00,
+  0x00, 0x03, 0x00, 0xc3, 0xfe, 0xa1, 0x05, 0x46, 0x04, 0xae, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0e, 0x00, 0x00, 0x25, 0x15, 0x01, 0x35, 0x01, 0x15,
+  0x01, 0x35, 0x11, 0x35, 0x01, 0x15, 0x01, 0x35, 0x01, 0x05, 0x45, 0xfb,
+  0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x04, 0x82, 0xfb, 0x7e, 0x03, 0x60, 0xc3,
+  0xb2, 0xfe, 0x90, 0xb2, 0x02, 0xb2, 0xb2, 0xfe, 0x90, 0xb2, 0x03, 0x69,
+  0xb0, 0xfe, 0x91, 0xaa, 0xfe, 0x90, 0xb2, 0x01, 0x12, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa2, 0xff, 0xc9, 0x05, 0x10, 0x04, 0xb3, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x01, 0x17, 0x01, 0x17, 0x01, 0x17, 0x11, 0x13,
+  0x27, 0x09, 0x02, 0x27, 0x21, 0x03, 0x62, 0x54, 0xfd, 0x6c, 0xac, 0x02,
+  0x93, 0x53, 0x5b, 0xae, 0xfd, 0x6d, 0xfe, 0xd5, 0x02, 0x94, 0xaf, 0x02,
+  0x87, 0x04, 0x4e, 0x5c, 0xfd, 0x23, 0xbf, 0x02, 0xdd, 0x5d, 0x01, 0x78,
+  0xfd, 0x96, 0xc2, 0xfd, 0x23, 0x01, 0x4c, 0x02, 0xdd, 0xc1, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x03, 0xff, 0xc9, 0x05, 0x70, 0x04, 0xb3, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x37, 0x01, 0x37, 0x09, 0x01,
+  0x11, 0x21, 0x07, 0x09, 0x02, 0x02, 0xb0, 0xfe, 0xae, 0x53, 0x02, 0x94,
+  0xab, 0xfd, 0x6d, 0xfe, 0xa6, 0x02, 0x87, 0xae, 0x02, 0x93, 0xfe, 0xd6,
+  0xfd, 0x6c, 0x04, 0x4e, 0xfe, 0x88, 0x5d, 0xfd, 0x23, 0xbf, 0x02, 0xdd,
+  0xfd, 0xf2, 0x02, 0xcf, 0xc1, 0xfd, 0x23, 0xfe, 0xb4, 0x02, 0xdd, 0x00,
+  0x00, 0x02, 0x00, 0xa2, 0x00, 0x34, 0x05, 0x10, 0x05, 0x1e, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x01, 0x07, 0x01, 0x07, 0x01, 0x07, 0x21, 0x05,
+  0x37, 0x09, 0x02, 0x37, 0x11, 0x04, 0xb4, 0x53, 0xfd, 0x6d, 0xac, 0x02,
+  0x94, 0x54, 0x01, 0x52, 0xfd, 0xd4, 0xaf, 0xfd, 0x6c, 0x01, 0x2b, 0x02,
+  0x93, 0xae, 0x02, 0x11, 0x5d, 0x02, 0xdd, 0xbf, 0xfd, 0x23, 0x5c, 0x65,
+  0xc1, 0x02, 0xdd, 0x01, 0x4c, 0xfd, 0x23, 0xc2, 0xfd, 0x31, 0x00, 0x00,
+  0x00, 0x02, 0x01, 0x03, 0x00, 0x34, 0x05, 0x70, 0x05, 0x1e, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x00, 0x25, 0x27, 0x01, 0x27, 0x01, 0x27, 0x11, 0x03,
+  0x17, 0x09, 0x02, 0x17, 0x21, 0x02, 0xb0, 0x53, 0x02, 0x93, 0xab, 0xfd,
+  0x6c, 0x53, 0x5b, 0xae, 0x02, 0x94, 0x01, 0x2a, 0xfd, 0x6d, 0xae, 0xfd,
+  0x79, 0x99, 0x5c, 0x02, 0xdd, 0xbf, 0xfd, 0x23, 0x5d, 0xfe, 0x88, 0x02,
+  0x6a, 0xc2, 0x02, 0xdd, 0xfe, 0xb4, 0xfd, 0x23, 0xc1, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x31, 0x00, 0x86, 0x05, 0xaf, 0x04, 0x7e, 0x00, 0x09,
+  0x00, 0x13, 0x00, 0x00, 0x25, 0x09, 0x01, 0x11, 0x21, 0x11, 0x09, 0x01,
+  0x11, 0x21, 0x01, 0x15, 0x21, 0x35, 0x03, 0x13, 0x35, 0x21, 0x15, 0x13,
+  0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9, 0x01, 0xea, 0x01, 0xc9, 0xfe, 0x37,
+  0xfe, 0x16, 0x02, 0x44, 0xfd, 0x62, 0xf0, 0xf0, 0x02, 0x9e, 0xf0, 0x86,
+  0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0x01, 0x11, 0xfe, 0x04, 0xfe, 0x04,
+  0x01, 0x11, 0x01, 0xf5, 0x83, 0x83, 0xfe, 0xf6, 0xfe, 0xf6, 0x83, 0x83,
+  0x01, 0x0a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x31, 0x00, 0x86, 0x05, 0xa0,
+  0x04, 0x7e, 0x00, 0x06, 0x00, 0x00, 0x25, 0x09, 0x01, 0x11, 0x21, 0x11,
+  0x21, 0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9, 0x03, 0xa4, 0xfc, 0x5c, 0x86,
+  0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0xfe, 0x2a, 0x00, 0x01, 0x01, 0x3b,
+  0x00, 0x00, 0x04, 0xce, 0x06, 0x08, 0x00, 0x06, 0x00, 0x00, 0x09, 0x02,
+  0x23, 0x11, 0x21, 0x11, 0x01, 0x3b, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0xfe,
+  0x59, 0x04, 0x0c, 0x01, 0xfc, 0xfe, 0x04, 0xfb, 0xf4, 0x04, 0x0c, 0x00,
+  0x00, 0x01, 0x01, 0x3b, 0xff, 0xcd, 0x04, 0xce, 0x05, 0xd5, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x33, 0x11, 0x21, 0x11, 0x33, 0x01, 0x01, 0x3b, 0xf6,
+  0x01, 0xa7, 0xf5, 0xfe, 0x37, 0x01, 0xc9, 0x04, 0x0c, 0xfb, 0xf4, 0xfe,
+  0x04, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa2, 0xff, 0xc9, 0x05, 0x10,
+  0x04, 0xb3, 0x00, 0x06, 0x00, 0x00, 0x01, 0x27, 0x09, 0x02, 0x27, 0x21,
+  0x05, 0x0f, 0xae, 0xfd, 0x6d, 0xfe, 0xd5, 0x02, 0x94, 0xaf, 0x02, 0x87,
+  0x01, 0xe4, 0xc2, 0xfd, 0x23, 0x01, 0x4c, 0x02, 0xdd, 0xc1, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x03, 0xff, 0xc9, 0x05, 0x70, 0x04, 0xb3, 0x00, 0x06,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x07, 0x09, 0x02, 0x01, 0x03, 0x02, 0x87,
+  0xae, 0x02, 0x93, 0xfe, 0xd6, 0xfd, 0x6c, 0x01, 0xe4, 0x02, 0xcf, 0xc1,
+  0xfd, 0x23, 0xfe, 0xb4, 0x02, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa2,
+  0x00, 0x34, 0x05, 0x10, 0x05, 0x1e, 0x00, 0x06, 0x00, 0x00, 0x25, 0x37,
+  0x09, 0x02, 0x37, 0x11, 0x02, 0x88, 0xaf, 0xfd, 0x6c, 0x01, 0x2b, 0x02,
+  0x93, 0xae, 0x34, 0xc1, 0x02, 0xdd, 0x01, 0x4c, 0xfd, 0x23, 0xc2, 0xfd,
+  0x31, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x03, 0x00, 0x34, 0x05, 0x70,
+  0x05, 0x1e, 0x00, 0x06, 0x00, 0x00, 0x01, 0x17, 0x09, 0x02, 0x17, 0x21,
+  0x01, 0x03, 0xae, 0x02, 0x94, 0x01, 0x2a, 0xfd, 0x6d, 0xae, 0xfd, 0x79,
+  0x03, 0x03, 0xc2, 0x02, 0xdd, 0xfe, 0xb4, 0xfd, 0x23, 0xc1, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x31, 0x00, 0x86, 0x05, 0xaf, 0x04, 0x7e, 0x00, 0x09,
+  0x00, 0x00, 0x25, 0x09, 0x01, 0x11, 0x21, 0x11, 0x09, 0x01, 0x11, 0x21,
+  0x01, 0xfb, 0xfe, 0x37, 0x01, 0xc9, 0x01, 0xea, 0x01, 0xc9, 0xfe, 0x37,
+  0xfe, 0x16, 0x86, 0x01, 0xfc, 0x01, 0xfc, 0xfe, 0xef, 0x01, 0x11, 0xfe,
+  0x04, 0xfe, 0x04, 0x01, 0x11, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x3b,
+  0xff, 0xcd, 0x04, 0xce, 0x06, 0x08, 0x00, 0x09, 0x00, 0x00, 0x01, 0x33,
+  0x09, 0x01, 0x33, 0x11, 0x23, 0x09, 0x01, 0x23, 0x03, 0xd8, 0xf5, 0xfe,
+  0x37, 0xfe, 0x37, 0xf6, 0xf6, 0x01, 0xc9, 0x01, 0xc9, 0xf5, 0x01, 0xc9,
+  0xfe, 0x04, 0x01, 0xfc, 0x02, 0x43, 0x01, 0xfc, 0xfe, 0x04, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x69, 0xff, 0xf9, 0x05, 0xb1, 0x02, 0xd7, 0x00, 0x0b,
+  0x00, 0x00, 0x05, 0x23, 0x01, 0x37, 0x17, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x37, 0x17, 0x04, 0x4e, 0x51, 0xfe, 0x9f, 0x6c, 0xd1, 0xfc, 0x90, 0x04,
+  0x09, 0xd2, 0x6c, 0x07, 0x01, 0x8a, 0x78, 0xea, 0x01, 0x1c, 0xaa, 0xfe,
+  0x3a, 0xea, 0x78, 0x00, 0x00, 0x01, 0x00, 0x69, 0x02, 0x2d, 0x05, 0xb1,
+  0x05, 0x0b, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01, 0x07, 0x27, 0x11, 0x21,
+  0x35, 0x21, 0x11, 0x07, 0x27, 0x01, 0x04, 0x4e, 0x01, 0x62, 0x6c, 0xd2,
+  0xfb, 0xf7, 0x03, 0x70, 0xd1, 0x6c, 0x01, 0x61, 0x05, 0x0b, 0xfe, 0x76,
+  0x78, 0xea, 0xfe, 0x3a, 0xaa, 0x01, 0x1c, 0xea, 0x78, 0x01, 0x8a, 0x00,
+  0x00, 0x01, 0x00, 0x40, 0xff, 0xf9, 0x05, 0x88, 0x02, 0xd7, 0x00, 0x0b,
+  0x00, 0x00, 0x05, 0x01, 0x37, 0x17, 0x11, 0x21, 0x15, 0x21, 0x11, 0x37,
+  0x17, 0x01, 0x01, 0xa3, 0xfe, 0x9e, 0x6c, 0xd2, 0x04, 0x09, 0xfc, 0x90,
+  0xd1, 0x6c, 0xfe, 0x9f, 0x07, 0x01, 0x8a, 0x78, 0xea, 0x01, 0xc6, 0xaa,
+  0xfe, 0xe4, 0xea, 0x78, 0xfe, 0x76, 0x00, 0x00, 0x00, 0x01, 0x00, 0x40,
+  0x02, 0x2d, 0x05, 0x88, 0x05, 0x0b, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33,
+  0x01, 0x07, 0x27, 0x11, 0x21, 0x15, 0x21, 0x11, 0x07, 0x27, 0x01, 0xa3,
+  0x51, 0x01, 0x61, 0x6c, 0xd1, 0x03, 0x70, 0xfb, 0xf7, 0xd2, 0x6c, 0x05,
+  0x0b, 0xfe, 0x76, 0x78, 0xea, 0xfe, 0xe4, 0xaa, 0x01, 0xc6, 0xea, 0x78,
+  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x17, 0x11, 0x21, 0x11, 0x25, 0x21, 0x11, 0x21,
+  0xa7, 0x05, 0x7f, 0xfa, 0xe8, 0x04, 0xb2, 0xfb, 0x4e, 0xfc, 0x06, 0x20,
+  0xf9, 0xe0, 0x72, 0x02, 0x9e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x17, 0x11, 0x21, 0x11, 0x01, 0x21, 0x11, 0x21, 0xa7, 0x05, 0x7f, 0xfa,
+  0xe8, 0x04, 0xb2, 0xfb, 0x4e, 0xfc, 0x06, 0x20, 0xf9, 0xe0, 0x03, 0x10,
+  0x02, 0x9e, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x05, 0x21, 0x01, 0x03,
+  0x11, 0x21, 0x11, 0x01, 0x0e, 0x04, 0xb2, 0xfb, 0x4e, 0x67, 0x05, 0x7f,
+  0x8a, 0x05, 0x3c, 0xfa, 0x52, 0x06, 0x20, 0xf9, 0xe0, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27, 0x05, 0x24, 0x00, 0x02,
+  0x00, 0x06, 0x00, 0x00, 0x05, 0x11, 0x21, 0x03, 0x11, 0x21, 0x11, 0x05,
+  0xc0, 0xfb, 0x4e, 0x67, 0x05, 0x7f, 0x8a, 0x05, 0x3c, 0xfa, 0x52, 0x06,
+  0x20, 0xf9, 0xe0, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x05, 0x09, 0x05, 0x02,
+  0xc4, 0x02, 0x37, 0xfd, 0xc9, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd,
+  0x40, 0x64, 0x02, 0x78, 0x02, 0x78, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0,
+  0xfc, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x13, 0x01, 0x11, 0x09,
+  0x03, 0x8e, 0x02, 0x36, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd, 0x40,
+  0x02, 0x14, 0xfd, 0x88, 0x04, 0xf0, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0,
+  0xfc, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x13, 0x09, 0x01, 0x21,
+  0x09, 0x02, 0x8e, 0x02, 0x36, 0x02, 0x37, 0xfb, 0x0a, 0x02, 0xbf, 0x02,
+  0xc0, 0xfd, 0x40, 0x02, 0x14, 0xfd, 0x88, 0x02, 0x78, 0x03, 0x10, 0xfc,
+  0xf0, 0xfc, 0xf0, 0x00, 0x00, 0x02, 0x00, 0x05, 0xff, 0x04, 0x05, 0x85,
+  0x05, 0x24, 0x00, 0x02, 0x00, 0x06, 0x00, 0x00, 0x13, 0x21, 0x09, 0x04,
+  0x8e, 0x04, 0x6d, 0xfd, 0xc9, 0xfd, 0x41, 0x02, 0xbf, 0x02, 0xc0, 0xfd,
+  0x40, 0x02, 0x14, 0x02, 0x78, 0xfd, 0x88, 0x03, 0x10, 0xfc, 0xf0, 0xfc,
+  0xf0, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xa7, 0xff, 0x04, 0x06, 0x27,
+  0x05, 0x24, 0x00, 0x05, 0x00, 0x09, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x15,
+  0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x29, 0x00, 0x2d, 0x00, 0x31,
+  0x00, 0x37, 0x00, 0x00, 0x05, 0x15, 0x23, 0x35, 0x33, 0x35, 0x13, 0x15,
+  0x23, 0x35, 0x13, 0x15, 0x23, 0x35, 0x01, 0x15, 0x23, 0x35, 0x23, 0x15,
+  0x23, 0x35, 0x01, 0x15, 0x23, 0x35, 0x23, 0x35, 0x23, 0x15, 0x23, 0x35,
+  0x23, 0x15, 0x23, 0x35, 0x01, 0x15, 0x33, 0x15, 0x23, 0x35, 0x13, 0x15,
+  0x23, 0x35, 0x13, 0x15, 0x23, 0x35, 0x13, 0x15, 0x23, 0x15, 0x23, 0x35,
+  0x06, 0x26, 0xcc, 0x66, 0x66, 0x66, 0x66, 0x66, 0xfe, 0xc7, 0xb7, 0xd3,
+  0xb6, 0x03, 0xdf, 0x66, 0x66, 0xd3, 0xb7, 0xd3, 0xb6, 0xfe, 0xc7, 0x67,
+  0xce, 0x67, 0x67, 0x67, 0x67, 0xce, 0x67, 0x67, 0x16, 0xe6, 0x74, 0x72,
+  0x01, 0xb6, 0xcc, 0xcc, 0x01, 0xb4, 0xca, 0xca, 0xfc, 0x24, 0x74, 0x74,
+  0x74, 0x74, 0x05, 0xac, 0xe6, 0x72, 0x74, 0x74, 0x74, 0x74, 0x74, 0xfa,
+  0xc6, 0x72, 0x74, 0xe6, 0x01, 0xb6, 0xcc, 0xcc, 0x01, 0xb4, 0xca, 0xca,
+  0x01, 0xd0, 0x74, 0x72, 0xe6, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x20,
+  0xff, 0xca, 0x06, 0x22, 0x06, 0x23, 0x00, 0x04, 0x00, 0x00, 0x13, 0x09,
+  0x02, 0x21, 0x20, 0x03, 0x01, 0x03, 0x01, 0xfe, 0xda, 0xfc, 0x4a, 0x03,
+  0xb6, 0x02, 0x6d, 0xfd, 0x93, 0xfc, 0x14, 0x00, 0x00, 0x02, 0x00, 0x20,
+  0xff, 0xca, 0x06, 0x22, 0x06, 0x23, 0x00, 0x04, 0x00, 0x09, 0x00, 0x00,
+  0x1b, 0x01, 0x21, 0x13, 0x09, 0x04, 0x21, 0x99, 0xf7, 0x03, 0x22, 0xf7,
+  0xfd, 0x78, 0xfc, 0xff, 0x03, 0x01, 0x03, 0x01, 0xfe, 0xda, 0xfc, 0x4a,
+  0x03, 0x8b, 0xfc, 0xb1, 0x03, 0x4f, 0x02, 0x0c, 0xfe, 0x1f, 0x02, 0x6d,
+  0xfd, 0x93, 0xfc, 0x14, 0x00, 0x02, 0x00, 0x87, 0xff, 0x46, 0x05, 0xc3,
+  0x05, 0xfc, 0x00, 0x05, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x09, 0x01, 0x11,
+  0x09, 0x01, 0x03, 0x11, 0x09, 0x01, 0x11, 0x01, 0xee, 0x02, 0x37, 0x02,
+  0x37, 0xfd, 0xc9, 0xfd, 0xc9, 0x67, 0x02, 0x9e, 0x02, 0x9d, 0xfd, 0x63,
+  0x01, 0x35, 0xfe, 0x95, 0x01, 0x6b, 0x02, 0xd8, 0x01, 0x6b, 0xfe, 0x95,
+  0xfc, 0xe6, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4, 0xfe, 0x53,
+  0x00, 0x01, 0x00, 0x87, 0xff, 0x46, 0x05, 0xc3, 0x05, 0xfc, 0x00, 0x05,
+  0x00, 0x00, 0x37, 0x11, 0x09, 0x01, 0x11, 0x01, 0x87, 0x02, 0x9e, 0x02,
+  0x9d, 0xfd, 0x63, 0xf3, 0x03, 0x5c, 0x01, 0xad, 0xfe, 0x53, 0xfc, 0xa4,
+  0xfe, 0x53, 0x00, 0x00, 0x00, 0x01, 0x00, 0x1e, 0xff, 0xb9, 0x06, 0x2a,
+  0x05, 0x89, 0x00, 0x05, 0x00, 0x00, 0x05, 0x09, 0x01, 0x21, 0x09, 0x01,
+  0x01, 0xa2, 0xfe, 0x7d, 0x01, 0x83, 0x03, 0x05, 0x01, 0x83, 0xfe, 0x7d,
+  0x47, 0x02, 0xe8, 0x02, 0xe8, 0xfd, 0x18, 0xfd, 0x18, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x64, 0xfe, 0x00, 0x07, 0xaa, 0x06, 0x28, 0x00, 0x0b,
+  0x00, 0x00, 0x16, 0x10, 0x01, 0x36, 0x20, 0x17, 0x00, 0x10, 0x01, 0x06,
+  0x20, 0x27, 0x65, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xe9, 0x01, 0xd1, 0xfe,
+  0x2f, 0xe9, 0xfe, 0x2f, 0xe9, 0x40, 0x04, 0xa8, 0x01, 0x2a, 0x96, 0x96,
+  0xfe, 0xd6, 0xfb, 0x58, 0xfe, 0xd6, 0x96, 0x96, 0x00, 0x01, 0x00, 0x45,
+  0xff, 0xa0, 0x05, 0xfd, 0x06, 0x4d, 0x00, 0x04, 0x00, 0x00, 0x09, 0x03,
+  0x11, 0x03, 0xcd, 0x02, 0x2f, 0xfd, 0xd1, 0xfc, 0x79, 0x06, 0x4c, 0xfc,
+  0xaa, 0xfc, 0xaa, 0x01, 0x46, 0x04, 0x20, 0x00, 0x00, 0x02, 0x00, 0x45,
+  0xff, 0xa0, 0x05, 0xfd, 0x06, 0x4d, 0x00, 0x04, 0x00, 0x09, 0x00, 0x00,
+  0x09, 0x01, 0x11, 0x09, 0x05, 0x11, 0x03, 0xa7, 0xfd, 0x05, 0x02, 0xfb,
+  0x01, 0xd7, 0xfe, 0x4f, 0x02, 0x2f, 0xfd, 0xd1, 0xfc, 0x79, 0x05, 0xc6,
+  0xfe, 0xee, 0xfc, 0x86, 0xfe, 0xec, 0x02, 0xd0, 0x03, 0x56, 0xfc, 0xaa,
+  0xfc, 0xaa, 0x01, 0x46, 0x04, 0x20, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
+  0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x15, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
+  0x11, 0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0x01, 0x38,
+  0xfe, 0xc8, 0x01, 0x38, 0xfe, 0xc8, 0x02, 0x8e, 0xfc, 0xbc, 0xac, 0xac,
+  0xac, 0xac, 0x05, 0xd5, 0xfe, 0x07, 0x90, 0x90, 0x90, 0xfe, 0x7e, 0xaa,
+  0x02, 0x2c, 0x90, 0x90, 0x90, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0xf3, 0x06, 0x14, 0x00, 0x13, 0x00, 0x00, 0x01, 0x33,
+  0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x23, 0x35, 0x33,
+  0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x01, 0x53, 0xa0, 0xa0, 0xa5, 0xa5,
+  0xa5, 0xa5, 0xa5, 0xa5, 0xa0, 0xa0, 0x02, 0xbc, 0x90, 0xfd, 0xd4, 0x02,
+  0x2c, 0x90, 0x90, 0x90, 0x02, 0x38, 0xfd, 0xc8, 0x90, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xdb, 0x00, 0x00, 0x03, 0xf9, 0x05, 0xd5, 0x00, 0x23,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x33,
+  0x32, 0x17, 0xb5, 0xb6, 0x01, 0x01, 0x10, 0x0b, 0x23, 0x10, 0x10, 0x02,
+  0x70, 0x01, 0x5c, 0x52, 0x12, 0x11, 0x02, 0x8e, 0xfc, 0xbc, 0x05, 0x05,
+  0x0f, 0x0c, 0x22, 0x10, 0x11, 0x01, 0x71, 0x02, 0x5c, 0x52, 0x16, 0x14,
+  0x05, 0xd5, 0xfd, 0x2c, 0x01, 0x01, 0x09, 0x25, 0x24, 0x52, 0x86, 0x94,
+  0x04, 0xfe, 0x2f, 0xaa, 0x03, 0x02, 0x04, 0x03, 0x09, 0x25, 0x24, 0x52,
+  0x86, 0x94, 0x06, 0x00, 0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x04, 0x19,
+  0x05, 0xd5, 0x00, 0x10, 0x00, 0x1d, 0x00, 0x00, 0x13, 0x21, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x23, 0x35,
+  0x33, 0x17, 0x15, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x15,
+  0x21, 0x15, 0xb5, 0x01, 0x9a, 0xe2, 0x73, 0x74, 0x74, 0x73, 0xe2, 0xe4,
+  0xb6, 0xac, 0xac, 0xb6, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xe4, 0x01, 0x38,
+  0x05, 0xd5, 0x71, 0x72, 0xdb, 0xdd, 0x71, 0x71, 0xfd, 0xa8, 0x03, 0xcf,
+  0x90, 0x90, 0xd1, 0x92, 0x87, 0x86, 0x92, 0xd0, 0x90, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0xfe, 0x66, 0x04, 0xcc, 0x05, 0xd5, 0x00, 0x1b,
+  0x00, 0x24, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17, 0x13, 0x23, 0x03, 0x2e,
+  0x01, 0x2b, 0x01, 0x11, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
+  0x19, 0x01, 0x21, 0x32, 0x16, 0x15, 0x14, 0x06, 0x01, 0x11, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x23, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4,
+  0xac, 0x42, 0x7d, 0x6c, 0xc6, 0x63, 0x78, 0x39, 0x45, 0xcd, 0xb8, 0x01,
+  0x9a, 0xe7, 0xe2, 0x75, 0xfd, 0xc8, 0xe4, 0x84, 0x86, 0x86, 0x84, 0x02,
+  0xbc, 0x16, 0x90, 0x7e, 0xfe, 0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0xf1,
+  0xc2, 0x96, 0xaa, 0xf4, 0x01, 0x0e, 0x05, 0x6d, 0xd6, 0xd8, 0x8d, 0xba,
+  0x02, 0x4f, 0xfd, 0xee, 0x87, 0x83, 0x83, 0x85, 0x00, 0x04, 0x00, 0x40,
+  0xff, 0xa2, 0x04, 0x26, 0x04, 0xbc, 0x00, 0x23, 0x00, 0x28, 0x00, 0x30,
+  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22,
+  0x27, 0x07, 0x27, 0x37, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x37, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17,
+  0x37, 0x17, 0x07, 0x16, 0x0f, 0x01, 0x33, 0x35, 0x34, 0x07, 0x01, 0x16,
+  0x33, 0x32, 0x36, 0x3d, 0x01, 0x01, 0x13, 0x06, 0x07, 0x06, 0x15, 0x14,
+  0x03, 0xc2, 0xa6, 0x38, 0xa9, 0x7b, 0x7a, 0x52, 0x5d, 0x56, 0x63, 0x35,
+  0xe3, 0xe2, 0x26, 0x8d, 0x0a, 0x0c, 0x4b, 0x88, 0x56, 0xa4, 0x4c, 0x5b,
+  0xab, 0x51, 0xd1, 0x6b, 0x85, 0x56, 0x97, 0x33, 0xa8, 0x30, 0x32, 0x9d,
+  0xfe, 0xdd, 0x37, 0x59, 0x8a, 0xa6, 0xfd, 0xff, 0xcd, 0x59, 0x2d, 0x4e,
+  0x02, 0x7f, 0xfd, 0x81, 0xaa, 0x66, 0x61, 0x3c, 0x7d, 0x4e, 0x85, 0x56,
+  0x7b, 0xbd, 0xc0, 0xbf, 0x0c, 0x0c, 0x45, 0x2e, 0x2e, 0xaa, 0x27, 0x27,
+  0x72, 0xb3, 0x4f, 0xcb, 0x73, 0x2b, 0x41, 0x12, 0x18, 0xba, 0xfe, 0x78,
+  0x2e, 0xd9, 0xb4, 0x29, 0xfe, 0xe2, 0x01, 0x15, 0x0c, 0x1e, 0x33, 0x7b,
+  0x20, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xea, 0xff, 0x42, 0x02, 0xc4,
+  0x06, 0x93, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x11, 0x33, 0x13, 0x33, 0x03,
+  0x33, 0x15, 0x23, 0x03, 0x15, 0x14, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x03, 0x23, 0x13, 0x11, 0x23, 0x35, 0x33, 0x11, 0x01,
+  0x52, 0x2b, 0xad, 0x99, 0xad, 0x91, 0xbd, 0x98, 0x43, 0x67, 0xab, 0xab,
+  0xbf, 0x49, 0x0b, 0x0a, 0x5c, 0x99, 0xc1, 0x79, 0x79, 0x05, 0x9e, 0xfe,
+  0xc2, 0x02, 0x33, 0xfd, 0xcd, 0x8f, 0xfe, 0x0f, 0x6f, 0x89, 0x4e, 0x9a,
+  0x50, 0x0c, 0x10, 0xfe, 0xd6, 0x02, 0x72, 0x02, 0x1d, 0x8f, 0x01, 0x3e,
+  0xff, 0xff, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x6a, 0x05, 0xd5, 0x10, 0x06,
+  0x04, 0x36, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0x9a,
+  0x06, 0x14, 0x00, 0x19, 0x00, 0x00, 0x21, 0x23, 0x11, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x11, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x23, 0x03, 0xf4, 0xa6, 0x70,
+  0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b, 0x50, 0x51, 0x6a, 0xad, 0x59, 0x5a,
+  0xa5, 0xa5, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x06, 0x14,
+  0xfd, 0x9e, 0x65, 0x32, 0x32, 0x77, 0x78, 0xe8, 0xfd, 0xf5, 0xfe, 0x4c,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x0e,
+  0x00, 0x00, 0x25, 0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x11, 0x23, 0x11,
+  0x33, 0x11, 0x01, 0x33, 0x01, 0x04, 0x47, 0x98, 0xb1, 0x3e, 0xfd, 0x7b,
+  0xb6, 0xb6, 0x02, 0x5b, 0xea, 0xfd, 0x65, 0xaa, 0xfe, 0x15, 0x01, 0x41,
+  0x02, 0xcf, 0xfd, 0x31, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x77, 0xfd, 0x48,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0x26, 0x06, 0x14, 0x00, 0x0e,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x33, 0x11, 0x23,
+  0x11, 0x23, 0x01, 0x11, 0x23, 0xa7, 0xa7, 0x01, 0xee, 0xd4, 0xfd, 0xe9,
+  0x01, 0x9e, 0x8f, 0xa6, 0x32, 0xfe, 0x00, 0xa7, 0x06, 0x14, 0xfc, 0x69,
+  0x01, 0xe3, 0xfd, 0xf4, 0xfe, 0x45, 0xfe, 0x4c, 0x01, 0x1b, 0x02, 0x23,
+  0xfd, 0xdd, 0x00, 0x00, 0x00, 0x01, 0x00, 0x52, 0xfe, 0xbf, 0x05, 0x51,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x01, 0x21, 0x11,
+  0x23, 0x11, 0x21, 0x35, 0x01, 0x21, 0x68, 0x04, 0x1f, 0xfc, 0xaf, 0x04,
+  0x1b, 0xb5, 0xfb, 0xb7, 0x03, 0x51, 0xfc, 0xc4, 0x05, 0xd5, 0x9a, 0xfb,
+  0x6f, 0xfe, 0x15, 0x01, 0x41, 0x9a, 0x04, 0x91, 0x00, 0x01, 0x00, 0x4f,
+  0xfe, 0xe5, 0x04, 0x1e, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21, 0x35, 0x01, 0x21, 0x66, 0x03,
+  0x12, 0xfd, 0x92, 0x03, 0x14, 0xa6, 0xfc, 0xd7, 0x02, 0x6f, 0xfd, 0xa8,
+  0x04, 0x60, 0xa8, 0xfc, 0xdb, 0xfe, 0x52, 0x01, 0x1b, 0xa8, 0x03, 0x25,
+  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xec, 0x05, 0xf1, 0x00, 0x10,
+  0x00, 0x1c, 0x00, 0x00, 0x01, 0x35, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01,
+  0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x01, 0x10, 0x12,
+  0x33, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22, 0x02, 0x04, 0x3b, 0xb0,
+  0xb0, 0x46, 0xd4, 0x95, 0xf3, 0xfe, 0xcf, 0x01, 0x31, 0xf3, 0x95, 0xd4,
+  0xfd, 0x2f, 0xd3, 0xb8, 0xb8, 0xd4, 0xd4, 0xb8, 0xb8, 0xd3, 0x04, 0xed,
+  0xe8, 0xfa, 0x2b, 0xe7, 0x84, 0x80, 0x01, 0xab, 0x01, 0x5c, 0x01, 0x5c,
+  0x01, 0xab, 0x80, 0xfd, 0x78, 0xfe, 0xe3, 0xfe, 0xbb, 0x01, 0x45, 0x01,
+  0x1d, 0x01, 0x1d, 0x01, 0x45, 0xfe, 0xbb, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0xfe, 0x66, 0x05, 0x83, 0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x13, 0x21,
+  0x09, 0x01, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36,
+  0x35, 0x11, 0x01, 0x23, 0x01, 0x11, 0x23, 0xb5, 0x01, 0x0f, 0x01, 0x57,
+  0x01, 0x58, 0x01, 0x0f, 0xb8, 0xcc, 0x46, 0x3d, 0x79, 0x63, 0xfe, 0xa5,
+  0xb6, 0xfe, 0xa5, 0xb0, 0x05, 0xd5, 0xfc, 0x08, 0x03, 0xf8, 0xfa, 0x93,
+  0xfe, 0xf2, 0xf4, 0xaa, 0x96, 0xc2, 0x04, 0xb7, 0xfc, 0x00, 0x04, 0x00,
+  0xfa, 0xe1, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x04, 0xde,
+  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00, 0x25, 0x13, 0x21, 0x01,
+  0x23, 0x01, 0x33, 0x13, 0x21, 0x13, 0x33, 0x02, 0x76, 0xf7, 0xfe, 0x11,
+  0x01, 0x5f, 0xcf, 0xfe, 0x00, 0xbd, 0x7b, 0x02, 0x5e, 0x7a, 0xc0, 0xc7,
+  0x02, 0xe7, 0xfc, 0x52, 0x05, 0xd5, 0xfe, 0x81, 0x01, 0x7f, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xec, 0x05, 0xf1, 0x00, 0x0f,
+  0x00, 0x18, 0x00, 0x00, 0x25, 0x15, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01,
+  0x33, 0x32, 0x00, 0x10, 0x00, 0x23, 0x22, 0x26, 0x00, 0x10, 0x02, 0x23,
+  0x22, 0x02, 0x10, 0x12, 0x20, 0x01, 0x18, 0xb0, 0xb0, 0x45, 0xd5, 0x94,
+  0xf3, 0x01, 0x32, 0xfe, 0xce, 0xf3, 0x94, 0xd5, 0x02, 0xd1, 0xd2, 0xb8,
+  0xb9, 0xd3, 0xd3, 0x01, 0x71, 0xe7, 0xe8, 0x05, 0xd5, 0xe7, 0x84, 0x80,
+  0xfe, 0x55, 0xfd, 0x48, 0xfe, 0x55, 0x80, 0x01, 0x6b, 0x02, 0x3a, 0x01,
+  0x45, 0xfe, 0xbb, 0xfd, 0xc6, 0xfe, 0xbb, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0x00, 0x00, 0x05, 0x4a, 0x04, 0x7b, 0x00, 0x14, 0x00, 0x00, 0x01, 0x30,
+  0x01, 0x23, 0x01, 0x33, 0x01, 0x13, 0x36, 0x33, 0x32, 0x16, 0x1d, 0x01,
+  0x23, 0x35, 0x34, 0x26, 0x22, 0x07, 0x06, 0x03, 0xba, 0xfe, 0xd8, 0xe1,
+  0xfe, 0x86, 0xaf, 0x01, 0x3b, 0xf9, 0x4b, 0xc8, 0x76, 0xa7, 0xa1, 0x49,
+  0x66, 0x25, 0x13, 0x03, 0x6d, 0xfc, 0x93, 0x04, 0x60, 0xfc, 0x54, 0x02,
+  0xe6, 0xe1, 0xbf, 0x86, 0x72, 0x72, 0x3a, 0x54, 0x2a, 0x15, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x08, 0x1f, 0x05, 0xf0, 0x00, 0x1d,
+  0x00, 0x00, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x01, 0x33, 0x09, 0x01,
+  0x33, 0x01, 0x13, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x1d, 0x01,
+  0x23, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x06, 0xa9, 0xfe, 0xe8,
+  0xe5, 0xfe, 0xe5, 0xfe, 0xe1, 0xe4, 0xfe, 0xaf, 0xb8, 0x01, 0x1a, 0x01,
+  0x1a, 0xcc, 0x01, 0x1b, 0xed, 0x10, 0x36, 0x4d, 0x7c, 0x7a, 0x4c, 0x4d,
+  0x99, 0x49, 0x29, 0x26, 0x24, 0x1a, 0x04, 0xe1, 0xfb, 0x1f, 0x05, 0x10,
+  0xfa, 0xf0, 0x05, 0xd5, 0xfb, 0x12, 0x04, 0xee, 0xfb, 0x12, 0x04, 0x26,
+  0x47, 0x40, 0x5c, 0x5c, 0x5b, 0x6e, 0x83, 0x79, 0x36, 0x50, 0x28, 0x1c,
+  0x00, 0x01, 0x00, 0x4d, 0x00, 0x00, 0x06, 0xed, 0x04, 0x7b, 0x00, 0x1b,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x1d, 0x01, 0x23,
+  0x35, 0x34, 0x26, 0x22, 0x07, 0x06, 0x07, 0x03, 0x23, 0x0b, 0x01, 0x23,
+  0x01, 0x33, 0x1b, 0x01, 0x33, 0x13, 0x04, 0xbf, 0x15, 0x33, 0x52, 0x77,
+  0x76, 0xa6, 0xa0, 0x49, 0x67, 0x24, 0x16, 0x06, 0xce, 0xc3, 0xd9, 0xda,
+  0xc3, 0xfe, 0xf8, 0xa6, 0xcf, 0xce, 0xc3, 0xcf, 0x03, 0x88, 0x56, 0x3d,
+  0x60, 0xbf, 0x86, 0x72, 0x72, 0x3a, 0x54, 0x2a, 0x19, 0x14, 0xfc, 0x93,
+  0x03, 0x96, 0xfc, 0x6a, 0x04, 0x60, 0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96,
+  0x00, 0x02, 0x00, 0x5d, 0x00, 0x00, 0x04, 0x0c, 0x04, 0xb3, 0x00, 0x13,
+  0x00, 0x1b, 0x00, 0x00, 0x13, 0x10, 0x25, 0x36, 0x33, 0x32, 0x15, 0x14,
+  0x0f, 0x01, 0x13, 0x01, 0x33, 0x01, 0x23, 0x03, 0x07, 0x35, 0x36, 0x3f,
+  0x01, 0x36, 0x35, 0x26, 0x23, 0x22, 0x15, 0x14, 0xb4, 0x01, 0x32, 0x12,
+  0x10, 0x97, 0xa5, 0x72, 0x99, 0x01, 0x3b, 0xb0, 0xfe, 0x86, 0xe1, 0xbc,
+  0x97, 0x2c, 0x36, 0x94, 0xc3, 0x01, 0x29, 0x9d, 0x03, 0x4d, 0x01, 0x32,
+  0x31, 0x03, 0xf8, 0x99, 0x5d, 0x40, 0xfe, 0x2f, 0x03, 0xac, 0xfb, 0xa0,
+  0x02, 0x32, 0x55, 0xc4, 0x14, 0x1c, 0x50, 0x6e, 0x34, 0x34, 0xa0, 0x25,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x00, 0x05, 0xd5, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x03, 0xff,
+  0xfd, 0x6c, 0xb6, 0xb6, 0x02, 0x94, 0x02, 0xc7, 0xfd, 0x39, 0x05, 0xd5,
+  0xfd, 0x9c, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x03, 0x6f,
+  0x04, 0x60, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x33,
+  0x11, 0x21, 0x03, 0x6e, 0xfd, 0xe5, 0xa5, 0xa5, 0x02, 0x1b, 0x02, 0x04,
+  0xfd, 0xfc, 0x04, 0x60, 0xfe, 0x33, 0x00, 0x00, 0x00, 0x02, 0x00, 0x64,
+  0xff, 0xe7, 0x04, 0x56, 0x04, 0x68, 0x00, 0x0a, 0x00, 0x27, 0x00, 0x00,
+  0x01, 0x22, 0x15, 0x11, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
+  0x32, 0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x23, 0x07, 0x22, 0x27, 0x26,
+  0x11, 0x10, 0x37, 0x36, 0x37, 0x15, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x33, 0x11, 0x10, 0x02, 0xea, 0x3a, 0x55, 0x56, 0x4c, 0x4d, 0x3f,
+  0x31, 0x7d, 0x73, 0x7c, 0x7c, 0x74, 0xb6, 0xa5, 0xb4, 0x78, 0x7a, 0x7a,
+  0x5b, 0x96, 0x3b, 0x34, 0x4e, 0x4e, 0x45, 0x65, 0x03, 0xcb, 0x91, 0xfd,
+  0x52, 0x68, 0x5d, 0xdf, 0xd0, 0x70, 0x5b, 0x9d, 0x84, 0x8d, 0xfe, 0xd9,
+  0xfe, 0xf1, 0xa1, 0x98, 0x01, 0x99, 0x9c, 0x01, 0x13, 0x01, 0x1e, 0x92,
+  0x6d, 0x1c, 0xa3, 0x17, 0x4e, 0x73, 0xbe, 0xca, 0x73, 0x67, 0x02, 0xaf,
+  0x01, 0x2e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0xff, 0xe5, 0x02, 0x4f,
+  0x06, 0x14, 0x00, 0x17, 0x00, 0x00, 0x21, 0x35, 0x06, 0x23, 0x22, 0x2f,
+  0x01, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x34, 0x26, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x11, 0x01, 0xa8, 0x67, 0xec, 0x22, 0x32,
+  0x01, 0x36, 0x4f, 0x8d, 0x96, 0x45, 0x5f, 0xd0, 0xe5, 0xa4, 0x48, 0x49,
+  0xae, 0xc9, 0x0a, 0xbd, 0x23, 0xcb, 0xbe, 0x02, 0x6c, 0x99, 0x61, 0x9c,
+  0x60, 0x62, 0xd4, 0xfb, 0x82, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x20,
+  0x00, 0x00, 0x00, 0x26, 0x22, 0x06, 0x14, 0x16, 0x32, 0x36, 0x00, 0x12,
+  0x20, 0x12, 0x10, 0x02, 0x20, 0x02, 0x00, 0x26, 0x20, 0x06, 0x15, 0x14,
+  0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x36, 0x35, 0x02,
+  0xc7, 0x55, 0x79, 0x54, 0x54, 0x7a, 0x54, 0xfd, 0x9f, 0xf5, 0x01, 0xb1,
+  0xf7, 0xf7, 0xfe, 0x4f, 0xf5, 0x02, 0xed, 0x9a, 0xfe, 0xf6, 0x9b, 0x12,
+  0x14, 0x32, 0x52, 0x78, 0x7a, 0x51, 0x2d, 0x15, 0x10, 0x01, 0x61, 0x5f,
+  0x5e, 0x87, 0x5c, 0x5c, 0x02, 0x68, 0x01, 0x38, 0xfe, 0xc8, 0xfd, 0xd9,
+  0xfe, 0xc7, 0x01, 0x39, 0x01, 0xda, 0xe9, 0xe7, 0xc9, 0x60, 0x4d, 0x47,
+  0x38, 0x5d, 0x5f, 0x32, 0x42, 0x49, 0x5b, 0x00, 0x00, 0x01, 0x00, 0x58,
+  0x00, 0x00, 0x02, 0xe2, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x02, 0xe1,
+  0xfd, 0x77, 0x01, 0xe2, 0xfe, 0x3f, 0x01, 0xc1, 0xfe, 0x2a, 0x04, 0x60,
+  0xfb, 0xa0, 0x93, 0x01, 0x78, 0x94, 0x01, 0x2d, 0x94, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xeb, 0xff, 0x11, 0x00, 0xd7, 0x03, 0x67, 0x12, 0x07,
+  0x02, 0x74, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
+  0x02, 0x9c, 0x03, 0x11, 0x05, 0xe0, 0x00, 0x06, 0x00, 0x00, 0x09, 0x01,
+  0x33, 0x09, 0x01, 0x33, 0x01, 0x01, 0x4c, 0xfe, 0xbd, 0x78, 0x01, 0x0c,
+  0x01, 0x0d, 0x77, 0xfe, 0xbd, 0x02, 0x9c, 0x03, 0x44, 0xfd, 0x40, 0x02,
+  0xc0, 0xfc, 0xbc, 0x00, 0x00, 0x01, 0x00, 0x79, 0xfe, 0x10, 0x04, 0x4e,
+  0x05, 0xf0, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x17, 0x1e, 0x01, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2e,
+  0x02, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x35, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x03, 0xda, 0x67, 0xb8, 0x55, 0x95, 0xa1, 0x36,
+  0x31, 0x9a, 0x6d, 0xd0, 0x5d, 0x60, 0x83, 0x67, 0xb5, 0x79, 0x70, 0x84,
+  0x3f, 0x16, 0x39, 0x1e, 0x47, 0x5d, 0x6e, 0x36, 0xc9, 0x2c, 0x0d, 0x2d,
+  0x22, 0x6c, 0x73, 0x6f, 0xd4, 0x67, 0x9b, 0xaa, 0x7a, 0x8b, 0x6e, 0xcc,
+  0xb5, 0xfb, 0xdc, 0x5f, 0xc4, 0x05, 0xa4, 0xc5, 0x37, 0x36, 0x80, 0x76,
+  0x63, 0x33, 0x2e, 0x23, 0x19, 0x2f, 0x69, 0x6c, 0xb6, 0xd9, 0x70, 0x59,
+  0x12, 0x77, 0x6e, 0x49, 0xaa, 0x10, 0x27, 0x4f, 0x38, 0xce, 0x2d, 0x0a,
+  0x21, 0x07, 0x18, 0x2f, 0xd0, 0x45, 0x46, 0x88, 0x7e, 0x6e, 0x7c, 0x1f,
+  0x18, 0x2d, 0xc0, 0xab, 0xc6, 0xe4, 0x26, 0x00, 0x00, 0x01, 0x00, 0x52,
+  0xfe, 0x10, 0x04, 0x9c, 0x05, 0xd5, 0x00, 0x18, 0x00, 0x00, 0x01, 0x33,
+  0x15, 0x23, 0x22, 0x2e, 0x02, 0x27, 0x25, 0x26, 0x2b, 0x01, 0x35, 0x01,
+  0x21, 0x35, 0x21, 0x15, 0x01, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x04, 0x3b,
+  0x61, 0x84, 0x23, 0x51, 0x6a, 0x7e, 0x3e, 0xfe, 0xf2, 0x47, 0x66, 0x70,
+  0x03, 0x51, 0xfc, 0xc4, 0x04, 0x1f, 0xfc, 0xb3, 0x67, 0x69, 0xe3, 0x7a,
+  0x90, 0xfe, 0xba, 0xaa, 0x10, 0x27, 0x4f, 0x38, 0xf3, 0x3f, 0x9a, 0x04,
+  0x91, 0xaa, 0x9a, 0xfb, 0x6f, 0x0d, 0x5f, 0xcd, 0x6e, 0x49, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x01, 0x11, 0x33, 0x11,
+  0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x05, 0x58, 0x88, 0xfb, 0x30, 0x05,
+  0x58, 0xfa, 0xa8, 0x00, 0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
+  0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23,
+  0x01, 0x11, 0x33, 0x11, 0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x04, 0x24,
+  0x88, 0xfc, 0x64, 0x05, 0x58, 0xfa, 0xa8, 0x00, 0x00, 0x02, 0x00, 0xc0,
+  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x33, 0x15, 0x23, 0x01, 0x11, 0x33, 0x11, 0xc1, 0x99, 0x99, 0x01,
+  0x92, 0x7a, 0x02, 0xf0, 0x88, 0xfd, 0x98, 0x05, 0x58, 0xfa, 0xa8, 0x00,
+  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x01, 0x11, 0x33, 0x11,
+  0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x01, 0xbc, 0x88, 0xfe, 0xcc, 0x05,
+  0x58, 0xfa, 0xa8, 0x00, 0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
+  0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x37, 0x33, 0x15, 0x23,
+  0x01, 0x33, 0x11, 0x23, 0xc1, 0x99, 0x99, 0x01, 0x92, 0x7a, 0x7a, 0x88,
+  0x88, 0x05, 0x58, 0xfa, 0xa8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc0,
+  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x23, 0x03, 0x23, 0x11, 0x33, 0x02, 0x34, 0x99, 0x99,
+  0xf9, 0x7a, 0x7a, 0x05, 0x58, 0x88, 0xfb, 0x30, 0x05, 0x58, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x03, 0x23, 0x11, 0x33,
+  0x02, 0x34, 0x99, 0x99, 0xf9, 0x7a, 0x7a, 0x04, 0x24, 0x88, 0xfc, 0x64,
+  0x05, 0x58, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce,
+  0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23,
+  0x03, 0x23, 0x11, 0x33, 0x02, 0x34, 0x99, 0x99, 0xf9, 0x7a, 0x7a, 0x02,
+  0xf0, 0x88, 0xfd, 0x98, 0x05, 0x58, 0x00, 0x00, 0x00, 0x02, 0x00, 0xc0,
+  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x01, 0x33, 0x15, 0x23, 0x03, 0x23, 0x11, 0x33, 0x02, 0x34, 0x99, 0x99,
+  0xf9, 0x7a, 0x7a, 0x01, 0xbc, 0x88, 0xfe, 0xcc, 0x05, 0x58, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x25, 0x33, 0x15, 0x2b, 0x02, 0x11, 0x33, 0x02,
+  0x34, 0x99, 0x99, 0xf9, 0x7a, 0x7a, 0x88, 0x88, 0x05, 0x58, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x05,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x02,
+  0x0c, 0xfe, 0x6e, 0x05, 0x58, 0x88, 0x00, 0x00, 0x00, 0x01, 0x00, 0xc0,
+  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
+  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x7a, 0x01, 0x92,
+  0xfe, 0x6e, 0x05, 0x58, 0xfe, 0xcc, 0x88, 0x00, 0x00, 0x01, 0x00, 0xc0,
+  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
+  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x7a, 0x01, 0x92,
+  0xfe, 0x6e, 0x05, 0x58, 0xfd, 0x98, 0x88, 0x00, 0x00, 0x01, 0x00, 0xc0,
+  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x07, 0x00, 0x00, 0x21, 0x23,
+  0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x01, 0x3b, 0x7a, 0x7a, 0x01, 0x92,
+  0xfe, 0x6e, 0x05, 0x58, 0xfc, 0x64, 0x88, 0x00, 0x00, 0x01, 0x00, 0xc0,
+  0x00, 0x00, 0x02, 0xce, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x25, 0x21,
+  0x15, 0x21, 0x11, 0x33, 0x01, 0x3b, 0x01, 0x92, 0xfd, 0xf4, 0x7a, 0x88,
+  0x88, 0x05, 0x58, 0x00, 0x00, 0x01, 0x00, 0x5b, 0x02, 0x9c, 0x02, 0x4d,
+  0x05, 0xe4, 0x00, 0x09, 0x00, 0x00, 0x01, 0x33, 0x17, 0x07, 0x27, 0x11,
+  0x23, 0x11, 0x07, 0x27, 0x01, 0x3b, 0x33, 0xdf, 0x45, 0x83, 0x61, 0x84,
+  0x44, 0x05, 0xe4, 0xdd, 0x43, 0x83, 0xfd, 0x55, 0x02, 0xab, 0x83, 0x43,
+  0x00, 0x01, 0x00, 0x5b, 0x02, 0x98, 0x02, 0x4d, 0x05, 0xe0, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x23, 0x27, 0x37, 0x17, 0x11, 0x33, 0x11, 0x37, 0x17,
+  0x01, 0x6e, 0x33, 0xdf, 0x44, 0x84, 0x61, 0x83, 0x45, 0x02, 0x98, 0xdd,
+  0x43, 0x83, 0x02, 0xab, 0xfd, 0x55, 0x83, 0x43, 0x00, 0x02, 0x00, 0xaf,
+  0x02, 0x9c, 0x01, 0x23, 0x05, 0xe0, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00,
+  0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x11, 0x07, 0x23, 0x27, 0xb0, 0x73,
+  0x73, 0x73, 0x0c, 0x5c, 0x0b, 0x03, 0x2a, 0x8e, 0x03, 0x44, 0xfe, 0x91,
+  0xc8, 0xc8, 0x00, 0x00, 0x00, 0x02, 0x00, 0xaf, 0x02, 0x9c, 0x01, 0x23,
+  0x05, 0xe0, 0x00, 0x03, 0x00, 0x09, 0x00, 0x00, 0x01, 0x23, 0x35, 0x33,
+  0x11, 0x23, 0x11, 0x37, 0x33, 0x17, 0x01, 0x23, 0x73, 0x73, 0x73, 0x0a,
+  0x5c, 0x0d, 0x05, 0x52, 0x8e, 0xfc, 0xbc, 0x01, 0x6f, 0xc8, 0xc8, 0x00,
+  0xff, 0xff, 0x00, 0xaf, 0x00, 0x00, 0x01, 0x23, 0x03, 0x44, 0x10, 0x07,
+  0x0e, 0x5c, 0x00, 0x00, 0xfd, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b,
+  0x00, 0x00, 0x02, 0x86, 0x05, 0xd4, 0x00, 0x10, 0x00, 0x00, 0x33, 0x35,
+  0x20, 0x02, 0x21, 0x35, 0x20, 0x02, 0x21, 0x35, 0x20, 0x13, 0x16, 0x07,
+  0x16, 0x13, 0x12, 0xba, 0x01, 0x29, 0x12, 0xfe, 0xd7, 0x01, 0x29, 0x1b,
+  0xfe, 0xc5, 0x01, 0xe7, 0x0d, 0x08, 0x9d, 0xa6, 0x05, 0x09, 0xa3, 0x02,
+  0x27, 0xa3, 0x01, 0xc5, 0xa2, 0xfe, 0x8c, 0xe5, 0x63, 0x6d, 0xfe, 0xfb,
+  0xfe, 0x5a, 0x00, 0x00, 0x00, 0x01, 0x00, 0x7b, 0x00, 0x00, 0x02, 0x50,
+  0x04, 0x60, 0x00, 0x10, 0x00, 0x00, 0x33, 0x35, 0x20, 0x02, 0x21, 0x35,
+  0x20, 0x02, 0x21, 0x35, 0x20, 0x13, 0x16, 0x07, 0x16, 0x17, 0x12, 0xa8,
+  0x01, 0x0e, 0x12, 0xfe, 0xf2, 0x01, 0x0e, 0x1b, 0xfe, 0xf2, 0x01, 0xb1,
+  0x0d, 0x07, 0x77, 0x81, 0x05, 0x09, 0x99, 0x01, 0x7c, 0x99, 0x01, 0x1a,
+  0x98, 0xfe, 0xe8, 0x9e, 0x4d, 0x59, 0xbc, 0xfe, 0xb8, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x67, 0x01, 0xcb, 0x02, 0xf6, 0x05, 0xf0, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x10, 0x17, 0x07, 0x02, 0x35, 0x10, 0x21, 0x15, 0x20,
+  0x01, 0x0f, 0x69, 0x93, 0x7d, 0x02, 0x8e, 0xfe, 0x19, 0x03, 0xcd, 0xfe,
+  0xfe, 0xd2, 0x2e, 0x01, 0x31, 0xd4, 0x02, 0x20, 0xdb, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x67, 0x00, 0x56, 0x02, 0xf6, 0x04, 0x7b, 0x00, 0x09,
+  0x00, 0x00, 0x01, 0x10, 0x17, 0x07, 0x02, 0x35, 0x10, 0x21, 0x15, 0x20,
+  0x01, 0x0f, 0x69, 0x93, 0x7d, 0x02, 0x8e, 0xfe, 0x19, 0x02, 0x58, 0xfe,
+  0xfe, 0xd2, 0x2e, 0x01, 0x31, 0xd4, 0x02, 0x20, 0xbd, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x66, 0x04, 0xb6, 0x05, 0xd5, 0x00, 0x13,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x10, 0x06, 0x2b,
+  0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x11, 0x21, 0x11, 0x23, 0xb5, 0xb6,
+  0x02, 0x94, 0xb6, 0xb8, 0xcd, 0x45, 0x39, 0x78, 0x63, 0xfd, 0x6c, 0xb6,
+  0x05, 0xd5, 0xfd, 0x9c, 0x02, 0x64, 0xfa, 0x93, 0xfe, 0xf2, 0xf4, 0xaa,
+  0x96, 0xc2, 0x02, 0x5f, 0xfd, 0x39, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7,
+  0xfe, 0x56, 0x03, 0xf4, 0x06, 0x14, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x11, 0x3e, 0x01,
+  0x33, 0x32, 0x16, 0x15, 0x11, 0x14, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x03, 0x4e, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b,
+  0xa1, 0x6a, 0xad, 0xb3, 0x93, 0xa3, 0x3f, 0x2c, 0x63, 0x1e, 0x22, 0x02,
+  0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x06, 0x14, 0xfd, 0x9e, 0x65,
+  0x64, 0xef, 0xe8, 0xfd, 0x48, 0xd6, 0xc0, 0x9c, 0x30, 0x38, 0x92, 0x00,
+  0x00, 0x01, 0xff, 0xfa, 0xfe, 0x4c, 0x05, 0xe6, 0x05, 0xd5, 0x00, 0x2a,
+  0x00, 0x00, 0x03, 0x21, 0x15, 0x21, 0x15, 0x21, 0x15, 0x01, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x2b, 0x01, 0x35, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21, 0x05, 0x04, 0x70,
+  0xfe, 0x23, 0x03, 0x08, 0xfe, 0x8e, 0x5f, 0x74, 0x59, 0x4c, 0x49, 0x89,
+  0x88, 0xfc, 0x68, 0x74, 0x75, 0x75, 0x60, 0x72, 0x71, 0x7b, 0xad, 0x59,
+  0x5a, 0x52, 0x54, 0x95, 0x9c, 0x01, 0x5a, 0xfd, 0xdb, 0xb6, 0xfe, 0x23,
+  0x05, 0xd5, 0xaa, 0xcb, 0x9a, 0xfe, 0x16, 0x38, 0x2b, 0x6c, 0x68, 0x8a,
+  0xdc, 0x7a, 0x79, 0x13, 0x13, 0x24, 0xc3, 0x31, 0x19, 0x19, 0x4b, 0x4b,
+  0x8f, 0x86, 0x49, 0x4a, 0x98, 0x01, 0xea, 0xfc, 0x4a, 0x05, 0x2b, 0x00,
+  0x00, 0x01, 0x00, 0x31, 0xfe, 0x4c, 0x04, 0xaf, 0x05, 0x9e, 0x00, 0x30,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x2b, 0x01, 0x35, 0x01, 0x21, 0x11, 0x14, 0x16, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11, 0x33,
+  0x11, 0x21, 0x15, 0x02, 0xee, 0x5e, 0x74, 0x59, 0x4d, 0x49, 0xfe, 0xee,
+  0xfc, 0x54, 0x59, 0x5a, 0x60, 0x4c, 0xb4, 0x62, 0xab, 0x59, 0x5a, 0x53,
+  0x52, 0x96, 0x9d, 0x01, 0x83, 0xfd, 0xad, 0x43, 0x67, 0xab, 0xab, 0xbf,
+  0x92, 0x79, 0x79, 0xa7, 0x03, 0x0e, 0x01, 0xdc, 0x38, 0x2b, 0x6c, 0x68,
+  0x8a, 0xdd, 0xf2, 0x12, 0x13, 0x25, 0xc3, 0x31, 0x32, 0x4b, 0x4b, 0x8f,
+  0x84, 0x4b, 0x4a, 0xa6, 0x01, 0xf3, 0xfd, 0xa4, 0x89, 0x4e, 0x9a, 0x9f,
+  0xd2, 0x02, 0x60, 0x8f, 0x01, 0x3e, 0xfe, 0xc2, 0xa8, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x93, 0xff, 0xe3, 0x04, 0x09, 0x05, 0xf0, 0x10, 0x06,
+  0x01, 0x52, 0x00, 0x00, 0x00, 0x01, 0x00, 0x77, 0xfe, 0x67, 0x03, 0x68,
+  0x04, 0x7c, 0x00, 0x31, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x15, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x64, 0x65, 0x36,
+  0x36, 0x66, 0x66, 0xb0, 0x45, 0x99, 0x58, 0x57, 0x48, 0x49, 0x40, 0x74,
+  0x35, 0x3f, 0x3d, 0x3c, 0x69, 0x8b, 0x85, 0x7b, 0x41, 0x46, 0x4b, 0x4d,
+  0x88, 0x57, 0x49, 0x4c, 0x40, 0x51, 0x4b, 0x4d, 0x48, 0xd6, 0xe8, 0x7c,
+  0x01, 0xac, 0x20, 0x56, 0x55, 0x7b, 0xba, 0x68, 0x68, 0x1a, 0x26, 0xb6,
+  0x2d, 0x14, 0x15, 0x3e, 0x48, 0x6d, 0x6d, 0x46, 0x45, 0x98, 0x4d, 0x55,
+  0x85, 0x88, 0x55, 0x55, 0x1c, 0x1c, 0x38, 0xbe, 0x25, 0x13, 0x12, 0xf0,
+  0xe5, 0x8f, 0xc1, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x25,
+  0x04, 0x60, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x11, 0x23, 0xa7, 0x02, 0x7e, 0xfe, 0x2a, 0x01, 0xa6, 0xfe,
+  0x5a, 0xa8, 0x04, 0x60, 0x94, 0xfe, 0xd3, 0x94, 0xfd, 0xf5, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67, 0x04, 0x7b, 0x10, 0x06,
+  0x00, 0x56, 0x00, 0x00, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x08, 0xf0,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x12, 0x00, 0x15, 0x00, 0x00, 0x01, 0x33,
+  0x09, 0x01, 0x33, 0x01, 0x23, 0x03, 0x21, 0x03, 0x2b, 0x01, 0x03, 0x21,
+  0x03, 0x23, 0x01, 0x03, 0x21, 0x01, 0x03, 0x21, 0x02, 0x0f, 0xcf, 0x01,
+  0xa1, 0x01, 0xa3, 0xce, 0x02, 0x00, 0xbd, 0x7b, 0xfd, 0xa3, 0x7b, 0x02,
+  0xbd, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0, 0x02, 0x68, 0xf7, 0x01, 0xef, 0x03,
+  0x1a, 0xf6, 0x01, 0xee, 0x05, 0xd5, 0xfb, 0x3e, 0x04, 0xc2, 0xfa, 0x2b,
+  0x01, 0x7f, 0xfe, 0x81, 0x01, 0x7f, 0xfe, 0x81, 0x05, 0x0e, 0xfd, 0x19,
+  0x02, 0xe7, 0xfd, 0x19, 0x00, 0x04, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0x70,
+  0x04, 0x7b, 0x00, 0x0a, 0x00, 0x35, 0x00, 0x40, 0x00, 0x4d, 0x00, 0x00,
+  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x25,
+  0x11, 0x23, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x15, 0x23, 0x35, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x30, 0x17,
+  0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x3d, 0x01, 0x01, 0x16, 0x17, 0x36, 0x3b, 0x01, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x02, 0x78, 0xc9, 0x9b, 0x74, 0x64,
+  0x8a, 0xa6, 0x03, 0x54, 0xa6, 0x38, 0xaa, 0x7a, 0x63, 0x49, 0xa6, 0x38,
+  0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2, 0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c,
+  0x5b, 0xab, 0x51, 0xdb, 0x6c, 0x10, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0xfe,
+  0xb6, 0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0xfd, 0xc8, 0x2f, 0x01, 0x6d,
+  0xb3, 0xe8, 0x96, 0x88, 0x56, 0x52, 0x3b, 0x02, 0x33, 0x66, 0x7b, 0x62,
+  0x73, 0xd9, 0xb4, 0x29, 0x4c, 0xfd, 0x81, 0xaa, 0x66, 0x61, 0x27, 0x0a,
+  0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e,
+  0xaa, 0x27, 0x27, 0x7e, 0x14, 0x44, 0x27, 0x27, 0xfc, 0xfe, 0xb4, 0x66,
+  0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x01, 0x68, 0x6e, 0xa6, 0x3c, 0x12,
+  0x7f, 0x8b, 0x17, 0x10, 0x00, 0x03, 0x00, 0x0e, 0xff, 0xe3, 0x08, 0x43,
+  0x05, 0xf0, 0x00, 0x13, 0x00, 0x16, 0x00, 0x20, 0x00, 0x00, 0x01, 0x33,
+  0x13, 0x36, 0x37, 0x36, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20,
+  0x27, 0x26, 0x27, 0x21, 0x03, 0x23, 0x01, 0x03, 0x21, 0x00, 0x20, 0x02,
+  0x11, 0x10, 0x12, 0x20, 0x12, 0x11, 0x10, 0x02, 0x0f, 0xcf, 0xa5, 0x29,
+  0x64, 0xaa, 0x01, 0x1b, 0x01, 0x1b, 0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5,
+  0xfe, 0xe5, 0xaa, 0x47, 0x2a, 0xfd, 0xa9, 0x7a, 0xc0, 0x02, 0x68, 0xf7,
+  0x01, 0xef, 0x03, 0x2d, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe7, 0x05,
+  0xd5, 0xfe, 0x1e, 0xae, 0x7d, 0xd2, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0x9f,
+  0xfe, 0x5b, 0xd2, 0x58, 0x72, 0xfe, 0x81, 0x05, 0x0e, 0xfd, 0x19, 0x03,
+  0x25, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48, 0x01,
+  0x1a, 0x01, 0x1b, 0x00, 0x00, 0x03, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0xbc,
+  0x04, 0x7b, 0x00, 0x22, 0x00, 0x2d, 0x00, 0x38, 0x00, 0x00, 0x01, 0x32,
+  0x12, 0x11, 0x10, 0x02, 0x20, 0x27, 0x26, 0x27, 0x0e, 0x02, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x07, 0x35, 0x3e, 0x01, 0x33, 0x20, 0x17, 0x36, 0x01, 0x22, 0x06, 0x15,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x01, 0x22, 0x06, 0x10, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x04, 0xed, 0xd8, 0xf7, 0xf7, 0xfe,
+  0x4f, 0x7b, 0x31, 0x1e, 0x10, 0x56, 0x7e, 0xa0, 0xa0, 0xb7, 0xe3, 0xe2,
+  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0x01, 0x0c, 0x66,
+  0x7c, 0xfe, 0x7b, 0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0x01, 0xd1, 0x85,
+  0x9b, 0x9a, 0x86, 0x84, 0x9b, 0x9b, 0x04, 0x7b, 0xfe, 0xc8, 0xfe, 0xec,
+  0xfe, 0xed, 0xfe, 0xc7, 0x9d, 0x3e, 0x52, 0x45, 0x87, 0x61, 0xc1, 0xa2,
+  0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xbd, 0xbd,
+  0xfd, 0xb8, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x01, 0xac, 0xe7,
+  0xfe, 0x6e, 0xe7, 0xe8, 0xc8, 0xc7, 0xe9, 0x00, 0x00, 0x02, 0x00, 0x0e,
+  0xff, 0xe3, 0x07, 0x99, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x16, 0x00, 0x00,
+  0x01, 0x03, 0x21, 0x01, 0x33, 0x01, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11,
+  0x33, 0x11, 0x10, 0x00, 0x23, 0x20, 0x03, 0x27, 0x21, 0x03, 0x23, 0x02,
+  0x76, 0xf7, 0x01, 0xef, 0xfe, 0xa1, 0xcf, 0x01, 0x8f, 0x42, 0xe8, 0xaf,
+  0x9c, 0xb7, 0xfe, 0xfc, 0xfe, 0xfe, 0x9a, 0x69, 0x22, 0xfd, 0xa2, 0x7a,
+  0xc0, 0x05, 0x0e, 0xfd, 0x19, 0x03, 0xae, 0xfb, 0x72, 0xc0, 0xd3, 0xf0,
+  0x03, 0x8b, 0xfc, 0x5c, 0xfe, 0xdc, 0xfe, 0xd6, 0x01, 0x34, 0x68, 0xfe,
+  0x81, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6e, 0xff, 0xe3, 0x06, 0x69,
+  0x04, 0x7b, 0x00, 0x28, 0x00, 0x33, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x11, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11, 0x23, 0x35, 0x0e, 0x01, 0x23,
+  0x22, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01,
+  0x03, 0x37, 0x41, 0x91, 0xa0, 0x9f, 0xb7, 0xe3, 0xe2, 0xe8, 0x96, 0x88,
+  0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0x70, 0x6f, 0x86, 0x9c,
+  0xa6, 0xa6, 0x3c, 0x9f, 0x6a, 0xfe, 0xfe, 0xf8, 0xc9, 0x9b, 0x74, 0x64,
+  0x8a, 0xa6, 0xdf, 0x8d, 0x6f, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b,
+  0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc, 0xff, 0x00, 0xbe, 0x9f, 0x9f, 0xbe,
+  0xa4, 0x02, 0x7b, 0xfb, 0xa0, 0xac, 0x66, 0x63, 0x02, 0x50, 0x66, 0x7b,
+  0x62, 0x73, 0xd9, 0xb4, 0x29, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0e,
+  0x00, 0x00, 0x06, 0xef, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x0d, 0x00, 0x00,
+  0x01, 0x03, 0x21, 0x13, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33, 0x09, 0x01,
+  0x33, 0x01, 0x02, 0x76, 0xf7, 0x01, 0xef, 0xb3, 0x7b, 0xfd, 0xa2, 0x7a,
+  0xc0, 0x02, 0x01, 0xcf, 0x01, 0xac, 0x01, 0xa8, 0xbd, 0xfe, 0x00, 0x05,
+  0x0e, 0xfd, 0x19, 0xfd, 0xd9, 0x01, 0x7f, 0xfe, 0x81, 0x05, 0xd5, 0xfb,
+  0x1f, 0x04, 0xe1, 0xfa, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x6e,
+  0xff, 0xe3, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x0a, 0x00, 0x28, 0x00, 0x00,
+  0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x11,
+  0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x35,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16,
+  0x19, 0x01, 0x01, 0x33, 0x01, 0x02, 0x78, 0xc9, 0x9b, 0x74, 0x64, 0x8a,
+  0xa6, 0x38, 0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2, 0xe8, 0x96, 0x88, 0x56,
+  0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0x01, 0x3b, 0xb0, 0xfe, 0x86,
+  0x02, 0x33, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0xfd, 0xcd, 0xaa,
+  0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa,
+  0x27, 0x27, 0xfc, 0xff, 0x00, 0xfe, 0x35, 0x03, 0xac, 0xfb, 0xa0, 0x00,
+  0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x06, 0xef, 0x05, 0xd5, 0x00, 0x02,
+  0x00, 0x12, 0x00, 0x15, 0x00, 0x00, 0x01, 0x03, 0x29, 0x02, 0x15, 0x21,
+  0x03, 0x23, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33, 0x01, 0x33, 0x01, 0x33,
+  0x01, 0x23, 0x17, 0x02, 0x76, 0xf7, 0x01, 0xef, 0x02, 0x3e, 0x01, 0x43,
+  0xfe, 0x83, 0x83, 0xce, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0, 0x02, 0x01, 0xcf,
+  0x01, 0x43, 0xd1, 0x01, 0x40, 0xbd, 0xfd, 0xca, 0x5f, 0x30, 0x05, 0x0e,
+  0xfd, 0x19, 0xa8, 0xfe, 0x81, 0x01, 0x7f, 0xfe, 0x81, 0x05, 0xd5, 0xfc,
+  0x52, 0x03, 0xae, 0xfb, 0xaa, 0x8b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x6e,
+  0xff, 0xe3, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x22, 0x00, 0x2d, 0x00, 0x30,
+  0x00, 0x00, 0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
+  0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x33, 0x13, 0x33, 0x03, 0x33, 0x15, 0x23,
+  0x03, 0x01, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x3d, 0x01,
+  0x21, 0x23, 0x11, 0x03, 0x1c, 0x38, 0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2,
+  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0x6c, 0x5d,
+  0x0d, 0xb2, 0x8b, 0xb0, 0x8c, 0x8c, 0xbd, 0xbd, 0xfe, 0x45, 0xc9, 0x9b,
+  0x74, 0x64, 0x8a, 0xa6, 0x01, 0x27, 0x81, 0xaa, 0x66, 0x61, 0xc1, 0xa2,
+  0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0x7e, 0x6d,
+  0xcd, 0x01, 0x9d, 0xfe, 0x63, 0x90, 0xfd, 0xcd, 0x02, 0x33, 0x66, 0x7b,
+  0x62, 0x73, 0xd9, 0xb4, 0x29, 0xfe, 0x81, 0x00, 0x00, 0x02, 0x00, 0x0e,
+  0xfe, 0x56, 0x06, 0xd9, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x18, 0x00, 0x00,
+  0x01, 0x03, 0x21, 0x01, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x3f, 0x01, 0x03, 0x21, 0x03, 0x23, 0x01, 0x33, 0x09, 0x01,
+  0x33, 0x02, 0x76, 0xf7, 0x01, 0xef, 0x01, 0x47, 0x43, 0x46, 0x42, 0x70,
+  0xc2, 0x9a, 0x44, 0x26, 0x26, 0x2e, 0x11, 0x7b, 0xfd, 0xa2, 0x7a, 0xc0,
+  0x02, 0x01, 0xcf, 0x01, 0xa0, 0x01, 0x9d, 0xbd, 0x05, 0x0e, 0xfd, 0x19,
+  0xfd, 0x71, 0xc6, 0x3f, 0x3d, 0xaa, 0x24, 0x25, 0x85, 0x32, 0x01, 0x7f,
+  0xfe, 0x81, 0x05, 0xd5, 0xfb, 0x40, 0x04, 0xc0, 0x00, 0x02, 0x00, 0x6e,
+  0xfe, 0x56, 0x05, 0xad, 0x04, 0x7b, 0x00, 0x27, 0x00, 0x32, 0x00, 0x00,
+  0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3b, 0x01,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32,
+  0x16, 0x19, 0x01, 0x01, 0x33, 0x01, 0x0e, 0x01, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x36, 0x3f, 0x01, 0x03, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x36, 0x3d, 0x01, 0x03, 0x1c, 0x38, 0xa9, 0x7b, 0x9b, 0xb6, 0xe3, 0xe2,
+  0xe8, 0x96, 0x88, 0x56, 0xa4, 0x4c, 0x5b, 0xab, 0x51, 0xdb, 0xd8, 0x01,
+  0x3b, 0xb0, 0xfe, 0x45, 0x46, 0x86, 0x6f, 0x85, 0x62, 0x44, 0x4c, 0x2e,
+  0x17, 0xf1, 0xc9, 0x9b, 0x74, 0x64, 0x8a, 0xa6, 0xaa, 0x66, 0x61, 0xc1,
+  0xa2, 0xbd, 0xc0, 0x12, 0x7f, 0x8b, 0x2e, 0x2e, 0xaa, 0x27, 0x27, 0xfc,
+  0xff, 0x00, 0xfe, 0x77, 0x03, 0x6a, 0xfb, 0x38, 0xc8, 0x7a, 0x9a, 0x48,
+  0x86, 0x42, 0x02, 0x33, 0x66, 0x7b, 0x62, 0x73, 0xd9, 0xb4, 0x29, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4, 0x05, 0xf0, 0x10, 0x06,
+  0x03, 0x93, 0x00, 0x00, 0xff, 0xff, 0x00, 0x72, 0xff, 0xe3, 0x03, 0x90,
+  0x04, 0x7b, 0x10, 0x06, 0x03, 0x19, 0x00, 0x00, 0x00, 0x01, 0x00, 0x09,
+  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33,
+  0x15, 0x33, 0x15, 0x23, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
+  0x23, 0x11, 0x23, 0x35, 0x33, 0xb5, 0xb6, 0xac, 0xac, 0x02, 0x5b, 0xea,
+  0xfd, 0x65, 0x02, 0xca, 0xef, 0xfd, 0x7b, 0xb6, 0xac, 0xac, 0x05, 0xd5,
+  0xb9, 0xaa, 0xfe, 0xec, 0x02, 0x77, 0xfd, 0x48, 0xfc, 0xe3, 0x02, 0xcf,
+  0xfd, 0x31, 0x04, 0x72, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0c,
+  0x00, 0x00, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x12, 0x00, 0x00, 0x13, 0x33,
+  0x15, 0x21, 0x15, 0x21, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
+  0x23, 0x11, 0x23, 0x35, 0x33, 0xaf, 0xa6, 0x01, 0x05, 0xfe, 0xfb, 0x01,
+  0xee, 0xd4, 0xfd, 0xe9, 0x02, 0x2d, 0xd8, 0xfe, 0x00, 0xa6, 0xa2, 0xa2,
+  0x06, 0x14, 0xac, 0xa4, 0xfd, 0xb9, 0x01, 0xe3, 0xfd, 0xf4, 0xfd, 0xac,
+  0x02, 0x23, 0xfd, 0xdd, 0x04, 0xc4, 0xa4, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xdc, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x13, 0x11,
+  0x33, 0x11, 0x37, 0x11, 0x21, 0x15, 0x21, 0x11, 0xb5, 0xb6, 0xe3, 0x02,
+  0x8e, 0xfc, 0xbc, 0x02, 0xad, 0x03, 0x28, 0xfd, 0x5e, 0x4d, 0xfd, 0x2a,
+  0xaa, 0x02, 0xfa, 0x00, 0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x02, 0x26,
+  0x06, 0x14, 0x00, 0x07, 0x00, 0x00, 0x13, 0x11, 0x33, 0x11, 0x37, 0x11,
+  0x23, 0x11, 0xae, 0xa5, 0xd3, 0xa6, 0x02, 0x9c, 0x03, 0x78, 0xfd, 0x05,
+  0x49, 0xfc, 0x9e, 0x02, 0xe5, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x4a,
+  0x00, 0x00, 0x04, 0x26, 0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33,
+  0x15, 0x33, 0x15, 0x23, 0x11, 0x21, 0x15, 0x21, 0x11, 0x23, 0x35, 0x33,
+  0xe2, 0xb6, 0x97, 0x97, 0x02, 0x8e, 0xfc, 0xbc, 0x97, 0x97, 0x05, 0xd5,
+  0xe0, 0xa4, 0xfc, 0x59, 0xaa, 0x04, 0x51, 0xa4, 0x00, 0x01, 0x00, 0x6c,
+  0x00, 0x00, 0x02, 0xa7, 0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x33,
+  0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x01, 0x36,
+  0xa6, 0xcb, 0xcb, 0xa6, 0xca, 0xca, 0x06, 0x14, 0xfe, 0xe2, 0xa4, 0xfb,
+  0xae, 0x04, 0x52, 0xa4, 0x00, 0x03, 0x00, 0x09, 0xff, 0xe3, 0x05, 0xc6,
+  0x05, 0xf0, 0x00, 0x15, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x00, 0x01, 0x20,
+  0x17, 0x16, 0x13, 0x33, 0x15, 0x23, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27,
+  0x26, 0x03, 0x23, 0x35, 0x33, 0x12, 0x37, 0x36, 0x04, 0x20, 0x07, 0x06,
+  0x07, 0x21, 0x26, 0x27, 0x13, 0x21, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36,
+  0x02, 0xe8, 0x01, 0x1b, 0xa9, 0x91, 0x15, 0x74, 0x72, 0x0a, 0x9e, 0xa9,
+  0xfe, 0xe5, 0xfe, 0xe5, 0xa9, 0xa0, 0x0a, 0x71, 0x74, 0x15, 0x92, 0xa9,
+  0x01, 0xe1, 0xfe, 0x74, 0x74, 0x5f, 0x12, 0x03, 0x55, 0x11, 0x5f, 0x73,
+  0xfc, 0xa5, 0x09, 0x6b, 0x74, 0x01, 0x8c, 0x74, 0x6b, 0x05, 0xf0, 0xd2,
+  0xb5, 0xfe, 0xe3, 0x90, 0xfe, 0xbe, 0xc4, 0xd3, 0xd2, 0xc4, 0x01, 0x43,
+  0x90, 0x01, 0x1d, 0xb5, 0xd2, 0xa4, 0xa4, 0x86, 0xd6, 0xd6, 0x86, 0xfe,
+  0x14, 0xfa, 0x97, 0xa4, 0xa4, 0x97, 0x00, 0x00, 0x00, 0x03, 0x00, 0x09,
+  0xff, 0xe3, 0x05, 0x00, 0x04, 0x7b, 0x00, 0x15, 0x00, 0x1e, 0x00, 0x27,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x33, 0x15, 0x23, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x23, 0x35, 0x33, 0x36, 0x37, 0x36,
+  0x17, 0x22, 0x07, 0x06, 0x07, 0x21, 0x26, 0x27, 0x26, 0x13, 0x21, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x02, 0x85, 0xd8, 0x7c, 0x63, 0x13,
+  0xb1, 0xad, 0x09, 0x71, 0x7c, 0xd8, 0xd9, 0x7a, 0x71, 0x09, 0xaf, 0xb2,
+  0x13, 0x64, 0x7a, 0xd9, 0x85, 0x4d, 0x39, 0x0f, 0x02, 0x34, 0x0f, 0x39,
+  0x4d, 0x9a, 0xfd, 0xc2, 0x07, 0x45, 0x4d, 0x86, 0x85, 0x4d, 0x45, 0x04,
+  0x7b, 0x9c, 0x7e, 0xcd, 0x90, 0xf4, 0x90, 0x9d, 0x9d, 0x90, 0xf4, 0x90,
+  0xcd, 0x7e, 0x9c, 0x9c, 0x73, 0x55, 0x83, 0x81, 0x55, 0x75, 0xfe, 0x25,
+  0xab, 0x67, 0x73, 0x74, 0x67, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x67,
+  0xff, 0xe3, 0x09, 0x60, 0x05, 0xf0, 0x00, 0x1a, 0x00, 0x24, 0x00, 0x2e,
+  0x00, 0x00, 0x01, 0x20, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x21, 0x20, 0x00, 0x10, 0x00, 0x04, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20,
+  0x12, 0x11, 0x10, 0x00, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20, 0x12, 0x11,
+  0x10, 0x02, 0xd6, 0x01, 0x1b, 0xa9, 0x2a, 0x20, 0x1f, 0x2a, 0xaa, 0x01,
+  0x1b, 0x01, 0x1b, 0x01, 0x52, 0xfe, 0xae, 0xfe, 0xe5, 0xfe, 0xe5, 0xaa,
+  0x2a, 0x20, 0x1f, 0x2a, 0xa9, 0xfe, 0xe5, 0xfe, 0xe5, 0xfe, 0xad, 0x01,
+  0x53, 0x01, 0xe1, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0x03, 0x34,
+  0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0x05, 0xf0, 0xd2, 0x35, 0x3d,
+  0x3d, 0x35, 0xd2, 0xfe, 0x5b, 0xfe, 0x9e, 0xfe, 0x9f, 0xfe, 0x5b, 0xd2,
+  0x34, 0x3d, 0x3c, 0x34, 0xd3, 0x01, 0xa4, 0x02, 0xc4, 0x01, 0xa5, 0xa4,
+  0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8, 0x01, 0x48, 0x01, 0x1a,
+  0x01, 0x1b, 0x01, 0x48, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8,
+  0x01, 0x48, 0x01, 0x1a, 0x01, 0x1b, 0x00, 0x00, 0x00, 0x03, 0x00, 0x65,
+  0xff, 0xe3, 0x06, 0xf1, 0x04, 0x7b, 0x00, 0x0a, 0x00, 0x15, 0x00, 0x31,
+  0x00, 0x00, 0x01, 0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x21, 0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x27, 0x32, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12, 0x11,
+  0x10, 0x02, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x02, 0x11, 0x10, 0x12, 0x05, 0x22, 0x85, 0x9b, 0x9a, 0x86, 0x84, 0x9b,
+  0x9b, 0xfc, 0x8e, 0x85, 0x9b, 0x9a, 0x86, 0x85, 0x9a, 0x9a, 0x85, 0xd8,
+  0x7c, 0x12, 0x11, 0x10, 0x13, 0x7b, 0xd9, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9,
+  0x7b, 0x13, 0x10, 0x11, 0x12, 0x7c, 0xd8, 0xd9, 0xf5, 0xf5, 0x03, 0xdf,
+  0xe7, 0xfe, 0x6e, 0xe7, 0xe8, 0xc8, 0xc7, 0xe9, 0xe7, 0xfe, 0x6e, 0xe7,
+  0xe8, 0xc8, 0xc7, 0xe9, 0x9c, 0x9c, 0x18, 0x1b, 0x1b, 0x18, 0x9c, 0xfe,
+  0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x9d, 0x18, 0x1b, 0x1b, 0x18,
+  0x9d, 0x01, 0x39, 0x01, 0x13, 0x01, 0x14, 0x01, 0x38, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x09, 0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x1d, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x25, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x2b, 0x01,
+  0x15, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x01, 0x6b,
+  0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xfe, 0x66, 0x01, 0x9a, 0xe2, 0x73, 0x74,
+  0x74, 0x73, 0xe2, 0xe4, 0xd5, 0xd5, 0xb6, 0xac, 0xac, 0x05, 0x2f, 0xfd,
+  0xcf, 0x92, 0x87, 0x86, 0x92, 0xa6, 0x71, 0x72, 0xdb, 0xdd, 0x71, 0x71,
+  0xc4, 0x90, 0xfe, 0xfc, 0x01, 0x04, 0x90, 0x00, 0x00, 0x02, 0xff, 0xfb,
+  0xfe, 0x56, 0x04, 0x2e, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x1f, 0x00, 0x00,
+  0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20, 0x01, 0x35, 0x33, 0x11,
+  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26,
+  0x27, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x03, 0x81, 0x96, 0xfe,
+  0xf9, 0x96, 0x96, 0x01, 0x07, 0xfd, 0x11, 0xab, 0xa7, 0x34, 0x9f, 0x6f,
+  0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xe4, 0xe4, 0xa7, 0x01, 0x64,
+  0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0xfe, 0x67, 0x90, 0x04, 0xec,
+  0xaa, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x64, 0xfe,
+  0xcc, 0x90, 0x8e, 0x8e, 0x00, 0x02, 0x00, 0x2d, 0x00, 0x00, 0x05, 0x0a,
+  0x05, 0xd5, 0x00, 0x1e, 0x00, 0x27, 0x00, 0x00, 0x01, 0x21, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x23, 0x22, 0x07, 0x06,
+  0x15, 0x16, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x3b, 0x03, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x01, 0xa6,
+  0x01, 0x9a, 0xe2, 0xe8, 0xe8, 0xe2, 0xe4, 0xb6, 0x28, 0x53, 0x2b, 0x35,
+  0x01, 0x18, 0x15, 0x35, 0x3d, 0x47, 0x3e, 0x3f, 0x72, 0x58, 0x91, 0x1e,
+  0xb6, 0xe4, 0x7f, 0x8b, 0x8b, 0x7f, 0xe4, 0x05, 0xd5, 0xe3, 0xdb, 0xdd,
+  0xe2, 0xfd, 0xa8, 0x02, 0x58, 0x18, 0x1f, 0x3d, 0x35, 0x27, 0x20, 0x18,
+  0x94, 0x17, 0x49, 0x4b, 0x7d, 0x93, 0x4c, 0x3b, 0x92, 0x87, 0x86, 0x92,
+  0x00, 0x02, 0x00, 0x2d, 0xfe, 0x56, 0x05, 0x2f, 0x04, 0x7b, 0x00, 0x0c,
+  0x00, 0x31, 0x00, 0x00, 0x01, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x26, 0x20, 0x06, 0x15, 0x03, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10,
+  0x02, 0x23, 0x22, 0x27, 0x11, 0x23, 0x02, 0x4f, 0x09, 0x8e, 0x83, 0x80,
+  0x4f, 0x4b, 0x97, 0xfe, 0xfa, 0x97, 0xa6, 0x2e, 0x25, 0x28, 0x2e, 0x35,
+  0x19, 0x15, 0x35, 0x3d, 0x47, 0x3e, 0x3f, 0x72, 0x4b, 0x5e, 0x30, 0x31,
+  0xa6, 0x35, 0x9f, 0x6f, 0xb7, 0xe6, 0xe6, 0xb6, 0xac, 0x98, 0xa6, 0x01,
+  0x32, 0x0b, 0xaa, 0x73, 0x70, 0xcf, 0xcb, 0xe7, 0xe7, 0xcb, 0xfe, 0xe3,
+  0x19, 0x18, 0x1b, 0x41, 0x34, 0x28, 0x20, 0x18, 0x94, 0x17, 0x49, 0x4b,
+  0x7d, 0x86, 0x59, 0x3b, 0x17, 0x02, 0xa6, 0xaa, 0x64, 0x61, 0xfe, 0xbc,
+  0xfd, 0xf0, 0xfe, 0xbc, 0xa2, 0xfd, 0xd1, 0x00, 0x00, 0x02, 0x00, 0x67,
+  0xfe, 0x94, 0x05, 0x44, 0x05, 0xf0, 0x00, 0x09, 0x00, 0x23, 0x00, 0x00,
+  0x00, 0x20, 0x02, 0x11, 0x10, 0x12, 0x20, 0x12, 0x11, 0x10, 0x01, 0x27,
+  0x37, 0x27, 0x07, 0x06, 0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x02, 0x07, 0x17, 0x37, 0x17, 0x07, 0x17, 0x23, 0x27,
+  0x03, 0x9c, 0xfe, 0x74, 0xe9, 0xe9, 0x01, 0x8c, 0xe8, 0xfe, 0xa6, 0x41,
+  0x99, 0x60, 0x2e, 0x10, 0x0e, 0xfe, 0xe5, 0xfe, 0xad, 0x01, 0x53, 0x01,
+  0x1b, 0x01, 0x1b, 0x01, 0x52, 0xbc, 0xb2, 0x3e, 0xc2, 0x40, 0xa9, 0x58,
+  0xdb, 0x0d, 0x05, 0x4c, 0xfe, 0xb8, 0xfe, 0xe5, 0xfe, 0xe6, 0xfe, 0xb8,
+  0x01, 0x48, 0x01, 0x1a, 0x01, 0x1b, 0xfa, 0x90, 0x7d, 0x62, 0x74, 0x03,
+  0x01, 0x01, 0xa5, 0x01, 0x61, 0x01, 0x62, 0x01, 0xa5, 0xfe, 0x5b, 0xfe,
+  0x9e, 0xfe, 0xfc, 0xfe, 0x8e, 0x58, 0x4b, 0x7c, 0x7d, 0x6c, 0x6b, 0x0f,
+  0x00, 0x02, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x97, 0x04, 0x7b, 0x00, 0x17,
+  0x00, 0x1f, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x10, 0x12,
+  0x33, 0x32, 0x16, 0x17, 0x35, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23,
+  0x35, 0x23, 0x35, 0x33, 0x00, 0x10, 0x16, 0x20, 0x36, 0x10, 0x26, 0x20,
+  0x03, 0x45, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34,
+  0xa6, 0xab, 0xab, 0xa6, 0xe5, 0xe5, 0xfd, 0xcc, 0x96, 0x01, 0x07, 0x97,
+  0x97, 0xfe, 0xf9, 0xa8, 0x64, 0x61, 0x01, 0x44, 0x02, 0x10, 0x01, 0x44,
+  0x61, 0x64, 0xaa, 0xfb, 0x14, 0x90, 0x8e, 0x8e, 0x90, 0x03, 0x86, 0xfe,
+  0x6a, 0xe7, 0xe7, 0x01, 0x96, 0xe7, 0x00, 0x00, 0x00, 0x02, 0x00, 0x09,
+  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x01, 0x33, 0x15, 0x33,
+  0x15, 0x23, 0x15, 0x33, 0x32, 0x16, 0x10, 0x06, 0x2b, 0x01, 0x11, 0x23,
+  0x11, 0x23, 0x35, 0x33, 0x01, 0x6b, 0xe4, 0x7f, 0x8b, 0x8a, 0x80, 0xfe,
+  0x66, 0xb6, 0xd5, 0xd5, 0xe4, 0xe2, 0xe7, 0xe7, 0xe2, 0xe4, 0xb6, 0xac,
+  0xac, 0x04, 0x27, 0xfd, 0xd1, 0x92, 0x01, 0x0c, 0x91, 0x01, 0xae, 0x2d,
+  0x90, 0x4b, 0xe1, 0xfe, 0x48, 0xe2, 0xfe, 0xae, 0x05, 0x18, 0x90, 0x00,
+  0x00, 0x02, 0xff, 0xfb, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x07,
+  0x00, 0x1f, 0x00, 0x00, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
+  0x25, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x33, 0x15, 0x33, 0x15,
+  0x23, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26,
+  0x03, 0x81, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07, 0xfe, 0x63, 0xa7,
+  0xab, 0xab, 0xa7, 0xe4, 0xe4, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8,
+  0x6f, 0x9f, 0x01, 0x64, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0x2b,
+  0xfd, 0xae, 0x06, 0x9b, 0x90, 0x93, 0x93, 0x90, 0xfe, 0xc5, 0x64, 0x61,
+  0xfe, 0xbc, 0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x00, 0x00, 0x02, 0x00, 0x09,
+  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x32, 0x36, 0x10, 0x26, 0x23, 0x01, 0x33, 0x11, 0x33,
+  0x32, 0x16, 0x10, 0x06, 0x2b, 0x01, 0x15, 0x33, 0x15, 0x23, 0x15, 0x23,
+  0x35, 0x23, 0x35, 0x33, 0x01, 0x6b, 0xe4, 0x7f, 0x8b, 0x8a, 0x80, 0xfe,
+  0x66, 0xb6, 0xe4, 0xe2, 0xe7, 0xe7, 0xe2, 0xe4, 0xd5, 0xd5, 0xb6, 0xac,
+  0xac, 0x04, 0x27, 0xfd, 0xd1, 0x92, 0x01, 0x0c, 0x91, 0x01, 0xae, 0xfe,
+  0xf8, 0xe1, 0xfe, 0x48, 0xe2, 0x5e, 0x90, 0x64, 0x64, 0x90, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xfb, 0xfe, 0x56, 0x04, 0x2e, 0x06, 0x14, 0x00, 0x07,
+  0x00, 0x1f, 0x00, 0x00, 0x00, 0x10, 0x26, 0x20, 0x06, 0x10, 0x16, 0x20,
+  0x01, 0x35, 0x33, 0x11, 0x33, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10,
+  0x02, 0x23, 0x22, 0x26, 0x27, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35,
+  0x03, 0x81, 0x96, 0xfe, 0xf9, 0x96, 0x96, 0x01, 0x07, 0xfd, 0x11, 0xab,
+  0xa7, 0x34, 0x9f, 0x6f, 0xb8, 0xe5, 0xe5, 0xb8, 0x6f, 0x9f, 0x34, 0xe4,
+  0xe4, 0xa7, 0x01, 0x64, 0x01, 0x96, 0xe7, 0xe7, 0xfe, 0x6a, 0xe7, 0xfe,
+  0x67, 0x90, 0x06, 0xa0, 0xfd, 0xa2, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0,
+  0xfe, 0xbc, 0x61, 0x64, 0xfe, 0xcc, 0x90, 0x8e, 0x8e, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x09, 0x00, 0x00, 0x03, 0x4e, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x21, 0x35, 0x21, 0x03, 0x4e, 0xb6, 0xfd,
+  0x72, 0x03, 0x44, 0x05, 0x2b, 0xaa, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad,
+  0xfe, 0x56, 0x01, 0x54, 0x04, 0x7b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00,
+  0x01, 0x07, 0x33, 0x11, 0x23, 0x01, 0x00, 0x52, 0xa5, 0xa5, 0x04, 0x7b,
+  0x1b, 0xf9, 0xf6, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x04, 0x97,
+  0x05, 0xf0, 0x00, 0x14, 0x00, 0x00, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x12,
+  0x19, 0x01, 0x23, 0x03, 0xe2, 0x8b, 0x8a, 0xa1, 0xc1, 0xb6, 0xb6, 0x48,
+  0x5c, 0x5b, 0x8e, 0xcd, 0xd1, 0xb4, 0x03, 0x7f, 0xd7, 0xd5, 0xff, 0xde,
+  0xfb, 0x08, 0x07, 0x7f, 0xf1, 0x87, 0x43, 0x42, 0xfe, 0xc1, 0xfe, 0xcc,
+  0xfc, 0x83, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0xfe, 0x56, 0x03, 0xf4,
+  0x04, 0x7b, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x03, 0xf4, 0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7, 0xa7, 0x3b,
+  0xa1, 0x6a, 0xad, 0xb3, 0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x9e, 0x9f, 0x9e,
+  0xbe, 0xa4, 0xfb, 0xdd, 0x06, 0x0a, 0xae, 0x65, 0x64, 0xef, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xd8, 0x00, 0x00, 0x01, 0x96, 0x04, 0x23, 0x12, 0x06,
+  0x00, 0x1d, 0x00, 0x00, 0x00, 0x02, 0x00, 0x90, 0x01, 0x49, 0x02, 0x25,
+  0x03, 0x0b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21,
+  0x35, 0x21, 0x35, 0x21, 0x02, 0x25, 0xfe, 0x6b, 0x01, 0x95, 0xfe, 0x6b,
+  0x01, 0x95, 0x01, 0x49, 0x96, 0x96, 0x96, 0x00, 0x00, 0x01, 0x01, 0x16,
+  0x01, 0xe1, 0x01, 0xcd, 0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x01, 0x33,
+  0x11, 0x03, 0x23, 0x03, 0x01, 0x16, 0xb7, 0x12, 0x92, 0x13, 0x05, 0xd5,
+  0xfd, 0x71, 0xfe, 0x9b, 0x01, 0x65, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb1,
+  0x03, 0xaa, 0x01, 0x4b, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x01, 0x4a, 0x99, 0x05, 0xd5, 0xfd, 0xd5, 0x02, 0x2b, 0x00,
+  0xff, 0xff, 0x00, 0x9d, 0x00, 0x00, 0x04, 0x3b, 0x05, 0xd5, 0x12, 0x06,
+  0x03, 0xbb, 0x00, 0x00, 0x00, 0x02, 0x00, 0x45, 0xfe, 0x56, 0x02, 0xff,
+  0x06, 0x14, 0x00, 0x06, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x26, 0x23, 0x22,
+  0x07, 0x14, 0x33, 0x37, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x11, 0x14,
+  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0x30, 0x03, 0x23, 0x22,
+  0x37, 0x36, 0x33, 0x32, 0x01, 0x6a, 0x15, 0x31, 0x46, 0x01, 0x53, 0x48,
+  0xa6, 0xe1, 0xe1, 0x37, 0x6c, 0x2c, 0x3f, 0xac, 0x8a, 0x02, 0x36, 0xfc,
+  0x01, 0x01, 0xdd, 0x30, 0x03, 0x12, 0x84, 0x4b, 0x39, 0xfa, 0x02, 0x08,
+  0xfc, 0xfe, 0xa0, 0xfd, 0x70, 0x7c, 0x74, 0x9c, 0xcc, 0xca, 0x02, 0x86,
+  0xbd, 0xf6, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xfe, 0xbf, 0x05, 0x47,
+  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x13, 0x33, 0x01, 0x11, 0x33, 0x11,
+  0x33, 0x11, 0x23, 0x11, 0x23, 0x01, 0x11, 0x23, 0xb5, 0xf5, 0x02, 0x54,
+  0xb0, 0x99, 0x99, 0xf5, 0xfd, 0xac, 0xb0, 0x05, 0xd5, 0xfb, 0x1f, 0x04,
+  0xe1, 0xfa, 0xd5, 0xfe, 0x15, 0x01, 0x41, 0x04, 0xe1, 0xfb, 0x1f, 0x00,
+  0x00, 0x01, 0x00, 0xa7, 0xfe, 0xe5, 0x04, 0x78, 0x04, 0x7b, 0x00, 0x17,
+  0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x23, 0x11, 0x23, 0x11, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x11, 0x23, 0x11, 0x33, 0x15, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x03, 0xf4, 0x84, 0x84, 0xa6, 0x70, 0x6f, 0x86, 0x9b, 0xa7,
+  0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0xb3, 0x02, 0xa4, 0xfd, 0xef, 0xfe, 0x52,
+  0x01, 0x1b, 0x02, 0x9e, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x87, 0x04, 0x60,
+  0xae, 0x65, 0x64, 0xef, 0x00, 0x01, 0x00, 0x03, 0xff, 0xe3, 0x05, 0x9a,
+  0x05, 0xf0, 0x00, 0x28, 0x00, 0x00, 0x25, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x0e, 0x01, 0x23, 0x24, 0x27, 0x26, 0x27, 0x07, 0x27, 0x37, 0x34, 0x35,
+  0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x07,
+  0x06, 0x03, 0x01, 0x17, 0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x04,
+  0x49, 0xfe, 0xd7, 0x01, 0xdd, 0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xb2, 0x7f,
+  0x24, 0x4c, 0x26, 0x64, 0x01, 0x63, 0x01, 0x3b, 0x83, 0xed, 0x64, 0x65,
+  0xe3, 0x7d, 0xf5, 0x7d, 0x79, 0x03, 0x04, 0x4c, 0x27, 0xfb, 0x94, 0x16,
+  0x5f, 0x7d, 0xf5, 0x61, 0x97, 0xd5, 0x01, 0x91, 0xa6, 0xfd, 0x7f, 0x53,
+  0x55, 0x01, 0xcc, 0x92, 0xe2, 0x1c, 0x7f, 0x25, 0x1e, 0x1f, 0x01, 0x6e,
+  0x01, 0x99, 0x48, 0x46, 0xd7, 0x5f, 0x60, 0x99, 0x97, 0xfe, 0xd9, 0x01,
+  0x95, 0x7f, 0xfe, 0x5f, 0xcf, 0x77, 0x99, 0x25, 0x00, 0x03, 0x00, 0x03,
+  0xfe, 0x56, 0x04, 0x8f, 0x04, 0x7b, 0x00, 0x26, 0x00, 0x30, 0x00, 0x3a,
+  0x00, 0x00, 0x25, 0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01,
+  0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x07, 0x27, 0x37, 0x26, 0x35, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35,
+  0x33, 0x11, 0x37, 0x17, 0x0f, 0x01, 0x05, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x15, 0x14,
+  0x17, 0x03, 0xeb, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a, 0xa3,
+  0xa2, 0x33, 0xa0, 0x70, 0xba, 0x71, 0x3c, 0x1c, 0x5e, 0x1d, 0x68, 0x06,
+  0xe2, 0xba, 0x70, 0xa0, 0x33, 0xa6, 0x86, 0x1d, 0xa3, 0xa7, 0xfd, 0xdc,
+  0x12, 0x29, 0x4a, 0x85, 0x86, 0x95, 0x0c, 0x11, 0x2d, 0x4a, 0x87, 0x85,
+  0x94, 0x01, 0x8b, 0xfe, 0xe2, 0xfe, 0xe9, 0x1d, 0x1e, 0xb3, 0x2c, 0x2a,
+  0xbd, 0xbf, 0x5b, 0x63, 0x62, 0x9d, 0x53, 0x70, 0x23, 0x63, 0x27, 0x38,
+  0x3e, 0x01, 0x04, 0x01, 0x3a, 0x62, 0x63, 0xaa, 0xfe, 0xb1, 0x32, 0x63,
+  0x3d, 0x3d, 0xcb, 0x57, 0x3c, 0x6e, 0xdc, 0xc7, 0x15, 0x7e, 0x62, 0x41,
+  0x6e, 0xdc, 0xc8, 0x1d, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x03,
+  0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00,
+  0x13, 0x33, 0x11, 0x01, 0x33, 0x01, 0x17, 0x25, 0x17, 0x05, 0x01, 0x23,
+  0x01, 0x07, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x25, 0x27, 0x15, 0xb5,
+  0xb6, 0x02, 0x5b, 0xea, 0xfd, 0x65, 0x6d, 0x02, 0x16, 0x27, 0xfe, 0x22,
+  0x01, 0xfe, 0xef, 0xfe, 0x3d, 0xc2, 0xb6, 0x8b, 0x26, 0xb1, 0x01, 0x19,
+  0x63, 0x05, 0xd5, 0xfd, 0x89, 0x02, 0x77, 0xfd, 0x48, 0x7a, 0xc5, 0x7f,
+  0xb0, 0xfd, 0xc7, 0x01, 0xf7, 0x48, 0xfe, 0x51, 0x01, 0x6c, 0x33, 0x7f,
+  0x41, 0x68, 0x6e, 0x93, 0x00, 0x02, 0x00, 0x03, 0x00, 0x00, 0x04, 0x28,
+  0x06, 0x14, 0x00, 0x13, 0x00, 0x16, 0x00, 0x00, 0x13, 0x33, 0x11, 0x01,
+  0x33, 0x01, 0x17, 0x25, 0x17, 0x05, 0x01, 0x23, 0x01, 0x07, 0x11, 0x23,
+  0x35, 0x07, 0x27, 0x37, 0x25, 0x27, 0x15, 0xa7, 0xa7, 0x01, 0xee, 0xd4,
+  0xfd, 0xe9, 0x55, 0x01, 0xbc, 0x1e, 0xfe, 0x72, 0x01, 0x8c, 0xd8, 0xfe,
+  0xab, 0xab, 0xa7, 0x86, 0x1d, 0xa3, 0x01, 0x05, 0x5e, 0x06, 0x14, 0xfc,
+  0x69, 0x01, 0xe3, 0xfd, 0xf4, 0x5b, 0xa4, 0x62, 0x93, 0xfe, 0x58, 0x01,
+  0x6c, 0x3f, 0xfe, 0xd3, 0xf0, 0x32, 0x63, 0x3c, 0x61, 0x65, 0x88, 0x00,
+  0x00, 0x03, 0x00, 0x03, 0x00, 0x00, 0x05, 0x60, 0x05, 0xd5, 0x00, 0x13,
+  0x00, 0x16, 0x00, 0x19, 0x00, 0x00, 0x13, 0x33, 0x01, 0x25, 0x11, 0x33,
+  0x11, 0x37, 0x17, 0x07, 0x11, 0x23, 0x01, 0x05, 0x11, 0x23, 0x11, 0x07,
+  0x27, 0x37, 0x25, 0x03, 0x11, 0x25, 0x13, 0x11, 0xb5, 0xf5, 0x01, 0x3b,
+  0x01, 0x19, 0xb0, 0x8a, 0x27, 0xb1, 0xf5, 0xfe, 0xc9, 0xfe, 0xe3, 0xb0,
+  0x8b, 0x26, 0xb1, 0x01, 0x93, 0xe3, 0x01, 0xb9, 0xe0, 0x05, 0xd5, 0xfd,
+  0x6b, 0x67, 0x02, 0x2e, 0xfe, 0x13, 0x33, 0x7f, 0x41, 0xfc, 0xa5, 0x02,
+  0x8e, 0x69, 0xfd, 0xdb, 0x01, 0xe4, 0x33, 0x7f, 0x41, 0x95, 0x01, 0xdb,
+  0xfd, 0xd1, 0x16, 0xfe, 0x2c, 0x02, 0x26, 0x00, 0x00, 0x02, 0x00, 0x03,
+  0x00, 0x00, 0x04, 0x8f, 0x04, 0x7b, 0x00, 0x17, 0x00, 0x20, 0x00, 0x00,
+  0x01, 0x11, 0x23, 0x11, 0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x11,
+  0x33, 0x15, 0x3e, 0x01, 0x33, 0x36, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07,
+  0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x03, 0xf4, 0xa6,
+  0xfe, 0x00, 0xa7, 0x86, 0x1d, 0xa3, 0xa7, 0x3b, 0xa1, 0x6a, 0xad, 0x59,
+  0x43, 0x11, 0x83, 0x1d, 0x9a, 0xa8, 0x08, 0x2e, 0x38, 0x6f, 0x86, 0x9b,
+  0x02, 0xa4, 0xfd, 0x5c, 0x02, 0x6a, 0xbe, 0xfe, 0x54, 0x01, 0x6f, 0x32,
+  0x63, 0x3d, 0x02, 0x83, 0xae, 0x65, 0x64, 0x01, 0x78, 0x59, 0x99, 0x31,
+  0x63, 0x39, 0x30, 0x75, 0x40, 0x4f, 0xbe, 0xa4, 0x5f, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x03, 0x00, 0x00, 0x04, 0xfe, 0x05, 0xd5, 0x00, 0x1d,
+  0x00, 0x24, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x1e, 0x01, 0x17, 0x13, 0x23,
+  0x03, 0x2e, 0x01, 0x2b, 0x01, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x11,
+  0x21, 0x32, 0x17, 0x16, 0x17, 0x37, 0x17, 0x07, 0x14, 0x15, 0x14, 0x06,
+  0x2d, 0x01, 0x26, 0x27, 0x26, 0x27, 0x23, 0x11, 0x15, 0x33, 0x16, 0x37,
+  0x36, 0x37, 0x03, 0x32, 0x3b, 0x6e, 0x38, 0xb9, 0xc4, 0xac, 0x42, 0x7d,
+  0x6c, 0xc6, 0xb6, 0x8b, 0x26, 0xb1, 0x01, 0x9a, 0xe7, 0x71, 0x42, 0x1c,
+  0xd1, 0x27, 0xe5, 0x75, 0xfd, 0xc8, 0x01, 0xe3, 0x10, 0x28, 0x42, 0x85,
+  0xe4, 0xe4, 0x85, 0x42, 0x37, 0x0a, 0x02, 0xbc, 0x16, 0x90, 0x7e, 0xfe,
+  0x68, 0x01, 0x7f, 0x96, 0x62, 0xfd, 0x89, 0x03, 0x01, 0x33, 0x7f, 0x42,
+  0x02, 0x46, 0x6b, 0x3e, 0x64, 0x4e, 0x7f, 0x55, 0x0d, 0x0e, 0x8d, 0xba,
+  0xf2, 0xb3, 0x3f, 0x28, 0x42, 0x01, 0xfe, 0x16, 0x28, 0x01, 0x44, 0x38,
+  0x63, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x02, 0xf6,
+  0x04, 0x7b, 0x00, 0x19, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x06,
+  0x1d, 0x01, 0x25, 0x17, 0x05, 0x11, 0x23, 0x11, 0x07, 0x27, 0x37, 0x11,
+  0x33, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x02, 0xf6, 0x1c, 0x42,
+  0x27, 0x8d, 0x96, 0x01, 0x86, 0x1e, 0xfe, 0x5c, 0xa7, 0x86, 0x1d, 0xa3,
+  0xa7, 0x34, 0xa8, 0x77, 0x11, 0x2a, 0x19, 0x03, 0xb4, 0x12, 0x11, 0xcb,
+  0xbe, 0x34, 0x90, 0x62, 0x9c, 0xfe, 0x54, 0x01, 0x6f, 0x32, 0x63, 0x3c,
+  0x02, 0x84, 0xae, 0x66, 0x63, 0x05, 0x05, 0x00, 0x00, 0x01, 0x00, 0x03,
+  0xff, 0xe3, 0x04, 0x8f, 0x05, 0xf0, 0x00, 0x2f, 0x00, 0x00, 0x01, 0x15,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x25, 0x17,
+  0x05, 0x16, 0x17, 0x16, 0x15, 0x14, 0x04, 0x23, 0x22, 0x26, 0x27, 0x35,
+  0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x05, 0x27,
+  0x25, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x03, 0xda,
+  0x67, 0xb8, 0x55, 0x95, 0xa1, 0x6b, 0x96, 0x4b, 0x01, 0xec, 0x26, 0xfe,
+  0xbd, 0x4f, 0x30, 0x61, 0xfe, 0xfb, 0xfd, 0x60, 0xd7, 0x73, 0x6f, 0xd4,
+  0x67, 0x9b, 0xaa, 0x7a, 0x8b, 0x57, 0xfe, 0x18, 0x26, 0x01, 0x41, 0x45,
+  0x2c, 0x5a, 0xfb, 0xdc, 0x5f, 0xc4, 0x05, 0xa4, 0xc5, 0x37, 0x36, 0x80,
+  0x76, 0x63, 0x65, 0x1f, 0x11, 0xb5, 0x7f, 0x77, 0x27, 0x38, 0x6c, 0xb6,
+  0xd9, 0xe0, 0x30, 0x2f, 0xd0, 0x45, 0x46, 0x88, 0x7e, 0x6e, 0x7c, 0x1f,
+  0x13, 0xb4, 0x7f, 0x77, 0x22, 0x2e, 0x60, 0xab, 0xc6, 0xe4, 0x26, 0x00,
+  0x00, 0x01, 0x00, 0x03, 0xff, 0xe3, 0x03, 0xbd, 0x04, 0x7b, 0x00, 0x2f,
+  0x00, 0x00, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x1f, 0x01, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x2f, 0x01, 0x05, 0x27, 0x25, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x03, 0x30, 0x46, 0x97, 0x51, 0x7b, 0x7c, 0x59, 0x85, 0x28,
+  0x01, 0x8e, 0x1e, 0xfe, 0xf3, 0x44, 0x28, 0x49, 0x01, 0xde, 0xc2, 0x51,
+  0xb0, 0x61, 0x5c, 0xb2, 0x57, 0x75, 0x7e, 0x5b, 0x9a, 0x20, 0xfe, 0x7a,
+  0x1d, 0x01, 0x06, 0x38, 0x22, 0x45, 0xca, 0xb9, 0x5c, 0xa2, 0x04, 0x3f,
+  0xae, 0x28, 0x28, 0x54, 0x54, 0x40, 0x49, 0x21, 0x0a, 0x93, 0x63, 0x63,
+  0x20, 0x28, 0x4c, 0x89, 0x9c, 0xb6, 0x23, 0x23, 0xbe, 0x35, 0x35, 0x59,
+  0x51, 0x4b, 0x50, 0x25, 0x08, 0x90, 0x63, 0x61, 0x1b, 0x26, 0x4a, 0x83,
+  0x9e, 0xac, 0x1e, 0x00, 0x00, 0x01, 0xff, 0xa1, 0x00, 0x00, 0x05, 0x10,
+  0x05, 0xd5, 0x00, 0x14, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x1d, 0x01, 0x23,
+  0x35, 0x34, 0x36, 0x3b, 0x01, 0x11, 0x21, 0x11, 0x33, 0x11, 0x23, 0x11,
+  0x21, 0x11, 0x23, 0x01, 0x0f, 0x77, 0x6a, 0x8c, 0xac, 0xc1, 0xb6, 0x02,
+  0x94, 0xb6, 0xb6, 0xfd, 0x6c, 0xb6, 0x05, 0x30, 0x01, 0x5e, 0x69, 0x31,
+  0x46, 0xb5, 0xa3, 0xfd, 0x9c, 0x02, 0x64, 0xfa, 0x2b, 0x02, 0xc7, 0xfd,
+  0x39, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x05, 0xf0,
+  0x04, 0x60, 0x12, 0x06, 0x03, 0xdc, 0x00, 0x00, 0x00, 0x01, 0x00, 0x6b,
+  0x00, 0x00, 0x03, 0x70, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x03, 0x6f, 0xb5, 0xfd,
+  0xeb, 0x02, 0x15, 0xfd, 0xb1, 0x05, 0xd5, 0xfa, 0x2b, 0x02, 0xc9, 0xaa,
+  0x01, 0xb8, 0xaa, 0x00, 0x00, 0x02, 0x00, 0x3f, 0x00, 0x00, 0x03, 0xa3,
+  0x05, 0xd5, 0x00, 0x08, 0x00, 0x13, 0x00, 0x00, 0x01, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x3b, 0x01, 0x13, 0x11, 0x23, 0x11, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x33, 0x02, 0xed, 0xe5, 0x7f, 0x8a, 0x8a, 0x7f, 0xe5,
+  0xb6, 0xb6, 0xe5, 0xe2, 0xe7, 0xe7, 0xe2, 0x05, 0x2f, 0x92, 0x86, 0x87,
+  0x92, 0x02, 0xd7, 0xfa, 0x2b, 0x02, 0x58, 0xe2, 0xdd, 0xdb, 0xe3, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x00, 0x0c,
+  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x01, 0x33, 0x01, 0x11, 0x33, 0x11,
+  0x21, 0x09, 0x01, 0xb5, 0xb0, 0x01, 0x5b, 0xb6, 0x01, 0x5b, 0xb1, 0xfe,
+  0xf1, 0xfe, 0xa8, 0xfe, 0xa9, 0x05, 0xd5, 0xfa, 0xe1, 0x04, 0x00, 0xfc,
+  0x00, 0x05, 0x1f, 0xfa, 0x2b, 0x03, 0xf8, 0xfc, 0x08, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x6b, 0x07, 0x6d, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0xb5, 0xb6, 0xb6, 0x07, 0x6d, 0xf8,
+  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3d, 0x00, 0x00, 0x08, 0x67,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x25, 0x01, 0x33, 0x09, 0x01, 0x33,
+  0x01, 0x23, 0x09, 0x01, 0x23, 0x09, 0x01, 0x23, 0x01, 0x33, 0x03, 0x8f,
+  0x01, 0x1e, 0xcc, 0x01, 0x1b, 0x01, 0x1a, 0xb8, 0xfe, 0xaf, 0xe5, 0xfe,
+  0xe4, 0xfe, 0xe2, 0xcc, 0xfe, 0xe5, 0xfe, 0xe7, 0xb9, 0x01, 0x52, 0xe4,
+  0xc5, 0x05, 0x10, 0xfb, 0x12, 0x04, 0xee, 0xfa, 0x2b, 0x05, 0x10, 0xfa,
+  0xf0, 0x04, 0xee, 0xfb, 0x12, 0x05, 0xd5, 0x00, 0x00, 0x01, 0x00, 0xae,
+  0x04, 0xd0, 0x02, 0x53, 0x05, 0x58, 0x00, 0x03, 0x00, 0x00, 0x01, 0x21,
+  0x35, 0x21, 0x02, 0x53, 0xfe, 0x5c, 0x01, 0xa4, 0x04, 0xd0, 0x88, 0x00,
+  0x00, 0x01, 0x00, 0x7e, 0x03, 0x9c, 0x02, 0x77, 0x05, 0x58, 0x00, 0x04,
+  0x00, 0x00, 0x13, 0x27, 0x01, 0x33, 0x15, 0xc1, 0x42, 0x01, 0xd4, 0x24,
+  0x03, 0x9c, 0x73, 0x01, 0x49, 0x88, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0x02, 0x68, 0x02, 0x9a, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
+  0x01, 0x27, 0x01, 0x33, 0x02, 0x9a, 0x0e, 0xfe, 0x35, 0x5e, 0x01, 0xf0,
+  0x47, 0x04, 0xd0, 0xfd, 0x98, 0x57, 0x02, 0x99, 0x00, 0x01, 0x00, 0x56,
+  0x01, 0x34, 0x02, 0xa7, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
+  0x01, 0x27, 0x01, 0x33, 0x02, 0xa7, 0x0d, 0xfe, 0x27, 0x6b, 0x01, 0xfd,
+  0x54, 0x04, 0xd0, 0xfc, 0x64, 0x44, 0x03, 0xe0, 0x00, 0x01, 0x00, 0x51,
+  0x00, 0x00, 0x02, 0xad, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x23,
+  0x01, 0x27, 0x01, 0x33, 0x02, 0xad, 0x0a, 0xfe, 0x1e, 0x70, 0x02, 0x02,
+  0x5a, 0x04, 0xd0, 0xfb, 0x30, 0x37, 0x05, 0x21, 0x00, 0x01, 0x00, 0x7e,
+  0x03, 0x9c, 0x02, 0x77, 0x05, 0x58, 0x00, 0x04, 0x00, 0x00, 0x13, 0x01,
+  0x15, 0x23, 0x01, 0xc1, 0x01, 0xb6, 0x24, 0xfe, 0x2c, 0x05, 0x58, 0xfe,
+  0xcc, 0x88, 0x01, 0x49, 0xff, 0xff, 0x00, 0xae, 0x03, 0x9c, 0x02, 0x53,
+  0x04, 0x24, 0x10, 0x07, 0x0e, 0xa9, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x7e, 0x02, 0x68, 0x02, 0x77, 0x04, 0x24, 0x10, 0x07,
+  0x0e, 0xaa, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63,
+  0x01, 0x34, 0x02, 0x9a, 0x04, 0x24, 0x10, 0x07, 0x0e, 0xab, 0x00, 0x00,
+  0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x56, 0x00, 0x00, 0x02, 0xa7,
+  0x04, 0x24, 0x10, 0x07, 0x0e, 0xac, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x63, 0x02, 0x68, 0x02, 0x9a, 0x05, 0x58, 0x00, 0x05,
+  0x00, 0x00, 0x01, 0x15, 0x23, 0x01, 0x37, 0x01, 0x02, 0x9a, 0x47, 0xfe,
+  0x10, 0x5e, 0x01, 0xcb, 0x02, 0xf0, 0x88, 0x02, 0x99, 0x57, 0xfd, 0x98,
+  0xff, 0xff, 0x00, 0x7e, 0x02, 0x68, 0x02, 0x77, 0x04, 0x24, 0x10, 0x07,
+  0x0e, 0xae, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0xae,
+  0x02, 0x68, 0x02, 0x53, 0x02, 0xf0, 0x10, 0x07, 0x0e, 0xa9, 0x00, 0x00,
+  0xfd, 0x98, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e, 0x01, 0x34, 0x02, 0x77,
+  0x02, 0xf0, 0x10, 0x07, 0x0e, 0xaa, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0x00, 0x00, 0x02, 0x9a, 0x02, 0xf0, 0x10, 0x07,
+  0x0e, 0xab, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00, 0x00, 0x01, 0x00, 0x56,
+  0x01, 0x34, 0x02, 0xa7, 0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x01, 0x15,
+  0x23, 0x01, 0x37, 0x01, 0x02, 0xa7, 0x54, 0xfe, 0x03, 0x6b, 0x01, 0xd9,
+  0x01, 0xbc, 0x88, 0x03, 0xe0, 0x44, 0xfc, 0x64, 0xff, 0xff, 0x00, 0x63,
+  0x01, 0x34, 0x02, 0x9a, 0x04, 0x24, 0x10, 0x07, 0x0e, 0xb3, 0x00, 0x00,
+  0xfe, 0xcc, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e, 0x01, 0x34, 0x02, 0x77,
+  0x02, 0xf0, 0x10, 0x07, 0x0e, 0xae, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xae, 0x01, 0x34, 0x02, 0x53, 0x01, 0xbc, 0x10, 0x07,
+  0x0e, 0xa9, 0x00, 0x00, 0xfc, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e,
+  0x00, 0x00, 0x02, 0x77, 0x01, 0xbc, 0x10, 0x07, 0x0e, 0xaa, 0x00, 0x00,
+  0xfc, 0x64, 0x00, 0x00, 0x00, 0x01, 0x00, 0x51, 0x00, 0x00, 0x02, 0xad,
+  0x05, 0x58, 0x00, 0x05, 0x00, 0x00, 0x25, 0x15, 0x23, 0x01, 0x37, 0x01,
+  0x02, 0xad, 0x5a, 0xfd, 0xfe, 0x70, 0x01, 0xe2, 0x88, 0x88, 0x05, 0x21,
+  0x37, 0xfb, 0x30, 0x00, 0xff, 0xff, 0x00, 0x56, 0x00, 0x00, 0x02, 0xa7,
+  0x04, 0x24, 0x10, 0x07, 0x0e, 0xb8, 0x00, 0x00, 0xfe, 0xcc, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x63, 0x00, 0x00, 0x02, 0x9a, 0x02, 0xf0, 0x10, 0x07,
+  0x0e, 0xb3, 0x00, 0x00, 0xfd, 0x98, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7e,
+  0x00, 0x00, 0x02, 0x77, 0x01, 0xbc, 0x10, 0x07, 0x0e, 0xae, 0x00, 0x00,
+  0xfc, 0x64, 0x00, 0x00, 0xff, 0xff, 0x00, 0xae, 0x00, 0x00, 0x02, 0x53,
+  0x00, 0x88, 0x11, 0x07, 0x0e, 0xa9, 0x00, 0x00, 0xfb, 0x30, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xc0, 0x00, 0x00, 0x01, 0x3b, 0x05, 0x58, 0x00, 0x03,
+  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0xc1, 0x7a, 0x05, 0x58, 0xfa, 0xa8,
+  0x00, 0x0e, 0x00, 0x87, 0x00, 0x00, 0x06, 0x81, 0x05, 0xdc, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
+  0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33,
+  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
+  0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
+  0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11,
+  0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
+  0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
+  0x06, 0x27, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01,
+  0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0xfe, 0x98, 0x5a,
+  0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7,
+  0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2,
+  0xfd, 0x44, 0x02, 0x4e, 0xfd, 0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88,
+  0x64, 0x64, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd,
+  0xad, 0x02, 0x4e, 0xfd, 0xb2, 0x02, 0xbc, 0x02, 0x4e, 0xfd, 0xb2, 0xfd,
+  0x44, 0x02, 0x4e, 0xfd, 0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88, 0x64,
+  0x64, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd, 0xad,
+  0x02, 0x4e, 0xfd, 0xb2, 0x00, 0x0e, 0x00, 0x87, 0x00, 0x00, 0x06, 0x81,
+  0x05, 0xdc, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13,
+  0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b,
+  0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
+  0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
+  0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
+  0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15,
+  0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15,
+  0x01, 0x11, 0x33, 0x11, 0x06, 0x27, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01,
+  0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7,
+  0x5a, 0xfe, 0x98, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11,
+  0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x03, 0x1b,
+  0x02, 0x58, 0xfd, 0xa8, 0xfd, 0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19,
+  0x64, 0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8,
+  0x5f, 0x64, 0x64, 0xfd, 0xa3, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0xbc, 0x02,
+  0x58, 0xfd, 0xa8, 0xfd, 0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19, 0x64,
+  0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8, 0x5f,
+  0x64, 0x64, 0xfd, 0xa3, 0x02, 0x58, 0xfd, 0xa8, 0x00, 0x0e, 0x00, 0x87,
+  0x00, 0x00, 0x06, 0x81, 0x05, 0xdc, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23,
+  0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15,
+  0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15,
+  0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
+  0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
+  0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x06, 0x27, 0x5a, 0x5a,
+  0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7, 0x5a,
+  0x01, 0xef, 0xfd, 0xb7, 0x5a, 0xfe, 0x98, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7,
+  0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd,
+  0xb7, 0x5a, 0x03, 0x25, 0x02, 0x4e, 0xfd, 0xb2, 0xfd, 0x44, 0x02, 0x4e,
+  0xfd, 0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x25,
+  0x02, 0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd, 0xad, 0x02, 0x4e, 0xfd,
+  0xb2, 0x02, 0xbc, 0x02, 0x4e, 0xfd, 0xb2, 0xfd, 0x44, 0x02, 0x4e, 0xfd,
+  0xb2, 0x05, 0x0f, 0x64, 0x64, 0xfa, 0x88, 0x64, 0x64, 0x03, 0x25, 0x02,
+  0x4e, 0xfd, 0xb2, 0x69, 0x64, 0x64, 0xfd, 0xad, 0x02, 0x4e, 0xfd, 0xb2,
+  0x00, 0x0e, 0x00, 0x87, 0x00, 0x00, 0x06, 0x81, 0x05, 0xdc, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b,
+  0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33,
+  0x00, 0x37, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x03, 0x11, 0x33, 0x11,
+  0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
+  0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x33, 0x11,
+  0x03, 0x11, 0x33, 0x11, 0x01, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15,
+  0x01, 0x11, 0x33, 0x11, 0x15, 0x35, 0x21, 0x15, 0x01, 0x11, 0x33, 0x11,
+  0x06, 0x27, 0x5a, 0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01,
+  0xef, 0xfd, 0xb7, 0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0xfe, 0x98, 0x5a,
+  0x5a, 0x5a, 0xfd, 0xb7, 0x01, 0xef, 0xfe, 0x11, 0x01, 0xef, 0xfd, 0xb7,
+  0x5a, 0x01, 0xef, 0xfd, 0xb7, 0x5a, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8,
+  0xfd, 0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19, 0x64, 0x64, 0xfa, 0x88,
+  0x64, 0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8, 0x5f, 0x64, 0x64, 0xfd,
+  0xa3, 0x02, 0x58, 0xfd, 0xa8, 0x02, 0xbc, 0x02, 0x58, 0xfd, 0xa8, 0xfd,
+  0x44, 0x02, 0x58, 0xfd, 0xa8, 0x05, 0x19, 0x64, 0x64, 0xfa, 0x88, 0x64,
+  0x64, 0x03, 0x1b, 0x02, 0x58, 0xfd, 0xa8, 0x5f, 0x64, 0x64, 0xfd, 0xa3,
+  0x02, 0x58, 0xfd, 0xa8, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb,
+  0x06, 0x9f, 0x00, 0x15, 0x00, 0x00, 0x01, 0x15, 0x10, 0x21, 0x20, 0x11,
+  0x35, 0x13, 0x33, 0x03, 0x15, 0x10, 0x21, 0x20, 0x11, 0x35, 0x34, 0x00,
+  0x11, 0x33, 0x16, 0x00, 0x03, 0xca, 0xfe, 0x56, 0xfe, 0x43, 0x35, 0xb4,
+  0x3e, 0x01, 0x12, 0x01, 0x08, 0xfe, 0x41, 0xa3, 0x01, 0x01, 0xbd, 0x02,
+  0xa1, 0x9f, 0xfd, 0xe0, 0x02, 0x25, 0x8b, 0x01, 0x09, 0xfe, 0xda, 0x73,
+  0xfe, 0x80, 0x01, 0x8a, 0xb8, 0xf9, 0x01, 0xcb, 0x01, 0x17, 0xc5, 0xfe,
+  0x07, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb,
+  0x06, 0x9f, 0x00, 0x09, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x12, 0x25, 0x04,
+  0x03, 0x15, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15, 0x10, 0x20, 0x11, 0x35,
+  0x10, 0x25, 0x33, 0x36, 0x27, 0x26, 0x27, 0x33, 0x14, 0x16, 0x07, 0x33,
+  0x04, 0x03, 0x28, 0x01, 0xfe, 0xe8, 0xfe, 0xfe, 0x01, 0x01, 0x09, 0x01,
+  0x11, 0xa2, 0xfc, 0x99, 0x01, 0x6b, 0x12, 0x2e, 0x78, 0x78, 0x02, 0xbb,
+  0xc4, 0x21, 0x12, 0x01, 0x3c, 0x02, 0x9d, 0x01, 0x67, 0x0b, 0x08, 0xfe,
+  0x82, 0x55, 0xfe, 0x4e, 0x01, 0xad, 0x4b, 0x37, 0xfd, 0x9f, 0x02, 0x61,
+  0x3c, 0x01, 0xeb, 0x3d, 0xa3, 0x51, 0x52, 0xb2, 0x6c, 0x9e, 0xf3, 0x45,
+  0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x04, 0x1b, 0x06, 0xb3, 0x00, 0x09,
+  0x00, 0x21, 0x00, 0x00, 0x01, 0x10, 0x21, 0x20, 0x11, 0x15, 0x10, 0x21,
+  0x20, 0x11, 0x37, 0x15, 0x10, 0x21, 0x20, 0x11, 0x35, 0x10, 0x25, 0x33,
+  0x36, 0x27, 0x36, 0x23, 0x22, 0x15, 0x23, 0x10, 0x21, 0x20, 0x03, 0x06,
+  0x07, 0x04, 0x03, 0x70, 0xfe, 0xd8, 0xfe, 0xc6, 0x01, 0x36, 0x01, 0x2c,
+  0xaa, 0xfe, 0x26, 0xfe, 0x23, 0x01, 0xd3, 0x55, 0x45, 0x02, 0x01, 0xab,
+  0xa4, 0x93, 0x01, 0x34, 0x01, 0x3a, 0x01, 0x0b, 0x3d, 0x01, 0x08, 0x02,
+  0x7e, 0x01, 0xa4, 0xfe, 0x62, 0x5f, 0xfe, 0x5d, 0x01, 0xa3, 0x61, 0x57,
+  0xfd, 0xb3, 0x02, 0x3e, 0x78, 0x01, 0xd6, 0x4e, 0x5c, 0x61, 0x9a, 0xc4,
+  0x01, 0x64, 0xfe, 0xc1, 0x8b, 0x55, 0x72, 0x00, 0x00, 0x02, 0x00, 0x63,
+  0x00, 0x00, 0x06, 0x04, 0x06, 0xb3, 0x00, 0x24, 0x00, 0x2e, 0x00, 0x00,
+  0x37, 0x36, 0x37, 0x00, 0x11, 0x35, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33,
+  0x20, 0x11, 0x15, 0x10, 0x05, 0x24, 0x11, 0x35, 0x34, 0x37, 0x26, 0x23,
+  0x22, 0x11, 0x15, 0x10, 0x01, 0x17, 0x04, 0x17, 0x23, 0x26, 0x27, 0x26,
+  0x07, 0x01, 0x10, 0x23, 0x22, 0x11, 0x15, 0x02, 0x17, 0x36, 0x13, 0xf2,
+  0x59, 0x73, 0xfe, 0xa5, 0x01, 0x8d, 0x98, 0x8f, 0x5b, 0xe8, 0x01, 0xaa,
+  0xfe, 0x56, 0xfe, 0x62, 0x23, 0x4b, 0x9c, 0xeb, 0x01, 0x7e, 0xbf, 0x01,
+  0x5f, 0x33, 0xee, 0x0c, 0xd6, 0xe8, 0xdc, 0x04, 0x11, 0xff, 0xf6, 0x01,
+  0xf7, 0xfe, 0x01, 0xc3, 0x4e, 0x21, 0x01, 0x56, 0x01, 0xc6, 0x6d, 0x01,
+  0xf8, 0xb3, 0xa9, 0xfd, 0xff, 0x95, 0xfd, 0xd2, 0x1e, 0x1c, 0x02, 0x30,
+  0x77, 0x5f, 0x8c, 0x9a, 0xfe, 0xb7, 0x63, 0xfe, 0x2d, 0xfe, 0xb1, 0x18,
+  0x53, 0xd6, 0x52, 0x40, 0x40, 0xb4, 0x04, 0x5d, 0x01, 0x8f, 0xfe, 0x9e,
+  0x9a, 0xfe, 0x77, 0x1d, 0x1c, 0x01, 0x6c, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe2, 0x03, 0xcb, 0x06, 0xb3, 0x00, 0x17, 0x00, 0x00, 0x01, 0x10,
+  0x21, 0x20, 0x1b, 0x01, 0x33, 0x03, 0x10, 0x21, 0x04, 0x19, 0x01, 0x34,
+  0x23, 0x22, 0x11, 0x17, 0x23, 0x03, 0x10, 0x21, 0x20, 0x11, 0x03, 0xca,
+  0xfe, 0x47, 0xfe, 0x52, 0x01, 0x51, 0xbb, 0x63, 0x01, 0x0a, 0x01, 0x1a,
+  0xff, 0xdb, 0x4b, 0xab, 0x3f, 0x01, 0x87, 0x01, 0x8b, 0x01, 0xc8, 0xfe,
+  0x1a, 0x01, 0xe9, 0x01, 0x2f, 0xfe, 0xd1, 0xfe, 0xb7, 0x01, 0x01, 0x4f,
+  0x03, 0x73, 0xd1, 0xfe, 0xff, 0xf6, 0x01, 0x0d, 0x01, 0x89, 0xfe, 0x8b,
+  0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb, 0x06, 0xb3, 0x00, 0x21,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x16, 0x1d, 0x01, 0x10, 0x20, 0x11, 0x13,
+  0x33, 0x03, 0x10, 0x21, 0x20, 0x11, 0x35, 0x34, 0x27, 0x23, 0x35, 0x33,
+  0x36, 0x03, 0x34, 0x23, 0x06, 0x07, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20,
+  0x03, 0xa6, 0x04, 0xb9, 0xe1, 0xfc, 0x99, 0x30, 0xb0, 0x36, 0x01, 0x0a,
+  0x01, 0x11, 0xab, 0x99, 0x52, 0xc6, 0x02, 0xe2, 0xe9, 0x02, 0x21, 0xa8,
+  0x16, 0x01, 0x88, 0x01, 0x8e, 0x05, 0x1b, 0xe6, 0x7c, 0x73, 0xfe, 0x7d,
+  0xfe, 0x17, 0x02, 0x01, 0x01, 0x17, 0xfe, 0xe0, 0xfe, 0xa8, 0x01, 0x4e,
+  0x73, 0xcd, 0x28, 0xa9, 0x50, 0x01, 0x0a, 0xda, 0x01, 0xf5, 0x9a, 0x9e,
+  0x01, 0x90, 0x00, 0x00, 0x00, 0x03, 0x00, 0x63, 0xff, 0xe2, 0x04, 0x51,
+  0x06, 0xb3, 0x00, 0x09, 0x00, 0x13, 0x00, 0x26, 0x00, 0x00, 0x01, 0x12,
+  0x07, 0x22, 0x15, 0x14, 0x17, 0x36, 0x37, 0x33, 0x01, 0x10, 0x21, 0x20,
+  0x11, 0x15, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15, 0x10, 0x21, 0x20, 0x11,
+  0x35, 0x34, 0x37, 0x26, 0x35, 0x10, 0x21, 0x20, 0x11, 0x14, 0x07, 0x33,
+  0x04, 0x02, 0x89, 0x02, 0xc1, 0xbc, 0x5e, 0x5b, 0xad, 0x10, 0x01, 0x1e,
+  0xfe, 0xe7, 0xfe, 0xd5, 0x01, 0x26, 0x01, 0x1e, 0xae, 0xfe, 0x33, 0xfe,
+  0x30, 0x5b, 0xab, 0x01, 0x5e, 0x01, 0x69, 0x0b, 0x0a, 0x01, 0x27, 0x04,
+  0xde, 0x01, 0x36, 0x01, 0xdf, 0xb4, 0x5f, 0x63, 0x09, 0xfd, 0xe5, 0x01,
+  0x88, 0xfe, 0x76, 0x4b, 0xfe, 0x5d, 0x01, 0x9b, 0x58, 0x4b, 0xfd, 0xb8,
+  0x02, 0x52, 0x46, 0x8d, 0xbc, 0x94, 0xce, 0x01, 0x8e, 0xfe, 0x2e, 0x25,
+  0x40, 0x7f, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x05, 0xf7,
+  0x06, 0xb3, 0x00, 0x09, 0x00, 0x22, 0x00, 0x00, 0x01, 0x10, 0x23, 0x22,
+  0x19, 0x01, 0x10, 0x33, 0x32, 0x11, 0x25, 0x02, 0x03, 0x23, 0x36, 0x13,
+  0x11, 0x10, 0x23, 0x22, 0x03, 0x11, 0x10, 0x21, 0x20, 0x19, 0x01, 0x10,
+  0x21, 0x36, 0x17, 0x36, 0x33, 0x20, 0x13, 0x02, 0xf5, 0xf2, 0xf8, 0xf8,
+  0xf2, 0x03, 0x01, 0x09, 0xb7, 0xef, 0xee, 0x15, 0xda, 0xc2, 0x11, 0xfe,
+  0x5d, 0xfe, 0x69, 0x01, 0xa0, 0xc9, 0x86, 0x68, 0xde, 0x01, 0x5d, 0x01,
+  0x04, 0x92, 0x01, 0x82, 0xfe, 0x7e, 0xfd, 0x93, 0xfe, 0x5c, 0x01, 0xa4,
+  0x9b, 0xfe, 0x46, 0xfe, 0xfa, 0xe5, 0x01, 0xdb, 0x01, 0xd2, 0x01, 0x79,
+  0xfe, 0xed, 0xfd, 0x2d, 0xfd, 0xbd, 0x02, 0x43, 0x02, 0x6d, 0x02, 0x21,
+  0x02, 0xe6, 0xda, 0xfd, 0xe9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0x00, 0x00, 0x03, 0x9d, 0x06, 0xb3, 0x00, 0x15, 0x00, 0x00, 0x01, 0x10,
+  0x03, 0x23, 0x12, 0x19, 0x01, 0x10, 0x23, 0x20, 0x19, 0x01, 0x10, 0x13,
+  0x23, 0x02, 0x19, 0x01, 0x10, 0x21, 0x20, 0x11, 0x03, 0x9c, 0x8b, 0xb2,
+  0x93, 0xdc, 0xfe, 0xf8, 0x9d, 0xb4, 0x94, 0x01, 0xb3, 0x01, 0x86, 0x02,
+  0xfb, 0xfe, 0x8a, 0xfe, 0x7b, 0x01, 0x43, 0x01, 0xb8, 0x01, 0x9a, 0x01,
+  0x7e, 0xfe, 0x82, 0xfe, 0x66, 0xfe, 0x53, 0xfe, 0xb2, 0x01, 0x79, 0x01,
+  0x82, 0x01, 0x9a, 0x02, 0x1e, 0xfd, 0xe2, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe2, 0x03, 0xcb, 0x06, 0xa0, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x02,
+  0x21, 0x20, 0x11, 0x13, 0x33, 0x03, 0x10, 0x05, 0x20, 0x11, 0x35, 0x10,
+  0x2b, 0x01, 0x35, 0x33, 0x36, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x10,
+  0x07, 0x16, 0x11, 0x03, 0xca, 0x01, 0xfe, 0x4e, 0xfe, 0x4c, 0x27, 0xb9,
+  0x36, 0x01, 0x0a, 0x01, 0x11, 0xbd, 0xc6, 0x9e, 0xe5, 0xb4, 0xfc, 0x5a,
+  0xe1, 0xe1, 0x01, 0xc6, 0xfe, 0x1c, 0x01, 0xf3, 0x01, 0x24, 0xfe, 0xdc,
+  0xfe, 0xae, 0x01, 0x01, 0x44, 0x78, 0x01, 0x3c, 0xa8, 0x81, 0xaf, 0x95,
+  0xb9, 0xbe, 0x6d, 0xfe, 0xf7, 0x64, 0x63, 0xfe, 0x9e, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x63, 0x00, 0x00, 0x08, 0x07, 0x06, 0xb3, 0x00, 0x35,
+  0x00, 0x00, 0x25, 0x36, 0x37, 0x24, 0x03, 0x35, 0x10, 0x21, 0x32, 0x17,
+  0x36, 0x20, 0x17, 0x36, 0x33, 0x20, 0x11, 0x15, 0x14, 0x03, 0x23, 0x12,
+  0x3d, 0x01, 0x12, 0x23, 0x22, 0x15, 0x11, 0x23, 0x11, 0x10, 0x23, 0x06,
+  0x15, 0x11, 0x23, 0x11, 0x26, 0x23, 0x22, 0x11, 0x15, 0x12, 0x05, 0x36,
+  0x17, 0x04, 0x13, 0x21, 0x26, 0x25, 0x24, 0x01, 0x01, 0x3a, 0x68, 0x82,
+  0xfe, 0x6a, 0x2b, 0x01, 0x8b, 0xd1, 0x65, 0x5a, 0x01, 0x74, 0x62, 0x55,
+  0xdb, 0x01, 0x83, 0xc9, 0xb8, 0xe2, 0x01, 0xe3, 0xe7, 0x9b, 0xcc, 0xc5,
+  0x9c, 0x02, 0xe8, 0xdf, 0x28, 0x01, 0x87, 0x6e, 0x81, 0x01, 0xda, 0xf6,
+  0xfe, 0xef, 0x24, 0xfe, 0xbd, 0xfe, 0xbe, 0xfe, 0xe9, 0xa6, 0x78, 0x43,
+  0xf3, 0x01, 0xf0, 0x7b, 0x01, 0xeb, 0xb2, 0xbb, 0xbb, 0xb2, 0xfe, 0x1f,
+  0x67, 0xba, 0xfe, 0x64, 0x01, 0xb1, 0xc8, 0x3f, 0x01, 0x47, 0xe7, 0xfe,
+  0x5a, 0x01, 0xa6, 0x01, 0x00, 0x02, 0xfe, 0xfe, 0x5a, 0x01, 0xa6, 0xe7,
+  0xfe, 0xb7, 0x79, 0xfe, 0x41, 0xe9, 0x17, 0x0b, 0x23, 0xfe, 0x76, 0xa5,
+  0x5c, 0x5b, 0xfe, 0xc3, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9,
+  0x06, 0xb3, 0x00, 0x09, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x11, 0x26, 0x27,
+  0x20, 0x11, 0x15, 0x10, 0x05, 0x20, 0x13, 0x10, 0x21, 0x20, 0x11, 0x35,
+  0x10, 0x25, 0x32, 0x17, 0x35, 0x34, 0x21, 0x22, 0x06, 0x15, 0x23, 0x10,
+  0x21, 0x20, 0x11, 0x03, 0x30, 0x5f, 0xa6, 0xfe, 0xe3, 0x01, 0x1b, 0x01,
+  0x07, 0x98, 0xfe, 0x61, 0xfe, 0x3a, 0x01, 0xb3, 0x8e, 0x8d, 0xfe, 0xfe,
+  0x8a, 0x6f, 0xa1, 0x01, 0x8e, 0x01, 0xa5, 0x01, 0xda, 0x01, 0xcb, 0x3f,
+  0x01, 0xfe, 0xc1, 0xb8, 0xfe, 0x95, 0x01, 0x01, 0x62, 0xfd, 0xfe, 0x02,
+  0x02, 0xae, 0x01, 0xee, 0x14, 0x4a, 0xd1, 0xf9, 0x71, 0x6c, 0x01, 0x7c,
+  0xfe, 0x63, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75, 0xff, 0xe2, 0x03, 0xdd,
+  0x06, 0xa0, 0x00, 0x09, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x10, 0x21, 0x22,
+  0x07, 0x11, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15, 0x10, 0x21, 0x20, 0x19,
+  0x01, 0x10, 0x29, 0x01, 0x15, 0x21, 0x22, 0x1d, 0x01, 0x36, 0x33, 0x20,
+  0x03, 0x3a, 0xfe, 0xe8, 0x97, 0x74, 0x01, 0x16, 0x01, 0x0d, 0xa2, 0xfe,
+  0x46, 0xfe, 0x53, 0x01, 0x2f, 0x01, 0xd0, 0xfe, 0x35, 0x9b, 0x98, 0x7e,
+  0x01, 0xb8, 0x02, 0xab, 0x01, 0x4f, 0x4b, 0xfe, 0x26, 0xfe, 0xad, 0x01,
+  0x44, 0xfe, 0xfa, 0xfe, 0x18, 0x01, 0xe8, 0x03, 0x54, 0x01, 0x82, 0xa0,
+  0xe6, 0xc7, 0x55, 0x00, 0x00, 0x01, 0x00, 0x63, 0x00, 0x00, 0x05, 0xdf,
+  0x06, 0xb3, 0x00, 0x20, 0x00, 0x00, 0x01, 0x10, 0x01, 0x23, 0x00, 0x19,
+  0x01, 0x10, 0x23, 0x22, 0x19, 0x01, 0x23, 0x11, 0x10, 0x23, 0x22, 0x19,
+  0x01, 0x10, 0x01, 0x23, 0x00, 0x19, 0x01, 0x10, 0x21, 0x32, 0x17, 0x36,
+  0x33, 0x20, 0x11, 0x05, 0xdf, 0xfe, 0xe6, 0xc9, 0x01, 0x3b, 0xf3, 0xce,
+  0xa5, 0xef, 0xd3, 0x01, 0x1e, 0xc1, 0xfe, 0xf7, 0x01, 0x91, 0xc8, 0x6c,
+  0x75, 0xa7, 0x01, 0x9b, 0x02, 0xc2, 0xfe, 0x66, 0xfe, 0xd8, 0x01, 0x6e,
+  0x01, 0x55, 0x01, 0xcf, 0x01, 0x83, 0xfe, 0xcf, 0xfd, 0x82, 0x02, 0x87,
+  0x01, 0x28, 0xfe, 0x7d, 0xfe, 0x31, 0xfe, 0xa7, 0xfe, 0x96, 0x01, 0x28,
+  0x01, 0x9b, 0x01, 0xcf, 0x02, 0x21, 0xf0, 0xf0, 0xfd, 0xdf, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xcb, 0x06, 0x9f, 0x00, 0x1e,
+  0x00, 0x00, 0x01, 0x15, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10,
+  0x21, 0x20, 0x11, 0x35, 0x34, 0x27, 0x23, 0x35, 0x33, 0x36, 0x35, 0x34,
+  0x24, 0x35, 0x33, 0x14, 0x04, 0x15, 0x14, 0x07, 0x16, 0x03, 0xca, 0xfe,
+  0x5f, 0xfe, 0x3a, 0x12, 0xb3, 0x1a, 0x01, 0x16, 0x01, 0x04, 0x9e, 0xc4,
+  0x67, 0xe9, 0xfe, 0x87, 0xc6, 0x01, 0x55, 0xd3, 0xe5, 0x01, 0xd7, 0x25,
+  0xfe, 0x30, 0x01, 0xdf, 0xb3, 0xb3, 0xfe, 0xc1, 0x01, 0x3f, 0x43, 0xc0,
+  0x2d, 0xb6, 0x3f, 0xb0, 0xa3, 0x72, 0xf4, 0x96, 0x8e, 0xdd, 0xb2, 0x79,
+  0x6e, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xca,
+  0x06, 0xc1, 0x00, 0x16, 0x00, 0x00, 0x01, 0x10, 0x25, 0x20, 0x11, 0x33,
+  0x10, 0x21, 0x20, 0x19, 0x01, 0x05, 0x04, 0x15, 0x10, 0x25, 0x35, 0x04,
+  0x27, 0x36, 0x25, 0x35, 0x25, 0x03, 0xc9, 0xfe, 0x49, 0xfe, 0x51, 0xab,
+  0x01, 0x04, 0x01, 0x14, 0xfe, 0x0f, 0x01, 0x3d, 0xfd, 0xf2, 0x01, 0x78,
+  0x01, 0x02, 0xfe, 0x87, 0x03, 0x65, 0x01, 0xd1, 0xfe, 0x0f, 0x02, 0x02,
+  0x4a, 0xfe, 0x56, 0x01, 0x4f, 0x04, 0x3b, 0x32, 0x78, 0xd6, 0xfe, 0x7d,
+  0x02, 0xb2, 0x02, 0xce, 0xb0, 0x5f, 0xa7, 0x82, 0x00, 0x01, 0x00, 0x63,
+  0x00, 0x00, 0x06, 0x31, 0x06, 0xb3, 0x00, 0x26, 0x00, 0x00, 0x01, 0x15,
+  0x10, 0x01, 0x23, 0x00, 0x11, 0x35, 0x10, 0x27, 0x22, 0x03, 0x11, 0x23,
+  0x11, 0x10, 0x23, 0x22, 0x11, 0x15, 0x10, 0x01, 0x23, 0x00, 0x11, 0x35,
+  0x10, 0x37, 0x36, 0x21, 0x15, 0x24, 0x03, 0x37, 0x32, 0x17, 0x36, 0x33,
+  0x20, 0x06, 0x31, 0xfe, 0xc5, 0xd7, 0x01, 0x60, 0xeb, 0xf0, 0x01, 0xad,
+  0xfe, 0xea, 0x01, 0x6c, 0xd4, 0xfe, 0xbd, 0xf8, 0xfa, 0x02, 0x82, 0xfd,
+  0x41, 0x9f, 0x71, 0xef, 0x7c, 0x69, 0xc6, 0x01, 0xac, 0x03, 0x1e, 0x7c,
+  0xfe, 0x62, 0xfe, 0xfc, 0x01, 0x62, 0x01, 0x49, 0x8c, 0x01, 0x4b, 0x02,
+  0xfe, 0xd7, 0xfe, 0xa2, 0x01, 0x5e, 0x01, 0x28, 0xfe, 0xb4, 0x95, 0xfe,
+  0xc1, 0xfe, 0x9d, 0x01, 0x04, 0x01, 0x9e, 0x77, 0x01, 0xa3, 0xfc, 0xfb,
+  0xa0, 0x01, 0xfe, 0xd8, 0x34, 0xf4, 0xf4, 0x00, 0x00, 0x01, 0x00, 0x75,
+  0xff, 0xe2, 0x03, 0xdd, 0x06, 0x9f, 0x00, 0x15, 0x00, 0x00, 0x01, 0x15,
+  0x10, 0x21, 0x20, 0x19, 0x01, 0x33, 0x11, 0x10, 0x21, 0x20, 0x11, 0x35,
+  0x34, 0x02, 0x27, 0x37, 0x33, 0x07, 0x14, 0x12, 0x03, 0xdc, 0xfe, 0x46,
+  0xfe, 0x53, 0xa2, 0x01, 0x0d, 0x01, 0x16, 0xe3, 0x02, 0x28, 0xb4, 0x42,
+  0xed, 0x02, 0x07, 0x2d, 0xfe, 0x08, 0x02, 0x52, 0x04, 0x6b, 0xfb, 0x6d,
+  0xfe, 0x76, 0x01, 0x49, 0x4b, 0xb3, 0x01, 0x26, 0x99, 0xd9, 0xe6, 0x7c,
+  0xfe, 0xfb, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x04, 0xe0,
+  0x06, 0xb3, 0x00, 0x24, 0x00, 0x00, 0x01, 0x0e, 0x01, 0x07, 0x11, 0x16,
+  0x12, 0x33, 0x32, 0x12, 0x35, 0x11, 0x34, 0x02, 0x27, 0x23, 0x13, 0x23,
+  0x13, 0x35, 0x33, 0x15, 0x33, 0x04, 0x12, 0x07, 0x11, 0x16, 0x00, 0x21,
+  0x20, 0x00, 0x35, 0x11, 0x34, 0x12, 0x37, 0x01, 0xd6, 0x77, 0x4f, 0x02,
+  0x01, 0xbc, 0xd9, 0xd7, 0xb9, 0xc1, 0x83, 0x11, 0x12, 0xa8, 0x12, 0x84,
+  0x11, 0x01, 0x0f, 0xe1, 0x01, 0x01, 0xfe, 0xf5, 0xfe, 0xcb, 0xfe, 0xdd,
+  0xfe, 0xe6, 0xad, 0xc6, 0x05, 0xa7, 0x2f, 0xf0, 0xb3, 0xfe, 0xbd, 0x98,
+  0xfe, 0x88, 0x01, 0x77, 0x99, 0x01, 0x40, 0xb6, 0x01, 0x44, 0x02, 0xfc,
+  0xed, 0x03, 0x11, 0xe7, 0x44, 0x5c, 0xfe, 0x75, 0xb1, 0xfe, 0xb6, 0xd1,
+  0xfe, 0x26, 0x01, 0xd6, 0xd5, 0x01, 0x49, 0xb0, 0x01, 0x8d, 0x52, 0x00,
+  0x00, 0x01, 0x00, 0x2d, 0xff, 0xe1, 0x03, 0xbd, 0x06, 0xb3, 0x00, 0x1e,
+  0x00, 0x00, 0x01, 0x12, 0x21, 0x20, 0x03, 0x13, 0x33, 0x03, 0x10, 0x21,
+  0x20, 0x19, 0x01, 0x26, 0x23, 0x22, 0x17, 0x11, 0x23, 0x11, 0x26, 0x27,
+  0x23, 0x35, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11, 0x03, 0xbd, 0x01,
+  0xfe, 0x62, 0xfe, 0x3a, 0x04, 0x33, 0xb7, 0x3e, 0x01, 0x22, 0x01, 0x01,
+  0x01, 0xaf, 0x96, 0x02, 0x8f, 0x12, 0x8f, 0x84, 0x7e, 0x8b, 0x44, 0x5e,
+  0x99, 0x01, 0x4c, 0x01, 0xee, 0xfd, 0xf3, 0x01, 0xea, 0x01, 0x2e, 0xfe,
+  0xd7, 0xfe, 0xb2, 0x01, 0x35, 0x03, 0xb4, 0xa9, 0x54, 0xfe, 0x68, 0x01,
+  0x4d, 0x8c, 0x13, 0x9f, 0x9f, 0x9f, 0xfe, 0x86, 0x00, 0x02, 0x00, 0x63,
+  0xff, 0xe2, 0x05, 0xe5, 0x06, 0xb3, 0x00, 0x09, 0x00, 0x37, 0x00, 0x00,
+  0x01, 0x10, 0x23, 0x22, 0x11, 0x15, 0x10, 0x33, 0x32, 0x11, 0x01, 0x14,
+  0x00, 0x2b, 0x01, 0x22, 0x24, 0x35, 0x33, 0x14, 0x16, 0x3b, 0x01, 0x32,
+  0x36, 0x35, 0x10, 0x2b, 0x01, 0x35, 0x37, 0x36, 0x35, 0x10, 0x23, 0x22,
+  0x07, 0x16, 0x07, 0x15, 0x10, 0x25, 0x04, 0x11, 0x35, 0x10, 0x21, 0x32,
+  0x17, 0x36, 0x33, 0x20, 0x11, 0x10, 0x07, 0x16, 0x02, 0xf2, 0xf6, 0xee,
+  0xfa, 0xea, 0x02, 0xe0, 0xfe, 0xdf, 0xfb, 0x5a, 0xbb, 0xfe, 0xd6, 0xb7,
+  0xc4, 0x75, 0x43, 0xb2, 0xd1, 0x73, 0x6f, 0x35, 0xbf, 0xef, 0x77, 0x64,
+  0x22, 0x03, 0xfe, 0x75, 0xfe, 0x5a, 0x01, 0x96, 0xe4, 0x62, 0x7e, 0xa8,
+  0x01, 0x7f, 0xd4, 0xc2, 0x04, 0x9e, 0x01, 0x76, 0xfe, 0x8f, 0x8b, 0xfe,
+  0x79, 0x01, 0x87, 0xfd, 0xc0, 0xd4, 0xfe, 0xde, 0xd9, 0x81, 0x3b, 0x80,
+  0xcd, 0x89, 0x01, 0x01, 0x97, 0x02, 0x89, 0xdf, 0x01, 0x35, 0x80, 0x70,
+  0x94, 0x72, 0xfd, 0xd7, 0x01, 0x01, 0x02, 0x29, 0x8b, 0x02, 0x10, 0xc7,
+  0xc1, 0xfe, 0x5a, 0xfe, 0xe5, 0x92, 0x7b, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe2, 0x03, 0xca, 0x06, 0x9f, 0x00, 0x19, 0x00, 0x00, 0x01, 0x10,
+  0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x21, 0x20, 0x19, 0x01, 0x02,
+  0x27, 0x06, 0x07, 0x13, 0x23, 0x27, 0x10, 0x05, 0x32, 0x13, 0x11, 0x33,
+  0x03, 0xc9, 0xfe, 0x47, 0xfe, 0x53, 0x31, 0xb8, 0x3e, 0x01, 0x04, 0x01,
+  0x1f, 0xbb, 0xa2, 0xb0, 0x01, 0x3b, 0xa1, 0x36, 0x01, 0x49, 0x9a, 0xc7,
+  0x98, 0x01, 0xca, 0xfe, 0x18, 0x01, 0xe8, 0xdd, 0xdc, 0xfe, 0xb7, 0x01,
+  0x4e, 0x02, 0x24, 0x01, 0xb2, 0x02, 0x01, 0xa8, 0xfe, 0xff, 0xf9, 0x01,
+  0x5e, 0x02, 0xfe, 0xaa, 0x01, 0xa2, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe2, 0x06, 0x0f, 0x06, 0xb3, 0x00, 0x2a, 0x00, 0x00, 0x37, 0x36,
+  0x37, 0x00, 0x11, 0x35, 0x10, 0x21, 0x32, 0x13, 0x12, 0x33, 0x20, 0x13,
+  0x15, 0x06, 0x03, 0x23, 0x12, 0x3d, 0x01, 0x10, 0x23, 0x22, 0x19, 0x01,
+  0x23, 0x11, 0x10, 0x20, 0x13, 0x15, 0x02, 0x01, 0x16, 0x17, 0x04, 0x17,
+  0x23, 0x26, 0x27, 0x26, 0x05, 0xe3, 0x6c, 0x8a, 0xfe, 0x8a, 0x01, 0x99,
+  0xc3, 0x7b, 0x6c, 0xcf, 0x01, 0x99, 0x01, 0x02, 0x9e, 0xce, 0xc1, 0xe9,
+  0xf4, 0x9a, 0xfe, 0x21, 0x02, 0x01, 0x01, 0x88, 0x6a, 0x4b, 0x01, 0x7a,
+  0x33, 0xee, 0x03, 0xe3, 0xf6, 0xfe, 0xfc, 0xb1, 0x62, 0x22, 0x01, 0x1c,
+  0x02, 0x20, 0x4b, 0x01, 0xf7, 0xfe, 0xf9, 0x01, 0x07, 0xfe, 0x20, 0x61,
+  0xeb, 0xfe, 0x94, 0x01, 0x60, 0xf2, 0x54, 0x01, 0x54, 0xfe, 0x72, 0xfe,
+  0xc0, 0x01, 0x40, 0x01, 0x8d, 0xfe, 0xa8, 0x6d, 0xfe, 0x4d, 0xfe, 0xad,
+  0x04, 0x12, 0x70, 0xe1, 0x52, 0x63, 0x45, 0xbe, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe2, 0x03, 0xc9, 0x06, 0xa1, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x10,
+  0x21, 0x20, 0x11, 0x13, 0x33, 0x03, 0x10, 0x21, 0x20, 0x19, 0x01, 0x06,
+  0x07, 0x04, 0x11, 0x35, 0x34, 0x37, 0x33, 0x06, 0x1d, 0x01, 0x10, 0x17,
+  0x36, 0x37, 0x11, 0x33, 0x03, 0xc8, 0xfe, 0x4a, 0xfe, 0x51, 0x1b, 0xaf,
+  0x1f, 0x01, 0x04, 0x01, 0x1f, 0x94, 0x82, 0xfe, 0x63, 0x82, 0xca, 0xa1,
+  0xe9, 0x94, 0x8b, 0x97, 0x01, 0xc5, 0xfe, 0x1d, 0x01, 0xbb, 0x01, 0x09,
+  0xfe, 0xf3, 0xfe, 0xe9, 0x01, 0x44, 0x01, 0xf8, 0x63, 0x0b, 0x02, 0x01,
+  0xb9, 0x28, 0xa9, 0xc9, 0xd4, 0x94, 0x28, 0xfe, 0xda, 0x01, 0x0a, 0x74,
+  0x02, 0x39, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9,
+  0x06, 0xb3, 0x00, 0x08, 0x00, 0x23, 0x00, 0x00, 0x01, 0x11, 0x26, 0x23,
+  0x20, 0x11, 0x15, 0x02, 0x20, 0x13, 0x10, 0x21, 0x20, 0x11, 0x35, 0x12,
+  0x21, 0x16, 0x17, 0x11, 0x34, 0x23, 0x22, 0x1d, 0x01, 0x23, 0x35, 0x34,
+  0x23, 0x35, 0x20, 0x17, 0x36, 0x33, 0x20, 0x11, 0x03, 0x31, 0x67, 0xb3,
+  0xfe, 0xf8, 0x01, 0x02, 0x23, 0x97, 0xfe, 0x60, 0xfe, 0x3b, 0x01, 0x01,
+  0xb3, 0x7a, 0xa0, 0x9c, 0xa1, 0x94, 0xfd, 0x01, 0x00, 0x30, 0x4d, 0xbe,
+  0x01, 0x2a, 0x01, 0xcb, 0x01, 0xc6, 0x49, 0xfe, 0x90, 0x72, 0xfe, 0x8a,
+  0x01, 0x5d, 0xfe, 0x03, 0x02, 0x0c, 0x90, 0x01, 0xf9, 0x02, 0x3d, 0x01,
+  0x60, 0x7c, 0xb4, 0x3a, 0x3a, 0xb4, 0x9f, 0xc0, 0xc0, 0xfe, 0xb3, 0x00,
+  0x00, 0x01, 0x00, 0x75, 0x00, 0x00, 0x03, 0xdd, 0x06, 0xb3, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x37, 0x34, 0x23, 0x22, 0x11, 0x15, 0x36, 0x17, 0x04,
+  0x03, 0x15, 0x10, 0x03, 0x23, 0x12, 0x3d, 0x01, 0x10, 0x05, 0x26, 0x07,
+  0x11, 0x23, 0x11, 0x02, 0x21, 0x20, 0x13, 0x07, 0x02, 0x4e, 0x0e, 0x95,
+  0xb0, 0x9d, 0x8b, 0x01, 0x9e, 0x01, 0xad, 0xc6, 0xd1, 0xfe, 0xf8, 0x74,
+  0xa7, 0xa1, 0x01, 0x01, 0x33, 0x01, 0x59, 0x01, 0x12, 0x05, 0x0e, 0x92,
+  0x75, 0xfe, 0xe6, 0xe1, 0x68, 0x04, 0x01, 0xfe, 0x3d, 0x5e, 0xfe, 0xfd,
+  0xfe, 0xa7, 0x01, 0x75, 0xb0, 0xae, 0x01, 0x13, 0x01, 0x01, 0x62, 0xfc,
+  0x7c, 0x04, 0xf0, 0x01, 0xc3, 0xfe, 0xed, 0x92, 0x00, 0x01, 0x00, 0x64,
+  0xff, 0xe2, 0x04, 0x4a, 0x06, 0xa0, 0x00, 0x23, 0x00, 0x00, 0x01, 0x16,
+  0x07, 0x04, 0x11, 0x10, 0x02, 0x20, 0x00, 0x19, 0x01, 0x02, 0x13, 0x33,
+  0x02, 0x15, 0x11, 0x1a, 0x01, 0x17, 0x32, 0x12, 0x35, 0x26, 0x2b, 0x01,
+  0x35, 0x33, 0x36, 0x35, 0x34, 0x24, 0x37, 0x33, 0x14, 0x04, 0x04, 0x1c,
+  0x02, 0xdf, 0x01, 0x0a, 0xff, 0xfe, 0x35, 0xfe, 0xe6, 0x02, 0x67, 0xc1,
+  0x79, 0x01, 0xb8, 0x9a, 0x9d, 0x9b, 0x03, 0xac, 0xbd, 0x51, 0xee, 0xff,
+  0x00, 0x01, 0xa5, 0x01, 0x07, 0x05, 0x07, 0xae, 0x8c, 0x7b, 0xfe, 0xf6,
+  0xfe, 0xe2, 0xfe, 0xb8, 0x01, 0x48, 0x01, 0x70, 0x01, 0x9d, 0x01, 0x2c,
+  0x01, 0x3d, 0xfe, 0x8b, 0xf4, 0xfe, 0x63, 0xfe, 0xf6, 0xfe, 0xf2, 0x01,
+  0x01, 0x0f, 0xad, 0xfb, 0xa3, 0x65, 0xc2, 0x81, 0x91, 0x8c, 0x54, 0x88,
+  0x00, 0x02, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9, 0x06, 0x9f, 0x00, 0x09,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x11, 0x26, 0x23, 0x20, 0x11, 0x15, 0x10,
+  0x21, 0x20, 0x13, 0x10, 0x21, 0x20, 0x11, 0x35, 0x10, 0x21, 0x36, 0x17,
+  0x11, 0x33, 0x03, 0x31, 0x6e, 0xb5, 0xff, 0x00, 0x01, 0x00, 0x01, 0x23,
+  0x97, 0xfe, 0x4f, 0xfe, 0x4c, 0x01, 0xb4, 0x95, 0x85, 0x97, 0x02, 0x07,
+  0x01, 0xa3, 0x50, 0xfe, 0x70, 0x59, 0xfe, 0x71, 0x01, 0x6c, 0xfd, 0xf4,
+  0x02, 0x3e, 0x4a, 0x02, 0x3d, 0x01, 0x52, 0x02, 0x49, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x75, 0xff, 0xe2, 0x03, 0xdc, 0x06, 0xb3, 0x00, 0x1a,
+  0x00, 0x24, 0x00, 0x00, 0x13, 0x10, 0x21, 0x32, 0x17, 0x36, 0x21, 0x15,
+  0x22, 0x1d, 0x01, 0x23, 0x35, 0x34, 0x23, 0x22, 0x15, 0x11, 0x36, 0x37,
+  0x20, 0x13, 0x15, 0x10, 0x21, 0x20, 0x13, 0x33, 0x10, 0x33, 0x20, 0x11,
+  0x35, 0x10, 0x21, 0x22, 0x07, 0x76, 0x01, 0x38, 0xb4, 0x57, 0x21, 0x01,
+  0x01, 0xfd, 0x93, 0x97, 0x9d, 0x95, 0x7d, 0x01, 0xb1, 0x01, 0xfe, 0x3c,
+  0xfe, 0x5e, 0x02, 0xa1, 0xfb, 0x01, 0x28, 0xfe, 0xee, 0x7c, 0x95, 0x05,
+  0x79, 0x01, 0x3a, 0xbd, 0xbd, 0x9f, 0xa0, 0x44, 0x44, 0xa0, 0x9b, 0xfe,
+  0x9e, 0x55, 0x01, 0xfe, 0x11, 0x77, 0xfd, 0xdb, 0x02, 0x1b, 0xfe, 0x85,
+  0x01, 0x71, 0x8b, 0x01, 0x52, 0x60, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63,
+  0xff, 0xe2, 0x03, 0xed, 0x06, 0xa0, 0x00, 0x1c, 0x00, 0x23, 0x00, 0x00,
+  0x01, 0x23, 0x13, 0x33, 0x15, 0x23, 0x13, 0x10, 0x21, 0x20, 0x11, 0x37,
+  0x33, 0x07, 0x10, 0x21, 0x20, 0x11, 0x03, 0x23, 0x20, 0x11, 0x10, 0x21,
+  0x33, 0x27, 0x33, 0x17, 0x33, 0x01, 0x14, 0x3b, 0x01, 0x03, 0x23, 0x22,
+  0x03, 0xec, 0xc6, 0x38, 0x8e, 0x71, 0x4e, 0xfe, 0x47, 0xfe, 0x53, 0x35,
+  0xb8, 0x41, 0x01, 0x03, 0x01, 0x16, 0x54, 0xcb, 0xfe, 0x90, 0x01, 0x73,
+  0x54, 0x21, 0xb4, 0x1f, 0xda, 0xfd, 0x3c, 0xda, 0xc0, 0x3e, 0x7f, 0xdd,
+  0x05, 0x69, 0xfe, 0xb9, 0x8d, 0xfe, 0x35, 0xfe, 0x18, 0x01, 0xe8, 0xdd,
+  0xdc, 0xfe, 0xb7, 0x01, 0x4e, 0x01, 0xc5, 0x01, 0x2d, 0x01, 0x36, 0xa8,
+  0xa8, 0xfe, 0xcf, 0xa5, 0x01, 0x47, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75,
+  0xff, 0xe2, 0x03, 0xdd, 0x06, 0x9f, 0x00, 0x09, 0x00, 0x15, 0x00, 0x00,
+  0x01, 0x10, 0x21, 0x06, 0x07, 0x11, 0x10, 0x21, 0x20, 0x11, 0x37, 0x15,
+  0x10, 0x21, 0x20, 0x19, 0x01, 0x33, 0x11, 0x36, 0x33, 0x04, 0x03, 0x3a,
+  0xfe, 0xea, 0x92, 0x7a, 0x01, 0x1a, 0x01, 0x08, 0xa2, 0xfe, 0x56, 0xfe,
+  0x43, 0xa3, 0x91, 0x7b, 0x01, 0xb8, 0x02, 0x8d, 0x01, 0x7f, 0x03, 0x55,
+  0xfe, 0x58, 0xfe, 0x76, 0x01, 0x80, 0x6e, 0x5f, 0xfd, 0xd1, 0x02, 0x25,
+  0x04, 0x98, 0xfd, 0xbc, 0x4e, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2d,
+  0xff, 0xe2, 0x03, 0x8b, 0x06, 0xb3, 0x00, 0x21, 0x00, 0x00, 0x01, 0x07,
+  0x25, 0x03, 0x04, 0x17, 0x06, 0x04, 0x21, 0x35, 0x32, 0x36, 0x35, 0x26,
+  0x2f, 0x01, 0x13, 0x25, 0x37, 0x05, 0x37, 0x36, 0x34, 0x26, 0x23, 0x07,
+  0x35, 0x33, 0x32, 0x17, 0x16, 0x14, 0x0f, 0x01, 0x03, 0x8a, 0x45, 0xfe,
+  0xc9, 0x82, 0x01, 0x2e, 0x01, 0x01, 0xfe, 0xe8, 0xfe, 0xbd, 0xfb, 0xb5,
+  0x01, 0xeb, 0x68, 0xd2, 0xfe, 0xa0, 0x48, 0x01, 0x5b, 0x5f, 0x11, 0x43,
+  0x39, 0x75, 0x8c, 0x77, 0x43, 0x43, 0x1b, 0x65, 0x03, 0xcc, 0x8a, 0xab,
+  0xfe, 0xeb, 0x6e, 0xdc, 0xc6, 0xe6, 0xa0, 0x7f, 0x7a, 0xc0, 0x28, 0x45,
+  0x01, 0x95, 0xbe, 0x8c, 0xc5, 0xc2, 0x1c, 0x53, 0x38, 0x13, 0x9b, 0x4b,
+  0x4a, 0xb2, 0x37, 0xc4, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xca,
+  0x06, 0xb3, 0x00, 0x26, 0x00, 0x00, 0x01, 0x10, 0x21, 0x20, 0x11, 0x33,
+  0x10, 0x21, 0x20, 0x11, 0x34, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x35, 0x34,
+  0x27, 0x23, 0x35, 0x33, 0x32, 0x35, 0x34, 0x21, 0x23, 0x35, 0x33, 0x20,
+  0x11, 0x14, 0x07, 0x33, 0x16, 0x15, 0x16, 0x07, 0x16, 0x03, 0xc9, 0xfe,
+  0x49, 0xfe, 0x51, 0xab, 0x01, 0x04, 0x01, 0x0f, 0x8b, 0xd0, 0xbe, 0x8b,
+  0x8b, 0xd0, 0xd0, 0x76, 0xfe, 0x96, 0x6b, 0x6b, 0x02, 0x15, 0x88, 0x02,
+  0x98, 0x01, 0x76, 0x87, 0x01, 0x99, 0xfe, 0x49, 0x02, 0x04, 0xfe, 0x9c,
+  0x01, 0x17, 0xc5, 0xb3, 0x84, 0x79, 0x01, 0xb5, 0x99, 0xb8, 0x9e, 0xfe,
+  0xaa, 0x9b, 0x61, 0x4e, 0x87, 0x94, 0x47, 0x6e, 0x00, 0x01, 0x00, 0x6c,
+  0xff, 0xe2, 0x03, 0xd2, 0x06, 0xb2, 0x00, 0x26, 0x00, 0x00, 0x05, 0x20,
+  0x19, 0x01, 0x33, 0x11, 0x10, 0x21, 0x20, 0x11, 0x34, 0x27, 0x23, 0x35,
+  0x33, 0x32, 0x37, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x36, 0x35, 0x34, 0x21,
+  0x35, 0x20, 0x11, 0x06, 0x07, 0x23, 0x16, 0x17, 0x06, 0x07, 0x16, 0x15,
+  0x10, 0x02, 0x20, 0xfe, 0x4c, 0xa3, 0x01, 0x11, 0x01, 0x0a, 0x76, 0x98,
+  0x98, 0x61, 0x05, 0x05, 0x76, 0x95, 0x95, 0x64, 0xfe, 0xf5, 0x01, 0xb6,
+  0x01, 0x8f, 0x02, 0xa4, 0x01, 0x01, 0x9b, 0xac, 0x1e, 0x01, 0xe6, 0x04,
+  0x4d, 0xfb, 0xb3, 0xfe, 0xba, 0x01, 0x12, 0xe0, 0x02, 0xb1, 0x83, 0x7d,
+  0xb7, 0x01, 0xb4, 0x81, 0x9e, 0xfe, 0xd2, 0xa5, 0x53, 0x67, 0x7e, 0x80,
+  0x5c, 0x56, 0xe1, 0xfe, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63,
+  0xff, 0x5f, 0x03, 0xcb, 0x06, 0xb3, 0x00, 0x09, 0x00, 0x1f, 0x00, 0x00,
+  0x01, 0x10, 0x05, 0x24, 0x19, 0x01, 0x10, 0x21, 0x20, 0x11, 0x03, 0x32,
+  0x37, 0x23, 0x02, 0x19, 0x01, 0x10, 0x21, 0x20, 0x19, 0x01, 0x10, 0x03,
+  0x16, 0x33, 0x15, 0x22, 0x27, 0x23, 0x06, 0x27, 0x01, 0x0e, 0x01, 0x07,
+  0x01, 0x0c, 0xfe, 0xf5, 0xfe, 0xf8, 0xab, 0xc3, 0x39, 0x02, 0xfa, 0x01,
+  0xb2, 0x01, 0xb3, 0xfe, 0x29, 0xd7, 0xaf, 0xfd, 0x13, 0xf7, 0xb1, 0x02,
+  0xd2, 0xfe, 0x68, 0x78, 0x78, 0x01, 0x98, 0x01, 0xa2, 0x01, 0xa0, 0xfe,
+  0x60, 0xfb, 0xa9, 0x53, 0x01, 0x04, 0x01, 0x5e, 0x01, 0xa6, 0x02, 0x3b,
+  0xfd, 0xc1, 0xfe, 0x5e, 0xfe, 0xa2, 0xfe, 0xf8, 0x4f, 0xbe, 0xe6, 0xe7,
+  0x01, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe2, 0x03, 0xc9,
+  0x06, 0xb5, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x10, 0x21, 0x20, 0x11, 0x35,
+  0x33, 0x15, 0x10, 0x21, 0x20, 0x11, 0x35, 0x10, 0x2b, 0x01, 0x35, 0x33,
+  0x24, 0x11, 0x05, 0x15, 0x23, 0x11, 0x25, 0x10, 0x05, 0x04, 0x11, 0x03,
+  0xc8, 0xfe, 0x48, 0xfe, 0x55, 0xaa, 0x01, 0x08, 0x01, 0x0a, 0xda, 0xcd,
+  0x6f, 0x01, 0x38, 0xfd, 0xf0, 0xae, 0x03, 0x65, 0xfe, 0xdb, 0x01, 0x25,
+  0x01, 0x96, 0xfe, 0x4c, 0x01, 0xd4, 0xd3, 0xdd, 0xfe, 0xd6, 0x01, 0x14,
+  0x9b, 0x01, 0x1a, 0xa4, 0xad, 0x01, 0x78, 0x17, 0xec, 0x01, 0x8f, 0x15,
+  0xfd, 0xbf, 0x9e, 0x71, 0xfe, 0xd2, 0x00, 0x00, 0x00, 0x01, 0x00, 0x63,
+  0xff, 0xe2, 0x03, 0xd5, 0x06, 0xb4, 0x00, 0x20, 0x00, 0x00, 0x01, 0x10,
+  0x21, 0x20, 0x11, 0x35, 0x33, 0x15, 0x10, 0x21, 0x20, 0x11, 0x10, 0x2b,
+  0x01, 0x35, 0x33, 0x24, 0x03, 0x06, 0x23, 0x04, 0x11, 0x33, 0x14, 0x21,
+  0x32, 0x37, 0x33, 0x15, 0x02, 0x05, 0x04, 0x03, 0xc9, 0xfe, 0x49, 0xfe,
+  0x51, 0xac, 0x01, 0x03, 0x01, 0x0f, 0xfa, 0xad, 0x63, 0x01, 0x43, 0x02,
+  0x96, 0x76, 0xfe, 0x51, 0xab, 0x01, 0x04, 0xc8, 0x70, 0x8b, 0x0a, 0xfe,
+  0xf3, 0x01, 0x0b, 0x01, 0xc8, 0xfe, 0x1a, 0x01, 0xe6, 0x8e, 0x8e, 0xfe,
+  0xba, 0x01, 0x46, 0x01, 0x60, 0xad, 0x1e, 0x01, 0xbb, 0x6f, 0x02, 0x01,
+  0x77, 0xc6, 0xc5, 0xe1, 0xfe, 0x80, 0xa6, 0x9c, 0x00, 0x03, 0x00, 0x63,
+  0xff, 0xe2, 0x04, 0x48, 0x06, 0xb3, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x25,
+  0x00, 0x00, 0x01, 0x21, 0x24, 0x11, 0x10, 0x21, 0x20, 0x35, 0x01, 0x10,
+  0x29, 0x01, 0x11, 0x34, 0x21, 0x20, 0x01, 0x15, 0x10, 0x21, 0x20, 0x11,
+  0x10, 0x37, 0x23, 0x26, 0x11, 0x10, 0x21, 0x20, 0x11, 0x15, 0x33, 0x15,
+  0x23, 0x11, 0x33, 0x15, 0x03, 0x2a, 0xfe, 0xe6, 0xfe, 0xfe, 0x01, 0x09,
+  0x01, 0x13, 0xfd, 0xe4, 0x01, 0x02, 0x01, 0x1a, 0xfe, 0xed, 0xfe, 0xf7,
+  0x02, 0xbb, 0xfe, 0x47, 0xfe, 0x53, 0xf1, 0x01, 0xf0, 0x01, 0xb4, 0x01,
+  0xb2, 0x7e, 0x7e, 0x7e, 0x02, 0xde, 0x02, 0xfe, 0xce, 0xfe, 0xd4, 0xf4,
+  0x03, 0x62, 0xfe, 0xba, 0x01, 0x9f, 0xe3, 0xfb, 0xda, 0x78, 0xfe, 0x6c,
+  0x01, 0xcc, 0x01, 0x21, 0x6a, 0x60, 0x01, 0x3f, 0x01, 0xdb, 0xfe, 0x7e,
+  0x97, 0xbe, 0xfe, 0xca, 0xb8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x63,
+  0xff, 0xe2, 0x06, 0x7e, 0x06, 0xb4, 0x00, 0x0a, 0x00, 0x2c, 0x00, 0x00,
+  0x01, 0x11, 0x34, 0x26, 0x23, 0x20, 0x13, 0x11, 0x10, 0x05, 0x20, 0x13,
+  0x10, 0x21, 0x22, 0x27, 0x15, 0x10, 0x21, 0x35, 0x32, 0x35, 0x11, 0x10,
+  0x21, 0x22, 0x06, 0x1d, 0x01, 0x10, 0x21, 0x15, 0x20, 0x03, 0x35, 0x10,
+  0x36, 0x37, 0x32, 0x17, 0x36, 0x33, 0x04, 0x12, 0x15, 0x05, 0xd6, 0x74,
+  0x96, 0xfe, 0xfc, 0x01, 0x01, 0x03, 0x01, 0x0a, 0xa7, 0xfe, 0x49, 0x73,
+  0x8b, 0xfe, 0x5e, 0xf8, 0xfe, 0xf8, 0x7d, 0x8a, 0x01, 0x08, 0xfe, 0x4d,
+  0x01, 0xfc, 0xb7, 0xea, 0x7b, 0x6a, 0xe7, 0x01, 0x0a, 0xa7, 0x03, 0xb5,
+  0x01, 0x03, 0xc3, 0x9a, 0xfe, 0xd9, 0xfe, 0x6b, 0xfe, 0xd4, 0x01, 0x01,
+  0x84, 0xfd, 0xdd, 0x87, 0x9e, 0xfe, 0x6c, 0xa0, 0xf4, 0x03, 0x78, 0x01,
+  0x27, 0x9b, 0xc2, 0xfd, 0xfe, 0xaf, 0xa5, 0x01, 0xf6, 0xfd, 0x01, 0x01,
+  0xfa, 0x01, 0xd8, 0xd8, 0x01, 0xfe, 0xc4, 0xbf, 0x00, 0x03, 0x00, 0x6d,
+  0xfe, 0x1e, 0x06, 0x47, 0x06, 0x87, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x23,
+  0x00, 0x00, 0x01, 0x04, 0x07, 0x03, 0x06, 0x33, 0x32, 0x25, 0x17, 0x24,
+  0x37, 0x13, 0x36, 0x23, 0x22, 0x05, 0x01, 0x06, 0x05, 0x13, 0x23, 0x03,
+  0x04, 0x23, 0x22, 0x1b, 0x01, 0x36, 0x25, 0x03, 0x33, 0x13, 0x24, 0x33,
+  0x32, 0x03, 0x03, 0x3e, 0xfe, 0x2f, 0x18, 0x3b, 0x15, 0x65, 0x66, 0x01,
+  0x10, 0x9a, 0x01, 0xd0, 0x0d, 0x41, 0x18, 0x80, 0x52, 0xff, 0x00, 0x02,
+  0x27, 0x1d, 0xfd, 0x8a, 0x54, 0xbb, 0x53, 0xfe, 0xe6, 0x98, 0xbe, 0x26,
+  0x41, 0x20, 0x02, 0x76, 0x47, 0xab, 0x41, 0x01, 0x16, 0xae, 0xbe, 0x26,
+  0x03, 0xfc, 0x4e, 0xa8, 0xfe, 0x2c, 0xae, 0xae, 0xae, 0x46, 0x68, 0x01,
+  0xfa, 0xae, 0x49, 0xfd, 0xa1, 0xe0, 0x28, 0xfd, 0xf4, 0x02, 0x91, 0xaf,
+  0x01, 0x32, 0x01, 0xf9, 0xfa, 0x3a, 0x02, 0x28, 0xfd, 0x6a, 0x6e, 0xfe,
+  0xcd, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xfe, 0x28, 0x05, 0x78,
+  0x06, 0xd3, 0x00, 0x30, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x14, 0x00, 0x15,
+  0x14, 0x07, 0x04, 0x11, 0x02, 0x05, 0x24, 0x03, 0x34, 0x37, 0x27, 0x26,
+  0x27, 0x06, 0x11, 0x10, 0x05, 0x04, 0x17, 0x23, 0x26, 0x25, 0x06, 0x07,
+  0x27, 0x36, 0x37, 0x24, 0x11, 0x10, 0x25, 0x26, 0x35, 0x37, 0x17, 0x07,
+  0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x26, 0x00, 0x35, 0x01, 0x10, 0x23,
+  0x22, 0x07, 0x06, 0x07, 0x06, 0x15, 0x12, 0x17, 0x36, 0x03, 0x14, 0x01,
+  0x34, 0x1b, 0x01, 0x4b, 0x13, 0xfe, 0x99, 0xfe, 0x8c, 0x12, 0x36, 0x3f,
+  0x60, 0x4c, 0xc7, 0x01, 0x41, 0x01, 0xf4, 0x04, 0xc5, 0x0a, 0xfe, 0xa3,
+  0x87, 0x68, 0x6e, 0x60, 0x8d, 0xfe, 0xc1, 0x01, 0x1b, 0x21, 0x22, 0x90,
+  0x15, 0x88, 0x57, 0x64, 0x73, 0x01, 0xfe, 0xce, 0x02, 0x62, 0xd8, 0x1c,
+  0x18, 0x30, 0x50, 0x3c, 0x09, 0xe7, 0xce, 0x06, 0xd3, 0xa4, 0xfe, 0xe6,
+  0xab, 0x66, 0x45, 0x14, 0xfe, 0x2c, 0xfe, 0x20, 0x14, 0x14, 0x01, 0xeb,
+  0x66, 0x8e, 0x0a, 0x09, 0x5c, 0x37, 0xfe, 0xb9, 0xfe, 0xac, 0xad, 0xc0,
+  0xde, 0xa8, 0x59, 0x03, 0x98, 0x6c, 0x67, 0x2f, 0xe9, 0x01, 0x42, 0x01,
+  0xbf, 0x38, 0x4d, 0x75, 0xb1, 0x38, 0x79, 0x8e, 0x90, 0x89, 0x8b, 0x7a,
+  0x01, 0x1b, 0xd4, 0xfb, 0x0e, 0x01, 0x52, 0x05, 0x34, 0x1a, 0x5d, 0xa1,
+  0xfe, 0x95, 0x0a, 0x0a, 0x00, 0x02, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e,
+  0x06, 0x1e, 0x00, 0x03, 0x00, 0x16, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
+  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x11,
+  0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0xc3, 0x02, 0x1b, 0xfd, 0xe5,
+  0x02, 0x8b, 0xfe, 0x85, 0xfe, 0x87, 0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01,
+  0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac, 0x06, 0x1e, 0x94, 0xfc, 0x20, 0xfe,
+  0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd,
+  0xad, 0x7e, 0x7e, 0x00, 0x00, 0x03, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e,
+  0x06, 0x38, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1a, 0x00, 0x00, 0x01, 0x33,
+  0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37,
+  0x33, 0x07, 0x10, 0x33, 0x32, 0x11, 0x26, 0x24, 0x35, 0x33, 0x16, 0x17,
+  0x16, 0x02, 0x11, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0x9d, 0xfe,
+  0x85, 0xfe, 0x87, 0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8,
+  0x02, 0xab, 0xac, 0x06, 0x38, 0xca, 0xca, 0xca, 0xfc, 0x3c, 0xfe, 0x38,
+  0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad,
+  0x7e, 0x7e, 0x00, 0x00, 0x00, 0x04, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e,
+  0x07, 0x00, 0x00, 0x12, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x00,
+  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x11,
+  0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0x01, 0x21, 0x15, 0x21, 0x01,
+  0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x03, 0x4e, 0xfe, 0x85, 0xfe,
+  0x87, 0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab,
+  0xac, 0xfd, 0x58, 0x02, 0x1b, 0xfd, 0xe5, 0x01, 0x62, 0xb7, 0xb7, 0xfe,
+  0xa0, 0xb7, 0xb7, 0x01, 0xaa, 0xfe, 0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe,
+  0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad, 0x7e, 0x7e, 0x02, 0xb6, 0x94,
+  0x02, 0x25, 0xca, 0xca, 0xca, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
+  0xff, 0xe2, 0x03, 0x4e, 0x06, 0x8c, 0x00, 0x03, 0x00, 0x16, 0x00, 0x00,
+  0x01, 0x33, 0x03, 0x23, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07,
+  0x10, 0x33, 0x32, 0x11, 0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0x01,
+  0xf0, 0xd3, 0xe8, 0x9b, 0x02, 0x0e, 0xfe, 0x85, 0xfe, 0x87, 0x23, 0x9f,
+  0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac, 0x06, 0x8c,
+  0xfe, 0xf8, 0xfc, 0x26, 0xfe, 0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce,
+  0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad, 0x7e, 0x7e, 0x00, 0x03, 0x00, 0x5a,
+  0xff, 0xe2, 0x03, 0x4e, 0x07, 0x18, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1a,
+  0x00, 0x00, 0x01, 0x33, 0x03, 0x23, 0x07, 0x21, 0x15, 0x21, 0x01, 0x10,
+  0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x11, 0x26, 0x24,
+  0x35, 0x33, 0x16, 0x17, 0x16, 0x01, 0xf0, 0xa6, 0xcd, 0x89, 0x88, 0x02,
+  0x1b, 0xfd, 0xe5, 0x02, 0x96, 0xfe, 0x85, 0xfe, 0x87, 0x23, 0x9f, 0x20,
+  0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac, 0x07, 0x18, 0xfe,
+  0xf8, 0x79, 0x94, 0xfc, 0xa7, 0xfe, 0x38, 0x01, 0xbe, 0xd0, 0xd0, 0xfe,
+  0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad, 0x7e, 0x7e, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x5a, 0xff, 0xe2, 0x03, 0x4e, 0x06, 0x79, 0x00, 0x08,
+  0x00, 0x1b, 0x00, 0x00, 0x01, 0x02, 0x20, 0x03, 0x33, 0x16, 0x33, 0x32,
+  0x37, 0x13, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32,
+  0x11, 0x26, 0x24, 0x35, 0x33, 0x16, 0x17, 0x16, 0x02, 0xd7, 0x11, 0xfd,
+  0xef, 0x11, 0x6a, 0x16, 0x9a, 0x9a, 0x15, 0xe1, 0xfe, 0x85, 0xfe, 0x87,
+  0x23, 0x9f, 0x20, 0xda, 0xd7, 0x01, 0xfe, 0xa1, 0xa8, 0x02, 0xab, 0xac,
+  0x06, 0x79, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0xfb, 0x31, 0xfe, 0x38,
+  0x01, 0xbe, 0xd0, 0xd0, 0xfe, 0xce, 0x01, 0x3c, 0xdd, 0xfe, 0xdd, 0xad,
+  0x7e, 0x7e, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xfe, 0x1d, 0x03, 0x3c,
+  0x06, 0x1e, 0x00, 0x03, 0x00, 0x1b, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
+  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19,
+  0x01, 0x10, 0x23, 0x22, 0x15, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20, 0x11,
+  0xf0, 0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x4c, 0xfe, 0x9c, 0xfe, 0x82, 0x1e,
+  0x9a, 0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01, 0x49, 0x01,
+  0x64, 0x06, 0x1e, 0x94, 0xfa, 0x37, 0xfe, 0x5c, 0x01, 0xa6, 0xe1, 0xe3,
+  0xfe, 0xe8, 0x01, 0x16, 0x03, 0x13, 0x01, 0x02, 0xf4, 0xe2, 0xdc, 0x01,
+  0x86, 0xfe, 0x6f, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xfe, 0x1d, 0x03, 0x3c,
+  0x06, 0x64, 0x00, 0x03, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x33, 0x03, 0x23,
+  0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19,
+  0x01, 0x10, 0x23, 0x22, 0x15, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20, 0x11,
+  0x02, 0x2f, 0xd3, 0xe8, 0x9c, 0x01, 0xbe, 0xfe, 0x9c, 0xfe, 0x82, 0x1e,
+  0x9a, 0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01, 0x49, 0x01,
+  0x64, 0x06, 0x64, 0xfe, 0xf8, 0xfa, 0x65, 0xfe, 0x5c, 0x01, 0xa6, 0xe1,
+  0xe3, 0xfe, 0xe8, 0x01, 0x16, 0x03, 0x13, 0x01, 0x02, 0xf4, 0xe2, 0xdc,
+  0x01, 0x86, 0xfe, 0x6f, 0x00, 0x03, 0x00, 0x5a, 0xfe, 0x1d, 0x03, 0x3c,
+  0x07, 0x36, 0x00, 0x03, 0x00, 0x07, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x33,
+  0x03, 0x23, 0x07, 0x21, 0x15, 0x21, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37,
+  0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x10, 0x23, 0x22, 0x15, 0x17,
+  0x23, 0x27, 0x10, 0x21, 0x20, 0x11, 0x02, 0x1d, 0xc1, 0xcd, 0xa5, 0x86,
+  0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x56, 0xfe, 0x9c, 0xfe, 0x82, 0x1e, 0x9a,
+  0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01, 0x49, 0x01, 0x64,
+  0x07, 0x36, 0xfe, 0xf8, 0x79, 0x94, 0xfa, 0xa0, 0xfe, 0x5c, 0x01, 0xa6,
+  0xe1, 0xe3, 0xfe, 0xe8, 0x01, 0x16, 0x03, 0x13, 0x01, 0x02, 0xf4, 0xe2,
+  0xdc, 0x01, 0x86, 0xfe, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
+  0xfe, 0x1d, 0x03, 0x3c, 0x06, 0x79, 0x00, 0x08, 0x00, 0x20, 0x00, 0x00,
+  0x01, 0x02, 0x20, 0x03, 0x33, 0x16, 0x33, 0x32, 0x37, 0x13, 0x10, 0x21,
+  0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x10, 0x23,
+  0x22, 0x15, 0x17, 0x23, 0x27, 0x10, 0x21, 0x20, 0x11, 0x02, 0xfb, 0x11,
+  0xfd, 0xef, 0x11, 0x6a, 0x16, 0x9a, 0x9a, 0x15, 0xab, 0xfe, 0x9c, 0xfe,
+  0x82, 0x1e, 0x9a, 0x16, 0xdc, 0xcb, 0xcb, 0xb4, 0x32, 0x9b, 0x2c, 0x01,
+  0x49, 0x01, 0x64, 0x06, 0x79, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0xf9,
+  0x48, 0xfe, 0x5c, 0x01, 0xa6, 0xe1, 0xe3, 0xfe, 0xe8, 0x01, 0x16, 0x03,
+  0x13, 0x01, 0x02, 0xf4, 0xe2, 0xdc, 0x01, 0x86, 0xfe, 0x6f, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x03, 0x60, 0x06, 0x1e, 0x00, 0x11,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x10, 0x03, 0x23, 0x12, 0x11, 0x10, 0x23,
+  0x22, 0x11, 0x10, 0x13, 0x23, 0x02, 0x11, 0x10, 0x21, 0x20, 0x01, 0x21,
+  0x15, 0x21, 0x03, 0x60, 0x8a, 0x9b, 0x83, 0xdd, 0xe5, 0x82, 0x9c, 0x88,
+  0x01, 0x87, 0x01, 0x7f, 0xfd, 0x7e, 0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x44,
+  0xfe, 0xf4, 0xfe, 0xc8, 0x01, 0x21, 0x01, 0x23, 0x01, 0x90, 0xfe, 0x6d,
+  0xfe, 0xe0, 0xfe, 0xdf, 0x01, 0x3a, 0x01, 0x0d, 0x02, 0x19, 0x01, 0xbe,
+  0x94, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x03, 0x60,
+  0x06, 0x64, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x01, 0x10, 0x03, 0x23,
+  0x12, 0x11, 0x10, 0x23, 0x22, 0x11, 0x10, 0x13, 0x23, 0x02, 0x11, 0x10,
+  0x21, 0x20, 0x01, 0x33, 0x03, 0x23, 0x03, 0x60, 0x8a, 0x9b, 0x83, 0xdd,
+  0xe5, 0x82, 0x9c, 0x88, 0x01, 0x87, 0x01, 0x7f, 0xfe, 0xd8, 0xca, 0xe8,
+  0x92, 0x02, 0x44, 0xfe, 0xf4, 0xfe, 0xc9, 0x01, 0x20, 0x01, 0x23, 0x01,
+  0x90, 0xfe, 0x6d, 0xfe, 0xe0, 0xfe, 0xdf, 0x01, 0x3a, 0x01, 0x0d, 0x02,
+  0x19, 0x02, 0x04, 0xfe, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a,
+  0x00, 0x00, 0x03, 0x60, 0x06, 0x79, 0x00, 0x11, 0x00, 0x1a, 0x00, 0x00,
+  0x01, 0x10, 0x03, 0x23, 0x12, 0x11, 0x10, 0x23, 0x22, 0x11, 0x10, 0x13,
+  0x23, 0x02, 0x11, 0x10, 0x21, 0x20, 0x03, 0x02, 0x20, 0x03, 0x33, 0x16,
+  0x33, 0x32, 0x37, 0x03, 0x60, 0x8a, 0x9b, 0x83, 0xdd, 0xe5, 0x82, 0x9c,
+  0x88, 0x01, 0x87, 0x01, 0x7f, 0x65, 0x11, 0xfd, 0xef, 0x11, 0x6a, 0x16,
+  0x9a, 0x9a, 0x15, 0x02, 0x44, 0xfe, 0xf4, 0xfe, 0xc9, 0x01, 0x20, 0x01,
+  0x23, 0x01, 0x90, 0xfe, 0x6d, 0xfe, 0xe0, 0xfe, 0xdf, 0x01, 0x3a, 0x01,
+  0x0d, 0x02, 0x19, 0x02, 0x19, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0x00,
+  0x00, 0x02, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f, 0x06, 0x1e, 0x00, 0x1c,
+  0x00, 0x20, 0x00, 0x00, 0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23,
+  0x22, 0x11, 0x15, 0x23, 0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23,
+  0x02, 0x11, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x21, 0x15,
+  0x21, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11, 0x01, 0xbd, 0xd0, 0x95,
+  0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01, 0x61, 0xca, 0x4f, 0x58,
+  0xc6, 0x01, 0x5e, 0xfc, 0x78, 0x02, 0x1a, 0xfd, 0xe6, 0x02, 0x56, 0xfe,
+  0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e, 0xfe, 0xa7, 0xd2,
+  0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc, 0x01, 0x24, 0x01,
+  0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x01, 0xbe, 0x94, 0x00, 0x03, 0x00, 0x5a,
+  0xff, 0xff, 0x05, 0x4f, 0x06, 0x38, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x24,
+  0x00, 0x00, 0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23, 0x22, 0x11,
+  0x15, 0x23, 0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23, 0x02, 0x11,
+  0x10, 0x21, 0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x33, 0x15, 0x23, 0x25,
+  0x33, 0x15, 0x23, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11, 0x01, 0xbd,
+  0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01, 0x61, 0xca,
+  0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfd, 0xd8, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7,
+  0xb7, 0x02, 0x56, 0xfe, 0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01,
+  0x7e, 0xfe, 0xa7, 0xd2, 0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe,
+  0xdc, 0x01, 0x24, 0x01, 0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x01, 0xd8, 0xca,
+  0xca, 0xca, 0x00, 0x00, 0x00, 0x04, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f,
+  0x07, 0x28, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x24, 0x00, 0x28, 0x00, 0x00,
+  0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23, 0x22, 0x11, 0x15, 0x23,
+  0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23, 0x02, 0x11, 0x10, 0x21,
+  0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x21, 0x15, 0x21, 0x01, 0x33, 0x15,
+  0x23, 0x25, 0x33, 0x15, 0x23, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11,
+  0x01, 0xbd, 0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01,
+  0x61, 0xca, 0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfc, 0x76, 0x02, 0x1b, 0xfd,
+  0xe5, 0x01, 0x62, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0x56, 0xfe,
+  0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e, 0xfe, 0xa7, 0xd2,
+  0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc, 0x01, 0x24, 0x01,
+  0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x01, 0x37, 0x94, 0x02, 0x25, 0xca, 0xca,
+  0xca, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f,
+  0x06, 0x64, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x12, 0x03, 0x23,
+  0x00, 0x11, 0x02, 0x23, 0x22, 0x11, 0x15, 0x23, 0x35, 0x10, 0x23, 0x22,
+  0x11, 0x02, 0x01, 0x23, 0x02, 0x11, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33,
+  0x20, 0x01, 0x33, 0x03, 0x23, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01, 0x11,
+  0x01, 0xbd, 0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe, 0x01,
+  0x61, 0xca, 0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfd, 0xb7, 0xca, 0xe8, 0x93,
+  0x02, 0x56, 0xfe, 0xd1, 0xfe, 0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e,
+  0xfe, 0xa7, 0xd2, 0xd2, 0x01, 0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc,
+  0x01, 0x24, 0x01, 0x33, 0x02, 0x0a, 0xe3, 0xe3, 0x02, 0x04, 0xfe, 0xf8,
+  0x00, 0x02, 0x00, 0x5a, 0xff, 0xff, 0x05, 0x4f, 0x06, 0x79, 0x00, 0x1c,
+  0x00, 0x25, 0x00, 0x00, 0x01, 0x12, 0x03, 0x23, 0x00, 0x11, 0x02, 0x23,
+  0x22, 0x11, 0x15, 0x23, 0x35, 0x10, 0x23, 0x22, 0x11, 0x02, 0x01, 0x23,
+  0x02, 0x11, 0x10, 0x21, 0x32, 0x17, 0x36, 0x33, 0x20, 0x01, 0x02, 0x20,
+  0x03, 0x33, 0x16, 0x33, 0x32, 0x37, 0x05, 0x4f, 0x01, 0xf8, 0xbc, 0x01,
+  0x11, 0x01, 0xbd, 0xd0, 0x95, 0xd0, 0xbe, 0x01, 0x01, 0x19, 0xbc, 0xfe,
+  0x01, 0x61, 0xca, 0x4f, 0x58, 0xc6, 0x01, 0x5e, 0xfe, 0xb0, 0x11, 0xfd,
+  0xef, 0x11, 0x6a, 0x17, 0x98, 0x9b, 0x15, 0x02, 0x56, 0xfe, 0xd1, 0xfe,
+  0xd9, 0x01, 0x16, 0x01, 0x40, 0x01, 0x7e, 0xfe, 0xa7, 0xd2, 0xd2, 0x01,
+  0x59, 0xfe, 0x82, 0xfe, 0xcd, 0xfe, 0xdc, 0x01, 0x24, 0x01, 0x33, 0x02,
+  0x0a, 0xe3, 0xe3, 0x02, 0x19, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0x00,
+  0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x1e, 0x00, 0x03,
+  0x00, 0x24, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x01, 0x10, 0x21, 0x20,
+  0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22,
+  0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32,
+  0x17, 0x36, 0x33, 0x20, 0x11, 0xd5, 0x02, 0x1b, 0xfd, 0xe5, 0x02, 0xaf,
+  0xfe, 0x96, 0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f,
+  0x09, 0x81, 0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c,
+  0x90, 0x01, 0x12, 0x06, 0x1e, 0x94, 0xfa, 0x36, 0xfe, 0x5d, 0x01, 0xa3,
+  0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe, 0xa5,
+  0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x38, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x28, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0x25, 0x33,
+  0x15, 0x23, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33,
+  0x32, 0x19, 0x01, 0x26, 0x23, 0x22, 0x15, 0x03, 0x23, 0x03, 0x34, 0x2b,
+  0x01, 0x27, 0x37, 0x17, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11, 0x02,
+  0x35, 0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0xaf, 0xfe, 0x96, 0xfe,
+  0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81, 0x09,
+  0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01, 0x12,
+  0x06, 0x38, 0xca, 0xca, 0xca, 0xfa, 0x52, 0xfe, 0x5d, 0x01, 0xa3, 0xe3,
+  0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe, 0xa5, 0x01,
+  0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x07, 0x3c, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x2c, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21,
+  0x01, 0x33, 0x15, 0x23, 0x25, 0x33, 0x15, 0x23, 0x01, 0x10, 0x21, 0x20,
+  0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22,
+  0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32,
+  0x17, 0x36, 0x33, 0x20, 0x11, 0xd4, 0x02, 0x1a, 0xfd, 0xe6, 0x01, 0x61,
+  0xb7, 0xb7, 0xfe, 0xa0, 0xb7, 0xb7, 0x02, 0xaf, 0xfe, 0x96, 0xfe, 0x73,
+  0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81, 0x09, 0x8c,
+  0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01, 0x12, 0x05,
+  0xab, 0x94, 0x02, 0x25, 0xca, 0xca, 0xca, 0xf9, 0x4e, 0xfe, 0x5d, 0x01,
+  0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe,
+  0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00,
+  0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x64, 0x00, 0x03,
+  0x00, 0x24, 0x00, 0x00, 0x01, 0x33, 0x03, 0x23, 0x01, 0x10, 0x21, 0x20,
+  0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22,
+  0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32,
+  0x17, 0x36, 0x33, 0x20, 0x11, 0x02, 0x1d, 0xc1, 0xdf, 0x93, 0x02, 0x18,
+  0xfe, 0x96, 0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f,
+  0x09, 0x81, 0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c,
+  0x90, 0x01, 0x12, 0x06, 0x64, 0xfe, 0xf8, 0xfa, 0x64, 0xfe, 0x5d, 0x01,
+  0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6, 0x8c, 0xfe,
+  0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe, 0xc7, 0x00,
+  0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84, 0x06, 0x79, 0x00, 0x08,
+  0x00, 0x29, 0x00, 0x00, 0x01, 0x02, 0x20, 0x03, 0x33, 0x16, 0x33, 0x32,
+  0x37, 0x13, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10, 0x33, 0x32,
+  0x19, 0x01, 0x26, 0x23, 0x22, 0x15, 0x03, 0x23, 0x03, 0x34, 0x2b, 0x01,
+  0x27, 0x37, 0x17, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11, 0x02, 0xf2,
+  0x11, 0xfd, 0xef, 0x11, 0x6a, 0x17, 0x98, 0x9b, 0x15, 0xfc, 0xfe, 0x96,
+  0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81,
+  0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01,
+  0x12, 0x06, 0x79, 0xfe, 0xe1, 0x01, 0x1f, 0x96, 0x96, 0xf9, 0x47, 0xfe,
+  0x5d, 0x01, 0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6,
+  0x8c, 0xfe, 0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe,
+  0xc7, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36, 0xfe, 0x1d, 0x03, 0x84,
+  0x06, 0xd1, 0x00, 0x06, 0x00, 0x27, 0x00, 0x00, 0x01, 0x13, 0x23, 0x27,
+  0x07, 0x23, 0x13, 0x01, 0x10, 0x21, 0x20, 0x11, 0x37, 0x33, 0x07, 0x10,
+  0x33, 0x32, 0x19, 0x01, 0x26, 0x23, 0x22, 0x15, 0x03, 0x23, 0x03, 0x34,
+  0x2b, 0x01, 0x27, 0x37, 0x17, 0x33, 0x32, 0x17, 0x36, 0x33, 0x20, 0x11,
+  0x02, 0x1c, 0xdc, 0x7d, 0xa2, 0xa2, 0x7d, 0xdd, 0x01, 0xed, 0xfe, 0x96,
+  0xfe, 0x73, 0x17, 0xa0, 0x15, 0xeb, 0xd1, 0x02, 0x79, 0x6f, 0x09, 0x81,
+  0x09, 0x8c, 0x4a, 0x62, 0x12, 0x4e, 0x48, 0x81, 0x47, 0x3c, 0x90, 0x01,
+  0x12, 0x06, 0xd1, 0xfe, 0x88, 0xf5, 0xf5, 0x01, 0x78, 0xf8, 0xef, 0xfe,
+  0x5d, 0x01, 0xa3, 0xe3, 0xe3, 0xfe, 0xe9, 0x01, 0x17, 0x03, 0x67, 0xb6,
+  0x8c, 0xfe, 0xa5, 0x01, 0x5b, 0x78, 0x28, 0xa1, 0x32, 0xbb, 0xbb, 0xfe,
+  0xc7, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03,
+  0x06, 0x14, 0x00, 0x09, 0x00, 0x20, 0x00, 0x00, 0x01, 0x22, 0x06, 0x10,
+  0x16, 0x20, 0x36, 0x35, 0x34, 0x26, 0x01, 0x10, 0x37, 0x2e, 0x01, 0x35,
+  0x34, 0x36, 0x33, 0x21, 0x15, 0x21, 0x22, 0x15, 0x14, 0x16, 0x33, 0x32,
+  0x12, 0x10, 0x02, 0x20, 0x02, 0x02, 0x33, 0x84, 0x9b, 0x9a, 0x01, 0x0b,
+  0x9a, 0x9a, 0xfd, 0xad, 0xaf, 0x47, 0x3a, 0xae, 0x8e, 0x01, 0xca, 0xfe,
+  0x57, 0xa9, 0x69, 0x83, 0xd6, 0xf9, 0xf8, 0xfe, 0x50, 0xf5, 0x03, 0xdf,
+  0xe7, 0xfe, 0x6e, 0xe7, 0xe8, 0xc7, 0xc8, 0xe9, 0xfe, 0x50, 0x01, 0x4d,
+  0x9b, 0x2f, 0x8d, 0x31, 0x7c, 0x94, 0x93, 0x89, 0x49, 0x34, 0xfe, 0xc8,
+  0xfd, 0xda, 0xfe, 0xc6, 0x01, 0x39, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a,
+  0x00, 0x00, 0x05, 0x19, 0x06, 0x14, 0x00, 0x24, 0x00, 0x00, 0x01, 0x15,
+  0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x07, 0x06, 0x1d, 0x01, 0x21, 0x35, 0x34, 0x36, 0x33, 0x05,
+  0x19, 0x9e, 0x59, 0x46, 0x01, 0x11, 0xfe, 0xef, 0xa6, 0xfe, 0x39, 0xa6,
+  0x9f, 0x9f, 0x9c, 0xaa, 0x9d, 0x9e, 0x5a, 0x22, 0x23, 0x01, 0xc7, 0x9c,
+  0xaa, 0x06, 0x14, 0x99, 0x50, 0x68, 0x63, 0x8f, 0xfc, 0x2f, 0x03, 0xd1,
+  0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0xab, 0x99, 0x28, 0x28, 0x68,
+  0x63, 0x4e, 0xbb, 0xab, 0x00, 0x02, 0x00, 0x2a, 0x00, 0x00, 0x03, 0xdd,
+  0x06, 0x14, 0x00, 0x15, 0x00, 0x19, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11,
+  0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x01, 0x33, 0x15, 0x23, 0x03, 0xdc,
+  0xa6, 0xfe, 0x39, 0xa6, 0x9f, 0x9f, 0x9b, 0xa2, 0xa6, 0x9e, 0x5a, 0x45,
+  0x01, 0xc7, 0xa6, 0xa6, 0x04, 0x60, 0xfb, 0xa0, 0x03, 0xd1, 0xfc, 0x2f,
+  0x03, 0xd1, 0x8f, 0x4e, 0xb7, 0xaf, 0x99, 0x50, 0x68, 0x63, 0x01, 0xb2,
+  0xe9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x03, 0xdd,
+  0x06, 0x14, 0x00, 0x15, 0x00, 0x00, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35,
+  0x33, 0x35, 0x34, 0x36, 0x02, 0x0f, 0x01, 0xcd, 0xa6, 0xfe, 0xd8, 0x5a,
+  0x45, 0x01, 0x11, 0xfe, 0xef, 0xa6, 0x9f, 0x9f, 0x9c, 0x06, 0x14, 0xf9,
+  0xec, 0x05, 0x7b, 0x50, 0x68, 0x63, 0x8f, 0xfc, 0x2f, 0x03, 0xd1, 0x8f,
+  0x4e, 0xbb, 0xab, 0x00, 0x00, 0x02, 0x00, 0x2a, 0x00, 0x00, 0x06, 0x4a,
+  0x06, 0x14, 0x00, 0x29, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x15, 0x23, 0x22,
+  0x07, 0x06, 0x1d, 0x01, 0x21, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x11, 0x23, 0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34,
+  0x36, 0x33, 0x05, 0x33, 0x15, 0x23, 0x02, 0xac, 0x9e, 0x5a, 0x22, 0x23,
+  0x01, 0xc7, 0x4e, 0x19, 0x23, 0x47, 0x75, 0x9d, 0x9e, 0x59, 0x46, 0x02,
+  0x6d, 0xa6, 0xfe, 0x39, 0xa6, 0xfe, 0x39, 0xa6, 0x9f, 0x9f, 0x9c, 0xaa,
+  0x03, 0x94, 0xa6, 0xa6, 0x06, 0x14, 0x99, 0x28, 0x28, 0x68, 0x63, 0x4e,
+  0xbb, 0x55, 0x1c, 0x13, 0x27, 0x99, 0x50, 0x68, 0x63, 0xfb, 0xa0, 0x03,
+  0xd1, 0xfc, 0x2f, 0x03, 0xd1, 0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb,
+  0xab, 0x02, 0xe9, 0x00, 0x00, 0x01, 0x00, 0x2a, 0x00, 0x00, 0x06, 0x4a,
+  0x06, 0x14, 0x00, 0x26, 0x00, 0x00, 0x01, 0x15, 0x23, 0x22, 0x07, 0x06,
+  0x1d, 0x01, 0x21, 0x35, 0x34, 0x36, 0x33, 0x21, 0x11, 0x23, 0x11, 0x21,
+  0x22, 0x06, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x23, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x36, 0x33, 0x02, 0xac, 0x9e,
+  0x5a, 0x22, 0x23, 0x01, 0xc7, 0x9c, 0xaa, 0x01, 0xcd, 0xa6, 0xfe, 0xd8,
+  0x59, 0x46, 0x01, 0x11, 0xfe, 0xef, 0xa6, 0xfe, 0x39, 0xa6, 0x9f, 0x9f,
+  0x9c, 0xaa, 0x06, 0x14, 0x99, 0x28, 0x28, 0x68, 0x63, 0x4e, 0xbb, 0xab,
+  0xf9, 0xec, 0x05, 0x7b, 0x50, 0x68, 0x63, 0x8f, 0xfc, 0x2f, 0x03, 0xd1,
+  0xfc, 0x2f, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0xab, 0x00, 0x01, 0x00, 0x2a,
+  0x00, 0x00, 0x04, 0xc5, 0x06, 0x14, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x35,
+  0x34, 0x27, 0x26, 0x2b, 0x01, 0x22, 0x07, 0x06, 0x15, 0x11, 0x23, 0x11,
+  0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36, 0x3b, 0x01, 0x32, 0x17, 0x16,
+  0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23, 0x35, 0x02, 0xc9, 0x21, 0x21,
+  0x5b, 0x1e, 0x5a, 0x23, 0x22, 0xa6, 0x9f, 0x9f, 0x4e, 0x4e, 0xaa, 0x1b,
+  0xaa, 0x4f, 0x4c, 0x01, 0x55, 0xfe, 0xab, 0x22, 0x22, 0x67, 0xaa, 0xaa,
+  0xbf, 0x49, 0x49, 0x7a, 0x04, 0x60, 0x63, 0x68, 0x28, 0x28, 0x28, 0x28,
+  0x68, 0xfb, 0x3d, 0x03, 0xd1, 0x8f, 0x4e, 0xbb, 0x55, 0x56, 0x56, 0x53,
+  0xbd, 0x4e, 0x8f, 0xfd, 0xa0, 0x89, 0x27, 0x27, 0x9a, 0x50, 0x4f, 0xd2,
+  0x02, 0x60, 0x8f, 0x00, 0x00, 0x01, 0x00, 0x63, 0xff, 0xe3, 0x06, 0x07,
+  0x05, 0xf0, 0x00, 0x59, 0x00, 0x00, 0x01, 0x15, 0x26, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15,
+  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x32, 0x17, 0x16, 0x1d, 0x01, 0x21, 0x15, 0x21, 0x11, 0x14,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x35, 0x11, 0x23,
+  0x35, 0x33, 0x35, 0x34, 0x27, 0x26, 0x07, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x02, 0xfc, 0x4d, 0x42, 0x4c, 0x3f, 0x69, 0x39, 0x35, 0x2c, 0x2d, 0x85,
+  0x38, 0xb0, 0x95, 0x6e, 0x70, 0xc2, 0x57, 0x53, 0x57, 0x61, 0x5c, 0x59,
+  0x59, 0x57, 0x75, 0x3f, 0x3f, 0x2d, 0x28, 0xa0, 0x39, 0x9a, 0x44, 0x45,
+  0x5c, 0x65, 0xa3, 0x40, 0x46, 0x05, 0x53, 0x52, 0x92, 0x7e, 0x58, 0x55,
+  0x01, 0x55, 0xfe, 0xab, 0x21, 0x22, 0x67, 0xab, 0xab, 0xbf, 0x49, 0x49,
+  0x79, 0x79, 0x2b, 0x31, 0x3d, 0x3e, 0x31, 0x2f, 0x04, 0x3f, 0xae, 0x2b,
+  0x11, 0x14, 0x2a, 0x27, 0x57, 0x40, 0x25, 0x24, 0x21, 0x0e, 0x2b, 0x98,
+  0x89, 0x9c, 0x5b, 0x5b, 0x11, 0x12, 0x23, 0xbe, 0x35, 0x1a, 0x1b, 0x2d,
+  0x2c, 0x51, 0x4b, 0x28, 0x23, 0x2a, 0x0f, 0x24, 0x4a, 0x4b, 0x82, 0xa6,
+  0x4e, 0x56, 0x0b, 0x1d, 0x1f, 0x87, 0x5f, 0x5d, 0x01, 0x60, 0x5c, 0x88,
+  0x4c, 0x8f, 0xfd, 0xa0, 0x89, 0x27, 0x27, 0x9a, 0x50, 0x4f, 0xd2, 0x02,
+  0x60, 0x8f, 0x4e, 0x41, 0x2b, 0x32, 0x01, 0x31, 0x30, 0x40, 0x3d, 0x00,
+  0x00, 0x01, 0xfc, 0xcb, 0x06, 0x04, 0x00, 0x00, 0x07, 0x6e, 0x00, 0x07,
+  0x00, 0x00, 0x11, 0x22, 0x04, 0x07, 0x35, 0x36, 0x24, 0x33, 0xd0, 0xfe,
+  0x6a, 0xcf, 0xd5, 0x01, 0x97, 0xc9, 0x06, 0xd4, 0x67, 0x69, 0x7e, 0x77,
+  0x75, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x06, 0x04, 0x03, 0x35,
+  0x07, 0x6e, 0x00, 0x07, 0x00, 0x00, 0x11, 0x35, 0x32, 0x04, 0x17, 0x15,
+  0x26, 0x24, 0xc9, 0x01, 0x97, 0xd5, 0xcf, 0xfe, 0x6a, 0x06, 0xd4, 0x9a,
+  0x75, 0x77, 0x7e, 0x69, 0x67, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x72,
+  0x06, 0x0d, 0x00, 0x00, 0x07, 0x27, 0x00, 0x13, 0x00, 0x00, 0x11, 0x2f,
+  0x01, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x23, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x04, 0x81, 0x19, 0x48, 0x27, 0x21,
+  0x5a, 0x30, 0x3f, 0x05, 0x91, 0x03, 0x66, 0x65, 0xb4, 0x52, 0x38, 0x32,
+  0x4f, 0x06, 0x48, 0x02, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x30, 0x47, 0x87,
+  0x4a, 0x49, 0x0e, 0x0d, 0x20, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+  0x06, 0x0d, 0x02, 0x8e, 0x07, 0x27, 0x00, 0x13, 0x00, 0x00, 0x11, 0x1f,
+  0x01, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x33, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x04, 0x81, 0x19, 0x48, 0x27, 0x21,
+  0x57, 0x33, 0x40, 0x04, 0x91, 0x03, 0x66, 0x65, 0xb4, 0x52, 0x38, 0x32,
+  0x4f, 0x06, 0xec, 0x02, 0x37, 0x0b, 0x12, 0x0a, 0x24, 0x2c, 0x4b, 0x87,
+  0x4a, 0x49, 0x0e, 0x0d, 0x20, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x1b,
+  0xff, 0x54, 0x07, 0x47, 0x07, 0x4c, 0x00, 0x03, 0x00, 0x07, 0x00, 0x2a,
+  0x00, 0x00, 0x09, 0x04, 0x15, 0x33, 0x35, 0x27, 0x35, 0x34, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x3f, 0x01, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x0f, 0x01, 0x0e, 0x01, 0x1d, 0x01, 0x03, 0xb1, 0x03, 0x96, 0xfc, 0x6a,
+  0xfc, 0x6a, 0x03, 0x3a, 0xb7, 0x06, 0x06, 0x05, 0x07, 0x12, 0x14, 0x28,
+  0x4f, 0x53, 0x1e, 0x21, 0xc9, 0xa5, 0x5d, 0xae, 0x54, 0x57, 0xa1, 0x47,
+  0x61, 0x76, 0x2e, 0x33, 0x51, 0x51, 0x32, 0x07, 0x4c, 0xfc, 0x04, 0xfc,
+  0x04, 0x03, 0xfc, 0xfd, 0xae, 0xfe, 0xfe, 0x93, 0x7b, 0x34, 0x3c, 0x15,
+  0x19, 0x1a, 0x1f, 0x2b, 0x56, 0x5a, 0x40, 0x45, 0x4c, 0x9f, 0xc2, 0x38,
+  0x39, 0xbc, 0x43, 0x46, 0x6e, 0x59, 0x31, 0x5e, 0x35, 0x59, 0x56, 0x82,
+  0x65, 0x9a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5a, 0xff, 0xe3, 0x05, 0x19,
+  0x05, 0xd5, 0x00, 0x07, 0x00, 0x0a, 0x00, 0x00, 0x37, 0x01, 0x33, 0x01,
+  0x07, 0x03, 0x21, 0x03, 0x13, 0x21, 0x03, 0x5a, 0x01, 0xf8, 0xcf, 0x01,
+  0xf8, 0x97, 0xae, 0xfd, 0xcb, 0xae, 0xec, 0x01, 0xb9, 0xdc, 0x23, 0x05,
+  0xb2, 0xfa, 0x4e, 0x40, 0x01, 0xf6, 0xfe, 0x0a, 0x02, 0xaa, 0x02, 0x7c,
+  0x00, 0x03, 0x00, 0xb4, 0xff, 0xed, 0x03, 0xac, 0x05, 0xe8, 0x00, 0x09,
+  0x00, 0x1a, 0x00, 0x24, 0x00, 0x00, 0x01, 0x11, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x01, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x16, 0x15, 0x14, 0x07, 0x06, 0x21, 0x22, 0x27, 0x13, 0x11, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x01, 0x56, 0x2f, 0xe2, 0x6b,
+  0x37, 0xb3, 0x9d, 0xfe, 0xfb, 0x7a, 0x5a, 0xd8, 0x92, 0xba, 0xc2, 0xc1,
+  0x6a, 0x99, 0xfe, 0xdd, 0x5a, 0x77, 0xa2, 0x64, 0xd2, 0x55, 0x28, 0xd5,
+  0xac, 0x02, 0x7e, 0xfe, 0x23, 0x72, 0x3b, 0x42, 0x59, 0x95, 0x03, 0x57,
+  0x13, 0x61, 0x7b, 0xd0, 0xd5, 0x7a, 0x7a, 0xe4, 0x8e, 0x70, 0xa4, 0x13,
+  0x05, 0x34, 0xfe, 0x15, 0x80, 0x3d, 0x38, 0x68, 0x8e, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x5a, 0xff, 0xe3, 0x03, 0x86, 0x05, 0xf3, 0x00, 0x05,
+  0x00, 0x00, 0x05, 0x09, 0x01, 0x17, 0x09, 0x01, 0x03, 0x14, 0xfd, 0x46,
+  0x02, 0xba, 0x72, 0xfd, 0xb9, 0x02, 0x47, 0x1d, 0x03, 0x08, 0x03, 0x08,
+  0x7f, 0xfd, 0x77, 0xfd, 0x77, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0x9f, 0x05, 0xd2, 0x00, 0x0c, 0x00, 0x15, 0x00, 0x00,
+  0x33, 0x11, 0x33, 0x20, 0x17, 0x16, 0x17, 0x16, 0x10, 0x07, 0x06, 0x04,
+  0x21, 0x37, 0x3e, 0x02, 0x10, 0x27, 0x2e, 0x01, 0x27, 0xb4, 0x51, 0x01,
+  0x5d, 0x8e, 0x90, 0x16, 0x09, 0x23, 0x32, 0xfe, 0xd9, 0xfe, 0xe2, 0x51,
+  0xb9, 0xb3, 0x3b, 0x09, 0x10, 0xa9, 0xe5, 0x05, 0xd2, 0x78, 0x7a, 0xf9,
+  0x65, 0xfe, 0x62, 0x7f, 0xb8, 0xad, 0xc0, 0x08, 0x63, 0xd4, 0x01, 0x7a,
+  0x5c, 0xac, 0x91, 0x0a, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0x40,
+  0x05, 0xf2, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x23, 0x11, 0x05, 0x07,
+  0x25, 0x11, 0x05, 0x07, 0x25, 0x11, 0x05, 0x07, 0x01, 0x56, 0xa2, 0x02,
+  0x8c, 0x1a, 0xfe, 0x30, 0x01, 0xea, 0x1a, 0xfe, 0x30, 0x01, 0xea, 0x1a,
+  0x01, 0x36, 0xfe, 0xca, 0x05, 0xf2, 0x75, 0xb2, 0x53, 0xfe, 0xc3, 0x58,
+  0xb2, 0x53, 0xfe, 0xc3, 0x58, 0xb2, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0x40, 0x05, 0xf2, 0x00, 0x09, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x05, 0x07, 0x25, 0x11, 0x05, 0x07, 0x01, 0x56, 0xa2, 0x02,
+  0x8c, 0x1a, 0xfe, 0x30, 0x01, 0xea, 0x1a, 0x03, 0x2a, 0xfc, 0xd6, 0x05,
+  0xf2, 0x75, 0xb2, 0x53, 0xfe, 0xc3, 0x58, 0xb2, 0x00, 0x01, 0x00, 0x87,
+  0x00, 0x00, 0x02, 0xa3, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x87, 0x02,
+  0x1c, 0xbd, 0xbd, 0xfd, 0xe4, 0xbd, 0xbd, 0x05, 0xd5, 0xb4, 0xfb, 0x93,
+  0xb4, 0xb4, 0x04, 0x6d, 0x00, 0x03, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xcc,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
+  0x11, 0x21, 0x01, 0x11, 0x21, 0x11, 0x05, 0x21, 0x11, 0x21, 0xb4, 0x03,
+  0x18, 0xfc, 0xe8, 0x02, 0x76, 0xfe, 0x2c, 0x01, 0xd4, 0xfe, 0x2c, 0x01,
+  0xd4, 0x05, 0xd5, 0xfa, 0x2b, 0x03, 0x45, 0x01, 0xdc, 0xfe, 0x24, 0xb4,
+  0xfe, 0x23, 0x00, 0x00, 0x00, 0x05, 0x00, 0x87, 0xff, 0xe3, 0x05, 0xfa,
+  0x05, 0xf3, 0x00, 0x0f, 0x00, 0x14, 0x00, 0x19, 0x00, 0x1e, 0x00, 0x23,
+  0x00, 0x00, 0x00, 0x02, 0x06, 0x04, 0x20, 0x24, 0x26, 0x02, 0x10, 0x12,
+  0x36, 0x24, 0x20, 0x04, 0x16, 0x12, 0x01, 0x36, 0x12, 0x37, 0x21, 0x03,
+  0x11, 0x21, 0x16, 0x12, 0x01, 0x21, 0x11, 0x06, 0x02, 0x01, 0x11, 0x21,
+  0x26, 0x02, 0x05, 0xfa, 0x6e, 0xbb, 0xfe, 0xfd, 0xfe, 0xe5, 0xfe, 0xfd,
+  0xbb, 0x6e, 0x6e, 0xbb, 0x01, 0x03, 0x01, 0x1b, 0x01, 0x03, 0xbb, 0x6e,
+  0xfd, 0x98, 0xae, 0xf7, 0x1b, 0xfe, 0x40, 0xa2, 0xfe, 0x3f, 0x1b, 0xf7,
+  0xfe, 0xee, 0x01, 0xc1, 0xaf, 0xf7, 0x02, 0x48, 0x01, 0xc0, 0x1b, 0xf7,
+  0x02, 0x4e, 0xfe, 0xe0, 0xd0, 0x7b, 0x7b, 0xd0, 0x01, 0x20, 0x01, 0x3a,
+  0x01, 0x20, 0xd0, 0x7b, 0x7b, 0xd0, 0xfe, 0xe0, 0xfd, 0x16, 0x1e, 0x01,
+  0x12, 0xc3, 0xfe, 0x0d, 0x01, 0xf3, 0xc3, 0xfe, 0xee, 0x02, 0x89, 0x01,
+  0xf3, 0x1e, 0xfe, 0xee, 0x01, 0x30, 0xfe, 0x0d, 0xc3, 0x01, 0x12, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x56, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x00, 0x13, 0x33, 0x11, 0x23, 0xb4, 0xa2, 0xa2, 0x05, 0xd5, 0xfa,
+  0x2b, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0xff, 0xe3, 0x04, 0x10,
+  0x05, 0xf3, 0x00, 0x0a, 0x00, 0x00, 0x21, 0x23, 0x11, 0x33, 0x11, 0x01,
+  0x17, 0x09, 0x01, 0x07, 0x01, 0x01, 0x56, 0xa2, 0xa2, 0x02, 0x47, 0x6c,
+  0xfd, 0x76, 0x02, 0x91, 0x6c, 0xfd, 0xb2, 0x05, 0xd5, 0xfd, 0xe1, 0x02,
+  0x3d, 0x86, 0xfd, 0x81, 0xfd, 0x7b, 0x86, 0x02, 0x43, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x03, 0x96, 0x05, 0xd5, 0x00, 0x06,
+  0x00, 0x00, 0x09, 0x01, 0x17, 0x01, 0x23, 0x11, 0x33, 0x01, 0x56, 0x01,
+  0xcc, 0x73, 0xfd, 0x92, 0x73, 0xa2, 0x01, 0x33, 0x02, 0x00, 0x80, 0xfd,
+  0x4d, 0x05, 0xd5, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x09, 0xbf,
+  0x05, 0xf3, 0x00, 0x0c, 0x00, 0x00, 0x13, 0x33, 0x09, 0x03, 0x17, 0x09,
+  0x03, 0x11, 0x23, 0xb4, 0x68, 0x02, 0x43, 0x01, 0xff, 0x01, 0xf7, 0x01,
+  0xf7, 0x73, 0xfd, 0x96, 0xfe, 0x0a, 0xfe, 0x09, 0xfd, 0xee, 0xa2, 0x05,
+  0xd5, 0xfd, 0xe5, 0x02, 0x39, 0xfd, 0xd1, 0x02, 0x2f, 0x80, 0xfd, 0x53,
+  0x02, 0x2e, 0xfd, 0xd2, 0x01, 0xee, 0xfb, 0x4c, 0x00, 0x01, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0xd2, 0x05, 0xf3, 0x00, 0x08, 0x00, 0x00, 0x13, 0x33,
+  0x09, 0x01, 0x17, 0x09, 0x01, 0x11, 0x23, 0xb4, 0x68, 0x02, 0x43, 0x01,
+  0xff, 0x74, 0xfd, 0x96, 0xfd, 0xee, 0xa2, 0x05, 0xd5, 0xfd, 0xe5, 0x02,
+  0x39, 0x80, 0xfd, 0x53, 0x01, 0xee, 0xfb, 0x4c, 0x00, 0x05, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0xf3, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11, 0x01, 0x21,
+  0x11, 0x21, 0x01, 0x11, 0x21, 0x11, 0x21, 0x11, 0x21, 0x11, 0x13, 0x11,
+  0x21, 0x11, 0x01, 0x56, 0x01, 0xac, 0xfd, 0xb2, 0x05, 0x3f, 0xfa, 0xc1,
+  0x02, 0xf0, 0x01, 0xad, 0xfc, 0x05, 0x01, 0xac, 0xa2, 0x01, 0xad, 0x02,
+  0x90, 0xfe, 0x24, 0x01, 0xdc, 0x03, 0x45, 0xfa, 0x2b, 0x05, 0x21, 0xfe,
+  0x24, 0x01, 0xdc, 0xfe, 0x24, 0x01, 0xdc, 0xfd, 0x6f, 0xfe, 0x24, 0x01,
+  0xdc, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x87, 0xff, 0xe3, 0x05, 0xfa,
+  0x05, 0xf3, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x27, 0x00, 0x00, 0x00, 0x36,
+  0x34, 0x2e, 0x02, 0x22, 0x0e, 0x02, 0x14, 0x1e, 0x02, 0x32, 0x36, 0x00,
+  0x02, 0x06, 0x04, 0x20, 0x24, 0x26, 0x02, 0x10, 0x12, 0x36, 0x24, 0x20,
+  0x04, 0x16, 0x12, 0x04, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x16, 0x05,
+  0x03, 0x55, 0x55, 0x8f, 0xc8, 0xd8, 0xc7, 0x8f, 0x55, 0x55, 0x8f, 0xc7,
+  0xd8, 0xc8, 0x01, 0x86, 0x6e, 0xbb, 0xfe, 0xfd, 0xfe, 0xe5, 0xfe, 0xfd,
+  0xbb, 0x6e, 0x6e, 0xbb, 0x01, 0x03, 0x01, 0x1b, 0x01, 0x03, 0xbb, 0x6e,
+  0xfd, 0xc4, 0x49, 0x69, 0x4a, 0x4a, 0x69, 0x49, 0x01, 0x94, 0xdf, 0xf0,
+  0xdf, 0x9e, 0x5f, 0x5f, 0x9e, 0xdf, 0xf0, 0xdf, 0x9e, 0x5f, 0x5f, 0x01,
+  0x58, 0xfe, 0xe0, 0xd0, 0x7b, 0x7b, 0xd0, 0x01, 0x20, 0x01, 0x3a, 0x01,
+  0x20, 0xd0, 0x7b, 0x7b, 0xd0, 0xfe, 0xe0, 0xd7, 0x52, 0x52, 0x74, 0x52,
+  0x52, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6a,
+  0x05, 0xe8, 0x00, 0x11, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x24, 0x21,
+  0x22, 0x07, 0x11, 0x23, 0x11, 0x36, 0x33, 0x20, 0x00, 0x11, 0x10, 0x05,
+  0x02, 0xd7, 0xf1, 0xfe, 0xf1, 0xfe, 0xfe, 0x2f, 0x32, 0xa2, 0x92, 0x71,
+  0x01, 0x3f, 0x01, 0x74, 0xfe, 0xa7, 0x02, 0x59, 0x66, 0xd4, 0xb6, 0xf9,
+  0x06, 0xfa, 0xc4, 0x05, 0xd4, 0x14, 0xfe, 0xbf, 0xfe, 0xec, 0xfe, 0xb0,
+  0x92, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x05, 0x8d,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x33, 0x11, 0x33, 0x09, 0x01, 0x33,
+  0x11, 0x23, 0x11, 0x09, 0x01, 0x11, 0xb4, 0xa2, 0x01, 0xca, 0x01, 0xca,
+  0xa2, 0xa2, 0xfe, 0x36, 0xfe, 0x36, 0x05, 0xd5, 0xfd, 0xa2, 0x02, 0x5e,
+  0xfa, 0x2b, 0x04, 0xbd, 0xfd, 0xa1, 0x02, 0x5f, 0xfb, 0x43, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x87, 0x00, 0x00, 0x03, 0xb1, 0x05, 0xf2, 0x00, 0x0b,
+  0x00, 0x1d, 0x00, 0x00, 0x00, 0x34, 0x2e, 0x01, 0x22, 0x0e, 0x01, 0x14,
+  0x1e, 0x01, 0x32, 0x3e, 0x01, 0x06, 0x07, 0x06, 0x07, 0x11, 0x23, 0x11,
+  0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x03, 0x0f,
+  0x41, 0x70, 0x84, 0x70, 0x41, 0x41, 0x70, 0x84, 0x70, 0xe3, 0x6e, 0x5c,
+  0x39, 0x41, 0xa2, 0x40, 0x3a, 0x5e, 0x6c, 0x6d, 0xba, 0xdc, 0xba, 0x6d,
+  0x03, 0xe7, 0x93, 0x7c, 0x48, 0x48, 0x7c, 0x93, 0x7d, 0x48, 0x48, 0x4c,
+  0xd1, 0x3b, 0x25, 0x0e, 0xfd, 0x89, 0x02, 0x77, 0x0e, 0x25, 0x3c, 0xd0,
+  0xf4, 0xcf, 0x79, 0x79, 0xcf, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0xd7, 0x05, 0xe9, 0x00, 0x0c, 0x00, 0x17, 0x00, 0x00,
+  0x08, 0x01, 0x15, 0x14, 0x02, 0x07, 0x06, 0x23, 0x11, 0x23, 0x11, 0x36,
+  0x33, 0x03, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x02, 0x8f, 0x01, 0x48, 0xb4, 0xe6, 0x6a, 0x7d, 0xa2, 0x92, 0x71, 0x61,
+  0xee, 0x78, 0x79, 0x7d, 0x67, 0xab, 0x26, 0x2a, 0x05, 0xe9, 0xfe, 0xe5,
+  0xfc, 0x8d, 0xfe, 0xd1, 0x4e, 0x24, 0xfe, 0x5c, 0x05, 0xd5, 0x14, 0xfc,
+  0x6f, 0x73, 0x72, 0x96, 0x9e, 0x6c, 0x58, 0x04, 0x00, 0x01, 0x00, 0x87,
+  0xff, 0xf2, 0x02, 0xa7, 0x05, 0xea, 0x00, 0x09, 0x00, 0x00, 0x09, 0x03,
+  0x07, 0x09, 0x03, 0x17, 0x01, 0x6c, 0x01, 0x3b, 0xfe, 0xc5, 0x01, 0x02,
+  0x73, 0xfe, 0x8c, 0x01, 0x3b, 0xfe, 0xc5, 0x01, 0x74, 0x73, 0x04, 0x4c,
+  0xfe, 0xa2, 0xfe, 0xa2, 0xfe, 0xe2, 0x80, 0x01, 0x9e, 0x01, 0x5e, 0x01,
+  0x5e, 0x01, 0x9e, 0x80, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x04, 0x7d,
+  0x05, 0xf2, 0x00, 0x07, 0x00, 0x00, 0x01, 0x07, 0x25, 0x11, 0x23, 0x11,
+  0x25, 0x37, 0x04, 0x7c, 0x32, 0xfe, 0x60, 0xa2, 0xfe, 0x52, 0x32, 0x04,
+  0x8a, 0xac, 0x95, 0xfb, 0x8d, 0x04, 0xad, 0x99, 0xac, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x3c, 0x05, 0xea, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x17, 0x01, 0x11, 0x23, 0x11, 0x33, 0x11, 0x03, 0xc8,
+  0x74, 0xfd, 0x1a, 0xa2, 0xa2, 0x05, 0xea, 0x80, 0xfc, 0xc9, 0xfd, 0xcd,
+  0x05, 0xd5, 0xfd, 0x5c, 0x00, 0x01, 0x00, 0x87, 0xff, 0xe3, 0x04, 0x6a,
+  0x05, 0xf2, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01, 0x37, 0x09, 0x01, 0x17,
+  0x09, 0x01, 0x07, 0x09, 0x01, 0x27, 0x02, 0x16, 0xfe, 0x71, 0x87, 0x01,
+  0x6a, 0x01, 0x6a, 0x88, 0xfe, 0x71, 0x01, 0x8f, 0x88, 0xfe, 0x96, 0xfe,
+  0x96, 0x87, 0x02, 0xed, 0x02, 0xa3, 0x62, 0xfd, 0xa1, 0x02, 0x5f, 0x62,
+  0xfd, 0x5d, 0xfd, 0x58, 0x62, 0x02, 0x64, 0xfd, 0x9c, 0x62, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x87, 0x00, 0x00, 0x04, 0x65, 0x05, 0xd5, 0x00, 0x13,
+  0x00, 0x1b, 0x00, 0x24, 0x00, 0x00, 0x21, 0x23, 0x35, 0x26, 0x27, 0x26,
+  0x10, 0x37, 0x36, 0x37, 0x35, 0x33, 0x15, 0x16, 0x17, 0x16, 0x10, 0x07,
+  0x06, 0x07, 0x19, 0x01, 0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x03, 0x11,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x02, 0xc7, 0xa2, 0x99, 0x74,
+  0x91, 0x91, 0x73, 0x9a, 0xa2, 0x99, 0x74, 0x91, 0x91, 0x73, 0x9a, 0x56,
+  0x44, 0x62, 0x62, 0x44, 0xf8, 0x56, 0x44, 0x62, 0x62, 0x44, 0xcc, 0x1a,
+  0x80, 0xa1, 0x01, 0xc7, 0xa2, 0x80, 0x1a, 0xcb, 0xcb, 0x1a, 0x80, 0xa1,
+  0xfe, 0x39, 0xa2, 0x80, 0x1a, 0x03, 0x87, 0xfd, 0x30, 0x17, 0x4c, 0x6c,
+  0x01, 0x32, 0x6c, 0x4b, 0xfd, 0x48, 0x02, 0xd0, 0x17, 0x4c, 0x6e, 0x98,
+  0x96, 0x6e, 0x4c, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x05, 0x7b,
+  0x05, 0xf2, 0x00, 0x0b, 0x00, 0x00, 0x21, 0x23, 0x11, 0x01, 0x37, 0x01,
+  0x11, 0x33, 0x11, 0x01, 0x17, 0x01, 0x03, 0x3b, 0xa2, 0xfd, 0xc1, 0x73,
+  0x01, 0xcc, 0xa2, 0x01, 0xcc, 0x73, 0xfd, 0xc1, 0x02, 0xf4, 0x02, 0x7e,
+  0x80, 0xfe, 0x00, 0x01, 0xe3, 0xfe, 0x1d, 0x02, 0x00, 0x80, 0xfd, 0x82,
+  0x00, 0x03, 0x00, 0x87, 0xff, 0xf1, 0x03, 0x45, 0x05, 0xb9, 0x00, 0x07,
+  0x00, 0x1d, 0x00, 0x25, 0x00, 0x00, 0x00, 0x34, 0x26, 0x22, 0x06, 0x14,
+  0x16, 0x32, 0x24, 0x06, 0x20, 0x26, 0x10, 0x37, 0x36, 0x37, 0x26, 0x27,
+  0x26, 0x10, 0x36, 0x20, 0x16, 0x10, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
+  0x02, 0x34, 0x26, 0x22, 0x06, 0x14, 0x16, 0x32, 0x02, 0xa3, 0x6f, 0x9c,
+  0x6f, 0x6f, 0x9c, 0x01, 0x11, 0xce, 0xfe, 0xde, 0xce, 0x67, 0x2a, 0x31,
+  0x31, 0x2a, 0x67, 0xce, 0x01, 0x22, 0xce, 0x67, 0x2a, 0x31, 0x31, 0x2a,
+  0x67, 0xa2, 0x6f, 0x9c, 0x6f, 0x6f, 0x9c, 0x01, 0x20, 0xae, 0x7b, 0x7b,
+  0xae, 0x7b, 0x31, 0xe5, 0xe5, 0x01, 0x42, 0x73, 0x2f, 0x1b, 0x1c, 0x2e,
+  0x72, 0x01, 0x43, 0xe5, 0xe5, 0xfe, 0xbe, 0x73, 0x2f, 0x1b, 0x1c, 0x2e,
+  0x72, 0x01, 0xc3, 0xae, 0x7b, 0x7b, 0xae, 0x7b, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x03, 0x7d, 0x05, 0xe8, 0x00, 0x0a, 0x00, 0x13, 0x00, 0x00,
+  0x33, 0x11, 0x36, 0x33, 0x32, 0x04, 0x15, 0x14, 0x04, 0x23, 0x19, 0x01,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0xb4, 0x77, 0x74, 0xdb,
+  0x01, 0x03, 0xfe, 0xcb, 0xf2, 0xb6, 0xcf, 0xa2, 0x92, 0x26, 0x2b, 0x05,
+  0xd5, 0x13, 0xe6, 0xbd, 0xd0, 0xdc, 0xfd, 0x67, 0x03, 0x4e, 0x7f, 0x76,
+  0x63, 0x9c, 0x06, 0x00, 0x00, 0x02, 0x00, 0xb4, 0xff, 0xed, 0x03, 0x7d,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x14, 0x00, 0x00, 0x13, 0x33, 0x11, 0x32,
+  0x04, 0x15, 0x14, 0x04, 0x23, 0x22, 0x27, 0x13, 0x30, 0x11, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0xb4, 0xa2, 0xf2, 0x01, 0x35, 0xfe, 0xfd,
+  0xdb, 0x74, 0x77, 0xa2, 0x2b, 0x26, 0x92, 0xa2, 0xcf, 0x05, 0xd5, 0xfd,
+  0x67, 0xdc, 0xd0, 0xbd, 0xe6, 0x13, 0x02, 0x87, 0xfe, 0x12, 0x06, 0x9c,
+  0x63, 0x76, 0x7f, 0x00, 0x00, 0x01, 0x00, 0x5a, 0x00, 0x00, 0x02, 0x76,
+  0x05, 0xd5, 0x00, 0x07, 0x00, 0x00, 0x13, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x23, 0x11, 0x5a, 0x01, 0x7a, 0xa2, 0xa2, 0x02, 0x91, 0xb4, 0x02, 0x90,
+  0xfa, 0x2b, 0x02, 0x91, 0x00, 0x02, 0x00, 0x5a, 0x00, 0x00, 0x05, 0x19,
+  0x05, 0xf2, 0x00, 0x06, 0x00, 0x0e, 0x00, 0x00, 0x09, 0x01, 0x23, 0x01,
+  0x37, 0x09, 0x01, 0x00, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x16, 0x05,
+  0x19, 0xfe, 0x08, 0xcf, 0xfe, 0x08, 0x97, 0x01, 0xc9, 0x01, 0xc8, 0xfe,
+  0xb6, 0x4a, 0x69, 0x49, 0x49, 0x69, 0x4a, 0x05, 0xb2, 0xfa, 0x4e, 0x05,
+  0xb2, 0x40, 0xfa, 0xda, 0x05, 0x26, 0xfd, 0xd8, 0x52, 0x52, 0x74, 0x52,
+  0x52, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x01, 0x56,
+  0x05, 0xd5, 0x12, 0x06, 0x0f, 0x22, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0xff, 0xe3, 0x05, 0x19, 0x05, 0xd5, 0x00, 0x06, 0x00, 0x00, 0x37, 0x01,
+  0x33, 0x01, 0x07, 0x09, 0x01, 0x5a, 0x01, 0xf8, 0xcf, 0x01, 0xf8, 0x97,
+  0xfe, 0x38, 0xfe, 0x37, 0x23, 0x05, 0xb2, 0xfa, 0x4e, 0x40, 0x05, 0x26,
+  0xfa, 0xda, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0xff, 0xe3, 0x04, 0x6a,
+  0x05, 0xf2, 0x12, 0x06, 0x0f, 0x30, 0x00, 0x00, 0x00, 0x01, 0x00, 0x5a,
+  0x00, 0x00, 0x05, 0x8a, 0x05, 0xf3, 0x00, 0x08, 0x00, 0x00, 0x13, 0x09,
+  0x01, 0x07, 0x01, 0x11, 0x23, 0x11, 0x01, 0x5a, 0x02, 0x81, 0x02, 0xaf,
+  0x6e, 0xfe, 0x12, 0xa2, 0xfe, 0x41, 0x03, 0x2c, 0x02, 0xc7, 0xfd, 0x3b,
+  0x84, 0x01, 0xfe, 0xfb, 0x58, 0x04, 0x9d, 0xfe, 0x0f, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x99, 0x01, 0xe0, 0x05, 0xdc, 0x02, 0xa8, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x21, 0x35, 0x21, 0x05, 0x35,
+  0x21, 0x15, 0x29, 0x01, 0x35, 0x21, 0x01, 0xca, 0xfe, 0xcf, 0x01, 0x31,
+  0x02, 0xe0, 0x01, 0x31, 0xfd, 0xf7, 0xfe, 0xd0, 0x01, 0x30, 0x01, 0xe0,
+  0xc8, 0xc8, 0xc8, 0xc8, 0xc8, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x01, 0x37, 0x05, 0xdc, 0x04, 0x0e, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0xff, 0x58, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x46, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x01, 0x3a, 0x05, 0xdc, 0x04, 0x0a, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x62, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00,
+  0x01, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x01, 0x3d, 0x05, 0xdc,
+  0x04, 0x0b, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xff, 0x5d, 0x10, 0x07,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x43, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x01, 0x3b, 0x05, 0xdc, 0x04, 0x0a, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x01, 0x3c, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x62, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x01, 0x3d, 0x05, 0xdc, 0x04, 0x0a, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xff, 0x5d, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x62, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
+  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
+  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06,
+  0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26,
+  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c,
+  0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb3,
+  0x00, 0x00, 0x04, 0x80, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
+  0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00,
+  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x07,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26,
+  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00,
+  0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x26,
+  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x26,
+  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c,
+  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0f, 0x3c,
+  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26,
+  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80,
+  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
+  0x01, 0x80, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
+  0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
+  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x04, 0x80, 0x10, 0x07, 0x0f, 0x3c,
+  0x00, 0x00, 0xfe, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4,
+  0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x06, 0x0b, 0xb3,
+  0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
+  0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0b, 0xb4,
+  0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
+  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
+  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00,
+  0xfe, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x06, 0x0f, 0x3c,
+  0x00, 0xa0, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x06,
+  0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb4,
+  0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x26,
+  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07,
+  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x04, 0x80, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c,
+  0x00, 0xa0, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x04, 0x80, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0xfe, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07, 0x0f, 0x3c,
+  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
+  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80,
+  0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb3,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06,
+  0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00,
+  0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
+  0x0b, 0xb4, 0x00, 0x00, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0f, 0x3c, 0x00, 0xa0,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x06,
+  0x0b, 0xb3, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
+  0x0b, 0xb3, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
+  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x27, 0x0b, 0xb4,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0xfe, 0x20, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07,
+  0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb4,
+  0x00, 0x00, 0x03, 0x00, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
+  0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26,
+  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00, 0x03, 0x00,
+  0x10, 0x07, 0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x10, 0x07, 0x0f, 0x3c,
+  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x01, 0x80, 0x10, 0x26, 0x0b, 0xb3, 0x00, 0x00, 0x10, 0x07, 0x0f, 0x3c,
+  0x00, 0x00, 0x01, 0x20, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26, 0x0b, 0xb4, 0x00, 0x00,
+  0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x01, 0x80, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0xfe, 0x20, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00,
+  0x01, 0x80, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc,
+  0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0,
+  0x10, 0x06, 0x0b, 0xb3, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x99,
+  0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00, 0x01, 0x20, 0x10, 0x26,
+  0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x06, 0x0b, 0xb4, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x00, 0x00, 0x05, 0xdc, 0x05, 0x48, 0x10, 0x27,
+  0x0f, 0x3c, 0x00, 0x00, 0x02, 0xa0, 0x10, 0x27, 0x0f, 0x3c, 0x00, 0x00,
+  0x01, 0x20, 0x10, 0x26, 0x0f, 0x3c, 0x00, 0xa0, 0x10, 0x07, 0x0f, 0x3c,
+  0x00, 0x00, 0xfe, 0x20, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x46,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x0e, 0x00, 0x00, 0x01, 0x23,
+  0x01, 0x33, 0x09, 0x01, 0x21, 0x03, 0x21, 0x03, 0x23, 0x01, 0x17, 0x01,
+  0x21, 0x03, 0x07, 0xb9, 0x01, 0xbd, 0xb9, 0xfe, 0x81, 0x02, 0x01, 0xfe,
+  0x86, 0x89, 0xfd, 0xc0, 0x89, 0x6c, 0x02, 0x00, 0x16, 0xff, 0x00, 0x01,
+  0xff, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x71, 0xfa, 0x2b, 0x01, 0xa1, 0xfe,
+  0x5f, 0x05, 0xd5, 0xc7, 0xfc, 0xf7, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xc7, 0x05, 0xd5, 0x00, 0x0c, 0x00, 0x14, 0x00, 0x1c,
+  0x00, 0x20, 0x00, 0x25, 0x00, 0x2a, 0x00, 0x00, 0x13, 0x21, 0x32, 0x16,
+  0x15, 0x14, 0x07, 0x16, 0x11, 0x14, 0x06, 0x23, 0x21, 0x01, 0x11, 0x33,
+  0x32, 0x37, 0x11, 0x26, 0x23, 0x03, 0x11, 0x33, 0x36, 0x33, 0x11, 0x26,
+  0x23, 0x21, 0x11, 0x33, 0x11, 0x01, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x36,
+  0x35, 0x34, 0x27, 0xb5, 0x02, 0x29, 0xcf, 0xe1, 0xac, 0xe4, 0xf5, 0xe1,
+  0xfd, 0xc5, 0x01, 0x68, 0xd3, 0x35, 0x2d, 0x2d, 0x35, 0xd3, 0xc1, 0x20,
+  0x1d, 0x1d, 0x20, 0xfe, 0x31, 0xb6, 0x01, 0xec, 0xbb, 0xbb, 0x38, 0xbb,
+  0xbb, 0x05, 0xd5, 0xc0, 0xb1, 0xe5, 0x5d, 0x61, 0xfe, 0xe1, 0xc8, 0xda,
+  0x02, 0xe9, 0xfd, 0x7b, 0x07, 0x02, 0x77, 0x07, 0x02, 0x88, 0xfd, 0xdc,
+  0x03, 0x02, 0x1f, 0x02, 0xfa, 0xf3, 0x05, 0x0d, 0xfb, 0x11, 0x44, 0xdc,
+  0xe5, 0x44, 0x96, 0x36, 0xcd, 0xc4, 0x36, 0x00, 0x00, 0x04, 0x00, 0xd0,
+  0x00, 0x00, 0x05, 0x95, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x10, 0x00, 0x14,
+  0x00, 0x19, 0x00, 0x00, 0x13, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x29,
+  0x01, 0x01, 0x13, 0x33, 0x32, 0x37, 0x11, 0x26, 0x23, 0x21, 0x11, 0x33,
+  0x03, 0x01, 0x36, 0x11, 0x10, 0x27, 0xd1, 0x01, 0xcf, 0x01, 0x87, 0x01,
+  0x6d, 0xfe, 0x91, 0xfe, 0x7b, 0xfe, 0x31, 0x01, 0x6a, 0x01, 0x59, 0xdc,
+  0x90, 0x90, 0xdd, 0xfe, 0x98, 0xb6, 0x01, 0x02, 0x7f, 0xc8, 0xc8, 0x05,
+  0xd5, 0xfe, 0x97, 0xfe, 0x80, 0xfe, 0x7e, 0xfe, 0x96, 0x05, 0x71, 0xfa,
+  0xf3, 0x41, 0x04, 0x8b, 0x41, 0xfa, 0xf3, 0x05, 0x0d, 0xfb, 0x6b, 0x95,
+  0x01, 0x7b, 0x01, 0x71, 0x9c, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0xcb, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x11, 0x25, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
+  0x11, 0x21, 0x15, 0x21, 0x01, 0x0f, 0xb6, 0xfe, 0xf0, 0x04, 0x05, 0xfd,
+  0x65, 0x02, 0x80, 0xfd, 0x80, 0x02, 0xac, 0xfb, 0xea, 0x05, 0x71, 0xfa,
+  0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfd, 0xe4, 0x64, 0xfd, 0x73, 0x64, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x00, 0x09,
+  0x00, 0x0d, 0x00, 0x00, 0x13, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21,
+  0x11, 0x21, 0x01, 0x23, 0x11, 0x33, 0xb5, 0x03, 0xb9, 0xfd, 0xb1, 0x02,
+  0x15, 0xfd, 0xeb, 0xfe, 0x96, 0x01, 0x10, 0xb6, 0xb6, 0x05, 0xd5, 0x64,
+  0xfd, 0xe4, 0x64, 0xfd, 0x0f, 0x05, 0x71, 0xfa, 0xf3, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xfe, 0x05, 0xf0, 0x00, 0x1d,
+  0x00, 0x26, 0x00, 0x00, 0x01, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x11, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x37, 0x11, 0x21, 0x35, 0x21, 0x11, 0x0e, 0x01,
+  0x23, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x32, 0x16, 0x17, 0x01, 0x11,
+  0x06, 0x07, 0x06, 0x11, 0x10, 0x17, 0x16, 0x04, 0xda, 0x72, 0xea, 0x78,
+  0xa8, 0x7a, 0x7a, 0xa8, 0x82, 0x73, 0x5b, 0x4d, 0xfe, 0x7d, 0x01, 0xdd,
+  0x69, 0xfe, 0x90, 0xfe, 0xc5, 0xfe, 0x9d, 0x01, 0x63, 0x01, 0x3b, 0x83,
+  0xed, 0x64, 0xfc, 0xb0, 0x19, 0x17, 0x98, 0x98, 0x17, 0x04, 0xe4, 0x61,
+  0x47, 0x40, 0xfb, 0x3b, 0x40, 0x26, 0x1f, 0x35, 0x01, 0xe7, 0x64, 0xfd,
+  0x7f, 0x53, 0x55, 0x01, 0x99, 0x01, 0x6d, 0x01, 0x6e, 0x01, 0x99, 0x48,
+  0x46, 0xfb, 0x63, 0x04, 0x49, 0x16, 0x1a, 0xaf, 0xfe, 0xba, 0xfe, 0xbb,
+  0xaf, 0x1a, 0x00, 0x00, 0x00, 0x02, 0x00, 0x5b, 0x00, 0x00, 0x02, 0x78,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11,
+  0x25, 0x21, 0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23,
+  0x01, 0x10, 0xb6, 0xfe, 0x96, 0x02, 0x1c, 0x5a, 0x5a, 0xfd, 0xe4, 0x5a,
+  0x5a, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0xf3, 0x64,
+  0x64, 0x05, 0x0d, 0x00, 0x00, 0x02, 0xff, 0xa0, 0xfe, 0x66, 0x02, 0x1d,
+  0x05, 0xd5, 0x00, 0x08, 0x00, 0x14, 0x00, 0x00, 0x01, 0x11, 0x14, 0x07,
+  0x36, 0x37, 0x36, 0x35, 0x11, 0x25, 0x21, 0x11, 0x10, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x36, 0x35, 0x01, 0x0f, 0x4d, 0x81, 0x39, 0x47, 0xfe,
+  0xf2, 0x01, 0x68, 0xb9, 0xcc, 0xf7, 0x38, 0x79, 0x63, 0x05, 0x71, 0xfa,
+  0xb1, 0xf2, 0x64, 0x0a, 0x4a, 0x5e, 0xea, 0x05, 0x09, 0x64, 0xfa, 0x93,
+  0xfe, 0xf2, 0xf4, 0x64, 0x96, 0xc2, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x92, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00,
+  0x13, 0x21, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x21, 0x13,
+  0x11, 0x33, 0x11, 0xb5, 0x01, 0x68, 0x02, 0xb6, 0x8f, 0xfc, 0xf9, 0x03,
+  0x37, 0x8a, 0xfd, 0x15, 0xfe, 0x98, 0x5a, 0xb6, 0x05, 0xd5, 0xfd, 0x89,
+  0x02, 0x77, 0xfd, 0x40, 0xfc, 0xeb, 0x02, 0xcf, 0xfd, 0x31, 0x05, 0x71,
+  0xfa, 0xf3, 0x05, 0x0d, 0x00, 0x02, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xad,
+  0x05, 0xd5, 0x00, 0x05, 0x00, 0x09, 0x00, 0x00, 0x13, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x13, 0x11, 0x33, 0x11, 0xb5, 0x01, 0x6a, 0x02, 0x8e, 0xfc,
+  0x08, 0x5a, 0xb6, 0x05, 0xd5, 0xfa, 0x8f, 0x64, 0x05, 0x6f, 0xfa, 0xf3,
+  0x05, 0x0d, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb0, 0x00, 0x00, 0x06, 0xb1,
+  0x05, 0xd5, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x14, 0x00, 0x00, 0x21, 0x11,
+  0x01, 0x23, 0x01, 0x03, 0x21, 0x11, 0x21, 0x09, 0x01, 0x21, 0x11, 0x01,
+  0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x05, 0x47, 0xfe, 0x89, 0x40,
+  0xfe, 0x8b, 0x01, 0xfe, 0x96, 0x01, 0xa9, 0x01, 0x57, 0x01, 0x59, 0x01,
+  0xa8, 0xfe, 0xf0, 0xb6, 0xfa, 0xb3, 0xb6, 0x05, 0x71, 0xfb, 0xae, 0x04,
+  0x52, 0xfa, 0x8f, 0x05, 0xd5, 0xfc, 0x08, 0x03, 0xf8, 0xfa, 0x2b, 0x05,
+  0x71, 0xfa, 0xf3, 0x05, 0x0d, 0xfa, 0xf3, 0x05, 0x0d, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x66, 0xff, 0xe3, 0x05, 0x45, 0x05, 0xf0, 0x00, 0x0f,
+  0x00, 0x17, 0x00, 0x1f, 0x00, 0x27, 0x00, 0x28, 0x00, 0x00, 0x01, 0x20,
+  0x17, 0x16, 0x11, 0x10, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x11, 0x10,
+  0x37, 0x36, 0x13, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22, 0x07, 0x03, 0x11,
+  0x06, 0x07, 0x06, 0x10, 0x17, 0x16, 0x01, 0x11, 0x36, 0x37, 0x36, 0x10,
+  0x27, 0x26, 0x01, 0x02, 0xd5, 0x01, 0x1b, 0xa9, 0xab, 0xaa, 0xaa, 0xfe,
+  0xe5, 0xfe, 0xe5, 0xa9, 0xaa, 0xaa, 0xa9, 0x40, 0x61, 0xf5, 0x61, 0x61,
+  0xf5, 0x61, 0x5f, 0x20, 0x1d, 0x8b, 0x8b, 0x1d, 0x02, 0x95, 0x1f, 0x1c,
+  0x8b, 0x8b, 0x1c, 0xfc, 0x38, 0x05, 0xf0, 0xd2, 0xd5, 0xfe, 0xa0, 0xfe,
+  0xa1, 0xd4, 0xd3, 0xd3, 0xd2, 0x01, 0x61, 0x01, 0x62, 0xd3, 0xd2, 0xfa,
+  0x8e, 0x32, 0x32, 0x04, 0xd7, 0x32, 0x32, 0xfb, 0x6a, 0x04, 0x54, 0x1d,
+  0x25, 0xb6, 0xfd, 0x9c, 0xb5, 0x25, 0x04, 0x35, 0xfb, 0xaf, 0x1d, 0x24,
+  0xb6, 0x02, 0x63, 0xb6, 0x24, 0xfd, 0xf4, 0x00, 0x00, 0x02, 0x00, 0x7a,
+  0xff, 0xdc, 0x04, 0x29, 0x05, 0xf6, 0x00, 0x11, 0x00, 0x2d, 0x00, 0x00,
+  0x01, 0x06, 0x10, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x10, 0x07, 0x36, 0x10,
+  0x26, 0x2f, 0x01, 0x2e, 0x01, 0x34, 0x25, 0x15, 0x26, 0x20, 0x06, 0x14,
+  0x16, 0x1f, 0x01, 0x1e, 0x01, 0x10, 0x04, 0x20, 0x27, 0x35, 0x16, 0x20,
+  0x36, 0x34, 0x26, 0x2f, 0x01, 0x2e, 0x01, 0x10, 0x36, 0x20, 0x01, 0x2e,
+  0x5a, 0x7b, 0x9b, 0x64, 0x98, 0x97, 0x22, 0x74, 0x8d, 0x99, 0x63, 0x9e,
+  0x8e, 0x02, 0xc0, 0xb9, 0xfe, 0xe5, 0x92, 0x62, 0x85, 0x63, 0xb6, 0xb5,
+  0xfe, 0xfd, 0xfe, 0x44, 0xeb, 0xc9, 0x01, 0x43, 0x98, 0x6e, 0x7c, 0x64,
+  0xb6, 0xa5, 0xfb, 0x01, 0x98, 0x05, 0x2d, 0x5b, 0xfe, 0xca, 0x9a, 0x29,
+  0x1a, 0x27, 0xb9, 0xfe, 0xff, 0x4e, 0x58, 0x01, 0x64, 0xbb, 0x27, 0x1b,
+  0x27, 0x9d, 0xe3, 0xb4, 0x70, 0x75, 0x89, 0xe9, 0x69, 0x24, 0x1b, 0x32,
+  0xeb, 0xfe, 0x58, 0xee, 0x66, 0x7c, 0x95, 0x92, 0xfd, 0x86, 0x20, 0x1a,
+  0x2f, 0xcf, 0x01, 0x8c, 0xf4, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xfa,
+  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0b, 0x00, 0x00,
+  0x01, 0x11, 0x33, 0x11, 0x25, 0x21, 0x15, 0x21, 0x11, 0x21, 0x11, 0x21,
+  0x02, 0x33, 0xb4, 0xfd, 0x14, 0x05, 0x23, 0xfe, 0x23, 0xfe, 0x98, 0xfe,
+  0x22, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0x8f, 0x05,
+  0x71, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x9f, 0xff, 0xe3, 0x05, 0x5b,
+  0x05, 0xd5, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x11,
+  0x10, 0x07, 0x24, 0x19, 0x01, 0x21, 0x11, 0x10, 0x05, 0x26, 0x13, 0x11,
+  0x25, 0x21, 0x11, 0x14, 0x16, 0x20, 0x36, 0x35, 0x11, 0x21, 0x11, 0x10,
+  0x00, 0x20, 0x00, 0x11, 0x04, 0x4c, 0x4f, 0x01, 0x04, 0xfb, 0xf8, 0x01,
+  0x04, 0x50, 0x01, 0xfe, 0xf1, 0x01, 0x69, 0x73, 0x01, 0x04, 0x73, 0x01,
+  0x69, 0xfe, 0xce, 0xfd, 0xa8, 0xfe, 0xce, 0x05, 0x71, 0xfc, 0x99, 0xfe,
+  0xe6, 0x82, 0x62, 0x01, 0x61, 0x03, 0x40, 0xfc, 0xc0, 0xfe, 0x9e, 0x60,
+  0x7c, 0x01, 0x1f, 0x03, 0x67, 0x64, 0xfc, 0x35, 0xf0, 0xd3, 0xd3, 0xf0,
+  0x03, 0xcb, 0xfc, 0x5c, 0xfe, 0xdc, 0xfe, 0xd6, 0x01, 0x2a, 0x01, 0x24,
+  0x00, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x05, 0x25, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x0a, 0x00, 0x00, 0x13, 0x01, 0x33, 0x01, 0x25, 0x21, 0x09, 0x01,
+  0x33, 0x01, 0x21, 0x8b, 0x01, 0xbc, 0xb4, 0xfe, 0x44, 0xfe, 0xcf, 0x01,
+  0x68, 0x01, 0xaa, 0x01, 0xab, 0x5a, 0xfe, 0x00, 0xfe, 0xea, 0x05, 0x71,
+  0xfa, 0xf3, 0x05, 0x0d, 0x64, 0xfb, 0x17, 0x04, 0xe9, 0xfa, 0x2b, 0x00,
+  0x00, 0x03, 0x00, 0x3d, 0x00, 0x00, 0x07, 0xd0, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x14, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x21, 0x01,
+  0x33, 0x01, 0x25, 0x21, 0x09, 0x01, 0x21, 0x09, 0x01, 0x33, 0x01, 0x21,
+  0x09, 0x01, 0x21, 0x04, 0x4a, 0x01, 0x24, 0xb4, 0xfe, 0xdc, 0xfb, 0xb0,
+  0x01, 0x23, 0xb4, 0xfe, 0xdd, 0xfe, 0xdb, 0x01, 0x68, 0x01, 0x1b, 0x01,
+  0x1a, 0x01, 0x68, 0x01, 0x1a, 0x01, 0x1a, 0x5a, 0xfe, 0xae, 0xfe, 0xa3,
+  0xfe, 0xe5, 0xfe, 0xe1, 0xfe, 0xa7, 0x05, 0x71, 0xfa, 0xf3, 0x05, 0x0d,
+  0xfa, 0xf3, 0x05, 0x0d, 0x64, 0xfb, 0x12, 0x04, 0xee, 0xfb, 0x12, 0x04,
+  0xee, 0xfa, 0x2b, 0x05, 0x10, 0xfa, 0xf0, 0x00, 0x00, 0x02, 0x00, 0x61,
+  0x00, 0x00, 0x05, 0x6c, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00,
+  0x09, 0x01, 0x33, 0x01, 0x25, 0x21, 0x09, 0x01, 0x33, 0x09, 0x01, 0x21,
+  0x09, 0x01, 0x23, 0x01, 0x01, 0x0a, 0x03, 0x06, 0xb3, 0xfc, 0xfa, 0xfe,
+  0xa4, 0x01, 0x8c, 0x01, 0x51, 0x01, 0x5d, 0x58, 0xfe, 0x78, 0x02, 0x01,
+  0xfe, 0x74, 0xfe, 0xaf, 0xfe, 0xa3, 0x5a, 0x01, 0x8a, 0x05, 0x71, 0xfa,
+  0xf3, 0x05, 0x0d, 0x64, 0xfd, 0xce, 0x02, 0x32, 0xfd, 0x84, 0xfc, 0xa7,
+  0x02, 0x32, 0xfd, 0xce, 0x02, 0x7b, 0x00, 0x00, 0x00, 0x02, 0xff, 0xfc,
+  0x00, 0x00, 0x05, 0x1b, 0x05, 0xd5, 0x00, 0x08, 0x00, 0x0e, 0x00, 0x00,
+  0x09, 0x01, 0x33, 0x01, 0x11, 0x21, 0x11, 0x01, 0x21, 0x09, 0x01, 0x23,
+  0x01, 0x11, 0x33, 0x03, 0x16, 0x01, 0xab, 0x5a, 0xfe, 0x25, 0xfe, 0x98,
+  0xfe, 0x24, 0x01, 0x6c, 0x01, 0x7f, 0xfe, 0x61, 0xb4, 0x01, 0x9e, 0xb5,
+  0x03, 0x13, 0x02, 0xc2, 0xfc, 0xf2, 0xfd, 0x39, 0x02, 0xc7, 0x03, 0x0e,
+  0xfc, 0xf2, 0x02, 0xaa, 0xfd, 0x56, 0xfd, 0x9d, 0x00, 0x04, 0x00, 0x6e,
+  0xff, 0xe3, 0x04, 0x1e, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x22, 0x00, 0x2c,
+  0x00, 0x33, 0x00, 0x00, 0x01, 0x34, 0x26, 0x27, 0x16, 0x15, 0x11, 0x33,
+  0x13, 0x11, 0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36,
+  0x3b, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01,
+  0x33, 0x20, 0x16, 0x01, 0x35, 0x23, 0x22, 0x07, 0x11, 0x3e, 0x01, 0x37,
+  0x36, 0x05, 0x11, 0x0e, 0x01, 0x15, 0x14, 0x16, 0x03, 0xc4, 0x87, 0x37,
+  0x44, 0x7a, 0x5a, 0xfe, 0xd2, 0x39, 0xa9, 0x4e, 0x9b, 0xb6, 0xe3, 0xe2,
+  0xbc, 0x6a, 0x88, 0x56, 0xa4, 0x4c, 0x6c, 0xc8, 0x33, 0x01, 0x01, 0xfe,
+  0xfe, 0xd2, 0xbc, 0x30, 0x2b, 0x55, 0x58, 0x35, 0x35, 0xfe, 0x8f, 0x3c,
+  0x7a, 0x6d, 0x02, 0x7f, 0xd3, 0x86, 0x18, 0x5d, 0x88, 0xfd, 0x59, 0x02,
+  0x1b, 0xfd, 0x81, 0xaa, 0x66, 0x61, 0xc1, 0xa2, 0xbd, 0xc0, 0x48, 0x7f,
+  0x8b, 0x2e, 0x2e, 0x74, 0x27, 0x27, 0xfc, 0xfe, 0x8b, 0x55, 0x04, 0xfd,
+  0xed, 0x04, 0x4e, 0x48, 0x47, 0xdc, 0x01, 0xfd, 0x12, 0x67, 0x8b, 0x77,
+  0x74, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x85, 0xff, 0xe3, 0x04, 0x92,
+  0x06, 0x14, 0x00, 0x0f, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00,
+  0x13, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22,
+  0x26, 0x27, 0x15, 0x21, 0x01, 0x34, 0x27, 0x26, 0x27, 0x11, 0x36, 0x37,
+  0x36, 0x37, 0x36, 0x01, 0x11, 0x33, 0x11, 0x01, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x85, 0x01,
+  0x2d, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0xfe,
+  0xd3, 0x03, 0xaa, 0x55, 0x27, 0x36, 0x36, 0x27, 0x34, 0x14, 0x0d, 0xfc,
+  0xb0, 0x79, 0x01, 0xc6, 0x16, 0x18, 0x94, 0x44, 0x45, 0x14, 0x0c, 0x55,
+  0x54, 0x94, 0x18, 0x16, 0x06, 0x14, 0xfd, 0xa2, 0x64, 0x61, 0xfe, 0xbc,
+  0xfd, 0xf0, 0xfe, 0xbc, 0x61, 0x64, 0xa8, 0x02, 0x74, 0x9f, 0x82, 0x3d,
+  0x20, 0xfc, 0x7a, 0x20, 0x3d, 0x4f, 0x73, 0x4b, 0x03, 0xda, 0xfa, 0xac,
+  0x05, 0x54, 0xfe, 0x64, 0x03, 0x69, 0x68, 0x74, 0x4a, 0x9e, 0x9f, 0x82,
+  0x82, 0x03, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84,
+  0x04, 0x7b, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x25, 0x15, 0x0e, 0x01,
+  0x23, 0x22, 0x00, 0x11, 0x10, 0x00, 0x33, 0x32, 0x16, 0x17, 0x15, 0x26,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x11, 0x16, 0x33, 0x32, 0x37, 0x36, 0x25,
+  0x11, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x03, 0x83, 0x45, 0x95,
+  0x53, 0xe4, 0xfe, 0xf4, 0x01, 0x0f, 0xeb, 0x4d, 0x92, 0x44, 0x3e, 0x62,
+  0x40, 0x43, 0x4f, 0x41, 0x3d, 0x49, 0x49, 0x41, 0x4e, 0xfe, 0x48, 0x27,
+  0x21, 0x6e, 0x6e, 0x20, 0x8f, 0x64, 0x24, 0x24, 0x01, 0x3e, 0x01, 0x0e,
+  0x01, 0x12, 0x01, 0x3a, 0x23, 0x23, 0x64, 0x1f, 0x18, 0x0f, 0x14, 0xfc,
+  0x57, 0x13, 0x10, 0x13, 0x1b, 0x03, 0x53, 0x1a, 0x25, 0x80, 0xea, 0xe6,
+  0x83, 0x26, 0x00, 0x00, 0x00, 0x04, 0x00, 0x85, 0xff, 0xe3, 0x04, 0x92,
+  0x06, 0x14, 0x00, 0x0f, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00,
+  0x01, 0x11, 0x21, 0x11, 0x21, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x02, 0x10,
+  0x12, 0x33, 0x32, 0x16, 0x01, 0x14, 0x17, 0x16, 0x17, 0x16, 0x17, 0x11,
+  0x06, 0x07, 0x06, 0x01, 0x11, 0x33, 0x11, 0x01, 0x11, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x03, 0x64,
+  0x01, 0x2d, 0xfe, 0xd3, 0x34, 0x9f, 0x70, 0xb6, 0xe6, 0xe6, 0xb6, 0x70,
+  0x9f, 0xfd, 0xb7, 0x0e, 0x14, 0x33, 0x28, 0x36, 0x36, 0x28, 0x55, 0x02,
+  0xd7, 0x79, 0xfd, 0xc1, 0x16, 0x18, 0x94, 0x54, 0x56, 0x0d, 0x14, 0x45,
+  0x44, 0x94, 0x18, 0x03, 0xb6, 0x02, 0x5e, 0xf9, 0xec, 0xa8, 0x64, 0x61,
+  0x01, 0x44, 0x02, 0x10, 0x01, 0x44, 0x61, 0xfe, 0x5a, 0x9e, 0x4b, 0x73,
+  0x4f, 0x3d, 0x20, 0x03, 0x86, 0x20, 0x3d, 0x82, 0x02, 0x9d, 0xfa, 0xac,
+  0x05, 0x54, 0xfe, 0x64, 0xfc, 0x36, 0x03, 0x82, 0x82, 0x9f, 0x9e, 0x4a,
+  0x74, 0x68, 0x69, 0x00, 0x00, 0x03, 0x00, 0x63, 0xff, 0xe3, 0x04, 0x0b,
+  0x04, 0x7b, 0x00, 0x13, 0x00, 0x18, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x21,
+  0x13, 0x16, 0x33, 0x32, 0x37, 0x15, 0x0e, 0x01, 0x23, 0x22, 0x00, 0x11,
+  0x10, 0x00, 0x33, 0x32, 0x12, 0x15, 0x01, 0x06, 0x11, 0x12, 0x17, 0x13,
+  0x21, 0x2e, 0x01, 0x23, 0x22, 0x07, 0x04, 0x0a, 0xfd, 0xca, 0x01, 0x43,
+  0x56, 0xc3, 0xb0, 0x62, 0xb0, 0x60, 0xf1, 0xfe, 0xe6, 0x01, 0x0b, 0xe3,
+  0xce, 0xea, 0xfd, 0x6c, 0xb2, 0x01, 0xb1, 0x5f, 0x01, 0xce, 0x03, 0xb8,
+  0x98, 0x42, 0x3a, 0x02, 0x04, 0xfe, 0x62, 0x15, 0x5d, 0x75, 0x2d, 0x29,
+  0x01, 0x38, 0x01, 0x0a, 0x01, 0x13, 0x01, 0x43, 0xfe, 0xda, 0xf7, 0x01,
+  0x71, 0x7a, 0xfe, 0xdb, 0xfe, 0xf3, 0x8e, 0x01, 0xd3, 0xbe, 0xe7, 0x11,
+  0x00, 0x02, 0x00, 0x2a, 0x00, 0x00, 0x03, 0x80, 0x06, 0x14, 0x00, 0x0a,
+  0x00, 0x20, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x15, 0x11, 0x33, 0x11,
+  0x34, 0x37, 0x36, 0x25, 0x15, 0x23, 0x22, 0x07, 0x06, 0x1d, 0x01, 0x21,
+  0x15, 0x21, 0x11, 0x21, 0x11, 0x23, 0x35, 0x33, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x01, 0xdc, 0x5d, 0x29, 0x33, 0x79, 0x14, 0x10, 0x01, 0xc0, 0x9d,
+  0x85, 0x34, 0x34, 0x01, 0x5d, 0xfe, 0xa3, 0xfe, 0xd3, 0x9f, 0x9f, 0x4e,
+  0x4f, 0xa9, 0x05, 0xae, 0x0a, 0x2d, 0x38, 0x91, 0xfb, 0xb6, 0x04, 0x4a,
+  0x5f, 0x44, 0x38, 0x8b, 0x64, 0x39, 0x37, 0x92, 0x64, 0x64, 0xfc, 0x1a,
+  0x03, 0xe6, 0x64, 0x64, 0xbc, 0x54, 0x56, 0x00, 0x00, 0x04, 0x00, 0x65,
+  0xfe, 0x56, 0x04, 0x72, 0x04, 0x7b, 0x00, 0x07, 0x00, 0x23, 0x00, 0x2e,
+  0x00, 0x3d, 0x00, 0x00, 0x01, 0x11, 0x14, 0x07, 0x16, 0x36, 0x19, 0x01,
+  0x01, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x3d, 0x01, 0x0e, 0x01, 0x23,
+  0x22, 0x02, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x21, 0x11, 0x10,
+  0x00, 0x21, 0x22, 0x26, 0x03, 0x14, 0x17, 0x16, 0x17, 0x11, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x03, 0x9f, 0x5f, 0x04, 0xd4, 0xfc,
+  0xc7, 0x49, 0x8e, 0x4a, 0xa3, 0xa2, 0x34, 0x9f, 0x70, 0xb7, 0xe5, 0xe5,
+  0xb7, 0x70, 0x9f, 0x34, 0x01, 0x2d, 0xfe, 0xf3, 0xfe, 0xec, 0x67, 0xb5,
+  0x6d, 0x54, 0x28, 0x36, 0x36, 0x28, 0x33, 0x14, 0x0d, 0x01, 0x10, 0x17,
+  0x17, 0x95, 0x43, 0x46, 0x14, 0x0c, 0x55, 0x54, 0x95, 0x17, 0x17, 0x03,
+  0xfa, 0xfc, 0x3d, 0xca, 0x8c, 0x05, 0x9d, 0x01, 0x12, 0x03, 0x6f, 0xfa,
+  0x97, 0x80, 0x2c, 0x2a, 0xbd, 0xbf, 0x71, 0x64, 0x61, 0x01, 0x44, 0x02,
+  0x10, 0x01, 0x44, 0x61, 0x64, 0xa8, 0xfc, 0x2d, 0xfe, 0xe2, 0xfe, 0xe9,
+  0x1d, 0x03, 0x77, 0x9f, 0x82, 0x3d, 0x20, 0x03, 0x86, 0x20, 0x3d, 0x4f,
+  0x73, 0x4b, 0xfd, 0xc2, 0x03, 0x69, 0x68, 0x74, 0x4a, 0x9e, 0x9f, 0x82,
+  0x82, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc1,
+  0x06, 0x14, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x22, 0x00, 0x00, 0x01, 0x16,
+  0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x34, 0x27, 0x26, 0x01, 0x11, 0x33,
+  0x11, 0x27, 0x21, 0x11, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x21,
+  0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x03, 0x9a, 0x08,
+  0x07, 0x40, 0x7e, 0x4b, 0x30, 0xfd, 0x15, 0x7a, 0xd4, 0x01, 0x2e, 0x42,
+  0xb2, 0x74, 0xbf, 0xc5, 0xfe, 0xce, 0x61, 0x60, 0x73, 0x86, 0xfe, 0xd2,
+  0x04, 0x0d, 0x0b, 0x0c, 0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b,
+  0x3a, 0x01, 0xb6, 0xfa, 0xb4, 0x05, 0x4c, 0x64, 0xfd, 0x9e, 0x65, 0x64,
+  0xef, 0xe8, 0xfd, 0x5c, 0x02, 0xd0, 0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x55,
+  0x00, 0x03, 0x00, 0xcf, 0x00, 0x00, 0x01, 0xfd, 0x06, 0x14, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x03, 0x33,
+  0x15, 0x23, 0x07, 0x21, 0x11, 0x21, 0x01, 0x29, 0x79, 0x90, 0xa7, 0xa7,
+  0x43, 0x01, 0x2d, 0xfe, 0xd3, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x02,
+  0x18, 0xe9, 0xcb, 0xfb, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xdb,
+  0xfe, 0x56, 0x01, 0xd8, 0x06, 0x14, 0x00, 0x08, 0x00, 0x16, 0x00, 0x1a,
+  0x00, 0x00, 0x05, 0x11, 0x23, 0x11, 0x14, 0x07, 0x36, 0x37, 0x36, 0x07,
+  0x23, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x21, 0x11, 0x14, 0x07,
+  0x06, 0x03, 0x33, 0x15, 0x23, 0x01, 0x7e, 0x7a, 0x21, 0x40, 0x24, 0x37,
+  0xdc, 0xc7, 0x2c, 0x61, 0x21, 0x21, 0x01, 0x2e, 0x49, 0x4a, 0x57, 0xa5,
+  0xa5, 0x16, 0x04, 0x12, 0xfb, 0xd0, 0xb5, 0x54, 0x0f, 0x30, 0x48, 0xf4,
+  0x64, 0x30, 0x31, 0x99, 0x04, 0xac, 0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x07,
+  0xbe, 0xe9, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xad,
+  0x06, 0x14, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x00, 0x13, 0x21, 0x11, 0x01,
+  0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x21, 0x13, 0x11, 0x33, 0x11, 0xa7,
+  0x01, 0x2e, 0x02, 0x43, 0x7e, 0xfd, 0x8e, 0x02, 0x89, 0x87, 0xfd, 0xaf,
+  0xfe, 0xd2, 0x5a, 0x7a, 0x06, 0x14, 0xfc, 0x69, 0x01, 0xe3, 0xfd, 0xf6,
+  0xfd, 0xaa, 0x02, 0x23, 0xfd, 0xdd, 0x05, 0xb0, 0xfa, 0xb4, 0x05, 0x4c,
+  0x00, 0x02, 0x00, 0xcf, 0x00, 0x00, 0x02, 0xa0, 0x06, 0x14, 0x00, 0x08,
+  0x00, 0x14, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16, 0x17, 0x26, 0x35, 0x11,
+  0x23, 0x13, 0x22, 0x27, 0x26, 0x35, 0x11, 0x21, 0x11, 0x14, 0x16, 0x33,
+  0x15, 0x01, 0x29, 0x37, 0x24, 0x40, 0x22, 0x79, 0xdd, 0xa4, 0x4a, 0x49,
+  0x01, 0x2d, 0x45, 0x5e, 0x01, 0x94, 0xa0, 0x48, 0x30, 0x0f, 0x54, 0xb5,
+  0x04, 0x30, 0xfa, 0x5a, 0x60, 0x60, 0xd6, 0x04, 0x7e, 0xfb, 0x4a, 0x9c,
+  0x5e, 0x64, 0x00, 0x00, 0x00, 0x04, 0x00, 0xa7, 0x00, 0x00, 0x07, 0xad,
+  0x04, 0x7b, 0x00, 0x22, 0x00, 0x26, 0x00, 0x31, 0x00, 0x3c, 0x00, 0x00,
+  0x13, 0x21, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x15, 0x11, 0x21, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x21, 0x11, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x13,
+  0x11, 0x33, 0x11, 0x25, 0x16, 0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x34,
+  0x27, 0x26, 0x25, 0x16, 0x17, 0x16, 0x15, 0x11, 0x33, 0x11, 0x34, 0x27,
+  0x26, 0xa7, 0x01, 0x2e, 0x42, 0xb2, 0x74, 0xbf, 0x8d, 0x18, 0x4c, 0xc8,
+  0x74, 0xbf, 0xc5, 0xfe, 0xce, 0x61, 0x60, 0x73, 0x86, 0xfe, 0xce, 0x61,
+  0x60, 0x73, 0x86, 0xfe, 0xd2, 0x5a, 0x7a, 0x02, 0x1f, 0x08, 0x07, 0x40,
+  0x7e, 0x4b, 0x30, 0x02, 0x9a, 0x08, 0x07, 0x40, 0x7e, 0x4b, 0x30, 0x04,
+  0x60, 0xae, 0x65, 0x64, 0xac, 0x4a, 0x80, 0x76, 0xef, 0xe8, 0xfd, 0x5c,
+  0x02, 0xd0, 0x9f, 0x9e, 0xbe, 0xab, 0xfd, 0x5c, 0x02, 0xd0, 0x9f, 0x9e,
+  0xbe, 0xa4, 0xfd, 0x55, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x11, 0x0b,
+  0x0c, 0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b, 0x3a, 0x13, 0x0b,
+  0x0c, 0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b, 0x3a, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc1, 0x04, 0x7b, 0x00, 0x0a,
+  0x00, 0x0e, 0x00, 0x22, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x15, 0x11,
+  0x33, 0x11, 0x34, 0x27, 0x26, 0x25, 0x11, 0x33, 0x11, 0x27, 0x21, 0x15,
+  0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x11, 0x21, 0x11, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x15, 0x11, 0x21, 0x03, 0x9a, 0x08, 0x07, 0x40, 0x7e, 0x4b,
+  0x30, 0xfd, 0x15, 0x7a, 0xd4, 0x01, 0x2e, 0x42, 0xb2, 0x74, 0xbf, 0xc5,
+  0xfe, 0xce, 0x61, 0x60, 0x73, 0x86, 0xfe, 0xd2, 0x04, 0x0d, 0x0b, 0x0c,
+  0x68, 0xbe, 0xfd, 0x94, 0x02, 0x40, 0xc1, 0x5b, 0x3a, 0x02, 0xfc, 0x68,
+  0x03, 0x98, 0x64, 0xae, 0x65, 0x64, 0xef, 0xe8, 0xfd, 0x5c, 0x02, 0xd0,
+  0x9f, 0x9e, 0xbe, 0xa4, 0xfd, 0x55, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x00, 0x0b, 0x00, 0x13, 0x00, 0x1b,
+  0x00, 0x23, 0x00, 0x00, 0x01, 0x32, 0x12, 0x11, 0x10, 0x02, 0x23, 0x22,
+  0x02, 0x11, 0x10, 0x12, 0x13, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22, 0x07,
+  0x03, 0x11, 0x06, 0x07, 0x06, 0x10, 0x17, 0x16, 0x01, 0x11, 0x36, 0x37,
+  0x36, 0x10, 0x27, 0x26, 0x02, 0x34, 0xd8, 0xf7, 0xf7, 0xd8, 0xd9, 0xf5,
+  0xf5, 0x75, 0x2e, 0x6c, 0x2e, 0x2e, 0x6c, 0x2e, 0x5a, 0x2e, 0x24, 0x64,
+  0x64, 0x24, 0x01, 0xaa, 0x2e, 0x24, 0x65, 0x65, 0x24, 0x04, 0x7b, 0xfe,
+  0xc8, 0xfe, 0xec, 0xfe, 0xed, 0xfe, 0xc7, 0x01, 0x39, 0x01, 0x13, 0x01,
+  0x14, 0x01, 0x38, 0xfb, 0xd7, 0x0b, 0x0b, 0x03, 0xba, 0x0b, 0x0b, 0xfc,
+  0x6b, 0x03, 0x70, 0x1d, 0x2d, 0x80, 0xfe, 0x24, 0x80, 0x2d, 0x03, 0x52,
+  0xfc, 0x92, 0x1c, 0x2d, 0x81, 0x01, 0xdb, 0x80, 0x2d, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x72, 0x04, 0x7b, 0x00, 0x0f,
+  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11,
+  0x21, 0x15, 0x3e, 0x01, 0x33, 0x32, 0x12, 0x10, 0x02, 0x23, 0x22, 0x26,
+  0x01, 0x34, 0x27, 0x26, 0x27, 0x26, 0x27, 0x11, 0x36, 0x37, 0x36, 0x01,
+  0x11, 0x23, 0x11, 0x01, 0x11, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14,
+  0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x01, 0x92, 0xfe, 0xd4, 0x01, 0x2c,
+  0x34, 0xa0, 0x6f, 0xb7, 0xe6, 0xe6, 0xb7, 0x6f, 0xa0, 0x02, 0x4a, 0x0e,
+  0x14, 0x33, 0x28, 0x36, 0x36, 0x28, 0x55, 0xfd, 0x28, 0x78, 0x02, 0x3f,
+  0x17, 0x17, 0x95, 0x53, 0x56, 0x0d, 0x14, 0x45, 0x43, 0x95, 0x17, 0xa8,
+  0xfd, 0xae, 0x06, 0x08, 0xa8, 0x64, 0x61, 0xfe, 0xbc, 0xfd, 0xf0, 0xfe,
+  0xbc, 0x61, 0x01, 0xa6, 0x9e, 0x4b, 0x73, 0x4f, 0x3d, 0x20, 0xfc, 0x7a,
+  0x20, 0x3d, 0x82, 0xfd, 0x6f, 0x05, 0x48, 0xfa, 0xb8, 0x01, 0x90, 0x03,
+  0xca, 0x03, 0x82, 0x82, 0x9f, 0x9e, 0x4a, 0x74, 0x68, 0x69, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x65, 0xfe, 0x56, 0x04, 0x72, 0x04, 0x7b, 0x00, 0x0f,
+  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x2d, 0x00, 0x00, 0x25, 0x0e, 0x01, 0x23,
+  0x22, 0x02, 0x10, 0x12, 0x33, 0x32, 0x16, 0x17, 0x35, 0x21, 0x11, 0x21,
+  0x01, 0x14, 0x17, 0x16, 0x17, 0x11, 0x06, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x33, 0x11, 0x23, 0x01, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x03, 0x45, 0x34, 0x9f, 0x70, 0xb7,
+  0xe5, 0xe5, 0xb7, 0x70, 0x9f, 0x34, 0x01, 0x2d, 0xfe, 0xd3, 0xfd, 0x83,
+  0x54, 0x28, 0x36, 0x36, 0x28, 0x33, 0x14, 0x0d, 0x02, 0xd7, 0x79, 0x79,
+  0xfe, 0x39, 0x17, 0x17, 0x95, 0x43, 0x46, 0x14, 0x0c, 0x55, 0x54, 0x95,
+  0x17, 0x17, 0xa8, 0x64, 0x61, 0x01, 0x44, 0x02, 0x10, 0x01, 0x44, 0x61,
+  0x64, 0xa8, 0xf9, 0xf8, 0x03, 0x94, 0x9f, 0x82, 0x3d, 0x20, 0x03, 0x86,
+  0x20, 0x3d, 0x4f, 0x73, 0x4b, 0xfc, 0x32, 0x05, 0x48, 0xfc, 0x48, 0x03,
+  0x69, 0x68, 0x74, 0x4a, 0x9e, 0x9f, 0x82, 0x82, 0x03, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x03, 0x7c, 0x04, 0x7b, 0x00, 0x03,
+  0x00, 0x15, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x27, 0x21, 0x15, 0x3e,
+  0x01, 0x33, 0x32, 0x1f, 0x01, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15,
+  0x11, 0x21, 0x01, 0x01, 0x79, 0xd3, 0x01, 0x2d, 0x34, 0xa8, 0x77, 0x19,
+  0x0d, 0x2f, 0x1c, 0x42, 0x27, 0x8d, 0x96, 0xfe, 0xd3, 0x03, 0xfc, 0xfc,
+  0x68, 0x03, 0x98, 0x64, 0xae, 0x66, 0x63, 0x03, 0x07, 0x85, 0x12, 0x11,
+  0xcb, 0xbe, 0xfd, 0x7a, 0x00, 0x02, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
+  0x04, 0x7b, 0x00, 0x1d, 0x00, 0x45, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x1f, 0x01, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2f, 0x01, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x03, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2f,
+  0x01, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x01, 0x45, 0x23, 0x19, 0x44, 0x22,
+  0x23, 0x66, 0x2f, 0x94, 0x37, 0x3c, 0x22, 0x22, 0x1a, 0x4c, 0x26, 0x2a,
+  0x77, 0x2d, 0x82, 0x33, 0x40, 0xbe, 0x4b, 0x90, 0x47, 0x5f, 0x66, 0x45,
+  0x82, 0x2f, 0x81, 0x6a, 0xca, 0xb9, 0x5c, 0xa2, 0x44, 0x42, 0x53, 0x56,
+  0x63, 0x65, 0x48, 0x6c, 0x2e, 0x91, 0x76, 0xde, 0xc2, 0x51, 0xb0, 0x61,
+  0x03, 0xf9, 0x0f, 0x17, 0x3d, 0x76, 0x66, 0x30, 0x33, 0x22, 0x10, 0x33,
+  0x3b, 0x40, 0x7b, 0x52, 0x3f, 0x10, 0x17, 0x42, 0x73, 0x6c, 0x33, 0x37,
+  0x27, 0x0f, 0x2a, 0x37, 0x43, 0x6f, 0x54, 0xfc, 0xfe, 0x37, 0x38, 0x5e,
+  0x55, 0x4e, 0x4f, 0x2c, 0x10, 0x2c, 0x97, 0x88, 0xa6, 0xb5, 0x20, 0x1f,
+  0x7a, 0x31, 0x24, 0x59, 0x58, 0x44, 0x4c, 0x23, 0x0f, 0x2f, 0x9e, 0x90,
+  0xa4, 0xc0, 0x25, 0x25, 0x00, 0x02, 0x00, 0x31, 0x00, 0x00, 0x03, 0x2e,
+  0x05, 0x9e, 0x00, 0x07, 0x00, 0x1b, 0x00, 0x00, 0x25, 0x26, 0x37, 0x11,
+  0x23, 0x11, 0x06, 0x16, 0x13, 0x11, 0x21, 0x15, 0x21, 0x11, 0x14, 0x16,
+  0x3b, 0x01, 0x15, 0x21, 0x22, 0x26, 0x35, 0x11, 0x23, 0x35, 0x33, 0x11,
+  0x01, 0xa2, 0x26, 0x02, 0x79, 0x01, 0x53, 0x81, 0x01, 0x56, 0xfe, 0xaa,
+  0x44, 0x68, 0xaa, 0xfe, 0xce, 0xbf, 0x92, 0x79, 0x79, 0x6a, 0x55, 0x7c,
+  0x03, 0xff, 0xfc, 0x37, 0xad, 0x4e, 0x05, 0x28, 0xfe, 0xac, 0x64, 0xfd,
+  0x55, 0x89, 0x4e, 0x64, 0x9f, 0xd2, 0x02, 0x75, 0x64, 0x01, 0x54, 0x00,
+  0x00, 0x03, 0x00, 0x9f, 0xff, 0xe5, 0x04, 0xbe, 0x04, 0x60, 0x00, 0x0a,
+  0x00, 0x0e, 0x00, 0x22, 0x00, 0x00, 0x25, 0x26, 0x27, 0x26, 0x35, 0x11,
+  0x23, 0x11, 0x14, 0x17, 0x16, 0x05, 0x11, 0x23, 0x11, 0x17, 0x21, 0x35,
+  0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x11, 0x21, 0x11, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x11, 0x21, 0x01, 0xc6, 0x08, 0x07, 0x40, 0x7e, 0x4b,
+  0x30, 0x02, 0xef, 0x79, 0xd3, 0xfe, 0xce, 0x41, 0xb3, 0x74, 0xbf, 0xc5,
+  0x01, 0x32, 0x61, 0x60, 0x73, 0x86, 0x01, 0x32, 0x53, 0x0b, 0x0c, 0x68,
+  0xbe, 0x02, 0x6c, 0xfd, 0xc0, 0xc1, 0x5b, 0x3a, 0x02, 0x03, 0x98, 0xfc,
+  0x68, 0x64, 0xae, 0x65, 0x64, 0xef, 0xe8, 0x02, 0xa4, 0xfd, 0x30, 0x9f,
+  0x9e, 0xbe, 0xa4, 0x02, 0xab, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36,
+  0x00, 0x00, 0x04, 0x39, 0x04, 0x60, 0x00, 0x03, 0x00, 0x0a, 0x00, 0x00,
+  0x13, 0x01, 0x33, 0x01, 0x27, 0x21, 0x09, 0x01, 0x33, 0x01, 0x21, 0xb8,
+  0x01, 0x37, 0x76, 0xfe, 0xc6, 0xf4, 0x01, 0x32, 0x01, 0x3b, 0x01, 0x3b,
+  0x5a, 0xfe, 0x86, 0xfe, 0xf2, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x64,
+  0xfc, 0x54, 0x03, 0xac, 0xfb, 0xa0, 0x00, 0x00, 0x00, 0x03, 0x00, 0x4d,
+  0x00, 0x00, 0x06, 0x41, 0x04, 0x60, 0x00, 0x03, 0x00, 0x07, 0x00, 0x14,
+  0x00, 0x00, 0x01, 0x13, 0x33, 0x03, 0x21, 0x13, 0x33, 0x03, 0x27, 0x21,
+  0x1b, 0x01, 0x21, 0x1b, 0x01, 0x33, 0x01, 0x21, 0x0b, 0x01, 0x21, 0x03,
+  0x8c, 0xd8, 0x7a, 0xda, 0xfc, 0xbe, 0xd8, 0x7a, 0xda, 0xed, 0x01, 0x32,
+  0xcf, 0xce, 0x01, 0x2d, 0xcf, 0xce, 0x5a, 0xfe, 0xf8, 0xfe, 0xea, 0xd9,
+  0xda, 0xfe, 0xe6, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0xfc, 0x68, 0x03,
+  0x98, 0x64, 0xfc, 0x96, 0x03, 0x6a, 0xfc, 0x96, 0x03, 0x6a, 0xfb, 0xa0,
+  0x03, 0x96, 0xfc, 0x6a, 0x00, 0x02, 0x00, 0x44, 0x00, 0x00, 0x04, 0x9a,
+  0x04, 0x60, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x13, 0x01, 0x33, 0x01,
+  0x25, 0x21, 0x09, 0x01, 0x33, 0x09, 0x01, 0x21, 0x09, 0x01, 0x23, 0x01,
+  0xf8, 0x02, 0x66, 0x88, 0xfd, 0x99, 0xfe, 0xc5, 0x01, 0x68, 0x01, 0x01,
+  0x01, 0x00, 0x70, 0xfe, 0xc8, 0x01, 0xb4, 0xfe, 0x98, 0xff, 0x00, 0xfe,
+  0xff, 0x6f, 0x01, 0x38, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x64, 0xfe,
+  0x81, 0x01, 0x7f, 0xfe, 0x2d, 0xfd, 0x73, 0x01, 0x7f, 0xfe, 0x81, 0x01,
+  0xd3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x4a,
+  0x04, 0x60, 0x00, 0x03, 0x00, 0x12, 0x00, 0x00, 0x13, 0x01, 0x37, 0x01,
+  0x27, 0x21, 0x09, 0x01, 0x33, 0x01, 0x0e, 0x01, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x36, 0x37, 0xbd, 0x01, 0x87, 0x37, 0xfe, 0xba, 0xfe, 0x01, 0x3b,
+  0x01, 0x3a, 0x01, 0x3c, 0x61, 0xfe, 0x45, 0x48, 0x83, 0x70, 0x84, 0x84,
+  0x4f, 0x49, 0x27, 0x03, 0xfc, 0xfb, 0xdb, 0x99, 0x03, 0x8c, 0x64, 0xfc,
+  0x97, 0x03, 0x69, 0xfb, 0x38, 0xc7, 0x7b, 0x64, 0x43, 0x59, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x4f, 0x00, 0x00, 0x03, 0xf2, 0x04, 0x60, 0x00, 0x03,
+  0x00, 0x0d, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x25, 0x21, 0x15, 0x01,
+  0x21, 0x15, 0x21, 0x35, 0x01, 0x21, 0x03, 0x06, 0xfd, 0xb7, 0x7e, 0x02,
+  0x49, 0xfc, 0xe2, 0x03, 0x8c, 0xfd, 0xb8, 0x02, 0x48, 0xfc, 0x5d, 0x02,
+  0x48, 0xfd, 0xcf, 0x03, 0xfc, 0xfc, 0x68, 0x03, 0x98, 0x64, 0x64, 0xfc,
+  0x68, 0x64, 0x64, 0x03, 0x98, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x24, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x6e, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x25, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x04, 0xa4,
+  0x05, 0xf0, 0x10, 0x06, 0x00, 0x26, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x1f, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x27, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0x17, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x28, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xba,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x29, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67,
+  0xff, 0xe3, 0x04, 0xfe, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x2a, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xb6, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x2b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0x00, 0x00, 0x02, 0xab,
+  0x05, 0xd5, 0x10, 0x06, 0x11, 0x48, 0x00, 0x00, 0xff, 0xff, 0xff, 0xa0,
+  0xfe, 0x66, 0x01, 0x6b, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x2d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xe0, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x2e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x03, 0xf9,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x2f, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x05, 0x83, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x30, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xae, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x31, 0x00, 0x00, 0xff, 0xff, 0x00, 0x67, 0xff, 0xe3, 0x05, 0x44,
+  0x05, 0xf0, 0x10, 0x06, 0x00, 0x32, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4,
+  0x00, 0x00, 0x04, 0x19, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x33, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x67, 0xfe, 0xf8, 0x05, 0x44, 0x05, 0xf0, 0x10, 0x06,
+  0x00, 0x34, 0x00, 0x00, 0xff, 0xff, 0x00, 0xb4, 0x00, 0x00, 0x04, 0xcc,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x35, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x04, 0x2c, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x36, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xfa, 0x00, 0x00, 0x04, 0x6c, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x37, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa0, 0xff, 0xe3, 0x04, 0xa5,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x38, 0x00, 0x00, 0xff, 0xff, 0x00, 0x0e,
+  0x00, 0x00, 0x04, 0xde, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x39, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x3d, 0x00, 0x00, 0x06, 0xe3, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x3a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0xb6,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x3b, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfc,
+  0x00, 0x00, 0x04, 0x6a, 0x05, 0xd5, 0x10, 0x06, 0x00, 0x3c, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x52, 0x00, 0x00, 0x04, 0x9c, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x00, 0x6e, 0xff, 0xe3, 0x03, 0xc3,
+  0x04, 0x7b, 0x10, 0x06, 0x00, 0x44, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0xff, 0xe3, 0x04, 0x2e, 0x06, 0x14, 0x10, 0x06, 0x00, 0x45, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0x84, 0x04, 0x7b, 0x10, 0x06,
+  0x00, 0x46, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x03, 0xeb,
+  0x06, 0x14, 0x10, 0x06, 0x00, 0x47, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x0c, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x48, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x2a, 0x00, 0x00, 0x02, 0xac, 0x06, 0x14, 0x10, 0x06,
+  0x00, 0x49, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xfe, 0x56, 0x03, 0xeb,
+  0x04, 0x7b, 0x10, 0x06, 0x00, 0x4a, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0xf4, 0x06, 0x14, 0x10, 0x06, 0x00, 0x4b, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x01, 0x54, 0x06, 0x14, 0x10, 0x06,
+  0x00, 0x4c, 0x00, 0x00, 0xff, 0xff, 0xff, 0xde, 0xfe, 0x56, 0x01, 0x54,
+  0x06, 0x14, 0x10, 0x06, 0x00, 0x4d, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0x26, 0x06, 0x14, 0x10, 0x06, 0x00, 0x4e, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xad, 0x00, 0x00, 0x02, 0x01, 0x06, 0x14, 0x10, 0x06,
+  0x11, 0x3e, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x06, 0x67,
+  0x04, 0x7b, 0x10, 0x06, 0x00, 0x50, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7,
+  0x00, 0x00, 0x03, 0xf4, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x51, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x03, 0x04, 0x7b, 0x10, 0x06,
+  0x00, 0x52, 0x00, 0x00, 0xff, 0xff, 0x00, 0xa7, 0xfe, 0x56, 0x04, 0x2e,
+  0x04, 0x7b, 0x10, 0x06, 0x00, 0x53, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65,
+  0xfe, 0x56, 0x03, 0xeb, 0x04, 0x7b, 0x10, 0x06, 0x00, 0x54, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xa7, 0x00, 0x00, 0x02, 0xf6, 0x04, 0x7b, 0x10, 0x06,
+  0x00, 0x55, 0x00, 0x00, 0xff, 0xff, 0x00, 0x63, 0xff, 0xe3, 0x03, 0x67,
+  0x04, 0x7b, 0x10, 0x06, 0x00, 0x56, 0x00, 0x00, 0xff, 0xff, 0x00, 0x31,
+  0x00, 0x00, 0x02, 0xa7, 0x05, 0x9e, 0x10, 0x06, 0x00, 0x57, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x9c, 0xff, 0xe3, 0x03, 0xe9, 0x04, 0x7b, 0x10, 0x06,
+  0x00, 0x58, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0x00, 0x00, 0x04, 0x0c,
+  0x04, 0x60, 0x10, 0x06, 0x00, 0x59, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4d,
+  0x00, 0x00, 0x05, 0x97, 0x04, 0x60, 0x10, 0x06, 0x00, 0x5a, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x35, 0x00, 0x00, 0x04, 0x07, 0x04, 0x60, 0x10, 0x06,
+  0x00, 0x5b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x36, 0xfe, 0x56, 0x04, 0x0c,
+  0x04, 0x60, 0x10, 0x06, 0x00, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x00, 0x4f,
+  0x00, 0x00, 0x03, 0x79, 0x04, 0x60, 0x10, 0x06, 0x00, 0x5d, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x7a, 0xff, 0xe3, 0x04, 0x1c, 0x05, 0xf0, 0x00, 0x07,
+  0x00, 0x0c, 0x00, 0x14, 0x00, 0x19, 0x00, 0x00, 0x00, 0x20, 0x12, 0x10,
+  0x02, 0x20, 0x02, 0x10, 0x01, 0x36, 0x11, 0x10, 0x2f, 0x01, 0x26, 0x22,
+  0x07, 0x11, 0x16, 0x32, 0x37, 0x01, 0x06, 0x11, 0x10, 0x17, 0x01, 0x68,
+  0x01, 0xc4, 0xef, 0xef, 0xfe, 0x3c, 0xee, 0x02, 0x90, 0xb7, 0xb7, 0x5a,
+  0x2e, 0x6f, 0x2f, 0x2f, 0x6f, 0x2e, 0xfe, 0xda, 0xb6, 0xb6, 0x05, 0xf0,
+  0xfe, 0x73, 0xfd, 0x0d, 0xfe, 0x73, 0x01, 0x8d, 0x02, 0xf3, 0xfc, 0x23,
+  0x8f, 0x01, 0xd4, 0x01, 0xd5, 0x8f, 0x30, 0x0f, 0x0f, 0xfa, 0xd9, 0x0f,
+  0x0f, 0x04, 0xf7, 0x90, 0xfe, 0x2c, 0xfe, 0x2d, 0x90, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x60, 0x00, 0x00, 0x04, 0x35, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x0e, 0x00, 0x00, 0x01, 0x11, 0x33, 0x11, 0x37, 0x11, 0x21, 0x15,
+  0x21, 0x35, 0x21, 0x11, 0x05, 0x35, 0x25, 0x01, 0xfd, 0xb6, 0x58, 0x01,
+  0x29, 0xfc, 0x46, 0x01, 0x29, 0xfe, 0xbd, 0x01, 0x43, 0x05, 0x71, 0xfa,
+  0xf3, 0x05, 0x0d, 0x64, 0xfa, 0x8f, 0x64, 0x64, 0x05, 0x0d, 0x48, 0x64,
+  0x48, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75, 0x00, 0x00, 0x04, 0x25,
+  0x05, 0xf0, 0x00, 0x10, 0x00, 0x28, 0x00, 0x00, 0x37, 0x33, 0x01, 0x36,
+  0x37, 0x36, 0x10, 0x27, 0x26, 0x27, 0x17, 0x16, 0x15, 0x14, 0x0e, 0x01,
+  0x0b, 0x01, 0x36, 0x33, 0x32, 0x04, 0x15, 0x14, 0x0e, 0x01, 0x07, 0x03,
+  0x21, 0x15, 0x21, 0x37, 0x36, 0x00, 0x37, 0x36, 0x10, 0x26, 0x23, 0x22,
+  0x07, 0xe2, 0xe6, 0x01, 0x0c, 0x56, 0x1f, 0x44, 0x61, 0x3d, 0x59, 0x03,
+  0x51, 0x3e, 0x75, 0xbc, 0xfd, 0xe9, 0xa3, 0xdb, 0x01, 0x02, 0x2b, 0x49,
+  0x54, 0xec, 0x01, 0xf1, 0xfc, 0x51, 0x01, 0x02, 0x01, 0x74, 0x37, 0x6d,
+  0x79, 0x63, 0x88, 0xae, 0x64, 0x01, 0xcd, 0x95, 0x40, 0x8f, 0x01, 0x39,
+  0x5c, 0x39, 0x18, 0x04, 0x70, 0xa8, 0x64, 0xba, 0xcf, 0xfe, 0xdd, 0x04,
+  0x39, 0x68, 0xf4, 0xcc, 0x62, 0xac, 0x96, 0x91, 0xfe, 0x69, 0x64, 0x64,
+  0x05, 0x02, 0x41, 0x62, 0xbf, 0x01, 0x19, 0xa8, 0x95, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x8c, 0xff, 0xe3, 0x04, 0x02, 0x05, 0xf0, 0x00, 0x24,
+  0x00, 0x2a, 0x00, 0x30, 0x00, 0x00, 0x05, 0x22, 0x27, 0x35, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x11, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x11,
+  0x26, 0x23, 0x22, 0x0f, 0x01, 0x35, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x07, 0x1e, 0x01, 0x15, 0x14, 0x04, 0x35, 0x36, 0x35, 0x34, 0x26,
+  0x27, 0x19, 0x01, 0x3e, 0x01, 0x35, 0x34, 0x01, 0xf4, 0xa9, 0xbf, 0x1e,
+  0xb0, 0x9a, 0x5a, 0x48, 0x31, 0x39, 0xb7, 0xbe, 0x35, 0x2e, 0x35, 0x44,
+  0x8d, 0xc3, 0x18, 0xcf, 0x9d, 0xcf, 0xf2, 0x7f, 0x73, 0x7f, 0x92, 0xfe,
+  0xef, 0xb7, 0x69, 0x4e, 0x3e, 0x5a, 0x1d, 0x4a, 0x6a, 0x0c, 0x44, 0x10,
+  0x02, 0x95, 0x0a, 0x64, 0x08, 0x02, 0x20, 0x0a, 0x3c, 0x08, 0x68, 0x40,
+  0xd1, 0xb2, 0x7c, 0xaa, 0x21, 0x1f, 0xc5, 0x90, 0xdd, 0xf2, 0x92, 0x55,
+  0xe8, 0x6c, 0x8d, 0x24, 0x02, 0x96, 0xfe, 0x1a, 0x1d, 0x79, 0x58, 0xac,
+  0x00, 0x03, 0x00, 0x51, 0x00, 0x00, 0x04, 0x40, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x06, 0x00, 0x11, 0x00, 0x00, 0x01, 0x23, 0x13, 0x33, 0x09, 0x01,
+  0x21, 0x03, 0x21, 0x11, 0x33, 0x15, 0x23, 0x11, 0x21, 0x11, 0x21, 0x35,
+  0x03, 0x4a, 0xb7, 0x03, 0xb4, 0xfe, 0xf2, 0xfe, 0x7c, 0x01, 0x84, 0x03,
+  0x01, 0x6b, 0x9b, 0x9b, 0xfe, 0x98, 0xfe, 0x15, 0x05, 0x71, 0xfa, 0xf3,
+  0x04, 0xc1, 0xfc, 0xe3, 0x03, 0xcd, 0xfc, 0x33, 0x64, 0xfe, 0x5c, 0x01,
+  0xa4, 0x7f, 0x00, 0x00, 0x00, 0x03, 0x00, 0x85, 0xff, 0xe3, 0x04, 0x18,
+  0x05, 0xd5, 0x00, 0x04, 0x00, 0x08, 0x00, 0x1e, 0x00, 0x00, 0x01, 0x11,
+  0x23, 0x11, 0x36, 0x01, 0x36, 0x10, 0x27, 0x03, 0x11, 0x26, 0x23, 0x22,
+  0x07, 0x11, 0x21, 0x15, 0x21, 0x11, 0x1e, 0x01, 0x10, 0x04, 0x21, 0x22,
+  0x27, 0x35, 0x16, 0x33, 0x32, 0x01, 0xcc, 0xb4, 0x5d, 0x01, 0x8a, 0xb7,
+  0xb7, 0x5a, 0x2c, 0x60, 0xa2, 0xb9, 0x02, 0xf7, 0xfe, 0x71, 0xf6, 0xfc,
+  0xfe, 0xf2, 0xfe, 0xdd, 0xa7, 0xbb, 0xaa, 0xc6, 0x74, 0x03, 0x91, 0x01,
+  0xe0, 0xfd, 0xfd, 0x1b, 0xfc, 0xe6, 0x5c, 0x01, 0xdc, 0x60, 0xfd, 0x49,
+  0x02, 0xd7, 0x0a, 0x4b, 0x02, 0xef, 0x64, 0xfe, 0x23, 0x09, 0xf5, 0xfe,
+  0x46, 0xf9, 0x3c, 0x88, 0x64, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x65,
+  0xff, 0xe3, 0x04, 0x33, 0x05, 0xf0, 0x00, 0x04, 0x00, 0x09, 0x00, 0x11,
+  0x00, 0x25, 0x00, 0x00, 0x25, 0x36, 0x11, 0x10, 0x27, 0x01, 0x06, 0x11,
+  0x10, 0x1f, 0x01, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22, 0x07, 0x13, 0x32,
+  0x17, 0x15, 0x27, 0x26, 0x20, 0x07, 0x11, 0x36, 0x33, 0x32, 0x12, 0x10,
+  0x02, 0x23, 0x20, 0x02, 0x10, 0x00, 0x03, 0x23, 0xb6, 0xb6, 0xfe, 0x55,
+  0xb8, 0xb8, 0x5a, 0x34, 0x9a, 0x29, 0x24, 0x9a, 0x39, 0xdc, 0x96, 0x97,
+  0x1e, 0x8a, 0xfe, 0xf4, 0x55, 0x3c, 0x5d, 0xdd, 0xeb, 0xf5, 0xde, 0xfe,
+  0xfc, 0xf6, 0x01, 0x2e, 0x70, 0x63, 0x01, 0x0c, 0x01, 0x18, 0x5c, 0x01,
+  0xca, 0xb3, 0xfe, 0x91, 0xfe, 0x23, 0x95, 0x32, 0x10, 0x08, 0x03, 0x22,
+  0x06, 0x13, 0x02, 0x8c, 0x3c, 0x6a, 0x0c, 0x36, 0x2d, 0xfe, 0x66, 0x16,
+  0xfe, 0xef, 0xfe, 0x2f, 0xfe, 0xea, 0x01, 0x8d, 0x02, 0xdb, 0x01, 0xa5,
+  0x00, 0x02, 0x00, 0x3a, 0x00, 0x00, 0x04, 0x5b, 0x05, 0xd5, 0x00, 0x03,
+  0x00, 0x0a, 0x00, 0x00, 0x09, 0x01, 0x33, 0x01, 0x25, 0x21, 0x15, 0x01,
+  0x21, 0x01, 0x21, 0x03, 0x39, 0xfe, 0x3f, 0xc1, 0x01, 0xc1, 0xfc, 0x40,
+  0x04, 0x20, 0xfe, 0x1d, 0xfe, 0x7e, 0x01, 0xe4, 0xfd, 0x61, 0x05, 0x71,
+  0xfa, 0xf3, 0x05, 0x0d, 0x64, 0x64, 0xfa, 0x8f, 0x05, 0x71, 0x00, 0x00,
+  0x00, 0x07, 0x00, 0x7d, 0xff, 0xe3, 0x04, 0x17, 0x05, 0xf0, 0x00, 0x04,
+  0x00, 0x0c, 0x00, 0x24, 0x00, 0x29, 0x00, 0x31, 0x00, 0x39, 0x00, 0x41,
+  0x00, 0x00, 0x25, 0x36, 0x27, 0x26, 0x27, 0x00, 0x10, 0x17, 0x16, 0x17,
+  0x11, 0x06, 0x07, 0x13, 0x35, 0x2e, 0x01, 0x35, 0x34, 0x36, 0x20, 0x16,
+  0x15, 0x14, 0x06, 0x07, 0x15, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x20, 0x26,
+  0x35, 0x34, 0x36, 0x13, 0x11, 0x06, 0x07, 0x06, 0x05, 0x16, 0x32, 0x37,
+  0x11, 0x26, 0x22, 0x07, 0x19, 0x01, 0x16, 0x32, 0x37, 0x11, 0x26, 0x22,
+  0x17, 0x11, 0x36, 0x37, 0x36, 0x10, 0x27, 0x26, 0x03, 0x02, 0xbc, 0x06,
+  0x06, 0xb0, 0xfd, 0xf5, 0x55, 0x1e, 0x27, 0x27, 0x1d, 0x44, 0x73, 0x81,
+  0xe5, 0x01, 0x91, 0xe4, 0x81, 0x74, 0x83, 0x92, 0xef, 0xfe, 0x44, 0xef,
+  0x93, 0x81, 0xaf, 0x06, 0x07, 0x01, 0x16, 0x2d, 0x64, 0x2c, 0x2c, 0x64,
+  0x2d, 0x2c, 0x66, 0x2b, 0x2b, 0x66, 0xeb, 0x28, 0x1d, 0x56, 0x55, 0x1e,
+  0x64, 0x4a, 0xea, 0xe4, 0x4e, 0x02, 0x27, 0xfe, 0xf8, 0x4d, 0x1b, 0x12,
+  0x01, 0xfc, 0x12, 0x1b, 0xfd, 0xdc, 0x02, 0x20, 0xb1, 0x80, 0xb3, 0xd0,
+  0xd0, 0xb3, 0x80, 0xb1, 0x20, 0x01, 0x23, 0xc5, 0x8f, 0xd9, 0xe8, 0xe8,
+  0xd9, 0x8f, 0xc5, 0xfd, 0x6c, 0x02, 0x66, 0x4e, 0xe4, 0xea, 0x61, 0x06,
+  0x06, 0x02, 0x96, 0x07, 0x07, 0x02, 0xa2, 0xfd, 0xd0, 0x07, 0x07, 0x02,
+  0x30, 0x07, 0x21, 0xfe, 0x04, 0x12, 0x1b, 0x4d, 0x01, 0x08, 0x4d, 0x1b,
+  0x00, 0x04, 0x00, 0x5f, 0xff, 0xe3, 0x04, 0x2d, 0x05, 0xf0, 0x00, 0x04,
+  0x00, 0x09, 0x00, 0x11, 0x00, 0x25, 0x00, 0x00, 0x01, 0x06, 0x11, 0x10,
+  0x17, 0x01, 0x36, 0x11, 0x10, 0x2f, 0x01, 0x26, 0x22, 0x07, 0x11, 0x16,
+  0x32, 0x37, 0x03, 0x22, 0x27, 0x35, 0x17, 0x16, 0x20, 0x37, 0x11, 0x06,
+  0x23, 0x22, 0x02, 0x10, 0x12, 0x33, 0x20, 0x12, 0x10, 0x00, 0x01, 0x6f,
+  0xb6, 0xb6, 0x01, 0xab, 0xb8, 0xb8, 0x5a, 0x34, 0x9a, 0x29, 0x24, 0x9a,
+  0x39, 0xdc, 0x96, 0x97, 0x1e, 0x8a, 0x01, 0x0c, 0x55, 0x3c, 0x5d, 0xdd,
+  0xeb, 0xf5, 0xde, 0x01, 0x04, 0xf6, 0xfe, 0xd2, 0x05, 0x63, 0x63, 0xfe,
+  0xf4, 0xfe, 0xe8, 0x5c, 0xfe, 0x36, 0xb3, 0x01, 0x6f, 0x01, 0xdd, 0x95,
+  0x32, 0x10, 0x08, 0xfc, 0xde, 0x06, 0x13, 0xfd, 0x74, 0x3c, 0x6a, 0x0c,
+  0x36, 0x2d, 0x01, 0x9a, 0x16, 0x01, 0x11, 0x01, 0xd1, 0x01, 0x16, 0xfe,
+  0x73, 0xfd, 0x25, 0xfe, 0x5b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x79,
+  0xff, 0xe3, 0x04, 0x1b, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x13, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0xca, 0x00, 0x00, 0x03, 0xeb, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x14, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87, 0x00, 0x00, 0x03, 0xdd,
+  0x05, 0xf0, 0x10, 0x06, 0x00, 0x15, 0x00, 0x00, 0xff, 0xff, 0x00, 0x8c,
+  0xff, 0xe3, 0x04, 0x02, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x16, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x5a, 0x00, 0x00, 0x04, 0x2e, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x17, 0x00, 0x00, 0xff, 0xff, 0x00, 0x8e, 0xff, 0xe3, 0x03, 0xf4,
+  0x05, 0xd5, 0x10, 0x06, 0x00, 0x18, 0x00, 0x00, 0xff, 0xff, 0x00, 0x80,
+  0xff, 0xe3, 0x04, 0x21, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x19, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x97, 0x00, 0x00, 0x03, 0xf8, 0x05, 0xd5, 0x10, 0x06,
+  0x00, 0x1a, 0x00, 0x00, 0xff, 0xff, 0x00, 0x7d, 0xff, 0xe3, 0x04, 0x17,
+  0x05, 0xf0, 0x10, 0x06, 0x00, 0x1b, 0x00, 0x00, 0xff, 0xff, 0x00, 0x74,
+  0xff, 0xe3, 0x04, 0x14, 0x05, 0xf0, 0x10, 0x06, 0x00, 0x1c, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x11, 0x23, 0x01, 0x11, 0x21, 0x11,
+  0x04, 0xa9, 0x7f, 0x7f, 0xfc, 0x0b, 0x08, 0x6a, 0x01, 0x5f, 0x02, 0xc3,
+  0xfc, 0x24, 0x04, 0xf5, 0xfb, 0x0b, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0xb4, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x46,
+  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
+  0xfd, 0x3d, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x00,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x06,
+  0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a,
+  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
+  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30,
+  0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
+  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15,
+  0xfd, 0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21,
+  0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08,
+  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01, 0x3f, 0x10, 0x10, 0x1b,
+  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10,
+  0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
+  0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x06, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
+  0x00, 0x4d, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11,
+  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x07, 0xd2,
+  0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
+  0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17,
+  0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01, 0x3f,
+  0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b,
+  0x17, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19,
+  0x1a, 0x12, 0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc,
+  0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
+  0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b,
+  0x00, 0x5f, 0x00, 0x63, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
+  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x05, 0x8a,
+  0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18,
+  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
+  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01,
+  0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
+  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a,
+  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25,
+  0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x05, 0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
+  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f,
+  0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20,
+  0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
+  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0xee, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08,
+  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x03, 0xcc, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8,
+  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
+  0xfd, 0x3d, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
+  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0x00, 0x01, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
+  0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x02, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x06, 0xe0, 0x20, 0x15, 0x17, 0x11,
+  0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15,
+  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xeb, 0x42,
+  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
+  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19, 0x42, 0x14, 0x17, 0x11,
+  0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d,
+  0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18,
+  0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbe, 0x42,
+  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
+  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8,
+  0x94, 0x03, 0x76, 0x7f, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10,
+  0xfd, 0xef, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
+  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24,
+  0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd,
+  0xde, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11,
+  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18,
+  0x19, 0x13, 0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
+  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x19, 0x00, 0x1d,
+  0x00, 0x21, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10,
+  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0xfe, 0x31,
+  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
+  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
+  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x84, 0x0f, 0x0e, 0x19,
+  0x14, 0x43, 0x15, 0x16, 0x11, 0x0f, 0x0f, 0x0f, 0x18, 0x16, 0x41, 0x15,
+  0x18, 0x0f, 0x0f, 0x03, 0xf4, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16,
+  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e,
+  0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3,
+  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
+  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x06, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2c, 0x00, 0x42,
+  0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16,
+  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x05,
+  0x4f, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16,
+  0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
+  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0xfe, 0xa1, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10,
+  0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18,
+  0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
+  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
+  0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2c, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
+  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14,
+  0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18,
+  0x0f, 0x0e, 0x05, 0x4f, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe,
+  0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15,
+  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18,
+  0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e,
+  0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
+  0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfe,
+  0xa1, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11,
+  0x1b, 0x17, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48,
+  0x19, 0x1a, 0x12, 0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10,
+  0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
+  0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d,
+  0x00, 0x71, 0x00, 0x75, 0x00, 0x79, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
+  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x83,
+  0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17,
+  0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x03, 0x07, 0x0e, 0x0f, 0x18, 0x15,
+  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
+  0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15,
+  0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe,
+  0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
+  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18,
+  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
+  0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
+  0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b,
+  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00,
+  0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x84, 0x00, 0x88,
+  0x00, 0x8c, 0x00, 0x90, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
+  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18,
+  0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16,
+  0x18, 0x0f, 0x0e, 0x03, 0x07, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
+  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f,
+  0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20,
+  0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
+  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0xee, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08,
+  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4,
+  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb,
+  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00,
+  0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2a, 0x00, 0x40, 0x00, 0x56, 0x00, 0x6b, 0x00, 0x7f, 0x00, 0x95,
+  0x00, 0x99, 0x00, 0x9d, 0x00, 0xa1, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
+  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
+  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x02, 0x83, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10,
+  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x04, 0x5d,
+  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f,
+  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
+  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19,
+  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
+  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e,
+  0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f,
+  0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
+  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3,
+  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x02, 0xc3, 0x24, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0xb4, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10,
+  0xfd, 0xef, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
+  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24,
+  0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd,
+  0xde, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11,
+  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18,
+  0x19, 0x13, 0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
+  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x2f,
+  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
+  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0x95, 0x08, 0x6a, 0x7f, 0xf8,
+  0x94, 0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfc, 0xf4, 0x04,
+  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
+  0x3d, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38,
+  0x00, 0x4e, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x06,
+  0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a,
+  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0xfd, 0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x02, 0xc3,
+  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb,
+  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x1f,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x00, 0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x4e, 0x00, 0x64, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07,
+  0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16,
+  0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd,
+  0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x01, 0x3f, 0x10, 0x10, 0x1b,
+  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10,
+  0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
+  0x02, 0xc3, 0xfd, 0x3d, 0x1f, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02,
+  0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x08, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x00,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe,
+  0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15,
+  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18,
+  0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e,
+  0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
+  0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
+  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x01, 0x3f, 0x10, 0x10, 0x1b, 0x18,
+  0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f, 0x01,
+  0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb,
+  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x1f,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x00, 0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e, 0x00, 0x53, 0x00, 0x57,
+  0x00, 0x5b, 0x00, 0x5f, 0x00, 0x74, 0x00, 0x89, 0x00, 0x00, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
+  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x05, 0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
+  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15, 0x17, 0x10, 0x0e,
+  0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x42, 0x15, 0x17, 0x10, 0x0f, 0x0f,
+  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18,
+  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15,
+  0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x42, 0x15, 0x17, 0x10,
+  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e,
+  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15,
+  0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
+  0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49,
+  0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x49, 0x18,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02,
+  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb,
+  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x1f,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x49, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x49,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e,
+  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0x00,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x05,
+  0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
+  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
+  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
+  0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
+  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
+  0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10,
+  0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16,
+  0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfd,
+  0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x03, 0xcc, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8,
+  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
+  0xfd, 0x3d, 0x1f, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40,
+  0x00, 0x55, 0x00, 0x69, 0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b,
+  0x00, 0xa1, 0x00, 0xb7, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
+  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
+  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x04, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x06, 0xe0,
+  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f,
+  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
+  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19,
+  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
+  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e,
+  0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f,
+  0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
+  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3,
+  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfe, 0xd8, 0x42, 0x15,
+  0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
+  0x0e, 0x0e, 0x10, 0x17, 0xfd, 0xe8, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f,
+  0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a,
+  0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a, 0x12, 0x02,
+  0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10, 0x11, 0x1b,
+  0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfc, 0xe3,
+  0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3,
+  0xfd, 0x3d, 0x1f, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe, 0xd7,
+  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0xfe, 0x95, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76,
+  0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11,
+  0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49,
+  0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0xfc, 0xf4, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25,
+  0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x58, 0x00, 0x5c, 0x00, 0x60, 0x00, 0x64, 0x00, 0x00, 0x00, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe,
+  0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21,
+  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
+  0x0e, 0x0f, 0x19, 0x14, 0x04, 0x59, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20,
+  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11,
+  0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01,
+  0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11, 0x1a, 0x17,
+  0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19,
+  0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x8f,
+  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb,
+  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00,
+  0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
+  0x00, 0x7a, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27,
+  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17,
+  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16,
+  0xfe, 0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x05, 0xb3, 0x20, 0x15,
+  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
+  0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d,
+  0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f,
+  0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11, 0x1a,
+  0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18,
+  0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0xfd, 0xed, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10,
+  0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18,
+  0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
+  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
+  0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x87,
+  0x00, 0x8b, 0x00, 0x8f, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe,
+  0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x05, 0xb3, 0x20, 0x15, 0x17,
+  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f,
+  0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21,
+  0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08,
+  0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0xf9, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x01, 0x09,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xed, 0x10, 0x10, 0x1b,
+  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f,
+  0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5,
+  0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d,
+  0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x99,
+  0x00, 0x9d, 0x00, 0xa1, 0x00, 0xa5, 0x00, 0x00, 0x00, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe,
+  0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x03, 0x6b, 0x0e, 0x0f, 0x18,
+  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
+  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f,
+  0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f,
+  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
+  0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9,
+  0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x7a, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04,
+  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
+  0x3d, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d,
+  0x00, 0x83, 0x00, 0x99, 0x00, 0xb0, 0x00, 0xb4, 0x00, 0xb8, 0x00, 0xbc,
+  0x00, 0x00, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x25, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x25, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x04,
+  0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20,
+  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe, 0xd7, 0x20, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x03, 0x6b, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f,
+  0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f,
+  0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
+  0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17,
+  0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10,
+  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e,
+  0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17,
+  0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8,
+  0x94, 0x03, 0x76, 0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0xf9, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x7a, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
+  0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b,
+  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00,
+  0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x56, 0x00, 0x6c, 0x00, 0x82, 0x00, 0x97,
+  0x00, 0xab, 0x00, 0xc1, 0x00, 0xc5, 0x00, 0xc9, 0x00, 0xcd, 0x00, 0x00,
+  0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x25, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x21, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
+  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
+  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x04, 0x00, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0xfe, 0xd7,
+  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xf0, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x04, 0xc1, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f,
+  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
+  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11,
+  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01,
+  0x0f, 0x0f, 0x18, 0x02, 0x19, 0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f,
+  0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15,
+  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
+  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11,
+  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01,
+  0x0f, 0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76,
+  0x7f, 0x01, 0x40, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xf9, 0x10, 0x11,
+  0x1a, 0x17, 0x4a, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49,
+  0x18, 0x19, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
+  0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13,
+  0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a, 0x12, 0x02, 0x02,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10, 0x11, 0x1b, 0x18,
+  0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
+  0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfc, 0xe3, 0x04,
+  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
+  0x3d, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e, 0x00, 0x53, 0x00, 0x57,
+  0x00, 0x5b, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x94, 0x0e, 0x10, 0x17, 0x16,
+  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x41, 0x16, 0x16,
+  0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15, 0x17, 0x10,
+  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e,
+  0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
+  0x41, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x42, 0x15,
+  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f,
+  0xfd, 0x43, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0x03, 0xcc,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x49, 0x18, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
+  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x00, 0x00, 0x00,
+  0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x19, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x36, 0x00, 0x4b, 0x00, 0x60,
+  0x00, 0x75, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x06, 0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17,
+  0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa,
+  0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e,
+  0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
+  0x41, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x42,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
+  0x0f, 0x19, 0x15, 0x41, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19,
+  0x15, 0x42, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16,
+  0x17, 0x10, 0x0f, 0x02, 0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
+  0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd,
+  0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
+  0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
+  0xe9, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x49, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x00,
+  0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16,
+  0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x4e, 0x00, 0x64,
+  0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25,
+  0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0xd2, 0x20, 0x15, 0x17,
+  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d,
+  0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc,
+  0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e,
+  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15,
+  0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15,
+  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x01, 0x3f, 0x10,
+  0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a,
+  0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
+  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
+  0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0x00,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0xd2,
+  0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
+  0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17,
+  0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c,
+  0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01,
+  0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x01, 0x3f, 0x10, 0x10,
+  0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12,
+  0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04,
+  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
+  0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x0b, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f,
+  0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11,
+  0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x05, 0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01,
+  0xdc, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
+  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18,
+  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15,
+  0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f,
+  0xf9, 0x4e, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c,
+  0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01,
+  0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x03, 0xcc, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
+  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e,
+  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0xbc,
+  0x00, 0xd2, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
+  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x05,
+  0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
+  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
+  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
+  0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
+  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
+  0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10,
+  0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16,
+  0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
+  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
+  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03,
+  0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x00, 0x00, 0x0d, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
+  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
+  0x00, 0xcd, 0x00, 0xe3, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x00,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x02, 0x22, 0x27, 0x26,
+  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
+  0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x06, 0xe0, 0x20, 0x15, 0x17, 0x11,
+  0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15,
+  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xeb, 0x42,
+  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
+  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19, 0x42, 0x14, 0x17, 0x11,
+  0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d,
+  0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18,
+  0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbe, 0x42,
+  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18,
+  0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8,
+  0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15,
+  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
+  0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e,
+  0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20,
+  0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17,
+  0x10, 0x0f, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12,
+  0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11,
+  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47,
+  0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a,
+  0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10,
+  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13,
+  0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
+  0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00,
+  0x00, 0x08, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x21, 0x00, 0x37, 0x00, 0x4d, 0x00, 0x63,
+  0x00, 0x79, 0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11,
+  0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0xb4, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
+  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
+  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f,
+  0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x46, 0x04, 0xf5, 0xfb,
+  0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02,
+  0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38,
+  0x00, 0x4e, 0x00, 0x64, 0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21,
+  0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x06,
+  0x78, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a,
+  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16,
+  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
+  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe,
+  0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16,
+  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x02,
+  0xc3, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5,
+  0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d,
+  0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02,
+  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x00, 0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x4e, 0x00, 0x64, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0x00,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21,
+  0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07,
+  0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd, 0xfe, 0x20, 0x16,
+  0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
+  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
+  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f,
+  0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x01, 0x3f, 0x10, 0x10,
+  0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13,
+  0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25,
+  0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x00, 0x0b, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f,
+  0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x01, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe,
+  0xec, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15,
+  0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18,
+  0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e,
+  0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
+  0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10,
+  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01,
+  0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17,
+  0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21,
+  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
+  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f,
+  0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f,
+  0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x01, 0x3f, 0x10, 0x10, 0x1b,
+  0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x01, 0x09, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f,
+  0x01, 0x08, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5,
+  0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d,
+  0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02,
+  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x00, 0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b,
+  0x00, 0x5f, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0xbb,
+  0x00, 0xd1, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11,
+  0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x05, 0x8a,
+  0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18,
+  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
+  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01,
+  0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
+  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a,
+  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16,
+  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15,
+  0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe,
+  0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16,
+  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x03,
+  0xcc, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b,
+  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x02, 0x6d,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10,
+  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e,
+  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0xbc,
+  0x00, 0xd2, 0x00, 0xe8, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21,
+  0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x05,
+  0x8a, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e,
+  0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
+  0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
+  0x41, 0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16,
+  0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10,
+  0x01, 0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10,
+  0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16,
+  0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94,
+  0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10, 0xfe, 0x14, 0x0e, 0x10,
+  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
+  0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x16, 0x10, 0x0f, 0x0f,
+  0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f, 0x0e, 0x03, 0xcc, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd,
+  0xa8, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
+  0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
+  0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x00, 0x00, 0x00, 0x0e, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40,
+  0x00, 0x55, 0x00, 0x69, 0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b,
+  0x00, 0xa1, 0x00, 0xb7, 0x00, 0xcd, 0x00, 0xe3, 0x00, 0xf9, 0x00, 0x00,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x17, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x02, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01, 0x11, 0x21, 0x11,
+  0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x07, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x06, 0xe0,
+  0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x11, 0x0f,
+  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0xfe, 0xeb, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
+  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0x02, 0x19,
+  0x42, 0x14, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15,
+  0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x42, 0x14, 0x17, 0x11, 0x0e,
+  0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f,
+  0x19, 0xfd, 0xbe, 0x42, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x15,
+  0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f, 0x0f, 0x18, 0xfa, 0xb3,
+  0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfc, 0x6c, 0x0e, 0x10,
+  0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20,
+  0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0f, 0x0e, 0x19, 0x15, 0x20,
+  0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x17,
+  0x10, 0xfe, 0x14, 0x0e, 0x10, 0x17, 0x16, 0x41, 0x15, 0x18, 0x10, 0x0e,
+  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0f,
+  0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17,
+  0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x0f, 0x18, 0x14, 0x43,
+  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x41, 0x16, 0x18, 0x0f,
+  0x0e, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f,
+  0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x13, 0x10, 0xfd, 0xef, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c,
+  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18,
+  0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a, 0x12,
+  0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10, 0x11,
+  0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfc,
+  0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02,
+  0xc3, 0xfd, 0x3d, 0x02, 0x6d, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd,
+  0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xe4, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4,
+  0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x22, 0x00, 0x3a, 0x00, 0x50, 0x00, 0x66, 0x00, 0x7c, 0x00, 0x92,
+  0x00, 0x00, 0x37, 0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11,
+  0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27,
+  0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x00, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x1e, 0x01, 0x07, 0x06, 0x07, 0xb4, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
+  0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21,
+  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec, 0x43, 0x14, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f,
+  0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01,
+  0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
+  0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14,
+  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd3, 0x43,
+  0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17,
+  0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x46, 0x04, 0xf5, 0xfb, 0x0b, 0x8d,
+  0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17,
+  0x26, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x00, 0x0a, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16,
+  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x39, 0x00, 0x51, 0x00, 0x67,
+  0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
+  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x06, 0x78,
+  0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10,
+  0x17, 0x16, 0x41, 0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f,
+  0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e,
+  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
+  0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec,
+  0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15,
+  0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18,
+  0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f,
+  0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
+  0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
+  0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x02, 0xc3, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04, 0xf5, 0xfb, 0x0b,
+  0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11,
+  0x1a, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a,
+  0x17, 0x26, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02,
+  0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x4f, 0x00, 0x67, 0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0xbf,
+  0x00, 0x00, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x11, 0x21, 0x11, 0x27, 0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e,
+  0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
+  0x06, 0x07, 0x07, 0xd2, 0x20, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfd,
+  0xfe, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x21, 0x20,
+  0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa, 0xa1, 0x08, 0x6a,
+  0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10,
+  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe,
+  0xec, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
+  0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14,
+  0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01,
+  0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
+  0x15, 0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0x3f,
+  0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x02, 0x11, 0x10, 0x11, 0x1c,
+  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18,
+  0x1a, 0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb,
+  0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x00, 0x00,
+  0x00, 0x0c, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x16,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x64,
+  0x00, 0x7c, 0x00, 0x92, 0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0x00,
+  0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
+  0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x00,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x07, 0xd2, 0x20,
+  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17,
+  0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x15, 0xfe, 0xec, 0x20, 0x15, 0x17, 0x11,
+  0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x14, 0xfe, 0xf0, 0x20, 0x16, 0x18, 0x10, 0x0d, 0x0d, 0x10, 0x18,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0xfa,
+  0xa1, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20,
+  0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16,
+  0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e,
+  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
+  0x17, 0x16, 0xfe, 0xec, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01,
+  0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41,
+  0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18,
+  0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e,
+  0x18, 0x01, 0x3f, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x01, 0x09,
+  0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x48, 0x19, 0x1a, 0x12, 0x0f, 0x01, 0x08, 0x10, 0x11, 0x1c, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a,
+  0x13, 0x10, 0xfc, 0xf6, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc,
+  0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x00, 0x00, 0x00,
+  0x00, 0x0d, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
+  0x00, 0x7a, 0x00, 0x92, 0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0xea,
+  0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
+  0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x00,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x05, 0x8a, 0x0e,
+  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15,
+  0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18, 0x15,
+  0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16,
+  0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01, 0xce,
+  0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f,
+  0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xf9, 0x4e, 0x08, 0x6a, 0x7f,
+  0xf8, 0x94, 0x03, 0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e,
+  0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
+  0x17, 0x16, 0x21, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec,
+  0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15,
+  0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18,
+  0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f,
+  0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15,
+  0xfd, 0xd3, 0x43, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
+  0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x03, 0xcc, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10,
+  0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0xfc, 0x9f, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03,
+  0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26,
+  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x02, 0x02, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x00,
+  0x00, 0x0e, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e, 0x05, 0x3b, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
+  0x00, 0x7a, 0x00, 0x91, 0x00, 0xa9, 0x00, 0xbf, 0x00, 0xd5, 0x00, 0xeb,
+  0x01, 0x01, 0x00, 0x00, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x07, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x11, 0x21, 0x11, 0x27,
+  0x11, 0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17,
+  0x14, 0x07, 0x06, 0x07, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x05, 0x8a,
+  0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0e, 0x19,
+  0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x18,
+  0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41,
+  0x16, 0x17, 0x10, 0xfe, 0x15, 0x0e, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x17,
+  0x10, 0x0f, 0x0f, 0x0e, 0x19, 0x15, 0x20, 0x22, 0x15, 0x17, 0x10, 0x01,
+  0xce, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0f, 0x0f,
+  0x0f, 0x18, 0x15, 0x41, 0x16, 0x17, 0x10, 0x0f, 0xee, 0x0e, 0x10, 0x17,
+  0x15, 0x22, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x41,
+  0x16, 0x16, 0x11, 0x0e, 0xfa, 0x3c, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03,
+  0x76, 0x7f, 0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21,
+  0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0xfe, 0xec, 0x43, 0x14, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f,
+  0x01, 0x10, 0x0e, 0x18, 0x01, 0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01,
+  0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
+  0x15, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14,
+  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd3, 0x43,
+  0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17,
+  0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18, 0x03, 0xcc, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0xfd, 0xe9, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0xe4, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0xfd, 0xa8, 0x04,
+  0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c, 0x02, 0xc3, 0xfd,
+  0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0xfd, 0xef,
+  0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd,
+  0xee, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x00, 0x0f, 0x00, 0xb4, 0x00, 0x46, 0x09, 0x1e,
+  0x05, 0x3b, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
+  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
+  0x00, 0xcc, 0x00, 0xe1, 0x00, 0xf6, 0x01, 0x0b, 0x00, 0x00, 0x01, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x14,
+  0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x02, 0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x00, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01, 0x11, 0x21, 0x11, 0x27, 0x11,
+  0x21, 0x11, 0x25, 0x11, 0x33, 0x11, 0x01, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x20, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07, 0x06, 0x07, 0x01,
+  0x22, 0x27, 0x26, 0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x03, 0x22, 0x27, 0x26,
+  0x27, 0x2e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x00, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x1e, 0x01, 0x07,
+  0x06, 0x07, 0x06, 0xe0, 0x20, 0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19,
+  0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
+  0x15, 0x17, 0x11, 0x0f, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10,
+  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0xfe, 0xea, 0x41, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f,
+  0x0f, 0x18, 0x02, 0x19, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10,
+  0x18, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0d, 0x0d, 0x0f, 0x19, 0x15, 0x41,
+  0x15, 0x17, 0x11, 0x0e, 0x01, 0x0f, 0x10, 0x18, 0x15, 0x41, 0x15, 0x18,
+  0x10, 0x0d, 0x0d, 0x0f, 0x19, 0xfd, 0xbd, 0x41, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x0f, 0x0e, 0x01, 0x0f,
+  0x0f, 0x18, 0xfa, 0xb3, 0x08, 0x6a, 0x7f, 0xf8, 0x94, 0x03, 0x76, 0x7f,
+  0xfd, 0xc4, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x41,
+  0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x21, 0x20, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0xfe, 0xeb, 0x42, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0f,
+  0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10, 0x0e, 0x18,
+  0x01, 0xf8, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14,
+  0x41, 0x16, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x14,
+  0x18, 0x10, 0x0e, 0x01, 0x0f, 0x0f, 0x19, 0x14, 0x41, 0x16, 0x17, 0x10,
+  0x0f, 0x0f, 0x0f, 0x18, 0x15, 0xfd, 0xd2, 0x42, 0x14, 0x18, 0x10, 0x0e,
+  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x15, 0x17, 0x0f, 0x0f, 0x01, 0x10,
+  0x0e, 0x18, 0x03, 0x52, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12,
+  0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x49, 0x17, 0x1a, 0x13, 0x10, 0xfd, 0xef,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11,
+  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x47,
+  0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x24, 0x24, 0x18, 0x1a,
+  0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13, 0xfd, 0xde, 0x10,
+  0x11, 0x1b, 0x18, 0x47, 0x18, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x18, 0x48, 0x18, 0x19, 0x13,
+  0xfc, 0xe3, 0x04, 0xf5, 0xfb, 0x0b, 0x8d, 0x03, 0xdb, 0xfc, 0x25, 0x8c,
+  0x02, 0xc3, 0xfd, 0x3d, 0x01, 0xf2, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x49, 0x18, 0x19, 0x13,
+  0x10, 0xfd, 0xef, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x12,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49,
+  0x18, 0x19, 0x12, 0x02, 0x02, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0xfd,
+  0xee, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x02, 0x12, 0x10, 0x11, 0x1b,
+  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35,
+  0x01, 0x21, 0x11, 0x21, 0x01, 0xb1, 0x02, 0x7c, 0xfc, 0x87, 0x04, 0x76,
+  0xfb, 0x8a, 0x03, 0x07, 0x8d, 0x8d, 0x04, 0x66, 0xf6, 0xa7, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0xb4, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
+  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x07, 0x6d, 0xf6,
+  0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e,
+  0x00, 0x22, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
+  0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e,
+  0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
+  0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
+  0x02, 0x7c, 0xfd, 0x84, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
+  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x05, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16,
+  0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16,
+  0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18,
+  0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd,
+  0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02,
+  0x7c, 0xfd, 0x84, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b,
+  0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d,
+  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x00, 0x05, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
+  0x15, 0x21, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef,
+  0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
+  0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41,
+  0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11,
+  0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
+  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10,
+  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24,
+  0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08,
+  0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b,
+  0x00, 0x5f, 0x00, 0x63, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x03, 0xe0,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
+  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11,
+  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
+  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x0e, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d,
+  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
+  0x21, 0x15, 0x21, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
+  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe,
+  0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11,
+  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21,
+  0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16,
+  0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a,
+  0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x0e,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd,
+  0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11,
+  0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
+  0xfc, 0x27, 0x8d, 0x00, 0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
+  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0x00, 0x25, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22,
+  0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15,
+  0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17,
+  0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17,
+  0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e,
+  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
+  0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21,
+  0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
+  0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
+  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16,
+  0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x91, 0x24, 0x17, 0x1a,
+  0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c,
+  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x33,
+  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17,
+  0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab, 0x4a, 0x16, 0x1a,
+  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f,
+  0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11,
+  0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x02, 0x82,
+  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x17,
+  0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4, 0xf6, 0xa7, 0x8d,
+  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x19, 0x00, 0x1d,
+  0x00, 0x21, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
+  0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
+  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd,
+  0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02,
+  0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0x02,
+  0x02, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
+  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18,
+  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
+  0x0f, 0x0f, 0x17, 0x16, 0x21, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e,
+  0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
+  0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
+  0x02, 0x7c, 0xfd, 0x84, 0x05, 0x69, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x18, 0x48, 0x18, 0x1a, 0x11, 0x10,
+  0xfb, 0x9c, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6,
+  0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x06, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2c, 0x00, 0x42,
+  0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
+  0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e,
+  0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
+  0xfe, 0xc4, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f,
+  0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
+  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10,
+  0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x19, 0x1a, 0x11, 0x10, 0xfa, 0x19, 0x24, 0x17, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05,
+  0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00,
+  0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2c, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10,
+  0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f,
+  0x0f, 0x17, 0x16, 0xfe, 0xc4, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
+  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e,
+  0xef, 0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f,
+  0x18, 0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15,
+  0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17,
+  0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
+  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17,
+  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a,
+  0x11, 0x10, 0xfa, 0x19, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
+  0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a,
+  0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
+  0x27, 0x8d, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d,
+  0x00, 0x71, 0x00, 0x75, 0x00, 0x79, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1,
+  0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16,
+  0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x01, 0x10, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
+  0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
+  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17,
+  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a,
+  0x11, 0x10, 0xfc, 0xa3, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd,
+  0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00,
+  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x84, 0x00, 0x88,
+  0x00, 0x8c, 0x00, 0x90, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
+  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18,
+  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
+  0x0f, 0x0f, 0x17, 0x16, 0x01, 0x10, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
+  0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
+  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
+  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd,
+  0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16,
+  0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb,
+  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x05,
+  0x6b, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0xfc, 0xa3, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19,
+  0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
+  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2a, 0x00, 0x40, 0x00, 0x56, 0x00, 0x6b, 0x00, 0x7f, 0x00, 0x95,
+  0x00, 0x99, 0x00, 0x9d, 0x00, 0xa1, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36,
+  0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27,
+  0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
+  0x15, 0x21, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
+  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xa2,
+  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18,
+  0x15, 0x42, 0x14, 0x17, 0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15,
+  0x21, 0x20, 0x15, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16,
+  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
+  0x0e, 0x10, 0x19, 0x15, 0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e,
+  0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18,
+  0x16, 0x41, 0x15, 0x17, 0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f,
+  0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10,
+  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e,
+  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76,
+  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
+  0x05, 0x6b, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0xfb, 0x26, 0x24, 0x17,
+  0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11,
+  0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01,
+  0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
+  0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab, 0x4a, 0x16,
+  0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12,
+  0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11,
+  0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x02,
+  0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
+  0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4, 0xf6, 0xa7,
+  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x2f,
+  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
+  0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf,
+  0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
+  0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfd, 0x42, 0x04, 0x76, 0xfb,
+  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03,
+  0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x01, 0x93, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27,
+  0x8d, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x16, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38,
+  0x00, 0x4e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
+  0x21, 0x15, 0x21, 0x02, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x02,
+  0xf1, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
+  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76,
+  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
+  0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40,
+  0x16, 0x17, 0x11, 0x0e, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
+  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01,
+  0x49, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x00, 0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x4e, 0x00, 0x64, 0x00, 0x00, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13,
+  0x21, 0x15, 0x21, 0x02, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
+  0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
+  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40,
+  0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
+  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e,
+  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18,
+  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
+  0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02,
+  0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x00, 0x08, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x00,
+  0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef,
+  0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18,
+  0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41,
+  0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11,
+  0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
+  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x7c, 0x24, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10,
+  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8,
+  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
+  0x00, 0x79, 0x00, 0x8f, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
+  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x02, 0x0e, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d,
+  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11,
+  0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x00, 0x00, 0x00,
+  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
+  0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01,
+  0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0xe0, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
+  0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14,
+  0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4,
+  0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c,
+  0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e,
+  0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e,
+  0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x02, 0x0e, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
+  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10,
+  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
+  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01,
+  0x49, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
+  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
+  0x00, 0x00, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x02, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15,
+  0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17,
+  0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17,
+  0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e,
+  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
+  0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21,
+  0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
+  0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
+  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16,
+  0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x1c, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
+  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e,
+  0x91, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13,
+  0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd,
+  0xab, 0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12,
+  0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f,
+  0x11, 0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05,
+  0xe4, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x01, 0x49, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x11, 0x1a, 0x02, 0x53, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
+  0x00, 0x4d, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10,
+  0x0e, 0xee, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfd, 0x42, 0x04,
+  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
+  0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x01, 0x93, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
+  0x00, 0x07, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x5c, 0x00, 0x60, 0x00, 0x64,
+  0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x03, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
+  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
+  0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e,
+  0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x81, 0x21, 0x14, 0x18, 0x10, 0x0e,
+  0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f,
+  0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
+  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
+  0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfb, 0x2b, 0x10, 0x11, 0x1a,
+  0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49,
+  0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
+  0x27, 0x8d, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6e,
+  0x00, 0x72, 0x00, 0x76, 0x00, 0x7a, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01,
+  0x95, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14,
+  0x43, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17,
+  0x10, 0x0e, 0xee, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x22,
+  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f, 0x19,
+  0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40, 0x16,
+  0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78,
+  0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19,
+  0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
+  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xf9, 0xaa, 0x24, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18, 0x1a, 0x12, 0x0f,
+  0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
+  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x58, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x87,
+  0x00, 0x8b, 0x00, 0x8f, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17, 0x16,
+  0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e, 0x10,
+  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16,
+  0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x22, 0x0e, 0x0f, 0x18, 0x16, 0x41,
+  0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17,
+  0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14, 0x43, 0x15, 0x17, 0x10, 0x0f,
+  0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18, 0x10, 0x0d, 0xed, 0x0f, 0x0f,
+  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40,
+  0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17,
+  0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10,
+  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17,
+  0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xf9, 0xaa, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13,
+  0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05,
+  0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00,
+  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x99,
+  0x00, 0x9d, 0x00, 0xa1, 0x00, 0xa5, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x13, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17, 0x16,
+  0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16,
+  0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e, 0x10,
+  0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16,
+  0x40, 0x16, 0x17, 0x11, 0x0e, 0x6e, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
+  0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
+  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
+  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc,
+  0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02,
+  0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x01,
+  0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0xfc, 0x34, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d,
+  0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6d, 0x00, 0x83, 0x00, 0x99,
+  0x00, 0xb0, 0x00, 0xb4, 0x00, 0xb8, 0x00, 0xbc, 0x00, 0x00, 0x00, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x13, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
+  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21,
+  0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10, 0x0e, 0xee, 0x0e,
+  0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x6e, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
+  0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
+  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76,
+  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
+  0x03, 0xc3, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10,
+  0x10, 0x10, 0x1b, 0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0xfc, 0x34, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01,
+  0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7,
+  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x56, 0x00, 0x6c, 0x00, 0x82, 0x00, 0x97, 0x00, 0xab, 0x00, 0xc1,
+  0x00, 0xc5, 0x00, 0xc9, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x11, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x95,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0xe1, 0x0e, 0x0f, 0x18, 0x14, 0x43,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x42, 0x15, 0x17, 0x10,
+  0x0e, 0xee, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x19,
+  0x15, 0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14,
+  0x17, 0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15,
+  0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e,
+  0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19,
+  0x15, 0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15,
+  0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15,
+  0x17, 0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12,
+  0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e,
+  0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18,
+  0x16, 0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
+  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x03, 0xc3, 0x4a,
+  0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x11, 0x1a, 0x01, 0x4a, 0x24, 0x17, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x01, 0x2e, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x10, 0x1b,
+  0x17, 0x4a, 0x17, 0x19, 0x13, 0x10, 0x10, 0x11, 0x1b, 0x17, 0xfa, 0xb7,
+  0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
+  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
+  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab,
+  0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10,
+  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
+  0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
+  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4,
+  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x00, 0x07, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e,
+  0x00, 0x53, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x03, 0xe0,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17,
+  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f,
+  0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x06, 0x74, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x49, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x49,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
+  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x03, 0x0b, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27,
+  0x8d, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x19, 0x00, 0x1d, 0x00, 0x21, 0x00, 0x36,
+  0x00, 0x4b, 0x00, 0x60, 0x00, 0x75, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x02, 0xf1, 0x21, 0x14, 0x18, 0x10,
+  0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x42, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f,
+  0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc,
+  0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42,
+  0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68,
+  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49,
+  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
+  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17,
+  0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x4e, 0x00, 0x64, 0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x05, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37,
+  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01,
+  0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
+  0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc, 0x0f, 0x0f,
+  0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x40,
+  0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
+  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x10, 0x18, 0x14, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02,
+  0x3b, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7,
+  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
+  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
+  0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0x00,
+  0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x94,
+  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14,
+  0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18,
+  0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e,
+  0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04,
+  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
+  0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0x7c, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10,
+  0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x01, 0x2e, 0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6,
+  0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10,
+  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f,
+  0x00, 0xa5, 0x00, 0xbb, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
+  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
+  0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfc, 0xf6, 0x04,
+  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
+  0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0x02, 0x0e, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08,
+  0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e, 0x00, 0x53, 0x00, 0x69,
+  0x00, 0x6d, 0x00, 0x71, 0x00, 0x75, 0x00, 0x8a, 0x00, 0x9f, 0x00, 0xb4,
+  0x00, 0xc9, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
+  0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f,
+  0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e,
+  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
+  0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14,
+  0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x42, 0x16, 0x16, 0x10, 0x0f,
+  0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e,
+  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e,
+  0x10, 0x18, 0x14, 0x02, 0x0e, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0xfd,
+  0xee, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19,
+  0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10,
+  0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08,
+  0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10,
+  0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18,
+  0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00,
+  0x00, 0x0d, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x14,
+  0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69, 0x00, 0x7f, 0x00, 0x83,
+  0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7, 0x00, 0xcd, 0x00, 0xe3,
+  0x00, 0x00, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x17, 0x11,
+  0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17, 0x12, 0x0e, 0xfe, 0x24,
+  0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17, 0x12, 0x0e, 0x0e, 0x10,
+  0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x16, 0x3f,
+  0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x20, 0x20, 0x16, 0x18,
+  0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
+  0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0xfe, 0x15, 0x0e,
+  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
+  0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20,
+  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
+  0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
+  0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
+  0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17,
+  0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
+  0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0x91,
+  0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
+  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
+  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab,
+  0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10,
+  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
+  0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
+  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4,
+  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
+  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x00, 0x00, 0x00, 0x08, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x21, 0x00, 0x37, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x00,
+  0x13, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0xb4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
+  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
+  0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
+  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x07, 0x6d, 0xf6, 0xa7,
+  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
+  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10,
+  0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16,
+  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x38, 0x00, 0x4e, 0x00, 0x64,
+  0x00, 0x7a, 0x00, 0x90, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11,
+  0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x02, 0xf1, 0x21, 0x14, 0x18,
+  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
+  0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
+  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
+  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x01,
+  0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a, 0x11, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06, 0x68, 0xf6, 0xa7,
+  0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02,
+  0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10,
+  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x4c, 0x00, 0x61,
+  0x00, 0x76, 0x00, 0x8b, 0x00, 0xa0, 0x00, 0x00, 0x05, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21,
+  0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e,
+  0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01, 0xdc,
+  0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb, 0x8a,
+  0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f,
+  0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17,
+  0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e,
+  0x0e, 0x1a, 0x14, 0x42, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16,
+  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b, 0x24, 0x18, 0x1a,
+  0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
+  0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee,
+  0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x49, 0x18, 0x19, 0x12,
+  0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11,
+  0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x19, 0x1a, 0x11, 0x10, 0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
+  0x00, 0x4d, 0x00, 0x63, 0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0xbb,
+  0x00, 0x00, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x13, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21,
+  0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x94,
+  0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
+  0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14,
+  0x43, 0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18,
+  0x10, 0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e,
+  0x0e, 0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04,
+  0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd,
+  0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18,
+  0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f,
+  0x0f, 0x0f, 0x17, 0x16, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
+  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x01, 0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18,
+  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12,
+  0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
+  0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
+  0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0x00, 0x00, 0x00,
+  0x00, 0x0c, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63,
+  0x00, 0x79, 0x00, 0x8f, 0x00, 0xa5, 0x00, 0xbb, 0x00, 0xd1, 0x00, 0x00,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21,
+  0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43,
+  0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88,
+  0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
+  0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21,
+  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x02, 0x0e, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
+  0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08,
+  0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12,
+  0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a, 0x11, 0x10, 0x00, 0x00,
+  0x00, 0x0d, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x57, 0x00, 0x6e, 0x00, 0x72, 0x00, 0x76,
+  0x00, 0x7a, 0x00, 0x90, 0x00, 0xa6, 0x00, 0xbc, 0x00, 0xd2, 0x00, 0xe8,
+  0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11,
+  0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0xe0, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f,
+  0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14,
+  0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4,
+  0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c,
+  0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
+  0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e,
+  0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15,
+  0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14, 0xcd, 0x21, 0x14,
+  0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16, 0x16, 0x10,
+  0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x02, 0x0e, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x02, 0x22,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11, 0x1b, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18,
+  0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10,
+  0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd,
+  0xfe, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11,
+  0x1a, 0x17, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x19, 0x1a, 0x11, 0x10, 0x00, 0x0e, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
+  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
+  0x00, 0xcd, 0x00, 0xe3, 0x00, 0xf9, 0x00, 0x00, 0x25, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26,
+  0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x24, 0x34,
+  0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e,
+  0x01, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21,
+  0x13, 0x21, 0x15, 0x21, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x00, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37,
+  0x12, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15,
+  0x40, 0x16, 0x17, 0x11, 0x0d, 0x0d, 0x10, 0x18, 0x15, 0x42, 0x14, 0x17,
+  0x12, 0x0e, 0xfe, 0x24, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17,
+  0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e,
+  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
+  0x20, 0x20, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21,
+  0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17,
+  0x11, 0xfe, 0x15, 0x0e, 0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e,
+  0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10,
+  0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16,
+  0x41, 0x15, 0x17, 0x11, 0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03,
+  0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x02, 0x2f, 0x20, 0x16,
+  0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e,
+  0x0e, 0x10, 0x18, 0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18,
+  0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20,
+  0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e,
+  0x10, 0x18, 0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a,
+  0x14, 0x21, 0x21, 0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0x91,
+  0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x13, 0x10,
+  0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x01, 0x33, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
+  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0xfd, 0xab,
+  0x4a, 0x16, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x4a, 0x16, 0x1a, 0x12, 0x10,
+  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11,
+  0x1b, 0x02, 0x82, 0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x17,
+  0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11, 0x1a, 0x05, 0xe4,
+  0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x03, 0xfa, 0x10, 0x11,
+  0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x10, 0x1c, 0x17, 0x24,
+  0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10,
+  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17,
+  0x4a, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x19, 0x1a,
+  0x11, 0x10, 0x00, 0x00, 0x00, 0x09, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x22, 0x00, 0x3a,
+  0x00, 0x50, 0x00, 0x66, 0x00, 0x7c, 0x00, 0x92, 0x00, 0x00, 0x13, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26,
+  0x27, 0xb4, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
+  0x02, 0x7c, 0xfd, 0x84, 0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11,
+  0x0f, 0xfe, 0x24, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20,
+  0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17,
+  0x11, 0x0e, 0xfe, 0x23, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01,
+  0xdd, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x07, 0x6d, 0xf6, 0xa7, 0x8d,
+  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33,
+  0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
+  0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11,
+  0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x02, 0x6b, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x00,
+  0x00, 0x0a, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16,
+  0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x39, 0x00, 0x51, 0x00, 0x67,
+  0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37,
+  0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07,
+  0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17,
+  0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x02, 0xf1,
+  0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x21, 0x21, 0x16,
+  0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76, 0xfb,
+  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x01,
+  0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e, 0x10,
+  0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23, 0x0e,
+  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x17, 0x11, 0x01, 0x05, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24, 0x18, 0x1a,
+  0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12, 0x10, 0x06,
+  0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19,
+  0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x01, 0x33, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd,
+  0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x02, 0x6b, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10,
+  0x1b, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x16, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x4f, 0x00, 0x67, 0x00, 0x7d, 0x00, 0x93, 0x00, 0xa9, 0x00, 0xbf,
+  0x00, 0x00, 0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01,
+  0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e,
+  0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27,
+  0x26, 0x27, 0x01, 0x94, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
+  0x0e, 0x0e, 0x0f, 0x19, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0x01,
+  0xdc, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76, 0xfb,
+  0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84, 0x01,
+  0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e, 0x0e,
+  0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e, 0x10,
+  0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23, 0x0e,
+  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x17, 0x11, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x02, 0x3b,
+  0x24, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d,
+  0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17,
+  0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33,
+  0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
+  0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11,
+  0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17,
+  0x02, 0x6b, 0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25,
+  0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x00,
+  0x00, 0x0c, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x16,
+  0x00, 0x2b, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x64,
+  0x00, 0x7c, 0x00, 0x92, 0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0x00,
+  0x05, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x13, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22,
+  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x94, 0x0e,
+  0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x15,
+  0x21, 0x20, 0x16, 0x17, 0x10, 0x0e, 0xef, 0x0d, 0x0f, 0x19, 0x14, 0x43,
+  0x15, 0x17, 0x10, 0x0f, 0x0f, 0x0f, 0x18, 0x15, 0x41, 0x16, 0x18, 0x10,
+  0x0d, 0xed, 0x0f, 0x0f, 0x19, 0x15, 0x41, 0x15, 0x18, 0x10, 0x0e, 0x0e,
+  0x10, 0x18, 0x15, 0x40, 0x16, 0x17, 0x11, 0x0f, 0xfd, 0x44, 0x04, 0x76,
+  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
+  0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e,
+  0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40,
+  0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16,
+  0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11,
+  0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23,
+  0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18,
+  0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40,
+  0x16, 0x17, 0x11, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01,
+  0x32, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x01, 0x2e, 0x24, 0x18, 0x1a,
+  0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x05, 0xf8, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc,
+  0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25,
+  0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33, 0x4a, 0x17, 0x1a,
+  0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10,
+  0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01,
+  0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x02, 0x6b, 0x4a,
+  0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
+  0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x00, 0x0d, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x2b, 0x00, 0x41,
+  0x00, 0x57, 0x00, 0x5b, 0x00, 0x5f, 0x00, 0x63, 0x00, 0x7a, 0x00, 0x92,
+  0x00, 0xa8, 0x00, 0xbe, 0x00, 0xd4, 0x00, 0xea, 0x00, 0x00, 0x01, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21,
+  0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22, 0x27, 0x26, 0x27, 0x01,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37,
+  0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x0e, 0x01, 0x27, 0x26, 0x27, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0xfe, 0x1f, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14,
+  0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x43, 0x14,
+  0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f,
+  0x0e, 0x18, 0x15, 0x43, 0x14, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18, 0x14,
+  0xfc, 0xf6, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
+  0x02, 0x7c, 0xfd, 0x84, 0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x42, 0x15, 0x16, 0x11,
+  0x0f, 0xfe, 0x24, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15,
+  0x20, 0x21, 0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x20,
+  0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17,
+  0x11, 0x0e, 0xfe, 0x23, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x01,
+  0xdd, 0x0e, 0x10, 0x18, 0x15, 0x20, 0x21, 0x16, 0x16, 0x11, 0x0e, 0x0e,
+  0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x02, 0x0e, 0x10, 0x11, 0x1a,
+  0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12,
+  0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10,
+  0x10, 0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11,
+  0x1b, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x07, 0x71, 0xf6, 0xa7, 0x8d, 0x08, 0x3f,
+  0xfc, 0x27, 0x8d, 0x02, 0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10,
+  0x1c, 0x17, 0x24, 0x25, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18,
+  0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x24, 0x25,
+  0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x01, 0x33, 0x4a, 0x17,
+  0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11,
+  0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd, 0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10,
+  0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11,
+  0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b,
+  0x17, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x02, 0x6b,
+  0x4a, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
+  0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0x00, 0x00, 0x0e, 0x00, 0xb4,
+  0xfe, 0x14, 0x05, 0x2b, 0x07, 0x6d, 0x00, 0x14, 0x00, 0x29, 0x00, 0x3e,
+  0x00, 0x53, 0x00, 0x69, 0x00, 0x6d, 0x00, 0x71, 0x00, 0x75, 0x00, 0x8b,
+  0x00, 0xa1, 0x00, 0xb6, 0x00, 0xcb, 0x00, 0xe0, 0x00, 0xf5, 0x00, 0x00,
+  0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x00, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x12, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34,
+  0x37, 0x36, 0x37, 0x01, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x03, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x34, 0x37, 0x36, 0x37, 0x36, 0x01, 0x21,
+  0x11, 0x21, 0x37, 0x21, 0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01,
+  0x27, 0x26, 0x27, 0x01, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16,
+  0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26,
+  0x25, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x03, 0xe0, 0x20, 0x16, 0x17, 0x0f,
+  0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10,
+  0x18, 0x14, 0xfe, 0x1f, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19,
+  0x14, 0x22, 0x20, 0x16, 0x17, 0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x15, 0x42,
+  0x15, 0x17, 0x11, 0x0e, 0x0e, 0x0f, 0x19, 0x14, 0x22, 0x20, 0x16, 0x17,
+  0x0f, 0x0f, 0x0f, 0x0e, 0x18, 0x02, 0x18, 0x20, 0x16, 0x17, 0x0f, 0x0f,
+  0x0f, 0x0e, 0x18, 0x15, 0x42, 0x15, 0x17, 0x11, 0x0e, 0x0e, 0x10, 0x18,
+  0x14, 0xcd, 0x21, 0x14, 0x18, 0x10, 0x0e, 0x0e, 0x0e, 0x1a, 0x14, 0x42,
+  0x16, 0x16, 0x10, 0x0f, 0x0f, 0x0f, 0x17, 0x16, 0xfd, 0xe4, 0x04, 0x76,
+  0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e, 0x02, 0x7c, 0xfd, 0x84,
+  0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21, 0x15, 0x17, 0x10, 0x0e,
+  0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0f, 0xfe, 0x24, 0x0e,
+  0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18,
+  0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x01,
+  0xcf, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
+  0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe, 0x23, 0x0e, 0x10, 0x17,
+  0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16,
+  0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16,
+  0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x02, 0x0e,
+  0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c,
+  0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0xfd, 0xee, 0x10, 0x11, 0x1b, 0x17,
+  0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a,
+  0x12, 0x02, 0x22, 0x10, 0x11, 0x1a, 0x18, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0xfd, 0xfe, 0x10, 0x11,
+  0x1b, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x01, 0x09, 0x10, 0x11, 0x1a, 0x17, 0x26, 0x24,
+  0x18, 0x1a, 0x11, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x49, 0x18, 0x19, 0x12,
+  0x10, 0x06, 0x68, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02,
+  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x01, 0x34, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd,
+  0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x02, 0x6c, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10,
+  0x1b, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0xb4, 0xfe, 0x14, 0x05, 0x2b,
+  0x07, 0x6d, 0x00, 0x14, 0x00, 0x2a, 0x00, 0x40, 0x00, 0x55, 0x00, 0x69,
+  0x00, 0x7f, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0xa1, 0x00, 0xb7,
+  0x00, 0xcc, 0x00, 0xe1, 0x00, 0xf6, 0x01, 0x0b, 0x00, 0x00, 0x25, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x22,
+  0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x32, 0x17,
+  0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27,
+  0x24, 0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x00, 0x34, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01, 0x21, 0x11, 0x21, 0x37, 0x21,
+  0x11, 0x21, 0x13, 0x21, 0x15, 0x21, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27, 0x26,
+  0x27, 0x26, 0x10, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x01,
+  0x34, 0x37, 0x36, 0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x27, 0x26, 0x27, 0x26, 0x25, 0x34, 0x37, 0x36,
+  0x37, 0x3e, 0x01, 0x17, 0x16, 0x17, 0x16, 0x14, 0x07, 0x06, 0x07, 0x06,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x00, 0x34, 0x37, 0x36, 0x37, 0x36, 0x32,
+  0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x27,
+  0x26, 0x27, 0x03, 0x72, 0x0e, 0x10, 0x19, 0x15, 0x40, 0x16, 0x17, 0x11,
+  0x0d, 0x0d, 0x10, 0x18, 0x15, 0x41, 0x15, 0x17, 0x12, 0x0e, 0xfe, 0x24,
+  0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x15, 0x17, 0x12, 0x0e, 0x0e, 0x10,
+  0x19, 0x15, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x16, 0x3f,
+  0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15, 0x20, 0x20, 0x16, 0x18,
+  0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20, 0x16, 0x17, 0x10,
+  0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11, 0xfe, 0x15, 0x0e,
+  0x10, 0x18, 0x16, 0x3f, 0x16, 0x17, 0x12, 0x0e, 0x0e, 0x10, 0x19, 0x15,
+  0x40, 0x16, 0x18, 0x10, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x21, 0x20,
+  0x16, 0x17, 0x10, 0x0e, 0x0e, 0x0f, 0x18, 0x16, 0x41, 0x15, 0x17, 0x11,
+  0xfd, 0x33, 0x04, 0x76, 0xfb, 0x8a, 0x7f, 0x03, 0x78, 0xfc, 0x88, 0x7e,
+  0x02, 0x7c, 0xfd, 0x84, 0x01, 0xc0, 0x0f, 0x0f, 0x18, 0x15, 0x21, 0x21,
+  0x15, 0x17, 0x10, 0x0e, 0x0e, 0x10, 0x17, 0x15, 0x41, 0x16, 0x16, 0x11,
+  0x0f, 0xfe, 0x24, 0x0e, 0x10, 0x17, 0x15, 0x22, 0x20, 0x15, 0x18, 0x10,
+  0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10,
+  0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10, 0x18, 0x15, 0x41,
+  0x16, 0x16, 0x11, 0x01, 0xcf, 0x0e, 0x10, 0x18, 0x15, 0x41, 0x16, 0x16,
+  0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x17, 0x11, 0x0e, 0xfe,
+  0x23, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16, 0x18, 0x10, 0x0e, 0x0e, 0x10,
+  0x18, 0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x01, 0xdd, 0x0e, 0x10, 0x18,
+  0x15, 0x41, 0x16, 0x16, 0x11, 0x0e, 0x0e, 0x10, 0x17, 0x16, 0x40, 0x16,
+  0x17, 0x11, 0x91, 0x24, 0x17, 0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17,
+  0x48, 0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17,
+  0x1a, 0x13, 0x10, 0x10, 0x11, 0x1c, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x01, 0x34, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11,
+  0x1a, 0xfd, 0xab, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b,
+  0x17, 0x48, 0x18, 0x1a, 0x12, 0x0f, 0x0f, 0x11, 0x1b, 0x17, 0x49, 0x17,
+  0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12,
+  0x0f, 0x0f, 0x11, 0x1b, 0x02, 0x83, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10,
+  0x11, 0x1a, 0x17, 0x26, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x11,
+  0x1a, 0x05, 0xe4, 0xf6, 0xa7, 0x8d, 0x08, 0x3f, 0xfc, 0x27, 0x8d, 0x02,
+  0x7c, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18,
+  0x19, 0x12, 0x10, 0x10, 0x11, 0x1a, 0x18, 0x25, 0x24, 0x17, 0x1a, 0x12,
+  0x10, 0x10, 0x10, 0x1c, 0x17, 0x49, 0x18, 0x19, 0x12, 0x10, 0x10, 0x11,
+  0x1a, 0x18, 0x01, 0x34, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b,
+  0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10, 0x1b, 0xfd,
+  0xd0, 0x24, 0x17, 0x1a, 0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48,
+  0x18, 0x1a, 0x12, 0x10, 0x10, 0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a,
+  0x12, 0x10, 0x01, 0x11, 0x11, 0x1b, 0x17, 0x48, 0x18, 0x1a, 0x12, 0x10,
+  0x10, 0x11, 0x1b, 0x17, 0x02, 0x6c, 0x49, 0x17, 0x1a, 0x12, 0x10, 0x10,
+  0x11, 0x1b, 0x17, 0x25, 0x24, 0x17, 0x1a, 0x11, 0x10, 0x01, 0x11, 0x10,
+  0x1b, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x00, 0x01, 0x22,
+  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
+  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x11,
+  0x21, 0x11, 0x01, 0x8c, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x0e, 0x03, 0xda, 0x06,
+  0xf5, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
+  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf7, 0xd3, 0x07, 0x01, 0xf8, 0xff,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x33, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x16,
+  0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23,
+  0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01,
+  0x03, 0x33, 0x03, 0x33, 0x01, 0x23, 0x27, 0x21, 0x07, 0x23, 0x04, 0x5b,
+  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
+  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01, 0x04, 0x77, 0x3d, 0xfe,
+  0xd7, 0x3d, 0x77, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4,
+  0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82,
+  0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
+  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac, 0xfe, 0x55, 0x02,
+  0x0f, 0xfc, 0xbc, 0xda, 0xda, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
+  0x00, 0x49, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23,
+  0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22,
+  0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
+  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
+  0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x21, 0x15, 0x21, 0x35, 0x36, 0x37,
+  0x00, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x01, 0x06, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08,
+  0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf,
+  0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
+  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x75, 0x01,
+  0x7d, 0xfd, 0xe6, 0x1f, 0x38, 0x01, 0x36, 0x5e, 0x4c, 0x2f, 0x6e, 0x41,
+  0x46, 0x77, 0x34, 0x82, 0x9d, 0xfe, 0xd6, 0x33, 0x03, 0x18, 0x79, 0xfe,
+  0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4,
+  0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78,
+  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
+  0xfc, 0x3f, 0x72, 0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23,
+  0x23, 0x7b, 0x1c, 0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x59, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
+  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
+  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
+  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
+  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x1e, 0x01,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32,
+  0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c,
+  0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c,
+  0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x57, 0x53, 0x5b, 0xab, 0x9f, 0x33,
+  0x71, 0x3f, 0x2f, 0x6b, 0x3c, 0x62, 0x6c, 0x64, 0x61, 0x4d, 0x54, 0x55,
+  0x57, 0x5a, 0x55, 0x24, 0x5c, 0x49, 0x42, 0x73, 0x31, 0x82, 0x98, 0x51,
+  0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b,
+  0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78,
+  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
+  0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x91, 0x12, 0x6d, 0x52, 0x7c, 0x86, 0x15,
+  0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46, 0x4a, 0x4c, 0x6c, 0x3f, 0x3c, 0x3a,
+  0x3d, 0x12, 0x17, 0x73, 0x11, 0x12, 0x76, 0x63, 0x45, 0x60, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x33, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x16,
+  0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23,
+  0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x09,
+  0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35, 0x21,
+  0x35, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b,
+  0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd,
+  0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
+  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95,
+  0x7a, 0x7a, 0x81, 0xfe, 0x8b, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25,
+  0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26,
+  0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
+  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe,
+  0x5d, 0x02, 0x1c, 0xfd, 0xe4, 0x6d, 0xba, 0xba, 0x79, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x51, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
+  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
+  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
+  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
+  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21, 0x15,
+  0x21, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08,
+  0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf,
+  0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
+  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb,
+  0xfe, 0xa0, 0x19, 0x1a, 0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e,
+  0x36, 0x72, 0x3b, 0x33, 0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f,
+  0x5d, 0x31, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b,
+  0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04,
+  0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
+  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04,
+  0x4d, 0x4c, 0x83, 0x87, 0x4b, 0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d,
+  0x66, 0xae, 0x66, 0x14, 0x15, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
+  0x00, 0x40, 0x00, 0x60, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15,
+  0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06,
+  0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14,
+  0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11,
+  0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x22, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x13,
+  0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x04, 0x5b, 0x3b, 0x01, 0x1b,
+  0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61,
+  0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
+  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x0d,
+  0x4f, 0x2e, 0x2e, 0x2e, 0x2e, 0x4f, 0x4e, 0x2e, 0x2e, 0x2e, 0x2e, 0x9a,
+  0x2c, 0x2d, 0x2d, 0x2c, 0x73, 0x3e, 0x3d, 0x09, 0x22, 0x34, 0x34, 0x3d,
+  0x83, 0x4b, 0x4c, 0x4f, 0x4f, 0x82, 0x97, 0x9e, 0x61, 0x61, 0xa4, 0x2c,
+  0x2d, 0x2d, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b,
+  0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04,
+  0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
+  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x9e, 0x34, 0x35, 0x5b, 0x5a,
+  0x34, 0x35, 0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14,
+  0x0a, 0x0b, 0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f,
+  0x4f, 0x4e, 0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x37, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
+  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
+  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
+  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
+  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21, 0x15,
+  0x01, 0x23, 0x01, 0x21, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0,
+  0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08,
+  0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7,
+  0x7a, 0x01, 0x27, 0xfe, 0x61, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25,
+  0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26,
+  0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
+  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc,
+  0xed, 0x02, 0xe4, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3d, 0x00, 0x5b,
+  0x00, 0x6a, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23,
+  0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22,
+  0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
+  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
+  0x21, 0x22, 0x35, 0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x36, 0x20, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x22, 0x07, 0x06, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61,
+  0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01,
+  0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
+  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x55, 0xa8, 0x2f, 0x30, 0x5f,
+  0x54, 0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01, 0x02,
+  0x4a, 0x48, 0x29, 0x2a, 0x4b, 0x51, 0x32, 0x30, 0x4c, 0x4e, 0x8e, 0x8f,
+  0x4d, 0x4d, 0x30, 0x30, 0x29, 0x2a, 0x29, 0x4d, 0x49, 0x2c, 0x2b, 0x2b,
+  0x2a, 0x96, 0x2b, 0x2a, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e,
+  0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01,
+  0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x5b, 0x2c, 0x2b,
+  0x4b, 0x4c, 0x56, 0x2c, 0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48,
+  0x64, 0x74, 0x3a, 0x3a, 0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37,
+  0x50, 0x79, 0x41, 0x41, 0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f,
+  0x26, 0x25, 0x25, 0x24, 0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x50, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x16,
+  0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23,
+  0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01,
+  0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x04, 0x5b,
+  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
+  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x01, 0x10, 0x2c, 0x2d, 0x2d, 0x2b, 0x74, 0x3d, 0x3d, 0x09, 0x20,
+  0x36, 0x33, 0x3e, 0x82, 0x97, 0x4e, 0x50, 0x82, 0x96, 0x4f, 0x4f, 0x60,
+  0x62, 0xa4, 0x2c, 0x2d, 0x2d, 0xb8, 0x4f, 0x5c, 0x2e, 0x2e, 0x4f, 0x4c,
+  0x30, 0x2f, 0x2f, 0x2e, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e,
+  0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01,
+  0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xdf, 0x67, 0x14,
+  0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b, 0x1a, 0x98, 0x84, 0x81, 0x4d,
+  0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x01, 0x72, 0x68,
+  0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5c, 0x34, 0x34, 0x00, 0x00,
+  0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x3e, 0x00, 0x4a, 0x00, 0x51, 0x00, 0x00,
+  0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14,
+  0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36,
+  0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34,
+  0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11,
+  0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x04, 0x5b,
+  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
+  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x03, 0x86, 0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e,
+  0x6d, 0x76, 0x99, 0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e,
+  0x7b, 0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc,
+  0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56,
+  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
+  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56,
+  0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde,
+  0xd4, 0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
+  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
+  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
+  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
+  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x05, 0x33, 0x11,
+  0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x04, 0x5b,
+  0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35,
+  0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x01, 0x87, 0x72, 0x3b, 0x39, 0x81, 0x2c, 0x24, 0x4c, 0x3f, 0x03,
+  0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b,
+  0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78, 0xf8,
+  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
+  0x07, 0x79, 0xf0, 0xf0, 0xfd, 0xdc, 0x95, 0x46, 0x45, 0x60, 0x54, 0x6c,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18,
+  0x00, 0x24, 0x00, 0x30, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17,
+  0x16, 0x15, 0x14, 0x23, 0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35,
+  0x23, 0x06, 0x23, 0x22, 0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15,
+  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
+  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x0e, 0x01,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e,
+  0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x04,
+  0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c, 0x1b, 0x36, 0x89,
+  0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c, 0xfd, 0x6b, 0x6c,
+  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
+  0xba, 0xd8, 0x02, 0xe9, 0x2c, 0x5b, 0x33, 0xa3, 0xb4, 0xb5, 0xa2, 0x33,
+  0x5c, 0x2b, 0x2a, 0x5f, 0x31, 0x70, 0x6f, 0x6e, 0x71, 0x31, 0x60, 0x29,
+  0x03, 0x18, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b,
+  0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78,
+  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
+  0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xeb, 0x17, 0x16, 0xe3, 0xce, 0xcd, 0xe5,
+  0x17, 0x17, 0x74, 0x22, 0x24, 0xaa, 0xac, 0xab, 0xab, 0x24, 0x22, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x11,
+  0x00, 0x1b, 0x00, 0x34, 0x00, 0x40, 0x00, 0x4c, 0x00, 0x00, 0x01, 0x22,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23, 0x22, 0x06, 0x10, 0x16,
+  0x33, 0x32, 0x05, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23, 0x22, 0x27,
+  0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22, 0x35, 0x34,
+  0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35,
+  0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22,
+  0x35, 0x11, 0x34, 0x02, 0xaf, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c, 0x8e,
+  0x8f, 0x8d, 0x4e, 0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d, 0x4d,
+  0x56, 0x58, 0x01, 0x6b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0, 0x61, 0x3c,
+  0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08, 0x01, 0x1c,
+  0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x03, 0x2c, 0x01, 0xd7, 0xda, 0xdb, 0xd7,
+  0xd7, 0xdb, 0xa5, 0xc9, 0x28, 0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e,
+  0x9e, 0xfe, 0x90, 0x9e, 0x6e, 0x79, 0xfe, 0x7e, 0x26, 0x25, 0x4e, 0xe4,
+  0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4, 0x4e, 0x25, 0x26, 0x01, 0x82,
+  0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
+  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
+  0x00, 0x3b, 0x00, 0x00, 0x01, 0x16, 0x00, 0x17, 0x16, 0x15, 0x14, 0x23,
+  0x22, 0x27, 0x23, 0x14, 0x17, 0x23, 0x36, 0x35, 0x23, 0x06, 0x23, 0x22,
+  0x35, 0x34, 0x37, 0x36, 0x00, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
+  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
+  0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01,
+  0x23, 0x01, 0x11, 0x23, 0x04, 0x5b, 0x3b, 0x01, 0x1b, 0x08, 0x19, 0xb0,
+  0x61, 0x3c, 0x1b, 0x36, 0x89, 0x35, 0x1b, 0x3c, 0x61, 0xaf, 0x18, 0x08,
+  0x01, 0x1c, 0xfd, 0x6b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x72, 0x01, 0x46, 0x94,
+  0xfe, 0x91, 0x01, 0x8c, 0x96, 0xfe, 0x9f, 0x72, 0x03, 0x18, 0x79, 0xfe,
+  0x7e, 0x26, 0x25, 0x4e, 0xe4, 0x9b, 0xcc, 0x6b, 0x6b, 0xcc, 0x9b, 0xe4,
+  0x4e, 0x25, 0x26, 0x01, 0x82, 0x04, 0x56, 0x78, 0xf8, 0x87, 0x78, 0x78,
+  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
+  0xf0, 0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe,
+  0x6d, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x30, 0x00, 0x38,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x01, 0x03, 0x33, 0x03, 0x33, 0x01, 0x23, 0x27, 0x21, 0x07, 0x23, 0x04,
+  0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe,
+  0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01, 0x04, 0x77, 0x3d, 0xfe,
+  0xd7, 0x3d, 0x77, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e,
+  0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41,
+  0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
+  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac, 0xfe, 0x55, 0x02,
+  0x0f, 0xfc, 0xbc, 0xda, 0xda, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
+  0x00, 0x46, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x01, 0x21, 0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15,
+  0x14, 0x01, 0x06, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
+  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
+  0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x75, 0x01, 0x7d, 0xfd, 0xe6, 0x1f,
+  0x38, 0x01, 0x36, 0x5e, 0x4c, 0x2f, 0x6e, 0x41, 0x46, 0x77, 0x34, 0x82,
+  0x9d, 0xfe, 0xd6, 0x33, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
+  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
+  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfc, 0x3f, 0x72, 0x6e,
+  0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23, 0x23, 0x7b, 0x1c, 0x1c,
+  0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
+  0x00, 0x56, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x01, 0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x27,
+  0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x35, 0x3e,
+  0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x04, 0x51, 0x14, 0x31, 0x38,
+  0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38,
+  0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
+  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x57, 0x53,
+  0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f, 0x2f, 0x6b, 0x3c, 0x62, 0x6c, 0x64,
+  0x61, 0x4d, 0x54, 0x55, 0x57, 0x5a, 0x55, 0x24, 0x5c, 0x49, 0x42, 0x73,
+  0x31, 0x82, 0x98, 0x51, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
+  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
+  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x91, 0x12, 0x6d,
+  0x52, 0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46, 0x4a, 0x4c,
+  0x6c, 0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11, 0x12, 0x76, 0x63,
+  0x45, 0x60, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x30, 0x00, 0x3b,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23, 0x35,
+  0x21, 0x35, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71,
+  0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd,
+  0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
+  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95,
+  0x7a, 0x7a, 0x81, 0xfe, 0x8b, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d,
+  0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95,
+  0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
+  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe,
+  0x5d, 0x02, 0x1c, 0xfd, 0xe4, 0x6d, 0xba, 0xba, 0x79, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x21, 0x00, 0x2d, 0x00, 0x4e, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33,
+  0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14,
+  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21, 0x15, 0x21, 0x15, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
+  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
+  0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb, 0xfe, 0xa0, 0x19, 0x1a,
+  0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e, 0x36, 0x72, 0x3b, 0x33,
+  0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f, 0x5d, 0x31, 0x01, 0xb6,
+  0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92,
+  0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87,
+  0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07,
+  0x79, 0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04, 0x4d, 0x4c, 0x83, 0x87,
+  0x4b, 0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d, 0x66, 0xae, 0x66, 0x14,
+  0x15, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3d, 0x00, 0x5d,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x01, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x07, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4,
+  0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c,
+  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
+  0xba, 0xd8, 0x02, 0x0d, 0x4f, 0x2e, 0x2e, 0x2e, 0x2e, 0x4f, 0x4e, 0x2e,
+  0x2e, 0x2e, 0x2e, 0x9a, 0x2c, 0x2d, 0x2d, 0x2c, 0x73, 0x3e, 0x3d, 0x09,
+  0x22, 0x34, 0x34, 0x3d, 0x83, 0x4b, 0x4c, 0x4f, 0x4f, 0x82, 0x97, 0x9e,
+  0x61, 0x61, 0xa4, 0x2c, 0x2d, 0x2d, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95,
+  0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d,
+  0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79,
+  0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x9e,
+  0x34, 0x35, 0x5b, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34,
+  0x01, 0x62, 0x67, 0x14, 0x0a, 0x0b, 0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a,
+  0x4c, 0x4d, 0x84, 0x7f, 0x4f, 0x4e, 0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08,
+  0x09, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x34, 0x00, 0x00,
+  0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x09,
+  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x01, 0x22,
+  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
+  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17, 0x21,
+  0x15, 0x01, 0x23, 0x01, 0x21, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d,
+  0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e,
+  0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7,
+  0x7a, 0x01, 0x27, 0xfe, 0x61, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d,
+  0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95,
+  0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78,
+  0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc,
+  0xed, 0x02, 0xe4, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3a, 0x00, 0x58,
+  0x00, 0x67, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x20, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06,
+  0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4,
+  0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c,
+  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
+  0xba, 0xd8, 0x02, 0x55, 0xa8, 0x2f, 0x30, 0x5f, 0x54, 0x53, 0x30, 0x30,
+  0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01, 0x02, 0x4a, 0x48, 0x29, 0x2a,
+  0x4b, 0x51, 0x32, 0x30, 0x4c, 0x4e, 0x8e, 0x8f, 0x4d, 0x4d, 0x30, 0x30,
+  0x29, 0x2a, 0x29, 0x4d, 0x49, 0x2c, 0x2b, 0x2b, 0x2a, 0x96, 0x2b, 0x2a,
+  0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e,
+  0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78,
+  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
+  0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x5b, 0x2c, 0x2b, 0x4b, 0x4c, 0x56, 0x2c,
+  0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48, 0x64, 0x74, 0x3a, 0x3a,
+  0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37, 0x50, 0x79, 0x41, 0x41,
+  0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f, 0x26, 0x25, 0x25, 0x24,
+  0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
+  0x00, 0x4d, 0x00, 0x5c, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
+  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
+  0x22, 0x35, 0x11, 0x34, 0x01, 0x35, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x13, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
+  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
+  0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x10, 0x2c, 0x2d, 0x2d, 0x2b, 0x74,
+  0x3d, 0x3d, 0x09, 0x20, 0x36, 0x33, 0x3e, 0x82, 0x97, 0x4e, 0x50, 0x82,
+  0x96, 0x4f, 0x4f, 0x60, 0x62, 0xa4, 0x2c, 0x2d, 0x2d, 0xb8, 0x4f, 0x5c,
+  0x2e, 0x2e, 0x4f, 0x4c, 0x30, 0x2f, 0x2f, 0x2e, 0x01, 0xb6, 0x76, 0x3e,
+  0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0,
+  0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78,
+  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
+  0xfb, 0xdf, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b, 0x1a,
+  0x98, 0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76, 0x08,
+  0x09, 0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5c,
+  0x34, 0x34, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x3b, 0x00, 0x47,
+  0x00, 0x4e, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x37,
+  0x36, 0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11, 0x04,
+  0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe,
+  0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x03, 0x86, 0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e,
+  0x6d, 0x76, 0x99, 0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e,
+  0x7b, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe,
+  0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc,
+  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
+  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56,
+  0x56, 0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde,
+  0xd4, 0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15,
+  0x00, 0x21, 0x00, 0x2d, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33,
+  0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14,
+  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x05, 0x33, 0x11, 0x14, 0x07, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x04, 0x51, 0x14, 0x31, 0x38,
+  0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38,
+  0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
+  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x87, 0x72,
+  0x3b, 0x39, 0x81, 0x2c, 0x24, 0x4c, 0x3f, 0x01, 0xb6, 0x76, 0x3e, 0x47,
+  0x95, 0x2d, 0x3b, 0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b,
+  0x2d, 0x95, 0x47, 0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
+  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0,
+  0xfd, 0xdc, 0x95, 0x46, 0x45, 0x60, 0x54, 0x6c, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
+  0x00, 0x47, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x01, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x15, 0x14, 0x16,
+  0x33, 0x32, 0x36, 0x37, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38,
+  0x11, 0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36,
+  0x31, 0xfd, 0x4f, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
+  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xe9, 0x2c, 0x5b, 0x33, 0xa3,
+  0xb4, 0xb5, 0xa2, 0x33, 0x5c, 0x2b, 0x2a, 0x5f, 0x31, 0x70, 0x6f, 0x6e,
+  0x71, 0x31, 0x60, 0x29, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
+  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
+  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xeb, 0x17, 0x16,
+  0xe3, 0xce, 0xcd, 0xe5, 0x17, 0x17, 0x74, 0x22, 0x24, 0xaa, 0xac, 0xab,
+  0xab, 0x24, 0x22, 0x00, 0x00, 0x05, 0x00, 0xc3, 0xfe, 0x14, 0x06, 0xb9,
+  0x07, 0x6d, 0x00, 0x11, 0x00, 0x1b, 0x00, 0x31, 0x00, 0x3d, 0x00, 0x49,
+  0x00, 0x00, 0x01, 0x22, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23,
+  0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
+  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
+  0x22, 0x35, 0x11, 0x34, 0x02, 0xaf, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c,
+  0x8e, 0x8f, 0x8d, 0x4e, 0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d,
+  0x4d, 0x56, 0x58, 0x01, 0x61, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11,
+  0x71, 0xfe, 0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31,
+  0xfd, 0x5e, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x03, 0x2c, 0x01, 0xd7, 0xda, 0xdb, 0xd7,
+  0xd7, 0xdb, 0xa5, 0xc9, 0x28, 0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e,
+  0x9e, 0xfe, 0x90, 0x9e, 0xfe, 0x30, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
+  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
+  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x15, 0x00, 0x21, 0x00, 0x2d,
+  0x00, 0x38, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x09, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x17, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11,
+  0x23, 0x04, 0x51, 0x14, 0x31, 0x38, 0x4c, 0x7d, 0x38, 0x11, 0x71, 0xfe,
+  0xe4, 0xfe, 0xe0, 0x71, 0x12, 0x38, 0x7c, 0x4e, 0x36, 0x31, 0xfd, 0x4f,
+  0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8,
+  0xfb, 0xba, 0xd8, 0xd8, 0x72, 0x01, 0x46, 0x94, 0xfe, 0x91, 0x01, 0x8c,
+  0x96, 0xfe, 0x9f, 0x72, 0x01, 0xb6, 0x76, 0x3e, 0x47, 0x95, 0x2d, 0x3b,
+  0x9e, 0x9f, 0xfe, 0x6e, 0x01, 0x92, 0x9d, 0xa0, 0x3b, 0x2d, 0x95, 0x47,
+  0x41, 0x04, 0xcc, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0xfe, 0x9f, 0x01,
+  0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe, 0x6d, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06,
+  0x00, 0x12, 0x00, 0x1e, 0x00, 0x21, 0x00, 0x29, 0x00, 0x00, 0x01, 0x30,
+  0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
+  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
+  0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x03, 0x33, 0x03, 0x33, 0x01, 0x23,
+  0x27, 0x21, 0x07, 0x23, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f,
+  0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01,
+  0x04, 0x77, 0x3d, 0xfe, 0xd7, 0x3d, 0x77, 0x02, 0xf9, 0xfd, 0xf2, 0xfd,
+  0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79,
+  0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac,
+  0xfe, 0x55, 0x02, 0x0f, 0xfc, 0xbc, 0xda, 0xda, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
+  0x00, 0x37, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01,
+  0x21, 0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34, 0x26, 0x23, 0x22,
+  0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x01, 0x06,
+  0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x01, 0x75, 0x01, 0x7d, 0xfd, 0xe6, 0x1f, 0x38, 0x01, 0x36, 0x5e,
+  0x4c, 0x2f, 0x6e, 0x41, 0x46, 0x77, 0x34, 0x82, 0x9d, 0xfe, 0xd6, 0x33,
+  0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8,
+  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
+  0x07, 0x79, 0xf0, 0xfc, 0x3f, 0x72, 0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e,
+  0x42, 0x51, 0x23, 0x23, 0x7b, 0x1c, 0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4,
+  0x30, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x47, 0x00, 0x00,
+  0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14,
+  0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11,
+  0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x1e, 0x01, 0x15, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35,
+  0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x02, 0x57, 0x53, 0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f, 0x2f, 0x6b,
+  0x3c, 0x62, 0x6c, 0x64, 0x61, 0x4d, 0x54, 0x55, 0x57, 0x5a, 0x55, 0x24,
+  0x5c, 0x49, 0x42, 0x73, 0x31, 0x82, 0x98, 0x51, 0x02, 0xf9, 0xfd, 0xf2,
+  0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
+  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd,
+  0x91, 0x12, 0x6d, 0x52, 0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f,
+  0x46, 0x4a, 0x4c, 0x6c, 0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11,
+  0x12, 0x76, 0x63, 0x45, 0x60, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
+  0x00, 0x21, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01,
+  0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34,
+  0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11,
+  0x34, 0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15, 0x23,
+  0x35, 0x21, 0x35, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe,
+  0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
+  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95,
+  0x7a, 0x7a, 0x81, 0xfe, 0x8b, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02,
+  0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe, 0x5d,
+  0x02, 0x1c, 0xfd, 0xe4, 0x6d, 0xba, 0xba, 0x79, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
+  0x00, 0x3f, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17,
+  0x21, 0x15, 0x21, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16, 0x33,
+  0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x04, 0x4f, 0x01, 0x70,
+  0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
+  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb,
+  0xfe, 0xa0, 0x19, 0x1a, 0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e,
+  0x36, 0x72, 0x3b, 0x33, 0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f,
+  0x5d, 0x31, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a,
+  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
+  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04, 0x4d,
+  0x4c, 0x83, 0x87, 0x4b, 0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d, 0x66,
+  0xae, 0x66, 0x14, 0x15, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x2e, 0x00, 0x4e,
+  0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15,
+  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
+  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x04, 0x4f, 0x01,
+  0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
+  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x0d,
+  0x4f, 0x2e, 0x2e, 0x2e, 0x2e, 0x4f, 0x4e, 0x2e, 0x2e, 0x2e, 0x2e, 0x9a,
+  0x2c, 0x2d, 0x2d, 0x2c, 0x73, 0x3e, 0x3d, 0x09, 0x22, 0x34, 0x34, 0x3d,
+  0x83, 0x4b, 0x4c, 0x4f, 0x4f, 0x82, 0x97, 0x9e, 0x61, 0x61, 0xa4, 0x2c,
+  0x2d, 0x2d, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a,
+  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
+  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x9e, 0x34, 0x35, 0x5b, 0x5a, 0x34,
+  0x35, 0x35, 0x34, 0x5a, 0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14, 0x0a,
+  0x0b, 0x4b, 0x4c, 0x99, 0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f, 0x4f,
+  0x4e, 0xde, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
+  0x00, 0x25, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17,
+  0x21, 0x15, 0x01, 0x23, 0x01, 0x21, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90,
+  0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7,
+  0x7a, 0x01, 0x27, 0xfe, 0x61, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02,
+  0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78,
+  0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc, 0xed,
+  0x02, 0xe4, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x2b, 0x00, 0x49,
+  0x00, 0x58, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x00,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x34, 0x2f,
+  0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x20, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x14, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x04, 0x4f, 0x01,
+  0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
+  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x55,
+  0xa8, 0x2f, 0x30, 0x5f, 0x54, 0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29,
+  0x2a, 0x93, 0x01, 0x02, 0x4a, 0x48, 0x29, 0x2a, 0x4b, 0x51, 0x32, 0x30,
+  0x4c, 0x4e, 0x8e, 0x8f, 0x4d, 0x4d, 0x30, 0x30, 0x29, 0x2a, 0x29, 0x4d,
+  0x49, 0x2c, 0x2b, 0x2b, 0x2a, 0x96, 0x2b, 0x2a, 0x02, 0xf9, 0xfd, 0xf2,
+  0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
+  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd,
+  0x5b, 0x2c, 0x2b, 0x4b, 0x4c, 0x56, 0x2c, 0x2b, 0x96, 0x2b, 0x5d, 0x12,
+  0x31, 0x32, 0x48, 0x64, 0x74, 0x3a, 0x3a, 0x64, 0x4a, 0x30, 0x31, 0x12,
+  0x12, 0x3a, 0x37, 0x50, 0x79, 0x41, 0x41, 0x41, 0x41, 0x79, 0x4e, 0x39,
+  0x38, 0xc6, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x41, 0x3f, 0x26, 0x25, 0x25,
+  0x24, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x3e, 0x00, 0x4d,
+  0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15,
+  0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32,
+  0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x35, 0x16,
+  0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x04, 0x4f, 0x01, 0x70,
+  0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c,
+  0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x10, 0x2c,
+  0x2d, 0x2d, 0x2b, 0x74, 0x3d, 0x3d, 0x09, 0x20, 0x36, 0x33, 0x3e, 0x82,
+  0x97, 0x4e, 0x50, 0x82, 0x96, 0x4f, 0x4f, 0x60, 0x62, 0xa4, 0x2c, 0x2d,
+  0x2d, 0xb8, 0x4f, 0x5c, 0x2e, 0x2e, 0x4f, 0x4c, 0x30, 0x2f, 0x2f, 0x2e,
+  0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8,
+  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
+  0x07, 0x79, 0xf0, 0xfb, 0xdf, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a,
+  0x2f, 0x1b, 0x1a, 0x98, 0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6,
+  0x75, 0x76, 0x08, 0x09, 0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35,
+  0x34, 0x5a, 0x5c, 0x34, 0x34, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
+  0x00, 0x2c, 0x00, 0x38, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01,
+  0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35,
+  0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22,
+  0x35, 0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33, 0x11,
+  0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x03, 0x86, 0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e,
+  0x6d, 0x76, 0x99, 0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e,
+  0x7b, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78,
+  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
+  0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56, 0x56,
+  0x56, 0x56, 0xad, 0xac, 0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde, 0xd4,
+  0xd3, 0xde, 0xfc, 0xac, 0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06,
+  0x00, 0x12, 0x00, 0x1e, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01,
+  0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35,
+  0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22,
+  0x35, 0x11, 0x34, 0x05, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x36, 0x35, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f,
+  0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46,
+  0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x87, 0x72, 0x3b, 0x39, 0x81, 0x2c,
+  0x24, 0x4c, 0x3f, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06,
+  0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
+  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0, 0xfd, 0xdc, 0x95, 0x46, 0x45,
+  0x60, 0x54, 0x6c, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e, 0x00, 0x38, 0x00, 0x00,
+  0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01, 0x22, 0x15, 0x11, 0x14,
+  0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11,
+  0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x0e, 0x01, 0x23, 0x22,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01, 0x23,
+  0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x04, 0x4f, 0x01,
+  0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
+  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xe9,
+  0x2c, 0x5b, 0x33, 0xa3, 0xb4, 0xb5, 0xa2, 0x33, 0x5c, 0x2b, 0x2a, 0x5f,
+  0x31, 0x70, 0x6f, 0x6e, 0x71, 0x31, 0x60, 0x29, 0x02, 0xf9, 0xfd, 0xf2,
+  0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
+  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb,
+  0xeb, 0x17, 0x16, 0xe3, 0xce, 0xcd, 0xe5, 0x17, 0x17, 0x74, 0x22, 0x24,
+  0xaa, 0xac, 0xab, 0xab, 0x24, 0x22, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x18, 0x00, 0x22,
+  0x00, 0x2e, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01,
+  0x30, 0x03, 0x22, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23, 0x22,
+  0x06, 0x10, 0x16, 0x33, 0x32, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21,
+  0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23,
+  0x21, 0x22, 0x35, 0x11, 0x34, 0x04, 0x4f, 0x01, 0x70, 0xfe, 0x90, 0xfe,
+  0x8f, 0x2f, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c, 0x8e, 0x8f, 0x8d, 0x4e,
+  0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d, 0x4d, 0x56, 0x58, 0xfe,
+  0x9c, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
+  0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06,
+  0x02, 0x41, 0x01, 0xd7, 0xda, 0xdb, 0xd7, 0xd7, 0xdb, 0xa5, 0xc9, 0x28,
+  0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e, 0x9e, 0xfe, 0x90, 0x9e, 0x03,
+  0x6f, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
+  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x06, 0x00, 0x12, 0x00, 0x1e,
+  0x00, 0x29, 0x00, 0x00, 0x01, 0x30, 0x09, 0x01, 0x30, 0x01, 0x30, 0x01,
+  0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25,
+  0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x17,
+  0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x04, 0x4f,
+  0x01, 0x70, 0xfe, 0x90, 0xfe, 0x8f, 0xfe, 0xae, 0x6c, 0x6c, 0x04, 0x46,
+  0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8,
+  0x72, 0x01, 0x46, 0x94, 0xfe, 0x91, 0x01, 0x8c, 0x96, 0xfe, 0x9f, 0x72,
+  0x02, 0xf9, 0xfd, 0xf2, 0xfd, 0xfa, 0x02, 0x06, 0x06, 0x0a, 0x78, 0xf8,
+  0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0,
+  0x07, 0x79, 0xf0, 0xf0, 0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42,
+  0x01, 0x93, 0xfe, 0x6d, 0x00, 0x03, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x09, 0x00, 0x15, 0x00, 0x21, 0x00, 0x00, 0x01, 0x13,
+  0x21, 0x01, 0x13, 0x09, 0x01, 0x13, 0x01, 0x21, 0x01, 0x22, 0x15, 0x11,
+  0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15,
+  0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x03, 0xaf, 0x80, 0x01,
+  0xa3, 0xfe, 0xae, 0x81, 0xfe, 0xae, 0xfe, 0xad, 0x82, 0xfe, 0xae, 0x01,
+  0xa2, 0xfe, 0x5e, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
+  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x05, 0x31, 0xfe, 0x47, 0xfe, 0xef,
+  0xfe, 0x47, 0x01, 0x11, 0xfe, 0xef, 0x01, 0xb9, 0x01, 0x11, 0x03, 0x7d,
+  0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87,
+  0xf0, 0xf0, 0x07, 0x79, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
+  0x00, 0x3e, 0x00, 0x46, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34,
+  0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33,
+  0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14,
+  0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x03, 0x33, 0x03, 0x33, 0x01,
+  0x23, 0x27, 0x21, 0x07, 0x23, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17,
+  0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44,
+  0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c,
+  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
+  0xba, 0xd8, 0x02, 0x10, 0x78, 0xf1, 0xbd, 0x8a, 0x01, 0x04, 0x77, 0x3d,
+  0xfe, 0xd7, 0x3d, 0x77, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43,
+  0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13,
+  0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07,
+  0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8,
+  0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfe, 0xac, 0xfe, 0x55, 0x02, 0x0f,
+  0xfc, 0xbc, 0xda, 0xda, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x54, 0x00, 0x00,
+  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x01, 0x21, 0x15, 0x21, 0x35, 0x36, 0x37, 0x00, 0x35, 0x34, 0x26, 0x23,
+  0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14, 0x01,
+  0x06, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a,
+  0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84,
+  0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
+  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x75,
+  0x01, 0x7d, 0xfd, 0xe6, 0x1f, 0x38, 0x01, 0x36, 0x5e, 0x4c, 0x2f, 0x6e,
+  0x41, 0x46, 0x77, 0x34, 0x82, 0x9d, 0xfe, 0xd6, 0x33, 0xfc, 0x4c, 0xfb,
+  0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a,
+  0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01,
+  0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
+  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfc,
+  0x3f, 0x72, 0x6e, 0x1f, 0x38, 0x01, 0x31, 0x5e, 0x42, 0x51, 0x23, 0x23,
+  0x7b, 0x1c, 0x1c, 0x84, 0x6c, 0x8b, 0xfe, 0xe4, 0x30, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x64, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26,
+  0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11,
+  0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15,
+  0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x1e, 0x01, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x36, 0x35, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x07, 0x35, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x06, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a,
+  0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84,
+  0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
+  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x57,
+  0x53, 0x5b, 0xab, 0x9f, 0x33, 0x71, 0x3f, 0x2f, 0x6b, 0x3c, 0x62, 0x6c,
+  0x64, 0x61, 0x4d, 0x54, 0x55, 0x57, 0x5a, 0x55, 0x24, 0x5c, 0x49, 0x42,
+  0x73, 0x31, 0x82, 0x98, 0x51, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c,
+  0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82,
+  0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c,
+  0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
+  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x91, 0x12, 0x6d, 0x52,
+  0x7c, 0x86, 0x15, 0x14, 0x79, 0x1b, 0x1a, 0x4f, 0x46, 0x4a, 0x4c, 0x6c,
+  0x3f, 0x3c, 0x3a, 0x3d, 0x12, 0x17, 0x73, 0x11, 0x12, 0x76, 0x63, 0x45,
+  0x60, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x3e, 0x00, 0x49,
+  0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
+  0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x09, 0x01, 0x21, 0x03, 0x33, 0x11, 0x33, 0x15, 0x23, 0x15,
+  0x23, 0x35, 0x21, 0x35, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83,
+  0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a,
+  0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c,
+  0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba,
+  0xd8, 0x02, 0x4d, 0xfe, 0xe9, 0x01, 0x17, 0x14, 0x95, 0x7a, 0x7a, 0x81,
+  0xfe, 0x8b, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34,
+  0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24,
+  0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78,
+  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
+  0xf0, 0x07, 0x79, 0xf0, 0xfe, 0x97, 0xfe, 0x5d, 0x02, 0x1c, 0xfd, 0xe4,
+  0x6d, 0xba, 0xba, 0x79, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x5c, 0x00, 0x00,
+  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x17, 0x21, 0x15, 0x21, 0x15, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x26, 0x27, 0x35, 0x16, 0x17, 0x16,
+  0x33, 0x32, 0x36, 0x34, 0x26, 0x23, 0x22, 0x06, 0x07, 0x03, 0xe6, 0x33,
+  0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01,
+  0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42,
+  0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
+  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xfc, 0x01, 0xcb, 0xfe, 0xa0, 0x19,
+  0x1a, 0x1a, 0x19, 0x91, 0x54, 0x55, 0x57, 0x57, 0x9e, 0x36, 0x72, 0x3b,
+  0x33, 0x38, 0x38, 0x3e, 0x64, 0x75, 0x75, 0x64, 0x2f, 0x5d, 0x31, 0xfc,
+  0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13,
+  0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46,
+  0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78,
+  0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79,
+  0xf0, 0xf0, 0x5f, 0xcc, 0x09, 0x04, 0x04, 0x4d, 0x4c, 0x83, 0x87, 0x4b,
+  0x4a, 0x12, 0x12, 0x71, 0x1b, 0x0e, 0x0d, 0x66, 0xae, 0x66, 0x14, 0x15,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x4b, 0x00, 0x6b, 0x00, 0x00, 0x05, 0x36,
+  0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22,
+  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
+  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x22,
+  0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x13, 0x15, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x03, 0xe6,
+  0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70,
+  0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98,
+  0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x0d, 0x4f, 0x2e, 0x2e,
+  0x2e, 0x2e, 0x4f, 0x4e, 0x2e, 0x2e, 0x2e, 0x2e, 0x9a, 0x2c, 0x2d, 0x2d,
+  0x2c, 0x73, 0x3e, 0x3d, 0x09, 0x22, 0x34, 0x34, 0x3d, 0x83, 0x4b, 0x4c,
+  0x4f, 0x4f, 0x82, 0x97, 0x9e, 0x61, 0x61, 0xa4, 0x2c, 0x2d, 0x2d, 0xfc,
+  0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13,
+  0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46,
+  0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78,
+  0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79,
+  0xf0, 0xfd, 0x9e, 0x34, 0x35, 0x5b, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a,
+  0x5b, 0x35, 0x34, 0x01, 0x62, 0x67, 0x14, 0x0a, 0x0b, 0x4b, 0x4c, 0x99,
+  0x31, 0x1a, 0x1a, 0x4c, 0x4d, 0x84, 0x7f, 0x4f, 0x4e, 0xde, 0xd4, 0xc6,
+  0x75, 0x76, 0x08, 0x09, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x42, 0x00, 0x00,
+  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x17, 0x21, 0x15, 0x01, 0x23, 0x01, 0x21, 0x03, 0xe6, 0x33, 0x40, 0x99,
+  0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70,
+  0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd,
+  0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8,
+  0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x02, 0x2b, 0xfe, 0xc7, 0x7a, 0x01, 0x27,
+  0xfe, 0x61, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34,
+  0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24,
+  0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78,
+  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
+  0xf0, 0x07, 0x79, 0xf0, 0xf0, 0x30, 0xfc, 0xed, 0x02, 0xe4, 0x00, 0x00,
+  0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x48, 0x00, 0x66, 0x00, 0x75, 0x00, 0x00,
+  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x37, 0x36, 0x34,
+  0x2f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x34, 0x36, 0x20, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x22, 0x07, 0x06, 0x03, 0xe6,
+  0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70,
+  0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98,
+  0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0x55, 0xa8, 0x2f, 0x30,
+  0x5f, 0x54, 0x53, 0x30, 0x30, 0x30, 0xf8, 0x4c, 0x29, 0x2a, 0x93, 0x01,
+  0x02, 0x4a, 0x48, 0x29, 0x2a, 0x4b, 0x51, 0x32, 0x30, 0x4c, 0x4e, 0x8e,
+  0x8f, 0x4d, 0x4d, 0x30, 0x30, 0x29, 0x2a, 0x29, 0x4d, 0x49, 0x2c, 0x2b,
+  0x2b, 0x2a, 0x96, 0x2b, 0x2a, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c,
+  0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82,
+  0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c,
+  0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
+  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfd, 0x5b, 0x2c, 0x2b, 0x4b,
+  0x4c, 0x56, 0x2c, 0x2b, 0x96, 0x2b, 0x5d, 0x12, 0x31, 0x32, 0x48, 0x64,
+  0x74, 0x3a, 0x3a, 0x64, 0x4a, 0x30, 0x31, 0x12, 0x12, 0x3a, 0x37, 0x50,
+  0x79, 0x41, 0x41, 0x41, 0x41, 0x79, 0x4e, 0x39, 0x38, 0xc6, 0x3f, 0x26,
+  0x25, 0x25, 0x24, 0x41, 0x3f, 0x26, 0x25, 0x25, 0x24, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x5b, 0x00, 0x6a, 0x00, 0x00, 0x05, 0x36,
+  0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22,
+  0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21,
+  0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x35,
+  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x13, 0x32, 0x36, 0x35, 0x34, 0x27,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x03, 0xe6, 0x33,
+  0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01,
+  0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42,
+  0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04,
+  0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x01, 0x10, 0x2c, 0x2d, 0x2d, 0x2b,
+  0x74, 0x3d, 0x3d, 0x09, 0x20, 0x36, 0x33, 0x3e, 0x82, 0x97, 0x4e, 0x50,
+  0x82, 0x96, 0x4f, 0x4f, 0x60, 0x62, 0xa4, 0x2c, 0x2d, 0x2d, 0xb8, 0x4f,
+  0x5c, 0x2e, 0x2e, 0x4f, 0x4c, 0x30, 0x2f, 0x2f, 0x2e, 0xfc, 0x4c, 0xfb,
+  0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a,
+  0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01,
+  0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
+  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb,
+  0xdf, 0x67, 0x14, 0x0b, 0x0a, 0x4b, 0x4b, 0x9a, 0x2f, 0x1b, 0x1a, 0x98,
+  0x84, 0x81, 0x4d, 0x4e, 0x6f, 0x6f, 0xd4, 0xc6, 0x75, 0x76, 0x08, 0x09,
+  0x01, 0x72, 0x68, 0x5c, 0x5a, 0x34, 0x35, 0x35, 0x34, 0x5a, 0x5c, 0x34,
+  0x34, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x49, 0x00, 0x55,
+  0x00, 0x5c, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15,
+  0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
+  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
+  0x22, 0x35, 0x11, 0x34, 0x00, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x01, 0x11, 0x07, 0x35, 0x37, 0x33,
+  0x11, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a,
+  0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84,
+  0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c,
+  0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x03, 0x86,
+  0x80, 0x2d, 0x2e, 0x2e, 0x2d, 0x80, 0x2d, 0x2e, 0x2e, 0x6d, 0x76, 0x99,
+  0x99, 0x76, 0x92, 0x7e, 0x7e, 0xfe, 0x9c, 0x78, 0x7e, 0x7b, 0xfc, 0x4c,
+  0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82,
+  0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c,
+  0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78,
+  0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0,
+  0xfe, 0xc8, 0x56, 0x56, 0xac, 0xad, 0x56, 0x56, 0x56, 0x56, 0xad, 0xac,
+  0x56, 0xaf, 0xde, 0xd3, 0xd4, 0xde, 0xde, 0xd4, 0xd3, 0xde, 0xfc, 0xac,
+  0x02, 0xd1, 0x29, 0x74, 0x27, 0xfc, 0xbd, 0x00, 0x00, 0x04, 0x00, 0xb4,
+  0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
+  0x00, 0x48, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15,
+  0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
+  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
+  0x22, 0x35, 0x11, 0x34, 0x05, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x36, 0x35, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30, 0x17,
+  0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44,
+  0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c,
+  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
+  0xba, 0xd8, 0x01, 0x87, 0x72, 0x3b, 0x39, 0x81, 0x2c, 0x24, 0x4c, 0x3f,
+  0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d,
+  0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92,
+  0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87,
+  0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07,
+  0x79, 0xf0, 0xf0, 0xfd, 0xdc, 0x95, 0x46, 0x45, 0x60, 0x54, 0x6c, 0x00,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x55, 0x00, 0x00, 0x05, 0x36, 0x35, 0x06,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x26,
+  0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17, 0x01, 0x22, 0x15, 0x11,
+  0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15,
+  0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34, 0x01, 0x0e, 0x01, 0x23,
+  0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x15, 0x2e, 0x01,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x37, 0x03, 0xe6,
+  0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70,
+  0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98,
+  0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba,
+  0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0x02, 0xe9, 0x2c, 0x5b, 0x33,
+  0xa3, 0xb4, 0xb5, 0xa2, 0x33, 0x5c, 0x2b, 0x2a, 0x5f, 0x31, 0x70, 0x6f,
+  0x6e, 0x71, 0x31, 0x60, 0x29, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c,
+  0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82,
+  0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c,
+  0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0,
+  0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xeb, 0x17, 0x16, 0xe3,
+  0xce, 0xcd, 0xe5, 0x17, 0x17, 0x74, 0x22, 0x24, 0xaa, 0xac, 0xab, 0xab,
+  0x24, 0x22, 0x00, 0x00, 0x00, 0x05, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x4d, 0x00, 0x57,
+  0x00, 0x00, 0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
+  0x14, 0x17, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11,
+  0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35,
+  0x11, 0x34, 0x01, 0x22, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x07, 0x17, 0x07, 0x12, 0x10, 0x26, 0x23,
+  0x22, 0x06, 0x10, 0x16, 0x33, 0x32, 0x03, 0xe6, 0x33, 0x40, 0x99, 0x30,
+  0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d, 0x70, 0x01, 0xa9, 0x70, 0x2c,
+  0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30, 0x98, 0x42, 0x34, 0xfd, 0x1b,
+  0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8,
+  0xfb, 0xba, 0xd8, 0x01, 0xfb, 0x04, 0x0f, 0x05, 0x8e, 0x8b, 0x8c, 0x8e,
+  0x8f, 0x8d, 0x4e, 0x4f, 0x71, 0x55, 0x09, 0x4c, 0x58, 0x56, 0x4d, 0x4d,
+  0x56, 0x58, 0xfc, 0x4c, 0xfb, 0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34,
+  0x24, 0x8d, 0x13, 0x82, 0x6a, 0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24,
+  0x34, 0x92, 0x46, 0x0c, 0x01, 0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78,
+  0xf8, 0x87, 0x78, 0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0,
+  0xf0, 0x07, 0x79, 0xf0, 0xfb, 0xbf, 0x01, 0xd7, 0xda, 0xdb, 0xd7, 0xd7,
+  0xdb, 0xa5, 0xc9, 0x28, 0x6a, 0x38, 0x01, 0x80, 0x01, 0x70, 0x9e, 0x9e,
+  0xfe, 0x90, 0x9e, 0x00, 0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa,
+  0x07, 0x6d, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x46, 0x00, 0x00,
+  0x05, 0x36, 0x35, 0x06, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x26, 0x35, 0x34, 0x20, 0x15, 0x14, 0x07, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x14, 0x17,
+  0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32, 0x35, 0x11, 0x34, 0x23,
+  0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21, 0x22, 0x35, 0x11, 0x34,
+  0x17, 0x33, 0x11, 0x01, 0x33, 0x09, 0x01, 0x23, 0x01, 0x11, 0x23, 0x03,
+  0xe6, 0x33, 0x40, 0x99, 0x30, 0x17, 0x83, 0x0e, 0x39, 0x9a, 0x43, 0x2d,
+  0x70, 0x01, 0xa9, 0x70, 0x2c, 0x44, 0x9a, 0x38, 0x0f, 0x84, 0x16, 0x30,
+  0x98, 0x42, 0x34, 0xfd, 0x1b, 0x6c, 0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb,
+  0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb, 0xba, 0xd8, 0xd8, 0x72, 0x01, 0x46,
+  0x94, 0xfe, 0x91, 0x01, 0x8c, 0x96, 0xfe, 0x9f, 0x72, 0xfc, 0x4c, 0xfb,
+  0xc3, 0x03, 0x01, 0x0c, 0x43, 0x95, 0x34, 0x24, 0x8d, 0x13, 0x82, 0x6a,
+  0xea, 0xea, 0x6a, 0x82, 0x13, 0x8d, 0x24, 0x34, 0x92, 0x46, 0x0c, 0x01,
+  0x05, 0xc5, 0xfb, 0x4c, 0x07, 0xf1, 0x78, 0xf8, 0x87, 0x78, 0x78, 0x07,
+  0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79, 0xf0, 0xf0,
+  0xfe, 0x9f, 0x01, 0x61, 0xfe, 0x7a, 0xfe, 0x42, 0x01, 0x93, 0xfe, 0x6d,
+  0x00, 0x04, 0x00, 0xb4, 0xfe, 0x14, 0x06, 0xaa, 0x07, 0x6d, 0x00, 0x09,
+  0x00, 0x13, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x00, 0x01, 0x03, 0x21, 0x17,
+  0x03, 0x37, 0x17, 0x03, 0x37, 0x21, 0x03, 0x13, 0x05, 0x01, 0x13, 0x25,
+  0x05, 0x13, 0x01, 0x25, 0x01, 0x22, 0x15, 0x11, 0x14, 0x33, 0x21, 0x32,
+  0x35, 0x11, 0x34, 0x23, 0x25, 0x21, 0x32, 0x15, 0x11, 0x14, 0x23, 0x21,
+  0x22, 0x35, 0x11, 0x34, 0x03, 0xaf, 0x5a, 0xfe, 0xdd, 0xeb, 0x5b, 0xed,
+  0xeb, 0x59, 0xeb, 0xfe, 0xdb, 0x58, 0x9c, 0x01, 0x87, 0xfe, 0xd8, 0x57,
+  0xfe, 0xae, 0xfe, 0xad, 0x58, 0xfe, 0xd8, 0x01, 0x88, 0xfe, 0x78, 0x6c,
+  0x6c, 0x04, 0x46, 0x6c, 0x6c, 0xfb, 0xba, 0x04, 0x46, 0xd8, 0xd8, 0xfb,
+  0xba, 0xd8, 0x04, 0x6e, 0xfe, 0xce, 0xbe, 0xfe, 0xcd, 0xbe, 0xbe, 0x01,
+  0x33, 0xbe, 0x01, 0xf5, 0xfe, 0x6f, 0x28, 0xfe, 0xe2, 0xfe, 0x54, 0xdf,
+  0xdf, 0x01, 0xa8, 0x01, 0x22, 0x28, 0x03, 0x55, 0x78, 0xf8, 0x87, 0x78,
+  0x78, 0x07, 0x79, 0x78, 0x78, 0xf0, 0xf8, 0x87, 0xf0, 0xf0, 0x07, 0x79,
+  0xf0, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x89, 0xff, 0x6a, 0x06, 0xf9,
+  0x07, 0x56, 0x00, 0x07, 0x00, 0x11, 0x00, 0x19, 0x00, 0x23, 0x00, 0x2b,
+  0x00, 0x33, 0x00, 0x7f, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x34, 0x36, 0x32,
+  0x16, 0x14, 0x06, 0x22, 0x37, 0x22, 0x06, 0x15, 0x14, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x24, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32, 0x17, 0x22,
+  0x06, 0x15, 0x14, 0x33, 0x32, 0x36, 0x35, 0x34, 0x00, 0x34, 0x36, 0x32,
+  0x16, 0x14, 0x06, 0x22, 0x36, 0x14, 0x06, 0x22, 0x26, 0x34, 0x36, 0x32,
+  0x06, 0x32, 0x3e, 0x03, 0x37, 0x13, 0x17, 0x07, 0x3e, 0x04, 0x35, 0x34,
+  0x26, 0x27, 0x26, 0x27, 0x3e, 0x01, 0x35, 0x34, 0x26, 0x23, 0x22, 0x0e,
+  0x01, 0x15, 0x14, 0x17, 0x07, 0x26, 0x35, 0x34, 0x37, 0x26, 0x22, 0x07,
+  0x16, 0x15, 0x14, 0x07, 0x27, 0x36, 0x35, 0x34, 0x2e, 0x01, 0x23, 0x22,
+  0x06, 0x15, 0x14, 0x16, 0x17, 0x06, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x1e,
+  0x03, 0x17, 0x27, 0x37, 0x13, 0x1e, 0x03, 0x12, 0x32, 0x17, 0x3e, 0x01,
+  0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x16, 0x15, 0x14, 0x0e, 0x02, 0x07,
+  0x05, 0x07, 0x25, 0x07, 0x06, 0x07, 0x05, 0x07, 0x25, 0x0e, 0x01, 0x22,
+  0x26, 0x27, 0x05, 0x27, 0x25, 0x26, 0x2f, 0x01, 0x05, 0x27, 0x25, 0x2e,
+  0x03, 0x35, 0x34, 0x37, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17,
+  0x02, 0x9c, 0x3b, 0x53, 0x3b, 0x3b, 0x53, 0x69, 0x10, 0x28, 0x0c, 0x0f,
+  0x29, 0x01, 0x84, 0x3b, 0x53, 0x3c, 0x3c, 0x53, 0x14, 0x0f, 0x28, 0x0c,
+  0x10, 0x28, 0xfe, 0x97, 0x14, 0x1d, 0x14, 0x14, 0x1d, 0xd4, 0x13, 0x1d,
+  0x14, 0x14, 0x1d, 0x91, 0x61, 0x46, 0x29, 0x19, 0x08, 0x02, 0x0e, 0x79,
+  0x0b, 0x35, 0x66, 0x67, 0x4e, 0x30, 0x3c, 0x32, 0x2b, 0x3a, 0x41, 0x58,
+  0x58, 0x47, 0x4b, 0x74, 0x3d, 0x10, 0x75, 0x14, 0x01, 0x26, 0x97, 0x26,
+  0x01, 0x15, 0x75, 0x10, 0x3c, 0x75, 0x4b, 0x47, 0x58, 0x58, 0x42, 0x3b,
+  0x2b, 0x31, 0x3d, 0x31, 0x4d, 0x68, 0x66, 0x35, 0x0b, 0x78, 0x0f, 0x02,
+  0x08, 0x18, 0x29, 0x33, 0x89, 0x44, 0x27, 0xb5, 0x81, 0x7d, 0x9c, 0x54,
+  0x8d, 0x44, 0x76, 0x89, 0x50, 0x01, 0x76, 0x04, 0xfe, 0x22, 0x01, 0x02,
+  0x04, 0x01, 0xc9, 0x14, 0xfe, 0x3f, 0x1d, 0x98, 0xe1, 0x98, 0x1d, 0xfe,
+  0x3f, 0x14, 0x01, 0xc8, 0x03, 0x02, 0x01, 0xfe, 0x21, 0x04, 0x01, 0x76,
+  0x50, 0x89, 0x76, 0x43, 0x8c, 0x54, 0x9c, 0x7d, 0x81, 0xb6, 0x26, 0x03,
+  0x38, 0x90, 0x67, 0x67, 0x90, 0x67, 0x82, 0x3d, 0x18, 0x12, 0x3e, 0x18,
+  0x11, 0x75, 0x90, 0x67, 0x67, 0x90, 0x67, 0xdc, 0x3d, 0x18, 0x12, 0x3e,
+  0x18, 0x11, 0xfd, 0x22, 0x36, 0x27, 0x27, 0x36, 0x27, 0x5d, 0x36, 0x27,
+  0x27, 0x36, 0x27, 0xe0, 0x24, 0x39, 0x5d, 0x57, 0x3e, 0x01, 0x3a, 0x06,
+  0xfb, 0x1f, 0x4c, 0x6b, 0x74, 0x93, 0x4c, 0x4a, 0x98, 0x37, 0x33, 0x28,
+  0x23, 0x83, 0x58, 0x51, 0x69, 0x6b, 0xa4, 0x5c, 0x42, 0x3f, 0x26, 0x53,
+  0x54, 0x1b, 0x0e, 0x03, 0x03, 0x0e, 0x1b, 0x54, 0x53, 0x26, 0x3f, 0x42,
+  0x5c, 0xa4, 0x6b, 0x69, 0x51, 0x58, 0x83, 0x23, 0x28, 0x33, 0x37, 0x98,
+  0x4a, 0x4c, 0x93, 0x74, 0x6b, 0x4c, 0x1f, 0xfb, 0x06, 0xfe, 0xc6, 0x3e,
+  0x57, 0x5d, 0x39, 0x06, 0x02, 0x06, 0x86, 0xbe, 0xb7, 0x8c, 0x8a, 0x72,
+  0xac, 0xc8, 0x6c, 0xc8, 0xa1, 0x7e, 0x33, 0x1a, 0x44, 0x23, 0x01, 0x1f,
+  0x1f, 0xae, 0x40, 0xac, 0x6d, 0x8a, 0x8a, 0x6d, 0xac, 0x40, 0xae, 0x1f,
+  0x1f, 0x01, 0x23, 0x44, 0x1a, 0x33, 0x7e, 0xa1, 0xc8, 0x6c, 0xc8, 0xac,
+  0x72, 0x8a, 0x8c, 0xb7, 0xbe, 0x86, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x43,
+  0xff, 0x6a, 0x08, 0x43, 0x06, 0x8a, 0x00, 0x09, 0x00, 0x14, 0x00, 0x18,
+  0x00, 0x22, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x8e, 0x00, 0x99, 0x00, 0x9f,
+  0x00, 0xfd, 0x01, 0x07, 0x00, 0x00, 0x01, 0x22, 0x26, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x14, 0x06, 0x27, 0x32, 0x36, 0x35, 0x34, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x33, 0x15, 0x23, 0x01, 0x22, 0x26, 0x34, 0x36,
+  0x33, 0x32, 0x16, 0x14, 0x06, 0x01, 0x37, 0x17, 0x07, 0x27, 0x37, 0x01,
+  0x15, 0x23, 0x35, 0x25, 0x17, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x1e,
+  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27,
+  0x37, 0x16, 0x17, 0x3e, 0x04, 0x37, 0x16, 0x33, 0x32, 0x3e, 0x04, 0x37,
+  0x3e, 0x01, 0x35, 0x34, 0x27, 0x2e, 0x04, 0x23, 0x22, 0x0e, 0x02, 0x0f,
+  0x01, 0x06, 0x07, 0x2e, 0x01, 0x20, 0x06, 0x07, 0x26, 0x2f, 0x01, 0x2e,
+  0x03, 0x23, 0x22, 0x0e, 0x03, 0x07, 0x06, 0x15, 0x14, 0x16, 0x17, 0x1e,
+  0x05, 0x33, 0x32, 0x37, 0x1e, 0x04, 0x17, 0x36, 0x25, 0x32, 0x36, 0x35,
+  0x34, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x01, 0x07, 0x17, 0x07, 0x27,
+  0x37, 0x01, 0x34, 0x37, 0x27, 0x26, 0x27, 0x23, 0x22, 0x2e, 0x06, 0x27,
+  0x2e, 0x01, 0x35, 0x34, 0x3e, 0x01, 0x37, 0x3e, 0x01, 0x33, 0x32, 0x1e,
+  0x02, 0x17, 0x16, 0x1f, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17,
+  0x37, 0x36, 0x37, 0x3e, 0x03, 0x33, 0x32, 0x16, 0x17, 0x1e, 0x02, 0x15,
+  0x14, 0x06, 0x07, 0x0e, 0x07, 0x2b, 0x01, 0x06, 0x0f, 0x01, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x0e, 0x01, 0x22, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x26, 0x01, 0x06, 0x20, 0x27,
+  0x16, 0x17, 0x16, 0x33, 0x32, 0x36, 0x03, 0x20, 0x2d, 0x38, 0x37, 0x2e,
+  0x2d, 0x38, 0x37, 0x1b, 0x10, 0x29, 0x0d, 0x0f, 0x15, 0x14, 0x30, 0x63,
+  0x63, 0x02, 0x0f, 0x2e, 0x37, 0x37, 0x2e, 0x2d, 0x37, 0x38, 0xfb, 0xcb,
+  0x2e, 0xb1, 0x33, 0x39, 0x26, 0x03, 0x39, 0x63, 0xfe, 0x09, 0x3c, 0x39,
+  0x0f, 0x05, 0x34, 0x2e, 0xa0, 0x7d, 0x5e, 0x3e, 0x74, 0x3b, 0x33, 0x04,
+  0x0f, 0x39, 0x3b, 0x16, 0x10, 0x04, 0x1c, 0x0b, 0x12, 0x09, 0x01, 0x4a,
+  0x23, 0x1d, 0x32, 0x21, 0x2b, 0x14, 0x30, 0x0b, 0x2c, 0x2a, 0x2f, 0x02,
+  0x22, 0x1b, 0x27, 0x27, 0x10, 0x0f, 0x1d, 0x20, 0x0e, 0x11, 0x11, 0x39,
+  0x50, 0x37, 0xee, 0xfe, 0xde, 0xef, 0x37, 0x50, 0x38, 0x11, 0x11, 0x0f,
+  0x1f, 0x1d, 0x0f, 0x11, 0x26, 0x27, 0x1b, 0x22, 0x02, 0x2f, 0x2a, 0x2c,
+  0x0a, 0x31, 0x14, 0x2a, 0x21, 0x33, 0x1d, 0x23, 0x49, 0x01, 0x09, 0x12,
+  0x0c, 0x1b, 0x05, 0x10, 0x02, 0xb8, 0x11, 0x28, 0x0d, 0x0f, 0x15, 0x13,
+  0x01, 0xbb, 0x99, 0x26, 0x39, 0x33, 0xb1, 0xfb, 0x51, 0x0b, 0x12, 0x34,
+  0x0e, 0x09, 0x1e, 0x35, 0x27, 0x2f, 0x19, 0x31, 0x11, 0x39, 0x09, 0x3b,
+  0x34, 0x24, 0x28, 0x20, 0x2d, 0x7a, 0x3a, 0x1b, 0x2d, 0x2d, 0x17, 0x15,
+  0x21, 0x0f, 0x3b, 0x24, 0x31, 0x94, 0x01, 0x7a, 0x93, 0x32, 0x24, 0x3a,
+  0x10, 0x21, 0x15, 0x16, 0x2d, 0x2e, 0x1a, 0x3b, 0x79, 0x2e, 0x20, 0x27,
+  0x25, 0x34, 0x3c, 0x08, 0x39, 0x11, 0x32, 0x18, 0x30, 0x26, 0x36, 0x1d,
+  0x09, 0x0f, 0x33, 0x13, 0x0c, 0x0c, 0x1f, 0x56, 0x08, 0x14, 0x1d, 0x3b,
+  0x31, 0x7a, 0xb0, 0x7b, 0x30, 0x3c, 0x1d, 0x13, 0x08, 0x56, 0x20, 0x0b,
+  0x02, 0xe2, 0x57, 0xfe, 0xda, 0x57, 0x0f, 0x1c, 0x32, 0x8d, 0x60, 0x71,
+  0x02, 0xd1, 0x6e, 0x82, 0x6e, 0x6e, 0x82, 0x6e, 0x1b, 0x41, 0x15, 0x11,
+  0x1f, 0x1d, 0x19, 0x12, 0xd4, 0xd2, 0x01, 0x8b, 0x6e, 0x82, 0x6e, 0x6e,
+  0x82, 0x6e, 0x02, 0xb5, 0x2d, 0xda, 0xba, 0x18, 0x94, 0xfd, 0x4d, 0xd2,
+  0xd2, 0x93, 0x76, 0x24, 0x44, 0x11, 0x19, 0x4b, 0x3b, 0x37, 0x22, 0x08,
+  0x0d, 0x44, 0x3b, 0x4b, 0x19, 0x11, 0x44, 0x24, 0x76, 0x0d, 0x0f, 0x13,
+  0x68, 0x35, 0x57, 0x4d, 0x27, 0x14, 0x0b, 0x0c, 0x20, 0x11, 0x31, 0x0a,
+  0x2a, 0x4c, 0x37, 0x2e, 0x34, 0x02, 0x28, 0x1a, 0x23, 0x13, 0x0e, 0x22,
+  0x11, 0x19, 0x19, 0x4e, 0x83, 0x65, 0x6d, 0x6d, 0x65, 0x83, 0x4e, 0x19,
+  0x19, 0x11, 0x22, 0x0e, 0x13, 0x23, 0x1a, 0x28, 0x02, 0x34, 0x2e, 0x37,
+  0x4c, 0x2a, 0x0a, 0x31, 0x11, 0x20, 0x0c, 0x0b, 0x14, 0x27, 0x4d, 0x57,
+  0x35, 0x68, 0x13, 0x0f, 0x4e, 0x41, 0x15, 0x11, 0x1f, 0x1d, 0x19, 0x12,
+  0x02, 0x9a, 0xbb, 0x94, 0x18, 0xba, 0xda, 0xfb, 0xef, 0x2a, 0x2c, 0x50,
+  0xdd, 0x49, 0x09, 0x08, 0x1b, 0x0d, 0x2c, 0x0f, 0x39, 0x09, 0x3a, 0x6b,
+  0x52, 0x34, 0x5f, 0x35, 0x22, 0x32, 0x53, 0x12, 0x27, 0x18, 0x19, 0x27,
+  0x15, 0x52, 0x1d, 0x1b, 0x4e, 0x4e, 0x1b, 0x1d, 0x52, 0x15, 0x27, 0x19,
+  0x18, 0x27, 0x12, 0x53, 0x32, 0x22, 0x35, 0x5f, 0x34, 0x52, 0x6b, 0x3a,
+  0x09, 0x39, 0x0f, 0x2c, 0x0d, 0x1b, 0x08, 0x09, 0x49, 0xdd, 0x50, 0x2c,
+  0x2a, 0x30, 0x28, 0x73, 0x42, 0x44, 0x30, 0x48, 0x2e, 0x26, 0x1b, 0x1b,
+  0x26, 0x2e, 0x48, 0x30, 0x44, 0x42, 0x73, 0x28, 0xfe, 0xe0, 0x16, 0x16,
+  0x24, 0x15, 0x27, 0x26, 0x00, 0x08, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e,
+  0x07, 0x14, 0x00, 0x11, 0x00, 0x19, 0x00, 0x28, 0x00, 0x32, 0x00, 0x41,
+  0x00, 0x4e, 0x00, 0x7f, 0x00, 0xb8, 0x00, 0x00, 0x01, 0x37, 0x16, 0x33,
+  0x32, 0x37, 0x16, 0x33, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x06,
+  0x23, 0x22, 0x01, 0x17, 0x06, 0x22, 0x27, 0x37, 0x16, 0x32, 0x03, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32,
+  0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e, 0x01, 0x37, 0x26, 0x05,
+  0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x23, 0x22, 0x06, 0x05, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27,
+  0x06, 0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03,
+  0x15, 0x14, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16,
+  0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25,
+  0x37, 0x05, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17,
+  0x1e, 0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16,
+  0x17, 0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17,
+  0x07, 0x27, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x07, 0x27,
+  0x37, 0x26, 0x27, 0x07, 0x27, 0x02, 0x62, 0x53, 0x3e, 0x52, 0x34, 0x4c,
+  0x4b, 0x35, 0x51, 0x3f, 0x52, 0x61, 0x81, 0x43, 0x3d, 0x3e, 0x42, 0x82,
+  0x01, 0x8c, 0x38, 0x6e, 0xae, 0x6e, 0x38, 0x51, 0x78, 0xea, 0x26, 0x49,
+  0x1d, 0x24, 0x3f, 0x31, 0x12, 0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21,
+  0x2b, 0x05, 0x26, 0x3e, 0x11, 0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c,
+  0x2a, 0x30, 0x13, 0x31, 0x3f, 0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b,
+  0x24, 0x0e, 0x03, 0x0b, 0x0c, 0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09,
+  0x14, 0x04, 0x18, 0x26, 0xda, 0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb,
+  0x26, 0x18, 0x05, 0x13, 0x09, 0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf,
+  0x0c, 0x15, 0x01, 0x01, 0x18, 0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9,
+  0xa3, 0x93, 0x5d, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0,
+  0x09, 0xfb, 0x46, 0x0f, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e,
+  0x36, 0x80, 0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e,
+  0x22, 0x15, 0x04, 0x1c, 0x0b, 0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d,
+  0x1d, 0x63, 0x17, 0x63, 0x69, 0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
+  0xae, 0x6a, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x01, 0x8c, 0x62,
+  0x40, 0x2c, 0x2c, 0x40, 0x62, 0x64, 0x1c, 0x1c, 0x01, 0xa8, 0x78, 0x3d,
+  0x3d, 0x78, 0x2e, 0x01, 0x06, 0x4c, 0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47,
+  0x30, 0x2c, 0x61, 0x26, 0x30, 0x24, 0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11,
+  0x1d, 0x43, 0x61, 0x2c, 0x30, 0x47, 0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04,
+  0x03, 0x16, 0x18, 0x1c, 0x0e, 0x0c, 0x03, 0x3b, 0xa7, 0x82, 0x74, 0x2e,
+  0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a,
+  0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0x2e, 0x74, 0x82, 0x2b, 0x42, 0x2c,
+  0x45, 0x40, 0x79, 0x3e, 0x7a, 0xe7, 0x77, 0x84, 0x84, 0x77, 0xe7, 0x7a,
+  0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42, 0x3d, 0x7c, 0x8f, 0x39, 0x6a, 0x77,
+  0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d,
+  0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a,
+  0x39, 0x8f, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e, 0xfe,
+  0xf7, 0x8e, 0x9e, 0x9e, 0x8c, 0x01, 0x0b, 0x2e, 0x3e, 0x2e, 0x51, 0x57,
+  0x0e, 0x42, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x99, 0xff, 0x6a, 0x07, 0xbb,
+  0x07, 0x0b, 0x00, 0x07, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x31,
+  0x00, 0x3b, 0x00, 0x47, 0x00, 0x68, 0x00, 0x98, 0x00, 0xaa, 0x00, 0xbc,
+  0x00, 0x00, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x37, 0x22,
+  0x06, 0x15, 0x14, 0x33, 0x32, 0x36, 0x35, 0x34, 0x03, 0x22, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x15, 0x14, 0x07, 0x06, 0x00, 0x14, 0x06, 0x22,
+  0x26, 0x34, 0x36, 0x32, 0x03, 0x34, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x23, 0x22, 0x27, 0x26, 0x01, 0x22, 0x06, 0x15, 0x14, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x01, 0x37, 0x16, 0x33, 0x32, 0x36, 0x37, 0x17, 0x06, 0x23,
+  0x22, 0x26, 0x12, 0x20, 0x37, 0x36, 0x35, 0x34, 0x27, 0x3e, 0x02, 0x35,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x07, 0x2e, 0x01, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x1e, 0x01, 0x17, 0x06, 0x15, 0x14, 0x17, 0x12, 0x20,
+  0x04, 0x17, 0x16, 0x17, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x07, 0x0e, 0x01, 0x2b, 0x01, 0x06, 0x07, 0x0e, 0x01, 0x07, 0x06, 0x20,
+  0x27, 0x2e, 0x01, 0x27, 0x26, 0x27, 0x23, 0x22, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x17, 0x36, 0x37, 0x36, 0x03, 0x26,
+  0x23, 0x22, 0x07, 0x0e, 0x01, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x3b,
+  0x01, 0x36, 0x37, 0x26, 0x25, 0x06, 0x07, 0x16, 0x17, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x27, 0x26, 0x23, 0x22, 0x02, 0xca,
+  0x4a, 0x68, 0x4a, 0x4a, 0x68, 0x82, 0x14, 0x31, 0x0e, 0x14, 0x32, 0x0e,
+  0x16, 0x28, 0x21, 0x1b, 0x16, 0x28, 0x21, 0x01, 0xd8, 0x49, 0x69, 0x4a,
+  0x4a, 0x69, 0xe8, 0x16, 0x1c, 0x21, 0x28, 0x16, 0x1c, 0x21, 0x28, 0x01,
+  0x02, 0x14, 0x32, 0x0f, 0x14, 0x32, 0xfd, 0x33, 0x5f, 0x75, 0xb9, 0x57,
+  0xa2, 0x35, 0x5f, 0x97, 0xf6, 0x74, 0xd2, 0x7c, 0x01, 0x93, 0x95, 0x6f,
+  0x4b, 0x1b, 0x1a, 0x1c, 0x4e, 0x51, 0x75, 0x40, 0x65, 0x1c, 0x19, 0x65,
+  0x40, 0x75, 0x51, 0x4e, 0x1c, 0x1a, 0x1c, 0x4c, 0x70, 0xbb, 0x01, 0x45,
+  0x01, 0x18, 0x58, 0x5e, 0x0f, 0x16, 0x1a, 0x60, 0x81, 0x07, 0x0c, 0x19,
+  0x1e, 0x79, 0x50, 0x07, 0x0d, 0x34, 0x33, 0x9a, 0x62, 0x85, 0xfe, 0xfd,
+  0x85, 0x62, 0x9a, 0x33, 0x34, 0x0d, 0x07, 0x50, 0x78, 0x1f, 0x19, 0x0c,
+  0x07, 0x82, 0x5f, 0x1a, 0x17, 0x0e, 0x5f, 0x57, 0xc1, 0x15, 0x1d, 0x0c,
+  0x13, 0x24, 0x27, 0x07, 0x15, 0x3f, 0x1c, 0x23, 0x03, 0x07, 0x36, 0x2f,
+  0x04, 0xe8, 0x0e, 0x30, 0x36, 0x07, 0x04, 0x22, 0x1c, 0x40, 0x14, 0x07,
+  0x27, 0x24, 0x13, 0x0c, 0x1c, 0x04, 0x08, 0x74, 0x52, 0x52, 0x74, 0x52,
+  0x68, 0x31, 0x13, 0x0e, 0x31, 0x13, 0x0e, 0xfe, 0x52, 0x15, 0x20, 0x24,
+  0x1f, 0x15, 0x20, 0x24, 0x1f, 0x02, 0x0c, 0x74, 0x52, 0x52, 0x74, 0x52,
+  0xfe, 0x05, 0x15, 0x1f, 0x24, 0x20, 0x15, 0x1f, 0x24, 0x01, 0x6b, 0x31,
+  0x13, 0x0e, 0x31, 0x13, 0x0e, 0xfd, 0xa8, 0x54, 0xa4, 0x58, 0x4c, 0x54,
+  0xd6, 0x72, 0xfe, 0xde, 0xcb, 0x9a, 0xb8, 0x86, 0x95, 0x2c, 0x30, 0x5e,
+  0x31, 0x8a, 0x69, 0x6f, 0x45, 0x35, 0x35, 0x45, 0x6f, 0x69, 0x8a, 0x31,
+  0x5e, 0x30, 0x2c, 0x95, 0x86, 0xb8, 0x9a, 0x06, 0x00, 0xa4, 0x7c, 0x88,
+  0x9b, 0x06, 0xa4, 0x87, 0x2c, 0x36, 0x5b, 0x3f, 0x4b, 0x69, 0x7b, 0x70,
+  0x6e, 0xad, 0x37, 0x4c, 0x4c, 0x37, 0xad, 0x6e, 0x70, 0x7b, 0x69, 0x4b,
+  0x3f, 0x5b, 0x36, 0x2c, 0x87, 0xa4, 0x06, 0x9b, 0x88, 0x7c, 0xfd, 0xcc,
+  0x15, 0x07, 0x0f, 0x52, 0x3a, 0x1e, 0x33, 0x97, 0x2f, 0x15, 0x87, 0x7b,
+  0x57, 0x60, 0x60, 0x57, 0x7b, 0x87, 0x15, 0x2f, 0x97, 0x33, 0x1e, 0x3a,
+  0x52, 0x0f, 0x07, 0x00, 0x00, 0x09, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x34,
+  0x00, 0x39, 0x00, 0x3e, 0x00, 0x42, 0x00, 0x46, 0x00, 0x00, 0x01, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34,
+  0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x21, 0x10,
+  0x00, 0x20, 0x00, 0x05, 0x36, 0x37, 0x11, 0x23, 0x03, 0x11, 0x23, 0x11,
+  0x16, 0x25, 0x36, 0x37, 0x23, 0x05, 0x35, 0x23, 0x16, 0x02, 0x42, 0x49,
+  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b,
+  0x4b, 0x34, 0x35, 0x49, 0xfc, 0xc8, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
+  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01,
+  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
+  0xb1, 0xfe, 0x27, 0xf8, 0x04, 0x5f, 0xfe, 0xb9, 0xfe, 0x30, 0xfe, 0xb8,
+  0x02, 0x6d, 0x50, 0x44, 0x94, 0x7a, 0x94, 0x45, 0x01, 0xd7, 0x41, 0x19,
+  0x5a, 0xfd, 0x6a, 0x5b, 0x19, 0x03, 0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a,
+  0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
+  0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
+  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x6a, 0xfe, 0xfe, 0xfe, 0x96, 0x01,
+  0x6a, 0xdf, 0x0b, 0x2a, 0x01, 0x25, 0xfe, 0xa6, 0x01, 0x5a, 0xfe, 0xdb,
+  0x2a, 0x99, 0x52, 0x64, 0xb8, 0xb8, 0x66, 0x00, 0x00, 0x09, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x35, 0x00, 0x3a, 0x00, 0x3f, 0x00, 0x43, 0x00, 0x47,
+  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
+  0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
+  0x06, 0x15, 0x07, 0x21, 0x10, 0x00, 0x20, 0x00, 0x05, 0x36, 0x37, 0x11,
+  0x23, 0x03, 0x11, 0x23, 0x11, 0x16, 0x25, 0x36, 0x37, 0x23, 0x05, 0x35,
+  0x23, 0x16, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x03, 0x5c, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfd, 0x72,
+  0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xc9, 0x04, 0x5f, 0xfe, 0xb9,
+  0xfe, 0x30, 0xfe, 0xb8, 0x02, 0x6d, 0x50, 0x44, 0x94, 0x7a, 0x94, 0x45,
+  0x01, 0xd7, 0x41, 0x19, 0x5a, 0xfd, 0x6a, 0x5b, 0x19, 0x02, 0xea, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
+  0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
+  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x02, 0x16, 0x8b, 0xc5, 0xc5, 0x8b, 0x53,
+  0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xac,
+  0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0xdf, 0x0b, 0x2a, 0x01, 0x25, 0xfe,
+  0xa6, 0x01, 0x5a, 0xfe, 0xdb, 0x2a, 0x99, 0x52, 0x64, 0xb8, 0xb8, 0x66,
+  0x00, 0x09, 0x00, 0x55, 0xff, 0x6a, 0x08, 0x14, 0x06, 0x6e, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0c, 0x00, 0x11, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2f,
+  0x00, 0x59, 0x00, 0x7e, 0x00, 0x00, 0x01, 0x35, 0x23, 0x16, 0x05, 0x36,
+  0x37, 0x23, 0x01, 0x11, 0x23, 0x11, 0x16, 0x17, 0x36, 0x37, 0x11, 0x23,
+  0x25, 0x21, 0x10, 0x00, 0x20, 0x00, 0x13, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x14, 0x07, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x06, 0x22, 0x27,
+  0x26, 0x2f, 0x01, 0x02, 0x07, 0x02, 0x21, 0x20, 0x03, 0x26, 0x03, 0x07,
+  0x06, 0x07, 0x06, 0x22, 0x26, 0x35, 0x34, 0x37, 0x36, 0x3f, 0x01, 0x26,
+  0x37, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x27, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x2f, 0x01, 0x17, 0x16, 0x17, 0x26, 0x27, 0x26, 0x21, 0x20,
+  0x07, 0x06, 0x07, 0x36, 0x3f, 0x01, 0x07, 0x06, 0x07, 0x06, 0x22, 0x27,
+  0x06, 0x02, 0xe9, 0x5b, 0x1a, 0x02, 0xd8, 0x40, 0x1a, 0x5a, 0xfe, 0x77,
+  0x93, 0x44, 0xca, 0x4f, 0x44, 0x93, 0xfd, 0x93, 0x04, 0x5e, 0xfe, 0xba,
+  0xfe, 0x2f, 0xfe, 0xb9, 0x4f, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37,
+  0x01, 0x9c, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfc, 0x2a, 0x01,
+  0xda, 0x01, 0x4e, 0x01, 0x50, 0x01, 0xd8, 0x02, 0x54, 0x35, 0x15, 0x1b,
+  0x30, 0x45, 0x1c, 0x16, 0x10, 0x0a, 0x26, 0xbc, 0xec, 0xfe, 0xb0, 0xfe,
+  0xb2, 0xed, 0xbc, 0x27, 0x09, 0x10, 0x17, 0x1c, 0x44, 0x30, 0x1a, 0x15,
+  0x36, 0x53, 0x02, 0x7a, 0x01, 0x92, 0x01, 0x1c, 0x01, 0x1e, 0x01, 0x90,
+  0x01, 0x18, 0x21, 0x22, 0x1c, 0x17, 0x10, 0x29, 0x7b, 0x25, 0x15, 0x2a,
+  0x8b, 0xc7, 0xfe, 0xe1, 0xfe, 0xe4, 0xca, 0x8a, 0x2a, 0x15, 0x25, 0x7a,
+  0x28, 0x10, 0x17, 0x1c, 0x44, 0x18, 0x01, 0x01, 0xa1, 0xb8, 0x66, 0x50,
+  0x52, 0x64, 0xfe, 0xa6, 0x01, 0x5a, 0xfe, 0xdb, 0x2a, 0x0b, 0x0b, 0x2a,
+  0x01, 0x25, 0x87, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x01, 0xae, 0x8b,
+  0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53,
+  0x77, 0x77, 0x53, 0xa2, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b,
+  0x1d, 0x1b, 0x1f, 0x14, 0x18, 0x1f, 0x25, 0x26, 0x36, 0x1f, 0x19, 0x39,
+  0x20, 0xfe, 0xe9, 0xd1, 0xfe, 0xfa, 0x01, 0x06, 0xd0, 0x01, 0x16, 0x1e,
+  0x39, 0x19, 0x1f, 0x36, 0x26, 0x25, 0x1f, 0x19, 0x13, 0x1e, 0x1c, 0x1d,
+  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x14, 0x13, 0x1a, 0x1f,
+  0x19, 0x39, 0x88, 0x2d, 0x0e, 0x0f, 0xc7, 0x9a, 0xe0, 0xe0, 0x9b, 0xc6,
+  0x10, 0x0d, 0x2d, 0x88, 0x39, 0x19, 0x1f, 0x1b, 0x14, 0x00, 0x00, 0x00,
+  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
+  0x00, 0x16, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x34, 0x00, 0x3c, 0x00, 0x00,
+  0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
+  0x21, 0x10, 0x00, 0x20, 0x00, 0x25, 0x21, 0x16, 0x17, 0x16, 0x24, 0x37,
+  0x36, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02,
+  0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9,
+  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
+  0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe,
+  0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x7f, 0x04, 0x5f, 0xfe, 0xb9,
+  0xfe, 0x30, 0xfe, 0xb8, 0x03, 0xd5, 0xfc, 0xb5, 0x1e, 0x53, 0x7f, 0x01,
+  0x6c, 0x80, 0x53, 0x03, 0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53,
+  0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0x01, 0x75, 0x02,
+  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
+  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
+  0xc0, 0xfe, 0x40, 0xfe, 0xb9, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x7b,
+  0x75, 0x5c, 0x8e, 0x01, 0x8e, 0x5c, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x35, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x34, 0x36, 0x32,
+  0x16, 0x15, 0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32,
+  0x16, 0x15, 0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x21, 0x10, 0x00,
+  0x20, 0x00, 0x25, 0x21, 0x16, 0x17, 0x16, 0x37, 0x32, 0x37, 0x36, 0x01,
+  0xe1, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0x01, 0x9b, 0x7e, 0xb1,
+  0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfc, 0x2a, 0x01, 0xd9, 0x01, 0x4f, 0x01,
+  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
+  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
+  0xfe, 0xe4, 0xfe, 0x6d, 0x7f, 0x04, 0x5f, 0xfe, 0xb9, 0xfe, 0x30, 0xfe,
+  0xb8, 0x03, 0xd5, 0xfc, 0xb5, 0x1e, 0x53, 0x7f, 0xb6, 0xb6, 0x80, 0x53,
+  0x03, 0x8c, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5,
+  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xa2, 0x01, 0x75, 0x02, 0x0f, 0xfd,
+  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
+  0x40, 0xfe, 0xb9, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x7b, 0x75, 0x5c,
+  0x8e, 0x01, 0x8e, 0x5c, 0x00, 0x07, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b,
+  0x00, 0x41, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x17, 0x16, 0x07, 0x14, 0x07,
+  0x06, 0x22, 0x26, 0x35, 0x34, 0x37, 0x05, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x21, 0x10, 0x00, 0x20, 0x00,
+  0x25, 0x21, 0x16, 0x17, 0x16, 0x37, 0x32, 0x37, 0x36, 0x05, 0xfe, 0x3a,
+  0x19, 0x01, 0x18, 0x18, 0x45, 0x30, 0x18, 0xfc, 0x1e, 0x7e, 0xb0, 0x7e,
+  0x79, 0x37, 0x4c, 0x37, 0x01, 0x9b, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b,
+  0x37, 0xfc, 0x2a, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
+  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
+  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
+  0x7f, 0x04, 0x5f, 0xfe, 0xb9, 0xfe, 0x30, 0xfe, 0xb8, 0x03, 0xd5, 0xfc,
+  0xb5, 0x1e, 0x53, 0x7f, 0xb6, 0xb6, 0x80, 0x53, 0x04, 0x2c, 0x80, 0x38,
+  0x22, 0x2b, 0x1a, 0x1b, 0x36, 0x2c, 0x23, 0x35, 0x20, 0x8b, 0xc5, 0xc5,
+  0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77,
+  0x53, 0xa2, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c,
+  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
+  0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xb9, 0xfe, 0xfe,
+  0xfe, 0x96, 0x01, 0x6a, 0x7b, 0x75, 0x5c, 0x8e, 0x01, 0x8e, 0x5c, 0x00,
+  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x06,
+  0x00, 0x0d, 0x00, 0x19, 0x00, 0x25, 0x00, 0x2b, 0x00, 0x33, 0x00, 0x00,
+  0x01, 0x25, 0x17, 0x07, 0x17, 0x07, 0x25, 0x27, 0x15, 0x05, 0x27, 0x37,
+  0x27, 0x37, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x13, 0x21, 0x10, 0x00, 0x20, 0x00, 0x25, 0x21, 0x16, 0x17,
+  0x16, 0x24, 0x37, 0x36, 0x04, 0x09, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45,
+  0xfe, 0xf6, 0x90, 0xfe, 0xf7, 0x46, 0xb3, 0xb3, 0x46, 0xfe, 0x29, 0x01,
+  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
+  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x7f, 0x04, 0x5f, 0xfe,
+  0xb9, 0xfe, 0x30, 0xfe, 0xb8, 0x03, 0xd5, 0xfc, 0xb5, 0x1e, 0x53, 0x7f,
+  0x01, 0x6c, 0x80, 0x53, 0x04, 0x27, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce,
+  0x55, 0x55, 0xce, 0x6e, 0x8a, 0x8b, 0x6e, 0xfd, 0xf5, 0x01, 0x75, 0x02,
+  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
+  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
+  0xc0, 0xfe, 0x40, 0xfe, 0xb9, 0xfe, 0xfe, 0xfe, 0x96, 0x01, 0x6a, 0x7b,
+  0x75, 0x5c, 0x8e, 0x01, 0x8e, 0x5c, 0x00, 0x00, 0x00, 0x07, 0x00, 0x80,
+  0xff, 0x6a, 0x07, 0x01, 0x07, 0x63, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x2a,
+  0x00, 0x35, 0x00, 0x49, 0x00, 0x57, 0x00, 0x5f, 0x00, 0x00, 0x01, 0x37,
+  0x16, 0x17, 0x16, 0x04, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x2f, 0x01,
+  0x06, 0x21, 0x20, 0x27, 0x07, 0x06, 0x05, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x01, 0x34, 0x24, 0x21, 0x20, 0x04, 0x15, 0x14,
+  0x07, 0x16, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x37, 0x26,
+  0x25, 0x36, 0x35, 0x34, 0x24, 0x21, 0x20, 0x04, 0x15, 0x14, 0x17, 0x36,
+  0x21, 0x20, 0x17, 0x26, 0x23, 0x22, 0x07, 0x16, 0x33, 0x32, 0x01, 0xe7,
+  0x67, 0x1a, 0x24, 0x80, 0x01, 0x6b, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d,
+  0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0xf6, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
+  0x01, 0x91, 0xc8, 0x0c, 0xcf, 0xfe, 0xf5, 0xfe, 0xf6, 0xcf, 0x0d, 0xc9,
+  0x03, 0x38, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfd, 0xf8, 0x49,
+  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0xfe, 0x3f, 0x01, 0xe7, 0x01,
+  0x59, 0x01, 0x5a, 0x01, 0xe6, 0xe4, 0xcb, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
+  0xb1, 0xfe, 0x27, 0xcc, 0xe4, 0x05, 0x45, 0xa9, 0xfe, 0x6f, 0xfe, 0xe3,
+  0xfe, 0xe4, 0xfe, 0x6d, 0xab, 0xdb, 0x01, 0x29, 0x01, 0x2a, 0x3c, 0x9e,
+  0xc8, 0xc7, 0x9e, 0x9e, 0xc7, 0xc8, 0x01, 0xd1, 0x47, 0x2c, 0x26, 0x8d,
+  0x01, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5, 0xb5, 0x33, 0x01, 0x51,
+  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0xe0, 0x0e,
+  0x39, 0x39, 0x0e, 0xe0, 0x2a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53,
+  0x3a, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x02, 0x5c, 0x86, 0xbe, 0xbe,
+  0x86, 0x82, 0x5c, 0xfc, 0xfe, 0xa5, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c,
+  0x01, 0x74, 0x01, 0x5b, 0xfc, 0x5c, 0x02, 0x36, 0x4a, 0x51, 0x72, 0x72,
+  0x51, 0x4a, 0x36, 0xcf, 0xf5, 0x6e, 0x6e, 0x1c, 0x00, 0x07, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x07, 0x30, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x19,
+  0x00, 0x1d, 0x00, 0x2d, 0x00, 0x39, 0x00, 0x4a, 0x00, 0x00, 0x01, 0x05,
+  0x07, 0x25, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x01, 0x17, 0x05, 0x27, 0x01, 0x37, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36,
+  0x37, 0x17, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x36, 0x20, 0x17,
+  0x25, 0x11, 0x16, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x37,
+  0x11, 0x02, 0x8a, 0x01, 0x10, 0x45, 0xfe, 0xef, 0x02, 0x06, 0x4a, 0x68,
+  0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfd, 0xf8, 0x49, 0x35, 0x34, 0x4a, 0x4a,
+  0x34, 0x35, 0x49, 0x02, 0xb7, 0x45, 0xfe, 0xef, 0x45, 0xfd, 0xff, 0x67,
+  0x1a, 0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4,
+  0xfe, 0x30, 0xa4, 0x2d, 0xf6, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01,
+  0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0xb2, 0x77,
+  0x01, 0x0c, 0x77, 0x01, 0x8f, 0x9b, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
+  0xfe, 0x27, 0x9d, 0x05, 0x67, 0xd4, 0x6f, 0xd5, 0xfe, 0xbc, 0x3b, 0x51,
+  0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53,
+  0x01, 0xec, 0x6e, 0xd5, 0x6f, 0xfd, 0x3e, 0x47, 0x2c, 0x26, 0x8e, 0x8e,
+  0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5, 0xb5, 0x33, 0x01, 0x51, 0xfe, 0xc4,
+  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
+  0x02, 0x1d, 0x2a, 0x2a, 0xec, 0xfd, 0xd0, 0xe7, 0xfe, 0xd1, 0xfe, 0x8c,
+  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0x01, 0x2f, 0xe7, 0x02, 0x30, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0f,
+  0x00, 0x1b, 0x00, 0x27, 0x00, 0x32, 0x00, 0x39, 0x00, 0x00, 0x01, 0x37,
+  0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x2d, 0x01, 0x17, 0x07, 0x17, 0x07, 0x25, 0x01, 0xe7, 0x67, 0x1a,
+  0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe,
+  0x30, 0xa4, 0x2d, 0xf6, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x01, 0xa9, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x01,
+  0xc7, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0x01, 0xd1, 0x47,
+  0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5, 0xb5, 0x33,
+  0x01, 0x51, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d,
+  0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
+  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x02, 0x87, 0x3b, 0x51,
+  0x51, 0x76, 0x52, 0x53, 0x64, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0f,
+  0x00, 0x1b, 0x00, 0x27, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x37,
+  0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x03, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
+  0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
+  0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x01, 0xe7, 0x67, 0x1a, 0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23,
+  0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x27, 0x7e, 0xb0,
+  0x7e, 0x79, 0x37, 0x4c, 0x37, 0x01, 0x9b, 0x7e, 0xb1, 0x7e, 0x7a, 0x37,
+  0x4b, 0x37, 0xfc, 0x2a, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7,
+  0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01,
+  0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe,
+  0x6d, 0x01, 0xd1, 0x47, 0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48, 0x39,
+  0x32, 0xb5, 0xb5, 0x33, 0x01, 0xf3, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77,
+  0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xa2, 0x01,
+  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
+  0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01,
+  0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x37,
+  0x00, 0x43, 0x00, 0x51, 0x00, 0x00, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x23, 0x34, 0x26, 0x22, 0x06, 0x15, 0x05, 0x10, 0x00, 0x21, 0x32, 0x37,
+  0x26, 0x27, 0x06, 0x23, 0x22, 0x00, 0x11, 0x33, 0x14, 0x00, 0x20, 0x00,
+  0x35, 0x33, 0x14, 0x07, 0x16, 0x1d, 0x01, 0x36, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x05, 0x06, 0x07, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x34, 0x27, 0x26, 0x03, 0xf5, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b,
+  0x37, 0xfd, 0x72, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfe, 0xb8,
+  0x01, 0x93, 0x01, 0x1c, 0x7b, 0x6a, 0x5b, 0x3b, 0x26, 0x29, 0xe8, 0xfe,
+  0xb8, 0x7a, 0x01, 0x00, 0x01, 0x6c, 0x01, 0x00, 0x79, 0x6f, 0x32, 0xbc,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x04, 0x8e, 0x47, 0x52, 0x1b, 0x23, 0x20, 0x18, 0x0f, 0x0b, 0x1e,
+  0x01, 0x01, 0x02, 0x03, 0x8c, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77,
+  0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xa2, 0xfe, 0xc4,
+  0xfe, 0x43, 0x29, 0x30, 0x6c, 0x05, 0x01, 0x6a, 0x01, 0x02, 0xca, 0xfe,
+  0xe5, 0x01, 0x1c, 0xc9, 0xd5, 0xa0, 0x64, 0x63, 0x04, 0xda, 0x01, 0x33,
+  0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f,
+  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x36, 0x43,
+  0x24, 0x28, 0x18, 0x17, 0x08, 0x13, 0x39, 0x05, 0x06, 0x2e, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0f,
+  0x00, 0x1b, 0x00, 0x27, 0x00, 0x33, 0x00, 0x3f, 0x00, 0x00, 0x01, 0x37,
+  0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20,
+  0x27, 0x26, 0x01, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32,
+  0x36, 0x35, 0x21, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32,
+  0x36, 0x35, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x01, 0xe7, 0x67, 0x1a, 0x24, 0x7f, 0x01, 0x6c, 0x80, 0x23,
+  0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x03, 0x9a, 0x7e,
+  0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0, 0x7e, 0x79,
+  0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01,
+  0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93,
+  0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4,
+  0xfe, 0x6d, 0x01, 0xd1, 0x47, 0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48,
+  0x39, 0x32, 0xb5, 0xb5, 0x33, 0x02, 0xef, 0x8b, 0xc5, 0xc5, 0x8b, 0x53,
+  0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfe,
+  0x62, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
+  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
+  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x05, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x17, 0x00, 0x2f, 0x00, 0x3b,
+  0x00, 0x47, 0x00, 0x57, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x06,
+  0x0f, 0x01, 0x23, 0x27, 0x26, 0x35, 0x26, 0x37, 0x36, 0x33, 0x16, 0x17,
+  0x16, 0x17, 0x33, 0x34, 0x37, 0x36, 0x21, 0x32, 0x17, 0x16, 0x15, 0x33,
+  0x36, 0x37, 0x36, 0x37, 0x32, 0x17, 0x16, 0x07, 0x14, 0x0f, 0x01, 0x23,
+  0x27, 0x26, 0x27, 0x34, 0x37, 0x36, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x37, 0x16, 0x17, 0x16, 0x20,
+  0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x20, 0x27, 0x26, 0x05, 0x15,
+  0x18, 0x16, 0x36, 0x01, 0x2d, 0x97, 0x02, 0x8f, 0x37, 0x01, 0x09, 0x22,
+  0x38, 0x25, 0x1d, 0x19, 0x09, 0x01, 0x0c, 0x1f, 0xfd, 0x8f, 0x37, 0x1f,
+  0x0c, 0x01, 0x09, 0x19, 0x1d, 0x25, 0x39, 0x22, 0x09, 0x01, 0x38, 0x8f,
+  0x02, 0x97, 0x2d, 0x01, 0x36, 0x17, 0xfe, 0x43, 0x01, 0xd9, 0x01, 0x4f,
+  0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27,
+  0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe,
+  0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x67, 0x1a, 0x24, 0x7f, 0x01, 0x6c,
+  0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x04,
+  0xc0, 0x0e, 0x25, 0x3f, 0x41, 0x3e, 0xcf, 0xbe, 0x44, 0x4c, 0x15, 0x19,
+  0x44, 0x01, 0x20, 0x20, 0x31, 0x0e, 0x1d, 0x47, 0x47, 0x1d, 0x0e, 0x31,
+  0x20, 0x20, 0x01, 0x44, 0x19, 0x15, 0x4c, 0x44, 0xbe, 0xcf, 0x3e, 0x41,
+  0x3f, 0x25, 0x0e, 0xfe, 0x2a, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
+  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd,
+  0xaa, 0x47, 0x2c, 0x26, 0x8e, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5,
+  0xb5, 0x33, 0x00, 0x00, 0x00, 0x04, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x17, 0x00, 0x23, 0x00, 0x33, 0x00, 0x3c, 0x00, 0x00,
+  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x27, 0x23, 0x15, 0x14,
+  0x06, 0x22, 0x26, 0x35, 0x14, 0x06, 0x22, 0x26, 0x3d, 0x01, 0x23, 0x06,
+  0x07, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x25, 0x37, 0x16, 0x17, 0x16, 0x04, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07,
+  0x06, 0x20, 0x27, 0x26, 0x03, 0x21, 0x26, 0x27, 0x26, 0x21, 0x20, 0x07,
+  0x06, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0x4c,
+  0x63, 0x95, 0xd4, 0x96, 0x95, 0xd5, 0x95, 0x63, 0x4d, 0x79, 0x01, 0xd9,
+  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
+  0xfe, 0x27, 0x01, 0x4e, 0x67, 0x1a, 0x24, 0x80, 0x01, 0x6b, 0x80, 0x23,
+  0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xfe, 0x30, 0xa4, 0x2d, 0x56, 0x04, 0x1f,
+  0x14, 0x16, 0xc8, 0xfe, 0xe2, 0xfe, 0xe4, 0xca, 0x15, 0x02, 0xea, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0xc3, 0xa0, 0x4f, 0x64, 0x8e,
+  0x8e, 0x64, 0x64, 0x8e, 0x8e, 0x64, 0x4f, 0xa0, 0xc3, 0x01, 0x75, 0x02,
+  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x5b,
+  0x47, 0x2c, 0x26, 0x8d, 0x01, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5,
+  0xb5, 0x33, 0x03, 0x3b, 0x1a, 0x19, 0xe0, 0xe0, 0x19, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x00, 0x01, 0x35,
+  0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x13, 0x32, 0x37, 0x36, 0x37, 0x17,
+  0x06, 0x07, 0x06, 0x23, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x04, 0x22, 0x01, 0x80, 0xfc, 0x3f, 0x01, 0x7f,
+  0x61, 0xb6, 0x80, 0x23, 0x1a, 0x68, 0x22, 0x2d, 0xa4, 0xe8, 0xfc, 0xd8,
+  0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0,
+  0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01,
+  0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0x8c, 0x87,
+  0x87, 0x87, 0x87, 0xfd, 0xac, 0x8e, 0x27, 0x2c, 0x48, 0x39, 0x32, 0xb5,
+  0x02, 0x39, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c,
+  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
+  0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x05, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x19,
+  0x00, 0x25, 0x00, 0x31, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x01, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x11, 0x03, 0x60,
+  0xfc, 0xd1, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08,
+  0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
+  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x71, 0x87, 0x87, 0x02, 0x8c,
+  0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a,
+  0x53, 0x53, 0xd9, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
+  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
+  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x00, 0x01, 0x35,
+  0x21, 0x15, 0x21, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x15, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x04, 0x22,
+  0x01, 0x80, 0xfc, 0x3f, 0x01, 0x7f, 0xfe, 0xb1, 0x03, 0x60, 0xfb, 0x28,
+  0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0,
+  0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01,
+  0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0x8c, 0x87,
+  0x87, 0x87, 0x87, 0xfd, 0xe5, 0x87, 0x87, 0x01, 0x79, 0x01, 0x75, 0x02,
+  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
+  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
+  0xc0, 0xfe, 0x40, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x29, 0x00, 0x37,
+  0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x05, 0x35, 0x21, 0x15, 0x01, 0x35, 0x21, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x35, 0x21, 0x35, 0x21, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x35, 0x34, 0x35, 0x01, 0x12,
+  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
+  0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01,
+  0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x78, 0x03,
+  0x60, 0xfc, 0x68, 0x01, 0x53, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x01,
+  0x34, 0x01, 0x52, 0x34, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0x02, 0xea, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
+  0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
+  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x05, 0x87, 0x87, 0x02, 0x2d, 0x87, 0x51,
+  0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x03, 0x02, 0x87, 0x51, 0x3b, 0x3a, 0x53,
+  0x53, 0x3a, 0x03, 0x02, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x10, 0x00, 0x14, 0x00, 0x1f,
+  0x00, 0x2a, 0x00, 0x36, 0x00, 0x42, 0x00, 0x00, 0x01, 0x17, 0x16, 0x14,
+  0x06, 0x22, 0x26, 0x34, 0x37, 0x01, 0x35, 0x21, 0x15, 0x13, 0x25, 0x37,
+  0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x05, 0xae, 0x3b, 0x18, 0x30, 0x45, 0x30, 0x18, 0xfc,
+  0x9d, 0x03, 0x60, 0x0a, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc, 0x47, 0x45,
+  0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49,
+  0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01,
+  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
+  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0xac, 0x80, 0x35,
+  0x4f, 0x36, 0x36, 0x4f, 0x35, 0xfe, 0x45, 0x87, 0x87, 0x02, 0xa5, 0xf0,
+  0x6f, 0xf1, 0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76,
+  0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01,
+  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
+  0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01,
+  0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b,
+  0x00, 0x27, 0x00, 0x33, 0x00, 0x00, 0x01, 0x35, 0x21, 0x15, 0x13, 0x14,
+  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x21, 0x14,
+  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x11,
+  0x03, 0x60, 0x31, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65,
+  0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
+  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x71, 0x87, 0x87, 0x03, 0x17,
+  0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b,
+  0x53, 0x77, 0x77, 0x53, 0xfe, 0x62, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
+  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
+  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
+  0x00, 0x0e, 0x00, 0x19, 0x00, 0x25, 0x00, 0x31, 0x00, 0x00, 0x25, 0x27,
+  0x01, 0x17, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x02, 0x53, 0x33, 0x03, 0x10, 0x33, 0xfc, 0xdf, 0x49, 0x35, 0x34, 0x4a,
+  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
+  0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
+  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
+  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
+  0xac, 0x7b, 0x01, 0x96, 0x7b, 0x01, 0xbb, 0x3b, 0x51, 0x51, 0x76, 0x52,
+  0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75,
+  0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c,
+  0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d,
+  0x01, 0xc0, 0xfe, 0x40, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x42,
+  0x00, 0x00, 0x01, 0x27, 0x13, 0x17, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x03, 0x37, 0x13, 0x03, 0x22,
+  0x07, 0x06, 0x07, 0x0e, 0x01, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x27, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x02, 0x82, 0x56,
+  0xf3, 0x56, 0xfd, 0x9d, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x04, 0x68, 0xf3, 0x55, 0xf3, 0x8a, 0x2f, 0x25, 0x0a, 0x16, 0x3f,
+  0xb0, 0x3f, 0x19, 0x0b, 0x1f, 0x2f, 0x33, 0x1d, 0x6c, 0x0e, 0x16, 0x40,
+  0xb0, 0x3f, 0x19, 0x0b, 0x1f, 0x2f, 0x2f, 0x24, 0x0b, 0x15, 0x3f, 0xb1,
+  0x3f, 0x15, 0x0f, 0x6d, 0x1c, 0x03, 0x5c, 0x5f, 0x01, 0x0e, 0x5f, 0xfe,
+  0x80, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
+  0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0xe6, 0x01, 0x0e, 0x5f,
+  0xfe, 0xf2, 0xfe, 0x57, 0x69, 0x1d, 0x22, 0x62, 0x01, 0x63, 0x28, 0x21,
+  0x5f, 0x5f, 0x39, 0x28, 0x22, 0x62, 0x62, 0x28, 0x22, 0x5f, 0x69, 0x1e,
+  0x22, 0x62, 0x62, 0x22, 0x28, 0x39, 0x5f, 0x00, 0x00, 0x05, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x23,
+  0x00, 0x2f, 0x00, 0x3b, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x03, 0x37, 0x27, 0x37, 0x17, 0x15, 0x07,
+  0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
+  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
+  0x49, 0xb9, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48,
+  0xfd, 0x08, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29,
+  0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01,
+  0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03,
+  0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51,
+  0x3b, 0x3a, 0x53, 0x53, 0xfe, 0x24, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e,
+  0x2e, 0x58, 0x8d, 0x76, 0x4e, 0x3e, 0x01, 0x23, 0x01, 0x75, 0x02, 0x0f,
+  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74,
+  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0,
+  0xfe, 0x40, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x17, 0x00, 0x22, 0x00, 0x29, 0x00, 0x36, 0x00, 0x42,
+  0x00, 0x4e, 0x00, 0x00, 0x01, 0x32, 0x17, 0x16, 0x15, 0x06, 0x0f, 0x01,
+  0x23, 0x27, 0x26, 0x35, 0x26, 0x37, 0x36, 0x33, 0x16, 0x17, 0x16, 0x17,
+  0x33, 0x34, 0x37, 0x36, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x2d, 0x01, 0x17, 0x07, 0x17, 0x07, 0x25, 0x03, 0x37,
+  0x27, 0x37, 0x17, 0x15, 0x07, 0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x01,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x05,
+  0xc6, 0x17, 0x18, 0x36, 0x02, 0x2d, 0x97, 0x02, 0x8e, 0x38, 0x02, 0x09,
+  0x22, 0x3a, 0x24, 0x1d, 0x19, 0x09, 0x02, 0x0a, 0x1f, 0xfc, 0xb4, 0x49,
+  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x01, 0xc7, 0x01, 0x0a, 0x45,
+  0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0x78, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36,
+  0xe9, 0x3b, 0x82, 0x48, 0xfd, 0x08, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
+  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
+  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
+  0xe4, 0xfe, 0x6d, 0x02, 0xaf, 0x0e, 0x25, 0x3f, 0x41, 0x3e, 0xcf, 0xbe,
+  0x44, 0x4c, 0x15, 0x19, 0x44, 0x01, 0x20, 0x20, 0x31, 0x0e, 0x1d, 0x47,
+  0x01, 0x4e, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x64, 0xce, 0x6e, 0x8b,
+  0x8a, 0x6e, 0xce, 0xfe, 0x17, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e, 0x2e,
+  0x58, 0x8d, 0x76, 0x4e, 0x3e, 0x01, 0x23, 0x01, 0x75, 0x02, 0x0f, 0xfd,
+  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
+  0x40, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3c,
+  0x00, 0x00, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
+  0x06, 0x15, 0x21, 0x34, 0x36, 0x32, 0x16, 0x15, 0x23, 0x34, 0x26, 0x22,
+  0x06, 0x15, 0x03, 0x37, 0x27, 0x37, 0x17, 0x15, 0x07, 0x17, 0x15, 0x07,
+  0x27, 0x37, 0x27, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x01, 0xe1, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37,
+  0x01, 0x9b, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xde, 0x48, 0x82,
+  0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48, 0xfd, 0x08, 0x01, 0xd9,
+  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
+  0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe,
+  0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x03, 0x8c, 0x8b, 0xc5, 0xc5,
+  0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77,
+  0x53, 0xfe, 0x5d, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e, 0x2e, 0x58, 0x8d,
+  0x76, 0x4e, 0x3e, 0x01, 0x23, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
+  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0c,
+  0x00, 0x18, 0x00, 0x24, 0x00, 0x30, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x37,
+  0x27, 0x37, 0x17, 0x15, 0x07, 0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x01,
+  0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x21,
+  0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03,
+  0x91, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48, 0x02,
+  0x11, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0,
+  0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01,
+  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
+  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
+  0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0xe9, 0x3e, 0x4e, 0x76, 0x8d, 0x58, 0x2e,
+  0x2e, 0x58, 0x8d, 0x76, 0x4e, 0x3e, 0x02, 0xc1, 0x8b, 0xc5, 0xc5, 0x8b,
+  0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53,
+  0xfe, 0x62, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c,
+  0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
+  0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x06, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22,
+  0x00, 0x2e, 0x00, 0x38, 0x00, 0x3e, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x25, 0x35, 0x21, 0x15, 0x23,
+  0x14, 0x06, 0x22, 0x26, 0x35, 0x21, 0x23, 0x14, 0x16, 0x32, 0x36, 0x02,
+  0x42, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a,
+  0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0xc8, 0x01, 0x93, 0x01, 0x1c,
+  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
+  0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
+  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x78, 0x03, 0x60, 0xda, 0x7e, 0xb0,
+  0x7e, 0x01, 0x33, 0xba, 0x37, 0x4c, 0x37, 0x03, 0xff, 0x3b, 0x51, 0x51,
+  0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53,
+  0xdb, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
+  0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x63, 0x87, 0x87, 0x8b, 0xc5,
+  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a, 0x00, 0x11, 0x00, 0x1d,
+  0x00, 0x29, 0x00, 0x33, 0x00, 0x39, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x2d, 0x01, 0x17, 0x07, 0x17,
+  0x07, 0x25, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x25, 0x35, 0x21, 0x15, 0x23, 0x14, 0x06, 0x22, 0x26, 0x35,
+  0x21, 0x23, 0x14, 0x16, 0x32, 0x36, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
+  0x4a, 0x34, 0x35, 0x49, 0x01, 0xc7, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45,
+  0xfe, 0xf6, 0xfd, 0x09, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x01, 0x78, 0x03, 0x60, 0xda, 0x7e, 0xb0, 0x7e, 0x01, 0x33, 0xba,
+  0x37, 0x4c, 0x37, 0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x64,
+  0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0xe8, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
+  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01,
+  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
+  0x0c, 0x63, 0x87, 0x87, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x00,
+  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
+  0x00, 0x17, 0x00, 0x1e, 0x00, 0x25, 0x00, 0x2f, 0x00, 0x35, 0x00, 0x00,
+  0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x01, 0x15, 0x05, 0x27, 0x37, 0x27, 0x37, 0x05, 0x25, 0x17, 0x07, 0x17,
+  0x07, 0x25, 0x01, 0x35, 0x21, 0x15, 0x23, 0x14, 0x06, 0x22, 0x26, 0x35,
+  0x21, 0x23, 0x14, 0x16, 0x32, 0x36, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c,
+  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
+  0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
+  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x02, 0xe0, 0xfe, 0xf7, 0x46, 0xb3, 0xb3,
+  0x46, 0x01, 0x99, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0xfe,
+  0x08, 0x03, 0x60, 0xda, 0x7e, 0xb0, 0x7e, 0x01, 0x33, 0xba, 0x37, 0x4c,
+  0x37, 0x02, 0xea, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01,
+  0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd,
+  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x02, 0xb1, 0x55,
+  0xce, 0x6e, 0x8a, 0x8b, 0x6e, 0xce, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce,
+  0xfe, 0x07, 0x87, 0x87, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x00,
+  0x00, 0x07, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x29, 0x00, 0x35, 0x00, 0x46,
+  0x00, 0x00, 0x01, 0x25, 0x37, 0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34,
+  0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36,
+  0x20, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06,
+  0x07, 0x05, 0x7b, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc, 0x47, 0x45, 0x01,
+  0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02,
+  0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9,
+  0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1,
+  0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe,
+  0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x21, 0x2d, 0xa4, 0x01,
+  0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6, 0x7f, 0x24,
+  0x1a, 0x04, 0x16, 0xf0, 0x6f, 0xf1, 0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf,
+  0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a,
+  0x53, 0x53, 0x91, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe,
+  0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
+  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd, 0x25, 0x38,
+  0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27,
+  0x2c, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x22, 0x00, 0x2d,
+  0x00, 0x39, 0x00, 0x45, 0x00, 0x56, 0x00, 0x00, 0x25, 0x27, 0x36, 0x37,
+  0x36, 0x32, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06,
+  0x01, 0x25, 0x37, 0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36, 0x20, 0x17,
+  0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x03,
+  0x73, 0x6d, 0x0e, 0x16, 0x3f, 0xb0, 0x3f, 0x16, 0x0e, 0x6c, 0x07, 0x07,
+  0x1b, 0x4c, 0x1b, 0x07, 0x02, 0x02, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc,
+  0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34,
+  0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc,
+  0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
+  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
+  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x21,
+  0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6,
+  0xb6, 0x7f, 0x24, 0x1a, 0x9f, 0x39, 0x28, 0x22, 0x62, 0x62, 0x22, 0x28,
+  0x39, 0x13, 0x10, 0x3c, 0x3c, 0x10, 0x03, 0x64, 0xf0, 0x6f, 0xf1, 0x6e,
+  0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a,
+  0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01, 0x75, 0x02, 0x0f,
+  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74,
+  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0,
+  0xfe, 0x40, 0xfd, 0x25, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c,
+  0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c, 0x00, 0x00, 0x00, 0x07, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x0e, 0x00, 0x19,
+  0x00, 0x1d, 0x00, 0x29, 0x00, 0x35, 0x00, 0x46, 0x00, 0x00, 0x01, 0x17,
+  0x05, 0x27, 0x05, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x01, 0x05, 0x07, 0x25, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x13, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17,
+  0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x04, 0xf9, 0x45,
+  0xfe, 0xef, 0x45, 0xfe, 0x5a, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35,
+  0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfe, 0x40,
+  0x01, 0x10, 0x45, 0xfe, 0xef, 0xfe, 0x55, 0x01, 0xd9, 0x01, 0x4f, 0x01,
+  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
+  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
+  0xfe, 0xe4, 0xfe, 0x6d, 0xd5, 0x21, 0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e,
+  0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6, 0x7f, 0x24, 0x1a, 0x05, 0x67,
+  0x6e, 0xd5, 0x6f, 0xde, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b,
+  0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x01, 0xec, 0xd4, 0x6f, 0xd5, 0xfd,
+  0xf1, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
+  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
+  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfd, 0x25, 0x38, 0x33, 0xb5,
+  0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c, 0x00,
+  0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x10,
+  0x00, 0x1c, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x37, 0x00, 0x42, 0x00, 0x46,
+  0x00, 0x56, 0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17,
+  0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x01, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x05, 0x07,
+  0x25, 0x01, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x01,
+  0x17, 0x05, 0x27, 0x03, 0x27, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17,
+  0x07, 0x26, 0x27, 0x26, 0x22, 0x07, 0x06, 0x01, 0xe7, 0x21, 0x2d, 0xa4,
+  0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6, 0x7f,
+  0x24, 0x1a, 0xfe, 0xc4, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x01, 0xf1, 0x01, 0x10, 0x45, 0xfe, 0xef, 0x02, 0x06, 0x4a, 0x68,
+  0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfd, 0xf8, 0x49, 0x35, 0x34, 0x4a, 0x4a,
+  0x34, 0x35, 0x49, 0x02, 0xb7, 0x45, 0xfe, 0xef, 0x45, 0x75, 0x6d, 0x0e,
+  0x16, 0x3f, 0xb0, 0x3f, 0x16, 0x0e, 0x6c, 0x07, 0x07, 0x1b, 0x4c, 0x1b,
+  0x07, 0x01, 0x4c, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27,
+  0x8e, 0x01, 0x8e, 0x27, 0x2c, 0x01, 0xe5, 0xfe, 0xc4, 0xfe, 0x43, 0x01,
+  0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01,
+  0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02,
+  0x0c, 0x03, 0xf1, 0xd4, 0x6f, 0xd5, 0xfe, 0xbc, 0x3b, 0x51, 0x51, 0x3b,
+  0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x01, 0xec,
+  0x6e, 0xd5, 0x6f, 0xfc, 0x0c, 0x39, 0x28, 0x22, 0x62, 0x62, 0x22, 0x28,
+  0x39, 0x13, 0x10, 0x3c, 0x3c, 0x10, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23,
+  0x00, 0x34, 0x00, 0x4f, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x14, 0x06, 0x22, 0x26, 0x35,
+  0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17,
+  0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x01,
+  0x14, 0x07, 0x06, 0x07, 0x17, 0x16, 0x07, 0x14, 0x07, 0x06, 0x22, 0x26,
+  0x35, 0x34, 0x3f, 0x01, 0x26, 0x27, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32,
+  0x36, 0x35, 0x01, 0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x02, 0xf4, 0x7e, 0xb0, 0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfe, 0xd3,
+  0x21, 0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80,
+  0xb6, 0xb6, 0x7f, 0x24, 0x1a, 0x03, 0x54, 0x3f, 0x34, 0x46, 0x1d, 0x19,
+  0x01, 0x18, 0x18, 0x45, 0x30, 0x18, 0x1d, 0x45, 0x35, 0x3f, 0x7a, 0x37,
+  0x4b, 0x37, 0x02, 0xea, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c,
+  0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f,
+  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x03, 0x12,
+  0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfc, 0xc4, 0x38, 0x33,
+  0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c,
+  0x03, 0x83, 0x8c, 0x62, 0x51, 0x0e, 0x3f, 0x37, 0x23, 0x2b, 0x1a, 0x1b,
+  0x36, 0x2c, 0x23, 0x35, 0x3f, 0x0d, 0x52, 0x62, 0x8c, 0x53, 0x77, 0x77,
+  0x53, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x10, 0x00, 0x17, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x36,
+  0x00, 0x00, 0x01, 0x36, 0x37, 0x36, 0x20, 0x17, 0x16, 0x17, 0x07, 0x26,
+  0x27, 0x26, 0x23, 0x26, 0x07, 0x06, 0x07, 0x01, 0x25, 0x17, 0x07, 0x17,
+  0x07, 0x25, 0x27, 0x15, 0x05, 0x27, 0x37, 0x27, 0x37, 0x01, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0xe7, 0x21,
+  0x2d, 0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6,
+  0xb6, 0x7f, 0x24, 0x1a, 0x01, 0xbb, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45,
+  0xfe, 0xf6, 0x90, 0xfe, 0xf7, 0x46, 0xb3, 0xb3, 0x46, 0xfe, 0x29, 0x01,
+  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
+  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x4c, 0x38, 0x33,
+  0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e, 0x01, 0x8e, 0x27, 0x2c,
+  0x03, 0x22, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0x55, 0x55, 0xce, 0x6e,
+  0x8a, 0x8b, 0x6e, 0xfd, 0xf5, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
+  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00,
+  0x00, 0x06, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x18, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x39, 0x00, 0x00,
+  0x01, 0x27, 0x13, 0x17, 0x01, 0x03, 0x37, 0x13, 0x01, 0x36, 0x37, 0x36,
+  0x20, 0x17, 0x16, 0x17, 0x07, 0x26, 0x27, 0x26, 0x23, 0x26, 0x07, 0x06,
+  0x07, 0x01, 0x17, 0x16, 0x0e, 0x01, 0x22, 0x26, 0x34, 0x37, 0x05, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x03, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x82,
+  0x56, 0xf3, 0x56, 0x01, 0x8c, 0xf3, 0x55, 0xf3, 0xfc, 0x91, 0x21, 0x2d,
+  0xa4, 0x01, 0xd0, 0xa4, 0x2e, 0x21, 0x68, 0x19, 0x24, 0x80, 0xb6, 0xb6,
+  0x7f, 0x24, 0x1a, 0x03, 0x78, 0x3b, 0x19, 0x01, 0x31, 0x44, 0x31, 0x19,
+  0xfb, 0x86, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
+  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01,
+  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x03,
+  0x5c, 0x5f, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x01, 0x0e, 0x5f, 0xfe, 0xf2,
+  0xfd, 0x91, 0x38, 0x33, 0xb5, 0xb5, 0x33, 0x38, 0x48, 0x2c, 0x27, 0x8e,
+  0x01, 0x8e, 0x27, 0x2c, 0x03, 0x23, 0x80, 0x35, 0x4f, 0x36, 0x36, 0x4f,
+  0x35, 0xbe, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d,
+  0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
+  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x00, 0x06, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b, 0x00, 0x16, 0x00, 0x22,
+  0x00, 0x2e, 0x00, 0x34, 0x00, 0x3c, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32,
+  0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20,
+  0x00, 0x05, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x02, 0x42, 0x49,
+  0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b,
+  0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
+  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
+  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
+  0xe4, 0xfe, 0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01,
+  0x0a, 0xfc, 0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e,
+  0x03, 0xff, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b, 0x51,
+  0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
+  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
+  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
+  0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe, 0xba, 0x61, 0x60, 0x4c, 0x74, 0x75,
+  0x4c, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x29,
+  0x00, 0x35, 0x00, 0x3b, 0x00, 0x43, 0x00, 0x00, 0x01, 0x25, 0x37, 0x0d,
+  0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23,
+  0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20, 0x00, 0x05, 0x21, 0x26, 0x27,
+  0x26, 0x20, 0x07, 0x06, 0x05, 0x7b, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc,
+  0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34,
+  0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc,
+  0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe,
+  0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d,
+  0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x04, 0x75,
+  0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01, 0x0a, 0xfc, 0xfe, 0x02, 0x77,
+  0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e, 0x04, 0x16, 0xf0, 0x6f, 0xf1,
+  0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53,
+  0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01, 0x75, 0x02,
+  0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01,
+  0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01,
+  0xc0, 0xfe, 0x40, 0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe, 0xba, 0x61, 0x60,
+  0x4c, 0x74, 0x75, 0x4c, 0x00, 0x0e, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x13, 0x00, 0x19, 0x00, 0x4e, 0x00, 0x5a,
+  0x00, 0x66, 0x00, 0x6c, 0x00, 0x78, 0x00, 0x84, 0x00, 0x8a, 0x00, 0x90,
+  0x00, 0x96, 0x00, 0x9c, 0x00, 0xa2, 0x00, 0x00, 0x01, 0x14, 0x16, 0x33,
+  0x32, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x01, 0x21, 0x26, 0x27,
+  0x26, 0x20, 0x07, 0x06, 0x05, 0x21, 0x34, 0x00, 0x20, 0x00, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x34, 0x27, 0x15, 0x23, 0x11, 0x26, 0x27,
+  0x11, 0x23, 0x35, 0x0e, 0x01, 0x22, 0x27, 0x23, 0x35, 0x26, 0x34, 0x37,
+  0x11, 0x26, 0x27, 0x11, 0x23, 0x11, 0x06, 0x07, 0x11, 0x16, 0x14, 0x07,
+  0x15, 0x23, 0x06, 0x22, 0x26, 0x27, 0x15, 0x23, 0x11, 0x06, 0x07, 0x11,
+  0x23, 0x35, 0x06, 0x07, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x25, 0x36, 0x37, 0x35, 0x06, 0x07, 0x13, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x27, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x01, 0x15, 0x16,
+  0x17, 0x35, 0x26, 0x27, 0x26, 0x27, 0x15, 0x36, 0x3f, 0x01, 0x26, 0x27,
+  0x15, 0x16, 0x17, 0x25, 0x06, 0x07, 0x15, 0x36, 0x3f, 0x01, 0x06, 0x07,
+  0x15, 0x16, 0x17, 0x04, 0x21, 0x68, 0x43, 0x4c, 0x5f, 0x64, 0x47, 0x45,
+  0x66, 0xfe, 0x64, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e,
+  0x02, 0xec, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01, 0x0a, 0xfb, 0x8b,
+  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0x30, 0x3d, 0x1b, 0x21,
+  0x3d, 0x1b, 0x62, 0x80, 0x33, 0x3d, 0x27, 0x27, 0x1e, 0x1e, 0x3d, 0x1f,
+  0x1e, 0x27, 0x27, 0x3d, 0x32, 0x80, 0x63, 0x1a, 0x3d, 0x22, 0x1b, 0x3d,
+  0x31, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29,
+  0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x03, 0xff, 0x1f, 0x15, 0x15, 0x1e,
+  0x1c, 0x17, 0x14, 0x20, 0xfd, 0xdb, 0x1d, 0x20, 0x20, 0x1d, 0xef, 0x67,
+  0x44, 0x47, 0x64, 0x5e, 0x4d, 0x42, 0x69, 0x78, 0x1f, 0x14, 0x18, 0x1b,
+  0x1d, 0x16, 0x15, 0x1e, 0x01, 0xe9, 0x20, 0x1c, 0x1d, 0x5c, 0x1e, 0x1f,
+  0x1c, 0x21, 0xf3, 0x1e, 0x1f, 0x27, 0x16, 0xfc, 0xad, 0x1f, 0x1d, 0x16,
+  0x26, 0xf3, 0x1f, 0x1d, 0x20, 0x1c, 0x04, 0x1a, 0x52, 0x6c, 0x75, 0x49,
+  0x4f, 0x6f, 0x6f, 0xfc, 0xe9, 0x60, 0x4c, 0x74, 0x75, 0x4c, 0xe6, 0xe8,
+  0x01, 0x46, 0xfe, 0xba, 0x01, 0x37, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd,
+  0x01, 0x3c, 0x9b, 0x85, 0xba, 0x01, 0x3b, 0x2e, 0x29, 0xfe, 0x6e, 0x59,
+  0x36, 0x47, 0x24, 0x40, 0x3c, 0x9c, 0x3c, 0x01, 0x3d, 0x04, 0x01, 0xfd,
+  0x6a, 0x02, 0x96, 0x01, 0x04, 0xfe, 0xc3, 0x3c, 0x9c, 0x3c, 0x40, 0x24,
+  0x46, 0x37, 0x59, 0x01, 0x93, 0x2a, 0x2e, 0xfe, 0xc5, 0xbc, 0x86, 0x9c,
+  0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4,
+  0x02, 0x0c, 0x02, 0xa4, 0x18, 0x21, 0x21, 0x18, 0x16, 0x23, 0x20, 0xfc,
+  0x0a, 0x01, 0xa2, 0x0f, 0x12, 0xfe, 0x91, 0x4f, 0x6f, 0x6f, 0x4f, 0x49,
+  0x75, 0x6c, 0x52, 0x19, 0x20, 0x23, 0x16, 0x18, 0x21, 0x21, 0x01, 0x79,
+  0xa3, 0x01, 0x0a, 0x8c, 0x13, 0x28, 0x0a, 0x08, 0xf2, 0x14, 0x09, 0x26,
+  0x1e, 0x18, 0x84, 0x21, 0x2d, 0xd2, 0x19, 0x1d, 0x9c, 0x2d, 0x21, 0xfd,
+  0x07, 0x0b, 0xc3, 0x09, 0x14, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x1b, 0x00, 0x27, 0x00, 0x2d, 0x00, 0x35, 0x00, 0x00,
+  0x01, 0x27, 0x13, 0x17, 0x01, 0x03, 0x37, 0x13, 0x01, 0x27, 0x13, 0x17,
+  0x01, 0x03, 0x37, 0x13, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20, 0x00, 0x05, 0x21,
+  0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x02, 0x82, 0x56, 0xf3, 0x56, 0x01,
+  0x8c, 0xf3, 0x55, 0xf3, 0xfd, 0x2c, 0x56, 0xf3, 0x56, 0x01, 0x8c, 0xf3,
+  0x55, 0xf3, 0xfb, 0x43, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7,
+  0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01,
+  0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe,
+  0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01, 0x0a, 0xfc,
+  0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e, 0x04, 0x13,
+  0x5f, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0xfe,
+  0x58, 0x5f, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x01, 0x0e, 0x5f, 0xfe, 0xf2,
+  0x3f, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
+  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
+  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfc, 0xa4, 0xe8, 0x01, 0x46,
+  0xfe, 0xba, 0x61, 0x60, 0x4c, 0x74, 0x75, 0x4c, 0x00, 0x07, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x11, 0x00, 0x1d, 0x00, 0x29,
+  0x00, 0x35, 0x00, 0x41, 0x00, 0x47, 0x00, 0x4f, 0x00, 0x00, 0x01, 0x37,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x03, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14,
+  0x16, 0x32, 0x36, 0x35, 0x21, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14,
+  0x16, 0x32, 0x36, 0x35, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x01, 0x21, 0x34, 0x00, 0x20, 0x00, 0x05, 0x21,
+  0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x05, 0x30, 0x4d, 0x21, 0x1c, 0x17,
+  0x13, 0x0c, 0x0c, 0x20, 0x10, 0x09, 0x04, 0x0b, 0x23, 0x1c, 0x35, 0x10,
+  0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0, 0x7e,
+  0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
+  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
+  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
+  0xe4, 0xfe, 0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79, 0x01,
+  0x0a, 0xfc, 0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e,
+  0x02, 0xc8, 0x74, 0x32, 0x0f, 0x0b, 0x04, 0x0c, 0x22, 0x14, 0x15, 0x0e,
+  0x0f, 0x24, 0x14, 0x10, 0x01, 0xc0, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77,
+  0x77, 0x53, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfe, 0x62,
+  0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4,
+  0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c,
+  0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe,
+  0xba, 0x61, 0x60, 0x4c, 0x74, 0x75, 0x4c, 0x00, 0x00, 0x06, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x06, 0x00, 0x0d, 0x00, 0x19,
+  0x00, 0x25, 0x00, 0x2b, 0x00, 0x33, 0x00, 0x00, 0x01, 0x25, 0x17, 0x07,
+  0x17, 0x07, 0x25, 0x27, 0x15, 0x05, 0x27, 0x37, 0x27, 0x37, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x21,
+  0x34, 0x00, 0x20, 0x00, 0x05, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06,
+  0x04, 0x09, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0x90, 0xfe,
+  0xf7, 0x46, 0xb3, 0xb3, 0x46, 0xfe, 0x29, 0x01, 0xd9, 0x01, 0x4f, 0x01,
+  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
+  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
+  0xfe, 0xe4, 0xfe, 0x6d, 0x04, 0x75, 0xfc, 0x74, 0x01, 0x09, 0x01, 0x79,
+  0x01, 0x0a, 0xfc, 0xfe, 0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f,
+  0x3e, 0x04, 0x27, 0xce, 0x6e, 0x8b, 0x8a, 0x6e, 0xce, 0x55, 0x55, 0xce,
+  0x6e, 0x8a, 0x8b, 0x6e, 0xfd, 0xf5, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
+  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
+  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
+  0xfc, 0xa4, 0xe8, 0x01, 0x46, 0xfe, 0xba, 0x61, 0x60, 0x4c, 0x74, 0x75,
+  0x4c, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x55, 0xff, 0x6a, 0x08, 0x14,
+  0x06, 0x6e, 0x00, 0x05, 0x00, 0x0c, 0x00, 0x13, 0x00, 0x3d, 0x00, 0x62,
+  0x00, 0x00, 0x25, 0x21, 0x34, 0x00, 0x20, 0x00, 0x01, 0x15, 0x05, 0x27,
+  0x37, 0x27, 0x37, 0x05, 0x25, 0x17, 0x07, 0x17, 0x07, 0x25, 0x05, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x14, 0x07, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x06, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x02, 0x07, 0x02, 0x21, 0x20,
+  0x03, 0x26, 0x03, 0x07, 0x06, 0x07, 0x06, 0x22, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x3f, 0x01, 0x26, 0x37, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
+  0x27, 0x06, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x17, 0x16, 0x17, 0x26,
+  0x27, 0x26, 0x21, 0x20, 0x07, 0x06, 0x07, 0x36, 0x3f, 0x01, 0x07, 0x06,
+  0x07, 0x06, 0x22, 0x27, 0x06, 0x05, 0xfa, 0xfc, 0x74, 0x01, 0x09, 0x01,
+  0x79, 0x01, 0x0a, 0xfd, 0xf2, 0xfe, 0xf7, 0x45, 0xb2, 0xb2, 0x45, 0x01,
+  0x99, 0x01, 0x0a, 0x45, 0xb2, 0xb2, 0x45, 0xfe, 0xf6, 0xfc, 0x90, 0x01,
+  0xda, 0x01, 0x4e, 0x01, 0x50, 0x01, 0xd8, 0x02, 0x54, 0x35, 0x15, 0x1b,
+  0x30, 0x45, 0x1c, 0x16, 0x10, 0x0a, 0x26, 0xbc, 0xec, 0xfe, 0xb0, 0xfe,
+  0xb2, 0xed, 0xbc, 0x27, 0x09, 0x10, 0x17, 0x1c, 0x44, 0x30, 0x1a, 0x15,
+  0x36, 0x53, 0x02, 0x7a, 0x01, 0x92, 0x01, 0x1c, 0x01, 0x1e, 0x01, 0x90,
+  0x01, 0x18, 0x21, 0x22, 0x1c, 0x17, 0x10, 0x29, 0x7b, 0x25, 0x15, 0x2a,
+  0x8b, 0xc7, 0xfe, 0xe1, 0xfe, 0xe4, 0xca, 0x8a, 0x2a, 0x15, 0x25, 0x7a,
+  0x28, 0x10, 0x17, 0x1c, 0x44, 0x18, 0x01, 0xcb, 0xe8, 0x01, 0x46, 0xfe,
+  0xba, 0x02, 0x74, 0x55, 0xce, 0x6e, 0x8a, 0x8b, 0x6e, 0xce, 0xce, 0x6e,
+  0x8b, 0x8a, 0x6e, 0xce, 0xe8, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0x1d, 0x1b, 0x1f, 0x14, 0x18, 0x1f, 0x25, 0x26, 0x36, 0x1f, 0x19,
+  0x39, 0x20, 0xfe, 0xe9, 0xd1, 0xfe, 0xfa, 0x01, 0x06, 0xd0, 0x01, 0x16,
+  0x1e, 0x39, 0x19, 0x1f, 0x36, 0x26, 0x25, 0x1f, 0x19, 0x13, 0x1e, 0x1c,
+  0x1d, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x14, 0x13, 0x1a,
+  0x1f, 0x19, 0x39, 0x88, 0x2d, 0x0e, 0x0f, 0xc7, 0x9a, 0xe0, 0xe0, 0x9b,
+  0xc6, 0x10, 0x0d, 0x2d, 0x88, 0x39, 0x19, 0x1f, 0x1b, 0x14, 0x00, 0x00,
+  0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x07,
+  0x00, 0x13, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x36, 0x00, 0x00, 0x00, 0x34,
+  0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x34, 0x36, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15,
+  0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11,
+  0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0xdb, 0x87, 0xbf, 0x87, 0x87, 0xbf,
+  0xfe, 0xe0, 0x49, 0x35, 0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08,
+  0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35, 0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01,
+  0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe,
+  0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f,
+  0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x01, 0x5a, 0xd4, 0x96, 0x96, 0xd4,
+  0x96, 0x03, 0x3b, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0x3a, 0x3b,
+  0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xdb, 0x01, 0x75, 0x02, 0x0f, 0xfd,
+  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe,
+  0x40, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x03, 0x00, 0x07, 0x00, 0x12, 0x00, 0x1d, 0x00, 0x25,
+  0x00, 0x31, 0x00, 0x3d, 0x00, 0x00, 0x01, 0x25, 0x37, 0x0d, 0x01, 0x27,
+  0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14, 0x06, 0x23, 0x22,
+  0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x02, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x05, 0x7b, 0xfe, 0xcb,
+  0x45, 0x01, 0x35, 0xfc, 0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35,
+  0x34, 0x4a, 0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b,
+  0x34, 0x35, 0x49, 0xfc, 0x44, 0x5f, 0x43, 0x43, 0x5f, 0xfd, 0x07, 0x01,
+  0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe,
+  0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91,
+  0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x04, 0x16, 0xf0, 0x6f,
+  0xf1, 0x6e, 0x6e, 0xf1, 0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52,
+  0x53, 0x3a, 0x3b, 0x51, 0x51, 0x3b, 0x3a, 0x53, 0x53, 0xfe, 0x14, 0x6a,
+  0x4b, 0x4b, 0x6a, 0x4b, 0x01, 0xa6, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
+  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
+  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
+  0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x08,
+  0x00, 0x10, 0x00, 0x14, 0x00, 0x18, 0x00, 0x23, 0x00, 0x2e, 0x00, 0x3a,
+  0x00, 0x46, 0x00, 0x00, 0x01, 0x17, 0x16, 0x14, 0x06, 0x22, 0x26, 0x34,
+  0x37, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x25, 0x37,
+  0x0d, 0x01, 0x27, 0x25, 0x17, 0x03, 0x34, 0x36, 0x33, 0x32, 0x16, 0x14,
+  0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16, 0x15, 0x14, 0x06,
+  0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00,
+  0x21, 0x20, 0x00, 0x05, 0xae, 0x3b, 0x18, 0x30, 0x45, 0x30, 0x18, 0xfd,
+  0x67, 0x87, 0xbf, 0x87, 0x87, 0xbf, 0x02, 0x19, 0xfe, 0xcb, 0x45, 0x01,
+  0x35, 0xfc, 0x47, 0x45, 0x01, 0x36, 0x45, 0xfb, 0x49, 0x35, 0x34, 0x4a,
+  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
+  0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
+  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
+  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
+  0x03, 0xac, 0x80, 0x35, 0x4f, 0x36, 0x36, 0x4f, 0x35, 0xfe, 0x2e, 0xd4,
+  0x96, 0x96, 0xd4, 0x96, 0x03, 0x52, 0xf0, 0x6f, 0xf1, 0x6e, 0x6e, 0xf1,
+  0x6f, 0xfe, 0xaf, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51,
+  0x51, 0x3b, 0x3a, 0x53, 0x53, 0x91, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1,
+  0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4,
+  0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40,
+  0x00, 0x07, 0x00, 0x1f, 0xff, 0x3c, 0x07, 0x63, 0x06, 0x6e, 0x00, 0x07,
+  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1f, 0x00, 0x6b, 0x00, 0x94,
+  0x00, 0x00, 0x00, 0x26, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x20, 0x26,
+  0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x2f, 0x01, 0x25, 0x17, 0x05, 0x25,
+  0x37, 0x05, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x35,
+  0x2e, 0x01, 0x27, 0x02, 0x11, 0x34, 0x36, 0x37, 0x36, 0x37, 0x12, 0x20,
+  0x13, 0x16, 0x17, 0x1e, 0x01, 0x15, 0x10, 0x03, 0x0e, 0x01, 0x07, 0x15,
+  0x23, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x13, 0x34, 0x26, 0x22, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x0f, 0x01, 0x0e, 0x01, 0x1d, 0x01, 0x23, 0x35,
+  0x06, 0x22, 0x27, 0x15, 0x23, 0x35, 0x34, 0x26, 0x2f, 0x01, 0x26, 0x27,
+  0x26, 0x27, 0x2e, 0x01, 0x22, 0x06, 0x15, 0x12, 0x17, 0x16, 0x17, 0x16,
+  0x1d, 0x01, 0x25, 0x16, 0x32, 0x37, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x3e, 0x01, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27,
+  0x26, 0x20, 0x07, 0x06, 0x07, 0x16, 0x17, 0x1e, 0x02, 0x17, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x04, 0x93, 0x49, 0x4a, 0x68, 0x4b,
+  0x4b, 0xfd, 0x8f, 0x49, 0x49, 0x69, 0x4a, 0x4a, 0xed, 0x45, 0x01, 0x36,
+  0x45, 0x02, 0x3e, 0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfd, 0x1b, 0x87, 0xbf,
+  0x87, 0x87, 0xbf, 0xfd, 0xde, 0x41, 0x4e, 0x15, 0x7c, 0x5d, 0x37, 0x35,
+  0x9d, 0xec, 0x02, 0x9f, 0xec, 0x9c, 0x35, 0x37, 0x5e, 0x7c, 0x16, 0x4d,
+  0x41, 0x7a, 0x23, 0x74, 0x1a, 0x6e, 0x01, 0x23, 0x34, 0x21, 0x06, 0x0c,
+  0x5f, 0x25, 0x32, 0x55, 0x23, 0x18, 0x7a, 0x63, 0xeb, 0x6d, 0x7b, 0x18,
+  0x23, 0x55, 0x32, 0x25, 0x5e, 0x0d, 0x05, 0x22, 0x34, 0x23, 0x02, 0x6e,
+  0x1a, 0x74, 0x22, 0x01, 0x2b, 0x6b, 0xee, 0x62, 0x18, 0x2b, 0x83, 0x32,
+  0x0f, 0x36, 0x10, 0x01, 0x08, 0x0a, 0x0b, 0x2e, 0x0e, 0x0f, 0x2d, 0x81,
+  0xc8, 0xfd, 0xc6, 0xca, 0x81, 0x2d, 0x10, 0x0d, 0x2e, 0x16, 0x07, 0x02,
+  0x0f, 0x36, 0x0f, 0x33, 0x82, 0x2c, 0x18, 0x03, 0x28, 0x53, 0x75, 0x51,
+  0x51, 0x75, 0x53, 0x53, 0x75, 0x51, 0x51, 0x76, 0x52, 0xee, 0x6e, 0xf1,
+  0x6f, 0xf0, 0xf0, 0x6f, 0xf1, 0xfc, 0xd6, 0xd4, 0x96, 0x96, 0xd4, 0x96,
+  0xfe, 0x78, 0xcb, 0x3e, 0x5b, 0x31, 0x01, 0x17, 0x01, 0x27, 0x53, 0x6b,
+  0x0a, 0xdf, 0xb0, 0x01, 0x08, 0xfe, 0xf8, 0xaf, 0xe0, 0x0a, 0x6b, 0x53,
+  0xfe, 0xd9, 0xfe, 0xe9, 0x31, 0x5b, 0x3e, 0xcb, 0xe7, 0x24, 0x1f, 0x6e,
+  0x39, 0xf0, 0x01, 0x12, 0x1c, 0x28, 0x23, 0x6d, 0xf3, 0x71, 0x2c, 0x25,
+  0x40, 0x1c, 0x3c, 0x3f, 0xfb, 0x4c, 0x1e, 0x20, 0x4e, 0xfb, 0x3f, 0x3c,
+  0x1c, 0x40, 0x25, 0x2c, 0x71, 0xf3, 0x6d, 0x23, 0x28, 0x1c, 0xfe, 0xee,
+  0xf0, 0x39, 0x6e, 0x1f, 0x24, 0xe7, 0xdb, 0x26, 0x25, 0x21, 0x59, 0x3b,
+  0x65, 0x56, 0x22, 0x13, 0x44, 0x78, 0x0f, 0x86, 0x38, 0x36, 0x30, 0x0e,
+  0x0a, 0xb5, 0x90, 0xe0, 0xe0, 0x8f, 0xb5, 0x0b, 0x0e, 0x30, 0x6e, 0x86,
+  0x0f, 0x78, 0x44, 0x13, 0x22, 0x56, 0x65, 0x3b, 0x59, 0x00, 0x00, 0x00,
+  0x00, 0x09, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
+  0x00, 0x17, 0x00, 0x23, 0x00, 0x2f, 0x00, 0x3b, 0x00, 0x47, 0x00, 0x4f,
+  0x00, 0x5b, 0x00, 0x67, 0x00, 0x00, 0x01, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x34, 0x36, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x37, 0x14, 0x16, 0x33, 0x32, 0x36,
+  0x35, 0x34, 0x26, 0x23, 0x22, 0x06, 0x17, 0x34, 0x36, 0x33, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x26, 0x23, 0x22, 0x06,
+  0x15, 0x14, 0x16, 0x33, 0x32, 0x36, 0x27, 0x14, 0x06, 0x23, 0x22, 0x26,
+  0x35, 0x34, 0x36, 0x33, 0x32, 0x16, 0x02, 0x34, 0x36, 0x32, 0x16, 0x14,
+  0x06, 0x22, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x03, 0x8d, 0x83, 0x53, 0x60, 0x76, 0x7d, 0x59, 0x55, 0x81,
+  0x68, 0x81, 0x56, 0x59, 0x7d, 0x77, 0x5f, 0x53, 0x84, 0x2c, 0x68, 0x43,
+  0x4c, 0x5f, 0x64, 0x47, 0x45, 0x66, 0x77, 0x1f, 0x15, 0x15, 0x1e, 0x1c,
+  0x17, 0x14, 0x20, 0xfe, 0xca, 0x67, 0x44, 0x47, 0x64, 0x5e, 0x4d, 0x42,
+  0x69, 0x78, 0x1f, 0x14, 0x18, 0x1b, 0x1d, 0x16, 0x15, 0x1e, 0x0f, 0x87,
+  0xbf, 0x87, 0x87, 0xbf, 0xfd, 0x37, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
+  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01,
+  0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe,
+  0xe4, 0xfe, 0x6d, 0x04, 0x1a, 0x66, 0x88, 0x93, 0x5b, 0x63, 0x8b, 0x8b,
+  0x63, 0x63, 0x8b, 0x8b, 0x63, 0x5b, 0x93, 0x88, 0x66, 0x52, 0x6c, 0x75,
+  0x49, 0x4f, 0x6f, 0x6f, 0x4f, 0x18, 0x21, 0x21, 0x18, 0x16, 0x23, 0x20,
+  0x19, 0x4f, 0x6f, 0x6f, 0x4f, 0x49, 0x75, 0x6c, 0x52, 0x19, 0x20, 0x23,
+  0x16, 0x18, 0x21, 0x21, 0xfd, 0x28, 0xd4, 0x96, 0x96, 0xd4, 0x96, 0x02,
+  0x26, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd,
+  0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01,
+  0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00, 0x00, 0x0a, 0x00, 0x99,
+  0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x4a, 0x00, 0x56, 0x00, 0x5e,
+  0x00, 0x62, 0x00, 0x66, 0x00, 0x6b, 0x00, 0x70, 0x00, 0x74, 0x00, 0x79,
+  0x00, 0x7e, 0x00, 0x00, 0x01, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x34,
+  0x27, 0x11, 0x23, 0x11, 0x26, 0x27, 0x15, 0x17, 0x07, 0x11, 0x23, 0x35,
+  0x23, 0x15, 0x23, 0x35, 0x23, 0x15, 0x23, 0x35, 0x23, 0x15, 0x23, 0x11,
+  0x33, 0x11, 0x33, 0x11, 0x27, 0x37, 0x17, 0x35, 0x26, 0x20, 0x07, 0x15,
+  0x37, 0x17, 0x07, 0x11, 0x33, 0x11, 0x33, 0x11, 0x23, 0x35, 0x23, 0x15,
+  0x23, 0x35, 0x23, 0x15, 0x23, 0x35, 0x23, 0x15, 0x23, 0x11, 0x27, 0x37,
+  0x35, 0x06, 0x07, 0x11, 0x23, 0x11, 0x06, 0x07, 0x10, 0x00, 0x21, 0x20,
+  0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x24, 0x34, 0x36, 0x32, 0x16,
+  0x14, 0x06, 0x22, 0x13, 0x11, 0x33, 0x11, 0x13, 0x33, 0x35, 0x27, 0x17,
+  0x33, 0x35, 0x07, 0x27, 0x11, 0x15, 0x17, 0x35, 0x26, 0x01, 0x35, 0x07,
+  0x15, 0x03, 0x06, 0x07, 0x15, 0x37, 0x11, 0x35, 0x07, 0x27, 0x15, 0x01,
+  0x12, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0x3a, 0x3d, 0x1b,
+  0x22, 0x05, 0x05, 0x3d, 0x2f, 0x3d, 0x3d, 0x3e, 0x3d, 0x3d, 0x3d, 0x3d,
+  0x51, 0x45, 0x87, 0x96, 0xfe, 0x8b, 0x96, 0x87, 0x45, 0x52, 0x3d, 0x3d,
+  0x3d, 0x3d, 0x3d, 0x3d, 0x3e, 0x2e, 0x3e, 0x05, 0x05, 0x21, 0x1c, 0x3d,
+  0x3b, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe, 0x29,
+  0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x02, 0xb5, 0x44, 0x5f, 0x43, 0x43,
+  0x5f, 0x11, 0x3d, 0xf5, 0x3d, 0x3d, 0x7a, 0x2f, 0x03, 0x2c, 0x2f, 0x17,
+  0xfd, 0x47, 0x3d, 0x3e, 0x18, 0x16, 0x2e, 0x2c, 0x02, 0x02, 0xea, 0xfe,
+  0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0xaa, 0x8f, 0xfe, 0x85, 0x01,
+  0xf3, 0x2c, 0x28, 0x67, 0x04, 0x09, 0xfe, 0x2d, 0x88, 0x88, 0x88, 0x88,
+  0x88, 0x88, 0x02, 0x38, 0xfe, 0xd7, 0x01, 0x10, 0x3f, 0x6f, 0x69, 0x7b,
+  0x60, 0x60, 0x7b, 0x69, 0x6f, 0x3f, 0xfe, 0xf0, 0x01, 0x29, 0xfd, 0xc8,
+  0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x01, 0xd3, 0x09, 0x04, 0x68, 0x28,
+  0x2c, 0xfe, 0x0c, 0x01, 0x7d, 0x90, 0xab, 0x01, 0x75, 0x02, 0x0f, 0xfd,
+  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x19, 0x6a, 0x4b,
+  0x4b, 0x6a, 0x4b, 0x01, 0x64, 0x02, 0x38, 0xfd, 0xc8, 0x01, 0x0f, 0xb1,
+  0x2f, 0xe0, 0x63, 0x04, 0x22, 0x01, 0x23, 0x7f, 0x24, 0x7a, 0x16, 0xfe,
+  0x6f, 0xe0, 0x2f, 0xb1, 0x01, 0xa4, 0x13, 0x17, 0x79, 0x24, 0xfe, 0xdb,
+  0x81, 0x22, 0x04, 0x63, 0x00, 0x08, 0x00, 0x99, 0xff, 0x6a, 0x0b, 0x33,
+  0x07, 0x6c, 0x00, 0x09, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x25, 0x00, 0x31,
+  0x00, 0x3d, 0x00, 0x49, 0x00, 0x55, 0x00, 0x00, 0x01, 0x21, 0x15, 0x03,
+  0x33, 0x15, 0x21, 0x35, 0x13, 0x23, 0x25, 0x21, 0x15, 0x03, 0x33, 0x15,
+  0x21, 0x35, 0x13, 0x23, 0x25, 0x21, 0x15, 0x03, 0x33, 0x15, 0x21, 0x35,
+  0x13, 0x23, 0x00, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x14,
+  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x21, 0x14,
+  0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16, 0x32, 0x36, 0x35, 0x01, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10,
+  0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x09, 0xdd,
+  0x01, 0x55, 0xdf, 0xdf, 0xfe, 0xa2, 0xe0, 0xd7, 0xfe, 0x48, 0x01, 0x55,
+  0xdf, 0xdf, 0xfe, 0xa2, 0xe0, 0xd7, 0xfe, 0x48, 0x01, 0x55, 0xdf, 0xdf,
+  0xfe, 0xa2, 0xdf, 0xd6, 0xfc, 0xe1, 0x44, 0x5f, 0x43, 0x43, 0x5f, 0x02,
+  0x10, 0x7e, 0xb1, 0x7e, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0,
+  0x7e, 0x79, 0x37, 0x4c, 0x37, 0xfd, 0x85, 0x01, 0xd9, 0x01, 0x4f, 0x01,
+  0x50, 0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79,
+  0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3,
+  0xfe, 0xe4, 0xfe, 0x6d, 0x07, 0x6c, 0x68, 0xfe, 0xf4, 0x5c, 0x68, 0x01,
+  0x0c, 0x5c, 0x68, 0xfe, 0xf4, 0x5c, 0x68, 0x01, 0x0c, 0x5c, 0x68, 0xfe,
+  0xf4, 0x5c, 0x68, 0x01, 0x0c, 0xfa, 0x7f, 0x6a, 0x4b, 0x4b, 0x6a, 0x4b,
+  0x03, 0x44, 0x8b, 0xc5, 0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5,
+  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfe, 0x62, 0x01, 0x75, 0x02, 0x0f,
+  0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74,
+  0xfe, 0xc4, 0xfe, 0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0,
+  0xfe, 0x40, 0x00, 0x00, 0x00, 0x05, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9,
+  0x06, 0x6e, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x23, 0x00, 0x2b, 0x00, 0x37,
+  0x00, 0x00, 0x01, 0x27, 0x37, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x17,
+  0x07, 0x27, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x03, 0x10, 0x00, 0x21, 0x20, 0x00, 0x11, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x04, 0x34, 0x36, 0x32, 0x16, 0x14, 0x06, 0x22, 0x01, 0x27,
+  0x37, 0x27, 0x37, 0x17, 0x37, 0x17, 0x07, 0x17, 0x07, 0x27, 0x02, 0x53,
+  0x56, 0x66, 0x66, 0x56, 0x66, 0x66, 0x56, 0x66, 0x66, 0x56, 0x66, 0xfe,
+  0x59, 0x01, 0x93, 0x01, 0x1c, 0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe,
+  0xe3, 0xfe, 0xe4, 0xfe, 0x6d, 0x79, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50,
+  0x01, 0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x02, 0x42,
+  0x87, 0xbf, 0x87, 0x87, 0xbf, 0x01, 0x01, 0x55, 0x65, 0x65, 0x55, 0x66,
+  0x67, 0x55, 0x66, 0x66, 0x55, 0x67, 0x03, 0x28, 0x5f, 0x71, 0x72, 0x5f,
+  0x71, 0x71, 0x5f, 0x72, 0x71, 0x5f, 0x71, 0xaf, 0xfe, 0xc4, 0xfe, 0x43,
+  0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0xfe, 0xc3,
+  0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4,
+  0x02, 0x0c, 0x1c, 0xd4, 0x96, 0x96, 0xd4, 0x96, 0x02, 0x64, 0x5f, 0x71,
+  0x72, 0x5f, 0x71, 0x71, 0x5f, 0x72, 0x71, 0x5f, 0x71, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0a,
+  0x00, 0x15, 0x00, 0x21, 0x00, 0x2d, 0x00, 0x00, 0x01, 0x34, 0x36, 0x33,
+  0x32, 0x16, 0x14, 0x06, 0x23, 0x22, 0x26, 0x25, 0x34, 0x36, 0x32, 0x16,
+  0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x05, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x13, 0x10, 0x00, 0x21, 0x20, 0x00,
+  0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x02, 0x42, 0x49, 0x35, 0x34, 0x4a,
+  0x4a, 0x34, 0x35, 0x49, 0x02, 0x08, 0x4a, 0x68, 0x4b, 0x4b, 0x34, 0x35,
+  0x49, 0xfc, 0x4f, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01, 0xd7, 0xfe,
+  0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x79, 0x01, 0x93, 0x01, 0x1c,
+  0x01, 0x1d, 0x01, 0x91, 0xfe, 0x6f, 0xfe, 0xe3, 0xfe, 0xe4, 0xfe, 0x6d,
+  0x03, 0xfd, 0x3b, 0x51, 0x51, 0x76, 0x52, 0x53, 0x3a, 0x3b, 0x51, 0x51,
+  0x3b, 0x3a, 0x53, 0x53, 0xd9, 0x01, 0x75, 0x02, 0x0f, 0xfd, 0xf1, 0xfe,
+  0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0x74, 0xfe, 0xc4, 0xfe,
+  0x43, 0x01, 0xbd, 0x01, 0x3c, 0x01, 0x3d, 0x01, 0xc0, 0xfe, 0x40, 0x00,
+  0x00, 0x0a, 0x00, 0x99, 0xff, 0x6a, 0x06, 0xe9, 0x06, 0x6e, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x13, 0x00, 0x17, 0x00, 0x1b, 0x00, 0x1f, 0x00, 0x24,
+  0x00, 0x28, 0x00, 0x2c, 0x00, 0x37, 0x00, 0x00, 0x13, 0x10, 0x00, 0x21,
+  0x20, 0x00, 0x11, 0x10, 0x00, 0x21, 0x20, 0x00, 0x01, 0x35, 0x21, 0x15,
+  0x33, 0x35, 0x21, 0x15, 0x25, 0x27, 0x25, 0x17, 0x05, 0x25, 0x37, 0x05,
+  0x01, 0x21, 0x11, 0x21, 0x01, 0x21, 0x16, 0x33, 0x32, 0x37, 0x36, 0x13,
+  0x07, 0x01, 0x11, 0x27, 0x12, 0x01, 0x02, 0x27, 0x26, 0x21, 0x20, 0x07,
+  0x06, 0x03, 0x17, 0x21, 0x99, 0x01, 0xd9, 0x01, 0x4f, 0x01, 0x50, 0x01,
+  0xd7, 0xfe, 0x29, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0x27, 0x01, 0x48, 0x01,
+  0x7f, 0xc2, 0x01, 0x80, 0xfc, 0x65, 0x45, 0x01, 0x36, 0x45, 0x02, 0x3e,
+  0xfe, 0xcb, 0x45, 0x01, 0x35, 0xfc, 0x9a, 0x02, 0xce, 0xfd, 0x32, 0x02,
+  0xff, 0xfc, 0xd1, 0xb0, 0xe7, 0xe8, 0xf9, 0xb6, 0x14, 0xca, 0xfc, 0x3f,
+  0xcc, 0x14, 0x05, 0x41, 0x18, 0xab, 0xc8, 0xfe, 0xe2, 0xfe, 0xe4, 0xca,
+  0xab, 0x19, 0xca, 0x03, 0xc1, 0x02, 0xea, 0x01, 0x75, 0x02, 0x0f, 0xfd,
+  0xf1, 0xfe, 0x8b, 0xfe, 0x8c, 0xfd, 0xf4, 0x02, 0x0c, 0x01, 0xba, 0x87,
+  0x87, 0x87, 0x87, 0xe6, 0x6e, 0xf1, 0x6f, 0xf0, 0xf0, 0x6f, 0xf1, 0xfc,
+  0x87, 0x01, 0x18, 0xfe, 0x61, 0x93, 0xd9, 0xc9, 0x01, 0x11, 0x9e, 0xfe,
+  0xc4, 0x01, 0x3c, 0x9e, 0xfe, 0xef, 0x01, 0xb3, 0x01, 0x02, 0xbf, 0xe0,
+  0xe0, 0xbf, 0xfe, 0xff, 0x9d, 0x00, 0x00, 0x00, 0x00, 0x09, 0x00, 0x34,
+  0xff, 0x6a, 0x07, 0x56, 0x07, 0x14, 0x00, 0x08, 0x00, 0x1d, 0x00, 0x52,
+  0x00, 0x8f, 0x00, 0x9d, 0x00, 0xab, 0x00, 0xb5, 0x00, 0xbb, 0x00, 0xc1,
+  0x00, 0x00, 0x00, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x37, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x20, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x16, 0x33, 0x32, 0x01, 0x14, 0x17, 0x25,
+  0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25,
+  0x37, 0x05, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07,
+  0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x07, 0x26,
+  0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17,
+  0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04,
+  0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x06,
+  0x07, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x26, 0x27, 0x07,
+  0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x25, 0x34, 0x2e, 0x01, 0x22, 0x0e,
+  0x01, 0x15, 0x23, 0x34, 0x36, 0x32, 0x16, 0x15, 0x21, 0x34, 0x2e, 0x01,
+  0x22, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x36, 0x32, 0x16, 0x15, 0x01, 0x26,
+  0x27, 0x06, 0x07, 0x15, 0x16, 0x33, 0x32, 0x3f, 0x01, 0x15, 0x36, 0x37,
+  0x06, 0x23, 0x05, 0x35, 0x23, 0x22, 0x27, 0x16, 0x03, 0x88, 0x75, 0x52,
+  0x38, 0x6c, 0x59, 0x5b, 0x6a, 0x38, 0x90, 0x66, 0x69, 0x8e, 0x83, 0x05,
+  0x1a, 0x31, 0xf7, 0xfe, 0xbf, 0xf8, 0x35, 0x20, 0x03, 0x86, 0x90, 0x6d,
+  0xfd, 0xa0, 0x07, 0x01, 0x2b, 0x05, 0xfe, 0xd5, 0x07, 0x0d, 0x01, 0x15,
+  0x14, 0xfe, 0xe7, 0x10, 0x14, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90,
+  0x5d, 0x17, 0x0f, 0xfe, 0xec, 0x13, 0x01, 0x10, 0x0d, 0x07, 0xfe, 0xdb,
+  0x04, 0x01, 0x26, 0x06, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda, 0x8a,
+  0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09, 0x0a,
+  0x73, 0x04, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80,
+  0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15,
+  0x04, 0x1c, 0x0b, 0x11, 0x06, 0x04, 0x5e, 0x03, 0x60, 0x08, 0x13, 0x5e,
+  0x14, 0x5a, 0x11, 0x18, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
+  0xad, 0x68, 0x1b, 0x0e, 0x55, 0x13, 0x58, 0x12, 0x08, 0x5b, 0x04, 0x02,
+  0xe0, 0x13, 0x2d, 0x3b, 0x2c, 0x13, 0x79, 0x7e, 0xb0, 0x7e, 0x01, 0x9b,
+  0x13, 0x2c, 0x3b, 0x2c, 0x13, 0x7a, 0x7e, 0xb1, 0x7e, 0xfe, 0x67, 0x20,
+  0x24, 0x18, 0x2d, 0x27, 0x21, 0x24, 0x1d, 0x7b, 0x56, 0x2e, 0x41, 0x34,
+  0xfe, 0x73, 0x13, 0x39, 0x38, 0x2e, 0x02, 0xfc, 0x2e, 0x78, 0x3d, 0x3d,
+  0x78, 0xfc, 0x25, 0x42, 0x20, 0x19, 0x44, 0x47, 0x81, 0x93, 0x8f, 0x7d,
+  0x4b, 0x53, 0x17, 0x17, 0x42, 0x01, 0xc7, 0x24, 0x62, 0x15, 0x43, 0x16,
+  0x4a, 0x41, 0x69, 0x3f, 0x6c, 0x3a, 0x31, 0xe2, 0x77, 0x84, 0x84, 0x76,
+  0xe3, 0x38, 0x35, 0x6a, 0x3f, 0x67, 0x3e, 0x4c, 0x15, 0x43, 0x15, 0x52,
+  0x34, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15,
+  0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0xbd, 0x4d, 0x45, 0x39,
+  0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61,
+  0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41,
+  0x77, 0x6a, 0x39, 0x44, 0x4d, 0x07, 0x44, 0x07, 0x56, 0x57, 0x24, 0x40,
+  0x22, 0x3c, 0x3c, 0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x40,
+  0x36, 0x20, 0x40, 0x22, 0x4f, 0x60, 0x07, 0x44, 0x51, 0x2b, 0x5a, 0x45,
+  0x45, 0x59, 0x2c, 0x8c, 0xc4, 0xc4, 0x8c, 0x2b, 0x5a, 0x45, 0x45, 0x59,
+  0x2c, 0x8c, 0xc4, 0xc4, 0x8c, 0xfe, 0x03, 0x07, 0x0b, 0x07, 0x0a, 0x91,
+  0x05, 0x04, 0x84, 0x63, 0x27, 0x46, 0x0a, 0x61, 0x61, 0x09, 0x43, 0x00,
+  0x00, 0x09, 0x00, 0x56, 0xff, 0x6a, 0x08, 0x13, 0x07, 0x14, 0x00, 0x3f,
+  0x00, 0x48, 0x00, 0x5d, 0x00, 0xa8, 0x00, 0xb6, 0x00, 0xc4, 0x00, 0xce,
+  0x00, 0xd4, 0x00, 0xda, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34, 0x2e, 0x02,
+  0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x20, 0x07, 0x26, 0x27, 0x06, 0x07,
+  0x0e, 0x03, 0x15, 0x14, 0x17, 0x36, 0x3f, 0x01, 0x07, 0x0e, 0x01, 0x23,
+  0x22, 0x27, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x20, 0x37, 0x36, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x06,
+  0x23, 0x22, 0x26, 0x2f, 0x01, 0x17, 0x16, 0x04, 0x32, 0x37, 0x17, 0x06,
+  0x23, 0x22, 0x27, 0x37, 0x17, 0x16, 0x33, 0x32, 0x37, 0x16, 0x15, 0x14,
+  0x07, 0x0e, 0x01, 0x20, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x16, 0x33,
+  0x32, 0x05, 0x22, 0x26, 0x35, 0x34, 0x36, 0x3f, 0x01, 0x34, 0x27, 0x07,
+  0x27, 0x37, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17,
+  0x1e, 0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16,
+  0x17, 0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17,
+  0x1e, 0x01, 0x15, 0x14, 0x06, 0x23, 0x22, 0x26, 0x2f, 0x01, 0x06, 0x07,
+  0x02, 0x07, 0x06, 0x20, 0x27, 0x26, 0x03, 0x26, 0x27, 0x07, 0x06, 0x01,
+  0x34, 0x2e, 0x01, 0x22, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x36, 0x32, 0x16,
+  0x15, 0x21, 0x34, 0x2e, 0x01, 0x22, 0x0e, 0x01, 0x15, 0x23, 0x34, 0x36,
+  0x32, 0x16, 0x15, 0x01, 0x26, 0x27, 0x06, 0x07, 0x15, 0x16, 0x33, 0x32,
+  0x3f, 0x01, 0x15, 0x36, 0x37, 0x06, 0x23, 0x05, 0x35, 0x23, 0x22, 0x27,
+  0x16, 0x06, 0xf4, 0x02, 0x09, 0x09, 0x14, 0x03, 0x18, 0x26, 0xd9, 0x8b,
+  0x68, 0xfe, 0xe7, 0x69, 0x88, 0xdc, 0x26, 0x19, 0x04, 0x13, 0x09, 0x09,
+  0x01, 0x16, 0x48, 0x7a, 0x27, 0x0f, 0x2e, 0x28, 0x2b, 0x19, 0x07, 0x0e,
+  0x01, 0x15, 0x14, 0xfe, 0xe7, 0x11, 0x13, 0x5c, 0x94, 0xa3, 0x01, 0xb8,
+  0xa4, 0x91, 0x5c, 0x18, 0x0e, 0xfe, 0xeb, 0x14, 0x01, 0x0f, 0x0f, 0x07,
+  0x19, 0x2b, 0x28, 0x2f, 0x0e, 0x2a, 0x7d, 0x49, 0xfd, 0x1b, 0x75, 0x53,
+  0x37, 0x6c, 0x58, 0x5c, 0x6a, 0x38, 0x90, 0x67, 0x68, 0x8e, 0x84, 0x05,
+  0x1b, 0x31, 0xf6, 0xfe, 0xbf, 0xf8, 0x36, 0x1f, 0x02, 0x87, 0x90, 0x6c,
+  0xfc, 0xd6, 0x21, 0x32, 0x38, 0x2f, 0x51, 0x07, 0x5c, 0x04, 0x5a, 0x05,
+  0x07, 0x10, 0x0b, 0x1d, 0x04, 0x15, 0x22, 0x0d, 0x36, 0x81, 0xe3, 0x55,
+  0x5e, 0xcb, 0x5f, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x14, 0x04, 0x1c,
+  0x0b, 0x12, 0x06, 0x04, 0x5e, 0x04, 0x5f, 0x06, 0x03, 0x51, 0x2e, 0x36,
+  0x30, 0x21, 0x27, 0x2f, 0x10, 0x0d, 0x15, 0x28, 0x68, 0xad, 0xc3, 0xfd,
+  0xfa, 0xc4, 0xad, 0x68, 0x26, 0x18, 0x0e, 0x20, 0x02, 0x9a, 0x14, 0x2b,
+  0x3c, 0x2d, 0x12, 0x7a, 0x7e, 0xb0, 0x7e, 0x01, 0x9c, 0x13, 0x2c, 0x3b,
+  0x2d, 0x12, 0x7a, 0x7e, 0xb0, 0x7e, 0xfe, 0x67, 0x20, 0x24, 0x17, 0x2d,
+  0x27, 0x21, 0x24, 0x1c, 0x7b, 0x56, 0x2f, 0x41, 0x34, 0xfe, 0x72, 0x12,
+  0x38, 0x39, 0x2f, 0x03, 0x7c, 0x28, 0x2c, 0x2e, 0x66, 0x3e, 0x76, 0x19,
+  0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72,
+  0x41, 0x65, 0x2e, 0x2a, 0x27, 0x2c, 0x19, 0x2c, 0x88, 0x33, 0x3c, 0x25,
+  0x57, 0x4c, 0x69, 0x3f, 0x6c, 0x3a, 0x31, 0xe2, 0x77, 0x84, 0x84, 0x76,
+  0xe3, 0x38, 0x35, 0x6a, 0x3f, 0x67, 0x44, 0x60, 0x28, 0x3c, 0x33, 0x88,
+  0x2c, 0x19, 0xaf, 0x2e, 0x78, 0x3d, 0x3d, 0x78, 0xfc, 0x25, 0x42, 0x20,
+  0x19, 0x44, 0x47, 0x81, 0x93, 0x8f, 0x7d, 0x4b, 0x53, 0x17, 0x17, 0x42,
+  0x41, 0x36, 0x25, 0x2c, 0x34, 0x11, 0x1d, 0x03, 0x4a, 0x07, 0x44, 0x06,
+  0x4d, 0x45, 0x39, 0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09,
+  0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75,
+  0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x44, 0x4d, 0x07, 0x44, 0x07, 0x34,
+  0x19, 0x1d, 0x11, 0x34, 0x2c, 0x25, 0x36, 0x3c, 0x33, 0x2a, 0x68, 0x62,
+  0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x5d, 0x70, 0x2d, 0x6f,
+  0x01, 0xc4, 0x2b, 0x5a, 0x45, 0x45, 0x59, 0x2c, 0x8c, 0xc4, 0xc4, 0x8c,
+  0x2b, 0x5a, 0x45, 0x45, 0x59, 0x2c, 0x8c, 0xc4, 0xc4, 0x8c, 0xfe, 0x03,
+  0x07, 0x0b, 0x07, 0x0a, 0x91, 0x05, 0x04, 0x84, 0x63, 0x27, 0x46, 0x0a,
+  0x61, 0x61, 0x09, 0x43, 0x00, 0x09, 0x00, 0x34, 0xff, 0x6a, 0x07, 0x56,
+  0x07, 0x14, 0x00, 0x08, 0x00, 0x1d, 0x00, 0x2a, 0x00, 0x5f, 0x00, 0x9c,
+  0x00, 0xaa, 0x00, 0xb4, 0x00, 0xc3, 0x00, 0xd0, 0x00, 0x00, 0x00, 0x32,
+  0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x37, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x16, 0x15, 0x14, 0x07, 0x0e, 0x01, 0x20, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x16, 0x33, 0x32, 0x17, 0x06, 0x23, 0x22, 0x27, 0x1e, 0x01, 0x32,
+  0x36, 0x37, 0x06, 0x23, 0x22, 0x01, 0x14, 0x17, 0x25, 0x17, 0x05, 0x16,
+  0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36,
+  0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36,
+  0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22,
+  0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x07, 0x26, 0x35, 0x34, 0x3e,
+  0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17, 0x36, 0x32, 0x17,
+  0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x07,
+  0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x02, 0x07,
+  0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x26, 0x27, 0x07, 0x27, 0x37, 0x26,
+  0x27, 0x07, 0x27, 0x25, 0x34, 0x36, 0x33, 0x32, 0x16, 0x17, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x37, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e,
+  0x01, 0x37, 0x26, 0x05, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x36, 0x37, 0x36, 0x33, 0x32, 0x16, 0x07, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x03, 0x88, 0x75, 0x52, 0x38,
+  0x6c, 0x59, 0x5b, 0x6a, 0x38, 0x90, 0x66, 0x69, 0x8e, 0x83, 0x05, 0x1a,
+  0x31, 0xf7, 0xfe, 0xbf, 0xf8, 0x35, 0x20, 0x03, 0x86, 0x90, 0x6d, 0x65,
+  0x67, 0x6b, 0x39, 0x38, 0x2f, 0xad, 0xd3, 0xaa, 0x2d, 0x41, 0x34, 0x69,
+  0xfc, 0xd6, 0x07, 0x01, 0x2b, 0x05, 0xfe, 0xd5, 0x07, 0x0d, 0x01, 0x15,
+  0x14, 0xfe, 0xe7, 0x10, 0x14, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90,
+  0x5d, 0x17, 0x0f, 0xfe, 0xec, 0x13, 0x01, 0x10, 0x0d, 0x07, 0xfe, 0xdb,
+  0x04, 0x01, 0x26, 0x06, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda, 0x8a,
+  0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09, 0x0a,
+  0x73, 0x04, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80,
+  0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15,
+  0x04, 0x1c, 0x0b, 0x11, 0x06, 0x04, 0x5e, 0x03, 0x60, 0x08, 0x13, 0x5e,
+  0x14, 0x5a, 0x11, 0x18, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
+  0xad, 0x68, 0x1b, 0x0e, 0x55, 0x13, 0x58, 0x12, 0x08, 0x5b, 0x04, 0x01,
+  0xb2, 0x59, 0x3c, 0x38, 0x54, 0x06, 0x2b, 0x44, 0x1e, 0x24, 0x3c, 0x33,
+  0x07, 0xe4, 0x21, 0x2b, 0x05, 0x26, 0x3e, 0x11, 0x13, 0x02, 0xb2, 0x07,
+  0x33, 0x3c, 0x21, 0x21, 0x45, 0x2a, 0x07, 0x2d, 0x28, 0x36, 0x3c, 0x59,
+  0x94, 0x0b, 0x18, 0x29, 0x26, 0x0e, 0x03, 0x0b, 0x0c, 0x27, 0x3a, 0x02,
+  0xfc, 0x2e, 0x78, 0x3d, 0x3d, 0x78, 0xfc, 0x25, 0x42, 0x20, 0x19, 0x44,
+  0x47, 0x81, 0x93, 0x8f, 0x7d, 0x4b, 0x53, 0x17, 0x17, 0x42, 0x68, 0x1f,
+  0x09, 0x45, 0x4c, 0x4d, 0x45, 0x0a, 0x02, 0x4e, 0x24, 0x62, 0x15, 0x43,
+  0x16, 0x4a, 0x41, 0x69, 0x3f, 0x6c, 0x3a, 0x31, 0xe2, 0x77, 0x84, 0x84,
+  0x76, 0xe3, 0x38, 0x35, 0x6a, 0x3f, 0x67, 0x3e, 0x4c, 0x15, 0x43, 0x15,
+  0x52, 0x34, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15,
+  0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0xbd, 0x4d, 0x45,
+  0x39, 0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89,
+  0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93,
+  0x41, 0x77, 0x6a, 0x39, 0x44, 0x4d, 0x07, 0x44, 0x07, 0x56, 0x57, 0x24,
+  0x40, 0x22, 0x3c, 0x3c, 0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03,
+  0x40, 0x36, 0x20, 0x40, 0x22, 0x4f, 0x60, 0x07, 0x44, 0x9f, 0x46, 0x5f,
+  0x57, 0x3b, 0x45, 0x18, 0x0b, 0x21, 0x17, 0x49, 0x2b, 0x20, 0x0d, 0x0d,
+  0x06, 0x2f, 0x21, 0x0f, 0x2d, 0x1d, 0x17, 0x21, 0x0c, 0x19, 0x43, 0x42,
+  0x2a, 0x26, 0x5f, 0x7a, 0x03, 0x14, 0x15, 0x19, 0x0c, 0x0b, 0x03, 0x35,
+  0x00, 0x06, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x11,
+  0x00, 0x19, 0x00, 0x4a, 0x00, 0x83, 0x00, 0x98, 0x00, 0xad, 0x00, 0x00,
+  0x01, 0x37, 0x16, 0x33, 0x32, 0x37, 0x16, 0x33, 0x32, 0x37, 0x17, 0x06,
+  0x23, 0x22, 0x27, 0x06, 0x23, 0x22, 0x01, 0x17, 0x06, 0x22, 0x27, 0x37,
+  0x16, 0x32, 0x25, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06,
+  0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x15,
+  0x14, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17,
+  0x16, 0x20, 0x37, 0x36, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37,
+  0x05, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e,
+  0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17,
+  0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07,
+  0x27, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x07, 0x27, 0x37,
+  0x26, 0x27, 0x07, 0x27, 0x01, 0x3e, 0x01, 0x33, 0x32, 0x16, 0x15, 0x14,
+  0x0f, 0x01, 0x23, 0x27, 0x26, 0x27, 0x34, 0x36, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x25, 0x32, 0x16, 0x17, 0x33, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16,
+  0x15, 0x06, 0x0f, 0x01, 0x23, 0x27, 0x26, 0x35, 0x34, 0x36, 0x02, 0x62,
+  0x53, 0x3e, 0x52, 0x34, 0x4c, 0x4b, 0x35, 0x51, 0x3f, 0x52, 0x61, 0x81,
+  0x43, 0x3d, 0x3e, 0x42, 0x82, 0x01, 0x8c, 0x38, 0x6e, 0xae, 0x6e, 0x38,
+  0x51, 0x78, 0x02, 0x75, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda,
+  0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09,
+  0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01, 0x01, 0x18,
+  0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9, 0xa3, 0x93, 0x5d, 0xfe, 0xfe,
+  0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0xfb, 0x46, 0x0f, 0x06,
+  0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4, 0x54, 0x5e,
+  0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04, 0x1c, 0x0b,
+  0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17, 0x63, 0x69,
+  0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xae, 0x6a, 0x62, 0x18, 0x62,
+  0x1b, 0x0e, 0x62, 0x09, 0x02, 0x99, 0x09, 0x34, 0x29, 0x29, 0x38, 0x38,
+  0x8f, 0x02, 0x97, 0x2c, 0x02, 0x3a, 0x2a, 0x37, 0x1f, 0x0c, 0x01, 0x7e,
+  0x28, 0x34, 0x09, 0x01, 0x0c, 0x1f, 0x37, 0x2b, 0x39, 0x01, 0x2d, 0x97,
+  0x02, 0x8f, 0x37, 0x37, 0x01, 0x8c, 0x62, 0x40, 0x2c, 0x2c, 0x40, 0x62,
+  0x64, 0x1c, 0x1c, 0x01, 0xa8, 0x78, 0x3d, 0x3d, 0x78, 0x2e, 0x38, 0x82,
+  0x74, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15,
+  0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65, 0x2e, 0x74, 0x82, 0x2b,
+  0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e, 0x7a, 0xe7, 0x77, 0x84, 0x84, 0x77,
+  0xe7, 0x7a, 0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42, 0x3d, 0x7c, 0x8f, 0x39,
+  0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61,
+  0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41,
+  0x77, 0x6a, 0x39, 0x8f, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e,
+  0x2e, 0xfe, 0xf7, 0x8e, 0x9e, 0x9e, 0x8c, 0x01, 0x0b, 0x2e, 0x3e, 0x2e,
+  0x51, 0x57, 0x0e, 0x42, 0x01, 0x95, 0x30, 0x42, 0x3d, 0x31, 0x4a, 0x4a,
+  0xbe, 0xcf, 0x3d, 0x42, 0x2a, 0x48, 0x47, 0x1b, 0x10, 0x72, 0x42, 0x30,
+  0x10, 0x1b, 0x47, 0x48, 0x2a, 0x42, 0x3d, 0xcf, 0xbe, 0x4a, 0x4a, 0x31,
+  0x3d, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e,
+  0x07, 0x14, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x1e, 0x00, 0x28,
+  0x00, 0x37, 0x00, 0x44, 0x00, 0x75, 0x00, 0xae, 0x00, 0xb8, 0x00, 0x00,
+  0x01, 0x05, 0x07, 0x2d, 0x01, 0x17, 0x05, 0x27, 0x13, 0x17, 0x06, 0x22,
+  0x27, 0x37, 0x16, 0x32, 0x03, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14,
+  0x17, 0x3e, 0x01, 0x37, 0x26, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x05, 0x36, 0x35,
+  0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22, 0x07,
+  0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x15, 0x14, 0x17, 0x25, 0x17, 0x05,
+  0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37,
+  0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37, 0x05, 0x26, 0x35, 0x34, 0x3e,
+  0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17, 0x36, 0x32, 0x17,
+  0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x07,
+  0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x02, 0x07, 0x06, 0x21,
+  0x20, 0x27, 0x26, 0x03, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x01,
+  0x32, 0x37, 0x36, 0x37, 0x17, 0x06, 0x07, 0x06, 0x23, 0x02, 0x8a, 0x01,
+  0x10, 0x45, 0xfe, 0xef, 0x02, 0xb5, 0x45, 0xfe, 0xef, 0x45, 0x67, 0x38,
+  0x6e, 0xae, 0x6e, 0x38, 0x51, 0x78, 0xea, 0x26, 0x49, 0x1d, 0x24, 0x3f,
+  0x31, 0x12, 0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21, 0x2b, 0x05, 0x26,
+  0x3e, 0x11, 0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c, 0x2a, 0x30, 0x13,
+  0x31, 0x3f, 0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b, 0x24, 0x0e, 0x03,
+  0x0b, 0x0c, 0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18,
+  0x26, 0xda, 0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05,
+  0x13, 0x09, 0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01,
+  0x01, 0x18, 0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9, 0xa3, 0x93, 0x5d,
+  0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0xfb, 0x46,
+  0x0f, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4,
+  0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04,
+  0x1c, 0x0b, 0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17,
+  0x63, 0x69, 0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xae, 0x6a, 0x62,
+  0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x03, 0x8a, 0xb6, 0x80, 0x24, 0x19,
+  0x68, 0x1f, 0x30, 0xa3, 0xe9, 0x05, 0x67, 0xd4, 0x6f, 0xd5, 0x6e, 0x6e,
+  0xd5, 0x6f, 0xfe, 0x3d, 0x78, 0x3d, 0x3d, 0x78, 0x2e, 0x01, 0x06, 0x4c,
+  0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47, 0x30, 0x2c, 0x61, 0x26, 0x30, 0x24,
+  0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11, 0x1d, 0x43, 0x61, 0x2c, 0x30, 0x47,
+  0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04, 0x03, 0x16, 0x18, 0x1c, 0x0e, 0x0c,
+  0x03, 0x3b, 0xa7, 0x82, 0x74, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7,
+  0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65,
+  0x2e, 0x74, 0x82, 0x2b, 0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e, 0x7a, 0xe7,
+  0x77, 0x84, 0x84, 0x77, 0xe7, 0x7a, 0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42,
+  0x3d, 0x7c, 0x8f, 0x39, 0x6a, 0x77, 0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a,
+  0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c,
+  0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x8f, 0x7c, 0x0f, 0x42, 0x0e,
+  0x51, 0x57, 0x2e, 0x3e, 0x2e, 0xfe, 0xf7, 0x8e, 0x9e, 0x9e, 0x8c, 0x01,
+  0x0b, 0x2e, 0x3e, 0x2e, 0x51, 0x57, 0x0e, 0x42, 0xfe, 0x7f, 0x8e, 0x28,
+  0x2b, 0x48, 0x36, 0x35, 0xb5, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x36,
+  0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x0e, 0x00, 0x18, 0x00, 0x27,
+  0x00, 0x34, 0x00, 0x69, 0x00, 0xa8, 0x00, 0xb5, 0x00, 0xbe, 0x00, 0x00,
+  0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e, 0x01, 0x37,
+  0x26, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x23, 0x22, 0x06, 0x05, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27,
+  0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07,
+  0x0e, 0x03, 0x15, 0x14, 0x17, 0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17,
+  0x25, 0x17, 0x05, 0x17, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x3f, 0x01,
+  0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37, 0x00, 0x32, 0x17, 0x3e, 0x01,
+  0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x06, 0x15, 0x06,
+  0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x07, 0x02, 0x07,
+  0x06, 0x21, 0x20, 0x27, 0x26, 0x03, 0x27, 0x07, 0x27, 0x37, 0x26, 0x27,
+  0x07, 0x27, 0x37, 0x26, 0x27, 0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f,
+  0x01, 0x17, 0x1e, 0x01, 0x17, 0x13, 0x37, 0x27, 0x37, 0x17, 0x15, 0x07,
+  0x17, 0x15, 0x07, 0x27, 0x37, 0x27, 0x02, 0x32, 0x37, 0x17, 0x06, 0x23,
+  0x22, 0x27, 0x37, 0x03, 0x14, 0x26, 0x49, 0x1d, 0x24, 0x3f, 0x31, 0x12,
+  0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21, 0x2b, 0x05, 0x26, 0x3e, 0x11,
+  0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c, 0x2a, 0x30, 0x13, 0x31, 0x3f,
+  0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b, 0x24, 0x0e, 0x03, 0x0b, 0x0c,
+  0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda,
+  0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09,
+  0x0a, 0x02, 0x07, 0x08, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01,
+  0x01, 0x18, 0xfe, 0xfd, 0x02, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90,
+  0x5d, 0x03, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09,
+  0xfe, 0x0a, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04,
+  0x1c, 0x0b, 0x11, 0x06, 0x01, 0x02, 0x0c, 0x61, 0x09, 0x62, 0x0d, 0x1d,
+  0x63, 0x17, 0x63, 0x03, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3,
+  0xad, 0x68, 0x03, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x61, 0x0c,
+  0x03, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4,
+  0x54, 0x93, 0x48, 0x82, 0x3b, 0xe9, 0x36, 0x36, 0xe9, 0x3b, 0x82, 0x48,
+  0x0a, 0x77, 0x51, 0x38, 0x6b, 0x5a, 0x5b, 0x6a, 0x38, 0x03, 0xa8, 0x4c,
+  0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47, 0x30, 0x2c, 0x61, 0x26, 0x30, 0x24,
+  0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11, 0x1d, 0x43, 0x61, 0x2c, 0x30, 0x47,
+  0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04, 0x03, 0x16, 0x18, 0x1c, 0x0e, 0x0c,
+  0x03, 0x3b, 0xa7, 0x83, 0x73, 0x2e, 0x66, 0x3e, 0x76, 0x19, 0xa1, 0xa7,
+  0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b, 0x72, 0x41, 0x65,
+  0x2e, 0x0f, 0x24, 0x82, 0x41, 0x2b, 0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e,
+  0x7a, 0x05, 0xe2, 0x77, 0x84, 0x84, 0x76, 0xe3, 0x05, 0x7a, 0x3e, 0x79,
+  0x39, 0x4c, 0x2c, 0x42, 0x03, 0x13, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a,
+  0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x07, 0x1c, 0x07, 0x8a,
+  0x57, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e, 0x08, 0xfe, 0xfd,
+  0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x08, 0x2e, 0x3e, 0x2e, 0x51, 0x57,
+  0x0e, 0x42, 0x0f, 0x60, 0x81, 0x2a, 0x39, 0x6a, 0x77, 0x41, 0x93, 0x18,
+  0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0xfb, 0x3a, 0x3d, 0x4e, 0x77,
+  0x8d, 0x59, 0x2e, 0x2d, 0x59, 0x8d, 0x77, 0x4e, 0x3d, 0x01, 0xda, 0x2e,
+  0x78, 0x3d, 0x3d, 0x78, 0x00, 0x0b, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e,
+  0x07, 0x14, 0x00, 0x0e, 0x00, 0x18, 0x00, 0x27, 0x00, 0x34, 0x00, 0x65,
+  0x00, 0x9e, 0x00, 0xa6, 0x00, 0xaf, 0x00, 0xb8, 0x00, 0xbc, 0x00, 0xc0,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x33, 0x32, 0x16, 0x07, 0x22, 0x06, 0x15, 0x14, 0x17, 0x3e,
+  0x01, 0x37, 0x26, 0x05, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x06, 0x05, 0x36, 0x35, 0x34, 0x2e,
+  0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26, 0x23, 0x22, 0x07, 0x26, 0x27,
+  0x06, 0x07, 0x0e, 0x03, 0x15, 0x14, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17,
+  0x25, 0x17, 0x05, 0x16, 0x17, 0x16, 0x20, 0x37, 0x36, 0x37, 0x25, 0x37,
+  0x05, 0x36, 0x37, 0x25, 0x37, 0x05, 0x26, 0x35, 0x34, 0x3e, 0x03, 0x37,
+  0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17, 0x36, 0x32, 0x17, 0x3e, 0x01,
+  0x3f, 0x01, 0x17, 0x16, 0x17, 0x1e, 0x04, 0x15, 0x14, 0x07, 0x17, 0x07,
+  0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27,
+  0x26, 0x03, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x01, 0x36, 0x32,
+  0x17, 0x07, 0x26, 0x22, 0x07, 0x25, 0x36, 0x20, 0x17, 0x07, 0x26, 0x23,
+  0x22, 0x07, 0x12, 0x32, 0x37, 0x17, 0x06, 0x23, 0x22, 0x27, 0x37, 0x01,
+  0x17, 0x05, 0x27, 0x25, 0x05, 0x07, 0x25, 0x03, 0x14, 0x26, 0x49, 0x1d,
+  0x24, 0x3f, 0x31, 0x12, 0x2f, 0x2b, 0x3a, 0x3f, 0x5b, 0x46, 0x21, 0x2b,
+  0x05, 0x26, 0x3e, 0x11, 0x14, 0x01, 0x8c, 0x04, 0x5a, 0x3f, 0x3c, 0x2a,
+  0x30, 0x13, 0x31, 0x3f, 0x24, 0x1d, 0x49, 0x6d, 0x0b, 0x18, 0x2b, 0x24,
+  0x0e, 0x03, 0x0b, 0x0c, 0x27, 0x3a, 0x01, 0x6b, 0x10, 0x09, 0x09, 0x14,
+  0x04, 0x18, 0x26, 0xda, 0x8a, 0x69, 0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26,
+  0x18, 0x05, 0x13, 0x09, 0x0a, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c,
+  0x15, 0x01, 0x01, 0x18, 0xfe, 0xfd, 0x5d, 0x94, 0xa3, 0x01, 0xb9, 0xa3,
+  0x93, 0x5d, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09,
+  0xfb, 0x46, 0x0f, 0x06, 0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36,
+  0x80, 0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22,
+  0x15, 0x04, 0x1c, 0x0b, 0x11, 0x06, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d,
+  0x63, 0x17, 0x63, 0x69, 0xaf, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xae,
+  0x6a, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x02, 0xf3, 0x3f, 0xb0,
+  0x3f, 0x56, 0x1b, 0x4c, 0x1b, 0xfe, 0xb5, 0xa3, 0x01, 0xd2, 0xa3, 0x56,
+  0x80, 0xb6, 0xb4, 0x81, 0xfb, 0x77, 0x51, 0x38, 0x6b, 0x5a, 0x5b, 0x6a,
+  0x38, 0x01, 0xc4, 0x45, 0xfe, 0xef, 0x45, 0xfe, 0xa2, 0x01, 0x10, 0x45,
+  0xfe, 0xef, 0x03, 0xa8, 0x4c, 0x1c, 0x0b, 0x23, 0x24, 0x2d, 0x47, 0x30,
+  0x2c, 0x61, 0x26, 0x30, 0x24, 0x0e, 0x0f, 0x07, 0x34, 0x25, 0x11, 0x1d,
+  0x43, 0x61, 0x2c, 0x30, 0x47, 0x2d, 0x24, 0x23, 0x0b, 0x1c, 0x04, 0x03,
+  0x16, 0x18, 0x1c, 0x0e, 0x0c, 0x03, 0x3b, 0xa7, 0x82, 0x74, 0x2e, 0x66,
+  0x3e, 0x76, 0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7,
+  0xa1, 0x1b, 0x72, 0x41, 0x65, 0x2e, 0x74, 0x82, 0x2b, 0x42, 0x2c, 0x45,
+  0x40, 0x79, 0x3e, 0x7a, 0xe7, 0x77, 0x84, 0x84, 0x77, 0xe7, 0x7a, 0x3e,
+  0x79, 0x39, 0x4c, 0x2c, 0x42, 0x3d, 0x7c, 0x8f, 0x39, 0x6a, 0x77, 0x41,
+  0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61,
+  0x89, 0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39,
+  0x8f, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e, 0xfe, 0xf7,
+  0x8e, 0x9e, 0x9e, 0x8c, 0x01, 0x0b, 0x2e, 0x3e, 0x2e, 0x51, 0x57, 0x0e,
+  0x42, 0xfe, 0x13, 0x63, 0x63, 0x5f, 0x3c, 0x3c, 0xf5, 0xb5, 0xb5, 0x60,
+  0x8e, 0x8e, 0x01, 0xfa, 0x2e, 0x78, 0x3d, 0x3d, 0x78, 0x02, 0x3d, 0x6e,
+  0xd5, 0x6f, 0xd4, 0xd4, 0x6f, 0xd5, 0x00, 0x00, 0x00, 0x05, 0x00, 0x36,
+  0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x34,
+  0x00, 0x64, 0x00, 0x8e, 0x00, 0x00, 0x01, 0x14, 0x06, 0x07, 0x17, 0x16,
+  0x14, 0x06, 0x22, 0x26, 0x35, 0x34, 0x35, 0x06, 0x22, 0x27, 0x37, 0x16,
+  0x32, 0x37, 0x17, 0x36, 0x3f, 0x01, 0x2e, 0x01, 0x35, 0x33, 0x14, 0x16,
+  0x32, 0x36, 0x35, 0x21, 0x14, 0x06, 0x22, 0x26, 0x35, 0x33, 0x14, 0x16,
+  0x32, 0x36, 0x35, 0x03, 0x36, 0x20, 0x17, 0x07, 0x26, 0x20, 0x07, 0x01,
+  0x26, 0x10, 0x36, 0x3f, 0x01, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17,
+  0x36, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x1f, 0x01, 0x1e,
+  0x01, 0x14, 0x07, 0x17, 0x07, 0x27, 0x06, 0x07, 0x17, 0x07, 0x27, 0x02,
+  0x00, 0x20, 0x00, 0x03, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x05,
+  0x12, 0x21, 0x32, 0x24, 0x37, 0x25, 0x37, 0x05, 0x36, 0x37, 0x25, 0x37,
+  0x05, 0x36, 0x35, 0x34, 0x2f, 0x01, 0x26, 0x27, 0x06, 0x07, 0x26, 0x20,
+  0x07, 0x26, 0x27, 0x06, 0x0f, 0x01, 0x06, 0x15, 0x14, 0x17, 0x25, 0x17,
+  0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0xa2, 0x73, 0x46, 0x1d, 0x18, 0x30,
+  0x45, 0x30, 0x63, 0xaf, 0x6a, 0x38, 0x52, 0x77, 0x51, 0x2e, 0x07, 0x0d,
+  0x1d, 0x45, 0x74, 0x7a, 0x37, 0x4b, 0x37, 0xfe, 0x65, 0x7e, 0xb0, 0x7e,
+  0x79, 0x37, 0x4c, 0x37, 0xdf, 0xa3, 0x01, 0xd2, 0xa3, 0x56, 0x80, 0xfe,
+  0x96, 0x81, 0xfe, 0x0c, 0x0f, 0x1d, 0x13, 0x12, 0x15, 0x22, 0x0e, 0x36,
+  0x80, 0xe4, 0x54, 0x5e, 0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22,
+  0x15, 0x12, 0x27, 0x09, 0x0f, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17,
+  0x63, 0x69, 0xfe, 0x8d, 0xfd, 0xf9, 0xfe, 0x8f, 0x6a, 0x62, 0x18, 0x62,
+  0x1b, 0x0e, 0x62, 0x09, 0x01, 0x1b, 0xc2, 0x01, 0xae, 0xdd, 0x01, 0x36,
+  0x5d, 0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0x01,
+  0x21, 0x10, 0x18, 0x1b, 0x0e, 0x27, 0xda, 0x8a, 0x69, 0xfe, 0xe8, 0x69,
+  0x89, 0xdb, 0x26, 0x18, 0x0f, 0x1c, 0x11, 0x01, 0x21, 0x0a, 0xfe, 0xdf,
+  0x0c, 0x15, 0x01, 0x01, 0x18, 0x04, 0x88, 0x8b, 0xb4, 0x0e, 0x3f, 0x35,
+  0x4f, 0x36, 0x36, 0x2c, 0x03, 0x03, 0x35, 0x3d, 0x78, 0x2e, 0x2e, 0x63,
+  0x18, 0x1d, 0x3f, 0x0e, 0xb4, 0x8b, 0x53, 0x77, 0x77, 0x53, 0x8b, 0xc5,
+  0xc5, 0x8b, 0x53, 0x77, 0x77, 0x53, 0xfc, 0xda, 0xb5, 0xb5, 0x60, 0x8e,
+  0x8e, 0x01, 0xc6, 0x7c, 0x01, 0x06, 0xc4, 0x6a, 0x61, 0x75, 0x8c, 0x3a,
+  0x09, 0x16, 0x89, 0x61, 0x0d, 0x0d, 0x61, 0x89, 0x16, 0x09, 0x3a, 0x8c,
+  0x75, 0x61, 0xcc, 0xa0, 0xc8, 0x7c, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e,
+  0x3e, 0x2e, 0xfe, 0xf7, 0xfe, 0xd4, 0x01, 0x2a, 0x01, 0x0b, 0x2e, 0x3e,
+  0x2e, 0x51, 0x57, 0x0e, 0x42, 0xe6, 0xfe, 0x1e, 0xfb, 0xe7, 0x7a, 0x3e,
+  0x79, 0x39, 0x4c, 0x2c, 0x42, 0x2b, 0x82, 0x51, 0x88, 0x8d, 0xae, 0x62,
+  0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x54, 0xa8, 0x6e,
+  0x6b, 0x82, 0x2b, 0x42, 0x2c, 0x45, 0x40, 0x79, 0x3e, 0x00, 0x00, 0x00,
+  0x00, 0x06, 0x00, 0x36, 0xff, 0x6a, 0x07, 0x4e, 0x07, 0x14, 0x00, 0x34,
+  0x00, 0x73, 0x00, 0x7b, 0x00, 0x83, 0x00, 0x87, 0x00, 0x8b, 0x00, 0x00,
+  0x01, 0x36, 0x35, 0x34, 0x2e, 0x02, 0x27, 0x26, 0x27, 0x06, 0x07, 0x26,
+  0x23, 0x22, 0x07, 0x26, 0x27, 0x06, 0x07, 0x0e, 0x03, 0x15, 0x14, 0x17,
+  0x16, 0x17, 0x25, 0x17, 0x05, 0x16, 0x17, 0x25, 0x17, 0x05, 0x17, 0x16,
+  0x17, 0x16, 0x20, 0x37, 0x36, 0x3f, 0x01, 0x25, 0x37, 0x05, 0x36, 0x37,
+  0x25, 0x37, 0x00, 0x32, 0x17, 0x3e, 0x01, 0x3f, 0x01, 0x17, 0x16, 0x17,
+  0x1e, 0x04, 0x15, 0x14, 0x06, 0x15, 0x06, 0x07, 0x17, 0x07, 0x27, 0x06,
+  0x07, 0x17, 0x07, 0x27, 0x07, 0x02, 0x07, 0x06, 0x21, 0x20, 0x27, 0x26,
+  0x03, 0x27, 0x07, 0x27, 0x37, 0x26, 0x27, 0x07, 0x27, 0x37, 0x26, 0x27,
+  0x35, 0x34, 0x3e, 0x03, 0x37, 0x36, 0x3f, 0x01, 0x17, 0x1e, 0x01, 0x17,
+  0x03, 0x21, 0x26, 0x27, 0x26, 0x20, 0x07, 0x06, 0x05, 0x21, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x00, 0x0b, 0x01, 0x37, 0x13, 0x05, 0x27, 0x13, 0x17,
+  0x06, 0x73, 0x10, 0x09, 0x09, 0x14, 0x04, 0x18, 0x26, 0xda, 0x8a, 0x69,
+  0x8b, 0x8d, 0x69, 0x89, 0xdb, 0x26, 0x18, 0x05, 0x13, 0x09, 0x0a, 0x02,
+  0x07, 0x08, 0x01, 0x21, 0x0a, 0xfe, 0xdf, 0x0c, 0x15, 0x01, 0x01, 0x18,
+  0xfe, 0xfd, 0x02, 0x5c, 0x93, 0xa3, 0x01, 0xb9, 0xa3, 0x90, 0x5d, 0x03,
+  0xfe, 0xfe, 0x17, 0x01, 0x01, 0x13, 0x0e, 0xfe, 0xe0, 0x09, 0xfe, 0x0a,
+  0xcc, 0x5e, 0x54, 0xe4, 0x80, 0x36, 0x0e, 0x22, 0x15, 0x04, 0x1c, 0x0b,
+  0x11, 0x06, 0x01, 0x02, 0x0c, 0x61, 0x09, 0x62, 0x0d, 0x1d, 0x63, 0x17,
+  0x63, 0x03, 0x69, 0xac, 0xc4, 0xfe, 0xfd, 0xfe, 0xfc, 0xc3, 0xad, 0x68,
+  0x03, 0x62, 0x18, 0x62, 0x1b, 0x0e, 0x62, 0x09, 0x61, 0x0c, 0x03, 0x06,
+  0x11, 0x0b, 0x1c, 0x04, 0x15, 0x22, 0x0e, 0x36, 0x80, 0xe4, 0x54, 0x79,
+  0x02, 0x77, 0x15, 0x3f, 0x60, 0xfe, 0xf0, 0x5f, 0x3e, 0x02, 0xec, 0xfc,
+  0x74, 0x84, 0x84, 0xbd, 0xbc, 0x01, 0x0b, 0x86, 0xf3, 0x55, 0xf3, 0xfd,
+  0x2c, 0x56, 0xf3, 0x56, 0x02, 0xda, 0x83, 0x73, 0x2e, 0x66, 0x3e, 0x76,
+  0x19, 0xa1, 0xa7, 0x3a, 0xc4, 0x15, 0x15, 0xc4, 0x3a, 0xa7, 0xa1, 0x1b,
+  0x72, 0x41, 0x65, 0x2e, 0x0f, 0x24, 0x82, 0x41, 0x2b, 0x42, 0x2c, 0x45,
+  0x40, 0x79, 0x3e, 0x7a, 0x05, 0xe2, 0x77, 0x84, 0x84, 0x76, 0xe3, 0x05,
+  0x7a, 0x3e, 0x79, 0x39, 0x4c, 0x2c, 0x42, 0x03, 0x13, 0x0d, 0x61, 0x89,
+  0x16, 0x09, 0x3a, 0x8c, 0x75, 0x18, 0x93, 0x41, 0x77, 0x6a, 0x39, 0x07,
+  0x1c, 0x07, 0x8a, 0x57, 0x0f, 0x42, 0x0e, 0x51, 0x57, 0x2e, 0x3e, 0x2e,
+  0x08, 0xfe, 0xfd, 0x8c, 0x9e, 0x9e, 0x8c, 0x01, 0x03, 0x08, 0x2e, 0x3e,
+  0x2e, 0x51, 0x57, 0x0e, 0x42, 0x0f, 0x60, 0x81, 0x2a, 0x39, 0x6a, 0x77,
+  0x41, 0x93, 0x18, 0x75, 0x8c, 0x3a, 0x09, 0x16, 0x89, 0x61, 0xfb, 0x47,
+  0x61, 0x4b, 0x74, 0x75, 0x4b, 0xe7, 0xe7, 0xa4, 0xa3, 0xfe, 0xba, 0x01,
+  0x7e, 0x01, 0x0e, 0x5f, 0xfe, 0xf2, 0x5f, 0x5f, 0x01, 0x0e, 0x5f, 0x00,
+  0x00, 0x01, 0xff, 0xc0, 0x04, 0x9a, 0x00, 0xb4, 0x06, 0x12, 0x00, 0x03,
+  0x00, 0x00, 0x11, 0x33, 0x03, 0x23, 0xb3, 0x69, 0x8a, 0x06, 0x12, 0xfe,
+  0x88, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x27, 0x05, 0x0e, 0xff, 0x3f,
+  0x05, 0xd9, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23,
+  0x25, 0x33, 0x15, 0x23, 0xfe, 0x88, 0xb6, 0xb6, 0xfe, 0xa0, 0xb7, 0xb7,
+  0x05, 0xd9, 0xcb, 0xcb, 0xcb, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0xb4,
+  0x04, 0xee, 0xff, 0x0c, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33,
+  0x03, 0x23, 0xfe, 0x65, 0xa6, 0xcd, 0x8a, 0x05, 0xf6, 0xfe, 0xf8, 0x00,
+  0x00, 0x01, 0xfd, 0x0a, 0x05, 0x0e, 0xff, 0x5d, 0x05, 0xe9, 0x00, 0x1d,
+  0x00, 0x00, 0x01, 0x27, 0x2e, 0x01, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x23,
+  0x34, 0x36, 0x33, 0x32, 0x16, 0x1f, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x36,
+  0x3d, 0x01, 0x33, 0x0e, 0x01, 0x23, 0x22, 0x26, 0xfe, 0x30, 0x34, 0x16,
+  0x1c, 0x0b, 0x20, 0x24, 0x71, 0x5d, 0x4d, 0x21, 0x37, 0x2b, 0x33, 0x15,
+  0x1e, 0x0e, 0x1d, 0x24, 0x70, 0x02, 0x5c, 0x4c, 0x1e, 0x36, 0x05, 0x39,
+  0x21, 0x0e, 0x0b, 0x32, 0x2d, 0x06, 0x65, 0x76, 0x10, 0x1b, 0x1e, 0x0d,
+  0x0c, 0x33, 0x29, 0x06, 0x64, 0x77, 0x10, 0x00, 0x00, 0x01, 0xfd, 0x57,
+  0x04, 0xee, 0xfe, 0xb1, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x00, 0x01, 0x13,
+  0x23, 0x03, 0xfe, 0x00, 0xb0, 0x89, 0xcf, 0x05, 0xf6, 0xfe, 0xf8, 0x01,
+  0x08, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x20, 0x04, 0xee, 0xff, 0x46,
+  0x05, 0xf8, 0x00, 0x06, 0x00, 0x00, 0x01, 0x33, 0x13, 0x23, 0x27, 0x07,
+  0x23, 0xfd, 0xdf, 0xa9, 0xbe, 0x7d, 0x96, 0x95, 0x7d, 0x05, 0xf8, 0xfe,
+  0xf6, 0xb2, 0xb2, 0x00, 0x00, 0x01, 0xfd, 0x20, 0x04, 0xee, 0xff, 0x46,
+  0x05, 0xf8, 0x00, 0x06, 0x00, 0x00, 0x01, 0x03, 0x33, 0x17, 0x37, 0x33,
+  0x03, 0xfd, 0xdf, 0xbe, 0x7d, 0x95, 0x96, 0x7d, 0xbe, 0x04, 0xee, 0x01,
+  0x0a, 0xb2, 0xb2, 0xfe, 0xf6, 0x00, 0x00, 0x00, 0x00, 0x01, 0xfd, 0x19,
+  0x05, 0x06, 0xff, 0x4d, 0x05, 0xf8, 0x00, 0x0d, 0x00, 0x00, 0x03, 0x23,
+  0x2e, 0x01, 0x23, 0x22, 0x06, 0x07, 0x23, 0x3e, 0x01, 0x33, 0x32, 0x16,
+  0xb3, 0x6a, 0x0c, 0x59, 0x4b, 0x4a, 0x57, 0x0e, 0x6a, 0x08, 0x90, 0x81,
+  0x82, 0x8f, 0x05, 0x06, 0x36, 0x39, 0x37, 0x38, 0x77, 0x7b, 0x7a, 0x00,
+  0x00, 0x01, 0xfd, 0x19, 0x05, 0x06, 0xff, 0x4d, 0x05, 0xf8, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0x33, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x37, 0x33, 0x0e,
+  0x01, 0x23, 0x22, 0x26, 0xfd, 0x1a, 0x6a, 0x0b, 0x59, 0x4b, 0x4a, 0x57,
+  0x0f, 0x6a, 0x09, 0x90, 0x81, 0x81, 0x90, 0x05, 0xf8, 0x36, 0x39, 0x37,
+  0x38, 0x77, 0x7b, 0x7a, 0x00, 0x01, 0xfd, 0xd7, 0x05, 0x0e, 0xfe, 0x8f,
+  0x05, 0xdb, 0x00, 0x03, 0x00, 0x00, 0x01, 0x33, 0x15, 0x23, 0xfd, 0xd7,
+  0xb8, 0xb8, 0x05, 0xdb, 0xcd, 0x00, 0x00, 0x00, 0x00, 0x02, 0xfd, 0x35,
+  0x04, 0xee, 0xff, 0xba, 0x05, 0xf6, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x03, 0x33, 0x03, 0x23, 0x03, 0x33, 0x03, 0x23, 0xed, 0xa7, 0xcd, 0x8a,
+  0x7d, 0xa6, 0xcd, 0x8a, 0x05, 0xf6, 0xfe, 0xf8, 0x01, 0x08, 0xfe, 0xf8,
+  0x00, 0x02, 0xfc, 0xac, 0x04, 0xee, 0xff, 0x31, 0x05, 0xf6, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x00, 0x01, 0x13, 0x23, 0x03, 0x21, 0x13, 0x23, 0x03,
+  0xfd, 0x53, 0xb1, 0x8a, 0xcd, 0x01, 0xd4, 0xb0, 0x8a, 0xcd, 0x05, 0xf6,
+  0xfe, 0xf8, 0x01, 0x08, 0xfe, 0xf8, 0x01, 0x08, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x87, 0x00, 0x96, 0x00, 0x03, 0x00, 0x00, 0x35, 0x33,
+  0x15, 0x23, 0x87, 0x87, 0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
+  0x00, 0x00, 0x01, 0x68, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x37, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0xe1, 0x87, 0x87, 0xe1,
+  0x87, 0x87, 0x96, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
+  0x00, 0x00, 0x01, 0x68, 0x01, 0x90, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x70, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01,
+  0x90, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
+  0xff, 0x06, 0x01, 0x68, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x17, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x70, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x64,
+  0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
+  0xff, 0x06, 0x00, 0x87, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x15, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x87, 0x87, 0x87, 0x87,
+  0x64, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00,
+  0xff, 0x06, 0x01, 0x68, 0x00, 0x96, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x00, 0x17, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23,
+  0x07, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0xe1, 0x87, 0x87, 0x87,
+  0x87, 0xe1, 0x87, 0x87, 0x87, 0x87, 0x64, 0x96, 0x01, 0x90, 0x96, 0x64,
+  0x96, 0x01, 0x90, 0x96, 0x00, 0x01, 0x00, 0x75, 0xff, 0xec, 0x07, 0x24,
+  0x02, 0x9d, 0x00, 0x26, 0x00, 0x00, 0x01, 0x14, 0x17, 0x16, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x24, 0x03, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x33, 0x16, 0x06, 0x3e, 0x3e,
+  0x39, 0x39, 0x36, 0x5c, 0x68, 0x40, 0x48, 0x16, 0x8b, 0xd2, 0xe9, 0xbe,
+  0xb0, 0x70, 0xfe, 0xd8, 0x01, 0x01, 0x3a, 0xa5, 0x3a, 0xb7, 0x5d, 0x88,
+  0xea, 0xab, 0xb3, 0x6f, 0x35, 0x1a, 0xa5, 0x12, 0x01, 0xf8, 0xd0, 0x3b,
+  0x35, 0xb8, 0x49, 0x53, 0x42, 0x83, 0x35, 0x3a, 0x26, 0x65, 0x01, 0x08,
+  0x8a, 0x5c, 0x5e, 0x88, 0x7d, 0x43, 0x22, 0x02, 0x37, 0x3a, 0x6d, 0x34,
+  0x77, 0x3e, 0x37, 0x4b, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x01, 0x60,
+  0x02, 0x58, 0x00, 0x0d, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x01, 0x0d, 0x41, 0x8d,
+  0x51, 0x20, 0x59, 0x27, 0x2c, 0xa6, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a,
+  0xd9, 0xd9, 0xbb, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3f,
+  0x02, 0x58, 0x00, 0x14, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x01, 0x0d, 0x45, 0x89, 0x51, 0x20, 0x59, 0x27, 0x2c,
+  0xa6, 0x2c, 0x28, 0x59, 0x31, 0x63, 0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31,
+  0x6a, 0xd9, 0xd9, 0x6a, 0x31, 0x2c, 0xb8, 0x00, 0x00, 0x02, 0x00, 0x75,
+  0xff, 0xa5, 0x07, 0x86, 0x03, 0x11, 0x00, 0x2c, 0x00, 0x3e, 0x00, 0x00,
+  0x25, 0x06, 0x07, 0x06, 0x23, 0x24, 0x27, 0x24, 0x03, 0x26, 0x37, 0x33,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x21, 0x32, 0x25, 0x37, 0x26, 0x27, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x05, 0xd2, 0x5d, 0x63, 0xfc, 0xf5, 0xfe, 0xed, 0x70,
+  0xfe, 0xd8, 0x01, 0x01, 0x3a, 0xa5, 0x3a, 0xb7, 0x48, 0x01, 0x0e, 0xd0,
+  0x01, 0x01, 0x19, 0x1f, 0x1a, 0x49, 0x03, 0x14, 0xa9, 0x34, 0x2f, 0x4a,
+  0x49, 0x7b, 0x10, 0x04, 0x48, 0x08, 0x06, 0xed, 0xf1, 0x5f, 0x64, 0x5e,
+  0x04, 0x0d, 0x2f, 0x1e, 0x24, 0x16, 0x14, 0x37, 0x11, 0x05, 0x25, 0x2c,
+  0x24, 0x2b, 0x18, 0x3c, 0x01, 0x27, 0x67, 0x01, 0x06, 0x8a, 0x5c, 0x5e,
+  0x88, 0x73, 0x4d, 0x1f, 0x36, 0x04, 0x1b, 0x2c, 0x7c, 0x79, 0x1f, 0x24,
+  0x9b, 0x4b, 0x17, 0x32, 0x53, 0x96, 0x25, 0x1e, 0x90, 0x6a, 0x01, 0xb8,
+  0xdf, 0x41, 0x7a, 0x14, 0x1b, 0x47, 0x27, 0x19, 0x0a, 0x19, 0x3c, 0x13,
+  0x12, 0x38, 0x42, 0x4e, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x02, 0xec,
+  0x03, 0xd9, 0x00, 0x0f, 0x00, 0x30, 0x00, 0x00, 0x01, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x07, 0x06, 0x07, 0x06, 0x07, 0x14, 0x17, 0x16, 0x33, 0x32,
+  0x01, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x06, 0x07, 0x06, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x21, 0x02, 0x1a, 0x25,
+  0x3b, 0x1c, 0x28, 0x2f, 0x24, 0x24, 0x01, 0x32, 0x24, 0x26, 0x41, 0xfd,
+  0xe9, 0xd9, 0x4b, 0x88, 0x48, 0x36, 0x1b, 0x0e, 0x39, 0x57, 0x75, 0x46,
+  0x58, 0x07, 0x14, 0x87, 0x47, 0x44, 0x51, 0x3b, 0x57, 0x29, 0x15, 0x46,
+  0x43, 0x6f, 0x63, 0x82, 0xfe, 0xdf, 0x02, 0x19, 0x2b, 0x4d, 0x3b, 0x33,
+  0x19, 0x01, 0x01, 0x2a, 0x29, 0x33, 0x50, 0x26, 0x19, 0xfe, 0xb7, 0x17,
+  0x0c, 0x5d, 0x30, 0x32, 0x37, 0x02, 0x02, 0x45, 0x57, 0x81, 0x34, 0x2c,
+  0x94, 0x45, 0x24, 0x32, 0x48, 0x66, 0x33, 0x8c, 0xd0, 0x8f, 0x88, 0x2c,
+  0x27, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xb7,
+  0x03, 0x08, 0x00, 0x21, 0x00, 0x35, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16,
+  0x15, 0x14, 0x07, 0x06, 0x07, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
+  0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x07, 0x22, 0x07, 0x06, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26,
+  0x27, 0x26, 0x02, 0x29, 0xa4, 0x16, 0x07, 0x13, 0x1a, 0x20, 0x23, 0x84,
+  0x72, 0xc3, 0x7a, 0xa7, 0xa6, 0x7b, 0xc3, 0x72, 0x85, 0x23, 0x1a, 0x21,
+  0x13, 0x08, 0x14, 0xa7, 0x1b, 0x3a, 0x39, 0x39, 0x0d, 0x11, 0x32, 0x16,
+  0x08, 0x15, 0x1c, 0x3d, 0x39, 0x20, 0x17, 0x0a, 0x15, 0x33, 0x11, 0x02,
+  0xfa, 0x50, 0x96, 0x32, 0x2a, 0x49, 0x31, 0x43, 0x32, 0x11, 0xb8, 0x39,
+  0x39, 0xb8, 0x11, 0x28, 0x4d, 0x2e, 0x4c, 0x2c, 0x30, 0x8f, 0x57, 0x0e,
+  0xb8, 0x0a, 0x20, 0x35, 0x15, 0x1d, 0x2b, 0x35, 0x44, 0x16, 0x15, 0x45,
+  0x32, 0x2e, 0x18, 0x1a, 0x34, 0x21, 0x0a, 0x00, 0x00, 0x02, 0x00, 0x60,
+  0xfe, 0x0c, 0x06, 0x14, 0x02, 0xe4, 0x00, 0x2e, 0x00, 0x40, 0x00, 0x00,
+  0x25, 0x26, 0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x2b,
+  0x01, 0x06, 0x07, 0x06, 0x07, 0x06, 0x27, 0x24, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x13,
+  0x36, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x17, 0x16, 0x04, 0x3f, 0x3b, 0x2a, 0x6c, 0x34, 0x84,
+  0x05, 0x24, 0x85, 0x24, 0x4f, 0x65, 0x32, 0x59, 0x2d, 0x12, 0x06, 0x17,
+  0x03, 0xed, 0xf1, 0x2b, 0x28, 0x38, 0x72, 0x8f, 0x9e, 0xb8, 0xfe, 0xb3,
+  0x55, 0x3e, 0x38, 0xa6, 0x38, 0x18, 0x36, 0xec, 0x7e, 0x87, 0xc0, 0x61,
+  0x04, 0x14, 0x11, 0x2b, 0x1e, 0x23, 0x1f, 0x13, 0x2e, 0x13, 0x09, 0x34,
+  0x44, 0x5a, 0x2a, 0x0a, 0x05, 0x0d, 0x23, 0x2b, 0x6d, 0xb9, 0x3d, 0x1a,
+  0xa5, 0x45, 0x13, 0x32, 0x58, 0x91, 0x3a, 0xd6, 0x01, 0xb8, 0x7a, 0x46,
+  0x91, 0x4e, 0x56, 0x01, 0x02, 0xbe, 0x8a, 0x7d, 0xa6, 0x60, 0x6b, 0x9b,
+  0x4c, 0x3a, 0x82, 0x44, 0x62, 0x01, 0x5a, 0x7a, 0x57, 0x4b, 0x23, 0x19,
+  0x0a, 0x1b, 0x3a, 0x1e, 0x19, 0x3c, 0x2c, 0x3b, 0x14, 0x09, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0xec, 0x03, 0xd9, 0x10, 0x06,
+  0x11, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x03, 0xb7,
+  0x03, 0x08, 0x10, 0x06, 0x11, 0x01, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x01, 0x60, 0x03, 0xe8, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0x00, 0x02, 0x00, 0x00,
+  0x00, 0x00, 0x01, 0x8b, 0x01, 0xb7, 0x00, 0x0b, 0x00, 0x17, 0x00, 0x00,
+  0x25, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e,
+  0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17,
+  0x01, 0x1c, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38,
+  0x3a, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0xdc, 0x28, 0x1c, 0x1d,
+  0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40,
+  0xb8, 0x40, 0x3f, 0x3f, 0xff, 0xff, 0x00, 0x75, 0xfe, 0x90, 0x07, 0x24,
+  0x03, 0x20, 0x10, 0x27, 0x10, 0xf7, 0x02, 0x76, 0x02, 0x8a, 0x10, 0x27,
+  0x11, 0x07, 0x02, 0x65, 0xfe, 0x90, 0x10, 0x06, 0x10, 0xfc, 0x00, 0x00,
+  0xff, 0xff, 0xff, 0xee, 0xfe, 0xf4, 0x01, 0xd3, 0x03, 0xe8, 0x10, 0x26,
+  0x10, 0xfd, 0x00, 0x00, 0x10, 0x27, 0x10, 0xf7, 0x00, 0x59, 0x03, 0x52,
+  0x10, 0x07, 0x11, 0x07, 0x00, 0x48, 0xfe, 0xf4, 0xff, 0xff, 0xff, 0xee,
+  0xfe, 0xf4, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00,
+  0x10, 0x27, 0x10, 0xf7, 0x00, 0x59, 0x03, 0x52, 0x10, 0x07, 0x11, 0x07,
+  0x00, 0x48, 0xfe, 0xf4, 0xff, 0xff, 0x00, 0x75, 0xff, 0xec, 0x07, 0x24,
+  0x03, 0xb6, 0x10, 0x27, 0x10, 0xf9, 0x02, 0x76, 0x03, 0x20, 0x10, 0x06,
+  0x10, 0xfc, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x01, 0xc2,
+  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf9,
+  0x00, 0x59, 0x04, 0x4c, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3f,
+  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf9,
+  0x00, 0x59, 0x04, 0x4c, 0x00, 0x02, 0x00, 0x8d, 0xfe, 0x0c, 0x04, 0xb8,
+  0x05, 0xaf, 0x00, 0x30, 0x00, 0x49, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x21, 0x32, 0x37, 0x15, 0x06, 0x23, 0x20, 0x27, 0x26, 0x35, 0x10,
+  0x37, 0x36, 0x37, 0x22, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33,
+  0x20, 0x17, 0x15, 0x22, 0x07, 0x17, 0x16, 0x17, 0x16, 0x01, 0x37, 0x26,
+  0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x15, 0x05, 0x04, 0x94,
+  0x24, 0x2c, 0x74, 0x6f, 0x4a, 0x37, 0x05, 0x42, 0x67, 0x58, 0xc9, 0x42,
+  0x74, 0x01, 0x29, 0xad, 0xbf, 0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76, 0xbf,
+  0x56, 0x7b, 0x0a, 0x0c, 0x56, 0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01, 0x08,
+  0xb4, 0x62, 0x1c, 0x1a, 0x2e, 0x41, 0x51, 0xfd, 0x62, 0x46, 0x28, 0x0e,
+  0x0e, 0x32, 0x34, 0x53, 0x38, 0x2f, 0x2e, 0x39, 0x3b, 0x10, 0x1a, 0x55,
+  0x1d, 0x6c, 0xfe, 0xcc, 0xb8, 0xb8, 0x96, 0x64, 0x9c, 0x0f, 0xb2, 0x18,
+  0x50, 0xb7, 0xfc, 0x89, 0x5e, 0xa4, 0x76, 0xb8, 0x63, 0xc2, 0x96, 0xe0,
+  0x01, 0x02, 0xdf, 0x65, 0x34, 0x13, 0x13, 0x29, 0xb8, 0x3f, 0x36, 0x9a,
+  0x0d, 0x5b, 0xa0, 0x5f, 0x77, 0x03, 0xa3, 0x12, 0x14, 0x24, 0x25, 0x2d,
+  0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12, 0x20, 0x1a, 0x4d, 0x1b, 0x0a,
+  0x1d, 0x66, 0x4d, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xed,
+  0x05, 0x4b, 0x00, 0x1e, 0x00, 0x37, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26,
+  0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x15, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x01, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x33, 0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x37, 0x15, 0x05, 0x02, 0xfe, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91,
+  0x41, 0x44, 0x91, 0x9b, 0xe8, 0xc6, 0x44, 0x4f, 0x96, 0x42, 0x83, 0x43,
+  0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55, 0xfe, 0xda, 0x46,
+  0x28, 0x0e, 0x0f, 0x33, 0x34, 0x53, 0x38, 0x2e, 0x2c, 0x3a, 0x3c, 0x0f,
+  0x1a, 0x55, 0x1d, 0x6c, 0xfe, 0xcc, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10,
+  0x07, 0x06, 0xb8, 0x07, 0x01, 0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62,
+  0x42, 0x81, 0x1b, 0x50, 0xb8, 0x48, 0x3a, 0x6a, 0x56, 0x01, 0xfd, 0x12,
+  0x14, 0x24, 0x25, 0x2d, 0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12, 0x20,
+  0x1a, 0x4d, 0x1b, 0x0a, 0x1d, 0x66, 0x4d, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x04, 0xb8, 0x05, 0x4b, 0x00, 0x29, 0x00, 0x42, 0x00, 0x00,
+  0x01, 0x16, 0x17, 0x15, 0x06, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27,
+  0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x27, 0x37, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x37, 0x15, 0x05, 0x02, 0x3e, 0xe8, 0xc6, 0x3a,
+  0x42, 0x2d, 0x1b, 0x5e, 0x66, 0x3c, 0x4e, 0xbc, 0x71, 0x24, 0x35, 0x3e,
+  0x25, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55,
+  0x5b, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x26, 0x46,
+  0x28, 0x0e, 0x0f, 0x33, 0x34, 0x53, 0x38, 0x2e, 0x2c, 0x3a, 0x3c, 0x0f,
+  0x1a, 0x55, 0x1d, 0x6c, 0xfe, 0xcc, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14,
+  0x29, 0x4e, 0x22, 0x77, 0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b,
+  0x50, 0xb8, 0x48, 0x3a, 0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07,
+  0x06, 0xb8, 0x07, 0x01, 0xc8, 0x12, 0x14, 0x24, 0x25, 0x2d, 0x60, 0x2b,
+  0x2d, 0x21, 0x64, 0x21, 0x12, 0x20, 0x1a, 0x4d, 0x1b, 0x0a, 0x1d, 0x66,
+  0x4d, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x8d, 0xfe, 0x0c, 0x04, 0xb8,
+  0x05, 0xaa, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38, 0x00, 0x00, 0x25, 0x33,
+  0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x21, 0x32, 0x37, 0x15, 0x06, 0x23, 0x20, 0x27, 0x26,
+  0x35, 0x10, 0x37, 0x36, 0x37, 0x22, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35,
+  0x36, 0x33, 0x20, 0x17, 0x15, 0x22, 0x07, 0x17, 0x16, 0x17, 0x16, 0x01,
+  0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x04, 0x94, 0x24, 0x2c, 0x74,
+  0x6f, 0x4a, 0x37, 0x05, 0x42, 0x67, 0x58, 0xc9, 0x42, 0x74, 0x01, 0x29,
+  0xad, 0xbf, 0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76, 0xbf, 0x56, 0x7b, 0x0a,
+  0x0c, 0x56, 0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01, 0x08, 0xb4, 0x62, 0x1c,
+  0x1a, 0x2e, 0x41, 0x51, 0xfd, 0xbe, 0x86, 0x86, 0x86, 0x86, 0xb8, 0xb8,
+  0x96, 0x64, 0x9c, 0x0f, 0xb2, 0x18, 0x50, 0xb7, 0xfc, 0x89, 0x5e, 0xa4,
+  0x76, 0xb8, 0x63, 0xc2, 0x96, 0xe0, 0x01, 0x02, 0xdf, 0x65, 0x34, 0x13,
+  0x13, 0x29, 0xb8, 0x3f, 0x36, 0x9a, 0x0d, 0x5b, 0xa0, 0x5f, 0x77, 0x03,
+  0xf8, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xed, 0x05, 0x46, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x26,
+  0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37,
+  0x32, 0x17, 0x16, 0x17, 0x15, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x03, 0x33, 0x15,
+  0x23, 0x11, 0x33, 0x15, 0x23, 0x02, 0xfe, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a,
+  0x91, 0x41, 0x44, 0x91, 0x9b, 0xe8, 0xc6, 0x44, 0x4f, 0x96, 0x42, 0x83,
+  0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55, 0xcb, 0x88,
+  0x88, 0x88, 0x88, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8,
+  0x07, 0x01, 0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62, 0x42, 0x81, 0x1b,
+  0x50, 0xb8, 0x48, 0x3a, 0x6a, 0x56, 0x02, 0x52, 0x96, 0x01, 0x90, 0x96,
+  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x04, 0xb8, 0x05, 0x46, 0x00, 0x29,
+  0x00, 0x2d, 0x00, 0x31, 0x00, 0x00, 0x01, 0x16, 0x17, 0x15, 0x06, 0x07,
+  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32,
+  0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x02, 0x3e, 0xe8, 0xc6,
+  0x3a, 0x42, 0x2d, 0x1b, 0x5e, 0x66, 0x3c, 0x4e, 0xbc, 0x71, 0x24, 0x35,
+  0x3e, 0x25, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68,
+  0x55, 0x5b, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x35,
+  0x88, 0x88, 0x88, 0x88, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14, 0x29, 0x4e,
+  0x22, 0x77, 0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b, 0x50, 0xb8,
+  0x48, 0x3a, 0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8,
+  0x07, 0x01, 0x01, 0x1d, 0x96, 0x01, 0x90, 0x96, 0x00, 0x04, 0x00, 0x8d,
+  0xfe, 0x0c, 0x04, 0xb8, 0x05, 0xaa, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x3c, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27,
+  0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x21, 0x32, 0x37,
+  0x15, 0x06, 0x23, 0x20, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36, 0x37, 0x22,
+  0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33, 0x20, 0x17, 0x15, 0x22,
+  0x07, 0x17, 0x16, 0x17, 0x16, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15,
+  0x23, 0x27, 0x33, 0x15, 0x23, 0x04, 0x94, 0x24, 0x2c, 0x74, 0x6f, 0x4a,
+  0x37, 0x05, 0x42, 0x67, 0x58, 0xc9, 0x42, 0x74, 0x01, 0x29, 0xad, 0xbf,
+  0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76, 0xbf, 0x56, 0x7b, 0x0a, 0x0c, 0x56,
+  0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01, 0x08, 0xb4, 0x62, 0x1c, 0x1a, 0x2e,
+  0x41, 0x51, 0xfd, 0xbe, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87,
+  0xb8, 0xb8, 0x96, 0x64, 0x9c, 0x0f, 0xb2, 0x18, 0x50, 0xb7, 0xfc, 0x89,
+  0x5e, 0xa4, 0x76, 0xb8, 0x63, 0xc2, 0x96, 0xe0, 0x01, 0x02, 0xdf, 0x65,
+  0x34, 0x13, 0x13, 0x29, 0xb8, 0x3f, 0x36, 0x9a, 0x0d, 0x5b, 0xa0, 0x5f,
+  0x77, 0x04, 0xf2, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xed, 0x05, 0x46, 0x00, 0x1e, 0x00, 0x22, 0x00, 0x26,
+  0x00, 0x2a, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35,
+  0x36, 0x37, 0x32, 0x17, 0x16, 0x17, 0x15, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x03,
+  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x02,
+  0xfe, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x9b, 0xe8,
+  0xc6, 0x44, 0x4f, 0x96, 0x42, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc,
+  0x74, 0x5e, 0x68, 0x55, 0xcb, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87,
+  0x87, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07, 0x01,
+  0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62, 0x42, 0x81, 0x1b, 0x50, 0xb8,
+  0x48, 0x3a, 0x6a, 0x56, 0x03, 0x4c, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00,
+  0x00, 0x04, 0xff, 0xee, 0x00, 0x00, 0x04, 0xb8, 0x05, 0x46, 0x00, 0x29,
+  0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x01, 0x16, 0x17, 0x15,
+  0x06, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36,
+  0x37, 0x32, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x02, 0x3e, 0xe8, 0xc6, 0x3a, 0x42, 0x2d, 0x1b, 0x5e, 0x66,
+  0x3c, 0x4e, 0xbc, 0x71, 0x24, 0x35, 0x3e, 0x25, 0x83, 0x43, 0xc7, 0x93,
+  0x73, 0x5a, 0xcc, 0x74, 0x5e, 0x68, 0x55, 0x5b, 0x4b, 0x5d, 0x4c, 0xa2,
+  0x4a, 0x91, 0x41, 0x44, 0x91, 0x35, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1,
+  0x87, 0x87, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14, 0x29, 0x4e, 0x22, 0x77,
+  0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b, 0x50, 0xb8, 0x48, 0x3a,
+  0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07, 0x01,
+  0x02, 0x17, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x05, 0x00, 0x8d,
+  0xfe, 0x0c, 0x04, 0xb8, 0x04, 0xb0, 0x00, 0x30, 0x00, 0x34, 0x00, 0x38,
+  0x00, 0x3c, 0x00, 0x40, 0x00, 0x00, 0x25, 0x33, 0x15, 0x23, 0x22, 0x27,
+  0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x21,
+  0x32, 0x37, 0x15, 0x06, 0x23, 0x20, 0x27, 0x26, 0x35, 0x10, 0x37, 0x36,
+  0x37, 0x22, 0x23, 0x22, 0x07, 0x06, 0x07, 0x35, 0x36, 0x33, 0x20, 0x17,
+  0x15, 0x22, 0x07, 0x17, 0x16, 0x17, 0x16, 0x01, 0x33, 0x15, 0x23, 0x13,
+  0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x04,
+  0x94, 0x24, 0x2c, 0x74, 0x6f, 0x4a, 0x37, 0x05, 0x42, 0x67, 0x58, 0xc9,
+  0x42, 0x74, 0x01, 0x29, 0xad, 0xbf, 0x87, 0xe1, 0xfe, 0x88, 0x98, 0x76,
+  0xbf, 0x56, 0x7b, 0x0a, 0x0c, 0x56, 0x7e, 0x79, 0x56, 0xf5, 0xae, 0x01,
+  0x08, 0xb4, 0x62, 0x1c, 0x1a, 0x2e, 0x41, 0x51, 0xfd, 0xbe, 0x86, 0x86,
+  0x21, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb8, 0xb8, 0x96,
+  0x64, 0x9c, 0x0f, 0xb2, 0x18, 0x50, 0xb7, 0xfc, 0x89, 0x5e, 0xa4, 0x76,
+  0xb8, 0x63, 0xc2, 0x96, 0xe0, 0x01, 0x02, 0xdf, 0x65, 0x34, 0x13, 0x13,
+  0x29, 0xb8, 0x3f, 0x36, 0x9a, 0x0d, 0x5b, 0xa0, 0x5f, 0x77, 0x03, 0xf8,
+  0x96, 0xfb, 0x9b, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0xff, 0xee, 0xfe, 0x3e, 0x03, 0xed, 0x04, 0x4c, 0x00, 0x1e,
+  0x00, 0x22, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x17, 0x16, 0x17,
+  0x15, 0x06, 0x07, 0x06, 0x07, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x37, 0x36, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15,
+  0x23, 0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x02, 0xfe, 0x4b,
+  0x5d, 0x4c, 0xa2, 0x4a, 0x91, 0x41, 0x44, 0x91, 0x9b, 0xe8, 0xc6, 0x44,
+  0x4f, 0x96, 0x42, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a, 0xcc, 0x74, 0x5e,
+  0x68, 0x55, 0xcb, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x70,
+  0x88, 0x88, 0x02, 0x1d, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07,
+  0x01, 0x23, 0x34, 0x62, 0x9a, 0x18, 0x34, 0x62, 0x42, 0x81, 0x1b, 0x50,
+  0xb8, 0x48, 0x3a, 0x6a, 0x56, 0xfc, 0xda, 0x96, 0x01, 0x90, 0x96, 0x96,
+  0x96, 0x05, 0x14, 0x96, 0x00, 0x05, 0xff, 0xee, 0xfe, 0x3e, 0x04, 0xb8,
+  0x04, 0x4c, 0x00, 0x29, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x39,
+  0x00, 0x00, 0x01, 0x16, 0x17, 0x15, 0x06, 0x07, 0x16, 0x17, 0x16, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x37, 0x26, 0x27,
+  0x26, 0x27, 0x26, 0x07, 0x35, 0x36, 0x37, 0x32, 0x13, 0x33, 0x15, 0x23,
+  0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23,
+  0x02, 0x3e, 0xe8, 0xc6, 0x3a, 0x42, 0x2d, 0x1b, 0x5e, 0x66, 0x3c, 0x4e,
+  0xbc, 0x71, 0x24, 0x35, 0x3e, 0x25, 0x83, 0x43, 0xc7, 0x93, 0x73, 0x5a,
+  0xcc, 0x74, 0x5e, 0x68, 0x55, 0x5b, 0x4b, 0x5d, 0x4c, 0xa2, 0x4a, 0x91,
+  0x41, 0x44, 0x91, 0x40, 0x87, 0x87, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87,
+  0x65, 0x88, 0x88, 0x03, 0x0c, 0x34, 0x62, 0x9a, 0x14, 0x29, 0x4e, 0x22,
+  0x77, 0xb8, 0xa8, 0x36, 0x61, 0x2e, 0x25, 0x81, 0x1b, 0x50, 0xb8, 0x48,
+  0x3a, 0x6a, 0x56, 0x23, 0x17, 0x17, 0x13, 0x10, 0x07, 0x06, 0xb8, 0x07,
+  0x01, 0xfb, 0xa5, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x05, 0x14, 0x96,
+  0x00, 0x01, 0x00, 0x00, 0x05, 0x33, 0x03, 0x09, 0x07, 0x2b, 0x00, 0x03,
+  0x00, 0x00, 0x09, 0x01, 0x35, 0x01, 0x03, 0x09, 0xfc, 0xf7, 0x03, 0x09,
+  0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0x00, 0x00, 0x01, 0x00, 0xbf,
+  0xfe, 0x56, 0x04, 0xa4, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x13, 0x33,
+  0x01, 0x11, 0x33, 0x11, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x01, 0x11, 0x23, 0xc0, 0xa5, 0x02, 0x99, 0xa5, 0x4a,
+  0x49, 0xa2, 0xe5, 0xd2, 0x5e, 0x22, 0x23, 0xfd, 0x67, 0xa5, 0x05, 0xd5,
+  0xfb, 0x83, 0x04, 0x7d, 0xfa, 0x17, 0xd6, 0x60, 0x60, 0x9c, 0x30, 0x31,
+  0xad, 0x04, 0x7d, 0xfb, 0x83, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x0d,
+  0x00, 0x00, 0x01, 0xe9, 0x04, 0x60, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33,
+  0x11, 0x33, 0x15, 0x23, 0x11, 0x23, 0x11, 0x23, 0x35, 0x33, 0xb0, 0xa5,
+  0x94, 0x94, 0xa5, 0xa2, 0xa2, 0x04, 0x60, 0xfe, 0x08, 0xa4, 0xfe, 0x3c,
+  0x01, 0xc4, 0xa4, 0x00, 0x00, 0x02, 0xff, 0x0d, 0xfe, 0x56, 0x01, 0xf7,
+  0x04, 0x60, 0x00, 0x0e, 0x00, 0x17, 0x00, 0x00, 0x13, 0x20, 0x35, 0x34,
+  0x3b, 0x01, 0x11, 0x33, 0x11, 0x33, 0x15, 0x23, 0x06, 0x07, 0x06, 0x03,
+  0x23, 0x22, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x1e, 0xfe, 0xef, 0xf3,
+  0xae, 0xa5, 0xa3, 0xac, 0x10, 0x30, 0x49, 0x1d, 0xa3, 0x6b, 0x02, 0x04,
+  0x6f, 0x5e, 0x23, 0x0f, 0xfe, 0x56, 0xdd, 0xcd, 0x04, 0x60, 0xfb, 0xa0,
+  0x9b, 0x70, 0x3f, 0x60, 0x01, 0x10, 0x33, 0x41, 0x30, 0x17, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x69, 0x06, 0x63, 0x03, 0x84, 0x08, 0x33, 0x10, 0x27,
+  0x00, 0x71, 0x00, 0xaa, 0x02, 0x3d, 0x10, 0x07, 0x10, 0xeb, 0x04, 0x43,
+  0x01, 0x55, 0x00, 0x00, 0xff, 0xff, 0x01, 0x69, 0x06, 0x61, 0x03, 0x84,
+  0x08, 0x34, 0x10, 0x27, 0x00, 0x71, 0x00, 0xaa, 0x00, 0xff, 0x10, 0x07,
+  0x10, 0xeb, 0x04, 0x43, 0x02, 0x5b, 0x00, 0x00, 0xff, 0xff, 0x01, 0x69,
+  0x06, 0x5e, 0x03, 0x84, 0x08, 0x33, 0x10, 0x27, 0x10, 0xf3, 0x04, 0x43,
+  0x01, 0x50, 0x10, 0x07, 0x00, 0x71, 0x00, 0xaa, 0x02, 0x3d, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x6a, 0x06, 0x63, 0x03, 0x82, 0x08, 0x5a, 0x10, 0x27,
+  0x10, 0xec, 0x04, 0x72, 0x02, 0x64, 0x10, 0x07, 0x10, 0xeb, 0x04, 0x43,
+  0x01, 0x55, 0x00, 0x00, 0xff, 0xff, 0x01, 0x6a, 0x06, 0x63, 0x03, 0x82,
+  0x08, 0x5a, 0x10, 0x27, 0x10, 0xee, 0x04, 0x18, 0x02, 0x64, 0x10, 0x07,
+  0x10, 0xeb, 0x04, 0x43, 0x01, 0x55, 0x00, 0x00, 0xff, 0xff, 0x01, 0x69,
+  0x06, 0x61, 0x03, 0x84, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xec, 0x04, 0x72,
+  0x02, 0x64, 0x10, 0x07, 0x00, 0x71, 0x00, 0xaa, 0x00, 0xff, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x69, 0x06, 0x61, 0x03, 0x84, 0x08, 0x5a, 0x10, 0x27,
+  0x10, 0xee, 0x04, 0x18, 0x02, 0x64, 0x10, 0x07, 0x00, 0x71, 0x00, 0xaa,
+  0x00, 0xff, 0x00, 0x00, 0xff, 0xff, 0x01, 0x50, 0x06, 0x6a, 0x03, 0xa3,
+  0x08, 0x33, 0x10, 0x27, 0x10, 0xed, 0x04, 0x46, 0x01, 0x5c, 0x10, 0x07,
+  0x00, 0x71, 0x00, 0xaa, 0x02, 0x3d, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63,
+  0x06, 0x63, 0x03, 0x89, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x43,
+  0x02, 0x62, 0x10, 0x07, 0x10, 0xeb, 0x04, 0x43, 0x01, 0x55, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x50, 0x06, 0x6a, 0x03, 0xa3, 0x08, 0x56, 0x10, 0x27,
+  0x10, 0xeb, 0x04, 0x43, 0x02, 0x7d, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46,
+  0x01, 0x5c, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x03, 0x89,
+  0x08, 0x57, 0x10, 0x27, 0x10, 0xf0, 0x04, 0x43, 0x01, 0x75, 0x10, 0x07,
+  0x10, 0xf3, 0x04, 0x43, 0x02, 0x7c, 0x00, 0x00, 0xff, 0xff, 0x01, 0x50,
+  0x06, 0x6a, 0x03, 0xc5, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xec, 0x04, 0xba,
+  0x02, 0x64, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46, 0x01, 0x5c, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x04, 0x96, 0x08, 0x3a, 0x10, 0x27,
+  0x10, 0xef, 0x04, 0x43, 0x01, 0x75, 0x10, 0x07, 0x10, 0xec, 0x05, 0x8a,
+  0x02, 0x44, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x03, 0xfc,
+  0x08, 0x3a, 0x10, 0x27, 0x10, 0xee, 0x05, 0x4b, 0x02, 0x44, 0x10, 0x07,
+  0x10, 0xef, 0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0xff, 0xff, 0x01, 0x50,
+  0x06, 0x63, 0x03, 0xa3, 0x08, 0x75, 0x10, 0x27, 0x10, 0xef, 0x04, 0x43,
+  0x01, 0x75, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46, 0x02, 0x8c, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x50, 0x06, 0x56, 0x03, 0xa3, 0x08, 0x59, 0x10, 0x27,
+  0x10, 0xf2, 0x04, 0x43, 0x01, 0x50, 0x10, 0x07, 0x10, 0xed, 0x04, 0x46,
+  0x02, 0x70, 0x00, 0x00, 0xff, 0xff, 0x01, 0x5c, 0x06, 0x56, 0x03, 0x90,
+  0x08, 0x5a, 0x10, 0x27, 0x10, 0xf2, 0x04, 0x43, 0x01, 0x50, 0x10, 0x07,
+  0x10, 0xec, 0x04, 0x72, 0x02, 0x64, 0x00, 0x00, 0xff, 0xff, 0x01, 0x5c,
+  0x06, 0x56, 0x03, 0x90, 0x08, 0x5a, 0x10, 0x27, 0x10, 0xf2, 0x04, 0x43,
+  0x01, 0x50, 0x10, 0x07, 0x10, 0xee, 0x04, 0x18, 0x02, 0x64, 0x00, 0x00,
+  0xff, 0xff, 0x01, 0x5c, 0x06, 0x56, 0x03, 0x90, 0x08, 0x8b, 0x10, 0x27,
+  0x02, 0xba, 0x04, 0x34, 0x02, 0x10, 0x10, 0x07, 0x10, 0xf2, 0x04, 0x43,
+  0x01, 0x50, 0x00, 0x00, 0xff, 0xff, 0x01, 0x63, 0x06, 0x63, 0x04, 0x87,
+  0x08, 0x5b, 0x10, 0x27, 0x02, 0xba, 0x05, 0x75, 0x01, 0xe0, 0x10, 0x07,
+  0x10, 0xef, 0x04, 0x43, 0x01, 0x75, 0x00, 0x00, 0xff, 0xff, 0xfc, 0xf1,
+  0x04, 0x7b, 0xff, 0x62, 0x06, 0x6e, 0x10, 0x26, 0x02, 0xb2, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xb8, 0xff, 0x12, 0x00, 0x5a, 0x00, 0x01, 0x00, 0x00,
+  0x00, 0x00, 0x01, 0x0e, 0x01, 0x2c, 0x00, 0x03, 0x00, 0x00, 0x11, 0x21,
+  0x11, 0x21, 0x01, 0x0e, 0xfe, 0xf2, 0x01, 0x2c, 0xfe, 0xd4, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0xff, 0xe3, 0x02, 0xfb, 0x05, 0xd5, 0x00, 0x0f,
+  0x00, 0x00, 0x3d, 0x01, 0x1e, 0x01, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33,
+  0x11, 0x10, 0x06, 0x23, 0x22, 0x26, 0x52, 0xae, 0x5e, 0x81, 0x65, 0xb6,
+  0xbe, 0xde, 0x56, 0xab, 0x3d, 0xec, 0x51, 0x51, 0x95, 0xcb, 0x03, 0xee,
+  0xfc, 0x12, 0xfe, 0xe6, 0xea, 0x2c, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb3,
+  0xfe, 0x0c, 0x04, 0x92, 0x02, 0x26, 0x00, 0x06, 0x00, 0x1f, 0x00, 0x00,
+  0x01, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03, 0x01, 0x33, 0x16, 0x17, 0x16,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21,
+  0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x5c, 0xaf, 0x7d,
+  0x75, 0x75, 0x7d, 0xaf, 0xfe, 0x57, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26,
+  0x5b, 0xaf, 0xe1, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01,
+  0x11, 0xb7, 0xc4, 0x20, 0x08, 0xfe, 0x0c, 0x01, 0x46, 0xc3, 0xc3, 0xfe,
+  0xba, 0x04, 0x1a, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea,
+  0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x77, 0x02, 0x26, 0x00, 0x18,
+  0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b,
+  0xaf, 0xe1, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11,
+  0xb7, 0xc4, 0x20, 0x08, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8,
+  0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e,
+  0x00, 0x02, 0x00, 0x81, 0xfe, 0xc8, 0x05, 0x86, 0x07, 0xc4, 0x00, 0x24,
+  0x00, 0x2b, 0x00, 0x00, 0x25, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17,
+  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x24, 0x11, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x13, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03,
+  0x03, 0xaa, 0x46, 0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46, 0x10,
+  0x19, 0x6d, 0xea, 0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39, 0xa6,
+  0x3b, 0x96, 0x24, 0x41, 0x48, 0x63, 0x9c, 0x99, 0xaf, 0x7d, 0x75, 0x75,
+  0x7d, 0xb0, 0x49, 0x7e, 0xe3, 0x04, 0x6a, 0xfb, 0x6b, 0x6a, 0x31, 0x2c,
+  0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22, 0x16, 0x5b, 0x01, 0x12, 0x8a,
+  0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22, 0x35, 0x06, 0xac, 0x01, 0x46,
+  0xc3, 0xc3, 0xfe, 0xba, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x02, 0x24,
+  0x07, 0xc4, 0x00, 0x0d, 0x00, 0x14, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x27, 0x03,
+  0x33, 0x17, 0x37, 0x33, 0x03, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75, 0x44,
+  0x59, 0x27, 0x2c, 0xa6, 0x96, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x01,
+  0x73, 0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0x6a, 0x01,
+  0x46, 0xc3, 0xc3, 0xfe, 0xba, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0x75, 0x07, 0xc4, 0x00, 0x14, 0x00, 0x1b, 0x00, 0x00,
+  0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
+  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x0b, 0x01, 0x33,
+  0x17, 0x37, 0x33, 0x03, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27,
+  0x2c, 0xa6, 0x2c, 0x28, 0x59, 0x43, 0x75, 0x87, 0x8a, 0xaf, 0x7d, 0x75,
+  0x75, 0x7d, 0xaf, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xfb,
+  0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x06, 0x7e, 0x01, 0x46, 0xc3, 0xc3, 0xfe,
+  0xba, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x75, 0xfe, 0xf0, 0x06, 0x13,
+  0x03, 0x46, 0x00, 0x37, 0x00, 0x3e, 0x00, 0x00, 0x05, 0x36, 0x35, 0x26,
+  0x27, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x17, 0x16, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x01, 0x03, 0x33, 0x17, 0x37, 0x33, 0x03, 0x03,
+  0xde, 0x52, 0x01, 0x2a, 0x1a, 0x1b, 0x28, 0x2f, 0x48, 0x4b, 0x1b, 0x26,
+  0x69, 0x4f, 0x73, 0x1d, 0x1f, 0x1f, 0x67, 0x65, 0x61, 0x17, 0x21, 0x0d,
+  0x29, 0x3b, 0x42, 0x02, 0x03, 0x66, 0x73, 0xc4, 0x50, 0x5e, 0xa9, 0x69,
+  0xfe, 0xf8, 0x39, 0xa5, 0x3a, 0x95, 0x3c, 0xa1, 0x52, 0x45, 0x86, 0xfe,
+  0x8b, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x21, 0x33, 0x21, 0x2b, 0x0d,
+  0x08, 0x28, 0x3b, 0x3d, 0x41, 0x3c, 0x5e, 0x0e, 0x06, 0x86, 0xc4, 0xb8,
+  0xac, 0xa5, 0x06, 0x11, 0x23, 0x30, 0x1b, 0x1e, 0x7b, 0x62, 0x56, 0x60,
+  0x1f, 0x0c, 0x29, 0x67, 0x01, 0x06, 0x99, 0x5a, 0x5a, 0x99, 0x72, 0x4e,
+  0x1f, 0x08, 0x0f, 0x02, 0x42, 0x01, 0x46, 0xc3, 0xc3, 0xfe, 0xba, 0x00,
+  0x00, 0x04, 0xff, 0xee, 0xfe, 0xd4, 0x02, 0x00, 0x04, 0x40, 0x00, 0x0d,
+  0x00, 0x14, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x0b, 0x01,
+  0x33, 0x17, 0x37, 0x33, 0x0b, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
+  0x23, 0x01, 0x0d, 0x41, 0x8d, 0x51, 0x20, 0x59, 0x27, 0x2c, 0xa6, 0x96,
+  0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x16, 0x87, 0x87, 0xe1, 0x87, 0x87,
+  0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0xd9, 0xd9, 0xbb, 0x02, 0x36, 0x01,
+  0x46, 0xc3, 0xc3, 0xfe, 0xba, 0xfc, 0x70, 0x96, 0x96, 0x96, 0x00, 0x00,
+  0x00, 0x04, 0xff, 0xee, 0xfe, 0xd4, 0x02, 0x3f, 0x04, 0x40, 0x00, 0x14,
+  0x00, 0x1b, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x0b, 0x01, 0x33, 0x17, 0x37, 0x33, 0x0b,
+  0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0x0d, 0x45, 0x89,
+  0x51, 0x20, 0x59, 0x27, 0x2c, 0xa6, 0x2c, 0x28, 0x59, 0x31, 0x63, 0x87,
+  0x8a, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf, 0x16, 0x87, 0x87, 0xe1, 0x87,
+  0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0xd9, 0xd9, 0x6a, 0x31, 0x2c,
+  0xb8, 0x02, 0xfa, 0x01, 0x46, 0xc3, 0xc3, 0xfe, 0xba, 0xfc, 0x70, 0x96,
+  0x96, 0x96, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x0b,
+  0x04, 0x72, 0x00, 0x18, 0x00, 0x1f, 0x00, 0x00, 0x01, 0x33, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04,
+  0x21, 0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x0b, 0x01, 0x33,
+  0x17, 0x37, 0x33, 0x03, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26,
+  0x5b, 0x43, 0x75, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01,
+  0x11, 0xb7, 0xc4, 0x20, 0x08, 0x35, 0xaf, 0x7d, 0x75, 0x75, 0x7d, 0xaf,
+  0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85,
+  0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0x01, 0x8e, 0x01, 0x46,
+  0xc3, 0xc3, 0xfe, 0xba, 0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x02, 0x01,
+  0x06, 0x14, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x33, 0x11, 0x14, 0x16, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x26, 0x35, 0xae, 0xa5, 0x45, 0x5e, 0x0a, 0x1d,
+  0xa3, 0x92, 0x06, 0x14, 0xfb, 0x82, 0x99, 0x61, 0x9c, 0xc0, 0xd6, 0x00,
+  0x00, 0x02, 0x00, 0x82, 0x00, 0x00, 0x03, 0xef, 0x02, 0xee, 0x00, 0x0a,
+  0x00, 0x24, 0x00, 0x00, 0x01, 0x26, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x17, 0x1e, 0x01, 0x13, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x23, 0x22, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x02, 0x60, 0x0d, 0x0c, 0x0b, 0x0b, 0x6c,
+  0x4a, 0x64, 0x02, 0x01, 0xa2, 0x68, 0x04, 0x02, 0xa5, 0x01, 0x21, 0x13,
+  0x32, 0x1c, 0x65, 0x43, 0x75, 0x51, 0x42, 0x28, 0x22, 0x7c, 0x8d, 0x32,
+  0x34, 0xab, 0xb8, 0x62, 0x01, 0x1a, 0x2a, 0x31, 0x32, 0x65, 0x0c, 0x43,
+  0x59, 0x3e, 0x29, 0x32, 0x01, 0xd1, 0x27, 0x2b, 0xa8, 0xae, 0x65, 0x4f,
+  0x2c, 0xb8, 0x33, 0x1f, 0x3b, 0x49, 0x0f, 0x30, 0x9a, 0xad, 0x7f, 0x44,
+  0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0xa2, 0x05, 0xf0, 0x10, 0x06,
+  0x01, 0xe4, 0x00, 0x00, 0xff, 0xff, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x00,
+  0x05, 0x0f, 0x10, 0x06, 0x01, 0xe5, 0x00, 0x00, 0xff, 0xff, 0x00, 0x87,
+  0xfe, 0x75, 0x01, 0xd7, 0x04, 0x7b, 0x10, 0x26, 0x00, 0xf3, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0x9d, 0xff, 0x5c, 0x00, 0x00, 0x00, 0x02, 0x00, 0x47,
+  0x00, 0x00, 0x02, 0x38, 0x04, 0x60, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x37, 0x33, 0x13, 0x23, 0x13, 0x21, 0x13, 0x21, 0xb3, 0x79, 0xa0, 0x79,
+  0x21, 0xfe, 0xd3, 0xc4, 0x01, 0x2d, 0x64, 0x03, 0x98, 0xfc, 0x04, 0x04,
+  0x60, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x2d, 0xfe, 0x56, 0x02, 0x38,
+  0x04, 0x60, 0x00, 0x08, 0x00, 0x16, 0x00, 0x00, 0x05, 0x13, 0x23, 0x03,
+  0x06, 0x07, 0x36, 0x37, 0x36, 0x05, 0x23, 0x37, 0x33, 0x32, 0x37, 0x36,
+  0x37, 0x13, 0x21, 0x03, 0x06, 0x07, 0x06, 0x01, 0x16, 0xb6, 0x79, 0xbb,
+  0x1f, 0x30, 0x41, 0x2d, 0x43, 0xfe, 0xf9, 0xc6, 0x12, 0x2d, 0x5e, 0x2b,
+  0x2b, 0x1a, 0xd1, 0x01, 0x2d, 0xc8, 0x25, 0x5a, 0x5b, 0x16, 0x04, 0x12,
+  0xfb, 0xd0, 0xb5, 0x54, 0x0f, 0x30, 0x48, 0xf4, 0x64, 0x30, 0x31, 0x99,
+  0x04, 0xac, 0xfb, 0x8c, 0xd6, 0x60, 0x60, 0x00, 0xff, 0xff, 0xff, 0xd7,
+  0xfe, 0x76, 0x02, 0x2a, 0x04, 0x7b, 0x10, 0x27, 0x02, 0xb0, 0xff, 0x34,
+  0x00, 0x00, 0x10, 0x06, 0x00, 0xf3, 0x00, 0x00, 0xff, 0xff, 0x00, 0xab,
+  0xfe, 0x89, 0x01, 0x54, 0x04, 0x7b, 0x10, 0x26, 0x00, 0xf3, 0x00, 0x00,
+  0x10, 0x07, 0x02, 0xd4, 0x02, 0xcd, 0x00, 0x00, 0x00, 0x02, 0x00, 0xd8,
+  0x00, 0xd8, 0x01, 0x96, 0x04, 0xfb, 0x00, 0x03, 0x00, 0x07, 0x00, 0x00,
+  0x13, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0xd8, 0xbe, 0xbe, 0xbe,
+  0xbe, 0x01, 0xd6, 0xfe, 0x04, 0x23, 0xfe, 0x00, 0x00, 0x01, 0x00, 0x87,
+  0x00, 0x00, 0x02, 0xab, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x13, 0x21,
+  0x15, 0x23, 0x11, 0x33, 0x15, 0x21, 0x35, 0x33, 0x11, 0x23, 0x88, 0x02,
+  0x21, 0xb5, 0xb6, 0xfd, 0xdf, 0xb5, 0xb6, 0x05, 0xd5, 0xaa, 0xfb, 0x7f,
+  0xaa, 0xaa, 0x04, 0x81, 0x00, 0x01, 0x01, 0x82, 0x02, 0x95, 0x04, 0x89,
+  0x03, 0x3f, 0x00, 0x03, 0x00, 0x00, 0x01, 0x15, 0x21, 0x35, 0x04, 0x88,
+  0xfc, 0xfa, 0x03, 0x3f, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4,
+  0x04, 0xcb, 0x02, 0xe6, 0x08, 0xf2, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x33, 0x16, 0x15, 0x14, 0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x26, 0x01, 0x35, 0x25, 0x15, 0x01,
+  0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48, 0x25, 0x1e,
+  0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56, 0x03, 0x50,
+  0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18, 0xfe, 0xe0,
+  0x02, 0x0e, 0xfd, 0xf2, 0x02, 0x0e, 0x05, 0x84, 0x4c, 0x28, 0x45, 0x3f,
+  0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa,
+  0x52, 0x59, 0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36,
+  0x59, 0x0a, 0x09, 0x21, 0x1e, 0x02, 0xb3, 0x6e, 0x82, 0x6e, 0xfe, 0x8e,
+  0x6e, 0x82, 0x6e, 0x00, 0x00, 0x03, 0x00, 0xb4, 0x04, 0xcb, 0x02, 0xe6,
+  0x09, 0x55, 0x00, 0x28, 0x00, 0x4f, 0x00, 0x5e, 0x00, 0x00, 0x01, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35, 0x33, 0x16, 0x15, 0x14,
+  0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07,
+  0x06, 0x27, 0x26, 0x03, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37,
+  0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x33, 0x16, 0x33,
+  0x15, 0x22, 0x2f, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35,
+  0x33, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34,
+  0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0xdb, 0x0d,
+  0x1e, 0x34, 0x3d, 0x48, 0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d,
+  0x37, 0x04, 0x02, 0x56, 0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28,
+  0x4b, 0x40, 0x1c, 0x18, 0x0f, 0x21, 0x13, 0x1e, 0x15, 0x61, 0x3e, 0x1a,
+  0x38, 0x42, 0x24, 0x31, 0x0b, 0x12, 0x0c, 0x11, 0x12, 0x2b, 0x12, 0x2e,
+  0x18, 0x43, 0x4d, 0x55, 0x66, 0x32, 0x0e, 0x51, 0x0b, 0x1f, 0x2b, 0x33,
+  0x8f, 0x03, 0x02, 0x09, 0x1f, 0x12, 0x15, 0x0a, 0x10, 0x29, 0x11, 0x05,
+  0x84, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38, 0x54,
+  0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59, 0x24, 0x36, 0xc3, 0xae, 0x73,
+  0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a, 0x09, 0x21, 0x1e, 0x02, 0x6d,
+  0x24, 0x2a, 0x07, 0x0d, 0x39, 0x5e, 0x57, 0x34, 0x15, 0x27, 0x36, 0x4f,
+  0x27, 0x26, 0x01, 0x01, 0x6e, 0x02, 0x05, 0x3d, 0x4e, 0x56, 0x9a, 0x29,
+  0x71, 0x61, 0x1a, 0x4b, 0xee, 0x07, 0x07, 0x15, 0x18, 0x22, 0x1c, 0x09,
+  0x0d, 0x1c, 0x25, 0x12, 0x08, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0xb4,
+  0x04, 0xba, 0x02, 0xe6, 0x08, 0xe8, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x33, 0x16, 0x15, 0x14, 0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x26, 0x01, 0x35, 0x25, 0x15, 0x01,
+  0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48, 0x25, 0x1e,
+  0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56, 0x03, 0x50,
+  0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18, 0xfe, 0xe0,
+  0x02, 0x0e, 0xfd, 0xf2, 0x02, 0x0e, 0x07, 0x78, 0x4c, 0x28, 0x45, 0x3f,
+  0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa,
+  0x52, 0x59, 0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36,
+  0x59, 0x0a, 0x09, 0x21, 0x1e, 0xfe, 0x67, 0x6e, 0x82, 0x6e, 0xfe, 0x8e,
+  0x6e, 0x82, 0x6e, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x04, 0xcb, 0x02, 0xe6,
+  0x08, 0x02, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x37, 0x36, 0x37, 0x36, 0x35, 0x33, 0x16, 0x15, 0x14, 0x33, 0x32,
+  0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
+  0x26, 0x01, 0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48,
+  0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56,
+  0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18,
+  0xfe, 0xe0, 0x02, 0x0e, 0x05, 0x84, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d,
+  0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59,
+  0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a,
+  0x09, 0x21, 0x1e, 0x01, 0xc3, 0x6e, 0x82, 0x6e, 0x00, 0x03, 0x00, 0xb4,
+  0x04, 0xcb, 0x02, 0xe6, 0x09, 0x55, 0x00, 0x28, 0x00, 0x47, 0x00, 0x56,
+  0x00, 0x00, 0x01, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x35, 0x34,
+  0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x36, 0x37, 0x36, 0x35,
+  0x33, 0x16, 0x15, 0x14, 0x33, 0x32, 0x35, 0x34, 0x27, 0x33, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x27, 0x26, 0x13, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x1e, 0x01,
+  0x33, 0x15, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x35, 0x32,
+  0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48,
+  0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56,
+  0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18,
+  0x0c, 0x08, 0x12, 0x61, 0x3e, 0x1a, 0x38, 0x42, 0x24, 0x31, 0x0c, 0x0f,
+  0x21, 0x12, 0x20, 0x1d, 0x1b, 0x19, 0x26, 0x3f, 0xb4, 0x84, 0x89, 0x7d,
+  0x15, 0x4d, 0x03, 0x02, 0x09, 0x1f, 0x12, 0x15, 0x0a, 0x10, 0x29, 0x11,
+  0x05, 0x84, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d, 0x6d, 0x62, 0x7d, 0x38,
+  0x54, 0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59, 0x24, 0x36, 0xc3, 0xae,
+  0x73, 0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a, 0x09, 0x21, 0x1e, 0x02,
+  0xc3, 0x02, 0x0a, 0x38, 0x5f, 0x57, 0x34, 0x15, 0x27, 0x36, 0x4f, 0x20,
+  0x2d, 0x01, 0x01, 0x6e, 0x02, 0x02, 0x03, 0x3d, 0x2a, 0x7b, 0x6e, 0x6d,
+  0x12, 0x70, 0x07, 0x07, 0x15, 0x18, 0x22, 0x1c, 0x09, 0x0d, 0x1c, 0x25,
+  0x12, 0x08, 0x00, 0x00, 0x00, 0x02, 0x00, 0xb4, 0x04, 0xba, 0x02, 0xe6,
+  0x08, 0x20, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x37, 0x36, 0x37, 0x36, 0x35, 0x33, 0x16, 0x15, 0x14, 0x33, 0x32,
+  0x35, 0x34, 0x27, 0x33, 0x16, 0x15, 0x14, 0x07, 0x06, 0x07, 0x06, 0x27,
+  0x26, 0x01, 0x35, 0x25, 0x15, 0x01, 0xdb, 0x0d, 0x1e, 0x34, 0x3d, 0x48,
+  0x25, 0x1e, 0x0e, 0x58, 0x0a, 0x16, 0x11, 0x2d, 0x37, 0x04, 0x02, 0x56,
+  0x03, 0x50, 0x40, 0x0c, 0x5d, 0x0b, 0x19, 0x28, 0x4b, 0x40, 0x1c, 0x18,
+  0xfe, 0xe0, 0x02, 0x0e, 0x06, 0xb0, 0x4c, 0x28, 0x45, 0x3f, 0x34, 0x6d,
+  0x6d, 0x62, 0x7d, 0x38, 0x54, 0x22, 0x19, 0x14, 0x18, 0xaa, 0x52, 0x59,
+  0x24, 0x36, 0xc3, 0xae, 0x73, 0x39, 0x49, 0x74, 0x85, 0x36, 0x59, 0x0a,
+  0x09, 0x21, 0x1e, 0xfe, 0x3f, 0x6e, 0x82, 0x6e, 0x00, 0x02, 0x00, 0xc6,
+  0x04, 0xbf, 0x02, 0xd4, 0x07, 0x9e, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00,
+  0x01, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x37, 0x15,
+  0x05, 0x03, 0x35, 0x25, 0x15, 0x01, 0x2e, 0x46, 0x28, 0x0e, 0x0f, 0x33,
+  0x34, 0x53, 0x37, 0x2f, 0x2d, 0x39, 0x3c, 0x0f, 0x1a, 0x54, 0x1e, 0x6c,
+  0xfe, 0xcc, 0x68, 0x02, 0x0e, 0x05, 0x23, 0x12, 0x14, 0x24, 0x25, 0x2d,
+  0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12, 0x20, 0x1a, 0x4d, 0x1b, 0x0a,
+  0x1d, 0x66, 0x4d, 0x01, 0xef, 0x6e, 0x82, 0x6e, 0x00, 0x03, 0x00, 0xc6,
+  0x04, 0xbf, 0x02, 0xd4, 0x08, 0xf1, 0x00, 0x18, 0x00, 0x37, 0x00, 0x46,
+  0x00, 0x00, 0x01, 0x37, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x15, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x37, 0x15, 0x05, 0x13, 0x26, 0x27, 0x26, 0x35, 0x34, 0x37, 0x36, 0x33,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x1e, 0x01, 0x33, 0x15, 0x22, 0x27,
+  0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x35, 0x32, 0x37, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x35, 0x34, 0x26, 0x23, 0x22, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x01, 0x2e, 0x46, 0x28, 0x0e, 0x0f, 0x33, 0x34, 0x53, 0x37, 0x2f,
+  0x2d, 0x39, 0x3c, 0x0f, 0x1a, 0x54, 0x1e, 0x6c, 0xfe, 0xcc, 0xc4, 0x08,
+  0x12, 0x61, 0x3e, 0x1a, 0x38, 0x42, 0x24, 0x31, 0x0c, 0x0f, 0x21, 0x12,
+  0x20, 0x1d, 0x1b, 0x19, 0x26, 0x3f, 0xb4, 0x84, 0x89, 0x7d, 0x15, 0x4d,
+  0x03, 0x02, 0x09, 0x1f, 0x12, 0x15, 0x0a, 0x10, 0x29, 0x11, 0x05, 0x23,
+  0x12, 0x14, 0x24, 0x25, 0x2d, 0x60, 0x2b, 0x2d, 0x21, 0x64, 0x21, 0x12,
+  0x20, 0x1a, 0x4d, 0x1b, 0x0a, 0x1d, 0x66, 0x4d, 0x02, 0xef, 0x02, 0x0a,
+  0x38, 0x5f, 0x57, 0x34, 0x15, 0x27, 0x36, 0x4f, 0x20, 0x2d, 0x01, 0x01,
+  0x6e, 0x02, 0x02, 0x03, 0x3d, 0x2a, 0x7b, 0x6e, 0x6d, 0x12, 0x70, 0x07,
+  0x07, 0x15, 0x18, 0x22, 0x1c, 0x09, 0x0d, 0x1c, 0x25, 0x12, 0x08, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x02, 0x13, 0x05, 0xd5, 0x00, 0x05,
+  0x00, 0x00, 0x33, 0x11, 0x33, 0x11, 0x33, 0x15, 0xae, 0xa5, 0xc0, 0x05,
+  0xd5, 0xfa, 0xbe, 0x93, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x13,
+  0x05, 0xd5, 0x00, 0x07, 0x00, 0x00, 0x25, 0x33, 0x15, 0x21, 0x35, 0x33,
+  0x11, 0x33, 0x01, 0x53, 0xc0, 0xfd, 0xdb, 0xc0, 0xa5, 0x93, 0x93, 0x93,
+  0x05, 0x42, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x01, 0x54,
+  0x05, 0xd5, 0x00, 0x05, 0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x33,
+  0x01, 0x53, 0xfe, 0x9b, 0xc0, 0xa5, 0x93, 0x05, 0x42, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0xff, 0xe3, 0x04, 0x2f, 0x03, 0x93, 0x00, 0x07,
+  0x00, 0x15, 0x00, 0x00, 0x12, 0x10, 0x16, 0x32, 0x36, 0x10, 0x26, 0x22,
+  0x01, 0x06, 0x23, 0x22, 0x02, 0x10, 0x12, 0x20, 0x12, 0x15, 0x14, 0x07,
+  0x33, 0x15, 0xf2, 0xa7, 0xeb, 0xa7, 0xa7, 0xeb, 0x01, 0x0c, 0x46, 0x51,
+  0xaf, 0xf9, 0xf9, 0x01, 0x5f, 0xf9, 0x5d, 0xd5, 0x02, 0x3e, 0xfe, 0xfa,
+  0xb9, 0xb9, 0x01, 0x06, 0xb9, 0xfd, 0x09, 0x1d, 0x01, 0x15, 0x01, 0x86,
+  0x01, 0x15, 0xfe, 0xeb, 0xc3, 0xa9, 0x7f, 0x93, 0x00, 0x02, 0xff, 0xee,
+  0xff, 0xe3, 0x04, 0x2f, 0x03, 0x93, 0x00, 0x07, 0x00, 0x19, 0x00, 0x00,
+  0x12, 0x10, 0x16, 0x32, 0x36, 0x10, 0x26, 0x22, 0x01, 0x06, 0x22, 0x27,
+  0x21, 0x35, 0x33, 0x26, 0x35, 0x34, 0x12, 0x20, 0x12, 0x15, 0x14, 0x07,
+  0x33, 0x15, 0xf2, 0xa7, 0xeb, 0xa7, 0xa7, 0xeb, 0x01, 0x0c, 0x46, 0xa1,
+  0x46, 0xfe, 0x76, 0xd5, 0x5d, 0xf9, 0x01, 0x5f, 0xf9, 0x5d, 0xd5, 0x02,
+  0x3e, 0xfe, 0xfa, 0xb9, 0xb9, 0x01, 0x06, 0xb9, 0xfd, 0x09, 0x1d, 0x1d,
+  0x93, 0x7f, 0xa9, 0xc3, 0x01, 0x15, 0xfe, 0xeb, 0xc3, 0xa9, 0x7f, 0x93,
+  0x00, 0x02, 0xff, 0xee, 0xff, 0xe3, 0x03, 0xb8, 0x03, 0x93, 0x00, 0x07,
+  0x00, 0x15, 0x00, 0x00, 0x12, 0x10, 0x16, 0x32, 0x36, 0x10, 0x26, 0x22,
+  0x03, 0x26, 0x35, 0x34, 0x12, 0x20, 0x12, 0x10, 0x02, 0x23, 0x22, 0x27,
+  0x21, 0x35, 0xf2, 0xa7, 0xeb, 0xa7, 0xa7, 0xeb, 0xd6, 0x5d, 0xf9, 0x01,
+  0x5f, 0xf9, 0xf9, 0xb0, 0x50, 0x46, 0xfe, 0x76, 0x02, 0x3e, 0xfe, 0xfa,
+  0xb9, 0xb9, 0x01, 0x06, 0xb9, 0xfd, 0x9c, 0x7f, 0xa9, 0xc3, 0x01, 0x15,
+  0xfe, 0xeb, 0xfe, 0x7a, 0xfe, 0xeb, 0x1d, 0x93, 0x00, 0x01, 0x00, 0x36,
+  0x00, 0x00, 0x03, 0x20, 0x05, 0xd9, 0x00, 0x0a, 0x00, 0x00, 0x29, 0x01,
+  0x11, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x11, 0x21, 0x03, 0x1f, 0xfe,
+  0x15, 0xfd, 0xaf, 0xa1, 0xa1, 0xae, 0xfd, 0x01, 0x46, 0x03, 0x2a, 0x02,
+  0xaf, 0xfe, 0x5d, 0x01, 0xa3, 0xfd, 0x51, 0xfd, 0x69, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x20, 0x05, 0xd9, 0x00, 0x0c,
+  0x00, 0x00, 0x25, 0x15, 0x21, 0x35, 0x21, 0x11, 0x03, 0x33, 0x1b, 0x01,
+  0x33, 0x03, 0x11, 0x03, 0x1f, 0xfc, 0xcf, 0x01, 0x46, 0xfd, 0xaf, 0xa1,
+  0xa1, 0xae, 0xfd, 0x93, 0x93, 0x93, 0x02, 0x97, 0x02, 0xaf, 0xfe, 0x5d,
+  0x01, 0xa3, 0xfd, 0x51, 0xfd, 0x69, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0xd7, 0x05, 0xd9, 0x00, 0x0a, 0x00, 0x00, 0x23, 0x35,
+  0x21, 0x11, 0x03, 0x33, 0x1b, 0x01, 0x33, 0x03, 0x11, 0x12, 0x01, 0x46,
+  0xfd, 0xaf, 0xa1, 0xa1, 0xae, 0xfd, 0x93, 0x02, 0x97, 0x02, 0xaf, 0xfe,
+  0x5d, 0x01, 0xa3, 0xfd, 0x51, 0xfc, 0xd6, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0x00, 0x00, 0x04, 0x55, 0x03, 0x71, 0x00, 0x08, 0x00, 0x00, 0x21, 0x23,
+  0x09, 0x01, 0x23, 0x01, 0x33, 0x01, 0x33, 0x04, 0x55, 0xf9, 0xfe, 0xc5,
+  0xfe, 0xc5, 0xaf, 0x01, 0x7a, 0xe1, 0x01, 0x48, 0x7b, 0x02, 0xbd, 0xfd,
+  0x43, 0x03, 0x71, 0xfd, 0x22, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x00, 0x00, 0x04, 0x55, 0x03, 0x71, 0x00, 0x0a, 0x00, 0x00, 0x33, 0x23,
+  0x35, 0x33, 0x01, 0x33, 0x01, 0x33, 0x15, 0x23, 0x01, 0xe6, 0xf8, 0x7a,
+  0x01, 0x49, 0xe1, 0x01, 0x48, 0x7b, 0xf9, 0xfe, 0xc5, 0x93, 0x02, 0xde,
+  0xfd, 0x22, 0x93, 0x02, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x00, 0x00, 0x04, 0x0c, 0x03, 0x71, 0x00, 0x08, 0x00, 0x00, 0x33, 0x23,
+  0x35, 0x33, 0x01, 0x33, 0x01, 0x23, 0x01, 0xe6, 0xf8, 0x7a, 0x01, 0x49,
+  0xe1, 0x01, 0x7a, 0xb0, 0xfe, 0xc5, 0x93, 0x02, 0xde, 0xfc, 0x8f, 0x02,
+  0xbd, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8,
+  0x03, 0x71, 0x00, 0x09, 0x00, 0x00, 0x29, 0x01, 0x11, 0x33, 0x11, 0x21,
+  0x11, 0x33, 0x11, 0x33, 0x04, 0xc7, 0xfb, 0xe0, 0xa7, 0x02, 0x19, 0xa7,
+  0xb9, 0x03, 0x71, 0xfd, 0x22, 0x02, 0xde, 0xfd, 0x22, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x0b,
+  0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33,
+  0x11, 0x33, 0x04, 0xc7, 0xfb, 0x27, 0xb9, 0xa7, 0x02, 0x19, 0xa7, 0xb9,
+  0x93, 0x02, 0xde, 0xfd, 0x22, 0x02, 0xde, 0xfd, 0x22, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e, 0x03, 0x71, 0x00, 0x09,
+  0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33,
+  0x04, 0x0e, 0xfb, 0xe0, 0xb9, 0xa7, 0x02, 0x19, 0xa7, 0x93, 0x02, 0xde,
+  0xfd, 0x22, 0x02, 0xde, 0x00, 0x01, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8,
+  0x03, 0x71, 0x00, 0x09, 0x00, 0x00, 0x33, 0x35, 0x21, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x33, 0x15, 0xa7, 0x02, 0xc0, 0xfd, 0x40, 0x03, 0x67, 0xb9,
+  0x93, 0x02, 0x4b, 0x93, 0xfd, 0x22, 0x93, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x09, 0x00, 0x00, 0x23, 0x35,
+  0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x15, 0x12, 0x03, 0x79, 0xfd,
+  0x40, 0x03, 0x67, 0xb9, 0x93, 0x02, 0x4b, 0x93, 0xfd, 0x22, 0x93, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e, 0x03, 0x71, 0x00, 0x07,
+  0x00, 0x00, 0x01, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x04, 0x0e,
+  0xfb, 0xe0, 0x03, 0x79, 0xfd, 0x40, 0x03, 0x71, 0xfc, 0x8f, 0x93, 0x02,
+  0x4b, 0x93, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x04, 0x59,
+  0x05, 0xe2, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x00, 0x21, 0x11, 0x26, 0x27,
+  0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06,
+  0x07, 0x11, 0x21, 0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34,
+  0x2e, 0x01, 0x22, 0x06, 0x01, 0xd0, 0x49, 0x43, 0x67, 0x77, 0x77, 0xce,
+  0xf1, 0xcf, 0x76, 0x76, 0x68, 0x43, 0x4a, 0x01, 0xe2, 0xfc, 0x9a, 0x52,
+  0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x03, 0x0e, 0x0b, 0x20,
+  0x31, 0xa8, 0xc5, 0xa9, 0x62, 0x62, 0xa9, 0xc5, 0xa8, 0x31, 0x20, 0x0b,
+  0xfd, 0x85, 0x93, 0x04, 0xad, 0x70, 0x60, 0x38, 0x38, 0x60, 0x70, 0x60,
+  0x38, 0x38, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
+  0x05, 0xe2, 0x00, 0x15, 0x00, 0x21, 0x00, 0x00, 0x25, 0x21, 0x15, 0x21,
+  0x35, 0x21, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32, 0x1e,
+  0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e,
+  0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x02, 0x76, 0x01, 0xe2, 0xfb, 0x96,
+  0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x77, 0xce, 0xf1, 0xcf, 0x76, 0x76,
+  0x68, 0x43, 0x4a, 0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d,
+  0xa6, 0x8c, 0x93, 0x93, 0x93, 0x02, 0x7b, 0x0b, 0x20, 0x31, 0xa8, 0xc5,
+  0xa9, 0x62, 0x62, 0xa9, 0xc5, 0xa8, 0x31, 0x20, 0x0b, 0x01, 0x9f, 0x70,
+  0x60, 0x38, 0x38, 0x60, 0x70, 0x60, 0x38, 0x38, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xe1, 0x05, 0xe2, 0x00, 0x13, 0x00, 0x1f, 0x00, 0x00,
+  0x23, 0x35, 0x21, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x3e, 0x01, 0x32,
+  0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x00, 0x14, 0x1e, 0x01,
+  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x12, 0x01, 0xe2, 0x49,
+  0x43, 0x67, 0x77, 0x77, 0xce, 0xf1, 0xcf, 0x76, 0x76, 0x68, 0x43, 0x4a,
+  0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x93,
+  0x02, 0x7b, 0x0b, 0x20, 0x31, 0xa8, 0xc5, 0xa9, 0x62, 0x62, 0xa9, 0xc5,
+  0xa8, 0x31, 0x20, 0x0b, 0xfc, 0xf2, 0x04, 0xad, 0x70, 0x60, 0x38, 0x38,
+  0x60, 0x70, 0x60, 0x38, 0x38, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xa7,
+  0x00, 0x00, 0x04, 0xc8, 0x04, 0xa6, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x00,
+  0x01, 0x10, 0x33, 0x15, 0x22, 0x07, 0x33, 0x15, 0x23, 0x01, 0x21, 0x35,
+  0x21, 0x01, 0xdc, 0xda, 0x77, 0x02, 0x78, 0xd9, 0x02, 0xeb, 0xfb, 0xe0,
+  0x04, 0x20, 0x03, 0x9c, 0x01, 0x0a, 0x66, 0x9a, 0x9e, 0xfc, 0xf8, 0x93,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0xc8, 0x04, 0xa6, 0x00, 0x08,
+  0x00, 0x0c, 0x00, 0x00, 0x01, 0x10, 0x33, 0x15, 0x22, 0x07, 0x33, 0x15,
+  0x23, 0x01, 0x21, 0x35, 0x21, 0x01, 0xdc, 0xda, 0x77, 0x02, 0x78, 0xd9,
+  0x02, 0xeb, 0xfb, 0x27, 0x04, 0xd9, 0x03, 0x9c, 0x01, 0x0a, 0x66, 0x9a,
+  0x9e, 0xfc, 0xf8, 0x93, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e,
+  0x04, 0xa6, 0x00, 0x08, 0x00, 0x0c, 0x00, 0x00, 0x01, 0x10, 0x33, 0x15,
+  0x22, 0x07, 0x33, 0x15, 0x23, 0x01, 0x21, 0x35, 0x21, 0x01, 0xdc, 0xda,
+  0x77, 0x02, 0x78, 0xd9, 0x02, 0x32, 0xfb, 0xe0, 0x04, 0x20, 0x03, 0x9c,
+  0x01, 0x0a, 0x66, 0x9a, 0x9e, 0xfc, 0xf8, 0x93, 0x00, 0x02, 0x00, 0x65,
+  0x00, 0x00, 0x06, 0x0a, 0x05, 0xee, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x00,
+  0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x22, 0x26, 0x10, 0x36, 0x20,
+  0x17, 0x16, 0x1d, 0x01, 0x21, 0x11, 0x33, 0x15, 0x01, 0x35, 0x34, 0x27,
+  0x26, 0x22, 0x06, 0x14, 0x16, 0x33, 0x04, 0xa9, 0xfe, 0x70, 0x8d, 0xdf,
+  0xa9, 0x9e, 0x9f, 0x01, 0x42, 0x55, 0x7d, 0x02, 0x37, 0xb9, 0xfc, 0x83,
+  0x53, 0x33, 0xb2, 0x62, 0x67, 0x54, 0x02, 0xde, 0xfe, 0xc4, 0x01, 0x3c,
+  0xd6, 0x01, 0x55, 0xe5, 0x66, 0x98, 0xb6, 0xc9, 0xfd, 0x22, 0x93, 0x03,
+  0x71, 0xc9, 0x83, 0x5d, 0x38, 0x98, 0xc6, 0x83, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x06, 0x0a, 0x05, 0xee, 0x00, 0x15, 0x00, 0x1f, 0x00, 0x00,
+  0x25, 0x11, 0x21, 0x11, 0x23, 0x11, 0x23, 0x22, 0x26, 0x10, 0x36, 0x20,
+  0x17, 0x16, 0x1d, 0x01, 0x21, 0x11, 0x33, 0x15, 0x21, 0x35, 0x01, 0x35,
+  0x34, 0x27, 0x26, 0x22, 0x06, 0x14, 0x16, 0x33, 0x04, 0xa9, 0xfe, 0x70,
+  0x8d, 0xdf, 0xa9, 0x9e, 0x9f, 0x01, 0x42, 0x55, 0x7d, 0x02, 0x37, 0xb9,
+  0xf9, 0xe5, 0x02, 0x9e, 0x53, 0x33, 0xb2, 0x62, 0x67, 0x54, 0x93, 0x02,
+  0x4b, 0xfe, 0xc4, 0x01, 0x3c, 0xd6, 0x01, 0x55, 0xe5, 0x66, 0x98, 0xb6,
+  0xc9, 0xfd, 0x22, 0x93, 0x93, 0x02, 0xde, 0xc9, 0x83, 0x5d, 0x38, 0x98,
+  0xc6, 0x83, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0x50,
+  0x05, 0xee, 0x00, 0x13, 0x00, 0x1d, 0x00, 0x00, 0x25, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x23, 0x22, 0x26, 0x10, 0x36, 0x20, 0x17, 0x16, 0x1d, 0x01,
+  0x21, 0x11, 0x21, 0x35, 0x01, 0x35, 0x34, 0x27, 0x26, 0x22, 0x06, 0x14,
+  0x16, 0x33, 0x04, 0xa9, 0xfe, 0x70, 0x8d, 0xdf, 0xa9, 0x9e, 0x9f, 0x01,
+  0x42, 0x55, 0x7d, 0x02, 0x37, 0xfa, 0x9e, 0x02, 0x9e, 0x53, 0x33, 0xb2,
+  0x62, 0x67, 0x54, 0x93, 0x02, 0x4b, 0xfe, 0xc4, 0x01, 0x3c, 0xd6, 0x01,
+  0x55, 0xe5, 0x66, 0x98, 0xb6, 0xc9, 0xfc, 0x8f, 0x93, 0x02, 0xde, 0xc9,
+  0x83, 0x5d, 0x38, 0x98, 0xc6, 0x83, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad,
+  0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x33, 0x11,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0xae, 0x02,
+  0x42, 0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x01, 0xe6, 0x05, 0xd5, 0x93,
+  0xfe, 0x2f, 0x92, 0xfd, 0xb4, 0x93, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x23, 0x35,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15,
+  0x12, 0xc0, 0x02, 0x42, 0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x01, 0xe6,
+  0x93, 0x05, 0x42, 0x93, 0xfe, 0x2f, 0x92, 0xfd, 0xb4, 0x93, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0xf1, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x29, 0x01, 0x35, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21,
+  0x15, 0x21, 0x01, 0x53, 0xfe, 0x9b, 0xc0, 0x02, 0x42, 0xfe, 0x63, 0x01,
+  0x9d, 0xfe, 0x63, 0x93, 0x05, 0x42, 0x93, 0xfe, 0x2f, 0x92, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0b,
+  0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x33, 0x15, 0x01, 0xd4, 0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x02, 0x43,
+  0xbf, 0x02, 0xdf, 0x92, 0x01, 0xd1, 0x93, 0xfa, 0xbe, 0x93, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x3a, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x33, 0x15, 0x12, 0x01, 0xe6, 0xfe, 0x63, 0x01, 0x9d, 0xfe,
+  0x63, 0x02, 0x43, 0xbf, 0x93, 0x02, 0x4c, 0x92, 0x01, 0xd1, 0x93, 0xfa,
+  0xbe, 0x93, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x7a,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21,
+  0x35, 0x21, 0x11, 0x21, 0x35, 0x21, 0x02, 0x7a, 0xfd, 0x74, 0x01, 0xe6,
+  0xfe, 0x63, 0x01, 0x9d, 0xfe, 0x63, 0x02, 0x43, 0x93, 0x02, 0x4c, 0x92,
+  0x01, 0xd1, 0x93, 0x00, 0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0x18,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x17, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0x11, 0x33, 0x11, 0x21,
+  0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x33, 0x15, 0x02, 0x59, 0xfe, 0xef,
+  0x01, 0x0e, 0x49, 0x2f, 0x28, 0x28, 0x37, 0xfe, 0x10, 0xa7, 0x01, 0x33,
+  0x5e, 0x73, 0x4f, 0x47, 0xbe, 0x02, 0xde, 0xfd, 0xb5, 0x5d, 0x4f, 0x7a,
+  0x7d, 0x49, 0x5f, 0xfd, 0x22, 0x05, 0xd5, 0xfd, 0x9c, 0x87, 0x5f, 0xd2,
+  0xa4, 0x82, 0x93, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x18,
+  0x05, 0xd5, 0x00, 0x0e, 0x00, 0x19, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11,
+  0x33, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x33, 0x15, 0x01,
+  0x21, 0x11, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x12, 0xb9,
+  0xa7, 0x01, 0x33, 0x5e, 0x73, 0x4f, 0x47, 0xbe, 0xfe, 0x41, 0xfe, 0xef,
+  0x01, 0x0e, 0x49, 0x2f, 0x28, 0x28, 0x37, 0x93, 0x05, 0x42, 0xfd, 0x9c,
+  0x87, 0x5f, 0xd2, 0xa4, 0x82, 0x93, 0x02, 0xde, 0xfd, 0xb5, 0x5d, 0x4f,
+  0x7a, 0x7d, 0x49, 0x5f, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xa1,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x19, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x01, 0x35, 0x33, 0x11, 0x33,
+  0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x02, 0x59,
+  0xfe, 0xef, 0x01, 0x0e, 0x49, 0x2f, 0x28, 0x28, 0x37, 0xfd, 0x57, 0xb9,
+  0xa7, 0x01, 0x33, 0x5e, 0x73, 0x4f, 0x4f, 0x50, 0x61, 0x02, 0xde, 0xfd,
+  0xb5, 0x5d, 0x4f, 0x7a, 0x7d, 0x49, 0x5f, 0xfd, 0x22, 0x93, 0x05, 0x42,
+  0xfd, 0x9c, 0x87, 0x5f, 0xd2, 0xad, 0x87, 0x85, 0x00, 0x01, 0x00, 0xad,
+  0x00, 0x00, 0x04, 0x7a, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x21, 0x34,
+  0x02, 0x27, 0x26, 0x27, 0x03, 0x35, 0x21, 0x15, 0x05, 0x13, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x15, 0x21, 0x15, 0x02, 0x66, 0x18, 0x30, 0x46, 0x7b,
+  0xaf, 0x03, 0x0c, 0xfd, 0xd6, 0x8e, 0x7a, 0x2f, 0x3b, 0x06, 0x02, 0x01,
+  0x70, 0x99, 0x01, 0x5f, 0x96, 0xdc, 0xdc, 0x01, 0x39, 0x56, 0x93, 0x01,
+  0xfe, 0xef, 0xea, 0xb8, 0xe6, 0x9c, 0x40, 0x39, 0x93, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x04, 0x7a, 0x05, 0xd5, 0x00, 0x16,
+  0x00, 0x00, 0x23, 0x35, 0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03,
+  0x35, 0x21, 0x15, 0x05, 0x13, 0x16, 0x17, 0x16, 0x17, 0x16, 0x15, 0x21,
+  0x15, 0x12, 0x02, 0x75, 0x03, 0x07, 0x0b, 0x30, 0x46, 0x7b, 0xaf, 0x03,
+  0x0c, 0xfd, 0xd6, 0x8e, 0x7a, 0x2f, 0x3b, 0x06, 0x02, 0x01, 0x70, 0x93,
+  0x58, 0x5d, 0xb0, 0x96, 0xdc, 0xdc, 0x01, 0x39, 0x56, 0x93, 0x01, 0xfe,
+  0xef, 0xea, 0xb8, 0xe6, 0x9c, 0x40, 0x39, 0x93, 0x00, 0x01, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xba, 0x05, 0xd5, 0x00, 0x13, 0x00, 0x00, 0x23, 0x35,
+  0x21, 0x26, 0x27, 0x26, 0x27, 0x26, 0x27, 0x03, 0x35, 0x21, 0x15, 0x05,
+  0x13, 0x16, 0x17, 0x16, 0x12, 0x07, 0x12, 0x02, 0x75, 0x03, 0x07, 0x0b,
+  0x30, 0x46, 0x7b, 0xaf, 0x03, 0x0c, 0xfd, 0xd6, 0x8e, 0x7a, 0x2f, 0x3b,
+  0x0a, 0x01, 0x93, 0x58, 0x5d, 0xb0, 0x96, 0xdc, 0xdc, 0x01, 0x39, 0x56,
+  0x93, 0x01, 0xfe, 0xef, 0xea, 0xb8, 0xe6, 0xfe, 0xc9, 0x71, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x02, 0x98, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x00, 0x21, 0x11, 0x03, 0x35, 0x13, 0x33, 0x11, 0x33, 0x15, 0x01,
+  0x32, 0xfb, 0xf9, 0xa8, 0xbf, 0x04, 0xdf, 0xfe, 0xc7, 0xf6, 0x01, 0x39,
+  0xfa, 0xbe, 0x93, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x02, 0x98,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x03, 0x35,
+  0x13, 0x33, 0x11, 0x33, 0x15, 0x12, 0x01, 0x44, 0xfb, 0xf9, 0xa8, 0xbf,
+  0x93, 0x04, 0x4c, 0xfe, 0xc7, 0xf6, 0x01, 0x39, 0xfa, 0xbe, 0x93, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x01, 0xd8, 0x05, 0xd5, 0x00, 0x08,
+  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x03, 0x35, 0x13, 0x33, 0x11, 0x12,
+  0x01, 0x44, 0xfb, 0xf9, 0xa8, 0x93, 0x04, 0x4c, 0xfe, 0xc7, 0xf6, 0x01,
+  0x39, 0xfa, 0x2b, 0x00, 0x00, 0x03, 0x00, 0xad, 0x00, 0x00, 0x06, 0xfa,
+  0x04, 0x1a, 0x00, 0x11, 0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x33, 0x11,
+  0x34, 0x12, 0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16,
+  0x15, 0x11, 0x33, 0x15, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11,
+  0x21, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0xae, 0xdb,
+  0xb3, 0x70, 0x6c, 0x30, 0x21, 0x87, 0xbe, 0xbd, 0x55, 0x7a, 0xc0, 0xfe,
+  0x98, 0x93, 0x51, 0x74, 0x72, 0x01, 0xca, 0xfd, 0x8e, 0x94, 0x50, 0x62,
+  0x85, 0x01, 0xcb, 0x01, 0xee, 0xa6, 0x00, 0xff, 0x4b, 0x2d, 0x2d, 0xd2,
+  0x58, 0x80, 0x68, 0xfd, 0xb9, 0x93, 0x02, 0x7c, 0x82, 0x80, 0xc5, 0x95,
+  0xfe, 0x6e, 0x01, 0x63, 0x83, 0x7f, 0xa7, 0xd2, 0xf2, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x06, 0xfa, 0x04, 0x1a, 0x00, 0x13,
+  0x00, 0x1c, 0x00, 0x25, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11, 0x34, 0x12,
+  0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
+  0x33, 0x15, 0x01, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x01,
+  0x34, 0x26, 0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x12, 0xc0, 0xdb, 0xb3,
+  0x70, 0x6c, 0x30, 0x21, 0x87, 0xbe, 0xbd, 0x55, 0x7a, 0xc0, 0xfe, 0x98,
+  0x93, 0x51, 0x74, 0x72, 0x01, 0xca, 0xfd, 0x8e, 0x94, 0x50, 0x62, 0x85,
+  0x01, 0xcb, 0x93, 0x01, 0x5b, 0xa6, 0x00, 0xff, 0x4b, 0x2d, 0x2d, 0xd2,
+  0x58, 0x80, 0x68, 0xfd, 0xb9, 0x93, 0x02, 0x7c, 0x82, 0x80, 0xc5, 0x95,
+  0xfe, 0x6e, 0x01, 0x63, 0x83, 0x7f, 0xa7, 0xd2, 0xf2, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x06, 0x3a, 0x04, 0x1a, 0x00, 0x11,
+  0x00, 0x1a, 0x00, 0x23, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11, 0x34, 0x12,
+  0x33, 0x32, 0x16, 0x17, 0x3e, 0x01, 0x33, 0x32, 0x17, 0x16, 0x15, 0x11,
+  0x03, 0x34, 0x26, 0x23, 0x22, 0x06, 0x15, 0x11, 0x21, 0x01, 0x34, 0x26,
+  0x23, 0x22, 0x06, 0x1d, 0x01, 0x21, 0x12, 0xc0, 0xdb, 0xb3, 0x70, 0x6c,
+  0x30, 0x21, 0x87, 0xbe, 0xbd, 0x55, 0x7a, 0xa8, 0x93, 0x51, 0x74, 0x72,
+  0x01, 0xca, 0xfd, 0x8e, 0x94, 0x50, 0x62, 0x85, 0x01, 0xcb, 0x93, 0x01,
+  0x5b, 0xa6, 0x00, 0xff, 0x4b, 0x2d, 0x2d, 0xd2, 0x58, 0x80, 0x68, 0xfd,
+  0x26, 0x02, 0x7c, 0x82, 0x80, 0xc5, 0x95, 0xfe, 0x6e, 0x01, 0x63, 0x83,
+  0x7f, 0xa7, 0xd2, 0xf2, 0x00, 0x01, 0x00, 0x36, 0x00, 0x00, 0x03, 0x7a,
+  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11,
+  0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x01, 0x61, 0xfe, 0xd6,
+  0x01, 0x2a, 0xa5, 0x01, 0x2a, 0xfe, 0xd6, 0x01, 0x73, 0x03, 0x81, 0x93,
+  0x01, 0xc1, 0xfe, 0x3f, 0x93, 0xfd, 0x12, 0x93, 0x00, 0x01, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0x7a, 0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x23, 0x35,
+  0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x21, 0x15, 0x12, 0x01, 0x73, 0xfe, 0xd6, 0x01, 0x2a, 0xa5, 0x01, 0x2a,
+  0xfe, 0xd6, 0x01, 0x73, 0x93, 0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe, 0x3f,
+  0x93, 0xfd, 0x12, 0x93, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x31,
+  0x05, 0xd5, 0x00, 0x0d, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21,
+  0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x02, 0x06, 0xfd, 0xe8,
+  0x01, 0x73, 0xfe, 0xd6, 0x01, 0x2a, 0xa5, 0x01, 0x2a, 0xfe, 0xd6, 0x93,
+  0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe, 0x3f, 0x93, 0x00, 0x02, 0x00, 0x36,
+  0x00, 0x00, 0x05, 0xb6, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x15, 0x00, 0x00,
+  0x25, 0x11, 0x21, 0x11, 0x07, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x33, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x03, 0x9d,
+  0xfe, 0x6a, 0xa6, 0xfe, 0xd6, 0x01, 0x2a, 0xa6, 0x01, 0x96, 0xa6, 0x01,
+  0x2b, 0xfe, 0xd5, 0x01, 0x73, 0x93, 0x02, 0xee, 0xfd, 0x12, 0x93, 0x03,
+  0x81, 0x93, 0x01, 0xc1, 0xfe, 0x3f, 0x01, 0xc1, 0xfe, 0x3f, 0x93, 0xfd,
+  0x12, 0x93, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0xb6,
+  0x05, 0xd5, 0x00, 0x13, 0x00, 0x17, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11,
+  0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21, 0x15,
+  0x21, 0x11, 0x21, 0x15, 0x25, 0x11, 0x21, 0x11, 0x12, 0x01, 0x73, 0xfe,
+  0xd6, 0x01, 0x2a, 0xa6, 0x01, 0x96, 0xa6, 0x01, 0x2b, 0xfe, 0xd5, 0x01,
+  0x73, 0xfd, 0xe7, 0xfe, 0x6a, 0x93, 0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe,
+  0x3f, 0x01, 0xc1, 0xfe, 0x3f, 0x93, 0xfd, 0x12, 0x93, 0x93, 0x02, 0xee,
+  0xfd, 0x12, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0x6e,
+  0x05, 0xd5, 0x00, 0x11, 0x00, 0x15, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21,
+  0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x21,
+  0x15, 0x21, 0x03, 0x11, 0x21, 0x11, 0x04, 0x43, 0xfb, 0xab, 0x01, 0x73,
+  0xfe, 0xd6, 0x01, 0x2a, 0xa6, 0x01, 0x96, 0xa6, 0x01, 0x2b, 0xfe, 0xd5,
+  0xa6, 0xfe, 0x6a, 0x93, 0x02, 0xee, 0x93, 0x01, 0xc1, 0xfe, 0x3f, 0x01,
+  0xc1, 0xfe, 0x3f, 0x93, 0xfd, 0x12, 0x02, 0xee, 0xfd, 0x12, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0xa7, 0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x05,
+  0x00, 0x09, 0x00, 0x00, 0x33, 0x11, 0x21, 0x11, 0x33, 0x15, 0x01, 0x11,
+  0x21, 0x11, 0xa7, 0x03, 0x67, 0xb9, 0xfc, 0x87, 0x02, 0x19, 0x03, 0x71,
+  0xfd, 0x22, 0x93, 0x02, 0xde, 0xfd, 0xb5, 0x02, 0x4b, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0xc8, 0x03, 0x71, 0x00, 0x07,
+  0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x33, 0x11, 0x21, 0x11, 0x33, 0x15,
+  0x01, 0x11, 0x21, 0x11, 0x12, 0xb9, 0x03, 0x67, 0xb9, 0xfc, 0x87, 0x02,
+  0x19, 0x93, 0x02, 0xde, 0xfd, 0x22, 0x93, 0x02, 0xde, 0xfd, 0xb5, 0x02,
+  0x4b, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0e,
+  0x03, 0x71, 0x00, 0x05, 0x00, 0x09, 0x00, 0x00, 0x29, 0x01, 0x35, 0x33,
+  0x11, 0x21, 0x05, 0x11, 0x21, 0x11, 0x04, 0x0e, 0xfb, 0xe0, 0xb9, 0x03,
+  0x67, 0xfd, 0x40, 0x02, 0x19, 0x93, 0x02, 0xde, 0x93, 0xfd, 0xb5, 0x02,
+  0x4b, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x04, 0x92,
+  0x05, 0xd5, 0x00, 0x02, 0x00, 0x08, 0x00, 0x00, 0x01, 0x21, 0x01, 0x07,
+  0x01, 0x21, 0x01, 0x21, 0x15, 0x03, 0x65, 0xfd, 0xb6, 0x01, 0x25, 0x68,
+  0xfe, 0x5f, 0x04, 0x12, 0xfe, 0x91, 0x01, 0xb8, 0x05, 0x42, 0xfb, 0x7e,
+  0xc0, 0x05, 0xd5, 0xfa, 0xbe, 0x93, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x04, 0x92, 0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00,
+  0x01, 0x21, 0x01, 0x05, 0x35, 0x21, 0x01, 0x21, 0x01, 0x21, 0x15, 0x03,
+  0x65, 0xfd, 0xb6, 0x01, 0x25, 0xfd, 0xae, 0x01, 0xb8, 0xfe, 0x91, 0x04,
+  0x12, 0xfe, 0x91, 0x01, 0xb8, 0x05, 0x42, 0xfb, 0x7e, 0xc0, 0x93, 0x05,
+  0x42, 0xfa, 0xbe, 0x93, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x4a,
+  0x05, 0xd5, 0x00, 0x02, 0x00, 0x08, 0x00, 0x00, 0x01, 0x21, 0x01, 0x05,
+  0x35, 0x21, 0x01, 0x21, 0x01, 0x03, 0x65, 0xfd, 0xb6, 0x01, 0x25, 0xfd,
+  0xae, 0x01, 0xb8, 0xfe, 0x91, 0x04, 0x12, 0xfe, 0x5f, 0x05, 0x42, 0xfb,
+  0x7e, 0xc0, 0x93, 0x05, 0x42, 0xfa, 0x2b, 0x00, 0x00, 0x03, 0x00, 0xad,
+  0x00, 0x00, 0x05, 0x5b, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x1f,
+  0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b,
+  0x01, 0x01, 0x11, 0x21, 0x11, 0x01, 0x11, 0x21, 0x11, 0x21, 0x32, 0x17,
+  0x16, 0x15, 0x06, 0x07, 0x06, 0x2f, 0x01, 0x11, 0x21, 0x15, 0x03, 0x15,
+  0x97, 0x55, 0x21, 0x1b, 0x1b, 0x1b, 0x5e, 0x94, 0xfe, 0x3f, 0x01, 0x1c,
+  0xfe, 0x3e, 0x01, 0xc2, 0x01, 0x84, 0x77, 0x3a, 0x3e, 0x01, 0x3d, 0x53,
+  0x7e, 0xbf, 0x02, 0x46, 0x03, 0x71, 0x51, 0x45, 0x3d, 0x3c, 0x64, 0x5e,
+  0xfd, 0x9c, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x03, 0x71, 0x02, 0x64,
+  0x85, 0x90, 0x7c, 0x91, 0x5b, 0x7c, 0x01, 0x01, 0xfd, 0xb5, 0x93, 0x00,
+  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x05, 0x5b, 0x05, 0xd5, 0x00, 0x0a,
+  0x00, 0x0e, 0x00, 0x21, 0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x2b, 0x01, 0x01, 0x11, 0x21, 0x11, 0x01, 0x35, 0x33,
+  0x11, 0x21, 0x11, 0x21, 0x32, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06, 0x2f,
+  0x01, 0x11, 0x21, 0x15, 0x03, 0x15, 0x97, 0x55, 0x21, 0x1b, 0x1b, 0x1b,
+  0x5e, 0x94, 0xfe, 0x3f, 0x01, 0x1c, 0xfd, 0x7e, 0xc0, 0x01, 0xc2, 0x01,
+  0x84, 0x77, 0x3a, 0x3e, 0x01, 0x3d, 0x53, 0x7e, 0xbf, 0x02, 0x46, 0x03,
+  0x71, 0x51, 0x45, 0x3d, 0x3c, 0x64, 0x5e, 0xfd, 0x9c, 0xfd, 0xb5, 0x02,
+  0x4b, 0xfd, 0x22, 0x93, 0x02, 0xde, 0x02, 0x64, 0x85, 0x90, 0x7c, 0x91,
+  0x5b, 0x7c, 0x01, 0x01, 0xfd, 0xb5, 0x93, 0x00, 0x00, 0x03, 0xff, 0xee,
+  0x00, 0x00, 0x04, 0xe3, 0x05, 0xd5, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x1f,
+  0x00, 0x00, 0x01, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x2b,
+  0x01, 0x01, 0x11, 0x21, 0x11, 0x13, 0x21, 0x35, 0x33, 0x11, 0x21, 0x11,
+  0x21, 0x32, 0x17, 0x16, 0x15, 0x06, 0x07, 0x06, 0x2f, 0x01, 0x03, 0x15,
+  0x97, 0x55, 0x21, 0x1b, 0x1b, 0x1b, 0x5e, 0x94, 0xfe, 0x3f, 0x01, 0x1c,
+  0xa5, 0xfc, 0xd9, 0xc0, 0x01, 0xc2, 0x01, 0x84, 0x77, 0x3a, 0x3e, 0x01,
+  0x3d, 0x53, 0x7e, 0xbf, 0x03, 0x71, 0x51, 0x45, 0x3d, 0x3c, 0x64, 0x5e,
+  0xfd, 0x9c, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x93, 0x02, 0xde, 0x02,
+  0x64, 0x85, 0x90, 0x7c, 0x91, 0x5b, 0x7c, 0x01, 0x01, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x03, 0xe3, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x33, 0x11, 0x33, 0x15, 0x02, 0x7e, 0xfe, 0xd6, 0xa6, 0xa6, 0x01, 0x2a,
+  0xa6, 0xbe, 0x03, 0x81, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0x01, 0xc1,
+  0xfa, 0xbe, 0x93, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe3,
+  0x05, 0xd5, 0x00, 0x0f, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x33, 0x11, 0x33, 0x15, 0x12, 0x02,
+  0x90, 0xfe, 0xd6, 0xa6, 0xa6, 0x01, 0x2a, 0xa6, 0xbe, 0x93, 0x02, 0xee,
+  0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0x01, 0xc1, 0xfa, 0xbe, 0x93, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x24, 0x05, 0xd5, 0x00, 0x0d,
+  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x33, 0x11, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6, 0xa6, 0x01,
+  0x2a, 0xa6, 0x93, 0x02, 0xee, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0x01,
+  0xc1, 0xfa, 0x2b, 0x00, 0x00, 0x02, 0x00, 0x64, 0x00, 0x00, 0x05, 0x49,
+  0x05, 0xd5, 0x00, 0x0a, 0x00, 0x1d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x01, 0x11, 0x21, 0x22, 0x27,
+  0x26, 0x35, 0x34, 0x37, 0x36, 0x33, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11,
+  0x21, 0x15, 0x01, 0xac, 0x01, 0x12, 0xfe, 0xf2, 0x4a, 0x2f, 0x27, 0x27,
+  0x37, 0x01, 0x4a, 0xfe, 0xcd, 0x61, 0x70, 0x4f, 0x4f, 0x4f, 0x61, 0x01,
+  0xfa, 0x01, 0x2b, 0xfe, 0xd5, 0x01, 0xeb, 0x02, 0xf7, 0x02, 0x4b, 0x5d,
+  0x4f, 0x7a, 0x7d, 0x49, 0x5f, 0xfd, 0x09, 0x02, 0x64, 0x87, 0x5f, 0xd2,
+  0xad, 0x87, 0x85, 0xfd, 0x22, 0x93, 0xfe, 0x2f, 0x93, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x05, 0x49, 0x05, 0xd5, 0x00, 0x0a,
+  0x00, 0x1f, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x22, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x01, 0x35, 0x21, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x33, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15,
+  0x01, 0xac, 0x01, 0x12, 0xfe, 0xf2, 0x4a, 0x2f, 0x27, 0x27, 0x37, 0xfe,
+  0x80, 0x02, 0xca, 0xfe, 0xcd, 0x61, 0x70, 0x4f, 0x4f, 0x4f, 0x61, 0x01,
+  0xfa, 0x01, 0x2b, 0xfe, 0xd5, 0x01, 0xeb, 0x02, 0xf7, 0x02, 0x4b, 0x5d,
+  0x4f, 0x7a, 0x7d, 0x49, 0x5f, 0xfd, 0x09, 0x93, 0x01, 0xd1, 0x87, 0x5f,
+  0xd2, 0xad, 0x87, 0x85, 0xfd, 0x22, 0x93, 0xfe, 0x2f, 0x93, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x89, 0x05, 0xd5, 0x00, 0x0a,
+  0x00, 0x1d, 0x00, 0x00, 0x01, 0x21, 0x11, 0x21, 0x22, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x01, 0x35, 0x21, 0x11, 0x21, 0x22, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x33, 0x21, 0x11, 0x21, 0x15, 0x21, 0x11, 0x01, 0xac,
+  0x01, 0x12, 0xfe, 0xf2, 0x4a, 0x2f, 0x27, 0x27, 0x37, 0xfe, 0x80, 0x02,
+  0xca, 0xfe, 0xcd, 0x61, 0x70, 0x4f, 0x4f, 0x4f, 0x61, 0x01, 0xfa, 0x01,
+  0x2b, 0xfe, 0xd5, 0x02, 0xf7, 0x02, 0x4b, 0x5d, 0x4f, 0x7a, 0x7d, 0x49,
+  0x5f, 0xfd, 0x09, 0x93, 0x01, 0xd1, 0x87, 0x5f, 0xd2, 0xad, 0x87, 0x85,
+  0xfd, 0x22, 0x93, 0xfd, 0x9c, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x36,
+  0x00, 0x00, 0x03, 0x7a, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x21, 0x11,
+  0x21, 0x35, 0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x01, 0x61, 0xfe, 0xd6,
+  0x02, 0xf9, 0xfe, 0xd6, 0x01, 0x73, 0x05, 0x42, 0x93, 0x93, 0xfb, 0x51,
+  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x7a,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x35,
+  0x21, 0x15, 0x21, 0x11, 0x21, 0x15, 0x12, 0x01, 0x73, 0xfe, 0xd6, 0x02,
+  0xf9, 0xfe, 0xd6, 0x01, 0x73, 0x93, 0x04, 0xaf, 0x93, 0x93, 0xfb, 0x51,
+  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x31,
+  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x11, 0x21,
+  0x35, 0x21, 0x15, 0x21, 0x02, 0x06, 0xfd, 0xe8, 0x01, 0x73, 0xfe, 0xd6,
+  0x02, 0xf9, 0xfe, 0xd6, 0x93, 0x04, 0xaf, 0x93, 0x93, 0x00, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x36, 0x00, 0x00, 0x04, 0x92, 0x05, 0xd5, 0x00, 0x02,
+  0x00, 0x08, 0x00, 0x00, 0x25, 0x09, 0x01, 0x07, 0x01, 0x33, 0x01, 0x33,
+  0x15, 0x03, 0x65, 0xfe, 0xdb, 0xfe, 0xdb, 0xe4, 0x01, 0xa1, 0xd0, 0x01,
+  0x6f, 0x7b, 0x93, 0x04, 0x82, 0xfb, 0x7e, 0x93, 0x05, 0xd5, 0xfa, 0xbe,
+  0x93, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x92,
+  0x05, 0xd5, 0x00, 0x02, 0x00, 0x0a, 0x00, 0x00, 0x25, 0x09, 0x01, 0x05,
+  0x35, 0x33, 0x01, 0x33, 0x01, 0x33, 0x15, 0x03, 0x65, 0xfe, 0xdb, 0xfe,
+  0xdb, 0xfe, 0xd3, 0x7b, 0x01, 0x6f, 0xd0, 0x01, 0x6f, 0x7b, 0x93, 0x04,
+  0x82, 0xfb, 0x7e, 0x93, 0x93, 0x05, 0x42, 0xfa, 0xbe, 0x93, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x4a, 0x05, 0xd5, 0x00, 0x02,
+  0x00, 0x08, 0x00, 0x00, 0x25, 0x09, 0x01, 0x05, 0x35, 0x33, 0x01, 0x33,
+  0x01, 0x03, 0x65, 0xfe, 0xdb, 0xfe, 0xdb, 0xfe, 0xd3, 0x7b, 0x01, 0x6f,
+  0xd0, 0x01, 0xa1, 0x93, 0x04, 0x82, 0xfb, 0x7e, 0x93, 0x93, 0x05, 0x42,
+  0xfa, 0x2b, 0x00, 0x00, 0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x04, 0x59,
+  0x05, 0xd5, 0x00, 0x1c, 0x00, 0x28, 0x00, 0x00, 0x21, 0x11, 0x26, 0x27,
+  0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x21, 0x35, 0x21,
+  0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x15, 0x21,
+  0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22,
+  0x06, 0x01, 0xd0, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49,
+  0xfe, 0xd6, 0x01, 0xd0, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b,
+  0x01, 0xe2, 0xfc, 0x9a, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6,
+  0x8c, 0x01, 0x86, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f,
+  0x0b, 0xf3, 0x93, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31,
+  0x20, 0x0b, 0xf2, 0x93, 0x03, 0x22, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70,
+  0x60, 0x38, 0x38, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
+  0x05, 0xd5, 0x00, 0x1e, 0x00, 0x2a, 0x00, 0x00, 0x23, 0x35, 0x21, 0x35,
+  0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x21,
+  0x35, 0x21, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07,
+  0x15, 0x21, 0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e,
+  0x01, 0x22, 0x06, 0x12, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e,
+  0x64, 0x43, 0x49, 0xfe, 0xd6, 0x01, 0xd0, 0x4f, 0x3e, 0x67, 0x77, 0x77,
+  0x67, 0x42, 0x4b, 0x01, 0xe2, 0xfc, 0x9a, 0x52, 0x8c, 0xa6, 0x8d, 0x51,
+  0x51, 0x8d, 0xa6, 0x8c, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53,
+  0x56, 0x2f, 0x1f, 0x0b, 0xf3, 0x93, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6,
+  0xc6, 0xa6, 0x31, 0x20, 0x0b, 0xf2, 0x93, 0x03, 0x22, 0x70, 0x5f, 0x38,
+  0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xe1, 0x05, 0xd5, 0x00, 0x1c, 0x00, 0x28, 0x00, 0x00,
+  0x23, 0x35, 0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37,
+  0x36, 0x37, 0x35, 0x21, 0x35, 0x21, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14,
+  0x06, 0x07, 0x06, 0x07, 0x11, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01,
+  0x34, 0x2e, 0x01, 0x22, 0x06, 0x12, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77,
+  0x3c, 0x3e, 0x64, 0x43, 0x49, 0xfe, 0xd6, 0x01, 0xd0, 0x4f, 0x3e, 0x67,
+  0x77, 0x77, 0x67, 0x42, 0x4b, 0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51,
+  0x51, 0x8d, 0xa6, 0x8c, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53,
+  0x56, 0x2f, 0x1f, 0x0b, 0xf3, 0x93, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6,
+  0xc6, 0xa6, 0x31, 0x20, 0x0b, 0xfe, 0x7b, 0x03, 0x22, 0x70, 0x5f, 0x38,
+  0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0x00, 0x00, 0x00, 0x01, 0x00, 0xad,
+  0x00, 0x00, 0x03, 0xe3, 0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x21, 0x11,
+  0x21, 0x11, 0x23, 0x11, 0x21, 0x11, 0x33, 0x15, 0x02, 0x7e, 0xfe, 0xd6,
+  0xa6, 0x02, 0x76, 0xbe, 0x05, 0x42, 0xfe, 0xc5, 0x01, 0xce, 0xfa, 0xbe,
+  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe3,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x21, 0x11, 0x33, 0x15, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6,
+  0x02, 0x76, 0xbe, 0x93, 0x04, 0xaf, 0xfe, 0xc5, 0x01, 0xce, 0xfa, 0xbe,
+  0x93, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x24,
+  0x05, 0xd5, 0x00, 0x09, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x21, 0x11, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6, 0x02, 0x76,
+  0x93, 0x04, 0xaf, 0xfe, 0xc5, 0x01, 0xce, 0xfa, 0x2b, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0x00, 0x00, 0x03, 0xe3, 0x04, 0xe6, 0x00, 0x0b,
+  0x00, 0x00, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11, 0x21, 0x11,
+  0x33, 0x15, 0x02, 0x7e, 0xfe, 0xd6, 0xa6, 0xa6, 0x01, 0xd0, 0xbe, 0x03,
+  0x4f, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0xfc, 0xb1, 0x93, 0x00, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe3, 0x04, 0xe6, 0x00, 0x0d,
+  0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11, 0x23, 0x11, 0x33, 0x11,
+  0x21, 0x11, 0x33, 0x15, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6, 0xa6, 0x01,
+  0xd0, 0xbe, 0x93, 0x02, 0xbc, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc, 0xfc,
+  0xb1, 0x93, 0x00, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x03, 0x24,
+  0x04, 0xe6, 0x00, 0x0b, 0x00, 0x00, 0x23, 0x35, 0x21, 0x11, 0x21, 0x11,
+  0x23, 0x11, 0x33, 0x11, 0x21, 0x11, 0x12, 0x02, 0x90, 0xfe, 0xd6, 0xa6,
+  0xa6, 0x01, 0xd0, 0x93, 0x02, 0xbc, 0xfe, 0xfc, 0x02, 0x9b, 0xfe, 0xfc,
+  0xfc, 0x1e, 0x00, 0x00, 0x00, 0x02, 0x00, 0xad, 0x00, 0x00, 0x03, 0xd5,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
+  0x01, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x15, 0x01, 0x54,
+  0x01, 0x1c, 0xfe, 0x3e, 0x01, 0xc2, 0xfe, 0x3e, 0x02, 0x67, 0xc0, 0x02,
+  0xde, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x03, 0x71, 0x01, 0xd1, 0x93,
+  0xfa, 0xbe, 0x93, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xd5,
+  0x05, 0xd5, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x11, 0x21, 0x11,
+  0x01, 0x35, 0x33, 0x11, 0x21, 0x11, 0x21, 0x35, 0x21, 0x11, 0x33, 0x15,
+  0x01, 0x54, 0x01, 0x1c, 0xfd, 0x7e, 0xc0, 0x01, 0xc2, 0xfe, 0x3e, 0x02,
+  0x67, 0xc0, 0x02, 0xde, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x93, 0x02,
+  0xde, 0x01, 0xd1, 0x93, 0xfa, 0xbe, 0x93, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0x16, 0x05, 0xd5, 0x00, 0x03, 0x00, 0x0d, 0x00, 0x00,
+  0x01, 0x11, 0x21, 0x11, 0x01, 0x35, 0x33, 0x11, 0x21, 0x11, 0x21, 0x35,
+  0x21, 0x11, 0x01, 0x54, 0x01, 0x1c, 0xfd, 0x7e, 0xc0, 0x01, 0xc2, 0xfe,
+  0x3e, 0x02, 0x67, 0x02, 0xde, 0xfd, 0xb5, 0x02, 0x4b, 0xfd, 0x22, 0x93,
+  0x02, 0xde, 0x01, 0xd1, 0x93, 0xfa, 0x2b, 0x00, 0x00, 0x02, 0x00, 0x65,
+  0x00, 0x00, 0x04, 0x59, 0x05, 0xd5, 0x00, 0x0b, 0x00, 0x26, 0x00, 0x00,
+  0x12, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06,
+  0x13, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x11, 0x33, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07,
+  0x15, 0x21, 0x15, 0xf2, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6,
+  0x8c, 0x8c, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xa6,
+  0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b, 0x01, 0xe2, 0x03, 0x22,
+  0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0xfc, 0x7e, 0x01,
+  0x86, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f, 0x0b, 0x01,
+  0x86, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31, 0x20, 0x0b,
+  0xf2, 0x93, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x28, 0x00, 0x00, 0x12, 0x14, 0x1e, 0x01,
+  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x01, 0x15, 0x21, 0x35,
+  0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x11, 0x33, 0x11, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07,
+  0x15, 0xf2, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x03,
+  0x14, 0xfb, 0x96, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64,
+  0x43, 0x49, 0xa6, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b, 0x03,
+  0x22, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70, 0x60, 0x38, 0x38, 0xfd, 0x11,
+  0x93, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f,
+  0x0b, 0x01, 0x86, 0xfe, 0x7b, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31,
+  0x20, 0x0b, 0xf2, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe1,
+  0x05, 0xd5, 0x00, 0x0b, 0x00, 0x26, 0x00, 0x00, 0x12, 0x14, 0x1e, 0x01,
+  0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x13, 0x35, 0x26, 0x27,
+  0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x11, 0x33, 0x11, 0x16,
+  0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x11, 0x21, 0x35, 0xf2,
+  0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x8c, 0x49, 0x43,
+  0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xa6, 0x4f, 0x3e, 0x67, 0x77,
+  0x77, 0x67, 0x42, 0x4b, 0xfd, 0x78, 0x03, 0x22, 0x70, 0x5f, 0x38, 0x38,
+  0x5f, 0x70, 0x60, 0x38, 0x38, 0xfd, 0x11, 0xf3, 0x0b, 0x1f, 0x31, 0xa6,
+  0xc6, 0x53, 0x56, 0x2f, 0x1f, 0x0b, 0x01, 0x86, 0xfe, 0x7b, 0x0d, 0x1e,
+  0x32, 0xa6, 0xc6, 0xa6, 0x31, 0x20, 0x0b, 0xfe, 0x7b, 0x93, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x65, 0x00, 0x00, 0x04, 0x59, 0x05, 0xd5, 0x00, 0x1e,
+  0x00, 0x2a, 0x00, 0x00, 0x21, 0x11, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x36, 0x37, 0x35, 0x21, 0x35, 0x21, 0x15, 0x21, 0x15, 0x16,
+  0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x15, 0x21, 0x15, 0x00,
+  0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x01,
+  0xd0, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xfe, 0xd6,
+  0x02, 0xfa, 0xfe, 0xd6, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b,
+  0x01, 0xe2, 0xfc, 0x9a, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6,
+  0x8c, 0x01, 0x86, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f,
+  0x0b, 0xf3, 0x93, 0x93, 0xf2, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31,
+  0x20, 0x0b, 0xf2, 0x93, 0x03, 0x22, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70,
+  0x60, 0x38, 0x38, 0x00, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x59,
+  0x05, 0xd5, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x00, 0x25, 0x15, 0x21, 0x35,
+  0x21, 0x35, 0x26, 0x27, 0x2e, 0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37,
+  0x35, 0x21, 0x35, 0x21, 0x15, 0x21, 0x15, 0x16, 0x17, 0x1e, 0x01, 0x14,
+  0x06, 0x07, 0x06, 0x07, 0x15, 0x00, 0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01,
+  0x34, 0x2e, 0x01, 0x22, 0x06, 0x04, 0x58, 0xfb, 0x96, 0x01, 0xe2, 0x49,
+  0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64, 0x43, 0x49, 0xfe, 0xd6, 0x02, 0xfa,
+  0xfe, 0xd6, 0x4f, 0x3e, 0x67, 0x77, 0x77, 0x67, 0x42, 0x4b, 0xfe, 0x7c,
+  0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51, 0x8d, 0xa6, 0x8c, 0x93, 0x93, 0x93,
+  0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56, 0x2f, 0x1f, 0x0b, 0xf3,
+  0x93, 0x93, 0xf2, 0x0d, 0x1e, 0x32, 0xa6, 0xc6, 0xa6, 0x31, 0x20, 0x0b,
+  0xf2, 0x02, 0x8f, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70, 0x60, 0x38, 0x38,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0xe1, 0x05, 0xd5, 0x00, 0x1e,
+  0x00, 0x2a, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x35, 0x26, 0x27, 0x2e,
+  0x01, 0x34, 0x37, 0x36, 0x37, 0x36, 0x37, 0x35, 0x21, 0x35, 0x21, 0x15,
+  0x21, 0x15, 0x16, 0x17, 0x1e, 0x01, 0x14, 0x06, 0x07, 0x06, 0x07, 0x00,
+  0x14, 0x1e, 0x01, 0x32, 0x3e, 0x01, 0x34, 0x2e, 0x01, 0x22, 0x06, 0x02,
+  0x76, 0xfd, 0x78, 0x01, 0xe2, 0x49, 0x43, 0x67, 0x77, 0x3c, 0x3e, 0x64,
+  0x43, 0x49, 0xfe, 0xd6, 0x02, 0xfa, 0xfe, 0xd6, 0x4f, 0x3e, 0x67, 0x77,
+  0x77, 0x67, 0x42, 0x4b, 0xfe, 0x7c, 0x52, 0x8c, 0xa6, 0x8d, 0x51, 0x51,
+  0x8d, 0xa6, 0x8c, 0x93, 0xf3, 0x0b, 0x1f, 0x31, 0xa6, 0xc6, 0x53, 0x56,
+  0x2f, 0x1f, 0x0b, 0xf3, 0x93, 0x93, 0xf2, 0x0d, 0x1e, 0x32, 0xa6, 0xc6,
+  0xa6, 0x31, 0x20, 0x0b, 0x01, 0x9d, 0x70, 0x5f, 0x38, 0x38, 0x5f, 0x70,
+  0x60, 0x38, 0x38, 0x00, 0xff, 0xff, 0xfd, 0x3a, 0x03, 0xfb, 0xff, 0x28,
+  0x06, 0x20, 0x10, 0x07, 0x02, 0x9c, 0xfc, 0x65, 0xff, 0x1a, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0xca, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdd, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x01,
+  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb3, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb3, 0x00, 0x00,
+  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb3, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0xff, 0xff, 0x00, 0x99, 0x02, 0x86, 0x05, 0xdc, 0x05, 0xd5, 0x12, 0x27,
+  0x0b, 0xb4, 0x00, 0x00, 0x02, 0x86, 0x10, 0x27, 0x0b, 0xb4, 0x00, 0x00,
+  0x03, 0xc9, 0x10, 0x07, 0x0b, 0xb4, 0x00, 0x00, 0x05, 0x0d, 0x00, 0x00,
+  0x00, 0x01, 0x01, 0x6e, 0x05, 0x18, 0x04, 0x99, 0x05, 0xe0, 0x00, 0x0b,
+  0x00, 0x00, 0x01, 0x07, 0x23, 0x27, 0x23, 0x07, 0x23, 0x27, 0x23, 0x07,
+  0x23, 0x27, 0x04, 0x98, 0x5a, 0x2d, 0x2d, 0x9d, 0x2d, 0x2d, 0x2d, 0x9e,
+  0x2d, 0x2d, 0x5a, 0x05, 0xe0, 0xc8, 0x64, 0x64, 0x64, 0x64, 0xc8, 0x00,
+  0x00, 0x01, 0x00, 0xb4, 0xfe, 0x56, 0x05, 0x63, 0x05, 0xd5, 0x00, 0x0e,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x01, 0x23, 0x11, 0x33, 0x11, 0x01, 0x33,
+  0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0xae, 0xb0, 0xfd, 0xac, 0xf5, 0xb0,
+  0x02, 0x54, 0xf5, 0xb5, 0xfe, 0xb6, 0x78, 0x04, 0xe1, 0xfb, 0x1f, 0x05,
+  0xd5, 0xfb, 0x1f, 0x04, 0xe1, 0xfa, 0xd5, 0xaa, 0xfe, 0x56, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0xad, 0xfe, 0x56, 0x04, 0xb3, 0x04, 0x60, 0x00, 0x0e,
+  0x00, 0x00, 0x21, 0x23, 0x11, 0x01, 0x23, 0x11, 0x33, 0x11, 0x01, 0x33,
+  0x11, 0x33, 0x15, 0x01, 0x23, 0x04, 0x0d, 0xa5, 0xfe, 0x1a, 0xd4, 0xa4,
+  0x01, 0xe6, 0xd5, 0xa5, 0xfe, 0xfb, 0x6e, 0x03, 0x83, 0xfc, 0x7d, 0x04,
+  0x60, 0xfc, 0x7f, 0x03, 0x81, 0xfc, 0x39, 0x99, 0xfe, 0x56, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x9c, 0xfe, 0x56, 0x03, 0xe9, 0x04, 0x7b, 0x00, 0x1f,
+  0x00, 0x20, 0x00, 0x00, 0x25, 0x35, 0x0e, 0x01, 0x23, 0x22, 0x26, 0x35,
+  0x11, 0x33, 0x11, 0x14, 0x16, 0x33, 0x32, 0x36, 0x35, 0x11, 0x33, 0x11,
+  0x10, 0x02, 0x23, 0x22, 0x26, 0x27, 0x35, 0x1e, 0x01, 0x33, 0x32, 0x36,
+  0x01, 0x03, 0x43, 0x3c, 0x9f, 0x6a, 0xad, 0xb4, 0xa5, 0x70, 0x6f, 0x87,
+  0x9b, 0xa6, 0xe5, 0xec, 0x57, 0x9b, 0x49, 0x49, 0x8e, 0x4a, 0xa3, 0xa2,
+  0xfe, 0xfa, 0x6a, 0x42, 0x66, 0x63, 0xf0, 0xe7, 0x02, 0xa6, 0xfd, 0x61,
+  0x9f, 0x9f, 0xbe, 0xa4, 0x02, 0x7b, 0xfc, 0x2b, 0xfe, 0xe2, 0xfe, 0xe9,
+  0x1d, 0x1e, 0xb3, 0x2c, 0x2a, 0xbd, 0x04, 0xd0, 0x00, 0x03, 0x00, 0x70,
+  0xfe, 0x90, 0x03, 0xda, 0x03, 0x52, 0x00, 0x20, 0x00, 0x2c, 0x00, 0x38,
+  0x00, 0x00, 0x01, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
+  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x35, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03,
+  0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01,
+  0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x01,
+  0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a, 0x28, 0x59, 0x44, 0x76,
+  0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d, 0x68, 0x4c, 0x1d, 0x1f,
+  0x9b, 0x1f, 0x07, 0x08, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32,
+  0x6e, 0x39, 0x39, 0xa6, 0x39, 0x39, 0x39, 0x39, 0xa6, 0x39, 0x02, 0x3f,
+  0x7a, 0x99, 0x4e, 0x89, 0x86, 0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80,
+  0x21, 0x07, 0x26, 0xb8, 0x2a, 0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0xfd,
+  0xab, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8,
+  0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x02, 0x00, 0x70,
+  0xfe, 0xa2, 0x03, 0xda, 0x03, 0x52, 0x00, 0x20, 0x00, 0x24, 0x00, 0x00,
+  0x01, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x33, 0x15,
+  0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a, 0x28, 0x59,
+  0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d, 0x68, 0x4c,
+  0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0xa3, 0x88, 0x88, 0x02, 0x3f, 0x7a, 0x99,
+  0x4e, 0x89, 0x86, 0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07,
+  0x26, 0xb8, 0x2a, 0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0xfd, 0x77, 0x96,
+  0x00, 0x04, 0x00, 0x70, 0xfe, 0xa2, 0x03, 0xda, 0x05, 0xf7, 0x00, 0x20,
+  0x00, 0x2b, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x00, 0x01, 0x26, 0x27, 0x33,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34,
+  0x27, 0x26, 0x07, 0x06, 0x17, 0x2b, 0x01, 0x35, 0x33, 0x11, 0x33, 0x11,
+  0x36, 0x37, 0x36, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x03, 0x33, 0x15,
+  0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a, 0x28, 0x59,
+  0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d, 0x68, 0x4c,
+  0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0xba, 0x32, 0x46, 0x14, 0x2f, 0x1b, 0x01,
+  0x40, 0x2e, 0x15, 0x9d, 0x65, 0x49, 0x5c, 0x20, 0x5e, 0x38, 0x3f, 0x3b,
+  0x3a, 0x30, 0x98, 0x88, 0x88, 0x02, 0x3f, 0x7a, 0x99, 0x4e, 0x89, 0x86,
+  0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07, 0x26, 0xb8, 0x2a,
+  0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0x02, 0xa7, 0x0d, 0x21, 0x15, 0x20,
+  0x10, 0x01, 0x1c, 0x15, 0xa8, 0x65, 0x01, 0x8f, 0xfe, 0xbf, 0x49, 0x28,
+  0x18, 0x1a, 0x19, 0x52, 0x5b, 0x32, 0x2a, 0xfb, 0x35, 0x96, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x70, 0xff, 0xda, 0x03, 0xda, 0x05, 0x78, 0x00, 0x20,
+  0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x00, 0x01, 0x26, 0x27, 0x33,
+  0x16, 0x17, 0x16, 0x15, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x37, 0x36, 0x35, 0x34, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15,
+  0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a,
+  0x49, 0x4a, 0x28, 0x59, 0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29,
+  0x5c, 0x5d, 0x68, 0x4c, 0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0xcf, 0x86, 0x86,
+  0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x02, 0x3f, 0x7a, 0x99, 0x4e, 0x89,
+  0x86, 0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07, 0x26, 0xb8,
+  0x2a, 0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0x02, 0xbd, 0x96, 0x01, 0x90,
+  0x96, 0x96, 0x96, 0x00, 0x00, 0x05, 0x00, 0x70, 0xff, 0xda, 0x03, 0xda,
+  0x05, 0xaa, 0x00, 0x20, 0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30,
+  0x00, 0x00, 0x01, 0x26, 0x27, 0x33, 0x16, 0x17, 0x16, 0x15, 0x14, 0x17,
+  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x35, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x03,
+  0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x07, 0x33, 0x15, 0x23, 0x11,
+  0x33, 0x15, 0x23, 0x01, 0xeb, 0x33, 0xa4, 0xcd, 0x57, 0x4a, 0x49, 0x4a,
+  0x28, 0x59, 0x44, 0x76, 0x84, 0x57, 0x54, 0xba, 0x29, 0x29, 0x5c, 0x5d,
+  0x68, 0x4c, 0x1d, 0x1f, 0x9b, 0x1f, 0x07, 0x5f, 0x87, 0x87, 0x87, 0x87,
+  0xe1, 0x87, 0x87, 0x87, 0x87, 0x02, 0x3f, 0x7a, 0x99, 0x4e, 0x89, 0x86,
+  0x75, 0x49, 0x53, 0x2c, 0xb8, 0x82, 0x80, 0x21, 0x07, 0x26, 0xb8, 0x2a,
+  0x09, 0x31, 0x70, 0x1b, 0x2a, 0x44, 0x02, 0xef, 0x96, 0x01, 0x90, 0x96,
+  0x64, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xb3,
+  0xfe, 0x0c, 0x04, 0x0b, 0x02, 0x26, 0x00, 0x18, 0x00, 0x24, 0x00, 0x30,
+  0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x13, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37,
+  0x36, 0x32, 0x17, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b,
+  0x43, 0x75, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11,
+  0xb7, 0xc4, 0x20, 0x08, 0xd0, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a,
+  0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0x02,
+  0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97,
+  0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0xfd, 0x4a, 0x28, 0x1c, 0x1d,
+  0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40,
+  0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x02, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x0b,
+  0x02, 0x26, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x00, 0x01, 0x33, 0x16, 0x17,
+  0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04,
+  0x21, 0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x13, 0x33, 0x15,
+  0x23, 0x02, 0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b, 0x43, 0x75,
+  0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4,
+  0x20, 0x08, 0x7a, 0x87, 0x87, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c,
+  0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48,
+  0x7e, 0xfd, 0x40, 0x96, 0x00, 0x03, 0xff, 0xb3, 0xfe, 0x0c, 0x04, 0x0b,
+  0x02, 0x26, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x20, 0x00, 0x00, 0x01, 0x33,
+  0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02,
+  0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x05,
+  0x33, 0x15, 0x23, 0x01, 0x33, 0x15, 0x23, 0x02, 0x39, 0xa5, 0x1b, 0x03,
+  0x09, 0x42, 0x26, 0x5b, 0x43, 0x75, 0x75, 0x2d, 0x3d, 0xe2, 0xff, 0x00,
+  0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4, 0x20, 0x08, 0xfe, 0x3a, 0x87, 0x87,
+  0x02, 0x40, 0x87, 0x87, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8,
+  0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e,
+  0xe0, 0x96, 0xfe, 0xb6, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xb3,
+  0xfe, 0x0c, 0x04, 0x0b, 0x03, 0xb6, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x20,
+  0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35, 0x20, 0x37, 0x36, 0x37,
+  0x36, 0x35, 0x34, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x02,
+  0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b, 0x43, 0x75, 0x75, 0x2d,
+  0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4, 0x20, 0x08,
+  0x3b, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x02, 0x26, 0x70, 0x1e, 0x67, 0x4d,
+  0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8, 0x80, 0x8a, 0xd0, 0x3a,
+  0x48, 0x7e, 0x02, 0x18, 0x96, 0x96, 0x96, 0x00, 0x00, 0x05, 0xff, 0xb3,
+  0xfe, 0x0c, 0x04, 0x0b, 0x04, 0xb0, 0x00, 0x18, 0x00, 0x1c, 0x00, 0x20,
+  0x00, 0x24, 0x00, 0x28, 0x00, 0x00, 0x01, 0x33, 0x16, 0x17, 0x16, 0x17,
+  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x02, 0x07, 0x04, 0x21, 0x35,
+  0x20, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x13, 0x33, 0x15, 0x23, 0x11,
+  0x33, 0x15, 0x23, 0x07, 0x33, 0x15, 0x23, 0x11, 0x33, 0x15, 0x23, 0x02,
+  0x39, 0xa5, 0x1b, 0x03, 0x09, 0x42, 0x26, 0x5b, 0x43, 0x75, 0x75, 0x2d,
+  0x3d, 0xe2, 0xff, 0x00, 0xfe, 0xdf, 0x01, 0x11, 0xb7, 0xc4, 0x20, 0x08,
+  0x3b, 0x87, 0x87, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x87, 0x87, 0x02, 0x26,
+  0x70, 0x1e, 0x67, 0x4d, 0x2c, 0xb8, 0x3e, 0xfe, 0xea, 0x85, 0x97, 0xb8,
+  0x80, 0x8a, 0xd0, 0x3a, 0x48, 0x7e, 0x02, 0x18, 0x96, 0x01, 0x90, 0x96,
+  0x64, 0x96, 0x01, 0x90, 0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x75,
+  0xfe, 0x0c, 0x09, 0x40, 0x03, 0xb6, 0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e,
+  0x00, 0x00, 0x25, 0x16, 0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x33,
+  0x32, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07,
+  0x06, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x26, 0x27,
+  0x26, 0x11, 0x34, 0x37, 0x33, 0x06, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x37, 0x36, 0x27, 0x26, 0x2f, 0x01, 0x33, 0x17, 0x16, 0x17,
+  0x16, 0x13, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x05, 0x26, 0x46,
+  0x2b, 0x21, 0xa6, 0x11, 0x3a, 0x63, 0x7f, 0xa6, 0x4b, 0x27, 0x59, 0x44,
+  0x75, 0x83, 0x6a, 0x3d, 0x62, 0x21, 0x1d, 0x42, 0x2b, 0x7c, 0x10, 0x2c,
+  0x55, 0x3a, 0x32, 0x7b, 0x24, 0x15, 0x4c, 0x77, 0xae, 0x48, 0x6c, 0x73,
+  0x63, 0xf7, 0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x59, 0x55,
+  0x6d, 0x55, 0x39, 0x01, 0x01, 0x0e, 0x3a, 0xa6, 0x20, 0x0f, 0x19, 0x34,
+  0x19, 0x86, 0x86, 0x86, 0x88, 0x88, 0xb5, 0x02, 0x7c, 0x5f, 0xca, 0xcd,
+  0x32, 0xa9, 0x01, 0x18, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8,
+  0x60, 0x5b, 0x19, 0x09, 0x19, 0x46, 0x7b, 0x9f, 0x1e, 0x14, 0x02, 0x02,
+  0x3c, 0xb3, 0x6b, 0xaa, 0x3e, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48, 0xf6,
+  0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x30, 0x9e, 0x6c, 0x8e, 0x7d,
+  0x3d, 0xea, 0x9c, 0x4a, 0x3c, 0x7e, 0x02, 0xfe, 0x96, 0xfc, 0x18, 0x96,
+  0x00, 0x03, 0xff, 0xee, 0xfe, 0xa2, 0x05, 0x70, 0x03, 0xe8, 0x00, 0x31,
+  0x00, 0x35, 0x00, 0x39, 0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x2b, 0x01,
+  0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19,
+  0x01, 0x33, 0x11, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x01, 0x33, 0x15, 0x23,
+  0x13, 0x33, 0x15, 0x23, 0x01, 0x5a, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44,
+  0x59, 0x27, 0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11,
+  0x3a, 0x63, 0x80, 0xa5, 0x52, 0x44, 0x5c, 0x21, 0x20, 0x38, 0x32, 0x7b,
+  0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x01, 0x3c, 0x86, 0x86,
+  0x86, 0x88, 0x88, 0x8a, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0,
+  0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02,
+  0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0xc7, 0x71, 0x5c, 0x18, 0x09, 0x19,
+  0x3d, 0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0x03, 0xa7, 0x96, 0xfb, 0xe6,
+  0x96, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xee, 0xfe, 0xa2, 0x06, 0x7f,
+  0x03, 0xe8, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x00, 0x05, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d,
+  0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x33,
+  0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01, 0x33, 0x15, 0x23, 0x13,
+  0x33, 0x15, 0x23, 0x04, 0x7d, 0x21, 0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b,
+  0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x24, 0x27, 0x33, 0x44, 0x59, 0x75,
+  0x44, 0x59, 0x27, 0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5,
+  0x11, 0x3a, 0x63, 0x80, 0xa5, 0x4b, 0x28, 0x59, 0x43, 0x75, 0x82, 0x6a,
+  0x3e, 0xfd, 0xdb, 0x86, 0x86, 0x86, 0x88, 0x88, 0x14, 0x09, 0x19, 0x3d,
+  0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0x49, 0x3b, 0x21, 0x2e, 0xb8, 0x2c,
+  0x50, 0x64, 0xc0, 0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32,
+  0xaa, 0x01, 0x02, 0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c,
+  0xb8, 0x60, 0x5a, 0x03, 0xe2, 0x96, 0xfb, 0xe6, 0x96, 0x00, 0x00, 0x00,
+  0x00, 0x04, 0x00, 0x75, 0xfe, 0x0c, 0x09, 0x40, 0x02, 0xee, 0x00, 0x46,
+  0x00, 0x4a, 0x00, 0x4e, 0x00, 0x52, 0x00, 0x00, 0x25, 0x16, 0x37, 0x36,
+  0x35, 0x33, 0x14, 0x17, 0x16, 0x33, 0x32, 0x19, 0x01, 0x33, 0x11, 0x14,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x27, 0x26, 0x27, 0x06, 0x07,
+  0x06, 0x07, 0x06, 0x23, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37, 0x33, 0x06,
+  0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x27, 0x26,
+  0x2f, 0x01, 0x33, 0x17, 0x16, 0x17, 0x16, 0x13, 0x33, 0x15, 0x23, 0x13,
+  0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0x26, 0x46, 0x2b, 0x21,
+  0xa6, 0x11, 0x3a, 0x63, 0x7f, 0xa6, 0x4b, 0x27, 0x59, 0x44, 0x75, 0x83,
+  0x6a, 0x3d, 0x62, 0x21, 0x1d, 0x42, 0x2b, 0x7c, 0x10, 0x2c, 0x55, 0x3a,
+  0x32, 0x7b, 0x24, 0x15, 0x4c, 0x77, 0xae, 0x48, 0x6c, 0x73, 0x63, 0xf7,
+  0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x59, 0x55, 0x6d, 0x55,
+  0x39, 0x01, 0x01, 0x0e, 0x3a, 0xa6, 0x20, 0x0f, 0x19, 0x34, 0x9f, 0x88,
+  0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb5, 0x02, 0x7c, 0x5f, 0xca,
+  0xcd, 0x32, 0xa9, 0x01, 0x18, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c,
+  0xb8, 0x60, 0x5b, 0x19, 0x09, 0x19, 0x46, 0x7b, 0x9f, 0x1e, 0x14, 0x02,
+  0x02, 0x3c, 0xb3, 0x6b, 0xaa, 0x3e, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48,
+  0xf6, 0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x30, 0x9e, 0x6c, 0x8e,
+  0x7d, 0x3d, 0xea, 0x9c, 0x4a, 0x3c, 0x7e, 0xfd, 0xea, 0x96, 0x01, 0x90,
+  0x96, 0x96, 0x96, 0x00, 0x00, 0x04, 0xff, 0xee, 0xfe, 0x0c, 0x05, 0x70,
+  0x02, 0xee, 0x00, 0x31, 0x00, 0x35, 0x00, 0x39, 0x00, 0x3d, 0x00, 0x00,
+  0x25, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d,
+  0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x33,
+  0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14, 0x07, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x01, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x01, 0x5a, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44, 0x59, 0x27,
+  0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11, 0x3a, 0x63,
+  0x80, 0xa5, 0x52, 0x44, 0x5c, 0x21, 0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b,
+  0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x01, 0xc2, 0x88, 0x88, 0x71, 0x87,
+  0x87, 0xe1, 0x87, 0x87, 0x8a, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64,
+  0xc0, 0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01,
+  0x02, 0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0xc7, 0x71, 0x5c, 0x18, 0x09,
+  0x19, 0x3d, 0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0xfe, 0x61, 0x96, 0x01,
+  0x90, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee, 0xfe, 0x0c, 0x06, 0x7f,
+  0x02, 0xee, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x44, 0x00, 0x00,
+  0x05, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x23, 0x22,
+  0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
+  0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01, 0x33, 0x15,
+  0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x04, 0x7d, 0x21,
+  0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36,
+  0x24, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44, 0x59, 0x27, 0x48, 0xa6, 0x27,
+  0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11, 0x3a, 0x63, 0x80, 0xa5, 0x4b,
+  0x28, 0x59, 0x43, 0x75, 0x82, 0x6a, 0x3e, 0xfe, 0x61, 0x88, 0x88, 0x71,
+  0x87, 0x87, 0xe1, 0x87, 0x87, 0x14, 0x09, 0x19, 0x3d, 0x84, 0x9c, 0x21,
+  0x18, 0x31, 0x28, 0x49, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0,
+  0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02,
+  0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8, 0x60, 0x5a,
+  0xfe, 0x9c, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x07, 0x00, 0x75,
+  0xfe, 0x0c, 0x09, 0x40, 0x04, 0xb0, 0x00, 0x46, 0x00, 0x4a, 0x00, 0x4e,
+  0x00, 0x52, 0x00, 0x56, 0x00, 0x5a, 0x00, 0x5e, 0x00, 0x00, 0x25, 0x16,
+  0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x33, 0x32, 0x19, 0x01, 0x33,
+  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07,
+  0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x27, 0x26, 0x27,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37,
+  0x33, 0x06, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
+  0x27, 0x26, 0x2f, 0x01, 0x33, 0x17, 0x16, 0x17, 0x16, 0x13, 0x33, 0x15,
+  0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15,
+  0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0x26, 0x46,
+  0x2b, 0x21, 0xa6, 0x11, 0x3a, 0x63, 0x7f, 0xa6, 0x4b, 0x27, 0x59, 0x44,
+  0x75, 0x83, 0x6a, 0x3d, 0x62, 0x21, 0x1d, 0x42, 0x2b, 0x7c, 0x10, 0x2c,
+  0x55, 0x3a, 0x32, 0x7b, 0x24, 0x15, 0x4c, 0x77, 0xae, 0x48, 0x6c, 0x73,
+  0x63, 0xf7, 0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x59, 0x55,
+  0x6d, 0x55, 0x39, 0x01, 0x01, 0x0e, 0x3a, 0xa6, 0x20, 0x0f, 0x19, 0x34,
+  0x19, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xf7, 0x88, 0x88,
+  0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb5, 0x02, 0x7c, 0x5f, 0xca, 0xcd,
+  0x32, 0xa9, 0x01, 0x18, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8,
+  0x60, 0x5b, 0x19, 0x09, 0x19, 0x46, 0x7b, 0x9f, 0x1e, 0x14, 0x02, 0x02,
+  0x3c, 0xb3, 0x6b, 0xaa, 0x3e, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48, 0xf6,
+  0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x30, 0x9e, 0x6c, 0x8e, 0x7d,
+  0x3d, 0xea, 0x9c, 0x4a, 0x3c, 0x7e, 0x03, 0xf8, 0x96, 0x64, 0x96, 0x96,
+  0x96, 0xfb, 0x82, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00,
+  0x00, 0x07, 0xff, 0xee, 0xfe, 0x0c, 0x05, 0x70, 0x04, 0xb0, 0x00, 0x31,
+  0x00, 0x35, 0x00, 0x39, 0x00, 0x3d, 0x00, 0x41, 0x00, 0x45, 0x00, 0x49,
+  0x00, 0x00, 0x25, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
+  0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36,
+  0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33, 0x11, 0x14,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23,
+  0x27, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23,
+  0x27, 0x33, 0x15, 0x23, 0x01, 0x5a, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44,
+  0x59, 0x27, 0x48, 0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11,
+  0x3a, 0x63, 0x80, 0xa5, 0x52, 0x44, 0x5c, 0x21, 0x20, 0x38, 0x32, 0x7b,
+  0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59, 0x41, 0x36, 0x01, 0x3c, 0x86, 0x86,
+  0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xf7, 0x88, 0x88, 0x71, 0x87, 0x87,
+  0xe1, 0x87, 0x87, 0x8a, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0,
+  0x9c, 0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02,
+  0x01, 0x16, 0x01, 0x26, 0xfe, 0xaa, 0xc7, 0x71, 0x5c, 0x18, 0x09, 0x19,
+  0x3d, 0x84, 0x9c, 0x21, 0x18, 0x31, 0x28, 0x04, 0x6f, 0x96, 0x64, 0x96,
+  0x96, 0x96, 0xfb, 0x82, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00,
+  0x00, 0x07, 0xff, 0xee, 0xfe, 0x0c, 0x06, 0x7f, 0x04, 0xb0, 0x00, 0x38,
+  0x00, 0x3c, 0x00, 0x40, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c, 0x00, 0x50,
+  0x00, 0x00, 0x05, 0x06, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x33, 0x14, 0x17, 0x16, 0x37, 0x36, 0x19, 0x01, 0x33,
+  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01,
+  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x13,
+  0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x04,
+  0x7d, 0x21, 0x20, 0x38, 0x32, 0x7b, 0x10, 0x2b, 0x57, 0x3d, 0x3a, 0x59,
+  0x41, 0x36, 0x24, 0x27, 0x33, 0x44, 0x59, 0x75, 0x44, 0x59, 0x27, 0x48,
+  0xa6, 0x27, 0x27, 0x5e, 0x62, 0x27, 0x22, 0xa5, 0x11, 0x3a, 0x63, 0x80,
+  0xa5, 0x4b, 0x28, 0x59, 0x43, 0x75, 0x82, 0x6a, 0x3e, 0xfd, 0xdb, 0x86,
+  0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xf7, 0x88, 0x88, 0x71, 0x87,
+  0x87, 0xe1, 0x87, 0x87, 0x14, 0x09, 0x19, 0x3d, 0x84, 0x9c, 0x21, 0x18,
+  0x31, 0x28, 0x49, 0x3b, 0x21, 0x2e, 0xb8, 0x2c, 0x50, 0x64, 0xc0, 0x9c,
+  0x40, 0x64, 0x63, 0x7a, 0x67, 0xc2, 0xcd, 0x32, 0xaa, 0x01, 0x02, 0x01,
+  0x16, 0x01, 0x26, 0xfe, 0xaa, 0x61, 0x53, 0x2c, 0xb8, 0x60, 0x5a, 0x04,
+  0xaa, 0x96, 0x64, 0x96, 0x96, 0x96, 0xfb, 0x82, 0x96, 0x01, 0x90, 0x96,
+  0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0x00, 0x75, 0xfe, 0x0c, 0x08, 0xe5,
+  0x02, 0xe5, 0x00, 0x3c, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x51, 0x00, 0x00,
+  0x21, 0x23, 0x22, 0x27, 0x26, 0x35, 0x14, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x26, 0x27, 0x26, 0x11, 0x34, 0x37, 0x33, 0x06, 0x17, 0x16, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x33, 0x06, 0x17,
+  0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x17, 0x16, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01,
+  0x06, 0x03, 0x22, 0x07, 0x06, 0x07, 0x33, 0x32, 0x37, 0x36, 0x27, 0x26,
+  0x27, 0x26, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0xd0,
+  0xf9, 0x22, 0x2f, 0x28, 0x43, 0x4f, 0xd6, 0x48, 0x6c, 0x73, 0x63, 0xf7,
+  0x5f, 0xa5, 0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x5c, 0x52, 0x92, 0x27,
+  0x1d, 0x23, 0x9a, 0x01, 0x0d, 0x09, 0x24, 0x67, 0x6f, 0x61, 0x85, 0x40,
+  0x50, 0x70, 0x57, 0xa8, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x43, 0x75, 0x76,
+  0x5d, 0x19, 0xb7, 0x10, 0x45, 0x71, 0x98, 0x82, 0xa8, 0xd6, 0x74, 0xa8,
+  0x01, 0x02, 0x7b, 0x21, 0xfe, 0xe6, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x1e,
+  0x1a, 0x10, 0xba, 0x80, 0x9b, 0x4d, 0x1a, 0x01, 0x1c, 0x47, 0x01, 0x48,
+  0xf6, 0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x44, 0x8a, 0x6c, 0x7f,
+  0x93, 0x8a, 0x0f, 0x37, 0x28, 0x32, 0x92, 0x6c, 0x5e, 0x46, 0x22, 0x01,
+  0x02, 0x25, 0x47, 0xe9, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c, 0x1a,
+  0x76, 0x02, 0x37, 0x51, 0x6c, 0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13, 0x05,
+  0xfd, 0x01, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
+  0xfe, 0xa2, 0x05, 0x94, 0x02, 0xe5, 0x00, 0x0c, 0x00, 0x2e, 0x00, 0x32,
+  0x00, 0x36, 0x00, 0x00, 0x01, 0x06, 0x07, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14,
+  0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x05, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
+  0x6e, 0x97, 0x82, 0xa8, 0xd6, 0x73, 0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xa8,
+  0xf8, 0x43, 0x46, 0x3a, 0x23, 0x5c, 0x9b, 0x75, 0x44, 0x59, 0x27, 0x48,
+  0xa6, 0x10, 0x28, 0x5b, 0x56, 0x89, 0x82, 0x44, 0x4c, 0x68, 0x60, 0xa7,
+  0xa5, 0xb6, 0xfe, 0xc5, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01, 0xe6, 0x6c,
+  0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13, 0x05, 0xfd, 0xc9, 0x2a, 0x23, 0x3d,
+  0x8a, 0xb8, 0x2c, 0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32, 0x86, 0x54,
+  0x89, 0x3f, 0x21, 0x27, 0x44, 0xec, 0xa9, 0x6d, 0x78, 0xc8, 0x96, 0x96,
+  0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee, 0xfe, 0xa2, 0x06, 0x51,
+  0x02, 0xe5, 0x00, 0x2b, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x00,
+  0x21, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32,
+  0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x16, 0x17, 0x36, 0x37, 0x36,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x17, 0x16,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x03, 0x06, 0x07, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x33, 0x15,
+  0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x3c, 0xfc, 0x43, 0x46, 0x3a, 0x23,
+  0x5c, 0x9b, 0x75, 0x44, 0x59, 0x27, 0x48, 0xa6, 0x10, 0x28, 0x5b, 0x56,
+  0x89, 0x82, 0x44, 0x4c, 0x66, 0x62, 0xab, 0x26, 0x0d, 0x0e, 0x37, 0x4a,
+  0x43, 0x75, 0x75, 0x5d, 0x19, 0xb8, 0xca, 0x97, 0x82, 0xa8, 0xd6, 0x73,
+  0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xe3, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x2a,
+  0x23, 0x3d, 0x8a, 0xb8, 0x2c, 0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32,
+  0x86, 0x54, 0x89, 0x3f, 0x21, 0x27, 0x44, 0xec, 0x4b, 0x48, 0x0c, 0x0b,
+  0x2c, 0xb8, 0x5c, 0x1a, 0x76, 0x01, 0xe6, 0x6c, 0xc2, 0x3f, 0x5b, 0x46,
+  0x87, 0x13, 0x05, 0xfd, 0x01, 0x96, 0x96, 0x96, 0x00, 0x05, 0x00, 0x75,
+  0xfe, 0x0c, 0x08, 0xe5, 0x04, 0xb0, 0x00, 0x3c, 0x00, 0x49, 0x00, 0x4d,
+  0x00, 0x51, 0x00, 0x55, 0x00, 0x00, 0x21, 0x23, 0x22, 0x27, 0x26, 0x35,
+  0x14, 0x07, 0x06, 0x07, 0x06, 0x23, 0x26, 0x27, 0x26, 0x11, 0x34, 0x37,
+  0x33, 0x06, 0x17, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x33, 0x06, 0x17, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37,
+  0x36, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16, 0x17, 0x16, 0x3b,
+  0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x03, 0x22, 0x07, 0x06, 0x07,
+  0x33, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26, 0x01, 0x33, 0x15, 0x23,
+  0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x05, 0xd0, 0xf9, 0x22,
+  0x2f, 0x28, 0x43, 0x4f, 0xd6, 0x48, 0x6c, 0x73, 0x63, 0xf7, 0x5f, 0xa5,
+  0x61, 0x01, 0x01, 0x84, 0x56, 0x48, 0x5c, 0x52, 0x92, 0x27, 0x1d, 0x23,
+  0x9a, 0x01, 0x0d, 0x09, 0x24, 0x67, 0x6f, 0x61, 0x85, 0x40, 0x50, 0x70,
+  0x57, 0xa8, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x43, 0x75, 0x76, 0x5d, 0x19,
+  0xb7, 0x10, 0x45, 0x71, 0x98, 0x82, 0xa8, 0xd6, 0x74, 0xa8, 0x01, 0x02,
+  0x7b, 0x21, 0xfd, 0x95, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87,
+  0x1e, 0x1a, 0x10, 0xba, 0x80, 0x9b, 0x4d, 0x1a, 0x01, 0x1c, 0x47, 0x01,
+  0x48, 0xf6, 0xb4, 0xce, 0xdc, 0xb3, 0x26, 0x18, 0x25, 0x44, 0x8a, 0x6c,
+  0x7f, 0x93, 0x8a, 0x0f, 0x37, 0x28, 0x32, 0x92, 0x6c, 0x5e, 0x46, 0x22,
+  0x01, 0x02, 0x25, 0x47, 0xe9, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c,
+  0x1a, 0x76, 0x02, 0x37, 0x51, 0x6c, 0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13,
+  0x05, 0x02, 0x79, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x05, 0xff, 0xee,
+  0x00, 0x00, 0x05, 0x94, 0x04, 0xb0, 0x00, 0x0c, 0x00, 0x2e, 0x00, 0x32,
+  0x00, 0x36, 0x00, 0x3a, 0x00, 0x00, 0x01, 0x06, 0x07, 0x33, 0x32, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x03, 0x23, 0x22, 0x27, 0x26,
+  0x27, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33,
+  0x15, 0x14, 0x16, 0x17, 0x36, 0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15,
+  0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x6e, 0x97, 0x82, 0xa8, 0xd6, 0x73,
+  0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xa8, 0xf8, 0x43, 0x46, 0x3a, 0x23, 0x5c,
+  0x9b, 0x75, 0x44, 0x59, 0x27, 0x48, 0xa6, 0x10, 0x28, 0x5b, 0x56, 0x89,
+  0x82, 0x44, 0x4c, 0x68, 0x60, 0xa7, 0xa5, 0xb6, 0xfd, 0xa0, 0x88, 0x88,
+  0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01, 0xe6, 0x6c, 0xc2, 0x3f, 0x5b,
+  0x46, 0x87, 0x13, 0x05, 0xfd, 0xc9, 0x2a, 0x23, 0x3d, 0x8a, 0xb8, 0x2c,
+  0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32, 0x86, 0x54, 0x89, 0x3f, 0x21,
+  0x27, 0x44, 0xec, 0xa9, 0x6d, 0x78, 0x04, 0xb0, 0x96, 0x64, 0x96, 0x96,
+  0x96, 0x00, 0x00, 0x00, 0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x06, 0x51,
+  0x04, 0xb0, 0x00, 0x2b, 0x00, 0x38, 0x00, 0x3c, 0x00, 0x40, 0x00, 0x44,
+  0x00, 0x00, 0x21, 0x23, 0x22, 0x27, 0x26, 0x27, 0x06, 0x2b, 0x01, 0x35,
+  0x33, 0x32, 0x37, 0x36, 0x3d, 0x01, 0x33, 0x15, 0x14, 0x16, 0x17, 0x36,
+  0x37, 0x36, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x03, 0x06,
+  0x07, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x23, 0x22, 0x01,
+  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
+  0x3c, 0xfc, 0x43, 0x46, 0x3a, 0x23, 0x5c, 0x9b, 0x75, 0x44, 0x59, 0x27,
+  0x48, 0xa6, 0x10, 0x28, 0x5b, 0x56, 0x89, 0x82, 0x44, 0x4c, 0x66, 0x62,
+  0xab, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x43, 0x75, 0x75, 0x5d, 0x19, 0xb8,
+  0xca, 0x97, 0x82, 0xa8, 0xd6, 0x73, 0xa8, 0x7d, 0x21, 0x2c, 0x44, 0xfd,
+  0xf8, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x2a, 0x23, 0x3d,
+  0x8a, 0xb8, 0x2c, 0x50, 0x64, 0x72, 0x4e, 0x18, 0x50, 0x32, 0x86, 0x54,
+  0x89, 0x3f, 0x21, 0x27, 0x44, 0xec, 0x4b, 0x48, 0x0c, 0x0b, 0x2c, 0xb8,
+  0x5c, 0x1a, 0x76, 0x01, 0xe6, 0x6c, 0xc2, 0x3f, 0x5b, 0x46, 0x87, 0x13,
+  0x05, 0x02, 0x79, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x05, 0x00, 0x81,
+  0x00, 0x00, 0x06, 0xe8, 0x06, 0x14, 0x00, 0x1c, 0x00, 0x29, 0x00, 0x2d,
+  0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x29, 0x02, 0x35, 0x21, 0x11, 0x33,
+  0x11, 0x12, 0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x16,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x2f, 0x01, 0x06, 0x25, 0x33,
+  0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26, 0x23, 0x22, 0x07, 0x06, 0x13,
+  0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
+  0xd3, 0xfd, 0xf9, 0xfe, 0xb6, 0x01, 0x4a, 0xa6, 0xc3, 0xf8, 0x53, 0x3d,
+  0x69, 0x5f, 0xa9, 0x26, 0x0d, 0x0e, 0x37, 0x4a, 0x44, 0x75, 0x76, 0x5d,
+  0x19, 0xb8, 0xfe, 0x1f, 0xa8, 0xd5, 0x74, 0xa9, 0x01, 0x02, 0x7b, 0x22,
+  0x2b, 0x48, 0x6e, 0x9f, 0x32, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87,
+  0x87, 0xb8, 0x05, 0x5c, 0xfb, 0x0e, 0x01, 0x3f, 0x63, 0x21, 0x27, 0x45,
+  0xeb, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c, 0x1a, 0x76, 0xb8, 0x3f,
+  0x5d, 0x44, 0x87, 0x13, 0x05, 0x51, 0x78, 0x03, 0x74, 0x96, 0x64, 0x96,
+  0x96, 0x96, 0x00, 0x00, 0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x05, 0x3f,
+  0x06, 0x14, 0x00, 0x0c, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b,
+  0x00, 0x00, 0x25, 0x33, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26, 0x23,
+  0x22, 0x07, 0x06, 0x13, 0x21, 0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x12,
+  0x37, 0x36, 0x33, 0x32, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x01, 0x33,
+  0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x02, 0x00,
+  0xa8, 0xd6, 0x74, 0xa8, 0x01, 0x02, 0x7b, 0x21, 0x2b, 0x48, 0x6e, 0xa0,
+  0x6a, 0xfd, 0xfa, 0xf0, 0xf0, 0xa6, 0xc3, 0xf9, 0x52, 0x3e, 0x69, 0x5e,
+  0xa8, 0xa6, 0xb6, 0xfe, 0xca, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1, 0x87,
+  0x87, 0xb8, 0x3f, 0x5d, 0x44, 0x87, 0x13, 0x05, 0x51, 0x78, 0xfe, 0x92,
+  0xb8, 0x05, 0x5c, 0xfb, 0x0e, 0x01, 0x3f, 0x63, 0x21, 0x27, 0x45, 0xeb,
+  0xa9, 0x6d, 0x78, 0x04, 0xe2, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00,
+  0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x05, 0xfa, 0x06, 0x14, 0x00, 0x1c,
+  0x00, 0x29, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x29, 0x01,
+  0x23, 0x35, 0x33, 0x11, 0x33, 0x11, 0x12, 0x37, 0x36, 0x33, 0x32, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22,
+  0x2f, 0x01, 0x06, 0x25, 0x33, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x26,
+  0x23, 0x22, 0x07, 0x06, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23,
+  0x27, 0x33, 0x15, 0x23, 0x02, 0xe6, 0xfd, 0xf8, 0xf0, 0xf0, 0xa6, 0xc3,
+  0xf9, 0x52, 0x3e, 0x69, 0x5e, 0xaa, 0x26, 0x0c, 0x0f, 0x37, 0x49, 0x44,
+  0x75, 0x76, 0x5d, 0x19, 0xb7, 0xfe, 0x1e, 0xa8, 0xd6, 0x74, 0xa8, 0x01,
+  0x02, 0x7b, 0x21, 0x2b, 0x48, 0x6e, 0xa0, 0x33, 0x87, 0x87, 0x70, 0x87,
+  0x87, 0xe1, 0x87, 0x87, 0xb8, 0x05, 0x5c, 0xfb, 0x0e, 0x01, 0x3f, 0x63,
+  0x21, 0x27, 0x45, 0xeb, 0x4d, 0x46, 0x0c, 0x0b, 0x2c, 0xb8, 0x5c, 0x1a,
+  0x76, 0xb8, 0x3f, 0x5d, 0x44, 0x87, 0x13, 0x05, 0x51, 0x78, 0x03, 0x74,
+  0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x69,
+  0xfe, 0x0c, 0x04, 0x3a, 0x05, 0x46, 0x00, 0x25, 0x00, 0x2b, 0x00, 0x2f,
+  0x00, 0x33, 0x00, 0x37, 0x00, 0x00, 0x01, 0x06, 0x23, 0x20, 0x27, 0x26,
+  0x10, 0x37, 0x2e, 0x01, 0x35, 0x34, 0x37, 0x36, 0x32, 0x17, 0x16, 0x15,
+  0x14, 0x07, 0x06, 0x07, 0x1e, 0x01, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x21, 0x32, 0x37, 0x01, 0x36, 0x34, 0x22,
+  0x15, 0x14, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x04, 0x3a, 0x89, 0xe7, 0xfe, 0x85, 0x8d, 0x59, 0xa9, 0x37,
+  0x3d, 0x70, 0x57, 0xd7, 0x55, 0x72, 0x52, 0x33, 0x54, 0x3d, 0xa3, 0x4d,
+  0x90, 0x82, 0xef, 0xdf, 0x8b, 0x25, 0x60, 0x01, 0x3c, 0xae, 0xbf, 0xfd,
+  0x79, 0x7a, 0xb9, 0x0a, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87,
+  0xfe, 0x6f, 0x63, 0xbc, 0x7a, 0x01, 0x92, 0x8c, 0x32, 0x74, 0x2a, 0x6e,
+  0x40, 0x30, 0x30, 0x40, 0x70, 0x5b, 0x43, 0x2b, 0x20, 0x40, 0x4d, 0xb8,
+  0xe4, 0x81, 0x6b, 0x6c, 0x3d, 0x9e, 0x76, 0x02, 0x96, 0x38, 0x60, 0x33,
+  0x24, 0x03, 0x48, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0x93, 0x06, 0x40, 0x00, 0x1a, 0x00, 0x1e, 0x00, 0x22,
+  0x00, 0x26, 0x00, 0x00, 0x37, 0x32, 0x37, 0x26, 0x27, 0x26, 0x35, 0x10,
+  0x37, 0x36, 0x33, 0x15, 0x22, 0x06, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x25, 0x15, 0x05, 0x04, 0x2b, 0x01, 0x35, 0x01, 0x33, 0x15, 0x23, 0x17,
+  0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x36, 0x91, 0xb6, 0x44, 0x2f,
+  0x4f, 0xb8, 0x70, 0xe2, 0xc4, 0xa7, 0x37, 0x4b, 0x3f, 0x32, 0x42, 0x01,
+  0x03, 0xfe, 0x86, 0xfe, 0xc5, 0xa0, 0x4f, 0x01, 0x90, 0x88, 0x88, 0x71,
+  0x87, 0x87, 0xe1, 0x87, 0x87, 0xb8, 0x5d, 0x18, 0x3b, 0x64, 0x8c, 0x01,
+  0x08, 0x7d, 0x4d, 0xa9, 0x89, 0xff, 0x34, 0x46, 0x21, 0x81, 0xb8, 0xc5,
+  0xa4, 0xb8, 0x05, 0x88, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00,
+  0x00, 0x05, 0xff, 0xee, 0x00, 0x00, 0x03, 0x8c, 0x05, 0x46, 0x00, 0x24,
+  0x00, 0x2f, 0x00, 0x33, 0x00, 0x37, 0x00, 0x3b, 0x00, 0x00, 0x25, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x37, 0x26, 0x27, 0x26, 0x35,
+  0x34, 0x37, 0x36, 0x37, 0x36, 0x32, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14,
+  0x07, 0x06, 0x07, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x02,
+  0x22, 0x07, 0x06, 0x15, 0x14, 0x17, 0x36, 0x35, 0x34, 0x27, 0x03, 0x33,
+  0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0xbd,
+  0xaf, 0xb6, 0x6a, 0x56, 0x61, 0x3b, 0x35, 0x24, 0x57, 0x3d, 0x1b, 0x0b,
+  0x0f, 0x5d, 0x51, 0xd6, 0x50, 0x5d, 0x0f, 0x0c, 0x1c, 0x45, 0x4f, 0x1c,
+  0x3d, 0x37, 0x65, 0x56, 0x6a, 0xb6, 0x97, 0x2f, 0x1b, 0x2a, 0x5d, 0x5c,
+  0x2a, 0x71, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb9, 0xb9,
+  0xb8, 0x28, 0x24, 0x27, 0x55, 0x5a, 0x27, 0x2d, 0x1f, 0x29, 0x37, 0x34,
+  0x2d, 0x2d, 0x34, 0x37, 0x29, 0x1f, 0x2d, 0x27, 0x62, 0x4d, 0x1f, 0x2c,
+  0x28, 0xb8, 0x02, 0x55, 0x07, 0x0c, 0x20, 0x1d, 0x5f, 0x5f, 0x1d, 0x20,
+  0x0c, 0x02, 0xf8, 0x96, 0x64, 0x96, 0x96, 0x96, 0xff, 0xff, 0x00, 0x75,
+  0xfe, 0xa2, 0x07, 0x86, 0x03, 0x11, 0x10, 0x26, 0x10, 0xff, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x03, 0x14, 0xfe, 0xa2, 0xff, 0xff, 0xff, 0xee,
+  0xfe, 0xd4, 0x02, 0xec, 0x03, 0xd9, 0x10, 0x26, 0x11, 0x00, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4, 0xff, 0xff, 0xff, 0xee,
+  0xfe, 0xd4, 0x03, 0xb7, 0x03, 0x08, 0x10, 0x26, 0x11, 0x01, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4, 0xff, 0xff, 0x00, 0x75,
+  0xfe, 0xa2, 0x07, 0x86, 0x04, 0x4c, 0x10, 0x26, 0x10, 0xff, 0x00, 0x00,
+  0x10, 0x27, 0x10, 0xf6, 0x05, 0x5c, 0x03, 0xb6, 0x10, 0x07, 0x10, 0xf6,
+  0x03, 0x14, 0xfe, 0xa2, 0xff, 0xff, 0xff, 0xee, 0xfe, 0xd4, 0x02, 0xec,
+  0x05, 0x14, 0x10, 0x26, 0x11, 0x00, 0x00, 0x00, 0x10, 0x27, 0x10, 0xf6,
+  0x01, 0x7e, 0x04, 0x7e, 0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4,
+  0xff, 0xff, 0xff, 0xee, 0xfe, 0xd4, 0x03, 0xb7, 0x04, 0x7e, 0x10, 0x26,
+  0x11, 0x01, 0x00, 0x00, 0x10, 0x27, 0x10, 0xf6, 0x01, 0x8f, 0x03, 0xe8,
+  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0xfe, 0xd4, 0xff, 0xff, 0x00, 0x75,
+  0xfd, 0xa8, 0x07, 0x86, 0x03, 0x11, 0x10, 0x26, 0x10, 0xff, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf9, 0x02, 0xa3, 0xfe, 0xa2, 0xff, 0xff, 0xff, 0xee,
+  0xfd, 0xda, 0x02, 0xec, 0x03, 0xd9, 0x10, 0x26, 0x11, 0x00, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf9, 0x01, 0x0e, 0xfe, 0xd4, 0xff, 0xff, 0xff, 0xee,
+  0xfd, 0xda, 0x03, 0xb7, 0x03, 0x08, 0x10, 0x26, 0x11, 0x01, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf9, 0x01, 0x0e, 0xfe, 0xd4, 0xff, 0xff, 0x00, 0x60,
+  0xfe, 0x0c, 0x06, 0x14, 0x04, 0x01, 0x10, 0x26, 0x11, 0x02, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x03, 0x9a, 0x03, 0x6b, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0xec, 0x05, 0x14, 0x10, 0x26, 0x11, 0x03, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x01, 0x7e, 0x04, 0x7e, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xb7, 0x04, 0x7e, 0x10, 0x26, 0x11, 0x04, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x01, 0x8f, 0x03, 0xe8, 0xff, 0xff, 0x00, 0x60,
+  0xfe, 0x0c, 0x06, 0x14, 0x04, 0xfb, 0x10, 0x26, 0x11, 0x02, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf8, 0x03, 0x2a, 0x03, 0x6b, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0xec, 0x06, 0x0e, 0x10, 0x26, 0x11, 0x03, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf8, 0x01, 0x0e, 0x04, 0x7e, 0xff, 0xff, 0xff, 0xee,
+  0x00, 0x00, 0x03, 0xb7, 0x05, 0x78, 0x10, 0x26, 0x11, 0x04, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf8, 0x01, 0x1e, 0x03, 0xe8, 0x00, 0x01, 0x00, 0x75,
+  0xff, 0xa7, 0x07, 0xa9, 0x06, 0x14, 0x00, 0x37, 0x00, 0x00, 0x25, 0x32,
+  0x24, 0x36, 0x3d, 0x01, 0x34, 0x27, 0x25, 0x24, 0x3d, 0x01, 0x34, 0x37,
+  0x36, 0x37, 0x01, 0x21, 0x01, 0x06, 0x07, 0x06, 0x17, 0x16, 0x17, 0x05,
+  0x16, 0x1d, 0x01, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26,
+  0x27, 0x06, 0x04, 0x23, 0x21, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x04, 0x77, 0xa6, 0x01, 0x46, 0x2c,
+  0x6d, 0xfc, 0xb7, 0xfe, 0xc1, 0x09, 0x11, 0x90, 0x02, 0x6c, 0x01, 0x3c,
+  0xfc, 0xc4, 0x55, 0x0d, 0x09, 0x04, 0x05, 0x9d, 0x03, 0x69, 0xdf, 0x2b,
+  0x0d, 0x14, 0x29, 0x51, 0x53, 0x33, 0x0a, 0x4b, 0xfe, 0x95, 0x91, 0xfe,
+  0x3e, 0xad, 0x73, 0xfe, 0xd7, 0x39, 0xa5, 0x3a, 0xb7, 0x5d, 0x88, 0x58,
+  0x96, 0x6c, 0x05, 0x09, 0x6b, 0x12, 0x91, 0x37, 0xbe, 0x07, 0x06, 0x3e,
+  0x63, 0x60, 0x01, 0x9b, 0xfd, 0xe8, 0x37, 0x23, 0x0a, 0x23, 0x35, 0x1b,
+  0x96, 0x26, 0xf8, 0x45, 0x5e, 0x11, 0x05, 0xb8, 0x32, 0x30, 0x39, 0x82,
+  0x26, 0x62, 0x01, 0x0b, 0x8a, 0x5c, 0x5e, 0x88, 0x7e, 0x42, 0x22, 0x00,
+  0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x05, 0xde, 0x06, 0x14, 0x00, 0x20,
+  0x00, 0x00, 0x23, 0x35, 0x21, 0x32, 0x37, 0x36, 0x27, 0x26, 0x27, 0x25,
+  0x24, 0x3d, 0x01, 0x34, 0x37, 0x36, 0x37, 0x01, 0x21, 0x01, 0x06, 0x07,
+  0x06, 0x17, 0x16, 0x17, 0x05, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x12,
+  0x04, 0x87, 0x85, 0x29, 0x11, 0x03, 0x0b, 0x5a, 0xfc, 0xb7, 0xfe, 0xc1,
+  0x09, 0x10, 0x91, 0x02, 0x6c, 0x01, 0x3c, 0xfc, 0xc4, 0x55, 0x0d, 0x09,
+  0x04, 0x05, 0x9d, 0x03, 0x69, 0xdf, 0x38, 0x55, 0xc9, 0xb8, 0x68, 0x2c,
+  0x1c, 0x6e, 0x0f, 0x91, 0x37, 0xbe, 0x08, 0x05, 0x3e, 0x62, 0x61, 0x01,
+  0x9b, 0xfd, 0xe8, 0x37, 0x23, 0x0a, 0x23, 0x35, 0x1b, 0x96, 0x26, 0xf8,
+  0x71, 0x65, 0x9b, 0x00, 0x00, 0x01, 0xff, 0xee, 0x00, 0x00, 0x06, 0x53,
+  0x06, 0x14, 0x00, 0x29, 0x00, 0x00, 0x23, 0x35, 0x21, 0x32, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x25, 0x24, 0x3d, 0x01, 0x34, 0x37, 0x36, 0x37, 0x01,
+  0x21, 0x01, 0x06, 0x07, 0x06, 0x17, 0x16, 0x17, 0x05, 0x16, 0x1d, 0x01,
+  0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x26, 0x27, 0x06, 0x23,
+  0x12, 0x04, 0x87, 0x7b, 0x33, 0x0e, 0x65, 0xfc, 0xb7, 0xfe, 0xc1, 0x09,
+  0x10, 0x91, 0x02, 0x6c, 0x01, 0x3c, 0xfc, 0xc4, 0x55, 0x0d, 0x09, 0x04,
+  0x05, 0x9d, 0x03, 0x69, 0xdf, 0x2b, 0x0d, 0x14, 0x29, 0x51, 0x51, 0x32,
+  0x0a, 0x56, 0x97, 0xb8, 0x68, 0x1d, 0x18, 0x7f, 0x11, 0x91, 0x37, 0xbe,
+  0x08, 0x04, 0x3f, 0x62, 0x61, 0x01, 0x9b, 0xfd, 0xe8, 0x37, 0x23, 0x0a,
+  0x23, 0x35, 0x1b, 0x96, 0x26, 0xf8, 0x45, 0x5f, 0x10, 0x05, 0xb8, 0x2f,
+  0x28, 0x57, 0x00, 0x00, 0x00, 0x03, 0x00, 0x75, 0xff, 0xa7, 0x07, 0x11,
+  0x06, 0x14, 0x00, 0x37, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x00, 0x25, 0x06,
+  0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27,
+  0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05, 0x06, 0x07,
+  0x06, 0x15, 0x14, 0x17, 0x01, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x13, 0x34, 0x27, 0x26, 0x22, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x05, 0x0c, 0x59, 0x98, 0xb8, 0xa5,
+  0xad, 0x73, 0xfe, 0xd7, 0x39, 0xa5, 0x3a, 0xb7, 0x5d, 0x88, 0xa6, 0xae,
+  0x8e, 0x20, 0x0e, 0x30, 0xfe, 0xe9, 0x2d, 0x09, 0x1f, 0x5a, 0x02, 0x9f,
+  0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c, 0x02, 0x0d, 0x13, 0x23, 0x26, 0x3a,
+  0x4f, 0x77, 0x3a, 0x34, 0x5d, 0x1e, 0x57, 0x17, 0x99, 0x19, 0x19, 0x4a,
+  0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x39, 0x39, 0xa6, 0x38, 0x3a, 0x3a,
+  0x38, 0xa6, 0x39, 0x78, 0x4c, 0x3c, 0x49, 0x26, 0x62, 0x01, 0x0b, 0x8a,
+  0x5c, 0x5e, 0x88, 0x7e, 0x42, 0x22, 0x50, 0x41, 0x37, 0x1a, 0x2e, 0x45,
+  0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21, 0x77, 0x2a, 0x01, 0x36, 0xba,
+  0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25, 0xfd, 0x3f, 0x1a, 0x0e, 0x10,
+  0xb8, 0x18, 0x2b, 0x29, 0x78, 0x40, 0x03, 0xbc, 0x28, 0x1c, 0x1d, 0x38,
+  0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8,
+  0x40, 0x3f, 0x3f, 0x00, 0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x03, 0x6e,
+  0x06, 0x14, 0x00, 0x1f, 0x00, 0x2b, 0x00, 0x37, 0x00, 0x00, 0x29, 0x01,
+  0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x26, 0x35, 0x34,
+  0x37, 0x36, 0x37, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17,
+  0x13, 0x16, 0x15, 0x14, 0x07, 0x06, 0x13, 0x34, 0x27, 0x26, 0x22, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17,
+  0x85, 0x29, 0x0e, 0x31, 0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f,
+  0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c, 0xf7, 0x5c, 0x38, 0x55, 0xfe, 0x19,
+  0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38,
+  0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01,
+  0x7c, 0x3d, 0x51, 0x23, 0x21, 0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e,
+  0x28, 0x0b, 0x19, 0x20, 0x25, 0xfe, 0xb6, 0x7b, 0x7b, 0x71, 0x65, 0x9b,
+  0x04, 0x60, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85,
+  0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x00, 0x00,
+  0x00, 0x03, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x29,
+  0x00, 0x35, 0x00, 0x41, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37,
+  0x36, 0x35, 0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01,
+  0x15, 0x05, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x01, 0x16, 0x17, 0x16,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x07, 0x06,
+  0x01, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e,
+  0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17,
+  0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29, 0x0e, 0x31, 0xfe, 0xea,
+  0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c,
+  0x02, 0x0c, 0x14, 0x22, 0x27, 0x3a, 0x4f, 0x77, 0x3a, 0x35, 0x5c, 0x1e,
+  0x57, 0x13, 0x10, 0x55, 0x01, 0x01, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19,
+  0x4a, 0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a,
+  0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21,
+  0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25,
+  0xfd, 0x3f, 0x1a, 0x0e, 0x10, 0xb8, 0x18, 0x2b, 0x29, 0x78, 0x2e, 0x1b,
+  0x9b, 0x04, 0x60, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38,
+  0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x00,
+  0x00, 0x03, 0x00, 0x81, 0xff, 0xc9, 0x06, 0x24, 0x06, 0x14, 0x00, 0x21,
+  0x00, 0x44, 0x00, 0x48, 0x00, 0x00, 0x01, 0x15, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x16, 0x17, 0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27,
+  0x35, 0x16, 0x33, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26,
+  0x37, 0x36, 0x37, 0x36, 0x13, 0x06, 0x27, 0x26, 0x27, 0x24, 0x35, 0x34,
+  0x37, 0x33, 0x06, 0x15, 0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37,
+  0x36, 0x19, 0x01, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x27, 0x06, 0x01, 0x33, 0x15, 0x23, 0x03, 0x6e, 0x42, 0x22, 0x48,
+  0x0c, 0x0b, 0x3d, 0x5c, 0x4f, 0x4a, 0x46, 0x3c, 0x32, 0x3d, 0x29, 0x36,
+  0x33, 0x36, 0x46, 0x43, 0x10, 0x1d, 0x01, 0x02, 0x43, 0x4d, 0x7c, 0x62,
+  0x83, 0xba, 0x5b, 0xfe, 0xf9, 0x0e, 0xa6, 0x0d, 0x02, 0x90, 0x6d, 0x72,
+  0x7e, 0x50, 0x89, 0x58, 0x45, 0xa5, 0x2c, 0x28, 0x59, 0x43, 0x75, 0x89,
+  0x66, 0x8e, 0xfe, 0x72, 0x87, 0x87, 0x04, 0x6f, 0x52, 0x04, 0x0e, 0x1e,
+  0x21, 0x1c, 0x12, 0x10, 0x0a, 0x0f, 0x58, 0x6e, 0x2a, 0x27, 0x0b, 0x58,
+  0x0a, 0x1a, 0x1a, 0x1e, 0x26, 0x11, 0x10, 0x1c, 0x2f, 0x2e, 0x51, 0x26,
+  0x2b, 0xfb, 0x70, 0x14, 0x02, 0x02, 0x1e, 0x58, 0xc3, 0x4b, 0x35, 0x3a,
+  0x2c, 0x5c, 0x2e, 0x23, 0x1b, 0x2f, 0x5e, 0x49, 0x01, 0x01, 0x03, 0xb1,
+  0xfb, 0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x7b, 0x7e, 0x05, 0xdf, 0x96, 0x00,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x03, 0x6e, 0x06, 0x72, 0x00, 0x1f,
+  0x00, 0x23, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x13, 0x16, 0x15, 0x14, 0x07, 0x06,
+  0x01, 0x33, 0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29,
+  0x0e, 0x31, 0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8,
+  0x40, 0x13, 0x05, 0x1c, 0xf7, 0x5c, 0x38, 0x55, 0xfe, 0xd4, 0x87, 0x87,
+  0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21,
+  0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25,
+  0xfe, 0xb6, 0x7b, 0x7b, 0x71, 0x65, 0x9b, 0x06, 0x72, 0x96, 0x00, 0x00,
+  0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x04, 0x0c, 0x06, 0x72, 0x00, 0x29,
+  0x00, 0x2d, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35,
+  0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05,
+  0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x01, 0x16, 0x17, 0x16, 0x3b, 0x01,
+  0x15, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x06, 0x07, 0x06, 0x01, 0x33,
+  0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29, 0x0e, 0x31,
+  0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13,
+  0x05, 0x1c, 0x02, 0x0c, 0x14, 0x22, 0x27, 0x3a, 0x4f, 0x77, 0x3a, 0x35,
+  0x5c, 0x1e, 0x57, 0x13, 0x10, 0x55, 0xfe, 0xd7, 0x87, 0x87, 0xb8, 0x68,
+  0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21, 0x76, 0x2b,
+  0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25, 0xfd, 0x3f,
+  0x1a, 0x0e, 0x10, 0xb8, 0x18, 0x2b, 0x29, 0x78, 0x2e, 0x1b, 0x9b, 0x06,
+  0x72, 0x96, 0x00, 0x00, 0x00, 0x05, 0x00, 0x81, 0xfd, 0xa8, 0x06, 0x24,
+  0x06, 0x14, 0x00, 0x21, 0x00, 0x44, 0x00, 0x48, 0x00, 0x4c, 0x00, 0x50,
+  0x00, 0x00, 0x01, 0x15, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x16, 0x17,
+  0x16, 0x15, 0x14, 0x07, 0x06, 0x23, 0x22, 0x27, 0x35, 0x16, 0x33, 0x32,
+  0x37, 0x36, 0x35, 0x34, 0x27, 0x26, 0x27, 0x26, 0x37, 0x36, 0x37, 0x36,
+  0x13, 0x06, 0x27, 0x26, 0x27, 0x24, 0x35, 0x34, 0x37, 0x33, 0x06, 0x15,
+  0x16, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x19, 0x01, 0x33,
+  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x01,
+  0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03,
+  0x6e, 0x42, 0x22, 0x48, 0x0c, 0x0b, 0x3d, 0x5c, 0x4f, 0x4a, 0x46, 0x3c,
+  0x32, 0x3d, 0x29, 0x36, 0x33, 0x36, 0x46, 0x43, 0x10, 0x1d, 0x01, 0x02,
+  0x43, 0x4d, 0x7c, 0x62, 0x83, 0xba, 0x5b, 0xfe, 0xf9, 0x0e, 0xa6, 0x0d,
+  0x02, 0x90, 0x6d, 0x72, 0x7e, 0x50, 0x89, 0x58, 0x45, 0xa5, 0x2c, 0x28,
+  0x59, 0x43, 0x75, 0x89, 0x66, 0x8e, 0xfe, 0x5b, 0x88, 0x88, 0x71, 0x87,
+  0x87, 0xe1, 0x87, 0x87, 0x04, 0x6f, 0x52, 0x04, 0x0e, 0x1e, 0x21, 0x1c,
+  0x12, 0x10, 0x0a, 0x0f, 0x58, 0x6e, 0x2a, 0x27, 0x0b, 0x58, 0x0a, 0x1a,
+  0x1a, 0x1e, 0x26, 0x11, 0x10, 0x1c, 0x2f, 0x2e, 0x51, 0x26, 0x2b, 0xfb,
+  0x70, 0x14, 0x02, 0x02, 0x1e, 0x58, 0xc3, 0x4b, 0x35, 0x3a, 0x2c, 0x5c,
+  0x2e, 0x23, 0x1b, 0x2f, 0x5e, 0x49, 0x01, 0x01, 0x03, 0xb1, 0xfb, 0x6b,
+  0x6a, 0x31, 0x2c, 0xb8, 0x7b, 0x7e, 0xfe, 0x41, 0x96, 0x01, 0x90, 0x96,
+  0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee, 0xfd, 0xda, 0x03, 0x6e,
+  0x06, 0x14, 0x00, 0x1f, 0x00, 0x23, 0x00, 0x27, 0x00, 0x2b, 0x00, 0x00,
+  0x29, 0x01, 0x35, 0x21, 0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x26,
+  0x35, 0x34, 0x37, 0x36, 0x37, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x15,
+  0x14, 0x17, 0x13, 0x16, 0x15, 0x14, 0x07, 0x06, 0x03, 0x33, 0x15, 0x23,
+  0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7,
+  0x01, 0x17, 0x85, 0x29, 0x0e, 0x31, 0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e,
+  0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13, 0x05, 0x1c, 0xf7, 0x5c, 0x38, 0x55,
+  0xbc, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0xb8, 0x68, 0x24,
+  0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d, 0x51, 0x23, 0x21, 0x76, 0x2b, 0x01,
+  0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b, 0x19, 0x20, 0x25, 0xfe, 0xb6, 0x7b,
+  0x7b, 0x71, 0x65, 0x9b, 0xfe, 0x70, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96,
+  0x00, 0x04, 0xff, 0xee, 0xfd, 0xda, 0x04, 0x0c, 0x06, 0x14, 0x00, 0x29,
+  0x00, 0x2d, 0x00, 0x31, 0x00, 0x35, 0x00, 0x00, 0x29, 0x01, 0x35, 0x21,
+  0x32, 0x37, 0x36, 0x35, 0x34, 0x27, 0x01, 0x26, 0x35, 0x34, 0x37, 0x36,
+  0x37, 0x01, 0x15, 0x05, 0x06, 0x07, 0x06, 0x15, 0x14, 0x17, 0x01, 0x16,
+  0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x26, 0x2f, 0x01, 0x06,
+  0x07, 0x06, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x01, 0x17, 0xfe, 0xd7, 0x01, 0x17, 0x85, 0x29, 0x0e, 0x31,
+  0xfe, 0xea, 0x2e, 0x0a, 0x1b, 0x5e, 0x02, 0x9f, 0xfd, 0xe8, 0x40, 0x13,
+  0x05, 0x1c, 0x02, 0x0c, 0x14, 0x22, 0x27, 0x3a, 0x4f, 0x77, 0x3a, 0x35,
+  0x5c, 0x1e, 0x57, 0x13, 0x10, 0x55, 0xb9, 0x88, 0x88, 0x71, 0x87, 0x87,
+  0xe1, 0x87, 0x87, 0xb8, 0x68, 0x24, 0x24, 0x45, 0x42, 0x01, 0x7c, 0x3d,
+  0x51, 0x23, 0x21, 0x76, 0x2b, 0x01, 0x36, 0xba, 0xfa, 0x1e, 0x28, 0x0b,
+  0x19, 0x20, 0x25, 0xfd, 0x3f, 0x1a, 0x0e, 0x10, 0xb8, 0x18, 0x2b, 0x29,
+  0x78, 0x2e, 0x1b, 0x9b, 0xfe, 0x70, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96,
+  0x00, 0x03, 0x03, 0x69, 0x03, 0x84, 0x06, 0x72, 0x07, 0x2b, 0x00, 0x03,
+  0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x09, 0x01, 0x35, 0x01, 0x03, 0x34,
+  0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14,
+  0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x06, 0x72,
+  0xfc, 0xf7, 0x03, 0x09, 0x97, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a,
+  0x32, 0x6e, 0x39, 0x39, 0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x39, 0x06,
+  0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xfd, 0x35, 0x28, 0x1c, 0x1d, 0x38,
+  0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8,
+  0x40, 0x3f, 0x3f, 0x00, 0x00, 0x03, 0x00, 0x64, 0x03, 0x84, 0x03, 0x6e,
+  0x07, 0x2b, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b, 0x00, 0x00, 0x09, 0x01,
+  0x35, 0x01, 0x03, 0x34, 0x27, 0x26, 0x22, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27, 0x26, 0x34, 0x37, 0x36,
+  0x32, 0x17, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09, 0x90, 0x19, 0x19, 0x4a,
+  0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38, 0x3a, 0xa6, 0x38, 0x3a, 0x3a,
+  0x38, 0xa6, 0x3a, 0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xfd, 0x35,
+  0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b, 0x38, 0x85, 0xb8, 0x40,
+  0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00, 0x00, 0x03, 0x00, 0x64,
+  0x03, 0x84, 0x03, 0x6e, 0x07, 0x2b, 0x00, 0x03, 0x00, 0x0f, 0x00, 0x1b,
+  0x00, 0x00, 0x09, 0x01, 0x35, 0x01, 0x03, 0x34, 0x27, 0x26, 0x22, 0x06,
+  0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22, 0x27,
+  0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09,
+  0x90, 0x19, 0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x38, 0x3a,
+  0xa6, 0x38, 0x3a, 0x3a, 0x38, 0xa6, 0x3a, 0x06, 0x95, 0xfe, 0x9e, 0x96,
+  0x01, 0x62, 0xfd, 0x35, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c, 0x1b,
+  0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f, 0x00,
+  0x00, 0x03, 0x02, 0x1c, 0xfe, 0xa2, 0x06, 0x72, 0x07, 0x2b, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01, 0x35, 0x09, 0x01, 0x33,
+  0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x06, 0x72, 0xfc, 0xf7, 0x03, 0x09,
+  0xfc, 0x8b, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x06, 0x95, 0xfe, 0x9e, 0x96,
+  0x01, 0x62, 0xf8, 0x0d, 0x96, 0x96, 0x96, 0x00, 0x00, 0x03, 0x00, 0x64,
+  0xfe, 0xd4, 0x03, 0x6e, 0x07, 0x2b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x00, 0x09, 0x01, 0x35, 0x09, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09, 0xfe, 0x27, 0x87, 0x87,
+  0xe1, 0x87, 0x87, 0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xf8, 0x3f,
+  0x96, 0x96, 0x96, 0x00, 0x00, 0x03, 0x00, 0x64, 0xfe, 0xd4, 0x03, 0x6e,
+  0x07, 0x2b, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x00, 0x09, 0x01,
+  0x35, 0x09, 0x01, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x6e,
+  0xfc, 0xf7, 0x03, 0x09, 0xfe, 0x27, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x06,
+  0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0xf8, 0x3f, 0x96, 0x96, 0x96, 0x00,
+  0x00, 0x04, 0x03, 0x2a, 0x05, 0x33, 0x06, 0x72, 0x08, 0x34, 0x00, 0x03,
+  0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00, 0x09, 0x01, 0x35, 0x09,
+  0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23,
+  0x06, 0x72, 0xfc, 0xf7, 0x03, 0x09, 0xfd, 0x28, 0x88, 0x88, 0x71, 0x87,
+  0x87, 0xe1, 0x87, 0x87, 0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0x01,
+  0x09, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0x00, 0x43,
+  0x05, 0x33, 0x03, 0x6e, 0x08, 0x34, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b,
+  0x00, 0x0f, 0x00, 0x00, 0x09, 0x01, 0x35, 0x09, 0x01, 0x33, 0x15, 0x23,
+  0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0x6e, 0xfc, 0xf7,
+  0x03, 0x09, 0xfd, 0x46, 0x87, 0x87, 0x70, 0x88, 0x88, 0xe0, 0x86, 0x86,
+  0x06, 0x95, 0xfe, 0x9e, 0x96, 0x01, 0x62, 0x01, 0x09, 0x96, 0x64, 0x96,
+  0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0x00, 0x43, 0x05, 0x33, 0x03, 0x6e,
+  0x08, 0x34, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0b, 0x00, 0x0f, 0x00, 0x00,
+  0x09, 0x01, 0x35, 0x09, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23,
+  0x27, 0x33, 0x15, 0x23, 0x03, 0x6e, 0xfc, 0xf7, 0x03, 0x09, 0xfd, 0x46,
+  0x87, 0x87, 0x70, 0x88, 0x88, 0xe0, 0x86, 0x86, 0x06, 0x95, 0xfe, 0x9e,
+  0x96, 0x01, 0x62, 0x01, 0x09, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00,
+  0x00, 0x02, 0x00, 0x81, 0xfe, 0xc8, 0x05, 0x86, 0x07, 0x9e, 0x00, 0x24,
+  0x00, 0x28, 0x00, 0x00, 0x25, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17,
+  0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06,
+  0x23, 0x22, 0x27, 0x24, 0x11, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17,
+  0x16, 0x33, 0x32, 0x37, 0x36, 0x13, 0x33, 0x15, 0x23, 0x03, 0xaa, 0x46,
+  0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46, 0x10, 0x19, 0x6d, 0xea,
+  0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39, 0xa6, 0x3b, 0x96, 0x24,
+  0x41, 0x48, 0x63, 0x9c, 0x92, 0x87, 0x87, 0x49, 0x7e, 0xe3, 0x04, 0x6a,
+  0xfb, 0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22,
+  0x16, 0x5b, 0x01, 0x12, 0x8a, 0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22,
+  0x35, 0x07, 0xcc, 0x96, 0x00, 0x02, 0xff, 0xee, 0x00, 0x00, 0x01, 0x84,
+  0x07, 0x9e, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06,
+  0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x03, 0x33,
+  0x15, 0x23, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75, 0x44, 0x59, 0x27, 0x2c,
+  0xa6, 0x9d, 0x87, 0x87, 0x01, 0x73, 0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31,
+  0x6a, 0x04, 0x95, 0x01, 0x8a, 0x96, 0x00, 0x00, 0x00, 0x02, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0x75, 0x07, 0x9e, 0x00, 0x14, 0x00, 0x18, 0x00, 0x00,
+  0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35, 0x11, 0x33,
+  0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x03, 0x33, 0x15,
+  0x23, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27, 0x2c, 0xa6, 0x2c,
+  0x28, 0x59, 0x43, 0x75, 0x87, 0x91, 0x87, 0x87, 0x56, 0x56, 0xb8, 0x2c,
+  0x31, 0x6a, 0x04, 0x95, 0xfb, 0x6b, 0x6a, 0x31, 0x2c, 0xb8, 0x07, 0x9e,
+  0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x81, 0xfe, 0xc8, 0x05, 0x86,
+  0x08, 0x34, 0x00, 0x24, 0x00, 0x28, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x00,
+  0x25, 0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15,
+  0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24,
+  0x11, 0x26, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37,
+  0x36, 0x13, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
+  0x23, 0x03, 0xaa, 0x46, 0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46,
+  0x10, 0x19, 0x6d, 0xea, 0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39,
+  0xa6, 0x3b, 0x96, 0x24, 0x41, 0x48, 0x63, 0x9c, 0x8d, 0x88, 0x88, 0x71,
+  0x87, 0x87, 0xe1, 0x87, 0x87, 0x49, 0x7e, 0xe3, 0x04, 0x6a, 0xfb, 0x6b,
+  0x6a, 0x31, 0x2c, 0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22, 0x16, 0x5b,
+  0x01, 0x12, 0x8a, 0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22, 0x35, 0x08,
+  0x62, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
+  0x00, 0x00, 0x01, 0xdb, 0x08, 0x34, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x15,
+  0x00, 0x19, 0x00, 0x00, 0x01, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33,
+  0x32, 0x37, 0x36, 0x35, 0x11, 0x33, 0x03, 0x33, 0x15, 0x23, 0x17, 0x33,
+  0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75,
+  0x44, 0x59, 0x27, 0x2c, 0xa6, 0xa1, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1,
+  0x87, 0x87, 0x01, 0x73, 0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31, 0x6a, 0x04,
+  0x95, 0x02, 0x20, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee,
+  0x00, 0x00, 0x02, 0x75, 0x08, 0x34, 0x00, 0x14, 0x00, 0x18, 0x00, 0x1c,
+  0x00, 0x20, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
+  0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x03, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
+  0x23, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27, 0x2c, 0xa6, 0x2c,
+  0x28, 0x59, 0x43, 0x75, 0x87, 0x95, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1,
+  0x87, 0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xfb, 0x6b,
+  0x6a, 0x31, 0x2c, 0xb8, 0x08, 0x34, 0x96, 0x64, 0x96, 0x96, 0x96, 0x00,
+  0x00, 0x04, 0x00, 0x81, 0xfc, 0xe0, 0x05, 0x86, 0x06, 0x14, 0x00, 0x24,
+  0x00, 0x28, 0x00, 0x2c, 0x00, 0x30, 0x00, 0x00, 0x25, 0x36, 0x35, 0x11,
+  0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06,
+  0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x26, 0x37, 0x33,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x01, 0x33, 0x15,
+  0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15, 0x23, 0x03, 0xaa, 0x46,
+  0xa6, 0x2c, 0x27, 0x59, 0x44, 0x75, 0x65, 0x46, 0x10, 0x19, 0x6d, 0xea,
+  0x79, 0x4d, 0x59, 0x3e, 0xfe, 0xf9, 0x01, 0x39, 0xa6, 0x3b, 0x96, 0x24,
+  0x41, 0x48, 0x63, 0x9c, 0xfe, 0xf9, 0x86, 0x86, 0x70, 0x87, 0x87, 0xe1,
+  0x87, 0x87, 0x49, 0x7e, 0xe3, 0x04, 0x6a, 0xfb, 0x6b, 0x6a, 0x31, 0x2c,
+  0xb8, 0x33, 0x2e, 0x28, 0xb1, 0x42, 0x22, 0x16, 0x5b, 0x01, 0x12, 0x8a,
+  0x5c, 0x73, 0x73, 0x7e, 0x42, 0x10, 0x22, 0x35, 0xfd, 0xa4, 0x96, 0x01,
+  0x90, 0x96, 0x96, 0x96, 0x00, 0x04, 0xff, 0xee, 0xfe, 0x0c, 0x01, 0xc2,
+  0x06, 0x14, 0x00, 0x0d, 0x00, 0x11, 0x00, 0x15, 0x00, 0x19, 0x00, 0x00,
+  0x01, 0x14, 0x07, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37, 0x36, 0x35,
+  0x11, 0x33, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33,
+  0x15, 0x23, 0x01, 0x84, 0x4e, 0x48, 0x8b, 0x75, 0x44, 0x59, 0x27, 0x2c,
+  0xa6, 0xba, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x01, 0x73,
+  0xb2, 0x65, 0x5c, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xf8, 0x8e, 0x96,
+  0x01, 0x90, 0x96, 0x96, 0x96, 0x00, 0x00, 0x00, 0x00, 0x04, 0xff, 0xee,
+  0xfe, 0x0c, 0x02, 0x75, 0x06, 0x14, 0x00, 0x14, 0x00, 0x18, 0x00, 0x1c,
+  0x00, 0x20, 0x00, 0x00, 0x25, 0x06, 0x2b, 0x01, 0x35, 0x33, 0x32, 0x37,
+  0x36, 0x35, 0x11, 0x33, 0x11, 0x14, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23,
+  0x22, 0x03, 0x33, 0x15, 0x23, 0x13, 0x33, 0x15, 0x23, 0x27, 0x33, 0x15,
+  0x23, 0x01, 0x31, 0x45, 0x89, 0x75, 0x44, 0x59, 0x27, 0x2c, 0xa6, 0x2c,
+  0x28, 0x59, 0x43, 0x75, 0x87, 0x93, 0x87, 0x87, 0x70, 0x87, 0x87, 0xe1,
+  0x87, 0x87, 0x56, 0x56, 0xb8, 0x2c, 0x31, 0x6a, 0x04, 0x95, 0xfb, 0x6b,
+  0x6a, 0x31, 0x2c, 0xb8, 0xfe, 0xa2, 0x96, 0x01, 0x90, 0x96, 0x96, 0x96,
+  0x00, 0x03, 0x00, 0x84, 0xfc, 0xc7, 0x05, 0x8e, 0x02, 0xbc, 0x00, 0x26,
+  0x00, 0x2a, 0x00, 0x2e, 0x00, 0x00, 0x01, 0x16, 0x17, 0x16, 0x17, 0x16,
+  0x3b, 0x01, 0x15, 0x23, 0x22, 0x27, 0x06, 0x07, 0x06, 0x07, 0x06, 0x23,
+  0x22, 0x27, 0x24, 0x11, 0x34, 0x37, 0x33, 0x06, 0x15, 0x14, 0x17, 0x16,
+  0x33, 0x32, 0x37, 0x36, 0x37, 0x36, 0x35, 0x34, 0x27, 0x25, 0x33, 0x15,
+  0x23, 0x13, 0x33, 0x15, 0x23, 0x04, 0x63, 0x28, 0x18, 0x14, 0x2d, 0x30,
+  0x36, 0x43, 0x75, 0x40, 0x1e, 0x03, 0x50, 0x6c, 0xd7, 0x58, 0x52, 0x69,
+  0x65, 0xfe, 0xd8, 0x2b, 0xa5, 0x2c, 0xb5, 0x51, 0x44, 0x50, 0x47, 0xae,
+  0x44, 0x1d, 0x5a, 0xfe, 0x48, 0x86, 0x86, 0x70, 0x87, 0x87, 0x02, 0x45,
+  0x61, 0x60, 0x50, 0x3c, 0x40, 0xb8, 0x30, 0x6d, 0x93, 0xc7, 0x42, 0x1b,
+  0x25, 0x6b, 0x01, 0x63, 0xaf, 0x8d, 0x89, 0xb3, 0xec, 0x35, 0x18, 0x14,
+  0x30, 0xe3, 0x65, 0x70, 0xb8, 0xcb, 0x77, 0x96, 0xfb, 0x37, 0x96, 0x00,
+  0xff, 0xff, 0xff, 0xee, 0xfe, 0xd4, 0x01, 0x60, 0x03, 0xe8, 0x10, 0x27,
+  0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00,
+  0x10, 0x07, 0x10, 0xf6, 0x00, 0xca, 0xfe, 0xd4, 0xff, 0xff, 0xff, 0xee,
+  0xfe, 0xd4, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x27, 0x10, 0xf6, 0x00, 0xca,
+  0x03, 0x52, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf6,
+  0x00, 0xca, 0xfe, 0xd4, 0x00, 0x04, 0x00, 0x84, 0xfc, 0xae, 0x05, 0x8e,
+  0x02, 0xbc, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x36, 0x00, 0x42, 0x00, 0x00,
+  0x01, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37,
+  0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x25, 0x33, 0x15, 0x23, 0x01, 0x34, 0x27, 0x26, 0x22,
+  0x06, 0x15, 0x14, 0x17, 0x16, 0x32, 0x3e, 0x01, 0x14, 0x07, 0x06, 0x22,
+  0x27, 0x26, 0x34, 0x37, 0x36, 0x32, 0x17, 0x04, 0x63, 0x28, 0x18, 0x14,
+  0x2d, 0x30, 0x36, 0x43, 0x75, 0x40, 0x1e, 0x03, 0x50, 0x6c, 0xd7, 0x58,
+  0x52, 0x69, 0x65, 0xfe, 0xd8, 0x2b, 0xa5, 0x2c, 0xb5, 0x51, 0x44, 0x50,
+  0x47, 0xae, 0x44, 0x1d, 0x5a, 0xfe, 0x48, 0x86, 0x86, 0x01, 0x05, 0x19,
+  0x19, 0x4a, 0x32, 0x19, 0x19, 0x4a, 0x32, 0x6e, 0x39, 0x39, 0xa6, 0x38,
+  0x3a, 0x3a, 0x38, 0xa6, 0x39, 0x02, 0x45, 0x61, 0x60, 0x50, 0x3c, 0x40,
+  0xb8, 0x30, 0x6d, 0x93, 0xc7, 0x42, 0x1b, 0x25, 0x6b, 0x01, 0x63, 0xaf,
+  0x8d, 0x89, 0xb3, 0xec, 0x35, 0x18, 0x14, 0x30, 0xe3, 0x65, 0x70, 0xb8,
+  0xcb, 0x77, 0x96, 0xfb, 0x64, 0x28, 0x1c, 0x1d, 0x38, 0x29, 0x2a, 0x1c,
+  0x1b, 0x38, 0x85, 0xb8, 0x40, 0x40, 0x40, 0x40, 0xb8, 0x40, 0x3f, 0x3f,
+  0xff, 0xff, 0xff, 0xee, 0xfe, 0xf4, 0x01, 0xd3, 0x03, 0xe8, 0x10, 0x27,
+  0x10, 0xf6, 0x00, 0xca, 0x03, 0x52, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00,
+  0x10, 0x07, 0x11, 0x07, 0x00, 0x48, 0xfe, 0xf4, 0xff, 0xff, 0xff, 0xee,
+  0xfe, 0xf4, 0x02, 0x3f, 0x03, 0xe8, 0x10, 0x27, 0x10, 0xf6, 0x00, 0xca,
+  0x03, 0x52, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x11, 0x07,
+  0x00, 0x48, 0xfe, 0xf4, 0x00, 0x04, 0x00, 0x84, 0xfe, 0x0c, 0x05, 0x8e,
+  0x03, 0xb6, 0x00, 0x26, 0x00, 0x2a, 0x00, 0x2e, 0x00, 0x32, 0x00, 0x00,
+  0x01, 0x16, 0x17, 0x16, 0x17, 0x16, 0x3b, 0x01, 0x15, 0x23, 0x22, 0x27,
+  0x06, 0x07, 0x06, 0x07, 0x06, 0x23, 0x22, 0x27, 0x24, 0x11, 0x34, 0x37,
+  0x33, 0x06, 0x15, 0x14, 0x17, 0x16, 0x33, 0x32, 0x37, 0x36, 0x37, 0x36,
+  0x35, 0x34, 0x27, 0x01, 0x33, 0x15, 0x23, 0x17, 0x33, 0x15, 0x23, 0x27,
+  0x33, 0x15, 0x23, 0x04, 0x63, 0x28, 0x18, 0x14, 0x2d, 0x30, 0x36, 0x43,
+  0x75, 0x40, 0x1e, 0x03, 0x50, 0x6c, 0xd7, 0x58, 0x52, 0x69, 0x65, 0xfe,
+  0xd8, 0x2b, 0xa5, 0x2c, 0xb5, 0x51, 0x44, 0x50, 0x47, 0xae, 0x44, 0x1d,
+  0x5a, 0xfe, 0x74, 0x88, 0x88, 0x71, 0x87, 0x87, 0xe1, 0x87, 0x87, 0x02,
+  0x45, 0x61, 0x60, 0x50, 0x3c, 0x40, 0xb8, 0x30, 0x6d, 0x93, 0xc7, 0x42,
+  0x1b, 0x25, 0x6b, 0x01, 0x63, 0xaf, 0x8d, 0x89, 0xb3, 0xec, 0x35, 0x18,
+  0x14, 0x30, 0xe3, 0x65, 0x70, 0xb8, 0xcb, 0x01, 0x71, 0x96, 0x64, 0x96,
+  0x96, 0x96, 0x00, 0x00, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x01, 0xc2,
+  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfd, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf8,
+  0x00, 0x59, 0x03, 0x52, 0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x02, 0x3f,
+  0x04, 0xe2, 0x10, 0x26, 0x10, 0xfe, 0x00, 0x00, 0x10, 0x07, 0x10, 0xf8,
+  0x00, 0x59, 0x03, 0x52, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x57, 0x0a,
+  0xdd, 0x83, 0xf3, 0x6b, 0x5f, 0x0f, 0x3c, 0xf5, 0x00, 0x1f, 0x08, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0xce, 0x3f, 0xd8, 0x65, 0x00, 0x00, 0x00, 0x00,
+  0xce, 0x3f, 0xd8, 0x65, 0xf8, 0xa7, 0xfc, 0xae, 0x0c, 0x1a, 0x09, 0x55,
+  0x00, 0x20, 0x00, 0x08, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x01, 0x00, 0x00, 0x07, 0x6d, 0xfe, 0x1d, 0x00, 0x00, 0x0c, 0x7e,
+  0xf8, 0xa7, 0xfc, 0xc9, 0x0c, 0x1a, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x0e,
+  0x04, 0x52, 0x00, 0x5b, 0x00, 0x00, 0x00, 0x00, 0x02, 0xaa, 0x00, 0x00,
+  0x02, 0x49, 0x00, 0x00, 0x02, 0xe2, 0x01, 0x16, 0x03, 0x4f, 0x00, 0xb1,
+  0x06, 0x08, 0x00, 0x8e, 0x04, 0x94, 0x00, 0x99, 0x06, 0xd7, 0x00, 0x65,
+  0x05, 0x9d, 0x00, 0x74, 0x01, 0xfa, 0x00, 0xb1, 0x02, 0xcf, 0x00, 0x9e,
+  0x02, 0xcf, 0x00, 0x93, 0x03, 0x99, 0x00, 0x36, 0x06, 0x08, 0x00, 0xc3,
+  0x02, 0x49, 0x00, 0x8e, 0x02, 0x99, 0x00, 0x5a, 0x02, 0x49, 0x00, 0xc5,
+  0x02, 0x6d, 0x00, 0x00, 0x04, 0x94, 0x00, 0x79, 0x04, 0x94, 0x00, 0xca,
+  0x04, 0x94, 0x00, 0x87, 0x04, 0x94, 0x00, 0x8c, 0x04, 0x94, 0x00, 0x5a,
+  0x04, 0x94, 0x00, 0x8e, 0x04, 0x94, 0x00, 0x80, 0x04, 0x94, 0x00, 0x97,
+  0x04, 0x94, 0x00, 0x7d, 0x04, 0x94, 0x00, 0x74, 0x02, 0x6d, 0x00, 0xd8,
+  0x02, 0x6d, 0x00, 0x8e, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x03, 0xd2, 0x00, 0x84, 0x07, 0x33, 0x00, 0x79,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0xf0, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67,
+  0x05, 0x8b, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x24, 0x00, 0xb4,
+  0x05, 0x94, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0xb4,
+  0x02, 0x1f, 0xff, 0xa1, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x02, 0x00, 0xb4,
+  0x06, 0x36, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x57, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x00, 0x00, 0xb4,
+  0x04, 0x92, 0x00, 0x79, 0x04, 0x65, 0xff, 0xfb, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0xec, 0x00, 0x0e, 0x07, 0x1e, 0x00, 0x3d, 0x04, 0xee, 0x00, 0x36,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0xee, 0x00, 0x52, 0x02, 0xcf, 0x00, 0x9e,
+  0x02, 0x6d, 0x00, 0x00, 0x02, 0xcf, 0x00, 0xb3, 0x06, 0x08, 0x00, 0xc3,
+  0x03, 0x99, 0xff, 0xee, 0x03, 0x99, 0x00, 0x99, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0x92, 0x00, 0xa7, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
+  0x04, 0x6e, 0x00, 0x65, 0x02, 0x88, 0x00, 0x2a, 0x04, 0x92, 0x00, 0x65,
+  0x04, 0x90, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x02, 0x00, 0xff, 0xdf,
+  0x04, 0x2b, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x07, 0x03, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x04, 0x92, 0x00, 0xa7,
+  0x04, 0x92, 0x00, 0x65, 0x02, 0xf5, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63,
+  0x02, 0xd2, 0x00, 0x31, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x42, 0x00, 0x36,
+  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x35, 0x04, 0x42, 0x00, 0x36,
+  0x03, 0xc7, 0x00, 0x4f, 0x04, 0x94, 0x00, 0xe6, 0x02, 0x6d, 0x00, 0xea,
+  0x04, 0x94, 0x00, 0xe6, 0x06, 0x08, 0x00, 0xc3, 0x02, 0x49, 0x00, 0x00,
+  0x02, 0xe2, 0x01, 0x16, 0x04, 0x94, 0x00, 0x9a, 0x04, 0x94, 0x00, 0x74,
+  0x04, 0x94, 0x00, 0x54, 0x04, 0x94, 0x00, 0x49, 0x02, 0x6d, 0x00, 0xea,
+  0x03, 0x99, 0x00, 0x52, 0x03, 0x99, 0x00, 0xc1, 0x07, 0x33, 0x00, 0xfe,
+  0x03, 0x64, 0x00, 0x67, 0x04, 0x67, 0x00, 0x8e, 0x06, 0x08, 0x00, 0xc3,
+  0x02, 0x99, 0x00, 0x5a, 0x07, 0x33, 0x00, 0xfe, 0x03, 0x99, 0x00, 0xbf,
+  0x03, 0x99, 0x00, 0xaf, 0x06, 0x08, 0x00, 0xc3, 0x02, 0xe2, 0x00, 0x54,
+  0x02, 0xe2, 0x00, 0x58, 0x03, 0x99, 0x01, 0x4d, 0x04, 0x94, 0x00, 0x9c,
+  0x04, 0x94, 0x00, 0x8e, 0x02, 0x49, 0x00, 0xc5, 0x03, 0x99, 0x01, 0x05,
+  0x02, 0xe2, 0x00, 0x7b, 0x03, 0x64, 0x00, 0x56, 0x04, 0x67, 0x00, 0xad,
+  0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x58,
+  0x03, 0xd2, 0x00, 0x80, 0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0xec, 0x00, 0x0e, 0x07, 0x03, 0x00, 0x07, 0x05, 0x07, 0x00, 0x67,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x8c, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0x35, 0x02, 0x1f, 0x00, 0x91,
+  0x02, 0x1f, 0xff, 0xff, 0x02, 0x1f, 0x00, 0x05, 0x05, 0x94, 0x00, 0x09,
+  0x05, 0x62, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0xaa, 0x00, 0x67,
+  0x05, 0xaa, 0x00, 0x67, 0x05, 0xaa, 0x00, 0x67, 0x05, 0xaa, 0x00, 0x67,
+  0x06, 0x08, 0x00, 0xfc, 0x05, 0xaa, 0x00, 0x5b, 0x05, 0x45, 0x00, 0xa0,
+  0x05, 0x45, 0x00, 0xa0, 0x05, 0x45, 0x00, 0xa0, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0x5b, 0x00, 0xb4, 0x04, 0x89, 0x00, 0xa7,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x69, 0x00, 0x6e,
+  0x07, 0x11, 0x00, 0x6e, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65,
+  0x02, 0x00, 0xff, 0xcd, 0x02, 0x00, 0x00, 0x81, 0x02, 0x00, 0xff, 0xe2,
+  0x02, 0x00, 0xff, 0xf6, 0x04, 0x67, 0x00, 0x65, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x06, 0x08, 0x00, 0xc3,
+  0x04, 0x67, 0x00, 0x40, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x90, 0x00, 0x9c,
+  0x04, 0x90, 0x00, 0x9c, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x42, 0x00, 0x36,
+  0x04, 0x92, 0x00, 0xa7, 0x04, 0x42, 0x00, 0x36, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x05, 0x07, 0x00, 0x67,
+  0x03, 0xf5, 0x00, 0x65, 0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65,
+  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x05, 0x07, 0x00, 0x67,
+  0x03, 0xf5, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65,
+  0x05, 0x94, 0x00, 0x09, 0x04, 0x92, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x05, 0x94, 0x00, 0x67,
+  0x04, 0x92, 0x00, 0x65, 0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
+  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x05, 0x6a, 0x00, 0xb4,
+  0x04, 0x90, 0xff, 0xe8, 0x06, 0x98, 0x00, 0xb4, 0x05, 0x00, 0x00, 0x6c,
+  0x02, 0x1f, 0xff, 0xe7, 0x02, 0x00, 0xff, 0xd8, 0x02, 0x1f, 0x00, 0x02,
+  0x02, 0x00, 0xff, 0xf4, 0x02, 0x1f, 0xff, 0xf7, 0x02, 0x00, 0xff, 0xe7,
+  0x02, 0x1f, 0x00, 0x9e, 0x02, 0x00, 0x00, 0x87, 0x02, 0x1f, 0x00, 0xb4,
+  0x02, 0x00, 0x00, 0xad, 0x04, 0x3f, 0x00, 0xb4, 0x04, 0x00, 0x00, 0xad,
+  0x02, 0x1f, 0xff, 0xa1, 0x02, 0x00, 0xff, 0xdf, 0x04, 0xb8, 0x00, 0xb4,
+  0x04, 0x2b, 0x00, 0xa7, 0x04, 0x2b, 0x00, 0xa7, 0x04, 0x02, 0x00, 0xb4,
+  0x02, 0x00, 0x00, 0xad, 0x04, 0x02, 0x00, 0xb4, 0x02, 0x00, 0x00, 0x7a,
+  0x04, 0x02, 0x00, 0xb4, 0x02, 0xb3, 0x00, 0xad, 0x04, 0x02, 0x00, 0xb4,
+  0x02, 0x76, 0x00, 0xad, 0x04, 0x0b, 0xff, 0xf4, 0x02, 0x0b, 0x00, 0x01,
+  0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4,
+  0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x05, 0xdb, 0x00, 0xb8, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x07, 0xb3, 0x00, 0x67, 0x07, 0x5d, 0x00, 0x65, 0x05, 0x00, 0x00, 0xb4,
+  0x02, 0xf5, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0x75,
+  0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7, 0x04, 0x92, 0x00, 0x79,
+  0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63,
+  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79,
+  0x03, 0xc0, 0x00, 0x63, 0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31,
+  0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb,
+  0x02, 0xd2, 0x00, 0x31, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
+  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
+  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0x90, 0x00, 0x9c, 0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd,
+  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xee, 0x00, 0x52,
+  0x03, 0xc7, 0x00, 0x4f, 0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f,
+  0x02, 0x88, 0x00, 0x2a, 0x04, 0x92, 0x00, 0x1c, 0x05, 0x4a, 0xff, 0xa2,
+  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7, 0x04, 0xf0, 0x00, 0x00,
+  0x04, 0x92, 0x00, 0x00, 0x05, 0x10, 0x00, 0x67, 0x05, 0x07, 0x00, 0x67,
+  0x03, 0xf5, 0x00, 0x65, 0x05, 0x94, 0x00, 0x09, 0x05, 0xe5, 0xff, 0xa2,
+  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0x8c, 0x00, 0x75, 0x05, 0xaa, 0x00, 0x69, 0x04, 0x6c, 0x00, 0x93,
+  0x04, 0x24, 0xff, 0xa1, 0x02, 0x88, 0xff, 0x8c, 0x05, 0x94, 0x00, 0x67,
+  0x04, 0xf1, 0x00, 0x07, 0x07, 0x15, 0x00, 0xa7, 0x02, 0x8b, 0x00, 0xb4,
+  0x02, 0x1f, 0x00, 0x09, 0x05, 0x5e, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa6,
+  0x02, 0x00, 0x00, 0x09, 0x04, 0x42, 0x00, 0x36, 0x07, 0x03, 0x00, 0xa0,
+  0x05, 0x62, 0xff, 0xa1, 0x04, 0x90, 0x00, 0xa7, 0x05, 0xaa, 0x00, 0x67,
+  0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a, 0x06, 0xd4, 0x00, 0x67,
+  0x05, 0x77, 0x00, 0x65, 0x04, 0xb1, 0xff, 0xa2, 0x04, 0x92, 0x00, 0xa6,
+  0x05, 0x00, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x66, 0x03, 0xc0, 0x00, 0x5a,
+  0x04, 0x8c, 0x00, 0xb4, 0x02, 0x6b, 0xff, 0x0d, 0x02, 0xd2, 0x00, 0x31,
+  0x04, 0x65, 0x00, 0x15, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb,
+  0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e, 0x05, 0x80, 0x00, 0x46,
+  0x05, 0x30, 0x00, 0xb4, 0x05, 0x5a, 0xff, 0xfd, 0x05, 0x42, 0x00, 0x36,
+  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xcb, 0x00, 0x90,
+  0x04, 0xcb, 0x00, 0x52, 0x04, 0x28, 0x00, 0x5d, 0x03, 0xc7, 0x00, 0x65,
+  0x04, 0x94, 0x00, 0x87, 0x04, 0xcb, 0x00, 0x53, 0x04, 0x28, 0x00, 0x5d,
+  0x03, 0xac, 0x00, 0x4f, 0x04, 0x92, 0x00, 0xa7, 0x02, 0x1f, 0x00, 0xb4,
+  0x03, 0x8b, 0x00, 0xb4, 0x03, 0x4e, 0x00, 0x12, 0x02, 0x20, 0x00, 0xb4,
+  0x0a, 0x3c, 0x00, 0xb4, 0x09, 0x5a, 0x00, 0xb4, 0x08, 0x4f, 0x00, 0x65,
+  0x06, 0x03, 0x00, 0xb4, 0x05, 0xa9, 0x00, 0xb4, 0x03, 0x49, 0x00, 0xad,
+  0x06, 0xb4, 0x00, 0xb4, 0x06, 0xa6, 0x00, 0xb4, 0x05, 0xbd, 0x00, 0xa7,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x02, 0x1f, 0xff, 0xff,
+  0x02, 0x00, 0xff, 0xe4, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
+  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0x90, 0x00, 0x9c, 0x04, 0x6e, 0x00, 0x65, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x07, 0x03, 0x00, 0x07, 0x07, 0x11, 0x00, 0x6e, 0x05, 0x94, 0x00, 0x67,
+  0x04, 0x92, 0x00, 0x65, 0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
+  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0xff, 0xec, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0xcb, 0x00, 0x90, 0x04, 0x28, 0x00, 0x4f, 0x02, 0x00, 0xff, 0xdf,
+  0x0a, 0x3c, 0x00, 0xb4, 0x09, 0x5a, 0x00, 0xb4, 0x08, 0x4f, 0x00, 0x65,
+  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x08, 0x03, 0x00, 0xb4,
+  0x04, 0xe9, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x07, 0x03, 0x00, 0x07,
+  0x07, 0x11, 0x00, 0x6e, 0x05, 0xaa, 0x00, 0x5b, 0x04, 0x67, 0x00, 0x40,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x02, 0x1f, 0xff, 0xb0,
+  0x02, 0x00, 0xff, 0xca, 0x02, 0x1f, 0x00, 0x04, 0x02, 0x00, 0xff, 0xe6,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0x00, 0x00, 0xb3, 0x02, 0xf5, 0x00, 0x75,
+  0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
+  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x65, 0xff, 0xfb,
+  0x02, 0xd2, 0x00, 0x31, 0x04, 0x83, 0x00, 0x8c, 0x03, 0xc1, 0x00, 0x3f,
+  0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0xff, 0xf2, 0x05, 0x4b, 0x00, 0xb4,
+  0x06, 0x08, 0x00, 0x65, 0x05, 0x07, 0x00, 0x65, 0x04, 0x65, 0x00, 0x65,
+  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x04, 0x65, 0xff, 0xfd,
+  0x04, 0x42, 0x00, 0x36, 0x03, 0x6a, 0x00, 0x7c, 0x06, 0x11, 0x00, 0xa7,
+  0x03, 0x6f, 0x00, 0x31, 0x02, 0x00, 0xff, 0xdf, 0x07, 0x2f, 0x00, 0x65,
+  0x07, 0x2f, 0x00, 0x65, 0x04, 0xec, 0xff, 0xfe, 0x05, 0x07, 0x00, 0x0a,
+  0x03, 0xf5, 0x00, 0x08, 0x04, 0x02, 0x00, 0x09, 0x04, 0x65, 0xff, 0xba,
+  0x03, 0xc0, 0x00, 0x63, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0x57, 0x00, 0x48,
+  0x03, 0x72, 0x00, 0x48, 0x04, 0xf0, 0x00, 0x09, 0x05, 0x45, 0x00, 0x0a,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x02, 0x1f, 0xff, 0xa1, 0x02, 0x00, 0xff, 0xdf, 0x05, 0xa0, 0x00, 0x67,
+  0x04, 0x92, 0x00, 0x65, 0x05, 0x00, 0x00, 0x09, 0x02, 0xf5, 0x00, 0x0c,
+  0x04, 0x65, 0xff, 0xf7, 0x04, 0x42, 0x00, 0x09, 0x04, 0x52, 0x00, 0x9c,
+  0x04, 0x92, 0x00, 0x65, 0x04, 0x92, 0x00, 0xa7, 0x04, 0x92, 0x00, 0xa7,
+  0x03, 0xf4, 0x00, 0x72, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
+  0x05, 0x03, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65,
+  0x05, 0xe6, 0x00, 0x6f, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xd4, 0x00, 0x77,
+  0x05, 0x95, 0x00, 0x77, 0x04, 0xc8, 0x00, 0x65, 0x02, 0x00, 0xff, 0xdf,
+  0x05, 0x02, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65, 0x04, 0x88, 0x00, 0x65,
+  0x04, 0x4a, 0x00, 0x56, 0x04, 0x4a, 0x00, 0x56, 0x04, 0x90, 0x00, 0x9c,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x02, 0x00, 0x00, 0x0c,
+  0x02, 0x6f, 0x00, 0x95, 0x02, 0xac, 0x00, 0x68, 0x02, 0xd9, 0x00, 0x43,
+  0x03, 0x82, 0x00, 0x45, 0x02, 0x01, 0x00, 0xad, 0x05, 0x15, 0x00, 0xad,
+  0x07, 0x03, 0x00, 0xa7, 0x07, 0x03, 0x00, 0xa7, 0x07, 0x03, 0x00, 0xa7,
+  0x04, 0xa6, 0xff, 0xdf, 0x04, 0x9f, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa1,
+  0x04, 0x67, 0x00, 0x65, 0x06, 0x2d, 0x00, 0x65, 0x05, 0x3d, 0x00, 0x85,
+  0x04, 0xbf, 0x00, 0x64, 0x02, 0xfb, 0x00, 0x00, 0x02, 0xfb, 0x00, 0x00,
+  0x02, 0xfa, 0x00, 0x00, 0x02, 0xf5, 0x00, 0xa7, 0x02, 0xf4, 0x00, 0xa7,
+  0x03, 0xd1, 0x00, 0x76, 0x03, 0xd1, 0x00, 0x68, 0x04, 0x58, 0x00, 0xa7,
+  0x04, 0x58, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63, 0x02, 0x6b, 0xff, 0xdd,
+  0x02, 0x6b, 0xff, 0xdd, 0x03, 0x52, 0x00, 0x31, 0x02, 0x6b, 0xff, 0x0d,
+  0x02, 0xd2, 0x00, 0x31, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x90, 0x00, 0x00,
+  0x04, 0x72, 0x00, 0x65, 0x04, 0x4e, 0x00, 0xad, 0x04, 0x42, 0x00, 0x36,
+  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0x00, 0x5b,
+  0x03, 0xc7, 0x00, 0x4f, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0x28, 0x00, 0x4f,
+  0x04, 0x28, 0x00, 0x62, 0x03, 0xac, 0x00, 0x4f, 0x03, 0xac, 0x00, 0x4f,
+  0x03, 0xac, 0x00, 0x4f, 0x03, 0xac, 0x00, 0x4f, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x2c, 0x00, 0xa7, 0x04, 0xc8, 0x00, 0x65, 0x05, 0x19, 0x00, 0x65,
+  0x04, 0xb5, 0x00, 0xa7, 0x02, 0x1a, 0xff, 0x0d, 0x04, 0xcd, 0x00, 0xa7,
+  0x03, 0xa6, 0x00, 0xa7, 0x05, 0x3c, 0x00, 0x65, 0x03, 0xac, 0x00, 0x4f,
+  0x03, 0xac, 0x00, 0x4f, 0x07, 0x4d, 0x00, 0x65, 0x07, 0x9d, 0x00, 0x65,
+  0x07, 0x4a, 0x00, 0x65, 0x05, 0xfa, 0x00, 0x31, 0x04, 0x64, 0x00, 0x31,
+  0x05, 0x9a, 0x00, 0x31, 0x06, 0x1b, 0x00, 0x2a, 0x05, 0x14, 0x00, 0xad,
+  0x04, 0xb6, 0x00, 0xad, 0x03, 0xb5, 0x00, 0x30, 0x03, 0xb5, 0x00, 0x30,
+  0x04, 0xc2, 0x00, 0x00, 0x04, 0xc7, 0x00, 0x00, 0x02, 0xe9, 0x00, 0x69,
+  0x02, 0xdf, 0x00, 0x69, 0x01, 0x42, 0xff, 0xec, 0x01, 0xdd, 0x00, 0x69,
+  0x02, 0x20, 0x00, 0x40, 0x02, 0x21, 0x00, 0x40, 0x02, 0xba, 0x00, 0x1c,
+  0x03, 0xb5, 0x00, 0x30, 0x02, 0xae, 0x00, 0x22, 0x02, 0x01, 0x00, 0x90,
+  0x03, 0x4f, 0x00, 0x90, 0x02, 0x49, 0x00, 0x9c, 0x02, 0x49, 0x00, 0xa0,
+  0x02, 0x49, 0x00, 0xb0, 0x02, 0x36, 0x00, 0x69, 0x02, 0x36, 0x00, 0x69,
+  0x02, 0xa9, 0x00, 0x69, 0x02, 0xa9, 0x00, 0x69, 0x03, 0x99, 0x00, 0xf0,
+  0x03, 0x99, 0x00, 0xf0, 0x03, 0x99, 0x00, 0xad, 0x03, 0x99, 0x00, 0xad,
+  0x03, 0x99, 0x00, 0xad, 0x03, 0x99, 0x00, 0xad, 0x01, 0xfa, 0x00, 0xc0,
+  0x03, 0x99, 0x00, 0xbf, 0x03, 0x99, 0x01, 0x4d, 0x03, 0x99, 0x00, 0x99,
+  0x01, 0xfa, 0x00, 0xc0, 0x03, 0x99, 0x00, 0xbf, 0x03, 0x99, 0x00, 0x99,
+  0x03, 0x99, 0x01, 0x4d, 0x02, 0x6d, 0x00, 0x63, 0x02, 0x6d, 0x00, 0x63,
+  0x02, 0x36, 0x00, 0x69, 0x02, 0x36, 0x00, 0x69, 0x03, 0x99, 0x01, 0x02,
+  0x03, 0x99, 0x01, 0x02, 0x02, 0xce, 0x00, 0x5a, 0x02, 0x49, 0x00, 0x5a,
+  0x03, 0x99, 0x00, 0xb3, 0x03, 0x99, 0x01, 0x71, 0x03, 0x99, 0x00, 0xd6,
+  0x03, 0x99, 0x01, 0x2a, 0x03, 0x99, 0x00, 0xa3, 0x03, 0x99, 0x00, 0xd8,
+  0x02, 0x45, 0x00, 0x00, 0x03, 0x99, 0x00, 0xd7, 0x03, 0x10, 0x00, 0x69,
+  0x01, 0x32, 0x00, 0x6d, 0x02, 0xaf, 0x00, 0x69, 0x03, 0x32, 0x00, 0x69,
+  0x02, 0xa9, 0x00, 0x69, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
+  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
+  0x03, 0x99, 0x00, 0xad, 0x03, 0x99, 0x00, 0xbf, 0x03, 0xba, 0x00, 0x9c,
+  0x03, 0x99, 0x00, 0xd6, 0x03, 0x99, 0x00, 0xa3, 0x00, 0x00, 0xfc, 0xfe,
+  0x00, 0x00, 0xfd, 0xb3, 0x00, 0x00, 0xfd, 0x15, 0x00, 0x00, 0xfd, 0x09,
+  0x00, 0x00, 0xfd, 0x2a, 0x00, 0x00, 0xfc, 0x55, 0x00, 0x00, 0xfd, 0x13,
+  0x00, 0x00, 0xfd, 0xdf, 0x00, 0x00, 0xfd, 0x28, 0x00, 0x00, 0xfd, 0x7f,
+  0x00, 0x00, 0xfd, 0x3b, 0x00, 0x00, 0xfd, 0x42, 0x00, 0x00, 0xfd, 0x18,
+  0x00, 0x00, 0xfd, 0xf6, 0x00, 0x00, 0xfd, 0x3f, 0x00, 0x00, 0xfc, 0xbb,
+  0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfe, 0x50,
+  0x00, 0x00, 0xfd, 0xcf, 0x00, 0x00, 0xfd, 0xcf, 0x00, 0x00, 0xff, 0x87,
+  0x00, 0x00, 0xfc, 0xfe, 0x00, 0x00, 0xfd, 0xb3, 0x00, 0x00, 0xfd, 0x6e,
+  0x00, 0x00, 0xfd, 0xfe, 0x00, 0x00, 0xfe, 0x80, 0x00, 0x00, 0xff, 0x0c,
+  0x00, 0x00, 0xfd, 0xc0, 0x00, 0x00, 0xfd, 0x57, 0x00, 0x00, 0xfd, 0x57,
+  0x00, 0x00, 0xfd, 0x6e, 0x00, 0x00, 0xfd, 0x57, 0x00, 0x00, 0xfd, 0xbb,
+  0x00, 0x00, 0xfd, 0xb8, 0x00, 0x00, 0xfd, 0xdf, 0x00, 0x00, 0xfd, 0x27,
+  0x00, 0x00, 0xfd, 0x71, 0x00, 0x00, 0xfd, 0xad, 0x00, 0x00, 0xfd, 0x6d,
+  0x00, 0x00, 0xfd, 0x92, 0x00, 0x00, 0xfd, 0xf6, 0x00, 0x00, 0xfd, 0x3f,
+  0x00, 0x00, 0xfc, 0xc0, 0x00, 0x00, 0xfd, 0x18, 0x00, 0x00, 0xfd, 0x13,
+  0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfd, 0x13, 0x00, 0x00, 0xfd, 0x09,
+  0x00, 0x00, 0xfd, 0x2a, 0x00, 0x00, 0xfc, 0x55, 0x00, 0x00, 0xfc, 0x55,
+  0x00, 0x00, 0xfb, 0xfe, 0x00, 0x00, 0xfd, 0xb9, 0x00, 0x00, 0xfb, 0x6f,
+  0x00, 0x00, 0xfb, 0xde, 0x00, 0x00, 0xfa, 0xaa, 0x00, 0x00, 0xfd, 0xe8,
+  0x00, 0x00, 0xfd, 0x40, 0x00, 0x00, 0xfd, 0x6b, 0x00, 0x00, 0xfc, 0xc0,
+  0x00, 0x00, 0xfd, 0x74, 0x00, 0x00, 0xfe, 0x39, 0x00, 0x00, 0xfc, 0x55,
+  0x00, 0x00, 0xfc, 0xfe, 0x00, 0x00, 0xfd, 0xb3, 0x00, 0x00, 0xfd, 0x09,
+  0x00, 0x00, 0xfd, 0xcf, 0x00, 0x00, 0xfd, 0x37, 0x00, 0x00, 0xfd, 0xff,
+  0x00, 0x00, 0xfd, 0x27, 0x00, 0x00, 0xfd, 0x69, 0x00, 0x00, 0xfd, 0x60,
+  0x00, 0x00, 0xfd, 0x69, 0x00, 0x00, 0xfd, 0x0b, 0x00, 0x00, 0xfd, 0x0b,
+  0x00, 0x00, 0xfd, 0x0b, 0x00, 0x00, 0xfc, 0xc0, 0x00, 0x00, 0xfd, 0x7b,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfd, 0xb9, 0x00, 0x00, 0xfd, 0x13,
+  0x00, 0x00, 0xfd, 0x74, 0x00, 0x00, 0xfd, 0xb9, 0x00, 0x00, 0xff, 0x43,
+  0x00, 0x00, 0xfc, 0xe8, 0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfc, 0xcc,
+  0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfd, 0x73,
+  0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0xfc, 0xd2, 0x04, 0xb6, 0x00, 0xb4,
+  0x04, 0x16, 0x00, 0xad, 0x06, 0x34, 0x00, 0xb4, 0x04, 0xa9, 0x00, 0xb4,
+  0x02, 0x01, 0x00, 0x90, 0x02, 0x01, 0x00, 0x90, 0x05, 0x62, 0x00, 0xb4,
+  0x04, 0xad, 0x00, 0xa7, 0x03, 0x99, 0x01, 0x8a, 0x03, 0xf4, 0x00, 0x72,
+  0x03, 0xf5, 0x00, 0x65, 0x03, 0xf4, 0x00, 0x72, 0x02, 0x6d, 0x00, 0x8e,
+  0x03, 0x99, 0x01, 0x4d, 0x03, 0x99, 0x00, 0xc1, 0x04, 0xfc, 0x00, 0x0e,
+  0x02, 0x49, 0x00, 0xc5, 0x05, 0x5f, 0xff, 0xea, 0x06, 0x45, 0xff, 0xf5,
+  0x02, 0xf0, 0xff, 0xef, 0x05, 0xd9, 0xff, 0xf4, 0x05, 0xf0, 0xff, 0xe5,
+  0x05, 0xf1, 0xff, 0xdf, 0x02, 0x6f, 0x00, 0x04, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x02, 0x00, 0xb4, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0xee, 0x00, 0x52, 0x05, 0x6a, 0x00, 0xb4,
+  0x05, 0xaa, 0x00, 0x67, 0x02, 0x1f, 0x00, 0xb4, 0x04, 0xb8, 0x00, 0xb4,
+  0x04, 0xec, 0x00, 0x0e, 0x06, 0x36, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4,
+  0x04, 0x8c, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4,
+  0x04, 0x57, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x65, 0xff, 0xfb,
+  0x04, 0x65, 0xff, 0xfd, 0x05, 0xaa, 0x00, 0x67, 0x04, 0xee, 0x00, 0x36,
+  0x05, 0xaa, 0x00, 0x67, 0x05, 0x80, 0x00, 0x46, 0x02, 0x1f, 0x00, 0x05,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0xbf, 0x00, 0x65, 0x03, 0xe4, 0x00, 0x77,
+  0x04, 0x90, 0x00, 0xa7, 0x02, 0x6f, 0x00, 0x95, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0xbf, 0x00, 0x65, 0x04, 0x98, 0x00, 0xac, 0x04, 0x42, 0x00, 0x1c,
+  0x04, 0x67, 0x00, 0x65, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xea, 0x00, 0x60,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x02, 0x6f, 0x00, 0x95,
+  0x04, 0x3e, 0x00, 0xab, 0x04, 0x42, 0x00, 0x36, 0x04, 0x94, 0x00, 0x9c,
+  0x04, 0x05, 0x00, 0x42, 0x04, 0x03, 0x00, 0x60, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0x55, 0x00, 0x42, 0x04, 0x92, 0x00, 0xa7, 0x04, 0x39, 0x00, 0x65,
+  0x04, 0x90, 0x00, 0x65, 0x04, 0x55, 0x00, 0x5a, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0xbf, 0x00, 0x64, 0x04, 0x28, 0x00, 0x35, 0x04, 0xbf, 0x00, 0x64,
+  0x06, 0x07, 0x00, 0x79, 0x02, 0x6f, 0x00, 0x04, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0x67, 0x00, 0x65, 0x04, 0x2a, 0x00, 0x86, 0x06, 0x07, 0x00, 0x79,
+  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x6c, 0x00, 0x96, 0x04, 0x75, 0x00, 0x65,
+  0x05, 0x07, 0x00, 0x4e, 0x06, 0x10, 0xff, 0xe5, 0x05, 0x07, 0x00, 0x4e,
+  0x04, 0xbf, 0x00, 0x64, 0x06, 0x07, 0x00, 0x3a, 0x04, 0xc7, 0x00, 0x64,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x04, 0xab, 0x00, 0x7d,
+  0x04, 0x39, 0x00, 0x65, 0x04, 0x24, 0x00, 0xb4, 0x03, 0x4d, 0xff, 0x54,
+  0x04, 0xbf, 0x00, 0xa1, 0x04, 0xbf, 0x00, 0xab, 0x06, 0x3a, 0x00, 0x66,
+  0x04, 0x84, 0x00, 0x6b, 0x06, 0xb8, 0x00, 0x67, 0x06, 0x07, 0x00, 0x79,
+  0x05, 0x75, 0x00, 0x67, 0x04, 0xbf, 0x00, 0x65, 0x05, 0xb2, 0x00, 0xb4,
+  0x04, 0x6d, 0x00, 0x28, 0x04, 0xf1, 0x00, 0x47, 0x04, 0x5e, 0x00, 0x5a,
+  0x05, 0x86, 0x00, 0x67, 0x04, 0x80, 0x00, 0x30, 0x05, 0x08, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x04, 0x65, 0x00, 0x27, 0x03, 0xdc, 0x00, 0x31,
+  0x04, 0xc7, 0x00, 0x64, 0x04, 0x92, 0x00, 0xa7, 0x03, 0xf5, 0x00, 0x65,
+  0x02, 0x00, 0xff, 0xdf, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x6e, 0x00, 0x65,
+  0x04, 0x6e, 0x00, 0xb0, 0x04, 0x5b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7,
+  0x05, 0x07, 0x00, 0x67, 0x06, 0x36, 0x00, 0xb4, 0x04, 0xaf, 0x00, 0x72,
+  0x04, 0x92, 0x00, 0x4c, 0x05, 0x10, 0x00, 0x67, 0x05, 0x07, 0x00, 0x67,
+  0x05, 0x10, 0x00, 0x67, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4,
+  0x05, 0xa9, 0xff, 0xfb, 0x04, 0x64, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67,
+  0x04, 0x92, 0x00, 0x79, 0x02, 0x1f, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0x05,
+  0x02, 0x1f, 0xff, 0xa1, 0x07, 0xe0, 0x00, 0x4b, 0x07, 0x86, 0x00, 0xb4,
+  0x05, 0xa9, 0xff, 0xfb, 0x05, 0x1c, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4,
+  0x04, 0x63, 0x00, 0x1f, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0xf0, 0x00, 0xb4, 0x04, 0xf0, 0x00, 0xb4, 0x04, 0x64, 0x00, 0xb4,
+  0x05, 0xa0, 0x00, 0x5a, 0x04, 0x8c, 0x00, 0xb4, 0x07, 0xc1, 0x00, 0x24,
+  0x04, 0x9d, 0x00, 0x79, 0x05, 0x62, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4,
+  0x05, 0x1c, 0x00, 0xb4, 0x05, 0x6a, 0x00, 0x4b, 0x06, 0x36, 0x00, 0xb4,
+  0x05, 0x6a, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4,
+  0x04, 0x57, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67, 0x04, 0x65, 0xff, 0xfb,
+  0x04, 0x63, 0x00, 0x1f, 0x06, 0x32, 0x00, 0x6c, 0x04, 0xee, 0x00, 0x36,
+  0x05, 0x97, 0x00, 0xb4, 0x04, 0xef, 0x00, 0x9d, 0x07, 0xb3, 0x00, 0xb4,
+  0x07, 0xe0, 0x00, 0xb4, 0x05, 0xfe, 0x00, 0x36, 0x06, 0x5a, 0x00, 0xb4,
+  0x04, 0xf0, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x63, 0x07, 0xc5, 0x00, 0xbd,
+  0x05, 0x00, 0x00, 0x7a, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x70, 0x00, 0x64,
+  0x04, 0x3e, 0x00, 0xa7, 0x03, 0xc8, 0x00, 0xa7, 0x04, 0xfa, 0x00, 0x60,
+  0x04, 0x6e, 0x00, 0x65, 0x06, 0x7c, 0x00, 0x3f, 0x03, 0xd4, 0x00, 0x77,
+  0x04, 0xad, 0x00, 0xa7, 0x04, 0xad, 0x00, 0xa7, 0x04, 0x59, 0x00, 0xa7,
+  0x04, 0x9a, 0x00, 0x44, 0x05, 0x6e, 0x00, 0xa7, 0x04, 0xb5, 0x00, 0xa7,
+  0x04, 0x67, 0x00, 0x65, 0x04, 0xb5, 0x00, 0xa7, 0x04, 0x92, 0x00, 0xa7,
+  0x03, 0xf5, 0x00, 0x65, 0x04, 0x31, 0x00, 0x36, 0x04, 0x42, 0x00, 0x36,
+  0x06, 0x27, 0x00, 0x64, 0x04, 0x42, 0x00, 0x35, 0x04, 0xe6, 0x00, 0xa7,
+  0x04, 0x41, 0x00, 0x87, 0x06, 0x96, 0x00, 0xa7, 0x06, 0xc8, 0x00, 0xa7,
+  0x05, 0x16, 0x00, 0x37, 0x05, 0xaf, 0x00, 0xa7, 0x04, 0x3e, 0x00, 0xa7,
+  0x03, 0xf3, 0x00, 0x65, 0x06, 0x0f, 0x00, 0xad, 0x04, 0x54, 0x00, 0x68,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x80, 0x00, 0x2a,
+  0x03, 0xc8, 0x00, 0xa7, 0x03, 0xf3, 0x00, 0x65, 0x03, 0xc0, 0x00, 0x63,
+  0x02, 0x00, 0x00, 0xad, 0x02, 0x00, 0xff, 0xf6, 0x02, 0x00, 0xff, 0xdf,
+  0x06, 0x7f, 0x00, 0x44, 0x06, 0x78, 0x00, 0xa7, 0x04, 0xb1, 0x00, 0x2a,
+  0x04, 0x59, 0x00, 0xa7, 0x04, 0xad, 0x00, 0xa7, 0x04, 0x42, 0x00, 0x36,
+  0x04, 0xb5, 0x00, 0xa7, 0x06, 0xb8, 0x00, 0x67, 0x06, 0x07, 0x00, 0x79,
+  0x05, 0x8c, 0x00, 0x1b, 0x04, 0xd6, 0x00, 0x1b, 0x06, 0xc9, 0x00, 0xbd,
+  0x05, 0x64, 0x00, 0xad, 0x06, 0x54, 0x00, 0x0e, 0x05, 0xa3, 0x00, 0x2d,
+  0x08, 0x59, 0x00, 0xb4, 0x07, 0x35, 0x00, 0xad, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x60, 0x07, 0x64, 0x00, 0xb4, 0x05, 0xef, 0x00, 0xad,
+  0x04, 0x94, 0x00, 0x67, 0x03, 0xe4, 0x00, 0x51, 0x06, 0x2a, 0x00, 0x0e,
+  0x06, 0x4f, 0x00, 0x2d, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x05, 0xa0, 0x00, 0x0e, 0x04, 0xc9, 0x00, 0x2d, 0x05, 0xa0, 0x00, 0x0e,
+  0x04, 0xc9, 0x00, 0x2d, 0x07, 0x24, 0x00, 0x67, 0x06, 0x82, 0x00, 0x65,
+  0x06, 0xdc, 0x00, 0x67, 0x05, 0x75, 0x00, 0x65, 0x08, 0x7e, 0x00, 0x6a,
+  0x07, 0x66, 0x00, 0x88, 0x06, 0xb8, 0x00, 0x67, 0x06, 0x07, 0x00, 0x79,
+  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x03, 0x9e, 0x00, 0x35,
+  0x00, 0x00, 0xfc, 0x45, 0x00, 0x00, 0xfd, 0x54, 0x00, 0x00, 0xfd, 0xee,
+  0x00, 0x00, 0xfd, 0xee, 0x00, 0x00, 0xfa, 0x69, 0x03, 0x02, 0xf8, 0xa7,
+  0x03, 0x02, 0xf9, 0x1c, 0x05, 0x8f, 0x00, 0xb4, 0x04, 0xdf, 0x00, 0xad,
+  0x04, 0xf0, 0x00, 0x1d, 0x04, 0x3e, 0x00, 0x22, 0x04, 0x57, 0x00, 0xb4,
+  0x04, 0x92, 0x00, 0xa7, 0x04, 0x64, 0x00, 0xb4, 0x03, 0xc8, 0x00, 0xa7,
+  0x04, 0xdb, 0x00, 0x3f, 0x04, 0x40, 0x00, 0x32, 0x04, 0x7e, 0x00, 0xb4,
+  0x03, 0xd0, 0x00, 0xa7, 0x07, 0xc1, 0x00, 0x24, 0x06, 0x7c, 0x00, 0x3f,
+  0x04, 0x9d, 0x00, 0x79, 0x03, 0xd4, 0x00, 0x77, 0x05, 0x1c, 0x00, 0xb4,
+  0x04, 0x59, 0x00, 0xa7, 0x05, 0x1c, 0x00, 0xb4, 0x04, 0x59, 0x00, 0xa7,
+  0x05, 0x1c, 0x00, 0x1d, 0x04, 0x59, 0x00, 0x36, 0x06, 0x2a, 0x00, 0x2d,
+  0x05, 0xfc, 0x00, 0x25, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0xc1, 0x00, 0xad,
+  0x07, 0x4d, 0x00, 0xb4, 0x06, 0x50, 0x00, 0xad, 0x07, 0xc8, 0x00, 0xb4,
+  0x06, 0x97, 0x00, 0xad, 0x06, 0x52, 0x00, 0x67, 0x04, 0xfd, 0x00, 0x65,
+  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x65, 0xff, 0xfb,
+  0x04, 0x31, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x04, 0xee, 0x00, 0x36,
+  0x04, 0x42, 0x00, 0x35, 0x06, 0xb9, 0xff, 0xfb, 0x05, 0xce, 0x00, 0x04,
+  0x04, 0xef, 0x00, 0x9d, 0x04, 0x41, 0x00, 0x87, 0x04, 0xef, 0x00, 0x9d,
+  0x04, 0x41, 0x00, 0x87, 0x04, 0xef, 0x00, 0x9d, 0x04, 0x90, 0x00, 0xa7,
+  0x06, 0xc6, 0x00, 0x12, 0x05, 0x3d, 0x00, 0x0d, 0x06, 0xc6, 0x00, 0x12,
+  0x05, 0x3d, 0x00, 0x0d, 0x02, 0x1f, 0x00, 0xb4, 0x07, 0xc1, 0x00, 0x24,
+  0x06, 0x7c, 0x00, 0x3f, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x59, 0x00, 0xab,
+  0x05, 0x96, 0x00, 0x30, 0x04, 0xd3, 0x00, 0x29, 0x05, 0x6a, 0x00, 0xb4,
+  0x04, 0xc1, 0x00, 0xad, 0x05, 0x97, 0x00, 0xb4, 0x04, 0xe6, 0x00, 0xad,
+  0x04, 0xef, 0x00, 0x9d, 0x04, 0x41, 0x00, 0x87, 0x06, 0x64, 0x00, 0xb4,
+  0x05, 0x93, 0x00, 0xad, 0x02, 0x00, 0x00, 0xad, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x07, 0x03, 0x00, 0x07, 0x07, 0x11, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x69, 0x04, 0x6e, 0x00, 0x65,
+  0x05, 0xaa, 0x00, 0x69, 0x04, 0x6e, 0x00, 0x65, 0x07, 0xc1, 0x00, 0x24,
+  0x06, 0x7c, 0x00, 0x3f, 0x04, 0x9d, 0x00, 0x79, 0x03, 0xd4, 0x00, 0x77,
+  0x04, 0xcb, 0x00, 0x90, 0x04, 0x28, 0x00, 0x4f, 0x05, 0x62, 0x00, 0xb4,
+  0x04, 0xad, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4, 0x04, 0xad, 0x00, 0xa7,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x05, 0x07, 0x00, 0x63, 0x03, 0xf3, 0x00, 0x65, 0x04, 0x63, 0x00, 0x1f,
+  0x04, 0x42, 0x00, 0x36, 0x04, 0x63, 0x00, 0x1f, 0x04, 0x42, 0x00, 0x36,
+  0x04, 0x63, 0x00, 0x1f, 0x04, 0x42, 0x00, 0x36, 0x04, 0xef, 0x00, 0x9d,
+  0x04, 0x41, 0x00, 0x87, 0x04, 0x64, 0x00, 0xb4, 0x03, 0xc8, 0x00, 0xa7,
+  0x06, 0x5a, 0x00, 0xb4, 0x05, 0xaf, 0x00, 0xa7, 0x04, 0xdb, 0x00, 0x3f,
+  0x04, 0x40, 0x00, 0x32, 0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35,
+  0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35, 0x04, 0xf0, 0x00, 0x82,
+  0x04, 0x3e, 0x00, 0x65, 0x07, 0x3e, 0x00, 0x82, 0x06, 0x75, 0x00, 0x65,
+  0x07, 0x04, 0x00, 0xb4, 0x06, 0x42, 0x00, 0x99, 0x04, 0xe3, 0x00, 0xb4,
+  0x04, 0x3c, 0x00, 0x99, 0x07, 0xb7, 0x00, 0x30, 0x06, 0xe4, 0x00, 0x29,
+  0x08, 0x03, 0x00, 0xb4, 0x06, 0xf6, 0x00, 0xad, 0x05, 0x94, 0x00, 0x67,
+  0x04, 0xbf, 0x00, 0x65, 0x05, 0x90, 0xff, 0xfb, 0x05, 0x1e, 0x00, 0x04,
+  0x04, 0x6c, 0x00, 0x93, 0x03, 0xe4, 0x00, 0x77, 0x05, 0x6a, 0x00, 0x4b,
+  0x04, 0x9a, 0x00, 0x44, 0x08, 0x6a, 0x00, 0x4b, 0x07, 0x27, 0x00, 0x44,
+  0x06, 0x6f, 0x00, 0xb4, 0x06, 0x39, 0x00, 0xa7, 0x07, 0x6d, 0x00, 0x7a,
+  0x07, 0x19, 0x00, 0x68, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
+  0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d, 0x05, 0x1c, 0x00, 0xb4,
+  0x04, 0x59, 0x00, 0xa7, 0x07, 0xc7, 0x00, 0x4b, 0x06, 0x84, 0x00, 0x44,
+  0x07, 0xc8, 0x00, 0xb4, 0x06, 0x91, 0x00, 0xa7, 0x05, 0xb5, 0x00, 0xb4,
+  0x04, 0xea, 0x00, 0xa7, 0x04, 0x42, 0x00, 0x36, 0x05, 0x2a, 0x00, 0x09,
+  0x07, 0x11, 0x00, 0x6e, 0x04, 0x38, 0x00, 0x37, 0x03, 0xf5, 0x00, 0x65,
+  0x04, 0x5b, 0x00, 0xa7, 0x04, 0x5b, 0x00, 0x20, 0x03, 0x88, 0x00, 0xa7,
+  0x03, 0xe4, 0x00, 0x75, 0x02, 0x00, 0x00, 0xad, 0x02, 0xd7, 0x00, 0x00,
+  0x04, 0x2b, 0x00, 0xa7, 0x04, 0x32, 0x00, 0x01, 0x05, 0x6e, 0x00, 0xa7,
+  0x04, 0xad, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x03, 0xf5, 0x00, 0x72,
+  0x04, 0xec, 0x00, 0x65, 0x04, 0xec, 0x00, 0x65, 0x04, 0xec, 0x00, 0x2d,
+  0x07, 0x5d, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
+  0x03, 0xc6, 0x00, 0x87, 0x04, 0x54, 0x00, 0x2d, 0x04, 0x54, 0x00, 0x2d,
+  0x04, 0x31, 0x00, 0x36, 0x04, 0x22, 0x00, 0xa7, 0x05, 0x4e, 0x00, 0x9c,
+  0x06, 0xd2, 0x00, 0x9c, 0x04, 0x97, 0x00, 0x2a, 0x04, 0x42, 0x00, 0x36,
+  0x05, 0xe3, 0x00, 0x4d, 0x03, 0xc7, 0x00, 0x4f, 0x03, 0xc9, 0x00, 0x6c,
+  0x04, 0x32, 0x00, 0xa1, 0x04, 0x42, 0x00, 0x36, 0x04, 0x0f, 0x00, 0x87,
+  0x03, 0xc6, 0x00, 0x87, 0x04, 0x40, 0x00, 0x51, 0x04, 0x9a, 0x00, 0x44,
+  0x03, 0x19, 0x00, 0x09, 0x04, 0x6a, 0x00, 0x04, 0x03, 0x1c, 0x00, 0x72,
+  0x03, 0x7d, 0x00, 0x72, 0x02, 0xdd, 0x00, 0x72, 0x02, 0xdd, 0x00, 0x4a,
+  0x03, 0x83, 0x00, 0x40, 0x03, 0x69, 0x00, 0x72, 0x01, 0x56, 0x00, 0x72,
+  0x01, 0x56, 0xff, 0xc4, 0x02, 0xf9, 0x00, 0x72, 0x02, 0x86, 0x00, 0x72,
+  0x03, 0xe9, 0x00, 0x72, 0x03, 0x64, 0x00, 0x72, 0x03, 0x64, 0x00, 0x72,
+  0x03, 0x91, 0x00, 0x40, 0x03, 0x2a, 0x00, 0x3f, 0x02, 0xbc, 0x00, 0x72,
+  0x03, 0x26, 0x00, 0x72, 0x02, 0xc5, 0xff, 0xfd, 0x03, 0x51, 0x00, 0x64,
+  0x04, 0x7b, 0x00, 0x26, 0x02, 0xd1, 0x00, 0x45, 0x02, 0xd1, 0x00, 0x45,
+  0x02, 0xeb, 0x00, 0x3f, 0x04, 0xaa, 0x00, 0x45, 0x03, 0x15, 0x00, 0x69,
+  0x02, 0xeb, 0x00, 0x3f, 0x03, 0x00, 0x00, 0x3f, 0x03, 0x00, 0x00, 0x3f,
+  0x02, 0x98, 0x00, 0x4b, 0x02, 0x96, 0x00, 0x49, 0x02, 0xeb, 0x00, 0x3f,
+  0x01, 0x49, 0x00, 0x6d, 0x03, 0x10, 0x00, 0x69, 0x04, 0x7c, 0x00, 0x69,
+  0x02, 0xf1, 0x00, 0x69, 0x02, 0xfa, 0x00, 0x3f, 0x02, 0xaa, 0x00, 0x3f,
+  0x02, 0xfa, 0x00, 0x3f, 0x02, 0xfa, 0x00, 0x3f, 0x03, 0x15, 0x00, 0x69,
+  0x02, 0x1f, 0x00, 0x1f, 0x02, 0xea, 0x00, 0x63, 0x03, 0x61, 0x00, 0x63,
+  0x04, 0x7c, 0x00, 0x69, 0x03, 0x00, 0x00, 0x22, 0x02, 0xe4, 0x00, 0x6c,
+  0x02, 0xae, 0x00, 0x12, 0x02, 0xc6, 0x00, 0x3f, 0x02, 0xfd, 0x00, 0x3f,
+  0x02, 0x9e, 0x00, 0x21, 0x01, 0x49, 0x00, 0x6d, 0x01, 0xdd, 0x00, 0x69,
+  0x02, 0xea, 0x00, 0x63, 0x03, 0x00, 0x00, 0x22, 0x02, 0xe4, 0x00, 0x6c,
+  0x02, 0xae, 0x00, 0x12, 0x02, 0xf6, 0x00, 0x6c, 0x02, 0xfd, 0x00, 0x3f,
+  0x02, 0x9e, 0x00, 0x21, 0x04, 0x92, 0x00, 0xa7, 0x03, 0x69, 0x00, 0x72,
+  0x02, 0xac, 0x00, 0x68, 0x04, 0xcd, 0x00, 0x2d, 0x02, 0x00, 0x00, 0x82,
+  0x02, 0xeb, 0x00, 0x3f, 0x02, 0xaa, 0x00, 0x3f, 0x02, 0xaa, 0x00, 0x3f,
+  0x02, 0xfa, 0x00, 0x3f, 0x02, 0x98, 0x00, 0x4b, 0x02, 0x22, 0x00, 0x1b,
+  0x01, 0xad, 0xff, 0xec, 0x02, 0xeb, 0x00, 0x3f, 0x02, 0xea, 0x00, 0x63,
+  0x01, 0xe1, 0x00, 0x41, 0x01, 0xcb, 0x00, 0x6d, 0x01, 0xe0, 0x00, 0x41,
+  0x01, 0xe1, 0x00, 0x41, 0x01, 0xb0, 0xff, 0x67, 0x01, 0xcb, 0x00, 0x6d,
+  0x01, 0xb0, 0x00, 0x51, 0x02, 0xb5, 0x00, 0x65, 0x04, 0x7c, 0x00, 0x69,
+  0x04, 0x7c, 0x00, 0x69, 0x02, 0xf4, 0xff, 0xec, 0x03, 0x73, 0x00, 0x69,
+  0x02, 0xf1, 0x00, 0x65, 0x02, 0xfa, 0x00, 0x3f, 0x02, 0xfa, 0x00, 0x3f,
+  0x02, 0x98, 0x00, 0x3f, 0x02, 0x10, 0xff, 0xec, 0x02, 0x1f, 0x00, 0x1f,
+  0x03, 0xa8, 0x00, 0x54, 0x03, 0x03, 0x00, 0x3f, 0x02, 0x9a, 0x00, 0x69,
+  0x02, 0xec, 0x00, 0x6d, 0x03, 0x00, 0x00, 0x22, 0x02, 0xa3, 0x00, 0x31,
+  0x03, 0x24, 0x00, 0x31, 0x02, 0xa3, 0x00, 0x31, 0x02, 0xd2, 0x00, 0x31,
+  0x02, 0xfa, 0x00, 0x3f, 0x00, 0x00, 0xfc, 0xb9, 0x00, 0x00, 0xfc, 0xb9,
+  0x00, 0x00, 0xfc, 0xb9, 0x00, 0x00, 0xfc, 0xb9, 0x00, 0x00, 0xfc, 0xa2,
+  0x00, 0x00, 0xfc, 0xa2, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa5, 0x04, 0xf0, 0x00, 0xb4,
+  0x04, 0x92, 0x00, 0xa7, 0x04, 0xf0, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7,
+  0x05, 0x07, 0x00, 0x67, 0x03, 0xf5, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4,
+  0x04, 0x92, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65,
+  0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4,
+  0x04, 0x92, 0x00, 0x65, 0x05, 0x8b, 0x00, 0xb4, 0x04, 0x92, 0x00, 0x65,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x24, 0x00, 0xb4, 0x02, 0x88, 0x00, 0x2a,
+  0x05, 0x94, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65, 0x05, 0x6a, 0x00, 0xb4,
+  0x04, 0x90, 0x00, 0xa5, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0xff, 0xef, 0x05, 0x6a, 0x00, 0x0f,
+  0x04, 0x90, 0x00, 0x01, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x02, 0x1f, 0x00, 0x00, 0x02, 0x00, 0xff, 0xd8, 0x02, 0x1f, 0x00, 0x06,
+  0x02, 0x00, 0xff, 0xf6, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa7,
+  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa7, 0x04, 0xb8, 0x00, 0xb4,
+  0x04, 0x2b, 0x00, 0xa7, 0x04, 0x02, 0x00, 0xb4, 0x02, 0x12, 0x00, 0xb4,
+  0x04, 0x02, 0x00, 0x02, 0x02, 0x12, 0xff, 0xfe, 0x04, 0x02, 0x00, 0xb4,
+  0x02, 0x00, 0xff, 0xf6, 0x04, 0x02, 0x00, 0xb4, 0x02, 0x00, 0xff, 0xe2,
+  0x06, 0x36, 0x00, 0xb4, 0x07, 0x03, 0x00, 0xa7, 0x06, 0x36, 0x00, 0xb4,
+  0x07, 0x03, 0x00, 0xa7, 0x06, 0x36, 0x00, 0xb4, 0x07, 0x03, 0x00, 0xa7,
+  0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4,
+  0x04, 0x90, 0x00, 0xa7, 0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x05, 0x62, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x04, 0x57, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7,
+  0x04, 0x57, 0x00, 0xb4, 0x04, 0x92, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4,
+  0x02, 0xf5, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7,
+  0x05, 0x00, 0x00, 0xb4, 0x02, 0xf5, 0x00, 0xa7, 0x05, 0x00, 0x00, 0xb4,
+  0x02, 0xf5, 0x00, 0x4b, 0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63,
+  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79,
+  0x03, 0xc0, 0x00, 0x63, 0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63,
+  0x04, 0x92, 0x00, 0x79, 0x03, 0xc0, 0x00, 0x63, 0x04, 0x65, 0xff, 0xfb,
+  0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31,
+  0x04, 0x65, 0xff, 0xfb, 0x02, 0xd2, 0x00, 0x31, 0x04, 0x65, 0xff, 0xfb,
+  0x02, 0xd2, 0x00, 0x31, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
+  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0x90, 0x00, 0x9c, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
+  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x42, 0x00, 0x36, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x42, 0x00, 0x36,
+  0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d, 0x07, 0x1e, 0x00, 0x3d,
+  0x05, 0xe3, 0x00, 0x4d, 0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d,
+  0x07, 0x1e, 0x00, 0x3d, 0x05, 0xe3, 0x00, 0x4d, 0x07, 0x1e, 0x00, 0x3d,
+  0x05, 0xe3, 0x00, 0x4d, 0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35,
+  0x04, 0xee, 0x00, 0x36, 0x04, 0x42, 0x00, 0x35, 0x04, 0x65, 0xff, 0xfd,
+  0x04, 0x42, 0x00, 0x36, 0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f,
+  0x04, 0xee, 0x00, 0x52, 0x03, 0xc7, 0x00, 0x4f, 0x04, 0xee, 0x00, 0x52,
+  0x03, 0xc7, 0x00, 0x4f, 0x04, 0x90, 0x00, 0xa7, 0x02, 0xd2, 0x00, 0x03,
+  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x36, 0x04, 0x69, 0x00, 0x6e,
+  0x02, 0x88, 0x00, 0x2a, 0x02, 0x88, 0x00, 0x01, 0x02, 0x88, 0x00, 0x2a,
+  0x05, 0x88, 0x00, 0xa0, 0x04, 0x67, 0x00, 0x65, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0x69, 0x00, 0x6e, 0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x69, 0x00, 0x6e, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4,
+  0x04, 0x6e, 0x00, 0x65, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x6e, 0x00, 0x65,
+  0x02, 0x1f, 0x00, 0x51, 0x02, 0x00, 0x00, 0x3d, 0x02, 0x1f, 0x00, 0xb4,
+  0x02, 0x00, 0x00, 0xab, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x67, 0x00, 0x65,
+  0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a, 0x06, 0x93, 0x00, 0x5c,
+  0x04, 0x67, 0x00, 0x6a, 0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a,
+  0x06, 0x93, 0x00, 0x5c, 0x04, 0x67, 0x00, 0x6a, 0x06, 0x93, 0x00, 0x5c,
+  0x04, 0x67, 0x00, 0x6a, 0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c,
+  0x05, 0x45, 0x00, 0xa0, 0x04, 0x90, 0x00, 0x9c, 0x06, 0x2d, 0x00, 0x9b,
+  0x04, 0x90, 0x00, 0x9e, 0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e,
+  0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e, 0x06, 0x2d, 0x00, 0x9b,
+  0x04, 0x90, 0x00, 0x9e, 0x06, 0x2d, 0x00, 0x9b, 0x04, 0x90, 0x00, 0x9e,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd,
+  0x04, 0x42, 0x00, 0x36, 0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0x42, 0x00, 0x36, 0x05, 0x89, 0x00, 0xb4,
+  0x03, 0x6f, 0x00, 0x1c, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e, 0x06, 0x51, 0x00, 0x04,
+  0x06, 0x51, 0x00, 0x05, 0x05, 0x89, 0x00, 0x06, 0x05, 0xc4, 0x00, 0x04,
+  0x05, 0x19, 0x00, 0x06, 0x05, 0x58, 0x00, 0x03, 0x03, 0xe4, 0x00, 0x77,
+  0x03, 0xe4, 0x00, 0x77, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xe4, 0x00, 0x77,
+  0x03, 0xe4, 0x00, 0x77, 0x03, 0xe4, 0x00, 0x77, 0x05, 0x1e, 0x00, 0x06,
+  0x05, 0x1e, 0x00, 0x06, 0x06, 0xf4, 0x00, 0x04, 0x07, 0x04, 0x00, 0x05,
+  0x06, 0x78, 0x00, 0x06, 0x06, 0xae, 0x00, 0x04, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x06, 0x06, 0x00, 0x06, 0x06, 0x03, 0x00, 0x06,
+  0x07, 0xd1, 0x00, 0x04, 0x07, 0xd7, 0x00, 0x05, 0x07, 0x64, 0x00, 0x06,
+  0x07, 0x90, 0x00, 0x04, 0x06, 0xb8, 0x00, 0x06, 0x06, 0xd1, 0x00, 0x03,
+  0x02, 0x6f, 0x00, 0x8b, 0x02, 0x6f, 0x00, 0x82, 0x02, 0x6f, 0xff, 0xb9,
+  0x02, 0x6f, 0xff, 0xc2, 0x02, 0x6f, 0x00, 0x04, 0x02, 0x6f, 0xff, 0xd8,
+  0x02, 0x6f, 0xff, 0xd1, 0x02, 0x6f, 0xff, 0xcc, 0x02, 0xbc, 0x00, 0x06,
+  0x02, 0xb1, 0x00, 0x06, 0x04, 0x92, 0x00, 0x04, 0x04, 0x92, 0x00, 0x05,
+  0x04, 0x1b, 0x00, 0x06, 0x04, 0x51, 0x00, 0x04, 0x03, 0x85, 0x00, 0x06,
+  0x03, 0x8c, 0x00, 0x03, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0xca, 0x00, 0x06, 0x06, 0x1b, 0x00, 0x06,
+  0x07, 0xe1, 0x00, 0x04, 0x07, 0xea, 0x00, 0x05, 0x06, 0xc1, 0x00, 0x06,
+  0x06, 0xfc, 0x00, 0x04, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
+  0x05, 0xa4, 0x00, 0x06, 0x07, 0x2e, 0x00, 0x05, 0x07, 0x49, 0x00, 0x04,
+  0x06, 0x76, 0x00, 0x03, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
+  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
+  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
+  0x05, 0xc6, 0x00, 0x06, 0x06, 0x12, 0x00, 0x06, 0x07, 0xd7, 0x00, 0x04,
+  0x07, 0xe2, 0x00, 0x05, 0x06, 0xcf, 0x00, 0x06, 0x06, 0xff, 0x00, 0x04,
+  0x06, 0xa2, 0x00, 0x06, 0x06, 0xdb, 0x00, 0x03, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xbf, 0x00, 0x65, 0x03, 0xe4, 0x00, 0x77, 0x03, 0xf2, 0x00, 0x77,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0xb6, 0x00, 0xa7, 0x02, 0x6f, 0xff, 0x99,
+  0x02, 0x6f, 0x00, 0x95, 0x04, 0x67, 0x00, 0x65, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x06, 0x07, 0x00, 0x79,
+  0x06, 0x07, 0x00, 0x79, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0xec, 0x00, 0x0e, 0x06, 0x51, 0x00, 0x04,
+  0x06, 0x51, 0x00, 0x05, 0x05, 0x89, 0x00, 0x06, 0x05, 0xc4, 0x00, 0x04,
+  0x05, 0x19, 0x00, 0x06, 0x05, 0x58, 0x00, 0x03, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x06, 0x06, 0x00, 0x06, 0x06, 0x03, 0x00, 0x06,
+  0x07, 0xd1, 0x00, 0x04, 0x07, 0xd7, 0x00, 0x05, 0x07, 0x64, 0x00, 0x06,
+  0x07, 0x90, 0x00, 0x04, 0x06, 0xb8, 0x00, 0x06, 0x06, 0xd1, 0x00, 0x03,
+  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
+  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
+  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x05, 0xc6, 0x00, 0x06,
+  0x06, 0x12, 0x00, 0x06, 0x07, 0xd7, 0x00, 0x04, 0x07, 0xe2, 0x00, 0x05,
+  0x06, 0xcf, 0x00, 0x06, 0x06, 0xff, 0x00, 0x04, 0x06, 0xa2, 0x00, 0x06,
+  0x06, 0xdb, 0x00, 0x03, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65,
+  0x04, 0xbf, 0x00, 0x65, 0x04, 0xbf, 0x00, 0x65, 0x04, 0xec, 0x00, 0x0e,
+  0x04, 0xec, 0x00, 0x0e, 0x05, 0x28, 0xff, 0xfd, 0x04, 0xfc, 0x00, 0x0e,
+  0x04, 0xec, 0x00, 0x0e, 0x03, 0x99, 0x01, 0x5f, 0x03, 0x99, 0x01, 0x8a,
+  0x03, 0x99, 0x01, 0x5f, 0x03, 0x99, 0x00, 0xa3, 0x03, 0x99, 0x00, 0xa3,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x04, 0xb6, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x90, 0x00, 0xa7, 0x05, 0xcb, 0xff, 0xfd,
+  0x05, 0x5f, 0xff, 0xea, 0x06, 0xb3, 0xff, 0xfd, 0x06, 0x45, 0xff, 0xf5,
+  0x05, 0x6a, 0x00, 0xb4, 0x03, 0x99, 0x00, 0x7b, 0x03, 0x99, 0x00, 0xa2,
+  0x03, 0x99, 0x00, 0xa3, 0x02, 0x6f, 0xff, 0xee, 0x02, 0x6f, 0xff, 0xe6,
+  0x02, 0x6f, 0xff, 0xdc, 0x02, 0x6f, 0x00, 0x04, 0x02, 0x6f, 0xff, 0xe7,
+  0x02, 0x6f, 0xff, 0xe9, 0x02, 0x1f, 0xff, 0xf7, 0x02, 0x1f, 0x00, 0x02,
+  0x03, 0x6b, 0xff, 0xfd, 0x02, 0xf0, 0xff, 0xef, 0x03, 0x99, 0x00, 0x71,
+  0x03, 0x99, 0x00, 0x86, 0x03, 0x99, 0x00, 0xa3, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0x92, 0x00, 0xa7, 0x04, 0x92, 0x00, 0xa7, 0x04, 0x2a, 0x00, 0x86,
+  0x04, 0x2a, 0x00, 0x86, 0x04, 0x65, 0xff, 0xfd, 0x04, 0x65, 0xff, 0xfd,
+  0x06, 0x15, 0xff, 0xfd, 0x05, 0xf0, 0xff, 0xe5, 0x04, 0xee, 0x00, 0x06,
+  0x03, 0x99, 0x00, 0x99, 0x03, 0x99, 0x00, 0xc1, 0x03, 0x99, 0x00, 0x99,
+  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79,
+  0x06, 0x07, 0x00, 0x79, 0x06, 0x07, 0x00, 0x79, 0x06, 0xc6, 0xff, 0xfd,
+  0x05, 0xd9, 0xff, 0xf4, 0x06, 0xa4, 0xff, 0xfd, 0x05, 0xf1, 0xff, 0xdf,
+  0x05, 0x80, 0x00, 0x46, 0x03, 0x99, 0x01, 0x4d, 0x03, 0x99, 0x01, 0x5f,
+  0x03, 0x99, 0x00, 0x00, 0x07, 0x33, 0x00, 0x00, 0x03, 0x99, 0x00, 0x00,
+  0x07, 0x33, 0x00, 0x00, 0x02, 0x5f, 0x00, 0x00, 0x01, 0xcc, 0x00, 0x00,
+  0x01, 0x33, 0x00, 0x00, 0x04, 0x94, 0x00, 0x00, 0x02, 0x49, 0x00, 0x00,
+  0x01, 0x70, 0x00, 0x00, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x02, 0x99, 0x00, 0x5a, 0x02, 0x99, 0x00, 0x5a,
+  0x04, 0x94, 0x00, 0x5a, 0x03, 0x99, 0x00, 0x5a, 0x07, 0x33, 0x00, 0x5a,
+  0x07, 0x33, 0x00, 0x00, 0x03, 0x99, 0x00, 0xea, 0x03, 0x99, 0xff, 0xee,
+  0x02, 0x49, 0x00, 0x9c, 0x02, 0x49, 0x00, 0xa0, 0x02, 0x49, 0x00, 0x9c,
+  0x02, 0x49, 0x00, 0xa0, 0x03, 0xba, 0x00, 0x9c, 0x03, 0xba, 0x00, 0x9c,
+  0x03, 0xba, 0x00, 0x9c, 0x03, 0xba, 0x00, 0x9c, 0x03, 0x99, 0x00, 0x33,
+  0x03, 0x99, 0x00, 0x33, 0x04, 0x3f, 0x01, 0x14, 0x04, 0x3f, 0x01, 0x14,
+  0x02, 0x68, 0x00, 0xd4, 0x04, 0xce, 0x00, 0xd4, 0x07, 0x33, 0x00, 0xd4,
+  0x02, 0x49, 0x00, 0xc6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x70, 0x00, 0x00,
+  0x09, 0xa9, 0x00, 0x65, 0x0c, 0x7e, 0x00, 0x65, 0x01, 0xa2, 0x00, 0x24,
+  0x02, 0xb0, 0x00, 0x24, 0x03, 0xbe, 0x00, 0x24, 0x01, 0xa2, 0x00, 0x24,
+  0x02, 0xb0, 0x00, 0x24, 0x03, 0xbe, 0x00, 0x24, 0x02, 0x70, 0x00, 0x09,
+  0x02, 0xe1, 0x00, 0x8e, 0x02, 0xe1, 0x00, 0xad, 0x06, 0x08, 0x00, 0xaf,
+  0x03, 0x7e, 0x00, 0x84, 0x03, 0xd2, 0x00, 0x84, 0x03, 0x99, 0xff, 0xee,
+  0x05, 0xc9, 0xff, 0xb0, 0x05, 0xc9, 0xff, 0xb0, 0x01, 0xcc, 0xff, 0xb3,
+  0x07, 0x33, 0x00, 0x36, 0x03, 0x99, 0x00, 0xc6, 0x01, 0x33, 0xfe, 0xaf,
+  0x02, 0xcf, 0x00, 0x9e, 0x02, 0xcf, 0x00, 0x9e, 0x06, 0xa3, 0x00, 0x42,
+  0x05, 0x46, 0x00, 0x84, 0x05, 0x46, 0x00, 0x84, 0x03, 0x94, 0x00, 0x5a,
+  0x04, 0x94, 0x00, 0xd4, 0x03, 0x99, 0x00, 0xc2, 0x03, 0x99, 0x00, 0xc2,
+  0x03, 0x99, 0x00, 0x36, 0x02, 0x6d, 0x01, 0x00, 0x05, 0xc9, 0xff, 0xb0,
+  0x03, 0x99, 0x00, 0x36, 0x03, 0x3c, 0x00, 0x82, 0x07, 0x33, 0x00, 0x5a,
+  0x05, 0xc9, 0xff, 0xb0, 0x06, 0x08, 0x01, 0x18, 0x04, 0x38, 0x00, 0xe1,
+  0x04, 0xc6, 0x00, 0x24, 0x06, 0x08, 0x01, 0x42, 0x06, 0x08, 0x01, 0x42,
+  0x02, 0x49, 0x00, 0xc5, 0x05, 0xbd, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x64,
+  0x02, 0x49, 0x00, 0xc5, 0x02, 0x49, 0x00, 0xc5, 0x01, 0x99, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xe2, 0x00, 0x4e,
+  0x01, 0x49, 0x00, 0x6d, 0x02, 0xe2, 0x00, 0x38, 0x02, 0xe2, 0x00, 0x5b,
+  0x02, 0xe2, 0x00, 0x52, 0x02, 0xe2, 0x00, 0x61, 0x02, 0xe2, 0x00, 0x50,
+  0x02, 0xe2, 0x00, 0x4a, 0x03, 0xcc, 0x00, 0x7b, 0x03, 0xcc, 0x00, 0x7b,
+  0x03, 0xcc, 0x00, 0x7b, 0x01, 0xc4, 0x00, 0x63, 0x01, 0xc4, 0x00, 0x5c,
+  0x02, 0xde, 0x00, 0x69, 0x02, 0xe2, 0x00, 0x4e, 0x02, 0xe2, 0x00, 0x7b,
+  0x02, 0xe2, 0x00, 0x54, 0x02, 0xe2, 0x00, 0x58, 0x02, 0xe2, 0x00, 0x38,
+  0x02, 0xe2, 0x00, 0x5b, 0x02, 0xe2, 0x00, 0x52, 0x02, 0xe2, 0x00, 0x61,
+  0x02, 0xe2, 0x00, 0x50, 0x02, 0xe2, 0x00, 0x4a, 0x03, 0xcc, 0x00, 0x7b,
+  0x03, 0xcc, 0x00, 0x7b, 0x03, 0xcc, 0x00, 0x7b, 0x01, 0xc4, 0x00, 0x63,
+  0x01, 0xc4, 0x00, 0x5c, 0x02, 0xd1, 0x00, 0x45, 0x03, 0x00, 0x00, 0x3f,
+  0x02, 0xfa, 0x00, 0x3f, 0x03, 0x32, 0x00, 0x69, 0x03, 0x00, 0x00, 0x3f,
+  0x02, 0xe9, 0x00, 0x69, 0x03, 0x10, 0x00, 0x69, 0x01, 0x32, 0x00, 0x6d,
+  0x04, 0x7c, 0x00, 0x69, 0x02, 0xde, 0x00, 0x69, 0x03, 0x15, 0x00, 0x69,
+  0x02, 0xaf, 0x00, 0x69, 0x02, 0x1f, 0x00, 0x1f, 0x06, 0x50, 0x00, 0x4d,
+  0x04, 0x94, 0x00, 0x67, 0x04, 0x94, 0x00, 0x56, 0x04, 0x94, 0x00, 0x77,
+  0x04, 0x94, 0x00, 0x74, 0x07, 0x03, 0x00, 0xa7, 0x05, 0x62, 0x00, 0x69,
+  0x09, 0x29, 0x00, 0xb4, 0x07, 0xbb, 0x00, 0xb4, 0x07, 0x1e, 0x00, 0x35,
+  0x05, 0xa5, 0x00, 0x55, 0x04, 0x94, 0x00, 0x65, 0x04, 0x94, 0x00, 0x00,
+  0x04, 0x94, 0x00, 0x24, 0x04, 0x94, 0x00, 0x12, 0x09, 0x29, 0x00, 0xbb,
+  0x04, 0x94, 0x00, 0x29, 0x04, 0x94, 0x00, 0x3d, 0x04, 0x94, 0x00, 0x53,
+  0x04, 0x94, 0x00, 0x0e, 0x05, 0x92, 0x00, 0x69, 0x04, 0x94, 0x00, 0x94,
+  0x04, 0x94, 0x00, 0x12, 0x04, 0x94, 0x00, 0x5f, 0x04, 0xe3, 0x00, 0x09,
+  0x00, 0x00, 0xfc, 0x77, 0x00, 0x00, 0xfc, 0x9e, 0x00, 0x00, 0xfc, 0x9e,
+  0x00, 0x00, 0xfc, 0x9e, 0x00, 0x00, 0xfc, 0x78, 0x00, 0x00, 0xfb, 0xc8,
+  0x00, 0x00, 0xfc, 0x9e, 0x07, 0x55, 0x00, 0x3c, 0x07, 0x55, 0x00, 0x3c,
+  0x05, 0x07, 0x00, 0x67, 0x08, 0x16, 0x00, 0xaf, 0x04, 0x9f, 0xff, 0xdb,
+  0x07, 0x55, 0x00, 0x36, 0x07, 0xae, 0x00, 0x36, 0x04, 0x6c, 0x00, 0x93,
+  0x05, 0x07, 0x00, 0x63, 0x06, 0xda, 0x00, 0xaf, 0x07, 0x1d, 0x00, 0x41,
+  0x05, 0x6e, 0x00, 0x01, 0x06, 0x1e, 0x00, 0xb4, 0x04, 0x90, 0x00, 0x40,
+  0x04, 0x90, 0x00, 0x51, 0x03, 0x61, 0x00, 0x35, 0x05, 0x05, 0x00, 0x5f,
+  0x05, 0x2f, 0x00, 0x3d, 0x02, 0xf9, 0xff, 0xe7, 0x05, 0xe3, 0x00, 0x1c,
+  0x05, 0xc4, 0x00, 0xb2, 0x07, 0x7d, 0x00, 0x30, 0x07, 0x33, 0x00, 0xfe,
+  0x05, 0x05, 0x00, 0x63, 0x05, 0x0c, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67,
+  0x05, 0xbe, 0x00, 0x3b, 0x05, 0xdc, 0x00, 0x4a, 0x05, 0xb3, 0x00, 0xb4,
+  0x06, 0x74, 0x00, 0x98, 0x04, 0xec, 0x00, 0xb4, 0x07, 0x57, 0x00, 0xe9,
+  0x07, 0xbc, 0xff, 0xfd, 0x07, 0x33, 0x01, 0x09, 0x04, 0xec, 0x00, 0x0e,
+  0x05, 0x5c, 0x00, 0x52, 0x04, 0x28, 0x00, 0x4f, 0x05, 0x80, 0x00, 0x46,
+  0x05, 0x80, 0x00, 0x46, 0x04, 0x6f, 0x00, 0x15, 0x02, 0x6f, 0x00, 0x3d,
+  0x04, 0xb8, 0x00, 0xb4, 0x04, 0xec, 0x00, 0x0e, 0x05, 0xa9, 0x00, 0x52,
+  0x05, 0x10, 0x00, 0x75, 0x06, 0x27, 0x00, 0x70, 0x04, 0x42, 0x00, 0x4e,
+  0x04, 0x5c, 0x00, 0x91, 0x05, 0xa9, 0x00, 0x4b, 0x04, 0x24, 0x00, 0xb4,
+  0x07, 0xb3, 0x00, 0x33, 0x03, 0x53, 0x00, 0x5d, 0x05, 0x5d, 0x00, 0x5c,
+  0x04, 0xda, 0xff, 0xfc, 0x03, 0x5a, 0x00, 0x18, 0x04, 0xa4, 0x00, 0x4d,
+  0x02, 0xbc, 0x00, 0x3f, 0x06, 0xaa, 0x00, 0x51, 0x08, 0x98, 0x00, 0x87,
+  0x05, 0x0e, 0x00, 0x20, 0x05, 0x3d, 0x00, 0x00, 0x04, 0xb6, 0x00, 0xb4,
+  0x06, 0x1c, 0x00, 0xb4, 0x05, 0xd6, 0x00, 0x16, 0x05, 0x94, 0x00, 0x92,
+  0x04, 0x02, 0x00, 0x07, 0x04, 0x02, 0x00, 0x06, 0x04, 0x65, 0xff, 0xfd,
+  0x05, 0xe5, 0x00, 0x4e, 0x05, 0x19, 0x00, 0x51, 0x04, 0x6e, 0x00, 0x51,
+  0x02, 0x87, 0x00, 0x47, 0x02, 0x87, 0xff, 0x2e, 0x05, 0x9d, 0x00, 0x35,
+  0x03, 0xca, 0x00, 0x48, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x7b,
+  0x09, 0xdd, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x54,
+  0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x54, 0x06, 0xfa, 0x00, 0x58,
+  0x06, 0xfa, 0x00, 0x38, 0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x5b,
+  0x06, 0xfa, 0x00, 0x7b, 0x06, 0xfa, 0x00, 0x58, 0x06, 0xfa, 0x00, 0x5b,
+  0x06, 0xfa, 0x00, 0x61, 0x04, 0x16, 0x00, 0x7b, 0x02, 0x1f, 0x00, 0xb4,
+  0x03, 0x8b, 0x00, 0xb4, 0x04, 0xf6, 0x00, 0xb4, 0x06, 0xa5, 0x00, 0xb4,
+  0x04, 0xec, 0x00, 0x0e, 0x06, 0xa4, 0x00, 0x0e, 0x08, 0x0f, 0x00, 0x0e,
+  0x09, 0x7b, 0x00, 0x0e, 0x06, 0x9b, 0x00, 0xb4, 0x04, 0xee, 0x00, 0x36,
+  0x06, 0xb7, 0x00, 0x36, 0x08, 0x25, 0x00, 0x36, 0x04, 0x02, 0x00, 0xb4,
+  0x05, 0x07, 0x00, 0x67, 0x05, 0x8b, 0x00, 0xb4, 0x06, 0x36, 0x00, 0xb4,
+  0x02, 0x00, 0x00, 0xad, 0x03, 0x4b, 0x00, 0xad, 0x04, 0x96, 0x00, 0xad,
+  0x05, 0xd7, 0x00, 0xad, 0x04, 0x42, 0x00, 0x36, 0x05, 0xd6, 0x00, 0x36,
+  0x07, 0x22, 0x00, 0x36, 0x08, 0x6d, 0x00, 0x36, 0x05, 0xe5, 0x00, 0xad,
+  0x04, 0x42, 0x00, 0x35, 0x05, 0xeb, 0x00, 0x35, 0x07, 0x36, 0x00, 0x35,
+  0x02, 0x00, 0x00, 0xad, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
+  0x07, 0x03, 0x00, 0xa7, 0x08, 0xf7, 0x00, 0x6c, 0x05, 0x8b, 0x00, 0xb4,
+  0x08, 0xf7, 0x00, 0x6c, 0x05, 0x10, 0x00, 0x67, 0x03, 0xf4, 0x00, 0x72,
+  0x05, 0x07, 0x00, 0x67, 0x06, 0xfa, 0x00, 0x4e, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x79,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x01, 0x03,
+  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x01, 0x03,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x27,
+  0x06, 0x08, 0x00, 0x13, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x01, 0x7a,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x6a, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x00, 0x6a, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x01, 0x0c, 0x06, 0x08, 0x01, 0x37, 0x06, 0x08, 0x01, 0x81,
+  0x06, 0x08, 0x01, 0x37, 0x06, 0x08, 0x01, 0x81, 0x06, 0x08, 0x01, 0xad,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x28, 0x06, 0x08, 0x00, 0x47,
+  0x06, 0x08, 0x00, 0xc7, 0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0xbd,
+  0x06, 0x08, 0x00, 0x8d, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x02, 0xb7, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x02, 0xb7, 0x06, 0x08, 0x01, 0x79,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x6b, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x6c, 0x06, 0x08, 0x00, 0x6a,
+  0x06, 0x08, 0x00, 0x6c, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x01, 0x7a, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x7a,
+  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0xa9, 0x06, 0x08, 0x00, 0xa9,
+  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x79,
+  0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x01, 0x79,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x00, 0x60,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x01, 0x3b,
+  0x06, 0x08, 0x00, 0x40, 0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x3b,
+  0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x20, 0x06, 0x08, 0x01, 0x3b,
+  0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x6d, 0x06, 0x08, 0x00, 0x6d, 0x06, 0x08, 0x01, 0x3b,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x6b, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x5a,
+  0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x31,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0x94, 0x00, 0x79, 0x03, 0xb9, 0x00, 0x55,
+  0x04, 0x8c, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x06, 0x45, 0x00, 0x8b,
+  0x04, 0xd1, 0xff, 0xfb, 0x04, 0xd1, 0xff, 0xfb, 0x06, 0x45, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x04, 0x94, 0x01, 0x0e,
+  0x05, 0x73, 0x00, 0x8c, 0x05, 0x73, 0x00, 0x8c, 0x04, 0xda, 0x00, 0x16,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x02, 0x6d, 0x00, 0x00, 0x04, 0x95, 0x01, 0x62, 0x06, 0x08, 0x00, 0xeb,
+  0x04, 0x81, 0x01, 0x23, 0x04, 0x81, 0x01, 0x35, 0x04, 0x96, 0x00, 0x36,
+  0x04, 0x96, 0x00, 0x36, 0x04, 0x96, 0x00, 0x36, 0x05, 0x24, 0x00, 0xc6,
+  0x05, 0xff, 0x00, 0xc6, 0x06, 0x08, 0x00, 0xfe, 0x06, 0x74, 0x00, 0x9d,
+  0x06, 0x74, 0x00, 0x9d, 0x06, 0x08, 0x00, 0xd5, 0x03, 0x99, 0x01, 0x84,
+  0x03, 0x99, 0x00, 0x5b, 0x03, 0x99, 0x00, 0xf4, 0x03, 0x99, 0x00, 0x5b,
+  0x05, 0x45, 0x00, 0xed, 0x05, 0x45, 0x00, 0xed, 0x05, 0x45, 0x00, 0xed,
+  0x05, 0x45, 0x00, 0xed, 0x03, 0xc0, 0x00, 0x69, 0x05, 0xae, 0x00, 0x69,
+  0x07, 0x9c, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x05, 0xae, 0x00, 0x69,
+  0x07, 0x9c, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
+  0x03, 0xc0, 0x00, 0x69, 0x04, 0x94, 0x00, 0x6c, 0x04, 0x94, 0x00, 0x6c,
+  0x01, 0xdf, 0x00, 0x90, 0x04, 0x94, 0x00, 0x6c, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc2, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0x91,
+  0x06, 0x08, 0x00, 0xc3, 0x02, 0xb3, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc2,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x0a, 0x00, 0xc3, 0x06, 0x0a, 0x00, 0xc3,
+  0x07, 0x33, 0x00, 0xba, 0x07, 0x33, 0x00, 0xb8, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc4,
+  0x06, 0x08, 0x00, 0xc4, 0x07, 0x89, 0x00, 0x85, 0x07, 0x89, 0x00, 0x85,
+  0x03, 0x57, 0x00, 0x9e, 0x06, 0x08, 0x00, 0xc2, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xbb,
+  0x06, 0x08, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xbb, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xb7, 0x06, 0x08, 0x00, 0xb7,
+  0x06, 0x08, 0x00, 0xb7, 0x06, 0x08, 0x00, 0xb7, 0x06, 0x08, 0x00, 0xab,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xab, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xab, 0x06, 0x08, 0x00, 0xab, 0x05, 0x45, 0x00, 0xed,
+  0x05, 0x45, 0x00, 0xed, 0x05, 0x45, 0x00, 0xed, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x05, 0x9e, 0x00, 0xc3, 0x05, 0x9e, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xa8,
+  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
+  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
+  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
+  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0xa8,
+  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x03, 0xbf, 0x00, 0x9d, 0x03, 0xbf, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x06, 0x45, 0x00, 0x9d, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0x6c,
+  0x07, 0x33, 0x00, 0x6c, 0x06, 0x08, 0x00, 0x58, 0x06, 0x08, 0x00, 0x6c,
+  0x03, 0xbf, 0x00, 0xd6, 0x05, 0x45, 0x00, 0xb4, 0x05, 0x45, 0x00, 0xb4,
+  0x05, 0x45, 0x00, 0xb4, 0x06, 0x08, 0x00, 0xfe, 0x06, 0x08, 0x00, 0xfe,
+  0x05, 0xe8, 0xff, 0xfb, 0x05, 0xe8, 0xff, 0xfb, 0x05, 0xe8, 0x00, 0x7e,
+  0x05, 0xe8, 0x00, 0x7e, 0x03, 0x8e, 0x00, 0x05, 0x02, 0x49, 0x00, 0xc5,
+  0x04, 0x81, 0x00, 0xe0, 0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
+  0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
+  0x07, 0x33, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x05, 0x46, 0x00, 0x59,
+  0x05, 0x46, 0x00, 0x59, 0x06, 0x08, 0x00, 0xab, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xbd, 0x06, 0x08, 0x00, 0xbd, 0x06, 0x08, 0x01, 0x56,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x0a, 0x3d, 0x00, 0x85, 0x0a, 0x3d, 0x00, 0x85, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xca,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xbf, 0x07, 0x33, 0x03, 0x3a, 0x07, 0x33, 0x00, 0xd4,
+  0x07, 0x33, 0x00, 0xd4, 0x07, 0x33, 0x00, 0xd4, 0x07, 0x33, 0x00, 0x4f,
+  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d,
+  0x06, 0x45, 0x00, 0x9d, 0x07, 0x33, 0x00, 0x4f, 0x06, 0x45, 0x00, 0x9d,
+  0x05, 0x2b, 0x00, 0xc3, 0x06, 0x45, 0x00, 0x9d, 0x05, 0x2b, 0x00, 0xc3,
+  0x06, 0x45, 0x00, 0xc3, 0x04, 0x55, 0x00, 0x42, 0x04, 0x55, 0x00, 0x66,
+  0x04, 0x92, 0x00, 0x83, 0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x01, 0x79,
+  0x06, 0x08, 0x01, 0x79, 0x06, 0x08, 0x01, 0x79, 0x03, 0x84, 0x01, 0x1b,
+  0x02, 0xcf, 0x00, 0x9e, 0x02, 0xcf, 0x00, 0xb3, 0x02, 0xcf, 0x00, 0x9e,
+  0x02, 0xcf, 0x00, 0xb3, 0x05, 0xd2, 0x02, 0xa8, 0x05, 0xd2, 0x00, 0x5a,
+  0x05, 0xd2, 0x02, 0xa8, 0x05, 0xd2, 0x00, 0x5a, 0x06, 0x08, 0x00, 0xc3,
+  0x03, 0xb1, 0x00, 0x05, 0x07, 0x33, 0x00, 0xde, 0x06, 0x08, 0x00, 0xc3,
+  0x03, 0x60, 0x00, 0x9e, 0x03, 0x60, 0x00, 0x78, 0x03, 0x60, 0x00, 0x9e,
+  0x03, 0x60, 0x00, 0x78, 0x03, 0xc0, 0x01, 0x83, 0x03, 0xc0, 0x00, 0x25,
+  0x08, 0x4c, 0x00, 0x8c, 0x08, 0x4c, 0x00, 0x8c, 0x0a, 0x2e, 0x00, 0x8c,
+  0x08, 0x4c, 0x00, 0x8c, 0x0a, 0x64, 0x00, 0x6c, 0x0a, 0x2e, 0x00, 0x00,
+  0x06, 0x49, 0x00, 0x87, 0x02, 0x6f, 0x00, 0x95, 0x04, 0x92, 0x00, 0xa7,
+  0x06, 0x07, 0x00, 0x79, 0x04, 0xbf, 0x00, 0x65, 0x05, 0x73, 0x00, 0x17,
+  0x08, 0x4c, 0x00, 0x8c, 0x06, 0x49, 0x00, 0x1f, 0x03, 0x99, 0x00, 0x9e,
+  0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e,
+  0x03, 0x99, 0x02, 0x4b, 0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e,
+  0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e, 0x03, 0x99, 0x00, 0x9e,
+  0x03, 0x99, 0x02, 0x4b, 0x03, 0x99, 0x00, 0x9e, 0x05, 0x66, 0x02, 0x5f,
+  0x05, 0x66, 0x00, 0x97, 0x05, 0x66, 0x02, 0x5f, 0x05, 0x66, 0x02, 0x5f,
+  0x05, 0x66, 0x00, 0x97, 0x05, 0x66, 0x02, 0x5f, 0x05, 0x66, 0x00, 0x97,
+  0x03, 0xc0, 0x01, 0x83, 0x06, 0x08, 0x00, 0x31, 0x06, 0xcd, 0x00, 0xa7,
+  0x06, 0x49, 0x00, 0x87, 0x05, 0x89, 0x00, 0x05, 0x04, 0x94, 0x00, 0x50,
+  0x04, 0x92, 0xff, 0x8f, 0x04, 0x92, 0x00, 0x83, 0x06, 0x74, 0x00, 0x88,
+  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
+  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
+  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2,
+  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a,
+  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a,
+  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2,
+  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0xe2,
+  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a,
+  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x01, 0x9a,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x52,
+  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x52,
+  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x01, 0x52,
+  0x04, 0x55, 0x01, 0x52, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0xff, 0x9e,
+  0x04, 0x55, 0xff, 0x9e, 0x04, 0x55, 0xff, 0x9e, 0x04, 0x55, 0xff, 0xee,
+  0x04, 0x55, 0x01, 0xe2, 0x04, 0x55, 0x02, 0x3c, 0x04, 0x55, 0x01, 0xe2,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0x02, 0x3c,
+  0x04, 0x55, 0x01, 0x9a, 0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0x9a,
+  0x04, 0x55, 0xff, 0xee, 0x04, 0x55, 0x01, 0x9a, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0x02, 0xc4, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0x04, 0xe5,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0x02, 0xc4, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x05, 0x89, 0x02, 0xc4, 0x05, 0x89, 0xff, 0xee,
+  0x05, 0x89, 0xff, 0xee, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x04, 0xe1, 0x00, 0xa7,
+  0x04, 0xe1, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
+  0x03, 0xf6, 0x00, 0xa7, 0x03, 0xf6, 0x00, 0xa7, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
+  0x03, 0x9d, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x03, 0x9d, 0x00, 0x05,
+  0x03, 0x9d, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
+  0x06, 0x48, 0x00, 0x64, 0x03, 0x8e, 0x00, 0x05, 0x06, 0x48, 0x00, 0x64,
+  0x06, 0x48, 0x00, 0x66, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
+  0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
+  0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
+  0x06, 0x48, 0x00, 0x64, 0x03, 0xcb, 0x00, 0x64, 0x03, 0xcb, 0x00, 0xa7,
+  0x05, 0xb2, 0x00, 0xa7, 0x06, 0xfc, 0x00, 0xa7, 0x06, 0xfc, 0x00, 0xa7,
+  0x06, 0xfc, 0x00, 0xa7, 0x02, 0xc9, 0x00, 0x05, 0x02, 0xc9, 0x00, 0x05,
+  0x02, 0xc9, 0x00, 0x05, 0x02, 0xc9, 0x00, 0x05, 0x06, 0x48, 0x00, 0x64,
+  0x06, 0x48, 0x00, 0x64, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x04, 0x3f, 0x01, 0x14,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x08, 0x0e, 0x00, 0x64,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64,
+  0x06, 0x48, 0x00, 0x64, 0x06, 0x48, 0x00, 0x64, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0xfa, 0x00, 0xa7,
+  0x05, 0xfa, 0x00, 0xa7, 0x05, 0x46, 0x00, 0xa7, 0x05, 0x46, 0x00, 0xa7,
+  0x05, 0x89, 0x00, 0x05, 0x06, 0x74, 0x00, 0x99, 0x07, 0x33, 0x00, 0x5d,
+  0x06, 0x74, 0x00, 0x5a, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x75,
+  0x06, 0x74, 0x00, 0x77, 0x06, 0x74, 0x00, 0x77, 0x04, 0x1f, 0x00, 0x99,
+  0x06, 0x73, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x65, 0x00, 0x70,
+  0x06, 0x65, 0x00, 0x70, 0x04, 0xd5, 0x00, 0x70, 0x07, 0x4a, 0x00, 0x70,
+  0x08, 0xf7, 0x00, 0x7e, 0x09, 0x00, 0x00, 0x82, 0x06, 0x74, 0x00, 0xa5,
+  0x06, 0x74, 0x00, 0xa4, 0x06, 0x74, 0x00, 0xa4, 0x03, 0xd5, 0x00, 0x8a,
+  0x06, 0x74, 0x00, 0x5a, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x9a,
+  0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x8f, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0xa0,
+  0x04, 0x62, 0x00, 0x84, 0x06, 0x74, 0x00, 0x9f, 0x04, 0x62, 0x00, 0x84,
+  0x06, 0x74, 0x00, 0x70, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x5a, 0x04, 0xd1, 0x00, 0x5a, 0x05, 0x5f, 0x00, 0x99,
+  0x04, 0xad, 0x00, 0x99, 0x05, 0xa4, 0x00, 0x99, 0x03, 0xec, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0xa0, 0x06, 0x74, 0x00, 0x99,
+  0x05, 0x1d, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x79, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x02, 0x93,
+  0x06, 0x74, 0x00, 0x99, 0x04, 0x6b, 0x00, 0x9d, 0x05, 0x46, 0x00, 0x9d,
+  0x05, 0x46, 0x00, 0x9d, 0x06, 0x74, 0x00, 0x91, 0x06, 0x74, 0x01, 0x31,
+  0x06, 0x74, 0x01, 0x93, 0x06, 0x74, 0x00, 0xdf, 0x06, 0x74, 0x00, 0xea,
+  0x06, 0x74, 0x01, 0xba, 0x06, 0x74, 0x00, 0x53, 0x06, 0x74, 0x00, 0xa4,
+  0x06, 0x74, 0x00, 0xac, 0x06, 0x74, 0x00, 0xcf, 0x06, 0x74, 0x01, 0x01,
+  0x06, 0x74, 0x00, 0x62, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x3e,
+  0x06, 0x74, 0x00, 0x98, 0x06, 0x74, 0x00, 0xac, 0x06, 0x74, 0x00, 0x9e,
+  0x06, 0x74, 0x01, 0x20, 0x06, 0x74, 0x00, 0xb4, 0x06, 0x74, 0x00, 0xcb,
+  0x06, 0x74, 0x01, 0x32, 0x06, 0x74, 0x01, 0x8a, 0x06, 0x74, 0x01, 0x2f,
+  0x06, 0x74, 0x01, 0x11, 0x06, 0x74, 0x00, 0xb4, 0x06, 0x74, 0x00, 0xcb,
+  0x06, 0x74, 0x01, 0x32, 0x06, 0x74, 0x01, 0x8a, 0x06, 0x74, 0x01, 0x2a,
+  0x06, 0x74, 0x01, 0x11, 0x06, 0x74, 0x01, 0x22, 0x06, 0x74, 0x00, 0xa6,
+  0x06, 0x74, 0x01, 0x35, 0x06, 0x74, 0x00, 0xcd, 0x06, 0x74, 0x01, 0x21,
+  0x06, 0x74, 0x00, 0xa3, 0x06, 0x74, 0x01, 0x35, 0x06, 0x74, 0x00, 0xcd,
+  0x06, 0x74, 0x00, 0xc2, 0x03, 0x65, 0x00, 0x9a, 0x04, 0x98, 0x00, 0x9a,
+  0x06, 0x74, 0x01, 0x52, 0x06, 0x74, 0x00, 0xa9, 0x03, 0x65, 0x00, 0xa2,
+  0x02, 0x92, 0x00, 0x9a, 0x03, 0x7b, 0x00, 0x9b, 0x05, 0x62, 0x00, 0x9a,
+  0x05, 0x83, 0x00, 0x76, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x8c,
+  0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c,
+  0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x8c,
+  0x06, 0x74, 0x00, 0x8c, 0x06, 0x74, 0x00, 0x9a, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x01, 0x12,
+  0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87,
+  0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87, 0x06, 0x42, 0x00, 0x87,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x01, 0x35, 0x06, 0x74, 0x01, 0x35,
+  0x06, 0x74, 0x00, 0x5f, 0x06, 0x74, 0x00, 0xb2, 0x06, 0x74, 0x00, 0xf2,
+  0x03, 0xe5, 0x00, 0x70, 0x06, 0x74, 0x00, 0x6c, 0x06, 0x74, 0x00, 0x70,
+  0x06, 0x74, 0x01, 0x0b, 0x06, 0x74, 0x00, 0xae, 0x06, 0x74, 0x00, 0xeb,
+  0x06, 0x74, 0x00, 0xea, 0x06, 0x74, 0x00, 0xea, 0x06, 0x74, 0x00, 0x5a,
+  0x05, 0x0e, 0x00, 0x99, 0x07, 0x3b, 0x00, 0x9d, 0x07, 0xd7, 0x00, 0x91,
+  0x08, 0x75, 0x00, 0x9d, 0x06, 0x80, 0x00, 0x9d, 0x06, 0x08, 0x00, 0xf2,
+  0x06, 0x08, 0x00, 0xba, 0x06, 0x08, 0x01, 0x59, 0x06, 0x08, 0x00, 0x08,
+  0x06, 0x08, 0x01, 0x58, 0x06, 0x08, 0x01, 0x58, 0x06, 0x08, 0x01, 0xc7,
+  0x06, 0x08, 0x01, 0x40, 0x06, 0x08, 0x00, 0x4b, 0x06, 0x08, 0x00, 0x09,
+  0x06, 0x13, 0x00, 0xbd, 0x06, 0x08, 0x01, 0x85, 0x05, 0x46, 0x00, 0x9d,
+  0x05, 0x46, 0x01, 0x36, 0x05, 0x46, 0x00, 0x9e, 0x05, 0x46, 0x00, 0x9e,
+  0x06, 0x1e, 0x00, 0x6c, 0x05, 0x46, 0x01, 0x66, 0x05, 0x46, 0x01, 0x23,
+  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4d,
+  0x06, 0x08, 0x00, 0x4d, 0x05, 0x46, 0x00, 0x9d, 0x06, 0x08, 0x00, 0x13,
+  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x13, 0x06, 0x08, 0x00, 0x41,
+  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x6c,
+  0x06, 0x08, 0x00, 0x76, 0x06, 0x08, 0x01, 0x87, 0x06, 0x08, 0x00, 0x26,
+  0x06, 0x08, 0x00, 0xa3, 0x06, 0x08, 0x00, 0x2f, 0x06, 0x08, 0x00, 0xa3,
+  0x06, 0x08, 0x00, 0x4f, 0x06, 0x08, 0x00, 0x7c, 0x06, 0x08, 0x01, 0x14,
+  0x06, 0x08, 0x00, 0xd5, 0x06, 0x08, 0x00, 0xe9, 0x06, 0x08, 0x00, 0x9d,
+  0x06, 0x08, 0x00, 0xd8, 0x06, 0x08, 0x00, 0xe2, 0x06, 0x08, 0x00, 0x64,
+  0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x64,
+  0x06, 0x08, 0x01, 0x30, 0x06, 0x08, 0x00, 0xf1, 0x06, 0x08, 0x01, 0x1e,
+  0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0x4b,
+  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x4a, 0x06, 0x08, 0x00, 0x4b,
+  0x06, 0x08, 0x00, 0x4e, 0x06, 0x08, 0x00, 0x4e, 0x06, 0x08, 0x00, 0x2a,
+  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x2b, 0x06, 0x08, 0x00, 0x2a,
+  0x06, 0x08, 0x00, 0x2b, 0x06, 0x08, 0x00, 0x2b, 0x06, 0x08, 0x00, 0x2b,
+  0x06, 0x08, 0x00, 0x2d, 0x06, 0x08, 0x00, 0x76, 0x06, 0x08, 0x00, 0x88,
+  0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x39, 0x06, 0x08, 0x00, 0x4b,
+  0x06, 0x08, 0x00, 0xa8, 0x06, 0x08, 0x00, 0x4b, 0x06, 0x08, 0x00, 0x4b,
+  0x06, 0x08, 0x00, 0x4b, 0x06, 0x08, 0x00, 0x64, 0x06, 0x08, 0x00, 0x96,
+  0x06, 0x08, 0x00, 0x96, 0x06, 0x08, 0x00, 0x90, 0x06, 0x08, 0x00, 0x90,
+  0x06, 0x08, 0x00, 0x63, 0x06, 0x08, 0x00, 0x63, 0x06, 0x08, 0x00, 0x4b,
+  0x06, 0x08, 0x00, 0x4d, 0x06, 0x08, 0x00, 0x90, 0x06, 0x08, 0x00, 0xa3,
+  0x06, 0x08, 0x00, 0x8c, 0x06, 0x08, 0x00, 0x75, 0x06, 0x08, 0x00, 0x90,
+  0x06, 0x08, 0x00, 0x57, 0x06, 0x08, 0x00, 0x57, 0x06, 0x08, 0x00, 0x4b,
+  0x06, 0x08, 0x00, 0x4b, 0x06, 0x74, 0x00, 0x5b, 0x06, 0x74, 0x00, 0x6d,
+  0x06, 0x74, 0x00, 0x6d, 0x06, 0x74, 0x00, 0x6d, 0x06, 0x74, 0x00, 0x6d,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x08, 0x02, 0xb7, 0x06, 0x08, 0x02, 0x6b,
+  0x06, 0x08, 0x01, 0xd2, 0x02, 0x52, 0x00, 0x9c, 0x02, 0x52, 0x00, 0x6c,
+  0x03, 0xdf, 0x00, 0x9c, 0x03, 0xdf, 0x00, 0x6c, 0x06, 0x08, 0x01, 0x1e,
+  0x06, 0x08, 0x01, 0x74, 0x06, 0x08, 0x01, 0x2c, 0x06, 0x08, 0x00, 0x63,
+  0x06, 0x08, 0x01, 0x35, 0x06, 0x08, 0x00, 0x71, 0x06, 0x08, 0x00, 0x90,
+  0x06, 0x08, 0x01, 0x68, 0x06, 0x08, 0x01, 0x68, 0x06, 0x08, 0x01, 0xe6,
+  0x06, 0x08, 0x01, 0xe6, 0x06, 0x08, 0x01, 0x8c, 0x06, 0x08, 0x01, 0xab,
+  0x06, 0x08, 0x01, 0x05, 0x06, 0x08, 0x01, 0x19, 0x06, 0x08, 0x01, 0x32,
+  0x06, 0x08, 0x01, 0x51, 0x06, 0x08, 0x02, 0x7d, 0x06, 0x08, 0x02, 0x2e,
+  0x06, 0x08, 0x01, 0x42, 0x06, 0x08, 0x01, 0x77, 0x06, 0x74, 0x00, 0x88,
+  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
+  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
+  0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88, 0x06, 0x74, 0x00, 0x88,
+  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
+  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
+  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
+  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
+  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
+  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08,
+  0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x08, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0xe2, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0xe2,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0xcd, 0x06, 0x08, 0x00, 0xcd,
+  0x06, 0x08, 0x00, 0xcd, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x01, 0xba, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x26, 0x06, 0x08, 0x00, 0x26,
+  0x06, 0x08, 0x00, 0xf9, 0x06, 0x08, 0x00, 0xf9, 0x06, 0x08, 0x00, 0x72,
+  0x06, 0x08, 0x00, 0x72, 0x06, 0x08, 0x01, 0x1c, 0x06, 0x08, 0x00, 0x75,
+  0x06, 0x08, 0x00, 0x94, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x96,
+  0x06, 0x08, 0x00, 0x96, 0x06, 0x08, 0x00, 0x69, 0x06, 0x08, 0x00, 0x96,
+  0x06, 0x08, 0x00, 0x67, 0x06, 0x08, 0x00, 0x87, 0x06, 0x08, 0x00, 0x91,
+  0x06, 0x08, 0x00, 0x91, 0x06, 0x08, 0x00, 0x69, 0x02, 0xcf, 0x00, 0x63,
+  0x02, 0xcf, 0x00, 0x47, 0x03, 0x8e, 0x00, 0x05, 0x03, 0x90, 0x00, 0x9e,
+  0x03, 0x90, 0x00, 0x9d, 0x02, 0xcf, 0x00, 0xa4, 0x02, 0xcf, 0x00, 0x93,
+  0x04, 0x01, 0x00, 0xa4, 0x04, 0x01, 0x00, 0x93, 0x06, 0x08, 0x00, 0x51,
+  0x06, 0x08, 0x00, 0x50, 0x06, 0x08, 0x00, 0x47, 0x06, 0x08, 0x00, 0x47,
+  0x08, 0x55, 0x00, 0x69, 0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69,
+  0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69,
+  0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69,
+  0x0a, 0x52, 0x00, 0x5a, 0x0a, 0x52, 0x00, 0x69, 0x0a, 0x52, 0x00, 0x69,
+  0x05, 0x46, 0x00, 0x00, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x03, 0x2a, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e, 0x05, 0x46, 0x01, 0x0e,
+  0x05, 0x46, 0x01, 0x0e, 0x06, 0x08, 0x00, 0x5a, 0x06, 0x08, 0x00, 0x69,
+  0x06, 0x08, 0x00, 0xe6, 0x06, 0x08, 0x00, 0xe6, 0x04, 0xeb, 0x00, 0x47,
+  0x04, 0xeb, 0x00, 0x47, 0x05, 0x48, 0x00, 0xe6, 0x05, 0x48, 0x00, 0xe6,
+  0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
+  0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3,
+  0x07, 0x33, 0x00, 0xc3, 0x07, 0x33, 0x00, 0xc3, 0x03, 0x8e, 0x00, 0x05,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x07, 0x33, 0x00, 0x34,
+  0x07, 0x33, 0x00, 0x34, 0x07, 0x33, 0x00, 0x34, 0x09, 0x8a, 0x00, 0x69,
+  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
+  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
+  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
+  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0xff, 0xc5, 0x03, 0xc0, 0x00, 0x69,
+  0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69, 0x03, 0xc0, 0x00, 0x69,
+  0x03, 0xc0, 0x00, 0x60, 0x06, 0x08, 0x00, 0xfc, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc4,
+  0x06, 0x08, 0x00, 0xc4, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xc3,
+  0x06, 0x08, 0x00, 0xc3, 0x06, 0x08, 0x00, 0xa2, 0x06, 0x08, 0x01, 0x03,
+  0x06, 0x08, 0x00, 0xa2, 0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0x31,
+  0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x01, 0x3b, 0x06, 0x08, 0x01, 0x3b,
+  0x06, 0x08, 0x00, 0xa2, 0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0xa2,
+  0x06, 0x08, 0x01, 0x03, 0x06, 0x08, 0x00, 0x31, 0x06, 0x08, 0x01, 0x3b,
+  0x06, 0x04, 0x00, 0x69, 0x06, 0x04, 0x00, 0x69, 0x06, 0x04, 0x00, 0x40,
+  0x06, 0x04, 0x00, 0x40, 0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0xcd, 0x00, 0xa7, 0x05, 0x89, 0x00, 0x05,
+  0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05, 0x05, 0x89, 0x00, 0x05,
+  0x06, 0xcd, 0x00, 0xa7, 0x06, 0x42, 0x00, 0x20, 0x06, 0x42, 0x00, 0x20,
+  0x06, 0x49, 0x00, 0x87, 0x06, 0x49, 0x00, 0x87, 0x06, 0x49, 0x00, 0x1e,
+  0x08, 0x0e, 0x00, 0x64, 0x06, 0x42, 0x00, 0x45, 0x06, 0x42, 0x00, 0x45,
+  0x04, 0x02, 0x00, 0x09, 0x02, 0x00, 0x00, 0x09, 0x04, 0x02, 0xff, 0xdc,
+  0x04, 0x57, 0x00, 0x09, 0x05, 0x00, 0x00, 0xb4, 0x04, 0x69, 0x00, 0x40,
+  0x02, 0xd2, 0xff, 0xeb, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x04, 0xb8, 0x00, 0xb4, 0x04, 0x2b, 0x00, 0xa7, 0x04, 0xee, 0x00, 0x52,
+  0x03, 0xc7, 0x00, 0x4f, 0x05, 0xa0, 0x00, 0x67, 0x06, 0x36, 0x00, 0xb4,
+  0x04, 0xec, 0x00, 0x0e, 0x05, 0xa0, 0x00, 0x67, 0x05, 0x49, 0x00, 0x36,
+  0x08, 0x1f, 0x00, 0x3d, 0x06, 0xec, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x5d,
+  0x04, 0xb6, 0x00, 0xb4, 0x04, 0x16, 0x00, 0xad, 0x04, 0xbf, 0x00, 0x64,
+  0x02, 0xfb, 0x00, 0x00, 0x04, 0x67, 0x00, 0x65, 0x03, 0x88, 0x00, 0x58,
+  0x01, 0x42, 0xff, 0xec, 0x03, 0x19, 0x00, 0x09, 0x04, 0x92, 0x00, 0x79,
+  0x04, 0xee, 0x00, 0x52, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
+  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
+  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
+  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
+  0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0, 0x03, 0x8d, 0x00, 0xc0,
+  0x03, 0x8d, 0x00, 0xc0, 0x02, 0xa8, 0x00, 0x5b, 0x02, 0xa8, 0x00, 0x5b,
+  0x01, 0xd1, 0x00, 0xaf, 0x01, 0xd1, 0x00, 0xaf, 0x01, 0xd1, 0x00, 0xaf,
+  0x02, 0xc6, 0x00, 0x7b, 0x02, 0x90, 0x00, 0x7b, 0x03, 0x65, 0x00, 0x67,
+  0x03, 0x65, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7,
+  0x06, 0x52, 0xff, 0xfb, 0x05, 0x1b, 0x00, 0x31, 0x04, 0x6c, 0x00, 0x93,
+  0x03, 0xe4, 0x00, 0x77, 0x03, 0x88, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63,
+  0x08, 0xff, 0x00, 0x0e, 0x07, 0x17, 0x00, 0x6e, 0x08, 0xa9, 0x00, 0x0e,
+  0x07, 0x20, 0x00, 0x6e, 0x08, 0x39, 0x00, 0x0e, 0x07, 0x10, 0x00, 0x6e,
+  0x06, 0xfe, 0x00, 0x0e, 0x05, 0xe3, 0x00, 0x6e, 0x06, 0xfe, 0x00, 0x0e,
+  0x05, 0xe3, 0x00, 0x6e, 0x06, 0xe7, 0x00, 0x0e, 0x05, 0xe3, 0x00, 0x6e,
+  0x05, 0x10, 0x00, 0x67, 0x03, 0xf4, 0x00, 0x72, 0x04, 0xb8, 0x00, 0x09,
+  0x04, 0x32, 0x00, 0x0c, 0x04, 0xe5, 0x00, 0xb4, 0x02, 0xd2, 0x00, 0xad,
+  0x04, 0x2f, 0x00, 0x4a, 0x03, 0x12, 0x00, 0x6c, 0x05, 0xce, 0x00, 0x09,
+  0x05, 0x11, 0x00, 0x09, 0x09, 0xc6, 0x00, 0x67, 0x07, 0x55, 0x00, 0x65,
+  0x04, 0x57, 0x00, 0x09, 0x04, 0x92, 0xff, 0xfc, 0x05, 0x48, 0x00, 0x2d,
+  0x05, 0x93, 0x00, 0x2d, 0x05, 0xaa, 0x00, 0x67, 0x04, 0x92, 0x00, 0x65,
+  0x04, 0x5b, 0x00, 0x09, 0x04, 0x92, 0xff, 0xfc, 0x04, 0x5b, 0x00, 0x09,
+  0x04, 0x92, 0xff, 0xfc, 0x04, 0x02, 0x00, 0x09, 0x02, 0x00, 0x00, 0xad,
+  0x05, 0x4b, 0x00, 0xb4, 0x04, 0x90, 0x00, 0xa7, 0x02, 0x6d, 0x00, 0xd8,
+  0x02, 0xb5, 0x00, 0x90, 0x02, 0xe2, 0x01, 0x16, 0x01, 0xfa, 0x00, 0xb1,
+  0x04, 0xef, 0x00, 0x9d, 0x03, 0x82, 0x00, 0x45, 0x05, 0x8f, 0x00, 0xb4,
+  0x04, 0xcc, 0x00, 0xa7, 0x05, 0x94, 0x00, 0x03, 0x04, 0x92, 0x00, 0x03,
+  0x04, 0xb8, 0x00, 0x03, 0x04, 0x2b, 0x00, 0x03, 0x05, 0x62, 0x00, 0x03,
+  0x04, 0x90, 0x00, 0x03, 0x05, 0x00, 0x00, 0x03, 0x02, 0xf5, 0x00, 0x03,
+  0x04, 0x92, 0x00, 0x03, 0x03, 0xc0, 0x00, 0x03, 0x05, 0xc4, 0xff, 0xa2,
+  0x06, 0x96, 0x00, 0xa7, 0x04, 0x24, 0x00, 0x6b, 0x04, 0x57, 0x00, 0x3f,
+  0x06, 0x36, 0x00, 0xb4, 0x02, 0x1f, 0x00, 0xb4, 0x08, 0xa2, 0x00, 0x3d,
+  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xd9, 0x00, 0x63,
+  0x01, 0xe6, 0x00, 0x56, 0x01, 0xec, 0x00, 0x51, 0x01, 0xb6, 0x00, 0x7e,
+  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xd9, 0x00, 0x63,
+  0x01, 0xe6, 0x00, 0x56, 0x01, 0xd9, 0x00, 0x63, 0x01, 0xb6, 0x00, 0x7e,
+  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xd9, 0x00, 0x63,
+  0x01, 0xe6, 0x00, 0x56, 0x01, 0xd9, 0x00, 0x63, 0x01, 0xb6, 0x00, 0x7e,
+  0x01, 0x89, 0x00, 0xae, 0x01, 0xb6, 0x00, 0x7e, 0x01, 0xec, 0x00, 0x51,
+  0x01, 0xe6, 0x00, 0x56, 0x01, 0xd9, 0x00, 0x63, 0x01, 0xb6, 0x00, 0x7e,
+  0x01, 0x89, 0x00, 0xae, 0x01, 0xfa, 0x00, 0xc0, 0x07, 0x08, 0x00, 0x87,
+  0x07, 0x08, 0x00, 0x87, 0x07, 0x08, 0x00, 0x87, 0x07, 0x08, 0x00, 0x87,
+  0x04, 0x2d, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63, 0x04, 0x7d, 0x00, 0x63,
+  0x06, 0x66, 0x00, 0x63, 0x04, 0x36, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63,
+  0x04, 0xb3, 0x00, 0x63, 0x06, 0x59, 0x00, 0x63, 0x03, 0xff, 0x00, 0x63,
+  0x04, 0x2d, 0x00, 0x63, 0x08, 0x69, 0x00, 0x63, 0x04, 0x3d, 0x00, 0x63,
+  0x04, 0x3f, 0x00, 0x75, 0x06, 0x42, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63,
+  0x04, 0x3e, 0x00, 0x63, 0x06, 0x93, 0x00, 0x63, 0x04, 0x3f, 0x00, 0x75,
+  0x05, 0x43, 0x00, 0x63, 0x04, 0x32, 0x00, 0x2d, 0x06, 0x47, 0x00, 0x63,
+  0x04, 0x3e, 0x00, 0x63, 0x06, 0x71, 0x00, 0x63, 0x04, 0x3d, 0x00, 0x63,
+  0x04, 0x3d, 0x00, 0x63, 0x04, 0x40, 0x00, 0x75, 0x04, 0xac, 0x00, 0x64,
+  0x04, 0x3d, 0x00, 0x63, 0x04, 0x3e, 0x00, 0x75, 0x04, 0x4f, 0x00, 0x63,
+  0x04, 0x3f, 0x00, 0x75, 0x03, 0xb7, 0x00, 0x2d, 0x04, 0x2c, 0x00, 0x63,
+  0x04, 0x34, 0x00, 0x6c, 0x04, 0x2d, 0x00, 0x63, 0x04, 0x2d, 0x00, 0x63,
+  0x04, 0x2e, 0x00, 0x63, 0x04, 0x98, 0x00, 0x63, 0x06, 0xe0, 0x00, 0x63,
+  0x06, 0xb4, 0x00, 0x6d, 0x05, 0xd1, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
+  0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
+  0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
+  0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a, 0x03, 0xa8, 0x00, 0x5a,
+  0x03, 0xba, 0x00, 0x5a, 0x03, 0xba, 0x00, 0x5a, 0x03, 0xba, 0x00, 0x5a,
+  0x05, 0xa9, 0x00, 0x5a, 0x05, 0xa9, 0x00, 0x5a, 0x05, 0xa9, 0x00, 0x5a,
+  0x05, 0xa9, 0x00, 0x5a, 0x05, 0xa9, 0x00, 0x5a, 0x03, 0xef, 0x00, 0x36,
+  0x03, 0xef, 0x00, 0x36, 0x03, 0xef, 0x00, 0x36, 0x03, 0xef, 0x00, 0x36,
+  0x03, 0xef, 0x00, 0x36, 0x03, 0xef, 0x00, 0x36, 0x04, 0x67, 0x00, 0x65,
+  0x04, 0xf5, 0x00, 0x2a, 0x04, 0x89, 0x00, 0x2a, 0x04, 0x89, 0x00, 0x2a,
+  0x06, 0xf6, 0x00, 0x2a, 0x06, 0xf6, 0x00, 0x2a, 0x04, 0xf0, 0x00, 0x2a,
+  0x06, 0x32, 0x00, 0x63, 0x00, 0x00, 0xfc, 0xcc, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0xfd, 0x73, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x07, 0x62, 0x00, 0x1b, 0x05, 0x73, 0x00, 0x5a, 0x04, 0x5f, 0x00, 0xb4,
+  0x04, 0x0c, 0x00, 0x5a, 0x04, 0x53, 0x00, 0xb4, 0x03, 0xf3, 0x00, 0xb4,
+  0x03, 0xf3, 0x00, 0xb4, 0x03, 0x2a, 0x00, 0x87, 0x04, 0x80, 0x00, 0xb4,
+  0x06, 0x81, 0x00, 0x87, 0x02, 0x0a, 0x00, 0xb4, 0x04, 0x96, 0x00, 0xb4,
+  0x03, 0xef, 0x00, 0xb4, 0x0a, 0x45, 0x00, 0xb4, 0x06, 0x58, 0x00, 0xb4,
+  0x06, 0xa6, 0x00, 0xb4, 0x06, 0x81, 0x00, 0x87, 0x04, 0xf0, 0x00, 0xb4,
+  0x06, 0x40, 0x00, 0xb4, 0x04, 0x38, 0x00, 0x87, 0x04, 0x5d, 0x00, 0xb4,
+  0x03, 0x2d, 0x00, 0x87, 0x05, 0x03, 0x00, 0x5a, 0x04, 0x95, 0x00, 0xb4,
+  0x04, 0xf0, 0x00, 0x87, 0x04, 0xec, 0x00, 0x87, 0x05, 0xd4, 0x00, 0x5a,
+  0x03, 0xcc, 0x00, 0x87, 0x04, 0x03, 0x00, 0xb4, 0x04, 0x03, 0x00, 0xb4,
+  0x03, 0x2a, 0x00, 0x5a, 0x05, 0x73, 0x00, 0x5a, 0x02, 0x0a, 0x00, 0xb4,
+  0x05, 0x73, 0x00, 0x5a, 0x04, 0xf0, 0x00, 0x87, 0x05, 0xe3, 0x00, 0x5a,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x05, 0x55, 0x00, 0x0e, 0x05, 0x43, 0x00, 0xb4, 0x05, 0xe5, 0x00, 0xd0,
+  0x05, 0x40, 0x00, 0xb4, 0x04, 0xd9, 0x00, 0xb4, 0x05, 0x94, 0x00, 0x67,
+  0x02, 0xd3, 0x00, 0x5b, 0x02, 0xd1, 0xff, 0xa1, 0x05, 0x6a, 0x00, 0xb4,
+  0x04, 0xb6, 0x00, 0xb4, 0x07, 0x61, 0x00, 0xb0, 0x05, 0xaa, 0x00, 0x66,
+  0x04, 0x92, 0x00, 0x7a, 0x05, 0x19, 0xff, 0xfb, 0x05, 0xfa, 0x00, 0x9f,
+  0x05, 0x34, 0x00, 0x0e, 0x07, 0xfa, 0x00, 0x3d, 0x05, 0xcd, 0x00, 0x61,
+  0x05, 0x17, 0xff, 0xfd, 0x04, 0xc3, 0x00, 0x6e, 0x05, 0x19, 0x00, 0x85,
+  0x03, 0xf5, 0x00, 0x65, 0x05, 0x19, 0x00, 0x85, 0x04, 0x6e, 0x00, 0x63,
+  0x03, 0x59, 0x00, 0x2a, 0x05, 0x19, 0x00, 0x65, 0x05, 0x4e, 0x00, 0xa7,
+  0x02, 0x87, 0x00, 0xcf, 0x02, 0x87, 0xff, 0xdc, 0x04, 0xaf, 0x00, 0xa7,
+  0x02, 0x87, 0x00, 0xcf, 0x08, 0x38, 0x00, 0xa7, 0x05, 0x4e, 0x00, 0xa7,
+  0x04, 0x67, 0x00, 0x65, 0x05, 0x19, 0x00, 0x65, 0x05, 0x19, 0x00, 0x65,
+  0x03, 0x7b, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63, 0x03, 0x59, 0x00, 0x31,
+  0x05, 0x52, 0x00, 0x9f, 0x04, 0x5f, 0x00, 0x36, 0x06, 0x8d, 0x00, 0x4d,
+  0x04, 0xdd, 0x00, 0x44, 0x04, 0x7f, 0x00, 0x36, 0x04, 0x3f, 0x00, 0x4f,
+  0x04, 0xec, 0x00, 0x0e, 0x04, 0xf0, 0x00, 0xb4, 0x05, 0x07, 0x00, 0x67,
+  0x05, 0x8b, 0x00, 0xb4, 0x04, 0x8c, 0x00, 0xb4, 0x04, 0x24, 0x00, 0xb4,
+  0x05, 0x94, 0x00, 0x67, 0x05, 0x6a, 0x00, 0xb4, 0x03, 0x31, 0x00, 0x87,
+  0x02, 0x1f, 0xff, 0xa1, 0x04, 0xb8, 0x00, 0xb4, 0x04, 0x02, 0x00, 0xb4,
+  0x06, 0x36, 0x00, 0xb4, 0x05, 0x62, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67,
+  0x04, 0x57, 0x00, 0xb4, 0x05, 0xaa, 0x00, 0x67, 0x05, 0x00, 0x00, 0xb4,
+  0x04, 0x92, 0x00, 0x79, 0x04, 0x65, 0xff, 0xfb, 0x05, 0x45, 0x00, 0xa0,
+  0x04, 0xec, 0x00, 0x0e, 0x07, 0x1e, 0x00, 0x3d, 0x04, 0xee, 0x00, 0x36,
+  0x04, 0x65, 0xff, 0xfd, 0x04, 0xee, 0x00, 0x52, 0x04, 0x69, 0x00, 0x6e,
+  0x04, 0x92, 0x00, 0xa7, 0x03, 0xf5, 0x00, 0x65, 0x04, 0x92, 0x00, 0x65,
+  0x04, 0x6e, 0x00, 0x65, 0x02, 0x88, 0x00, 0x2a, 0x04, 0x92, 0x00, 0x65,
+  0x04, 0x90, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x02, 0x00, 0xff, 0xdf,
+  0x04, 0x2b, 0x00, 0xa7, 0x02, 0x00, 0x00, 0xad, 0x07, 0x03, 0x00, 0xa7,
+  0x04, 0x90, 0x00, 0xa7, 0x04, 0x67, 0x00, 0x65, 0x04, 0x92, 0x00, 0xa7,
+  0x04, 0x92, 0x00, 0x65, 0x02, 0xf5, 0x00, 0xa7, 0x03, 0xc0, 0x00, 0x63,
+  0x02, 0xd2, 0x00, 0x31, 0x04, 0x90, 0x00, 0x9c, 0x04, 0x42, 0x00, 0x36,
+  0x05, 0xe3, 0x00, 0x4d, 0x04, 0x42, 0x00, 0x35, 0x04, 0x42, 0x00, 0x36,
+  0x03, 0xc7, 0x00, 0x4f, 0x04, 0x94, 0x00, 0x7a, 0x04, 0x94, 0x00, 0x60,
+  0x04, 0x94, 0x00, 0x75, 0x04, 0x94, 0x00, 0x8c, 0x04, 0x94, 0x00, 0x51,
+  0x04, 0x94, 0x00, 0x85, 0x04, 0x94, 0x00, 0x65, 0x04, 0x94, 0x00, 0x3a,
+  0x04, 0x94, 0x00, 0x7d, 0x04, 0x92, 0x00, 0x5f, 0x04, 0x94, 0x00, 0x79,
+  0x04, 0x94, 0x00, 0xca, 0x04, 0x94, 0x00, 0x87, 0x04, 0x94, 0x00, 0x8c,
+  0x04, 0x94, 0x00, 0x5a, 0x04, 0x94, 0x00, 0x8e, 0x04, 0x94, 0x00, 0x80,
+  0x04, 0x94, 0x00, 0x97, 0x04, 0x94, 0x00, 0x7d, 0x04, 0x94, 0x00, 0x74,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4,
+  0x09, 0xd1, 0x00, 0xb4, 0x09, 0xd1, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4, 0x05, 0xde, 0x00, 0xb4,
+  0x05, 0xde, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x6c, 0x00, 0xc3, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4, 0x07, 0x5d, 0x00, 0xb4,
+  0x07, 0x82, 0x00, 0x89, 0x08, 0x85, 0x00, 0x43, 0x07, 0x81, 0x00, 0x36,
+  0x08, 0x53, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x08, 0x69, 0x00, 0x55, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x80,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x08, 0x69, 0x00, 0x55,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x1f, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x0b, 0x8c, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x99,
+  0x07, 0x81, 0x00, 0x99, 0x07, 0x81, 0x00, 0x34, 0x08, 0x69, 0x00, 0x56,
+  0x07, 0x81, 0x00, 0x34, 0x07, 0x81, 0x00, 0x36, 0x07, 0x81, 0x00, 0x36,
+  0x07, 0x81, 0x00, 0x36, 0x07, 0x81, 0x00, 0x36, 0x07, 0x81, 0x00, 0x36,
+  0x07, 0x81, 0x00, 0x36, 0x00, 0x00, 0xff, 0xc1, 0x00, 0x00, 0xfd, 0x28,
+  0x00, 0x00, 0xfd, 0xb5, 0x00, 0x00, 0xfd, 0x0b, 0x00, 0x00, 0xfd, 0x58,
+  0x00, 0x00, 0xfd, 0x21, 0x00, 0x00, 0xfd, 0x21, 0x00, 0x00, 0xfd, 0x1a,
+  0x00, 0x00, 0xfd, 0x1a, 0x00, 0x00, 0xfd, 0xd8, 0x00, 0x00, 0xfd, 0x36,
+  0x00, 0x00, 0xfc, 0xad, 0x00, 0x87, 0x00, 0x00, 0x01, 0x68, 0x00, 0x00,
+  0x01, 0x68, 0x00, 0x00, 0x01, 0x68, 0x00, 0x00, 0x00, 0x87, 0x00, 0x00,
+  0x01, 0x68, 0x00, 0x00, 0x07, 0x11, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee,
+  0x02, 0x2c, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75, 0x03, 0x71, 0xff, 0xee,
+  0x03, 0xa4, 0xff, 0xee, 0x06, 0x01, 0x00, 0x60, 0x03, 0x71, 0xff, 0xee,
+  0x03, 0xa4, 0xff, 0xee, 0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee,
+  0x01, 0x8a, 0x00, 0x00, 0x07, 0x11, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee,
+  0x02, 0x2c, 0xff, 0xee, 0x07, 0x11, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee,
+  0x02, 0x2c, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
+  0x04, 0xa5, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
+  0x04, 0xa5, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
+  0x04, 0xa5, 0xff, 0xee, 0x04, 0xa5, 0x00, 0x8d, 0x04, 0x73, 0xff, 0xee,
+  0x04, 0xa5, 0xff, 0xee, 0x03, 0x08, 0x00, 0x00, 0x05, 0x62, 0x00, 0xbf,
+  0x02, 0x00, 0x00, 0x0d, 0x02, 0xa3, 0xff, 0x0d, 0x04, 0xec, 0x01, 0x69,
+  0x04, 0xec, 0x01, 0x69, 0x04, 0xec, 0x01, 0x69, 0x04, 0xec, 0x01, 0x6a,
+  0x04, 0xec, 0x01, 0x6a, 0x04, 0xec, 0x01, 0x69, 0x04, 0xec, 0x01, 0x69,
+  0x04, 0xec, 0x01, 0x50, 0x04, 0xec, 0x01, 0x63, 0x04, 0xec, 0x01, 0x50,
+  0x04, 0xec, 0x01, 0x63, 0x04, 0xec, 0x01, 0x50, 0x04, 0xec, 0x01, 0x63,
+  0x04, 0xec, 0x01, 0x63, 0x04, 0xec, 0x01, 0x50, 0x04, 0xec, 0x01, 0x50,
+  0x04, 0xec, 0x01, 0x5c, 0x04, 0xec, 0x01, 0x5c, 0x04, 0xec, 0x01, 0x5c,
+  0x04, 0xec, 0x01, 0x63, 0x00, 0x00, 0xfc, 0xf1, 0x01, 0x0e, 0x00, 0x00,
+  0x03, 0xaf, 0x00, 0x00, 0x04, 0x65, 0xff, 0xb4, 0x04, 0x65, 0xff, 0xb4,
+  0x05, 0x73, 0x00, 0x81, 0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee,
+  0x06, 0x00, 0x00, 0x75, 0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee,
+  0x03, 0xf9, 0xff, 0xb4, 0x02, 0x00, 0x00, 0xad, 0x03, 0xdc, 0x00, 0x82,
+  0x05, 0x07, 0x00, 0x65, 0x04, 0x65, 0x00, 0x65, 0x02, 0x00, 0x00, 0x87,
+  0x02, 0x87, 0x00, 0x47, 0x02, 0x87, 0xff, 0x2e, 0x02, 0x00, 0xff, 0xd8,
+  0x02, 0x00, 0x00, 0xab, 0x02, 0x6d, 0x00, 0xd8, 0x03, 0x31, 0x00, 0x87,
+  0x06, 0x08, 0x01, 0x82, 0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xb4,
+  0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xb4,
+  0x00, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0xc6, 0x00, 0x00, 0x00, 0xc6,
+  0x02, 0x01, 0x00, 0xad, 0x02, 0x01, 0xff, 0xee, 0x02, 0x01, 0xff, 0xee,
+  0x04, 0x1d, 0x00, 0x65, 0x04, 0x1d, 0xff, 0xee, 0x04, 0x1d, 0xff, 0xee,
+  0x03, 0x0d, 0x00, 0x36, 0x03, 0x0d, 0xff, 0xee, 0x03, 0x0d, 0xff, 0xee,
+  0x04, 0x42, 0x00, 0x36, 0x04, 0x42, 0xff, 0xee, 0x04, 0x42, 0xff, 0xee,
+  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
+  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
+  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
+  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
+  0x05, 0xf7, 0x00, 0x65, 0x05, 0xf7, 0xff, 0xee, 0x05, 0xf7, 0xff, 0xee,
+  0x03, 0x27, 0x00, 0xad, 0x03, 0x27, 0xff, 0xee, 0x03, 0x27, 0xff, 0xee,
+  0x03, 0x27, 0x00, 0x36, 0x03, 0x27, 0xff, 0xee, 0x03, 0x27, 0xff, 0xee,
+  0x04, 0x05, 0x00, 0xa7, 0x04, 0x05, 0xff, 0xee, 0x04, 0x05, 0xff, 0xee,
+  0x04, 0x67, 0x00, 0xad, 0x04, 0x67, 0xff, 0xee, 0x04, 0x67, 0xff, 0xee,
+  0x02, 0x85, 0x00, 0x36, 0x02, 0x85, 0xff, 0xee, 0x02, 0x85, 0xff, 0xee,
+  0x06, 0xe7, 0x00, 0xad, 0x06, 0xe7, 0xff, 0xee, 0x06, 0xe7, 0xff, 0xee,
+  0x03, 0x67, 0x00, 0x36, 0x03, 0x67, 0xff, 0xee, 0x03, 0x67, 0xff, 0xee,
+  0x05, 0xa3, 0x00, 0x36, 0x05, 0xa3, 0xff, 0xee, 0x05, 0xa3, 0xff, 0xee,
+  0x04, 0xb5, 0x00, 0xa7, 0x04, 0xb5, 0xff, 0xee, 0x04, 0xb5, 0xff, 0xee,
+  0x04, 0x80, 0x00, 0x36, 0x04, 0x80, 0xff, 0xee, 0x04, 0x80, 0xff, 0xee,
+  0x05, 0x48, 0x00, 0xad, 0x05, 0x48, 0xff, 0xee, 0x05, 0x48, 0xff, 0xee,
+  0x03, 0xd0, 0x00, 0xad, 0x03, 0xd0, 0xff, 0xee, 0x03, 0xd0, 0xff, 0xee,
+  0x05, 0x36, 0x00, 0x64, 0x05, 0x36, 0xff, 0xee, 0x05, 0x36, 0xff, 0xee,
+  0x03, 0x67, 0x00, 0x36, 0x03, 0x67, 0xff, 0xee, 0x03, 0x67, 0xff, 0xee,
+  0x04, 0x80, 0x00, 0x36, 0x04, 0x80, 0xff, 0xee, 0x04, 0x80, 0xff, 0xee,
+  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
+  0x03, 0xd0, 0x00, 0xad, 0x03, 0xd0, 0xff, 0xee, 0x03, 0xd0, 0xff, 0xee,
+  0x03, 0xd0, 0x00, 0xad, 0x03, 0xd0, 0xff, 0xee, 0x03, 0xd0, 0xff, 0xee,
+  0x03, 0xc3, 0x00, 0xad, 0x03, 0xc3, 0xff, 0xee, 0x03, 0xc3, 0xff, 0xee,
+  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
+  0x04, 0x46, 0x00, 0x65, 0x04, 0x46, 0xff, 0xee, 0x04, 0x46, 0xff, 0xee,
+  0x00, 0x00, 0xfd, 0x3b, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99, 0x06, 0x74, 0x00, 0x99,
+  0x06, 0x07, 0x01, 0x6e, 0x05, 0x8f, 0x00, 0xb4, 0x04, 0xdf, 0x00, 0xad,
+  0x04, 0x90, 0x00, 0x9c, 0x03, 0xc7, 0x00, 0x70, 0x03, 0xc7, 0x00, 0x70,
+  0x03, 0xc7, 0x00, 0x70, 0x03, 0xc7, 0x00, 0x70, 0x03, 0xc7, 0x00, 0x70,
+  0x03, 0xf9, 0xff, 0xb4, 0x03, 0xf9, 0xff, 0xb4, 0x03, 0xf9, 0xff, 0xb4,
+  0x03, 0xf9, 0xff, 0xb4, 0x03, 0xf9, 0xff, 0xb4, 0x09, 0x2d, 0x00, 0x75,
+  0x06, 0x08, 0xff, 0xee, 0x06, 0x6c, 0xff, 0xee, 0x09, 0x2d, 0x00, 0x75,
+  0x06, 0x08, 0xff, 0xee, 0x06, 0x6c, 0xff, 0xee, 0x09, 0x2d, 0x00, 0x75,
+  0x06, 0x08, 0xff, 0xee, 0x06, 0x6c, 0xff, 0xee, 0x08, 0xd2, 0x00, 0x75,
+  0x06, 0x1d, 0xff, 0xee, 0x06, 0x3e, 0xff, 0xee, 0x08, 0xd2, 0x00, 0x75,
+  0x06, 0x1d, 0xff, 0xee, 0x06, 0x3e, 0xff, 0xee, 0x06, 0xd5, 0x00, 0x81,
+  0x05, 0xbb, 0xff, 0xee, 0x05, 0xe8, 0xff, 0xee, 0x03, 0xd5, 0x00, 0x69,
+  0x04, 0x4b, 0xff, 0xee, 0x03, 0x79, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75,
+  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75,
+  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x07, 0x74, 0x00, 0x75,
+  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x06, 0x01, 0x00, 0x60,
+  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x06, 0x01, 0x00, 0x60,
+  0x03, 0x71, 0xff, 0xee, 0x03, 0xa4, 0xff, 0xee, 0x07, 0x96, 0x00, 0x75,
+  0x06, 0x40, 0xff, 0xee, 0x06, 0x40, 0xff, 0xee, 0x06, 0x71, 0x00, 0x75,
+  0x03, 0x6d, 0xff, 0xee, 0x03, 0xf9, 0xff, 0xee, 0x06, 0x11, 0x00, 0x81,
+  0x03, 0x6d, 0xff, 0xee, 0x03, 0xf9, 0xff, 0xee, 0x06, 0x11, 0x00, 0x81,
+  0x03, 0x6d, 0xff, 0xee, 0x03, 0xf9, 0xff, 0xee, 0x06, 0x71, 0x03, 0x69,
+  0x03, 0x6d, 0x00, 0x64, 0x03, 0xf9, 0x00, 0x64, 0x06, 0x71, 0x02, 0x1c,
+  0x03, 0x6d, 0x00, 0x64, 0x03, 0xf9, 0x00, 0x64, 0x06, 0x71, 0x03, 0x2a,
+  0x03, 0x6d, 0x00, 0x43, 0x03, 0xf9, 0x00, 0x43, 0x05, 0x73, 0x00, 0x81,
+  0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee, 0x05, 0x73, 0x00, 0x81,
+  0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee, 0x05, 0x73, 0x00, 0x81,
+  0x02, 0x31, 0xff, 0xee, 0x02, 0x62, 0xff, 0xee, 0x05, 0x7b, 0x00, 0x84,
+  0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee, 0x05, 0x7b, 0x00, 0x84,
+  0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee, 0x05, 0x7b, 0x00, 0x84,
+  0x02, 0x01, 0xff, 0xee, 0x02, 0x2c, 0xff, 0xee, 0x00, 0x00, 0x00, 0x01,
+  0x00, 0x00, 0x3f, 0xf8, 0x00, 0x01, 0x0a, 0xa7, 0x30, 0x00, 0x00, 0x0b,
+  0x0f, 0xea, 0x00, 0x10, 0x00, 0x24, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x25,
+  0xff, 0xb7, 0x00, 0x10, 0x00, 0x2a, 0x00, 0x4b, 0x00, 0x10, 0x00, 0x2d,
+  0x00, 0x72, 0x00, 0x10, 0x00, 0x32, 0x00, 0x39, 0x00, 0x10, 0x00, 0x34,
+  0x00, 0x4b, 0x00, 0x10, 0x00, 0x37, 0xff, 0x44, 0x00, 0x10, 0x00, 0x39,
+  0xff, 0x88, 0x00, 0x10, 0x00, 0x3a, 0xff, 0xad, 0x00, 0x10, 0x00, 0x3b,
+  0xff, 0x9a, 0x00, 0x10, 0x00, 0x3c, 0xff, 0x0d, 0x00, 0x10, 0x00, 0x52,
+  0x00, 0x26, 0x00, 0x10, 0x00, 0x59, 0xff, 0xc9, 0x00, 0x10, 0x00, 0x5c,
+  0xff, 0xdc, 0x00, 0x10, 0x00, 0x82, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x83,
+  0xff, 0xd3, 0x00, 0x10, 0x00, 0x84, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x85,
+  0xff, 0xd3, 0x00, 0x10, 0x00, 0x86, 0xff, 0xd3, 0x00, 0x10, 0x00, 0x94,
+  0x00, 0x39, 0x00, 0x10, 0x00, 0x95, 0x00, 0x39, 0x00, 0x10, 0x00, 0x96,
+  0x00, 0x39, 0x00, 0x10, 0x00, 0x97, 0x00, 0x39, 0x00, 0x10, 0x00, 0x98,
+  0x00, 0x39, 0x00, 0x10, 0x00, 0x9f, 0xff, 0x0d, 0x00, 0x10, 0x00, 0xb4,
+  0x00, 0x26, 0x00, 0x10, 0x00, 0xb5, 0x00, 0x26, 0x00, 0x10, 0x00, 0xb6,
+  0x00, 0x26, 0x00, 0x10, 0x00, 0xb7, 0x00, 0x26, 0x00, 0x10, 0x00, 0xb8,
+  0x00, 0x26, 0x00, 0x10, 0x00, 0xbf, 0xff, 0xdc, 0x00, 0x10, 0x00, 0xc1,
+  0xff, 0xdc, 0x00, 0x10, 0x00, 0xc2, 0xff, 0xd3, 0x00, 0x10, 0x00, 0xc4,
+  0xff, 0xd3, 0x00, 0x10, 0x00, 0xc6, 0xff, 0xd3, 0x00, 0x10, 0x00, 0xe0,
+  0x00, 0x4b, 0x00, 0x10, 0x01, 0x26, 0xff, 0x44, 0x00, 0x10, 0x01, 0x3a,
+  0xff, 0x0d, 0x00, 0x24, 0x00, 0x10, 0xff, 0xd3, 0x00, 0x24, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x24,
+  0x00, 0x39, 0x00, 0x24, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x2a,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x32, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x34,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x37, 0xff, 0x61, 0x00, 0x24, 0x00, 0x39,
+  0xff, 0x7d, 0x00, 0x24, 0x00, 0x3a, 0xff, 0x90, 0x00, 0x24, 0x00, 0x3c,
+  0xff, 0x61, 0x00, 0x24, 0x00, 0x46, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x47,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x48, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x49,
+  0xff, 0xb7, 0x00, 0x24, 0x00, 0x52, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x54,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x57, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x59,
+  0xff, 0x88, 0x00, 0x24, 0x00, 0x5a, 0xff, 0xad, 0x00, 0x24, 0x00, 0x5c,
+  0xff, 0x75, 0x00, 0x24, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0x24, 0x00, 0x82,
+  0x00, 0x39, 0x00, 0x24, 0x00, 0x83, 0x00, 0x39, 0x00, 0x24, 0x00, 0x84,
+  0x00, 0x39, 0x00, 0x24, 0x00, 0x85, 0x00, 0x39, 0x00, 0x24, 0x00, 0x86,
+  0x00, 0x39, 0x00, 0x24, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x94,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x96,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x24, 0x00, 0x98,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0x9f, 0xff, 0x61, 0x00, 0x24, 0x00, 0xa9,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xab,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xac, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xad,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xb5,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xb7,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xbf,
+  0xff, 0x75, 0x00, 0x24, 0x00, 0xc1, 0xff, 0x75, 0x00, 0x24, 0x00, 0xc2,
+  0x00, 0x39, 0x00, 0x24, 0x00, 0xc4, 0x00, 0x39, 0x00, 0x24, 0x00, 0xc6,
+  0x00, 0x39, 0x00, 0x24, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xc9,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xca, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xcb,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xcd,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xcf,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xd3,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xd7,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xdb,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xde,
+  0xff, 0xdc, 0x00, 0x24, 0x00, 0xe0, 0xff, 0xdc, 0x00, 0x24, 0x00, 0xe2,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0x0e, 0xff, 0xdc, 0x00, 0x24, 0x01, 0x0f,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0x10, 0xff, 0xdc, 0x00, 0x24, 0x01, 0x11,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0x12, 0xff, 0xdc, 0x00, 0x24, 0x01, 0x13,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0x24, 0xff, 0x61, 0x00, 0x24, 0x01, 0x25,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0x26, 0xff, 0x61, 0x00, 0x24, 0x01, 0x27,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0x36, 0xff, 0x90, 0x00, 0x24, 0x01, 0x37,
+  0xff, 0xad, 0x00, 0x24, 0x01, 0x38, 0xff, 0x61, 0x00, 0x24, 0x01, 0x39,
+  0xff, 0x75, 0x00, 0x24, 0x01, 0x3a, 0xff, 0x61, 0x00, 0x24, 0x01, 0x88,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0xac, 0xff, 0xdc, 0x00, 0x24, 0x01, 0xad,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0xae, 0xff, 0xdc, 0x00, 0x24, 0x01, 0xaf,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0xdc, 0xff, 0x61, 0x00, 0x24, 0x01, 0xdd,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x24, 0x01, 0xf3,
+  0xff, 0xdc, 0x00, 0x24, 0x01, 0xf4, 0xff, 0x61, 0x00, 0x24, 0x01, 0xf5,
+  0xff, 0x75, 0x00, 0x24, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x24, 0x05, 0xd1,
+  0xff, 0xad, 0x00, 0x24, 0x05, 0xd2, 0xff, 0x90, 0x00, 0x24, 0x05, 0xd3,
+  0xff, 0xad, 0x00, 0x24, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x24, 0x05, 0xd5,
+  0xff, 0xad, 0x00, 0x24, 0x06, 0x42, 0xff, 0x61, 0x00, 0x24, 0x06, 0x43,
+  0xff, 0x75, 0x00, 0x24, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x24, 0x07, 0x52,
+  0xff, 0x03, 0x00, 0x24, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x25, 0x00, 0x26,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x32,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0x36, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x39,
+  0xff, 0xc1, 0x00, 0x25, 0x00, 0x3a, 0xff, 0xb7, 0x00, 0x25, 0x00, 0x3c,
+  0xff, 0x90, 0x00, 0x25, 0x00, 0x6d, 0xff, 0xc1, 0x00, 0x25, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x94,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x96,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x25, 0x00, 0x98,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0x9f, 0xff, 0x90, 0x00, 0x25, 0x00, 0xc8,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0xca, 0xff, 0xdc, 0x00, 0x25, 0x00, 0xcc,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x25, 0x00, 0xde,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0xe0, 0xff, 0xdc, 0x00, 0x25, 0x00, 0xe2,
+  0xff, 0xdc, 0x00, 0x25, 0x00, 0xe4, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x0e,
+  0xff, 0xdc, 0x00, 0x25, 0x01, 0x10, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x12,
+  0xff, 0xdc, 0x00, 0x25, 0x01, 0x1c, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x1e,
+  0xff, 0xdc, 0x00, 0x25, 0x01, 0x20, 0xff, 0xdc, 0x00, 0x25, 0x01, 0x22,
+  0xff, 0xdc, 0x00, 0x25, 0x01, 0x36, 0xff, 0xb7, 0x00, 0x25, 0x01, 0x38,
+  0xff, 0x90, 0x00, 0x25, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x25, 0x01, 0xac,
+  0xff, 0xdc, 0x00, 0x25, 0x01, 0xae, 0xff, 0xdc, 0x00, 0x25, 0x01, 0xda,
+  0xff, 0xdc, 0x00, 0x25, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x25, 0x05, 0xd0,
+  0xff, 0xb7, 0x00, 0x25, 0x05, 0xd2, 0xff, 0xb7, 0x00, 0x25, 0x05, 0xd4,
+  0xff, 0xb7, 0x00, 0x25, 0x06, 0x42, 0xff, 0x90, 0x00, 0x25, 0x07, 0x51,
+  0xff, 0x90, 0x00, 0x25, 0x07, 0x52, 0xff, 0x90, 0x00, 0x25, 0x07, 0x53,
+  0xff, 0xad, 0x00, 0x26, 0x00, 0x3c, 0xff, 0xdc, 0x00, 0x26, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0x26, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x26, 0x00, 0x9f,
+  0xff, 0xdc, 0x00, 0x26, 0x01, 0x38, 0xff, 0xdc, 0x00, 0x26, 0x01, 0x3a,
+  0xff, 0xdc, 0x00, 0x26, 0x01, 0xf4, 0xff, 0xdc, 0x00, 0x26, 0x06, 0x42,
+  0xff, 0xdc, 0x00, 0x26, 0x07, 0x52, 0x00, 0x26, 0x00, 0x27, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x27, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x3c,
+  0xff, 0x90, 0x00, 0x27, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x27, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x27, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x27, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x27, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0x27, 0x00, 0xc2, 0xff, 0xdc, 0x00, 0x27, 0x00, 0xc4,
+  0xff, 0xdc, 0x00, 0x27, 0x00, 0xc6, 0xff, 0xdc, 0x00, 0x27, 0x01, 0x38,
+  0xff, 0x90, 0x00, 0x27, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x27, 0x01, 0xf4,
+  0xff, 0x90, 0x00, 0x27, 0x06, 0x42, 0xff, 0x90, 0x00, 0x27, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x27, 0x07, 0x52, 0xff, 0xc9, 0x00, 0x27, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0x11, 0xfe, 0xb7, 0x00, 0x29, 0x00, 0x1d,
+  0xff, 0x61, 0x00, 0x29, 0x00, 0x24, 0xff, 0x44, 0x00, 0x29, 0x00, 0x36,
+  0xff, 0xdc, 0x00, 0x29, 0x00, 0x37, 0xff, 0xdc, 0x00, 0x29, 0x00, 0x44,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0x48, 0xff, 0x90, 0x00, 0x29, 0x00, 0x4c,
+  0xff, 0x6b, 0x00, 0x29, 0x00, 0x52, 0xff, 0xb7, 0x00, 0x29, 0x00, 0x55,
+  0xff, 0x6b, 0x00, 0x29, 0x00, 0x58, 0xff, 0x90, 0x00, 0x29, 0x00, 0x5c,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0x82, 0xff, 0x44, 0x00, 0x29, 0x00, 0x83,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0x84, 0xff, 0x44, 0x00, 0x29, 0x00, 0x85,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0x86, 0xff, 0x44, 0x00, 0x29, 0x00, 0xa2,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0xa3, 0xff, 0x44, 0x00, 0x29, 0x00, 0xa4,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0xa5, 0xff, 0x44, 0x00, 0x29, 0x00, 0xa6,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0xa7, 0xff, 0x44, 0x00, 0x29, 0x00, 0xaa,
+  0xff, 0x90, 0x00, 0x29, 0x00, 0xab, 0xff, 0x90, 0x00, 0x29, 0x00, 0xac,
+  0xff, 0x90, 0x00, 0x29, 0x00, 0xad, 0xff, 0x90, 0x00, 0x29, 0x00, 0xb4,
+  0xff, 0xb7, 0x00, 0x29, 0x00, 0xb5, 0xff, 0xb7, 0x00, 0x29, 0x00, 0xb6,
+  0xff, 0xb7, 0x00, 0x29, 0x00, 0xb7, 0xff, 0xb7, 0x00, 0x29, 0x00, 0xb8,
+  0xff, 0xb7, 0x00, 0x29, 0x00, 0xbb, 0xff, 0x90, 0x00, 0x29, 0x00, 0xbc,
+  0xff, 0x90, 0x00, 0x29, 0x00, 0xbd, 0xff, 0x90, 0x00, 0x29, 0x00, 0xbe,
+  0xff, 0x90, 0x00, 0x29, 0x00, 0xbf, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc1,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0xc2, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc3,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0xc4, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc5,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0xc6, 0xff, 0x44, 0x00, 0x29, 0x00, 0xc7,
+  0xff, 0x44, 0x00, 0x29, 0x00, 0xd5, 0xff, 0x90, 0x00, 0x29, 0x00, 0xd7,
+  0xff, 0x90, 0x00, 0x29, 0x00, 0xd9, 0xff, 0x90, 0x00, 0x29, 0x00, 0xdb,
+  0xff, 0x90, 0x00, 0x29, 0x00, 0xdd, 0xff, 0x90, 0x00, 0x29, 0x00, 0xf1,
+  0xff, 0x6b, 0x00, 0x29, 0x00, 0xf5, 0xff, 0x6b, 0x00, 0x29, 0x01, 0x0f,
+  0xff, 0xb7, 0x00, 0x29, 0x01, 0x11, 0xff, 0xb7, 0x00, 0x29, 0x01, 0x13,
+  0xff, 0xb7, 0x00, 0x29, 0x01, 0x17, 0xff, 0x6b, 0x00, 0x29, 0x01, 0x19,
+  0xff, 0x6b, 0x00, 0x29, 0x01, 0x1b, 0xff, 0x6b, 0x00, 0x29, 0x01, 0x1c,
+  0xff, 0xdc, 0x00, 0x29, 0x01, 0x1e, 0xff, 0xdc, 0x00, 0x29, 0x01, 0x20,
+  0xff, 0xdc, 0x00, 0x29, 0x01, 0x22, 0xff, 0xdc, 0x00, 0x29, 0x01, 0x24,
+  0xff, 0xdc, 0x00, 0x29, 0x01, 0x26, 0xff, 0xdc, 0x00, 0x29, 0x01, 0x28,
+  0xff, 0xdc, 0x00, 0x29, 0x01, 0x2b, 0xff, 0x90, 0x00, 0x29, 0x01, 0x2d,
+  0xff, 0x90, 0x00, 0x29, 0x01, 0x2f, 0xff, 0x90, 0x00, 0x29, 0x01, 0x31,
+  0xff, 0x90, 0x00, 0x29, 0x01, 0x33, 0xff, 0x90, 0x00, 0x29, 0x01, 0x35,
+  0xff, 0x90, 0x00, 0x29, 0x01, 0x39, 0xff, 0x44, 0x00, 0x29, 0x01, 0xad,
+  0xff, 0xb7, 0x00, 0x29, 0x01, 0xaf, 0xff, 0xb7, 0x00, 0x29, 0x01, 0xda,
+  0xff, 0xdc, 0x00, 0x29, 0x01, 0xdc, 0xff, 0xdc, 0x00, 0x29, 0x01, 0xf1,
+  0xff, 0xb7, 0x00, 0x29, 0x01, 0xf5, 0xff, 0x44, 0x00, 0x29, 0x06, 0x43,
+  0xff, 0x44, 0x00, 0x29, 0x07, 0x51, 0xff, 0xd3, 0x00, 0x29, 0x07, 0x53,
+  0xfe, 0x88, 0x00, 0x2a, 0x00, 0x37, 0xff, 0xb7, 0x00, 0x2a, 0x00, 0x3c,
+  0xff, 0x9a, 0x00, 0x2a, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x2a, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x2a, 0x00, 0x9f, 0xff, 0x9a, 0x00, 0x2a, 0x01, 0x26,
+  0xff, 0xb7, 0x00, 0x2a, 0x01, 0x3a, 0xff, 0x9a, 0x00, 0x2a, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x2a, 0x07, 0x52, 0xff, 0xd3, 0x00, 0x2a, 0x07, 0x53,
+  0xff, 0xc9, 0x00, 0x2b, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x2b, 0x07, 0x51,
+  0xff, 0xb7, 0x00, 0x2b, 0x07, 0x52, 0xff, 0xc1, 0x00, 0x2b, 0x07, 0x53,
+  0xff, 0xb7, 0x00, 0x2d, 0x00, 0x10, 0xff, 0xb7, 0x00, 0x2d, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x2d, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x2d, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x2d, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x2d, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x2d, 0x07, 0x51,
+  0xff, 0xb7, 0x00, 0x2d, 0x07, 0x52, 0xff, 0xc1, 0x00, 0x2d, 0x07, 0x53,
+  0xff, 0x90, 0x00, 0x2e, 0x00, 0x10, 0xff, 0x29, 0x00, 0x2e, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x2e, 0x00, 0x26, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x32,
+  0xff, 0x90, 0x00, 0x2e, 0x00, 0x37, 0xff, 0x61, 0x00, 0x2e, 0x00, 0x38,
+  0xff, 0xc9, 0x00, 0x2e, 0x00, 0x3a, 0xff, 0xb7, 0x00, 0x2e, 0x00, 0x3c,
+  0xff, 0xb7, 0x00, 0x2e, 0x00, 0x44, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x48,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0x52, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0x58,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0x5c, 0xff, 0x6b, 0x00, 0x2e, 0x00, 0x6d,
+  0xff, 0x7d, 0x00, 0x2e, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x2e, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x2e, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0x89,
+  0xff, 0x90, 0x00, 0x2e, 0x00, 0x94, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x95,
+  0xff, 0x90, 0x00, 0x2e, 0x00, 0x96, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x97,
+  0xff, 0x90, 0x00, 0x2e, 0x00, 0x98, 0xff, 0x90, 0x00, 0x2e, 0x00, 0x9b,
+  0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9c, 0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9d,
+  0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9e, 0xff, 0xc9, 0x00, 0x2e, 0x00, 0x9f,
+  0xff, 0xb7, 0x00, 0x2e, 0x00, 0xa2, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa3,
+  0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa4, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa5,
+  0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa6, 0xff, 0xdc, 0x00, 0x2e, 0x00, 0xa7,
+  0xff, 0xdc, 0x00, 0x2e, 0x00, 0xaa, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xab,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xac, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xad,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb4, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb5,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb6, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb7,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xb8, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbb,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbc, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbd,
+  0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbe, 0xff, 0x9a, 0x00, 0x2e, 0x00, 0xbf,
+  0xff, 0x6b, 0x00, 0x2e, 0x00, 0xc1, 0xff, 0x6b, 0x00, 0x2e, 0x00, 0xc8,
+  0xff, 0x90, 0x00, 0x2e, 0x00, 0xce, 0xff, 0x90, 0x00, 0x2e, 0x00, 0xdd,
+  0xff, 0x9a, 0x00, 0x2e, 0x01, 0x26, 0xff, 0x61, 0x00, 0x2e, 0x01, 0x30,
+  0xff, 0xc9, 0x00, 0x2e, 0x01, 0x31, 0xff, 0x9a, 0x00, 0x2e, 0x01, 0x3a,
+  0xff, 0xb7, 0x00, 0x2e, 0x07, 0x51, 0xff, 0xc1, 0x00, 0x2e, 0x07, 0x52,
+  0xff, 0xc1, 0x00, 0x2f, 0x00, 0x10, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0x24,
+  0x00, 0x2f, 0x00, 0x2f, 0x00, 0x32, 0xff, 0xb7, 0x00, 0x2f, 0x00, 0x37,
+  0xfe, 0xe6, 0x00, 0x2f, 0x00, 0x38, 0xff, 0x9a, 0x00, 0x2f, 0x00, 0x39,
+  0xff, 0x1f, 0x00, 0x2f, 0x00, 0x3a, 0xff, 0x44, 0x00, 0x2f, 0x00, 0x3c,
+  0xfe, 0xf0, 0x00, 0x2f, 0x00, 0x48, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0x52,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0x58, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0x5c,
+  0xff, 0x44, 0x00, 0x2f, 0x00, 0x82, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x83,
+  0x00, 0x2f, 0x00, 0x2f, 0x00, 0x84, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x85,
+  0x00, 0x2f, 0x00, 0x2f, 0x00, 0x86, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x94,
+  0xff, 0xb7, 0x00, 0x2f, 0x00, 0x95, 0xff, 0xb7, 0x00, 0x2f, 0x00, 0x96,
+  0xff, 0xb7, 0x00, 0x2f, 0x00, 0x97, 0xff, 0xb7, 0x00, 0x2f, 0x00, 0x98,
+  0xff, 0xb7, 0x00, 0x2f, 0x00, 0x9b, 0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9c,
+  0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9d, 0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9e,
+  0xff, 0x9a, 0x00, 0x2f, 0x00, 0x9f, 0xfe, 0xf0, 0x00, 0x2f, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbb, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbc,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbd, 0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbe,
+  0xff, 0xdc, 0x00, 0x2f, 0x00, 0xbf, 0xff, 0x44, 0x00, 0x2f, 0x00, 0xc1,
+  0xff, 0x44, 0x00, 0x2f, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0x2f, 0x01, 0x26,
+  0xfe, 0xe6, 0x00, 0x2f, 0x01, 0x30, 0xff, 0x9a, 0x00, 0x2f, 0x01, 0x31,
+  0xff, 0xdc, 0x00, 0x2f, 0x01, 0x3a, 0xfe, 0xf0, 0x00, 0x2f, 0x07, 0x51,
+  0xfe, 0x61, 0x00, 0x2f, 0x07, 0x52, 0xfd, 0xe6, 0x00, 0x32, 0x00, 0x10,
+  0x00, 0x39, 0x00, 0x32, 0x00, 0x11, 0xff, 0xad, 0x00, 0x32, 0x00, 0x1d,
+  0xff, 0xdc, 0x00, 0x32, 0x00, 0x24, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x39,
+  0xff, 0xdc, 0x00, 0x32, 0x00, 0x3b, 0xff, 0x7d, 0x00, 0x32, 0x00, 0x3c,
+  0xff, 0x90, 0x00, 0x32, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x82,
+  0xff, 0xdc, 0x00, 0x32, 0x00, 0x83, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x84,
+  0xff, 0xdc, 0x00, 0x32, 0x00, 0x85, 0xff, 0xdc, 0x00, 0x32, 0x00, 0x86,
+  0xff, 0xdc, 0x00, 0x32, 0x00, 0x9f, 0xff, 0x90, 0x00, 0x32, 0x01, 0x3a,
+  0xff, 0x90, 0x00, 0x32, 0x07, 0x51, 0xff, 0xd3, 0x00, 0x32, 0x07, 0x52,
+  0xff, 0xdc, 0x00, 0x32, 0x07, 0x53, 0xff, 0x44, 0x00, 0x33, 0x00, 0x10,
+  0xff, 0xd3, 0x00, 0x33, 0x00, 0x11, 0xfe, 0xc1, 0x00, 0x33, 0x00, 0x24,
+  0xff, 0x7d, 0x00, 0x33, 0x00, 0x3c, 0xff, 0xd3, 0x00, 0x33, 0x00, 0x44,
+  0xff, 0xa4, 0x00, 0x33, 0x00, 0x48, 0xff, 0xb7, 0x00, 0x33, 0x00, 0x4c,
+  0xff, 0xd3, 0x00, 0x33, 0x00, 0x51, 0xff, 0xdc, 0x00, 0x33, 0x00, 0x52,
+  0xff, 0xb7, 0x00, 0x33, 0x00, 0x55, 0xff, 0xdc, 0x00, 0x33, 0x00, 0x56,
+  0xff, 0xdc, 0x00, 0x33, 0x00, 0x58, 0xff, 0xdc, 0x00, 0x33, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0x33, 0x00, 0x82, 0xff, 0x7d, 0x00, 0x33, 0x00, 0x83,
+  0xff, 0x7d, 0x00, 0x33, 0x00, 0x84, 0xff, 0x7d, 0x00, 0x33, 0x00, 0x85,
+  0xff, 0x7d, 0x00, 0x33, 0x00, 0x86, 0xff, 0x7d, 0x00, 0x33, 0x00, 0x9f,
+  0xff, 0xd3, 0x00, 0x33, 0x00, 0xa2, 0xff, 0xa4, 0x00, 0x33, 0x00, 0xa3,
+  0xff, 0xa4, 0x00, 0x33, 0x00, 0xa4, 0xff, 0xa4, 0x00, 0x33, 0x00, 0xa5,
+  0xff, 0xa4, 0x00, 0x33, 0x00, 0xa6, 0xff, 0xa4, 0x00, 0x33, 0x00, 0xa7,
+  0xff, 0xa4, 0x00, 0x33, 0x00, 0xaa, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xab,
+  0xff, 0xb7, 0x00, 0x33, 0x00, 0xac, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xad,
+  0xff, 0xb7, 0x00, 0x33, 0x00, 0xb3, 0xff, 0xdc, 0x00, 0x33, 0x00, 0xb4,
+  0xff, 0xb7, 0x00, 0x33, 0x00, 0xb5, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xb6,
+  0xff, 0xb7, 0x00, 0x33, 0x00, 0xb7, 0xff, 0xb7, 0x00, 0x33, 0x00, 0xb8,
+  0xff, 0xb7, 0x00, 0x33, 0x00, 0xbb, 0xff, 0xdc, 0x00, 0x33, 0x00, 0xbc,
+  0xff, 0xdc, 0x00, 0x33, 0x00, 0xbd, 0xff, 0xdc, 0x00, 0x33, 0x00, 0xbe,
+  0xff, 0xdc, 0x00, 0x33, 0x00, 0xdd, 0xff, 0xb7, 0x00, 0x33, 0x01, 0x0a,
+  0xff, 0xdc, 0x00, 0x33, 0x01, 0x17, 0xff, 0xdc, 0x00, 0x33, 0x01, 0x1b,
+  0xff, 0xdc, 0x00, 0x33, 0x01, 0x21, 0xff, 0xdc, 0x00, 0x33, 0x01, 0x23,
+  0xff, 0xdc, 0x00, 0x33, 0x01, 0x31, 0xff, 0xdc, 0x00, 0x33, 0x01, 0x3a,
+  0xff, 0xd3, 0x00, 0x33, 0x07, 0x51, 0x00, 0x26, 0x00, 0x33, 0x07, 0x52,
+  0x00, 0x26, 0x00, 0x33, 0x07, 0x53, 0xfe, 0xb7, 0x00, 0x34, 0x00, 0x10,
+  0x00, 0x39, 0x00, 0x34, 0x07, 0x51, 0xff, 0xd3, 0x00, 0x34, 0x07, 0x52,
+  0xff, 0xdc, 0x00, 0x34, 0x07, 0x53, 0xff, 0x7d, 0x00, 0x35, 0x00, 0x10,
+  0xff, 0xad, 0x00, 0x35, 0x00, 0x11, 0xff, 0xb7, 0x00, 0x35, 0x00, 0x1d,
+  0xff, 0xc1, 0x00, 0x35, 0x00, 0x24, 0xff, 0xad, 0x00, 0x35, 0x00, 0x26,
+  0xff, 0x9a, 0x00, 0x35, 0x00, 0x37, 0xff, 0x6b, 0x00, 0x35, 0x00, 0x39,
+  0xff, 0x90, 0x00, 0x35, 0x00, 0x3a, 0xff, 0xad, 0x00, 0x35, 0x00, 0x3c,
+  0xff, 0x7d, 0x00, 0x35, 0x00, 0x44, 0xff, 0xd3, 0x00, 0x35, 0x00, 0x48,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0x52, 0xff, 0xa4, 0x00, 0x35, 0x00, 0x58,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0x5c, 0xff, 0x90, 0x00, 0x35, 0x00, 0x6d,
+  0xff, 0x90, 0x00, 0x35, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x35, 0x00, 0x82,
+  0xff, 0xad, 0x00, 0x35, 0x00, 0x83, 0xff, 0xad, 0x00, 0x35, 0x00, 0x84,
+  0xff, 0xad, 0x00, 0x35, 0x00, 0x85, 0xff, 0xad, 0x00, 0x35, 0x00, 0x86,
+  0xff, 0xad, 0x00, 0x35, 0x00, 0x89, 0xff, 0x9a, 0x00, 0x35, 0x00, 0x9f,
+  0xff, 0x7d, 0x00, 0x35, 0x00, 0xa2, 0xff, 0xd3, 0x00, 0x35, 0x00, 0xa3,
+  0xff, 0xd3, 0x00, 0x35, 0x00, 0xa4, 0xff, 0xd3, 0x00, 0x35, 0x00, 0xa5,
+  0xff, 0xd3, 0x00, 0x35, 0x00, 0xa6, 0xff, 0xd3, 0x00, 0x35, 0x00, 0xa7,
+  0xff, 0xd3, 0x00, 0x35, 0x00, 0xaa, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xab,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0xac, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xad,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0xb4, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xb5,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0xb6, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xb7,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0xb8, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xbb,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0xbc, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xbd,
+  0xff, 0xa4, 0x00, 0x35, 0x00, 0xbe, 0xff, 0xa4, 0x00, 0x35, 0x00, 0xbf,
+  0xff, 0x90, 0x00, 0x35, 0x00, 0xc1, 0xff, 0x90, 0x00, 0x35, 0x00, 0xc8,
+  0xff, 0x9a, 0x00, 0x35, 0x00, 0xce, 0xff, 0x9a, 0x00, 0x35, 0x00, 0xdd,
+  0xff, 0xa4, 0x00, 0x35, 0x01, 0x26, 0xff, 0x6b, 0x00, 0x35, 0x01, 0x31,
+  0xff, 0xa4, 0x00, 0x35, 0x01, 0x3a, 0xff, 0x7d, 0x00, 0x35, 0x07, 0x51,
+  0xff, 0x6b, 0x00, 0x35, 0x07, 0x52, 0xff, 0x7d, 0x00, 0x35, 0x07, 0x53,
+  0xff, 0xdc, 0x00, 0x36, 0x00, 0x24, 0x00, 0x26, 0x00, 0x36, 0x00, 0x82,
+  0x00, 0x26, 0x00, 0x36, 0x00, 0x83, 0x00, 0x26, 0x00, 0x36, 0x00, 0x84,
+  0x00, 0x26, 0x00, 0x36, 0x00, 0x85, 0x00, 0x26, 0x00, 0x36, 0x00, 0x86,
+  0x00, 0x26, 0x00, 0x37, 0x00, 0x10, 0xff, 0x44, 0x00, 0x37, 0x00, 0x11,
+  0xff, 0x0d, 0x00, 0x37, 0x00, 0x1d, 0xff, 0x1f, 0x00, 0x37, 0x00, 0x24,
+  0xff, 0x61, 0x00, 0x37, 0x00, 0x26, 0xff, 0x88, 0x00, 0x37, 0x00, 0x37,
+  0xff, 0xdc, 0x00, 0x37, 0x00, 0x44, 0xfe, 0xad, 0x00, 0x37, 0x00, 0x46,
+  0xfe, 0xa4, 0x00, 0x37, 0x00, 0x48, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0x4c,
+  0xff, 0xc1, 0x00, 0x37, 0x00, 0x52, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0x55,
+  0xfe, 0xd3, 0x00, 0x37, 0x00, 0x56, 0xfe, 0xad, 0x00, 0x37, 0x00, 0x58,
+  0xfe, 0xc9, 0x00, 0x37, 0x00, 0x5a, 0xfe, 0xad, 0x00, 0x37, 0x00, 0x5c,
+  0xfe, 0xc1, 0x00, 0x37, 0x00, 0x6d, 0xff, 0x44, 0x00, 0x37, 0x00, 0x7d,
+  0xff, 0x90, 0x00, 0x37, 0x00, 0x82, 0xff, 0x61, 0x00, 0x37, 0x00, 0x83,
+  0xff, 0x61, 0x00, 0x37, 0x00, 0x84, 0xff, 0x61, 0x00, 0x37, 0x00, 0x85,
+  0xff, 0x61, 0x00, 0x37, 0x00, 0x86, 0xff, 0x61, 0x00, 0x37, 0x00, 0x89,
+  0xff, 0x88, 0x00, 0x37, 0x00, 0xa2, 0xff, 0x11, 0x00, 0x37, 0x00, 0xa3,
+  0xfe, 0xad, 0x00, 0x37, 0x00, 0xa4, 0xff, 0x11, 0x00, 0x37, 0x00, 0xa5,
+  0xff, 0x11, 0x00, 0x37, 0x00, 0xa6, 0xff, 0x11, 0x00, 0x37, 0x00, 0xa7,
+  0xff, 0x11, 0x00, 0x37, 0x00, 0xa9, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0xaa,
+  0xfe, 0xe0, 0x00, 0x37, 0x00, 0xab, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0xac,
+  0xfe, 0xe0, 0x00, 0x37, 0x00, 0xad, 0xfe, 0xe0, 0x00, 0x37, 0x00, 0xb4,
+  0xfe, 0xf4, 0x00, 0x37, 0x00, 0xb5, 0xfe, 0xa4, 0x00, 0x37, 0x00, 0xb6,
+  0xfe, 0xf4, 0x00, 0x37, 0x00, 0xb7, 0xfe, 0xf4, 0x00, 0x37, 0x00, 0xb8,
+  0xfe, 0xf4, 0x00, 0x37, 0x00, 0xbb, 0xfe, 0xe7, 0x00, 0x37, 0x00, 0xbc,
+  0xfe, 0xc9, 0x00, 0x37, 0x00, 0xbd, 0xfe, 0xe7, 0x00, 0x37, 0x00, 0xbe,
+  0xfe, 0xe7, 0x00, 0x37, 0x00, 0xbf, 0xfe, 0xc1, 0x00, 0x37, 0x00, 0xc1,
+  0xfe, 0xc1, 0x00, 0x37, 0x00, 0xc8, 0xff, 0x88, 0x00, 0x37, 0x00, 0xc9,
+  0xfe, 0xa4, 0x00, 0x37, 0x00, 0xce, 0xff, 0x88, 0x00, 0x37, 0x00, 0xcf,
+  0xfe, 0xa4, 0x00, 0x37, 0x00, 0xdd, 0xfe, 0xa4, 0x00, 0x37, 0x01, 0x17,
+  0xfe, 0xd3, 0x00, 0x37, 0x01, 0x1b, 0xfe, 0xd3, 0x00, 0x37, 0x01, 0x21,
+  0xfe, 0xad, 0x00, 0x37, 0x01, 0x23, 0xfe, 0xad, 0x00, 0x37, 0x01, 0x26,
+  0xff, 0xdc, 0x00, 0x37, 0x01, 0x31, 0xfe, 0xc9, 0x00, 0x37, 0x07, 0x52,
+  0xff, 0xd3, 0x00, 0x37, 0x07, 0x53, 0xfe, 0xf8, 0x00, 0x38, 0x00, 0x3d,
+  0xff, 0xdc, 0x00, 0x38, 0x01, 0x3f, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x10,
+  0xff, 0x88, 0x00, 0x39, 0x00, 0x11, 0xfe, 0xf8, 0x00, 0x39, 0x00, 0x1d,
+  0xff, 0x59, 0x00, 0x39, 0x00, 0x24, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x32,
+  0xff, 0xdc, 0x00, 0x39, 0x00, 0x44, 0xff, 0x61, 0x00, 0x39, 0x00, 0x48,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0x4c, 0xff, 0xd3, 0x00, 0x39, 0x00, 0x52,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0x58, 0xff, 0x75, 0x00, 0x39, 0x00, 0x5c,
+  0xff, 0xc9, 0x00, 0x39, 0x00, 0x6d, 0xff, 0x4e, 0x00, 0x39, 0x00, 0x7d,
+  0xff, 0x90, 0x00, 0x39, 0x00, 0x82, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x83,
+  0xff, 0x7d, 0x00, 0x39, 0x00, 0x84, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x85,
+  0xff, 0x7d, 0x00, 0x39, 0x00, 0x86, 0xff, 0x7d, 0x00, 0x39, 0x00, 0x94,
+  0xff, 0xdc, 0x00, 0x39, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x96,
+  0xff, 0xdc, 0x00, 0x39, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x39, 0x00, 0x98,
+  0xff, 0xdc, 0x00, 0x39, 0x00, 0xa2, 0xff, 0x61, 0x00, 0x39, 0x00, 0xa3,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0xa4, 0xff, 0x61, 0x00, 0x39, 0x00, 0xa5,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0xa6, 0xff, 0x61, 0x00, 0x39, 0x00, 0xa7,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0xaa, 0xff, 0x61, 0x00, 0x39, 0x00, 0xab,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0xac, 0xff, 0x61, 0x00, 0x39, 0x00, 0xad,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0xb4, 0xff, 0x61, 0x00, 0x39, 0x00, 0xb5,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0xb6, 0xff, 0x61, 0x00, 0x39, 0x00, 0xb7,
+  0xff, 0x61, 0x00, 0x39, 0x00, 0xb8, 0xff, 0x61, 0x00, 0x39, 0x00, 0xbb,
+  0xff, 0x75, 0x00, 0x39, 0x00, 0xbc, 0xff, 0x75, 0x00, 0x39, 0x00, 0xbd,
+  0xff, 0x75, 0x00, 0x39, 0x00, 0xbe, 0xff, 0x75, 0x00, 0x39, 0x00, 0xbf,
+  0xff, 0xc9, 0x00, 0x39, 0x00, 0xc1, 0xff, 0xc9, 0x00, 0x39, 0x00, 0xdd,
+  0xff, 0x61, 0x00, 0x39, 0x01, 0x31, 0xff, 0x75, 0x00, 0x39, 0x07, 0x53,
+  0xfe, 0xe6, 0x00, 0x3a, 0x00, 0x10, 0xff, 0xad, 0x00, 0x3a, 0x00, 0x11,
+  0xff, 0x15, 0x00, 0x3a, 0x00, 0x1d, 0xff, 0x88, 0x00, 0x3a, 0x00, 0x24,
+  0xff, 0x90, 0x00, 0x3a, 0x00, 0x44, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0x48,
+  0xff, 0x88, 0x00, 0x3a, 0x00, 0x4c, 0xff, 0xd3, 0x00, 0x3a, 0x00, 0x52,
+  0xff, 0x88, 0x00, 0x3a, 0x00, 0x55, 0xff, 0xa4, 0x00, 0x3a, 0x00, 0x58,
+  0xff, 0xb7, 0x00, 0x3a, 0x00, 0x5c, 0xff, 0xdc, 0x00, 0x3a, 0x00, 0x6d,
+  0xff, 0x90, 0x00, 0x3a, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x3a, 0x00, 0x82,
+  0xff, 0x90, 0x00, 0x3a, 0x00, 0x83, 0xff, 0x90, 0x00, 0x3a, 0x00, 0x84,
+  0xff, 0x90, 0x00, 0x3a, 0x00, 0x85, 0xff, 0x90, 0x00, 0x3a, 0x00, 0x86,
+  0xff, 0x90, 0x00, 0x3a, 0x00, 0xa2, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa3,
+  0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa4, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa5,
+  0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa6, 0xff, 0x7d, 0x00, 0x3a, 0x00, 0xa7,
+  0xff, 0x7d, 0x00, 0x3a, 0x00, 0xaa, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xab,
+  0xff, 0x88, 0x00, 0x3a, 0x00, 0xac, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xad,
+  0xff, 0x88, 0x00, 0x3a, 0x00, 0xb4, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xb5,
+  0xff, 0x88, 0x00, 0x3a, 0x00, 0xb6, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xb7,
+  0xff, 0x88, 0x00, 0x3a, 0x00, 0xb8, 0xff, 0x88, 0x00, 0x3a, 0x00, 0xbb,
+  0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbc, 0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbd,
+  0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbe, 0xff, 0xb7, 0x00, 0x3a, 0x00, 0xbf,
+  0xff, 0xdc, 0x00, 0x3a, 0x00, 0xc1, 0xff, 0xdc, 0x00, 0x3a, 0x00, 0xdd,
+  0xff, 0x88, 0x00, 0x3a, 0x01, 0x17, 0xff, 0xa4, 0x00, 0x3a, 0x01, 0x1b,
+  0xff, 0xa4, 0x00, 0x3a, 0x01, 0x31, 0xff, 0xb7, 0x00, 0x3a, 0x07, 0x51,
+  0xff, 0xdc, 0x00, 0x3a, 0x07, 0x53, 0xfe, 0xf8, 0x00, 0x3b, 0x00, 0x10,
+  0xff, 0x9a, 0x00, 0x3b, 0x00, 0x26, 0xff, 0x6b, 0x00, 0x3b, 0x00, 0x32,
+  0xff, 0x7d, 0x00, 0x3b, 0x00, 0x37, 0xff, 0xdc, 0x00, 0x3b, 0x00, 0x48,
+  0xff, 0xa4, 0x00, 0x3b, 0x00, 0x6d, 0xff, 0x90, 0x00, 0x3b, 0x00, 0x89,
+  0xff, 0x6b, 0x00, 0x3b, 0x00, 0x94, 0xff, 0x7d, 0x00, 0x3b, 0x00, 0x95,
+  0xff, 0x7d, 0x00, 0x3b, 0x00, 0x96, 0xff, 0x7d, 0x00, 0x3b, 0x00, 0x97,
+  0xff, 0x7d, 0x00, 0x3b, 0x00, 0x98, 0xff, 0x7d, 0x00, 0x3b, 0x00, 0xaa,
+  0xff, 0xa4, 0x00, 0x3b, 0x00, 0xab, 0xff, 0xa4, 0x00, 0x3b, 0x00, 0xac,
+  0xff, 0xa4, 0x00, 0x3b, 0x00, 0xad, 0xff, 0xa4, 0x00, 0x3b, 0x00, 0xc8,
+  0xff, 0x6b, 0x00, 0x3b, 0x00, 0xce, 0xff, 0x6b, 0x00, 0x3b, 0x00, 0xdd,
+  0xff, 0xa4, 0x00, 0x3b, 0x01, 0x26, 0xff, 0xdc, 0x00, 0x3b, 0x07, 0x51,
+  0xff, 0x61, 0x00, 0x3b, 0x07, 0x52, 0xff, 0xad, 0x00, 0x3b, 0x07, 0x53,
+  0xff, 0xd3, 0x00, 0x3c, 0x00, 0x10, 0xff, 0x0d, 0x00, 0x3c, 0x00, 0x11,
+  0xfe, 0x61, 0x00, 0x3c, 0x00, 0x1d, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0x24,
+  0xff, 0x61, 0x00, 0x3c, 0x00, 0x26, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x32,
+  0xff, 0x90, 0x00, 0x3c, 0x00, 0x44, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0x48,
+  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0x4c, 0xff, 0xb7, 0x00, 0x3c, 0x00, 0x52,
+  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0x58, 0xff, 0x15, 0x00, 0x3c, 0x00, 0x6d,
+  0xff, 0x1f, 0x00, 0x3c, 0x00, 0x7d, 0xff, 0x6b, 0x00, 0x3c, 0x00, 0x82,
+  0xff, 0x61, 0x00, 0x3c, 0x00, 0x83, 0xff, 0x61, 0x00, 0x3c, 0x00, 0x84,
+  0xff, 0x61, 0x00, 0x3c, 0x00, 0x85, 0xff, 0x61, 0x00, 0x3c, 0x00, 0x86,
+  0xff, 0x61, 0x00, 0x3c, 0x00, 0x89, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x94,
+  0xff, 0x90, 0x00, 0x3c, 0x00, 0x95, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x96,
+  0xff, 0x90, 0x00, 0x3c, 0x00, 0x97, 0xff, 0x90, 0x00, 0x3c, 0x00, 0x98,
+  0xff, 0x90, 0x00, 0x3c, 0x00, 0xa2, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa3,
+  0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa4, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa5,
+  0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa6, 0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xa7,
+  0xfe, 0xe6, 0x00, 0x3c, 0x00, 0xaa, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xab,
+  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xac, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xad,
+  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb4, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb5,
+  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb6, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb7,
+  0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xb8, 0xfe, 0xf0, 0x00, 0x3c, 0x00, 0xbb,
+  0xff, 0x15, 0x00, 0x3c, 0x00, 0xbc, 0xff, 0x15, 0x00, 0x3c, 0x00, 0xbd,
+  0xff, 0x15, 0x00, 0x3c, 0x00, 0xbe, 0xff, 0x15, 0x00, 0x3c, 0x00, 0xc8,
+  0xff, 0x90, 0x00, 0x3c, 0x00, 0xce, 0xff, 0x90, 0x00, 0x3c, 0x00, 0xdd,
+  0xfe, 0xf0, 0x00, 0x3c, 0x01, 0x31, 0xff, 0x15, 0x00, 0x3c, 0x07, 0x51,
+  0xff, 0x90, 0x00, 0x3c, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x3c, 0x07, 0x53,
+  0xfe, 0xf8, 0x00, 0x3d, 0x00, 0x10, 0xff, 0xdc, 0x00, 0x3d, 0x07, 0x51,
+  0xff, 0xdc, 0x00, 0x3d, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x3d, 0x07, 0x53,
+  0xff, 0xdc, 0x00, 0x48, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0x49, 0x00, 0x10,
+  0xff, 0x90, 0x00, 0x49, 0x00, 0x11, 0xff, 0x6b, 0x00, 0x49, 0x00, 0x1d,
+  0xff, 0xb7, 0x00, 0x49, 0x00, 0x57, 0xff, 0xdc, 0x00, 0x49, 0x00, 0x5a,
+  0xff, 0xdc, 0x00, 0x49, 0x00, 0x5c, 0xff, 0xdc, 0x00, 0x49, 0x00, 0x6d,
+  0xff, 0xb7, 0x00, 0x49, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0x49, 0x00, 0xbf,
+  0xff, 0xdc, 0x00, 0x49, 0x00, 0xc1, 0xff, 0xdc, 0x00, 0x49, 0x01, 0x27,
+  0xff, 0xdc, 0x00, 0x49, 0x07, 0x51, 0x00, 0x41, 0x00, 0x49, 0x07, 0x53,
+  0xff, 0x15, 0x00, 0x4e, 0x00, 0x44, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0x48,
+  0xff, 0xb7, 0x00, 0x4e, 0x00, 0x52, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0x58,
+  0xff, 0xc1, 0x00, 0x4e, 0x00, 0x5c, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xa2,
+  0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa3, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa4,
+  0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa5, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa6,
+  0xff, 0xdc, 0x00, 0x4e, 0x00, 0xa7, 0xff, 0xdc, 0x00, 0x4e, 0x00, 0xaa,
+  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xab, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xac,
+  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xad, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb4,
+  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb5, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb6,
+  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb7, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xb8,
+  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xbb, 0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbc,
+  0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbd, 0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbe,
+  0xff, 0xc1, 0x00, 0x4e, 0x00, 0xbf, 0xff, 0xb7, 0x00, 0x4e, 0x00, 0xc1,
+  0xff, 0xb7, 0x00, 0x4e, 0x00, 0xdd, 0xff, 0xb7, 0x00, 0x4e, 0x01, 0x31,
+  0xff, 0xc1, 0x00, 0x51, 0x07, 0x51, 0xff, 0x6b, 0x00, 0x51, 0x07, 0x52,
+  0xff, 0x90, 0x00, 0x51, 0x07, 0x53, 0xff, 0xa4, 0x00, 0x52, 0x00, 0x10,
+  0x00, 0x26, 0x00, 0x52, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x52, 0x00, 0x5b,
+  0xff, 0xc1, 0x00, 0x52, 0x07, 0x51, 0xff, 0x6b, 0x00, 0x52, 0x07, 0x52,
+  0xff, 0xb7, 0x00, 0x52, 0x07, 0x53, 0xff, 0x7d, 0x00, 0x55, 0x00, 0x10,
+  0xff, 0x7d, 0x00, 0x55, 0x00, 0x11, 0xff, 0x44, 0x00, 0x55, 0x00, 0x1d,
+  0xff, 0xdc, 0x00, 0x55, 0x00, 0x46, 0xff, 0xd3, 0x00, 0x55, 0x00, 0x47,
+  0xff, 0xdc, 0x00, 0x55, 0x00, 0x48, 0xff, 0xd3, 0x00, 0x55, 0x00, 0x4a,
+  0xff, 0xdc, 0x00, 0x55, 0x00, 0x4b, 0xff, 0xdc, 0x00, 0x55, 0x00, 0x50,
+  0xff, 0xdc, 0x00, 0x55, 0x00, 0x51, 0xff, 0xdc, 0x00, 0x55, 0x00, 0x52,
+  0xff, 0xd3, 0x00, 0x55, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x55, 0x00, 0x55,
+  0xff, 0xdc, 0x00, 0x55, 0x00, 0x5b, 0xff, 0xc9, 0x00, 0x55, 0x00, 0x6d,
+  0xff, 0xb7, 0x00, 0x55, 0x00, 0xa9, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xaa,
+  0xff, 0xd3, 0x00, 0x55, 0x00, 0xab, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xac,
+  0xff, 0xd3, 0x00, 0x55, 0x00, 0xad, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xb3,
+  0xff, 0xdc, 0x00, 0x55, 0x00, 0xb4, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xb5,
+  0xff, 0xd3, 0x00, 0x55, 0x00, 0xb6, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xb7,
+  0xff, 0xd3, 0x00, 0x55, 0x00, 0xb8, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xc9,
+  0xff, 0xd3, 0x00, 0x55, 0x00, 0xcf, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xd1,
+  0x00, 0x48, 0x00, 0x55, 0x00, 0xdd, 0xff, 0xd3, 0x00, 0x55, 0x00, 0xe1,
+  0xff, 0xdc, 0x00, 0x55, 0x01, 0x0a, 0xff, 0xdc, 0x00, 0x55, 0x01, 0x17,
+  0xff, 0xdc, 0x00, 0x55, 0x01, 0x1b, 0xff, 0xdc, 0x00, 0x55, 0x07, 0x52,
+  0x00, 0x56, 0x00, 0x55, 0x07, 0x53, 0xfe, 0xc9, 0x00, 0x59, 0x00, 0x10,
+  0xff, 0xc9, 0x00, 0x59, 0x00, 0x11, 0xff, 0x61, 0x00, 0x59, 0x00, 0x1d,
+  0xff, 0x90, 0x00, 0x59, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x59, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x59, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x59, 0x07, 0x53,
+  0xfe, 0xf0, 0x00, 0x5a, 0x00, 0x11, 0xff, 0x44, 0x00, 0x5a, 0x00, 0x1d,
+  0xff, 0x90, 0x00, 0x5a, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x5a, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x5a, 0x07, 0x53, 0xff, 0x29, 0x00, 0x5b, 0x00, 0x46,
+  0xff, 0xdc, 0x00, 0x5b, 0x00, 0x48, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0x52,
+  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x5b, 0x00, 0xaa,
+  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xab, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xac,
+  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xad, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb4,
+  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb5, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb6,
+  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb7, 0xff, 0xc1, 0x00, 0x5b, 0x00, 0xb8,
+  0xff, 0xc1, 0x00, 0x5b, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x5b, 0x00, 0xcf,
+  0xff, 0xdc, 0x00, 0x5b, 0x00, 0xdd, 0xff, 0xc1, 0x00, 0x5c, 0x00, 0x10,
+  0xff, 0xdc, 0x00, 0x5c, 0x00, 0x11, 0xfe, 0xdc, 0x00, 0x5c, 0x00, 0x1d,
+  0xff, 0x6b, 0x00, 0x5c, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x5c, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x5c, 0x07, 0x53, 0xfe, 0xd3, 0x00, 0x6d, 0x00, 0x25,
+  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x27,
+  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x2d,
+  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x37, 0xff, 0x90, 0x00, 0x6d, 0x00, 0x39,
+  0xff, 0x90, 0x00, 0x6d, 0x00, 0x3a, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x3c,
+  0xff, 0x6b, 0x00, 0x6d, 0x00, 0x59, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x5a,
+  0xff, 0xdc, 0x00, 0x6d, 0x00, 0x5c, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x88,
+  0x00, 0x97, 0x00, 0x6d, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0x9f,
+  0xff, 0x6b, 0x00, 0x6d, 0x00, 0xbf, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0xc1,
+  0xff, 0xdc, 0x00, 0x6d, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0xce,
+  0xff, 0xdc, 0x00, 0x6d, 0x00, 0xd0, 0xff, 0xdc, 0x00, 0x6d, 0x00, 0xe0,
+  0xff, 0xdc, 0x00, 0x6d, 0x01, 0x26, 0xff, 0x90, 0x00, 0x6d, 0x01, 0x3a,
+  0xff, 0x6b, 0x00, 0x7d, 0x00, 0x24, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x25,
+  0xff, 0xb7, 0x00, 0x7d, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x27,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x2d, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x32,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x37, 0xff, 0x44, 0x00, 0x7d, 0x00, 0x39,
+  0xff, 0x4e, 0x00, 0x7d, 0x00, 0x3a, 0xff, 0x90, 0x00, 0x7d, 0x00, 0x3b,
+  0xff, 0x90, 0x00, 0x7d, 0x00, 0x3c, 0xff, 0x1f, 0x00, 0x7d, 0x00, 0x59,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x5a, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x5c,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x82, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x83,
+  0xff, 0xb7, 0x00, 0x7d, 0x00, 0x84, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x85,
+  0xff, 0xb7, 0x00, 0x7d, 0x00, 0x86, 0xff, 0xb7, 0x00, 0x7d, 0x00, 0x89,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x95,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x97,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0x9f,
+  0xff, 0x1f, 0x00, 0x7d, 0x00, 0xbf, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0xc1,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x7d, 0x00, 0xce,
+  0xff, 0xdc, 0x00, 0x7d, 0x00, 0xd0, 0xff, 0xdc, 0x00, 0x7d, 0x01, 0x26,
+  0xff, 0x44, 0x00, 0x7d, 0x01, 0x3a, 0xff, 0x1f, 0x00, 0x82, 0x00, 0x10,
+  0xff, 0xd3, 0x00, 0x82, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x1d,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x24, 0x00, 0x39, 0x00, 0x82, 0x00, 0x26,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x32,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x37,
+  0xff, 0x61, 0x00, 0x82, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x82, 0x00, 0x3a,
+  0xff, 0x90, 0x00, 0x82, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x82, 0x00, 0x46,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x48,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x82, 0x00, 0x52,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x57,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x59, 0xff, 0x88, 0x00, 0x82, 0x00, 0x5a,
+  0xff, 0xad, 0x00, 0x82, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x82, 0x00, 0x6d,
+  0xff, 0xb7, 0x00, 0x82, 0x00, 0x82, 0x00, 0x39, 0x00, 0x82, 0x00, 0x83,
+  0x00, 0x39, 0x00, 0x82, 0x00, 0x84, 0x00, 0x39, 0x00, 0x82, 0x00, 0x85,
+  0x00, 0x39, 0x00, 0x82, 0x00, 0x86, 0x00, 0x39, 0x00, 0x82, 0x00, 0x89,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x95,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x97,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x82, 0x00, 0x9f,
+  0xff, 0x61, 0x00, 0x82, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x82, 0x00, 0xc1,
+  0xff, 0x75, 0x00, 0x82, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x82, 0x00, 0xc4,
+  0x00, 0x39, 0x00, 0x82, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x82, 0x00, 0xc8,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xca,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xcd,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xcf,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xd5,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xd9,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xdd,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x82, 0x00, 0xe0,
+  0xff, 0xdc, 0x00, 0x82, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x0e,
+  0xff, 0xdc, 0x00, 0x82, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x10,
+  0xff, 0xdc, 0x00, 0x82, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x12,
+  0xff, 0xdc, 0x00, 0x82, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x24,
+  0xff, 0x61, 0x00, 0x82, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x26,
+  0xff, 0x61, 0x00, 0x82, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x82, 0x01, 0x36,
+  0xff, 0x90, 0x00, 0x82, 0x01, 0x37, 0xff, 0xad, 0x00, 0x82, 0x01, 0x38,
+  0xff, 0x61, 0x00, 0x82, 0x01, 0x39, 0xff, 0x75, 0x00, 0x82, 0x01, 0x3a,
+  0xff, 0x61, 0x00, 0x82, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x82, 0x01, 0xf1,
+  0xff, 0xdc, 0x00, 0x82, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x82, 0x05, 0xd3,
+  0xff, 0xad, 0x00, 0x82, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x82, 0x05, 0xd5,
+  0xff, 0xad, 0x00, 0x82, 0x06, 0x42, 0xff, 0x61, 0x00, 0x82, 0x06, 0x43,
+  0xff, 0x75, 0x00, 0x82, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x82, 0x07, 0x52,
+  0xff, 0x03, 0x00, 0x82, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x83, 0x00, 0x10,
+  0xff, 0xd3, 0x00, 0x83, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x1d,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x24, 0x00, 0x39, 0x00, 0x83, 0x00, 0x26,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x32,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x37,
+  0xff, 0x61, 0x00, 0x83, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x83, 0x00, 0x3a,
+  0xff, 0x90, 0x00, 0x83, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x83, 0x00, 0x46,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x48,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x83, 0x00, 0x52,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x57,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x59, 0xff, 0x88, 0x00, 0x83, 0x00, 0x5a,
+  0xff, 0xad, 0x00, 0x83, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x83, 0x00, 0x6d,
+  0xff, 0xb7, 0x00, 0x83, 0x00, 0x82, 0x00, 0x39, 0x00, 0x83, 0x00, 0x83,
+  0x00, 0x39, 0x00, 0x83, 0x00, 0x84, 0x00, 0x39, 0x00, 0x83, 0x00, 0x85,
+  0x00, 0x39, 0x00, 0x83, 0x00, 0x86, 0x00, 0x39, 0x00, 0x83, 0x00, 0x89,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x95,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x97,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x83, 0x00, 0x9f,
+  0xff, 0x61, 0x00, 0x83, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x83, 0x00, 0xc1,
+  0xff, 0x75, 0x00, 0x83, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x83, 0x00, 0xc4,
+  0x00, 0x39, 0x00, 0x83, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x83, 0x00, 0xc8,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xca,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xcd,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xcf,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xd5,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xd9,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xdd,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x83, 0x00, 0xe0,
+  0xff, 0xdc, 0x00, 0x83, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x0e,
+  0xff, 0xdc, 0x00, 0x83, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x10,
+  0xff, 0xdc, 0x00, 0x83, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x12,
+  0xff, 0xdc, 0x00, 0x83, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x24,
+  0xff, 0x61, 0x00, 0x83, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x26,
+  0xff, 0x61, 0x00, 0x83, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x83, 0x01, 0x36,
+  0xff, 0x90, 0x00, 0x83, 0x01, 0x37, 0xff, 0xad, 0x00, 0x83, 0x01, 0x38,
+  0xff, 0x61, 0x00, 0x83, 0x01, 0x39, 0xff, 0x75, 0x00, 0x83, 0x01, 0x3a,
+  0xff, 0x61, 0x00, 0x83, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x83, 0x01, 0xf1,
+  0xff, 0xdc, 0x00, 0x83, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x83, 0x05, 0xd2,
+  0xff, 0x90, 0x00, 0x83, 0x05, 0xd3, 0xff, 0xad, 0x00, 0x83, 0x05, 0xd4,
+  0xff, 0x90, 0x00, 0x83, 0x05, 0xd5, 0xff, 0xad, 0x00, 0x83, 0x06, 0x42,
+  0xff, 0x61, 0x00, 0x83, 0x06, 0x43, 0xff, 0x75, 0x00, 0x83, 0x07, 0x51,
+  0xfe, 0xf8, 0x00, 0x83, 0x07, 0x52, 0xff, 0x03, 0x00, 0x83, 0x07, 0x53,
+  0x00, 0x2f, 0x00, 0x84, 0x00, 0x10, 0xff, 0xd3, 0x00, 0x84, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x24,
+  0x00, 0x39, 0x00, 0x84, 0x00, 0x26, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x2a,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x32, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x34,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x37, 0xff, 0x61, 0x00, 0x84, 0x00, 0x39,
+  0xff, 0x7d, 0x00, 0x84, 0x00, 0x3a, 0xff, 0x90, 0x00, 0x84, 0x00, 0x3c,
+  0xff, 0x61, 0x00, 0x84, 0x00, 0x46, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x47,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x48, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x49,
+  0xff, 0xb7, 0x00, 0x84, 0x00, 0x52, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x54,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x57, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x59,
+  0xff, 0x88, 0x00, 0x84, 0x00, 0x5a, 0xff, 0xad, 0x00, 0x84, 0x00, 0x5c,
+  0xff, 0x75, 0x00, 0x84, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0x84, 0x00, 0x82,
+  0x00, 0x39, 0x00, 0x84, 0x00, 0x83, 0x00, 0x39, 0x00, 0x84, 0x00, 0x84,
+  0x00, 0x39, 0x00, 0x84, 0x00, 0x85, 0x00, 0x39, 0x00, 0x84, 0x00, 0x86,
+  0x00, 0x39, 0x00, 0x84, 0x00, 0x89, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x94,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x95, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x96,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x97, 0xff, 0xdc, 0x00, 0x84, 0x00, 0x98,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0x9f, 0xff, 0x61, 0x00, 0x84, 0x00, 0xa9,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xab,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xac, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xad,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xb5,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xb7,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xbf,
+  0xff, 0x75, 0x00, 0x84, 0x00, 0xc1, 0xff, 0x75, 0x00, 0x84, 0x00, 0xc2,
+  0x00, 0x39, 0x00, 0x84, 0x00, 0xc4, 0x00, 0x39, 0x00, 0x84, 0x00, 0xc6,
+  0x00, 0x39, 0x00, 0x84, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xc9,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xca, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xcc,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xcd, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xce,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xcf, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xd1,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xd7,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xdb,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xde,
+  0xff, 0xdc, 0x00, 0x84, 0x00, 0xe0, 0xff, 0xdc, 0x00, 0x84, 0x00, 0xe2,
+  0xff, 0xdc, 0x00, 0x84, 0x01, 0x0e, 0xff, 0xdc, 0x00, 0x84, 0x01, 0x0f,
+  0xff, 0xdc, 0x00, 0x84, 0x01, 0x10, 0xff, 0xdc, 0x00, 0x84, 0x01, 0x11,
+  0xff, 0xdc, 0x00, 0x84, 0x01, 0x12, 0xff, 0xdc, 0x00, 0x84, 0x01, 0x13,
+  0xff, 0xdc, 0x00, 0x84, 0x01, 0x24, 0xff, 0x61, 0x00, 0x84, 0x01, 0x25,
+  0xff, 0xdc, 0x00, 0x84, 0x01, 0x26, 0xff, 0x61, 0x00, 0x84, 0x01, 0x27,
+  0xff, 0xdc, 0x00, 0x84, 0x01, 0x36, 0xff, 0x90, 0x00, 0x84, 0x01, 0x37,
+  0xff, 0xad, 0x00, 0x84, 0x01, 0x38, 0xff, 0x61, 0x00, 0x84, 0x01, 0x39,
+  0xff, 0x75, 0x00, 0x84, 0x01, 0x3a, 0xff, 0x61, 0x00, 0x84, 0x01, 0xf0,
+  0xff, 0xdc, 0x00, 0x84, 0x01, 0xf1, 0xff, 0xdc, 0x00, 0x84, 0x05, 0xd0,
+  0xff, 0x90, 0x00, 0x84, 0x05, 0xd2, 0xff, 0x90, 0x00, 0x84, 0x05, 0xd3,
+  0xff, 0xad, 0x00, 0x84, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x84, 0x05, 0xd5,
+  0xff, 0xad, 0x00, 0x84, 0x06, 0x42, 0xff, 0x61, 0x00, 0x84, 0x06, 0x43,
+  0xff, 0x75, 0x00, 0x84, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x84, 0x07, 0x52,
+  0xff, 0x03, 0x00, 0x84, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x85, 0x00, 0x10,
+  0xff, 0xd3, 0x00, 0x85, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x1d,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x24, 0x00, 0x39, 0x00, 0x85, 0x00, 0x26,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x32,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x37,
+  0xff, 0x61, 0x00, 0x85, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x85, 0x00, 0x3a,
+  0xff, 0x90, 0x00, 0x85, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x85, 0x00, 0x46,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x48,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x85, 0x00, 0x52,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x57,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x59, 0xff, 0x88, 0x00, 0x85, 0x00, 0x5a,
+  0xff, 0xad, 0x00, 0x85, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x85, 0x00, 0x6d,
+  0xff, 0xb7, 0x00, 0x85, 0x00, 0x82, 0x00, 0x39, 0x00, 0x85, 0x00, 0x83,
+  0x00, 0x39, 0x00, 0x85, 0x00, 0x84, 0x00, 0x39, 0x00, 0x85, 0x00, 0x85,
+  0x00, 0x39, 0x00, 0x85, 0x00, 0x86, 0x00, 0x39, 0x00, 0x85, 0x00, 0x89,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x95,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x97,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x85, 0x00, 0x9f,
+  0xff, 0x61, 0x00, 0x85, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x85, 0x00, 0xc1,
+  0xff, 0x75, 0x00, 0x85, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x85, 0x00, 0xc4,
+  0x00, 0x39, 0x00, 0x85, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x85, 0x00, 0xc8,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xca,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xcd,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xcf,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xd5,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xd9,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xdd,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x85, 0x00, 0xe0,
+  0xff, 0xdc, 0x00, 0x85, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x0e,
+  0xff, 0xdc, 0x00, 0x85, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x10,
+  0xff, 0xdc, 0x00, 0x85, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x12,
+  0xff, 0xdc, 0x00, 0x85, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x24,
+  0xff, 0x61, 0x00, 0x85, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x26,
+  0xff, 0x61, 0x00, 0x85, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x85, 0x01, 0x36,
+  0xff, 0x90, 0x00, 0x85, 0x01, 0x37, 0xff, 0xad, 0x00, 0x85, 0x01, 0x38,
+  0xff, 0x61, 0x00, 0x85, 0x01, 0x39, 0xff, 0x75, 0x00, 0x85, 0x01, 0x3a,
+  0xff, 0x61, 0x00, 0x85, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x85, 0x05, 0xd0,
+  0xff, 0x90, 0x00, 0x85, 0x05, 0xd2, 0xff, 0x90, 0x00, 0x85, 0x05, 0xd3,
+  0xff, 0xad, 0x00, 0x85, 0x05, 0xd4, 0xff, 0x90, 0x00, 0x85, 0x05, 0xd5,
+  0xff, 0xad, 0x00, 0x85, 0x06, 0x42, 0xff, 0x61, 0x00, 0x85, 0x06, 0x43,
+  0xff, 0x75, 0x00, 0x85, 0x07, 0x51, 0xfe, 0xf8, 0x00, 0x85, 0x07, 0x52,
+  0xff, 0x03, 0x00, 0x85, 0x07, 0x53, 0x00, 0x2f, 0x00, 0x86, 0x00, 0x10,
+  0xff, 0xd3, 0x00, 0x86, 0x00, 0x11, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x1d,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x24, 0x00, 0x39, 0x00, 0x86, 0x00, 0x26,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x2a, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x32,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x34, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x37,
+  0xff, 0x61, 0x00, 0x86, 0x00, 0x39, 0xff, 0x7d, 0x00, 0x86, 0x00, 0x3a,
+  0xff, 0x90, 0x00, 0x86, 0x00, 0x3c, 0xff, 0x61, 0x00, 0x86, 0x00, 0x46,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x47, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x48,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x49, 0xff, 0xb7, 0x00, 0x86, 0x00, 0x52,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x54, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x57,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x59, 0xff, 0x88, 0x00, 0x86, 0x00, 0x5a,
+  0xff, 0xad, 0x00, 0x86, 0x00, 0x5c, 0xff, 0x75, 0x00, 0x86, 0x00, 0x6d,
+  0xff, 0xb7, 0x00, 0x86, 0x00, 0x82, 0x00, 0x39, 0x00, 0x86, 0x00, 0x83,
+  0x00, 0x39, 0x00, 0x86, 0x00, 0x84, 0x00, 0x39, 0x00, 0x86, 0x00, 0x85,
+  0x00, 0x39, 0x00, 0x86, 0x00, 0x86, 0x00, 0x39, 0x00, 0x86, 0x00, 0x89,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x94, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x95,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x96, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x97,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0x98, 0xff, 0xdc, 0x00, 0x86, 0x00, 0x9f,
+  0xff, 0x61, 0x00, 0x86, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xab, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xad, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xbf, 0xff, 0x75, 0x00, 0x86, 0x00, 0xc1,
+  0xff, 0x75, 0x00, 0x86, 0x00, 0xc2, 0x00, 0x39, 0x00, 0x86, 0x00, 0xc4,
+  0x00, 0x39, 0x00, 0x86, 0x00, 0xc6, 0x00, 0x39, 0x00, 0x86, 0x00, 0xc8,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xc9, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xca,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xcd,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xce, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xcf,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xd5,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xd9,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xdd,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xde, 0xff, 0xdc, 0x00, 0x86, 0x00, 0xe0,
+  0xff, 0xdc, 0x00, 0x86, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x0e,
+  0xff, 0xdc, 0x00, 0x86, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x10,
+  0xff, 0xdc, 0x00, 0x86, 0x01, 0x11, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x12,
+  0xff, 0xdc, 0x00, 0x86, 0x01, 0x13, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x24,
+  0xff, 0x61, 0x00, 0x86, 0x01, 0x25, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x26,
+  0xff, 0x61, 0x00, 0x86, 0x01, 0x27, 0xff, 0xdc, 0x00, 0x86, 0x01, 0x36,
+  0xff, 0x90, 0x00, 0x86, 0x01, 0x37, 0xff, 0xad, 0x00, 0x86, 0x01, 0x38,
+  0xff, 0x61, 0x00, 0x86, 0x01, 0x39, 0xff, 0x75, 0x00, 0x86, 0x01, 0x3a,
+  0xff, 0x61, 0x00, 0x86, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0x86, 0x01, 0xf1,
+  0xff, 0xdc, 0x00, 0x86, 0x05, 0xd0, 0xff, 0x90, 0x00, 0x86, 0x05, 0xd2,
+  0xff, 0x90, 0x00, 0x86, 0x05, 0xd3, 0xff, 0xad, 0x00, 0x86, 0x05, 0xd4,
+  0xff, 0x90, 0x00, 0x86, 0x05, 0xd5, 0xff, 0xad, 0x00, 0x86, 0x06, 0x42,
+  0xff, 0x61, 0x00, 0x86, 0x06, 0x43, 0xff, 0x75, 0x00, 0x86, 0x07, 0x51,
+  0xfe, 0xf8, 0x00, 0x86, 0x07, 0x52, 0xff, 0x03, 0x00, 0x86, 0x07, 0x53,
+  0x00, 0x2f, 0x00, 0x88, 0x07, 0x51, 0xff, 0xad, 0x00, 0x88, 0x07, 0x52,
+  0xff, 0xa4, 0x00, 0x88, 0x07, 0x53, 0xff, 0x90, 0x00, 0x89, 0x00, 0x3c,
+  0xff, 0xdc, 0x00, 0x89, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x89, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x89, 0x00, 0x9f, 0xff, 0xdc, 0x00, 0x89, 0x01, 0x3a,
+  0xff, 0xdc, 0x00, 0x89, 0x07, 0x52, 0x00, 0x26, 0x00, 0x92, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x92, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x3c,
+  0xff, 0x90, 0x00, 0x92, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0x92, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x92, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x92, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x92, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0x92, 0x00, 0xc2, 0xff, 0xdc, 0x00, 0x92, 0x00, 0xc4,
+  0xff, 0xdc, 0x00, 0x92, 0x00, 0xc6, 0xff, 0xdc, 0x00, 0x92, 0x01, 0x38,
+  0xff, 0x90, 0x00, 0x92, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x92, 0x01, 0xf4,
+  0xff, 0x90, 0x00, 0x92, 0x06, 0x42, 0xff, 0x90, 0x00, 0x92, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x92, 0x07, 0x52, 0xff, 0xc9, 0x00, 0x92, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0x94, 0x00, 0x10, 0x00, 0x39, 0x00, 0x94, 0x00, 0x11,
+  0xff, 0xad, 0x00, 0x94, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x94, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x3b,
+  0xff, 0x7d, 0x00, 0x94, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x94, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0x94, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x94, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x94, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x94, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0x94, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x94, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x94, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x94, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0x95, 0x00, 0x10, 0x00, 0x39, 0x00, 0x95, 0x00, 0x11,
+  0xff, 0xad, 0x00, 0x95, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x95, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x3b,
+  0xff, 0x7d, 0x00, 0x95, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x95, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0x95, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x95, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x95, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x95, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0x95, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x95, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x95, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x95, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0x96, 0x00, 0x10, 0x00, 0x39, 0x00, 0x96, 0x00, 0x11,
+  0xff, 0xad, 0x00, 0x96, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x96, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x3b,
+  0xff, 0x7d, 0x00, 0x96, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x96, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0x96, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x96, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x96, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x96, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0x96, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x96, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x96, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x96, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0x97, 0x00, 0x10, 0x00, 0x39, 0x00, 0x97, 0x00, 0x11,
+  0xff, 0xad, 0x00, 0x97, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x97, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x3b,
+  0xff, 0x7d, 0x00, 0x97, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x97, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0x97, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x97, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x97, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x97, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0x97, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x97, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x97, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x97, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0x98, 0x00, 0x10, 0x00, 0x39, 0x00, 0x98, 0x00, 0x11,
+  0xff, 0xad, 0x00, 0x98, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0x98, 0x00, 0x39, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x3b,
+  0xff, 0x7d, 0x00, 0x98, 0x00, 0x3c, 0xff, 0x90, 0x00, 0x98, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0x98, 0x00, 0x82, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0x98, 0x00, 0x84, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0x98, 0x00, 0x86, 0xff, 0xdc, 0x00, 0x98, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0x98, 0x01, 0x3a, 0xff, 0x90, 0x00, 0x98, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0x98, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x98, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0x9b, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9b, 0x01, 0x3f,
+  0xff, 0xdc, 0x00, 0x9c, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9c, 0x01, 0x3f,
+  0xff, 0xdc, 0x00, 0x9d, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9d, 0x01, 0x3f,
+  0xff, 0xdc, 0x00, 0x9e, 0x00, 0x3d, 0xff, 0xdc, 0x00, 0x9e, 0x01, 0x3f,
+  0xff, 0xdc, 0x00, 0x9f, 0x00, 0x10, 0xff, 0x0d, 0x00, 0x9f, 0x00, 0x11,
+  0xfe, 0x61, 0x00, 0x9f, 0x00, 0x1d, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0x24,
+  0xff, 0x61, 0x00, 0x9f, 0x00, 0x26, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x32,
+  0xff, 0x90, 0x00, 0x9f, 0x00, 0x44, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0x48,
+  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0x4c, 0xff, 0xb7, 0x00, 0x9f, 0x00, 0x52,
+  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0x58, 0xff, 0x15, 0x00, 0x9f, 0x00, 0x6d,
+  0xff, 0x1f, 0x00, 0x9f, 0x00, 0x7d, 0xff, 0x6b, 0x00, 0x9f, 0x00, 0x82,
+  0xff, 0x61, 0x00, 0x9f, 0x00, 0x83, 0xff, 0x61, 0x00, 0x9f, 0x00, 0x84,
+  0xff, 0x61, 0x00, 0x9f, 0x00, 0x85, 0xff, 0x61, 0x00, 0x9f, 0x00, 0x86,
+  0xff, 0x61, 0x00, 0x9f, 0x00, 0x89, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x94,
+  0xff, 0x90, 0x00, 0x9f, 0x00, 0x95, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x96,
+  0xff, 0x90, 0x00, 0x9f, 0x00, 0x97, 0xff, 0x90, 0x00, 0x9f, 0x00, 0x98,
+  0xff, 0x90, 0x00, 0x9f, 0x00, 0xa2, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa3,
+  0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa4, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa5,
+  0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa6, 0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xa7,
+  0xfe, 0xe6, 0x00, 0x9f, 0x00, 0xaa, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xab,
+  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xac, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xad,
+  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb4, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb5,
+  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb6, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb7,
+  0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xb8, 0xfe, 0xf0, 0x00, 0x9f, 0x00, 0xbb,
+  0xff, 0x15, 0x00, 0x9f, 0x00, 0xbc, 0xff, 0x15, 0x00, 0x9f, 0x00, 0xbd,
+  0xff, 0x15, 0x00, 0x9f, 0x00, 0xbe, 0xff, 0x15, 0x00, 0x9f, 0x00, 0xc8,
+  0xff, 0x90, 0x00, 0x9f, 0x00, 0xce, 0xff, 0x90, 0x00, 0x9f, 0x00, 0xdd,
+  0xfe, 0xf0, 0x00, 0x9f, 0x01, 0x31, 0xff, 0x15, 0x00, 0x9f, 0x07, 0x51,
+  0xff, 0x90, 0x00, 0x9f, 0x07, 0x52, 0xff, 0xdc, 0x00, 0x9f, 0x07, 0x53,
+  0xfe, 0xf8, 0x00, 0xa0, 0x00, 0x11, 0xff, 0x6b, 0x00, 0xa0, 0x00, 0x1d,
+  0xff, 0xb7, 0x00, 0xa0, 0x07, 0x51, 0xff, 0xdc, 0x00, 0xa0, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0xa1, 0x00, 0x10, 0x00, 0x26, 0x00, 0xa1, 0x07, 0x51,
+  0xff, 0x90, 0x00, 0xa1, 0x07, 0x52, 0xff, 0x90, 0x00, 0xa1, 0x07, 0x53,
+  0xff, 0xad, 0x00, 0xaa, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0xab, 0x00, 0x5b,
+  0xff, 0xdc, 0x00, 0xac, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0xad, 0x00, 0x5b,
+  0xff, 0xdc, 0x00, 0xb2, 0x07, 0x51, 0xff, 0xa4, 0x00, 0xb2, 0x07, 0x52,
+  0xff, 0x90, 0x00, 0xb2, 0x07, 0x53, 0xff, 0xb7, 0x00, 0xb3, 0x07, 0x51,
+  0xff, 0x6b, 0x00, 0xb3, 0x07, 0x52, 0xff, 0x90, 0x00, 0xb3, 0x07, 0x53,
+  0xff, 0xa4, 0x00, 0xb4, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb4, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xb4, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb4, 0x07, 0x51,
+  0xff, 0x6b, 0x00, 0xb4, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb4, 0x07, 0x53,
+  0xff, 0x7d, 0x00, 0xb5, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb5, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xb5, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb5, 0x07, 0x51,
+  0xff, 0x6b, 0x00, 0xb5, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb5, 0x07, 0x53,
+  0xff, 0x7d, 0x00, 0xb6, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb6, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xb6, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb6, 0x07, 0x51,
+  0xff, 0x6b, 0x00, 0xb6, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb6, 0x07, 0x53,
+  0xff, 0x7d, 0x00, 0xb7, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb7, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xb7, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb7, 0x07, 0x51,
+  0xff, 0x6b, 0x00, 0xb7, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb7, 0x07, 0x53,
+  0xff, 0x7d, 0x00, 0xb8, 0x00, 0x10, 0x00, 0x26, 0x00, 0xb8, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xb8, 0x00, 0x5b, 0xff, 0xc1, 0x00, 0xb8, 0x07, 0x51,
+  0xff, 0x6b, 0x00, 0xb8, 0x07, 0x52, 0xff, 0xb7, 0x00, 0xb8, 0x07, 0x53,
+  0xff, 0x7d, 0x00, 0xbf, 0x00, 0x10, 0xff, 0xdc, 0x00, 0xbf, 0x00, 0x11,
+  0xfe, 0xdc, 0x00, 0xbf, 0x00, 0x1d, 0xff, 0x6b, 0x00, 0xbf, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0xbf, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xbf, 0x07, 0x53,
+  0xfe, 0xd3, 0x00, 0xc1, 0x00, 0x10, 0xff, 0xdc, 0x00, 0xc1, 0x00, 0x11,
+  0xfe, 0xdc, 0x00, 0xc1, 0x00, 0x1d, 0xff, 0x6b, 0x00, 0xc1, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0xc1, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xc1, 0x07, 0x53,
+  0xfe, 0xd3, 0x00, 0xc2, 0x00, 0x10, 0xff, 0xd3, 0x00, 0xc2, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x24,
+  0x00, 0x39, 0x00, 0xc2, 0x00, 0x26, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x2a,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x32, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x34,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x37, 0xff, 0x61, 0x00, 0xc2, 0x00, 0x39,
+  0xff, 0x7d, 0x00, 0xc2, 0x00, 0x3a, 0xff, 0x90, 0x00, 0xc2, 0x00, 0x3c,
+  0xff, 0x61, 0x00, 0xc2, 0x00, 0x46, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x47,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x49,
+  0xff, 0xb7, 0x00, 0xc2, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x54,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x57, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x59,
+  0xff, 0x88, 0x00, 0xc2, 0x00, 0x5a, 0xff, 0xad, 0x00, 0xc2, 0x00, 0x5c,
+  0xff, 0x75, 0x00, 0xc2, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0xc2, 0x00, 0x82,
+  0x00, 0x39, 0x00, 0xc2, 0x00, 0x83, 0x00, 0x39, 0x00, 0xc2, 0x00, 0x84,
+  0x00, 0x39, 0x00, 0xc2, 0x00, 0x85, 0x00, 0x39, 0x00, 0xc2, 0x00, 0x86,
+  0x00, 0x39, 0x00, 0xc2, 0x00, 0x94, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x95,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x96, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x97,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0x98, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0x9f,
+  0xff, 0x61, 0x00, 0xc2, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xab, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xad, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xbf, 0xff, 0x75, 0x00, 0xc2, 0x00, 0xc1,
+  0xff, 0x75, 0x00, 0xc2, 0x00, 0xc2, 0x00, 0x39, 0x00, 0xc2, 0x00, 0xc4,
+  0x00, 0x39, 0x00, 0xc2, 0x00, 0xc6, 0x00, 0x39, 0x00, 0xc2, 0x00, 0xc8,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xca, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xcc,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xcd, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xce,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd3,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd7,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xdb,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0xc2, 0x00, 0xde,
+  0xff, 0xdc, 0x00, 0xc2, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x0e,
+  0xff, 0xdc, 0x00, 0xc2, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x10,
+  0xff, 0xdc, 0x00, 0xc2, 0x01, 0x11, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x12,
+  0xff, 0xdc, 0x00, 0xc2, 0x01, 0x13, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x24,
+  0xff, 0x61, 0x00, 0xc2, 0x01, 0x25, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x26,
+  0xff, 0x61, 0x00, 0xc2, 0x01, 0x27, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0x36,
+  0xff, 0x90, 0x00, 0xc2, 0x01, 0x37, 0xff, 0xad, 0x00, 0xc2, 0x01, 0x38,
+  0xff, 0x61, 0x00, 0xc2, 0x01, 0x39, 0xff, 0x75, 0x00, 0xc2, 0x01, 0x3a,
+  0xff, 0x61, 0x00, 0xc2, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0xc2, 0x01, 0xf1,
+  0xff, 0xdc, 0x00, 0xc2, 0x05, 0xd0, 0xff, 0x90, 0x00, 0xc2, 0x05, 0xd2,
+  0xff, 0x90, 0x00, 0xc2, 0x05, 0xd3, 0xff, 0xad, 0x00, 0xc2, 0x05, 0xd4,
+  0xff, 0x90, 0x00, 0xc2, 0x05, 0xd5, 0xff, 0xad, 0x00, 0xc2, 0x06, 0x42,
+  0xff, 0x61, 0x00, 0xc2, 0x06, 0x43, 0xff, 0x75, 0x00, 0xc2, 0x07, 0x51,
+  0xfe, 0xf8, 0x00, 0xc2, 0x07, 0x52, 0xff, 0x02, 0x00, 0xc2, 0x07, 0x53,
+  0x00, 0x2f, 0x00, 0xc4, 0x00, 0x10, 0xff, 0xd3, 0x00, 0xc4, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x24,
+  0x00, 0x39, 0x00, 0xc4, 0x00, 0x26, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x2a,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x32, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x34,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x37, 0xff, 0x61, 0x00, 0xc4, 0x00, 0x39,
+  0xff, 0x7d, 0x00, 0xc4, 0x00, 0x3a, 0xff, 0x90, 0x00, 0xc4, 0x00, 0x3c,
+  0xff, 0x61, 0x00, 0xc4, 0x00, 0x46, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x47,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x49,
+  0xff, 0xb7, 0x00, 0xc4, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x54,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x57, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x59,
+  0xff, 0x88, 0x00, 0xc4, 0x00, 0x5a, 0xff, 0xad, 0x00, 0xc4, 0x00, 0x5c,
+  0xff, 0x75, 0x00, 0xc4, 0x00, 0x6d, 0xff, 0xb7, 0x00, 0xc4, 0x00, 0x82,
+  0x00, 0x39, 0x00, 0xc4, 0x00, 0x83, 0x00, 0x39, 0x00, 0xc4, 0x00, 0x84,
+  0x00, 0x39, 0x00, 0xc4, 0x00, 0x85, 0x00, 0x39, 0x00, 0xc4, 0x00, 0x86,
+  0x00, 0x39, 0x00, 0xc4, 0x00, 0x94, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x95,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x96, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x97,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0x98, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0x9f,
+  0xff, 0x61, 0x00, 0xc4, 0x00, 0xa9, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xab, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xad, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xbf, 0xff, 0x75, 0x00, 0xc4, 0x00, 0xc1,
+  0xff, 0x75, 0x00, 0xc4, 0x00, 0xc2, 0x00, 0x39, 0x00, 0xc4, 0x00, 0xc4,
+  0x00, 0x39, 0x00, 0xc4, 0x00, 0xc6, 0x00, 0x39, 0x00, 0xc4, 0x00, 0xc8,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xca, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xcc,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xcd, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xce,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd1, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd3,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd5, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd7,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xd9, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xdb,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0xc4, 0x00, 0xde,
+  0xff, 0xdc, 0x00, 0xc4, 0x00, 0xe2, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x0e,
+  0xff, 0xdc, 0x00, 0xc4, 0x01, 0x0f, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x10,
+  0xff, 0xdc, 0x00, 0xc4, 0x01, 0x11, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x12,
+  0xff, 0xdc, 0x00, 0xc4, 0x01, 0x13, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x24,
+  0xff, 0x61, 0x00, 0xc4, 0x01, 0x25, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x26,
+  0xff, 0x61, 0x00, 0xc4, 0x01, 0x27, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0x36,
+  0xff, 0x90, 0x00, 0xc4, 0x01, 0x37, 0xff, 0xad, 0x00, 0xc4, 0x01, 0x38,
+  0xff, 0x61, 0x00, 0xc4, 0x01, 0x39, 0xff, 0x75, 0x00, 0xc4, 0x01, 0x3a,
+  0xff, 0x61, 0x00, 0xc4, 0x01, 0xf0, 0xff, 0xdc, 0x00, 0xc4, 0x01, 0xf1,
+  0xff, 0xdc, 0x00, 0xc4, 0x05, 0xd0, 0xff, 0x90, 0x00, 0xc4, 0x05, 0xd2,
+  0xff, 0x90, 0x00, 0xc4, 0x05, 0xd3, 0xff, 0xad, 0x00, 0xc4, 0x05, 0xd4,
+  0xff, 0x90, 0x00, 0xc4, 0x05, 0xd5, 0xff, 0xad, 0x00, 0xc4, 0x06, 0x42,
+  0xff, 0x61, 0x00, 0xc4, 0x06, 0x43, 0xff, 0x75, 0x00, 0xc4, 0x07, 0x51,
+  0xfe, 0xf8, 0x00, 0xc4, 0x07, 0x52, 0xff, 0x02, 0x00, 0xc4, 0x07, 0x53,
+  0x00, 0x2f, 0x00, 0xc6, 0x00, 0x10, 0xff, 0xd3, 0x00, 0xc6, 0x00, 0x11,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x1d, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x24,
+  0x00, 0x39, 0x00, 0xc6, 0x00, 0x26, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x2a,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x32, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x34,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x37, 0xff, 0x61, 0x00, 0xc6, 0x00, 0x39,
+  0xff, 0x7d, 0x00, 0xc6, 0x00, 0x3a, 0xff, 0x90, 0x00, 0xc6, 0x00, 0x3c,
+  0xff, 0x61, 0x00, 0xc6, 0x00, 0x46, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x47,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x49,
+  0xff, 0xb7, 0x00, 0xc6, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x54,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x57, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x59,
+  0xff, 0x88, 0x00, 0xc6, 0x00, 0x5a, 0xff, 0xad, 0x00, 0xc6, 0x00, 0x6d,
+  0xff, 0xb7, 0x00, 0xc6, 0x00, 0x82, 0x00, 0x39, 0x00, 0xc6, 0x00, 0x83,
+  0x00, 0x39, 0x00, 0xc6, 0x00, 0x84, 0x00, 0x39, 0x00, 0xc6, 0x00, 0x85,
+  0x00, 0x39, 0x00, 0xc6, 0x00, 0x86, 0x00, 0x39, 0x00, 0xc6, 0x00, 0x94,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x95, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x96,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x97, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0x98,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0x9f, 0xff, 0x61, 0x00, 0xc6, 0x00, 0xa9,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xab,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xac, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xad,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb5,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb7,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xc2,
+  0x00, 0x39, 0x00, 0xc6, 0x00, 0xc4, 0x00, 0x39, 0x00, 0xc6, 0x00, 0xc6,
+  0x00, 0x39, 0x00, 0xc6, 0x00, 0xc8, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xca,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xcc, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xcd,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xce, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd1,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd3, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd5,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd7, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xd9,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xdb, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xdd,
+  0xff, 0xdc, 0x00, 0xc6, 0x00, 0xde, 0xff, 0xdc, 0x00, 0xc6, 0x00, 0xe2,
+  0xff, 0xdc, 0x00, 0xc6, 0x01, 0x0e, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x0f,
+  0xff, 0xdc, 0x00, 0xc6, 0x01, 0x10, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x11,
+  0xff, 0xdc, 0x00, 0xc6, 0x01, 0x13, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x24,
+  0xff, 0x61, 0x00, 0xc6, 0x01, 0x25, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x26,
+  0xff, 0x61, 0x00, 0xc6, 0x01, 0x27, 0xff, 0xdc, 0x00, 0xc6, 0x01, 0x36,
+  0xff, 0x90, 0x00, 0xc6, 0x01, 0x37, 0xff, 0xad, 0x00, 0xc6, 0x01, 0x38,
+  0xff, 0x61, 0x00, 0xc6, 0x01, 0x3a, 0xff, 0x61, 0x00, 0xc6, 0x01, 0xf0,
+  0xff, 0xdc, 0x00, 0xc6, 0x01, 0xf1, 0xff, 0xdc, 0x00, 0xc6, 0x05, 0xd0,
+  0xff, 0x90, 0x00, 0xc6, 0x05, 0xd2, 0xff, 0x90, 0x00, 0xc6, 0x05, 0xd3,
+  0xff, 0xad, 0x00, 0xc6, 0x05, 0xd4, 0xff, 0x90, 0x00, 0xc6, 0x05, 0xd5,
+  0xff, 0xad, 0x00, 0xc6, 0x06, 0x42, 0xff, 0x61, 0x00, 0xc6, 0x07, 0x51,
+  0xfe, 0xf8, 0x00, 0xc6, 0x07, 0x52, 0xff, 0x02, 0x00, 0xc6, 0x07, 0x53,
+  0x00, 0x2f, 0x00, 0xc8, 0x00, 0x3c, 0xff, 0xdc, 0x00, 0xc8, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0xc8, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xc8, 0x00, 0x9f,
+  0xff, 0xdc, 0x00, 0xc8, 0x01, 0x3a, 0xff, 0xdc, 0x00, 0xc8, 0x07, 0x52,
+  0x00, 0x26, 0x00, 0xce, 0x00, 0x3c, 0xff, 0xdc, 0x00, 0xce, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0xce, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xce, 0x00, 0x9f,
+  0xff, 0xdc, 0x00, 0xce, 0x01, 0x3a, 0xff, 0xdc, 0x00, 0xce, 0x07, 0x52,
+  0x00, 0x26, 0x00, 0xd0, 0x00, 0x24, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x39,
+  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x3c, 0xff, 0x90, 0x00, 0xd0, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x82,
+  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x83, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x84,
+  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x85, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0x86,
+  0xff, 0xdc, 0x00, 0xd0, 0x00, 0x9f, 0xff, 0x90, 0x00, 0xd0, 0x00, 0xc2,
+  0xff, 0xdc, 0x00, 0xd0, 0x00, 0xc4, 0xff, 0xdc, 0x00, 0xd0, 0x00, 0xc6,
+  0xff, 0xdc, 0x00, 0xd0, 0x01, 0x38, 0xff, 0x90, 0x00, 0xd0, 0x01, 0x3a,
+  0xff, 0x90, 0x00, 0xd0, 0x01, 0xf4, 0xff, 0x90, 0x00, 0xd0, 0x06, 0x42,
+  0xff, 0x90, 0x00, 0xd0, 0x07, 0x51, 0xff, 0xd3, 0x00, 0xd0, 0x07, 0x52,
+  0xff, 0xc9, 0x00, 0xd0, 0x07, 0x53, 0xff, 0x44, 0x00, 0xd2, 0x00, 0x24,
+  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x39, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x3c,
+  0xff, 0x90, 0x00, 0xd2, 0x00, 0x6d, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x7d,
+  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x82, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x83,
+  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x84, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x85,
+  0xff, 0xdc, 0x00, 0xd2, 0x00, 0x86, 0xff, 0xdc, 0x00, 0xd2, 0x00, 0x9f,
+  0xff, 0x90, 0x00, 0xd2, 0x01, 0x3a, 0xff, 0x90, 0x00, 0xd2, 0x07, 0x51,
+  0xff, 0xd3, 0x00, 0xd2, 0x07, 0x52, 0xff, 0xc9, 0x00, 0xd2, 0x07, 0x53,
+  0xff, 0x44, 0x00, 0xdd, 0x00, 0x5b, 0xff, 0xdc, 0x00, 0xe0, 0x00, 0x37,
+  0xff, 0xb7, 0x00, 0xe0, 0x00, 0x3c, 0xff, 0x9a, 0x00, 0xe0, 0x00, 0x6d,
+  0xff, 0xdc, 0x00, 0xe0, 0x00, 0x7d, 0xff, 0xdc, 0x00, 0xe0, 0x00, 0x9f,
+  0xff, 0x9a, 0x00, 0xe0, 0x01, 0x26, 0xff, 0xb7, 0x00, 0xe0, 0x01, 0x3a,
+  0xff, 0x9a, 0x00, 0xe0, 0x07, 0x51, 0xff, 0xd3, 0x00, 0xe0, 0x07, 0x52,
+  0xff, 0xd3, 0x00, 0xe0, 0x07, 0x53, 0xff, 0xc9, 0x00, 0xfb, 0x00, 0x10,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0x24, 0x00, 0x2f, 0x00, 0xfb, 0x00, 0x32,
+  0xff, 0xb7, 0x00, 0xfb, 0x00, 0x37, 0xfe, 0xe6, 0x00, 0xfb, 0x00, 0x38,
+  0xff, 0x9a, 0x00, 0xfb, 0x00, 0x39, 0xff, 0x1f, 0x00, 0xfb, 0x00, 0x3a,
+  0xff, 0x44, 0x00, 0xfb, 0x00, 0x3c, 0xfe, 0xf0, 0x00, 0xfb, 0x00, 0x48,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0x52, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0x58,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0x5c, 0xff, 0x44, 0x00, 0xfb, 0x00, 0x82,
+  0x00, 0x2f, 0x00, 0xfb, 0x00, 0x83, 0x00, 0x2f, 0x00, 0xfb, 0x00, 0x84,
+  0x00, 0x2f, 0x00, 0xfb, 0x00, 0x85, 0x00, 0x2f, 0x00, 0xfb, 0x00, 0x86,
+  0x00, 0x2f, 0x00, 0xfb, 0x00, 0x94, 0xff, 0xb7, 0x00, 0xfb, 0x00, 0x95,
+  0xff, 0xb7, 0x00, 0xfb, 0x00, 0x96, 0xff, 0xb7, 0x00, 0xfb, 0x00, 0x97,
+  0xff, 0xb7, 0x00, 0xfb, 0x00, 0x98, 0xff, 0xb7, 0x00, 0xfb, 0x00, 0x9b,
+  0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9c, 0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9d,
+  0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9e, 0xff, 0x9a, 0x00, 0xfb, 0x00, 0x9f,
+  0xfe, 0xf0, 0x00, 0xfb, 0x00, 0xaa, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xab,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xac, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xad,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb4, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb5,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb6, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb7,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xb8, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbb,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbc, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbd,
+  0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbe, 0xff, 0xdc, 0x00, 0xfb, 0x00, 0xbf,
+  0xff, 0x44, 0x00, 0xfb, 0x00, 0xc1, 0xff, 0x44, 0x00, 0xfb, 0x00, 0xdd,
+  0xff, 0xdc, 0x00, 0xfb, 0x01, 0x26, 0xfe, 0xe6, 0x00, 0xfb, 0x01, 0x30,
+  0xff, 0x9a, 0x00, 0xfb, 0x01, 0x31, 0xff, 0xdc, 0x00, 0xfb, 0x01, 0x3a,
+  0xfe, 0xf0, 0x00, 0xfb, 0x07, 0x51, 0xfe, 0x61, 0x00, 0xfb, 0x07, 0x52,
+  0xfd, 0xe6, 0x00, 0xff, 0x00, 0x10, 0xff, 0xdc, 0x00, 0xff, 0x00, 0x24,
+  0x00, 0x2f, 0x00, 0xff, 0x00, 0x32, 0xff, 0xb7, 0x00, 0xff, 0x00, 0x37,
+  0xfe, 0xe6, 0x00, 0xff, 0x00, 0x38, 0xff, 0x9a, 0x00, 0xff, 0x00, 0x39,
+  0xff, 0x1f, 0x00, 0xff, 0x00, 0x3a, 0xff, 0x44, 0x00, 0xff, 0x00, 0x3c,
+  0xfe, 0xf0, 0x00, 0xff, 0x00, 0x48, 0xff, 0xdc, 0x00, 0xff, 0x00, 0x52,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0x58, 0xff, 0xdc, 0x00, 0xff, 0x00, 0x5c,
+  0xff, 0x44, 0x00, 0xff, 0x00, 0x82, 0x00, 0x2f, 0x00, 0xff, 0x00, 0x83,
+  0x00, 0x2f, 0x00, 0xff, 0x00, 0x84, 0x00, 0x2f, 0x00, 0xff, 0x00, 0x85,
+  0x00, 0x2f, 0x00, 0xff, 0x00, 0x86, 0x00, 0x2f, 0x00, 0xff, 0x00, 0x94,
+  0xff, 0xb7, 0x00, 0xff, 0x00, 0x95, 0xff, 0xb7, 0x00, 0xff, 0x00, 0x96,
+  0xff, 0xb7, 0x00, 0xff, 0x00, 0x97, 0xff, 0xb7, 0x00, 0xff, 0x00, 0x98,
+  0xff, 0xb7, 0x00, 0xff, 0x00, 0x9b, 0xff, 0x9a, 0x00, 0xff, 0x00, 0x9c,
+  0xff, 0x9a, 0x00, 0xff, 0x00, 0x9d, 0xff, 0x9a, 0x00, 0xff, 0x00, 0x9e,
+  0xff, 0x9a, 0x00, 0xff, 0x00, 0x9f, 0xfe, 0xf0, 0x00, 0xff, 0x00, 0xaa,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0xab, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xac,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0xad, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xb4,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0xb5, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xb6,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0xb7, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xb8,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0xbb, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xbc,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0xbd, 0xff, 0xdc, 0x00, 0xff, 0x00, 0xbe,
+  0xff, 0xdc, 0x00, 0xff, 0x00, 0xbf, 0xff, 0x44, 0x00, 0xff, 0x00, 0xc1,
+  0xff, 0x44, 0x00, 0xff, 0x00, 0xdd, 0xff, 0xdc, 0x00, 0xff, 0x01, 0x26,
+  0xfe, 0xe6, 0x00, 0xff, 0x01, 0x30, 0xff, 0x9a, 0x00, 0xff, 0x01, 0x31,
+  0xff, 0xdc, 0x00, 0xff, 0x01, 0x3a, 0xfe, 0xf0, 0x00, 0xff, 0x07, 0x51,
+  0xfe, 0x61, 0x00, 0xff, 0x07, 0x52, 0xfd, 0xe6, 0x01, 0x02, 0x00, 0x4f,
+  0xff, 0x3f, 0x01, 0x0a, 0x07, 0x51, 0xff, 0x6b, 0x01, 0x0a, 0x07, 0x52,
+  0xff, 0x90, 0x01, 0x0a, 0x07, 0x53, 0xff, 0xa4, 0x01, 0x16, 0x00, 0x10,
+  0xff, 0xad, 0x01, 0x16, 0x00, 0x11, 0xff, 0xb7, 0x01, 0x16, 0x00, 0x1d,
+  0xff, 0xc1, 0x01, 0x16, 0x00, 0x24, 0xff, 0xad, 0x01, 0x16, 0x00, 0x26,
+  0xff, 0x9a, 0x01, 0x16, 0x00, 0x37, 0xff, 0x6b, 0x01, 0x16, 0x00, 0x39,
+  0xff, 0x90, 0x01, 0x16, 0x00, 0x3a, 0xff, 0xad, 0x01, 0x16, 0x00, 0x3c,
+  0xff, 0x7d, 0x01, 0x16, 0x00, 0x44, 0xff, 0xd3, 0x01, 0x16, 0x00, 0x48,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0x52, 0xff, 0xa4, 0x01, 0x16, 0x00, 0x58,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0x5c, 0xff, 0x90, 0x01, 0x16, 0x00, 0x6d,
+  0xff, 0x90, 0x01, 0x16, 0x00, 0x7d, 0xff, 0xdc, 0x01, 0x16, 0x00, 0x82,
+  0xff, 0xad, 0x01, 0x16, 0x00, 0x83, 0xff, 0xad, 0x01, 0x16, 0x00, 0x84,
+  0xff, 0xad, 0x01, 0x16, 0x00, 0x85, 0xff, 0xad, 0x01, 0x16, 0x00, 0x86,
+  0xff, 0xad, 0x01, 0x16, 0x00, 0x89, 0xff, 0x9a, 0x01, 0x16, 0x00, 0x9f,
+  0xff, 0x7d, 0x01, 0x16, 0x00, 0xa2, 0xff, 0xd3, 0x01, 0x16, 0x00, 0xa3,
+  0xff, 0xd3, 0x01, 0x16, 0x00, 0xa4, 0xff, 0xd3, 0x01, 0x16, 0x00, 0xa5,
+  0xff, 0xd3, 0x01, 0x16, 0x00, 0xa6, 0xff, 0xd3, 0x01, 0x16, 0x00, 0xa7,
+  0xff, 0xd3, 0x01, 0x16, 0x00, 0xaa, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xab,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0xac, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xad,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0xb4, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xb5,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0xb6, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xb7,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0xb8, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xbb,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0xbc, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xbd,
+  0xff, 0xa4, 0x01, 0x16, 0x00, 0xbe, 0xff, 0xa4, 0x01, 0x16, 0x00, 0xbf,
+  0xff, 0x90, 0x01, 0x16, 0x00, 0xc1, 0xff, 0x90, 0x01, 0x16, 0x00, 0xc8,
+  0xff, 0x9a, 0x01, 0x16, 0x00, 0xce, 0xff, 0x9a, 0x01, 0x16, 0x00, 0xdd,
+  0xff, 0xa4, 0x01, 0x16, 0x01, 0x26, 0xff, 0x6b, 0x01, 0x16, 0x01, 0x31,
+  0xff, 0xa4, 0x01, 0x16, 0x01, 0x3a, 0xff, 0x7d, 0x01, 0x16, 0x07, 0x51,
+  0xff, 0x6b, 0x01, 0x16, 0x07, 0x52, 0xff, 0x7d, 0x01, 0x16, 0x07, 0x53,
+  0xff, 0xdc, 0x01, 0x17, 0x00, 0x10, 0xff, 0x7d, 0x01, 0x17, 0x00, 0x11,
+  0xff, 0x44, 0x01, 0x17, 0x00, 0x1d, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x46,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0x47, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x48,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0x4a, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x4b,
+  0xff, 0xdc, 0x01, 0x17, 0x00, 0x50, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x51,
+  0xff, 0xdc, 0x01, 0x17, 0x00, 0x52, 0xff, 0xd3, 0x01, 0x17, 0x00, 0x54,
+  0xff, 0xdc, 0x01, 0x17, 0x00, 0x55, 0xff, 0xdc, 0x01, 0x17, 0x00, 0x5b,
+  0xff, 0xc9, 0x01, 0x17, 0x00, 0x6d, 0xff, 0xb7, 0x01, 0x17, 0x00, 0xa9,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xaa, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xab,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xac, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xad,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xb3, 0xff, 0xdc, 0x01, 0x17, 0x00, 0xb4,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xb5, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xb6,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xb7, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xb8,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xc9, 0xff, 0xd3, 0x01, 0x17, 0x00, 0xcf,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xd1, 0x00, 0x48, 0x01, 0x17, 0x00, 0xdd,
+  0xff, 0xd3, 0x01, 0x17, 0x00, 0xe1, 0xff, 0xdc, 0x01, 0x17, 0x01, 0x0a,
+  0xff, 0xdc, 0x01, 0x17, 0x01, 0x17, 0xff, 0xdc, 0x01, 0x17, 0x01, 0x1b,
+  0xff, 0xdc, 0x01, 0x17, 0x07, 0x52, 0x00, 0x56, 0x01, 0x17, 0x07, 0x53,
+  0xfe, 0xc9, 0x01, 0x1a, 0x00, 0x10, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x11,
+  0xff, 0xb7, 0x01, 0x1a, 0x00, 0x1d, 0xff, 0xc1, 0x01, 0x1a, 0x00, 0x24,
+  0xff, 0xad, 0x01, 0x1a, 0x00, 0x26, 0xff, 0x9a, 0x01, 0x1a, 0x00, 0x37,
+  0xff, 0x6b, 0x01, 0x1a, 0x00, 0x39, 0xff, 0x90, 0x01, 0x1a, 0x00, 0x3a,
+  0xff, 0xad, 0x01, 0x1a, 0x00, 0x3c, 0xff, 0x7d, 0x01, 0x1a, 0x00, 0x44,
+  0xff, 0xd3, 0x01, 0x1a, 0x00, 0x48, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0x52,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0x58, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0x5c,
+  0xff, 0x90, 0x01, 0x1a, 0x00, 0x6d, 0xff, 0x90, 0x01, 0x1a, 0x00, 0x7d,
+  0xff, 0xdc, 0x01, 0x1a, 0x00, 0x82, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x83,
+  0xff, 0xad, 0x01, 0x1a, 0x00, 0x84, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x85,
+  0xff, 0xad, 0x01, 0x1a, 0x00, 0x86, 0xff, 0xad, 0x01, 0x1a, 0x00, 0x89,
+  0xff, 0x9a, 0x01, 0x1a, 0x00, 0x9f, 0xff, 0x7d, 0x01, 0x1a, 0x00, 0xa2,
+  0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa3, 0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa4,
+  0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa5, 0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa6,
+  0xff, 0xd3, 0x01, 0x1a, 0x00, 0xa7, 0xff, 0xd3, 0x01, 0x1a, 0x00, 0xaa,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xab, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xac,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xad, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb4,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb5, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb6,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb7, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xb8,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbb, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbc,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbd, 0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbe,
+  0xff, 0xa4, 0x01, 0x1a, 0x00, 0xbf, 0xff, 0x90, 0x01, 0x1a, 0x00, 0xc1,
+  0xff, 0x90, 0x01, 0x1a, 0x00, 0xc8, 0xff, 0x9a, 0x01, 0x1a, 0x00, 0xce,
+  0xff, 0x9a, 0x01, 0x1a, 0x00, 0xdd, 0xff, 0xa4, 0x01, 0x1a, 0x01, 0x26,
+  0xff, 0x6b, 0x01, 0x1a, 0x01, 0x31, 0xff, 0xa4, 0x01, 0x1a, 0x01, 0x3a,
+  0xff, 0x7d, 0x01, 0x1a, 0x07, 0x51, 0xff, 0x6b, 0x01, 0x1a, 0x07, 0x52,
+  0xff, 0x7d, 0x01, 0x1a, 0x07, 0x53, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x10,
+  0xff, 0x7d, 0x01, 0x1b, 0x00, 0x11, 0xff, 0x44, 0x01, 0x1b, 0x00, 0x1d,
+  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x46, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0x47,
+  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x48, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0x4a,
+  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x4b, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x50,
+  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x51, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x52,
+  0xff, 0xd3, 0x01, 0x1b, 0x00, 0x54, 0xff, 0xdc, 0x01, 0x1b, 0x00, 0x55,
+  0xff, 0xdc, 0x01, 0x1b, 0x00, 0x5b, 0xff, 0xc9, 0x01, 0x1b, 0x00, 0x6d,
+  0xff, 0xb7, 0x01, 0x1b, 0x00, 0xa9, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xaa,
+  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xab, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xac,
+  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xad, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb3,
+  0xff, 0xdc, 0x01, 0x1b, 0x00, 0xb4, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb5,
+  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb6, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb7,
+  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xb8, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xc9,
+  0xff, 0xd3, 0x01, 0x1b, 0x00, 0xcf, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xd1,
+  0xff, 0xdc, 0x01, 0x1b, 0x00, 0xdd, 0xff, 0xd3, 0x01, 0x1b, 0x00, 0xe1,
+  0xff, 0xdc, 0x01, 0x1b, 0x01, 0x0a, 0xff, 0xdc, 0x01, 0x1b, 0x01, 0x17,
+  0xff, 0xdc, 0x01, 0x1b, 0x01, 0x1b, 0xff, 0xdc, 0x01, 0x1b, 0x07, 0x52,
+  0x00, 0x56, 0x01, 0x1b, 0x07, 0x53, 0xfe, 0xc9, 0x01, 0x20, 0x00, 0x24,
+  0x00, 0x26, 0x01, 0x20, 0x00, 0x82, 0x00, 0x26, 0x01, 0x20, 0x00, 0x83,
+  0x00, 0x26, 0x01, 0x20, 0x00, 0x84, 0x00, 0x26, 0x01, 0x20, 0x00, 0x85,
+  0x00, 0x26, 0x01, 0x20, 0x00, 0x86, 0x00, 0x26, 0x01, 0x22, 0x00, 0x24,
+  0x00, 0x26, 0x01, 0x22, 0x00, 0x82, 0x00, 0x26, 0x01, 0x22, 0x00, 0x83,
+  0x00, 0x26, 0x01, 0x22, 0x00, 0x84, 0x00, 0x26, 0x01, 0x22, 0x00, 0x85,
+  0x00, 0x26, 0x01, 0x22, 0x00, 0x86, 0x00, 0x26, 0x01, 0x26, 0x00, 0x10,
+  0xff, 0x44, 0x01, 0x26, 0x00, 0x11, 0xff, 0x0d, 0x01, 0x26, 0x00, 0x1d,
+  0xff, 0x1f, 0x01, 0x26, 0x00, 0x24, 0xff, 0x61, 0x01, 0x26, 0x00, 0x26,
+  0xff, 0x88, 0x01, 0x26, 0x00, 0x37, 0xff, 0xdc, 0x01, 0x26, 0x00, 0x44,
+  0xfe, 0xad, 0x01, 0x26, 0x00, 0x46, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0x48,
+  0xfe, 0xa4, 0x01, 0x26, 0x00, 0x4c, 0xff, 0xc1, 0x01, 0x26, 0x00, 0x52,
+  0xfe, 0xa4, 0x01, 0x26, 0x00, 0x55, 0xfe, 0xd3, 0x01, 0x26, 0x00, 0x56,
+  0xfe, 0xad, 0x01, 0x26, 0x00, 0x58, 0xfe, 0xc9, 0x01, 0x26, 0x00, 0x5a,
+  0xfe, 0xad, 0x01, 0x26, 0x00, 0x5c, 0xfe, 0xc1, 0x01, 0x26, 0x00, 0x6d,
+  0xff, 0x44, 0x01, 0x26, 0x00, 0x7d, 0xff, 0x90, 0x01, 0x26, 0x00, 0x82,
+  0xff, 0x61, 0x01, 0x26, 0x00, 0x83, 0xff, 0x61, 0x01, 0x26, 0x00, 0x84,
+  0xff, 0x61, 0x01, 0x26, 0x00, 0x85, 0xff, 0x61, 0x01, 0x26, 0x00, 0x86,
+  0xff, 0x61, 0x01, 0x26, 0x00, 0x89, 0xff, 0x88, 0x01, 0x26, 0x00, 0xa2,
+  0xfe, 0xad, 0x01, 0x26, 0x00, 0xa3, 0xfe, 0xad, 0x01, 0x26, 0x00, 0xa4,
+  0xfe, 0xad, 0x01, 0x26, 0x00, 0xa5, 0xfe, 0xad, 0x01, 0x26, 0x00, 0xa6,
+  0xfe, 0xad, 0x01, 0x26, 0x00, 0xa7, 0xfe, 0xad, 0x01, 0x26, 0x00, 0xa9,
+  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xaa, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xab,
+  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xac, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xad,
+  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb4, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb5,
+  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb6, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb7,
+  0xfe, 0xa4, 0x01, 0x26, 0x00, 0xb8, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xbb,
+  0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbc, 0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbd,
+  0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbe, 0xfe, 0xc9, 0x01, 0x26, 0x00, 0xbf,
+  0xfe, 0xc1, 0x01, 0x26, 0x00, 0xc1, 0xfe, 0xc1, 0x01, 0x26, 0x00, 0xc8,
+  0xff, 0x88, 0x01, 0x26, 0x00, 0xc9, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xce,
+  0xff, 0x88, 0x01, 0x26, 0x00, 0xcf, 0xfe, 0xa4, 0x01, 0x26, 0x00, 0xdd,
+  0xfe, 0xa4, 0x01, 0x26, 0x01, 0x17, 0xfe, 0xd3, 0x01, 0x26, 0x01, 0x1b,
+  0xfe, 0xd3, 0x01, 0x26, 0x01, 0x21, 0xfe, 0xad, 0x01, 0x26, 0x01, 0x23,
+  0xfe, 0xad, 0x01, 0x26, 0x01, 0x26, 0xff, 0xdc, 0x01, 0x26, 0x01, 0x31,
+  0xfe, 0xc9, 0x01, 0x26, 0x07, 0x52, 0xff, 0xd3, 0x01, 0x26, 0x07, 0x53,
+  0xfe, 0xf8, 0x01, 0x30, 0x00, 0x3d, 0xff, 0xdc, 0x01, 0x30, 0x01, 0x3f,
+  0xff, 0xdc, 0x01, 0x3a, 0x00, 0x10, 0xff, 0x0d, 0x01, 0x3a, 0x00, 0x11,
+  0xfe, 0x61, 0x01, 0x3a, 0x00, 0x1d, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0x24,
+  0xff, 0x61, 0x01, 0x3a, 0x00, 0x26, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x32,
+  0xff, 0x90, 0x01, 0x3a, 0x00, 0x44, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0x48,
+  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0x4c, 0xff, 0xb7, 0x01, 0x3a, 0x00, 0x52,
+  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0x58, 0xff, 0x15, 0x01, 0x3a, 0x00, 0x6d,
+  0xff, 0x1f, 0x01, 0x3a, 0x00, 0x7d, 0xff, 0x6b, 0x01, 0x3a, 0x00, 0x82,
+  0xff, 0x61, 0x01, 0x3a, 0x00, 0x83, 0xff, 0x61, 0x01, 0x3a, 0x00, 0x84,
+  0xff, 0x61, 0x01, 0x3a, 0x00, 0x85, 0xff, 0x61, 0x01, 0x3a, 0x00, 0x86,
+  0xff, 0x61, 0x01, 0x3a, 0x00, 0x89, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x94,
+  0xff, 0x90, 0x01, 0x3a, 0x00, 0x95, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x96,
+  0xff, 0x90, 0x01, 0x3a, 0x00, 0x97, 0xff, 0x90, 0x01, 0x3a, 0x00, 0x98,
+  0xff, 0x90, 0x01, 0x3a, 0x00, 0xa2, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa3,
+  0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa4, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa5,
+  0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa6, 0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xa7,
+  0xfe, 0xe6, 0x01, 0x3a, 0x00, 0xaa, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xab,
+  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xac, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xad,
+  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb4, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb5,
+  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb6, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb7,
+  0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xb8, 0xfe, 0xf0, 0x01, 0x3a, 0x00, 0xbb,
+  0xff, 0x15, 0x01, 0x3a, 0x00, 0xbc, 0xff, 0x15, 0x01, 0x3a, 0x00, 0xbd,
+  0xff, 0x15, 0x01, 0x3a, 0x00, 0xbe, 0xff, 0x15, 0x01, 0x3a, 0x00, 0xc8,
+  0xff, 0x90, 0x01, 0x3a, 0x00, 0xce, 0xff, 0x90, 0x01, 0x3a, 0x00, 0xdd,
+  0xfe, 0xf0, 0x01, 0x3a, 0x01, 0x31, 0xff, 0x15, 0x01, 0x3a, 0x07, 0x51,
+  0xff, 0x90, 0x01, 0x3a, 0x07, 0x52, 0xff, 0xdc, 0x01, 0x3a, 0x07, 0x53,
+  0xfe, 0xf8, 0x01, 0x3f, 0x00, 0x10, 0xff, 0xdc, 0x01, 0x3f, 0x07, 0x51,
+  0xff, 0xdc, 0x01, 0x3f, 0x07, 0x52, 0xff, 0xdc, 0x01, 0x3f, 0x07, 0x53,
+  0xff, 0xdc, 0x07, 0x45, 0x00, 0x24, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x25,
+  0xff, 0xb7, 0x07, 0x45, 0x00, 0x2a, 0x00, 0x4b, 0x07, 0x45, 0x00, 0x2d,
+  0x00, 0x72, 0x07, 0x45, 0x00, 0x32, 0x00, 0x39, 0x07, 0x45, 0x00, 0x34,
+  0x00, 0x4b, 0x07, 0x45, 0x00, 0x37, 0xff, 0x44, 0x07, 0x45, 0x00, 0x39,
+  0xff, 0x88, 0x07, 0x45, 0x00, 0x3a, 0xff, 0xad, 0x07, 0x45, 0x00, 0x3b,
+  0xff, 0x9a, 0x07, 0x45, 0x00, 0x3c, 0xff, 0x0d, 0x07, 0x45, 0x00, 0x52,
+  0x00, 0x26, 0x07, 0x45, 0x00, 0x59, 0xff, 0xc9, 0x07, 0x45, 0x00, 0x5c,
+  0xff, 0xdc, 0x07, 0x45, 0x00, 0x82, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x83,
+  0xff, 0xd3, 0x07, 0x45, 0x00, 0x84, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x85,
+  0xff, 0xd3, 0x07, 0x45, 0x00, 0x86, 0xff, 0xd3, 0x07, 0x45, 0x00, 0x94,
+  0x00, 0x39, 0x07, 0x45, 0x00, 0x95, 0x00, 0x39, 0x07, 0x45, 0x00, 0x96,
+  0x00, 0x39, 0x07, 0x45, 0x00, 0x97, 0x00, 0x39, 0x07, 0x45, 0x00, 0x98,
+  0x00, 0x39, 0x07, 0x45, 0x00, 0x9f, 0xff, 0x0d, 0x07, 0x45, 0x00, 0xb4,
+  0x00, 0x26, 0x07, 0x45, 0x00, 0xb5, 0x00, 0x26, 0x07, 0x45, 0x00, 0xb6,
+  0x00, 0x26, 0x07, 0x45, 0x00, 0xb7, 0x00, 0x26, 0x07, 0x45, 0x00, 0xb8,
+  0x00, 0x26, 0x07, 0x45, 0x00, 0xbf, 0xff, 0xdc, 0x07, 0x45, 0x00, 0xc1,
+  0xff, 0xdc, 0x07, 0x45, 0x00, 0xe0, 0x00, 0x4b, 0x07, 0x45, 0x01, 0x26,
+  0xff, 0x44, 0x07, 0x45, 0x01, 0x3a, 0xff, 0x0d, 0x07, 0x51, 0x00, 0x24,
+  0xfe, 0xf8, 0x07, 0x51, 0x00, 0x25, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x26,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x27, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x29,
+  0xff, 0xc1, 0x07, 0x51, 0x00, 0x2a, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x2b,
+  0xff, 0xc1, 0x07, 0x51, 0x00, 0x2d, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x2e,
+  0xff, 0xc1, 0x07, 0x51, 0x00, 0x2f, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x32,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x33, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x34,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x35, 0xff, 0xc1, 0x07, 0x51, 0x00, 0x3b,
+  0xff, 0x88, 0x07, 0x51, 0x00, 0x3d, 0xff, 0xdc, 0x07, 0x51, 0x00, 0x49,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x51, 0xff, 0x90, 0x07, 0x51, 0x00, 0x52,
+  0xff, 0x6b, 0x07, 0x51, 0x00, 0x55, 0xff, 0x90, 0x07, 0x51, 0x00, 0x59,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x5a, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x5c,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x82, 0xfe, 0xf8, 0x07, 0x51, 0x00, 0x83,
+  0xfe, 0xf8, 0x07, 0x51, 0x00, 0x84, 0xfe, 0xf8, 0x07, 0x51, 0x00, 0x85,
+  0xfe, 0xf8, 0x07, 0x51, 0x00, 0x86, 0xfe, 0xf8, 0x07, 0x51, 0x00, 0x88,
+  0xfe, 0x7d, 0x07, 0x51, 0x00, 0x89, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x94,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x95, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x96,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0x97, 0xff, 0xb7, 0x07, 0x51, 0x00, 0x98,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0xa0, 0xff, 0xc1, 0x07, 0x51, 0x00, 0xa1,
+  0xff, 0xc1, 0x07, 0x51, 0x00, 0xb2, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xb3,
+  0xff, 0x90, 0x07, 0x51, 0x00, 0xb4, 0xff, 0x6b, 0x07, 0x51, 0x00, 0xb5,
+  0xff, 0x6b, 0x07, 0x51, 0x00, 0xb6, 0xff, 0x6b, 0x07, 0x51, 0x00, 0xb7,
+  0xff, 0x6b, 0x07, 0x51, 0x00, 0xb8, 0xff, 0x6b, 0x07, 0x51, 0x00, 0xbf,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0xc1, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xc8,
+  0xff, 0xb7, 0x07, 0x51, 0x00, 0xce, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xd0,
+  0xff, 0xc1, 0x07, 0x51, 0x00, 0xe0, 0xff, 0xb7, 0x07, 0x51, 0x00, 0xfb,
+  0xff, 0xc1, 0x07, 0x51, 0x00, 0xff, 0xff, 0xc1, 0x07, 0x51, 0x01, 0x0a,
+  0xff, 0x90, 0x07, 0x51, 0x01, 0x16, 0xff, 0xc1, 0x07, 0x51, 0x01, 0x17,
+  0xff, 0x90, 0x07, 0x51, 0x01, 0x1a, 0xff, 0xc1, 0x07, 0x51, 0x01, 0x1b,
+  0xff, 0x90, 0x07, 0x51, 0x01, 0x3f, 0xff, 0xdc, 0x07, 0x51, 0x0e, 0x78,
+  0xff, 0xc1, 0x07, 0x53, 0x00, 0x24, 0x00, 0x26, 0x07, 0x53, 0x00, 0x25,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x26, 0xff, 0x90, 0x07, 0x53, 0x00, 0x27,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x29, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x2a,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x2b, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x2d,
+  0x00, 0x2f, 0x07, 0x53, 0x00, 0x2e, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x2f,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x32, 0xff, 0x90, 0x07, 0x53, 0x00, 0x33,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x34, 0xff, 0x90, 0x07, 0x53, 0x00, 0x35,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x37, 0xfe, 0xe6, 0x07, 0x53, 0x00, 0x39,
+  0xfe, 0x88, 0x07, 0x53, 0x00, 0x3a, 0xff, 0x03, 0x07, 0x53, 0x00, 0x3b,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x3c, 0xfe, 0x88, 0x07, 0x53, 0x00, 0x49,
+  0xff, 0xdc, 0x07, 0x53, 0x00, 0x51, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x52,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0x55, 0xff, 0xb7, 0x07, 0x53, 0x00, 0x59,
+  0xff, 0x15, 0x07, 0x53, 0x00, 0x5a, 0xff, 0x3c, 0x07, 0x53, 0x00, 0x5c,
+  0xff, 0x90, 0x07, 0x53, 0x00, 0x82, 0x00, 0x26, 0x07, 0x53, 0x00, 0x83,
+  0x00, 0x26, 0x07, 0x53, 0x00, 0x84, 0x00, 0x26, 0x07, 0x53, 0x00, 0x85,
+  0x00, 0x26, 0x07, 0x53, 0x00, 0x86, 0x00, 0x26, 0x07, 0x53, 0x00, 0x88,
+  0x00, 0x26, 0x07, 0x53, 0x00, 0x89, 0xff, 0x90, 0x07, 0x53, 0x00, 0x94,
+  0xff, 0x90, 0x07, 0x53, 0x00, 0x95, 0xff, 0x90, 0x07, 0x53, 0x00, 0x96,
+  0xff, 0x90, 0x07, 0x53, 0x00, 0x97, 0xff, 0x90, 0x07, 0x53, 0x00, 0x98,
+  0xff, 0x90, 0x07, 0x53, 0x00, 0x9f, 0xfe, 0x88, 0x07, 0x53, 0x00, 0xa0,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0xa1, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb2,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0xb3, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb4,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0xb5, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb6,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0xb7, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xb8,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0xbf, 0xff, 0x90, 0x07, 0x53, 0x00, 0xc1,
+  0xff, 0x90, 0x07, 0x53, 0x00, 0xc8, 0xff, 0x90, 0x07, 0x53, 0x00, 0xce,
+  0xff, 0x90, 0x07, 0x53, 0x00, 0xd0, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xe0,
+  0xff, 0xb7, 0x07, 0x53, 0x00, 0xfb, 0xff, 0xb7, 0x07, 0x53, 0x00, 0xff,
+  0xff, 0xb7, 0x07, 0x53, 0x01, 0x0a, 0xff, 0xb7, 0x07, 0x53, 0x01, 0x16,
+  0xff, 0xb7, 0x07, 0x53, 0x01, 0x17, 0xff, 0xb7, 0x07, 0x53, 0x01, 0x1a,
+  0xff, 0xb7, 0x07, 0x53, 0x01, 0x1b, 0xff, 0xb7, 0x07, 0x53, 0x01, 0x26,
+  0xfe, 0xe6, 0x07, 0x53, 0x01, 0x3a, 0xfe, 0x88, 0x07, 0x53, 0x0e, 0x78,
+  0xff, 0xb7, 0x0e, 0x60, 0x00, 0x10, 0xff, 0x44, 0x0e, 0x60, 0x00, 0x11,
+  0xff, 0x0d, 0x0e, 0x60, 0x00, 0x1d, 0xff, 0x1f, 0x0e, 0x60, 0x00, 0x24,
+  0xff, 0x61, 0x0e, 0x60, 0x00, 0x26, 0xff, 0x88, 0x0e, 0x60, 0x00, 0x37,
+  0xff, 0xdc, 0x0e, 0x60, 0x00, 0x44, 0xfe, 0xad, 0x0e, 0x60, 0x00, 0x46,
+  0xfe, 0xa4, 0x0e, 0x60, 0x00, 0x48, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0x4c,
+  0xff, 0xc1, 0x0e, 0x60, 0x00, 0x52, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0x55,
+  0xfe, 0xd3, 0x0e, 0x60, 0x00, 0x56, 0xfe, 0xad, 0x0e, 0x60, 0x00, 0x58,
+  0xfe, 0xc9, 0x0e, 0x60, 0x00, 0x5a, 0xfe, 0xad, 0x0e, 0x60, 0x00, 0x5c,
+  0xfe, 0xc1, 0x0e, 0x60, 0x00, 0x6d, 0xff, 0x44, 0x0e, 0x60, 0x00, 0x7d,
+  0xff, 0x90, 0x0e, 0x60, 0x00, 0x82, 0xff, 0x61, 0x0e, 0x60, 0x00, 0x83,
+  0xff, 0x61, 0x0e, 0x60, 0x00, 0x84, 0xff, 0x61, 0x0e, 0x60, 0x00, 0x85,
+  0xff, 0x61, 0x0e, 0x60, 0x00, 0x86, 0xff, 0x61, 0x0e, 0x60, 0x00, 0x89,
+  0xff, 0x88, 0x0e, 0x60, 0x00, 0xa2, 0xff, 0x11, 0x0e, 0x60, 0x00, 0xa3,
+  0xfe, 0xad, 0x0e, 0x60, 0x00, 0xa4, 0xff, 0x11, 0x0e, 0x60, 0x00, 0xa5,
+  0xff, 0x11, 0x0e, 0x60, 0x00, 0xa6, 0xff, 0x11, 0x0e, 0x60, 0x00, 0xa7,
+  0xff, 0x11, 0x0e, 0x60, 0x00, 0xa9, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xaa,
+  0xfe, 0xe0, 0x0e, 0x60, 0x00, 0xab, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xac,
+  0xfe, 0xe0, 0x0e, 0x60, 0x00, 0xad, 0xfe, 0xe0, 0x0e, 0x60, 0x00, 0xb4,
+  0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xb5, 0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xb6,
+  0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xb7, 0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xb8,
+  0xfe, 0xf4, 0x0e, 0x60, 0x00, 0xbb, 0xfe, 0xe7, 0x0e, 0x60, 0x00, 0xbc,
+  0xfe, 0xc9, 0x0e, 0x60, 0x00, 0xbd, 0xfe, 0xe7, 0x0e, 0x60, 0x00, 0xbe,
+  0xfe, 0xe7, 0x0e, 0x60, 0x00, 0xbf, 0xfe, 0xc1, 0x0e, 0x60, 0x00, 0xc1,
+  0xfe, 0xc1, 0x0e, 0x60, 0x00, 0xc8, 0xff, 0x88, 0x0e, 0x60, 0x00, 0xc9,
+  0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xce, 0xff, 0x88, 0x0e, 0x60, 0x00, 0xcf,
+  0xfe, 0xa4, 0x0e, 0x60, 0x00, 0xdd, 0xfe, 0xa4, 0x0e, 0x60, 0x01, 0x17,
+  0xfe, 0xd3, 0x0e, 0x60, 0x01, 0x1b, 0xfe, 0xd3, 0x0e, 0x60, 0x01, 0x21,
+  0xfe, 0xad, 0x0e, 0x60, 0x01, 0x23, 0xfe, 0xad, 0x0e, 0x60, 0x01, 0x26,
+  0xff, 0xdc, 0x0e, 0x60, 0x01, 0x31, 0xfe, 0xc9, 0x0e, 0x60, 0x07, 0x52,
+  0xff, 0xd3, 0x0e, 0x60, 0x07, 0x53, 0xfe, 0xf8, 0x0e, 0x78, 0x00, 0x10,
+  0xff, 0x29, 0x0e, 0x78, 0x00, 0x24, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0x26,
+  0xff, 0x90, 0x0e, 0x78, 0x00, 0x32, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x37,
+  0xff, 0x61, 0x0e, 0x78, 0x00, 0x38, 0xff, 0xc9, 0x0e, 0x78, 0x00, 0x3a,
+  0xff, 0xb7, 0x0e, 0x78, 0x00, 0x3c, 0xff, 0xb7, 0x0e, 0x78, 0x00, 0x44,
+  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x48, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0x52,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0x58, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0x5c,
+  0xff, 0x6b, 0x0e, 0x78, 0x00, 0x6d, 0xff, 0x7d, 0x0e, 0x78, 0x00, 0x82,
+  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x83, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0x84,
+  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x85, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0x86,
+  0xff, 0xdc, 0x0e, 0x78, 0x00, 0x89, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x94,
+  0xff, 0x90, 0x0e, 0x78, 0x00, 0x95, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x96,
+  0xff, 0x90, 0x0e, 0x78, 0x00, 0x97, 0xff, 0x90, 0x0e, 0x78, 0x00, 0x98,
+  0xff, 0x90, 0x0e, 0x78, 0x00, 0x9b, 0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9c,
+  0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9d, 0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9e,
+  0xff, 0xc9, 0x0e, 0x78, 0x00, 0x9f, 0xff, 0xb7, 0x0e, 0x78, 0x00, 0xa2,
+  0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa3, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa4,
+  0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa5, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa6,
+  0xff, 0xdc, 0x0e, 0x78, 0x00, 0xa7, 0xff, 0xdc, 0x0e, 0x78, 0x00, 0xaa,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xab, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xac,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xad, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb4,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb5, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb6,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb7, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xb8,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbb, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbc,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbd, 0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbe,
+  0xff, 0x9a, 0x0e, 0x78, 0x00, 0xbf, 0xff, 0x6b, 0x0e, 0x78, 0x00, 0xc1,
+  0xff, 0x6b, 0x0e, 0x78, 0x00, 0xc8, 0xff, 0x90, 0x0e, 0x78, 0x00, 0xce,
+  0xff, 0x90, 0x0e, 0x78, 0x00, 0xdd, 0xff, 0x9a, 0x0e, 0x78, 0x01, 0x26,
+  0xff, 0x61, 0x0e, 0x78, 0x01, 0x30, 0xff, 0xc9, 0x0e, 0x78, 0x01, 0x31,
+  0xff, 0x9a, 0x0e, 0x78, 0x01, 0x3a, 0xff, 0xb7, 0x0e, 0x78, 0x07, 0x51,
+  0xff, 0xc1, 0x0e, 0x78, 0x07, 0x52, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0x44,
+  0xff, 0xdc, 0x0e, 0x79, 0x00, 0x48, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0x52,
+  0xff, 0xb7, 0x0e, 0x79, 0x00, 0x58, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0x5c,
+  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xa2, 0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa3,
+  0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa4, 0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa5,
+  0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa6, 0xff, 0xdc, 0x0e, 0x79, 0x00, 0xa7,
+  0xff, 0xdc, 0x0e, 0x79, 0x00, 0xaa, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xab,
+  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xac, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xad,
+  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb4, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb5,
+  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb6, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb7,
+  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xb8, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xbb,
+  0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbc, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbd,
+  0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbe, 0xff, 0xc1, 0x0e, 0x79, 0x00, 0xbf,
+  0xff, 0xb7, 0x0e, 0x79, 0x00, 0xc1, 0xff, 0xb7, 0x0e, 0x79, 0x00, 0xdd,
+  0xff, 0xb7, 0x0e, 0x79, 0x01, 0x31, 0xff, 0xc1, 0x0e, 0xaa, 0x0e, 0xc2,
+  0xff, 0xd8, 0x0e, 0xab, 0x0e, 0xc2, 0xff, 0xb1, 0x0e, 0xac, 0x0e, 0xc2,
+  0xff, 0xa3, 0x0e, 0xad, 0x0e, 0xc2, 0xff, 0x9c, 0x0e, 0xae, 0x0e, 0xc2,
+  0xff, 0xd8, 0x0e, 0xb0, 0x0e, 0xc2, 0xff, 0xd8, 0x0e, 0xb1, 0x0e, 0xc2,
+  0xff, 0xb1, 0x0e, 0xb2, 0x0e, 0xc2, 0xff, 0xa3, 0x0e, 0xb3, 0x0e, 0xc2,
+  0xff, 0xb1, 0x0e, 0xb4, 0x0e, 0xc2, 0xff, 0xd8, 0x0e, 0xb6, 0x0e, 0xc2,
+  0xff, 0xd8, 0x0e, 0xb7, 0x0e, 0xc2, 0xff, 0xb1, 0x0e, 0xb8, 0x0e, 0xc2,
+  0xff, 0xa3, 0x0e, 0xb9, 0x0e, 0xc2, 0xff, 0xb1, 0x0e, 0xba, 0x0e, 0xc2,
+  0xff, 0xd8, 0x0e, 0xbc, 0x0e, 0xc2, 0xff, 0xd8, 0x0e, 0xbd, 0x0e, 0xc2,
+  0xff, 0x9c, 0x0e, 0xbe, 0x0e, 0xc2, 0xff, 0xa3, 0x0e, 0xbf, 0x0e, 0xc2,
+  0xff, 0xb1, 0x0e, 0xc0, 0x0e, 0xc2, 0xff, 0xd8, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x2c,
+  0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x58, 0x00, 0x00, 0x00, 0x80,
+  0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0x01, 0x90, 0x00, 0x00, 0x02, 0x2c,
+  0x00, 0x00, 0x02, 0xc8, 0x00, 0x00, 0x02, 0xe4, 0x00, 0x00, 0x03, 0x20,
+  0x00, 0x00, 0x03, 0x58, 0x00, 0x00, 0x03, 0xa4, 0x00, 0x00, 0x03, 0xd8,
+  0x00, 0x00, 0x03, 0xf8, 0x00, 0x00, 0x04, 0x14, 0x00, 0x00, 0x04, 0x2c,
+  0x00, 0x00, 0x04, 0x48, 0x00, 0x00, 0x04, 0xa4, 0x00, 0x00, 0x04, 0xd4,
+  0x00, 0x00, 0x05, 0x34, 0x00, 0x00, 0x05, 0xac, 0x00, 0x00, 0x05, 0xe8,
+  0x00, 0x00, 0x06, 0x48, 0x00, 0x00, 0x06, 0xc0, 0x00, 0x00, 0x06, 0xe8,
+  0x00, 0x00, 0x07, 0x74, 0x00, 0x00, 0x07, 0xec, 0x00, 0x00, 0x08, 0x10,
+  0x00, 0x00, 0x08, 0x3c, 0x00, 0x00, 0x08, 0x68, 0x00, 0x00, 0x08, 0x90,
+  0x00, 0x00, 0x08, 0xb8, 0x00, 0x00, 0x09, 0x2c, 0x00, 0x00, 0x0a, 0x14,
+  0x00, 0x00, 0x0a, 0x4c, 0x00, 0x00, 0x0a, 0xb8, 0x00, 0x00, 0x0b, 0x14,
+  0x00, 0x00, 0x0b, 0x64, 0x00, 0x00, 0x0b, 0x94, 0x00, 0x00, 0x0b, 0xc0,
+  0x00, 0x00, 0x0c, 0x28, 0x00, 0x00, 0x0c, 0x58, 0x00, 0x00, 0x0c, 0x74,
+  0x00, 0x00, 0x0c, 0xa0, 0x00, 0x00, 0x0c, 0xd4, 0x00, 0x00, 0x0c, 0xf4,
+  0x00, 0x00, 0x0d, 0x30, 0x00, 0x00, 0x0d, 0x60, 0x00, 0x00, 0x0d, 0xc4,
+  0x00, 0x00, 0x0e, 0x08, 0x00, 0x00, 0x0e, 0x7c, 0x00, 0x00, 0x0e, 0xe0,
+  0x00, 0x00, 0x0f, 0x58, 0x00, 0x00, 0x0f, 0x80, 0x00, 0x00, 0x0f, 0xc4,
+  0x00, 0x00, 0x0f, 0xf0, 0x00, 0x00, 0x10, 0x30, 0x00, 0x00, 0x10, 0x70,
+  0x00, 0x00, 0x10, 0xa0, 0x00, 0x00, 0x10, 0xd0, 0x00, 0x00, 0x10, 0xf4,
+  0x00, 0x00, 0x11, 0x14, 0x00, 0x00, 0x11, 0x38, 0x00, 0x00, 0x11, 0x64,
+  0x00, 0x00, 0x11, 0x80, 0x00, 0x00, 0x11, 0xa0, 0x00, 0x00, 0x12, 0x10,
+  0x00, 0x00, 0x12, 0x70, 0x00, 0x00, 0x12, 0xc8, 0x00, 0x00, 0x13, 0x28,
+  0x00, 0x00, 0x13, 0x8c, 0x00, 0x00, 0x13, 0xcc, 0x00, 0x00, 0x14, 0x48,
+  0x00, 0x00, 0x14, 0x8c, 0x00, 0x00, 0x14, 0xb0, 0x00, 0x00, 0x14, 0xe8,
+  0x00, 0x00, 0x15, 0x1c, 0x00, 0x00, 0x15, 0x38, 0x00, 0x00, 0x15, 0xa0,
+  0x00, 0x00, 0x15, 0xe4, 0x00, 0x00, 0x16, 0x38, 0x00, 0x00, 0x16, 0x98,
+  0x00, 0x00, 0x16, 0xf8, 0x00, 0x00, 0x17, 0x38, 0x00, 0x00, 0x17, 0xb0,
+  0x00, 0x00, 0x17, 0xf4, 0x00, 0x00, 0x18, 0x3c, 0x00, 0x00, 0x18, 0x64,
+  0x00, 0x00, 0x18, 0xa0, 0x00, 0x00, 0x18, 0xe0, 0x00, 0x00, 0x19, 0x20,
+  0x00, 0x00, 0x19, 0x50, 0x00, 0x00, 0x19, 0xb4, 0x00, 0x00, 0x19, 0xd0,
+  0x00, 0x00, 0x1a, 0x34, 0x00, 0x00, 0x1a, 0x94, 0x00, 0x00, 0x1a, 0x94,
+  0x00, 0x00, 0x1a, 0xc4, 0x00, 0x00, 0x1b, 0x3c, 0x00, 0x00, 0x1b, 0x94,
+  0x00, 0x00, 0x1c, 0x28, 0x00, 0x00, 0x1c, 0x84, 0x00, 0x00, 0x1c, 0xb0,
+  0x00, 0x00, 0x1d, 0x68, 0x00, 0x00, 0x1d, 0x90, 0x00, 0x00, 0x1e, 0x6c,
+  0x00, 0x00, 0x1e, 0xe8, 0x00, 0x00, 0x1f, 0x2c, 0x00, 0x00, 0x1f, 0x4c,
+  0x00, 0x00, 0x1f, 0x68, 0x00, 0x00, 0x20, 0x50, 0x00, 0x00, 0x20, 0x6c,
+  0x00, 0x00, 0x20, 0xc4, 0x00, 0x00, 0x21, 0x04, 0x00, 0x00, 0x21, 0x58,
+  0x00, 0x00, 0x21, 0xcc, 0x00, 0x00, 0x21, 0xe8, 0x00, 0x00, 0x22, 0x4c,
+  0x00, 0x00, 0x22, 0x84, 0x00, 0x00, 0x22, 0x9c, 0x00, 0x00, 0x22, 0xe0,
+  0x00, 0x00, 0x23, 0x0c, 0x00, 0x00, 0x23, 0x68, 0x00, 0x00, 0x23, 0xb0,
+  0x00, 0x00, 0x23, 0xd0, 0x00, 0x00, 0x23, 0xf0, 0x00, 0x00, 0x24, 0x10,
+  0x00, 0x00, 0x24, 0x84, 0x00, 0x00, 0x24, 0x9c, 0x00, 0x00, 0x24, 0xb4,
+  0x00, 0x00, 0x24, 0xd0, 0x00, 0x00, 0x24, 0xec, 0x00, 0x00, 0x25, 0x08,
+  0x00, 0x00, 0x25, 0x7c, 0x00, 0x00, 0x25, 0xcc, 0x00, 0x00, 0x25, 0xe4,
+  0x00, 0x00, 0x25, 0xfc, 0x00, 0x00, 0x26, 0x14, 0x00, 0x00, 0x26, 0x30,
+  0x00, 0x00, 0x26, 0x4c, 0x00, 0x00, 0x26, 0x64, 0x00, 0x00, 0x26, 0x7c,
+  0x00, 0x00, 0x26, 0x98, 0x00, 0x00, 0x26, 0xb4, 0x00, 0x00, 0x27, 0x18,
+  0x00, 0x00, 0x27, 0x34, 0x00, 0x00, 0x27, 0x4c, 0x00, 0x00, 0x27, 0x64,
+  0x00, 0x00, 0x27, 0x80, 0x00, 0x00, 0x27, 0x9c, 0x00, 0x00, 0x27, 0xb8,
+  0x00, 0x00, 0x27, 0xfc, 0x00, 0x00, 0x28, 0x94, 0x00, 0x00, 0x28, 0xac,
+  0x00, 0x00, 0x28, 0xc4, 0x00, 0x00, 0x28, 0xe0, 0x00, 0x00, 0x28, 0xfc,
+  0x00, 0x00, 0x29, 0x14, 0x00, 0x00, 0x29, 0x5c, 0x00, 0x00, 0x29, 0xe8,
+  0x00, 0x00, 0x2a, 0x00, 0x00, 0x00, 0x2a, 0x18, 0x00, 0x00, 0x2a, 0x30,
+  0x00, 0x00, 0x2a, 0x48, 0x00, 0x00, 0x2a, 0x60, 0x00, 0x00, 0x2a, 0x78,
+  0x00, 0x00, 0x2b, 0x30, 0x00, 0x00, 0x2b, 0x48, 0x00, 0x00, 0x2b, 0x60,
+  0x00, 0x00, 0x2b, 0x78, 0x00, 0x00, 0x2b, 0x90, 0x00, 0x00, 0x2b, 0xa8,
+  0x00, 0x00, 0x2b, 0xc0, 0x00, 0x00, 0x2b, 0xd8, 0x00, 0x00, 0x2b, 0xf4,
+  0x00, 0x00, 0x2c, 0x10, 0x00, 0x00, 0x2c, 0x98, 0x00, 0x00, 0x2c, 0xb0,
+  0x00, 0x00, 0x2c, 0xc8, 0x00, 0x00, 0x2c, 0xe0, 0x00, 0x00, 0x2c, 0xf8,
+  0x00, 0x00, 0x2d, 0x10, 0x00, 0x00, 0x2d, 0x28, 0x00, 0x00, 0x2d, 0x5c,
+  0x00, 0x00, 0x2d, 0xec, 0x00, 0x00, 0x2e, 0x04, 0x00, 0x00, 0x2e, 0x1c,
+  0x00, 0x00, 0x2e, 0x34, 0x00, 0x00, 0x2e, 0x4c, 0x00, 0x00, 0x2e, 0x64,
+  0x00, 0x00, 0x2e, 0xc4, 0x00, 0x00, 0x2e, 0xdc, 0x00, 0x00, 0x2e, 0xf8,
+  0x00, 0x00, 0x2f, 0x10, 0x00, 0x00, 0x2f, 0x2c, 0x00, 0x00, 0x2f, 0x44,
+  0x00, 0x00, 0x2f, 0x5c, 0x00, 0x00, 0x2f, 0x74, 0x00, 0x00, 0x2f, 0x8c,
+  0x00, 0x00, 0x2f, 0xa4, 0x00, 0x00, 0x2f, 0xc0, 0x00, 0x00, 0x2f, 0xd8,
+  0x00, 0x00, 0x2f, 0xf0, 0x00, 0x00, 0x30, 0x08, 0x00, 0x00, 0x30, 0x24,
+  0x00, 0x00, 0x30, 0x3c, 0x00, 0x00, 0x30, 0x54, 0x00, 0x00, 0x30, 0x70,
+  0x00, 0x00, 0x30, 0x80, 0x00, 0x00, 0x30, 0xf4, 0x00, 0x00, 0x31, 0x0c,
+  0x00, 0x00, 0x31, 0x28, 0x00, 0x00, 0x31, 0x44, 0x00, 0x00, 0x31, 0x60,
+  0x00, 0x00, 0x31, 0x78, 0x00, 0x00, 0x31, 0x90, 0x00, 0x00, 0x31, 0xa8,
+  0x00, 0x00, 0x31, 0xc0, 0x00, 0x00, 0x31, 0xdc, 0x00, 0x00, 0x31, 0xf8,
+  0x00, 0x00, 0x32, 0x14, 0x00, 0x00, 0x32, 0x2c, 0x00, 0x00, 0x32, 0x44,
+  0x00, 0x00, 0x32, 0x5c, 0x00, 0x00, 0x32, 0x78, 0x00, 0x00, 0x32, 0x90,
+  0x00, 0x00, 0x32, 0xa8, 0x00, 0x00, 0x32, 0xc0, 0x00, 0x00, 0x32, 0xdc,
+  0x00, 0x00, 0x32, 0xf8, 0x00, 0x00, 0x33, 0x44, 0x00, 0x00, 0x33, 0x9c,
+  0x00, 0x00, 0x33, 0xb8, 0x00, 0x00, 0x33, 0xd4, 0x00, 0x00, 0x33, 0xf0,
+  0x00, 0x00, 0x34, 0x0c, 0x00, 0x00, 0x34, 0x28, 0x00, 0x00, 0x34, 0x44,
+  0x00, 0x00, 0x34, 0x5c, 0x00, 0x00, 0x34, 0x74, 0x00, 0x00, 0x34, 0x90,
+  0x00, 0x00, 0x34, 0xb0, 0x00, 0x00, 0x34, 0xcc, 0x00, 0x00, 0x34, 0xe8,
+  0x00, 0x00, 0x35, 0x04, 0x00, 0x00, 0x35, 0x20, 0x00, 0x00, 0x35, 0x38,
+  0x00, 0x00, 0x35, 0x50, 0x00, 0x00, 0x35, 0x84, 0x00, 0x00, 0x35, 0x9c,
+  0x00, 0x00, 0x35, 0xb8, 0x00, 0x00, 0x35, 0xd0, 0x00, 0x00, 0x35, 0xec,
+  0x00, 0x00, 0x36, 0x04, 0x00, 0x00, 0x36, 0x20, 0x00, 0x00, 0x36, 0x38,
+  0x00, 0x00, 0x36, 0x54, 0x00, 0x00, 0x36, 0x90, 0x00, 0x00, 0x36, 0xc4,
+  0x00, 0x00, 0x36, 0xe0, 0x00, 0x00, 0x36, 0xf8, 0x00, 0x00, 0x37, 0x10,
+  0x00, 0x00, 0x37, 0x28, 0x00, 0x00, 0x37, 0x44, 0x00, 0x00, 0x37, 0x5c,
+  0x00, 0x00, 0x37, 0x74, 0x00, 0x00, 0x37, 0xd0, 0x00, 0x00, 0x38, 0x30,
+  0x00, 0x00, 0x38, 0x4c, 0x00, 0x00, 0x38, 0x64, 0x00, 0x00, 0x38, 0x80,
+  0x00, 0x00, 0x38, 0x98, 0x00, 0x00, 0x38, 0xb0, 0x00, 0x00, 0x38, 0xc8,
+  0x00, 0x00, 0x39, 0x2c, 0x00, 0x00, 0x39, 0xcc, 0x00, 0x00, 0x39, 0xe4,
+  0x00, 0x00, 0x39, 0xfc, 0x00, 0x00, 0x3a, 0x14, 0x00, 0x00, 0x3a, 0x2c,
+  0x00, 0x00, 0x3a, 0x48, 0x00, 0x00, 0x3a, 0x60, 0x00, 0x00, 0x3a, 0x78,
+  0x00, 0x00, 0x3a, 0x90, 0x00, 0x00, 0x3a, 0xac, 0x00, 0x00, 0x3a, 0xc4,
+  0x00, 0x00, 0x3a, 0xdc, 0x00, 0x00, 0x3a, 0xf4, 0x00, 0x00, 0x3b, 0x10,
+  0x00, 0x00, 0x3b, 0x2c, 0x00, 0x00, 0x3b, 0x44, 0x00, 0x00, 0x3b, 0x5c,
+  0x00, 0x00, 0x3b, 0x78, 0x00, 0x00, 0x3b, 0x94, 0x00, 0x00, 0x3b, 0xcc,
+  0x00, 0x00, 0x3c, 0x24, 0x00, 0x00, 0x3c, 0x40, 0x00, 0x00, 0x3c, 0x58,
+  0x00, 0x00, 0x3c, 0x74, 0x00, 0x00, 0x3c, 0x8c, 0x00, 0x00, 0x3c, 0xa8,
+  0x00, 0x00, 0x3c, 0xc0, 0x00, 0x00, 0x3c, 0xd8, 0x00, 0x00, 0x3c, 0xf0,
+  0x00, 0x00, 0x3d, 0x08, 0x00, 0x00, 0x3d, 0x20, 0x00, 0x00, 0x3d, 0x38,
+  0x00, 0x00, 0x3d, 0x50, 0x00, 0x00, 0x3d, 0x6c, 0x00, 0x00, 0x3d, 0x88,
+  0x00, 0x00, 0x3d, 0xa4, 0x00, 0x00, 0x3d, 0xbc, 0x00, 0x00, 0x3d, 0xd8,
+  0x00, 0x00, 0x3d, 0xf0, 0x00, 0x00, 0x3e, 0x08, 0x00, 0x00, 0x3e, 0x20,
+  0x00, 0x00, 0x3e, 0x3c, 0x00, 0x00, 0x3e, 0x54, 0x00, 0x00, 0x3e, 0x6c,
+  0x00, 0x00, 0x3e, 0xa4, 0x00, 0x00, 0x3f, 0x2c, 0x00, 0x00, 0x3f, 0xb0,
+  0x00, 0x00, 0x3f, 0xc0, 0x00, 0x00, 0x40, 0x3c, 0x00, 0x00, 0x40, 0x94,
+  0x00, 0x00, 0x40, 0xfc, 0x00, 0x00, 0x41, 0x58, 0x00, 0x00, 0x41, 0xd0,
+  0x00, 0x00, 0x42, 0x3c, 0x00, 0x00, 0x42, 0x4c, 0x00, 0x00, 0x42, 0xb4,
+  0x00, 0x00, 0x43, 0x00, 0x00, 0x00, 0x43, 0x64, 0x00, 0x00, 0x43, 0xe4,
+  0x00, 0x00, 0x44, 0x18, 0x00, 0x00, 0x44, 0x80, 0x00, 0x00, 0x44, 0xf8,
+  0x00, 0x00, 0x45, 0x38, 0x00, 0x00, 0x45, 0x8c, 0x00, 0x00, 0x46, 0x08,
+  0x00, 0x00, 0x46, 0x88, 0x00, 0x00, 0x47, 0x08, 0x00, 0x00, 0x47, 0x34,
+  0x00, 0x00, 0x47, 0x60, 0x00, 0x00, 0x47, 0xb8, 0x00, 0x00, 0x48, 0x00,
+  0x00, 0x00, 0x48, 0x2c, 0x00, 0x00, 0x48, 0x74, 0x00, 0x00, 0x48, 0xec,
+  0x00, 0x00, 0x49, 0x2c, 0x00, 0x00, 0x49, 0x3c, 0x00, 0x00, 0x49, 0xac,
+  0x00, 0x00, 0x49, 0xc4, 0x00, 0x00, 0x49, 0xdc, 0x00, 0x00, 0x4a, 0x50,
+  0x00, 0x00, 0x4a, 0xc0, 0x00, 0x00, 0x4b, 0x1c, 0x00, 0x00, 0x4b, 0x8c,
+  0x00, 0x00, 0x4b, 0xf0, 0x00, 0x00, 0x4c, 0x5c, 0x00, 0x00, 0x4c, 0xd4,
+  0x00, 0x00, 0x4c, 0xe4, 0x00, 0x00, 0x4d, 0x48, 0x00, 0x00, 0x4d, 0xa0,
+  0x00, 0x00, 0x4d, 0xd8, 0x00, 0x00, 0x4e, 0x2c, 0x00, 0x00, 0x4e, 0x64,
+  0x00, 0x00, 0x4e, 0x7c, 0x00, 0x00, 0x4e, 0x94, 0x00, 0x00, 0x4f, 0x04,
+  0x00, 0x00, 0x4f, 0x64, 0x00, 0x00, 0x4f, 0xbc, 0x00, 0x00, 0x50, 0x24,
+  0x00, 0x00, 0x50, 0x6c, 0x00, 0x00, 0x50, 0xb0, 0x00, 0x00, 0x51, 0x20,
+  0x00, 0x00, 0x51, 0x90, 0x00, 0x00, 0x51, 0xfc, 0x00, 0x00, 0x52, 0x68,
+  0x00, 0x00, 0x52, 0xdc, 0x00, 0x00, 0x53, 0x38, 0x00, 0x00, 0x53, 0x90,
+  0x00, 0x00, 0x54, 0x00, 0x00, 0x00, 0x54, 0x54, 0x00, 0x00, 0x54, 0x70,
+  0x00, 0x00, 0x54, 0x88, 0x00, 0x00, 0x54, 0xcc, 0x00, 0x00, 0x54, 0xdc,
+  0x00, 0x00, 0x54, 0xf4, 0x00, 0x00, 0x55, 0x0c, 0x00, 0x00, 0x55, 0x24,
+  0x00, 0x00, 0x55, 0x3c, 0x00, 0x00, 0x55, 0x54, 0x00, 0x00, 0x55, 0x6c,
+  0x00, 0x00, 0x55, 0x84, 0x00, 0x00, 0x55, 0x9c, 0x00, 0x00, 0x55, 0xb4,
+  0x00, 0x00, 0x55, 0xd0, 0x00, 0x00, 0x55, 0xe8, 0x00, 0x00, 0x56, 0x04,
+  0x00, 0x00, 0x56, 0x20, 0x00, 0x00, 0x56, 0x38, 0x00, 0x00, 0x56, 0x50,
+  0x00, 0x00, 0x56, 0x6c, 0x00, 0x00, 0x56, 0x84, 0x00, 0x00, 0x56, 0x9c,
+  0x00, 0x00, 0x56, 0xb4, 0x00, 0x00, 0x56, 0xcc, 0x00, 0x00, 0x56, 0xe4,
+  0x00, 0x00, 0x56, 0xfc, 0x00, 0x00, 0x57, 0x14, 0x00, 0x00, 0x57, 0x2c,
+  0x00, 0x00, 0x57, 0x44, 0x00, 0x00, 0x57, 0x54, 0x00, 0x00, 0x57, 0x6c,
+  0x00, 0x00, 0x57, 0x84, 0x00, 0x00, 0x57, 0x9c, 0x00, 0x00, 0x57, 0xb4,
+  0x00, 0x00, 0x57, 0xcc, 0x00, 0x00, 0x57, 0xe4, 0x00, 0x00, 0x58, 0x5c,
+  0x00, 0x00, 0x58, 0xf8, 0x00, 0x00, 0x59, 0x14, 0x00, 0x00, 0x59, 0x2c,
+  0x00, 0x00, 0x59, 0x44, 0x00, 0x00, 0x59, 0x60, 0x00, 0x00, 0x59, 0x78,
+  0x00, 0x00, 0x59, 0x90, 0x00, 0x00, 0x59, 0xa8, 0x00, 0x00, 0x59, 0xc0,
+  0x00, 0x00, 0x59, 0xd8, 0x00, 0x00, 0x59, 0xf0, 0x00, 0x00, 0x5a, 0x0c,
+  0x00, 0x00, 0x5a, 0x24, 0x00, 0x00, 0x5a, 0x3c, 0x00, 0x00, 0x5a, 0x54,
+  0x00, 0x00, 0x5a, 0x6c, 0x00, 0x00, 0x5a, 0x84, 0x00, 0x00, 0x5a, 0xe4,
+  0x00, 0x00, 0x5b, 0x3c, 0x00, 0x00, 0x5b, 0x54, 0x00, 0x00, 0x5b, 0x6c,
+  0x00, 0x00, 0x5b, 0x84, 0x00, 0x00, 0x5b, 0x9c, 0x00, 0x00, 0x5b, 0xb4,
+  0x00, 0x00, 0x5b, 0xcc, 0x00, 0x00, 0x5b, 0xe4, 0x00, 0x00, 0x5b, 0xfc,
+  0x00, 0x00, 0x5c, 0x14, 0x00, 0x00, 0x5c, 0x2c, 0x00, 0x00, 0x5c, 0x44,
+  0x00, 0x00, 0x5c, 0x5c, 0x00, 0x00, 0x5c, 0x74, 0x00, 0x00, 0x5c, 0x8c,
+  0x00, 0x00, 0x5c, 0xa4, 0x00, 0x00, 0x5c, 0xbc, 0x00, 0x00, 0x5c, 0xd4,
+  0x00, 0x00, 0x5c, 0xec, 0x00, 0x00, 0x5d, 0x04, 0x00, 0x00, 0x5d, 0x1c,
+  0x00, 0x00, 0x5d, 0x34, 0x00, 0x00, 0x5d, 0x4c, 0x00, 0x00, 0x5d, 0x64,
+  0x00, 0x00, 0x5d, 0x7c, 0x00, 0x00, 0x5d, 0x94, 0x00, 0x00, 0x5d, 0xac,
+  0x00, 0x00, 0x5d, 0xc4, 0x00, 0x00, 0x5d, 0xdc, 0x00, 0x00, 0x5d, 0xf4,
+  0x00, 0x00, 0x5e, 0x0c, 0x00, 0x00, 0x5e, 0x24, 0x00, 0x00, 0x5e, 0x3c,
+  0x00, 0x00, 0x5e, 0x54, 0x00, 0x00, 0x5e, 0x6c, 0x00, 0x00, 0x5e, 0x84,
+  0x00, 0x00, 0x5e, 0x9c, 0x00, 0x00, 0x5f, 0x24, 0x00, 0x00, 0x5f, 0xb4,
+  0x00, 0x00, 0x5f, 0xcc, 0x00, 0x00, 0x5f, 0xe8, 0x00, 0x00, 0x60, 0x2c,
+  0x00, 0x00, 0x60, 0xd0, 0x00, 0x00, 0x61, 0x84, 0x00, 0x00, 0x62, 0x28,
+  0x00, 0x00, 0x62, 0x74, 0x00, 0x00, 0x62, 0xc0, 0x00, 0x00, 0x62, 0xd8,
+  0x00, 0x00, 0x62, 0xf0, 0x00, 0x00, 0x63, 0x08, 0x00, 0x00, 0x63, 0x20,
+  0x00, 0x00, 0x63, 0x38, 0x00, 0x00, 0x63, 0x50, 0x00, 0x00, 0x63, 0x68,
+  0x00, 0x00, 0x63, 0x80, 0x00, 0x00, 0x63, 0x98, 0x00, 0x00, 0x63, 0xb0,
+  0x00, 0x00, 0x63, 0xc8, 0x00, 0x00, 0x63, 0xe0, 0x00, 0x00, 0x63, 0xf8,
+  0x00, 0x00, 0x64, 0x10, 0x00, 0x00, 0x64, 0x64, 0x00, 0x00, 0x64, 0xe8,
+  0x00, 0x00, 0x65, 0x50, 0x00, 0x00, 0x65, 0x7c, 0x00, 0x00, 0x66, 0x1c,
+  0x00, 0x00, 0x66, 0xbc, 0x00, 0x00, 0x67, 0x28, 0x00, 0x00, 0x67, 0xbc,
+  0x00, 0x00, 0x68, 0x48, 0x00, 0x00, 0x68, 0x7c, 0x00, 0x00, 0x68, 0xd0,
+  0x00, 0x00, 0x69, 0x88, 0x00, 0x00, 0x69, 0xe0, 0x00, 0x00, 0x6a, 0x2c,
+  0x00, 0x00, 0x6a, 0x7c, 0x00, 0x00, 0x6a, 0xfc, 0x00, 0x00, 0x6b, 0x5c,
+  0x00, 0x00, 0x6b, 0x6c, 0x00, 0x00, 0x6b, 0xd4, 0x00, 0x00, 0x6c, 0x80,
+  0x00, 0x00, 0x6c, 0xc0, 0x00, 0x00, 0x6d, 0x08, 0x00, 0x00, 0x6d, 0x84,
+  0x00, 0x00, 0x6d, 0xf8, 0x00, 0x00, 0x6e, 0x64, 0x00, 0x00, 0x6e, 0xb4,
+  0x00, 0x00, 0x6f, 0x00, 0x00, 0x00, 0x6f, 0x60, 0x00, 0x00, 0x6f, 0xd0,
+  0x00, 0x00, 0x70, 0x30, 0x00, 0x00, 0x70, 0x90, 0x00, 0x00, 0x71, 0x04,
+  0x00, 0x00, 0x71, 0x5c, 0x00, 0x00, 0x71, 0xec, 0x00, 0x00, 0x72, 0x60,
+  0x00, 0x00, 0x72, 0xd0, 0x00, 0x00, 0x73, 0x44, 0x00, 0x00, 0x73, 0xa4,
+  0x00, 0x00, 0x74, 0x4c, 0x00, 0x00, 0x74, 0x5c, 0x00, 0x00, 0x74, 0x6c,
+  0x00, 0x00, 0x75, 0x1c, 0x00, 0x00, 0x75, 0xac, 0x00, 0x00, 0x75, 0xec,
+  0x00, 0x00, 0x76, 0x7c, 0x00, 0x00, 0x76, 0xf0, 0x00, 0x00, 0x77, 0x50,
+  0x00, 0x00, 0x77, 0xcc, 0x00, 0x00, 0x78, 0x48, 0x00, 0x00, 0x78, 0x8c,
+  0x00, 0x00, 0x78, 0xe0, 0x00, 0x00, 0x79, 0x44, 0x00, 0x00, 0x79, 0x7c,
+  0x00, 0x00, 0x79, 0x8c, 0x00, 0x00, 0x79, 0xb8, 0x00, 0x00, 0x7a, 0x28,
+  0x00, 0x00, 0x7a, 0x78, 0x00, 0x00, 0x7a, 0xa8, 0x00, 0x00, 0x7b, 0x1c,
+  0x00, 0x00, 0x7b, 0x90, 0x00, 0x00, 0x7c, 0x04, 0x00, 0x00, 0x7c, 0x90,
+  0x00, 0x00, 0x7c, 0xe4, 0x00, 0x00, 0x7d, 0x40, 0x00, 0x00, 0x7d, 0x70,
+  0x00, 0x00, 0x7d, 0xd4, 0x00, 0x00, 0x7e, 0x38, 0x00, 0x00, 0x7e, 0xb8,
+  0x00, 0x00, 0x7e, 0xc8, 0x00, 0x00, 0x7f, 0x00, 0x00, 0x00, 0x7f, 0x38,
+  0x00, 0x00, 0x7f, 0x80, 0x00, 0x00, 0x7f, 0xc0, 0x00, 0x00, 0x80, 0x10,
+  0x00, 0x00, 0x80, 0x48, 0x00, 0x00, 0x80, 0x80, 0x00, 0x00, 0x80, 0xe4,
+  0x00, 0x00, 0x81, 0x44, 0x00, 0x00, 0x81, 0xd0, 0x00, 0x00, 0x82, 0x10,
+  0x00, 0x00, 0x82, 0x6c, 0x00, 0x00, 0x82, 0xac, 0x00, 0x00, 0x83, 0x0c,
+  0x00, 0x00, 0x83, 0x50, 0x00, 0x00, 0x83, 0x94, 0x00, 0x00, 0x83, 0xf4,
+  0x00, 0x00, 0x84, 0x58, 0x00, 0x00, 0x84, 0xbc, 0x00, 0x00, 0x84, 0xe4,
+  0x00, 0x00, 0x85, 0x1c, 0x00, 0x00, 0x85, 0x64, 0x00, 0x00, 0x85, 0x94,
+  0x00, 0x00, 0x85, 0xd8, 0x00, 0x00, 0x86, 0x48, 0x00, 0x00, 0x86, 0xb0,
+  0x00, 0x00, 0x87, 0x40, 0x00, 0x00, 0x87, 0x9c, 0x00, 0x00, 0x87, 0xfc,
+  0x00, 0x00, 0x88, 0x5c, 0x00, 0x00, 0x88, 0xcc, 0x00, 0x00, 0x89, 0x54,
+  0x00, 0x00, 0x89, 0x64, 0x00, 0x00, 0x89, 0xf8, 0x00, 0x00, 0x8a, 0x70,
+  0x00, 0x00, 0x8a, 0x80, 0x00, 0x00, 0x8a, 0xd4, 0x00, 0x00, 0x8b, 0x0c,
+  0x00, 0x00, 0x8b, 0x2c, 0x00, 0x00, 0x8b, 0xa0, 0x00, 0x00, 0x8c, 0x10,
+  0x00, 0x00, 0x8c, 0x80, 0x00, 0x00, 0x8d, 0x10, 0x00, 0x00, 0x8d, 0xd8,
+  0x00, 0x00, 0x8e, 0x94, 0x00, 0x00, 0x8f, 0x38, 0x00, 0x00, 0x8f, 0xc4,
+  0x00, 0x00, 0x90, 0x94, 0x00, 0x00, 0x91, 0x28, 0x00, 0x00, 0x91, 0xa0,
+  0x00, 0x00, 0x91, 0xdc, 0x00, 0x00, 0x92, 0x40, 0x00, 0x00, 0x92, 0x80,
+  0x00, 0x00, 0x92, 0xd0, 0x00, 0x00, 0x93, 0x34, 0x00, 0x00, 0x93, 0x78,
+  0x00, 0x00, 0x93, 0xcc, 0x00, 0x00, 0x94, 0x08, 0x00, 0x00, 0x94, 0x48,
+  0x00, 0x00, 0x94, 0x88, 0x00, 0x00, 0x94, 0xdc, 0x00, 0x00, 0x95, 0x48,
+  0x00, 0x00, 0x95, 0x80, 0x00, 0x00, 0x95, 0xc4, 0x00, 0x00, 0x95, 0xd4,
+  0x00, 0x00, 0x95, 0xec, 0x00, 0x00, 0x95, 0xfc, 0x00, 0x00, 0x96, 0x0c,
+  0x00, 0x00, 0x96, 0x30, 0x00, 0x00, 0x96, 0x64, 0x00, 0x00, 0x96, 0x9c,
+  0x00, 0x00, 0x96, 0xf8, 0x00, 0x00, 0x97, 0x58, 0x00, 0x00, 0x97, 0x80,
+  0x00, 0x00, 0x97, 0xa8, 0x00, 0x00, 0x97, 0xd0, 0x00, 0x00, 0x97, 0xf8,
+  0x00, 0x00, 0x98, 0x1c, 0x00, 0x00, 0x98, 0x44, 0x00, 0x00, 0x98, 0x60,
+  0x00, 0x00, 0x98, 0x70, 0x00, 0x00, 0x98, 0x8c, 0x00, 0x00, 0x98, 0xac,
+  0x00, 0x00, 0x98, 0xc8, 0x00, 0x00, 0x98, 0xdc, 0x00, 0x00, 0x98, 0xfc,
+  0x00, 0x00, 0x99, 0x18, 0x00, 0x00, 0x99, 0x40, 0x00, 0x00, 0x99, 0x5c,
+  0x00, 0x00, 0x99, 0x70, 0x00, 0x00, 0x99, 0x84, 0x00, 0x00, 0x99, 0xa8,
+  0x00, 0x00, 0x99, 0xcc, 0x00, 0x00, 0x99, 0xf8, 0x00, 0x00, 0x9a, 0x14,
+  0x00, 0x00, 0x9a, 0x48, 0x00, 0x00, 0x9a, 0x64, 0x00, 0x00, 0x9a, 0xb0,
+  0x00, 0x00, 0x9a, 0xf0, 0x00, 0x00, 0x9b, 0x4c, 0x00, 0x00, 0x9b, 0x78,
+  0x00, 0x00, 0x9b, 0xb0, 0x00, 0x00, 0x9b, 0xe4, 0x00, 0x00, 0x9c, 0x30,
+  0x00, 0x00, 0x9c, 0x4c, 0x00, 0x00, 0x9c, 0xe4, 0x00, 0x00, 0x9d, 0x1c,
+  0x00, 0x00, 0x9d, 0x2c, 0x00, 0x00, 0x9d, 0x4c, 0x00, 0x00, 0x9d, 0x70,
+  0x00, 0x00, 0x9d, 0x94, 0x00, 0x00, 0x9d, 0xb8, 0x00, 0x00, 0x9d, 0xd8,
+  0x00, 0x00, 0x9d, 0xec, 0x00, 0x00, 0x9e, 0x04, 0x00, 0x00, 0x9e, 0x14,
+  0x00, 0x00, 0x9e, 0x28, 0x00, 0x00, 0x9e, 0x94, 0x00, 0x00, 0x9e, 0xbc,
+  0x00, 0x00, 0x9e, 0xe0, 0x00, 0x00, 0x9f, 0x0c, 0x00, 0x00, 0x9f, 0x20,
+  0x00, 0x00, 0x9f, 0x34, 0x00, 0x00, 0x9f, 0x48, 0x00, 0x00, 0x9f, 0x5c,
+  0x00, 0x00, 0x9f, 0x7c, 0x00, 0x00, 0x9f, 0xa8, 0x00, 0x00, 0x9f, 0xfc,
+  0x00, 0x00, 0xa0, 0x10, 0x00, 0x00, 0xa0, 0x24, 0x00, 0x00, 0xa0, 0x50,
+  0x00, 0x00, 0xa0, 0x6c, 0x00, 0x00, 0xa0, 0x88, 0x00, 0x00, 0xa0, 0xb4,
+  0x00, 0x00, 0xa0, 0xd0, 0x00, 0x00, 0xa1, 0x04, 0x00, 0x00, 0xa1, 0x20,
+  0x00, 0x00, 0xa1, 0x48, 0x00, 0x00, 0xa1, 0x6c, 0x00, 0x00, 0xa1, 0x88,
+  0x00, 0x00, 0xa1, 0x9c, 0x00, 0x00, 0xa1, 0xb0, 0x00, 0x00, 0xa1, 0xd4,
+  0x00, 0x00, 0xa1, 0xf4, 0x00, 0x00, 0xa2, 0x14, 0x00, 0x00, 0xa2, 0x58,
+  0x00, 0x00, 0xa2, 0x8c, 0x00, 0x00, 0xa2, 0xb0, 0x00, 0x00, 0xa2, 0xd4,
+  0x00, 0x00, 0xa3, 0x00, 0x00, 0x00, 0xa3, 0x1c, 0x00, 0x00, 0xa3, 0x4c,
+  0x00, 0x00, 0xa3, 0x7c, 0x00, 0x00, 0xa3, 0x94, 0x00, 0x00, 0xa3, 0xa8,
+  0x00, 0x00, 0xa3, 0xf4, 0x00, 0x00, 0xa4, 0x10, 0x00, 0x00, 0xa4, 0x24,
+  0x00, 0x00, 0xa4, 0x38, 0x00, 0x00, 0xa4, 0x54, 0x00, 0x00, 0xa4, 0x78,
+  0x00, 0x00, 0xa4, 0xc0, 0x00, 0x00, 0xa4, 0xd4, 0x00, 0x00, 0xa4, 0xe8,
+  0x00, 0x00, 0xa4, 0xfc, 0x00, 0x00, 0xa5, 0x30, 0x00, 0x00, 0xa5, 0x44,
+  0x00, 0x00, 0xa5, 0x58, 0x00, 0x00, 0xa5, 0x6c, 0x00, 0x00, 0xa5, 0x80,
+  0x00, 0x00, 0xa5, 0xdc, 0x00, 0x00, 0xa5, 0xf8, 0x00, 0x00, 0xa6, 0x14,
+  0x00, 0x00, 0xa6, 0x34, 0x00, 0x00, 0xa6, 0x54, 0x00, 0x00, 0xa6, 0x84,
+  0x00, 0x00, 0xa6, 0xa8, 0x00, 0x00, 0xa6, 0xd0, 0x00, 0x00, 0xa7, 0x18,
+  0x00, 0x00, 0xa7, 0x4c, 0x00, 0x00, 0xa7, 0xac, 0x00, 0x00, 0xa7, 0xc8,
+  0x00, 0x00, 0xa7, 0xdc, 0x00, 0x00, 0xa7, 0xf0, 0x00, 0x00, 0xa8, 0x04,
+  0x00, 0x00, 0xa8, 0x14, 0x00, 0x00, 0xa8, 0x28, 0x00, 0x00, 0xa8, 0x3c,
+  0x00, 0x00, 0xa8, 0x60, 0x00, 0x00, 0xa8, 0x88, 0x00, 0x00, 0xa8, 0xb0,
+  0x00, 0x00, 0xa8, 0xd0, 0x00, 0x00, 0xa9, 0x4c, 0x00, 0x00, 0xa9, 0xc0,
+  0x00, 0x00, 0xa9, 0xd8, 0x00, 0x00, 0xaa, 0x10, 0x00, 0x00, 0xaa, 0x38,
+  0x00, 0x00, 0xaa, 0x38, 0x00, 0x00, 0xaa, 0x78, 0x00, 0x00, 0xaa, 0x90,
+  0x00, 0x00, 0xaa, 0xa4, 0x00, 0x00, 0xaa, 0xe4, 0x00, 0x00, 0xaa, 0xf8,
+  0x00, 0x00, 0xab, 0x5c, 0x00, 0x00, 0xab, 0x70, 0x00, 0x00, 0xab, 0x84,
+  0x00, 0x00, 0xab, 0xa0, 0x00, 0x00, 0xab, 0xbc, 0x00, 0x00, 0xac, 0x30,
+  0x00, 0x00, 0xac, 0x44, 0x00, 0x00, 0xac, 0x6c, 0x00, 0x00, 0xac, 0x7c,
+  0x00, 0x00, 0xac, 0x8c, 0x00, 0x00, 0xac, 0xbc, 0x00, 0x00, 0xac, 0xec,
+  0x00, 0x00, 0xad, 0x08, 0x00, 0x00, 0xad, 0x24, 0x00, 0x00, 0xad, 0x34,
+  0x00, 0x00, 0xad, 0x44, 0x00, 0x00, 0xad, 0x78, 0x00, 0x00, 0xad, 0x88,
+  0x00, 0x00, 0xad, 0xa0, 0x00, 0x00, 0xad, 0xb8, 0x00, 0x00, 0xad, 0xc8,
+  0x00, 0x00, 0xad, 0xe4, 0x00, 0x00, 0xae, 0x00, 0x00, 0x00, 0xae, 0x18,
+  0x00, 0x00, 0xae, 0x28, 0x00, 0x00, 0xae, 0x44, 0x00, 0x00, 0xae, 0x60,
+  0x00, 0x00, 0xae, 0x7c, 0x00, 0x00, 0xae, 0x94, 0x00, 0x00, 0xae, 0xb0,
+  0x00, 0x00, 0xae, 0xc8, 0x00, 0x00, 0xae, 0xe0, 0x00, 0x00, 0xae, 0xf0,
+  0x00, 0x00, 0xaf, 0x00, 0x00, 0x00, 0xaf, 0x20, 0x00, 0x00, 0xaf, 0x50,
+  0x00, 0x00, 0xaf, 0x60, 0x00, 0x00, 0xaf, 0x70, 0x00, 0x00, 0xaf, 0x80,
+  0x00, 0x00, 0xaf, 0xfc, 0x00, 0x00, 0xb0, 0x0c, 0x00, 0x00, 0xb0, 0x1c,
+  0x00, 0x00, 0xb0, 0x44, 0x00, 0x00, 0xb0, 0x54, 0x00, 0x00, 0xb0, 0x64,
+  0x00, 0x00, 0xb0, 0x9c, 0x00, 0x00, 0xb0, 0xac, 0x00, 0x00, 0xb0, 0xbc,
+  0x00, 0x00, 0xb0, 0xcc, 0x00, 0x00, 0xb1, 0x04, 0x00, 0x00, 0xb1, 0x14,
+  0x00, 0x00, 0xb1, 0x24, 0x00, 0x00, 0xb1, 0xa8, 0x00, 0x00, 0xb1, 0xb8,
+  0x00, 0x00, 0xb2, 0x20, 0x00, 0x00, 0xb2, 0x9c, 0x00, 0x00, 0xb2, 0xb8,
+  0x00, 0x00, 0xb2, 0xd4, 0x00, 0x00, 0xb2, 0xec, 0x00, 0x00, 0xb3, 0x04,
+  0x00, 0x00, 0xb3, 0x1c, 0x00, 0x00, 0xb3, 0x34, 0x00, 0x00, 0xb3, 0x4c,
+  0x00, 0x00, 0xb3, 0xd4, 0x00, 0x00, 0xb4, 0x38, 0x00, 0x00, 0xb4, 0x78,
+  0x00, 0x00, 0xb5, 0x08, 0x00, 0x00, 0xb5, 0x9c, 0x00, 0x00, 0xb6, 0x00,
+  0x00, 0x00, 0xb6, 0x48, 0x00, 0x00, 0xb6, 0xc4, 0x00, 0x00, 0xb6, 0xf8,
+  0x00, 0x00, 0xb7, 0x30, 0x00, 0x00, 0xb7, 0x70, 0x00, 0x00, 0xb7, 0x80,
+  0x00, 0x00, 0xb7, 0xd0, 0x00, 0x00, 0xb8, 0x4c, 0x00, 0x00, 0xb8, 0x5c,
+  0x00, 0x00, 0xb8, 0xa8, 0x00, 0x00, 0xb9, 0x0c, 0x00, 0x00, 0xb9, 0x80,
+  0x00, 0x00, 0xb9, 0xe4, 0x00, 0x00, 0xba, 0x20, 0x00, 0x00, 0xba, 0x80,
+  0x00, 0x00, 0xbb, 0x04, 0x00, 0x00, 0xbb, 0x60, 0x00, 0x00, 0xbb, 0xbc,
+  0x00, 0x00, 0xbc, 0x18, 0x00, 0x00, 0xbc, 0x30, 0x00, 0x00, 0xbc, 0x48,
+  0x00, 0x00, 0xbc, 0x60, 0x00, 0x00, 0xbc, 0x78, 0x00, 0x00, 0xbc, 0x90,
+  0x00, 0x00, 0xbc, 0xcc, 0x00, 0x00, 0xbd, 0x54, 0x00, 0x00, 0xbd, 0xc4,
+  0x00, 0x00, 0xbe, 0x34, 0x00, 0x00, 0xbe, 0x50, 0x00, 0x00, 0xbe, 0x68,
+  0x00, 0x00, 0xbe, 0xf0, 0x00, 0x00, 0xbf, 0x58, 0x00, 0x00, 0xc0, 0x04,
+  0x00, 0x00, 0xc0, 0x78, 0x00, 0x00, 0xc0, 0xe4, 0x00, 0x00, 0xc1, 0x58,
+  0x00, 0x00, 0xc1, 0xc0, 0x00, 0x00, 0xc1, 0xd0, 0x00, 0x00, 0xc2, 0x48,
+  0x00, 0x00, 0xc2, 0xa4, 0x00, 0x00, 0xc2, 0xd0, 0x00, 0x00, 0xc3, 0x44,
+  0x00, 0x00, 0xc3, 0xa0, 0x00, 0x00, 0xc4, 0x60, 0x00, 0x00, 0xc4, 0xe0,
+  0x00, 0x00, 0xc5, 0x48, 0x00, 0x00, 0xc5, 0xa8, 0x00, 0x00, 0xc6, 0x24,
+  0x00, 0x00, 0xc7, 0x0c, 0x00, 0x00, 0xc7, 0x80, 0x00, 0x00, 0xc7, 0xec,
+  0x00, 0x00, 0xc8, 0x9c, 0x00, 0x00, 0xc9, 0x4c, 0x00, 0x00, 0xc9, 0xe0,
+  0x00, 0x00, 0xca, 0x78, 0x00, 0x00, 0xca, 0xb0, 0x00, 0x00, 0xca, 0xe8,
+  0x00, 0x00, 0xcb, 0x84, 0x00, 0x00, 0xcc, 0x00, 0x00, 0x00, 0xcc, 0x10,
+  0x00, 0x00, 0xcc, 0x20, 0x00, 0x00, 0xcc, 0x30, 0x00, 0x00, 0xcc, 0x9c,
+  0x00, 0x00, 0xcd, 0x08, 0x00, 0x00, 0xcd, 0x18, 0x00, 0x00, 0xcd, 0x28,
+  0x00, 0x00, 0xcd, 0x38, 0x00, 0x00, 0xcd, 0x74, 0x00, 0x00, 0xcd, 0xac,
+  0x00, 0x00, 0xce, 0x2c, 0x00, 0x00, 0xce, 0x3c, 0x00, 0x00, 0xce, 0x54,
+  0x00, 0x00, 0xce, 0x6c, 0x00, 0x00, 0xce, 0x84, 0x00, 0x00, 0xce, 0xa0,
+  0x00, 0x00, 0xce, 0xf8, 0x00, 0x00, 0xcf, 0x10, 0x00, 0x00, 0xcf, 0x68,
+  0x00, 0x00, 0xcf, 0x78, 0x00, 0x00, 0xcf, 0x88, 0x00, 0x00, 0xcf, 0x98,
+  0x00, 0x00, 0xcf, 0xa8, 0x00, 0x00, 0xd0, 0x0c, 0x00, 0x00, 0xd0, 0x68,
+  0x00, 0x00, 0xd0, 0xac, 0x00, 0x00, 0xd0, 0xc4, 0x00, 0x00, 0xd0, 0xdc,
+  0x00, 0x00, 0xd0, 0xf4, 0x00, 0x00, 0xd1, 0x24, 0x00, 0x00, 0xd1, 0x34,
+  0x00, 0x00, 0xd1, 0x84, 0x00, 0x00, 0xd1, 0x94, 0x00, 0x00, 0xd1, 0xb4,
+  0x00, 0x00, 0xd2, 0x0c, 0x00, 0x00, 0xd2, 0x1c, 0x00, 0x00, 0xd2, 0x74,
+  0x00, 0x00, 0xd2, 0xec, 0x00, 0x00, 0xd3, 0x1c, 0x00, 0x00, 0xd3, 0x38,
+  0x00, 0x00, 0xd3, 0x70, 0x00, 0x00, 0xd3, 0xac, 0x00, 0x00, 0xd3, 0xbc,
+  0x00, 0x00, 0xd3, 0xcc, 0x00, 0x00, 0xd3, 0xdc, 0x00, 0x00, 0xd4, 0x04,
+  0x00, 0x00, 0xd4, 0x14, 0x00, 0x00, 0xd4, 0x24, 0x00, 0x00, 0xd4, 0x34,
+  0x00, 0x00, 0xd4, 0x78, 0x00, 0x00, 0xd4, 0xf0, 0x00, 0x00, 0xd5, 0x00,
+  0x00, 0x00, 0xd5, 0x30, 0x00, 0x00, 0xd5, 0x68, 0x00, 0x00, 0xd5, 0x98,
+  0x00, 0x00, 0xd5, 0xd4, 0x00, 0x00, 0xd6, 0x28, 0x00, 0x00, 0xd6, 0x40,
+  0x00, 0x00, 0xd6, 0x90, 0x00, 0x00, 0xd6, 0xe8, 0x00, 0x00, 0xd7, 0x70,
+  0x00, 0x00, 0xd7, 0xc4, 0x00, 0x00, 0xd7, 0xd4, 0x00, 0x00, 0xd8, 0x60,
+  0x00, 0x00, 0xd8, 0xcc, 0x00, 0x00, 0xd8, 0xec, 0x00, 0x00, 0xd9, 0x40,
+  0x00, 0x00, 0xd9, 0x50, 0x00, 0x00, 0xd9, 0xa8, 0x00, 0x00, 0xda, 0x1c,
+  0x00, 0x00, 0xda, 0x4c, 0x00, 0x00, 0xda, 0x68, 0x00, 0x00, 0xda, 0xa0,
+  0x00, 0x00, 0xda, 0xdc, 0x00, 0x00, 0xdb, 0x18, 0x00, 0x00, 0xdb, 0x48,
+  0x00, 0x00, 0xdb, 0x58, 0x00, 0x00, 0xdb, 0x80, 0x00, 0x00, 0xdb, 0x90,
+  0x00, 0x00, 0xdb, 0xa0, 0x00, 0x00, 0xdb, 0xc8, 0x00, 0x00, 0xdb, 0xd8,
+  0x00, 0x00, 0xdc, 0x80, 0x00, 0x00, 0xdc, 0x90, 0x00, 0x00, 0xdc, 0xc0,
+  0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xdd, 0x30, 0x00, 0x00, 0xdd, 0x6c,
+  0x00, 0x00, 0xdd, 0xb8, 0x00, 0x00, 0xdd, 0xd0, 0x00, 0x00, 0xde, 0x18,
+  0x00, 0x00, 0xde, 0x6c, 0x00, 0x00, 0xde, 0xd4, 0x00, 0x00, 0xdf, 0x28,
+  0x00, 0x00, 0xdf, 0x40, 0x00, 0x00, 0xdf, 0x5c, 0x00, 0x00, 0xdf, 0xc0,
+  0x00, 0x00, 0xdf, 0xd8, 0x00, 0x00, 0xe0, 0x30, 0x00, 0x00, 0xe0, 0x40,
+  0x00, 0x00, 0xe0, 0x50, 0x00, 0x00, 0xe0, 0x60, 0x00, 0x00, 0xe0, 0x70,
+  0x00, 0x00, 0xe0, 0xd4, 0x00, 0x00, 0xe1, 0x30, 0x00, 0x00, 0xe1, 0x88,
+  0x00, 0x00, 0xe1, 0xa0, 0x00, 0x00, 0xe1, 0xb8, 0x00, 0x00, 0xe1, 0xd0,
+  0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0xe2, 0xa0, 0x00, 0x00, 0xe2, 0xb0,
+  0x00, 0x00, 0xe3, 0x10, 0x00, 0x00, 0xe3, 0x68, 0x00, 0x00, 0xe3, 0xf4,
+  0x00, 0x00, 0xe4, 0x64, 0x00, 0x00, 0xe4, 0xa4, 0x00, 0x00, 0xe4, 0xe4,
+  0x00, 0x00, 0xe5, 0x3c, 0x00, 0x00, 0xe5, 0x94, 0x00, 0x00, 0xe5, 0xfc,
+  0x00, 0x00, 0xe6, 0x64, 0x00, 0x00, 0xe6, 0xe0, 0x00, 0x00, 0xe7, 0x58,
+  0x00, 0x00, 0xe8, 0x44, 0x00, 0x00, 0xe9, 0x20, 0x00, 0x00, 0xe9, 0x84,
+  0x00, 0x00, 0xe9, 0xe8, 0x00, 0x00, 0xe9, 0xf8, 0x00, 0x00, 0xea, 0x08,
+  0x00, 0x00, 0xea, 0x54, 0x00, 0x00, 0xea, 0xa4, 0x00, 0x00, 0xea, 0xbc,
+  0x00, 0x00, 0xea, 0xd4, 0x00, 0x00, 0xeb, 0x78, 0x00, 0x00, 0xeb, 0xfc,
+  0x00, 0x00, 0xec, 0xf4, 0x00, 0x00, 0xed, 0xdc, 0x00, 0x00, 0xee, 0xb8,
+  0x00, 0x00, 0xef, 0x68, 0x00, 0x00, 0xef, 0x80, 0x00, 0x00, 0xef, 0x98,
+  0x00, 0x00, 0xef, 0xfc, 0x00, 0x00, 0xf0, 0x58, 0x00, 0x00, 0xf0, 0xa4,
+  0x00, 0x00, 0xf1, 0x3c, 0x00, 0x00, 0xf1, 0x70, 0x00, 0x00, 0xf1, 0x98,
+  0x00, 0x00, 0xf1, 0xc0, 0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0xf3, 0x44,
+  0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf4, 0x18, 0x00, 0x00, 0xf4, 0x30,
+  0x00, 0x00, 0xf4, 0x90, 0x00, 0x00, 0xf4, 0xf4, 0x00, 0x00, 0xf5, 0x54,
+  0x00, 0x00, 0xf5, 0xd8, 0x00, 0x00, 0xf5, 0xfc, 0x00, 0x00, 0xf6, 0x20,
+  0x00, 0x00, 0xf6, 0x54, 0x00, 0x00, 0xf6, 0x88, 0x00, 0x00, 0xf6, 0xe0,
+  0x00, 0x00, 0xf7, 0x3c, 0x00, 0x00, 0xf7, 0xa0, 0x00, 0x00, 0xf8, 0x00,
+  0x00, 0x00, 0xf8, 0x18, 0x00, 0x00, 0xf8, 0x30, 0x00, 0x00, 0xf8, 0x74,
+  0x00, 0x00, 0xf8, 0xb8, 0x00, 0x00, 0xf9, 0x04, 0x00, 0x00, 0xf9, 0x4c,
+  0x00, 0x00, 0xf9, 0x98, 0x00, 0x00, 0xf9, 0xe4, 0x00, 0x00, 0xfa, 0x24,
+  0x00, 0x00, 0xfa, 0x64, 0x00, 0x00, 0xfa, 0xa0, 0x00, 0x00, 0xfa, 0xdc,
+  0x00, 0x00, 0xfb, 0x14, 0x00, 0x00, 0xfb, 0x4c, 0x00, 0x00, 0xfb, 0xac,
+  0x00, 0x00, 0xfc, 0x10, 0x00, 0x00, 0xfd, 0x04, 0x00, 0x00, 0xfd, 0xe0,
+  0x00, 0x00, 0xfd, 0xf8, 0x00, 0x00, 0xfe, 0x10, 0x00, 0x00, 0xfe, 0x40,
+  0x00, 0x00, 0xfe, 0x70, 0x00, 0x00, 0xfe, 0x80, 0x00, 0x00, 0xfe, 0xb0,
+  0x00, 0x00, 0xfe, 0xf4, 0x00, 0x00, 0xff, 0x34, 0x00, 0x00, 0xff, 0x7c,
+  0x00, 0x00, 0xff, 0xc4, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x3c,
+  0x00, 0x01, 0x00, 0x84, 0x00, 0x01, 0x00, 0xcc, 0x00, 0x01, 0x01, 0x1c,
+  0x00, 0x01, 0x01, 0x68, 0x00, 0x01, 0x01, 0xa4, 0x00, 0x01, 0x01, 0xb4,
+  0x00, 0x01, 0x02, 0x44, 0x00, 0x01, 0x02, 0xd4, 0x00, 0x01, 0x03, 0x6c,
+  0x00, 0x01, 0x04, 0x04, 0x00, 0x01, 0x04, 0x14, 0x00, 0x01, 0x04, 0x2c,
+  0x00, 0x01, 0x04, 0x44, 0x00, 0x01, 0x04, 0xa0, 0x00, 0x01, 0x05, 0x00,
+  0x00, 0x01, 0x05, 0x4c, 0x00, 0x01, 0x05, 0x98, 0x00, 0x01, 0x05, 0xe0,
+  0x00, 0x01, 0x06, 0x28, 0x00, 0x01, 0x06, 0x64, 0x00, 0x01, 0x06, 0xa0,
+  0x00, 0x01, 0x06, 0xe8, 0x00, 0x01, 0x07, 0x30, 0x00, 0x01, 0x07, 0x7c,
+  0x00, 0x01, 0x07, 0xc4, 0x00, 0x01, 0x07, 0xd4, 0x00, 0x01, 0x07, 0xf0,
+  0x00, 0x01, 0x08, 0x08, 0x00, 0x01, 0x08, 0x24, 0x00, 0x01, 0x08, 0x3c,
+  0x00, 0x01, 0x08, 0x4c, 0x00, 0x01, 0x08, 0x5c, 0x00, 0x01, 0x08, 0x78,
+  0x00, 0x01, 0x08, 0x94, 0x00, 0x01, 0x08, 0xa4, 0x00, 0x01, 0x08, 0xb4,
+  0x00, 0x01, 0x08, 0xcc, 0x00, 0x01, 0x08, 0xe4, 0x00, 0x01, 0x08, 0xfc,
+  0x00, 0x01, 0x09, 0x14, 0x00, 0x01, 0x09, 0x2c, 0x00, 0x01, 0x09, 0x44,
+  0x00, 0x01, 0x09, 0x54, 0x00, 0x01, 0x09, 0x64, 0x00, 0x01, 0x09, 0x7c,
+  0x00, 0x01, 0x09, 0x94, 0x00, 0x01, 0x09, 0xac, 0x00, 0x01, 0x09, 0xc4,
+  0x00, 0x01, 0x09, 0xe0, 0x00, 0x01, 0x09, 0xf8, 0x00, 0x01, 0x0a, 0x08,
+  0x00, 0x01, 0x0a, 0x18, 0x00, 0x01, 0x0a, 0x30, 0x00, 0x01, 0x0a, 0x48,
+  0x00, 0x01, 0x0a, 0x60, 0x00, 0x01, 0x0a, 0x78, 0x00, 0x01, 0x0a, 0x90,
+  0x00, 0x01, 0x0a, 0xa8, 0x00, 0x01, 0x0a, 0xc0, 0x00, 0x01, 0x0a, 0xd8,
+  0x00, 0x01, 0x0a, 0xf0, 0x00, 0x01, 0x0b, 0x08, 0x00, 0x01, 0x0b, 0x20,
+  0x00, 0x01, 0x0b, 0x38, 0x00, 0x01, 0x0b, 0x60, 0x00, 0x01, 0x0b, 0x88,
+  0x00, 0x01, 0x0b, 0xa0, 0x00, 0x01, 0x0b, 0xb8, 0x00, 0x01, 0x0c, 0x08,
+  0x00, 0x01, 0x0c, 0x58, 0x00, 0x01, 0x0c, 0xb8, 0x00, 0x01, 0x0d, 0x18,
+  0x00, 0x01, 0x0d, 0x68, 0x00, 0x01, 0x0d, 0xb8, 0x00, 0x01, 0x0e, 0x08,
+  0x00, 0x01, 0x0e, 0x5c, 0x00, 0x01, 0x0e, 0xf0, 0x00, 0x01, 0x0f, 0x80,
+  0x00, 0x01, 0x10, 0x20, 0x00, 0x01, 0x10, 0xbc, 0x00, 0x01, 0x11, 0x38,
+  0x00, 0x01, 0x11, 0xb4, 0x00, 0x01, 0x12, 0x24, 0x00, 0x01, 0x12, 0x90,
+  0x00, 0x01, 0x12, 0xa0, 0x00, 0x01, 0x12, 0xfc, 0x00, 0x01, 0x13, 0x5c,
+  0x00, 0x01, 0x13, 0xb4, 0x00, 0x01, 0x14, 0x08, 0x00, 0x01, 0x14, 0x5c,
+  0x00, 0x01, 0x14, 0x6c, 0x00, 0x01, 0x14, 0x7c, 0x00, 0x01, 0x14, 0xcc,
+  0x00, 0x01, 0x15, 0x1c, 0x00, 0x01, 0x15, 0x80, 0x00, 0x01, 0x15, 0xe8,
+  0x00, 0x01, 0x16, 0x48, 0x00, 0x01, 0x16, 0xc0, 0x00, 0x01, 0x17, 0x28,
+  0x00, 0x01, 0x17, 0xc0, 0x00, 0x01, 0x17, 0xd0, 0x00, 0x01, 0x17, 0xe0,
+  0x00, 0x01, 0x17, 0xf0, 0x00, 0x01, 0x18, 0x00, 0x00, 0x01, 0x18, 0x54,
+  0x00, 0x01, 0x18, 0xa0, 0x00, 0x01, 0x19, 0x14, 0x00, 0x01, 0x19, 0x88,
+  0x00, 0x01, 0x19, 0xf0, 0x00, 0x01, 0x1a, 0x5c, 0x00, 0x01, 0x1a, 0x8c,
+  0x00, 0x01, 0x1a, 0xbc, 0x00, 0x01, 0x1a, 0xf4, 0x00, 0x01, 0x1b, 0x44,
+  0x00, 0x01, 0x1c, 0x1c, 0x00, 0x01, 0x1c, 0x88, 0x00, 0x01, 0x1c, 0x98,
+  0x00, 0x01, 0x1c, 0xe0, 0x00, 0x01, 0x1d, 0x38, 0x00, 0x01, 0x1d, 0x68,
+  0x00, 0x01, 0x1d, 0xf8, 0x00, 0x01, 0x1e, 0x1c, 0x00, 0x01, 0x1e, 0x58,
+  0x00, 0x01, 0x1e, 0x68, 0x00, 0x01, 0x1e, 0xa0, 0x00, 0x01, 0x1e, 0xb0,
+  0x00, 0x01, 0x1e, 0xc0, 0x00, 0x01, 0x1e, 0xd0, 0x00, 0x01, 0x1e, 0xe0,
+  0x00, 0x01, 0x1f, 0x34, 0x00, 0x01, 0x1f, 0x88, 0x00, 0x01, 0x20, 0x18,
+  0x00, 0x01, 0x20, 0xd4, 0x00, 0x01, 0x21, 0x0c, 0x00, 0x01, 0x21, 0x44,
+  0x00, 0x01, 0x21, 0x88, 0x00, 0x01, 0x21, 0xf8, 0x00, 0x01, 0x22, 0x68,
+  0x00, 0x01, 0x22, 0x78, 0x00, 0x01, 0x22, 0xb0, 0x00, 0x01, 0x22, 0xf4,
+  0x00, 0x01, 0x23, 0x50, 0x00, 0x01, 0x23, 0xc4, 0x00, 0x01, 0x23, 0xd4,
+  0x00, 0x01, 0x23, 0xe4, 0x00, 0x01, 0x23, 0xf4, 0x00, 0x01, 0x24, 0x44,
+  0x00, 0x01, 0x24, 0x64, 0x00, 0x01, 0x24, 0x74, 0x00, 0x01, 0x24, 0x9c,
+  0x00, 0x01, 0x24, 0xac, 0x00, 0x01, 0x25, 0x08, 0x00, 0x01, 0x25, 0x18,
+  0x00, 0x01, 0x25, 0x4c, 0x00, 0x01, 0x25, 0x98, 0x00, 0x01, 0x26, 0x14,
+  0x00, 0x01, 0x26, 0x5c, 0x00, 0x01, 0x26, 0x8c, 0x00, 0x01, 0x26, 0xbc,
+  0x00, 0x01, 0x27, 0x2c, 0x00, 0x01, 0x27, 0x5c, 0x00, 0x01, 0x27, 0x78,
+  0x00, 0x01, 0x27, 0xa8, 0x00, 0x01, 0x27, 0xdc, 0x00, 0x01, 0x27, 0xfc,
+  0x00, 0x01, 0x28, 0x34, 0x00, 0x01, 0x28, 0x64, 0x00, 0x01, 0x28, 0x94,
+  0x00, 0x01, 0x28, 0xf4, 0x00, 0x01, 0x29, 0xb0, 0x00, 0x01, 0x29, 0xfc,
+  0x00, 0x01, 0x2a, 0x68, 0x00, 0x01, 0x2a, 0x90, 0x00, 0x01, 0x2a, 0xd4,
+  0x00, 0x01, 0x2b, 0x0c, 0x00, 0x01, 0x2b, 0x8c, 0x00, 0x01, 0x2c, 0x14,
+  0x00, 0x01, 0x2c, 0x7c, 0x00, 0x01, 0x2d, 0x54, 0x00, 0x01, 0x2d, 0xb8,
+  0x00, 0x01, 0x2e, 0x20, 0x00, 0x01, 0x2e, 0x94, 0x00, 0x01, 0x2e, 0xf0,
+  0x00, 0x01, 0x2f, 0x84, 0x00, 0x01, 0x30, 0x14, 0x00, 0x01, 0x30, 0xa8,
+  0x00, 0x01, 0x30, 0xcc, 0x00, 0x01, 0x31, 0x00, 0x00, 0x01, 0x31, 0x68,
+  0x00, 0x01, 0x31, 0xc8, 0x00, 0x01, 0x32, 0x14, 0x00, 0x01, 0x32, 0x7c,
+  0x00, 0x01, 0x32, 0xb8, 0x00, 0x01, 0x32, 0xf0, 0x00, 0x01, 0x33, 0x54,
+  0x00, 0x01, 0x33, 0x94, 0x00, 0x01, 0x33, 0xe0, 0x00, 0x01, 0x34, 0x2c,
+  0x00, 0x01, 0x34, 0xa8, 0x00, 0x01, 0x34, 0xcc, 0x00, 0x01, 0x35, 0x2c,
+  0x00, 0x01, 0x35, 0x64, 0x00, 0x01, 0x35, 0xec, 0x00, 0x01, 0x36, 0x68,
+  0x00, 0x01, 0x36, 0xc0, 0x00, 0x01, 0x36, 0xd4, 0x00, 0x01, 0x36, 0xe8,
+  0x00, 0x01, 0x36, 0xfc, 0x00, 0x01, 0x37, 0x10, 0x00, 0x01, 0x37, 0x24,
+  0x00, 0x01, 0x37, 0x38, 0x00, 0x01, 0x37, 0x94, 0x00, 0x01, 0x37, 0xa8,
+  0x00, 0x01, 0x37, 0xbc, 0x00, 0x01, 0x38, 0x38, 0x00, 0x01, 0x38, 0x48,
+  0x00, 0x01, 0x38, 0x88, 0x00, 0x01, 0x39, 0x14, 0x00, 0x01, 0x39, 0x50,
+  0x00, 0x01, 0x39, 0xb8, 0x00, 0x01, 0x3a, 0x18, 0x00, 0x01, 0x3a, 0x9c,
+  0x00, 0x01, 0x3b, 0x2c, 0x00, 0x01, 0x3b, 0xbc, 0x00, 0x01, 0x3c, 0x00,
+  0x00, 0x01, 0x3c, 0x44, 0x00, 0x01, 0x3c, 0xcc, 0x00, 0x01, 0x3d, 0x18,
+  0x00, 0x01, 0x3d, 0x50, 0x00, 0x01, 0x3d, 0x80, 0x00, 0x01, 0x3d, 0xac,
+  0x00, 0x01, 0x3d, 0xe8, 0x00, 0x01, 0x3e, 0x40, 0x00, 0x01, 0x3e, 0x74,
+  0x00, 0x01, 0x3e, 0xb4, 0x00, 0x01, 0x3e, 0xd4, 0x00, 0x01, 0x3f, 0x6c,
+  0x00, 0x01, 0x3f, 0xe8, 0x00, 0x01, 0x40, 0x48, 0x00, 0x01, 0x40, 0xac,
+  0x00, 0x01, 0x40, 0xdc, 0x00, 0x01, 0x41, 0x4c, 0x00, 0x01, 0x41, 0xdc,
+  0x00, 0x01, 0x42, 0x84, 0x00, 0x01, 0x42, 0xd4, 0x00, 0x01, 0x43, 0x2c,
+  0x00, 0x01, 0x43, 0x94, 0x00, 0x01, 0x44, 0x08, 0x00, 0x01, 0x44, 0x4c,
+  0x00, 0x01, 0x44, 0xb0, 0x00, 0x01, 0x44, 0xd8, 0x00, 0x01, 0x45, 0x08,
+  0x00, 0x01, 0x45, 0x54, 0x00, 0x01, 0x45, 0xac, 0x00, 0x01, 0x46, 0x14,
+  0x00, 0x01, 0x46, 0x80, 0x00, 0x01, 0x46, 0xa0, 0x00, 0x01, 0x46, 0xc4,
+  0x00, 0x01, 0x46, 0xe8, 0x00, 0x01, 0x47, 0x08, 0x00, 0x01, 0x47, 0x34,
+  0x00, 0x01, 0x47, 0x64, 0x00, 0x01, 0x47, 0x7c, 0x00, 0x01, 0x47, 0x94,
+  0x00, 0x01, 0x47, 0xac, 0x00, 0x01, 0x47, 0xc4, 0x00, 0x01, 0x47, 0xdc,
+  0x00, 0x01, 0x47, 0xf4, 0x00, 0x01, 0x48, 0x0c, 0x00, 0x01, 0x48, 0x24,
+  0x00, 0x01, 0x48, 0x3c, 0x00, 0x01, 0x48, 0x54, 0x00, 0x01, 0x48, 0x6c,
+  0x00, 0x01, 0x48, 0x84, 0x00, 0x01, 0x48, 0x9c, 0x00, 0x01, 0x48, 0xb4,
+  0x00, 0x01, 0x48, 0xcc, 0x00, 0x01, 0x48, 0xe4, 0x00, 0x01, 0x48, 0xfc,
+  0x00, 0x01, 0x49, 0x14, 0x00, 0x01, 0x49, 0x2c, 0x00, 0x01, 0x49, 0x44,
+  0x00, 0x01, 0x49, 0x5c, 0x00, 0x01, 0x49, 0x74, 0x00, 0x01, 0x49, 0x8c,
+  0x00, 0x01, 0x49, 0xa4, 0x00, 0x01, 0x49, 0xbc, 0x00, 0x01, 0x49, 0xd4,
+  0x00, 0x01, 0x49, 0xec, 0x00, 0x01, 0x4a, 0x04, 0x00, 0x01, 0x4a, 0x24,
+  0x00, 0x01, 0x4a, 0x40, 0x00, 0x01, 0x4a, 0x58, 0x00, 0x01, 0x4a, 0x70,
+  0x00, 0x01, 0x4a, 0x88, 0x00, 0x01, 0x4a, 0xa0, 0x00, 0x01, 0x4a, 0xb8,
+  0x00, 0x01, 0x4a, 0xd0, 0x00, 0x01, 0x4a, 0xe8, 0x00, 0x01, 0x4b, 0x00,
+  0x00, 0x01, 0x4b, 0x18, 0x00, 0x01, 0x4b, 0x30, 0x00, 0x01, 0x4b, 0x48,
+  0x00, 0x01, 0x4b, 0x60, 0x00, 0x01, 0x4b, 0x78, 0x00, 0x01, 0x4b, 0x90,
+  0x00, 0x01, 0x4b, 0xa8, 0x00, 0x01, 0x4b, 0xc0, 0x00, 0x01, 0x4b, 0xd8,
+  0x00, 0x01, 0x4b, 0xf0, 0x00, 0x01, 0x4c, 0x08, 0x00, 0x01, 0x4c, 0x20,
+  0x00, 0x01, 0x4c, 0x38, 0x00, 0x01, 0x4c, 0x50, 0x00, 0x01, 0x4c, 0x68,
+  0x00, 0x01, 0x4c, 0x80, 0x00, 0x01, 0x4c, 0x98, 0x00, 0x01, 0x4c, 0xb0,
+  0x00, 0x01, 0x4c, 0xd0, 0x00, 0x01, 0x4c, 0xe8, 0x00, 0x01, 0x4d, 0x00,
+  0x00, 0x01, 0x4d, 0x18, 0x00, 0x01, 0x4d, 0x30, 0x00, 0x01, 0x4d, 0x48,
+  0x00, 0x01, 0x4d, 0x60, 0x00, 0x01, 0x4d, 0x78, 0x00, 0x01, 0x4d, 0x90,
+  0x00, 0x01, 0x4d, 0xa8, 0x00, 0x01, 0x4d, 0xc0, 0x00, 0x01, 0x4d, 0xd8,
+  0x00, 0x01, 0x4d, 0xf0, 0x00, 0x01, 0x4e, 0x08, 0x00, 0x01, 0x4e, 0x20,
+  0x00, 0x01, 0x4e, 0x38, 0x00, 0x01, 0x4e, 0x50, 0x00, 0x01, 0x4e, 0x68,
+  0x00, 0x01, 0x4e, 0x80, 0x00, 0x01, 0x4e, 0x98, 0x00, 0x01, 0x4e, 0xb0,
+  0x00, 0x01, 0x4e, 0xc8, 0x00, 0x01, 0x4e, 0xe0, 0x00, 0x01, 0x4f, 0x00,
+  0x00, 0x01, 0x4f, 0x18, 0x00, 0x01, 0x4f, 0x30, 0x00, 0x01, 0x4f, 0x48,
+  0x00, 0x01, 0x4f, 0x60, 0x00, 0x01, 0x4f, 0x78, 0x00, 0x01, 0x4f, 0x90,
+  0x00, 0x01, 0x4f, 0xa8, 0x00, 0x01, 0x4f, 0xc0, 0x00, 0x01, 0x4f, 0xd8,
+  0x00, 0x01, 0x4f, 0xf0, 0x00, 0x01, 0x50, 0x08, 0x00, 0x01, 0x50, 0x20,
+  0x00, 0x01, 0x50, 0x38, 0x00, 0x01, 0x50, 0x50, 0x00, 0x01, 0x50, 0x68,
+  0x00, 0x01, 0x50, 0x80, 0x00, 0x01, 0x50, 0x98, 0x00, 0x01, 0x50, 0xb0,
+  0x00, 0x01, 0x50, 0xc8, 0x00, 0x01, 0x50, 0xe0, 0x00, 0x01, 0x51, 0x00,
+  0x00, 0x01, 0x51, 0x20, 0x00, 0x01, 0x51, 0x38, 0x00, 0x01, 0x51, 0x50,
+  0x00, 0x01, 0x51, 0x68, 0x00, 0x01, 0x51, 0x80, 0x00, 0x01, 0x51, 0x98,
+  0x00, 0x01, 0x51, 0xb0, 0x00, 0x01, 0x51, 0xc8, 0x00, 0x01, 0x51, 0xe0,
+  0x00, 0x01, 0x51, 0xf8, 0x00, 0x01, 0x52, 0x10, 0x00, 0x01, 0x52, 0x28,
+  0x00, 0x01, 0x52, 0x40, 0x00, 0x01, 0x52, 0x58, 0x00, 0x01, 0x52, 0x70,
+  0x00, 0x01, 0x52, 0x88, 0x00, 0x01, 0x52, 0xa0, 0x00, 0x01, 0x52, 0xb8,
+  0x00, 0x01, 0x52, 0xd0, 0x00, 0x01, 0x52, 0xe8, 0x00, 0x01, 0x53, 0x00,
+  0x00, 0x01, 0x53, 0x18, 0x00, 0x01, 0x53, 0x30, 0x00, 0x01, 0x53, 0x48,
+  0x00, 0x01, 0x53, 0x60, 0x00, 0x01, 0x53, 0x78, 0x00, 0x01, 0x53, 0x90,
+  0x00, 0x01, 0x53, 0xa8, 0x00, 0x01, 0x53, 0xc0, 0x00, 0x01, 0x53, 0xd8,
+  0x00, 0x01, 0x53, 0xf0, 0x00, 0x01, 0x54, 0x08, 0x00, 0x01, 0x54, 0x20,
+  0x00, 0x01, 0x54, 0x38, 0x00, 0x01, 0x54, 0x50, 0x00, 0x01, 0x54, 0x68,
+  0x00, 0x01, 0x54, 0x80, 0x00, 0x01, 0x54, 0x98, 0x00, 0x01, 0x54, 0xb0,
+  0x00, 0x01, 0x54, 0xc8, 0x00, 0x01, 0x54, 0xe0, 0x00, 0x01, 0x54, 0xf8,
+  0x00, 0x01, 0x55, 0x10, 0x00, 0x01, 0x55, 0x28, 0x00, 0x01, 0x55, 0x40,
+  0x00, 0x01, 0x55, 0x58, 0x00, 0x01, 0x55, 0x70, 0x00, 0x01, 0x55, 0x88,
+  0x00, 0x01, 0x55, 0xa0, 0x00, 0x01, 0x55, 0xb8, 0x00, 0x01, 0x55, 0xd0,
+  0x00, 0x01, 0x55, 0xe8, 0x00, 0x01, 0x56, 0x00, 0x00, 0x01, 0x56, 0x18,
+  0x00, 0x01, 0x56, 0x30, 0x00, 0x01, 0x56, 0x80, 0x00, 0x01, 0x56, 0xc8,
+  0x00, 0x01, 0x57, 0x60, 0x00, 0x01, 0x57, 0x70, 0x00, 0x01, 0x57, 0x88,
+  0x00, 0x01, 0x57, 0xa0, 0x00, 0x01, 0x57, 0xb8, 0x00, 0x01, 0x57, 0xd0,
+  0x00, 0x01, 0x57, 0xe8, 0x00, 0x01, 0x58, 0x00, 0x00, 0x01, 0x58, 0x18,
+  0x00, 0x01, 0x58, 0x30, 0x00, 0x01, 0x58, 0x48, 0x00, 0x01, 0x58, 0x60,
+  0x00, 0x01, 0x58, 0x78, 0x00, 0x01, 0x58, 0x90, 0x00, 0x01, 0x58, 0xa8,
+  0x00, 0x01, 0x58, 0xc0, 0x00, 0x01, 0x58, 0xd8, 0x00, 0x01, 0x58, 0xf0,
+  0x00, 0x01, 0x59, 0x08, 0x00, 0x01, 0x59, 0x20, 0x00, 0x01, 0x59, 0x38,
+  0x00, 0x01, 0x59, 0x50, 0x00, 0x01, 0x59, 0x68, 0x00, 0x01, 0x59, 0x80,
+  0x00, 0x01, 0x59, 0x98, 0x00, 0x01, 0x59, 0xb0, 0x00, 0x01, 0x59, 0xc8,
+  0x00, 0x01, 0x59, 0xe0, 0x00, 0x01, 0x59, 0xf8, 0x00, 0x01, 0x5a, 0x10,
+  0x00, 0x01, 0x5a, 0x28, 0x00, 0x01, 0x5a, 0x40, 0x00, 0x01, 0x5a, 0x58,
+  0x00, 0x01, 0x5a, 0x70, 0x00, 0x01, 0x5a, 0x88, 0x00, 0x01, 0x5a, 0xa0,
+  0x00, 0x01, 0x5a, 0xb8, 0x00, 0x01, 0x5a, 0xd0, 0x00, 0x01, 0x5a, 0xe8,
+  0x00, 0x01, 0x5b, 0x00, 0x00, 0x01, 0x5b, 0x18, 0x00, 0x01, 0x5b, 0x38,
+  0x00, 0x01, 0x5b, 0x50, 0x00, 0x01, 0x5b, 0x68, 0x00, 0x01, 0x5b, 0x80,
+  0x00, 0x01, 0x5b, 0x98, 0x00, 0x01, 0x5b, 0xb0, 0x00, 0x01, 0x5b, 0xc8,
+  0x00, 0x01, 0x5b, 0xe0, 0x00, 0x01, 0x5b, 0xf8, 0x00, 0x01, 0x5c, 0x10,
+  0x00, 0x01, 0x5c, 0x28, 0x00, 0x01, 0x5c, 0x40, 0x00, 0x01, 0x5c, 0x58,
+  0x00, 0x01, 0x5c, 0x70, 0x00, 0x01, 0x5c, 0x88, 0x00, 0x01, 0x5c, 0xa0,
+  0x00, 0x01, 0x5c, 0xb8, 0x00, 0x01, 0x5c, 0xd0, 0x00, 0x01, 0x5c, 0xf0,
+  0x00, 0x01, 0x5d, 0x08, 0x00, 0x01, 0x5d, 0x20, 0x00, 0x01, 0x5d, 0x38,
+  0x00, 0x01, 0x5d, 0x50, 0x00, 0x01, 0x5d, 0x68, 0x00, 0x01, 0x5d, 0x80,
+  0x00, 0x01, 0x5d, 0x98, 0x00, 0x01, 0x5d, 0xb0, 0x00, 0x01, 0x5d, 0xc8,
+  0x00, 0x01, 0x5d, 0xe0, 0x00, 0x01, 0x5d, 0xf8, 0x00, 0x01, 0x5e, 0x10,
+  0x00, 0x01, 0x5e, 0x28, 0x00, 0x01, 0x5e, 0x40, 0x00, 0x01, 0x5e, 0x58,
+  0x00, 0x01, 0x5e, 0x70, 0x00, 0x01, 0x5e, 0x88, 0x00, 0x01, 0x5e, 0xa0,
+  0x00, 0x01, 0x5e, 0xb8, 0x00, 0x01, 0x5e, 0xd0, 0x00, 0x01, 0x5e, 0xe8,
+  0x00, 0x01, 0x5f, 0x00, 0x00, 0x01, 0x5f, 0x18, 0x00, 0x01, 0x5f, 0x30,
+  0x00, 0x01, 0x5f, 0x48, 0x00, 0x01, 0x5f, 0x60, 0x00, 0x01, 0x5f, 0x78,
+  0x00, 0x01, 0x5f, 0x90, 0x00, 0x01, 0x5f, 0xa8, 0x00, 0x01, 0x5f, 0xc0,
+  0x00, 0x01, 0x5f, 0xd8, 0x00, 0x01, 0x5f, 0xf0, 0x00, 0x01, 0x60, 0x1c,
+  0x00, 0x01, 0x60, 0x58, 0x00, 0x01, 0x60, 0x70, 0x00, 0x01, 0x60, 0x88,
+  0x00, 0x01, 0x60, 0xa0, 0x00, 0x01, 0x60, 0xb8, 0x00, 0x01, 0x60, 0xd0,
+  0x00, 0x01, 0x60, 0xe8, 0x00, 0x01, 0x61, 0x00, 0x00, 0x01, 0x61, 0x18,
+  0x00, 0x01, 0x61, 0x30, 0x00, 0x01, 0x61, 0x48, 0x00, 0x01, 0x61, 0x60,
+  0x00, 0x01, 0x61, 0x78, 0x00, 0x01, 0x61, 0x94, 0x00, 0x01, 0x61, 0xb0,
+  0x00, 0x01, 0x61, 0xc8, 0x00, 0x01, 0x61, 0xe0, 0x00, 0x01, 0x61, 0xf8,
+  0x00, 0x01, 0x62, 0x10, 0x00, 0x01, 0x62, 0x28, 0x00, 0x01, 0x62, 0x40,
+  0x00, 0x01, 0x62, 0x58, 0x00, 0x01, 0x62, 0x70, 0x00, 0x01, 0x62, 0x8c,
+  0x00, 0x01, 0x62, 0xa8, 0x00, 0x01, 0x62, 0xc0, 0x00, 0x01, 0x62, 0xd8,
+  0x00, 0x01, 0x62, 0xf4, 0x00, 0x01, 0x63, 0x10, 0x00, 0x01, 0x63, 0x28,
+  0x00, 0x01, 0x63, 0x40, 0x00, 0x01, 0x63, 0x58, 0x00, 0x01, 0x63, 0x70,
+  0x00, 0x01, 0x63, 0x88, 0x00, 0x01, 0x63, 0xa0, 0x00, 0x01, 0x63, 0xb8,
+  0x00, 0x01, 0x63, 0xd0, 0x00, 0x01, 0x63, 0xec, 0x00, 0x01, 0x64, 0x08,
+  0x00, 0x01, 0x64, 0x20, 0x00, 0x01, 0x64, 0x38, 0x00, 0x01, 0x64, 0x54,
+  0x00, 0x01, 0x64, 0x70, 0x00, 0x01, 0x64, 0x8c, 0x00, 0x01, 0x64, 0xa8,
+  0x00, 0x01, 0x64, 0xc0, 0x00, 0x01, 0x64, 0xd8, 0x00, 0x01, 0x64, 0xf0,
+  0x00, 0x01, 0x65, 0x08, 0x00, 0x01, 0x65, 0x20, 0x00, 0x01, 0x65, 0x38,
+  0x00, 0x01, 0x65, 0x50, 0x00, 0x01, 0x65, 0x68, 0x00, 0x01, 0x65, 0x84,
+  0x00, 0x01, 0x65, 0xa0, 0x00, 0x01, 0x65, 0xb8, 0x00, 0x01, 0x65, 0xd0,
+  0x00, 0x01, 0x65, 0xec, 0x00, 0x01, 0x66, 0x08, 0x00, 0x01, 0x66, 0x24,
+  0x00, 0x01, 0x66, 0x40, 0x00, 0x01, 0x66, 0x58, 0x00, 0x01, 0x66, 0x70,
+  0x00, 0x01, 0x66, 0x88, 0x00, 0x01, 0x66, 0xa0, 0x00, 0x01, 0x66, 0xb8,
+  0x00, 0x01, 0x66, 0xd0, 0x00, 0x01, 0x66, 0xe8, 0x00, 0x01, 0x67, 0x00,
+  0x00, 0x01, 0x67, 0x18, 0x00, 0x01, 0x67, 0x30, 0x00, 0x01, 0x67, 0x4c,
+  0x00, 0x01, 0x67, 0x68, 0x00, 0x01, 0x67, 0x80, 0x00, 0x01, 0x67, 0x98,
+  0x00, 0x01, 0x67, 0xb0, 0x00, 0x01, 0x67, 0xc8, 0x00, 0x01, 0x67, 0xe0,
+  0x00, 0x01, 0x67, 0xf8, 0x00, 0x01, 0x68, 0x10, 0x00, 0x01, 0x68, 0x28,
+  0x00, 0x01, 0x68, 0x44, 0x00, 0x01, 0x68, 0x5c, 0x00, 0x01, 0x68, 0x78,
+  0x00, 0x01, 0x68, 0x94, 0x00, 0x01, 0x68, 0xac, 0x00, 0x01, 0x68, 0xc4,
+  0x00, 0x01, 0x68, 0xdc, 0x00, 0x01, 0x68, 0xf4, 0x00, 0x01, 0x69, 0x0c,
+  0x00, 0x01, 0x69, 0x24, 0x00, 0x01, 0x69, 0x3c, 0x00, 0x01, 0x69, 0x54,
+  0x00, 0x01, 0x69, 0x6c, 0x00, 0x01, 0x69, 0x88, 0x00, 0x01, 0x69, 0xa0,
+  0x00, 0x01, 0x69, 0xb8, 0x00, 0x01, 0x69, 0xd4, 0x00, 0x01, 0x69, 0xf0,
+  0x00, 0x01, 0x6a, 0x0c, 0x00, 0x01, 0x6a, 0x28, 0x00, 0x01, 0x6a, 0x40,
+  0x00, 0x01, 0x6a, 0x50, 0x00, 0x01, 0x6a, 0x68, 0x00, 0x01, 0x6a, 0x78,
+  0x00, 0x01, 0x6a, 0x90, 0x00, 0x01, 0x6a, 0xa0, 0x00, 0x01, 0x6a, 0xb8,
+  0x00, 0x01, 0x6a, 0xc8, 0x00, 0x01, 0x6a, 0xe0, 0x00, 0x01, 0x6a, 0xf0,
+  0x00, 0x01, 0x6b, 0x08, 0x00, 0x01, 0x6b, 0x18, 0x00, 0x01, 0x6b, 0x30,
+  0x00, 0x01, 0x6b, 0x40, 0x00, 0x01, 0x6b, 0x58, 0x00, 0x01, 0x6b, 0x70,
+  0x00, 0x01, 0x6b, 0x88, 0x00, 0x01, 0x6b, 0xa0, 0x00, 0x01, 0x6b, 0xb8,
+  0x00, 0x01, 0x6b, 0xd0, 0x00, 0x01, 0x6b, 0xe8, 0x00, 0x01, 0x6c, 0x00,
+  0x00, 0x01, 0x6c, 0x18, 0x00, 0x01, 0x6c, 0x30, 0x00, 0x01, 0x6c, 0x48,
+  0x00, 0x01, 0x6c, 0x60, 0x00, 0x01, 0x6c, 0x78, 0x00, 0x01, 0x6c, 0x90,
+  0x00, 0x01, 0x6c, 0xa8, 0x00, 0x01, 0x6c, 0xc0, 0x00, 0x01, 0x6c, 0xd8,
+  0x00, 0x01, 0x6c, 0xf0, 0x00, 0x01, 0x6d, 0x08, 0x00, 0x01, 0x6d, 0x20,
+  0x00, 0x01, 0x6d, 0x38, 0x00, 0x01, 0x6d, 0x50, 0x00, 0x01, 0x6d, 0x68,
+  0x00, 0x01, 0x6d, 0x80, 0x00, 0x01, 0x6d, 0x98, 0x00, 0x01, 0x6d, 0xb0,
+  0x00, 0x01, 0x6d, 0xc8, 0x00, 0x01, 0x6d, 0xe0, 0x00, 0x01, 0x6d, 0xf8,
+  0x00, 0x01, 0x6e, 0x10, 0x00, 0x01, 0x6e, 0x28, 0x00, 0x01, 0x6e, 0x40,
+  0x00, 0x01, 0x6e, 0x58, 0x00, 0x01, 0x6e, 0x70, 0x00, 0x01, 0x6e, 0x88,
+  0x00, 0x01, 0x6e, 0xa0, 0x00, 0x01, 0x6e, 0xb8, 0x00, 0x01, 0x6e, 0xd0,
+  0x00, 0x01, 0x6e, 0xe8, 0x00, 0x01, 0x6f, 0x00, 0x00, 0x01, 0x6f, 0x18,
+  0x00, 0x01, 0x6f, 0x30, 0x00, 0x01, 0x6f, 0x48, 0x00, 0x01, 0x6f, 0x60,
+  0x00, 0x01, 0x6f, 0x78, 0x00, 0x01, 0x6f, 0x90, 0x00, 0x01, 0x6f, 0xa8,
+  0x00, 0x01, 0x6f, 0xc0, 0x00, 0x01, 0x6f, 0xd8, 0x00, 0x01, 0x6f, 0xf0,
+  0x00, 0x01, 0x70, 0x08, 0x00, 0x01, 0x70, 0x20, 0x00, 0x01, 0x70, 0x38,
+  0x00, 0x01, 0x70, 0x50, 0x00, 0x01, 0x70, 0x68, 0x00, 0x01, 0x70, 0x80,
+  0x00, 0x01, 0x70, 0x98, 0x00, 0x01, 0x70, 0xb0, 0x00, 0x01, 0x70, 0xc0,
+  0x00, 0x01, 0x70, 0xd8, 0x00, 0x01, 0x70, 0xe8, 0x00, 0x01, 0x70, 0xf8,
+  0x00, 0x01, 0x71, 0x20, 0x00, 0x01, 0x71, 0x30, 0x00, 0x01, 0x71, 0x48,
+  0x00, 0x01, 0x71, 0x60, 0x00, 0x01, 0x71, 0x78, 0x00, 0x01, 0x71, 0x90,
+  0x00, 0x01, 0x71, 0xa8, 0x00, 0x01, 0x71, 0xc0, 0x00, 0x01, 0x71, 0xdc,
+  0x00, 0x01, 0x71, 0xec, 0x00, 0x01, 0x72, 0x08, 0x00, 0x01, 0x72, 0x18,
+  0x00, 0x01, 0x72, 0x30, 0x00, 0x01, 0x72, 0x4c, 0x00, 0x01, 0x72, 0x64,
+  0x00, 0x01, 0x72, 0x7c, 0x00, 0x01, 0x72, 0x94, 0x00, 0x01, 0x72, 0xac,
+  0x00, 0x01, 0x72, 0xc4, 0x00, 0x01, 0x72, 0xd4, 0x00, 0x01, 0x72, 0xec,
+  0x00, 0x01, 0x73, 0x04, 0x00, 0x01, 0x73, 0x1c, 0x00, 0x01, 0x73, 0x34,
+  0x00, 0x01, 0x73, 0x50, 0x00, 0x01, 0x73, 0x60, 0x00, 0x01, 0x73, 0x7c,
+  0x00, 0x01, 0x73, 0x94, 0x00, 0x01, 0x73, 0xac, 0x00, 0x01, 0x73, 0xc4,
+  0x00, 0x01, 0x73, 0xdc, 0x00, 0x01, 0x73, 0xf4, 0x00, 0x01, 0x74, 0x04,
+  0x00, 0x01, 0x74, 0x1c, 0x00, 0x01, 0x74, 0x34, 0x00, 0x01, 0x74, 0x4c,
+  0x00, 0x01, 0x74, 0x64, 0x00, 0x01, 0x74, 0x7c, 0x00, 0x01, 0x74, 0x94,
+  0x00, 0x01, 0x74, 0xb0, 0x00, 0x01, 0x74, 0xc0, 0x00, 0x01, 0x74, 0xdc,
+  0x00, 0x01, 0x74, 0xf4, 0x00, 0x01, 0x75, 0x04, 0x00, 0x01, 0x75, 0x14,
+  0x00, 0x01, 0x75, 0x2c, 0x00, 0x01, 0x75, 0x44, 0x00, 0x01, 0x75, 0x5c,
+  0x00, 0x01, 0x75, 0x74, 0x00, 0x01, 0x75, 0x8c, 0x00, 0x01, 0x75, 0xa8,
+  0x00, 0x01, 0x75, 0xb8, 0x00, 0x01, 0x75, 0xd4, 0x00, 0x01, 0x75, 0xe4,
+  0x00, 0x01, 0x75, 0xfc, 0x00, 0x01, 0x76, 0x0c, 0x00, 0x01, 0x76, 0x30,
+  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
+  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
+  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
+  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
+  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x30,
+  0x00, 0x01, 0x76, 0x30, 0x00, 0x01, 0x76, 0x4c, 0x00, 0x01, 0x76, 0x5c,
+  0x00, 0x01, 0x76, 0x78, 0x00, 0x01, 0x76, 0x94, 0x00, 0x01, 0x76, 0xb0,
+  0x00, 0x01, 0x76, 0xcc, 0x00, 0x01, 0x76, 0xe4, 0x00, 0x01, 0x76, 0xfc,
+  0x00, 0x01, 0x77, 0x20, 0x00, 0x01, 0x77, 0x40, 0x00, 0x01, 0x77, 0x60,
+  0x00, 0x01, 0x77, 0x84, 0x00, 0x01, 0x77, 0xbc, 0x00, 0x01, 0x77, 0xf0,
+  0x00, 0x01, 0x78, 0x24, 0x00, 0x01, 0x78, 0x58, 0x00, 0x01, 0x78, 0x88,
+  0x00, 0x01, 0x78, 0xd0, 0x00, 0x01, 0x79, 0x00, 0x00, 0x01, 0x79, 0x1c,
+  0x00, 0x01, 0x79, 0x34, 0x00, 0x01, 0x79, 0x58, 0x00, 0x01, 0x79, 0x88,
+  0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0,
+  0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0,
+  0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0, 0x00, 0x01, 0x79, 0xa0,
+  0x00, 0x01, 0x7a, 0x7c, 0x00, 0x01, 0x7b, 0x8c, 0x00, 0x01, 0x7b, 0xac,
+  0x00, 0x01, 0x7b, 0xc4, 0x00, 0x01, 0x7b, 0xe4, 0x00, 0x01, 0x7c, 0x00,
+  0x00, 0x01, 0x7c, 0x18, 0x00, 0x01, 0x7c, 0x38, 0x00, 0x01, 0x7c, 0x5c,
+  0x00, 0x01, 0x7c, 0x84, 0x00, 0x01, 0x7c, 0xb0, 0x00, 0x01, 0x7c, 0xe0,
+  0x00, 0x01, 0x7c, 0xfc, 0x00, 0x01, 0x7d, 0x78, 0x00, 0x01, 0x7d, 0x8c,
+  0x00, 0x01, 0x7d, 0xc8, 0x00, 0x01, 0x7e, 0x04, 0x00, 0x01, 0x7e, 0x30,
+  0x00, 0x01, 0x7e, 0x54, 0x00, 0x01, 0x7e, 0x70, 0x00, 0x01, 0x7e, 0x8c,
+  0x00, 0x01, 0x7e, 0xbc, 0x00, 0x01, 0x7e, 0xec, 0x00, 0x01, 0x7f, 0x04,
+  0x00, 0x01, 0x7f, 0x1c, 0x00, 0x01, 0x7f, 0x38, 0x00, 0x01, 0x7f, 0x6c,
+  0x00, 0x01, 0x7f, 0xa0, 0x00, 0x01, 0x7f, 0xd0, 0x00, 0x01, 0x80, 0x00,
+  0x00, 0x01, 0x80, 0x14, 0x00, 0x01, 0x80, 0x44, 0x00, 0x01, 0x80, 0x5c,
+  0x00, 0x01, 0x80, 0x78, 0x00, 0x01, 0x80, 0x9c, 0x00, 0x01, 0x80, 0xfc,
+  0x00, 0x01, 0x81, 0x10, 0x00, 0x01, 0x81, 0x64, 0x00, 0x01, 0x81, 0x98,
+  0x00, 0x01, 0x81, 0xc0, 0x00, 0x01, 0x82, 0x00, 0x00, 0x01, 0x82, 0x4c,
+  0x00, 0x01, 0x82, 0x70, 0x00, 0x01, 0x82, 0xac, 0x00, 0x01, 0x83, 0x10,
+  0x00, 0x01, 0x83, 0x40, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
+  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
+  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
+  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c,
+  0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0x7c, 0x00, 0x01, 0x83, 0xd0,
+  0x00, 0x01, 0x83, 0xf4, 0x00, 0x01, 0x84, 0x2c, 0x00, 0x01, 0x84, 0x90,
+  0x00, 0x01, 0x85, 0x20, 0x00, 0x01, 0x85, 0x48, 0x00, 0x01, 0x85, 0xf8,
+  0x00, 0x01, 0x86, 0x84, 0x00, 0x01, 0x86, 0xb8, 0x00, 0x01, 0x86, 0xd4,
+  0x00, 0x01, 0x86, 0xfc, 0x00, 0x01, 0x87, 0x34, 0x00, 0x01, 0x87, 0x70,
+  0x00, 0x01, 0x87, 0xb4, 0x00, 0x01, 0x87, 0xc8, 0x00, 0x01, 0x87, 0xdc,
+  0x00, 0x01, 0x87, 0xf0, 0x00, 0x01, 0x88, 0x04, 0x00, 0x01, 0x88, 0x18,
+  0x00, 0x01, 0x88, 0x2c, 0x00, 0x01, 0x88, 0x40, 0x00, 0x01, 0x88, 0x54,
+  0x00, 0x01, 0x88, 0x68, 0x00, 0x01, 0x88, 0x7c, 0x00, 0x01, 0x88, 0x90,
+  0x00, 0x01, 0x88, 0xa4, 0x00, 0x01, 0x88, 0xb8, 0x00, 0x01, 0x88, 0xcc,
+  0x00, 0x01, 0x88, 0xe0, 0x00, 0x01, 0x88, 0xf4, 0x00, 0x01, 0x89, 0x08,
+  0x00, 0x01, 0x89, 0x1c, 0x00, 0x01, 0x89, 0x30, 0x00, 0x01, 0x89, 0x44,
+  0x00, 0x01, 0x89, 0x58, 0x00, 0x01, 0x89, 0x6c, 0x00, 0x01, 0x89, 0x80,
+  0x00, 0x01, 0x89, 0x94, 0x00, 0x01, 0x89, 0xa8, 0x00, 0x01, 0x89, 0xbc,
+  0x00, 0x01, 0x89, 0xd0, 0x00, 0x01, 0x89, 0xe4, 0x00, 0x01, 0x8a, 0x58,
+  0x00, 0x01, 0x8b, 0x08, 0x00, 0x01, 0x8b, 0x98, 0x00, 0x01, 0x8b, 0xd8,
+  0x00, 0x01, 0x8c, 0x40, 0x00, 0x01, 0x8c, 0xc4, 0x00, 0x01, 0x8d, 0x48,
+  0x00, 0x01, 0x8e, 0x2c, 0x00, 0x01, 0x8e, 0xf8, 0x00, 0x01, 0x8f, 0xa4,
+  0x00, 0x01, 0x90, 0x04, 0x00, 0x01, 0x90, 0x1c, 0x00, 0x01, 0x90, 0xb4,
+  0x00, 0x01, 0x90, 0xfc, 0x00, 0x01, 0x91, 0x54, 0x00, 0x01, 0x92, 0xe0,
+  0x00, 0x01, 0x93, 0x7c, 0x00, 0x01, 0x94, 0x14, 0x00, 0x01, 0x94, 0xa8,
+  0x00, 0x01, 0x95, 0x14, 0x00, 0x01, 0x95, 0xb4, 0x00, 0x01, 0x96, 0x44,
+  0x00, 0x01, 0x96, 0x78, 0x00, 0x01, 0x96, 0xf8, 0x00, 0x01, 0x97, 0x60,
+  0x00, 0x01, 0x97, 0x84, 0x00, 0x01, 0x97, 0xa4, 0x00, 0x01, 0x97, 0xcc,
+  0x00, 0x01, 0x97, 0xf4, 0x00, 0x01, 0x98, 0x2c, 0x00, 0x01, 0x98, 0x70,
+  0x00, 0x01, 0x98, 0xa8, 0x00, 0x01, 0x99, 0x68, 0x00, 0x01, 0x9a, 0x40,
+  0x00, 0x01, 0x9a, 0xb8, 0x00, 0x01, 0x9a, 0xd0, 0x00, 0x01, 0x9b, 0x5c,
+  0x00, 0x01, 0x9b, 0xf8, 0x00, 0x01, 0x9c, 0x90, 0x00, 0x01, 0x9c, 0xa0,
+  0x00, 0x01, 0x9c, 0xb4, 0x00, 0x01, 0x9c, 0xcc, 0x00, 0x01, 0x9e, 0x0c,
+  0x00, 0x01, 0x9e, 0xfc, 0x00, 0x01, 0x9f, 0x4c, 0x00, 0x01, 0x9f, 0xa8,
+  0x00, 0x01, 0xa0, 0x08, 0x00, 0x01, 0xa0, 0xb4, 0x00, 0x01, 0xa1, 0x48,
+  0x00, 0x01, 0xa2, 0x24, 0x00, 0x01, 0xa2, 0xa4, 0x00, 0x01, 0xa3, 0x20,
+  0x00, 0x01, 0xa3, 0x64, 0x00, 0x01, 0xa3, 0xf4, 0x00, 0x01, 0xa4, 0x98,
+  0x00, 0x01, 0xa5, 0x4c, 0x00, 0x01, 0xa5, 0xbc, 0x00, 0x01, 0xa6, 0x58,
+  0x00, 0x01, 0xa7, 0x70, 0x00, 0x01, 0xa8, 0x6c, 0x00, 0x01, 0xa9, 0x1c,
+  0x00, 0x01, 0xa9, 0x8c, 0x00, 0x01, 0xaa, 0x34, 0x00, 0x01, 0xaa, 0xd4,
+  0x00, 0x01, 0xab, 0x34, 0x00, 0x01, 0xab, 0x80, 0x00, 0x01, 0xab, 0xd0,
+  0x00, 0x01, 0xac, 0x10, 0x00, 0x01, 0xac, 0x7c, 0x00, 0x01, 0xac, 0x8c,
+  0x00, 0x01, 0xac, 0x9c, 0x00, 0x01, 0xad, 0x90, 0x00, 0x01, 0xad, 0xc4,
+  0x00, 0x01, 0xad, 0xd4, 0x00, 0x01, 0xad, 0xe4, 0x00, 0x01, 0xae, 0xd8,
+  0x00, 0x01, 0xaf, 0x9c, 0x00, 0x01, 0xb0, 0x24, 0x00, 0x01, 0xb0, 0xa0,
+  0x00, 0x01, 0xb1, 0x68, 0x00, 0x01, 0xb2, 0x48, 0x00, 0x01, 0xb2, 0x74,
+  0x00, 0x01, 0xb3, 0xb8, 0x00, 0x01, 0xb4, 0x0c, 0x00, 0x01, 0xb4, 0xb0,
+  0x00, 0x01, 0xb5, 0x40, 0x00, 0x01, 0xb5, 0xcc, 0x00, 0x01, 0xb6, 0x44,
+  0x00, 0x01, 0xb6, 0x8c, 0x00, 0x01, 0xb6, 0xfc, 0x00, 0x01, 0xb7, 0x7c,
+  0x00, 0x01, 0xb8, 0x10, 0x00, 0x01, 0xb8, 0x84, 0x00, 0x01, 0xb8, 0xb4,
+  0x00, 0x01, 0xb8, 0xf8, 0x00, 0x01, 0xb9, 0x4c, 0x00, 0x01, 0xb9, 0xb4,
+  0x00, 0x01, 0xb9, 0xd4, 0x00, 0x01, 0xb9, 0xf8, 0x00, 0x01, 0xba, 0x24,
+  0x00, 0x01, 0xba, 0xa8, 0x00, 0x01, 0xbb, 0x54, 0x00, 0x01, 0xbb, 0xf4,
+  0x00, 0x01, 0xbc, 0x2c, 0x00, 0x01, 0xbc, 0x94, 0x00, 0x01, 0xbd, 0x2c,
+  0x00, 0x01, 0xbd, 0x58, 0x00, 0x01, 0xbd, 0x78, 0x00, 0x01, 0xbd, 0x98,
+  0x00, 0x01, 0xbd, 0xc0, 0x00, 0x01, 0xbd, 0xe0, 0x00, 0x01, 0xbe, 0x00,
+  0x00, 0x01, 0xbe, 0x20, 0x00, 0x01, 0xbe, 0x40, 0x00, 0x01, 0xbe, 0x60,
+  0x00, 0x01, 0xbe, 0x80, 0x00, 0x01, 0xbe, 0xa0, 0x00, 0x01, 0xbe, 0xc0,
+  0x00, 0x01, 0xbe, 0xe0, 0x00, 0x01, 0xbf, 0x00, 0x00, 0x01, 0xbf, 0x20,
+  0x00, 0x01, 0xbf, 0x40, 0x00, 0x01, 0xbf, 0x58, 0x00, 0x01, 0xbf, 0x68,
+  0x00, 0x01, 0xbf, 0x80, 0x00, 0x01, 0xbf, 0xa0, 0x00, 0x01, 0xbf, 0xb8,
+  0x00, 0x01, 0xbf, 0xc8, 0x00, 0x01, 0xbf, 0xe0, 0x00, 0x01, 0xc0, 0x00,
+  0x00, 0x01, 0xc0, 0x28, 0x00, 0x01, 0xc0, 0x40, 0x00, 0x01, 0xc0, 0x50,
+  0x00, 0x01, 0xc0, 0x68, 0x00, 0x01, 0xc0, 0x88, 0x00, 0x01, 0xc0, 0x98,
+  0x00, 0x01, 0xc0, 0xa8, 0x00, 0x01, 0xc0, 0xb8, 0x00, 0x01, 0xc0, 0xc8,
+  0x00, 0x01, 0xc0, 0xd8, 0x00, 0x01, 0xc0, 0xf0, 0x00, 0x01, 0xc1, 0x10,
+  0x00, 0x01, 0xc1, 0x28, 0x00, 0x01, 0xc1, 0x38, 0x00, 0x01, 0xc1, 0x50,
+  0x00, 0x01, 0xc1, 0x70, 0x00, 0x01, 0xc1, 0x98, 0x00, 0x01, 0xc1, 0xb0,
+  0x00, 0x01, 0xc1, 0xc0, 0x00, 0x01, 0xc1, 0xd8, 0x00, 0x01, 0xc1, 0xf8,
+  0x00, 0x01, 0xc2, 0x08, 0x00, 0x01, 0xc2, 0x18, 0x00, 0x01, 0xc2, 0x28,
+  0x00, 0x01, 0xc2, 0x38, 0x00, 0x01, 0xc2, 0xbc, 0x00, 0x01, 0xc3, 0x38,
+  0x00, 0x01, 0xc4, 0x14, 0x00, 0x01, 0xc4, 0x24, 0x00, 0x01, 0xc4, 0x34,
+  0x00, 0x01, 0xc4, 0x9c, 0x00, 0x01, 0xc4, 0xbc, 0x00, 0x01, 0xc4, 0xec,
+  0x00, 0x01, 0xc5, 0x1c, 0x00, 0x01, 0xc5, 0x4c, 0x00, 0x01, 0xc5, 0x7c,
+  0x00, 0x01, 0xc5, 0xc0, 0x00, 0x01, 0xc6, 0x04, 0x00, 0x01, 0xc6, 0x34,
+  0x00, 0x01, 0xc6, 0x64, 0x00, 0x01, 0xc6, 0x94, 0x00, 0x01, 0xc6, 0xc4,
+  0x00, 0x01, 0xc7, 0x10, 0x00, 0x01, 0xc7, 0x5c, 0x00, 0x01, 0xc8, 0x04,
+  0x00, 0x01, 0xc8, 0xac, 0x00, 0x01, 0xc8, 0xf8, 0x00, 0x01, 0xc9, 0x44,
+  0x00, 0x01, 0xc9, 0x90, 0x00, 0x01, 0xc9, 0xdc, 0x00, 0x01, 0xca, 0x24,
+  0x00, 0x01, 0xca, 0x70, 0x00, 0x01, 0xca, 0xac, 0x00, 0x01, 0xca, 0xe8,
+  0x00, 0x01, 0xcb, 0x24, 0x00, 0x01, 0xcb, 0x60, 0x00, 0x01, 0xcb, 0xb4,
+  0x00, 0x01, 0xcc, 0x34, 0x00, 0x01, 0xcc, 0xc0, 0x00, 0x01, 0xcd, 0x84,
+  0x00, 0x01, 0xce, 0x48, 0x00, 0x01, 0xcf, 0x5c, 0x00, 0x01, 0xcf, 0xbc,
+  0x00, 0x01, 0xd0, 0x04, 0x00, 0x01, 0xd0, 0x3c, 0x00, 0x01, 0xd0, 0x74,
+  0x00, 0x01, 0xd0, 0xac, 0x00, 0x01, 0xd0, 0xe4, 0x00, 0x01, 0xd1, 0x1c,
+  0x00, 0x01, 0xd1, 0x54, 0x00, 0x01, 0xd1, 0xd4, 0x00, 0x01, 0xd2, 0x54,
+  0x00, 0x01, 0xd2, 0x90, 0x00, 0x01, 0xd2, 0xfc, 0x00, 0x01, 0xd3, 0xa4,
+  0x00, 0x01, 0xd4, 0x4c, 0x00, 0x01, 0xd4, 0x70, 0x00, 0x01, 0xd4, 0x98,
+  0x00, 0x01, 0xd4, 0xc0, 0x00, 0x01, 0xd4, 0xe8, 0x00, 0x01, 0xd5, 0x10,
+  0x00, 0x01, 0xd5, 0x38, 0x00, 0x01, 0xd5, 0x5c, 0x00, 0x01, 0xd5, 0x80,
+  0x00, 0x01, 0xd5, 0x9c, 0x00, 0x01, 0xd5, 0xb8, 0x00, 0x01, 0xd5, 0xd4,
+  0x00, 0x01, 0xd6, 0x1c, 0x00, 0x01, 0xd6, 0x64, 0x00, 0x01, 0xd6, 0xac,
+  0x00, 0x01, 0xd6, 0xf4, 0x00, 0x01, 0xd7, 0x10, 0x00, 0x01, 0xd7, 0x2c,
+  0x00, 0x01, 0xd7, 0x94, 0x00, 0x01, 0xd8, 0x14, 0x00, 0x01, 0xd8, 0x7c,
+  0x00, 0x01, 0xd8, 0xbc, 0x00, 0x01, 0xd8, 0xfc, 0x00, 0x01, 0xd9, 0x3c,
+  0x00, 0x01, 0xd9, 0x7c, 0x00, 0x01, 0xd9, 0xd8, 0x00, 0x01, 0xda, 0x34,
+  0x00, 0x01, 0xda, 0x74, 0x00, 0x01, 0xda, 0xb4, 0x00, 0x01, 0xda, 0xf4,
+  0x00, 0x01, 0xdb, 0x34, 0x00, 0x01, 0xdb, 0x74, 0x00, 0x01, 0xdb, 0xb4,
+  0x00, 0x01, 0xdc, 0x10, 0x00, 0x01, 0xdc, 0x6c, 0x00, 0x01, 0xdc, 0xc4,
+  0x00, 0x01, 0xdd, 0x1c, 0x00, 0x01, 0xdd, 0x60, 0x00, 0x01, 0xdd, 0xa8,
+  0x00, 0x01, 0xdd, 0xf0, 0x00, 0x01, 0xde, 0x3c, 0x00, 0x01, 0xde, 0x78,
+  0x00, 0x01, 0xde, 0xb4, 0x00, 0x01, 0xde, 0xf8, 0x00, 0x01, 0xdf, 0x38,
+  0x00, 0x01, 0xdf, 0x78, 0x00, 0x01, 0xdf, 0xb4, 0x00, 0x01, 0xe0, 0x10,
+  0x00, 0x01, 0xe0, 0x60, 0x00, 0x01, 0xe0, 0xc0, 0x00, 0x01, 0xe1, 0x1c,
+  0x00, 0x01, 0xe1, 0x7c, 0x00, 0x01, 0xe1, 0xf0, 0x00, 0x01, 0xe2, 0x44,
+  0x00, 0x01, 0xe2, 0x88, 0x00, 0x01, 0xe2, 0xcc, 0x00, 0x01, 0xe3, 0x20,
+  0x00, 0x01, 0xe3, 0xfc, 0x00, 0x01, 0xe4, 0x18, 0x00, 0x01, 0xe4, 0x78,
+  0x00, 0x01, 0xe4, 0xbc, 0x00, 0x01, 0xe5, 0x04, 0x00, 0x01, 0xe5, 0x60,
+  0x00, 0x01, 0xe5, 0xb8, 0x00, 0x01, 0xe6, 0x14, 0x00, 0x01, 0xe6, 0x84,
+  0x00, 0x01, 0xe6, 0xb8, 0x00, 0x01, 0xe6, 0xec, 0x00, 0x01, 0xe7, 0x3c,
+  0x00, 0x01, 0xe7, 0x74, 0x00, 0x01, 0xe7, 0xd8, 0x00, 0x01, 0xe8, 0x6c,
+  0x00, 0x01, 0xe8, 0xa0, 0x00, 0x01, 0xe9, 0x08, 0x00, 0x01, 0xe9, 0xc8,
+  0x00, 0x01, 0xe9, 0xf4, 0x00, 0x01, 0xea, 0x24, 0x00, 0x01, 0xea, 0x88,
+  0x00, 0x01, 0xeb, 0x2c, 0x00, 0x01, 0xeb, 0x80, 0x00, 0x01, 0xeb, 0xe4,
+  0x00, 0x01, 0xec, 0x88, 0x00, 0x01, 0xec, 0xdc, 0x00, 0x01, 0xec, 0xf8,
+  0x00, 0x01, 0xed, 0x20, 0x00, 0x01, 0xed, 0x48, 0x00, 0x01, 0xed, 0x80,
+  0x00, 0x01, 0xed, 0x9c, 0x00, 0x01, 0xed, 0xd8, 0x00, 0x01, 0xee, 0x14,
+  0x00, 0x01, 0xee, 0x24, 0x00, 0x01, 0xee, 0x38, 0x00, 0x01, 0xee, 0x84,
+  0x00, 0x01, 0xee, 0x98, 0x00, 0x01, 0xee, 0xa8, 0x00, 0x01, 0xee, 0xdc,
+  0x00, 0x01, 0xee, 0xf4, 0x00, 0x01, 0xef, 0x0c, 0x00, 0x01, 0xef, 0xa4,
+  0x00, 0x01, 0xf0, 0x5c, 0x00, 0x01, 0xf0, 0x7c, 0x00, 0x01, 0xf0, 0xa0,
+  0x00, 0x01, 0xf1, 0x0c, 0x00, 0x01, 0xf1, 0x84, 0x00, 0x01, 0xf1, 0xa0,
+  0x00, 0x01, 0xf1, 0xd4, 0x00, 0x01, 0xf1, 0xfc, 0x00, 0x01, 0xf2, 0x44,
+  0x00, 0x01, 0xf2, 0x6c, 0x00, 0x01, 0xf2, 0x94, 0x00, 0x01, 0xf2, 0xd4,
+  0x00, 0x01, 0xf3, 0x14, 0x00, 0x01, 0xf3, 0x64, 0x00, 0x01, 0xf3, 0x7c,
+  0x00, 0x01, 0xf3, 0x9c, 0x00, 0x01, 0xf4, 0x68, 0x00, 0x01, 0xf5, 0xa0,
+  0x00, 0x01, 0xf7, 0x48, 0x00, 0x01, 0xf7, 0xe8, 0x00, 0x01, 0xf8, 0xb0,
+  0x00, 0x01, 0xf9, 0x78, 0x00, 0x01, 0xf9, 0x9c, 0x00, 0x01, 0xf9, 0xc0,
+  0x00, 0x01, 0xf9, 0xdc, 0x00, 0x01, 0xfa, 0x08, 0x00, 0x01, 0xfa, 0x20,
+  0x00, 0x01, 0xfa, 0x54, 0x00, 0x01, 0xfa, 0x84, 0x00, 0x01, 0xfa, 0xa4,
+  0x00, 0x01, 0xfb, 0x04, 0x00, 0x01, 0xfb, 0x64, 0x00, 0x01, 0xfb, 0xe0,
+  0x00, 0x01, 0xfc, 0x28, 0x00, 0x01, 0xfc, 0x88, 0x00, 0x01, 0xfc, 0xe8,
+  0x00, 0x01, 0xfd, 0x54, 0x00, 0x01, 0xfd, 0xbc, 0x00, 0x01, 0xfe, 0x3c,
+  0x00, 0x01, 0xfe, 0xb0, 0x00, 0x01, 0xff, 0x40, 0x00, 0x01, 0xff, 0xd0,
+  0x00, 0x02, 0x00, 0x84, 0x00, 0x02, 0x01, 0x24, 0x00, 0x02, 0x01, 0xd4,
+  0x00, 0x02, 0x02, 0xbc, 0x00, 0x02, 0x03, 0x30, 0x00, 0x02, 0x03, 0x88,
+  0x00, 0x02, 0x04, 0x40, 0x00, 0x02, 0x04, 0xb4, 0x00, 0x02, 0x04, 0xcc,
+  0x00, 0x02, 0x04, 0xec, 0x00, 0x02, 0x05, 0x0c, 0x00, 0x02, 0x05, 0x2c,
+  0x00, 0x02, 0x05, 0x50, 0x00, 0x02, 0x05, 0x70, 0x00, 0x02, 0x05, 0xcc,
+  0x00, 0x02, 0x06, 0x38, 0x00, 0x02, 0x06, 0x7c, 0x00, 0x02, 0x06, 0xc0,
+  0x00, 0x02, 0x07, 0x00, 0x00, 0x02, 0x07, 0x4c, 0x00, 0x02, 0x07, 0x90,
+  0x00, 0x02, 0x08, 0x70, 0x00, 0x02, 0x08, 0xf4, 0x00, 0x02, 0x09, 0x80,
+  0x00, 0x02, 0x09, 0xcc, 0x00, 0x02, 0x0a, 0x00, 0x00, 0x02, 0x0a, 0x60,
+  0x00, 0x02, 0x0a, 0xa4, 0x00, 0x02, 0x0a, 0xe0, 0x00, 0x02, 0x0b, 0x18,
+  0x00, 0x02, 0x0b, 0x60, 0x00, 0x02, 0x0b, 0xa0, 0x00, 0x02, 0x0c, 0x08,
+  0x00, 0x02, 0x0c, 0x6c, 0x00, 0x02, 0x0c, 0xb4, 0x00, 0x02, 0x0c, 0xf8,
+  0x00, 0x02, 0x0d, 0x80, 0x00, 0x02, 0x0d, 0xe8, 0x00, 0x02, 0x0e, 0x3c,
+  0x00, 0x02, 0x0e, 0x90, 0x00, 0x02, 0x0e, 0xfc, 0x00, 0x02, 0x0f, 0x64,
+  0x00, 0x02, 0x0f, 0xe4, 0x00, 0x02, 0x10, 0x5c, 0x00, 0x02, 0x11, 0x10,
+  0x00, 0x02, 0x11, 0xc4, 0x00, 0x02, 0x12, 0x08, 0x00, 0x02, 0x12, 0x50,
+  0x00, 0x02, 0x12, 0xdc, 0x00, 0x02, 0x13, 0x64, 0x00, 0x02, 0x13, 0xa0,
+  0x00, 0x02, 0x13, 0xd8, 0x00, 0x02, 0x14, 0x2c, 0x00, 0x02, 0x14, 0x7c,
+  0x00, 0x02, 0x15, 0x0c, 0x00, 0x02, 0x15, 0x98, 0x00, 0x02, 0x16, 0x08,
+  0x00, 0x02, 0x16, 0x78, 0x00, 0x02, 0x16, 0xbc, 0x00, 0x02, 0x17, 0x00,
+  0x00, 0x02, 0x17, 0x68, 0x00, 0x02, 0x17, 0xd0, 0x00, 0x02, 0x18, 0x24,
+  0x00, 0x02, 0x18, 0x74, 0x00, 0x02, 0x18, 0xf0, 0x00, 0x02, 0x19, 0x70,
+  0x00, 0x02, 0x19, 0xdc, 0x00, 0x02, 0x1a, 0x48, 0x00, 0x02, 0x1a, 0xa8,
+  0x00, 0x02, 0x1a, 0xc0, 0x00, 0x02, 0x1b, 0x1c, 0x00, 0x02, 0x1b, 0x44,
+  0x00, 0x02, 0x1b, 0x6c, 0x00, 0x02, 0x1b, 0xa0, 0x00, 0x02, 0x1b, 0xd4,
+  0x00, 0x02, 0x1b, 0xfc, 0x00, 0x02, 0x1c, 0x20, 0x00, 0x02, 0x1c, 0xe8,
+  0x00, 0x02, 0x1d, 0x9c, 0x00, 0x02, 0x1e, 0x68, 0x00, 0x02, 0x1f, 0x20,
+  0x00, 0x02, 0x1f, 0xd0, 0x00, 0x02, 0x20, 0xb8, 0x00, 0x02, 0x21, 0x9c,
+  0x00, 0x02, 0x22, 0x5c, 0x00, 0x02, 0x23, 0x10, 0x00, 0x02, 0x23, 0x60,
+  0x00, 0x02, 0x23, 0x9c, 0x00, 0x02, 0x24, 0x00, 0x00, 0x02, 0x24, 0x38,
+  0x00, 0x02, 0x24, 0x5c, 0x00, 0x02, 0x24, 0x80, 0x00, 0x02, 0x24, 0xa8,
+  0x00, 0x02, 0x24, 0xcc, 0x00, 0x02, 0x24, 0xf0, 0x00, 0x02, 0x25, 0x20,
+  0x00, 0x02, 0x25, 0x50, 0x00, 0x02, 0x25, 0x80, 0x00, 0x02, 0x25, 0xc0,
+  0x00, 0x02, 0x25, 0xfc, 0x00, 0x02, 0x26, 0x40, 0x00, 0x02, 0x26, 0x9c,
+  0x00, 0x02, 0x26, 0xf0, 0x00, 0x02, 0x27, 0x58, 0x00, 0x02, 0x27, 0xdc,
+  0x00, 0x02, 0x28, 0x64, 0x00, 0x02, 0x28, 0x94, 0x00, 0x02, 0x28, 0xc0,
+  0x00, 0x02, 0x28, 0xf8, 0x00, 0x02, 0x29, 0x30, 0x00, 0x02, 0x29, 0x9c,
+  0x00, 0x02, 0x2a, 0x08, 0x00, 0x02, 0x2a, 0x58, 0x00, 0x02, 0x2a, 0x9c,
+  0x00, 0x02, 0x2a, 0xc0, 0x00, 0x02, 0x2a, 0xf4, 0x00, 0x02, 0x2b, 0x2c,
+  0x00, 0x02, 0x2b, 0x60, 0x00, 0x02, 0x2b, 0xb4, 0x00, 0x02, 0x2b, 0xe4,
+  0x00, 0x02, 0x2c, 0x10, 0x00, 0x02, 0x2c, 0x3c, 0x00, 0x02, 0x2c, 0x80,
+  0x00, 0x02, 0x2c, 0xc4, 0x00, 0x02, 0x2c, 0xd4, 0x00, 0x02, 0x2c, 0xec,
+  0x00, 0x02, 0x2d, 0x20, 0x00, 0x02, 0x2d, 0x8c, 0x00, 0x02, 0x2d, 0xd0,
+  0x00, 0x02, 0x2e, 0x10, 0x00, 0x02, 0x2e, 0x50, 0x00, 0x02, 0x2e, 0x7c,
+  0x00, 0x02, 0x2e, 0xac, 0x00, 0x02, 0x2f, 0x10, 0x00, 0x02, 0x2f, 0x48,
+  0x00, 0x02, 0x2f, 0x80, 0x00, 0x02, 0x30, 0x00, 0x00, 0x02, 0x30, 0x80,
+  0x00, 0x02, 0x30, 0xf8, 0x00, 0x02, 0x31, 0x70, 0x00, 0x02, 0x31, 0xcc,
+  0x00, 0x02, 0x32, 0x30, 0x00, 0x02, 0x32, 0x68, 0x00, 0x02, 0x32, 0x9c,
+  0x00, 0x02, 0x33, 0x04, 0x00, 0x02, 0x33, 0x64, 0x00, 0x02, 0x33, 0xbc,
+  0x00, 0x02, 0x34, 0x10, 0x00, 0x02, 0x34, 0x48, 0x00, 0x02, 0x34, 0x80,
+  0x00, 0x02, 0x34, 0xd4, 0x00, 0x02, 0x35, 0x28, 0x00, 0x02, 0x35, 0xb8,
+  0x00, 0x02, 0x36, 0x48, 0x00, 0x02, 0x36, 0xb0, 0x00, 0x02, 0x37, 0x18,
+  0x00, 0x02, 0x37, 0x64, 0x00, 0x02, 0x37, 0xb0, 0x00, 0x02, 0x38, 0x28,
+  0x00, 0x02, 0x38, 0xa0, 0x00, 0x02, 0x39, 0x28, 0x00, 0x02, 0x39, 0xb0,
+  0x00, 0x02, 0x3a, 0x08, 0x00, 0x02, 0x3a, 0x60, 0x00, 0x02, 0x3a, 0xd4,
+  0x00, 0x02, 0x3b, 0x44, 0x00, 0x02, 0x3b, 0x68, 0x00, 0x02, 0x3b, 0x88,
+  0x00, 0x02, 0x3b, 0xac, 0x00, 0x02, 0x3b, 0xd0, 0x00, 0x02, 0x3c, 0x44,
+  0x00, 0x02, 0x3c, 0xa8, 0x00, 0x02, 0x3d, 0x00, 0x00, 0x02, 0x3d, 0x18,
+  0x00, 0x02, 0x3d, 0x8c, 0x00, 0x02, 0x3d, 0xec, 0x00, 0x02, 0x3e, 0x60,
+  0x00, 0x02, 0x3e, 0xcc, 0x00, 0x02, 0x3f, 0x40, 0x00, 0x02, 0x3f, 0xa4,
+  0x00, 0x02, 0x40, 0x00, 0x00, 0x02, 0x40, 0x74, 0x00, 0x02, 0x40, 0xd8,
+  0x00, 0x02, 0x41, 0x0c, 0x00, 0x02, 0x41, 0x84, 0x00, 0x02, 0x41, 0xb0,
+  0x00, 0x02, 0x41, 0xe8, 0x00, 0x02, 0x42, 0x18, 0x00, 0x02, 0x42, 0x44,
+  0x00, 0x02, 0x42, 0x5c, 0x00, 0x02, 0x42, 0x7c, 0x00, 0x02, 0x42, 0xd4,
+  0x00, 0x02, 0x42, 0xf4, 0x00, 0x02, 0x43, 0x14, 0x00, 0x02, 0x43, 0x34,
+  0x00, 0x02, 0x43, 0x54, 0x00, 0x02, 0x43, 0x7c, 0x00, 0x02, 0x43, 0xa4,
+  0x00, 0x02, 0x43, 0xcc, 0x00, 0x02, 0x43, 0xf4, 0x00, 0x02, 0x44, 0x14,
+  0x00, 0x02, 0x44, 0x64, 0x00, 0x02, 0x45, 0x5c, 0x00, 0x02, 0x45, 0x80,
+  0x00, 0x02, 0x45, 0xa4, 0x00, 0x02, 0x45, 0xc4, 0x00, 0x02, 0x45, 0xe4,
+  0x00, 0x02, 0x46, 0x04, 0x00, 0x02, 0x46, 0x5c, 0x00, 0x02, 0x46, 0xb4,
+  0x00, 0x02, 0x47, 0x00, 0x00, 0x02, 0x47, 0x38, 0x00, 0x02, 0x47, 0xa4,
+  0x00, 0x02, 0x48, 0x04, 0x00, 0x02, 0x4c, 0xb8, 0x00, 0x02, 0x4d, 0x24,
+  0x00, 0x02, 0x4d, 0x98, 0x00, 0x02, 0x4d, 0xa8, 0x00, 0x02, 0x4d, 0xb8,
+  0x00, 0x02, 0x4d, 0xc8, 0x00, 0x02, 0x4d, 0xd8, 0x00, 0x02, 0x4e, 0x08,
+  0x00, 0x02, 0x4e, 0x54, 0x00, 0x02, 0x4e, 0x98, 0x00, 0x02, 0x4e, 0xd0,
+  0x00, 0x02, 0x4e, 0xec, 0x00, 0x02, 0x4f, 0x24, 0x00, 0x02, 0x4f, 0x5c,
+  0x00, 0x02, 0x4f, 0x78, 0x00, 0x02, 0x4f, 0xb0, 0x00, 0x02, 0x4f, 0xd0,
+  0x00, 0x02, 0x4f, 0xec, 0x00, 0x02, 0x50, 0x10, 0x00, 0x02, 0x50, 0x34,
+  0x00, 0x02, 0x50, 0x50, 0x00, 0x02, 0x50, 0x70, 0x00, 0x02, 0x50, 0xa4,
+  0x00, 0x02, 0x50, 0xfc, 0x00, 0x02, 0x51, 0x30, 0x00, 0x02, 0x51, 0x4c,
+  0x00, 0x02, 0x51, 0x80, 0x00, 0x02, 0x51, 0xd8, 0x00, 0x02, 0x52, 0x0c,
+  0x00, 0x02, 0x52, 0x28, 0x00, 0x02, 0x52, 0x78, 0x00, 0x02, 0x52, 0xa4,
+  0x00, 0x02, 0x53, 0x4c, 0x00, 0x02, 0x53, 0x5c, 0x00, 0x02, 0x53, 0xc8,
+  0x00, 0x02, 0x54, 0x38, 0x00, 0x02, 0x54, 0x60, 0x00, 0x02, 0x54, 0xf4,
+  0x00, 0x02, 0x55, 0xb8, 0x00, 0x02, 0x56, 0x90, 0x00, 0x02, 0x57, 0x2c,
+  0x00, 0x02, 0x57, 0xec, 0x00, 0x02, 0x58, 0xc0, 0x00, 0x02, 0x59, 0x4c,
+  0x00, 0x02, 0x5a, 0x3c, 0x00, 0x02, 0x5b, 0x10, 0x00, 0x02, 0x5b, 0xe0,
+  0x00, 0x02, 0x5b, 0xfc, 0x00, 0x02, 0x5c, 0x18, 0x00, 0x02, 0x5c, 0x34,
+  0x00, 0x02, 0x5c, 0x50, 0x00, 0x02, 0x5c, 0x84, 0x00, 0x02, 0x5c, 0xbc,
+  0x00, 0x02, 0x5c, 0xf4, 0x00, 0x02, 0x5d, 0x30, 0x00, 0x02, 0x5d, 0x68,
+  0x00, 0x02, 0x5d, 0xa8, 0x00, 0x02, 0x5d, 0xf0, 0x00, 0x02, 0x5e, 0x3c,
+  0x00, 0x02, 0x5e, 0x60, 0x00, 0x02, 0x5e, 0x84, 0x00, 0x02, 0x5e, 0xa8,
+  0x00, 0x02, 0x5e, 0xcc, 0x00, 0x02, 0x5e, 0xf0, 0x00, 0x02, 0x5f, 0x14,
+  0x00, 0x02, 0x5f, 0x38, 0x00, 0x02, 0x5f, 0x5c, 0x00, 0x02, 0x5f, 0x7c,
+  0x00, 0x02, 0x5f, 0xa0, 0x00, 0x02, 0x5f, 0xc4, 0x00, 0x02, 0x5f, 0xe8,
+  0x00, 0x02, 0x60, 0x08, 0x00, 0x02, 0x60, 0x28, 0x00, 0x02, 0x60, 0x48,
+  0x00, 0x02, 0x60, 0x6c, 0x00, 0x02, 0x60, 0x94, 0x00, 0x02, 0x60, 0xbc,
+  0x00, 0x02, 0x60, 0xe8, 0x00, 0x02, 0x61, 0x14, 0x00, 0x02, 0x61, 0x3c,
+  0x00, 0x02, 0x61, 0x6c, 0x00, 0x02, 0x61, 0x98, 0x00, 0x02, 0x61, 0xc0,
+  0x00, 0x02, 0x61, 0xe8, 0x00, 0x02, 0x62, 0x10, 0x00, 0x02, 0x62, 0x3c,
+  0x00, 0x02, 0x62, 0x68, 0x00, 0x02, 0x62, 0x90, 0x00, 0x02, 0x62, 0xc0,
+  0x00, 0x02, 0x62, 0xec, 0x00, 0x02, 0x63, 0x14, 0x00, 0x02, 0x63, 0x3c,
+  0x00, 0x02, 0x63, 0x68, 0x00, 0x02, 0x63, 0x94, 0x00, 0x02, 0x63, 0xbc,
+  0x00, 0x02, 0x63, 0xe4, 0x00, 0x02, 0x64, 0x10, 0x00, 0x02, 0x64, 0x3c,
+  0x00, 0x02, 0x64, 0x64, 0x00, 0x02, 0x64, 0x88, 0x00, 0x02, 0x64, 0xb4,
+  0x00, 0x02, 0x64, 0xe0, 0x00, 0x02, 0x65, 0x08, 0x00, 0x02, 0x65, 0x30,
+  0x00, 0x02, 0x65, 0x5c, 0x00, 0x02, 0x65, 0x88, 0x00, 0x02, 0x65, 0xb0,
+  0x00, 0x02, 0x65, 0xe0, 0x00, 0x02, 0x66, 0x14, 0x00, 0x02, 0x66, 0x48,
+  0x00, 0x02, 0x66, 0x7c, 0x00, 0x02, 0x66, 0xb0, 0x00, 0x02, 0x66, 0xe4,
+  0x00, 0x02, 0x67, 0x18, 0x00, 0x02, 0x67, 0x50, 0x00, 0x02, 0x67, 0x88,
+  0x00, 0x02, 0x67, 0xc0, 0x00, 0x02, 0x67, 0xf8, 0x00, 0x02, 0x68, 0x2c,
+  0x00, 0x02, 0x68, 0x60, 0x00, 0x02, 0x68, 0x94, 0x00, 0x02, 0x68, 0xc8,
+  0x00, 0x02, 0x68, 0xfc, 0x00, 0x02, 0x69, 0x20, 0x00, 0x02, 0x69, 0x4c,
+  0x00, 0x02, 0x69, 0x78, 0x00, 0x02, 0x69, 0xa4, 0x00, 0x02, 0x69, 0xcc,
+  0x00, 0x02, 0x69, 0xf4, 0x00, 0x02, 0x6a, 0x20, 0x00, 0x02, 0x6a, 0x4c,
+  0x00, 0x02, 0x6a, 0x80, 0x00, 0x02, 0x6a, 0xac, 0x00, 0x02, 0x6a, 0xd8,
+  0x00, 0x02, 0x6b, 0x0c, 0x00, 0x02, 0x6b, 0x38, 0x00, 0x02, 0x6b, 0x64,
+  0x00, 0x02, 0x6b, 0x98, 0x00, 0x02, 0x6b, 0xc4, 0x00, 0x02, 0x6b, 0xf0,
+  0x00, 0x02, 0x6c, 0x24, 0x00, 0x02, 0x6c, 0x54, 0x00, 0x02, 0x6c, 0x88,
+  0x00, 0x02, 0x6c, 0xcc, 0x00, 0x02, 0x6c, 0xfc, 0x00, 0x02, 0x6d, 0x30,
+  0x00, 0x02, 0x6d, 0x70, 0x00, 0x02, 0x6d, 0xa4, 0x00, 0x02, 0x6d, 0xd4,
+  0x00, 0x02, 0x6e, 0x14, 0x00, 0x02, 0x6e, 0x48, 0x00, 0x02, 0x6e, 0x78,
+  0x00, 0x02, 0x6e, 0xb8, 0x00, 0x02, 0x6f, 0x00, 0x00, 0x02, 0x6f, 0x44,
+  0x00, 0x02, 0x6f, 0xa0, 0x00, 0x02, 0x6f, 0xd4, 0x00, 0x02, 0x70, 0x0c,
+  0x00, 0x02, 0x70, 0x3c, 0x00, 0x02, 0x70, 0x70, 0x00, 0x02, 0x70, 0x90,
+  0x00, 0x02, 0x70, 0xac, 0x00, 0x02, 0x70, 0xec, 0x00, 0x02, 0x71, 0x08,
+  0x00, 0x02, 0x71, 0x24, 0x00, 0x02, 0x71, 0x40, 0x00, 0x02, 0x71, 0x5c,
+  0x00, 0x02, 0x71, 0x78, 0x00, 0x02, 0x71, 0x94, 0x00, 0x02, 0x71, 0xb0,
+  0x00, 0x02, 0x71, 0xcc, 0x00, 0x02, 0x71, 0xf0, 0x00, 0x02, 0x72, 0x18,
+  0x00, 0x02, 0x72, 0x3c, 0x00, 0x02, 0x72, 0x64, 0x00, 0x02, 0x72, 0x78,
+  0x00, 0x02, 0x72, 0x94, 0x00, 0x02, 0x72, 0xb0, 0x00, 0x02, 0x72, 0xcc,
+  0x00, 0x02, 0x72, 0xe8, 0x00, 0x02, 0x73, 0x04, 0x00, 0x02, 0x73, 0x20,
+  0x00, 0x02, 0x73, 0x3c, 0x00, 0x02, 0x73, 0x58, 0x00, 0x02, 0x73, 0x74,
+  0x00, 0x02, 0x73, 0x90, 0x00, 0x02, 0x73, 0xac, 0x00, 0x02, 0x73, 0xc8,
+  0x00, 0x02, 0x73, 0xe4, 0x00, 0x02, 0x74, 0x00, 0x00, 0x02, 0x74, 0x1c,
+  0x00, 0x02, 0x74, 0x30, 0x00, 0x02, 0x74, 0xe4, 0x00, 0x02, 0x77, 0xf8,
+  0x00, 0x02, 0x78, 0xa0, 0x00, 0x02, 0x78, 0xb4, 0x00, 0x02, 0x78, 0xc8,
+  0x00, 0x02, 0x78, 0xe4, 0x00, 0x02, 0x79, 0x00, 0x00, 0x02, 0x79, 0x1c,
+  0x00, 0x02, 0x79, 0x40, 0x00, 0x02, 0x79, 0x68, 0x00, 0x02, 0x79, 0x8c,
+  0x00, 0x02, 0x79, 0xb0, 0x00, 0x02, 0x79, 0xcc, 0x00, 0x02, 0x79, 0xf4,
+  0x00, 0x02, 0x7a, 0x18, 0x00, 0x02, 0x7a, 0x34, 0x00, 0x02, 0x7a, 0x60,
+  0x00, 0x02, 0x7a, 0xb4, 0x00, 0x02, 0x7a, 0xcc, 0x00, 0x02, 0x7b, 0x24,
+  0x00, 0x02, 0x7b, 0x84, 0x00, 0x02, 0x7c, 0xc0, 0x00, 0x02, 0x7d, 0x48,
+  0x00, 0x02, 0x7d, 0xd0, 0x00, 0x02, 0x7f, 0x8c, 0x00, 0x02, 0x7f, 0xa8,
+  0x00, 0x02, 0x7f, 0xd4, 0x00, 0x02, 0x7f, 0xf0, 0x00, 0x02, 0x80, 0x1c,
+  0x00, 0x02, 0x80, 0x38, 0x00, 0x02, 0x80, 0x64, 0x00, 0x02, 0x80, 0x84,
+  0x00, 0x02, 0x80, 0xb4, 0x00, 0x02, 0x80, 0xd0, 0x00, 0x02, 0x80, 0xf8,
+  0x00, 0x02, 0x81, 0x14, 0x00, 0x02, 0x81, 0x3c, 0x00, 0x02, 0x81, 0x58,
+  0x00, 0x02, 0x81, 0x84, 0x00, 0x02, 0x81, 0xa0, 0x00, 0x02, 0x81, 0xcc,
+  0x00, 0x02, 0x81, 0xe8, 0x00, 0x02, 0x82, 0x14, 0x00, 0x02, 0x82, 0x30,
+  0x00, 0x02, 0x82, 0x5c, 0x00, 0x02, 0x82, 0x78, 0x00, 0x02, 0x82, 0xa4,
+  0x00, 0x02, 0x82, 0xc0, 0x00, 0x02, 0x82, 0xec, 0x00, 0x02, 0x83, 0x08,
+  0x00, 0x02, 0x83, 0x34, 0x00, 0x02, 0x83, 0x50, 0x00, 0x02, 0x83, 0x7c,
+  0x00, 0x02, 0x83, 0x9c, 0x00, 0x02, 0x83, 0xd0, 0x00, 0x02, 0x84, 0x14,
+  0x00, 0x02, 0x84, 0xa4, 0x00, 0x02, 0x84, 0xd8, 0x00, 0x02, 0x85, 0x40,
+  0x00, 0x02, 0x86, 0x38, 0x00, 0x02, 0x86, 0xec, 0x00, 0x02, 0x87, 0xa8,
+  0x00, 0x02, 0x87, 0xf8, 0x00, 0x02, 0x88, 0x50, 0x00, 0x02, 0x88, 0xa8,
+  0x00, 0x02, 0x89, 0x04, 0x00, 0x02, 0x89, 0x60, 0x00, 0x02, 0x89, 0xc8,
+  0x00, 0x02, 0x8a, 0x18, 0x00, 0x02, 0x8a, 0x40, 0x00, 0x02, 0x8a, 0x68,
+  0x00, 0x02, 0x8a, 0xa4, 0x00, 0x02, 0x8b, 0x1c, 0x00, 0x02, 0x8b, 0x70,
+  0x00, 0x02, 0x8b, 0xc4, 0x00, 0x02, 0x8b, 0xf0, 0x00, 0x02, 0x8c, 0x1c,
+  0x00, 0x02, 0x8c, 0x48, 0x00, 0x02, 0x8c, 0x78, 0x00, 0x02, 0x8c, 0xbc,
+  0x00, 0x02, 0x8d, 0x00, 0x00, 0x02, 0x8d, 0x1c, 0x00, 0x02, 0x8d, 0x38,
+  0x00, 0x02, 0x8d, 0x50, 0x00, 0x02, 0x8d, 0x68, 0x00, 0x02, 0x8d, 0xb0,
+  0x00, 0x02, 0x8d, 0xdc, 0x00, 0x02, 0x8e, 0x08, 0x00, 0x02, 0x8e, 0x30,
+  0x00, 0x02, 0x8e, 0x58, 0x00, 0x02, 0x8e, 0x94, 0x00, 0x02, 0x8e, 0xd8,
+  0x00, 0x02, 0x8f, 0x04, 0x00, 0x02, 0x8f, 0x2c, 0x00, 0x02, 0x8f, 0x94,
+  0x00, 0x02, 0x8f, 0xd4, 0x00, 0x02, 0x90, 0x14, 0x00, 0x02, 0x90, 0x54,
+  0x00, 0x02, 0x90, 0x94, 0x00, 0x02, 0x91, 0x14, 0x00, 0x02, 0x91, 0x94,
+  0x00, 0x02, 0x92, 0x14, 0x00, 0x02, 0x92, 0x94, 0x00, 0x02, 0x92, 0xbc,
+  0x00, 0x02, 0x92, 0xe4, 0x00, 0x02, 0x93, 0x0c, 0x00, 0x02, 0x93, 0x38,
+  0x00, 0x02, 0x93, 0x54, 0x00, 0x02, 0x93, 0x80, 0x00, 0x02, 0x93, 0x9c,
+  0x00, 0x02, 0x93, 0xc4, 0x00, 0x02, 0x94, 0xb4, 0x00, 0x02, 0x95, 0x20,
+  0x00, 0x02, 0x95, 0xd4, 0x00, 0x02, 0x9e, 0xb4, 0x00, 0x02, 0xa1, 0x94,
+  0x00, 0x02, 0xa1, 0xcc, 0x00, 0x02, 0xa2, 0x30, 0x00, 0x02, 0xa2, 0x80,
+  0x00, 0x02, 0xa2, 0xe4, 0x00, 0x02, 0xa3, 0x78, 0x00, 0x02, 0xa4, 0x44,
+  0x00, 0x02, 0xa5, 0x10, 0x00, 0x02, 0xa5, 0x74, 0x00, 0x02, 0xa6, 0x10,
+  0x00, 0x02, 0xa8, 0x90, 0x00, 0x02, 0xab, 0x70, 0x00, 0x02, 0xab, 0xa8,
+  0x00, 0x02, 0xac, 0x20, 0x00, 0x02, 0xac, 0x94, 0x00, 0x02, 0xac, 0xec,
+  0x00, 0x02, 0xae, 0x48, 0x00, 0x02, 0xaf, 0xf4, 0x00, 0x02, 0xb0, 0x3c,
+  0x00, 0x02, 0xb0, 0x70, 0x00, 0x02, 0xb1, 0x64, 0x00, 0x02, 0xb2, 0x34,
+  0x00, 0x02, 0xb2, 0xc8, 0x00, 0x02, 0xb3, 0x5c, 0x00, 0x02, 0xb4, 0x20,
+  0x00, 0x02, 0xb4, 0xe8, 0x00, 0x02, 0xb5, 0xac, 0x00, 0x02, 0xb6, 0x70,
+  0x00, 0x02, 0xb9, 0xf4, 0x00, 0x02, 0xba, 0x70, 0x00, 0x02, 0xbb, 0x90,
+  0x00, 0x02, 0xbd, 0x2c, 0x00, 0x02, 0xc0, 0x88, 0x00, 0x02, 0xc1, 0x08,
+  0x00, 0x02, 0xc1, 0x8c, 0x00, 0x02, 0xc2, 0x00, 0x00, 0x02, 0xc2, 0x64,
+  0x00, 0x02, 0xc2, 0xe8, 0x00, 0x02, 0xc3, 0x78, 0x00, 0x02, 0xc4, 0xbc,
+  0x00, 0x02, 0xc5, 0xec, 0x00, 0x02, 0xc6, 0x88, 0x00, 0x02, 0xc7, 0x1c,
+  0x00, 0x02, 0xc7, 0xd0, 0x00, 0x02, 0xc7, 0xf0, 0x00, 0x02, 0xc8, 0x10,
+  0x00, 0x02, 0xc8, 0x30, 0x00, 0x02, 0xc8, 0x50, 0x00, 0x02, 0xc8, 0x70,
+  0x00, 0x02, 0xc8, 0x90, 0x00, 0x02, 0xc8, 0xb0, 0x00, 0x02, 0xc8, 0xd0,
+  0x00, 0x02, 0xca, 0x44, 0x00, 0x02, 0xcb, 0x20, 0x00, 0x02, 0xcb, 0xfc,
+  0x00, 0x02, 0xcc, 0xa8, 0x00, 0x02, 0xcd, 0xc4, 0x00, 0x02, 0xce, 0x54,
+  0x00, 0x02, 0xce, 0xe4, 0x00, 0x02, 0xcf, 0x9c, 0x00, 0x02, 0xd0, 0x10,
+  0x00, 0x02, 0xd0, 0x84, 0x00, 0x02, 0xd0, 0xf8, 0x00, 0x02, 0xd1, 0x50,
+  0x00, 0x02, 0xd1, 0xac, 0x00, 0x02, 0xd2, 0x40, 0x00, 0x02, 0xd2, 0xec,
+  0x00, 0x02, 0xd3, 0x54, 0x00, 0x02, 0xd3, 0xc8, 0x00, 0x02, 0xd4, 0x60,
+  0x00, 0x02, 0xd4, 0xc4, 0x00, 0x02, 0xd5, 0x84, 0x00, 0x02, 0xd6, 0x64,
+  0x00, 0x02, 0xd7, 0x34, 0x00, 0x02, 0xd7, 0xa8, 0x00, 0x02, 0xd8, 0x4c,
+  0x00, 0x02, 0xd8, 0xa8, 0x00, 0x02, 0xd9, 0x44, 0x00, 0x02, 0xda, 0x2c,
+  0x00, 0x02, 0xda, 0xa8, 0x00, 0x02, 0xdb, 0xd0, 0x00, 0x02, 0xdd, 0xfc,
+  0x00, 0x02, 0xde, 0x94, 0x00, 0x02, 0xdf, 0xb0, 0x00, 0x02, 0xe0, 0xf8,
+  0x00, 0x02, 0xe2, 0x0c, 0x00, 0x02, 0xe3, 0xa0, 0x00, 0x02, 0xe4, 0x98,
+  0x00, 0x02, 0xe5, 0x18, 0x00, 0x02, 0xe5, 0xdc, 0x00, 0x02, 0xe6, 0xc4,
+  0x00, 0x02, 0xe7, 0x58, 0x00, 0x02, 0xe7, 0xcc, 0x00, 0x02, 0xe8, 0x6c,
+  0x00, 0x02, 0xe8, 0xb4, 0x00, 0x02, 0xe9, 0x54, 0x00, 0x02, 0xea, 0x1c,
+  0x00, 0x02, 0xea, 0x70, 0x00, 0x02, 0xea, 0xa0, 0x00, 0x02, 0xeb, 0xc0,
+  0x00, 0x02, 0xec, 0xac, 0x00, 0x02, 0xec, 0xec, 0x00, 0x02, 0xed, 0x48,
+  0x00, 0x02, 0xed, 0xac, 0x00, 0x02, 0xee, 0x0c, 0x00, 0x02, 0xee, 0x60,
+  0x00, 0x02, 0xee, 0xac, 0x00, 0x02, 0xef, 0x40, 0x00, 0x02, 0xf0, 0x00,
+  0x00, 0x02, 0xf0, 0xe8, 0x00, 0x02, 0xf2, 0xf4, 0x00, 0x02, 0xf3, 0xe8,
+  0x00, 0x02, 0xf5, 0x0c, 0x00, 0x02, 0xf6, 0x48, 0x00, 0x02, 0xf7, 0x48,
+  0x00, 0x02, 0xf8, 0x6c, 0x00, 0x02, 0xf9, 0xa0, 0x00, 0x02, 0xfa, 0x90,
+  0x00, 0x02, 0xfb, 0x64, 0x00, 0x02, 0xfc, 0x70, 0x00, 0x02, 0xfd, 0xa4,
+  0x00, 0x02, 0xfe, 0xfc, 0x00, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0x98,
+  0x00, 0x03, 0x01, 0x08, 0x00, 0x03, 0x01, 0xbc, 0x00, 0x03, 0x02, 0xb0,
+  0x00, 0x03, 0x03, 0xe8, 0x00, 0x03, 0x05, 0x64, 0x00, 0x03, 0x07, 0x24,
+  0x00, 0x03, 0x07, 0xc0, 0x00, 0x03, 0x08, 0x80, 0x00, 0x03, 0x08, 0xe8,
+  0x00, 0x03, 0x09, 0x74, 0x00, 0x03, 0x09, 0x90, 0x00, 0x03, 0x09, 0xb8,
+  0x00, 0x03, 0x09, 0xd0, 0x00, 0x03, 0x09, 0xe8, 0x00, 0x03, 0x0a, 0x00,
+  0x00, 0x03, 0x0a, 0x18, 0x00, 0x03, 0x0a, 0x98, 0x00, 0x03, 0x0a, 0xe8,
+  0x00, 0x03, 0x0b, 0x6c, 0x00, 0x03, 0x0c, 0x64, 0x00, 0x03, 0x0d, 0x0c,
+  0x00, 0x03, 0x0e, 0x2c, 0x00, 0x03, 0x0e, 0xdc, 0x00, 0x03, 0x0f, 0x64,
+  0x00, 0x03, 0x10, 0x08, 0x00, 0x03, 0x11, 0x0c, 0x00, 0x03, 0x12, 0xf4,
+  0x00, 0x03, 0x15, 0xb8, 0x00, 0x03, 0x17, 0x78, 0x00, 0x03, 0x17, 0xfc,
+  0x00, 0x03, 0x18, 0x48, 0x00, 0x03, 0x19, 0x20, 0x00, 0x03, 0x1a, 0x08,
+  0x00, 0x03, 0x1a, 0xec, 0x00, 0x03, 0x1b, 0x78, 0x00, 0x03, 0x1c, 0x58,
+  0x00, 0x03, 0x1d, 0x68, 0x00, 0x03, 0x1e, 0x40, 0x00, 0x03, 0x1f, 0x1c,
+  0x00, 0x03, 0x1f, 0x6c, 0x00, 0x03, 0x1f, 0xa0, 0x00, 0x03, 0x1f, 0xec,
+  0x00, 0x03, 0x20, 0x8c, 0x00, 0x03, 0x21, 0xd8, 0x00, 0x03, 0x23, 0x1c,
+  0x00, 0x03, 0x23, 0x58, 0x00, 0x03, 0x23, 0xd8, 0x00, 0x03, 0x24, 0x30,
+  0x00, 0x03, 0x24, 0x8c, 0x00, 0x03, 0x24, 0xe4, 0x00, 0x03, 0x25, 0x50,
+  0x00, 0x03, 0x25, 0xb4, 0x00, 0x03, 0x26, 0x1c, 0x00, 0x03, 0x26, 0x80,
+  0x00, 0x03, 0x27, 0x28, 0x00, 0x03, 0x28, 0x08, 0x00, 0x03, 0x29, 0x18,
+  0x00, 0x03, 0x2a, 0x84, 0x00, 0x03, 0x2b, 0x18, 0x00, 0x03, 0x2c, 0xa8,
+  0x00, 0x03, 0x2e, 0x0c, 0x00, 0x03, 0x2f, 0x98, 0x00, 0x03, 0x33, 0x58,
+  0x00, 0x03, 0x34, 0xe4, 0x00, 0x03, 0x36, 0x5c, 0x00, 0x03, 0x36, 0xe8,
+  0x00, 0x03, 0x37, 0x98, 0x00, 0x03, 0x3a, 0x4c, 0x00, 0x03, 0x3b, 0xec,
+  0x00, 0x03, 0x3d, 0x04, 0x00, 0x03, 0x3d, 0xf0, 0x00, 0x03, 0x3f, 0x04,
+  0x00, 0x03, 0x3f, 0xec, 0x00, 0x03, 0x40, 0x74, 0x00, 0x03, 0x40, 0xd8,
+  0x00, 0x03, 0x41, 0x3c, 0x00, 0x03, 0x41, 0x80, 0x00, 0x03, 0x41, 0xc0,
+  0x00, 0x03, 0x42, 0x8c, 0x00, 0x03, 0x43, 0x84, 0x00, 0x03, 0x44, 0x04,
+  0x00, 0x03, 0x44, 0x38, 0x00, 0x03, 0x44, 0x74, 0x00, 0x03, 0x44, 0xb8,
+  0x00, 0x03, 0x44, 0xe8, 0x00, 0x03, 0x45, 0x48, 0x00, 0x03, 0x45, 0xbc,
+  0x00, 0x03, 0x46, 0xa0, 0x00, 0x03, 0x47, 0x38, 0x00, 0x03, 0x47, 0xf4,
+  0x00, 0x03, 0x49, 0x74, 0x00, 0x03, 0x4a, 0xf8, 0x00, 0x03, 0x4e, 0x58,
+  0x00, 0x03, 0x4e, 0xb8, 0x00, 0x03, 0x4f, 0x68, 0x00, 0x03, 0x4f, 0xd0,
+  0x00, 0x03, 0x50, 0x5c, 0x00, 0x03, 0x50, 0xec, 0x00, 0x03, 0x51, 0xac,
+  0x00, 0x03, 0x52, 0x38, 0x00, 0x03, 0x52, 0xb8, 0x00, 0x03, 0x53, 0x34,
+  0x00, 0x03, 0x53, 0xa4, 0x00, 0x03, 0x53, 0xf8, 0x00, 0x03, 0x54, 0x60,
+  0x00, 0x03, 0x54, 0xc4, 0x00, 0x03, 0x55, 0x1c, 0x00, 0x03, 0x55, 0xe0,
+  0x00, 0x03, 0x56, 0x24, 0x00, 0x03, 0x56, 0x78, 0x00, 0x03, 0x56, 0xc8,
+  0x00, 0x03, 0x57, 0x34, 0x00, 0x03, 0x57, 0xf0, 0x00, 0x03, 0x59, 0x9c,
+  0x00, 0x03, 0x5b, 0x90, 0x00, 0x03, 0x5c, 0xbc, 0x00, 0x03, 0x5e, 0xec,
+  0x00, 0x03, 0x60, 0x4c, 0x00, 0x03, 0x62, 0xc4, 0x00, 0x03, 0x68, 0x14,
+  0x00, 0x03, 0x69, 0x4c, 0x00, 0x03, 0x6b, 0x9c, 0x00, 0x03, 0x6c, 0x60,
+  0x00, 0x03, 0x6d, 0x24, 0x00, 0x03, 0x6d, 0xf0, 0x00, 0x03, 0x6f, 0x74,
+  0x00, 0x03, 0x70, 0xf4, 0x00, 0x03, 0x72, 0x54, 0x00, 0x03, 0x73, 0xb0,
+  0x00, 0x03, 0x74, 0xfc, 0x00, 0x03, 0x75, 0x80, 0x00, 0x03, 0x75, 0xb4,
+  0x00, 0x03, 0x75, 0xe8, 0x00, 0x03, 0x76, 0x18, 0x00, 0x03, 0x76, 0x48,
+  0x00, 0x03, 0x76, 0xa0, 0x00, 0x03, 0x76, 0xbc, 0x00, 0x03, 0x76, 0xd8,
+  0x00, 0x03, 0x76, 0xf4, 0x00, 0x03, 0x77, 0x1c, 0x00, 0x03, 0x77, 0x40,
+  0x00, 0x03, 0x77, 0x58, 0x00, 0x03, 0x77, 0x70, 0x00, 0x03, 0x78, 0x4c,
+  0x00, 0x03, 0x78, 0xe4, 0x00, 0x03, 0x79, 0xa0, 0x00, 0x03, 0x7a, 0x10,
+  0x00, 0x03, 0x7a, 0x84, 0x00, 0x03, 0x7b, 0xa4, 0x00, 0x03, 0x7c, 0x8c,
+  0x00, 0x03, 0x7c, 0xf8, 0x00, 0x03, 0x7d, 0x68, 0x00, 0x03, 0x7d, 0xa4,
+  0x00, 0x03, 0x7d, 0xe0, 0x00, 0x03, 0x7e, 0x08, 0x00, 0x03, 0x7e, 0x34,
+  0x00, 0x03, 0x7e, 0x5c, 0x00, 0x03, 0x7e, 0x88, 0x00, 0x03, 0x7e, 0xb0,
+  0x00, 0x03, 0x7e, 0xdc, 0x00, 0x03, 0x7f, 0x08, 0x00, 0x03, 0x7f, 0x34,
+  0x00, 0x03, 0x7f, 0x98, 0x00, 0x03, 0x7f, 0xfc, 0x00, 0x03, 0x80, 0x5c,
+  0x00, 0x03, 0x80, 0xec, 0x00, 0x03, 0x81, 0x94, 0x00, 0x03, 0x82, 0x00,
+  0x00, 0x03, 0x82, 0x90, 0x00, 0x03, 0x83, 0x34, 0x00, 0x03, 0x83, 0x90,
+  0x00, 0x03, 0x84, 0x54, 0x00, 0x03, 0x84, 0xf8, 0x00, 0x03, 0x85, 0x98,
+  0x00, 0x03, 0x86, 0x6c, 0x00, 0x03, 0x87, 0x70, 0x00, 0x03, 0x88, 0x88,
+  0x00, 0x03, 0x89, 0x64, 0x00, 0x03, 0x8a, 0x64, 0x00, 0x03, 0x8b, 0x7c,
+  0x00, 0x03, 0x8c, 0x48, 0x00, 0x03, 0x8d, 0x70, 0x00, 0x03, 0x8e, 0x88,
+  0x00, 0x03, 0x8f, 0xb8, 0x00, 0x03, 0x90, 0x38, 0x00, 0x03, 0x90, 0xe8,
+  0x00, 0x03, 0x91, 0xb0, 0x00, 0x03, 0x92, 0x3c, 0x00, 0x03, 0x92, 0xec,
+  0x00, 0x03, 0x93, 0xb4, 0x00, 0x03, 0x94, 0x2c, 0x00, 0x03, 0x95, 0x04,
+  0x00, 0x03, 0x95, 0xcc, 0x00, 0x03, 0x96, 0x90, 0x00, 0x03, 0x96, 0xc0,
+  0x00, 0x03, 0x96, 0xec, 0x00, 0x03, 0x97, 0x18, 0x00, 0x03, 0x97, 0x44,
+  0x00, 0x03, 0x97, 0x74, 0x00, 0x03, 0x98, 0x00, 0x00, 0x03, 0x98, 0x28,
+  0x00, 0x03, 0x98, 0x50, 0x00, 0x03, 0x98, 0xa4, 0x00, 0x03, 0x98, 0xf8,
+  0x00, 0x03, 0x99, 0x20, 0x00, 0x03, 0x99, 0x50, 0x00, 0x03, 0x99, 0x80,
+  0x00, 0x03, 0x99, 0xa0, 0x00, 0x03, 0x99, 0xf0, 0x00, 0x03, 0x9a, 0x40,
+  0x00, 0x03, 0x9a, 0x6c, 0x00, 0x03, 0x9a, 0x9c, 0x00, 0x03, 0x9a, 0xe4,
+  0x00, 0x03, 0x9b, 0x2c, 0x00, 0x03, 0x9b, 0x80, 0x00, 0x03, 0x9b, 0xd0,
+  0x00, 0x03, 0x9c, 0x1c, 0x00, 0x03, 0x9c, 0x6c, 0x00, 0x03, 0x9c, 0xc0,
+  0x00, 0x03, 0x9d, 0x14, 0x00, 0x03, 0x9d, 0x80, 0x00, 0x03, 0x9e, 0x24,
+  0x00, 0x03, 0x9e, 0x7c, 0x00, 0x03, 0x9e, 0xc4, 0x00, 0x03, 0x9f, 0x1c,
+  0x00, 0x03, 0x9f, 0xa8, 0x00, 0x03, 0xa0, 0x28, 0x00, 0x03, 0xa0, 0xb4,
+  0x00, 0x03, 0xa1, 0x84, 0x00, 0x03, 0xa2, 0x14, 0x00, 0x03, 0xa3, 0x38,
+  0x00, 0x03, 0xa4, 0x64, 0x00, 0x03, 0xa4, 0xf0, 0x00, 0x03, 0xa5, 0x50,
+  0x00, 0x03, 0xa5, 0xb0, 0x00, 0x03, 0xa5, 0xec, 0x00, 0x03, 0xa6, 0x20,
+  0x00, 0x03, 0xa6, 0x54, 0x00, 0x03, 0xa6, 0x78, 0x00, 0x03, 0xa6, 0x9c,
+  0x00, 0x03, 0xa6, 0xb4, 0x00, 0x03, 0xa6, 0xcc, 0x00, 0x03, 0xa7, 0x24,
+  0x00, 0x03, 0xa7, 0x78, 0x00, 0x03, 0xa8, 0x3c, 0x00, 0x03, 0xa8, 0xfc,
+  0x00, 0x03, 0xa9, 0xf8, 0x00, 0x03, 0xaa, 0x28, 0x00, 0x03, 0xaa, 0x58,
+  0x00, 0x03, 0xaa, 0x9c, 0x00, 0x03, 0xaa, 0xdc, 0x00, 0x03, 0xab, 0x1c,
+  0x00, 0x03, 0xab, 0x78, 0x00, 0x03, 0xab, 0xb4, 0x00, 0x03, 0xab, 0xf0,
+  0x00, 0x03, 0xac, 0x3c, 0x00, 0x03, 0xac, 0x88, 0x00, 0x03, 0xad, 0x0c,
+  0x00, 0x03, 0xad, 0x0c, 0x00, 0x03, 0xad, 0x20, 0x00, 0x03, 0xad, 0x34,
+  0x00, 0x03, 0xad, 0x50, 0x00, 0x03, 0xad, 0x64, 0x00, 0x03, 0xad, 0x80,
+  0x00, 0x03, 0xad, 0x9c, 0x00, 0x03, 0xad, 0xc0, 0x00, 0x03, 0xad, 0xd4,
+  0x00, 0x03, 0xad, 0xf0, 0x00, 0x03, 0xae, 0x0c, 0x00, 0x03, 0xae, 0x30,
+  0x00, 0x03, 0xae, 0x4c, 0x00, 0x03, 0xae, 0x70, 0x00, 0x03, 0xae, 0x94,
+  0x00, 0x03, 0xae, 0xc0, 0x00, 0x03, 0xae, 0xd4, 0x00, 0x03, 0xae, 0xf0,
+  0x00, 0x03, 0xaf, 0x0c, 0x00, 0x03, 0xaf, 0x30, 0x00, 0x03, 0xaf, 0x4c,
+  0x00, 0x03, 0xaf, 0x70, 0x00, 0x03, 0xaf, 0x94, 0x00, 0x03, 0xaf, 0xc0,
+  0x00, 0x03, 0xaf, 0xdc, 0x00, 0x03, 0xb0, 0x00, 0x00, 0x03, 0xb0, 0x24,
+  0x00, 0x03, 0xb0, 0x50, 0x00, 0x03, 0xb0, 0x74, 0x00, 0x03, 0xb0, 0xa0,
+  0x00, 0x03, 0xb0, 0xcc, 0x00, 0x03, 0xb1, 0x00, 0x00, 0x03, 0xb1, 0x14,
+  0x00, 0x03, 0xb1, 0x30, 0x00, 0x03, 0xb1, 0x4c, 0x00, 0x03, 0xb1, 0x70,
+  0x00, 0x03, 0xb1, 0x8c, 0x00, 0x03, 0xb1, 0xb0, 0x00, 0x03, 0xb1, 0xd4,
+  0x00, 0x03, 0xb2, 0x00, 0x00, 0x03, 0xb2, 0x1c, 0x00, 0x03, 0xb2, 0x40,
+  0x00, 0x03, 0xb2, 0x64, 0x00, 0x03, 0xb2, 0x90, 0x00, 0x03, 0xb2, 0xb4,
+  0x00, 0x03, 0xb2, 0xe0, 0x00, 0x03, 0xb3, 0x0c, 0x00, 0x03, 0xb3, 0x40,
+  0x00, 0x03, 0xb3, 0x5c, 0x00, 0x03, 0xb3, 0x80, 0x00, 0x03, 0xb3, 0xa4,
+  0x00, 0x03, 0xb3, 0xd0, 0x00, 0x03, 0xb3, 0xf4, 0x00, 0x03, 0xb4, 0x20,
+  0x00, 0x03, 0xb4, 0x4c, 0x00, 0x03, 0xb4, 0x80, 0x00, 0x03, 0xb4, 0xa4,
+  0x00, 0x03, 0xb4, 0xd0, 0x00, 0x03, 0xb4, 0xfc, 0x00, 0x03, 0xb5, 0x30,
+  0x00, 0x03, 0xb5, 0x5c, 0x00, 0x03, 0xb5, 0x90, 0x00, 0x03, 0xb5, 0xc4,
+  0x00, 0x03, 0xb6, 0x00, 0x00, 0x03, 0xb6, 0x14, 0x00, 0x03, 0xb6, 0x30,
+  0x00, 0x03, 0xb6, 0x4c, 0x00, 0x03, 0xb6, 0x70, 0x00, 0x03, 0xb6, 0x8c,
+  0x00, 0x03, 0xb6, 0xb0, 0x00, 0x03, 0xb6, 0xd4, 0x00, 0x03, 0xb7, 0x00,
+  0x00, 0x03, 0xb7, 0x1c, 0x00, 0x03, 0xb7, 0x40, 0x00, 0x03, 0xb7, 0x64,
+  0x00, 0x03, 0xb7, 0x90, 0x00, 0x03, 0xb7, 0xb4, 0x00, 0x03, 0xb7, 0xe0,
+  0x00, 0x03, 0xb8, 0x0c, 0x00, 0x03, 0xb8, 0x40, 0x00, 0x03, 0xb8, 0x5c,
+  0x00, 0x03, 0xb8, 0x80, 0x00, 0x03, 0xb8, 0xa4, 0x00, 0x03, 0xb8, 0xd0,
+  0x00, 0x03, 0xb8, 0xf4, 0x00, 0x03, 0xb9, 0x20, 0x00, 0x03, 0xb9, 0x4c,
+  0x00, 0x03, 0xb9, 0x80, 0x00, 0x03, 0xb9, 0xa4, 0x00, 0x03, 0xb9, 0xd0,
+  0x00, 0x03, 0xb9, 0xfc, 0x00, 0x03, 0xba, 0x30, 0x00, 0x03, 0xba, 0x5c,
+  0x00, 0x03, 0xba, 0x90, 0x00, 0x03, 0xba, 0xc4, 0x00, 0x03, 0xbb, 0x00,
+  0x00, 0x03, 0xbb, 0x1c, 0x00, 0x03, 0xbb, 0x40, 0x00, 0x03, 0xbb, 0x64,
+  0x00, 0x03, 0xbb, 0x90, 0x00, 0x03, 0xbb, 0xb4, 0x00, 0x03, 0xbb, 0xe0,
+  0x00, 0x03, 0xbc, 0x0c, 0x00, 0x03, 0xbc, 0x40, 0x00, 0x03, 0xbc, 0x64,
+  0x00, 0x03, 0xbc, 0x90, 0x00, 0x03, 0xbc, 0xbc, 0x00, 0x03, 0xbc, 0xf0,
+  0x00, 0x03, 0xbd, 0x1c, 0x00, 0x03, 0xbd, 0x50, 0x00, 0x03, 0xbd, 0x84,
+  0x00, 0x03, 0xbd, 0xc0, 0x00, 0x03, 0xbd, 0xe4, 0x00, 0x03, 0xbe, 0x10,
+  0x00, 0x03, 0xbe, 0x3c, 0x00, 0x03, 0xbe, 0x70, 0x00, 0x03, 0xbe, 0x9c,
+  0x00, 0x03, 0xbe, 0xd0, 0x00, 0x03, 0xbf, 0x04, 0x00, 0x03, 0xbf, 0x40,
+  0x00, 0x03, 0xbf, 0x6c, 0x00, 0x03, 0xbf, 0xa0, 0x00, 0x03, 0xbf, 0xd4,
+  0x00, 0x03, 0xc0, 0x10, 0x00, 0x03, 0xc0, 0x44, 0x00, 0x03, 0xc0, 0x80,
+  0x00, 0x03, 0xc0, 0xbc, 0x00, 0x03, 0xc1, 0x00, 0x00, 0x03, 0xc1, 0x14,
+  0x00, 0x03, 0xc1, 0x30, 0x00, 0x03, 0xc1, 0x4c, 0x00, 0x03, 0xc1, 0x70,
+  0x00, 0x03, 0xc1, 0x8c, 0x00, 0x03, 0xc1, 0xb0, 0x00, 0x03, 0xc1, 0xd4,
+  0x00, 0x03, 0xc2, 0x00, 0x00, 0x03, 0xc2, 0x1c, 0x00, 0x03, 0xc2, 0x40,
+  0x00, 0x03, 0xc2, 0x64, 0x00, 0x03, 0xc2, 0x90, 0x00, 0x03, 0xc2, 0xb4,
+  0x00, 0x03, 0xc2, 0xe0, 0x00, 0x03, 0xc3, 0x0c, 0x00, 0x03, 0xc3, 0x40,
+  0x00, 0x03, 0xc3, 0x5c, 0x00, 0x03, 0xc3, 0x80, 0x00, 0x03, 0xc3, 0xa4,
+  0x00, 0x03, 0xc3, 0xd0, 0x00, 0x03, 0xc3, 0xf4, 0x00, 0x03, 0xc4, 0x20,
+  0x00, 0x03, 0xc4, 0x4c, 0x00, 0x03, 0xc4, 0x80, 0x00, 0x03, 0xc4, 0xa4,
+  0x00, 0x03, 0xc4, 0xd0, 0x00, 0x03, 0xc4, 0xfc, 0x00, 0x03, 0xc5, 0x30,
+  0x00, 0x03, 0xc5, 0x5c, 0x00, 0x03, 0xc5, 0x90, 0x00, 0x03, 0xc5, 0xc4,
+  0x00, 0x03, 0xc6, 0x00, 0x00, 0x03, 0xc6, 0x1c, 0x00, 0x03, 0xc6, 0x40,
+  0x00, 0x03, 0xc6, 0x64, 0x00, 0x03, 0xc6, 0x90, 0x00, 0x03, 0xc6, 0xb4,
+  0x00, 0x03, 0xc6, 0xe0, 0x00, 0x03, 0xc7, 0x0c, 0x00, 0x03, 0xc7, 0x40,
+  0x00, 0x03, 0xc7, 0x64, 0x00, 0x03, 0xc7, 0x90, 0x00, 0x03, 0xc7, 0xbc,
+  0x00, 0x03, 0xc7, 0xf0, 0x00, 0x03, 0xc8, 0x1c, 0x00, 0x03, 0xc8, 0x50,
+  0x00, 0x03, 0xc8, 0x84, 0x00, 0x03, 0xc8, 0xc0, 0x00, 0x03, 0xc8, 0xe4,
+  0x00, 0x03, 0xc9, 0x10, 0x00, 0x03, 0xc9, 0x3c, 0x00, 0x03, 0xc9, 0x70,
+  0x00, 0x03, 0xc9, 0x9c, 0x00, 0x03, 0xc9, 0xd0, 0x00, 0x03, 0xca, 0x04,
+  0x00, 0x03, 0xca, 0x40, 0x00, 0x03, 0xca, 0x6c, 0x00, 0x03, 0xca, 0xa0,
+  0x00, 0x03, 0xca, 0xd4, 0x00, 0x03, 0xcb, 0x10, 0x00, 0x03, 0xcb, 0x44,
+  0x00, 0x03, 0xcb, 0x80, 0x00, 0x03, 0xcb, 0xbc, 0x00, 0x03, 0xcc, 0x00,
+  0x00, 0x03, 0xcc, 0x1c, 0x00, 0x03, 0xcc, 0x40, 0x00, 0x03, 0xcc, 0x64,
+  0x00, 0x03, 0xcc, 0x90, 0x00, 0x03, 0xcc, 0xb4, 0x00, 0x03, 0xcc, 0xe0,
+  0x00, 0x03, 0xcd, 0x0c, 0x00, 0x03, 0xcd, 0x40, 0x00, 0x03, 0xcd, 0x64,
+  0x00, 0x03, 0xcd, 0x90, 0x00, 0x03, 0xcd, 0xbc, 0x00, 0x03, 0xcd, 0xf0,
+  0x00, 0x03, 0xce, 0x1c, 0x00, 0x03, 0xce, 0x50, 0x00, 0x03, 0xce, 0x84,
+  0x00, 0x03, 0xce, 0xc0, 0x00, 0x03, 0xce, 0xe4, 0x00, 0x03, 0xcf, 0x10,
+  0x00, 0x03, 0xcf, 0x3c, 0x00, 0x03, 0xcf, 0x70, 0x00, 0x03, 0xcf, 0x9c,
+  0x00, 0x03, 0xcf, 0xd0, 0x00, 0x03, 0xd0, 0x04, 0x00, 0x03, 0xd0, 0x40,
+  0x00, 0x03, 0xd0, 0x6c, 0x00, 0x03, 0xd0, 0xa0, 0x00, 0x03, 0xd0, 0xd4,
+  0x00, 0x03, 0xd1, 0x10, 0x00, 0x03, 0xd1, 0x44, 0x00, 0x03, 0xd1, 0x80,
+  0x00, 0x03, 0xd1, 0xbc, 0x00, 0x03, 0xd2, 0x00, 0x00, 0x03, 0xd2, 0x24,
+  0x00, 0x03, 0xd2, 0x50, 0x00, 0x03, 0xd2, 0x7c, 0x00, 0x03, 0xd2, 0xb0,
+  0x00, 0x03, 0xd2, 0xdc, 0x00, 0x03, 0xd3, 0x10, 0x00, 0x03, 0xd3, 0x44,
+  0x00, 0x03, 0xd3, 0x80, 0x00, 0x03, 0xd3, 0xac, 0x00, 0x03, 0xd3, 0xe0,
+  0x00, 0x03, 0xd4, 0x14, 0x00, 0x03, 0xd4, 0x50, 0x00, 0x03, 0xd4, 0x84,
+  0x00, 0x03, 0xd4, 0xc0, 0x00, 0x03, 0xd4, 0xfc, 0x00, 0x03, 0xd5, 0x40,
+  0x00, 0x03, 0xd5, 0x6c, 0x00, 0x03, 0xd5, 0xa0, 0x00, 0x03, 0xd5, 0xd4,
+  0x00, 0x03, 0xd6, 0x10, 0x00, 0x03, 0xd6, 0x44, 0x00, 0x03, 0xd6, 0x80,
+  0x00, 0x03, 0xd6, 0xbc, 0x00, 0x03, 0xd7, 0x00, 0x00, 0x03, 0xd7, 0x34,
+  0x00, 0x03, 0xd7, 0x70, 0x00, 0x03, 0xd7, 0xac, 0x00, 0x03, 0xd7, 0xf0,
+  0x00, 0x03, 0xd8, 0x2c, 0x00, 0x03, 0xd8, 0x70, 0x00, 0x03, 0xd8, 0xb4,
+  0x00, 0x03, 0xd9, 0x00, 0x00, 0x03, 0xd9, 0x4c, 0x00, 0x03, 0xd9, 0x98,
+  0x00, 0x03, 0xd9, 0xe0, 0x00, 0x03, 0xda, 0x24, 0x00, 0x03, 0xda, 0xf0,
+  0x00, 0x03, 0xdb, 0xb8, 0x00, 0x03, 0xdc, 0x40, 0x00, 0x03, 0xdc, 0xc8,
+  0x00, 0x03, 0xdd, 0x14, 0x00, 0x03, 0xdd, 0x50, 0x00, 0x03, 0xdd, 0x8c,
+  0x00, 0x03, 0xdd, 0xc0, 0x00, 0x03, 0xdd, 0xf4, 0x00, 0x03, 0xde, 0x1c,
+  0x00, 0x03, 0xde, 0x50, 0x00, 0x03, 0xde, 0x84, 0x00, 0x03, 0xde, 0xa4,
+  0x00, 0x03, 0xde, 0xec, 0x00, 0x03, 0xdf, 0x44, 0x00, 0x03, 0xe0, 0x04,
+  0x00, 0x03, 0xe0, 0xd8, 0x00, 0x03, 0xe1, 0xbc, 0x00, 0x03, 0xe1, 0xe4,
+  0x00, 0x03, 0xe2, 0x44, 0x00, 0x03, 0xe2, 0xbc, 0x00, 0x03, 0xe3, 0x28,
+  0x00, 0x03, 0xe3, 0xd4, 0x00, 0x03, 0xe4, 0x74, 0x00, 0x03, 0xe4, 0xe8,
+  0x00, 0x03, 0xe5, 0x78, 0x00, 0x03, 0xe6, 0x0c, 0x00, 0x03, 0xe6, 0xb0,
+  0x00, 0x03, 0xe7, 0x30, 0x00, 0x03, 0xe7, 0xc8, 0x00, 0x03, 0xe8, 0x44,
+  0x00, 0x03, 0xe8, 0xcc, 0x00, 0x03, 0xe9, 0x50, 0x00, 0x03, 0xe9, 0xb0,
+  0x00, 0x03, 0xea, 0x10, 0x00, 0x03, 0xea, 0x20, 0x00, 0x03, 0xea, 0x38,
+  0x00, 0x03, 0xea, 0x58, 0x00, 0x03, 0xea, 0x94, 0x00, 0x03, 0xea, 0xcc,
+  0x00, 0x03, 0xea, 0xe4, 0x00, 0x03, 0xea, 0xfc, 0x00, 0x03, 0xeb, 0x14,
+  0x00, 0x03, 0xeb, 0x2c, 0x00, 0x03, 0xeb, 0x44, 0x00, 0x03, 0xeb, 0x5c,
+  0x00, 0x03, 0xec, 0x2c, 0x00, 0x03, 0xec, 0xf8, 0x00, 0x03, 0xed, 0x48,
+  0x00, 0x03, 0xed, 0x98, 0x00, 0x03, 0xee, 0x5c, 0x00, 0x03, 0xef, 0x18,
+  0x00, 0x03, 0xef, 0x7c, 0x00, 0x03, 0xef, 0xd8, 0x00, 0x03, 0xf0, 0x5c,
+  0x00, 0x03, 0xf0, 0xdc, 0x00, 0x03, 0xf1, 0x6c, 0x00, 0x03, 0xf1, 0xfc,
+  0x00, 0x03, 0xf2, 0x58, 0x00, 0x03, 0xf2, 0xbc, 0x00, 0x03, 0xf3, 0x24,
+  0x00, 0x03, 0xf3, 0x88, 0x00, 0x03, 0xf3, 0xc4, 0x00, 0x03, 0xf4, 0x00,
+  0x00, 0x03, 0xf4, 0x18, 0x00, 0x03, 0xf4, 0x30, 0x00, 0x03, 0xf4, 0x74,
+  0x00, 0x03, 0xf4, 0xbc, 0x00, 0x03, 0xf5, 0x04, 0x00, 0x03, 0xf5, 0x54,
+  0x00, 0x03, 0xf5, 0xcc, 0x00, 0x03, 0xf6, 0x48, 0x00, 0x03, 0xf6, 0xdc,
+  0x00, 0x03, 0xf7, 0x74, 0x00, 0x03, 0xf7, 0xf4, 0x00, 0x03, 0xf8, 0x3c,
+  0x00, 0x03, 0xf8, 0x80, 0x00, 0x03, 0xf8, 0xe4, 0x00, 0x03, 0xf9, 0x44,
+  0x00, 0x03, 0xf9, 0x98, 0x00, 0x03, 0xf9, 0xec, 0x00, 0x03, 0xfa, 0x64,
+  0x00, 0x03, 0xfa, 0xd8, 0x00, 0x03, 0xfb, 0xb8, 0x00, 0x03, 0xfc, 0x98,
+  0x00, 0x03, 0xfd, 0x68, 0x00, 0x03, 0xfe, 0x38, 0x00, 0x03, 0xfe, 0x84,
+  0x00, 0x03, 0xfe, 0xcc, 0x00, 0x03, 0xff, 0x14, 0x00, 0x03, 0xff, 0x5c,
+  0x00, 0x03, 0xff, 0xa4, 0x00, 0x03, 0xff, 0xec, 0x00, 0x04, 0x00, 0x44,
+  0x00, 0x04, 0x00, 0x6c, 0x00, 0x04, 0x00, 0x94, 0x00, 0x04, 0x00, 0xbc,
+  0x00, 0x04, 0x00, 0xe8, 0x00, 0x04, 0x01, 0x14, 0x00, 0x04, 0x01, 0x40,
+  0x00, 0x04, 0x01, 0x6c, 0x00, 0x04, 0x01, 0xa4, 0x00, 0x04, 0x01, 0xd8,
+  0x00, 0x04, 0x02, 0x0c, 0x00, 0x04, 0x02, 0x44, 0x00, 0x04, 0x02, 0x7c,
+  0x00, 0x04, 0x02, 0xb0, 0x00, 0x04, 0x02, 0xdc, 0x00, 0x04, 0x03, 0x08,
+  0x00, 0x04, 0x03, 0x34, 0x00, 0x04, 0x03, 0x5c, 0x00, 0x04, 0x03, 0x8c,
+  0x00, 0x04, 0x03, 0xbc, 0x00, 0x04, 0x03, 0xec, 0x00, 0x04, 0x04, 0x1c,
+  0x00, 0x04, 0x04, 0xc8, 0x00, 0x04, 0x04, 0xec, 0x00, 0x04, 0x05, 0x24,
+  0x00, 0x04, 0x05, 0x68, 0x00, 0x04, 0x05, 0x90, 0x00, 0x04, 0x05, 0xbc,
+  0x00, 0x04, 0x05, 0xf4, 0x00, 0x04, 0x06, 0x18, 0x00, 0x04, 0x06, 0x54,
+  0x00, 0x04, 0x06, 0x9c, 0x00, 0x04, 0x06, 0xdc, 0x00, 0x04, 0x07, 0x4c,
+  0x00, 0x04, 0x07, 0xa8, 0x00, 0x04, 0x08, 0x1c, 0x00, 0x04, 0x08, 0xcc,
+  0x00, 0x04, 0x09, 0x28, 0x00, 0x04, 0x09, 0x38, 0x00, 0x04, 0x09, 0x88,
+  0x00, 0x04, 0x09, 0xc4, 0x00, 0x04, 0x0a, 0x04, 0x00, 0x04, 0x0a, 0x38,
+  0x00, 0x04, 0x0a, 0x6c, 0x00, 0x04, 0x0a, 0xd4, 0x00, 0x04, 0x0b, 0x24,
+  0x00, 0x04, 0x0b, 0x5c, 0x00, 0x04, 0x0b, 0xb8, 0x00, 0x04, 0x0c, 0x04,
+  0x00, 0x04, 0x0c, 0x70, 0x00, 0x04, 0x0c, 0xd0, 0x00, 0x04, 0x0d, 0x30,
+  0x00, 0x04, 0x0d, 0x58, 0x00, 0x04, 0x0d, 0x80, 0x00, 0x04, 0x0e, 0x00,
+  0x00, 0x04, 0x0e, 0x4c, 0x00, 0x04, 0x0e, 0xc4, 0x00, 0x04, 0x0e, 0xf8,
+  0x00, 0x04, 0x0f, 0x0c, 0x00, 0x04, 0x0f, 0x38, 0x00, 0x04, 0x0f, 0xe4,
+  0x00, 0x04, 0x10, 0x3c, 0x00, 0x04, 0x10, 0x64, 0x00, 0x04, 0x10, 0x8c,
+  0x00, 0x04, 0x10, 0xb4, 0x00, 0x04, 0x10, 0xdc, 0x00, 0x04, 0x11, 0x04,
+  0x00, 0x04, 0x11, 0x2c, 0x00, 0x04, 0x11, 0x54, 0x00, 0x04, 0x11, 0x7c,
+  0x00, 0x04, 0x11, 0xa4, 0x00, 0x04, 0x11, 0xc8, 0x00, 0x04, 0x11, 0xe8,
+  0x00, 0x04, 0x12, 0x0c, 0x00, 0x04, 0x12, 0x30, 0x00, 0x04, 0x12, 0x54,
+  0x00, 0x04, 0x12, 0x74, 0x00, 0x04, 0x12, 0xa0, 0x00, 0x04, 0x12, 0xcc,
+  0x00, 0x04, 0x12, 0xf8, 0x00, 0x04, 0x13, 0x24, 0x00, 0x04, 0x13, 0x38,
+  0x00, 0x04, 0x13, 0x7c, 0x00, 0x04, 0x13, 0xc0, 0x00, 0x04, 0x13, 0xf0,
+  0x00, 0x04, 0x14, 0x20, 0x00, 0x04, 0x14, 0x64, 0x00, 0x04, 0x14, 0xbc,
+  0x00, 0x04, 0x15, 0x40, 0x00, 0x04, 0x15, 0xd0, 0x00, 0x04, 0x15, 0xe0,
+  0x00, 0x04, 0x16, 0x70, 0x00, 0x04, 0x16, 0x9c, 0x00, 0x04, 0x16, 0xac,
+  0x00, 0x04, 0x17, 0x0c, 0x00, 0x04, 0x17, 0xe4, 0x00, 0x04, 0x18, 0x68,
+  0x00, 0x04, 0x19, 0x14, 0x00, 0x04, 0x19, 0x70, 0x00, 0x04, 0x1a, 0x04,
+  0x00, 0x04, 0x1a, 0x4c, 0x00, 0x04, 0x1a, 0xc8, 0x00, 0x04, 0x1b, 0x24,
+  0x00, 0x04, 0x1b, 0xb4, 0x00, 0x04, 0x1c, 0x14, 0x00, 0x04, 0x1c, 0xa8,
+  0x00, 0x04, 0x1c, 0xb8, 0x00, 0x04, 0x1c, 0xc8, 0x00, 0x04, 0x1d, 0x10,
+  0x00, 0x04, 0x1d, 0x58, 0x00, 0x04, 0x1d, 0x84, 0x00, 0x04, 0x1d, 0xac,
+  0x00, 0x04, 0x1d, 0xdc, 0x00, 0x04, 0x1e, 0x08, 0x00, 0x04, 0x1e, 0x90,
+  0x00, 0x04, 0x1f, 0x14, 0x00, 0x04, 0x1f, 0xc8, 0x00, 0x04, 0x20, 0x68,
+  0x00, 0x04, 0x20, 0xc4, 0x00, 0x04, 0x21, 0x2c, 0x00, 0x04, 0x21, 0xa0,
+  0x00, 0x04, 0x22, 0x38, 0x00, 0x04, 0x22, 0xc0, 0x00, 0x04, 0x23, 0x28,
+  0x00, 0x04, 0x23, 0x80, 0x00, 0x04, 0x23, 0xe8, 0x00, 0x04, 0x24, 0x40,
+  0x00, 0x04, 0x24, 0xac, 0x00, 0x04, 0x24, 0xcc, 0x00, 0x04, 0x24, 0xec,
+  0x00, 0x04, 0x25, 0x34, 0x00, 0x04, 0x25, 0x78, 0x00, 0x04, 0x25, 0x88,
+  0x00, 0x04, 0x25, 0xb0, 0x00, 0x04, 0x25, 0xd4, 0x00, 0x04, 0x25, 0xf0,
+  0x00, 0x04, 0x26, 0x00, 0x00, 0x04, 0x26, 0x60, 0x00, 0x04, 0x26, 0x98,
+  0x00, 0x04, 0x26, 0xe4, 0x00, 0x04, 0x27, 0x6c, 0x00, 0x04, 0x28, 0x20,
+  0x00, 0x04, 0x28, 0x7c, 0x00, 0x04, 0x28, 0xd8, 0x00, 0x04, 0x29, 0x40,
+  0x00, 0x04, 0x29, 0xb0, 0x00, 0x04, 0x2a, 0x44, 0x00, 0x04, 0x2a, 0x9c,
+  0x00, 0x04, 0x2b, 0x30, 0x00, 0x04, 0x2b, 0xc4, 0x00, 0x04, 0x2c, 0x0c,
+  0x00, 0x04, 0x2c, 0x1c, 0x00, 0x04, 0x2c, 0x48, 0x00, 0x04, 0x2c, 0x8c,
+  0x00, 0x04, 0x2c, 0xc8, 0x00, 0x04, 0x2c, 0xe4, 0x00, 0x04, 0x2d, 0x30,
+  0x00, 0x04, 0x2d, 0x4c, 0x00, 0x04, 0x2d, 0x6c, 0x00, 0x04, 0x2d, 0x90,
+  0x00, 0x04, 0x2d, 0xb4, 0x00, 0x04, 0x2d, 0xd8, 0x00, 0x04, 0x2d, 0xf8,
+  0x00, 0x04, 0x2e, 0x0c, 0x00, 0x04, 0x2e, 0x20, 0x00, 0x04, 0x2e, 0x34,
+  0x00, 0x04, 0x2e, 0x48, 0x00, 0x04, 0x2e, 0x6c, 0x00, 0x04, 0x2e, 0x80,
+  0x00, 0x04, 0x2e, 0x94, 0x00, 0x04, 0x2e, 0xa8, 0x00, 0x04, 0x2e, 0xbc,
+  0x00, 0x04, 0x2e, 0xe0, 0x00, 0x04, 0x2e, 0xf4, 0x00, 0x04, 0x2f, 0x08,
+  0x00, 0x04, 0x2f, 0x1c, 0x00, 0x04, 0x2f, 0x30, 0x00, 0x04, 0x2f, 0x54,
+  0x00, 0x04, 0x2f, 0x68, 0x00, 0x04, 0x2f, 0x7c, 0x00, 0x04, 0x2f, 0x90,
+  0x00, 0x04, 0x2f, 0xa4, 0x00, 0x04, 0x2f, 0xbc, 0x00, 0x04, 0x30, 0x8c,
+  0x00, 0x04, 0x31, 0x5c, 0x00, 0x04, 0x32, 0x2c, 0x00, 0x04, 0x32, 0xfc,
+  0x00, 0x04, 0x33, 0x50, 0x00, 0x04, 0x33, 0xb8, 0x00, 0x04, 0x34, 0x2c,
+  0x00, 0x04, 0x34, 0xc8, 0x00, 0x04, 0x35, 0x20, 0x00, 0x04, 0x35, 0x90,
+  0x00, 0x04, 0x36, 0x14, 0x00, 0x04, 0x36, 0x90, 0x00, 0x04, 0x36, 0xe4,
+  0x00, 0x04, 0x37, 0x48, 0x00, 0x04, 0x37, 0xf4, 0x00, 0x04, 0x38, 0x60,
+  0x00, 0x04, 0x38, 0xc0, 0x00, 0x04, 0x39, 0x34, 0x00, 0x04, 0x39, 0x98,
+  0x00, 0x04, 0x39, 0xf0, 0x00, 0x04, 0x3a, 0x74, 0x00, 0x04, 0x3a, 0xc4,
+  0x00, 0x04, 0x3b, 0x44, 0x00, 0x04, 0x3b, 0xac, 0x00, 0x04, 0x3c, 0x54,
+  0x00, 0x04, 0x3c, 0xb4, 0x00, 0x04, 0x3d, 0x44, 0x00, 0x04, 0x3d, 0xac,
+  0x00, 0x04, 0x3e, 0x20, 0x00, 0x04, 0x3e, 0x88, 0x00, 0x04, 0x3f, 0x04,
+  0x00, 0x04, 0x3f, 0x58, 0x00, 0x04, 0x3f, 0xcc, 0x00, 0x04, 0x40, 0x44,
+  0x00, 0x04, 0x40, 0x98, 0x00, 0x04, 0x41, 0x0c, 0x00, 0x04, 0x41, 0x7c,
+  0x00, 0x04, 0x41, 0xf4, 0x00, 0x04, 0x42, 0x68, 0x00, 0x04, 0x42, 0xcc,
+  0x00, 0x04, 0x43, 0x38, 0x00, 0x04, 0x43, 0xbc, 0x00, 0x04, 0x44, 0x4c,
+  0x00, 0x04, 0x44, 0xd8, 0x00, 0x04, 0x45, 0xa4, 0x00, 0x04, 0x45, 0xf8,
+  0x00, 0x04, 0x46, 0x58, 0x00, 0x04, 0x46, 0xc8, 0x00, 0x04, 0x47, 0x1c,
+  0x00, 0x04, 0x47, 0x80, 0x00, 0x04, 0x47, 0xe4, 0x00, 0x04, 0x48, 0x44,
+  0x00, 0x04, 0x48, 0xa4, 0x00, 0x04, 0x49, 0x14, 0x00, 0x04, 0x49, 0x84,
+  0x00, 0x04, 0x49, 0xdc, 0x00, 0x04, 0x4a, 0x34, 0x00, 0x04, 0x4a, 0x98,
+  0x00, 0x04, 0x4b, 0x0c, 0x00, 0x04, 0x4b, 0x8c, 0x00, 0x04, 0x4c, 0x1c,
+  0x00, 0x04, 0x4c, 0x90, 0x00, 0x04, 0x4d, 0x14, 0x00, 0x04, 0x4d, 0x8c,
+  0x00, 0x04, 0x4e, 0x10, 0x00, 0x04, 0x4e, 0xa0, 0x00, 0x04, 0x4f, 0x18,
+  0x00, 0x04, 0x4f, 0xa0, 0x00, 0x04, 0x50, 0x24, 0x00, 0x04, 0x50, 0x94,
+  0x00, 0x04, 0x50, 0xfc, 0x00, 0x04, 0x51, 0x50, 0x00, 0x04, 0x51, 0x98,
+  0x00, 0x04, 0x52, 0x1c, 0x00, 0x04, 0x52, 0x8c, 0x00, 0x04, 0x53, 0x0c,
+  0x00, 0x04, 0x54, 0x04, 0x00, 0x04, 0x54, 0x2c, 0x00, 0x04, 0x54, 0x54,
+  0x00, 0x04, 0x54, 0x9c, 0x00, 0x04, 0x54, 0xe4, 0x00, 0x04, 0x54, 0xe4,
+  0x00, 0x04, 0x54, 0xe4, 0x00, 0x04, 0x54, 0xe4, 0x00, 0x04, 0x54, 0xe4,
+  0x00, 0x04, 0x55, 0x70, 0x00, 0x04, 0x55, 0xa8, 0x00, 0x04, 0x56, 0x20,
+  0x00, 0x04, 0x56, 0x4c, 0x00, 0x04, 0x56, 0x9c, 0x00, 0x04, 0x56, 0xdc,
+  0x00, 0x04, 0x57, 0x0c, 0x00, 0x04, 0x57, 0x38, 0x00, 0x04, 0x57, 0x74,
+  0x00, 0x04, 0x58, 0x0c, 0x00, 0x04, 0x58, 0x28, 0x00, 0x04, 0x58, 0x60,
+  0x00, 0x04, 0x58, 0x88, 0x00, 0x04, 0x58, 0xc8, 0x00, 0x04, 0x58, 0xf8,
+  0x00, 0x04, 0x59, 0x54, 0x00, 0x04, 0x59, 0xe4, 0x00, 0x04, 0x5a, 0x2c,
+  0x00, 0x04, 0x5a, 0x64, 0x00, 0x04, 0x5a, 0xcc, 0x00, 0x04, 0x5b, 0x20,
+  0x00, 0x04, 0x5b, 0x58, 0x00, 0x04, 0x5b, 0x84, 0x00, 0x04, 0x5b, 0xac,
+  0x00, 0x04, 0x5b, 0xf0, 0x00, 0x04, 0x5c, 0x6c, 0x00, 0x04, 0x5c, 0xa4,
+  0x00, 0x04, 0x5d, 0x24, 0x00, 0x04, 0x5d, 0x68, 0x00, 0x04, 0x5d, 0xb0,
+  0x00, 0x04, 0x5d, 0xd4, 0x00, 0x04, 0x5e, 0x1c, 0x00, 0x04, 0x5e, 0x2c,
+  0x00, 0x04, 0x5e, 0x58, 0x00, 0x04, 0x5e, 0x68, 0x00, 0x04, 0x5e, 0x9c,
+  0x00, 0x04, 0x5e, 0xd4, 0x00, 0x04, 0x5e, 0xf0, 0x00, 0x04, 0x5f, 0x0c,
+  0x00, 0x04, 0x5f, 0x28, 0x00, 0x04, 0x5f, 0x44, 0x00, 0x04, 0x5f, 0x60,
+  0x00, 0x04, 0x5f, 0x88, 0x00, 0x04, 0x5f, 0xb0, 0x00, 0x04, 0x5f, 0xdc,
+  0x00, 0x04, 0x60, 0x04, 0x00, 0x04, 0x60, 0x2c, 0x00, 0x04, 0x60, 0x58,
+  0x00, 0x04, 0x60, 0x80, 0x00, 0x04, 0x60, 0xa8, 0x00, 0x04, 0x60, 0xd0,
+  0x00, 0x04, 0x60, 0xf8, 0x00, 0x04, 0x61, 0x20, 0x00, 0x04, 0x61, 0x4c,
+  0x00, 0x04, 0x61, 0x74, 0x00, 0x04, 0x61, 0x9c, 0x00, 0x04, 0x61, 0xc8,
+  0x00, 0x04, 0x61, 0xf0, 0x00, 0x04, 0x62, 0x18, 0x00, 0x04, 0x62, 0x40,
+  0x00, 0x04, 0x62, 0x68, 0x00, 0x04, 0x62, 0x90, 0x00, 0x04, 0x62, 0xbc,
+  0x00, 0x04, 0x62, 0xe4, 0x00, 0x04, 0x63, 0x0c, 0x00, 0x04, 0x63, 0x38,
+  0x00, 0x04, 0x63, 0x60, 0x00, 0x04, 0x63, 0x88, 0x00, 0x04, 0x63, 0xb0,
+  0x00, 0x04, 0x63, 0xd8, 0x00, 0x04, 0x64, 0x00, 0x00, 0x04, 0x64, 0x2c,
+  0x00, 0x04, 0x64, 0x54, 0x00, 0x04, 0x64, 0x7c, 0x00, 0x04, 0x64, 0xa8,
+  0x00, 0x04, 0x64, 0xd0, 0x00, 0x04, 0x64, 0xf8, 0x00, 0x04, 0x65, 0x20,
+  0x00, 0x04, 0x65, 0x48, 0x00, 0x04, 0x65, 0x70, 0x00, 0x04, 0x65, 0x9c,
+  0x00, 0x04, 0x65, 0xc4, 0x00, 0x04, 0x65, 0xec, 0x00, 0x04, 0x66, 0x18,
+  0x00, 0x04, 0x66, 0x40, 0x00, 0x04, 0x66, 0x68, 0x00, 0x04, 0x66, 0x90,
+  0x00, 0x04, 0x66, 0xb8, 0x00, 0x04, 0x66, 0xe0, 0x00, 0x04, 0x67, 0x0c,
+  0x00, 0x04, 0x67, 0x34, 0x00, 0x04, 0x67, 0x5c, 0x00, 0x04, 0x67, 0x88,
+  0x00, 0x04, 0x67, 0xb0, 0x00, 0x04, 0x67, 0xd8, 0x00, 0x04, 0x68, 0x00,
+  0x00, 0x04, 0x68, 0x28, 0x00, 0x04, 0x68, 0x50, 0x00, 0x04, 0x68, 0x7c,
+  0x00, 0x04, 0x68, 0xa4, 0x00, 0x04, 0x68, 0xcc, 0x00, 0x04, 0x68, 0xf8,
+  0x00, 0x04, 0x69, 0x20, 0x00, 0x04, 0x69, 0x48, 0x00, 0x04, 0x69, 0x70,
+  0x00, 0x04, 0x69, 0x98, 0x00, 0x04, 0x69, 0xc0, 0x00, 0x04, 0x69, 0xec,
+  0x00, 0x04, 0x6a, 0x14, 0x00, 0x04, 0x6a, 0x3c, 0x00, 0x04, 0x6a, 0x68,
+  0x00, 0x04, 0x6a, 0x90, 0x00, 0x04, 0x6a, 0xb8, 0x00, 0x04, 0x6a, 0xe0,
+  0x00, 0x04, 0x6b, 0x08, 0x00, 0x04, 0x6b, 0x30, 0x00, 0x04, 0x6b, 0x5c,
+  0x00, 0x04, 0x6b, 0x84, 0x00, 0x04, 0x6b, 0xac, 0x00, 0x04, 0x6b, 0xd8,
+  0x00, 0x04, 0x6c, 0x00, 0x00, 0x04, 0x6c, 0x28, 0x00, 0x04, 0x6c, 0x50,
+  0x00, 0x04, 0x6c, 0x9c, 0x00, 0x04, 0x6d, 0x2c, 0x00, 0x04, 0x6d, 0x98,
+  0x00, 0x04, 0x6d, 0xd8, 0x00, 0x04, 0x6e, 0x14, 0x00, 0x04, 0x6e, 0x9c,
+  0x00, 0x04, 0x6e, 0xd8, 0x00, 0x04, 0x6f, 0x24, 0x00, 0x04, 0x6f, 0x68,
+  0x00, 0x04, 0x6f, 0x98, 0x00, 0x04, 0x6f, 0xf4, 0x00, 0x04, 0x70, 0x8c,
+  0x00, 0x04, 0x71, 0x28, 0x00, 0x04, 0x71, 0x60, 0x00, 0x04, 0x71, 0xd4,
+  0x00, 0x04, 0x72, 0x10, 0x00, 0x04, 0x72, 0x78, 0x00, 0x04, 0x72, 0xcc,
+  0x00, 0x04, 0x73, 0x14, 0x00, 0x04, 0x73, 0xb8, 0x00, 0x04, 0x74, 0x54,
+  0x00, 0x04, 0x74, 0xcc, 0x00, 0x04, 0x75, 0x68, 0x00, 0x04, 0x75, 0xdc,
+  0x00, 0x04, 0x76, 0x44, 0x00, 0x04, 0x77, 0x0c, 0x00, 0x04, 0x77, 0x80,
+  0x00, 0x04, 0x77, 0xb8, 0x00, 0x04, 0x78, 0x14, 0x00, 0x04, 0x78, 0x58,
+  0x00, 0x04, 0x78, 0xa4, 0x00, 0x04, 0x79, 0x60, 0x00, 0x04, 0x79, 0xd4,
+  0x00, 0x04, 0x7a, 0x5c, 0x00, 0x04, 0x7a, 0xf8, 0x00, 0x04, 0x7b, 0x94,
+  0x00, 0x04, 0x7b, 0xe0, 0x00, 0x04, 0x7c, 0xac, 0x00, 0x04, 0x7d, 0x08,
+  0x00, 0x04, 0x7d, 0x7c, 0x00, 0x04, 0x7d, 0xb8, 0x00, 0x04, 0x7e, 0x14,
+  0x00, 0x04, 0x7e, 0x68, 0x00, 0x04, 0x7e, 0xb8, 0x00, 0x04, 0x7e, 0xfc,
+  0x00, 0x04, 0x7f, 0x0c, 0x00, 0x04, 0x7f, 0x1c, 0x00, 0x04, 0x7f, 0x2c,
+  0x00, 0x04, 0x7f, 0x3c, 0x00, 0x04, 0x7f, 0x4c, 0x00, 0x04, 0x7f, 0x5c,
+  0x00, 0x04, 0x7f, 0x6c, 0x00, 0x04, 0x7f, 0x7c, 0x00, 0x04, 0x7f, 0x8c,
+  0x00, 0x04, 0x7f, 0x9c, 0x00, 0x04, 0x7f, 0xac, 0x00, 0x04, 0x7f, 0xbc,
+  0x00, 0x04, 0x7f, 0xcc, 0x00, 0x04, 0x7f, 0xdc, 0x00, 0x04, 0x7f, 0xec,
+  0x00, 0x04, 0x7f, 0xfc, 0x00, 0x04, 0x80, 0x0c, 0x00, 0x04, 0x80, 0x1c,
+  0x00, 0x04, 0x80, 0x2c, 0x00, 0x04, 0x80, 0x3c, 0x00, 0x04, 0x80, 0x4c,
+  0x00, 0x04, 0x80, 0x5c, 0x00, 0x04, 0x80, 0x6c, 0x00, 0x04, 0x80, 0x7c,
+  0x00, 0x04, 0x80, 0x8c, 0x00, 0x04, 0x80, 0x9c, 0x00, 0x04, 0x80, 0xac,
+  0x00, 0x04, 0x80, 0xbc, 0x00, 0x04, 0x80, 0xcc, 0x00, 0x04, 0x80, 0xdc,
+  0x00, 0x04, 0x80, 0xec, 0x00, 0x04, 0x80, 0xfc, 0x00, 0x04, 0x81, 0x0c,
+  0x00, 0x04, 0x81, 0x1c, 0x00, 0x04, 0x81, 0x2c, 0x00, 0x04, 0x81, 0x3c,
+  0x00, 0x04, 0x81, 0x4c, 0x00, 0x04, 0x81, 0x5c, 0x00, 0x04, 0x81, 0x6c,
+  0x00, 0x04, 0x81, 0x7c, 0x00, 0x04, 0x81, 0x8c, 0x00, 0x04, 0x81, 0x9c,
+  0x00, 0x04, 0x81, 0xac, 0x00, 0x04, 0x81, 0xbc, 0x00, 0x04, 0x81, 0xcc,
+  0x00, 0x04, 0x81, 0xdc, 0x00, 0x04, 0x81, 0xec, 0x00, 0x04, 0x81, 0xfc,
+  0x00, 0x04, 0x82, 0x0c, 0x00, 0x04, 0x82, 0x1c, 0x00, 0x04, 0x82, 0x2c,
+  0x00, 0x04, 0x82, 0x3c, 0x00, 0x04, 0x82, 0xa8, 0x00, 0x04, 0x82, 0xe8,
+  0x00, 0x04, 0x83, 0x74, 0x00, 0x04, 0x84, 0x04, 0x00, 0x04, 0x84, 0x50,
+  0x00, 0x04, 0x84, 0xc0, 0x00, 0x04, 0x85, 0x48, 0x00, 0x04, 0x85, 0x84,
+  0x00, 0x04, 0x86, 0x5c, 0x00, 0x04, 0x86, 0xe8, 0x00, 0x04, 0x86, 0xf8,
+  0x00, 0x04, 0x87, 0x08, 0x00, 0x04, 0x87, 0x18, 0x00, 0x04, 0x87, 0x28,
+  0x00, 0x04, 0x87, 0x38, 0x00, 0x04, 0x87, 0x48, 0x00, 0x04, 0x87, 0x58,
+  0x00, 0x04, 0x87, 0x68, 0x00, 0x04, 0x87, 0x78, 0x00, 0x04, 0x87, 0x88,
+  0x00, 0x04, 0x87, 0xb4, 0x00, 0x04, 0x87, 0xec, 0x00, 0x04, 0x88, 0x68,
+  0x00, 0x04, 0x89, 0x24, 0x00, 0x04, 0x8a, 0x20, 0x00, 0x04, 0x8b, 0x5c,
+  0x00, 0x04, 0x8c, 0xd8, 0x00, 0x04, 0x8e, 0x8c, 0x00, 0x04, 0x8f, 0x08,
+  0x00, 0x04, 0x8f, 0xc4, 0x00, 0x04, 0x90, 0xc4, 0x00, 0x04, 0x92, 0x00,
+  0x00, 0x04, 0x93, 0x7c, 0x00, 0x04, 0x95, 0x38, 0x00, 0x04, 0x97, 0x2c,
+  0x00, 0x04, 0x97, 0xe8, 0x00, 0x04, 0x98, 0xe4, 0x00, 0x04, 0x9a, 0x20,
+  0x00, 0x04, 0x9b, 0x9c, 0x00, 0x04, 0x9d, 0x4c, 0x00, 0x04, 0x9f, 0x48,
+  0x00, 0x04, 0xa1, 0x7c, 0x00, 0x04, 0xa2, 0x78, 0x00, 0x04, 0xa3, 0xb4,
+  0x00, 0x04, 0xa5, 0x34, 0x00, 0x04, 0xa6, 0xf0, 0x00, 0x04, 0xa8, 0xec,
+  0x00, 0x04, 0xab, 0x28, 0x00, 0x04, 0xad, 0x9c, 0x00, 0x04, 0xae, 0xd0,
+  0x00, 0x04, 0xb0, 0x44, 0x00, 0x04, 0xb2, 0x04, 0x00, 0x04, 0xb4, 0x00,
+  0x00, 0x04, 0xb6, 0x3c, 0x00, 0x04, 0xb8, 0xb8, 0x00, 0x04, 0xbb, 0x6c,
+  0x00, 0x04, 0xbc, 0xe4, 0x00, 0x04, 0xbe, 0xa0, 0x00, 0x04, 0xc0, 0x9c,
+  0x00, 0x04, 0xc2, 0xd8, 0x00, 0x04, 0xc5, 0x54, 0x00, 0x04, 0xc8, 0x10,
+  0x00, 0x04, 0xcb, 0x04, 0x00, 0x04, 0xcc, 0xc4, 0x00, 0x04, 0xce, 0xcc,
+  0x00, 0x04, 0xd1, 0x14, 0x00, 0x04, 0xd3, 0x9c, 0x00, 0x04, 0xd6, 0x60,
+  0x00, 0x04, 0xd9, 0x64, 0x00, 0x04, 0xdc, 0x94, 0x00, 0x04, 0xdc, 0xc0,
+  0x00, 0x04, 0xdc, 0xf8, 0x00, 0x04, 0xdd, 0x74, 0x00, 0x04, 0xde, 0x30,
+  0x00, 0x04, 0xdf, 0x28, 0x00, 0x04, 0xe0, 0x64, 0x00, 0x04, 0xe1, 0xe0,
+  0x00, 0x04, 0xe3, 0x94, 0x00, 0x04, 0xe4, 0x10, 0x00, 0x04, 0xe4, 0xcc,
+  0x00, 0x04, 0xe5, 0xcc, 0x00, 0x04, 0xe7, 0x08, 0x00, 0x04, 0xe8, 0x84,
+  0x00, 0x04, 0xea, 0x40, 0x00, 0x04, 0xec, 0x34, 0x00, 0x04, 0xec, 0xf0,
+  0x00, 0x04, 0xed, 0xec, 0x00, 0x04, 0xef, 0x28, 0x00, 0x04, 0xf0, 0xa0,
+  0x00, 0x04, 0xf2, 0x5c, 0x00, 0x04, 0xf4, 0x58, 0x00, 0x04, 0xf6, 0x8c,
+  0x00, 0x04, 0xf7, 0x84, 0x00, 0x04, 0xf8, 0xc0, 0x00, 0x04, 0xfa, 0x3c,
+  0x00, 0x04, 0xfb, 0xf8, 0x00, 0x04, 0xfd, 0xf0, 0x00, 0x05, 0x00, 0x2c,
+  0x00, 0x05, 0x02, 0x9c, 0x00, 0x05, 0x03, 0xd0, 0x00, 0x05, 0x05, 0x44,
+  0x00, 0x05, 0x07, 0x00, 0x00, 0x05, 0x08, 0xfc, 0x00, 0x05, 0x0b, 0x38,
+  0x00, 0x05, 0x0d, 0xa4, 0x00, 0x05, 0x10, 0x58, 0x00, 0x05, 0x11, 0xd0,
+  0x00, 0x05, 0x13, 0x8c, 0x00, 0x05, 0x15, 0x7c, 0x00, 0x05, 0x17, 0xb8,
+  0x00, 0x05, 0x1a, 0x34, 0x00, 0x05, 0x1c, 0xf0, 0x00, 0x05, 0x1f, 0xe4,
+  0x00, 0x05, 0x21, 0xa8, 0x00, 0x05, 0x23, 0xb0, 0x00, 0x05, 0x25, 0xf8,
+  0x00, 0x05, 0x28, 0x7c, 0x00, 0x05, 0x2b, 0x40, 0x00, 0x05, 0x2e, 0x30,
+  0x00, 0x05, 0x31, 0x60, 0x00, 0x05, 0x31, 0xbc, 0x00, 0x05, 0x32, 0x78,
+  0x00, 0x05, 0x33, 0x54, 0x00, 0x05, 0x34, 0x50, 0x00, 0x05, 0x35, 0x10,
+  0x00, 0x05, 0x35, 0xfc, 0x00, 0x05, 0x37, 0x14, 0x00, 0x05, 0x37, 0xc0,
+  0x00, 0x05, 0x38, 0xf4, 0x00, 0x05, 0x3a, 0x08, 0x00, 0x05, 0x3a, 0xf8,
+  0x00, 0x05, 0x3b, 0xac, 0x00, 0x05, 0x3c, 0x84, 0x00, 0x05, 0x3d, 0x64,
+  0x00, 0x05, 0x3e, 0x20, 0x00, 0x05, 0x3e, 0xd8, 0x00, 0x05, 0x3f, 0xb0,
+  0x00, 0x05, 0x40, 0xa8, 0x00, 0x05, 0x41, 0x64, 0x00, 0x05, 0x42, 0x4c,
+  0x00, 0x05, 0x43, 0x60, 0x00, 0x05, 0x44, 0x08, 0x00, 0x05, 0x45, 0x38,
+  0x00, 0x05, 0x46, 0x48, 0x00, 0x05, 0x47, 0x34, 0x00, 0x05, 0x47, 0xe4,
+  0x00, 0x05, 0x48, 0xb8, 0x00, 0x05, 0x49, 0x94, 0x00, 0x05, 0x4a, 0x4c,
+  0x00, 0x05, 0x4a, 0xd8, 0x00, 0x05, 0x4b, 0x88, 0x00, 0x05, 0x4c, 0x58,
+  0x00, 0x05, 0x4c, 0xe8, 0x00, 0x05, 0x4d, 0xa4, 0x00, 0x05, 0x4e, 0x8c,
+  0x00, 0x05, 0x4f, 0x0c, 0x00, 0x05, 0x50, 0x14, 0x00, 0x05, 0x50, 0xfc,
+  0x00, 0x05, 0x51, 0xc0, 0x00, 0x05, 0x52, 0x48, 0x00, 0x05, 0x52, 0xf4,
+  0x00, 0x05, 0x53, 0xa8, 0x00, 0x05, 0x54, 0x34, 0x00, 0x05, 0x54, 0xb0,
+  0x00, 0x05, 0x55, 0x84, 0x00, 0x05, 0x56, 0x7c, 0x00, 0x05, 0x57, 0x94,
+  0x00, 0x05, 0x58, 0x6c, 0x00, 0x05, 0x59, 0x70, 0x00, 0x05, 0x5a, 0xa0,
+  0x00, 0x05, 0x5b, 0x68, 0x00, 0x05, 0x5c, 0xb8, 0x00, 0x05, 0x5d, 0xe8,
+  0x00, 0x05, 0x5e, 0xf4, 0x00, 0x05, 0x5f, 0xc4, 0x00, 0x05, 0x60, 0xb8,
+  0x00, 0x05, 0x61, 0xb4, 0x00, 0x05, 0x62, 0x88, 0x00, 0x05, 0x63, 0x28,
+  0x00, 0x05, 0x65, 0x30, 0x00, 0x05, 0x68, 0x14, 0x00, 0x05, 0x6a, 0x3c,
+  0x00, 0x05, 0x6c, 0x58, 0x00, 0x05, 0x6d, 0x58, 0x00, 0x05, 0x6e, 0x58,
+  0x00, 0x05, 0x6f, 0xf0, 0x00, 0x05, 0x70, 0xd0, 0x00, 0x05, 0x71, 0xb0,
+  0x00, 0x05, 0x72, 0xb4, 0x00, 0x05, 0x73, 0x88, 0x00, 0x05, 0x74, 0xc0,
+  0x00, 0x05, 0x75, 0xcc, 0x00, 0x05, 0x76, 0xa4, 0x00, 0x05, 0x77, 0x84,
+  0x00, 0x05, 0x78, 0x90, 0x00, 0x05, 0x79, 0x70, 0x00, 0x05, 0x7a, 0x98,
+  0x00, 0x05, 0x7b, 0x6c, 0x00, 0x05, 0x7c, 0x10, 0x00, 0x05, 0x7c, 0xc8,
+  0x00, 0x05, 0x7d, 0x5c, 0x00, 0x05, 0x7e, 0x1c, 0x00, 0x05, 0x7f, 0x10,
+  0x00, 0x05, 0x7f, 0xc8, 0x00, 0x05, 0x80, 0x80, 0x00, 0x05, 0x81, 0x74,
+  0x00, 0x05, 0x82, 0x48, 0x00, 0x05, 0x83, 0x5c, 0x00, 0x05, 0x84, 0x30,
+  0x00, 0x05, 0x85, 0x04, 0x00, 0x05, 0x85, 0xdc, 0x00, 0x05, 0x86, 0xac,
+  0x00, 0x05, 0x87, 0x78, 0x00, 0x05, 0x88, 0x78, 0x00, 0x05, 0x89, 0xa8,
+  0x00, 0x05, 0x8a, 0xa8, 0x00, 0x05, 0x8b, 0xdc, 0x00, 0x05, 0x8c, 0xec,
+  0x00, 0x05, 0x8d, 0xc0, 0x00, 0x05, 0x8e, 0xa0, 0x00, 0x05, 0x8f, 0x80,
+  0x00, 0x05, 0x90, 0x7c, 0x00, 0x05, 0x92, 0x78, 0x00, 0x05, 0x93, 0x5c,
+  0x00, 0x05, 0x94, 0x70, 0x00, 0x05, 0x95, 0x44, 0x00, 0x05, 0x96, 0x90,
+  0x00, 0x05, 0x97, 0x54, 0x00, 0x05, 0x98, 0x34, 0x00, 0x05, 0x99, 0x30,
+  0x00, 0x05, 0x9a, 0xf8, 0x00, 0x05, 0x9c, 0x38, 0x00, 0x05, 0x9d, 0xb4,
+  0x00, 0x05, 0x9e, 0xd4, 0x00, 0x05, 0x9f, 0xa8, 0x00, 0x05, 0xa0, 0x50,
+  0x00, 0x05, 0xa1, 0x30, 0x00, 0x05, 0xa3, 0x74, 0x00, 0x05, 0xa5, 0xf4,
+  0x00, 0x05, 0xa8, 0x60, 0x00, 0x05, 0xaa, 0x68, 0x00, 0x05, 0xac, 0xa0,
+  0x00, 0x05, 0xae, 0xdc, 0x00, 0x05, 0xb1, 0x2c, 0x00, 0x05, 0xb2, 0xec,
+  0x00, 0x05, 0xb4, 0xa8, 0x00, 0x05, 0xb4, 0xc4, 0x00, 0x05, 0xb4, 0xec,
+  0x00, 0x05, 0xb5, 0x08, 0x00, 0x05, 0xb5, 0x64, 0x00, 0x05, 0xb5, 0x84,
+  0x00, 0x05, 0xb5, 0xa8, 0x00, 0x05, 0xb5, 0xd0, 0x00, 0x05, 0xb6, 0x04,
+  0x00, 0x05, 0xb6, 0x38, 0x00, 0x05, 0xb6, 0x54, 0x00, 0x05, 0xb6, 0x7c,
+  0x00, 0x05, 0xb6, 0xa8, 0x00, 0x05, 0xb6, 0xc0, 0x00, 0x05, 0xb6, 0xe4,
+  0x00, 0x05, 0xb7, 0x14, 0x00, 0x05, 0xb7, 0x44, 0x00, 0x05, 0xb7, 0x68,
+  0x00, 0x05, 0xb7, 0xa0, 0x00, 0x05, 0xb8, 0x18, 0x00, 0x05, 0xb8, 0x48,
+  0x00, 0x05, 0xb8, 0x88, 0x00, 0x05, 0xb9, 0x44, 0x00, 0x05, 0xb9, 0xe0,
+  0x00, 0x05, 0xba, 0x80, 0x00, 0x05, 0xbb, 0x44, 0x00, 0x05, 0xbb, 0x54,
+  0x00, 0x05, 0xbb, 0x64, 0x00, 0x05, 0xbb, 0x7c, 0x00, 0x05, 0xbb, 0x94,
+  0x00, 0x05, 0xbb, 0xe4, 0x00, 0x05, 0xbc, 0x04, 0x00, 0x05, 0xbc, 0x24,
+  0x00, 0x05, 0xbc, 0x44, 0x00, 0x05, 0xbc, 0x5c, 0x00, 0x05, 0xbc, 0x74,
+  0x00, 0x05, 0xbc, 0x8c, 0x00, 0x05, 0xbd, 0x64, 0x00, 0x05, 0xbe, 0x10,
+  0x00, 0x05, 0xbe, 0xd8, 0x00, 0x05, 0xbf, 0x84, 0x00, 0x05, 0xc0, 0x00,
+  0x00, 0x05, 0xc0, 0x98, 0x00, 0x05, 0xc1, 0x4c, 0x00, 0x05, 0xc1, 0xd4,
+  0x00, 0x05, 0xc2, 0x78, 0x00, 0x05, 0xc3, 0x3c, 0x00, 0x05, 0xc3, 0xd0,
+  0x00, 0x05, 0xc4, 0x80, 0x00, 0x05, 0xc4, 0xa0, 0x00, 0x05, 0xc4, 0xe8,
+  0x00, 0x05, 0xc5, 0x14, 0x00, 0x05, 0xc5, 0x64, 0x00, 0x05, 0xc5, 0x80,
+  0x00, 0x05, 0xc5, 0x9c, 0x00, 0x05, 0xc5, 0xb8, 0x00, 0x05, 0xc5, 0xd4,
+  0x00, 0x05, 0xc5, 0xf0, 0x00, 0x05, 0xc6, 0x0c, 0x00, 0x05, 0xc6, 0x28,
+  0x00, 0x05, 0xc6, 0x44, 0x00, 0x05, 0xc6, 0x60, 0x00, 0x05, 0xc6, 0x7c,
+  0x00, 0x05, 0xc6, 0x98, 0x00, 0x05, 0xc6, 0xb4, 0x00, 0x05, 0xc6, 0xd0,
+  0x00, 0x05, 0xc6, 0xec, 0x00, 0x05, 0xc7, 0x08, 0x00, 0x05, 0xc7, 0x24,
+  0x00, 0x05, 0xc7, 0x40, 0x00, 0x05, 0xc7, 0x5c, 0x00, 0x05, 0xc7, 0x78,
+  0x00, 0x05, 0xc7, 0x94, 0x00, 0x05, 0xc7, 0xac, 0x00, 0x05, 0xc7, 0xc8,
+  0x00, 0x05, 0xc8, 0x00, 0x00, 0x05, 0xc8, 0x70, 0x00, 0x05, 0xc8, 0xc4,
+  0x00, 0x05, 0xc9, 0x4c, 0x00, 0x05, 0xc9, 0x98, 0x00, 0x05, 0xc9, 0xf4,
+  0x00, 0x05, 0xca, 0xb0, 0x00, 0x05, 0xcb, 0x10, 0x00, 0x05, 0xcb, 0x80,
+  0x00, 0x05, 0xcb, 0xec, 0x00, 0x05, 0xcc, 0x18, 0x00, 0x05, 0xcc, 0x90,
+  0x00, 0x05, 0xcc, 0xa0, 0x00, 0x05, 0xcc, 0xb0, 0x00, 0x05, 0xcc, 0xc8,
+  0x00, 0x05, 0xcc, 0xf4, 0x00, 0x05, 0xcd, 0x4c, 0x00, 0x05, 0xcd, 0x64,
+  0x00, 0x05, 0xcd, 0x7c, 0x00, 0x05, 0xcd, 0xa0, 0x00, 0x05, 0xcd, 0xcc,
+  0x00, 0x05, 0xcd, 0xe8, 0x00, 0x05, 0xce, 0x80, 0x00, 0x05, 0xcf, 0x8c,
+  0x00, 0x05, 0xd0, 0x24, 0x00, 0x05, 0xd0, 0xac, 0x00, 0x05, 0xd1, 0xa4,
+  0x00, 0x05, 0xd2, 0x2c, 0x00, 0x05, 0xd2, 0x8c, 0x00, 0x05, 0xd3, 0x5c,
+  0x00, 0x05, 0xd3, 0x78, 0x00, 0x05, 0xd3, 0x9c, 0x00, 0x05, 0xd3, 0xbc,
+  0x00, 0x05, 0xd4, 0x0c, 0x00, 0x05, 0xd4, 0x64, 0x00, 0x05, 0xd4, 0xb4,
+  0x00, 0x05, 0xd4, 0xe8, 0x00, 0x05, 0xd5, 0x20, 0x00, 0x05, 0xd5, 0x50,
+  0x00, 0x05, 0xd5, 0x80, 0x00, 0x05, 0xd5, 0xb0, 0x00, 0x05, 0xd5, 0xdc,
+  0x00, 0x05, 0xd6, 0x08, 0x00, 0x05, 0xd6, 0x38, 0x00, 0x05, 0xd6, 0x60,
+  0x00, 0x05, 0xd6, 0x88, 0x00, 0x05, 0xd6, 0xb0, 0x00, 0x05, 0xd6, 0xd8,
+  0x00, 0x05, 0xd7, 0x44, 0x00, 0x05, 0xd7, 0xb4, 0x00, 0x05, 0xd8, 0x20,
+  0x00, 0x05, 0xd8, 0x54, 0x00, 0x05, 0xd8, 0x88, 0x00, 0x05, 0xd8, 0xbc,
+  0x00, 0x05, 0xd9, 0x1c, 0x00, 0x05, 0xd9, 0x84, 0x00, 0x05, 0xd9, 0xe8,
+  0x00, 0x05, 0xda, 0x18, 0x00, 0x05, 0xda, 0x4c, 0x00, 0x05, 0xda, 0x7c,
+  0x00, 0x05, 0xda, 0xac, 0x00, 0x05, 0xda, 0xe0, 0x00, 0x05, 0xdb, 0x10,
+  0x00, 0x05, 0xdb, 0x64, 0x00, 0x05, 0xdb, 0xb8, 0x00, 0x05, 0xdc, 0x10,
+  0x00, 0x05, 0xdc, 0x5c, 0x00, 0x05, 0xdc, 0xac, 0x00, 0x05, 0xdc, 0xf8,
+  0x00, 0x05, 0xdd, 0x20, 0x00, 0x05, 0xdd, 0x4c, 0x00, 0x05, 0xdd, 0x74,
+  0x00, 0x05, 0xdd, 0xe8, 0x00, 0x05, 0xde, 0x60, 0x00, 0x05, 0xde, 0xd0,
+  0x00, 0x05, 0xdf, 0x04, 0x00, 0x05, 0xdf, 0x3c, 0x00, 0x05, 0xdf, 0x70,
+  0x00, 0x05, 0xdf, 0xc0, 0x00, 0x05, 0xe0, 0x14, 0x00, 0x05, 0xe0, 0x64,
+  0x00, 0x05, 0xe0, 0x94, 0x00, 0x05, 0xe0, 0xc8, 0x00, 0x05, 0xe0, 0xf8,
+  0x00, 0x05, 0xe1, 0x2c, 0x00, 0x05, 0xe1, 0x64, 0x00, 0x05, 0xe1, 0x98,
+  0x00, 0x05, 0xe2, 0x08, 0x00, 0x05, 0xe2, 0x7c, 0x00, 0x05, 0xe2, 0xec,
+  0x00, 0x05, 0xe3, 0x20, 0x00, 0x05, 0xe3, 0x58, 0x00, 0x05, 0xe3, 0x8c,
+  0x00, 0x05, 0xe3, 0xf4, 0x00, 0x05, 0xe4, 0x60, 0x00, 0x05, 0xe4, 0xc8,
+  0x00, 0x05, 0xe4, 0xf4, 0x00, 0x05, 0xe5, 0x24, 0x00, 0x05, 0xe5, 0x50,
+  0x00, 0x05, 0xe5, 0x84, 0x00, 0x05, 0xe5, 0xbc, 0x00, 0x05, 0xe5, 0xf0,
+  0x00, 0x05, 0xe6, 0x74, 0x00, 0x05, 0xe6, 0xfc, 0x00, 0x05, 0xe7, 0x80,
+  0x00, 0x05, 0xe7, 0xac, 0x00, 0x05, 0xe7, 0xdc, 0x00, 0x05, 0xe8, 0x08,
+  0x00, 0x05, 0xe8, 0x38, 0x00, 0x05, 0xe8, 0x6c, 0x00, 0x05, 0xe8, 0x9c,
+  0x00, 0x05, 0xe8, 0xd8, 0x00, 0x05, 0xe9, 0x18, 0x00, 0x05, 0xe9, 0x54,
+  0x00, 0x05, 0xe9, 0xd4, 0x00, 0x05, 0xea, 0x58, 0x00, 0x05, 0xea, 0xd8,
+  0x00, 0x05, 0xeb, 0x60, 0x00, 0x05, 0xeb, 0xec, 0x00, 0x05, 0xec, 0x74,
+  0x00, 0x05, 0xec, 0x88, 0x00, 0x05, 0xec, 0xac, 0x00, 0x05, 0xec, 0xd0,
+  0x00, 0x05, 0xec, 0xf4, 0x00, 0x05, 0xed, 0x18, 0x00, 0x05, 0xed, 0x3c,
+  0x00, 0x05, 0xed, 0x60, 0x00, 0x05, 0xed, 0x84, 0x00, 0x05, 0xed, 0xa8,
+  0x00, 0x05, 0xed, 0xd8, 0x00, 0x05, 0xee, 0x14, 0x00, 0x05, 0xee, 0x50,
+  0x00, 0x05, 0xee, 0xb8, 0x00, 0x05, 0xef, 0x60, 0x00, 0x05, 0xef, 0xd0,
+  0x00, 0x05, 0xf0, 0x90, 0x00, 0x05, 0xf1, 0x18, 0x00, 0x05, 0xf1, 0xac,
+  0x00, 0x05, 0xf2, 0x44, 0x00, 0x05, 0xf2, 0xa4, 0x00, 0x05, 0xf3, 0x14,
+  0x00, 0x05, 0xf3, 0x80, 0x00, 0x05, 0xf4, 0x04, 0x00, 0x05, 0xf4, 0xec,
+  0x00, 0x05, 0xf5, 0x98, 0x00, 0x05, 0xf6, 0x54, 0x00, 0x05, 0xf7, 0x48,
+  0x00, 0x05, 0xf7, 0xfc, 0x00, 0x05, 0xf8, 0xc0, 0x00, 0x05, 0xf9, 0xd8,
+  0x00, 0x05, 0xfa, 0xb0, 0x00, 0x05, 0xfb, 0x98, 0x00, 0x05, 0xfc, 0x8c,
+  0x00, 0x05, 0xfd, 0x30, 0x00, 0x05, 0xfd, 0xe8, 0x00, 0x05, 0xfe, 0xe4,
+  0x00, 0x05, 0xff, 0x94, 0x00, 0x06, 0x00, 0x58, 0x00, 0x06, 0x00, 0xfc,
+  0x00, 0x06, 0x01, 0x88, 0x00, 0x06, 0x02, 0x2c, 0x00, 0x06, 0x02, 0xd4,
+  0x00, 0x06, 0x03, 0x50, 0x00, 0x06, 0x04, 0x00, 0x00, 0x06, 0x04, 0x18,
+  0x00, 0x06, 0x04, 0x30, 0x00, 0x06, 0x04, 0x48, 0x00, 0x06, 0x04, 0x68,
+  0x00, 0x06, 0x04, 0x88, 0x00, 0x06, 0x04, 0xa8, 0x00, 0x06, 0x04, 0xc0,
+  0x00, 0x06, 0x04, 0xd8, 0x00, 0x06, 0x04, 0xf0, 0x00, 0x06, 0x05, 0x08,
+  0x00, 0x06, 0x05, 0x20, 0x00, 0x06, 0x05, 0x38, 0x00, 0x06, 0x05, 0x50,
+  0x00, 0x06, 0x05, 0x68, 0x00, 0x06, 0x05, 0x80, 0x00, 0x06, 0x06, 0x2c,
+  0x00, 0x06, 0x06, 0x9c, 0x00, 0x06, 0x07, 0x20, 0x00, 0x06, 0x08, 0x10,
+  0x00, 0x06, 0x08, 0xc0, 0x00, 0x06, 0x09, 0x8c, 0x00, 0x06, 0x0a, 0x64,
+  0x00, 0x06, 0x0a, 0xdc, 0x00, 0x06, 0x0b, 0x70, 0x00, 0x06, 0x0c, 0x60,
+  0x00, 0x06, 0x0c, 0xec, 0x00, 0x06, 0x0d, 0x94, 0x00, 0x06, 0x0d, 0xf8,
+  0x00, 0x06, 0x0e, 0x5c, 0x00, 0x06, 0x0e, 0xc0, 0x00, 0x06, 0x0e, 0xf8,
+  0x00, 0x06, 0x0f, 0x30, 0x00, 0x06, 0x0f, 0x68, 0x00, 0x06, 0x0f, 0xac,
+  0x00, 0x06, 0x0f, 0xf0, 0x00, 0x06, 0x10, 0x34, 0x00, 0x06, 0x10, 0xb0,
+  0x00, 0x06, 0x10, 0xf0, 0x00, 0x06, 0x11, 0x40, 0x00, 0x06, 0x11, 0xd4,
+  0x00, 0x06, 0x12, 0x28, 0x00, 0x06, 0x12, 0x8c, 0x00, 0x06, 0x13, 0x20,
+  0x00, 0x06, 0x13, 0x78, 0x00, 0x06, 0x13, 0xdc, 0x00, 0x06, 0x14, 0x6c,
+  0x00, 0x06, 0x14, 0x8c, 0x00, 0x06, 0x14, 0xac, 0x00, 0x06, 0x15, 0x74,
+  0x00, 0x06, 0x15, 0x94, 0x00, 0x06, 0x15, 0xb4, 0x00, 0x06, 0x16, 0x50,
+  0x00, 0x06, 0x16, 0x68, 0x00, 0x06, 0x16, 0x80, 0x00, 0x01, 0x00, 0x00,
+  0x12, 0x0e, 0x03, 0x54, 0x00, 0x2b, 0x00, 0x68, 0x00, 0x0c, 0x00, 0x02,
+  0x00, 0x10, 0x00, 0x99, 0x00, 0x08, 0x00, 0x00, 0x04, 0x15, 0x00, 0x00,
+  0x00, 0x08, 0x00, 0x04, 0x00, 0x00, 0x00, 0x1a, 0x01, 0x3e, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x98, 0x01, 0x32, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x19, 0x01, 0xff, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x04, 0x02, 0x23, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x19, 0x02, 0x5c, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x19, 0x02, 0xaa, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x0c, 0x02, 0xde, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x16, 0x03, 0x19, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x11, 0x03, 0x54, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x1d, 0x03, 0xa2, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x12, 0x9d, 0x28, 0xfc, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x34, 0x3c, 0x04, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x0f, 0x3c, 0x59, 0x00, 0x01,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x09, 0x3c, 0x7d, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x00, 0x01, 0x30, 0x00, 0x00, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x01, 0x00, 0x32, 0x01, 0xcb, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x02, 0x00, 0x08, 0x02, 0x19, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x03, 0x00, 0x32, 0x02, 0x28, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x04, 0x00, 0x32, 0x02, 0x76, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x05, 0x00, 0x18, 0x02, 0xc4, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x06, 0x00, 0x2c, 0x02, 0xeb, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x08, 0x00, 0x22, 0x03, 0x30, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x0b, 0x00, 0x3a, 0x03, 0x66, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x0d, 0x25, 0x3a, 0x03, 0xc0, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x0e, 0x00, 0x68, 0x3b, 0x9a, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x10, 0x00, 0x1e, 0x3c, 0x39, 0x00, 0x03,
+  0x00, 0x01, 0x04, 0x09, 0x00, 0x11, 0x00, 0x12, 0x3c, 0x69, 0x00, 0x43,
+  0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67,
+  0x00, 0x68, 0x00, 0x74, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29,
+  0x00, 0x20, 0x00, 0x32, 0x00, 0x30, 0x00, 0x30, 0x00, 0x33, 0x00, 0x20,
+  0x00, 0x62, 0x00, 0x79, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74,
+  0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e,
+  0x00, 0x20, 0x00, 0x41, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x52,
+  0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x52, 0x00, 0x65, 0x00, 0x73, 0x00, 0x65, 0x00, 0x72, 0x00, 0x76,
+  0x00, 0x65, 0x00, 0x64, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x43, 0x00, 0x6f,
+  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20,
+  0x00, 0x32, 0x00, 0x30, 0x00, 0x30, 0x00, 0x36, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x79, 0x00, 0x20, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d,
+  0x00, 0x6a, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42,
+  0x00, 0x61, 0x00, 0x68, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x6c,
+  0x00, 0x6c, 0x00, 0x20, 0x00, 0x52, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x52, 0x00, 0x65, 0x00, 0x73,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x76, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2e,
+  0x00, 0x0a, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56,
+  0x00, 0x75, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6e,
+  0x00, 0x67, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x70,
+  0x00, 0x75, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63, 0x00, 0x20,
+  0x00, 0x64, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e,
+  0x00, 0x0a, 0x00, 0x00, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68,
+  0x74, 0x20, 0x28, 0x63, 0x29, 0x20, 0x32, 0x30, 0x30, 0x33, 0x20, 0x62,
+  0x79, 0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x2c,
+  0x20, 0x49, 0x6e, 0x63, 0x2e, 0x20, 0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69,
+  0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65, 0x73, 0x65, 0x72, 0x76, 0x65,
+  0x64, 0x2e, 0x0a, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74,
+  0x20, 0x28, 0x63, 0x29, 0x20, 0x32, 0x30, 0x30, 0x36, 0x20, 0x62, 0x79,
+  0x20, 0x54, 0x61, 0x76, 0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61,
+  0x68, 0x2e, 0x20, 0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69, 0x67, 0x68, 0x74,
+  0x73, 0x20, 0x52, 0x65, 0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2e, 0x0a,
+  0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x63, 0x68, 0x61, 0x6e, 0x67,
+  0x65, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20, 0x69, 0x6e, 0x20, 0x70, 0x75,
+  0x62, 0x6c, 0x69, 0x63, 0x20, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x0a,
+  0x00, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00,
+  0x75, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x47, 0x00, 0x43, 0x00, 0x20, 0x00,
+  0x53, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00,
+  0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00,
+  0x65, 0x00, 0x64, 0x00, 0x00, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20,
+  0x4c, 0x47, 0x43, 0x20, 0x53, 0x61, 0x6e, 0x73, 0x20, 0x43, 0x6f, 0x6e,
+  0x64, 0x65, 0x6e, 0x73, 0x65, 0x64, 0x00, 0x00, 0x42, 0x00, 0x6f, 0x00,
+  0x6f, 0x00, 0x6b, 0x00, 0x00, 0x42, 0x6f, 0x6f, 0x6b, 0x00, 0x00, 0x44,
+  0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75, 0x00, 0x20,
+  0x00, 0x4c, 0x00, 0x47, 0x00, 0x43, 0x00, 0x20, 0x00, 0x53, 0x00, 0x61,
+  0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x64, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00, 0x64,
+  0x00, 0x00, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x4c, 0x47, 0x43,
+  0x20, 0x53, 0x61, 0x6e, 0x73, 0x20, 0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e,
+  0x73, 0x65, 0x64, 0x00, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61,
+  0x00, 0x56, 0x00, 0x75, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x47, 0x00, 0x43,
+  0x00, 0x20, 0x00, 0x53, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x43, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6e,
+  0x00, 0x73, 0x00, 0x65, 0x00, 0x64, 0x00, 0x00, 0x44, 0x65, 0x6a, 0x61,
+  0x56, 0x75, 0x20, 0x4c, 0x47, 0x43, 0x20, 0x53, 0x61, 0x6e, 0x73, 0x20,
+  0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e, 0x73, 0x65, 0x64, 0x00, 0x00, 0x56,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x20, 0x00, 0x32, 0x00, 0x2e, 0x00, 0x33, 0x00, 0x34, 0x00, 0x00,
+  0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x32, 0x2e, 0x33, 0x34,
+  0x00, 0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00,
+  0x75, 0x00, 0x4c, 0x00, 0x47, 0x00, 0x43, 0x00, 0x53, 0x00, 0x61, 0x00,
+  0x6e, 0x00, 0x73, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00,
+  0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00, 0x64, 0x00, 0x00, 0x44,
+  0x65, 0x6a, 0x61, 0x56, 0x75, 0x4c, 0x47, 0x43, 0x53, 0x61, 0x6e, 0x73,
+  0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e, 0x73, 0x65, 0x64, 0x00, 0x00, 0x44,
+  0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75, 0x00, 0x20,
+  0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x00, 0x44, 0x65,
+  0x6a, 0x61, 0x56, 0x75, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x74,
+  0x65, 0x61, 0x6d, 0x00, 0x00, 0x68, 0x00, 0x74, 0x00, 0x74, 0x00, 0x70,
+  0x00, 0x3a, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6a,
+  0x00, 0x61, 0x00, 0x76, 0x00, 0x75, 0x00, 0x2e, 0x00, 0x73, 0x00, 0x6f,
+  0x00, 0x75, 0x00, 0x72, 0x00, 0x63, 0x00, 0x65, 0x00, 0x66, 0x00, 0x6f,
+  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2e, 0x00, 0x6e, 0x00, 0x65,
+  0x00, 0x74, 0x00, 0x00, 0x68, 0x74, 0x74, 0x70, 0x3a, 0x2f, 0x2f, 0x64,
+  0x65, 0x6a, 0x61, 0x76, 0x75, 0x2e, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65,
+  0x66, 0x6f, 0x72, 0x67, 0x65, 0x2e, 0x6e, 0x65, 0x74, 0x00, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29,
+  0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x28,
+  0x00, 0x73, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65,
+  0x00, 0x6c, 0x00, 0x6f, 0x00, 0x77, 0x00, 0x29, 0x00, 0x2e, 0x00, 0x20,
+  0x00, 0x44, 0x00, 0x65, 0x00, 0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75,
+  0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x67,
+  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x70, 0x00, 0x75,
+  0x00, 0x62, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63, 0x00, 0x20, 0x00, 0x64,
+  0x00, 0x6f, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x2e,
+  0x00, 0x20, 0x00, 0x47, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6d, 0x00, 0x70, 0x00, 0x6f,
+  0x00, 0x72, 0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x66,
+  0x00, 0x72, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x41, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x76, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20, 0x00, 0x54,
+  0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a, 0x00, 0x75, 0x00, 0x6e,
+  0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61, 0x00, 0x68, 0x00, 0x20,
+  0x00, 0x28, 0x00, 0x73, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x65, 0x00, 0x6c, 0x00, 0x6f, 0x00, 0x77, 0x00, 0x29, 0x00, 0x0a,
+  0x00, 0x0a, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x56,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x61, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00, 0x6f,
+  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
+  0x00, 0x74, 0x00, 0x0a, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x43, 0x00, 0x6f,
+  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20,
+  0x00, 0x32, 0x00, 0x30, 0x00, 0x30, 0x00, 0x33, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x79, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73,
+  0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x2c,
+  0x00, 0x20, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e, 0x00, 0x20,
+  0x00, 0x41, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x52, 0x00, 0x69,
+  0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x52,
+  0x00, 0x65, 0x00, 0x73, 0x00, 0x65, 0x00, 0x72, 0x00, 0x76, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74,
+  0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d,
+  0x00, 0x20, 0x00, 0x56, 0x00, 0x65, 0x00, 0x72, 0x00, 0x61, 0x00, 0x20,
+  0x00, 0x69, 0x00, 0x73, 0x00, 0x0a, 0x00, 0x61, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x72, 0x00, 0x61, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6d, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x6b, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
+  0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x49,
+  0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x50,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69, 0x00, 0x73, 0x00, 0x73,
+  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x69, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x65, 0x00, 0x62,
+  0x00, 0x79, 0x00, 0x20, 0x00, 0x67, 0x00, 0x72, 0x00, 0x61, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x66,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x72, 0x00, 0x67,
+  0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x6e, 0x00, 0x79, 0x00, 0x20, 0x00, 0x70, 0x00, 0x65,
+  0x00, 0x72, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6f,
+  0x00, 0x62, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x69,
+  0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x61, 0x00, 0x20, 0x00, 0x63,
+  0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x66,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x61,
+  0x00, 0x63, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x70, 0x00, 0x61,
+  0x00, 0x6e, 0x00, 0x79, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6c,
+  0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x28, 0x00, 0x22, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x22, 0x00, 0x29, 0x00, 0x20, 0x00, 0x61,
+  0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x73,
+  0x00, 0x6f, 0x00, 0x63, 0x00, 0x69, 0x00, 0x61, 0x00, 0x74, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x0a, 0x00, 0x64, 0x00, 0x6f, 0x00, 0x63, 0x00, 0x75,
+  0x00, 0x6d, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x74,
+  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x66, 0x00, 0x69,
+  0x00, 0x6c, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x28, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x22, 0x00, 0x46, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x22,
+  0x00, 0x29, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x70, 0x00, 0x72, 0x00, 0x6f, 0x00, 0x64,
+  0x00, 0x75, 0x00, 0x63, 0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74,
+  0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x6c,
+  0x00, 0x75, 0x00, 0x64, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
+  0x00, 0x77, 0x00, 0x69, 0x00, 0x74, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x75,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x6d, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x72,
+  0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x72, 0x00, 0x67,
+  0x00, 0x65, 0x00, 0x2c, 0x00, 0x0a, 0x00, 0x70, 0x00, 0x75, 0x00, 0x62,
+  0x00, 0x6c, 0x00, 0x69, 0x00, 0x73, 0x00, 0x68, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x69,
+  0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x2f, 0x00, 0x6f, 0x00, 0x72,
+  0x00, 0x20, 0x00, 0x73, 0x00, 0x65, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20,
+  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x69, 0x00, 0x65, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x61,
+  0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
+  0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69, 0x00, 0x74,
+  0x00, 0x0a, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
+  0x00, 0x77, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
+  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x69,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75, 0x00, 0x72, 0x00, 0x6e,
+  0x00, 0x69, 0x00, 0x73, 0x00, 0x68, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x64, 0x00, 0x6f, 0x00, 0x20,
+  0x00, 0x73, 0x00, 0x6f, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x73, 0x00, 0x75,
+  0x00, 0x62, 0x00, 0x6a, 0x00, 0x65, 0x00, 0x63, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
+  0x00, 0x0a, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x6f,
+  0x00, 0x77, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x63,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x69, 0x00, 0x74, 0x00, 0x69,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x3a, 0x00, 0x0a, 0x00, 0x0a,
+  0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x62,
+  0x00, 0x6f, 0x00, 0x76, 0x00, 0x65, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
+  0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x72, 0x00, 0x61, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6d,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x6b, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72,
+  0x00, 0x6d, 0x00, 0x69, 0x00, 0x73, 0x00, 0x73, 0x00, 0x69, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x69,
+  0x00, 0x63, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x68, 0x00, 0x61,
+  0x00, 0x6c, 0x00, 0x6c, 0x00, 0x0a, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x69, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x6c, 0x00, 0x75, 0x00, 0x64,
+  0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
+  0x00, 0x70, 0x00, 0x69, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
+  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x79, 0x00, 0x70, 0x00, 0x65, 0x00, 0x66, 0x00, 0x61, 0x00, 0x63,
+  0x00, 0x65, 0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
+  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6d,
+  0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69,
+  0x00, 0x65, 0x00, 0x64, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6c,
+  0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64,
+  0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x70, 0x00, 0x61, 0x00, 0x72,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x75, 0x00, 0x6c, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x0a, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x64, 0x00, 0x65, 0x00, 0x73, 0x00, 0x69, 0x00, 0x67, 0x00, 0x6e,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x67,
+  0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74, 0x00, 0x65, 0x00, 0x72,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79,
+  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f,
+  0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x0a, 0x00, 0x61,
+  0x00, 0x64, 0x00, 0x64, 0x00, 0x69, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x67, 0x00, 0x6c,
+  0x00, 0x79, 0x00, 0x70, 0x00, 0x68, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f,
+  0x00, 0x72, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61, 0x00, 0x72,
+  0x00, 0x61, 0x00, 0x63, 0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64, 0x00, 0x64, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x6c, 0x00, 0x79, 0x00, 0x20, 0x00, 0x69, 0x00, 0x66, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x0a, 0x00, 0x61, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x61,
+  0x00, 0x6d, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
+  0x00, 0x20, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x20, 0x00, 0x63,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e,
+  0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x65, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x6f, 0x00, 0x72,
+  0x00, 0x64, 0x00, 0x73, 0x00, 0x20, 0x00, 0x22, 0x00, 0x42, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
+  0x00, 0x6d, 0x00, 0x22, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x6f,
+  0x00, 0x72, 0x00, 0x64, 0x00, 0x0a, 0x00, 0x22, 0x00, 0x56, 0x00, 0x65,
+  0x00, 0x72, 0x00, 0x61, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
+  0x00, 0x54, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x4c,
+  0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d,
+  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x75, 0x00, 0x6c,
+  0x00, 0x6c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x76, 0x00, 0x6f, 0x00, 0x69, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x65, 0x00, 0x78, 0x00, 0x74, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x70, 0x00, 0x70, 0x00, 0x6c, 0x00, 0x69,
+  0x00, 0x63, 0x00, 0x61, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
+  0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x53,
+  0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x61, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x68, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x65, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f,
+  0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74,
+  0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x75, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65,
+  0x00, 0x72, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x22, 0x00, 0x42, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x74,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x0a, 0x00, 0x56,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x61, 0x00, 0x22, 0x00, 0x20, 0x00, 0x6e,
+  0x00, 0x61, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a,
+  0x00, 0x0a, 0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6c, 0x00, 0x64,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x70, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x74, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x20, 0x00, 0x6c, 0x00, 0x61, 0x00, 0x72, 0x00, 0x67,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x70, 0x00, 0x61, 0x00, 0x63, 0x00, 0x6b, 0x00, 0x61, 0x00, 0x67,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x6e, 0x00, 0x6f, 0x00, 0x0a, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70,
+  0x00, 0x79, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
+  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53,
+  0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x79, 0x00, 0x70, 0x00, 0x65,
+  0x00, 0x66, 0x00, 0x61, 0x00, 0x63, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6c, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x62, 0x00, 0x79, 0x00, 0x20, 0x00, 0x69, 0x00, 0x74, 0x00, 0x73,
+  0x00, 0x65, 0x00, 0x6c, 0x00, 0x66, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
+  0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x20, 0x00, 0x46, 0x00, 0x4f,
+  0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x46,
+  0x00, 0x54, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52, 0x00, 0x45, 0x00, 0x20,
+  0x00, 0x49, 0x00, 0x53, 0x00, 0x20, 0x00, 0x50, 0x00, 0x52, 0x00, 0x4f,
+  0x00, 0x56, 0x00, 0x49, 0x00, 0x44, 0x00, 0x45, 0x00, 0x44, 0x00, 0x20,
+  0x00, 0x22, 0x00, 0x41, 0x00, 0x53, 0x00, 0x20, 0x00, 0x49, 0x00, 0x53,
+  0x00, 0x22, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x57, 0x00, 0x49, 0x00, 0x54,
+  0x00, 0x48, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x54, 0x00, 0x20, 0x00, 0x57,
+  0x00, 0x41, 0x00, 0x52, 0x00, 0x52, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x54,
+  0x00, 0x59, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x41,
+  0x00, 0x4e, 0x00, 0x59, 0x00, 0x20, 0x00, 0x4b, 0x00, 0x49, 0x00, 0x4e,
+  0x00, 0x44, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x45, 0x00, 0x58, 0x00, 0x50,
+  0x00, 0x52, 0x00, 0x45, 0x00, 0x53, 0x00, 0x53, 0x00, 0x0a, 0x00, 0x4f,
+  0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x50, 0x00, 0x4c,
+  0x00, 0x49, 0x00, 0x45, 0x00, 0x44, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x49,
+  0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x55, 0x00, 0x44, 0x00, 0x49,
+  0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x42, 0x00, 0x55, 0x00, 0x54,
+  0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4c,
+  0x00, 0x49, 0x00, 0x4d, 0x00, 0x49, 0x00, 0x54, 0x00, 0x45, 0x00, 0x44,
+  0x00, 0x20, 0x00, 0x54, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e,
+  0x00, 0x59, 0x00, 0x20, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52, 0x00, 0x52,
+  0x00, 0x41, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x49, 0x00, 0x45, 0x00, 0x53,
+  0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x4d, 0x00, 0x45,
+  0x00, 0x52, 0x00, 0x43, 0x00, 0x48, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x54,
+  0x00, 0x41, 0x00, 0x42, 0x00, 0x49, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x54,
+  0x00, 0x59, 0x00, 0x2c, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x49, 0x00, 0x54,
+  0x00, 0x4e, 0x00, 0x45, 0x00, 0x53, 0x00, 0x53, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x41, 0x00, 0x20, 0x00, 0x50,
+  0x00, 0x41, 0x00, 0x52, 0x00, 0x54, 0x00, 0x49, 0x00, 0x43, 0x00, 0x55,
+  0x00, 0x4c, 0x00, 0x41, 0x00, 0x52, 0x00, 0x20, 0x00, 0x50, 0x00, 0x55,
+  0x00, 0x52, 0x00, 0x50, 0x00, 0x4f, 0x00, 0x53, 0x00, 0x45, 0x00, 0x20,
+  0x00, 0x41, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f,
+  0x00, 0x4e, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x46, 0x00, 0x52, 0x00, 0x49,
+  0x00, 0x4e, 0x00, 0x47, 0x00, 0x45, 0x00, 0x4d, 0x00, 0x45, 0x00, 0x4e,
+  0x00, 0x54, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x43,
+  0x00, 0x4f, 0x00, 0x50, 0x00, 0x59, 0x00, 0x52, 0x00, 0x49, 0x00, 0x47,
+  0x00, 0x48, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x50, 0x00, 0x41,
+  0x00, 0x54, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x0a,
+  0x00, 0x54, 0x00, 0x52, 0x00, 0x41, 0x00, 0x44, 0x00, 0x45, 0x00, 0x4d,
+  0x00, 0x41, 0x00, 0x52, 0x00, 0x4b, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f,
+  0x00, 0x52, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
+  0x00, 0x52, 0x00, 0x20, 0x00, 0x52, 0x00, 0x49, 0x00, 0x47, 0x00, 0x48,
+  0x00, 0x54, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x20,
+  0x00, 0x4e, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x45, 0x00, 0x56, 0x00, 0x45,
+  0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53, 0x00, 0x48, 0x00, 0x41,
+  0x00, 0x4c, 0x00, 0x4c, 0x00, 0x20, 0x00, 0x42, 0x00, 0x49, 0x00, 0x54,
+  0x00, 0x53, 0x00, 0x54, 0x00, 0x52, 0x00, 0x45, 0x00, 0x41, 0x00, 0x4d,
+  0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x47, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x4d,
+  0x00, 0x45, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x4e,
+  0x00, 0x44, 0x00, 0x41, 0x00, 0x54, 0x00, 0x49, 0x00, 0x4f, 0x00, 0x4e,
+  0x00, 0x20, 0x00, 0x42, 0x00, 0x45, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x49,
+  0x00, 0x41, 0x00, 0x42, 0x00, 0x4c, 0x00, 0x45, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59,
+  0x00, 0x20, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x41, 0x00, 0x49, 0x00, 0x4d,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x44, 0x00, 0x41, 0x00, 0x4d, 0x00, 0x41,
+  0x00, 0x47, 0x00, 0x45, 0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52,
+  0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x52,
+  0x00, 0x20, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x41, 0x00, 0x42, 0x00, 0x49,
+  0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x55, 0x00, 0x44,
+  0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x0a, 0x00, 0x41, 0x00, 0x4e,
+  0x00, 0x59, 0x00, 0x20, 0x00, 0x47, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x45,
+  0x00, 0x52, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x53,
+  0x00, 0x50, 0x00, 0x45, 0x00, 0x43, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x49,
+  0x00, 0x52, 0x00, 0x45, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x49, 0x00, 0x44, 0x00, 0x45,
+  0x00, 0x4e, 0x00, 0x54, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e,
+  0x00, 0x53, 0x00, 0x45, 0x00, 0x51, 0x00, 0x55, 0x00, 0x45, 0x00, 0x4e,
+  0x00, 0x54, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x20, 0x00, 0x44,
+  0x00, 0x41, 0x00, 0x4d, 0x00, 0x41, 0x00, 0x47, 0x00, 0x45, 0x00, 0x53,
+  0x00, 0x2c, 0x00, 0x0a, 0x00, 0x57, 0x00, 0x48, 0x00, 0x45, 0x00, 0x54,
+  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e,
+  0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x43,
+  0x00, 0x54, 0x00, 0x49, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x4f,
+  0x00, 0x46, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
+  0x00, 0x52, 0x00, 0x41, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x54, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4f,
+  0x00, 0x52, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
+  0x00, 0x52, 0x00, 0x57, 0x00, 0x49, 0x00, 0x53, 0x00, 0x45, 0x00, 0x2c,
+  0x00, 0x20, 0x00, 0x41, 0x00, 0x52, 0x00, 0x49, 0x00, 0x53, 0x00, 0x49,
+  0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x46, 0x00, 0x52, 0x00, 0x4f,
+  0x00, 0x4d, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x54,
+  0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x48,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53, 0x00, 0x45, 0x00, 0x20,
+  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x41,
+  0x00, 0x42, 0x00, 0x49, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59,
+  0x00, 0x20, 0x00, 0x54, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x20,
+  0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53,
+  0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x52, 0x00, 0x4f, 0x00, 0x4d, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54,
+  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x44, 0x00, 0x45,
+  0x00, 0x41, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x53,
+  0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
+  0x00, 0x45, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
+  0x00, 0x20, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57,
+  0x00, 0x41, 0x00, 0x52, 0x00, 0x45, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
+  0x00, 0x45, 0x00, 0x78, 0x00, 0x63, 0x00, 0x65, 0x00, 0x70, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61,
+  0x00, 0x6d, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x20, 0x00, 0x47, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x47, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x0a,
+  0x00, 0x46, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x61,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
+  0x00, 0x6d, 0x00, 0x20, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x73, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6c,
+  0x00, 0x6c, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x61,
+  0x00, 0x64, 0x00, 0x76, 0x00, 0x65, 0x00, 0x72, 0x00, 0x74, 0x00, 0x69,
+  0x00, 0x73, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x6f,
+  0x00, 0x72, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
+  0x00, 0x72, 0x00, 0x77, 0x00, 0x69, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x70, 0x00, 0x72, 0x00, 0x6f,
+  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x61, 0x00, 0x6c,
+  0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x64, 0x00, 0x65,
+  0x00, 0x61, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
+  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x77,
+  0x00, 0x69, 0x00, 0x74, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x70, 0x00, 0x72, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x72,
+  0x00, 0x20, 0x00, 0x77, 0x00, 0x72, 0x00, 0x69, 0x00, 0x74, 0x00, 0x74,
+  0x00, 0x65, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x75, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x69, 0x00, 0x7a, 0x00, 0x61,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x66,
+  0x00, 0x72, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x47, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x6e,
+  0x00, 0x64, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
+  0x00, 0x6d, 0x00, 0x0a, 0x00, 0x49, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x2e,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65, 0x00, 0x73, 0x00, 0x70,
+  0x00, 0x65, 0x00, 0x63, 0x00, 0x74, 0x00, 0x69, 0x00, 0x76, 0x00, 0x65,
+  0x00, 0x6c, 0x00, 0x79, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f,
+  0x00, 0x72, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75, 0x00, 0x72, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e,
+  0x00, 0x66, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x74,
+  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x63,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74,
+  0x00, 0x3a, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x74, 0x00, 0x20, 0x00, 0x67,
+  0x00, 0x6e, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x20, 0x00, 0x64,
+  0x00, 0x6f, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x67,
+  0x00, 0x2e, 0x00, 0x20, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x41, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x76, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x70,
+  0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
+  0x00, 0x0a, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d, 0x00, 0x2d,
+  0x00, 0x2d, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x43, 0x00, 0x6f, 0x00, 0x70,
+  0x00, 0x79, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x28, 0x00, 0x63, 0x00, 0x29, 0x00, 0x20, 0x00, 0x32,
+  0x00, 0x30, 0x00, 0x30, 0x00, 0x36, 0x00, 0x20, 0x00, 0x62, 0x00, 0x79,
+  0x00, 0x20, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61,
+  0x00, 0x68, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x6c, 0x00, 0x6c,
+  0x00, 0x20, 0x00, 0x52, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x52, 0x00, 0x65, 0x00, 0x73, 0x00, 0x65,
+  0x00, 0x72, 0x00, 0x76, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2e, 0x00, 0x0a,
+  0x00, 0x0a, 0x00, 0x50, 0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69,
+  0x00, 0x73, 0x00, 0x73, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20,
+  0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x62, 0x00, 0x79, 0x00, 0x20, 0x00, 0x67, 0x00, 0x72,
+  0x00, 0x61, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c,
+  0x00, 0x20, 0x00, 0x66, 0x00, 0x72, 0x00, 0x65, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x79, 0x00, 0x20,
+  0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x62, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69,
+  0x00, 0x6e, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x0a, 0x00, 0x61,
+  0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x63, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d,
+  0x00, 0x70, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x79, 0x00, 0x69, 0x00, 0x6e,
+  0x00, 0x67, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e,
+  0x00, 0x73, 0x00, 0x65, 0x00, 0x20, 0x00, 0x28, 0x00, 0x22, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x22, 0x00, 0x29,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x0a, 0x00, 0x61,
+  0x00, 0x73, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x63, 0x00, 0x69, 0x00, 0x61,
+  0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x64, 0x00, 0x6f,
+  0x00, 0x63, 0x00, 0x75, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74,
+  0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20,
+  0x00, 0x66, 0x00, 0x69, 0x00, 0x6c, 0x00, 0x65, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x28, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x22,
+  0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53,
+  0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x22, 0x00, 0x29, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65, 0x00, 0x70, 0x00, 0x72,
+  0x00, 0x6f, 0x00, 0x64, 0x00, 0x75, 0x00, 0x63, 0x00, 0x65, 0x00, 0x0a,
+  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x64, 0x00, 0x69,
+  0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75,
+  0x00, 0x74, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69, 0x00, 0x66,
+  0x00, 0x69, 0x00, 0x63, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x42, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72, 0x00, 0x65, 0x00, 0x61,
+  0x00, 0x6d, 0x00, 0x20, 0x00, 0x56, 0x00, 0x65, 0x00, 0x72, 0x00, 0x61,
+  0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x0a, 0x00, 0x69, 0x00, 0x6e,
+  0x00, 0x63, 0x00, 0x6c, 0x00, 0x75, 0x00, 0x64, 0x00, 0x69, 0x00, 0x6e,
+  0x00, 0x67, 0x00, 0x20, 0x00, 0x77, 0x00, 0x69, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x6f, 0x00, 0x75, 0x00, 0x74, 0x00, 0x20, 0x00, 0x6c, 0x00, 0x69,
+  0x00, 0x6d, 0x00, 0x69, 0x00, 0x74, 0x00, 0x61, 0x00, 0x74, 0x00, 0x69,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x72, 0x00, 0x69, 0x00, 0x67, 0x00, 0x68, 0x00, 0x74,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x75,
+  0x00, 0x73, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
+  0x00, 0x70, 0x00, 0x79, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x65,
+  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x70,
+  0x00, 0x75, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x73, 0x00, 0x68,
+  0x00, 0x2c, 0x00, 0x0a, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74,
+  0x00, 0x72, 0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x2f,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x73, 0x00, 0x65, 0x00, 0x6c,
+  0x00, 0x6c, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x69,
+  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x2c,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72, 0x00, 0x6d,
+  0x00, 0x69, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x70, 0x00, 0x65, 0x00, 0x72,
+  0x00, 0x73, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x77, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x6d,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75,
+  0x00, 0x72, 0x00, 0x6e, 0x00, 0x69, 0x00, 0x73, 0x00, 0x68, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x64,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x73, 0x00, 0x75, 0x00, 0x62, 0x00, 0x6a, 0x00, 0x65, 0x00, 0x63,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f, 0x00, 0x0a, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x6c,
+  0x00, 0x6c, 0x00, 0x6f, 0x00, 0x77, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67,
+  0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x3a,
+  0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x62, 0x00, 0x6f, 0x00, 0x76, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x72, 0x00, 0x69,
+  0x00, 0x67, 0x00, 0x68, 0x00, 0x74, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x72, 0x00, 0x61, 0x00, 0x64,
+  0x00, 0x65, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x72, 0x00, 0x6b, 0x00, 0x20,
+  0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x70,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x69, 0x00, 0x73, 0x00, 0x73,
+  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x73,
+  0x00, 0x68, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x63, 0x00, 0x6c,
+  0x00, 0x75, 0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69,
+  0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c, 0x00, 0x20,
+  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x69, 0x00, 0x65, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6d,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x0a, 0x00, 0x74, 0x00, 0x79, 0x00, 0x70, 0x00, 0x65, 0x00, 0x66,
+  0x00, 0x61, 0x00, 0x63, 0x00, 0x65, 0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a,
+  0x00, 0x0a, 0x00, 0x54, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69,
+  0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x6c, 0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x64, 0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x6f, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x0a, 0x00, 0x70,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x75,
+  0x00, 0x6c, 0x00, 0x61, 0x00, 0x72, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x64, 0x00, 0x65, 0x00, 0x73, 0x00, 0x69,
+  0x00, 0x67, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66,
+  0x00, 0x20, 0x00, 0x67, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x63,
+  0x00, 0x68, 0x00, 0x61, 0x00, 0x72, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x73, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d,
+  0x00, 0x61, 0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x0a,
+  0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64, 0x00, 0x69, 0x00, 0x66, 0x00, 0x69,
+  0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x64, 0x00, 0x64, 0x00, 0x69, 0x00, 0x74,
+  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x20,
+  0x00, 0x67, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x70, 0x00, 0x68, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x63, 0x00, 0x68,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x61, 0x00, 0x63, 0x00, 0x74, 0x00, 0x65,
+  0x00, 0x72, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79,
+  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64,
+  0x00, 0x64, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x0a, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x6c, 0x00, 0x79, 0x00, 0x20, 0x00, 0x69,
+  0x00, 0x66, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x66, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x6f, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d,
+  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61,
+  0x00, 0x69, 0x00, 0x6e, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
+  0x00, 0x65, 0x00, 0x69, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72,
+  0x00, 0x0a, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x64, 0x00, 0x73, 0x00, 0x20, 0x00, 0x22,
+  0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61, 0x00, 0x68,
+  0x00, 0x22, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x6f, 0x00, 0x72,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x22, 0x00, 0x41, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x76, 0x00, 0x22, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54,
+  0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x69,
+  0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x62, 0x00, 0x65, 0x00, 0x63, 0x00, 0x6f, 0x00, 0x6d, 0x00, 0x65,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x75, 0x00, 0x6c, 0x00, 0x6c,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x76,
+  0x00, 0x6f, 0x00, 0x69, 0x00, 0x64, 0x00, 0x20, 0x00, 0x74, 0x00, 0x6f,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x65,
+  0x00, 0x78, 0x00, 0x74, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x70, 0x00, 0x70, 0x00, 0x6c, 0x00, 0x69, 0x00, 0x63,
+  0x00, 0x61, 0x00, 0x62, 0x00, 0x6c, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
+  0x00, 0x73, 0x00, 0x0a, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x61, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x68, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65,
+  0x00, 0x65, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x64,
+  0x00, 0x69, 0x00, 0x66, 0x00, 0x69, 0x00, 0x65, 0x00, 0x64, 0x00, 0x20,
+  0x00, 0x61, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x64, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74, 0x00, 0x72,
+  0x00, 0x69, 0x00, 0x62, 0x00, 0x75, 0x00, 0x74, 0x00, 0x65, 0x00, 0x64,
+  0x00, 0x20, 0x00, 0x75, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x72,
+  0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x0a,
+  0x00, 0x22, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a,
+  0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61,
+  0x00, 0x68, 0x00, 0x20, 0x00, 0x41, 0x00, 0x72, 0x00, 0x65, 0x00, 0x76,
+  0x00, 0x22, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61, 0x00, 0x6d, 0x00, 0x65,
+  0x00, 0x73, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x68,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61,
+  0x00, 0x79, 0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73,
+  0x00, 0x6f, 0x00, 0x6c, 0x00, 0x64, 0x00, 0x20, 0x00, 0x61, 0x00, 0x73,
+  0x00, 0x20, 0x00, 0x70, 0x00, 0x61, 0x00, 0x72, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x61, 0x00, 0x20, 0x00, 0x6c,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20,
+  0x00, 0x73, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77, 0x00, 0x61,
+  0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x70, 0x00, 0x61, 0x00, 0x63,
+  0x00, 0x6b, 0x00, 0x61, 0x00, 0x67, 0x00, 0x65, 0x00, 0x20, 0x00, 0x62,
+  0x00, 0x75, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x20,
+  0x00, 0x63, 0x00, 0x6f, 0x00, 0x70, 0x00, 0x79, 0x00, 0x20, 0x00, 0x6f,
+  0x00, 0x66, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x6f, 0x00, 0x72,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e,
+  0x00, 0x74, 0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74,
+  0x00, 0x77, 0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x79, 0x00, 0x70, 0x00, 0x65, 0x00, 0x66, 0x00, 0x61, 0x00, 0x63,
+  0x00, 0x65, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6d, 0x00, 0x61, 0x00, 0x79,
+  0x00, 0x20, 0x00, 0x62, 0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x6f,
+  0x00, 0x6c, 0x00, 0x64, 0x00, 0x20, 0x00, 0x62, 0x00, 0x79, 0x00, 0x0a,
+  0x00, 0x69, 0x00, 0x74, 0x00, 0x73, 0x00, 0x65, 0x00, 0x6c, 0x00, 0x66,
+  0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
+  0x00, 0x20, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20,
+  0x00, 0x53, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57, 0x00, 0x41,
+  0x00, 0x52, 0x00, 0x45, 0x00, 0x20, 0x00, 0x49, 0x00, 0x53, 0x00, 0x20,
+  0x00, 0x50, 0x00, 0x52, 0x00, 0x4f, 0x00, 0x56, 0x00, 0x49, 0x00, 0x44,
+  0x00, 0x45, 0x00, 0x44, 0x00, 0x20, 0x00, 0x22, 0x00, 0x41, 0x00, 0x53,
+  0x00, 0x20, 0x00, 0x49, 0x00, 0x53, 0x00, 0x22, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x57, 0x00, 0x49, 0x00, 0x54, 0x00, 0x48, 0x00, 0x4f, 0x00, 0x55,
+  0x00, 0x54, 0x00, 0x20, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52, 0x00, 0x52,
+  0x00, 0x41, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x59, 0x00, 0x20, 0x00, 0x4f,
+  0x00, 0x46, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59, 0x00, 0x20,
+  0x00, 0x4b, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x2c, 0x00, 0x0a,
+  0x00, 0x45, 0x00, 0x58, 0x00, 0x50, 0x00, 0x52, 0x00, 0x45, 0x00, 0x53,
+  0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49,
+  0x00, 0x4d, 0x00, 0x50, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x45, 0x00, 0x44,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c,
+  0x00, 0x55, 0x00, 0x44, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x20,
+  0x00, 0x42, 0x00, 0x55, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f,
+  0x00, 0x54, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x4d, 0x00, 0x49,
+  0x00, 0x54, 0x00, 0x45, 0x00, 0x44, 0x00, 0x20, 0x00, 0x54, 0x00, 0x4f,
+  0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59, 0x00, 0x20, 0x00, 0x57,
+  0x00, 0x41, 0x00, 0x52, 0x00, 0x52, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x54,
+  0x00, 0x49, 0x00, 0x45, 0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x46,
+  0x00, 0x0a, 0x00, 0x4d, 0x00, 0x45, 0x00, 0x52, 0x00, 0x43, 0x00, 0x48,
+  0x00, 0x41, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x41, 0x00, 0x42, 0x00, 0x49,
+  0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x46, 0x00, 0x49, 0x00, 0x54, 0x00, 0x4e, 0x00, 0x45, 0x00, 0x53,
+  0x00, 0x53, 0x00, 0x20, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20,
+  0x00, 0x41, 0x00, 0x20, 0x00, 0x50, 0x00, 0x41, 0x00, 0x52, 0x00, 0x54,
+  0x00, 0x49, 0x00, 0x43, 0x00, 0x55, 0x00, 0x4c, 0x00, 0x41, 0x00, 0x52,
+  0x00, 0x20, 0x00, 0x50, 0x00, 0x55, 0x00, 0x52, 0x00, 0x50, 0x00, 0x4f,
+  0x00, 0x53, 0x00, 0x45, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x44,
+  0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x49, 0x00, 0x4e,
+  0x00, 0x46, 0x00, 0x52, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x45,
+  0x00, 0x4d, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x0a, 0x00, 0x4f,
+  0x00, 0x46, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x50, 0x00, 0x59,
+  0x00, 0x52, 0x00, 0x49, 0x00, 0x47, 0x00, 0x48, 0x00, 0x54, 0x00, 0x2c,
+  0x00, 0x20, 0x00, 0x50, 0x00, 0x41, 0x00, 0x54, 0x00, 0x45, 0x00, 0x4e,
+  0x00, 0x54, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x54, 0x00, 0x52, 0x00, 0x41,
+  0x00, 0x44, 0x00, 0x45, 0x00, 0x4d, 0x00, 0x41, 0x00, 0x52, 0x00, 0x4b,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x4f,
+  0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x52,
+  0x00, 0x49, 0x00, 0x47, 0x00, 0x48, 0x00, 0x54, 0x00, 0x2e, 0x00, 0x20,
+  0x00, 0x49, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x20,
+  0x00, 0x45, 0x00, 0x56, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20,
+  0x00, 0x53, 0x00, 0x48, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x4c, 0x00, 0x0a,
+  0x00, 0x54, 0x00, 0x41, 0x00, 0x56, 0x00, 0x4d, 0x00, 0x4a, 0x00, 0x4f,
+  0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x42, 0x00, 0x41, 0x00, 0x48,
+  0x00, 0x20, 0x00, 0x42, 0x00, 0x45, 0x00, 0x20, 0x00, 0x4c, 0x00, 0x49,
+  0x00, 0x41, 0x00, 0x42, 0x00, 0x4c, 0x00, 0x45, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x59,
+  0x00, 0x20, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x41, 0x00, 0x49, 0x00, 0x4d,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x44, 0x00, 0x41, 0x00, 0x4d, 0x00, 0x41,
+  0x00, 0x47, 0x00, 0x45, 0x00, 0x53, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52,
+  0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x52,
+  0x00, 0x20, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x41, 0x00, 0x42, 0x00, 0x49,
+  0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59, 0x00, 0x2c, 0x00, 0x0a,
+  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x4c, 0x00, 0x55, 0x00, 0x44,
+  0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x20, 0x00, 0x41, 0x00, 0x4e,
+  0x00, 0x59, 0x00, 0x20, 0x00, 0x47, 0x00, 0x45, 0x00, 0x4e, 0x00, 0x45,
+  0x00, 0x52, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x53,
+  0x00, 0x50, 0x00, 0x45, 0x00, 0x43, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x44, 0x00, 0x49,
+  0x00, 0x52, 0x00, 0x45, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x49, 0x00, 0x4e, 0x00, 0x43, 0x00, 0x49, 0x00, 0x44, 0x00, 0x45,
+  0x00, 0x4e, 0x00, 0x54, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e,
+  0x00, 0x53, 0x00, 0x45, 0x00, 0x51, 0x00, 0x55, 0x00, 0x45, 0x00, 0x4e,
+  0x00, 0x54, 0x00, 0x49, 0x00, 0x41, 0x00, 0x4c, 0x00, 0x0a, 0x00, 0x44,
+  0x00, 0x41, 0x00, 0x4d, 0x00, 0x41, 0x00, 0x47, 0x00, 0x45, 0x00, 0x53,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x57, 0x00, 0x48, 0x00, 0x45, 0x00, 0x54,
+  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e,
+  0x00, 0x20, 0x00, 0x41, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x41, 0x00, 0x43,
+  0x00, 0x54, 0x00, 0x49, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x4f,
+  0x00, 0x46, 0x00, 0x20, 0x00, 0x43, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
+  0x00, 0x52, 0x00, 0x41, 0x00, 0x43, 0x00, 0x54, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x54, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x54, 0x00, 0x20, 0x00, 0x4f,
+  0x00, 0x52, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45,
+  0x00, 0x52, 0x00, 0x57, 0x00, 0x49, 0x00, 0x53, 0x00, 0x45, 0x00, 0x2c,
+  0x00, 0x20, 0x00, 0x41, 0x00, 0x52, 0x00, 0x49, 0x00, 0x53, 0x00, 0x49,
+  0x00, 0x4e, 0x00, 0x47, 0x00, 0x0a, 0x00, 0x46, 0x00, 0x52, 0x00, 0x4f,
+  0x00, 0x4d, 0x00, 0x2c, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x55, 0x00, 0x54,
+  0x00, 0x20, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53, 0x00, 0x45, 0x00, 0x20,
+  0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x41,
+  0x00, 0x42, 0x00, 0x49, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x54, 0x00, 0x59,
+  0x00, 0x20, 0x00, 0x54, 0x00, 0x4f, 0x00, 0x20, 0x00, 0x55, 0x00, 0x53,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48, 0x00, 0x45, 0x00, 0x20,
+  0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54, 0x00, 0x20, 0x00, 0x53,
+  0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57, 0x00, 0x41, 0x00, 0x52,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x4f, 0x00, 0x52, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x52, 0x00, 0x4f, 0x00, 0x4d, 0x00, 0x0a, 0x00, 0x4f, 0x00, 0x54,
+  0x00, 0x48, 0x00, 0x45, 0x00, 0x52, 0x00, 0x20, 0x00, 0x44, 0x00, 0x45,
+  0x00, 0x41, 0x00, 0x4c, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x47, 0x00, 0x53,
+  0x00, 0x20, 0x00, 0x49, 0x00, 0x4e, 0x00, 0x20, 0x00, 0x54, 0x00, 0x48,
+  0x00, 0x45, 0x00, 0x20, 0x00, 0x46, 0x00, 0x4f, 0x00, 0x4e, 0x00, 0x54,
+  0x00, 0x20, 0x00, 0x53, 0x00, 0x4f, 0x00, 0x46, 0x00, 0x54, 0x00, 0x57,
+  0x00, 0x41, 0x00, 0x52, 0x00, 0x45, 0x00, 0x2e, 0x00, 0x0a, 0x00, 0x0a,
+  0x00, 0x45, 0x00, 0x78, 0x00, 0x63, 0x00, 0x65, 0x00, 0x70, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x61, 0x00, 0x73, 0x00, 0x20, 0x00, 0x63, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x65,
+  0x00, 0x64, 0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x68, 0x00, 0x69, 0x00, 0x73, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6e, 0x00, 0x61,
+  0x00, 0x6d, 0x00, 0x65, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x20,
+  0x00, 0x54, 0x00, 0x61, 0x00, 0x76, 0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f,
+  0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x42, 0x00, 0x61, 0x00, 0x68,
+  0x00, 0x20, 0x00, 0x73, 0x00, 0x68, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x6c,
+  0x00, 0x20, 0x00, 0x6e, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x0a, 0x00, 0x62,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65, 0x00, 0x64,
+  0x00, 0x20, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x64,
+  0x00, 0x76, 0x00, 0x65, 0x00, 0x72, 0x00, 0x74, 0x00, 0x69, 0x00, 0x73,
+  0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x72,
+  0x00, 0x20, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72,
+  0x00, 0x77, 0x00, 0x69, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74,
+  0x00, 0x6f, 0x00, 0x20, 0x00, 0x70, 0x00, 0x72, 0x00, 0x6f, 0x00, 0x6d,
+  0x00, 0x6f, 0x00, 0x74, 0x00, 0x65, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x65, 0x00, 0x20, 0x00, 0x73, 0x00, 0x61, 0x00, 0x6c, 0x00, 0x65,
+  0x00, 0x2c, 0x00, 0x20, 0x00, 0x75, 0x00, 0x73, 0x00, 0x65, 0x00, 0x20,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x6f, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x65, 0x00, 0x72, 0x00, 0x0a, 0x00, 0x64, 0x00, 0x65, 0x00, 0x61,
+  0x00, 0x6c, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x73, 0x00, 0x20,
+  0x00, 0x69, 0x00, 0x6e, 0x00, 0x20, 0x00, 0x74, 0x00, 0x68, 0x00, 0x69,
+  0x00, 0x73, 0x00, 0x20, 0x00, 0x46, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74,
+  0x00, 0x20, 0x00, 0x53, 0x00, 0x6f, 0x00, 0x66, 0x00, 0x74, 0x00, 0x77,
+  0x00, 0x61, 0x00, 0x72, 0x00, 0x65, 0x00, 0x20, 0x00, 0x77, 0x00, 0x69,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x6f, 0x00, 0x75, 0x00, 0x74, 0x00, 0x20,
+  0x00, 0x70, 0x00, 0x72, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x20,
+  0x00, 0x77, 0x00, 0x72, 0x00, 0x69, 0x00, 0x74, 0x00, 0x74, 0x00, 0x65,
+  0x00, 0x6e, 0x00, 0x20, 0x00, 0x61, 0x00, 0x75, 0x00, 0x74, 0x00, 0x68,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x69, 0x00, 0x7a, 0x00, 0x61, 0x00, 0x74,
+  0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x0a, 0x00, 0x66, 0x00, 0x72,
+  0x00, 0x6f, 0x00, 0x6d, 0x00, 0x20, 0x00, 0x54, 0x00, 0x61, 0x00, 0x76,
+  0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
+  0x00, 0x42, 0x00, 0x61, 0x00, 0x68, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x46,
+  0x00, 0x6f, 0x00, 0x72, 0x00, 0x20, 0x00, 0x66, 0x00, 0x75, 0x00, 0x72,
+  0x00, 0x74, 0x00, 0x68, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00, 0x69,
+  0x00, 0x6e, 0x00, 0x66, 0x00, 0x6f, 0x00, 0x72, 0x00, 0x6d, 0x00, 0x61,
+  0x00, 0x74, 0x00, 0x69, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x2c, 0x00, 0x20,
+  0x00, 0x63, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x74, 0x00, 0x61, 0x00, 0x63,
+  0x00, 0x74, 0x00, 0x3a, 0x00, 0x20, 0x00, 0x74, 0x00, 0x61, 0x00, 0x76,
+  0x00, 0x6d, 0x00, 0x6a, 0x00, 0x6f, 0x00, 0x6e, 0x00, 0x67, 0x00, 0x20,
+  0x00, 0x40, 0x00, 0x20, 0x00, 0x66, 0x00, 0x72, 0x00, 0x65, 0x00, 0x65,
+  0x00, 0x0a, 0x00, 0x2e, 0x00, 0x20, 0x00, 0x66, 0x00, 0x72, 0x00, 0x2e,
+  0x00, 0x00, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20,
+  0x28, 0x63, 0x29, 0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61,
+  0x6d, 0x20, 0x28, 0x73, 0x65, 0x65, 0x20, 0x62, 0x65, 0x6c, 0x6f, 0x77,
+  0x29, 0x2e, 0x20, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x63, 0x68,
+  0x61, 0x6e, 0x67, 0x65, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20, 0x69, 0x6e,
+  0x20, 0x70, 0x75, 0x62, 0x6c, 0x69, 0x63, 0x20, 0x64, 0x6f, 0x6d, 0x61,
+  0x69, 0x6e, 0x2e, 0x20, 0x47, 0x6c, 0x79, 0x70, 0x68, 0x73, 0x20, 0x69,
+  0x6d, 0x70, 0x6f, 0x72, 0x74, 0x65, 0x64, 0x20, 0x66, 0x72, 0x6f, 0x6d,
+  0x20, 0x41, 0x72, 0x65, 0x76, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20,
+  0x61, 0x72, 0x65, 0x20, 0x28, 0x63, 0x29, 0x20, 0x54, 0x61, 0x76, 0x6d,
+  0x6a, 0x75, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x20, 0x28, 0x73, 0x65,
+  0x65, 0x20, 0x62, 0x65, 0x6c, 0x6f, 0x77, 0x29, 0x0a, 0x0a, 0x42, 0x69,
+  0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x20, 0x56, 0x65, 0x72, 0x61,
+  0x20, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x43, 0x6f, 0x70, 0x79, 0x72,
+  0x69, 0x67, 0x68, 0x74, 0x0a, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
+  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
+  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x0a,
+  0x0a, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74, 0x20, 0x28,
+  0x63, 0x29, 0x20, 0x32, 0x30, 0x30, 0x33, 0x20, 0x62, 0x79, 0x20, 0x42,
+  0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x2c, 0x20, 0x49, 0x6e,
+  0x63, 0x2e, 0x20, 0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69, 0x67, 0x68, 0x74,
+  0x73, 0x20, 0x52, 0x65, 0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2e, 0x20,
+  0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x20, 0x56, 0x65,
+  0x72, 0x61, 0x20, 0x69, 0x73, 0x0a, 0x61, 0x20, 0x74, 0x72, 0x61, 0x64,
+  0x65, 0x6d, 0x61, 0x72, 0x6b, 0x20, 0x6f, 0x66, 0x20, 0x42, 0x69, 0x74,
+  0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e,
+  0x0a, 0x0a, 0x50, 0x65, 0x72, 0x6d, 0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e,
+  0x20, 0x69, 0x73, 0x20, 0x68, 0x65, 0x72, 0x65, 0x62, 0x79, 0x20, 0x67,
+  0x72, 0x61, 0x6e, 0x74, 0x65, 0x64, 0x2c, 0x20, 0x66, 0x72, 0x65, 0x65,
+  0x20, 0x6f, 0x66, 0x20, 0x63, 0x68, 0x61, 0x72, 0x67, 0x65, 0x2c, 0x20,
+  0x74, 0x6f, 0x20, 0x61, 0x6e, 0x79, 0x20, 0x70, 0x65, 0x72, 0x73, 0x6f,
+  0x6e, 0x20, 0x6f, 0x62, 0x74, 0x61, 0x69, 0x6e, 0x69, 0x6e, 0x67, 0x20,
+  0x61, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x0a, 0x6f, 0x66, 0x20, 0x74, 0x68,
+  0x65, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x61, 0x63, 0x63, 0x6f,
+  0x6d, 0x70, 0x61, 0x6e, 0x79, 0x69, 0x6e, 0x67, 0x20, 0x74, 0x68, 0x69,
+  0x73, 0x20, 0x6c, 0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x28, 0x22,
+  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x22, 0x29, 0x20, 0x61, 0x6e, 0x64, 0x20,
+  0x61, 0x73, 0x73, 0x6f, 0x63, 0x69, 0x61, 0x74, 0x65, 0x64, 0x0a, 0x64,
+  0x6f, 0x63, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e,
+  0x20, 0x66, 0x69, 0x6c, 0x65, 0x73, 0x20, 0x28, 0x74, 0x68, 0x65, 0x20,
+  0x22, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61,
+  0x72, 0x65, 0x22, 0x29, 0x2c, 0x20, 0x74, 0x6f, 0x20, 0x72, 0x65, 0x70,
+  0x72, 0x6f, 0x64, 0x75, 0x63, 0x65, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x64,
+  0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75, 0x74, 0x65, 0x20, 0x74, 0x68,
+  0x65, 0x0a, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77,
+  0x61, 0x72, 0x65, 0x2c, 0x20, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x69,
+  0x6e, 0x67, 0x20, 0x77, 0x69, 0x74, 0x68, 0x6f, 0x75, 0x74, 0x20, 0x6c,
+  0x69, 0x6d, 0x69, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x74, 0x68,
+  0x65, 0x20, 0x72, 0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x74, 0x6f, 0x20,
+  0x75, 0x73, 0x65, 0x2c, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x2c, 0x20, 0x6d,
+  0x65, 0x72, 0x67, 0x65, 0x2c, 0x0a, 0x70, 0x75, 0x62, 0x6c, 0x69, 0x73,
+  0x68, 0x2c, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75, 0x74,
+  0x65, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x2f, 0x6f, 0x72, 0x20, 0x73, 0x65,
+  0x6c, 0x6c, 0x20, 0x63, 0x6f, 0x70, 0x69, 0x65, 0x73, 0x20, 0x6f, 0x66,
+  0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f,
+  0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x20,
+  0x74, 0x6f, 0x20, 0x70, 0x65, 0x72, 0x6d, 0x69, 0x74, 0x0a, 0x70, 0x65,
+  0x72, 0x73, 0x6f, 0x6e, 0x73, 0x20, 0x74, 0x6f, 0x20, 0x77, 0x68, 0x6f,
+  0x6d, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53,
+  0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x69, 0x73, 0x20, 0x66,
+  0x75, 0x72, 0x6e, 0x69, 0x73, 0x68, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20,
+  0x64, 0x6f, 0x20, 0x73, 0x6f, 0x2c, 0x20, 0x73, 0x75, 0x62, 0x6a, 0x65,
+  0x63, 0x74, 0x20, 0x74, 0x6f, 0x20, 0x74, 0x68, 0x65, 0x0a, 0x66, 0x6f,
+  0x6c, 0x6c, 0x6f, 0x77, 0x69, 0x6e, 0x67, 0x20, 0x63, 0x6f, 0x6e, 0x64,
+  0x69, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x3a, 0x0a, 0x0a, 0x54, 0x68, 0x65,
+  0x20, 0x61, 0x62, 0x6f, 0x76, 0x65, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x72,
+  0x69, 0x67, 0x68, 0x74, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x72, 0x61,
+  0x64, 0x65, 0x6d, 0x61, 0x72, 0x6b, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63,
+  0x65, 0x73, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20,
+  0x70, 0x65, 0x72, 0x6d, 0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x6e,
+  0x6f, 0x74, 0x69, 0x63, 0x65, 0x20, 0x73, 0x68, 0x61, 0x6c, 0x6c, 0x0a,
+  0x62, 0x65, 0x20, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x64, 0x20,
+  0x69, 0x6e, 0x20, 0x61, 0x6c, 0x6c, 0x20, 0x63, 0x6f, 0x70, 0x69, 0x65,
+  0x73, 0x20, 0x6f, 0x66, 0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20,
+  0x6d, 0x6f, 0x72, 0x65, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20,
+  0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72,
+  0x65, 0x20, 0x74, 0x79, 0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x2e,
+  0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53,
+  0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x6d, 0x61, 0x79, 0x20,
+  0x62, 0x65, 0x20, 0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x2c,
+  0x20, 0x61, 0x6c, 0x74, 0x65, 0x72, 0x65, 0x64, 0x2c, 0x20, 0x6f, 0x72,
+  0x20, 0x61, 0x64, 0x64, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x2c, 0x20, 0x61,
+  0x6e, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x70, 0x61, 0x72, 0x74, 0x69, 0x63,
+  0x75, 0x6c, 0x61, 0x72, 0x0a, 0x74, 0x68, 0x65, 0x20, 0x64, 0x65, 0x73,
+  0x69, 0x67, 0x6e, 0x73, 0x20, 0x6f, 0x66, 0x20, 0x67, 0x6c, 0x79, 0x70,
+  0x68, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x63, 0x68, 0x61, 0x72, 0x61, 0x63,
+  0x74, 0x65, 0x72, 0x73, 0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x65, 0x20,
+  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65,
+  0x20, 0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e,
+  0x64, 0x0a, 0x61, 0x64, 0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x61, 0x6c,
+  0x20, 0x67, 0x6c, 0x79, 0x70, 0x68, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x63,
+  0x68, 0x61, 0x72, 0x61, 0x63, 0x74, 0x65, 0x72, 0x73, 0x20, 0x6d, 0x61,
+  0x79, 0x20, 0x62, 0x65, 0x20, 0x61, 0x64, 0x64, 0x65, 0x64, 0x20, 0x74,
+  0x6f, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x2c,
+  0x20, 0x6f, 0x6e, 0x6c, 0x79, 0x20, 0x69, 0x66, 0x20, 0x74, 0x68, 0x65,
+  0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x0a, 0x61, 0x72, 0x65, 0x20, 0x72,
+  0x65, 0x6e, 0x61, 0x6d, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x6e, 0x61,
+  0x6d, 0x65, 0x73, 0x20, 0x6e, 0x6f, 0x74, 0x20, 0x63, 0x6f, 0x6e, 0x74,
+  0x61, 0x69, 0x6e, 0x69, 0x6e, 0x67, 0x20, 0x65, 0x69, 0x74, 0x68, 0x65,
+  0x72, 0x20, 0x74, 0x68, 0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x73, 0x20,
+  0x22, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x22, 0x20,
+  0x6f, 0x72, 0x20, 0x74, 0x68, 0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x0a,
+  0x22, 0x56, 0x65, 0x72, 0x61, 0x22, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x69,
+  0x73, 0x20, 0x4c, 0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x62, 0x65,
+  0x63, 0x6f, 0x6d, 0x65, 0x73, 0x20, 0x6e, 0x75, 0x6c, 0x6c, 0x20, 0x61,
+  0x6e, 0x64, 0x20, 0x76, 0x6f, 0x69, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x74,
+  0x68, 0x65, 0x20, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x74, 0x20, 0x61, 0x70,
+  0x70, 0x6c, 0x69, 0x63, 0x61, 0x62, 0x6c, 0x65, 0x20, 0x74, 0x6f, 0x20,
+  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x46, 0x6f, 0x6e,
+  0x74, 0x0a, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x74,
+  0x68, 0x61, 0x74, 0x20, 0x68, 0x61, 0x73, 0x20, 0x62, 0x65, 0x65, 0x6e,
+  0x20, 0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e,
+  0x64, 0x20, 0x69, 0x73, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72, 0x69, 0x62,
+  0x75, 0x74, 0x65, 0x64, 0x20, 0x75, 0x6e, 0x64, 0x65, 0x72, 0x20, 0x74,
+  0x68, 0x65, 0x20, 0x22, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61,
+  0x6d, 0x0a, 0x56, 0x65, 0x72, 0x61, 0x22, 0x20, 0x6e, 0x61, 0x6d, 0x65,
+  0x73, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74,
+  0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x6d, 0x61,
+  0x79, 0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64, 0x20, 0x61, 0x73,
+  0x20, 0x70, 0x61, 0x72, 0x74, 0x20, 0x6f, 0x66, 0x20, 0x61, 0x20, 0x6c,
+  0x61, 0x72, 0x67, 0x65, 0x72, 0x20, 0x73, 0x6f, 0x66, 0x74, 0x77, 0x61,
+  0x72, 0x65, 0x20, 0x70, 0x61, 0x63, 0x6b, 0x61, 0x67, 0x65, 0x20, 0x62,
+  0x75, 0x74, 0x20, 0x6e, 0x6f, 0x0a, 0x63, 0x6f, 0x70, 0x79, 0x20, 0x6f,
+  0x66, 0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20, 0x6d, 0x6f, 0x72,
+  0x65, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e,
+  0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x74,
+  0x79, 0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x20, 0x6d, 0x61, 0x79,
+  0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64, 0x20, 0x62, 0x79, 0x20,
+  0x69, 0x74, 0x73, 0x65, 0x6c, 0x66, 0x2e, 0x0a, 0x0a, 0x54, 0x48, 0x45,
+  0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46, 0x54, 0x57, 0x41,
+  0x52, 0x45, 0x20, 0x49, 0x53, 0x20, 0x50, 0x52, 0x4f, 0x56, 0x49, 0x44,
+  0x45, 0x44, 0x20, 0x22, 0x41, 0x53, 0x20, 0x49, 0x53, 0x22, 0x2c, 0x20,
+  0x57, 0x49, 0x54, 0x48, 0x4f, 0x55, 0x54, 0x20, 0x57, 0x41, 0x52, 0x52,
+  0x41, 0x4e, 0x54, 0x59, 0x20, 0x4f, 0x46, 0x20, 0x41, 0x4e, 0x59, 0x20,
+  0x4b, 0x49, 0x4e, 0x44, 0x2c, 0x20, 0x45, 0x58, 0x50, 0x52, 0x45, 0x53,
+  0x53, 0x0a, 0x4f, 0x52, 0x20, 0x49, 0x4d, 0x50, 0x4c, 0x49, 0x45, 0x44,
+  0x2c, 0x20, 0x49, 0x4e, 0x43, 0x4c, 0x55, 0x44, 0x49, 0x4e, 0x47, 0x20,
+  0x42, 0x55, 0x54, 0x20, 0x4e, 0x4f, 0x54, 0x20, 0x4c, 0x49, 0x4d, 0x49,
+  0x54, 0x45, 0x44, 0x20, 0x54, 0x4f, 0x20, 0x41, 0x4e, 0x59, 0x20, 0x57,
+  0x41, 0x52, 0x52, 0x41, 0x4e, 0x54, 0x49, 0x45, 0x53, 0x20, 0x4f, 0x46,
+  0x20, 0x4d, 0x45, 0x52, 0x43, 0x48, 0x41, 0x4e, 0x54, 0x41, 0x42, 0x49,
+  0x4c, 0x49, 0x54, 0x59, 0x2c, 0x0a, 0x46, 0x49, 0x54, 0x4e, 0x45, 0x53,
+  0x53, 0x20, 0x46, 0x4f, 0x52, 0x20, 0x41, 0x20, 0x50, 0x41, 0x52, 0x54,
+  0x49, 0x43, 0x55, 0x4c, 0x41, 0x52, 0x20, 0x50, 0x55, 0x52, 0x50, 0x4f,
+  0x53, 0x45, 0x20, 0x41, 0x4e, 0x44, 0x20, 0x4e, 0x4f, 0x4e, 0x49, 0x4e,
+  0x46, 0x52, 0x49, 0x4e, 0x47, 0x45, 0x4d, 0x45, 0x4e, 0x54, 0x20, 0x4f,
+  0x46, 0x20, 0x43, 0x4f, 0x50, 0x59, 0x52, 0x49, 0x47, 0x48, 0x54, 0x2c,
+  0x20, 0x50, 0x41, 0x54, 0x45, 0x4e, 0x54, 0x2c, 0x0a, 0x54, 0x52, 0x41,
+  0x44, 0x45, 0x4d, 0x41, 0x52, 0x4b, 0x2c, 0x20, 0x4f, 0x52, 0x20, 0x4f,
+  0x54, 0x48, 0x45, 0x52, 0x20, 0x52, 0x49, 0x47, 0x48, 0x54, 0x2e, 0x20,
+  0x49, 0x4e, 0x20, 0x4e, 0x4f, 0x20, 0x45, 0x56, 0x45, 0x4e, 0x54, 0x20,
+  0x53, 0x48, 0x41, 0x4c, 0x4c, 0x20, 0x42, 0x49, 0x54, 0x53, 0x54, 0x52,
+  0x45, 0x41, 0x4d, 0x20, 0x4f, 0x52, 0x20, 0x54, 0x48, 0x45, 0x20, 0x47,
+  0x4e, 0x4f, 0x4d, 0x45, 0x0a, 0x46, 0x4f, 0x55, 0x4e, 0x44, 0x41, 0x54,
+  0x49, 0x4f, 0x4e, 0x20, 0x42, 0x45, 0x20, 0x4c, 0x49, 0x41, 0x42, 0x4c,
+  0x45, 0x20, 0x46, 0x4f, 0x52, 0x20, 0x41, 0x4e, 0x59, 0x20, 0x43, 0x4c,
+  0x41, 0x49, 0x4d, 0x2c, 0x20, 0x44, 0x41, 0x4d, 0x41, 0x47, 0x45, 0x53,
+  0x20, 0x4f, 0x52, 0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x20, 0x4c, 0x49,
+  0x41, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x2c, 0x20, 0x49, 0x4e, 0x43,
+  0x4c, 0x55, 0x44, 0x49, 0x4e, 0x47, 0x0a, 0x41, 0x4e, 0x59, 0x20, 0x47,
+  0x45, 0x4e, 0x45, 0x52, 0x41, 0x4c, 0x2c, 0x20, 0x53, 0x50, 0x45, 0x43,
+  0x49, 0x41, 0x4c, 0x2c, 0x20, 0x49, 0x4e, 0x44, 0x49, 0x52, 0x45, 0x43,
+  0x54, 0x2c, 0x20, 0x49, 0x4e, 0x43, 0x49, 0x44, 0x45, 0x4e, 0x54, 0x41,
+  0x4c, 0x2c, 0x20, 0x4f, 0x52, 0x20, 0x43, 0x4f, 0x4e, 0x53, 0x45, 0x51,
+  0x55, 0x45, 0x4e, 0x54, 0x49, 0x41, 0x4c, 0x20, 0x44, 0x41, 0x4d, 0x41,
+  0x47, 0x45, 0x53, 0x2c, 0x0a, 0x57, 0x48, 0x45, 0x54, 0x48, 0x45, 0x52,
+  0x20, 0x49, 0x4e, 0x20, 0x41, 0x4e, 0x20, 0x41, 0x43, 0x54, 0x49, 0x4f,
+  0x4e, 0x20, 0x4f, 0x46, 0x20, 0x43, 0x4f, 0x4e, 0x54, 0x52, 0x41, 0x43,
+  0x54, 0x2c, 0x20, 0x54, 0x4f, 0x52, 0x54, 0x20, 0x4f, 0x52, 0x20, 0x4f,
+  0x54, 0x48, 0x45, 0x52, 0x57, 0x49, 0x53, 0x45, 0x2c, 0x20, 0x41, 0x52,
+  0x49, 0x53, 0x49, 0x4e, 0x47, 0x20, 0x46, 0x52, 0x4f, 0x4d, 0x2c, 0x20,
+  0x4f, 0x55, 0x54, 0x20, 0x4f, 0x46, 0x0a, 0x54, 0x48, 0x45, 0x20, 0x55,
+  0x53, 0x45, 0x20, 0x4f, 0x52, 0x20, 0x49, 0x4e, 0x41, 0x42, 0x49, 0x4c,
+  0x49, 0x54, 0x59, 0x20, 0x54, 0x4f, 0x20, 0x55, 0x53, 0x45, 0x20, 0x54,
+  0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46, 0x54,
+  0x57, 0x41, 0x52, 0x45, 0x20, 0x4f, 0x52, 0x20, 0x46, 0x52, 0x4f, 0x4d,
+  0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x20, 0x44, 0x45, 0x41, 0x4c, 0x49,
+  0x4e, 0x47, 0x53, 0x20, 0x49, 0x4e, 0x20, 0x54, 0x48, 0x45, 0x0a, 0x46,
+  0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46, 0x54, 0x57, 0x41, 0x52, 0x45,
+  0x2e, 0x0a, 0x0a, 0x45, 0x78, 0x63, 0x65, 0x70, 0x74, 0x20, 0x61, 0x73,
+  0x20, 0x63, 0x6f, 0x6e, 0x74, 0x61, 0x69, 0x6e, 0x65, 0x64, 0x20, 0x69,
+  0x6e, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63,
+  0x65, 0x2c, 0x20, 0x74, 0x68, 0x65, 0x20, 0x6e, 0x61, 0x6d, 0x65, 0x73,
+  0x20, 0x6f, 0x66, 0x20, 0x47, 0x6e, 0x6f, 0x6d, 0x65, 0x2c, 0x20, 0x74,
+  0x68, 0x65, 0x20, 0x47, 0x6e, 0x6f, 0x6d, 0x65, 0x0a, 0x46, 0x6f, 0x75,
+  0x6e, 0x64, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2c, 0x20, 0x61, 0x6e, 0x64,
+  0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x20, 0x49,
+  0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x73, 0x68, 0x61, 0x6c, 0x6c, 0x20, 0x6e,
+  0x6f, 0x74, 0x20, 0x62, 0x65, 0x20, 0x75, 0x73, 0x65, 0x64, 0x20, 0x69,
+  0x6e, 0x20, 0x61, 0x64, 0x76, 0x65, 0x72, 0x74, 0x69, 0x73, 0x69, 0x6e,
+  0x67, 0x20, 0x6f, 0x72, 0x0a, 0x6f, 0x74, 0x68, 0x65, 0x72, 0x77, 0x69,
+  0x73, 0x65, 0x20, 0x74, 0x6f, 0x20, 0x70, 0x72, 0x6f, 0x6d, 0x6f, 0x74,
+  0x65, 0x20, 0x74, 0x68, 0x65, 0x20, 0x73, 0x61, 0x6c, 0x65, 0x2c, 0x20,
+  0x75, 0x73, 0x65, 0x20, 0x6f, 0x72, 0x20, 0x6f, 0x74, 0x68, 0x65, 0x72,
+  0x20, 0x64, 0x65, 0x61, 0x6c, 0x69, 0x6e, 0x67, 0x73, 0x20, 0x69, 0x6e,
+  0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53,
+  0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x0a, 0x77, 0x69, 0x74, 0x68,
+  0x6f, 0x75, 0x74, 0x20, 0x70, 0x72, 0x69, 0x6f, 0x72, 0x20, 0x77, 0x72,
+  0x69, 0x74, 0x74, 0x65, 0x6e, 0x20, 0x61, 0x75, 0x74, 0x68, 0x6f, 0x72,
+  0x69, 0x7a, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x66, 0x72, 0x6f, 0x6d,
+  0x20, 0x74, 0x68, 0x65, 0x20, 0x47, 0x6e, 0x6f, 0x6d, 0x65, 0x20, 0x46,
+  0x6f, 0x75, 0x6e, 0x64, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x6f, 0x72,
+  0x20, 0x42, 0x69, 0x74, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x0a, 0x49,
+  0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x72, 0x65, 0x73, 0x70, 0x65, 0x63, 0x74,
+  0x69, 0x76, 0x65, 0x6c, 0x79, 0x2e, 0x20, 0x46, 0x6f, 0x72, 0x20, 0x66,
+  0x75, 0x72, 0x74, 0x68, 0x65, 0x72, 0x20, 0x69, 0x6e, 0x66, 0x6f, 0x72,
+  0x6d, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2c, 0x20, 0x63, 0x6f, 0x6e, 0x74,
+  0x61, 0x63, 0x74, 0x3a, 0x20, 0x66, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x61,
+  0x74, 0x20, 0x67, 0x6e, 0x6f, 0x6d, 0x65, 0x20, 0x64, 0x6f, 0x74, 0x0a,
+  0x6f, 0x72, 0x67, 0x2e, 0x20, 0x0a, 0x0a, 0x41, 0x72, 0x65, 0x76, 0x20,
+  0x46, 0x6f, 0x6e, 0x74, 0x73, 0x20, 0x43, 0x6f, 0x70, 0x79, 0x72, 0x69,
+  0x67, 0x68, 0x74, 0x0a, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
+  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d,
+  0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x2d, 0x0a, 0x0a,
+  0x43, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74, 0x20, 0x28, 0x63,
+  0x29, 0x20, 0x32, 0x30, 0x30, 0x36, 0x20, 0x62, 0x79, 0x20, 0x54, 0x61,
+  0x76, 0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x2e, 0x20,
+  0x41, 0x6c, 0x6c, 0x20, 0x52, 0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52,
+  0x65, 0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2e, 0x0a, 0x0a, 0x50, 0x65,
+  0x72, 0x6d, 0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x69, 0x73, 0x20,
+  0x68, 0x65, 0x72, 0x65, 0x62, 0x79, 0x20, 0x67, 0x72, 0x61, 0x6e, 0x74,
+  0x65, 0x64, 0x2c, 0x20, 0x66, 0x72, 0x65, 0x65, 0x20, 0x6f, 0x66, 0x20,
+  0x63, 0x68, 0x61, 0x72, 0x67, 0x65, 0x2c, 0x20, 0x74, 0x6f, 0x20, 0x61,
+  0x6e, 0x79, 0x20, 0x70, 0x65, 0x72, 0x73, 0x6f, 0x6e, 0x20, 0x6f, 0x62,
+  0x74, 0x61, 0x69, 0x6e, 0x69, 0x6e, 0x67, 0x0a, 0x61, 0x20, 0x63, 0x6f,
+  0x70, 0x79, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x66, 0x6f,
+  0x6e, 0x74, 0x73, 0x20, 0x61, 0x63, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x6e,
+  0x79, 0x69, 0x6e, 0x67, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x6c, 0x69,
+  0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x28, 0x22, 0x46, 0x6f, 0x6e, 0x74,
+  0x73, 0x22, 0x29, 0x20, 0x61, 0x6e, 0x64, 0x0a, 0x61, 0x73, 0x73, 0x6f,
+  0x63, 0x69, 0x61, 0x74, 0x65, 0x64, 0x20, 0x64, 0x6f, 0x63, 0x75, 0x6d,
+  0x65, 0x6e, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x66, 0x69, 0x6c,
+  0x65, 0x73, 0x20, 0x28, 0x74, 0x68, 0x65, 0x20, 0x22, 0x46, 0x6f, 0x6e,
+  0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x22, 0x29,
+  0x2c, 0x20, 0x74, 0x6f, 0x20, 0x72, 0x65, 0x70, 0x72, 0x6f, 0x64, 0x75,
+  0x63, 0x65, 0x0a, 0x61, 0x6e, 0x64, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72,
+  0x69, 0x62, 0x75, 0x74, 0x65, 0x20, 0x74, 0x68, 0x65, 0x20, 0x6d, 0x6f,
+  0x64, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x20,
+  0x74, 0x6f, 0x20, 0x74, 0x68, 0x65, 0x20, 0x42, 0x69, 0x74, 0x73, 0x74,
+  0x72, 0x65, 0x61, 0x6d, 0x20, 0x56, 0x65, 0x72, 0x61, 0x20, 0x46, 0x6f,
+  0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x2c,
+  0x0a, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x69, 0x6e, 0x67, 0x20, 0x77,
+  0x69, 0x74, 0x68, 0x6f, 0x75, 0x74, 0x20, 0x6c, 0x69, 0x6d, 0x69, 0x74,
+  0x61, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x74, 0x68, 0x65, 0x20, 0x72, 0x69,
+  0x67, 0x68, 0x74, 0x73, 0x20, 0x74, 0x6f, 0x20, 0x75, 0x73, 0x65, 0x2c,
+  0x20, 0x63, 0x6f, 0x70, 0x79, 0x2c, 0x20, 0x6d, 0x65, 0x72, 0x67, 0x65,
+  0x2c, 0x20, 0x70, 0x75, 0x62, 0x6c, 0x69, 0x73, 0x68, 0x2c, 0x0a, 0x64,
+  0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75, 0x74, 0x65, 0x2c, 0x20, 0x61,
+  0x6e, 0x64, 0x2f, 0x6f, 0x72, 0x20, 0x73, 0x65, 0x6c, 0x6c, 0x20, 0x63,
+  0x6f, 0x70, 0x69, 0x65, 0x73, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65,
+  0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61,
+  0x72, 0x65, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x70,
+  0x65, 0x72, 0x6d, 0x69, 0x74, 0x0a, 0x70, 0x65, 0x72, 0x73, 0x6f, 0x6e,
+  0x73, 0x20, 0x74, 0x6f, 0x20, 0x77, 0x68, 0x6f, 0x6d, 0x20, 0x74, 0x68,
+  0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77,
+  0x61, 0x72, 0x65, 0x20, 0x69, 0x73, 0x20, 0x66, 0x75, 0x72, 0x6e, 0x69,
+  0x73, 0x68, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x64, 0x6f, 0x20, 0x73,
+  0x6f, 0x2c, 0x20, 0x73, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x20, 0x74,
+  0x6f, 0x0a, 0x74, 0x68, 0x65, 0x20, 0x66, 0x6f, 0x6c, 0x6c, 0x6f, 0x77,
+  0x69, 0x6e, 0x67, 0x20, 0x63, 0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69, 0x6f,
+  0x6e, 0x73, 0x3a, 0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x61, 0x62, 0x6f,
+  0x76, 0x65, 0x20, 0x63, 0x6f, 0x70, 0x79, 0x72, 0x69, 0x67, 0x68, 0x74,
+  0x20, 0x61, 0x6e, 0x64, 0x20, 0x74, 0x72, 0x61, 0x64, 0x65, 0x6d, 0x61,
+  0x72, 0x6b, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63, 0x65, 0x73, 0x20, 0x61,
+  0x6e, 0x64, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x70, 0x65, 0x72, 0x6d,
+  0x69, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63,
+  0x65, 0x0a, 0x73, 0x68, 0x61, 0x6c, 0x6c, 0x20, 0x62, 0x65, 0x20, 0x69,
+  0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x61,
+  0x6c, 0x6c, 0x20, 0x63, 0x6f, 0x70, 0x69, 0x65, 0x73, 0x20, 0x6f, 0x66,
+  0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20, 0x6d, 0x6f, 0x72, 0x65,
+  0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74,
+  0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x0a, 0x74, 0x79,
+  0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x2e, 0x0a, 0x0a, 0x54, 0x68,
+  0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77,
+  0x61, 0x72, 0x65, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x20, 0x6d,
+  0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x2c, 0x20, 0x61, 0x6c, 0x74,
+  0x65, 0x72, 0x65, 0x64, 0x2c, 0x20, 0x6f, 0x72, 0x20, 0x61, 0x64, 0x64,
+  0x65, 0x64, 0x20, 0x74, 0x6f, 0x2c, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x69,
+  0x6e, 0x0a, 0x70, 0x61, 0x72, 0x74, 0x69, 0x63, 0x75, 0x6c, 0x61, 0x72,
+  0x20, 0x74, 0x68, 0x65, 0x20, 0x64, 0x65, 0x73, 0x69, 0x67, 0x6e, 0x73,
+  0x20, 0x6f, 0x66, 0x20, 0x67, 0x6c, 0x79, 0x70, 0x68, 0x73, 0x20, 0x6f,
+  0x72, 0x20, 0x63, 0x68, 0x61, 0x72, 0x61, 0x63, 0x74, 0x65, 0x72, 0x73,
+  0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x65, 0x20, 0x46, 0x6f, 0x6e, 0x74,
+  0x73, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x0a, 0x6d, 0x6f, 0x64,
+  0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e, 0x64, 0x20, 0x61, 0x64,
+  0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x61, 0x6c, 0x20, 0x67, 0x6c, 0x79,
+  0x70, 0x68, 0x73, 0x20, 0x6f, 0x72, 0x20, 0x63, 0x68, 0x61, 0x72, 0x61,
+  0x63, 0x74, 0x65, 0x72, 0x73, 0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65,
+  0x20, 0x61, 0x64, 0x64, 0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x74, 0x68,
+  0x65, 0x0a, 0x46, 0x6f, 0x6e, 0x74, 0x73, 0x2c, 0x20, 0x6f, 0x6e, 0x6c,
+  0x79, 0x20, 0x69, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20, 0x66, 0x6f, 0x6e,
+  0x74, 0x73, 0x20, 0x61, 0x72, 0x65, 0x20, 0x72, 0x65, 0x6e, 0x61, 0x6d,
+  0x65, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x20,
+  0x6e, 0x6f, 0x74, 0x20, 0x63, 0x6f, 0x6e, 0x74, 0x61, 0x69, 0x6e, 0x69,
+  0x6e, 0x67, 0x20, 0x65, 0x69, 0x74, 0x68, 0x65, 0x72, 0x0a, 0x74, 0x68,
+  0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x73, 0x20, 0x22, 0x54, 0x61, 0x76,
+  0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x22, 0x20, 0x6f,
+  0x72, 0x20, 0x74, 0x68, 0x65, 0x20, 0x77, 0x6f, 0x72, 0x64, 0x20, 0x22,
+  0x41, 0x72, 0x65, 0x76, 0x22, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x69, 0x73,
+  0x20, 0x4c, 0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x20, 0x62, 0x65, 0x63,
+  0x6f, 0x6d, 0x65, 0x73, 0x20, 0x6e, 0x75, 0x6c, 0x6c, 0x20, 0x61, 0x6e,
+  0x64, 0x20, 0x76, 0x6f, 0x69, 0x64, 0x20, 0x74, 0x6f, 0x20, 0x74, 0x68,
+  0x65, 0x20, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x74, 0x20, 0x61, 0x70, 0x70,
+  0x6c, 0x69, 0x63, 0x61, 0x62, 0x6c, 0x65, 0x20, 0x74, 0x6f, 0x20, 0x46,
+  0x6f, 0x6e, 0x74, 0x73, 0x0a, 0x6f, 0x72, 0x20, 0x46, 0x6f, 0x6e, 0x74,
+  0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x74, 0x68,
+  0x61, 0x74, 0x20, 0x68, 0x61, 0x73, 0x20, 0x62, 0x65, 0x65, 0x6e, 0x20,
+  0x6d, 0x6f, 0x64, 0x69, 0x66, 0x69, 0x65, 0x64, 0x20, 0x61, 0x6e, 0x64,
+  0x20, 0x69, 0x73, 0x20, 0x64, 0x69, 0x73, 0x74, 0x72, 0x69, 0x62, 0x75,
+  0x74, 0x65, 0x64, 0x20, 0x75, 0x6e, 0x64, 0x65, 0x72, 0x20, 0x74, 0x68,
+  0x65, 0x20, 0x0a, 0x22, 0x54, 0x61, 0x76, 0x6d, 0x6a, 0x6f, 0x6e, 0x67,
+  0x20, 0x42, 0x61, 0x68, 0x20, 0x41, 0x72, 0x65, 0x76, 0x22, 0x20, 0x6e,
+  0x61, 0x6d, 0x65, 0x73, 0x2e, 0x0a, 0x0a, 0x54, 0x68, 0x65, 0x20, 0x46,
+  0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65,
+  0x20, 0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64,
+  0x20, 0x61, 0x73, 0x20, 0x70, 0x61, 0x72, 0x74, 0x20, 0x6f, 0x66, 0x20,
+  0x61, 0x20, 0x6c, 0x61, 0x72, 0x67, 0x65, 0x72, 0x20, 0x73, 0x6f, 0x66,
+  0x74, 0x77, 0x61, 0x72, 0x65, 0x20, 0x70, 0x61, 0x63, 0x6b, 0x61, 0x67,
+  0x65, 0x20, 0x62, 0x75, 0x74, 0x0a, 0x6e, 0x6f, 0x20, 0x63, 0x6f, 0x70,
+  0x79, 0x20, 0x6f, 0x66, 0x20, 0x6f, 0x6e, 0x65, 0x20, 0x6f, 0x72, 0x20,
+  0x6d, 0x6f, 0x72, 0x65, 0x20, 0x6f, 0x66, 0x20, 0x74, 0x68, 0x65, 0x20,
+  0x46, 0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72,
+  0x65, 0x20, 0x74, 0x79, 0x70, 0x65, 0x66, 0x61, 0x63, 0x65, 0x73, 0x20,
+  0x6d, 0x61, 0x79, 0x20, 0x62, 0x65, 0x20, 0x73, 0x6f, 0x6c, 0x64, 0x20,
+  0x62, 0x79, 0x0a, 0x69, 0x74, 0x73, 0x65, 0x6c, 0x66, 0x2e, 0x0a, 0x0a,
+  0x54, 0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f, 0x46,
+  0x54, 0x57, 0x41, 0x52, 0x45, 0x20, 0x49, 0x53, 0x20, 0x50, 0x52, 0x4f,
+  0x56, 0x49, 0x44, 0x45, 0x44, 0x20, 0x22, 0x41, 0x53, 0x20, 0x49, 0x53,
+  0x22, 0x2c, 0x20, 0x57, 0x49, 0x54, 0x48, 0x4f, 0x55, 0x54, 0x20, 0x57,
+  0x41, 0x52, 0x52, 0x41, 0x4e, 0x54, 0x59, 0x20, 0x4f, 0x46, 0x20, 0x41,
+  0x4e, 0x59, 0x20, 0x4b, 0x49, 0x4e, 0x44, 0x2c, 0x0a, 0x45, 0x58, 0x50,
+  0x52, 0x45, 0x53, 0x53, 0x20, 0x4f, 0x52, 0x20, 0x49, 0x4d, 0x50, 0x4c,
+  0x49, 0x45, 0x44, 0x2c, 0x20, 0x49, 0x4e, 0x43, 0x4c, 0x55, 0x44, 0x49,
+  0x4e, 0x47, 0x20, 0x42, 0x55, 0x54, 0x20, 0x4e, 0x4f, 0x54, 0x20, 0x4c,
+  0x49, 0x4d, 0x49, 0x54, 0x45, 0x44, 0x20, 0x54, 0x4f, 0x20, 0x41, 0x4e,
+  0x59, 0x20, 0x57, 0x41, 0x52, 0x52, 0x41, 0x4e, 0x54, 0x49, 0x45, 0x53,
+  0x20, 0x4f, 0x46, 0x0a, 0x4d, 0x45, 0x52, 0x43, 0x48, 0x41, 0x4e, 0x54,
+  0x41, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x2c, 0x20, 0x46, 0x49, 0x54,
+  0x4e, 0x45, 0x53, 0x53, 0x20, 0x46, 0x4f, 0x52, 0x20, 0x41, 0x20, 0x50,
+  0x41, 0x52, 0x54, 0x49, 0x43, 0x55, 0x4c, 0x41, 0x52, 0x20, 0x50, 0x55,
+  0x52, 0x50, 0x4f, 0x53, 0x45, 0x20, 0x41, 0x4e, 0x44, 0x20, 0x4e, 0x4f,
+  0x4e, 0x49, 0x4e, 0x46, 0x52, 0x49, 0x4e, 0x47, 0x45, 0x4d, 0x45, 0x4e,
+  0x54, 0x0a, 0x4f, 0x46, 0x20, 0x43, 0x4f, 0x50, 0x59, 0x52, 0x49, 0x47,
+  0x48, 0x54, 0x2c, 0x20, 0x50, 0x41, 0x54, 0x45, 0x4e, 0x54, 0x2c, 0x20,
+  0x54, 0x52, 0x41, 0x44, 0x45, 0x4d, 0x41, 0x52, 0x4b, 0x2c, 0x20, 0x4f,
+  0x52, 0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x20, 0x52, 0x49, 0x47, 0x48,
+  0x54, 0x2e, 0x20, 0x49, 0x4e, 0x20, 0x4e, 0x4f, 0x20, 0x45, 0x56, 0x45,
+  0x4e, 0x54, 0x20, 0x53, 0x48, 0x41, 0x4c, 0x4c, 0x0a, 0x54, 0x41, 0x56,
+  0x4d, 0x4a, 0x4f, 0x4e, 0x47, 0x20, 0x42, 0x41, 0x48, 0x20, 0x42, 0x45,
+  0x20, 0x4c, 0x49, 0x41, 0x42, 0x4c, 0x45, 0x20, 0x46, 0x4f, 0x52, 0x20,
+  0x41, 0x4e, 0x59, 0x20, 0x43, 0x4c, 0x41, 0x49, 0x4d, 0x2c, 0x20, 0x44,
+  0x41, 0x4d, 0x41, 0x47, 0x45, 0x53, 0x20, 0x4f, 0x52, 0x20, 0x4f, 0x54,
+  0x48, 0x45, 0x52, 0x20, 0x4c, 0x49, 0x41, 0x42, 0x49, 0x4c, 0x49, 0x54,
+  0x59, 0x2c, 0x0a, 0x49, 0x4e, 0x43, 0x4c, 0x55, 0x44, 0x49, 0x4e, 0x47,
+  0x20, 0x41, 0x4e, 0x59, 0x20, 0x47, 0x45, 0x4e, 0x45, 0x52, 0x41, 0x4c,
+  0x2c, 0x20, 0x53, 0x50, 0x45, 0x43, 0x49, 0x41, 0x4c, 0x2c, 0x20, 0x49,
+  0x4e, 0x44, 0x49, 0x52, 0x45, 0x43, 0x54, 0x2c, 0x20, 0x49, 0x4e, 0x43,
+  0x49, 0x44, 0x45, 0x4e, 0x54, 0x41, 0x4c, 0x2c, 0x20, 0x4f, 0x52, 0x20,
+  0x43, 0x4f, 0x4e, 0x53, 0x45, 0x51, 0x55, 0x45, 0x4e, 0x54, 0x49, 0x41,
+  0x4c, 0x0a, 0x44, 0x41, 0x4d, 0x41, 0x47, 0x45, 0x53, 0x2c, 0x20, 0x57,
+  0x48, 0x45, 0x54, 0x48, 0x45, 0x52, 0x20, 0x49, 0x4e, 0x20, 0x41, 0x4e,
+  0x20, 0x41, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x20, 0x4f, 0x46, 0x20, 0x43,
+  0x4f, 0x4e, 0x54, 0x52, 0x41, 0x43, 0x54, 0x2c, 0x20, 0x54, 0x4f, 0x52,
+  0x54, 0x20, 0x4f, 0x52, 0x20, 0x4f, 0x54, 0x48, 0x45, 0x52, 0x57, 0x49,
+  0x53, 0x45, 0x2c, 0x20, 0x41, 0x52, 0x49, 0x53, 0x49, 0x4e, 0x47, 0x0a,
+  0x46, 0x52, 0x4f, 0x4d, 0x2c, 0x20, 0x4f, 0x55, 0x54, 0x20, 0x4f, 0x46,
+  0x20, 0x54, 0x48, 0x45, 0x20, 0x55, 0x53, 0x45, 0x20, 0x4f, 0x52, 0x20,
+  0x49, 0x4e, 0x41, 0x42, 0x49, 0x4c, 0x49, 0x54, 0x59, 0x20, 0x54, 0x4f,
+  0x20, 0x55, 0x53, 0x45, 0x20, 0x54, 0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e,
+  0x54, 0x20, 0x53, 0x4f, 0x46, 0x54, 0x57, 0x41, 0x52, 0x45, 0x20, 0x4f,
+  0x52, 0x20, 0x46, 0x52, 0x4f, 0x4d, 0x0a, 0x4f, 0x54, 0x48, 0x45, 0x52,
+  0x20, 0x44, 0x45, 0x41, 0x4c, 0x49, 0x4e, 0x47, 0x53, 0x20, 0x49, 0x4e,
+  0x20, 0x54, 0x48, 0x45, 0x20, 0x46, 0x4f, 0x4e, 0x54, 0x20, 0x53, 0x4f,
+  0x46, 0x54, 0x57, 0x41, 0x52, 0x45, 0x2e, 0x0a, 0x0a, 0x45, 0x78, 0x63,
+  0x65, 0x70, 0x74, 0x20, 0x61, 0x73, 0x20, 0x63, 0x6f, 0x6e, 0x74, 0x61,
+  0x69, 0x6e, 0x65, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x69, 0x73,
+  0x20, 0x6e, 0x6f, 0x74, 0x69, 0x63, 0x65, 0x2c, 0x20, 0x74, 0x68, 0x65,
+  0x20, 0x6e, 0x61, 0x6d, 0x65, 0x20, 0x6f, 0x66, 0x20, 0x54, 0x61, 0x76,
+  0x6d, 0x6a, 0x6f, 0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x20, 0x73, 0x68,
+  0x61, 0x6c, 0x6c, 0x20, 0x6e, 0x6f, 0x74, 0x0a, 0x62, 0x65, 0x20, 0x75,
+  0x73, 0x65, 0x64, 0x20, 0x69, 0x6e, 0x20, 0x61, 0x64, 0x76, 0x65, 0x72,
+  0x74, 0x69, 0x73, 0x69, 0x6e, 0x67, 0x20, 0x6f, 0x72, 0x20, 0x6f, 0x74,
+  0x68, 0x65, 0x72, 0x77, 0x69, 0x73, 0x65, 0x20, 0x74, 0x6f, 0x20, 0x70,
+  0x72, 0x6f, 0x6d, 0x6f, 0x74, 0x65, 0x20, 0x74, 0x68, 0x65, 0x20, 0x73,
+  0x61, 0x6c, 0x65, 0x2c, 0x20, 0x75, 0x73, 0x65, 0x20, 0x6f, 0x72, 0x20,
+  0x6f, 0x74, 0x68, 0x65, 0x72, 0x0a, 0x64, 0x65, 0x61, 0x6c, 0x69, 0x6e,
+  0x67, 0x73, 0x20, 0x69, 0x6e, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 0x46,
+  0x6f, 0x6e, 0x74, 0x20, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72, 0x65,
+  0x20, 0x77, 0x69, 0x74, 0x68, 0x6f, 0x75, 0x74, 0x20, 0x70, 0x72, 0x69,
+  0x6f, 0x72, 0x20, 0x77, 0x72, 0x69, 0x74, 0x74, 0x65, 0x6e, 0x20, 0x61,
+  0x75, 0x74, 0x68, 0x6f, 0x72, 0x69, 0x7a, 0x61, 0x74, 0x69, 0x6f, 0x6e,
+  0x0a, 0x66, 0x72, 0x6f, 0x6d, 0x20, 0x54, 0x61, 0x76, 0x6d, 0x6a, 0x6f,
+  0x6e, 0x67, 0x20, 0x42, 0x61, 0x68, 0x2e, 0x20, 0x46, 0x6f, 0x72, 0x20,
+  0x66, 0x75, 0x72, 0x74, 0x68, 0x65, 0x72, 0x20, 0x69, 0x6e, 0x66, 0x6f,
+  0x72, 0x6d, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2c, 0x20, 0x63, 0x6f, 0x6e,
+  0x74, 0x61, 0x63, 0x74, 0x3a, 0x20, 0x74, 0x61, 0x76, 0x6d, 0x6a, 0x6f,
+  0x6e, 0x67, 0x20, 0x40, 0x20, 0x66, 0x72, 0x65, 0x65, 0x0a, 0x2e, 0x20,
+  0x66, 0x72, 0x2e, 0x00, 0x00, 0x68, 0x00, 0x74, 0x00, 0x74, 0x00, 0x70,
+  0x00, 0x3a, 0x00, 0x2f, 0x00, 0x2f, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6a,
+  0x00, 0x61, 0x00, 0x76, 0x00, 0x75, 0x00, 0x2e, 0x00, 0x73, 0x00, 0x6f,
+  0x00, 0x75, 0x00, 0x72, 0x00, 0x63, 0x00, 0x65, 0x00, 0x66, 0x00, 0x6f,
+  0x00, 0x72, 0x00, 0x67, 0x00, 0x65, 0x00, 0x2e, 0x00, 0x6e, 0x00, 0x65,
+  0x00, 0x74, 0x00, 0x2f, 0x00, 0x77, 0x00, 0x69, 0x00, 0x6b, 0x00, 0x69,
+  0x00, 0x2f, 0x00, 0x69, 0x00, 0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x78,
+  0x00, 0x2e, 0x00, 0x70, 0x00, 0x68, 0x00, 0x70, 0x00, 0x2f, 0x00, 0x4c,
+  0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65,
+  0x00, 0x00, 0x68, 0x74, 0x74, 0x70, 0x3a, 0x2f, 0x2f, 0x64, 0x65, 0x6a,
+  0x61, 0x76, 0x75, 0x2e, 0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x66, 0x6f,
+  0x72, 0x67, 0x65, 0x2e, 0x6e, 0x65, 0x74, 0x2f, 0x77, 0x69, 0x6b, 0x69,
+  0x2f, 0x69, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x70, 0x68, 0x70, 0x2f, 0x4c,
+  0x69, 0x63, 0x65, 0x6e, 0x73, 0x65, 0x00, 0x00, 0x44, 0x00, 0x65, 0x00,
+  0x6a, 0x00, 0x61, 0x00, 0x56, 0x00, 0x75, 0x00, 0x20, 0x00, 0x4c, 0x00,
+  0x47, 0x00, 0x43, 0x00, 0x20, 0x00, 0x53, 0x00, 0x61, 0x00, 0x6e, 0x00,
+  0x73, 0x00, 0x00, 0x44, 0x65, 0x6a, 0x61, 0x56, 0x75, 0x20, 0x4c, 0x47,
+  0x43, 0x20, 0x53, 0x61, 0x6e, 0x73, 0x00, 0x00, 0x43, 0x00, 0x6f, 0x00,
+  0x6e, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6e, 0x00, 0x73, 0x00, 0x65, 0x00,
+  0x64, 0x00, 0x00, 0x43, 0x6f, 0x6e, 0x64, 0x65, 0x6e, 0x73, 0x65, 0x64,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0xff, 0x7e, 0x00, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+  0x12, 0x0e, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04,
+  0x00, 0x05, 0x00, 0x06, 0x00, 0x07, 0x00, 0x08, 0x00, 0x09, 0x00, 0x0a,
+  0x00, 0x0b, 0x00, 0x0c, 0x00, 0x0d, 0x00, 0x0e, 0x00, 0x0f, 0x00, 0x10,
+  0x00, 0x11, 0x00, 0x12, 0x00, 0x13, 0x00, 0x14, 0x00, 0x15, 0x00, 0x16,
+  0x00, 0x17, 0x00, 0x18, 0x00, 0x19, 0x00, 0x1a, 0x00, 0x1b, 0x00, 0x1c,
+  0x00, 0x1d, 0x00, 0x1e, 0x00, 0x1f, 0x00, 0x20, 0x00, 0x21, 0x00, 0x22,
+  0x00, 0x23, 0x00, 0x24, 0x00, 0x25, 0x00, 0x26, 0x00, 0x27, 0x00, 0x28,
+  0x00, 0x29, 0x00, 0x2a, 0x00, 0x2b, 0x00, 0x2c, 0x00, 0x2d, 0x00, 0x2e,
+  0x00, 0x2f, 0x00, 0x30, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34,
+  0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39, 0x00, 0x3a,
+  0x00, 0x3b, 0x00, 0x3c, 0x00, 0x3d, 0x00, 0x3e, 0x00, 0x3f, 0x00, 0x40,
+  0x00, 0x41, 0x00, 0x42, 0x00, 0x43, 0x00, 0x44, 0x00, 0x45, 0x00, 0x46,
+  0x00, 0x47, 0x00, 0x48, 0x00, 0x49, 0x00, 0x4a, 0x00, 0x4b, 0x00, 0x4c,
+  0x00, 0x4d, 0x00, 0x4e, 0x00, 0x4f, 0x00, 0x50, 0x00, 0x51, 0x00, 0x52,
+  0x00, 0x53, 0x00, 0x54, 0x00, 0x55, 0x00, 0x56, 0x00, 0x57, 0x00, 0x58,
+  0x00, 0x59, 0x00, 0x5a, 0x00, 0x5b, 0x00, 0x5c, 0x00, 0x5d, 0x00, 0x5e,
+  0x00, 0x5f, 0x00, 0x60, 0x00, 0x61, 0x00, 0xac, 0x00, 0xa3, 0x00, 0x84,
+  0x00, 0x85, 0x00, 0xbd, 0x00, 0x96, 0x00, 0xe8, 0x00, 0x86, 0x00, 0x8e,
+  0x00, 0x8b, 0x00, 0x9d, 0x00, 0xa9, 0x00, 0xa4, 0x01, 0x02, 0x00, 0x8a,
+  0x00, 0xda, 0x00, 0x83, 0x00, 0x93, 0x00, 0xf2, 0x00, 0xf3, 0x00, 0x8d,
+  0x00, 0x97, 0x00, 0x88, 0x00, 0xc3, 0x00, 0xde, 0x00, 0xf1, 0x00, 0x9e,
+  0x00, 0xaa, 0x00, 0xf5, 0x00, 0xf4, 0x00, 0xf6, 0x00, 0xa2, 0x00, 0xad,
+  0x00, 0xc9, 0x00, 0xc7, 0x00, 0xae, 0x00, 0x62, 0x00, 0x63, 0x00, 0x90,
+  0x00, 0x64, 0x00, 0xcb, 0x00, 0x65, 0x00, 0xc8, 0x00, 0xca, 0x00, 0xcf,
+  0x00, 0xcc, 0x00, 0xcd, 0x00, 0xce, 0x00, 0xe9, 0x00, 0x66, 0x00, 0xd3,
+  0x00, 0xd0, 0x00, 0xd1, 0x00, 0xaf, 0x00, 0x67, 0x00, 0xf0, 0x00, 0x91,
+  0x00, 0xd6, 0x00, 0xd4, 0x00, 0xd5, 0x00, 0x68, 0x00, 0xeb, 0x00, 0xed,
+  0x00, 0x89, 0x00, 0x6a, 0x00, 0x69, 0x00, 0x6b, 0x00, 0x6d, 0x00, 0x6c,
+  0x00, 0x6e, 0x00, 0xa0, 0x00, 0x6f, 0x00, 0x71, 0x00, 0x70, 0x00, 0x72,
+  0x00, 0x73, 0x00, 0x75, 0x00, 0x74, 0x00, 0x76, 0x00, 0x77, 0x00, 0xea,
+  0x00, 0x78, 0x00, 0x7a, 0x00, 0x79, 0x00, 0x7b, 0x00, 0x7d, 0x00, 0x7c,
+  0x00, 0xb8, 0x00, 0xa1, 0x00, 0x7f, 0x00, 0x7e, 0x00, 0x80, 0x00, 0x81,
+  0x00, 0xec, 0x00, 0xee, 0x00, 0xba, 0x01, 0x03, 0x01, 0x04, 0x01, 0x05,
+  0x01, 0x06, 0x01, 0x07, 0x01, 0x08, 0x00, 0xfd, 0x00, 0xfe, 0x01, 0x09,
+  0x01, 0x0a, 0x01, 0x0b, 0x01, 0x0c, 0x00, 0xff, 0x01, 0x00, 0x01, 0x0d,
+  0x01, 0x0e, 0x01, 0x0f, 0x01, 0x01, 0x01, 0x10, 0x01, 0x11, 0x01, 0x12,
+  0x01, 0x13, 0x01, 0x14, 0x01, 0x15, 0x01, 0x16, 0x01, 0x17, 0x01, 0x18,
+  0x01, 0x19, 0x01, 0x1a, 0x01, 0x1b, 0x00, 0xf8, 0x00, 0xf9, 0x01, 0x1c,
+  0x01, 0x1d, 0x01, 0x1e, 0x01, 0x1f, 0x01, 0x20, 0x01, 0x21, 0x01, 0x22,
+  0x01, 0x23, 0x01, 0x24, 0x01, 0x25, 0x01, 0x26, 0x01, 0x27, 0x01, 0x28,
+  0x01, 0x29, 0x01, 0x2a, 0x01, 0x2b, 0x00, 0xfa, 0x00, 0xd7, 0x01, 0x2c,
+  0x01, 0x2d, 0x01, 0x2e, 0x01, 0x2f, 0x01, 0x30, 0x01, 0x31, 0x01, 0x32,
+  0x01, 0x33, 0x01, 0x34, 0x01, 0x35, 0x01, 0x36, 0x01, 0x37, 0x01, 0x38,
+  0x01, 0x39, 0x01, 0x3a, 0x00, 0xe2, 0x00, 0xe3, 0x01, 0x3b, 0x01, 0x3c,
+  0x01, 0x3d, 0x01, 0x3e, 0x01, 0x3f, 0x01, 0x40, 0x01, 0x41, 0x01, 0x42,
+  0x01, 0x43, 0x01, 0x44, 0x01, 0x45, 0x01, 0x46, 0x01, 0x47, 0x01, 0x48,
+  0x01, 0x49, 0x00, 0xb0, 0x00, 0xb1, 0x01, 0x4a, 0x01, 0x4b, 0x01, 0x4c,
+  0x01, 0x4d, 0x01, 0x4e, 0x01, 0x4f, 0x01, 0x50, 0x01, 0x51, 0x01, 0x52,
+  0x01, 0x53, 0x00, 0xfb, 0x00, 0xfc, 0x00, 0xe4, 0x00, 0xe5, 0x01, 0x54,
+  0x01, 0x55, 0x01, 0x56, 0x01, 0x57, 0x01, 0x58, 0x01, 0x59, 0x01, 0x5a,
+  0x01, 0x5b, 0x01, 0x5c, 0x01, 0x5d, 0x01, 0x5e, 0x01, 0x5f, 0x01, 0x60,
+  0x01, 0x61, 0x01, 0x62, 0x01, 0x63, 0x01, 0x64, 0x01, 0x65, 0x01, 0x66,
+  0x01, 0x67, 0x01, 0x68, 0x01, 0x69, 0x00, 0xbb, 0x01, 0x6a, 0x01, 0x6b,
+  0x01, 0x6c, 0x01, 0x6d, 0x00, 0xe6, 0x00, 0xe7, 0x01, 0x6e, 0x01, 0x6f,
+  0x01, 0x70, 0x01, 0x71, 0x01, 0x72, 0x01, 0x73, 0x01, 0x74, 0x01, 0x75,
+  0x01, 0x76, 0x01, 0x77, 0x01, 0x78, 0x01, 0x79, 0x01, 0x7a, 0x01, 0x7b,
+  0x01, 0x7c, 0x01, 0x7d, 0x01, 0x7e, 0x01, 0x7f, 0x01, 0x80, 0x00, 0xa6,
+  0x01, 0x81, 0x01, 0x82, 0x01, 0x83, 0x01, 0x84, 0x01, 0x85, 0x01, 0x86,
+  0x01, 0x87, 0x01, 0x88, 0x01, 0x89, 0x01, 0x8a, 0x01, 0x8b, 0x01, 0x8c,
+  0x01, 0x8d, 0x01, 0x8e, 0x01, 0x8f, 0x01, 0x90, 0x01, 0x91, 0x01, 0x92,
+  0x01, 0x93, 0x01, 0x94, 0x01, 0x95, 0x01, 0x96, 0x01, 0x97, 0x01, 0x98,
+  0x01, 0x99, 0x01, 0x9a, 0x01, 0x9b, 0x01, 0x9c, 0x01, 0x9d, 0x01, 0x9e,
+  0x01, 0x9f, 0x01, 0xa0, 0x01, 0xa1, 0x01, 0xa2, 0x01, 0xa3, 0x01, 0xa4,
+  0x01, 0xa5, 0x01, 0xa6, 0x01, 0xa7, 0x01, 0xa8, 0x01, 0xa9, 0x01, 0xaa,
+  0x01, 0xab, 0x01, 0xac, 0x01, 0xad, 0x01, 0xae, 0x01, 0xaf, 0x01, 0xb0,
+  0x01, 0xb1, 0x01, 0xb2, 0x01, 0xb3, 0x01, 0xb4, 0x01, 0xb5, 0x01, 0xb6,
+  0x01, 0xb7, 0x01, 0xb8, 0x01, 0xb9, 0x01, 0xba, 0x01, 0xbb, 0x01, 0xbc,
+  0x01, 0xbd, 0x01, 0xbe, 0x01, 0xbf, 0x01, 0xc0, 0x01, 0xc1, 0x01, 0xc2,
+  0x01, 0xc3, 0x01, 0xc4, 0x01, 0xc5, 0x01, 0xc6, 0x01, 0xc7, 0x01, 0xc8,
+  0x01, 0xc9, 0x01, 0xca, 0x01, 0xcb, 0x01, 0xcc, 0x01, 0xcd, 0x01, 0xce,
+  0x01, 0xcf, 0x01, 0xd0, 0x01, 0xd1, 0x01, 0xd2, 0x01, 0xd3, 0x01, 0xd4,
+  0x01, 0xd5, 0x01, 0xd6, 0x01, 0xd7, 0x01, 0xd8, 0x01, 0xd9, 0x01, 0xda,
+  0x01, 0xdb, 0x01, 0xdc, 0x01, 0xdd, 0x01, 0xde, 0x01, 0xdf, 0x01, 0xe0,
+  0x01, 0xe1, 0x01, 0xe2, 0x01, 0xe3, 0x01, 0xe4, 0x01, 0xe5, 0x01, 0xe6,
+  0x01, 0xe7, 0x01, 0xe8, 0x01, 0xe9, 0x01, 0xea, 0x01, 0xeb, 0x01, 0xec,
+  0x01, 0xed, 0x01, 0xee, 0x01, 0xef, 0x01, 0xf0, 0x01, 0xf1, 0x01, 0xf2,
+  0x01, 0xf3, 0x01, 0xf4, 0x01, 0xf5, 0x01, 0xf6, 0x01, 0xf7, 0x01, 0xf8,
+  0x01, 0xf9, 0x01, 0xfa, 0x01, 0xfb, 0x01, 0xfc, 0x01, 0xfd, 0x01, 0xfe,
+  0x01, 0xff, 0x02, 0x00, 0x02, 0x01, 0x02, 0x02, 0x02, 0x03, 0x02, 0x04,
+  0x02, 0x05, 0x02, 0x06, 0x02, 0x07, 0x02, 0x08, 0x02, 0x09, 0x02, 0x0a,
+  0x02, 0x0b, 0x02, 0x0c, 0x02, 0x0d, 0x02, 0x0e, 0x02, 0x0f, 0x02, 0x10,
+  0x02, 0x11, 0x02, 0x12, 0x02, 0x13, 0x02, 0x14, 0x02, 0x15, 0x02, 0x16,
+  0x02, 0x17, 0x02, 0x18, 0x02, 0x19, 0x02, 0x1a, 0x02, 0x1b, 0x02, 0x1c,
+  0x02, 0x1d, 0x02, 0x1e, 0x02, 0x1f, 0x02, 0x20, 0x02, 0x21, 0x02, 0x22,
+  0x02, 0x23, 0x02, 0x24, 0x02, 0x25, 0x02, 0x26, 0x02, 0x27, 0x02, 0x28,
+  0x02, 0x29, 0x02, 0x2a, 0x02, 0x2b, 0x02, 0x2c, 0x02, 0x2d, 0x02, 0x2e,
+  0x02, 0x2f, 0x02, 0x30, 0x02, 0x31, 0x02, 0x32, 0x02, 0x33, 0x02, 0x34,
+  0x02, 0x35, 0x02, 0x36, 0x02, 0x37, 0x02, 0x38, 0x02, 0x39, 0x02, 0x3a,
+  0x02, 0x3b, 0x02, 0x3c, 0x02, 0x3d, 0x02, 0x3e, 0x02, 0x3f, 0x02, 0x40,
+  0x02, 0x41, 0x02, 0x42, 0x02, 0x43, 0x02, 0x44, 0x02, 0x45, 0x02, 0x46,
+  0x02, 0x47, 0x02, 0x48, 0x02, 0x49, 0x02, 0x4a, 0x02, 0x4b, 0x02, 0x4c,
+  0x02, 0x4d, 0x02, 0x4e, 0x02, 0x4f, 0x02, 0x50, 0x02, 0x51, 0x02, 0x52,
+  0x02, 0x53, 0x02, 0x54, 0x02, 0x55, 0x02, 0x56, 0x02, 0x57, 0x02, 0x58,
+  0x02, 0x59, 0x02, 0x5a, 0x02, 0x5b, 0x02, 0x5c, 0x02, 0x5d, 0x02, 0x5e,
+  0x02, 0x5f, 0x02, 0x60, 0x02, 0x61, 0x02, 0x62, 0x02, 0x63, 0x02, 0x64,
+  0x02, 0x65, 0x02, 0x66, 0x02, 0x67, 0x02, 0x68, 0x02, 0x69, 0x02, 0x6a,
+  0x02, 0x6b, 0x02, 0x6c, 0x02, 0x6d, 0x02, 0x6e, 0x02, 0x6f, 0x02, 0x70,
+  0x02, 0x71, 0x02, 0x72, 0x02, 0x73, 0x02, 0x74, 0x02, 0x75, 0x02, 0x76,
+  0x02, 0x77, 0x02, 0x78, 0x02, 0x79, 0x02, 0x7a, 0x02, 0x7b, 0x02, 0x7c,
+  0x02, 0x7d, 0x02, 0x7e, 0x02, 0x7f, 0x02, 0x80, 0x02, 0x81, 0x02, 0x82,
+  0x02, 0x83, 0x02, 0x84, 0x02, 0x85, 0x02, 0x86, 0x02, 0x87, 0x02, 0x88,
+  0x02, 0x89, 0x02, 0x8a, 0x02, 0x8b, 0x02, 0x8c, 0x02, 0x8d, 0x02, 0x8e,
+  0x02, 0x8f, 0x02, 0x90, 0x02, 0x91, 0x02, 0x92, 0x02, 0x93, 0x02, 0x94,
+  0x02, 0x95, 0x02, 0x96, 0x02, 0x97, 0x02, 0x98, 0x02, 0x99, 0x02, 0x9a,
+  0x02, 0x9b, 0x02, 0x9c, 0x02, 0x9d, 0x02, 0x9e, 0x02, 0x9f, 0x02, 0xa0,
+  0x02, 0xa1, 0x02, 0xa2, 0x02, 0xa3, 0x02, 0xa4, 0x02, 0xa5, 0x02, 0xa6,
+  0x02, 0xa7, 0x02, 0xa8, 0x02, 0xa9, 0x02, 0xaa, 0x02, 0xab, 0x02, 0xac,
+  0x02, 0xad, 0x02, 0xae, 0x02, 0xaf, 0x02, 0xb0, 0x02, 0xb1, 0x02, 0xb2,
+  0x02, 0xb3, 0x00, 0xd8, 0x00, 0xe1, 0x02, 0xb4, 0x02, 0xb5, 0x02, 0xb6,
+  0x02, 0xb7, 0x02, 0xb8, 0x02, 0xb9, 0x02, 0xba, 0x02, 0xbb, 0x02, 0xbc,
+  0x02, 0xbd, 0x02, 0xbe, 0x02, 0xbf, 0x02, 0xc0, 0x02, 0xc1, 0x02, 0xc2,
+  0x02, 0xc3, 0x00, 0xdb, 0x00, 0xdc, 0x00, 0xdd, 0x00, 0xe0, 0x00, 0xd9,
+  0x00, 0xdf, 0x02, 0xc4, 0x02, 0xc5, 0x02, 0xc6, 0x02, 0xc7, 0x02, 0xc8,
+  0x02, 0xc9, 0x02, 0xca, 0x02, 0xcb, 0x02, 0xcc, 0x02, 0xcd, 0x02, 0xce,
+  0x02, 0xcf, 0x02, 0xd0, 0x02, 0xd1, 0x02, 0xd2, 0x02, 0xd3, 0x02, 0xd4,
+  0x02, 0xd5, 0x02, 0xd6, 0x02, 0xd7, 0x02, 0xd8, 0x02, 0xd9, 0x02, 0xda,
+  0x02, 0xdb, 0x02, 0xdc, 0x02, 0xdd, 0x02, 0xde, 0x02, 0xdf, 0x02, 0xe0,
+  0x02, 0xe1, 0x02, 0xe2, 0x02, 0xe3, 0x02, 0xe4, 0x02, 0xe5, 0x02, 0xe6,
+  0x02, 0xe7, 0x02, 0xe8, 0x02, 0xe9, 0x02, 0xea, 0x02, 0xeb, 0x02, 0xec,
+  0x02, 0xed, 0x02, 0xee, 0x02, 0xef, 0x02, 0xf0, 0x02, 0xf1, 0x02, 0xf2,
+  0x02, 0xf3, 0x02, 0xf4, 0x02, 0xf5, 0x02, 0xf6, 0x02, 0xf7, 0x02, 0xf8,
+  0x02, 0xf9, 0x02, 0xfa, 0x02, 0xfb, 0x02, 0xfc, 0x02, 0xfd, 0x02, 0xfe,
+  0x02, 0xff, 0x03, 0x00, 0x03, 0x01, 0x03, 0x02, 0x03, 0x03, 0x03, 0x04,
+  0x03, 0x05, 0x03, 0x06, 0x03, 0x07, 0x03, 0x08, 0x03, 0x09, 0x03, 0x0a,
+  0x03, 0x0b, 0x03, 0x0c, 0x03, 0x0d, 0x03, 0x0e, 0x03, 0x0f, 0x03, 0x10,
+  0x03, 0x11, 0x03, 0x12, 0x03, 0x13, 0x03, 0x14, 0x03, 0x15, 0x03, 0x16,
+  0x03, 0x17, 0x03, 0x18, 0x03, 0x19, 0x03, 0x1a, 0x03, 0x1b, 0x03, 0x1c,
+  0x03, 0x1d, 0x03, 0x1e, 0x03, 0x1f, 0x03, 0x20, 0x03, 0x21, 0x03, 0x22,
+  0x03, 0x23, 0x03, 0x24, 0x03, 0x25, 0x03, 0x26, 0x03, 0x27, 0x03, 0x28,
+  0x03, 0x29, 0x03, 0x2a, 0x03, 0x2b, 0x03, 0x2c, 0x03, 0x2d, 0x03, 0x2e,
+  0x03, 0x2f, 0x03, 0x30, 0x03, 0x31, 0x03, 0x32, 0x03, 0x33, 0x03, 0x34,
+  0x03, 0x35, 0x03, 0x36, 0x03, 0x37, 0x03, 0x38, 0x03, 0x39, 0x03, 0x3a,
+  0x03, 0x3b, 0x03, 0x3c, 0x03, 0x3d, 0x03, 0x3e, 0x03, 0x3f, 0x03, 0x40,
+  0x03, 0x41, 0x03, 0x42, 0x03, 0x43, 0x03, 0x44, 0x03, 0x45, 0x03, 0x46,
+  0x03, 0x47, 0x03, 0x48, 0x03, 0x49, 0x03, 0x4a, 0x03, 0x4b, 0x03, 0x4c,
+  0x03, 0x4d, 0x03, 0x4e, 0x03, 0x4f, 0x03, 0x50, 0x03, 0x51, 0x03, 0x52,
+  0x03, 0x53, 0x03, 0x54, 0x03, 0x55, 0x03, 0x56, 0x03, 0x57, 0x03, 0x58,
+  0x03, 0x59, 0x03, 0x5a, 0x03, 0x5b, 0x03, 0x5c, 0x03, 0x5d, 0x03, 0x5e,
+  0x03, 0x5f, 0x03, 0x60, 0x00, 0x9f, 0x03, 0x61, 0x03, 0x62, 0x03, 0x63,
+  0x03, 0x64, 0x03, 0x65, 0x03, 0x66, 0x03, 0x67, 0x03, 0x68, 0x03, 0x69,
+  0x03, 0x6a, 0x03, 0x6b, 0x03, 0x6c, 0x03, 0x6d, 0x03, 0x6e, 0x03, 0x6f,
+  0x03, 0x70, 0x03, 0x71, 0x03, 0x72, 0x03, 0x73, 0x03, 0x74, 0x03, 0x75,
+  0x03, 0x76, 0x00, 0x9b, 0x03, 0x77, 0x03, 0x78, 0x03, 0x79, 0x03, 0x7a,
+  0x03, 0x7b, 0x03, 0x7c, 0x03, 0x7d, 0x03, 0x7e, 0x03, 0x7f, 0x03, 0x80,
+  0x03, 0x81, 0x03, 0x82, 0x03, 0x83, 0x03, 0x84, 0x03, 0x85, 0x03, 0x86,
+  0x03, 0x87, 0x03, 0x88, 0x03, 0x89, 0x03, 0x8a, 0x03, 0x8b, 0x03, 0x8c,
+  0x03, 0x8d, 0x03, 0x8e, 0x03, 0x8f, 0x03, 0x90, 0x03, 0x91, 0x03, 0x92,
+  0x03, 0x93, 0x03, 0x94, 0x03, 0x95, 0x03, 0x96, 0x03, 0x97, 0x03, 0x98,
+  0x03, 0x99, 0x03, 0x9a, 0x03, 0x9b, 0x03, 0x9c, 0x03, 0x9d, 0x03, 0x9e,
+  0x03, 0x9f, 0x03, 0xa0, 0x03, 0xa1, 0x03, 0xa2, 0x03, 0xa3, 0x03, 0xa4,
+  0x03, 0xa5, 0x03, 0xa6, 0x03, 0xa7, 0x03, 0xa8, 0x03, 0xa9, 0x03, 0xaa,
+  0x03, 0xab, 0x03, 0xac, 0x03, 0xad, 0x03, 0xae, 0x03, 0xaf, 0x03, 0xb0,
+  0x03, 0xb1, 0x03, 0xb2, 0x03, 0xb3, 0x03, 0xb4, 0x03, 0xb5, 0x03, 0xb6,
+  0x03, 0xb7, 0x03, 0xb8, 0x03, 0xb9, 0x03, 0xba, 0x03, 0xbb, 0x03, 0xbc,
+  0x03, 0xbd, 0x03, 0xbe, 0x03, 0xbf, 0x03, 0xc0, 0x03, 0xc1, 0x03, 0xc2,
+  0x03, 0xc3, 0x03, 0xc4, 0x03, 0xc5, 0x03, 0xc6, 0x03, 0xc7, 0x03, 0xc8,
+  0x03, 0xc9, 0x03, 0xca, 0x03, 0xcb, 0x03, 0xcc, 0x03, 0xcd, 0x03, 0xce,
+  0x03, 0xcf, 0x03, 0xd0, 0x03, 0xd1, 0x03, 0xd2, 0x03, 0xd3, 0x03, 0xd4,
+  0x03, 0xd5, 0x03, 0xd6, 0x03, 0xd7, 0x03, 0xd8, 0x03, 0xd9, 0x03, 0xda,
+  0x03, 0xdb, 0x03, 0xdc, 0x03, 0xdd, 0x03, 0xde, 0x03, 0xdf, 0x03, 0xe0,
+  0x03, 0xe1, 0x03, 0xe2, 0x03, 0xe3, 0x03, 0xe4, 0x03, 0xe5, 0x03, 0xe6,
+  0x03, 0xe7, 0x03, 0xe8, 0x03, 0xe9, 0x03, 0xea, 0x03, 0xeb, 0x03, 0xec,
+  0x03, 0xed, 0x03, 0xee, 0x03, 0xef, 0x03, 0xf0, 0x03, 0xf1, 0x03, 0xf2,
+  0x03, 0xf3, 0x03, 0xf4, 0x03, 0xf5, 0x03, 0xf6, 0x03, 0xf7, 0x03, 0xf8,
+  0x03, 0xf9, 0x03, 0xfa, 0x03, 0xfb, 0x03, 0xfc, 0x03, 0xfd, 0x03, 0xfe,
+  0x03, 0xff, 0x04, 0x00, 0x04, 0x01, 0x04, 0x02, 0x04, 0x03, 0x04, 0x04,
+  0x04, 0x05, 0x04, 0x06, 0x04, 0x07, 0x04, 0x08, 0x04, 0x09, 0x04, 0x0a,
+  0x04, 0x0b, 0x04, 0x0c, 0x04, 0x0d, 0x04, 0x0e, 0x04, 0x0f, 0x04, 0x10,
+  0x04, 0x11, 0x04, 0x12, 0x04, 0x13, 0x04, 0x14, 0x04, 0x15, 0x04, 0x16,
+  0x04, 0x17, 0x04, 0x18, 0x04, 0x19, 0x04, 0x1a, 0x04, 0x1b, 0x04, 0x1c,
+  0x04, 0x1d, 0x04, 0x1e, 0x04, 0x1f, 0x04, 0x20, 0x04, 0x21, 0x04, 0x22,
+  0x04, 0x23, 0x04, 0x24, 0x04, 0x25, 0x04, 0x26, 0x04, 0x27, 0x04, 0x28,
+  0x04, 0x29, 0x04, 0x2a, 0x04, 0x2b, 0x04, 0x2c, 0x04, 0x2d, 0x04, 0x2e,
+  0x04, 0x2f, 0x04, 0x30, 0x04, 0x31, 0x04, 0x32, 0x04, 0x33, 0x04, 0x34,
+  0x04, 0x35, 0x04, 0x36, 0x04, 0x37, 0x04, 0x38, 0x04, 0x39, 0x04, 0x3a,
+  0x04, 0x3b, 0x04, 0x3c, 0x04, 0x3d, 0x04, 0x3e, 0x04, 0x3f, 0x04, 0x40,
+  0x04, 0x41, 0x04, 0x42, 0x04, 0x43, 0x04, 0x44, 0x04, 0x45, 0x04, 0x46,
+  0x04, 0x47, 0x04, 0x48, 0x04, 0x49, 0x04, 0x4a, 0x04, 0x4b, 0x04, 0x4c,
+  0x04, 0x4d, 0x04, 0x4e, 0x04, 0x4f, 0x04, 0x50, 0x04, 0x51, 0x04, 0x52,
+  0x04, 0x53, 0x04, 0x54, 0x04, 0x55, 0x04, 0x56, 0x04, 0x57, 0x04, 0x58,
+  0x04, 0x59, 0x04, 0x5a, 0x04, 0x5b, 0x04, 0x5c, 0x04, 0x5d, 0x04, 0x5e,
+  0x04, 0x5f, 0x04, 0x60, 0x04, 0x61, 0x04, 0x62, 0x04, 0x63, 0x04, 0x64,
+  0x04, 0x65, 0x04, 0x66, 0x04, 0x67, 0x04, 0x68, 0x04, 0x69, 0x04, 0x6a,
+  0x04, 0x6b, 0x04, 0x6c, 0x04, 0x6d, 0x04, 0x6e, 0x04, 0x6f, 0x04, 0x70,
+  0x04, 0x71, 0x04, 0x72, 0x04, 0x73, 0x04, 0x74, 0x04, 0x75, 0x04, 0x76,
+  0x04, 0x77, 0x04, 0x78, 0x04, 0x79, 0x04, 0x7a, 0x04, 0x7b, 0x04, 0x7c,
+  0x04, 0x7d, 0x04, 0x7e, 0x04, 0x7f, 0x04, 0x80, 0x04, 0x81, 0x04, 0x82,
+  0x04, 0x83, 0x04, 0x84, 0x04, 0x85, 0x04, 0x86, 0x04, 0x87, 0x04, 0x88,
+  0x04, 0x89, 0x04, 0x8a, 0x04, 0x8b, 0x04, 0x8c, 0x04, 0x8d, 0x04, 0x8e,
+  0x04, 0x8f, 0x04, 0x90, 0x04, 0x91, 0x04, 0x92, 0x04, 0x93, 0x04, 0x94,
+  0x04, 0x95, 0x04, 0x96, 0x04, 0x97, 0x04, 0x98, 0x04, 0x99, 0x04, 0x9a,
+  0x04, 0x9b, 0x04, 0x9c, 0x04, 0x9d, 0x04, 0x9e, 0x04, 0x9f, 0x04, 0xa0,
+  0x04, 0xa1, 0x04, 0xa2, 0x04, 0xa3, 0x04, 0xa4, 0x04, 0xa5, 0x04, 0xa6,
+  0x04, 0xa7, 0x04, 0xa8, 0x04, 0xa9, 0x04, 0xaa, 0x04, 0xab, 0x04, 0xac,
+  0x04, 0xad, 0x04, 0xae, 0x04, 0xaf, 0x04, 0xb0, 0x04, 0xb1, 0x04, 0xb2,
+  0x04, 0xb3, 0x04, 0xb4, 0x04, 0xb5, 0x04, 0xb6, 0x04, 0xb7, 0x04, 0xb8,
+  0x04, 0xb9, 0x04, 0xba, 0x04, 0xbb, 0x04, 0xbc, 0x04, 0xbd, 0x04, 0xbe,
+  0x04, 0xbf, 0x04, 0xc0, 0x04, 0xc1, 0x04, 0xc2, 0x04, 0xc3, 0x04, 0xc4,
+  0x04, 0xc5, 0x04, 0xc6, 0x04, 0xc7, 0x04, 0xc8, 0x04, 0xc9, 0x04, 0xca,
+  0x04, 0xcb, 0x04, 0xcc, 0x04, 0xcd, 0x04, 0xce, 0x04, 0xcf, 0x04, 0xd0,
+  0x04, 0xd1, 0x04, 0xd2, 0x04, 0xd3, 0x04, 0xd4, 0x04, 0xd5, 0x04, 0xd6,
+  0x04, 0xd7, 0x04, 0xd8, 0x04, 0xd9, 0x04, 0xda, 0x04, 0xdb, 0x04, 0xdc,
+  0x04, 0xdd, 0x04, 0xde, 0x04, 0xdf, 0x04, 0xe0, 0x04, 0xe1, 0x04, 0xe2,
+  0x04, 0xe3, 0x04, 0xe4, 0x04, 0xe5, 0x04, 0xe6, 0x04, 0xe7, 0x04, 0xe8,
+  0x04, 0xe9, 0x04, 0xea, 0x04, 0xeb, 0x04, 0xec, 0x04, 0xed, 0x04, 0xee,
+  0x04, 0xef, 0x04, 0xf0, 0x04, 0xf1, 0x04, 0xf2, 0x04, 0xf3, 0x04, 0xf4,
+  0x04, 0xf5, 0x04, 0xf6, 0x04, 0xf7, 0x04, 0xf8, 0x04, 0xf9, 0x04, 0xfa,
+  0x04, 0xfb, 0x04, 0xfc, 0x04, 0xfd, 0x04, 0xfe, 0x04, 0xff, 0x05, 0x00,
+  0x05, 0x01, 0x05, 0x02, 0x05, 0x03, 0x05, 0x04, 0x05, 0x05, 0x05, 0x06,
+  0x05, 0x07, 0x05, 0x08, 0x05, 0x09, 0x05, 0x0a, 0x05, 0x0b, 0x05, 0x0c,
+  0x05, 0x0d, 0x05, 0x0e, 0x05, 0x0f, 0x05, 0x10, 0x05, 0x11, 0x05, 0x12,
+  0x05, 0x13, 0x05, 0x14, 0x05, 0x15, 0x05, 0x16, 0x05, 0x17, 0x05, 0x18,
+  0x05, 0x19, 0x05, 0x1a, 0x05, 0x1b, 0x05, 0x1c, 0x05, 0x1d, 0x05, 0x1e,
+  0x05, 0x1f, 0x05, 0x20, 0x05, 0x21, 0x05, 0x22, 0x05, 0x23, 0x05, 0x24,
+  0x05, 0x25, 0x05, 0x26, 0x05, 0x27, 0x05, 0x28, 0x05, 0x29, 0x05, 0x2a,
+  0x05, 0x2b, 0x05, 0x2c, 0x05, 0x2d, 0x05, 0x2e, 0x05, 0x2f, 0x05, 0x30,
+  0x05, 0x31, 0x05, 0x32, 0x05, 0x33, 0x05, 0x34, 0x05, 0x35, 0x05, 0x36,
+  0x05, 0x37, 0x05, 0x38, 0x05, 0x39, 0x05, 0x3a, 0x05, 0x3b, 0x05, 0x3c,
+  0x05, 0x3d, 0x05, 0x3e, 0x05, 0x3f, 0x05, 0x40, 0x05, 0x41, 0x05, 0x42,
+  0x05, 0x43, 0x05, 0x44, 0x05, 0x45, 0x05, 0x46, 0x05, 0x47, 0x05, 0x48,
+  0x05, 0x49, 0x05, 0x4a, 0x05, 0x4b, 0x05, 0x4c, 0x05, 0x4d, 0x05, 0x4e,
+  0x05, 0x4f, 0x05, 0x50, 0x05, 0x51, 0x05, 0x52, 0x05, 0x53, 0x05, 0x54,
+  0x05, 0x55, 0x05, 0x56, 0x05, 0x57, 0x05, 0x58, 0x05, 0x59, 0x05, 0x5a,
+  0x05, 0x5b, 0x05, 0x5c, 0x05, 0x5d, 0x05, 0x5e, 0x05, 0x5f, 0x05, 0x60,
+  0x05, 0x61, 0x05, 0x62, 0x05, 0x63, 0x05, 0x64, 0x05, 0x65, 0x05, 0x66,
+  0x05, 0x67, 0x05, 0x68, 0x05, 0x69, 0x05, 0x6a, 0x05, 0x6b, 0x05, 0x6c,
+  0x05, 0x6d, 0x05, 0x6e, 0x05, 0x6f, 0x05, 0x70, 0x05, 0x71, 0x05, 0x72,
+  0x05, 0x73, 0x05, 0x74, 0x05, 0x75, 0x05, 0x76, 0x05, 0x77, 0x05, 0x78,
+  0x05, 0x79, 0x05, 0x7a, 0x05, 0x7b, 0x05, 0x7c, 0x05, 0x7d, 0x05, 0x7e,
+  0x05, 0x7f, 0x05, 0x80, 0x05, 0x81, 0x05, 0x82, 0x05, 0x83, 0x05, 0x84,
+  0x05, 0x85, 0x05, 0x86, 0x05, 0x87, 0x05, 0x88, 0x05, 0x89, 0x05, 0x8a,
+  0x05, 0x8b, 0x05, 0x8c, 0x05, 0x8d, 0x05, 0x8e, 0x05, 0x8f, 0x05, 0x90,
+  0x05, 0x91, 0x05, 0x92, 0x05, 0x93, 0x05, 0x94, 0x05, 0x95, 0x05, 0x96,
+  0x05, 0x97, 0x05, 0x98, 0x05, 0x99, 0x05, 0x9a, 0x05, 0x9b, 0x05, 0x9c,
+  0x05, 0x9d, 0x05, 0x9e, 0x05, 0x9f, 0x05, 0xa0, 0x05, 0xa1, 0x05, 0xa2,
+  0x05, 0xa3, 0x05, 0xa4, 0x05, 0xa5, 0x05, 0xa6, 0x05, 0xa7, 0x05, 0xa8,
+  0x05, 0xa9, 0x05, 0xaa, 0x05, 0xab, 0x05, 0xac, 0x05, 0xad, 0x05, 0xae,
+  0x05, 0xaf, 0x05, 0xb0, 0x05, 0xb1, 0x05, 0xb2, 0x05, 0xb3, 0x05, 0xb4,
+  0x05, 0xb5, 0x05, 0xb6, 0x05, 0xb7, 0x05, 0xb8, 0x05, 0xb9, 0x05, 0xba,
+  0x05, 0xbb, 0x05, 0xbc, 0x05, 0xbd, 0x05, 0xbe, 0x05, 0xbf, 0x05, 0xc0,
+  0x05, 0xc1, 0x05, 0xc2, 0x05, 0xc3, 0x05, 0xc4, 0x05, 0xc5, 0x05, 0xc6,
+  0x05, 0xc7, 0x05, 0xc8, 0x05, 0xc9, 0x05, 0xca, 0x05, 0xcb, 0x05, 0xcc,
+  0x05, 0xcd, 0x05, 0xce, 0x05, 0xcf, 0x05, 0xd0, 0x05, 0xd1, 0x05, 0xd2,
+  0x05, 0xd3, 0x05, 0xd4, 0x05, 0xd5, 0x05, 0xd6, 0x05, 0xd7, 0x05, 0xd8,
+  0x05, 0xd9, 0x05, 0xda, 0x05, 0xdb, 0x05, 0xdc, 0x05, 0xdd, 0x05, 0xde,
+  0x05, 0xdf, 0x05, 0xe0, 0x05, 0xe1, 0x05, 0xe2, 0x05, 0xe3, 0x05, 0xe4,
+  0x05, 0xe5, 0x05, 0xe6, 0x05, 0xe7, 0x05, 0xe8, 0x05, 0xe9, 0x05, 0xea,
+  0x05, 0xeb, 0x05, 0xec, 0x05, 0xed, 0x05, 0xee, 0x05, 0xef, 0x05, 0xf0,
+  0x05, 0xf1, 0x05, 0xf2, 0x05, 0xf3, 0x05, 0xf4, 0x05, 0xf5, 0x05, 0xf6,
+  0x05, 0xf7, 0x05, 0xf8, 0x05, 0xf9, 0x05, 0xfa, 0x05, 0xfb, 0x05, 0xfc,
+  0x05, 0xfd, 0x05, 0xfe, 0x05, 0xff, 0x06, 0x00, 0x06, 0x01, 0x06, 0x02,
+  0x06, 0x03, 0x06, 0x04, 0x06, 0x05, 0x06, 0x06, 0x06, 0x07, 0x06, 0x08,
+  0x06, 0x09, 0x06, 0x0a, 0x06, 0x0b, 0x06, 0x0c, 0x06, 0x0d, 0x06, 0x0e,
+  0x06, 0x0f, 0x06, 0x10, 0x06, 0x11, 0x06, 0x12, 0x06, 0x13, 0x06, 0x14,
+  0x06, 0x15, 0x06, 0x16, 0x06, 0x17, 0x06, 0x18, 0x06, 0x19, 0x06, 0x1a,
+  0x06, 0x1b, 0x06, 0x1c, 0x06, 0x1d, 0x06, 0x1e, 0x06, 0x1f, 0x06, 0x20,
+  0x06, 0x21, 0x06, 0x22, 0x06, 0x23, 0x06, 0x24, 0x06, 0x25, 0x06, 0x26,
+  0x06, 0x27, 0x06, 0x28, 0x06, 0x29, 0x06, 0x2a, 0x06, 0x2b, 0x06, 0x2c,
+  0x06, 0x2d, 0x06, 0x2e, 0x06, 0x2f, 0x06, 0x30, 0x06, 0x31, 0x06, 0x32,
+  0x06, 0x33, 0x06, 0x34, 0x06, 0x35, 0x06, 0x36, 0x06, 0x37, 0x06, 0x38,
+  0x06, 0x39, 0x06, 0x3a, 0x06, 0x3b, 0x06, 0x3c, 0x06, 0x3d, 0x06, 0x3e,
+  0x06, 0x3f, 0x06, 0x40, 0x06, 0x41, 0x06, 0x42, 0x06, 0x43, 0x06, 0x44,
+  0x06, 0x45, 0x06, 0x46, 0x06, 0x47, 0x06, 0x48, 0x06, 0x49, 0x06, 0x4a,
+  0x06, 0x4b, 0x06, 0x4c, 0x06, 0x4d, 0x06, 0x4e, 0x06, 0x4f, 0x06, 0x50,
+  0x06, 0x51, 0x06, 0x52, 0x06, 0x53, 0x06, 0x54, 0x06, 0x55, 0x06, 0x56,
+  0x06, 0x57, 0x06, 0x58, 0x06, 0x59, 0x06, 0x5a, 0x06, 0x5b, 0x06, 0x5c,
+  0x06, 0x5d, 0x06, 0x5e, 0x06, 0x5f, 0x06, 0x60, 0x06, 0x61, 0x06, 0x62,
+  0x06, 0x63, 0x06, 0x64, 0x06, 0x65, 0x06, 0x66, 0x06, 0x67, 0x06, 0x68,
+  0x06, 0x69, 0x06, 0x6a, 0x06, 0x6b, 0x06, 0x6c, 0x06, 0x6d, 0x06, 0x6e,
+  0x06, 0x6f, 0x06, 0x70, 0x06, 0x71, 0x06, 0x72, 0x06, 0x73, 0x06, 0x74,
+  0x06, 0x75, 0x06, 0x76, 0x06, 0x77, 0x06, 0x78, 0x06, 0x79, 0x06, 0x7a,
+  0x06, 0x7b, 0x06, 0x7c, 0x06, 0x7d, 0x06, 0x7e, 0x06, 0x7f, 0x06, 0x80,
+  0x06, 0x81, 0x06, 0x82, 0x06, 0x83, 0x06, 0x84, 0x06, 0x85, 0x06, 0x86,
+  0x06, 0x87, 0x06, 0x88, 0x06, 0x89, 0x06, 0x8a, 0x06, 0x8b, 0x06, 0x8c,
+  0x06, 0x8d, 0x06, 0x8e, 0x06, 0x8f, 0x06, 0x90, 0x06, 0x91, 0x06, 0x92,
+  0x06, 0x93, 0x06, 0x94, 0x06, 0x95, 0x06, 0x96, 0x06, 0x97, 0x06, 0x98,
+  0x06, 0x99, 0x06, 0x9a, 0x06, 0x9b, 0x06, 0x9c, 0x06, 0x9d, 0x06, 0x9e,
+  0x06, 0x9f, 0x06, 0xa0, 0x06, 0xa1, 0x06, 0xa2, 0x06, 0xa3, 0x06, 0xa4,
+  0x06, 0xa5, 0x06, 0xa6, 0x06, 0xa7, 0x06, 0xa8, 0x06, 0xa9, 0x06, 0xaa,
+  0x06, 0xab, 0x06, 0xac, 0x06, 0xad, 0x06, 0xae, 0x06, 0xaf, 0x06, 0xb0,
+  0x06, 0xb1, 0x06, 0xb2, 0x06, 0xb3, 0x06, 0xb4, 0x06, 0xb5, 0x06, 0xb6,
+  0x06, 0xb7, 0x06, 0xb8, 0x06, 0xb9, 0x06, 0xba, 0x06, 0xbb, 0x06, 0xbc,
+  0x06, 0xbd, 0x06, 0xbe, 0x06, 0xbf, 0x06, 0xc0, 0x06, 0xc1, 0x06, 0xc2,
+  0x06, 0xc3, 0x06, 0xc4, 0x06, 0xc5, 0x06, 0xc6, 0x06, 0xc7, 0x06, 0xc8,
+  0x06, 0xc9, 0x06, 0xca, 0x06, 0xcb, 0x06, 0xcc, 0x06, 0xcd, 0x06, 0xce,
+  0x06, 0xcf, 0x06, 0xd0, 0x06, 0xd1, 0x06, 0xd2, 0x06, 0xd3, 0x06, 0xd4,
+  0x06, 0xd5, 0x06, 0xd6, 0x06, 0xd7, 0x06, 0xd8, 0x06, 0xd9, 0x06, 0xda,
+  0x06, 0xdb, 0x06, 0xdc, 0x06, 0xdd, 0x06, 0xde, 0x06, 0xdf, 0x06, 0xe0,
+  0x06, 0xe1, 0x06, 0xe2, 0x06, 0xe3, 0x06, 0xe4, 0x06, 0xe5, 0x06, 0xe6,
+  0x06, 0xe7, 0x06, 0xe8, 0x06, 0xe9, 0x06, 0xea, 0x06, 0xeb, 0x06, 0xec,
+  0x06, 0xed, 0x06, 0xee, 0x06, 0xef, 0x06, 0xf0, 0x06, 0xf1, 0x06, 0xf2,
+  0x06, 0xf3, 0x06, 0xf4, 0x06, 0xf5, 0x06, 0xf6, 0x06, 0xf7, 0x06, 0xf8,
+  0x06, 0xf9, 0x06, 0xfa, 0x06, 0xfb, 0x06, 0xfc, 0x06, 0xfd, 0x06, 0xfe,
+  0x06, 0xff, 0x07, 0x00, 0x07, 0x01, 0x07, 0x02, 0x07, 0x03, 0x07, 0x04,
+  0x07, 0x05, 0x07, 0x06, 0x07, 0x07, 0x07, 0x08, 0x07, 0x09, 0x07, 0x0a,
+  0x07, 0x0b, 0x07, 0x0c, 0x07, 0x0d, 0x07, 0x0e, 0x07, 0x0f, 0x07, 0x10,
+  0x07, 0x11, 0x07, 0x12, 0x07, 0x13, 0x07, 0x14, 0x07, 0x15, 0x07, 0x16,
+  0x07, 0x17, 0x07, 0x18, 0x07, 0x19, 0x07, 0x1a, 0x07, 0x1b, 0x07, 0x1c,
+  0x07, 0x1d, 0x07, 0x1e, 0x07, 0x1f, 0x07, 0x20, 0x07, 0x21, 0x07, 0x22,
+  0x07, 0x23, 0x07, 0x24, 0x07, 0x25, 0x07, 0x26, 0x07, 0x27, 0x07, 0x28,
+  0x07, 0x29, 0x07, 0x2a, 0x07, 0x2b, 0x07, 0x2c, 0x07, 0x2d, 0x07, 0x2e,
+  0x07, 0x2f, 0x07, 0x30, 0x07, 0x31, 0x07, 0x32, 0x07, 0x33, 0x07, 0x34,
+  0x07, 0x35, 0x07, 0x36, 0x07, 0x37, 0x07, 0x38, 0x07, 0x39, 0x07, 0x3a,
+  0x07, 0x3b, 0x07, 0x3c, 0x07, 0x3d, 0x07, 0x3e, 0x07, 0x3f, 0x07, 0x40,
+  0x07, 0x41, 0x07, 0x42, 0x07, 0x43, 0x07, 0x44, 0x07, 0x45, 0x07, 0x46,
+  0x07, 0x47, 0x07, 0x48, 0x07, 0x49, 0x07, 0x4a, 0x07, 0x4b, 0x07, 0x4c,
+  0x07, 0x4d, 0x07, 0x4e, 0x07, 0x4f, 0x07, 0x50, 0x07, 0x51, 0x07, 0x52,
+  0x07, 0x53, 0x07, 0x54, 0x07, 0x55, 0x07, 0x56, 0x07, 0x57, 0x07, 0x58,
+  0x07, 0x59, 0x07, 0x5a, 0x07, 0x5b, 0x07, 0x5c, 0x07, 0x5d, 0x07, 0x5e,
+  0x07, 0x5f, 0x07, 0x60, 0x07, 0x61, 0x07, 0x62, 0x07, 0x63, 0x07, 0x64,
+  0x07, 0x65, 0x07, 0x66, 0x07, 0x67, 0x07, 0x68, 0x07, 0x69, 0x00, 0xb2,
+  0x00, 0xb3, 0x07, 0x6a, 0x07, 0x6b, 0x07, 0x6c, 0x00, 0xb6, 0x00, 0xb7,
+  0x00, 0xc4, 0x07, 0x6d, 0x00, 0xb4, 0x00, 0xb5, 0x00, 0xc5, 0x07, 0x6e,
+  0x00, 0x82, 0x00, 0xc2, 0x00, 0x87, 0x07, 0x6f, 0x07, 0x70, 0x07, 0x71,
+  0x00, 0xab, 0x07, 0x72, 0x07, 0x73, 0x07, 0x74, 0x07, 0x75, 0x07, 0x76,
+  0x07, 0x77, 0x07, 0x78, 0x07, 0x79, 0x07, 0x7a, 0x00, 0xc6, 0x07, 0x7b,
+  0x07, 0x7c, 0x07, 0x7d, 0x07, 0x7e, 0x07, 0x7f, 0x07, 0x80, 0x07, 0x81,
+  0x07, 0x82, 0x00, 0xbe, 0x00, 0xbf, 0x07, 0x83, 0x07, 0x84, 0x07, 0x85,
+  0x07, 0x86, 0x07, 0x87, 0x07, 0x88, 0x07, 0x89, 0x07, 0x8a, 0x07, 0x8b,
+  0x00, 0xbc, 0x07, 0x8c, 0x07, 0x8d, 0x07, 0x8e, 0x07, 0x8f, 0x07, 0x90,
+  0x07, 0x91, 0x07, 0x92, 0x07, 0x93, 0x07, 0x94, 0x07, 0x95, 0x07, 0x96,
+  0x07, 0x97, 0x07, 0x98, 0x07, 0x99, 0x07, 0x9a, 0x07, 0x9b, 0x07, 0x9c,
+  0x07, 0x9d, 0x07, 0x9e, 0x07, 0x9f, 0x07, 0xa0, 0x07, 0xa1, 0x07, 0xa2,
+  0x07, 0xa3, 0x07, 0xa4, 0x07, 0xa5, 0x07, 0xa6, 0x07, 0xa7, 0x07, 0xa8,
+  0x07, 0xa9, 0x07, 0xaa, 0x07, 0xab, 0x07, 0xac, 0x07, 0xad, 0x07, 0xae,
+  0x07, 0xaf, 0x07, 0xb0, 0x07, 0xb1, 0x07, 0xb2, 0x07, 0xb3, 0x07, 0xb4,
+  0x07, 0xb5, 0x07, 0xb6, 0x07, 0xb7, 0x07, 0xb8, 0x07, 0xb9, 0x07, 0xba,
+  0x07, 0xbb, 0x07, 0xbc, 0x07, 0xbd, 0x07, 0xbe, 0x07, 0xbf, 0x07, 0xc0,
+  0x07, 0xc1, 0x07, 0xc2, 0x07, 0xc3, 0x07, 0xc4, 0x07, 0xc5, 0x07, 0xc6,
+  0x07, 0xc7, 0x07, 0xc8, 0x07, 0xc9, 0x07, 0xca, 0x07, 0xcb, 0x07, 0xcc,
+  0x07, 0xcd, 0x07, 0xce, 0x07, 0xcf, 0x07, 0xd0, 0x07, 0xd1, 0x07, 0xd2,
+  0x07, 0xd3, 0x07, 0xd4, 0x07, 0xd5, 0x07, 0xd6, 0x07, 0xd7, 0x07, 0xd8,
+  0x07, 0xd9, 0x07, 0xda, 0x07, 0xdb, 0x07, 0xdc, 0x07, 0xdd, 0x07, 0xde,
+  0x00, 0xf7, 0x07, 0xdf, 0x07, 0xe0, 0x07, 0xe1, 0x07, 0xe2, 0x07, 0xe3,
+  0x07, 0xe4, 0x07, 0xe5, 0x07, 0xe6, 0x07, 0xe7, 0x07, 0xe8, 0x07, 0xe9,
+  0x07, 0xea, 0x07, 0xeb, 0x07, 0xec, 0x07, 0xed, 0x07, 0xee, 0x07, 0xef,
+  0x07, 0xf0, 0x07, 0xf1, 0x07, 0xf2, 0x07, 0xf3, 0x07, 0xf4, 0x07, 0xf5,
+  0x07, 0xf6, 0x07, 0xf7, 0x07, 0xf8, 0x07, 0xf9, 0x07, 0xfa, 0x07, 0xfb,
+  0x07, 0xfc, 0x07, 0xfd, 0x07, 0xfe, 0x07, 0xff, 0x08, 0x00, 0x08, 0x01,
+  0x08, 0x02, 0x08, 0x03, 0x08, 0x04, 0x08, 0x05, 0x08, 0x06, 0x08, 0x07,
+  0x08, 0x08, 0x08, 0x09, 0x08, 0x0a, 0x08, 0x0b, 0x08, 0x0c, 0x08, 0x0d,
+  0x08, 0x0e, 0x08, 0x0f, 0x08, 0x10, 0x08, 0x11, 0x08, 0x12, 0x08, 0x13,
+  0x08, 0x14, 0x08, 0x15, 0x08, 0x16, 0x08, 0x17, 0x08, 0x18, 0x08, 0x19,
+  0x08, 0x1a, 0x08, 0x1b, 0x00, 0x8c, 0x08, 0x1c, 0x08, 0x1d, 0x08, 0x1e,
+  0x08, 0x1f, 0x08, 0x20, 0x08, 0x21, 0x08, 0x22, 0x08, 0x23, 0x08, 0x24,
+  0x08, 0x25, 0x08, 0x26, 0x08, 0x27, 0x08, 0x28, 0x08, 0x29, 0x08, 0x2a,
+  0x08, 0x2b, 0x08, 0x2c, 0x08, 0x2d, 0x08, 0x2e, 0x08, 0x2f, 0x08, 0x30,
+  0x08, 0x31, 0x08, 0x32, 0x08, 0x33, 0x08, 0x34, 0x08, 0x35, 0x08, 0x36,
+  0x08, 0x37, 0x08, 0x38, 0x08, 0x39, 0x08, 0x3a, 0x08, 0x3b, 0x08, 0x3c,
+  0x08, 0x3d, 0x08, 0x3e, 0x08, 0x3f, 0x08, 0x40, 0x08, 0x41, 0x08, 0x42,
+  0x08, 0x43, 0x08, 0x44, 0x08, 0x45, 0x08, 0x46, 0x08, 0x47, 0x08, 0x48,
+  0x08, 0x49, 0x08, 0x4a, 0x08, 0x4b, 0x08, 0x4c, 0x08, 0x4d, 0x08, 0x4e,
+  0x08, 0x4f, 0x08, 0x50, 0x08, 0x51, 0x08, 0x52, 0x08, 0x53, 0x08, 0x54,
+  0x08, 0x55, 0x08, 0x56, 0x08, 0x57, 0x08, 0x58, 0x08, 0x59, 0x08, 0x5a,
+  0x08, 0x5b, 0x08, 0x5c, 0x08, 0x5d, 0x08, 0x5e, 0x08, 0x5f, 0x08, 0x60,
+  0x08, 0x61, 0x08, 0x62, 0x08, 0x63, 0x08, 0x64, 0x08, 0x65, 0x08, 0x66,
+  0x08, 0x67, 0x08, 0x68, 0x08, 0x69, 0x08, 0x6a, 0x08, 0x6b, 0x08, 0x6c,
+  0x08, 0x6d, 0x08, 0x6e, 0x08, 0x6f, 0x08, 0x70, 0x08, 0x71, 0x08, 0x72,
+  0x08, 0x73, 0x08, 0x74, 0x08, 0x75, 0x08, 0x76, 0x08, 0x77, 0x08, 0x78,
+  0x08, 0x79, 0x08, 0x7a, 0x08, 0x7b, 0x08, 0x7c, 0x08, 0x7d, 0x08, 0x7e,
+  0x08, 0x7f, 0x08, 0x80, 0x08, 0x81, 0x08, 0x82, 0x08, 0x83, 0x08, 0x84,
+  0x08, 0x85, 0x08, 0x86, 0x08, 0x87, 0x08, 0x88, 0x08, 0x89, 0x08, 0x8a,
+  0x08, 0x8b, 0x08, 0x8c, 0x08, 0x8d, 0x08, 0x8e, 0x08, 0x8f, 0x08, 0x90,
+  0x08, 0x91, 0x08, 0x92, 0x08, 0x93, 0x08, 0x94, 0x08, 0x95, 0x08, 0x96,
+  0x08, 0x97, 0x08, 0x98, 0x08, 0x99, 0x08, 0x9a, 0x08, 0x9b, 0x08, 0x9c,
+  0x08, 0x9d, 0x08, 0x9e, 0x08, 0x9f, 0x08, 0xa0, 0x08, 0xa1, 0x08, 0xa2,
+  0x08, 0xa3, 0x08, 0xa4, 0x08, 0xa5, 0x08, 0xa6, 0x08, 0xa7, 0x08, 0xa8,
+  0x08, 0xa9, 0x08, 0xaa, 0x08, 0xab, 0x08, 0xac, 0x08, 0xad, 0x08, 0xae,
+  0x08, 0xaf, 0x08, 0xb0, 0x08, 0xb1, 0x08, 0xb2, 0x08, 0xb3, 0x08, 0xb4,
+  0x08, 0xb5, 0x08, 0xb6, 0x08, 0xb7, 0x08, 0xb8, 0x08, 0xb9, 0x08, 0xba,
+  0x08, 0xbb, 0x08, 0xbc, 0x08, 0xbd, 0x08, 0xbe, 0x08, 0xbf, 0x08, 0xc0,
+  0x08, 0xc1, 0x08, 0xc2, 0x08, 0xc3, 0x08, 0xc4, 0x08, 0xc5, 0x08, 0xc6,
+  0x08, 0xc7, 0x08, 0xc8, 0x08, 0xc9, 0x08, 0xca, 0x08, 0xcb, 0x08, 0xcc,
+  0x08, 0xcd, 0x08, 0xce, 0x08, 0xcf, 0x08, 0xd0, 0x08, 0xd1, 0x08, 0xd2,
+  0x08, 0xd3, 0x08, 0xd4, 0x08, 0xd5, 0x08, 0xd6, 0x08, 0xd7, 0x08, 0xd8,
+  0x08, 0xd9, 0x08, 0xda, 0x08, 0xdb, 0x08, 0xdc, 0x08, 0xdd, 0x08, 0xde,
+  0x08, 0xdf, 0x08, 0xe0, 0x08, 0xe1, 0x08, 0xe2, 0x08, 0xe3, 0x08, 0xe4,
+  0x08, 0xe5, 0x08, 0xe6, 0x08, 0xe7, 0x08, 0xe8, 0x08, 0xe9, 0x08, 0xea,
+  0x08, 0xeb, 0x08, 0xec, 0x08, 0xed, 0x00, 0x98, 0x08, 0xee, 0x08, 0xef,
+  0x08, 0xf0, 0x00, 0xa8, 0x08, 0xf1, 0x08, 0xf2, 0x08, 0xf3, 0x08, 0xf4,
+  0x08, 0xf5, 0x08, 0xf6, 0x08, 0xf7, 0x08, 0xf8, 0x00, 0x9a, 0x08, 0xf9,
+  0x00, 0x99, 0x00, 0xef, 0x08, 0xfa, 0x08, 0xfb, 0x08, 0xfc, 0x08, 0xfd,
+  0x08, 0xfe, 0x08, 0xff, 0x09, 0x00, 0x00, 0xa5, 0x09, 0x01, 0x09, 0x02,
+  0x09, 0x03, 0x00, 0x92, 0x09, 0x04, 0x09, 0x05, 0x09, 0x06, 0x09, 0x07,
+  0x09, 0x08, 0x09, 0x09, 0x09, 0x0a, 0x09, 0x0b, 0x09, 0x0c, 0x09, 0x0d,
+  0x09, 0x0e, 0x09, 0x0f, 0x00, 0x9c, 0x09, 0x10, 0x09, 0x11, 0x09, 0x12,
+  0x09, 0x13, 0x09, 0x14, 0x09, 0x15, 0x09, 0x16, 0x09, 0x17, 0x09, 0x18,
+  0x09, 0x19, 0x09, 0x1a, 0x09, 0x1b, 0x09, 0x1c, 0x09, 0x1d, 0x09, 0x1e,
+  0x09, 0x1f, 0x09, 0x20, 0x09, 0x21, 0x09, 0x22, 0x09, 0x23, 0x09, 0x24,
+  0x09, 0x25, 0x09, 0x26, 0x09, 0x27, 0x09, 0x28, 0x09, 0x29, 0x09, 0x2a,
+  0x09, 0x2b, 0x00, 0xa7, 0x09, 0x2c, 0x09, 0x2d, 0x09, 0x2e, 0x09, 0x2f,
+  0x09, 0x30, 0x09, 0x31, 0x09, 0x32, 0x09, 0x33, 0x09, 0x34, 0x09, 0x35,
+  0x09, 0x36, 0x09, 0x37, 0x09, 0x38, 0x09, 0x39, 0x09, 0x3a, 0x09, 0x3b,
+  0x09, 0x3c, 0x09, 0x3d, 0x09, 0x3e, 0x09, 0x3f, 0x09, 0x40, 0x09, 0x41,
+  0x09, 0x42, 0x00, 0x8f, 0x09, 0x43, 0x09, 0x44, 0x09, 0x45, 0x00, 0x94,
+  0x00, 0x95, 0x09, 0x46, 0x09, 0x47, 0x09, 0x48, 0x09, 0x49, 0x09, 0x4a,
+  0x09, 0x4b, 0x09, 0x4c, 0x09, 0x4d, 0x09, 0x4e, 0x09, 0x4f, 0x09, 0x50,
+  0x09, 0x51, 0x09, 0x52, 0x09, 0x53, 0x09, 0x54, 0x09, 0x55, 0x09, 0x56,
+  0x09, 0x57, 0x09, 0x58, 0x09, 0x59, 0x09, 0x5a, 0x09, 0x5b, 0x09, 0x5c,
+  0x09, 0x5d, 0x09, 0x5e, 0x09, 0x5f, 0x09, 0x60, 0x09, 0x61, 0x09, 0x62,
+  0x09, 0x63, 0x09, 0x64, 0x09, 0x65, 0x09, 0x66, 0x09, 0x67, 0x09, 0x68,
+  0x09, 0x69, 0x09, 0x6a, 0x09, 0x6b, 0x09, 0x6c, 0x09, 0x6d, 0x09, 0x6e,
+  0x09, 0x6f, 0x09, 0x70, 0x09, 0x71, 0x09, 0x72, 0x09, 0x73, 0x09, 0x74,
+  0x09, 0x75, 0x09, 0x76, 0x09, 0x77, 0x09, 0x78, 0x09, 0x79, 0x09, 0x7a,
+  0x09, 0x7b, 0x09, 0x7c, 0x09, 0x7d, 0x09, 0x7e, 0x09, 0x7f, 0x09, 0x80,
+  0x09, 0x81, 0x09, 0x82, 0x09, 0x83, 0x09, 0x84, 0x09, 0x85, 0x09, 0x86,
+  0x09, 0x87, 0x09, 0x88, 0x09, 0x89, 0x09, 0x8a, 0x09, 0x8b, 0x09, 0x8c,
+  0x09, 0x8d, 0x09, 0x8e, 0x09, 0x8f, 0x09, 0x90, 0x09, 0x91, 0x09, 0x92,
+  0x09, 0x93, 0x09, 0x94, 0x09, 0x95, 0x09, 0x96, 0x09, 0x97, 0x09, 0x98,
+  0x09, 0x99, 0x09, 0x9a, 0x09, 0x9b, 0x09, 0x9c, 0x09, 0x9d, 0x09, 0x9e,
+  0x09, 0x9f, 0x09, 0xa0, 0x09, 0xa1, 0x09, 0xa2, 0x09, 0xa3, 0x09, 0xa4,
+  0x09, 0xa5, 0x09, 0xa6, 0x09, 0xa7, 0x09, 0xa8, 0x09, 0xa9, 0x09, 0xaa,
+  0x09, 0xab, 0x09, 0xac, 0x09, 0xad, 0x09, 0xae, 0x09, 0xaf, 0x09, 0xb0,
+  0x09, 0xb1, 0x09, 0xb2, 0x09, 0xb3, 0x09, 0xb4, 0x09, 0xb5, 0x09, 0xb6,
+  0x09, 0xb7, 0x09, 0xb8, 0x09, 0xb9, 0x09, 0xba, 0x09, 0xbb, 0x09, 0xbc,
+  0x09, 0xbd, 0x09, 0xbe, 0x09, 0xbf, 0x09, 0xc0, 0x09, 0xc1, 0x09, 0xc2,
+  0x09, 0xc3, 0x09, 0xc4, 0x09, 0xc5, 0x09, 0xc6, 0x09, 0xc7, 0x09, 0xc8,
+  0x09, 0xc9, 0x09, 0xca, 0x09, 0xcb, 0x09, 0xcc, 0x09, 0xcd, 0x09, 0xce,
+  0x09, 0xcf, 0x09, 0xd0, 0x09, 0xd1, 0x09, 0xd2, 0x09, 0xd3, 0x09, 0xd4,
+  0x09, 0xd5, 0x09, 0xd6, 0x09, 0xd7, 0x09, 0xd8, 0x09, 0xd9, 0x09, 0xda,
+  0x09, 0xdb, 0x09, 0xdc, 0x09, 0xdd, 0x09, 0xde, 0x09, 0xdf, 0x09, 0xe0,
+  0x09, 0xe1, 0x09, 0xe2, 0x09, 0xe3, 0x09, 0xe4, 0x09, 0xe5, 0x09, 0xe6,
+  0x09, 0xe7, 0x09, 0xe8, 0x09, 0xe9, 0x09, 0xea, 0x09, 0xeb, 0x09, 0xec,
+  0x09, 0xed, 0x09, 0xee, 0x09, 0xef, 0x09, 0xf0, 0x09, 0xf1, 0x09, 0xf2,
+  0x09, 0xf3, 0x09, 0xf4, 0x09, 0xf5, 0x09, 0xf6, 0x09, 0xf7, 0x09, 0xf8,
+  0x09, 0xf9, 0x09, 0xfa, 0x09, 0xfb, 0x09, 0xfc, 0x09, 0xfd, 0x09, 0xfe,
+  0x09, 0xff, 0x0a, 0x00, 0x0a, 0x01, 0x0a, 0x02, 0x0a, 0x03, 0x0a, 0x04,
+  0x0a, 0x05, 0x0a, 0x06, 0x0a, 0x07, 0x0a, 0x08, 0x0a, 0x09, 0x0a, 0x0a,
+  0x0a, 0x0b, 0x0a, 0x0c, 0x0a, 0x0d, 0x0a, 0x0e, 0x0a, 0x0f, 0x0a, 0x10,
+  0x0a, 0x11, 0x0a, 0x12, 0x0a, 0x13, 0x0a, 0x14, 0x0a, 0x15, 0x0a, 0x16,
+  0x0a, 0x17, 0x0a, 0x18, 0x0a, 0x19, 0x0a, 0x1a, 0x0a, 0x1b, 0x0a, 0x1c,
+  0x0a, 0x1d, 0x0a, 0x1e, 0x0a, 0x1f, 0x0a, 0x20, 0x0a, 0x21, 0x0a, 0x22,
+  0x0a, 0x23, 0x0a, 0x24, 0x0a, 0x25, 0x0a, 0x26, 0x0a, 0x27, 0x0a, 0x28,
+  0x0a, 0x29, 0x0a, 0x2a, 0x0a, 0x2b, 0x0a, 0x2c, 0x0a, 0x2d, 0x0a, 0x2e,
+  0x0a, 0x2f, 0x0a, 0x30, 0x0a, 0x31, 0x0a, 0x32, 0x0a, 0x33, 0x0a, 0x34,
+  0x0a, 0x35, 0x0a, 0x36, 0x0a, 0x37, 0x0a, 0x38, 0x0a, 0x39, 0x0a, 0x3a,
+  0x0a, 0x3b, 0x0a, 0x3c, 0x0a, 0x3d, 0x0a, 0x3e, 0x0a, 0x3f, 0x0a, 0x40,
+  0x0a, 0x41, 0x0a, 0x42, 0x0a, 0x43, 0x0a, 0x44, 0x0a, 0x45, 0x0a, 0x46,
+  0x0a, 0x47, 0x0a, 0x48, 0x0a, 0x49, 0x0a, 0x4a, 0x0a, 0x4b, 0x0a, 0x4c,
+  0x0a, 0x4d, 0x0a, 0x4e, 0x0a, 0x4f, 0x0a, 0x50, 0x0a, 0x51, 0x0a, 0x52,
+  0x0a, 0x53, 0x0a, 0x54, 0x0a, 0x55, 0x0a, 0x56, 0x0a, 0x57, 0x0a, 0x58,
+  0x0a, 0x59, 0x0a, 0x5a, 0x0a, 0x5b, 0x0a, 0x5c, 0x0a, 0x5d, 0x0a, 0x5e,
+  0x0a, 0x5f, 0x0a, 0x60, 0x0a, 0x61, 0x0a, 0x62, 0x0a, 0x63, 0x0a, 0x64,
+  0x0a, 0x65, 0x0a, 0x66, 0x0a, 0x67, 0x0a, 0x68, 0x0a, 0x69, 0x0a, 0x6a,
+  0x0a, 0x6b, 0x0a, 0x6c, 0x0a, 0x6d, 0x0a, 0x6e, 0x0a, 0x6f, 0x0a, 0x70,
+  0x0a, 0x71, 0x0a, 0x72, 0x0a, 0x73, 0x0a, 0x74, 0x0a, 0x75, 0x0a, 0x76,
+  0x0a, 0x77, 0x0a, 0x78, 0x0a, 0x79, 0x0a, 0x7a, 0x0a, 0x7b, 0x0a, 0x7c,
+  0x0a, 0x7d, 0x0a, 0x7e, 0x0a, 0x7f, 0x0a, 0x80, 0x0a, 0x81, 0x0a, 0x82,
+  0x0a, 0x83, 0x0a, 0x84, 0x0a, 0x85, 0x0a, 0x86, 0x0a, 0x87, 0x0a, 0x88,
+  0x0a, 0x89, 0x0a, 0x8a, 0x0a, 0x8b, 0x0a, 0x8c, 0x0a, 0x8d, 0x0a, 0x8e,
+  0x0a, 0x8f, 0x0a, 0x90, 0x0a, 0x91, 0x0a, 0x92, 0x0a, 0x93, 0x0a, 0x94,
+  0x0a, 0x95, 0x0a, 0x96, 0x0a, 0x97, 0x0a, 0x98, 0x0a, 0x99, 0x0a, 0x9a,
+  0x0a, 0x9b, 0x0a, 0x9c, 0x0a, 0x9d, 0x0a, 0x9e, 0x0a, 0x9f, 0x0a, 0xa0,
+  0x0a, 0xa1, 0x0a, 0xa2, 0x0a, 0xa3, 0x0a, 0xa4, 0x0a, 0xa5, 0x0a, 0xa6,
+  0x0a, 0xa7, 0x0a, 0xa8, 0x0a, 0xa9, 0x0a, 0xaa, 0x0a, 0xab, 0x0a, 0xac,
+  0x0a, 0xad, 0x0a, 0xae, 0x0a, 0xaf, 0x0a, 0xb0, 0x0a, 0xb1, 0x0a, 0xb2,
+  0x0a, 0xb3, 0x0a, 0xb4, 0x0a, 0xb5, 0x0a, 0xb6, 0x0a, 0xb7, 0x0a, 0xb8,
+  0x0a, 0xb9, 0x0a, 0xba, 0x0a, 0xbb, 0x0a, 0xbc, 0x0a, 0xbd, 0x0a, 0xbe,
+  0x0a, 0xbf, 0x0a, 0xc0, 0x0a, 0xc1, 0x0a, 0xc2, 0x0a, 0xc3, 0x0a, 0xc4,
+  0x0a, 0xc5, 0x0a, 0xc6, 0x0a, 0xc7, 0x0a, 0xc8, 0x0a, 0xc9, 0x0a, 0xca,
+  0x0a, 0xcb, 0x0a, 0xcc, 0x0a, 0xcd, 0x0a, 0xce, 0x0a, 0xcf, 0x0a, 0xd0,
+  0x0a, 0xd1, 0x0a, 0xd2, 0x0a, 0xd3, 0x0a, 0xd4, 0x0a, 0xd5, 0x0a, 0xd6,
+  0x0a, 0xd7, 0x0a, 0xd8, 0x0a, 0xd9, 0x0a, 0xda, 0x0a, 0xdb, 0x0a, 0xdc,
+  0x0a, 0xdd, 0x0a, 0xde, 0x0a, 0xdf, 0x0a, 0xe0, 0x0a, 0xe1, 0x0a, 0xe2,
+  0x0a, 0xe3, 0x0a, 0xe4, 0x0a, 0xe5, 0x0a, 0xe6, 0x0a, 0xe7, 0x0a, 0xe8,
+  0x0a, 0xe9, 0x0a, 0xea, 0x0a, 0xeb, 0x0a, 0xec, 0x0a, 0xed, 0x0a, 0xee,
+  0x0a, 0xef, 0x0a, 0xf0, 0x0a, 0xf1, 0x0a, 0xf2, 0x0a, 0xf3, 0x0a, 0xf4,
+  0x0a, 0xf5, 0x0a, 0xf6, 0x00, 0xb9, 0x0a, 0xf7, 0x0a, 0xf8, 0x0a, 0xf9,
+  0x0a, 0xfa, 0x0a, 0xfb, 0x0a, 0xfc, 0x0a, 0xfd, 0x0a, 0xfe, 0x0a, 0xff,
+  0x0b, 0x00, 0x0b, 0x01, 0x0b, 0x02, 0x0b, 0x03, 0x0b, 0x04, 0x0b, 0x05,
+  0x0b, 0x06, 0x0b, 0x07, 0x0b, 0x08, 0x0b, 0x09, 0x0b, 0x0a, 0x0b, 0x0b,
+  0x0b, 0x0c, 0x0b, 0x0d, 0x0b, 0x0e, 0x0b, 0x0f, 0x0b, 0x10, 0x0b, 0x11,
+  0x0b, 0x12, 0x0b, 0x13, 0x0b, 0x14, 0x0b, 0x15, 0x0b, 0x16, 0x0b, 0x17,
+  0x0b, 0x18, 0x0b, 0x19, 0x0b, 0x1a, 0x0b, 0x1b, 0x0b, 0x1c, 0x0b, 0x1d,
+  0x0b, 0x1e, 0x0b, 0x1f, 0x0b, 0x20, 0x0b, 0x21, 0x0b, 0x22, 0x0b, 0x23,
+  0x0b, 0x24, 0x0b, 0x25, 0x0b, 0x26, 0x0b, 0x27, 0x0b, 0x28, 0x0b, 0x29,
+  0x0b, 0x2a, 0x0b, 0x2b, 0x0b, 0x2c, 0x0b, 0x2d, 0x0b, 0x2e, 0x0b, 0x2f,
+  0x0b, 0x30, 0x0b, 0x31, 0x0b, 0x32, 0x0b, 0x33, 0x0b, 0x34, 0x0b, 0x35,
+  0x0b, 0x36, 0x0b, 0x37, 0x0b, 0x38, 0x0b, 0x39, 0x0b, 0x3a, 0x0b, 0x3b,
+  0x0b, 0x3c, 0x0b, 0x3d, 0x0b, 0x3e, 0x0b, 0x3f, 0x0b, 0x40, 0x0b, 0x41,
+  0x0b, 0x42, 0x0b, 0x43, 0x0b, 0x44, 0x0b, 0x45, 0x0b, 0x46, 0x0b, 0x47,
+  0x0b, 0x48, 0x0b, 0x49, 0x0b, 0x4a, 0x0b, 0x4b, 0x0b, 0x4c, 0x0b, 0x4d,
+  0x0b, 0x4e, 0x0b, 0x4f, 0x0b, 0x50, 0x0b, 0x51, 0x0b, 0x52, 0x0b, 0x53,
+  0x0b, 0x54, 0x0b, 0x55, 0x0b, 0x56, 0x0b, 0x57, 0x0b, 0x58, 0x0b, 0x59,
+  0x0b, 0x5a, 0x0b, 0x5b, 0x0b, 0x5c, 0x0b, 0x5d, 0x0b, 0x5e, 0x0b, 0x5f,
+  0x0b, 0x60, 0x0b, 0x61, 0x0b, 0x62, 0x0b, 0x63, 0x0b, 0x64, 0x0b, 0x65,
+  0x0b, 0x66, 0x0b, 0x67, 0x0b, 0x68, 0x0b, 0x69, 0x0b, 0x6a, 0x0b, 0x6b,
+  0x0b, 0x6c, 0x0b, 0x6d, 0x0b, 0x6e, 0x0b, 0x6f, 0x0b, 0x70, 0x0b, 0x71,
+  0x0b, 0x72, 0x0b, 0x73, 0x0b, 0x74, 0x0b, 0x75, 0x0b, 0x76, 0x0b, 0x77,
+  0x0b, 0x78, 0x0b, 0x79, 0x0b, 0x7a, 0x0b, 0x7b, 0x0b, 0x7c, 0x0b, 0x7d,
+  0x0b, 0x7e, 0x0b, 0x7f, 0x0b, 0x80, 0x0b, 0x81, 0x0b, 0x82, 0x0b, 0x83,
+  0x0b, 0x84, 0x0b, 0x85, 0x0b, 0x86, 0x0b, 0x87, 0x0b, 0x88, 0x0b, 0x89,
+  0x0b, 0x8a, 0x0b, 0x8b, 0x0b, 0x8c, 0x0b, 0x8d, 0x0b, 0x8e, 0x0b, 0x8f,
+  0x0b, 0x90, 0x0b, 0x91, 0x0b, 0x92, 0x0b, 0x93, 0x0b, 0x94, 0x0b, 0x95,
+  0x0b, 0x96, 0x0b, 0x97, 0x0b, 0x98, 0x0b, 0x99, 0x0b, 0x9a, 0x0b, 0x9b,
+  0x0b, 0x9c, 0x0b, 0x9d, 0x0b, 0x9e, 0x0b, 0x9f, 0x0b, 0xa0, 0x0b, 0xa1,
+  0x0b, 0xa2, 0x0b, 0xa3, 0x0b, 0xa4, 0x0b, 0xa5, 0x0b, 0xa6, 0x0b, 0xa7,
+  0x0b, 0xa8, 0x0b, 0xa9, 0x0b, 0xaa, 0x0b, 0xab, 0x0b, 0xac, 0x0b, 0xad,
+  0x0b, 0xae, 0x0b, 0xaf, 0x0b, 0xb0, 0x0b, 0xb1, 0x0b, 0xb2, 0x0b, 0xb3,
+  0x0b, 0xb4, 0x0b, 0xb5, 0x0b, 0xb6, 0x0b, 0xb7, 0x0b, 0xb8, 0x0b, 0xb9,
+  0x0b, 0xba, 0x0b, 0xbb, 0x0b, 0xbc, 0x0b, 0xbd, 0x0b, 0xbe, 0x0b, 0xbf,
+  0x0b, 0xc0, 0x0b, 0xc1, 0x0b, 0xc2, 0x0b, 0xc3, 0x0b, 0xc4, 0x0b, 0xc5,
+  0x0b, 0xc6, 0x0b, 0xc7, 0x0b, 0xc8, 0x0b, 0xc9, 0x0b, 0xca, 0x0b, 0xcb,
+  0x0b, 0xcc, 0x0b, 0xcd, 0x0b, 0xce, 0x0b, 0xcf, 0x0b, 0xd0, 0x0b, 0xd1,
+  0x0b, 0xd2, 0x0b, 0xd3, 0x0b, 0xd4, 0x0b, 0xd5, 0x0b, 0xd6, 0x0b, 0xd7,
+  0x0b, 0xd8, 0x0b, 0xd9, 0x0b, 0xda, 0x0b, 0xdb, 0x0b, 0xdc, 0x0b, 0xdd,
+  0x0b, 0xde, 0x0b, 0xdf, 0x0b, 0xe0, 0x0b, 0xe1, 0x0b, 0xe2, 0x0b, 0xe3,
+  0x0b, 0xe4, 0x0b, 0xe5, 0x0b, 0xe6, 0x0b, 0xe7, 0x0b, 0xe8, 0x0b, 0xe9,
+  0x0b, 0xea, 0x0b, 0xeb, 0x0b, 0xec, 0x0b, 0xed, 0x0b, 0xee, 0x0b, 0xef,
+  0x0b, 0xf0, 0x0b, 0xf1, 0x0b, 0xf2, 0x0b, 0xf3, 0x0b, 0xf4, 0x0b, 0xf5,
+  0x0b, 0xf6, 0x0b, 0xf7, 0x0b, 0xf8, 0x0b, 0xf9, 0x0b, 0xfa, 0x0b, 0xfb,
+  0x0b, 0xfc, 0x0b, 0xfd, 0x0b, 0xfe, 0x0b, 0xff, 0x0c, 0x00, 0x0c, 0x01,
+  0x0c, 0x02, 0x0c, 0x03, 0x0c, 0x04, 0x0c, 0x05, 0x0c, 0x06, 0x0c, 0x07,
+  0x0c, 0x08, 0x0c, 0x09, 0x0c, 0x0a, 0x0c, 0x0b, 0x0c, 0x0c, 0x0c, 0x0d,
+  0x0c, 0x0e, 0x0c, 0x0f, 0x0c, 0x10, 0x0c, 0x11, 0x0c, 0x12, 0x0c, 0x13,
+  0x0c, 0x14, 0x0c, 0x15, 0x0c, 0x16, 0x0c, 0x17, 0x0c, 0x18, 0x0c, 0x19,
+  0x0c, 0x1a, 0x0c, 0x1b, 0x0c, 0x1c, 0x0c, 0x1d, 0x0c, 0x1e, 0x0c, 0x1f,
+  0x0c, 0x20, 0x0c, 0x21, 0x0c, 0x22, 0x0c, 0x23, 0x0c, 0x24, 0x0c, 0x25,
+  0x0c, 0x26, 0x0c, 0x27, 0x0c, 0x28, 0x0c, 0x29, 0x0c, 0x2a, 0x0c, 0x2b,
+  0x0c, 0x2c, 0x0c, 0x2d, 0x0c, 0x2e, 0x0c, 0x2f, 0x0c, 0x30, 0x0c, 0x31,
+  0x0c, 0x32, 0x0c, 0x33, 0x0c, 0x34, 0x0c, 0x35, 0x0c, 0x36, 0x0c, 0x37,
+  0x0c, 0x38, 0x0c, 0x39, 0x0c, 0x3a, 0x0c, 0x3b, 0x0c, 0x3c, 0x0c, 0x3d,
+  0x0c, 0x3e, 0x0c, 0x3f, 0x0c, 0x40, 0x0c, 0x41, 0x0c, 0x42, 0x0c, 0x43,
+  0x0c, 0x44, 0x0c, 0x45, 0x0c, 0x46, 0x0c, 0x47, 0x0c, 0x48, 0x0c, 0x49,
+  0x0c, 0x4a, 0x0c, 0x4b, 0x0c, 0x4c, 0x0c, 0x4d, 0x0c, 0x4e, 0x0c, 0x4f,
+  0x0c, 0x50, 0x0c, 0x51, 0x0c, 0x52, 0x0c, 0x53, 0x0c, 0x54, 0x0c, 0x55,
+  0x0c, 0x56, 0x0c, 0x57, 0x0c, 0x58, 0x0c, 0x59, 0x0c, 0x5a, 0x0c, 0x5b,
+  0x0c, 0x5c, 0x0c, 0x5d, 0x0c, 0x5e, 0x0c, 0x5f, 0x0c, 0x60, 0x0c, 0x61,
+  0x0c, 0x62, 0x0c, 0x63, 0x0c, 0x64, 0x0c, 0x65, 0x0c, 0x66, 0x0c, 0x67,
+  0x0c, 0x68, 0x0c, 0x69, 0x0c, 0x6a, 0x0c, 0x6b, 0x0c, 0x6c, 0x0c, 0x6d,
+  0x0c, 0x6e, 0x0c, 0x6f, 0x0c, 0x70, 0x0c, 0x71, 0x0c, 0x72, 0x0c, 0x73,
+  0x0c, 0x74, 0x0c, 0x75, 0x0c, 0x76, 0x0c, 0x77, 0x0c, 0x78, 0x0c, 0x79,
+  0x0c, 0x7a, 0x0c, 0x7b, 0x0c, 0x7c, 0x0c, 0x7d, 0x0c, 0x7e, 0x0c, 0x7f,
+  0x0c, 0x80, 0x0c, 0x81, 0x0c, 0x82, 0x0c, 0x83, 0x0c, 0x84, 0x0c, 0x85,
+  0x0c, 0x86, 0x0c, 0x87, 0x0c, 0x88, 0x0c, 0x89, 0x0c, 0x8a, 0x0c, 0x8b,
+  0x0c, 0x8c, 0x0c, 0x8d, 0x0c, 0x8e, 0x0c, 0x8f, 0x0c, 0x90, 0x0c, 0x91,
+  0x0c, 0x92, 0x0c, 0x93, 0x0c, 0x94, 0x0c, 0x95, 0x0c, 0x96, 0x0c, 0x97,
+  0x0c, 0x98, 0x0c, 0x99, 0x0c, 0x9a, 0x0c, 0x9b, 0x0c, 0x9c, 0x0c, 0x9d,
+  0x0c, 0x9e, 0x0c, 0x9f, 0x0c, 0xa0, 0x0c, 0xa1, 0x0c, 0xa2, 0x0c, 0xa3,
+  0x0c, 0xa4, 0x0c, 0xa5, 0x0c, 0xa6, 0x0c, 0xa7, 0x0c, 0xa8, 0x0c, 0xa9,
+  0x0c, 0xaa, 0x0c, 0xab, 0x0c, 0xac, 0x0c, 0xad, 0x0c, 0xae, 0x0c, 0xaf,
+  0x0c, 0xb0, 0x0c, 0xb1, 0x0c, 0xb2, 0x0c, 0xb3, 0x0c, 0xb4, 0x0c, 0xb5,
+  0x0c, 0xb6, 0x0c, 0xb7, 0x0c, 0xb8, 0x0c, 0xb9, 0x0c, 0xba, 0x0c, 0xbb,
+  0x0c, 0xbc, 0x0c, 0xbd, 0x0c, 0xbe, 0x0c, 0xbf, 0x0c, 0xc0, 0x0c, 0xc1,
+  0x0c, 0xc2, 0x0c, 0xc3, 0x0c, 0xc4, 0x0c, 0xc5, 0x0c, 0xc6, 0x0c, 0xc7,
+  0x0c, 0xc8, 0x0c, 0xc9, 0x0c, 0xca, 0x0c, 0xcb, 0x0c, 0xcc, 0x0c, 0xcd,
+  0x0c, 0xce, 0x0c, 0xcf, 0x0c, 0xd0, 0x0c, 0xd1, 0x0c, 0xd2, 0x0c, 0xd3,
+  0x0c, 0xd4, 0x0c, 0xd5, 0x0c, 0xd6, 0x0c, 0xd7, 0x0c, 0xd8, 0x0c, 0xd9,
+  0x0c, 0xda, 0x0c, 0xdb, 0x0c, 0xdc, 0x0c, 0xdd, 0x0c, 0xde, 0x0c, 0xdf,
+  0x0c, 0xe0, 0x0c, 0xe1, 0x0c, 0xe2, 0x0c, 0xe3, 0x0c, 0xe4, 0x0c, 0xe5,
+  0x0c, 0xe6, 0x0c, 0xe7, 0x0c, 0xe8, 0x0c, 0xe9, 0x0c, 0xea, 0x0c, 0xeb,
+  0x0c, 0xec, 0x0c, 0xed, 0x0c, 0xee, 0x0c, 0xef, 0x0c, 0xf0, 0x0c, 0xf1,
+  0x0c, 0xf2, 0x0c, 0xf3, 0x0c, 0xf4, 0x0c, 0xf5, 0x0c, 0xf6, 0x0c, 0xf7,
+  0x0c, 0xf8, 0x0c, 0xf9, 0x0c, 0xfa, 0x0c, 0xfb, 0x0c, 0xfc, 0x0c, 0xfd,
+  0x0c, 0xfe, 0x0c, 0xff, 0x0d, 0x00, 0x0d, 0x01, 0x0d, 0x02, 0x0d, 0x03,
+  0x0d, 0x04, 0x0d, 0x05, 0x0d, 0x06, 0x0d, 0x07, 0x0d, 0x08, 0x0d, 0x09,
+  0x0d, 0x0a, 0x0d, 0x0b, 0x0d, 0x0c, 0x0d, 0x0d, 0x0d, 0x0e, 0x0d, 0x0f,
+  0x0d, 0x10, 0x0d, 0x11, 0x0d, 0x12, 0x0d, 0x13, 0x0d, 0x14, 0x0d, 0x15,
+  0x0d, 0x16, 0x0d, 0x17, 0x0d, 0x18, 0x0d, 0x19, 0x0d, 0x1a, 0x0d, 0x1b,
+  0x0d, 0x1c, 0x0d, 0x1d, 0x0d, 0x1e, 0x0d, 0x1f, 0x0d, 0x20, 0x0d, 0x21,
+  0x0d, 0x22, 0x0d, 0x23, 0x0d, 0x24, 0x0d, 0x25, 0x0d, 0x26, 0x0d, 0x27,
+  0x0d, 0x28, 0x0d, 0x29, 0x0d, 0x2a, 0x0d, 0x2b, 0x0d, 0x2c, 0x0d, 0x2d,
+  0x0d, 0x2e, 0x0d, 0x2f, 0x0d, 0x30, 0x0d, 0x31, 0x0d, 0x32, 0x0d, 0x33,
+  0x0d, 0x34, 0x0d, 0x35, 0x0d, 0x36, 0x0d, 0x37, 0x0d, 0x38, 0x0d, 0x39,
+  0x0d, 0x3a, 0x0d, 0x3b, 0x0d, 0x3c, 0x0d, 0x3d, 0x0d, 0x3e, 0x0d, 0x3f,
+  0x0d, 0x40, 0x0d, 0x41, 0x0d, 0x42, 0x0d, 0x43, 0x0d, 0x44, 0x0d, 0x45,
+  0x0d, 0x46, 0x0d, 0x47, 0x0d, 0x48, 0x0d, 0x49, 0x0d, 0x4a, 0x0d, 0x4b,
+  0x0d, 0x4c, 0x0d, 0x4d, 0x0d, 0x4e, 0x0d, 0x4f, 0x0d, 0x50, 0x0d, 0x51,
+  0x0d, 0x52, 0x0d, 0x53, 0x0d, 0x54, 0x0d, 0x55, 0x0d, 0x56, 0x0d, 0x57,
+  0x0d, 0x58, 0x0d, 0x59, 0x0d, 0x5a, 0x0d, 0x5b, 0x0d, 0x5c, 0x0d, 0x5d,
+  0x0d, 0x5e, 0x0d, 0x5f, 0x0d, 0x60, 0x0d, 0x61, 0x0d, 0x62, 0x0d, 0x63,
+  0x0d, 0x64, 0x0d, 0x65, 0x0d, 0x66, 0x0d, 0x67, 0x0d, 0x68, 0x0d, 0x69,
+  0x0d, 0x6a, 0x0d, 0x6b, 0x0d, 0x6c, 0x0d, 0x6d, 0x0d, 0x6e, 0x0d, 0x6f,
+  0x0d, 0x70, 0x0d, 0x71, 0x0d, 0x72, 0x0d, 0x73, 0x0d, 0x74, 0x0d, 0x75,
+  0x0d, 0x76, 0x0d, 0x77, 0x0d, 0x78, 0x0d, 0x79, 0x0d, 0x7a, 0x0d, 0x7b,
+  0x0d, 0x7c, 0x0d, 0x7d, 0x0d, 0x7e, 0x0d, 0x7f, 0x0d, 0x80, 0x0d, 0x81,
+  0x0d, 0x82, 0x0d, 0x83, 0x0d, 0x84, 0x0d, 0x85, 0x0d, 0x86, 0x0d, 0x87,
+  0x0d, 0x88, 0x0d, 0x89, 0x0d, 0x8a, 0x0d, 0x8b, 0x0d, 0x8c, 0x0d, 0x8d,
+  0x0d, 0x8e, 0x0d, 0x8f, 0x0d, 0x90, 0x0d, 0x91, 0x0d, 0x92, 0x0d, 0x93,
+  0x0d, 0x94, 0x0d, 0x95, 0x0d, 0x96, 0x0d, 0x97, 0x0d, 0x98, 0x0d, 0x99,
+  0x0d, 0x9a, 0x0d, 0x9b, 0x0d, 0x9c, 0x0d, 0x9d, 0x0d, 0x9e, 0x0d, 0x9f,
+  0x0d, 0xa0, 0x0d, 0xa1, 0x0d, 0xa2, 0x0d, 0xa3, 0x0d, 0xa4, 0x0d, 0xa5,
+  0x0d, 0xa6, 0x0d, 0xa7, 0x0d, 0xa8, 0x0d, 0xa9, 0x0d, 0xaa, 0x0d, 0xab,
+  0x0d, 0xac, 0x0d, 0xad, 0x0d, 0xae, 0x0d, 0xaf, 0x0d, 0xb0, 0x0d, 0xb1,
+  0x0d, 0xb2, 0x0d, 0xb3, 0x0d, 0xb4, 0x0d, 0xb5, 0x0d, 0xb6, 0x0d, 0xb7,
+  0x0d, 0xb8, 0x0d, 0xb9, 0x0d, 0xba, 0x0d, 0xbb, 0x0d, 0xbc, 0x0d, 0xbd,
+  0x0d, 0xbe, 0x0d, 0xbf, 0x0d, 0xc0, 0x0d, 0xc1, 0x0d, 0xc2, 0x0d, 0xc3,
+  0x0d, 0xc4, 0x0d, 0xc5, 0x0d, 0xc6, 0x0d, 0xc7, 0x0d, 0xc8, 0x0d, 0xc9,
+  0x0d, 0xca, 0x0d, 0xcb, 0x0d, 0xcc, 0x0d, 0xcd, 0x0d, 0xce, 0x0d, 0xcf,
+  0x0d, 0xd0, 0x0d, 0xd1, 0x0d, 0xd2, 0x0d, 0xd3, 0x0d, 0xd4, 0x0d, 0xd5,
+  0x0d, 0xd6, 0x0d, 0xd7, 0x0d, 0xd8, 0x0d, 0xd9, 0x0d, 0xda, 0x0d, 0xdb,
+  0x0d, 0xdc, 0x0d, 0xdd, 0x0d, 0xde, 0x0d, 0xdf, 0x0d, 0xe0, 0x0d, 0xe1,
+  0x0d, 0xe2, 0x0d, 0xe3, 0x0d, 0xe4, 0x0d, 0xe5, 0x0d, 0xe6, 0x0d, 0xe7,
+  0x0d, 0xe8, 0x0d, 0xe9, 0x0d, 0xea, 0x0d, 0xeb, 0x0d, 0xec, 0x0d, 0xed,
+  0x0d, 0xee, 0x0d, 0xef, 0x0d, 0xf0, 0x0d, 0xf1, 0x0d, 0xf2, 0x0d, 0xf3,
+  0x0d, 0xf4, 0x0d, 0xf5, 0x0d, 0xf6, 0x0d, 0xf7, 0x0d, 0xf8, 0x0d, 0xf9,
+  0x0d, 0xfa, 0x0d, 0xfb, 0x0d, 0xfc, 0x0d, 0xfd, 0x0d, 0xfe, 0x0d, 0xff,
+  0x0e, 0x00, 0x0e, 0x01, 0x0e, 0x02, 0x0e, 0x03, 0x0e, 0x04, 0x0e, 0x05,
+  0x0e, 0x06, 0x0e, 0x07, 0x0e, 0x08, 0x0e, 0x09, 0x0e, 0x0a, 0x0e, 0x0b,
+  0x0e, 0x0c, 0x0e, 0x0d, 0x0e, 0x0e, 0x0e, 0x0f, 0x0e, 0x10, 0x0e, 0x11,
+  0x0e, 0x12, 0x0e, 0x13, 0x0e, 0x14, 0x0e, 0x15, 0x0e, 0x16, 0x0e, 0x17,
+  0x0e, 0x18, 0x0e, 0x19, 0x0e, 0x1a, 0x0e, 0x1b, 0x0e, 0x1c, 0x0e, 0x1d,
+  0x0e, 0x1e, 0x0e, 0x1f, 0x0e, 0x20, 0x0e, 0x21, 0x0e, 0x22, 0x0e, 0x23,
+  0x0e, 0x24, 0x0e, 0x25, 0x0e, 0x26, 0x0e, 0x27, 0x0e, 0x28, 0x0e, 0x29,
+  0x0e, 0x2a, 0x0e, 0x2b, 0x0e, 0x2c, 0x0e, 0x2d, 0x0e, 0x2e, 0x0e, 0x2f,
+  0x0e, 0x30, 0x0e, 0x31, 0x0e, 0x32, 0x0e, 0x33, 0x0e, 0x34, 0x0e, 0x35,
+  0x0e, 0x36, 0x0e, 0x37, 0x0e, 0x38, 0x0e, 0x39, 0x0e, 0x3a, 0x0e, 0x3b,
+  0x0e, 0x3c, 0x0e, 0x3d, 0x0e, 0x3e, 0x0e, 0x3f, 0x0e, 0x40, 0x0e, 0x41,
+  0x0e, 0x42, 0x0e, 0x43, 0x0e, 0x44, 0x0e, 0x45, 0x0e, 0x46, 0x0e, 0x47,
+  0x0e, 0x48, 0x0e, 0x49, 0x0e, 0x4a, 0x0e, 0x4b, 0x0e, 0x4c, 0x0e, 0x4d,
+  0x0e, 0x4e, 0x0e, 0x4f, 0x0e, 0x50, 0x0e, 0x51, 0x0e, 0x52, 0x0e, 0x53,
+  0x0e, 0x54, 0x0e, 0x55, 0x0e, 0x56, 0x0e, 0x57, 0x0e, 0x58, 0x0e, 0x59,
+  0x0e, 0x5a, 0x0e, 0x5b, 0x0e, 0x5c, 0x0e, 0x5d, 0x0e, 0x5e, 0x0e, 0x5f,
+  0x0e, 0x60, 0x0e, 0x61, 0x0e, 0x62, 0x0e, 0x63, 0x0e, 0x64, 0x0e, 0x65,
+  0x0e, 0x66, 0x0e, 0x67, 0x0e, 0x68, 0x0e, 0x69, 0x0e, 0x6a, 0x0e, 0x6b,
+  0x0e, 0x6c, 0x0e, 0x6d, 0x0e, 0x6e, 0x0e, 0x6f, 0x0e, 0x70, 0x0e, 0x71,
+  0x0e, 0x72, 0x0e, 0x73, 0x0e, 0x74, 0x0e, 0x75, 0x0e, 0x76, 0x0e, 0x77,
+  0x0e, 0x78, 0x0e, 0x79, 0x0e, 0x7a, 0x0e, 0x7b, 0x0e, 0x7c, 0x0e, 0x7d,
+  0x0e, 0x7e, 0x0e, 0x7f, 0x0e, 0x80, 0x0e, 0x81, 0x0e, 0x82, 0x0e, 0x83,
+  0x0e, 0x84, 0x0e, 0x85, 0x0e, 0x86, 0x0e, 0x87, 0x0e, 0x88, 0x0e, 0x89,
+  0x0e, 0x8a, 0x0e, 0x8b, 0x0e, 0x8c, 0x0e, 0x8d, 0x0e, 0x8e, 0x0e, 0x8f,
+  0x0e, 0x90, 0x0e, 0x91, 0x0e, 0x92, 0x0e, 0x93, 0x0e, 0x94, 0x0e, 0x95,
+  0x0e, 0x96, 0x0e, 0x97, 0x0e, 0x98, 0x0e, 0x99, 0x0e, 0x9a, 0x0e, 0x9b,
+  0x0e, 0x9c, 0x0e, 0x9d, 0x0e, 0x9e, 0x0e, 0x9f, 0x0e, 0xa0, 0x0e, 0xa1,
+  0x0e, 0xa2, 0x0e, 0xa3, 0x0e, 0xa4, 0x0e, 0xa5, 0x0e, 0xa6, 0x0e, 0xa7,
+  0x0e, 0xa8, 0x0e, 0xa9, 0x0e, 0xaa, 0x0e, 0xab, 0x0e, 0xac, 0x0e, 0xad,
+  0x0e, 0xae, 0x0e, 0xaf, 0x0e, 0xb0, 0x0e, 0xb1, 0x0e, 0xb2, 0x0e, 0xb3,
+  0x0e, 0xb4, 0x0e, 0xb5, 0x0e, 0xb6, 0x0e, 0xb7, 0x0e, 0xb8, 0x0e, 0xb9,
+  0x0e, 0xba, 0x0e, 0xbb, 0x0e, 0xbc, 0x0e, 0xbd, 0x0e, 0xbe, 0x0e, 0xbf,
+  0x0e, 0xc0, 0x0e, 0xc1, 0x0e, 0xc2, 0x0e, 0xc3, 0x0e, 0xc4, 0x0e, 0xc5,
+  0x0e, 0xc6, 0x0e, 0xc7, 0x0e, 0xc8, 0x0e, 0xc9, 0x0e, 0xca, 0x0e, 0xcb,
+  0x0e, 0xcc, 0x0e, 0xcd, 0x0e, 0xce, 0x0e, 0xcf, 0x0e, 0xd0, 0x0e, 0xd1,
+  0x0e, 0xd2, 0x0e, 0xd3, 0x0e, 0xd4, 0x0e, 0xd5, 0x0e, 0xd6, 0x0e, 0xd7,
+  0x0e, 0xd8, 0x0e, 0xd9, 0x0e, 0xda, 0x0e, 0xdb, 0x0e, 0xdc, 0x0e, 0xdd,
+  0x0e, 0xde, 0x0e, 0xdf, 0x0e, 0xe0, 0x0e, 0xe1, 0x0e, 0xe2, 0x0e, 0xe3,
+  0x0e, 0xe4, 0x0e, 0xe5, 0x0e, 0xe6, 0x0e, 0xe7, 0x0e, 0xe8, 0x0e, 0xe9,
+  0x0e, 0xea, 0x0e, 0xeb, 0x0e, 0xec, 0x0e, 0xed, 0x0e, 0xee, 0x0e, 0xef,
+  0x0e, 0xf0, 0x0e, 0xf1, 0x0e, 0xf2, 0x0e, 0xf3, 0x0e, 0xf4, 0x0e, 0xf5,
+  0x0e, 0xf6, 0x0e, 0xf7, 0x0e, 0xf8, 0x0e, 0xf9, 0x0e, 0xfa, 0x0e, 0xfb,
+  0x0e, 0xfc, 0x0e, 0xfd, 0x0e, 0xfe, 0x0e, 0xff, 0x0f, 0x00, 0x0f, 0x01,
+  0x0f, 0x02, 0x0f, 0x03, 0x0f, 0x04, 0x0f, 0x05, 0x0f, 0x06, 0x0f, 0x07,
+  0x0f, 0x08, 0x0f, 0x09, 0x0f, 0x0a, 0x0f, 0x0b, 0x0f, 0x0c, 0x00, 0xc0,
+  0x00, 0xc1, 0x0f, 0x0d, 0x0f, 0x0e, 0x0f, 0x0f, 0x0f, 0x10, 0x0f, 0x11,
+  0x0f, 0x12, 0x0f, 0x13, 0x0f, 0x14, 0x0f, 0x15, 0x0f, 0x16, 0x0f, 0x17,
+  0x0f, 0x18, 0x0f, 0x19, 0x0f, 0x1a, 0x0f, 0x1b, 0x0f, 0x1c, 0x0f, 0x1d,
+  0x0f, 0x1e, 0x0f, 0x1f, 0x0f, 0x20, 0x0f, 0x21, 0x0f, 0x22, 0x0f, 0x23,
+  0x0f, 0x24, 0x0f, 0x25, 0x0f, 0x26, 0x0f, 0x27, 0x0f, 0x28, 0x0f, 0x29,
+  0x0f, 0x2a, 0x0f, 0x2b, 0x0f, 0x2c, 0x0f, 0x2d, 0x0f, 0x2e, 0x0f, 0x2f,
+  0x0f, 0x30, 0x0f, 0x31, 0x0f, 0x32, 0x0f, 0x33, 0x0f, 0x34, 0x0f, 0x35,
+  0x0f, 0x36, 0x0f, 0x37, 0x0f, 0x38, 0x0f, 0x39, 0x0f, 0x3a, 0x0f, 0x3b,
+  0x0f, 0x3c, 0x0f, 0x3d, 0x0f, 0x3e, 0x0f, 0x3f, 0x0f, 0x40, 0x0f, 0x41,
+  0x0f, 0x42, 0x0f, 0x43, 0x0f, 0x44, 0x0f, 0x45, 0x0f, 0x46, 0x0f, 0x47,
+  0x0f, 0x48, 0x0f, 0x49, 0x0f, 0x4a, 0x0f, 0x4b, 0x0f, 0x4c, 0x0f, 0x4d,
+  0x0f, 0x4e, 0x0f, 0x4f, 0x0f, 0x50, 0x0f, 0x51, 0x0f, 0x52, 0x0f, 0x53,
+  0x0f, 0x54, 0x0f, 0x55, 0x0f, 0x56, 0x0f, 0x57, 0x0f, 0x58, 0x0f, 0x59,
+  0x0f, 0x5a, 0x0f, 0x5b, 0x0f, 0x5c, 0x0f, 0x5d, 0x0f, 0x5e, 0x0f, 0x5f,
+  0x0f, 0x60, 0x0f, 0x61, 0x0f, 0x62, 0x0f, 0x63, 0x0f, 0x64, 0x0f, 0x65,
+  0x0f, 0x66, 0x0f, 0x67, 0x0f, 0x68, 0x0f, 0x69, 0x0f, 0x6a, 0x0f, 0x6b,
+  0x0f, 0x6c, 0x0f, 0x6d, 0x0f, 0x6e, 0x0f, 0x6f, 0x0f, 0x70, 0x0f, 0x71,
+  0x0f, 0x72, 0x0f, 0x73, 0x0f, 0x74, 0x0f, 0x75, 0x0f, 0x76, 0x0f, 0x77,
+  0x0f, 0x78, 0x0f, 0x79, 0x0f, 0x7a, 0x0f, 0x7b, 0x0f, 0x7c, 0x0f, 0x7d,
+  0x0f, 0x7e, 0x0f, 0x7f, 0x0f, 0x80, 0x0f, 0x81, 0x0f, 0x82, 0x0f, 0x83,
+  0x0f, 0x84, 0x0f, 0x85, 0x0f, 0x86, 0x0f, 0x87, 0x0f, 0x88, 0x0f, 0x89,
+  0x0f, 0x8a, 0x0f, 0x8b, 0x0f, 0x8c, 0x0f, 0x8d, 0x0f, 0x8e, 0x0f, 0x8f,
+  0x0f, 0x90, 0x0f, 0x91, 0x0f, 0x92, 0x0f, 0x93, 0x0f, 0x94, 0x0f, 0x95,
+  0x0f, 0x96, 0x0f, 0x97, 0x0f, 0x98, 0x0f, 0x99, 0x0f, 0x9a, 0x0f, 0x9b,
+  0x0f, 0x9c, 0x0f, 0x9d, 0x0f, 0x9e, 0x0f, 0x9f, 0x0f, 0xa0, 0x0f, 0xa1,
+  0x0f, 0xa2, 0x0f, 0xa3, 0x0f, 0xa4, 0x0f, 0xa5, 0x0f, 0xa6, 0x0f, 0xa7,
+  0x0f, 0xa8, 0x0f, 0xa9, 0x0f, 0xaa, 0x0f, 0xab, 0x0f, 0xac, 0x0f, 0xad,
+  0x0f, 0xae, 0x0f, 0xaf, 0x0f, 0xb0, 0x0f, 0xb1, 0x0f, 0xb2, 0x0f, 0xb3,
+  0x0f, 0xb4, 0x0f, 0xb5, 0x0f, 0xb6, 0x0f, 0xb7, 0x0f, 0xb8, 0x0f, 0xb9,
+  0x0f, 0xba, 0x0f, 0xbb, 0x0f, 0xbc, 0x0f, 0xbd, 0x0f, 0xbe, 0x0f, 0xbf,
+  0x0f, 0xc0, 0x0f, 0xc1, 0x0f, 0xc2, 0x0f, 0xc3, 0x0f, 0xc4, 0x0f, 0xc5,
+  0x0f, 0xc6, 0x0f, 0xc7, 0x0f, 0xc8, 0x0f, 0xc9, 0x0f, 0xca, 0x0f, 0xcb,
+  0x0f, 0xcc, 0x0f, 0xcd, 0x0f, 0xce, 0x0f, 0xcf, 0x0f, 0xd0, 0x0f, 0xd1,
+  0x0f, 0xd2, 0x0f, 0xd3, 0x0f, 0xd4, 0x0f, 0xd5, 0x0f, 0xd6, 0x0f, 0xd7,
+  0x0f, 0xd8, 0x0f, 0xd9, 0x0f, 0xda, 0x0f, 0xdb, 0x0f, 0xdc, 0x0f, 0xdd,
+  0x0f, 0xde, 0x0f, 0xdf, 0x0f, 0xe0, 0x0f, 0xe1, 0x0f, 0xe2, 0x0f, 0xe3,
+  0x0f, 0xe4, 0x0f, 0xe5, 0x0f, 0xe6, 0x0f, 0xe7, 0x0f, 0xe8, 0x0f, 0xe9,
+  0x0f, 0xea, 0x0f, 0xeb, 0x0f, 0xec, 0x0f, 0xed, 0x0f, 0xee, 0x0f, 0xef,
+  0x0f, 0xf0, 0x0f, 0xf1, 0x0f, 0xf2, 0x0f, 0xf3, 0x0f, 0xf4, 0x0f, 0xf5,
+  0x0f, 0xf6, 0x0f, 0xf7, 0x0f, 0xf8, 0x0f, 0xf9, 0x0f, 0xfa, 0x0f, 0xfb,
+  0x0f, 0xfc, 0x0f, 0xfd, 0x0f, 0xfe, 0x0f, 0xff, 0x10, 0x00, 0x10, 0x01,
+  0x10, 0x02, 0x10, 0x03, 0x10, 0x04, 0x10, 0x05, 0x10, 0x06, 0x10, 0x07,
+  0x10, 0x08, 0x10, 0x09, 0x10, 0x0a, 0x10, 0x0b, 0x10, 0x0c, 0x10, 0x0d,
+  0x10, 0x0e, 0x10, 0x0f, 0x10, 0x10, 0x10, 0x11, 0x10, 0x12, 0x10, 0x13,
+  0x10, 0x14, 0x10, 0x15, 0x10, 0x16, 0x10, 0x17, 0x10, 0x18, 0x10, 0x19,
+  0x10, 0x1a, 0x10, 0x1b, 0x10, 0x1c, 0x10, 0x1d, 0x10, 0x1e, 0x10, 0x1f,
+  0x10, 0x20, 0x10, 0x21, 0x10, 0x22, 0x10, 0x23, 0x10, 0x24, 0x10, 0x25,
+  0x10, 0x26, 0x10, 0x27, 0x10, 0x28, 0x10, 0x29, 0x10, 0x2a, 0x10, 0x2b,
+  0x10, 0x2c, 0x10, 0x2d, 0x10, 0x2e, 0x10, 0x2f, 0x10, 0x30, 0x10, 0x31,
+  0x10, 0x32, 0x10, 0x33, 0x10, 0x34, 0x10, 0x35, 0x10, 0x36, 0x10, 0x37,
+  0x10, 0x38, 0x10, 0x39, 0x10, 0x3a, 0x10, 0x3b, 0x10, 0x3c, 0x10, 0x3d,
+  0x10, 0x3e, 0x10, 0x3f, 0x10, 0x40, 0x10, 0x41, 0x10, 0x42, 0x10, 0x43,
+  0x10, 0x44, 0x10, 0x45, 0x10, 0x46, 0x10, 0x47, 0x10, 0x48, 0x10, 0x49,
+  0x10, 0x4a, 0x10, 0x4b, 0x10, 0x4c, 0x10, 0x4d, 0x10, 0x4e, 0x10, 0x4f,
+  0x10, 0x50, 0x10, 0x51, 0x10, 0x52, 0x10, 0x53, 0x10, 0x54, 0x10, 0x55,
+  0x10, 0x56, 0x10, 0x57, 0x10, 0x58, 0x10, 0x59, 0x10, 0x5a, 0x10, 0x5b,
+  0x10, 0x5c, 0x10, 0x5d, 0x10, 0x5e, 0x10, 0x5f, 0x10, 0x60, 0x10, 0x61,
+  0x10, 0x62, 0x10, 0x63, 0x10, 0x64, 0x10, 0x65, 0x10, 0x66, 0x10, 0x67,
+  0x10, 0x68, 0x10, 0x69, 0x10, 0x6a, 0x10, 0x6b, 0x10, 0x6c, 0x10, 0x6d,
+  0x10, 0x6e, 0x10, 0x6f, 0x10, 0x70, 0x10, 0x71, 0x10, 0x72, 0x10, 0x73,
+  0x10, 0x74, 0x10, 0x75, 0x10, 0x76, 0x10, 0x77, 0x10, 0x78, 0x10, 0x79,
+  0x10, 0x7a, 0x10, 0x7b, 0x10, 0x7c, 0x10, 0x7d, 0x10, 0x7e, 0x10, 0x7f,
+  0x10, 0x80, 0x10, 0x81, 0x10, 0x82, 0x10, 0x83, 0x10, 0x84, 0x10, 0x85,
+  0x10, 0x86, 0x10, 0x87, 0x10, 0x88, 0x10, 0x89, 0x10, 0x8a, 0x10, 0x8b,
+  0x10, 0x8c, 0x10, 0x8d, 0x10, 0x8e, 0x10, 0x8f, 0x10, 0x90, 0x10, 0x91,
+  0x10, 0x92, 0x10, 0x93, 0x10, 0x94, 0x10, 0x95, 0x10, 0x96, 0x10, 0x97,
+  0x10, 0x98, 0x10, 0x99, 0x10, 0x9a, 0x10, 0x9b, 0x10, 0x9c, 0x10, 0x9d,
+  0x10, 0x9e, 0x10, 0x9f, 0x10, 0xa0, 0x10, 0xa1, 0x10, 0xa2, 0x10, 0xa3,
+  0x10, 0xa4, 0x10, 0xa5, 0x10, 0xa6, 0x10, 0xa7, 0x10, 0xa8, 0x10, 0xa9,
+  0x10, 0xaa, 0x10, 0xab, 0x10, 0xac, 0x10, 0xad, 0x10, 0xae, 0x10, 0xaf,
+  0x10, 0xb0, 0x10, 0xb1, 0x10, 0xb2, 0x10, 0xb3, 0x10, 0xb4, 0x10, 0xb5,
+  0x10, 0xb6, 0x10, 0xb7, 0x10, 0xb8, 0x10, 0xb9, 0x10, 0xba, 0x10, 0xbb,
+  0x10, 0xbc, 0x10, 0xbd, 0x10, 0xbe, 0x10, 0xbf, 0x10, 0xc0, 0x10, 0xc1,
+  0x10, 0xc2, 0x10, 0xc3, 0x10, 0xc4, 0x10, 0xc5, 0x10, 0xc6, 0x10, 0xc7,
+  0x10, 0xc8, 0x10, 0xc9, 0x10, 0xca, 0x10, 0xcb, 0x10, 0xcc, 0x10, 0xcd,
+  0x10, 0xce, 0x10, 0xcf, 0x10, 0xd0, 0x10, 0xd1, 0x10, 0xd2, 0x10, 0xd3,
+  0x10, 0xd4, 0x10, 0xd5, 0x10, 0xd6, 0x10, 0xd7, 0x10, 0xd8, 0x10, 0xd9,
+  0x10, 0xda, 0x10, 0xdb, 0x10, 0xdc, 0x10, 0xdd, 0x10, 0xde, 0x10, 0xdf,
+  0x10, 0xe0, 0x10, 0xe1, 0x10, 0xe2, 0x10, 0xe3, 0x10, 0xe4, 0x10, 0xe5,
+  0x10, 0xe6, 0x10, 0xe7, 0x10, 0xe8, 0x10, 0xe9, 0x10, 0xea, 0x10, 0xeb,
+  0x10, 0xec, 0x10, 0xed, 0x10, 0xee, 0x10, 0xef, 0x10, 0xf0, 0x10, 0xf1,
+  0x10, 0xf2, 0x10, 0xf3, 0x10, 0xf4, 0x10, 0xf5, 0x10, 0xf6, 0x10, 0xf7,
+  0x10, 0xf8, 0x10, 0xf9, 0x10, 0xfa, 0x10, 0xfb, 0x10, 0xfc, 0x10, 0xfd,
+  0x10, 0xfe, 0x10, 0xff, 0x11, 0x00, 0x11, 0x01, 0x11, 0x02, 0x11, 0x03,
+  0x11, 0x04, 0x11, 0x05, 0x11, 0x06, 0x11, 0x07, 0x11, 0x08, 0x11, 0x09,
+  0x11, 0x0a, 0x11, 0x0b, 0x11, 0x0c, 0x11, 0x0d, 0x11, 0x0e, 0x11, 0x0f,
+  0x11, 0x10, 0x11, 0x11, 0x11, 0x12, 0x11, 0x13, 0x11, 0x14, 0x11, 0x15,
+  0x11, 0x16, 0x11, 0x17, 0x11, 0x18, 0x11, 0x19, 0x11, 0x1a, 0x11, 0x1b,
+  0x11, 0x1c, 0x11, 0x1d, 0x11, 0x1e, 0x11, 0x1f, 0x11, 0x20, 0x11, 0x21,
+  0x11, 0x22, 0x11, 0x23, 0x11, 0x24, 0x11, 0x25, 0x11, 0x26, 0x11, 0x27,
+  0x11, 0x28, 0x11, 0x29, 0x11, 0x2a, 0x11, 0x2b, 0x11, 0x2c, 0x11, 0x2d,
+  0x11, 0x2e, 0x11, 0x2f, 0x11, 0x30, 0x11, 0x31, 0x11, 0x32, 0x11, 0x33,
+  0x11, 0x34, 0x11, 0x35, 0x11, 0x36, 0x11, 0x37, 0x11, 0x38, 0x11, 0x39,
+  0x11, 0x3a, 0x11, 0x3b, 0x11, 0x3c, 0x11, 0x3d, 0x11, 0x3e, 0x11, 0x3f,
+  0x11, 0x40, 0x11, 0x41, 0x11, 0x42, 0x11, 0x43, 0x11, 0x44, 0x11, 0x45,
+  0x11, 0x46, 0x11, 0x47, 0x11, 0x48, 0x11, 0x49, 0x11, 0x4a, 0x11, 0x4b,
+  0x11, 0x4c, 0x11, 0x4d, 0x11, 0x4e, 0x11, 0x4f, 0x11, 0x50, 0x11, 0x51,
+  0x11, 0x52, 0x11, 0x53, 0x11, 0x54, 0x11, 0x55, 0x11, 0x56, 0x11, 0x57,
+  0x11, 0x58, 0x11, 0x59, 0x11, 0x5a, 0x11, 0x5b, 0x11, 0x5c, 0x11, 0x5d,
+  0x11, 0x5e, 0x11, 0x5f, 0x11, 0x60, 0x11, 0x61, 0x11, 0x62, 0x11, 0x63,
+  0x11, 0x64, 0x11, 0x65, 0x11, 0x66, 0x11, 0x67, 0x11, 0x68, 0x11, 0x69,
+  0x11, 0x6a, 0x11, 0x6b, 0x11, 0x6c, 0x11, 0x6d, 0x11, 0x6e, 0x11, 0x6f,
+  0x11, 0x70, 0x11, 0x71, 0x11, 0x72, 0x11, 0x73, 0x11, 0x74, 0x11, 0x75,
+  0x11, 0x76, 0x11, 0x77, 0x11, 0x78, 0x11, 0x79, 0x11, 0x7a, 0x11, 0x7b,
+  0x11, 0x7c, 0x11, 0x7d, 0x11, 0x7e, 0x11, 0x7f, 0x11, 0x80, 0x11, 0x81,
+  0x11, 0x82, 0x11, 0x83, 0x11, 0x84, 0x11, 0x85, 0x11, 0x86, 0x11, 0x87,
+  0x11, 0x88, 0x11, 0x89, 0x11, 0x8a, 0x11, 0x8b, 0x11, 0x8c, 0x11, 0x8d,
+  0x11, 0x8e, 0x11, 0x8f, 0x11, 0x90, 0x11, 0x91, 0x11, 0x92, 0x11, 0x93,
+  0x11, 0x94, 0x11, 0x95, 0x11, 0x96, 0x11, 0x97, 0x11, 0x98, 0x11, 0x99,
+  0x11, 0x9a, 0x11, 0x9b, 0x11, 0x9c, 0x11, 0x9d, 0x11, 0x9e, 0x11, 0x9f,
+  0x11, 0xa0, 0x11, 0xa1, 0x11, 0xa2, 0x11, 0xa3, 0x11, 0xa4, 0x11, 0xa5,
+  0x11, 0xa6, 0x11, 0xa7, 0x11, 0xa8, 0x11, 0xa9, 0x11, 0xaa, 0x11, 0xab,
+  0x11, 0xac, 0x11, 0xad, 0x11, 0xae, 0x11, 0xaf, 0x11, 0xb0, 0x11, 0xb1,
+  0x11, 0xb2, 0x11, 0xb3, 0x11, 0xb4, 0x11, 0xb5, 0x11, 0xb6, 0x11, 0xb7,
+  0x11, 0xb8, 0x11, 0xb9, 0x11, 0xba, 0x11, 0xbb, 0x11, 0xbc, 0x11, 0xbd,
+  0x11, 0xbe, 0x11, 0xbf, 0x11, 0xc0, 0x11, 0xc1, 0x11, 0xc2, 0x11, 0xc3,
+  0x11, 0xc4, 0x11, 0xc5, 0x11, 0xc6, 0x11, 0xc7, 0x11, 0xc8, 0x11, 0xc9,
+  0x11, 0xca, 0x11, 0xcb, 0x11, 0xcc, 0x11, 0xcd, 0x11, 0xce, 0x11, 0xcf,
+  0x11, 0xd0, 0x11, 0xd1, 0x11, 0xd2, 0x11, 0xd3, 0x11, 0xd4, 0x11, 0xd5,
+  0x11, 0xd6, 0x11, 0xd7, 0x11, 0xd8, 0x11, 0xd9, 0x11, 0xda, 0x11, 0xdb,
+  0x11, 0xdc, 0x11, 0xdd, 0x11, 0xde, 0x11, 0xdf, 0x11, 0xe0, 0x11, 0xe1,
+  0x11, 0xe2, 0x11, 0xe3, 0x11, 0xe4, 0x11, 0xe5, 0x11, 0xe6, 0x11, 0xe7,
+  0x11, 0xe8, 0x11, 0xe9, 0x11, 0xea, 0x11, 0xeb, 0x11, 0xec, 0x11, 0xed,
+  0x11, 0xee, 0x11, 0xef, 0x11, 0xf0, 0x11, 0xf1, 0x11, 0xf2, 0x11, 0xf3,
+  0x11, 0xf4, 0x11, 0xf5, 0x11, 0xf6, 0x11, 0xf7, 0x11, 0xf8, 0x11, 0xf9,
+  0x11, 0xfa, 0x11, 0xfb, 0x11, 0xfc, 0x11, 0xfd, 0x11, 0xfe, 0x11, 0xff,
+  0x12, 0x00, 0x12, 0x01, 0x12, 0x02, 0x12, 0x03, 0x12, 0x04, 0x12, 0x05,
+  0x12, 0x06, 0x12, 0x07, 0x12, 0x08, 0x12, 0x09, 0x12, 0x0a, 0x12, 0x0b,
+  0x12, 0x0c, 0x12, 0x0d, 0x12, 0x0e, 0x09, 0x73, 0x66, 0x74, 0x68, 0x79,
+  0x70, 0x68, 0x65, 0x6e, 0x07, 0x41, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e,
+  0x07, 0x61, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e, 0x06, 0x41, 0x62, 0x72,
+  0x65, 0x76, 0x65, 0x06, 0x61, 0x62, 0x72, 0x65, 0x76, 0x65, 0x07, 0x41,
+  0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x07, 0x61, 0x6f, 0x67, 0x6f, 0x6e,
+  0x65, 0x6b, 0x0b, 0x43, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
+  0x65, 0x78, 0x0b, 0x63, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
+  0x65, 0x78, 0x0a, 0x43, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e,
+  0x74, 0x0a, 0x63, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74,
+  0x06, 0x44, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x64, 0x63, 0x61, 0x72,
+  0x6f, 0x6e, 0x06, 0x44, 0x63, 0x72, 0x6f, 0x61, 0x74, 0x07, 0x45, 0x6d,
+  0x61, 0x63, 0x72, 0x6f, 0x6e, 0x07, 0x65, 0x6d, 0x61, 0x63, 0x72, 0x6f,
+  0x6e, 0x06, 0x45, 0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x65, 0x62, 0x72,
+  0x65, 0x76, 0x65, 0x0a, 0x45, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65,
+  0x6e, 0x74, 0x0a, 0x65, 0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e,
+  0x74, 0x07, 0x45, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x07, 0x65, 0x6f,
+  0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x06, 0x45, 0x63, 0x61, 0x72, 0x6f, 0x6e,
+  0x06, 0x65, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x0b, 0x47, 0x63, 0x69, 0x72,
+  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x67, 0x63, 0x69, 0x72,
+  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0a, 0x47, 0x64, 0x6f, 0x74,
+  0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0a, 0x67, 0x64, 0x6f, 0x74, 0x61,
+  0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x47, 0x63, 0x6f, 0x6d, 0x6d, 0x61,
+  0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x67, 0x63, 0x6f, 0x6d, 0x6d,
+  0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0b, 0x48, 0x63, 0x69, 0x72,
+  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x68, 0x63, 0x69, 0x72,
+  0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x04, 0x48, 0x62, 0x61, 0x72,
+  0x04, 0x68, 0x62, 0x61, 0x72, 0x06, 0x49, 0x74, 0x69, 0x6c, 0x64, 0x65,
+  0x06, 0x69, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x07, 0x49, 0x6d, 0x61, 0x63,
+  0x72, 0x6f, 0x6e, 0x07, 0x69, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e, 0x06,
+  0x49, 0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x69, 0x62, 0x72, 0x65, 0x76,
+  0x65, 0x07, 0x49, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x07, 0x69, 0x6f,
+  0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x02, 0x49, 0x4a, 0x02, 0x69, 0x6a, 0x0b,
+  0x4a, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b,
+  0x6a, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0c,
+  0x4b, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74,
+  0x0c, 0x6b, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e,
+  0x74, 0x0c, 0x6b, 0x67, 0x72, 0x65, 0x65, 0x6e, 0x6c, 0x61, 0x6e, 0x64,
+  0x69, 0x63, 0x06, 0x4c, 0x61, 0x63, 0x75, 0x74, 0x65, 0x06, 0x6c, 0x61,
+  0x63, 0x75, 0x74, 0x65, 0x0c, 0x4c, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61,
+  0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x6c, 0x63, 0x6f, 0x6d, 0x6d, 0x61,
+  0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x06, 0x4c, 0x63, 0x61, 0x72, 0x6f,
+  0x6e, 0x06, 0x6c, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x04, 0x4c, 0x64, 0x6f,
+  0x74, 0x04, 0x6c, 0x64, 0x6f, 0x74, 0x06, 0x4e, 0x61, 0x63, 0x75, 0x74,
+  0x65, 0x06, 0x6e, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0c, 0x4e, 0x63, 0x6f,
+  0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x6e, 0x63,
+  0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x06, 0x4e,
+  0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x6e, 0x63, 0x61, 0x72, 0x6f, 0x6e,
+  0x0b, 0x6e, 0x61, 0x70, 0x6f, 0x73, 0x74, 0x72, 0x6f, 0x70, 0x68, 0x65,
+  0x03, 0x45, 0x6e, 0x67, 0x03, 0x65, 0x6e, 0x67, 0x07, 0x4f, 0x6d, 0x61,
+  0x63, 0x72, 0x6f, 0x6e, 0x07, 0x6f, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e,
+  0x06, 0x4f, 0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x6f, 0x62, 0x72, 0x65,
+  0x76, 0x65, 0x0d, 0x4f, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75, 0x6d,
+  0x6c, 0x61, 0x75, 0x74, 0x0d, 0x6f, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72,
+  0x75, 0x6d, 0x6c, 0x61, 0x75, 0x74, 0x06, 0x52, 0x61, 0x63, 0x75, 0x74,
+  0x65, 0x06, 0x72, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0c, 0x52, 0x63, 0x6f,
+  0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0c, 0x72, 0x63,
+  0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x06, 0x52,
+  0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x72, 0x63, 0x61, 0x72, 0x6f, 0x6e,
+  0x06, 0x53, 0x61, 0x63, 0x75, 0x74, 0x65, 0x06, 0x73, 0x61, 0x63, 0x75,
+  0x74, 0x65, 0x0b, 0x53, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
+  0x65, 0x78, 0x0b, 0x73, 0x63, 0x69, 0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c,
+  0x65, 0x78, 0x0c, 0x54, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63,
+  0x65, 0x6e, 0x74, 0x0c, 0x74, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63,
+  0x63, 0x65, 0x6e, 0x74, 0x06, 0x54, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06,
+  0x74, 0x63, 0x61, 0x72, 0x6f, 0x6e, 0x04, 0x54, 0x62, 0x61, 0x72, 0x04,
+  0x74, 0x62, 0x61, 0x72, 0x06, 0x55, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x06,
+  0x75, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x07, 0x55, 0x6d, 0x61, 0x63, 0x72,
+  0x6f, 0x6e, 0x07, 0x75, 0x6d, 0x61, 0x63, 0x72, 0x6f, 0x6e, 0x06, 0x55,
+  0x62, 0x72, 0x65, 0x76, 0x65, 0x06, 0x75, 0x62, 0x72, 0x65, 0x76, 0x65,
+  0x05, 0x55, 0x72, 0x69, 0x6e, 0x67, 0x05, 0x75, 0x72, 0x69, 0x6e, 0x67,
+  0x0d, 0x55, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75, 0x6d, 0x6c, 0x61,
+  0x75, 0x74, 0x0d, 0x75, 0x68, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75, 0x6d,
+  0x6c, 0x61, 0x75, 0x74, 0x07, 0x55, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b,
+  0x07, 0x75, 0x6f, 0x67, 0x6f, 0x6e, 0x65, 0x6b, 0x0b, 0x57, 0x63, 0x69,
+  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x77, 0x63, 0x69,
+  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x59, 0x63, 0x69,
+  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x0b, 0x79, 0x63, 0x69,
+  0x72, 0x63, 0x75, 0x6d, 0x66, 0x6c, 0x65, 0x78, 0x06, 0x5a, 0x61, 0x63,
+  0x75, 0x74, 0x65, 0x06, 0x7a, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0a, 0x5a,
+  0x64, 0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x0a, 0x7a, 0x64,
+  0x6f, 0x74, 0x61, 0x63, 0x63, 0x65, 0x6e, 0x74, 0x05, 0x6c, 0x6f, 0x6e,
+  0x67, 0x73, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x38, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x39, 0x46, 0x05, 0x4f,
+  0x68, 0x6f, 0x72, 0x6e, 0x05, 0x6f, 0x68, 0x6f, 0x72, 0x6e, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x41, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x41, 0x45, 0x05, 0x55, 0x68, 0x6f, 0x72, 0x6e,
+  0x05, 0x75, 0x68, 0x6f, 0x72, 0x6e, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x42, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x43, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x44, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x31, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31,
+  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x35, 0x06, 0x47,
+  0x63, 0x61, 0x72, 0x6f, 0x6e, 0x06, 0x67, 0x63, 0x61, 0x72, 0x6f, 0x6e,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x31, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x31, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x45, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x31, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x31, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x31, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x31, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x31, 0x46, 0x39,
+  0x0a, 0x41, 0x72, 0x69, 0x6e, 0x67, 0x61, 0x63, 0x75, 0x74, 0x65, 0x0a,
+  0x61, 0x72, 0x69, 0x6e, 0x67, 0x61, 0x63, 0x75, 0x74, 0x65, 0x07, 0x41,
+  0x45, 0x61, 0x63, 0x75, 0x74, 0x65, 0x07, 0x61, 0x65, 0x61, 0x63, 0x75,
+  0x74, 0x65, 0x0b, 0x4f, 0x73, 0x6c, 0x61, 0x73, 0x68, 0x61, 0x63, 0x75,
+  0x74, 0x65, 0x0b, 0x6f, 0x73, 0x6c, 0x61, 0x73, 0x68, 0x61, 0x63, 0x75,
+  0x74, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x30, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x32, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32,
+  0x31, 0x37, 0x0c, 0x53, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63, 0x63,
+  0x65, 0x6e, 0x74, 0x0c, 0x73, 0x63, 0x6f, 0x6d, 0x6d, 0x61, 0x61, 0x63,
+  0x63, 0x65, 0x6e, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x43,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x32, 0x46,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x32,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x30, 0x32, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x36, 0x08, 0x64, 0x6f, 0x74,
+  0x6c, 0x65, 0x73, 0x73, 0x6a, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x33, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x34, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x35,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x37, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x38,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x39, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x41, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x42,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x43, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x43, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x44,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x46,
+  0x37, 0x09, 0x67, 0x72, 0x61, 0x76, 0x65, 0x63, 0x6f, 0x6d, 0x62, 0x09,
+  0x61, 0x63, 0x75, 0x74, 0x65, 0x63, 0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x30, 0x32, 0x09, 0x74, 0x69, 0x6c, 0x64, 0x65, 0x63,
+  0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30,
+  0x33, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x0d, 0x68, 0x6f, 0x6f, 0x6b,
+  0x61, 0x62, 0x6f, 0x76, 0x65, 0x63, 0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x30, 0x33, 0x32, 0x32, 0x0c, 0x64, 0x6f, 0x74, 0x62, 0x65, 0x6c,
+  0x6f, 0x77, 0x63, 0x6f, 0x6d, 0x62, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x32, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x33, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x34, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x35, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x35, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x35, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x36, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x37, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x37, 0x45, 0x05, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x0d, 0x64, 0x69, 0x65,
+  0x72, 0x65, 0x73, 0x69, 0x73, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x0a, 0x41,
+  0x6c, 0x70, 0x68, 0x61, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x09, 0x61, 0x6e,
+  0x6f, 0x74, 0x65, 0x6c, 0x65, 0x69, 0x61, 0x0c, 0x45, 0x70, 0x73, 0x69,
+  0x6c, 0x6f, 0x6e, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x08, 0x45, 0x74, 0x61,
+  0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x09, 0x49, 0x6f, 0x74, 0x61, 0x74, 0x6f,
+  0x6e, 0x6f, 0x73, 0x0c, 0x4f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x74,
+  0x6f, 0x6e, 0x6f, 0x73, 0x0c, 0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e,
+  0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x0a, 0x4f, 0x6d, 0x65, 0x67, 0x61, 0x74,
+  0x6f, 0x6e, 0x6f, 0x73, 0x11, 0x69, 0x6f, 0x74, 0x61, 0x64, 0x69, 0x65,
+  0x72, 0x65, 0x73, 0x69, 0x73, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x05, 0x41,
+  0x6c, 0x70, 0x68, 0x61, 0x04, 0x42, 0x65, 0x74, 0x61, 0x05, 0x47, 0x61,
+  0x6d, 0x6d, 0x61, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x39, 0x34, 0x07,
+  0x45, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x04, 0x5a, 0x65, 0x74, 0x61,
+  0x03, 0x45, 0x74, 0x61, 0x05, 0x54, 0x68, 0x65, 0x74, 0x61, 0x04, 0x49,
+  0x6f, 0x74, 0x61, 0x05, 0x4b, 0x61, 0x70, 0x70, 0x61, 0x06, 0x4c, 0x61,
+  0x6d, 0x62, 0x64, 0x61, 0x02, 0x4d, 0x75, 0x02, 0x4e, 0x75, 0x02, 0x58,
+  0x69, 0x07, 0x4f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x02, 0x50, 0x69,
+  0x03, 0x52, 0x68, 0x6f, 0x05, 0x53, 0x69, 0x67, 0x6d, 0x61, 0x03, 0x54,
+  0x61, 0x75, 0x07, 0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x03, 0x50,
+  0x68, 0x69, 0x03, 0x43, 0x68, 0x69, 0x03, 0x50, 0x73, 0x69, 0x0c, 0x49,
+  0x6f, 0x74, 0x61, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73, 0x0f,
+  0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x64, 0x69, 0x65, 0x72, 0x65,
+  0x73, 0x69, 0x73, 0x0a, 0x61, 0x6c, 0x70, 0x68, 0x61, 0x74, 0x6f, 0x6e,
+  0x6f, 0x73, 0x0c, 0x65, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x74, 0x6f,
+  0x6e, 0x6f, 0x73, 0x08, 0x65, 0x74, 0x61, 0x74, 0x6f, 0x6e, 0x6f, 0x73,
+  0x09, 0x69, 0x6f, 0x74, 0x61, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x14, 0x75,
+  0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73,
+  0x69, 0x73, 0x74, 0x6f, 0x6e, 0x6f, 0x73, 0x05, 0x61, 0x6c, 0x70, 0x68,
+  0x61, 0x04, 0x62, 0x65, 0x74, 0x61, 0x05, 0x67, 0x61, 0x6d, 0x6d, 0x61,
+  0x05, 0x64, 0x65, 0x6c, 0x74, 0x61, 0x07, 0x65, 0x70, 0x73, 0x69, 0x6c,
+  0x6f, 0x6e, 0x04, 0x7a, 0x65, 0x74, 0x61, 0x03, 0x65, 0x74, 0x61, 0x05,
+  0x74, 0x68, 0x65, 0x74, 0x61, 0x04, 0x69, 0x6f, 0x74, 0x61, 0x05, 0x6b,
+  0x61, 0x70, 0x70, 0x61, 0x06, 0x6c, 0x61, 0x6d, 0x62, 0x64, 0x61, 0x07,
+  0x75, 0x6e, 0x69, 0x30, 0x33, 0x42, 0x43, 0x02, 0x6e, 0x75, 0x02, 0x78,
+  0x69, 0x07, 0x6f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x03, 0x72, 0x68,
+  0x6f, 0x06, 0x73, 0x69, 0x67, 0x6d, 0x61, 0x31, 0x05, 0x73, 0x69, 0x67,
+  0x6d, 0x61, 0x03, 0x74, 0x61, 0x75, 0x07, 0x75, 0x70, 0x73, 0x69, 0x6c,
+  0x6f, 0x6e, 0x03, 0x70, 0x68, 0x69, 0x03, 0x63, 0x68, 0x69, 0x03, 0x70,
+  0x73, 0x69, 0x05, 0x6f, 0x6d, 0x65, 0x67, 0x61, 0x0c, 0x69, 0x6f, 0x74,
+  0x61, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73, 0x0f, 0x75, 0x70,
+  0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69,
+  0x73, 0x0c, 0x6f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x6e, 0x74, 0x6f, 0x6e,
+  0x6f, 0x73, 0x0c, 0x75, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x74, 0x6f,
+  0x6e, 0x6f, 0x73, 0x0a, 0x6f, 0x6d, 0x65, 0x67, 0x61, 0x74, 0x6f, 0x6e,
+  0x6f, 0x73, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x43, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x44, 0x30, 0x06, 0x74, 0x68, 0x65, 0x74, 0x61,
+  0x31, 0x08, 0x55, 0x70, 0x73, 0x69, 0x6c, 0x6f, 0x6e, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x44, 0x34, 0x04, 0x70, 0x68, 0x69, 0x31, 0x06, 0x6f, 0x6d, 0x65, 0x67,
+  0x61, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x44, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x44, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x44, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x44, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x44, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x45, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x45, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x45, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33,
+  0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x46, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x33, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x30, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x31, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x32, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x33, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x34, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x35, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x36, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x39, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x41, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x42, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x43, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x44, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x45, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x46, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x34, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x30, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x31, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x32, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35,
+  0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x30, 0x35, 0x32, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x30, 0x35, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x30, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x31, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x32, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x33, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x34, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x35, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x36, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x37, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x38, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x39, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x41, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x42, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x43, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x43, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44,
+  0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x44, 0x43, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x44, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x30, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x31, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x32, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x33, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x34, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x35, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x36, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x37, 0x46, 0x06, 0x57,
+  0x67, 0x72, 0x61, 0x76, 0x65, 0x06, 0x77, 0x67, 0x72, 0x61, 0x76, 0x65,
+  0x06, 0x57, 0x61, 0x63, 0x75, 0x74, 0x65, 0x06, 0x77, 0x61, 0x63, 0x75,
+  0x74, 0x65, 0x09, 0x57, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73,
+  0x09, 0x77, 0x64, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x38, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x38, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x38, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x39, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x41, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x42, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x44, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x45, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x31, 0x45, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45,
+  0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x31, 0x06, 0x59,
+  0x67, 0x72, 0x61, 0x76, 0x65, 0x06, 0x79, 0x67, 0x72, 0x61, 0x76, 0x65,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x45, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x45, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x45, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x43,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x30, 0x46,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x32,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x31, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x32,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x45,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x31,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x34,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x35, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x43,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x36, 0x46,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x32,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x43,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x38, 0x46,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x32,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x45,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x31,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x34,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x44, 0x46,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x32,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x45,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x31, 0x46, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x31, 0x46, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x31,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x30, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x34,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x30, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x30, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x30, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x30, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x31, 0x0a, 0x66, 0x69, 0x67,
+  0x75, 0x72, 0x65, 0x64, 0x61, 0x73, 0x68, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x30, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x36, 0x0d,
+  0x75, 0x6e, 0x64, 0x65, 0x72, 0x73, 0x63, 0x6f, 0x72, 0x65, 0x64, 0x62,
+  0x6c, 0x0d, 0x71, 0x75, 0x6f, 0x74, 0x65, 0x72, 0x65, 0x76, 0x65, 0x72,
+  0x73, 0x65, 0x64, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x31, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x33, 0x0e, 0x6f, 0x6e, 0x65, 0x64,
+  0x6f, 0x74, 0x65, 0x6e, 0x6c, 0x65, 0x61, 0x64, 0x65, 0x72, 0x0e, 0x74,
+  0x77, 0x6f, 0x64, 0x6f, 0x74, 0x65, 0x6e, 0x6c, 0x65, 0x61, 0x64, 0x65,
+  0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x32,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x31, 0x06, 0x6d, 0x69,
+  0x6e, 0x75, 0x74, 0x65, 0x06, 0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x30, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x30, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x42, 0x09,
+  0x65, 0x78, 0x63, 0x6c, 0x61, 0x6d, 0x64, 0x62, 0x6c, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x33, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x34, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x35, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x36, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x37,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x38,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x39, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x41, 0x30, 0x0d, 0x63, 0x6f, 0x6c, 0x6f, 0x6e, 0x6d,
+  0x6f, 0x6e, 0x65, 0x74, 0x61, 0x72, 0x79, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x30, 0x41, 0x32, 0x04, 0x6c, 0x69, 0x72, 0x61, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x30, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x36,
+  0x06, 0x70, 0x65, 0x73, 0x65, 0x74, 0x61, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x30, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x41, 0x04, 0x64, 0x6f, 0x6e, 0x67,
+  0x04, 0x45, 0x75, 0x72, 0x6f, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x41, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x42, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x44, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x30, 0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x30, 0x45,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x31, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x31, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x31, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x31, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x31, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x30,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x30, 0x08, 0x49, 0x66,
+  0x72, 0x61, 0x6b, 0x74, 0x75, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x31, 0x37, 0x0b, 0x77, 0x65, 0x69, 0x65, 0x72,
+  0x73, 0x74, 0x72, 0x61, 0x73, 0x73, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x31, 0x42, 0x08, 0x52, 0x66, 0x72, 0x61, 0x6b,
+  0x74, 0x75, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x44, 0x0c,
+  0x70, 0x72, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x31,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x32, 0x44, 0x09, 0x65, 0x73, 0x74, 0x69, 0x6d, 0x61, 0x74,
+  0x65, 0x64, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x32, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x33, 0x34, 0x05, 0x61, 0x6c, 0x65, 0x70, 0x68, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x31, 0x35, 0x32, 0x08, 0x6f, 0x6e, 0x65, 0x74, 0x68, 0x69, 0x72,
+  0x64, 0x09, 0x74, 0x77, 0x6f, 0x74, 0x68, 0x69, 0x72, 0x64, 0x73, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x41, 0x09,
+  0x6f, 0x6e, 0x65, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x0c, 0x74, 0x68,
+  0x72, 0x65, 0x65, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x73, 0x0b, 0x66,
+  0x69, 0x76, 0x65, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x73, 0x0c, 0x73,
+  0x65, 0x76, 0x65, 0x6e, 0x65, 0x69, 0x67, 0x68, 0x74, 0x68, 0x73, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x35, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x37, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x38, 0x39, 0x09, 0x61, 0x72, 0x72, 0x6f,
+  0x77, 0x6c, 0x65, 0x66, 0x74, 0x07, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x75,
+  0x70, 0x0a, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x72, 0x69, 0x67, 0x68, 0x74,
+  0x09, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x6f, 0x77, 0x6e, 0x09, 0x61,
+  0x72, 0x72, 0x6f, 0x77, 0x62, 0x6f, 0x74, 0x68, 0x09, 0x61, 0x72, 0x72,
+  0x6f, 0x77, 0x75, 0x70, 0x64, 0x6e, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x39, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x39, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x39, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x41, 0x37, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77,
+  0x75, 0x70, 0x64, 0x6e, 0x62, 0x73, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x31, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x34, 0x0e, 0x63, 0x61, 0x72, 0x72,
+  0x69, 0x61, 0x67, 0x65, 0x72, 0x65, 0x74, 0x75, 0x72, 0x6e, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x42, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x42, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x42, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x43, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x43, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x43, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x43, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x43, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x43, 0x46, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62, 0x6c, 0x6c,
+  0x65, 0x66, 0x74, 0x0a, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62, 0x6c,
+  0x75, 0x70, 0x0d, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62, 0x6c, 0x72,
+  0x69, 0x67, 0x68, 0x74, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64, 0x62,
+  0x6c, 0x64, 0x6f, 0x77, 0x6e, 0x0c, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x64,
+  0x62, 0x6c, 0x62, 0x6f, 0x74, 0x68, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x44, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x44, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x45, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x45, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x46, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x31, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x31,
+  0x46, 0x46, 0x09, 0x75, 0x6e, 0x69, 0x76, 0x65, 0x72, 0x73, 0x61, 0x6c,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x30, 0x31, 0x0b, 0x65, 0x78, 0x69,
+  0x73, 0x74, 0x65, 0x6e, 0x74, 0x69, 0x61, 0x6c, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x32, 0x30, 0x34, 0x08, 0x65, 0x6d, 0x70, 0x74, 0x79, 0x73, 0x65,
+  0x74, 0x08, 0x67, 0x72, 0x61, 0x64, 0x69, 0x65, 0x6e, 0x74, 0x07, 0x65,
+  0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x0a, 0x6e, 0x6f, 0x74, 0x65, 0x6c,
+  0x65, 0x6d, 0x65, 0x6e, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x30,
+  0x41, 0x08, 0x73, 0x75, 0x63, 0x68, 0x74, 0x68, 0x61, 0x74, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x32, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32,
+  0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x30, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x32, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32,
+  0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x32, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32,
+  0x31, 0x36, 0x0c, 0x61, 0x73, 0x74, 0x65, 0x72, 0x69, 0x73, 0x6b, 0x6d,
+  0x61, 0x74, 0x68, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x31, 0x43, 0x0c,
+  0x70, 0x72, 0x6f, 0x70, 0x6f, 0x72, 0x74, 0x69, 0x6f, 0x6e, 0x61, 0x6c,
+  0x0a, 0x6f, 0x72, 0x74, 0x68, 0x6f, 0x67, 0x6f, 0x6e, 0x61, 0x6c, 0x05,
+  0x61, 0x6e, 0x67, 0x6c, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x32, 0x36, 0x0a, 0x6c, 0x6f, 0x67, 0x69, 0x63, 0x61,
+  0x6c, 0x61, 0x6e, 0x64, 0x09, 0x6c, 0x6f, 0x67, 0x69, 0x63, 0x61, 0x6c,
+  0x6f, 0x72, 0x0c, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x73, 0x65, 0x63, 0x74,
+  0x69, 0x6f, 0x6e, 0x05, 0x75, 0x6e, 0x69, 0x6f, 0x6e, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x32, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33,
+  0x33, 0x09, 0x74, 0x68, 0x65, 0x72, 0x65, 0x66, 0x6f, 0x72, 0x65, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x42, 0x07, 0x73, 0x69, 0x6d, 0x69,
+  0x6c, 0x61, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x34, 0x09, 0x63, 0x6f, 0x6e, 0x67,
+  0x72, 0x75, 0x65, 0x6e, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x34, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x35,
+  0x46, 0x0b, 0x65, 0x71, 0x75, 0x69, 0x76, 0x61, 0x6c, 0x65, 0x6e, 0x63,
+  0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x36,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x39, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x37, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38,
+  0x31, 0x0c, 0x70, 0x72, 0x6f, 0x70, 0x65, 0x72, 0x73, 0x75, 0x62, 0x73,
+  0x65, 0x74, 0x0e, 0x70, 0x72, 0x6f, 0x70, 0x65, 0x72, 0x73, 0x75, 0x70,
+  0x65, 0x72, 0x73, 0x65, 0x74, 0x09, 0x6e, 0x6f, 0x74, 0x73, 0x75, 0x62,
+  0x73, 0x65, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x35, 0x0c,
+  0x72, 0x65, 0x66, 0x6c, 0x65, 0x78, 0x73, 0x75, 0x62, 0x73, 0x65, 0x74,
+  0x0e, 0x72, 0x65, 0x66, 0x6c, 0x65, 0x78, 0x73, 0x75, 0x70, 0x65, 0x72,
+  0x73, 0x65, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x34, 0x0a,
+  0x63, 0x69, 0x72, 0x63, 0x6c, 0x65, 0x70, 0x6c, 0x75, 0x73, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x32, 0x39, 0x36, 0x0e, 0x63, 0x69, 0x72, 0x63, 0x6c,
+  0x65, 0x6d, 0x75, 0x6c, 0x74, 0x69, 0x70, 0x6c, 0x79, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x39,
+  0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x32, 0x41, 0x34, 0x0d, 0x70, 0x65, 0x72, 0x70, 0x65, 0x6e,
+  0x64, 0x69, 0x63, 0x75, 0x6c, 0x61, 0x72, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x42, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x43, 0x34, 0x07, 0x64, 0x6f, 0x74, 0x6d, 0x61, 0x74, 0x68, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x43, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x43, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x44, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x44, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x44, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x45, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x45, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x45, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x32, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x32, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x33, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x31, 0x05,
+  0x68, 0x6f, 0x75, 0x73, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x30,
+  0x46, 0x0d, 0x72, 0x65, 0x76, 0x6c, 0x6f, 0x67, 0x69, 0x63, 0x61, 0x6c,
+  0x6e, 0x6f, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x33, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x33, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x31, 0x46, 0x0a,
+  0x69, 0x6e, 0x74, 0x65, 0x67, 0x72, 0x61, 0x6c, 0x74, 0x70, 0x0a, 0x69,
+  0x6e, 0x74, 0x65, 0x67, 0x72, 0x61, 0x6c, 0x62, 0x74, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x32, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x37, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x39, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x34, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x37, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
+  0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x41, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41,
+  0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x41, 0x44, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x43,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x43, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x33, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x45,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x33, 0x45, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x34, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x32,
+  0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x34, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36,
+  0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x34, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36,
+  0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x36, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x34, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36,
+  0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x34, 0x36, 0x39, 0x08, 0x53, 0x46,
+  0x31, 0x30, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x30, 0x31, 0x08, 0x53, 0x46, 0x31, 0x31, 0x30, 0x30, 0x30, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x42, 0x08,
+  0x53, 0x46, 0x30, 0x31, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x45,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x30, 0x46, 0x08, 0x53, 0x46, 0x30,
+  0x33, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x31, 0x33, 0x08, 0x53, 0x46, 0x30, 0x32, 0x30, 0x30,
+  0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x35, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x31, 0x37, 0x08, 0x53, 0x46, 0x30, 0x34, 0x30, 0x30, 0x30, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x42, 0x08,
+  0x53, 0x46, 0x30, 0x38, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x45,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x31,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x32, 0x33, 0x08, 0x53, 0x46, 0x30, 0x39, 0x30, 0x30, 0x30,
+  0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x42, 0x08, 0x53, 0x46,
+  0x30, 0x36, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x32, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x35, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x35, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x33, 0x33, 0x08, 0x53, 0x46, 0x30, 0x37, 0x30, 0x30, 0x30, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x42, 0x08, 0x53, 0x46, 0x30, 0x35,
+  0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x43,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x34, 0x46,
+  0x08, 0x53, 0x46, 0x34, 0x33, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
+  0x32, 0x34, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x31, 0x30,
+  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x32, 0x30, 0x30, 0x30, 0x30,
+  0x08, 0x53, 0x46, 0x33, 0x39, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
+  0x32, 0x32, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x31, 0x30,
+  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x35, 0x30, 0x30, 0x30, 0x30,
+  0x08, 0x53, 0x46, 0x35, 0x30, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
+  0x34, 0x39, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x33, 0x38, 0x30,
+  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x38, 0x30, 0x30, 0x30, 0x30,
+  0x08, 0x53, 0x46, 0x32, 0x37, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
+  0x32, 0x36, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x33, 0x36, 0x30,
+  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x33, 0x37, 0x30, 0x30, 0x30, 0x30,
+  0x08, 0x53, 0x46, 0x34, 0x32, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
+  0x31, 0x39, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x30, 0x30,
+  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x32, 0x33, 0x30, 0x30, 0x30, 0x30,
+  0x08, 0x53, 0x46, 0x34, 0x37, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
+  0x34, 0x38, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x34, 0x31, 0x30,
+  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x34, 0x35, 0x30, 0x30, 0x30, 0x30,
+  0x08, 0x53, 0x46, 0x34, 0x36, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46,
+  0x34, 0x30, 0x30, 0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x34, 0x30,
+  0x30, 0x30, 0x30, 0x08, 0x53, 0x46, 0x35, 0x33, 0x30, 0x30, 0x30, 0x30,
+  0x08, 0x53, 0x46, 0x34, 0x34, 0x30, 0x30, 0x30, 0x30, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x36,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x36, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x37, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x37, 0x46, 0x07, 0x75, 0x70, 0x62, 0x6c, 0x6f, 0x63,
+  0x6b, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x31, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38,
+  0x33, 0x07, 0x64, 0x6e, 0x62, 0x6c, 0x6f, 0x63, 0x6b, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38,
+  0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x37, 0x05, 0x62, 0x6c,
+  0x6f, 0x63, 0x6b, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x38, 0x42, 0x07, 0x6c, 0x66, 0x62, 0x6c, 0x6f, 0x63, 0x6b, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x38, 0x46, 0x07,
+  0x72, 0x74, 0x62, 0x6c, 0x6f, 0x63, 0x6b, 0x07, 0x6c, 0x74, 0x73, 0x68,
+  0x61, 0x64, 0x65, 0x05, 0x73, 0x68, 0x61, 0x64, 0x65, 0x07, 0x64, 0x6b,
+  0x73, 0x68, 0x61, 0x64, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
+  0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x38, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
+  0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x42, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39,
+  0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x39, 0x45, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x39, 0x46, 0x09, 0x66, 0x69, 0x6c, 0x6c, 0x65, 0x64,
+  0x62, 0x6f, 0x78, 0x06, 0x48, 0x32, 0x32, 0x30, 0x37, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x35, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x35, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x35, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x41, 0x39, 0x06, 0x48, 0x31, 0x38, 0x35, 0x34, 0x33, 0x06, 0x48, 0x31,
+  0x38, 0x35, 0x35, 0x31, 0x0a, 0x66, 0x69, 0x6c, 0x6c, 0x65, 0x64, 0x72,
+  0x65, 0x63, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x31, 0x07, 0x74, 0x72, 0x69, 0x61,
+  0x67, 0x75, 0x70, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x39, 0x07,
+  0x74, 0x72, 0x69, 0x61, 0x67, 0x72, 0x74, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x42, 0x42, 0x07, 0x74, 0x72, 0x69, 0x61, 0x67, 0x64, 0x6e, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x42, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x33, 0x07, 0x74, 0x72, 0x69, 0x61,
+  0x67, 0x6c, 0x66, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x35, 0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x39, 0x06, 0x63, 0x69, 0x72, 0x63,
+  0x6c, 0x65, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x43, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x35, 0x43, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35,
+  0x43, 0x45, 0x06, 0x48, 0x31, 0x38, 0x35, 0x33, 0x33, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x44, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x35, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
+  0x37, 0x09, 0x69, 0x6e, 0x76, 0x62, 0x75, 0x6c, 0x6c, 0x65, 0x74, 0x09,
+  0x69, 0x6e, 0x76, 0x63, 0x69, 0x72, 0x63, 0x6c, 0x65, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x44, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
+  0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x43, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x44, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44,
+  0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x44, 0x46, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45,
+  0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x32, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x35, 0x45, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45,
+  0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x35, 0x0a, 0x6f, 0x70,
+  0x65, 0x6e, 0x62, 0x75, 0x6c, 0x6c, 0x65, 0x74, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x45,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x45, 0x46, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x31,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x34,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x35, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x35, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x39,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x43,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x30, 0x46,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x32,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x35,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x38,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x42,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x45,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x31,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x34,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x41,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x44,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x30,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x33,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x36,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x39,
+  0x09, 0x73, 0x6d, 0x69, 0x6c, 0x65, 0x66, 0x61, 0x63, 0x65, 0x0c, 0x69,
+  0x6e, 0x76, 0x73, 0x6d, 0x69, 0x6c, 0x65, 0x66, 0x61, 0x63, 0x65, 0x03,
+  0x73, 0x75, 0x6e, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x33, 0x46, 0x06, 0x66, 0x65, 0x6d, 0x61, 0x6c, 0x65, 0x07, 0x75,
+  0x6e, 0x69, 0x32, 0x36, 0x34, 0x31, 0x04, 0x6d, 0x61, 0x6c, 0x65, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x34, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x34, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x34, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x35, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x35, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x35, 0x46, 0x05, 0x73, 0x70, 0x61, 0x64, 0x65, 0x07, 0x75, 0x6e,
+  0x69, 0x32, 0x36, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36,
+  0x32, 0x04, 0x63, 0x6c, 0x75, 0x62, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36,
+  0x36, 0x34, 0x05, 0x68, 0x65, 0x61, 0x72, 0x74, 0x07, 0x64, 0x69, 0x61,
+  0x6d, 0x6f, 0x6e, 0x64, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x37,
+  0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69,
+  0x32, 0x36, 0x36, 0x39, 0x0b, 0x6d, 0x75, 0x73, 0x69, 0x63, 0x61, 0x6c,
+  0x6e, 0x6f, 0x74, 0x65, 0x0e, 0x6d, 0x75, 0x73, 0x69, 0x63, 0x61, 0x6c,
+  0x6e, 0x6f, 0x74, 0x65, 0x64, 0x62, 0x6c, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x37, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x41, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x42, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x43, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x36, 0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x36, 0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x31, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x32, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x34, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x34, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x36, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x37, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x41, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x43, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x45, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x46, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x46, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x46, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x37, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x37, 0x46, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x32, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x34, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x34, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x34, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x35, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x35, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x35, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x35, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x35, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x35, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x37, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x38, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x39, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x41, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x41, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x42, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x42, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x42, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x42, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x42, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x42, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x43, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x43, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x43, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x43, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x43, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x44, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x44, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x44, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x44, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x44, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x44, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x44, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x45, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x45, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x45, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x45, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x45, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x45, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x46, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x46, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x46, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x38, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x38, 0x46, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x39, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x30, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x39, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x39, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x34, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x39, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x39, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x38, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x39, 0x43, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x39, 0x43, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x39, 0x44, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x39, 0x44, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x39, 0x44, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x39, 0x45, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x39, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x39, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x30, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x36, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x36, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x37, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x38, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x38, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x38, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x38, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x39, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x39, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x39, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x39, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x39, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x39, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x41, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x41, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x42, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x42, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x42, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x42, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x41, 0x42, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x41, 0x46, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x41, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x31, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x33, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x42, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x42, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x42, 0x35, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x36, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x38, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x36, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x36, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x36, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x37, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x37, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x37, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x37, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x42, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x32,
+  0x43, 0x37, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x45, 0x07,
+  0x75, 0x6e, 0x69, 0x32, 0x43, 0x37, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x30, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x30, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x30, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x30, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x31, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x31, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x35, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x31, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x32, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x32, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x33, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x33, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x33, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x33, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x33, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x44, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x33, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x34, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x34, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x34, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x34, 0x46, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x35, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x32, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x35, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x35, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x36, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x36, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x36, 0x36, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x36, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x38, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x38, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x39, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x38, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x38, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x38, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x39, 0x30, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x39, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x41, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x31, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x41, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x34, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x41, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x37, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x41, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x41, 0x41, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x46, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x43, 0x07,
+  0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x41,
+  0x37, 0x46, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x41, 0x37, 0x46, 0x46, 0x09,
+  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x35, 0x2e, 0x35, 0x09, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x36, 0x2e, 0x35, 0x09, 0x75, 0x6e, 0x69, 0x30,
+  0x32, 0x45, 0x37, 0x2e, 0x35, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x38, 0x2e, 0x35, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x39, 0x2e,
+  0x35, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x35, 0x2e, 0x34, 0x09,
+  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x2e, 0x34, 0x09, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x37, 0x2e, 0x34, 0x09, 0x75, 0x6e, 0x69, 0x30,
+  0x32, 0x45, 0x38, 0x2e, 0x34, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x39, 0x2e, 0x34, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x35, 0x2e,
+  0x33, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x2e, 0x33, 0x09,
+  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x37, 0x2e, 0x33, 0x09, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x38, 0x2e, 0x33, 0x09, 0x75, 0x6e, 0x69, 0x30,
+  0x32, 0x45, 0x39, 0x2e, 0x33, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x35, 0x2e, 0x32, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x36, 0x2e,
+  0x32, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x37, 0x2e, 0x32, 0x09,
+  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x38, 0x2e, 0x32, 0x09, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x45, 0x39, 0x2e, 0x32, 0x09, 0x75, 0x6e, 0x69, 0x30,
+  0x32, 0x45, 0x35, 0x2e, 0x31, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45,
+  0x36, 0x2e, 0x31, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x37, 0x2e,
+  0x31, 0x09, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x38, 0x2e, 0x31, 0x09,
+  0x75, 0x6e, 0x69, 0x30, 0x32, 0x45, 0x39, 0x2e, 0x31, 0x04, 0x73, 0x74,
+  0x65, 0x6d, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x30, 0x30, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x30, 0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x30,
+  0x30, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x30, 0x30, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x30, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x32, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x30, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x30, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x38, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x30, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x30, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x30, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x30, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x30, 0x45, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x30, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x31, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x31, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x31, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x31, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x31, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x31, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x37, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x31, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x31, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x31, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x31, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x31, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x31, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x31, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x32, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x32, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x32, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x32, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x41, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x32, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x32, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x32, 0x44, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x32, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x32, 0x46, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x33, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x33, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x33, 0x34, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x33, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x36, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x33, 0x37, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x33, 0x38, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x39, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x33, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x33, 0x42, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x43, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x33, 0x44, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x33, 0x45, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34, 0x33, 0x46, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x34, 0x34, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x34,
+  0x34, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x36, 0x43, 0x35, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x42, 0x30, 0x30, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x42,
+  0x30, 0x33, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x42, 0x30, 0x34, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x42, 0x30, 0x35, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x42,
+  0x30, 0x36, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x45, 0x32, 0x30, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x45, 0x32, 0x31, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x45,
+  0x32, 0x32, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x45, 0x32, 0x33, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x46, 0x46, 0x39, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x46,
+  0x46, 0x41, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x46, 0x46, 0x42, 0x07, 0x75,
+  0x6e, 0x69, 0x46, 0x46, 0x46, 0x43, 0x07, 0x75, 0x6e, 0x69, 0x46, 0x46,
+  0x46, 0x44, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x30, 0x06, 0x75, 0x31,
+  0x30, 0x33, 0x30, 0x31, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x32, 0x06,
+  0x75, 0x31, 0x30, 0x33, 0x30, 0x33, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30,
+  0x34, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x35, 0x06, 0x75, 0x31, 0x30,
+  0x33, 0x30, 0x36, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x37, 0x06, 0x75,
+  0x31, 0x30, 0x33, 0x30, 0x38, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x39,
+  0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x41, 0x06, 0x75, 0x31, 0x30, 0x33,
+  0x30, 0x42, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x43, 0x06, 0x75, 0x31,
+  0x30, 0x33, 0x30, 0x44, 0x06, 0x75, 0x31, 0x30, 0x33, 0x30, 0x45, 0x06,
+  0x75, 0x31, 0x30, 0x33, 0x30, 0x46, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31,
+  0x30, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x31, 0x06, 0x75, 0x31, 0x30,
+  0x33, 0x31, 0x32, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x33, 0x06, 0x75,
+  0x31, 0x30, 0x33, 0x31, 0x34, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x35,
+  0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x36, 0x06, 0x75, 0x31, 0x30, 0x33,
+  0x31, 0x37, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x38, 0x06, 0x75, 0x31,
+  0x30, 0x33, 0x31, 0x39, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x41, 0x06,
+  0x75, 0x31, 0x30, 0x33, 0x31, 0x42, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31,
+  0x43, 0x06, 0x75, 0x31, 0x30, 0x33, 0x31, 0x44, 0x06, 0x75, 0x31, 0x30,
+  0x33, 0x31, 0x45, 0x06, 0x75, 0x31, 0x30, 0x33, 0x32, 0x30, 0x06, 0x75,
+  0x31, 0x30, 0x33, 0x32, 0x31, 0x06, 0x75, 0x31, 0x30, 0x33, 0x32, 0x32,
+  0x06, 0x75, 0x31, 0x30, 0x33, 0x32, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x30, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x31, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x30, 0x32, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x33, 0x06,
+  0x75, 0x31, 0x44, 0x33, 0x30, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30,
+  0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x36, 0x06, 0x75, 0x31, 0x44,
+  0x33, 0x30, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x38, 0x06, 0x75,
+  0x31, 0x44, 0x33, 0x30, 0x39, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x41,
+  0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x42, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x30, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x44, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x30, 0x45, 0x06, 0x75, 0x31, 0x44, 0x33, 0x30, 0x46, 0x06,
+  0x75, 0x31, 0x44, 0x33, 0x31, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31,
+  0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x32, 0x06, 0x75, 0x31, 0x44,
+  0x33, 0x31, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x34, 0x06, 0x75,
+  0x31, 0x44, 0x33, 0x31, 0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x36,
+  0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x31, 0x38, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x39, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x31, 0x41, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x42, 0x06,
+  0x75, 0x31, 0x44, 0x33, 0x31, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31,
+  0x44, 0x06, 0x75, 0x31, 0x44, 0x33, 0x31, 0x45, 0x06, 0x75, 0x31, 0x44,
+  0x33, 0x31, 0x46, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x30, 0x06, 0x75,
+  0x31, 0x44, 0x33, 0x32, 0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x32,
+  0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x32, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x35, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x32, 0x36, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x37, 0x06,
+  0x75, 0x31, 0x44, 0x33, 0x32, 0x38, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32,
+  0x39, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x41, 0x06, 0x75, 0x31, 0x44,
+  0x33, 0x32, 0x42, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x43, 0x06, 0x75,
+  0x31, 0x44, 0x33, 0x32, 0x44, 0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x45,
+  0x06, 0x75, 0x31, 0x44, 0x33, 0x32, 0x46, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x33, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x31, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x33, 0x32, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x33, 0x06,
+  0x75, 0x31, 0x44, 0x33, 0x33, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33,
+  0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x36, 0x06, 0x75, 0x31, 0x44,
+  0x33, 0x33, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x38, 0x06, 0x75,
+  0x31, 0x44, 0x33, 0x33, 0x39, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x41,
+  0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x42, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x33, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x44, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x33, 0x45, 0x06, 0x75, 0x31, 0x44, 0x33, 0x33, 0x46, 0x06,
+  0x75, 0x31, 0x44, 0x33, 0x34, 0x30, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34,
+  0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x32, 0x06, 0x75, 0x31, 0x44,
+  0x33, 0x34, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x34, 0x06, 0x75,
+  0x31, 0x44, 0x33, 0x34, 0x35, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x36,
+  0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x37, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x34, 0x38, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x39, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x34, 0x41, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x42, 0x06,
+  0x75, 0x31, 0x44, 0x33, 0x34, 0x43, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34,
+  0x44, 0x06, 0x75, 0x31, 0x44, 0x33, 0x34, 0x45, 0x06, 0x75, 0x31, 0x44,
+  0x33, 0x34, 0x46, 0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x30, 0x06, 0x75,
+  0x31, 0x44, 0x33, 0x35, 0x31, 0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x32,
+  0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x33, 0x06, 0x75, 0x31, 0x44, 0x33,
+  0x35, 0x34, 0x06, 0x75, 0x31, 0x44, 0x33, 0x35, 0x35, 0x06, 0x75, 0x31,
+  0x44, 0x33, 0x35, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33, 0x38, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x33, 0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33,
+  0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33, 0x43, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x33, 0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x33, 0x45, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x34, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x31,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x34, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x34, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x34, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x41, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x34, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34,
+  0x43, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x44, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x34, 0x45, 0x06, 0x75, 0x31, 0x44, 0x35, 0x34, 0x46, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x35, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x32,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x35, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x35, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x35, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x37, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x35, 0x38, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35,
+  0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x41, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x35, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x43, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x35, 0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x45,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x35, 0x46, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x36, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x31, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x36, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x33, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x36, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36,
+  0x35, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x36, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x36, 0x37, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x38, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x36, 0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x41,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x36, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x41, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x31, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x41, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x33, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x41, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41,
+  0x35, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x36, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x41, 0x37, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x38, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x41, 0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x41,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x41, 0x43, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x44, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x41, 0x45, 0x06, 0x75, 0x31, 0x44, 0x35, 0x41, 0x46, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x42, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42,
+  0x31, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x32, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x42, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x34, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x42, 0x35, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x36,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x37, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x42, 0x38, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x39, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x42, 0x41, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x42, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x42, 0x43, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42,
+  0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x42, 0x45, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x42, 0x46, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x30, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x43, 0x31, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x32,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x33, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x43, 0x34, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x35, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x43, 0x36, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x37, 0x06,
+  0x75, 0x31, 0x44, 0x35, 0x43, 0x38, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43,
+  0x39, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x41, 0x06, 0x75, 0x31, 0x44,
+  0x35, 0x43, 0x42, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x43, 0x06, 0x75,
+  0x31, 0x44, 0x35, 0x43, 0x44, 0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x45,
+  0x06, 0x75, 0x31, 0x44, 0x35, 0x43, 0x46, 0x06, 0x75, 0x31, 0x44, 0x35,
+  0x44, 0x30, 0x06, 0x75, 0x31, 0x44, 0x35, 0x44, 0x31, 0x06, 0x75, 0x31,
+  0x44, 0x35, 0x44, 0x32, 0x06, 0x75, 0x31, 0x44, 0x35, 0x44, 0x33, 0x06,
+  0x75, 0x31, 0x44, 0x37, 0x44, 0x38, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44,
+  0x39, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x41, 0x06, 0x75, 0x31, 0x44,
+  0x37, 0x44, 0x42, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x43, 0x06, 0x75,
+  0x31, 0x44, 0x37, 0x44, 0x44, 0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x45,
+  0x06, 0x75, 0x31, 0x44, 0x37, 0x44, 0x46, 0x06, 0x75, 0x31, 0x44, 0x37,
+  0x45, 0x30, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x31, 0x06, 0x75, 0x31,
+  0x44, 0x37, 0x45, 0x32, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x33, 0x06,
+  0x75, 0x31, 0x44, 0x37, 0x45, 0x34, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45,
+  0x35, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x36, 0x06, 0x75, 0x31, 0x44,
+  0x37, 0x45, 0x37, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x38, 0x06, 0x75,
+  0x31, 0x44, 0x37, 0x45, 0x39, 0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x41,
+  0x06, 0x75, 0x31, 0x44, 0x37, 0x45, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x33, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x31, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x33, 0x32, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x33, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x33, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33,
+  0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x36, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x33, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x38, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x33, 0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x41,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x33, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x44, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x33, 0x45, 0x06, 0x75, 0x31, 0x46, 0x30, 0x33, 0x46, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x34, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34,
+  0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x32, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x34, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x34, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x34, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x36,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x34, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x39, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x34, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x42, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x34, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34,
+  0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x34, 0x45, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x34, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x30, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x35, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x32,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x35, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x35, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x35, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x37, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x35, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35,
+  0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x41, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x35, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x43, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x35, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x45,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x35, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x36, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x31, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x36, 0x32, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x33, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x36, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36,
+  0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x36, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x36, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x38, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x36, 0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x41,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x36, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x44, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x36, 0x45, 0x06, 0x75, 0x31, 0x46, 0x30, 0x36, 0x46, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x37, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37,
+  0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x32, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x37, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x34, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x37, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x36,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x37, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x39, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x37, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x42, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x37, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37,
+  0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x37, 0x45, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x37, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x30, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x38, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x32,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x38, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x35, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x38, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x37, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x38, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38,
+  0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x41, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x38, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x43, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x38, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x45,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x38, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x39, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x39, 0x31, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x39, 0x32, 0x06, 0x75, 0x31, 0x46, 0x30, 0x39, 0x33, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x41, 0x30, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41,
+  0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x32, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x41, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x34, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x41, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x36,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x37, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x41, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x39, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x41, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x42, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x41, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41,
+  0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x41, 0x45, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x42, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x32, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x42, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x34,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x42, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x37, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x42, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x39, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x42, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42,
+  0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x43, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x42, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x42, 0x45, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x43, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x32,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x43, 0x34, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x35, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x43, 0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x37, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x43, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43,
+  0x39, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x41, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x43, 0x42, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x43, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x43, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x45,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x43, 0x46, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x44, 0x31, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x32, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x44, 0x33, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x34, 0x06,
+  0x75, 0x31, 0x46, 0x30, 0x44, 0x35, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44,
+  0x36, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x37, 0x06, 0x75, 0x31, 0x46,
+  0x30, 0x44, 0x38, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x39, 0x06, 0x75,
+  0x31, 0x46, 0x30, 0x44, 0x41, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x42,
+  0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x43, 0x06, 0x75, 0x31, 0x46, 0x30,
+  0x44, 0x44, 0x06, 0x75, 0x31, 0x46, 0x30, 0x44, 0x45, 0x06, 0x75, 0x31,
+  0x46, 0x30, 0x44, 0x46, 0x06, 0x75, 0x31, 0x46, 0x34, 0x32, 0x44, 0x06,
+  0x75, 0x31, 0x46, 0x34, 0x32, 0x45, 0x06, 0x75, 0x31, 0x46, 0x34, 0x33,
+  0x31, 0x06, 0x75, 0x31, 0x46, 0x34, 0x33, 0x35, 0x06, 0x75, 0x31, 0x46,
+  0x36, 0x30, 0x30, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x31, 0x06, 0x75,
+  0x31, 0x46, 0x36, 0x30, 0x32, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x33,
+  0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x34, 0x06, 0x75, 0x31, 0x46, 0x36,
+  0x30, 0x35, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x36, 0x06, 0x75, 0x31,
+  0x46, 0x36, 0x30, 0x37, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x38, 0x06,
+  0x75, 0x31, 0x46, 0x36, 0x30, 0x39, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30,
+  0x41, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x42, 0x06, 0x75, 0x31, 0x46,
+  0x36, 0x30, 0x43, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x44, 0x06, 0x75,
+  0x31, 0x46, 0x36, 0x30, 0x45, 0x06, 0x75, 0x31, 0x46, 0x36, 0x30, 0x46,
+  0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x30, 0x06, 0x75, 0x31, 0x46, 0x36,
+  0x31, 0x31, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x32, 0x06, 0x75, 0x31,
+  0x46, 0x36, 0x31, 0x33, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x34, 0x06,
+  0x75, 0x31, 0x46, 0x36, 0x31, 0x35, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31,
+  0x36, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x37, 0x06, 0x75, 0x31, 0x46,
+  0x36, 0x31, 0x38, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x39, 0x06, 0x75,
+  0x31, 0x46, 0x36, 0x31, 0x41, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x42,
+  0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x43, 0x06, 0x75, 0x31, 0x46, 0x36,
+  0x31, 0x44, 0x06, 0x75, 0x31, 0x46, 0x36, 0x31, 0x45, 0x06, 0x75, 0x31,
+  0x46, 0x36, 0x31, 0x46, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x30, 0x06,
+  0x75, 0x31, 0x46, 0x36, 0x32, 0x31, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32,
+  0x32, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x33, 0x06, 0x75, 0x31, 0x46,
+  0x36, 0x32, 0x35, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x36, 0x06, 0x75,
+  0x31, 0x46, 0x36, 0x32, 0x37, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x38,
+  0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x39, 0x06, 0x75, 0x31, 0x46, 0x36,
+  0x32, 0x41, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x42, 0x06, 0x75, 0x31,
+  0x46, 0x36, 0x32, 0x44, 0x06, 0x75, 0x31, 0x46, 0x36, 0x32, 0x45, 0x06,
+  0x75, 0x31, 0x46, 0x36, 0x32, 0x46, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33,
+  0x30, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x31, 0x06, 0x75, 0x31, 0x46,
+  0x36, 0x33, 0x32, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x33, 0x06, 0x75,
+  0x31, 0x46, 0x36, 0x33, 0x34, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x35,
+  0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x36, 0x06, 0x75, 0x31, 0x46, 0x36,
+  0x33, 0x37, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x38, 0x06, 0x75, 0x31,
+  0x46, 0x36, 0x33, 0x39, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x41, 0x06,
+  0x75, 0x31, 0x46, 0x36, 0x33, 0x42, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33,
+  0x43, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x44, 0x06, 0x75, 0x31, 0x46,
+  0x36, 0x33, 0x45, 0x06, 0x75, 0x31, 0x46, 0x36, 0x33, 0x46, 0x06, 0x75,
+  0x31, 0x46, 0x36, 0x34, 0x30, 0x09, 0x64, 0x6c, 0x4c, 0x74, 0x63, 0x61,
+  0x72, 0x6f, 0x6e, 0x08, 0x44, 0x69, 0x65, 0x72, 0x65, 0x73, 0x69, 0x73,
+  0x05, 0x41, 0x63, 0x75, 0x74, 0x65, 0x05, 0x54, 0x69, 0x6c, 0x64, 0x65,
+  0x05, 0x47, 0x72, 0x61, 0x76, 0x65, 0x0a, 0x43, 0x69, 0x72, 0x63, 0x75,
+  0x6d, 0x66, 0x6c, 0x65, 0x78, 0x05, 0x43, 0x61, 0x72, 0x6f, 0x6e, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x33, 0x31, 0x31, 0x2e, 0x63, 0x61, 0x73, 0x65,
+  0x05, 0x42, 0x72, 0x65, 0x76, 0x65, 0x09, 0x44, 0x6f, 0x74, 0x61, 0x63,
+  0x63, 0x65, 0x6e, 0x74, 0x0c, 0x48, 0x75, 0x6e, 0x67, 0x61, 0x72, 0x75,
+  0x6d, 0x6c, 0x61, 0x75, 0x74, 0x0b, 0x44, 0x6f, 0x75, 0x62, 0x6c, 0x65,
+  0x67, 0x72, 0x61, 0x76, 0x65, 0x0a, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63,
+  0x5f, 0x64, 0x6f, 0x74, 0x0c, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63, 0x5f,
+  0x32, 0x64, 0x6f, 0x74, 0x73, 0x0c, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63,
+  0x5f, 0x33, 0x64, 0x6f, 0x74, 0x73, 0x0e, 0x61, 0x72, 0x61, 0x62, 0x69,
+  0x63, 0x5f, 0x33, 0x64, 0x6f, 0x74, 0x73, 0x5f, 0x61, 0x0e, 0x61, 0x72,
+  0x61, 0x62, 0x69, 0x63, 0x5f, 0x32, 0x64, 0x6f, 0x74, 0x73, 0x5f, 0x61,
+  0x0c, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63, 0x5f, 0x34, 0x64, 0x6f, 0x74,
+  0x73, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x36, 0x45, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x36, 0x45, 0x2e, 0x69,
+  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x36, 0x45, 0x2e,
+  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x31,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
+  0x31, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x41, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x36, 0x46, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x36, 0x46, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x36, 0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x42, 0x41, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x41, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0b, 0x61, 0x72, 0x61, 0x62, 0x69, 0x63, 0x5f, 0x72, 0x69, 0x6e, 0x67,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x43, 0x2e, 0x66, 0x69, 0x6e,
+  0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x43, 0x2e, 0x69, 0x6e,
+  0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x43, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x44, 0x2e,
+  0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37, 0x44,
+  0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x37,
+  0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x38, 0x31, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x38, 0x31, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x38, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x38, 0x32, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x38, 0x32, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x32, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x35, 0x2e, 0x66, 0x69, 0x6e,
+  0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x35, 0x2e, 0x69, 0x6e,
+  0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x35, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x46, 0x2e,
+  0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x46,
+  0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42,
+  0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0e, 0x61, 0x72, 0x61, 0x62, 0x69,
+  0x63, 0x5f, 0x67, 0x61, 0x66, 0x5f, 0x62, 0x61, 0x72, 0x07, 0x45, 0x6e,
+  0x67, 0x2e, 0x61, 0x6c, 0x74, 0x0f, 0x75, 0x6e, 0x69, 0x30, 0x32, 0x36,
+  0x38, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73, 0x0f, 0x75, 0x6e,
+  0x69, 0x30, 0x32, 0x39, 0x44, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73,
+  0x73, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
+  0x34, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x30, 0x33, 0x30,
+  0x38, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x37, 0x30, 0x33, 0x30,
+  0x34, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
+  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
+  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x30, 0x33, 0x30,
+  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x34, 0x30, 0x33, 0x30,
+  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x33, 0x30, 0x33, 0x30,
+  0x34, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x38, 0x30, 0x33, 0x30,
+  0x43, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x33, 0x30, 0x33, 0x30,
+  0x38, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x43, 0x30, 0x33, 0x30,
+  0x37, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x33, 0x30, 0x33, 0x30,
+  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
+  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
+  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
+  0x33, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
+  0x33, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
+  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
+  0x30, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x36, 0x30, 0x33, 0x30,
+  0x39, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x32, 0x30, 0x33, 0x30,
+  0x39, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x33, 0x30, 0x31, 0x30, 0x33, 0x30,
+  0x37, 0x0a, 0x62, 0x72, 0x61, 0x69, 0x6c, 0x6c, 0x65, 0x64, 0x6f, 0x74,
+  0x05, 0x4a, 0x2e, 0x61, 0x6c, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x39, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x16, 0x75, 0x6e, 0x69, 0x46,
+  0x45, 0x41, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x2e, 0x6c, 0x6f, 0x6e,
+  0x67, 0x73, 0x74, 0x61, 0x72, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x42, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x42, 0x35, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x42, 0x35, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x43, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x43, 0x45, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x43, 0x45, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x32, 0x2e, 0x66, 0x69, 0x6e,
+  0x61, 0x05, 0x6c, 0x2e, 0x61, 0x6c, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x44, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x11, 0x75, 0x6e, 0x69,
+  0x30, 0x34, 0x37, 0x38, 0x2e, 0x6d, 0x6f, 0x6e, 0x6f, 0x67, 0x72, 0x61,
+  0x70, 0x68, 0x11, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37, 0x39, 0x2e, 0x6d,
+  0x6f, 0x6e, 0x6f, 0x67, 0x72, 0x61, 0x70, 0x68, 0x0f, 0x69, 0x6f, 0x67,
+  0x6f, 0x6e, 0x65, 0x6b, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73,
+  0x0f, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x38, 0x2e, 0x64, 0x6f, 0x74,
+  0x6c, 0x65, 0x73, 0x73, 0x0f, 0x75, 0x6e, 0x69, 0x32, 0x31, 0x34, 0x39,
+  0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73, 0x0f, 0x75, 0x6e, 0x69,
+  0x31, 0x45, 0x32, 0x44, 0x2e, 0x64, 0x6f, 0x74, 0x6c, 0x65, 0x73, 0x73,
+  0x0f, 0x75, 0x6e, 0x69, 0x31, 0x45, 0x43, 0x42, 0x2e, 0x64, 0x6f, 0x74,
+  0x6c, 0x65, 0x73, 0x73, 0x03, 0x64, 0x63, 0x6f, 0x05, 0x49, 0x2e, 0x61,
+  0x6c, 0x74, 0x0a, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x2e, 0x62, 0x61, 0x73,
+  0x65, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
+  0x42, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
+  0x43, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x34, 0x42, 0x30, 0x36, 0x35,
+  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
+  0x45, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x31, 0x30, 0x36, 0x34,
+  0x46, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x34, 0x45, 0x30, 0x36, 0x35,
+  0x31, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x34, 0x30, 0x36, 0x34,
+  0x45, 0x0b, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x35, 0x34, 0x30, 0x36, 0x34,
+  0x46, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x41, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x41, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x41, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x42,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43,
+  0x42, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x43, 0x42, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x37, 0x43, 0x43, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x37, 0x43, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x37, 0x43, 0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x37, 0x43, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x44, 0x2e, 0x69, 0x6e, 0x69,
+  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x45, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x45, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x45, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43, 0x46,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x43,
+  0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x43, 0x46, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x37, 0x44, 0x30, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x37, 0x44, 0x30, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x37, 0x44, 0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x37, 0x44, 0x31, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x31, 0x2e, 0x69, 0x6e, 0x69,
+  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x32, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x32, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x32, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x33,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
+  0x33, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x44, 0x33, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x37, 0x44, 0x34, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x37, 0x44, 0x34, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x37, 0x44, 0x34, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x37, 0x44, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x35, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x35, 0x2e, 0x69, 0x6e, 0x69,
+  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x36, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x36, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x36, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x37,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
+  0x37, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x44, 0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x37, 0x44, 0x38, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x37, 0x44, 0x38, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x37, 0x44, 0x38, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x37, 0x44, 0x39, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x39, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x39, 0x2e, 0x69, 0x6e, 0x69,
+  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x41, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x41, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x41, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x42,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
+  0x42, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x44, 0x42, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x37, 0x44, 0x43, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x37, 0x44, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x37, 0x44, 0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x37, 0x44, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x44, 0x2e, 0x69, 0x6e, 0x69,
+  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x45, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x45, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x45, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44, 0x46,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x44,
+  0x46, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x44, 0x46, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x37, 0x45, 0x30, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x37, 0x45, 0x30, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x37, 0x45, 0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x37, 0x45, 0x31, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x31, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x31, 0x2e, 0x69, 0x6e, 0x69,
+  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x32, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x32, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x32, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x33,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45,
+  0x33, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x45, 0x33, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x37, 0x45, 0x34, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x37, 0x45, 0x34, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x37, 0x45, 0x34, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x37, 0x45, 0x35, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x35, 0x2e, 0x6d, 0x65, 0x64, 0x69,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x35, 0x2e, 0x69, 0x6e, 0x69,
+  0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x36, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x36, 0x2e, 0x6d,
+  0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x36, 0x2e,
+  0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45, 0x37,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37, 0x45,
+  0x37, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x37,
+  0x45, 0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x09, 0x52, 0x69, 0x6e, 0x67,
+  0x61, 0x62, 0x6f, 0x76, 0x65, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x30, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x31, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x32, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x33, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x34, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x35, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x36, 0x2e, 0x61, 0x6c, 0x74, 0x0b, 0x75, 0x6e, 0x69, 0x32, 0x36, 0x33,
+  0x37, 0x2e, 0x61, 0x6c, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x37,
+  0x45, 0x2e, 0x64, 0x69, 0x61, 0x63, 0x11, 0x75, 0x6e, 0x69, 0x30, 0x34,
+  0x38, 0x41, 0x2e, 0x62, 0x72, 0x65, 0x76, 0x65, 0x6c, 0x65, 0x73, 0x73,
+  0x11, 0x75, 0x6e, 0x69, 0x30, 0x34, 0x38, 0x42, 0x2e, 0x62, 0x72, 0x65,
+  0x76, 0x65, 0x6c, 0x65, 0x73, 0x73, 0x05, 0x79, 0x2e, 0x61, 0x6c, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x39, 0x2e, 0x66, 0x69, 0x6e,
+  0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x41, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x42, 0x2e, 0x66,
+  0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x38, 0x46, 0x2e,
+  0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x30,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39,
+  0x33, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x39, 0x34, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x39, 0x36, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x39, 0x37, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x39, 0x39, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x39, 0x41, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x41, 0x2e, 0x69, 0x6e, 0x69, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x41, 0x2e, 0x6d, 0x65, 0x64,
+  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x42, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x42, 0x2e, 0x69,
+  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x42, 0x2e,
+  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x43,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39,
+  0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x39, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x39, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x39, 0x44, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x39, 0x44, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x39, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x45, 0x2e, 0x69, 0x6e, 0x69, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x45, 0x2e, 0x6d, 0x65, 0x64,
+  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x46, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x46, 0x2e, 0x69,
+  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x39, 0x46, 0x2e,
+  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x30,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
+  0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x41, 0x30, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x41, 0x32, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x41, 0x32, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x41, 0x32, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x41, 0x33, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x33, 0x2e, 0x69, 0x6e, 0x69, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x33, 0x2e, 0x6d, 0x65, 0x64,
+  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x35, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x35, 0x2e, 0x69,
+  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x35, 0x2e,
+  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x37,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
+  0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x41, 0x37, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x41, 0x38, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x41, 0x38, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x41, 0x38, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x41, 0x41, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x41, 0x2e, 0x69, 0x6e, 0x69, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x41, 0x2e, 0x6d, 0x65, 0x64,
+  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x42, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x42, 0x2e, 0x69,
+  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x42, 0x2e,
+  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41, 0x43,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x41,
+  0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x41, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x41, 0x45, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x41, 0x45, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x41, 0x45, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x42, 0x30, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x30, 0x2e, 0x69, 0x6e, 0x69, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x30, 0x2e, 0x6d, 0x65, 0x64,
+  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x32, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x32, 0x2e, 0x69,
+  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x32, 0x2e,
+  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x34,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42,
+  0x34, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x42, 0x34, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x42, 0x36, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x42, 0x36, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x42, 0x36, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x42, 0x37, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x37, 0x2e, 0x69, 0x6e, 0x69, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x37, 0x2e, 0x6d, 0x65, 0x64,
+  0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x38, 0x2e, 0x66, 0x69,
+  0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x38, 0x2e, 0x69,
+  0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x38, 0x2e,
+  0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x39,
+  0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42,
+  0x39, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36,
+  0x42, 0x39, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75, 0x6e, 0x69, 0x30,
+  0x36, 0x42, 0x43, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c, 0x75, 0x6e, 0x69,
+  0x30, 0x36, 0x42, 0x43, 0x2e, 0x69, 0x6e, 0x69, 0x74, 0x0c, 0x75, 0x6e,
+  0x69, 0x30, 0x36, 0x42, 0x43, 0x2e, 0x6d, 0x65, 0x64, 0x69, 0x0c, 0x75,
+  0x6e, 0x69, 0x30, 0x36, 0x42, 0x44, 0x2e, 0x66, 0x69, 0x6e, 0x61, 0x0c,
+  0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x44, 0x2e, 0x69, 0x6e, 0x69, 0x74,
+  0x0c, 0x75, 0x6e, 0x69, 0x30, 0x36, 0x42, 0x44, 0x2e, 0x6d, 0x65, 0x64,
+  0x69, 0x00, 0x00, 0x00, 0xb8, 0x02, 0x80, 0x40, 0xff, 0xfb, 0xfe, 0x03,
+  0xfa, 0x14, 0x03, 0xf9, 0x25, 0x03, 0xf8, 0x32, 0x03, 0xf7, 0x96, 0x03,
+  0xf6, 0x0e, 0x03, 0xf5, 0xfe, 0x03, 0xf4, 0xfe, 0x03, 0xf3, 0x25, 0x03,
+  0xf2, 0x0e, 0x03, 0xf1, 0x96, 0x03, 0xf0, 0x25, 0x03, 0xef, 0x8a, 0x41,
+  0x05, 0xef, 0xfe, 0x03, 0xee, 0x96, 0x03, 0xed, 0x96, 0x03, 0xec, 0xfa,
+  0x03, 0xeb, 0xfa, 0x03, 0xea, 0xfe, 0x03, 0xe9, 0x3a, 0x03, 0xe8, 0x42,
+  0x03, 0xe7, 0xfe, 0x03, 0xe6, 0x32, 0x03, 0xe5, 0xe4, 0x53, 0x05, 0xe5,
+  0x96, 0x03, 0xe4, 0x8a, 0x41, 0x05, 0xe4, 0x53, 0x03, 0xe3, 0xe2, 0x2f,
+  0x05, 0xe3, 0xfa, 0x03, 0xe2, 0x2f, 0x03, 0xe1, 0xfe, 0x03, 0xe0, 0xfe,
+  0x03, 0xdf, 0x32, 0x03, 0xde, 0x14, 0x03, 0xdd, 0x96, 0x03, 0xdc, 0xfe,
+  0x03, 0xdb, 0x12, 0x03, 0xda, 0x7d, 0x03, 0xd9, 0xbb, 0x03, 0xd8, 0xfe,
+  0x03, 0xd6, 0x8a, 0x41, 0x05, 0xd6, 0x7d, 0x03, 0xd5, 0xd4, 0x47, 0x05,
+  0xd5, 0x7d, 0x03, 0xd4, 0x47, 0x03, 0xd3, 0xd2, 0x1b, 0x05, 0xd3, 0xfe,
+  0x03, 0xd2, 0x1b, 0x03, 0xd1, 0xfe, 0x03, 0xd0, 0xfe, 0x03, 0xcf, 0xfe,
+  0x03, 0xce, 0xfe, 0x03, 0xcd, 0x96, 0x03, 0xcc, 0xcb, 0x1e, 0x05, 0xcc,
+  0xfe, 0x03, 0xcb, 0x1e, 0x03, 0xca, 0x32, 0x03, 0xc9, 0xfe, 0x03, 0xc6,
+  0x85, 0x11, 0x05, 0xc6, 0x1c, 0x03, 0xc5, 0x16, 0x03, 0xc4, 0xfe, 0x03,
+  0xc3, 0xfe, 0x03, 0xc2, 0xfe, 0x03, 0xc1, 0xfe, 0x03, 0xc0, 0xfe, 0x03,
+  0xbf, 0xfe, 0x03, 0xbe, 0xfe, 0x03, 0xbd, 0xfe, 0x03, 0xbc, 0xfe, 0x03,
+  0xbb, 0xfe, 0x03, 0xba, 0x11, 0x03, 0xb9, 0x86, 0x25, 0x05, 0xb9, 0xfe,
+  0x03, 0xb8, 0xb7, 0xbb, 0x05, 0xb8, 0xfe, 0x03, 0xb7, 0xb6, 0x5d, 0x05,
+  0xb7, 0xbb, 0x03, 0xb7, 0x80, 0x04, 0xb6, 0xb5, 0x25, 0x05, 0xb6, 0x5d,
+  0x40, 0xff, 0x03, 0xb6, 0x40, 0x04, 0xb5, 0x25, 0x03, 0xb4, 0xfe, 0x03,
+  0xb3, 0x96, 0x03, 0xb2, 0xfe, 0x03, 0xb1, 0xfe, 0x03, 0xb0, 0xfe, 0x03,
+  0xaf, 0xfe, 0x03, 0xae, 0x64, 0x03, 0xad, 0x0e, 0x03, 0xac, 0xab, 0x25,
+  0x05, 0xac, 0x64, 0x03, 0xab, 0xaa, 0x12, 0x05, 0xab, 0x25, 0x03, 0xaa,
+  0x12, 0x03, 0xa9, 0x8a, 0x41, 0x05, 0xa9, 0xfa, 0x03, 0xa8, 0xfe, 0x03,
+  0xa7, 0xfe, 0x03, 0xa6, 0xfe, 0x03, 0xa5, 0x12, 0x03, 0xa4, 0xfe, 0x03,
+  0xa3, 0xa2, 0x0e, 0x05, 0xa3, 0x32, 0x03, 0xa2, 0x0e, 0x03, 0xa1, 0x64,
+  0x03, 0xa0, 0x8a, 0x41, 0x05, 0xa0, 0x96, 0x03, 0x9f, 0xfe, 0x03, 0x9e,
+  0x9d, 0x0c, 0x05, 0x9e, 0xfe, 0x03, 0x9d, 0x0c, 0x03, 0x9c, 0x9b, 0x19,
+  0x05, 0x9c, 0x64, 0x03, 0x9b, 0x9a, 0x10, 0x05, 0x9b, 0x19, 0x03, 0x9a,
+  0x10, 0x03, 0x99, 0x0a, 0x03, 0x98, 0xfe, 0x03, 0x97, 0x96, 0x0d, 0x05,
+  0x97, 0xfe, 0x03, 0x96, 0x0d, 0x03, 0x95, 0x8a, 0x41, 0x05, 0x95, 0x96,
+  0x03, 0x94, 0x93, 0x0e, 0x05, 0x94, 0x28, 0x03, 0x93, 0x0e, 0x03, 0x92,
+  0xfa, 0x03, 0x91, 0x90, 0xbb, 0x05, 0x91, 0xfe, 0x03, 0x90, 0x8f, 0x5d,
+  0x05, 0x90, 0xbb, 0x03, 0x90, 0x80, 0x04, 0x8f, 0x8e, 0x25, 0x05, 0x8f,
+  0x5d, 0x03, 0x8f, 0x40, 0x04, 0x8e, 0x25, 0x03, 0x8d, 0xfe, 0x03, 0x8c,
+  0x8b, 0x2e, 0x05, 0x8c, 0xfe, 0x03, 0x8b, 0x2e, 0x03, 0x8a, 0x86, 0x25,
+  0x05, 0x8a, 0x41, 0x03, 0x89, 0x88, 0x0b, 0x05, 0x89, 0x14, 0x03, 0x88,
+  0x0b, 0x03, 0x87, 0x86, 0x25, 0x05, 0x87, 0x64, 0x03, 0x86, 0x85, 0x11,
+  0x05, 0x86, 0x25, 0x03, 0x85, 0x11, 0x03, 0x84, 0xfe, 0x03, 0x83, 0x82,
+  0x11, 0x05, 0x83, 0xfe, 0x03, 0x82, 0x11, 0x03, 0x81, 0xfe, 0x03, 0x80,
+  0xfe, 0x03, 0x7f, 0xfe, 0x03, 0x40, 0xff, 0x7e, 0x7d, 0x7d, 0x05, 0x7e,
+  0xfe, 0x03, 0x7d, 0x7d, 0x03, 0x7c, 0x64, 0x03, 0x7b, 0x54, 0x15, 0x05,
+  0x7b, 0x25, 0x03, 0x7a, 0xfe, 0x03, 0x79, 0xfe, 0x03, 0x78, 0x0e, 0x03,
+  0x77, 0x0c, 0x03, 0x76, 0x0a, 0x03, 0x75, 0xfe, 0x03, 0x74, 0xfa, 0x03,
+  0x73, 0xfa, 0x03, 0x72, 0xfa, 0x03, 0x71, 0xfa, 0x03, 0x70, 0xfe, 0x03,
+  0x6f, 0xfe, 0x03, 0x6e, 0xfe, 0x03, 0x6c, 0x21, 0x03, 0x6b, 0xfe, 0x03,
+  0x6a, 0x11, 0x42, 0x05, 0x6a, 0x53, 0x03, 0x69, 0xfe, 0x03, 0x68, 0x7d,
+  0x03, 0x67, 0x11, 0x42, 0x05, 0x66, 0xfe, 0x03, 0x65, 0xfe, 0x03, 0x64,
+  0xfe, 0x03, 0x63, 0xfe, 0x03, 0x62, 0xfe, 0x03, 0x61, 0x3a, 0x03, 0x60,
+  0xfa, 0x03, 0x5e, 0x0c, 0x03, 0x5d, 0xfe, 0x03, 0x5b, 0xfe, 0x03, 0x5a,
+  0xfe, 0x03, 0x59, 0x58, 0x0a, 0x05, 0x59, 0xfa, 0x03, 0x58, 0x0a, 0x03,
+  0x57, 0x16, 0x19, 0x05, 0x57, 0x32, 0x03, 0x56, 0xfe, 0x03, 0x55, 0x54,
+  0x15, 0x05, 0x55, 0x42, 0x03, 0x54, 0x15, 0x03, 0x53, 0x01, 0x10, 0x05,
+  0x53, 0x18, 0x03, 0x52, 0x14, 0x03, 0x51, 0x4a, 0x13, 0x05, 0x51, 0xfe,
+  0x03, 0x50, 0x0b, 0x03, 0x4f, 0xfe, 0x03, 0x4e, 0x4d, 0x10, 0x05, 0x4e,
+  0xfe, 0x03, 0x4d, 0x10, 0x03, 0x4c, 0xfe, 0x03, 0x4b, 0x4a, 0x13, 0x05,
+  0x4b, 0xfe, 0x03, 0x4a, 0x49, 0x10, 0x05, 0x4a, 0x13, 0x03, 0x49, 0x1d,
+  0x0d, 0x05, 0x49, 0x10, 0x03, 0x48, 0x0d, 0x03, 0x47, 0xfe, 0x03, 0x46,
+  0x96, 0x03, 0x45, 0x96, 0x03, 0x44, 0xfe, 0x03, 0x43, 0x02, 0x2d, 0x05,
+  0x43, 0xfa, 0x03, 0x42, 0xbb, 0x03, 0x41, 0x4b, 0x03, 0x40, 0xfe, 0x03,
+  0x3f, 0xfe, 0x03, 0x3e, 0x3d, 0x12, 0x05, 0x3e, 0x14, 0x03, 0x3d, 0x3c,
+  0x0f, 0x05, 0x3d, 0x12, 0x03, 0x3c, 0x3b, 0x0d, 0x05, 0x3c, 0x40, 0xff,
+  0x0f, 0x03, 0x3b, 0x0d, 0x03, 0x3a, 0xfe, 0x03, 0x39, 0xfe, 0x03, 0x38,
+  0x37, 0x14, 0x05, 0x38, 0xfa, 0x03, 0x37, 0x36, 0x10, 0x05, 0x37, 0x14,
+  0x03, 0x36, 0x35, 0x0b, 0x05, 0x36, 0x10, 0x03, 0x35, 0x0b, 0x03, 0x34,
+  0x1e, 0x03, 0x33, 0x0d, 0x03, 0x32, 0x31, 0x0b, 0x05, 0x32, 0xfe, 0x03,
+  0x31, 0x0b, 0x03, 0x30, 0x2f, 0x0b, 0x05, 0x30, 0x0d, 0x03, 0x2f, 0x0b,
+  0x03, 0x2e, 0x2d, 0x09, 0x05, 0x2e, 0x10, 0x03, 0x2d, 0x09, 0x03, 0x2c,
+  0x32, 0x03, 0x2b, 0x2a, 0x25, 0x05, 0x2b, 0x64, 0x03, 0x2a, 0x29, 0x12,
+  0x05, 0x2a, 0x25, 0x03, 0x29, 0x12, 0x03, 0x28, 0x27, 0x25, 0x05, 0x28,
+  0x41, 0x03, 0x27, 0x25, 0x03, 0x26, 0x25, 0x0b, 0x05, 0x26, 0x0f, 0x03,
+  0x25, 0x0b, 0x03, 0x24, 0xfe, 0x03, 0x23, 0xfe, 0x03, 0x22, 0x0f, 0x03,
+  0x21, 0x01, 0x10, 0x05, 0x21, 0x12, 0x03, 0x20, 0x64, 0x03, 0x1f, 0xfa,
+  0x03, 0x1e, 0x1d, 0x0d, 0x05, 0x1e, 0x64, 0x03, 0x1d, 0x0d, 0x03, 0x1c,
+  0x11, 0x42, 0x05, 0x1c, 0xfe, 0x03, 0x1b, 0xfa, 0x03, 0x1a, 0x42, 0x03,
+  0x19, 0x11, 0x42, 0x05, 0x19, 0xfe, 0x03, 0x18, 0x64, 0x03, 0x17, 0x16,
+  0x19, 0x05, 0x17, 0xfe, 0x03, 0x16, 0x01, 0x10, 0x05, 0x16, 0x19, 0x03,
+  0x15, 0xfe, 0x03, 0x14, 0xfe, 0x03, 0x13, 0xfe, 0x03, 0x12, 0x11, 0x42,
+  0x05, 0x12, 0xfe, 0x03, 0x11, 0x02, 0x2d, 0x05, 0x11, 0x42, 0x03, 0x10,
+  0x7d, 0x03, 0x0f, 0x64, 0x03, 0x0e, 0xfe, 0x03, 0x0d, 0x0c, 0x16, 0x05,
+  0x0d, 0xfe, 0x03, 0x0c, 0x01, 0x10, 0x05, 0x0c, 0x16, 0x03, 0x0b, 0xfe,
+  0x03, 0x0a, 0x10, 0x03, 0x09, 0xfe, 0x03, 0x08, 0x02, 0x2d, 0x05, 0x08,
+  0xfe, 0x03, 0x07, 0x14, 0x03, 0x06, 0x64, 0x03, 0x04, 0x01, 0x10, 0x05,
+  0x04, 0xfe, 0x03, 0x40, 0x15, 0x03, 0x02, 0x2d, 0x05, 0x03, 0xfe, 0x03,
+  0x02, 0x01, 0x10, 0x05, 0x02, 0x2d, 0x03, 0x01, 0x10, 0x03, 0x00, 0xfe,
+  0x03, 0x01, 0xb8, 0x01, 0x64, 0x85, 0x8d, 0x01, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x00, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b,
+  0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x2b, 0x1d
+};
+unsigned int dejavu_sans_condensed_ttf_len = 552620;
+#endif
diff -pruN 8.0.1-5/src/dxfcolor.h 8.2.0~beta1-1~exp1/src/dxfcolor.h
--- 8.0.1-5/src/dxfcolor.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/dxfcolor.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,69 @@
+struct dxfcolor {
+  int r, g, b;
+};
+struct dxfcolor ctable[256] = {
+    {0, 0, 0},       {255, 0, 0},     {255, 255, 0},   {0, 255, 0},
+    {0, 255, 255},   {0, 0, 255},     {255, 0, 255},   {255, 255, 255},
+    {128, 128, 128}, {192, 192, 192}, {255, 0, 0},     {255, 127, 127},
+    {204, 0, 0},     {204, 102, 102}, {153, 0, 0},     {153, 76, 76},
+    {127, 0, 0},     {127, 63, 63},   {76, 0, 0},      {76, 38, 38},
+    {255, 63, 0},    {255, 159, 127}, {204, 51, 0},    {204, 127, 102},
+    {153, 38, 0},    {153, 95, 76},   {127, 31, 0},    {127, 79, 63},
+    {76, 19, 0},     {76, 47, 38},    {255, 127, 0},   {255, 191, 127},
+    {204, 102, 0},   {204, 153, 102}, {153, 76, 0},    {153, 114, 76},
+    {127, 63, 0},    {127, 95, 63},   {76, 38, 0},     {76, 57, 38},
+    {255, 191, 0},   {255, 223, 127}, {204, 153, 0},   {204, 178, 102},
+    {153, 114, 0},   {153, 133, 76},  {127, 95, 0},    {127, 111, 63},
+    {76, 57, 0},     {76, 66, 38},    {255, 255, 0},   {255, 255, 127},
+    {204, 204, 0},   {204, 204, 102}, {153, 153, 0},   {153, 153, 76},
+    {127, 127, 0},   {127, 127, 63},  {76, 76, 0},     {76, 76, 38},
+    {191, 255, 0},   {223, 255, 127}, {153, 204, 0},   {178, 204, 102},
+    {114, 153, 0},   {133, 153, 76},  {95, 127, 0},    {111, 127, 63},
+    {57, 76, 0},     {66, 76, 38},    {127, 255, 0},   {191, 255, 127},
+    {102, 204, 0},   {153, 204, 102}, {76, 153, 0},    {114, 153, 76},
+    {63, 127, 0},    {95, 127, 63},   {38, 76, 0},     {57, 76, 38},
+    {63, 255, 0},    {159, 255, 127}, {51, 204, 0},    {127, 204, 102},
+    {38, 153, 0},    {95, 153, 76},   {31, 127, 0},    {79, 127, 63},
+    {19, 76, 0},     {47, 76, 38},    {0, 255, 0},     {127, 255, 127},
+    {0, 204, 0},     {102, 204, 102}, {0, 153, 0},     {76, 153, 76},
+    {0, 127, 0},     {63, 127, 63},   {0, 76, 0},      {38, 76, 38},
+    {0, 255, 63},    {127, 255, 159}, {0, 204, 51},    {102, 204, 127},
+    {0, 153, 38},    {76, 153, 95},   {0, 127, 31},    {63, 127, 79},
+    {0, 76, 19},     {38, 76, 47},    {0, 255, 127},   {127, 255, 191},
+    {0, 204, 102},   {102, 204, 153}, {0, 153, 76},    {76, 153, 114},
+    {0, 127, 63},    {63, 127, 95},   {0, 76, 38},     {38, 76, 57},
+    {0, 255, 191},   {127, 255, 223}, {0, 204, 153},   {102, 204, 178},
+    {0, 153, 114},   {76, 153, 133},  {0, 127, 95},    {63, 127, 111},
+    {0, 76, 57},     {38, 76, 66},    {0, 255, 255},   {127, 255, 255},
+    {0, 204, 204},   {102, 204, 204}, {0, 153, 153},   {76, 153, 153},
+    {0, 127, 127},   {63, 127, 127},  {0, 76, 76},     {38, 76, 76},
+    {0, 191, 255},   {127, 223, 255}, {0, 153, 204},   {102, 178, 204},
+    {0, 114, 153},   {76, 133, 153},  {0, 95, 127},    {63, 111, 127},
+    {0, 57, 76},     {38, 66, 76},    {0, 127, 255},   {127, 191, 255},
+    {0, 102, 204},   {102, 153, 204}, {0, 76, 153},    {76, 114, 153},
+    {0, 63, 127},    {63, 95, 127},   {0, 38, 76},     {38, 57, 76},
+    {0, 63, 255},    {127, 159, 255}, {0, 51, 204},    {102, 127, 204},
+    {0, 38, 153},    {76, 95, 153},   {0, 31, 127},    {63, 79, 127},
+    {0, 19, 76},     {38, 47, 76},    {0, 0, 255},     {127, 127, 255},
+    {0, 0, 204},     {102, 102, 204}, {0, 0, 153},     {76, 76, 153},
+    {0, 0, 127},     {63, 63, 127},   {0, 0, 76},      {38, 38, 76},
+    {63, 0, 255},    {159, 127, 255}, {51, 0, 204},    {127, 102, 204},
+    {38, 0, 153},    {95, 76, 153},   {31, 0, 127},    {79, 63, 127},
+    {19, 0, 76},     {47, 38, 76},    {127, 0, 255},   {191, 127, 255},
+    {102, 0, 204},   {153, 102, 204}, {76, 0, 153},    {114, 76, 153},
+    {63, 0, 127},    {95, 63, 127},   {38, 0, 76},     {57, 38, 76},
+    {191, 0, 255},   {223, 127, 255}, {153, 0, 204},   {178, 102, 204},
+    {114, 0, 153},   {133, 76, 153},  {95, 0, 127},    {111, 63, 127},
+    {57, 0, 76},     {66, 38, 76},    {255, 0, 255},   {255, 127, 255},
+    {204, 0, 204},   {204, 102, 204}, {153, 0, 153},   {153, 76, 153},
+    {127, 0, 127},   {127, 63, 127},  {76, 0, 76},     {76, 38, 76},
+    {255, 0, 191},   {255, 127, 223}, {204, 0, 153},   {204, 102, 178},
+    {153, 0, 114},   {153, 76, 133},  {127, 0, 95},    {127, 63, 111},
+    {76, 0, 57},     {76, 38, 66},    {255, 0, 127},   {255, 127, 191},
+    {204, 0, 102},   {204, 102, 153}, {153, 0, 76},    {153, 76, 114},
+    {127, 0, 63},    {127, 63, 95},   {76, 0, 38},     {76, 38, 57},
+    {255, 0, 63},    {255, 127, 159}, {204, 0, 51},    {204, 102, 127},
+    {153, 0, 38},    {153, 76, 95},   {127, 0, 31},    {127, 63, 79},
+    {76, 0, 19},     {76, 38, 47},    {51, 51, 51},    {91, 91, 91},
+    {132, 132, 132}, {173, 173, 173}, {214, 214, 214}, {255, 255, 255},
+};
diff -pruN 8.0.1-5/src/flatgeobuf/LICENSE 8.2.0~beta1-1~exp1/src/flatgeobuf/LICENSE
--- 8.0.1-5/src/flatgeobuf/LICENSE	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/LICENSE	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,9 @@
+Copyright (c) 2018, Björn Harrtell
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are met:
+
+1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
+2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
diff -pruN 8.0.1-5/src/flatgeobuf/feature_generated.h 8.2.0~beta1-1~exp1/src/flatgeobuf/feature_generated.h
--- 8.0.1-5/src/flatgeobuf/feature_generated.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/feature_generated.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,287 @@
+// automatically generated by the FlatBuffers compiler, do not modify
+
+
+#ifndef FLATBUFFERS_GENERATED_FEATURE_FLATGEOBUF_H_
+#define FLATBUFFERS_GENERATED_FEATURE_FLATGEOBUF_H_
+
+#include "flatbuffers/flatbuffers.h"
+
+// Ensure the included flatbuffers.h is the same version as when this file was
+// generated, otherwise it may not be compatible.
+static_assert(FLATBUFFERS_VERSION_MAJOR == 2 &&
+              FLATBUFFERS_VERSION_MINOR == 0 &&
+              FLATBUFFERS_VERSION_REVISION == 6,
+             "Non-compatible flatbuffers version included");
+
+#include "header_generated.h"
+
+namespace mapserver {
+namespace FlatGeobuf {
+
+struct Geometry;
+struct GeometryBuilder;
+
+struct Feature;
+struct FeatureBuilder;
+
+struct Geometry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef GeometryBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_ENDS = 4,
+    VT_XY = 6,
+    VT_Z = 8,
+    VT_M = 10,
+    VT_T = 12,
+    VT_TM = 14,
+    VT_TYPE = 16,
+    VT_PARTS = 18
+  };
+  const flatbuffers::Vector<uint32_t> *ends() const {
+    return GetPointer<const flatbuffers::Vector<uint32_t> *>(VT_ENDS);
+  }
+  const flatbuffers::Vector<double> *xy() const {
+    return GetPointer<const flatbuffers::Vector<double> *>(VT_XY);
+  }
+  const flatbuffers::Vector<double> *z() const {
+    return GetPointer<const flatbuffers::Vector<double> *>(VT_Z);
+  }
+  const flatbuffers::Vector<double> *m() const {
+    return GetPointer<const flatbuffers::Vector<double> *>(VT_M);
+  }
+  const flatbuffers::Vector<double> *t() const {
+    return GetPointer<const flatbuffers::Vector<double> *>(VT_T);
+  }
+  const flatbuffers::Vector<uint64_t> *tm() const {
+    return GetPointer<const flatbuffers::Vector<uint64_t> *>(VT_TM);
+  }
+  FlatGeobuf::GeometryType type() const {
+    return static_cast<FlatGeobuf::GeometryType>(GetField<uint8_t>(VT_TYPE, 0));
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>> *parts() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>> *>(VT_PARTS);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffset(verifier, VT_ENDS) &&
+           verifier.VerifyVector(ends()) &&
+           VerifyOffset(verifier, VT_XY) &&
+           verifier.VerifyVector(xy()) &&
+           VerifyOffset(verifier, VT_Z) &&
+           verifier.VerifyVector(z()) &&
+           VerifyOffset(verifier, VT_M) &&
+           verifier.VerifyVector(m()) &&
+           VerifyOffset(verifier, VT_T) &&
+           verifier.VerifyVector(t()) &&
+           VerifyOffset(verifier, VT_TM) &&
+           verifier.VerifyVector(tm()) &&
+           VerifyField<uint8_t>(verifier, VT_TYPE, 1) &&
+           VerifyOffset(verifier, VT_PARTS) &&
+           verifier.VerifyVector(parts()) &&
+           verifier.VerifyVectorOfTables(parts()) &&
+           verifier.EndTable();
+  }
+};
+
+struct GeometryBuilder {
+  typedef Geometry Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_ends(flatbuffers::Offset<flatbuffers::Vector<uint32_t>> ends) {
+    fbb_.AddOffset(Geometry::VT_ENDS, ends);
+  }
+  void add_xy(flatbuffers::Offset<flatbuffers::Vector<double>> xy) {
+    fbb_.AddOffset(Geometry::VT_XY, xy);
+  }
+  void add_z(flatbuffers::Offset<flatbuffers::Vector<double>> z) {
+    fbb_.AddOffset(Geometry::VT_Z, z);
+  }
+  void add_m(flatbuffers::Offset<flatbuffers::Vector<double>> m) {
+    fbb_.AddOffset(Geometry::VT_M, m);
+  }
+  void add_t(flatbuffers::Offset<flatbuffers::Vector<double>> t) {
+    fbb_.AddOffset(Geometry::VT_T, t);
+  }
+  void add_tm(flatbuffers::Offset<flatbuffers::Vector<uint64_t>> tm) {
+    fbb_.AddOffset(Geometry::VT_TM, tm);
+  }
+  void add_type(FlatGeobuf::GeometryType type) {
+    fbb_.AddElement<uint8_t>(Geometry::VT_TYPE, static_cast<uint8_t>(type), 0);
+  }
+  void add_parts(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>>> parts) {
+    fbb_.AddOffset(Geometry::VT_PARTS, parts);
+  }
+  explicit GeometryBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Geometry> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Geometry>(end);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Geometry> CreateGeometry(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::Vector<uint32_t>> ends = 0,
+    flatbuffers::Offset<flatbuffers::Vector<double>> xy = 0,
+    flatbuffers::Offset<flatbuffers::Vector<double>> z = 0,
+    flatbuffers::Offset<flatbuffers::Vector<double>> m = 0,
+    flatbuffers::Offset<flatbuffers::Vector<double>> t = 0,
+    flatbuffers::Offset<flatbuffers::Vector<uint64_t>> tm = 0,
+    FlatGeobuf::GeometryType type = FlatGeobuf::GeometryType::Unknown,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Geometry>>> parts = 0) {
+  GeometryBuilder builder_(_fbb);
+  builder_.add_parts(parts);
+  builder_.add_tm(tm);
+  builder_.add_t(t);
+  builder_.add_m(m);
+  builder_.add_z(z);
+  builder_.add_xy(xy);
+  builder_.add_ends(ends);
+  builder_.add_type(type);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Geometry> CreateGeometryDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const std::vector<uint32_t> *ends = nullptr,
+    const std::vector<double> *xy = nullptr,
+    const std::vector<double> *z = nullptr,
+    const std::vector<double> *m = nullptr,
+    const std::vector<double> *t = nullptr,
+    const std::vector<uint64_t> *tm = nullptr,
+    FlatGeobuf::GeometryType type = FlatGeobuf::GeometryType::Unknown,
+    const std::vector<flatbuffers::Offset<FlatGeobuf::Geometry>> *parts = nullptr) {
+  auto ends__ = ends ? _fbb.CreateVector<uint32_t>(*ends) : 0;
+  auto xy__ = xy ? _fbb.CreateVector<double>(*xy) : 0;
+  auto z__ = z ? _fbb.CreateVector<double>(*z) : 0;
+  auto m__ = m ? _fbb.CreateVector<double>(*m) : 0;
+  auto t__ = t ? _fbb.CreateVector<double>(*t) : 0;
+  auto tm__ = tm ? _fbb.CreateVector<uint64_t>(*tm) : 0;
+  auto parts__ = parts ? _fbb.CreateVector<flatbuffers::Offset<FlatGeobuf::Geometry>>(*parts) : 0;
+  return FlatGeobuf::CreateGeometry(
+      _fbb,
+      ends__,
+      xy__,
+      z__,
+      m__,
+      t__,
+      tm__,
+      type,
+      parts__);
+}
+
+struct Feature FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef FeatureBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_GEOMETRY = 4,
+    VT_PROPERTIES = 6,
+    VT_COLUMNS = 8
+  };
+  const FlatGeobuf::Geometry *geometry() const {
+    return GetPointer<const FlatGeobuf::Geometry *>(VT_GEOMETRY);
+  }
+  const flatbuffers::Vector<uint8_t> *properties() const {
+    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_PROPERTIES);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *>(VT_COLUMNS);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffset(verifier, VT_GEOMETRY) &&
+           verifier.VerifyTable(geometry()) &&
+           VerifyOffset(verifier, VT_PROPERTIES) &&
+           verifier.VerifyVector(properties()) &&
+           VerifyOffset(verifier, VT_COLUMNS) &&
+           verifier.VerifyVector(columns()) &&
+           verifier.VerifyVectorOfTables(columns()) &&
+           verifier.EndTable();
+  }
+};
+
+struct FeatureBuilder {
+  typedef Feature Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_geometry(flatbuffers::Offset<FlatGeobuf::Geometry> geometry) {
+    fbb_.AddOffset(Feature::VT_GEOMETRY, geometry);
+  }
+  void add_properties(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> properties) {
+    fbb_.AddOffset(Feature::VT_PROPERTIES, properties);
+  }
+  void add_columns(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns) {
+    fbb_.AddOffset(Feature::VT_COLUMNS, columns);
+  }
+  explicit FeatureBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Feature> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Feature>(end);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Feature> CreateFeature(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<FlatGeobuf::Geometry> geometry = 0,
+    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> properties = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns = 0) {
+  FeatureBuilder builder_(_fbb);
+  builder_.add_columns(columns);
+  builder_.add_properties(properties);
+  builder_.add_geometry(geometry);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Feature> CreateFeatureDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<FlatGeobuf::Geometry> geometry = 0,
+    const std::vector<uint8_t> *properties = nullptr,
+    const std::vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns = nullptr) {
+  auto properties__ = properties ? _fbb.CreateVector<uint8_t>(*properties) : 0;
+  auto columns__ = columns ? _fbb.CreateVector<flatbuffers::Offset<FlatGeobuf::Column>>(*columns) : 0;
+  return FlatGeobuf::CreateFeature(
+      _fbb,
+      geometry,
+      properties__,
+      columns__);
+}
+
+inline const FlatGeobuf::Feature *GetFeature(const void *buf) {
+  return flatbuffers::GetRoot<FlatGeobuf::Feature>(buf);
+}
+
+inline const FlatGeobuf::Feature *GetSizePrefixedFeature(const void *buf) {
+  return flatbuffers::GetSizePrefixedRoot<FlatGeobuf::Feature>(buf);
+}
+
+inline bool VerifyFeatureBuffer(
+    flatbuffers::Verifier &verifier) {
+  return verifier.VerifyBuffer<FlatGeobuf::Feature>(nullptr);
+}
+
+inline bool VerifySizePrefixedFeatureBuffer(
+    flatbuffers::Verifier &verifier) {
+  return verifier.VerifySizePrefixedBuffer<FlatGeobuf::Feature>(nullptr);
+}
+
+inline void FinishFeatureBuffer(
+    flatbuffers::FlatBufferBuilder &fbb,
+    flatbuffers::Offset<FlatGeobuf::Feature> root) {
+  fbb.Finish(root);
+}
+
+inline void FinishSizePrefixedFeatureBuffer(
+    flatbuffers::FlatBufferBuilder &fbb,
+    flatbuffers::Offset<FlatGeobuf::Feature> root) {
+  fbb.FinishSizePrefixed(root);
+}
+
+}  // namespace FlatGeobuf
+}
+
+#endif  // FLATBUFFERS_GENERATED_FEATURE_FLATGEOBUF_H_
diff -pruN 8.0.1-5/src/flatgeobuf/flatgeobuf_c.cpp 8.2.0~beta1-1~exp1/src/flatgeobuf/flatgeobuf_c.cpp
--- 8.0.1-5/src/flatgeobuf/flatgeobuf_c.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/flatgeobuf_c.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,399 @@
+#include "flatgeobuf_c.h"
+
+#include "feature_generated.h"
+#include "geometryreader.h"
+#include "packedrtree.h"
+#include <stdexcept>
+
+using namespace mapserver::flatbuffers;
+using namespace mapserver::FlatGeobuf;
+
+typedef flatgeobuf_ctx ctx;
+
+uint8_t flatgeobuf_magicbytes[] = { 0x66, 0x67, 0x62, 0x03, 0x66, 0x67, 0x62, 0x01 };
+uint8_t FLATGEOBUF_MAGICBYTES_SIZE = sizeof(flatgeobuf_magicbytes);
+uint32_t INIT_BUFFER_SIZE = 1024 * 4;
+
+template <typename T>
+void parse_value(uint8_t *data, char **values, uint16_t i, uint32_t &offset, bool found)
+{
+    using std::to_string;
+    if (found)
+    {
+        msFree(values[i]);
+        values[i] = msStrdup(to_string(*((T*) (data + offset))).c_str());
+    }
+    offset += sizeof(T);
+}
+
+ctx *flatgeobuf_init_ctx()
+{
+    ctx *c = (ctx *) malloc(sizeof(ctx));
+    memset(c, 0, sizeof(ctx));
+    c->is_null_geom = false;
+    c->done = false;
+    return c;
+}
+
+void flatgeobuf_free_ctx(ctx *ctx)
+{
+    if (ctx->columns) {
+        for (uint32_t i = 0; i < ctx->columns_len; i++)
+            free(ctx->columns[i].name);
+        free(ctx->columns);
+    }
+    if (ctx->search_result)
+        free(ctx->search_result);
+    if (ctx->buf)
+        free(ctx->buf);
+    if (ctx->wkt)
+        free(ctx->wkt);
+    free(ctx);
+}
+
+void flatgeobuf_ensure_line(ctx *ctx, uint32_t len)
+{
+    if (!ctx->line) {
+        ctx->line_len = len;
+        ctx->line = (lineObj *) malloc(ctx->line_len * sizeof(lineObj));
+        return;
+    }
+    if (ctx->line_len < len) {
+        ctx->line_len = len;
+        ctx->line = (lineObj *) realloc(ctx->buf, ctx->line_len * sizeof(lineObj));
+    }
+}
+
+void flatgeobuf_ensure_point(ctx *ctx, uint32_t len)
+{
+    if (!ctx->point) {
+        ctx->point_len = len;
+        ctx->point = (pointObj *) malloc(ctx->point_len * sizeof(pointObj));
+        return;
+    }
+    if (ctx->point_len < len) {
+        ctx->point_len = len;
+        ctx->point = (pointObj *) realloc(ctx->buf, ctx->point_len * sizeof(pointObj));
+    }
+}
+
+int flatgeobuf_ensure_buf(ctx *ctx, uint32_t size)
+{
+    if (size > 100 * 1024 * 1024) {
+        msSetError(MS_FGBERR, "Invalid buffer size requested", "flatgeobuf_ensure_buf");
+        return -1;
+    }
+    if (!ctx->buf) {
+        ctx->buf_size = std::max(INIT_BUFFER_SIZE, size);
+        ctx->buf = (uint8_t *) malloc(ctx->buf_size);
+        if (ctx->buf == NULL) {
+            msSetError(MS_FGBERR, "Failed to allocate buffer", "flatgeobuf_ensure_buf");
+            return -1;
+        }
+        return 0;
+    }
+    if (ctx->buf_size < size) {
+        ctx->buf_size = std::max(ctx->buf_size * 2, size);
+        auto buf = (uint8_t *) realloc(ctx->buf, ctx->buf_size);
+        if (buf == NULL) {
+            msSetError(MS_FGBERR, "Failed to reallocate buffer", "flatgeobuf_ensure_buf");
+            return -1;
+        }
+        ctx->buf = buf;
+    }
+    return 0;
+}
+
+int flatgeobuf_decode_feature(ctx *ctx, layerObj *layer, shapeObj *shape)
+{
+    ctx->is_null_geom = false;
+
+    uint32_t featureSize;
+    if (VSIFReadL(&featureSize, sizeof(featureSize), 1, ctx->file) != 1) {
+        if (VSIFEofL(ctx->file)) {
+            ctx->done = true;
+            return 0;
+        }
+        return -1;
+    }
+
+    ctx->offset += sizeof(uoffset_t);
+    if (flatgeobuf_ensure_buf(ctx, featureSize) != 0) {
+        return -1;
+    }
+
+    if (VSIFReadL(ctx->buf, 1, featureSize, ctx->file) != featureSize) {
+        msSetError(MS_FGBERR, "Failed to read feature", "flatgeobuf_decode_feature");
+        return -1;
+    }
+    ctx->offset += featureSize;
+    auto feature = GetFeature(ctx->buf);
+    const auto geometry = feature->geometry();
+    if (geometry) {
+        GeometryReader(ctx, geometry).read(shape);
+    } else {
+        ctx->is_null_geom = true;
+        return 0;
+    }
+    auto properties = feature->properties();
+    if (properties && properties->size() != 0) {
+        ctx->properties = (uint8_t *) properties->data();
+        ctx->properties_size = properties->size();
+        flatgeobuf_decode_properties(ctx, layer, shape);
+    } else {
+        ctx->properties_size = 0;
+    }
+
+    return 0;
+}
+
+int flatgeobuf_decode_properties(ctx *ctx, layerObj *layer, shapeObj *shape)
+{
+	uint8_t type;
+	uint32_t offset = 0;
+	uint8_t *data = ctx->properties;
+	uint32_t size = ctx->properties_size;
+    uint16_t numvalues = layer->numitems;
+    bool found;
+    char **values;
+
+    if (numvalues == 0)
+        return 0;
+
+    values = (char **) msSmallCalloc(sizeof(char *), numvalues);
+    if (shape->values) msFreeCharArray(shape->values, shape->numvalues);
+    shape->numvalues = numvalues;
+    shape->values = values;
+
+    if (size > 0 && size < (sizeof(uint16_t) + sizeof(uint8_t))) {
+        msSetError(MS_FGBERR, "Unexpected properties data size", "flatgeobuf_decode_properties");
+        return -1;
+    }
+	while (offset + 1 < size) {
+        uint16_t i;
+        memcpy(&i, data + offset, sizeof(uint16_t));
+		offset += sizeof(uint16_t);
+		if (i >= ctx->columns_len) {
+            msSetError(MS_FGBERR, "Column index out of range", "flatgeobuf_decode_properties");
+            return -1;
+        }
+		const auto& column = ctx->columns[i];
+        const int32_t ii = column.itemindex;
+        found = ii != -1;
+		type = column.type;
+		switch (type) {
+		case flatgeobuf_column_type_bool:
+            parse_value<uint8_t>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_byte:
+            parse_value<int8_t>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_ubyte:
+            parse_value<uint8_t>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_short:
+			parse_value<int16_t>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_ushort:
+            parse_value<uint16_t>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_int:
+            parse_value<int32_t>(data, values, ii, offset, found);
+            break;
+		case flatgeobuf_column_type_uint:
+			parse_value<uint32_t>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_long:
+            parse_value<int64_t>(data, values, ii, offset, found);
+            break;
+		case flatgeobuf_column_type_ulong:
+			parse_value<uint64_t>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_float:
+            parse_value<float>(data, values, ii, offset, found);
+			break;
+		case flatgeobuf_column_type_double:
+			parse_value<double>(data, values, ii, offset, found);
+			break;
+        case flatgeobuf_column_type_datetime:
+		case flatgeobuf_column_type_string: {
+			uint32_t len;
+			if (offset + sizeof(len) > size){
+                msSetError(MS_FGBERR, "Invalid size for string value", "flatgeobuf_decode_properties");
+                return -1;
+            }
+			memcpy(&len, data + offset, sizeof(uint32_t));
+			offset += sizeof(len);
+			if (found) {
+                char *str = (char *) msSmallMalloc(len + 1);
+                memcpy(str, data + offset, len);
+                str[len] = '\0';
+                msFree(values[ii]);
+                values[ii] = str;
+            }
+			offset += len;
+			break;
+		}
+        }
+    }
+
+    for(int i = 0; i < shape->numvalues; i++)
+    {
+        if( shape->values[i] == NULL)
+            shape->values[i] = msStrdup("");
+    }
+
+    return 0;
+}
+
+int flatgeobuf_check_magicbytes(ctx *ctx)
+{
+    if (ctx->offset != 0) {
+        msSetError(MS_FGBERR, "Unexpected offset", "flatgeobuf_check_magicbytes");
+        return -1;
+    }
+    if (flatgeobuf_ensure_buf(ctx, FLATGEOBUF_MAGICBYTES_SIZE) != 0)
+        return -1;
+    if (VSIFReadL(ctx->buf, 8, 1, ctx->file) != 1) {
+        msSetError(MS_FGBERR, "Failed to read magicbytes", "flatgeobuf_check_magicbytes");
+        return -1;
+    }
+	uint32_t i;
+	for (i = 0; i < FLATGEOBUF_MAGICBYTES_SIZE / 2; i++) {
+        if (ctx->buf[i] != flatgeobuf_magicbytes[i]) {
+            msSetError(MS_FGBERR, "Data is not FlatGeobuf", "flatgeobuf_check_magicbytes");
+            return -1;
+        }
+    }
+	ctx->offset += FLATGEOBUF_MAGICBYTES_SIZE;
+    return 0;
+}
+
+int flatgeobuf_decode_header(ctx *ctx)
+{
+    if (ctx->offset != FLATGEOBUF_MAGICBYTES_SIZE) {
+        msSetError(MS_FGBERR, "Unexpected offset", "flatgeobuf_decode_header");
+        return -1;
+    }
+    if (VSIFSeekL(ctx->file, ctx->offset, SEEK_SET) == -1) {
+        msSetError(MS_FGBERR, "Unable to get seek in file", "flatgeobuf_decode_header");
+        return -1;
+    }
+    uint32_t headerSize;
+    if (VSIFReadL(&headerSize, 4, 1, ctx->file) != 1) {
+        msSetError(MS_FGBERR, "Failed to read header size", "flatgeobuf_decode_header");
+        return -1;
+    }
+    ctx->offset += sizeof(uoffset_t);
+    if (flatgeobuf_ensure_buf(ctx, headerSize) != 0) {
+        return -1;
+    }
+    if (VSIFReadL(ctx->buf, 1, headerSize, ctx->file) != headerSize) {
+        msSetError(MS_FGBERR, "Failed to read header", "flatgeobuf_decode_header");
+        return -1;
+    }
+    auto header = GetHeader(ctx->buf);
+	ctx->offset += headerSize;
+
+	ctx->geometry_type = (uint8_t) header->geometry_type();
+    ctx->features_count = header->features_count();
+    auto envelope = header->envelope();
+    if (envelope != nullptr) {
+        ctx->has_extent = true;
+        ctx->xmin = envelope->Get(0);
+        ctx->ymin = envelope->Get(1);
+        ctx->xmax = envelope->Get(2);
+        ctx->ymax = envelope->Get(3);
+        ctx->bounds.minx = ctx->xmin;
+        ctx->bounds.miny = ctx->ymin;
+        ctx->bounds.maxx = ctx->xmax;
+        ctx->bounds.maxy = ctx->ymax;
+    }
+	ctx->has_z = header->has_z();
+    ctx->has_m = header->has_m();
+    ctx->has_t = header->has_t();
+    ctx->has_tm = header->has_tm();
+    ctx->index_node_size = header->index_node_size();
+    auto crs = header->crs();
+    if (crs != nullptr) {
+        ctx->srid = crs->code();
+        auto wkt = crs->wkt();
+        if (wkt != nullptr)
+            ctx->wkt = msStrdup(wkt->c_str());
+    }
+    auto columns = header->columns();
+    if (columns != nullptr) {
+        auto size = columns->size();
+        ctx->columns = (flatgeobuf_column *) malloc(size * sizeof(flatgeobuf_column));
+        memset(ctx->columns, 0, size * sizeof(flatgeobuf_column));
+        ctx->columns_len = size;
+        for (uint32_t i = 0; i < size; i++) {
+            auto column = columns->Get(i);
+            ctx->columns[i].name = msStrdup(column->name()->c_str());
+            ctx->columns[i].type = (uint8_t) column->type();
+            ctx->columns[i].itemindex = -1;
+        }
+    }
+
+    ctx->index_offset = ctx->offset;
+    ctx->feature_offset = ctx->offset;
+    if ( ctx->index_node_size > 0)
+        ctx->feature_offset += PackedRTree::size(ctx->features_count, ctx->index_node_size);
+
+    return 0;
+}
+
+int flatgeobuf_index_search(ctx *ctx, rectObj *rect)
+{
+    const auto treeOffset = ctx->offset;
+    const auto readNode = [treeOffset, ctx] (uint8_t *buf, size_t i, size_t s) {
+        if (VSIFSeekL(ctx->file, treeOffset + i, SEEK_SET) == -1)
+            throw std::runtime_error("Unable to seek in file");
+        if (VSIFReadL(buf, 1, s, ctx->file) != s)
+            throw std::runtime_error("Unable to read file");
+    };
+    NodeItem n { rect->minx, rect->miny, rect->maxx, rect->maxy, 0 };
+    try {
+        const auto foundItems = PackedRTree::streamSearch(ctx->features_count, ctx->index_node_size, n, readNode);
+        ctx->search_result = (flatgeobuf_search_item *) malloc(foundItems.size() * sizeof(flatgeobuf_search_item));
+        memcpy(ctx->search_result, foundItems.data(), foundItems.size() * sizeof(flatgeobuf_search_item));
+        ctx->search_result_len = (uint32_t) foundItems.size();
+    } catch (const std::exception &e) {
+        msSetError(MS_FGBERR, "Unable to seek or read file", "flatgeobuf_index_search");
+        return -1;
+    }
+    return 0;
+}
+
+int flatgeobuf_index_skip(ctx *ctx)
+{
+    auto treeSize = PackedRTree::size(ctx->features_count, ctx->index_node_size);
+    ctx->offset += treeSize;
+    if (VSIFSeekL(ctx->file, ctx->offset, SEEK_SET) == -1) {
+        msSetError(MS_FGBERR, "Unable to seek in file", "flatgeobuf_index_skip");
+        return -1;
+    }
+    return 0;
+}
+
+int flatgeobuf_read_feature_offset(ctx *ctx, uint64_t index, uint64_t *featureOffset)
+{
+    try {
+        const auto levelBounds = PackedRTree::generateLevelBounds(ctx->features_count, ctx->index_node_size);
+        const auto bottomLevelOffset = ctx->index_offset + (levelBounds.front().first * sizeof(NodeItem));
+        const auto nodeItemOffset = bottomLevelOffset + (index * sizeof(NodeItem));
+        const auto featureOffsetOffset = nodeItemOffset + (sizeof(double) * 4);
+        if (VSIFSeekL(ctx->file, featureOffsetOffset, SEEK_SET) == -1) {
+            msSetError(MS_FGBERR, "Failed to seek feature offset", "flatgeobuf_read_feature_offset");
+            return -1;
+        }
+        if (VSIFReadL(featureOffset, sizeof(uint64_t), 1, ctx->file) != 1) {
+            msSetError(MS_FGBERR, "Failed to read feature offset", "flatgeobuf_read_feature_offset");
+            return -1;
+        }
+        return 0;
+    } catch (const std::exception& e) {
+        msSetError(MS_FGBERR, "Failed to calculate tree size", "flatgeobuf_read_feature_offset");
+        return -1;
+    }
+}
diff -pruN 8.0.1-5/src/flatgeobuf/flatgeobuf_c.h 8.2.0~beta1-1~exp1/src/flatgeobuf/flatgeobuf_c.h
--- 8.0.1-5/src/flatgeobuf/flatgeobuf_c.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/flatgeobuf_c.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,136 @@
+#ifndef FLATGEOBUF_C_H
+#define FLATGEOBUF_C_H
+
+#include "../../mapserver.h"
+#include "../../maperror.h"
+#include "../../mapprimitive.h"
+#include <stdbool.h>
+#include <stdint.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+extern uint8_t flatgeobuf_magicbytes[];
+extern uint8_t FLATGEOBUF_MAGICBYTES_SIZE;
+
+// need c compatible variant of this enum
+#define flatgeobuf_column_type_byte UINT8_C(0)
+#define flatgeobuf_column_type_ubyte UINT8_C(1)
+#define flatgeobuf_column_type_bool UINT8_C(2)
+#define flatgeobuf_column_type_short UINT8_C(3)
+#define flatgeobuf_column_type_ushort UINT8_C(4)
+#define flatgeobuf_column_type_int UINT8_C(5)
+#define flatgeobuf_column_type_uint UINT8_C(6)
+#define flatgeobuf_column_type_long UINT8_C(7)
+#define flatgeobuf_column_type_ulong UINT8_C(8)
+#define flatgeobuf_column_type_float UINT8_C(9)
+#define flatgeobuf_column_type_double UINT8_C(10)
+#define flatgeobuf_column_type_string UINT8_C(11)
+#define flatgeobuf_column_type_json UINT8_C(12)
+#define flatgeobuf_column_type_datetime UINT8_C(13)
+#define flatgeobuf_column_type_binary UINT8_C(14)
+
+typedef struct flatgeobuf_column
+{
+	char *name;
+	uint8_t type;
+	const char *title;
+	const char *description;
+	uint32_t width;
+	uint32_t precision;
+	uint32_t scale;
+	bool nullable;
+	bool unique;
+	bool primary_key;
+	const char * metadata;
+	int32_t itemindex;
+} flatgeobuf_column;
+
+typedef struct flatgeobuf_item
+{
+	double xmin;
+	double xmax;
+	double ymin;
+	double ymax;
+	uint32_t size;
+	uint64_t offset;
+} flatgeobuf_item;
+
+typedef struct flatgeobuf_search_item {
+    uint64_t offset;
+    uint64_t index;
+} flatgeobuf_search_item;
+
+typedef struct flatgeobuf_ctx
+{
+	VSILFILE *file;
+	uint64_t index_offset;
+	uint64_t feature_offset;
+	uint64_t offset;
+	uint8_t *buf;
+	uint32_t buf_size;
+	bool done;
+
+    // header contents
+	const char *name;
+	uint64_t features_count;
+	uint8_t geometry_type;
+	bool has_extent;
+	double xmin;
+	double xmax;
+	double ymin;
+	double ymax;
+	bool has_z;
+	bool has_m;
+	bool has_t;
+	bool has_tm;
+	uint16_t index_node_size;
+	int32_t srid;
+	char *wkt;
+	flatgeobuf_column *columns;
+	uint16_t columns_len;
+
+	// mapserver structs
+	rectObj bounds;
+
+	// index search result
+	flatgeobuf_search_item *search_result;
+	uint32_t search_result_len;
+	uint32_t search_index;
+
+	// shape parts buffers
+	// NOTE: not used at this time, need to introduce optional free in mapdraw
+	lineObj *line;
+	uint32_t line_len;
+	pointObj *point;
+	uint32_t point_len;
+
+	bool is_null_geom;
+	uint64_t feature_index;
+	int ms_type;
+    uint8_t *properties;
+	uint32_t properties_size;
+} flatgeobuf_ctx;
+
+flatgeobuf_ctx *flatgeobuf_init_ctx();
+void flatgeobuf_free_ctx(flatgeobuf_ctx *ctx);
+
+int flatgeobuf_ensure_buf(flatgeobuf_ctx *ctx, uint32_t size);
+void flatgeobuf_ensure_line(flatgeobuf_ctx *ctx, uint32_t len);
+void flatgeobuf_ensure_point(flatgeobuf_ctx *ctx, uint32_t len);
+
+int flatgeobuf_check_magicbytes(flatgeobuf_ctx *ctx);
+int flatgeobuf_decode_header(flatgeobuf_ctx *ctx);
+int flatgeobuf_decode_feature(flatgeobuf_ctx *ctx, layerObj *layer, shapeObj *shape);
+int flatgeobuf_decode_properties(flatgeobuf_ctx *ctx, layerObj *layer, shapeObj *shape);
+
+int flatgeobuf_index_search(flatgeobuf_ctx *ctx, rectObj *rect);
+int flatgeobuf_index_skip(flatgeobuf_ctx *ctx);
+int flatgeobuf_read_feature_offset(flatgeobuf_ctx *ctx, uint64_t index, uint64_t *featureOffset);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* FLATGEOBUF_C_H */
diff -pruN 8.0.1-5/src/flatgeobuf/geometryreader.cpp 8.2.0~beta1-1~exp1/src/flatgeobuf/geometryreader.cpp
--- 8.0.1-5/src/flatgeobuf/geometryreader.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/geometryreader.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,150 @@
+#include "geometryreader.h"
+
+using namespace mapserver::flatbuffers;
+using namespace mapserver::FlatGeobuf;
+
+void GeometryReader::readPoint(shapeObj *shape)
+{
+    lineObj *l = (lineObj *) malloc(sizeof(lineObj));
+    pointObj *p = (pointObj *) malloc(sizeof(pointObj));
+
+	p->x = m_xy[m_offset + 0];
+	p->y = m_xy[m_offset + 1];
+    if (m_has_z)
+        p->z = m_geometry->z()->data()[m_offset];
+    if (m_has_m)
+        p->m = m_geometry->m()->data()[m_offset];
+
+    l[0].numpoints = 1;
+    l[0].point = p;
+    shape->numlines = 1;
+    shape->line = l;
+    shape->type = MS_SHAPE_POINT;
+}
+
+void GeometryReader::readLineObj(lineObj *line)
+{
+    const double *z = m_has_z ? m_geometry->z()->data() : nullptr;
+    const double *m = m_has_m ? m_geometry->m()->data() : nullptr;
+
+    line->point = (pointObj *) malloc(m_length * sizeof(pointObj));
+    line->numpoints = m_length;
+
+    for (uint32_t i = m_offset; i < m_offset + m_length; i++) {
+        pointObj *point = &line->point[i - m_offset];
+        memcpy(point, &m_xy[i * 2], 2 * sizeof(double));
+        if (m_has_z)
+            point->z = z[i];
+        if (m_has_m)
+            point->m = m[i];
+    }
+}
+
+void GeometryReader::readMultiPoint(shapeObj *shape)
+{
+    readLineString(shape);
+    shape->type = MS_SHAPE_POINT;
+}
+
+void GeometryReader::readLineString(shapeObj *shape)
+{
+    lineObj *line = (lineObj *) malloc(sizeof(lineObj));
+    readLineObj(line);
+    shape->numlines = 1;
+    shape->line = line;
+    shape->type = MS_SHAPE_LINE;
+}
+
+void GeometryReader::readMultiLineString(shapeObj *shape)
+{
+    readPolygon(shape);
+    shape->type = MS_SHAPE_LINE;
+}
+
+void GeometryReader::readPolygon(shapeObj *shape)
+{
+    const auto ends = m_geometry->ends();
+
+    uint32_t nrings = 1;
+    if (ends != nullptr && ends->size() > 1)
+        nrings = ends->size();
+
+    lineObj *line = (lineObj *) malloc(nrings * sizeof(lineObj));
+    if (nrings > 1) {
+        for (uint32_t i = 0; i < nrings; i++) {
+            const auto e = ends->Get(i);
+            m_length = e - m_offset;
+            readLineObj(&line[i]);
+            m_offset = e;
+        }
+    } else {
+        readLineObj(line);
+    }
+    shape->numlines = nrings;
+    shape->line = line;
+    shape->type = MS_SHAPE_POLYGON;
+}
+
+void GeometryReader::readMultiPolygon(shapeObj *shape)
+{
+    const auto parts = m_geometry->parts();
+    lineObj *line = (lineObj *) nullptr;
+    auto numlines = 0;
+    for (size_t i = 0; i < parts->size(); i++) {
+        GeometryReader(m_ctx, parts->Get(i), GeometryType::Polygon).read(shape);
+        lineObj *tmp = line;
+        line = (lineObj *) realloc(line, (numlines + shape->numlines) * sizeof(lineObj));
+        if (!line) {
+            free(tmp);
+            free(shape->line);
+            break;
+        }
+        for (int j = 0; j < shape->numlines; j++)
+            line[numlines + j] = shape->line[j];
+        numlines += shape->numlines;
+        free(shape->line);
+    }
+    shape->line = line;
+    shape->numlines = numlines;
+}
+
+/*void GeometryReader::readGeometryCollection(shapeObj *shape)
+{
+    // TODO
+    return;
+}*/
+
+void GeometryReader::read(shapeObj *shape)
+{
+    // nested types
+    switch (m_geometry_type) {
+        //case GeometryType::GeometryCollection: return readGeometryCollection(shape);
+        case GeometryType::MultiPolygon: return readMultiPolygon(shape);
+        /*case GeometryType::CompoundCurve: return readCompoundCurve();
+        case GeometryType::CurvePolygon: return readCurvePolygon();
+        case GeometryType::MultiCurve: return readMultiCurve();
+        case GeometryType::MultiSurface: return readMultiSurface();
+        case GeometryType::PolyhedralSurface: return readPolyhedralSurface();*/
+        default: break;
+    }
+
+    // if not nested must have geometry data
+    const auto pXy = m_geometry->xy();
+    const auto xySize = pXy->size();
+    m_xy = pXy->data();
+    m_length = xySize / 2;
+
+    switch (m_geometry_type) {
+        case GeometryType::Point: return readPoint(shape);
+        case GeometryType::MultiPoint: return readMultiPoint(shape);
+        case GeometryType::LineString: return readLineString(shape);
+        case GeometryType::MultiLineString: return readMultiLineString(shape);
+        case GeometryType::Polygon: return readPolygon(shape);
+        /*
+        case GeometryType::CircularString: return readSimpleCurve<OGRCircularString>(true);
+        case GeometryType::Triangle: return readTriangle();
+        case GeometryType::TIN: return readTIN();
+        */
+        default: break;
+    }
+}
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/geometryreader.h 8.2.0~beta1-1~exp1/src/flatgeobuf/geometryreader.h
--- 8.0.1-5/src/flatgeobuf/geometryreader.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/geometryreader.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,63 @@
+#ifndef FLATGEOBUF_GEOMETRYREADER_H
+#define FLATGEOBUF_GEOMETRYREADER_H
+
+#include "../../mapserver.h"
+#include "../../maperror.h"
+#include "../../mapprimitive.h"
+
+#include "flatgeobuf_c.h"
+#include "feature_generated.h"
+
+namespace mapserver {
+namespace FlatGeobuf {
+
+class GeometryReader {
+    private:
+        flatgeobuf_ctx *m_ctx;
+        const FlatGeobuf::Geometry *m_geometry;
+        FlatGeobuf::GeometryType m_geometry_type;
+        bool m_has_z;
+        bool m_has_m;
+
+        const double *m_xy = nullptr;
+        uint32_t m_length = 0;
+        uint32_t m_offset = 0;
+
+        void readPoint(shapeObj *);
+        void readMultiPoint(shapeObj *);
+        void readLineString(shapeObj *);
+        void readMultiLineString(shapeObj *);
+        void readPolygon(shapeObj *);
+        void readMultiPolygon(shapeObj *);
+        //void readGeometryCollection(shapeObj *);
+
+        void readLineObj(lineObj *line);
+
+    public:
+        GeometryReader(
+            flatgeobuf_ctx *ctx,
+            const FlatGeobuf::Geometry *geometry) :
+            m_ctx (ctx),
+            m_geometry (geometry),
+            m_geometry_type ((FlatGeobuf::GeometryType) ctx->geometry_type),
+            m_has_z (ctx->has_z),
+            m_has_m (ctx->has_m)
+            { }
+        GeometryReader(
+            flatgeobuf_ctx *ctx,
+            const FlatGeobuf::Geometry *geometry,
+            const FlatGeobuf::GeometryType geometry_type) :
+            m_ctx (ctx),
+            m_geometry (geometry),
+            m_geometry_type (geometry_type),
+            m_has_z (ctx->has_z),
+            m_has_m (ctx->has_m)
+            { }
+        void read(shapeObj *);
+};
+
+}
+}
+
+
+#endif /* FLATGEOBUF_GEOMETRYREADER_H */
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/header_generated.h 8.2.0~beta1-1~exp1/src/flatgeobuf/header_generated.h
--- 8.0.1-5/src/flatgeobuf/header_generated.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/header_generated.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,724 @@
+// automatically generated by the FlatBuffers compiler, do not modify
+
+
+#ifndef FLATBUFFERS_GENERATED_HEADER_FLATGEOBUF_H_
+#define FLATBUFFERS_GENERATED_HEADER_FLATGEOBUF_H_
+
+#include "flatbuffers/flatbuffers.h"
+
+// Ensure the included flatbuffers.h is the same version as when this file was
+// generated, otherwise it may not be compatible.
+static_assert(FLATBUFFERS_VERSION_MAJOR == 2 &&
+              FLATBUFFERS_VERSION_MINOR == 0 &&
+              FLATBUFFERS_VERSION_REVISION == 6,
+             "Non-compatible flatbuffers version included");
+
+namespace mapserver {
+namespace FlatGeobuf {
+
+struct Column;
+struct ColumnBuilder;
+
+struct Crs;
+struct CrsBuilder;
+
+struct Header;
+struct HeaderBuilder;
+
+enum class GeometryType : uint8_t {
+  Unknown = 0,
+  Point = 1,
+  LineString = 2,
+  Polygon = 3,
+  MultiPoint = 4,
+  MultiLineString = 5,
+  MultiPolygon = 6,
+  GeometryCollection = 7,
+  CircularString = 8,
+  CompoundCurve = 9,
+  CurvePolygon = 10,
+  MultiCurve = 11,
+  MultiSurface = 12,
+  Curve = 13,
+  Surface = 14,
+  PolyhedralSurface = 15,
+  TIN = 16,
+  Triangle = 17,
+  MIN = Unknown,
+  MAX = Triangle
+};
+
+inline const GeometryType (&EnumValuesGeometryType())[18] {
+  static const GeometryType values[] = {
+    GeometryType::Unknown,
+    GeometryType::Point,
+    GeometryType::LineString,
+    GeometryType::Polygon,
+    GeometryType::MultiPoint,
+    GeometryType::MultiLineString,
+    GeometryType::MultiPolygon,
+    GeometryType::GeometryCollection,
+    GeometryType::CircularString,
+    GeometryType::CompoundCurve,
+    GeometryType::CurvePolygon,
+    GeometryType::MultiCurve,
+    GeometryType::MultiSurface,
+    GeometryType::Curve,
+    GeometryType::Surface,
+    GeometryType::PolyhedralSurface,
+    GeometryType::TIN,
+    GeometryType::Triangle
+  };
+  return values;
+}
+
+inline const char * const *EnumNamesGeometryType() {
+  static const char * const names[19] = {
+    "Unknown",
+    "Point",
+    "LineString",
+    "Polygon",
+    "MultiPoint",
+    "MultiLineString",
+    "MultiPolygon",
+    "GeometryCollection",
+    "CircularString",
+    "CompoundCurve",
+    "CurvePolygon",
+    "MultiCurve",
+    "MultiSurface",
+    "Curve",
+    "Surface",
+    "PolyhedralSurface",
+    "TIN",
+    "Triangle",
+    nullptr
+  };
+  return names;
+}
+
+inline const char *EnumNameGeometryType(GeometryType e) {
+  if (flatbuffers::IsOutRange(e, GeometryType::Unknown, GeometryType::Triangle)) return "";
+  const size_t index = static_cast<size_t>(e);
+  return EnumNamesGeometryType()[index];
+}
+
+enum class ColumnType : uint8_t {
+  Byte = 0,
+  UByte = 1,
+  Bool = 2,
+  Short = 3,
+  UShort = 4,
+  Int = 5,
+  UInt = 6,
+  Long = 7,
+  ULong = 8,
+  Float = 9,
+  Double = 10,
+  String = 11,
+  Json = 12,
+  DateTime = 13,
+  Binary = 14,
+  MIN = Byte,
+  MAX = Binary
+};
+
+inline const ColumnType (&EnumValuesColumnType())[15] {
+  static const ColumnType values[] = {
+    ColumnType::Byte,
+    ColumnType::UByte,
+    ColumnType::Bool,
+    ColumnType::Short,
+    ColumnType::UShort,
+    ColumnType::Int,
+    ColumnType::UInt,
+    ColumnType::Long,
+    ColumnType::ULong,
+    ColumnType::Float,
+    ColumnType::Double,
+    ColumnType::String,
+    ColumnType::Json,
+    ColumnType::DateTime,
+    ColumnType::Binary
+  };
+  return values;
+}
+
+inline const char * const *EnumNamesColumnType() {
+  static const char * const names[16] = {
+    "Byte",
+    "UByte",
+    "Bool",
+    "Short",
+    "UShort",
+    "Int",
+    "UInt",
+    "Long",
+    "ULong",
+    "Float",
+    "Double",
+    "String",
+    "Json",
+    "DateTime",
+    "Binary",
+    nullptr
+  };
+  return names;
+}
+
+inline const char *EnumNameColumnType(ColumnType e) {
+  if (flatbuffers::IsOutRange(e, ColumnType::Byte, ColumnType::Binary)) return "";
+  const size_t index = static_cast<size_t>(e);
+  return EnumNamesColumnType()[index];
+}
+
+struct Column FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef ColumnBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_TYPE = 6,
+    VT_TITLE = 8,
+    VT_DESCRIPTION = 10,
+    VT_WIDTH = 12,
+    VT_PRECISION = 14,
+    VT_SCALE = 16,
+    VT_NULLABLE = 18,
+    VT_UNIQUE = 20,
+    VT_PRIMARY_KEY = 22,
+    VT_METADATA = 24
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  FlatGeobuf::ColumnType type() const {
+    return static_cast<FlatGeobuf::ColumnType>(GetField<uint8_t>(VT_TYPE, 0));
+  }
+  const flatbuffers::String *title() const {
+    return GetPointer<const flatbuffers::String *>(VT_TITLE);
+  }
+  const flatbuffers::String *description() const {
+    return GetPointer<const flatbuffers::String *>(VT_DESCRIPTION);
+  }
+  int32_t width() const {
+    return GetField<int32_t>(VT_WIDTH, -1);
+  }
+  int32_t precision() const {
+    return GetField<int32_t>(VT_PRECISION, -1);
+  }
+  int32_t scale() const {
+    return GetField<int32_t>(VT_SCALE, -1);
+  }
+  bool nullable() const {
+    return GetField<uint8_t>(VT_NULLABLE, 1) != 0;
+  }
+  bool unique() const {
+    return GetField<uint8_t>(VT_UNIQUE, 0) != 0;
+  }
+  bool primary_key() const {
+    return GetField<uint8_t>(VT_PRIMARY_KEY, 0) != 0;
+  }
+  const flatbuffers::String *metadata() const {
+    return GetPointer<const flatbuffers::String *>(VT_METADATA);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyField<uint8_t>(verifier, VT_TYPE, 1) &&
+           VerifyOffset(verifier, VT_TITLE) &&
+           verifier.VerifyString(title()) &&
+           VerifyOffset(verifier, VT_DESCRIPTION) &&
+           verifier.VerifyString(description()) &&
+           VerifyField<int32_t>(verifier, VT_WIDTH, 4) &&
+           VerifyField<int32_t>(verifier, VT_PRECISION, 4) &&
+           VerifyField<int32_t>(verifier, VT_SCALE, 4) &&
+           VerifyField<uint8_t>(verifier, VT_NULLABLE, 1) &&
+           VerifyField<uint8_t>(verifier, VT_UNIQUE, 1) &&
+           VerifyField<uint8_t>(verifier, VT_PRIMARY_KEY, 1) &&
+           VerifyOffset(verifier, VT_METADATA) &&
+           verifier.VerifyString(metadata()) &&
+           verifier.EndTable();
+  }
+};
+
+struct ColumnBuilder {
+  typedef Column Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(Column::VT_NAME, name);
+  }
+  void add_type(FlatGeobuf::ColumnType type) {
+    fbb_.AddElement<uint8_t>(Column::VT_TYPE, static_cast<uint8_t>(type), 0);
+  }
+  void add_title(flatbuffers::Offset<flatbuffers::String> title) {
+    fbb_.AddOffset(Column::VT_TITLE, title);
+  }
+  void add_description(flatbuffers::Offset<flatbuffers::String> description) {
+    fbb_.AddOffset(Column::VT_DESCRIPTION, description);
+  }
+  void add_width(int32_t width) {
+    fbb_.AddElement<int32_t>(Column::VT_WIDTH, width, -1);
+  }
+  void add_precision(int32_t precision) {
+    fbb_.AddElement<int32_t>(Column::VT_PRECISION, precision, -1);
+  }
+  void add_scale(int32_t scale) {
+    fbb_.AddElement<int32_t>(Column::VT_SCALE, scale, -1);
+  }
+  void add_nullable(bool nullable) {
+    fbb_.AddElement<uint8_t>(Column::VT_NULLABLE, static_cast<uint8_t>(nullable), 1);
+  }
+  void add_unique(bool unique) {
+    fbb_.AddElement<uint8_t>(Column::VT_UNIQUE, static_cast<uint8_t>(unique), 0);
+  }
+  void add_primary_key(bool primary_key) {
+    fbb_.AddElement<uint8_t>(Column::VT_PRIMARY_KEY, static_cast<uint8_t>(primary_key), 0);
+  }
+  void add_metadata(flatbuffers::Offset<flatbuffers::String> metadata) {
+    fbb_.AddOffset(Column::VT_METADATA, metadata);
+  }
+  explicit ColumnBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Column> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Column>(end);
+    fbb_.Required(o, Column::VT_NAME);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Column> CreateColumn(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    FlatGeobuf::ColumnType type = FlatGeobuf::ColumnType::Byte,
+    flatbuffers::Offset<flatbuffers::String> title = 0,
+    flatbuffers::Offset<flatbuffers::String> description = 0,
+    int32_t width = -1,
+    int32_t precision = -1,
+    int32_t scale = -1,
+    bool nullable = true,
+    bool unique = false,
+    bool primary_key = false,
+    flatbuffers::Offset<flatbuffers::String> metadata = 0) {
+  ColumnBuilder builder_(_fbb);
+  builder_.add_metadata(metadata);
+  builder_.add_scale(scale);
+  builder_.add_precision(precision);
+  builder_.add_width(width);
+  builder_.add_description(description);
+  builder_.add_title(title);
+  builder_.add_name(name);
+  builder_.add_primary_key(primary_key);
+  builder_.add_unique(unique);
+  builder_.add_nullable(nullable);
+  builder_.add_type(type);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Column> CreateColumnDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    FlatGeobuf::ColumnType type = FlatGeobuf::ColumnType::Byte,
+    const char *title = nullptr,
+    const char *description = nullptr,
+    int32_t width = -1,
+    int32_t precision = -1,
+    int32_t scale = -1,
+    bool nullable = true,
+    bool unique = false,
+    bool primary_key = false,
+    const char *metadata = nullptr) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto title__ = title ? _fbb.CreateString(title) : 0;
+  auto description__ = description ? _fbb.CreateString(description) : 0;
+  auto metadata__ = metadata ? _fbb.CreateString(metadata) : 0;
+  return FlatGeobuf::CreateColumn(
+      _fbb,
+      name__,
+      type,
+      title__,
+      description__,
+      width,
+      precision,
+      scale,
+      nullable,
+      unique,
+      primary_key,
+      metadata__);
+}
+
+struct Crs FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef CrsBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_ORG = 4,
+    VT_CODE = 6,
+    VT_NAME = 8,
+    VT_DESCRIPTION = 10,
+    VT_WKT = 12,
+    VT_CODE_STRING = 14
+  };
+  const flatbuffers::String *org() const {
+    return GetPointer<const flatbuffers::String *>(VT_ORG);
+  }
+  int32_t code() const {
+    return GetField<int32_t>(VT_CODE, 0);
+  }
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  const flatbuffers::String *description() const {
+    return GetPointer<const flatbuffers::String *>(VT_DESCRIPTION);
+  }
+  const flatbuffers::String *wkt() const {
+    return GetPointer<const flatbuffers::String *>(VT_WKT);
+  }
+  const flatbuffers::String *code_string() const {
+    return GetPointer<const flatbuffers::String *>(VT_CODE_STRING);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffset(verifier, VT_ORG) &&
+           verifier.VerifyString(org()) &&
+           VerifyField<int32_t>(verifier, VT_CODE, 4) &&
+           VerifyOffset(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyOffset(verifier, VT_DESCRIPTION) &&
+           verifier.VerifyString(description()) &&
+           VerifyOffset(verifier, VT_WKT) &&
+           verifier.VerifyString(wkt()) &&
+           VerifyOffset(verifier, VT_CODE_STRING) &&
+           verifier.VerifyString(code_string()) &&
+           verifier.EndTable();
+  }
+};
+
+struct CrsBuilder {
+  typedef Crs Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_org(flatbuffers::Offset<flatbuffers::String> org) {
+    fbb_.AddOffset(Crs::VT_ORG, org);
+  }
+  void add_code(int32_t code) {
+    fbb_.AddElement<int32_t>(Crs::VT_CODE, code, 0);
+  }
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(Crs::VT_NAME, name);
+  }
+  void add_description(flatbuffers::Offset<flatbuffers::String> description) {
+    fbb_.AddOffset(Crs::VT_DESCRIPTION, description);
+  }
+  void add_wkt(flatbuffers::Offset<flatbuffers::String> wkt) {
+    fbb_.AddOffset(Crs::VT_WKT, wkt);
+  }
+  void add_code_string(flatbuffers::Offset<flatbuffers::String> code_string) {
+    fbb_.AddOffset(Crs::VT_CODE_STRING, code_string);
+  }
+  explicit CrsBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Crs> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Crs>(end);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Crs> CreateCrs(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> org = 0,
+    int32_t code = 0,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    flatbuffers::Offset<flatbuffers::String> description = 0,
+    flatbuffers::Offset<flatbuffers::String> wkt = 0,
+    flatbuffers::Offset<flatbuffers::String> code_string = 0) {
+  CrsBuilder builder_(_fbb);
+  builder_.add_code_string(code_string);
+  builder_.add_wkt(wkt);
+  builder_.add_description(description);
+  builder_.add_name(name);
+  builder_.add_code(code);
+  builder_.add_org(org);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Crs> CreateCrsDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *org = nullptr,
+    int32_t code = 0,
+    const char *name = nullptr,
+    const char *description = nullptr,
+    const char *wkt = nullptr,
+    const char *code_string = nullptr) {
+  auto org__ = org ? _fbb.CreateString(org) : 0;
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto description__ = description ? _fbb.CreateString(description) : 0;
+  auto wkt__ = wkt ? _fbb.CreateString(wkt) : 0;
+  auto code_string__ = code_string ? _fbb.CreateString(code_string) : 0;
+  return FlatGeobuf::CreateCrs(
+      _fbb,
+      org__,
+      code,
+      name__,
+      description__,
+      wkt__,
+      code_string__);
+}
+
+struct Header FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef HeaderBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_ENVELOPE = 6,
+    VT_GEOMETRY_TYPE = 8,
+    VT_HAS_Z = 10,
+    VT_HAS_M = 12,
+    VT_HAS_T = 14,
+    VT_HAS_TM = 16,
+    VT_COLUMNS = 18,
+    VT_FEATURES_COUNT = 20,
+    VT_INDEX_NODE_SIZE = 22,
+    VT_CRS = 24,
+    VT_TITLE = 26,
+    VT_DESCRIPTION = 28,
+    VT_METADATA = 30
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  const flatbuffers::Vector<double> *envelope() const {
+    return GetPointer<const flatbuffers::Vector<double> *>(VT_ENVELOPE);
+  }
+  FlatGeobuf::GeometryType geometry_type() const {
+    return static_cast<FlatGeobuf::GeometryType>(GetField<uint8_t>(VT_GEOMETRY_TYPE, 0));
+  }
+  bool has_z() const {
+    return GetField<uint8_t>(VT_HAS_Z, 0) != 0;
+  }
+  bool has_m() const {
+    return GetField<uint8_t>(VT_HAS_M, 0) != 0;
+  }
+  bool has_t() const {
+    return GetField<uint8_t>(VT_HAS_T, 0) != 0;
+  }
+  bool has_tm() const {
+    return GetField<uint8_t>(VT_HAS_TM, 0) != 0;
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>> *>(VT_COLUMNS);
+  }
+  uint64_t features_count() const {
+    return GetField<uint64_t>(VT_FEATURES_COUNT, 0);
+  }
+  uint16_t index_node_size() const {
+    return GetField<uint16_t>(VT_INDEX_NODE_SIZE, 16);
+  }
+  const FlatGeobuf::Crs *crs() const {
+    return GetPointer<const FlatGeobuf::Crs *>(VT_CRS);
+  }
+  const flatbuffers::String *title() const {
+    return GetPointer<const flatbuffers::String *>(VT_TITLE);
+  }
+  const flatbuffers::String *description() const {
+    return GetPointer<const flatbuffers::String *>(VT_DESCRIPTION);
+  }
+  const flatbuffers::String *metadata() const {
+    return GetPointer<const flatbuffers::String *>(VT_METADATA);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffset(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyOffset(verifier, VT_ENVELOPE) &&
+           verifier.VerifyVector(envelope()) &&
+           VerifyField<uint8_t>(verifier, VT_GEOMETRY_TYPE, 1) &&
+           VerifyField<uint8_t>(verifier, VT_HAS_Z, 1) &&
+           VerifyField<uint8_t>(verifier, VT_HAS_M, 1) &&
+           VerifyField<uint8_t>(verifier, VT_HAS_T, 1) &&
+           VerifyField<uint8_t>(verifier, VT_HAS_TM, 1) &&
+           VerifyOffset(verifier, VT_COLUMNS) &&
+           verifier.VerifyVector(columns()) &&
+           verifier.VerifyVectorOfTables(columns()) &&
+           VerifyField<uint64_t>(verifier, VT_FEATURES_COUNT, 8) &&
+           VerifyField<uint16_t>(verifier, VT_INDEX_NODE_SIZE, 2) &&
+           VerifyOffset(verifier, VT_CRS) &&
+           verifier.VerifyTable(crs()) &&
+           VerifyOffset(verifier, VT_TITLE) &&
+           verifier.VerifyString(title()) &&
+           VerifyOffset(verifier, VT_DESCRIPTION) &&
+           verifier.VerifyString(description()) &&
+           VerifyOffset(verifier, VT_METADATA) &&
+           verifier.VerifyString(metadata()) &&
+           verifier.EndTable();
+  }
+};
+
+struct HeaderBuilder {
+  typedef Header Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(Header::VT_NAME, name);
+  }
+  void add_envelope(flatbuffers::Offset<flatbuffers::Vector<double>> envelope) {
+    fbb_.AddOffset(Header::VT_ENVELOPE, envelope);
+  }
+  void add_geometry_type(FlatGeobuf::GeometryType geometry_type) {
+    fbb_.AddElement<uint8_t>(Header::VT_GEOMETRY_TYPE, static_cast<uint8_t>(geometry_type), 0);
+  }
+  void add_has_z(bool has_z) {
+    fbb_.AddElement<uint8_t>(Header::VT_HAS_Z, static_cast<uint8_t>(has_z), 0);
+  }
+  void add_has_m(bool has_m) {
+    fbb_.AddElement<uint8_t>(Header::VT_HAS_M, static_cast<uint8_t>(has_m), 0);
+  }
+  void add_has_t(bool has_t) {
+    fbb_.AddElement<uint8_t>(Header::VT_HAS_T, static_cast<uint8_t>(has_t), 0);
+  }
+  void add_has_tm(bool has_tm) {
+    fbb_.AddElement<uint8_t>(Header::VT_HAS_TM, static_cast<uint8_t>(has_tm), 0);
+  }
+  void add_columns(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns) {
+    fbb_.AddOffset(Header::VT_COLUMNS, columns);
+  }
+  void add_features_count(uint64_t features_count) {
+    fbb_.AddElement<uint64_t>(Header::VT_FEATURES_COUNT, features_count, 0);
+  }
+  void add_index_node_size(uint16_t index_node_size) {
+    fbb_.AddElement<uint16_t>(Header::VT_INDEX_NODE_SIZE, index_node_size, 16);
+  }
+  void add_crs(flatbuffers::Offset<FlatGeobuf::Crs> crs) {
+    fbb_.AddOffset(Header::VT_CRS, crs);
+  }
+  void add_title(flatbuffers::Offset<flatbuffers::String> title) {
+    fbb_.AddOffset(Header::VT_TITLE, title);
+  }
+  void add_description(flatbuffers::Offset<flatbuffers::String> description) {
+    fbb_.AddOffset(Header::VT_DESCRIPTION, description);
+  }
+  void add_metadata(flatbuffers::Offset<flatbuffers::String> metadata) {
+    fbb_.AddOffset(Header::VT_METADATA, metadata);
+  }
+  explicit HeaderBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Header> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Header>(end);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Header> CreateHeader(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    flatbuffers::Offset<flatbuffers::Vector<double>> envelope = 0,
+    FlatGeobuf::GeometryType geometry_type = FlatGeobuf::GeometryType::Unknown,
+    bool has_z = false,
+    bool has_m = false,
+    bool has_t = false,
+    bool has_tm = false,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<FlatGeobuf::Column>>> columns = 0,
+    uint64_t features_count = 0,
+    uint16_t index_node_size = 16,
+    flatbuffers::Offset<FlatGeobuf::Crs> crs = 0,
+    flatbuffers::Offset<flatbuffers::String> title = 0,
+    flatbuffers::Offset<flatbuffers::String> description = 0,
+    flatbuffers::Offset<flatbuffers::String> metadata = 0) {
+  HeaderBuilder builder_(_fbb);
+  builder_.add_features_count(features_count);
+  builder_.add_metadata(metadata);
+  builder_.add_description(description);
+  builder_.add_title(title);
+  builder_.add_crs(crs);
+  builder_.add_columns(columns);
+  builder_.add_envelope(envelope);
+  builder_.add_name(name);
+  builder_.add_index_node_size(index_node_size);
+  builder_.add_has_tm(has_tm);
+  builder_.add_has_t(has_t);
+  builder_.add_has_m(has_m);
+  builder_.add_has_z(has_z);
+  builder_.add_geometry_type(geometry_type);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Header> CreateHeaderDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    const std::vector<double> *envelope = nullptr,
+    FlatGeobuf::GeometryType geometry_type = FlatGeobuf::GeometryType::Unknown,
+    bool has_z = false,
+    bool has_m = false,
+    bool has_t = false,
+    bool has_tm = false,
+    const std::vector<flatbuffers::Offset<FlatGeobuf::Column>> *columns = nullptr,
+    uint64_t features_count = 0,
+    uint16_t index_node_size = 16,
+    flatbuffers::Offset<FlatGeobuf::Crs> crs = 0,
+    const char *title = nullptr,
+    const char *description = nullptr,
+    const char *metadata = nullptr) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto envelope__ = envelope ? _fbb.CreateVector<double>(*envelope) : 0;
+  auto columns__ = columns ? _fbb.CreateVector<flatbuffers::Offset<FlatGeobuf::Column>>(*columns) : 0;
+  auto title__ = title ? _fbb.CreateString(title) : 0;
+  auto description__ = description ? _fbb.CreateString(description) : 0;
+  auto metadata__ = metadata ? _fbb.CreateString(metadata) : 0;
+  return FlatGeobuf::CreateHeader(
+      _fbb,
+      name__,
+      envelope__,
+      geometry_type,
+      has_z,
+      has_m,
+      has_t,
+      has_tm,
+      columns__,
+      features_count,
+      index_node_size,
+      crs,
+      title__,
+      description__,
+      metadata__);
+}
+
+inline const FlatGeobuf::Header *GetHeader(const void *buf) {
+  return flatbuffers::GetRoot<FlatGeobuf::Header>(buf);
+}
+
+inline const FlatGeobuf::Header *GetSizePrefixedHeader(const void *buf) {
+  return flatbuffers::GetSizePrefixedRoot<FlatGeobuf::Header>(buf);
+}
+
+inline bool VerifyHeaderBuffer(
+    flatbuffers::Verifier &verifier) {
+  return verifier.VerifyBuffer<FlatGeobuf::Header>(nullptr);
+}
+
+inline bool VerifySizePrefixedHeaderBuffer(
+    flatbuffers::Verifier &verifier) {
+  return verifier.VerifySizePrefixedBuffer<FlatGeobuf::Header>(nullptr);
+}
+
+inline void FinishHeaderBuffer(
+    flatbuffers::FlatBufferBuilder &fbb,
+    flatbuffers::Offset<FlatGeobuf::Header> root) {
+  fbb.Finish(root);
+}
+
+inline void FinishSizePrefixedHeaderBuffer(
+    flatbuffers::FlatBufferBuilder &fbb,
+    flatbuffers::Offset<FlatGeobuf::Header> root) {
+  fbb.FinishSizePrefixed(root);
+}
+
+}  // namespace FlatGeobuf
+}
+
+#endif  // FLATBUFFERS_GENERATED_HEADER_FLATGEOBUF_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/LICENSE 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/LICENSE
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/LICENSE	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/LICENSE	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,203 @@
+
+                                 Apache License
+                           Version 2.0, January 2004
+                        http://www.apache.org/licenses/
+
+   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
+
+   1. Definitions.
+
+      "License" shall mean the terms and conditions for use, reproduction,
+      and distribution as defined by Sections 1 through 9 of this document.
+
+      "Licensor" shall mean the copyright owner or entity authorized by
+      the copyright owner that is granting the License.
+
+      "Legal Entity" shall mean the union of the acting entity and all
+      other entities that control, are controlled by, or are under common
+      control with that entity. For the purposes of this definition,
+      "control" means (i) the power, direct or indirect, to cause the
+      direction or management of such entity, whether by contract or
+      otherwise, or (ii) ownership of fifty percent (50%) or more of the
+      outstanding shares, or (iii) beneficial ownership of such entity.
+
+      "You" (or "Your") shall mean an individual or Legal Entity
+      exercising permissions granted by this License.
+
+      "Source" form shall mean the preferred form for making modifications,
+      including but not limited to software source code, documentation
+      source, and configuration files.
+
+      "Object" form shall mean any form resulting from mechanical
+      transformation or translation of a Source form, including but
+      not limited to compiled object code, generated documentation,
+      and conversions to other media types.
+
+      "Work" shall mean the work of authorship, whether in Source or
+      Object form, made available under the License, as indicated by a
+      copyright notice that is included in or attached to the work
+      (an example is provided in the Appendix below).
+
+      "Derivative Works" shall mean any work, whether in Source or Object
+      form, that is based on (or derived from) the Work and for which the
+      editorial revisions, annotations, elaborations, or other modifications
+      represent, as a whole, an original work of authorship. For the purposes
+      of this License, Derivative Works shall not include works that remain
+      separable from, or merely link (or bind by name) to the interfaces of,
+      the Work and Derivative Works thereof.
+
+      "Contribution" shall mean any work of authorship, including
+      the original version of the Work and any modifications or additions
+      to that Work or Derivative Works thereof, that is intentionally
+      submitted to Licensor for inclusion in the Work by the copyright owner
+      or by an individual or Legal Entity authorized to submit on behalf of
+      the copyright owner. For the purposes of this definition, "submitted"
+      means any form of electronic, verbal, or written communication sent
+      to the Licensor or its representatives, including but not limited to
+      communication on electronic mailing lists, source code control systems,
+      and issue tracking systems that are managed by, or on behalf of, the
+      Licensor for the purpose of discussing and improving the Work, but
+      excluding communication that is conspicuously marked or otherwise
+      designated in writing by the copyright owner as "Not a Contribution."
+
+      "Contributor" shall mean Licensor and any individual or Legal Entity
+      on behalf of whom a Contribution has been received by Licensor and
+      subsequently incorporated within the Work.
+
+   2. Grant of Copyright License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      copyright license to reproduce, prepare Derivative Works of,
+      publicly display, publicly perform, sublicense, and distribute the
+      Work and such Derivative Works in Source or Object form.
+
+   3. Grant of Patent License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      (except as stated in this section) patent license to make, have made,
+      use, offer to sell, sell, import, and otherwise transfer the Work,
+      where such license applies only to those patent claims licensable
+      by such Contributor that are necessarily infringed by their
+      Contribution(s) alone or by combination of their Contribution(s)
+      with the Work to which such Contribution(s) was submitted. If You
+      institute patent litigation against any entity (including a
+      cross-claim or counterclaim in a lawsuit) alleging that the Work
+      or a Contribution incorporated within the Work constitutes direct
+      or contributory patent infringement, then any patent licenses
+      granted to You under this License for that Work shall terminate
+      as of the date such litigation is filed.
+
+   4. Redistribution. You may reproduce and distribute copies of the
+      Work or Derivative Works thereof in any medium, with or without
+      modifications, and in Source or Object form, provided that You
+      meet the following conditions:
+
+      (a) You must give any other recipients of the Work or
+          Derivative Works a copy of this License; and
+
+      (b) You must cause any modified files to carry prominent notices
+          stating that You changed the files; and
+
+      (c) You must retain, in the Source form of any Derivative Works
+          that You distribute, all copyright, patent, trademark, and
+          attribution notices from the Source form of the Work,
+          excluding those notices that do not pertain to any part of
+          the Derivative Works; and
+
+      (d) If the Work includes a "NOTICE" text file as part of its
+          distribution, then any Derivative Works that You distribute must
+          include a readable copy of the attribution notices contained
+          within such NOTICE file, excluding those notices that do not
+          pertain to any part of the Derivative Works, in at least one
+          of the following places: within a NOTICE text file distributed
+          as part of the Derivative Works; within the Source form or
+          documentation, if provided along with the Derivative Works; or,
+          within a display generated by the Derivative Works, if and
+          wherever such third-party notices normally appear. The contents
+          of the NOTICE file are for informational purposes only and
+          do not modify the License. You may add Your own attribution
+          notices within Derivative Works that You distribute, alongside
+          or as an addendum to the NOTICE text from the Work, provided
+          that such additional attribution notices cannot be construed
+          as modifying the License.
+
+      You may add Your own copyright statement to Your modifications and
+      may provide additional or different license terms and conditions
+      for use, reproduction, or distribution of Your modifications, or
+      for any such Derivative Works as a whole, provided Your use,
+      reproduction, and distribution of the Work otherwise complies with
+      the conditions stated in this License.
+
+   5. Submission of Contributions. Unless You explicitly state otherwise,
+      any Contribution intentionally submitted for inclusion in the Work
+      by You to the Licensor shall be under the terms and conditions of
+      this License, without any additional terms or conditions.
+      Notwithstanding the above, nothing herein shall supersede or modify
+      the terms of any separate license agreement you may have executed
+      with Licensor regarding such Contributions.
+
+   6. Trademarks. This License does not grant permission to use the trade
+      names, trademarks, service marks, or product names of the Licensor,
+      except as required for reasonable and customary use in describing the
+      origin of the Work and reproducing the content of the NOTICE file.
+
+   7. Disclaimer of Warranty. Unless required by applicable law or
+      agreed to in writing, Licensor provides the Work (and each
+      Contributor provides its Contributions) on an "AS IS" BASIS,
+      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+      implied, including, without limitation, any warranties or conditions
+      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
+      PARTICULAR PURPOSE. You are solely responsible for determining the
+      appropriateness of using or redistributing the Work and assume any
+      risks associated with Your exercise of permissions under this License.
+
+   8. Limitation of Liability. In no event and under no legal theory,
+      whether in tort (including negligence), contract, or otherwise,
+      unless required by applicable law (such as deliberate and grossly
+      negligent acts) or agreed to in writing, shall any Contributor be
+      liable to You for damages, including any direct, indirect, special,
+      incidental, or consequential damages of any character arising as a
+      result of this License or out of the use or inability to use the
+      Work (including but not limited to damages for loss of goodwill,
+      work stoppage, computer failure or malfunction, or any and all
+      other commercial damages or losses), even if such Contributor
+      has been advised of the possibility of such damages.
+
+   9. Accepting Warranty or Additional Liability. While redistributing
+      the Work or Derivative Works thereof, You may choose to offer,
+      and charge a fee for, acceptance of support, warranty, indemnity,
+      or other liability obligations and/or rights consistent with this
+      License. However, in accepting such obligations, You may act only
+      on Your own behalf and on Your sole responsibility, not on behalf
+      of any other Contributor, and only if You agree to indemnify,
+      defend, and hold each Contributor harmless for any liability
+      incurred by, or claims asserted against, such Contributor by reason
+      of your accepting any such warranty or additional liability.
+
+   END OF TERMS AND CONDITIONS
+
+   APPENDIX: How to apply the Apache License to your work.
+
+      To apply the Apache License to your work, attach the following
+      boilerplate notice, with the fields enclosed by brackets "[]"
+      replaced with your own identifying information. (Don't include
+      the brackets!)  The text should be enclosed in the appropriate
+      comment syntax for the file format. We also recommend that a
+      file or class name and description of purpose be included on the
+      same "printed page" as the copyright notice for easier
+      identification within third-party archives.
+
+   Copyright 2014 Google Inc.
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
+
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/allocator.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/allocator.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/allocator.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/allocator.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,70 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_ALLOCATOR_H_
+#define FLATBUFFERS_ALLOCATOR_H_
+
+#include "flatbuffers/base.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Allocator interface. This is flatbuffers-specific and meant only for
+// `vector_downward` usage.
+class Allocator {
+ public:
+  virtual ~Allocator() {}
+
+  // Allocate `size` bytes of memory.
+  virtual uint8_t *allocate(size_t size) = 0;
+
+  // Deallocate `size` bytes of memory at `p` allocated by this allocator.
+  virtual void deallocate(uint8_t *p, size_t size) = 0;
+
+  // Reallocate `new_size` bytes of memory, replacing the old region of size
+  // `old_size` at `p`. In contrast to a normal realloc, this grows downwards,
+  // and is intended specifcally for `vector_downward` use.
+  // `in_use_back` and `in_use_front` indicate how much of `old_size` is
+  // actually in use at each end, and needs to be copied.
+  virtual uint8_t *reallocate_downward(uint8_t *old_p, size_t old_size,
+                                       size_t new_size, size_t in_use_back,
+                                       size_t in_use_front) {
+    FLATBUFFERS_ASSERT(new_size > old_size);  // vector_downward only grows
+    uint8_t *new_p = allocate(new_size);
+    memcpy_downward(old_p, old_size, new_p, new_size, in_use_back,
+                    in_use_front);
+    deallocate(old_p, old_size);
+    return new_p;
+  }
+
+ protected:
+  // Called by `reallocate_downward` to copy memory from `old_p` of `old_size`
+  // to `new_p` of `new_size`. Only memory of size `in_use_front` and
+  // `in_use_back` will be copied from the front and back of the old memory
+  // allocation.
+  void memcpy_downward(uint8_t *old_p, size_t old_size, uint8_t *new_p,
+                       size_t new_size, size_t in_use_back,
+                       size_t in_use_front) {
+    memcpy(new_p + new_size - in_use_back, old_p + old_size - in_use_back,
+           in_use_back);
+    memcpy(new_p, old_p, in_use_front);
+  }
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_ALLOCATOR_H_
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/array.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/array.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/array.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/array.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,245 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_ARRAY_H_
+#define FLATBUFFERS_ARRAY_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/stl_emulation.h"
+#include "flatbuffers/vector.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// This is used as a helper type for accessing arrays.
+template<typename T, uint16_t length> class Array {
+  // Array<T> can carry only POD data types (scalars or structs).
+  typedef typename flatbuffers::bool_constant<flatbuffers::is_scalar<T>::value>
+      scalar_tag;
+  typedef
+      typename flatbuffers::conditional<scalar_tag::value, T, const T *>::type
+          IndirectHelperType;
+
+ public:
+  typedef uint16_t size_type;
+  typedef typename IndirectHelper<IndirectHelperType>::return_type return_type;
+  typedef VectorIterator<T, return_type> const_iterator;
+  typedef VectorReverseIterator<const_iterator> const_reverse_iterator;
+
+  // If T is a LE-scalar or a struct (!scalar_tag::value).
+  static FLATBUFFERS_CONSTEXPR bool is_span_observable =
+      (scalar_tag::value && (FLATBUFFERS_LITTLEENDIAN || sizeof(T) == 1)) ||
+      !scalar_tag::value;
+
+  FLATBUFFERS_CONSTEXPR uint16_t size() const { return length; }
+
+  return_type Get(uoffset_t i) const {
+    FLATBUFFERS_ASSERT(i < size());
+    return IndirectHelper<IndirectHelperType>::Read(Data(), i);
+  }
+
+  return_type operator[](uoffset_t i) const { return Get(i); }
+
+  // If this is a Vector of enums, T will be its storage type, not the enum
+  // type. This function makes it convenient to retrieve value with enum
+  // type E.
+  template<typename E> E GetEnum(uoffset_t i) const {
+    return static_cast<E>(Get(i));
+  }
+
+  const_iterator begin() const { return const_iterator(Data(), 0); }
+  const_iterator end() const { return const_iterator(Data(), size()); }
+
+  const_reverse_iterator rbegin() const {
+    return const_reverse_iterator(end());
+  }
+  const_reverse_iterator rend() const {
+    return const_reverse_iterator(begin());
+  }
+
+  const_iterator cbegin() const { return begin(); }
+  const_iterator cend() const { return end(); }
+
+  const_reverse_iterator crbegin() const { return rbegin(); }
+  const_reverse_iterator crend() const { return rend(); }
+
+  // Get a mutable pointer to elements inside this array.
+  // This method used to mutate arrays of structs followed by a @p Mutate
+  // operation. For primitive types use @p Mutate directly.
+  // @warning Assignments and reads to/from the dereferenced pointer are not
+  //  automatically converted to the correct endianness.
+  typename flatbuffers::conditional<scalar_tag::value, void, T *>::type
+  GetMutablePointer(uoffset_t i) const {
+    FLATBUFFERS_ASSERT(i < size());
+    return const_cast<T *>(&data()[i]);
+  }
+
+  // Change elements if you have a non-const pointer to this object.
+  void Mutate(uoffset_t i, const T &val) { MutateImpl(scalar_tag(), i, val); }
+
+  // The raw data in little endian format. Use with care.
+  const uint8_t *Data() const { return data_; }
+
+  uint8_t *Data() { return data_; }
+
+  // Similarly, but typed, much like std::vector::data
+  const T *data() const { return reinterpret_cast<const T *>(Data()); }
+  T *data() { return reinterpret_cast<T *>(Data()); }
+
+  // Copy data from a span with endian conversion.
+  // If this Array and the span overlap, the behavior is undefined.
+  void CopyFromSpan(flatbuffers::span<const T, length> src) {
+    const auto p1 = reinterpret_cast<const uint8_t *>(src.data());
+    const auto p2 = Data();
+    FLATBUFFERS_ASSERT(!(p1 >= p2 && p1 < (p2 + length)) &&
+                       !(p2 >= p1 && p2 < (p1 + length)));
+    (void)p1;
+    (void)p2;
+    CopyFromSpanImpl(flatbuffers::bool_constant<is_span_observable>(), src);
+  }
+
+ protected:
+  void MutateImpl(flatbuffers::true_type, uoffset_t i, const T &val) {
+    FLATBUFFERS_ASSERT(i < size());
+    WriteScalar(data() + i, val);
+  }
+
+  void MutateImpl(flatbuffers::false_type, uoffset_t i, const T &val) {
+    *(GetMutablePointer(i)) = val;
+  }
+
+  void CopyFromSpanImpl(flatbuffers::true_type,
+                        flatbuffers::span<const T, length> src) {
+    // Use std::memcpy() instead of std::copy() to avoid performance degradation
+    // due to aliasing if T is char or unsigned char.
+    // The size is known at compile time, so memcpy would be inlined.
+    std::memcpy(data(), src.data(), length * sizeof(T));
+  }
+
+  // Copy data from flatbuffers::span with endian conversion.
+  void CopyFromSpanImpl(flatbuffers::false_type,
+                        flatbuffers::span<const T, length> src) {
+    for (size_type k = 0; k < length; k++) { Mutate(k, src[k]); }
+  }
+
+  // This class is only used to access pre-existing data. Don't ever
+  // try to construct these manually.
+  // 'constexpr' allows us to use 'size()' at compile time.
+  // @note Must not use 'FLATBUFFERS_CONSTEXPR' here, as const is not allowed on
+  //  a constructor.
+#if defined(__cpp_constexpr)
+  constexpr Array();
+#else
+  Array();
+#endif
+
+  uint8_t data_[length * sizeof(T)];
+
+ private:
+  // This class is a pointer. Copying will therefore create an invalid object.
+  // Private and unimplemented copy constructor.
+  Array(const Array &);
+  Array &operator=(const Array &);
+};
+
+// Specialization for Array[struct] with access using Offset<void> pointer.
+// This specialization used by idl_gen_text.cpp.
+template<typename T, uint16_t length> class Array<Offset<T>, length> {
+  static_assert(flatbuffers::is_same<T, void>::value, "unexpected type T");
+
+ public:
+  typedef const void *return_type;
+
+  const uint8_t *Data() const { return data_; }
+
+  // Make idl_gen_text.cpp::PrintContainer happy.
+  return_type operator[](uoffset_t) const {
+    FLATBUFFERS_ASSERT(false);
+    return nullptr;
+  }
+
+ private:
+  // This class is only used to access pre-existing data.
+  Array();
+  Array(const Array &);
+  Array &operator=(const Array &);
+
+  uint8_t data_[1];
+};
+
+template<class U, uint16_t N>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<U, N> make_span(Array<U, N> &arr)
+    FLATBUFFERS_NOEXCEPT {
+  static_assert(
+      Array<U, N>::is_span_observable,
+      "wrong type U, only plain struct, LE-scalar, or byte types are allowed");
+  return span<U, N>(arr.data(), N);
+}
+
+template<class U, uint16_t N>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const U, N> make_span(
+    const Array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
+  static_assert(
+      Array<U, N>::is_span_observable,
+      "wrong type U, only plain struct, LE-scalar, or byte types are allowed");
+  return span<const U, N>(arr.data(), N);
+}
+
+template<class U, uint16_t N>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<uint8_t, sizeof(U) * N>
+make_bytes_span(Array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
+  static_assert(Array<U, N>::is_span_observable,
+                "internal error, Array<T> might hold only scalars or structs");
+  return span<uint8_t, sizeof(U) * N>(arr.Data(), sizeof(U) * N);
+}
+
+template<class U, uint16_t N>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const uint8_t, sizeof(U) * N>
+make_bytes_span(const Array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
+  static_assert(Array<U, N>::is_span_observable,
+                "internal error, Array<T> might hold only scalars or structs");
+  return span<const uint8_t, sizeof(U) * N>(arr.Data(), sizeof(U) * N);
+}
+
+// Cast a raw T[length] to a raw flatbuffers::Array<T, length>
+// without endian conversion. Use with care.
+// TODO: move these Cast-methods to `internal` namespace.
+template<typename T, uint16_t length>
+Array<T, length> &CastToArray(T (&arr)[length]) {
+  return *reinterpret_cast<Array<T, length> *>(arr);
+}
+
+template<typename T, uint16_t length>
+const Array<T, length> &CastToArray(const T (&arr)[length]) {
+  return *reinterpret_cast<const Array<T, length> *>(arr);
+}
+
+template<typename E, typename T, uint16_t length>
+Array<E, length> &CastToArrayOfEnum(T (&arr)[length]) {
+  static_assert(sizeof(E) == sizeof(T), "invalid enum type E");
+  return *reinterpret_cast<Array<E, length> *>(arr);
+}
+
+template<typename E, typename T, uint16_t length>
+const Array<E, length> &CastToArrayOfEnum(const T (&arr)[length]) {
+  static_assert(sizeof(E) == sizeof(T), "invalid enum type E");
+  return *reinterpret_cast<const Array<E, length> *>(arr);
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_ARRAY_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/base.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/base.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/base.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/base.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,482 @@
+#ifndef FLATBUFFERS_BASE_H_
+#define FLATBUFFERS_BASE_H_
+
+// clang-format off
+
+// If activate should be declared and included first.
+#if defined(FLATBUFFERS_MEMORY_LEAK_TRACKING) && \
+    defined(_MSC_VER) && defined(_DEBUG)
+  // The _CRTDBG_MAP_ALLOC inside <crtdbg.h> will replace
+  // calloc/free (etc) to its debug version using #define directives.
+  #define _CRTDBG_MAP_ALLOC
+  #include <stdlib.h>
+  #include <crtdbg.h>
+  // Replace operator new by trace-enabled version.
+  #define DEBUG_NEW new(_NORMAL_BLOCK, __FILE__, __LINE__)
+  #define new DEBUG_NEW
+#endif
+
+#if !defined(FLATBUFFERS_ASSERT)
+#include <assert.h>
+#define FLATBUFFERS_ASSERT assert
+#elif defined(FLATBUFFERS_ASSERT_INCLUDE)
+// Include file with forward declaration
+#include FLATBUFFERS_ASSERT_INCLUDE
+#endif
+
+#ifndef ARDUINO
+#include <cstdint>
+#endif
+
+#include <cstddef>
+#include <cstdlib>
+#include <cstring>
+
+#if defined(ARDUINO) && !defined(ARDUINOSTL_M_H)
+  #include <utility.h>
+#else
+  #include <utility>
+#endif
+
+#include <string>
+#include <type_traits>
+#include <vector>
+#include <set>
+#include <algorithm>
+#include <iterator>
+#include <memory>
+
+#if defined(__unix__) && !defined(FLATBUFFERS_LOCALE_INDEPENDENT)
+  #include <unistd.h>
+#endif
+
+#ifdef __ANDROID__
+  #include <android/api-level.h>
+#endif
+
+#if defined(__ICCARM__)
+#include <intrinsics.h>
+#endif
+
+// Note the __clang__ check is needed, because clang presents itself
+// as an older GNUC compiler (4.2).
+// Clang 3.3 and later implement all of the ISO C++ 2011 standard.
+// Clang 3.4 and later implement all of the ISO C++ 2014 standard.
+// http://clang.llvm.org/cxx_status.html
+
+// Note the MSVC value '__cplusplus' may be incorrect:
+// The '__cplusplus' predefined macro in the MSVC stuck at the value 199711L,
+// indicating (erroneously!) that the compiler conformed to the C++98 Standard.
+// This value should be correct starting from MSVC2017-15.7-Preview-3.
+// The '__cplusplus' will be valid only if MSVC2017-15.7-P3 and the `/Zc:__cplusplus` switch is set.
+// Workaround (for details see MSDN):
+// Use the _MSC_VER and _MSVC_LANG definition instead of the __cplusplus  for compatibility.
+// The _MSVC_LANG macro reports the Standard version regardless of the '/Zc:__cplusplus' switch.
+
+#if defined(__GNUC__) && !defined(__clang__)
+  #define FLATBUFFERS_GCC (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
+#else
+  #define FLATBUFFERS_GCC 0
+#endif
+
+#if defined(__clang__)
+  #define FLATBUFFERS_CLANG (__clang_major__ * 10000 + __clang_minor__ * 100 + __clang_patchlevel__)
+#else
+  #define FLATBUFFERS_CLANG 0
+#endif
+
+/// @cond FLATBUFFERS_INTERNAL
+#if __cplusplus <= 199711L && \
+    (!defined(_MSC_VER) || _MSC_VER < 1600) && \
+    (!defined(__GNUC__) || \
+      (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__ < 40400))
+  #error A C++11 compatible compiler with support for the auto typing is \
+         required for FlatBuffers.
+  #error __cplusplus _MSC_VER __GNUC__  __GNUC_MINOR__  __GNUC_PATCHLEVEL__
+#endif
+
+#if !defined(__clang__) && \
+    defined(__GNUC__) && \
+    (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__ < 40600)
+  // Backwards compatibility for g++ 4.4, and 4.5 which don't have the nullptr
+  // and constexpr keywords. Note the __clang__ check is needed, because clang
+  // presents itself as an older GNUC compiler.
+  #ifndef nullptr_t
+    const class nullptr_t {
+    public:
+      template<class T> inline operator T*() const { return 0; }
+    private:
+      void operator&() const;
+    } nullptr = {};
+  #endif
+  #ifndef constexpr
+    #define constexpr const
+  #endif
+#endif
+
+// The wire format uses a little endian encoding (since that's efficient for
+// the common platforms).
+#if defined(__s390x__)
+  #define FLATBUFFERS_LITTLEENDIAN 0
+#endif // __s390x__
+#if !defined(FLATBUFFERS_LITTLEENDIAN)
+  #if defined(__GNUC__) || defined(__clang__) || defined(__ICCARM__)
+    #if (defined(__BIG_ENDIAN__) || \
+         (defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__))
+      #define FLATBUFFERS_LITTLEENDIAN 0
+    #else
+      #define FLATBUFFERS_LITTLEENDIAN 1
+    #endif // __BIG_ENDIAN__
+  #elif defined(_MSC_VER)
+    #if defined(_M_PPC)
+      #define FLATBUFFERS_LITTLEENDIAN 0
+    #else
+      #define FLATBUFFERS_LITTLEENDIAN 1
+    #endif
+  #else
+    #error Unable to determine endianness, define FLATBUFFERS_LITTLEENDIAN.
+  #endif
+#endif // !defined(FLATBUFFERS_LITTLEENDIAN)
+
+#define FLATBUFFERS_VERSION_MAJOR 2
+#define FLATBUFFERS_VERSION_MINOR 0
+#define FLATBUFFERS_VERSION_REVISION 6
+#define FLATBUFFERS_STRING_EXPAND(X) #X
+#define FLATBUFFERS_STRING(X) FLATBUFFERS_STRING_EXPAND(X)
+namespace mapserver {
+namespace flatbuffers {
+  // Returns version as string  "MAJOR.MINOR.REVISION".
+  const char* FLATBUFFERS_VERSION();
+} }
+
+#if (!defined(_MSC_VER) || _MSC_VER > 1600) && \
+    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 407)) || \
+    defined(__clang__)
+  #define FLATBUFFERS_FINAL_CLASS final
+  #define FLATBUFFERS_OVERRIDE override
+  #define FLATBUFFERS_EXPLICIT_CPP11 explicit
+  #define FLATBUFFERS_VTABLE_UNDERLYING_TYPE : flatbuffers::voffset_t
+#else
+  #define FLATBUFFERS_FINAL_CLASS
+  #define FLATBUFFERS_OVERRIDE
+  #define FLATBUFFERS_EXPLICIT_CPP11
+  #define FLATBUFFERS_VTABLE_UNDERLYING_TYPE
+#endif
+
+#if (!defined(_MSC_VER) || _MSC_VER >= 1900) && \
+    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 406)) || \
+    (defined(__cpp_constexpr) && __cpp_constexpr >= 200704)
+  #define FLATBUFFERS_CONSTEXPR constexpr
+  #define FLATBUFFERS_CONSTEXPR_CPP11 constexpr
+  #define FLATBUFFERS_CONSTEXPR_DEFINED
+#else
+  #define FLATBUFFERS_CONSTEXPR const
+  #define FLATBUFFERS_CONSTEXPR_CPP11
+#endif
+
+#if (defined(__cplusplus) && __cplusplus >= 201402L) || \
+    (defined(__cpp_constexpr) && __cpp_constexpr >= 201304)
+  #define FLATBUFFERS_CONSTEXPR_CPP14 FLATBUFFERS_CONSTEXPR_CPP11
+#else
+  #define FLATBUFFERS_CONSTEXPR_CPP14
+#endif
+
+#if (defined(__GXX_EXPERIMENTAL_CXX0X__) && (__GNUC__ * 100 + __GNUC_MINOR__ >= 406)) || \
+    (defined(_MSC_FULL_VER) && (_MSC_FULL_VER >= 190023026)) || \
+    defined(__clang__)
+  #define FLATBUFFERS_NOEXCEPT noexcept
+#else
+  #define FLATBUFFERS_NOEXCEPT
+#endif
+
+// NOTE: the FLATBUFFERS_DELETE_FUNC macro may change the access mode to
+// private, so be sure to put it at the end or reset access mode explicitly.
+#if (!defined(_MSC_VER) || _MSC_FULL_VER >= 180020827) && \
+    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 404)) || \
+    defined(__clang__)
+  #define FLATBUFFERS_DELETE_FUNC(func) func = delete
+#else
+  #define FLATBUFFERS_DELETE_FUNC(func) private: func
+#endif
+
+#if (!defined(_MSC_VER) || _MSC_VER >= 1900) && \
+    (!defined(__GNUC__) || (__GNUC__ * 100 + __GNUC_MINOR__ >= 409)) || \
+    defined(__clang__)
+  #define FLATBUFFERS_DEFAULT_DECLARATION
+#endif
+
+// Check if we can use template aliases
+// Not possible if Microsoft Compiler before 2012
+// Possible is the language feature __cpp_alias_templates is defined well
+// Or possible if the C++ std is C+11 or newer
+#if (defined(_MSC_VER) && _MSC_VER > 1700 /* MSVC2012 */) \
+    || (defined(__cpp_alias_templates) && __cpp_alias_templates >= 200704) \
+    || (defined(__cplusplus) && __cplusplus >= 201103L)
+  #define FLATBUFFERS_TEMPLATES_ALIASES
+#endif
+
+#ifndef FLATBUFFERS_HAS_STRING_VIEW
+  // Only provide flatbuffers::string_view if __has_include can be used
+  // to detect a header that provides an implementation
+  #if defined(__has_include)
+    // Check for std::string_view (in c++17)
+    #if __has_include(<string_view>) && (__cplusplus >= 201606 || (defined(_HAS_CXX17) && _HAS_CXX17))
+      #include <string_view>
+      namespace mapserver {
+namespace flatbuffers {
+        typedef std::string_view string_view;
+      } }
+      #define FLATBUFFERS_HAS_STRING_VIEW 1
+    // Check for std::experimental::string_view (in c++14, compiler-dependent)
+    #elif __has_include(<experimental/string_view>) && (__cplusplus >= 201411)
+      #include <experimental/string_view>
+      namespace mapserver {
+namespace flatbuffers {
+        typedef std::experimental::string_view string_view;
+      } }
+      #define FLATBUFFERS_HAS_STRING_VIEW 1
+    // Check for absl::string_view
+    #elif __has_include("absl/strings/string_view.h") && (__cplusplus >= 201411)
+      #include "absl/strings/string_view.h"
+      namespace mapserver {
+namespace flatbuffers {
+        typedef absl::string_view string_view;
+      } }
+      #define FLATBUFFERS_HAS_STRING_VIEW 1
+    #endif
+  #endif // __has_include
+#endif // !FLATBUFFERS_HAS_STRING_VIEW
+
+#ifndef FLATBUFFERS_GENERAL_HEAP_ALLOC_OK
+  // Allow heap allocations to be used
+  #define FLATBUFFERS_GENERAL_HEAP_ALLOC_OK 1
+#endif // !FLATBUFFERS_GENERAL_HEAP_ALLOC_OK
+
+#ifndef FLATBUFFERS_HAS_NEW_STRTOD
+  // Modern (C++11) strtod and strtof functions are available for use.
+  // 1) nan/inf strings as argument of strtod;
+  // 2) hex-float  as argument of  strtod/strtof.
+  #if (defined(_MSC_VER) && _MSC_VER >= 1900) || \
+      (defined(__GNUC__) && (__GNUC__ * 100 + __GNUC_MINOR__ >= 409)) || \
+      (defined(__clang__))
+    #define FLATBUFFERS_HAS_NEW_STRTOD 1
+  #endif
+#endif // !FLATBUFFERS_HAS_NEW_STRTOD
+
+#ifndef FLATBUFFERS_LOCALE_INDEPENDENT
+  // Enable locale independent functions {strtof_l, strtod_l,strtoll_l, strtoull_l}.
+  #if ((defined(_MSC_VER) && _MSC_VER >= 1800)            || \
+       (defined(_XOPEN_VERSION) && (_XOPEN_VERSION>=700)) && (!defined(__ANDROID_API__) || (defined(__ANDROID_API__) && (__ANDROID_API__>=21))))
+    #define FLATBUFFERS_LOCALE_INDEPENDENT 1
+  #else
+    #define FLATBUFFERS_LOCALE_INDEPENDENT 0
+  #endif
+#endif  // !FLATBUFFERS_LOCALE_INDEPENDENT
+
+// Suppress Undefined Behavior Sanitizer (recoverable only). Usage:
+// - __supress_ubsan__("undefined")
+// - __supress_ubsan__("signed-integer-overflow")
+#if defined(__clang__) && (__clang_major__ > 3 || (__clang_major__ == 3 && __clang_minor__ >=7))
+  #define __supress_ubsan__(type) __attribute__((no_sanitize(type)))
+#elif defined(__GNUC__) && (__GNUC__ * 100 + __GNUC_MINOR__ >= 409)
+  #define __supress_ubsan__(type) __attribute__((no_sanitize_undefined))
+#else
+  #define __supress_ubsan__(type)
+#endif
+
+// This is constexpr function used for checking compile-time constants.
+// Avoid `#pragma warning(disable: 4127) // C4127: expression is constant`.
+template<typename T> FLATBUFFERS_CONSTEXPR inline bool IsConstTrue(T t) {
+  return !!t;
+}
+
+// Enable C++ attribute [[]] if std:c++17 or higher.
+#if ((__cplusplus >= 201703L) \
+    || (defined(_MSVC_LANG) &&  (_MSVC_LANG >= 201703L)))
+  // All attributes unknown to an implementation are ignored without causing an error.
+  #define FLATBUFFERS_ATTRIBUTE(attr) attr
+
+  #define FLATBUFFERS_FALLTHROUGH() [[fallthrough]]
+#else
+  #define FLATBUFFERS_ATTRIBUTE(attr)
+
+  #if FLATBUFFERS_CLANG >= 30800
+    #define FLATBUFFERS_FALLTHROUGH() [[clang::fallthrough]]
+  #elif FLATBUFFERS_GCC >= 70300
+    #define FLATBUFFERS_FALLTHROUGH() [[gnu::fallthrough]]
+  #else
+    #define FLATBUFFERS_FALLTHROUGH()
+  #endif
+#endif
+
+/// @endcond
+
+/// @file
+namespace mapserver {
+namespace flatbuffers {
+
+/// @cond FLATBUFFERS_INTERNAL
+// Our default offset / size type, 32bit on purpose on 64bit systems.
+// Also, using a consistent offset type maintains compatibility of serialized
+// offset values between 32bit and 64bit systems.
+typedef uint32_t uoffset_t;
+
+// Signed offsets for references that can go in both directions.
+typedef int32_t soffset_t;
+
+// Offset/index used in v-tables, can be changed to uint8_t in
+// format forks to save a bit of space if desired.
+typedef uint16_t voffset_t;
+
+typedef uintmax_t largest_scalar_t;
+
+// In 32bits, this evaluates to 2GB - 1
+#define FLATBUFFERS_MAX_BUFFER_SIZE ((1ULL << (sizeof(::mapserver::flatbuffers::soffset_t) * 8 - 1)) - 1)
+
+// We support aligning the contents of buffers up to this size.
+#ifndef FLATBUFFERS_MAX_ALIGNMENT
+  #define FLATBUFFERS_MAX_ALIGNMENT 32
+#endif
+
+/// @brief The length of a FlatBuffer file header.
+static const size_t kFileIdentifierLength = 4;
+
+inline bool VerifyAlignmentRequirements(size_t align, size_t min_align = 1) {
+  return (min_align <= align) && (align <= (FLATBUFFERS_MAX_ALIGNMENT)) &&
+         (align & (align - 1)) == 0;  // must be power of 2
+}
+
+#if defined(_MSC_VER)
+  #pragma warning(disable: 4351) // C4351: new behavior: elements of array ... will be default initialized
+  #pragma warning(push)
+  #pragma warning(disable: 4127) // C4127: conditional expression is constant
+#endif
+
+template<typename T> T EndianSwap(T t) {
+  #if defined(_MSC_VER)
+    #define FLATBUFFERS_BYTESWAP16 _byteswap_ushort
+    #define FLATBUFFERS_BYTESWAP32 _byteswap_ulong
+    #define FLATBUFFERS_BYTESWAP64 _byteswap_uint64
+  #elif defined(__ICCARM__)
+    #define FLATBUFFERS_BYTESWAP16 __REV16
+    #define FLATBUFFERS_BYTESWAP32 __REV
+    #define FLATBUFFERS_BYTESWAP64(x) \
+       ((__REV(static_cast<uint32_t>(x >> 32U))) | (static_cast<uint64_t>(__REV(static_cast<uint32_t>(x)))) << 32U)
+  #else
+    #if defined(__GNUC__) && __GNUC__ * 100 + __GNUC_MINOR__ < 408 && !defined(__clang__)
+      // __builtin_bswap16 was missing prior to GCC 4.8.
+      #define FLATBUFFERS_BYTESWAP16(x) \
+        static_cast<uint16_t>(__builtin_bswap32(static_cast<uint32_t>(x) << 16))
+    #else
+      #define FLATBUFFERS_BYTESWAP16 __builtin_bswap16
+    #endif
+    #define FLATBUFFERS_BYTESWAP32 __builtin_bswap32
+    #define FLATBUFFERS_BYTESWAP64 __builtin_bswap64
+  #endif
+  if (sizeof(T) == 1) {   // Compile-time if-then's.
+    return t;
+  } else if (sizeof(T) == 2) {
+    union { T t; uint16_t i; } u = { t };
+    u.i = FLATBUFFERS_BYTESWAP16(u.i);
+    return u.t;
+  } else if (sizeof(T) == 4) {
+    union { T t; uint32_t i; } u = { t };
+    u.i = FLATBUFFERS_BYTESWAP32(u.i);
+    return u.t;
+  } else if (sizeof(T) == 8) {
+    union { T t; uint64_t i; } u = { t };
+    u.i = FLATBUFFERS_BYTESWAP64(u.i);
+    return u.t;
+  } else {
+    FLATBUFFERS_ASSERT(0);
+    return t;
+  }
+}
+
+#if defined(_MSC_VER)
+  #pragma warning(pop)
+#endif
+
+
+template<typename T> T EndianScalar(T t) {
+  #if FLATBUFFERS_LITTLEENDIAN
+    return t;
+  #else
+    return EndianSwap(t);
+  #endif
+}
+
+template<typename T>
+// UBSAN: C++ aliasing type rules, see std::bit_cast<> for details.
+__supress_ubsan__("alignment")
+T ReadScalar(const void *p) {
+  return EndianScalar(*reinterpret_cast<const T *>(p));
+}
+
+// See https://github.com/google/flatbuffers/issues/5950
+
+#if (FLATBUFFERS_GCC >= 100000) && (FLATBUFFERS_GCC < 110000)
+  #pragma GCC diagnostic push
+  #pragma GCC diagnostic ignored "-Wstringop-overflow"
+#endif
+
+template<typename T>
+// UBSAN: C++ aliasing type rules, see std::bit_cast<> for details.
+__supress_ubsan__("alignment")
+void WriteScalar(void *p, T t) {
+  *reinterpret_cast<T *>(p) = EndianScalar(t);
+}
+
+template<typename T> struct Offset;
+template<typename T> __supress_ubsan__("alignment") void WriteScalar(void *p, Offset<T> t) {
+  *reinterpret_cast<uoffset_t *>(p) = EndianScalar(t.o);
+}
+
+#if (FLATBUFFERS_GCC >= 100000) && (FLATBUFFERS_GCC < 110000)
+  #pragma GCC diagnostic pop
+#endif
+
+// Computes how many bytes you'd have to pad to be able to write an
+// "scalar_size" scalar if the buffer had grown to "buf_size" (downwards in
+// memory).
+__supress_ubsan__("unsigned-integer-overflow")
+inline size_t PaddingBytes(size_t buf_size, size_t scalar_size) {
+  return ((~buf_size) + 1) & (scalar_size - 1);
+}
+
+// Generic 'operator==' with conditional specialisations.
+// T e - new value of a scalar field.
+// T def - default of scalar (is known at compile-time).
+template<typename T> inline bool IsTheSameAs(T e, T def) { return e == def; }
+
+#if defined(FLATBUFFERS_NAN_DEFAULTS) && \
+    defined(FLATBUFFERS_HAS_NEW_STRTOD) && (FLATBUFFERS_HAS_NEW_STRTOD > 0)
+// Like `operator==(e, def)` with weak NaN if T=(float|double).
+template<typename T> inline bool IsFloatTheSameAs(T e, T def) {
+  return (e == def) || ((def != def) && (e != e));
+}
+template<> inline bool IsTheSameAs<float>(float e, float def) {
+  return IsFloatTheSameAs(e, def);
+}
+template<> inline bool IsTheSameAs<double>(double e, double def) {
+  return IsFloatTheSameAs(e, def);
+}
+#endif
+
+// Check 'v' is out of closed range [low; high].
+// Workaround for GCC warning [-Werror=type-limits]:
+// comparison is always true due to limited range of data type.
+template<typename T>
+inline bool IsOutRange(const T &v, const T &low, const T &high) {
+  return (v < low) || (high < v);
+}
+
+// Check 'v' is in closed range [low; high].
+template<typename T>
+inline bool IsInRange(const T &v, const T &low, const T &high) {
+  return !IsOutRange(v, low, high);
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+#endif  // FLATBUFFERS_BASE_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/bfbs_generator.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/bfbs_generator.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/bfbs_generator.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/bfbs_generator.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,45 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_BFBS_GENERATOR_H_
+#define FLATBUFFERS_BFBS_GENERATOR_H_
+
+#include <cstdint>
+
+namespace mapserver {
+namespace flatbuffers {
+
+enum GeneratorStatus {
+  OK,
+  FAILED,
+  FAILED_VERIFICATION,
+};
+
+// A Flatbuffer Code Generator that receives a binary serialized reflection.fbs
+// and generates code from it.
+class BfbsGenerator {
+ public:
+  virtual ~BfbsGenerator() {}
+
+  // Generate code from the provided `buffer` of given `length`. The buffer is
+  // a serialized reflection.fbs.
+  virtual GeneratorStatus Generate(const uint8_t *buffer, int64_t length) = 0;
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_BFBS_GENERATOR_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/buffer.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/buffer.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/buffer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/buffer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,144 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_BUFFER_H_
+#define FLATBUFFERS_BUFFER_H_
+
+#include "flatbuffers/base.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Wrapper for uoffset_t to allow safe template specialization.
+// Value is allowed to be 0 to indicate a null object (see e.g. AddOffset).
+template<typename T> struct Offset {
+  uoffset_t o;
+  Offset() : o(0) {}
+  Offset(uoffset_t _o) : o(_o) {}
+  Offset<void> Union() const { return Offset<void>(o); }
+  bool IsNull() const { return !o; }
+};
+
+inline void EndianCheck() {
+  int endiantest = 1;
+  // If this fails, see FLATBUFFERS_LITTLEENDIAN above.
+  FLATBUFFERS_ASSERT(*reinterpret_cast<char *>(&endiantest) ==
+                     FLATBUFFERS_LITTLEENDIAN);
+  (void)endiantest;
+}
+
+template<typename T> FLATBUFFERS_CONSTEXPR size_t AlignOf() {
+  // clang-format off
+  #ifdef _MSC_VER
+    return __alignof(T);
+  #else
+    #ifndef alignof
+      return __alignof__(T);
+    #else
+      return alignof(T);
+    #endif
+  #endif
+  // clang-format on
+}
+
+// Lexicographically compare two strings (possibly containing nulls), and
+// return true if the first is less than the second.
+static inline bool StringLessThan(const char *a_data, uoffset_t a_size,
+                                  const char *b_data, uoffset_t b_size) {
+  const auto cmp = memcmp(a_data, b_data, (std::min)(a_size, b_size));
+  return cmp == 0 ? a_size < b_size : cmp < 0;
+}
+
+// When we read serialized data from memory, in the case of most scalars,
+// we want to just read T, but in the case of Offset, we want to actually
+// perform the indirection and return a pointer.
+// The template specialization below does just that.
+// It is wrapped in a struct since function templates can't overload on the
+// return type like this.
+// The typedef is for the convenience of callers of this function
+// (avoiding the need for a trailing return decltype)
+template<typename T> struct IndirectHelper {
+  typedef T return_type;
+  typedef T mutable_return_type;
+  static const size_t element_stride = sizeof(T);
+  static return_type Read(const uint8_t *p, uoffset_t i) {
+    return EndianScalar((reinterpret_cast<const T *>(p))[i]);
+  }
+};
+template<typename T> struct IndirectHelper<Offset<T>> {
+  typedef const T *return_type;
+  typedef T *mutable_return_type;
+  static const size_t element_stride = sizeof(uoffset_t);
+  static return_type Read(const uint8_t *p, uoffset_t i) {
+    p += i * sizeof(uoffset_t);
+    return reinterpret_cast<return_type>(p + ReadScalar<uoffset_t>(p));
+  }
+};
+template<typename T> struct IndirectHelper<const T *> {
+  typedef const T *return_type;
+  typedef T *mutable_return_type;
+  static const size_t element_stride = sizeof(T);
+  static return_type Read(const uint8_t *p, uoffset_t i) {
+    return reinterpret_cast<const T *>(p + i * sizeof(T));
+  }
+};
+
+/// @brief Get a pointer to the the file_identifier section of the buffer.
+/// @return Returns a const char pointer to the start of the file_identifier
+/// characters in the buffer.  The returned char * has length
+/// 'flatbuffers::FlatBufferBuilder::kFileIdentifierLength'.
+/// This function is UNDEFINED for FlatBuffers whose schema does not include
+/// a file_identifier (likely points at padding or the start of a the root
+/// vtable).
+inline const char *GetBufferIdentifier(const void *buf,
+                                       bool size_prefixed = false) {
+  return reinterpret_cast<const char *>(buf) +
+         ((size_prefixed) ? 2 * sizeof(uoffset_t) : sizeof(uoffset_t));
+}
+
+// Helper to see if the identifier in a buffer has the expected value.
+inline bool BufferHasIdentifier(const void *buf, const char *identifier,
+                                bool size_prefixed = false) {
+  return strncmp(GetBufferIdentifier(buf, size_prefixed), identifier,
+                 flatbuffers::kFileIdentifierLength) == 0;
+}
+
+/// @cond FLATBUFFERS_INTERNAL
+// Helpers to get a typed pointer to the root object contained in the buffer.
+template<typename T> T *GetMutableRoot(void *buf) {
+  EndianCheck();
+  return reinterpret_cast<T *>(
+      reinterpret_cast<uint8_t *>(buf) +
+      EndianScalar(*reinterpret_cast<uoffset_t *>(buf)));
+}
+
+template<typename T> T *GetMutableSizePrefixedRoot(void *buf) {
+  return GetMutableRoot<T>(reinterpret_cast<uint8_t *>(buf) +
+                           sizeof(uoffset_t));
+}
+
+template<typename T> const T *GetRoot(const void *buf) {
+  return GetMutableRoot<T>(const_cast<void *>(buf));
+}
+
+template<typename T> const T *GetSizePrefixedRoot(const void *buf) {
+  return GetRoot<T>(reinterpret_cast<const uint8_t *>(buf) + sizeof(uoffset_t));
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_BUFFER_H_
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/buffer_ref.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/buffer_ref.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/buffer_ref.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/buffer_ref.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,55 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_BUFFER_REF_H_
+#define FLATBUFFERS_BUFFER_REF_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/verifier.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Convenient way to bundle a buffer and its length, to pass it around
+// typed by its root.
+// A BufferRef does not own its buffer.
+struct BufferRefBase {};  // for std::is_base_of
+
+template<typename T> struct BufferRef : BufferRefBase {
+  BufferRef() : buf(nullptr), len(0), must_free(false) {}
+  BufferRef(uint8_t *_buf, uoffset_t _len)
+      : buf(_buf), len(_len), must_free(false) {}
+
+  ~BufferRef() {
+    if (must_free) free(buf);
+  }
+
+  const T *GetRoot() const { return flatbuffers::GetRoot<T>(buf); }
+
+  bool Verify() {
+    Verifier verifier(buf, len);
+    return verifier.VerifyBuffer<T>(nullptr);
+  }
+
+  uint8_t *buf;
+  uoffset_t len;
+  bool must_free;
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_BUFFER_REF_H_
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/code_generators.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/code_generators.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/code_generators.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/code_generators.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,235 @@
+/*
+ * Copyright 2014 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_CODE_GENERATORS_H_
+#define FLATBUFFERS_CODE_GENERATORS_H_
+
+#include <map>
+#include <sstream>
+
+#include "flatbuffers/idl.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Utility class to assist in generating code through use of text templates.
+//
+// Example code:
+//   CodeWriter code("\t");
+//   code.SetValue("NAME", "Foo");
+//   code += "void {{NAME}}() { printf("%s", "{{NAME}}"); }";
+//   code.SetValue("NAME", "Bar");
+//   code += "void {{NAME}}() { printf("%s", "{{NAME}}"); }";
+//   std::cout << code.ToString() << std::endl;
+//
+// Output:
+//  void Foo() { printf("%s", "Foo"); }
+//  void Bar() { printf("%s", "Bar"); }
+class CodeWriter {
+ public:
+  CodeWriter(std::string pad = std::string())
+      : pad_(pad), cur_ident_lvl_(0), ignore_ident_(false) {}
+
+  // Clears the current "written" code.
+  void Clear() {
+    stream_.str("");
+    stream_.clear();
+  }
+
+  // Associates a key with a value.  All subsequent calls to operator+=, where
+  // the specified key is contained in {{ and }} delimiters will be replaced by
+  // the given value.
+  void SetValue(const std::string &key, const std::string &value) {
+    value_map_[key] = value;
+  }
+
+  std::string GetValue(const std::string &key) const {
+    const auto it = value_map_.find(key);
+    return it == value_map_.end() ? "" : it->second;
+  }
+
+  // Appends the given text to the generated code as well as a newline
+  // character.  Any text within {{ and }} delimiters is replaced by values
+  // previously stored in the CodeWriter by calling SetValue above.  The newline
+  // will be suppressed if the text ends with the \\ character.
+  void operator+=(std::string text);
+
+  // Returns the current contents of the CodeWriter as a std::string.
+  std::string ToString() const { return stream_.str(); }
+
+  // Increase ident level for writing code
+  void IncrementIdentLevel() { cur_ident_lvl_++; }
+  // Decrease ident level for writing code
+  void DecrementIdentLevel() {
+    if (cur_ident_lvl_) cur_ident_lvl_--;
+  }
+
+  void SetPadding(const std::string &padding) { pad_ = padding; }
+
+ private:
+  std::map<std::string, std::string> value_map_;
+  std::stringstream stream_;
+  std::string pad_;
+  int cur_ident_lvl_;
+  bool ignore_ident_;
+
+  // Add ident padding (tab or space) based on ident level
+  void AppendIdent(std::stringstream &stream);
+};
+
+class BaseGenerator {
+ public:
+  virtual bool generate() = 0;
+
+  static std::string NamespaceDir(const Parser &parser, const std::string &path,
+                                  const Namespace &ns,
+                                  const bool dasherize = false);
+
+  std::string GeneratedFileName(const std::string &path,
+                                const std::string &file_name,
+                                const IDLOptions &options) const;
+
+ protected:
+  BaseGenerator(const Parser &parser, const std::string &path,
+                const std::string &file_name, std::string qualifying_start,
+                std::string qualifying_separator, std::string default_extension)
+      : parser_(parser),
+        path_(path),
+        file_name_(file_name),
+        qualifying_start_(qualifying_start),
+        qualifying_separator_(qualifying_separator),
+        default_extension_(default_extension) {}
+  virtual ~BaseGenerator() {}
+
+  // No copy/assign.
+  BaseGenerator &operator=(const BaseGenerator &);
+  BaseGenerator(const BaseGenerator &);
+
+  std::string NamespaceDir(const Namespace &ns,
+                           const bool dasherize = false) const;
+
+  static const char *FlatBuffersGeneratedWarning();
+
+  static std::string FullNamespace(const char *separator, const Namespace &ns);
+
+  static std::string LastNamespacePart(const Namespace &ns);
+
+  // tracks the current namespace for early exit in WrapInNameSpace
+  // c++, java and csharp returns a different namespace from
+  // the following default (no early exit, always fully qualify),
+  // which works for js and php
+  virtual const Namespace *CurrentNameSpace() const { return nullptr; }
+
+  // Ensure that a type is prefixed with its namespace even within
+  // its own namespace to avoid conflict between generated method
+  // names and similarly named classes or structs
+  std::string WrapInNameSpace(const Namespace *ns,
+                              const std::string &name) const;
+
+  std::string WrapInNameSpace(const Definition &def) const;
+
+  std::string GetNameSpace(const Definition &def) const;
+
+  const Parser &parser_;
+  const std::string &path_;
+  const std::string &file_name_;
+  const std::string qualifying_start_;
+  const std::string qualifying_separator_;
+  const std::string default_extension_;
+};
+
+struct CommentConfig {
+  const char *first_line;
+  const char *content_line_prefix;
+  const char *last_line;
+};
+
+extern void GenComment(const std::vector<std::string> &dc,
+                       std::string *code_ptr, const CommentConfig *config,
+                       const char *prefix = "");
+
+class FloatConstantGenerator {
+ public:
+  virtual ~FloatConstantGenerator() {}
+  std::string GenFloatConstant(const FieldDef &field) const;
+
+ private:
+  virtual std::string Value(double v, const std::string &src) const = 0;
+  virtual std::string Inf(double v) const = 0;
+  virtual std::string NaN(double v) const = 0;
+
+  virtual std::string Value(float v, const std::string &src) const = 0;
+  virtual std::string Inf(float v) const = 0;
+  virtual std::string NaN(float v) const = 0;
+
+  template<typename T>
+  std::string GenFloatConstantImpl(const FieldDef &field) const;
+};
+
+class SimpleFloatConstantGenerator : public FloatConstantGenerator {
+ public:
+  SimpleFloatConstantGenerator(const char *nan_number,
+                               const char *pos_inf_number,
+                               const char *neg_inf_number);
+
+ private:
+  std::string Value(double v,
+                    const std::string &src) const FLATBUFFERS_OVERRIDE;
+  std::string Inf(double v) const FLATBUFFERS_OVERRIDE;
+  std::string NaN(double v) const FLATBUFFERS_OVERRIDE;
+
+  std::string Value(float v, const std::string &src) const FLATBUFFERS_OVERRIDE;
+  std::string Inf(float v) const FLATBUFFERS_OVERRIDE;
+  std::string NaN(float v) const FLATBUFFERS_OVERRIDE;
+
+  const std::string nan_number_;
+  const std::string pos_inf_number_;
+  const std::string neg_inf_number_;
+};
+
+// C++, C#, Java like generator.
+class TypedFloatConstantGenerator : public FloatConstantGenerator {
+ public:
+  TypedFloatConstantGenerator(const char *double_prefix,
+                              const char *single_prefix, const char *nan_number,
+                              const char *pos_inf_number,
+                              const char *neg_inf_number = "");
+
+ private:
+  std::string Value(double v,
+                    const std::string &src) const FLATBUFFERS_OVERRIDE;
+  std::string Inf(double v) const FLATBUFFERS_OVERRIDE;
+
+  std::string NaN(double v) const FLATBUFFERS_OVERRIDE;
+
+  std::string Value(float v, const std::string &src) const FLATBUFFERS_OVERRIDE;
+  std::string Inf(float v) const FLATBUFFERS_OVERRIDE;
+  std::string NaN(float v) const FLATBUFFERS_OVERRIDE;
+
+  std::string MakeNaN(const std::string &prefix) const;
+  std::string MakeInf(bool neg, const std::string &prefix) const;
+
+  const std::string double_prefix_;
+  const std::string single_prefix_;
+  const std::string nan_number_;
+  const std::string pos_inf_number_;
+  const std::string neg_inf_number_;
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_CODE_GENERATORS_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/default_allocator.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/default_allocator.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/default_allocator.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/default_allocator.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_DEFAULT_ALLOCATOR_H_
+#define FLATBUFFERS_DEFAULT_ALLOCATOR_H_
+
+#include "flatbuffers/allocator.h"
+#include "flatbuffers/base.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// DefaultAllocator uses new/delete to allocate memory regions
+class DefaultAllocator : public Allocator {
+ public:
+  uint8_t *allocate(size_t size) FLATBUFFERS_OVERRIDE {
+    return new uint8_t[size];
+  }
+
+  void deallocate(uint8_t *p, size_t) FLATBUFFERS_OVERRIDE { delete[] p; }
+
+  static void dealloc(void *p, size_t) { delete[] static_cast<uint8_t *>(p); }
+};
+
+// These functions allow for a null allocator to mean use the default allocator,
+// as used by DetachedBuffer and vector_downward below.
+// This is to avoid having a statically or dynamically allocated default
+// allocator, or having to move it between the classes that may own it.
+inline uint8_t *Allocate(Allocator *allocator, size_t size) {
+  return allocator ? allocator->allocate(size)
+                   : DefaultAllocator().allocate(size);
+}
+
+inline void Deallocate(Allocator *allocator, uint8_t *p, size_t size) {
+  if (allocator)
+    allocator->deallocate(p, size);
+  else
+    DefaultAllocator().deallocate(p, size);
+}
+
+inline uint8_t *ReallocateDownward(Allocator *allocator, uint8_t *old_p,
+                                   size_t old_size, size_t new_size,
+                                   size_t in_use_back, size_t in_use_front) {
+  return allocator ? allocator->reallocate_downward(old_p, old_size, new_size,
+                                                    in_use_back, in_use_front)
+                   : DefaultAllocator().reallocate_downward(
+                         old_p, old_size, new_size, in_use_back, in_use_front);
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_DEFAULT_ALLOCATOR_H_
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/detached_buffer.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/detached_buffer.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/detached_buffer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/detached_buffer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,116 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_DETACHED_BUFFER_H_
+#define FLATBUFFERS_DETACHED_BUFFER_H_
+
+#include "flatbuffers/allocator.h"
+#include "flatbuffers/base.h"
+#include "flatbuffers/default_allocator.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// DetachedBuffer is a finished flatbuffer memory region, detached from its
+// builder. The original memory region and allocator are also stored so that
+// the DetachedBuffer can manage the memory lifetime.
+class DetachedBuffer {
+ public:
+  DetachedBuffer()
+      : allocator_(nullptr),
+        own_allocator_(false),
+        buf_(nullptr),
+        reserved_(0),
+        cur_(nullptr),
+        size_(0) {}
+
+  DetachedBuffer(Allocator *allocator, bool own_allocator, uint8_t *buf,
+                 size_t reserved, uint8_t *cur, size_t sz)
+      : allocator_(allocator),
+        own_allocator_(own_allocator),
+        buf_(buf),
+        reserved_(reserved),
+        cur_(cur),
+        size_(sz) {}
+
+  DetachedBuffer(DetachedBuffer &&other)
+      : allocator_(other.allocator_),
+        own_allocator_(other.own_allocator_),
+        buf_(other.buf_),
+        reserved_(other.reserved_),
+        cur_(other.cur_),
+        size_(other.size_) {
+    other.reset();
+  }
+
+  DetachedBuffer &operator=(DetachedBuffer &&other) {
+    if (this == &other) return *this;
+
+    destroy();
+
+    allocator_ = other.allocator_;
+    own_allocator_ = other.own_allocator_;
+    buf_ = other.buf_;
+    reserved_ = other.reserved_;
+    cur_ = other.cur_;
+    size_ = other.size_;
+
+    other.reset();
+
+    return *this;
+  }
+
+  ~DetachedBuffer() { destroy(); }
+
+  const uint8_t *data() const { return cur_; }
+
+  uint8_t *data() { return cur_; }
+
+  size_t size() const { return size_; }
+
+  // These may change access mode, leave these at end of public section
+  FLATBUFFERS_DELETE_FUNC(DetachedBuffer(const DetachedBuffer &other));
+  FLATBUFFERS_DELETE_FUNC(
+      DetachedBuffer &operator=(const DetachedBuffer &other));
+
+ protected:
+  Allocator *allocator_;
+  bool own_allocator_;
+  uint8_t *buf_;
+  size_t reserved_;
+  uint8_t *cur_;
+  size_t size_;
+
+  inline void destroy() {
+    if (buf_) Deallocate(allocator_, buf_, reserved_);
+    if (own_allocator_ && allocator_) { delete allocator_; }
+    reset();
+  }
+
+  inline void reset() {
+    allocator_ = nullptr;
+    own_allocator_ = false;
+    buf_ = nullptr;
+    reserved_ = 0;
+    cur_ = nullptr;
+    size_ = 0;
+  }
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_DETACHED_BUFFER_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/flatbuffer_builder.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flatbuffer_builder.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/flatbuffer_builder.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flatbuffer_builder.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1216 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_FLATBUFFER_BUILDER_H_
+#define FLATBUFFERS_FLATBUFFER_BUILDER_H_
+
+#include <functional>
+#include <initializer_list>
+
+#include "flatbuffers/allocator.h"
+#include "flatbuffers/array.h"
+#include "flatbuffers/base.h"
+#include "flatbuffers/buffer_ref.h"
+#include "flatbuffers/default_allocator.h"
+#include "flatbuffers/detached_buffer.h"
+#include "flatbuffers/stl_emulation.h"
+#include "flatbuffers/string.h"
+#include "flatbuffers/struct.h"
+#include "flatbuffers/table.h"
+#include "flatbuffers/vector.h"
+#include "flatbuffers/vector_downward.h"
+#include "flatbuffers/verifier.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Converts a Field ID to a virtual table offset.
+inline voffset_t FieldIndexToOffset(voffset_t field_id) {
+  // Should correspond to what EndTable() below builds up.
+  const int fixed_fields = 2;  // Vtable size and Object Size.
+  return static_cast<voffset_t>((field_id + fixed_fields) * sizeof(voffset_t));
+}
+
+template<typename T, typename Alloc = std::allocator<T>>
+const T *data(const std::vector<T, Alloc> &v) {
+  // Eventually the returned pointer gets passed down to memcpy, so
+  // we need it to be non-null to avoid undefined behavior.
+  static uint8_t t;
+  return v.empty() ? reinterpret_cast<const T *>(&t) : &v.front();
+}
+template<typename T, typename Alloc = std::allocator<T>>
+T *data(std::vector<T, Alloc> &v) {
+  // Eventually the returned pointer gets passed down to memcpy, so
+  // we need it to be non-null to avoid undefined behavior.
+  static uint8_t t;
+  return v.empty() ? reinterpret_cast<T *>(&t) : &v.front();
+}
+
+/// @addtogroup flatbuffers_cpp_api
+/// @{
+/// @class FlatBufferBuilder
+/// @brief Helper class to hold data needed in creation of a FlatBuffer.
+/// To serialize data, you typically call one of the `Create*()` functions in
+/// the generated code, which in turn call a sequence of `StartTable`/
+/// `PushElement`/`AddElement`/`EndTable`, or the builtin `CreateString`/
+/// `CreateVector` functions. Do this is depth-first order to build up a tree to
+/// the root. `Finish()` wraps up the buffer ready for transport.
+class FlatBufferBuilder {
+ public:
+  /// @brief Default constructor for FlatBufferBuilder.
+  /// @param[in] initial_size The initial size of the buffer, in bytes. Defaults
+  /// to `1024`.
+  /// @param[in] allocator An `Allocator` to use. If null will use
+  /// `DefaultAllocator`.
+  /// @param[in] own_allocator Whether the builder/vector should own the
+  /// allocator. Defaults to / `false`.
+  /// @param[in] buffer_minalign Force the buffer to be aligned to the given
+  /// minimum alignment upon reallocation. Only needed if you intend to store
+  /// types with custom alignment AND you wish to read the buffer in-place
+  /// directly after creation.
+  explicit FlatBufferBuilder(
+      size_t initial_size = 1024, Allocator *allocator = nullptr,
+      bool own_allocator = false,
+      size_t buffer_minalign = AlignOf<largest_scalar_t>())
+      : buf_(initial_size, allocator, own_allocator, buffer_minalign),
+        num_field_loc(0),
+        max_voffset_(0),
+        nested(false),
+        finished(false),
+        minalign_(1),
+        force_defaults_(false),
+        dedup_vtables_(true),
+        string_pool(nullptr) {
+    EndianCheck();
+  }
+
+  /// @brief Move constructor for FlatBufferBuilder.
+  FlatBufferBuilder(FlatBufferBuilder &&other)
+      : buf_(1024, nullptr, false, AlignOf<largest_scalar_t>()),
+        num_field_loc(0),
+        max_voffset_(0),
+        nested(false),
+        finished(false),
+        minalign_(1),
+        force_defaults_(false),
+        dedup_vtables_(true),
+        string_pool(nullptr) {
+    EndianCheck();
+    // Default construct and swap idiom.
+    // Lack of delegating constructors in vs2010 makes it more verbose than
+    // needed.
+    Swap(other);
+  }
+
+  /// @brief Move assignment operator for FlatBufferBuilder.
+  FlatBufferBuilder &operator=(FlatBufferBuilder &&other) {
+    // Move construct a temporary and swap idiom
+    FlatBufferBuilder temp(std::move(other));
+    Swap(temp);
+    return *this;
+  }
+
+  void Swap(FlatBufferBuilder &other) {
+    using std::swap;
+    buf_.swap(other.buf_);
+    swap(num_field_loc, other.num_field_loc);
+    swap(max_voffset_, other.max_voffset_);
+    swap(nested, other.nested);
+    swap(finished, other.finished);
+    swap(minalign_, other.minalign_);
+    swap(force_defaults_, other.force_defaults_);
+    swap(dedup_vtables_, other.dedup_vtables_);
+    swap(string_pool, other.string_pool);
+  }
+
+  ~FlatBufferBuilder() {
+    if (string_pool) delete string_pool;
+  }
+
+  void Reset() {
+    Clear();       // clear builder state
+    buf_.reset();  // deallocate buffer
+  }
+
+  /// @brief Reset all the state in this FlatBufferBuilder so it can be reused
+  /// to construct another buffer.
+  void Clear() {
+    ClearOffsets();
+    buf_.clear();
+    nested = false;
+    finished = false;
+    minalign_ = 1;
+    if (string_pool) string_pool->clear();
+  }
+
+  /// @brief The current size of the serialized buffer, counting from the end.
+  /// @return Returns an `uoffset_t` with the current size of the buffer.
+  uoffset_t GetSize() const { return buf_.size(); }
+
+  /// @brief Get the serialized buffer (after you call `Finish()`).
+  /// @return Returns an `uint8_t` pointer to the FlatBuffer data inside the
+  /// buffer.
+  uint8_t *GetBufferPointer() const {
+    Finished();
+    return buf_.data();
+  }
+
+  /// @brief Get the serialized buffer (after you call `Finish()`) as a span.
+  /// @return Returns a constructed flatbuffers::span that is a view over the
+  /// FlatBuffer data inside the buffer.
+  flatbuffers::span<uint8_t> GetBufferSpan() const {
+    Finished();
+    return flatbuffers::span<uint8_t>(buf_.data(), buf_.size());
+  }
+
+  /// @brief Get a pointer to an unfinished buffer.
+  /// @return Returns a `uint8_t` pointer to the unfinished buffer.
+  uint8_t *GetCurrentBufferPointer() const { return buf_.data(); }
+
+  /// @brief Get the released pointer to the serialized buffer.
+  /// @warning Do NOT attempt to use this FlatBufferBuilder afterwards!
+  /// @return A `FlatBuffer` that owns the buffer and its allocator and
+  /// behaves similar to a `unique_ptr` with a deleter.
+  FLATBUFFERS_ATTRIBUTE([[deprecated("use Release() instead")]])
+  DetachedBuffer ReleaseBufferPointer() {
+    Finished();
+    return buf_.release();
+  }
+
+  /// @brief Get the released DetachedBuffer.
+  /// @return A `DetachedBuffer` that owns the buffer and its allocator.
+  DetachedBuffer Release() {
+    Finished();
+    return buf_.release();
+  }
+
+  /// @brief Get the released pointer to the serialized buffer.
+  /// @param size The size of the memory block containing
+  /// the serialized `FlatBuffer`.
+  /// @param offset The offset from the released pointer where the finished
+  /// `FlatBuffer` starts.
+  /// @return A raw pointer to the start of the memory block containing
+  /// the serialized `FlatBuffer`.
+  /// @remark If the allocator is owned, it gets deleted when the destructor is
+  /// called..
+  uint8_t *ReleaseRaw(size_t &size, size_t &offset) {
+    Finished();
+    return buf_.release_raw(size, offset);
+  }
+
+  /// @brief get the minimum alignment this buffer needs to be accessed
+  /// properly. This is only known once all elements have been written (after
+  /// you call Finish()). You can use this information if you need to embed
+  /// a FlatBuffer in some other buffer, such that you can later read it
+  /// without first having to copy it into its own buffer.
+  size_t GetBufferMinAlignment() const {
+    Finished();
+    return minalign_;
+  }
+
+  /// @cond FLATBUFFERS_INTERNAL
+  void Finished() const {
+    // If you get this assert, you're attempting to get access a buffer
+    // which hasn't been finished yet. Be sure to call
+    // FlatBufferBuilder::Finish with your root table.
+    // If you really need to access an unfinished buffer, call
+    // GetCurrentBufferPointer instead.
+    FLATBUFFERS_ASSERT(finished);
+  }
+  /// @endcond
+
+  /// @brief In order to save space, fields that are set to their default value
+  /// don't get serialized into the buffer.
+  /// @param[in] fd When set to `true`, always serializes default values that
+  /// are set. Optional fields which are not set explicitly, will still not be
+  /// serialized.
+  void ForceDefaults(bool fd) { force_defaults_ = fd; }
+
+  /// @brief By default vtables are deduped in order to save space.
+  /// @param[in] dedup When set to `true`, dedup vtables.
+  void DedupVtables(bool dedup) { dedup_vtables_ = dedup; }
+
+  /// @cond FLATBUFFERS_INTERNAL
+  void Pad(size_t num_bytes) { buf_.fill(num_bytes); }
+
+  void TrackMinAlign(size_t elem_size) {
+    if (elem_size > minalign_) minalign_ = elem_size;
+  }
+
+  void Align(size_t elem_size) {
+    TrackMinAlign(elem_size);
+    buf_.fill(PaddingBytes(buf_.size(), elem_size));
+  }
+
+  void PushFlatBuffer(const uint8_t *bytes, size_t size) {
+    PushBytes(bytes, size);
+    finished = true;
+  }
+
+  void PushBytes(const uint8_t *bytes, size_t size) { buf_.push(bytes, size); }
+
+  void PopBytes(size_t amount) { buf_.pop(amount); }
+
+  template<typename T> void AssertScalarT() {
+    // The code assumes power of 2 sizes and endian-swap-ability.
+    static_assert(flatbuffers::is_scalar<T>::value, "T must be a scalar type");
+  }
+
+  // Write a single aligned scalar to the buffer
+  template<typename T> uoffset_t PushElement(T element) {
+    AssertScalarT<T>();
+    Align(sizeof(T));
+    buf_.push_small(EndianScalar(element));
+    return GetSize();
+  }
+
+  template<typename T> uoffset_t PushElement(Offset<T> off) {
+    // Special case for offsets: see ReferTo below.
+    return PushElement(ReferTo(off.o));
+  }
+
+  // When writing fields, we track where they are, so we can create correct
+  // vtables later.
+  void TrackField(voffset_t field, uoffset_t off) {
+    FieldLoc fl = { off, field };
+    buf_.scratch_push_small(fl);
+    num_field_loc++;
+    if (field > max_voffset_) { max_voffset_ = field; }
+  }
+
+  // Like PushElement, but additionally tracks the field this represents.
+  template<typename T> void AddElement(voffset_t field, T e, T def) {
+    // We don't serialize values equal to the default.
+    if (IsTheSameAs(e, def) && !force_defaults_) return;
+    TrackField(field, PushElement(e));
+  }
+
+  template<typename T> void AddElement(voffset_t field, T e) {
+    TrackField(field, PushElement(e));
+  }
+
+  template<typename T> void AddOffset(voffset_t field, Offset<T> off) {
+    if (off.IsNull()) return;  // Don't store.
+    AddElement(field, ReferTo(off.o), static_cast<uoffset_t>(0));
+  }
+
+  template<typename T> void AddStruct(voffset_t field, const T *structptr) {
+    if (!structptr) return;  // Default, don't store.
+    Align(AlignOf<T>());
+    buf_.push_small(*structptr);
+    TrackField(field, GetSize());
+  }
+
+  void AddStructOffset(voffset_t field, uoffset_t off) {
+    TrackField(field, off);
+  }
+
+  // Offsets initially are relative to the end of the buffer (downwards).
+  // This function converts them to be relative to the current location
+  // in the buffer (when stored here), pointing upwards.
+  uoffset_t ReferTo(uoffset_t off) {
+    // Align to ensure GetSize() below is correct.
+    Align(sizeof(uoffset_t));
+    // Offset must refer to something already in buffer.
+    const uoffset_t size = GetSize();
+    FLATBUFFERS_ASSERT(off && off <= size);
+    return size - off + static_cast<uoffset_t>(sizeof(uoffset_t));
+  }
+
+  void NotNested() {
+    // If you hit this, you're trying to construct a Table/Vector/String
+    // during the construction of its parent table (between the MyTableBuilder
+    // and table.Finish().
+    // Move the creation of these sub-objects to above the MyTableBuilder to
+    // not get this assert.
+    // Ignoring this assert may appear to work in simple cases, but the reason
+    // it is here is that storing objects in-line may cause vtable offsets
+    // to not fit anymore. It also leads to vtable duplication.
+    FLATBUFFERS_ASSERT(!nested);
+    // If you hit this, fields were added outside the scope of a table.
+    FLATBUFFERS_ASSERT(!num_field_loc);
+  }
+
+  // From generated code (or from the parser), we call StartTable/EndTable
+  // with a sequence of AddElement calls in between.
+  uoffset_t StartTable() {
+    NotNested();
+    nested = true;
+    return GetSize();
+  }
+
+  // This finishes one serialized object by generating the vtable if it's a
+  // table, comparing it against existing vtables, and writing the
+  // resulting vtable offset.
+  uoffset_t EndTable(uoffset_t start) {
+    // If you get this assert, a corresponding StartTable wasn't called.
+    FLATBUFFERS_ASSERT(nested);
+    // Write the vtable offset, which is the start of any Table.
+    // We fill it's value later.
+    auto vtableoffsetloc = PushElement<soffset_t>(0);
+    // Write a vtable, which consists entirely of voffset_t elements.
+    // It starts with the number of offsets, followed by a type id, followed
+    // by the offsets themselves. In reverse:
+    // Include space for the last offset and ensure empty tables have a
+    // minimum size.
+    max_voffset_ =
+        (std::max)(static_cast<voffset_t>(max_voffset_ + sizeof(voffset_t)),
+                   FieldIndexToOffset(0));
+    buf_.fill_big(max_voffset_);
+    auto table_object_size = vtableoffsetloc - start;
+    // Vtable use 16bit offsets.
+    FLATBUFFERS_ASSERT(table_object_size < 0x10000);
+    WriteScalar<voffset_t>(buf_.data() + sizeof(voffset_t),
+                           static_cast<voffset_t>(table_object_size));
+    WriteScalar<voffset_t>(buf_.data(), max_voffset_);
+    // Write the offsets into the table
+    for (auto it = buf_.scratch_end() - num_field_loc * sizeof(FieldLoc);
+         it < buf_.scratch_end(); it += sizeof(FieldLoc)) {
+      auto field_location = reinterpret_cast<FieldLoc *>(it);
+      auto pos = static_cast<voffset_t>(vtableoffsetloc - field_location->off);
+      // If this asserts, it means you've set a field twice.
+      FLATBUFFERS_ASSERT(
+          !ReadScalar<voffset_t>(buf_.data() + field_location->id));
+      WriteScalar<voffset_t>(buf_.data() + field_location->id, pos);
+    }
+    ClearOffsets();
+    auto vt1 = reinterpret_cast<voffset_t *>(buf_.data());
+    auto vt1_size = ReadScalar<voffset_t>(vt1);
+    auto vt_use = GetSize();
+    // See if we already have generated a vtable with this exact same
+    // layout before. If so, make it point to the old one, remove this one.
+    if (dedup_vtables_) {
+      for (auto it = buf_.scratch_data(); it < buf_.scratch_end();
+           it += sizeof(uoffset_t)) {
+        auto vt_offset_ptr = reinterpret_cast<uoffset_t *>(it);
+        auto vt2 = reinterpret_cast<voffset_t *>(buf_.data_at(*vt_offset_ptr));
+        auto vt2_size = ReadScalar<voffset_t>(vt2);
+        if (vt1_size != vt2_size || 0 != memcmp(vt2, vt1, vt1_size)) continue;
+        vt_use = *vt_offset_ptr;
+        buf_.pop(GetSize() - vtableoffsetloc);
+        break;
+      }
+    }
+    // If this is a new vtable, remember it.
+    if (vt_use == GetSize()) { buf_.scratch_push_small(vt_use); }
+    // Fill the vtable offset we created above.
+    // The offset points from the beginning of the object to where the
+    // vtable is stored.
+    // Offsets default direction is downward in memory for future format
+    // flexibility (storing all vtables at the start of the file).
+    WriteScalar(buf_.data_at(vtableoffsetloc),
+                static_cast<soffset_t>(vt_use) -
+                    static_cast<soffset_t>(vtableoffsetloc));
+
+    nested = false;
+    return vtableoffsetloc;
+  }
+
+  FLATBUFFERS_ATTRIBUTE([[deprecated("call the version above instead")]])
+  uoffset_t EndTable(uoffset_t start, voffset_t /*numfields*/) {
+    return EndTable(start);
+  }
+
+  // This checks a required field has been set in a given table that has
+  // just been constructed.
+  template<typename T> void Required(Offset<T> table, voffset_t field);
+
+  uoffset_t StartStruct(size_t alignment) {
+    Align(alignment);
+    return GetSize();
+  }
+
+  uoffset_t EndStruct() { return GetSize(); }
+
+  void ClearOffsets() {
+    buf_.scratch_pop(num_field_loc * sizeof(FieldLoc));
+    num_field_loc = 0;
+    max_voffset_ = 0;
+  }
+
+  // Aligns such that when "len" bytes are written, an object can be written
+  // after it with "alignment" without padding.
+  void PreAlign(size_t len, size_t alignment) {
+    if (len == 0) return;
+    TrackMinAlign(alignment);
+    buf_.fill(PaddingBytes(GetSize() + len, alignment));
+  }
+  template<typename T> void PreAlign(size_t len) {
+    AssertScalarT<T>();
+    PreAlign(len, sizeof(T));
+  }
+  /// @endcond
+
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// @param[in] str A const char pointer to the data to be stored as a string.
+  /// @param[in] len The number of bytes that should be stored from `str`.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateString(const char *str, size_t len) {
+    NotNested();
+    PreAlign<uoffset_t>(len + 1);  // Always 0-terminated.
+    buf_.fill(1);
+    PushBytes(reinterpret_cast<const uint8_t *>(str), len);
+    PushElement(static_cast<uoffset_t>(len));
+    return Offset<String>(GetSize());
+  }
+
+  /// @brief Store a string in the buffer, which is null-terminated.
+  /// @param[in] str A const char pointer to a C-string to add to the buffer.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateString(const char *str) {
+    return CreateString(str, strlen(str));
+  }
+
+  /// @brief Store a string in the buffer, which is null-terminated.
+  /// @param[in] str A char pointer to a C-string to add to the buffer.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateString(char *str) {
+    return CreateString(str, strlen(str));
+  }
+
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// @param[in] str A const reference to a std::string to store in the buffer.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateString(const std::string &str) {
+    return CreateString(str.c_str(), str.length());
+  }
+
+  // clang-format off
+  #ifdef FLATBUFFERS_HAS_STRING_VIEW
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// @param[in] str A const string_view to copy in to the buffer.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateString(flatbuffers::string_view str) {
+    return CreateString(str.data(), str.size());
+  }
+  #endif // FLATBUFFERS_HAS_STRING_VIEW
+  // clang-format on
+
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// @param[in] str A const pointer to a `String` struct to add to the buffer.
+  /// @return Returns the offset in the buffer where the string starts
+  Offset<String> CreateString(const String *str) {
+    return str ? CreateString(str->c_str(), str->size()) : 0;
+  }
+
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// @param[in] str A const reference to a std::string like type with support
+  /// of T::c_str() and T::length() to store in the buffer.
+  /// @return Returns the offset in the buffer where the string starts.
+  template<typename T> Offset<String> CreateString(const T &str) {
+    return CreateString(str.c_str(), str.length());
+  }
+
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// If a string with this exact contents has already been serialized before,
+  /// instead simply returns the offset of the existing string. This uses a map
+  /// stored on the heap, but only stores the numerical offsets.
+  /// @param[in] str A const char pointer to the data to be stored as a string.
+  /// @param[in] len The number of bytes that should be stored from `str`.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateSharedString(const char *str, size_t len) {
+    FLATBUFFERS_ASSERT(FLATBUFFERS_GENERAL_HEAP_ALLOC_OK);
+    if (!string_pool)
+      string_pool = new StringOffsetMap(StringOffsetCompare(buf_));
+    auto size_before_string = buf_.size();
+    // Must first serialize the string, since the set is all offsets into
+    // buffer.
+    auto off = CreateString(str, len);
+    auto it = string_pool->find(off);
+    // If it exists we reuse existing serialized data!
+    if (it != string_pool->end()) {
+      // We can remove the string we serialized.
+      buf_.pop(buf_.size() - size_before_string);
+      return *it;
+    }
+    // Record this string for future use.
+    string_pool->insert(off);
+    return off;
+  }
+
+#ifdef FLATBUFFERS_HAS_STRING_VIEW
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// If a string with this exact contents has already been serialized before,
+  /// instead simply returns the offset of the existing string. This uses a map
+  /// stored on the heap, but only stores the numerical offsets.
+  /// @param[in] str A const std::string_view to store in the buffer.
+  /// @return Returns the offset in the buffer where the string starts
+  Offset<String> CreateSharedString(const flatbuffers::string_view str) {
+    return CreateSharedString(str.data(), str.size());
+  }
+#else
+  /// @brief Store a string in the buffer, which null-terminated.
+  /// If a string with this exact contents has already been serialized before,
+  /// instead simply returns the offset of the existing string. This uses a map
+  /// stored on the heap, but only stores the numerical offsets.
+  /// @param[in] str A const char pointer to a C-string to add to the buffer.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateSharedString(const char *str) {
+    return CreateSharedString(str, strlen(str));
+  }
+
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// If a string with this exact contents has already been serialized before,
+  /// instead simply returns the offset of the existing string. This uses a map
+  /// stored on the heap, but only stores the numerical offsets.
+  /// @param[in] str A const reference to a std::string to store in the buffer.
+  /// @return Returns the offset in the buffer where the string starts.
+  Offset<String> CreateSharedString(const std::string &str) {
+    return CreateSharedString(str.c_str(), str.length());
+  }
+#endif
+
+  /// @brief Store a string in the buffer, which can contain any binary data.
+  /// If a string with this exact contents has already been serialized before,
+  /// instead simply returns the offset of the existing string. This uses a map
+  /// stored on the heap, but only stores the numerical offsets.
+  /// @param[in] str A const pointer to a `String` struct to add to the buffer.
+  /// @return Returns the offset in the buffer where the string starts
+  Offset<String> CreateSharedString(const String *str) {
+    return CreateSharedString(str->c_str(), str->size());
+  }
+
+  /// @cond FLATBUFFERS_INTERNAL
+  uoffset_t EndVector(size_t len) {
+    FLATBUFFERS_ASSERT(nested);  // Hit if no corresponding StartVector.
+    nested = false;
+    return PushElement(static_cast<uoffset_t>(len));
+  }
+
+  void StartVector(size_t len, size_t elemsize) {
+    NotNested();
+    nested = true;
+    PreAlign<uoffset_t>(len * elemsize);
+    PreAlign(len * elemsize, elemsize);  // Just in case elemsize > uoffset_t.
+  }
+
+  // Call this right before StartVector/CreateVector if you want to force the
+  // alignment to be something different than what the element size would
+  // normally dictate.
+  // This is useful when storing a nested_flatbuffer in a vector of bytes,
+  // or when storing SIMD floats, etc.
+  void ForceVectorAlignment(size_t len, size_t elemsize, size_t alignment) {
+    if (len == 0) return;
+    FLATBUFFERS_ASSERT(VerifyAlignmentRequirements(alignment));
+    PreAlign(len * elemsize, alignment);
+  }
+
+  // Similar to ForceVectorAlignment but for String fields.
+  void ForceStringAlignment(size_t len, size_t alignment) {
+    if (len == 0) return;
+    FLATBUFFERS_ASSERT(VerifyAlignmentRequirements(alignment));
+    PreAlign((len + 1) * sizeof(char), alignment);
+  }
+
+  /// @endcond
+
+  /// @brief Serialize an array into a FlatBuffer `vector`.
+  /// @tparam T The data type of the array elements.
+  /// @param[in] v A pointer to the array of type `T` to serialize into the
+  /// buffer as a `vector`.
+  /// @param[in] len The number of elements to serialize.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T> Offset<Vector<T>> CreateVector(const T *v, size_t len) {
+    // If this assert hits, you're specifying a template argument that is
+    // causing the wrong overload to be selected, remove it.
+    AssertScalarT<T>();
+    StartVector(len, sizeof(T));
+    if (len == 0) { return Offset<Vector<T>>(EndVector(len)); }
+    // clang-format off
+    #if FLATBUFFERS_LITTLEENDIAN
+      PushBytes(reinterpret_cast<const uint8_t *>(v), len * sizeof(T));
+    #else
+      if (sizeof(T) == 1) {
+        PushBytes(reinterpret_cast<const uint8_t *>(v), len);
+      } else {
+        for (auto i = len; i > 0; ) {
+          PushElement(v[--i]);
+        }
+      }
+    #endif
+    // clang-format on
+    return Offset<Vector<T>>(EndVector(len));
+  }
+
+  /// @brief Serialize an array like object into a FlatBuffer `vector`.
+  /// @tparam T The data type of the array elements.
+  /// @tparam C The type of the array.
+  /// @param[in] array A reference to an array like object of type `T` to
+  /// serialize into the buffer as a `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, class C> Offset<Vector<T>> CreateVector(const C &array) {
+    return CreateVector(array.data(), array.size());
+  }
+
+  /// @brief Serialize an initializer list into a FlatBuffer `vector`.
+  /// @tparam T The data type of the initializer list elements.
+  /// @param[in] v The value of the initializer list.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T>
+  Offset<Vector<T>> CreateVector(std::initializer_list<T> v) {
+    return CreateVector(v.begin(), v.size());
+  }
+
+  template<typename T>
+  Offset<Vector<Offset<T>>> CreateVector(const Offset<T> *v, size_t len) {
+    StartVector(len, sizeof(Offset<T>));
+    for (auto i = len; i > 0;) { PushElement(v[--i]); }
+    return Offset<Vector<Offset<T>>>(EndVector(len));
+  }
+
+  /// @brief Serialize a `std::vector` into a FlatBuffer `vector`.
+  /// @tparam T The data type of the `std::vector` elements.
+  /// @param v A const reference to the `std::vector` to serialize into the
+  /// buffer as a `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename Alloc = std::allocator<T>>
+  Offset<Vector<T>> CreateVector(const std::vector<T, Alloc> &v) {
+    return CreateVector(data(v), v.size());
+  }
+
+  // vector<bool> may be implemented using a bit-set, so we can't access it as
+  // an array. Instead, read elements manually.
+  // Background: https://isocpp.org/blog/2012/11/on-vectorbool
+  Offset<Vector<uint8_t>> CreateVector(const std::vector<bool> &v) {
+    StartVector(v.size(), sizeof(uint8_t));
+    for (auto i = v.size(); i > 0;) {
+      PushElement(static_cast<uint8_t>(v[--i]));
+    }
+    return Offset<Vector<uint8_t>>(EndVector(v.size()));
+  }
+
+  /// @brief Serialize values returned by a function into a FlatBuffer `vector`.
+  /// This is a convenience function that takes care of iteration for you.
+  /// @tparam T The data type of the `std::vector` elements.
+  /// @param f A function that takes the current iteration 0..vector_size-1 and
+  /// returns any type that you can construct a FlatBuffers vector out of.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T>
+  Offset<Vector<T>> CreateVector(size_t vector_size,
+                                 const std::function<T(size_t i)> &f) {
+    FLATBUFFERS_ASSERT(FLATBUFFERS_GENERAL_HEAP_ALLOC_OK);
+    std::vector<T> elems(vector_size);
+    for (size_t i = 0; i < vector_size; i++) elems[i] = f(i);
+    return CreateVector(elems);
+  }
+
+  /// @brief Serialize values returned by a function into a FlatBuffer `vector`.
+  /// This is a convenience function that takes care of iteration for you. This
+  /// uses a vector stored on the heap to store the intermediate results of the
+  /// iteration.
+  /// @tparam T The data type of the `std::vector` elements.
+  /// @param f A function that takes the current iteration 0..vector_size-1,
+  /// and the state parameter returning any type that you can construct a
+  /// FlatBuffers vector out of.
+  /// @param state State passed to f.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename F, typename S>
+  Offset<Vector<T>> CreateVector(size_t vector_size, F f, S *state) {
+    FLATBUFFERS_ASSERT(FLATBUFFERS_GENERAL_HEAP_ALLOC_OK);
+    std::vector<T> elems(vector_size);
+    for (size_t i = 0; i < vector_size; i++) elems[i] = f(i, state);
+    return CreateVector(elems);
+  }
+
+  /// @brief Serialize a `std::vector<StringType>` into a FlatBuffer `vector`.
+  /// whereas StringType is any type that is accepted by the CreateString()
+  /// overloads.
+  /// This is a convenience function for a common case.
+  /// @param v A const reference to the `std::vector` to serialize into the
+  /// buffer as a `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename StringType = std::string,
+           typename Alloc = std::allocator<StringType>>
+  Offset<Vector<Offset<String>>> CreateVectorOfStrings(
+      const std::vector<StringType, Alloc> &v) {
+    return CreateVectorOfStrings(v.cbegin(), v.cend());
+  }
+
+  /// @brief Serialize a collection of Strings into a FlatBuffer `vector`.
+  /// This is a convenience function for a common case.
+  /// @param begin The begining iterator of the collection
+  /// @param end The ending iterator of the collection
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<class It>
+  Offset<Vector<Offset<String>>> CreateVectorOfStrings(It begin, It end) {
+    auto size = std::distance(begin, end);
+    auto scratch_buffer_usage = size * sizeof(Offset<String>);
+    // If there is not enough space to store the offsets, there definitely won't
+    // be enough space to store all the strings. So ensuring space for the
+    // scratch region is OK, for it it fails, it would have failed later.
+    buf_.ensure_space(scratch_buffer_usage);
+    for (auto it = begin; it != end; ++it) {
+      buf_.scratch_push_small(CreateString(*it));
+    }
+    StartVector(size, sizeof(Offset<String>));
+    for (auto i = 1; i <= size; i++) {
+      // Note we re-evaluate the buf location each iteration to account for any
+      // underlying buffer resizing that may occur.
+      PushElement(*reinterpret_cast<Offset<String> *>(
+          buf_.scratch_end() - i * sizeof(Offset<String>)));
+    }
+    buf_.scratch_pop(scratch_buffer_usage);
+    return Offset<Vector<Offset<String>>>(EndVector(size));
+  }
+
+  /// @brief Serialize an array of structs into a FlatBuffer `vector`.
+  /// @tparam T The data type of the struct array elements.
+  /// @param[in] v A pointer to the array of type `T` to serialize into the
+  /// buffer as a `vector`.
+  /// @param[in] len The number of elements to serialize.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T>
+  Offset<Vector<const T *>> CreateVectorOfStructs(const T *v, size_t len) {
+    StartVector(len * sizeof(T) / AlignOf<T>(), AlignOf<T>());
+    if (len > 0) {
+      PushBytes(reinterpret_cast<const uint8_t *>(v), sizeof(T) * len);
+    }
+    return Offset<Vector<const T *>>(EndVector(len));
+  }
+
+  /// @brief Serialize an array of native structs into a FlatBuffer `vector`.
+  /// @tparam T The data type of the struct array elements.
+  /// @tparam S The data type of the native struct array elements.
+  /// @param[in] v A pointer to the array of type `S` to serialize into the
+  /// buffer as a `vector`.
+  /// @param[in] len The number of elements to serialize.
+  /// @param[in] pack_func Pointer to a function to convert the native struct
+  /// to the FlatBuffer struct.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename S>
+  Offset<Vector<const T *>> CreateVectorOfNativeStructs(
+      const S *v, size_t len, T (*const pack_func)(const S &)) {
+    FLATBUFFERS_ASSERT(pack_func);
+    auto structs = StartVectorOfStructs<T>(len);
+    for (size_t i = 0; i < len; i++) { structs[i] = pack_func(v[i]); }
+    return EndVectorOfStructs<T>(len);
+  }
+
+  /// @brief Serialize an array of native structs into a FlatBuffer `vector`.
+  /// @tparam T The data type of the struct array elements.
+  /// @tparam S The data type of the native struct array elements.
+  /// @param[in] v A pointer to the array of type `S` to serialize into the
+  /// buffer as a `vector`.
+  /// @param[in] len The number of elements to serialize.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename S>
+  Offset<Vector<const T *>> CreateVectorOfNativeStructs(const S *v,
+                                                        size_t len) {
+    extern T Pack(const S &);
+    return CreateVectorOfNativeStructs(v, len, Pack);
+  }
+
+  /// @brief Serialize an array of structs into a FlatBuffer `vector`.
+  /// @tparam T The data type of the struct array elements.
+  /// @param[in] filler A function that takes the current iteration
+  /// 0..vector_size-1 and a pointer to the struct that must be filled.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  /// This is mostly useful when flatbuffers are generated with mutation
+  /// accessors.
+  template<typename T>
+  Offset<Vector<const T *>> CreateVectorOfStructs(
+      size_t vector_size, const std::function<void(size_t i, T *)> &filler) {
+    T *structs = StartVectorOfStructs<T>(vector_size);
+    for (size_t i = 0; i < vector_size; i++) {
+      filler(i, structs);
+      structs++;
+    }
+    return EndVectorOfStructs<T>(vector_size);
+  }
+
+  /// @brief Serialize an array of structs into a FlatBuffer `vector`.
+  /// @tparam T The data type of the struct array elements.
+  /// @param[in] f A function that takes the current iteration 0..vector_size-1,
+  /// a pointer to the struct that must be filled and the state argument.
+  /// @param[in] state Arbitrary state to pass to f.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  /// This is mostly useful when flatbuffers are generated with mutation
+  /// accessors.
+  template<typename T, typename F, typename S>
+  Offset<Vector<const T *>> CreateVectorOfStructs(size_t vector_size, F f,
+                                                  S *state) {
+    T *structs = StartVectorOfStructs<T>(vector_size);
+    for (size_t i = 0; i < vector_size; i++) {
+      f(i, structs, state);
+      structs++;
+    }
+    return EndVectorOfStructs<T>(vector_size);
+  }
+
+  /// @brief Serialize a `std::vector` of structs into a FlatBuffer `vector`.
+  /// @tparam T The data type of the `std::vector` struct elements.
+  /// @param[in] v A const reference to the `std::vector` of structs to
+  /// serialize into the buffer as a `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename Alloc = std::allocator<T>>
+  Offset<Vector<const T *>> CreateVectorOfStructs(
+      const std::vector<T, Alloc> &v) {
+    return CreateVectorOfStructs(data(v), v.size());
+  }
+
+  /// @brief Serialize a `std::vector` of native structs into a FlatBuffer
+  /// `vector`.
+  /// @tparam T The data type of the `std::vector` struct elements.
+  /// @tparam S The data type of the `std::vector` native struct elements.
+  /// @param[in] v A const reference to the `std::vector` of structs to
+  /// serialize into the buffer as a `vector`.
+  /// @param[in] pack_func Pointer to a function to convert the native struct
+  /// to the FlatBuffer struct.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename S, typename Alloc = std::allocator<T>>
+  Offset<Vector<const T *>> CreateVectorOfNativeStructs(
+      const std::vector<S, Alloc> &v, T (*const pack_func)(const S &)) {
+    return CreateVectorOfNativeStructs<T, S>(data(v), v.size(), pack_func);
+  }
+
+  /// @brief Serialize a `std::vector` of native structs into a FlatBuffer
+  /// `vector`.
+  /// @tparam T The data type of the `std::vector` struct elements.
+  /// @tparam S The data type of the `std::vector` native struct elements.
+  /// @param[in] v A const reference to the `std::vector` of structs to
+  /// serialize into the buffer as a `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename S, typename Alloc = std::allocator<S>>
+  Offset<Vector<const T *>> CreateVectorOfNativeStructs(
+      const std::vector<S, Alloc> &v) {
+    return CreateVectorOfNativeStructs<T, S>(data(v), v.size());
+  }
+
+  /// @cond FLATBUFFERS_INTERNAL
+  template<typename T> struct StructKeyComparator {
+    bool operator()(const T &a, const T &b) const {
+      return a.KeyCompareLessThan(&b);
+    }
+  };
+  /// @endcond
+
+  /// @brief Serialize a `std::vector` of structs into a FlatBuffer `vector`
+  /// in sorted order.
+  /// @tparam T The data type of the `std::vector` struct elements.
+  /// @param[in] v A const reference to the `std::vector` of structs to
+  /// serialize into the buffer as a `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename Alloc = std::allocator<T>>
+  Offset<Vector<const T *>> CreateVectorOfSortedStructs(
+      std::vector<T, Alloc> *v) {
+    return CreateVectorOfSortedStructs(data(*v), v->size());
+  }
+
+  /// @brief Serialize a `std::vector` of native structs into a FlatBuffer
+  /// `vector` in sorted order.
+  /// @tparam T The data type of the `std::vector` struct elements.
+  /// @tparam S The data type of the `std::vector` native struct elements.
+  /// @param[in] v A const reference to the `std::vector` of structs to
+  /// serialize into the buffer as a `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename S, typename Alloc = std::allocator<T>>
+  Offset<Vector<const T *>> CreateVectorOfSortedNativeStructs(
+      std::vector<S, Alloc> *v) {
+    return CreateVectorOfSortedNativeStructs<T, S>(data(*v), v->size());
+  }
+
+  /// @brief Serialize an array of structs into a FlatBuffer `vector` in sorted
+  /// order.
+  /// @tparam T The data type of the struct array elements.
+  /// @param[in] v A pointer to the array of type `T` to serialize into the
+  /// buffer as a `vector`.
+  /// @param[in] len The number of elements to serialize.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T>
+  Offset<Vector<const T *>> CreateVectorOfSortedStructs(T *v, size_t len) {
+    std::stable_sort(v, v + len, StructKeyComparator<T>());
+    return CreateVectorOfStructs(v, len);
+  }
+
+  /// @brief Serialize an array of native structs into a FlatBuffer `vector` in
+  /// sorted order.
+  /// @tparam T The data type of the struct array elements.
+  /// @tparam S The data type of the native struct array elements.
+  /// @param[in] v A pointer to the array of type `S` to serialize into the
+  /// buffer as a `vector`.
+  /// @param[in] len The number of elements to serialize.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename S>
+  Offset<Vector<const T *>> CreateVectorOfSortedNativeStructs(S *v,
+                                                              size_t len) {
+    extern T Pack(const S &);
+    auto structs = StartVectorOfStructs<T>(len);
+    for (size_t i = 0; i < len; i++) { structs[i] = Pack(v[i]); }
+    std::stable_sort(structs, structs + len, StructKeyComparator<T>());
+    return EndVectorOfStructs<T>(len);
+  }
+
+  /// @cond FLATBUFFERS_INTERNAL
+  template<typename T> struct TableKeyComparator {
+    TableKeyComparator(vector_downward &buf) : buf_(buf) {}
+    TableKeyComparator(const TableKeyComparator &other) : buf_(other.buf_) {}
+    bool operator()(const Offset<T> &a, const Offset<T> &b) const {
+      auto table_a = reinterpret_cast<T *>(buf_.data_at(a.o));
+      auto table_b = reinterpret_cast<T *>(buf_.data_at(b.o));
+      return table_a->KeyCompareLessThan(table_b);
+    }
+    vector_downward &buf_;
+
+   private:
+    FLATBUFFERS_DELETE_FUNC(
+        TableKeyComparator &operator=(const TableKeyComparator &other));
+  };
+  /// @endcond
+
+  /// @brief Serialize an array of `table` offsets as a `vector` in the buffer
+  /// in sorted order.
+  /// @tparam T The data type that the offset refers to.
+  /// @param[in] v An array of type `Offset<T>` that contains the `table`
+  /// offsets to store in the buffer in sorted order.
+  /// @param[in] len The number of elements to store in the `vector`.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T>
+  Offset<Vector<Offset<T>>> CreateVectorOfSortedTables(Offset<T> *v,
+                                                       size_t len) {
+    std::stable_sort(v, v + len, TableKeyComparator<T>(buf_));
+    return CreateVector(v, len);
+  }
+
+  /// @brief Serialize an array of `table` offsets as a `vector` in the buffer
+  /// in sorted order.
+  /// @tparam T The data type that the offset refers to.
+  /// @param[in] v An array of type `Offset<T>` that contains the `table`
+  /// offsets to store in the buffer in sorted order.
+  /// @return Returns a typed `Offset` into the serialized data indicating
+  /// where the vector is stored.
+  template<typename T, typename Alloc = std::allocator<T>>
+  Offset<Vector<Offset<T>>> CreateVectorOfSortedTables(
+      std::vector<Offset<T>, Alloc> *v) {
+    return CreateVectorOfSortedTables(data(*v), v->size());
+  }
+
+  /// @brief Specialized version of `CreateVector` for non-copying use cases.
+  /// Write the data any time later to the returned buffer pointer `buf`.
+  /// @param[in] len The number of elements to store in the `vector`.
+  /// @param[in] elemsize The size of each element in the `vector`.
+  /// @param[out] buf A pointer to a `uint8_t` pointer that can be
+  /// written to at a later time to serialize the data into a `vector`
+  /// in the buffer.
+  uoffset_t CreateUninitializedVector(size_t len, size_t elemsize,
+                                      uint8_t **buf) {
+    NotNested();
+    StartVector(len, elemsize);
+    buf_.make_space(len * elemsize);
+    auto vec_start = GetSize();
+    auto vec_end = EndVector(len);
+    *buf = buf_.data_at(vec_start);
+    return vec_end;
+  }
+
+  /// @brief Specialized version of `CreateVector` for non-copying use cases.
+  /// Write the data any time later to the returned buffer pointer `buf`.
+  /// @tparam T The data type of the data that will be stored in the buffer
+  /// as a `vector`.
+  /// @param[in] len The number of elements to store in the `vector`.
+  /// @param[out] buf A pointer to a pointer of type `T` that can be
+  /// written to at a later time to serialize the data into a `vector`
+  /// in the buffer.
+  template<typename T>
+  Offset<Vector<T>> CreateUninitializedVector(size_t len, T **buf) {
+    AssertScalarT<T>();
+    return CreateUninitializedVector(len, sizeof(T),
+                                     reinterpret_cast<uint8_t **>(buf));
+  }
+
+  template<typename T>
+  Offset<Vector<const T *>> CreateUninitializedVectorOfStructs(size_t len,
+                                                               T **buf) {
+    return CreateUninitializedVector(len, sizeof(T),
+                                     reinterpret_cast<uint8_t **>(buf));
+  }
+
+  // @brief Create a vector of scalar type T given as input a vector of scalar
+  // type U, useful with e.g. pre "enum class" enums, or any existing scalar
+  // data of the wrong type.
+  template<typename T, typename U>
+  Offset<Vector<T>> CreateVectorScalarCast(const U *v, size_t len) {
+    AssertScalarT<T>();
+    AssertScalarT<U>();
+    StartVector(len, sizeof(T));
+    for (auto i = len; i > 0;) { PushElement(static_cast<T>(v[--i])); }
+    return Offset<Vector<T>>(EndVector(len));
+  }
+
+  /// @brief Write a struct by itself, typically to be part of a union.
+  template<typename T> Offset<const T *> CreateStruct(const T &structobj) {
+    NotNested();
+    Align(AlignOf<T>());
+    buf_.push_small(structobj);
+    return Offset<const T *>(GetSize());
+  }
+
+  /// @brief Finish serializing a buffer by writing the root offset.
+  /// @param[in] file_identifier If a `file_identifier` is given, the buffer
+  /// will be prefixed with a standard FlatBuffers file header.
+  template<typename T>
+  void Finish(Offset<T> root, const char *file_identifier = nullptr) {
+    Finish(root.o, file_identifier, false);
+  }
+
+  /// @brief Finish a buffer with a 32 bit size field pre-fixed (size of the
+  /// buffer following the size field). These buffers are NOT compatible
+  /// with standard buffers created by Finish, i.e. you can't call GetRoot
+  /// on them, you have to use GetSizePrefixedRoot instead.
+  /// All >32 bit quantities in this buffer will be aligned when the whole
+  /// size pre-fixed buffer is aligned.
+  /// These kinds of buffers are useful for creating a stream of FlatBuffers.
+  template<typename T>
+  void FinishSizePrefixed(Offset<T> root,
+                          const char *file_identifier = nullptr) {
+    Finish(root.o, file_identifier, true);
+  }
+
+  void SwapBufAllocator(FlatBufferBuilder &other) {
+    buf_.swap_allocator(other.buf_);
+  }
+
+  /// @brief The length of a FlatBuffer file header.
+  static const size_t kFileIdentifierLength =
+      ::mapserver::flatbuffers::kFileIdentifierLength;
+
+ protected:
+  // You shouldn't really be copying instances of this class.
+  FlatBufferBuilder(const FlatBufferBuilder &);
+  FlatBufferBuilder &operator=(const FlatBufferBuilder &);
+
+  void Finish(uoffset_t root, const char *file_identifier, bool size_prefix) {
+    NotNested();
+    buf_.clear_scratch();
+    // This will cause the whole buffer to be aligned.
+    PreAlign((size_prefix ? sizeof(uoffset_t) : 0) + sizeof(uoffset_t) +
+                 (file_identifier ? kFileIdentifierLength : 0),
+             minalign_);
+    if (file_identifier) {
+      FLATBUFFERS_ASSERT(strlen(file_identifier) == kFileIdentifierLength);
+      PushBytes(reinterpret_cast<const uint8_t *>(file_identifier),
+                kFileIdentifierLength);
+    }
+    PushElement(ReferTo(root));  // Location of root.
+    if (size_prefix) { PushElement(GetSize()); }
+    finished = true;
+  }
+
+  struct FieldLoc {
+    uoffset_t off;
+    voffset_t id;
+  };
+
+  vector_downward buf_;
+
+  // Accumulating offsets of table members while it is being built.
+  // We store these in the scratch pad of buf_, after the vtable offsets.
+  uoffset_t num_field_loc;
+  // Track how much of the vtable is in use, so we can output the most compact
+  // possible vtable.
+  voffset_t max_voffset_;
+
+  // Ensure objects are not nested.
+  bool nested;
+
+  // Ensure the buffer is finished before it is being accessed.
+  bool finished;
+
+  size_t minalign_;
+
+  bool force_defaults_;  // Serialize values equal to their defaults anyway.
+
+  bool dedup_vtables_;
+
+  struct StringOffsetCompare {
+    StringOffsetCompare(const vector_downward &buf) : buf_(&buf) {}
+    bool operator()(const Offset<String> &a, const Offset<String> &b) const {
+      auto stra = reinterpret_cast<const String *>(buf_->data_at(a.o));
+      auto strb = reinterpret_cast<const String *>(buf_->data_at(b.o));
+      return StringLessThan(stra->data(), stra->size(), strb->data(),
+                            strb->size());
+    }
+    const vector_downward *buf_;
+  };
+
+  // For use with CreateSharedString. Instantiated on first use only.
+  typedef std::set<Offset<String>, StringOffsetCompare> StringOffsetMap;
+  StringOffsetMap *string_pool;
+
+ private:
+  // Allocates space for a vector of structures.
+  // Must be completed with EndVectorOfStructs().
+  template<typename T> T *StartVectorOfStructs(size_t vector_size) {
+    StartVector(vector_size * sizeof(T) / AlignOf<T>(), AlignOf<T>());
+    return reinterpret_cast<T *>(buf_.make_space(vector_size * sizeof(T)));
+  }
+
+  // End the vector of structures in the flatbuffers.
+  // Vector should have previously be started with StartVectorOfStructs().
+  template<typename T>
+  Offset<Vector<const T *>> EndVectorOfStructs(size_t vector_size) {
+    return Offset<Vector<const T *>>(EndVector(vector_size));
+  }
+};
+/// @}
+
+/// Helpers to get a typed pointer to objects that are currently being built.
+/// @warning Creating new objects will lead to reallocations and invalidates
+/// the pointer!
+template<typename T>
+T *GetMutableTemporaryPointer(FlatBufferBuilder &fbb, Offset<T> offset) {
+  return reinterpret_cast<T *>(fbb.GetCurrentBufferPointer() + fbb.GetSize() -
+                               offset.o);
+}
+
+template<typename T>
+const T *GetTemporaryPointer(FlatBufferBuilder &fbb, Offset<T> offset) {
+  return GetMutableTemporaryPointer<T>(fbb, offset);
+}
+
+template<typename T>
+void FlatBufferBuilder::Required(Offset<T> table, voffset_t field) {
+  auto table_ptr = reinterpret_cast<const Table *>(buf_.data_at(table.o));
+  bool ok = table_ptr->GetOptionalFieldOffset(field) != 0;
+  // If this fails, the caller will show what field needs to be set.
+  FLATBUFFERS_ASSERT(ok);
+  (void)ok;
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_VECTOR_DOWNWARD_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/flatbuffers.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flatbuffers.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/flatbuffers.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flatbuffers.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,272 @@
+/*
+ * Copyright 2014 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_H_
+#define FLATBUFFERS_H_
+
+// TODO: These includes are for mitigating the pains of users editing their
+// source because they relied on flatbuffers.h to include everything for them.
+#include "flatbuffers/array.h"
+#include "flatbuffers/base.h"
+#include "flatbuffers/buffer.h"
+#include "flatbuffers/buffer_ref.h"
+#include "flatbuffers/detached_buffer.h"
+#include "flatbuffers/flatbuffer_builder.h"
+#include "flatbuffers/stl_emulation.h"
+#include "flatbuffers/string.h"
+#include "flatbuffers/struct.h"
+#include "flatbuffers/table.h"
+#include "flatbuffers/vector.h"
+#include "flatbuffers/vector_downward.h"
+#include "flatbuffers/verifier.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+/// @brief This can compute the start of a FlatBuffer from a root pointer, i.e.
+/// it is the opposite transformation of GetRoot().
+/// This may be useful if you want to pass on a root and have the recipient
+/// delete the buffer afterwards.
+inline const uint8_t *GetBufferStartFromRootPointer(const void *root) {
+  auto table = reinterpret_cast<const Table *>(root);
+  auto vtable = table->GetVTable();
+  // Either the vtable is before the root or after the root.
+  auto start = (std::min)(vtable, reinterpret_cast<const uint8_t *>(root));
+  // Align to at least sizeof(uoffset_t).
+  start = reinterpret_cast<const uint8_t *>(reinterpret_cast<uintptr_t>(start) &
+                                            ~(sizeof(uoffset_t) - 1));
+  // Additionally, there may be a file_identifier in the buffer, and the root
+  // offset. The buffer may have been aligned to any size between
+  // sizeof(uoffset_t) and FLATBUFFERS_MAX_ALIGNMENT (see "force_align").
+  // Sadly, the exact alignment is only known when constructing the buffer,
+  // since it depends on the presence of values with said alignment properties.
+  // So instead, we simply look at the next uoffset_t values (root,
+  // file_identifier, and alignment padding) to see which points to the root.
+  // None of the other values can "impersonate" the root since they will either
+  // be 0 or four ASCII characters.
+  static_assert(flatbuffers::kFileIdentifierLength == sizeof(uoffset_t),
+                "file_identifier is assumed to be the same size as uoffset_t");
+  for (auto possible_roots = FLATBUFFERS_MAX_ALIGNMENT / sizeof(uoffset_t) + 1;
+       possible_roots; possible_roots--) {
+    start -= sizeof(uoffset_t);
+    if (ReadScalar<uoffset_t>(start) + start ==
+        reinterpret_cast<const uint8_t *>(root))
+      return start;
+  }
+  // We didn't find the root, either the "root" passed isn't really a root,
+  // or the buffer is corrupt.
+  // Assert, because calling this function with bad data may cause reads
+  // outside of buffer boundaries.
+  FLATBUFFERS_ASSERT(false);
+  return nullptr;
+}
+
+/// @brief This return the prefixed size of a FlatBuffer.
+inline uoffset_t GetPrefixedSize(const uint8_t *buf) {
+  return ReadScalar<uoffset_t>(buf);
+}
+
+// Base class for native objects (FlatBuffer data de-serialized into native
+// C++ data structures).
+// Contains no functionality, purely documentative.
+struct NativeTable {};
+
+/// @brief Function types to be used with resolving hashes into objects and
+/// back again. The resolver gets a pointer to a field inside an object API
+/// object that is of the type specified in the schema using the attribute
+/// `cpp_type` (it is thus important whatever you write to this address
+/// matches that type). The value of this field is initially null, so you
+/// may choose to implement a delayed binding lookup using this function
+/// if you wish. The resolver does the opposite lookup, for when the object
+/// is being serialized again.
+typedef uint64_t hash_value_t;
+typedef std::function<void(void **pointer_adr, hash_value_t hash)>
+    resolver_function_t;
+typedef std::function<hash_value_t(void *pointer)> rehasher_function_t;
+
+// Helper function to test if a field is present, using any of the field
+// enums in the generated code.
+// `table` must be a generated table type. Since this is a template parameter,
+// this is not typechecked to be a subclass of Table, so beware!
+// Note: this function will return false for fields equal to the default
+// value, since they're not stored in the buffer (unless force_defaults was
+// used).
+template<typename T>
+bool IsFieldPresent(const T *table, typename T::FlatBuffersVTableOffset field) {
+  // Cast, since Table is a private baseclass of any table types.
+  return reinterpret_cast<const Table *>(table)->CheckField(
+      static_cast<voffset_t>(field));
+}
+
+// Utility function for reverse lookups on the EnumNames*() functions
+// (in the generated C++ code)
+// names must be NULL terminated.
+inline int LookupEnum(const char **names, const char *name) {
+  for (const char **p = names; *p; p++)
+    if (!strcmp(*p, name)) return static_cast<int>(p - names);
+  return -1;
+}
+
+// These macros allow us to layout a struct with a guarantee that they'll end
+// up looking the same on different compilers and platforms.
+// It does this by disallowing the compiler to do any padding, and then
+// does padding itself by inserting extra padding fields that make every
+// element aligned to its own size.
+// Additionally, it manually sets the alignment of the struct as a whole,
+// which is typically its largest element, or a custom size set in the schema
+// by the force_align attribute.
+// These are used in the generated code only.
+
+// clang-format off
+#if defined(_MSC_VER)
+  #define FLATBUFFERS_MANUALLY_ALIGNED_STRUCT(alignment) \
+    __pragma(pack(1)) \
+    struct __declspec(align(alignment))
+  #define FLATBUFFERS_STRUCT_END(name, size) \
+    __pragma(pack()) \
+    static_assert(sizeof(name) == size, "compiler breaks packing rules")
+#elif defined(__GNUC__) || defined(__clang__) || defined(__ICCARM__)
+  #define FLATBUFFERS_MANUALLY_ALIGNED_STRUCT(alignment) \
+    _Pragma("pack(1)") \
+    struct __attribute__((aligned(alignment)))
+  #define FLATBUFFERS_STRUCT_END(name, size) \
+    _Pragma("pack()") \
+    static_assert(sizeof(name) == size, "compiler breaks packing rules")
+#else
+  #error Unknown compiler, please define structure alignment macros
+#endif
+// clang-format on
+
+// Minimal reflection via code generation.
+// Besides full-fat reflection (see reflection.h) and parsing/printing by
+// loading schemas (see idl.h), we can also have code generation for minimal
+// reflection data which allows pretty-printing and other uses without needing
+// a schema or a parser.
+// Generate code with --reflect-types (types only) or --reflect-names (names
+// also) to enable.
+// See minireflect.h for utilities using this functionality.
+
+// These types are organized slightly differently as the ones in idl.h.
+enum SequenceType { ST_TABLE, ST_STRUCT, ST_UNION, ST_ENUM };
+
+// Scalars have the same order as in idl.h
+// clang-format off
+#define FLATBUFFERS_GEN_ELEMENTARY_TYPES(ET) \
+  ET(ET_UTYPE) \
+  ET(ET_BOOL) \
+  ET(ET_CHAR) \
+  ET(ET_UCHAR) \
+  ET(ET_SHORT) \
+  ET(ET_USHORT) \
+  ET(ET_INT) \
+  ET(ET_UINT) \
+  ET(ET_LONG) \
+  ET(ET_ULONG) \
+  ET(ET_FLOAT) \
+  ET(ET_DOUBLE) \
+  ET(ET_STRING) \
+  ET(ET_SEQUENCE)  // See SequenceType.
+
+enum ElementaryType {
+  #define FLATBUFFERS_ET(E) E,
+    FLATBUFFERS_GEN_ELEMENTARY_TYPES(FLATBUFFERS_ET)
+  #undef FLATBUFFERS_ET
+};
+
+inline const char * const *ElementaryTypeNames() {
+  static const char * const names[] = {
+    #define FLATBUFFERS_ET(E) #E,
+      FLATBUFFERS_GEN_ELEMENTARY_TYPES(FLATBUFFERS_ET)
+    #undef FLATBUFFERS_ET
+  };
+  return names;
+}
+// clang-format on
+
+// Basic type info cost just 16bits per field!
+// We're explicitly defining the signedness since the signedness of integer
+// bitfields is otherwise implementation-defined and causes warnings on older
+// GCC compilers.
+struct TypeCode {
+  // ElementaryType
+  unsigned short base_type : 4;
+  // Either vector (in table) or array (in struct)
+  unsigned short is_repeating : 1;
+  // Index into type_refs below, or -1 for none.
+  signed short sequence_ref : 11;
+};
+
+static_assert(sizeof(TypeCode) == 2, "TypeCode");
+
+struct TypeTable;
+
+// Signature of the static method present in each type.
+typedef const TypeTable *(*TypeFunction)();
+
+struct TypeTable {
+  SequenceType st;
+  size_t num_elems;  // of type_codes, values, names (but not type_refs).
+  const TypeCode *type_codes;     // num_elems count
+  const TypeFunction *type_refs;  // less than num_elems entries (see TypeCode).
+  const int16_t *array_sizes;     // less than num_elems entries (see TypeCode).
+  const int64_t *values;  // Only set for non-consecutive enum/union or structs.
+  const char *const *names;  // Only set if compiled with --reflect-names.
+};
+
+// String which identifies the current version of FlatBuffers.
+inline const char *flatbuffers_version_string() {
+  return "FlatBuffers " FLATBUFFERS_STRING(FLATBUFFERS_VERSION_MAJOR) "."
+      FLATBUFFERS_STRING(FLATBUFFERS_VERSION_MINOR) "."
+      FLATBUFFERS_STRING(FLATBUFFERS_VERSION_REVISION);
+}
+
+// clang-format off
+#define FLATBUFFERS_DEFINE_BITMASK_OPERATORS(E, T)\
+    inline E operator | (E lhs, E rhs){\
+        return E(T(lhs) | T(rhs));\
+    }\
+    inline E operator & (E lhs, E rhs){\
+        return E(T(lhs) & T(rhs));\
+    }\
+    inline E operator ^ (E lhs, E rhs){\
+        return E(T(lhs) ^ T(rhs));\
+    }\
+    inline E operator ~ (E lhs){\
+        return E(~T(lhs));\
+    }\
+    inline E operator |= (E &lhs, E rhs){\
+        lhs = lhs | rhs;\
+        return lhs;\
+    }\
+    inline E operator &= (E &lhs, E rhs){\
+        lhs = lhs & rhs;\
+        return lhs;\
+    }\
+    inline E operator ^= (E &lhs, E rhs){\
+        lhs = lhs ^ rhs;\
+        return lhs;\
+    }\
+    inline bool operator !(E rhs) \
+    {\
+        return !bool(T(rhs)); \
+    }
+/// @endcond
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+// clang-format on
+
+#endif  // FLATBUFFERS_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/flatc.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flatc.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/flatc.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flatc.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,118 @@
+/*
+ * Copyright 2017 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_FLATC_H_
+#define FLATBUFFERS_FLATC_H_
+
+#include <functional>
+#include <limits>
+#include <string>
+
+#include "flatbuffers/bfbs_generator.h"
+#include "flatbuffers/flatbuffers.h"
+#include "flatbuffers/idl.h"
+#include "flatbuffers/util.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+extern void LogCompilerWarn(const std::string &warn);
+extern void LogCompilerError(const std::string &err);
+
+struct FlatCOption {
+  std::string short_opt;
+  std::string long_opt;
+  std::string parameter;
+  std::string description;
+};
+
+class FlatCompiler {
+ public:
+  // Output generator for the various programming languages and formats we
+  // support.
+  struct Generator {
+    typedef bool (*GenerateFn)(const flatbuffers::Parser &parser,
+                               const std::string &path,
+                               const std::string &file_name);
+    typedef std::string (*MakeRuleFn)(const flatbuffers::Parser &parser,
+                                      const std::string &path,
+                                      const std::string &file_name);
+    typedef bool (*ParsingCompletedFn)(const flatbuffers::Parser &parser,
+                                       const std::string &output_path);
+
+    GenerateFn generate;
+    const char *lang_name;
+    bool schema_only;
+    GenerateFn generateGRPC;
+    flatbuffers::IDLOptions::Language lang;
+    FlatCOption option;
+    MakeRuleFn make_rule;
+    BfbsGenerator *bfbs_generator;
+    ParsingCompletedFn parsing_completed;
+  };
+
+  typedef void (*WarnFn)(const FlatCompiler *flatc, const std::string &warn,
+                         bool show_exe_name);
+
+  typedef void (*ErrorFn)(const FlatCompiler *flatc, const std::string &err,
+                          bool usage, bool show_exe_name);
+
+  // Parameters required to initialize the FlatCompiler.
+  struct InitParams {
+    InitParams()
+        : generators(nullptr),
+          num_generators(0),
+          warn_fn(nullptr),
+          error_fn(nullptr) {}
+
+    const Generator *generators;
+    size_t num_generators;
+    WarnFn warn_fn;
+    ErrorFn error_fn;
+  };
+
+  explicit FlatCompiler(const InitParams &params) : params_(params) {}
+
+  int Compile(int argc, const char **argv);
+
+  std::string GetShortUsageString(const char *program_name) const;
+  std::string GetUsageString(const char *program_name) const;
+
+ private:
+  void ParseFile(flatbuffers::Parser &parser, const std::string &filename,
+                 const std::string &contents,
+                 std::vector<const char *> &include_directories) const;
+
+  void LoadBinarySchema(Parser &parser, const std::string &filename,
+                        const std::string &contents);
+
+  void Warn(const std::string &warn, bool show_exe_name = true) const;
+
+  void Error(const std::string &err, bool usage = true,
+             bool show_exe_name = true) const;
+
+  void AnnotateBinaries(const uint8_t *binary_schema,
+                        uint64_t binary_schema_size,
+                        const std::string & schema_filename,
+                        const std::vector<std::string> &binary_files);
+
+  InitParams params_;
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_FLATC_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/flex_flat_util.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flex_flat_util.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/flex_flat_util.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flex_flat_util.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,36 @@
+/*
+ * Copyright 2022 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_FLEX_FLAT_UTIL_H_
+#define FLATBUFFERS_FLEX_FLAT_UTIL_H_
+
+#include "flatbuffers/flatbuffers.h"
+#include "flatbuffers/flexbuffers.h"
+
+namespace flexbuffers {
+
+// Verifies the `nested` flexbuffer within a flatbuffer vector is valid.
+inline bool VerifyNestedFlexBuffer(
+    const flatbuffers::Vector<uint8_t> *const nested,
+    flatbuffers::Verifier &verifier) {
+  if (!nested) return true;
+  return verifier.Check(flexbuffers::VerifyBuffer(
+      nested->data(), nested->size(), verifier.GetFlexReuseTracker()));
+}
+
+}  // namespace flexbuffers
+
+#endif  // FLATBUFFERS_FLEX_FLAT_UTIL_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/flexbuffers.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flexbuffers.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/flexbuffers.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/flexbuffers.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1888 @@
+/*
+ * Copyright 2017 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_FLEXBUFFERS_H_
+#define FLATBUFFERS_FLEXBUFFERS_H_
+
+#include <map>
+// Used to select STL variant.
+#include "flatbuffers/base.h"
+// We use the basic binary writing functions from the regular FlatBuffers.
+#include "flatbuffers/util.h"
+
+#ifdef _MSC_VER
+#  include <intrin.h>
+#endif
+
+#if defined(_MSC_VER)
+#  pragma warning(push)
+#  pragma warning(disable : 4127)  // C4127: conditional expression is constant
+#endif
+
+namespace flexbuffers {
+
+class Reference;
+class Map;
+
+// These are used in the lower 2 bits of a type field to determine the size of
+// the elements (and or size field) of the item pointed to (e.g. vector).
+enum BitWidth {
+  BIT_WIDTH_8 = 0,
+  BIT_WIDTH_16 = 1,
+  BIT_WIDTH_32 = 2,
+  BIT_WIDTH_64 = 3,
+};
+
+// These are used as the upper 6 bits of a type field to indicate the actual
+// type.
+enum Type {
+  FBT_NULL = 0,
+  FBT_INT = 1,
+  FBT_UINT = 2,
+  FBT_FLOAT = 3,
+  // Types above stored inline, types below (except FBT_BOOL) store an offset.
+  FBT_KEY = 4,
+  FBT_STRING = 5,
+  FBT_INDIRECT_INT = 6,
+  FBT_INDIRECT_UINT = 7,
+  FBT_INDIRECT_FLOAT = 8,
+  FBT_MAP = 9,
+  FBT_VECTOR = 10,      // Untyped.
+  FBT_VECTOR_INT = 11,  // Typed any size (stores no type table).
+  FBT_VECTOR_UINT = 12,
+  FBT_VECTOR_FLOAT = 13,
+  FBT_VECTOR_KEY = 14,
+  // DEPRECATED, use FBT_VECTOR or FBT_VECTOR_KEY instead.
+  // Read test.cpp/FlexBuffersDeprecatedTest() for details on why.
+  FBT_VECTOR_STRING_DEPRECATED = 15,
+  FBT_VECTOR_INT2 = 16,  // Typed tuple (no type table, no size field).
+  FBT_VECTOR_UINT2 = 17,
+  FBT_VECTOR_FLOAT2 = 18,
+  FBT_VECTOR_INT3 = 19,  // Typed triple (no type table, no size field).
+  FBT_VECTOR_UINT3 = 20,
+  FBT_VECTOR_FLOAT3 = 21,
+  FBT_VECTOR_INT4 = 22,  // Typed quad (no type table, no size field).
+  FBT_VECTOR_UINT4 = 23,
+  FBT_VECTOR_FLOAT4 = 24,
+  FBT_BLOB = 25,
+  FBT_BOOL = 26,
+  FBT_VECTOR_BOOL =
+      36,  // To Allow the same type of conversion of type to vector type
+
+  FBT_MAX_TYPE = 37
+};
+
+inline bool IsInline(Type t) { return t <= FBT_FLOAT || t == FBT_BOOL; }
+
+inline bool IsTypedVectorElementType(Type t) {
+  return (t >= FBT_INT && t <= FBT_STRING) || t == FBT_BOOL;
+}
+
+inline bool IsTypedVector(Type t) {
+  return (t >= FBT_VECTOR_INT && t <= FBT_VECTOR_STRING_DEPRECATED) ||
+         t == FBT_VECTOR_BOOL;
+}
+
+inline bool IsFixedTypedVector(Type t) {
+  return t >= FBT_VECTOR_INT2 && t <= FBT_VECTOR_FLOAT4;
+}
+
+inline Type ToTypedVector(Type t, size_t fixed_len = 0) {
+  FLATBUFFERS_ASSERT(IsTypedVectorElementType(t));
+  switch (fixed_len) {
+    case 0: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT);
+    case 2: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT2);
+    case 3: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT3);
+    case 4: return static_cast<Type>(t - FBT_INT + FBT_VECTOR_INT4);
+    default: FLATBUFFERS_ASSERT(0); return FBT_NULL;
+  }
+}
+
+inline Type ToTypedVectorElementType(Type t) {
+  FLATBUFFERS_ASSERT(IsTypedVector(t));
+  return static_cast<Type>(t - FBT_VECTOR_INT + FBT_INT);
+}
+
+inline Type ToFixedTypedVectorElementType(Type t, uint8_t *len) {
+  FLATBUFFERS_ASSERT(IsFixedTypedVector(t));
+  auto fixed_type = t - FBT_VECTOR_INT2;
+  *len = static_cast<uint8_t>(fixed_type / 3 +
+                              2);  // 3 types each, starting from length 2.
+  return static_cast<Type>(fixed_type % 3 + FBT_INT);
+}
+
+// TODO: implement proper support for 8/16bit floats, or decide not to
+// support them.
+typedef int16_t half;
+typedef int8_t quarter;
+
+// TODO: can we do this without conditionals using intrinsics or inline asm
+// on some platforms? Given branch prediction the method below should be
+// decently quick, but it is the most frequently executed function.
+// We could do an (unaligned) 64-bit read if we ifdef out the platforms for
+// which that doesn't work (or where we'd read into un-owned memory).
+template<typename R, typename T1, typename T2, typename T4, typename T8>
+R ReadSizedScalar(const uint8_t *data, uint8_t byte_width) {
+  return byte_width < 4
+             ? (byte_width < 2
+                    ? static_cast<R>(flatbuffers::ReadScalar<T1>(data))
+                    : static_cast<R>(flatbuffers::ReadScalar<T2>(data)))
+             : (byte_width < 8
+                    ? static_cast<R>(flatbuffers::ReadScalar<T4>(data))
+                    : static_cast<R>(flatbuffers::ReadScalar<T8>(data)));
+}
+
+inline int64_t ReadInt64(const uint8_t *data, uint8_t byte_width) {
+  return ReadSizedScalar<int64_t, int8_t, int16_t, int32_t, int64_t>(
+      data, byte_width);
+}
+
+inline uint64_t ReadUInt64(const uint8_t *data, uint8_t byte_width) {
+  // This is the "hottest" function (all offset lookups use this), so worth
+  // optimizing if possible.
+  // TODO: GCC apparently replaces memcpy by a rep movsb, but only if count is a
+  // constant, which here it isn't. Test if memcpy is still faster than
+  // the conditionals in ReadSizedScalar. Can also use inline asm.
+
+  // clang-format off
+  #if defined(_MSC_VER) && defined(_M_X64) && !defined(_M_ARM64EC)
+  // This is 64-bit Windows only, __movsb does not work on 32-bit Windows.
+    uint64_t u = 0;
+    __movsb(reinterpret_cast<uint8_t *>(&u),
+            reinterpret_cast<const uint8_t *>(data), byte_width);
+    return flatbuffers::EndianScalar(u);
+  #else
+    return ReadSizedScalar<uint64_t, uint8_t, uint16_t, uint32_t, uint64_t>(
+             data, byte_width);
+  #endif
+  // clang-format on
+}
+
+inline double ReadDouble(const uint8_t *data, uint8_t byte_width) {
+  return ReadSizedScalar<double, quarter, half, float, double>(data,
+                                                               byte_width);
+}
+
+inline const uint8_t *Indirect(const uint8_t *offset, uint8_t byte_width) {
+  return offset - ReadUInt64(offset, byte_width);
+}
+
+template<typename T> const uint8_t *Indirect(const uint8_t *offset) {
+  return offset - flatbuffers::ReadScalar<T>(offset);
+}
+
+inline BitWidth WidthU(uint64_t u) {
+#define FLATBUFFERS_GET_FIELD_BIT_WIDTH(value, width)                   \
+  {                                                                     \
+    if (!((u) & ~((1ULL << (width)) - 1ULL))) return BIT_WIDTH_##width; \
+  }
+  FLATBUFFERS_GET_FIELD_BIT_WIDTH(u, 8);
+  FLATBUFFERS_GET_FIELD_BIT_WIDTH(u, 16);
+  FLATBUFFERS_GET_FIELD_BIT_WIDTH(u, 32);
+#undef FLATBUFFERS_GET_FIELD_BIT_WIDTH
+  return BIT_WIDTH_64;
+}
+
+inline BitWidth WidthI(int64_t i) {
+  auto u = static_cast<uint64_t>(i) << 1;
+  return WidthU(i >= 0 ? u : ~u);
+}
+
+inline BitWidth WidthF(double f) {
+  return static_cast<double>(static_cast<float>(f)) == f ? BIT_WIDTH_32
+                                                         : BIT_WIDTH_64;
+}
+
+// Base class of all types below.
+// Points into the data buffer and allows access to one type.
+class Object {
+ public:
+  Object(const uint8_t *data, uint8_t byte_width)
+      : data_(data), byte_width_(byte_width) {}
+
+ protected:
+  const uint8_t *data_;
+  uint8_t byte_width_;
+};
+
+// Object that has a size, obtained either from size prefix, or elsewhere.
+class Sized : public Object {
+ public:
+  // Size prefix.
+  Sized(const uint8_t *data, uint8_t byte_width)
+      : Object(data, byte_width), size_(read_size()) {}
+  // Manual size.
+  Sized(const uint8_t *data, uint8_t byte_width, size_t sz)
+      : Object(data, byte_width), size_(sz) {}
+  size_t size() const { return size_; }
+  // Access size stored in `byte_width_` bytes before data_ pointer.
+  size_t read_size() const {
+    return static_cast<size_t>(ReadUInt64(data_ - byte_width_, byte_width_));
+  }
+
+ protected:
+  size_t size_;
+};
+
+class String : public Sized {
+ public:
+  // Size prefix.
+  String(const uint8_t *data, uint8_t byte_width) : Sized(data, byte_width) {}
+  // Manual size.
+  String(const uint8_t *data, uint8_t byte_width, size_t sz)
+      : Sized(data, byte_width, sz) {}
+
+  size_t length() const { return size(); }
+  const char *c_str() const { return reinterpret_cast<const char *>(data_); }
+  std::string str() const { return std::string(c_str(), size()); }
+
+  static String EmptyString() {
+    static const char *empty_string = "";
+    return String(reinterpret_cast<const uint8_t *>(empty_string), 1, 0);
+  }
+  bool IsTheEmptyString() const { return data_ == EmptyString().data_; }
+};
+
+class Blob : public Sized {
+ public:
+  Blob(const uint8_t *data_buf, uint8_t byte_width)
+      : Sized(data_buf, byte_width) {}
+
+  static Blob EmptyBlob() {
+    static const uint8_t empty_blob[] = { 0 /*len*/ };
+    return Blob(empty_blob + 1, 1);
+  }
+  bool IsTheEmptyBlob() const { return data_ == EmptyBlob().data_; }
+  const uint8_t *data() const { return data_; }
+};
+
+class Vector : public Sized {
+ public:
+  Vector(const uint8_t *data, uint8_t byte_width) : Sized(data, byte_width) {}
+
+  Reference operator[](size_t i) const;
+
+  static Vector EmptyVector() {
+    static const uint8_t empty_vector[] = { 0 /*len*/ };
+    return Vector(empty_vector + 1, 1);
+  }
+  bool IsTheEmptyVector() const { return data_ == EmptyVector().data_; }
+};
+
+class TypedVector : public Sized {
+ public:
+  TypedVector(const uint8_t *data, uint8_t byte_width, Type element_type)
+      : Sized(data, byte_width), type_(element_type) {}
+
+  Reference operator[](size_t i) const;
+
+  static TypedVector EmptyTypedVector() {
+    static const uint8_t empty_typed_vector[] = { 0 /*len*/ };
+    return TypedVector(empty_typed_vector + 1, 1, FBT_INT);
+  }
+  bool IsTheEmptyVector() const {
+    return data_ == TypedVector::EmptyTypedVector().data_;
+  }
+
+  Type ElementType() { return type_; }
+
+  friend Reference;
+
+ private:
+  Type type_;
+
+  friend Map;
+};
+
+class FixedTypedVector : public Object {
+ public:
+  FixedTypedVector(const uint8_t *data, uint8_t byte_width, Type element_type,
+                   uint8_t len)
+      : Object(data, byte_width), type_(element_type), len_(len) {}
+
+  Reference operator[](size_t i) const;
+
+  static FixedTypedVector EmptyFixedTypedVector() {
+    static const uint8_t fixed_empty_vector[] = { 0 /* unused */ };
+    return FixedTypedVector(fixed_empty_vector, 1, FBT_INT, 0);
+  }
+  bool IsTheEmptyFixedTypedVector() const {
+    return data_ == FixedTypedVector::EmptyFixedTypedVector().data_;
+  }
+
+  Type ElementType() const { return type_; }
+  uint8_t size() const { return len_; }
+
+ private:
+  Type type_;
+  uint8_t len_;
+};
+
+class Map : public Vector {
+ public:
+  Map(const uint8_t *data, uint8_t byte_width) : Vector(data, byte_width) {}
+
+  Reference operator[](const char *key) const;
+  Reference operator[](const std::string &key) const;
+
+  Vector Values() const { return Vector(data_, byte_width_); }
+
+  TypedVector Keys() const {
+    const size_t num_prefixed_fields = 3;
+    auto keys_offset = data_ - byte_width_ * num_prefixed_fields;
+    return TypedVector(Indirect(keys_offset, byte_width_),
+                       static_cast<uint8_t>(
+                           ReadUInt64(keys_offset + byte_width_, byte_width_)),
+                       FBT_KEY);
+  }
+
+  static Map EmptyMap() {
+    static const uint8_t empty_map[] = {
+      0 /*keys_len*/, 0 /*keys_offset*/, 1 /*keys_width*/, 0 /*len*/
+    };
+    return Map(empty_map + 4, 1);
+  }
+
+  bool IsTheEmptyMap() const { return data_ == EmptyMap().data_; }
+};
+
+template<typename T>
+void AppendToString(std::string &s, T &&v, bool keys_quoted) {
+  s += "[ ";
+  for (size_t i = 0; i < v.size(); i++) {
+    if (i) s += ", ";
+    v[i].ToString(true, keys_quoted, s);
+  }
+  s += " ]";
+}
+
+class Reference {
+ public:
+  Reference()
+      : data_(nullptr), parent_width_(0), byte_width_(0), type_(FBT_NULL) {}
+
+  Reference(const uint8_t *data, uint8_t parent_width, uint8_t byte_width,
+            Type type)
+      : data_(data),
+        parent_width_(parent_width),
+        byte_width_(byte_width),
+        type_(type) {}
+
+  Reference(const uint8_t *data, uint8_t parent_width, uint8_t packed_type)
+      : data_(data), parent_width_(parent_width) {
+    byte_width_ = 1U << static_cast<BitWidth>(packed_type & 3);
+    type_ = static_cast<Type>(packed_type >> 2);
+  }
+
+  Type GetType() const { return type_; }
+
+  bool IsNull() const { return type_ == FBT_NULL; }
+  bool IsBool() const { return type_ == FBT_BOOL; }
+  bool IsInt() const { return type_ == FBT_INT || type_ == FBT_INDIRECT_INT; }
+  bool IsUInt() const {
+    return type_ == FBT_UINT || type_ == FBT_INDIRECT_UINT;
+  }
+  bool IsIntOrUint() const { return IsInt() || IsUInt(); }
+  bool IsFloat() const {
+    return type_ == FBT_FLOAT || type_ == FBT_INDIRECT_FLOAT;
+  }
+  bool IsNumeric() const { return IsIntOrUint() || IsFloat(); }
+  bool IsString() const { return type_ == FBT_STRING; }
+  bool IsKey() const { return type_ == FBT_KEY; }
+  bool IsVector() const { return type_ == FBT_VECTOR || type_ == FBT_MAP; }
+  bool IsUntypedVector() const { return type_ == FBT_VECTOR; }
+  bool IsTypedVector() const { return flexbuffers::IsTypedVector(type_); }
+  bool IsFixedTypedVector() const {
+    return flexbuffers::IsFixedTypedVector(type_);
+  }
+  bool IsAnyVector() const {
+    return (IsTypedVector() || IsFixedTypedVector() || IsVector());
+  }
+  bool IsMap() const { return type_ == FBT_MAP; }
+  bool IsBlob() const { return type_ == FBT_BLOB; }
+  bool AsBool() const {
+    return (type_ == FBT_BOOL ? ReadUInt64(data_, parent_width_)
+                              : AsUInt64()) != 0;
+  }
+
+  // Reads any type as a int64_t. Never fails, does most sensible conversion.
+  // Truncates floats, strings are attempted to be parsed for a number,
+  // vectors/maps return their size. Returns 0 if all else fails.
+  int64_t AsInt64() const {
+    if (type_ == FBT_INT) {
+      // A fast path for the common case.
+      return ReadInt64(data_, parent_width_);
+    } else
+      switch (type_) {
+        case FBT_INDIRECT_INT: return ReadInt64(Indirect(), byte_width_);
+        case FBT_UINT: return ReadUInt64(data_, parent_width_);
+        case FBT_INDIRECT_UINT: return ReadUInt64(Indirect(), byte_width_);
+        case FBT_FLOAT:
+          return static_cast<int64_t>(ReadDouble(data_, parent_width_));
+        case FBT_INDIRECT_FLOAT:
+          return static_cast<int64_t>(ReadDouble(Indirect(), byte_width_));
+        case FBT_NULL: return 0;
+        case FBT_STRING: return flatbuffers::StringToInt(AsString().c_str());
+        case FBT_VECTOR: return static_cast<int64_t>(AsVector().size());
+        case FBT_BOOL: return ReadInt64(data_, parent_width_);
+        default:
+          // Convert other things to int.
+          return 0;
+      }
+  }
+
+  // TODO: could specialize these to not use AsInt64() if that saves
+  // extension ops in generated code, and use a faster op than ReadInt64.
+  int32_t AsInt32() const { return static_cast<int32_t>(AsInt64()); }
+  int16_t AsInt16() const { return static_cast<int16_t>(AsInt64()); }
+  int8_t AsInt8() const { return static_cast<int8_t>(AsInt64()); }
+
+  uint64_t AsUInt64() const {
+    if (type_ == FBT_UINT) {
+      // A fast path for the common case.
+      return ReadUInt64(data_, parent_width_);
+    } else
+      switch (type_) {
+        case FBT_INDIRECT_UINT: return ReadUInt64(Indirect(), byte_width_);
+        case FBT_INT: return ReadInt64(data_, parent_width_);
+        case FBT_INDIRECT_INT: return ReadInt64(Indirect(), byte_width_);
+        case FBT_FLOAT:
+          return static_cast<uint64_t>(ReadDouble(data_, parent_width_));
+        case FBT_INDIRECT_FLOAT:
+          return static_cast<uint64_t>(ReadDouble(Indirect(), byte_width_));
+        case FBT_NULL: return 0;
+        case FBT_STRING: return flatbuffers::StringToUInt(AsString().c_str());
+        case FBT_VECTOR: return static_cast<uint64_t>(AsVector().size());
+        case FBT_BOOL: return ReadUInt64(data_, parent_width_);
+        default:
+          // Convert other things to uint.
+          return 0;
+      }
+  }
+
+  uint32_t AsUInt32() const { return static_cast<uint32_t>(AsUInt64()); }
+  uint16_t AsUInt16() const { return static_cast<uint16_t>(AsUInt64()); }
+  uint8_t AsUInt8() const { return static_cast<uint8_t>(AsUInt64()); }
+
+  double AsDouble() const {
+    if (type_ == FBT_FLOAT) {
+      // A fast path for the common case.
+      return ReadDouble(data_, parent_width_);
+    } else
+      switch (type_) {
+        case FBT_INDIRECT_FLOAT: return ReadDouble(Indirect(), byte_width_);
+        case FBT_INT:
+          return static_cast<double>(ReadInt64(data_, parent_width_));
+        case FBT_UINT:
+          return static_cast<double>(ReadUInt64(data_, parent_width_));
+        case FBT_INDIRECT_INT:
+          return static_cast<double>(ReadInt64(Indirect(), byte_width_));
+        case FBT_INDIRECT_UINT:
+          return static_cast<double>(ReadUInt64(Indirect(), byte_width_));
+        case FBT_NULL: return 0.0;
+        case FBT_STRING: {
+          double d;
+          flatbuffers::StringToNumber(AsString().c_str(), &d);
+          return d;
+        }
+        case FBT_VECTOR: return static_cast<double>(AsVector().size());
+        case FBT_BOOL:
+          return static_cast<double>(ReadUInt64(data_, parent_width_));
+        default:
+          // Convert strings and other things to float.
+          return 0;
+      }
+  }
+
+  float AsFloat() const { return static_cast<float>(AsDouble()); }
+
+  const char *AsKey() const {
+    if (type_ == FBT_KEY || type_ == FBT_STRING) {
+      return reinterpret_cast<const char *>(Indirect());
+    } else {
+      return "";
+    }
+  }
+
+  // This function returns the empty string if you try to read something that
+  // is not a string or key.
+  String AsString() const {
+    if (type_ == FBT_STRING) {
+      return String(Indirect(), byte_width_);
+    } else if (type_ == FBT_KEY) {
+      auto key = Indirect();
+      return String(key, byte_width_,
+                    strlen(reinterpret_cast<const char *>(key)));
+    } else {
+      return String::EmptyString();
+    }
+  }
+
+  // Unlike AsString(), this will convert any type to a std::string.
+  std::string ToString() const {
+    std::string s;
+    ToString(false, false, s);
+    return s;
+  }
+
+  // Convert any type to a JSON-like string. strings_quoted determines if
+  // string values at the top level receive "" quotes (inside other values
+  // they always do). keys_quoted determines if keys are quoted, at any level.
+  // TODO(wvo): add further options to have indentation/newlines.
+  void ToString(bool strings_quoted, bool keys_quoted, std::string &s) const {
+    if (type_ == FBT_STRING) {
+      String str(Indirect(), byte_width_);
+      if (strings_quoted) {
+        flatbuffers::EscapeString(str.c_str(), str.length(), &s, true, false);
+      } else {
+        s.append(str.c_str(), str.length());
+      }
+    } else if (IsKey()) {
+      auto str = AsKey();
+      if (keys_quoted) {
+        flatbuffers::EscapeString(str, strlen(str), &s, true, false);
+      } else {
+        s += str;
+      }
+    } else if (IsInt()) {
+      s += flatbuffers::NumToString(AsInt64());
+    } else if (IsUInt()) {
+      s += flatbuffers::NumToString(AsUInt64());
+    } else if (IsFloat()) {
+      s += flatbuffers::NumToString(AsDouble());
+    } else if (IsNull()) {
+      s += "null";
+    } else if (IsBool()) {
+      s += AsBool() ? "true" : "false";
+    } else if (IsMap()) {
+      s += "{ ";
+      auto m = AsMap();
+      auto keys = m.Keys();
+      auto vals = m.Values();
+      for (size_t i = 0; i < keys.size(); i++) {
+        bool kq = keys_quoted;
+        if (!kq) {
+          // FlexBuffers keys may contain arbitrary characters, only allow
+          // unquoted if it looks like an "identifier":
+          const char *p = keys[i].AsKey();
+          if (!flatbuffers::is_alpha(*p) && *p != '_') {
+            kq = true;
+          } else {
+            while (*++p) {
+              if (!flatbuffers::is_alnum(*p) && *p != '_') {
+                kq = true;
+                break;
+              }
+            }
+          }
+        }
+        keys[i].ToString(true, kq, s);
+        s += ": ";
+        vals[i].ToString(true, keys_quoted, s);
+        if (i < keys.size() - 1) s += ", ";
+      }
+      s += " }";
+    } else if (IsVector()) {
+      AppendToString<Vector>(s, AsVector(), keys_quoted);
+    } else if (IsTypedVector()) {
+      AppendToString<TypedVector>(s, AsTypedVector(), keys_quoted);
+    } else if (IsFixedTypedVector()) {
+      AppendToString<FixedTypedVector>(s, AsFixedTypedVector(), keys_quoted);
+    } else if (IsBlob()) {
+      auto blob = AsBlob();
+      flatbuffers::EscapeString(reinterpret_cast<const char *>(blob.data()),
+                                blob.size(), &s, true, false);
+    } else {
+      s += "(?)";
+    }
+  }
+
+  // This function returns the empty blob if you try to read a not-blob.
+  // Strings can be viewed as blobs too.
+  Blob AsBlob() const {
+    if (type_ == FBT_BLOB || type_ == FBT_STRING) {
+      return Blob(Indirect(), byte_width_);
+    } else {
+      return Blob::EmptyBlob();
+    }
+  }
+
+  // This function returns the empty vector if you try to read a not-vector.
+  // Maps can be viewed as vectors too.
+  Vector AsVector() const {
+    if (type_ == FBT_VECTOR || type_ == FBT_MAP) {
+      return Vector(Indirect(), byte_width_);
+    } else {
+      return Vector::EmptyVector();
+    }
+  }
+
+  TypedVector AsTypedVector() const {
+    if (IsTypedVector()) {
+      auto tv =
+          TypedVector(Indirect(), byte_width_, ToTypedVectorElementType(type_));
+      if (tv.type_ == FBT_STRING) {
+        // These can't be accessed as strings, since we don't know the bit-width
+        // of the size field, see the declaration of
+        // FBT_VECTOR_STRING_DEPRECATED above for details.
+        // We change the type here to be keys, which are a subtype of strings,
+        // and will ignore the size field. This will truncate strings with
+        // embedded nulls.
+        tv.type_ = FBT_KEY;
+      }
+      return tv;
+    } else {
+      return TypedVector::EmptyTypedVector();
+    }
+  }
+
+  FixedTypedVector AsFixedTypedVector() const {
+    if (IsFixedTypedVector()) {
+      uint8_t len = 0;
+      auto vtype = ToFixedTypedVectorElementType(type_, &len);
+      return FixedTypedVector(Indirect(), byte_width_, vtype, len);
+    } else {
+      return FixedTypedVector::EmptyFixedTypedVector();
+    }
+  }
+
+  Map AsMap() const {
+    if (type_ == FBT_MAP) {
+      return Map(Indirect(), byte_width_);
+    } else {
+      return Map::EmptyMap();
+    }
+  }
+
+  template<typename T> T As() const;
+
+  // Experimental: Mutation functions.
+  // These allow scalars in an already created buffer to be updated in-place.
+  // Since by default scalars are stored in the smallest possible space,
+  // the new value may not fit, in which case these functions return false.
+  // To avoid this, you can construct the values you intend to mutate using
+  // Builder::ForceMinimumBitWidth.
+  bool MutateInt(int64_t i) {
+    if (type_ == FBT_INT) {
+      return Mutate(data_, i, parent_width_, WidthI(i));
+    } else if (type_ == FBT_INDIRECT_INT) {
+      return Mutate(Indirect(), i, byte_width_, WidthI(i));
+    } else if (type_ == FBT_UINT) {
+      auto u = static_cast<uint64_t>(i);
+      return Mutate(data_, u, parent_width_, WidthU(u));
+    } else if (type_ == FBT_INDIRECT_UINT) {
+      auto u = static_cast<uint64_t>(i);
+      return Mutate(Indirect(), u, byte_width_, WidthU(u));
+    } else {
+      return false;
+    }
+  }
+
+  bool MutateBool(bool b) {
+    return type_ == FBT_BOOL && Mutate(data_, b, parent_width_, BIT_WIDTH_8);
+  }
+
+  bool MutateUInt(uint64_t u) {
+    if (type_ == FBT_UINT) {
+      return Mutate(data_, u, parent_width_, WidthU(u));
+    } else if (type_ == FBT_INDIRECT_UINT) {
+      return Mutate(Indirect(), u, byte_width_, WidthU(u));
+    } else if (type_ == FBT_INT) {
+      auto i = static_cast<int64_t>(u);
+      return Mutate(data_, i, parent_width_, WidthI(i));
+    } else if (type_ == FBT_INDIRECT_INT) {
+      auto i = static_cast<int64_t>(u);
+      return Mutate(Indirect(), i, byte_width_, WidthI(i));
+    } else {
+      return false;
+    }
+  }
+
+  bool MutateFloat(float f) {
+    if (type_ == FBT_FLOAT) {
+      return MutateF(data_, f, parent_width_, BIT_WIDTH_32);
+    } else if (type_ == FBT_INDIRECT_FLOAT) {
+      return MutateF(Indirect(), f, byte_width_, BIT_WIDTH_32);
+    } else {
+      return false;
+    }
+  }
+
+  bool MutateFloat(double d) {
+    if (type_ == FBT_FLOAT) {
+      return MutateF(data_, d, parent_width_, WidthF(d));
+    } else if (type_ == FBT_INDIRECT_FLOAT) {
+      return MutateF(Indirect(), d, byte_width_, WidthF(d));
+    } else {
+      return false;
+    }
+  }
+
+  bool MutateString(const char *str, size_t len) {
+    auto s = AsString();
+    if (s.IsTheEmptyString()) return false;
+    // This is very strict, could allow shorter strings, but that creates
+    // garbage.
+    if (s.length() != len) return false;
+    memcpy(const_cast<char *>(s.c_str()), str, len);
+    return true;
+  }
+  bool MutateString(const char *str) { return MutateString(str, strlen(str)); }
+  bool MutateString(const std::string &str) {
+    return MutateString(str.data(), str.length());
+  }
+
+ private:
+  const uint8_t *Indirect() const {
+    return flexbuffers::Indirect(data_, parent_width_);
+  }
+
+  template<typename T>
+  bool Mutate(const uint8_t *dest, T t, size_t byte_width,
+              BitWidth value_width) {
+    auto fits = static_cast<size_t>(static_cast<size_t>(1U) << value_width) <=
+                byte_width;
+    if (fits) {
+      t = flatbuffers::EndianScalar(t);
+      memcpy(const_cast<uint8_t *>(dest), &t, byte_width);
+    }
+    return fits;
+  }
+
+  template<typename T>
+  bool MutateF(const uint8_t *dest, T t, size_t byte_width,
+               BitWidth value_width) {
+    if (byte_width == sizeof(double))
+      return Mutate(dest, static_cast<double>(t), byte_width, value_width);
+    if (byte_width == sizeof(float))
+      return Mutate(dest, static_cast<float>(t), byte_width, value_width);
+    FLATBUFFERS_ASSERT(false);
+    return false;
+  }
+
+  friend class Verifier;
+
+  const uint8_t *data_;
+  uint8_t parent_width_;
+  uint8_t byte_width_;
+  Type type_;
+};
+
+// Template specialization for As().
+template<> inline bool Reference::As<bool>() const { return AsBool(); }
+
+template<> inline int8_t Reference::As<int8_t>() const { return AsInt8(); }
+template<> inline int16_t Reference::As<int16_t>() const { return AsInt16(); }
+template<> inline int32_t Reference::As<int32_t>() const { return AsInt32(); }
+template<> inline int64_t Reference::As<int64_t>() const { return AsInt64(); }
+
+template<> inline uint8_t Reference::As<uint8_t>() const { return AsUInt8(); }
+template<> inline uint16_t Reference::As<uint16_t>() const {
+  return AsUInt16();
+}
+template<> inline uint32_t Reference::As<uint32_t>() const {
+  return AsUInt32();
+}
+template<> inline uint64_t Reference::As<uint64_t>() const {
+  return AsUInt64();
+}
+
+template<> inline double Reference::As<double>() const { return AsDouble(); }
+template<> inline float Reference::As<float>() const { return AsFloat(); }
+
+template<> inline String Reference::As<String>() const { return AsString(); }
+template<> inline std::string Reference::As<std::string>() const {
+  return AsString().str();
+}
+
+template<> inline Blob Reference::As<Blob>() const { return AsBlob(); }
+template<> inline Vector Reference::As<Vector>() const { return AsVector(); }
+template<> inline TypedVector Reference::As<TypedVector>() const {
+  return AsTypedVector();
+}
+template<> inline FixedTypedVector Reference::As<FixedTypedVector>() const {
+  return AsFixedTypedVector();
+}
+template<> inline Map Reference::As<Map>() const { return AsMap(); }
+
+inline uint8_t PackedType(BitWidth bit_width, Type type) {
+  return static_cast<uint8_t>(bit_width | (type << 2));
+}
+
+inline uint8_t NullPackedType() { return PackedType(BIT_WIDTH_8, FBT_NULL); }
+
+// Vector accessors.
+// Note: if you try to access outside of bounds, you get a Null value back
+// instead. Normally this would be an assert, but since this is "dynamically
+// typed" data, you may not want that (someone sends you a 2d vector and you
+// wanted 3d).
+// The Null converts seamlessly into a default value for any other type.
+// TODO(wvo): Could introduce an #ifdef that makes this into an assert?
+inline Reference Vector::operator[](size_t i) const {
+  auto len = size();
+  if (i >= len) return Reference(nullptr, 1, NullPackedType());
+  auto packed_type = (data_ + len * byte_width_)[i];
+  auto elem = data_ + i * byte_width_;
+  return Reference(elem, byte_width_, packed_type);
+}
+
+inline Reference TypedVector::operator[](size_t i) const {
+  auto len = size();
+  if (i >= len) return Reference(nullptr, 1, NullPackedType());
+  auto elem = data_ + i * byte_width_;
+  return Reference(elem, byte_width_, 1, type_);
+}
+
+inline Reference FixedTypedVector::operator[](size_t i) const {
+  if (i >= len_) return Reference(nullptr, 1, NullPackedType());
+  auto elem = data_ + i * byte_width_;
+  return Reference(elem, byte_width_, 1, type_);
+}
+
+template<typename T> int KeyCompare(const void *key, const void *elem) {
+  auto str_elem = reinterpret_cast<const char *>(
+      Indirect<T>(reinterpret_cast<const uint8_t *>(elem)));
+  auto skey = reinterpret_cast<const char *>(key);
+  return strcmp(skey, str_elem);
+}
+
+inline Reference Map::operator[](const char *key) const {
+  auto keys = Keys();
+  // We can't pass keys.byte_width_ to the comparison function, so we have
+  // to pick the right one ahead of time.
+  int (*comp)(const void *, const void *) = nullptr;
+  switch (keys.byte_width_) {
+    case 1: comp = KeyCompare<uint8_t>; break;
+    case 2: comp = KeyCompare<uint16_t>; break;
+    case 4: comp = KeyCompare<uint32_t>; break;
+    case 8: comp = KeyCompare<uint64_t>; break;
+    default: FLATBUFFERS_ASSERT(false); return Reference();
+  }
+  auto res = std::bsearch(key, keys.data_, keys.size(), keys.byte_width_, comp);
+  if (!res) return Reference(nullptr, 1, NullPackedType());
+  auto i = (reinterpret_cast<uint8_t *>(res) - keys.data_) / keys.byte_width_;
+  return (*static_cast<const Vector *>(this))[i];
+}
+
+inline Reference Map::operator[](const std::string &key) const {
+  return (*this)[key.c_str()];
+}
+
+inline Reference GetRoot(const uint8_t *buffer, size_t size) {
+  // See Finish() below for the serialization counterpart of this.
+  // The root starts at the end of the buffer, so we parse backwards from there.
+  auto end = buffer + size;
+  auto byte_width = *--end;
+  auto packed_type = *--end;
+  end -= byte_width;  // The root data item.
+  return Reference(end, byte_width, packed_type);
+}
+
+inline Reference GetRoot(const std::vector<uint8_t> &buffer) {
+  return GetRoot(buffer.data(), buffer.size());
+}
+
+// Flags that configure how the Builder behaves.
+// The "Share" flags determine if the Builder automatically tries to pool
+// this type. Pooling can reduce the size of serialized data if there are
+// multiple maps of the same kind, at the expense of slightly slower
+// serialization (the cost of lookups) and more memory use (std::set).
+// By default this is on for keys, but off for strings.
+// Turn keys off if you have e.g. only one map.
+// Turn strings on if you expect many non-unique string values.
+// Additionally, sharing key vectors can save space if you have maps with
+// identical field populations.
+enum BuilderFlag {
+  BUILDER_FLAG_NONE = 0,
+  BUILDER_FLAG_SHARE_KEYS = 1,
+  BUILDER_FLAG_SHARE_STRINGS = 2,
+  BUILDER_FLAG_SHARE_KEYS_AND_STRINGS = 3,
+  BUILDER_FLAG_SHARE_KEY_VECTORS = 4,
+  BUILDER_FLAG_SHARE_ALL = 7,
+};
+
+class Builder FLATBUFFERS_FINAL_CLASS {
+ public:
+  Builder(size_t initial_size = 256,
+          BuilderFlag flags = BUILDER_FLAG_SHARE_KEYS)
+      : buf_(initial_size),
+        finished_(false),
+        has_duplicate_keys_(false),
+        flags_(flags),
+        force_min_bit_width_(BIT_WIDTH_8),
+        key_pool(KeyOffsetCompare(buf_)),
+        string_pool(StringOffsetCompare(buf_)) {
+    buf_.clear();
+  }
+
+#ifdef FLATBUFFERS_DEFAULT_DECLARATION
+  Builder(Builder &&) = default;
+  Builder &operator=(Builder &&) = default;
+#endif
+
+  /// @brief Get the serialized buffer (after you call `Finish()`).
+  /// @return Returns a vector owned by this class.
+  const std::vector<uint8_t> &GetBuffer() const {
+    Finished();
+    return buf_;
+  }
+
+  // Size of the buffer. Does not include unfinished values.
+  size_t GetSize() const { return buf_.size(); }
+
+  // Reset all state so we can re-use the buffer.
+  void Clear() {
+    buf_.clear();
+    stack_.clear();
+    finished_ = false;
+    // flags_ remains as-is;
+    force_min_bit_width_ = BIT_WIDTH_8;
+    key_pool.clear();
+    string_pool.clear();
+  }
+
+  // All value constructing functions below have two versions: one that
+  // takes a key (for placement inside a map) and one that doesn't (for inside
+  // vectors and elsewhere).
+
+  void Null() { stack_.push_back(Value()); }
+  void Null(const char *key) {
+    Key(key);
+    Null();
+  }
+
+  void Int(int64_t i) { stack_.push_back(Value(i, FBT_INT, WidthI(i))); }
+  void Int(const char *key, int64_t i) {
+    Key(key);
+    Int(i);
+  }
+
+  void UInt(uint64_t u) { stack_.push_back(Value(u, FBT_UINT, WidthU(u))); }
+  void UInt(const char *key, uint64_t u) {
+    Key(key);
+    UInt(u);
+  }
+
+  void Float(float f) { stack_.push_back(Value(f)); }
+  void Float(const char *key, float f) {
+    Key(key);
+    Float(f);
+  }
+
+  void Double(double f) { stack_.push_back(Value(f)); }
+  void Double(const char *key, double d) {
+    Key(key);
+    Double(d);
+  }
+
+  void Bool(bool b) { stack_.push_back(Value(b)); }
+  void Bool(const char *key, bool b) {
+    Key(key);
+    Bool(b);
+  }
+
+  void IndirectInt(int64_t i) { PushIndirect(i, FBT_INDIRECT_INT, WidthI(i)); }
+  void IndirectInt(const char *key, int64_t i) {
+    Key(key);
+    IndirectInt(i);
+  }
+
+  void IndirectUInt(uint64_t u) {
+    PushIndirect(u, FBT_INDIRECT_UINT, WidthU(u));
+  }
+  void IndirectUInt(const char *key, uint64_t u) {
+    Key(key);
+    IndirectUInt(u);
+  }
+
+  void IndirectFloat(float f) {
+    PushIndirect(f, FBT_INDIRECT_FLOAT, BIT_WIDTH_32);
+  }
+  void IndirectFloat(const char *key, float f) {
+    Key(key);
+    IndirectFloat(f);
+  }
+
+  void IndirectDouble(double f) {
+    PushIndirect(f, FBT_INDIRECT_FLOAT, WidthF(f));
+  }
+  void IndirectDouble(const char *key, double d) {
+    Key(key);
+    IndirectDouble(d);
+  }
+
+  size_t Key(const char *str, size_t len) {
+    auto sloc = buf_.size();
+    WriteBytes(str, len + 1);
+    if (flags_ & BUILDER_FLAG_SHARE_KEYS) {
+      auto it = key_pool.find(sloc);
+      if (it != key_pool.end()) {
+        // Already in the buffer. Remove key we just serialized, and use
+        // existing offset instead.
+        buf_.resize(sloc);
+        sloc = *it;
+      } else {
+        key_pool.insert(sloc);
+      }
+    }
+    stack_.push_back(Value(static_cast<uint64_t>(sloc), FBT_KEY, BIT_WIDTH_8));
+    return sloc;
+  }
+
+  size_t Key(const char *str) { return Key(str, strlen(str)); }
+  size_t Key(const std::string &str) { return Key(str.c_str(), str.size()); }
+
+  size_t String(const char *str, size_t len) {
+    auto reset_to = buf_.size();
+    auto sloc = CreateBlob(str, len, 1, FBT_STRING);
+    if (flags_ & BUILDER_FLAG_SHARE_STRINGS) {
+      StringOffset so(sloc, len);
+      auto it = string_pool.find(so);
+      if (it != string_pool.end()) {
+        // Already in the buffer. Remove string we just serialized, and use
+        // existing offset instead.
+        buf_.resize(reset_to);
+        sloc = it->first;
+        stack_.back().u_ = sloc;
+      } else {
+        string_pool.insert(so);
+      }
+    }
+    return sloc;
+  }
+  size_t String(const char *str) { return String(str, strlen(str)); }
+  size_t String(const std::string &str) {
+    return String(str.c_str(), str.size());
+  }
+  void String(const flexbuffers::String &str) {
+    String(str.c_str(), str.length());
+  }
+
+  void String(const char *key, const char *str) {
+    Key(key);
+    String(str);
+  }
+  void String(const char *key, const std::string &str) {
+    Key(key);
+    String(str);
+  }
+  void String(const char *key, const flexbuffers::String &str) {
+    Key(key);
+    String(str);
+  }
+
+  size_t Blob(const void *data, size_t len) {
+    return CreateBlob(data, len, 0, FBT_BLOB);
+  }
+  size_t Blob(const std::vector<uint8_t> &v) {
+    return CreateBlob(v.data(), v.size(), 0, FBT_BLOB);
+  }
+
+  void Blob(const char *key, const void *data, size_t len) {
+    Key(key);
+    Blob(data, len);
+  }
+  void Blob(const char *key, const std::vector<uint8_t> &v) {
+    Key(key);
+    Blob(v);
+  }
+
+  // TODO(wvo): support all the FlexBuffer types (like flexbuffers::String),
+  // e.g. Vector etc. Also in overloaded versions.
+  // Also some FlatBuffers types?
+
+  size_t StartVector() { return stack_.size(); }
+  size_t StartVector(const char *key) {
+    Key(key);
+    return stack_.size();
+  }
+  size_t StartMap() { return stack_.size(); }
+  size_t StartMap(const char *key) {
+    Key(key);
+    return stack_.size();
+  }
+
+  // TODO(wvo): allow this to specify an alignment greater than the natural
+  // alignment.
+  size_t EndVector(size_t start, bool typed, bool fixed) {
+    auto vec = CreateVector(start, stack_.size() - start, 1, typed, fixed);
+    // Remove temp elements and return vector.
+    stack_.resize(start);
+    stack_.push_back(vec);
+    return static_cast<size_t>(vec.u_);
+  }
+
+  size_t EndMap(size_t start) {
+    // We should have interleaved keys and values on the stack.
+    // Make sure it is an even number:
+    auto len = stack_.size() - start;
+    FLATBUFFERS_ASSERT(!(len & 1));
+    len /= 2;
+    // Make sure keys are all strings:
+    for (auto key = start; key < stack_.size(); key += 2) {
+      FLATBUFFERS_ASSERT(stack_[key].type_ == FBT_KEY);
+    }
+    // Now sort values, so later we can do a binary search lookup.
+    // We want to sort 2 array elements at a time.
+    struct TwoValue {
+      Value key;
+      Value val;
+    };
+    // TODO(wvo): strict aliasing?
+    // TODO(wvo): allow the caller to indicate the data is already sorted
+    // for maximum efficiency? With an assert to check sortedness to make sure
+    // we're not breaking binary search.
+    // Or, we can track if the map is sorted as keys are added which would be
+    // be quite cheap (cheaper than checking it here), so we can skip this
+    // step automatically when appliccable, and encourage people to write in
+    // sorted fashion.
+    // std::sort is typically already a lot faster on sorted data though.
+    auto dict = reinterpret_cast<TwoValue *>(stack_.data() + start);
+    std::sort(
+        dict, dict + len, [&](const TwoValue &a, const TwoValue &b) -> bool {
+          auto as = reinterpret_cast<const char *>(buf_.data() + a.key.u_);
+          auto bs = reinterpret_cast<const char *>(buf_.data() + b.key.u_);
+          auto comp = strcmp(as, bs);
+          // We want to disallow duplicate keys, since this results in a
+          // map where values cannot be found.
+          // But we can't assert here (since we don't want to fail on
+          // random JSON input) or have an error mechanism.
+          // Instead, we set has_duplicate_keys_ in the builder to
+          // signal this.
+          // TODO: Have to check for pointer equality, as some sort
+          // implementation apparently call this function with the same
+          // element?? Why?
+          if (!comp && &a != &b) has_duplicate_keys_ = true;
+          return comp < 0;
+        });
+    // First create a vector out of all keys.
+    // TODO(wvo): if kBuilderFlagShareKeyVectors is true, see if we can share
+    // the first vector.
+    auto keys = CreateVector(start, len, 2, true, false);
+    auto vec = CreateVector(start + 1, len, 2, false, false, &keys);
+    // Remove temp elements and return map.
+    stack_.resize(start);
+    stack_.push_back(vec);
+    return static_cast<size_t>(vec.u_);
+  }
+
+  // Call this after EndMap to see if the map had any duplicate keys.
+  // Any map with such keys won't be able to retrieve all values.
+  bool HasDuplicateKeys() const { return has_duplicate_keys_; }
+
+  template<typename F> size_t Vector(F f) {
+    auto start = StartVector();
+    f();
+    return EndVector(start, false, false);
+  }
+  template<typename F, typename T> size_t Vector(F f, T &state) {
+    auto start = StartVector();
+    f(state);
+    return EndVector(start, false, false);
+  }
+  template<typename F> size_t Vector(const char *key, F f) {
+    auto start = StartVector(key);
+    f();
+    return EndVector(start, false, false);
+  }
+  template<typename F, typename T>
+  size_t Vector(const char *key, F f, T &state) {
+    auto start = StartVector(key);
+    f(state);
+    return EndVector(start, false, false);
+  }
+
+  template<typename T> void Vector(const T *elems, size_t len) {
+    if (flatbuffers::is_scalar<T>::value) {
+      // This path should be a lot quicker and use less space.
+      ScalarVector(elems, len, false);
+    } else {
+      auto start = StartVector();
+      for (size_t i = 0; i < len; i++) Add(elems[i]);
+      EndVector(start, false, false);
+    }
+  }
+  template<typename T>
+  void Vector(const char *key, const T *elems, size_t len) {
+    Key(key);
+    Vector(elems, len);
+  }
+  template<typename T> void Vector(const std::vector<T> &vec) {
+    Vector(vec.data(), vec.size());
+  }
+
+  template<typename F> size_t TypedVector(F f) {
+    auto start = StartVector();
+    f();
+    return EndVector(start, true, false);
+  }
+  template<typename F, typename T> size_t TypedVector(F f, T &state) {
+    auto start = StartVector();
+    f(state);
+    return EndVector(start, true, false);
+  }
+  template<typename F> size_t TypedVector(const char *key, F f) {
+    auto start = StartVector(key);
+    f();
+    return EndVector(start, true, false);
+  }
+  template<typename F, typename T>
+  size_t TypedVector(const char *key, F f, T &state) {
+    auto start = StartVector(key);
+    f(state);
+    return EndVector(start, true, false);
+  }
+
+  template<typename T> size_t FixedTypedVector(const T *elems, size_t len) {
+    // We only support a few fixed vector lengths. Anything bigger use a
+    // regular typed vector.
+    FLATBUFFERS_ASSERT(len >= 2 && len <= 4);
+    // And only scalar values.
+    static_assert(flatbuffers::is_scalar<T>::value, "Unrelated types");
+    return ScalarVector(elems, len, true);
+  }
+
+  template<typename T>
+  size_t FixedTypedVector(const char *key, const T *elems, size_t len) {
+    Key(key);
+    return FixedTypedVector(elems, len);
+  }
+
+  template<typename F> size_t Map(F f) {
+    auto start = StartMap();
+    f();
+    return EndMap(start);
+  }
+  template<typename F, typename T> size_t Map(F f, T &state) {
+    auto start = StartMap();
+    f(state);
+    return EndMap(start);
+  }
+  template<typename F> size_t Map(const char *key, F f) {
+    auto start = StartMap(key);
+    f();
+    return EndMap(start);
+  }
+  template<typename F, typename T> size_t Map(const char *key, F f, T &state) {
+    auto start = StartMap(key);
+    f(state);
+    return EndMap(start);
+  }
+  template<typename T> void Map(const std::map<std::string, T> &map) {
+    auto start = StartMap();
+    for (auto it = map.begin(); it != map.end(); ++it)
+      Add(it->first.c_str(), it->second);
+    EndMap(start);
+  }
+
+  // If you wish to share a value explicitly (a value not shared automatically
+  // through one of the BUILDER_FLAG_SHARE_* flags) you can do so with these
+  // functions. Or if you wish to turn those flags off for performance reasons
+  // and still do some explicit sharing. For example:
+  // builder.IndirectDouble(M_PI);
+  // auto id = builder.LastValue();  // Remember where we stored it.
+  // .. more code goes here ..
+  // builder.ReuseValue(id);  // Refers to same double by offset.
+  // LastValue works regardless of whether the value has a key or not.
+  // Works on any data type.
+  struct Value;
+  Value LastValue() { return stack_.back(); }
+  void ReuseValue(Value v) { stack_.push_back(v); }
+  void ReuseValue(const char *key, Value v) {
+    Key(key);
+    ReuseValue(v);
+  }
+
+  // Overloaded Add that tries to call the correct function above.
+  void Add(int8_t i) { Int(i); }
+  void Add(int16_t i) { Int(i); }
+  void Add(int32_t i) { Int(i); }
+  void Add(int64_t i) { Int(i); }
+  void Add(uint8_t u) { UInt(u); }
+  void Add(uint16_t u) { UInt(u); }
+  void Add(uint32_t u) { UInt(u); }
+  void Add(uint64_t u) { UInt(u); }
+  void Add(float f) { Float(f); }
+  void Add(double d) { Double(d); }
+  void Add(bool b) { Bool(b); }
+  void Add(const char *str) { String(str); }
+  void Add(const std::string &str) { String(str); }
+  void Add(const flexbuffers::String &str) { String(str); }
+
+  template<typename T> void Add(const std::vector<T> &vec) { Vector(vec); }
+
+  template<typename T> void Add(const char *key, const T &t) {
+    Key(key);
+    Add(t);
+  }
+
+  template<typename T> void Add(const std::map<std::string, T> &map) {
+    Map(map);
+  }
+
+  template<typename T> void operator+=(const T &t) { Add(t); }
+
+  // This function is useful in combination with the Mutate* functions above.
+  // It forces elements of vectors and maps to have a minimum size, such that
+  // they can later be updated without failing.
+  // Call with no arguments to reset.
+  void ForceMinimumBitWidth(BitWidth bw = BIT_WIDTH_8) {
+    force_min_bit_width_ = bw;
+  }
+
+  void Finish() {
+    // If you hit this assert, you likely have objects that were never included
+    // in a parent. You need to have exactly one root to finish a buffer.
+    // Check your Start/End calls are matched, and all objects are inside
+    // some other object.
+    FLATBUFFERS_ASSERT(stack_.size() == 1);
+
+    // Write root value.
+    auto byte_width = Align(stack_[0].ElemWidth(buf_.size(), 0));
+    WriteAny(stack_[0], byte_width);
+    // Write root type.
+    Write(stack_[0].StoredPackedType(), 1);
+    // Write root size. Normally determined by parent, but root has no parent :)
+    Write(byte_width, 1);
+
+    finished_ = true;
+  }
+
+ private:
+  void Finished() const {
+    // If you get this assert, you're attempting to get access a buffer
+    // which hasn't been finished yet. Be sure to call
+    // Builder::Finish with your root object.
+    FLATBUFFERS_ASSERT(finished_);
+  }
+
+  // Align to prepare for writing a scalar with a certain size.
+  uint8_t Align(BitWidth alignment) {
+    auto byte_width = 1U << alignment;
+    buf_.insert(buf_.end(), flatbuffers::PaddingBytes(buf_.size(), byte_width),
+                0);
+    return static_cast<uint8_t>(byte_width);
+  }
+
+  void WriteBytes(const void *val, size_t size) {
+    buf_.insert(buf_.end(), reinterpret_cast<const uint8_t *>(val),
+                reinterpret_cast<const uint8_t *>(val) + size);
+  }
+
+  template<typename T> void Write(T val, size_t byte_width) {
+    FLATBUFFERS_ASSERT(sizeof(T) >= byte_width);
+    val = flatbuffers::EndianScalar(val);
+    WriteBytes(&val, byte_width);
+  }
+
+  void WriteDouble(double f, uint8_t byte_width) {
+    switch (byte_width) {
+      case 8: Write(f, byte_width); break;
+      case 4: Write(static_cast<float>(f), byte_width); break;
+      // case 2: Write(static_cast<half>(f), byte_width); break;
+      // case 1: Write(static_cast<quarter>(f), byte_width); break;
+      default: FLATBUFFERS_ASSERT(0);
+    }
+  }
+
+  void WriteOffset(uint64_t o, uint8_t byte_width) {
+    auto reloff = buf_.size() - o;
+    FLATBUFFERS_ASSERT(byte_width == 8 || reloff < 1ULL << (byte_width * 8));
+    Write(reloff, byte_width);
+  }
+
+  template<typename T> void PushIndirect(T val, Type type, BitWidth bit_width) {
+    auto byte_width = Align(bit_width);
+    auto iloc = buf_.size();
+    Write(val, byte_width);
+    stack_.push_back(Value(static_cast<uint64_t>(iloc), type, bit_width));
+  }
+
+  static BitWidth WidthB(size_t byte_width) {
+    switch (byte_width) {
+      case 1: return BIT_WIDTH_8;
+      case 2: return BIT_WIDTH_16;
+      case 4: return BIT_WIDTH_32;
+      case 8: return BIT_WIDTH_64;
+      default: FLATBUFFERS_ASSERT(false); return BIT_WIDTH_64;
+    }
+  }
+
+  template<typename T> static Type GetScalarType() {
+    static_assert(flatbuffers::is_scalar<T>::value, "Unrelated types");
+    return flatbuffers::is_floating_point<T>::value
+               ? FBT_FLOAT
+               : flatbuffers::is_same<T, bool>::value
+                     ? FBT_BOOL
+                     : (flatbuffers::is_unsigned<T>::value ? FBT_UINT
+                                                           : FBT_INT);
+  }
+
+ public:
+  // This was really intended to be private, except for LastValue/ReuseValue.
+  struct Value {
+    union {
+      int64_t i_;
+      uint64_t u_;
+      double f_;
+    };
+
+    Type type_;
+
+    // For scalars: of itself, for vector: of its elements, for string: length.
+    BitWidth min_bit_width_;
+
+    Value() : i_(0), type_(FBT_NULL), min_bit_width_(BIT_WIDTH_8) {}
+
+    Value(bool b)
+        : u_(static_cast<uint64_t>(b)),
+          type_(FBT_BOOL),
+          min_bit_width_(BIT_WIDTH_8) {}
+
+    Value(int64_t i, Type t, BitWidth bw)
+        : i_(i), type_(t), min_bit_width_(bw) {}
+    Value(uint64_t u, Type t, BitWidth bw)
+        : u_(u), type_(t), min_bit_width_(bw) {}
+
+    Value(float f)
+        : f_(static_cast<double>(f)),
+          type_(FBT_FLOAT),
+          min_bit_width_(BIT_WIDTH_32) {}
+    Value(double f) : f_(f), type_(FBT_FLOAT), min_bit_width_(WidthF(f)) {}
+
+    uint8_t StoredPackedType(BitWidth parent_bit_width_ = BIT_WIDTH_8) const {
+      return PackedType(StoredWidth(parent_bit_width_), type_);
+    }
+
+    BitWidth ElemWidth(size_t buf_size, size_t elem_index) const {
+      if (IsInline(type_)) {
+        return min_bit_width_;
+      } else {
+        // We have an absolute offset, but want to store a relative offset
+        // elem_index elements beyond the current buffer end. Since whether
+        // the relative offset fits in a certain byte_width depends on
+        // the size of the elements before it (and their alignment), we have
+        // to test for each size in turn.
+        for (size_t byte_width = 1;
+             byte_width <= sizeof(flatbuffers::largest_scalar_t);
+             byte_width *= 2) {
+          // Where are we going to write this offset?
+          auto offset_loc = buf_size +
+                            flatbuffers::PaddingBytes(buf_size, byte_width) +
+                            elem_index * byte_width;
+          // Compute relative offset.
+          auto offset = offset_loc - u_;
+          // Does it fit?
+          auto bit_width = WidthU(offset);
+          if (static_cast<size_t>(static_cast<size_t>(1U) << bit_width) ==
+              byte_width)
+            return bit_width;
+        }
+        FLATBUFFERS_ASSERT(false);  // Must match one of the sizes above.
+        return BIT_WIDTH_64;
+      }
+    }
+
+    BitWidth StoredWidth(BitWidth parent_bit_width_ = BIT_WIDTH_8) const {
+      if (IsInline(type_)) {
+        return (std::max)(min_bit_width_, parent_bit_width_);
+      } else {
+        return min_bit_width_;
+      }
+    }
+  };
+
+ private:
+  void WriteAny(const Value &val, uint8_t byte_width) {
+    switch (val.type_) {
+      case FBT_NULL:
+      case FBT_INT: Write(val.i_, byte_width); break;
+      case FBT_BOOL:
+      case FBT_UINT: Write(val.u_, byte_width); break;
+      case FBT_FLOAT: WriteDouble(val.f_, byte_width); break;
+      default: WriteOffset(val.u_, byte_width); break;
+    }
+  }
+
+  size_t CreateBlob(const void *data, size_t len, size_t trailing, Type type) {
+    auto bit_width = WidthU(len);
+    auto byte_width = Align(bit_width);
+    Write<uint64_t>(len, byte_width);
+    auto sloc = buf_.size();
+    WriteBytes(data, len + trailing);
+    stack_.push_back(Value(static_cast<uint64_t>(sloc), type, bit_width));
+    return sloc;
+  }
+
+  template<typename T>
+  size_t ScalarVector(const T *elems, size_t len, bool fixed) {
+    auto vector_type = GetScalarType<T>();
+    auto byte_width = sizeof(T);
+    auto bit_width = WidthB(byte_width);
+    // If you get this assert, you're trying to write a vector with a size
+    // field that is bigger than the scalars you're trying to write (e.g. a
+    // byte vector > 255 elements). For such types, write a "blob" instead.
+    // TODO: instead of asserting, could write vector with larger elements
+    // instead, though that would be wasteful.
+    FLATBUFFERS_ASSERT(WidthU(len) <= bit_width);
+    Align(bit_width);
+    if (!fixed) Write<uint64_t>(len, byte_width);
+    auto vloc = buf_.size();
+    for (size_t i = 0; i < len; i++) Write(elems[i], byte_width);
+    stack_.push_back(Value(static_cast<uint64_t>(vloc),
+                           ToTypedVector(vector_type, fixed ? len : 0),
+                           bit_width));
+    return vloc;
+  }
+
+  Value CreateVector(size_t start, size_t vec_len, size_t step, bool typed,
+                     bool fixed, const Value *keys = nullptr) {
+    FLATBUFFERS_ASSERT(
+        !fixed ||
+        typed);  // typed=false, fixed=true combination is not supported.
+    // Figure out smallest bit width we can store this vector with.
+    auto bit_width = (std::max)(force_min_bit_width_, WidthU(vec_len));
+    auto prefix_elems = 1;
+    if (keys) {
+      // If this vector is part of a map, we will pre-fix an offset to the keys
+      // to this vector.
+      bit_width = (std::max)(bit_width, keys->ElemWidth(buf_.size(), 0));
+      prefix_elems += 2;
+    }
+    Type vector_type = FBT_KEY;
+    // Check bit widths and types for all elements.
+    for (size_t i = start; i < stack_.size(); i += step) {
+      auto elem_width =
+          stack_[i].ElemWidth(buf_.size(), i - start + prefix_elems);
+      bit_width = (std::max)(bit_width, elem_width);
+      if (typed) {
+        if (i == start) {
+          vector_type = stack_[i].type_;
+        } else {
+          // If you get this assert, you are writing a typed vector with
+          // elements that are not all the same type.
+          FLATBUFFERS_ASSERT(vector_type == stack_[i].type_);
+        }
+      }
+    }
+    // If you get this assert, your typed types are not one of:
+    // Int / UInt / Float / Key.
+    FLATBUFFERS_ASSERT(!typed || IsTypedVectorElementType(vector_type));
+    auto byte_width = Align(bit_width);
+    // Write vector. First the keys width/offset if available, and size.
+    if (keys) {
+      WriteOffset(keys->u_, byte_width);
+      Write<uint64_t>(1ULL << keys->min_bit_width_, byte_width);
+    }
+    if (!fixed) Write<uint64_t>(vec_len, byte_width);
+    // Then the actual data.
+    auto vloc = buf_.size();
+    for (size_t i = start; i < stack_.size(); i += step) {
+      WriteAny(stack_[i], byte_width);
+    }
+    // Then the types.
+    if (!typed) {
+      for (size_t i = start; i < stack_.size(); i += step) {
+        buf_.push_back(stack_[i].StoredPackedType(bit_width));
+      }
+    }
+    return Value(static_cast<uint64_t>(vloc),
+                 keys ? FBT_MAP
+                      : (typed ? ToTypedVector(vector_type, fixed ? vec_len : 0)
+                               : FBT_VECTOR),
+                 bit_width);
+  }
+
+  // You shouldn't really be copying instances of this class.
+  Builder(const Builder &);
+  Builder &operator=(const Builder &);
+
+  std::vector<uint8_t> buf_;
+  std::vector<Value> stack_;
+
+  bool finished_;
+  bool has_duplicate_keys_;
+
+  BuilderFlag flags_;
+
+  BitWidth force_min_bit_width_;
+
+  struct KeyOffsetCompare {
+    explicit KeyOffsetCompare(const std::vector<uint8_t> &buf) : buf_(&buf) {}
+    bool operator()(size_t a, size_t b) const {
+      auto stra = reinterpret_cast<const char *>(buf_->data() + a);
+      auto strb = reinterpret_cast<const char *>(buf_->data() + b);
+      return strcmp(stra, strb) < 0;
+    }
+    const std::vector<uint8_t> *buf_;
+  };
+
+  typedef std::pair<size_t, size_t> StringOffset;
+  struct StringOffsetCompare {
+    explicit StringOffsetCompare(const std::vector<uint8_t> &buf)
+        : buf_(&buf) {}
+    bool operator()(const StringOffset &a, const StringOffset &b) const {
+      auto stra = buf_->data() + a.first;
+      auto strb = buf_->data() + b.first;
+      auto cr = memcmp(stra, strb, (std::min)(a.second, b.second) + 1);
+      return cr < 0 || (cr == 0 && a.second < b.second);
+    }
+    const std::vector<uint8_t> *buf_;
+  };
+
+  typedef std::set<size_t, KeyOffsetCompare> KeyOffsetMap;
+  typedef std::set<StringOffset, StringOffsetCompare> StringOffsetMap;
+
+  KeyOffsetMap key_pool;
+  StringOffsetMap string_pool;
+
+  friend class Verifier;
+};
+
+// Helper class to verify the integrity of a FlexBuffer
+class Verifier FLATBUFFERS_FINAL_CLASS {
+ public:
+  Verifier(const uint8_t *buf, size_t buf_len,
+           // Supplying this vector likely results in faster verification
+           // of larger buffers with many shared keys/strings, but
+           // comes at the cost of using additional memory the same size of
+           // the buffer being verified, so it is by default off.
+           std::vector<uint8_t> *reuse_tracker = nullptr,
+           bool _check_alignment = true, size_t max_depth = 64)
+      : buf_(buf),
+        size_(buf_len),
+        depth_(0),
+        max_depth_(max_depth),
+        num_vectors_(0),
+        max_vectors_(buf_len),
+        check_alignment_(_check_alignment),
+        reuse_tracker_(reuse_tracker) {
+    FLATBUFFERS_ASSERT(size_ < FLATBUFFERS_MAX_BUFFER_SIZE);
+    if (reuse_tracker_) {
+      reuse_tracker_->clear();
+      reuse_tracker_->resize(size_, PackedType(BIT_WIDTH_8, FBT_NULL));
+    }
+  }
+
+ private:
+  // Central location where any verification failures register.
+  bool Check(bool ok) const {
+    // clang-format off
+    #ifdef FLATBUFFERS_DEBUG_VERIFICATION_FAILURE
+      FLATBUFFERS_ASSERT(ok);
+    #endif
+    // clang-format on
+    return ok;
+  }
+
+  // Verify any range within the buffer.
+  bool VerifyFrom(size_t elem, size_t elem_len) const {
+    return Check(elem_len < size_ && elem <= size_ - elem_len);
+  }
+  bool VerifyBefore(size_t elem, size_t elem_len) const {
+    return Check(elem_len <= elem);
+  }
+
+  bool VerifyFromPointer(const uint8_t *p, size_t len) {
+    auto o = static_cast<size_t>(p - buf_);
+    return VerifyFrom(o, len);
+  }
+  bool VerifyBeforePointer(const uint8_t *p, size_t len) {
+    auto o = static_cast<size_t>(p - buf_);
+    return VerifyBefore(o, len);
+  }
+
+  bool VerifyByteWidth(size_t width) {
+    return Check(width == 1 || width == 2 || width == 4 || width == 8);
+  }
+
+  bool VerifyType(int type) { return Check(type >= 0 && type < FBT_MAX_TYPE); }
+
+  bool VerifyOffset(uint64_t off, const uint8_t *p) {
+    return Check(off <= static_cast<uint64_t>(size_)) &&
+           off <= static_cast<uint64_t>(p - buf_);
+  }
+
+  bool VerifyAlignment(const uint8_t *p, size_t size) const {
+    auto o = static_cast<size_t>(p - buf_);
+    return Check((o & (size - 1)) == 0 || !check_alignment_);
+  }
+
+// Macro, since we want to escape from parent function & use lazy args.
+#define FLEX_CHECK_VERIFIED(P, PACKED_TYPE)                     \
+  if (reuse_tracker_) {                                         \
+    auto packed_type = PACKED_TYPE;                             \
+    auto existing = (*reuse_tracker_)[P - buf_];                \
+    if (existing == packed_type) return true;                   \
+    /* Fail verification if already set with different type! */ \
+    if (!Check(existing == 0)) return false;                    \
+    (*reuse_tracker_)[P - buf_] = packed_type;                  \
+  }
+
+  bool VerifyVector(Reference r, const uint8_t *p, Type elem_type) {
+    // Any kind of nesting goes thru this function, so guard against that
+    // here, both with simple nesting checks, and the reuse tracker if on.
+    depth_++;
+    num_vectors_++;
+    if (!Check(depth_ <= max_depth_ && num_vectors_ <= max_vectors_))
+      return false;
+    auto size_byte_width = r.byte_width_;
+    FLEX_CHECK_VERIFIED(p,
+                        PackedType(Builder::WidthB(size_byte_width), r.type_));
+    if (!VerifyBeforePointer(p, size_byte_width)) return false;
+    auto sized = Sized(p, size_byte_width);
+    auto num_elems = sized.size();
+    auto elem_byte_width = r.type_ == FBT_STRING || r.type_ == FBT_BLOB
+                               ? uint8_t(1)
+                               : r.byte_width_;
+    auto max_elems = SIZE_MAX / elem_byte_width;
+    if (!Check(num_elems < max_elems))
+      return false;  // Protect against byte_size overflowing.
+    auto byte_size = num_elems * elem_byte_width;
+    if (!VerifyFromPointer(p, byte_size)) return false;
+    if (elem_type == FBT_NULL) {
+      // Verify type bytes after the vector.
+      if (!VerifyFromPointer(p + byte_size, num_elems)) return false;
+      auto v = Vector(p, size_byte_width);
+      for (size_t i = 0; i < num_elems; i++)
+        if (!VerifyRef(v[i])) return false;
+    } else if (elem_type == FBT_KEY) {
+      auto v = TypedVector(p, elem_byte_width, FBT_KEY);
+      for (size_t i = 0; i < num_elems; i++)
+        if (!VerifyRef(v[i])) return false;
+    } else {
+      FLATBUFFERS_ASSERT(IsInline(elem_type));
+    }
+    depth_--;
+    return true;
+  }
+
+  bool VerifyKeys(const uint8_t *p, uint8_t byte_width) {
+    // The vector part of the map has already been verified.
+    const size_t num_prefixed_fields = 3;
+    if (!VerifyBeforePointer(p, byte_width * num_prefixed_fields)) return false;
+    p -= byte_width * num_prefixed_fields;
+    auto off = ReadUInt64(p, byte_width);
+    if (!VerifyOffset(off, p)) return false;
+    auto key_byte_with =
+        static_cast<uint8_t>(ReadUInt64(p + byte_width, byte_width));
+    if (!VerifyByteWidth(key_byte_with)) return false;
+    return VerifyVector(Reference(p, byte_width, key_byte_with, FBT_VECTOR_KEY),
+                        p - off, FBT_KEY);
+  }
+
+  bool VerifyKey(const uint8_t *p) {
+    FLEX_CHECK_VERIFIED(p, PackedType(BIT_WIDTH_8, FBT_KEY));
+    while (p < buf_ + size_)
+      if (*p++) return true;
+    return false;
+  }
+
+#undef FLEX_CHECK_VERIFIED
+
+  bool VerifyTerminator(const String &s) {
+    return VerifyFromPointer(reinterpret_cast<const uint8_t *>(s.c_str()),
+                             s.size() + 1);
+  }
+
+  bool VerifyRef(Reference r) {
+    // r.parent_width_ and r.data_ already verified.
+    if (!VerifyByteWidth(r.byte_width_) || !VerifyType(r.type_)) {
+      return false;
+    }
+    if (IsInline(r.type_)) {
+      // Inline scalars, don't require further verification.
+      return true;
+    }
+    // All remaining types are an offset.
+    auto off = ReadUInt64(r.data_, r.parent_width_);
+    if (!VerifyOffset(off, r.data_)) return false;
+    auto p = r.Indirect();
+    if (!VerifyAlignment(p, r.byte_width_)) return false;
+    switch (r.type_) {
+      case FBT_INDIRECT_INT:
+      case FBT_INDIRECT_UINT:
+      case FBT_INDIRECT_FLOAT: return VerifyFromPointer(p, r.byte_width_);
+      case FBT_KEY: return VerifyKey(p);
+      case FBT_MAP:
+        return VerifyVector(r, p, FBT_NULL) && VerifyKeys(p, r.byte_width_);
+      case FBT_VECTOR: return VerifyVector(r, p, FBT_NULL);
+      case FBT_VECTOR_INT: return VerifyVector(r, p, FBT_INT);
+      case FBT_VECTOR_BOOL:
+      case FBT_VECTOR_UINT: return VerifyVector(r, p, FBT_UINT);
+      case FBT_VECTOR_FLOAT: return VerifyVector(r, p, FBT_FLOAT);
+      case FBT_VECTOR_KEY: return VerifyVector(r, p, FBT_KEY);
+      case FBT_VECTOR_STRING_DEPRECATED:
+        // Use of FBT_KEY here intentional, see elsewhere.
+        return VerifyVector(r, p, FBT_KEY);
+      case FBT_BLOB: return VerifyVector(r, p, FBT_UINT);
+      case FBT_STRING:
+        return VerifyVector(r, p, FBT_UINT) &&
+               VerifyTerminator(String(p, r.byte_width_));
+      case FBT_VECTOR_INT2:
+      case FBT_VECTOR_UINT2:
+      case FBT_VECTOR_FLOAT2:
+      case FBT_VECTOR_INT3:
+      case FBT_VECTOR_UINT3:
+      case FBT_VECTOR_FLOAT3:
+      case FBT_VECTOR_INT4:
+      case FBT_VECTOR_UINT4:
+      case FBT_VECTOR_FLOAT4: {
+        uint8_t len = 0;
+        auto vtype = ToFixedTypedVectorElementType(r.type_, &len);
+        if (!VerifyType(vtype)) return false;
+        return VerifyFromPointer(p, r.byte_width_ * len);
+      }
+      default: return false;
+    }
+  }
+
+ public:
+  bool VerifyBuffer() {
+    if (!Check(size_ >= 3)) return false;
+    auto end = buf_ + size_;
+    auto byte_width = *--end;
+    auto packed_type = *--end;
+    return VerifyByteWidth(byte_width) && Check(end - buf_ >= byte_width) &&
+           VerifyRef(Reference(end - byte_width, byte_width, packed_type));
+  }
+
+ private:
+  const uint8_t *buf_;
+  size_t size_;
+  size_t depth_;
+  const size_t max_depth_;
+  size_t num_vectors_;
+  const size_t max_vectors_;
+  bool check_alignment_;
+  std::vector<uint8_t> *reuse_tracker_;
+};
+
+// Utility function that contructs the Verifier for you, see above for
+// parameters.
+inline bool VerifyBuffer(const uint8_t *buf, size_t buf_len,
+                         std::vector<uint8_t> *reuse_tracker = nullptr) {
+  Verifier verifier(buf, buf_len, reuse_tracker);
+  return verifier.VerifyBuffer();
+}
+
+}  // namespace flexbuffers
+
+#if defined(_MSC_VER)
+#  pragma warning(pop)
+#endif
+
+#endif  // FLATBUFFERS_FLEXBUFFERS_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/grpc.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/grpc.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/grpc.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/grpc.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,302 @@
+/*
+ * Copyright 2014 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_GRPC_H_
+#define FLATBUFFERS_GRPC_H_
+
+// Helper functionality to glue FlatBuffers and GRPC.
+
+#include "flatbuffers/flatbuffers.h"
+#include "grpc/byte_buffer_reader.h"
+#include "grpcpp/support/byte_buffer.h"
+#include "grpcpp/support/slice.h"
+
+namespace mapserver {
+namespace flatbuffers {
+namespace grpc {
+
+// Message is a typed wrapper around a buffer that manages the underlying
+// `grpc_slice` and also provides flatbuffers-specific helpers such as `Verify`
+// and `GetRoot`. Since it is backed by a `grpc_slice`, the underlying buffer
+// is refcounted and ownership is be managed automatically.
+template<class T> class Message {
+ public:
+  Message() {}
+
+  Message(::grpc::Slice slice) : slice_(slice) {}
+
+  Message &operator=(const Message &other) = delete;
+
+  Message(Message &&other) = default;
+
+  Message(const Message &other) = delete;
+
+  Message &operator=(Message &&other) = default;
+
+  const uint8_t *mutable_data() const { return slice_.begin(); }
+
+  const uint8_t *data() const { return slice_.begin(); }
+
+  size_t size() const { return slice_.size(); }
+
+  bool Verify() const {
+    Verifier verifier(data(), size());
+    return verifier.VerifyBuffer<T>(nullptr);
+  }
+
+  T *GetMutableRoot() { return flatbuffers::GetMutableRoot<T>(mutable_data()); }
+
+  const T *GetRoot() const { return flatbuffers::GetRoot<T>(data()); }
+
+  // This is only intended for serializer use, or if you know what you're doing
+  const ::grpc::Slice &BorrowSlice() const { return slice_; }
+
+ private:
+  ::grpc::Slice slice_;
+};
+
+class MessageBuilder;
+
+// SliceAllocator is a gRPC-specific allocator that uses the `grpc_slice`
+// refcounted slices to manage memory ownership. This makes it easy and
+// efficient to transfer buffers to gRPC.
+class SliceAllocator : public Allocator {
+ public:
+  SliceAllocator() {}
+
+  SliceAllocator(const SliceAllocator &other) = delete;
+  SliceAllocator &operator=(const SliceAllocator &other) = delete;
+
+  SliceAllocator(SliceAllocator &&other) {
+    // default-construct and swap idiom
+    swap(other);
+  }
+
+  SliceAllocator &operator=(SliceAllocator &&other) {
+    // move-construct and swap idiom
+    SliceAllocator temp(std::move(other));
+    swap(temp);
+    return *this;
+  }
+
+  void swap(SliceAllocator &other) {
+    using std::swap;
+    swap(slice_, other.slice_);
+  }
+
+  virtual ~SliceAllocator() {}
+
+  virtual uint8_t *allocate(size_t size) override {
+    FLATBUFFERS_ASSERT(slice_.size() == 0);
+    slice_ = ::grpc::Slice(size);
+    return const_cast<uint8_t *>(slice_.begin());
+  }
+
+  virtual void deallocate(uint8_t *p, size_t size) override {
+    FLATBUFFERS_ASSERT(p == slice_.begin());
+    FLATBUFFERS_ASSERT(size == slice_.size());
+    slice_ = ::grpc::Slice();
+  }
+
+  virtual uint8_t *reallocate_downward(uint8_t *old_p, size_t old_size,
+                                       size_t new_size, size_t in_use_back,
+                                       size_t in_use_front) override {
+    FLATBUFFERS_ASSERT(old_p == slice_.begin());
+    FLATBUFFERS_ASSERT(old_size == slice_.size());
+    FLATBUFFERS_ASSERT(new_size > old_size);
+    ::grpc::Slice old_slice = slice_;
+    ::grpc::Slice new_slice = ::grpc::Slice(new_size);
+    uint8_t *new_p = const_cast<uint8_t *>(new_slice.begin());
+    memcpy_downward(old_p, old_size, new_p, new_size, in_use_back,
+                    in_use_front);
+    slice_ = new_slice;
+    return new_p;
+  }
+
+ private:
+  ::grpc::Slice &get_slice(uint8_t *p, size_t size) {
+    FLATBUFFERS_ASSERT(p == slice_.begin());
+    FLATBUFFERS_ASSERT(size == slice_.size());
+    return slice_;
+  }
+
+  ::grpc::Slice slice_;
+
+  friend class MessageBuilder;
+};
+
+// SliceAllocatorMember is a hack to ensure that the MessageBuilder's
+// slice_allocator_ member is constructed before the FlatBufferBuilder, since
+// the allocator is used in the FlatBufferBuilder ctor.
+namespace detail {
+struct SliceAllocatorMember {
+  SliceAllocator slice_allocator_;
+};
+}  // namespace detail
+
+// MessageBuilder is a gRPC-specific FlatBufferBuilder that uses SliceAllocator
+// to allocate gRPC buffers.
+class MessageBuilder : private detail::SliceAllocatorMember,
+                       public FlatBufferBuilder {
+ public:
+  explicit MessageBuilder(uoffset_t initial_size = 1024)
+      : FlatBufferBuilder(initial_size, &slice_allocator_, false) {}
+
+  MessageBuilder(const MessageBuilder &other) = delete;
+  MessageBuilder &operator=(const MessageBuilder &other) = delete;
+
+  MessageBuilder(MessageBuilder &&other)
+      : FlatBufferBuilder(1024, &slice_allocator_, false) {
+    // Default construct and swap idiom.
+    Swap(other);
+  }
+
+  /// Create a MessageBuilder from a FlatBufferBuilder.
+  explicit MessageBuilder(FlatBufferBuilder &&src,
+                          void (*dealloc)(void *,
+                                          size_t) = &DefaultAllocator::dealloc)
+      : FlatBufferBuilder(1024, &slice_allocator_, false) {
+    src.Swap(*this);
+    src.SwapBufAllocator(*this);
+    if (buf_.capacity()) {
+      uint8_t *buf = buf_.scratch_data();  // pointer to memory
+      size_t capacity = buf_.capacity();   // size of memory
+      slice_allocator_.slice_ = ::grpc::Slice(buf, capacity, dealloc);
+    } else {
+      slice_allocator_.slice_ = ::grpc::Slice();
+    }
+  }
+
+  /// Move-assign a FlatBufferBuilder to a MessageBuilder.
+  /// Only FlatBufferBuilder with default allocator (basically, nullptr) is
+  /// supported.
+  MessageBuilder &operator=(FlatBufferBuilder &&src) {
+    // Move construct a temporary and swap
+    MessageBuilder temp(std::move(src));
+    Swap(temp);
+    return *this;
+  }
+
+  MessageBuilder &operator=(MessageBuilder &&other) {
+    // Move construct a temporary and swap
+    MessageBuilder temp(std::move(other));
+    Swap(temp);
+    return *this;
+  }
+
+  void Swap(MessageBuilder &other) {
+    slice_allocator_.swap(other.slice_allocator_);
+    FlatBufferBuilder::Swap(other);
+    // After swapping the FlatBufferBuilder, we swap back the allocator, which
+    // restores the original allocator back in place. This is necessary because
+    // MessageBuilder's allocator is its own member (SliceAllocatorMember). The
+    // allocator passed to FlatBufferBuilder::vector_downward must point to this
+    // member.
+    buf_.swap_allocator(other.buf_);
+  }
+
+  // Releases the ownership of the buffer pointer.
+  // Returns the size, offset, and the original grpc_slice that
+  // allocated the buffer. Also see grpc_slice_unref().
+  uint8_t *ReleaseRaw(size_t &size, size_t &offset, ::grpc::Slice &slice) {
+    uint8_t *buf = FlatBufferBuilder::ReleaseRaw(size, offset);
+    slice = slice_allocator_.slice_;
+    slice_allocator_.slice_ = ::grpc::Slice();
+    return buf;
+  }
+
+  ~MessageBuilder() {}
+
+  // GetMessage extracts the subslice of the buffer corresponding to the
+  // flatbuffers-encoded region and wraps it in a `Message<T>` to handle buffer
+  // ownership.
+  template<class T> Message<T> GetMessage() {
+    auto buf_data = buf_.scratch_data();  // pointer to memory
+    auto buf_size = buf_.capacity();      // size of memory
+    auto msg_data = buf_.data();          // pointer to msg
+    auto msg_size = buf_.size();          // size of msg
+    // Do some sanity checks on data/size
+    FLATBUFFERS_ASSERT(msg_data);
+    FLATBUFFERS_ASSERT(msg_size);
+    FLATBUFFERS_ASSERT(msg_data >= buf_data);
+    FLATBUFFERS_ASSERT(msg_data + msg_size <= buf_data + buf_size);
+    // Calculate offsets from the buffer start
+    auto begin = msg_data - buf_data;
+    auto end = begin + msg_size;
+    // Get the slice we are working with (no refcount change)
+    ::grpc::Slice slice = slice_allocator_.get_slice(buf_data, buf_size);
+    // Extract a subslice of the existing slice (increment refcount)
+    ::grpc::Slice subslice = slice.sub(begin, end);
+    // Wrap the subslice in a `Message<T>`, but don't increment refcount
+    Message<T> msg(subslice);
+    return msg;
+  }
+
+  template<class T> Message<T> ReleaseMessage() {
+    Message<T> msg = GetMessage<T>();
+    Reset();
+    return msg;
+  }
+
+ private:
+  // SliceAllocator slice_allocator_;  // part of SliceAllocatorMember
+};
+
+}  // namespace grpc
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+namespace grpc {
+
+template<class T> class SerializationTraits<flatbuffers::grpc::Message<T>> {
+ public:
+  static grpc::Status Serialize(const flatbuffers::grpc::Message<T> &msg,
+                                ByteBuffer *buffer, bool *own_buffer) {
+    // Package the single slice into a `ByteBuffer`,
+    // incrementing the refcount in the process.
+    *buffer = ByteBuffer(&msg.BorrowSlice(), 1);
+    *own_buffer = true;
+    return grpc::Status::OK;
+  }
+
+  // Deserialize by pulling the
+  static grpc::Status Deserialize(ByteBuffer *buf,
+                                  flatbuffers::grpc::Message<T> *msg) {
+    Slice slice;
+    if (!buf->TrySingleSlice(&slice).ok()) {
+      if (!buf->DumpToSingleSlice(&slice).ok()) {
+        buf->Clear();
+        return ::grpc::Status(::grpc::StatusCode::INTERNAL, "No payload");
+      }
+    }
+    *msg = flatbuffers::grpc::Message<T>(slice);
+    buf->Clear();
+#if FLATBUFFERS_GRPC_DISABLE_AUTO_VERIFICATION
+    return ::grpc::Status::OK;
+#else
+    if (msg->Verify()) {
+      return ::grpc::Status::OK;
+    } else {
+      return ::grpc::Status(::grpc::StatusCode::INTERNAL,
+                            "Message verification failed");
+    }
+#endif
+  }
+};
+
+}  // namespace grpc
+
+#endif  // FLATBUFFERS_GRPC_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/hash.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/hash.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/hash.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/hash.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,129 @@
+/*
+ * Copyright 2015 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_HASH_H_
+#define FLATBUFFERS_HASH_H_
+
+#include <cstdint>
+#include <cstring>
+
+#include "flatbuffers/flatbuffers.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+template<typename T> struct FnvTraits {
+  static const T kFnvPrime;
+  static const T kOffsetBasis;
+};
+
+template<> struct FnvTraits<uint32_t> {
+  static const uint32_t kFnvPrime = 0x01000193;
+  static const uint32_t kOffsetBasis = 0x811C9DC5;
+};
+
+template<> struct FnvTraits<uint64_t> {
+  static const uint64_t kFnvPrime = 0x00000100000001b3ULL;
+  static const uint64_t kOffsetBasis = 0xcbf29ce484222645ULL;
+};
+
+template<typename T> T HashFnv1(const char *input) {
+  T hash = FnvTraits<T>::kOffsetBasis;
+  for (const char *c = input; *c; ++c) {
+    hash *= FnvTraits<T>::kFnvPrime;
+    hash ^= static_cast<unsigned char>(*c);
+  }
+  return hash;
+}
+
+template<typename T> T HashFnv1a(const char *input) {
+  T hash = FnvTraits<T>::kOffsetBasis;
+  for (const char *c = input; *c; ++c) {
+    hash ^= static_cast<unsigned char>(*c);
+    hash *= FnvTraits<T>::kFnvPrime;
+  }
+  return hash;
+}
+
+template<> inline uint16_t HashFnv1<uint16_t>(const char *input) {
+  uint32_t hash = HashFnv1<uint32_t>(input);
+  return (hash >> 16) ^ (hash & 0xffff);
+}
+
+template<> inline uint16_t HashFnv1a<uint16_t>(const char *input) {
+  uint32_t hash = HashFnv1a<uint32_t>(input);
+  return (hash >> 16) ^ (hash & 0xffff);
+}
+
+template<typename T> struct NamedHashFunction {
+  const char *name;
+
+  typedef T (*HashFunction)(const char *);
+  HashFunction function;
+};
+
+const NamedHashFunction<uint16_t> kHashFunctions16[] = {
+  { "fnv1_16", HashFnv1<uint16_t> },
+  { "fnv1a_16", HashFnv1a<uint16_t> },
+};
+
+const NamedHashFunction<uint32_t> kHashFunctions32[] = {
+  { "fnv1_32", HashFnv1<uint32_t> },
+  { "fnv1a_32", HashFnv1a<uint32_t> },
+};
+
+const NamedHashFunction<uint64_t> kHashFunctions64[] = {
+  { "fnv1_64", HashFnv1<uint64_t> },
+  { "fnv1a_64", HashFnv1a<uint64_t> },
+};
+
+inline NamedHashFunction<uint16_t>::HashFunction FindHashFunction16(
+    const char *name) {
+  std::size_t size = sizeof(kHashFunctions16) / sizeof(kHashFunctions16[0]);
+  for (std::size_t i = 0; i < size; ++i) {
+    if (std::strcmp(name, kHashFunctions16[i].name) == 0) {
+      return kHashFunctions16[i].function;
+    }
+  }
+  return nullptr;
+}
+
+inline NamedHashFunction<uint32_t>::HashFunction FindHashFunction32(
+    const char *name) {
+  std::size_t size = sizeof(kHashFunctions32) / sizeof(kHashFunctions32[0]);
+  for (std::size_t i = 0; i < size; ++i) {
+    if (std::strcmp(name, kHashFunctions32[i].name) == 0) {
+      return kHashFunctions32[i].function;
+    }
+  }
+  return nullptr;
+}
+
+inline NamedHashFunction<uint64_t>::HashFunction FindHashFunction64(
+    const char *name) {
+  std::size_t size = sizeof(kHashFunctions64) / sizeof(kHashFunctions64[0]);
+  for (std::size_t i = 0; i < size; ++i) {
+    if (std::strcmp(name, kHashFunctions64[i].name) == 0) {
+      return kHashFunctions64[i].function;
+    }
+  }
+  return nullptr;
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_HASH_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/idl.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/idl.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/idl.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/idl.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1234 @@
+/*
+ * Copyright 2014 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_IDL_H_
+#define FLATBUFFERS_IDL_H_
+
+#include <functional>
+#include <map>
+#include <memory>
+#include <stack>
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/flatbuffers.h"
+#include "flatbuffers/flexbuffers.h"
+#include "flatbuffers/hash.h"
+#include "flatbuffers/reflection.h"
+
+// This file defines the data types representing a parsed IDL (Interface
+// Definition Language) / schema file.
+
+// Limits maximum depth of nested objects.
+// Prevents stack overflow while parse scheme, or json, or flexbuffer.
+#if !defined(FLATBUFFERS_MAX_PARSING_DEPTH)
+#  define FLATBUFFERS_MAX_PARSING_DEPTH 64
+#endif
+
+namespace mapserver {
+namespace flatbuffers {
+
+// The order of these matters for Is*() functions below.
+// Additionally, Parser::ParseType assumes bool..string is a contiguous range
+// of type tokens.
+// clang-format off
+#define FLATBUFFERS_GEN_TYPES_SCALAR(TD) \
+  TD(NONE,   "",       uint8_t,  byte,   byte,    byte,   uint8,   u8,   UByte, UInt8) \
+  TD(UTYPE,  "",       uint8_t,  byte,   byte,    byte,   uint8,   u8,   UByte, UInt8) /* begin scalar/int */ \
+  TD(BOOL,   "bool",   uint8_t,  boolean,bool,    bool,   bool,    bool, Boolean, Bool) \
+  TD(CHAR,   "byte",   int8_t,   byte,   int8,    sbyte,  int8,    i8,   Byte, Int8) \
+  TD(UCHAR,  "ubyte",  uint8_t,  byte,   byte,    byte,   uint8,   u8,   UByte, UInt8) \
+  TD(SHORT,  "short",  int16_t,  short,  int16,   short,  int16,   i16,  Short, Int16) \
+  TD(USHORT, "ushort", uint16_t, short,  uint16,  ushort, uint16,  u16,  UShort, UInt16) \
+  TD(INT,    "int",    int32_t,  int,    int32,   int,    int32,   i32,  Int, Int32) \
+  TD(UINT,   "uint",   uint32_t, int,    uint32,  uint,   uint32,  u32,  UInt, UInt32) \
+  TD(LONG,   "long",   int64_t,  long,   int64,   long,   int64,   i64,  Long, Int64) \
+  TD(ULONG,  "ulong",  uint64_t, long,   uint64,  ulong,  uint64,  u64,  ULong, UInt64) /* end int */ \
+  TD(FLOAT,  "float",  float,    float,  float32, float,  float32, f32,  Float, Float32) /* begin float */ \
+  TD(DOUBLE, "double", double,   double, float64, double, float64, f64,  Double, Double) /* end float/scalar */
+#define FLATBUFFERS_GEN_TYPES_POINTER(TD) \
+  TD(STRING, "string", Offset<void>, int, int, StringOffset, int, unused, Int, Offset<String>) \
+  TD(VECTOR, "",       Offset<void>, int, int, VectorOffset, int, unused, Int, Offset<UOffset>) \
+  TD(STRUCT, "",       Offset<void>, int, int, int,          int, unused, Int, Offset<UOffset>) \
+  TD(UNION,  "",       Offset<void>, int, int, int,          int, unused, Int, Offset<UOffset>)
+#define FLATBUFFERS_GEN_TYPE_ARRAY(TD) \
+  TD(ARRAY,  "",       int,          int, int, int,          int, unused, Int, Offset<UOffset>)
+// The fields are:
+// - enum
+// - FlatBuffers schema type.
+// - C++ type.
+// - Java type.
+// - Go type.
+// - C# / .Net type.
+// - Python type.
+// - Kotlin type.
+// - Rust type.
+
+// using these macros, we can now write code dealing with types just once, e.g.
+
+/*
+switch (type) {
+  #define FLATBUFFERS_TD(ENUM, IDLTYPE, CTYPE, JTYPE, GTYPE, NTYPE, PTYPE, \
+                         RTYPE, KTYPE) \
+    case BASE_TYPE_ ## ENUM: \
+      // do something specific to CTYPE here
+    FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
+  #undef FLATBUFFERS_TD
+}
+*/
+
+// If not all FLATBUFFERS_GEN_() arguments are necessary for implementation
+// of FLATBUFFERS_TD, you can use a variadic macro (with __VA_ARGS__ if needed).
+// In the above example, only CTYPE is used to generate the code, it can be rewritten:
+
+/*
+switch (type) {
+  #define FLATBUFFERS_TD(ENUM, IDLTYPE, CTYPE, ...) \
+    case BASE_TYPE_ ## ENUM: \
+      // do something specific to CTYPE here
+    FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
+  #undef FLATBUFFERS_TD
+}
+*/
+
+#define FLATBUFFERS_GEN_TYPES(TD) \
+        FLATBUFFERS_GEN_TYPES_SCALAR(TD) \
+        FLATBUFFERS_GEN_TYPES_POINTER(TD) \
+        FLATBUFFERS_GEN_TYPE_ARRAY(TD)
+
+// Create an enum for all the types above.
+#ifdef __GNUC__
+__extension__  // Stop GCC complaining about trailing comma with -Wpendantic.
+#endif
+enum BaseType {
+  #define FLATBUFFERS_TD(ENUM, ...) \
+    BASE_TYPE_ ## ENUM,
+    FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
+  #undef FLATBUFFERS_TD
+};
+
+#define FLATBUFFERS_TD(ENUM, IDLTYPE, CTYPE, ...) \
+  static_assert(sizeof(CTYPE) <= sizeof(largest_scalar_t), \
+                "define largest_scalar_t as " #CTYPE);
+  FLATBUFFERS_GEN_TYPES(FLATBUFFERS_TD)
+#undef FLATBUFFERS_TD
+
+inline bool IsScalar (BaseType t) { return t >= BASE_TYPE_UTYPE &&
+                                           t <= BASE_TYPE_DOUBLE; }
+inline bool IsInteger(BaseType t) { return t >= BASE_TYPE_UTYPE &&
+                                           t <= BASE_TYPE_ULONG; }
+inline bool IsFloat  (BaseType t) { return t == BASE_TYPE_FLOAT ||
+                                           t == BASE_TYPE_DOUBLE; }
+inline bool IsLong   (BaseType t) { return t == BASE_TYPE_LONG ||
+                                           t == BASE_TYPE_ULONG; }
+inline bool IsBool   (BaseType t) { return t == BASE_TYPE_BOOL; }
+inline bool IsOneByte(BaseType t) { return t >= BASE_TYPE_UTYPE &&
+                                           t <= BASE_TYPE_UCHAR; }
+
+inline bool IsUnsigned(BaseType t) {
+  return (t == BASE_TYPE_UTYPE)  || (t == BASE_TYPE_UCHAR) ||
+         (t == BASE_TYPE_USHORT) || (t == BASE_TYPE_UINT)  ||
+         (t == BASE_TYPE_ULONG);
+}
+
+// clang-format on
+
+extern const char *const kTypeNames[];
+extern const char kTypeSizes[];
+
+inline size_t SizeOf(BaseType t) { return kTypeSizes[t]; }
+
+struct StructDef;
+struct EnumDef;
+class Parser;
+
+// Represents any type in the IDL, which is a combination of the BaseType
+// and additional information for vectors/structs_.
+struct Type {
+  explicit Type(BaseType _base_type = BASE_TYPE_NONE, StructDef *_sd = nullptr,
+                EnumDef *_ed = nullptr, uint16_t _fixed_length = 0)
+      : base_type(_base_type),
+        element(BASE_TYPE_NONE),
+        struct_def(_sd),
+        enum_def(_ed),
+        fixed_length(_fixed_length) {}
+
+  bool operator==(const Type &o) {
+    return base_type == o.base_type && element == o.element &&
+           struct_def == o.struct_def && enum_def == o.enum_def;
+  }
+
+  Type VectorType() const {
+    return Type(element, struct_def, enum_def, fixed_length);
+  }
+
+  Offset<reflection::Type> Serialize(FlatBufferBuilder *builder) const;
+
+  bool Deserialize(const Parser &parser, const reflection::Type *type);
+
+  BaseType base_type;
+  BaseType element;       // only set if t == BASE_TYPE_VECTOR
+  StructDef *struct_def;  // only set if t or element == BASE_TYPE_STRUCT
+  EnumDef *enum_def;      // set if t == BASE_TYPE_UNION / BASE_TYPE_UTYPE,
+                          // or for an integral type derived from an enum.
+  uint16_t fixed_length;  // only set if t == BASE_TYPE_ARRAY
+};
+
+// Represents a parsed scalar value, it's type, and field offset.
+struct Value {
+  Value()
+      : constant("0"),
+        offset(static_cast<voffset_t>(~(static_cast<voffset_t>(0U)))) {}
+  Type type;
+  std::string constant;
+  voffset_t offset;
+};
+
+// Helper class that retains the original order of a set of identifiers and
+// also provides quick lookup.
+template<typename T> class SymbolTable {
+ public:
+  ~SymbolTable() {
+    for (auto it = vec.begin(); it != vec.end(); ++it) { delete *it; }
+  }
+
+  bool Add(const std::string &name, T *e) {
+    vec.emplace_back(e);
+    auto it = dict.find(name);
+    if (it != dict.end()) return true;
+    dict[name] = e;
+    return false;
+  }
+
+  void Move(const std::string &oldname, const std::string &newname) {
+    auto it = dict.find(oldname);
+    if (it != dict.end()) {
+      auto obj = it->second;
+      dict.erase(it);
+      dict[newname] = obj;
+    } else {
+      FLATBUFFERS_ASSERT(false);
+    }
+  }
+
+  T *Lookup(const std::string &name) const {
+    auto it = dict.find(name);
+    return it == dict.end() ? nullptr : it->second;
+  }
+
+ public:
+  std::map<std::string, T *> dict;  // quick lookup
+  std::vector<T *> vec;             // Used to iterate in order of insertion
+};
+
+// A name space, as set in the schema.
+struct Namespace {
+  Namespace() : from_table(0) {}
+
+  // Given a (potentially unqualified) name, return the "fully qualified" name
+  // which has a full namespaced descriptor.
+  // With max_components you can request less than the number of components
+  // the current namespace has.
+  std::string GetFullyQualifiedName(const std::string &name,
+                                    size_t max_components = 1000) const;
+
+  std::vector<std::string> components;
+  size_t from_table;  // Part of the namespace corresponds to a message/table.
+};
+
+inline bool operator<(const Namespace &a, const Namespace &b) {
+  size_t min_size = std::min(a.components.size(), b.components.size());
+  for (size_t i = 0; i < min_size; ++i) {
+    if (a.components[i] != b.components[i])
+      return a.components[i] < b.components[i];
+  }
+  return a.components.size() < b.components.size();
+}
+
+// Base class for all definition types (fields, structs_, enums_).
+struct Definition {
+  Definition()
+      : generated(false),
+        defined_namespace(nullptr),
+        serialized_location(0),
+        index(-1),
+        refcount(1),
+        declaration_file(nullptr) {}
+
+  flatbuffers::Offset<
+      flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>>
+  SerializeAttributes(FlatBufferBuilder *builder, const Parser &parser) const;
+
+  bool DeserializeAttributes(Parser &parser,
+                             const Vector<Offset<reflection::KeyValue>> *attrs);
+
+  std::string name;
+  std::string file;
+  std::vector<std::string> doc_comment;
+  SymbolTable<Value> attributes;
+  bool generated;  // did we already output code for this definition?
+  Namespace *defined_namespace;  // Where it was defined.
+
+  // For use with Serialize()
+  uoffset_t serialized_location;
+  int index;  // Inside the vector it is stored.
+  int refcount;
+  const std::string *declaration_file;
+};
+
+struct FieldDef : public Definition {
+  FieldDef()
+      : deprecated(false),
+        key(false),
+        shared(false),
+        native_inline(false),
+        flexbuffer(false),
+        presence(kDefault),
+        nested_flatbuffer(NULL),
+        padding(0) {}
+
+  Offset<reflection::Field> Serialize(FlatBufferBuilder *builder, uint16_t id,
+                                      const Parser &parser) const;
+
+  bool Deserialize(Parser &parser, const reflection::Field *field);
+
+  bool IsScalarOptional() const {
+    return IsScalar(value.type.base_type) && IsOptional();
+  }
+  bool IsOptional() const { return presence == kOptional; }
+  bool IsRequired() const { return presence == kRequired; }
+  bool IsDefault() const { return presence == kDefault; }
+
+  Value value;
+  bool deprecated;  // Field is allowed to be present in old data, but can't be.
+                    // written in new data nor accessed in new code.
+  bool key;         // Field functions as a key for creating sorted vectors.
+  bool shared;  // Field will be using string pooling (i.e. CreateSharedString)
+                // as default serialization behavior if field is a string.
+  bool native_inline;  // Field will be defined inline (instead of as a pointer)
+                       // for native tables if field is a struct.
+  bool flexbuffer;     // This field contains FlexBuffer data.
+
+  enum Presence {
+    // Field must always be present.
+    kRequired,
+    // Non-presence should be signalled to and controlled by users.
+    kOptional,
+    // Non-presence is hidden from users.
+    // Implementations may omit writing default values.
+    kDefault,
+  };
+  Presence static MakeFieldPresence(bool optional, bool required) {
+    FLATBUFFERS_ASSERT(!(required && optional));
+    // clang-format off
+    return required ? FieldDef::kRequired
+         : optional ? FieldDef::kOptional
+                    : FieldDef::kDefault;
+    // clang-format on
+  }
+  Presence presence;
+
+  StructDef *nested_flatbuffer;  // This field contains nested FlatBuffer data.
+  size_t padding;                // Bytes to always pad after this field.
+};
+
+struct StructDef : public Definition {
+  StructDef()
+      : fixed(false),
+        predecl(true),
+        sortbysize(true),
+        has_key(false),
+        minalign(1),
+        bytesize(0) {}
+
+  void PadLastField(size_t min_align) {
+    auto padding = PaddingBytes(bytesize, min_align);
+    bytesize += padding;
+    if (fields.vec.size()) fields.vec.back()->padding = padding;
+  }
+
+  Offset<reflection::Object> Serialize(FlatBufferBuilder *builder,
+                                       const Parser &parser) const;
+
+  bool Deserialize(Parser &parser, const reflection::Object *object);
+
+  SymbolTable<FieldDef> fields;
+
+  bool fixed;       // If it's struct, not a table.
+  bool predecl;     // If it's used before it was defined.
+  bool sortbysize;  // Whether fields come in the declaration or size order.
+  bool has_key;     // It has a key field.
+  size_t minalign;  // What the whole object needs to be aligned to.
+  size_t bytesize;  // Size if fixed.
+
+  flatbuffers::unique_ptr<std::string> original_location;
+};
+
+struct EnumDef;
+struct EnumValBuilder;
+
+struct EnumVal {
+  Offset<reflection::EnumVal> Serialize(FlatBufferBuilder *builder,
+                                        const Parser &parser) const;
+
+  bool Deserialize(const Parser &parser, const reflection::EnumVal *val);
+
+  uint64_t GetAsUInt64() const { return static_cast<uint64_t>(value); }
+  int64_t GetAsInt64() const { return value; }
+  bool IsZero() const { return 0 == value; }
+  bool IsNonZero() const { return !IsZero(); }
+
+  std::string name;
+  std::vector<std::string> doc_comment;
+  Type union_type;
+
+ private:
+  friend EnumDef;
+  friend EnumValBuilder;
+  friend bool operator==(const EnumVal &lhs, const EnumVal &rhs);
+
+  EnumVal(const std::string &_name, int64_t _val) : name(_name), value(_val) {}
+  EnumVal() : value(0) {}
+
+  int64_t value;
+};
+
+struct EnumDef : public Definition {
+  EnumDef() : is_union(false), uses_multiple_type_instances(false) {}
+
+  Offset<reflection::Enum> Serialize(FlatBufferBuilder *builder,
+                                     const Parser &parser) const;
+
+  bool Deserialize(Parser &parser, const reflection::Enum *values);
+
+  template<typename T> void ChangeEnumValue(EnumVal *ev, T new_val);
+  void SortByValue();
+  void RemoveDuplicates();
+
+  std::string AllFlags() const;
+  const EnumVal *MinValue() const;
+  const EnumVal *MaxValue() const;
+  // Returns the number of integer steps from v1 to v2.
+  uint64_t Distance(const EnumVal *v1, const EnumVal *v2) const;
+  // Returns the number of integer steps from Min to Max.
+  uint64_t Distance() const { return Distance(MinValue(), MaxValue()); }
+
+  EnumVal *ReverseLookup(int64_t enum_idx,
+                         bool skip_union_default = false) const;
+  EnumVal *FindByValue(const std::string &constant) const;
+
+  std::string ToString(const EnumVal &ev) const {
+    return IsUInt64() ? NumToString(ev.GetAsUInt64())
+                      : NumToString(ev.GetAsInt64());
+  }
+
+  size_t size() const { return vals.vec.size(); }
+
+  const std::vector<EnumVal *> &Vals() const { return vals.vec; }
+
+  const EnumVal *Lookup(const std::string &enum_name) const {
+    return vals.Lookup(enum_name);
+  }
+
+  bool is_union;
+  // Type is a union which uses type aliases where at least one type is
+  // available under two different names.
+  bool uses_multiple_type_instances;
+  Type underlying_type;
+
+ private:
+  bool IsUInt64() const {
+    return (BASE_TYPE_ULONG == underlying_type.base_type);
+  }
+
+  friend EnumValBuilder;
+  SymbolTable<EnumVal> vals;
+};
+
+inline bool IsString(const Type &type) {
+  return type.base_type == BASE_TYPE_STRING;
+}
+
+inline bool IsStruct(const Type &type) {
+  return type.base_type == BASE_TYPE_STRUCT && type.struct_def->fixed;
+}
+
+inline bool IsUnion(const Type &type) {
+  return type.enum_def != nullptr && type.enum_def->is_union;
+}
+
+inline bool IsUnionType(const Type &type) {
+  return IsUnion(type) && IsInteger(type.base_type);
+}
+
+inline bool IsVector(const Type &type) {
+  return type.base_type == BASE_TYPE_VECTOR;
+}
+
+inline bool IsArray(const Type &type) {
+  return type.base_type == BASE_TYPE_ARRAY;
+}
+
+inline bool IsSeries(const Type &type) {
+  return IsVector(type) || IsArray(type);
+}
+
+inline bool IsEnum(const Type &type) {
+  return type.enum_def != nullptr && IsInteger(type.base_type);
+}
+
+inline size_t InlineSize(const Type &type) {
+  return IsStruct(type)
+             ? type.struct_def->bytesize
+             : (IsArray(type)
+                    ? InlineSize(type.VectorType()) * type.fixed_length
+                    : SizeOf(type.base_type));
+}
+
+inline size_t InlineAlignment(const Type &type) {
+  if (IsStruct(type)) {
+    return type.struct_def->minalign;
+  } else if (IsArray(type)) {
+    return IsStruct(type.VectorType()) ? type.struct_def->minalign
+                                       : SizeOf(type.element);
+  } else {
+    return SizeOf(type.base_type);
+  }
+}
+inline bool operator==(const EnumVal &lhs, const EnumVal &rhs) {
+  return lhs.value == rhs.value;
+}
+inline bool operator!=(const EnumVal &lhs, const EnumVal &rhs) {
+  return !(lhs == rhs);
+}
+
+inline bool EqualByName(const Type &a, const Type &b) {
+  return a.base_type == b.base_type && a.element == b.element &&
+         (a.struct_def == b.struct_def ||
+          a.struct_def->name == b.struct_def->name) &&
+         (a.enum_def == b.enum_def || a.enum_def->name == b.enum_def->name);
+}
+
+struct RPCCall : public Definition {
+  Offset<reflection::RPCCall> Serialize(FlatBufferBuilder *builder,
+                                        const Parser &parser) const;
+
+  bool Deserialize(Parser &parser, const reflection::RPCCall *call);
+
+  StructDef *request, *response;
+};
+
+struct ServiceDef : public Definition {
+  Offset<reflection::Service> Serialize(FlatBufferBuilder *builder,
+                                        const Parser &parser) const;
+  bool Deserialize(Parser &parser, const reflection::Service *service);
+
+  SymbolTable<RPCCall> calls;
+};
+
+// Container of options that may apply to any of the source/text generators.
+struct IDLOptions {
+  // field case style options for C++
+  enum CaseStyle { CaseStyle_Unchanged = 0, CaseStyle_Upper, CaseStyle_Lower };
+
+  bool gen_jvmstatic;
+  // Use flexbuffers instead for binary and text generation
+  bool use_flexbuffers;
+  bool strict_json;
+  bool output_default_scalars_in_json;
+  int indent_step;
+  bool output_enum_identifiers;
+  bool prefixed_enums;
+  bool scoped_enums;
+  bool swift_implementation_only;
+  bool include_dependence_headers;
+  bool mutable_buffer;
+  bool one_file;
+  bool proto_mode;
+  bool proto_oneof_union;
+  bool generate_all;
+  bool skip_unexpected_fields_in_json;
+  bool generate_name_strings;
+  bool generate_object_based_api;
+  bool gen_compare;
+  std::string cpp_object_api_pointer_type;
+  std::string cpp_object_api_string_type;
+  bool cpp_object_api_string_flexible_constructor;
+  CaseStyle cpp_object_api_field_case_style;
+  bool cpp_direct_copy;
+  bool gen_nullable;
+  bool java_checkerframework;
+  bool gen_generated;
+  bool gen_json_coders;
+  std::string object_prefix;
+  std::string object_suffix;
+  bool union_value_namespacing;
+  bool allow_non_utf8;
+  bool natural_utf8;
+  std::string include_prefix;
+  bool keep_include_path;
+  bool binary_schema_comments;
+  bool binary_schema_builtins;
+  bool binary_schema_gen_embed;
+  std::string go_import;
+  std::string go_namespace;
+  bool protobuf_ascii_alike;
+  bool size_prefixed;
+  std::string root_type;
+  bool force_defaults;
+  bool java_primitive_has_method;
+  bool cs_gen_json_serializer;
+  std::vector<std::string> cpp_includes;
+  std::string cpp_std;
+  bool cpp_static_reflection;
+  std::string proto_namespace_suffix;
+  std::string filename_suffix;
+  std::string filename_extension;
+  bool no_warnings;
+  bool warnings_as_errors;
+  std::string project_root;
+  bool cs_global_alias;
+  bool json_nested_flatbuffers;
+  bool json_nested_flexbuffers;
+  bool json_nested_legacy_flatbuffers;
+  bool ts_flat_file;
+
+  // Possible options for the more general generator below.
+  enum Language {
+    kJava = 1 << 0,
+    kCSharp = 1 << 1,
+    kGo = 1 << 2,
+    kCpp = 1 << 3,
+    kPython = 1 << 5,
+    kPhp = 1 << 6,
+    kJson = 1 << 7,
+    kBinary = 1 << 8,
+    kTs = 1 << 9,
+    kJsonSchema = 1 << 10,
+    kDart = 1 << 11,
+    kLua = 1 << 12,
+    kLobster = 1 << 13,
+    kRust = 1 << 14,
+    kKotlin = 1 << 15,
+    kSwift = 1 << 16,
+    kMAX
+  };
+
+  enum MiniReflect { kNone, kTypes, kTypesAndNames };
+
+  MiniReflect mini_reflect;
+
+  // If set, require all fields in a table to be explicitly numbered.
+  bool require_explicit_ids;
+
+  // If set, implement serde::Serialize for generated Rust types
+  bool rust_serialize;
+
+  // If set, generate rust types in individual files with a root module file.
+  bool rust_module_root_file;
+
+  // The corresponding language bit will be set if a language is included
+  // for code generation.
+  unsigned long lang_to_generate;
+
+  // If set (default behavior), empty string fields will be set to nullptr to
+  // make the flatbuffer more compact.
+  bool set_empty_strings_to_null;
+
+  // If set (default behavior), empty vector fields will be set to nullptr to
+  // make the flatbuffer more compact.
+  bool set_empty_vectors_to_null;
+
+  IDLOptions()
+      : gen_jvmstatic(false),
+        use_flexbuffers(false),
+        strict_json(false),
+        output_default_scalars_in_json(false),
+        indent_step(2),
+        output_enum_identifiers(true),
+        prefixed_enums(true),
+        scoped_enums(false),
+        swift_implementation_only(false),
+        include_dependence_headers(true),
+        mutable_buffer(false),
+        one_file(false),
+        proto_mode(false),
+        proto_oneof_union(false),
+        generate_all(false),
+        skip_unexpected_fields_in_json(false),
+        generate_name_strings(false),
+        generate_object_based_api(false),
+        gen_compare(false),
+        cpp_object_api_pointer_type("std::unique_ptr"),
+        cpp_object_api_string_flexible_constructor(false),
+        cpp_object_api_field_case_style(CaseStyle_Unchanged),
+        cpp_direct_copy(true),
+        gen_nullable(false),
+        java_checkerframework(false),
+        gen_generated(false),
+        gen_json_coders(false),
+        object_suffix("T"),
+        union_value_namespacing(true),
+        allow_non_utf8(false),
+        natural_utf8(false),
+        keep_include_path(false),
+        binary_schema_comments(false),
+        binary_schema_builtins(false),
+        binary_schema_gen_embed(false),
+        protobuf_ascii_alike(false),
+        size_prefixed(false),
+        force_defaults(false),
+        java_primitive_has_method(false),
+        cs_gen_json_serializer(false),
+        cpp_static_reflection(false),
+        filename_suffix("_generated"),
+        filename_extension(),
+        no_warnings(false),
+        warnings_as_errors(false),
+        project_root(""),
+        cs_global_alias(false),
+        json_nested_flatbuffers(true),
+        json_nested_flexbuffers(true),
+        json_nested_legacy_flatbuffers(false),
+        ts_flat_file(false),
+        mini_reflect(IDLOptions::kNone),
+        require_explicit_ids(false),
+        rust_serialize(false),
+        rust_module_root_file(false),
+        lang_to_generate(0),
+        set_empty_strings_to_null(true),
+        set_empty_vectors_to_null(true) {}
+};
+
+// This encapsulates where the parser is in the current source file.
+struct ParserState {
+  ParserState()
+      : cursor_(nullptr),
+        line_start_(nullptr),
+        line_(0),
+        token_(-1),
+        attr_is_trivial_ascii_string_(true) {}
+
+ protected:
+  void ResetState(const char *source) {
+    cursor_ = source;
+    line_ = 0;
+    MarkNewLine();
+  }
+
+  void MarkNewLine() {
+    line_start_ = cursor_;
+    line_ += 1;
+  }
+
+  int64_t CursorPosition() const {
+    FLATBUFFERS_ASSERT(cursor_ && line_start_ && cursor_ >= line_start_);
+    return static_cast<int64_t>(cursor_ - line_start_);
+  }
+
+  const char *cursor_;
+  const char *line_start_;
+  int line_;  // the current line being parsed
+  int token_;
+
+  // Flag: text in attribute_ is true ASCII string without escape
+  // sequences. Only printable ASCII (without [\t\r\n]).
+  // Used for number-in-string (and base64 string in future).
+  bool attr_is_trivial_ascii_string_;
+  std::string attribute_;
+  std::vector<std::string> doc_comment_;
+};
+
+// A way to make error propagation less error prone by requiring values to be
+// checked.
+// Once you create a value of this type you must either:
+// - Call Check() on it.
+// - Copy or assign it to another value.
+// Failure to do so leads to an assert.
+// This guarantees that this as return value cannot be ignored.
+class CheckedError {
+ public:
+  explicit CheckedError(bool error)
+      : is_error_(error), has_been_checked_(false) {}
+
+  CheckedError &operator=(const CheckedError &other) {
+    is_error_ = other.is_error_;
+    has_been_checked_ = false;
+    other.has_been_checked_ = true;
+    return *this;
+  }
+
+  CheckedError(const CheckedError &other) {
+    *this = other;  // Use assignment operator.
+  }
+
+  ~CheckedError() { FLATBUFFERS_ASSERT(has_been_checked_); }
+
+  bool Check() {
+    has_been_checked_ = true;
+    return is_error_;
+  }
+
+ private:
+  bool is_error_;
+  mutable bool has_been_checked_;
+};
+
+// Additionally, in GCC we can get these errors statically, for additional
+// assurance:
+// clang-format off
+#ifdef __GNUC__
+#define FLATBUFFERS_CHECKED_ERROR CheckedError \
+          __attribute__((warn_unused_result))
+#else
+#define FLATBUFFERS_CHECKED_ERROR CheckedError
+#endif
+// clang-format on
+
+class Parser : public ParserState {
+ public:
+  explicit Parser(const IDLOptions &options = IDLOptions())
+      : current_namespace_(nullptr),
+        empty_namespace_(nullptr),
+        flex_builder_(256, flexbuffers::BUILDER_FLAG_SHARE_ALL),
+        root_struct_def_(nullptr),
+        opts(options),
+        uses_flexbuffers_(false),
+        has_warning_(false),
+        advanced_features_(0),
+        source_(nullptr),
+        anonymous_counter_(0),
+        parse_depth_counter_(0) {
+    if (opts.force_defaults) { builder_.ForceDefaults(true); }
+    // Start out with the empty namespace being current.
+    empty_namespace_ = new Namespace();
+    namespaces_.push_back(empty_namespace_);
+    current_namespace_ = empty_namespace_;
+    known_attributes_["deprecated"] = true;
+    known_attributes_["required"] = true;
+    known_attributes_["key"] = true;
+    known_attributes_["shared"] = true;
+    known_attributes_["hash"] = true;
+    known_attributes_["id"] = true;
+    known_attributes_["force_align"] = true;
+    known_attributes_["bit_flags"] = true;
+    known_attributes_["original_order"] = true;
+    known_attributes_["nested_flatbuffer"] = true;
+    known_attributes_["csharp_partial"] = true;
+    known_attributes_["streaming"] = true;
+    known_attributes_["idempotent"] = true;
+    known_attributes_["cpp_type"] = true;
+    known_attributes_["cpp_ptr_type"] = true;
+    known_attributes_["cpp_ptr_type_get"] = true;
+    known_attributes_["cpp_str_type"] = true;
+    known_attributes_["cpp_str_flex_ctor"] = true;
+    known_attributes_["native_inline"] = true;
+    known_attributes_["native_custom_alloc"] = true;
+    known_attributes_["native_type"] = true;
+    known_attributes_["native_type_pack_name"] = true;
+    known_attributes_["native_default"] = true;
+    known_attributes_["flexbuffer"] = true;
+    known_attributes_["private"] = true;
+  }
+
+  ~Parser() {
+    for (auto it = namespaces_.begin(); it != namespaces_.end(); ++it) {
+      delete *it;
+    }
+  }
+
+  // Parse the string containing either schema or JSON data, which will
+  // populate the SymbolTable's or the FlatBufferBuilder above.
+  // include_paths is used to resolve any include statements, and typically
+  // should at least include the project path (where you loaded source_ from).
+  // include_paths must be nullptr terminated if specified.
+  // If include_paths is nullptr, it will attempt to load from the current
+  // directory.
+  // If the source was loaded from a file and isn't an include file,
+  // supply its name in source_filename.
+  // All paths specified in this call must be in posix format, if you accept
+  // paths from user input, please call PosixPath on them first.
+  bool Parse(const char *_source, const char **include_paths = nullptr,
+             const char *source_filename = nullptr);
+
+  bool ParseJson(const char *json, const char *json_filename = nullptr);
+
+  // Set the root type. May override the one set in the schema.
+  bool SetRootType(const char *name);
+
+  // Mark all definitions as already having code generated.
+  void MarkGenerated();
+
+  // Get the files recursively included by the given file. The returned
+  // container will have at least the given file.
+  std::set<std::string> GetIncludedFilesRecursive(
+      const std::string &file_name) const;
+
+  // Fills builder_ with a binary version of the schema parsed.
+  // See reflection/reflection.fbs
+  void Serialize();
+
+  // Deserialize a schema buffer
+  bool Deserialize(const uint8_t *buf, const size_t size);
+
+  // Fills internal structure as if the schema passed had been loaded by parsing
+  // with Parse except that included filenames will not be populated.
+  bool Deserialize(const reflection::Schema *schema);
+
+  Type *DeserializeType(const reflection::Type *type);
+
+  // Checks that the schema represented by this parser is a safe evolution
+  // of the schema provided. Returns non-empty error on any problems.
+  std::string ConformTo(const Parser &base);
+
+  // Similar to Parse(), but now only accepts JSON to be parsed into a
+  // FlexBuffer.
+  bool ParseFlexBuffer(const char *source, const char *source_filename,
+                       flexbuffers::Builder *builder);
+
+  StructDef *LookupStruct(const std::string &id) const;
+  StructDef *LookupStructThruParentNamespaces(const std::string &id) const;
+
+  std::string UnqualifiedName(const std::string &fullQualifiedName);
+
+  FLATBUFFERS_CHECKED_ERROR Error(const std::string &msg);
+
+  // @brief Verify that any of 'opts.lang_to_generate' supports Optional scalars
+  // in a schema.
+  // @param opts Options used to parce a schema and generate code.
+  static bool SupportsOptionalScalars(const flatbuffers::IDLOptions &opts);
+
+ private:
+  class ParseDepthGuard;
+
+  void Message(const std::string &msg);
+  void Warning(const std::string &msg);
+  FLATBUFFERS_CHECKED_ERROR ParseHexNum(int nibbles, uint64_t *val);
+  FLATBUFFERS_CHECKED_ERROR Next();
+  FLATBUFFERS_CHECKED_ERROR SkipByteOrderMark();
+  bool Is(int t) const;
+  bool IsIdent(const char *id) const;
+  FLATBUFFERS_CHECKED_ERROR Expect(int t);
+  std::string TokenToStringId(int t) const;
+  EnumDef *LookupEnum(const std::string &id);
+  FLATBUFFERS_CHECKED_ERROR ParseNamespacing(std::string *id,
+                                             std::string *last);
+  FLATBUFFERS_CHECKED_ERROR ParseTypeIdent(Type &type);
+  FLATBUFFERS_CHECKED_ERROR ParseType(Type &type);
+  FLATBUFFERS_CHECKED_ERROR AddField(StructDef &struct_def,
+                                     const std::string &name, const Type &type,
+                                     FieldDef **dest);
+  FLATBUFFERS_CHECKED_ERROR ParseField(StructDef &struct_def);
+  FLATBUFFERS_CHECKED_ERROR ParseString(Value &val, bool use_string_pooling);
+  FLATBUFFERS_CHECKED_ERROR ParseComma();
+  FLATBUFFERS_CHECKED_ERROR ParseAnyValue(Value &val, FieldDef *field,
+                                          size_t parent_fieldn,
+                                          const StructDef *parent_struct_def,
+                                          uoffset_t count,
+                                          bool inside_vector = false);
+  template<typename F>
+  FLATBUFFERS_CHECKED_ERROR ParseTableDelimiters(size_t &fieldn,
+                                                 const StructDef *struct_def,
+                                                 F body);
+  FLATBUFFERS_CHECKED_ERROR ParseTable(const StructDef &struct_def,
+                                       std::string *value, uoffset_t *ovalue);
+  void SerializeStruct(const StructDef &struct_def, const Value &val);
+  void SerializeStruct(FlatBufferBuilder &builder, const StructDef &struct_def,
+                       const Value &val);
+  template<typename F>
+  FLATBUFFERS_CHECKED_ERROR ParseVectorDelimiters(uoffset_t &count, F body);
+  FLATBUFFERS_CHECKED_ERROR ParseVector(const Type &type, uoffset_t *ovalue,
+                                        FieldDef *field, size_t fieldn);
+  FLATBUFFERS_CHECKED_ERROR ParseArray(Value &array);
+  FLATBUFFERS_CHECKED_ERROR ParseNestedFlatbuffer(
+      Value &val, FieldDef *field, size_t fieldn,
+      const StructDef *parent_struct_def);
+  FLATBUFFERS_CHECKED_ERROR ParseMetaData(SymbolTable<Value> *attributes);
+  FLATBUFFERS_CHECKED_ERROR TryTypedValue(const std::string *name, int dtoken,
+                                          bool check, Value &e, BaseType req,
+                                          bool *destmatch);
+  FLATBUFFERS_CHECKED_ERROR ParseHash(Value &e, FieldDef *field);
+  FLATBUFFERS_CHECKED_ERROR TokenError();
+  FLATBUFFERS_CHECKED_ERROR ParseSingleValue(const std::string *name, Value &e,
+                                             bool check_now);
+  FLATBUFFERS_CHECKED_ERROR ParseFunction(const std::string *name, Value &e);
+  FLATBUFFERS_CHECKED_ERROR ParseEnumFromString(const Type &type,
+                                                std::string *result);
+  StructDef *LookupCreateStruct(const std::string &name,
+                                bool create_if_new = true,
+                                bool definition = false);
+  FLATBUFFERS_CHECKED_ERROR ParseEnum(bool is_union, EnumDef **dest,
+                                      const char *filename);
+  FLATBUFFERS_CHECKED_ERROR ParseNamespace();
+  FLATBUFFERS_CHECKED_ERROR StartStruct(const std::string &name,
+                                        StructDef **dest);
+  FLATBUFFERS_CHECKED_ERROR StartEnum(const std::string &name, bool is_union,
+                                      EnumDef **dest);
+  FLATBUFFERS_CHECKED_ERROR ParseDecl(const char *filename);
+  FLATBUFFERS_CHECKED_ERROR ParseService(const char *filename);
+  FLATBUFFERS_CHECKED_ERROR ParseProtoFields(StructDef *struct_def,
+                                             bool isextend, bool inside_oneof);
+  FLATBUFFERS_CHECKED_ERROR ParseProtoOption();
+  FLATBUFFERS_CHECKED_ERROR ParseProtoKey();
+  FLATBUFFERS_CHECKED_ERROR ParseProtoDecl();
+  FLATBUFFERS_CHECKED_ERROR ParseProtoCurliesOrIdent();
+  FLATBUFFERS_CHECKED_ERROR ParseTypeFromProtoType(Type *type);
+  FLATBUFFERS_CHECKED_ERROR SkipAnyJsonValue();
+  FLATBUFFERS_CHECKED_ERROR ParseFlexBufferNumericConstant(
+      flexbuffers::Builder *builder);
+  FLATBUFFERS_CHECKED_ERROR ParseFlexBufferValue(flexbuffers::Builder *builder);
+  FLATBUFFERS_CHECKED_ERROR StartParseFile(const char *source,
+                                           const char *source_filename);
+  FLATBUFFERS_CHECKED_ERROR ParseRoot(const char *_source,
+                                      const char **include_paths,
+                                      const char *source_filename);
+  FLATBUFFERS_CHECKED_ERROR DoParse(const char *_source,
+                                    const char **include_paths,
+                                    const char *source_filename,
+                                    const char *include_filename);
+  FLATBUFFERS_CHECKED_ERROR DoParseJson();
+  FLATBUFFERS_CHECKED_ERROR CheckClash(std::vector<FieldDef *> &fields,
+                                       StructDef *struct_def,
+                                       const char *suffix, BaseType baseType);
+  FLATBUFFERS_CHECKED_ERROR ParseAlignAttribute(
+      const std::string &align_constant, size_t min_align, size_t *align);
+
+  bool SupportsAdvancedUnionFeatures() const;
+  bool SupportsAdvancedArrayFeatures() const;
+  bool SupportsOptionalScalars() const;
+  bool SupportsDefaultVectorsAndStrings() const;
+  Namespace *UniqueNamespace(Namespace *ns);
+
+  FLATBUFFERS_CHECKED_ERROR RecurseError();
+  template<typename F> CheckedError Recurse(F f);
+
+  const std::string &GetPooledString(const std::string &s) const;
+
+ public:
+  SymbolTable<Type> types_;
+  SymbolTable<StructDef> structs_;
+  SymbolTable<EnumDef> enums_;
+  SymbolTable<ServiceDef> services_;
+  std::vector<Namespace *> namespaces_;
+  Namespace *current_namespace_;
+  Namespace *empty_namespace_;
+  std::string error_;  // User readable error_ if Parse() == false
+
+  FlatBufferBuilder builder_;  // any data contained in the file
+  flexbuffers::Builder flex_builder_;
+  flexbuffers::Reference flex_root_;
+  StructDef *root_struct_def_;
+  std::string file_identifier_;
+  std::string file_extension_;
+
+  std::map<uint64_t, std::string> included_files_;
+  std::map<std::string, std::set<std::string>> files_included_per_file_;
+  std::vector<std::string> native_included_files_;
+
+  std::map<std::string, bool> known_attributes_;
+
+  IDLOptions opts;
+  bool uses_flexbuffers_;
+  bool has_warning_;
+
+  uint64_t advanced_features_;
+
+ private:
+  const char *source_;
+
+  std::string file_being_parsed_;
+
+  std::vector<std::pair<Value, FieldDef *>> field_stack_;
+
+  // TODO(cneo): Refactor parser to use string_cache more often to save
+  // on memory usage.
+  mutable std::set<std::string> string_cache_;
+
+  int anonymous_counter_;
+  int parse_depth_counter_;  // stack-overflow guard
+};
+
+// Utility functions for multiple generators:
+
+// Generate text (JSON) from a given FlatBuffer, and a given Parser
+// object that has been populated with the corresponding schema.
+// If ident_step is 0, no indentation will be generated. Additionally,
+// if it is less than 0, no linefeeds will be generated either.
+// See idl_gen_text.cpp.
+// strict_json adds "quotes" around field names if true.
+// If the flatbuffer cannot be encoded in JSON (e.g., it contains non-UTF-8
+// byte arrays in String values), returns false.
+extern bool GenerateTextFromTable(const Parser &parser, const void *table,
+                                  const std::string &tablename,
+                                  std::string *text);
+extern bool GenerateText(const Parser &parser, const void *flatbuffer,
+                         std::string *text);
+extern bool GenerateTextFile(const Parser &parser, const std::string &path,
+                             const std::string &file_name);
+
+// Generate Json schema to string
+// See idl_gen_json_schema.cpp.
+extern bool GenerateJsonSchema(const Parser &parser, std::string *json);
+
+// Generate binary files from a given FlatBuffer, and a given Parser
+// object that has been populated with the corresponding schema.
+// See code_generators.cpp.
+extern bool GenerateBinary(const Parser &parser, const std::string &path,
+                           const std::string &file_name);
+
+// Generate a C++ header from the definitions in the Parser object.
+// See idl_gen_cpp.
+extern bool GenerateCPP(const Parser &parser, const std::string &path,
+                        const std::string &file_name);
+
+// Generate C# files from the definitions in the Parser object.
+// See idl_gen_csharp.cpp.
+extern bool GenerateCSharp(const Parser &parser, const std::string &path,
+                           const std::string &file_name);
+
+extern bool GenerateDart(const Parser &parser, const std::string &path,
+                         const std::string &file_name);
+
+// Generate Java files from the definitions in the Parser object.
+// See idl_gen_java.cpp.
+extern bool GenerateJava(const Parser &parser, const std::string &path,
+                         const std::string &file_name);
+
+// Generate JavaScript or TypeScript code from the definitions in the Parser
+// object. See idl_gen_js.
+extern bool GenerateTS(const Parser &parser, const std::string &path,
+                       const std::string &file_name);
+
+// Generate Go files from the definitions in the Parser object.
+// See idl_gen_go.cpp.
+extern bool GenerateGo(const Parser &parser, const std::string &path,
+                       const std::string &file_name);
+
+// Generate Php code from the definitions in the Parser object.
+// See idl_gen_php.
+extern bool GeneratePhp(const Parser &parser, const std::string &path,
+                        const std::string &file_name);
+
+// Generate Python files from the definitions in the Parser object.
+// See idl_gen_python.cpp.
+extern bool GeneratePython(const Parser &parser, const std::string &path,
+                           const std::string &file_name);
+
+// Generate Lobster files from the definitions in the Parser object.
+// See idl_gen_lobster.cpp.
+extern bool GenerateLobster(const Parser &parser, const std::string &path,
+                            const std::string &file_name);
+
+// Generate Lua files from the definitions in the Parser object.
+// See idl_gen_lua.cpp.
+extern bool GenerateLua(const Parser &parser, const std::string &path,
+                        const std::string &file_name);
+
+// Generate Rust files from the definitions in the Parser object.
+// See idl_gen_rust.cpp.
+extern bool GenerateRust(const Parser &parser, const std::string &path,
+                         const std::string &file_name);
+
+// Generate Json schema file
+// See idl_gen_json_schema.cpp.
+extern bool GenerateJsonSchema(const Parser &parser, const std::string &path,
+                               const std::string &file_name);
+
+extern bool GenerateKotlin(const Parser &parser, const std::string &path,
+                           const std::string &file_name);
+
+// Generate Swift classes.
+// See idl_gen_swift.cpp
+extern bool GenerateSwift(const Parser &parser, const std::string &path,
+                          const std::string &file_name);
+
+// Generate a schema file from the internal representation, useful after
+// parsing a .proto schema.
+extern std::string GenerateFBS(const Parser &parser,
+                               const std::string &file_name);
+extern bool GenerateFBS(const Parser &parser, const std::string &path,
+                        const std::string &file_name);
+
+// Generate a make rule for the generated TypeScript code.
+// See idl_gen_ts.cpp.
+extern std::string TSMakeRule(const Parser &parser, const std::string &path,
+                              const std::string &file_name);
+
+// Generate a make rule for the generated C++ header.
+// See idl_gen_cpp.cpp.
+extern std::string CPPMakeRule(const Parser &parser, const std::string &path,
+                               const std::string &file_name);
+
+// Generate a make rule for the generated Dart code
+// see idl_gen_dart.cpp
+extern std::string DartMakeRule(const Parser &parser, const std::string &path,
+                                const std::string &file_name);
+
+// Generate a make rule for the generated Rust code.
+// See idl_gen_rust.cpp.
+extern std::string RustMakeRule(const Parser &parser, const std::string &path,
+                                const std::string &file_name);
+
+// Generate a make rule for generated Java or C# files.
+// See code_generators.cpp.
+extern std::string CSharpMakeRule(const Parser &parser, const std::string &path,
+                                  const std::string &file_name);
+extern std::string JavaMakeRule(const Parser &parser, const std::string &path,
+                                const std::string &file_name);
+
+// Generate a make rule for the generated text (JSON) files.
+// See idl_gen_text.cpp.
+extern std::string TextMakeRule(const Parser &parser, const std::string &path,
+                                const std::string &file_names);
+
+// Generate a make rule for the generated binary files.
+// See code_generators.cpp.
+extern std::string BinaryMakeRule(const Parser &parser, const std::string &path,
+                                  const std::string &file_name);
+
+// Generate GRPC Cpp interfaces.
+// See idl_gen_grpc.cpp.
+bool GenerateCppGRPC(const Parser &parser, const std::string &path,
+                     const std::string &file_name);
+
+// Generate GRPC Go interfaces.
+// See idl_gen_grpc.cpp.
+bool GenerateGoGRPC(const Parser &parser, const std::string &path,
+                    const std::string &file_name);
+
+// Generate GRPC Java classes.
+// See idl_gen_grpc.cpp
+bool GenerateJavaGRPC(const Parser &parser, const std::string &path,
+                      const std::string &file_name);
+
+// Generate GRPC Python interfaces.
+// See idl_gen_grpc.cpp.
+bool GeneratePythonGRPC(const Parser &parser, const std::string &path,
+                        const std::string &file_name);
+
+// Generate GRPC Swift interfaces.
+// See idl_gen_grpc.cpp.
+extern bool GenerateSwiftGRPC(const Parser &parser, const std::string &path,
+                              const std::string &file_name);
+
+extern bool GenerateTSGRPC(const Parser &parser, const std::string &path,
+                           const std::string &file_name);
+
+extern bool GenerateRustModuleRootFile(const Parser &parser,
+                                       const std::string &path);
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_IDL_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/minireflect.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/minireflect.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/minireflect.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/minireflect.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,421 @@
+/*
+ * Copyright 2017 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_MINIREFLECT_H_
+#define FLATBUFFERS_MINIREFLECT_H_
+
+#include "flatbuffers/flatbuffers.h"
+#include "flatbuffers/util.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Utilities that can be used with the "mini reflection" tables present
+// in generated code with --reflect-types (only types) or --reflect-names
+// (also names).
+// This allows basic reflection functionality such as pretty-printing
+// that does not require the use of the schema parser or loading of binary
+// schema files at runtime (reflection.h).
+
+// For any of the functions below that take `const TypeTable *`, you pass
+// `FooTypeTable()` if the type of the root is `Foo`.
+
+// First, a generic iterator that can be used by multiple algorithms.
+
+struct IterationVisitor {
+  // These mark the scope of a table or struct.
+  virtual void StartSequence() {}
+  virtual void EndSequence() {}
+  // Called for each field regardless of whether it is present or not.
+  // If not present, val == nullptr. set_idx is the index of all set fields.
+  virtual void Field(size_t /*field_idx*/, size_t /*set_idx*/,
+                     ElementaryType /*type*/, bool /*is_vector*/,
+                     const TypeTable * /*type_table*/, const char * /*name*/,
+                     const uint8_t * /*val*/) {}
+  // Called for a value that is actually present, after a field, or as part
+  // of a vector.
+  virtual void UType(uint8_t, const char *) {}
+  virtual void Bool(bool) {}
+  virtual void Char(int8_t, const char *) {}
+  virtual void UChar(uint8_t, const char *) {}
+  virtual void Short(int16_t, const char *) {}
+  virtual void UShort(uint16_t, const char *) {}
+  virtual void Int(int32_t, const char *) {}
+  virtual void UInt(uint32_t, const char *) {}
+  virtual void Long(int64_t) {}
+  virtual void ULong(uint64_t) {}
+  virtual void Float(float) {}
+  virtual void Double(double) {}
+  virtual void String(const String *) {}
+  virtual void Unknown(const uint8_t *) {}  // From a future version.
+  // These mark the scope of a vector.
+  virtual void StartVector() {}
+  virtual void EndVector() {}
+  virtual void Element(size_t /*i*/, ElementaryType /*type*/,
+                       const TypeTable * /*type_table*/,
+                       const uint8_t * /*val*/) {}
+  virtual ~IterationVisitor() {}
+};
+
+inline size_t InlineSize(ElementaryType type, const TypeTable *type_table) {
+  switch (type) {
+    case ET_UTYPE:
+    case ET_BOOL:
+    case ET_CHAR:
+    case ET_UCHAR: return 1;
+    case ET_SHORT:
+    case ET_USHORT: return 2;
+    case ET_INT:
+    case ET_UINT:
+    case ET_FLOAT:
+    case ET_STRING: return 4;
+    case ET_LONG:
+    case ET_ULONG:
+    case ET_DOUBLE: return 8;
+    case ET_SEQUENCE:
+      switch (type_table->st) {
+        case ST_TABLE:
+        case ST_UNION: return 4;
+        case ST_STRUCT:
+          return static_cast<size_t>(type_table->values[type_table->num_elems]);
+        default: FLATBUFFERS_ASSERT(false); return 1;
+      }
+    default: FLATBUFFERS_ASSERT(false); return 1;
+  }
+}
+
+inline int64_t LookupEnum(int64_t enum_val, const int64_t *values,
+                          size_t num_values) {
+  if (!values) return enum_val;
+  for (size_t i = 0; i < num_values; i++) {
+    if (enum_val == values[i]) return static_cast<int64_t>(i);
+  }
+  return -1;  // Unknown enum value.
+}
+
+template<typename T> const char *EnumName(T tval, const TypeTable *type_table) {
+  if (!type_table || !type_table->names) return nullptr;
+  auto i = LookupEnum(static_cast<int64_t>(tval), type_table->values,
+                      type_table->num_elems);
+  if (i >= 0 && i < static_cast<int64_t>(type_table->num_elems)) {
+    return type_table->names[i];
+  }
+  return nullptr;
+}
+
+void IterateObject(const uint8_t *obj, const TypeTable *type_table,
+                   IterationVisitor *visitor);
+
+inline void IterateValue(ElementaryType type, const uint8_t *val,
+                         const TypeTable *type_table, const uint8_t *prev_val,
+                         soffset_t vector_index, IterationVisitor *visitor) {
+  switch (type) {
+    case ET_UTYPE: {
+      auto tval = ReadScalar<uint8_t>(val);
+      visitor->UType(tval, EnumName(tval, type_table));
+      break;
+    }
+    case ET_BOOL: {
+      visitor->Bool(ReadScalar<uint8_t>(val) != 0);
+      break;
+    }
+    case ET_CHAR: {
+      auto tval = ReadScalar<int8_t>(val);
+      visitor->Char(tval, EnumName(tval, type_table));
+      break;
+    }
+    case ET_UCHAR: {
+      auto tval = ReadScalar<uint8_t>(val);
+      visitor->UChar(tval, EnumName(tval, type_table));
+      break;
+    }
+    case ET_SHORT: {
+      auto tval = ReadScalar<int16_t>(val);
+      visitor->Short(tval, EnumName(tval, type_table));
+      break;
+    }
+    case ET_USHORT: {
+      auto tval = ReadScalar<uint16_t>(val);
+      visitor->UShort(tval, EnumName(tval, type_table));
+      break;
+    }
+    case ET_INT: {
+      auto tval = ReadScalar<int32_t>(val);
+      visitor->Int(tval, EnumName(tval, type_table));
+      break;
+    }
+    case ET_UINT: {
+      auto tval = ReadScalar<uint32_t>(val);
+      visitor->UInt(tval, EnumName(tval, type_table));
+      break;
+    }
+    case ET_LONG: {
+      visitor->Long(ReadScalar<int64_t>(val));
+      break;
+    }
+    case ET_ULONG: {
+      visitor->ULong(ReadScalar<uint64_t>(val));
+      break;
+    }
+    case ET_FLOAT: {
+      visitor->Float(ReadScalar<float>(val));
+      break;
+    }
+    case ET_DOUBLE: {
+      visitor->Double(ReadScalar<double>(val));
+      break;
+    }
+    case ET_STRING: {
+      val += ReadScalar<uoffset_t>(val);
+      visitor->String(reinterpret_cast<const String *>(val));
+      break;
+    }
+    case ET_SEQUENCE: {
+      switch (type_table->st) {
+        case ST_TABLE:
+          val += ReadScalar<uoffset_t>(val);
+          IterateObject(val, type_table, visitor);
+          break;
+        case ST_STRUCT: IterateObject(val, type_table, visitor); break;
+        case ST_UNION: {
+          val += ReadScalar<uoffset_t>(val);
+          FLATBUFFERS_ASSERT(prev_val);
+          auto union_type = *prev_val;  // Always a uint8_t.
+          if (vector_index >= 0) {
+            auto type_vec = reinterpret_cast<const Vector<uint8_t> *>(prev_val);
+            union_type = type_vec->Get(static_cast<uoffset_t>(vector_index));
+          }
+          auto type_code_idx =
+              LookupEnum(union_type, type_table->values, type_table->num_elems);
+          if (type_code_idx >= 0 &&
+              type_code_idx < static_cast<int32_t>(type_table->num_elems)) {
+            auto type_code = type_table->type_codes[type_code_idx];
+            switch (type_code.base_type) {
+              case ET_SEQUENCE: {
+                auto ref = type_table->type_refs[type_code.sequence_ref]();
+                IterateObject(val, ref, visitor);
+                break;
+              }
+              case ET_STRING:
+                visitor->String(reinterpret_cast<const String *>(val));
+                break;
+              default: visitor->Unknown(val);
+            }
+          } else {
+            visitor->Unknown(val);
+          }
+          break;
+        }
+        case ST_ENUM: FLATBUFFERS_ASSERT(false); break;
+      }
+      break;
+    }
+    default: {
+      visitor->Unknown(val);
+      break;
+    }
+  }
+}
+
+inline void IterateObject(const uint8_t *obj, const TypeTable *type_table,
+                          IterationVisitor *visitor) {
+  visitor->StartSequence();
+  const uint8_t *prev_val = nullptr;
+  size_t set_idx = 0;
+  size_t array_idx = 0;
+  for (size_t i = 0; i < type_table->num_elems; i++) {
+    auto type_code = type_table->type_codes[i];
+    auto type = static_cast<ElementaryType>(type_code.base_type);
+    auto is_repeating = type_code.is_repeating != 0;
+    auto ref_idx = type_code.sequence_ref;
+    const TypeTable *ref = nullptr;
+    if (ref_idx >= 0) { ref = type_table->type_refs[ref_idx](); }
+    auto name = type_table->names ? type_table->names[i] : nullptr;
+    const uint8_t *val = nullptr;
+    if (type_table->st == ST_TABLE) {
+      val = reinterpret_cast<const Table *>(obj)->GetAddressOf(
+          FieldIndexToOffset(static_cast<voffset_t>(i)));
+    } else {
+      val = obj + type_table->values[i];
+    }
+    visitor->Field(i, set_idx, type, is_repeating, ref, name, val);
+    if (val) {
+      set_idx++;
+      if (is_repeating) {
+        auto elem_ptr = val;
+        size_t size = 0;
+        if (type_table->st == ST_TABLE) {
+          // variable length vector
+          val += ReadScalar<uoffset_t>(val);
+          auto vec = reinterpret_cast<const Vector<uint8_t> *>(val);
+          elem_ptr = vec->Data();
+          size = vec->size();
+        } else {
+          // otherwise fixed size array
+          size = type_table->array_sizes[array_idx];
+          ++array_idx;
+        }
+        visitor->StartVector();
+        for (size_t j = 0; j < size; j++) {
+          visitor->Element(j, type, ref, elem_ptr);
+          IterateValue(type, elem_ptr, ref, prev_val, static_cast<soffset_t>(j),
+                       visitor);
+          elem_ptr += InlineSize(type, ref);
+        }
+        visitor->EndVector();
+      } else {
+        IterateValue(type, val, ref, prev_val, -1, visitor);
+      }
+    }
+    prev_val = val;
+  }
+  visitor->EndSequence();
+}
+
+inline void IterateFlatBuffer(const uint8_t *buffer,
+                              const TypeTable *type_table,
+                              IterationVisitor *callback) {
+  IterateObject(GetRoot<uint8_t>(buffer), type_table, callback);
+}
+
+// Outputting a Flatbuffer to a string. Tries to conform as close to JSON /
+// the output generated by idl_gen_text.cpp.
+
+struct ToStringVisitor : public IterationVisitor {
+  std::string s;
+  std::string d;
+  bool q;
+  std::string in;
+  size_t indent_level;
+  bool vector_delimited;
+  ToStringVisitor(std::string delimiter, bool quotes, std::string indent,
+                  bool vdelimited = true)
+      : d(delimiter),
+        q(quotes),
+        in(indent),
+        indent_level(0),
+        vector_delimited(vdelimited) {}
+  ToStringVisitor(std::string delimiter)
+      : d(delimiter),
+        q(false),
+        in(""),
+        indent_level(0),
+        vector_delimited(true) {}
+
+  void append_indent() {
+    for (size_t i = 0; i < indent_level; i++) { s += in; }
+  }
+
+  void StartSequence() {
+    s += "{";
+    s += d;
+    indent_level++;
+  }
+  void EndSequence() {
+    s += d;
+    indent_level--;
+    append_indent();
+    s += "}";
+  }
+  void Field(size_t /*field_idx*/, size_t set_idx, ElementaryType /*type*/,
+             bool /*is_vector*/, const TypeTable * /*type_table*/,
+             const char *name, const uint8_t *val) {
+    if (!val) return;
+    if (set_idx) {
+      s += ",";
+      s += d;
+    }
+    append_indent();
+    if (name) {
+      if (q) s += "\"";
+      s += name;
+      if (q) s += "\"";
+      s += ": ";
+    }
+  }
+  template<typename T> void Named(T x, const char *name) {
+    if (name) {
+      if (q) s += "\"";
+      s += name;
+      if (q) s += "\"";
+    } else {
+      s += NumToString(x);
+    }
+  }
+  void UType(uint8_t x, const char *name) { Named(x, name); }
+  void Bool(bool x) { s += x ? "true" : "false"; }
+  void Char(int8_t x, const char *name) { Named(x, name); }
+  void UChar(uint8_t x, const char *name) { Named(x, name); }
+  void Short(int16_t x, const char *name) { Named(x, name); }
+  void UShort(uint16_t x, const char *name) { Named(x, name); }
+  void Int(int32_t x, const char *name) { Named(x, name); }
+  void UInt(uint32_t x, const char *name) { Named(x, name); }
+  void Long(int64_t x) { s += NumToString(x); }
+  void ULong(uint64_t x) { s += NumToString(x); }
+  void Float(float x) { s += NumToString(x); }
+  void Double(double x) { s += NumToString(x); }
+  void String(const struct String *str) {
+    EscapeString(str->c_str(), str->size(), &s, true, false);
+  }
+  void Unknown(const uint8_t *) { s += "(?)"; }
+  void StartVector() {
+    s += "[";
+    if (vector_delimited) {
+      s += d;
+      indent_level++;
+      append_indent();
+    } else {
+      s += " ";
+    }
+  }
+  void EndVector() {
+    if (vector_delimited) {
+      s += d;
+      indent_level--;
+      append_indent();
+    } else {
+      s += " ";
+    }
+    s += "]";
+  }
+  void Element(size_t i, ElementaryType /*type*/,
+               const TypeTable * /*type_table*/, const uint8_t * /*val*/) {
+    if (i) {
+      s += ",";
+      if (vector_delimited) {
+        s += d;
+        append_indent();
+      } else {
+        s += " ";
+      }
+    }
+  }
+};
+
+inline std::string FlatBufferToString(const uint8_t *buffer,
+                                      const TypeTable *type_table,
+                                      bool multi_line = false,
+                                      bool vector_delimited = true) {
+  ToStringVisitor tostring_visitor(multi_line ? "\n" : " ", false, "",
+                                   vector_delimited);
+  IterateFlatBuffer(buffer, type_table, &tostring_visitor);
+  return tostring_visitor.s;
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_MINIREFLECT_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/pch/flatc_pch.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/pch/flatc_pch.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/pch/flatc_pch.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/pch/flatc_pch.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,39 @@
+/*
+ * Copyright 2017 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_FLATC_PCH_H_
+#define FLATBUFFERS_FLATC_PCH_H_
+
+// stl
+#include <cmath>
+#include <sstream>
+#include <cassert>
+#include <unordered_set>
+#include <unordered_map>
+#include <iostream>
+#include <functional>
+#include <set>
+#include <iterator>
+#include <tuple>
+
+// flatbuffers
+#include "flatbuffers/pch/pch.h"
+#include "flatbuffers/code_generators.h"
+#include "flatbuffers/flatbuffers.h"
+#include "flatbuffers/flexbuffers.h"
+#include "flatbuffers/idl.h"
+
+#endif // FLATBUFFERS_FLATC_PCH_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/pch/pch.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/pch/pch.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/pch/pch.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/pch/pch.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,38 @@
+/*
+ * Copyright 2017 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_PCH_H_
+#define FLATBUFFERS_PCH_H_
+
+// stl
+#include <cstdint>
+#include <cstring>
+#include <algorithm>
+#include <list>
+#include <string>
+#include <utility>
+#include <iomanip>
+#include <map>
+#include <memory>
+#include <limits>
+#include <stack>
+#include <vector>
+#include <type_traits>
+
+// flatbuffers
+#include "flatbuffers/util.h"
+
+#endif // FLATBUFFERS_PCH_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/reflection.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/reflection.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/reflection.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/reflection.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,524 @@
+/*
+ * Copyright 2015 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_REFLECTION_H_
+#define FLATBUFFERS_REFLECTION_H_
+
+// This is somewhat of a circular dependency because flatc (and thus this
+// file) is needed to generate this header in the first place.
+// Should normally not be a problem since it can be generated by the
+// previous version of flatc whenever this code needs to change.
+// See scripts/generate_code.py for generation.
+#include "flatbuffers/reflection_generated.h"
+
+// Helper functionality for reflection.
+
+namespace mapserver {
+namespace flatbuffers {
+
+// ------------------------- GETTERS -------------------------
+
+inline bool IsScalar(reflection::BaseType t) {
+  return t >= reflection::UType && t <= reflection::Double;
+}
+inline bool IsInteger(reflection::BaseType t) {
+  return t >= reflection::UType && t <= reflection::ULong;
+}
+inline bool IsFloat(reflection::BaseType t) {
+  return t == reflection::Float || t == reflection::Double;
+}
+inline bool IsLong(reflection::BaseType t) {
+  return t == reflection::Long || t == reflection::ULong;
+}
+
+// Size of a basic type, don't use with structs.
+inline size_t GetTypeSize(reflection::BaseType base_type) {
+  // This needs to correspond to the BaseType enum.
+  static size_t sizes[] = {
+    0,  // None
+    1,  // UType
+    1,  // Bool
+    1,  // Byte
+    1,  // UByte
+    2,  // Short
+    2,  // UShort
+    4,  // Int
+    4,  // UInt
+    8,  // Long
+    8,  // ULong
+    4,  // Float
+    8,  // Double
+    4,  // String
+    4,  // Vector
+    4,  // Obj
+    4,  // Union
+    0,  // Array. Only used in structs. 0 was chosen to prevent out-of-bounds
+        // errors.
+
+    0  // MaxBaseType. This must be kept the last entry in this array.
+  };
+  static_assert(sizeof(sizes) / sizeof(size_t) == reflection::MaxBaseType + 1,
+                "Size of sizes[] array does not match the count of BaseType "
+                "enum values.");
+  return sizes[base_type];
+}
+
+// Same as above, but now correctly returns the size of a struct if
+// the field (or vector element) is a struct.
+inline size_t GetTypeSizeInline(reflection::BaseType base_type, int type_index,
+                                const reflection::Schema &schema) {
+  if (base_type == reflection::Obj &&
+      schema.objects()->Get(type_index)->is_struct()) {
+    return schema.objects()->Get(type_index)->bytesize();
+  } else {
+    return GetTypeSize(base_type);
+  }
+}
+
+// Get the root, regardless of what type it is.
+inline Table *GetAnyRoot(uint8_t *const flatbuf) {
+  return GetMutableRoot<Table>(flatbuf);
+}
+
+inline const Table *GetAnyRoot(const uint8_t *const flatbuf) {
+  return GetRoot<Table>(flatbuf);
+}
+
+inline Table *GetAnySizePrefixedRoot(uint8_t *const flatbuf) {
+  return GetMutableSizePrefixedRoot<Table>(flatbuf);
+}
+
+inline const Table *GetAnySizePrefixedRoot(const uint8_t *const flatbuf) {
+  return GetSizePrefixedRoot<Table>(flatbuf);
+}
+
+// Get a field's default, if you know it's an integer, and its exact type.
+template<typename T> T GetFieldDefaultI(const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
+  return static_cast<T>(field.default_integer());
+}
+
+// Get a field's default, if you know it's floating point and its exact type.
+template<typename T> T GetFieldDefaultF(const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
+  return static_cast<T>(field.default_real());
+}
+
+// Get a field, if you know it's an integer, and its exact type.
+template<typename T>
+T GetFieldI(const Table &table, const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
+  return table.GetField<T>(field.offset(),
+                           static_cast<T>(field.default_integer()));
+}
+
+// Get a field, if you know it's floating point and its exact type.
+template<typename T>
+T GetFieldF(const Table &table, const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(field.type()->base_type()));
+  return table.GetField<T>(field.offset(),
+                           static_cast<T>(field.default_real()));
+}
+
+// Get a field, if you know it's a string.
+inline const String *GetFieldS(const Table &table,
+                               const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::String);
+  return table.GetPointer<const String *>(field.offset());
+}
+
+// Get a field, if you know it's a vector.
+template<typename T>
+Vector<T> *GetFieldV(const Table &table, const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Vector &&
+                     sizeof(T) == GetTypeSize(field.type()->element()));
+  return table.GetPointer<Vector<T> *>(field.offset());
+}
+
+// Get a field, if you know it's a vector, generically.
+// To actually access elements, use the return value together with
+// field.type()->element() in any of GetAnyVectorElemI below etc.
+inline VectorOfAny *GetFieldAnyV(const Table &table,
+                                 const reflection::Field &field) {
+  return table.GetPointer<VectorOfAny *>(field.offset());
+}
+
+// Get a field, if you know it's a table.
+inline Table *GetFieldT(const Table &table, const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Obj ||
+                     field.type()->base_type() == reflection::Union);
+  return table.GetPointer<Table *>(field.offset());
+}
+
+// Get a field, if you know it's a struct.
+inline const Struct *GetFieldStruct(const Table &table,
+                                    const reflection::Field &field) {
+  // TODO: This does NOT check if the field is a table or struct, but we'd need
+  // access to the schema to check the is_struct flag.
+  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Obj);
+  return table.GetStruct<const Struct *>(field.offset());
+}
+
+// Get a structure's field, if you know it's a struct.
+inline const Struct *GetFieldStruct(const Struct &structure,
+                                    const reflection::Field &field) {
+  FLATBUFFERS_ASSERT(field.type()->base_type() == reflection::Obj);
+  return structure.GetStruct<const Struct *>(field.offset());
+}
+
+// Raw helper functions used below: get any value in memory as a 64bit int, a
+// double or a string.
+// All scalars get static_cast to an int64_t, strings use strtoull, every other
+// data type returns 0.
+int64_t GetAnyValueI(reflection::BaseType type, const uint8_t *data);
+// All scalars static cast to double, strings use strtod, every other data
+// type is 0.0.
+double GetAnyValueF(reflection::BaseType type, const uint8_t *data);
+// All scalars converted using stringstream, strings as-is, and all other
+// data types provide some level of debug-pretty-printing.
+std::string GetAnyValueS(reflection::BaseType type, const uint8_t *data,
+                         const reflection::Schema *schema, int type_index);
+
+// Get any table field as a 64bit int, regardless of what type it is.
+inline int64_t GetAnyFieldI(const Table &table,
+                            const reflection::Field &field) {
+  auto field_ptr = table.GetAddressOf(field.offset());
+  return field_ptr ? GetAnyValueI(field.type()->base_type(), field_ptr)
+                   : field.default_integer();
+}
+
+// Get any table field as a double, regardless of what type it is.
+inline double GetAnyFieldF(const Table &table, const reflection::Field &field) {
+  auto field_ptr = table.GetAddressOf(field.offset());
+  return field_ptr ? GetAnyValueF(field.type()->base_type(), field_ptr)
+                   : field.default_real();
+}
+
+// Get any table field as a string, regardless of what type it is.
+// You may pass nullptr for the schema if you don't care to have fields that
+// are of table type pretty-printed.
+inline std::string GetAnyFieldS(const Table &table,
+                                const reflection::Field &field,
+                                const reflection::Schema *schema) {
+  auto field_ptr = table.GetAddressOf(field.offset());
+  return field_ptr ? GetAnyValueS(field.type()->base_type(), field_ptr, schema,
+                                  field.type()->index())
+                   : "";
+}
+
+// Get any struct field as a 64bit int, regardless of what type it is.
+inline int64_t GetAnyFieldI(const Struct &st, const reflection::Field &field) {
+  return GetAnyValueI(field.type()->base_type(),
+                      st.GetAddressOf(field.offset()));
+}
+
+// Get any struct field as a double, regardless of what type it is.
+inline double GetAnyFieldF(const Struct &st, const reflection::Field &field) {
+  return GetAnyValueF(field.type()->base_type(),
+                      st.GetAddressOf(field.offset()));
+}
+
+// Get any struct field as a string, regardless of what type it is.
+inline std::string GetAnyFieldS(const Struct &st,
+                                const reflection::Field &field) {
+  return GetAnyValueS(field.type()->base_type(),
+                      st.GetAddressOf(field.offset()), nullptr, -1);
+}
+
+// Get any vector element as a 64bit int, regardless of what type it is.
+inline int64_t GetAnyVectorElemI(const VectorOfAny *vec,
+                                 reflection::BaseType elem_type, size_t i) {
+  return GetAnyValueI(elem_type, vec->Data() + GetTypeSize(elem_type) * i);
+}
+
+// Get any vector element as a double, regardless of what type it is.
+inline double GetAnyVectorElemF(const VectorOfAny *vec,
+                                reflection::BaseType elem_type, size_t i) {
+  return GetAnyValueF(elem_type, vec->Data() + GetTypeSize(elem_type) * i);
+}
+
+// Get any vector element as a string, regardless of what type it is.
+inline std::string GetAnyVectorElemS(const VectorOfAny *vec,
+                                     reflection::BaseType elem_type, size_t i) {
+  return GetAnyValueS(elem_type, vec->Data() + GetTypeSize(elem_type) * i,
+                      nullptr, -1);
+}
+
+// Get a vector element that's a table/string/vector from a generic vector.
+// Pass Table/String/VectorOfAny as template parameter.
+// Warning: does no typechecking.
+template<typename T>
+T *GetAnyVectorElemPointer(const VectorOfAny *vec, size_t i) {
+  auto elem_ptr = vec->Data() + sizeof(uoffset_t) * i;
+  return reinterpret_cast<T *>(elem_ptr + ReadScalar<uoffset_t>(elem_ptr));
+}
+
+// Get the inline-address of a vector element. Useful for Structs (pass Struct
+// as template arg), or being able to address a range of scalars in-line.
+// Get elem_size from GetTypeSizeInline().
+// Note: little-endian data on all platforms, use EndianScalar() instead of
+// raw pointer access with scalars).
+template<typename T>
+T *GetAnyVectorElemAddressOf(const VectorOfAny *vec, size_t i,
+                             size_t elem_size) {
+  return reinterpret_cast<T *>(vec->Data() + elem_size * i);
+}
+
+// Similarly, for elements of tables.
+template<typename T>
+T *GetAnyFieldAddressOf(const Table &table, const reflection::Field &field) {
+  return reinterpret_cast<T *>(table.GetAddressOf(field.offset()));
+}
+
+// Similarly, for elements of structs.
+template<typename T>
+T *GetAnyFieldAddressOf(const Struct &st, const reflection::Field &field) {
+  return reinterpret_cast<T *>(st.GetAddressOf(field.offset()));
+}
+
+// Loop over all the fields of the provided `object` and call `func` on each one
+// in increasing order by their field->id(). If `reverse` is true, `func` is
+// called in descending order
+void ForAllFields(const reflection::Object *object, bool reverse,
+                  std::function<void(const reflection::Field *)> func);
+
+// ------------------------- SETTERS -------------------------
+
+// Set any scalar field, if you know its exact type.
+template<typename T>
+bool SetField(Table *table, const reflection::Field &field, T val) {
+  reflection::BaseType type = field.type()->base_type();
+  if (!IsScalar(type)) { return false; }
+  FLATBUFFERS_ASSERT(sizeof(T) == GetTypeSize(type));
+  T def;
+  if (IsInteger(type)) {
+    def = GetFieldDefaultI<T>(field);
+  } else {
+    FLATBUFFERS_ASSERT(IsFloat(type));
+    def = GetFieldDefaultF<T>(field);
+  }
+  return table->SetField(field.offset(), val, def);
+}
+
+// Raw helper functions used below: set any value in memory as a 64bit int, a
+// double or a string.
+// These work for all scalar values, but do nothing for other data types.
+// To set a string, see SetString below.
+void SetAnyValueI(reflection::BaseType type, uint8_t *data, int64_t val);
+void SetAnyValueF(reflection::BaseType type, uint8_t *data, double val);
+void SetAnyValueS(reflection::BaseType type, uint8_t *data, const char *val);
+
+// Set any table field as a 64bit int, regardless of type what it is.
+inline bool SetAnyFieldI(Table *table, const reflection::Field &field,
+                         int64_t val) {
+  auto field_ptr = table->GetAddressOf(field.offset());
+  if (!field_ptr) return val == GetFieldDefaultI<int64_t>(field);
+  SetAnyValueI(field.type()->base_type(), field_ptr, val);
+  return true;
+}
+
+// Set any table field as a double, regardless of what type it is.
+inline bool SetAnyFieldF(Table *table, const reflection::Field &field,
+                         double val) {
+  auto field_ptr = table->GetAddressOf(field.offset());
+  if (!field_ptr) return val == GetFieldDefaultF<double>(field);
+  SetAnyValueF(field.type()->base_type(), field_ptr, val);
+  return true;
+}
+
+// Set any table field as a string, regardless of what type it is.
+inline bool SetAnyFieldS(Table *table, const reflection::Field &field,
+                         const char *val) {
+  auto field_ptr = table->GetAddressOf(field.offset());
+  if (!field_ptr) return false;
+  SetAnyValueS(field.type()->base_type(), field_ptr, val);
+  return true;
+}
+
+// Set any struct field as a 64bit int, regardless of type what it is.
+inline void SetAnyFieldI(Struct *st, const reflection::Field &field,
+                         int64_t val) {
+  SetAnyValueI(field.type()->base_type(), st->GetAddressOf(field.offset()),
+               val);
+}
+
+// Set any struct field as a double, regardless of type what it is.
+inline void SetAnyFieldF(Struct *st, const reflection::Field &field,
+                         double val) {
+  SetAnyValueF(field.type()->base_type(), st->GetAddressOf(field.offset()),
+               val);
+}
+
+// Set any struct field as a string, regardless of type what it is.
+inline void SetAnyFieldS(Struct *st, const reflection::Field &field,
+                         const char *val) {
+  SetAnyValueS(field.type()->base_type(), st->GetAddressOf(field.offset()),
+               val);
+}
+
+// Set any vector element as a 64bit int, regardless of type what it is.
+inline void SetAnyVectorElemI(VectorOfAny *vec, reflection::BaseType elem_type,
+                              size_t i, int64_t val) {
+  SetAnyValueI(elem_type, vec->Data() + GetTypeSize(elem_type) * i, val);
+}
+
+// Set any vector element as a double, regardless of type what it is.
+inline void SetAnyVectorElemF(VectorOfAny *vec, reflection::BaseType elem_type,
+                              size_t i, double val) {
+  SetAnyValueF(elem_type, vec->Data() + GetTypeSize(elem_type) * i, val);
+}
+
+// Set any vector element as a string, regardless of type what it is.
+inline void SetAnyVectorElemS(VectorOfAny *vec, reflection::BaseType elem_type,
+                              size_t i, const char *val) {
+  SetAnyValueS(elem_type, vec->Data() + GetTypeSize(elem_type) * i, val);
+}
+
+// ------------------------- RESIZING SETTERS -------------------------
+
+// "smart" pointer for use with resizing vectors: turns a pointer inside
+// a vector into a relative offset, such that it is not affected by resizes.
+template<typename T, typename U> class pointer_inside_vector {
+ public:
+  pointer_inside_vector(T *ptr, std::vector<U> &vec)
+      : offset_(reinterpret_cast<uint8_t *>(ptr) -
+                reinterpret_cast<uint8_t *>(vec.data())),
+        vec_(vec) {}
+
+  T *operator*() const {
+    return reinterpret_cast<T *>(reinterpret_cast<uint8_t *>(vec_.data()) +
+                                 offset_);
+  }
+  T *operator->() const { return operator*(); }
+
+ private:
+  size_t offset_;
+  std::vector<U> &vec_;
+};
+
+// Helper to create the above easily without specifying template args.
+template<typename T, typename U>
+pointer_inside_vector<T, U> piv(T *ptr, std::vector<U> &vec) {
+  return pointer_inside_vector<T, U>(ptr, vec);
+}
+
+inline const char *UnionTypeFieldSuffix() { return "_type"; }
+
+// Helper to figure out the actual table type a union refers to.
+inline const reflection::Object &GetUnionType(
+    const reflection::Schema &schema, const reflection::Object &parent,
+    const reflection::Field &unionfield, const Table &table) {
+  auto enumdef = schema.enums()->Get(unionfield.type()->index());
+  // TODO: this is clumsy and slow, but no other way to find it?
+  auto type_field = parent.fields()->LookupByKey(
+      (unionfield.name()->str() + UnionTypeFieldSuffix()).c_str());
+  FLATBUFFERS_ASSERT(type_field);
+  auto union_type = GetFieldI<uint8_t>(table, *type_field);
+  auto enumval = enumdef->values()->LookupByKey(union_type);
+  return *schema.objects()->Get(enumval->union_type()->index());
+}
+
+// Changes the contents of a string inside a FlatBuffer. FlatBuffer must
+// live inside a std::vector so we can resize the buffer if needed.
+// "str" must live inside "flatbuf" and may be invalidated after this call.
+// If your FlatBuffer's root table is not the schema's root table, you should
+// pass in your root_table type as well.
+void SetString(const reflection::Schema &schema, const std::string &val,
+               const String *str, std::vector<uint8_t> *flatbuf,
+               const reflection::Object *root_table = nullptr);
+
+// Resizes a flatbuffers::Vector inside a FlatBuffer. FlatBuffer must
+// live inside a std::vector so we can resize the buffer if needed.
+// "vec" must live inside "flatbuf" and may be invalidated after this call.
+// If your FlatBuffer's root table is not the schema's root table, you should
+// pass in your root_table type as well.
+uint8_t *ResizeAnyVector(const reflection::Schema &schema, uoffset_t newsize,
+                         const VectorOfAny *vec, uoffset_t num_elems,
+                         uoffset_t elem_size, std::vector<uint8_t> *flatbuf,
+                         const reflection::Object *root_table = nullptr);
+
+template<typename T>
+void ResizeVector(const reflection::Schema &schema, uoffset_t newsize, T val,
+                  const Vector<T> *vec, std::vector<uint8_t> *flatbuf,
+                  const reflection::Object *root_table = nullptr) {
+  auto delta_elem = static_cast<int>(newsize) - static_cast<int>(vec->size());
+  auto newelems = ResizeAnyVector(
+      schema, newsize, reinterpret_cast<const VectorOfAny *>(vec), vec->size(),
+      static_cast<uoffset_t>(sizeof(T)), flatbuf, root_table);
+  // Set new elements to "val".
+  for (int i = 0; i < delta_elem; i++) {
+    auto loc = newelems + i * sizeof(T);
+    auto is_scalar = flatbuffers::is_scalar<T>::value;
+    if (is_scalar) {
+      WriteScalar(loc, val);
+    } else {  // struct
+      *reinterpret_cast<T *>(loc) = val;
+    }
+  }
+}
+
+// Adds any new data (in the form of a new FlatBuffer) to an existing
+// FlatBuffer. This can be used when any of the above methods are not
+// sufficient, in particular for adding new tables and new fields.
+// This is potentially slightly less efficient than a FlatBuffer constructed
+// in one piece, since the new FlatBuffer doesn't share any vtables with the
+// existing one.
+// The return value can now be set using Vector::MutateOffset or SetFieldT
+// below.
+const uint8_t *AddFlatBuffer(std::vector<uint8_t> &flatbuf,
+                             const uint8_t *newbuf, size_t newlen);
+
+inline bool SetFieldT(Table *table, const reflection::Field &field,
+                      const uint8_t *val) {
+  FLATBUFFERS_ASSERT(sizeof(uoffset_t) ==
+                     GetTypeSize(field.type()->base_type()));
+  return table->SetPointer(field.offset(), val);
+}
+
+// ------------------------- COPYING -------------------------
+
+// Generic copying of tables from a FlatBuffer into a FlatBuffer builder.
+// Can be used to do any kind of merging/selecting you may want to do out
+// of existing buffers. Also useful to reconstruct a whole buffer if the
+// above resizing functionality has introduced garbage in a buffer you want
+// to remove.
+// Note: this does not deal with DAGs correctly. If the table passed forms a
+// DAG, the copy will be a tree instead (with duplicates). Strings can be
+// shared however, by passing true for use_string_pooling.
+
+Offset<const Table *> CopyTable(FlatBufferBuilder &fbb,
+                                const reflection::Schema &schema,
+                                const reflection::Object &objectdef,
+                                const Table &table,
+                                bool use_string_pooling = false);
+
+// Verifies the provided flatbuffer using reflection.
+// root should point to the root type for this flatbuffer.
+// buf should point to the start of flatbuffer data.
+// length specifies the size of the flatbuffer data.
+bool Verify(const reflection::Schema &schema, const reflection::Object &root,
+            const uint8_t *buf, size_t length, uoffset_t max_depth = 64,
+            uoffset_t max_tables = 1000000);
+
+bool VerifySizePrefixed(const reflection::Schema &schema,
+                        const reflection::Object &root, const uint8_t *buf,
+                        size_t length, uoffset_t max_depth = 64,
+                        uoffset_t max_tables = 1000000);
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_REFLECTION_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/reflection_generated.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/reflection_generated.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/reflection_generated.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/reflection_generated.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1456 @@
+// automatically generated by the FlatBuffers compiler, do not modify
+
+
+#ifndef FLATBUFFERS_GENERATED_REFLECTION_REFLECTION_H_
+#define FLATBUFFERS_GENERATED_REFLECTION_REFLECTION_H_
+
+#include "flatbuffers/flatbuffers.h"
+
+// Ensure the included flatbuffers.h is the same version as when this file was
+// generated, otherwise it may not be compatible.
+static_assert(FLATBUFFERS_VERSION_MAJOR == 2 &&
+              FLATBUFFERS_VERSION_MINOR == 0 &&
+              FLATBUFFERS_VERSION_REVISION == 6,
+             "Non-compatible flatbuffers version included");
+
+namespace reflection {
+
+struct Type;
+struct TypeBuilder;
+
+struct KeyValue;
+struct KeyValueBuilder;
+
+struct EnumVal;
+struct EnumValBuilder;
+
+struct Enum;
+struct EnumBuilder;
+
+struct Field;
+struct FieldBuilder;
+
+struct Object;
+struct ObjectBuilder;
+
+struct RPCCall;
+struct RPCCallBuilder;
+
+struct Service;
+struct ServiceBuilder;
+
+struct SchemaFile;
+struct SchemaFileBuilder;
+
+struct Schema;
+struct SchemaBuilder;
+
+enum BaseType {
+  None = 0,
+  UType = 1,
+  Bool = 2,
+  Byte = 3,
+  UByte = 4,
+  Short = 5,
+  UShort = 6,
+  Int = 7,
+  UInt = 8,
+  Long = 9,
+  ULong = 10,
+  Float = 11,
+  Double = 12,
+  String = 13,
+  Vector = 14,
+  Obj = 15,
+  Union = 16,
+  Array = 17,
+  MaxBaseType = 18
+};
+
+inline const BaseType (&EnumValuesBaseType())[19] {
+  static const BaseType values[] = {
+    None,
+    UType,
+    Bool,
+    Byte,
+    UByte,
+    Short,
+    UShort,
+    Int,
+    UInt,
+    Long,
+    ULong,
+    Float,
+    Double,
+    String,
+    Vector,
+    Obj,
+    Union,
+    Array,
+    MaxBaseType
+  };
+  return values;
+}
+
+inline const char * const *EnumNamesBaseType() {
+  static const char * const names[20] = {
+    "None",
+    "UType",
+    "Bool",
+    "Byte",
+    "UByte",
+    "Short",
+    "UShort",
+    "Int",
+    "UInt",
+    "Long",
+    "ULong",
+    "Float",
+    "Double",
+    "String",
+    "Vector",
+    "Obj",
+    "Union",
+    "Array",
+    "MaxBaseType",
+    nullptr
+  };
+  return names;
+}
+
+inline const char *EnumNameBaseType(BaseType e) {
+  if (flatbuffers::IsOutRange(e, None, MaxBaseType)) return "";
+  const size_t index = static_cast<size_t>(e);
+  return EnumNamesBaseType()[index];
+}
+
+/// New schema language features that are not supported by old code generators.
+enum AdvancedFeatures {
+  AdvancedArrayFeatures = 1ULL,
+  AdvancedUnionFeatures = 2ULL,
+  OptionalScalars = 4ULL,
+  DefaultVectorsAndStrings = 8ULL
+};
+
+inline const AdvancedFeatures (&EnumValuesAdvancedFeatures())[4] {
+  static const AdvancedFeatures values[] = {
+    AdvancedArrayFeatures,
+    AdvancedUnionFeatures,
+    OptionalScalars,
+    DefaultVectorsAndStrings
+  };
+  return values;
+}
+
+inline const char * const *EnumNamesAdvancedFeatures() {
+  static const char * const names[9] = {
+    "AdvancedArrayFeatures",
+    "AdvancedUnionFeatures",
+    "",
+    "OptionalScalars",
+    "",
+    "",
+    "",
+    "DefaultVectorsAndStrings",
+    nullptr
+  };
+  return names;
+}
+
+inline const char *EnumNameAdvancedFeatures(AdvancedFeatures e) {
+  if (flatbuffers::IsOutRange(e, AdvancedArrayFeatures, DefaultVectorsAndStrings)) return "";
+  const size_t index = static_cast<size_t>(e) - static_cast<size_t>(AdvancedArrayFeatures);
+  return EnumNamesAdvancedFeatures()[index];
+}
+
+struct Type FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef TypeBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_BASE_TYPE = 4,
+    VT_ELEMENT = 6,
+    VT_INDEX = 8,
+    VT_FIXED_LENGTH = 10,
+    VT_BASE_SIZE = 12,
+    VT_ELEMENT_SIZE = 14
+  };
+  reflection::BaseType base_type() const {
+    return static_cast<reflection::BaseType>(GetField<int8_t>(VT_BASE_TYPE, 0));
+  }
+  reflection::BaseType element() const {
+    return static_cast<reflection::BaseType>(GetField<int8_t>(VT_ELEMENT, 0));
+  }
+  int32_t index() const {
+    return GetField<int32_t>(VT_INDEX, -1);
+  }
+  uint16_t fixed_length() const {
+    return GetField<uint16_t>(VT_FIXED_LENGTH, 0);
+  }
+  /// The size (octets) of the `base_type` field.
+  uint32_t base_size() const {
+    return GetField<uint32_t>(VT_BASE_SIZE, 4);
+  }
+  /// The size (octets) of the `element` field, if present.
+  uint32_t element_size() const {
+    return GetField<uint32_t>(VT_ELEMENT_SIZE, 0);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyField<int8_t>(verifier, VT_BASE_TYPE, 1) &&
+           VerifyField<int8_t>(verifier, VT_ELEMENT, 1) &&
+           VerifyField<int32_t>(verifier, VT_INDEX, 4) &&
+           VerifyField<uint16_t>(verifier, VT_FIXED_LENGTH, 2) &&
+           VerifyField<uint32_t>(verifier, VT_BASE_SIZE, 4) &&
+           VerifyField<uint32_t>(verifier, VT_ELEMENT_SIZE, 4) &&
+           verifier.EndTable();
+  }
+};
+
+struct TypeBuilder {
+  typedef Type Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_base_type(reflection::BaseType base_type) {
+    fbb_.AddElement<int8_t>(Type::VT_BASE_TYPE, static_cast<int8_t>(base_type), 0);
+  }
+  void add_element(reflection::BaseType element) {
+    fbb_.AddElement<int8_t>(Type::VT_ELEMENT, static_cast<int8_t>(element), 0);
+  }
+  void add_index(int32_t index) {
+    fbb_.AddElement<int32_t>(Type::VT_INDEX, index, -1);
+  }
+  void add_fixed_length(uint16_t fixed_length) {
+    fbb_.AddElement<uint16_t>(Type::VT_FIXED_LENGTH, fixed_length, 0);
+  }
+  void add_base_size(uint32_t base_size) {
+    fbb_.AddElement<uint32_t>(Type::VT_BASE_SIZE, base_size, 4);
+  }
+  void add_element_size(uint32_t element_size) {
+    fbb_.AddElement<uint32_t>(Type::VT_ELEMENT_SIZE, element_size, 0);
+  }
+  explicit TypeBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Type> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Type>(end);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Type> CreateType(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    reflection::BaseType base_type = reflection::None,
+    reflection::BaseType element = reflection::None,
+    int32_t index = -1,
+    uint16_t fixed_length = 0,
+    uint32_t base_size = 4,
+    uint32_t element_size = 0) {
+  TypeBuilder builder_(_fbb);
+  builder_.add_element_size(element_size);
+  builder_.add_base_size(base_size);
+  builder_.add_index(index);
+  builder_.add_fixed_length(fixed_length);
+  builder_.add_element(element);
+  builder_.add_base_type(base_type);
+  return builder_.Finish();
+}
+
+struct KeyValue FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef KeyValueBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_KEY = 4,
+    VT_VALUE = 6
+  };
+  const flatbuffers::String *key() const {
+    return GetPointer<const flatbuffers::String *>(VT_KEY);
+  }
+  bool KeyCompareLessThan(const KeyValue *o) const {
+    return *key() < *o->key();
+  }
+  int KeyCompareWithValue(const char *_key) const {
+    return strcmp(key()->c_str(), _key);
+  }
+  const flatbuffers::String *value() const {
+    return GetPointer<const flatbuffers::String *>(VT_VALUE);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_KEY) &&
+           verifier.VerifyString(key()) &&
+           VerifyOffset(verifier, VT_VALUE) &&
+           verifier.VerifyString(value()) &&
+           verifier.EndTable();
+  }
+};
+
+struct KeyValueBuilder {
+  typedef KeyValue Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_key(flatbuffers::Offset<flatbuffers::String> key) {
+    fbb_.AddOffset(KeyValue::VT_KEY, key);
+  }
+  void add_value(flatbuffers::Offset<flatbuffers::String> value) {
+    fbb_.AddOffset(KeyValue::VT_VALUE, value);
+  }
+  explicit KeyValueBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<KeyValue> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<KeyValue>(end);
+    fbb_.Required(o, KeyValue::VT_KEY);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<KeyValue> CreateKeyValue(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> key = 0,
+    flatbuffers::Offset<flatbuffers::String> value = 0) {
+  KeyValueBuilder builder_(_fbb);
+  builder_.add_value(value);
+  builder_.add_key(key);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<KeyValue> CreateKeyValueDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *key = nullptr,
+    const char *value = nullptr) {
+  auto key__ = key ? _fbb.CreateString(key) : 0;
+  auto value__ = value ? _fbb.CreateString(value) : 0;
+  return reflection::CreateKeyValue(
+      _fbb,
+      key__,
+      value__);
+}
+
+struct EnumVal FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef EnumValBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_VALUE = 6,
+    VT_UNION_TYPE = 10,
+    VT_DOCUMENTATION = 12
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  int64_t value() const {
+    return GetField<int64_t>(VT_VALUE, 0);
+  }
+  bool KeyCompareLessThan(const EnumVal *o) const {
+    return value() < o->value();
+  }
+  int KeyCompareWithValue(int64_t _value) const {
+    return static_cast<int>(value() > _value) - static_cast<int>(value() < _value);
+  }
+  const reflection::Type *union_type() const {
+    return GetPointer<const reflection::Type *>(VT_UNION_TYPE);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyField<int64_t>(verifier, VT_VALUE, 8) &&
+           VerifyOffset(verifier, VT_UNION_TYPE) &&
+           verifier.VerifyTable(union_type()) &&
+           VerifyOffset(verifier, VT_DOCUMENTATION) &&
+           verifier.VerifyVector(documentation()) &&
+           verifier.VerifyVectorOfStrings(documentation()) &&
+           verifier.EndTable();
+  }
+};
+
+struct EnumValBuilder {
+  typedef EnumVal Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(EnumVal::VT_NAME, name);
+  }
+  void add_value(int64_t value) {
+    fbb_.AddElement<int64_t>(EnumVal::VT_VALUE, value, 0);
+  }
+  void add_union_type(flatbuffers::Offset<reflection::Type> union_type) {
+    fbb_.AddOffset(EnumVal::VT_UNION_TYPE, union_type);
+  }
+  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
+    fbb_.AddOffset(EnumVal::VT_DOCUMENTATION, documentation);
+  }
+  explicit EnumValBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<EnumVal> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<EnumVal>(end);
+    fbb_.Required(o, EnumVal::VT_NAME);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<EnumVal> CreateEnumVal(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    int64_t value = 0,
+    flatbuffers::Offset<reflection::Type> union_type = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0) {
+  EnumValBuilder builder_(_fbb);
+  builder_.add_value(value);
+  builder_.add_documentation(documentation);
+  builder_.add_union_type(union_type);
+  builder_.add_name(name);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<EnumVal> CreateEnumValDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    int64_t value = 0,
+    flatbuffers::Offset<reflection::Type> union_type = 0,
+    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
+  return reflection::CreateEnumVal(
+      _fbb,
+      name__,
+      value,
+      union_type,
+      documentation__);
+}
+
+struct Enum FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef EnumBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_VALUES = 6,
+    VT_IS_UNION = 8,
+    VT_UNDERLYING_TYPE = 10,
+    VT_ATTRIBUTES = 12,
+    VT_DOCUMENTATION = 14,
+    VT_DECLARATION_FILE = 16
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  bool KeyCompareLessThan(const Enum *o) const {
+    return *name() < *o->name();
+  }
+  int KeyCompareWithValue(const char *_name) const {
+    return strcmp(name()->c_str(), _name);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>> *values() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>> *>(VT_VALUES);
+  }
+  bool is_union() const {
+    return GetField<uint8_t>(VT_IS_UNION, 0) != 0;
+  }
+  const reflection::Type *underlying_type() const {
+    return GetPointer<const reflection::Type *>(VT_UNDERLYING_TYPE);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
+  }
+  /// File that this Enum is declared in.
+  const flatbuffers::String *declaration_file() const {
+    return GetPointer<const flatbuffers::String *>(VT_DECLARATION_FILE);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyOffsetRequired(verifier, VT_VALUES) &&
+           verifier.VerifyVector(values()) &&
+           verifier.VerifyVectorOfTables(values()) &&
+           VerifyField<uint8_t>(verifier, VT_IS_UNION, 1) &&
+           VerifyOffsetRequired(verifier, VT_UNDERLYING_TYPE) &&
+           verifier.VerifyTable(underlying_type()) &&
+           VerifyOffset(verifier, VT_ATTRIBUTES) &&
+           verifier.VerifyVector(attributes()) &&
+           verifier.VerifyVectorOfTables(attributes()) &&
+           VerifyOffset(verifier, VT_DOCUMENTATION) &&
+           verifier.VerifyVector(documentation()) &&
+           verifier.VerifyVectorOfStrings(documentation()) &&
+           VerifyOffset(verifier, VT_DECLARATION_FILE) &&
+           verifier.VerifyString(declaration_file()) &&
+           verifier.EndTable();
+  }
+};
+
+struct EnumBuilder {
+  typedef Enum Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(Enum::VT_NAME, name);
+  }
+  void add_values(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>>> values) {
+    fbb_.AddOffset(Enum::VT_VALUES, values);
+  }
+  void add_is_union(bool is_union) {
+    fbb_.AddElement<uint8_t>(Enum::VT_IS_UNION, static_cast<uint8_t>(is_union), 0);
+  }
+  void add_underlying_type(flatbuffers::Offset<reflection::Type> underlying_type) {
+    fbb_.AddOffset(Enum::VT_UNDERLYING_TYPE, underlying_type);
+  }
+  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
+    fbb_.AddOffset(Enum::VT_ATTRIBUTES, attributes);
+  }
+  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
+    fbb_.AddOffset(Enum::VT_DOCUMENTATION, documentation);
+  }
+  void add_declaration_file(flatbuffers::Offset<flatbuffers::String> declaration_file) {
+    fbb_.AddOffset(Enum::VT_DECLARATION_FILE, declaration_file);
+  }
+  explicit EnumBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Enum> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Enum>(end);
+    fbb_.Required(o, Enum::VT_NAME);
+    fbb_.Required(o, Enum::VT_VALUES);
+    fbb_.Required(o, Enum::VT_UNDERLYING_TYPE);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Enum> CreateEnum(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::EnumVal>>> values = 0,
+    bool is_union = false,
+    flatbuffers::Offset<reflection::Type> underlying_type = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
+    flatbuffers::Offset<flatbuffers::String> declaration_file = 0) {
+  EnumBuilder builder_(_fbb);
+  builder_.add_declaration_file(declaration_file);
+  builder_.add_documentation(documentation);
+  builder_.add_attributes(attributes);
+  builder_.add_underlying_type(underlying_type);
+  builder_.add_values(values);
+  builder_.add_name(name);
+  builder_.add_is_union(is_union);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Enum> CreateEnumDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    std::vector<flatbuffers::Offset<reflection::EnumVal>> *values = nullptr,
+    bool is_union = false,
+    flatbuffers::Offset<reflection::Type> underlying_type = 0,
+    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
+    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
+    const char *declaration_file = nullptr) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto values__ = values ? _fbb.CreateVectorOfSortedTables<reflection::EnumVal>(values) : 0;
+  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
+  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
+  auto declaration_file__ = declaration_file ? _fbb.CreateString(declaration_file) : 0;
+  return reflection::CreateEnum(
+      _fbb,
+      name__,
+      values__,
+      is_union,
+      underlying_type,
+      attributes__,
+      documentation__,
+      declaration_file__);
+}
+
+struct Field FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef FieldBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_TYPE = 6,
+    VT_ID = 8,
+    VT_OFFSET = 10,
+    VT_DEFAULT_INTEGER = 12,
+    VT_DEFAULT_REAL = 14,
+    VT_DEPRECATED = 16,
+    VT_REQUIRED = 18,
+    VT_KEY = 20,
+    VT_ATTRIBUTES = 22,
+    VT_DOCUMENTATION = 24,
+    VT_OPTIONAL = 26,
+    VT_PADDING = 28
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  bool KeyCompareLessThan(const Field *o) const {
+    return *name() < *o->name();
+  }
+  int KeyCompareWithValue(const char *_name) const {
+    return strcmp(name()->c_str(), _name);
+  }
+  const reflection::Type *type() const {
+    return GetPointer<const reflection::Type *>(VT_TYPE);
+  }
+  uint16_t id() const {
+    return GetField<uint16_t>(VT_ID, 0);
+  }
+  uint16_t offset() const {
+    return GetField<uint16_t>(VT_OFFSET, 0);
+  }
+  int64_t default_integer() const {
+    return GetField<int64_t>(VT_DEFAULT_INTEGER, 0);
+  }
+  double default_real() const {
+    return GetField<double>(VT_DEFAULT_REAL, 0.0);
+  }
+  bool deprecated() const {
+    return GetField<uint8_t>(VT_DEPRECATED, 0) != 0;
+  }
+  bool required() const {
+    return GetField<uint8_t>(VT_REQUIRED, 0) != 0;
+  }
+  bool key() const {
+    return GetField<uint8_t>(VT_KEY, 0) != 0;
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
+  }
+  bool optional() const {
+    return GetField<uint8_t>(VT_OPTIONAL, 0) != 0;
+  }
+  /// Number of padding octets to always add after this field. Structs only.
+  uint16_t padding() const {
+    return GetField<uint16_t>(VT_PADDING, 0);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyOffsetRequired(verifier, VT_TYPE) &&
+           verifier.VerifyTable(type()) &&
+           VerifyField<uint16_t>(verifier, VT_ID, 2) &&
+           VerifyField<uint16_t>(verifier, VT_OFFSET, 2) &&
+           VerifyField<int64_t>(verifier, VT_DEFAULT_INTEGER, 8) &&
+           VerifyField<double>(verifier, VT_DEFAULT_REAL, 8) &&
+           VerifyField<uint8_t>(verifier, VT_DEPRECATED, 1) &&
+           VerifyField<uint8_t>(verifier, VT_REQUIRED, 1) &&
+           VerifyField<uint8_t>(verifier, VT_KEY, 1) &&
+           VerifyOffset(verifier, VT_ATTRIBUTES) &&
+           verifier.VerifyVector(attributes()) &&
+           verifier.VerifyVectorOfTables(attributes()) &&
+           VerifyOffset(verifier, VT_DOCUMENTATION) &&
+           verifier.VerifyVector(documentation()) &&
+           verifier.VerifyVectorOfStrings(documentation()) &&
+           VerifyField<uint8_t>(verifier, VT_OPTIONAL, 1) &&
+           VerifyField<uint16_t>(verifier, VT_PADDING, 2) &&
+           verifier.EndTable();
+  }
+};
+
+struct FieldBuilder {
+  typedef Field Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(Field::VT_NAME, name);
+  }
+  void add_type(flatbuffers::Offset<reflection::Type> type) {
+    fbb_.AddOffset(Field::VT_TYPE, type);
+  }
+  void add_id(uint16_t id) {
+    fbb_.AddElement<uint16_t>(Field::VT_ID, id, 0);
+  }
+  void add_offset(uint16_t offset) {
+    fbb_.AddElement<uint16_t>(Field::VT_OFFSET, offset, 0);
+  }
+  void add_default_integer(int64_t default_integer) {
+    fbb_.AddElement<int64_t>(Field::VT_DEFAULT_INTEGER, default_integer, 0);
+  }
+  void add_default_real(double default_real) {
+    fbb_.AddElement<double>(Field::VT_DEFAULT_REAL, default_real, 0.0);
+  }
+  void add_deprecated(bool deprecated) {
+    fbb_.AddElement<uint8_t>(Field::VT_DEPRECATED, static_cast<uint8_t>(deprecated), 0);
+  }
+  void add_required(bool required) {
+    fbb_.AddElement<uint8_t>(Field::VT_REQUIRED, static_cast<uint8_t>(required), 0);
+  }
+  void add_key(bool key) {
+    fbb_.AddElement<uint8_t>(Field::VT_KEY, static_cast<uint8_t>(key), 0);
+  }
+  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
+    fbb_.AddOffset(Field::VT_ATTRIBUTES, attributes);
+  }
+  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
+    fbb_.AddOffset(Field::VT_DOCUMENTATION, documentation);
+  }
+  void add_optional(bool optional) {
+    fbb_.AddElement<uint8_t>(Field::VT_OPTIONAL, static_cast<uint8_t>(optional), 0);
+  }
+  void add_padding(uint16_t padding) {
+    fbb_.AddElement<uint16_t>(Field::VT_PADDING, padding, 0);
+  }
+  explicit FieldBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Field> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Field>(end);
+    fbb_.Required(o, Field::VT_NAME);
+    fbb_.Required(o, Field::VT_TYPE);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Field> CreateField(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    flatbuffers::Offset<reflection::Type> type = 0,
+    uint16_t id = 0,
+    uint16_t offset = 0,
+    int64_t default_integer = 0,
+    double default_real = 0.0,
+    bool deprecated = false,
+    bool required = false,
+    bool key = false,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
+    bool optional = false,
+    uint16_t padding = 0) {
+  FieldBuilder builder_(_fbb);
+  builder_.add_default_real(default_real);
+  builder_.add_default_integer(default_integer);
+  builder_.add_documentation(documentation);
+  builder_.add_attributes(attributes);
+  builder_.add_type(type);
+  builder_.add_name(name);
+  builder_.add_padding(padding);
+  builder_.add_offset(offset);
+  builder_.add_id(id);
+  builder_.add_optional(optional);
+  builder_.add_key(key);
+  builder_.add_required(required);
+  builder_.add_deprecated(deprecated);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Field> CreateFieldDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    flatbuffers::Offset<reflection::Type> type = 0,
+    uint16_t id = 0,
+    uint16_t offset = 0,
+    int64_t default_integer = 0,
+    double default_real = 0.0,
+    bool deprecated = false,
+    bool required = false,
+    bool key = false,
+    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
+    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
+    bool optional = false,
+    uint16_t padding = 0) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
+  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
+  return reflection::CreateField(
+      _fbb,
+      name__,
+      type,
+      id,
+      offset,
+      default_integer,
+      default_real,
+      deprecated,
+      required,
+      key,
+      attributes__,
+      documentation__,
+      optional,
+      padding);
+}
+
+struct Object FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef ObjectBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_FIELDS = 6,
+    VT_IS_STRUCT = 8,
+    VT_MINALIGN = 10,
+    VT_BYTESIZE = 12,
+    VT_ATTRIBUTES = 14,
+    VT_DOCUMENTATION = 16,
+    VT_DECLARATION_FILE = 18
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  bool KeyCompareLessThan(const Object *o) const {
+    return *name() < *o->name();
+  }
+  int KeyCompareWithValue(const char *_name) const {
+    return strcmp(name()->c_str(), _name);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::Field>> *fields() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Field>> *>(VT_FIELDS);
+  }
+  bool is_struct() const {
+    return GetField<uint8_t>(VT_IS_STRUCT, 0) != 0;
+  }
+  int32_t minalign() const {
+    return GetField<int32_t>(VT_MINALIGN, 0);
+  }
+  int32_t bytesize() const {
+    return GetField<int32_t>(VT_BYTESIZE, 0);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
+  }
+  /// File that this Object is declared in.
+  const flatbuffers::String *declaration_file() const {
+    return GetPointer<const flatbuffers::String *>(VT_DECLARATION_FILE);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyOffsetRequired(verifier, VT_FIELDS) &&
+           verifier.VerifyVector(fields()) &&
+           verifier.VerifyVectorOfTables(fields()) &&
+           VerifyField<uint8_t>(verifier, VT_IS_STRUCT, 1) &&
+           VerifyField<int32_t>(verifier, VT_MINALIGN, 4) &&
+           VerifyField<int32_t>(verifier, VT_BYTESIZE, 4) &&
+           VerifyOffset(verifier, VT_ATTRIBUTES) &&
+           verifier.VerifyVector(attributes()) &&
+           verifier.VerifyVectorOfTables(attributes()) &&
+           VerifyOffset(verifier, VT_DOCUMENTATION) &&
+           verifier.VerifyVector(documentation()) &&
+           verifier.VerifyVectorOfStrings(documentation()) &&
+           VerifyOffset(verifier, VT_DECLARATION_FILE) &&
+           verifier.VerifyString(declaration_file()) &&
+           verifier.EndTable();
+  }
+};
+
+struct ObjectBuilder {
+  typedef Object Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(Object::VT_NAME, name);
+  }
+  void add_fields(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Field>>> fields) {
+    fbb_.AddOffset(Object::VT_FIELDS, fields);
+  }
+  void add_is_struct(bool is_struct) {
+    fbb_.AddElement<uint8_t>(Object::VT_IS_STRUCT, static_cast<uint8_t>(is_struct), 0);
+  }
+  void add_minalign(int32_t minalign) {
+    fbb_.AddElement<int32_t>(Object::VT_MINALIGN, minalign, 0);
+  }
+  void add_bytesize(int32_t bytesize) {
+    fbb_.AddElement<int32_t>(Object::VT_BYTESIZE, bytesize, 0);
+  }
+  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
+    fbb_.AddOffset(Object::VT_ATTRIBUTES, attributes);
+  }
+  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
+    fbb_.AddOffset(Object::VT_DOCUMENTATION, documentation);
+  }
+  void add_declaration_file(flatbuffers::Offset<flatbuffers::String> declaration_file) {
+    fbb_.AddOffset(Object::VT_DECLARATION_FILE, declaration_file);
+  }
+  explicit ObjectBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Object> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Object>(end);
+    fbb_.Required(o, Object::VT_NAME);
+    fbb_.Required(o, Object::VT_FIELDS);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Object> CreateObject(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Field>>> fields = 0,
+    bool is_struct = false,
+    int32_t minalign = 0,
+    int32_t bytesize = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
+    flatbuffers::Offset<flatbuffers::String> declaration_file = 0) {
+  ObjectBuilder builder_(_fbb);
+  builder_.add_declaration_file(declaration_file);
+  builder_.add_documentation(documentation);
+  builder_.add_attributes(attributes);
+  builder_.add_bytesize(bytesize);
+  builder_.add_minalign(minalign);
+  builder_.add_fields(fields);
+  builder_.add_name(name);
+  builder_.add_is_struct(is_struct);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Object> CreateObjectDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    std::vector<flatbuffers::Offset<reflection::Field>> *fields = nullptr,
+    bool is_struct = false,
+    int32_t minalign = 0,
+    int32_t bytesize = 0,
+    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
+    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
+    const char *declaration_file = nullptr) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto fields__ = fields ? _fbb.CreateVectorOfSortedTables<reflection::Field>(fields) : 0;
+  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
+  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
+  auto declaration_file__ = declaration_file ? _fbb.CreateString(declaration_file) : 0;
+  return reflection::CreateObject(
+      _fbb,
+      name__,
+      fields__,
+      is_struct,
+      minalign,
+      bytesize,
+      attributes__,
+      documentation__,
+      declaration_file__);
+}
+
+struct RPCCall FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef RPCCallBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_REQUEST = 6,
+    VT_RESPONSE = 8,
+    VT_ATTRIBUTES = 10,
+    VT_DOCUMENTATION = 12
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  bool KeyCompareLessThan(const RPCCall *o) const {
+    return *name() < *o->name();
+  }
+  int KeyCompareWithValue(const char *_name) const {
+    return strcmp(name()->c_str(), _name);
+  }
+  const reflection::Object *request() const {
+    return GetPointer<const reflection::Object *>(VT_REQUEST);
+  }
+  const reflection::Object *response() const {
+    return GetPointer<const reflection::Object *>(VT_RESPONSE);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyOffsetRequired(verifier, VT_REQUEST) &&
+           verifier.VerifyTable(request()) &&
+           VerifyOffsetRequired(verifier, VT_RESPONSE) &&
+           verifier.VerifyTable(response()) &&
+           VerifyOffset(verifier, VT_ATTRIBUTES) &&
+           verifier.VerifyVector(attributes()) &&
+           verifier.VerifyVectorOfTables(attributes()) &&
+           VerifyOffset(verifier, VT_DOCUMENTATION) &&
+           verifier.VerifyVector(documentation()) &&
+           verifier.VerifyVectorOfStrings(documentation()) &&
+           verifier.EndTable();
+  }
+};
+
+struct RPCCallBuilder {
+  typedef RPCCall Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(RPCCall::VT_NAME, name);
+  }
+  void add_request(flatbuffers::Offset<reflection::Object> request) {
+    fbb_.AddOffset(RPCCall::VT_REQUEST, request);
+  }
+  void add_response(flatbuffers::Offset<reflection::Object> response) {
+    fbb_.AddOffset(RPCCall::VT_RESPONSE, response);
+  }
+  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
+    fbb_.AddOffset(RPCCall::VT_ATTRIBUTES, attributes);
+  }
+  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
+    fbb_.AddOffset(RPCCall::VT_DOCUMENTATION, documentation);
+  }
+  explicit RPCCallBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<RPCCall> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<RPCCall>(end);
+    fbb_.Required(o, RPCCall::VT_NAME);
+    fbb_.Required(o, RPCCall::VT_REQUEST);
+    fbb_.Required(o, RPCCall::VT_RESPONSE);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<RPCCall> CreateRPCCall(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    flatbuffers::Offset<reflection::Object> request = 0,
+    flatbuffers::Offset<reflection::Object> response = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0) {
+  RPCCallBuilder builder_(_fbb);
+  builder_.add_documentation(documentation);
+  builder_.add_attributes(attributes);
+  builder_.add_response(response);
+  builder_.add_request(request);
+  builder_.add_name(name);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<RPCCall> CreateRPCCallDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    flatbuffers::Offset<reflection::Object> request = 0,
+    flatbuffers::Offset<reflection::Object> response = 0,
+    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
+    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
+  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
+  return reflection::CreateRPCCall(
+      _fbb,
+      name__,
+      request,
+      response,
+      attributes__,
+      documentation__);
+}
+
+struct Service FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef ServiceBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_NAME = 4,
+    VT_CALLS = 6,
+    VT_ATTRIBUTES = 8,
+    VT_DOCUMENTATION = 10,
+    VT_DECLARATION_FILE = 12
+  };
+  const flatbuffers::String *name() const {
+    return GetPointer<const flatbuffers::String *>(VT_NAME);
+  }
+  bool KeyCompareLessThan(const Service *o) const {
+    return *name() < *o->name();
+  }
+  int KeyCompareWithValue(const char *_name) const {
+    return strcmp(name()->c_str(), _name);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>> *calls() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>> *>(VT_CALLS);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *attributes() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>> *>(VT_ATTRIBUTES);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *documentation() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_DOCUMENTATION);
+  }
+  /// File that this Service is declared in.
+  const flatbuffers::String *declaration_file() const {
+    return GetPointer<const flatbuffers::String *>(VT_DECLARATION_FILE);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_NAME) &&
+           verifier.VerifyString(name()) &&
+           VerifyOffset(verifier, VT_CALLS) &&
+           verifier.VerifyVector(calls()) &&
+           verifier.VerifyVectorOfTables(calls()) &&
+           VerifyOffset(verifier, VT_ATTRIBUTES) &&
+           verifier.VerifyVector(attributes()) &&
+           verifier.VerifyVectorOfTables(attributes()) &&
+           VerifyOffset(verifier, VT_DOCUMENTATION) &&
+           verifier.VerifyVector(documentation()) &&
+           verifier.VerifyVectorOfStrings(documentation()) &&
+           VerifyOffset(verifier, VT_DECLARATION_FILE) &&
+           verifier.VerifyString(declaration_file()) &&
+           verifier.EndTable();
+  }
+};
+
+struct ServiceBuilder {
+  typedef Service Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_name(flatbuffers::Offset<flatbuffers::String> name) {
+    fbb_.AddOffset(Service::VT_NAME, name);
+  }
+  void add_calls(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>>> calls) {
+    fbb_.AddOffset(Service::VT_CALLS, calls);
+  }
+  void add_attributes(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes) {
+    fbb_.AddOffset(Service::VT_ATTRIBUTES, attributes);
+  }
+  void add_documentation(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation) {
+    fbb_.AddOffset(Service::VT_DOCUMENTATION, documentation);
+  }
+  void add_declaration_file(flatbuffers::Offset<flatbuffers::String> declaration_file) {
+    fbb_.AddOffset(Service::VT_DECLARATION_FILE, declaration_file);
+  }
+  explicit ServiceBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Service> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Service>(end);
+    fbb_.Required(o, Service::VT_NAME);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Service> CreateService(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> name = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::RPCCall>>> calls = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::KeyValue>>> attributes = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> documentation = 0,
+    flatbuffers::Offset<flatbuffers::String> declaration_file = 0) {
+  ServiceBuilder builder_(_fbb);
+  builder_.add_declaration_file(declaration_file);
+  builder_.add_documentation(documentation);
+  builder_.add_attributes(attributes);
+  builder_.add_calls(calls);
+  builder_.add_name(name);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Service> CreateServiceDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *name = nullptr,
+    std::vector<flatbuffers::Offset<reflection::RPCCall>> *calls = nullptr,
+    std::vector<flatbuffers::Offset<reflection::KeyValue>> *attributes = nullptr,
+    const std::vector<flatbuffers::Offset<flatbuffers::String>> *documentation = nullptr,
+    const char *declaration_file = nullptr) {
+  auto name__ = name ? _fbb.CreateString(name) : 0;
+  auto calls__ = calls ? _fbb.CreateVectorOfSortedTables<reflection::RPCCall>(calls) : 0;
+  auto attributes__ = attributes ? _fbb.CreateVectorOfSortedTables<reflection::KeyValue>(attributes) : 0;
+  auto documentation__ = documentation ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*documentation) : 0;
+  auto declaration_file__ = declaration_file ? _fbb.CreateString(declaration_file) : 0;
+  return reflection::CreateService(
+      _fbb,
+      name__,
+      calls__,
+      attributes__,
+      documentation__,
+      declaration_file__);
+}
+
+/// File specific information.
+/// Symbols declared within a file may be recovered by iterating over all
+/// symbols and examining the `declaration_file` field.
+struct SchemaFile FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef SchemaFileBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_FILENAME = 4,
+    VT_INCLUDED_FILENAMES = 6
+  };
+  /// Filename, relative to project root.
+  const flatbuffers::String *filename() const {
+    return GetPointer<const flatbuffers::String *>(VT_FILENAME);
+  }
+  bool KeyCompareLessThan(const SchemaFile *o) const {
+    return *filename() < *o->filename();
+  }
+  int KeyCompareWithValue(const char *_filename) const {
+    return strcmp(filename()->c_str(), _filename);
+  }
+  /// Names of included files, relative to project root.
+  const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *included_filenames() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_INCLUDED_FILENAMES);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_FILENAME) &&
+           verifier.VerifyString(filename()) &&
+           VerifyOffset(verifier, VT_INCLUDED_FILENAMES) &&
+           verifier.VerifyVector(included_filenames()) &&
+           verifier.VerifyVectorOfStrings(included_filenames()) &&
+           verifier.EndTable();
+  }
+};
+
+struct SchemaFileBuilder {
+  typedef SchemaFile Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_filename(flatbuffers::Offset<flatbuffers::String> filename) {
+    fbb_.AddOffset(SchemaFile::VT_FILENAME, filename);
+  }
+  void add_included_filenames(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> included_filenames) {
+    fbb_.AddOffset(SchemaFile::VT_INCLUDED_FILENAMES, included_filenames);
+  }
+  explicit SchemaFileBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<SchemaFile> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<SchemaFile>(end);
+    fbb_.Required(o, SchemaFile::VT_FILENAME);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<SchemaFile> CreateSchemaFile(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::String> filename = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> included_filenames = 0) {
+  SchemaFileBuilder builder_(_fbb);
+  builder_.add_included_filenames(included_filenames);
+  builder_.add_filename(filename);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<SchemaFile> CreateSchemaFileDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    const char *filename = nullptr,
+    const std::vector<flatbuffers::Offset<flatbuffers::String>> *included_filenames = nullptr) {
+  auto filename__ = filename ? _fbb.CreateString(filename) : 0;
+  auto included_filenames__ = included_filenames ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*included_filenames) : 0;
+  return reflection::CreateSchemaFile(
+      _fbb,
+      filename__,
+      included_filenames__);
+}
+
+struct Schema FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
+  typedef SchemaBuilder Builder;
+  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
+    VT_OBJECTS = 4,
+    VT_ENUMS = 6,
+    VT_FILE_IDENT = 8,
+    VT_FILE_EXT = 10,
+    VT_ROOT_TABLE = 12,
+    VT_SERVICES = 14,
+    VT_ADVANCED_FEATURES = 16,
+    VT_FBS_FILES = 18
+  };
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::Object>> *objects() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Object>> *>(VT_OBJECTS);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>> *enums() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>> *>(VT_ENUMS);
+  }
+  const flatbuffers::String *file_ident() const {
+    return GetPointer<const flatbuffers::String *>(VT_FILE_IDENT);
+  }
+  const flatbuffers::String *file_ext() const {
+    return GetPointer<const flatbuffers::String *>(VT_FILE_EXT);
+  }
+  const reflection::Object *root_table() const {
+    return GetPointer<const reflection::Object *>(VT_ROOT_TABLE);
+  }
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::Service>> *services() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::Service>> *>(VT_SERVICES);
+  }
+  reflection::AdvancedFeatures advanced_features() const {
+    return static_cast<reflection::AdvancedFeatures>(GetField<uint64_t>(VT_ADVANCED_FEATURES, 0));
+  }
+  /// All the files used in this compilation. Files are relative to where
+  /// flatc was invoked.
+  const flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>> *fbs_files() const {
+    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>> *>(VT_FBS_FILES);
+  }
+  bool Verify(flatbuffers::Verifier &verifier) const {
+    return VerifyTableStart(verifier) &&
+           VerifyOffsetRequired(verifier, VT_OBJECTS) &&
+           verifier.VerifyVector(objects()) &&
+           verifier.VerifyVectorOfTables(objects()) &&
+           VerifyOffsetRequired(verifier, VT_ENUMS) &&
+           verifier.VerifyVector(enums()) &&
+           verifier.VerifyVectorOfTables(enums()) &&
+           VerifyOffset(verifier, VT_FILE_IDENT) &&
+           verifier.VerifyString(file_ident()) &&
+           VerifyOffset(verifier, VT_FILE_EXT) &&
+           verifier.VerifyString(file_ext()) &&
+           VerifyOffset(verifier, VT_ROOT_TABLE) &&
+           verifier.VerifyTable(root_table()) &&
+           VerifyOffset(verifier, VT_SERVICES) &&
+           verifier.VerifyVector(services()) &&
+           verifier.VerifyVectorOfTables(services()) &&
+           VerifyField<uint64_t>(verifier, VT_ADVANCED_FEATURES, 8) &&
+           VerifyOffset(verifier, VT_FBS_FILES) &&
+           verifier.VerifyVector(fbs_files()) &&
+           verifier.VerifyVectorOfTables(fbs_files()) &&
+           verifier.EndTable();
+  }
+};
+
+struct SchemaBuilder {
+  typedef Schema Table;
+  flatbuffers::FlatBufferBuilder &fbb_;
+  flatbuffers::uoffset_t start_;
+  void add_objects(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Object>>> objects) {
+    fbb_.AddOffset(Schema::VT_OBJECTS, objects);
+  }
+  void add_enums(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>>> enums) {
+    fbb_.AddOffset(Schema::VT_ENUMS, enums);
+  }
+  void add_file_ident(flatbuffers::Offset<flatbuffers::String> file_ident) {
+    fbb_.AddOffset(Schema::VT_FILE_IDENT, file_ident);
+  }
+  void add_file_ext(flatbuffers::Offset<flatbuffers::String> file_ext) {
+    fbb_.AddOffset(Schema::VT_FILE_EXT, file_ext);
+  }
+  void add_root_table(flatbuffers::Offset<reflection::Object> root_table) {
+    fbb_.AddOffset(Schema::VT_ROOT_TABLE, root_table);
+  }
+  void add_services(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Service>>> services) {
+    fbb_.AddOffset(Schema::VT_SERVICES, services);
+  }
+  void add_advanced_features(reflection::AdvancedFeatures advanced_features) {
+    fbb_.AddElement<uint64_t>(Schema::VT_ADVANCED_FEATURES, static_cast<uint64_t>(advanced_features), 0);
+  }
+  void add_fbs_files(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>>> fbs_files) {
+    fbb_.AddOffset(Schema::VT_FBS_FILES, fbs_files);
+  }
+  explicit SchemaBuilder(flatbuffers::FlatBufferBuilder &_fbb)
+        : fbb_(_fbb) {
+    start_ = fbb_.StartTable();
+  }
+  flatbuffers::Offset<Schema> Finish() {
+    const auto end = fbb_.EndTable(start_);
+    auto o = flatbuffers::Offset<Schema>(end);
+    fbb_.Required(o, Schema::VT_OBJECTS);
+    fbb_.Required(o, Schema::VT_ENUMS);
+    return o;
+  }
+};
+
+inline flatbuffers::Offset<Schema> CreateSchema(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Object>>> objects = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Enum>>> enums = 0,
+    flatbuffers::Offset<flatbuffers::String> file_ident = 0,
+    flatbuffers::Offset<flatbuffers::String> file_ext = 0,
+    flatbuffers::Offset<reflection::Object> root_table = 0,
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::Service>>> services = 0,
+    reflection::AdvancedFeatures advanced_features = static_cast<reflection::AdvancedFeatures>(0),
+    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<reflection::SchemaFile>>> fbs_files = 0) {
+  SchemaBuilder builder_(_fbb);
+  builder_.add_advanced_features(advanced_features);
+  builder_.add_fbs_files(fbs_files);
+  builder_.add_services(services);
+  builder_.add_root_table(root_table);
+  builder_.add_file_ext(file_ext);
+  builder_.add_file_ident(file_ident);
+  builder_.add_enums(enums);
+  builder_.add_objects(objects);
+  return builder_.Finish();
+}
+
+inline flatbuffers::Offset<Schema> CreateSchemaDirect(
+    flatbuffers::FlatBufferBuilder &_fbb,
+    std::vector<flatbuffers::Offset<reflection::Object>> *objects = nullptr,
+    std::vector<flatbuffers::Offset<reflection::Enum>> *enums = nullptr,
+    const char *file_ident = nullptr,
+    const char *file_ext = nullptr,
+    flatbuffers::Offset<reflection::Object> root_table = 0,
+    std::vector<flatbuffers::Offset<reflection::Service>> *services = nullptr,
+    reflection::AdvancedFeatures advanced_features = static_cast<reflection::AdvancedFeatures>(0),
+    std::vector<flatbuffers::Offset<reflection::SchemaFile>> *fbs_files = nullptr) {
+  auto objects__ = objects ? _fbb.CreateVectorOfSortedTables<reflection::Object>(objects) : 0;
+  auto enums__ = enums ? _fbb.CreateVectorOfSortedTables<reflection::Enum>(enums) : 0;
+  auto file_ident__ = file_ident ? _fbb.CreateString(file_ident) : 0;
+  auto file_ext__ = file_ext ? _fbb.CreateString(file_ext) : 0;
+  auto services__ = services ? _fbb.CreateVectorOfSortedTables<reflection::Service>(services) : 0;
+  auto fbs_files__ = fbs_files ? _fbb.CreateVectorOfSortedTables<reflection::SchemaFile>(fbs_files) : 0;
+  return reflection::CreateSchema(
+      _fbb,
+      objects__,
+      enums__,
+      file_ident__,
+      file_ext__,
+      root_table,
+      services__,
+      advanced_features,
+      fbs_files__);
+}
+
+inline const reflection::Schema *GetSchema(const void *buf) {
+  return flatbuffers::GetRoot<reflection::Schema>(buf);
+}
+
+inline const reflection::Schema *GetSizePrefixedSchema(const void *buf) {
+  return flatbuffers::GetSizePrefixedRoot<reflection::Schema>(buf);
+}
+
+inline const char *SchemaIdentifier() {
+  return "BFBS";
+}
+
+inline bool SchemaBufferHasIdentifier(const void *buf) {
+  return flatbuffers::BufferHasIdentifier(
+      buf, SchemaIdentifier());
+}
+
+inline bool SizePrefixedSchemaBufferHasIdentifier(const void *buf) {
+  return flatbuffers::BufferHasIdentifier(
+      buf, SchemaIdentifier(), true);
+}
+
+inline bool VerifySchemaBuffer(
+    flatbuffers::Verifier &verifier) {
+  return verifier.VerifyBuffer<reflection::Schema>(SchemaIdentifier());
+}
+
+inline bool VerifySizePrefixedSchemaBuffer(
+    flatbuffers::Verifier &verifier) {
+  return verifier.VerifySizePrefixedBuffer<reflection::Schema>(SchemaIdentifier());
+}
+
+inline const char *SchemaExtension() {
+  return "bfbs";
+}
+
+inline void FinishSchemaBuffer(
+    flatbuffers::FlatBufferBuilder &fbb,
+    flatbuffers::Offset<reflection::Schema> root) {
+  fbb.Finish(root, SchemaIdentifier());
+}
+
+inline void FinishSizePrefixedSchemaBuffer(
+    flatbuffers::FlatBufferBuilder &fbb,
+    flatbuffers::Offset<reflection::Schema> root) {
+  fbb.FinishSizePrefixed(root, SchemaIdentifier());
+}
+
+}  // namespace reflection
+
+#endif  // FLATBUFFERS_GENERATED_REFLECTION_REFLECTION_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/registry.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/registry.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/registry.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/registry.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,130 @@
+/*
+ * Copyright 2017 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_REGISTRY_H_
+#define FLATBUFFERS_REGISTRY_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/idl.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Convenience class to easily parse or generate text for arbitrary FlatBuffers.
+// Simply pre-populate it with all schema filenames that may be in use, and
+// This class will look them up using the file_identifier declared in the
+// schema.
+class Registry {
+ public:
+  // Call this for all schemas that may be in use. The identifier has
+  // a function in the generated code, e.g. MonsterIdentifier().
+  void Register(const char *file_identifier, const char *schema_path) {
+    Schema schema;
+    schema.path_ = schema_path;
+    schemas_[file_identifier] = schema;
+  }
+
+  // Generate text from an arbitrary FlatBuffer by looking up its
+  // file_identifier in the registry.
+  bool FlatBufferToText(const uint8_t *flatbuf, size_t len, std::string *dest) {
+    // Get the identifier out of the buffer.
+    // If the buffer is truncated, exit.
+    if (len < sizeof(uoffset_t) + kFileIdentifierLength) {
+      lasterror_ = "buffer truncated";
+      return false;
+    }
+    std::string ident(
+        reinterpret_cast<const char *>(flatbuf) + sizeof(uoffset_t),
+        kFileIdentifierLength);
+    // Load and parse the schema.
+    Parser parser;
+    if (!LoadSchema(ident, &parser)) return false;
+    // Now we're ready to generate text.
+    if (!GenerateText(parser, flatbuf, dest)) {
+      lasterror_ = "unable to generate text for FlatBuffer binary";
+      return false;
+    }
+    return true;
+  }
+
+  // Converts a binary buffer to text using one of the schemas in the registry,
+  // use the file_identifier to indicate which.
+  // If DetachedBuffer::data() is null then parsing failed.
+  DetachedBuffer TextToFlatBuffer(const char *text,
+                                  const char *file_identifier) {
+    // Load and parse the schema.
+    Parser parser;
+    if (!LoadSchema(file_identifier, &parser)) return DetachedBuffer();
+    // Parse the text.
+    if (!parser.Parse(text)) {
+      lasterror_ = parser.error_;
+      return DetachedBuffer();
+    }
+    // We have a valid FlatBuffer. Detach it from the builder and return.
+    return parser.builder_.Release();
+  }
+
+  // Modify any parsing / output options used by the other functions.
+  void SetOptions(const IDLOptions &opts) { opts_ = opts; }
+
+  // If schemas used contain include statements, call this function for every
+  // directory the parser should search them for.
+  void AddIncludeDirectory(const char *path) { include_paths_.push_back(path); }
+
+  // Returns a human readable error if any of the above functions fail.
+  const std::string &GetLastError() { return lasterror_; }
+
+ private:
+  bool LoadSchema(const std::string &ident, Parser *parser) {
+    // Find the schema, if not, exit.
+    auto it = schemas_.find(ident);
+    if (it == schemas_.end()) {
+      // Don't attach the identifier, since it may not be human readable.
+      lasterror_ = "identifier for this buffer not in the registry";
+      return false;
+    }
+    auto &schema = it->second;
+    // Load the schema from disk. If not, exit.
+    std::string schematext;
+    if (!LoadFile(schema.path_.c_str(), false, &schematext)) {
+      lasterror_ = "could not load schema: " + schema.path_;
+      return false;
+    }
+    // Parse schema.
+    parser->opts = opts_;
+    if (!parser->Parse(schematext.c_str(), include_paths_.data(),
+                       schema.path_.c_str())) {
+      lasterror_ = parser->error_;
+      return false;
+    }
+    return true;
+  }
+
+  struct Schema {
+    std::string path_;
+    // TODO(wvo) optionally cache schema file or parsed schema here.
+  };
+
+  std::string lasterror_;
+  IDLOptions opts_;
+  std::vector<const char *> include_paths_;
+  std::map<std::string, Schema> schemas_;
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_REGISTRY_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/stl_emulation.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/stl_emulation.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/stl_emulation.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/stl_emulation.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,515 @@
+/*
+ * Copyright 2017 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_STL_EMULATION_H_
+#define FLATBUFFERS_STL_EMULATION_H_
+
+// clang-format off
+#include "flatbuffers/base.h"
+
+#include <string>
+#include <type_traits>
+#include <vector>
+#include <memory>
+#include <limits>
+
+#ifndef FLATBUFFERS_USE_STD_OPTIONAL
+  // Detect C++17 compatible compiler.
+  // __cplusplus >= 201703L - a compiler has support of 'static inline' variables.
+  #if (defined(__cplusplus) && __cplusplus >= 201703L) \
+      || (defined(_MSVC_LANG) && _MSVC_LANG >= 201703L)
+    #define FLATBUFFERS_USE_STD_OPTIONAL 1
+  #else
+    #define FLATBUFFERS_USE_STD_OPTIONAL 0
+  #endif // (defined(__cplusplus) && __cplusplus >= 201703L) ...
+#endif // FLATBUFFERS_USE_STD_OPTIONAL
+
+#if FLATBUFFERS_USE_STD_OPTIONAL
+  #include <optional>
+#endif
+
+// The __cpp_lib_span is the predefined feature macro.
+#if defined(FLATBUFFERS_USE_STD_SPAN)
+    #include <span>
+#elif defined(__cpp_lib_span) && defined(__has_include)
+  #if __has_include(<span>)
+    #include <span>
+    #define FLATBUFFERS_USE_STD_SPAN
+  #endif
+#else
+  // Disable non-trivial ctors if FLATBUFFERS_SPAN_MINIMAL defined.
+  #if !defined(FLATBUFFERS_TEMPLATES_ALIASES)
+    #define FLATBUFFERS_SPAN_MINIMAL
+  #else
+    // Enable implicit construction of a span<T,N> from a std::array<T,N>.
+    #include <array>
+  #endif
+#endif // defined(FLATBUFFERS_USE_STD_SPAN)
+
+// This header provides backwards compatibility for older versions of the STL.
+namespace mapserver {
+namespace flatbuffers {
+
+#if defined(FLATBUFFERS_TEMPLATES_ALIASES)
+  template <typename T>
+  using numeric_limits = std::numeric_limits<T>;
+#else
+  template <typename T> class numeric_limits :
+    public std::numeric_limits<T> {};
+#endif  // defined(FLATBUFFERS_TEMPLATES_ALIASES)
+
+#if defined(FLATBUFFERS_TEMPLATES_ALIASES)
+  template <typename T> using is_scalar = std::is_scalar<T>;
+  template <typename T, typename U> using is_same = std::is_same<T,U>;
+  template <typename T> using is_floating_point = std::is_floating_point<T>;
+  template <typename T> using is_unsigned = std::is_unsigned<T>;
+  template <typename T> using is_enum = std::is_enum<T>;
+  template <typename T> using make_unsigned = std::make_unsigned<T>;
+  template<bool B, class T, class F>
+  using conditional = std::conditional<B, T, F>;
+  template<class T, T v>
+  using integral_constant = std::integral_constant<T, v>;
+  template <bool B>
+  using bool_constant = integral_constant<bool, B>;
+  using true_type  = std::true_type;
+  using false_type = std::false_type;
+#else
+  // MSVC 2010 doesn't support C++11 aliases.
+  template <typename T> struct is_scalar : public std::is_scalar<T> {};
+  template <typename T, typename U> struct is_same : public std::is_same<T,U> {};
+  template <typename T> struct is_floating_point :
+        public std::is_floating_point<T> {};
+  template <typename T> struct is_unsigned : public std::is_unsigned<T> {};
+  template <typename T> struct is_enum : public std::is_enum<T> {};
+  template <typename T> struct make_unsigned : public std::make_unsigned<T> {};
+  template<bool B, class T, class F>
+  struct conditional : public std::conditional<B, T, F> {};
+  template<class T, T v>
+  struct integral_constant : public std::integral_constant<T, v> {};
+  template <bool B>
+  struct bool_constant : public integral_constant<bool, B> {};
+  typedef bool_constant<true>  true_type;
+  typedef bool_constant<false> false_type;
+#endif  // defined(FLATBUFFERS_TEMPLATES_ALIASES)
+
+#if defined(FLATBUFFERS_TEMPLATES_ALIASES)
+  template <class T> using unique_ptr = std::unique_ptr<T>;
+#else
+  // MSVC 2010 doesn't support C++11 aliases.
+  // We're manually "aliasing" the class here as we want to bring unique_ptr
+  // into the flatbuffers namespace.  We have unique_ptr in the flatbuffers
+  // namespace we have a completely independent implementation (see below)
+  // for C++98 STL implementations.
+  template <class T> class unique_ptr : public std::unique_ptr<T> {
+    public:
+    unique_ptr() {}
+    explicit unique_ptr(T* p) : std::unique_ptr<T>(p) {}
+    unique_ptr(std::unique_ptr<T>&& u) { *this = std::move(u); }
+    unique_ptr(unique_ptr&& u) { *this = std::move(u); }
+    unique_ptr& operator=(std::unique_ptr<T>&& u) {
+      std::unique_ptr<T>::reset(u.release());
+      return *this;
+    }
+    unique_ptr& operator=(unique_ptr&& u) {
+      std::unique_ptr<T>::reset(u.release());
+      return *this;
+    }
+    unique_ptr& operator=(T* p) {
+      return std::unique_ptr<T>::operator=(p);
+    }
+  };
+#endif  // defined(FLATBUFFERS_TEMPLATES_ALIASES)
+
+#if FLATBUFFERS_USE_STD_OPTIONAL
+template<class T>
+using Optional = std::optional<T>;
+using nullopt_t = std::nullopt_t;
+inline constexpr nullopt_t nullopt = std::nullopt;
+
+#else
+// Limited implementation of Optional<T> type for a scalar T.
+// This implementation limited by trivial types compatible with
+// std::is_arithmetic<T> or std::is_enum<T> type traits.
+
+// A tag to indicate an empty flatbuffers::optional<T>.
+struct nullopt_t {
+  explicit FLATBUFFERS_CONSTEXPR_CPP11 nullopt_t(int) {}
+};
+
+#if defined(FLATBUFFERS_CONSTEXPR_DEFINED)
+  namespace internal {
+    template <class> struct nullopt_holder {
+      static constexpr nullopt_t instance_ = nullopt_t(0);
+    };
+    template<class Dummy>
+    constexpr nullopt_t nullopt_holder<Dummy>::instance_;
+  }
+  static constexpr const nullopt_t &nullopt = internal::nullopt_holder<void>::instance_;
+
+#else
+  namespace internal {
+    template <class> struct nullopt_holder {
+      static const nullopt_t instance_;
+    };
+    template<class Dummy>
+    const nullopt_t nullopt_holder<Dummy>::instance_  = nullopt_t(0);
+  }
+  static const nullopt_t &nullopt = internal::nullopt_holder<void>::instance_;
+
+#endif
+
+template<class T>
+class Optional FLATBUFFERS_FINAL_CLASS {
+  // Non-scalar 'T' would extremely complicated Optional<T>.
+  // Use is_scalar<T> checking because flatbuffers flatbuffers::is_arithmetic<T>
+  // isn't implemented.
+  static_assert(flatbuffers::is_scalar<T>::value, "unexpected type T");
+
+ public:
+  ~Optional() {}
+
+  FLATBUFFERS_CONSTEXPR_CPP11 Optional() FLATBUFFERS_NOEXCEPT
+    : value_(), has_value_(false) {}
+
+  FLATBUFFERS_CONSTEXPR_CPP11 Optional(nullopt_t) FLATBUFFERS_NOEXCEPT
+    : value_(), has_value_(false) {}
+
+  FLATBUFFERS_CONSTEXPR_CPP11 Optional(T val) FLATBUFFERS_NOEXCEPT
+    : value_(val), has_value_(true) {}
+
+  FLATBUFFERS_CONSTEXPR_CPP11 Optional(const Optional &other) FLATBUFFERS_NOEXCEPT
+    : value_(other.value_), has_value_(other.has_value_) {}
+
+  FLATBUFFERS_CONSTEXPR_CPP14 Optional &operator=(const Optional &other) FLATBUFFERS_NOEXCEPT {
+    value_ = other.value_;
+    has_value_ = other.has_value_;
+    return *this;
+  }
+
+  FLATBUFFERS_CONSTEXPR_CPP14 Optional &operator=(nullopt_t) FLATBUFFERS_NOEXCEPT {
+    value_ = T();
+    has_value_ = false;
+    return *this;
+  }
+
+  FLATBUFFERS_CONSTEXPR_CPP14 Optional &operator=(T val) FLATBUFFERS_NOEXCEPT {
+    value_ = val;
+    has_value_ = true;
+    return *this;
+  }
+
+  void reset() FLATBUFFERS_NOEXCEPT {
+    *this = nullopt;
+  }
+
+  void swap(Optional &other) FLATBUFFERS_NOEXCEPT {
+    std::swap(value_, other.value_);
+    std::swap(has_value_, other.has_value_);
+  }
+
+  FLATBUFFERS_CONSTEXPR_CPP11 FLATBUFFERS_EXPLICIT_CPP11 operator bool() const FLATBUFFERS_NOEXCEPT {
+    return has_value_;
+  }
+
+  FLATBUFFERS_CONSTEXPR_CPP11 bool has_value() const FLATBUFFERS_NOEXCEPT {
+    return has_value_;
+  }
+
+  FLATBUFFERS_CONSTEXPR_CPP11 const T& operator*() const FLATBUFFERS_NOEXCEPT {
+    return value_;
+  }
+
+  const T& value() const {
+    FLATBUFFERS_ASSERT(has_value());
+    return value_;
+  }
+
+  T value_or(T default_value) const FLATBUFFERS_NOEXCEPT {
+    return has_value() ? value_ : default_value;
+  }
+
+ private:
+  T value_;
+  bool has_value_;
+};
+
+template<class T>
+FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const Optional<T>& opt, nullopt_t) FLATBUFFERS_NOEXCEPT {
+  return !opt;
+}
+template<class T>
+FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(nullopt_t, const Optional<T>& opt) FLATBUFFERS_NOEXCEPT {
+  return !opt;
+}
+
+template<class T, class U>
+FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const Optional<T>& lhs, const U& rhs) FLATBUFFERS_NOEXCEPT {
+  return static_cast<bool>(lhs) && (*lhs == rhs);
+}
+
+template<class T, class U>
+FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const T& lhs, const Optional<U>& rhs) FLATBUFFERS_NOEXCEPT {
+  return static_cast<bool>(rhs) && (lhs == *rhs);
+}
+
+template<class T, class U>
+FLATBUFFERS_CONSTEXPR_CPP11 bool operator==(const Optional<T>& lhs, const Optional<U>& rhs) FLATBUFFERS_NOEXCEPT {
+  return static_cast<bool>(lhs) != static_cast<bool>(rhs)
+              ? false
+              : !static_cast<bool>(lhs) ? false : (*lhs == *rhs);
+}
+#endif // FLATBUFFERS_USE_STD_OPTIONAL
+
+
+// Very limited and naive partial implementation of C++20 std::span<T,Extent>.
+#if defined(FLATBUFFERS_USE_STD_SPAN)
+  inline constexpr std::size_t dynamic_extent = std::dynamic_extent;
+  template<class T, std::size_t Extent = std::dynamic_extent>
+  using span = std::span<T, Extent>;
+
+#else // !defined(FLATBUFFERS_USE_STD_SPAN)
+FLATBUFFERS_CONSTEXPR std::size_t dynamic_extent = static_cast<std::size_t>(-1);
+
+// Exclude this code if MSVC2010 or non-STL Android is active.
+// The non-STL Android doesn't have `std::is_convertible` required for SFINAE.
+#if !defined(FLATBUFFERS_SPAN_MINIMAL)
+namespace internal {
+  // This is SFINAE helper class for checking of a common condition:
+  // > This overload only participates in overload resolution
+  // > Check whether a pointer to an array of U can be converted
+  // > to a pointer to an array of E.
+  // This helper is used for checking of 'U -> const U'.
+  template<class E, std::size_t Extent, class U, std::size_t N>
+  struct is_span_convertable {
+    using type =
+      typename std::conditional<std::is_convertible<U (*)[], E (*)[]>::value
+                                && (Extent == dynamic_extent || N == Extent),
+                                int, void>::type;
+  };
+
+  template<typename T>
+  struct SpanIterator {
+    // TODO: upgrade to std::random_access_iterator_tag.
+    using iterator_category = std::forward_iterator_tag;
+    using difference_type  = std::ptrdiff_t;
+    using value_type = typename std::remove_cv<T>::type;
+    using reference = T&;
+    using pointer   = T*;
+
+    // Convince MSVC compiler that this iterator is trusted (it is verified).
+    #ifdef _MSC_VER
+      using _Unchecked_type = pointer;
+    #endif // _MSC_VER
+
+    SpanIterator(pointer ptr) : ptr_(ptr) {}
+    reference operator*() const { return *ptr_; }
+    pointer operator->() { return ptr_; }
+    SpanIterator& operator++() { ptr_++; return *this; }  
+    SpanIterator  operator++(int) { auto tmp = *this; ++(*this); return tmp; }
+
+    friend bool operator== (const SpanIterator& lhs, const SpanIterator& rhs) { return lhs.ptr_ == rhs.ptr_; }
+    friend bool operator!= (const SpanIterator& lhs, const SpanIterator& rhs) { return lhs.ptr_ != rhs.ptr_; }
+
+   private:
+    pointer ptr_;
+  };
+}  // namespace internal
+#endif  // !defined(FLATBUFFERS_SPAN_MINIMAL)
+
+// T - element type; must be a complete type that is not an abstract
+// class type.
+// Extent - the number of elements in the sequence, or dynamic.
+template<class T, std::size_t Extent = dynamic_extent>
+class span FLATBUFFERS_FINAL_CLASS {
+ public:
+  typedef T element_type;
+  typedef T& reference;
+  typedef const T& const_reference;
+  typedef T* pointer;
+  typedef const T* const_pointer;
+  typedef std::size_t size_type;
+
+  static FLATBUFFERS_CONSTEXPR size_type extent = Extent;
+
+  // Returns the number of elements in the span.
+  FLATBUFFERS_CONSTEXPR_CPP11 size_type size() const FLATBUFFERS_NOEXCEPT {
+    return count_;
+  }
+
+  // Returns the size of the sequence in bytes.
+  FLATBUFFERS_CONSTEXPR_CPP11
+  size_type size_bytes() const FLATBUFFERS_NOEXCEPT {
+    return size() * sizeof(element_type);
+  }
+
+  // Checks if the span is empty.
+  FLATBUFFERS_CONSTEXPR_CPP11 bool empty() const FLATBUFFERS_NOEXCEPT {
+    return size() == 0;
+  }
+
+  // Returns a pointer to the beginning of the sequence.
+  FLATBUFFERS_CONSTEXPR_CPP11 pointer data() const FLATBUFFERS_NOEXCEPT {
+    return data_;
+  }
+
+  #if !defined(FLATBUFFERS_SPAN_MINIMAL)
+    using Iterator = internal::SpanIterator<T>;
+    using ConstIterator = internal::SpanIterator<const T>;
+
+    Iterator begin() const { return Iterator(data()); }
+    Iterator end() const   { return Iterator(data() + size()); }
+
+    ConstIterator cbegin() const { return ConstIterator(data()); }
+    ConstIterator cend() const  { return ConstIterator(data() + size()); }
+  #endif
+
+  // Returns a reference to the idx-th element of the sequence.
+  // The behavior is undefined if the idx is greater than or equal to size().
+  FLATBUFFERS_CONSTEXPR_CPP11 reference operator[](size_type idx) const {
+    return data()[idx];
+  }
+
+  FLATBUFFERS_CONSTEXPR_CPP11 span(const span &other) FLATBUFFERS_NOEXCEPT
+      : data_(other.data_), count_(other.count_) {}
+
+  FLATBUFFERS_CONSTEXPR_CPP14 span &operator=(const span &other)
+      FLATBUFFERS_NOEXCEPT {
+    data_ = other.data_;
+    count_ = other.count_;
+  }
+
+  // Limited implementation of
+  // `template <class It> constexpr std::span(It first, size_type count);`.
+  //
+  // Constructs a span that is a view over the range [first, first + count);
+  // the resulting span has: data() == first and size() == count.
+  // The behavior is undefined if [first, first + count) is not a valid range,
+  // or if (extent != flatbuffers::dynamic_extent && count != extent).
+  FLATBUFFERS_CONSTEXPR_CPP11
+  explicit span(pointer first, size_type count) FLATBUFFERS_NOEXCEPT
+    : data_ (Extent == dynamic_extent ? first : (Extent == count ? first : nullptr)),
+      count_(Extent == dynamic_extent ? count : (Extent == count ? Extent : 0)) {
+      // Make span empty if the count argument is incompatible with span<T,N>.
+  }
+
+  // Exclude this code if MSVC2010 is active. The MSVC2010 isn't C++11
+  // compliant, it doesn't support default template arguments for functions.
+  #if defined(FLATBUFFERS_SPAN_MINIMAL)
+  FLATBUFFERS_CONSTEXPR_CPP11 span() FLATBUFFERS_NOEXCEPT : data_(nullptr),
+                                                            count_(0) {
+    static_assert(extent == 0 || extent == dynamic_extent, "invalid span");
+  }
+
+  #else
+  // Constructs an empty span whose data() == nullptr and size() == 0.
+  // This overload only participates in overload resolution if
+  // extent == 0 || extent == flatbuffers::dynamic_extent.
+  // A dummy template argument N is need dependency for SFINAE.
+  template<std::size_t N = 0,
+    typename internal::is_span_convertable<element_type, Extent, element_type, (N - N)>::type = 0>
+  FLATBUFFERS_CONSTEXPR_CPP11 span() FLATBUFFERS_NOEXCEPT : data_(nullptr),
+                                                            count_(0) {
+    static_assert(extent == 0 || extent == dynamic_extent, "invalid span");
+  }
+
+  // Constructs a span that is a view over the array arr; the resulting span
+  // has size() == N and data() == std::data(arr). These overloads only
+  // participate in overload resolution if
+  // extent == std::dynamic_extent || N == extent is true and
+  // std::remove_pointer_t<decltype(std::data(arr))>(*)[]
+  // is convertible to element_type (*)[].
+  template<std::size_t N,
+    typename internal::is_span_convertable<element_type, Extent, element_type, N>::type = 0>
+  FLATBUFFERS_CONSTEXPR_CPP11 span(element_type (&arr)[N]) FLATBUFFERS_NOEXCEPT
+      : data_(arr), count_(N) {}
+
+  template<class U, std::size_t N,
+    typename internal::is_span_convertable<element_type, Extent, U, N>::type = 0>
+  FLATBUFFERS_CONSTEXPR_CPP11 span(std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT
+     : data_(arr.data()), count_(N) {}
+
+  //template<class U, std::size_t N,
+  //  int = 0>
+  //FLATBUFFERS_CONSTEXPR_CPP11 span(std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT
+  //   : data_(arr.data()), count_(N) {}
+
+  template<class U, std::size_t N,
+    typename internal::is_span_convertable<element_type, Extent, U, N>::type = 0>
+  FLATBUFFERS_CONSTEXPR_CPP11 span(const std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT
+    : data_(arr.data()), count_(N) {}
+
+  // Converting constructor from another span s;
+  // the resulting span has size() == s.size() and data() == s.data().
+  // This overload only participates in overload resolution
+  // if extent == std::dynamic_extent || N == extent is true and U (*)[]
+  // is convertible to element_type (*)[].
+  template<class U, std::size_t N,
+    typename internal::is_span_convertable<element_type, Extent, U, N>::type = 0>
+  FLATBUFFERS_CONSTEXPR_CPP11 span(const flatbuffers::span<U, N> &s) FLATBUFFERS_NOEXCEPT
+      : span(s.data(), s.size()) {
+  }
+
+  #endif  // !defined(FLATBUFFERS_SPAN_MINIMAL)
+
+ private:
+  // This is a naive implementation with 'count_' member even if (Extent != dynamic_extent).
+  pointer const data_;
+  size_type count_;
+};
+#endif  // defined(FLATBUFFERS_USE_STD_SPAN)
+
+#if !defined(FLATBUFFERS_SPAN_MINIMAL)
+template<class U, std::size_t N>
+FLATBUFFERS_CONSTEXPR_CPP11
+flatbuffers::span<U, N> make_span(U(&arr)[N]) FLATBUFFERS_NOEXCEPT {
+  return span<U, N>(arr);
+}
+
+template<class U, std::size_t N>
+FLATBUFFERS_CONSTEXPR_CPP11
+flatbuffers::span<const U, N> make_span(const U(&arr)[N]) FLATBUFFERS_NOEXCEPT {
+  return span<const U, N>(arr);
+}
+
+template<class U, std::size_t N>
+FLATBUFFERS_CONSTEXPR_CPP11
+flatbuffers::span<U, N> make_span(std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
+  return span<U, N>(arr);
+}
+
+template<class U, std::size_t N>
+FLATBUFFERS_CONSTEXPR_CPP11
+flatbuffers::span<const U, N> make_span(const std::array<U, N> &arr) FLATBUFFERS_NOEXCEPT {
+  return span<const U, N>(arr);
+}
+
+template<class U, std::size_t N>
+FLATBUFFERS_CONSTEXPR_CPP11
+flatbuffers::span<U, dynamic_extent> make_span(U *first, std::size_t count) FLATBUFFERS_NOEXCEPT {
+  return span<U, dynamic_extent>(first, count);
+}
+
+template<class U, std::size_t N>
+FLATBUFFERS_CONSTEXPR_CPP11
+flatbuffers::span<const U, dynamic_extent> make_span(const U *first, std::size_t count) FLATBUFFERS_NOEXCEPT {
+  return span<const U, dynamic_extent>(first, count);
+}
+#endif // !defined(FLATBUFFERS_SPAN_MINIMAL)
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_STL_EMULATION_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/string.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/string.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/string.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/string.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_STRING_H_
+#define FLATBUFFERS_STRING_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/vector.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+struct String : public Vector<char> {
+  const char *c_str() const { return reinterpret_cast<const char *>(Data()); }
+  std::string str() const { return std::string(c_str(), size()); }
+
+  // clang-format off
+  #ifdef FLATBUFFERS_HAS_STRING_VIEW
+  flatbuffers::string_view string_view() const {
+    return flatbuffers::string_view(c_str(), size());
+  }
+  #endif // FLATBUFFERS_HAS_STRING_VIEW
+  // clang-format on
+
+  bool operator<(const String &o) const {
+    return StringLessThan(this->data(), this->size(), o.data(), o.size());
+  }
+};
+
+// Convenience function to get std::string from a String returning an empty
+// string on null pointer.
+static inline std::string GetString(const String *str) {
+  return str ? str->str() : "";
+}
+
+// Convenience function to get char* from a String returning an empty string on
+// null pointer.
+static inline const char *GetCstring(const String *str) {
+  return str ? str->c_str() : "";
+}
+
+#ifdef FLATBUFFERS_HAS_STRING_VIEW
+// Convenience function to get string_view from a String returning an empty
+// string_view on null pointer.
+static inline flatbuffers::string_view GetStringView(const String *str) {
+  return str ? str->string_view() : flatbuffers::string_view();
+}
+#endif  // FLATBUFFERS_HAS_STRING_VIEW
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_STRING_H_
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/struct.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/struct.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/struct.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/struct.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,55 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_STRUCT_H_
+#define FLATBUFFERS_STRUCT_H_
+
+#include "flatbuffers/base.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// "structs" are flat structures that do not have an offset table, thus
+// always have all members present and do not support forwards/backwards
+// compatible extensions.
+
+class Struct FLATBUFFERS_FINAL_CLASS {
+ public:
+  template<typename T> T GetField(uoffset_t o) const {
+    return ReadScalar<T>(&data_[o]);
+  }
+
+  template<typename T> T GetStruct(uoffset_t o) const {
+    return reinterpret_cast<T>(&data_[o]);
+  }
+
+  const uint8_t *GetAddressOf(uoffset_t o) const { return &data_[o]; }
+  uint8_t *GetAddressOf(uoffset_t o) { return &data_[o]; }
+
+ private:
+  // private constructor & copy constructor: you obtain instances of this
+  // class by pointing to existing data only
+  Struct();
+  Struct(const Struct &);
+  Struct &operator=(const Struct &);
+
+  uint8_t data_[1];
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_STRUCT_H_
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/table.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/table.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/table.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/table.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,170 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_TABLE_H_
+#define FLATBUFFERS_TABLE_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/verifier.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// "tables" use an offset table (possibly shared) that allows fields to be
+// omitted and added at will, but uses an extra indirection to read.
+class Table {
+ public:
+  const uint8_t *GetVTable() const {
+    return data_ - ReadScalar<soffset_t>(data_);
+  }
+
+  // This gets the field offset for any of the functions below it, or 0
+  // if the field was not present.
+  voffset_t GetOptionalFieldOffset(voffset_t field) const {
+    // The vtable offset is always at the start.
+    auto vtable = GetVTable();
+    // The first element is the size of the vtable (fields + type id + itself).
+    auto vtsize = ReadScalar<voffset_t>(vtable);
+    // If the field we're accessing is outside the vtable, we're reading older
+    // data, so it's the same as if the offset was 0 (not present).
+    return field < vtsize ? ReadScalar<voffset_t>(vtable + field) : 0;
+  }
+
+  template<typename T> T GetField(voffset_t field, T defaultval) const {
+    auto field_offset = GetOptionalFieldOffset(field);
+    return field_offset ? ReadScalar<T>(data_ + field_offset) : defaultval;
+  }
+
+  template<typename P> P GetPointer(voffset_t field) {
+    auto field_offset = GetOptionalFieldOffset(field);
+    auto p = data_ + field_offset;
+    return field_offset ? reinterpret_cast<P>(p + ReadScalar<uoffset_t>(p))
+                        : nullptr;
+  }
+  template<typename P> P GetPointer(voffset_t field) const {
+    return const_cast<Table *>(this)->GetPointer<P>(field);
+  }
+
+  template<typename P> P GetStruct(voffset_t field) const {
+    auto field_offset = GetOptionalFieldOffset(field);
+    auto p = const_cast<uint8_t *>(data_ + field_offset);
+    return field_offset ? reinterpret_cast<P>(p) : nullptr;
+  }
+
+  template<typename Raw, typename Face>
+  flatbuffers::Optional<Face> GetOptional(voffset_t field) const {
+    auto field_offset = GetOptionalFieldOffset(field);
+    auto p = data_ + field_offset;
+    return field_offset ? Optional<Face>(static_cast<Face>(ReadScalar<Raw>(p)))
+                        : Optional<Face>();
+  }
+
+  template<typename T> bool SetField(voffset_t field, T val, T def) {
+    auto field_offset = GetOptionalFieldOffset(field);
+    if (!field_offset) return IsTheSameAs(val, def);
+    WriteScalar(data_ + field_offset, val);
+    return true;
+  }
+  template<typename T> bool SetField(voffset_t field, T val) {
+    auto field_offset = GetOptionalFieldOffset(field);
+    if (!field_offset) return false;
+    WriteScalar(data_ + field_offset, val);
+    return true;
+  }
+
+  bool SetPointer(voffset_t field, const uint8_t *val) {
+    auto field_offset = GetOptionalFieldOffset(field);
+    if (!field_offset) return false;
+    WriteScalar(data_ + field_offset,
+                static_cast<uoffset_t>(val - (data_ + field_offset)));
+    return true;
+  }
+
+  uint8_t *GetAddressOf(voffset_t field) {
+    auto field_offset = GetOptionalFieldOffset(field);
+    return field_offset ? data_ + field_offset : nullptr;
+  }
+  const uint8_t *GetAddressOf(voffset_t field) const {
+    return const_cast<Table *>(this)->GetAddressOf(field);
+  }
+
+  bool CheckField(voffset_t field) const {
+    return GetOptionalFieldOffset(field) != 0;
+  }
+
+  // Verify the vtable of this table.
+  // Call this once per table, followed by VerifyField once per field.
+  bool VerifyTableStart(Verifier &verifier) const {
+    return verifier.VerifyTableStart(data_);
+  }
+
+  // Verify a particular field.
+  template<typename T>
+  bool VerifyField(const Verifier &verifier, voffset_t field,
+                   size_t align) const {
+    // Calling GetOptionalFieldOffset should be safe now thanks to
+    // VerifyTable().
+    auto field_offset = GetOptionalFieldOffset(field);
+    // Check the actual field.
+    return !field_offset || verifier.VerifyField<T>(data_, field_offset, align);
+  }
+
+  // VerifyField for required fields.
+  template<typename T>
+  bool VerifyFieldRequired(const Verifier &verifier, voffset_t field,
+                           size_t align) const {
+    auto field_offset = GetOptionalFieldOffset(field);
+    return verifier.Check(field_offset != 0) &&
+           verifier.VerifyField<T>(data_, field_offset, align);
+  }
+
+  // Versions for offsets.
+  bool VerifyOffset(const Verifier &verifier, voffset_t field) const {
+    auto field_offset = GetOptionalFieldOffset(field);
+    return !field_offset || verifier.VerifyOffset(data_, field_offset);
+  }
+
+  bool VerifyOffsetRequired(const Verifier &verifier, voffset_t field) const {
+    auto field_offset = GetOptionalFieldOffset(field);
+    return verifier.Check(field_offset != 0) &&
+           verifier.VerifyOffset(data_, field_offset);
+  }
+
+ private:
+  // private constructor & copy constructor: you obtain instances of this
+  // class by pointing to existing data only
+  Table();
+  Table(const Table &other);
+  Table &operator=(const Table &);
+
+  uint8_t data_[1];
+};
+
+// This specialization allows avoiding warnings like:
+// MSVC C4800: type: forcing value to bool 'true' or 'false'.
+template<>
+inline flatbuffers::Optional<bool> Table::GetOptional<uint8_t, bool>(
+    voffset_t field) const {
+  auto field_offset = GetOptionalFieldOffset(field);
+  auto p = data_ + field_offset;
+  return field_offset ? Optional<bool>(ReadScalar<uint8_t>(p) != 0)
+                      : Optional<bool>();
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_TABLE_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/util.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/util.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/util.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/util.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,718 @@
+/*
+ * Copyright 2014 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_UTIL_H_
+#define FLATBUFFERS_UTIL_H_
+
+#include <ctype.h>
+#include <errno.h>
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/stl_emulation.h"
+
+#ifndef FLATBUFFERS_PREFER_PRINTF
+#  include <iomanip>
+#  include <sstream>
+#else  // FLATBUFFERS_PREFER_PRINTF
+#  include <float.h>
+#  include <stdio.h>
+#endif  // FLATBUFFERS_PREFER_PRINTF
+
+#include <string>
+
+namespace mapserver {
+namespace flatbuffers {
+
+// @locale-independent functions for ASCII characters set.
+
+// Fast checking that character lies in closed range: [a <= x <= b]
+// using one compare (conditional branch) operator.
+inline bool check_ascii_range(char x, char a, char b) {
+  FLATBUFFERS_ASSERT(a <= b);
+  // (Hacker's Delight): `a <= x <= b` <=> `(x-a) <={u} (b-a)`.
+  // The x, a, b will be promoted to int and subtracted without overflow.
+  return static_cast<unsigned int>(x - a) <= static_cast<unsigned int>(b - a);
+}
+
+// Case-insensitive isalpha
+inline bool is_alpha(char c) {
+  // ASCII only: alpha to upper case => reset bit 0x20 (~0x20 = 0xDF).
+  return check_ascii_range(c & 0xDF, 'a' & 0xDF, 'z' & 0xDF);
+}
+
+// Check for uppercase alpha
+inline bool is_alpha_upper(char c) { return check_ascii_range(c, 'A', 'Z'); }
+
+// Check (case-insensitive) that `c` is equal to alpha.
+inline bool is_alpha_char(char c, char alpha) {
+  FLATBUFFERS_ASSERT(is_alpha(alpha));
+  // ASCII only: alpha to upper case => reset bit 0x20 (~0x20 = 0xDF).
+  return ((c & 0xDF) == (alpha & 0xDF));
+}
+
+// https://en.cppreference.com/w/cpp/string/byte/isxdigit
+// isdigit and isxdigit are the only standard narrow character classification
+// functions that are not affected by the currently installed C locale. although
+// some implementations (e.g. Microsoft in 1252 codepage) may classify
+// additional single-byte characters as digits.
+inline bool is_digit(char c) { return check_ascii_range(c, '0', '9'); }
+
+inline bool is_xdigit(char c) {
+  // Replace by look-up table.
+  return is_digit(c) || check_ascii_range(c & 0xDF, 'a' & 0xDF, 'f' & 0xDF);
+}
+
+// Case-insensitive isalnum
+inline bool is_alnum(char c) { return is_alpha(c) || is_digit(c); }
+
+inline char CharToUpper(char c) {
+  return static_cast<char>(::toupper(static_cast<unsigned char>(c)));
+}
+
+inline char CharToLower(char c) {
+  return static_cast<char>(::tolower(static_cast<unsigned char>(c)));
+}
+
+// @end-locale-independent functions for ASCII character set
+
+#ifdef FLATBUFFERS_PREFER_PRINTF
+template<typename T> size_t IntToDigitCount(T t) {
+  size_t digit_count = 0;
+  // Count the sign for negative numbers
+  if (t < 0) digit_count++;
+  // Count a single 0 left of the dot for fractional numbers
+  if (-1 < t && t < 1) digit_count++;
+  // Count digits until fractional part
+  T eps = std::numeric_limits<T>::epsilon();
+  while (t <= (-1 + eps) || (1 - eps) <= t) {
+    t /= 10;
+    digit_count++;
+  }
+  return digit_count;
+}
+
+template<typename T> size_t NumToStringWidth(T t, int precision = 0) {
+  size_t string_width = IntToDigitCount(t);
+  // Count the dot for floating point numbers
+  if (precision) string_width += (precision + 1);
+  return string_width;
+}
+
+template<typename T>
+std::string NumToStringImplWrapper(T t, const char *fmt, int precision = 0) {
+  size_t string_width = NumToStringWidth(t, precision);
+  std::string s(string_width, 0x00);
+  // Allow snprintf to use std::string trailing null to detect buffer overflow
+  snprintf(const_cast<char *>(s.data()), (s.size() + 1), fmt, string_width, t);
+  return s;
+}
+#endif  // FLATBUFFERS_PREFER_PRINTF
+
+// Convert an integer or floating point value to a string.
+// In contrast to std::stringstream, "char" values are
+// converted to a string of digits, and we don't use scientific notation.
+template<typename T> std::string NumToString(T t) {
+  // clang-format off
+
+  #ifndef FLATBUFFERS_PREFER_PRINTF
+    std::stringstream ss;
+    ss << t;
+    return ss.str();
+  #else // FLATBUFFERS_PREFER_PRINTF
+    auto v = static_cast<long long>(t);
+    return NumToStringImplWrapper(v, "%.*lld");
+  #endif // FLATBUFFERS_PREFER_PRINTF
+  // clang-format on
+}
+// Avoid char types used as character data.
+template<> inline std::string NumToString<signed char>(signed char t) {
+  return NumToString(static_cast<int>(t));
+}
+template<> inline std::string NumToString<unsigned char>(unsigned char t) {
+  return NumToString(static_cast<int>(t));
+}
+template<> inline std::string NumToString<char>(char t) {
+  return NumToString(static_cast<int>(t));
+}
+
+// Special versions for floats/doubles.
+template<typename T> std::string FloatToString(T t, int precision) {
+  // clang-format off
+
+  #ifndef FLATBUFFERS_PREFER_PRINTF
+    // to_string() prints different numbers of digits for floats depending on
+    // platform and isn't available on Android, so we use stringstream
+    std::stringstream ss;
+    // Use std::fixed to suppress scientific notation.
+    ss << std::fixed;
+    // Default precision is 6, we want that to be higher for doubles.
+    ss << std::setprecision(precision);
+    ss << t;
+    auto s = ss.str();
+  #else // FLATBUFFERS_PREFER_PRINTF
+    auto v = static_cast<double>(t);
+    auto s = NumToStringImplWrapper(v, "%0.*f", precision);
+  #endif // FLATBUFFERS_PREFER_PRINTF
+  // clang-format on
+  // Sadly, std::fixed turns "1" into "1.00000", so here we undo that.
+  auto p = s.find_last_not_of('0');
+  if (p != std::string::npos) {
+    // Strip trailing zeroes. If it is a whole number, keep one zero.
+    s.resize(p + (s[p] == '.' ? 2 : 1));
+  }
+  return s;
+}
+
+template<> inline std::string NumToString<double>(double t) {
+  return FloatToString(t, 12);
+}
+template<> inline std::string NumToString<float>(float t) {
+  return FloatToString(t, 6);
+}
+
+// Convert an integer value to a hexadecimal string.
+// The returned string length is always xdigits long, prefixed by 0 digits.
+// For example, IntToStringHex(0x23, 8) returns the string "00000023".
+inline std::string IntToStringHex(int i, int xdigits) {
+  FLATBUFFERS_ASSERT(i >= 0);
+  // clang-format off
+
+  #ifndef FLATBUFFERS_PREFER_PRINTF
+    std::stringstream ss;
+    ss << std::setw(xdigits) << std::setfill('0') << std::hex << std::uppercase
+       << i;
+    return ss.str();
+  #else // FLATBUFFERS_PREFER_PRINTF
+    return NumToStringImplWrapper(i, "%.*X", xdigits);
+  #endif // FLATBUFFERS_PREFER_PRINTF
+  // clang-format on
+}
+
+// clang-format off
+// Use locale independent functions {strtod_l, strtof_l, strtoll_l, strtoull_l}.
+#if defined(FLATBUFFERS_LOCALE_INDEPENDENT) && (FLATBUFFERS_LOCALE_INDEPENDENT > 0)
+  class ClassicLocale {
+    #ifdef _MSC_VER
+      typedef _locale_t locale_type;
+    #else
+      typedef locale_t locale_type;  // POSIX.1-2008 locale_t type
+    #endif
+    ClassicLocale();
+    ~ClassicLocale();
+    locale_type locale_;
+    static ClassicLocale instance_;
+  public:
+    static locale_type Get() { return instance_.locale_; }
+  };
+
+  #ifdef _MSC_VER
+    #define __strtoull_impl(s, pe, b) _strtoui64_l(s, pe, b, ClassicLocale::Get())
+    #define __strtoll_impl(s, pe, b) _strtoi64_l(s, pe, b, ClassicLocale::Get())
+    #define __strtod_impl(s, pe) _strtod_l(s, pe, ClassicLocale::Get())
+    #define __strtof_impl(s, pe) _strtof_l(s, pe, ClassicLocale::Get())
+  #else
+    #define __strtoull_impl(s, pe, b) strtoull_l(s, pe, b, ClassicLocale::Get())
+    #define __strtoll_impl(s, pe, b) strtoll_l(s, pe, b, ClassicLocale::Get())
+    #define __strtod_impl(s, pe) strtod_l(s, pe, ClassicLocale::Get())
+    #define __strtof_impl(s, pe) strtof_l(s, pe, ClassicLocale::Get())
+  #endif
+#else
+  #define __strtod_impl(s, pe) strtod(s, pe)
+  #define __strtof_impl(s, pe) static_cast<float>(strtod(s, pe))
+  #ifdef _MSC_VER
+    #define __strtoull_impl(s, pe, b) _strtoui64(s, pe, b)
+    #define __strtoll_impl(s, pe, b) _strtoi64(s, pe, b)
+  #else
+    #define __strtoull_impl(s, pe, b) strtoull(s, pe, b)
+    #define __strtoll_impl(s, pe, b) strtoll(s, pe, b)
+  #endif
+#endif
+
+inline void strtoval_impl(int64_t *val, const char *str, char **endptr,
+                                 int base) {
+    *val = __strtoll_impl(str, endptr, base);
+}
+
+inline void strtoval_impl(uint64_t *val, const char *str, char **endptr,
+                                 int base) {
+  *val = __strtoull_impl(str, endptr, base);
+}
+
+inline void strtoval_impl(double *val, const char *str, char **endptr) {
+  *val = __strtod_impl(str, endptr);
+}
+
+// UBSAN: double to float is safe if numeric_limits<float>::is_iec559 is true.
+__supress_ubsan__("float-cast-overflow")
+inline void strtoval_impl(float *val, const char *str, char **endptr) {
+  *val = __strtof_impl(str, endptr);
+}
+#undef __strtoull_impl
+#undef __strtoll_impl
+#undef __strtod_impl
+#undef __strtof_impl
+// clang-format on
+
+// Adaptor for strtoull()/strtoll().
+// Flatbuffers accepts numbers with any count of leading zeros (-009 is -9),
+// while strtoll with base=0 interprets first leading zero as octal prefix.
+// In future, it is possible to add prefixed 0b0101.
+// 1) Checks errno code for overflow condition (out of range).
+// 2) If base <= 0, function try to detect base of number by prefix.
+//
+// Return value (like strtoull and strtoll, but reject partial result):
+// - If successful, an integer value corresponding to the str is returned.
+// - If full string conversion can't be performed, 0 is returned.
+// - If the converted value falls out of range of corresponding return type, a
+// range error occurs. In this case value MAX(T)/MIN(T) is returned.
+template<typename T>
+inline bool StringToIntegerImpl(T *val, const char *const str,
+                                const int base = 0,
+                                const bool check_errno = true) {
+  // T is int64_t or uint64_T
+  FLATBUFFERS_ASSERT(str);
+  if (base <= 0) {
+    auto s = str;
+    while (*s && !is_digit(*s)) s++;
+    if (s[0] == '0' && is_alpha_char(s[1], 'X'))
+      return StringToIntegerImpl(val, str, 16, check_errno);
+    // if a prefix not match, try base=10
+    return StringToIntegerImpl(val, str, 10, check_errno);
+  } else {
+    if (check_errno) errno = 0;  // clear thread-local errno
+    auto endptr = str;
+    strtoval_impl(val, str, const_cast<char **>(&endptr), base);
+    if ((*endptr != '\0') || (endptr == str)) {
+      *val = 0;      // erase partial result
+      return false;  // invalid string
+    }
+    // errno is out-of-range, return MAX/MIN
+    if (check_errno && errno) return false;
+    return true;
+  }
+}
+
+template<typename T>
+inline bool StringToFloatImpl(T *val, const char *const str) {
+  // Type T must be either float or double.
+  FLATBUFFERS_ASSERT(str && val);
+  auto end = str;
+  strtoval_impl(val, str, const_cast<char **>(&end));
+  auto done = (end != str) && (*end == '\0');
+  if (!done) *val = 0;  // erase partial result
+  return done;
+}
+
+// Convert a string to an instance of T.
+// Return value (matched with StringToInteger64Impl and strtod):
+// - If successful, a numeric value corresponding to the str is returned.
+// - If full string conversion can't be performed, 0 is returned.
+// - If the converted value falls out of range of corresponding return type, a
+// range error occurs. In this case value MAX(T)/MIN(T) is returned.
+template<typename T> inline bool StringToNumber(const char *s, T *val) {
+  // Assert on `unsigned long` and `signed long` on LP64.
+  // If it is necessary, it could be solved with flatbuffers::enable_if<B,T>.
+  static_assert(sizeof(T) < sizeof(int64_t), "unexpected type T");
+  FLATBUFFERS_ASSERT(s && val);
+  int64_t i64;
+  // The errno check isn't needed, will return MAX/MIN on overflow.
+  if (StringToIntegerImpl(&i64, s, 0, false)) {
+    const int64_t max = (flatbuffers::numeric_limits<T>::max)();
+    const int64_t min = flatbuffers::numeric_limits<T>::lowest();
+    if (i64 > max) {
+      *val = static_cast<T>(max);
+      return false;
+    }
+    if (i64 < min) {
+      // For unsigned types return max to distinguish from
+      // "no conversion can be performed" when 0 is returned.
+      *val = static_cast<T>(flatbuffers::is_unsigned<T>::value ? max : min);
+      return false;
+    }
+    *val = static_cast<T>(i64);
+    return true;
+  }
+  *val = 0;
+  return false;
+}
+
+template<> inline bool StringToNumber<int64_t>(const char *str, int64_t *val) {
+  return StringToIntegerImpl(val, str);
+}
+
+template<>
+inline bool StringToNumber<uint64_t>(const char *str, uint64_t *val) {
+  if (!StringToIntegerImpl(val, str)) return false;
+  // The strtoull accepts negative numbers:
+  // If the minus sign was part of the input sequence, the numeric value
+  // calculated from the sequence of digits is negated as if by unary minus
+  // in the result type, which applies unsigned integer wraparound rules.
+  // Fix this behaviour (except -0).
+  if (*val) {
+    auto s = str;
+    while (*s && !is_digit(*s)) s++;
+    s = (s > str) ? (s - 1) : s;  // step back to one symbol
+    if (*s == '-') {
+      // For unsigned types return the max to distinguish from
+      // "no conversion can be performed".
+      *val = (flatbuffers::numeric_limits<uint64_t>::max)();
+      return false;
+    }
+  }
+  return true;
+}
+
+template<> inline bool StringToNumber(const char *s, float *val) {
+  return StringToFloatImpl(val, s);
+}
+
+template<> inline bool StringToNumber(const char *s, double *val) {
+  return StringToFloatImpl(val, s);
+}
+
+inline int64_t StringToInt(const char *s, int base = 10) {
+  int64_t val;
+  return StringToIntegerImpl(&val, s, base) ? val : 0;
+}
+
+inline uint64_t StringToUInt(const char *s, int base = 10) {
+  uint64_t val;
+  return StringToIntegerImpl(&val, s, base) ? val : 0;
+}
+
+typedef bool (*LoadFileFunction)(const char *filename, bool binary,
+                                 std::string *dest);
+typedef bool (*FileExistsFunction)(const char *filename);
+
+LoadFileFunction SetLoadFileFunction(LoadFileFunction load_file_function);
+
+FileExistsFunction SetFileExistsFunction(
+    FileExistsFunction file_exists_function);
+
+// Check if file "name" exists.
+bool FileExists(const char *name);
+
+// Check if "name" exists and it is also a directory.
+bool DirExists(const char *name);
+
+// Load file "name" into "buf" returning true if successful
+// false otherwise.  If "binary" is false data is read
+// using ifstream's text mode, otherwise data is read with
+// no transcoding.
+bool LoadFile(const char *name, bool binary, std::string *buf);
+
+// Save data "buf" of length "len" bytes into a file
+// "name" returning true if successful, false otherwise.
+// If "binary" is false data is written using ifstream's
+// text mode, otherwise data is written with no
+// transcoding.
+bool SaveFile(const char *name, const char *buf, size_t len, bool binary);
+
+// Save data "buf" into file "name" returning true if
+// successful, false otherwise.  If "binary" is false
+// data is written using ifstream's text mode, otherwise
+// data is written with no transcoding.
+inline bool SaveFile(const char *name, const std::string &buf, bool binary) {
+  return SaveFile(name, buf.c_str(), buf.size(), binary);
+}
+
+// Functionality for minimalistic portable path handling.
+
+// The functions below behave correctly regardless of whether posix ('/') or
+// Windows ('/' or '\\') separators are used.
+
+// Any new separators inserted are always posix.
+FLATBUFFERS_CONSTEXPR char kPathSeparator = '/';
+
+// Returns the path with the extension, if any, removed.
+std::string StripExtension(const std::string &filepath);
+
+// Returns the extension, if any.
+std::string GetExtension(const std::string &filepath);
+
+// Return the last component of the path, after the last separator.
+std::string StripPath(const std::string &filepath);
+
+// Strip the last component of the path + separator.
+std::string StripFileName(const std::string &filepath);
+
+// Concatenates a path with a filename, regardless of whether the path
+// ends in a separator or not.
+std::string ConCatPathFileName(const std::string &path,
+                               const std::string &filename);
+
+// Replaces any '\\' separators with '/'
+std::string PosixPath(const char *path);
+std::string PosixPath(const std::string &path);
+
+// This function ensure a directory exists, by recursively
+// creating dirs for any parts of the path that don't exist yet.
+void EnsureDirExists(const std::string &filepath);
+
+// Obtains the absolute path from any other path.
+// Returns the input path if the absolute path couldn't be resolved.
+std::string AbsolutePath(const std::string &filepath);
+
+// Returns files relative to the --project_root path, prefixed with `//`.
+std::string RelativeToRootPath(const std::string &project,
+                               const std::string &filepath);
+
+// To and from UTF-8 unicode conversion functions
+
+// Convert a unicode code point into a UTF-8 representation by appending it
+// to a string. Returns the number of bytes generated.
+inline int ToUTF8(uint32_t ucc, std::string *out) {
+  FLATBUFFERS_ASSERT(!(ucc & 0x80000000));  // Top bit can't be set.
+  // 6 possible encodings: http://en.wikipedia.org/wiki/UTF-8
+  for (int i = 0; i < 6; i++) {
+    // Max bits this encoding can represent.
+    uint32_t max_bits = 6 + i * 5 + static_cast<int>(!i);
+    if (ucc < (1u << max_bits)) {  // does it fit?
+      // Remaining bits not encoded in the first byte, store 6 bits each
+      uint32_t remain_bits = i * 6;
+      // Store first byte:
+      (*out) += static_cast<char>((0xFE << (max_bits - remain_bits)) |
+                                  (ucc >> remain_bits));
+      // Store remaining bytes:
+      for (int j = i - 1; j >= 0; j--) {
+        (*out) += static_cast<char>(((ucc >> (j * 6)) & 0x3F) | 0x80);
+      }
+      return i + 1;  // Return the number of bytes added.
+    }
+  }
+  FLATBUFFERS_ASSERT(0);  // Impossible to arrive here.
+  return -1;
+}
+
+// Converts whatever prefix of the incoming string corresponds to a valid
+// UTF-8 sequence into a unicode code. The incoming pointer will have been
+// advanced past all bytes parsed.
+// returns -1 upon corrupt UTF-8 encoding (ignore the incoming pointer in
+// this case).
+inline int FromUTF8(const char **in) {
+  int len = 0;
+  // Count leading 1 bits.
+  for (int mask = 0x80; mask >= 0x04; mask >>= 1) {
+    if (**in & mask) {
+      len++;
+    } else {
+      break;
+    }
+  }
+  if ((static_cast<unsigned char>(**in) << len) & 0x80)
+    return -1;  // Bit after leading 1's must be 0.
+  if (!len) return *(*in)++;
+  // UTF-8 encoded values with a length are between 2 and 4 bytes.
+  if (len < 2 || len > 4) { return -1; }
+  // Grab initial bits of the code.
+  int ucc = *(*in)++ & ((1 << (7 - len)) - 1);
+  for (int i = 0; i < len - 1; i++) {
+    if ((**in & 0xC0) != 0x80) return -1;  // Upper bits must 1 0.
+    ucc <<= 6;
+    ucc |= *(*in)++ & 0x3F;  // Grab 6 more bits of the code.
+  }
+  // UTF-8 cannot encode values between 0xD800 and 0xDFFF (reserved for
+  // UTF-16 surrogate pairs).
+  if (ucc >= 0xD800 && ucc <= 0xDFFF) { return -1; }
+  // UTF-8 must represent code points in their shortest possible encoding.
+  switch (len) {
+    case 2:
+      // Two bytes of UTF-8 can represent code points from U+0080 to U+07FF.
+      if (ucc < 0x0080 || ucc > 0x07FF) { return -1; }
+      break;
+    case 3:
+      // Three bytes of UTF-8 can represent code points from U+0800 to U+FFFF.
+      if (ucc < 0x0800 || ucc > 0xFFFF) { return -1; }
+      break;
+    case 4:
+      // Four bytes of UTF-8 can represent code points from U+10000 to U+10FFFF.
+      if (ucc < 0x10000 || ucc > 0x10FFFF) { return -1; }
+      break;
+  }
+  return ucc;
+}
+
+#ifndef FLATBUFFERS_PREFER_PRINTF
+// Wraps a string to a maximum length, inserting new lines where necessary. Any
+// existing whitespace will be collapsed down to a single space. A prefix or
+// suffix can be provided, which will be inserted before or after a wrapped
+// line, respectively.
+inline std::string WordWrap(const std::string in, size_t max_length,
+                            const std::string wrapped_line_prefix,
+                            const std::string wrapped_line_suffix) {
+  std::istringstream in_stream(in);
+  std::string wrapped, line, word;
+
+  in_stream >> word;
+  line = word;
+
+  while (in_stream >> word) {
+    if ((line.length() + 1 + word.length() + wrapped_line_suffix.length()) <
+        max_length) {
+      line += " " + word;
+    } else {
+      wrapped += line + wrapped_line_suffix + "\n";
+      line = wrapped_line_prefix + word;
+    }
+  }
+  wrapped += line;
+
+  return wrapped;
+}
+#endif  // !FLATBUFFERS_PREFER_PRINTF
+
+inline bool EscapeString(const char *s, size_t length, std::string *_text,
+                         bool allow_non_utf8, bool natural_utf8) {
+  std::string &text = *_text;
+  text += "\"";
+  for (uoffset_t i = 0; i < length; i++) {
+    char c = s[i];
+    switch (c) {
+      case '\n': text += "\\n"; break;
+      case '\t': text += "\\t"; break;
+      case '\r': text += "\\r"; break;
+      case '\b': text += "\\b"; break;
+      case '\f': text += "\\f"; break;
+      case '\"': text += "\\\""; break;
+      case '\\': text += "\\\\"; break;
+      default:
+        if (c >= ' ' && c <= '~') {
+          text += c;
+        } else {
+          // Not printable ASCII data. Let's see if it's valid UTF-8 first:
+          const char *utf8 = s + i;
+          int ucc = FromUTF8(&utf8);
+          if (ucc < 0) {
+            if (allow_non_utf8) {
+              text += "\\x";
+              text += IntToStringHex(static_cast<uint8_t>(c), 2);
+            } else {
+              // There are two cases here:
+              //
+              // 1) We reached here by parsing an IDL file. In that case,
+              // we previously checked for non-UTF-8, so we shouldn't reach
+              // here.
+              //
+              // 2) We reached here by someone calling GenerateText()
+              // on a previously-serialized flatbuffer. The data might have
+              // non-UTF-8 Strings, or might be corrupt.
+              //
+              // In both cases, we have to give up and inform the caller
+              // they have no JSON.
+              return false;
+            }
+          } else {
+            if (natural_utf8) {
+              // utf8 points to past all utf-8 bytes parsed
+              text.append(s + i, static_cast<size_t>(utf8 - s - i));
+            } else if (ucc <= 0xFFFF) {
+              // Parses as Unicode within JSON's \uXXXX range, so use that.
+              text += "\\u";
+              text += IntToStringHex(ucc, 4);
+            } else if (ucc <= 0x10FFFF) {
+              // Encode Unicode SMP values to a surrogate pair using two \u
+              // escapes.
+              uint32_t base = ucc - 0x10000;
+              auto high_surrogate = (base >> 10) + 0xD800;
+              auto low_surrogate = (base & 0x03FF) + 0xDC00;
+              text += "\\u";
+              text += IntToStringHex(high_surrogate, 4);
+              text += "\\u";
+              text += IntToStringHex(low_surrogate, 4);
+            }
+            // Skip past characters recognized.
+            i = static_cast<uoffset_t>(utf8 - s - 1);
+          }
+        }
+        break;
+    }
+  }
+  text += "\"";
+  return true;
+}
+
+inline std::string BufferToHexText(const void *buffer, size_t buffer_size,
+                                   size_t max_length,
+                                   const std::string &wrapped_line_prefix,
+                                   const std::string &wrapped_line_suffix) {
+  std::string text = wrapped_line_prefix;
+  size_t start_offset = 0;
+  const char *s = reinterpret_cast<const char *>(buffer);
+  for (size_t i = 0; s && i < buffer_size; i++) {
+    // Last iteration or do we have more?
+    bool have_more = i + 1 < buffer_size;
+    text += "0x";
+    text += IntToStringHex(static_cast<uint8_t>(s[i]), 2);
+    if (have_more) { text += ','; }
+    // If we have more to process and we reached max_length
+    if (have_more &&
+        text.size() + wrapped_line_suffix.size() >= start_offset + max_length) {
+      text += wrapped_line_suffix;
+      text += '\n';
+      start_offset = text.size();
+      text += wrapped_line_prefix;
+    }
+  }
+  text += wrapped_line_suffix;
+  return text;
+}
+
+// Remove paired quotes in a string: "text"|'text' -> text.
+std::string RemoveStringQuotes(const std::string &s);
+
+// Change th global C-locale to locale with name <locale_name>.
+// Returns an actual locale name in <_value>, useful if locale_name is "" or
+// null.
+bool SetGlobalTestLocale(const char *locale_name,
+                         std::string *_value = nullptr);
+
+// Read (or test) a value of environment variable.
+bool ReadEnvironmentVariable(const char *var_name,
+                             std::string *_value = nullptr);
+
+// MSVC specific: Send all assert reports to STDOUT to prevent CI hangs.
+void SetupDefaultCRTReportMode();
+
+enum class Case {
+  kUnknown = 0,
+  // TheQuickBrownFox
+  kUpperCamel = 1,
+  // theQuickBrownFox
+  kLowerCamel = 2,
+  // the_quick_brown_fox
+  kSnake = 3,
+  // THE_QUICK_BROWN_FOX
+  kScreamingSnake = 4,
+  // THEQUICKBROWNFOX
+  kAllUpper = 5,
+  // thequickbrownfox
+  kAllLower = 6,
+  // the-quick-brown-fox
+  kDasher = 7,
+  // THEQuiCKBr_ownFox (or whatever you want, we won't change it)
+  kKeep = 8,
+  // the_quick_brown_fox123 (as opposed to the_quick_brown_fox_123)
+  kSnake2 = 9,
+};
+
+// Convert the `input` string of case `input_case` to the specified `output_case`.
+std::string ConvertCase(const std::string &input, Case output_case,
+                    Case input_case = Case::kSnake);
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_UTIL_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/vector.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/vector.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/vector.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/vector.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,373 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_VECTOR_H_
+#define FLATBUFFERS_VECTOR_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/buffer.h"
+#include "flatbuffers/stl_emulation.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+struct String;
+
+// An STL compatible iterator implementation for Vector below, effectively
+// calling Get() for every element.
+template<typename T, typename IT> struct VectorIterator {
+  typedef std::random_access_iterator_tag iterator_category;
+  typedef IT value_type;
+  typedef ptrdiff_t difference_type;
+  typedef IT *pointer;
+  typedef IT &reference;
+
+  VectorIterator(const uint8_t *data, uoffset_t i)
+      : data_(data + IndirectHelper<T>::element_stride * i) {}
+  VectorIterator(const VectorIterator &other) : data_(other.data_) {}
+  VectorIterator() : data_(nullptr) {}
+
+  VectorIterator &operator=(const VectorIterator &other) {
+    data_ = other.data_;
+    return *this;
+  }
+
+  VectorIterator &operator=(VectorIterator &&other) {
+    data_ = other.data_;
+    return *this;
+  }
+
+  bool operator==(const VectorIterator &other) const {
+    return data_ == other.data_;
+  }
+
+  bool operator<(const VectorIterator &other) const {
+    return data_ < other.data_;
+  }
+
+  bool operator!=(const VectorIterator &other) const {
+    return data_ != other.data_;
+  }
+
+  difference_type operator-(const VectorIterator &other) const {
+    return (data_ - other.data_) / IndirectHelper<T>::element_stride;
+  }
+
+  // Note: return type is incompatible with the standard
+  // `reference operator*()`.
+  IT operator*() const { return IndirectHelper<T>::Read(data_, 0); }
+
+  // Note: return type is incompatible with the standard
+  // `pointer operator->()`.
+  IT operator->() const { return IndirectHelper<T>::Read(data_, 0); }
+
+  VectorIterator &operator++() {
+    data_ += IndirectHelper<T>::element_stride;
+    return *this;
+  }
+
+  VectorIterator operator++(int) {
+    VectorIterator temp(data_, 0);
+    data_ += IndirectHelper<T>::element_stride;
+    return temp;
+  }
+
+  VectorIterator operator+(const uoffset_t &offset) const {
+    return VectorIterator(data_ + offset * IndirectHelper<T>::element_stride,
+                          0);
+  }
+
+  VectorIterator &operator+=(const uoffset_t &offset) {
+    data_ += offset * IndirectHelper<T>::element_stride;
+    return *this;
+  }
+
+  VectorIterator &operator--() {
+    data_ -= IndirectHelper<T>::element_stride;
+    return *this;
+  }
+
+  VectorIterator operator--(int) {
+    VectorIterator temp(data_, 0);
+    data_ -= IndirectHelper<T>::element_stride;
+    return temp;
+  }
+
+  VectorIterator operator-(const uoffset_t &offset) const {
+    return VectorIterator(data_ - offset * IndirectHelper<T>::element_stride,
+                          0);
+  }
+
+  VectorIterator &operator-=(const uoffset_t &offset) {
+    data_ -= offset * IndirectHelper<T>::element_stride;
+    return *this;
+  }
+
+ private:
+  const uint8_t *data_;
+};
+
+template<typename Iterator>
+struct VectorReverseIterator : public std::reverse_iterator<Iterator> {
+  explicit VectorReverseIterator(Iterator iter)
+      : std::reverse_iterator<Iterator>(iter) {}
+
+  // Note: return type is incompatible with the standard
+  // `reference operator*()`.
+  typename Iterator::value_type operator*() const {
+    auto tmp = std::reverse_iterator<Iterator>::current;
+    return *--tmp;
+  }
+
+  // Note: return type is incompatible with the standard
+  // `pointer operator->()`.
+  typename Iterator::value_type operator->() const {
+    auto tmp = std::reverse_iterator<Iterator>::current;
+    return *--tmp;
+  }
+};
+
+// This is used as a helper type for accessing vectors.
+// Vector::data() assumes the vector elements start after the length field.
+template<typename T> class Vector {
+ public:
+  typedef VectorIterator<T, typename IndirectHelper<T>::mutable_return_type>
+      iterator;
+  typedef VectorIterator<T, typename IndirectHelper<T>::return_type>
+      const_iterator;
+  typedef VectorReverseIterator<iterator> reverse_iterator;
+  typedef VectorReverseIterator<const_iterator> const_reverse_iterator;
+
+  typedef typename flatbuffers::bool_constant<flatbuffers::is_scalar<T>::value>
+      scalar_tag;
+
+  static FLATBUFFERS_CONSTEXPR bool is_span_observable =
+      scalar_tag::value && (FLATBUFFERS_LITTLEENDIAN || sizeof(T) == 1);
+
+  uoffset_t size() const { return EndianScalar(length_); }
+
+  // Deprecated: use size(). Here for backwards compatibility.
+  FLATBUFFERS_ATTRIBUTE([[deprecated("use size() instead")]])
+  uoffset_t Length() const { return size(); }
+
+  typedef typename IndirectHelper<T>::return_type return_type;
+  typedef typename IndirectHelper<T>::mutable_return_type mutable_return_type;
+  typedef return_type value_type;
+
+  return_type Get(uoffset_t i) const {
+    FLATBUFFERS_ASSERT(i < size());
+    return IndirectHelper<T>::Read(Data(), i);
+  }
+
+  return_type operator[](uoffset_t i) const { return Get(i); }
+
+  // If this is a Vector of enums, T will be its storage type, not the enum
+  // type. This function makes it convenient to retrieve value with enum
+  // type E.
+  template<typename E> E GetEnum(uoffset_t i) const {
+    return static_cast<E>(Get(i));
+  }
+
+  // If this a vector of unions, this does the cast for you. There's no check
+  // to make sure this is the right type!
+  template<typename U> const U *GetAs(uoffset_t i) const {
+    return reinterpret_cast<const U *>(Get(i));
+  }
+
+  // If this a vector of unions, this does the cast for you. There's no check
+  // to make sure this is actually a string!
+  const String *GetAsString(uoffset_t i) const {
+    return reinterpret_cast<const String *>(Get(i));
+  }
+
+  const void *GetStructFromOffset(size_t o) const {
+    return reinterpret_cast<const void *>(Data() + o);
+  }
+
+  iterator begin() { return iterator(Data(), 0); }
+  const_iterator begin() const { return const_iterator(Data(), 0); }
+
+  iterator end() { return iterator(Data(), size()); }
+  const_iterator end() const { return const_iterator(Data(), size()); }
+
+  reverse_iterator rbegin() { return reverse_iterator(end()); }
+  const_reverse_iterator rbegin() const {
+    return const_reverse_iterator(end());
+  }
+
+  reverse_iterator rend() { return reverse_iterator(begin()); }
+  const_reverse_iterator rend() const {
+    return const_reverse_iterator(begin());
+  }
+
+  const_iterator cbegin() const { return begin(); }
+
+  const_iterator cend() const { return end(); }
+
+  const_reverse_iterator crbegin() const { return rbegin(); }
+
+  const_reverse_iterator crend() const { return rend(); }
+
+  // Change elements if you have a non-const pointer to this object.
+  // Scalars only. See reflection.h, and the documentation.
+  void Mutate(uoffset_t i, const T &val) {
+    FLATBUFFERS_ASSERT(i < size());
+    WriteScalar(data() + i, val);
+  }
+
+  // Change an element of a vector of tables (or strings).
+  // "val" points to the new table/string, as you can obtain from
+  // e.g. reflection::AddFlatBuffer().
+  void MutateOffset(uoffset_t i, const uint8_t *val) {
+    FLATBUFFERS_ASSERT(i < size());
+    static_assert(sizeof(T) == sizeof(uoffset_t), "Unrelated types");
+    WriteScalar(data() + i,
+                static_cast<uoffset_t>(val - (Data() + i * sizeof(uoffset_t))));
+  }
+
+  // Get a mutable pointer to tables/strings inside this vector.
+  mutable_return_type GetMutableObject(uoffset_t i) const {
+    FLATBUFFERS_ASSERT(i < size());
+    return const_cast<mutable_return_type>(IndirectHelper<T>::Read(Data(), i));
+  }
+
+  // The raw data in little endian format. Use with care.
+  const uint8_t *Data() const {
+    return reinterpret_cast<const uint8_t *>(&length_ + 1);
+  }
+
+  uint8_t *Data() { return reinterpret_cast<uint8_t *>(&length_ + 1); }
+
+  // Similarly, but typed, much like std::vector::data
+  const T *data() const { return reinterpret_cast<const T *>(Data()); }
+  T *data() { return reinterpret_cast<T *>(Data()); }
+
+  template<typename K> return_type LookupByKey(K key) const {
+    void *search_result = std::bsearch(
+        &key, Data(), size(), IndirectHelper<T>::element_stride, KeyCompare<K>);
+
+    if (!search_result) {
+      return nullptr;  // Key not found.
+    }
+
+    const uint8_t *element = reinterpret_cast<const uint8_t *>(search_result);
+
+    return IndirectHelper<T>::Read(element, 0);
+  }
+
+  template<typename K> mutable_return_type MutableLookupByKey(K key) {
+    return const_cast<mutable_return_type>(LookupByKey(key));
+  }
+
+ protected:
+  // This class is only used to access pre-existing data. Don't ever
+  // try to construct these manually.
+  Vector();
+
+  uoffset_t length_;
+
+ private:
+  // This class is a pointer. Copying will therefore create an invalid object.
+  // Private and unimplemented copy constructor.
+  Vector(const Vector &);
+  Vector &operator=(const Vector &);
+
+  template<typename K> static int KeyCompare(const void *ap, const void *bp) {
+    const K *key = reinterpret_cast<const K *>(ap);
+    const uint8_t *data = reinterpret_cast<const uint8_t *>(bp);
+    auto table = IndirectHelper<T>::Read(data, 0);
+
+    // std::bsearch compares with the operands transposed, so we negate the
+    // result here.
+    return -table->KeyCompareWithValue(*key);
+  }
+};
+
+template<class U>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<U> make_span(Vector<U> &vec)
+    FLATBUFFERS_NOEXCEPT {
+  static_assert(Vector<U>::is_span_observable,
+                "wrong type U, only LE-scalar, or byte types are allowed");
+  return span<U>(vec.data(), vec.size());
+}
+
+template<class U>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const U> make_span(
+    const Vector<U> &vec) FLATBUFFERS_NOEXCEPT {
+  static_assert(Vector<U>::is_span_observable,
+                "wrong type U, only LE-scalar, or byte types are allowed");
+  return span<const U>(vec.data(), vec.size());
+}
+
+template<class U>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<uint8_t> make_bytes_span(
+    Vector<U> &vec) FLATBUFFERS_NOEXCEPT {
+  static_assert(Vector<U>::scalar_tag::value,
+                "wrong type U, only LE-scalar, or byte types are allowed");
+  return span<uint8_t>(vec.Data(), vec.size() * sizeof(U));
+}
+
+template<class U>
+FLATBUFFERS_CONSTEXPR_CPP11 flatbuffers::span<const uint8_t> make_bytes_span(
+    const Vector<U> &vec) FLATBUFFERS_NOEXCEPT {
+  static_assert(Vector<U>::scalar_tag::value,
+                "wrong type U, only LE-scalar, or byte types are allowed");
+  return span<const uint8_t>(vec.Data(), vec.size() * sizeof(U));
+}
+
+// Represent a vector much like the template above, but in this case we
+// don't know what the element types are (used with reflection.h).
+class VectorOfAny {
+ public:
+  uoffset_t size() const { return EndianScalar(length_); }
+
+  const uint8_t *Data() const {
+    return reinterpret_cast<const uint8_t *>(&length_ + 1);
+  }
+  uint8_t *Data() { return reinterpret_cast<uint8_t *>(&length_ + 1); }
+
+ protected:
+  VectorOfAny();
+
+  uoffset_t length_;
+
+ private:
+  VectorOfAny(const VectorOfAny &);
+  VectorOfAny &operator=(const VectorOfAny &);
+};
+
+template<typename T, typename U>
+Vector<Offset<T>> *VectorCast(Vector<Offset<U>> *ptr) {
+  static_assert(std::is_base_of<T, U>::value, "Unrelated types");
+  return reinterpret_cast<Vector<Offset<T>> *>(ptr);
+}
+
+template<typename T, typename U>
+const Vector<Offset<T>> *VectorCast(const Vector<Offset<U>> *ptr) {
+  static_assert(std::is_base_of<T, U>::value, "Unrelated types");
+  return reinterpret_cast<const Vector<Offset<T>> *>(ptr);
+}
+
+// Convenient helper function to get the length of any vector, regardless
+// of whether it is null or not (the field is not set).
+template<typename T> static inline size_t VectorLength(const Vector<T> *v) {
+  return v ? v->size() : 0;
+}
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_VERIFIER_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/vector_downward.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/vector_downward.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/vector_downward.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/vector_downward.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,273 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_VECTOR_DOWNWARD_H_
+#define FLATBUFFERS_VECTOR_DOWNWARD_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/default_allocator.h"
+#include "flatbuffers/detached_buffer.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// This is a minimal replication of std::vector<uint8_t> functionality,
+// except growing from higher to lower addresses. i.e push_back() inserts data
+// in the lowest address in the vector.
+// Since this vector leaves the lower part unused, we support a "scratch-pad"
+// that can be stored there for temporary data, to share the allocated space.
+// Essentially, this supports 2 std::vectors in a single buffer.
+class vector_downward {
+ public:
+  explicit vector_downward(size_t initial_size, Allocator *allocator,
+                           bool own_allocator, size_t buffer_minalign)
+      : allocator_(allocator),
+        own_allocator_(own_allocator),
+        initial_size_(initial_size),
+        buffer_minalign_(buffer_minalign),
+        reserved_(0),
+        size_(0),
+        buf_(nullptr),
+        cur_(nullptr),
+        scratch_(nullptr) {}
+
+  vector_downward(vector_downward &&other)
+      // clang-format on
+      : allocator_(other.allocator_),
+        own_allocator_(other.own_allocator_),
+        initial_size_(other.initial_size_),
+        buffer_minalign_(other.buffer_minalign_),
+        reserved_(other.reserved_),
+        size_(other.size_),
+        buf_(other.buf_),
+        cur_(other.cur_),
+        scratch_(other.scratch_) {
+    // No change in other.allocator_
+    // No change in other.initial_size_
+    // No change in other.buffer_minalign_
+    other.own_allocator_ = false;
+    other.reserved_ = 0;
+    other.buf_ = nullptr;
+    other.cur_ = nullptr;
+    other.scratch_ = nullptr;
+  }
+
+  vector_downward &operator=(vector_downward &&other) {
+    // Move construct a temporary and swap idiom
+    vector_downward temp(std::move(other));
+    swap(temp);
+    return *this;
+  }
+
+  ~vector_downward() {
+    clear_buffer();
+    clear_allocator();
+  }
+
+  void reset() {
+    clear_buffer();
+    clear();
+  }
+
+  void clear() {
+    if (buf_) {
+      cur_ = buf_ + reserved_;
+    } else {
+      reserved_ = 0;
+      cur_ = nullptr;
+    }
+    size_ = 0;
+    clear_scratch();
+  }
+
+  void clear_scratch() { scratch_ = buf_; }
+
+  void clear_allocator() {
+    if (own_allocator_ && allocator_) { delete allocator_; }
+    allocator_ = nullptr;
+    own_allocator_ = false;
+  }
+
+  void clear_buffer() {
+    if (buf_) Deallocate(allocator_, buf_, reserved_);
+    buf_ = nullptr;
+  }
+
+  // Relinquish the pointer to the caller.
+  uint8_t *release_raw(size_t &allocated_bytes, size_t &offset) {
+    auto *buf = buf_;
+    allocated_bytes = reserved_;
+    offset = static_cast<size_t>(cur_ - buf_);
+
+    // release_raw only relinquishes the buffer ownership.
+    // Does not deallocate or reset the allocator. Destructor will do that.
+    buf_ = nullptr;
+    clear();
+    return buf;
+  }
+
+  // Relinquish the pointer to the caller.
+  DetachedBuffer release() {
+    // allocator ownership (if any) is transferred to DetachedBuffer.
+    DetachedBuffer fb(allocator_, own_allocator_, buf_, reserved_, cur_,
+                      size());
+    if (own_allocator_) {
+      allocator_ = nullptr;
+      own_allocator_ = false;
+    }
+    buf_ = nullptr;
+    clear();
+    return fb;
+  }
+
+  size_t ensure_space(size_t len) {
+    FLATBUFFERS_ASSERT(cur_ >= scratch_ && scratch_ >= buf_);
+    if (len > static_cast<size_t>(cur_ - scratch_)) { reallocate(len); }
+    // Beyond this, signed offsets may not have enough range:
+    // (FlatBuffers > 2GB not supported).
+    FLATBUFFERS_ASSERT(size() < FLATBUFFERS_MAX_BUFFER_SIZE);
+    return len;
+  }
+
+  inline uint8_t *make_space(size_t len) {
+    if (len) {
+      ensure_space(len);
+      cur_ -= len;
+      size_ += static_cast<uoffset_t>(len);
+    }
+    return cur_;
+  }
+
+  // Returns nullptr if using the DefaultAllocator.
+  Allocator *get_custom_allocator() { return allocator_; }
+
+  inline uoffset_t size() const { return size_; }
+
+  uoffset_t scratch_size() const {
+    return static_cast<uoffset_t>(scratch_ - buf_);
+  }
+
+  size_t capacity() const { return reserved_; }
+
+  uint8_t *data() const {
+    FLATBUFFERS_ASSERT(cur_);
+    return cur_;
+  }
+
+  uint8_t *scratch_data() const {
+    FLATBUFFERS_ASSERT(buf_);
+    return buf_;
+  }
+
+  uint8_t *scratch_end() const {
+    FLATBUFFERS_ASSERT(scratch_);
+    return scratch_;
+  }
+
+  uint8_t *data_at(size_t offset) const { return buf_ + reserved_ - offset; }
+
+  void push(const uint8_t *bytes, size_t num) {
+    if (num > 0) { memcpy(make_space(num), bytes, num); }
+  }
+
+  // Specialized version of push() that avoids memcpy call for small data.
+  template<typename T> void push_small(const T &little_endian_t) {
+    make_space(sizeof(T));
+    *reinterpret_cast<T *>(cur_) = little_endian_t;
+  }
+
+  template<typename T> void scratch_push_small(const T &t) {
+    ensure_space(sizeof(T));
+    *reinterpret_cast<T *>(scratch_) = t;
+    scratch_ += sizeof(T);
+  }
+
+  // fill() is most frequently called with small byte counts (<= 4),
+  // which is why we're using loops rather than calling memset.
+  void fill(size_t zero_pad_bytes) {
+    make_space(zero_pad_bytes);
+    for (size_t i = 0; i < zero_pad_bytes; i++) cur_[i] = 0;
+  }
+
+  // Version for when we know the size is larger.
+  // Precondition: zero_pad_bytes > 0
+  void fill_big(size_t zero_pad_bytes) {
+    memset(make_space(zero_pad_bytes), 0, zero_pad_bytes);
+  }
+
+  void pop(size_t bytes_to_remove) {
+    cur_ += bytes_to_remove;
+    size_ -= static_cast<uoffset_t>(bytes_to_remove);
+  }
+
+  void scratch_pop(size_t bytes_to_remove) { scratch_ -= bytes_to_remove; }
+
+  void swap(vector_downward &other) {
+    using std::swap;
+    swap(allocator_, other.allocator_);
+    swap(own_allocator_, other.own_allocator_);
+    swap(initial_size_, other.initial_size_);
+    swap(buffer_minalign_, other.buffer_minalign_);
+    swap(reserved_, other.reserved_);
+    swap(size_, other.size_);
+    swap(buf_, other.buf_);
+    swap(cur_, other.cur_);
+    swap(scratch_, other.scratch_);
+  }
+
+  void swap_allocator(vector_downward &other) {
+    using std::swap;
+    swap(allocator_, other.allocator_);
+    swap(own_allocator_, other.own_allocator_);
+  }
+
+ private:
+  // You shouldn't really be copying instances of this class.
+  FLATBUFFERS_DELETE_FUNC(vector_downward(const vector_downward &));
+  FLATBUFFERS_DELETE_FUNC(vector_downward &operator=(const vector_downward &));
+
+  Allocator *allocator_;
+  bool own_allocator_;
+  size_t initial_size_;
+  size_t buffer_minalign_;
+  size_t reserved_;
+  uoffset_t size_;
+  uint8_t *buf_;
+  uint8_t *cur_;  // Points at location between empty (below) and used (above).
+  uint8_t *scratch_;  // Points to the end of the scratchpad in use.
+
+  void reallocate(size_t len) {
+    auto old_reserved = reserved_;
+    auto old_size = size();
+    auto old_scratch_size = scratch_size();
+    reserved_ +=
+        (std::max)(len, old_reserved ? old_reserved / 2 : initial_size_);
+    reserved_ = (reserved_ + buffer_minalign_ - 1) & ~(buffer_minalign_ - 1);
+    if (buf_) {
+      buf_ = ReallocateDownward(allocator_, buf_, old_reserved, reserved_,
+                                old_size, old_scratch_size);
+    } else {
+      buf_ = Allocate(allocator_, reserved_);
+    }
+    cur_ = buf_ + reserved_ - old_size;
+    scratch_ = buf_ + old_scratch_size;
+  }
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_VECTOR_DOWNWARD_H_
diff -pruN 8.0.1-5/src/flatgeobuf/include/flatbuffers/verifier.h 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/verifier.h
--- 8.0.1-5/src/flatgeobuf/include/flatbuffers/verifier.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/include/flatbuffers/verifier.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,284 @@
+/*
+ * Copyright 2021 Google Inc. All rights reserved.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef FLATBUFFERS_VERIFIER_H_
+#define FLATBUFFERS_VERIFIER_H_
+
+#include "flatbuffers/base.h"
+#include "flatbuffers/vector.h"
+
+namespace mapserver {
+namespace flatbuffers {
+
+// Helper class to verify the integrity of a FlatBuffer
+class Verifier FLATBUFFERS_FINAL_CLASS {
+ public:
+  Verifier(const uint8_t *buf, size_t buf_len, uoffset_t _max_depth = 64,
+           uoffset_t _max_tables = 1000000, bool _check_alignment = true)
+      : buf_(buf),
+        size_(buf_len),
+        depth_(0),
+        max_depth_(_max_depth),
+        num_tables_(0),
+        max_tables_(_max_tables),
+        upper_bound_(0),
+        check_alignment_(_check_alignment),
+        flex_reuse_tracker_(nullptr) {
+    FLATBUFFERS_ASSERT(size_ < FLATBUFFERS_MAX_BUFFER_SIZE);
+  }
+
+  // Central location where any verification failures register.
+  bool Check(bool ok) const {
+    // clang-format off
+    #ifdef FLATBUFFERS_DEBUG_VERIFICATION_FAILURE
+      FLATBUFFERS_ASSERT(ok);
+    #endif
+    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
+      if (!ok)
+        upper_bound_ = 0;
+    #endif
+    // clang-format on
+    return ok;
+  }
+
+  // Verify any range within the buffer.
+  bool Verify(size_t elem, size_t elem_len) const {
+    // clang-format off
+    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
+      auto upper_bound = elem + elem_len;
+      if (upper_bound_ < upper_bound)
+        upper_bound_ =  upper_bound;
+    #endif
+    // clang-format on
+    return Check(elem_len < size_ && elem <= size_ - elem_len);
+  }
+
+  bool VerifyAlignment(size_t elem, size_t align) const {
+    return Check((elem & (align - 1)) == 0 || !check_alignment_);
+  }
+
+  // Verify a range indicated by sizeof(T).
+  template<typename T> bool Verify(size_t elem) const {
+    return VerifyAlignment(elem, sizeof(T)) && Verify(elem, sizeof(T));
+  }
+
+  bool VerifyFromPointer(const uint8_t *p, size_t len) {
+    auto o = static_cast<size_t>(p - buf_);
+    return Verify(o, len);
+  }
+
+  // Verify relative to a known-good base pointer.
+  bool VerifyFieldStruct(const uint8_t *base, voffset_t elem_off,
+                         size_t elem_len, size_t align) const {
+    auto f = static_cast<size_t>(base - buf_) + elem_off;
+    return VerifyAlignment(f, align) && Verify(f, elem_len);
+  }
+
+  template<typename T>
+  bool VerifyField(const uint8_t *base, voffset_t elem_off,
+                   size_t align) const {
+    auto f = static_cast<size_t>(base - buf_) + elem_off;
+    return VerifyAlignment(f, align) && Verify(f, sizeof(T));
+  }
+
+  // Verify a pointer (may be NULL) of a table type.
+  template<typename T> bool VerifyTable(const T *table) {
+    return !table || table->Verify(*this);
+  }
+
+  // Verify a pointer (may be NULL) of any vector type.
+  template<typename T> bool VerifyVector(const Vector<T> *vec) const {
+    return !vec || VerifyVectorOrString(reinterpret_cast<const uint8_t *>(vec),
+                                        sizeof(T));
+  }
+
+  // Verify a pointer (may be NULL) of a vector to struct.
+  template<typename T> bool VerifyVector(const Vector<const T *> *vec) const {
+    return VerifyVector(reinterpret_cast<const Vector<T> *>(vec));
+  }
+
+  // Verify a pointer (may be NULL) to string.
+  bool VerifyString(const String *str) const {
+    size_t end;
+    return !str || (VerifyVectorOrString(reinterpret_cast<const uint8_t *>(str),
+                                         1, &end) &&
+                    Verify(end, 1) &&           // Must have terminator
+                    Check(buf_[end] == '\0'));  // Terminating byte must be 0.
+  }
+
+  // Common code between vectors and strings.
+  bool VerifyVectorOrString(const uint8_t *vec, size_t elem_size,
+                            size_t *end = nullptr) const {
+    auto veco = static_cast<size_t>(vec - buf_);
+    // Check we can read the size field.
+    if (!Verify<uoffset_t>(veco)) return false;
+    // Check the whole array. If this is a string, the byte past the array
+    // must be 0.
+    auto size = ReadScalar<uoffset_t>(vec);
+    auto max_elems = FLATBUFFERS_MAX_BUFFER_SIZE / elem_size;
+    if (!Check(size < max_elems))
+      return false;  // Protect against byte_size overflowing.
+    auto byte_size = sizeof(size) + elem_size * size;
+    if (end) *end = veco + byte_size;
+    return Verify(veco, byte_size);
+  }
+
+  // Special case for string contents, after the above has been called.
+  bool VerifyVectorOfStrings(const Vector<Offset<String>> *vec) const {
+    if (vec) {
+      for (uoffset_t i = 0; i < vec->size(); i++) {
+        if (!VerifyString(vec->Get(i))) return false;
+      }
+    }
+    return true;
+  }
+
+  // Special case for table contents, after the above has been called.
+  template<typename T> bool VerifyVectorOfTables(const Vector<Offset<T>> *vec) {
+    if (vec) {
+      for (uoffset_t i = 0; i < vec->size(); i++) {
+        if (!vec->Get(i)->Verify(*this)) return false;
+      }
+    }
+    return true;
+  }
+
+  __supress_ubsan__("unsigned-integer-overflow") bool VerifyTableStart(
+      const uint8_t *table) {
+    // Check the vtable offset.
+    auto tableo = static_cast<size_t>(table - buf_);
+    if (!Verify<soffset_t>(tableo)) return false;
+    // This offset may be signed, but doing the subtraction unsigned always
+    // gives the result we want.
+    auto vtableo = tableo - static_cast<size_t>(ReadScalar<soffset_t>(table));
+    // Check the vtable size field, then check vtable fits in its entirety.
+    return VerifyComplexity() && Verify<voffset_t>(vtableo) &&
+           VerifyAlignment(ReadScalar<voffset_t>(buf_ + vtableo),
+                           sizeof(voffset_t)) &&
+           Verify(vtableo, ReadScalar<voffset_t>(buf_ + vtableo));
+  }
+
+  template<typename T>
+  bool VerifyBufferFromStart(const char *identifier, size_t start) {
+    if (identifier && !Check((size_ >= 2 * sizeof(flatbuffers::uoffset_t) &&
+                              BufferHasIdentifier(buf_ + start, identifier)))) {
+      return false;
+    }
+
+    // Call T::Verify, which must be in the generated code for this type.
+    auto o = VerifyOffset(start);
+    return o && reinterpret_cast<const T *>(buf_ + start + o)->Verify(*this)
+    // clang-format off
+    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
+           && GetComputedSize()
+    #endif
+        ;
+    // clang-format on
+  }
+
+  template<typename T>
+  bool VerifyNestedFlatBuffer(const Vector<uint8_t> *buf,
+                              const char *identifier) {
+    if (!buf) return true;
+    Verifier nested_verifier(buf->data(), buf->size());
+    return nested_verifier.VerifyBuffer<T>(identifier);
+  }
+
+  // Verify this whole buffer, starting with root type T.
+  template<typename T> bool VerifyBuffer() { return VerifyBuffer<T>(nullptr); }
+
+  template<typename T> bool VerifyBuffer(const char *identifier) {
+    return VerifyBufferFromStart<T>(identifier, 0);
+  }
+
+  template<typename T> bool VerifySizePrefixedBuffer(const char *identifier) {
+    return Verify<uoffset_t>(0U) &&
+           ReadScalar<uoffset_t>(buf_) == size_ - sizeof(uoffset_t) &&
+           VerifyBufferFromStart<T>(identifier, sizeof(uoffset_t));
+  }
+
+  uoffset_t VerifyOffset(size_t start) const {
+    if (!Verify<uoffset_t>(start)) return 0;
+    auto o = ReadScalar<uoffset_t>(buf_ + start);
+    // May not point to itself.
+    if (!Check(o != 0)) return 0;
+    // Can't wrap around / buffers are max 2GB.
+    if (!Check(static_cast<soffset_t>(o) >= 0)) return 0;
+    // Must be inside the buffer to create a pointer from it (pointer outside
+    // buffer is UB).
+    if (!Verify(start + o, 1)) return 0;
+    return o;
+  }
+
+  uoffset_t VerifyOffset(const uint8_t *base, voffset_t start) const {
+    return VerifyOffset(static_cast<size_t>(base - buf_) + start);
+  }
+
+  // Called at the start of a table to increase counters measuring data
+  // structure depth and amount, and possibly bails out with false if
+  // limits set by the constructor have been hit. Needs to be balanced
+  // with EndTable().
+  bool VerifyComplexity() {
+    depth_++;
+    num_tables_++;
+    return Check(depth_ <= max_depth_ && num_tables_ <= max_tables_);
+  }
+
+  // Called at the end of a table to pop the depth count.
+  bool EndTable() {
+    depth_--;
+    return true;
+  }
+
+  // Returns the message size in bytes
+  size_t GetComputedSize() const {
+    // clang-format off
+    #ifdef FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE
+      uintptr_t size = upper_bound_;
+      // Align the size to uoffset_t
+      size = (size - 1 + sizeof(uoffset_t)) & ~(sizeof(uoffset_t) - 1);
+      return (size > size_) ?  0 : size;
+    #else
+      // Must turn on FLATBUFFERS_TRACK_VERIFIER_BUFFER_SIZE for this to work.
+      (void)upper_bound_;
+      FLATBUFFERS_ASSERT(false);
+      return 0;
+    #endif
+    // clang-format on
+  }
+
+  std::vector<uint8_t> *GetFlexReuseTracker() { return flex_reuse_tracker_; }
+
+  void SetFlexReuseTracker(std::vector<uint8_t> *rt) {
+    flex_reuse_tracker_ = rt;
+  }
+
+ private:
+  const uint8_t *buf_;
+  size_t size_;
+  uoffset_t depth_;
+  uoffset_t max_depth_;
+  uoffset_t num_tables_;
+  uoffset_t max_tables_;
+  mutable size_t upper_bound_;
+  bool check_alignment_;
+  std::vector<uint8_t> *flex_reuse_tracker_;
+};
+
+}  // namespace flatbuffers
+}  // namespace mapserver
+
+#endif  // FLATBUFFERS_VERIFIER_H_
diff -pruN 8.0.1-5/src/flatgeobuf/packedrtree.cpp 8.2.0~beta1-1~exp1/src/flatgeobuf/packedrtree.cpp
--- 8.0.1-5/src/flatgeobuf/packedrtree.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/packedrtree.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,413 @@
+/******************************************************************************
+ *
+ * Project:  FlatGeobuf
+ * Purpose:  Packed RTree management
+ * Author:   Björn Harrtell <bjorn at wololo dot org>
+ *
+ ******************************************************************************
+ * Copyright (c) 2018-2020, Björn Harrtell <bjorn at wololo dot org>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included
+ * in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+// NOTE: The upstream of this file is in https://github.com/bjornharrtell/flatgeobuf/tree/master/src/cpp
+
+#ifdef GDAL_COMPILATION
+#include "cpl_port.h"
+#else
+#define CPL_IS_LSB 1
+#endif
+
+#include "packedrtree.h"
+
+#include <map>
+#include <unordered_map>
+#include <iostream>
+
+namespace mapserver
+{
+namespace FlatGeobuf
+{
+
+const NodeItem &NodeItem::expand(const NodeItem &r)
+{
+    if (r.minX < minX) minX = r.minX;
+    if (r.minY < minY) minY = r.minY;
+    if (r.maxX > maxX) maxX = r.maxX;
+    if (r.maxY > maxY) maxY = r.maxY;
+    return *this;
+}
+
+NodeItem NodeItem::create(uint64_t offset)
+{
+    return {
+        std::numeric_limits<double>::infinity(),
+        std::numeric_limits<double>::infinity(),
+        -1 * std::numeric_limits<double>::infinity(),
+        -1 * std::numeric_limits<double>::infinity(),
+        offset
+    };
+}
+
+bool NodeItem::intersects(const NodeItem &r) const
+{
+    if (maxX < r.minX) return false;
+    if (maxY < r.minY) return false;
+    if (minX > r.maxX) return false;
+    if (minY > r.maxY) return false;
+    return true;
+}
+
+std::vector<double> NodeItem::toVector()
+{
+    return std::vector<double> { minX, minY, maxX, maxY };
+}
+
+// Based on public domain code at https://github.com/rawrunprotected/hilbert_curves
+uint32_t hilbert(uint32_t x, uint32_t y)
+{
+    uint32_t a = x ^ y;
+    uint32_t b = 0xFFFF ^ a;
+    uint32_t c = 0xFFFF ^ (x | y);
+    uint32_t d = x & (y ^ 0xFFFF);
+
+    uint32_t A = a | (b >> 1);
+    uint32_t B = (a >> 1) ^ a;
+    uint32_t C = ((c >> 1) ^ (b & (d >> 1))) ^ c;
+    uint32_t D = ((a & (c >> 1)) ^ (d >> 1)) ^ d;
+
+    a = A; b = B; c = C; d = D;
+    A = ((a & (a >> 2)) ^ (b & (b >> 2)));
+    B = ((a & (b >> 2)) ^ (b & ((a ^ b) >> 2)));
+    C ^= ((a & (c >> 2)) ^ (b & (d >> 2)));
+    D ^= ((b & (c >> 2)) ^ ((a ^ b) & (d >> 2)));
+
+    a = A; b = B; c = C; d = D;
+    A = ((a & (a >> 4)) ^ (b & (b >> 4)));
+    B = ((a & (b >> 4)) ^ (b & ((a ^ b) >> 4)));
+    C ^= ((a & (c >> 4)) ^ (b & (d >> 4)));
+    D ^= ((b & (c >> 4)) ^ ((a ^ b) & (d >> 4)));
+
+    a = A; b = B; c = C; d = D;
+    C ^= ((a & (c >> 8)) ^ (b & (d >> 8)));
+    D ^= ((b & (c >> 8)) ^ ((a ^ b) & (d >> 8)));
+
+    a = C ^ (C >> 1);
+    b = D ^ (D >> 1);
+
+    uint32_t i0 = x ^ y;
+    uint32_t i1 = b | (0xFFFF ^ (i0 | a));
+
+    i0 = (i0 | (i0 << 8)) & 0x00FF00FF;
+    i0 = (i0 | (i0 << 4)) & 0x0F0F0F0F;
+    i0 = (i0 | (i0 << 2)) & 0x33333333;
+    i0 = (i0 | (i0 << 1)) & 0x55555555;
+
+    i1 = (i1 | (i1 << 8)) & 0x00FF00FF;
+    i1 = (i1 | (i1 << 4)) & 0x0F0F0F0F;
+    i1 = (i1 | (i1 << 2)) & 0x33333333;
+    i1 = (i1 | (i1 << 1)) & 0x55555555;
+
+    uint32_t value = ((i1 << 1) | i0);
+
+    return value;
+}
+
+uint32_t hilbert(const NodeItem &r, uint32_t hilbertMax, const double minX, const double minY, const double width, const double height)
+{
+    uint32_t x = 0;
+    uint32_t y = 0;
+    uint32_t v;
+    if (width != 0.0)
+        x = static_cast<uint32_t>(floor(hilbertMax * ((r.minX + r.maxX) / 2 - minX) / width));
+    if (height != 0.0)
+        y = static_cast<uint32_t>(floor(hilbertMax * ((r.minY + r.maxY) / 2 - minY) / height));
+    v = hilbert(x, y);
+    return v;
+}
+
+const uint32_t hilbertMax = (1 << 16) - 1;
+
+void hilbertSort(std::vector<std::shared_ptr<Item>> &items)
+{
+    NodeItem extent = calcExtent(items);
+    const double minX = extent.minX;
+    const double minY = extent.minY;
+    const double width = extent.width();
+    const double height = extent.height();
+    std::sort(items.begin(), items.end(), [minX, minY, width, height] (std::shared_ptr<Item> a, std::shared_ptr<Item> b) {
+        uint32_t ha = hilbert(a->nodeItem, hilbertMax, minX, minY, width, height);
+        uint32_t hb = hilbert(b->nodeItem, hilbertMax, minX, minY, width, height);
+        return ha > hb;
+    });
+}
+
+void hilbertSort(std::vector<NodeItem> &items)
+{
+    NodeItem extent = calcExtent(items);
+    const double minX = extent.minX;
+    const double minY = extent.minY;
+    const double width = extent.width();
+    const double height = extent.height();
+    std::sort(items.begin(), items.end(), [minX, minY, width, height] (const NodeItem &a, const NodeItem &b) {
+        uint32_t ha = hilbert(a, hilbertMax, minX, minY, width, height);
+        uint32_t hb = hilbert(b, hilbertMax, minX, minY, width, height);
+        return ha > hb;
+    });
+}
+
+NodeItem calcExtent(const std::vector<std::shared_ptr<Item>> &items)
+{
+    return std::accumulate(items.begin(), items.end(), NodeItem::create(0), [] (NodeItem a, const std::shared_ptr<Item>& b) {
+        return a.expand(b->nodeItem);
+    });
+}
+
+NodeItem calcExtent(const std::vector<NodeItem> &nodes)
+{
+    return std::accumulate(nodes.begin(), nodes.end(), NodeItem::create(0), [] (NodeItem a, const NodeItem &b) {
+        return a.expand(b);
+    });
+}
+
+void PackedRTree::init(const uint16_t nodeSize)
+{
+    if (nodeSize < 2)
+        throw std::invalid_argument("Node size must be at least 2");
+    if (_numItems == 0)
+        throw std::invalid_argument("Cannot create empty tree");
+    _nodeSize = std::min(std::max(nodeSize, static_cast<uint16_t>(2)), static_cast<uint16_t>(65535));
+    _levelBounds = generateLevelBounds(_numItems, _nodeSize);
+    _numNodes = _levelBounds.front().second;
+    _nodeItems = new NodeItem[static_cast<size_t>(_numNodes)];
+}
+
+std::vector<std::pair<uint64_t, uint64_t>> PackedRTree::generateLevelBounds(const uint64_t numItems, const uint16_t nodeSize) {
+    if (nodeSize < 2)
+        throw std::invalid_argument("Node size must be at least 2");
+    if (numItems == 0)
+        throw std::invalid_argument("Number of items must be greater than 0");
+    if (numItems > std::numeric_limits<uint64_t>::max() - ((numItems / nodeSize) * 2))
+        throw std::overflow_error("Number of items too large");
+
+    // number of nodes per level in bottom-up order
+    std::vector<uint64_t> levelNumNodes;
+    uint64_t n = numItems;
+    uint64_t numNodes = n;
+    levelNumNodes.push_back(n);
+    do {
+        n = (n + nodeSize - 1) / nodeSize;
+        numNodes += n;
+        levelNumNodes.push_back(n);
+    } while (n != 1);
+
+    // bounds per level in reversed storage order (top-down)
+    std::vector<uint64_t> levelOffsets;
+    n = numNodes;
+    for (auto size : levelNumNodes)
+        levelOffsets.push_back(n -= size);
+    std::reverse(levelOffsets.begin(), levelOffsets.end());
+    std::reverse(levelNumNodes.begin(), levelNumNodes.end());
+    std::vector<std::pair<uint64_t, uint64_t>> levelBounds;
+    for (size_t i = 0; i < levelNumNodes.size(); i++)
+        levelBounds.push_back(std::pair<uint64_t, uint64_t>(levelOffsets[i], levelOffsets[i] + levelNumNodes[i]));
+    std::reverse(levelBounds.begin(), levelBounds.end());
+    return levelBounds;
+}
+
+void PackedRTree::generateNodes()
+{
+    for (uint32_t i = 0; i < _levelBounds.size() - 1; i++) {
+        auto pos = _levelBounds[i].first;
+        auto end = _levelBounds[i].second;
+        auto newpos = _levelBounds[i + 1].first;
+        while (pos < end) {
+            NodeItem node = NodeItem::create(pos);
+            for (uint32_t j = 0; j < _nodeSize && pos < end; j++)
+                node.expand(_nodeItems[pos++]);
+            _nodeItems[newpos++] = node;
+        }
+    }
+}
+
+void PackedRTree::fromData(const void *data)
+{
+    auto buf = reinterpret_cast<const uint8_t *>(data);
+    const NodeItem *pn = reinterpret_cast<const NodeItem *>(buf);
+    for (uint64_t i = 0; i < _numNodes; i++) {
+        NodeItem n = *pn++;
+        _nodeItems[i] = n;
+        _extent.expand(n);
+    }
+}
+
+PackedRTree::PackedRTree(const std::vector<std::shared_ptr<Item>> &items, const NodeItem &extent, const uint16_t nodeSize) :
+    _extent(extent),
+    _numItems(items.size())
+{
+    init(nodeSize);
+    for (size_t i = 0; i < _numItems; i++)
+        _nodeItems[_numNodes - _numItems + i] = items[i]->nodeItem;
+    generateNodes();
+}
+
+PackedRTree::PackedRTree(const std::vector<NodeItem> &nodes, const NodeItem &extent, const uint16_t nodeSize) :
+    _extent(extent),
+    _numItems(nodes.size())
+{
+    init(nodeSize);
+    for (size_t i = 0; i < _numItems; i++)
+        _nodeItems[_numNodes - _numItems + i] = nodes[i];
+    generateNodes();
+}
+
+PackedRTree::PackedRTree(const void *data, const uint64_t numItems, const uint16_t nodeSize) :
+    _extent(NodeItem::create(0)),
+    _numItems(numItems)
+{
+    init(nodeSize);
+    fromData(data);
+}
+
+std::vector<SearchResultItem> PackedRTree::search(double minX, double minY, double maxX, double maxY) const
+{
+    uint64_t leafNodesOffset = _levelBounds.front().first;
+    NodeItem n { minX, minY, maxX, maxY, 0 };
+    std::vector<SearchResultItem> results;
+    std::unordered_map<uint64_t, uint64_t> queue;
+    queue.insert(std::pair<uint64_t, uint64_t>(0, _levelBounds.size() - 1));
+    while(queue.size() != 0) {
+        auto next = queue.begin();
+        uint64_t nodeIndex = next->first;
+        uint64_t level = next->second;
+        queue.erase(next);
+        bool isLeafNode = nodeIndex >= _numNodes - _numItems;
+        // find the end index of the node
+        uint64_t end = std::min(static_cast<uint64_t>(nodeIndex + _nodeSize), _levelBounds[static_cast<size_t>(level)].second);
+        // search through child nodes
+        for (uint64_t pos = nodeIndex; pos < end; pos++) {
+            auto nodeItem = _nodeItems[static_cast<size_t>(pos)];
+            if (!n.intersects(nodeItem))
+                continue;
+            if (isLeafNode)
+                results.push_back({ nodeItem.offset, pos - leafNodesOffset });
+            else
+                queue.insert(std::pair<uint64_t, uint64_t>(nodeItem.offset, level - 1));
+        }
+    }
+    return results;
+}
+
+std::vector<SearchResultItem> PackedRTree::streamSearch(
+    const uint64_t numItems, const uint16_t nodeSize, const NodeItem &item,
+    const std::function<void(uint8_t *, size_t, size_t)> &readNode)
+{
+    auto levelBounds = generateLevelBounds(numItems, nodeSize);
+    uint64_t leafNodesOffset = levelBounds.front().first;
+    uint64_t numNodes = levelBounds.front().second;
+    auto nodeItems = std::vector<NodeItem>(nodeSize);
+    uint8_t *nodesBuf = reinterpret_cast<uint8_t *>(nodeItems.data());
+    // use ordered search queue to make index traversal in sequential order
+    std::map<uint64_t, uint64_t> queue;
+    std::vector<SearchResultItem> results;
+    queue.insert(std::pair<uint64_t, uint64_t>(0, levelBounds.size() - 1));
+    while(queue.size() != 0) {
+        auto next = queue.begin();
+        uint64_t nodeIndex = next->first;
+        uint64_t level = next->second;
+        queue.erase(next);
+        bool isLeafNode = nodeIndex >= numNodes - numItems;
+        // find the end index of the node
+        uint64_t end = std::min(static_cast<uint64_t>(nodeIndex + nodeSize), levelBounds[static_cast<size_t>(level)].second);
+        uint64_t length = end - nodeIndex;
+        readNode(nodesBuf, static_cast<size_t>(nodeIndex * sizeof(NodeItem)), static_cast<size_t>(length * sizeof(NodeItem)));
+#if !CPL_IS_LSB
+        for( size_t i = 0; i < static_cast<size_t>(length); i++ )
+        {
+            CPL_LSBPTR64(&nodeItems[i].minX);
+            CPL_LSBPTR64(&nodeItems[i].minY);
+            CPL_LSBPTR64(&nodeItems[i].maxX);
+            CPL_LSBPTR64(&nodeItems[i].maxY);
+            CPL_LSBPTR64(&nodeItems[i].offset);
+        }
+#endif
+        // search through child nodes
+        for (uint64_t pos = nodeIndex; pos < end; pos++) {
+            uint64_t nodePos = pos - nodeIndex;
+            auto nodeItem = nodeItems[static_cast<size_t>(nodePos)];
+            if (!item.intersects(nodeItem))
+                continue;
+            if (isLeafNode)
+                results.push_back({ nodeItem.offset, pos - leafNodesOffset });
+            else
+                queue.insert(std::pair<uint64_t, uint64_t>(nodeItem.offset, level - 1));
+        }
+    }
+    return results;
+}
+
+uint64_t PackedRTree::size() const { return _numNodes * sizeof(NodeItem); }
+
+uint64_t PackedRTree::size(const uint64_t numItems, const uint16_t nodeSize)
+{
+    if (nodeSize < 2)
+        throw std::invalid_argument("Node size must be at least 2");
+    if (numItems == 0)
+        throw std::invalid_argument("Number of items must be greater than 0");
+    const uint16_t nodeSizeMin = std::min(std::max(nodeSize, static_cast<uint16_t>(2)), static_cast<uint16_t>(65535));
+    // limit so that resulting size in bytes can be represented by uint64_t
+    if (numItems > static_cast<uint64_t>(1) << 56)
+        throw std::overflow_error("Number of items must be less than 2^56");
+    uint64_t n = numItems;
+    uint64_t numNodes = n;
+    do {
+        n = (n + nodeSizeMin - 1) / nodeSizeMin;
+        numNodes += n;
+    } while (n != 1);
+    return numNodes * sizeof(NodeItem);
+}
+
+void PackedRTree::streamWrite(const std::function<void(uint8_t *, size_t)> &writeData) {
+#if !CPL_IS_LSB
+    for( size_t i = 0; i < static_cast<size_t>(_numNodes); i++ )
+    {
+        CPL_LSBPTR64(&_nodeItems[i].minX);
+        CPL_LSBPTR64(&_nodeItems[i].minY);
+        CPL_LSBPTR64(&_nodeItems[i].maxX);
+        CPL_LSBPTR64(&_nodeItems[i].maxY);
+        CPL_LSBPTR64(&_nodeItems[i].offset);
+    }
+#endif
+    writeData(reinterpret_cast<uint8_t *>(_nodeItems), static_cast<size_t>(_numNodes * sizeof(NodeItem)));
+#if !CPL_IS_LSB
+    for( size_t i = 0; i < static_cast<size_t>(_numNodes); i++ )
+    {
+        CPL_LSBPTR64(&_nodeItems[i].minX);
+        CPL_LSBPTR64(&_nodeItems[i].minY);
+        CPL_LSBPTR64(&_nodeItems[i].maxX);
+        CPL_LSBPTR64(&_nodeItems[i].maxY);
+        CPL_LSBPTR64(&_nodeItems[i].offset);
+    }
+#endif
+}
+
+NodeItem PackedRTree::getExtent() const { return _extent; }
+
+}
+}
\ No newline at end of file
diff -pruN 8.0.1-5/src/flatgeobuf/packedrtree.h 8.2.0~beta1-1~exp1/src/flatgeobuf/packedrtree.h
--- 8.0.1-5/src/flatgeobuf/packedrtree.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/flatgeobuf/packedrtree.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,113 @@
+/******************************************************************************
+ *
+ * Project:  FlatGeobuf
+ * Purpose:  Packed RTree management
+ * Author:   Björn Harrtell <bjorn at wololo dot org>
+ *
+ ******************************************************************************
+ * Copyright (c) 2018-2020, Björn Harrtell <bjorn at wololo dot org>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included
+ * in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+// NOTE: The upstream of this file is in https://github.com/bjornharrtell/flatgeobuf/tree/master/src/cpp
+
+#ifndef FLATGEOBUF_PACKEDRTREE_H_
+#define FLATGEOBUF_PACKEDRTREE_H_
+
+#include <cmath>
+#include <numeric>
+
+#include "flatbuffers/flatbuffers.h"
+
+namespace mapserver {
+namespace FlatGeobuf {
+
+struct NodeItem {
+    double minX;
+    double minY;
+    double maxX;
+    double maxY;
+    uint64_t offset;
+    double width() const { return maxX - minX; }
+    double height() const { return maxY - minY; }
+    static NodeItem sum(NodeItem a, const NodeItem &b) {
+        a.expand(b);
+        return a;
+    }
+    static NodeItem create(uint64_t offset = 0);
+    const NodeItem &expand(const NodeItem &r);
+    bool intersects(const NodeItem &r) const;
+    std::vector<double> toVector();
+};
+
+struct Item {
+    NodeItem nodeItem;
+};
+
+struct SearchResultItem {
+    uint64_t offset;
+    uint64_t index;
+};
+
+std::ostream& operator << (std::ostream& os, NodeItem const& value);
+
+uint32_t hilbert(uint32_t x, uint32_t y);
+uint32_t hilbert(const NodeItem &n, uint32_t hilbertMax, const double minX, const double minY, const double width, const double height);
+void hilbertSort(std::vector<std::shared_ptr<Item>> &items);
+void hilbertSort(std::vector<NodeItem> &items);
+NodeItem calcExtent(const std::vector<std::shared_ptr<Item>> &items);
+NodeItem calcExtent(const std::vector<NodeItem> &rects);
+
+/**
+ * Packed R-Tree
+ * Based on https://github.com/mourner/flatbush
+ */
+class PackedRTree {
+    NodeItem _extent;
+    NodeItem *_nodeItems = nullptr;
+    uint64_t _numItems;
+    uint64_t _numNodes;
+    uint16_t _nodeSize;
+    std::vector<std::pair<uint64_t, uint64_t>> _levelBounds;
+    void init(const uint16_t nodeSize);
+    void generateNodes();
+    void fromData(const void *data);
+public:
+    ~PackedRTree() {
+        if (_nodeItems != nullptr)
+            delete[] _nodeItems;
+    }
+    PackedRTree(const std::vector<std::shared_ptr<Item>> &items, const NodeItem &extent, const uint16_t nodeSize = 16);
+    PackedRTree(const std::vector<NodeItem> &nodes, const NodeItem &extent, const uint16_t nodeSize = 16);
+    PackedRTree(const void *data, const uint64_t numItems, const uint16_t nodeSize = 16);
+    std::vector<SearchResultItem> search(double minX, double minY, double maxX, double maxY) const;
+    static std::vector<SearchResultItem> streamSearch(
+        const uint64_t numItems, const uint16_t nodeSize, const NodeItem &item,
+        const std::function<void(uint8_t *, size_t, size_t)> &readNode);
+    static std::vector<std::pair<uint64_t, uint64_t>> generateLevelBounds(const uint64_t numItems, const uint16_t nodeSize);
+    uint64_t size() const;
+    static uint64_t size(const uint64_t numItems, const uint16_t nodeSize = 16);
+    NodeItem getExtent() const;
+    void streamWrite(const std::function<void(uint8_t *, size_t)> &writeData);
+};
+
+} }
+
+#endif
diff -pruN 8.0.1-5/src/fontcache.c 8.2.0~beta1-1~exp1/src/fontcache.c
--- 8.0.1-5/src/fontcache.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/fontcache.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,406 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Freetype Font helper functions
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2013 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "mapthread.h"
+#include "fontcache.h"
+#include "dejavu-sans-condensed.h"
+
+#include "cpl_conv.h"
+
+typedef struct {
+  FT_Library library;
+  face_element *face_cache;
+  glyph_element *bitmap_glyph_cache;
+} ft_cache;
+
+#ifdef USE_THREAD
+typedef struct ft_thread_cache ft_thread_cache;
+struct ft_thread_cache {
+  void *thread_id;
+  ft_thread_cache *next;
+  ft_cache cache;
+};
+ft_thread_cache *ft_caches;
+int use_global_ft_cache;
+#else
+ft_cache global_ft_cache;
+#endif
+
+void msInitFontCache(ft_cache *c) {
+  memset(c, 0, sizeof(ft_cache));
+  FT_Init_FreeType(&c->library);
+}
+
+void msFreeFontCache(ft_cache *c) {
+  /* ... TODO ... */
+  face_element *cur_face, *tmp_face;
+  glyph_element *cur_bitmap, *tmp_bitmap;
+  UT_HASH_ITER(hh, c->face_cache, cur_face, tmp_face) {
+    index_element *cur_index, *tmp_index;
+    outline_element *cur_outline, *tmp_outline;
+    glyph_element *cur_glyph, *tmp_glyph;
+    UT_HASH_ITER(hh, cur_face->index_cache, cur_index, tmp_index) {
+      UT_HASH_DEL(cur_face->index_cache, cur_index);
+      free(cur_index);
+    }
+    UT_HASH_ITER(hh, cur_face->outline_cache, cur_outline, tmp_outline) {
+      UT_HASH_DEL(cur_face->outline_cache, cur_outline);
+      FT_Outline_Done(c->library, &cur_outline->outline);
+      free(cur_outline);
+    }
+    UT_HASH_ITER(hh, cur_face->glyph_cache, cur_glyph, tmp_glyph) {
+      UT_HASH_DEL(cur_face->glyph_cache, cur_glyph);
+      free(cur_glyph);
+    }
+#ifdef USE_HARFBUZZ
+    if (cur_face->hbfont) {
+      hb_font_destroy(cur_face->hbfont->hbfont);
+      hb_font_destroy(cur_face->hbfont->hbparentfont);
+      hb_font_funcs_destroy(cur_face->hbfont->funcs);
+      free(cur_face->hbfont);
+    }
+#endif
+    FT_Done_Face(cur_face->face);
+    free(cur_face->font);
+    UT_HASH_DEL(c->face_cache, cur_face);
+    free(cur_face);
+  }
+  FT_Done_FreeType(c->library);
+
+  UT_HASH_ITER(hh, c->bitmap_glyph_cache, cur_bitmap, tmp_bitmap) {
+    UT_HASH_DEL(c->bitmap_glyph_cache, cur_bitmap);
+    free(cur_bitmap);
+  }
+  memset(c, 0, sizeof(ft_cache));
+}
+
+ft_cache *msGetFontCache() {
+#ifndef USE_THREAD
+  return &global_ft_cache;
+#else
+  void *nThreadId = 0;
+  ft_thread_cache *prev = NULL, *cur = ft_caches;
+
+  if (!use_global_ft_cache)
+    nThreadId = msGetThreadId();
+
+  if (cur != NULL && cur->thread_id == nThreadId)
+    return &cur->cache;
+
+  /* -------------------------------------------------------------------- */
+  /*      Search for cache for this thread                                */
+  /* -------------------------------------------------------------------- */
+  msAcquireLock(TLOCK_TTF);
+
+  cur = ft_caches;
+  while (cur != NULL && cur->thread_id != nThreadId) {
+    prev = cur;
+    cur = cur->next;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If we found it, make sure it is pushed to the front of the      */
+  /*      link for faster finding next time, and return it.               */
+  /* -------------------------------------------------------------------- */
+  if (cur != NULL) {
+    if (prev != NULL) {
+      prev->next = cur->next;
+      cur->next = ft_caches;
+      ft_caches = cur;
+    }
+
+    msReleaseLock(TLOCK_TTF);
+    return &cur->cache;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create a new context group for this thread.                     */
+  /* -------------------------------------------------------------------- */
+  cur = msSmallMalloc(sizeof(ft_thread_cache));
+  cur->next = NULL;
+  cur->thread_id = nThreadId;
+  msInitFontCache(&cur->cache);
+  cur->next = ft_caches;
+  ft_caches = cur;
+
+  msReleaseLock(TLOCK_TTF);
+
+  return &cur->cache;
+#endif
+}
+
+void msFontCacheSetup() {
+#ifndef USE_THREAD
+  ft_cache *c = msGetFontCache();
+  msInitFontCache(c);
+#else
+  const char *use_global_cache =
+      CPLGetConfigOption("MS_USE_GLOBAL_FT_CACHE", NULL);
+  if (use_global_cache)
+    use_global_ft_cache = atoi(use_global_cache);
+  else
+    use_global_ft_cache = 0;
+
+  ft_caches = NULL;
+#endif
+}
+
+void msFontCacheCleanup() {
+#ifndef USE_THREAD
+  ft_cache *c = msGetFontCache();
+  msFreeFontCache(c);
+#else
+  ft_thread_cache *cur, *next;
+  msAcquireLock(TLOCK_TTF);
+  cur = ft_caches;
+  while (cur != NULL) {
+    msFreeFontCache(&cur->cache);
+    next = cur->next;
+    free(cur);
+    cur = next;
+  }
+  ft_caches = NULL;
+  msReleaseLock(TLOCK_TTF);
+#endif
+}
+
+unsigned int msGetGlyphIndex(face_element *face, unsigned int unicode) {
+  index_element *ic;
+  if (face->face->charmap &&
+      face->face->charmap->encoding == FT_ENCODING_MS_SYMBOL) {
+    unicode |= 0xf000; /* why? */
+  }
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msAcquireLock(TLOCK_TTF);
+#endif
+  UT_HASH_FIND_INT(face->index_cache, &unicode, ic);
+  if (!ic) {
+    ic = msSmallMalloc(sizeof(index_element));
+    ic->codepoint = FT_Get_Char_Index(face->face, unicode);
+    ic->unicode = unicode;
+    UT_HASH_ADD_INT(face->index_cache, unicode, ic);
+  }
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msReleaseLock(TLOCK_TTF);
+#endif
+  return ic->codepoint;
+}
+
+#define MS_DEFAULT_FONT_KEY "_ms_default_"
+
+face_element *msGetFontFace(const char *key, fontSetObj *fontset) {
+  face_element *fc;
+  int error;
+  ft_cache *cache = msGetFontCache();
+  if (!key) {
+    key = MS_DEFAULT_FONT_KEY;
+  }
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msAcquireLock(TLOCK_TTF);
+#endif
+  UT_HASH_FIND_STR(cache->face_cache, key, fc);
+  if (!fc) {
+    const char *fontfile = NULL;
+    fc = msSmallCalloc(1, sizeof(face_element));
+    if (fontset && strcmp(key, MS_DEFAULT_FONT_KEY)) {
+      fontfile = msLookupHashTable(&(fontset->fonts), key);
+      if (!fontfile) {
+        msSetError(MS_MISCERR, "Could not find font with key \"%s\" in fontset",
+                   "msGetFontFace()", key);
+        free(fc);
+#ifdef USE_THREAD
+        if (use_global_ft_cache)
+          msReleaseLock(TLOCK_TTF);
+#endif
+        return NULL;
+      }
+      error = FT_New_Face(cache->library, fontfile, 0, &(fc->face));
+    } else {
+      error = FT_New_Memory_Face(cache->library, dejavu_sans_condensed_ttf,
+                                 dejavu_sans_condensed_ttf_len, 0, &(fc->face));
+    }
+    if (error) {
+      msSetError(MS_MISCERR,
+                 "Freetype was unable to load font file \"%s\" for key \"%s\"",
+                 "msGetFontFace()", fontfile, key);
+      free(fc);
+#ifdef USE_THREAD
+      if (use_global_ft_cache)
+        msReleaseLock(TLOCK_TTF);
+#endif
+      return NULL;
+    }
+    if (!fc->face->charmap) {
+      /* The font file has no unicode charmap, select an alternate one */
+      if (FT_Select_Charmap(fc->face, FT_ENCODING_MS_SYMBOL))
+        FT_Select_Charmap(fc->face, FT_ENCODING_APPLE_ROMAN);
+      /* the previous calls may have failed, we ignore as there's nothing much
+       * left to do */
+    }
+    fc->font = msStrdup(key);
+    UT_HASH_ADD_KEYPTR(hh, cache->face_cache, fc->font, strlen(key), fc);
+  }
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msReleaseLock(TLOCK_TTF);
+#endif
+  return fc;
+}
+
+glyph_element *msGetGlyphByIndex(face_element *face, unsigned int size,
+                                 unsigned int codepoint) {
+  glyph_element *gc;
+  glyph_element_key key;
+  memset(&key, 0, sizeof(glyph_element_key));
+  key.codepoint = codepoint;
+  key.size = size;
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msAcquireLock(TLOCK_TTF);
+#endif
+  UT_HASH_FIND(hh, face->glyph_cache, &key, sizeof(glyph_element_key), gc);
+  if (!gc) {
+    FT_Error error;
+    gc = msSmallMalloc(sizeof(glyph_element));
+    if (MS_NINT(size * 96.0 / 72.0) != face->face->size->metrics.x_ppem) {
+      FT_Set_Pixel_Sizes(face->face, 0, MS_NINT(size * 96 / 72.0));
+    }
+    error =
+        FT_Load_Glyph(face->face, key.codepoint,
+                      FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP | FT_LOAD_NO_HINTING |
+                          FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+    if (error) {
+      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n",
+              key.codepoint, face->font);
+      // If we can't find a glyph then try to fallback to a question mark.
+      unsigned int fallbackCodepoint = msGetGlyphIndex(face, 0x3F);
+      error = FT_Load_Glyph(face->face, fallbackCodepoint,
+                            FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP |
+                                FT_LOAD_NO_HINTING |
+                                FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+    }
+    if (error) {
+      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"",
+                 "msGetGlyphByIndex()", key.codepoint, face->font);
+      free(gc);
+#ifdef USE_THREAD
+      if (use_global_ft_cache)
+        msReleaseLock(TLOCK_TTF);
+#endif
+      return NULL;
+    }
+    gc->metrics.minx = face->face->glyph->metrics.horiBearingX / 64.0;
+    gc->metrics.maxx =
+        gc->metrics.minx + face->face->glyph->metrics.width / 64.0;
+    gc->metrics.maxy = face->face->glyph->metrics.horiBearingY / 64.0;
+    gc->metrics.miny =
+        gc->metrics.maxy - face->face->glyph->metrics.height / 64.0;
+    gc->metrics.advance = face->face->glyph->metrics.horiAdvance / 64.0;
+    gc->key = key;
+    UT_HASH_ADD(hh, face->glyph_cache, key, sizeof(glyph_element_key), gc);
+  }
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msReleaseLock(TLOCK_TTF);
+#endif
+  return gc;
+}
+
+outline_element *msGetGlyphOutline(face_element *face, glyph_element *glyph) {
+  outline_element *oc;
+  outline_element_key key;
+  ft_cache *cache = msGetFontCache();
+  memset(&key, 0, sizeof(outline_element_key));
+  key.glyph = glyph;
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msAcquireLock(TLOCK_TTF);
+#endif
+  UT_HASH_FIND(hh, face->outline_cache, &key, sizeof(outline_element_key), oc);
+  if (!oc) {
+    FT_Matrix matrix;
+    FT_Vector pen;
+    FT_Error error;
+    oc = msSmallMalloc(sizeof(outline_element));
+    if (MS_NINT(glyph->key.size * 96.0 / 72.0) !=
+        face->face->size->metrics.x_ppem) {
+      FT_Set_Pixel_Sizes(face->face, 0, MS_NINT(glyph->key.size * 96 / 72.0));
+    }
+    matrix.xx = matrix.yy = 0x10000L;
+    matrix.xy = matrix.yx = 0x00000L;
+    pen.x = pen.y = 0;
+    FT_Set_Transform(face->face, &matrix, &pen);
+    error = FT_Load_Glyph(
+        face->face, glyph->key.codepoint,
+        FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP /*|FT_LOAD_IGNORE_TRANSFORM*/ |
+            FT_LOAD_NO_HINTING | FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+    if (error) {
+      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n",
+              glyph->key.codepoint, face->font);
+      // If we can't find a glyph then try to fallback to a question mark.
+      unsigned int fallbackCodepoint = msGetGlyphIndex(face, 0x3F);
+      error = FT_Load_Glyph(
+          face->face, fallbackCodepoint,
+          FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP /*|FT_LOAD_IGNORE_TRANSFORM*/ |
+              FT_LOAD_NO_HINTING | FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+    }
+    if (error) {
+      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"",
+                 "msGetGlyphOutline()", glyph->key.codepoint, face->font);
+#ifdef USE_THREAD
+      if (use_global_ft_cache)
+        msReleaseLock(TLOCK_TTF);
+#endif
+      return NULL;
+    }
+    error = FT_Outline_New(cache->library, face->face->glyph->outline.n_points,
+                           face->face->glyph->outline.n_contours, &oc->outline);
+    (void)error;
+    FT_Outline_Copy(&face->face->glyph->outline, &oc->outline);
+    oc->key = key;
+    UT_HASH_ADD(hh, face->outline_cache, key, sizeof(outline_element_key), oc);
+  }
+#ifdef USE_THREAD
+  if (use_global_ft_cache)
+    msReleaseLock(TLOCK_TTF);
+#endif
+  return oc;
+}
+
+int msIsGlyphASpace(glyphObj *glyph) {
+  /* space or tab, for now */
+  unsigned int space, tab;
+  space = msGetGlyphIndex(glyph->face, 0x20);
+  tab = msGetGlyphIndex(glyph->face, 0x9);
+  return glyph->glyph->key.codepoint == space ||
+         glyph->glyph->key.codepoint == tab;
+}
diff -pruN 8.0.1-5/src/fontcache.h 8.2.0~beta1-1~exp1/src/fontcache.h
--- 8.0.1-5/src/fontcache.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/fontcache.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,87 @@
+#include "mapserver.h"
+#include "uthash.h"
+
+#include <ft2build.h>
+#include FT_FREETYPE_H
+#include FT_GLYPH_H
+#include FT_OUTLINE_H
+
+#ifdef USE_FRIBIDI
+#if (defined(_WIN32) && !defined(__CYGWIN__)) || defined(HAVE_FRIBIDI2)
+#include "fribidi.h"
+#else
+#include <fribidi/fribidi.h>
+#endif
+#include <hb-ft.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct { /* this one can remain private */
+  unsigned int unicode;
+  unsigned int codepoint;
+  UT_hash_handle hh;
+} index_element;
+
+typedef struct {
+  void *hbparentfont;
+  void *hbfont;
+  void *funcs;
+  int cursize;
+} hb_font_element;
+
+typedef struct {
+  unsigned int codepoint;
+  unsigned int size;
+} glyph_element_key;
+
+struct glyph_element {
+  glyph_element_key key;
+  glyph_metrics metrics;
+  UT_hash_handle hh;
+};
+
+typedef struct {
+  glyph_element *glyph;
+} outline_element_key;
+
+typedef struct {
+  outline_element_key key;
+  FT_Outline outline;
+  UT_hash_handle hh;
+} outline_element;
+
+typedef struct {
+  glyph_element *glyph;
+} bitmap_element_key;
+
+typedef struct {
+  bitmap_element_key key;
+  void *bitmap;
+  UT_hash_handle hh;
+} bitmap_element;
+
+struct face_element {
+  char *font;
+  FT_Face face;
+  index_element *index_cache;
+  glyph_element *glyph_cache;
+  outline_element *outline_cache;
+  hb_font_element *hbfont;
+  UT_hash_handle hh;
+};
+
+face_element *msGetFontFace(const char *key, fontSetObj *fontset);
+outline_element *msGetGlyphOutline(face_element *face, glyph_element *glyph);
+glyph_element *msGetBitmapGlyph(rendererVTableObj *renderer, unsigned int size,
+                                unsigned int unicode);
+unsigned int msGetGlyphIndex(face_element *face, unsigned int unicode);
+glyph_element *msGetGlyphByIndex(face_element *face, unsigned int size,
+                                 unsigned int codepoint);
+int msIsGlyphASpace(glyphObj *glyph);
+
+#ifdef __cplusplus
+}
+#endif
diff -pruN 8.0.1-5/src/hittest.c 8.2.0~beta1-1~exp1/src/hittest.c
--- 8.0.1-5/src/hittest.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/hittest.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,317 @@
+/*****************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Content Dependant Legend rendering support
+ * Author:   Thomas Bonfort (tbonfort@terriscope.fr)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2013 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+void initStyleHitTests(styleObj *s, style_hittest *sh, int default_status) {
+  (void)s;
+  sh->status = default_status;
+}
+
+void initLabelHitTests(labelObj *l, label_hittest *lh, int default_status) {
+  int i;
+  lh->stylehits = msSmallCalloc(l->numstyles, sizeof(style_hittest));
+  lh->status = default_status;
+  for (i = 0; i < l->numstyles; i++) {
+    initStyleHitTests(l->styles[i], &lh->stylehits[i], default_status);
+  }
+}
+
+void initClassHitTests(classObj *c, class_hittest *ch, int default_status) {
+  int i;
+  ch->stylehits = msSmallCalloc(c->numstyles, sizeof(style_hittest));
+  ch->labelhits = msSmallCalloc(c->numlabels, sizeof(label_hittest));
+  ch->status = default_status;
+  for (i = 0; i < c->numstyles; i++) {
+    initStyleHitTests(c->styles[i], &ch->stylehits[i], default_status);
+  }
+  for (i = 0; i < c->numlabels; i++) {
+    initLabelHitTests(c->labels[i], &ch->labelhits[i], default_status);
+  }
+}
+
+void initLayerHitTests(layerObj *l, layer_hittest *lh) {
+  int i, default_status;
+  lh->classhits = msSmallCalloc(l->numclasses, sizeof(class_hittest));
+
+  switch (l->type) {
+  case MS_LAYER_POLYGON:
+  case MS_LAYER_POINT:
+  case MS_LAYER_LINE:
+  case MS_LAYER_ANNOTATION:
+    default_status = 0; /* needs testing */
+    break;
+  default:
+    default_status = 1; /* no hittesting needed, use traditional mode */
+    break;
+  }
+  lh->status = default_status;
+  for (i = 0; i < l->numclasses; i++) {
+    initClassHitTests(l->class[i], &lh -> classhits[i], default_status);
+  }
+}
+void initMapHitTests(mapObj *map, map_hittest *mh) {
+  int i;
+  mh->layerhits = msSmallCalloc(map->numlayers, sizeof(layer_hittest));
+  for (i = 0; i < map->numlayers; i++) {
+    initLayerHitTests(GET_LAYER(map, i), &mh->layerhits[i]);
+  }
+}
+
+void freeLabelHitTests(labelObj *l, label_hittest *lh) {
+  (void)l;
+  free(lh->stylehits);
+}
+
+void freeClassHitTests(classObj *c, class_hittest *ch) {
+  int i;
+  for (i = 0; i < c->numlabels; i++) {
+    freeLabelHitTests(c->labels[i], &ch->labelhits[i]);
+  }
+  free(ch->stylehits);
+  free(ch->labelhits);
+}
+void freeLayerHitTests(layerObj *l, layer_hittest *lh) {
+  int i;
+  for (i = 0; i < l->numclasses; i++) {
+    freeClassHitTests(l->class[i], &lh -> classhits[i]);
+  }
+  free(lh->classhits);
+}
+void freeMapHitTests(mapObj *map, map_hittest *mh) {
+  int i;
+  for (i = 0; i < map->numlayers; i++) {
+    freeLayerHitTests(GET_LAYER(map, i), &mh->layerhits[i]);
+  }
+  free(mh->layerhits);
+}
+
+int msHitTestShape(mapObj *map, layerObj *layer, shapeObj *shape, int drawmode,
+                   class_hittest *hittest) {
+  int i;
+  classObj *cp = layer->class[shape->classindex];
+  if (MS_DRAW_FEATURES(drawmode)) {
+    for (i = 0; i < cp->numstyles; i++) {
+      styleObj *sp = cp->styles[i];
+      if (msScaleInBounds(map->scaledenom, sp->minscaledenom,
+                          sp->maxscaledenom)) {
+        hittest->stylehits[i].status = 1;
+      }
+    }
+  }
+  if (MS_DRAW_LABELS(drawmode)) {
+    for (i = 0; i < cp->numlabels; i++) {
+      labelObj *l = cp->labels[i];
+      if (msGetLabelStatus(map, layer, shape, l) == MS_ON) {
+        int s;
+        hittest->labelhits[i].status = 1;
+        for (s = 0; s < l->numstyles; s++) {
+          hittest->labelhits[i].stylehits[s].status = 1;
+        }
+      }
+    }
+  }
+  return MS_SUCCESS;
+}
+
+int msHitTestLayer(mapObj *map, layerObj *layer, layer_hittest *hittest) {
+  int status;
+#ifdef USE_GEOS
+  shapeObj searchpoly;
+#endif
+  if (!msLayerIsVisible(map, layer)) {
+    hittest->status = 0;
+    return MS_SUCCESS;
+  }
+  if (layer->type == MS_LAYER_LINE || layer->type == MS_LAYER_POLYGON ||
+      layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_ANNOTATION) {
+    int maxfeatures = msLayerGetMaxFeaturesToDraw(layer, NULL);
+    int annotate = msEvalContext(map, layer, layer->labelrequires);
+    shapeObj shape;
+    int nclasses, featuresdrawn = 0;
+    int *classgroup;
+    rectObj searchrect;
+    int minfeaturesize = -1;
+    if (map->scaledenom > 0) {
+      if ((layer->labelmaxscaledenom != -1) &&
+          (map->scaledenom >= layer->labelmaxscaledenom))
+        annotate = MS_FALSE;
+      if ((layer->labelminscaledenom != -1) &&
+          (map->scaledenom < layer->labelminscaledenom))
+        annotate = MS_FALSE;
+    }
+
+    status = msLayerOpen(layer);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+
+    /* build item list */
+    status = msLayerWhichItems(layer, MS_FALSE, NULL);
+
+    if (status != MS_SUCCESS) {
+      msLayerClose(layer);
+      return MS_FAILURE;
+    }
+
+    /* identify target shapes */
+    if (layer->transform == MS_TRUE) {
+      searchrect = map->extent;
+      if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+        msProjectRect(
+            &map->projection, &layer->projection,
+            &searchrect); /* project the searchrect to source coords */
+    } else {
+      searchrect.minx = searchrect.miny = 0;
+      searchrect.maxx = map->width - 1;
+      searchrect.maxy = map->height - 1;
+    }
+#ifdef USE_GEOS
+    msInitShape(&searchpoly);
+    msRectToPolygon(searchrect, &searchpoly);
+#endif
+
+    status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
+    if (status == MS_DONE) { /* no overlap */
+#ifdef USE_GEOS
+      msFreeShape(&searchpoly);
+#endif
+      msLayerClose(layer);
+      hittest->status = 0;
+      return MS_SUCCESS;
+    } else if (status != MS_SUCCESS) {
+#ifdef USE_GEOS
+      msFreeShape(&searchpoly);
+#endif
+      msLayerClose(layer);
+      return MS_FAILURE;
+    }
+
+    /* step through the target shapes */
+    msInitShape(&shape);
+
+    nclasses = 0;
+    classgroup = NULL;
+    if (layer->classgroup && layer->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(layer, &nclasses);
+
+    if (layer->minfeaturesize > 0)
+      minfeaturesize = Pix2LayerGeoref(map, layer, layer->minfeaturesize);
+
+    while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+      int drawmode = MS_DRAWMODE_FEATURES;
+#ifdef USE_GEOS
+      if (!msGEOSIntersects(&shape, &searchpoly)) {
+        msFreeShape(&shape);
+        continue;
+      }
+#else
+      if (shape.type == MS_SHAPE_POLYGON) {
+        msClipPolygonRect(&shape, map->extent);
+      } else {
+        msClipPolylineRect(&shape, map->extent);
+      }
+      if (shape.numlines == 0) {
+        msFreeShape(&shape);
+        continue;
+      }
+#endif
+      /* Check if the shape size is ok to be drawn, we need to clip */
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
+        msTransformShape(&shape, map->extent, map->cellsize, NULL);
+        msComputeBounds(&shape);
+        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
+          msFreeShape(&shape);
+          continue;
+        }
+      }
+
+      shape.classindex =
+          msShapeGetClass(layer, map, &shape, classgroup, nclasses);
+      if ((shape.classindex == -1) ||
+          (layer->class[shape.classindex] -> status == MS_OFF)) {
+        msFreeShape(&shape);
+        continue;
+      }
+      hittest->classhits[shape.classindex].status = 1;
+      hittest->status = 1;
+
+      if (maxfeatures >= 0 && featuresdrawn >= maxfeatures) {
+        msFreeShape(&shape);
+        status = MS_DONE;
+        break;
+      }
+      featuresdrawn++;
+
+      if (annotate && layer->class[shape.classindex] -> numlabels > 0) {
+        drawmode |= MS_DRAWMODE_LABELS;
+      }
+
+      status = msHitTestShape(
+          map, layer, &shape, drawmode,
+          &hittest->classhits[shape.classindex]); /* all styles  */
+      msFreeShape(&shape);
+    }
+
+#ifdef USE_GEOS
+    msFreeShape(&searchpoly);
+#endif
+
+    if (classgroup)
+      msFree(classgroup);
+
+    if (status != MS_DONE) {
+      msLayerClose(layer);
+      return MS_FAILURE;
+    }
+    msLayerClose(layer);
+    return MS_SUCCESS;
+
+  } else {
+    /* we don't hittest these layers, skip as they already have been initialised
+     */
+    return MS_SUCCESS;
+  }
+}
+int msHitTestMap(mapObj *map, map_hittest *hittest) {
+  int i, status;
+  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+  status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                            map->resolution, &map->scaledenom);
+  if (status != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp = map->layers[i];
+    status = msHitTestLayer(map, lp, &hittest->layerhits[i]);
+    if (status != MS_SUCCESS) {
+      return MS_FAILURE;
+    }
+  }
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/hittest.h 8.2.0~beta1-1~exp1/src/hittest.h
--- 8.0.1-5/src/hittest.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/hittest.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,68 @@
+/*****************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Content Dependant Legend rendering support
+ * Author:   Thomas Bonfort (tbonfort@terriscope.fr)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2013 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef HITTEST_H
+#define HITTEST_H
+
+typedef struct {
+  int status;
+} style_hittest;
+
+typedef struct {
+  style_hittest *stylehits;
+  int status;
+} label_hittest;
+
+typedef struct {
+  style_hittest *stylehits;
+  label_hittest *labelhits;
+  int status;
+} class_hittest;
+
+typedef struct {
+  class_hittest *classhits;
+  int status;
+} layer_hittest;
+
+typedef struct map_hittest {
+  layer_hittest *layerhits;
+} map_hittest;
+
+int msHitTestMap(mapObj *map, map_hittest *hittest);
+int msHitTestLayer(mapObj *map, layerObj *layer, layer_hittest *hittest);
+void initStyleHitTests(styleObj *s, style_hittest *sh, int default_status);
+void initLabelHitTests(labelObj *l, label_hittest *lh, int default_status);
+void initClassHitTests(classObj *c, class_hittest *ch, int default_status);
+void initLayerHitTests(layerObj *l, layer_hittest *lh);
+void initMapHitTests(mapObj *map, map_hittest *mh);
+void freeLabelHitTests(labelObj *l, label_hittest *lh);
+void freeClassHitTests(classObj *c, class_hittest *ch);
+void freeLayerHitTests(layerObj *l, layer_hittest *lh);
+void freeMapHitTests(mapObj *map, map_hittest *mh);
+
+#endif
diff -pruN 8.0.1-5/src/idw.c 8.2.0~beta1-1~exp1/src/idw.c
--- 8.0.1-5/src/idw.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/idw.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,82 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Inverse Distance Weighted layer interpolation.
+ * Author:   Hermes L. Herrera Martinez and the MapServer team.
+ * Thanks:   Thomas Bonfort
+ *
+ ******************************************************************************
+ * Copyright (c) 2014 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include <float.h>
+#define EPSILON 0.000000001
+#include <time.h>
+
+void msIdw(float *xyz, int width, int height, int npoints,
+           interpolationProcessingParams *interpParams,
+           unsigned char *iValues) {
+  int i, j, index;
+  int radius = interpParams->radius;
+  float power = interpParams->power;
+  for (j = 0; j < height; j++) {
+    for (i = 0; i < width; i++) {
+      double den = EPSILON, num = 0;
+      for (index = 0; index < npoints * 3; index += 3) {
+        double d = (xyz[index] - i) * (xyz[index] - i) +
+                   (xyz[index + 1] - j) * (xyz[index + 1] - j);
+        if (radius * radius > d) {
+          double w = 1.0 / (pow(d, power) + EPSILON);
+          num += w * xyz[index + 2];
+          den += w;
+        }
+      }
+      iValues[j * width + i] = num / den;
+    }
+  }
+}
+
+void msIdwProcessing(layerObj *layer,
+                     interpolationProcessingParams *interpParams) {
+  const char *interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "IDW_POWER");
+  if (interpParamsProcessing) {
+    interpParams->power = atof(interpParamsProcessing);
+  } else {
+    interpParams->power = 1.0;
+  }
+
+  interpParamsProcessing = msLayerGetProcessingKey(layer, "IDW_RADIUS");
+  if (interpParamsProcessing) {
+    interpParams->radius = atof(interpParamsProcessing);
+  } else {
+    interpParams->radius = MAX(layer->map->width, layer->map->height);
+  }
+
+  interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "IDW_COMPUTE_BORDERS");
+  if (interpParamsProcessing && strcasecmp(interpParamsProcessing, "OFF")) {
+    interpParams->expand_searchrect = 1;
+  } else {
+    interpParams->expand_searchrect = 0;
+  }
+}
diff -pruN 8.0.1-5/src/interpolation.c 8.2.0~beta1-1~exp1/src/interpolation.c
--- 8.0.1-5/src/interpolation.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/interpolation.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,293 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  KernelDensity layer implementation and related functions.
+ * Author:   Hermes L. Herrera and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 2014 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include <float.h>
+
+#include "gdal.h"
+#include "cpl_string.h"
+
+/******************************************************************************
+ * kernel density.
+ ******************************************************************************/
+void msKernelDensity(imageObj *image, float *values, int width, int height,
+                     int npoints, interpolationProcessingParams *interpParams,
+                     unsigned char *iValues);
+void msKernelDensityProcessing(layerObj *layer,
+                               interpolationProcessingParams *interpParams);
+
+/******************************************************************************
+ * kernel density.
+ ******************************************************************************/
+void msIdw(float *xyz, int width, int height, int npoints,
+           interpolationProcessingParams *interpParams, unsigned char *iValues);
+void msIdwProcessing(layerObj *layer,
+                     interpolationProcessingParams *interpParams);
+
+//---------------------------------------------------------------------------//
+int msInterpolationDataset(mapObj *map, imageObj *image,
+                           layerObj *interpolation_layer, void **hDSvoid,
+                           void **cleanup_ptr) {
+
+  int status, layer_idx, i, nclasses = 0, npoints = 0, length = 0;
+  rectObj searchrect;
+  shapeObj shape;
+  layerObj *layer = NULL;
+  float *values = NULL, *xyz_values = NULL;
+  int im_width = image->width, im_height = image->height;
+  double invcellsize = 1.0 / map->cellsize, georadius = 0;
+  unsigned char *iValues;
+  GDALDatasetH hDS;
+  interpolationProcessingParams interpParams;
+  int *classgroup = NULL;
+
+  memset(&interpParams, 0, sizeof(interpParams));
+
+  assert(interpolation_layer->connectiontype == MS_KERNELDENSITY ||
+         interpolation_layer->connectiontype == MS_IDW);
+  *cleanup_ptr = NULL;
+
+  if (!interpolation_layer->connection || !*interpolation_layer->connection) {
+    msSetError(MS_MISCERR, "msInterpolationDataset()",
+               "Interpolation layer has no CONNECTION defined");
+    return MS_FAILURE;
+  }
+
+  if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
+    msKernelDensityProcessing(interpolation_layer, &interpParams);
+  } else if (interpolation_layer->connectiontype == MS_IDW) {
+    msIdwProcessing(interpolation_layer, &interpParams);
+  }
+
+  layer_idx = msGetLayerIndex(map, interpolation_layer->connection);
+  if (layer_idx == -1) {
+    int nLayers, *aLayers;
+    aLayers =
+        msGetLayersIndexByGroup(map, interpolation_layer->connection, &nLayers);
+    if (!aLayers || !nLayers) {
+      msSetError(MS_MISCERR,
+                 "Interpolation layer (%s) references unknown layer (%s)",
+                 "msInterpolationDataset()", interpolation_layer->name,
+                 interpolation_layer->connection);
+      return (MS_FAILURE);
+    }
+    for (i = 0; i < nLayers; i++) {
+      layer_idx = aLayers[i];
+      layer = GET_LAYER(map, layer_idx);
+      if (msScaleInBounds(map->scaledenom, layer->minscaledenom,
+                          layer->maxscaledenom))
+        break;
+    }
+    free(aLayers);
+    if (i == nLayers) {
+      msSetError(
+          MS_MISCERR,
+          "Interpolation layer (%s) references no layer for current scale",
+          "msInterpolationDataset()", interpolation_layer->name);
+      return (MS_FAILURE);
+    }
+  } else {
+    layer = GET_LAYER(map, layer_idx);
+  }
+  /* open the linked layer */
+  status = msLayerOpen(layer);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  status = msLayerWhichItems(layer, MS_FALSE, NULL);
+  if (status != MS_SUCCESS) {
+    msLayerClose(layer);
+    return MS_FAILURE;
+  }
+
+  /* identify target shapes */
+  if (layer->transform == MS_TRUE) {
+    searchrect = map->extent;
+    if (interpParams.expand_searchrect) {
+      georadius = interpParams.radius * map->cellsize;
+      searchrect.minx -= georadius;
+      searchrect.miny -= georadius;
+      searchrect.maxx += georadius;
+      searchrect.maxy += georadius;
+      im_width += 2 * interpParams.radius;
+      im_height += 2 * interpParams.radius;
+    }
+  } else {
+    searchrect.minx = searchrect.miny = 0;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
+  }
+
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
+  if (layer->project)
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
+
+  status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
+  /* nothing to do */
+  if (status == MS_SUCCESS) { /* at least one sample may have overlapped */
+
+    if (layer->classgroup && layer->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(layer, &nclasses);
+
+    msInitShape(&shape);
+    while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+      int l, p, s, c;
+      double weight = 1.0;
+      if (!values) { /* defer allocation until we effectively have a feature */
+        values = (float *)msSmallCalloc(((size_t)im_width) * im_height,
+                                        sizeof(float));
+        xyz_values = (float *)msSmallCalloc(((size_t)im_width) * im_height,
+                                            sizeof(float));
+      }
+      if (layer->project)
+        msProjectShape(&layer->projection, &map->projection, &shape);
+
+      /* the weight for the sample is set to 1.0 by default. If the
+       * layer has some classes defined, we will read the weight from
+       * the class->style->size (which can be binded to an attribute)
+       */
+      if (layer->numclasses > 0) {
+        c = msShapeGetClass(layer, map, &shape, classgroup, nclasses);
+        if ((c == -1) || (layer->class[c] -> status == MS_OFF)) {
+          goto nextshape; /* no class matched, skip */
+        }
+        for (s = 0; s < layer->class[c] -> numstyles; s++) {
+          if (msScaleInBounds(
+                  map->scaledenom,
+                  layer->class[c] -> styles[s] -> minscaledenom,
+                  layer -> class[c] -> styles[s] -> maxscaledenom)) {
+            if (layer->class[c] -> styles[s]
+                -> bindings[MS_STYLE_BINDING_SIZE].index != -1) {
+              weight =
+                  atof(shape.values[layer->class[c] -> styles[s]
+                                    -> bindings[MS_STYLE_BINDING_SIZE].index]);
+            } else {
+              weight = layer->class[c]->styles[s]->size;
+            }
+            break;
+          }
+        }
+        if (s == layer->class[c] -> numstyles) {
+          /* no style in scale bounds */
+          goto nextshape;
+        }
+      }
+      for (l = 0; l < shape.numlines; l++) {
+        for (p = 0; p < shape.line[l].numpoints; p++) {
+          int x =
+              MS_MAP2IMAGE_XCELL_IC(shape.line[l].point[p].x,
+                                    map->extent.minx - georadius, invcellsize);
+          int y =
+              MS_MAP2IMAGE_YCELL_IC(shape.line[l].point[p].y,
+                                    map->extent.maxy + georadius, invcellsize);
+          if (x >= 0 && y >= 0 && x < im_width && y < im_height) {
+            float *value = values + y * im_width + x;
+            (*value) += weight;
+            xyz_values[length++] = x;
+            xyz_values[length++] = y;
+            xyz_values[length++] = (*value);
+          }
+        }
+      }
+
+    nextshape:
+      msFreeShape(&shape);
+    }
+    // number of layer points.
+    npoints = length / 3;
+  } else if (status != MS_DONE) {
+    msLayerClose(layer);
+    return MS_FAILURE;
+  }
+
+  /* status == MS_DONE */
+  msLayerClose(layer);
+  status = MS_SUCCESS;
+
+  if (npoints > 0 && interpParams.expand_searchrect) {
+    iValues =
+        msSmallMalloc(sizeof(unsigned char) * image->width * image->height);
+  } else {
+    iValues =
+        msSmallCalloc(1, sizeof(unsigned char) * image->width * image->height);
+  }
+
+  if (npoints >
+      0) { /* no use applying the filtering kernel if we have no samples */
+    if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
+      msKernelDensity(image, values, im_width, im_height, npoints,
+                      &interpParams, iValues);
+    } else if (interpolation_layer->connectiontype == MS_IDW) {
+      msIdw(xyz_values, image->width, image->height, npoints, &interpParams,
+            iValues);
+    }
+  }
+
+  free(values);
+  free(xyz_values);
+
+  char pointer[64];
+  char ds_string[1024];
+  double adfGeoTransform[6];
+  memset(pointer, 0, sizeof(pointer));
+  CPLPrintPointer(pointer, iValues, sizeof(pointer));
+  snprintf(ds_string, 1024,
+           "MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Byte,"
+           "PIXELOFFSET=1,LINEOFFSET=%d",
+           pointer, image->width, image->height, image->width);
+  hDS = GDALOpenShared(ds_string, GA_ReadOnly);
+  if (hDS == NULL) {
+    msSetError(MS_MISCERR, "msInterpolationDataset()",
+               "failed to create in-memory gdal dataset for interpolated data");
+    status = MS_FAILURE;
+    free(iValues);
+  }
+  adfGeoTransform[0] = map->extent.minx - map->cellsize * 0.5; /* top left x */
+  adfGeoTransform[1] = map->cellsize; /* w-e pixel resolution */
+  adfGeoTransform[2] = 0;             /* 0 */
+  adfGeoTransform[3] = map->extent.maxy + map->cellsize * 0.5; /* top left y */
+  adfGeoTransform[4] = 0;                                      /* 0 */
+  adfGeoTransform[5] =
+      -map->cellsize; /* n-s pixel resolution (negative value) */
+  GDALSetGeoTransform(hDS, adfGeoTransform);
+  *hDSvoid = hDS;
+  *cleanup_ptr = (void *)iValues;
+
+  return status;
+}
+
+int msCleanupInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer,
+                                  void *cleanup_ptr) {
+  (void)map;
+  (void)image;
+  (void)layer;
+  free(cleanup_ptr);
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/kerneldensity.c 8.2.0~beta1-1~exp1/src/kerneldensity.c
--- 8.0.1-5/src/kerneldensity.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/kerneldensity.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,169 @@
+
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  KernelDensity layer implementation and related functions.
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 2014 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include <float.h>
+
+#include "gdal.h"
+
+static void gaussian_blur(float *values, int width, int height, int radius) {
+  float *tmp = (float *)msSmallMalloc(sizeof(float) * width * height);
+  int length = radius * 2 + 1;
+  float *kernel = (float *)msSmallMalloc(length * sizeof(float));
+  float sigma = radius / 3.0;
+  float a = 1.0 / sqrt(2.0 * M_PI * sigma * sigma);
+  float den = 2.0 * sigma * sigma;
+  int i, x, y;
+
+  for (i = 0; i < length; i++) {
+    float x = i - radius;
+    float v = a * exp(-(x * x) / den);
+    kernel[i] = v;
+  }
+  memset(tmp, 0, sizeof(float) * width * height);
+
+  for (y = 0; y < height; y++) {
+    float *src_row = values + width * y;
+    float *dst_row = tmp + width * y;
+
+    for (x = radius; x < width - radius; x++) {
+      float accum = 0;
+      for (i = 0; i < length; i++) {
+        accum += src_row[x + i - radius] * kernel[i];
+      }
+      dst_row[x] = accum;
+    }
+  }
+
+  for (x = 0; x < width; x++) {
+    float *src_col = tmp + x;
+    float *dst_col = values + x;
+
+    for (y = radius; y < height - radius; y++) {
+      float accum = 0;
+      for (i = 0; i < length; i++) {
+        accum += src_col[width * (y + i - radius)] * kernel[i];
+      }
+      dst_col[y * width] = accum;
+    }
+  }
+  free(tmp);
+  free(kernel);
+}
+
+void msKernelDensityProcessing(layerObj *layer,
+                               interpolationProcessingParams *interpParams) {
+  const char *interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "KERNELDENSITY_RADIUS");
+  if (interpParamsProcessing) {
+    interpParams->radius = atoi(interpParamsProcessing);
+  } else {
+    interpParams->radius = 10;
+  }
+
+  interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "KERNELDENSITY_COMPUTE_BORDERS");
+  if (interpParamsProcessing && strcasecmp(interpParamsProcessing, "OFF")) {
+    interpParams->expand_searchrect = 1;
+  } else {
+    interpParams->expand_searchrect = 0;
+  }
+
+  interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "KERNELDENSITY_NORMALIZATION");
+  if (!interpParamsProcessing || !strcasecmp(interpParamsProcessing, "AUTO")) {
+    interpParams->normalization_scale = 0.0;
+  } else {
+    interpParams->normalization_scale = atof(interpParamsProcessing);
+    if (interpParams->normalization_scale != 0) {
+      interpParams->normalization_scale =
+          1.0 / interpParams->normalization_scale;
+    } else {
+      interpParams->normalization_scale = 1.0;
+    }
+  }
+}
+
+void msKernelDensity(imageObj *image, float *values, int width, int height,
+                     int npoints, interpolationProcessingParams *interpParams,
+                     unsigned char *iValues) {
+  int i, j;
+  float valmax = FLT_MIN, valmin = FLT_MAX;
+  int radius = interpParams->radius;
+  float normalization_scale = interpParams->normalization_scale;
+  int expand_searchrect = interpParams->expand_searchrect;
+
+  gaussian_blur(values, width, height, radius);
+
+  if (normalization_scale == 0.0) { /* auto normalization */
+    for (j = radius; j < height - radius; j++) {
+      for (i = radius; i < width - radius; i++) {
+        float val = values[j * width + i];
+        if (val > 0 && val > valmax) {
+          valmax = val;
+        }
+        if (val > 0 && val < valmin) {
+          valmin = val;
+        }
+      }
+    }
+  } else {
+    valmin = 0;
+    valmax = normalization_scale;
+  }
+
+  if (expand_searchrect) {
+    for (j = 0; j < image->height; j++) {
+      for (i = 0; i < image->width; i++) {
+        float norm =
+            (values[(j + radius) * width + i + radius] - valmin) / valmax;
+        int v = 255 * norm;
+        if (v < 0)
+          v = 0;
+        else if (v > 255)
+          v = 255;
+        iValues[j * image->width + i] = v;
+      }
+    }
+  } else {
+    if (npoints > 0) {
+      for (j = radius; j < image->height - radius; j++) {
+        for (i = radius; i < image->width - radius; i++) {
+          float norm = (values[j * width + i] - valmin) / valmax;
+          int v = 255 * norm;
+          if (v < 0)
+            v = 0;
+          else if (v > 255)
+            v = 255;
+          iValues[j * image->width + i] = v;
+        }
+      }
+    }
+  }
+}
diff -pruN 8.0.1-5/src/layerobject.c 8.2.0~beta1-1~exp1/src/layerobject.c
--- 8.0.1-5/src/layerobject.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/layerobject.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,197 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Functions for operating on a layerObj that don't belong in a
+ *           more specific file such as mapfile.c.
+ *           Adapted from mapobject.c.
+ * Author:   Sean Gillies, sgillies@frii.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2004, Sean Gillies
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+/* ===========================================================================
+   msInsertClass
+
+   Returns the index at which the class was inserted.
+   ======================================================================== */
+
+int msInsertClass(layerObj *layer, classObj *classobj, int nIndex) {
+  int i;
+
+  if (!classobj) {
+    msSetError(MS_CHILDERR, "Cannot insert NULL class", "msInsertClass()");
+    return -1;
+  }
+
+  /* Ensure there is room for a new class */
+  if (msGrowLayerClasses(layer) == NULL) {
+    return -1;
+  }
+  /* Catch attempt to insert past end of styles array */
+  else if (nIndex >= layer->numclasses) {
+    msSetError(MS_CHILDERR, "Cannot insert class beyond index %d",
+               "msInsertClass()", layer->numclasses - 1);
+    return -1;
+  } else if (nIndex < 0) { /* Insert at the end by default */
+#ifndef __cplusplus
+    layer->class[layer->numclasses] = classobj;
+#else
+    layer->_class[layer->numclasses] = classobj;
+#endif
+    /* set parent pointer */
+    classobj->layer = layer;
+    MS_REFCNT_INCR(classobj);
+    layer->numclasses++;
+    return layer->numclasses - 1;
+  } else {
+
+    /* Copy classes existing at the specified nIndex or greater */
+    /* to an index one higher */
+
+#ifndef __cplusplus
+    for (i = layer->numclasses - 1; i >= nIndex; i--)
+      layer->class[i + 1] = layer->class[i];
+    layer->class[nIndex] = classobj;
+#else
+    for (i = layer->numclasses - 1; i >= nIndex; i--)
+      layer->_class[i + 1] = layer->_class[i];
+    layer->_class[nIndex] = classobj;
+#endif
+
+    /* set parent pointer */
+    classobj->layer = layer;
+    MS_REFCNT_INCR(classobj);
+    /* increment number of classes and return */
+    layer->numclasses++;
+    return nIndex;
+  }
+}
+
+/* ===========================================================================
+   msRemoveClass
+
+   remove the class at an index from a layer, returning a copy
+   ======================================================================== */
+
+classObj *msRemoveClass(layerObj *layer, int nIndex) {
+  int i;
+  classObj *classobj;
+
+  if (nIndex < 0 || nIndex >= layer->numclasses) {
+    msSetError(MS_CHILDERR, "Cannot remove class, invalid index %d",
+               "removeClass()", nIndex);
+    return NULL;
+  } else {
+#ifndef __cplusplus
+    classobj = layer->class[nIndex];
+#else
+    classobj = layer->_class[nIndex];
+#endif
+    classobj->layer = NULL;
+    MS_REFCNT_DECR(classobj);
+
+    /* Iteratively copy the higher index classes down one index */
+    for (i = nIndex; i < layer->numclasses - 1; i++) {
+#ifndef __cplusplus
+      layer->class[i] = layer->class[i + 1];
+#else
+      layer->_class[i] = layer->_class[i + 1];
+#endif
+    }
+#ifndef __cplusplus
+    layer->class[i] = NULL;
+#else
+    layer->_class[i] = NULL;
+#endif
+
+    /* decrement number of layers and return copy of removed layer */
+    layer->numclasses--;
+    return classobj;
+  }
+}
+
+/**
+ * Move the class up inside the array of classes.
+ */
+int msMoveClassUp(layerObj *layer, int nClassIndex) {
+  classObj *psTmpClass = NULL;
+  if (layer && nClassIndex < layer->numclasses && nClassIndex > 0) {
+    psTmpClass = layer->class[nClassIndex];
+
+    layer->class[nClassIndex] = layer->class[nClassIndex - 1];
+
+    layer->class[nClassIndex - 1] = psTmpClass;
+
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveClassUp()", nClassIndex);
+  return (MS_FAILURE);
+}
+
+/**
+ * Move the class down inside the array of classes.
+ */
+int msMoveClassDown(layerObj *layer, int nClassIndex) {
+  classObj *psTmpClass = NULL;
+  if (layer && nClassIndex < layer->numclasses - 1 && nClassIndex >= 0) {
+    psTmpClass = layer->class[nClassIndex];
+
+    layer->class[nClassIndex] = layer->class[nClassIndex + 1];
+
+    layer->class[nClassIndex + 1] = psTmpClass;
+
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveClassDown()",
+             nClassIndex);
+  return (MS_FAILURE);
+}
+
+/**
+ * Set the extent of a layer.
+ */
+
+int msLayerSetExtent(layerObj *layer, double minx, double miny, double maxx,
+                     double maxy) {
+
+  layer->extent.minx = minx;
+  layer->extent.miny = miny;
+  layer->extent.maxx = maxx;
+  layer->extent.maxy = maxy;
+
+  if (minx == -1.0 && miny == -1.0 && maxx == -1.0 && maxy == -1.0)
+    return (MS_SUCCESS);
+
+  if (!MS_VALID_EXTENT(layer->extent)) {
+    msSetError(MS_MISCERR,
+               "Given layer extent is invalid. minx=%lf, miny=%lf, maxx=%lf, "
+               "maxy=%lf.",
+               "msLayerSetExtent()", layer->extent.minx, layer->extent.miny,
+               layer->extent.maxx, layer->extent.maxy);
+    return (MS_FAILURE);
+  }
+
+  return (MS_SUCCESS);
+}
diff -pruN 8.0.1-5/src/mapagg.cpp 8.2.0~beta1-1~exp1/src/mapagg.cpp
--- 8.0.1-5/src/mapagg.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapagg.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1413 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  AGG rendering and other AGG related functions.
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "fontcache.h"
+#include "mapagg.h"
+#include <assert.h>
+#include "renderers/agg/include/agg_color_rgba.h"
+#include "renderers/agg/include/agg_pixfmt_rgba.h"
+#include "renderers/agg/include/agg_renderer_base.h"
+#include "renderers/agg/include/agg_renderer_scanline.h"
+#include "renderers/agg/include/agg_math_stroke.h"
+#include "renderers/agg/include/agg_scanline_p.h"
+#include "renderers/agg/include/agg_scanline_u.h"
+#include "renderers/agg/include/agg_rasterizer_scanline_aa.h"
+#include "renderers/agg/include/agg_span_pattern_rgba.h"
+#include "renderers/agg/include/agg_span_allocator.h"
+#include "renderers/agg/include/agg_span_interpolator_linear.h"
+#include "renderers/agg/include/agg_pattern_filters_rgba.h"
+#include "renderers/agg/include/agg_image_accessors.h"
+#include "renderers/agg/include/agg_conv_stroke.h"
+#include "renderers/agg/include/agg_conv_dash.h"
+#include "renderers/agg/include/agg_font_freetype.h"
+#include "renderers/agg/include/agg_conv_contour.h"
+#include "renderers/agg/include/agg_ellipse.h"
+#include "renderers/agg/include/agg_gamma_functions.h"
+#include "renderers/agg/include/agg_blur.h"
+
+#include "renderers/agg/include/agg_rasterizer_outline_aa.h"
+#include "renderers/agg/include/agg_renderer_outline_aa.h"
+#include "renderers/agg/include/agg_renderer_outline_image.h"
+#include "renderers/agg/include/agg_span_pattern_rgba.h"
+#include "renderers/agg/include/agg_span_image_filter_rgba.h"
+#include "renderers/agg/include/agg_glyph_raster_bin.h"
+#include "renderers/agg/include/agg_renderer_raster_text.h"
+#include "renderers/agg/include/agg_path_storage_integer.h"
+
+#include "renderers/agg/include/agg_conv_clipper.h"
+
+#ifdef USE_PIXMAN
+#include <pixman.h>
+#endif
+
+#include <limits>
+#include <memory>
+#include <new>
+#include <vector>
+
+typedef mapserver::order_bgra band_order;
+
+#define AGG_LINESPACE 1.33
+
+typedef mapserver::int8u band_type;
+typedef mapserver::rgba8 color_type;
+typedef mapserver::pixel32_type pixel_type;
+
+typedef mapserver::blender_rgba_pre<color_type, band_order> blender_pre;
+typedef mapserver::comp_op_adaptor_rgba_pre<color_type, band_order>
+    compop_blender_pre;
+
+typedef mapserver::pixfmt_alpha_blend_rgba<
+    blender_pre, mapserver::rendering_buffer, pixel_type>
+    pixel_format;
+typedef mapserver::pixfmt_custom_blend_rgba<compop_blender_pre,
+                                            mapserver::rendering_buffer>
+    compop_pixel_format;
+typedef mapserver::rendering_buffer rendering_buffer;
+typedef mapserver::renderer_base<pixel_format> renderer_base;
+typedef mapserver::renderer_base<compop_pixel_format> compop_renderer_base;
+typedef mapserver::renderer_scanline_aa_solid<renderer_base> renderer_scanline;
+typedef mapserver::renderer_scanline_bin_solid<renderer_base>
+    renderer_scanline_aliased;
+typedef mapserver::rasterizer_scanline_aa<> rasterizer_scanline;
+typedef mapserver::font_engine_freetype_int16 font_engine_type;
+typedef mapserver::font_cache_manager<font_engine_type> font_manager_type;
+typedef mapserver::conv_curve<font_manager_type::path_adaptor_type>
+    font_curve_type;
+typedef mapserver::glyph_raster_bin<color_type> glyph_gen;
+
+static const color_type AGG_NO_COLOR = color_type(0, 0, 0, 0);
+
+#define aggColor(c)                                                            \
+  mapserver::rgba8_pre((c)->red, (c)->green, (c)->blue, (c)->alpha)
+
+class aggRendererCache {
+public:
+  font_engine_type m_feng;
+  font_manager_type m_fman;
+  aggRendererCache() : m_fman(m_feng) {}
+};
+
+class AGG2Renderer {
+public:
+  std::vector<band_type> buffer{};
+  rendering_buffer m_rendering_buffer;
+  pixel_format m_pixel_format;
+  compop_pixel_format m_compop_pixel_format;
+  renderer_base m_renderer_base;
+  compop_renderer_base m_compop_renderer_base;
+  renderer_scanline m_renderer_scanline;
+  renderer_scanline_aliased m_renderer_scanline_aliased;
+  rasterizer_scanline m_rasterizer_aa;
+  rasterizer_scanline m_rasterizer_aa_gamma;
+  mapserver::scanline_p8 sl_poly; /*packed scanlines, works faster when the area
+    is larger than the perimeter, in number of pixels*/
+  mapserver::scanline_u8 sl_line; /*unpacked scanlines, works faster if the area
+    is roughly equal to the perimeter, in number of pixels*/
+  bool use_alpha = false;
+  std::unique_ptr<mapserver::conv_stroke<line_adaptor>> stroke{};
+  std::unique_ptr<mapserver::conv_dash<line_adaptor>> dash{};
+  std::unique_ptr<mapserver::conv_stroke<mapserver::conv_dash<line_adaptor>>>
+      stroke_dash{};
+  double default_gamma = 0.0;
+  mapserver::gamma_linear gamma_function;
+};
+
+#define AGG_RENDERER(image) ((AGG2Renderer *)(image)->img.plugin)
+
+template <class VertexSource>
+static void applyCJC(VertexSource &stroke, int caps, int joins) {
+  switch (joins) {
+  case MS_CJC_ROUND:
+    stroke.line_join(mapserver::round_join);
+    break;
+  case MS_CJC_MITER:
+    stroke.line_join(mapserver::miter_join);
+    break;
+  case MS_CJC_BEVEL:
+  case MS_CJC_NONE:
+    stroke.line_join(mapserver::bevel_join);
+    break;
+  }
+  switch (caps) {
+  case MS_CJC_BUTT:
+  case MS_CJC_NONE:
+    stroke.line_cap(mapserver::butt_cap);
+    break;
+  case MS_CJC_ROUND:
+    stroke.line_cap(mapserver::round_cap);
+    break;
+  case MS_CJC_SQUARE:
+    stroke.line_cap(mapserver::square_cap);
+    break;
+  }
+}
+
+int agg2RenderLine(imageObj *img, shapeObj *p, strokeStyleObj *style) {
+
+  AGG2Renderer *r = AGG_RENDERER(img);
+  line_adaptor lines = line_adaptor(p);
+
+  r->m_rasterizer_aa.reset();
+  r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
+  if (style->antialiased == MS_FALSE) {
+    r->m_renderer_scanline_aliased.color(aggColor(style->color));
+  } else {
+    r->m_renderer_scanline.color(aggColor(style->color));
+  }
+
+  if (style->patternlength <= 0) {
+    if (!r->stroke) {
+      r->stroke.reset(new mapserver::conv_stroke<line_adaptor>(lines));
+    } else {
+      r->stroke->attach(lines);
+    }
+    r->stroke->width(style->width);
+    if (style->width > 1) {
+      applyCJC(*r->stroke, style->linecap, style->linejoin);
+    } else {
+      r->stroke->inner_join(mapserver::inner_bevel);
+      r->stroke->line_join(mapserver::bevel_join);
+    }
+    r->m_rasterizer_aa.add_path(*r->stroke);
+  } else {
+    if (!r->dash) {
+      r->dash.reset(new mapserver::conv_dash<line_adaptor>(lines));
+    } else {
+      r->dash->remove_all_dashes();
+      r->dash->dash_start(0.0);
+      r->dash->attach(lines);
+    }
+    if (!r->stroke_dash) {
+      r->stroke_dash.reset(
+          new mapserver::conv_stroke<mapserver::conv_dash<line_adaptor>>(
+              *r->dash));
+    } else {
+      r->stroke_dash->attach(*r->dash);
+    }
+    int patt_length = 0;
+    for (int i = 0; i < style->patternlength; i += 2) {
+      if (i < style->patternlength - 1) {
+        r->dash->add_dash(MS_MAX(1, MS_NINT(style->pattern[i])),
+                          MS_MAX(1, MS_NINT(style->pattern[i + 1])));
+        if (style->patternoffset) {
+          patt_length += MS_MAX(1, MS_NINT(style->pattern[i])) +
+                         MS_MAX(1, MS_NINT(style->pattern[i + 1]));
+        }
+      }
+    }
+    if (style->patternoffset > 0) {
+      r->dash->dash_start(patt_length - style->patternoffset);
+    }
+    r->stroke_dash->width(style->width);
+    if (style->width > 1) {
+      applyCJC(*r->stroke_dash, style->linecap, style->linejoin);
+    } else {
+      r->stroke_dash->inner_join(mapserver::inner_bevel);
+      r->stroke_dash->line_join(mapserver::bevel_join);
+    }
+    r->m_rasterizer_aa.add_path(*r->stroke_dash);
+  }
+  if (style->antialiased == MS_FALSE)
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline_aliased);
+  else
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
+  return MS_SUCCESS;
+}
+
+int agg2RenderLineTiled(imageObj *img, shapeObj *p, imageObj *tile) {
+
+  mapserver::pattern_filter_bilinear_rgba8 fltr;
+  typedef mapserver::line_image_pattern<
+      mapserver::pattern_filter_bilinear_rgba8>
+      pattern_type;
+  typedef mapserver::renderer_outline_image<renderer_base, pattern_type>
+      renderer_img_type;
+  typedef mapserver::rasterizer_outline_aa<renderer_img_type,
+                                           mapserver::line_coord_sat>
+      rasterizer_img_type;
+  pattern_type patt(fltr);
+
+  AGG2Renderer *r = AGG_RENDERER(img);
+  AGG2Renderer *tileRenderer = AGG_RENDERER(tile);
+
+  line_adaptor lines(p);
+
+  patt.create(tileRenderer->m_pixel_format);
+  renderer_img_type ren_img(r->m_renderer_base, patt);
+  rasterizer_img_type ras_img(ren_img);
+  ras_img.add_path(lines);
+  return MS_SUCCESS;
+}
+
+int agg2RenderPolygon(imageObj *img, shapeObj *p, colorObj *color) {
+  AGG2Renderer *r = AGG_RENDERER(img);
+  polygon_adaptor polygons(p);
+  r->m_rasterizer_aa_gamma.reset();
+  r->m_rasterizer_aa_gamma.filling_rule(mapserver::fill_even_odd);
+  r->m_rasterizer_aa_gamma.add_path(polygons);
+  r->m_renderer_scanline.color(aggColor(color));
+  mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly,
+                              r->m_renderer_scanline);
+  return MS_SUCCESS;
+}
+
+static inline double int26p6_to_dbl(int p) { return double(p) / 64.0; }
+
+template <class PathStorage>
+bool decompose_ft_outline(const FT_Outline &outline, bool flip_y,
+                          const mapserver::trans_affine &mtx,
+                          PathStorage &path) {
+  double x1, y1, x2, y2, x3, y3;
+
+  FT_Vector *point;
+  FT_Vector *limit;
+  char *tags;
+
+  int n;     // index of contour in outline
+  int first; // index of first point in contour
+  char tag;  // current point's state
+
+  first = 0;
+
+  for (n = 0; n < outline.n_contours; n++) {
+    int last; // index of last point in contour
+
+    last = outline.contours[n];
+    limit = outline.points + last;
+
+    FT_Vector v_start = outline.points[first];
+
+    FT_Vector v_control = v_start;
+
+    point = outline.points + first;
+    tags = outline.tags + first;
+    tag = FT_CURVE_TAG(tags[0]);
+
+    // A contour cannot start with a cubic control point!
+    if (tag == FT_CURVE_TAG_CUBIC)
+      return false;
+
+    // check first point to determine origin
+    if (tag == FT_CURVE_TAG_CONIC) {
+      const FT_Vector v_last = outline.points[last];
+
+      // first point is conic control.  Yes, this happens.
+      if (FT_CURVE_TAG(outline.tags[last]) == FT_CURVE_TAG_ON) {
+        // start at last point if it is on the curve
+        v_start = v_last;
+        limit--;
+      } else {
+        // if both first and last points are conic,
+        // start at their middle and record its position
+        // for closure
+        v_start.x = (v_start.x + v_last.x) / 2;
+        v_start.y = (v_start.y + v_last.y) / 2;
+      }
+      point--;
+      tags--;
+    }
+
+    x1 = int26p6_to_dbl(v_start.x);
+    y1 = int26p6_to_dbl(v_start.y);
+    if (flip_y)
+      y1 = -y1;
+    mtx.transform(&x1, &y1);
+    path.move_to(x1, y1);
+
+    while (point < limit) {
+      point++;
+      tags++;
+
+      tag = FT_CURVE_TAG(tags[0]);
+      switch (tag) {
+      case FT_CURVE_TAG_ON: // emit a single line_to
+      {
+        x1 = int26p6_to_dbl(point->x);
+        y1 = int26p6_to_dbl(point->y);
+        if (flip_y)
+          y1 = -y1;
+        mtx.transform(&x1, &y1);
+        path.line_to(x1, y1);
+        // path.line_to(conv(point->x), flip_y ? -conv(point->y) :
+        // conv(point->y));
+        continue;
+      }
+
+      case FT_CURVE_TAG_CONIC: // consume conic arcs
+      {
+        v_control.x = point->x;
+        v_control.y = point->y;
+
+      Do_Conic:
+        if (point < limit) {
+          FT_Vector vec;
+          FT_Vector v_middle;
+
+          point++;
+          tags++;
+          tag = FT_CURVE_TAG(tags[0]);
+
+          vec.x = point->x;
+          vec.y = point->y;
+
+          if (tag == FT_CURVE_TAG_ON) {
+            x1 = int26p6_to_dbl(v_control.x);
+            y1 = int26p6_to_dbl(v_control.y);
+            x2 = int26p6_to_dbl(vec.x);
+            y2 = int26p6_to_dbl(vec.y);
+            if (flip_y) {
+              y1 = -y1;
+              y2 = -y2;
+            }
+            mtx.transform(&x1, &y1);
+            mtx.transform(&x2, &y2);
+            path.curve3(x1, y1, x2, y2);
+            continue;
+          }
+
+          if (tag != FT_CURVE_TAG_CONIC)
+            return false;
+
+          v_middle.x = (v_control.x + vec.x) / 2;
+          v_middle.y = (v_control.y + vec.y) / 2;
+
+          x1 = int26p6_to_dbl(v_control.x);
+          y1 = int26p6_to_dbl(v_control.y);
+          x2 = int26p6_to_dbl(v_middle.x);
+          y2 = int26p6_to_dbl(v_middle.y);
+          if (flip_y) {
+            y1 = -y1;
+            y2 = -y2;
+          }
+          mtx.transform(&x1, &y1);
+          mtx.transform(&x2, &y2);
+          path.curve3(x1, y1, x2, y2);
+
+          // path.curve3(conv(v_control.x),
+          //             flip_y ? -conv(v_control.y) : conv(v_control.y),
+          //             conv(v_middle.x),
+          //             flip_y ? -conv(v_middle.y) : conv(v_middle.y));
+
+          v_control = vec;
+          goto Do_Conic;
+        }
+
+        x1 = int26p6_to_dbl(v_control.x);
+        y1 = int26p6_to_dbl(v_control.y);
+        x2 = int26p6_to_dbl(v_start.x);
+        y2 = int26p6_to_dbl(v_start.y);
+        if (flip_y) {
+          y1 = -y1;
+          y2 = -y2;
+        }
+        mtx.transform(&x1, &y1);
+        mtx.transform(&x2, &y2);
+        path.curve3(x1, y1, x2, y2);
+
+        // path.curve3(conv(v_control.x),
+        //             flip_y ? -conv(v_control.y) : conv(v_control.y),
+        //             conv(v_start.x),
+        //             flip_y ? -conv(v_start.y) : conv(v_start.y));
+        goto Close;
+      }
+
+      default: // FT_CURVE_TAG_CUBIC
+      {
+        FT_Vector vec1, vec2;
+
+        if (point + 1 > limit || FT_CURVE_TAG(tags[1]) != FT_CURVE_TAG_CUBIC) {
+          return false;
+        }
+
+        vec1.x = point[0].x;
+        vec1.y = point[0].y;
+        vec2.x = point[1].x;
+        vec2.y = point[1].y;
+
+        point += 2;
+        tags += 2;
+
+        if (point <= limit) {
+          FT_Vector vec;
+
+          vec.x = point->x;
+          vec.y = point->y;
+
+          x1 = int26p6_to_dbl(vec1.x);
+          y1 = int26p6_to_dbl(vec1.y);
+          x2 = int26p6_to_dbl(vec2.x);
+          y2 = int26p6_to_dbl(vec2.y);
+          x3 = int26p6_to_dbl(vec.x);
+          y3 = int26p6_to_dbl(vec.y);
+          if (flip_y) {
+            y1 = -y1;
+            y2 = -y2;
+            y3 = -y3;
+          }
+          mtx.transform(&x1, &y1);
+          mtx.transform(&x2, &y2);
+          mtx.transform(&x3, &y3);
+          path.curve4(x1, y1, x2, y2, x3, y3);
+
+          // path.curve4(conv(vec1.x),
+          //             flip_y ? -conv(vec1.y) : conv(vec1.y),
+          //             conv(vec2.x),
+          //             flip_y ? -conv(vec2.y) : conv(vec2.y),
+          //             conv(vec.x),
+          //             flip_y ? -conv(vec.y) : conv(vec.y));
+          continue;
+        }
+
+        x1 = int26p6_to_dbl(vec1.x);
+        y1 = int26p6_to_dbl(vec1.y);
+        x2 = int26p6_to_dbl(vec2.x);
+        y2 = int26p6_to_dbl(vec2.y);
+        x3 = int26p6_to_dbl(v_start.x);
+        y3 = int26p6_to_dbl(v_start.y);
+        if (flip_y) {
+          y1 = -y1;
+          y2 = -y2;
+          y3 = -y3;
+        }
+        mtx.transform(&x1, &y1);
+        mtx.transform(&x2, &y2);
+        mtx.transform(&x3, &y3);
+        path.curve4(x1, y1, x2, y2, x3, y3);
+
+        // path.curve4(conv(vec1.x),
+        //             flip_y ? -conv(vec1.y) : conv(vec1.y),
+        //             conv(vec2.x),
+        //             flip_y ? -conv(vec2.y) : conv(vec2.y),
+        //             conv(v_start.x),
+        //             flip_y ? -conv(v_start.y) : conv(v_start.y));
+        goto Close;
+      }
+      }
+    }
+
+    path.close_polygon();
+
+  Close:
+    first = last + 1;
+  }
+
+  return true;
+}
+
+int agg2RenderPolygonTiled(imageObj *img, shapeObj *p, imageObj *tile) {
+  assert(img->format->renderer == tile->format->renderer);
+
+  AGG2Renderer *r = AGG_RENDERER(img);
+  AGG2Renderer *tileRenderer = AGG_RENDERER(tile);
+  polygon_adaptor polygons(p);
+  typedef mapserver::wrap_mode_repeat wrap_type;
+  typedef mapserver::image_accessor_wrap<pixel_format, wrap_type, wrap_type>
+      img_source_type;
+  typedef mapserver::span_pattern_rgba<img_source_type> span_gen_type;
+  mapserver::span_allocator<mapserver::rgba8> sa;
+  r->m_rasterizer_aa.reset();
+  r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
+  img_source_type img_src(tileRenderer->m_pixel_format);
+  span_gen_type sg(img_src, 0, 0);
+  r->m_rasterizer_aa.add_path(polygons);
+  mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly,
+                                 r->m_renderer_base, sa, sg);
+  return MS_SUCCESS;
+}
+
+int agg2RenderGlyphsPath(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                         colorObj *oc, int ow, int /*isMarker*/) {
+
+  const textPathObj *tp = ts->textpath;
+  mapserver::path_storage glyphs;
+  mapserver::trans_affine trans;
+  AGG2Renderer *r = AGG_RENDERER(img);
+  r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
+  for (int i = 0; i < tp->numglyphs; i++) {
+    glyphObj *gl = tp->glyphs + i;
+    trans.reset();
+    trans.rotate(-gl->rot);
+    trans.translate(gl->pnt.x, gl->pnt.y);
+    outline_element *ol = msGetGlyphOutline(gl->face, gl->glyph);
+    if (!ol) {
+      return MS_FAILURE;
+    }
+    decompose_ft_outline(ol->outline, true, trans, glyphs);
+  }
+  mapserver::conv_curve<mapserver::path_storage> m_curves(glyphs);
+  if (oc) {
+    r->m_rasterizer_aa.reset();
+    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
+    mapserver::conv_contour<mapserver::conv_curve<mapserver::path_storage>> cc(
+        m_curves);
+    cc.width(ow + 1);
+    r->m_rasterizer_aa.add_path(cc);
+    r->m_renderer_scanline.color(aggColor(oc));
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
+  }
+  if (c) {
+    r->m_rasterizer_aa.reset();
+    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
+    r->m_rasterizer_aa.add_path(m_curves);
+    r->m_renderer_scanline.color(aggColor(c));
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
+  }
+  return MS_SUCCESS;
+}
+
+mapserver::path_storage imageVectorSymbol(symbolObj *symbol) {
+  mapserver::path_storage path;
+  int is_new = 1;
+
+  for (int i = 0; i < symbol->numpoints; i++) {
+    if ((symbol->points[i].x == -99) && (symbol->points[i].y == -99))
+      is_new = 1;
+
+    else {
+      if (is_new) {
+        path.move_to(symbol->points[i].x, symbol->points[i].y);
+        is_new = 0;
+      } else {
+        path.line_to(symbol->points[i].x, symbol->points[i].y);
+      }
+    }
+  }
+  return path;
+}
+
+int agg2RenderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                           symbolStyleObj *style) {
+  AGG2Renderer *r = AGG_RENDERER(img);
+  double ox = symbol->sizex * 0.5;
+  double oy = symbol->sizey * 0.5;
+
+  mapserver::path_storage path = imageVectorSymbol(symbol);
+  mapserver::trans_affine mtx;
+  mtx *= mapserver::trans_affine_translation(-ox, -oy);
+  mtx *= mapserver::trans_affine_scaling(style->scale);
+  mtx *= mapserver::trans_affine_rotation(-style->rotation);
+  mtx *= mapserver::trans_affine_translation(x, y);
+  path.transform(mtx);
+  if (style->color) {
+    r->m_rasterizer_aa.reset();
+    r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
+    r->m_rasterizer_aa.add_path(path);
+    r->m_renderer_scanline.color(aggColor(style->color));
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly,
+                                r->m_renderer_scanline);
+  }
+  if (style->outlinecolor) {
+    r->m_rasterizer_aa.reset();
+    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
+    r->m_renderer_scanline.color(aggColor(style->outlinecolor));
+    mapserver::conv_stroke<mapserver::path_storage> stroke(path);
+    stroke.width(style->outlinewidth);
+    r->m_rasterizer_aa.add_path(stroke);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly,
+                                r->m_renderer_scanline);
+  }
+  return MS_SUCCESS;
+}
+
+int agg2RenderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                           symbolStyleObj *style) {
+  AGG2Renderer *r = AGG_RENDERER(img);
+  rasterBufferObj *pixmap = symbol->pixmap_buffer;
+  assert(pixmap->type == MS_BUFFER_BYTE_RGBA);
+  rendering_buffer b(pixmap->data.rgba.pixels, pixmap->width, pixmap->height,
+                     pixmap->data.rgba.row_step);
+  pixel_format pf(b);
+
+  r->m_rasterizer_aa.reset();
+  r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
+  if ((style->rotation != 0 && style->rotation != MS_PI * 2.) ||
+      style->scale != 1) {
+    mapserver::trans_affine image_mtx;
+    image_mtx *= mapserver::trans_affine_translation(-(pf.width() / 2.),
+                                                     -(pf.height() / 2.));
+    /*agg angles are antitrigonometric*/
+    image_mtx *= mapserver::trans_affine_rotation(-style->rotation);
+    image_mtx *= mapserver::trans_affine_scaling(style->scale);
+
+    image_mtx *= mapserver::trans_affine_translation(x, y);
+    image_mtx.invert();
+    typedef mapserver::span_interpolator_linear<> interpolator_type;
+    interpolator_type interpolator(image_mtx);
+    mapserver::span_allocator<color_type> sa;
+
+    // "hardcoded" bilinear filter
+    //------------------------------------------
+    typedef mapserver::span_image_filter_rgba_bilinear_clip<pixel_format,
+                                                            interpolator_type>
+        span_gen_type;
+    span_gen_type sg(pf, mapserver::rgba(0, 0, 0, 0), interpolator);
+    mapserver::path_storage pixmap_bbox;
+    int ims_2 =
+        MS_NINT(MS_MAX(pixmap->width, pixmap->height) * style->scale * 1.415) /
+            2 +
+        1;
+
+    pixmap_bbox.move_to(x - ims_2, y - ims_2);
+    pixmap_bbox.line_to(x + ims_2, y - ims_2);
+    pixmap_bbox.line_to(x + ims_2, y + ims_2);
+    pixmap_bbox.line_to(x - ims_2, y + ims_2);
+
+    r->m_rasterizer_aa.add_path(pixmap_bbox);
+    mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly,
+                                   r->m_renderer_base, sa, sg);
+  } else {
+    // just copy the image at the correct location (we place the pixmap on
+    // the nearest integer pixel to avoid blurring)
+    r->m_renderer_base.blend_from(pf, 0, MS_NINT(x - pixmap->width / 2.),
+                                  MS_NINT(y - pixmap->height / 2.));
+  }
+  return MS_SUCCESS;
+}
+
+int agg2RenderEllipseSymbol(imageObj *image, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  AGG2Renderer *r = AGG_RENDERER(image);
+  mapserver::path_storage path;
+  mapserver::ellipse ellipse(x, y, symbol->sizex * style->scale / 2,
+                             symbol->sizey * style->scale / 2);
+  path.concat_path(ellipse);
+  if (style->rotation != 0) {
+    mapserver::trans_affine mtx;
+    mtx *= mapserver::trans_affine_translation(-x, -y);
+    /*agg angles are antitrigonometric*/
+    mtx *= mapserver::trans_affine_rotation(-style->rotation);
+    mtx *= mapserver::trans_affine_translation(x, y);
+    path.transform(mtx);
+  }
+
+  if (style->color) {
+    r->m_rasterizer_aa.reset();
+    r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
+    r->m_rasterizer_aa.add_path(path);
+    r->m_renderer_scanline.color(aggColor(style->color));
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
+  }
+  if (style->outlinewidth) {
+    r->m_rasterizer_aa.reset();
+    r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
+    mapserver::conv_stroke<mapserver::path_storage> stroke(path);
+    stroke.width(style->outlinewidth);
+    r->m_rasterizer_aa.add_path(stroke);
+    r->m_renderer_scanline.color(aggColor(style->outlinecolor));
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly,
+                                r->m_renderer_scanline);
+  }
+  return MS_SUCCESS;
+}
+
+int agg2RenderTile(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/,
+                   double /*y*/) {
+  /*
+  AGG2Renderer *imgRenderer = agg2GetRenderer(img);
+  AGG2Renderer *tileRenderer = agg2GetRenderer(tile);
+  */
+  return MS_FAILURE;
+}
+
+int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height,
+                              int mode) {
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->data.rgba.pixel_step = 4;
+  rb->data.rgba.row_step = rb->data.rgba.pixel_step * width;
+  rb->width = width;
+  rb->height = height;
+  int nBytes = rb->data.rgba.row_step * height;
+  rb->data.rgba.pixels = (band_type *)msSmallCalloc(nBytes, sizeof(band_type));
+  rb->data.rgba.r = &(rb->data.rgba.pixels[band_order::R]);
+  rb->data.rgba.g = &(rb->data.rgba.pixels[band_order::G]);
+  rb->data.rgba.b = &(rb->data.rgba.pixels[band_order::B]);
+  if (mode == MS_IMAGEMODE_RGBA) {
+    rb->data.rgba.a = &(rb->data.rgba.pixels[band_order::A]);
+  }
+  return MS_SUCCESS;
+}
+
+int aggGetRasterBufferHandle(imageObj *img, rasterBufferObj *rb) {
+  AGG2Renderer *r = AGG_RENDERER(img);
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->data.rgba.pixels = r->buffer.data();
+  rb->data.rgba.row_step = r->m_rendering_buffer.stride();
+  rb->data.rgba.pixel_step = 4;
+  rb->width = r->m_rendering_buffer.width();
+  rb->height = r->m_rendering_buffer.height();
+  rb->data.rgba.r = &(r->buffer[band_order::R]);
+  rb->data.rgba.g = &(r->buffer[band_order::G]);
+  rb->data.rgba.b = &(r->buffer[band_order::B]);
+  if (r->use_alpha)
+    rb->data.rgba.a = &(r->buffer[band_order::A]);
+  else
+    rb->data.rgba.a = NULL;
+  return MS_SUCCESS;
+}
+
+int aggGetRasterBufferCopy(imageObj *img, rasterBufferObj *rb) {
+  AGG2Renderer *r = AGG_RENDERER(img);
+  aggInitializeRasterBuffer(rb, img->width, img->height, MS_IMAGEMODE_RGBA);
+  int nBytes = r->m_rendering_buffer.stride() * r->m_rendering_buffer.height();
+  memcpy(rb->data.rgba.pixels, r->buffer.data(), nBytes);
+  return MS_SUCCESS;
+}
+
+int agg2MergeRasterBuffer(imageObj *dest, rasterBufferObj *overlay,
+                          double opacity, int srcX, int srcY, int dstX,
+                          int dstY, int width, int height) {
+  assert(overlay->type == MS_BUFFER_BYTE_RGBA);
+  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height,
+                     overlay->data.rgba.row_step);
+  pixel_format pf(b);
+  AGG2Renderer *r = AGG_RENDERER(dest);
+  mapserver::rect_base<int> src_rect(srcX, srcY, srcX + width, srcY + height);
+  r->m_renderer_base.blend_from(pf, &src_rect, dstX - srcX, dstY - srcY,
+                                unsigned(opacity * 255));
+  return MS_SUCCESS;
+}
+
+/* image i/o */
+imageObj *agg2CreateImage(int width, int height, outputFormatObj *format,
+                          colorObj *bg) {
+  imageObj *image = NULL;
+  if (format->imagemode != MS_IMAGEMODE_RGB &&
+      format->imagemode != MS_IMAGEMODE_RGBA) {
+    msSetError(MS_MISCERR,
+               "AGG2 driver only supports RGB or RGBA pixel models.",
+               "agg2CreateImage()");
+    return image;
+  }
+  if (width > 0 && height > 0) {
+    image = (imageObj *)calloc(1, sizeof(imageObj));
+    MS_CHECK_ALLOC(image, sizeof(imageObj), NULL);
+    AGG2Renderer *r = new AGG2Renderer();
+
+    /* Compute size on 64bit and check that it is compatible of the platform
+     * size_t */
+    const AGG_INT64U bufSize64 =
+        (AGG_INT64U)width * height * 4 * sizeof(band_type);
+    if (bufSize64 > std::numeric_limits<size_t>::max() / 2) {
+      msSetError(MS_MEMERR,
+                 "%s: %d: Out of memory allocating " AGG_INT64U_FRMT
+                 " bytes.\n",
+                 "agg2CreateImage()", __FILE__, __LINE__, bufSize64);
+      free(image);
+      delete r;
+      return NULL;
+    }
+
+    const size_t bufSize = (size_t)bufSize64;
+    try {
+      r->buffer.resize(bufSize / sizeof(band_type));
+    } catch (const std::bad_alloc &) {
+      msSetError(MS_MEMERR,
+                 "%s: %d: Out of memory allocating " AGG_INT64U_FRMT
+                 " bytes.\n",
+                 "agg2CreateImage()", __FILE__, __LINE__, bufSize64);
+      free(image);
+      delete r;
+      return NULL;
+    }
+    r->m_rendering_buffer.attach(r->buffer.data(), width, height, width * 4);
+    r->m_pixel_format.attach(r->m_rendering_buffer);
+    r->m_compop_pixel_format.attach(r->m_rendering_buffer);
+    r->m_renderer_base.attach(r->m_pixel_format);
+    r->m_compop_renderer_base.attach(r->m_compop_pixel_format);
+    r->m_renderer_scanline.attach(r->m_renderer_base);
+    r->m_renderer_scanline_aliased.attach(r->m_renderer_base);
+    r->default_gamma = atof(msGetOutputFormatOption(format, "GAMMA", "0.75"));
+    if (r->default_gamma <= 0.0 || r->default_gamma >= 1.0) {
+      r->default_gamma = 0.75;
+    }
+    r->gamma_function.set(0, r->default_gamma);
+    r->m_rasterizer_aa_gamma.gamma(r->gamma_function);
+    if (bg && !format->transparent)
+      r->m_renderer_base.clear(aggColor(bg));
+    else
+      r->m_renderer_base.clear(AGG_NO_COLOR);
+
+    if (!bg || format->transparent || format->imagemode == MS_IMAGEMODE_RGBA) {
+      r->use_alpha = true;
+    } else {
+      r->use_alpha = false;
+    }
+    image->img.plugin = (void *)r;
+  } else {
+    msSetError(MS_RENDERERERR, "Cannot create cairo image of size %dx%d.",
+               "msImageCreateCairo()", width, height);
+  }
+
+  return image;
+}
+
+int agg2SaveImage(imageObj * /*img*/, mapObj * /*map*/, FILE * /*fp*/,
+                  outputFormatObj * /*format*/) {
+
+  return MS_FAILURE;
+}
+
+int agg2StartNewLayer(imageObj *img, mapObj * /*map*/, layerObj *layer) {
+  AGG2Renderer *r = AGG_RENDERER(img);
+  const char *sgamma = msLayerGetProcessingKey(layer, "GAMMA");
+  double gamma;
+  if (sgamma) {
+    gamma = atof(sgamma);
+    if (gamma <= 0 || gamma >= 1)
+      gamma = 0.75;
+  } else {
+    gamma = r->default_gamma;
+  }
+  if (r->gamma_function.end() != gamma) {
+    r->gamma_function.end(gamma);
+    r->m_rasterizer_aa_gamma.gamma(r->gamma_function);
+  }
+  return MS_SUCCESS;
+}
+
+int agg2CloseNewLayer(imageObj * /*img*/, mapObj * /*map*/,
+                      layerObj * /*layer*/) {
+  return MS_SUCCESS;
+}
+
+int agg2FreeImage(imageObj *image) {
+  AGG2Renderer *r = AGG_RENDERER(image);
+  delete r;
+  image->img.plugin = NULL;
+  return MS_SUCCESS;
+}
+
+int agg2FreeSymbol(symbolObj * /*symbol*/) { return MS_SUCCESS; }
+
+int agg2InitCache(void **vcache) {
+  aggRendererCache *cache = new aggRendererCache();
+  *vcache = (void *)cache;
+  return MS_SUCCESS;
+}
+
+int agg2Cleanup(void *vcache) {
+  aggRendererCache *cache = (aggRendererCache *)vcache;
+  delete cache;
+  return MS_SUCCESS;
+}
+
+// ------------------------------------------------------------------------
+// Function to create a custom hatch symbol based on an arbitrary angle.
+// ------------------------------------------------------------------------
+static mapserver::path_storage createHatch(double ox, double oy, double rx,
+                                           double ry, int sx, int sy,
+                                           double angle, double step) {
+  mapserver::path_storage path;
+  // restrict the angle to [0 180[, i.e ]-pi/2,pi/2] in radians
+  angle = fmod(angle, 360.0);
+  if (angle < 0)
+    angle += 360;
+  if (angle >= 180)
+    angle -= 180;
+
+  // treat 2 easy cases which would cause divide by 0 in generic case
+  if (angle == 0) {
+    double y0 = step - fmod(oy - ry, step);
+    if ((oy - ry) < 0) {
+      y0 -= step;
+    }
+    for (double y = y0; y < sy; y += step) {
+      path.move_to(0, y);
+      path.line_to(sx, y);
+    }
+    return path;
+  }
+  if (angle == 90) {
+    double x0 = step - fmod(ox - rx, step);
+    if ((ox - rx) < 0) {
+      x0 -= step;
+    }
+    for (double x = x0; x < sx; x += step) {
+      path.move_to(x, 0);
+      path.line_to(x, sy);
+    }
+    return path;
+  }
+
+  double theta = (90 - angle) * MS_DEG_TO_RAD; /* theta in ]-pi/2 , pi/2] */
+  double ct = cos(theta);
+  double st = sin(theta);
+  double invct = 1.0 / ct;
+  double invst = 1.0 / st;
+  double
+      r0; /* distance from first hatch line to the top-left (if angle in 0,pi/2)
+               or bottom-left (if angle in -pi/2,0) corner of the hatch bbox */
+  double rmax = sqrt((
+      double)(sx * sx +
+              sy *
+                  sy)); /* distance to the furthest hatch we will have to create
+TODO: this could be optimized for bounding boxes where width is very different
+than height for certain hatch angles */
+  double rref =
+      rx * ct + ry * st; /* distance to the line passing through the refpoint,
+                            origin is (0,0) of the imageObj */
+  double
+      rcorner; /* distance to the line passing through the topleft or bottomleft
+                  corner of the hatch bbox (origin is (0,0) of imageObj) */
+
+  /* calculate the distance from the refpoint to the top right of the path */
+  if (angle < 90) {
+    rcorner = ox * ct + oy * st;
+    r0 = step - fmod(rcorner - rref, step);
+    if (rcorner - rref < 0)
+      r0 -= step;
+  } else {
+    rcorner = ox * ct + (oy + sy) * st;
+    r0 = step - fmod(rcorner - rref, step);
+    if (rcorner - rref < 0)
+      r0 -= step;
+    st = -st;
+    invst = -invst;
+  }
+
+  // parametrize each line as r = x.cos(theta) + y.sin(theta)
+  for (double r = r0; r < rmax; r += step) {
+    int inter = 0;
+    double x, y;
+    double pt[4]; // array to store the coordinates of intersection of the line
+                  // with the sides
+    // in the general case there will only be two intersections
+    // so pt[4] should be sufficient to store the coordinates of the
+    // intersection, but we allocate pt[8] to treat the special and
+    // rare/unfortunate case when the line is a perfect diagonal (and therfore
+    // intersects all four sides) note that the order for testing is important
+    // in this case so that the first two intersection points actually
+    // correspond to the diagonal and not a degenerate line
+
+    // test for intersection with each side
+
+    y = r * invst;
+    x = 0; // test for intersection with left of image
+    if (y >= 0 && y <= sy) {
+      pt[2 * inter] = x;
+      pt[2 * inter + 1] = y;
+      inter++;
+    }
+    x = sx;
+    y = (r - sx * ct) * invst; // test for intersection with right of image
+    if (y >= 0 && y <= sy) {
+      pt[2 * inter] = x;
+      pt[2 * inter + 1] = y;
+      inter++;
+    }
+    if (inter < 2) {
+      y = 0;
+      x = r * invct; // test for intersection with top of image
+      if (x >= 0 && x <= sx) {
+        pt[2 * inter] = x;
+        pt[2 * inter + 1] = y;
+        inter++;
+      }
+    }
+    if (inter < 2) {
+      y = sy;
+      x = (r - sy * st) * invct; // test for intersection with bottom of image
+      if (x >= 0 && x <= sx) {
+        pt[2 * inter] = x;
+        pt[2 * inter + 1] = y;
+        inter++;
+      }
+    }
+    if (inter == 2 && (pt[0] != pt[2] || pt[1] != pt[3])) {
+      // the line intersects with two sides of the image, it should therefore be
+      // drawn
+      if (angle < 90) {
+        path.move_to(pt[0], pt[1]);
+        path.line_to(pt[2], pt[3]);
+      } else {
+        path.move_to(pt[0], sy - pt[1]);
+        path.line_to(pt[2], sy - pt[3]);
+      }
+    }
+  }
+  return path;
+}
+
+template <class VertexSource>
+int renderPolygonHatches(imageObj *img, VertexSource &clipper,
+                         colorObj *color) {
+  if (img->format->renderer == MS_RENDER_WITH_AGG) {
+    AGG2Renderer *r = AGG_RENDERER(img);
+    r->m_rasterizer_aa_gamma.reset();
+    r->m_rasterizer_aa_gamma.filling_rule(mapserver::fill_non_zero);
+    r->m_rasterizer_aa_gamma.add_path(clipper);
+    r->m_renderer_scanline.color(aggColor(color));
+    mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly,
+                                r->m_renderer_scanline);
+  } else {
+    shapeObj shape;
+    msInitShape(&shape);
+    int allocated = 20;
+    lineObj line;
+    shape.line = &line;
+    shape.numlines = 1;
+    shape.line[0].point =
+        (pointObj *)msSmallCalloc(allocated, sizeof(pointObj));
+    shape.line[0].numpoints = 0;
+    double x = 0, y = 0;
+    unsigned int cmd;
+    clipper.rewind(0);
+    while ((cmd = clipper.vertex(&x, &y)) != mapserver::path_cmd_stop) {
+      switch (cmd) {
+      case mapserver::path_cmd_line_to:
+        if (shape.line[0].numpoints == allocated) {
+          allocated *= 2;
+          shape.line[0].point = (pointObj *)msSmallRealloc(
+              shape.line[0].point, allocated * sizeof(pointObj));
+        }
+        shape.line[0].point[shape.line[0].numpoints].x = x;
+        shape.line[0].point[shape.line[0].numpoints].y = y;
+        shape.line[0].numpoints++;
+        break;
+      case mapserver::path_cmd_move_to:
+        shape.line[0].point[0].x = x;
+        shape.line[0].point[0].y = y;
+        shape.line[0].numpoints = 1;
+        break;
+      case mapserver::path_cmd_end_poly | mapserver::path_flags_close:
+        if (shape.line[0].numpoints > 2) {
+          if (MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(img)->renderPolygon(
+                                            img, &shape, color))) {
+            free(shape.line[0].point);
+            return MS_FAILURE;
+          }
+        }
+        break;
+      default:
+        assert(0); // WTF?
+      }
+    }
+    free(shape.line[0].point);
+  }
+  return MS_SUCCESS;
+}
+
+int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing, double width,
+                   double *pattern, int patternlength, double angle,
+                   colorObj *color) {
+  assert(MS_RENDERER_PLUGIN(img->format));
+  msComputeBounds(poly);
+
+  /* amount we should expand the bounding box by */
+  double exp = width * 0.7072;
+
+  /* width and height of the bounding box we will be creating the hatch in */
+  int pw = (int)(poly->bounds.maxx - poly->bounds.minx + exp * 2) + 1;
+  int ph = (int)(poly->bounds.maxy - poly->bounds.miny + exp * 2) + 1;
+
+  /* position of the top-left corner of the bounding box */
+  double ox = poly->bounds.minx - exp;
+  double oy = poly->bounds.miny - exp;
+
+  // create a rectangular hatch of size pw,ph starting at 0,0
+  // the created hatch is of the size of the shape's bounding box
+  mapserver::path_storage hatch =
+      createHatch(ox, oy, img->refpt.x, img->refpt.y, pw, ph, angle, spacing);
+  if (hatch.total_vertices() <= 0)
+    return MS_SUCCESS;
+
+  // translate the hatch so it overlaps the current shape
+  hatch.transform(mapserver::trans_affine_translation(ox, oy));
+
+  polygon_adaptor polygons(poly);
+
+  if (patternlength > 1) {
+    // dash the color-hatch and render it clipped by the shape
+    mapserver::conv_dash<mapserver::path_storage> dash(hatch);
+    mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage>>
+        stroke(dash);
+    for (int i = 0; i < patternlength; i += 2) {
+      if (i < patternlength - 1) {
+        dash.add_dash(pattern[i], pattern[i + 1]);
+      }
+    }
+    stroke.width(width);
+    stroke.line_cap(mapserver::butt_cap);
+    mapserver::conv_clipper<
+        polygon_adaptor,
+        mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage>>>
+        clipper(polygons, stroke, mapserver::clipper_and);
+    renderPolygonHatches(img, clipper, color);
+  } else {
+    // render the hatch clipped by the shape
+    mapserver::conv_stroke<mapserver::path_storage> stroke(hatch);
+    stroke.width(width);
+    stroke.line_cap(mapserver::butt_cap);
+    mapserver::conv_clipper<polygon_adaptor,
+                            mapserver::conv_stroke<mapserver::path_storage>>
+        clipper(polygons, stroke, mapserver::clipper_and);
+    renderPolygonHatches(img, clipper, color);
+  }
+
+  // assert(prevCmd == mapserver::path_cmd_line_to);
+  // delete lines;
+  return MS_SUCCESS;
+}
+
+#ifdef USE_PIXMAN
+static pixman_op_t ms2pixman_compop(CompositingOperation c) {
+  switch (c) {
+  case MS_COMPOP_CLEAR:
+    return PIXMAN_OP_CLEAR;
+  case MS_COMPOP_SRC:
+    return PIXMAN_OP_SRC;
+  case MS_COMPOP_DST:
+    return PIXMAN_OP_DST;
+  case MS_COMPOP_SRC_OVER:
+    return PIXMAN_OP_OVER;
+  case MS_COMPOP_DST_OVER:
+    return PIXMAN_OP_OVER_REVERSE;
+  case MS_COMPOP_SRC_IN:
+    return PIXMAN_OP_IN;
+  case MS_COMPOP_DST_IN:
+    return PIXMAN_OP_IN_REVERSE;
+  case MS_COMPOP_SRC_OUT:
+    return PIXMAN_OP_OUT;
+  case MS_COMPOP_DST_OUT:
+    return PIXMAN_OP_OUT_REVERSE;
+  case MS_COMPOP_SRC_ATOP:
+    return PIXMAN_OP_ATOP;
+  case MS_COMPOP_DST_ATOP:
+    return PIXMAN_OP_ATOP_REVERSE;
+  case MS_COMPOP_XOR:
+    return PIXMAN_OP_XOR;
+  case MS_COMPOP_PLUS:
+    return PIXMAN_OP_ADD;
+  case MS_COMPOP_MULTIPLY:
+    return PIXMAN_OP_MULTIPLY;
+  case MS_COMPOP_SCREEN:
+    return PIXMAN_OP_SCREEN;
+  case MS_COMPOP_OVERLAY:
+    return PIXMAN_OP_OVERLAY;
+  case MS_COMPOP_DARKEN:
+    return PIXMAN_OP_DARKEN;
+  case MS_COMPOP_LIGHTEN:
+    return PIXMAN_OP_LIGHTEN;
+  case MS_COMPOP_COLOR_DODGE:
+    return PIXMAN_OP_COLOR_DODGE;
+  case MS_COMPOP_COLOR_BURN:
+    return PIXMAN_OP_COLOR_DODGE;
+  case MS_COMPOP_HARD_LIGHT:
+    return PIXMAN_OP_HARD_LIGHT;
+  case MS_COMPOP_SOFT_LIGHT:
+    return PIXMAN_OP_SOFT_LIGHT;
+  case MS_COMPOP_DIFFERENCE:
+    return PIXMAN_OP_DIFFERENCE;
+  case MS_COMPOP_EXCLUSION:
+    return PIXMAN_OP_EXCLUSION;
+  case MS_COMPOP_INVERT:
+  case MS_COMPOP_INVERT_RGB:
+  case MS_COMPOP_MINUS:
+  case MS_COMPOP_CONTRAST:
+  default:
+    return PIXMAN_OP_OVER;
+  }
+}
+#else
+static mapserver::comp_op_e ms2agg_compop(CompositingOperation c) {
+  switch (c) {
+  case MS_COMPOP_CLEAR:
+    return mapserver::comp_op_clear;
+  case MS_COMPOP_SRC:
+    return mapserver::comp_op_src;
+  case MS_COMPOP_DST:
+    return mapserver::comp_op_dst;
+  case MS_COMPOP_SRC_OVER:
+    return mapserver::comp_op_src_over;
+  case MS_COMPOP_DST_OVER:
+    return mapserver::comp_op_dst_over;
+  case MS_COMPOP_SRC_IN:
+    return mapserver::comp_op_src_in;
+  case MS_COMPOP_DST_IN:
+    return mapserver::comp_op_dst_in;
+  case MS_COMPOP_SRC_OUT:
+    return mapserver::comp_op_src_out;
+  case MS_COMPOP_DST_OUT:
+    return mapserver::comp_op_dst_out;
+  case MS_COMPOP_SRC_ATOP:
+    return mapserver::comp_op_src_atop;
+  case MS_COMPOP_DST_ATOP:
+    return mapserver::comp_op_dst_atop;
+  case MS_COMPOP_XOR:
+    return mapserver::comp_op_xor;
+  case MS_COMPOP_PLUS:
+    return mapserver::comp_op_plus;
+  case MS_COMPOP_MINUS:
+    return mapserver::comp_op_minus;
+  case MS_COMPOP_MULTIPLY:
+    return mapserver::comp_op_multiply;
+  case MS_COMPOP_SCREEN:
+    return mapserver::comp_op_screen;
+  case MS_COMPOP_OVERLAY:
+    return mapserver::comp_op_overlay;
+  case MS_COMPOP_DARKEN:
+    return mapserver::comp_op_darken;
+  case MS_COMPOP_LIGHTEN:
+    return mapserver::comp_op_lighten;
+  case MS_COMPOP_COLOR_DODGE:
+    return mapserver::comp_op_color_dodge;
+  case MS_COMPOP_COLOR_BURN:
+    return mapserver::comp_op_color_burn;
+  case MS_COMPOP_HARD_LIGHT:
+    return mapserver::comp_op_hard_light;
+  case MS_COMPOP_SOFT_LIGHT:
+    return mapserver::comp_op_soft_light;
+  case MS_COMPOP_DIFFERENCE:
+    return mapserver::comp_op_difference;
+  case MS_COMPOP_EXCLUSION:
+    return mapserver::comp_op_exclusion;
+  case MS_COMPOP_CONTRAST:
+    return mapserver::comp_op_contrast;
+  case MS_COMPOP_INVERT:
+    return mapserver::comp_op_invert;
+  case MS_COMPOP_INVERT_RGB:
+    return mapserver::comp_op_invert_rgb;
+  default:
+    return mapserver::comp_op_src_over;
+  }
+}
+#endif
+
+int aggCompositeRasterBuffer(imageObj *dest, rasterBufferObj *overlay,
+                             CompositingOperation comp, int opacity) {
+  assert(overlay->type == MS_BUFFER_BYTE_RGBA);
+  AGG2Renderer *r = AGG_RENDERER(dest);
+#ifdef USE_PIXMAN
+  pixman_image_t *si = pixman_image_create_bits(
+      PIXMAN_a8r8g8b8, overlay->width, overlay->height,
+      (uint32_t *)overlay->data.rgba.pixels, overlay->data.rgba.row_step);
+  pixman_image_t *bi = pixman_image_create_bits(
+      PIXMAN_a8r8g8b8, dest->width, dest->height,
+      reinterpret_cast<uint32_t *>(&(r->buffer[0])), dest->width * 4);
+  pixman_image_t *alpha_mask_i = NULL, *alpha_mask_i_ptr;
+  pixman_image_set_filter(si, PIXMAN_FILTER_NEAREST, NULL, 0);
+  unsigned char *alpha_mask = NULL;
+  if (opacity > 0) {
+    if (opacity == 100) {
+      alpha_mask_i_ptr = NULL;
+    } else {
+      unsigned char alpha = (unsigned char)(opacity * 2.55);
+      if (!alpha_mask_i) {
+        alpha_mask = (unsigned char *)msSmallMalloc(dest->width * dest->height);
+        alpha_mask_i =
+            pixman_image_create_bits(PIXMAN_a8, dest->width, dest->height,
+                                     (uint32_t *)alpha_mask, dest->width);
+      }
+      memset(alpha_mask, alpha, dest->width * dest->height);
+      alpha_mask_i_ptr = alpha_mask_i;
+    }
+    pixman_image_composite(ms2pixman_compop(comp), si, alpha_mask_i_ptr, bi, 0,
+                           0, 0, 0, 0, 0, dest->width, dest->height);
+  }
+  pixman_image_unref(si);
+  pixman_image_unref(bi);
+  if (alpha_mask_i) {
+    pixman_image_unref(alpha_mask_i);
+    msFree(alpha_mask);
+  }
+  return MS_SUCCESS;
+#else
+  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height,
+                     overlay->data.rgba.row_step);
+  pixel_format pf(b);
+  mapserver::comp_op_e comp_op = ms2agg_compop(comp);
+  if (comp_op == mapserver::comp_op_src_over) {
+    r->m_renderer_base.blend_from(pf, 0, 0, 0, unsigned(opacity * 2.55));
+  } else {
+    compop_pixel_format pixf(r->m_rendering_buffer);
+    compop_renderer_base ren(pixf);
+    pixf.comp_op(comp_op);
+    ren.blend_from(pf, 0, 0, 0, unsigned(opacity * 2.55));
+  }
+  return MS_SUCCESS;
+#endif
+}
+
+void msApplyBlurringCompositingFilter(rasterBufferObj *rb,
+                                      unsigned int radius) {
+  rendering_buffer b(rb->data.rgba.pixels, rb->width, rb->height,
+                     rb->data.rgba.row_step);
+  pixel_format pf(b);
+  mapserver::stack_blur_rgba32(pf, radius, radius);
+}
+
+int msPopulateRendererVTableAGG(rendererVTableObj *renderer) {
+  renderer->compositeRasterBuffer = &aggCompositeRasterBuffer;
+  renderer->supports_pixel_buffer = 1;
+  renderer->use_imagecache = 0;
+  renderer->supports_clipping = 0;
+  renderer->supports_svg = 0;
+  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
+  agg2InitCache(&(MS_RENDERER_CACHE(renderer)));
+  renderer->cleanup = agg2Cleanup;
+  renderer->renderLine = &agg2RenderLine;
+
+  renderer->renderPolygon = &agg2RenderPolygon;
+  renderer->renderPolygonTiled = &agg2RenderPolygonTiled;
+  renderer->renderLineTiled = &agg2RenderLineTiled;
+
+  renderer->renderGlyphs = &agg2RenderGlyphsPath;
+
+  renderer->renderVectorSymbol = &agg2RenderVectorSymbol;
+
+  renderer->renderPixmapSymbol = &agg2RenderPixmapSymbol;
+
+  renderer->renderEllipseSymbol = &agg2RenderEllipseSymbol;
+
+  renderer->renderTile = &agg2RenderTile;
+
+  renderer->getRasterBufferHandle = &aggGetRasterBufferHandle;
+  renderer->getRasterBufferCopy = aggGetRasterBufferCopy;
+  renderer->initializeRasterBuffer = aggInitializeRasterBuffer;
+
+  renderer->mergeRasterBuffer = &agg2MergeRasterBuffer;
+  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
+  renderer->createImage = &agg2CreateImage;
+  renderer->saveImage = &agg2SaveImage;
+
+  renderer->startLayer = &agg2StartNewLayer;
+  renderer->endLayer = &agg2CloseNewLayer;
+
+  renderer->freeImage = &agg2FreeImage;
+  renderer->freeSymbol = &agg2FreeSymbol;
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapagg.h 8.2.0~beta1-1~exp1/src/mapagg.h
--- 8.0.1-5/src/mapagg.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapagg.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,157 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  AGG template library types.
+ * Author:   John Novak (jnovak@novacell.com)
+ * Author:   Thomas Bonfort (tbonfort@terriscope.fr)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ******************************************************************************/
+
+#include "renderers/agg/include/agg_path_storage.h"
+
+/*
+ * interface to a shapeObj representing lines, providing the functions
+ * needed by the agg rasterizer. treats shapeObjs with multiple linestrings.
+ */
+class line_adaptor {
+public:
+  explicit line_adaptor(shapeObj *shape) : s(shape) {
+    m_line = s->line;        /*first line*/
+    m_point = m_line->point; /*current vertex is first vertex of first line*/
+    m_lend = &(s->line[s->numlines]);             /*pointer to after last line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last vertex
+                                                     of first line*/
+  }
+
+  /* a class with virtual functions should also provide a virtual destructor */
+  virtual ~line_adaptor() {}
+
+  void rewind(unsigned) {
+    m_line = s->line;        /*first line*/
+    m_point = m_line->point; /*current vertex is first vertex of first line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last vertex
+                                                     of first line*/
+  }
+
+  virtual unsigned vertex(double *x, double *y) {
+    if (m_point < m_pend) {
+      /*here we treat the case where a real vertex is returned*/
+      bool first =
+          m_point == m_line->point; /*is this the first vertex of a line*/
+      *x = m_point->x;
+      *y = m_point->y;
+      m_point++;
+      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
+    }
+    /*if here, we're at the end of a line*/
+    m_line++;
+    *x = *y = 0.0;
+    if (m_line >= m_lend) /*is this the last line of the shapObj. normally,
+           (m_line==m_lend) should be a sufficient test, as the caller should
+           not call this function if a previous call returned path_cmd_stop.*/
+      return mapserver::path_cmd_stop; /*no more points to process*/
+
+    /*if here, there are more lines in the shapeObj, continue with next one*/
+    m_point = m_line->point; /*pointer to first point of next line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last point
+                                                     of next line*/
+
+    return vertex(x, y); /*this will return the first point of the next line*/
+  }
+
+protected:
+  shapeObj *s;
+  lineObj *m_line,   /*current line pointer*/
+      *m_lend;       /*points to after the last line*/
+  pointObj *m_point, /*current point*/
+      *m_pend;       /*points to after last point of current line*/
+};
+
+class polygon_adaptor {
+public:
+  explicit polygon_adaptor(shapeObj *shape) : s(shape) {
+    m_line = s->line;                             /*first lines*/
+    m_point = m_line->point;                      /*first vertex of first line*/
+    m_lend = &(s->line[s->numlines]);             /*pointer to after last line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last vertex
+                                                     of first line*/
+  }
+
+  /* a class with virtual functions should also provide a virtual destructor */
+  virtual ~polygon_adaptor() {}
+
+  void rewind(unsigned) {
+    /*reset pointers*/
+    m_stop = false;
+    m_line = s->line;
+    m_point = m_line->point;
+    m_pend = &(m_line->point[m_line->numpoints]);
+  }
+
+  virtual unsigned vertex(double *x, double *y) {
+    if (m_point < m_pend) {
+      /*if here, we have a real vertex*/
+      bool first = m_point == m_line->point;
+      *x = m_point->x;
+      *y = m_point->y;
+      m_point++;
+      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
+    }
+    *x = *y = 0.0;
+    if (!m_stop) {
+      /*if here, we're after the last vertex of the current line
+       * we return the command to close the current polygon*/
+      m_line++;
+      if (m_line >= m_lend) {
+        /*if here, we've finished all the vertexes of the shape.
+         * we still return the command to close the current polygon,
+         * but set m_stop so the subsequent call to vertex() will return
+         * the stop command*/
+        m_stop = true;
+        return mapserver::path_cmd_end_poly;
+      }
+      /*if here, there's another line in the shape, so we set the pointers
+       * accordingly and return the command to close the current polygon*/
+      m_point = m_line->point; /*first vertex of next line*/
+      m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last
+                                                       vertex of next line*/
+      return mapserver::path_cmd_end_poly;
+    }
+    /*if here, a previous call to vertex informed us that we'd consumed all the
+     * vertexes of the shape. return the command to stop processing this shape*/
+    return mapserver::path_cmd_stop;
+  }
+
+protected:
+  shapeObj *s;
+  double ox = 0.0;
+  double oy = 0.0;
+  lineObj *m_line,     /*pointer to current line*/
+      *m_lend;         /*pointer to after last line of the shape*/
+  pointObj *m_point,   /*pointer to current vertex*/
+      *m_pend;         /*pointer to after last vertex of current line*/
+  bool m_stop = false; /*should next call return stop command*/
+};
+
+mapserver::path_storage imageVectorSymbol(symbolObj *);
diff -pruN 8.0.1-5/src/mapaxisorder.h 8.2.0~beta1-1~exp1/src/mapaxisorder.h
--- 8.0.1-5/src/mapaxisorder.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapaxisorder.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4139 @@
+/******************************************************************************
+ * $Id: $
+ *
+ * Project:  MapServer
+ * Purpose:  Axis lookup table
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/*
+ * Generated file
+ *
+ * This file was generated from by means of a script. Do not edit manually.
+ */
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+static const unsigned char axisOrientationEpsgCodes[] = {
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0};
+
+#ifdef __cplusplus
+}
+#endif
diff -pruN 8.0.1-5/src/mapbits.c 8.2.0~beta1-1~exp1/src/mapbits.c
--- 8.0.1-5/src/mapbits.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapbits.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,111 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of bit array functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ * Notes: Derived from code placed in the public domain by Bob Stout, for more
+ * information see http://c.snippets.org/snip_lister.php?fname=bitarray.c.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#include <limits.h>
+
+/*
+ * Hardcoded size of our bit array.
+ * See function msGetNextBit for another hardcoded value.
+ */
+
+/* #define msGetBit(array, index) (*((array) + (index)/MS_ARRAY_BIT) & ( 1 <<
+ * ((index) % MS_ARRAY_BIT))) */
+
+size_t msGetBitArraySize(int numbits) {
+  return ((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT);
+}
+
+ms_bitarray msAllocBitArray(int numbits) {
+  ms_bitarray array =
+      calloc((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT, MS_ARRAY_BIT);
+
+  return (array);
+}
+
+int msGetBit(ms_const_bitarray array, int index) {
+  array += index / MS_ARRAY_BIT;
+  return (*array & (1U << (index % MS_ARRAY_BIT))) != 0; /* 0 or 1 */
+}
+
+/*
+** msGetNextBit( status, start, size)
+**
+** Quickly find the next bit set. If start == 0 and 0 is set, will return 0.
+** If hits end of bitmap without finding set bit, will return -1.
+**
+*/
+int msGetNextBit(ms_const_bitarray array, int i, int size) {
+
+  register ms_uint32 b;
+
+  while (i < size) {
+    b = *(array + (i / MS_ARRAY_BIT));
+    if (b && (b >> (i % MS_ARRAY_BIT))) {
+      /* There is something in this byte */
+      /* And it is not to the right of us */
+      if (b & (1U << (i % MS_ARRAY_BIT))) {
+        /* There is something at this bit! */
+        return i;
+      } else {
+        i++;
+      }
+    } else {
+      /* Nothing in this byte, move to start of next byte */
+      i += MS_ARRAY_BIT - (i % MS_ARRAY_BIT);
+    }
+  }
+
+  /* Got to the last byte with no hits! */
+  return -1;
+}
+
+void msSetBit(ms_bitarray array, int index, int value) {
+  array += index / MS_ARRAY_BIT;
+  if (value)
+    *array |= 1U << (index % MS_ARRAY_BIT); /* set bit */
+  else
+    *array &= ~(1U << (index % MS_ARRAY_BIT)); /* clear bit */
+}
+
+void msSetAllBits(ms_bitarray array, int numbits, int value) {
+  if (value)
+    memset(array, 0xff, ((numbits + 7) / 8)); /* set bit */
+  else
+    memset(array, 0x0, ((numbits + 7) / 8)); /* clear bit */
+}
+
+void msFlipBit(ms_bitarray array, int index) {
+  array += index / MS_ARRAY_BIT;
+  *array ^= 1U << (index % MS_ARRAY_BIT); /* flip bit */
+}
diff -pruN 8.0.1-5/src/mapcairo.c 8.2.0~beta1-1~exp1/src/mapcairo.c
--- 8.0.1-5/src/mapcairo.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcairo.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1237 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Cairo Rendering functions
+ * Author:   Thomas Bonfort
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2009 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+#include "mapserver.h"
+
+#ifdef USE_CAIRO
+
+#include <cairo.h>
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <cairo-pdf.h>
+#include <cairo-svg.h>
+#include <cairo-win32.h>
+#else
+#include <cairo/cairo-pdf.h>
+#include <cairo/cairo-svg.h>
+#endif
+
+#ifdef USE_SVG_CAIRO
+#include <svg-cairo.h>
+#else
+#ifdef USE_RSVG
+#include <librsvg/rsvg.h>
+#ifndef LIBRSVG_CHECK_VERSION
+#include <librsvg/librsvg-features.h>
+#endif
+#ifndef RSVG_CAIRO_H
+#include <librsvg/rsvg-cairo.h>
+#endif
+#include <glib-object.h>
+#endif
+#endif
+
+#include <cpl_string.h>
+#include "cpl_conv.h"
+#include <gdal.h>
+
+#include "fontcache.h"
+
+#include <cairo-ft.h>
+/*
+#include <pango/pangocairo.h>
+#include <glib.h>
+*/
+#include <string.h>
+/*
+#include <ft2build.h>
+#include FT_FREETYPE_H
+*/
+
+typedef struct cairoFaceCache cairoFaceCache;
+struct cairoFaceCache {
+  cairo_font_face_t *face;
+  FT_Face ftface;
+  cairo_font_options_t *options;
+  cairoFaceCache *next;
+};
+
+void freeCairoFaceCache(cairoFaceCache *fc) {
+  cairo_font_face_destroy(fc->face);
+  cairo_font_options_destroy(fc->options);
+}
+
+typedef struct {
+  cairoFaceCache *cairofacecache;
+  /* dummy surface and context */
+  unsigned char dummydata[4];
+  cairo_surface_t *dummysurface;
+  cairo_t *dummycr;
+} cairoCacheData;
+
+void initializeCache(void **vcache) {
+  cairoCacheData *cache = (cairoCacheData *)malloc(sizeof(cairoCacheData));
+  *vcache = cache;
+
+  cache->cairofacecache = NULL;
+  /* dummy surface and context */
+  cache->dummysurface = cairo_image_surface_create_for_data(
+      cache->dummydata, CAIRO_FORMAT_ARGB32, 1, 1, 4);
+  cache->dummycr = cairo_create(cache->dummysurface);
+}
+
+int cleanupCairo(void *cache) {
+  cairoCacheData *ccache = (cairoCacheData *)cache;
+
+  if (ccache->dummycr) {
+    cairo_destroy(ccache->dummycr);
+  }
+  if (ccache->dummysurface) {
+    cairo_surface_destroy(ccache->dummysurface);
+  }
+  if (ccache->cairofacecache) {
+    cairoFaceCache *next, *cur;
+    cur = ccache->cairofacecache;
+    do {
+      next = cur->next;
+      freeCairoFaceCache(cur);
+      free(cur);
+      cur = next;
+    } while (cur);
+  }
+
+  free(ccache);
+  return MS_SUCCESS;
+}
+
+typedef struct {
+  cairo_surface_t *surface;
+  cairo_t *cr;
+  bufferObj *outputStream;
+  int use_alpha;
+} cairo_renderer;
+
+#define CAIRO_RENDERER(im) ((cairo_renderer *)(im->img.plugin))
+
+int freeImageCairo(imageObj *img) {
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  if (r) {
+    cairo_destroy(r->cr);
+    cairo_surface_finish(r->surface);
+    cairo_surface_destroy(r->surface);
+    if (r->outputStream) {
+      msBufferFree(r->outputStream);
+      free(r->outputStream);
+    }
+    free(r);
+  }
+  return MS_SUCCESS;
+}
+
+static cairoFaceCache *getCairoFontFace(cairoCacheData *cache, FT_Face ftface) {
+  cairoFaceCache *cur = cache->cairofacecache;
+  while (cur) {
+    if (cur->ftface == ftface)
+      return cur;
+    cur = cur->next;
+  }
+  cur = msSmallMalloc(sizeof(cairoFaceCache));
+  cur->next = cache->cairofacecache;
+  cache->cairofacecache = cur;
+  cur->ftface = ftface;
+  cur->face = cairo_ft_font_face_create_for_ft_face(ftface, 0);
+  cur->options = cairo_font_options_create();
+  cairo_font_options_set_hint_style(cur->options, CAIRO_HINT_STYLE_NONE);
+  return cur;
+}
+
+#define msCairoSetSourceColor(cr, c)                                           \
+  cairo_set_source_rgba((cr), (c)->red / 255.0, (c)->green / 255.0,            \
+                        (c)->blue / 255.0, (c)->alpha / 255.0);
+
+int renderLineCairo(imageObj *img, shapeObj *p, strokeStyleObj *stroke) {
+  int i, j;
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  assert(stroke->color);
+  cairo_new_path(r->cr);
+  msCairoSetSourceColor(r->cr, stroke->color);
+  for (i = 0; i < p->numlines; i++) {
+    lineObj *l = &(p->line[i]);
+    if (l->numpoints == 0)
+      continue;
+    cairo_move_to(r->cr, l->point[0].x, l->point[0].y);
+    for (j = 1; j < l->numpoints; j++) {
+      cairo_line_to(r->cr, l->point[j].x, l->point[j].y);
+    }
+  }
+  if (stroke->patternlength > 0) {
+    cairo_set_dash(r->cr, stroke->pattern, stroke->patternlength,
+                   -stroke->patternoffset);
+  }
+  switch (stroke->linecap) {
+  case MS_CJC_BUTT:
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_BUTT);
+    break;
+  case MS_CJC_SQUARE:
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_SQUARE);
+    break;
+  case MS_CJC_ROUND:
+  case MS_CJC_NONE:
+  default:
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_ROUND);
+  }
+  cairo_set_line_width(r->cr, stroke->width);
+  cairo_stroke(r->cr);
+  if (stroke->patternlength > 0) {
+    cairo_set_dash(r->cr, stroke->pattern, 0, 0);
+  }
+  return MS_SUCCESS;
+}
+
+int renderPolygonCairo(imageObj *img, shapeObj *p, colorObj *c) {
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  int i, j;
+  cairo_new_path(r->cr);
+  cairo_set_fill_rule(r->cr, CAIRO_FILL_RULE_EVEN_ODD);
+  msCairoSetSourceColor(r->cr, c);
+  for (i = 0; i < p->numlines; i++) {
+    lineObj *l = &(p->line[i]);
+    cairo_move_to(r->cr, l->point[0].x, l->point[0].y);
+    for (j = 1; j < l->numpoints; j++) {
+      cairo_line_to(r->cr, l->point[j].x, l->point[j].y);
+    }
+    cairo_close_path(r->cr);
+  }
+  cairo_fill(r->cr);
+  return MS_SUCCESS;
+}
+
+int renderPolygonTiledCairo(imageObj *img, shapeObj *p, imageObj *tile) {
+  int i, j;
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  cairo_renderer *tileRenderer = CAIRO_RENDERER(tile);
+  cairo_pattern_t *pattern =
+      cairo_pattern_create_for_surface(tileRenderer->surface);
+  cairo_pattern_set_extend(pattern, CAIRO_EXTEND_REPEAT);
+
+  cairo_set_source(r->cr, pattern);
+  for (i = 0; i < p->numlines; i++) {
+    lineObj *l = &(p->line[i]);
+    cairo_move_to(r->cr, l->point[0].x, l->point[0].y);
+    for (j = 1; j < l->numpoints; j++) {
+      cairo_line_to(r->cr, l->point[j].x, l->point[j].y);
+    }
+    /* cairo_close_path(r->cr); */
+  }
+  cairo_fill(r->cr);
+  cairo_pattern_destroy(pattern);
+  return MS_SUCCESS;
+}
+
+cairo_surface_t *createSurfaceFromBuffer(rasterBufferObj *b) {
+  assert(b->type == MS_BUFFER_BYTE_RGBA);
+  return cairo_image_surface_create_for_data(b->data.rgba.pixels,
+                                             CAIRO_FORMAT_ARGB32, b->width,
+                                             b->height, b->data.rgba.row_step);
+}
+
+int renderPixmapSymbolCairo(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  cairo_surface_t *im;
+  rasterBufferObj *b = symbol->pixmap_buffer;
+  assert(b);
+  if (!symbol->renderer_cache) {
+    symbol->renderer_cache = (void *)createSurfaceFromBuffer(b);
+  }
+  assert(symbol->renderer_cache);
+  im = (cairo_surface_t *)symbol->renderer_cache;
+  cairo_save(r->cr);
+  if (style->rotation != 0 || style->scale != 1) {
+    cairo_translate(r->cr, x, y);
+    cairo_rotate(r->cr, -style->rotation);
+    cairo_scale(r->cr, style->scale, style->scale);
+    cairo_translate(r->cr, -0.5 * b->width, -0.5 * b->height);
+  } else {
+    cairo_translate(r->cr, MS_NINT(x - 0.5 * b->width),
+                    MS_NINT(y - 0.5 * b->height));
+  }
+  cairo_set_source_surface(r->cr, im, 0, 0);
+  cairo_paint(r->cr);
+  cairo_restore(r->cr);
+  return MS_SUCCESS;
+}
+
+int renderVectorSymbolCairo(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  double ox = symbol->sizex * 0.5, oy = symbol->sizey * 0.5;
+  int is_new = 1, i;
+  cairo_new_path(r->cr);
+  cairo_save(r->cr);
+  cairo_translate(r->cr, x, y);
+  cairo_scale(r->cr, style->scale, style->scale);
+  cairo_rotate(r->cr, -style->rotation);
+  cairo_translate(r->cr, -ox, -oy);
+  for (i = 0; i < symbol->numpoints; i++) {
+    if ((symbol->points[i].x == -99) &&
+        (symbol->points[i].y == -99)) { /* (PENUP) */
+      is_new = 1;
+    } else {
+      if (is_new) {
+        cairo_move_to(r->cr, symbol->points[i].x, symbol->points[i].y);
+        is_new = 0;
+      } else {
+        cairo_line_to(r->cr, symbol->points[i].x, symbol->points[i].y);
+      }
+    }
+  }
+  cairo_restore(r->cr);
+  if (style->color) {
+    msCairoSetSourceColor(r->cr, style->color);
+    cairo_fill_preserve(r->cr);
+  }
+  if (style->outlinewidth > 0) {
+    msCairoSetSourceColor(r->cr, style->outlinecolor);
+    cairo_set_line_width(r->cr, style->outlinewidth);
+    cairo_stroke_preserve(r->cr);
+  }
+  cairo_new_path(r->cr);
+  return MS_SUCCESS;
+}
+
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+struct svg_symbol_cache {
+  rasterBufferObj *pixmap_buffer;
+#ifdef USE_RSVG
+  RsvgHandle *svgc;
+#else
+  svg_cairo_t *svgc;
+#endif
+  double scale, rotation;
+};
+#endif
+
+int renderSVGSymbolCairo(imageObj *img, double x, double y, symbolObj *symbol,
+                         symbolStyleObj *style) {
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+  struct svg_symbol_cache *cache;
+  cairo_renderer *r = CAIRO_RENDERER(img);
+
+  msPreloadSVGSymbol(symbol);
+  assert(symbol->renderer_cache);
+  cache = symbol->renderer_cache;
+
+  cairo_save(r->cr);
+  cairo_translate(r->cr, x, y);
+  cairo_scale(r->cr, style->scale, style->scale);
+
+  if (style->rotation != 0) {
+    cairo_rotate(r->cr, -style->rotation);
+    cairo_translate(r->cr, -(int)(symbol->sizex / 2),
+                    -(int)(symbol->sizey / 2));
+  } else
+    cairo_translate(r->cr, -(int)(symbol->sizex / 2),
+                    -(int)(symbol->sizey / 2));
+
+#ifdef USE_SVG_CAIRO
+  {
+    svg_cairo_status_t status;
+    status = svg_cairo_render(cache->svgc, r->cr);
+    if (status != SVG_CAIRO_STATUS_SUCCESS) {
+      cairo_restore(r->cr);
+      return MS_FAILURE;
+    }
+  }
+#else
+  rsvg_handle_render_cairo(cache->svgc, r->cr);
+#endif
+
+  cairo_restore(r->cr);
+
+  return MS_SUCCESS;
+
+#else
+  msSetError(MS_MISCERR,
+             "SVG Symbols requested but is not built with libsvgcairo",
+             "renderSVGSymbolCairo()");
+  return MS_FAILURE;
+#endif
+}
+
+int renderTileCairo(imageObj *img, imageObj *tile, double x, double y) {
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  cairo_surface_t *im = CAIRO_RENDERER(tile)->surface;
+  int w = cairo_image_surface_get_width(im);
+  int h = cairo_image_surface_get_height(im);
+  cairo_save(r->cr);
+  cairo_translate(r->cr, MS_NINT(x - 0.5 * w), MS_NINT(y - 0.5 * h));
+  cairo_set_source_surface(r->cr, im, 0, 0);
+  cairo_pattern_set_filter(cairo_get_source(r->cr), CAIRO_FILTER_NEAREST);
+  cairo_paint(r->cr);
+  cairo_restore(r->cr);
+  return MS_SUCCESS;
+}
+
+int renderGlyphs2Cairo(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                       colorObj *oc, int ow, int isMarker) {
+  const textPathObj *tp = ts->textpath;
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  cairoCacheData *cache = MS_IMAGE_RENDERER_CACHE(img);
+  cairoFaceCache *cairo_face = NULL;
+  FT_Face prevface = NULL;
+  int g;
+  (void)isMarker;
+
+  cairo_set_font_size(r->cr, MS_NINT(tp->glyph_size * 96.0 / 72.0));
+  for (g = 0; g < tp->numglyphs; g++) {
+    glyphObj *gl = &tp->glyphs[g];
+    cairo_glyph_t glyph;
+    /* load the glyph's face into cairo, if not already present */
+    if (gl->face->face != prevface) {
+      cairo_face = getCairoFontFace(cache, gl->face->face);
+      cairo_set_font_face(r->cr, cairo_face->face);
+      cairo_set_font_options(r->cr, cairo_face->options);
+      prevface = gl->face->face;
+      cairo_set_font_size(r->cr, MS_NINT(tp->glyph_size * 96.0 / 72.0));
+    }
+    cairo_save(r->cr);
+    cairo_translate(r->cr, gl->pnt.x, gl->pnt.y);
+    if (gl->rot != 0.0)
+      cairo_rotate(r->cr, -gl->rot);
+    glyph.x = glyph.y = 0;
+    glyph.index = gl->glyph->key.codepoint;
+    cairo_glyph_path(r->cr, &glyph, 1);
+    cairo_restore(r->cr);
+  }
+  if (oc) {
+    cairo_save(r->cr);
+    msCairoSetSourceColor(r->cr, oc);
+    cairo_set_line_width(r->cr, ow + 1);
+    cairo_stroke_preserve(r->cr);
+    cairo_restore(r->cr);
+  }
+  if (c) {
+    msCairoSetSourceColor(r->cr, c);
+    cairo_fill(r->cr);
+  }
+  cairo_new_path(r->cr);
+  return MS_SUCCESS;
+}
+
+cairo_status_t _stream_write_fn(void *b, const unsigned char *data,
+                                unsigned int length) {
+  msBufferAppend((bufferObj *)b, (void *)data, length);
+  return CAIRO_STATUS_SUCCESS;
+}
+
+imageObj *createImageCairo(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
+  imageObj *image = NULL;
+  cairo_renderer *r = NULL;
+  if (format->imagemode != MS_IMAGEMODE_RGB &&
+      format->imagemode != MS_IMAGEMODE_RGBA) {
+    msSetError(MS_MISCERR,
+               "Cairo driver only supports RGB or RGBA pixel models.",
+               "msImageCreateCairo()");
+    return image;
+  }
+  if (width > 0 && height > 0) {
+    image = (imageObj *)calloc(1, sizeof(imageObj));
+    r = (cairo_renderer *)calloc(1, sizeof(cairo_renderer));
+    if (!strcasecmp(format->driver, "cairo/pdf")) {
+      r->outputStream = (bufferObj *)malloc(sizeof(bufferObj));
+      msBufferInit(r->outputStream);
+      r->surface = cairo_pdf_surface_create_for_stream(
+          _stream_write_fn, r->outputStream, width, height);
+#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 15, 10)
+      {
+        const char *msPDFCreationDate =
+            CPLGetConfigOption("MS_PDF_CREATION_DATE", NULL);
+        if (msPDFCreationDate) {
+          cairo_pdf_surface_set_metadata(
+              r->surface, CAIRO_PDF_METADATA_CREATE_DATE, msPDFCreationDate);
+        }
+      }
+#endif
+    } else if (!strcasecmp(format->driver, "cairo/svg")) {
+      r->outputStream = (bufferObj *)malloc(sizeof(bufferObj));
+      msBufferInit(r->outputStream);
+      r->surface = cairo_svg_surface_create_for_stream(
+          _stream_write_fn, r->outputStream, width, height);
+    } else if (!strcasecmp(format->driver, "cairo/winGDI") && format->device) {
+#if CAIRO_HAS_WIN32_SURFACE
+      r->outputStream = NULL;
+      r->surface = cairo_win32_surface_create(format->device);
+#else
+      msSetError(MS_RENDERERERR,
+                 "Cannot create cairo image. Cairo was not compiled with "
+                 "support for the win32 backend.",
+                 "msImageCreateCairo()");
+#endif
+    } else if (!strcasecmp(format->driver, "cairo/winGDIPrint") &&
+               format->device) {
+#if CAIRO_HAS_WIN32_SURFACE
+      r->outputStream = NULL;
+      r->surface = cairo_win32_printing_surface_create(format->device);
+#else
+      msSetError(MS_RENDERERERR,
+                 "Cannot create cairo image. Cairo was not compiled with "
+                 "support for the win32 backend.",
+                 "msImageCreateCairo()");
+#endif
+    } else {
+      r->outputStream = NULL;
+      r->surface =
+          cairo_image_surface_create(CAIRO_FORMAT_ARGB32, width, height);
+    }
+    r->cr = cairo_create(r->surface);
+    if (format->transparent || !bg || !MS_VALID_COLOR(*bg)) {
+      r->use_alpha = 1;
+      cairo_set_source_rgba(r->cr, 0, 0, 0, 0);
+    } else {
+      r->use_alpha = 0;
+      msCairoSetSourceColor(r->cr, bg);
+    }
+    cairo_save(r->cr);
+    cairo_set_operator(r->cr, CAIRO_OPERATOR_SOURCE);
+    cairo_paint(r->cr);
+    cairo_restore(r->cr);
+
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_ROUND);
+    cairo_set_line_join(r->cr, CAIRO_LINE_JOIN_ROUND);
+    image->img.plugin = (void *)r;
+  } else {
+    msSetError(MS_RENDERERERR, "Cannot create cairo image of size %dx%d.",
+               "msImageCreateCairo()", width, height);
+  }
+  return image;
+}
+
+/* msSaveImagePostPDFProcessing() will call the GDAL PDF driver to add
+ * geospatial */
+/* information to the regular PDF generated by cairo. This is only triggered if
+ * the */
+/* GEO_ENCODING outputformat option is set (to ISO32000 or OGC_BP). Additionnal
+ */
+/* options can be provided by specifying outputformat options starting with */
+/* METADATA_ITEM: prefix. For example METADATA_ITEM:PRODUCER=MapServer */
+/* Those options are AUTHOR, CREATOR, CREATION_DATE, KEYWORDS, PRODUCER,
+ * SUBJECT, TITLE */
+/* See http://gdal.org/frmt_pdf.html documentation. */
+
+static void msTransformToGeospatialPDF(imageObj *img, mapObj *map,
+                                       cairo_renderer *r) {
+  GDALDatasetH hDS = NULL;
+  const char *pszGEO_ENCODING = NULL;
+  GDALDriverH hPDFDriver = NULL;
+  const char *pszVirtualIO = NULL;
+  int bVirtualIO = FALSE;
+  char *pszTmpFilename = NULL;
+  VSILFILE *fp = NULL;
+
+  if (map == NULL)
+    return;
+
+  pszGEO_ENCODING = msGetOutputFormatOption(img->format, "GEO_ENCODING", NULL);
+  if (pszGEO_ENCODING == NULL)
+    return;
+
+  msGDALInitialize();
+
+  hPDFDriver = GDALGetDriverByName("PDF");
+  if (hPDFDriver == NULL)
+    return;
+
+  /* When compiled against libpoppler, the PDF driver is VirtualIO capable */
+  /* but not, when it is compiled against libpodofo. */
+  pszVirtualIO = GDALGetMetadataItem(hPDFDriver, GDAL_DCAP_VIRTUALIO, NULL);
+  if (pszVirtualIO)
+    bVirtualIO = CSLTestBoolean(pszVirtualIO);
+
+  if (bVirtualIO)
+    pszTmpFilename = msTmpFile(map, NULL, "/vsimem/mscairopdf/", "pdf");
+  else
+    pszTmpFilename = msTmpFile(map, map->mappath, NULL, "pdf");
+
+  /* Copy content of outputStream buffer into file */
+  fp = VSIFOpenL(pszTmpFilename, "wb");
+  if (fp == NULL) {
+    msFree(pszTmpFilename);
+    return;
+  }
+  VSIFWriteL(r->outputStream->data, 1, r->outputStream->size, fp);
+  VSIFCloseL(fp);
+  fp = NULL;
+
+  hDS = GDALOpen(pszTmpFilename, GA_Update);
+  if (hDS != NULL) {
+    char *pszWKT = msProjectionObj2OGCWKT(&(map->projection));
+    if (pszWKT != NULL) {
+      double adfGeoTransform[6];
+      int i;
+
+      /* Add user-specified options */
+      for (i = 0; i < img->format->numformatoptions; i++) {
+        const char *pszOption = img->format->formatoptions[i];
+        if (strncasecmp(pszOption, "METADATA_ITEM:", 14) == 0) {
+          char *pszKey = NULL;
+          const char *pszValue = CPLParseNameValue(pszOption + 14, &pszKey);
+          if (pszKey != NULL) {
+            GDALSetMetadataItem(hDS, pszKey, pszValue, NULL);
+            CPLFree(pszKey);
+          }
+        }
+      }
+
+      /* We need to rescale the geotransform because GDAL will not necessary */
+      /* open the PDF with the DPI that was used to generate it */
+      memcpy(adfGeoTransform, map->gt.geotransform, 6 * sizeof(double));
+      adfGeoTransform[1] =
+          adfGeoTransform[1] * map->width / GDALGetRasterXSize(hDS);
+      adfGeoTransform[5] =
+          adfGeoTransform[5] * map->height / GDALGetRasterYSize(hDS);
+      GDALSetGeoTransform(hDS, adfGeoTransform);
+      GDALSetProjection(hDS, pszWKT);
+
+      msFree(pszWKT);
+      pszWKT = NULL;
+
+      CPLSetThreadLocalConfigOption("GDAL_PDF_GEO_ENCODING", pszGEO_ENCODING);
+
+      GDALClose(hDS);
+      hDS = NULL;
+
+      CPLSetThreadLocalConfigOption("GDAL_PDF_GEO_ENCODING", NULL);
+
+      /* We need to replace the buffer with the content of the GDAL file */
+      fp = VSIFOpenL(pszTmpFilename, "rb");
+      if (fp != NULL) {
+        int nFileSize;
+
+        VSIFSeekL(fp, 0, SEEK_END);
+        nFileSize = (int)VSIFTellL(fp);
+
+        msBufferResize(r->outputStream, nFileSize);
+
+        VSIFSeekL(fp, 0, SEEK_SET);
+        r->outputStream->size =
+            VSIFReadL(r->outputStream->data, 1, nFileSize, fp);
+
+        VSIFCloseL(fp);
+        fp = NULL;
+      }
+    }
+  }
+
+  if (hDS != NULL)
+    GDALClose(hDS);
+
+  VSIUnlink(pszTmpFilename);
+
+  msFree(pszTmpFilename);
+}
+
+int saveImageCairo(imageObj *img, mapObj *map, FILE *fp,
+                   outputFormatObj *format_unused) {
+  (void)format_unused;
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  if (!strcasecmp(img->format->driver, "cairo/pdf") ||
+      !strcasecmp(img->format->driver, "cairo/svg")) {
+    cairo_surface_finish(r->surface);
+
+    if (map != NULL && !strcasecmp(img->format->driver, "cairo/pdf"))
+      msTransformToGeospatialPDF(img, map, r);
+
+    msIO_fwrite(r->outputStream->data, r->outputStream->size, 1, fp);
+  } else {
+    /* not supported */
+  }
+  return MS_SUCCESS;
+}
+
+unsigned char *saveImageBufferCairo(imageObj *img, int *size_ptr,
+                                    outputFormatObj *format_unused) {
+  (void)format_unused;
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  unsigned char *data;
+  assert(!strcasecmp(img->format->driver, "cairo/pdf") ||
+         !strcasecmp(img->format->driver, "cairo/svg"));
+  cairo_surface_finish(r->surface);
+  data = msSmallMalloc(r->outputStream->size);
+  memcpy(data, r->outputStream->data, r->outputStream->size);
+  *size_ptr = (int)r->outputStream->size;
+  return data;
+}
+
+int renderEllipseSymbolCairo(imageObj *img, double x, double y,
+                             symbolObj *symbol, symbolStyleObj *style) {
+  cairo_renderer *r = CAIRO_RENDERER(img);
+
+  cairo_save(r->cr);
+  cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_BUTT);
+  cairo_set_line_join(r->cr, CAIRO_LINE_JOIN_MITER);
+  cairo_translate(r->cr, x, y);
+  cairo_rotate(r->cr, -style->rotation);
+  cairo_scale(r->cr, symbol->sizex * style->scale / 2,
+              symbol->sizey * style->scale / 2);
+  cairo_arc(r->cr, 0, 0, 1, 0, 2 * MS_PI);
+  cairo_restore(r->cr);
+  if (style->color) {
+    msCairoSetSourceColor(r->cr, style->color);
+    cairo_fill_preserve(r->cr);
+  }
+  if (style->outlinewidth > 0) {
+    cairo_set_line_width(r->cr, style->outlinewidth);
+    msCairoSetSourceColor(r->cr, style->outlinecolor);
+    cairo_stroke_preserve(r->cr);
+  }
+  cairo_new_path(r->cr);
+  return MS_SUCCESS;
+}
+
+int startLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer) {
+  (void)map;
+  if (layer->compositer && layer->compositer->opacity < 100) {
+    cairo_renderer *r = CAIRO_RENDERER(img);
+    cairo_push_group(r->cr);
+  }
+  return MS_SUCCESS;
+}
+
+int closeLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer) {
+  (void)map;
+  if (layer->compositer && layer->compositer->opacity < 100) {
+    cairo_renderer *r = CAIRO_RENDERER(img);
+    cairo_pop_group_to_source(r->cr);
+    cairo_paint_with_alpha(r->cr, layer->compositer->opacity * 0.01);
+  }
+  return MS_SUCCESS;
+}
+
+int startLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer) {
+  (void)img;
+  (void)map;
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+int closeLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer) {
+  (void)img;
+  (void)map;
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+int getRasterBufferHandleCairo(imageObj *img, rasterBufferObj *rb) {
+  unsigned char *pb;
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  pb = cairo_image_surface_get_data(r->surface);
+  rb->data.rgba.pixels = pb;
+  rb->data.rgba.row_step = cairo_image_surface_get_stride(r->surface);
+  rb->data.rgba.pixel_step = 4;
+  rb->width = cairo_image_surface_get_width(r->surface);
+  rb->height = cairo_image_surface_get_height(r->surface);
+  rb->data.rgba.r = &(pb[2]);
+  rb->data.rgba.g = &(pb[1]);
+  rb->data.rgba.b = &(pb[0]);
+  if (r->use_alpha)
+    rb->data.rgba.a = &(pb[3]);
+  else
+    rb->data.rgba.a = NULL;
+  return MS_SUCCESS;
+}
+
+int getRasterBufferCopyCairo(imageObj *img, rasterBufferObj *rb) {
+  cairo_renderer *r = CAIRO_RENDERER(img);
+  unsigned char *pb;
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->data.rgba.row_step = cairo_image_surface_get_stride(r->surface);
+  rb->data.rgba.pixel_step = 4;
+  rb->width = cairo_image_surface_get_width(r->surface);
+  rb->height = cairo_image_surface_get_height(r->surface);
+  pb = (unsigned char *)malloc(sizeof(unsigned char) * rb->height *
+                               rb->data.rgba.row_step);
+  memcpy(pb, cairo_image_surface_get_data(r->surface),
+         ((size_t)rb->height) * rb->data.rgba.row_step);
+  rb->data.rgba.pixels = pb;
+  rb->data.rgba.r = &(pb[2]);
+  rb->data.rgba.g = &(pb[1]);
+  rb->data.rgba.b = &(pb[0]);
+  if (r->use_alpha)
+    rb->data.rgba.a = &(pb[3]);
+  else
+    rb->data.rgba.a = NULL;
+  return MS_SUCCESS;
+}
+
+static cairo_operator_t ms2cairo_compop(CompositingOperation op) {
+  switch (op) {
+  case MS_COMPOP_CLEAR:
+    return CAIRO_OPERATOR_CLEAR;
+  case MS_COMPOP_SRC:
+    return CAIRO_OPERATOR_SOURCE;
+  case MS_COMPOP_DST:
+    return CAIRO_OPERATOR_DEST;
+  case MS_COMPOP_SRC_OVER:
+    return CAIRO_OPERATOR_OVER;
+  case MS_COMPOP_DST_OVER:
+    return CAIRO_OPERATOR_DEST_OVER;
+  case MS_COMPOP_SRC_IN:
+    return CAIRO_OPERATOR_IN;
+  case MS_COMPOP_DST_IN:
+    return CAIRO_OPERATOR_DEST_IN;
+  case MS_COMPOP_SRC_OUT:
+    return CAIRO_OPERATOR_OUT;
+  case MS_COMPOP_DST_OUT:
+    return CAIRO_OPERATOR_DEST_OUT;
+  case MS_COMPOP_SRC_ATOP:
+    return CAIRO_OPERATOR_ATOP;
+  case MS_COMPOP_DST_ATOP:
+    return CAIRO_OPERATOR_DEST_ATOP;
+  case MS_COMPOP_XOR:
+    return CAIRO_OPERATOR_XOR;
+  case MS_COMPOP_PLUS:
+    return CAIRO_OPERATOR_ADD;
+  case MS_COMPOP_MULTIPLY:
+    return CAIRO_OPERATOR_MULTIPLY;
+  case MS_COMPOP_SCREEN:
+    return CAIRO_OPERATOR_SCREEN;
+  case MS_COMPOP_OVERLAY:
+    return CAIRO_OPERATOR_OVERLAY;
+  case MS_COMPOP_DARKEN:
+    return CAIRO_OPERATOR_DARKEN;
+  case MS_COMPOP_LIGHTEN:
+    return CAIRO_OPERATOR_LIGHTEN;
+  case MS_COMPOP_COLOR_DODGE:
+    return CAIRO_OPERATOR_COLOR_DODGE;
+  case MS_COMPOP_COLOR_BURN:
+    return CAIRO_OPERATOR_COLOR_BURN;
+  case MS_COMPOP_HARD_LIGHT:
+    return CAIRO_OPERATOR_HARD_LIGHT;
+  case MS_COMPOP_SOFT_LIGHT:
+    return CAIRO_OPERATOR_SOFT_LIGHT;
+  case MS_COMPOP_DIFFERENCE:
+    return CAIRO_OPERATOR_DIFFERENCE;
+  case MS_COMPOP_EXCLUSION:
+    return CAIRO_OPERATOR_EXCLUSION;
+  case MS_COMPOP_INVERT:
+  case MS_COMPOP_INVERT_RGB:
+  case MS_COMPOP_MINUS:
+  case MS_COMPOP_CONTRAST:
+  default:
+    return CAIRO_OPERATOR_OVER;
+  }
+}
+
+int cairoCompositeRasterBuffer(imageObj *img, rasterBufferObj *rb,
+                               CompositingOperation comp, int opacity) {
+  cairo_surface_t *src;
+  cairo_renderer *r;
+  if (rb->type != MS_BUFFER_BYTE_RGBA) {
+    return MS_FAILURE;
+  }
+  r = CAIRO_RENDERER(img);
+
+  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,
+                                            CAIRO_FORMAT_ARGB32, rb->width,
+                                            rb->height, rb->data.rgba.row_step);
+
+  cairo_set_source_surface(r->cr, src, 0, 0);
+  cairo_set_operator(r->cr, ms2cairo_compop(comp));
+  cairo_paint_with_alpha(r->cr, opacity / 100.0);
+  cairo_surface_finish(src);
+  cairo_surface_destroy(src);
+  cairo_set_operator(r->cr, CAIRO_OPERATOR_OVER);
+  return MS_SUCCESS;
+}
+
+int mergeRasterBufferCairo(imageObj *img, rasterBufferObj *rb, double opacity,
+                           int srcX, int srcY, int dstX, int dstY, int width,
+                           int height) {
+  cairo_surface_t *src;
+  cairo_renderer *r;
+  /* not implemented for src,dst,width and height */
+  if (rb->type != MS_BUFFER_BYTE_RGBA) {
+    return MS_FAILURE;
+  }
+  r = CAIRO_RENDERER(img);
+
+  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,
+                                            CAIRO_FORMAT_ARGB32, rb->width,
+                                            rb->height, rb->data.rgba.row_step);
+
+  if (dstX || dstY || srcX || srcY || width != img->width ||
+      height != img->height) {
+    cairo_set_source_surface(r->cr, src, dstX - srcX, dstY - srcY);
+    cairo_rectangle(r->cr, dstX, dstY, width, height);
+    cairo_fill(r->cr);
+  } else {
+    cairo_set_source_surface(r->cr, src, 0, 0);
+    cairo_paint_with_alpha(r->cr, opacity);
+  }
+  cairo_surface_finish(src);
+  cairo_surface_destroy(src);
+  return MS_SUCCESS;
+}
+
+void freeSVGCache(symbolObj *s) {
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+  struct svg_symbol_cache *cache = s->renderer_cache;
+  if (!cache)
+    return;
+  assert(cache->svgc);
+#ifdef USE_SVG_CAIRO
+  svg_cairo_destroy(cache->svgc);
+#else
+#if LIBRSVG_CHECK_VERSION(2, 35, 0)
+  g_object_unref(cache->svgc);
+#else
+  rsvg_handle_free(cache->svgc);
+#endif
+#endif
+  if (cache->pixmap_buffer) {
+    msFreeRasterBuffer(cache->pixmap_buffer);
+    free(cache->pixmap_buffer);
+  }
+  msFree(s->renderer_cache);
+  s->renderer_cache = NULL;
+#endif
+}
+
+int freeSymbolCairo(symbolObj *s) {
+  if (!s->renderer_cache)
+    return MS_SUCCESS;
+  switch (s->type) {
+  case MS_SYMBOL_VECTOR:
+    cairo_path_destroy(s->renderer_cache);
+    break;
+  case MS_SYMBOL_PIXMAP:
+    cairo_surface_destroy(s->renderer_cache);
+    break;
+  case MS_SYMBOL_SVG:
+    freeSVGCache(s);
+    break;
+  }
+  s->renderer_cache = NULL;
+  return MS_SUCCESS;
+}
+
+int initializeRasterBufferCairo(rasterBufferObj *rb, int width, int height,
+                                int mode) {
+  (void)mode;
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->width = width;
+  rb->height = height;
+  rb->data.rgba.pixel_step = 4;
+  rb->data.rgba.row_step = width * 4;
+  rb->data.rgba.pixels = (unsigned char *)calloc(((size_t)width) * height * 4,
+                                                 sizeof(unsigned char));
+  rb->data.rgba.r = &(rb->data.rgba.pixels[2]);
+  rb->data.rgba.g = &(rb->data.rgba.pixels[1]);
+  rb->data.rgba.b = &(rb->data.rgba.pixels[0]);
+  rb->data.rgba.a = &(rb->data.rgba.pixels[3]);
+  return MS_SUCCESS;
+}
+
+int msPreloadSVGSymbol(symbolObj *symbol) {
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+  struct svg_symbol_cache *cache;
+
+  if (!symbol->renderer_cache) {
+    cache = msSmallCalloc(1, sizeof(struct svg_symbol_cache));
+    symbol->renderer_free_func = &freeSVGCache;
+  } else {
+    cache = symbol->renderer_cache;
+  }
+  if (cache->svgc)
+    return MS_SUCCESS;
+
+#ifdef USE_SVG_CAIRO
+  {
+    unsigned int svg_width, svg_height;
+    int status;
+    status = svg_cairo_create(&cache->svgc);
+    if (status) {
+      msSetError(MS_RENDERERERR, "problem creating cairo svg",
+                 "msPreloadSVGSymbol()");
+      return MS_FAILURE;
+    }
+    status = svg_cairo_parse(cache->svgc, symbol->full_pixmap_path);
+    if (status) {
+      msSetError(MS_RENDERERERR, "problem parsing svg symbol",
+                 "msPreloadSVGSymbol()");
+      return MS_FAILURE;
+    }
+    svg_cairo_get_size(cache->svgc, &svg_width, &svg_height);
+    if (svg_width == 0 || svg_height == 0) {
+      msSetError(MS_RENDERERERR, "problem parsing svg symbol",
+                 "msPreloadSVGSymbol()");
+      return MS_FAILURE;
+    }
+
+    symbol->sizex = svg_width;
+    symbol->sizey = svg_height;
+  }
+#else
+  {
+    cache->svgc = rsvg_handle_new_from_file(symbol->full_pixmap_path, NULL);
+    if (!cache->svgc) {
+      msSetError(MS_RENDERERERR, "failed to load svg file %s",
+                 "msPreloadSVGSymbol()", symbol->full_pixmap_path);
+      return MS_FAILURE;
+    }
+#if LIBRSVG_CHECK_VERSION(2, 46, 0)
+    /* rsvg_handle_get_dimensions_sub() is deprecated since librsvg 2.46 */
+    /* It seems rsvg_handle_get_intrinsic_dimensions() is the best equivalent */
+    /* when the <svg> root node includes a width and height attributes in pixels
+     */
+    gboolean has_width = FALSE;
+    RsvgLength width = {0, RSVG_UNIT_PX};
+    gboolean has_height = FALSE;
+    RsvgLength height = {0, RSVG_UNIT_PX};
+    gboolean has_viewbox = FALSE;
+    RsvgRectangle viewbox;
+    rsvg_handle_get_intrinsic_dimensions(cache->svgc, &has_width, &width,
+                                         &has_height, &height, &has_viewbox,
+                                         &viewbox);
+    if (has_width && width.unit == RSVG_UNIT_PX && has_height &&
+        height.unit == RSVG_UNIT_PX) {
+      symbol->sizex = width.length;
+      symbol->sizey = height.length;
+    } else if (!has_viewbox) {
+      RsvgRectangle ink_rect = {0, 0, 0, 0};
+      rsvg_handle_get_geometry_for_element(cache->svgc, NULL, &ink_rect, NULL,
+                                           NULL);
+      symbol->sizex = ink_rect.width;
+      symbol->sizey = ink_rect.height;
+    } else {
+      symbol->sizex = viewbox.width;
+      symbol->sizey = viewbox.height;
+    }
+#else
+    RsvgDimensionData dim;
+    rsvg_handle_get_dimensions_sub(cache->svgc, &dim, NULL);
+    symbol->sizex = dim.width;
+    symbol->sizey = dim.height;
+#endif
+  }
+#endif
+
+  symbol->renderer_cache = cache;
+
+  return MS_SUCCESS;
+
+#else
+  msSetError(MS_MISCERR,
+             "SVG Symbols requested but is not built with libsvgcairo",
+             "msPreloadSVGSymbol()");
+  return MS_FAILURE;
+#endif
+}
+
+int msRenderRasterizedSVGSymbol(imageObj *img, double x, double y,
+                                symbolObj *symbol, symbolStyleObj *style) {
+
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+  struct svg_symbol_cache *svg_cache;
+  symbolStyleObj pixstyle;
+  symbolObj pixsymbol;
+  int status;
+
+  if (MS_SUCCESS != msPreloadSVGSymbol(symbol))
+    return MS_FAILURE;
+  svg_cache = (struct svg_symbol_cache *)symbol->renderer_cache;
+
+  // already rendered at the right size and scale? return
+  if (svg_cache->scale != style->scale ||
+      svg_cache->rotation != style->rotation) {
+    cairo_t *cr;
+    cairo_surface_t *surface;
+    unsigned char *pb;
+    int width, height, surface_w, surface_h;
+    /* need to recompute the pixmap */
+    if (svg_cache->pixmap_buffer) {
+      msFreeRasterBuffer(svg_cache->pixmap_buffer);
+    } else {
+      svg_cache->pixmap_buffer = msSmallCalloc(1, sizeof(rasterBufferObj));
+    }
+
+    // increase pixmap size to accomodate scaling/rotation
+    if (style->scale != 1.0) {
+      width = surface_w = (symbol->sizex * style->scale + 0.5);
+      height = surface_h = (symbol->sizey * style->scale + 0.5);
+    } else {
+      width = surface_w = symbol->sizex;
+      height = surface_h = symbol->sizey;
+    }
+    if (style->rotation != 0) {
+      surface_w = surface_h = MS_NINT(MS_MAX(height, width) * 1.415);
+    }
+
+    surface =
+        cairo_image_surface_create(CAIRO_FORMAT_ARGB32, surface_w, surface_h);
+    cr = cairo_create(surface);
+
+    if (style->rotation != 0) {
+      cairo_translate(cr, surface_w / 2, surface_h / 2);
+      cairo_rotate(cr, -style->rotation);
+      cairo_translate(cr, -width / 2, -height / 2);
+    }
+    if (style->scale != 1.0) {
+      cairo_scale(cr, style->scale, style->scale);
+    }
+#ifdef USE_SVG_CAIRO
+    if (svg_cairo_render(svg_cache->svgc, cr) != SVG_CAIRO_STATUS_SUCCESS) {
+      return MS_FAILURE;
+    }
+#else
+    rsvg_handle_render_cairo(svg_cache->svgc, cr);
+#endif
+    pb = cairo_image_surface_get_data(surface);
+
+    // set up raster
+    initializeRasterBufferCairo(svg_cache->pixmap_buffer, surface_w, surface_h,
+                                0);
+    memcpy(svg_cache->pixmap_buffer->data.rgba.pixels, pb,
+           sizeof(unsigned char) * surface_w * surface_h * 4);
+    svg_cache->scale = style->scale;
+    svg_cache->rotation = style->rotation;
+    cairo_destroy(cr);
+    cairo_surface_destroy(surface);
+  }
+
+  pixstyle = *style;
+  pixstyle.rotation = 0.0;
+  pixstyle.scale = 1.0;
+
+  pixsymbol.pixmap_buffer = svg_cache->pixmap_buffer;
+  pixsymbol.type = MS_SYMBOL_PIXMAP;
+
+  if (svg_cache->pixmap_buffer->height && svg_cache->pixmap_buffer->width)
+    status = MS_IMAGE_RENDERER(img)->renderPixmapSymbol(img, x, y, &pixsymbol,
+                                                        &pixstyle);
+  else {
+    msDebug("SVG symbol with too small size to be rendered");
+    status = MS_SUCCESS;
+  }
+  MS_IMAGE_RENDERER(img)->freeSymbol(&pixsymbol);
+  return status;
+#else
+  msSetError(
+      MS_MISCERR,
+      "SVG Symbols requested but MapServer is not built with libsvgcairo",
+      "renderSVGSymbolCairo()");
+  return MS_FAILURE;
+#endif
+}
+
+void msCairoCleanup() { cairo_debug_reset_static_data(); }
+
+#endif /*USE_CAIRO*/
+
+int msPopulateRendererVTableCairoRaster(rendererVTableObj *renderer) {
+#ifdef USE_CAIRO
+  renderer->supports_pixel_buffer = 1;
+  renderer->compositeRasterBuffer = cairoCompositeRasterBuffer;
+  renderer->supports_svg = 1;
+  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
+  initializeCache(&MS_RENDERER_CACHE(renderer));
+  renderer->startLayer = startLayerRasterCairo;
+  renderer->endLayer = closeLayerRasterCairo;
+  renderer->renderLineTiled = NULL;
+  renderer->renderLine = &renderLineCairo;
+  renderer->createImage = &createImageCairo;
+  renderer->saveImage = &saveImageCairo;
+  renderer->getRasterBufferHandle = &getRasterBufferHandleCairo;
+  renderer->getRasterBufferCopy = &getRasterBufferCopyCairo;
+  renderer->renderPolygon = &renderPolygonCairo;
+  renderer->renderGlyphs = &renderGlyphs2Cairo;
+  renderer->freeImage = &freeImageCairo;
+  renderer->renderEllipseSymbol = &renderEllipseSymbolCairo;
+  renderer->renderVectorSymbol = &renderVectorSymbolCairo;
+  renderer->renderSVGSymbol = &renderSVGSymbolCairo;
+  renderer->renderPixmapSymbol = &renderPixmapSymbolCairo;
+  renderer->mergeRasterBuffer = &mergeRasterBufferCairo;
+  renderer->renderTile = &renderTileCairo;
+  renderer->loadImageFromFile = &msLoadMSRasterBufferFromFile;
+  renderer->renderPolygonTiled = &renderPolygonTiledCairo;
+  renderer->freeSymbol = &freeSymbolCairo;
+  renderer->cleanup = &cleanupCairo;
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "Cairo Driver requested but MapServer is not built in",
+             "msPopulateRendererVTableCairoRaster()");
+  return MS_FAILURE;
+#endif
+}
+
+int populateRendererVTableCairoVector(rendererVTableObj *renderer) {
+#ifdef USE_CAIRO
+  renderer->use_imagecache = 0;
+  renderer->supports_pixel_buffer = 0;
+  renderer->compositeRasterBuffer = NULL;
+  renderer->supports_svg = 1;
+  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
+  initializeCache(&MS_RENDERER_CACHE(renderer));
+  renderer->startLayer = startLayerVectorCairo;
+  renderer->endLayer = closeLayerVectorCairo;
+  renderer->renderLine = &renderLineCairo;
+  renderer->renderLineTiled = NULL;
+  renderer->createImage = &createImageCairo;
+  renderer->saveImage = &saveImageCairo;
+  renderer->saveImageBuffer = &saveImageBufferCairo;
+  renderer->getRasterBufferHandle = &getRasterBufferHandleCairo;
+  renderer->renderPolygon = &renderPolygonCairo;
+  renderer->renderGlyphs = &renderGlyphs2Cairo;
+  renderer->freeImage = &freeImageCairo;
+  renderer->renderEllipseSymbol = &renderEllipseSymbolCairo;
+  renderer->renderVectorSymbol = &renderVectorSymbolCairo;
+  renderer->renderSVGSymbol = &renderSVGSymbolCairo;
+  renderer->renderPixmapSymbol = &renderPixmapSymbolCairo;
+  renderer->loadImageFromFile = &msLoadMSRasterBufferFromFile;
+  renderer->mergeRasterBuffer = &mergeRasterBufferCairo;
+  renderer->initializeRasterBuffer = initializeRasterBufferCairo;
+  renderer->renderTile = &renderTileCairo;
+  renderer->renderPolygonTiled = &renderPolygonTiledCairo;
+  renderer->freeSymbol = &freeSymbolCairo;
+  renderer->cleanup = &cleanupCairo;
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "Cairo Driver requested but MapServer is not built in",
+             "msPopulateRendererVTableCairoRaster()");
+  return MS_FAILURE;
+#endif
+}
+
+int msPopulateRendererVTableCairoSVG(rendererVTableObj *renderer) {
+  return populateRendererVTableCairoVector(renderer);
+}
+int msPopulateRendererVTableCairoPDF(rendererVTableObj *renderer) {
+  return populateRendererVTableCairoVector(renderer);
+}
diff -pruN 8.0.1-5/src/mapchart.c 8.2.0~beta1-1~exp1/src/mapchart.c
--- 8.0.1-5/src/mapchart.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapchart.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,727 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of dynamic charting (MS-RFC-29)
+ * Author:   Thomas Bonfort ( thomas.bonfort[at]gmail.com )
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#define MS_CHART_TYPE_PIE 1
+#define MS_CHART_TYPE_BAR 2
+#define MS_CHART_TYPE_VBAR 3
+
+/*
+** check if an object of width w and height h placed at point x,y can fit in an
+*image of width mw and height mh
+*/
+#define MS_CHART_FITS(x, y, w, h, mw, mh)                                      \
+  (((x) - (w) / 2. > 0.) && ((x) + (w) / 2. < (mw)) &&                         \
+   ((y) - (h) / 2. > 0.) && ((y) + (h) / 2.) < (mh))
+
+/*
+** find a point on a shape. check if it fits in image
+** returns
+**  MS_SUCCESS and point coordinates in 'p' if chart fits in image
+**  MS_FAILURE if no point could be found
+*/
+int findChartPoint(mapObj *map, shapeObj *shape, int width, int height,
+                   pointObj *center) {
+  int middle, numpoints;
+  double invcellsize = 1.0 / map->cellsize; /*speed up MAP2IMAGE_X/Y_IC_DBL*/
+  switch (shape->type) {
+  case MS_SHAPE_POINT:
+    center->x = MS_MAP2IMAGE_X_IC_DBL(shape->line[0].point[0].x,
+                                      map->extent.minx, invcellsize);
+    center->y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[0].point[0].y,
+                                      map->extent.maxy, invcellsize);
+
+    if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                      map->height))
+      return MS_SUCCESS;
+    else
+      return MS_FAILURE;
+    break;
+  case MS_SHAPE_LINE:
+    /*loop through line segments starting from middle (alternate between before
+     *and after middle point) *first segment that fits is chosen
+     */
+    middle = shape->line[0].numpoints / 2; /*start with middle segment of line*/
+    numpoints = shape->line[0].numpoints;
+    if (1 <= middle) {
+      int idx = middle + 1;
+      if (idx < numpoints) {
+        center->x =
+            (shape->line[0].point[idx - 1].x + shape->line[0].point[idx].x) /
+            2.;
+        center->y =
+            (shape->line[0].point[idx - 1].y + shape->line[0].point[idx].y) /
+            2.;
+        center->x =
+            MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
+        center->y =
+            MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
+
+        if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                          map->height))
+          return MS_SUCCESS;
+
+        return MS_FAILURE;
+      }
+      idx = middle - 1;
+      center->x =
+          (shape->line[0].point[idx].x + shape->line[0].point[idx + 1].x) / 2;
+      center->y =
+          (shape->line[0].point[idx].y + shape->line[0].point[idx + 1].y) / 2;
+      center->x =
+          MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
+      center->y =
+          MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
+
+      if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                        map->height))
+        return MS_SUCCESS;
+      return MS_FAILURE;
+    }
+    return MS_FAILURE;
+    break;
+  case MS_SHAPE_POLYGON:
+    msPolygonLabelPoint(shape, center, -1);
+    center->x = MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
+    center->y = MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
+
+    if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                      map->height))
+      return MS_SUCCESS;
+    else
+      return MS_FAILURE;
+    break;
+  default:
+    return MS_FAILURE;
+  }
+}
+
+int WARN_UNUSED drawRectangle(mapObj *map, imageObj *image, double mx,
+                              double my, double Mx, double My,
+                              styleObj *style) {
+  shapeObj shape;
+  lineObj line;
+  pointObj point[5];
+  line.point = point;
+  line.numpoints = 5;
+  shape.line = &line;
+  shape.numlines = 1;
+
+  point[0].x = point[4].x = point[3].x = mx;
+  point[0].y = point[4].y = point[1].y = my;
+  /* cppcheck-suppress unreadVariable */
+  point[1].x = point[2].x = Mx;
+  /* cppcheck-suppress unreadVariable */
+  point[2].y = point[3].y = My;
+
+  return msDrawShadeSymbol(map, image, &shape, style, 1.0);
+}
+
+int WARN_UNUSED msDrawVBarChart(mapObj *map, imageObj *image, pointObj *center,
+                                double *values, styleObj **styles,
+                                int numvalues, double barWidth) {
+
+  int c;
+  double left, cur; /*shortcut to pixel boundaries of the chart*/
+  double height = 0;
+
+  for (c = 0; c < numvalues; c++) {
+    height += values[c];
+  }
+
+  cur = center->y + height / 2.;
+  left = center->x - barWidth / 2.;
+
+  for (c = 0; c < numvalues; c++) {
+    if (MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, left, cur,
+                                                left + barWidth,
+                                                cur - values[c], styles[c])))
+      return MS_FAILURE;
+    cur -= values[c];
+  }
+  return MS_SUCCESS;
+}
+
+int msDrawBarChart(mapObj *map, imageObj *image, pointObj *center,
+                   double *values, styleObj **styles, int numvalues,
+                   double width, double height, double *maxVal, double *minVal,
+                   double barWidth) {
+
+  double upperLimit, lowerLimit;
+  double shapeMaxVal, shapeMinVal, pixperval;
+  int c;
+  double vertOrigin, vertOriginClipped, horizStart, y;
+  double left, top, bottom; /*shortcut to pixel boundaries of the chart*/
+
+  top = center->y - height / 2.;
+  bottom = center->y + height / 2.;
+  left = center->x - width / 2.;
+
+  shapeMaxVal = shapeMinVal = values[0];
+  for (c = 1; c < numvalues; c++) {
+    if (maxVal == NULL || minVal == NULL) { /*compute bounds if not specified*/
+      if (values[c] > shapeMaxVal)
+        shapeMaxVal = values[c];
+      if (values[c] < shapeMinVal)
+        shapeMinVal = values[c];
+    }
+  }
+
+  /*
+   * use specified bounds if wanted
+   * if not, always show the origin
+   */
+  upperLimit = (maxVal != NULL) ? *maxVal : MS_MAX(shapeMaxVal, 0);
+  lowerLimit = (minVal != NULL) ? *minVal : MS_MIN(shapeMinVal, 0);
+  if (upperLimit == lowerLimit) {
+    /* treat the case where we would have an unspecified behavior */
+    upperLimit += 0.5;
+    lowerLimit -= 0.5;
+  }
+
+  pixperval = height / (upperLimit - lowerLimit);
+  vertOrigin = bottom + lowerLimit * pixperval;
+  vertOriginClipped = (vertOrigin < top)      ? top
+                      : (vertOrigin > bottom) ? bottom
+                                              : vertOrigin;
+  horizStart = left;
+
+  for (c = 0; c < numvalues; c++) {
+    double barHeight = values[c] * pixperval;
+    /*clip bars*/
+    y = ((vertOrigin - barHeight) < top)    ? top
+        : (vertOrigin - barHeight > bottom) ? bottom
+                                            : vertOrigin - barHeight;
+    if (y != vertOriginClipped) { /*don't draw bars of height == 0 (i.e. either
+                                     values==0, or clipped)*/
+      if (values[c] > 0) {
+        if (MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, horizStart, y,
+                                                    horizStart + barWidth - 1,
+                                                    vertOriginClipped,
+                                                    styles[c])))
+          return MS_FAILURE;
+      } else {
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        drawRectangle(map, image, horizStart, vertOriginClipped,
+                                      horizStart + barWidth - 1, y, styles[c])))
+          return MS_FAILURE;
+      }
+    }
+    horizStart += barWidth;
+  }
+  return MS_SUCCESS;
+}
+
+int WARN_UNUSED msDrawPieChart(mapObj *map, imageObj *image, pointObj *center,
+                               double diameter, double *values,
+                               styleObj **styles, int numvalues) {
+  int i;
+  double dTotal = 0., start = 0;
+
+  for (i = 0; i < numvalues; i++) {
+    if (values[i] < 0.) {
+      msSetError(MS_MISCERR, "cannot draw pie charts for negative values",
+                 "msDrawPieChart()");
+      return MS_FAILURE;
+    }
+    dTotal += values[i];
+  }
+
+  for (i = 0; i < numvalues; i++) {
+    double angle = values[i];
+    if (angle == 0)
+      continue; /*no need to draw. causes artifacts with outlines*/
+    angle *= 360.0 / dTotal;
+    if (MS_UNLIKELY(MS_FAILURE == msDrawPieSlice(map, image, center, styles[i],
+                                                 diameter / 2., start,
+                                                 start + angle)))
+      return MS_FAILURE;
+
+    start += angle;
+  }
+  return MS_SUCCESS;
+}
+
+int getNextShape(mapObj *map, layerObj *layer, double *values, int *nvalues,
+                 styleObj **styles, shapeObj *shape) {
+  int status;
+  int c;
+  status = msLayerNextShape(layer, shape);
+  if (status == MS_SUCCESS) {
+
+    if (layer->project) {
+      if (layer->reprojectorLayerToMap == NULL) {
+        layer->reprojectorLayerToMap =
+            msProjectCreateReprojector(&layer->projection, &map->projection);
+        if (layer->reprojectorLayerToMap == NULL) {
+          return MS_FAILURE;
+        }
+      }
+      msProjectShapeEx(layer->reprojectorLayerToMap, shape);
+    }
+
+    if (msBindLayerToShape(layer, shape,
+                           MS_DRAWMODE_FEATURES | MS_DRAWMODE_LABELS) !=
+        MS_SUCCESS)
+      return MS_FAILURE; /* error message is set in msBindLayerToShape() */
+
+    *nvalues = 0;
+    for (c = 0; c < layer->numclasses; c++) {
+      if (msEvalExpression(layer, shape, &(layer->class[c] -> expression),
+                           layer->classitemindex) == MS_TRUE) {
+        values[*nvalues] = (layer->class[c] -> styles[0] -> size);
+        styles[*nvalues] = layer->class[c]->styles[0];
+        (*nvalues)++;
+      }
+    }
+  }
+  return status;
+}
+
+/* eventually add a class to the layer to get the diameter from an attribute */
+int pieLayerProcessDynamicDiameter(layerObj *layer) {
+  const char *chartRangeProcessingKey = NULL;
+  char *attrib;
+  double mindiameter = -1, maxdiameter, minvalue, maxvalue;
+  classObj *newclass;
+  styleObj *newstyle;
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  if (chartSizeProcessingKey != NULL)
+    return MS_FALSE;
+  chartRangeProcessingKey = msLayerGetProcessingKey(layer, "CHART_SIZE_RANGE");
+  if (chartRangeProcessingKey == NULL)
+    return MS_FALSE;
+  attrib = msStrdup(chartRangeProcessingKey);
+  char *space = strchr(attrib, ' ');
+  if (space) {
+    *space = '\0';
+    switch (sscanf(space + 1, "%lf %lf %lf %lf", &mindiameter, &maxdiameter,
+                   &minvalue, &maxvalue)) {
+    case 4: /*we have the attribute and the four range values*/
+      break;
+    default:
+      free(attrib);
+      msSetError(MS_MISCERR,
+                 "Chart Layer format error for processing key \"CHART_RANGE\"",
+                 "msDrawChartLayer()");
+      return MS_FAILURE;
+    }
+  }
+
+  /*create a new class in the layer containing the wanted attribute
+   * as the SIZE of its first STYLE*/
+  newclass = msGrowLayerClasses(layer);
+  if (newclass == NULL) {
+    free(attrib);
+    return MS_FAILURE;
+  }
+  initClass(newclass);
+  layer->numclasses++;
+
+  /*create and attach a new styleObj to our temp class
+   * and bind the wanted attribute to its SIZE
+   */
+  newstyle = msGrowClassStyles(newclass);
+  if (newstyle == NULL) {
+    free(attrib);
+    return MS_FAILURE;
+  }
+  initStyle(newstyle);
+  newclass->numstyles++;
+  newclass->name = (char *)msStrdup("__MS_SIZE_ATTRIBUTE_");
+  newstyle->bindings[MS_STYLE_BINDING_SIZE].item = msStrdup(attrib);
+  newstyle->numbindings++;
+  free(attrib);
+
+  return MS_TRUE;
+}
+
+/* clean up the class added temporarily */
+static void pieLayerCleanupDynamicDiameter(layerObj *layer) {
+  if (layer->numclasses > 0 &&
+      EQUALN(layer->class[layer->numclasses - 1] -> name,
+             "__MS_SIZE_ATTRIBUTE_", 20)) {
+    classObj *c = msRemoveClass(layer, layer->numclasses - 1);
+    freeClass(c);
+    msFree(c);
+  }
+}
+
+int msDrawPieChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  shapeObj shape;
+  int status = MS_SUCCESS;
+  const char *chartRangeProcessingKey = NULL;
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  double diameter = 0, mindiameter = -1, maxdiameter = 0, minvalue = 0,
+         maxvalue = 0, exponent = 0;
+  double *values;
+  styleObj **styles;
+  pointObj center;
+  int numvalues =
+      layer->numclasses; /* the number of classes to represent in the graph */
+  int numvalues_for_shape = 0;
+
+  if (chartSizeProcessingKey == NULL) {
+    chartRangeProcessingKey =
+        msLayerGetProcessingKey(layer, "CHART_SIZE_RANGE");
+    if (chartRangeProcessingKey == NULL)
+      diameter = 20;
+    else {
+      sscanf(chartRangeProcessingKey, "%*s %lf %lf %lf %lf %lf", &mindiameter,
+             &maxdiameter, &minvalue, &maxvalue, &exponent);
+    }
+  } else {
+    if (sscanf(chartSizeProcessingKey, "%lf", &diameter) != 1) {
+      msSetError(MS_MISCERR,
+                 "msDrawChart format error for processing key \"CHART_SIZE\"",
+                 "msDrawPieChartLayer()");
+      return MS_FAILURE;
+    }
+  }
+
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
+
+  /* step through the target shapes */
+  msInitShape(&shape);
+
+  values = (double *)calloc(numvalues, sizeof(double));
+  MS_CHECK_ALLOC(values, numvalues * sizeof(double), MS_FAILURE);
+  styles = (styleObj **)malloc((numvalues) * sizeof(styleObj *));
+  if (styles == NULL) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawPieChartLayer()", __FILE__, __LINE__,
+               (unsigned int)(numvalues * sizeof(styleObj *)));
+    free(values);
+    return MS_FAILURE;
+  }
+
+  while (MS_SUCCESS == getNextShape(map, layer, values, &numvalues_for_shape,
+                                    styles, &shape)) {
+    if (chartRangeProcessingKey != NULL)
+      numvalues_for_shape--;
+    if (numvalues_for_shape == 0) {
+      msFreeShape(&shape);
+      continue;
+    }
+    msDrawStartShape(map, layer, image, &shape);
+    if (chartRangeProcessingKey != NULL) {
+      diameter = values[numvalues_for_shape];
+      if (mindiameter >= 0) {
+        if (diameter <= minvalue)
+          diameter = mindiameter;
+        else if (diameter >= maxvalue)
+          diameter = maxdiameter;
+        else {
+          if (exponent <= 0)
+            diameter = MS_NINT(mindiameter +
+                               ((diameter - minvalue) / (maxvalue - minvalue)) *
+                                   (maxdiameter - mindiameter));
+          else
+            diameter = MS_NINT(
+                mindiameter + pow((diameter - minvalue) / (maxvalue - minvalue),
+                                  1.0 / exponent) *
+                                  (maxdiameter - mindiameter));
+        }
+      }
+    }
+    if (findChartPoint(map, &shape, diameter, diameter, &center) ==
+        MS_SUCCESS) {
+      status = msDrawPieChart(map, image, &center, diameter, values, styles,
+                              numvalues_for_shape);
+    }
+    msDrawEndShape(map, layer, image, &shape);
+    msFreeShape(&shape);
+  }
+  free(values);
+  free(styles);
+  return status;
+}
+
+int msDrawVBarChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  shapeObj shape;
+  int status = MS_SUCCESS;
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  const char *chartScaleProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SCALE");
+  double barWidth, scale = 1.0;
+  double *values;
+  styleObj **styles;
+  pointObj center;
+  int numvalues = layer->numclasses;
+  int numvalues_for_shape;
+  if (chartSizeProcessingKey == NULL) {
+    barWidth = 20;
+  } else {
+    if (sscanf(chartSizeProcessingKey, "%lf", &barWidth) != 1) {
+      msSetError(MS_MISCERR,
+                 "msDrawChart format error for processing key \"CHART_SIZE\"",
+                 "msDrawVBarChartLayer()");
+      return MS_FAILURE;
+    }
+  }
+
+  if (chartScaleProcessingKey) {
+    if (sscanf(chartScaleProcessingKey, "%lf", &scale) != 1) {
+      msSetError(MS_MISCERR,
+                 "Error reading value for processing key \"CHART_SCALE\"",
+                 "msDrawVBarChartLayer()");
+      return MS_FAILURE;
+    }
+  }
+  msInitShape(&shape);
+
+  values = (double *)calloc(numvalues, sizeof(double));
+  MS_CHECK_ALLOC(values, numvalues * sizeof(double), MS_FAILURE);
+  styles = (styleObj **)malloc(numvalues * sizeof(styleObj *));
+  if (styles == NULL) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawVBarChartLayer()", __FILE__, __LINE__,
+               (unsigned int)(numvalues * sizeof(styleObj *)));
+    free(values);
+    return MS_FAILURE;
+  }
+
+  while (MS_SUCCESS == getNextShape(map, layer, values, &numvalues_for_shape,
+                                    styles, &shape)) {
+    int i;
+    double h = 0;
+    if (numvalues_for_shape == 0) {
+      continue;
+    }
+    for (i = 0; i < numvalues_for_shape; i++) {
+      values[i] *= scale;
+      h += values[i];
+    }
+    msDrawStartShape(map, layer, image, &shape);
+    if (findChartPoint(map, &shape, barWidth, h, &center) == MS_SUCCESS) {
+      status = msDrawVBarChart(map, image, &center, values, styles,
+                               numvalues_for_shape, barWidth);
+    }
+    msDrawEndShape(map, layer, image, &shape);
+    msFreeShape(&shape);
+  }
+  free(values);
+  free(styles);
+  return status;
+}
+
+int msDrawBarChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  shapeObj shape;
+  int status = MS_SUCCESS;
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  const char *barMax = msLayerGetProcessingKey(layer, "CHART_BAR_MAXVAL");
+  const char *barMin = msLayerGetProcessingKey(layer, "CHART_BAR_MINVAL");
+  double width, height;
+  double barWidth;
+  double *values;
+  styleObj **styles;
+  pointObj center;
+  double barMaxVal = 0.0, barMinVal = 0.0;
+  int numvalues = layer->numclasses;
+  int numvalues_for_shape;
+  if (chartSizeProcessingKey == NULL) {
+    width = height = 20;
+  } else {
+    switch (sscanf(chartSizeProcessingKey, "%lf %lf", &width, &height)) {
+    case 2:
+      break;
+    case 1:
+      height = width;
+      break;
+    default:
+      msSetError(MS_MISCERR,
+                 "msDrawChart format error for processing key \"CHART_SIZE\"",
+                 "msDrawBarChartLayer()");
+      return MS_FAILURE;
+    }
+  }
+
+  if (barMax) {
+    if (sscanf(barMax, "%lf", &barMaxVal) != 1) {
+      msSetError(MS_MISCERR,
+                 "Error reading value for processing key \"CHART_BAR_MAXVAL\"",
+                 "msDrawBarChartLayer()");
+      return MS_FAILURE;
+    }
+  }
+  if (barMin) {
+    if (sscanf(barMin, "%lf", &barMinVal) != 1) {
+      msSetError(MS_MISCERR,
+                 "Error reading value for processing key \"CHART_BAR_MINVAL\"",
+                 "msDrawBarChartLayer()");
+      return MS_FAILURE;
+    }
+  }
+  if (barMin && barMax && barMinVal >= barMaxVal) {
+    msSetError(MS_MISCERR,
+               "\"CHART_BAR_MINVAL\" must be less than \"CHART_BAR_MAXVAL\"",
+               "msDrawBarChartLayer()");
+    return MS_FAILURE;
+  }
+  barWidth = (double)width / (double)layer->numclasses;
+  if (!barWidth) {
+    msSetError(
+        MS_MISCERR,
+        "Specified width of chart too small to fit given number of classes",
+        "msDrawBarChartLayer()");
+    return MS_FAILURE;
+  }
+
+  msInitShape(&shape);
+
+  values = (double *)calloc(numvalues, sizeof(double));
+  MS_CHECK_ALLOC(values, numvalues * sizeof(double), MS_FAILURE);
+  styles = (styleObj **)malloc(numvalues * sizeof(styleObj *));
+  if (styles == NULL) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawBarChartLayer()", __FILE__, __LINE__,
+               (unsigned int)(numvalues * sizeof(styleObj *)));
+    free(values);
+    return MS_FAILURE;
+  }
+
+  while (MS_SUCCESS == getNextShape(map, layer, values, &numvalues_for_shape,
+                                    styles, &shape)) {
+    if (numvalues_for_shape == 0)
+      continue;
+    msDrawStartShape(map, layer, image, &shape);
+    if (findChartPoint(map, &shape, width, height, &center) == MS_SUCCESS) {
+      status = msDrawBarChart(map, image, &center, values, styles,
+                              numvalues_for_shape, width, height,
+                              (barMax != NULL) ? &barMaxVal : NULL,
+                              (barMin != NULL) ? &barMinVal : NULL, barWidth);
+    }
+    msDrawEndShape(map, layer, image, &shape);
+    msFreeShape(&shape);
+  }
+  free(values);
+  free(styles);
+  return status;
+}
+
+/**
+ * Generic function to render chart layers.
+ */
+int msDrawChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+
+  rectObj searchrect;
+  const char *chartTypeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_TYPE");
+  int chartType = MS_CHART_TYPE_PIE;
+  int status = MS_FAILURE;
+
+  if (image && map) {
+    if (!(MS_RENDERER_PLUGIN(image->format))) {
+      msSetError(MS_MISCERR,
+                 "chart drawing currently only supports GD and AGG renderers",
+                 "msDrawChartLayer()");
+      return MS_FAILURE;
+    }
+
+    if (chartTypeProcessingKey != NULL) {
+      if (strcasecmp(chartTypeProcessingKey, "PIE") == 0) {
+        chartType = MS_CHART_TYPE_PIE;
+      } else if (strcasecmp(chartTypeProcessingKey, "BAR") == 0) {
+        chartType = MS_CHART_TYPE_BAR;
+      } else if (strcasecmp(chartTypeProcessingKey, "VBAR") == 0) {
+        chartType = MS_CHART_TYPE_VBAR;
+      } else {
+        msSetError(MS_MISCERR,
+                   "unknown chart type for processing key \"CHART_TYPE\", must "
+                   "be one of \"PIE\" or \"BAR\"",
+                   "msDrawChartLayer()");
+        return MS_FAILURE;
+      }
+    }
+    if (chartType == MS_CHART_TYPE_PIE) {
+      pieLayerProcessDynamicDiameter(layer);
+    }
+
+    /* open this layer */
+    status = msLayerOpen(layer);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+
+    status = msLayerWhichItems(layer, MS_FALSE, NULL);
+    if (status != MS_SUCCESS) {
+      msLayerClose(layer);
+      return MS_FAILURE;
+    }
+    /* identify target shapes */
+    if (layer->transform == MS_TRUE)
+      searchrect = map->extent;
+    else {
+      searchrect.minx = searchrect.miny = 0;
+      searchrect.maxx = map->width - 1;
+      searchrect.maxy = map->height - 1;
+    }
+
+    if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+      msProjectRect(&map->projection, &layer->projection,
+                    &searchrect); /* project the searchrect to source coords */
+
+    status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
+    if (status == MS_DONE) { /* no overlap */
+      msLayerClose(layer);
+      if (chartType == MS_CHART_TYPE_PIE)
+        pieLayerCleanupDynamicDiameter(layer);
+      return MS_SUCCESS;
+    } else if (status != MS_SUCCESS) {
+      msLayerClose(layer);
+      if (chartType == MS_CHART_TYPE_PIE)
+        pieLayerCleanupDynamicDiameter(layer);
+      return MS_FAILURE;
+    }
+    switch (chartType) {
+    case MS_CHART_TYPE_PIE:
+      status = msDrawPieChartLayer(map, layer, image);
+      break;
+    case MS_CHART_TYPE_BAR:
+      status = msDrawBarChartLayer(map, layer, image);
+      break;
+    case MS_CHART_TYPE_VBAR:
+      status = msDrawVBarChartLayer(map, layer, image);
+      break;
+    default:
+      return MS_FAILURE; /*shouldn't be here anyways*/
+    }
+
+    msLayerClose(layer);
+
+    if (chartType == MS_CHART_TYPE_PIE)
+      pieLayerCleanupDynamicDiameter(layer);
+  }
+  return status;
+}
diff -pruN 8.0.1-5/src/mapcluster.c 8.2.0~beta1-1~exp1/src/mapcluster.c
--- 8.0.1-5/src/mapcluster.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcluster.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1857 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of the cluster layer data provider (RFC-69).
+ * Author:   Tamas Szekeres (szekerest@gmail.com).
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#define _CRT_SECURE_NO_WARNINGS 1
+
+/* $Id$ */
+#include <assert.h>
+#include "mapserver.h"
+
+#ifdef USE_CLUSTER_PLUGIN
+#define USE_CLUSTER_EXTERNAL
+#endif
+
+/* custom attributes provided by this layer data source */
+#define MSCLUSTER_NUMITEMS 3
+#define MSCLUSTER_FEATURECOUNT "Cluster_FeatureCount"
+#define MSCLUSTER_FEATURECOUNTINDEX -100
+#define MSCLUSTER_GROUP "Cluster_Group"
+#define MSCLUSTER_GROUPINDEX -101
+#define MSCLUSTER_BASEFID "Cluster_BaseFID"
+#define MSCLUSTER_BASEFIDINDEX -102
+
+typedef struct cluster_tree_node clusterTreeNode;
+typedef struct cluster_info clusterInfo;
+typedef struct cluster_layer_info msClusterLayerInfo;
+
+/* forward declarations */
+void msClusterLayerCopyVirtualTable(layerVTableObj *vtable);
+static void clusterTreeNodeDestroy(msClusterLayerInfo *layerinfo,
+                                   clusterTreeNode *node);
+
+/* cluster compare func */
+typedef int (*clusterCompareRegionFunc)(clusterInfo *current,
+                                        clusterInfo *other);
+
+/* quadtree constants */
+#define SPLITRATIO 0.55
+#define TREE_MAX_DEPTH 10
+
+/* cluster algorithm */
+#define MSCLUSTER_ALGORITHM_FULL 0
+#define MSCLUSTER_ALGORITHM_SIMPLE 1
+
+/* cluster data */
+struct cluster_info {
+  double x;       /* x position of the current point */
+  double y;       /* y position of the current point */
+  double avgx;    /* average x positions of this cluster */
+  double avgy;    /* average y positions of this cluster */
+  double varx;    /* variance of the x positions of this cluster */
+  double vary;    /* variance of the y positions of this cluster */
+  shapeObj shape; /* current shape */
+  rectObj bounds; /* clustering region */
+  /* number of the neighbouring shapes */
+  int numsiblings;
+  /* diagnostics */
+  int numcollected;
+  int numremoved;
+  int index;
+  clusterTreeNode *node;
+  /* collection of the siblings */
+  clusterInfo *siblings;
+  /* next shape in the linked list */
+  clusterInfo *next;
+  /* current group */
+  char *group;
+  int filter;
+};
+
+/* quadtree node */
+struct cluster_tree_node {
+  /* area covered by this node */
+  rectObj rect;
+  /* linked list of the shapes stored at this node. */
+  int numshapes;
+  int index;
+  int position;
+  clusterInfo *shapes;
+  /* quad tree subnodes */
+  clusterTreeNode *subnode[4];
+};
+
+/* layeinfo */
+struct cluster_layer_info {
+  /* array of features (finalized clusters) */
+  clusterInfo *finalized;
+  clusterInfo *finalizedSiblings;
+  clusterInfo *filtered;
+  int numFeatures;
+  int numFinalized;
+  int numFinalizedSiblings;
+  int numFiltered;
+  /* variables for collecting the best cluster and iterating with NextShape */
+  clusterInfo *current;
+  /* check whether all shapes should be returned behind a cluster */
+  int get_all_shapes;
+  /* check whether the location of the shapes should be preserved (no averaging)
+   */
+  int keep_locations;
+  /* the maxdistance and the buffer parameters are specified in map units (scale
+   * independent clustering) */
+  int use_map_units;
+  double rank;
+  /* root node of the quad tree */
+  clusterTreeNode *root;
+  int numNodes;
+  clusterTreeNode *finalizedNodes;
+  int numFinalizedNodes;
+  /* map extent used for building cluster data */
+  rectObj searchRect;
+  /* source layer parameters */
+  layerObj srcLayer;
+  /* distance comparator function */
+  clusterCompareRegionFunc fnCompare;
+  /* diagnostics */
+  int depth;
+  /* processing algorithm */
+  int algorithm;
+};
+
+extern int yyparse(parseObj *p);
+
+/* evaluate the filter expression */
+int msClusterEvaluateFilter(expressionObj *expression, shapeObj *shape) {
+  if (expression->type == MS_EXPRESSION) {
+    int status;
+    parseObj p;
+
+    p.shape = shape;
+    p.expr = expression;
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_BOOLEAN;
+
+    status = yyparse(&p);
+
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to parse expression: %s",
+                 "msClusterEvaluateFilter", expression->string);
+      return 0;
+    }
+
+    return p.result.intval;
+  }
+
+  return 0;
+}
+
+/* get the group text when creating the clusters */
+char *msClusterGetGroupText(expressionObj *expression, shapeObj *shape) {
+  char *tmpstr = NULL;
+
+  if (expression->string) {
+    switch (expression->type) {
+    case (MS_STRING):
+      tmpstr = msStrdup(expression->string);
+      break;
+    case (MS_EXPRESSION): {
+      int status;
+      parseObj p;
+
+      p.shape = shape;
+      p.expr = expression;
+      p.expr->curtoken = p.expr->tokens; /* reset */
+      p.type = MS_PARSE_TYPE_STRING;
+
+      status = yyparse(&p);
+
+      if (status != 0) {
+        msSetError(MS_PARSEERR, "Failed to process text expression: %s",
+                   "msClusterGetGroupText", expression->string);
+        return NULL;
+      }
+
+      tmpstr = p.result.strval;
+      break;
+    }
+    default:
+      break;
+    }
+  }
+
+  return (tmpstr);
+}
+
+int CompareEllipseRegion(clusterInfo *current, clusterInfo *other) {
+  if (current->group && other->group && !EQUAL(current->group, other->group))
+    return MS_FALSE;
+
+  if ((other->x - current->x) * (other->x - current->x) /
+              ((current->bounds.maxx - current->x) *
+               (current->bounds.maxx - current->x)) +
+          (other->y - current->y) * (other->y - current->y) /
+              ((current->bounds.maxy - current->y) *
+               (current->bounds.maxy - current->y)) >
+      1)
+    return MS_FALSE;
+
+  return MS_TRUE;
+}
+
+int CompareRectangleRegion(clusterInfo *current, clusterInfo *other) {
+  if (current->group && other->group && !EQUAL(current->group, other->group))
+    return MS_FALSE;
+
+  if (other->x < current->bounds.minx)
+    return MS_FALSE;
+  if (other->x > current->bounds.maxx)
+    return MS_FALSE;
+  if (other->y < current->bounds.miny)
+    return MS_FALSE;
+  if (other->y > current->bounds.maxy)
+    return MS_FALSE;
+
+  return MS_TRUE;
+}
+
+static void treeSplitBounds(rectObj *in, rectObj *out1, rectObj *out2) {
+  double range;
+
+  /* -------------------------------------------------------------------- */
+  /*      The output bounds will be very similar to the input bounds,     */
+  /*      so just copy over to start.                                     */
+  /* -------------------------------------------------------------------- */
+  memcpy(out1, in, sizeof(rectObj));
+  memcpy(out2, in, sizeof(rectObj));
+
+  /* -------------------------------------------------------------------- */
+  /*      Split in X direction.                                           */
+  /* -------------------------------------------------------------------- */
+  if ((in->maxx - in->minx) > (in->maxy - in->miny)) {
+    range = in->maxx - in->minx;
+
+    out1->maxx = in->minx + range * SPLITRATIO;
+    out2->minx = in->maxx - range * SPLITRATIO;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise split in Y direction.                                 */
+  /* -------------------------------------------------------------------- */
+  else {
+    range = in->maxy - in->miny;
+
+    out1->maxy = in->miny + range * SPLITRATIO;
+    out2->miny = in->maxy - range * SPLITRATIO;
+  }
+}
+
+/* alloc memory for a new tentative cluster */
+static clusterInfo *clusterInfoCreate(msClusterLayerInfo *layerinfo) {
+  clusterInfo *feature = (clusterInfo *)msSmallMalloc(sizeof(clusterInfo));
+  msInitShape(&feature->shape);
+  feature->numsiblings = 0;
+  feature->numcollected = 0;
+  feature->numremoved = 0;
+  feature->next = NULL;
+  feature->group = NULL;
+  feature->node = NULL;
+  feature->siblings = NULL;
+  feature->index = layerinfo->numFeatures;
+  feature->filter = -1; /* not yet calculated */
+  ++layerinfo->numFeatures;
+  return feature;
+}
+
+/* destroy memory of the cluster list */
+static void clusterInfoDestroyList(msClusterLayerInfo *layerinfo,
+                                   clusterInfo *feature) {
+  clusterInfo *s = feature;
+  clusterInfo *next;
+  /* destroy the shapes added to this node */
+  while (s) {
+    next = s->next;
+    if (s->siblings) {
+      clusterInfoDestroyList(layerinfo, s->siblings);
+    }
+    msFreeShape(&s->shape);
+    msFree(s->group);
+    msFree(s);
+    --layerinfo->numFeatures;
+    s = next;
+  }
+}
+
+/* alloc memory for a new treenode */
+static clusterTreeNode *clusterTreeNodeCreate(msClusterLayerInfo *layerinfo,
+                                              rectObj rect) {
+  clusterTreeNode *node =
+      (clusterTreeNode *)msSmallMalloc(sizeof(clusterTreeNode));
+  node->rect = rect;
+  node->numshapes = 0;
+  node->shapes = NULL;
+  node->subnode[0] = node->subnode[1] = node->subnode[2] = node->subnode[3] =
+      NULL;
+  node->index = layerinfo->numNodes;
+  node->position = 0;
+  ++layerinfo->numNodes;
+  return node;
+}
+
+/* traverse the quadtree and destroy all sub elements */
+static void clusterTreeNodeDestroy(msClusterLayerInfo *layerinfo,
+                                   clusterTreeNode *node) {
+  int i;
+  /* destroy the shapes added to this node */
+  clusterInfoDestroyList(layerinfo, node->shapes);
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i])
+      clusterTreeNodeDestroy(layerinfo, node->subnode[i]);
+  }
+
+  msFree(node);
+  --layerinfo->numNodes;
+}
+
+/* destroy memory of the cluster finalized list (without recursion) */
+static void clusterTreeNodeDestroyList(msClusterLayerInfo *layerinfo,
+                                       clusterTreeNode *node) {
+  clusterTreeNode *n = node;
+  clusterTreeNode *next;
+  /* destroy the list of nodes */
+  while (n) {
+    next = n->subnode[0];
+    n->subnode[0] = NULL;
+    clusterTreeNodeDestroy(layerinfo, n);
+    --layerinfo->numFinalizedNodes;
+    n = next;
+  }
+}
+
+void clusterDestroyData(msClusterLayerInfo *layerinfo) {
+  if (layerinfo->finalized) {
+    clusterInfoDestroyList(layerinfo, layerinfo->finalized);
+    layerinfo->finalized = NULL;
+  }
+  layerinfo->numFinalized = 0;
+
+  if (layerinfo->finalizedSiblings) {
+    clusterInfoDestroyList(layerinfo, layerinfo->finalizedSiblings);
+    layerinfo->finalizedSiblings = NULL;
+  }
+  layerinfo->numFinalizedSiblings = 0;
+
+  if (layerinfo->filtered) {
+    clusterInfoDestroyList(layerinfo, layerinfo->filtered);
+    layerinfo->filtered = NULL;
+  }
+  layerinfo->numFiltered = 0;
+
+  if (layerinfo->finalizedNodes) {
+    clusterTreeNodeDestroyList(layerinfo, layerinfo->finalizedNodes);
+    layerinfo->finalizedNodes = NULL;
+  }
+
+  layerinfo->numFinalizedNodes = 0;
+
+  if (layerinfo->root) {
+    clusterTreeNodeDestroy(layerinfo, layerinfo->root);
+    layerinfo->root = NULL;
+  }
+
+  layerinfo->numNodes = 0;
+}
+
+/* traverse the quadtree to find the neighbouring shapes and update some data
+on the related shapes (when adding a new feature)*/
+static void findRelatedShapes(msClusterLayerInfo *layerinfo,
+                              clusterTreeNode *node, clusterInfo *current) {
+  int i;
+  clusterInfo *s;
+
+  /* -------------------------------------------------------------------- */
+  /*      Does this node overlap the area of interest at all?  If not,    */
+  /*      return without adding to the list at all.                       */
+  /* -------------------------------------------------------------------- */
+  if (!msRectOverlap(&node->rect, &current->bounds))
+    return;
+
+  /* Modify the feature count of the related shapes */
+  s = node->shapes;
+  while (s) {
+    if (layerinfo->fnCompare(current, s)) {
+      ++current->numsiblings;
+      /* calculating the average positions */
+      current->avgx = (current->avgx * current->numsiblings + s->x) /
+                      (current->numsiblings + 1);
+      current->avgy = (current->avgy * current->numsiblings + s->y) /
+                      (current->numsiblings + 1);
+      /* calculating the variance */
+      current->varx =
+          current->varx * current->numsiblings / (current->numsiblings + 1) +
+          (s->x - current->avgx) * (s->x - current->avgx) /
+              (current->numsiblings + 1);
+      current->vary =
+          current->vary * current->numsiblings / (current->numsiblings + 1) +
+          (s->y - current->avgy) * (s->y - current->avgy) /
+              (current->numsiblings + 1);
+
+      if (layerinfo->fnCompare(s, current)) {
+        /* this feature falls into the region of the other as well */
+        ++s->numsiblings;
+        /* calculating the average positions */
+        s->avgx =
+            (s->avgx * s->numsiblings + current->x) / (s->numsiblings + 1);
+        s->avgy =
+            (s->avgy * s->numsiblings + current->y) / (s->numsiblings + 1);
+        /* calculating the variance */
+        s->varx = s->varx * s->numsiblings / (s->numsiblings + 1) +
+                  (current->x - s->avgx) * (current->x - s->avgx) /
+                      (s->numsiblings + 1);
+        s->vary = s->vary * s->numsiblings / (s->numsiblings + 1) +
+                  (current->y - s->avgy) * (current->y - s->avgy) /
+                      (s->numsiblings + 1);
+      }
+    }
+    s = s->next;
+  }
+
+  if (node->subnode[0] == NULL)
+    return;
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i])
+      findRelatedShapes(layerinfo, node->subnode[i], current);
+  }
+}
+
+/* traverse the quadtree to find the neighbouring clusters and update data on
+ * the cluster*/
+static void findRelatedShapes2(msClusterLayerInfo *layerinfo,
+                               clusterTreeNode *node, clusterInfo *current) {
+  int i;
+  clusterInfo *s;
+
+  /* -------------------------------------------------------------------- */
+  /*      Does this node overlap the area of interest at all?  If not,    */
+  /*      return without adding to the list at all.                       */
+  /* -------------------------------------------------------------------- */
+  if (!msRectOverlap(&node->rect, &current->bounds))
+    return;
+
+  /* Modify the feature count of the related shapes */
+  s = node->shapes;
+  while (s) {
+    if (layerinfo->fnCompare(s, current)) {
+      if (layerinfo->rank > 0) {
+        double r = (current->x - s->x) * (current->x - s->x) +
+                   (current->y - s->y) * (current->y - s->y);
+        if (r < layerinfo->rank) {
+          layerinfo->current = s;
+          layerinfo->rank = r;
+        }
+      } else {
+        /* no rank was specified, return immediately */
+        layerinfo->current = s;
+        return;
+      }
+    }
+    s = s->next;
+  }
+
+  if (node->subnode[0] == NULL)
+    return;
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i])
+      findRelatedShapes2(layerinfo, node->subnode[i], current);
+  }
+}
+
+/* traverse the quadtree to find the neighbouring shapes and update some data
+on the related shapes (when removing a feature) */
+static void findRelatedShapesRemove(msClusterLayerInfo *layerinfo,
+                                    clusterTreeNode *node,
+                                    clusterInfo *current) {
+  int i;
+  clusterInfo *s;
+
+  /* -------------------------------------------------------------------- */
+  /*      Does this node overlap the area of interest at all?  If not,    */
+  /*      return without adding to the list at all.                       */
+  /* -------------------------------------------------------------------- */
+  if (!msRectOverlap(&node->rect, &current->bounds))
+    return;
+
+  /* Modify the feature count of the related shapes */
+  s = node->shapes;
+  while (s) {
+    if (layerinfo->fnCompare(current, s)) {
+      if (s->numsiblings > 0) {
+        /* calculating the average positions */
+        s->avgx =
+            (s->avgx * (s->numsiblings + 1) - current->x) / s->numsiblings;
+        s->avgy =
+            (s->avgy * (s->numsiblings + 1) - current->y) / s->numsiblings;
+        /* calculating the variance */
+        s->varx = (s->varx - (current->x - s->avgx) * (current->x - s->avgx) /
+                                 s->numsiblings) *
+                  (s->numsiblings + 1) / s->numsiblings;
+        s->vary = (s->vary - (current->y - s->avgy) * (current->y - s->avgy) /
+                                 s->numsiblings) *
+                  (s->numsiblings + 1) / s->numsiblings;
+        --s->numsiblings;
+        ++s->numremoved;
+      }
+    }
+    s = s->next;
+  }
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i])
+      findRelatedShapesRemove(layerinfo, node->subnode[i], current);
+  }
+}
+
+/* setting the aggregated attributes */
+static void InitShapeAttributes(layerObj *layer, clusterInfo *base) {
+  int i;
+  int *itemindexes = layer->iteminfo;
+
+  for (i = 0; i < layer->numitems; i++) {
+    if (base->shape.numvalues <= i)
+      break;
+
+    if (itemindexes[i] == MSCLUSTER_FEATURECOUNTINDEX) {
+      if (base->shape.values[i])
+        msFree(base->shape.values[i]);
+
+      base->shape.values[i] = msIntToString(base->numsiblings + 1);
+    } else if (itemindexes[i] == MSCLUSTER_GROUPINDEX) {
+      if (base->shape.values[i])
+        msFree(base->shape.values[i]);
+
+      if (base->group)
+        base->shape.values[i] = msStrdup(base->group);
+      else
+        base->shape.values[i] = msStrdup("");
+    } else if (itemindexes[i] == MSCLUSTER_BASEFIDINDEX) {
+      if (base->shape.values[i])
+        msFree(base->shape.values[i]);
+
+      base->shape.values[i] = msIntToString(base->shape.index);
+    } else if (EQUALN(layer->items[i], "Count:", 6)) {
+      if (base->shape.values[i])
+        msFree(base->shape.values[i]);
+
+      base->shape.values[i] = msStrdup("1"); /* initial count */
+    }
+  }
+}
+
+/* update the shape attributes (aggregate) */
+static void UpdateShapeAttributes(layerObj *layer, clusterInfo *base,
+                                  clusterInfo *current) {
+  int i;
+  int *itemindexes = layer->iteminfo;
+
+  for (i = 0; i < layer->numitems; i++) {
+    if (base->shape.numvalues <= i)
+      break;
+
+    if (itemindexes[i] == MSCLUSTER_FEATURECOUNTINDEX ||
+        itemindexes[i] == MSCLUSTER_GROUPINDEX)
+      continue;
+
+    if (current->shape.numvalues <= i)
+      break;
+
+    /* setting the base feature index for each cluster member */
+    if (itemindexes[i] == MSCLUSTER_BASEFIDINDEX) {
+      msFree(current->shape.values[i]);
+      current->shape.values[i] = msIntToString(base->shape.index);
+    }
+
+    if (current->shape.values[i]) {
+      if (EQUALN(layer->items[i], "Min:", 4)) {
+        if (strcasecmp(base->shape.values[i], current->shape.values[i]) > 0) {
+          msFree(base->shape.values[i]);
+          base->shape.values[i] = msStrdup(current->shape.values[i]);
+        }
+      } else if (EQUALN(layer->items[i], "Max:", 4)) {
+        if (strcasecmp(base->shape.values[i], current->shape.values[i]) < 0) {
+          msFree(base->shape.values[i]);
+          base->shape.values[i] = msStrdup(current->shape.values[i]);
+        }
+      } else if (EQUALN(layer->items[i], "Sum:", 4)) {
+        double sum =
+            atof(base->shape.values[i]) + atof(current->shape.values[i]);
+        msFree(base->shape.values[i]);
+        base->shape.values[i] = msDoubleToString(sum, MS_FALSE);
+      } else if (EQUALN(layer->items[i], "Count:", 6)) {
+        int count = atoi(base->shape.values[i]) + 1;
+        msFree(base->shape.values[i]);
+        base->shape.values[i] = msIntToString(count);
+      }
+    }
+  }
+}
+
+static int BuildFeatureAttributes(layerObj *layer,
+                                  msClusterLayerInfo *layerinfo,
+                                  shapeObj *shape) {
+  char **values;
+  int i;
+  int *itemindexes = layer->iteminfo;
+
+  if (layer->numitems == layerinfo->srcLayer.numitems)
+    return MS_SUCCESS; /* we don't have custom attributes, no need to
+                          reconstruct the array */
+
+  values = msSmallMalloc(sizeof(char *) * (layer->numitems));
+
+  for (i = 0; i < layer->numitems; i++) {
+    if (itemindexes[i] == MSCLUSTER_FEATURECOUNTINDEX) {
+      values[i] = NULL; /* not yet assigned */
+    } else if (itemindexes[i] == MSCLUSTER_GROUPINDEX) {
+      values[i] = NULL; /* not yet assigned */
+    } else if (itemindexes[i] == MSCLUSTER_BASEFIDINDEX) {
+      values[i] = NULL; /* not yet assigned */
+    } else if (shape->values[itemindexes[i]])
+      values[i] = msStrdup(shape->values[itemindexes[i]]);
+    else
+      values[i] = msStrdup("");
+  }
+
+  if (shape->values)
+    msFreeCharArray(shape->values, shape->numvalues);
+
+  shape->values = values;
+  shape->numvalues = layer->numitems;
+
+  return MS_SUCCESS;
+}
+
+/* traverse the quadtree to find the best renking cluster */
+static void findBestCluster(layerObj *layer, msClusterLayerInfo *layerinfo,
+                            clusterTreeNode *node) {
+  int i;
+  double rank;
+  clusterInfo *s = node->shapes;
+  while (s) {
+    if (s->filter < 0 && layer->cluster.filter.string != NULL) {
+      InitShapeAttributes(layer, s);
+      s->filter = msClusterEvaluateFilter(&layer->cluster.filter, &s->shape);
+    }
+
+    if (s->numsiblings == 0 || s->filter == 0) {
+      /* individual or filtered shapes must be removed for sure */
+      layerinfo->current = s;
+      return;
+    }
+
+    /* calculating the rank */
+    rank = (s->x - s->avgx) * (s->x - s->avgx) +
+           (s->y - s->avgy) * (s->y - s->avgy) /*+ s->varx + s->vary*/ +
+           (double)1 / (1 + s->numsiblings);
+
+    if (rank < layerinfo->rank) {
+      layerinfo->current = s;
+      layerinfo->rank = rank;
+    }
+    s = s->next;
+  }
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i])
+      findBestCluster(layer, layerinfo, node->subnode[i]);
+  }
+}
+
+/* adding the shape based on the shape bounds (point) */
+static int treeNodeAddShape(msClusterLayerInfo *layerinfo,
+                            clusterTreeNode *node, clusterInfo *shape,
+                            int depth) {
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*      If there are subnodes, then consider whether this object        */
+  /*      will fit in them.                                               */
+  /* -------------------------------------------------------------------- */
+  if (depth > 1 && node->subnode[0] != NULL) {
+    for (i = 0; i < 4; i++) {
+      if (msRectContained(&shape->shape.bounds, &node->subnode[i]->rect)) {
+        return treeNodeAddShape(layerinfo, node->subnode[i], shape, depth - 1);
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise, consider creating four subnodes if could fit into    */
+  /*      them, and adding to the appropriate subnode.                    */
+  /* -------------------------------------------------------------------- */
+  else if (depth > 1 && node->subnode[0] == NULL) {
+    rectObj half1, half2, quad1, quad2, quad3, quad4;
+    int subnode = -1;
+
+    treeSplitBounds(&node->rect, &half1, &half2);
+    treeSplitBounds(&half1, &quad1, &quad2);
+    treeSplitBounds(&half2, &quad3, &quad4);
+
+    if (msRectContained(&shape->shape.bounds, &quad1))
+      subnode = 0;
+    else if (msRectContained(&shape->shape.bounds, &quad2))
+      subnode = 1;
+    else if (msRectContained(&shape->shape.bounds, &quad3))
+      subnode = 2;
+    else if (msRectContained(&shape->shape.bounds, &quad4))
+      subnode = 3;
+
+    if (subnode >= 0) {
+      if ((node->subnode[0] = clusterTreeNodeCreate(layerinfo, quad1)) == NULL)
+        return MS_FAILURE;
+      node->subnode[0]->position = node->position * 4;
+
+      if ((node->subnode[1] = clusterTreeNodeCreate(layerinfo, quad2)) == NULL)
+        return MS_FAILURE;
+      node->subnode[1]->position = node->position * 4 + 1;
+
+      if ((node->subnode[2] = clusterTreeNodeCreate(layerinfo, quad3)) == NULL)
+        return MS_FAILURE;
+      node->subnode[2]->position = node->position * 4 + 2;
+
+      if ((node->subnode[3] = clusterTreeNodeCreate(layerinfo, quad4)) == NULL)
+        return MS_FAILURE;
+      node->subnode[3]->position = node->position * 4 + 3;
+
+      /* add to subnode */
+      return treeNodeAddShape(layerinfo, node->subnode[subnode], shape,
+                              depth - 1);
+    }
+  }
+
+  /* found the right place, add this shape to the node */
+  node->numshapes++;
+  shape->next = node->shapes;
+  node->shapes = shape;
+  shape->node = node;
+
+  return MS_SUCCESS;
+}
+
+/* collecting the cluster shapes, returns true if this subnode must be removed
+ */
+static int collectClusterShapes(msClusterLayerInfo *layerinfo,
+                                clusterTreeNode *node, clusterInfo *current) {
+  int i;
+  clusterInfo *prev = NULL;
+  clusterInfo *s = node->shapes;
+
+  if (!msRectOverlap(&node->rect, &current->bounds))
+    return (!node->shapes && !node->subnode[0] && !node->subnode[1] &&
+            !node->subnode[2] && !node->subnode[3]);
+
+  /* removing the shapes from this node if overlap with the cluster */
+  while (s) {
+    if (s == current || layerinfo->fnCompare(current, s)) {
+      if (s != current && current->filter == 0) {
+        /* skip siblings of the filtered shapes */
+        prev = s;
+        s = prev->next;
+        continue;
+      }
+
+      /* removing from the list */
+      if (!prev)
+        node->shapes = s->next;
+      else
+        prev->next = s->next;
+
+      ++current->numcollected;
+
+      /* adding the shape to the finalization list */
+      if (s == current) {
+        if (s->filter) {
+          s->next = layerinfo->finalized;
+          layerinfo->finalized = s;
+          ++layerinfo->numFinalized;
+        } else {
+          /* this shape is filtered */
+          s->next = layerinfo->filtered;
+          layerinfo->filtered = s;
+          ++layerinfo->numFiltered;
+        }
+      } else {
+        s->next = layerinfo->finalizedSiblings;
+        layerinfo->finalizedSiblings = s;
+        ++layerinfo->numFinalizedSiblings;
+      }
+
+      if (!prev)
+        s = node->shapes;
+      else
+        s = prev->next;
+    } else {
+      prev = s;
+      s = prev->next;
+    }
+  }
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i] &&
+        collectClusterShapes(layerinfo, node->subnode[i], current)) {
+      /* placing this empty node to the finalization queue */
+      node->subnode[i]->subnode[0] = layerinfo->finalizedNodes;
+      layerinfo->finalizedNodes = node->subnode[i];
+      node->subnode[i] = NULL;
+      ++layerinfo->numFinalizedNodes;
+    }
+  }
+
+  /* returns true is this subnode must be removed */
+  return (!node->shapes && !node->subnode[0] && !node->subnode[1] &&
+          !node->subnode[2] && !node->subnode[3]);
+}
+
+/* collecting the cluster shapes, returns true if this subnode must be removed
+ */
+static int collectClusterShapes2(layerObj *layer, msClusterLayerInfo *layerinfo,
+                                 clusterTreeNode *node) {
+  int i;
+  clusterInfo *current = NULL;
+  clusterInfo *s;
+
+  while (node->shapes) {
+    s = node->shapes;
+    /* removing from the list */
+    node->shapes = s->next;
+
+    InitShapeAttributes(layer, s);
+
+    if (s->filter) {
+      s->next = layerinfo->finalized;
+      layerinfo->finalized = s;
+      ++layerinfo->numFinalized;
+    } else {
+      /* this shape is filtered */
+      s->next = layerinfo->filtered;
+      layerinfo->filtered = s;
+      ++layerinfo->numFiltered;
+    }
+
+    /* update the parameters of the related shapes if any */
+    if (s->siblings) {
+      current = s->siblings;
+      while (current) {
+        UpdateShapeAttributes(layer, s, current);
+
+        /* setting the average position to the cluster position */
+        current->avgx = s->x;
+        current->avgy = s->y;
+
+        if (current->next == NULL) {
+          if (layerinfo->get_all_shapes == MS_TRUE) {
+            /* insert the siblings into the finalization list */
+            current->next = layerinfo->finalized;
+            layerinfo->finalized = s->siblings;
+            s->siblings = NULL;
+          }
+          break;
+        }
+
+        current = current->next;
+      }
+    }
+  }
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i] &&
+        collectClusterShapes2(layer, layerinfo, node->subnode[i])) {
+      /* placing this empty node to the finalization queue */
+      node->subnode[i]->subnode[0] = layerinfo->finalizedNodes;
+      layerinfo->finalizedNodes = node->subnode[i];
+      node->subnode[i] = NULL;
+      ++layerinfo->numFinalizedNodes;
+    }
+  }
+
+  /* returns true is this subnode must be removed */
+  return (!node->shapes && !node->subnode[0] && !node->subnode[1] &&
+          !node->subnode[2] && !node->subnode[3]);
+}
+
+int selectClusterShape(layerObj *layer, long shapeindex) {
+  int i;
+  clusterInfo *current;
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo) {
+    msSetError(MS_MISCERR, "Layer not open: %s", "selectClusterShape()",
+               layer->name);
+    return MS_FAILURE;
+  }
+
+  i = 0;
+  current = layerinfo->finalized;
+  while (current && i < shapeindex) {
+    ++i;
+    current = current->next;
+  }
+  assert(current);
+
+  current->next = current->siblings;
+  layerinfo->current = current;
+
+  if (layerinfo->keep_locations == MS_FALSE) {
+    current->shape.line[0].point[0].x = current->shape.bounds.minx =
+        current->shape.bounds.maxx = current->avgx;
+    current->shape.line[0].point[0].y = current->shape.bounds.miny =
+        current->shape.bounds.maxy = current->avgy;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* update the parameters from the related shapes */
+#ifdef ms_notused
+static void UpdateClusterParameters(msClusterLayerInfo *layerinfo,
+                                    clusterTreeNode *node, clusterInfo *shape) {
+  int i;
+  clusterInfo *s = node->shapes;
+
+  while (s) {
+    if (layerinfo->fnCompare(shape, s)) {
+      shape->avgx += s->x;
+      shape->avgy += s->y;
+      ++shape->numsiblings;
+    }
+    s = s->next;
+  }
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i])
+      UpdateClusterParameters(layerinfo, node->subnode[i], shape);
+  }
+}
+
+/* check for the validity of the clusters added to the tree (for debug purposes)
+ */
+static int ValidateTree(msClusterLayerInfo *layerinfo, clusterTreeNode *node) {
+  int i;
+  int isValid = MS_TRUE;
+
+  clusterInfo *s = node->shapes;
+  while (s) {
+    double avgx = s->avgx;
+    double avgy = s->avgy;
+    int numsiblings = s->numsiblings;
+
+    s->avgx = 0;
+    s->avgy = 0;
+    s->numsiblings = 0;
+
+    UpdateClusterParameters(layerinfo, layerinfo->root, s);
+
+    if (numsiblings + 1 != s->numsiblings)
+      isValid = MS_FALSE;
+    else if ((avgx * s->numsiblings - s->avgx) / s->avgx > 0.000001)
+      isValid = MS_FALSE;
+    else if ((avgy * s->numsiblings - s->avgy) / s->avgy > 0.000001)
+      isValid = MS_FALSE;
+
+    s->avgx = avgx;
+    s->avgy = avgy;
+    s->numsiblings = numsiblings;
+
+    if (isValid == MS_FALSE)
+      return MS_FALSE;
+
+    s = s->next;
+  }
+
+  /* Recurse to subnodes if they exist */
+  for (i = 0; i < 4; i++) {
+    if (node->subnode[i] &&
+        ValidateTree(layerinfo, node->subnode[i]) == MS_FALSE)
+      return MS_FALSE;
+  }
+
+  /* returns true if this node contains only valid clusters */
+  return MS_TRUE;
+}
+#endif
+
+/* rebuild the clusters according to the current extent */
+int RebuildClusters(layerObj *layer, int isQuery) {
+  mapObj *map;
+  layerObj *srcLayer;
+  double distance, maxDistanceX, maxDistanceY, cellSizeX, cellSizeY;
+  rectObj searchrect;
+  int status;
+  clusterInfo *current;
+  int depth;
+  const char *pszProcessing;
+#ifdef USE_CLUSTER_EXTERNAL
+  int layerIndex;
+#endif
+  reprojectionObj *reprojector = NULL;
+
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
+
+  if (!layerinfo) {
+    msSetError(MS_MISCERR, "Layer is not open: %s", "RebuildClusters()",
+               layer->name);
+    return MS_FAILURE;
+  }
+
+  if (!layer->map) {
+    msSetError(MS_MISCERR, "No map associated with this layer: %s",
+               "RebuildClusters()", layer->name);
+    return MS_FAILURE;
+  }
+
+  if (layer->debug >= MS_DEBUGLEVEL_VVV)
+    msDebug("Clustering started.\n");
+
+  map = layer->map;
+
+  layerinfo->current = layerinfo->finalized; /* restart */
+
+  /* check whether the simplified algorithm was selected */
+  pszProcessing = msLayerGetProcessingKey(layer, "CLUSTER_ALGORITHM");
+  if (pszProcessing && !strncasecmp(pszProcessing, "SIMPLE", 6))
+    layerinfo->algorithm = MSCLUSTER_ALGORITHM_SIMPLE;
+  else
+    layerinfo->algorithm = MSCLUSTER_ALGORITHM_FULL;
+
+  /* check whether all shapes should be returned from a query */
+  if (msLayerGetProcessingKey(layer, "CLUSTER_GET_ALL_SHAPES") != NULL)
+    layerinfo->get_all_shapes = MS_TRUE;
+  else
+    layerinfo->get_all_shapes = MS_FALSE;
+
+  /* check whether the location of the shapes should be preserved */
+  if (msLayerGetProcessingKey(layer, "CLUSTER_KEEP_LOCATIONS") != NULL)
+    layerinfo->keep_locations = MS_TRUE;
+  else
+    layerinfo->keep_locations = MS_FALSE;
+
+  /* check whether the maxdistance and the buffer parameters
+  are specified in map units (scale independent clustering) */
+  if (msLayerGetProcessingKey(layer, "CLUSTER_USE_MAP_UNITS") != NULL)
+    layerinfo->use_map_units = MS_TRUE;
+  else
+    layerinfo->use_map_units = MS_FALSE;
+
+  /* identify the current extent */
+  if (layer->transform == MS_TRUE)
+    searchrect = map->extent;
+  else {
+    searchrect.minx = searchrect.miny = 0;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
+  }
+
+  if (searchrect.minx == layerinfo->searchRect.minx &&
+      searchrect.miny == layerinfo->searchRect.miny &&
+      searchrect.maxx == layerinfo->searchRect.maxx &&
+      searchrect.maxy == layerinfo->searchRect.maxy) {
+    /* already built */
+    return MS_SUCCESS;
+  }
+
+  /* destroy previous data*/
+  clusterDestroyData(layerinfo);
+
+  layerinfo->searchRect = searchrect;
+
+  /* reproject the rectangle to layer coordinates */
+  if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
+
+  /* determine the compare method */
+  layerinfo->fnCompare = CompareRectangleRegion;
+  if (layer->cluster.region) {
+    if (EQUAL(layer->cluster.region, "ellipse"))
+      layerinfo->fnCompare = CompareEllipseRegion;
+  }
+
+  /* trying to find a reasonable quadtree depth */
+  depth = 0;
+  distance = layer->cluster.maxdistance;
+  if (layerinfo->use_map_units == MS_TRUE) {
+    while ((distance < (searchrect.maxx - searchrect.minx) ||
+            distance < (searchrect.maxy - searchrect.miny)) &&
+           depth <= TREE_MAX_DEPTH) {
+      distance *= 2;
+      ++depth;
+    }
+    cellSizeX = 1;
+    cellSizeY = 1;
+  } else {
+    while ((distance < map->width || distance < map->height) &&
+           depth <= TREE_MAX_DEPTH) {
+      distance *= 2;
+      ++depth;
+    }
+    cellSizeX = MS_CELLSIZE(searchrect.minx, searchrect.maxx, map->width);
+    cellSizeY = MS_CELLSIZE(searchrect.miny, searchrect.maxy, map->height);
+  }
+
+  layerinfo->depth = depth;
+
+  maxDistanceX = layer->cluster.maxdistance * cellSizeX;
+  maxDistanceY = layer->cluster.maxdistance * cellSizeY;
+
+  /* increase the search rectangle so that the neighbouring shapes are also
+   * retrieved */
+  searchrect.minx -= layer->cluster.buffer * cellSizeX;
+  searchrect.maxx += layer->cluster.buffer * cellSizeX;
+  searchrect.miny -= layer->cluster.buffer * cellSizeY;
+  searchrect.maxy += layer->cluster.buffer * cellSizeY;
+
+  /* create the root node */
+  if (layerinfo->root)
+    clusterTreeNodeDestroy(layerinfo, layerinfo->root);
+  layerinfo->root = clusterTreeNodeCreate(layerinfo, searchrect);
+
+  srcLayer = &layerinfo->srcLayer;
+
+  /* start retrieving the shapes */
+  status = msLayerWhichShapes(srcLayer, searchrect, isQuery);
+  if (status == MS_DONE) {
+    /* no overlap */
+    return MS_SUCCESS;
+  } else if (status != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  /* step through the source shapes and populate the quadtree with the tentative
+   * clusters */
+  if ((current = clusterInfoCreate(layerinfo)) == NULL)
+    return MS_FAILURE;
+
+#if defined(USE_CLUSTER_EXTERNAL)
+  if (srcLayer->transform == MS_TRUE && srcLayer->project &&
+      layer->transform == MS_TRUE && layer->project &&
+      msProjectionsDiffer(&(srcLayer->projection), &(layer->projection))) {
+    reprojector =
+        msProjectCreateReprojector(&srcLayer->projection, &layer->projection);
+  }
+#endif
+
+  while ((status = msLayerNextShape(srcLayer, &current->shape)) == MS_SUCCESS) {
+#if defined(USE_CLUSTER_EXTERNAL)
+    /* transform the shape to the projection of this layer */
+    if (reprojector)
+      msProjectShapeEx(reprojector, &current->shape);
+#endif
+    /* set up positions and variance */
+    current->avgx = current->x = current->shape.bounds.minx;
+    current->avgy = current->y = current->shape.bounds.miny;
+    current->varx = current->vary = 0;
+    /* set up the area of interest when searching for the neighboring shapes */
+    current->bounds.minx = current->x - maxDistanceX;
+    current->bounds.miny = current->y - maxDistanceY;
+    current->bounds.maxx = current->x + maxDistanceX;
+    current->bounds.maxy = current->y + maxDistanceY;
+
+    /* if the shape doesn't overlap we must skip it to avoid further issues */
+    if (!msRectOverlap(&searchrect, &current->bounds)) {
+      msFreeShape(&current->shape);
+      msInitShape(&current->shape);
+
+      msDebug(
+          "Skipping an invalid shape falling outside of the given extent\n");
+      continue;
+    }
+
+    /* construct the item array */
+    if (layer->iteminfo)
+      BuildFeatureAttributes(layer, layerinfo, &current->shape);
+
+    /* evaluate the group expression */
+    if (layer->cluster.group.string)
+      current->group =
+          msClusterGetGroupText(&layer->cluster.group, &current->shape);
+
+    if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_FULL) {
+      /*start a query for the related shapes */
+      findRelatedShapes(layerinfo, layerinfo->root, current);
+
+      /* add this shape to the tree */
+      if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) !=
+          MS_SUCCESS) {
+        clusterInfoDestroyList(layerinfo, current);
+        msProjectDestroyReprojector(reprojector);
+        return MS_FAILURE;
+      }
+    } else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
+      /* find a related cluster and try to assign */
+      layerinfo->rank = 0;
+      layerinfo->current = NULL;
+      findRelatedShapes2(layerinfo, layerinfo->root, current);
+      if (layerinfo->current) {
+        /* store these points until all clusters are created */
+        current->next = layerinfo->finalizedSiblings;
+        layerinfo->finalizedSiblings = current;
+      } else {
+        /* if not found add this shape as a new cluster */
+        if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) !=
+            MS_SUCCESS) {
+          clusterInfoDestroyList(layerinfo, current);
+          msProjectDestroyReprojector(reprojector);
+          return MS_FAILURE;
+        }
+      }
+    }
+
+    if ((current = clusterInfoCreate(layerinfo)) == NULL) {
+      clusterInfoDestroyList(layerinfo, current);
+      msProjectDestroyReprojector(reprojector);
+      return MS_FAILURE;
+    }
+  }
+
+  msProjectDestroyReprojector(reprojector);
+
+  clusterInfoDestroyList(layerinfo, current);
+
+  if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_FULL) {
+    while (layerinfo->root) {
+#ifdef TESTCOUNT
+      int n;
+      double avgx, avgy;
+#endif
+
+      /* pick up the best cluster from the tree and do the finalization */
+      /* the initial rank must be big enough */
+      layerinfo->rank = (searchrect.maxx - searchrect.minx) *
+                            (searchrect.maxx - searchrect.minx) +
+                        (searchrect.maxy - searchrect.miny) *
+                            (searchrect.maxy - searchrect.miny) +
+                        1;
+
+      layerinfo->current = NULL;
+      findBestCluster(layer, layerinfo, layerinfo->root);
+
+      if (layerinfo->current == NULL) {
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug("Clustering terminated.\n");
+        break; /* completed */
+      }
+
+      /* Update the feature count of the shape */
+      InitShapeAttributes(layer, layerinfo->current);
+
+      /* collecting the shapes of the cluster */
+      collectClusterShapes(layerinfo, layerinfo->root, layerinfo->current);
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+        msDebug(
+            "processing cluster %p: rank=%lf fcount=%d ncoll=%d nfin=%d "
+            "nfins=%d nflt=%d bounds={%lf %lf %lf %lf}\n",
+            layerinfo->current, layerinfo->rank,
+            layerinfo->current->numsiblings + 1,
+            layerinfo->current->numcollected, layerinfo->numFinalized,
+            layerinfo->numFinalizedSiblings, layerinfo->numFiltered,
+            layerinfo->current->bounds.minx, layerinfo->current->bounds.miny,
+            layerinfo->current->bounds.maxx, layerinfo->current->bounds.maxy);
+        if (layerinfo->current->node) {
+          char pszBuffer[TREE_MAX_DEPTH + 1];
+          clusterTreeNode *node = layerinfo->current->node;
+          int position = node->position;
+          int i = 1;
+          while (position > 0 && i <= TREE_MAX_DEPTH) {
+            pszBuffer[TREE_MAX_DEPTH - i] = '0' + (position % 4);
+            position = position >> 2;
+            ++i;
+          }
+          pszBuffer[TREE_MAX_DEPTH] = 0;
+
+          msDebug(" ->node %p: count=%d index=%d pos=%s subn={%p %p %p %p} "
+                  "rect={%lf %lf %lf %lf}\n",
+                  node, node->numshapes, node->index,
+                  pszBuffer + TREE_MAX_DEPTH - i + 1, node->subnode[0],
+                  node->subnode[1], node->subnode[2], node->subnode[3],
+                  node->rect.minx, node->rect.miny, node->rect.maxx,
+                  node->rect.maxy);
+        }
+      }
+
+#ifdef TESTCOUNT
+      avgx = layerinfo->current->x;
+      avgy = layerinfo->current->y;
+      n = 0;
+#endif
+
+      if (layerinfo->current->numsiblings > 0) {
+        /* update the parameters due to the shape removal */
+        findRelatedShapesRemove(layerinfo, layerinfo->root, layerinfo->current);
+
+        if (layerinfo->current->filter == 0) {
+          /* filtered shapes has no siblings */
+          layerinfo->current->numsiblings = 0;
+          layerinfo->current->avgx = layerinfo->current->x;
+          layerinfo->current->avgy = layerinfo->current->y;
+        }
+
+        /* update the parameters of the related shapes if any */
+        if (layerinfo->finalizedSiblings) {
+          current = layerinfo->finalizedSiblings;
+          while (current) {
+            /* update the parameters due to the shape removal */
+            findRelatedShapesRemove(layerinfo, layerinfo->root, current);
+            UpdateShapeAttributes(layer, layerinfo->current, current);
+#ifdef TESTCOUNT
+            avgx += current->x;
+            avgy += current->y;
+            ++n;
+#endif
+            /* setting the average position to the same value */
+            current->avgx = layerinfo->current->avgx;
+            current->avgy = layerinfo->current->avgy;
+
+            if (current->next == NULL) {
+              if (layerinfo->get_all_shapes == MS_TRUE) {
+                /* insert the siblings into the finalization list */
+                current->next = layerinfo->finalized;
+                layerinfo->finalized = layerinfo->finalizedSiblings;
+              } else {
+                /* preserve the clustered siblings for later use */
+                layerinfo->current->siblings = layerinfo->finalizedSiblings;
+              }
+              break;
+            }
+
+            current = current->next;
+          }
+
+          layerinfo->finalizedSiblings = NULL;
+        }
+      }
+
+#ifdef TESTCOUNT
+      avgx /= (n + 1);
+      avgy /= (n + 1);
+
+      if (layerinfo->current->numsiblings != n)
+        layerinfo->current->numsiblings = n;
+
+      if (fabs(layerinfo->current->avgx - avgx) / avgx > 0.000000001 ||
+          fabs(layerinfo->current->avgy - avgy) / avgy > 0.000000001) {
+        layerinfo->current->avgx = avgx;
+        layerinfo->current->avgy = avgy;
+      }
+#endif
+    }
+  } else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
+    /* assingn stired points to clusters */
+    while (layerinfo->finalizedSiblings) {
+      current = layerinfo->finalizedSiblings;
+      layerinfo->rank =
+          maxDistanceX * maxDistanceX + maxDistanceY * maxDistanceY;
+      layerinfo->current = NULL;
+      findRelatedShapes2(layerinfo, layerinfo->root, current);
+      if (layerinfo->current) {
+        clusterInfo *s = layerinfo->current;
+        /* found a matching cluster */
+        ++s->numsiblings;
+        /* assign to cluster */
+        layerinfo->finalizedSiblings = current->next;
+        current->next = s->siblings;
+        s->siblings = current;
+      } else {
+        /* this appears to be a bug */
+        layerinfo->finalizedSiblings = current->next;
+        current->next = layerinfo->filtered;
+        layerinfo->filtered = current;
+        ++layerinfo->numFiltered;
+      }
+    }
+
+    /* collecting the shapes of the cluster */
+    collectClusterShapes2(layer, layerinfo, layerinfo->root);
+  }
+
+  /* set the pointer to the first shape */
+  layerinfo->current = layerinfo->finalized;
+
+  return MS_SUCCESS;
+}
+
+/* Close the the combined layer */
+int msClusterLayerClose(layerObj *layer) {
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo)
+    return MS_SUCCESS;
+
+  clusterDestroyData(layerinfo);
+
+  msLayerClose(&layerinfo->srcLayer);
+  freeLayer(&layerinfo->srcLayer);
+
+  msFree(layerinfo);
+  layer->layerinfo = NULL;
+
+#ifndef USE_CLUSTER_EXTERNAL
+  /* switch back to the source layer vtable */
+  if (msInitializeVirtualTable(layer) != MS_SUCCESS)
+    return MS_FAILURE;
+#endif
+
+  return MS_SUCCESS;
+}
+
+/* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
+int msClusterLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return (MS_TRUE);
+  else
+    return (MS_FALSE);
+}
+
+/* Free the itemindexes array in a layer. */
+void msClusterLayerFreeItemInfo(layerObj *layer) {
+  msFree(layer->iteminfo);
+  layer->iteminfo = NULL;
+}
+
+/* allocate the iteminfo index array - same order as the item list */
+int msClusterLayerInitItemInfo(layerObj *layer) {
+  int i, numitems;
+  int *itemindexes;
+
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
+
+  if (layer->numitems == 0) {
+    return MS_SUCCESS;
+  }
+
+  if (!layerinfo)
+    return MS_FAILURE;
+
+  /* Cleanup any previous item selection */
+  msClusterLayerFreeItemInfo(layer);
+
+  layer->iteminfo = (int *)msSmallMalloc(sizeof(int) * layer->numitems);
+
+  itemindexes = layer->iteminfo;
+
+  /* check whether we require attributes from the source layers also */
+  numitems = 0;
+  for (i = 0; i < layer->numitems; i++) {
+    if (EQUAL(layer->items[i], MSCLUSTER_FEATURECOUNT))
+      itemindexes[i] = MSCLUSTER_FEATURECOUNTINDEX;
+    else if (EQUAL(layer->items[i], MSCLUSTER_GROUP))
+      itemindexes[i] = MSCLUSTER_GROUPINDEX;
+    else if (EQUAL(layer->items[i], MSCLUSTER_BASEFID))
+      itemindexes[i] = MSCLUSTER_BASEFIDINDEX;
+    else
+      itemindexes[i] = numitems++;
+  }
+
+  msLayerFreeItemInfo(&layerinfo->srcLayer);
+  if (layerinfo->srcLayer.items) {
+    msFreeCharArray(layerinfo->srcLayer.items, layerinfo->srcLayer.numitems);
+    layerinfo->srcLayer.items = NULL;
+    layerinfo->srcLayer.numitems = 0;
+  }
+
+  if (numitems > 0) {
+    /* now allocate and set the layer item parameters  */
+    layerinfo->srcLayer.items =
+        (char **)msSmallMalloc(sizeof(char *) * numitems);
+    layerinfo->srcLayer.numitems = numitems;
+
+    for (i = 0; i < layer->numitems; i++) {
+      if (itemindexes[i] >= 0) {
+        if (EQUALN(layer->items[i], "Min:", 4))
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 4);
+        else if (EQUALN(layer->items[i], "Max:", 4))
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 4);
+        else if (EQUALN(layer->items[i], "Sum:", 4))
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 4);
+        else if (EQUALN(layer->items[i], "Count:", 6))
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 6);
+        else
+          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i]);
+      }
+    }
+
+    if (msLayerInitItemInfo(&layerinfo->srcLayer) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* Execute a query for this layer */
+int msClusterLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  (void)rect;
+  /* rebuild the cluster database */
+  return RebuildClusters(layer, isQuery);
+}
+
+static int prepareShape(layerObj *layer, msClusterLayerInfo *layerinfo,
+                        clusterInfo *current, shapeObj *shape) {
+  (void)layer;
+  if (msCopyShape(&(current->shape), shape) != MS_SUCCESS) {
+    msSetError(
+        MS_SHPERR,
+        "Cannot retrieve inline shape. There some problem with the shape",
+        "msClusterLayerNextShape()");
+    return MS_FAILURE;
+  }
+
+  /* update the positions of the cluster shape */
+  if (layerinfo->keep_locations == MS_FALSE) {
+    shape->line[0].point[0].x = shape->bounds.minx = shape->bounds.maxx =
+        current->avgx;
+    shape->line[0].point[0].y = shape->bounds.miny = shape->bounds.maxy =
+        current->avgy;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* Execute a query on the DB based on fid. */
+int msClusterLayerGetShape(layerObj *layer, shapeObj *shape,
+                           resultObj *record) {
+  clusterInfo *current;
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo) {
+    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerGetShape()",
+               layer->name);
+    return MS_FAILURE;
+  }
+
+  current = layerinfo->finalized;
+  while (current) {
+    if (record->shapeindex == current->shape.index &&
+        record->tileindex == current->shape.tileindex)
+      break;
+    current = current->next;
+  }
+
+  if (current == NULL) {
+    msSetError(MS_SHPERR, "No feature with this index.",
+               "msClusterLayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  return prepareShape(layer, layerinfo, current, shape);
+}
+
+/* find the next shape with the appropriate shape type */
+/* also, load in the attribute data */
+/* MS_DONE => no more data */
+int msClusterLayerNextShape(layerObj *layer, shapeObj *shape) {
+  int rv;
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo) {
+    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerNextShape()",
+               layer->name);
+    return MS_FAILURE;
+  }
+
+  if (!layerinfo->current)
+    return MS_DONE;
+
+  rv = prepareShape(layer, layerinfo, layerinfo->current, shape);
+
+  layerinfo->current = layerinfo->current->next;
+
+  return rv;
+}
+
+/* Query for the items collection */
+int msClusterLayerGetItems(layerObj *layer) {
+  /* we support certain built in attributes */
+  layer->numitems = MSCLUSTER_NUMITEMS;
+  layer->items = msSmallMalloc(sizeof(char *) * (layer->numitems));
+  layer->items[0] = msStrdup(MSCLUSTER_FEATURECOUNT);
+  layer->items[1] = msStrdup(MSCLUSTER_GROUP);
+  layer->items[2] = msStrdup(MSCLUSTER_BASEFID);
+
+  return msClusterLayerInitItemInfo(layer);
+}
+
+int msClusterLayerGetNumFeatures(layerObj *layer) {
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo)
+    return -1;
+
+  return layerinfo->numFinalized;
+}
+
+static int msClusterLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                      shapeObj *shape) {
+  (void)map;
+  (void)layer;
+  (void)c;
+  (void)shape;
+  /* TODO */
+  return MS_SUCCESS;
+}
+
+msClusterLayerInfo *msClusterInitialize(layerObj *layer) {
+  msClusterLayerInfo *layerinfo =
+      (msClusterLayerInfo *)msSmallMalloc(sizeof(msClusterLayerInfo));
+
+  layer->layerinfo = layerinfo;
+
+  layerinfo->searchRect.minx = -1;
+  layerinfo->searchRect.miny = -1;
+  layerinfo->searchRect.maxx = -1;
+  layerinfo->searchRect.maxy = -1;
+
+  layerinfo->root = NULL;
+
+  layerinfo->get_all_shapes = MS_FALSE;
+
+  layerinfo->numFeatures = 0;
+  layerinfo->numNodes = 0;
+
+  layerinfo->finalized = NULL;
+  layerinfo->numFinalized = 0;
+  layerinfo->finalizedSiblings = NULL;
+  layerinfo->numFinalizedSiblings = 0;
+  layerinfo->filtered = NULL;
+  layerinfo->numFiltered = 0;
+
+  layerinfo->finalizedNodes = NULL;
+  layerinfo->numFinalizedNodes = 0;
+
+  return layerinfo;
+}
+
+int msClusterLayerOpen(layerObj *layer) {
+  msClusterLayerInfo *layerinfo;
+
+  if (layer->type != MS_LAYER_POINT) {
+    msSetError(MS_MISCERR, "Only point layers are supported for clustering: %s",
+               "msClusterLayerOpen()", layer->name);
+    return MS_FAILURE;
+  }
+
+  if (!layer->map)
+    return MS_FAILURE;
+
+  if (layer->layerinfo) {
+    if (layer->vtable->LayerOpen != msClusterLayerOpen)
+      msLayerClose(layer);
+    else
+      return MS_SUCCESS; /* already open */
+  }
+
+  layerinfo = msClusterInitialize(layer);
+
+  if (!layer->layerinfo)
+    return MS_FAILURE;
+
+  /* prepare the source layer */
+  if (initLayer(&layerinfo->srcLayer, layer->map) == -1)
+    return MS_FAILURE;
+
+#ifdef USE_CLUSTER_EXTERNAL
+  if (!layer->map)
+    return MS_FAILURE;
+
+  layerIndex = msGetLayerIndex(layer->map, layer->connection);
+
+  if (layerIndex < 0 && layerIndex >= layer->map->numlayers) {
+    msSetError(MS_MISCERR, "No source layers specified in layer: %s",
+               "msClusterLayerOpen()", layer->name);
+    return MS_FAILURE;
+  }
+
+  if (layer->map->layers[layerIndex]->type != MS_LAYER_POINT) {
+    msSetError(MS_MISCERR,
+               "Only point layers are supported for cluster data source: %s",
+               "msClusterLayerOpen()", layer->name);
+    return MS_FAILURE;
+  }
+
+  if (msCopyLayer(&layerinfo->srcLayer, layer->map->layers[layerIndex]) !=
+      MS_SUCCESS)
+    return (MS_FAILURE);
+#else
+  /* hook the vtable to this driver, will be restored in LayerClose*/
+  if (!layer->vtable) {
+    if (msInitializeVirtualTable(layer) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+  assert(layer->vtable);
+  msClusterLayerCopyVirtualTable(layer->vtable);
+
+  if (msCopyLayer(&layerinfo->srcLayer, layer) != MS_SUCCESS)
+    return (MS_FAILURE);
+#endif
+
+  /* disable the connection pool for this layer */
+  msLayerSetProcessingKey(&layerinfo->srcLayer, "CLOSE_CONNECTION", "ALWAYS");
+
+  /* open the source layer */
+  if (!layerinfo->srcLayer.vtable) {
+    if (msInitializeVirtualTable(&layerinfo->srcLayer) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  if (layerinfo->srcLayer.vtable->LayerOpen(&layerinfo->srcLayer) !=
+      MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+int msClusterLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                  char *filteritem) {
+  (void)filter;
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
+
+  if (!layerinfo) {
+    msSetError(MS_MISCERR, "Layer is not open: %s",
+               "msClusterLayerTranslateFilter()", layer->name);
+    return MS_FAILURE;
+  }
+
+  if (layerinfo->srcLayer.filter.type == MS_EXPRESSION &&
+      layerinfo->srcLayer.filter.tokens == NULL)
+    msTokenizeExpression(&(layerinfo->srcLayer.filter), layer->items,
+                         &(layer->numitems));
+
+  return layerinfo->srcLayer.vtable->LayerTranslateFilter(
+      &layerinfo->srcLayer, &layerinfo->srcLayer.filter, filteritem);
+}
+
+char *msClusterLayerEscapeSQLParam(layerObj *layer, const char *pszString) {
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
+
+  if (!layerinfo) {
+    msSetError(MS_MISCERR, "Layer is not open: %s",
+               "msClusterLayerEscapeSQLParam()", layer->name);
+    return msStrdup("");
+  }
+
+  return layerinfo->srcLayer.vtable->LayerEscapeSQLParam(&layerinfo->srcLayer,
+                                                         pszString);
+}
+
+int msClusterLayerGetAutoProjection(layerObj *layer,
+                                    projectionObj *projection) {
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
+
+  if (!layerinfo) {
+    msSetError(MS_MISCERR, "Layer is not open: %s",
+               "msClusterLayerGetAutoProjection()", layer->name);
+    return MS_FAILURE;
+  }
+
+  return layerinfo->srcLayer.vtable->LayerGetAutoProjection(
+      &layerinfo->srcLayer, projection);
+}
+
+int msClusterLayerGetPaging(layerObj *layer) {
+  (void)layer;
+  return MS_FALSE;
+}
+
+void msClusterLayerEnablePaging(layerObj *layer, int value) {
+  (void)layer;
+  (void)value;
+}
+
+void msClusterLayerCopyVirtualTable(layerVTableObj *vtable) {
+  vtable->LayerInitItemInfo = msClusterLayerInitItemInfo;
+  vtable->LayerFreeItemInfo = msClusterLayerFreeItemInfo;
+  vtable->LayerOpen = msClusterLayerOpen;
+  vtable->LayerIsOpen = msClusterLayerIsOpen;
+  vtable->LayerWhichShapes = msClusterLayerWhichShapes;
+  vtable->LayerNextShape = msClusterLayerNextShape;
+  vtable->LayerGetShape = msClusterLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+
+  vtable->LayerClose = msClusterLayerClose;
+
+  vtable->LayerGetItems = msClusterLayerGetItems;
+  vtable->LayerCloseConnection = msClusterLayerClose;
+
+  vtable->LayerGetNumFeatures = msClusterLayerGetNumFeatures;
+  vtable->LayerGetAutoStyle = msClusterLayerGetAutoStyle;
+  vtable->LayerTranslateFilter = msClusterLayerTranslateFilter;
+  /* vtable->LayerSupportsCommonFilters, use driver implementation */
+  vtable->LayerEscapeSQLParam = msClusterLayerEscapeSQLParam;
+  /* vtable->LayerEscapePropertyName, use driver implementation */
+
+  vtable->LayerEnablePaging = msClusterLayerEnablePaging;
+  vtable->LayerGetPaging = msClusterLayerGetPaging;
+  vtable->LayerGetAutoProjection = msClusterLayerGetAutoProjection;
+}
+
+#ifdef USE_CLUSTER_PLUGIN
+
+MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj *vtable,
+                                               layerObj *layer) {
+  assert(layer != NULL);
+  assert(vtable != NULL);
+
+  msClusterLayerCopyVirtualTable(vtable);
+
+  return MS_SUCCESS;
+}
+
+#endif
+
+int msClusterLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  msClusterLayerCopyVirtualTable(layer->vtable);
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapcompositingfilter.c 8.2.0~beta1-1~exp1/src/mapcompositingfilter.c
--- 8.0.1-5/src/mapcompositingfilter.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcompositingfilter.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,234 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  RFC 113 Layer compositing
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2015 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+#include "mapserver.h"
+#include <regex.h>
+#define pixmove(rb, srcx, srcy, dstx, dsty)                                    \
+  memcpy(rb->data.rgba.pixels + dsty * rb->data.rgba.row_step + dstx * 4,      \
+         rb->data.rgba.pixels + srcy * rb->data.rgba.row_step + srcx * 4, 4)
+#define pixerase(rb, x, y)                                                     \
+  memset(rb->data.rgba.pixels + y * rb->data.rgba.row_step + x * 4, 0, 4)
+
+void msApplyTranslationCompositingFilter(rasterBufferObj *rb, int xtrans,
+                                         int ytrans) {
+  int src_sx, src_sy, dst_sx, dst_sy;
+  if ((unsigned)abs(xtrans) >= rb->width ||
+      (unsigned)abs(ytrans) >= rb->height) {
+    for (unsigned y = 0; y < rb->height; y++)
+      for (unsigned x = 0; x < rb->width; x++)
+        pixerase(rb, x, y);
+  }
+  if (xtrans == 0 && ytrans == 0)
+    return;
+  if (xtrans >= 0) {
+    if (ytrans >= 0) {
+      src_sx = rb->width - xtrans - 1;
+      src_sy = rb->height - ytrans - 1;
+      dst_sx = rb->width - 1;
+      dst_sy = rb->height - 1;
+      for (int y = src_sy, dst_y = dst_sy; y >= 0; y--, dst_y--) {
+        for (int x = src_sx, dst_x = dst_sx; x >= 0; x--, dst_x--) {
+          pixmove(rb, x, y, dst_x, dst_y);
+        }
+      }
+      for (int y = 0; y < ytrans; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = ytrans; y < rb->height; y++)
+        for (int x = 0; x < xtrans; x++)
+          pixerase(rb, x, y);
+    } else {
+      src_sx = rb->width - xtrans - 1;
+      src_sy = -ytrans;
+      dst_sx = rb->width - 1;
+      dst_sy = 0;
+      for (unsigned y = src_sy, dst_y = dst_sy; y < rb->height; y++, dst_y++) {
+        for (int x = src_sx, dst_x = dst_sx; x >= 0; x--, dst_x--) {
+          pixmove(rb, x, y, dst_x, dst_y);
+        }
+      }
+      for (unsigned y = 0; y < rb->height + ytrans; y++)
+        for (int x = 0; x < xtrans; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = rb->height + ytrans; y < rb->height; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
+    }
+  } else {
+    if (ytrans >= 0) {
+      src_sx = -xtrans;
+      src_sy = rb->height - ytrans - 1;
+      dst_sx = 0;
+      dst_sy = rb->height - 1;
+      for (int y = src_sy, dst_y = dst_sy; y >= 0; y--, dst_y--) {
+        for (unsigned x = src_sx, dst_x = dst_sx; x < rb->width; x++, dst_x++) {
+          pixmove(rb, x, y, dst_x, dst_y);
+        }
+      }
+      for (int y = 0; y < ytrans; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = ytrans; y < rb->height; y++)
+        for (unsigned x = rb->width + xtrans; x < rb->width; x++)
+          pixerase(rb, x, y);
+    } else {
+      src_sx = -xtrans;
+      src_sy = -ytrans;
+      dst_sx = 0;
+      dst_sy = 0;
+      for (unsigned y = src_sy, dst_y = dst_sy; y < rb->height; y++, dst_y++) {
+        for (unsigned x = src_sx, dst_x = dst_sx; x < rb->width; x++, dst_x++) {
+          pixmove(rb, x, y, dst_x, dst_y);
+        }
+      }
+      for (unsigned y = 0; y < rb->height + ytrans; y++)
+        for (unsigned x = rb->width + xtrans; x < rb->width; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = rb->height + ytrans; y < rb->height; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
+    }
+  }
+}
+
+void msApplyBlackeningCompositingFilter(rasterBufferObj *rb) {
+  unsigned char *r, *g, *b;
+  for (unsigned row = 0; row < rb->height; row++) {
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
+      *r = *g = *b = 0;
+      r += 4;
+      g += 4;
+      b += 4;
+    }
+  }
+}
+
+void msApplyWhiteningCompositingFilter(rasterBufferObj *rb) {
+  unsigned char *r, *g, *b, *a;
+  for (unsigned row = 0; row < rb->height; row++) {
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    a = rb->data.rgba.a + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
+      *r = *g = *b = *a;
+      r += 4;
+      g += 4;
+      b += 4;
+      a += 4;
+    }
+  }
+}
+
+void msApplyGrayscaleCompositingFilter(rasterBufferObj *rb) {
+  unsigned char *r, *g, *b;
+  for (unsigned row = 0; row < rb->height; row++) {
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
+      unsigned int mix = (unsigned int)*r + (unsigned int)*g + (unsigned int)*b;
+      mix /= 3;
+      *r = *g = *b = (unsigned char)mix;
+      r += 4;
+      g += 4;
+      b += 4;
+    }
+  }
+}
+
+int msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb,
+                             CompositingFilter *filter) {
+  int rstatus;
+  regex_t regex;
+  regmatch_t pmatch[3];
+
+  /* test for blurring filter */
+  regcomp(&regex, "blur\\(([0-9]+)\\)", REG_EXTENDED);
+  rstatus = regexec(&regex, filter->filter, 2, pmatch, 0);
+  regfree(&regex);
+  if (!rstatus) {
+    char *rad = malloc(pmatch[1].rm_eo - pmatch[1].rm_so + 1);
+    unsigned int irad;
+    strncpy(rad, filter->filter + pmatch[1].rm_so,
+            pmatch[1].rm_eo - pmatch[1].rm_so);
+    rad[pmatch[1].rm_eo - pmatch[1].rm_so] = 0;
+    // msDebug("got blur filter with radius %s\n",rad);
+    irad = atoi(rad);
+    free(rad);
+    irad = MS_NINT(irad * map->resolution / map->defresolution);
+    msApplyBlurringCompositingFilter(rb, irad);
+    return MS_SUCCESS;
+  }
+
+  /* test for translation filter */
+  regcomp(&regex, "translate\\((-?[0-9]+),(-?[0-9]+)\\)", REG_EXTENDED);
+  rstatus = regexec(&regex, filter->filter, 3, pmatch, 0);
+  regfree(&regex);
+  if (!rstatus) {
+    char *num;
+    int xtrans, ytrans;
+    num = malloc(pmatch[1].rm_eo - pmatch[1].rm_so + 1);
+    strncpy(num, filter->filter + pmatch[1].rm_so,
+            pmatch[1].rm_eo - pmatch[1].rm_so);
+    num[pmatch[1].rm_eo - pmatch[1].rm_so] = 0;
+    xtrans = atoi(num);
+    free(num);
+    num = malloc(pmatch[2].rm_eo - pmatch[2].rm_so + 1);
+    strncpy(num, filter->filter + pmatch[2].rm_so,
+            pmatch[2].rm_eo - pmatch[2].rm_so);
+    num[pmatch[2].rm_eo - pmatch[2].rm_so] = 0;
+    ytrans = atoi(num);
+    free(num);
+    // msDebug("got translation filter of radius %d,%d\n",xtrans,ytrans);
+    xtrans = MS_NINT(xtrans * map->resolution / map->defresolution);
+    ytrans = MS_NINT(ytrans * map->resolution / map->defresolution);
+    msApplyTranslationCompositingFilter(rb, xtrans, ytrans);
+    return MS_SUCCESS;
+  }
+
+  /* test for grayscale filter */
+  if (!strncmp(filter->filter, "grayscale()", strlen("grayscale()"))) {
+    msApplyGrayscaleCompositingFilter(rb);
+    return MS_SUCCESS;
+  }
+  if (!strncmp(filter->filter, "blacken()", strlen("blacken()"))) {
+    msApplyBlackeningCompositingFilter(rb);
+    return MS_SUCCESS;
+  }
+  if (!strncmp(filter->filter, "whiten()", strlen("whiten()"))) {
+    msApplyWhiteningCompositingFilter(rb);
+    return MS_SUCCESS;
+  }
+
+  msSetError(MS_MISCERR, "unknown compositing filter (%s)",
+             "msApplyCompositingFilter()", filter->filter);
+  return MS_FAILURE;
+}
diff -pruN 8.0.1-5/src/mapcontext.c 8.2.0~beta1-1~exp1/src/mapcontext.c
--- 8.0.1-5/src/mapcontext.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcontext.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1951 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC Web Map Context implementation
+ * Author:   Julien-Samuel Lacroix, DM Solutions Group (lacroix@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2002-2003, Julien-Samuel Lacroix, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#include "cpl_vsi.h"
+#include "cpl_conv.h"
+
+#if defined(USE_WMS_LYR)
+
+/* There is a dependency to GDAL/OGR for the GML driver and MiniXML parser */
+#include "cpl_minixml.h"
+
+#endif
+
+/* msGetMapContextFileText()
+**
+** Read a file and return is content
+**
+** Take the filename in argument
+** Return value must be freed by caller
+*/
+static char *msGetMapContextFileText(const char *filename) {
+  char *pszBuffer;
+  VSILFILE *stream;
+  vsi_l_offset nLength;
+
+  /* open file */
+  if (filename != NULL && strlen(filename) > 0) {
+    stream = VSIFOpenL(filename, "rb");
+    if (!stream) {
+      msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
+      return NULL;
+    }
+  } else {
+    msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
+    return NULL;
+  }
+
+  VSIFSeekL(stream, 0, SEEK_END);
+  nLength = VSIFTellL(stream);
+  VSIFSeekL(stream, 0, SEEK_SET);
+  if (nLength > 100 * 1024 * 1024U) {
+    msSetError(MS_MEMERR, "(%s): too big file", "msGetMapContextFileText()",
+               filename);
+    VSIFCloseL(stream);
+    return NULL;
+  }
+
+  pszBuffer = (char *)malloc((size_t)nLength + 1);
+  if (pszBuffer == NULL) {
+    msSetError(MS_MEMERR, "(%s)", "msGetMapContextFileText()", filename);
+    VSIFCloseL(stream);
+    return NULL;
+  }
+
+  if (VSIFReadL(pszBuffer, nLength, 1, stream) == 0) {
+    free(pszBuffer);
+    VSIFCloseL(stream);
+    msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
+    return NULL;
+  }
+  pszBuffer[nLength] = '\0';
+
+  VSIFCloseL(stream);
+
+  return pszBuffer;
+}
+
+#if defined(USE_WMS_LYR)
+
+/*
+**msGetMapContextXMLHashValue()
+**
+**Get the xml value and put it in the hash table
+**
+*/
+int msGetMapContextXMLHashValue(CPLXMLNode *psRoot, const char *pszXMLPath,
+                                hashTableObj *metadata, char *pszMetadata) {
+  char *pszValue;
+
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (metadata != NULL) {
+      msInsertHashTable(metadata, pszMetadata, pszValue);
+    } else {
+      return MS_FAILURE;
+    }
+  } else {
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+**msGetMapContextXMLHashValue()
+**
+**Get the xml value and put it in the hash table
+**
+*/
+int msGetMapContextXMLHashValueDecode(CPLXMLNode *psRoot,
+                                      const char *pszXMLPath,
+                                      hashTableObj *metadata,
+                                      char *pszMetadata) {
+  char *pszValue;
+
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (metadata != NULL) {
+      msDecodeHTMLEntities(pszValue);
+      msInsertHashTable(metadata, pszMetadata, pszValue);
+    } else {
+      return MS_FAILURE;
+    }
+  } else {
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+**msGetMapContextXMLStringValue()
+**
+**Get the xml value and put it in the string field
+**
+*/
+int msGetMapContextXMLStringValue(CPLXMLNode *psRoot, char *pszXMLPath,
+                                  char **pszField) {
+  char *pszValue;
+
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (pszField != NULL) {
+      *pszField = msStrdup(pszValue);
+    } else {
+      return MS_FAILURE;
+    }
+  } else {
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+**msGetMapContextXMLStringValue()
+**
+**Get the xml value and put it in the string field
+**
+*/
+int msGetMapContextXMLStringValueDecode(CPLXMLNode *psRoot, char *pszXMLPath,
+                                        char **pszField) {
+  char *pszValue;
+
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (pszField != NULL) {
+      msDecodeHTMLEntities(pszValue);
+      *pszField = msStrdup(pszValue);
+    } else {
+      return MS_FAILURE;
+    }
+  } else {
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+**msGetMapContextXMLFloatValue()
+**
+**Get the xml value and put it in the string field
+**
+*/
+int msGetMapContextXMLFloatValue(CPLXMLNode *psRoot, char *pszXMLPath,
+                                 double *pszField) {
+  char *pszValue;
+
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (pszField != NULL) {
+      *pszField = atof(pszValue);
+    } else {
+      return MS_FAILURE;
+    }
+  } else {
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** msLoadMapContextURLELements
+**
+** Take a Node and get the width, height, format and href from it.
+** Then put this info in metadatas.
+*/
+int msLoadMapContextURLELements(CPLXMLNode *psRoot, hashTableObj *metadata,
+                                const char *pszMetadataRoot) {
+  char *pszMetadataName;
+
+  if (psRoot == NULL || metadata == NULL || pszMetadataRoot == NULL)
+    return MS_FAILURE;
+
+  pszMetadataName = (char *)malloc(strlen(pszMetadataRoot) + 10);
+
+  sprintf(pszMetadataName, "%s_width", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "width", metadata, pszMetadataName);
+
+  sprintf(pszMetadataName, "%s_height", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "height", metadata, pszMetadataName);
+
+  sprintf(pszMetadataName, "%s_format", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "format", metadata, pszMetadataName);
+
+  sprintf(pszMetadataName, "%s_href", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "OnlineResource.xlink:href", metadata,
+                              pszMetadataName);
+
+  free(pszMetadataName);
+
+  return MS_SUCCESS;
+}
+
+/* msLoadMapContextKeyword
+**
+** Put the keywords from a XML node and put them in a metadata.
+** psRoot should be set to keywordlist
+*/
+int msLoadMapContextListInMetadata(CPLXMLNode *psRoot, hashTableObj *metadata,
+                                   char *pszXMLName, char *pszMetadataName,
+                                   char *pszHashDelimiter) {
+  const char *pszHash, *pszXMLValue;
+  char *pszMetadata;
+
+  if (psRoot == NULL || psRoot->psChild == NULL || metadata == NULL ||
+      pszMetadataName == NULL || pszXMLName == NULL)
+    return MS_FAILURE;
+
+  /* Pass from KeywordList to Keyword level */
+  psRoot = psRoot->psChild;
+
+  /* Loop on all elements and append keywords to the hash table */
+  while (psRoot) {
+    if (psRoot->psChild && strcasecmp(psRoot->pszValue, pszXMLName) == 0) {
+      pszXMLValue = psRoot->psChild->pszValue;
+      pszHash = msLookupHashTable(metadata, pszMetadataName);
+      if (pszHash != NULL) {
+        pszMetadata = (char *)malloc(strlen(pszHash) + strlen(pszXMLValue) + 2);
+        if (pszHashDelimiter == NULL)
+          sprintf(pszMetadata, "%s%s", pszHash, pszXMLValue);
+        else
+          sprintf(pszMetadata, "%s%s%s", pszHash, pszHashDelimiter,
+                  pszXMLValue);
+        msInsertHashTable(metadata, pszMetadataName, pszMetadata);
+        free(pszMetadata);
+      } else
+        msInsertHashTable(metadata, pszMetadataName, pszXMLValue);
+    }
+    psRoot = psRoot->psNext;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* msLoadMapContextContactInfo
+**
+** Put the Contact informations from a XML node and put them in a metadata.
+**
+*/
+int msLoadMapContextContactInfo(CPLXMLNode *psRoot, hashTableObj *metadata) {
+  if (psRoot == NULL || metadata == NULL)
+    return MS_FAILURE;
+
+  /* Contact Person primary */
+  msGetMapContextXMLHashValue(psRoot, "ContactPersonPrimary.ContactPerson",
+                              metadata, "wms_contactperson");
+  msGetMapContextXMLHashValue(psRoot,
+                              "ContactPersonPrimary.ContactOrganization",
+                              metadata, "wms_contactorganization");
+  /* Contact Position */
+  msGetMapContextXMLHashValue(psRoot, "ContactPosition", metadata,
+                              "wms_contactposition");
+  /* Contact Address */
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.AddressType", metadata,
+                              "wms_addresstype");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Address", metadata,
+                              "wms_address");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.City", metadata,
+                              "wms_city");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.StateOrProvince",
+                              metadata, "wms_stateorprovince");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.PostCode", metadata,
+                              "wms_postcode");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Country", metadata,
+                              "wms_country");
+
+  /* Others */
+  msGetMapContextXMLHashValue(psRoot, "ContactVoiceTelephone", metadata,
+                              "wms_contactvoicetelephone");
+  msGetMapContextXMLHashValue(psRoot, "ContactFacsimileTelephone", metadata,
+                              "wms_contactfacsimiletelephone");
+  msGetMapContextXMLHashValue(psRoot, "ContactElectronicMailAddress", metadata,
+                              "wms_contactelectronicmailaddress");
+
+  return MS_SUCCESS;
+}
+
+/*
+** msLoadMapContextLayerFormat
+**
+**
+*/
+int msLoadMapContextLayerFormat(CPLXMLNode *psFormat, layerObj *layer) {
+  const char *pszValue;
+  char *pszValue1;
+  const char *pszHash;
+
+  if (psFormat->psChild != NULL &&
+      strcasecmp(psFormat->pszValue, "Format") == 0) {
+    if (psFormat->psChild->psNext == NULL)
+      pszValue = psFormat->psChild->pszValue;
+    else
+      pszValue = psFormat->psChild->psNext->pszValue;
+  } else
+    pszValue = NULL;
+
+  if (pszValue != NULL && strcasecmp(pszValue, "") != 0) {
+    /* wms_format */
+    pszValue1 = (char *)CPLGetXMLValue(psFormat, "current", NULL);
+    if (pszValue1 != NULL &&
+        (strcasecmp(pszValue1, "1") == 0 || strcasecmp(pszValue1, "true") == 0))
+      msInsertHashTable(&(layer->metadata), "wms_format", pszValue);
+    /* wms_formatlist */
+    pszHash = msLookupHashTable(&(layer->metadata), "wms_formatlist");
+    if (pszHash != NULL) {
+      pszValue1 = (char *)malloc(strlen(pszHash) + strlen(pszValue) + 2);
+      sprintf(pszValue1, "%s,%s", pszHash, pszValue);
+      msInsertHashTable(&(layer->metadata), "wms_formatlist", pszValue1);
+      free(pszValue1);
+    } else
+      msInsertHashTable(&(layer->metadata), "wms_formatlist", pszValue);
+  }
+
+  /* Make sure selected format is supported or select another
+   * supported format.  Note that we can efficiently do this
+   * only for GIF/PNG/JPEG, can't try to handle all GDAL
+   * formats.
+   */
+  pszValue = msLookupHashTable(&(layer->metadata), "wms_format");
+
+  if (pszValue && (
+#if !(defined USE_PNG)
+                      strcasecmp(pszValue, "image/png") == 0 ||
+                      strcasecmp(pszValue, "PNG") == 0 ||
+#endif
+#if !(defined USE_JPEG)
+                      strcasecmp(pszValue, "image/jpeg") == 0 ||
+                      strcasecmp(pszValue, "JPEG") == 0 ||
+#endif
+                      0)) {
+    char **papszList = NULL;
+    int i, numformats = 0;
+
+    pszValue = msLookupHashTable(&(layer->metadata), "wms_formatlist");
+
+    papszList = msStringSplit(pszValue, ',', &numformats);
+    for (i = 0; i < numformats; i++) {
+      if (
+#if (defined USE_PNG)
+          strcasecmp(papszList[i], "image/png") == 0 ||
+          strcasecmp(papszList[i], "PNG") == 0 ||
+#endif
+#if (defined USE_JPEG)
+          strcasecmp(papszList[i], "image/jpeg") == 0 ||
+          strcasecmp(papszList[i], "JPEG") == 0 ||
+#endif
+#ifdef USE_GD_GIF
+          strcasecmp(papszList[i], "image/gif") == 0 ||
+          strcasecmp(papszList[i], "GIF") == 0 ||
+#endif
+          0) {
+        /* Found a match */
+        msInsertHashTable(&(layer->metadata), "wms_format", papszList[i]);
+        break;
+      }
+    }
+    if (papszList)
+      msFreeCharArray(papszList, numformats);
+
+  } /* end if unsupported format */
+
+  return MS_SUCCESS;
+}
+
+int msLoadMapContextLayerStyle(CPLXMLNode *psStyle, layerObj *layer,
+                               int nStyle) {
+  char *pszValue, *pszValue1, *pszValue2;
+  const char *pszHash;
+  char *pszStyle = NULL;
+  char *pszStyleName;
+  CPLXMLNode *psStyleSLDBody;
+
+  pszStyleName = (char *)CPLGetXMLValue(psStyle, "Name", NULL);
+  if (pszStyleName == NULL) {
+    pszStyleName = (char *)malloc(20);
+    sprintf(pszStyleName, "Style{%d}", nStyle);
+  } else
+    pszStyleName = msStrdup(pszStyleName);
+
+  /* wms_style */
+  pszValue = (char *)CPLGetXMLValue(psStyle, "current", NULL);
+  if (pszValue != NULL &&
+      (strcasecmp(pszValue, "1") == 0 || strcasecmp(pszValue, "true") == 0))
+    msInsertHashTable(&(layer->metadata), "wms_style", pszStyleName);
+  /* wms_stylelist */
+  pszHash = msLookupHashTable(&(layer->metadata), "wms_stylelist");
+  if (pszHash != NULL) {
+    pszValue1 = (char *)malloc(strlen(pszHash) + strlen(pszStyleName) + 2);
+    sprintf(pszValue1, "%s,%s", pszHash, pszStyleName);
+    msInsertHashTable(&(layer->metadata), "wms_stylelist", pszValue1);
+    free(pszValue1);
+  } else
+    msInsertHashTable(&(layer->metadata), "wms_stylelist", pszStyleName);
+
+  /* Title */
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 20);
+  sprintf(pszStyle, "wms_style_%s_title", pszStyleName);
+
+  if (msGetMapContextXMLHashValue(psStyle, "Title", &(layer->metadata),
+                                  pszStyle) == MS_FAILURE)
+    msInsertHashTable(&(layer->metadata), pszStyle, layer->name);
+
+  free(pszStyle);
+
+  /* SLD */
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 15);
+  sprintf(pszStyle, "wms_style_%s_sld", pszStyleName);
+
+  msGetMapContextXMLHashValueDecode(psStyle, "SLD.OnlineResource.xlink:href",
+                                    &(layer->metadata), pszStyle);
+  free(pszStyle);
+
+  /* SLDBODY */
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 20);
+  sprintf(pszStyle, "wms_style_%s_sld_body", pszStyleName);
+
+  psStyleSLDBody = CPLGetXMLNode(psStyle, "SLD.StyledLayerDescriptor");
+  /*some clients such as OpenLayers add a name space, which I believe is wrong
+   but added this additional test for compatibility #3115*/
+  if (psStyleSLDBody == NULL)
+    psStyleSLDBody = CPLGetXMLNode(psStyle, "SLD.sld:StyledLayerDescriptor");
+
+  if (psStyleSLDBody != NULL) {
+    pszValue = CPLSerializeXMLTree(psStyleSLDBody);
+    if (pszValue != NULL) {
+      /* Before including SLDBody in the mapfile, we must replace the */
+      /* double quote for single quote. This is to prevent having this: */
+      /* "metadata" "<string attriute="ttt">" */
+      char *c;
+      for (c = pszValue; *c != '\0'; c++)
+        if (*c == '"')
+          *c = '\'';
+      msInsertHashTable(&(layer->metadata), pszStyle, pszValue);
+      msFree(pszValue);
+    }
+  }
+
+  free(pszStyle);
+
+  /* LegendURL */
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 25);
+
+  sprintf(pszStyle, "wms_style_%s_legendurl", pszStyleName);
+  msLoadMapContextURLELements(CPLGetXMLNode(psStyle, "LegendURL"),
+                              &(layer->metadata), pszStyle);
+
+  free(pszStyle);
+
+  free(pszStyleName);
+
+  /*  */
+  /* Add the stylelist to the layer connection */
+  /*  */
+  if (msLookupHashTable(&(layer->metadata), "wms_stylelist") == NULL) {
+    if (layer->connection)
+      pszValue = msStrdup(layer->connection);
+    else
+      pszValue = msStrdup("");
+    pszValue1 = strstr(pszValue, "STYLELIST=");
+    if (pszValue1 != NULL) {
+      pszValue1 += 10;
+      pszValue2 = strchr(pszValue, '&');
+      if (pszValue2 != NULL)
+        pszValue1[pszValue2 - pszValue1] = '\0';
+      msInsertHashTable(&(layer->metadata), "wms_stylelist", pszValue1);
+    }
+    free(pszValue);
+  }
+
+  /*  */
+  /* Add the style to the layer connection */
+  /*  */
+  if (msLookupHashTable(&(layer->metadata), "wms_style") == NULL) {
+    if (layer->connection)
+      pszValue = msStrdup(layer->connection);
+    else
+      pszValue = msStrdup("");
+    pszValue1 = strstr(pszValue, "STYLE=");
+    if (pszValue1 != NULL) {
+      pszValue1 += 6;
+      pszValue2 = strchr(pszValue, '&');
+      if (pszValue2 != NULL)
+        pszValue1[pszValue2 - pszValue1] = '\0';
+      msInsertHashTable(&(layer->metadata), "wms_style", pszValue1);
+    }
+    free(pszValue);
+  }
+
+  return MS_SUCCESS;
+}
+
+int msLoadMapContextLayerDimension(CPLXMLNode *psDimension, layerObj *layer) {
+  char *pszValue;
+  const char *pszHash;
+  char *pszDimension = NULL, *pszDimensionName = NULL;
+
+  pszDimensionName = (char *)CPLGetXMLValue(psDimension, "name", NULL);
+  if (pszDimensionName == NULL) {
+    return MS_FALSE;
+  } else
+    pszDimensionName = msStrdup(pszDimensionName);
+
+  pszDimension = (char *)malloc(strlen(pszDimensionName) + 50);
+
+  /* wms_dimension: This is the current dimension */
+  pszValue = (char *)CPLGetXMLValue(psDimension, "current", NULL);
+  if (pszValue != NULL &&
+      (strcasecmp(pszValue, "1") == 0 || strcasecmp(pszValue, "true") == 0))
+    msInsertHashTable(&(layer->metadata), "wms_dimension", pszDimensionName);
+  /* wms_dimensionlist */
+  pszHash = msLookupHashTable(&(layer->metadata), "wms_dimensionlist");
+  if (pszHash != NULL) {
+    pszValue = (char *)malloc(strlen(pszHash) + strlen(pszDimensionName) + 2);
+    sprintf(pszValue, "%s,%s", pszHash, pszDimensionName);
+    msInsertHashTable(&(layer->metadata), "wms_dimensionlist", pszValue);
+    free(pszValue);
+  } else
+    msInsertHashTable(&(layer->metadata), "wms_dimensionlist",
+                      pszDimensionName);
+
+  /* Units */
+  sprintf(pszDimension, "wms_dimension_%s_units", pszDimensionName);
+  msGetMapContextXMLHashValue(psDimension, "units", &(layer->metadata),
+                              pszDimension);
+
+  /* UnitSymbol */
+  sprintf(pszDimension, "wms_dimension_%s_unitsymbol", pszDimensionName);
+  msGetMapContextXMLHashValue(psDimension, "unitSymbol", &(layer->metadata),
+                              pszDimension);
+
+  /* userValue */
+  sprintf(pszDimension, "wms_dimension_%s_uservalue", pszDimensionName);
+  msGetMapContextXMLHashValue(psDimension, "userValue", &(layer->metadata),
+                              pszDimension);
+  if (strcasecmp(pszDimensionName, "time") == 0)
+    msGetMapContextXMLHashValue(psDimension, "userValue", &(layer->metadata),
+                                "wms_time");
+
+  /* default */
+  sprintf(pszDimension, "wms_dimension_%s_default", pszDimensionName);
+  msGetMapContextXMLHashValue(psDimension, "default", &(layer->metadata),
+                              pszDimension);
+
+  /* multipleValues */
+  sprintf(pszDimension, "wms_dimension_%s_multiplevalues", pszDimensionName);
+  msGetMapContextXMLHashValue(psDimension, "multipleValues", &(layer->metadata),
+                              pszDimension);
+
+  /* nearestValue */
+  sprintf(pszDimension, "wms_dimension_%s_nearestvalue", pszDimensionName);
+  msGetMapContextXMLHashValue(psDimension, "nearestValue", &(layer->metadata),
+                              pszDimension);
+
+  free(pszDimension);
+
+  free(pszDimensionName);
+
+  return MS_SUCCESS;
+}
+
+/*
+** msLoadMapContextGeneral
+**
+** Load the General block of the mapcontext document
+*/
+int msLoadMapContextGeneral(mapObj *map, CPLXMLNode *psGeneral,
+                            CPLXMLNode *psMapContext, int nVersion,
+                            const char *filename) {
+
+  char *pszProj = NULL;
+  char *pszValue, *pszValue1, *pszValue2;
+  int nTmp;
+
+  /* Projection */
+  pszValue = (char *)CPLGetXMLValue(psGeneral, "BoundingBox.SRS", NULL);
+  if (pszValue != NULL && !EQUAL(pszValue, "(null)")) {
+    if (strncasecmp(pszValue, "AUTO:", 5) == 0) {
+      pszProj = msStrdup(pszValue);
+    } else {
+      pszProj = (char *)malloc(sizeof(char) * (strlen(pszValue) + 10));
+      sprintf(pszProj, "init=epsg:%s", pszValue + 5);
+    }
+
+    msFreeProjection(&map->projection);
+    msInitProjection(&map->projection);
+    map->projection.args[map->projection.numargs] = msStrdup(pszProj);
+    map->projection.numargs++;
+    msProcessProjection(&map->projection);
+
+    if ((nTmp = GetMapserverUnitUsingProj(&(map->projection))) == -1) {
+      msSetError(MS_MAPCONTEXTERR, "Unable to set units for projection '%s'",
+                 "msLoadMapContext()", pszProj);
+      free(pszProj);
+      return MS_FAILURE;
+    } else {
+      map->units = nTmp;
+    }
+    free(pszProj);
+  } else {
+    msDebug("Mandatory data General.BoundingBox.SRS missing in %s.", filename);
+  }
+
+  /* Extent */
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.minx",
+                                   &(map->extent.minx)) == MS_FAILURE) {
+    msDebug("Mandatory data General.BoundingBox.minx missing in %s.", filename);
+  }
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.miny",
+                                   &(map->extent.miny)) == MS_FAILURE) {
+    msDebug("Mandatory data General.BoundingBox.miny missing in %s.", filename);
+  }
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxx",
+                                   &(map->extent.maxx)) == MS_FAILURE) {
+    msDebug("Mandatory data General.BoundingBox.maxx missing in %s.", filename);
+  }
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxy",
+                                   &(map->extent.maxy)) == MS_FAILURE) {
+    msDebug("Mandatory data General.BoundingBox.maxy missing in %s.", filename);
+  }
+
+  /* Title */
+  if (msGetMapContextXMLHashValue(psGeneral, "Title", &(map->web.metadata),
+                                  "wms_title") == MS_FAILURE) {
+    if (nVersion >= OWS_1_0_0)
+      msDebug("Mandatory data General.Title missing in %s.", filename);
+    else {
+      if (msGetMapContextXMLHashValue(psGeneral, "gml:name",
+                                      &(map->web.metadata),
+                                      "wms_title") == MS_FAILURE) {
+        if (nVersion < OWS_0_1_7)
+          msDebug("Mandatory data General.Title missing in %s.", filename);
+        else
+          msDebug("Mandatory data General.gml:name missing in %s.", filename);
+      }
+    }
+  }
+
+  /* Name */
+  if (nVersion >= OWS_1_0_0) {
+    pszValue = (char *)CPLGetXMLValue(psMapContext, "id", NULL);
+    if (pszValue) {
+      msFree(map->name);
+      map->name = msStrdup(pszValue);
+    }
+  } else {
+    char *pszMapName = NULL;
+    if (msGetMapContextXMLStringValue(psGeneral, "Name", &pszMapName) ==
+        MS_FAILURE) {
+      msGetMapContextXMLStringValue(psGeneral, "gml:name", &pszMapName);
+    }
+    if (pszMapName) {
+      msFree(map->name);
+      map->name = pszMapName;
+    }
+  }
+  /* Keyword */
+  if (nVersion >= OWS_1_0_0) {
+    msLoadMapContextListInMetadata(CPLGetXMLNode(psGeneral, "KeywordList"),
+                                   &(map->web.metadata), "KEYWORD",
+                                   "wms_keywordlist", ",");
+  } else
+    msGetMapContextXMLHashValue(psGeneral, "Keywords", &(map->web.metadata),
+                                "wms_keywordlist");
+
+  /* Window */
+  pszValue1 = (char *)CPLGetXMLValue(psGeneral, "Window.width", NULL);
+  pszValue2 = (char *)CPLGetXMLValue(psGeneral, "Window.height", NULL);
+  if (pszValue1 != NULL && pszValue2 != NULL) {
+    map->width = atoi(pszValue1);
+    map->height = atoi(pszValue2);
+  }
+
+  /* Abstract */
+  if (msGetMapContextXMLHashValue(psGeneral, "Abstract", &(map->web.metadata),
+                                  "wms_abstract") == MS_FAILURE) {
+    msGetMapContextXMLHashValue(psGeneral, "gml:description",
+                                &(map->web.metadata), "wms_abstract");
+  }
+
+  /* DataURL */
+  msGetMapContextXMLHashValueDecode(psGeneral,
+                                    "DataURL.OnlineResource.xlink:href",
+                                    &(map->web.metadata), "wms_dataurl");
+
+  /* LogoURL */
+  /* The logourl have a width, height, format and an URL */
+  msLoadMapContextURLELements(CPLGetXMLNode(psGeneral, "LogoURL"),
+                              &(map->web.metadata), "wms_logourl");
+
+  /* DescriptionURL */
+  /* The descriptionurl have a width, height, format and an URL */
+  msLoadMapContextURLELements(CPLGetXMLNode(psGeneral, "DescriptionURL"),
+                              &(map->web.metadata), "wms_descriptionurl");
+
+  /* Contact Info */
+  msLoadMapContextContactInfo(CPLGetXMLNode(psGeneral, "ContactInformation"),
+                              &(map->web.metadata));
+
+  return MS_SUCCESS;
+}
+
+/*
+** msLoadMapContextLayer
+**
+** Load a Layer block from a MapContext document
+*/
+int msLoadMapContextLayer(mapObj *map, CPLXMLNode *psLayer, int nVersion,
+                          const char *filename, int unique_layer_names) {
+  char *pszValue;
+  const char *pszHash;
+  char *pszName = NULL;
+  CPLXMLNode *psFormatList, *psFormat, *psStyleList, *psStyle, *psExtension;
+  CPLXMLNode *psDimensionList, *psDimension;
+  int nStyle;
+  layerObj *layer;
+
+  /* Init new layer */
+  if (msGrowMapLayers(map) == NULL)
+    return MS_FAILURE;
+
+  layer = (GET_LAYER(map, map->numlayers));
+  initLayer(layer, map);
+  layer->map = (mapObj *)map;
+  layer->type = MS_LAYER_RASTER;
+  /* save the index */
+  GET_LAYER(map, map->numlayers)->index = map->numlayers;
+  map->layerorder[map->numlayers] = map->numlayers;
+  map->numlayers++;
+
+  /* Status */
+  pszValue = (char *)CPLGetXMLValue(psLayer, "hidden", "1");
+  if ((pszValue != NULL) &&
+      (atoi(pszValue) == 0 && strcasecmp(pszValue, "true") != 0))
+    layer->status = MS_ON;
+  else
+    layer->status = MS_OFF;
+
+  /* Queryable */
+  pszValue = (char *)CPLGetXMLValue(psLayer, "queryable", "0");
+  if (pszValue != NULL &&
+      (atoi(pszValue) == 1 || strcasecmp(pszValue, "true") == 0))
+    layer->template = msStrdup("ttt");
+
+  /* Name and Title */
+  pszValue = (char *)CPLGetXMLValue(psLayer, "Name", NULL);
+  if (pszValue != NULL) {
+    msInsertHashTable(&(layer->metadata), "wms_name", pszValue);
+
+    if (unique_layer_names) {
+      pszName = (char *)malloc(sizeof(char) * (strlen(pszValue) + 15));
+      sprintf(pszName, "l%d:%s", layer->index, pszValue);
+      layer->name = msStrdup(pszName);
+      free(pszName);
+    } else
+      layer->name = msStrdup(pszValue);
+  } else {
+    pszName = (char *)malloc(sizeof(char) * 15);
+    sprintf(pszName, "l%d:", layer->index);
+    layer->name = msStrdup(pszName);
+    free(pszName);
+  }
+
+  if (msGetMapContextXMLHashValue(psLayer, "Title", &(layer->metadata),
+                                  "wms_title") == MS_FAILURE) {
+    if (msGetMapContextXMLHashValue(psLayer, "Server.title", &(layer->metadata),
+                                    "wms_title") == MS_FAILURE) {
+      msDebug("Mandatory data Layer.Title missing in %s.", filename);
+    }
+  }
+
+  /* Server Title */
+  msGetMapContextXMLHashValue(psLayer, "Server.title", &(layer->metadata),
+                              "wms_server_title");
+
+  /* Abstract */
+  msGetMapContextXMLHashValue(psLayer, "Abstract", &(layer->metadata),
+                              "wms_abstract");
+
+  /* DataURL */
+  if (nVersion <= OWS_0_1_4) {
+    msGetMapContextXMLHashValueDecode(psLayer,
+                                      "DataURL.OnlineResource.xlink:href",
+                                      &(layer->metadata), "wms_dataurl");
+  } else {
+    /* The DataURL have a width, height, format and an URL */
+    /* Width and height are not used, but they are included to */
+    /* be consistent with the spec. */
+    msLoadMapContextURLELements(CPLGetXMLNode(psLayer, "DataURL"),
+                                &(layer->metadata), "wms_dataurl");
+  }
+
+  /* The MetadataURL have a width, height, format and an URL */
+  /* Width and height are not used, but they are included to */
+  /* be consistent with the spec. */
+  msLoadMapContextURLELements(CPLGetXMLNode(psLayer, "MetadataURL"),
+                              &(layer->metadata), "wms_metadataurl");
+
+  /* MinScale && MaxScale */
+  pszValue = (char *)CPLGetXMLValue(psLayer, "sld:MinScaleDenominator", NULL);
+  if (pszValue != NULL) {
+    layer->minscaledenom = atof(pszValue);
+  }
+
+  pszValue = (char *)CPLGetXMLValue(psLayer, "sld:MaxScaleDenominator", NULL);
+  if (pszValue != NULL) {
+    layer->maxscaledenom = atof(pszValue);
+  }
+
+  /*  */
+  /* Server */
+  /*  */
+  if (nVersion >= OWS_0_1_4) {
+    if (msGetMapContextXMLStringValueDecode(
+            psLayer, "Server.OnlineResource.xlink:href",
+            &(layer->connection)) == MS_FAILURE) {
+      msSetError(
+          MS_MAPCONTEXTERR,
+          "Mandatory data Server.OnlineResource.xlink:href missing in %s.",
+          "msLoadMapContext()", filename);
+      return MS_FAILURE;
+    } else {
+      msGetMapContextXMLHashValueDecode(
+          psLayer, "Server.OnlineResource.xlink:href", &(layer->metadata),
+          "wms_onlineresource");
+      layer->connectiontype = MS_WMS;
+    }
+  } else {
+    if (msGetMapContextXMLStringValueDecode(psLayer, "Server.onlineResource",
+                                            &(layer->connection)) ==
+        MS_FAILURE) {
+      msSetError(MS_MAPCONTEXTERR,
+                 "Mandatory data Server.onlineResource missing in %s.",
+                 "msLoadMapContext()", filename);
+      return MS_FAILURE;
+    } else {
+      msGetMapContextXMLHashValueDecode(psLayer, "Server.onlineResource",
+                                        &(layer->metadata),
+                                        "wms_onlineresource");
+      layer->connectiontype = MS_WMS;
+    }
+  }
+
+  if (nVersion >= OWS_0_1_4) {
+    if (msGetMapContextXMLHashValue(psLayer, "Server.version",
+                                    &(layer->metadata),
+                                    "wms_server_version") == MS_FAILURE) {
+      msSetError(MS_MAPCONTEXTERR,
+                 "Mandatory data Server.version missing in %s.",
+                 "msLoadMapContext()", filename);
+      return MS_FAILURE;
+    }
+  } else {
+    if (msGetMapContextXMLHashValue(psLayer, "Server.wmtver",
+                                    &(layer->metadata),
+                                    "wms_server_version") == MS_FAILURE) {
+      msSetError(MS_MAPCONTEXTERR,
+                 "Mandatory data Server.wmtver missing in %s.",
+                 "msLoadMapContext()", filename);
+      return MS_FAILURE;
+    }
+  }
+
+  /* Projection */
+  msLoadMapContextListInMetadata(psLayer, &(layer->metadata), "SRS", "wms_srs",
+                                 " ");
+
+  pszHash = msLookupHashTable(&(layer->metadata), "wms_srs");
+  if (((pszHash == NULL) || (strcasecmp(pszHash, "") == 0)) &&
+      map->projection.numargs != 0) {
+    const char *pszLastProjArg =
+        map->projection.args[map->projection.numargs - 1];
+
+    if (pszLastProjArg != NULL) {
+      if (strncasecmp(pszLastProjArg, "AUTO:", 5) == 0) {
+        msInsertHashTable(&(layer->metadata), "wms_srs", pszLastProjArg);
+      } else {
+        if (strncasecmp(pszLastProjArg, "+init=epsg:", strlen("+init=epsg:")) ==
+            0) {
+          const size_t nSRSSize =
+              strlen("EPSG:") + strlen(pszLastProjArg + strlen("+init=epsg:")) +
+              1;
+          char *pszSRS = (char *)malloc(nSRSSize);
+          snprintf(pszSRS, nSRSSize, "EPSG:%s",
+                   pszLastProjArg + strlen("+init=epsg:"));
+          msInsertHashTable(&(layer->metadata), "wms_srs", pszSRS);
+          msFree(pszSRS);
+        } else {
+          msDebug("Unable to set data for layer wms_srs from this"
+                  " value %s.",
+                  pszLastProjArg);
+        }
+      }
+    }
+  }
+
+  /*  */
+  /* Format */
+  /*  */
+  if (nVersion >= OWS_0_1_4) {
+    psFormatList = CPLGetXMLNode(psLayer, "FormatList");
+  } else {
+    psFormatList = psLayer;
+  }
+
+  if (psFormatList != NULL) {
+    for (psFormat = psFormatList->psChild; psFormat != NULL;
+         psFormat = psFormat->psNext) {
+      msLoadMapContextLayerFormat(psFormat, layer);
+    }
+
+  } /* end FormatList parsing */
+
+  /* Style */
+  if (nVersion >= OWS_0_1_4) {
+    psStyleList = CPLGetXMLNode(psLayer, "StyleList");
+  } else {
+    psStyleList = psLayer;
+  }
+
+  if (psStyleList != NULL) {
+    nStyle = 0;
+    for (psStyle = psStyleList->psChild; psStyle != NULL;
+         psStyle = psStyle->psNext) {
+      if (strcasecmp(psStyle->pszValue, "Style") == 0) {
+        nStyle++;
+        msLoadMapContextLayerStyle(psStyle, layer, nStyle);
+      }
+    }
+  }
+
+  /* Dimension */
+  psDimensionList = CPLGetXMLNode(psLayer, "DimensionList");
+  if (psDimensionList != NULL) {
+    for (psDimension = psDimensionList->psChild; psDimension != NULL;
+         psDimension = psDimension->psNext) {
+      if (strcasecmp(psDimension->pszValue, "Dimension") == 0) {
+        msLoadMapContextLayerDimension(psDimension, layer);
+      }
+    }
+  }
+
+  /* Extension */
+  psExtension = CPLGetXMLNode(psLayer, "Extension");
+  if (psExtension != NULL) {
+    pszValue = (char *)CPLGetXMLValue(psExtension, "ol:opacity", NULL);
+    if (pszValue != NULL) {
+      if (!layer->compositer) {
+        layer->compositer = msSmallMalloc(sizeof(LayerCompositer));
+        initLayerCompositer(layer->compositer);
+      }
+      layer->compositer->opacity = atof(pszValue) * 100;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+#endif
+
+/* msLoadMapContextURL()
+**
+** load an OGC Web Map Context format from an URL
+**
+** Take a map object and a URL to a conect file in arguments
+*/
+
+int msLoadMapContextURL(mapObj *map, char *urlfilename,
+                        int unique_layer_names) {
+#if defined(USE_WMS_LYR)
+  char *pszTmpFile = NULL;
+  int status = 0;
+
+  if (!map || !urlfilename) {
+    msSetError(MS_MAPCONTEXTERR, "Invalid map or url given.",
+               "msGetMapContextURL()");
+    return MS_FAILURE;
+  }
+
+  pszTmpFile = msTmpFile(map, map->mappath, NULL, "context.xml");
+  if (msHTTPGetFile(urlfilename, pszTmpFile, &status, -1, 0, 0, 0) ==
+      MS_SUCCESS) {
+    return msLoadMapContext(map, pszTmpFile, unique_layer_names);
+  } else {
+    msSetError(MS_MAPCONTEXTERR, "Could not open context file %s.",
+               "msGetMapContextURL()", urlfilename);
+    return MS_FAILURE;
+  }
+
+#else
+  msSetError(MS_MAPCONTEXTERR,
+             "Not implemented since Map Context is not enabled.",
+             "msGetMapContextURL()");
+  return MS_FAILURE;
+#endif
+}
+/* msLoadMapContext()
+**
+** Get a mapfile from a OGC Web Map Context format
+**
+** Take as first map object and a file in arguments
+** If The 2nd aregument unique_layer_names is set to MS_TRUE, the layer
+** name created would be unique and be prefixed with an l plus the layers's
+*index
+** (eg l:1:park. l:2:road ...). If It is set to MS_FALSE, the layer name
+** would be the same name as the layer name in the context
+*/
+int msLoadMapContext(mapObj *map, const char *filename,
+                     int unique_layer_names) {
+#if defined(USE_WMS_LYR)
+  char *pszWholeText, *pszValue;
+  CPLXMLNode *psRoot, *psMapContext, *psLayer, *psLayerList, *psChild;
+  char szPath[MS_MAXPATHLEN];
+  int nVersion = -1;
+  char szVersionBuf[OWS_VERSION_MAXLEN];
+
+  const char *ms_contextfile_pattern = CPLGetConfigOption(
+      "MS_CONTEXTFILE_PATTERN", MS_DEFAULT_CONTEXTFILE_PATTERN);
+  if (msEvalRegex(ms_contextfile_pattern, filename) != MS_TRUE) {
+    msSetError(MS_REGEXERR, "Filename validation failed.",
+               "msLoadMapContext()");
+    return MS_FAILURE;
+  }
+
+  /*  */
+  /* Load the raw XML file */
+  /*  */
+
+  pszWholeText =
+      msGetMapContextFileText(msBuildPath(szPath, map->mappath, filename));
+  if (pszWholeText == NULL) {
+    msSetError(MS_MAPCONTEXTERR, "Unable to read %s", "msLoadMapContext()",
+               filename);
+    return MS_FAILURE;
+  }
+
+  if ((strstr(pszWholeText, "<WMS_Viewer_Context") == NULL) &&
+      (strstr(pszWholeText, "<View_Context") == NULL) &&
+      (strstr(pszWholeText, "<ViewContext") == NULL))
+
+  {
+    free(pszWholeText);
+    msSetError(MS_MAPCONTEXTERR, "Not a Map Context file (%s)",
+               "msLoadMapContext()", filename);
+    return MS_FAILURE;
+  }
+
+  /*  */
+  /* Convert to XML parse tree. */
+  /*  */
+  psRoot = CPLParseXMLString(pszWholeText);
+  free(pszWholeText);
+
+  /* We assume parser will report errors via CPL. */
+  if (psRoot == NULL) {
+    msSetError(MS_MAPCONTEXTERR, "Invalid XML file (%s)", "msLoadMapContext()",
+               filename);
+    return MS_FAILURE;
+  }
+
+  /*  */
+  /* Valid the MapContext file and get the root of the document */
+  /*  */
+  psChild = psRoot;
+  psMapContext = NULL;
+  while (psChild != NULL) {
+    if (psChild->eType == CXT_Element &&
+        (EQUAL(psChild->pszValue, "WMS_Viewer_Context") ||
+         EQUAL(psChild->pszValue, "View_Context") ||
+         EQUAL(psChild->pszValue, "ViewContext"))) {
+      psMapContext = psChild;
+      break;
+    } else {
+      psChild = psChild->psNext;
+    }
+  }
+
+  if (psMapContext == NULL) {
+    CPLDestroyXMLNode(psRoot);
+    msSetError(MS_MAPCONTEXTERR, "Invalid Map Context File (%s)",
+               "msLoadMapContext()", filename);
+    return MS_FAILURE;
+  }
+
+  /* Fetch document version number */
+  pszValue = (char *)CPLGetXMLValue(psMapContext, "version", NULL);
+  if (!pszValue) {
+    msDebug("msLoadMapContext(): Mandatory data version missing in %s, "
+            "assuming 0.1.4.",
+            filename);
+    pszValue = "0.1.4";
+  }
+
+  nVersion = msOWSParseVersionString(pszValue);
+
+  /* Make sure this is a supported version */
+  switch (nVersion) {
+  case OWS_0_1_2:
+  case OWS_0_1_4:
+  case OWS_0_1_7:
+  case OWS_1_0_0:
+  case OWS_1_1_0:
+    /* All is good, this is a supported version. */
+    break;
+  default:
+    /* Not a supported version */
+    msSetError(MS_MAPCONTEXTERR,
+               "This version of Map Context is not supported (%s).",
+               "msLoadMapContext()", pszValue);
+    CPLDestroyXMLNode(psRoot);
+    return MS_FAILURE;
+  }
+
+  /* Reformat and save Version in metadata */
+  msInsertHashTable(&(map->web.metadata), "wms_context_version",
+                    msOWSGetVersionString(nVersion, szVersionBuf));
+
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    if (msGetMapContextXMLHashValue(psMapContext, "fid", &(map->web.metadata),
+                                    "wms_context_fid") == MS_FAILURE) {
+      msDebug("Mandatory data fid missing in %s.", filename);
+    }
+  }
+
+  /*  */
+  /* Load the General bloc */
+  /*  */
+  psChild = CPLGetXMLNode(psMapContext, "General");
+  if (psChild == NULL) {
+    CPLDestroyXMLNode(psRoot);
+    msSetError(MS_MAPCONTEXTERR,
+               "The Map Context document provided (%s) does not contain any "
+               "General elements.",
+               "msLoadMapContext()", filename);
+    return MS_FAILURE;
+  }
+
+  if (msLoadMapContextGeneral(map, psChild, psMapContext, nVersion, filename) ==
+      MS_FAILURE) {
+    CPLDestroyXMLNode(psRoot);
+    return MS_FAILURE;
+  }
+
+  /*  */
+  /* Load the bloc LayerList */
+  /*  */
+  psLayerList = CPLGetXMLNode(psMapContext, "LayerList");
+  if (psLayerList != NULL) {
+    for (psLayer = psLayerList->psChild; psLayer != NULL;
+         psLayer = psLayer->psNext) {
+      if (EQUAL(psLayer->pszValue, "Layer")) {
+        if (msLoadMapContextLayer(map, psLayer, nVersion, filename,
+                                  unique_layer_names) == MS_FAILURE) {
+          CPLDestroyXMLNode(psRoot);
+          return MS_FAILURE;
+        }
+      } /* end Layer parsing */
+    }   /* for */
+  }
+
+  CPLDestroyXMLNode(psRoot);
+
+  return MS_SUCCESS;
+
+#else
+  msSetError(MS_MAPCONTEXTERR,
+             "Not implemented since Map Context is not enabled.",
+             "msGetMapContext()");
+  return MS_FAILURE;
+#endif
+}
+
+/* msSaveMapContext()
+**
+** Save a mapfile into the OGC Web Map Context format
+**
+** Take a map object and a file in arguments
+*/
+int msSaveMapContext(mapObj *map, char *filename) {
+#if defined(USE_WMS_LYR)
+  FILE *stream;
+  char szPath[MS_MAXPATHLEN];
+  int nStatus;
+
+  /* open file */
+  if (filename != NULL && strlen(filename) > 0) {
+    stream = fopen(msBuildPath(szPath, map->mappath, filename), "wb");
+    if (!stream) {
+      msSetError(MS_IOERR, "(%s)", "msSaveMapContext()", filename);
+      return (MS_FAILURE);
+    }
+  } else {
+    msSetError(MS_IOERR, "Filename is undefined.", "msSaveMapContext()");
+    return MS_FAILURE;
+  }
+
+  nStatus = msWriteMapContext(map, stream);
+
+  fclose(stream);
+
+  return nStatus;
+#else
+  msSetError(MS_MAPCONTEXTERR,
+             "Not implemented since Map Context is not enabled.",
+             "msSaveMapContext()");
+  return MS_FAILURE;
+#endif
+}
+
+int msWriteMapContext(mapObj *map, FILE *stream) {
+#if defined(USE_WMS_LYR)
+  const char *version;
+  char *pszEPSG;
+  char *tabspace = NULL, *pszChar, *pszSLD = NULL, *pszSLD2 = NULL;
+  char *pszStyleItem, *pszSLDBody;
+  char *pszEncodedVal;
+  int i, nValue, nVersion = OWS_VERSION_NOTSET;
+  /* Dimension element */
+  char *pszDimension;
+  const char *pszDimUserValue = NULL, *pszDimUnits = NULL,
+             *pszDimDefault = NULL;
+  const char *pszDimNearValue = NULL, *pszDimUnitSymbol = NULL;
+  const char *pszDimMultiValue = NULL;
+  int bDimensionList = 0;
+
+  /* Decide which version we're going to return... */
+  version = msLookupHashTable(&(map->web.metadata), "wms_context_version");
+  if (version == NULL)
+    version = "1.1.0";
+
+  nVersion = msOWSParseVersionString(version);
+  if (nVersion == OWS_VERSION_BADFORMAT)
+    return MS_FAILURE; /* msSetError() already called. */
+
+  /* Make sure this is a supported version */
+  /* Note that we don't write 0.1.2 even if we read it. */
+  switch (nVersion) {
+  case OWS_0_1_4:
+  case OWS_0_1_7:
+  case OWS_1_0_0:
+  case OWS_1_1_0:
+    /* All is good, this is a supported version. */
+    break;
+  default:
+    /* Not a supported version */
+    msSetError(MS_MAPCONTEXTERR,
+               "This version of Map Context is not supported (%s).",
+               "msSaveMapContext()", version);
+    return MS_FAILURE;
+  }
+
+  /* file header */
+  msIO_fprintf(stream,
+               "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+
+  /* set the WMS_Viewer_Context information */
+  pszEncodedVal = msEncodeHTMLEntities(version);
+  if (nVersion >= OWS_1_0_0) {
+    msIO_fprintf(stream, "<ViewContext version=\"%s\"", pszEncodedVal);
+  } else if (nVersion >= OWS_0_1_7) {
+    msIO_fprintf(stream, "<View_Context version=\"%s\"", pszEncodedVal);
+
+  } else { /* 0.1.4 */
+    msIO_fprintf(stream, "<WMS_Viewer_Context version=\"%s\"", pszEncodedVal);
+  }
+  msFree(pszEncodedVal);
+
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), NULL,
+                             "wms_context_fid", OWS_NOERR, " fid=\"%s\"", "0");
+  }
+  if (nVersion >= OWS_1_0_0)
+    msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
+                          " id=\"%s\"", NULL);
+
+  msIO_fprintf(stream,
+               " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
+  msIO_fprintf(stream, " xmlns:ogc=\"http://www.opengis.net/ogc\"");
+
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    msIO_fprintf(stream, " xmlns:gml=\"http://www.opengis.net/gml\"");
+  }
+  if (nVersion >= OWS_1_0_0) {
+    msIO_fprintf(stream, " xmlns:xlink=\"http://www.w3.org/1999/xlink\"");
+    msIO_fprintf(stream, " xmlns=\"http://www.opengis.net/context\"");
+    msIO_fprintf(stream, " xmlns:sld=\"http://www.opengis.net/sld\"");
+    pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    if (nVersion >= OWS_1_1_0)
+      msIO_fprintf(stream,
+                   " xsi:schemaLocation=\"http://www.opengis.net/context "
+                   "%s/context/1.1.0/context.xsd\">\n",
+                   pszEncodedVal);
+    else
+      msIO_fprintf(stream,
+                   " xsi:schemaLocation=\"http://www.opengis.net/context "
+                   "%s/context/1.0.0/context.xsd\">\n",
+                   pszEncodedVal);
+    msFree(pszEncodedVal);
+  } else {
+    msIO_fprintf(stream, " xmlns:xlink=\"http://www.w3.org/TR/xlink\"");
+
+    pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    msIO_fprintf(stream, " xsi:noNamespaceSchemaLocation=\"%s/contexts/",
+                 pszEncodedVal);
+    msFree(pszEncodedVal);
+    pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    msIO_fprintf(stream, "%s/context.xsd\">\n", pszEncodedVal);
+    msFree(pszEncodedVal);
+  }
+
+  /* set the General information */
+  msIO_fprintf(stream, "  <General>\n");
+
+  /* Window */
+  if (map->width != -1 || map->height != -1)
+    msIO_fprintf(stream, "    <Window width=\"%d\" height=\"%d\"/>\n",
+                 map->width, map->height);
+
+  /* Bounding box corners and spatial reference system */
+  if (tabspace)
+    free(tabspace);
+  tabspace = msStrdup("    ");
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_TRUE,
+                   &pszEPSG);
+  msIO_fprintf(stream,
+               "%s<!-- Bounding box corners and spatial reference system -->\n",
+               tabspace);
+  if (!pszEPSG || (strcasecmp(pszEPSG, "(null)") == 0))
+    msIO_fprintf(stream, "<!-- WARNING: Mandatory data 'projection' was "
+                         "missing in this context. -->\n");
+
+  pszEncodedVal = msEncodeHTMLEntities(pszEPSG);
+  msIO_fprintf(stream,
+               "%s<BoundingBox SRS=\"%s\" minx=\"%f\" miny=\"%f\" maxx=\"%f\" "
+               "maxy=\"%f\"/>\n",
+               tabspace, pszEncodedVal, map->extent.minx, map->extent.miny,
+               map->extent.maxx, map->extent.maxy);
+  msFree(pszEncodedVal);
+  msFree(pszEPSG);
+
+  /* Title, name */
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
+                          "    <gml:name>%s</gml:name>\n", NULL);
+  } else {
+    if (nVersion < OWS_0_1_7)
+      msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
+                            "    <Name>%s</Name>\n", NULL);
+
+    msIO_fprintf(stream, "%s<!-- Title of Context -->\n", tabspace);
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), NULL, "wms_title",
+                             OWS_WARN, "    <Title>%s</Title>\n", map->name);
+  }
+
+  /* keyword */
+  if (nVersion >= OWS_1_0_0) {
+    if (msLookupHashTable(&(map->web.metadata), "wms_keywordlist") != NULL) {
+      char **papszKeywords;
+      int nKeywords, iKey;
+
+      const char *pszValue =
+          msLookupHashTable(&(map->web.metadata), "wms_keywordlist");
+      papszKeywords = msStringSplit(pszValue, ',', &nKeywords);
+      if (nKeywords > 0 && papszKeywords) {
+        msIO_fprintf(stream, "    <KeywordList>\n");
+        for (iKey = 0; iKey < nKeywords; iKey++) {
+          pszEncodedVal = msEncodeHTMLEntities(papszKeywords[iKey]);
+          msIO_fprintf(stream, "      <Keyword>%s</Keyword>\n", pszEncodedVal);
+          msFree(pszEncodedVal);
+        }
+        msIO_fprintf(stream, "    </KeywordList>\n");
+      }
+    }
+  } else
+    msOWSPrintEncodeMetadataList(stream, &(map->web.metadata), NULL,
+                                 "wms_keywordlist", "    <Keywords>\n",
+                                 "    </Keywords>\n", "      %s\n", NULL);
+
+  /* abstract */
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), NULL, "wms_abstract", OWS_NOERR,
+        "    <gml:description>%s</gml:description>\n", NULL);
+  } else {
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), NULL, "wms_abstract",
+                             OWS_NOERR, "    <Abstract>%s</Abstract>\n", NULL);
+  }
+
+  /* LogoURL */
+  /* The LogoURL have a width, height, format and an URL */
+  msOWSPrintURLType(
+      stream, &(map->web.metadata), "MO", "logourl", OWS_NOERR, NULL, "LogoURL",
+      NULL, " width=\"%s\"", " height=\"%s\"", " format=\"%s\"",
+      "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL, NULL, NULL, NULL,
+      NULL, "    ");
+
+  /* DataURL */
+  msOWSPrintEncodeMetadata(
+      stream, &(map->web.metadata), NULL, "wms_dataurl", OWS_NOERR,
+      "    <DataURL>\n      <OnlineResource xlink:type=\"simple\" "
+      "xlink:href=\"%s\"/>\n    </DataURL>\n",
+      NULL);
+
+  /* DescriptionURL */
+  /* The DescriptionURL have a width, height, format and an URL */
+  /* The metadata is structured like this: "width height format url" */
+  msOWSPrintURLType(
+      stream, &(map->web.metadata), "MO", "descriptionurl", OWS_NOERR, NULL,
+      "DescriptionURL", NULL, " width=\"%s\"", " height=\"%s\"",
+      " format=\"%s\"",
+      "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL, NULL, NULL, NULL,
+      NULL, "    ");
+
+  /* Contact Info */
+  msOWSPrintContactInfo(stream, tabspace, OWS_1_1_0, &(map->web.metadata),
+                        "MO");
+
+  /* Close General */
+  msIO_fprintf(stream, "  </General>\n");
+  free(tabspace);
+
+  /* Set the layer list */
+  msIO_fprintf(stream, "  <LayerList>\n");
+
+  /* Loop on all layer   */
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->status != MS_DELETE &&
+        GET_LAYER(map, i)->connectiontype == MS_WMS) {
+      const char *pszValue;
+      char *pszValueMod;
+      const char *pszCurrent;
+      if (GET_LAYER(map, i)->status == MS_OFF)
+        nValue = 1;
+      else
+        nValue = 0;
+      msIO_fprintf(stream, "    <Layer queryable=\"%d\" hidden=\"%d\">\n",
+                   msIsLayerQueryable(GET_LAYER(map, i)), nValue);
+
+      /*  */
+      /* Server definition */
+      /*  */
+      if (nVersion < OWS_1_0_0)
+        msOWSPrintEncodeMetadata(
+            stream, &(GET_LAYER(map, i)->metadata), NULL, "wms_server_version",
+            OWS_WARN, "      <Server service=\"WMS\" version=\"%s\" ", "1.0.0");
+      else
+        msOWSPrintEncodeMetadata(
+            stream, &(GET_LAYER(map, i)->metadata), NULL, "wms_server_version",
+            OWS_WARN, "      <Server service=\"OGC:WMS\" version=\"%s\" ",
+            "1.0.0");
+
+      if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "MO",
+                              "server_title"))
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_server_title", OWS_NOERR,
+                                 "title=\"%s\">\n", "");
+
+      else if (GET_LAYER(map, i)->name)
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_title", OWS_NOERR, "title=\"%s\">\n",
+                                 GET_LAYER(map, i)->name);
+      else {
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_title", OWS_NOERR, "title=\"%s\">\n", "");
+      }
+
+      /* Get base url of the online resource to be the default value */
+      if (GET_LAYER(map, i)->connection)
+        pszValueMod = msStrdup(GET_LAYER(map, i)->connection);
+      else
+        pszValueMod = msStrdup("");
+      pszChar = strchr(pszValueMod, '?');
+      if (pszChar)
+        pszValueMod[pszChar - pszValueMod] = '\0';
+      if (msOWSPrintEncodeMetadata(
+              stream, &(GET_LAYER(map, i)->metadata), NULL,
+              "wms_onlineresource", OWS_WARN,
+              "        <OnlineResource xlink:type=\"simple\" "
+              "xlink:href=\"%s\"/>\n",
+              pszValueMod) == OWS_WARN)
+        msIO_fprintf(stream, "<!-- wms_onlineresource not set, using base URL"
+                             " , but probably not what you want -->\n");
+      msIO_fprintf(stream, "      </Server>\n");
+      if (pszValueMod)
+        free(pszValueMod);
+
+      /*  */
+      /* Layer information */
+      /*  */
+      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                               "wms_name", OWS_WARN, "      <Name>%s</Name>\n",
+                               GET_LAYER(map, i)->name);
+      msOWSPrintEncodeMetadata(
+          stream, &(GET_LAYER(map, i)->metadata), NULL, "wms_title", OWS_WARN,
+          "      <Title>%s</Title>\n", GET_LAYER(map, i)->name);
+      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                               "wms_abstract", OWS_NOERR,
+                               "      <Abstract>%s</Abstract>\n", NULL);
+
+      /* DataURL */
+      if (nVersion <= OWS_0_1_4) {
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_dataurl", OWS_NOERR,
+                                 "      <DataURL>%s</DataURL>\n", NULL);
+      } else {
+        /* The DataURL have a width, height, format and an URL */
+        /* The metadata will be structured like this:  */
+        /* "width height format url" */
+        /* Note: in version 0.1.7 the width and height are not included  */
+        /* in the Context file, but they are included in the metadata for */
+        /* for consistency with the URLType. */
+        msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "MO",
+                          "dataurl", OWS_NOERR, NULL, "DataURL", NULL,
+                          " width=\"%s\"", " height=\"%s\"", " format=\"%s\"",
+                          "        <OnlineResource xlink:type=\"simple\""
+                          " xlink:href=\"%s\"/>\n",
+                          MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "      ");
+      }
+
+      /* MetadataURL */
+      /* The MetadataURL have a width, height, format and an URL */
+      /* The metadata will be structured like this:  */
+      /* "width height format url" */
+      msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "MO",
+                        "metadataurl", OWS_NOERR, NULL, "MetadataURL", NULL,
+                        " width=\"%s\"", " height=\"%s\"", " format=\"%s\"",
+                        "        <OnlineResource xlink:type=\"simple\""
+                        " xlink:href=\"%s\"/>\n",
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "      ");
+
+      /* MinScale && MaxScale */
+      if (nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->minscaledenom > 0)
+        msIO_fprintf(
+            stream,
+            "      <sld:MinScaleDenominator>%g</sld:MinScaleDenominator>\n",
+            GET_LAYER(map, i)->minscaledenom);
+      if (nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->maxscaledenom > 0)
+        msIO_fprintf(
+            stream,
+            "      <sld:MaxScaleDenominator>%g</sld:MaxScaleDenominator>\n",
+            GET_LAYER(map, i)->maxscaledenom);
+
+      /* Layer SRS */
+      msOWSGetEPSGProj(&(GET_LAYER(map, i)->projection),
+                       &(GET_LAYER(map, i)->metadata), "MO", MS_FALSE,
+                       &pszEPSG);
+      if (pszEPSG && (strcasecmp(pszEPSG, "(null)") != 0)) {
+        pszEncodedVal = msEncodeHTMLEntities(pszEPSG);
+        msIO_fprintf(stream, "      <SRS>%s</SRS>\n", pszEncodedVal);
+        msFree(pszEncodedVal);
+      }
+      msFree(pszEPSG);
+
+      /* Format */
+      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_formatlist") ==
+              NULL &&
+          msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_format") ==
+              NULL) {
+        char *pszURL;
+        if (GET_LAYER(map, i)->connection)
+          pszURL = msStrdup(GET_LAYER(map, i)->connection);
+        else
+          pszURL = msStrdup("");
+
+        pszValueMod = strstr(pszURL, "FORMAT=");
+        if (pszValueMod) {
+          pszValueMod += 7;
+          pszChar = strchr(pszValueMod, '&');
+          if (pszChar)
+            pszValueMod[pszChar - pszValueMod] = '\0';
+          if (strcasecmp(pszValueMod, "") != 0) {
+            pszEncodedVal = msEncodeHTMLEntities(pszValueMod);
+            msIO_fprintf(stream, "      <FormatList>\n");
+            msIO_fprintf(stream, "        <Format>%s</Format>\n", pszValueMod);
+            msIO_fprintf(stream, "      </FormatList>\n");
+            msFree(pszEncodedVal);
+          }
+        }
+        free(pszURL);
+      } else {
+        char **papszFormats;
+        int numFormats, nForm;
+
+        pszValue =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_formatlist");
+        if (!pszValue)
+          pszValue =
+              msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_format");
+        pszCurrent =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_format");
+
+        papszFormats = msStringSplit(pszValue, ',', &numFormats);
+        if (numFormats > 0 && papszFormats) {
+          msIO_fprintf(stream, "      <FormatList>\n");
+          for (nForm = 0; nForm < numFormats; nForm++) {
+            pszEncodedVal = msEncodeHTMLEntities(papszFormats[nForm]);
+            if (pszCurrent &&
+                (strcasecmp(papszFormats[nForm], pszCurrent) == 0))
+              msIO_fprintf(stream,
+                           "        <Format current=\"1\">%s</Format>\n",
+                           pszEncodedVal);
+            else
+              msIO_fprintf(stream, "        <Format>%s</Format>\n",
+                           pszEncodedVal);
+            msFree(pszEncodedVal);
+          }
+          msIO_fprintf(stream, "      </FormatList>\n");
+        }
+        if (papszFormats)
+          msFreeCharArray(papszFormats, numFormats);
+      }
+      /* Style */
+      /* First check the stylelist */
+      pszValue =
+          msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_stylelist");
+      while (pszValue && *pszValue == ' ')
+        pszValue++;
+      if (pszValue == NULL || strlen(pszValue) < 1) {
+        /* Check if the style is in the connection URL */
+        char *pszURL;
+        if (GET_LAYER(map, i)->connection)
+          pszURL = msStrdup(GET_LAYER(map, i)->connection);
+        else
+          pszURL = msStrdup("");
+
+        /* Grab the STYLES in the URL */
+        pszValueMod = strstr(pszURL, "STYLES=");
+        if (pszValueMod) {
+          pszValueMod += 7;
+          pszChar = strchr(pszValueMod, '&');
+          if (pszChar)
+            pszValueMod[pszChar - pszValueMod] = '\0';
+
+          /* Check the SLD string from the URL */
+          if (GET_LAYER(map, i)->connection)
+            pszSLD2 = msStrdup(GET_LAYER(map, i)->connection);
+          else
+            pszSLD2 = msStrdup("");
+          if (pszSLD2) {
+            pszSLD = strstr(pszSLD2, "SLD=");
+            pszSLDBody = strstr(pszSLD2, "SLD_BODY=");
+          } else {
+            pszSLD = NULL;
+            pszSLDBody = NULL;
+          }
+          /* Check SLD */
+          if (pszSLD) {
+            pszChar = strchr(pszSLD, '&');
+            if (pszChar)
+              pszSLD[pszChar - pszSLD] = '\0';
+            pszSLD += 4;
+          }
+          /* Check SLDBody  */
+          if (pszSLDBody) {
+            pszChar = strchr(pszSLDBody, '&');
+            if (pszChar)
+              pszSLDBody[pszChar - pszSLDBody] = '\0';
+            pszSLDBody += 9;
+          }
+          if ((pszValueMod && (strcasecmp(pszValueMod, "") != 0)) ||
+              (pszSLD && (strcasecmp(pszSLD, "") != 0)) ||
+              (pszSLDBody && (strcasecmp(pszSLDBody, "") != 0))) {
+            /* Write Name and Title */
+            msIO_fprintf(stream, "      <StyleList>\n");
+            msIO_fprintf(stream, "        <Style current=\"1\">\n");
+            if (pszValueMod && (strcasecmp(pszValueMod, "") != 0)) {
+              pszEncodedVal = msEncodeHTMLEntities(pszValueMod);
+              msIO_fprintf(stream, "          <Name>%s</Name>\n",
+                           pszEncodedVal);
+              msIO_fprintf(stream, "          <Title>%s</Title>\n",
+                           pszEncodedVal);
+              msFree(pszEncodedVal);
+            }
+            /* Write the SLD string from the URL */
+            if (pszSLD && (strcasecmp(pszSLD, "") != 0)) {
+              pszEncodedVal = msEncodeHTMLEntities(pszSLD);
+              msIO_fprintf(stream, "          <SLD>\n");
+              msIO_fprintf(
+                  stream, "            <OnlineResource xlink:type=\"simple\" ");
+              msIO_fprintf(stream, "xlink:href=\"%s\"/>", pszEncodedVal);
+              msIO_fprintf(stream, "          </SLD>\n");
+              free(pszEncodedVal);
+            } else if (pszSLDBody && (strcasecmp(pszSLDBody, "") != 0)) {
+              msIO_fprintf(stream, "          <SLD>\n");
+              msIO_fprintf(stream, "            %s\n", pszSLDBody);
+              msIO_fprintf(stream, "          </SLD>\n");
+            }
+            msIO_fprintf(stream, "        </Style>\n");
+            msIO_fprintf(stream, "      </StyleList>\n");
+          }
+          if (pszSLD2) {
+            free(pszSLD2);
+            pszSLD2 = NULL;
+          }
+        }
+        free(pszURL);
+      } else {
+        const char *pszCurrent;
+        /* If the style information is not in the connection URL, */
+        /* read the metadata. */
+        pszValue =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_stylelist");
+        pszCurrent =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_style");
+        msIO_fprintf(stream, "      <StyleList>\n");
+        /* Loop in each style in the style list */
+        while (pszValue != NULL) {
+          char *pszStyle = msStrdup(pszValue);
+          pszChar = strchr(pszStyle, ',');
+          if (pszChar != NULL)
+            pszStyle[pszChar - pszStyle] = '\0';
+          if (pszStyle[0] == '\0') {
+            msFree(pszStyle);
+            continue;
+          }
+
+          if (pszCurrent && (strcasecmp(pszStyle, pszCurrent) == 0))
+            msIO_fprintf(stream, "        <Style current=\"1\">\n");
+          else
+            msIO_fprintf(stream, "        <Style>\n");
+
+          /* Write SLDURL if it is in the metadata */
+          pszStyleItem = (char *)malloc(strlen(pszStyle) + 10 + 10);
+          sprintf(pszStyleItem, "wms_style_%s_sld", pszStyle);
+          if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), pszStyleItem) !=
+              NULL) {
+            msIO_fprintf(stream, "          <SLD>\n");
+            msOWSPrintEncodeMetadata(
+                stream, &(GET_LAYER(map, i)->metadata), NULL, pszStyleItem,
+                OWS_NOERR,
+                "            <OnlineResource xlink:type=\"simple\" "
+                "xlink:href=\"%s\"/>\n",
+                NULL);
+            msIO_fprintf(stream, "          </SLD>\n");
+            free(pszStyleItem);
+          } else {
+            /* If the URL is not there, check for SLDBody */
+            sprintf(pszStyleItem, "wms_style_%s_sld_body", pszStyle);
+            if (msLookupHashTable(&(GET_LAYER(map, i)->metadata),
+                                  pszStyleItem) != NULL) {
+              msIO_fprintf(stream, "          <SLD>\n");
+              msOWSPrintMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 pszStyleItem, OWS_NOERR, "            %s\n",
+                                 NULL);
+              msIO_fprintf(stream, "          </SLD>\n");
+              free(pszStyleItem);
+            } else {
+              /* If the SLD is not specified, then write the */
+              /* name, Title and LegendURL */
+              free(pszStyleItem);
+              /* Name */
+              pszEncodedVal = msEncodeHTMLEntities(pszStyle);
+              msIO_fprintf(stream, "          <Name>%s</Name>\n",
+                           pszEncodedVal);
+              msFree(pszEncodedVal);
+              pszStyleItem = (char *)malloc(strlen(pszStyle) + 10 + 8);
+              sprintf(pszStyleItem, "wms_style_%s_title", pszStyle);
+              /* Title */
+              msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
+                                       NULL, pszStyleItem, OWS_NOERR,
+                                       "          <Title>%s</Title>\n", NULL);
+              free(pszStyleItem);
+
+              /* LegendURL */
+              pszStyleItem = (char *)malloc(strlen(pszStyle) + 10 + 20);
+              sprintf(pszStyleItem, "style_%s_legendurl", pszStyle);
+              msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "M",
+                                pszStyleItem, OWS_NOERR, NULL, "LegendURL",
+                                NULL, " width=\"%s\"", " height=\"%s\"",
+                                " format=\"%s\"",
+                                "            <OnlineResource "
+                                "xlink:type=\"simple\""
+                                " xlink:href=\"%s\"/>\n          ",
+                                MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE,
+                                NULL, NULL, NULL, NULL, NULL, "          ");
+              free(pszStyleItem);
+            }
+          }
+
+          msIO_fprintf(stream, "        </Style>\n");
+
+          msFree(pszStyle);
+          pszValue = strchr(pszValue, ',');
+          if (pszValue)
+            pszValue++;
+        }
+        msIO_fprintf(stream, "      </StyleList>\n");
+      }
+
+      /* Dimension element */;
+      pszCurrent = NULL;
+
+      pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
+                                   "wms_dimensionlist");
+      pszCurrent =
+          msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_dimension");
+      while (pszValue != NULL) {
+        /* Extract the dimension name from the list */
+        pszDimension = msStrdup(pszValue);
+        pszChar = strchr(pszDimension, ',');
+        if (pszChar != NULL)
+          pszDimension[pszChar - pszDimension] = '\0';
+        if (strcasecmp(pszDimension, "") == 0) {
+          free(pszDimension);
+          pszValue = strchr(pszValue, ',');
+          if (pszValue)
+            pszValue++;
+          continue;
+        }
+
+        /* From the dimension list, extract the required dimension */
+        msOWSGetDimensionInfo(GET_LAYER(map, i), pszDimension, &pszDimUserValue,
+                              &pszDimUnits, &pszDimDefault, &pszDimNearValue,
+                              &pszDimUnitSymbol, &pszDimMultiValue);
+
+        if (pszDimUserValue == NULL || pszDimUnits == NULL ||
+            pszDimUnitSymbol == NULL) {
+          free(pszDimension);
+          pszValue = strchr(pszValue, ',');
+          if (pszValue)
+            pszValue++;
+          continue;
+        }
+
+        if (!bDimensionList) {
+          bDimensionList = 1;
+          msIO_fprintf(stream, "      <DimensionList>\n");
+        }
+
+        /* name */
+        msIO_fprintf(stream, "        <Dimension name=\"%s\"", pszDimension);
+        /* units */
+        msIO_fprintf(stream, " units=\"%s\"", pszDimUnits);
+        /* unitSymbol */
+        msIO_fprintf(stream, " unitSymbol=\"%s\"", pszDimUnitSymbol);
+        /* userValue */
+        msIO_fprintf(stream, " userValue=\"%s\"", pszDimUserValue);
+        /* default */
+        if (pszDimDefault)
+          msIO_fprintf(stream, " default=\"%s\"", pszDimDefault);
+        /* multipleValues */
+        if (pszDimMultiValue)
+          msIO_fprintf(stream, " multipleValues=\"%s\"", pszDimMultiValue);
+        /* nearestValue */
+        if (pszDimNearValue)
+          msIO_fprintf(stream, " nearestValue=\"%s\"", pszDimNearValue);
+
+        if (pszCurrent && strcasecmp(pszDimension, pszCurrent) == 0)
+          msIO_fprintf(stream, " current=\"1\"");
+
+        msIO_fprintf(stream, "/>\n");
+
+        free(pszDimension);
+        pszValue = strchr(pszValue, ',');
+        if (pszValue)
+          pszValue++;
+      }
+
+      if (bDimensionList) {
+        msIO_fprintf(stream, "      </DimensionList>\n");
+        bDimensionList = 0;
+      }
+
+      msIO_fprintf(stream, "    </Layer>\n");
+    }
+  }
+
+  /* Close layer list */
+  msIO_fprintf(stream, "  </LayerList>\n");
+  /* Close Map Context */
+
+  if (nVersion >= OWS_1_0_0) {
+    msIO_fprintf(stream, "</ViewContext>\n");
+  } else if (nVersion >= OWS_0_1_7) {
+    msIO_fprintf(stream, "</View_Context>\n");
+  } else { /* 0.1.4 */
+    msIO_fprintf(stream, "</WMS_Viewer_Context>\n");
+  }
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MAPCONTEXTERR,
+             "Not implemented since Map Context is not enabled.",
+             "msWriteMapContext()");
+  return MS_FAILURE;
+#endif
+}
diff -pruN 8.0.1-5/src/mapcontour.c 8.2.0~beta1-1~exp1/src/mapcontour.c
--- 8.0.1-5/src/mapcontour.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcontour.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1015 @@
+/**********************************************************************
+ * $Id: mapcontour.c 12629 2011-10-06 18:06:34Z aboudreault $
+ *
+ * Project:  MapServer
+ * Purpose:  Contour Layer
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ * Author:   Daniel Morissette (dmorissette@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2011, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include "mapserver.h"
+#include "mapcopy.h"
+#include "mapresample.h"
+
+#include "ogr_api.h"
+#include "ogr_srs_api.h"
+#include "gdal.h"
+#include "gdal_alg.h"
+
+#include "mapows.h"
+#include "mapthread.h"
+#include "mapraster.h"
+#include "cpl_string.h"
+
+#define GEO_TRANS(tr, x, y) ((tr)[0] + (tr)[1] * (x) + (tr)[2] * (y))
+
+extern int InvGeoTransform(double *gt_in, double *gt_out);
+
+typedef struct {
+
+  /* OGR DataSource */
+  layerObj ogrLayer;
+
+  /* internal use */
+  GDALDatasetH hOrigDS;
+  GDALDatasetH hDS;
+  double *buffer; /* memory dataset buffer */
+  rectObj extent; /* original dataset extent */
+  OGRDataSourceH hOGRDS;
+  double cellsize;
+
+} contourLayerInfo;
+
+static int msContourLayerInitItemInfo(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerInitItemInfo()");
+    return MS_FAILURE;
+  }
+
+  return msLayerInitItemInfo(&clinfo->ogrLayer);
+}
+
+static void msContourLayerFreeItemInfo(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerFreeItemInfo()");
+    return;
+  }
+
+  msLayerFreeItemInfo(&clinfo->ogrLayer);
+}
+
+static void msContourLayerInfoInitialize(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (clinfo != NULL)
+    return;
+
+  clinfo = (contourLayerInfo *)msSmallCalloc(1, sizeof(contourLayerInfo));
+  layer->layerinfo = clinfo;
+  clinfo->hOrigDS = NULL;
+  clinfo->hDS = NULL;
+  clinfo->extent.minx = -1.0;
+  clinfo->extent.miny = -1.0;
+  clinfo->extent.maxx = -1.0;
+  clinfo->extent.maxy = -1.0;
+
+  initLayer(&clinfo->ogrLayer, layer->map);
+  clinfo->ogrLayer.type = layer->type;
+  clinfo->ogrLayer.debug = layer->debug;
+  clinfo->ogrLayer.connectiontype = MS_OGR;
+  clinfo->ogrLayer.name = msStrdup(layer->name);
+  clinfo->ogrLayer.connection =
+      (char *)msSmallMalloc(strlen(clinfo->ogrLayer.name) + 13);
+  sprintf(clinfo->ogrLayer.connection, "__%s_CONTOUR__", clinfo->ogrLayer.name);
+  clinfo->ogrLayer.units = layer->units;
+
+  if (msOWSLookupMetadata(&(layer->metadata), "OFG", "ID_type") == NULL) {
+    msInsertHashTable(&(layer->metadata), "gml_ID_type", "Integer");
+  }
+  {
+    const char *elevItem = CSLFetchNameValue(layer->processing, "CONTOUR_ITEM");
+    if (elevItem && strlen(elevItem) > 0) {
+      char szTmp[100];
+      snprintf(szTmp, sizeof(szTmp), "%s_type", elevItem);
+      if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
+        snprintf(szTmp, sizeof(szTmp), "gml_%s_type", elevItem);
+        msInsertHashTable(&(layer->metadata), szTmp, "Real");
+      }
+    }
+  }
+}
+
+static void msContourLayerInfoFree(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (clinfo == NULL)
+    return;
+
+  freeLayer(&clinfo->ogrLayer);
+  free(clinfo);
+
+  layer->layerinfo = NULL;
+}
+
+static int msContourLayerReadRaster(layerObj *layer, rectObj rect) {
+  mapObj *map = layer->map;
+  char **bands;
+  char pointer[64], memDSPointer[128];
+  int band = 1;
+  double adfGeoTransform[6], adfInvGeoTransform[6];
+  double llx, lly, urx, ury;
+  rectObj copyRect, mapRect;
+  int dst_xsize, dst_ysize;
+  int virtual_grid_step_x, virtual_grid_step_y;
+  int src_xoff, src_yoff, src_xsize, src_ysize;
+  double map_cellsize_x, map_cellsize_y, dst_cellsize_x, dst_cellsize_y;
+  GDALRasterBandH hBand = NULL;
+  CPLErr eErr;
+
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (layer->debug)
+    msDebug("Entering msContourLayerReadRaster().\n");
+
+  if (clinfo == NULL || clinfo->hOrigDS == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerReadRaster()");
+    return MS_FAILURE;
+  }
+
+  bands = CSLTokenizeStringComplex(
+      CSLFetchNameValue(layer->processing, "BANDS"), " ,", FALSE, FALSE);
+  if (CSLCount(bands) > 0) {
+    band = atoi(bands[0]);
+    if (band < 1 || band > GDALGetRasterCount(clinfo->hOrigDS)) {
+      msSetError(MS_IMGERR,
+                 "BANDS PROCESSING directive includes illegal band '%d', "
+                 "should be from 1 to %d.",
+                 "msContourLayerReadRaster()", band,
+                 GDALGetRasterCount(clinfo->hOrigDS));
+      CSLDestroy(bands);
+      return MS_FAILURE;
+    }
+  }
+  CSLDestroy(bands);
+
+  hBand = GDALGetRasterBand(clinfo->hOrigDS, band);
+  if (hBand == NULL) {
+    msSetError(MS_IMGERR, "Band %d does not exist on dataset.",
+               "msContourLayerReadRaster()", band);
+    return MS_FAILURE;
+  }
+
+  if (layer->projection.numargs > 0 &&
+      EQUAL(layer->projection.args[0], "auto")) {
+    const char *wkt;
+    wkt = GDALGetProjectionRef(clinfo->hOrigDS);
+    if (wkt != NULL && strlen(wkt) > 0) {
+      if (msOGCWKT2ProjectionObj(wkt, &(layer->projection), layer->debug) !=
+          MS_SUCCESS) {
+        char msg[MESSAGELENGTH * 2];
+        errorObj *ms_error = msGetErrorObj();
+
+        snprintf(msg, sizeof(msg),
+                 "%s\n"
+                 "PROJECTION AUTO cannot be used for this "
+                 "GDAL raster (`%s').",
+                 ms_error->message, layer->data);
+        msg[MESSAGELENGTH - 1] = '\0';
+
+        msSetError(MS_OGRERR, "%s", "msDrawRasterLayer()", msg);
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  /*
+   * Compute the georeferenced window of overlap, and read the source data
+   * downsampled to match output resolution, or at full resolution if
+   * output resolution is lower than the source resolution.
+   *
+   * A large portion of this overlap calculation code was borrowed from
+   * msDrawRasterLayerGDAL().
+   * Would be possible to move some of this to a reusable function?
+   *
+   * Note: This code works only if no reprojection is involved. It would
+   * need rework to support cases where output projection differs from source
+   * data file projection.
+   */
+
+  src_xsize = GDALGetRasterXSize(clinfo->hOrigDS);
+  src_ysize = GDALGetRasterYSize(clinfo->hOrigDS);
+
+  /* set the Dataset extent */
+  msGetGDALGeoTransform(clinfo->hOrigDS, map, layer, adfGeoTransform);
+  clinfo->extent.minx = adfGeoTransform[0];
+  clinfo->extent.maxy = adfGeoTransform[3];
+  clinfo->extent.maxx = adfGeoTransform[0] + src_xsize * adfGeoTransform[1];
+  clinfo->extent.miny = adfGeoTransform[3] + src_ysize * adfGeoTransform[5];
+
+  if (layer->transform) {
+    if (layer->debug)
+      msDebug("msContourLayerReadRaster(): Entering transform.\n");
+
+    InvGeoTransform(adfGeoTransform, adfInvGeoTransform);
+
+    mapRect = rect;
+    if (map->cellsize == 0) {
+      map->cellsize = msAdjustExtent(&mapRect, map->width, map->height);
+    }
+    map_cellsize_x = map_cellsize_y = map->cellsize;
+    /* if necessary, project the searchrect to source coords */
+    if (msProjectionsDiffer(&(map->projection), &(layer->projection))) {
+      if (msProjectRect(&map->projection, &layer->projection, &mapRect) !=
+          MS_SUCCESS) {
+        msDebug("msContourLayerReadRaster(%s): unable to reproject map request "
+                "rectangle into layer projection, canceling.\n",
+                layer->name);
+        return MS_FAILURE;
+      }
+
+      map_cellsize_x = MS_CELLSIZE(mapRect.minx, mapRect.maxx, map->width);
+      map_cellsize_y = MS_CELLSIZE(mapRect.miny, mapRect.maxy, map->height);
+
+      /* if the projection failed to project the extent requested, we need to
+         calculate the cellsize to preserve the initial map cellsize ratio */
+      if ((mapRect.minx < GEO_TRANS(adfGeoTransform, 0, src_ysize)) ||
+          (mapRect.maxx > GEO_TRANS(adfGeoTransform, src_xsize, 0)) ||
+          (mapRect.miny < GEO_TRANS(adfGeoTransform + 3, 0, src_ysize)) ||
+          (mapRect.maxy > GEO_TRANS(adfGeoTransform + 3, src_xsize, 0))) {
+
+        int src_unit, dst_unit;
+        src_unit = GetMapserverUnitUsingProj(&map->projection);
+        dst_unit = GetMapserverUnitUsingProj(&layer->projection);
+        if (src_unit == -1 || dst_unit == -1) {
+          msDebug("msContourLayerReadRaster(%s): unable to reproject map "
+                  "request rectangle into layer projection, canceling.\n",
+                  layer->name);
+          return MS_FAILURE;
+        }
+
+        map_cellsize_x = MS_CONVERT_UNIT(
+            src_unit, dst_unit, MS_CELLSIZE(rect.minx, rect.maxx, map->width));
+        map_cellsize_y = MS_CONVERT_UNIT(
+            src_unit, dst_unit, MS_CELLSIZE(rect.miny, rect.maxy, map->height));
+      }
+    }
+
+    if (map_cellsize_x == 0 || map_cellsize_y == 0) {
+      if (layer->debug)
+        msDebug("msContourLayerReadRaster(): Cellsize can't be 0.\n");
+      return MS_FAILURE;
+    }
+
+    /* Adjust MapServer pixel model to GDAL pixel model */
+    mapRect.minx -= map_cellsize_x * 0.5;
+    mapRect.maxx += map_cellsize_x * 0.5;
+    mapRect.miny -= map_cellsize_y * 0.5;
+    mapRect.maxy += map_cellsize_y * 0.5;
+
+    /*
+     * If raw data cellsize (from geotransform) is larger than output
+     * map_cellsize then we want to extract only enough data to match the output
+     * map resolution which means that GDAL will automatically sample the data
+     * on read.
+     *
+     * To prevent bad contour effects on tile edges, we adjust the target
+     * cellsize to align the extracted window with a virtual grid based on the
+     * origin of the raw data and a virtual grid step size corresponding to an
+     * integer sampling step.
+     *
+     * If source data has a greater cellsize (i.e. lower res) that requested
+     * ouptut map then we use the raw data cellsize as target cellsize since
+     * there is no point in interpolating the data for contours in this case.
+     */
+
+    virtual_grid_step_x = (int)floor(map_cellsize_x / ABS(adfGeoTransform[1]));
+    if (virtual_grid_step_x < 1)
+      virtual_grid_step_x =
+          1; /* Do not interpolate data if grid sampling step < 1 */
+
+    virtual_grid_step_y = (int)floor(map_cellsize_y / ABS(adfGeoTransform[5]));
+    if (virtual_grid_step_y < 1)
+      virtual_grid_step_y =
+          1; /* Do not interpolate data if grid sampling step < 1 */
+
+    /* target cellsize is a multiple of raw data cellsize based on grid step*/
+    dst_cellsize_x = ABS(adfGeoTransform[1]) * virtual_grid_step_x;
+    dst_cellsize_y = ABS(adfGeoTransform[5]) * virtual_grid_step_y;
+
+    /* Compute overlap between source and target views */
+
+    copyRect = mapRect;
+
+    if (copyRect.minx < GEO_TRANS(adfGeoTransform, 0, src_ysize))
+      copyRect.minx = GEO_TRANS(adfGeoTransform, 0, src_ysize);
+    if (copyRect.maxx > GEO_TRANS(adfGeoTransform, src_xsize, 0))
+      copyRect.maxx = GEO_TRANS(adfGeoTransform, src_xsize, 0);
+    if (copyRect.miny < GEO_TRANS(adfGeoTransform + 3, 0, src_ysize))
+      copyRect.miny = GEO_TRANS(adfGeoTransform + 3, 0, src_ysize);
+    if (copyRect.maxy > GEO_TRANS(adfGeoTransform + 3, src_xsize, 0))
+      copyRect.maxy = GEO_TRANS(adfGeoTransform + 3, src_xsize, 0);
+
+    if (copyRect.minx >= copyRect.maxx || copyRect.miny >= copyRect.maxy) {
+      if (layer->debug)
+        msDebug("msContourLayerReadRaster(): No overlap.\n");
+      return MS_SUCCESS;
+    }
+
+    /*
+     * Convert extraction window to raster coordinates
+     */
+    llx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.minx, copyRect.miny);
+    lly = GEO_TRANS(adfInvGeoTransform + 3, copyRect.minx, copyRect.miny);
+    urx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.maxx, copyRect.maxy);
+    ury = GEO_TRANS(adfInvGeoTransform + 3, copyRect.maxx, copyRect.maxy);
+
+    /*
+     * Align extraction window with virtual grid
+     * (keep in mind raster coordinates origin is at upper-left)
+     * We also add an extra buffer to fix tile boundarie issues when zoomed
+     */
+    llx = floor(llx / virtual_grid_step_x) * virtual_grid_step_x -
+          (virtual_grid_step_x * 5);
+    urx = ceil(urx / virtual_grid_step_x) * virtual_grid_step_x +
+          (virtual_grid_step_x * 5);
+    ury = floor(ury / virtual_grid_step_y) * virtual_grid_step_y -
+          (virtual_grid_step_x * 5);
+    lly = ceil(lly / virtual_grid_step_y) * virtual_grid_step_y +
+          (virtual_grid_step_x * 5);
+
+    src_xoff = MS_MAX(0, (int)floor(llx + 0.5));
+    src_yoff = MS_MAX(0, (int)floor(ury + 0.5));
+    src_xsize = MS_MIN(MS_MAX(0, (int)(urx - llx + 0.5)),
+                       GDALGetRasterXSize(clinfo->hOrigDS) - src_xoff);
+    src_ysize = MS_MIN(MS_MAX(0, (int)(lly - ury + 0.5)),
+                       GDALGetRasterYSize(clinfo->hOrigDS) - src_yoff);
+
+    /* Update the geographic extent (buffer added) */
+    /* TODO: a better way to go the geo_trans */
+    copyRect.minx = GEO_TRANS(adfGeoTransform + 0, src_xoff, 0);
+    copyRect.maxx = GEO_TRANS(adfGeoTransform + 0, src_xoff + src_xsize, 0);
+    copyRect.miny = GEO_TRANS(adfGeoTransform + 3, 0, src_yoff + src_ysize);
+    copyRect.maxy = GEO_TRANS(adfGeoTransform + 3, 0, src_yoff);
+
+    /*
+     * If input window is to small then stop here
+     */
+    if (src_xsize < 2 || src_ysize < 2) {
+      if (layer->debug)
+        msDebug("msContourLayerReadRaster(): input window too small, or no "
+                "apparent overlap between map view and this window(1).\n");
+      return MS_SUCCESS;
+    }
+
+    /* Target buffer size */
+    dst_xsize = (int)ceil((copyRect.maxx - copyRect.minx) / dst_cellsize_x);
+    dst_ysize = (int)ceil((copyRect.maxy - copyRect.miny) / dst_cellsize_y);
+
+    if (dst_xsize == 0 || dst_ysize == 0) {
+      if (layer->debug)
+        msDebug("msContourLayerReadRaster(): no apparent overlap between map "
+                "view and this window(2).\n");
+      return MS_SUCCESS;
+    }
+
+    if (layer->debug)
+      msDebug("msContourLayerReadRaster(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
+              src_xoff, src_yoff, src_xsize, src_ysize, 0, 0, dst_xsize,
+              dst_ysize);
+  } else {
+    src_xoff = 0;
+    src_yoff = 0;
+    dst_xsize = src_xsize = MS_MIN(map->width, src_xsize);
+    dst_ysize = src_ysize = MS_MIN(map->height, src_ysize);
+    copyRect.minx = 0;
+    copyRect.miny = 0;
+    (void)copyRect.miny;
+    copyRect.maxx = map->width;
+    copyRect.maxy = map->height;
+    (void)copyRect.maxx;
+    dst_cellsize_y = dst_cellsize_x = 1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Allocate buffer, and read data into it.                         */
+  /* -------------------------------------------------------------------- */
+
+  clinfo->buffer = (double *)malloc(sizeof(double) * dst_xsize * dst_ysize);
+  if (clinfo->buffer == NULL) {
+    msSetError(MS_MEMERR, "Malloc(): Out of memory.",
+               "msContourLayerReadRaster()");
+    return MS_FAILURE;
+  }
+
+  eErr = GDALRasterIO(hBand, GF_Read, src_xoff, src_yoff, src_xsize, src_ysize,
+                      clinfo->buffer, dst_xsize, dst_ysize, GDT_Float64, 0, 0);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALRasterIO() failed: %s",
+               "msContourLayerReadRaster()", CPLGetLastErrorMsg());
+    free(clinfo->buffer);
+    return MS_FAILURE;
+  }
+
+  memset(pointer, 0, sizeof(pointer));
+  CPLPrintPointer(pointer, clinfo->buffer, sizeof(pointer));
+  sprintf(memDSPointer,
+          "MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Float64",
+          pointer, dst_xsize, dst_ysize);
+  clinfo->hDS = GDALOpen(memDSPointer, GA_ReadOnly);
+  if (clinfo->hDS == NULL) {
+    msSetError(MS_IMGERR, "Unable to open GDAL Memory dataset.",
+               "msContourLayerReadRaster()");
+    free(clinfo->buffer);
+    return MS_FAILURE;
+  }
+
+  {
+    // Copy nodata value from source dataset to memory dataset
+    int bHasNoData = FALSE;
+    double dfNoDataValue = GDALGetRasterNoDataValue(hBand, &bHasNoData);
+    if (bHasNoData) {
+      GDALSetRasterNoDataValue(GDALGetRasterBand(clinfo->hDS, 1),
+                               dfNoDataValue);
+    }
+  }
+
+  adfGeoTransform[0] = copyRect.minx;
+  adfGeoTransform[1] = dst_cellsize_x;
+  adfGeoTransform[2] = 0;
+  adfGeoTransform[3] = copyRect.maxy;
+  adfGeoTransform[4] = 0;
+  adfGeoTransform[5] = -dst_cellsize_y;
+
+  clinfo->cellsize = MS_MAX(dst_cellsize_x, dst_cellsize_y);
+  {
+    char buf[64];
+    sprintf(buf, "%lf", clinfo->cellsize);
+    msInsertHashTable(&layer->metadata, "__data_cellsize__", buf);
+  }
+
+  GDALSetGeoTransform(clinfo->hDS, adfGeoTransform);
+  return MS_SUCCESS;
+}
+
+static void msContourOGRCloseConnection(void *conn_handle) {
+  OGRDataSourceH hDS = (OGRDataSourceH)conn_handle;
+
+  msAcquireLock(TLOCK_OGR);
+  OGR_DS_Destroy(hDS);
+  msReleaseLock(TLOCK_OGR);
+}
+
+/* Function that parses multiple options in the a list. It also supports
+   min/maxscaledenom checks. ie. "CONTOUR_INTERVAL=0,3842942:10" */
+static char *msContourGetOption(layerObj *layer, const char *name) {
+  int c, i, found = MS_FALSE;
+  char **values, **tmp, **options;
+  double maxscaledenom, minscaledenom;
+  char *value = NULL;
+
+  options = CSLFetchNameValueMultiple(layer->processing, name);
+  c = CSLCount(options);
+
+  /* First pass to find the value among options that have min/maxscaledenom */
+  /* specified */
+  for (i = 0; i < c && found == MS_FALSE; ++i) {
+    values = CSLTokenizeStringComplex(options[i], ":", FALSE, FALSE);
+    if (CSLCount(values) == 2) {
+      tmp = CSLTokenizeStringComplex(values[0], ",", FALSE, FALSE);
+      if (CSLCount(tmp) == 2) {
+        minscaledenom = atof(tmp[0]);
+        maxscaledenom = atof(tmp[1]);
+        if (layer->map->scaledenom <= 0 ||
+            (((maxscaledenom <= 0) ||
+              (layer->map->scaledenom <= maxscaledenom)) &&
+             ((minscaledenom <= 0) ||
+              (layer->map->scaledenom > minscaledenom)))) {
+          value = msStrdup(values[1]);
+          found = MS_TRUE;
+        }
+      }
+      CSLDestroy(tmp);
+    }
+    CSLDestroy(values);
+  }
+
+  /* Second pass to find the value among options that do NOT have */
+  /* min/maxscaledenom specified */
+  for (i = 0; i < c && found == MS_FALSE; ++i) {
+    values = CSLTokenizeStringComplex(options[i], ":", FALSE, FALSE);
+    if (CSLCount(values) == 1) {
+      value = msStrdup(values[0]);
+      found = MS_TRUE;
+    }
+    CSLDestroy(values);
+  }
+
+  CSLDestroy(options);
+
+  return value;
+}
+
+static int msContourLayerGenerateContour(layerObj *layer) {
+  OGRSFDriverH hDriver;
+  OGRFieldDefnH hFld;
+  OGRLayerH hLayer;
+  const char *elevItem;
+  char *option;
+  double interval = 1.0, levels[1000];
+  int levelCount = 0;
+  GDALRasterBandH hBand = NULL;
+  CPLErr eErr;
+  int bHasNoData = FALSE;
+  double dfNoDataValue;
+
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  OGRRegisterAll();
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerCreateOGRDataSource()");
+    return MS_FAILURE;
+  }
+
+  if (!clinfo->hDS) { /* no overlap */
+    return MS_SUCCESS;
+  }
+
+  hBand = GDALGetRasterBand(clinfo->hDS, 1);
+  if (hBand == NULL) {
+    msSetError(MS_IMGERR, "Band %d does not exist on dataset.",
+               "msContourLayerGenerateContour()", 1);
+    return MS_FAILURE;
+  }
+
+  /* Create the OGR DataSource */
+  hDriver = OGRGetDriverByName("Memory");
+  if (hDriver == NULL) {
+    msSetError(MS_OGRERR, "Unable to get OGR driver 'Memory'.",
+               "msContourLayerCreateOGRDataSource()");
+    return MS_FAILURE;
+  }
+
+  clinfo->hOGRDS = OGR_Dr_CreateDataSource(hDriver, "", NULL);
+  if (clinfo->hOGRDS == NULL) {
+    msSetError(MS_OGRERR, "Unable to create OGR DataSource.",
+               "msContourLayerCreateOGRDataSource()");
+    return MS_FAILURE;
+  }
+
+  hLayer = OGR_DS_CreateLayer(clinfo->hOGRDS, clinfo->ogrLayer.name, NULL,
+                              wkbLineString, NULL);
+
+  hFld = OGR_Fld_Create("ID", OFTInteger);
+  OGR_Fld_SetWidth(hFld, 8);
+  OGR_L_CreateField(hLayer, hFld, FALSE);
+  OGR_Fld_Destroy(hFld);
+
+  /* Check if we have a coutour item specified */
+  elevItem = CSLFetchNameValue(layer->processing, "CONTOUR_ITEM");
+  if (elevItem && strlen(elevItem) > 0) {
+    hFld = OGR_Fld_Create(elevItem, OFTReal);
+    OGR_Fld_SetWidth(hFld, 12);
+    OGR_Fld_SetPrecision(hFld, 3);
+    OGR_L_CreateField(hLayer, hFld, FALSE);
+    OGR_Fld_Destroy(hFld);
+  } else {
+    elevItem = NULL;
+  }
+
+  option = msContourGetOption(layer, "CONTOUR_INTERVAL");
+  if (option) {
+    interval = atof(option);
+    free(option);
+  }
+
+  option = msContourGetOption(layer, "CONTOUR_LEVELS");
+  if (option) {
+    int i, c;
+    char **levelsTmp;
+    levelsTmp = CSLTokenizeStringComplex(option, ",", FALSE, FALSE);
+    c = CSLCount(levelsTmp);
+    for (i = 0; i < c && i < (int)(sizeof(levels) / sizeof(double)); ++i)
+      levels[levelCount++] = atof(levelsTmp[i]);
+
+    CSLDestroy(levelsTmp);
+    free(option);
+  }
+
+  dfNoDataValue = GDALGetRasterNoDataValue(hBand, &bHasNoData);
+
+  eErr = GDALContourGenerate(
+      hBand, interval, 0.0, levelCount, levels, bHasNoData, dfNoDataValue,
+      hLayer, OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn(hLayer), "ID"),
+      (elevItem == NULL)
+          ? -1
+          : OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn(hLayer), elevItem),
+      NULL, NULL);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALContourGenerate() failed: %s",
+               "msContourLayerGenerateContour()", CPLGetLastErrorMsg());
+    return MS_FAILURE;
+  }
+
+  msConnPoolRegister(&clinfo->ogrLayer, clinfo->hOGRDS,
+                     msContourOGRCloseConnection);
+
+  return MS_SUCCESS;
+}
+
+int msContourLayerOpen(layerObj *layer) {
+  char *decrypted_path;
+  char szPath[MS_MAXPATHLEN];
+  contourLayerInfo *clinfo;
+
+  if (layer->debug)
+    msDebug("Entering msContourLayerOpen().\n");
+
+  /* If we don't have info, initialize an empty one now */
+  if (layer->layerinfo == NULL)
+    msContourLayerInfoInitialize(layer);
+
+  clinfo = (contourLayerInfo *)layer->layerinfo;
+  if (layer->data == NULL && layer->tileindex == NULL) {
+    msSetError(MS_MISCERR, "Layer %s has neither DATA nor TILEINDEX defined.",
+               "msContourLayerOpen()", layer->name);
+    return MS_FAILURE;
+  }
+
+  if (layer->tileindex != NULL) {
+    char szTilename[MS_MAXPATHLEN];
+    int status;
+    int tilelayerindex, tileitemindex, tilesrsindex;
+    rectObj searchrect;
+    layerObj *tlp;
+    shapeObj tshp;
+    char tilesrsname[1];
+
+    msInitShape(&tshp);
+    searchrect = layer->map->extent;
+
+    status = msDrawRasterSetupTileLayer(layer->map, layer, &searchrect,
+                                        MS_FALSE, &tilelayerindex,
+                                        &tileitemindex, &tilesrsindex, &tlp);
+    if (status == MS_FAILURE) {
+      return MS_FAILURE;
+    }
+
+    status = msDrawRasterIterateTileIndex(layer, tlp, &tshp, tileitemindex, -1,
+                                          szTilename, sizeof(szTilename),
+                                          tilesrsname, sizeof(tilesrsname));
+    if (status == MS_FAILURE || status == MS_DONE) {
+      if (status == MS_DONE) {
+        if (layer->debug)
+          msDebug("No raster matching filter.\n");
+      }
+      msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
+      return MS_FAILURE;
+    }
+
+    msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
+
+    msDrawRasterBuildRasterPath(layer->map, layer, szTilename, szPath);
+    decrypted_path = msStrdup(szPath);
+
+    /* Cancel the time filter that might have been set on ours in case of */
+    /* a inline tileindex */
+    msFreeExpression(&layer->filter);
+    msInitExpression(&layer->filter);
+  } else {
+    msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                    layer->data);
+    decrypted_path = msDecryptStringTokens(layer->map, szPath);
+  }
+
+  GDALAllRegister();
+
+  /* Open the original Dataset */
+
+  msAcquireLock(TLOCK_GDAL);
+  if (decrypted_path) {
+    clinfo->hOrigDS = GDALOpen(decrypted_path, GA_ReadOnly);
+    msFree(decrypted_path);
+  } else
+    clinfo->hOrigDS = NULL;
+
+  msReleaseLock(TLOCK_GDAL);
+
+  if (clinfo->hOrigDS == NULL) {
+    msSetError(MS_IMGERR, "Unable to open GDAL dataset.",
+               "msContourLayerOpen()");
+    return MS_FAILURE;
+  }
+
+  /* Open the raster source */
+  if (msContourLayerReadRaster(layer, layer->map->extent) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /* Generate Contour Dataset */
+  if (msContourLayerGenerateContour(layer) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (clinfo->hDS) {
+    GDALClose(clinfo->hDS);
+    clinfo->hDS = NULL;
+    free(clinfo->buffer);
+  }
+
+  /* Open our virtual ogr layer */
+  if (clinfo->hOGRDS && (msLayerOpen(&clinfo->ogrLayer) != MS_SUCCESS))
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+int msContourLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return MS_TRUE;
+  return MS_FALSE;
+}
+
+int msContourLayerClose(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (layer->debug)
+    msDebug("Entering msContourLayerClose().\n");
+
+  if (clinfo) {
+    if (clinfo->hOGRDS)
+      msConnPoolRelease(&clinfo->ogrLayer, clinfo->hOGRDS);
+
+    msLayerClose(&clinfo->ogrLayer);
+
+    if (clinfo->hDS) {
+      GDALClose(clinfo->hDS);
+      clinfo->hDS = NULL;
+      free(clinfo->buffer);
+    }
+
+    if (clinfo->hOrigDS) {
+      GDALClose(clinfo->hOrigDS);
+      clinfo->hOrigDS = NULL;
+    }
+
+    msContourLayerInfoFree(layer);
+  }
+
+  return MS_SUCCESS;
+}
+
+int msContourLayerGetItems(layerObj *layer) {
+  const char *elevItem;
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerGetItems()");
+    return MS_FAILURE;
+  }
+
+  layer->numitems = 0;
+  layer->items = (char **)msSmallCalloc(sizeof(char *), 2);
+
+  layer->items[layer->numitems++] = msStrdup("ID");
+  elevItem = CSLFetchNameValue(layer->processing, "CONTOUR_ITEM");
+  if (elevItem && strlen(elevItem) > 0) {
+    layer->items[layer->numitems++] = msStrdup(elevItem);
+  }
+
+  return msLayerGetItems(&clinfo->ogrLayer);
+}
+
+int msContourLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  int i;
+  rectObj newRect;
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (layer->debug)
+    msDebug("Entering msContourLayerWhichShapes().\n");
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerWhichShapes()");
+    return MS_FAILURE;
+  }
+
+  if (isQuery) {
+    newRect = layer->map->extent;
+  } else {
+    newRect = rect;
+    /* if necessary, project the searchrect to source coords */
+    if (msProjectionsDiffer(&(layer->map->projection), &(layer->projection))) {
+      if (msProjectRect(&layer->projection, &layer->map->projection,
+                        &newRect) != MS_SUCCESS) {
+        msDebug("msContourLayerWhichShapes(%s): unable to reproject map "
+                "request rectangle into layer projection, canceling.\n",
+                layer->name);
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  /* regenerate the raster io */
+  if (clinfo->hOGRDS)
+    msConnPoolRelease(&clinfo->ogrLayer, clinfo->hOGRDS);
+
+  msLayerClose(&clinfo->ogrLayer);
+
+  /* Open the raster source */
+  if (msContourLayerReadRaster(layer, newRect) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /* Generate Contour Dataset */
+  if (msContourLayerGenerateContour(layer) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (clinfo->hDS) {
+    GDALClose(clinfo->hDS);
+    clinfo->hDS = NULL;
+    free(clinfo->buffer);
+  }
+
+  if (!clinfo->hOGRDS) /* no overlap */
+    return MS_DONE;
+
+  /* Open our virtual ogr layer */
+  if (msLayerOpen(&clinfo->ogrLayer) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  clinfo->ogrLayer.numitems = layer->numitems;
+  clinfo->ogrLayer.items =
+      (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
+  for (i = 0; i < layer->numitems; ++i) {
+    clinfo->ogrLayer.items[i] = msStrdup(layer->items[i]);
+  }
+
+  return msLayerWhichShapes(&clinfo->ogrLayer, rect, isQuery);
+}
+
+int msContourLayerGetShape(layerObj *layer, shapeObj *shape,
+                           resultObj *record) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (layer->debug)
+    msDebug("Entering msContourLayerGetShape().\n");
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  return msLayerGetShape(&clinfo->ogrLayer, shape, record);
+}
+
+int msContourLayerNextShape(layerObj *layer, shapeObj *shape) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (layer->debug)
+    msDebug("Entering msContourLayerNextShape().\n");
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerNextShape()");
+    return MS_FAILURE;
+  }
+
+  return msLayerNextShape(&clinfo->ogrLayer, shape);
+}
+
+/************************************************************************/
+/*                       msContourLayerGetExtent()                     */
+/* Simple copy of the maprasterquery.c file. might change in the future */
+/************************************************************************/
+
+int msContourLayerGetExtent(layerObj *layer, rectObj *extent) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
+
+  if (layer->debug)
+    msDebug("Entering msContourLayerGetExtent().\n");
+
+  if (clinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
+               "msContourLayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  MS_COPYRECT(extent, &clinfo->extent);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                     msContourLayerSetTimeFilter()                    */
+/*                                                                      */
+/*      This function is actually just used in the context of           */
+/*      setting a filter on the tileindex for time based queries.       */
+/*      For instance via WMS requests.                                  */
+/*                                                                      */
+/*      If a local shapefile tileindex is in use, we will set a         */
+/*      backtics filter (shapefile compatible).  If another layer is    */
+/*      being used as the tileindex then we will forward the            */
+/*      SetTimeFilter call to it.  If there is no tileindex in          */
+/*      place, we do nothing.                                           */
+/************************************************************************/
+
+int msContourLayerSetTimeFilter(layerObj *layer, const char *timestring,
+                                const char *timefield) {
+  int tilelayerindex;
+
+  if (layer->debug)
+    msDebug("msContourLayerSetTimeFilter(%s,%s).\n", timestring, timefield);
+
+  /* -------------------------------------------------------------------- */
+  /*      If we don't have a tileindex the time filter has no effect.     */
+  /* -------------------------------------------------------------------- */
+  if (layer->tileindex == NULL) {
+    if (layer->debug)
+      msDebug("msContourLayerSetTimeFilter(): time filter without effect on "
+              "layers without tileindex.\n");
+    return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Find the tileindex layer.                                       */
+  /* -------------------------------------------------------------------- */
+  tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
+
+  /* -------------------------------------------------------------------- */
+  /*      If we are using a local shapefile as our tileindex (that is     */
+  /*      to say, the tileindex name is not of another layer), then we    */
+  /*      just install a backtics style filter on the current layer.      */
+  /* -------------------------------------------------------------------- */
+  if (tilelayerindex == -1)
+    return msLayerMakeBackticsTimeFilter(layer, timestring, timefield);
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
+  /*      method.                                                         */
+  /* -------------------------------------------------------------------- */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+  return msLayerSetTimeFilter(layer->GET_LAYER(map, tilelayerindex), timestring,
+                              timefield);
+}
+
+/************************************************************************/
+/*                msRASTERLayerInitializeVirtualTable()                 */
+/************************************************************************/
+
+int msContourLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerInitItemInfo = msContourLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msContourLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msContourLayerOpen;
+  layer->vtable->LayerIsOpen = msContourLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msContourLayerWhichShapes;
+  layer->vtable->LayerNextShape = msContourLayerNextShape;
+  layer->vtable->LayerGetShape = msContourLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msContourLayerClose;
+  layer->vtable->LayerGetItems = msContourLayerGetItems;
+  layer->vtable->LayerGetExtent = msContourLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /*layer->vtable->LayerCloseConnection = msContourLayerClose;*/
+  /* we use backtics for proper tileindex shapefile functioning */
+  layer->vtable->LayerSetTimeFilter = msContourLayerSetTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapcopy.c 8.2.0~beta1-1~exp1/src/mapcopy.c
--- 8.0.1-5/src/mapcopy.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcopy.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1290 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project: MapServer
+ * Purpose: Functions to allow copying/cloning of maps
+ * Author:  Sean Gillies, sgillies@frii.com
+ *
+ * Notes:
+ * These functions are not in mapfile.c because that file is
+ * cumbersome enough as it is.  There is agreement that this code and
+ * that in mapfile.c should eventually be split up by object into
+ * mapobj.c, layerobj.c, etc.  Or something like that.
+ *
+ * Unit tests are written in Python using PyUnit and are in
+ * mapscript/python/tests/testCopyMap.py.  The tests can be
+ * executed from the python directory as
+ *
+ *   python2 tests/testCopyMap.py
+ *
+ * I just find Python to be very handy for unit testing, that's all.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "mapsymbol.h"
+
+#include "mapcopy.h"
+
+/***********************************************************************
+ * msCopyProjectioExtended()                                           *
+ *                                                                     *
+ * Copy a projectionObj while adding additional arguments              *
+ **********************************************************************/
+
+int msCopyProjectionExtended(projectionObj *dst, const projectionObj *src,
+                             char **args, int num_args) {
+  MS_COPYSTELEM(numargs);
+  MS_COPYSTELEM(gt);
+
+  for (int i = 0; i < dst->numargs; i++) {
+    /* Our destination consists of unallocated pointers */
+    dst->args[i] = msStrdup(src->args[i]);
+  }
+  if (args) {
+    for (int i = 0; i < num_args; i++) {
+      dst->args[dst->numargs++] = msStrdup(args[i]);
+    }
+  }
+  msProjectionInheritContextFrom(dst, src);
+  if (dst->numargs != 0) {
+    if (msProcessProjection(dst) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+  MS_COPYSTELEM(wellknownprojection);
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyProjection()                                                  *
+ *                                                                     *
+ * Copy a projectionObj                                                *
+ **********************************************************************/
+
+int msCopyProjection(projectionObj *dst, const projectionObj *src) {
+  return msCopyProjectionExtended(dst, src, NULL, 0);
+}
+
+/***********************************************************************
+ * msCopyLine()                                                        *
+ *                                                                     *
+ * Copy a lineObj, using msCopyPoint()                                 *
+ **********************************************************************/
+int msCopyLine(lineObj *dst, const lineObj *src) {
+
+  int i;
+
+  dst->numpoints = src->numpoints;
+  for (i = 0; i < dst->numpoints; i++) {
+    MS_COPYPOINT(&(dst->point[i]), &(src->point[i]));
+  }
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyShape()                                                       *
+ *                                                                     *
+ * Copy a shapeObj, using msCopyLine(), msCopyRect()                   *
+ * Not completely implemented or tested.                               *
+ **********************************************************************/
+/*
+int msCopyShapeObj(shapeObj *dst, shapeObj *src) {
+  int i;
+  copyProperty(&(dst->numlines), &(src->numlines), sizeof(int));
+  for (i = 0; i < dst->numlines; i++) {
+    msCopyLine(&(dst->line[i]), &(src->line[i]));
+  }
+  msCopyRect(&(dst->bounds), &(src->bounds));
+  copyProperty(&(dst->type), &(src->type), sizeof(int));
+  copyProperty(&(dst->index), &(src->index), sizeof(long));
+  copyProperty(&(dst->tileindex), &(src->tileindex), sizeof(int));
+  copyProperty(&(dst->classindex), &(src->classindex), sizeof(int));
+  copyStringPropertyRealloc(&(dst->text), src->text);
+  copyProperty(&(dst->numvalues), &(src->numvalues), sizeof(int));
+  for (i = 0; i < dst->numvalues; i++) {
+    copyStringPropertyRealloc(&(dst->values[i]), src->values[i]);
+  }
+
+  return(0);
+}
+*/
+
+/**********************************************************************
+ * msCopyItem()                                                        *
+ *                                                                     *
+ * Copy an itemObj                                                     *
+ **********************************************************************/
+
+int msCopyItem(itemObj *dst, const itemObj *src) {
+
+  MS_COPYSTRING(dst->name, src->name);
+  MS_COPYSTELEM(type);
+  MS_COPYSTELEM(index);
+  MS_COPYSTELEM(size);
+  MS_COPYSTELEM(numdecimals);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyHashTable()                                                   *
+ *                                                                     *
+ * Copy a hashTableObj, using msInsertHashTable()                      *
+ **********************************************************************/
+
+int msCopyHashTable(hashTableObj *dst, const hashTableObj *src) {
+  const char *key = NULL;
+  while (1) {
+    key = msNextKeyFromHashTable(src, key);
+    if (!key)
+      break;
+    else
+      msInsertHashTable(dst, key, msLookupHashTable(src, key));
+  }
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyFontSet()                                                     *
+ *                                                                     *
+ * Copy a fontSetObj, using msCreateHashTable() and msCopyHashTable()  *
+ **********************************************************************/
+
+int msCopyFontSet(fontSetObj *dst, const fontSetObj *src, mapObj *map) {
+
+  MS_COPYSTRING(dst->filename, src->filename);
+  MS_COPYSTELEM(numfonts);
+  if (msCopyHashTable(&(dst->fonts), &(src->fonts)) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  dst->map = map;
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyExpression()                                                  *
+ *                                                                     *
+ * Copy an expressionObj, but only its string, type and flags          *
+ **********************************************************************/
+
+int msCopyExpression(expressionObj *dst, const expressionObj *src) {
+  if ((dst->type == MS_REGEX) && dst->compiled)
+    ms_regfree(&(dst->regex));
+  dst->compiled = MS_FALSE;
+
+  MS_COPYSTRING(dst->string, src->string);
+  MS_COPYSTELEM(type);
+  MS_COPYSTELEM(flags);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyJoin()                                                        *
+ *                                                                     *
+ * Copy a joinObj                                                      *
+ **********************************************************************/
+
+int msCopyJoin(joinObj *dst, const joinObj *src) {
+  MS_COPYSTRING(dst->name, src->name);
+
+  /* makes no sense to copy the items or values
+     since they are runtime additions to the mapfile */
+
+  MS_COPYSTRING(dst->table, src->table);
+  MS_COPYSTRING(dst->from, src->from);
+  MS_COPYSTRING(dst->to, src->to);
+  MS_COPYSTRING(dst->header, src->header);
+#ifndef __cplusplus
+  MS_COPYSTRING(dst->template, src->template);
+#else
+  MS_COPYSTRING(dst->_template, src->_template);
+#endif
+  MS_COPYSTRING(dst->footer, src->footer);
+  dst->type = src->type;
+  MS_COPYSTRING(dst->connection, src->connection);
+
+  MS_COPYSTELEM(connectiontype);
+
+  /* TODO: need to handle joininfo (probably should be just set to NULL) */
+  dst->joininfo = NULL;
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyQueryMap()                                                    *
+ *                                                                     *
+ * Copy a queryMapObj, using msCopyColor()                             *
+ **********************************************************************/
+
+int msCopyQueryMap(queryMapObj *dst, const queryMapObj *src) {
+  MS_COPYSTELEM(height);
+  MS_COPYSTELEM(width);
+  MS_COPYSTELEM(status);
+  MS_COPYSTELEM(style);
+  MS_COPYCOLOR(&(dst->color), &(src->color));
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyLeader()                                                      *
+ *                                                                     *
+ * Copy a labelLeaderObj, using msCopyStyle()                          *
+ **********************************************************************/
+
+int msCopyLabelLeader(labelLeaderObj *dst, const labelLeaderObj *src) {
+  int i;
+  assert(dst && src);
+  MS_COPYSTELEM(gridstep);
+  MS_COPYSTELEM(maxdistance);
+  /*
+   ** now the styles
+   */
+
+  /* free any previous styles on the dst label */
+  for (i = 0; i < dst->numstyles; i++) { /* each style */
+    if (dst->styles[i] != NULL) {
+      if (freeStyle(dst->styles[i]) == MS_SUCCESS)
+        msFree(dst->styles[i]);
+    }
+  }
+  dst->numstyles = 0;
+
+  for (i = 0; i < src->numstyles; i++) {
+    if (msGrowLeaderStyles(dst) == NULL)
+      return MS_FAILURE;
+    if (initStyle(dst->styles[i]) != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to init style.", "msCopyLabel()");
+      return MS_FAILURE;
+    }
+    if (msCopyStyle(dst->styles[i], src->styles[i]) != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to copy style.", "msCopyLabel()");
+      return MS_FAILURE;
+    }
+    dst->numstyles++;
+  }
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyLabel()                                                       *
+ *                                                                     *
+ * Copy a labelObj, using msCopyColor() and msCopyStyle()              *
+ **********************************************************************/
+
+int msCopyLabel(labelObj *dst, const labelObj *src) {
+  int i;
+
+  for (i = 0; i < MS_LABEL_BINDING_LENGTH; i++) {
+    MS_COPYSTRING(dst->bindings[i].item, src->bindings[i].item);
+    dst->bindings[i].index =
+        src->bindings[i].index; /* no way to use the macros */
+    MS_COPYSTRING(dst->exprBindings[i].string, src->exprBindings[i].string);
+    dst->exprBindings[i].type = src->exprBindings[i].type;
+  }
+  MS_COPYSTELEM(numbindings);
+  MS_COPYSTELEM(nexprbindings);
+
+  MS_COPYSTRING(dst->font, src->font);
+
+  MS_COPYCOLOR(&(dst->color), &(src->color));
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
+  MS_COPYCOLOR(&(dst->shadowcolor), &(src->shadowcolor));
+
+  MS_COPYSTELEM(shadowsizex);
+  MS_COPYSTELEM(shadowsizey);
+
+  MS_COPYSTELEM(size);
+  MS_COPYSTELEM(minsize);
+  MS_COPYSTELEM(maxsize);
+  MS_COPYSTELEM(position);
+  MS_COPYSTELEM(offsetx);
+  MS_COPYSTELEM(offsety);
+  MS_COPYSTELEM(angle);
+  MS_COPYSTELEM(anglemode);
+  MS_COPYSTELEM(buffer);
+  MS_COPYSTELEM(wrap);
+  MS_COPYSTELEM(align);
+  MS_COPYSTELEM(maxlength);
+  MS_COPYSTELEM(minfeaturesize);
+
+  MS_COPYSTELEM(minscaledenom);
+  MS_COPYSTELEM(maxscaledenom);
+
+  MS_COPYSTELEM(autominfeaturesize);
+
+  MS_COPYSTELEM(mindistance);
+  MS_COPYSTELEM(partials);
+  MS_COPYSTELEM(force);
+  MS_COPYSTELEM(priority);
+
+  MS_COPYSTELEM(repeatdistance);
+  MS_COPYSTELEM(maxoverlapangle);
+
+  MS_COPYSTRING(dst->encoding, src->encoding);
+
+  MS_COPYSTELEM(outlinewidth);
+  MS_COPYSTELEM(space_size_10);
+
+  if (msCopyExpression(&(dst->expression), &(src->expression)) != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy expression.", "msCopyLabel()");
+    return MS_FAILURE;
+  }
+
+  if (msCopyExpression(&(dst->text), &(src->text)) != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy text.", "msCopyLabel()");
+    return MS_FAILURE;
+  }
+
+  /*
+  ** now the styles
+  */
+
+  /* free any previous styles on the dst label */
+  for (i = 0; i < dst->numstyles; i++) { /* each style */
+    if (dst->styles[i] != NULL) {
+      if (freeStyle(dst->styles[i]) == MS_SUCCESS)
+        msFree(dst->styles[i]);
+    }
+  }
+  dst->numstyles = 0;
+
+  for (i = 0; i < src->numstyles; i++) {
+    if (msGrowLabelStyles(dst) == NULL)
+      return MS_FAILURE;
+    if (initStyle(dst->styles[i]) != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to init style.", "msCopyLabel()");
+      return MS_FAILURE;
+    }
+    if (msCopyStyle(dst->styles[i], src->styles[i]) != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to copy style.", "msCopyLabel()");
+      return MS_FAILURE;
+    }
+    dst->numstyles++;
+  }
+
+  if (src->leader) {
+    dst->leader = msSmallMalloc(sizeof(labelLeaderObj));
+    initLeader(dst->leader);
+    msCopyLabelLeader(dst->leader, src->leader);
+  } else {
+    if (dst->leader) {
+      freeLabelLeader(dst->leader);
+      msFree(dst->leader);
+    }
+    dst->leader = NULL;
+  }
+
+  MS_COPYSTELEM(sizeunits);
+  MS_COPYSTELEM(scalefactor);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyWeb()                                                         *
+ *                                                                     *
+ * Copy webObj, using msCopyRect(), msCreateHashTable(), and           *
+ * msCopyHashTable()                                                   *
+ **********************************************************************/
+
+int msCopyWeb(webObj *dst, const webObj *src, mapObj *map) {
+
+  MS_COPYSTRING(dst->imagepath, src->imagepath);
+  MS_COPYSTRING(dst->imageurl, src->imageurl);
+  dst->map = map;
+#ifndef __cplusplus
+  MS_COPYSTRING(dst->template, src->template);
+#else
+  MS_COPYSTRING(dst->_template, src->_template);
+#endif
+  MS_COPYSTRING(dst->header, src->header);
+  MS_COPYSTRING(dst->footer, src->footer);
+  MS_COPYSTRING(dst->empty, src->empty);
+  MS_COPYSTRING(dst->error, src->error);
+
+  MS_COPYSTELEM(minscaledenom);
+  MS_COPYSTELEM(maxscaledenom);
+  MS_COPYSTRING(dst->mintemplate, src->mintemplate);
+  MS_COPYSTRING(dst->maxtemplate, src->maxtemplate);
+
+  if (msCopyHashTable(&(dst->metadata), &(src->metadata)) != MS_SUCCESS)
+    return MS_FAILURE;
+  msCopyHashTable(&dst->validation, &src->validation);
+
+  MS_COPYSTRING(dst->queryformat, src->queryformat);
+  MS_COPYSTRING(dst->legendformat, src->legendformat);
+  MS_COPYSTRING(dst->browseformat, src->browseformat);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyStyle()                                                       *
+ *                                                                     *
+ * Copy a styleObj, using msCopyColor()                                *
+ **********************************************************************/
+
+int msCopyStyle(styleObj *dst, const styleObj *src) {
+  int i;
+
+  for (i = 0; i < MS_STYLE_BINDING_LENGTH; i++) {
+    MS_COPYSTRING(dst->bindings[i].item, src->bindings[i].item);
+    dst->bindings[i].index =
+        src->bindings[i].index; /* no way to use the macros */
+    MS_COPYSTRING(dst->exprBindings[i].string, src->exprBindings[i].string);
+    dst->exprBindings[i].type = src->exprBindings[i].type;
+  }
+  MS_COPYSTELEM(numbindings);
+  MS_COPYSTELEM(nexprbindings);
+
+  MS_COPYCOLOR(&(dst->color), &(src->color));
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
+
+  MS_COPYCOLOR(&(dst->mincolor), &(src->mincolor));
+  MS_COPYCOLOR(&(dst->maxcolor), &(src->maxcolor));
+
+  MS_COPYSTRING(dst->symbolname, src->symbolname);
+  MS_COPYSTELEM(patternlength);
+  for (i = 0; i < src->patternlength; i++)
+    dst->pattern[i] = src->pattern[i];
+  MS_COPYSTELEM(initialgap);
+  MS_COPYSTELEM(gap);
+  MS_COPYSTELEM(linejoin);
+  MS_COPYSTELEM(linejoinmaxsize);
+  MS_COPYSTELEM(antialiased);
+  MS_COPYSTELEM(linecap);
+  MS_COPYSTELEM(symbol);
+  MS_COPYSTELEM(size);
+  MS_COPYSTELEM(minsize);
+  MS_COPYSTELEM(maxsize);
+  MS_COPYSTELEM(width);
+  MS_COPYSTELEM(minwidth);
+  MS_COPYSTELEM(maxwidth);
+  MS_COPYSTELEM(offsetx);
+  MS_COPYSTELEM(offsety);
+  MS_COPYSTELEM(angle);
+  MS_COPYSTELEM(autoangle);
+  MS_COPYSTELEM(minvalue);
+  MS_COPYSTELEM(maxvalue);
+  MS_COPYSTELEM(opacity);
+  MS_COPYSTRING(dst->_geomtransform.string, src->_geomtransform.string);
+  MS_COPYSTELEM(_geomtransform.type);
+  MS_COPYSTRING(dst->rangeitem, src->rangeitem);
+  MS_COPYSTELEM(rangeitemindex);
+  MS_COPYSTELEM(outlinewidth);
+  MS_COPYSTELEM(minscaledenom);
+  MS_COPYSTELEM(maxscaledenom);
+  /* TODO: add copy for bindings */
+
+  MS_COPYSTELEM(sizeunits);
+  MS_COPYSTELEM(scalefactor);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyClass()                                                       *
+ *                                                                     *
+ * Copy a classObj, using msCopyExpression(), msCopyStyle(),           *
+ * msCopyLabel(), msCreateHashTable(), msCopyHashTable()               *
+ **********************************************************************/
+
+int msCopyClass(classObj *dst, const classObj *src, layerObj *layer_unused) {
+  int i, return_value;
+  (void)layer_unused;
+
+  return_value = msCopyExpression(&(dst->expression), &(src->expression));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy expression.", "msCopyClass()");
+    return MS_FAILURE;
+  }
+
+  MS_COPYSTELEM(status);
+  MS_COPYSTELEM(isfallback);
+
+  /* free any previous styles on the dst layer */
+  for (i = 0; i < dst->numstyles; i++) { /* each style */
+    if (dst->styles[i] != NULL) {
+      if (freeStyle(dst->styles[i]) == MS_SUCCESS) {
+        msFree(dst->styles[i]);
+      }
+    }
+  }
+  dst->numstyles = 0;
+
+  for (i = 0; i < src->numstyles; i++) {
+    if (msGrowClassStyles(dst) == NULL)
+      return MS_FAILURE;
+    if (initStyle(dst->styles[i]) != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to init style.", "msCopyClass()");
+      return MS_FAILURE;
+    }
+    if (msCopyStyle(dst->styles[i], src->styles[i]) != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to copy style.", "msCopyClass()");
+      return MS_FAILURE;
+    }
+
+    dst->numstyles++;
+  }
+
+  for (i = 0; i < src->numlabels; i++) {
+    if (msGrowClassLabels(dst) == NULL)
+      return MS_FAILURE;
+    initLabel(dst->labels[i]);
+    if (msCopyLabel(dst->labels[i], src->labels[i]) != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to copy label.", "msCopyClass()");
+      return MS_FAILURE;
+    }
+
+    dst->numlabels++;
+  }
+  MS_COPYSTELEM(numlabels);
+
+  if (src->leader) {
+    if (dst->leader) {
+      freeLabelLeader(dst->leader);
+    }
+    if (!dst->leader) {
+      dst->leader = msSmallMalloc(sizeof(labelLeaderObj));
+      initLeader(dst->leader);
+    }
+    msCopyLabelLeader(dst->leader, src->leader);
+  }
+
+  MS_COPYSTRING(dst->keyimage, src->keyimage);
+  MS_COPYSTRING(dst->name, src->name);
+  MS_COPYSTRING(dst->title, src->title);
+  MS_COPYSTRING(dst->group, src->group);
+
+  if (msCopyExpression(&(dst->text), &(src->text)) != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy text.", "msCopyClass()");
+    return MS_FAILURE;
+  }
+
+#ifndef __cplusplus
+  MS_COPYSTRING(dst->template, src->template);
+#else
+  MS_COPYSTRING(dst->_template, src->_template);
+#endif
+
+  msCopyHashTable(&(dst->metadata), &(src->metadata));
+  msCopyHashTable(&dst->validation, &src->validation);
+
+  MS_COPYSTELEM(minscaledenom);
+  MS_COPYSTELEM(maxscaledenom);
+  MS_COPYSTELEM(layer);
+  MS_COPYSTELEM(debug);
+
+  MS_COPYSTELEM(sizeunits);
+  MS_COPYSTELEM(scalefactor);
+
+  return MS_SUCCESS;
+}
+
+int msCopyCluster(clusterObj *dst, const clusterObj *src) {
+  int return_value;
+
+  MS_COPYSTELEM(maxdistance);
+  MS_COPYSTELEM(buffer);
+  MS_COPYSTRING(dst->region, src->region);
+
+  return_value = msCopyExpression(&(dst->group), &(src->group));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy cluster group.", "msCopyCluster()");
+    return MS_FAILURE;
+  }
+
+  return_value = msCopyExpression(&(dst->filter), &(src->filter));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy cluster filter.", "msCopyCluster()");
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyGrid()                                                        *
+ **********************************************************************/
+
+int msCopyGrid(graticuleObj *dst, const graticuleObj *src) {
+  MS_COPYSTELEM(dwhichlatitude);
+  MS_COPYSTELEM(dwhichlongitude);
+  MS_COPYSTELEM(dstartlatitude);
+  MS_COPYSTELEM(dstartlongitude);
+  MS_COPYSTELEM(dendlatitude);
+  MS_COPYSTELEM(dendlongitude);
+  MS_COPYSTELEM(dincrementlatitude);
+  MS_COPYSTELEM(dincrementlongitude);
+  MS_COPYSTELEM(minarcs);
+  MS_COPYSTELEM(maxarcs);
+  MS_COPYSTELEM(minincrement);
+  MS_COPYSTELEM(maxincrement);
+  MS_COPYSTELEM(minsubdivides);
+  MS_COPYSTELEM(maxsubdivides);
+  MS_COPYSTELEM(bvertical);
+  MS_COPYSTELEM(blabelaxes);
+  MS_COPYSTELEM(ilabelstate);
+  MS_COPYSTELEM(ilabeltype);
+  MS_COPYRECT(&(dst->extent), &(src->extent));
+  MS_COPYSTRING(dst->labelformat, src->labelformat);
+
+  return MS_SUCCESS;
+}
+
+#ifdef why_on_earth_would_you_copy_a_labelcache
+
+/***********************************************************************
+ * msCopyLabelCacheMember()                                            *
+ *                                                                     *
+ * Copy a labelCacheMemberObj using msCopyStyle(), msCopyPoint()       *
+ *                                                                     *
+ * Note: since it seems most users will want to clone maps rather than *
+ * make exact copies, this method might not get much use.              *
+ **********************************************************************/
+
+int msCopyLabelCacheMember(labelCacheMemberObj *dst,
+                           const labelCacheMemberObj *src) {
+  int i;
+
+  MS_COPYSTELEM(featuresize);
+
+  MS_COPYSTELEM(numstyles);
+  for (i = 0; i < dst->numstyles; i++) {
+    msCopyStyle(&(dst->styles[i]), &(src->styles[i]));
+  }
+
+  MS_COPYSTELEM(numlabels);
+  dst->labels = (labelObj *)msSmallMalloc(sizeof(labelObj) * dst->numlabels);
+  for (i = 0; i < dst->numlabels; i++) {
+    msCopyLabel(&(dst->labels[i]), &(src->labels[i]));
+  }
+
+  MS_COPYSTELEM(layerindex);
+  MS_COPYSTELEM(classindex);
+  MS_COPYSTELEM(tileindex);
+  MS_COPYSTELEM(shapeindex);
+  MS_COPYPOINT(&(dst->point), &(src->point));
+  /* msCopyShape(&(dst->poly), &(src->poly)); */
+  MS_COPYSTELEM(status);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyMarkerCacheMember()                                           *
+ *                                                                     *
+ * Copy a markerCacheMemberObj                                         *
+ **********************************************************************/
+
+int msCopyMarkerCacheMember(markerCacheMemberObj *dst,
+                            const markerCacheMemberObj *src) {
+  MS_COPYSTELEM(id);
+
+  /* msCopyShape(&(dst->poly), &(src->poly)); */
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyLabelCacheSlot()                                                  *
+ **********************************************************************/
+
+int msCopyLabelCacheSlot(labelCacheSlotObj *dst, const labelCacheSlotObj *src) {
+  int i;
+
+  for (i = 0; i < dst->numlabels; i++) {
+    msCopyLabelCacheMember(&(dst->labels[i]), &(src->labels[i]));
+  }
+  MS_COPYSTELEM(cachesize);
+  MS_COPYSTELEM(nummarkers);
+  for (i = 0; i < dst->nummarkers; i++) {
+    msCopyMarkerCacheMember(&(dst->markers[i]), &(src->markers[i]));
+  }
+  MS_COPYSTELEM(markercachesize);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyLabelCache()                                                  *
+ **********************************************************************/
+
+int msCopyLabelCache(labelCacheObj *dst, const labelCacheObj *src) {
+  int p;
+  MS_COPYSTELEM(numlabels);
+
+  for (p = 0; p < MS_MAX_LABEL_PRIORITY; p++) {
+    msCopyLabelCacheSlot(&(dst->slots[p]), &(src->slots[p]));
+  }
+
+  return MS_SUCCESS;
+}
+
+#endif
+
+/***********************************************************************
+ * msCopyResult()                                                      *
+ **********************************************************************/
+
+int msCopyResult(resultObj *dst, const resultObj *src) {
+  MS_COPYSTELEM(shapeindex);
+  MS_COPYSTELEM(tileindex);
+  MS_COPYSTELEM(classindex);
+  MS_COPYSTELEM(resultindex);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyResultCache()                                                 *
+ **********************************************************************/
+
+int msCopyResultCache(resultCacheObj *dst, const resultCacheObj *src) {
+  int i;
+  MS_COPYSTELEM(cachesize);
+  MS_COPYSTELEM(numresults);
+  for (i = 0; i < dst->numresults; i++) {
+    msCopyResult(&(dst->results[i]), &(src->results[i]));
+  }
+  MS_COPYRECT(&(dst->bounds), &(src->bounds));
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyReferenceMap()                                                *
+ *                                                                     *
+ * Copy a referenceMapObj using mapfile.c:initReferenceMap(),          *
+ * msCopyRect(), msCopyColor()                                         *
+ **********************************************************************/
+
+int msCopyReferenceMap(referenceMapObj *dst, const referenceMapObj *src,
+                       mapObj *map) {
+
+  initReferenceMap(dst);
+
+  MS_COPYRECT(&(dst->extent), &(src->extent));
+
+  MS_COPYSTELEM(height);
+  MS_COPYSTELEM(width);
+
+  MS_COPYCOLOR(&(dst->color), &(src->color));
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
+  MS_COPYSTRING(dst->image, src->image);
+
+  MS_COPYSTELEM(status);
+  MS_COPYSTELEM(marker);
+  MS_COPYSTRING(dst->markername, src->markername);
+  MS_COPYSTELEM(markersize);
+  MS_COPYSTELEM(minboxsize);
+  MS_COPYSTELEM(maxboxsize);
+  dst->map = map;
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyScalebar()                                                    *
+ *                                                                     *
+ * Copy a scalebarObj, using initScalebar(), msCopyColor(),            *
+ * and msCopyLabel()                                                   *
+ **********************************************************************/
+
+int msCopyScalebar(scalebarObj *dst, const scalebarObj *src) {
+
+  initScalebar(dst);
+
+  MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
+  MS_COPYSTELEM(height);
+  MS_COPYSTELEM(width);
+  MS_COPYSTELEM(style);
+  MS_COPYSTELEM(intervals);
+
+  if (msCopyLabel(&(dst->label), &(src->label)) != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy label.", "msCopyScalebar()");
+    return MS_FAILURE;
+  }
+
+  MS_COPYCOLOR(&(dst->color), &(src->color));
+  MS_COPYCOLOR(&(dst->backgroundcolor), &(src->backgroundcolor));
+
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
+
+  MS_COPYSTELEM(units);
+  MS_COPYSTELEM(status);
+  MS_COPYSTELEM(position);
+  MS_COPYSTELEM(transparent);
+  MS_COPYSTELEM(postlabelcache);
+  MS_COPYSTELEM(align);
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyLegend()                                                      *
+ *                                                                     *
+ * Copy a legendObj, using msCopyColor()                               *
+ **********************************************************************/
+
+int msCopyLegend(legendObj *dst, const legendObj *src, mapObj *map) {
+  int return_value;
+
+  MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
+
+  return_value = msCopyLabel(&(dst->label), &(src->label));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy label.", "msCopyLegend()");
+    return MS_FAILURE;
+  }
+
+  MS_COPYSTELEM(keysizex);
+  MS_COPYSTELEM(keysizey);
+  MS_COPYSTELEM(keyspacingx);
+  MS_COPYSTELEM(keyspacingy);
+
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
+
+  MS_COPYSTELEM(status);
+  MS_COPYSTELEM(height);
+  MS_COPYSTELEM(width);
+  MS_COPYSTELEM(position);
+  MS_COPYSTELEM(transparent);
+  MS_COPYSTELEM(postlabelcache);
+
+#ifndef __cplusplus
+  MS_COPYSTRING(dst->template, src->template);
+#else
+  MS_COPYSTRING(dst->_template, src->_template);
+#endif
+  dst->map = map;
+
+  return MS_SUCCESS;
+}
+
+int msCopyScaleTokenEntry(const scaleTokenEntryObj *src,
+                          scaleTokenEntryObj *dst) {
+  MS_COPYSTRING(dst->value, src->value);
+  MS_COPYSTELEM(minscale);
+  MS_COPYSTELEM(maxscale);
+  return MS_SUCCESS;
+}
+
+int msCopyScaleToken(const scaleTokenObj *src, scaleTokenObj *dst) {
+  int i;
+  MS_COPYSTRING(dst->name, src->name);
+  MS_COPYSTELEM(n_entries);
+  dst->tokens = (scaleTokenEntryObj *)msSmallCalloc(src->n_entries,
+                                                    sizeof(scaleTokenEntryObj));
+  for (i = 0; i < src->n_entries; i++) {
+    msCopyScaleTokenEntry(&src->tokens[i], &dst->tokens[i]);
+  }
+  return MS_SUCCESS;
+}
+
+int msCopyCompositingFilter(CompositingFilter **pdst,
+                            const CompositingFilter *src) {
+  CompositingFilter *dst = NULL;
+  if (!src) {
+    *pdst = NULL;
+    return MS_SUCCESS;
+  }
+  while (src) {
+    if (!dst) {
+      dst = *pdst = msSmallMalloc(sizeof(CompositingFilter));
+    } else {
+      dst->next = msSmallMalloc(sizeof(CompositingFilter));
+      dst = dst->next;
+    }
+    dst->filter = msStrdup(src->filter);
+    dst->next = NULL;
+    src = src->next;
+  }
+  return MS_SUCCESS;
+}
+
+int msCopyCompositer(LayerCompositer **ldst, const LayerCompositer *src) {
+  LayerCompositer *dst = NULL;
+  if (!src) {
+    *ldst = NULL;
+    return MS_SUCCESS;
+  }
+
+  while (src) {
+    if (!dst) {
+      dst = *ldst = msSmallMalloc(sizeof(LayerCompositer));
+    } else {
+      dst->next = msSmallMalloc(sizeof(LayerCompositer));
+      dst = dst->next;
+    }
+    dst->comp_op = src->comp_op;
+    dst->opacity = src->opacity;
+    dst->next = NULL;
+    msCopyCompositingFilter(&dst->filter, src->filter);
+    src = src->next;
+  }
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyLayer()                                                       *
+ *                                                                     *
+ * Copy a layerObj, using mapfile.c:initClass(), msCopyClass(),        *
+ * msCopyColor(), msCopyProjection(), msShapefileOpen(),                 *
+ * msCreateHashTable(), msCopyHashTable(), msCopyExpression()          *
+ *                                                                     *
+ * As it stands, we are not copying a layer's resultcache              *
+ **********************************************************************/
+
+int msCopyLayer(layerObj *dst, const layerObj *src) {
+  int i, return_value;
+  featureListNodeObjPtr current;
+
+  MS_COPYSTELEM(index);
+  MS_COPYSTRING(dst->classitem, src->classitem);
+
+  MS_COPYSTELEM(classitemindex);
+
+  for (i = 0; i < src->numscaletokens; i++) {
+    if (msGrowLayerScaletokens(dst) == NULL)
+      return MS_FAILURE;
+    initScaleToken(&dst->scaletokens[i]);
+    msCopyScaleToken(&src->scaletokens[i], &dst->scaletokens[i]);
+    dst->numscaletokens++;
+  }
+
+  for (i = 0; i < src->numclasses; i++) {
+    if (msGrowLayerClasses(dst) == NULL)
+      return MS_FAILURE;
+#ifndef __cplusplus
+    initClass(dst->class[i]);
+    return_value = msCopyClass(dst->class[i], src -> class[i], dst);
+#else
+    initClass(dst->_class[i]);
+    return_value = msCopyClass(dst->_class[i], src->_class[i], dst);
+#endif
+    if (return_value != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to copy class.", "msCopyLayer()");
+      return MS_FAILURE;
+    }
+    dst->numclasses++;
+  }
+  MS_COPYSTRING(dst->header, src->header);
+  MS_COPYSTRING(dst->footer, src->footer);
+#ifndef __cplusplus
+  MS_COPYSTRING(dst->template, src->template);
+#else
+  MS_COPYSTRING(dst->_template, src->_template);
+#endif
+
+  MS_COPYSTRING(dst->name, src->name);
+  MS_COPYSTRING(dst->group, src->group);
+  MS_COPYSTRING(dst->data, src->data);
+  MS_COPYSTRING(dst->encoding, src->encoding);
+
+  MS_COPYSTELEM(rendermode);
+  MS_COPYSTELEM(status);
+  MS_COPYSTELEM(type);
+  MS_COPYSTELEM(tolerance);
+  MS_COPYSTELEM(toleranceunits);
+  MS_COPYSTELEM(symbolscaledenom);
+  MS_COPYSTELEM(scalefactor);
+  MS_COPYSTELEM(minscaledenom);
+  MS_COPYSTELEM(maxscaledenom);
+
+  MS_COPYSTELEM(labelminscaledenom);
+  MS_COPYSTELEM(labelmaxscaledenom);
+  MS_COPYSTELEM(mingeowidth);
+  MS_COPYSTELEM(maxgeowidth);
+
+  MS_COPYSTELEM(sizeunits);
+  MS_COPYSTELEM(maxfeatures);
+
+  MS_COPYCOLOR(&(dst->offsite), &(src->offsite));
+
+  MS_COPYSTELEM(transform);
+  MS_COPYSTELEM(labelcache);
+  MS_COPYSTELEM(postlabelcache);
+
+  MS_COPYSTRING(dst->labelitem, src->labelitem);
+  MS_COPYSTELEM(labelitemindex);
+
+  MS_COPYSTRING(dst->tileitem, src->tileitem);
+  MS_COPYSTELEM(tileitemindex);
+
+  MS_COPYSTRING(dst->tilesrs, src->tilesrs);
+
+  MS_COPYSTRING(dst->tileindex, src->tileindex);
+
+  return_value = msCopyProjection(&(dst->projection), &(src->projection));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy projection.", "msCopyLayer()");
+    return MS_FAILURE;
+  }
+
+  return_value = msCopyCluster(&(dst->cluster), &(src->cluster));
+  if (return_value != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  MS_COPYSTELEM(project);
+  MS_COPYSTELEM(units);
+
+  current = src->features;
+  while (current != NULL) {
+    insertFeatureList(&(dst->features), &(current->shape));
+    current = current->next;
+  }
+
+  MS_COPYSTRING(dst->connection, src->connection);
+  MS_COPYSTELEM(connectiontype);
+
+  MS_COPYSTRING(dst->plugin_library, src->plugin_library);
+  MS_COPYSTRING(dst->plugin_library_original, src->plugin_library_original);
+
+  /* Do not copy *layerinfo, items, or iteminfo. these are all initialized
+     when the copied layer is opened */
+
+  return_value = msCopyExpression(&(dst->filter), &(src->filter));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy filter.", "msCopyLayer()");
+    return MS_FAILURE;
+  }
+
+  MS_COPYSTRING(dst->filteritem, src->filteritem);
+  MS_COPYSTELEM(filteritemindex);
+
+  MS_COPYSTRING(dst->styleitem, src->styleitem);
+  MS_COPYSTELEM(styleitemindex);
+
+  MS_COPYSTRING(dst->requires, src->requires);
+  MS_COPYSTRING(dst->labelrequires, src->labelrequires);
+
+  msCopyHashTable(&(dst->metadata), &(src->metadata));
+  msCopyHashTable(&dst->validation, &src->validation);
+  msCopyHashTable(&dst->connectionoptions, &src->connectionoptions);
+
+  MS_COPYSTELEM(debug);
+
+  /* No need to copy the numprocessing member, as it is incremented by
+     msLayerAddProcessing */
+  for (i = 0; i < src->numprocessing; i++) {
+    msLayerAddProcessing(dst, msLayerGetProcessing(src, i));
+  }
+
+  MS_COPYSTELEM(numjoins);
+
+  for (i = 0; i < dst->numjoins; i++) {
+    initJoin(&(dst->joins[i]));
+    return_value = msCopyJoin(&(dst->joins[i]), &(src->joins[i]));
+    if (return_value != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  MS_COPYRECT(&(dst->extent), &(src->extent));
+
+  MS_COPYSTRING(dst->classgroup, src->classgroup);
+  MS_COPYSTRING(dst->mask, src->mask);
+
+  if (src->grid) {
+    if (dst->grid) {
+      freeGrid(dst->grid);
+      msFree(dst->grid);
+    }
+    dst->grid = (void *)malloc(sizeof(graticuleObj));
+    MS_CHECK_ALLOC(dst->grid, sizeof(graticuleObj), -1);
+    initGrid(dst->grid);
+    msCopyGrid(dst->grid, src->grid);
+  }
+
+  if (src->compositer) {
+    msCopyCompositer(&dst->compositer, src->compositer);
+  }
+
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopyMap()                                                         *
+ *                                                                     *
+ * Copy a mapObj, using mapfile.c:initLayer(), msCopyLayer(),          *
+
+ * msCopyLegend(), msCopyScalebar(), msCopyProjection()                *
+ * msCopyOutputFormat(), msCopyWeb(), msCopyReferenceMap()             *
+ **********************************************************************/
+
+int msCopyMap(mapObj *dst, const mapObj *src) {
+  int i, return_value;
+  outputFormatObj *format;
+
+  MS_COPYSTRING(dst->name, src->name);
+  MS_COPYSTELEM(status);
+  MS_COPYSTELEM(height);
+  MS_COPYSTELEM(width);
+  MS_COPYSTELEM(maxsize);
+
+  for (i = 0; i < src->numlayers; i++) {
+    if (msGrowMapLayers(dst) == NULL)
+      return MS_FAILURE;
+    initLayer((GET_LAYER(dst, i)), dst);
+
+    return_value = msCopyLayer((GET_LAYER(dst, i)), (GET_LAYER(src, i)));
+    if (return_value != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to copy layer.", "msCopyMap()");
+      return MS_FAILURE;
+    }
+    dst->numlayers++;
+  }
+
+  return_value = msCopyFontSet(&(dst->fontset), &(src->fontset), dst);
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy fontset.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  return_value = msCopySymbolSet(&(dst->symbolset), &(src->symbolset), dst);
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy symbolset.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  /* msCopyLabelCache(&(dst->labelcache), &(src->labelcache)); */
+  MS_COPYRECT(&(dst->extent), &(src->extent));
+
+  MS_COPYSTELEM(cellsize);
+  MS_COPYSTELEM(units);
+  MS_COPYSTELEM(scaledenom);
+  MS_COPYSTELEM(defresolution);
+  MS_COPYSTELEM(resolution);
+  MS_COPYSTRING(dst->shapepath, src->shapepath);
+  MS_COPYSTRING(dst->mappath, src->mappath);
+  MS_COPYSTELEM(sldurl);
+
+  MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
+
+  /* clear existing destination format list */
+  if (dst->outputformat && --dst->outputformat->refcount < 1) {
+    msFreeOutputFormat(dst->outputformat);
+    dst->outputformat = NULL;
+  }
+
+  for (i = 0; i < dst->numoutputformats; i++) {
+    if (--dst->outputformatlist[i]->refcount < 1)
+      msFreeOutputFormat(dst->outputformatlist[i]);
+  }
+  if (dst->outputformatlist != NULL)
+    msFree(dst->outputformatlist);
+  dst->outputformatlist = NULL;
+  dst->outputformat = NULL;
+  dst->numoutputformats = 0;
+
+  for (i = 0; i < src->numoutputformats; i++)
+    msAppendOutputFormat(dst, msCloneOutputFormat(src->outputformatlist[i]));
+
+  /* set the active output format */
+  MS_COPYSTRING(dst->imagetype, src->imagetype);
+  format = msSelectOutputFormat(dst, dst->imagetype);
+  msApplyOutputFormat(&(dst->outputformat), format, MS_NOOVERRIDE);
+
+  return_value = msCopyProjection(&(dst->projection), &(src->projection));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy projection.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  /* No need to copy latlon projection */
+
+  return_value = msCopyReferenceMap(&(dst->reference), &(src->reference), dst);
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy reference.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  return_value = msCopyScalebar(&(dst->scalebar), &(src->scalebar));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy scalebar.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  return_value = msCopyLegend(&(dst->legend), &(src->legend), dst);
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy legend.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  return_value = msCopyQueryMap(&(dst->querymap), &(src->querymap));
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy querymap.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  return_value = msCopyWeb(&(dst->web), &(src->web), dst);
+  if (return_value != MS_SUCCESS) {
+    msSetError(MS_MEMERR, "Failed to copy web.", "msCopyMap()");
+    return MS_FAILURE;
+  }
+
+  if (src->layerorder) {
+    for (i = 0; i < dst->numlayers; i++) {
+      MS_COPYSTELEM(layerorder[i]);
+    }
+  }
+  MS_COPYSTELEM(debug);
+  MS_COPYSTRING(dst->datapattern, src->datapattern);
+  MS_COPYSTRING(dst->templatepattern, src->templatepattern);
+
+  if (msCopyHashTable(&(dst->configoptions), &(src->configoptions)) !=
+      MS_SUCCESS)
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+int msCopyRasterBuffer(rasterBufferObj *dst, const rasterBufferObj *src) {
+  *dst = *src;
+  if (src->type == MS_BUFFER_BYTE_RGBA) {
+    dst->data.rgba = src->data.rgba;
+    dst->data.rgba.pixels =
+        msSmallMalloc(((size_t)src->height) * src->data.rgba.row_step);
+    memcpy(dst->data.rgba.pixels, src->data.rgba.pixels,
+           ((size_t)src->data.rgba.row_step) * src->height);
+    dst->data.rgba.r =
+        dst->data.rgba.pixels + (src->data.rgba.r - src->data.rgba.pixels);
+    dst->data.rgba.g =
+        dst->data.rgba.pixels + (src->data.rgba.g - src->data.rgba.pixels);
+    dst->data.rgba.b =
+        dst->data.rgba.pixels + (src->data.rgba.b - src->data.rgba.pixels);
+    if (src->data.rgba.a) {
+      dst->data.rgba.a =
+          dst->data.rgba.pixels + (src->data.rgba.a - src->data.rgba.pixels);
+    } else {
+      dst->data.rgba.a = NULL;
+    }
+  }
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapcopy.h 8.2.0~beta1-1~exp1/src/mapcopy.h
--- 8.0.1-5/src/mapcopy.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcopy.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,70 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Declarations related to copyng mapObjs.  Provided by Mladen Turk
+ *           for resolution of bug 701
+ *           http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=701.
+ * Author:   Mladen Turk (and Sean Gilles?)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/* Following works for GCC and MSVC.  That's ~98% of our users, if Tyler
+ * Mitchell's survey is correct
+ */
+#define MS_COPYSTELEM(_name) (dst)->/**/ _name = (src)->/**/ _name
+
+#define MS_MACROBEGIN do {
+#define MS_MACROEND                                                            \
+  }                                                                            \
+  while (0)
+
+#define MS_COPYRECT(_dst, _src)                                                \
+  MS_MACROBEGIN(_dst)->minx = (_src)->minx;                                    \
+  (_dst)->miny = (_src)->miny;                                                 \
+  (_dst)->maxx = (_src)->maxx;                                                 \
+  (_dst)->maxy = (_src)->maxy;                                                 \
+  MS_MACROEND
+
+#define MS_COPYPOINT(_dst, _src)                                               \
+  MS_MACROBEGIN(_dst)->x = (_src)->x;                                          \
+  (_dst)->y = (_src)->y;                                                       \
+  (_dst)->m = (_src)->m;                                                       \
+  MS_MACROEND
+
+#define MS_COPYCOLOR(_dst, _src)                                               \
+  MS_MACROBEGIN(_dst)->red = (_src)->red;                                      \
+  (_dst)->green = (_src)->green;                                               \
+  (_dst)->blue = (_src)->blue;                                                 \
+  (_dst)->alpha = (_src)->alpha;                                               \
+  MS_MACROEND
+
+#define MS_COPYSTRING(_dst, _src)                                              \
+  MS_MACROBEGIN                                                                \
+  if ((_dst) != NULL)                                                          \
+    msFree((_dst));                                                            \
+  if ((_src))                                                                  \
+    (_dst) = msStrdup((_src));                                                 \
+  else                                                                         \
+    (_dst) = NULL;                                                             \
+  MS_MACROEND
diff -pruN 8.0.1-5/src/mapcpl.c 8.2.0~beta1-1~exp1/src/mapcpl.c
--- 8.0.1-5/src/mapcpl.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcpl.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,256 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Functions copied from GDAL's CPL. This file contain utility
+ *           functions that come from the GDAL/OGR cpl library. The idea
+ *           behind it is to have access in mapserver to all these
+ *           utilities, without being constrained to link with GDAL/OGR.
+ * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ *
+ * Note:
+ * Names of functions used here are the same as those in the cpl
+ * library with the exception the the CPL prefix is changed to ms
+ * (eg : CPLGetBasename() would become msGetBasename())
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/* $Id$ */
+
+#include <assert.h>
+#include "mapserver.h"
+
+/* should be size of largest possible filename */
+#define MS_PATH_BUF_SIZE 2048
+static char szStaticResult[MS_PATH_BUF_SIZE];
+
+/************************************************************************/
+/*                        msFindFilenameStart()                         */
+/************************************************************************/
+
+static int msFindFilenameStart(const char *pszFilename)
+
+{
+  int iFileStart;
+
+  for (iFileStart = strlen(pszFilename);
+       iFileStart > 0 && pszFilename[iFileStart - 1] != '/' &&
+       pszFilename[iFileStart - 1] != '\\';
+       iFileStart--) {
+  }
+
+  return iFileStart;
+}
+
+/************************************************************************/
+/*                           msGetBasename()                            */
+/************************************************************************/
+
+/**
+ * Extract basename (non-directory, non-extension) portion of filename.
+ *
+ * Returns a string containing the file basename portion of the passed
+ * name.  If there is no basename (passed value ends in trailing directory
+ * separator, or filename starts with a dot) an empty string is returned.
+ *
+ * <pre>
+ * msGetBasename( "abc/def.xyz" ) == "def"
+ * msGetBasename( "abc/def" ) == "def"
+ * msGetBasename( "abc/def/" ) == ""
+ * </pre>
+ *
+ * @param pszFullFilename the full filename potentially including a path.
+ *
+ * @return just the non-directory, non-extension portion of the path in
+ * an internal string which must not be freed.  The string
+ * may be destroyed by the next ms filename handling call.
+ */
+
+const char *msGetBasename(const char *pszFullFilename)
+
+{
+  int iFileStart = msFindFilenameStart(pszFullFilename);
+  int iExtStart, nLength;
+
+  for (iExtStart = strlen(pszFullFilename);
+       iExtStart > iFileStart && pszFullFilename[iExtStart] != '.';
+       iExtStart--) {
+  }
+
+  if (iExtStart == iFileStart)
+    iExtStart = strlen(pszFullFilename);
+
+  nLength = iExtStart - iFileStart;
+
+  assert(nLength < MS_PATH_BUF_SIZE);
+
+  strlcpy(szStaticResult, pszFullFilename + iFileStart, nLength + 1);
+
+  return szStaticResult;
+}
+
+/* Id: GDAL/port/cplgetsymbol.cpp,v 1.14 2004/11/11 20:40:38 fwarmerdam Exp */
+/* ==================================================================== */
+/*                  Unix Implementation                                 */
+/* ==================================================================== */
+#if defined(HAVE_DLFCN_H)
+
+#define GOT_GETSYMBOL
+
+#include <dlfcn.h>
+
+/************************************************************************/
+/*                            msGetSymbol()                            */
+/************************************************************************/
+
+/**
+ * Fetch a function pointer from a shared library / DLL.
+ *
+ * This function is meant to abstract access to shared libraries and
+ * DLLs and performs functions similar to dlopen()/dlsym() on Unix and
+ * LoadLibrary() / GetProcAddress() on Windows.
+ *
+ * If no support for loading entry points from a shared library is available
+ * this function will always return NULL.   Rules on when this function
+ * issues a msError() or not are not currently well defined, and will have
+ * to be resolved in the future.
+ *
+ * Currently msGetSymbol() doesn't try to:
+ * <ul>
+ *  <li> prevent the reference count on the library from going up
+ *    for every request, or given any opportunity to unload
+ *    the library.
+ *  <li> Attempt to look for the library in non-standard
+ *    locations.
+ *  <li> Attempt to try variations on the symbol name, like
+ *    pre-prending or post-pending an underscore.
+ * </ul>
+ *
+ * Some of these issues may be worked on in the future.
+ *
+ * @param pszLibrary the name of the shared library or DLL containing
+ * the function.  May contain path to file.  If not system supplies search
+ * paths will be used.
+ * @param pszSymbolName the name of the function to fetch a pointer to.
+ * @return A pointer to the function if found, or NULL if the function isn't
+ * found, or the shared library can't be loaded.
+ */
+
+void *msGetSymbol(const char *pszLibrary, const char *pszSymbolName) {
+  void *pLibrary;
+  void *pSymbol;
+
+  pLibrary = dlopen(pszLibrary, RTLD_LAZY);
+  if (pLibrary == NULL) {
+    msSetError(MS_MISCERR, "Dynamic loading failed: %s", "msGetSymbol()",
+               dlerror());
+    return NULL;
+  }
+
+  pSymbol = dlsym(pLibrary, pszSymbolName);
+
+#if (defined(__APPLE__) && defined(__MACH__))
+  /* On mach-o systems, C symbols have a leading underscore and depending
+   * on how dlcompat is configured it may or may not add the leading
+   * underscore.  So if dlsym() fails add an underscore and try again.
+   */
+  if (pSymbol == NULL) {
+    char withUnder[strlen(pszSymbolName) + 2];
+    withUnder[0] = '_';
+    withUnder[1] = 0;
+    strcat(withUnder, pszSymbolName);
+    pSymbol = dlsym(pLibrary, withUnder);
+  }
+#endif
+
+  if (pSymbol == NULL) {
+    msSetError(MS_MISCERR, "Dynamic loading failed: %s", "msGetSymbol()",
+               dlerror());
+    return NULL;
+  }
+
+  /* We accept leakage of pLibrary */
+  /* coverity[leaked_storage] */
+  return (pSymbol);
+}
+
+#endif /* def __unix__ && defined(HAVE_DLFCN_H) */
+
+/* ==================================================================== */
+/*                 Windows Implementation                               */
+/* ==================================================================== */
+#ifdef WIN32
+
+#define GOT_GETSYMBOL
+
+#include <windows.h>
+
+/************************************************************************/
+/*                            msGetSymbol()                            */
+/************************************************************************/
+
+void *msGetSymbol(const char *pszLibrary, const char *pszSymbolName) {
+  void *pLibrary;
+  void *pSymbol;
+
+  pLibrary = LoadLibrary(pszLibrary);
+  if (pLibrary == NULL) {
+    msSetError(MS_MISCERR, "Can't load requested dynamic library: %s",
+               "msGetSymbol()", pszLibrary);
+    return NULL;
+  }
+
+  pSymbol = (void *)GetProcAddress((HINSTANCE)pLibrary, pszSymbolName);
+
+  if (pSymbol == NULL) {
+    msSetError(MS_MISCERR, "Can't find requested entry point: %s in lib %s",
+               "msGetSymbol()", pszSymbolName, pLibrary);
+    return NULL;
+  }
+
+  return (pSymbol);
+}
+
+#endif /* def _WIN32 */
+
+/* ==================================================================== */
+/*      Dummy implementation.                                           */
+/* ==================================================================== */
+
+#ifndef GOT_GETSYMBOL
+
+/************************************************************************/
+/*                            msGetSymbol()                            */
+/*                                                                      */
+/*      Dummy implementation.                                           */
+/************************************************************************/
+
+void *msGetSymbol(const char *pszLibrary, const char *pszEntryPoint) {
+  msSetError(
+      MS_MISCERR,
+      "msGetSymbol(%s,%s) called.  Failed as this is stub implementation.",
+      "msGetSymbol()", pszLibrary, pszEntryPoint);
+  return NULL;
+}
+#endif
diff -pruN 8.0.1-5/src/mapcrypto.c 8.2.0~beta1-1~exp1/src/mapcrypto.c
--- 8.0.1-5/src/mapcrypto.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapcrypto.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,592 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Encryption functions (see MS-RFC-18)
+ * Author:   Daniel Morissette
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2006 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <assert.h>
+#include <ctype.h>  /* isxdigit() */
+#include <stdlib.h> /* rand() */
+#include <time.h>   /* time() */
+
+#include "mapserver.h"
+
+#include "cpl_conv.h"
+
+/**********************************************************************
+ * encipher() and decipher() from the Tiny Encryption Algorithm (TEA)
+ * website at:
+ *   http://www.simonshepherd.supanet.com/tea.htm
+ *
+ * TEA was developed and placed in the public domain by David Wheeler
+ * and Roger Needham at the Computer Laboratory of Cambridge University.
+ *
+ * The source below came with the following public domain notice:
+ *
+ *   "Please feel free to use any of this code in your applications.
+ *    The TEA algorithm (including new-variant TEA) has been placed
+ *    in the public domain, as have my assembly language implementations."
+ *
+ * ... and the following usage notes:
+ *
+ * All the routines have the general form
+ *
+ *  void encipher(const unsigned long *const v,unsigned long *const w,
+ *                const unsigned long * const k);
+ *
+ *  void decipher(const unsigned long *const v,unsigned long *const w,
+ *                const unsigned long * const k);
+ *
+ * TEA takes 64 bits of data in v[0] and v[1], and 128 bits of key in
+ * k[0] - k[3]. The result is returned in w[0] and w[1]. Returning the
+ * result separately makes implementation of cipher modes other than
+ * Electronic Code Book a little bit easier.
+ *
+ * TEA can be operated in any of the modes of DES.
+ *
+ * n is the number of iterations. 32 is ample, 16 is sufficient, as few
+ * as eight should be OK for most applications, especially ones where
+ * the data age quickly (real-time video, for example). The algorithm
+ * achieves good dispersion after six iterations. The iteration count
+ * can be made variable if required.
+ *
+ * Note this algorithm is optimised for 32-bit CPUs with fast shift
+ * capabilities. It can very easily be ported to assembly language
+ * on most CPUs.
+ *
+ * delta is chosen to be the Golden ratio ((5/4)1/2 - 1/2 ~ 0.618034)
+ * multiplied by 232. On entry to decipher(), sum is set to be delta * n.
+ * Which way round you call the functions is arbitrary: DK(EK(P)) = EK(DK(P))
+ * where EK and DK are encryption and decryption under key K respectively.
+ *
+ **********************************************************************/
+
+static void encipher(const ms_uint32 *const v, ms_uint32 *const w,
+                     const ms_uint32 *const k) {
+  register ms_uint32 y = v[0], z = v[1], sum = 0, delta = 0x9E3779B9, n = 32;
+
+  while (n-- > 0) {
+    y += ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum & 3]);
+    sum += delta;
+    z += ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum >> 11 & 3]);
+  }
+
+  w[0] = y;
+  w[1] = z;
+}
+
+static void decipher(const ms_uint32 *const v, ms_uint32 *const w,
+                     const ms_uint32 *const k) {
+  register ms_uint32 y = v[0], z = v[1], sum = 0xC6EF3720, delta = 0x9E3779B9,
+                     n = 32;
+
+  /* sum = delta<<5, in general sum = delta * n */
+
+  while (n-- > 0) {
+    z -= ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum >> 11 & 3]);
+    sum -= delta;
+    y -= ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum & 3]);
+  }
+
+  w[0] = y;
+  w[1] = z;
+}
+
+/**********************************************************************
+ *                          msHexEncode()
+ *
+ * Hex-encode numbytes from in[] and return the result in out[].
+ *
+ * out[] should be preallocated by the caller to be at least 2*numbytes+1
+ * (+1 for the terminating '\0')
+ **********************************************************************/
+void msHexEncode(const unsigned char *in, char *out, int numbytes) {
+  char *hex = "0123456789ABCDEF";
+
+  while (numbytes-- > 0) {
+    *out++ = hex[*in / 16];
+    *out++ = hex[*in % 16];
+    in++;
+  }
+  *out = '\0';
+}
+
+/**********************************************************************
+ *                          msHexDecode()
+ *
+ * Hex-decode numchars from in[] and return the result in out[].
+ *
+ * If numchars > 0 then only up to this number of chars from in[] are
+ * processed, otherwise the full in[] string up to the '\0' is processed.
+ *
+ * out[] should be preallocated by the caller to be large enough to hold
+ * the resulting bytes.
+ *
+ * Returns the number of bytes written to out[] which may be different from
+ * numchars/2 if an error or a '\0' is encountered.
+ **********************************************************************/
+int msHexDecode(const char *in, unsigned char *out, int numchars) {
+  int numbytes_out = 0;
+
+  /* Make sure numchars is even */
+  numchars = (numchars / 2) * 2;
+
+  if (numchars < 2)
+    numchars = -1; /* Will result in this value being ignored in the loop*/
+
+  while (*in != '\0' && *(in + 1) != '\0' && numchars != 0) {
+    *out = 0x10 * (*in >= 'A' ? ((*in & 0xdf) - 'A') + 10 : (*in - '0'));
+    in++;
+    *out += (*in >= 'A' ? ((*in & 0xdf) - 'A') + 10 : (*in - '0'));
+    in++;
+
+    out++;
+    numbytes_out++;
+
+    numchars -= 2;
+  }
+
+  return numbytes_out;
+}
+
+/**********************************************************************
+ *                       msGenerateEncryptionKey()
+ *
+ * Create a new encryption key.
+ *
+ * The output buffer should be at least MS_ENCRYPTION_KEY_SIZE bytes.
+ **********************************************************************/
+
+int msGenerateEncryptionKey(unsigned char *k) {
+  int i;
+
+  /* Use current time as seed for rand() */
+  srand((unsigned int)time(NULL));
+
+  for (i = 0; i < MS_ENCRYPTION_KEY_SIZE; i++) {
+    /* coverity[dont_call] */
+    k[i] = (unsigned char)rand();
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                       msReadEncryptionKeyFromFile()
+ *
+ * Read and decode hex-encoded encryption key from file and returns the
+ * key in the 'unsigned char k[MS_ENCRYPTION_KEY_SIZE]' buffer that is
+ * provided by the caller.
+ *
+ * Returns MS_SUCCESS/MS_FAILURE.
+ **********************************************************************/
+
+int msReadEncryptionKeyFromFile(const char *keyfile, unsigned char *k) {
+  FILE *fp;
+  char szBuf[100];
+  int numchars;
+
+  if ((fp = fopen(keyfile, "rt")) == NULL) {
+    msSetError(MS_MISCERR, "Cannot open key file.",
+               "msReadEncryptionKeyFromFile()");
+    return MS_FAILURE;
+  }
+
+  numchars =
+      fread(szBuf, sizeof(unsigned char), MS_ENCRYPTION_KEY_SIZE * 2, fp);
+  fclose(fp);
+  szBuf[MS_ENCRYPTION_KEY_SIZE * 2] = '\0';
+
+  if (numchars != MS_ENCRYPTION_KEY_SIZE * 2) {
+    msSetError(MS_MISCERR, "Invalid key file, got %d chars, expected %d.",
+               "msReadEncryptionKeyFromFile()", numchars,
+               MS_ENCRYPTION_KEY_SIZE * 2);
+    return MS_FAILURE;
+  }
+
+  msHexDecode(szBuf, k, MS_ENCRYPTION_KEY_SIZE * 2);
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                       msLoadEncryptionKey()
+ *
+ * Load and decode hex-encoded encryption key from file and returns the
+ * key in the 'unsigned char k[MS_ENCRYPTION_KEY_SIZE]' buffer that is
+ * provided by the caller.
+ *
+ * The first time that msLoadEncryptionKey() is called for a given mapObj
+ * it will load the encryption key and cache it in mapObj->encryption_key.
+ * If the key is already set in the mapObj then it does nothing and returns.
+ *
+ * The location of the encryption key can be specified in two ways,
+ * either by setting the environment variable MS_ENCRYPTION_KEY or using
+ * a CONFIG directive:
+ *    CONFIG MS_ENCRYPTION_KEY "/path/to/mykey.txt"
+ * Returns MS_SUCCESS/MS_FAILURE.
+ **********************************************************************/
+
+static int msLoadEncryptionKey(mapObj *map) {
+  const char *keyfile;
+
+  if (map == NULL) {
+    msSetError(MS_MISCERR, "NULL MapObj.", "msLoadEncryptionKey()");
+    return MS_FAILURE;
+  }
+
+  if (map->encryption_key_loaded)
+    return MS_SUCCESS; /* Already loaded */
+
+  keyfile = msGetConfigOption(map, "MS_ENCRYPTION_KEY");
+  if (!keyfile)
+    keyfile = CPLGetConfigOption("MS_ENCRYPTION_KEY", NULL);
+
+  if (keyfile &&
+      msReadEncryptionKeyFromFile(keyfile, map->encryption_key) == MS_SUCCESS) {
+    map->encryption_key_loaded = MS_TRUE;
+  } else {
+    msSetError(MS_MISCERR,
+               "Failed reading encryption key. Make sure "
+               "MS_ENCRYPTION_KEY is set and points to a valid key file.",
+               "msLoadEncryptionKey()");
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                        msEncryptStringWithKey()
+ *
+ * Encrypts and hex-encodes the contents of string in[] and returns the
+ * result in out[] which should have been pre-allocated by the caller
+ * to be at least twice the size of in[] + 16+1 bytes (for padding + '\0').
+ *
+ **********************************************************************/
+
+void msEncryptStringWithKey(const unsigned char *key, const char *in,
+                            char *out) {
+  ms_uint32 v[4], w[4];
+  const ms_uint32 *k;
+  int last_block = MS_FALSE;
+
+  /* Casting the key this way is safe only as long as longs are 4 bytes
+   * on this platform */
+  assert(sizeof(ms_uint32) == 4);
+  k = (const ms_uint32 *)key;
+
+  while (!last_block) {
+    int i, j;
+    /* encipher() takes v[2] (64 bits) as input.
+     * Copy bytes from in[] to the v[2] input array (pair of 4 bytes)
+     * v[] is padded with zeros if string doesn't align with 8 bytes
+     */
+    v[0] = 0;
+    v[1] = 0;
+    for (i = 0; !last_block && i < 2; i++) {
+      for (j = 0; j < 4; j++) {
+        if (*in == '\0') {
+          last_block = MS_TRUE;
+          break;
+        }
+
+        v[i] |= *in << (j * 8);
+        in++;
+      }
+    }
+
+    if (*in == '\0')
+      last_block = MS_TRUE;
+
+    /* Do the actual encryption */
+    encipher(v, w, k);
+
+    /* Append hex-encoded bytes to output, 4 bytes at a time */
+    msHexEncode((unsigned char *)w, out, 4);
+    out += 8;
+    msHexEncode((unsigned char *)(w + 1), out, 4);
+    out += 8;
+  }
+
+  /* Make sure output is 0-terminated */
+  *out = '\0';
+}
+
+/**********************************************************************
+ *                        msDecryptStringWithKey()
+ *
+ * Hex-decodes and then decrypts the contents of string in[] and returns the
+ * result in out[] which should have been pre-allocated by the caller
+ * to be at least half the size of in[].
+ *
+ **********************************************************************/
+
+void msDecryptStringWithKey(const unsigned char *key, const char *in,
+                            char *out) {
+  ms_uint32 v[4], w[4];
+  const ms_uint32 *k;
+  int last_block = MS_FALSE;
+
+  /* Casting the key this way is safe only as long as longs are 4 bytes
+   * on this platform */
+  assert(sizeof(ms_uint32) == 4);
+  k = (const ms_uint32 *)key;
+
+  while (!last_block) {
+    int i;
+    /* decipher() takes v[2] (64 bits) as input.
+     * Copy bytes from in[] to the v[2] input array (pair of 4 bytes)
+     * v[] is padded with zeros if string doesn't align with 8 bytes
+     */
+    v[0] = 0;
+    v[1] = 0;
+
+    if (msHexDecode(in, (unsigned char *)v, 8) != 4)
+      last_block = MS_TRUE;
+    else {
+      in += 8;
+      if (msHexDecode(in, (unsigned char *)(v + 1), 8) != 4)
+        last_block = MS_TRUE;
+      else
+        in += 8;
+    }
+
+    /* Do the actual decryption */
+    decipher(v, w, k);
+
+    /* Copy the results to out[] */
+    for (i = 0; i < 2; i++) {
+      *out++ = (w[i] & 0x000000ff);
+      *out++ = (w[i] & 0x0000ff00) >> 8;
+      *out++ = (w[i] & 0x00ff0000) >> 16;
+      *out++ = (w[i] & 0xff000000) >> 24;
+    }
+
+    if (*in == '\0')
+      last_block = MS_TRUE;
+  }
+
+  /* Make sure output is 0-terminated */
+  *out = '\0';
+}
+
+/**********************************************************************
+ *                        msDecryptStringTokens()
+ *
+ * Returns a newly allocated string (to be msFree'd by the caller) in
+ * which all occurences of encrypted strings delimited by {...} have
+ * been decrypted.
+ *
+ **********************************************************************/
+
+char *msDecryptStringTokens(mapObj *map, const char *in) {
+  char *outbuf, *out;
+
+  if (map == NULL) {
+    msSetError(MS_MISCERR, "NULL MapObj.", "msLoadEncryptionKey()");
+    return NULL;
+  }
+
+  /* Start with a copy of the string. Decryption can only result in
+   * a string with the same or shorter length */
+  if ((outbuf = (char *)malloc((strlen(in) + 1) * sizeof(char))) == NULL) {
+    msSetError(MS_MEMERR, NULL, "msDecryptStringTokens()");
+    return NULL;
+  }
+  out = outbuf;
+
+  while (*in != '\0') {
+    if (*in == '{') {
+      /* Possibly beginning of a token, look for closing bracket
+      ** and make sure all chars in between are valid hex encoding chars
+      */
+      const char *pszStart, *pszEnd;
+      int valid_token = MS_FALSE;
+
+      pszStart = in + 1;
+      if ((pszEnd = strchr(pszStart, '}')) != NULL && pszEnd - pszStart > 1) {
+        const char *pszTmp;
+        valid_token = MS_TRUE;
+        for (pszTmp = pszStart; pszTmp < pszEnd; pszTmp++) {
+          if (!isxdigit(*pszTmp)) {
+            valid_token = MS_FALSE;
+            break;
+          }
+        }
+      }
+
+      if (valid_token) {
+        /* Go ahead and decrypt the token */
+        char *pszTmp;
+
+        /* Make sure encryption key is loaded. We do this here instead
+         * of at the beginning of the function to avoid loading the
+         * key unless ready necessary. This is a very cheap call if
+         * the key is already loaded
+         */
+        if (msLoadEncryptionKey(map) != MS_SUCCESS)
+          return NULL;
+
+        pszTmp = (char *)malloc((pszEnd - pszStart + 1) * sizeof(char));
+        strlcpy(pszTmp, pszStart, (pszEnd - pszStart) + 1);
+
+        msDecryptStringWithKey(map->encryption_key, pszTmp, out);
+
+        out += strlen(out);
+        in = pszEnd + 1;
+        free(pszTmp);
+      } else {
+        /* Not a valid token, just copy the '{' and keep going */
+        *out++ = *in++;
+      }
+    } else {
+      /* Just copy any other chars */
+      *out++ = *in++;
+    }
+  }
+  *out = '\0';
+
+  return outbuf;
+}
+
+#ifdef TEST_MAPCRYPTO
+
+/* Test for mapcrypto.c functions. To run these tests, use the following
+** Makefile directive:
+
+test_mapcrypto: $(LIBMAP_STATIC) mapcrypto.c
+  $(CC) $(CFLAGS) mapcrypto.c -DTEST_MAPCRYPTO $(EXE_LDFLAGS) -o test_mapcrypto
+
+**
+*/
+int main(int argc, char *argv[]) {
+  const unsigned char bytes_in[] = {0x12, 0x34, 0xff, 0x00, 0x44, 0x22};
+  unsigned char bytes_out[8], encryption_key[MS_ENCRYPTION_KEY_SIZE * 2 + 1];
+  char string_buf[256], string_buf2[256];
+  int numbytes = 0;
+
+  /*
+  ** Test msHexEncode()
+  */
+  msHexEncode(bytes_in, string_buf, 6);
+  printf("msHexEncode returned '%s'\n", string_buf);
+
+  /*
+  ** Test msHexDecode()
+  */
+  memset(bytes_out, 0, 8);
+  numbytes = msHexDecode(string_buf, bytes_out, -1);
+  printf(
+      "msHexDecode(%s, -1) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
+      string_buf, numbytes, bytes_out[0], bytes_out[1], bytes_out[2],
+      bytes_out[3], bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
+
+  memset(bytes_out, 0, 8);
+  numbytes = msHexDecode(string_buf, bytes_out, 4);
+  printf(
+      "msHexDecode(%s, 4) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
+      string_buf, numbytes, bytes_out[0], bytes_out[1], bytes_out[2],
+      bytes_out[3], bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
+
+  memset(bytes_out, 0, 8);
+  numbytes = msHexDecode(string_buf, bytes_out, 20);
+  printf(
+      "msHexDecode(%s, 20) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
+      string_buf, numbytes, bytes_out[0], bytes_out[1], bytes_out[2],
+      bytes_out[3], bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
+
+  /*
+  ** Test loading encryption key
+  */
+  if (msReadEncryptionKeyFromFile("/tmp/test.key", encryption_key) !=
+      MS_SUCCESS) {
+    printf("msReadEncryptionKeyFromFile() = MS_FAILURE\n");
+    printf("Aborting tests!\n");
+    msWriteError(stderr);
+    return -1;
+  } else {
+    msHexEncode(encryption_key, string_buf, MS_ENCRYPTION_KEY_SIZE);
+    printf("msReadEncryptionKeyFromFile() returned '%s'\n", string_buf);
+  }
+
+  /*
+  ** Test Encryption/Decryption
+  */
+
+  /* First with an 8 bytes input string (test boundaries) */
+  msEncryptStringWithKey(encryption_key, "test1234", string_buf);
+  printf("msEncryptStringWithKey('test1234') returned '%s'\n", string_buf);
+
+  msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
+  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf,
+         string_buf2);
+
+  /* Next with an 1 byte input string */
+  msEncryptStringWithKey(encryption_key, "t", string_buf);
+  printf("msEncryptStringWithKey('t') returned '%s'\n", string_buf);
+
+  msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
+  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf,
+         string_buf2);
+
+  /* Next with an 12 bytes input string */
+  msEncryptStringWithKey(encryption_key, "test123456", string_buf);
+  printf("msEncryptStringWithKey('test123456') returned '%s'\n", string_buf);
+
+  msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
+  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf,
+         string_buf2);
+
+  /*
+  ** Test decryption with tokens
+  */
+  {
+    char *pszBuf;
+    mapObj *map;
+    /* map = msNewMapObj(); */
+    map = msLoadMap("/tmp/test.map", NULL);
+
+    sprintf(string_buf2, "string with a {%s} encrypted token", string_buf);
+
+    pszBuf = msDecryptStringTokens(map, string_buf2);
+    if (pszBuf == NULL) {
+      printf("msDecryptStringTokens() failed.\n");
+      printf("Aborting tests!\n");
+      msWriteError(stderr);
+      return -1;
+    } else {
+      printf("msDecryptStringTokens('%s') returned '%s'\n", string_buf2,
+             pszBuf);
+    }
+    msFree(pszBuf);
+    msFreeMap(map);
+  }
+
+  return 0;
+}
+
+#endif /* TEST_MAPCRYPTO */
diff -pruN 8.0.1-5/src/mapdebug.c 8.2.0~beta1-1~exp1/src/mapdebug.c
--- 8.0.1-5/src/mapdebug.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapdebug.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,358 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of debug/logging, msDebug() and related functions.
+ * Author:   Daniel Morissette
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapthread.h"
+#include "maptime.h"
+
+#include "cpl_conv.h"
+
+#include <time.h>
+#ifndef _WIN32
+#include <sys/time.h>
+#include <unistd.h>
+#endif
+#include <stdarg.h>
+
+#ifdef NEED_NONBLOCKING_STDERR
+#include <fcntl.h>
+#endif
+
+#ifdef _WIN32
+#include <windows.h> /* OutputDebugStringA() */
+#endif
+
+#ifndef USE_THREAD
+
+debugInfoObj *msGetDebugInfoObj() {
+  static debugInfoObj debuginfo = {
+      MS_DEBUGLEVEL_ERRORSONLY, MS_DEBUGMODE_OFF, NULL, NULL, 0, NULL};
+  return &debuginfo;
+}
+
+#else
+
+static debugInfoObj *debuginfo_list = NULL;
+
+debugInfoObj *msGetDebugInfoObj() {
+  debugInfoObj *link;
+  void *thread_id;
+  debugInfoObj *ret_obj;
+
+  msAcquireLock(TLOCK_DEBUGOBJ);
+
+  thread_id = msGetThreadId();
+
+  /* find link for this thread */
+
+  for (link = debuginfo_list;
+       link != NULL && link->thread_id != thread_id && link->next != NULL &&
+       link->next->thread_id != thread_id;
+       link = link->next) {
+  }
+
+  /* If the target thread link is already at the head of the list were ok */
+  if (debuginfo_list != NULL && debuginfo_list->thread_id == thread_id) {
+  }
+
+  /* We don't have one ... initialize one. */
+  else if (link == NULL || link->next == NULL) {
+    debugInfoObj *new_link;
+
+    new_link = (debugInfoObj *)msSmallMalloc(sizeof(debugInfoObj));
+    new_link->next = debuginfo_list;
+    new_link->thread_id = thread_id;
+    new_link->global_debug_level = MS_DEBUGLEVEL_ERRORSONLY;
+    new_link->debug_mode = MS_DEBUGMODE_OFF;
+    new_link->errorfile = NULL;
+    new_link->fp = NULL;
+    debuginfo_list = new_link;
+  }
+
+  /* If the link is not already at the head of the list, promote it */
+  else {
+    debugInfoObj *target = link->next;
+
+    link->next = link->next->next;
+    target->next = debuginfo_list;
+    debuginfo_list = target;
+  }
+
+  ret_obj = debuginfo_list;
+
+  msReleaseLock(TLOCK_DEBUGOBJ);
+
+  return ret_obj;
+}
+#endif
+
+/* msSetErrorFile()
+**
+** Set output target, ready to write to it, open file if necessary
+**
+** If pszRelToPath != NULL then we will try to make the value relative to
+** this path if it is not absolute already and it's not one of the special
+** values (stderr, stdout, windowsdebug)
+**
+** Returns MS_SUCCESS/MS_FAILURE
+*/
+int msSetErrorFile(const char *pszErrorFile, const char *pszRelToPath) {
+  char extended_path[MS_MAXPATHLEN];
+  debugInfoObj *debuginfo = msGetDebugInfoObj();
+
+  if (strcmp(pszErrorFile, "stderr") != 0 &&
+      strcmp(pszErrorFile, "stdout") != 0 &&
+      strcmp(pszErrorFile, "windowsdebug") != 0) {
+    /* Try to make the path relative */
+    if (msBuildPath(extended_path, pszRelToPath, pszErrorFile) == NULL)
+      return MS_FAILURE;
+    pszErrorFile = extended_path;
+  }
+
+  if (debuginfo->errorfile && pszErrorFile &&
+      strcmp(debuginfo->errorfile, pszErrorFile) == 0) {
+    /* Nothing to do, already writing to the right place */
+    return MS_SUCCESS;
+  }
+
+  /* Close current output file if any */
+  msCloseErrorFile();
+
+  /* NULL or empty target will just close current output and return */
+  if (pszErrorFile == NULL || *pszErrorFile == '\0')
+    return MS_SUCCESS;
+
+  if (strcmp(pszErrorFile, "stderr") == 0) {
+    debuginfo->fp = stderr;
+    debuginfo->errorfile = msStrdup(pszErrorFile);
+    debuginfo->debug_mode = MS_DEBUGMODE_STDERR;
+  } else if (strcmp(pszErrorFile, "stdout") == 0) {
+    debuginfo->fp = stdout;
+    debuginfo->errorfile = msStrdup(pszErrorFile);
+    debuginfo->debug_mode = MS_DEBUGMODE_STDOUT;
+  } else if (strcmp(pszErrorFile, "windowsdebug") == 0) {
+#ifdef _WIN32
+    debuginfo->errorfile = msStrdup(pszErrorFile);
+    debuginfo->fp = NULL;
+    debuginfo->debug_mode = MS_DEBUGMODE_WINDOWSDEBUG;
+#else
+    msSetError(
+        MS_MISCERR,
+        "'MS_ERRORFILE windowsdebug' is available only on Windows platforms.",
+        "msSetErrorFile()");
+    return MS_FAILURE;
+#endif
+  } else {
+    debuginfo->fp = fopen(pszErrorFile, "a");
+    if (debuginfo->fp == NULL) {
+      msSetError(MS_MISCERR, "Failed to open MS_ERRORFILE %s",
+                 "msSetErrorFile()", pszErrorFile);
+      return MS_FAILURE;
+    }
+    debuginfo->errorfile = msStrdup(pszErrorFile);
+    debuginfo->debug_mode = MS_DEBUGMODE_FILE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* msCloseErrorFile()
+**
+** Close current output file (if one is open) and reset related members
+*/
+void msCloseErrorFile() {
+  debugInfoObj *debuginfo = msGetDebugInfoObj();
+
+  if (debuginfo && debuginfo->debug_mode != MS_DEBUGMODE_OFF) {
+    if (debuginfo->fp && debuginfo->debug_mode == MS_DEBUGMODE_FILE)
+      fclose(debuginfo->fp);
+
+    if (debuginfo->fp && (debuginfo->debug_mode == MS_DEBUGMODE_STDERR ||
+                          debuginfo->debug_mode == MS_DEBUGMODE_STDOUT))
+      fflush(debuginfo->fp); /* just flush stderr or stdout */
+
+    debuginfo->fp = NULL;
+
+    msFree(debuginfo->errorfile);
+    debuginfo->errorfile = NULL;
+
+    debuginfo->debug_mode = MS_DEBUGMODE_OFF;
+  }
+}
+
+/* msGetErrorFile()
+**
+** Returns name of current error file
+**
+** Returns NULL if not set.
+*/
+const char *msGetErrorFile() {
+  debugInfoObj *debuginfo = msGetDebugInfoObj();
+
+  if (debuginfo)
+    return debuginfo->errorfile;
+
+  return NULL;
+}
+
+/* Set/Get the current global debug level value, used as default value for
+** new map and layer objects and to control msDebug() calls outside of
+** the context of mapObj or layerObj.
+**
+*/
+void msSetGlobalDebugLevel(int level) {
+  debugInfoObj *debuginfo = msGetDebugInfoObj();
+
+  if (debuginfo)
+    debuginfo->global_debug_level = (debugLevel)level;
+}
+
+debugLevel msGetGlobalDebugLevel() {
+  debugInfoObj *debuginfo = msGetDebugInfoObj();
+
+  if (debuginfo)
+    return debuginfo->global_debug_level;
+
+  return MS_DEBUGLEVEL_ERRORSONLY;
+}
+
+/* msDebugInitFromEnv()
+**
+** Init debug state from MS_ERRORFILE and MS_DEBUGLEVEL env vars if set
+**
+** Returns MS_SUCCESS/MS_FAILURE
+*/
+int msDebugInitFromEnv() {
+  const char *val;
+
+  if ((val = CPLGetConfigOption("MS_ERRORFILE", NULL)) != NULL) {
+    if (msSetErrorFile(val, NULL) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  if ((val = CPLGetConfigOption("MS_DEBUGLEVEL", NULL)) != NULL)
+    msSetGlobalDebugLevel(atoi(val));
+
+  return MS_SUCCESS;
+}
+
+/* msDebugCleanup()
+**
+** Called by msCleanup to remove info related to this thread.
+*/
+void msDebugCleanup() {
+  /* make sure file is closed */
+  msCloseErrorFile();
+
+#ifdef USE_THREAD
+  {
+    void *thread_id = msGetThreadId();
+    debugInfoObj *link;
+
+    msAcquireLock(TLOCK_DEBUGOBJ);
+
+    /* find link for this thread */
+
+    for (link = debuginfo_list;
+         link != NULL && link->thread_id != thread_id && link->next != NULL &&
+         link->next->thread_id != thread_id;
+         link = link->next) {
+    }
+
+    if (link->thread_id == thread_id) {
+      /* presumably link is at head of list.  */
+      if (debuginfo_list == link)
+        debuginfo_list = link->next;
+
+      free(link);
+    } else if (link->next != NULL && link->next->thread_id == thread_id) {
+      debugInfoObj *next_link = link->next;
+      link->next = link->next->next;
+      free(next_link);
+    }
+    msReleaseLock(TLOCK_DEBUGOBJ);
+  }
+#endif
+}
+
+/* msDebug()
+**
+** Outputs/logs messages to the MS_ERRORFILE if one is set
+** (see msSetErrorFile())
+**
+*/
+void msDebug(const char *pszFormat, ...) {
+  va_list args;
+  debugInfoObj *debuginfo = msGetDebugInfoObj();
+  char szMessage[MESSAGELENGTH];
+
+  if (debuginfo == NULL || debuginfo->debug_mode == MS_DEBUGMODE_OFF)
+    return; /* Don't waste time here! */
+
+  va_start(args, pszFormat);
+  vsnprintf(szMessage, MESSAGELENGTH, pszFormat, args);
+  va_end(args);
+  szMessage[MESSAGELENGTH - 1] = '\0';
+
+  msRedactCredentials(szMessage);
+
+  if (debuginfo->fp) {
+    /* Writing to a stdio file handle */
+
+#if defined(USE_FASTCGI)
+    /* It seems the FastCGI stuff inserts a timestamp anyways, so  */
+    /* we might as well skip this one if writing to stderr w/ FastCGI. */
+    if (debuginfo->debug_mode != MS_DEBUGMODE_STDERR)
+#endif
+    {
+      struct mstimeval tv;
+      time_t t;
+      msGettimeofday(&tv, NULL);
+      t = tv.tv_sec;
+      msIO_fprintf(debuginfo->fp, "[%s].%ld ", msStringChop(ctime(&t)),
+                   (long)tv.tv_usec);
+    }
+
+    msIO_fprintf(debuginfo->fp, "%s", szMessage);
+  }
+#ifdef _WIN32
+  else if (debuginfo->debug_mode == MS_DEBUGMODE_WINDOWSDEBUG) {
+    /* Writing to Windows Debug Console */
+    OutputDebugStringA(szMessage);
+  }
+#endif
+}
+
+/* msDebug2()
+**
+** Variadic function with no operation
+**
+*/
+void msDebug2(int level, ...) { (void)level; }
diff -pruN 8.0.1-5/src/mapdraw.c 8.2.0~beta1-1~exp1/src/mapdraw.c
--- 8.0.1-5/src/mapdraw.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapdraw.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4316 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  High level msDrawMap() implementation and related functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <assert.h>
+#include <math.h>
+#include "mapserver.h"
+#include "maptime.h"
+#include "mapcopy.h"
+#include "mapfile.h"
+#include "mapows.h"
+#include "cpl_port.h"
+
+/* msPrepareImage()
+ *
+ * Returns a new imageObj ready for rendering the current map.
+ *
+ * If allow_nonsquare is set to MS_TRUE then the caller should call
+ * msMapRestoreRealExtent() once they are done with the image.
+ * This should be set to MS_TRUE only when called from msDrawMap(), see bug 945.
+ */
+imageObj *msPrepareImage(mapObj *map, int allow_nonsquare) {
+  int i, status;
+  imageObj *image = NULL;
+  double geo_cellsize;
+
+  if (map->width == -1 || map->height == -1) {
+    msSetError(MS_MISCERR, "Image dimensions not specified.",
+               "msPrepareImage()");
+    return (NULL);
+  }
+
+  msFreeLabelCache(&(map->labelcache));
+  msInitLabelCache(
+      &(map->labelcache)); /* this clears any previously allocated cache */
+
+  /* clear any previously created mask layer images */
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->maskimage) {
+      msFreeImage(GET_LAYER(map, i)->maskimage);
+      GET_LAYER(map, i)->maskimage = NULL;
+    }
+  }
+
+  status = msValidateContexts(map); /* make sure there are no recursive REQUIRES
+                                       or LABELREQUIRES expressions */
+  if (status != MS_SUCCESS)
+    return NULL;
+
+  if (!map->outputformat) {
+    msSetError(MS_IMGERR, "Map outputformat not set!", "msPrepareImage()");
+    return (NULL);
+  } else if (MS_RENDERER_PLUGIN(map->outputformat)) {
+    rendererVTableObj *renderer = map->outputformat->vtable;
+    colorObj *bg = &map->imagecolor;
+    map->imagecolor.alpha = 255;
+
+    image =
+        renderer->createImage(map->width, map->height, map->outputformat, bg);
+    if (image == NULL)
+      return (NULL);
+    image->format = map->outputformat;
+    image->format->refcount++;
+    image->width = map->width;
+    image->height = map->height;
+
+    image->resolution = map->resolution;
+    image->resolutionfactor = map->resolution / map->defresolution;
+    if (map->web.imagepath)
+      image->imagepath = msStrdup(map->web.imagepath);
+    if (map->web.imageurl)
+      image->imageurl = msStrdup(map->web.imageurl);
+
+  } else if (MS_RENDERER_IMAGEMAP(map->outputformat)) {
+    image = msImageCreateIM(map->width, map->height, map->outputformat,
+                            map->web.imagepath, map->web.imageurl,
+                            map->resolution, map->defresolution);
+  } else if (MS_RENDERER_RAWDATA(map->outputformat)) {
+    image =
+        msImageCreate(map->width, map->height, map->outputformat,
+                      map->web.imagepath, map->web.imageurl, map->resolution,
+                      map->defresolution, &map->imagecolor);
+  } else {
+    image = NULL;
+  }
+
+  if (!image) {
+    msSetError(MS_IMGERR, "Unable to initialize image.", "msPrepareImage()");
+    return (NULL);
+  }
+
+  image->map = map;
+
+  /*
+   * If we want to support nonsquare pixels, note that now, otherwise
+   * adjust the extent size to have square pixels.
+   *
+   * If allow_nonsquare is set to MS_TRUE then the caller should call
+   * msMapRestoreRealExtent() once they are done with the image.
+   * This should be set to MS_TRUE only when called from msDrawMap(), see bug
+   * 945.
+   */
+  if (allow_nonsquare && msTestConfigOption(map, "MS_NONSQUARE", MS_FALSE)) {
+    double cellsize_x = (map->extent.maxx - map->extent.minx) / map->width;
+    double cellsize_y = (map->extent.maxy - map->extent.miny) / map->height;
+
+    if (cellsize_y != 0.0 && (fabs(cellsize_x / cellsize_y) > 1.00001 ||
+                              fabs(cellsize_x / cellsize_y) < 0.99999)) {
+      map->gt.need_geotransform = MS_TRUE;
+      if (map->debug)
+        msDebug(
+            "msDrawMap(): kicking into non-square pixel preserving mode.\n");
+    }
+    map->cellsize = (cellsize_x * 0.5 + cellsize_y * 0.5);
+  } else
+    map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+
+  status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                            map->resolution, &map->scaledenom);
+  if (status != MS_SUCCESS) {
+    msFreeImage(image);
+    return (NULL);
+  }
+
+  /* update geotransform based on adjusted extent. */
+  msMapComputeGeotransform(map);
+
+  /* Do we need to fake out stuff for rotated support? */
+  if (map->gt.need_geotransform)
+    msMapSetFakedExtent(map);
+
+  /* We will need a cellsize that represents a real georeferenced */
+  /* coordinate cellsize here, so compute it from saved extents.   */
+
+  geo_cellsize = map->cellsize;
+  if (map->gt.need_geotransform == MS_TRUE) {
+    double cellsize_x =
+        (map->saved_extent.maxx - map->saved_extent.minx) / map->width;
+    double cellsize_y =
+        (map->saved_extent.maxy - map->saved_extent.miny) / map->height;
+
+    geo_cellsize =
+        sqrt(cellsize_x * cellsize_x + cellsize_y * cellsize_y) / sqrt(2.0);
+  }
+
+  /* compute layer/class/style/label scale factors now */
+  for (int lid = 0; lid < map->numlayers; lid++) {
+    layerObj *layer = GET_LAYER(map, lid);
+    if (layer->sizeunits != MS_PIXELS)
+      layer->scalefactor = (msInchesPerUnit(layer->sizeunits, 0) /
+                            msInchesPerUnit(map->units, 0)) /
+                           geo_cellsize;
+    else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
+      layer->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                           map->resolution / map->defresolution;
+    else
+      layer->scalefactor = map->resolution / map->defresolution;
+    for (int cid = 0; cid < layer->numclasses; cid++) {
+      classObj *class = GET_CLASS(map, lid, cid);
+      if (class->sizeunits == MS_INHERIT)
+        class->scalefactor = layer->scalefactor;
+      else if (class->sizeunits != MS_PIXELS)
+        class->scalefactor = (msInchesPerUnit(class->sizeunits, 0) /
+                              msInchesPerUnit(map->units, 0)) /
+                             geo_cellsize;
+      else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
+        class->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                             map->resolution / map->defresolution;
+      else
+        class->scalefactor = map->resolution / map->defresolution;
+      for (int sid = 0; sid < class->numstyles; sid++) {
+        styleObj *style = class->styles[sid];
+        if (style->sizeunits == MS_INHERIT)
+          style->scalefactor = class->scalefactor;
+        else if (style->sizeunits != MS_PIXELS)
+          style->scalefactor = (msInchesPerUnit(style->sizeunits, 0) /
+                                msInchesPerUnit(map->units, 0)) /
+                               geo_cellsize;
+        else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
+          style->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                               map->resolution / map->defresolution;
+        else
+          style->scalefactor = map->resolution / map->defresolution;
+      }
+      for (int sid = 0; sid < class->numlabels; sid++) {
+        labelObj *label = class->labels[sid];
+        if (label->sizeunits == MS_INHERIT)
+          label->scalefactor = class->scalefactor;
+        else if (label->sizeunits != MS_PIXELS)
+          label->scalefactor = (msInchesPerUnit(label->sizeunits, 0) /
+                                msInchesPerUnit(map->units, 0)) /
+                               geo_cellsize;
+        else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
+          label->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                               map->resolution / map->defresolution;
+        else
+          label->scalefactor = map->resolution / map->defresolution;
+        for (int lsid = 0; lsid < label->numstyles; lsid++) {
+          styleObj *lstyle = label->styles[lsid];
+          if (lstyle->sizeunits == MS_INHERIT)
+            lstyle->scalefactor = label->scalefactor;
+          else if (lstyle->sizeunits != MS_PIXELS)
+            lstyle->scalefactor = (msInchesPerUnit(lstyle->sizeunits, 0) /
+                                   msInchesPerUnit(map->units, 0)) /
+                                  geo_cellsize;
+          else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
+            lstyle->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                                  map->resolution / map->defresolution;
+          else
+            lstyle->scalefactor = map->resolution / map->defresolution;
+        }
+      }
+    }
+  }
+
+  image->refpt.x =
+      MS_MAP2IMAGE_X_IC_DBL(0, map->extent.minx, 1.0 / map->cellsize);
+  image->refpt.y =
+      MS_MAP2IMAGE_Y_IC_DBL(0, map->extent.maxy, 1.0 / map->cellsize);
+
+  return image;
+}
+
+static int msCompositeRasterBuffer(mapObj *map, imageObj *img,
+                                   rasterBufferObj *rb, LayerCompositer *comp) {
+  int ret = MS_SUCCESS;
+  if (MS_IMAGE_RENDERER(img)->compositeRasterBuffer) {
+    while (comp && ret == MS_SUCCESS) {
+      rasterBufferObj *rb_ptr = rb;
+      CompositingFilter *filter = comp->filter;
+      if (filter && comp->next) {
+        /* if we have another compositor to apply, then we need to copy the
+         * rasterBufferObj. Otherwise we can work on it directly */
+        rb_ptr = (rasterBufferObj *)msSmallCalloc(sizeof(rasterBufferObj), 1);
+        msCopyRasterBuffer(rb_ptr, rb);
+      }
+      while (filter && ret == MS_SUCCESS) {
+        ret = msApplyCompositingFilter(map, rb_ptr, filter);
+        filter = filter->next;
+      }
+      if (ret == MS_SUCCESS)
+        ret = MS_IMAGE_RENDERER(img)->compositeRasterBuffer(
+            img, rb_ptr, comp->comp_op, comp->opacity);
+      if (rb_ptr != rb) {
+        msFreeRasterBuffer(rb_ptr);
+        msFree(rb_ptr);
+      }
+      comp = comp->next;
+    }
+  } else {
+    ret = MS_FAILURE;
+  }
+  return ret;
+}
+
+/*
+ * Generic function to render the map file.
+ * The type of the image created is based on the imagetype parameter in the map
+ * file.
+ *
+ * mapObj *map - map object loaded in MapScript or via a mapfile to use
+ * int querymap - is this map the result of a query operation, MS_TRUE|MS_FALSE
+ */
+imageObj *msDrawMap(mapObj *map, int querymap) {
+  int i;
+  layerObj *lp = NULL;
+  int status = MS_FAILURE;
+  imageObj *image = NULL;
+  struct mstimeval mapstarttime = {0}, mapendtime = {0};
+  struct mstimeval starttime = {0}, endtime = {0};
+
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+  enum MS_CONNECTION_TYPE lastconnectiontype;
+  httpRequestObj *pasOWSReqInfo = NULL;
+  int numOWSLayers = 0;
+  int numOWSRequests = 0;
+  wmsParamsObj sLastWMSParams;
+#endif
+
+  if (map->debug >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&mapstarttime, NULL);
+
+  if (querymap) { /* use queryMapObj image dimensions */
+    if (map->querymap.width > 0 && map->querymap.width <= map->maxsize)
+      map->width = map->querymap.width;
+    if (map->querymap.height > 0 && map->querymap.height <= map->maxsize)
+      map->height = map->querymap.height;
+  }
+
+  msApplyMapConfigOptions(map);
+  image = msPrepareImage(map, MS_TRUE);
+
+  if (!image) {
+    msSetError(MS_IMGERR, "Unable to initialize image.", "msDrawMap()");
+    return (NULL);
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_DEBUG)
+    msDebug("msDrawMap(): rendering using outputformat named %s (%s).\n",
+            map->outputformat->name, map->outputformat->driver);
+
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+
+  /* Time the OWS query phase */
+  if (map->debug >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&starttime, NULL);
+
+  /* How many OWS (WMS/WFS) layers do we have to draw?
+   * Note: numOWSLayers is the number of actual layers and numOWSRequests is
+   * the number of HTTP requests which could be lower if multiple layers
+   * are merged into the same request.
+   */
+  numOWSLayers = 0;
+  for (i = 0; i < map->numlayers; i++) {
+    if (map->layerorder[i] == -1)
+      continue;
+
+    lp = GET_LAYER(map, map->layerorder[i]);
+    if (lp->connectiontype != MS_WMS && lp->connectiontype != MS_WFS) {
+      continue;
+    }
+    numOWSLayers++;
+  }
+
+  if (numOWSLayers > 0) {
+
+    /* Alloc and init pasOWSReqInfo...
+     */
+    pasOWSReqInfo =
+        (httpRequestObj *)malloc(numOWSLayers * sizeof(httpRequestObj));
+    if (pasOWSReqInfo == NULL) {
+      msSetError(MS_MEMERR, "Allocation of httpRequestObj failed.",
+                 "msDrawMap()");
+      return NULL;
+    }
+    msHTTPInitRequestObj(pasOWSReqInfo, numOWSLayers);
+    msInitWmsParamsObj(&sLastWMSParams);
+
+    /* Pre-download all WMS/WFS layers in parallel before starting to draw map
+     */
+    lastconnectiontype = MS_SHAPEFILE;
+    for (i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] == -1)
+        continue;
+
+      lp = GET_LAYER(map, map->layerorder[i]);
+      if (lp->connectiontype != MS_WMS && lp->connectiontype != MS_WFS) {
+        continue;
+      }
+
+      if (!msLayerIsVisible(map, lp))
+        continue;
+
+#ifdef USE_WMS_LYR
+      if (lp->connectiontype == MS_WMS) {
+        if (msPrepareWMSLayerRequest(map->layerorder[i], map, lp, 1,
+                                     lastconnectiontype, &sLastWMSParams, 0, 0,
+                                     0, NULL, pasOWSReqInfo,
+                                     &numOWSRequests) == MS_FAILURE) {
+          msFreeWmsParamsObj(&sLastWMSParams);
+          msFreeImage(image);
+          msFree(pasOWSReqInfo);
+          return NULL;
+        }
+      }
+#endif
+
+#ifdef USE_WFS_LYR
+      if (lp->connectiontype == MS_WFS) {
+        if (msPrepareWFSLayerRequest(map->layerorder[i], map, lp, pasOWSReqInfo,
+                                     &numOWSRequests) == MS_FAILURE) {
+          msFreeWmsParamsObj(&sLastWMSParams);
+          msFreeImage(image);
+          msFree(pasOWSReqInfo);
+          return NULL;
+        }
+      }
+#endif
+
+      lastconnectiontype = lp->connectiontype;
+    }
+
+    msFreeWmsParamsObj(&sLastWMSParams);
+  } /* if numOWSLayers > 0 */
+
+  if (numOWSRequests && msOWSExecuteRequests(pasOWSReqInfo, numOWSRequests, map,
+                                             MS_TRUE) == MS_FAILURE) {
+    msFreeImage(image);
+    msFree(pasOWSReqInfo);
+    return NULL;
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&endtime, NULL);
+    msDebug("msDrawMap(): WMS/WFS set-up and query, %.3fs\n",
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+  }
+
+#endif /* USE_WMS_LYR || USE_WFS_LYR */
+
+  /* OK, now we can start drawing */
+  for (i = 0; i < map->numlayers; i++) {
+
+    if (map->layerorder[i] != -1) {
+      const char *force_draw_label_cache = NULL;
+
+      lp = (GET_LAYER(map, map->layerorder[i]));
+
+      if (lp->postlabelcache) /* wait to draw */
+        continue;
+
+      if (map->debug >= MS_DEBUGLEVEL_TUNING ||
+          lp->debug >= MS_DEBUGLEVEL_TUNING)
+        msGettimeofday(&starttime, NULL);
+
+      if (!msLayerIsVisible(map, lp))
+        continue;
+
+      if (lp->connectiontype == MS_WMS) {
+#ifdef USE_WMS_LYR
+        if (MS_RENDERER_PLUGIN(image->format) ||
+            MS_RENDERER_RAWDATA(image->format)) {
+          assert(pasOWSReqInfo);
+          status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo,
+                                     numOWSRequests, map, lp, image);
+        } else {
+          msSetError(MS_WMSCONNERR,
+                     "Output format '%s' doesn't support WMS layers.",
+                     "msDrawMap()", image->format->name);
+          status = MS_FAILURE;
+        }
+
+        if (status == MS_FAILURE) {
+          msSetError(MS_WMSCONNERR,
+                     "Failed to draw WMS layer named '%s'. This most likely "
+                     "happened because "
+                     "the remote WMS server returned an invalid image, and XML "
+                     "exception "
+                     "or another unexpected result in response to the GetMap "
+                     "request. Also check "
+                     "and make sure that the layer's connection URL is valid.",
+                     "msDrawMap()", lp->name);
+          msFreeImage(image);
+          msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+          msFree(pasOWSReqInfo);
+          return (NULL);
+        }
+
+#else /* ndef USE_WMS_LYR */
+        msSetError(MS_WMSCONNERR,
+                   "MapServer not built with WMS Client support, unable to "
+                   "render layer '%s'.",
+                   "msDrawMap()", lp->name);
+        msFreeImage(image);
+        return (NULL);
+#endif
+      } else { /* Default case: anything but WMS layers */
+        if (querymap)
+          status = msDrawQueryLayer(map, lp, image);
+        else
+          status = msDrawLayer(map, lp, image);
+        if (status == MS_FAILURE) {
+          msSetError(MS_IMGERR, "Failed to draw layer named '%s'.",
+                     "msDrawMap()", lp->name);
+          msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+          if (pasOWSReqInfo) {
+            msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+            msFree(pasOWSReqInfo);
+          }
+#endif /* USE_WMS_LYR || USE_WFS_LYR */
+          return (NULL);
+        }
+      }
+      if (map->debug >= MS_DEBUGLEVEL_TUNING ||
+          lp->debug >= MS_DEBUGLEVEL_TUNING) {
+        msGettimeofday(&endtime, NULL);
+        msDebug("msDrawMap(): Layer %d (%s), %.3fs\n", map->layerorder[i],
+                lp->name ? lp->name : "(null)",
+                (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                    (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+      }
+
+      /* Flush layer cache in-between layers if requested by PROCESSING
+       * directive*/
+      force_draw_label_cache =
+          msLayerGetProcessingKey(lp, "FORCE_DRAW_LABEL_CACHE");
+      if (force_draw_label_cache &&
+          strncasecmp(force_draw_label_cache, "FLUSH", 5) == 0) {
+        if (map->debug >= MS_DEBUGLEVEL_V)
+          msDebug(
+              "msDrawMap(): PROCESSING FORCE_DRAW_LABEL_CACHE=FLUSH found.\n");
+        if (msDrawLabelCache(map, image) != MS_SUCCESS) {
+          msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+          if (pasOWSReqInfo) {
+            msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+            msFree(pasOWSReqInfo);
+          }
+#endif /* USE_WMS_LYR || USE_WFS_LYR */
+          return (NULL);
+        }
+        msFreeLabelCache(&(map->labelcache));
+        msInitLabelCache(&(map->labelcache));
+      } /* PROCESSING FORCE_DRAW_LABEL_CACHE */
+    }
+  }
+
+  if (map->scalebar.status == MS_EMBED && !map->scalebar.postlabelcache) {
+
+    /* We need to temporarily restore the original extent for drawing */
+    /* the scalebar as it uses the extent to recompute cellsize. */
+    if (map->gt.need_geotransform)
+      msMapRestoreRealExtent(map);
+
+    if (MS_SUCCESS != msEmbedScalebar(map, image)) {
+      msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+      /* Cleanup WMS/WFS Request stuff */
+      if (pasOWSReqInfo) {
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
+      }
+#endif
+      return NULL;
+    }
+
+    if (map->gt.need_geotransform)
+      msMapSetFakedExtent(map);
+  }
+
+  if (map->legend.status == MS_EMBED && !map->legend.postlabelcache) {
+    if (msEmbedLegend(map, image) != MS_SUCCESS) {
+      msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+      /* Cleanup WMS/WFS Request stuff */
+      if (pasOWSReqInfo) {
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
+      }
+#endif
+      return NULL;
+    }
+  }
+
+  if (msDrawLabelCache(map, image) != MS_SUCCESS) {
+    msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+    if (pasOWSReqInfo) {
+      msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+      msFree(pasOWSReqInfo);
+    }
+#endif /* USE_WMS_LYR || USE_WFS_LYR */
+    return (NULL);
+  }
+
+  for (i = 0; i < map->numlayers;
+       i++) { /* for each layer, check for postlabelcache layers */
+
+    lp = (GET_LAYER(map, map->layerorder[i]));
+
+    if (!lp->postlabelcache)
+      continue;
+    if (!msLayerIsVisible(map, lp))
+      continue;
+
+    if (map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING)
+      msGettimeofday(&starttime, NULL);
+
+    if (lp->connectiontype == MS_WMS) {
+#ifdef USE_WMS_LYR
+      if (MS_RENDERER_PLUGIN(image->format) ||
+          MS_RENDERER_RAWDATA(image->format)) {
+        assert(pasOWSReqInfo);
+        status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo,
+                                   numOWSRequests, map, lp, image);
+      }
+
+#else
+      status = MS_FAILURE;
+#endif
+    } else {
+      if (querymap)
+        status = msDrawQueryLayer(map, lp, image);
+      else
+        status = msDrawLayer(map, lp, image);
+    }
+
+    if (status == MS_FAILURE) {
+      msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+      if (pasOWSReqInfo) {
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
+      }
+#endif /* USE_WMS_LYR || USE_WFS_LYR */
+      return (NULL);
+    }
+
+    if (map->debug >= MS_DEBUGLEVEL_TUNING ||
+        lp->debug >= MS_DEBUGLEVEL_TUNING) {
+      msGettimeofday(&endtime, NULL);
+      msDebug("msDrawMap(): Layer %d (%s), %.3fs\n", map->layerorder[i],
+              lp->name ? lp->name : "(null)",
+              (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                  (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+    }
+  }
+
+  /* Do we need to fake out stuff for rotated support? */
+  /* This really needs to be done on every preceeding exit point too... */
+  if (map->gt.need_geotransform)
+    msMapRestoreRealExtent(map);
+
+  if (map->legend.status == MS_EMBED && map->legend.postlabelcache)
+    if (MS_UNLIKELY(MS_FAILURE == msEmbedLegend(map, image))) {
+      msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+      /* Cleanup WMS/WFS Request stuff */
+      if (pasOWSReqInfo) {
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
+      }
+#endif
+      return NULL;
+    }
+
+  if (map->scalebar.status == MS_EMBED && map->scalebar.postlabelcache) {
+
+    /* We need to temporarily restore the original extent for drawing */
+    /* the scalebar as it uses the extent to recompute cellsize. */
+    if (map->gt.need_geotransform)
+      msMapRestoreRealExtent(map);
+
+    if (MS_SUCCESS != msEmbedScalebar(map, image)) {
+      msFreeImage(image);
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+      /* Cleanup WMS/WFS Request stuff */
+      if (pasOWSReqInfo) {
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
+      }
+#endif
+      return NULL;
+    }
+
+    if (map->gt.need_geotransform)
+      msMapSetFakedExtent(map);
+  }
+
+#if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+  /* Cleanup WMS/WFS Request stuff */
+  if (pasOWSReqInfo) {
+    msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+    msFree(pasOWSReqInfo);
+  }
+#endif
+
+  if (map->debug >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&mapendtime, NULL);
+    msDebug("msDrawMap() total time: %.3fs\n",
+            (mapendtime.tv_sec + mapendtime.tv_usec / 1.0e6) -
+                (mapstarttime.tv_sec + mapstarttime.tv_usec / 1.0e6));
+  }
+
+  return (image);
+}
+
+/*
+ * Test whether a layer should be drawn or not in the current map view and
+ * at the current scale.
+ * Returns TRUE if layer is visible, FALSE if not.
+ */
+int msLayerIsVisible(mapObj *map, layerObj *layer) {
+  int i;
+
+  if (!layer->data && !layer->tileindex && !layer->connection &&
+      !layer->features && !layer->grid)
+    return (MS_FALSE); /* no data associated with this layer, not an error since
+                          layer may be used as a template from MapScript */
+
+  if (layer->type == MS_LAYER_QUERY || layer->type == MS_LAYER_TILEINDEX)
+    return (MS_FALSE);
+  if ((layer->status != MS_ON) && (layer->status != MS_DEFAULT))
+    return (MS_FALSE);
+
+  /* Do comparisons of layer scale vs map scale now, since msExtentsOverlap() */
+  /* can be slow */
+  if (map->scaledenom > 0) {
+
+    /* layer scale boundaries should be checked first */
+    if ((layer->maxscaledenom > 0) &&
+        (map->scaledenom > layer->maxscaledenom)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because "
+                "LAYER.MAXSCALE is too small for this MAP scale\n",
+                layer->name);
+      }
+      return (MS_FALSE);
+    }
+    if (/*(layer->minscaledenom > 0) &&*/ (map->scaledenom <=
+                                           layer->minscaledenom)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because "
+                "LAYER.MINSCALE is too large for this MAP scale\n",
+                layer->name);
+      }
+      return (MS_FALSE);
+    }
+  }
+
+  /* Only return MS_FALSE if it is definitely false. Sometimes it will return
+   *MS_UNKNOWN, which we
+   ** consider true, for this use case (it might be visible, try and draw it,
+   *see what happens). */
+  if (msExtentsOverlap(map, layer) == MS_FALSE) {
+    if (layer->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.EXTENT "
+              "does not intersect MAP.EXTENT\n",
+              layer->name);
+    }
+    return (MS_FALSE);
+  }
+
+  if (msEvalContext(map, layer, layer->requires) == MS_FALSE)
+    return (MS_FALSE);
+
+  if (map->scaledenom > 0) {
+
+    /* now check class scale boundaries (all layers *must* pass these tests) */
+    if (layer->numclasses > 0) {
+      for (i = 0; i < layer->numclasses; i++) {
+        if ((layer->class[i] -> maxscaledenom > 0) &&
+            (map->scaledenom > layer->class[i] -> maxscaledenom))
+          continue; /* can skip this one, next class */
+        if ((layer->class[i] -> minscaledenom > 0) &&
+            (map->scaledenom <= layer->class[i] -> minscaledenom))
+          continue; /* can skip this one, next class */
+
+        break; /* can't skip this class (or layer for that matter) */
+      }
+      if (i == layer->numclasses) {
+        if (layer->debug >= MS_DEBUGLEVEL_V) {
+          msDebug("msLayerIsVisible(): Skipping layer (%s) because no CLASS in "
+                  "the layer is in-scale for this MAP scale\n",
+                  layer->name);
+        }
+        return (MS_FALSE);
+      }
+    }
+  }
+
+  if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
+    if ((layer->maxgeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width "
+                "is much smaller than map width\n",
+                layer->name);
+      }
+      return (MS_FALSE);
+    }
+    if ((layer->mingeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width "
+                "is much larger than map width\n",
+                layer->name);
+      }
+      return (MS_FALSE);
+    }
+  }
+
+  return MS_TRUE; /* All tests passed.  Layer is visible. */
+}
+
+#define LAYER_NEEDS_COMPOSITING(layer)                                         \
+  (((layer)->compositer != NULL) &&                                            \
+   ((layer)->compositer->next || (layer)->compositor->opacity < 100 ||         \
+    (layer)->compositor->compop != MS_COMPOP_SRC_OVER ||                       \
+    (layer)->compositer->filter))
+/*
+ * Generic function to render a layer object.
+ */
+int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  imageObj *image_draw = image;
+  outputFormatObj *altFormat = NULL;
+  int retcode = MS_SUCCESS;
+  const char *alternativeFomatString = NULL;
+  layerObj *maskLayer = NULL;
+
+  if (!msLayerIsVisible(map, layer))
+    return MS_SUCCESS;
+
+  if (layer->compositer && !layer->compositer->next &&
+      layer->compositer->opacity == 0)
+    return MS_SUCCESS; /* layer is completely transparent, skip it */
+
+  /* conditions may have changed since this layer last drawn, so retest
+     layer->project (Bug #673) */
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
+
+  /* make sure labelcache setting is set correctly if postlabelcache is set.
+     This is done by the parser but may have been altered by a mapscript. see
+     #5142 */
+  if (layer->postlabelcache) {
+    layer->labelcache = MS_FALSE;
+  }
+
+  if (layer->mask) {
+    int maskLayerIdx;
+    /* render the mask layer in its own imageObj */
+    if (!MS_IMAGE_RENDERER(image)->supports_pixel_buffer) {
+      msSetError(MS_MISCERR,
+                 "Layer (%s) references references a mask layer, but the "
+                 "selected renderer does not support them",
+                 "msDrawLayer()", layer->name);
+      return (MS_FAILURE);
+    }
+    maskLayerIdx = msGetLayerIndex(map, layer->mask);
+    if (maskLayerIdx == -1) {
+      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)",
+                 "msDrawLayer()", layer->name, layer->mask);
+      return (MS_FAILURE);
+    }
+    maskLayer = GET_LAYER(map, maskLayerIdx);
+    if (!maskLayer->maskimage) {
+      int i;
+      int origstatus, origlabelcache;
+      altFormat = msSelectOutputFormat(map, "png24");
+      msInitializeRendererVTable(altFormat);
+      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg
+       */
+      maskLayer->maskimage = msImageCreate(
+          image->width, image->height, altFormat, image->imagepath,
+          image->imageurl, map->resolution, map->defresolution, NULL);
+      if (!maskLayer->maskimage) {
+        msSetError(MS_MISCERR, "Unable to initialize mask image.",
+                   "msDrawLayer()");
+        return (MS_FAILURE);
+      }
+
+      /*
+       * force the masked layer to status on, and turn off the labelcache so
+       * that eventual labels are added to the temporary image instead of being
+       * added to the labelcache
+       */
+      origstatus = maskLayer->status;
+      origlabelcache = maskLayer->labelcache;
+      maskLayer->status = MS_ON;
+      maskLayer->labelcache = MS_OFF;
+
+      /* draw the mask layer in the temporary image */
+      retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
+      maskLayer->status = origstatus;
+      maskLayer->labelcache = origlabelcache;
+      if (retcode != MS_SUCCESS) {
+        return MS_FAILURE;
+      }
+      /*
+       * hack to work around bug #3834: if we have use an alternate renderer,
+       * the symbolset may contain symbols that reference it. We want to remove
+       * those references before the altFormat is destroyed to avoid a segfault
+       * and/or a leak, and so the the main renderer doesn't pick the cache up
+       * thinking it's for him.
+       */
+      for (i = 0; i < map->symbolset.numsymbols; i++) {
+        if (map->symbolset.symbol[i] != NULL) {
+          symbolObj *s = map->symbolset.symbol[i];
+          if (s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
+            MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
+            s->renderer = NULL;
+          }
+        }
+      }
+      /* set the imagetype from the original outputformat back (it was removed
+       * by msSelectOutputFormat() */
+      msFree(map->imagetype);
+      map->imagetype = msStrdup(image->format->name);
+    }
+  }
+  altFormat = NULL;
+  /* inform the rendering device that layer draw is starting. */
+  msImageStartLayer(map, layer, image);
+
+  /*check if an alternative renderer should be used for this layer*/
+  alternativeFomatString = msLayerGetProcessingKey(layer, "RENDERER");
+  if (MS_RENDERER_PLUGIN(image_draw->format) &&
+      alternativeFomatString != NULL &&
+      (altFormat = msSelectOutputFormat(map, alternativeFomatString))) {
+    rendererVTableObj *renderer = NULL;
+    msInitializeRendererVTable(altFormat);
+
+    image_draw = msImageCreate(
+        image->width, image->height, altFormat, image->imagepath,
+        image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
+    renderer = MS_IMAGE_RENDERER(image_draw);
+    renderer->startLayer(image_draw, map, layer);
+  } else if (MS_RENDERER_PLUGIN(image_draw->format)) {
+    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
+    if ((layer->mask && layer->connectiontype != MS_WMS &&
+         layer->type != MS_LAYER_RASTER) ||
+        layer->compositer) {
+      /* masking occurs at the pixel/layer level for raster images, so we don't
+       need to create a temporary image in these cases
+       */
+      if (layer->mask || renderer->compositeRasterBuffer) {
+        image_draw = msImageCreate(image->width, image->height, image->format,
+                                   image->imagepath, image->imageurl,
+                                   map->resolution, map->defresolution, NULL);
+        if (!image_draw) {
+          msSetError(MS_MISCERR,
+                     "Unable to initialize temporary transparent image.",
+                     "msDrawLayer()");
+          return (MS_FAILURE);
+        }
+        image_draw->map = map;
+        renderer->startLayer(image_draw, map, layer);
+      }
+    }
+  }
+  /*
+  ** redirect processing of some layer types.
+  */
+  if (layer->connectiontype == MS_WMS) {
+#ifdef USE_WMS_LYR
+    retcode = msDrawWMSLayer(map, layer, image_draw);
+#else
+    retcode = MS_FAILURE;
+#endif
+  } else if (layer->type == MS_LAYER_RASTER) {
+    retcode = msDrawRasterLayer(map, layer, image_draw);
+  } else if (layer->type == MS_LAYER_CHART) {
+    retcode = msDrawChartLayer(map, layer, image_draw);
+  } else { /* must be a Vector layer */
+    retcode = msDrawVectorLayer(map, layer, image_draw);
+  }
+
+  if (altFormat) {
+    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
+    rendererVTableObj *altrenderer = MS_IMAGE_RENDERER(image_draw);
+    rasterBufferObj rb;
+    int i;
+    memset(&rb, 0, sizeof(rasterBufferObj));
+
+    altrenderer->endLayer(image_draw, map, layer);
+
+    retcode = altrenderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
+      goto altformat_cleanup;
+    }
+    retcode = renderer->mergeRasterBuffer(
+        image, &rb,
+        ((layer->compositer) ? (layer->compositer->opacity * 0.01) : (1.0)), 0,
+        0, 0, 0, rb.width, rb.height);
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
+      goto altformat_cleanup;
+    }
+
+  altformat_cleanup:
+    /*
+     * hack to work around bug #3834: if we have use an alternate renderer, the
+     * symbolset may contain symbols that reference it. We want to remove those
+     * references before the altFormat is destroyed to avoid a segfault and/or a
+     * leak, and so the main renderer doesn't pick the cache up thinking
+     * it's for him.
+     */
+    for (i = 0; i < map->symbolset.numsymbols; i++) {
+      if (map->symbolset.symbol[i] != NULL) {
+        symbolObj *s = map->symbolset.symbol[i];
+        if (s->renderer == altrenderer) {
+          altrenderer->freeSymbol(s);
+          s->renderer = NULL;
+        }
+      }
+    }
+    msFreeImage(image_draw);
+    /* set the imagetype from the original outputformat back (it was removed by
+     * msSelectOutputFormat() */
+    msFree(map->imagetype);
+    map->imagetype = msStrdup(image->format->name);
+  } else if (image != image_draw) {
+    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
+    rasterBufferObj rb;
+    memset(&rb, 0, sizeof(rasterBufferObj));
+
+    renderer->endLayer(image_draw, map, layer);
+
+    retcode = renderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
+      goto imagedraw_cleanup;
+    }
+    if (maskLayer && maskLayer->maskimage) {
+      rasterBufferObj mask;
+      unsigned int row, col;
+      memset(&mask, 0, sizeof(rasterBufferObj));
+      retcode = MS_IMAGE_RENDERER(maskLayer->maskimage)
+                    ->getRasterBufferHandle(maskLayer->maskimage, &mask);
+      if (MS_UNLIKELY(retcode == MS_FAILURE)) {
+        goto imagedraw_cleanup;
+      }
+      /* modify the pixels of the overlay */
+
+      if (rb.type == MS_BUFFER_BYTE_RGBA) {
+        for (row = 0; row < rb.height; row++) {
+          unsigned char *ma, *a, *r, *g, *b;
+          r = rb.data.rgba.r + row * rb.data.rgba.row_step;
+          g = rb.data.rgba.g + row * rb.data.rgba.row_step;
+          b = rb.data.rgba.b + row * rb.data.rgba.row_step;
+          a = rb.data.rgba.a + row * rb.data.rgba.row_step;
+          ma = mask.data.rgba.a + row * mask.data.rgba.row_step;
+          for (col = 0; col < rb.width; col++) {
+            if (*ma == 0) {
+              *a = *r = *g = *b = 0;
+            }
+            a += rb.data.rgba.pixel_step;
+            r += rb.data.rgba.pixel_step;
+            g += rb.data.rgba.pixel_step;
+            b += rb.data.rgba.pixel_step;
+            ma += mask.data.rgba.pixel_step;
+          }
+        }
+      }
+    }
+    if (!layer->compositer) {
+      /*we have a mask layer with no composition configured, do a nomral blend
+       */
+      retcode = renderer->mergeRasterBuffer(image, &rb, 1.0, 0, 0, 0, 0,
+                                            rb.width, rb.height);
+    } else {
+      retcode = msCompositeRasterBuffer(map, image, &rb, layer->compositer);
+    }
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
+      goto imagedraw_cleanup;
+    }
+
+  imagedraw_cleanup:
+    msFreeImage(image_draw);
+  }
+
+  msImageEndLayer(map, layer, image);
+  return (retcode);
+}
+
+int msDrawVectorLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  int status, retcode = MS_SUCCESS;
+  int drawmode = MS_DRAWMODE_FEATURES;
+  char annotate = MS_TRUE;
+  shapeObj shape;
+  shapeObj savedShape;
+  rectObj searchrect;
+  char cache = MS_FALSE;
+  int maxnumstyles = 1;
+  featureListNodeObjPtr shpcache = NULL, current = NULL;
+  int nclasses = 0;
+  int *classgroup = NULL;
+  double minfeaturesize = -1;
+  int maxfeatures = -1;
+  int featuresdrawn = 0;
+
+  if (image)
+    maxfeatures = msLayerGetMaxFeaturesToDraw(layer, image->format);
+
+  /* TODO TBT: draw as raster layer in vector renderers */
+
+  annotate = msEvalContext(map, layer, layer->labelrequires);
+  if (map->scaledenom > 0) {
+    if ((layer->labelmaxscaledenom != -1) &&
+        (map->scaledenom >= layer->labelmaxscaledenom))
+      annotate = MS_FALSE;
+    if ((layer->labelminscaledenom != -1) &&
+        (map->scaledenom < layer->labelminscaledenom))
+      annotate = MS_FALSE;
+  }
+
+  /* open this layer */
+  status = msLayerOpen(layer);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /* build item list. STYLEITEM javascript needs the shape attributes */
+  if (layer->styleitem && (STARTS_WITH_CI(layer->styleitem, "javascript://") ||
+                           STARTS_WITH_CI(layer->styleitem, "sld://"))) {
+    status = msLayerWhichItems(layer, MS_TRUE, NULL);
+  } else {
+    status = msLayerWhichItems(layer, MS_FALSE, NULL);
+  }
+
+  if (status != MS_SUCCESS) {
+    msLayerClose(layer);
+    return MS_FAILURE;
+  }
+
+  /* identify target shapes */
+  if (layer->transform == MS_TRUE) {
+    searchrect = map->extent;
+
+    if ((map->projection.numargs > 0) && (layer->projection.numargs > 0)) {
+      int bDone = MS_FALSE;
+
+      if (layer->connectiontype == MS_UVRASTER) {
+        /* Nasty hack to make msUVRASTERLayerWhichShapes() aware that the */
+        /* original area of interest is (map->extent, map->projection)... */
+        /* Useful when dealing with UVRASTER that extend beyond 180 deg */
+        msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layer, map);
+
+        searchrect = msUVRASTERGetSearchRect(layer, map);
+        bDone = MS_TRUE;
+      }
+
+      if (!bDone)
+        msProjectRect(
+            &map->projection, &layer->projection,
+            &searchrect); /* project the searchrect to source coords */
+    }
+
+  } else {
+    searchrect.minx = searchrect.miny = 0;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
+  }
+
+  status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
+
+  if (layer->connectiontype == MS_UVRASTER) {
+    msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layer, NULL);
+  }
+
+  if (status == MS_DONE) { /* no overlap */
+    msLayerClose(layer);
+    return MS_SUCCESS;
+  } else if (status != MS_SUCCESS) {
+    msLayerClose(layer);
+    return MS_FAILURE;
+  }
+
+  nclasses = 0;
+  classgroup = NULL;
+  if (layer->classgroup && layer->numclasses > 0)
+    classgroup = msAllocateValidClassGroups(layer, &nclasses);
+
+  if (layer->minfeaturesize > 0)
+    minfeaturesize = Pix2LayerGeoref(map, layer, layer->minfeaturesize);
+
+  // Select how to render classes
+  //    MS_FIRST_MATCHING_CLASS: Default and historic MapServer behavior
+  //    MS_ALL_MATCHING_CLASSES: SLD behavior
+  int ref_rendermode;
+  const char *rendermodestr = msLayerGetProcessingKey(layer, "RENDERMODE");
+  if (layer->rendermode == MS_ALL_MATCHING_CLASSES) {
+    // SLD takes precedence
+    ref_rendermode = MS_ALL_MATCHING_CLASSES;
+  } else if (!rendermodestr) {
+    // Default Mapfile
+    ref_rendermode = MS_FIRST_MATCHING_CLASS;
+  } else if (!strcmp(rendermodestr, "FIRST_MATCHING_CLASS")) {
+    // Explicit default Mapfile
+    ref_rendermode = MS_FIRST_MATCHING_CLASS;
+  } else if (!strcmp(rendermodestr, "ALL_MATCHING_CLASSES")) {
+    // SLD-like Mapfile
+    ref_rendermode = MS_ALL_MATCHING_CLASSES;
+  } else {
+    msLayerClose(layer);
+    msSetError(MS_MISCERR,
+               "Unknown RENDERMODE: %s, should be one of: "
+               "FIRST_MATCHING_CLASS, ALL_MATCHING_CLASSES.",
+               "msDrawVectorLayer()", rendermodestr);
+    return MS_FAILURE;
+  }
+
+  /* step through the target shapes and their classes */
+  msInitShape(&shape);
+  int classindex = -1;
+  int classcount = 0;
+  for (;;) {
+    int rendermode;
+    if (classindex == -1) {
+      msFreeShape(&shape);
+      status = msLayerNextShape(layer, &shape);
+      if (status != MS_SUCCESS) {
+        break;
+      }
+
+      /* Check if the shape size is ok to be drawn */
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0) &&
+          (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE)) {
+        if (layer->debug >= MS_DEBUGLEVEL_V)
+          msDebug("msDrawVectorLayer(): Skipping shape (%ld) because "
+                  "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                  shape.index);
+        continue;
+      }
+      classcount = 0;
+    }
+
+    classindex = msShapeGetNextClass(classindex, layer, map, &shape, classgroup,
+                                     nclasses);
+    if ((classindex == -1) || (layer->class[classindex] -> status == MS_OFF)) {
+      continue;
+    }
+    shape.classindex = classindex;
+
+    // When only one class is applicable, rendering mode is forced to its
+    // default, i.e. only the first applicable class is actually applied. As a
+    // consequence, cache can be enabled when relevant.
+    classcount++;
+    rendermode = ref_rendermode;
+    if ((classcount == 1) &&
+        (msShapeGetNextClass(classindex, layer, map, &shape, classgroup,
+                             nclasses) == -1)) {
+      rendermode = MS_FIRST_MATCHING_CLASS;
+    }
+
+    if (rendermode == MS_FIRST_MATCHING_CLASS) {
+      classindex = -1;
+    }
+
+    if (maxfeatures >= 0 && featuresdrawn >= maxfeatures) {
+      status = MS_DONE;
+      break;
+    }
+    featuresdrawn++;
+
+    cache = MS_FALSE;
+    if (layer->type == MS_LAYER_LINE &&
+        (layer->class[shape.classindex]
+         -> numstyles > 1 ||
+                (layer->class[shape.classindex]
+                 -> numstyles == 1 &&
+                        (layer->class[shape.classindex] -> styles[0]
+                         -> outlinewidth > 0 ||
+                                layer -> class[shape.classindex] -> styles[0]
+                         -> bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index !=
+                                -1)))) {
+      cache = MS_TRUE; /* only line layers with multiple styles need be cached
+                          (I don't think POLYLINE layers need caching - SDL) */
+      // we also cache line layers with outlinewidths
+    }
+
+    /* With 'STYLEITEM AUTO', we will have the datasource fill the class' */
+    /* style parameters for this shape. */
+    if (layer->styleitem) {
+      if (strcasecmp(layer->styleitem, "AUTO") == 0) {
+        if (msLayerGetAutoStyle(map, layer, layer->class[shape.classindex],
+                                &shape) != MS_SUCCESS) {
+          retcode = MS_FAILURE;
+          break;
+        }
+      } else {
+        /* Generic feature style handling as per RFC-61 */
+        if (msLayerGetFeatureStyle(map, layer, layer->class[shape.classindex],
+                                   &shape) != MS_SUCCESS) {
+          retcode = MS_FAILURE;
+          break;
+        }
+      }
+
+      /* __TODO__ For now, we can't cache features with 'AUTO' style */
+      cache = MS_FALSE;
+    }
+
+    if (rendermode == MS_ALL_MATCHING_CLASSES) {
+      // Cache is designed to handle only one class. Therefore it is
+      // disabled when using SLD "painters model" rendering mode.
+      cache = MS_FALSE;
+    }
+
+    /* RFC77 TODO: check return value, may need a more sophisticated if-then
+     * test. */
+    if (annotate && layer->class[shape.classindex] -> numlabels > 0) {
+      drawmode |= MS_DRAWMODE_LABELS;
+      if (msLayerGetProcessingKey(layer, "LABEL_NO_CLIP")) {
+        drawmode |= MS_DRAWMODE_UNCLIPPEDLABELS;
+      }
+    }
+
+    if (layer->type == MS_LAYER_LINE &&
+        msLayerGetProcessingKey(layer, "POLYLINE_NO_CLIP")) {
+      drawmode |= MS_DRAWMODE_UNCLIPPEDLINES;
+    }
+
+    if (rendermode == MS_ALL_MATCHING_CLASSES) {
+      // In SLD "painters model" rendering mode, all applicable classes are
+      // actually applied. Coordinates stored in the shape must keep their
+      // original values for the shape to be drawn multiple times. Here the
+      // original shape is saved.
+      msInitShape(&savedShape);
+      msCopyShape(&shape, &savedShape);
+    }
+
+    if (cache) {
+      styleObj *pStyle = layer->class[shape.classindex]->styles[0];
+
+      // first ensure the style properties are bound to the shape
+      // any outlinewidth bindings will then be set
+      if (msBindLayerToShape(layer, &shape, drawmode) != MS_SUCCESS) {
+        retcode = MS_FAILURE;
+        break;
+      }
+
+      if (pStyle->outlinewidth > 0) {
+        /*
+         * RFC 49 implementation
+         * if an outlinewidth is used:
+         *  - augment the style's width to account for the outline width
+         *  - swap the style color and outlinecolor
+         *  - draw the shape (the outline) in the first pass of the
+         *    caching mechanism
+         */
+        msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
+      }
+      /* draw a single style */
+      status = msDrawShape(map, layer, &shape, image, 0,
+                           drawmode | MS_DRAWMODE_SINGLESTYLE);
+
+      if (pStyle->outlinewidth > 0) {
+        /*
+         * RFC 49 implementation: switch back the styleobj to its
+         * original state, so the line fill will be drawn in the
+         * second pass of the caching mechanism
+         */
+        msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
+      }
+    } else {
+      status =
+          msDrawShape(map, layer, &shape, image, -1, drawmode); /* all styles */
+    }
+
+    if (rendermode == MS_ALL_MATCHING_CLASSES) {
+      // In SLD "painters model" rendering mode, all applicable classes are
+      // actually applied. Coordinates stored in the shape must keep their
+      // original values for the shape to be drawn multiple times. Here the
+      // original shape is restored.
+      msFreeShape(&shape);
+      msCopyShape(&savedShape, &shape);
+      msFreeShape(&savedShape);
+    }
+
+    if (status != MS_SUCCESS) {
+      retcode = MS_FAILURE;
+      break;
+    }
+
+    if (shape.numlines ==
+        0) { /* once clipped the shape didn't need to be drawn */
+      continue;
+    }
+
+    if (cache) {
+      if (insertFeatureList(&shpcache, &shape) == NULL) {
+        retcode = MS_FAILURE; /* problem adding to the cache */
+        break;
+      }
+    }
+
+    maxnumstyles =
+        MS_MAX(maxnumstyles, layer->class[shape.classindex] -> numstyles);
+  }
+  msFreeShape(&shape);
+
+  if (classgroup)
+    msFree(classgroup);
+
+  if (status != MS_DONE || retcode == MS_FAILURE) {
+    msLayerClose(layer);
+    if (shpcache) {
+      freeFeatureList(shpcache);
+      shpcache = NULL;
+    }
+    return MS_FAILURE;
+  }
+
+  if (shpcache && MS_DRAW_FEATURES(drawmode)) {
+    int s;
+    for (s = 0; s < maxnumstyles; s++) {
+      for (current = shpcache; current; current = current->next) {
+        if (layer->class[current->shape.classindex] -> numstyles > s) {
+          styleObj *pStyle = layer->class[current->shape.classindex]->styles[s];
+          if (pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
+            continue; /*skip this as it has already been rendered*/
+          if (map->scaledenom > 0) {
+            if ((pStyle->maxscaledenom != -1) &&
+                (map->scaledenom >= pStyle->maxscaledenom))
+              continue;
+            if ((pStyle->minscaledenom != -1) &&
+                (map->scaledenom < pStyle->minscaledenom))
+              continue;
+          }
+          if (s == 0 &&
+              (pStyle->outlinewidth > 0 ||
+               pStyle->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index != -1) &&
+              MS_VALID_COLOR(pStyle->color)) {
+            if (MS_UNLIKELY(MS_FAILURE ==
+                            msDrawLineSymbol(map, image, &current->shape,
+                                             pStyle, pStyle->scalefactor))) {
+              return MS_FAILURE;
+            }
+          } else if (s > 0) {
+            if ((pStyle->outlinewidth > 0 ||
+                 pStyle->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index != -1) &&
+                MS_VALID_COLOR(pStyle->outlinecolor)) {
+              /*
+               * RFC 49 implementation
+               * if an outlinewidth is used:
+               *  - augment the style's width to account for the outline width
+               *  - swap the style color and outlinecolor
+               *  - draw the shape (the outline) in the first pass of the
+               *    caching mechanism
+               */
+              msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor))) {
+                return MS_FAILURE;
+              }
+              /*
+               * RFC 49 implementation: switch back the styleobj to its
+               * original state, so the line fill will be drawn in the
+               * second pass of the caching mechanism
+               */
+              msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
+            }
+            /* draw a valid line, i.e. one with a color defined or of type
+             * pixmap*/
+            if (MS_VALID_COLOR(pStyle->color) ||
+                (pStyle->symbol < map->symbolset.numsymbols &&
+                 (map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_PIXMAP ||
+                  map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_SVG))) {
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor)))
+                return MS_FAILURE;
+            }
+          }
+        }
+      }
+    }
+
+    freeFeatureList(shpcache);
+    shpcache = NULL;
+  }
+
+  msLayerClose(layer);
+  return MS_SUCCESS;
+}
+
+/*
+** Function to draw a layer IF it already has a result cache associated with it.
+*Called by msDrawMap and via MapScript.
+*/
+int msDrawQueryLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  int i, status;
+  char annotate = MS_TRUE, cache = MS_FALSE;
+  int drawmode = MS_DRAWMODE_FEATURES;
+  shapeObj shape;
+  int maxnumstyles = 1;
+
+  featureListNodeObjPtr shpcache = NULL, current = NULL;
+
+  colorObj *colorbuffer = NULL;
+  int *mindistancebuffer = NULL;
+
+  if (!layer->resultcache)
+    return (msDrawLayer(map, layer, image));
+
+  if (!msLayerIsVisible(map, layer))
+    return (MS_SUCCESS); /* not an error, just nothing to do */
+
+  /* conditions may have changed since this layer last drawn, so reset
+     layer->project to recheck projection needs (Bug #673) */
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
+
+  /* set annotation status */
+  annotate = msEvalContext(map, layer, layer->labelrequires);
+  if (map->scaledenom > 0) {
+    if ((layer->labelmaxscaledenom != -1) &&
+        (map->scaledenom >= layer->labelmaxscaledenom))
+      annotate = MS_FALSE;
+    if ((layer->labelminscaledenom != -1) &&
+        (map->scaledenom < layer->labelminscaledenom))
+      annotate = MS_FALSE;
+  }
+
+  /*
+  ** Certain query map styles require us to render all features only (MS_NORMAL)
+  *or first (MS_HILITE). With
+  ** single-pass queries we have to make a copy of the layer and work from it
+  *instead.
+  */
+  if (map->querymap.style == MS_NORMAL || map->querymap.style == MS_HILITE) {
+    layerObj tmp_layer;
+
+    if (initLayer(&tmp_layer, map) == -1)
+      return (MS_FAILURE);
+
+    if (msCopyLayer(&tmp_layer, layer) != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    /* disable the connection pool for this layer */
+    msLayerSetProcessingKey(&tmp_layer, "CLOSE_CONNECTION", "ALWAYS");
+
+    status = msDrawLayer(map, &tmp_layer, image);
+
+    freeLayer(&tmp_layer);
+
+    if (map->querymap.style == MS_NORMAL || status != MS_SUCCESS)
+      return (status);
+  }
+
+  /* if MS_HILITE, alter the one style (always at least 1 style), and set a
+   * MINDISTANCE for the labelObj to avoid duplicates */
+  if (map->querymap.style == MS_HILITE) {
+
+    drawmode |= MS_DRAWMODE_QUERY;
+
+    if (layer->numclasses > 0) {
+      colorbuffer =
+          (colorObj *)msSmallMalloc(layer->numclasses * sizeof(colorObj));
+      mindistancebuffer = (int *)msSmallMalloc(layer->numclasses * sizeof(int));
+    }
+
+    for (i = 0; i < layer->numclasses; i++) {
+      if (layer->type == MS_LAYER_POLYGON &&
+              layer->class[i] -> numstyles >
+                                     0) { /* alter BOTTOM style since that's
+                                             almost always the fill */
+        if (layer->class[i] -> styles == NULL) {
+          msSetError(MS_MISCERR,
+                     "Don't know how to draw class %s of layer %s without a "
+                     "style definition.",
+                     "msDrawQueryLayer()", layer->class[i] -> name,
+                     layer -> name);
+          msFree(colorbuffer);
+          msFree(mindistancebuffer);
+          return (MS_FAILURE);
+        }
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[0]
+                  ->color; /* save the color from the BOTTOM style */
+          layer->class[i]->styles[0]->color = map->querymap.color;
+        } else if (MS_VALID_COLOR(
+                       layer->class[i] -> styles[0] -> outlinecolor)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[0]
+                  ->outlinecolor; /* if no color, save the outlinecolor from the
+                                     BOTTOM style */
+          layer->class[i]->styles[0]->outlinecolor = map->querymap.color;
+        }
+      } else if (layer->type == MS_LAYER_LINE &&
+                     layer->class[i] -> numstyles > 0 &&
+                                            layer -> class[i] -> styles[0]
+                 -> outlinewidth >
+                        0) { /* alter BOTTOM style for lines with outlines */
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[0]
+                  ->color; /* save the color from the BOTTOM style */
+          layer->class[i]->styles[0]->color = map->querymap.color;
+        } /* else ??? */
+      } else if (layer->class[i] -> numstyles > 0) {
+        if (MS_VALID_COLOR(
+                layer->class[i] -> styles[layer->class[i] -> numstyles - 1]
+                -> color)) {
+          colorbuffer[i] = layer->class[i]
+                               ->styles[layer->class[i] -> numstyles - 1]
+                               ->color; /* save the color from the TOP style */
+          layer->class[i]->styles[layer->class[i] -> numstyles - 1]->color =
+              map->querymap.color;
+        } else if (MS_VALID_COLOR(layer->class[i]
+                                  -> styles[layer->class[i] -> numstyles - 1]
+                                  -> outlinecolor)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[layer->class[i] -> numstyles - 1]
+                  ->outlinecolor; /* if no color, save the outlinecolor from the
+                                     TOP style */
+          layer->class[i]
+              ->styles[layer->class[i] -> numstyles - 1]
+              ->outlinecolor = map->querymap.color;
+        }
+      } else if (layer->class[i] -> numlabels > 0) {
+        colorbuffer[i] = layer->class[i]->labels[0]->color;
+        layer->class[i]->labels[0]->color = map->querymap.color;
+      } /* else ??? */
+
+      mindistancebuffer[i] =
+          -1; /* RFC77 TODO: only using the first label, is that cool? */
+      if (layer->class[i] -> numlabels > 0) {
+        mindistancebuffer[i] = layer->class[i]->labels[0]->mindistance;
+        layer->class[i]->labels[0]->mindistance =
+            MS_MAX(0, layer->class[i] -> labels[0] -> mindistance);
+      }
+    }
+  }
+
+  /*
+  ** Layer was opened as part of the query process, msLayerWhichItems() has also
+  *been run, shapes have been classified - start processing!
+  */
+
+  msInitShape(&shape);
+
+  for (i = 0; i < layer->resultcache->numresults; i++) {
+    status = msLayerGetShape(layer, &shape, &(layer->resultcache->results[i]));
+    if (status != MS_SUCCESS) {
+      msFree(colorbuffer);
+      msFree(mindistancebuffer);
+      return (MS_FAILURE);
+    }
+
+    shape.classindex = layer->resultcache->results[i].classindex;
+    /* classindex may be -1 here if there was a template at the top level
+     * in this layer and the current shape selected even if it didn't
+     * match any class
+     *
+     * FrankW: classindex is also sometimes 0 even if there are no classes, so
+     * we are careful not to use out of range class values as an index.
+     */
+    if (shape.classindex == -1 || shape.classindex >= layer->numclasses ||
+            layer->class[shape.classindex] -> status == MS_OFF) {
+      msFreeShape(&shape);
+      continue;
+    }
+
+    cache = MS_FALSE;
+    if (layer->type == MS_LAYER_LINE &&
+        (layer->class[shape.classindex]
+         -> numstyles > 1 ||
+                (layer->class[shape.classindex]
+                 -> numstyles == 1 &&
+                        (layer->class[shape.classindex] -> styles[0]
+                         -> outlinewidth > 0 ||
+                                layer -> class[shape.classindex] -> styles[0]
+                         -> bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index !=
+                                -1)))) {
+      cache = MS_TRUE; /* only line layers with multiple styles need be cached
+                          (I don't think POLYLINE layers need caching - SDL) */
+    }
+
+    if (annotate && layer->class[shape.classindex] -> numlabels > 0) {
+      drawmode |= MS_DRAWMODE_LABELS;
+    }
+
+    if (cache) {
+      styleObj *pStyle = layer->class[shape.classindex]->styles[0];
+
+      if (msBindLayerToShape(layer, &shape, drawmode) == MS_SUCCESS) {
+        if (pStyle->outlinewidth > 0) {
+          msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
+        }
+        /* draw only the first style */
+        status = msDrawShape(map, layer, &shape, image, 0,
+                             drawmode | MS_DRAWMODE_SINGLESTYLE);
+        if (pStyle->outlinewidth > 0) {
+          msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
+        }
+      }
+    } else {
+      /* all styles */
+      status = msDrawShape(map, layer, &shape, image, -1, drawmode);
+    }
+
+    if (status != MS_SUCCESS) {
+      msLayerClose(layer);
+      msFree(colorbuffer);
+      msFree(mindistancebuffer);
+      return (MS_FAILURE);
+    }
+
+    if (shape.numlines ==
+        0) { /* once clipped the shape didn't need to be drawn */
+      msFreeShape(&shape);
+      continue;
+    }
+
+    if (cache) {
+      if (insertFeatureList(&shpcache, &shape) == NULL) {
+        msFree(colorbuffer);
+        msFree(mindistancebuffer);
+        return (MS_FAILURE); /* problem adding to the cache */
+      }
+    }
+
+    maxnumstyles =
+        MS_MAX(maxnumstyles, layer->class[shape.classindex] -> numstyles);
+    msFreeShape(&shape);
+  }
+
+  if (shpcache) {
+    int s;
+    for (s = 0; s < maxnumstyles; s++) {
+      for (current = shpcache; current; current = current->next) {
+        if (layer->class[current->shape.classindex] -> numstyles > s) {
+          styleObj *pStyle = layer->class[current->shape.classindex]->styles[s];
+          if (pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
+            continue; /* skip this as it has already been rendered */
+          if (map->scaledenom > 0) {
+            if ((pStyle->maxscaledenom != -1) &&
+                (map->scaledenom >= pStyle->maxscaledenom))
+              continue;
+            if ((pStyle->minscaledenom != -1) &&
+                (map->scaledenom < pStyle->minscaledenom))
+              continue;
+          }
+          if (s == 0 && pStyle->outlinewidth > 0 &&
+              MS_VALID_COLOR(pStyle->color)) {
+            if (MS_UNLIKELY(MS_FAILURE ==
+                            msDrawLineSymbol(map, image, &current->shape,
+                                             pStyle, pStyle->scalefactor))) {
+              return MS_FAILURE;
+            }
+          } else if (s > 0) {
+            if (pStyle->outlinewidth > 0 &&
+                MS_VALID_COLOR(pStyle->outlinecolor)) {
+              msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor))) {
+                return MS_FAILURE;
+              }
+              msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
+            }
+            /* draw a valid line, i.e. one with a color defined or of type
+             * pixmap */
+            if (MS_VALID_COLOR(pStyle->color) ||
+                (pStyle->symbol < map->symbolset.numsymbols &&
+                 (map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_PIXMAP ||
+                  map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_SVG))) {
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor)))
+                return MS_FAILURE;
+            }
+          }
+        }
+      }
+    }
+
+    freeFeatureList(shpcache);
+    shpcache = NULL;
+  }
+
+  /* if MS_HILITE, restore color and mindistance values */
+  if (map->querymap.style == MS_HILITE) {
+    for (i = 0; i < layer->numclasses; i++) {
+      if (layer->type == MS_LAYER_POLYGON && layer->class[i] -> numstyles > 0) {
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color))
+          layer->class[i]->styles[0]->color = colorbuffer[i];
+        else if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> outlinecolor))
+          layer->class[i]->styles[0]->outlinecolor =
+              colorbuffer[i]; /* if no color, restore outlinecolor for the
+                                 BOTTOM style */
+      } else if (layer->type == MS_LAYER_LINE &&
+                     layer->class[i] -> numstyles > 0 && layer -> class[i]
+                 -> styles[0] -> outlinewidth > 0) {
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color))
+          layer->class[i]->styles[0]->color = colorbuffer[i];
+      } else if (layer->class[i] -> numstyles > 0) {
+        if (MS_VALID_COLOR(
+                layer->class[i] -> styles[layer->class[i] -> numstyles - 1]
+                -> color))
+          layer->class[i]->styles[layer->class[i] -> numstyles - 1]->color =
+              colorbuffer[i];
+        else if (MS_VALID_COLOR(
+                     layer->class[i] -> styles[layer->class[i] -> numstyles - 1]
+                     -> outlinecolor))
+          layer->class[i]
+              ->styles[layer->class[i] -> numstyles - 1]
+              ->outlinecolor =
+              colorbuffer[i]; /* if no color, restore outlinecolor for the TOP
+                                 style */
+      } else if (layer->class[i] -> numlabels > 0) {
+        if (MS_VALID_COLOR(layer->class[i] -> labels[0] -> color))
+          layer->class[i]->labels[0]->color = colorbuffer[i];
+      }
+
+      if (layer->class[i] -> numlabels > 0)
+        layer->class[i]->labels[0]->mindistance =
+            mindistancebuffer[i]; /* RFC77 TODO: again, only using the first
+                                     label, is that cool? */
+    }
+
+    msFree(colorbuffer);
+    msFree(mindistancebuffer);
+  }
+
+  return (MS_SUCCESS);
+}
+
+/**
+ * msDrawRasterLayerPlugin()
+ */
+
+static int msDrawRasterLayerPlugin(mapObj *map, layerObj *layer,
+                                   imageObj *image)
+
+{
+  rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
+  rasterBufferObj *rb = msSmallCalloc(1, sizeof(rasterBufferObj));
+  int ret;
+  if (renderer->supports_pixel_buffer) {
+    if (MS_SUCCESS != renderer->getRasterBufferHandle(image, rb)) {
+      msSetError(MS_MISCERR, "renderer failed to extract raster buffer",
+                 "msDrawRasterLayer()");
+      return MS_FAILURE;
+    }
+    ret = msDrawRasterLayerLow(map, layer, image, rb);
+  } else {
+    if (MS_SUCCESS != renderer->initializeRasterBuffer(
+                          rb, image->width, image->height, MS_IMAGEMODE_RGBA)) {
+      msSetError(MS_MISCERR, "renderer failed to create raster buffer",
+                 "msDrawRasterLayer()");
+      return MS_FAILURE;
+    }
+
+    ret = msDrawRasterLayerLow(map, layer, image, rb);
+
+    if (ret == 0) {
+      ret = renderer->mergeRasterBuffer(image, rb, 1.0, 0, 0, 0, 0, rb->width,
+                                        rb->height);
+    }
+
+    msFreeRasterBuffer(rb);
+  }
+#define RB_GET_R(rb, x, y)                                                     \
+  *((rb)->data.rgba.r + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
+#define RB_GET_G(rb, x, y)                                                     \
+  *((rb)->data.rgba.g + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
+#define RB_GET_B(rb, x, y)                                                     \
+  *((rb)->data.rgba.b + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
+#define RB_GET_A(rb, x, y)                                                     \
+  *((rb)->data.rgba.a + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
+
+  free(rb);
+
+  return ret;
+}
+
+/**
+ * Generic function to render raster layers.
+ */
+int msDrawRasterLayer(mapObj *map, layerObj *layer, imageObj *image) {
+
+  int rv = MS_FAILURE;
+  if (!image || !map || !layer) {
+    return rv;
+  }
+
+  /* RFC-86 Scale dependant token replacements*/
+  rv = msLayerApplyScaletokens(layer,
+                               (layer->map) ? layer->map->scaledenom : -1);
+  if (rv != MS_SUCCESS)
+    return rv;
+  if (MS_RENDERER_PLUGIN(image->format))
+    rv = msDrawRasterLayerPlugin(map, layer, image);
+  else if (MS_RENDERER_RAWDATA(image->format))
+    rv = msDrawRasterLayerLow(map, layer, image, NULL);
+  msLayerRestoreFromScaletokens(layer);
+  return rv;
+}
+
+/**
+ * msDrawWMSLayer()
+ *
+ * Draw a single WMS layer.
+ * Multiple WMS layers in a map are preloaded and then drawn using
+ * msDrawWMSLayerLow()
+ */
+
+#ifdef USE_WMS_LYR
+int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  int nStatus = MS_FAILURE;
+
+  if (image && map && layer) {
+    /* ------------------------------------------------------------------
+     * Start by downloading the layer
+     * ------------------------------------------------------------------ */
+    httpRequestObj asReqInfo[2];
+    int numReq = 0;
+
+    msHTTPInitRequestObj(asReqInfo, 2);
+
+    if (msPrepareWMSLayerRequest(1, map, layer, 1, 0, NULL, 0, 0, 0, NULL,
+                                 asReqInfo, &numReq) == MS_FAILURE ||
+        msOWSExecuteRequests(asReqInfo, numReq, map, MS_TRUE) == MS_FAILURE) {
+      return MS_FAILURE;
+    }
+
+    /* ------------------------------------------------------------------
+     * Then draw layer based on output format
+     * ------------------------------------------------------------------ */
+    if (MS_RENDERER_PLUGIN(image->format))
+      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq, map, layer, image);
+    else if (MS_RENDERER_RAWDATA(image->format))
+      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq, map, layer, image);
+
+    else {
+      msSetError(MS_WMSCONNERR,
+                 "Output format '%s' doesn't support WMS layers.",
+                 "msDrawWMSLayer()", image->format->name);
+      nStatus = MS_SUCCESS; /* Should we fail if output doesn't support WMS? */
+    }
+    /* Cleanup */
+    msHTTPFreeRequestObj(asReqInfo, numReq);
+  }
+
+  return nStatus;
+}
+#endif
+
+int circleLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
+                         shapeObj *shape) {
+  pointObj center;
+  double r;
+  int s;
+  int c = shape->classindex;
+
+  if (shape->numlines != 1)
+    return (MS_SUCCESS); /* invalid shape */
+  if (shape->line[0].numpoints != 2)
+    return (MS_SUCCESS); /* invalid shape */
+
+  center.x = (shape->line[0].point[0].x + shape->line[0].point[1].x) / 2.0;
+  center.y = (shape->line[0].point[0].y + shape->line[0].point[1].y) / 2.0;
+  r = MS_ABS(center.x - shape->line[0].point[0].x);
+  if (r == 0)
+    r = MS_ABS(center.y - shape->line[0].point[0].y);
+  if (r == 0)
+    return (MS_SUCCESS);
+
+  if (layer->transform == MS_TRUE) {
+
+    if (layer->project)
+      msProjectPoint(&layer->projection, &map->projection, &center);
+
+    center.x = MS_MAP2IMAGE_X(center.x, map->extent.minx, map->cellsize);
+    center.y = MS_MAP2IMAGE_Y(center.y, map->extent.maxy, map->cellsize);
+    r /= map->cellsize;
+  } else
+    msOffsetPointRelativeTo(&center, layer);
+
+  for (s = 0; s < layer->class[c] -> numstyles; s++) {
+    if (msScaleInBounds(map->scaledenom,
+                        layer->class[c] -> styles[s] -> minscaledenom,
+                        layer -> class[c] -> styles[s] -> maxscaledenom))
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msCircleDrawShadeSymbol(
+                          map, image, &center, r, layer->class[c] -> styles[s],
+                          layer -> class[c] -> styles[s] -> scalefactor))) {
+        return MS_FAILURE;
+      }
+  }
+  return MS_SUCCESS;
+  /* TODO: need to handle circle annotation */
+}
+
+static int pointLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
+                               shapeObj *shape, int drawmode) {
+  int l, c = shape->classindex, j, i, s;
+  pointObj *point;
+  int ret = MS_FAILURE;
+
+  if (layer->project && layer->transform == MS_TRUE) {
+    reprojectionObj *reprojector = msLayerGetReprojectorToMap(layer, map);
+    if (reprojector == NULL) {
+      return MS_FAILURE;
+    }
+    msProjectShapeEx(reprojector, shape);
+  }
+
+  // Only take into account map rotation if the label and style angles are
+  // non-zero.
+  if (map->gt.rotation_angle) {
+    for (l = 0; l < layer->class[c] -> numlabels; l++) {
+      if (layer->class[c] -> labels[l] -> angle != 0)
+        layer->class[c]->labels[l]->angle -= map->gt.rotation_angle;
+    }
+
+    for (s = 0; s < layer->class[c] -> numstyles; s++) {
+      if (layer->class[c] -> styles[s] -> angle != 0)
+        layer->class[c]->styles[s]->angle -= map->gt.rotation_angle;
+    }
+  }
+
+  for (j = 0; j < shape->numlines; j++) {
+    for (i = 0; i < shape->line[j].numpoints; i++) {
+      point = &(shape->line[j].point[i]);
+      if (layer->transform == MS_TRUE) {
+        if (!msPointInRect(point, &map->extent))
+          continue; /* next point */
+        msTransformPoint(point, &map->extent, map->cellsize, image);
+      } else
+        msOffsetPointRelativeTo(point, layer);
+
+      if (MS_DRAW_FEATURES(drawmode)) {
+        for (s = 0; s < layer->class[c] -> numstyles; s++) {
+          if (msScaleInBounds(map->scaledenom,
+                              layer->class[c] -> styles[s] -> minscaledenom,
+                              layer -> class[c] -> styles[s] -> maxscaledenom))
+            if (MS_UNLIKELY(
+                    MS_FAILURE ==
+                    msDrawMarkerSymbol(
+                        map, image, point, layer->class[c] -> styles[s],
+                        layer -> class[c] -> styles[s] -> scalefactor))) {
+              goto end;
+            }
+        }
+      }
+      if (MS_DRAW_LABELS(drawmode)) {
+        if (layer->labelcache) {
+          if (msAddLabelGroup(map, image, layer, c, shape, point, -1) !=
+              MS_SUCCESS)
+            goto end;
+        } else {
+          for (l = 0; l < layer->class[c] -> numlabels; l++)
+            if (msGetLabelStatus(map, layer, shape,
+                                 layer->class[c] -> labels[l]) == MS_ON) {
+              char *annotext = msShapeGetLabelAnnotation(
+                  layer, shape, layer->class[c] -> labels[l]);
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLabel(map, image, *point, annotext,
+                                          layer->class[c] -> labels[l],
+                                          layer -> class[c] -> labels[l]
+                                          -> scalefactor))) {
+                goto end;
+              }
+            }
+        }
+      }
+    }
+  }
+  ret = MS_SUCCESS;
+
+end:
+  if (map->gt.rotation_angle) {
+    for (l = 0; l < layer->class[c] -> numlabels; l++) {
+      if (layer->class[c] -> labels[l] -> angle != 0)
+        layer->class[c]->labels[l]->angle += map->gt.rotation_angle;
+    }
+
+    for (s = 0; s < layer->class[c] -> numstyles; s++) {
+      if (layer->class[c] -> styles[s] -> angle != 0)
+        layer->class[c]->styles[s]->angle += map->gt.rotation_angle;
+    }
+  }
+
+  return ret;
+}
+
+int lineLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
+                       shapeObj *shape, shapeObj *anno_shape,
+                       shapeObj *unclipped_shape, int style, int drawmode) {
+  int c = shape->classindex;
+  int ret = MS_SUCCESS;
+
+  /* RFC48: loop through the styles, and pass off to the type-specific
+  function if the style has an appropriate type */
+  if (MS_DRAW_FEATURES(drawmode)) {
+    for (int s = 0; s < layer->class[c] -> numstyles; s++) {
+      if (msScaleInBounds(map->scaledenom,
+                          layer->class[c] -> styles[s] -> minscaledenom,
+                          layer -> class[c] -> styles[s] -> maxscaledenom)) {
+        if (layer->class[c] -> styles[s] -> _geomtransform.type !=
+                                                MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawTransformedShape(
+                              map, image, unclipped_shape,
+                              layer->class[c] -> styles[s],
+                              layer -> class[c] -> styles[s] -> scalefactor))) {
+            return MS_FAILURE;
+          }
+        } else if (!MS_DRAW_SINGLESTYLE(drawmode) || s == style) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawLineSymbol(
+                              map, image, shape, layer->class[c] -> styles[s],
+                              layer -> class[c] -> styles[s] -> scalefactor))) {
+            return MS_FAILURE;
+          }
+        }
+      }
+    }
+  }
+
+  if (MS_DRAW_LABELS(drawmode)) {
+    for (int l = 0; l < layer->class[c] -> numlabels; l++) {
+      labelObj *label = layer->class[c]->labels[l];
+      textSymbolObj ts;
+      char *annotext;
+      if (!msGetLabelStatus(map, layer, shape, label)) {
+        continue;
+      }
+
+      annotext = msShapeGetLabelAnnotation(layer, anno_shape, label);
+      if (!annotext)
+        continue;
+      initTextSymbol(&ts);
+      msPopulateTextSymbolForLabelAndString(
+          &ts, label, annotext, label->scalefactor, image->resolutionfactor,
+          layer->labelcache);
+
+      if (label->anglemode == MS_FOLLOW) { /* bug #1620 implementation */
+        struct label_follow_result lfr;
+
+        if (!layer->labelcache) {
+          msSetError(MS_MISCERR,
+                     "Angle mode 'FOLLOW' is supported only with labelcache on",
+                     "msDrawShape()");
+          ret = MS_FAILURE;
+          goto line_cleanup;
+        }
+
+        memset(&lfr, 0, sizeof(lfr));
+        msPolylineLabelPath(map, image, anno_shape, &ts, label, &lfr);
+
+        for (int i = 0; i < lfr.num_follow_labels; i++) {
+          if (msAddLabel(map, image, label, layer->index, c, anno_shape, NULL,
+                         -1, lfr.follow_labels[i]) != MS_SUCCESS) {
+            ret = MS_FAILURE;
+            goto line_cleanup;
+          }
+        }
+        free(lfr.follow_labels);
+        for (int i = 0; i < lfr.lar.num_label_points; i++) {
+          textSymbolObj *ts_auto = msSmallMalloc(sizeof(textSymbolObj));
+          initTextSymbol(ts_auto);
+          msCopyTextSymbol(ts_auto, &ts);
+          ts_auto->rotation = lfr.lar.angles[i];
+          {
+            if (msAddLabel(map, image, label, layer->index, c, anno_shape,
+                           &lfr.lar.label_points[i], -1,
+                           ts_auto) != MS_SUCCESS) {
+              ret = MS_FAILURE;
+              free(lfr.lar.angles);
+              free(lfr.lar.label_points);
+              goto line_cleanup;
+            }
+          }
+        }
+        free(lfr.lar.angles);
+        free(lfr.lar.label_points);
+      } else {
+        struct label_auto_result lar;
+        memset(&lar, 0, sizeof(struct label_auto_result));
+        ret = msPolylineLabelPoint(map, anno_shape, &ts, label, &lar,
+                                   image->resolutionfactor);
+        if (MS_UNLIKELY(MS_FAILURE == ret))
+          goto line_cleanup;
+
+        if (label->angle != 0)
+          label->angle -= map->gt.rotation_angle; /* apply rotation angle */
+
+        for (int i = 0; i < lar.num_label_points; i++) {
+          textSymbolObj *ts_auto = msSmallMalloc(sizeof(textSymbolObj));
+          initTextSymbol(ts_auto);
+          msCopyTextSymbol(ts_auto, &ts);
+          ts_auto->rotation = lar.angles[i];
+          if (layer->labelcache) {
+            if (msAddLabel(map, image, label, layer->index, c, anno_shape,
+                           &lar.label_points[i], -1, ts_auto) != MS_SUCCESS) {
+              ret = MS_FAILURE;
+              free(lar.angles);
+              free(lar.label_points);
+              freeTextSymbol(ts_auto);
+              free(ts_auto);
+              goto line_cleanup;
+            }
+          } else {
+            if (!ts_auto->textpath) {
+              if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts_auto))) {
+                ret = MS_FAILURE;
+                free(lar.angles);
+                free(lar.label_points);
+                freeTextSymbol(ts_auto);
+                free(ts_auto);
+                goto line_cleanup;
+              }
+            }
+            ret = msDrawTextSymbol(map, image, lar.label_points[i], ts_auto);
+            freeTextSymbol(ts_auto);
+            free(ts_auto); /* TODO RFC98: could we not re-use the original ts
+                            * instead of duplicating into ts_auto ? we cannot
+                            * for now, as the rendering code will modify the
+                            * glyph positions to apply the labelpoint and
+                            * rotation offsets */
+            ts_auto = NULL;
+            if (MS_UNLIKELY(MS_FAILURE == ret))
+              goto line_cleanup;
+          }
+        }
+        free(lar.angles);
+        free(lar.label_points);
+      }
+
+    line_cleanup:
+      /* clean up and reset */
+      if (ret == MS_FAILURE) {
+        break; /* from the label looping */
+      }
+      freeTextSymbol(&ts);
+    } /* next label */
+  }
+
+  return ret;
+}
+
+int polygonLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
+                          shapeObj *shape, shapeObj *anno_shape,
+                          shapeObj *unclipped_shape, int drawmode) {
+
+  int c = shape->classindex;
+  pointObj annopnt = {0}; // initialize
+  int i;
+
+  if (MS_DRAW_FEATURES(drawmode)) {
+    for (i = 0; i < layer->class[c] -> numstyles; i++) {
+      if (msScaleInBounds(map->scaledenom,
+                          layer->class[c] -> styles[i] -> minscaledenom,
+                          layer -> class[c] -> styles[i] -> maxscaledenom)) {
+        if (layer->class[c] -> styles[i] -> _geomtransform.type ==
+                                                MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawShadeSymbol(
+                              map, image, shape, layer->class[c] -> styles[i],
+                              layer -> class[c] -> styles[i] -> scalefactor))) {
+            return MS_FAILURE;
+          }
+        } else {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawTransformedShape(
+                              map, image, unclipped_shape,
+                              layer->class[c] -> styles[i],
+                              layer -> class[c] -> styles[i] -> scalefactor))) {
+            return MS_FAILURE;
+          }
+        }
+      }
+    }
+  }
+
+  if (MS_DRAW_LABELS(drawmode)) {
+    if (layer->class[c] -> numlabels > 0) {
+      double minfeaturesize =
+          layer->class[c]->labels[0]->minfeaturesize * image->resolutionfactor;
+      if (msPolygonLabelPoint(anno_shape, &annopnt, minfeaturesize) ==
+          MS_SUCCESS) {
+        for (i = 0; i < layer->class[c] -> numlabels; i++)
+          if (layer->class[c] -> labels[i] -> angle != 0)
+            layer->class[c]->labels[i]->angle -=
+                map->gt.rotation_angle; /* TODO: is this correct ??? */
+        if (layer->labelcache) {
+          if (msAddLabelGroup(map, image, layer, c, anno_shape, &annopnt,
+                              MS_MIN(shape->bounds.maxx - shape->bounds.minx,
+                                     shape->bounds.maxy -
+                                         shape->bounds.miny)) != MS_SUCCESS) {
+            return MS_FAILURE;
+          }
+        } else {
+          for (i = 0; i < layer->class[c] -> numlabels; i++)
+            if (msGetLabelStatus(map, layer, shape,
+                                 layer->class[c] -> labels[i]) == MS_ON) {
+              char *annotext = msShapeGetLabelAnnotation(
+                  layer, shape,
+                  layer->class[c]
+                  -> labels[i]); /*ownership taken by msDrawLabel, no need to
+                                    free */
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLabel(map, image, annopnt, annotext,
+                                          layer->class[c] -> labels[i],
+                                          layer -> class[c] -> labels[i]
+                                          -> scalefactor))) {
+                return MS_FAILURE;
+              }
+            }
+        }
+      }
+    }
+  }
+  return MS_SUCCESS;
+}
+
+/*
+** Function to render an individual shape, the style variable enables/disables
+*the drawing of a single style
+** versus a single style. This is necessary when drawing entire layers as proper
+*overlay can only be achieved
+** through caching. "querymapMode" parameter is used to tell msBindLayerToShape
+*to not override the
+** QUERYMAP HILITE color.
+*/
+int msDrawShape(mapObj *map, layerObj *layer, shapeObj *shape, imageObj *image,
+                int style, int drawmode) {
+  int c, s, ret = MS_SUCCESS;
+  shapeObj *anno_shape, *unclipped_shape = shape;
+  int bNeedUnclippedShape = MS_FALSE;
+  int bNeedUnclippedAnnoShape = MS_FALSE;
+  int bShapeNeedsClipping = MS_TRUE;
+
+  if (shape->numlines == 0 || shape->type == MS_SHAPE_NULL)
+    return MS_SUCCESS;
+
+  c = shape->classindex;
+
+  /* Before we do anything else, we will check for a rangeitem.
+     If its there, we need to change the style's color to map
+     the range to the shape */
+  for (s = 0; s < layer->class[c] -> numstyles; s++) {
+    styleObj *style = layer->class[c]->styles[s];
+    if (style->rangeitem != NULL)
+      msShapeToRange((layer->class[c] -> styles[s]), shape);
+  }
+
+  /* circle and point layers go through their own treatment */
+  if (layer->type == MS_LAYER_CIRCLE) {
+    if (msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS)
+      return MS_FAILURE;
+    msDrawStartShape(map, layer, image, shape);
+    ret = circleLayerDrawShape(map, image, layer, shape);
+    msDrawEndShape(map, layer, image, shape);
+    return ret;
+  } else if (layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_RASTER) {
+    if (msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS)
+      return MS_FAILURE;
+    msDrawStartShape(map, layer, image, shape);
+    ret = pointLayerDrawShape(map, image, layer, shape, drawmode);
+    msDrawEndShape(map, layer, image, shape);
+    return ret;
+  }
+
+  if (layer->type == MS_LAYER_POLYGON && shape->type != MS_SHAPE_POLYGON) {
+    msSetError(
+        MS_MISCERR,
+        "Only polygon shapes can be drawn using a polygon layer definition.",
+        "polygonLayerDrawShape()");
+    return (MS_FAILURE);
+  }
+  if (layer->type == MS_LAYER_LINE && shape->type != MS_SHAPE_POLYGON &&
+      shape->type != MS_SHAPE_LINE) {
+    msSetError(MS_MISCERR,
+               "Only polygon or line shapes can be drawn using a line layer "
+               "definition.",
+               "msDrawShape()");
+    return (MS_FAILURE);
+  }
+
+  if (layer->project && layer->transform == MS_TRUE) {
+    reprojectionObj *reprojector = msLayerGetReprojectorToMap(layer, map);
+    if (reprojector == NULL) {
+      return MS_FAILURE;
+    }
+    msProjectShapeEx(reprojector, shape);
+  }
+
+  /* check if we'll need the unclipped shape */
+  if (shape->type != MS_SHAPE_POINT) {
+    if (MS_DRAW_FEATURES(drawmode)) {
+      for (s = 0; s < layer->class[c] -> numstyles; s++) {
+        styleObj *style = layer->class[c]->styles[s];
+        if (style->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
+          bNeedUnclippedShape = MS_TRUE;
+      }
+    }
+    /* check if we need to clip the shape */
+    if (shape->bounds.minx < map->extent.minx ||
+        shape->bounds.miny < map->extent.miny ||
+        shape->bounds.maxx > map->extent.maxx ||
+        shape->bounds.maxy > map->extent.maxy) {
+      bShapeNeedsClipping = MS_TRUE;
+    }
+
+    if (MS_DRAW_LABELS(drawmode) && MS_DRAW_UNCLIPPED_LABELS(drawmode)) {
+      bNeedUnclippedAnnoShape = MS_TRUE;
+      bNeedUnclippedShape = MS_TRUE;
+    }
+
+    if (MS_DRAW_UNCLIPPED_LINES(drawmode)) {
+      bShapeNeedsClipping = MS_FALSE;
+    }
+  } else {
+    bShapeNeedsClipping = MS_FALSE;
+  }
+
+  if (layer->transform == MS_TRUE && bShapeNeedsClipping) {
+    /* compute the size of the clipping buffer, in pixels. This buffer must
+     account for the size of symbols drawn to avoid artifacts around the image
+     edges */
+    int clip_buf = 0;
+    int s;
+    rectObj cliprect;
+    for (s = 0; s < layer->class[c] -> numstyles; s++) {
+      double maxsize, maxunscaledsize;
+      symbolObj *symbol;
+      styleObj *style = layer->class[c]->styles[s];
+      if (!MS_IS_VALID_ARRAY_INDEX(style->symbol, map->symbolset.numsymbols)) {
+        msSetError(MS_SYMERR, "Invalid symbol index: %d", "msDrawShape()",
+                   style->symbol);
+        return MS_FAILURE;
+      }
+      symbol = map->symbolset.symbol[style->symbol];
+      if (symbol->type == MS_SYMBOL_PIXMAP) {
+        if (MS_SUCCESS != msPreloadImageSymbol(MS_MAP_RENDERER(map), symbol))
+          return MS_FAILURE;
+      } else if (symbol->type == MS_SYMBOL_SVG) {
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+        if (MS_SUCCESS != msPreloadSVGSymbol(symbol))
+          return MS_FAILURE;
+#else
+        msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                   "msDrawShape()");
+        return MS_FAILURE;
+#endif
+      }
+      maxsize = MS_MAX(msSymbolGetDefaultSize(symbol),
+                       MS_MAX(style->size, style->width));
+      maxunscaledsize = MS_MAX(style->minsize * image->resolutionfactor,
+                               style->minwidth * image->resolutionfactor);
+      if (shape->type == MS_SHAPE_POLYGON &&
+          !IS_PARALLEL_OFFSET(style->offsety)) {
+        maxsize += MS_MAX(fabs(style->offsety), fabs(style->offsetx));
+      }
+      clip_buf = MS_MAX(
+          clip_buf,
+          MS_NINT(MS_MAX(maxsize * style->scalefactor, maxunscaledsize) + 1));
+    }
+
+    /* if we need a copy of the unclipped shape, transform first, then clip to
+     * avoid transforming twice */
+    if (bNeedUnclippedShape) {
+      msTransformShape(shape, map->extent, map->cellsize, image);
+      if (shape->numlines == 0)
+        return MS_SUCCESS;
+      msComputeBounds(shape);
+
+      /* TODO: there's an optimization here that can be implemented:
+         - no need to allocate unclipped_shape for each call to this function
+         - the calls to msClipXXXRect will discard the original lineObjs,
+         whereas we have just copied them because they where needed. These two
+         functions could be changed so they are instructed not to free the
+         original lineObjs. */
+      unclipped_shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+      msInitShape(unclipped_shape);
+      msCopyShape(shape, unclipped_shape);
+      if (shape->type == MS_SHAPE_POLYGON) {
+        /* #179: additional buffer for polygons */
+        clip_buf += 2;
+      }
+
+      cliprect.minx = cliprect.miny = -clip_buf;
+      cliprect.maxx = image->width + clip_buf;
+      cliprect.maxy = image->height + clip_buf;
+      if (shape->type == MS_SHAPE_POLYGON) {
+        msClipPolygonRect(shape, cliprect);
+      } else {
+        assert(shape->type == MS_SHAPE_LINE);
+        msClipPolylineRect(shape, cliprect);
+      }
+      if (bNeedUnclippedAnnoShape) {
+        anno_shape = unclipped_shape;
+      } else {
+        anno_shape = shape;
+      }
+    } else {
+      /* clip first, then transform. This means we are clipping in geographical
+       * space */
+      double clip_buf_d;
+      if (shape->type == MS_SHAPE_POLYGON) {
+        /*
+         * add a small buffer around the cliping rectangle to
+         * avoid lines around the edges : #179
+         */
+        clip_buf += 2;
+      }
+      clip_buf_d = clip_buf * map->cellsize;
+      cliprect.minx = map->extent.minx - clip_buf_d;
+      cliprect.miny = map->extent.miny - clip_buf_d;
+      cliprect.maxx = map->extent.maxx + clip_buf_d;
+      cliprect.maxy = map->extent.maxy + clip_buf_d;
+      if (shape->type == MS_SHAPE_POLYGON) {
+        msClipPolygonRect(shape, cliprect);
+      } else {
+        assert(shape->type == MS_SHAPE_LINE);
+        msClipPolylineRect(shape, cliprect);
+      }
+      msTransformShape(shape, map->extent, map->cellsize, image);
+      msComputeBounds(shape);
+      anno_shape = shape;
+    }
+
+  } else {
+    /* the shape is fully in the map extent,
+     * or is a point type layer where out of bounds points are treated
+     * differently*/
+    if (layer->transform == MS_TRUE) {
+      msTransformShape(shape, map->extent, map->cellsize, image);
+      msComputeBounds(shape);
+    } else {
+      msOffsetShapeRelativeTo(shape, layer);
+    }
+    anno_shape = shape;
+  }
+  if (shape->numlines == 0) {
+    ret = MS_SUCCESS; /* error message is set in msBindLayerToShape() */
+    goto draw_shape_cleanup;
+  }
+
+  // if we are only drawing a single style then it may have been modified
+  // outside this function by msOutlineRenderingPrepareStyle and we don't want
+  // to rebind the style to the layer
+  if (style != 0) {
+    if (msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) {
+      ret = MS_FAILURE; /* error message is set in msBindLayerToShape() */
+      goto draw_shape_cleanup;
+    }
+  }
+
+  switch (layer->type) {
+  case MS_LAYER_LINE:
+    msDrawStartShape(map, layer, image, shape);
+    ret = lineLayerDrawShape(map, image, layer, shape, anno_shape,
+                             unclipped_shape, style, drawmode);
+    break;
+  case MS_LAYER_POLYGON:
+    msDrawStartShape(map, layer, image, shape);
+    ret = polygonLayerDrawShape(map, image, layer, shape, anno_shape,
+                                unclipped_shape, drawmode);
+    break;
+  case MS_LAYER_POINT:
+  case MS_LAYER_RASTER:
+    assert(0); // bug !
+  default:
+    msSetError(MS_MISCERR, "Unknown layer type.", "msDrawShape()");
+    ret = MS_FAILURE;
+  }
+
+draw_shape_cleanup:
+  msDrawEndShape(map, layer, image, shape);
+  if (unclipped_shape != shape) {
+    msFreeShape(unclipped_shape);
+    msFree(unclipped_shape);
+  }
+  return ret;
+}
+
+/*
+** Function to render an individual point, used as a helper function for
+*mapscript only. Since a point
+** can't carry attributes you can't do attribute based font size or angle.
+*/
+int msDrawPoint(mapObj *map, layerObj *layer, pointObj *point, imageObj *image,
+                int classindex, char *labeltext) {
+  int s, ret;
+  classObj *theclass = NULL;
+  labelObj *label = NULL;
+
+  if (layer->transform == MS_TRUE && layer->project &&
+      msProjectionsDiffer(&(layer->projection), &(map->projection))) {
+    msProjectPoint(&(layer->projection), &(map->projection), point);
+  }
+
+  if (classindex > layer->numclasses) {
+    msSetError(MS_MISCERR, "Invalid classindex (%d)", "msDrawPoint()",
+               classindex);
+    return MS_FAILURE;
+  }
+  theclass = layer->class[classindex];
+
+  if (labeltext && theclass->numlabels > 0) {
+    label = theclass->labels[0];
+  }
+
+  switch (layer->type) {
+  case MS_LAYER_POINT:
+    if (layer->transform == MS_TRUE) {
+      if (!msPointInRect(point, &map->extent))
+        return (0);
+      point->x = MS_MAP2IMAGE_X(point->x, map->extent.minx, map->cellsize);
+      point->y = MS_MAP2IMAGE_Y(point->y, map->extent.maxy, map->cellsize);
+    } else
+      msOffsetPointRelativeTo(point, layer);
+
+    for (s = 0; s < theclass->numstyles; s++) {
+      if (msScaleInBounds(map->scaledenom, theclass->styles[s]->minscaledenom,
+                          theclass->styles[s]->maxscaledenom))
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawMarkerSymbol(map, image, point,
+                                           theclass->styles[s],
+                                           theclass->styles[s]->scalefactor))) {
+          return MS_FAILURE;
+        }
+    }
+    if (label && labeltext && *labeltext) {
+      textSymbolObj *ts = msSmallMalloc(sizeof(textSymbolObj));
+      initTextSymbol(ts);
+      msPopulateTextSymbolForLabelAndString(
+          ts, label, msStrdup(labeltext), label->scalefactor,
+          image->resolutionfactor, layer->labelcache);
+      if (layer->labelcache) {
+        if (msAddLabel(map, image, label, layer->index, classindex, NULL, point,
+                       -1, ts) != MS_SUCCESS) {
+          return (MS_FAILURE);
+        }
+      } else {
+        if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
+          freeTextSymbol(ts);
+          free(ts);
+          return MS_FAILURE;
+        }
+        ret = msDrawTextSymbol(map, image, *point, ts);
+        freeTextSymbol(ts);
+        free(ts);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          return MS_FAILURE;
+      }
+    }
+    break;
+  default:
+    break; /* don't do anything with layer of other types */
+  }
+
+  return (MS_SUCCESS); /* all done, no cleanup */
+}
+
+/*
+** Draws a single label independently of the label cache. No collision avoidance
+*is performed.
+*/
+int msDrawLabel(mapObj *map, imageObj *image, pointObj labelPnt, char *string,
+                labelObj *label, double scalefactor) {
+  shapeObj labelPoly;
+  label_bounds lbounds = {0};
+  lineObj labelPolyLine;
+  pointObj labelPolyPoints[5];
+  textSymbolObj ts = {0};
+  int needLabelPoly = MS_TRUE;
+  int needLabelPoint = MS_TRUE;
+  int haveLabelText = MS_TRUE;
+
+  if (!string || !*string)
+    haveLabelText = MS_FALSE;
+
+  if (haveLabelText) {
+    initTextSymbol(&ts);
+    msPopulateTextSymbolForLabelAndString(&ts, label, string, scalefactor,
+                                          image->resolutionfactor, 0);
+    if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, &ts))) {
+      freeTextSymbol(&ts);
+      return MS_FAILURE;
+    }
+  }
+
+  labelPoly.line = &labelPolyLine; /* setup the label polygon structure */
+  labelPoly.numlines = 1;
+  lbounds.poly = &labelPolyLine; /* setup the label polygon structure */
+  labelPoly.line->point = labelPolyPoints;
+  labelPoly.line->numpoints = 5;
+
+  if (label->position != MS_XY) {
+    pointObj p = {0};
+
+    if (label->numstyles > 0) {
+      int i;
+
+      for (i = 0; i < label->numstyles; i++) {
+        if (label->styles[i]->_geomtransform.type ==
+                MS_GEOMTRANSFORM_LABELPOINT ||
+            label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawMarkerSymbol(map, image, &labelPnt,
+                                             label->styles[i], scalefactor))) {
+            if (haveLabelText)
+              freeTextSymbol(&ts);
+            return MS_FAILURE;
+          }
+        } else if (haveLabelText && (label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELPOLY ||
+                                     label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELCENTER)) {
+          if (needLabelPoly) {
+            p = get_metrics(&labelPnt, label->position, ts.textpath,
+                            label->offsetx * ts.scalefactor,
+                            label->offsety * ts.scalefactor, ts.rotation, 1,
+                            &lbounds);
+            if (!lbounds.poly) {
+              /* we need the full shape to draw the label background */
+              labelPolyPoints[0].x = labelPolyPoints[4].x = lbounds.bbox.minx;
+              labelPolyPoints[0].y = labelPolyPoints[4].y = lbounds.bbox.miny;
+              labelPolyPoints[1].x = lbounds.bbox.minx;
+              labelPolyPoints[1].y = lbounds.bbox.maxy;
+              labelPolyPoints[2].x = lbounds.bbox.maxx;
+              labelPolyPoints[2].y = lbounds.bbox.maxy;
+              labelPolyPoints[3].x = lbounds.bbox.maxx;
+              labelPolyPoints[3].y = lbounds.bbox.miny;
+            }
+            needLabelPoint = MS_FALSE; /* don't re-compute */
+            needLabelPoly = MS_FALSE;
+          }
+          if (label->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+            if (MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image,
+                                                            &labelPoly,
+                                                            label->styles[i],
+                                                            ts.scalefactor))) {
+              freeTextSymbol(&ts);
+              return MS_FAILURE;
+            }
+          } else {
+            pointObj labelCenter;
+            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx) / 2;
+            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny) / 2;
+            if (MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(
+                                              map, image, &labelCenter,
+                                              label->styles[i], scalefactor))) {
+              freeTextSymbol(&ts);
+              return MS_FAILURE;
+            }
+          }
+        } else {
+          msSetError(MS_MISCERR, "Unknown label geomtransform %s",
+                     "msDrawLabel()", label->styles[i]->_geomtransform.string);
+          if (haveLabelText)
+            freeTextSymbol(&ts);
+          return MS_FAILURE;
+        }
+      }
+    }
+
+    if (haveLabelText) {
+      if (needLabelPoint)
+        p = get_metrics(&labelPnt, label->position, ts.textpath,
+                        label->offsetx * ts.scalefactor,
+                        label->offsety * ts.scalefactor, ts.rotation, 0,
+                        &lbounds);
+
+      /* draw the label text */
+      if (MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map, image, p, &ts))) {
+        freeTextSymbol(&ts);
+        return MS_FAILURE;
+      }
+    }
+  } else {
+    labelPnt.x += label->offsetx * ts.scalefactor;
+    labelPnt.y += label->offsety * ts.scalefactor;
+
+    if (label->numstyles > 0) {
+      int i;
+
+      for (i = 0; i < label->numstyles; i++) {
+        if (label->styles[i]->_geomtransform.type ==
+                MS_GEOMTRANSFORM_LABELPOINT ||
+            label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawMarkerSymbol(map, image, &labelPnt,
+                                             label->styles[i], scalefactor))) {
+            freeTextSymbol(&ts);
+            return MS_FAILURE;
+          }
+        } else if (haveLabelText && (label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELPOLY ||
+                                     label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELCENTER)) {
+          if (needLabelPoly) {
+            get_metrics(&labelPnt, label->position, ts.textpath,
+                        label->offsetx * ts.scalefactor,
+                        label->offsety * ts.scalefactor, ts.rotation, 1,
+                        &lbounds);
+            needLabelPoly = MS_FALSE; /* don't re-compute */
+            if (!lbounds.poly) {
+              /* we need the full shape to draw the label background */
+              labelPolyPoints[0].x = labelPolyPoints[4].x = lbounds.bbox.minx;
+              labelPolyPoints[0].y = labelPolyPoints[4].y = lbounds.bbox.miny;
+              labelPolyPoints[1].x = lbounds.bbox.minx;
+              labelPolyPoints[1].y = lbounds.bbox.maxy;
+              labelPolyPoints[2].x = lbounds.bbox.maxx;
+              labelPolyPoints[2].y = lbounds.bbox.maxy;
+              labelPolyPoints[3].x = lbounds.bbox.maxx;
+              labelPolyPoints[3].y = lbounds.bbox.miny;
+            }
+          }
+          if (label->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+            if (MS_UNLIKELY(MS_FAILURE ==
+                            msDrawShadeSymbol(map, image, &labelPoly,
+                                              label->styles[i], scalefactor))) {
+              freeTextSymbol(&ts);
+              return MS_FAILURE;
+            }
+          } else {
+            pointObj labelCenter;
+            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx) / 2;
+            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny) / 2;
+            if (MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(
+                                              map, image, &labelCenter,
+                                              label->styles[i], scalefactor))) {
+              freeTextSymbol(&ts);
+              return MS_FAILURE;
+            }
+          }
+        } else {
+          msSetError(MS_MISCERR, "Unknown label geomtransform %s",
+                     "msDrawLabel()", label->styles[i]->_geomtransform.string);
+          if (haveLabelText)
+            freeTextSymbol(&ts);
+          return MS_FAILURE;
+        }
+      }
+    }
+
+    if (haveLabelText) {
+      /* draw the label text */
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msDrawTextSymbol(map, image, labelPnt, &ts))) {
+        freeTextSymbol(&ts);
+        return MS_FAILURE;
+      }
+    }
+  }
+  if (haveLabelText)
+    freeTextSymbol(&ts);
+
+  return MS_SUCCESS;
+}
+
+static inline void offset_bbox(const rectObj *from, rectObj *to, double ox,
+                               double oy) {
+  to->minx = from->minx + ox;
+  to->miny = from->miny + oy;
+  to->maxx = from->maxx + ox;
+  to->maxy = from->maxy + oy;
+}
+
+static inline void offset_label_bounds(const label_bounds *from,
+                                       label_bounds *to, double ox, double oy) {
+  if (from->poly) {
+    int i;
+    for (i = 0; i < from->poly->numpoints; i++) {
+      to->poly->point[i].x = from->poly->point[i].x + ox;
+      to->poly->point[i].y = from->poly->point[i].y + oy;
+    }
+    to->poly->numpoints = from->poly->numpoints;
+  } else {
+    to->poly = NULL;
+  }
+  offset_bbox(&from->bbox, &to->bbox, ox, oy);
+}
+
+/* private shortcut function to try a leader offsetted label
+ * the caller must ensure that scratch->poly->points has been sufficiently
+ * allocated to hold the points from the cachePtr's label_bounds */
+void offsetAndTest(mapObj *map, labelCacheMemberObj *cachePtr, double ox,
+                   double oy, int priority, int label_idx,
+                   label_bounds *scratch) {
+  int i, j, status;
+  pointObj leaderpt;
+  lineObj *scratch_line = scratch->poly;
+
+  for (i = 0; i < cachePtr->numtextsymbols; i++) {
+    textSymbolObj *ts = cachePtr->textsymbols[i];
+    if (ts->textpath) {
+      offset_label_bounds(&ts->textpath->bounds, scratch, ox, oy);
+      status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority,
+                                          label_idx);
+      if (!status) {
+        return;
+      }
+    }
+    for (j = 0; j < ts->label->numstyles; j++) {
+      if (ts->label->styles[j]->_geomtransform.type ==
+          MS_GEOMTRANSFORM_LABELPOINT) {
+        scratch->poly = scratch_line;
+        offset_label_bounds(ts->style_bounds[j], scratch, ox, oy);
+        status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority,
+                                            label_idx);
+        if (!status) {
+          return;
+        }
+      }
+    }
+  }
+
+  leaderpt.x = cachePtr->point.x + ox;
+  leaderpt.y = cachePtr->point.y + oy;
+  leaderpt.z = 0;
+  leaderpt.m = 0;
+
+  status = msTestLabelCacheLeaderCollision(map, &cachePtr->point, &leaderpt);
+  if (!status) {
+    return;
+  }
+
+  /* the current offset is ok */
+  cachePtr->leaderbbox = msSmallMalloc(sizeof(rectObj));
+  cachePtr->leaderline = msSmallMalloc(sizeof(lineObj));
+  cachePtr->leaderline->point = msSmallMalloc(2 * sizeof(pointObj));
+  cachePtr->leaderline->numpoints = 2;
+  cachePtr->leaderline->point[0] = cachePtr->point;
+  cachePtr->leaderline->point[1] = leaderpt;
+  cachePtr->leaderbbox->minx = MS_MIN(leaderpt.x, cachePtr->point.x);
+  cachePtr->leaderbbox->maxx = MS_MAX(leaderpt.x, cachePtr->point.x);
+  cachePtr->leaderbbox->miny = MS_MIN(leaderpt.y, cachePtr->point.y);
+  cachePtr->leaderbbox->maxy = MS_MAX(leaderpt.y, cachePtr->point.y);
+  cachePtr->status = MS_ON;
+
+  offset_bbox(&cachePtr->bbox, &cachePtr->bbox, ox, oy);
+
+  for (i = 0; i < cachePtr->numtextsymbols; i++) {
+    textSymbolObj *ts = cachePtr->textsymbols[i];
+    if (ts->textpath) {
+      offset_label_bounds(&ts->textpath->bounds, &ts->textpath->bounds, ox, oy);
+      ts->annopoint.x += ox;
+      ts->annopoint.y += oy;
+    }
+    if (ts->style_bounds) {
+      for (j = 0; j < ts->label->numstyles; j++) {
+        if (ts->label->styles[j]->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
+          offset_label_bounds(ts->style_bounds[j], ts->style_bounds[j], ox, oy);
+      }
+    }
+  }
+}
+
+int msDrawOffsettedLabels(imageObj *image, mapObj *map, int priority) {
+  int retval = MS_SUCCESS;
+  int l;
+  labelCacheObj *labelcache = &(map->labelcache);
+  labelCacheSlotObj *cacheslot;
+  labelCacheMemberObj *cachePtr;
+  label_bounds scratch;
+  lineObj scratch_line;
+  pointObj *scratch_points = NULL;
+  int num_allocated_scratch_points = 0;
+  assert(MS_RENDERER_PLUGIN(image->format));
+  cacheslot = &(labelcache->slots[priority]);
+  scratch.poly = &scratch_line;
+
+  for (l = cacheslot->numlabels - 1; l >= 0; l--) {
+    cachePtr =
+        &(cacheslot->labels[l]); /* point to right spot in the label cache */
+    if (cachePtr->status == MS_OFF) {
+      /* only test regular labels that have had their bounding box computed
+       and that haven't been rendered  */
+      classObj *classPtr =
+          (GET_CLASS(map, cachePtr->layerindex, cachePtr->classindex));
+      layerObj *layerPtr = (GET_LAYER(map, cachePtr->layerindex));
+      int steps, i, num_scratch_points_to_allocate = 0;
+
+      assert(classPtr->leader); /* cachePtrs that don't need to be tested have
+                                   been marked as status on or delete */
+
+      if (cachePtr->point.x < labelcache->gutter ||
+          cachePtr->point.y < labelcache->gutter ||
+          cachePtr->point.x >= image->width - labelcache->gutter ||
+          cachePtr->point.y >= image->height - labelcache->gutter) {
+        /* don't look for leaders if point is in edge buffer as the leader line
+         * would end up chopped off */
+        continue;
+      }
+
+      for (i = 0; i < cachePtr->numtextsymbols; i++) {
+        int j;
+        textSymbolObj *ts = cachePtr->textsymbols[i];
+        if (ts->textpath && ts->textpath->bounds.poly) {
+          num_scratch_points_to_allocate =
+              MS_MAX(num_scratch_points_to_allocate,
+                     ts->textpath->bounds.poly->numpoints);
+        }
+        if (ts->style_bounds) {
+          for (j = 0; j < ts->label->numstyles; j++) {
+            if (ts->label->styles[j]->_geomtransform.type ==
+                    MS_GEOMTRANSFORM_LABELPOINT &&
+                ts->style_bounds[j]->poly) {
+              num_scratch_points_to_allocate =
+                  MS_MAX(num_scratch_points_to_allocate,
+                         ts->style_bounds[j]->poly->numpoints);
+            }
+          }
+        }
+      }
+      if (num_scratch_points_to_allocate > num_allocated_scratch_points) {
+        scratch_points = msSmallRealloc(
+            scratch_points, num_scratch_points_to_allocate * sizeof(pointObj));
+        num_allocated_scratch_points = num_scratch_points_to_allocate;
+      }
+
+      steps = classPtr->leader->maxdistance / classPtr->leader->gridstep;
+
+#define x0 (cachePtr->point.x)
+#define y0 (cachePtr->point.y)
+#define gridstepsc (classPtr->leader->gridstep)
+
+#define otest(ox, oy)                                                          \
+  if ((x0 + (ox)) >= labelcache->gutter &&                                     \
+      (y0 + (oy)) >= labelcache->gutter &&                                     \
+      (x0 + (ox)) < image->width - labelcache->gutter &&                       \
+      (y0 + (oy)) < image->height - labelcache->gutter) {                      \
+    scratch_line.point = scratch_points;                                       \
+    scratch.poly = &scratch_line;                                              \
+    offsetAndTest(map, cachePtr, (ox), (oy), priority, l, &scratch);           \
+    if (cachePtr->status == MS_ON)                                             \
+      break;                                                                   \
+  }
+
+      /* loop through possible offsetted positions */
+      for (i = 1; i <= steps; i++) {
+
+        /* test the intermediate points on the ring */
+
+        /* (points marked "0" are the ones being tested)
+
+           X00X00X
+           0XXXXX0
+           0XXXXX0
+           XXX.XXX
+           0XXXXX0
+           0XXXXX0
+           X00X00X
+        */
+        int j;
+        for (j = 1; j < i - 1; j++) {
+          /* test the right positions */
+          otest(i * gridstepsc, j * gridstepsc);
+          otest(i * gridstepsc, -j * gridstepsc);
+          /* test the left positions */
+          otest(-i * gridstepsc, j * gridstepsc);
+          otest(-i * gridstepsc, -j * gridstepsc);
+          /* test the top positions */
+          otest(j * gridstepsc, -i * gridstepsc);
+          otest(-j * gridstepsc, -i * gridstepsc);
+          /* test the bottom positions */
+          otest(j * gridstepsc, i * gridstepsc);
+          otest(-j * gridstepsc, i * gridstepsc);
+        }
+        if (j < (i - 1))
+          break;
+
+        otest(i * gridstepsc, i * gridstepsc);
+        otest(-i * gridstepsc, -i * gridstepsc);
+        otest(i * gridstepsc, -i * gridstepsc);
+        otest(-i * gridstepsc, i * gridstepsc);
+
+        /* test the intermediate points on the ring */
+
+        /* (points marked "0" are the ones being tested)
+
+           X00X00X
+           0XXXXX0
+           0XXXXX0
+           XXX.XXX
+           0XXXXX0
+           0XXXXX0
+           X00X00X
+
+        */
+
+        /* test the extreme diagonal points */
+
+        /* (points marked "0" are the ones being tested)
+
+           0XXXXX0
+           XXXXXXX
+           XXXXXXX
+           XXX.XXX
+           XXXXXXX
+           XXXXXXX
+           0XXXXX0
+
+           (x0+i*gridstep, y0+i*gridstep), pos lr
+           (x0-i*gridstep, y0-i*gridstep), pos ul
+           (x0+i*gridstep, y0-i*gridstep), pos ur
+           (x0-i*gridstep, y0+i*gridstep), pos ll
+
+        */
+
+        /* test the 4 cardinal points on the ring */
+
+        /* (points marked "0" are the ones being tested)
+
+           XXX0XXX
+           XXXXXXX
+           XXXXXXX
+           0XX.XX0
+           XXXXXXX
+           XXXXXXX
+           XXX0XXX
+
+         * (x0+i*gridtep,y0), pos cr
+
+         * (x0-i*gridstep,y0), pos cl
+         * (x0,y0-i*gridstep), pos uc
+         * (x0,y0+i*gridstep), pos lc
+         */
+        otest(i * gridstepsc, 0);
+        otest(-i * gridstepsc, 0);
+        otest(0, -i * gridstepsc);
+        otest(0, i * gridstepsc);
+      }
+      if (cachePtr->status == MS_ON) {
+        int ll;
+        shapeObj
+            labelLeader; /* label polygon (bounding box, possibly rotated) */
+        labelLeader.line =
+            cachePtr->leaderline; /* setup the label polygon structure */
+        labelLeader.numlines = 1;
+        insertRenderedLabelMember(map, cachePtr);
+
+        for (ll = 0; ll < classPtr->leader->numstyles; ll++) {
+          retval = msDrawLineSymbol(map, image, &labelLeader,
+                                    classPtr->leader->styles[ll],
+                                    layerPtr->scalefactor);
+          if (MS_UNLIKELY(retval == MS_FAILURE)) {
+            goto offset_cleanup;
+          }
+        }
+        for (ll = 0; ll < cachePtr->numtextsymbols; ll++) {
+          textSymbolObj *ts = cachePtr->textsymbols[ll];
+
+          if (ts->style_bounds) {
+            /* here's where we draw the label styles */
+            for (i = 0; i < ts->label->numstyles; i++) {
+              if (ts->label->styles[i]->_geomtransform.type ==
+                  MS_GEOMTRANSFORM_LABELPOINT) {
+                retval = msDrawMarkerSymbol(
+                    map, image, &(labelLeader.line->point[1]),
+                    ts->label->styles[i], layerPtr->scalefactor);
+                if (MS_UNLIKELY(retval == MS_FAILURE)) {
+                  goto offset_cleanup;
+                }
+              } else if (ts->label->styles[i]->_geomtransform.type ==
+                         MS_GEOMTRANSFORM_LABELPOLY) {
+                retval =
+                    msDrawLabelBounds(map, image, ts->style_bounds[i],
+                                      ts->label->styles[i], ts->scalefactor);
+                if (MS_UNLIKELY(retval == MS_FAILURE)) {
+                  goto offset_cleanup;
+                }
+              } else if (ts->label->styles[i]->_geomtransform.type ==
+                         MS_GEOMTRANSFORM_LABELCENTER) {
+                pointObj labelCenter;
+                labelCenter.x = (ts->style_bounds[i]->bbox.maxx +
+                                 ts->style_bounds[i]->bbox.minx) /
+                                2;
+                labelCenter.y = (ts->style_bounds[i]->bbox.maxy +
+                                 ts->style_bounds[i]->bbox.miny) /
+                                2;
+                retval = msDrawMarkerSymbol(map, image, &labelCenter,
+                                            ts->label->styles[i],
+                                            layerPtr->scalefactor);
+                if (MS_UNLIKELY(retval == MS_FAILURE)) {
+                  goto offset_cleanup;
+                }
+              } else {
+                msSetError(MS_MISCERR,
+                           "Labels only support LABELPNT, LABELPOLY and "
+                           "LABELCENTER GEOMTRANSFORMS",
+                           "msDrawOffsettedLabels()");
+                retval = MS_FAILURE;
+              }
+            }
+          }
+          if (ts->annotext) {
+            retval = msDrawTextSymbol(map, image, ts->annopoint, ts);
+            if (MS_UNLIKELY(retval == MS_FAILURE)) {
+              goto offset_cleanup;
+            }
+          }
+        }
+        /* TODO: draw cachePtr->marker, but where ? */
+
+        /*
+         styleObj tstyle;
+         static int foo =0;
+         if(!foo) {
+            srand(time(NULL));
+            foo = 1;
+            initStyle(&tstyle);
+            tstyle.width = 1;
+            tstyle.color.alpha = 255;
+         }
+         tstyle.color.red = random()%255;
+         tstyle.color.green = random()%255;
+         tstyle.color.blue =random()%255;
+         msDrawLineSymbol(&map->symbolset, image, cachePtr->poly, &tstyle,
+         layerPtr->scalefactor);
+        */
+      }
+    }
+  }
+
+offset_cleanup:
+
+  free(scratch_points);
+
+  return retval;
+}
+
+void fastComputeBounds(lineObj *line, rectObj *bounds) {
+  int j;
+  bounds->minx = bounds->maxx = line->point[0].x;
+  bounds->miny = bounds->maxy = line->point[0].y;
+
+  for (j = 0; j < line->numpoints; j++) {
+    bounds->minx = MS_MIN(bounds->minx, line->point[j].x);
+    bounds->maxx = MS_MAX(bounds->maxx, line->point[j].x);
+    bounds->miny = MS_MIN(bounds->miny, line->point[j].y);
+    bounds->maxy = MS_MAX(bounds->maxy, line->point[j].y);
+  }
+}
+
+int computeMarkerBounds(mapObj *map, pointObj *annopoint, textSymbolObj *ts,
+                        label_bounds *poly) {
+  int i;
+  for (i = 0; i < ts->label->numstyles; i++) {
+    styleObj *style = ts->label->styles[i];
+    if (style->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
+        style->symbol < map->symbolset.numsymbols && style->symbol >= 0) {
+      double sx, sy;
+      int p;
+      double aox, aoy;
+      symbolObj *symbol = map->symbolset.symbol[style->symbol];
+      if (msGetMarkerSize(map, style, &sx, &sy, ts->scalefactor) != MS_SUCCESS)
+        return -1; /* real error, different from MS_FALSE, return -1 so we can
+                      trap it */
+      if (style->angle) {
+        pointObj *point = poly->poly->point;
+        point[0].x = sx / 2.0;
+        point[0].y = sy / 2.0;
+        point[1].x = point[0].x;
+        point[1].y = -point[0].y;
+        point[2].x = -point[0].x;
+        point[2].y = -point[0].y;
+        point[3].x = -point[0].x;
+        point[3].y = point[0].y;
+        point[4].x = point[0].x;
+        point[4].y = point[0].y;
+        if (symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
+          aox = (0.5 - symbol->anchorpoint_x) * sx;
+          aoy = (0.5 - symbol->anchorpoint_y) * sy;
+          for (p = 0; p < 5; p++) {
+            point[p].x += aox;
+            point[p].y += aoy;
+          }
+        }
+        {
+          double rot = -style->angle * MS_DEG_TO_RAD;
+          double sina = sin(rot);
+          double cosa = cos(rot);
+          for (p = 0; p < 5; p++) {
+            double tmpx = point[p].x;
+            point[p].x = point[p].x * cosa - point[p].y * sina;
+            point[p].y = tmpx * sina + point[p].y * cosa;
+          }
+        }
+        aox = annopoint->x + style->offsetx * ts->scalefactor;
+        aoy = annopoint->y + style->offsety * ts->scalefactor;
+        for (p = 0; p < 5; p++) {
+          point[p].x += aox;
+          point[p].y += aoy;
+        }
+        fastComputeBounds(poly->poly, &poly->bbox);
+      } else {
+        double aox = (0.5 - symbol->anchorpoint_x) * sx + annopoint->x +
+                     style->offsetx * ts->scalefactor;
+        double aoy = (0.5 - symbol->anchorpoint_y) * sy + annopoint->y +
+                     style->offsety * ts->scalefactor;
+        poly->poly = NULL;
+        poly->bbox.maxx = sx / 2.0 + aox;
+        poly->bbox.minx = -sx / 2.0 + aox;
+        poly->bbox.maxy = sy / 2.0 + aoy;
+        poly->bbox.miny = -sy / 2.0 + aoy;
+      }
+      break;
+    }
+  }
+  if (i == ts->label->numstyles)
+    return MS_FALSE; /* the label has no marker styles */
+  else
+    return MS_TRUE;
+}
+
+/* check that the current entry does not fall close to a label with identical
+ * text, if configured so. Currently only checks the first label/text */
+
+int msCheckLabelMinDistance(mapObj *map, labelCacheMemberObj *lc) {
+  int i;
+  textSymbolObj *s; /* shortcut */
+  textSymbolObj *ts;
+  rectObj buffered;
+  if (lc->numtextsymbols == 0)
+    return MS_FALSE; /* no label with text */
+  s = lc->textsymbols[0];
+
+  if (!s->annotext || s->label->mindistance <= 0.0 ||
+      s->label->force == MS_TRUE)
+    return MS_FALSE; /*  min distance is not checked */
+
+  /* we buffer the label and check for intersection instead of calculating
+     the distance of two textpaths. we also buffer only the bbox of lc for
+     faster computation (it is still compared to the full textpath
+     of the label cache members).
+  */
+  buffered = lc->bbox;
+  buffered.minx -= s->label->mindistance * s->resolutionfactor;
+  buffered.miny -= s->label->mindistance * s->resolutionfactor;
+  buffered.maxx += s->label->mindistance * s->resolutionfactor;
+  buffered.maxy += s->label->mindistance * s->resolutionfactor;
+
+  for (i = 0; i < map->labelcache.num_rendered_members; i++) {
+    labelCacheMemberObj *ilc = map->labelcache.rendered_text_symbols[i];
+    if (ilc->numtextsymbols == 0 || !ilc->textsymbols[0]->annotext)
+      continue;
+
+    ts = ilc->textsymbols[0];
+    if (strcmp(s->annotext, ts->annotext) != 0) {
+      /* only check min distance against same label */
+      continue;
+    }
+
+    if (msPointInRect(&ilc->point, &buffered) == MS_TRUE) {
+      return MS_TRUE;
+    }
+
+    if (ts->textpath && ts->textpath->absolute) {
+      if (intersectLabelPolygons(ts->textpath->bounds.poly, &ilc->bbox, NULL,
+                                 &buffered) == MS_TRUE) {
+        return MS_TRUE;
+      }
+      continue;
+    }
+
+    if (intersectLabelPolygons(NULL, &ilc->bbox, NULL, &buffered) == MS_TRUE) {
+      return MS_TRUE;
+    }
+  }
+  return MS_FALSE;
+}
+
+void copyLabelBounds(label_bounds *dst, label_bounds *src) {
+  *dst = *src;
+  if (src->poly) {
+    int i;
+    dst->poly = msSmallMalloc(sizeof(lineObj));
+    dst->poly->numpoints = src->poly->numpoints;
+    dst->poly->point = msSmallMalloc(dst->poly->numpoints * sizeof(pointObj));
+    for (i = 0; i < dst->poly->numpoints; i++) {
+      dst->poly->point[i] = src->poly->point[i];
+    }
+  }
+}
+
+static int getLabelPositionFromString(char *pszString) {
+  if (strcasecmp(pszString, "UL") == 0)
+    return MS_UL;
+  else if (strcasecmp(pszString, "LR") == 0)
+    return MS_LR;
+  else if (strcasecmp(pszString, "UR") == 0)
+    return MS_UR;
+  else if (strcasecmp(pszString, "LL") == 0)
+    return MS_LL;
+  else if (strcasecmp(pszString, "CR") == 0)
+    return MS_CR;
+  else if (strcasecmp(pszString, "CL") == 0)
+    return MS_CL;
+  else if (strcasecmp(pszString, "UC") == 0)
+    return MS_UC;
+  else if (strcasecmp(pszString, "LC") == 0)
+    return MS_LC;
+  else
+    return MS_CC;
+}
+
+int msDrawLabelCache(mapObj *map, imageObj *image) {
+  int nReturnVal = MS_SUCCESS;
+  struct mstimeval starttime = {0}, endtime = {0};
+
+  if (map->debug >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&starttime, NULL);
+
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      int i, l, ll, priority, its;
+
+      double marker_offset_x, marker_offset_y;
+      int label_offset_x, label_offset_y;
+      const char *value;
+
+      labelCacheMemberObj *cachePtr = NULL;
+      layerObj *layerPtr = NULL;
+      classObj *classPtr = NULL;
+      textSymbolObj *textSymbolPtr = NULL;
+
+      /*
+       * some statically allocated containers for storing label bounds before
+       * copying them into the cachePtr: we avoid allocating these structures
+       * at runtime, except for the labels that are actually rendered.
+       */
+      lineObj labelpoly_line;
+      pointObj labelpoly_points[5];
+      label_bounds labelpoly_bounds = {0};
+      lineObj label_marker_line;
+      pointObj label_marker_points[5];
+      label_bounds label_marker_bounds;
+      lineObj metrics_line;
+      pointObj metrics_points[5];
+      label_bounds metrics_bounds;
+
+      label_marker_line.point = label_marker_points;
+      label_marker_line.numpoints = 5;
+      metrics_line.point = metrics_points;
+      metrics_line.numpoints = 5;
+      labelpoly_line.point = labelpoly_points;
+      labelpoly_line.numpoints = 5;
+
+      /* Look for labelcache_map_edge_buffer map metadata
+       * If set then the value defines a buffer (in pixels) along the edge of
+       * the map image where labels can't fall
+       */
+      if ((value = msLookupHashTable(&(map->web.metadata),
+                                     "labelcache_map_edge_buffer")) != NULL) {
+        map->labelcache.gutter = MS_ABS(atoi(value));
+        if (map->debug)
+          msDebug("msDrawLabelCache(): labelcache_map_edge_buffer = %d\n",
+                  map->labelcache.gutter);
+      }
+
+      for (priority = MS_MAX_LABEL_PRIORITY - 1; priority >= 0; priority--) {
+        labelCacheSlotObj *cacheslot;
+        cacheslot = &(map->labelcache.slots[priority]);
+
+        for (l = cacheslot->numlabels - 1; l >= 0; l--) {
+          cachePtr =
+              &(cacheslot
+                    ->labels[l]); /* point to right spot in the label cache */
+
+          layerPtr = (GET_LAYER(
+              map, cachePtr->layerindex)); /* set a couple of other pointers,
+                                              avoids nasty references */
+          classPtr =
+              (GET_CLASS(map, cachePtr->layerindex, cachePtr->classindex));
+
+          if (cachePtr->textsymbols[0]->textpath &&
+              cachePtr->textsymbols[0]->textpath->absolute) {
+            /* we have an angle follow label */
+            cachePtr->bbox = cachePtr->textsymbols[0]->textpath->bounds.bbox;
+
+            /* before going any futher, check that mindistance is respected */
+            if (cachePtr->numtextsymbols &&
+                cachePtr->textsymbols[0]->label->mindistance > 0.0 &&
+                cachePtr->textsymbols[0]->annotext) {
+              if (msCheckLabelMinDistance(map, cachePtr) == MS_TRUE) {
+                cachePtr->status = MS_DELETE;
+                MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                         "Skipping labelgroup %d \"%s\" in layer \"%s\": too "
+                         "close to an identical label (mindistance)\n",
+                         l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
+                continue; /* move on to next entry, this one is too close to an
+                             already placed one */
+              }
+            }
+
+            if (!cachePtr->textsymbols[0]->label->force)
+              cachePtr->status = msTestLabelCacheCollisions(
+                  map, cachePtr, &cachePtr->textsymbols[0]->textpath->bounds,
+                  priority, l);
+            else
+              cachePtr->status = MS_ON;
+            if (cachePtr->status) {
+
+              if (MS_UNLIKELY(
+                      MS_FAILURE ==
+                      msDrawTextSymbol(
+                          map, image,
+                          cachePtr->textsymbols[0]->annopoint /*not used*/,
+                          cachePtr->textsymbols[0]))) {
+                return MS_FAILURE;
+              }
+              insertRenderedLabelMember(map, cachePtr);
+            } else {
+              MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                       "Skipping follow labelgroup %d \"%s\" in layer \"%s\": "
+                       "text collided\n",
+                       l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
+            }
+            cachePtr->status =
+                MS_DELETE; /* we're done with this label, it won't even have a
+                              second chance in the leader phase */
+          } else {
+            marker_offset_x = marker_offset_y = 0; /* assume no marker */
+
+            if (layerPtr->type == MS_LAYER_POINT &&
+                cachePtr->markerid !=
+                    -1) { /* there is a marker already in the image that we need
+                             to account for */
+              markerCacheMemberObj *markerPtr = &(
+                  cacheslot
+                      ->markers[cachePtr->markerid]); /* point to the right spot
+                                                         in the marker cache*/
+              marker_offset_x =
+                  (markerPtr->bounds.maxx - markerPtr->bounds.minx) / 2.0;
+              marker_offset_y =
+                  (markerPtr->bounds.maxy - markerPtr->bounds.miny) / 2.0;
+            }
+
+            /*
+            ** all other cases *could* have multiple labels defined
+            */
+            cachePtr->status =
+                MS_ON; /* assume this cache element can be placed */
+            for (ll = 0; ll < cachePtr->numtextsymbols;
+                 ll++) { /* RFC 77 TODO: Still may want to step through
+                            backwards... */
+              int label_marker_status = MS_ON, have_label_marker,
+                  metrics_status = MS_ON;
+              int need_labelpoly = 0;
+
+              /* reset the lineObj which may have been unset by a previous call
+               * to get_metrics() */
+              label_marker_bounds.poly = &label_marker_line;
+              labelpoly_bounds.poly = &labelpoly_line;
+
+              textSymbolPtr = cachePtr->textsymbols[ll];
+              for (i = 0; i < textSymbolPtr->label->numstyles; i++) {
+                if (textSymbolPtr->label->styles[i]->_geomtransform.type ==
+                        MS_GEOMTRANSFORM_LABELPOLY ||
+                    textSymbolPtr->label->styles[i]->_geomtransform.type ==
+                        MS_GEOMTRANSFORM_LABELCENTER) {
+                  need_labelpoly = 1;
+                  break;
+                }
+              }
+
+              /* compute the poly of the label styles */
+              if ((have_label_marker =
+                       computeMarkerBounds(map, &cachePtr->point, textSymbolPtr,
+                                           &label_marker_bounds)) == MS_TRUE) {
+                if (cachePtr->numtextsymbols >
+                    1) { /* FIXME this test doesn't seem right, should probably
+                            check if we have an annotation layer with a regular
+                            style defined */
+                  marker_offset_x = (label_marker_bounds.bbox.maxx -
+                                     label_marker_bounds.bbox.minx) /
+                                    2.0;
+                  marker_offset_y = (label_marker_bounds.bbox.maxy -
+                                     label_marker_bounds.bbox.miny) /
+                                    2.0;
+                } else {
+                  /* we might be using an old style behavior with a markerPtr */
+                  marker_offset_x =
+                      MS_MAX(marker_offset_x, (label_marker_bounds.bbox.maxx -
+                                               label_marker_bounds.bbox.minx) /
+                                                  2.0);
+                  marker_offset_y =
+                      MS_MAX(marker_offset_y, (label_marker_bounds.bbox.maxy -
+                                               label_marker_bounds.bbox.miny) /
+                                                  2.0);
+                }
+                /* add marker to cachePtr->poly */
+                if (textSymbolPtr->label->force != MS_TRUE) {
+                  label_marker_status = msTestLabelCacheCollisions(
+                      map, cachePtr, &label_marker_bounds, priority, l);
+                }
+                if (label_marker_status == MS_OFF &&
+                    !(textSymbolPtr->label->force == MS_ON ||
+                      classPtr->leader)) {
+                  cachePtr->status = MS_DELETE;
+                  MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                           "Skipping label %d of labelgroup %d of class %d in "
+                           "layer \"%s\": marker collided\n",
+                           ll, l, cachePtr->classindex, layerPtr->name);
+                  break; /* the marker collided, break from multi-label loop */
+                }
+              }
+              if (have_label_marker == -1)
+                return MS_FAILURE; /* error occured (symbol not found, etc...)
+                                    */
+
+              if (textSymbolPtr->annotext) {
+                /*
+                 * if we don't have an offset defined, first check that the
+                 * labelpoint itself does not collide this helps speed things up
+                 * in dense labelling, as if the labelpoint collides there's no
+                 * use in computing the labeltext bounds (i.e. going into
+                 * shaping+freetype). We do however skip collision testing
+                 * against the marker cache, as we want to allow rendering a
+                 * label for points that overlap each other: this is done by
+                 * setting priority to MAX_PRIORITY in the call to
+                 * msTestLabelCacheCollisions (which is a hack!!)
+                 */
+                if (!have_label_marker &&
+                    textSymbolPtr->label->force != MS_TRUE &&
+                    !classPtr->leader && !textSymbolPtr->label->offsetx &&
+                    !textSymbolPtr->label->offsety) {
+                  label_bounds labelpoint_bounds;
+                  labelpoint_bounds.poly = NULL;
+                  labelpoint_bounds.bbox.minx = cachePtr->point.x - 0.1;
+                  labelpoint_bounds.bbox.maxx = cachePtr->point.x + 0.1;
+                  labelpoint_bounds.bbox.miny = cachePtr->point.y - 0.1;
+                  labelpoint_bounds.bbox.maxy = cachePtr->point.y + 0.1;
+                  if (MS_OFF == msTestLabelCacheCollisions(
+                                    map, cachePtr, &labelpoint_bounds,
+                                    MS_MAX_LABEL_PRIORITY, l)) {
+                    cachePtr->status =
+                        MS_DELETE; /* we won't check for leader offseted
+                                      positions, as the anchor point colided */
+                    MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                             "Skipping label %d \"%s\" of labelgroup %d of "
+                             "class %d in layer \"%s\": labelpoint collided\n",
+                             ll, textSymbolPtr->annotext, l,
+                             cachePtr->classindex, layerPtr->name);
+                    break;
+                  }
+                }
+
+                /* compute label size */
+                if (!textSymbolPtr->textpath) {
+                  if (MS_UNLIKELY(MS_FAILURE ==
+                                  msComputeTextPath(map, textSymbolPtr))) {
+                    return MS_FAILURE;
+                  }
+                }
+
+                /* if our label has an outline, adjust the marker offset so the
+                 * outlinecolor does not bleed into the marker */
+                if (marker_offset_x &&
+                    MS_VALID_COLOR(textSymbolPtr->label->outlinecolor)) {
+                  marker_offset_x += textSymbolPtr->label->outlinewidth / 2.0 *
+                                     textSymbolPtr->scalefactor;
+                  marker_offset_y += textSymbolPtr->label->outlinewidth / 2.0 *
+                                     textSymbolPtr->scalefactor;
+                }
+
+                /* apply offset and buffer settings */
+                if (textSymbolPtr->label->anglemode != MS_FOLLOW) {
+                  label_offset_x = textSymbolPtr->label->offsetx *
+                                   textSymbolPtr->scalefactor;
+                  label_offset_y = textSymbolPtr->label->offsety *
+                                   textSymbolPtr->scalefactor;
+                } else {
+                  label_offset_x = 0;
+                  label_offset_y = 0;
+                }
+
+                if (textSymbolPtr->label->position == MS_AUTO) {
+                  /* no point in using auto positionning if the marker cannot be
+                   * placed */
+                  int positions[MS_POSITIONS_LENGTH], npositions = 0;
+
+                  /*
+                  **   (Note: might be able to re-order this for more speed.)
+                  */
+                  if (msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS")) {
+                    int p, ncustom_positions = 0;
+                    char **custom_positions = msStringSplitComplex(
+                        msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS"),
+                        ",", &ncustom_positions,
+                        MS_STRIPLEADSPACES | MS_STRIPENDSPACES);
+                    for (p = 0; p < MS_MIN(9, ncustom_positions); p++)
+                      positions[p] =
+                          getLabelPositionFromString(custom_positions[p]);
+                    npositions = p;
+                    msFree(custom_positions);
+                  } else if (layerPtr->type == MS_LAYER_POLYGON &&
+                             marker_offset_x == 0) {
+                    positions[0] = MS_CC;
+                    positions[1] = MS_UC;
+                    positions[2] = MS_LC;
+                    positions[3] = MS_CL;
+                    positions[4] = MS_CR;
+                    npositions = 5;
+                  } else if (layerPtr->type == MS_LAYER_LINE &&
+                             marker_offset_x == 0) {
+                    positions[0] = MS_UC;
+                    positions[1] = MS_LC;
+                    positions[2] = MS_CC;
+                    npositions = 3;
+                  } else {
+                    positions[0] = MS_UL;
+                    positions[1] = MS_LR;
+                    positions[2] = MS_UR;
+                    positions[3] = MS_LL;
+                    positions[4] = MS_CR;
+                    positions[5] = MS_CL;
+                    positions[6] = MS_UC;
+                    positions[7] = MS_LC;
+                    npositions = 8;
+                  }
+
+                  for (i = 0; i < npositions; i++) {
+                    // RFC 77 TODO: take label_marker_offset_x/y into account
+                    metrics_bounds.poly = &metrics_line;
+                    textSymbolPtr->annopoint =
+                        get_metrics(&(cachePtr->point), positions[i],
+                                    textSymbolPtr->textpath,
+                                    marker_offset_x + label_offset_x,
+                                    marker_offset_y + label_offset_y,
+                                    textSymbolPtr->rotation,
+                                    textSymbolPtr->label->buffer *
+                                        textSymbolPtr->scalefactor,
+                                    &metrics_bounds);
+                    if (textSymbolPtr->label->force == MS_OFF) {
+                      for (its = 0; its < ll; its++) {
+                        /* check for collisions inside the label group */
+                        if (intersectTextSymbol(cachePtr->textsymbols[its],
+                                                &metrics_bounds) == MS_TRUE) {
+                          /* there was a self intersection */
+                          break; /* next position, will break out to next
+                                    position in containing loop*/
+                        }
+                        if (its != ll)
+                          continue; /* goto next position, this one had an
+                                       intersection with our own label group */
+                      }
+                    }
+
+                    metrics_status = msTestLabelCacheCollisions(
+                        map, cachePtr, &metrics_bounds, priority, l);
+
+                    /* found a suitable place for this label */
+                    if (metrics_status == MS_TRUE ||
+                        (i == (npositions - 1) &&
+                         textSymbolPtr->label->force == MS_ON)) {
+                      metrics_status =
+                          MS_TRUE; /* set to true in case we are forcing it */
+                      /* compute anno poly for label background if needed */
+                      if (need_labelpoly)
+                        get_metrics(&(cachePtr->point), positions[i],
+                                    textSymbolPtr->textpath,
+                                    marker_offset_x + label_offset_x,
+                                    marker_offset_y + label_offset_y,
+                                    textSymbolPtr->rotation, 1,
+                                    &labelpoly_bounds);
+
+                      break; /* ...out of position loop */
+                    }
+                  } /* next position */
+
+                  /* if position auto didn't manage to find a position, but we
+                   * have leader configured for the class, then we want to
+                   * compute the label poly anyway, placed as MS_CC */
+                  if (classPtr->leader && metrics_status == MS_FALSE) {
+                    metrics_bounds.poly = &metrics_line;
+                    textSymbolPtr->annopoint = get_metrics(
+                        &(cachePtr->point), MS_CC, textSymbolPtr->textpath,
+                        label_offset_x, label_offset_y, textSymbolPtr->rotation,
+                        textSymbolPtr->label->buffer *
+                            textSymbolPtr->scalefactor,
+                        &metrics_bounds);
+                    if (need_labelpoly)
+                      get_metrics(&(cachePtr->point), MS_CC,
+                                  textSymbolPtr->textpath, label_offset_x,
+                                  label_offset_y, textSymbolPtr->rotation, 1,
+                                  &labelpoly_bounds);
+                  }
+                } else { /* explicit position */
+                  if (textSymbolPtr->label->position ==
+                      MS_CC) { /* don't need the marker_offset */
+                    metrics_bounds.poly = &metrics_line;
+                    textSymbolPtr->annopoint = get_metrics(
+                        &(cachePtr->point), MS_CC, textSymbolPtr->textpath,
+                        label_offset_x, label_offset_y, textSymbolPtr->rotation,
+                        textSymbolPtr->label->buffer *
+                            textSymbolPtr->scalefactor,
+                        &metrics_bounds);
+                    if (need_labelpoly)
+                      get_metrics(&(cachePtr->point), MS_CC,
+                                  textSymbolPtr->textpath, label_offset_x,
+                                  label_offset_y, textSymbolPtr->rotation, 1,
+                                  &labelpoly_bounds);
+                  } else {
+                    metrics_bounds.poly = &metrics_line;
+                    textSymbolPtr->annopoint = get_metrics(
+                        &(cachePtr->point), textSymbolPtr->label->position,
+                        textSymbolPtr->textpath,
+                        marker_offset_x + label_offset_x,
+                        marker_offset_y + label_offset_y,
+                        textSymbolPtr->rotation,
+                        textSymbolPtr->label->buffer *
+                            textSymbolPtr->scalefactor,
+                        &metrics_bounds);
+                    if (need_labelpoly)
+                      get_metrics(
+                          &(cachePtr->point), textSymbolPtr->label->position,
+                          textSymbolPtr->textpath,
+                          marker_offset_x + label_offset_x,
+                          marker_offset_y + label_offset_y,
+                          textSymbolPtr->rotation, 1, &labelpoly_bounds);
+                  }
+
+                  if (textSymbolPtr->label->force == MS_ON) {
+                    metrics_status = MS_ON;
+                  } else {
+                    if (textSymbolPtr->label->force == MS_OFF) {
+                      /* check for collisions inside the label group unless the
+                       * label is FORCE GROUP */
+                      for (its = 0; its < ll; its++) {
+                        /* check for collisions inside the label group */
+                        if (intersectTextSymbol(cachePtr->textsymbols[its],
+                                                &metrics_bounds) == MS_TRUE) {
+                          /* there was a self intersection */
+                          break; /* will break out to next position in
+                                    containing loop*/
+                        }
+                        if (its != ll) {
+                          cachePtr->status = MS_DELETE; /* TODO RFC98: check if
+                                                           this is correct */
+                          MS_DEBUG(
+                              MS_DEBUGLEVEL_DEVDEBUG, map,
+                              "Skipping label %d (\"%s\") of labelgroup %d of "
+                              "class %d in layer \"%s\": intercollision with "
+                              "label text inside labelgroup\n",
+                              ll, textSymbolPtr->annotext, l,
+                              cachePtr->classindex, layerPtr->name);
+                          break; /* collision within the group, break out of
+                                    textSymbol loop */
+                        }
+                      }
+                    }
+                    /* TODO: in case we have leader lines and multiple labels,
+                     * there's no use in testing for labelcache collisions once
+                     * a first collision has been found. we only need to know
+                     * that the label group has collided, and the poly of the
+                     * whole label group: if(label_group)
+                     * testLabelCacheCollisions */
+                    metrics_status = msTestLabelCacheCollisions(
+                        map, cachePtr, &metrics_bounds, priority, l);
+                  }
+                } /* end POSITION AUTO vs Fixed POSITION */
+
+                if (!metrics_status && classPtr->leader == 0) {
+                  cachePtr->status = MS_DELETE;
+                  MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                           "Skipping label %d \"%s\" of labelgroup %d of class "
+                           "%d in layer \"%s\": text collided\n",
+                           ll, textSymbolPtr->annotext, l, cachePtr->classindex,
+                           layerPtr->name);
+                  break; /* no point looking at more labels, unless their is a
+                            leader defined */
+                }
+              }
+
+              /* if we're here, we can either fit the label directly, or we need
+               * to put it in the leader queue */
+              assert((metrics_status && label_marker_status) ||
+                     classPtr->leader);
+
+              if (textSymbolPtr->annotext) {
+                copyLabelBounds(&textSymbolPtr->textpath->bounds,
+                                &metrics_bounds);
+              }
+              if (have_label_marker) {
+                if (!textSymbolPtr->style_bounds)
+                  textSymbolPtr->style_bounds = msSmallCalloc(
+                      textSymbolPtr->label->numstyles, sizeof(label_bounds *));
+                for (its = 0; its < textSymbolPtr->label->numstyles; its++) {
+                  if (textSymbolPtr->label->styles[its]->_geomtransform.type ==
+                      MS_GEOMTRANSFORM_LABELPOINT) {
+                    textSymbolPtr->style_bounds[its] =
+                        msSmallMalloc(sizeof(label_bounds));
+                    copyLabelBounds(textSymbolPtr->style_bounds[its],
+                                    &label_marker_bounds);
+                  }
+                }
+              }
+              if (!label_marker_status || !metrics_status) {
+                MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                         "Putting label %d of labelgroup %d of class %d , "
+                         "layer \"%s\" in leader queue\n",
+                         ll, l, cachePtr->classindex, layerPtr->name);
+                cachePtr->status =
+                    MS_OFF; /* we have a collision, but this entry is a
+                               candidate for leader testing */
+              }
+
+              /* do we need to copy the labelpoly, or can we use the static one
+               * ?*/
+              if (cachePtr->numtextsymbols > 1 ||
+                  (cachePtr->status == MS_OFF && classPtr->leader)) {
+                /*
+                 * if we have more than one label, or if we have a single one
+                 * which didn't fit but needs to go through leader offset
+                 * testing
+                 */
+                if (!textSymbolPtr->style_bounds)
+                  textSymbolPtr->style_bounds = msSmallCalloc(
+                      textSymbolPtr->label->numstyles, sizeof(label_bounds *));
+                for (its = 0; its < textSymbolPtr->label->numstyles; its++) {
+                  if (textSymbolPtr->label->styles[its]->_geomtransform.type ==
+                          MS_GEOMTRANSFORM_LABELPOLY ||
+                      textSymbolPtr->label->styles[its]->_geomtransform.type ==
+                          MS_GEOMTRANSFORM_LABELCENTER) {
+                    textSymbolPtr->style_bounds[its] =
+                        msSmallMalloc(sizeof(label_bounds));
+                    copyLabelBounds(textSymbolPtr->style_bounds[its],
+                                    &labelpoly_bounds);
+                  }
+                }
+
+              } /* else: we'll use labelpoly_bounds directly below */
+            }   /* next label in the group */
+
+            if (cachePtr->status != MS_DELETE) {
+              /* compute the global label bbox */
+              int inited = 0, s;
+              for (its = 0; its < cachePtr->numtextsymbols; its++) {
+                if (cachePtr->textsymbols[its]->annotext) {
+                  if (inited == 0) {
+                    cachePtr->bbox =
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox;
+                    inited = 1;
+                  } else {
+                    cachePtr->bbox.minx = MS_MIN(
+                        cachePtr->bbox.minx,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.minx);
+                    cachePtr->bbox.miny = MS_MIN(
+                        cachePtr->bbox.miny,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.miny);
+                    cachePtr->bbox.maxx = MS_MAX(
+                        cachePtr->bbox.maxx,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.maxx);
+                    cachePtr->bbox.maxy = MS_MAX(
+                        cachePtr->bbox.maxy,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.maxy);
+                  }
+                }
+                for (s = 0; s < cachePtr->textsymbols[its]->label->numstyles;
+                     s++) {
+                  if (cachePtr->textsymbols[its]
+                          ->label->styles[s]
+                          ->_geomtransform.type ==
+                      MS_GEOMTRANSFORM_LABELPOINT) {
+                    if (inited == 0) {
+                      cachePtr->bbox =
+                          cachePtr->textsymbols[its]->style_bounds[s]->bbox;
+                      inited = 1;
+                      break;
+                    } else {
+                      cachePtr->bbox.minx =
+                          MS_MIN(cachePtr->bbox.minx, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.minx);
+                      cachePtr->bbox.miny =
+                          MS_MIN(cachePtr->bbox.miny, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.miny);
+                      cachePtr->bbox.maxx =
+                          MS_MAX(cachePtr->bbox.maxx, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.maxx);
+                      cachePtr->bbox.maxy =
+                          MS_MAX(cachePtr->bbox.maxy, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.maxy);
+                      break;
+                    }
+                  }
+                }
+              }
+            }
+
+            /* check that mindistance is respected */
+            if (cachePtr->numtextsymbols &&
+                cachePtr->textsymbols[0]->label->mindistance > 0.0 &&
+                cachePtr->textsymbols[0]->annotext) {
+              if (msCheckLabelMinDistance(map, cachePtr) == MS_TRUE) {
+                cachePtr->status = MS_DELETE;
+                MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                         "Skipping labelgroup %d \"%s\" in layer \"%s\": too "
+                         "close to an identical label (mindistance)\n",
+                         l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
+              }
+            }
+
+            if (cachePtr->status == MS_OFF || cachePtr->status == MS_DELETE)
+              continue; /* next labelCacheMemberObj, as we had a collision */
+
+            /* insert the rendered label */
+            insertRenderedLabelMember(map, cachePtr);
+
+            for (ll = 0; ll < cachePtr->numtextsymbols; ll++) {
+              textSymbolPtr = cachePtr->textsymbols[ll];
+
+              /* here's where we draw the label styles */
+              for (i = 0; i < textSymbolPtr->label->numstyles; i++) {
+                if (textSymbolPtr->label->styles[i]->_geomtransform.type ==
+                    MS_GEOMTRANSFORM_LABELPOINT) {
+                  if (MS_UNLIKELY(
+                          MS_FAILURE ==
+                          msDrawMarkerSymbol(map, image, &(cachePtr->point),
+                                             textSymbolPtr->label->styles[i],
+                                             textSymbolPtr->scalefactor))) {
+                    return MS_FAILURE;
+                  }
+                } else if (textSymbolPtr->annotext &&
+                           textSymbolPtr->label->styles[i]
+                                   ->_geomtransform.type ==
+                               MS_GEOMTRANSFORM_LABELPOLY) {
+                  if (textSymbolPtr->style_bounds &&
+                      textSymbolPtr->style_bounds[i]) {
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawLabelBounds(map, image,
+                                              textSymbolPtr->style_bounds[i],
+                                              textSymbolPtr->label->styles[i],
+                                              textSymbolPtr->scalefactor))) {
+                      return MS_FAILURE;
+                    }
+                  } else {
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawLabelBounds(map, image, &labelpoly_bounds,
+                                              textSymbolPtr->label->styles[i],
+                                              textSymbolPtr->scalefactor))) {
+                      return MS_FAILURE;
+                    }
+                  }
+                } else if (textSymbolPtr->annotext &&
+                           textSymbolPtr->label->styles[i]
+                                   ->_geomtransform.type ==
+                               MS_GEOMTRANSFORM_LABELCENTER) {
+                  pointObj labelCenter;
+
+                  if (textSymbolPtr->style_bounds &&
+                      textSymbolPtr->style_bounds[i]) {
+                    labelCenter.x =
+                        (textSymbolPtr->style_bounds[i]->bbox.maxx +
+                         textSymbolPtr->style_bounds[i]->bbox.minx) /
+                        2;
+                    labelCenter.y =
+                        (textSymbolPtr->style_bounds[i]->bbox.maxy +
+                         textSymbolPtr->style_bounds[i]->bbox.miny) /
+                        2;
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawMarkerSymbol(map, image, &labelCenter,
+                                               textSymbolPtr->label->styles[i],
+                                               textSymbolPtr->scalefactor))) {
+                      return MS_FAILURE;
+                    }
+                  } else {
+                    labelCenter.x = (labelpoly_bounds.bbox.maxx +
+                                     labelpoly_bounds.bbox.minx) /
+                                    2;
+                    labelCenter.y = (labelpoly_bounds.bbox.maxy +
+                                     labelpoly_bounds.bbox.miny) /
+                                    2;
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawMarkerSymbol(map, image, &labelCenter,
+                                               textSymbolPtr->label->styles[i],
+                                               textSymbolPtr->scalefactor))) {
+                      return MS_FAILURE;
+                    }
+                  }
+
+                } else {
+                  msSetError(MS_MISCERR,
+                             "Labels only support LABELPNT, LABELPOLY and "
+                             "LABELCENTER GEOMTRANSFORMS",
+                             "msDrawLabelCache()");
+                  return MS_FAILURE;
+                }
+              }
+
+              if (textSymbolPtr->annotext) {
+                if (MS_UNLIKELY(MS_FAILURE ==
+                                msDrawTextSymbol(map, image,
+                                                 textSymbolPtr->annopoint,
+                                                 textSymbolPtr))) {
+                  return MS_FAILURE;
+                }
+              }
+            }
+          }
+        } /* next label(group) from cacheslot */
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawOffsettedLabels(image, map, priority))) {
+          return MS_FAILURE;
+        }
+      } /* next priority */
+#ifdef TBDEBUG
+      styleObj tstyle;
+      initStyle(&tstyle);
+      tstyle.width = 1;
+      tstyle.color.alpha = 255;
+      tstyle.color.red = 255;
+      tstyle.color.green = 0;
+      tstyle.color.blue = 0;
+      for (priority = MS_MAX_LABEL_PRIORITY - 1; priority >= 0; priority--) {
+        labelCacheSlotObj *cacheslot;
+        cacheslot = &(map->labelcache.slots[priority]);
+
+        for (l = cacheslot->numlabels - 1; l >= 0; l--) {
+          cachePtr =
+              &(cacheslot
+                    ->labels[l]); /* point to right spot in the label cache */
+          /*
+          assert((cachePtr->poly == NULL && cachePtr->status == MS_OFF) ||
+                  (cachePtr->poly && (cachePtr->status == MS_ON));
+           */
+          if (cachePtr->status) {
+            msDrawLineSymbol(map, image, cachePtr->poly, &tstyle,
+                             layerPtr->scalefactor);
+          }
+        }
+      }
+#endif
+
+      nReturnVal = MS_SUCCESS; /* necessary? */
+    }
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&endtime, NULL);
+    msDebug("msDrawMap(): Drawing Label Cache, %.3fs\n",
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+  }
+
+  return nReturnVal;
+}
+
+/**
+ * Generic function to tell the underline device that layer
+ * drawing is stating
+ */
+
+void msImageStartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      const char *approximation_scale =
+          msLayerGetProcessingKey(layer, "APPROXIMATION_SCALE");
+      if (approximation_scale) {
+        if (!strncasecmp(approximation_scale, "ROUND", 5)) {
+          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_ROUND;
+        } else if (!strncasecmp(approximation_scale, "FULL", 4)) {
+          MS_IMAGE_RENDERER(image)->transform_mode =
+              MS_TRANSFORM_FULLRESOLUTION;
+        } else if (!strncasecmp(approximation_scale, "SIMPLIFY", 8)) {
+          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_SIMPLIFY;
+        } else {
+          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_SNAPTOGRID;
+          MS_IMAGE_RENDERER(image)->approximation_scale =
+              atof(approximation_scale);
+        }
+      } else {
+        MS_IMAGE_RENDERER(image)->transform_mode =
+            MS_IMAGE_RENDERER(image)->default_transform_mode;
+        MS_IMAGE_RENDERER(image)->approximation_scale =
+            MS_IMAGE_RENDERER(image)->default_approximation_scale;
+      }
+      MS_IMAGE_RENDERER(image)->startLayer(image, map, layer);
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
+      msImageStartLayerIM(map, layer, image);
+  }
+}
+
+/**
+ * Generic function to tell the underline device that layer
+ * drawing is ending
+ */
+
+void msImageEndLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      MS_IMAGE_RENDERER(image)->endLayer(image, map, layer);
+    }
+  }
+}
+
+/**
+ * Generic function to tell the underline device that shape
+ * drawing is starting
+ */
+
+void msDrawStartShape(mapObj *map, layerObj *layer, imageObj *image,
+                      shapeObj *shape) {
+  (void)map;
+  (void)layer;
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      if (image->format->vtable->startShape)
+        image->format->vtable->startShape(image, shape);
+    }
+  }
+}
+
+/**
+ * Generic function to tell the underline device that shape
+ * drawing is ending
+ */
+
+void msDrawEndShape(mapObj *map, layerObj *layer, imageObj *image,
+                    shapeObj *shape) {
+  (void)map;
+  (void)layer;
+  if (MS_RENDERER_PLUGIN(image->format)) {
+    if (image->format->vtable->endShape)
+      image->format->vtable->endShape(image, shape);
+  }
+}
+/**
+ * take the value from the shape and use it to change the
+ * color in the style to match the range map
+ */
+int msShapeToRange(styleObj *style, shapeObj *shape) {
+  /*first, get the value of the rangeitem, which should*/
+  /*evaluate to a double*/
+  const char *fieldStr = shape->values[style->rangeitemindex];
+  if (fieldStr == NULL) { /*if there's not value, bail*/
+    return MS_FAILURE;
+  }
+  double fieldVal = atof(fieldStr); /*faith that it's ok -- */
+  /*should switch to strtod*/
+  return msValueToRange(style, fieldVal, MS_COLORSPACE_RGB);
+}
+
+/**
+ * Allow direct mapping of a value so that mapscript can use the
+ * Ranges.  The styls passed in is updated to reflect the right color
+ * based on the fieldVal
+ */
+int msValueToRange(styleObj *style, double fieldVal, colorspace cs) {
+  double range;
+  double scaledVal;
+
+  range = style->maxvalue - style->minvalue;
+  scaledVal = (fieldVal - style->minvalue) / range;
+
+  if (cs == MS_COLORSPACE_RGB) {
+    /*At this point, we know where on the range we need to be*/
+    /*However, we don't know how to map it yet, since RGB(A) can */
+    /*Go up or down*/
+    style->color.red = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.red +
+                         ((style->maxcolor.red - style->mincolor.red) *
+                          scaledVal))))));
+    style->color.green = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.green +
+                         ((style->maxcolor.green - style->mincolor.green) *
+                          scaledVal))))));
+    style->color.blue = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.blue +
+                         ((style->maxcolor.blue - style->mincolor.blue) *
+                          scaledVal))))));
+    style->color.alpha = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.alpha +
+                         ((style->maxcolor.alpha - style->mincolor.alpha) *
+                          scaledVal))))));
+  } else {
+    /* HSL */
+    assert(cs == MS_COLORSPACE_HSL);
+    if (fieldVal <= style->minvalue)
+      style->color = style->mincolor;
+    else if (fieldVal >= style->maxvalue)
+      style->color = style->maxcolor;
+    else {
+      double mh, ms, ml, Mh, Ms, Ml;
+      msRGBtoHSL(&style->mincolor, &mh, &ms, &ml);
+      msRGBtoHSL(&style->maxcolor, &Mh, &Ms, &Ml);
+      mh += (Mh - mh) * scaledVal;
+      ms += (Ms - ms) * scaledVal;
+      ml += (Ml - ml) * scaledVal;
+      msHSLtoRGB(mh, ms, ml, &style->color);
+      style->color.alpha =
+          style->mincolor.alpha +
+          (style->maxcolor.alpha - style->mincolor.alpha) * scaledVal;
+    }
+  }
+  /*( "msMapRange(): %i %i %i", style->color.red , style->color.green,
+   * style->color.blue);*/
+
+#if ALPHACOLOR_ENABLED
+  /*NO ALPHA RANGE YET  style->color.alpha = style->mincolor.alpha +
+   * ((style->maxcolor.alpha - style->mincolor.alpha) * scaledVal);*/
+#endif
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapdrawgdal.c 8.2.0~beta1-1~exp1/src/mapdrawgdal.c
--- 8.0.1-5/src/mapdrawgdal.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapdrawgdal.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2313 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Code for drawing GDAL raster layers.  Called from
+ *           msDrawRasterLayerLow() in mapraster.c.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <assert.h>
+#include <stdbool.h>
+#include "mapserver.h"
+#include "mapresample.h"
+#include "mapthread.h"
+#include "maptime.h"
+
+extern int InvGeoTransform(double *gt_in, double *gt_out);
+
+#define MAXCOLORS 256
+#define GEO_TRANS(tr, x, y) ((tr)[0] + (tr)[1] * (x) + (tr)[2] * (y))
+#define SKIP_MASK(x, y)                                                        \
+  (mask_rb && !*(mask_rb->data.rgba.a + (y)*mask_rb->data.rgba.row_step +      \
+                 (x)*mask_rb->data.rgba.pixel_step))
+
+#include "gdal.h"
+#include "cpl_string.h"
+
+#include "gdal_alg.h"
+
+static bool IsNoData(double dfValue, double dfNoDataValue);
+
+static int LoadGDALImages(GDALDatasetH hDS, int band_numbers[4], int band_count,
+                          layerObj *layer, int src_xoff, int src_yoff,
+                          int src_xsize, int src_ysize, GByte *pabyBuffer,
+                          int dst_xsize, int dst_ysize, int *pbHaveRGBNoData,
+                          int *pnNoData1, int *pnNoData2, int *pnNoData3,
+                          bool *pbScaled, double *pdfScaleMin,
+                          double *pdfScaleRatio, bool **ppbIsNoDataBuffer);
+static int msDrawRasterLayerGDAL_RawMode(mapObj *map, layerObj *layer,
+                                         imageObj *image, GDALDatasetH hDS,
+                                         int src_xoff, int src_yoff,
+                                         int src_xsize, int src_ysize,
+                                         int dst_xoff, int dst_yoff,
+                                         int dst_xsize, int dst_ysize);
+
+static int msDrawRasterLayerGDAL_16BitClassification(
+    mapObj *map, layerObj *layer, rasterBufferObj *rb, GDALRasterBandH hBand,
+    int src_xoff, int src_yoff, int src_xsize, int src_ysize, int dst_xoff,
+    int dst_yoff, int dst_xsize, int dst_ysize);
+
+/*
+ * rasterBufferObj setting macros.
+ */
+
+/************************************************************************/
+/*                       msDrawRasterLayerGDAL()                        */
+/************************************************************************/
+
+int msDrawRasterLayerGDAL(mapObj *map, layerObj *layer, imageObj *image,
+                          rasterBufferObj *rb, void *hDSVoid)
+
+{
+  int i; /* loop counters */
+  int cmap[MAXCOLORS];
+#ifndef NDEBUG
+  int cmap_set = FALSE;
+#endif
+  unsigned char rb_cmap[4][MAXCOLORS];
+  double adfGeoTransform[6], adfInvGeoTransform[6];
+  int dst_xoff, dst_yoff, dst_xsize, dst_ysize;
+  int src_xoff, src_yoff, src_xsize, src_ysize;
+  double llx, lly, urx, ury;
+  rectObj copyRect, mapRect;
+  unsigned char *pabyRaw1 = NULL, *pabyRaw2 = NULL, *pabyRaw3 = NULL,
+                *pabyRawAlpha = NULL;
+  int classified = FALSE;
+  int red_band = 0, green_band = 0, blue_band = 0, alpha_band = 0;
+  int band_count, band_numbers[4];
+  GDALDatasetH hDS = hDSVoid;
+  GDALColorTableH hColorMap = NULL;
+  GDALRasterBandH hBand1 = NULL, hBand2 = NULL, hBand3 = NULL,
+                  hBandAlpha = NULL;
+  int bHaveRGBNoData = FALSE;
+  int nNoData1 = -1, nNoData2 = -1, nNoData3 = -1;
+  rasterBufferObj *mask_rb = NULL;
+  rasterBufferObj s_mask_rb;
+
+  if (layer->mask) {
+    int ret;
+    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map, layer->mask));
+    mask_rb = &s_mask_rb;
+    memset(mask_rb, 0, sizeof(s_mask_rb));
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS)
+      return -1;
+  }
+
+  /*only support rawdata and pluggable renderers*/
+  assert(MS_RENDERER_RAWDATA(image->format) ||
+         (MS_RENDERER_PLUGIN(image->format) && rb));
+
+  memset(cmap, 0xff, MAXCOLORS * sizeof(int));
+  memset(rb_cmap, 0, sizeof(rb_cmap));
+
+  /* -------------------------------------------------------------------- */
+  /*      Test the image format instead of the map format.                */
+  /*      Normally the map format and the image format should be the      */
+  /*      same but In somes cases like swf and pdf support, a temporary   */
+  /*      GD image object is created and used to render raster layers     */
+  /*      and then dumped into the SWF or the PDF file.                   */
+  /* -------------------------------------------------------------------- */
+
+  src_xsize = GDALGetRasterXSize(hDS);
+  src_ysize = GDALGetRasterYSize(hDS);
+
+  /*
+   * If the RAW_WINDOW attribute is set, use that to establish what to
+   * load.  This is normally just set by the mapresample.c module to avoid
+   * problems with rotated maps.
+   */
+
+  if (CSLFetchNameValue(layer->processing, "RAW_WINDOW") != NULL) {
+    char **papszTokens =
+        CSLTokenizeString(CSLFetchNameValue(layer->processing, "RAW_WINDOW"));
+
+    if (layer->debug)
+      msDebug("msDrawGDAL(%s): using RAW_WINDOW=%s, dst=0,0,%d,%d\n",
+              layer->name, CSLFetchNameValue(layer->processing, "RAW_WINDOW"),
+              image->width, image->height);
+
+    if (CSLCount(papszTokens) != 4) {
+      CSLDestroy(papszTokens);
+      msSetError(MS_IMGERR, "RAW_WINDOW PROCESSING directive corrupt.",
+                 "msDrawGDAL()");
+      return -1;
+    }
+
+    src_xoff = atoi(papszTokens[0]);
+    src_yoff = atoi(papszTokens[1]);
+    src_xsize = atoi(papszTokens[2]);
+    src_ysize = atoi(papszTokens[3]);
+
+    dst_xoff = 0;
+    dst_yoff = 0;
+    dst_xsize = image->width;
+    dst_ysize = image->height;
+
+    CSLDestroy(papszTokens);
+  }
+
+  /*
+   * Compute the georeferenced window of overlap, and do nothing if there
+   * is no overlap between the map extents, and the file we are operating on.
+   */
+  else if (layer->transform) {
+    int dst_lrx, dst_lry;
+
+    if (layer->debug)
+      msDebug("msDrawRasterLayerGDAL(): Entering transform.\n");
+
+    msGetGDALGeoTransform(hDS, map, layer, adfGeoTransform);
+    InvGeoTransform(adfGeoTransform, adfInvGeoTransform);
+
+    mapRect = map->extent;
+
+    mapRect.minx -= map->cellsize * 0.5;
+    mapRect.maxx += map->cellsize * 0.5;
+    mapRect.miny -= map->cellsize * 0.5;
+    mapRect.maxy += map->cellsize * 0.5;
+
+    copyRect = mapRect;
+
+    if (copyRect.minx < GEO_TRANS(adfGeoTransform, 0, src_ysize))
+      copyRect.minx = GEO_TRANS(adfGeoTransform, 0, src_ysize);
+    if (copyRect.maxx > GEO_TRANS(adfGeoTransform, src_xsize, 0))
+      copyRect.maxx = GEO_TRANS(adfGeoTransform, src_xsize, 0);
+
+    if (copyRect.miny < GEO_TRANS(adfGeoTransform + 3, 0, src_ysize))
+      copyRect.miny = GEO_TRANS(adfGeoTransform + 3, 0, src_ysize);
+    if (copyRect.maxy > GEO_TRANS(adfGeoTransform + 3, src_xsize, 0))
+      copyRect.maxy = GEO_TRANS(adfGeoTransform + 3, src_xsize, 0);
+
+    if (copyRect.minx >= copyRect.maxx || copyRect.miny >= copyRect.maxy) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): Error in overlap calculation.\n");
+      return 0;
+    }
+
+    /*
+     * Copy the source and destination raster coordinates.
+     */
+    llx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.minx, copyRect.miny);
+    lly = GEO_TRANS(adfInvGeoTransform + 3, copyRect.minx, copyRect.miny);
+    urx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.maxx, copyRect.maxy);
+    ury = GEO_TRANS(adfInvGeoTransform + 3, copyRect.maxx, copyRect.maxy);
+
+    src_xoff = MS_MAX(0, (int)floor(llx + 0.5));
+    src_yoff = MS_MAX(0, (int)floor(ury + 0.5));
+    src_xsize = MS_MIN(MS_MAX(0, (int)(urx - llx + 0.5)),
+                       GDALGetRasterXSize(hDS) - src_xoff);
+    src_ysize = MS_MIN(MS_MAX(0, (int)(lly - ury + 0.5)),
+                       GDALGetRasterYSize(hDS) - src_yoff);
+
+    /* We want very small windows to use at least one source pixel (#4172) */
+    if (src_xsize == 0 && (urx - llx) > 0.0) {
+      src_xsize = 1;
+      src_xoff = MS_MIN(src_xoff, GDALGetRasterXSize(hDS) - 1);
+    }
+    if (src_ysize == 0 && (lly - ury) > 0.0) {
+      src_ysize = 1;
+      src_yoff = MS_MIN(src_yoff, GDALGetRasterYSize(hDS) - 1);
+    }
+
+    if (src_xsize == 0 || src_ysize == 0) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): no apparent overlap between map view "
+                "and this window(1).\n");
+      return 0;
+    }
+
+    if (map->cellsize == 0) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): Cellsize can't be 0.\n");
+      return 0;
+    }
+
+    dst_xoff = (int)((copyRect.minx - mapRect.minx) / map->cellsize);
+    dst_yoff = (int)((mapRect.maxy - copyRect.maxy) / map->cellsize);
+
+    dst_lrx = (int)((copyRect.maxx - mapRect.minx) / map->cellsize + 0.5);
+    dst_lry = (int)((mapRect.maxy - copyRect.miny) / map->cellsize + 0.5);
+    dst_lrx = MS_MAX(0, MS_MIN(image->width, dst_lrx));
+    dst_lry = MS_MAX(0, MS_MIN(image->height, dst_lry));
+
+    dst_xsize = MS_MAX(0, MS_MIN(image->width, dst_lrx - dst_xoff));
+    dst_ysize = MS_MAX(0, MS_MIN(image->height, dst_lry - dst_yoff));
+
+    if (dst_xsize == 0 || dst_ysize == 0) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): no apparent overlap between map view "
+                "and this window(2).\n");
+      return 0;
+    }
+
+    if (layer->debug)
+      msDebug("msDrawRasterLayerGDAL(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
+              src_xoff, src_yoff, src_xsize, src_ysize, dst_xoff, dst_yoff,
+              dst_xsize, dst_ysize);
+#ifndef notdef
+    if (layer->debug) {
+      double d_src_xoff, d_src_yoff, geo_x, geo_y;
+
+      geo_x = mapRect.minx + dst_xoff * map->cellsize;
+      geo_y = mapRect.maxy - dst_yoff * map->cellsize;
+
+      d_src_xoff = (geo_x - adfGeoTransform[0]) / adfGeoTransform[1];
+      d_src_yoff = (geo_y - adfGeoTransform[3]) / adfGeoTransform[5];
+
+      msDebug("msDrawRasterLayerGDAL(): source raster PL (%.3f,%.3f) for dst "
+              "PL (%d,%d).\n",
+              d_src_xoff, d_src_yoff, dst_xoff, dst_yoff);
+    }
+#endif
+  }
+
+  /*
+   * If layer transforms are turned off, just map 1:1.
+   */
+  else {
+    dst_xoff = src_xoff = 0;
+    dst_yoff = src_yoff = 0;
+    dst_xsize = src_xsize = MS_MIN(image->width, src_xsize);
+    dst_ysize = src_ysize = MS_MIN(image->height, src_ysize);
+  }
+
+  /*
+   * In RAWDATA mode we don't fool with colors.  Do the raw processing,
+   * and return from the function early.
+   */
+  if (MS_RENDERER_RAWDATA(image->format)) {
+    return msDrawRasterLayerGDAL_RawMode(
+        map, layer, image, hDS, src_xoff, src_yoff, src_xsize, src_ysize,
+        dst_xoff, dst_yoff, dst_xsize, dst_ysize);
+  }
+
+  /*
+   * Is this image classified?  We consider it classified if there are
+   * classes with an expression string *or* a color range.  We don't want
+   * to treat the raster as classified if there is just a bogus class here
+   * to force inclusion in the legend.
+   */
+  for (i = 0; i < layer->numclasses; i++) {
+    int s;
+
+    /* change colour based on colour range? */
+    for (s = 0; s < layer->class[i] -> numstyles; s++) {
+      if (MS_VALID_COLOR(layer->class[i] -> styles[s] -> mincolor) &&
+          MS_VALID_COLOR(layer->class[i] -> styles[s] -> maxcolor)) {
+        classified = TRUE;
+        break;
+      }
+    }
+
+    if (layer->class[i] -> expression.string != NULL) {
+      classified = TRUE;
+      break;
+    }
+  }
+
+  /*
+   * Set up the band selection.  We look for a BANDS directive in the
+   * the PROCESSING options.  If not found we default to grey=1, grey=1,alpha=2,
+   * red=1,green=2,blue=3 or red=1,green=2,blue=3,alpha>=4.
+   */
+
+  if (CSLFetchNameValue(layer->processing, "BANDS") == NULL) {
+    const int gdal_band_count = GDALGetRasterCount(hDS);
+    red_band = 1;
+
+    if (gdal_band_count >= 4) {
+      /* The alpha band is not necessarily the 4th one */
+      for (i = 4; i <= gdal_band_count; i++) {
+        if (GDALGetRasterColorInterpretation(GDALGetRasterBand(hDS, i)) ==
+            GCI_AlphaBand) {
+          alpha_band = i;
+          break;
+        }
+      }
+    }
+
+    if (gdal_band_count >= 3) {
+      green_band = 2;
+      blue_band = 3;
+    }
+
+    if (gdal_band_count == 2 && GDALGetRasterColorInterpretation(
+                                    GDALGetRasterBand(hDS, 2)) == GCI_AlphaBand)
+      alpha_band = 2;
+
+    hBand1 = GDALGetRasterBand(hDS, red_band);
+    if (classified || GDALGetRasterColorTable(hBand1) != NULL) {
+      alpha_band = 0;
+      green_band = 0;
+      blue_band = 0;
+    }
+  } else {
+    int *band_list;
+
+    band_list = msGetGDALBandList(layer, hDS, 4, &band_count);
+    if (band_list == NULL)
+      return -1;
+
+    if (band_count > 0)
+      red_band = band_list[0];
+    else
+      red_band = 0;
+    if (band_count > 2) {
+      green_band = band_list[1];
+      blue_band = band_list[2];
+    } else {
+      green_band = 0;
+      blue_band = 0;
+    }
+
+    if (band_count > 3)
+      alpha_band = band_list[3];
+    else
+      alpha_band = 0;
+
+    free(band_list);
+  }
+
+  band_numbers[0] = red_band;
+  band_numbers[1] = green_band;
+  band_numbers[2] = blue_band;
+  band_numbers[3] = 0;
+
+  if (blue_band != 0 && alpha_band != 0) {
+    band_numbers[3] = alpha_band;
+    band_count = 4;
+  } else if (blue_band != 0 && alpha_band == 0)
+    band_count = 3;
+  else if (alpha_band != 0) {
+    band_numbers[1] = alpha_band;
+    band_count = 2;
+  } else
+    band_count = 1;
+
+  if (layer->debug > 1 || (layer->debug > 0 && green_band != 0)) {
+    msDebug(
+        "msDrawRasterLayerGDAL(): red,green,blue,alpha bands = %d,%d,%d,%d\n",
+        red_band, green_band, blue_band, alpha_band);
+  }
+
+  /*
+   * Get band handles for PC256, RGB or RGBA cases.
+   */
+  hBand1 = GDALGetRasterBand(hDS, red_band);
+  if (hBand1 == NULL)
+    return -1;
+
+  hBand2 = hBand3 = hBandAlpha = NULL;
+
+  if (green_band != 0) {
+    hBand1 = GDALGetRasterBand(hDS, red_band);
+    hBand2 = GDALGetRasterBand(hDS, green_band);
+    hBand3 = GDALGetRasterBand(hDS, blue_band);
+    if (hBand1 == NULL || hBand2 == NULL || hBand3 == NULL)
+      return -1;
+  }
+
+  if (alpha_band != 0)
+    hBandAlpha = GDALGetRasterBand(hDS, alpha_band);
+
+  /*
+   * The logic for a classification rendering of non-8bit raster bands
+   * is sufficiently different than the normal mechanism of loading
+   * into an 8bit buffer, that we isolate it into it's own subfunction.
+   */
+  if (classified && hBand1 != NULL &&
+      GDALGetRasterDataType(hBand1) != GDT_Byte) {
+    return msDrawRasterLayerGDAL_16BitClassification(
+        map, layer, rb, hBand1, src_xoff, src_yoff, src_xsize, src_ysize,
+        dst_xoff, dst_yoff, dst_xsize, dst_ysize);
+  }
+
+  /*
+   * Get colormap for this image.  If there isn't one, and we have only
+   * one band create a greyscale colormap.
+   */
+  bool isDefaultGreyscale = false;
+
+  if (hBand2 != NULL)
+    hColorMap = NULL;
+  else {
+    hColorMap = GDALGetRasterColorTable(hBand1);
+    if (hColorMap != NULL)
+      hColorMap = GDALCloneColorTable(hColorMap);
+    else {
+      hColorMap = GDALCreateColorTable(GPI_RGB);
+      isDefaultGreyscale = true;
+
+      for (i = 0; i < 256; i++) {
+        colorObj pixel = {i, i, i, 0};
+        GDALColorEntry sEntry;
+
+        if (MS_COMPARE_COLORS(pixel, layer->offsite)) {
+          sEntry.c1 = 0;
+          sEntry.c2 = 0;
+          sEntry.c3 = 0;
+          sEntry.c4 = 0; /* alpha set to zero */
+        } else {
+          sEntry.c1 = i;
+          sEntry.c2 = i;
+          sEntry.c3 = i;
+          sEntry.c4 = 255;
+        }
+
+        GDALSetColorEntry(hColorMap, i, &sEntry);
+      }
+    }
+
+    /*
+    ** If we have a known NODATA value, mark it now as transparent.
+    */
+    {
+      int bGotNoData;
+      double dfNoDataValue = msGetGDALNoDataValue(layer, hBand1, &bGotNoData);
+
+      if (bGotNoData && dfNoDataValue >= 0 &&
+          dfNoDataValue < GDALGetColorEntryCount(hColorMap)) {
+        GDALColorEntry sEntry;
+
+        memcpy(&sEntry, GDALGetColorEntry(hColorMap, (int)dfNoDataValue),
+               sizeof(GDALColorEntry));
+
+        sEntry.c4 = 0;
+        GDALSetColorEntry(hColorMap, (int)dfNoDataValue, &sEntry);
+      }
+    }
+  }
+
+  /*
+   * Allocate imagery buffers.
+   */
+  pabyRaw1 =
+      (unsigned char *)malloc(((size_t)dst_xsize) * dst_ysize * band_count);
+  if (pabyRaw1 == NULL) {
+    msSetError(MS_MEMERR, "Allocating work image of size %dx%dx%d failed.",
+               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
+    return -1;
+  }
+
+  if (hBand2 != NULL && hBand3 != NULL) {
+    pabyRaw2 = pabyRaw1 + dst_xsize * dst_ysize * 1;
+    pabyRaw3 = pabyRaw1 + dst_xsize * dst_ysize * 2;
+  }
+
+  if (hBandAlpha != NULL) {
+    if (hBand2 != NULL)
+      pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 3;
+    else
+      pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 1;
+  }
+
+  /*
+   * Load image data into buffers with scaling, etc.
+   */
+  bool bScaled = false;
+  double dfScaleMin = 0;
+  double dfScaleRatio = 0;
+  bool *pbIsNoDataBuffer = NULL;
+  if (LoadGDALImages(hDS, band_numbers, band_count, layer, src_xoff, src_yoff,
+                     src_xsize, src_ysize, pabyRaw1, dst_xsize, dst_ysize,
+                     &bHaveRGBNoData, &nNoData1, &nNoData2, &nNoData3, &bScaled,
+                     &dfScaleMin, &dfScaleRatio, &pbIsNoDataBuffer) == -1) {
+    free(pabyRaw1);
+    free(pbIsNoDataBuffer);
+    return -1;
+  }
+
+  /*
+   * Setup the mapping between source eight bit pixel values, and the
+   * output images color table.  There are two general cases, where the
+   * class colors are provided by the MAP file, or where we use the native
+   * color table.
+   */
+  if (classified) {
+    int c;
+    const char *pszRangeColorspace =
+        msLayerGetProcessingKey(layer, "RANGE_COLORSPACE");
+    colorspace iRangeColorspace;
+
+#ifndef NDEBUG
+    cmap_set = TRUE;
+#endif
+
+    if (hColorMap == NULL) {
+      msSetError(MS_IOERR,
+                 "Attempt to classify 24bit image, this is unsupported.",
+                 "drawGDAL()");
+      free(pabyRaw1);
+      free(pbIsNoDataBuffer);
+      return -1;
+    }
+
+    if (!pszRangeColorspace || !strcasecmp(pszRangeColorspace, "RGB")) {
+      iRangeColorspace = MS_COLORSPACE_RGB;
+    } else if (!strcasecmp(pszRangeColorspace, "HSL")) {
+      iRangeColorspace = MS_COLORSPACE_HSL;
+    } else {
+      msSetError(MS_MISCERR,
+                 "Unknown RANGE_COLORSPACE \"%s\", expecting RGB or HSL",
+                 "drawGDAL()", pszRangeColorspace);
+      GDALDestroyColorTable(hColorMap);
+      free(pabyRaw1);
+      free(pbIsNoDataBuffer);
+      return -1;
+    }
+
+    int color_count = GDALGetColorEntryCount(hColorMap);
+    const bool bScaleColors = bScaled && !isDefaultGreyscale;
+
+    if (!bScaleColors && color_count > 256)
+      color_count = 256;
+
+    for (i = 0; i < color_count; i++) {
+      colorObj pixel;
+      int colormap_index;
+      GDALColorEntry sEntry;
+
+      GDALGetColorEntryAsRGB(hColorMap, i, &sEntry);
+
+      const int j =
+          bScaleColors
+              ? MAX(0, MIN(255, (int)((i - dfScaleMin) * dfScaleRatio)))
+              : i;
+
+      pixel.red = sEntry.c1;
+      pixel.green = sEntry.c2;
+      pixel.blue = sEntry.c3;
+      colormap_index = i;
+
+      if (!MS_COMPARE_COLORS(pixel, layer->offsite)) {
+        c = msGetClass(layer, &pixel, colormap_index);
+
+        if (c != -1) { /* belongs to any class */
+          int s;
+
+          /* change colour based on colour range?  Currently we
+             only address the greyscale case properly. */
+
+          if (MS_VALID_COLOR(layer->class[c] -> styles[0] -> mincolor)) {
+            for (s = 0; s < layer->class[c] -> numstyles; s++) {
+              if (MS_VALID_COLOR(layer->class[c] -> styles[s] -> mincolor) &&
+                  MS_VALID_COLOR(layer->class[c] -> styles[s] -> maxcolor)) {
+                if (sEntry.c1 >= layer->class[c] -> styles[s]
+                    -> minvalue &&
+                           sEntry.c1 <=
+                               layer->class[c] -> styles[s] -> maxvalue) {
+                  msValueToRange(layer->class[c] -> styles[s], sEntry.c1,
+                                 iRangeColorspace);
+                  if (MS_VALID_COLOR(layer->class[c] -> styles[s] -> color)) {
+                    rb_cmap[0][j] = layer->class[c]->styles[s]->color.red;
+                    rb_cmap[1][j] = layer->class[c]->styles[s]->color.green;
+                    rb_cmap[2][j] = layer->class[c]->styles[s]->color.blue;
+                    rb_cmap[3][j] =
+                        (layer->class[c] -> styles[s] -> color.alpha != 255)
+                            ? (layer->class[c] -> styles[s] -> color.alpha)
+                            : (255 * layer->class[c] -> styles[0] -> opacity /
+                                                                         100);
+                    break;
+                  }
+                }
+              }
+            }
+          } else if (MS_TRANSPARENT_COLOR(
+                         layer->class[c] -> styles[0] -> color))
+            /* leave it transparent */;
+
+          else if (MS_VALID_COLOR(layer->class[c] -> styles[0] -> color)) {
+            rb_cmap[0][j] = layer->class[c]->styles[0]->color.red;
+            rb_cmap[1][j] = layer->class[c]->styles[0]->color.green;
+            rb_cmap[2][j] = layer->class[c]->styles[0]->color.blue;
+            rb_cmap[3][j] =
+                (255 * layer->class[c] -> styles[0] -> opacity / 100);
+          }
+
+          else { /* Use raster color */
+            rb_cmap[0][j] = pixel.red;
+            rb_cmap[1][j] = pixel.green;
+            rb_cmap[2][j] = pixel.blue;
+            rb_cmap[3][j] = 255;
+          }
+        }
+      }
+    }
+  } else if (hBand2 == NULL && hColorMap != NULL &&
+             rb->type == MS_BUFFER_BYTE_RGBA) {
+    int color_count;
+#ifndef NDEBUG
+    cmap_set = TRUE;
+#endif
+
+    color_count = MS_MIN(256, GDALGetColorEntryCount(hColorMap));
+    const bool bScaleColors = bScaled && !isDefaultGreyscale;
+
+    for (i = 0; i < color_count; i++) {
+      GDALColorEntry sEntry;
+
+      GDALGetColorEntryAsRGB(hColorMap, i, &sEntry);
+      const int j =
+          bScaleColors
+              ? MAX(0, MIN(255, (int)((i - dfScaleMin) * dfScaleRatio)))
+              : i;
+
+      if (sEntry.c4 != 0 &&
+          (!MS_VALID_COLOR(layer->offsite) || layer->offsite.red != sEntry.c1 ||
+           layer->offsite.green != sEntry.c2 ||
+           layer->offsite.blue != sEntry.c3)) {
+        rb_cmap[0][j] = sEntry.c1;
+        rb_cmap[1][j] = sEntry.c2;
+        rb_cmap[2][j] = sEntry.c3;
+        rb_cmap[3][j] = sEntry.c4;
+      }
+    }
+  }
+
+  if (bHaveRGBNoData && layer->debug)
+    msDebug("msDrawGDAL(): using RGB nodata values from GDAL dataset.\n");
+
+  /* -------------------------------------------------------------------- */
+  /*      If there was no alpha band, but we have a dataset level mask    */
+  /*      load it as massage it so it will function as our alpha for      */
+  /*      transparency purposes.                                          */
+  /* -------------------------------------------------------------------- */
+  if (hBandAlpha == NULL) {
+    int nMaskFlags = GDALGetMaskFlags(hBand1);
+
+    if (CSLTestBoolean(
+            CSLFetchNameValueDef(layer->processing, "USE_MASK_BAND", "YES")) &&
+        (nMaskFlags & GMF_PER_DATASET) != 0 &&
+        (nMaskFlags & (GMF_NODATA | GMF_ALL_VALID)) == 0) {
+      CPLErr eErr;
+      unsigned char *pabyOrig = pabyRaw1;
+
+      if (layer->debug)
+        msDebug("msDrawGDAL(): using GDAL mask band for alpha.\n");
+
+      band_count++;
+
+      pabyRaw1 = (unsigned char *)realloc(pabyOrig, ((size_t)dst_xsize) *
+                                                        dst_ysize * band_count);
+
+      if (pabyRaw1 == NULL) {
+        msSetError(MS_MEMERR, "Allocating work image of size %dx%dx%d failed.",
+                   "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
+        free(pabyOrig);
+        if (hColorMap != NULL)
+          GDALDestroyColorTable(hColorMap);
+        free(pbIsNoDataBuffer);
+        return -1;
+      }
+
+      if (hBand2 != NULL) {
+        pabyRaw2 = pabyRaw1 + dst_xsize * dst_ysize * 1;
+        pabyRaw3 = pabyRaw1 + dst_xsize * dst_ysize * 2;
+        pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 3;
+      } else {
+        pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 1;
+      }
+
+      hBandAlpha = GDALGetMaskBand(hBand1);
+
+      eErr = GDALRasterIO(hBandAlpha, GF_Read, src_xoff, src_yoff, src_xsize,
+                          src_ysize, pabyRawAlpha, dst_xsize, dst_ysize,
+                          GDT_Byte, 0, 0);
+
+      if (eErr != CE_None) {
+        msSetError(MS_IOERR, "GDALRasterIO() failed: %s", "drawGDAL()",
+                   CPLGetLastErrorMsg());
+        if (hColorMap != NULL)
+          GDALDestroyColorTable(hColorMap);
+        free(pabyRaw1);
+        free(pbIsNoDataBuffer);
+        return -1;
+      }
+
+      /* In case the mask is not an alpha channel, expand values of 1 to 255, */
+      /* so we can deal as it was an alpha band afterwards */
+      if ((nMaskFlags & GMF_ALPHA) == 0) {
+        for (i = 0; i < dst_xsize * dst_ysize; i++)
+          if (pabyRawAlpha[i])
+            pabyRawAlpha[i] = 255;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Single band plus colormap and alpha to truecolor. (RB)          */
+  /* -------------------------------------------------------------------- */
+  if (hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA && hBandAlpha != NULL) {
+    assert(cmap_set);
+
+    int k = 0;
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      for (int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++) {
+        int src_pixel, src_alpha, cmap_alpha, merged_alpha;
+        if (SKIP_MASK(j, i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
+          continue;
+
+        src_pixel = pabyRaw1[k];
+        src_alpha = pabyRawAlpha[k];
+        cmap_alpha = rb_cmap[3][src_pixel];
+
+        merged_alpha = (src_alpha * cmap_alpha) / 255;
+
+        if (merged_alpha < 2)
+          /* do nothing - transparent */;
+        else if (merged_alpha > 253) {
+          RB_SET_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], cmap_alpha);
+        } else {
+          RB_MIX_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], merged_alpha);
+        }
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Single band plus colormap (no alpha) to truecolor (RB)          */
+  /* -------------------------------------------------------------------- */
+  else if (hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA) {
+    assert(cmap_set);
+
+    int k = 0;
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      for (int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++) {
+        int src_pixel = pabyRaw1[k];
+        if (SKIP_MASK(j, i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
+          continue;
+
+        if (rb_cmap[3][src_pixel] > 253) {
+          RB_SET_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], rb_cmap[3][src_pixel]);
+        } else if (rb_cmap[3][src_pixel] > 1) {
+          RB_MIX_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], rb_cmap[3][src_pixel]);
+        }
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Input is 3 band RGB.  Alpha blending is mixed into the loop     */
+  /*      since this case is less commonly used and has lots of other     */
+  /*      overhead. (RB)                                                  */
+  /* -------------------------------------------------------------------- */
+  else if (hBand3 != NULL && rb->type == MS_BUFFER_BYTE_RGBA) {
+    int k = 0;
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      for (int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++) {
+        if (SKIP_MASK(j, i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
+          continue;
+        if (MS_VALID_COLOR(layer->offsite) &&
+            pabyRaw1[k] == layer->offsite.red &&
+            pabyRaw2[k] == layer->offsite.green &&
+            pabyRaw3[k] == layer->offsite.blue)
+          continue;
+
+        if (bHaveRGBNoData && pabyRaw1[k] == nNoData1 &&
+            pabyRaw2[k] == nNoData2 && pabyRaw3[k] == nNoData3)
+          continue;
+
+        if (pabyRawAlpha == NULL || pabyRawAlpha[k] == 255) {
+          RB_SET_PIXEL(rb, j, i, pabyRaw1[k], pabyRaw2[k], pabyRaw3[k], 255);
+        } else if (pabyRawAlpha[k] != 0) {
+          RB_MIX_PIXEL(rb, j, i, pabyRaw1[k], pabyRaw2[k], pabyRaw3[k],
+                       pabyRawAlpha[k]);
+        }
+      }
+    }
+  }
+
+  /*
+  ** Cleanup
+  */
+  free(pabyRaw1);
+  free(pbIsNoDataBuffer);
+
+  if (hColorMap != NULL)
+    GDALDestroyColorTable(hColorMap);
+
+  return 0;
+}
+
+/************************************************************************/
+/*                          ParseDefaultLUT()                           */
+/************************************************************************/
+
+static int ParseDefaultLUT(const char *lut_def, GByte *lut, int nMaxValIn)
+
+{
+  const char *lut_read;
+  int last_in = 0, last_out = 0, all_done = FALSE;
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse definition, applying to lut on the fly.                   */
+  /* -------------------------------------------------------------------- */
+  lut_read = lut_def;
+  while (!all_done) {
+    int this_in = 0, this_out = 0;
+    int lut_i;
+
+    while (isspace(*lut_read))
+      lut_read++;
+
+    /* if we are at end, assume nMaxValIn:255 */
+    if (*lut_read == '\0') {
+      all_done = TRUE;
+      if (last_in != nMaxValIn) {
+        this_in = nMaxValIn;
+        this_out = 255;
+      }
+    }
+
+    /* otherwise read "in:out", and skip past */
+    else {
+      this_in = atoi(lut_read);
+      while (*lut_read != ':' && *lut_read)
+        lut_read++;
+      if (*lut_read == ':')
+        lut_read++;
+      while (isspace(*lut_read))
+        lut_read++;
+      this_out = atoi(lut_read);
+      while (*lut_read && *lut_read != ',' && *lut_read != '\n')
+        lut_read++;
+      if (*lut_read == ',' || *lut_read == '\n')
+        lut_read++;
+      while (isspace(*lut_read))
+        lut_read++;
+    }
+
+    this_in = MS_MAX(0, MS_MIN(nMaxValIn, this_in));
+    this_out = MS_MAX(0, MS_MIN(255, this_out));
+
+    /* apply linear values from last in:out to this in:out */
+    for (lut_i = last_in; lut_i <= this_in; lut_i++) {
+      double ratio;
+
+      if (last_in == this_in)
+        ratio = 1.0;
+      else
+        ratio = (lut_i - last_in) / (double)(this_in - last_in);
+
+      lut[lut_i] =
+          (int)floor(((1.0 - ratio) * last_out + ratio * this_out) + 0.5);
+    }
+
+    last_in = this_in;
+    last_out = this_out;
+  }
+
+  return 0;
+}
+
+/************************************************************************/
+/*                          LutFromGimpLine()                           */
+/************************************************************************/
+
+static int LutFromGimpLine(char *lut_line, GByte *lut)
+
+{
+  char wrkLUTDef[1000];
+  int i, count = 0;
+  char **tokens;
+
+  /* cleanup white space at end of line (DOS LF, etc) */
+  i = strlen(lut_line) - 1;
+  while (i > 0 && isspace(lut_line[i]))
+    lut_line[i--] = '\0';
+
+  while (*lut_line == 10 || *lut_line == 13)
+    lut_line++;
+
+  /* tokenize line */
+  tokens = CSLTokenizeString(lut_line);
+  if (CSLCount(tokens) != 17 * 2) {
+    CSLDestroy(tokens);
+    msSetError(MS_MISCERR, "GIMP curve file appears corrupt.",
+               "LutFromGimpLine()");
+    return -1;
+  }
+
+  /* Convert to our own format */
+  wrkLUTDef[0] = '\0';
+  for (i = 0; i < 17; i++) {
+    if (atoi(tokens[i * 2]) >= 0) {
+      if (count++ > 0)
+        strlcat(wrkLUTDef, ",", sizeof(wrkLUTDef));
+
+      snprintf(wrkLUTDef + strlen(wrkLUTDef),
+               sizeof(wrkLUTDef) - strlen(wrkLUTDef), "%s:%s", tokens[i * 2],
+               tokens[i * 2 + 1]);
+    }
+  }
+
+  CSLDestroy(tokens);
+
+  return ParseDefaultLUT(wrkLUTDef, lut, 255);
+}
+
+/************************************************************************/
+/*                            ParseGimpLUT()                            */
+/*                                                                      */
+/*      Parse a Gimp style LUT.                                         */
+/************************************************************************/
+
+static int ParseGimpLUT(const char *lut_def, GByte *lut, int iColorIndex)
+
+{
+  int i;
+  GByte lutValue[256];
+  GByte lutColorBand[256];
+  char **lines = CSLTokenizeStringComplex(lut_def, "\n", FALSE, FALSE);
+
+  if (!EQUALN(lines[0], "# GIMP Curves File", 18) || CSLCount(lines) < 6) {
+    msSetError(MS_MISCERR, "GIMP curve file appears corrupt.",
+               "ParseGimpLUT()");
+    CSLDestroy(lines);
+    return -1;
+  }
+
+  /*
+   * Convert the overall curve, and the color band specific curve into LUTs.
+   */
+  if (LutFromGimpLine(lines[1], lutValue) != 0 ||
+      LutFromGimpLine(lines[iColorIndex + 1], lutColorBand) != 0) {
+    CSLDestroy(lines);
+    return -1;
+  }
+  CSLDestroy(lines);
+
+  /*
+   * Compose the two luts as if the raw value passed through the color band
+   * specific lut, and then the general value lut.  Usually one or the
+   * other will be the identity mapping, but not always.
+   */
+
+  for (i = 0; i < 256; i++) {
+    lut[i] = lutValue[lutColorBand[i]];
+  }
+
+  return 0;
+}
+
+/************************************************************************/
+/*                              LoadLUT()                               */
+/*                                                                      */
+/*      Load a LUT according to RFC 21.                                 */
+/************************************************************************/
+
+static int LoadLUT(layerObj *layer, int iColorIndex, char **ppszLutDef)
+
+{
+  const char *lut_def;
+  char key[20], lut_def_fromfile[2500];
+
+  *ppszLutDef = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Get lut specifier from processing directives.  Do nothing if    */
+  /*      none are found.                                                 */
+  /* -------------------------------------------------------------------- */
+  sprintf(key, "LUT_%d", iColorIndex);
+  lut_def = msLayerGetProcessingKey(layer, key);
+  if (lut_def == NULL)
+    lut_def = msLayerGetProcessingKey(layer, "LUT");
+  if (lut_def == NULL)
+    return 0;
+
+  /* -------------------------------------------------------------------- */
+  /*      Does this look like a file?  If so, read it into memory.        */
+  /* -------------------------------------------------------------------- */
+  if (strspn(lut_def, "0123456789:, ") != strlen(lut_def)) {
+    FILE *fp;
+    char path[MS_MAXPATHLEN];
+    int len;
+    msBuildPath(path, layer->map->mappath, lut_def);
+    fp = fopen(path, "rb");
+    if (fp == NULL) {
+      msSetError(MS_IOERR, "Failed to open LUT file '%s'.", "drawGDAL()", path);
+      return -1;
+    }
+
+    len = fread(lut_def_fromfile, 1, sizeof(lut_def_fromfile), fp);
+    fclose(fp);
+
+    if (len == sizeof(lut_def_fromfile)) {
+      msSetError(MS_IOERR,
+                 "LUT definition from file %s longer than maximum buffer size "
+                 "(%d bytes).",
+                 "drawGDAL()", path, (int)sizeof(lut_def_fromfile));
+      return -1;
+    }
+
+    lut_def_fromfile[len] = '\0';
+
+    lut_def = lut_def_fromfile;
+  }
+
+  *ppszLutDef = msStrdup(lut_def);
+
+  return 0;
+}
+
+/************************************************************************/
+/*                              FreeLUTs()                              */
+/************************************************************************/
+
+static void FreeLUTs(char **apszLUTs) {
+  int i;
+  for (i = 0; i < 4; i++)
+    msFree(apszLUTs[i]);
+  msFree(apszLUTs);
+}
+
+/************************************************************************/
+/*                            LoadLUTs()                                */
+/*                                                                      */
+/* Return an array of 4 strings (some possibly NULL) with loaded LUTs   */
+/* or NULL in case of failure.                                          */
+/************************************************************************/
+
+static char **LoadLUTs(layerObj *layer, int band_count) {
+  int i;
+  char **apszLUTs;
+
+  assert(band_count <= 4);
+
+  apszLUTs = (char **)msSmallCalloc(4, sizeof(char *));
+  for (i = 0; i < band_count; i++) {
+    if (LoadLUT(layer, i + 1, &apszLUTs[i]) != 0) {
+      FreeLUTs(apszLUTs);
+      return NULL;
+    }
+  }
+
+  return apszLUTs;
+}
+
+/************************************************************************/
+/*                  GetDataTypeAppropriateForLUTS()                     */
+/*                                                                      */
+/*      This does a quick examination of the LUT strings to determine   */
+/*      if they have input values > 255, in which case the raster data  */
+/*      must be queries on 16-bits.                                     */
+/************************************************************************/
+
+static GDALDataType GetDataTypeAppropriateForLUTS(char **apszLUTs) {
+  GDALDataType eDT = GDT_Byte;
+  int i;
+  for (i = 0; i < 4; i++) {
+    const char *pszLastTuple;
+    int nLastInValue;
+    if (apszLUTs[i] == NULL)
+      continue;
+    if (EQUALN(apszLUTs[i], "# GIMP", 6))
+      continue;
+    /* Find last in:out tuple in string */
+    pszLastTuple = strrchr(apszLUTs[i], ',');
+    if (pszLastTuple == NULL)
+      pszLastTuple = apszLUTs[i];
+    else
+      pszLastTuple++;
+    while (*pszLastTuple == ' ')
+      pszLastTuple++;
+    nLastInValue = atoi(pszLastTuple);
+    if (nLastInValue > 255) {
+      eDT = GDT_UInt16;
+      break;
+    }
+  }
+  return eDT;
+}
+
+/************************************************************************/
+/*                              ApplyLUT()                              */
+/************************************************************************/
+
+static int ApplyLUT(int iColorIndex, const char *lut_def, const void *pInBuffer,
+                    GDALDataType eDT, GByte *pabyOutBuffer, int nPixelCount) {
+  int i, err;
+  GByte byteLut[256];
+  GByte *uint16Lut = NULL;
+
+  assert(eDT == GDT_Byte || eDT == GDT_UInt16);
+
+  if (lut_def == NULL) {
+    if (pInBuffer != pabyOutBuffer) {
+      GDALCopyWords((void *)pInBuffer, eDT, GDALGetDataTypeSize(eDT) / 8,
+                    pabyOutBuffer, GDT_Byte, 1, nPixelCount);
+    }
+    return 0;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse the LUT description.                                      */
+  /* -------------------------------------------------------------------- */
+  if (EQUALN(lut_def, "# GIMP", 6)) {
+    if (eDT != GDT_Byte) {
+      msSetError(MS_MISCERR, "Cannot apply a GIMP LUT on a 16-bit buffer",
+                 "ApplyLUT()");
+      return -1;
+    }
+    err = ParseGimpLUT(lut_def, byteLut, iColorIndex);
+  } else {
+    if (eDT == GDT_Byte)
+      err = ParseDefaultLUT(lut_def, byteLut, 255);
+    else {
+      uint16Lut = (GByte *)malloc(65536);
+      if (uint16Lut == NULL) {
+        msSetError(MS_MEMERR, "Cannot allocate 16-bit LUT", "ApplyLUT()");
+        return -1;
+      }
+      err = ParseDefaultLUT(lut_def, uint16Lut, 65535);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Apply LUT.                                                      */
+  /* -------------------------------------------------------------------- */
+  if (eDT == GDT_Byte) {
+    for (i = 0; i < nPixelCount; i++)
+      pabyOutBuffer[i] = byteLut[((GByte *)pInBuffer)[i]];
+  } else {
+    for (i = 0; i < nPixelCount; i++)
+      pabyOutBuffer[i] = uint16Lut[((GUInt16 *)pInBuffer)[i]];
+    free(uint16Lut);
+  }
+
+  return err;
+}
+
+/************************************************************************/
+/*                           LoadGDALImages()                           */
+/*                                                                      */
+/*      This call will load and process 1-4 bands of input for the      */
+/*      selected rectangle, loading the result into the passed 8bit     */
+/*      buffer.  The processing options include scaling.                */
+/************************************************************************/
+
+static int LoadGDALImages(GDALDatasetH hDS, int band_numbers[4], int band_count,
+                          layerObj *layer, int src_xoff, int src_yoff,
+                          int src_xsize, int src_ysize, GByte *pabyWholeBuffer,
+                          int dst_xsize, int dst_ysize, int *pbHaveRGBNoData,
+                          int *pnNoData1, int *pnNoData2, int *pnNoData3,
+                          bool *pbScaled, double *pdfScaleMin,
+                          double *pdfScaleRatio, bool **ppbIsNoDataBuffer)
+
+{
+  int iColorIndex, result_code = 0;
+  CPLErr eErr;
+  float *pafWholeRawData;
+  char **papszLUTs;
+
+  *pbScaled = false;
+  *pdfScaleMin = 0;
+  *pdfScaleRatio = 0;
+  *ppbIsNoDataBuffer = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      If we have no alpha band, but we do have three input            */
+  /*      bands, then check for nodata values.  If we only have one       */
+  /*      input band, then nodata will already have been adderssed as     */
+  /*      part of the real or manufactured color table.                   */
+  /* -------------------------------------------------------------------- */
+  if (band_count == 3) {
+    *pnNoData1 = (int)msGetGDALNoDataValue(
+        layer, GDALGetRasterBand(hDS, band_numbers[0]), pbHaveRGBNoData);
+
+    if (*pbHaveRGBNoData)
+      *pnNoData2 = (int)msGetGDALNoDataValue(
+          layer, GDALGetRasterBand(hDS, band_numbers[1]), pbHaveRGBNoData);
+    if (*pbHaveRGBNoData)
+      *pnNoData3 = (int)msGetGDALNoDataValue(
+          layer, GDALGetRasterBand(hDS, band_numbers[2]), pbHaveRGBNoData);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Are we doing a simple, non-scaling case?  If so, read directly  */
+  /*      and return.                                                     */
+  /* -------------------------------------------------------------------- */
+  if (CSLFetchNameValue(layer->processing, "SCALE") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_1") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_2") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_3") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_4") == NULL) {
+
+    GDALDataType eDT;
+    GUInt16 *panBuffer = NULL;
+    void *pBuffer;
+
+    papszLUTs = LoadLUTs(layer, band_count);
+    if (papszLUTs == NULL) {
+      return -1;
+    }
+
+    eDT = GetDataTypeAppropriateForLUTS(papszLUTs);
+    if (eDT == GDT_UInt16) {
+      panBuffer = (GUInt16 *)malloc(sizeof(GUInt16) * dst_xsize * dst_ysize *
+                                    band_count);
+
+      if (panBuffer == NULL) {
+        msSetError(MS_MEMERR,
+                   "Allocating work uint16 image of size %dx%dx%d failed.",
+                   "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
+        FreeLUTs(papszLUTs);
+        return -1;
+      }
+      pBuffer = panBuffer;
+    } else
+      pBuffer = pabyWholeBuffer;
+
+    eErr = GDALDatasetRasterIO(hDS, GF_Read, src_xoff, src_yoff, src_xsize,
+                               src_ysize, pBuffer, dst_xsize, dst_ysize, eDT,
+                               band_count, band_numbers, 0, 0, 0);
+
+    if (eErr != CE_None) {
+      msSetError(MS_IOERR, "GDALDatasetRasterIO() failed: %s", "drawGDAL()",
+                 CPLGetLastErrorMsg());
+      FreeLUTs(papszLUTs);
+      msFree(panBuffer);
+      return -1;
+    }
+
+    for (iColorIndex = 0; iColorIndex < band_count && result_code == 0;
+         iColorIndex++) {
+      result_code =
+          ApplyLUT(iColorIndex + 1, papszLUTs[iColorIndex],
+                   (GByte *)pBuffer + dst_xsize * dst_ysize * iColorIndex *
+                                          (GDALGetDataTypeSize(eDT) / 8),
+                   eDT, pabyWholeBuffer + dst_xsize * dst_ysize * iColorIndex,
+                   dst_xsize * dst_ysize);
+    }
+
+    FreeLUTs(papszLUTs);
+    msFree(panBuffer);
+    return result_code;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Disable use of nodata if we are doing scaling.                  */
+  /* -------------------------------------------------------------------- */
+  *pbHaveRGBNoData = FALSE;
+
+  /* -------------------------------------------------------------------- */
+  /*      We need to do some scaling.  Will load into either a 16bit      */
+  /*      unsigned or a floating point buffer depending on the source     */
+  /*      data.  We offer a special case for 16U data because it is       */
+  /*      common and it is a substantial win to avoid alot of floating    */
+  /*      point operations on it.                                         */
+  /* -------------------------------------------------------------------- */
+  /* TODO */
+
+  /* -------------------------------------------------------------------- */
+  /*      Allocate the raw imagery buffer, and load into it (band         */
+  /*      interleaved).                                                   */
+  /* -------------------------------------------------------------------- */
+  pafWholeRawData =
+      (float *)malloc(sizeof(float) * dst_xsize * dst_ysize * band_count);
+
+  if (pafWholeRawData == NULL) {
+    msSetError(MS_MEMERR,
+               "Allocating work float image of size %dx%dx%d failed.",
+               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
+    return -1;
+  }
+
+  eErr = GDALDatasetRasterIO(hDS, GF_Read, src_xoff, src_yoff, src_xsize,
+                             src_ysize, pafWholeRawData, dst_xsize, dst_ysize,
+                             GDT_Float32, band_count, band_numbers, 0, 0, 0);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALDatasetRasterIO() failed: %s", "drawGDAL()",
+               CPLGetLastErrorMsg());
+
+    free(pafWholeRawData);
+    return -1;
+  }
+
+  papszLUTs = LoadLUTs(layer, band_count);
+  if (papszLUTs == NULL) {
+    free(pafWholeRawData);
+    return -1;
+  }
+
+  if (GetDataTypeAppropriateForLUTS(papszLUTs) != GDT_Byte) {
+    msDebug("LoadGDALImage(%s): One of the LUT contains a input value > 255.\n"
+            "This is not properly supported in combination with SCALE\n",
+            layer->name);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch the scale processing option.                              */
+  /* -------------------------------------------------------------------- */
+  for (iColorIndex = 0; iColorIndex < band_count; iColorIndex++) {
+    unsigned char *pabyBuffer;
+    double dfScaleMin = 0.0, dfScaleMax = 255.0, dfScaleRatio, dfNoDataValue;
+    const char *pszScaleInfo;
+    float *pafRawData;
+    int nPixelCount = dst_xsize * dst_ysize, i, bGotNoData = FALSE;
+    GDALRasterBandH hBand = GDALGetRasterBand(hDS, band_numbers[iColorIndex]);
+    pszScaleInfo = CSLFetchNameValue(layer->processing, "SCALE");
+    if (pszScaleInfo == NULL) {
+      char szBandScalingName[20];
+
+      sprintf(szBandScalingName, "SCALE_%d", iColorIndex + 1);
+      pszScaleInfo = CSLFetchNameValue(layer->processing, szBandScalingName);
+    }
+
+    if (pszScaleInfo != NULL) {
+      char **papszTokens;
+
+      papszTokens = CSLTokenizeStringComplex(pszScaleInfo, " ,", FALSE, FALSE);
+      if (CSLCount(papszTokens) == 1 && EQUAL(papszTokens[0], "AUTO")) {
+        dfScaleMin = dfScaleMax = 0.0;
+      } else if (CSLCount(papszTokens) != 2) {
+        free(pafWholeRawData);
+        CSLDestroy(papszTokens);
+        FreeLUTs(papszLUTs);
+        msSetError(MS_MISCERR,
+                   "SCALE PROCESSING option unparsable for layer %s.",
+                   "msDrawGDAL()", layer->name);
+        return -1;
+      } else {
+        dfScaleMin = atof(papszTokens[0]);
+        dfScaleMax = atof(papszTokens[1]);
+      }
+      CSLDestroy(papszTokens);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      If we are using autoscaling, then compute the max and min       */
+    /*      now.  Perhaps we should eventually honour the offsite value     */
+    /*      as a nodata value, or get it from GDAL.                         */
+    /* -------------------------------------------------------------------- */
+    pafRawData = pafWholeRawData + iColorIndex * dst_xsize * dst_ysize;
+
+    dfNoDataValue = msGetGDALNoDataValue(layer, hBand, &bGotNoData);
+
+    /* we force assignment to a float rather than letting pafRawData[i]
+       get promoted to double later to avoid float precision issues. */
+    float fNoDataValue = (float)dfNoDataValue;
+
+    if (dfScaleMin == dfScaleMax) {
+      int bMinMaxSet = 0;
+
+      /* we force assignment to a float rather than letting pafRawData[i]
+         get promoted to double later to avoid float precision issues. */
+      float fNoDataValue = (float)dfNoDataValue;
+
+      for (i = 0; i < nPixelCount; i++) {
+        if (bGotNoData && IsNoData(pafRawData[i], fNoDataValue))
+          continue;
+
+        if (CPLIsNan(pafRawData[i]))
+          continue;
+
+        if (!bMinMaxSet) {
+          dfScaleMin = dfScaleMax = pafRawData[i];
+          bMinMaxSet = TRUE;
+        }
+
+        dfScaleMin = MS_MIN(dfScaleMin, pafRawData[i]);
+        dfScaleMax = MS_MAX(dfScaleMax, pafRawData[i]);
+      }
+
+      if (dfScaleMin == dfScaleMax)
+        dfScaleMax = dfScaleMin + 1.0;
+    }
+
+    if (layer->debug > 0)
+      msDebug("msDrawGDAL(%s): scaling to 8bit, src range=%g,%g\n", layer->name,
+              dfScaleMin, dfScaleMax);
+
+    /* -------------------------------------------------------------------- */
+    /*      Now process the data.                                           */
+    /* -------------------------------------------------------------------- */
+    dfScaleRatio = 256.0 / (dfScaleMax - dfScaleMin);
+    pabyBuffer = pabyWholeBuffer + iColorIndex * nPixelCount;
+
+    if (iColorIndex == 0 && bGotNoData)
+      *ppbIsNoDataBuffer = (bool *)calloc(nPixelCount, 1);
+
+    for (i = 0; i < nPixelCount; i++) {
+      float fScaledValue;
+
+      if (bGotNoData && IsNoData(pafRawData[i], fNoDataValue)) {
+        if (iColorIndex == 0)
+          (*ppbIsNoDataBuffer)[i] = true;
+        continue;
+      }
+
+      fScaledValue = (float)((pafRawData[i] - dfScaleMin) * dfScaleRatio);
+
+      if (fScaledValue < 0.0)
+        pabyBuffer[i] = 0;
+      else if (fScaledValue > 255.0)
+        pabyBuffer[i] = 255;
+      else
+        pabyBuffer[i] = (int)fScaledValue;
+    }
+
+    if (iColorIndex == 0) {
+      *pbScaled = true;
+      *pdfScaleMin = dfScaleMin;
+      *pdfScaleRatio = dfScaleRatio;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Report a warning if NODATA keyword was applied.  We are         */
+    /*      unable to utilize it since we can't return any pixels marked    */
+    /*      as nodata from this function.  Need to fix someday.             */
+    /* -------------------------------------------------------------------- */
+    if (bGotNoData)
+      msDebug("LoadGDALImage(%s): NODATA value %g in GDAL\n"
+              "file or PROCESSING directive largely ignored.  Not yet fully "
+              "supported for\n"
+              "unclassified scaled data.  The NODATA value is excluded from "
+              "auto-scaling\n"
+              "min/max computation, but will not be transparent.\n",
+              layer->name, dfNoDataValue);
+
+    /* -------------------------------------------------------------------- */
+    /*      Apply LUT if there is one.                                      */
+    /* -------------------------------------------------------------------- */
+    result_code = ApplyLUT(iColorIndex + 1, papszLUTs[iColorIndex], pabyBuffer,
+                           GDT_Byte, pabyBuffer, dst_xsize * dst_ysize);
+    if (result_code == -1) {
+      free(pafWholeRawData);
+      FreeLUTs(papszLUTs);
+      return result_code;
+    }
+  }
+
+  free(pafWholeRawData);
+  FreeLUTs(papszLUTs);
+
+  return result_code;
+}
+
+/************************************************************************/
+/*                       msGetGDALGeoTransform()                        */
+/*                                                                      */
+/*      Cover function that tries GDALGetGeoTransform(), a world        */
+/*      file or OWS extents.  It is assumed that TLOCK_GDAL is held     */
+/*      before this function is called.                                 */
+/************************************************************************/
+
+int msGetGDALGeoTransform(GDALDatasetH hDS, mapObj *map, layerObj *layer,
+                          double *padfGeoTransform)
+
+{
+  const char *extent_priority = NULL;
+  const char *value;
+  const char *gdalDesc;
+  const char *fullPath;
+  char *fileExtension = NULL;
+  char szPath[MS_MAXPATHLEN];
+  int fullPathLen;
+  int success = 0;
+  rectObj rect;
+
+  /* -------------------------------------------------------------------- */
+  /*      some GDAL drivers (ie. GIF) don't set geotransform on failure.  */
+  /* -------------------------------------------------------------------- */
+  padfGeoTransform[0] = 0.0;
+  padfGeoTransform[1] = 1.0;
+  padfGeoTransform[2] = 0.0;
+  padfGeoTransform[3] = GDALGetRasterYSize(hDS);
+  padfGeoTransform[4] = 0.0;
+  padfGeoTransform[5] = -1.0;
+
+  /* -------------------------------------------------------------------- */
+  /*      Do we want to override GDAL with a worldfile if one is present? */
+  /* -------------------------------------------------------------------- */
+  extent_priority = CSLFetchNameValue(layer->processing, "EXTENT_PRIORITY");
+
+  if (extent_priority != NULL && EQUALN(extent_priority, "WORLD", 5)) {
+    /* is there a user configured worldfile? */
+    value = CSLFetchNameValue(layer->processing, "WORLDFILE");
+
+    if (value != NULL) {
+      /* at this point, fullPath may be a filePath or path only */
+      fullPath = msBuildPath(szPath, map->mappath, value);
+
+      /* fullPath is a path only, so let's append the dataset filename */
+      if (strrchr(szPath, '.') == NULL) {
+        fullPathLen = strlen(fullPath);
+        gdalDesc = msStripPath((char *)GDALGetDescription(hDS));
+
+        if ((fullPathLen + strlen(gdalDesc)) < MS_MAXPATHLEN) {
+          strcpy((char *)(fullPath + fullPathLen), gdalDesc);
+        } else {
+          msDebug(
+              "Path length to alternative worldfile exceeds MS_MAXPATHLEN.\n");
+          fullPath = NULL;
+        }
+      }
+      /* fullPath has a filename included, so get the extension */
+      else {
+        fileExtension = msStrdup(strrchr(szPath, '.') + 1);
+      }
+    }
+    /* common behaviour with worldfile generated from basename + .wld */
+    else {
+      fullPath = GDALGetDescription(hDS);
+      fileExtension = msStrdup("wld");
+    }
+
+    if (fullPath)
+      success = GDALReadWorldFile(fullPath, fileExtension, padfGeoTransform);
+
+    if (success && layer->debug >= MS_DEBUGLEVEL_VVV) {
+      msDebug("Worldfile location: %s.\n", fullPath);
+    } else if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+      msDebug("Failed using worldfile location: %s.\n", fullPath);
+    }
+
+    msFree(fileExtension);
+
+    if (success)
+      return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Try GDAL.                                                       */
+  /*                                                                      */
+  /*      Make sure that ymax is always at the top, and ymin at the       */
+  /*      bottom ... that is flip any files without the usual             */
+  /*      orientation.  This is intended to enable display of "raw"       */
+  /*      files with no coordinate system otherwise they break down in    */
+  /*      many ways.                                                      */
+  /* -------------------------------------------------------------------- */
+  if (GDALGetGeoTransform(hDS, padfGeoTransform) == CE_None) {
+    if (padfGeoTransform[5] == 1.0 && padfGeoTransform[3] == 0.0) {
+      padfGeoTransform[5] = -1.0;
+      padfGeoTransform[3] = GDALGetRasterYSize(hDS);
+    }
+
+    return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Try worldfile.                                                  */
+  /* -------------------------------------------------------------------- */
+  if (GDALGetDescription(hDS) != NULL &&
+      GDALReadWorldFile(GDALGetDescription(hDS), "wld", padfGeoTransform)) {
+    return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Do we have the extent keyword on the layer?  We only use        */
+  /*      this if we have a single raster associated with the layer as    */
+  /*      opposed to a tile index.                                        */
+  /*                                                                      */
+  /*      Arguably this ought to take priority over all the other         */
+  /*      stuff.                                                          */
+  /* -------------------------------------------------------------------- */
+  if (MS_VALID_EXTENT(layer->extent) && layer->data != NULL) {
+    rect = layer->extent;
+
+    padfGeoTransform[0] = rect.minx;
+    padfGeoTransform[1] =
+        (rect.maxx - rect.minx) / (double)GDALGetRasterXSize(hDS);
+    padfGeoTransform[2] = 0;
+    padfGeoTransform[3] = rect.maxy;
+    padfGeoTransform[4] = 0;
+    padfGeoTransform[5] =
+        (rect.miny - rect.maxy) / (double)GDALGetRasterYSize(hDS);
+
+    return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      We didn't find any info ... use the default.                    */
+  /*      Reset our default geotransform.  GDALGetGeoTransform() may      */
+  /*      have altered it even if GDALGetGeoTransform() failed.           */
+  /* -------------------------------------------------------------------- */
+  padfGeoTransform[0] = 0.0;
+  padfGeoTransform[1] = 1.0;
+  padfGeoTransform[2] = 0.0;
+  padfGeoTransform[3] = GDALGetRasterYSize(hDS);
+  padfGeoTransform[4] = 0.0;
+  padfGeoTransform[5] = -1.0;
+
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                   msDrawRasterLayerGDAL_RawMode()                    */
+/*                                                                      */
+/*      Handle the loading and application of data in rawmode.          */
+/************************************************************************/
+
+static int
+msDrawRasterLayerGDAL_RawMode(mapObj *map, layerObj *layer, imageObj *image,
+                              GDALDatasetH hDS, int src_xoff, int src_yoff,
+                              int src_xsize, int src_ysize, int dst_xoff,
+                              int dst_yoff, int dst_xsize, int dst_ysize)
+
+{
+  void *pBuffer;
+  GDALDataType eDataType;
+  int *band_list, band_count;
+  int i, j, k, band;
+  CPLErr eErr;
+  float *f_nodatas = NULL;
+  unsigned char *b_nodatas = NULL;
+  GInt16 *i_nodatas = NULL;
+  int got_nodata = FALSE;
+  rasterBufferObj *mask_rb = NULL;
+  rasterBufferObj s_mask_rb;
+  if (layer->mask) {
+    int ret;
+    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map, layer->mask));
+    mask_rb = &s_mask_rb;
+    memset(mask_rb, 0, sizeof(s_mask_rb));
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS)
+      return -1;
+  }
+
+  if (image->format->bands > 256) {
+    msSetError(MS_IMGERR, "Too many bands (more than 256).",
+               "msDrawRasterLayerGDAL_RawMode()");
+    return -1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      What data type do we need?                                      */
+  /* -------------------------------------------------------------------- */
+  if (image->format->imagemode == MS_IMAGEMODE_INT16)
+    eDataType = GDT_Int16;
+  else if (image->format->imagemode == MS_IMAGEMODE_FLOAT32)
+    eDataType = GDT_Float32;
+  else if (image->format->imagemode == MS_IMAGEMODE_BYTE)
+    eDataType = GDT_Byte;
+  else
+    return -1;
+
+  /* -------------------------------------------------------------------- */
+  /*      Work out the band list.                                         */
+  /* -------------------------------------------------------------------- */
+  band_list = msGetGDALBandList(layer, hDS, image->format->bands, &band_count);
+  if (band_list == NULL)
+    return -1;
+
+  if (band_count != image->format->bands) {
+    free(band_list);
+    msSetError(MS_IMGERR,
+               "BANDS PROCESSING directive has wrong number of bands, expected "
+               "%d, got %d.",
+               "msDrawRasterLayerGDAL_RawMode()", image->format->bands,
+               band_count);
+    return -1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Do we have nodata values?                                       */
+  /* -------------------------------------------------------------------- */
+  f_nodatas = (float *)calloc(sizeof(float), band_count);
+  if (f_nodatas == NULL) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawRasterLayerGDAL_RawMode()", __FILE__, __LINE__,
+               (unsigned int)(sizeof(float) * band_count));
+    free(band_list);
+    return -1;
+  }
+
+  if (band_count <= 3 &&
+      (layer->offsite.red != -1 || layer->offsite.green != -1 ||
+       layer->offsite.blue != -1)) {
+    if (band_count > 0)
+      f_nodatas[0] = layer->offsite.red;
+    if (band_count > 1)
+      f_nodatas[1] = layer->offsite.green;
+    if (band_count > 2)
+      f_nodatas[2] = layer->offsite.blue;
+    got_nodata = TRUE;
+  }
+
+  if (!got_nodata) {
+    got_nodata = TRUE;
+    for (band = 0; band < band_count && got_nodata; band++) {
+      f_nodatas[band] = msGetGDALNoDataValue(
+          layer, GDALGetRasterBand(hDS, band_list[band]), &got_nodata);
+    }
+  }
+
+  if (!got_nodata) {
+    free(f_nodatas);
+    f_nodatas = NULL;
+  } else if (eDataType == GDT_Byte) {
+    b_nodatas = (unsigned char *)f_nodatas;
+    for (band = 0; band < band_count; band++)
+      b_nodatas[band] = (unsigned char)f_nodatas[band];
+  } else if (eDataType == GDT_Int16) {
+    i_nodatas = (GInt16 *)f_nodatas;
+    for (band = 0; band < band_count; band++)
+      i_nodatas[band] = (GInt16)f_nodatas[band];
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Allocate buffer, and read data into it.                         */
+  /* -------------------------------------------------------------------- */
+  pBuffer = malloc(((size_t)dst_xsize) * dst_ysize * image->format->bands *
+                   (GDALGetDataTypeSize(eDataType) / 8));
+  if (pBuffer == NULL) {
+    msSetError(MS_MEMERR, "Allocating work image of size %dx%d failed.",
+               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize);
+    free(band_list);
+    free(f_nodatas);
+    return -1;
+  }
+
+  eErr =
+      GDALDatasetRasterIO(hDS, GF_Read, src_xoff, src_yoff, src_xsize,
+                          src_ysize, pBuffer, dst_xsize, dst_ysize, eDataType,
+                          image->format->bands, band_list, 0, 0, 0);
+  free(band_list);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALRasterIO() failed: %s",
+               "msDrawRasterLayerGDAL_RawMode()", CPLGetLastErrorMsg());
+    free(pBuffer);
+    free(f_nodatas);
+    return -1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Transfer the data to the imageObj.                              */
+  /* -------------------------------------------------------------------- */
+  k = 0;
+  for (band = 0; band < image->format->bands; band++) {
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      if (image->format->imagemode == MS_IMAGEMODE_INT16) {
+        for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
+          int off = j + i * image->width + band * image->width * image->height;
+          int off_mask = j + i * image->width;
+
+          if ((i_nodatas && ((GInt16 *)pBuffer)[k] == i_nodatas[band]) ||
+              SKIP_MASK(j, i)) {
+            k++;
+            continue;
+          }
+
+          image->img.raw_16bit[off] = ((GInt16 *)pBuffer)[k++];
+          MS_SET_BIT(image->img_mask, off_mask);
+        }
+      } else if (image->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+        for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
+          int off = j + i * image->width + band * image->width * image->height;
+          int off_mask = j + i * image->width;
+
+          if ((f_nodatas && ((float *)pBuffer)[k] == f_nodatas[band]) ||
+              SKIP_MASK(j, i)) {
+            k++;
+            continue;
+          }
+
+          image->img.raw_float[off] = ((float *)pBuffer)[k++];
+          MS_SET_BIT(image->img_mask, off_mask);
+        }
+      } else if (image->format->imagemode == MS_IMAGEMODE_BYTE) {
+        for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
+          int off = j + i * image->width + band * image->width * image->height;
+          int off_mask = j + i * image->width;
+
+          if ((b_nodatas && ((unsigned char *)pBuffer)[k] == b_nodatas[band]) ||
+              SKIP_MASK(j, i)) {
+            k++;
+            continue;
+          }
+
+          image->img.raw_byte[off] = ((unsigned char *)pBuffer)[k++];
+          MS_SET_BIT(image->img_mask, off_mask);
+        }
+      }
+    }
+  }
+
+  free(pBuffer);
+  free(f_nodatas);
+
+  return 0;
+}
+
+/************************************************************************/
+/*              msDrawRasterLayerGDAL_16BitClassifcation()              */
+/*                                                                      */
+/*      Handle the rendering of rasters going through a 16bit           */
+/*      classification lookup instead of the more common 8bit one.      */
+/*                                                                      */
+/*      Currently we are using one data path where we load the          */
+/*      raster into a floating point buffer, and then scale to          */
+/*      16bit.  Eventually we could add optimizations for some of       */
+/*      the 16bit cases at the cost of some complication.               */
+/************************************************************************/
+
+static int msDrawRasterLayerGDAL_16BitClassification(
+    mapObj *map, layerObj *layer, rasterBufferObj *rb, GDALRasterBandH hBand,
+    int src_xoff, int src_yoff, int src_xsize, int src_ysize, int dst_xoff,
+    int dst_yoff, int dst_xsize, int dst_ysize)
+
+{
+  float *pafRawData;
+  double dfScaleMin = 0.0, dfScaleMax = 0.0, dfScaleRatio;
+  int nPixelCount = dst_xsize * dst_ysize, i, nBucketCount = 0;
+  GDALDataType eDataType;
+  float fDataMin = 0.0, fDataMax = 255.0, fNoDataValue;
+  const char *pszScaleInfo;
+  const char *pszBuckets;
+  int *cmap, c, j, k, bGotNoData = FALSE, bGotFirstValue;
+  unsigned char *rb_cmap[4];
+  CPLErr eErr;
+  rasterBufferObj *mask_rb = NULL;
+  rasterBufferObj s_mask_rb;
+  int lastC;
+  struct mstimeval starttime = {0}, endtime = {0};
+
+  const char *pszClassifyScaled;
+  int bClassifyScaled = FALSE;
+
+  if (layer->mask) {
+    int ret;
+    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map, layer->mask));
+    mask_rb = &s_mask_rb;
+    memset(mask_rb, 0, sizeof(s_mask_rb));
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS)
+      return -1;
+  }
+
+  assert(rb->type == MS_BUFFER_BYTE_RGBA);
+
+  /* ==================================================================== */
+  /*      Read the requested data in one gulp into a floating point       */
+  /*      buffer.                                                         */
+  /* ==================================================================== */
+  pafRawData = (float *)malloc(sizeof(float) * dst_xsize * dst_ysize);
+  if (pafRawData == NULL) {
+    msSetError(MS_MEMERR, "Out of memory allocating working buffer.",
+               "msDrawRasterLayerGDAL_16BitClassification()");
+    return -1;
+  }
+
+  eErr = GDALRasterIO(hBand, GF_Read, src_xoff, src_yoff, src_xsize, src_ysize,
+                      pafRawData, dst_xsize, dst_ysize, GDT_Float32, 0, 0);
+
+  if (eErr != CE_None) {
+    free(pafRawData);
+    msSetError(MS_IOERR, "GDALRasterIO() failed: %s",
+               "msDrawRasterLayerGDAL_16BitClassification()",
+               CPLGetLastErrorMsg());
+    return -1;
+  }
+
+  fNoDataValue = (float)msGetGDALNoDataValue(layer, hBand, &bGotNoData);
+
+  /* ==================================================================== */
+  /*      Determine scaling.                                              */
+  /* ==================================================================== */
+  eDataType = GDALGetRasterDataType(hBand);
+
+  /* -------------------------------------------------------------------- */
+  /*      Scan for absolute min/max of this block.                        */
+  /* -------------------------------------------------------------------- */
+  bGotFirstValue = FALSE;
+
+  for (i = 1; i < nPixelCount; i++) {
+    if (bGotNoData && IsNoData(pafRawData[i], fNoDataValue))
+      continue;
+
+    if (CPLIsNan(pafRawData[i]))
+      continue;
+
+    if (!bGotFirstValue) {
+      fDataMin = fDataMax = pafRawData[i];
+      bGotFirstValue = TRUE;
+    } else {
+      fDataMin = MS_MIN(fDataMin, pafRawData[i]);
+      fDataMax = MS_MAX(fDataMax, pafRawData[i]);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch the scale classification option.                          */
+  /* -------------------------------------------------------------------- */
+  pszClassifyScaled = CSLFetchNameValue(layer->processing, "CLASSIFY_SCALED");
+  if (pszClassifyScaled != NULL)
+    bClassifyScaled = CSLTestBoolean(pszClassifyScaled);
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch the scale processing option.                              */
+  /* -------------------------------------------------------------------- */
+  pszBuckets = CSLFetchNameValue(layer->processing, "SCALE_BUCKETS");
+  pszScaleInfo = CSLFetchNameValue(layer->processing, "SCALE");
+
+  if (pszScaleInfo != NULL) {
+    char **papszTokens;
+
+    papszTokens = CSLTokenizeStringComplex(pszScaleInfo, " ,", FALSE, FALSE);
+    if (CSLCount(papszTokens) == 1 && EQUAL(papszTokens[0], "AUTO")) {
+      dfScaleMin = dfScaleMax = 0.0;
+    } else if (CSLCount(papszTokens) != 2) {
+      free(pafRawData);
+      CSLDestroy(papszTokens);
+      msSetError(MS_MISCERR, "SCALE PROCESSING option unparsable for layer %s.",
+                 "msDrawGDAL()", layer->name);
+      return -1;
+    } else {
+      dfScaleMin = atof(papszTokens[0]);
+      dfScaleMax = atof(papszTokens[1]);
+    }
+    CSLDestroy(papszTokens);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Special integer cases for scaling.                              */
+  /*                                                                      */
+  /*      TODO: Treat Int32 and UInt32 case the same way *if* the min     */
+  /*      and max are less than 65536 apart.                              */
+  /* -------------------------------------------------------------------- */
+  if (eDataType == GDT_Byte || eDataType == GDT_Int16 ||
+      eDataType == GDT_UInt16) {
+    if (pszScaleInfo == NULL) {
+      dfScaleMin = fDataMin - 0.5;
+      dfScaleMax = fDataMax + 0.5;
+    }
+
+    if (pszBuckets == NULL) {
+      nBucketCount = (int)floor(fDataMax - fDataMin + 1.1);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      General case if no scaling values provided in mapfile.          */
+  /* -------------------------------------------------------------------- */
+  else if (dfScaleMin == 0.0 && dfScaleMax == 0.0) {
+    double dfEpsilon = (fDataMax - fDataMin) / (65536 * 2);
+    dfScaleMin = fDataMin - dfEpsilon;
+    dfScaleMax = fDataMax + dfEpsilon;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      How many buckets?  Only set if we don't already have a value.   */
+  /* -------------------------------------------------------------------- */
+  if (pszBuckets == NULL) {
+    if (nBucketCount == 0)
+      nBucketCount = 65536;
+  } else {
+    nBucketCount = atoi(pszBuckets);
+    if (nBucketCount < 2) {
+      free(pafRawData);
+      msSetError(
+          MS_MISCERR,
+          "SCALE_BUCKETS PROCESSING option is not a value of 2 or more: %s.",
+          "msDrawRasterLayerGDAL_16BitClassification()", pszBuckets);
+      return -1;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Compute scaling ratio.                                          */
+  /* -------------------------------------------------------------------- */
+  if (dfScaleMax == dfScaleMin)
+    dfScaleMax = dfScaleMin + 1.0;
+
+  dfScaleRatio = nBucketCount / (dfScaleMax - dfScaleMin);
+
+  if (layer->debug > 0)
+    msDebug("msDrawRasterGDAL_16BitClassification(%s):\n"
+            "  scaling to %d buckets from range=%g,%g.\n",
+            layer->name, nBucketCount, dfScaleMin, dfScaleMax);
+
+  /* ==================================================================== */
+  /*      Compute classification lookup table.                            */
+  /* ==================================================================== */
+
+  cmap = (int *)msSmallCalloc(sizeof(int), nBucketCount);
+  rb_cmap[0] = (unsigned char *)msSmallCalloc(1, nBucketCount);
+  rb_cmap[1] = (unsigned char *)msSmallCalloc(1, nBucketCount);
+  rb_cmap[2] = (unsigned char *)msSmallCalloc(1, nBucketCount);
+  rb_cmap[3] = (unsigned char *)msSmallCalloc(1, nBucketCount);
+
+  if (layer->debug >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&starttime, NULL);
+  }
+
+  lastC = -1;
+  for (i = 0; i < nBucketCount; i++) {
+    double dfOriginalValue;
+
+    cmap[i] = -1;
+
+    // i = (int) ((dfOriginalValue - dfScaleMin) * dfScaleRatio+1)-1;
+    dfOriginalValue = (i + 0.5) / dfScaleRatio + dfScaleMin;
+
+    /* The creation of buckets takes a significant time when they are many, and
+       many classes as well. When iterating over buckets, a faster strategy is
+       to reuse first the last used class index. */
+    if (bClassifyScaled == TRUE)
+      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float)i, -1, -1, -1,
+                                                  lastC);
+    else
+      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float)dfOriginalValue,
+                                                  -1, -1, -1, lastC);
+
+    lastC = c;
+    if (c != -1) {
+      int s;
+      int styleindex = 0;
+
+      /* change colour based on colour range? */
+      if (MS_VALID_COLOR(layer->class[c] -> styles[0] -> mincolor)) {
+        styleindex = -1;
+        for (s = 0; s < layer->class[c] -> numstyles; s++) {
+          if (MS_VALID_COLOR(layer->class[c] -> styles[s] -> mincolor) &&
+                  MS_VALID_COLOR(layer->class[c] -> styles[s] -> maxcolor) &&
+                  dfOriginalValue + 0.5 / dfScaleRatio >=
+                      layer->class[c] -> styles[s]
+              -> minvalue && dfOriginalValue - 0.5 / dfScaleRatio <=
+                                 layer -> class[c] -> styles[s] -> maxvalue) {
+            msValueToRange(layer->class[c] -> styles[s], dfOriginalValue,
+                           MS_COLORSPACE_RGB);
+            styleindex = s;
+            break;
+          }
+        }
+      }
+      if (styleindex >= 0) {
+        if (MS_TRANSPARENT_COLOR(
+                layer->class[c] -> styles[styleindex] -> color)) {
+          /* leave it transparent */
+        } else if (MS_VALID_COLOR(
+                       layer->class[c] -> styles[styleindex] -> color)) {
+          /* use class color */
+          rb_cmap[0][i] = layer->class[c]->styles[styleindex]->color.red;
+          rb_cmap[1][i] = layer->class[c]->styles[styleindex]->color.green;
+          rb_cmap[2][i] = layer->class[c]->styles[styleindex]->color.blue;
+          rb_cmap[3][i] =
+              (255 * layer->class[c] -> styles[styleindex] -> opacity / 100);
+        }
+      }
+    }
+  }
+
+  if (layer->debug >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&endtime, NULL);
+    msDebug(
+        "msDrawRasterGDAL_16BitClassification() bucket creation time: %.3fs\n",
+        (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+            (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+  }
+
+  /* ==================================================================== */
+  /*      Now process the data, applying to the working imageObj.         */
+  /* ==================================================================== */
+  k = 0;
+
+  for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+    for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
+      float fRawValue = pafRawData[k++];
+      int iMapIndex;
+
+      /*
+       * Skip nodata pixels ... no processing.
+       */
+      if (bGotNoData && IsNoData(fRawValue, fNoDataValue))
+        continue;
+
+      if (CPLIsNan(fRawValue))
+        continue;
+
+      if (SKIP_MASK(j, i))
+        continue;
+
+      /*
+       * The funny +1/-1 is to avoid odd rounding around zero.
+       * We could use floor() but sometimes it is expensive.
+       */
+      iMapIndex = (int)((fRawValue - dfScaleMin) * dfScaleRatio + 1) - 1;
+
+      if (iMapIndex >= nBucketCount || iMapIndex < 0) {
+        continue;
+      }
+      /* currently we never have partial alpha so keep simple */
+      if (rb_cmap[3][iMapIndex] > 0)
+        RB_SET_PIXEL(rb, j, i, rb_cmap[0][iMapIndex], rb_cmap[1][iMapIndex],
+                     rb_cmap[2][iMapIndex], rb_cmap[3][iMapIndex]);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Cleanup                                                         */
+  /* -------------------------------------------------------------------- */
+  free(pafRawData);
+  free(cmap);
+  free(rb_cmap[0]);
+  free(rb_cmap[1]);
+  free(rb_cmap[2]);
+  free(rb_cmap[3]);
+
+  assert(k == dst_xsize * dst_ysize);
+
+  return 0;
+}
+
+/************************************************************************/
+/*                          IsNoData()                                  */
+/************************************************************************/
+static bool IsNoData(double dfValue, double dfNoDataValue) {
+  return isnan(dfValue) || dfValue == dfNoDataValue;
+}
+
+/************************************************************************/
+/*                          msGetGDALNoDataValue()                      */
+/************************************************************************/
+double msGetGDALNoDataValue(layerObj *layer, void *hBand, int *pbGotNoData)
+
+{
+  const char *pszNODATAOpt;
+
+  *pbGotNoData = FALSE;
+
+  /* -------------------------------------------------------------------- */
+  /*      Check for a NODATA setting in the .map file.                    */
+  /* -------------------------------------------------------------------- */
+  pszNODATAOpt = CSLFetchNameValue(layer->processing, "NODATA");
+  if (pszNODATAOpt != NULL) {
+    if (EQUAL(pszNODATAOpt, "OFF") || strlen(pszNODATAOpt) == 0)
+      return -1234567.0;
+    if (!EQUAL(pszNODATAOpt, "AUTO")) {
+      *pbGotNoData = TRUE;
+      return atof(pszNODATAOpt);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Check for a NODATA setting on the raw file.                     */
+  /* -------------------------------------------------------------------- */
+  if (hBand == NULL)
+    return -1234567.0;
+  else
+    return GDALGetRasterNoDataValue(hBand, pbGotNoData);
+}
+
+/************************************************************************/
+/*                         msGetGDALBandList()                          */
+/*                                                                      */
+/*      max_bands - pass zero for no limit.                             */
+/*      band_count - location in which length of the return band        */
+/*      list is placed.                                                 */
+/*                                                                      */
+/*      returns malloc() list of band numbers (*band_count long).       */
+/************************************************************************/
+
+int *msGetGDALBandList(layerObj *layer, void *hDS, int max_bands,
+                       int *band_count)
+
+{
+  int i, file_bands;
+  int *band_list = NULL;
+
+  file_bands = GDALGetRasterCount(hDS);
+  if (file_bands == 0) {
+    msSetError(MS_IMGERR,
+               "Attempt to operate on GDAL file with no bands, layer=%s.",
+               "msGetGDALBandList()", layer->name);
+
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Use all (or first) bands.                                       */
+  /* -------------------------------------------------------------------- */
+  if (CSLFetchNameValue(layer->processing, "BANDS") == NULL) {
+    if (max_bands > 0)
+      *band_count = MS_MIN(file_bands, max_bands);
+    else
+      *band_count = file_bands;
+
+    band_list = (int *)malloc(sizeof(int) * *band_count);
+
+    /* FIXME MS_CHECK_ALLOC leaks papszItems */
+    MS_CHECK_ALLOC(band_list, sizeof(int) * *band_count, NULL);
+
+    for (i = 0; i < *band_count; i++)
+      band_list[i] = i + 1;
+    return band_list;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      get bands from BANDS processing directive.                      */
+  /* -------------------------------------------------------------------- */
+  else {
+    char **papszItems = CSLTokenizeStringComplex(
+        CSLFetchNameValue(layer->processing, "BANDS"), " ,", FALSE, FALSE);
+
+    if (CSLCount(papszItems) == 0) {
+      CSLDestroy(papszItems);
+      msSetError(MS_IMGERR, "BANDS PROCESSING directive has no items.",
+                 "msGetGDALBandList()");
+      return NULL;
+    } else if (max_bands != 0 && CSLCount(papszItems) > max_bands) {
+      msSetError(MS_IMGERR,
+                 "BANDS PROCESSING directive has wrong number of bands, "
+                 "expected at most %d, got %d.",
+                 "msGetGDALBandList()", max_bands, CSLCount(papszItems));
+      CSLDestroy(papszItems);
+      return NULL;
+    }
+
+    *band_count = CSLCount(papszItems);
+    band_list = (int *)malloc(sizeof(int) * *band_count);
+    MS_CHECK_ALLOC(band_list, sizeof(int) * *band_count, NULL);
+
+    for (i = 0; i < *band_count; i++) {
+      band_list[i] = atoi(papszItems[i]);
+      if (band_list[i] < 1 || band_list[i] > GDALGetRasterCount(hDS)) {
+        msSetError(MS_IMGERR,
+                   "BANDS PROCESSING directive includes illegal band '%s', "
+                   "should be from 1 to %d.",
+                   "msGetGDALBandList()", papszItems[i],
+                   GDALGetRasterCount(hDS));
+        CSLDestroy(papszItems);
+        free(band_list);
+        return NULL;
+      }
+    }
+    CSLDestroy(papszItems);
+
+    return band_list;
+  }
+}
diff -pruN 8.0.1-5/src/mapdummyrenderer.c 8.2.0~beta1-1~exp1/src/mapdummyrenderer.c
--- 8.0.1-5/src/mapdummyrenderer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapdummyrenderer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,388 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Dummy functions to implement when using a pluggable renderer
+ * Author:   Thomas Bonfort, thomas.bonfort@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2010, Thomas Bonfort
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+
+int renderLineDummy(imageObj *img, shapeObj *p, strokeStyleObj *style) {
+  (void)img;
+  (void)p;
+  (void)style;
+  msSetError(MS_RENDERERERR, "renderLine not implemented", "renderLine()");
+  return MS_FAILURE;
+}
+
+int renderPolygonDummy(imageObj *img, shapeObj *p, colorObj *color) {
+  (void)img;
+  (void)p;
+  (void)color;
+  msSetError(MS_RENDERERERR, "renderPolygon not implemented",
+             "renderPolygon()");
+  return MS_FAILURE;
+}
+
+int renderPolygonTiledDummy(imageObj *img, shapeObj *p, imageObj *tile) {
+  (void)img;
+  (void)p;
+  (void)tile;
+  msSetError(MS_RENDERERERR, "renderPolygonTiled not implemented",
+             "renderPolygonTiled()");
+  return MS_FAILURE;
+}
+
+int renderLineTiledDummy(imageObj *img, shapeObj *p, imageObj *tile) {
+  (void)img;
+  (void)p;
+  (void)tile;
+  msSetError(MS_RENDERERERR, "renderLineTiled not implemented",
+             "renderLineTiled()");
+  return MS_FAILURE;
+}
+
+int renderRasterGlyphsDummy(imageObj *img, double x, double y, int fontIndex,
+                            colorObj *color, char *text) {
+  (void)img;
+  (void)x;
+  (void)y;
+  (void)fontIndex;
+  (void)color;
+  (void)text;
+  msSetError(MS_RENDERERERR, "renderRasterGlyphs not implemented",
+             "renderRasterGlyphs()");
+  return MS_FAILURE;
+}
+
+int renderGlyphsLineDummy(imageObj *img, labelPathObj *labelpath,
+                          labelStyleObj *style, char *text) {
+  (void)img;
+  (void)labelpath;
+  (void)style;
+  (void)text;
+  msSetError(MS_RENDERERERR, "renderGlyphsLine not implemented",
+             "renderGlyphsLine()");
+  return MS_FAILURE;
+}
+
+int renderVectorSymbolDummy(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  (void)img;
+  (void)x;
+  (void)y;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "renderVectorSymbol not implemented",
+             "renderVectorSymbol()");
+  return MS_FAILURE;
+}
+
+void *createVectorSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                  symbolStyleObj *style) {
+  (void)width;
+  (void)height;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "createVectorSymbolTile not implemented",
+             "createVectorSymbolTile()");
+  return NULL;
+}
+
+int renderPixmapSymbolDummy(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  (void)img;
+  (void)x;
+  (void)y;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "renderPixmapSymbol not implemented",
+             "renderPixmapSymbol()");
+  return MS_FAILURE;
+}
+
+void *createPixmapSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                  symbolStyleObj *style) {
+  (void)width;
+  (void)height;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "createPixmapSymbolTile not implemented",
+             "createPixmapSymbolTile()");
+  return NULL;
+}
+
+int renderEllipseSymbolDummy(imageObj *image, double x, double y,
+                             symbolObj *symbol, symbolStyleObj *style) {
+  (void)image;
+  (void)x;
+  (void)y;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "renderEllipseSymbol not implemented",
+             "renderEllipseSymbol()");
+  return MS_FAILURE;
+}
+
+void *createEllipseSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                   symbolStyleObj *style) {
+  (void)width;
+  (void)height;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "createEllipseSymbolTile not implemented",
+             "createEllipseSymbolTile()");
+  return NULL;
+}
+
+int renderTruetypeSymbolDummy(imageObj *img, double x, double y,
+                              symbolObj *symbol, symbolStyleObj *style) {
+  (void)img;
+  (void)x;
+  (void)y;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "renderTruetypeSymbol not implemented",
+             "renderTruetypeSymbol()");
+  return MS_FAILURE;
+}
+
+void *createTruetypeSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                    symbolStyleObj *style) {
+  (void)width;
+  (void)height;
+  (void)symbol;
+  (void)style;
+  msSetError(MS_RENDERERERR, "createTruetypeSymbolTile not implemented",
+             "createTruetypeSymbolTile()");
+  return NULL;
+}
+
+int renderTileDummy(imageObj *img, imageObj *tile, double x, double y) {
+  (void)img;
+  (void)tile;
+  (void)x;
+  (void)y;
+  msSetError(MS_RENDERERERR, "renderTile not implemented", "renderTile()");
+  return MS_FAILURE;
+}
+
+rasterBufferObj *loadImageFromFileDummy(char *path) {
+  (void)path;
+  msSetError(MS_RENDERERERR, "loadImageFromFile not implemented",
+             "loadImageFromFile()");
+  return NULL;
+}
+
+int getRasterBufferHandleDummy(imageObj *img, rasterBufferObj *rb) {
+  (void)img;
+  (void)rb;
+  msSetError(MS_RENDERERERR, "getRasterBufferHandle not implemented",
+             "getRasterBufferHandle()");
+  return MS_FAILURE;
+}
+
+int getRasterBufferCopyDummy(imageObj *img, rasterBufferObj *rb) {
+  (void)img;
+  (void)rb;
+  msSetError(MS_RENDERERERR, "getRasterBufferCopy not implemented",
+             "getRasterBufferCopy()");
+  return MS_FAILURE;
+}
+
+rasterBufferObj *createRasterBufferDummy(int width, int height) {
+  (void)width;
+  (void)height;
+  msSetError(MS_RENDERERERR, "createRasterBuffer not implemented",
+             "createRasterBuffer()");
+  return NULL;
+}
+
+int mergeRasterBufferDummy(imageObj *dest, rasterBufferObj *overlay,
+                           double opacity, int srcX, int srcY, int dstX,
+                           int dstY, int width, int height) {
+  (void)dest;
+  (void)overlay;
+  (void)opacity;
+  (void)srcX;
+  (void)srcY;
+  (void)dstX;
+  (void)dstY;
+  (void)width;
+  (void)height;
+  msSetError(MS_RENDERERERR, "mergeRasterBuffer not implemented",
+             "mergeRasterBuffer()");
+  return MS_FAILURE;
+}
+
+int initializeRasterBufferDummy(rasterBufferObj *rb, int width, int height,
+                                int mode) {
+  (void)rb;
+  (void)width;
+  (void)height;
+  (void)mode;
+  msSetError(MS_RENDERERERR, "initializeRasterBuffer not implemented",
+             "initializeRasterBuffer()");
+  return MS_FAILURE;
+}
+
+/* image i/o */
+imageObj *createImageDummy(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
+  (void)width;
+  (void)height;
+  (void)format;
+  (void)bg;
+  msSetError(MS_RENDERERERR, "createImage not implemented", "createImage()");
+  return NULL;
+}
+
+int saveImageDummy(imageObj *img, mapObj *map, FILE *fp,
+                   outputFormatObj *format) {
+  (void)img;
+  (void)map;
+  (void)fp;
+  (void)format;
+  msSetError(MS_RENDERERERR, "saveImage not implemented", "saveImage()");
+  return MS_FAILURE;
+}
+/*...*/
+
+/* helper functions */
+int getTruetypeTextBBoxDummy(rendererVTableObj *renderer, char **fonts,
+                             int numfonts, double size, char *string,
+                             rectObj *rect, double **advances,
+                             int bAdjustBaseline) {
+  (void)renderer;
+  (void)fonts;
+  (void)numfonts;
+  (void)size;
+  (void)string;
+  (void)rect;
+  (void)advances;
+  (void)bAdjustBaseline;
+  msSetError(MS_RENDERERERR, "getTruetypeTextBBox not implemented",
+             "getTruetypeTextBBox()");
+  return MS_FAILURE;
+}
+
+int startLayerDummy(imageObj *img, mapObj *map, layerObj *layer) {
+  (void)img;
+  (void)map;
+  (void)layer;
+  msSetError(MS_RENDERERERR, "startLayer not implemented", "startLayer()");
+  return MS_FAILURE;
+}
+
+int endLayerDummy(imageObj *img, mapObj *map, layerObj *layer) {
+  (void)img;
+  (void)map;
+  (void)layer;
+  msSetError(MS_RENDERERERR, "endLayer not implemented", "endLayer()");
+  return MS_FAILURE;
+}
+
+int startShapeDummy(imageObj *img, shapeObj *shape) {
+  (void)img;
+  (void)shape;
+  msSetError(MS_RENDERERERR, "startShape not implemented", "startShape()");
+  return MS_FAILURE;
+}
+
+int endShapeDummy(imageObj *img, shapeObj *shape) {
+  (void)img;
+  (void)shape;
+  msSetError(MS_RENDERERERR, "endShape not implemented", "endShape()");
+  return MS_FAILURE;
+}
+
+int setClipDummy(imageObj *img, rectObj clipRect) {
+  (void)img;
+  (void)clipRect;
+  msSetError(MS_RENDERERERR, "setClip not implemented", "setClip()");
+  return MS_FAILURE;
+}
+int resetClipDummy(imageObj *img) {
+  (void)img;
+  msSetError(MS_RENDERERERR, "resetClip not implemented", "resetClip()");
+  return MS_FAILURE;
+}
+
+int freeImageDummy(imageObj *image) {
+  (void)image;
+  msSetError(MS_RENDERERERR, "freeImage not implemented", "freeImage()");
+  return MS_FAILURE;
+}
+
+int freeTileDummy(imageObj *tile) {
+  (void)tile;
+  msSetError(MS_RENDERERERR, "freeTile not implemented", "freeTile()");
+  return MS_FAILURE;
+}
+
+int freeSymbolDummy(symbolObj *symbol) {
+  (void)symbol;
+  msSetError(MS_RENDERERERR, "freeSymbol not implemented", "freeSymbol()");
+  return MS_FAILURE;
+}
+
+int cleanupDummy(void *renderer_data) {
+  (void)renderer_data;
+  return MS_SUCCESS;
+}
+
+int msInitializeDummyRenderer(rendererVTableObj *renderer) {
+
+  renderer->use_imagecache = 0;
+  renderer->supports_pixel_buffer = 0;
+  renderer->compositeRasterBuffer = NULL;
+  renderer->supports_clipping = 0;
+  renderer->supports_svg = 0;
+  renderer->renderer_data = NULL;
+  renderer->transform_mode = MS_TRANSFORM_SIMPLIFY;
+  renderer->startLayer = &startLayerDummy;
+  renderer->endLayer = &endLayerDummy;
+  renderer->renderLine = &renderLineDummy;
+  renderer->renderLineTiled = NULL;
+  renderer->createImage = &createImageDummy;
+  renderer->saveImage = &saveImageDummy;
+  renderer->getRasterBufferHandle = &getRasterBufferHandleDummy;
+  renderer->getRasterBufferCopy = getRasterBufferCopyDummy;
+  renderer->initializeRasterBuffer = initializeRasterBufferDummy;
+  renderer->renderPolygon = &renderPolygonDummy;
+  renderer->freeImage = &freeImageDummy;
+  renderer->renderEllipseSymbol = &renderEllipseSymbolDummy;
+  renderer->renderVectorSymbol = &renderVectorSymbolDummy;
+  renderer->renderPixmapSymbol = &renderPixmapSymbolDummy;
+  renderer->mergeRasterBuffer = &mergeRasterBufferDummy;
+  renderer->renderTile = &renderTileDummy;
+  renderer->renderPolygonTiled = &renderPolygonTiledDummy;
+  renderer->freeSymbol = &freeSymbolDummy;
+  renderer->cleanup = &cleanupDummy;
+  renderer->startShape = NULL;
+  renderer->endShape = NULL;
+  renderer->renderGlyphs = NULL;
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapentities.h 8.2.0~beta1-1~exp1/src/mapentities.h
--- 8.0.1-5/src/mapentities.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapentities.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,118 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  HTML entity to unicode lookup table
+ * Author:   Thomas Bonfort
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/*
+ * Generated file
+ *
+ * This file was generated from:
+ *       http://www.w3.org/TR/REC-html40/sgml/entities.html
+ * by means of the libgd script:
+ *       entities.tcl
+ * and modified to avoid namespace collisions
+ */
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+static const struct mapentities_s {
+  const char *name;
+  int value;
+} mapentities[] = {
+    {"AElig", 198},    {"Aacute", 193},   {"Acirc", 194},   {"Agrave", 192},
+    {"Alpha", 913},    {"Aring", 197},    {"Atilde", 195},  {"Auml", 196},
+    {"Beta", 914},     {"Ccedil", 199},   {"Chi", 935},     {"Dagger", 8225},
+    {"Delta", 916},    {"ETH", 208},      {"Eacute", 201},  {"Ecirc", 202},
+    {"Egrave", 200},   {"Epsilon", 917},  {"Eta", 919},     {"Euml", 203},
+    {"Gamma", 915},    {"Iacute", 205},   {"Icirc", 206},   {"Igrave", 204},
+    {"Iota", 921},     {"Iuml", 207},     {"Kappa", 922},   {"Lambda", 923},
+    {"Mu", 924},       {"Ntilde", 209},   {"Nu", 925},      {"OElig", 338},
+    {"Oacute", 211},   {"Ocirc", 212},    {"Ograve", 210},  {"Omega", 937},
+    {"Omicron", 927},  {"Oslash", 216},   {"Otilde", 213},  {"Ouml", 214},
+    {"Phi", 934},      {"Pi", 928},       {"Prime", 8243},  {"Psi", 936},
+    {"Rho", 929},      {"Scaron", 352},   {"Sigma", 931},   {"THORN", 222},
+    {"Tau", 932},      {"Theta", 920},    {"Uacute", 218},  {"Ucirc", 219},
+    {"Ugrave", 217},   {"Upsilon", 933},  {"Uuml", 220},    {"Xi", 926},
+    {"Yacute", 221},   {"Yuml", 376},     {"Zeta", 918},    {"aacute", 225},
+    {"acirc", 226},    {"acute", 180},    {"aelig", 230},   {"agrave", 224},
+    {"alefsym", 8501}, {"alpha", 945},    {"amp", 38},      {"and", 8743},
+    {"ang", 8736},     {"aring", 229},    {"asymp", 8776},  {"atilde", 227},
+    {"auml", 228},     {"bdquo", 8222},   {"beta", 946},    {"brvbar", 166},
+    {"bull", 8226},    {"cap", 8745},     {"ccedil", 231},  {"cedil", 184},
+    {"cent", 162},     {"chi", 967},      {"circ", 710},    {"clubs", 9827},
+    {"cong", 8773},    {"copy", 169},     {"crarr", 8629},  {"cup", 8746},
+    {"curren", 164},   {"dArr", 8659},    {"dagger", 8224}, {"darr", 8595},
+    {"deg", 176},      {"delta", 948},    {"diams", 9830},  {"divide", 247},
+    {"eacute", 233},   {"ecirc", 234},    {"egrave", 232},  {"empty", 8709},
+    {"emsp", 8195},    {"ensp", 8194},    {"epsilon", 949}, {"equiv", 8801},
+    {"eta", 951},      {"eth", 240},      {"euml", 235},    {"euro", 8364},
+    {"exist", 8707},   {"fnof", 402},     {"forall", 8704}, {"frac12", 189},
+    {"frac14", 188},   {"frac34", 190},   {"frasl", 8260},  {"gamma", 947},
+    {"ge", 8805},      {"gt", 62},        {"hArr", 8660},   {"harr", 8596},
+    {"hearts", 9829},  {"hellip", 8230},  {"iacute", 237},  {"icirc", 238},
+    {"iexcl", 161},    {"igrave", 236},   {"image", 8465},  {"infin", 8734},
+    {"int", 8747},     {"iota", 953},     {"iquest", 191},  {"isin", 8712},
+    {"iuml", 239},     {"kappa", 954},    {"lArr", 8656},   {"lambda", 955},
+    {"lang", 9001},    {"laquo", 171},    {"larr", 8592},   {"lceil", 8968},
+    {"ldquo", 8220},   {"le", 8804},      {"lfloor", 8970}, {"lowast", 8727},
+    {"loz", 9674},     {"lrm", 8206},     {"lsaquo", 8249}, {"lsquo", 8216},
+    {"lt", 60},        {"macr", 175},     {"mdash", 8212},  {"micro", 181},
+    {"middot", 183},   {"minus", 8722},   {"mu", 956},      {"nabla", 8711},
+    {"nbsp", 160},     {"ndash", 8211},   {"ne", 8800},     {"ni", 8715},
+    {"not", 172},      {"notin", 8713},   {"nsub", 8836},   {"ntilde", 241},
+    {"nu", 957},       {"oacute", 243},   {"ocirc", 244},   {"oelig", 339},
+    {"ograve", 242},   {"oline", 8254},   {"omega", 969},   {"omicron", 959},
+    {"oplus", 8853},   {"or", 8744},      {"ordf", 170},    {"ordm", 186},
+    {"oslash", 248},   {"otilde", 245},   {"otimes", 8855}, {"ouml", 246},
+    {"para", 182},     {"part", 8706},    {"permil", 8240}, {"perp", 8869},
+    {"phi", 966},      {"pi", 960},       {"piv", 982},     {"plusmn", 177},
+    {"pound", 163},    {"prime", 8242},   {"prod", 8719},   {"prop", 8733},
+    {"psi", 968},      {"quot", 34},      {"rArr", 8658},   {"radic", 8730},
+    {"rang", 9002},    {"raquo", 187},    {"rarr", 8594},   {"rceil", 8969},
+    {"rdquo", 8221},   {"real", 8476},    {"reg", 174},     {"rfloor", 8971},
+    {"rho", 961},      {"rlm", 8207},     {"rsaquo", 8250}, {"rsquo", 8217},
+    {"sbquo", 8218},   {"scaron", 353},   {"sdot", 8901},   {"sect", 167},
+    {"shy", 173},      {"sigma", 963},    {"sigmaf", 962},  {"sim", 8764},
+    {"spades", 9824},  {"sub", 8834},     {"sube", 8838},   {"sum", 8721},
+    {"sup", 8835},     {"sup1", 185},     {"sup2", 178},    {"sup3", 179},
+    {"supe", 8839},    {"szlig", 223},    {"tau", 964},     {"there4", 8756},
+    {"theta", 952},    {"thetasym", 977}, {"thinsp", 8201}, {"thorn", 254},
+    {"tilde", 732},    {"times", 215},    {"trade", 8482},  {"uArr", 8657},
+    {"uacute", 250},   {"uarr", 8593},    {"ucirc", 251},   {"ugrave", 249},
+    {"uml", 168},      {"upsih", 978},    {"upsilon", 965}, {"uuml", 252},
+    {"weierp", 8472},  {"xi", 958},       {"yacute", 253},  {"yen", 165},
+    {"yuml", 255},     {"zeta", 950},     {"zwj", 8205},    {"zwnj", 8204},
+};
+
+#define MAP_ENTITY_NAME_LENGTH_MAX 8
+#define MAP_NR_OF_ENTITIES 252
+
+#ifdef __cplusplus
+}
+#endif
diff -pruN 8.0.1-5/src/maperror.c 8.2.0~beta1-1~exp1/src/maperror.c
--- 8.0.1-5/src/maperror.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maperror.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,695 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of msSetError(), msDebug() and related functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapthread.h"
+#include "maptime.h"
+
+#include <time.h>
+#ifndef _WIN32
+#include <sys/time.h>
+#include <unistd.h>
+#endif
+#include <stdarg.h>
+
+#include "cpl_conv.h"
+
+static char *const ms_errorCodes[MS_NUMERRORCODES] = {
+    "",
+    "Unable to access file.",
+    "Memory allocation error.",
+    "Incorrect data type.",
+    "Symbol definition error.",
+    "Regular expression error.",
+    "TrueType Font error.",
+    "DBASE file error.",
+    "GD library error.",
+    "Unknown identifier.",
+    "Premature End-of-File.",
+    "Projection library error.",
+    "General error message.",
+    "CGI error.",
+    "Web application error.",
+    "Image handling error.",
+    "Hash table error.",
+    "Join error.",
+    "Search returned no results.",
+    "Shapefile error.",
+    "Expression parser error.",
+    "SDE error.",
+    "OGR error.",
+    "Query error.",
+    "WMS server error.",
+    "WMS connection error.",
+    "OracleSpatial error.",
+    "WFS server error.",
+    "WFS connection error.",
+    "WMS Map Context error.",
+    "HTTP request error.",
+    "Child array error.",
+    "WCS server error.",
+    "GEOS library error.",
+    "Invalid rectangle.",
+    "Date/time error.",
+    "GML encoding error.",
+    "SOS server error.",
+    "NULL parent pointer error.",
+    "AGG library error.",
+    "OWS error.",
+    "OpenGL renderer error.",
+    "Renderer error.",
+    "V8 engine error.",
+    "OCG API error.",
+    "Flatgeobuf error."};
+
+#ifndef USE_THREAD
+
+// Get the MapServer error object
+errorObj *msGetErrorObj() {
+  static errorObj ms_error = {MS_NOERR, "", "", MS_FALSE, 0, NULL, 0};
+  return &ms_error;
+}
+#endif
+
+#ifdef USE_THREAD
+
+typedef struct te_info {
+  struct te_info *next;
+  void *thread_id;
+  errorObj ms_error;
+} te_info_t;
+
+static te_info_t *error_list = NULL;
+
+errorObj *msGetErrorObj() {
+  te_info_t *link;
+  void *thread_id;
+  errorObj *ret_obj;
+
+  msAcquireLock(TLOCK_ERROROBJ);
+
+  thread_id = msGetThreadId();
+
+  /* find link for this thread */
+
+  for (link = error_list;
+       link != NULL && link->thread_id != thread_id && link->next != NULL &&
+       link->next->thread_id != thread_id;
+       link = link->next) {
+  }
+
+  /* If the target thread link is already at the head of the list were ok */
+  if (error_list != NULL && error_list->thread_id == thread_id) {
+  }
+
+  /* We don't have one ... initialize one. */
+  else if (link == NULL || link->next == NULL) {
+    te_info_t *new_link;
+    errorObj error_obj = {MS_NOERR, "", "", 0, 0, NULL, 0};
+
+    new_link = (te_info_t *)malloc(sizeof(te_info_t));
+    new_link->next = error_list;
+    new_link->thread_id = thread_id;
+    new_link->ms_error = error_obj;
+
+    error_list = new_link;
+  }
+
+  /* If the link is not already at the head of the list, promote it */
+  else {
+    te_info_t *target = link->next;
+
+    link->next = link->next->next;
+    target->next = error_list;
+    error_list = target;
+  }
+
+  ret_obj = &(error_list->ms_error);
+
+  msReleaseLock(TLOCK_ERROROBJ);
+
+  return ret_obj;
+}
+#endif
+
+/* msInsertErrorObj()
+**
+** We maintain a chained list of errorObj in which the first errorObj is
+** the most recent (i.e. a stack).  msErrorReset() should be used to clear
+** the list.
+**
+** Note that since some code in MapServer will fetch the head of the list and
+** keep a handle on it for a while, the head of the chained list is static
+** and never changes.
+** A new errorObj is always inserted after the head, and only if the
+** head of the list already contains some information.  i.e. If the static
+** errorObj at the head of the list is empty then it is returned directly,
+** otherwise a new object is inserted after the head and the data that was in
+** the head is moved to the new errorObj, freeing the head errorObj to receive
+** the new error information.
+*/
+static errorObj *msInsertErrorObj(void) {
+  errorObj *ms_error;
+  ms_error = msGetErrorObj();
+
+  if (ms_error->code != MS_NOERR && ms_error->totalerrorcount < 100) {
+    /* Head of the list already in use, insert a new errorObj after the head
+     * and move head contents to this new errorObj, freeing the errorObj
+     * for reuse.
+     */
+    errorObj *new_error;
+    new_error = (errorObj *)malloc(sizeof(errorObj));
+
+    /* Note: if malloc() failed then we simply do nothing and the head will
+     * be overwritten by the caller... we cannot produce an error here
+     * since we are already inside a msSetError() call.
+     */
+    if (new_error) {
+      new_error->next = ms_error->next;
+      new_error->code = ms_error->code;
+      new_error->isreported = ms_error->isreported;
+      strlcpy(new_error->routine, ms_error->routine,
+              sizeof(new_error->routine));
+      strlcpy(new_error->message, ms_error->message,
+              sizeof(new_error->message));
+      new_error->errorcount = ms_error->errorcount;
+
+      ms_error->next = new_error;
+      ms_error->code = MS_NOERR;
+      ms_error->isreported = MS_FALSE;
+      ms_error->routine[0] = '\0';
+      ms_error->message[0] = '\0';
+      ms_error->errorcount = 0;
+    }
+    ms_error->totalerrorcount++;
+  }
+
+  return ms_error;
+}
+
+/* msResetErrorList()
+**
+** Clear the list of error objects.
+*/
+void msResetErrorList() {
+  errorObj *ms_error, *this_error;
+  ms_error = msGetErrorObj();
+
+  this_error = ms_error->next;
+  while (this_error != NULL) {
+    errorObj *next_error;
+
+    next_error = this_error->next;
+    msFree(this_error);
+    this_error = next_error;
+  }
+
+  ms_error->next = NULL;
+  ms_error->code = MS_NOERR;
+  ms_error->isreported = MS_FALSE;
+  ms_error->routine[0] = '\0';
+  ms_error->message[0] = '\0';
+  ms_error->errorcount = 0;
+  ms_error->totalerrorcount = 0;
+
+  /* -------------------------------------------------------------------- */
+  /*      Cleanup our entry in the thread list.  This is mainly           */
+  /*      imprortant when msCleanup() calls msResetErrorList().           */
+  /* -------------------------------------------------------------------- */
+#ifdef USE_THREAD
+  {
+    void *thread_id = msGetThreadId();
+    te_info_t *link;
+
+    msAcquireLock(TLOCK_ERROROBJ);
+
+    /* find link for this thread */
+
+    for (link = error_list;
+         link != NULL && link->thread_id != thread_id && link->next != NULL &&
+         link->next->thread_id != thread_id;
+         link = link->next) {
+    }
+
+    if (link->thread_id == thread_id) {
+      /* presumably link is at head of list.  */
+      if (error_list == link)
+        error_list = link->next;
+
+      free(link);
+    } else if (link->next != NULL && link->next->thread_id == thread_id) {
+      te_info_t *next_link = link->next;
+      link->next = link->next->next;
+      free(next_link);
+    }
+    msReleaseLock(TLOCK_ERROROBJ);
+  }
+#endif
+}
+
+char *msGetErrorCodeString(int code) {
+
+  if (code < 0 || code > MS_NUMERRORCODES - 1)
+    return ("Invalid error code.");
+
+  return (ms_errorCodes[code]);
+}
+
+/* -------------------------------------------------------------------- */
+/*      Adding the displayable error string to a given string           */
+/*      and reallocates the memory enough to hold the characters.       */
+/*      If source is null returns a newly allocated string              */
+/* -------------------------------------------------------------------- */
+char *msAddErrorDisplayString(char *source, errorObj *error) {
+  if ((source = msStringConcatenate(source, error->routine)) == NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, ": ")) == NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, ms_errorCodes[error->code])) ==
+      NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, " ")) == NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, error->message)) == NULL)
+    return (NULL);
+  if (error->errorcount > 0) {
+    char *pszTmp;
+    if ((source = msStringConcatenate(source, " (message repeated ")) == NULL)
+      return (NULL);
+    pszTmp = msIntToString(error->errorcount);
+    if ((source = msStringConcatenate(source, pszTmp)) == NULL) {
+      msFree(pszTmp);
+      return (NULL);
+    }
+    msFree(pszTmp);
+    if ((source = msStringConcatenate(source, " times)")) == NULL)
+      return (NULL);
+  }
+
+  return source;
+}
+
+char *msGetErrorString(const char *delimiter) {
+  char *errstr = NULL;
+
+  errorObj *error = msGetErrorObj();
+
+  if (!delimiter || !error)
+    return (NULL);
+
+  while (error && error->code != MS_NOERR) {
+    if ((errstr = msAddErrorDisplayString(errstr, error)) == NULL)
+      return (NULL);
+
+    if (error->next &&
+        error->next->code !=
+            MS_NOERR) { /* (peek ahead) more errors, use delimiter */
+      if ((errstr = msStringConcatenate(errstr, delimiter)) == NULL)
+        return (NULL);
+    }
+    error = error->next;
+  }
+
+  return (errstr);
+}
+
+static void msRedactString(char *str, const char *keyword) {
+
+  char *password = strstr(str, keyword);
+  if (password != NULL) {
+    const char chOptionDelimeter = password - str > 0 ? password[-1] : 0;
+    char *ptr = password + strlen(keyword);
+    char chStringSep = *ptr;
+    if (chStringSep == '\'' || chStringSep == '"') {
+      ++ptr;
+    } else if (chOptionDelimeter == ';' && chStringSep == '{' &&
+               strcmp(keyword, "pwd=") == 0) {
+      // Handle cases like "\\SQL2019;DATABASE=msautotest;Driver={ODBC Driver 17
+      // for SQL Server};pwd={Password;12!};uid=sa;"
+      ++ptr;
+      chStringSep = '}';
+    } else {
+      chStringSep = '\0';
+    }
+    /* Replace all characters from after equal sign to end of line, end of
+     * string, or end of quoted string.
+     */
+    char *ptr_first_redacted_char = NULL;
+    while (*ptr != '\0' && *ptr != '\r' && *ptr != '\n') {
+      if (chStringSep == '\0') {
+        if (*ptr == chOptionDelimeter)
+          break;
+      } else {
+        if (*ptr == chStringSep) {
+          break;
+        }
+        if (*ptr == '\\' && ptr[1] == chStringSep) {
+          ptr++;
+        }
+      }
+      if (!ptr_first_redacted_char) {
+        ptr_first_redacted_char = ptr;
+        *ptr = '*';
+      }
+      ptr++;
+    }
+    if (ptr_first_redacted_char) {
+      memmove(ptr_first_redacted_char + 1, ptr, strlen(ptr) + 1);
+    }
+  }
+}
+
+void msRedactCredentials(char *str) {
+
+  // postgres or mssql formats
+  msRedactString(str, "password=");
+  // ODBC connections can use pwd rather than password
+  msRedactString(str, "pwd=");
+}
+
+void msSetError(int code, const char *message_fmt, const char *routine, ...) {
+  errorObj *ms_error;
+  va_list args;
+  char message[MESSAGELENGTH];
+
+  if (!message_fmt)
+    strcpy(message, "");
+  else {
+    va_start(args, routine);
+    vsnprintf(message, MESSAGELENGTH, message_fmt, args);
+    va_end(args);
+  }
+
+  ms_error = msGetErrorObj();
+
+  /* Insert the error to the list if it is not the same as the previous error*/
+  if (ms_error->code != code || !EQUAL(message, ms_error->message) ||
+      !EQUAL(routine, ms_error->routine)) {
+    ms_error = msInsertErrorObj();
+    if (!routine)
+      strcpy(ms_error->routine, "");
+    else {
+      strlcpy(ms_error->routine, routine, sizeof(ms_error->routine));
+    }
+    strlcpy(ms_error->message, message, sizeof(ms_error->message));
+    ms_error->code = code;
+    ms_error->errorcount = 0;
+  } else
+    ++ms_error->errorcount;
+
+  msRedactCredentials(ms_error->message);
+
+  /* Log a copy of errors to MS_ERRORFILE if set (handled automatically inside
+   * msDebug()) */
+  msDebug("%s: %s %s\n", ms_error->routine, ms_errorCodes[ms_error->code],
+          ms_error->message);
+}
+
+void msWriteError(FILE *stream) {
+  errorObj *ms_error = msGetErrorObj();
+
+  while (ms_error && ms_error->code != MS_NOERR) {
+    msIO_fprintf(stream, "%s: %s %s <br>\n", ms_error->routine,
+                 ms_errorCodes[ms_error->code], ms_error->message);
+    ms_error->isreported = MS_TRUE;
+    ms_error = ms_error->next;
+  }
+}
+
+void msWriteErrorXML(FILE *stream) {
+  char *message;
+  errorObj *ms_error = msGetErrorObj();
+
+  while (ms_error && ms_error->code != MS_NOERR) {
+    message = msEncodeHTMLEntities(ms_error->message);
+
+    msIO_fprintf(stream, "%s: %s %s\n", ms_error->routine,
+                 ms_errorCodes[ms_error->code], message);
+    ms_error->isreported = MS_TRUE;
+    ms_error = ms_error->next;
+
+    msFree(message);
+  }
+}
+
+void msWriteErrorImage(mapObj *map, char *filename, int blank) {
+  imageObj *img;
+  int width = 400, height = 300;
+  const int nMargin = 5;
+
+  char **papszLines = NULL;
+  pointObj pnt = {0};
+  outputFormatObj *format = NULL;
+  char *errormsg = msGetErrorString("; ");
+  errorObj *error = msGetErrorObj();
+  char *imagepath = NULL, *imageurl = NULL;
+  colorObj imagecolor, *imagecolorptr = NULL;
+  textSymbolObj ts;
+  labelObj label;
+  int charWidth = 5,
+      charHeight = 8; /* hardcoded, should be looked up from ft face */
+  if (!errormsg) {
+    errormsg = msStrdup("No error found sorry. This is likely a bug");
+  }
+
+  if (map) {
+    if (map->width > 0 && map->height > 0) {
+      width = map->width;
+      height = map->height;
+    }
+    format = map->outputformat;
+    imagepath = map->web.imagepath;
+    imageurl = map->web.imageurl;
+  }
+
+  /* Default to GIF if no suitable GD output format set */
+  if (format == NULL || !MS_RENDERER_PLUGIN(format))
+    format = msCreateDefaultOutputFormat(NULL, "AGG/PNG8", "png", NULL);
+
+  if (!format->transparent) {
+    if (map && MS_VALID_COLOR(map->imagecolor)) {
+      imagecolorptr = &map->imagecolor;
+    } else {
+      MS_INIT_COLOR(imagecolor, 255, 255, 255, 255);
+      imagecolorptr = &imagecolor;
+    }
+  }
+
+  img = msImageCreate(width, height, format, imagepath, imageurl,
+                      MS_DEFAULT_RESOLUTION, MS_DEFAULT_RESOLUTION,
+                      imagecolorptr);
+
+  const int nTextLength = strlen(errormsg);
+  const int nWidthTxt = nTextLength * charWidth;
+  const int nUsableWidth = width - (nMargin * 2);
+
+  /* Check to see if it all fits on one line. If not, split the text on several
+   * lines. */
+  if (!blank) {
+    int nLines;
+    if (nWidthTxt > nUsableWidth) {
+      const int nMaxCharsPerLine = nUsableWidth / charWidth;
+      nLines = (int)ceil((double)nTextLength / (double)nMaxCharsPerLine);
+      if (nLines > 0) {
+        papszLines = (char **)malloc(nLines * sizeof(char *));
+        for (int i = 0; i < nLines; i++) {
+          papszLines[i] = (char *)malloc((nMaxCharsPerLine + 1) * sizeof(char));
+          papszLines[i][0] = '\0';
+        }
+      }
+      for (int i = 0; i < nLines; i++) {
+        const int nStart = i * nMaxCharsPerLine;
+        int nEnd = nStart + nMaxCharsPerLine;
+        if (nStart < nTextLength) {
+          if (nEnd > nTextLength)
+            nEnd = nTextLength;
+          const int nLength = nEnd - nStart;
+
+          strncpy(papszLines[i], errormsg + nStart, nLength);
+          papszLines[i][nLength] = '\0';
+        }
+      }
+    } else {
+      nLines = 1;
+      papszLines = (char **)malloc(nLines * sizeof(char *));
+      papszLines[0] = msStrdup(errormsg);
+    }
+    initLabel(&label);
+    MS_INIT_COLOR(label.color, 0, 0, 0, 255);
+    MS_INIT_COLOR(label.outlinecolor, 255, 255, 255, 255);
+    label.outlinewidth = 1;
+
+    label.size = MS_SMALL;
+    MS_REFCNT_INCR((&label));
+    for (int i = 0; i < nLines; i++) {
+      pnt.y = charHeight * ((i * 2) + 1);
+      pnt.x = charWidth;
+      initTextSymbol(&ts);
+      msPopulateTextSymbolForLabelAndString(&ts, &label, papszLines[i], 1, 1,
+                                            0);
+      if (MS_LIKELY(MS_SUCCESS == msComputeTextPath(map, &ts))) {
+        if (MS_SUCCESS != msDrawTextSymbol(NULL, img, pnt, &ts)) {
+          /* an error occured, but there's nothing much we can do about it here
+           * as we are already handling an error condition */
+        }
+        freeTextSymbol(&ts);
+      }
+    }
+    if (papszLines) {
+      free(papszLines);
+    }
+  }
+
+  /* actually write the image */
+  if (!filename) {
+    msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(format));
+    msIO_sendHeaders();
+  }
+  msSaveImage(NULL, img, filename);
+  msFreeImage(img);
+
+  /* the errors are reported */
+  while (error && error->code != MS_NOERR) {
+    error->isreported = MS_TRUE;
+    error = error->next;
+  }
+
+  if (format->refcount == 0)
+    msFreeOutputFormat(format);
+  msFree(errormsg);
+}
+
+char *msGetVersion() {
+  static char version[2048];
+
+  sprintf(version, "MapServer version %s", MS_VERSION);
+
+  // add versions of required dependencies
+  static char PROJVersion[20];
+  sprintf(PROJVersion, " PROJ version %d.%d", PROJ_VERSION_MAJOR,
+          PROJ_VERSION_MINOR);
+  strcat(version, PROJVersion);
+
+  static char GDALVersion[20];
+  sprintf(GDALVersion, " GDAL version %d.%d", GDAL_VERSION_MAJOR,
+          GDAL_VERSION_MINOR);
+  strcat(version, GDALVersion);
+
+#if (defined USE_PNG)
+  strcat(version, " OUTPUT=PNG");
+#endif
+#if (defined USE_JPEG)
+  strcat(version, " OUTPUT=JPEG");
+#endif
+#ifdef USE_KML
+  strcat(version, " OUTPUT=KML");
+#endif
+  strcat(version, " SUPPORTS=PROJ");
+  strcat(version, " SUPPORTS=AGG");
+  strcat(version, " SUPPORTS=FREETYPE");
+#ifdef USE_CAIRO
+  strcat(version, " SUPPORTS=CAIRO");
+#endif
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+  strcat(version, " SUPPORTS=SVG_SYMBOLS");
+#ifdef USE_SVG_CAIRO
+  strcat(version, " SUPPORTS=SVGCAIRO");
+#else
+  strcat(version, " SUPPORTS=RSVG");
+#endif
+#endif
+#ifdef USE_OGL
+  strcat(version, " SUPPORTS=OPENGL");
+#endif
+#ifdef USE_ICONV
+  strcat(version, " SUPPORTS=ICONV");
+#endif
+#ifdef USE_EXEMPI
+  strcat(version, " SUPPORTS=XMP");
+#endif
+#ifdef USE_FRIBIDI
+  strcat(version, " SUPPORTS=FRIBIDI");
+#endif
+#ifdef USE_WMS_SVR
+  strcat(version, " SUPPORTS=WMS_SERVER");
+#endif
+#ifdef USE_WMS_LYR
+  strcat(version, " SUPPORTS=WMS_CLIENT");
+#endif
+#ifdef USE_WFS_SVR
+  strcat(version, " SUPPORTS=WFS_SERVER");
+#endif
+#ifdef USE_WFS_LYR
+  strcat(version, " SUPPORTS=WFS_CLIENT");
+#endif
+#ifdef USE_WCS_SVR
+  strcat(version, " SUPPORTS=WCS_SERVER");
+#endif
+#ifdef USE_SOS_SVR
+  strcat(version, " SUPPORTS=SOS_SERVER");
+#endif
+#ifdef USE_OGCAPI_SVR
+  strcat(version, " SUPPORTS=OGCAPI_SERVER");
+#endif
+#ifdef USE_FASTCGI
+  strcat(version, " SUPPORTS=FASTCGI");
+#endif
+#ifdef USE_THREAD
+  strcat(version, " SUPPORTS=THREADS");
+#endif
+#ifdef USE_GEOS
+  strcat(version, " SUPPORTS=GEOS");
+#endif
+#ifdef USE_V8_MAPSCRIPT
+  strcat(version, " SUPPORTS=V8");
+#endif
+#ifdef USE_PBF
+  strcat(version, " SUPPORTS=PBF");
+#endif
+#ifdef USE_JPEG
+  strcat(version, " INPUT=JPEG");
+#endif
+#ifdef USE_SDE
+  strcat(version, " INPUT=SDE");
+#endif
+#ifdef USE_POSTGIS
+  strcat(version, " INPUT=POSTGIS");
+#endif
+#ifdef USE_ORACLESPATIAL
+  strcat(version, " INPUT=ORACLESPATIAL");
+#endif
+  strcat(version, " INPUT=OGR");
+  strcat(version, " INPUT=GDAL");
+  strcat(version, " INPUT=SHAPEFILE");
+  strcat(version, " INPUT=FLATGEOBUF");
+  return (version);
+}
+
+int msGetVersionInt() { return MS_VERSION_NUM; }
diff -pruN 8.0.1-5/src/maperror.h 8.2.0~beta1-1~exp1/src/maperror.h
--- 8.0.1-5/src/maperror.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maperror.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,228 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Declarations for Error and Debug functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPERROR_H
+#define MAPERROR_H
+
+#include "mapthread.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*====================================================================
+ *   maperror.c
+ *====================================================================*/
+
+#define MS_NOERR 0 /* general error codes */
+#define MS_IOERR 1
+#define MS_MEMERR 2
+#define MS_TYPEERR 3
+#define MS_SYMERR 4
+#define MS_REGEXERR 5
+#define MS_TTFERR 6
+#define MS_DBFERR 7
+#define MS_IDENTERR 9
+#define MS_EOFERR 10
+#define MS_PROJERR 11
+#define MS_MISCERR 12
+#define MS_CGIERR 13
+#define MS_WEBERR 14
+#define MS_IMGERR 15
+#define MS_HASHERR 16
+#define MS_JOINERR 17
+#define MS_NOTFOUND 18 /* empty search results */
+#define MS_SHPERR 19
+#define MS_PARSEERR 20
+#define MS_UNUSEDERR 21
+#define MS_OGRERR 22
+#define MS_QUERYERR 23
+#define MS_WMSERR 24     /* WMS server error */
+#define MS_WMSCONNERR 25 /* WMS connectiontype error */
+#define MS_ORACLESPATIALERR 26
+#define MS_WFSERR 27        /* WFS server error */
+#define MS_WFSCONNERR 28    /* WFS connectiontype error */
+#define MS_MAPCONTEXTERR 29 /* Map Context error */
+#define MS_HTTPERR 30
+#define MS_CHILDERR 31 /* Errors involving arrays of child objects */
+#define MS_WCSERR 32
+#define MS_GEOSERR 33
+#define MS_RECTERR 34
+#define MS_TIMEERR 35
+#define MS_GMLERR 36
+#define MS_SOSERR 37
+#define MS_NULLPARENTERR 38
+#define MS_AGGERR 39
+#define MS_OWSERR 40
+#define MS_OGLERR 41
+#define MS_RENDERERERR 42
+#define MS_V8ERR 43
+#define MS_OGCAPIERR 44
+#define MS_FGBERR 45
+/* NOTE to developers: if adding a new constant, increment MS_NUMERRORCODES and
+ * add a new string in ms_errorCodes[] */
+#define MS_NUMERRORCODES 46
+
+#define MESSAGELENGTH 2048
+#define ROUTINELENGTH 64
+
+#define MS_ERROR_LANGUAGE "en-US"
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#define MS_DLL_EXPORT __declspec(dllexport)
+#else
+#define MS_DLL_EXPORT
+#endif
+
+#ifndef MS_PRINT_FUNC_FORMAT
+#if defined(__GNUC__) && __GNUC__ >= 3 && !defined(DOXYGEN_SKIP)
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)                              \
+  __attribute__((__format__(__printf__, format_idx, arg_idx)))
+#else
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)
+#endif
+#endif
+
+/**
+This class allows inspection of the MapServer error stack.
+Instances of errorObj are created internally by MapServer as errors happen.
+Errors are managed as a chained list with the first item being the most recent
+error.
+*/
+typedef struct errorObj {
+  int code; ///< MapServer error code such as :data:`MS_IMGERR`
+  char
+      routine[ROUTINELENGTH]; ///< MapServer function in which the error was set
+  char message[MESSAGELENGTH]; ///< Context-dependent error message
+  int isreported; ///< :data:`MS_TRUE` or :data:`MS_FALSE` flag indicating if
+                  ///< the error has been output
+  int errorcount; ///< Number of subsequent errors
+#ifndef SWIG
+  struct errorObj *next;
+  int totalerrorcount;
+#endif
+} errorObj;
+
+/*
+** Function prototypes
+*/
+
+/**
+Get the MapServer error object
+*/
+MS_DLL_EXPORT errorObj *msGetErrorObj(void);
+/**
+Clear the list of error objects
+*/
+MS_DLL_EXPORT void msResetErrorList(void);
+/**
+Returns a string containing MapServer version information, and details on what
+optional components are built in - the same report as produced by ``mapserv -v``
+*/
+MS_DLL_EXPORT char *msGetVersion(void);
+/**
+Returns the MapServer version number (x.y.z) as an integer (x*10000 + y*100 + z)
+e.g. V7.4.2 would return 70402
+*/
+MS_DLL_EXPORT int msGetVersionInt(void);
+/**
+Return a string of all errors
+*/
+MS_DLL_EXPORT char *msGetErrorString(const char *delimiter);
+
+#ifndef SWIG
+MS_DLL_EXPORT void msRedactCredentials(char *str);
+MS_DLL_EXPORT void msSetError(int code, const char *message,
+                              const char *routine, ...)
+    MS_PRINT_FUNC_FORMAT(2, 4);
+MS_DLL_EXPORT void msWriteError(FILE *stream);
+MS_DLL_EXPORT void msWriteErrorXML(FILE *stream);
+MS_DLL_EXPORT char *msGetErrorCodeString(int code);
+MS_DLL_EXPORT char *msAddErrorDisplayString(char *source, errorObj *error);
+
+struct mapObj;
+MS_DLL_EXPORT void msWriteErrorImage(struct mapObj *map, char *filename,
+                                     int blank);
+
+#endif /* SWIG */
+
+/*====================================================================
+ *   mapdebug.c (See also MS-RFC-28)
+ *====================================================================*/
+
+typedef enum {
+  MS_DEBUGLEVEL_ERRORSONLY = 0, /* DEBUG OFF, log fatal errors */
+  MS_DEBUGLEVEL_DEBUG = 1,      /* DEBUG ON */
+  MS_DEBUGLEVEL_TUNING = 2,     /* Reports timing info */
+  MS_DEBUGLEVEL_V = 3,          /* Verbose */
+  MS_DEBUGLEVEL_VV = 4,         /* Very verbose */
+  MS_DEBUGLEVEL_VVV = 5,        /* Very very verbose */
+  MS_DEBUGLEVEL_DEVDEBUG = 20, /* Undocumented, will trigger debug messages only
+                                  useful for developers */
+} debugLevel;
+
+#ifndef SWIG
+
+typedef enum {
+  MS_DEBUGMODE_OFF,
+  MS_DEBUGMODE_FILE,
+  MS_DEBUGMODE_STDERR,
+  MS_DEBUGMODE_STDOUT,
+  MS_DEBUGMODE_WINDOWSDEBUG
+} debugMode;
+
+typedef struct debug_info_obj {
+  debugLevel global_debug_level;
+  debugMode debug_mode;
+  char *errorfile;
+  FILE *fp;
+  /* The following 2 members are used only with USE_THREAD (but we won't #ifndef
+   * them) */
+  void *thread_id;
+  struct debug_info_obj *next;
+} debugInfoObj;
+
+MS_DLL_EXPORT void msDebug(const char *pszFormat, ...)
+    MS_PRINT_FUNC_FORMAT(1, 2);
+MS_DLL_EXPORT int msSetErrorFile(const char *pszErrorFile,
+                                 const char *pszRelToPath);
+MS_DLL_EXPORT void msCloseErrorFile(void);
+MS_DLL_EXPORT const char *msGetErrorFile(void);
+MS_DLL_EXPORT void msSetGlobalDebugLevel(int level);
+MS_DLL_EXPORT debugLevel msGetGlobalDebugLevel(void);
+MS_DLL_EXPORT int msDebugInitFromEnv(void);
+MS_DLL_EXPORT void msDebugCleanup(void);
+
+#endif /* SWIG */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPERROR_H */
diff -pruN 8.0.1-5/src/mapfile.c 8.2.0~beta1-1~exp1/src/mapfile.c
--- 8.0.1-5/src/mapfile.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapfile.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,7609 @@
+/******************************************************************************
+ * $id: mapfile.c 7854 2008-08-14 19:22:48Z dmorissette $
+ *
+ * Project:  MapServer
+ * Purpose:  High level Map file parsing code.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+
+#include <stdarg.h>
+#include <stdbool.h>
+#include <assert.h>
+#include <ctype.h>
+#include <float.h>
+
+#include "mapserver.h"
+#include "mapfile.h"
+#include "mapthread.h"
+#include "maptime.h"
+#include "mapogcsld.h"
+
+#include "cpl_conv.h"
+#include "cpl_port.h"
+
+extern int msyylex(void);
+extern void msyyrestart(FILE *);
+extern int msyylex_destroy(void);
+extern void msyycleanup_includes();
+
+extern double msyynumber;
+extern int msyylineno;
+extern FILE *msyyin;
+
+extern int msyysource;
+extern int msyystate;
+extern const char *msyystring;
+extern char *msyybasepath;
+extern int msyyreturncomments;
+extern char *msyystring_buffer;
+extern int msyystring_icase;
+
+extern int loadSymbol(symbolObj *s, char *symbolpath); /* in mapsymbol.c */
+extern void writeSymbol(symbolObj *s, FILE *stream);   /* in mapsymbol.c */
+static int loadGrid(layerObj *pLayer);
+static int loadStyle(styleObj *style);
+static void writeStyle(FILE *stream, int indent, styleObj *style);
+static int resolveSymbolNames(mapObj *map);
+static int loadExpression(expressionObj *exp);
+static void writeExpression(FILE *stream, int indent, const char *name,
+                            expressionObj *exp);
+
+/*
+** Symbol to string static arrays needed for writing map files.
+** Must be kept in sync with enumerations and defines found in mapserver.h.
+*/
+/* static char *msUnits[9]={"INCHES", "FEET", "MILES", "METERS", "KILOMETERS",
+ * "DD", "PIXELS", "PERCENTAGES", "NAUTICALMILES"}; */
+/* static char *msLayerTypes[10]={"POINT", "LINE", "POLYGON", "RASTER",
+ * "ANNOTATION", "QUERY", "CIRCLE", "TILEINDEX","CHART"}; */
+char *msPositionsText[MS_POSITIONS_LENGTH] = {
+    "UL", "LR", "UR",   "LL", "CR",    "CL", "UC",
+    "LC", "CC", "AUTO", "XY", "FOLLOW"}; /* msLabelPositions[] also used in
+                                            mapsymbols.c (not static) */
+/* static char *msBitmapFontSizes[5]={"TINY", "SMALL", "MEDIUM", "LARGE",
+ * "GIANT"}; */
+/* static char *msQueryMapStyles[4]={"NORMAL", "HILITE", "SELECTED",
+ * "INVERTED"}; */
+/* static char *msStatus[4]={"OFF", "ON", "DEFAULT", "EMBED"}; */
+/* static char *msOnOff[2]={"OFF", "ON"}; */
+/* static char *msTrueFalse[2]={"FALSE", "TRUE"}; */
+/* static char *msYesNo[2]={"NO", "YES"}; */
+/* static char *msJoinType[2]={"ONE-TO-ONE", "ONE-TO-MANY"}; */
+/* static char *msAlignValue[3]={"LEFT","CENTER","RIGHT"}; */
+
+/*
+** Validates a string (value) against a series of patterns. We support up to
+*four to allow cascading from classObj to
+** layerObj to webObj plus a legacy pattern like TEMPLATEPATTERN.
+*/
+int msValidateParameter(const char *value, const char *pattern1,
+                        const char *pattern2, const char *pattern3,
+                        const char *pattern4) {
+  if (msEvalRegex(pattern1, value) == MS_TRUE)
+    return MS_SUCCESS;
+  if (msEvalRegex(pattern2, value) == MS_TRUE)
+    return MS_SUCCESS;
+  if (msEvalRegex(pattern3, value) == MS_TRUE)
+    return MS_SUCCESS;
+  if (msEvalRegex(pattern4, value) == MS_TRUE)
+    return MS_SUCCESS;
+
+  return (MS_FAILURE);
+}
+
+int msIsValidRegex(const char *e) {
+  ms_regex_t re;
+  if (ms_regcomp(&re, e, MS_REG_EXTENDED | MS_REG_NOSUB) != 0) {
+    msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+               "msEvalRegex()", e);
+    return (MS_FALSE);
+  }
+  ms_regfree(&re);
+  return MS_TRUE;
+}
+
+int msEvalRegex(const char *e, const char *s) {
+  ms_regex_t re;
+
+  if (!e || !s)
+    return (MS_FALSE);
+
+  if (ms_regcomp(&re, e, MS_REG_EXTENDED | MS_REG_NOSUB) != 0) {
+    msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+               "msEvalRegex()", e);
+    return (MS_FALSE);
+  }
+
+  if (ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
+    ms_regfree(&re);
+    return (MS_FALSE);
+  }
+  ms_regfree(&re);
+
+  return (MS_TRUE);
+}
+
+int msCaseEvalRegex(const char *e, const char *s) {
+  ms_regex_t re;
+
+  if (!e || !s)
+    return (MS_FALSE);
+
+  if (ms_regcomp(&re, e, MS_REG_EXTENDED | MS_REG_ICASE | MS_REG_NOSUB) != 0) {
+    msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+               "msEvalRegex()", e);
+    return (MS_FALSE);
+  }
+
+  if (ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
+    ms_regfree(&re);
+    return (MS_FALSE);
+  }
+  ms_regfree(&re);
+
+  return (MS_TRUE);
+}
+
+#ifdef USE_MSFREE
+void msFree(void *p) {
+  if (p)
+    free(p);
+}
+#endif
+
+/*
+** Free memory allocated for a character array
+*/
+void msFreeCharArray(char **array, int num_items) {
+  int i;
+  if (!array)
+    return;
+  for (i = 0; i < num_items; i++)
+    msFree(array[i]);
+  msFree(array);
+}
+
+/*
+** Checks symbol from lexer against variable length list of
+** legal symbols.
+*/
+int getSymbol(int n, ...) {
+  int symbol;
+  va_list argp;
+  int i = 0;
+
+  symbol = msyylex();
+
+  va_start(argp, n);
+  while (i < n) { /* check each symbol in the list */
+    if (symbol == va_arg(argp, int)) {
+      va_end(argp);
+      return (symbol);
+    }
+    i++;
+  }
+
+  va_end(argp);
+
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getSymbol()",
+             msyystring_buffer, msyylineno);
+  return (-1);
+}
+
+/*
+** Same as getSymbol, except no error message is set on failure
+*/
+int getSymbol2(int n, ...) {
+  int symbol;
+  va_list argp;
+  int i = 0;
+
+  symbol = msyylex();
+
+  va_start(argp, n);
+  while (i < n) { /* check each symbol in the list */
+    if (symbol == va_arg(argp, int)) {
+      va_end(argp);
+      return (symbol);
+    }
+    i++;
+  }
+
+  va_end(argp);
+  return (-1);
+}
+
+/*
+** Get a string or symbol as a string.   Operates like getString(), but also
+** supports symbols.
+*/
+static char *getToken(void) {
+  msyylex();
+  return msStrdup(msyystring_buffer);
+}
+
+/*
+** Load a string from the map file. A "string" is defined in lexer.l.
+*/
+int getString(char **s) {
+  /* if (*s)
+    msSetError(MS_SYMERR, "Duplicate item (%s):(line %d)", "getString()",
+  msyystring_buffer, msyylineno); return(MS_FAILURE); } else */
+  if (msyylex() == MS_STRING) {
+    if (*s)
+      free(*s); /* avoid leak */
+    *s = msStrdup(msyystring_buffer);
+    return (MS_SUCCESS);
+  }
+
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getString()",
+             msyystring_buffer, msyylineno);
+  return (MS_FAILURE);
+}
+
+int msCheckNumber(double number, int num_check_type, double value1,
+                  double value2) {
+  if (num_check_type == MS_NUM_CHECK_NONE) {
+    return MS_SUCCESS;
+  } else if (num_check_type == MS_NUM_CHECK_RANGE && number >= value1 &&
+             number <= value2) {
+    return MS_SUCCESS;
+  } else if (num_check_type == MS_NUM_CHECK_GT && number > value1) {
+    return MS_SUCCESS;
+  } else if (num_check_type == MS_NUM_CHECK_GTE && number >= value1) {
+    return MS_SUCCESS;
+  }
+
+  return MS_FAILURE;
+}
+
+/*
+** Load a floating point number from the map file. (see lexer.l)
+*/
+int getDouble(double *d, int num_check_type, double value1, double value2) {
+  if (msyylex() == MS_NUMBER) {
+    if (msCheckNumber(msyynumber, num_check_type, value1, value2) ==
+        MS_SUCCESS) {
+      *d = msyynumber;
+      return (0);
+    }
+  }
+
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getDouble()",
+             msyystring_buffer, msyylineno);
+  return (-1);
+}
+
+/*
+** Load a integer from the map file. (see lexer.l)
+*/
+int getInteger(int *i, int num_check_type, int value1, int value2) {
+  if (msyylex() == MS_NUMBER) {
+    if (msCheckNumber(msyynumber, num_check_type, value1, value2) ==
+        MS_SUCCESS) {
+      *i = (int)msyynumber;
+      return (0);
+    }
+  }
+
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getInteger()",
+             msyystring_buffer, msyylineno);
+  return (-1);
+}
+
+int getCharacter(char *c) {
+  if (msyylex() == MS_STRING) {
+    *c = msyystring_buffer[0];
+    return (0);
+  }
+
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getCharacter()",
+             msyystring_buffer, msyylineno);
+  return (-1);
+}
+
+/*
+** Try to load as an integer, then try as a named symbol.
+** Part of work on bug 490.
+*/
+int getIntegerOrSymbol(int *i, int n, ...) {
+  int symbol;
+  va_list argp;
+  int j = 0;
+
+  symbol = msyylex();
+
+  if (symbol == MS_NUMBER) {
+    *i = (int)msyynumber;
+    return MS_SUCCESS; /* success */
+  }
+
+  va_start(argp, n);
+  while (j < n) { /* check each symbol in the list */
+    if (symbol == va_arg(argp, int)) {
+      va_end(argp);
+      *i = symbol;
+      return MS_SUCCESS;
+    }
+    j++;
+  }
+  va_end(argp);
+
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)",
+             "getIntegerOrSymbol()", msyystring_buffer, msyylineno);
+  return (-1);
+}
+
+/*
+** msBuildPluginLibraryPath
+**
+** This function builds a path to be used dynamically to load plugin library.
+*/
+int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map) {
+  char szLibPath[MS_MAXPATHLEN] = {'\0'};
+  char szLibPathExt[MS_MAXPATHLEN] = {'\0'};
+  const char *plugin_dir = NULL;
+
+  if (map)
+    plugin_dir = msLookupHashTable(&(map->configoptions), "MS_PLUGIN_DIR");
+
+    /* do nothing on windows, filename without .dll will be loaded by default*/
+#if !defined(_WIN32)
+  if (lib_str) {
+    size_t len = strlen(lib_str);
+    if (3 < len && strcmp(lib_str + len - 3, ".so")) {
+      strlcpy(szLibPathExt, lib_str, MS_MAXPATHLEN);
+      strlcat(szLibPathExt, ".so", MS_MAXPATHLEN);
+      lib_str = szLibPathExt;
+    }
+  }
+#endif /* !defined(_WIN32) */
+  if (NULL == msBuildPath(szLibPath, plugin_dir, lib_str)) {
+    return MS_FAILURE;
+  }
+  msFree(*dest);
+  *dest = msStrdup(szLibPath);
+
+  return MS_SUCCESS;
+}
+
+/*
+** Returns the index of specified symbol or -1 if not found.
+**
+** If try_addimage_if_notfound==MS_TRUE then msAddImageSymbol() will be called
+** to try to allocate the symbol as an image symbol.
+*/
+int msGetSymbolIndex(symbolSetObj *symbols, const char *name,
+                     int try_addimage_if_notfound) {
+  int i;
+
+  if (!symbols || !name)
+    return (-1);
+
+  /* symbol 0 has no name */
+  for (i = 1; i < symbols->numsymbols; i++) {
+    if (symbols->symbol[i]->name)
+      if (strcasecmp(symbols->symbol[i]->name, name) == 0)
+        return (i);
+  }
+
+  if (try_addimage_if_notfound)
+    return (
+        msAddImageSymbol(symbols, name)); /* make sure it's not a filename */
+
+  return (-1);
+}
+
+/*
+** Return the index number for a given layer based on its name.
+*/
+int msGetLayerIndex(mapObj *map, const char *name) {
+  int i;
+
+  if (!name)
+    return (-1);
+
+  for (i = 0; i < map->numlayers; i++) {
+    if (!GET_LAYER(map, i)->name) /* skip it */
+      continue;
+    if (strcmp(name, GET_LAYER(map, i)->name) == 0)
+      return (i);
+  }
+  return (-1);
+}
+
+int loadColor(colorObj *color, attributeBindingObj *binding) {
+  int symbol;
+  char hex[2];
+
+  /*
+  ** Note that negative color values can be used to suppress or change behavior.
+  *For example, referenceObj uses
+  ** a negative color component to suppress rectangle fills.
+  */
+
+  if (binding) {
+    if ((symbol = getSymbol(3, MS_NUMBER, MS_BINDING, MS_STRING)) == -1)
+      return MS_FAILURE;
+  } else {
+    if ((symbol = getSymbol(2, MS_NUMBER, MS_STRING)) == -1)
+      return MS_FAILURE;
+  }
+
+  color->alpha = 255;
+  if (symbol == MS_NUMBER) {
+    if (msyynumber >= -255 && msyynumber <= 255) {
+      color->red = (int)msyynumber;
+    } else {
+      return MS_FAILURE;
+    }
+    if (getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+      return MS_FAILURE;
+    if (getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+      return MS_FAILURE;
+  } else if (symbol == MS_STRING) {
+    int len = strlen(msyystring_buffer);
+    if (msyystring_buffer[0] == '#' &&
+        (len == 7 || len == 9)) { /* got a hex color w/optional alpha */
+      hex[0] = msyystring_buffer[1];
+      hex[1] = msyystring_buffer[2];
+      color->red = msHexToInt(hex);
+      hex[0] = msyystring_buffer[3];
+      hex[1] = msyystring_buffer[4];
+      color->green = msHexToInt(hex);
+      hex[0] = msyystring_buffer[5];
+      hex[1] = msyystring_buffer[6];
+      color->blue = msHexToInt(hex);
+      if (len == 9) {
+        hex[0] = msyystring_buffer[7];
+        hex[1] = msyystring_buffer[8];
+        color->alpha = msHexToInt(hex);
+      }
+    } else {
+      /* TODO: consider named colors here */
+      msSetError(MS_SYMERR, "Invalid hex color (%s):(line %d)", "loadColor()",
+                 msyystring_buffer, msyylineno);
+      return MS_FAILURE;
+    }
+  } else {
+    assert(binding);
+    msFree(binding->item);
+    binding->item = msStrdup(msyystring_buffer);
+    binding->index = -1;
+  }
+
+  return MS_SUCCESS;
+}
+
+#if ALPHACOLOR_ENABLED
+int loadColorWithAlpha(colorObj *color) {
+  char hex[2];
+
+  /*
+  ** Note that negative color values can be used to suppress or change behavior.
+  *For example, referenceObj uses
+  ** a negative color component to suppress rectangle fills.
+  */
+
+  if (getInteger(&(color->red), MS_NUM_CHECK_RANGE, -255, 255) == -1) {
+    if (msyystring_buffer[0] == '#' &&
+        strlen(msyystring_buffer) == 7) { /* got a hex color */
+      hex[0] = msyystring_buffer[1];
+      hex[1] = msyystring_buffer[2];
+      color->red = msHexToInt(hex);
+      hex[0] = msyystring_buffer[3];
+      hex[1] = msyystring_buffer[4];
+      color->green = msHexToInt(hex);
+      hex[0] = msyystring_buffer[5];
+      hex[1] = msyystring_buffer[6];
+      color->blue = msHexToInt(hex);
+      color->alpha = 0;
+
+      return (MS_SUCCESS);
+    } else if (msyystring_buffer[0] == '#' &&
+               strlen(msyystring_buffer) ==
+                   9) { /* got a hex color with alpha */
+      hex[0] = msyystring_buffer[1];
+      hex[1] = msyystring_buffer[2];
+      color->red = msHexToInt(hex);
+      hex[0] = msyystring_buffer[3];
+      hex[1] = msyystring_buffer[4];
+      color->green = msHexToInt(hex);
+      hex[0] = msyystring_buffer[5];
+      hex[1] = msyystring_buffer[6];
+      color->blue = msHexToInt(hex);
+      hex[0] = msyystring_buffer[7];
+      hex[1] = msyystring_buffer[8];
+      color->alpha = msHexToInt(hex);
+      return (MS_SUCCESS);
+    }
+    return (MS_FAILURE);
+  }
+  if (getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+    return (MS_FAILURE);
+  if (getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+    return (MS_FAILURE);
+  if (getInteger(&(color->alpha), MS_NUM_CHECK_RANGE, 0, 255) == -1)
+    return (MS_FAILURE);
+
+  return (MS_SUCCESS);
+}
+#endif
+
+/*
+** Helper functions for writing mapfiles.
+*/
+static void writeLineFeed(FILE *stream) { msIO_fprintf(stream, "\n"); }
+
+static void writeIndent(FILE *stream, int indent) {
+  const char *str = "  "; /* change this string to define the indent */
+  int i;
+  for (i = 0; i < indent; i++)
+    msIO_fprintf(stream, "%s", str);
+}
+
+static void writeBlockBegin(FILE *stream, int indent, const char *name) {
+  writeIndent(stream, indent);
+  msIO_fprintf(stream, "%s\n", name);
+}
+
+static void writeBlockEnd(FILE *stream, int indent, const char *name) {
+  writeIndent(stream, indent);
+  msIO_fprintf(stream, "END # %s\n", name);
+}
+
+static void writeKeyword(FILE *stream, int indent, const char *name, int value,
+                         int size, ...) {
+  va_list argp;
+  int i, j = 0;
+  const char *s;
+
+  va_start(argp, size);
+  while (j < size) { /* check each value/keyword mapping in the list, values
+                        with no match are ignored */
+    i = va_arg(argp, int);
+    s = va_arg(argp, const char *);
+    if (value == i) {
+      writeIndent(stream, ++indent);
+      msIO_fprintf(stream, "%s %s\n", name, s);
+      va_end(argp);
+      return;
+    }
+    j++;
+  }
+  va_end(argp);
+}
+
+static void writeDimension(FILE *stream, int indent, const char *name, double x,
+                           double y, char *bind_x, char *bind_y) {
+  writeIndent(stream, ++indent);
+  if (bind_x)
+    msIO_fprintf(stream, "%s [%s] ", name, bind_x);
+  else
+    msIO_fprintf(stream, "%s %.15g ", name, x);
+  if (bind_y)
+    msIO_fprintf(stream, "[%s]\n", bind_y);
+  else
+    msIO_fprintf(stream, "%.15g\n", y);
+}
+
+static void writeDoubleRange(FILE *stream, int indent, const char *name,
+                             double x, double y) {
+  writeIndent(stream, ++indent);
+  msIO_fprintf(stream, "%s %f %f\n", name, x, y);
+}
+
+static void writeExtent(FILE *stream, int indent, const char *name,
+                        rectObj extent) {
+  if (!MS_VALID_EXTENT(extent))
+    return;
+  writeIndent(stream, ++indent);
+  msIO_fprintf(stream, "%s %.15g %.15g %.15g %.15g\n", name, extent.minx,
+               extent.miny, extent.maxx, extent.maxy);
+}
+
+static void writeNumber(FILE *stream, int indent, const char *name,
+                        double defaultNumber, double number) {
+  if (number == defaultNumber)
+    return; /* don't output default */
+  writeIndent(stream, ++indent);
+  msIO_fprintf(stream, "%s %.15g\n", name, number);
+}
+
+static void writeCharacter(FILE *stream, int indent, const char *name,
+                           const char defaultCharacter, char character) {
+  if (defaultCharacter == character)
+    return;
+  writeIndent(stream, ++indent);
+  msIO_fprintf(stream, "%s '%c'\n", name, character);
+}
+
+static void writeStringElement(FILE *stream, char *string) {
+  char *string_escaped;
+
+  if (strchr(string, '\\')) {
+    string_escaped = msStrdup(string);
+    string_escaped = msReplaceSubstring(string_escaped, "\\", "\\\\");
+  } else {
+    string_escaped = string;
+  }
+  if ((strchr(string_escaped, '\'') == NULL) &&
+      (strchr(string_escaped, '\"') == NULL))
+    msIO_fprintf(stream, "\"%s\"", string_escaped);
+  else if ((strchr(string_escaped, '\"') != NULL) &&
+           (strchr(string_escaped, '\'') == NULL))
+    msIO_fprintf(stream, "'%s'", string_escaped);
+  else if ((strchr(string_escaped, '\'') != NULL) &&
+           (strchr(string_escaped, '\"') == NULL))
+    msIO_fprintf(stream, "\"%s\"", string_escaped);
+  else {
+    char *string_tmp = msStringEscape(string_escaped);
+    msIO_fprintf(stream, "\"%s\"", string_tmp);
+    if (string_escaped != string_tmp)
+      free(string_tmp);
+  }
+  if (string_escaped != string)
+    free(string_escaped);
+}
+
+static void writeString(FILE *stream, int indent, const char *name,
+                        const char *defaultString, char *string) {
+  if (!string)
+    return;
+  if (defaultString && strcmp(string, defaultString) == 0)
+    return;
+  writeIndent(stream, ++indent);
+  if (name)
+    msIO_fprintf(stream, "%s ", name);
+  writeStringElement(stream, string);
+  writeLineFeed(stream);
+}
+
+static void writeNumberOrString(FILE *stream, int indent, const char *name,
+                                double defaultNumber, double number,
+                                char *string) {
+  if (string)
+    writeString(stream, indent, name, NULL, string);
+  else
+    writeNumber(stream, indent, name, defaultNumber, number);
+}
+
+static void writeNumberOrKeyword(FILE *stream, int indent, const char *name,
+                                 double defaultNumber, double number, int value,
+                                 int size, ...) {
+  va_list argp;
+  int i, j = 0;
+  const char *s;
+
+  va_start(argp, size);
+  while (j < size) { /* check each value/keyword mapping in the list */
+    i = va_arg(argp, int);
+    s = va_arg(argp, const char *);
+    if (value == i) {
+      writeIndent(stream, ++indent);
+      msIO_fprintf(stream, "%s %s\n", name, s);
+      va_end(argp);
+      return;
+    }
+    j++;
+  }
+  va_end(argp);
+
+  writeNumber(stream, indent, name, defaultNumber, number);
+}
+
+static void writeNameValuePair(FILE *stream, int indent, const char *name,
+                               const char *value) {
+  if (!name || !value)
+    return;
+  writeIndent(stream, ++indent);
+
+  writeStringElement(stream, (char *)name);
+  msIO_fprintf(stream, "\t");
+  writeStringElement(stream, (char *)value);
+  writeLineFeed(stream);
+}
+
+static void writeAttributeBinding(FILE *stream, int indent, const char *name,
+                                  attributeBindingObj *binding) {
+  if (!binding || !binding->item)
+    return;
+  writeIndent(stream, ++indent);
+  msIO_fprintf(stream, "%s [%s]\n", name, binding->item);
+}
+
+static void writeColor(FILE *stream, int indent, const char *name,
+                       colorObj *defaultColor, colorObj *color) {
+  if (!defaultColor && !MS_VALID_COLOR(*color))
+    return;
+  else if (defaultColor && MS_COMPARE_COLOR(*defaultColor, *color))
+    return; /* if defaultColor has the same value than the color, return.*/
+
+  writeIndent(stream, ++indent);
+#if ALPHACOLOR_ENABLED
+  msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green,
+               color->blue, color->alpha);
+#else
+  if (color->alpha != 255) {
+    char buffer[9];
+    sprintf(buffer, "%02x", color->red);
+    sprintf(buffer + 2, "%02x", color->green);
+    sprintf(buffer + 4, "%02x", color->blue);
+    sprintf(buffer + 6, "%02x", color->alpha);
+    *(buffer + 8) = 0;
+    msIO_fprintf(stream, "%s \"#%s\"\n", name, buffer);
+  } else {
+    msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green,
+                 color->blue);
+  }
+#endif
+}
+
+/* todo: deal with alpha's... */
+static void writeColorRange(FILE *stream, int indent, const char *name,
+                            colorObj *mincolor, colorObj *maxcolor) {
+  if (!MS_VALID_COLOR(*mincolor) || !MS_VALID_COLOR(*maxcolor))
+    return;
+  writeIndent(stream, ++indent);
+  msIO_fprintf(stream, "%s %d %d %d  %d %d %d\n", name, mincolor->red,
+               mincolor->green, mincolor->blue, maxcolor->red, maxcolor->green,
+               maxcolor->blue);
+}
+
+/*
+** Initialize, load and free a single join
+*/
+void initJoin(joinObj *join) {
+  join->numitems = 0;
+
+  join->name = NULL; /* unique join name, used for variable substitution */
+
+  join->items = NULL;  /* array to hold item names for the joined table */
+  join->values = NULL; /* arrays of strings to holds one record worth of data */
+
+  join->table = NULL;
+
+  join->joininfo = NULL;
+
+  join->from = NULL; /* join items */
+  join->to = NULL;
+
+  join->header = NULL;
+  join->template = NULL; /* only html type templates are supported */
+  join->footer = NULL;
+
+  join->type = MS_JOIN_ONE_TO_ONE;
+
+  join->connection = NULL;
+  join->connectiontype = MS_DB_XBASE;
+}
+
+void freeJoin(joinObj *join) {
+  msFree(join->name);
+  msFree(join->table);
+  msFree(join->from);
+  msFree(join->to);
+
+  msFree(join->header);
+  msFree(join->template);
+  msFree(join->footer);
+
+  msFreeCharArray(join->items,
+                  join->numitems); /* these may have been free'd elsewhere */
+  msFreeCharArray(join->values, join->numitems);
+  join->numitems = 0;
+
+  msJoinClose(join);
+  msFree(join->connection);
+}
+
+int loadJoin(joinObj *join) {
+  int nTmp;
+  initJoin(join);
+
+  for (;;) {
+    switch (msyylex()) {
+    case (CONNECTION):
+      if (getString(&join->connection) == MS_FAILURE)
+        return (-1);
+      break;
+    case (CONNECTIONTYPE):
+      if ((nTmp = getSymbol(5, MS_DB_XBASE, MS_DB_MYSQL, MS_DB_ORACLE,
+                            MS_DB_POSTGRES, MS_DB_CSV)) == -1)
+        return (-1);
+      join->connectiontype = nTmp;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadJoin()");
+      return (-1);
+    case (END):
+      if ((join->from == NULL) || (join->to == NULL) || (join->table == NULL)) {
+        msSetError(MS_EOFERR,
+                   "Join must define table, name, from and to properties.",
+                   "loadJoin()");
+        return (-1);
+      }
+      if ((join->type == MS_MULTIPLE) &&
+          ((join->template == NULL) || (join->name == NULL))) {
+        msSetError(
+            MS_EOFERR,
+            "One-to-many joins must define template and name properties.",
+            "loadJoin()");
+        return (-1);
+      }
+      return (0);
+    case (FOOTER):
+      if (getString(&join->footer) == MS_FAILURE)
+        return (-1);
+      break;
+    case (FROM):
+      if (getString(&join->from) == MS_FAILURE)
+        return (-1);
+      break;
+    case (HEADER):
+      if (getString(&join->header) == MS_FAILURE)
+        return (-1);
+      break;
+    case (JOIN):
+      break; /* for string loads */
+    case (NAME):
+      if (getString(&join->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TABLE):
+      if (getString(&join->table) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&join->template) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TO):
+      if (getString(&join->to) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TYPE):
+      if ((nTmp = getSymbol(2, MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY)) == -1)
+        return (-1);
+      join->type = nTmp;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadJoin()",
+                 msyystring_buffer, msyylineno);
+      return (-1);
+    }
+  } /* next token */
+}
+
+static void writeScaleToken(FILE *stream, int indent, scaleTokenObj *token) {
+  int i;
+  indent++;
+  writeBlockBegin(stream, indent, "SCALETOKEN");
+  writeString(stream, indent, "NAME", NULL, token->name);
+  indent++;
+  writeBlockBegin(stream, indent, "VALUES");
+  for (i = 0; i < token->n_entries; i++) {
+    char minscale[32];
+    sprintf(minscale, "%g", token->tokens[i].minscale);
+    writeNameValuePair(stream, indent, minscale, token->tokens[i].value);
+  }
+  writeBlockEnd(stream, indent, "VALUES");
+  indent--;
+  writeBlockEnd(stream, indent, "SCALETOKEN");
+}
+
+static void writeJoin(FILE *stream, int indent, joinObj *join) {
+  indent++;
+  writeBlockBegin(stream, indent, "JOIN");
+  writeString(stream, indent, "FOOTER", NULL, join->footer);
+  writeString(stream, indent, "FROM", NULL, join->from);
+  writeString(stream, indent, "HEADER", NULL, join->header);
+  writeString(stream, indent, "NAME", NULL, join->name);
+  writeString(stream, indent, "TABLE", NULL, join->table);
+  writeString(stream, indent, "TEMPLATE", NULL, join->template);
+  writeString(stream, indent, "TO", NULL, join->to);
+  writeKeyword(stream, indent, "CONNECTIONTYPE", join->connectiontype, 3,
+               MS_DB_CSV, "CSV", MS_DB_POSTGRES, "POSTGRESQL", MS_DB_MYSQL,
+               "MYSQL");
+  writeKeyword(stream, indent, "TYPE", join->type, 1, MS_JOIN_ONE_TO_MANY,
+               "ONE-TO-MANY");
+  writeBlockEnd(stream, indent, "JOIN");
+}
+
+/* inserts a feature at the end of the list, can create a new list */
+featureListNodeObjPtr insertFeatureList(featureListNodeObjPtr *list,
+                                        shapeObj *shape) {
+  featureListNodeObjPtr node;
+
+  node = (featureListNodeObjPtr)msSmallMalloc(sizeof(featureListNodeObj));
+
+  msInitShape(&(node->shape));
+  if (msCopyShape(shape, &(node->shape)) == -1) {
+    msFree(node);
+    return (NULL);
+  }
+
+  /* AJS - alans@wunderground.com O(n^2) -> O(n) conversion, keep a pointer to
+   * the end */
+
+  /* set the tailifhead to NULL, since it is only set for the head of the list
+   */
+  node->tailifhead = NULL;
+  node->next = NULL;
+
+  /* if we are at the head of the list, we need to set the list to node, before
+   * pointing tailifhead somewhere  */
+  if (*list == NULL) {
+    *list = node;
+  } else {
+    if ((*list)->tailifhead !=
+        NULL) /* this should never be NULL, but just in case */
+      (*list)->tailifhead->next =
+          node; /* put the node at the end of the list */
+  }
+
+  /* repoint the head of the list to the end  - our new element
+     this causes a loop if we are at the head, be careful not to
+     walk in a loop */
+  (*list)->tailifhead = node;
+
+  return (node); /* a pointer to last object in the list */
+}
+
+void freeFeatureList(featureListNodeObjPtr list) {
+  featureListNodeObjPtr listNext = NULL;
+  while (list != NULL) {
+    listNext = list->next;
+    msFreeShape(&(list->shape));
+    msFree(list);
+    list = listNext;
+  }
+}
+
+/* lineObj = multipointObj */
+static int loadFeaturePoints(lineObj *points) {
+  int ret = -1;
+  int buffer_size = 0;
+
+  points->point = (pointObj *)malloc(sizeof(pointObj) * MS_FEATUREINITSIZE);
+  MS_CHECK_ALLOC(points->point, sizeof(pointObj) * MS_FEATUREINITSIZE,
+                 MS_FAILURE);
+  points->numpoints = 0;
+  buffer_size = MS_FEATUREINITSIZE;
+
+  while (ret < 0) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadFeaturePoints()");
+      ret = MS_FAILURE;
+      break;
+    case (END):
+      ret = MS_SUCCESS;
+      break;
+    case (MS_NUMBER):
+      if (points->numpoints == buffer_size) { /* just add it to the end */
+        pointObj *newPoints = (pointObj *)realloc(
+            points->point,
+            sizeof(pointObj) * (buffer_size + MS_FEATUREINCREMENT));
+        if (newPoints == NULL) {
+          msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                     __FUNCTION__, __FILE__, __LINE__,
+                     (unsigned int)(sizeof(pointObj) *
+                                    (buffer_size + MS_FEATUREINCREMENT)));
+          ret = MS_FAILURE;
+          break;
+        }
+        points->point = newPoints;
+        buffer_size += MS_FEATUREINCREMENT;
+      }
+
+      points->point[points->numpoints].x = atof(msyystring_buffer);
+      if (getDouble(&(points->point[points->numpoints].y), MS_NUM_CHECK_NONE,
+                    -1, -1) == -1) {
+        ret = MS_FAILURE;
+        break;
+      }
+      points->numpoints++;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadFeaturePoints()", msyystring_buffer, msyylineno);
+      ret = MS_FAILURE;
+      break;
+    }
+  }
+
+  if (ret == MS_FAILURE) {
+    msFree(points->point); /* clean up */
+    points->point = NULL;
+    points->numpoints = 0;
+  }
+  return ret;
+}
+
+static int loadFeature(layerObj *player, int type) {
+  int status = MS_SUCCESS;
+  featureListNodeObjPtr *list = &(player->features);
+  multipointObj points = {0, NULL};
+  shapeObj *shape = NULL;
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  MS_CHECK_ALLOC(shape, sizeof(shapeObj), MS_FAILURE);
+
+  msInitShape(shape);
+  shape->type = type;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadFeature()");
+      msFreeShape(shape); /* clean up */
+      msFree(shape);
+      return (MS_FAILURE);
+    case (END):
+      if (player->features != NULL && player->features->tailifhead != NULL)
+        shape->index = player->features->tailifhead->shape.index + 1;
+      else
+        shape->index = 0;
+      if (insertFeatureList(list, shape) == NULL)
+        status = MS_FAILURE;
+
+      msFreeShape(shape); /* clean up */
+      msFree(shape);
+
+      return (status);
+    case (FEATURE):
+      break; /* for string loads */
+    case (POINTS):
+      if (loadFeaturePoints(&points) == MS_FAILURE) {
+        msFreeShape(shape); /* clean up */
+        msFree(shape);
+        return (MS_FAILURE);
+      }
+      status = msAddLine(shape, &points);
+
+      msFree(points.point); /* clean up */
+      points.numpoints = 0;
+
+      if (status == MS_FAILURE) {
+        msFreeShape(shape); /* clean up */
+        msFree(shape);
+        return (MS_FAILURE);
+      }
+      break;
+    case (ITEMS): {
+      char *string = NULL;
+      if (getString(&string) == MS_FAILURE) {
+        msFreeShape(shape); /* clean up */
+        msFree(shape);
+        return (MS_FAILURE);
+      }
+      if (string) {
+        if (shape->values)
+          msFreeCharArray(shape->values, shape->numvalues);
+        shape->values = msStringSplitComplex(string, ";", &shape->numvalues,
+                                             MS_ALLOWEMPTYTOKENS);
+        msFree(string); /* clean up */
+      }
+      break;
+    }
+    case (TEXT):
+      if (getString(&shape->text) == MS_FAILURE) {
+        msFreeShape(shape); /* clean up */
+        msFree(shape);
+        return (MS_FAILURE);
+      }
+      break;
+    case (WKT): {
+      char *string = NULL;
+
+      /* todo, what do we do with multiple WKT property occurances? */
+
+      msFreeShape(shape);
+      msFree(shape);
+      if (getString(&string) == MS_FAILURE)
+        return (MS_FAILURE);
+
+      if ((shape = msShapeFromWKT(string)) == NULL)
+        status = MS_FAILURE;
+
+      msFree(string); /* clean up */
+
+      if (status == MS_FAILURE) {
+        msFreeShape(shape); /* clean up */
+        msFree(shape);
+        return (MS_FAILURE);
+      }
+      break;
+    }
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadfeature()", msyystring_buffer, msyylineno);
+      msFreeShape(shape); /* clean up */
+      msFree(shape);
+      return (MS_FAILURE);
+    }
+  } /* next token */
+}
+
+static void writeFeature(FILE *stream, int indent, shapeObj *feature) {
+  int i, j;
+
+  indent++;
+  writeBlockBegin(stream, indent, "FEATURE");
+
+  indent++;
+  for (i = 0; i < feature->numlines; i++) {
+    writeBlockBegin(stream, indent, "POINTS");
+    for (j = 0; j < feature->line[i].numpoints; j++) {
+      writeIndent(stream, indent);
+      msIO_fprintf(stream, "%.15g %.15g\n", feature->line[i].point[j].x,
+                   feature->line[i].point[j].y);
+    }
+    writeBlockEnd(stream, indent, "POINTS");
+  }
+  indent--;
+
+  if (feature->numvalues) {
+    writeIndent(stream, indent);
+    msIO_fprintf(stream, "ITEMS \"");
+    for (i = 0; i < feature->numvalues; i++) {
+      if (i == 0)
+        msIO_fprintf(stream, "%s", feature->values[i]);
+      else
+        msIO_fprintf(stream, ";%s", feature->values[i]);
+    }
+    msIO_fprintf(stream, "\"\n");
+  }
+
+  writeString(stream, indent, "TEXT", NULL, feature->text);
+  writeBlockEnd(stream, indent, "FEATURE");
+}
+
+void initGrid(graticuleObj *pGraticule) {
+  memset(pGraticule, 0, sizeof(graticuleObj));
+}
+
+void freeGrid(graticuleObj *pGraticule) {
+  msFree(pGraticule->labelformat);
+  msFree(pGraticule->pboundingpoints);
+  msFree(pGraticule->pboundinglines);
+}
+
+static int loadGrid(layerObj *pLayer) {
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadGrid()");
+      return (-1);
+    case (END):
+      return (0);
+    case (GRID):
+      break; /* for string loads */
+    case (LABELFORMAT):
+      if (getString(&(pLayer->grid->labelformat)) == MS_FAILURE) {
+        if (strcasecmp(msyystring_buffer, "DD") ==
+            0) /* DD triggers a symbol to be returned instead of a string so
+                  check for this special case */
+        {
+          msFree(pLayer->grid->labelformat);
+          pLayer->grid->labelformat = msStrdup("DD");
+        } else
+          return (-1);
+      }
+      break;
+    case (MINARCS):
+      if (getDouble(&(pLayer->grid->minarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXARCS):
+      if (getDouble(&(pLayer->grid->maxarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MININTERVAL):
+      if (getDouble(&(pLayer->grid->minincrement), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (MAXINTERVAL):
+      if (getDouble(&(pLayer->grid->maxincrement), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (MINSUBDIVIDE):
+      if (getDouble(&(pLayer->grid->minsubdivides), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (MAXSUBDIVIDE):
+      if (getDouble(&(pLayer->grid->maxsubdivides), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadGrid()",
+                 msyystring_buffer, msyylineno);
+      return (-1);
+    }
+  }
+}
+
+static void writeGrid(FILE *stream, int indent, graticuleObj *pGraticule) {
+  if (!pGraticule)
+    return;
+
+  indent++;
+  writeBlockBegin(stream, indent, "GRID");
+  writeString(stream, indent, "LABELFORMAT", NULL, pGraticule->labelformat);
+  writeNumber(stream, indent, "MAXARCS", 0, pGraticule->maxarcs);
+  writeNumber(stream, indent, "MAXSUBDIVIDE", 0, pGraticule->maxsubdivides);
+  writeNumber(stream, indent, "MAXINTERVAL", 0, pGraticule->maxincrement);
+  writeNumber(stream, indent, "MINARCS", 0, pGraticule->minarcs);
+  writeNumber(stream, indent, "MININTERVAL", 0, pGraticule->minincrement);
+  writeNumber(stream, indent, "MINSUBDIVIDE", 0, pGraticule->minsubdivides);
+  writeBlockEnd(stream, indent, "GRID");
+}
+
+static int loadProjection(projectionObj *p) {
+  p->gt.need_geotransform = MS_FALSE;
+
+  if (p->proj != NULL || p->numargs != 0) {
+    msSetError(MS_MISCERR,
+               "Projection is already initialized. Multiple projection "
+               "definitions are not allowed in this object. (line %d)",
+               "loadProjection()", msyylineno);
+    return (-1);
+  }
+
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadProjection()");
+      return (-1);
+    case (END):
+      if (p->numargs == 1 && strstr(p->args[0], "+") != NULL) {
+        char *one_line_def = p->args[0];
+        int result;
+
+        p->args[0] = NULL;
+        p->numargs = 0;
+        result = msLoadProjectionString(p, one_line_def);
+        free(one_line_def);
+        return result;
+      } else {
+        if (p->numargs != 0)
+          return msProcessProjection(p);
+        else
+          return 0;
+      }
+      break;
+    case (MS_STRING):
+    case (MS_AUTO):
+      if (p->numargs == MS_MAXPROJARGS) {
+        msSetError(MS_MISCERR,
+                   "Parsing error near (%s):(line %d): Too many arguments in "
+                   "projection string",
+                   "loadProjection()", msyystring_buffer, msyylineno);
+        return -1;
+      }
+      p->args[p->numargs] = msStrdup(msyystring_buffer);
+      p->numargs++;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadProjection()", msyystring_buffer, msyylineno);
+      return (-1);
+    }
+  } /* next token */
+}
+
+/************************************************************************/
+/*                     msLoadProjectionStringEPSGLike                   */
+/************************************************************************/
+
+static int msLoadProjectionStringEPSGLike(projectionObj *p, const char *value,
+                                          const char *pszPrefix,
+                                          int bFollowEPSGAxisOrder) {
+  size_t buffer_size = 0;
+  char *init_string = NULL;
+  const char *code;
+  const char *next_sep;
+  size_t prefix_len;
+
+  prefix_len = strlen(pszPrefix);
+  if (strncasecmp(value, pszPrefix, prefix_len) != 0)
+    return -1;
+
+  code = value + prefix_len;
+  next_sep = strchr(code, pszPrefix[prefix_len - 1]);
+  if (next_sep != NULL)
+    code = next_sep + 1;
+
+  buffer_size = 10 + strlen(code) + 1;
+  init_string = (char *)msSmallMalloc(buffer_size);
+
+  /* translate into PROJ.4 format. */
+  snprintf(init_string, buffer_size, "init=epsg:%s", code);
+
+  p->args = (char **)msSmallMalloc(sizeof(char *) * 2);
+  p->args[0] = init_string;
+  p->numargs = 1;
+
+  if (bFollowEPSGAxisOrder && msIsAxisInverted(atoi(code))) {
+    p->args[1] = msStrdup("+epsgaxis=ne");
+    p->numargs = 2;
+  }
+
+  return 0;
+}
+
+/************************************************************************/
+/*                     msLoadProjectionStringCRSLike                    */
+/************************************************************************/
+
+static int msLoadProjectionStringCRSLike(projectionObj *p, const char *value,
+                                         const char *pszPrefix) {
+  char init_string[100];
+  const char *id;
+  const char *next_sep;
+  size_t prefix_len;
+
+  prefix_len = strlen(pszPrefix);
+  if (strncasecmp(value, pszPrefix, prefix_len) != 0)
+    return -1;
+
+  id = value + prefix_len;
+  next_sep = strchr(id, pszPrefix[prefix_len - 1]);
+  if (next_sep != NULL)
+    id = next_sep + 1;
+
+  init_string[0] = '\0';
+
+  if (strcasecmp(id, "84") == 0 || strcasecmp(id, "CRS84") == 0)
+    strncpy(init_string, "init=epsg:4326", sizeof(init_string));
+  else if (strcasecmp(id, "83") == 0 || strcasecmp(id, "CRS83") == 0)
+    strncpy(init_string, "init=epsg:4269", sizeof(init_string));
+  else if (strcasecmp(id, "27") == 0 || strcasecmp(id, "CRS27") == 0)
+    strncpy(init_string, "init=epsg:4267", sizeof(init_string));
+  else {
+    msSetError(MS_PROJERR, "Unrecognised OGC CRS def '%s'.",
+               "msLoadProjectionString()", value);
+    return -1;
+  }
+
+  p->args = (char **)msSmallMalloc(sizeof(char *) * 2);
+  p->args[0] = msStrdup(init_string);
+  p->numargs = 1;
+
+  return 0;
+}
+
+/************************************************************************/
+/*                         msLoadProjectionStringEPSG                   */
+/*                                                                      */
+/*      Checks for EPSG type projection and set the axes for a          */
+/*      certain code ranges.                                            */
+/*      Use for now in WMS 1.3.0 and WFS >= 1.1.0                       */
+/************************************************************************/
+int msLoadProjectionStringEPSG(projectionObj *p, const char *value) {
+  assert(p);
+
+  msFreeProjectionExceptContext(p);
+
+  p->gt.need_geotransform = MS_FALSE;
+#ifdef USE_PROJ_FASTPATHS
+  if (strcasestr(value, "epsg:4326")) {
+    p->wellknownprojection = wkp_lonlat;
+  } else if (strcasestr(value, "epsg:3857")) {
+    p->wellknownprojection = wkp_gmerc;
+  } else {
+    p->wellknownprojection = wkp_none;
+  }
+#endif
+
+  if (msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_TRUE) == 0) {
+    return msProcessProjection(p);
+  }
+
+  return msLoadProjectionString(p, value);
+}
+
+int msLoadProjectionCodeString(projectionObj *p, const char *value) {
+
+  int num_params = 0;
+
+  // exit if init= is already at the start of the string e.g. from
+  // msOGRSpatialRef2ProjectionObj
+  if (strncasecmp(value, "init=", 5) == 0) {
+    return -1;
+  }
+
+  if (!strchr(value, ':')) {
+    return -1;
+  }
+
+  char **papszList = msStringSplit(value, ':', &(num_params));
+
+  if (num_params != 2) {
+    msFreeCharArray(papszList, num_params);
+    return -1;
+  }
+
+  const size_t buffer_size = 5 + strlen(value) + 1;
+  char *init_string = (char *)msSmallMalloc(buffer_size);
+
+  /* translate into PROJ format. */
+  snprintf(init_string, buffer_size, "init=%s:%s", papszList[0], papszList[1]);
+
+  p->args = (char **)msSmallMalloc(sizeof(char *));
+  p->args[0] = init_string;
+  p->numargs = 1;
+
+  msFreeCharArray(papszList, num_params);
+
+  return 0;
+}
+
+int msLoadProjectionString(projectionObj *p, const char *value) {
+  assert(p);
+  p->gt.need_geotransform = MS_FALSE;
+
+  msFreeProjectionExceptContext(p);
+
+  /*
+   * Handle new style definitions, the same as they would be given to
+   * the proj program.
+   * eg.
+   *    "+proj=utm +zone=11 +ellps=WGS84"
+   */
+  if (value[0] == '+') {
+    char *trimmed;
+    int i, i_out = 0;
+
+    trimmed = msStrdup(value + 1);
+    for (i = 1; value[i] != '\0'; i++) {
+      if (!isspace(value[i]))
+        trimmed[i_out++] = value[i];
+    }
+    trimmed[i_out] = '\0';
+
+    p->args = msStringSplit(trimmed, '+', &p->numargs);
+    free(trimmed);
+  } else if (strncasecmp(value, "AUTO:", 5) == 0 ||
+             strncasecmp(value, "AUTO2:", 6) == 0) {
+    /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
+    /* WMS 1.3.0 projection: "AUTO2:auto_crs_id,factor,lon0,lat0"*/
+    /* Keep the projection defn into a single token for writeProjection() */
+    /* to work fine. */
+    p->args = (char **)msSmallMalloc(sizeof(char *));
+    p->args[0] = msStrdup(value);
+    p->numargs = 1;
+  } else if (msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_FALSE) == 0) {
+    /* Assume lon/lat ordering. Use msLoadProjectionStringEPSG() if wanting to
+     * follow EPSG axis */
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "urn:ogc:def:crs:EPSG:", MS_TRUE) == 0) {
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "urn:EPSG:geographicCRS:", MS_TRUE) == 0) {
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "urn:x-ogc:def:crs:EPSG:", MS_TRUE) == 0) {
+    /*this case is to account for OGC CITE tests where x-ogc was used
+      before the ogc name became an official NID. Note also we also account
+      for the fact that a space for the version of the espg is not used with
+      CITE tests. (Syntax used could be urn:ogc:def:objectType:authority:code)*/
+  } else if (msLoadProjectionStringCRSLike(p, value, "urn:ogc:def:crs:OGC:") ==
+             0) {
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "http://www.opengis.net/def/crs/EPSG/", MS_TRUE) ==
+             0) {
+    /* URI projection support */
+  } else if (msLoadProjectionStringCRSLike(
+                 p, value, "http://www.opengis.net/def/crs/OGC/") == 0) {
+    /* Mandatory support for this URI format specified in WFS1.1 (also in 1.0?)
+     */
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "http://www.opengis.net/gml/srs/epsg.xml#",
+                 MS_FALSE) == 0) {
+    /* We assume always lon/lat ordering, as that is what GeoServer does... */
+  } else if (msLoadProjectionStringCRSLike(p, value, "CRS:") == 0) {
+  } else if (msLoadProjectionCodeString(p, value) == 0) {
+    /* allow strings in the form AUTH:XXXX */
+  }
+  /*
+   * Handle old style comma delimited.  eg. "proj=utm,zone=11,ellps=WGS84".
+   */
+  else {
+    p->args = msStringSplit(value, ',', &p->numargs);
+  }
+
+  return msProcessProjection(p);
+}
+
+static void writeProjection(FILE *stream, int indent, projectionObj *p) {
+  int i;
+
+  if (!p || p->numargs <= 0)
+    return;
+  indent++;
+  writeBlockBegin(stream, indent, "PROJECTION");
+  for (i = 0; i < p->numargs; i++)
+    writeString(stream, indent, NULL, NULL, p->args[i]);
+  writeBlockEnd(stream, indent, "PROJECTION");
+}
+
+void initLeader(labelLeaderObj *leader) {
+  leader->gridstep = 5;
+  leader->maxdistance = 0;
+
+  /* Set maxstyles = 0, styles[] will be allocated as needed on first call
+   * to msGrowLabelLeaderStyles()
+   */
+  leader->numstyles = leader->maxstyles = 0;
+  leader->styles = NULL;
+}
+
+/*
+** Initialize, load and free a labelObj structure
+*/
+void initLabel(labelObj *label) {
+  int i;
+
+  MS_REFCNT_INIT(label);
+
+  label->align = MS_ALIGN_DEFAULT;
+  MS_INIT_COLOR(label->color, 0, 0, 0, 255);
+  MS_INIT_COLOR(label->outlinecolor, -1, -1, -1, 255); /* don't use it */
+  label->outlinewidth = 1;
+
+  MS_INIT_COLOR(label->shadowcolor, -1, -1, -1, 255); /* don't use it */
+  label->shadowsizex = label->shadowsizey = 1;
+
+  label->font = NULL;
+  label->size = MS_MEDIUM;
+
+  label->position = MS_CC;
+  label->angle = 0;
+  label->anglemode = MS_NONE;
+  label->minsize = MS_MINFONTSIZE;
+  label->maxsize = MS_MAXFONTSIZE;
+  label->buffer = 0;
+  label->offsetx = label->offsety = 0;
+  label->minscaledenom = -1;
+  label->maxscaledenom = -1;
+  label->minfeaturesize = -1; /* no limit */
+  label->autominfeaturesize = MS_FALSE;
+  label->mindistance = -1;       /* no limit */
+  label->repeatdistance = 0;     /* no repeat */
+  label->maxoverlapangle = 22.5; /* default max overlap angle */
+  label->partials = MS_FALSE;
+  label->wrap = '\0';
+  label->maxlength = 0;
+  label->space_size_10 = 0.0;
+
+  label->encoding = NULL;
+
+  label->force = MS_OFF;
+  label->priority = MS_DEFAULT_LABEL_PRIORITY;
+
+  /* Set maxstyles = 0, styles[] will be allocated as needed on first call
+   * to msGrowLabelStyles()
+   */
+  label->numstyles = label->maxstyles = 0;
+  label->styles = NULL;
+
+  label->numbindings = 0;
+  label->nexprbindings = 0;
+  for (i = 0; i < MS_LABEL_BINDING_LENGTH; i++) {
+    label->bindings[i].item = NULL;
+    label->bindings[i].index = -1;
+    msInitExpression(&(label->exprBindings[i]));
+  }
+
+  msInitExpression(&(label->expression));
+  msInitExpression(&(label->text));
+
+  label->leader = NULL;
+
+  label->sizeunits = MS_INHERIT;
+  label->scalefactor = 1.0;
+
+  return;
+}
+
+int freeLabelLeader(labelLeaderObj *leader) {
+  int i;
+  for (i = 0; i < leader->numstyles; i++) {
+    if (freeStyle(leader->styles[i]) == MS_SUCCESS) {
+      msFree(leader->styles[i]);
+    }
+  }
+  msFree(leader->styles);
+
+  return MS_SUCCESS;
+}
+int freeLabel(labelObj *label) {
+  int i;
+
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(label)) {
+    return MS_FAILURE;
+  }
+
+  msFree(label->font);
+  msFree(label->encoding);
+
+  for (i = 0; i < label->numstyles; i++) { /* each style */
+    if (label->styles[i] != NULL) {
+      if (freeStyle(label->styles[i]) == MS_SUCCESS) {
+        msFree(label->styles[i]);
+      }
+    }
+  }
+  msFree(label->styles);
+
+  for (i = 0; i < MS_LABEL_BINDING_LENGTH; i++) {
+    msFree(label->bindings[i].item);
+    msFreeExpression(&(label->exprBindings[i]));
+  }
+
+  msFreeExpression(&(label->expression));
+  msFreeExpression(&(label->text));
+
+  if (label->leader) {
+    freeLabelLeader(label->leader);
+    msFree(label->leader);
+    label->leader = NULL;
+  }
+
+  return MS_SUCCESS;
+}
+
+static int loadLeader(labelLeaderObj *leader) {
+  for (;;) {
+    switch (msyylex()) {
+    case (END):
+      return (0);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLeader()");
+      return (-1);
+    case GRIDSTEP:
+      if (getInteger(&(leader->gridstep), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case MAXDISTANCE:
+      if (getInteger(&(leader->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case STYLE:
+      if (msGrowLeaderStyles(leader) == NULL)
+        return (-1);
+      initStyle(leader->styles[leader->numstyles]);
+      if (loadStyle(leader->styles[leader->numstyles]) != MS_SUCCESS) {
+        freeStyle(leader->styles[leader->numstyles]);
+        free(leader->styles[leader->numstyles]);
+        leader->styles[leader->numstyles] = NULL;
+        return -1;
+      }
+      leader->numstyles++;
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLeader()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  }
+}
+
+static int loadLabel(labelObj *label) {
+  int symbol;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (ANGLE):
+      if ((symbol = getSymbol(5, MS_NUMBER, MS_AUTO, MS_AUTO2, MS_FOLLOW,
+                              MS_BINDING)) == -1)
+        return (-1);
+
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) ==
+            MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid ANGLE, must be between -360 and 360 (line %d)",
+                     "loadLabel()", msyylineno);
+          return (MS_FAILURE);
+        }
+        label->angle = (double)msyynumber;
+      } else if (symbol == MS_BINDING) {
+        if (label->bindings[MS_LABEL_BINDING_ANGLE].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_ANGLE].item);
+        label->bindings[MS_LABEL_BINDING_ANGLE].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      } else {
+        label->anglemode = symbol;
+      }
+      break;
+    case (ALIGN):
+      if ((symbol = getSymbol(4, MS_ALIGN_LEFT, MS_ALIGN_CENTER, MS_ALIGN_RIGHT,
+                              MS_BINDING)) == -1)
+        return (-1);
+      if ((symbol == MS_ALIGN_LEFT) || (symbol == MS_ALIGN_CENTER) ||
+          (symbol == MS_ALIGN_RIGHT)) {
+        label->align = symbol;
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_ALIGN].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_ALIGN].item);
+        label->bindings[MS_LABEL_BINDING_ALIGN].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (ANTIALIAS): /*ignore*/
+      msyylex();
+      break;
+    case (BUFFER):
+      if (getInteger(&(label->buffer), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      break;
+    case (COLOR):
+      if (loadColor(&(label->color),
+                    &(label->bindings[MS_LABEL_BINDING_COLOR])) != MS_SUCCESS)
+        return (-1);
+      if (label->bindings[MS_LABEL_BINDING_COLOR].item)
+        label->numbindings++;
+      break;
+    case (ENCODING):
+      if ((getString(&label->encoding)) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END):
+      return (0);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLabel()");
+      return (-1);
+    case (EXPRESSION):
+      if (loadExpression(&(label->expression)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (FONT):
+      if ((symbol = getSymbol(2, MS_STRING, MS_BINDING)) == -1)
+        return (-1);
+
+      if (symbol == MS_STRING) {
+        if (label->font != NULL)
+          msFree(label->font);
+        label->font = msStrdup(msyystring_buffer);
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_FONT].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_FONT].item);
+        label->bindings[MS_LABEL_BINDING_FONT].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (FORCE):
+      switch (msyylex()) {
+      case MS_ON:
+        label->force = MS_ON;
+        break;
+      case MS_OFF:
+        label->force = MS_OFF;
+        break;
+      case GROUP:
+        label->force = MS_LABEL_FORCE_GROUP;
+        break;
+      default:
+        msSetError(MS_MISCERR,
+                   "Invalid FORCE, must be ON,OFF,or GROUP (line %d)",
+                   "loadLabel()", msyylineno);
+        return (-1);
+      }
+      break;
+    case (LABEL):
+      break; /* for string loads */
+    case (LEADER):
+      msSetError(MS_MISCERR,
+                 "LABEL LEADER not implemented. LEADER goes at the CLASS level "
+                 "(line %d)",
+                 "loadLabel()", msyylineno);
+      return (-1);
+    case (MAXSIZE):
+      if (getInteger(&(label->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXSCALEDENOM):
+      if (getDouble(&(label->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXLENGTH):
+      if (getInteger(&(label->maxlength), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINDISTANCE):
+      if (getInteger(&(label->mindistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (REPEATDISTANCE):
+      if (getInteger(&(label->repeatdistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXOVERLAPANGLE):
+      if (getDouble(&(label->maxoverlapangle), MS_NUM_CHECK_RANGE, 0, 360) ==
+          -1)
+        return (-1);
+      break;
+    case (MINFEATURESIZE):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_AUTO)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid MINFEATURESIZE, must be greater than 0 (line %d)",
+                     "loadLabel()", msyylineno);
+          return (MS_FAILURE);
+        }
+        label->minfeaturesize = (int)msyynumber;
+      } else
+        label->autominfeaturesize = MS_TRUE;
+      break;
+    case (MINSCALEDENOM):
+      if (getDouble(&(label->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINSIZE):
+      if (getInteger(&(label->minsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (OFFSET):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        label->offsetx = (int)msyynumber; // any integer ok
+      else {
+        if (label->bindings[MS_LABEL_BINDING_OFFSET_X].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_OFFSET_X].item);
+        label->bindings[MS_LABEL_BINDING_OFFSET_X].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        label->offsety = (int)msyynumber; // any integer ok
+      else {
+        if (label->bindings[MS_LABEL_BINDING_OFFSET_Y].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_OFFSET_Y].item);
+        label->bindings[MS_LABEL_BINDING_OFFSET_Y].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(label->outlinecolor),
+                    &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR])) !=
+          MS_SUCCESS)
+        return (-1);
+      if (label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item)
+        label->numbindings++;
+      break;
+    case (OUTLINEWIDTH):
+      if (getInteger(&(label->outlinewidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (PARTIALS):
+      if ((label->partials = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (POSITION):
+      if ((label->position =
+               getSymbol(11, MS_UL, MS_UC, MS_UR, MS_CL, MS_CC, MS_CR, MS_LL,
+                         MS_LC, MS_LR, MS_AUTO, MS_BINDING)) == -1)
+        return (-1);
+      if (label->position == MS_BINDING) {
+        if (label->bindings[MS_LABEL_BINDING_POSITION].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_POSITION].item);
+        label->bindings[MS_LABEL_BINDING_POSITION].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (PRIORITY):
+      if (label->exprBindings[MS_LABEL_BINDING_PRIORITY].string) {
+        msFreeExpression(&label->exprBindings[MS_LABEL_BINDING_PRIORITY]);
+        label->nexprbindings--;
+      }
+
+      if ((symbol = getSymbol(3, MS_EXPRESSION, MS_NUMBER, MS_BINDING)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 1,
+                          MS_MAX_LABEL_PRIORITY) == MS_FAILURE) {
+          msSetError(
+              MS_MISCERR,
+              "Invalid PRIORITY, must be an integer between 1 and %d (line %d)",
+              "loadLabel()", MS_MAX_LABEL_PRIORITY, msyylineno);
+          return (-1);
+        }
+        label->priority = (int)msyynumber;
+      } else if (symbol == MS_EXPRESSION) {
+        msFree(label->exprBindings[MS_LABEL_BINDING_PRIORITY].string);
+        label->exprBindings[MS_LABEL_BINDING_PRIORITY].string =
+            msStrdup(msyystring_buffer);
+        label->exprBindings[MS_LABEL_BINDING_PRIORITY].type = MS_EXPRESSION;
+        label->nexprbindings++;
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_PRIORITY].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_PRIORITY].item);
+        label->bindings[MS_LABEL_BINDING_PRIORITY].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (SHADOWCOLOR):
+      if (loadColor(&(label->shadowcolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (SHADOWSIZE):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        label->shadowsizex = (int)msyynumber; // x offset, any int ok
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item);
+        label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        label->shadowsizey = (int)msyynumber; // y offset, any int ok
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
+        label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (SIZE):
+      if (label->bindings[MS_LABEL_BINDING_SIZE].item) {
+        msFree(label->bindings[MS_LABEL_BINDING_SIZE].item);
+        label->bindings[MS_LABEL_BINDING_SIZE].item = NULL;
+        label->numbindings--;
+      }
+      if (label->exprBindings[MS_LABEL_BINDING_SIZE].string) {
+        msFreeExpression(&label->exprBindings[MS_LABEL_BINDING_SIZE]);
+        label->nexprbindings--;
+      }
+
+      if ((symbol = getSymbol(8, MS_EXPRESSION, MS_NUMBER, MS_BINDING, MS_TINY,
+                              MS_SMALL, MS_MEDIUM, MS_LARGE, MS_GIANT)) == -1)
+        return (-1);
+
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid SIZE, must be greater than 0 (line %d)",
+                     "loadLabel()", msyylineno);
+          return (-1);
+        }
+        label->size = (double)msyynumber;
+      } else if (symbol == MS_BINDING) {
+        label->bindings[MS_LABEL_BINDING_SIZE].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      } else if (symbol == MS_EXPRESSION) {
+        msFree(label->exprBindings[MS_LABEL_BINDING_SIZE].string);
+        label->exprBindings[MS_LABEL_BINDING_SIZE].string =
+            msStrdup(msyystring_buffer);
+        label->exprBindings[MS_LABEL_BINDING_SIZE].type = MS_EXPRESSION;
+        label->nexprbindings++;
+      } else
+        label->size = symbol;
+      break;
+    case (STYLE):
+      if (msGrowLabelStyles(label) == NULL)
+        return (-1);
+      initStyle(label->styles[label->numstyles]);
+      if (loadStyle(label->styles[label->numstyles]) != MS_SUCCESS) {
+        freeStyle(label->styles[label->numstyles]);
+        free(label->styles[label->numstyles]);
+        label->styles[label->numstyles] = NULL;
+        return (-1);
+      }
+      if (label->styles[label->numstyles]->_geomtransform.type ==
+          MS_GEOMTRANSFORM_NONE)
+        label->styles[label->numstyles]->_geomtransform.type =
+            MS_GEOMTRANSFORM_LABELPOINT; /* set a default, a marker? */
+      label->numstyles++;
+      break;
+    case (TEXT):
+      if (loadExpression(&(label->text)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      if ((label->text.type != MS_STRING) &&
+          (label->text.type != MS_EXPRESSION)) {
+        msSetError(
+            MS_MISCERR,
+            "Text expressions support constant or tagged replacement strings.",
+            "loadLabel()");
+        return (-1);
+      }
+      break;
+    case (TYPE):
+      if (getSymbol(2, MS_TRUETYPE, MS_BITMAP) == -1)
+        return (-1); /* ignore TYPE */
+      break;
+    case (WRAP):
+      if (getCharacter(&(label->wrap)) == -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLabel()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  } /* next token */
+}
+
+int msUpdateLabelFromString(labelObj *label, char *string) {
+  if (!label || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadLabel(label) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+static void writeLeader(FILE *stream, int indent, labelLeaderObj *leader) {
+  int i;
+  if (leader->maxdistance == 0 && leader->numstyles == 0) {
+    return;
+  }
+  indent++;
+  writeBlockBegin(stream, indent, "LEADER");
+  writeNumber(stream, indent, "MAXDISTANCE", 0, leader->maxdistance);
+  writeNumber(stream, indent, "GRIDSTEP", 5, leader->gridstep);
+  for (i = 0; i < leader->numstyles; i++)
+    writeStyle(stream, indent, leader->styles[i]);
+
+  writeBlockEnd(stream, indent, "LEADER");
+}
+
+static void writeLabel(FILE *stream, int indent, labelObj *label) {
+  int i;
+  colorObj c;
+
+  if (label->size == -1)
+    return; /* there is no default label anymore */
+
+  indent++;
+  writeBlockBegin(stream, indent, "LABEL");
+
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_ANGLE].item)
+    writeAttributeBinding(stream, indent, "ANGLE",
+                          &(label->bindings[MS_LABEL_BINDING_ANGLE]));
+  else
+    writeNumberOrKeyword(stream, indent, "ANGLE", 0, label->angle,
+                         label->anglemode, 3, MS_FOLLOW, "FOLLOW", MS_AUTO,
+                         "AUTO", MS_AUTO2, "AUTO2");
+
+  writeExpression(stream, indent, "EXPRESSION", &(label->expression));
+
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_FONT].item)
+    writeAttributeBinding(stream, indent, "FONT",
+                          &(label->bindings[MS_LABEL_BINDING_FONT]));
+  else
+    writeString(stream, indent, "FONT", NULL, label->font);
+
+  writeNumber(stream, indent, "MAXSIZE", MS_MAXFONTSIZE, label->maxsize);
+  writeNumber(stream, indent, "MINSIZE", MS_MINFONTSIZE, label->minsize);
+
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_SIZE].item)
+    writeAttributeBinding(stream, indent, "SIZE",
+                          &(label->bindings[MS_LABEL_BINDING_SIZE]));
+  else
+    writeNumber(stream, indent, "SIZE", -1, label->size);
+
+  writeKeyword(stream, indent, "ALIGN", label->align, 3, MS_ALIGN_LEFT, "LEFT",
+               MS_ALIGN_CENTER, "CENTER", MS_ALIGN_RIGHT, "RIGHT");
+  writeNumber(stream, indent, "BUFFER", 0, label->buffer);
+
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_COLOR].item)
+    writeAttributeBinding(stream, indent, "COLOR",
+                          &(label->bindings[MS_LABEL_BINDING_COLOR]));
+  else {
+    MS_INIT_COLOR(c, 0, 0, 0, 255);
+    writeColor(stream, indent, "COLOR", &c, &(label->color));
+  }
+
+  writeString(stream, indent, "ENCODING", NULL, label->encoding);
+  if (label->leader)
+    writeLeader(stream, indent, label->leader);
+  writeKeyword(stream, indent, "FORCE", label->force, 2, MS_TRUE, "TRUE",
+               MS_LABEL_FORCE_GROUP, "GROUP");
+  writeNumber(stream, indent, "MAXLENGTH", 0, label->maxlength);
+  writeNumber(stream, indent, "MAXSCALEDENOM", -1, label->maxscaledenom);
+  writeNumber(stream, indent, "MINDISTANCE", -1, label->mindistance);
+  writeNumberOrKeyword(stream, indent, "MINFEATURESIZE", -1,
+                       label->minfeaturesize, 1, label->autominfeaturesize,
+                       MS_TRUE, "AUTO");
+  writeNumber(stream, indent, "MINSCALEDENOM", -1, label->minscaledenom);
+  writeDimension(stream, indent, "OFFSET", label->offsetx, label->offsety, NULL,
+                 NULL);
+
+  if (label->numbindings > 0 &&
+      label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item)
+    writeAttributeBinding(stream, indent, "OUTLINECOLOR",
+                          &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR]));
+  else
+    writeColor(stream, indent, "OUTLINECOLOR", NULL, &(label->outlinecolor));
+
+  writeNumber(stream, indent, "OUTLINEWIDTH", 1, label->outlinewidth);
+  writeKeyword(stream, indent, "PARTIALS", label->partials, 1, MS_TRUE, "TRUE");
+
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_POSITION].item)
+    writeAttributeBinding(stream, indent, "POSITION",
+                          &(label->bindings[MS_LABEL_BINDING_POSITION]));
+  else
+    writeKeyword(stream, indent, "POSITION", label->position, 10, MS_UL, "UL",
+                 MS_UC, "UC", MS_UR, "UR", MS_CL, "CL", MS_CC, "CC", MS_CR,
+                 "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR", MS_AUTO, "AUTO");
+
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_PRIORITY].item)
+    writeAttributeBinding(stream, indent, "PRIORITY",
+                          &(label->bindings[MS_LABEL_BINDING_PRIORITY]));
+  else if (label->nexprbindings > 0 &&
+           label->exprBindings[MS_LABEL_BINDING_PRIORITY].string)
+    writeExpression(stream, indent, "PRIORITY",
+                    &(label->exprBindings[MS_LABEL_BINDING_PRIORITY]));
+  else
+    writeNumber(stream, indent, "PRIORITY", MS_DEFAULT_LABEL_PRIORITY,
+                label->priority);
+
+  writeNumber(stream, indent, "REPEATDISTANCE", 0, label->repeatdistance);
+  writeColor(stream, indent, "SHADOWCOLOR", NULL, &(label->shadowcolor));
+  writeDimension(stream, indent, "SHADOWSIZE", label->shadowsizex,
+                 label->shadowsizey,
+                 label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item,
+                 label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
+
+  writeNumber(stream, indent, "MAXOVERLAPANGLE", 22.5, label->maxoverlapangle);
+  for (i = 0; i < label->numstyles; i++)
+    writeStyle(stream, indent, label->styles[i]);
+
+  writeExpression(stream, indent, "TEXT", &(label->text));
+
+  writeCharacter(stream, indent, "WRAP", '\0', label->wrap);
+  writeBlockEnd(stream, indent, "LABEL");
+}
+
+char *msWriteLabelToString(labelObj *label) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeLabel(stdout, -1, label);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+void msInitExpression(expressionObj *exp) {
+  memset(exp, 0, sizeof(*exp));
+  exp->type = MS_STRING;
+}
+
+void msFreeExpressionTokens(expressionObj *exp) {
+  tokenListNodeObjPtr node = NULL;
+  tokenListNodeObjPtr nextNode = NULL;
+
+  if (!exp)
+    return;
+
+  if (exp->tokens) {
+    node = exp->tokens;
+    while (node != NULL) {
+      nextNode = node->next;
+
+      msFree(node->tokensrc); /* not set very often */
+
+      switch (node->token) {
+      case MS_TOKEN_BINDING_DOUBLE:
+      case MS_TOKEN_BINDING_INTEGER:
+      case MS_TOKEN_BINDING_STRING:
+      case MS_TOKEN_BINDING_TIME:
+        msFree(node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_LITERAL_TIME:
+        /* anything to do? */
+        break;
+      case MS_TOKEN_LITERAL_STRING:
+        msFree(node->tokenval.strval);
+        break;
+      case MS_TOKEN_LITERAL_SHAPE:
+        msFreeShape(node->tokenval.shpval);
+        free(node->tokenval.shpval);
+        break;
+      }
+
+      msFree(node);
+      node = nextNode;
+    }
+    exp->tokens = exp->curtoken = NULL;
+  }
+}
+
+void msFreeExpression(expressionObj *exp) {
+  if (!exp)
+    return;
+  msFree(exp->string);
+  msFree(exp->native_string);
+  if ((exp->type == MS_REGEX) && exp->compiled)
+    ms_regfree(&(exp->regex));
+  msFreeExpressionTokens(exp);
+  msInitExpression(exp); /* re-initialize */
+}
+
+int loadExpression(expressionObj *exp) {
+  /* TODO: should we call msFreeExpression if exp->string != NULL? We do some
+   * checking to avoid a leak but is it enough... */
+
+  msyystring_icase = MS_TRUE;
+  if ((exp->type = getSymbol(6, MS_STRING, MS_EXPRESSION, MS_REGEX, MS_ISTRING,
+                             MS_IREGEX, MS_LIST)) == -1)
+    return (-1);
+  if (exp->string != NULL) {
+    msFree(exp->string);
+    msFree(exp->native_string);
+  }
+  exp->string = msStrdup(msyystring_buffer);
+  exp->native_string = NULL;
+
+  if (exp->type == MS_ISTRING) {
+    exp->flags = exp->flags | MS_EXP_INSENSITIVE;
+    exp->type = MS_STRING;
+  } else if (exp->type == MS_IREGEX) {
+    exp->flags = exp->flags | MS_EXP_INSENSITIVE;
+    exp->type = MS_REGEX;
+  }
+
+  return (0);
+}
+
+/* ---------------------------------------------------------------------------
+   msLoadExpressionString and loadExpressionString
+
+   msLoadExpressionString wraps call to loadExpressionString with mutex
+   acquisition and release.  This function should be used everywhere outside
+   the mapfile loading phase of an application.  loadExpressionString does
+   not check for a mutex!  It should be used only within code that has
+   properly acquired a mutex.
+
+   See bug 339 for more details -- SG.
+   ------------------------------------------------------------------------ */
+
+int msLoadExpressionString(expressionObj *exp, const char *value) {
+  int retval = MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+  retval = loadExpressionString(exp, value);
+  msReleaseLock(TLOCK_PARSER);
+
+  return retval;
+}
+
+int loadExpressionString(expressionObj *exp, const char *value) {
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = value;
+  msyylex(); /* sets things up but processes no tokens */
+
+  msFreeExpression(exp); /* we're totally replacing the old expression so free
+                            (which re-inits) to start over */
+
+  msyystring_icase = MS_TRUE;
+  if ((exp->type = getSymbol2(5, MS_EXPRESSION, MS_REGEX, MS_IREGEX, MS_ISTRING,
+                              MS_LIST)) != -1) {
+    exp->string = msStrdup(msyystring_buffer);
+
+    if (exp->type == MS_ISTRING) {
+      exp->type = MS_STRING;
+      exp->flags = exp->flags | MS_EXP_INSENSITIVE;
+    } else if (exp->type == MS_IREGEX) {
+      exp->type = MS_REGEX;
+      exp->flags = exp->flags | MS_EXP_INSENSITIVE;
+    }
+  } else {
+    /* failure above is not an error since we'll consider anything not matching
+     * (like an unquoted number) as a STRING) */
+    exp->type = MS_STRING;
+    if ((strlen(value) - strlen(msyystring_buffer)) == 2)
+      exp->string = msStrdup(msyystring_buffer); /* value was quoted */
+    else
+      exp->string = msStrdup(value); /* use the whole value */
+  }
+
+  return (0);
+}
+
+/* msGetExpressionString()
+ *
+ * Returns the string representation of this expression, including delimiters
+ * and any flags (e.g. i = case-insensitive).
+ *
+ * Returns a newly allocated buffer that should be freed by the caller or NULL.
+ */
+char *msGetExpressionString(expressionObj *exp) {
+  if (exp->string) {
+    char *exprstring;
+    size_t buffer_size;
+    const char *case_insensitive = "";
+
+    if (exp->flags & MS_EXP_INSENSITIVE)
+      case_insensitive = "i";
+
+    /* Alloc buffer big enough for string + 2 delimiters + 'i' + \0 */
+    buffer_size = strlen(exp->string) + 4;
+    exprstring = (char *)msSmallMalloc(buffer_size);
+
+    switch (exp->type) {
+    case (MS_REGEX):
+      snprintf(exprstring, buffer_size, "/%s/%s", exp->string,
+               case_insensitive);
+      return exprstring;
+    case (MS_STRING):
+      snprintf(exprstring, buffer_size, "\"%s\"%s", exp->string,
+               case_insensitive);
+      return exprstring;
+    case (MS_EXPRESSION):
+      snprintf(exprstring, buffer_size, "(%s)", exp->string);
+      return exprstring;
+    case (MS_LIST):
+      snprintf(exprstring, buffer_size, "{%s}", exp->string);
+      return exprstring;
+    default:
+      /* We should never get to here really! */
+      free(exprstring);
+      return NULL;
+    }
+  }
+  return NULL;
+}
+
+static void writeExpression(FILE *stream, int indent, const char *name,
+                            expressionObj *exp) {
+  if (!exp || !exp->string)
+    return;
+
+  writeIndent(stream, ++indent);
+  switch (exp->type) {
+  case (MS_LIST):
+    fprintf(stream, "%s {%s}", name, exp->string);
+    break;
+  case (MS_REGEX):
+    msIO_fprintf(stream, "%s /%s/", name, exp->string);
+    break;
+  case (MS_STRING):
+    msIO_fprintf(stream, "%s ", name);
+    writeStringElement(stream, exp->string);
+    break;
+  case (MS_EXPRESSION):
+    msIO_fprintf(stream, "%s (%s)", name, exp->string);
+    break;
+  }
+  if ((exp->type == MS_STRING || exp->type == MS_REGEX) &&
+      (exp->flags & MS_EXP_INSENSITIVE))
+    msIO_fprintf(stream, "i");
+  writeLineFeed(stream);
+}
+
+int loadHashTable(hashTableObj *ptable) {
+  assert(ptable);
+
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadHashTable()");
+      return (MS_FAILURE);
+    case (END):
+      return (MS_SUCCESS);
+    case (MS_STRING): {
+      char *data = NULL;
+      char *key =
+          msStrdup(msyystring_buffer); /* the key is *always* a string */
+      if (getString(&data) == MS_FAILURE) {
+        free(key);
+        return (MS_FAILURE);
+      }
+      msInsertHashTable(ptable, key, data);
+
+      free(key);
+      free(data);
+      break;
+    }
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadHashTable()", msyystring_buffer, msyylineno);
+      return (MS_FAILURE);
+    }
+  }
+
+  return (MS_SUCCESS);
+}
+
+static void writeHashTable(FILE *stream, int indent, const char *title,
+                           hashTableObj *table) {
+  struct hashObj *tp;
+  int i;
+
+  if (!table)
+    return;
+  if (msHashIsEmpty(table))
+    return;
+
+  indent++;
+  writeBlockBegin(stream, indent, title);
+  for (i = 0; i < MS_HASHSIZE; i++) {
+    if (table->items[i] != NULL) {
+      for (tp = table->items[i]; tp != NULL; tp = tp->next)
+        writeNameValuePair(stream, indent, tp->key, tp->data);
+    }
+  }
+  writeBlockEnd(stream, indent, title);
+}
+
+static void writeHashTableInline(FILE *stream, int indent, char *name,
+                                 hashTableObj *table) {
+  struct hashObj *tp = NULL;
+  int i;
+
+  if (!table)
+    return;
+  if (msHashIsEmpty(table))
+    return;
+
+  ++indent;
+  for (i = 0; i < MS_HASHSIZE; ++i) {
+    if (table->items[i] != NULL) {
+      for (tp = table->items[i]; tp != NULL; tp = tp->next) {
+        writeIndent(stream, indent);
+        msIO_fprintf(stream, "%s ", name);
+        writeStringElement(stream, tp->key);
+        msIO_fprintf(stream, " ");
+        writeStringElement(stream, tp->data);
+        writeLineFeed(stream);
+      }
+    }
+  }
+}
+
+/*
+** Initialize, load and free a cluster object
+*/
+void initCluster(clusterObj *cluster) {
+  cluster->maxdistance = 10;
+  cluster->buffer = 0;
+  cluster->region = NULL;
+  msInitExpression(&(cluster->group));
+  msInitExpression(&(cluster->filter));
+}
+
+void freeCluster(clusterObj *cluster) {
+  msFree(cluster->region);
+  msFreeExpression(&(cluster->group));
+  msFreeExpression(&(cluster->filter));
+}
+
+int loadCluster(clusterObj *cluster) {
+  for (;;) {
+    switch (msyylex()) {
+    case (CLUSTER):
+      break; /* for string loads */
+    case (MAXDISTANCE):
+      if (getDouble(&(cluster->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (BUFFER):
+      if (getDouble(&(cluster->buffer), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (REGION):
+      if (getString(&cluster->region) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END):
+      return (0);
+      break;
+    case (GROUP):
+      if (loadExpression(&(cluster->group)) == -1)
+        return (-1);
+      break;
+    case (FILTER):
+      if (loadExpression(&(cluster->filter)) == -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadCluster()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  }
+  return (MS_SUCCESS);
+}
+
+int msUpdateClusterFromString(clusterObj *cluster, char *string) {
+  if (!cluster || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadCluster(cluster) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+static void writeCluster(FILE *stream, int indent, clusterObj *cluster) {
+
+  if (cluster->maxdistance == 10 && cluster->buffer == 0.0 &&
+      cluster->region == NULL && cluster->group.string == NULL &&
+      cluster->filter.string == NULL)
+    return; /* Nothing to write */
+
+  indent++;
+  writeBlockBegin(stream, indent, "CLUSTER");
+  writeNumber(stream, indent, "MAXDISTANCE", 10, cluster->maxdistance);
+  writeNumber(stream, indent, "BUFFER", 0, cluster->buffer);
+  writeString(stream, indent, "REGION", NULL, cluster->region);
+  writeExpression(stream, indent, "GROUP", &(cluster->group));
+  writeExpression(stream, indent, "FILTER", &(cluster->filter));
+  writeBlockEnd(stream, indent, "CLUSTER");
+}
+
+char *msWriteClusterToString(clusterObj *cluster) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeCluster(stdout, -1, cluster);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+/*
+** Initialize, load and free a single style
+*/
+int initStyle(styleObj *style) {
+  int i;
+  MS_REFCNT_INIT(style);
+  MS_INIT_COLOR(style->color, -1, -1, -1, 255); /* must explictly set colors */
+  MS_INIT_COLOR(style->outlinecolor, -1, -1, -1, 255);
+  /* New Color Range fields*/
+  MS_INIT_COLOR(style->mincolor, -1, -1, -1, 255);
+  MS_INIT_COLOR(style->maxcolor, -1, -1, -1, 255);
+  style->minvalue = 0.0;
+  style->maxvalue = 1.0;
+  style->rangeitem = NULL;
+  /* End Color Range fields*/
+  style->symbol = 0; /* there is always a default symbol*/
+  style->symbolname = NULL;
+  style->size = -1; /* in SIZEUNITS (layerObj) */
+  style->minsize = MS_MINSYMBOLSIZE;
+  style->maxsize = MS_MAXSYMBOLSIZE;
+  style->width = 1;        /* in pixels */
+  style->outlinewidth = 0; /* in pixels */
+  style->minwidth = MS_MINSYMBOLWIDTH;
+  style->maxwidth = MS_MAXSYMBOLWIDTH;
+  style->minscaledenom = style->maxscaledenom = -1.0;
+  style->offsetx = style->offsety = 0;                   /* no offset */
+  style->polaroffsetpixel = style->polaroffsetangle = 0; /* no polar offset */
+  style->angle = 0;
+  style->autoangle = MS_FALSE;
+  style->antialiased = MS_TRUE;
+  style->opacity = 100; /* fully opaque */
+
+  msInitExpression(&(style->_geomtransform));
+  style->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
+
+  style->patternlength = 0; /* solid line */
+  style->gap = 0;
+  style->initialgap = -1;
+  style->linecap = MS_CJC_DEFAULT_CAPS;
+  style->linejoin = MS_CJC_DEFAULT_JOINS;
+  style->linejoinmaxsize = MS_CJC_DEFAULT_JOIN_MAXSIZE;
+
+  style->numbindings = 0;
+  style->nexprbindings = 0;
+  for (i = 0; i < MS_STYLE_BINDING_LENGTH; i++) {
+    style->bindings[i].item = NULL;
+    style->bindings[i].index = -1;
+    msInitExpression(&(style->exprBindings[i]));
+  }
+
+  style->sizeunits = MS_INHERIT;
+  style->scalefactor = 1.0;
+
+  return MS_SUCCESS;
+}
+
+int loadStyle(styleObj *style) {
+  int symbol;
+
+  for (;;) {
+    switch (msyylex()) {
+      /* New Color Range fields*/
+    case (COLORRANGE):
+      /*These are both in one line now*/
+      if (loadColor(&(style->mincolor), NULL) != MS_SUCCESS)
+        return (MS_FAILURE);
+      if (loadColor(&(style->maxcolor), NULL) != MS_SUCCESS)
+        return (MS_FAILURE);
+      break;
+    case (DATARANGE):
+      /*These are both in one line now*/
+      if (getDouble(&(style->minvalue), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (MS_FAILURE);
+      if (getDouble(&(style->maxvalue), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (RANGEITEM):
+      if (getString(&style->rangeitem) == MS_FAILURE)
+        return (MS_FAILURE);
+      break;
+      /* End Range fields*/
+    case (ANGLE):
+      if ((symbol = getSymbol(3, MS_NUMBER, MS_BINDING, MS_AUTO)) == -1)
+        return (MS_FAILURE);
+
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) ==
+            MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid ANGLE, must be between -360 and 360 (line %d)",
+                     "loadStyle()", msyylineno);
+          return (MS_FAILURE);
+        }
+        style->angle = (double)msyynumber;
+      } else if (symbol == MS_BINDING) {
+        if (style->bindings[MS_STYLE_BINDING_ANGLE].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_ANGLE].item);
+        style->bindings[MS_STYLE_BINDING_ANGLE].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      } else {
+        style->autoangle = MS_TRUE;
+      }
+      break;
+    case (ANTIALIAS):
+      if ((symbol = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_FALSE) {
+        style->antialiased = MS_FALSE;
+      }
+      break;
+    case (COLOR):
+      if (loadColor(&(style->color),
+                    &(style->bindings[MS_STYLE_BINDING_COLOR])) != MS_SUCCESS)
+        return (MS_FAILURE);
+      if (style->bindings[MS_STYLE_BINDING_COLOR].item)
+        style->numbindings++;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadStyle()");
+      return (MS_FAILURE); /* missing END (probably) */
+    case (END): {
+      int alpha;
+
+      /* apply opacity as the alpha channel color(s) */
+      if (style->opacity < 100) {
+        alpha = MS_NINT(style->opacity * 2.55);
+
+        style->color.alpha = alpha;
+        style->outlinecolor.alpha = alpha;
+
+        style->mincolor.alpha = alpha;
+        style->maxcolor.alpha = alpha;
+      }
+
+      return (MS_SUCCESS);
+    } break;
+    case (GAP):
+      if (getDouble(&(style->gap), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (INITIALGAP):
+      if (getDouble(&(style->initialgap), MS_NUM_CHECK_GTE, 0, -1) ==
+          -1) { // zero is ok
+        msSetError(MS_MISCERR,
+                   "INITIALGAP requires a positive values (line %d)",
+                   "loadStyle()", msyylineno);
+        return (MS_FAILURE);
+      }
+      break;
+    case (MAXSCALEDENOM):
+      if (getDouble(&(style->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MINSCALEDENOM):
+      if (getDouble(&(style->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (GEOMTRANSFORM): {
+      int s;
+      if ((s = getSymbol(2, MS_STRING, MS_EXPRESSION)) == -1)
+        return (MS_FAILURE);
+      if (s == MS_STRING)
+        msStyleSetGeomTransform(style, msyystring_buffer);
+      else {
+        /* handle expression case here for the moment */
+        msFree(style->_geomtransform.string);
+        style->_geomtransform.string = msStrdup(msyystring_buffer);
+        style->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
+      }
+    } break;
+    case (LINECAP):
+      if ((style->linecap = getSymbol(4, MS_CJC_BUTT, MS_CJC_ROUND,
+                                      MS_CJC_SQUARE, MS_CJC_TRIANGLE)) == -1)
+        return (MS_FAILURE);
+      break;
+    case (LINEJOIN):
+      if ((style->linejoin = getSymbol(4, MS_CJC_NONE, MS_CJC_ROUND,
+                                       MS_CJC_MITER, MS_CJC_BEVEL)) == -1)
+        return (MS_FAILURE);
+      break;
+    case (LINEJOINMAXSIZE):
+      if (getDouble(&(style->linejoinmaxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MAXSIZE):
+      if (getDouble(&(style->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MINSIZE):
+      if (getDouble(&(style->minsize), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MAXWIDTH):
+      if (getDouble(&(style->maxwidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MINWIDTH):
+      if (getDouble(&(style->minwidth), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (OFFSET):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        style->offsetx = (double)msyynumber; // any double ok
+      else {
+        if (style->bindings[MS_STYLE_BINDING_OFFSET_X].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OFFSET_X].item);
+        style->bindings[MS_STYLE_BINDING_OFFSET_X].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        style->offsety = (double)msyynumber; // any double ok
+      else {
+        if (style->bindings[MS_STYLE_BINDING_OFFSET_Y].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
+        style->bindings[MS_STYLE_BINDING_OFFSET_Y].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (OPACITY):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        style->opacity = MS_MAX(MS_MIN((int)msyynumber, 100),
+                                0); /* force opacity to between 0 and 100 */
+      else {
+        if (style->bindings[MS_STYLE_BINDING_OPACITY].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OPACITY].item);
+        style->bindings[MS_STYLE_BINDING_OPACITY].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(style->outlinecolor),
+                    &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR])) !=
+          MS_SUCCESS)
+        return (MS_FAILURE);
+      if (style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item)
+        style->numbindings++;
+      break;
+    case (PATTERN): {
+      int done = MS_FALSE;
+      for (;;) { /* read till the next END */
+        switch (msyylex()) {
+        case (END):
+          if (style->patternlength < 2) {
+            msSetError(MS_SYMERR,
+                       "Not enough pattern elements. A minimum of 2 are "
+                       "required (line %d)",
+                       "loadStyle()", msyylineno);
+            return (MS_FAILURE);
+          }
+          done = MS_TRUE;
+          break;
+        case (MS_NUMBER): /* read the pattern values */
+          if (style->patternlength == MS_MAXPATTERNLENGTH) {
+            msSetError(MS_SYMERR, "Pattern too long.", "loadStyle()");
+            return (MS_FAILURE);
+          }
+          style->pattern[style->patternlength] =
+              atof(msyystring_buffer); // good enough?
+          style->patternlength++;
+          break;
+        default:
+          msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)",
+                     "loadStyle()", msyystring_buffer, msyylineno);
+          return (MS_FAILURE);
+        }
+        if (done == MS_TRUE)
+          break;
+      }
+      break;
+    }
+    case (OUTLINEWIDTH):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid OUTLINEWIDTH, must be greater then or equal to 0 "
+                     "(line %d)",
+                     "loadStyle()", msyylineno);
+          return (MS_FAILURE);
+        }
+        style->outlinewidth = (double)msyynumber;
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item);
+        style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (SIZE):
+      if (style->exprBindings[MS_STYLE_BINDING_SIZE].string) {
+        msFreeExpression(&style->exprBindings[MS_STYLE_BINDING_SIZE]);
+        style->nexprbindings--;
+      }
+
+      if ((symbol = getSymbol(3, MS_EXPRESSION, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid SIZE, must be greater than 0 (line %d)",
+                     "loadStyle()", msyylineno);
+          return (MS_FAILURE);
+        }
+        style->size = (double)msyynumber;
+      } else if (symbol == MS_EXPRESSION) {
+        msFree(style->exprBindings[MS_STYLE_BINDING_SIZE].string);
+        style->exprBindings[MS_STYLE_BINDING_SIZE].string =
+            msStrdup(msyystring_buffer);
+        style->exprBindings[MS_STYLE_BINDING_SIZE].type = MS_EXPRESSION;
+        style->nexprbindings++;
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_SIZE].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_SIZE].item);
+        style->bindings[MS_STYLE_BINDING_SIZE].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (STYLE):
+      break; /* for string loads */
+    case (SYMBOL):
+      if ((symbol = getSymbol(3, MS_NUMBER, MS_STRING, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(
+              MS_MISCERR,
+              "Invalid SYMBOL id, must be greater than or equal to 0 (line %d)",
+              "loadStyle()", msyylineno);
+          return (MS_FAILURE);
+        }
+        if (style->symbolname != NULL) {
+          msFree(style->symbolname);
+          style->symbolname = NULL;
+        }
+        style->symbol = (int)msyynumber;
+      } else if (symbol == MS_STRING) {
+        if (style->symbolname != NULL)
+          msFree(style->symbolname);
+        style->symbolname = msStrdup(msyystring_buffer);
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_SYMBOL].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_SYMBOL].item);
+        style->bindings[MS_STYLE_BINDING_SYMBOL].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (WIDTH):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(
+              MS_MISCERR,
+              "Invalid WIDTH, must be greater than or equal to 0 (line %d)",
+              "loadStyle()", msyylineno);
+          return (MS_FAILURE);
+        }
+        style->width = (double)msyynumber;
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_WIDTH].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_WIDTH].item);
+        style->bindings[MS_STYLE_BINDING_WIDTH].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (POLAROFFSET):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        style->polaroffsetpixel = (double)msyynumber; // ok?
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item);
+        style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        style->polaroffsetangle = (double)msyynumber; // ok?
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
+        style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadStyle()", msyystring_buffer, msyylineno);
+        return (MS_FAILURE);
+      } else {
+        return (MS_SUCCESS); /* end of a string, not an error */
+      }
+    }
+  }
+}
+
+int msUpdateStyleFromString(styleObj *style, char *string) {
+  if (!style || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadStyle(style) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+int freeStyle(styleObj *style) {
+  int i;
+
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(style)) {
+    return MS_FAILURE;
+  }
+
+  msFree(style->symbolname);
+  msFreeExpression(&style->_geomtransform);
+  msFree(style->rangeitem);
+
+  for (i = 0; i < MS_STYLE_BINDING_LENGTH; i++) {
+    msFree(style->bindings[i].item);
+    msFreeExpression(&(style->exprBindings[i]));
+  }
+
+  return MS_SUCCESS;
+}
+
+void writeStyle(FILE *stream, int indent, styleObj *style) {
+
+  indent++;
+  writeBlockBegin(stream, indent, "STYLE");
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_ANGLE].item)
+    writeAttributeBinding(stream, indent, "ANGLE",
+                          &(style->bindings[MS_STYLE_BINDING_ANGLE]));
+  else
+    writeNumberOrKeyword(stream, indent, "ANGLE", 0, style->angle,
+                         style->autoangle, 1, MS_TRUE, "AUTO");
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_COLOR].item)
+    writeAttributeBinding(stream, indent, "COLOR",
+                          &(style->bindings[MS_STYLE_BINDING_COLOR]));
+  else
+    writeColor(stream, indent, "COLOR", NULL, &(style->color));
+
+  writeNumber(stream, indent, "GAP", 0, style->gap);
+  writeNumber(stream, indent, "INITIALGAP", -1, style->initialgap);
+
+  if (style->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
+    writeIndent(stream, indent + 1);
+    msIO_fprintf(stream, "GEOMTRANSFORM (%s)\n", style->_geomtransform.string);
+  } else if (style->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
+    writeKeyword(stream, indent, "GEOMTRANSFORM", style->_geomtransform.type, 8,
+                 MS_GEOMTRANSFORM_BBOX, "\"bbox\"", MS_GEOMTRANSFORM_END,
+                 "\"end\"", MS_GEOMTRANSFORM_LABELPOINT, "\"labelpnt\"",
+                 MS_GEOMTRANSFORM_LABELPOLY, "\"labelpoly\"",
+                 MS_GEOMTRANSFORM_LABELCENTER, "\"labelcenter\"",
+                 MS_GEOMTRANSFORM_START, "\"start\"", MS_GEOMTRANSFORM_VERTICES,
+                 "\"vertices\"", MS_GEOMTRANSFORM_CENTROID, "\"centroid\"");
+  }
+
+  if (style->linecap != MS_CJC_DEFAULT_CAPS) {
+    writeKeyword(stream, indent, "LINECAP", (int)style->linecap, 5, MS_CJC_NONE,
+                 "NONE", MS_CJC_ROUND, "ROUND", MS_CJC_SQUARE, "SQUARE",
+                 MS_CJC_BUTT, "BUTT", MS_CJC_TRIANGLE, "TRIANGLE");
+  }
+  if (style->linejoin != MS_CJC_DEFAULT_JOINS) {
+    writeKeyword(stream, indent, "LINEJOIN", (int)style->linejoin, 5,
+                 MS_CJC_NONE, "NONE", MS_CJC_ROUND, "ROUND", MS_CJC_BEVEL,
+                 "BEVEL", MS_CJC_MITER, "MITER");
+  }
+  writeNumber(stream, indent, "LINEJOINMAXSIZE", MS_CJC_DEFAULT_JOIN_MAXSIZE,
+              style->linejoinmaxsize);
+
+  writeNumber(stream, indent, "MAXSCALEDENOM", -1, style->maxscaledenom);
+  writeNumber(stream, indent, "MAXSIZE", MS_MAXSYMBOLSIZE, style->maxsize);
+  writeNumber(stream, indent, "MAXWIDTH", MS_MAXSYMBOLWIDTH, style->maxwidth);
+  writeNumber(stream, indent, "MINSCALEDENOM", -1, style->minscaledenom);
+  writeNumber(stream, indent, "MINSIZE", MS_MINSYMBOLSIZE, style->minsize);
+  writeNumber(stream, indent, "MINWIDTH", MS_MINSYMBOLWIDTH, style->minwidth);
+  if ((style->numbindings > 0 &&
+       (style->bindings[MS_STYLE_BINDING_OFFSET_X].item ||
+        style->bindings[MS_STYLE_BINDING_OFFSET_Y].item)) ||
+      style->offsetx != 0 || style->offsety != 0)
+    writeDimension(stream, indent, "OFFSET", style->offsetx, style->offsety,
+                   style->bindings[MS_STYLE_BINDING_OFFSET_X].item,
+                   style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
+  if ((style->numbindings > 0 &&
+       (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item ||
+        style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item)) ||
+      style->polaroffsetangle != 0 || style->polaroffsetpixel != 0)
+    writeDimension(stream, indent, "POLAROFFSET", style->polaroffsetpixel,
+                   style->polaroffsetangle,
+                   style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item,
+                   style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OPACITY].item)
+    writeAttributeBinding(stream, indent, "OPACITY",
+                          &(style->bindings[MS_STYLE_BINDING_OPACITY]));
+  else
+    writeNumber(stream, indent, "OPACITY", 100, style->opacity);
+
+  if (style->numbindings > 0 &&
+      style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item)
+    writeAttributeBinding(stream, indent, "OUTLINECOLOR",
+                          &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR]));
+  else
+    writeColor(stream, indent, "OUTLINECOLOR", NULL, &(style->outlinecolor));
+
+  if (style->numbindings > 0 &&
+      style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item)
+    writeAttributeBinding(stream, indent, "OUTLINEWIDTH",
+                          &(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH]));
+  else
+    writeNumber(stream, indent, "OUTLINEWIDTH", 0, style->outlinewidth);
+
+  /* PATTERN */
+  if (style->patternlength != 0) {
+    int i;
+    indent++;
+    writeBlockBegin(stream, indent, "PATTERN");
+    writeIndent(stream, indent);
+    for (i = 0; i < style->patternlength; i++)
+      msIO_fprintf(stream, " %.2f", style->pattern[i]);
+    msIO_fprintf(stream, "\n");
+    writeBlockEnd(stream, indent, "PATTERN");
+    indent--;
+  }
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SIZE].item)
+    writeAttributeBinding(stream, indent, "SIZE",
+                          &(style->bindings[MS_STYLE_BINDING_SIZE]));
+  else
+    writeNumber(stream, indent, "SIZE", -1, style->size);
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SYMBOL].item)
+    writeAttributeBinding(stream, indent, "SYMBOL",
+                          &(style->bindings[MS_STYLE_BINDING_SYMBOL]));
+  else
+    writeNumberOrString(stream, indent, "SYMBOL", 0, style->symbol,
+                        style->symbolname);
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_WIDTH].item)
+    writeAttributeBinding(stream, indent, "WIDTH",
+                          &(style->bindings[MS_STYLE_BINDING_WIDTH]));
+  else
+    writeNumber(stream, indent, "WIDTH", 1, style->width);
+
+  writeString(stream, indent, "RANGEITEM", NULL, style->rangeitem);
+  /* If COLORRANGE is valid, assume DATARANGE also needs to be written */
+  if (MS_VALID_COLOR(style->mincolor) && MS_VALID_COLOR(style->maxcolor)) {
+    writeColorRange(stream, indent, "COLORRANGE", &(style->mincolor),
+                    &(style->maxcolor));
+    writeDoubleRange(stream, indent, "DATARANGE", style->minvalue,
+                     style->maxvalue);
+  }
+
+  writeBlockEnd(stream, indent, "STYLE");
+}
+
+char *msWriteStyleToString(styleObj *style) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeStyle(stdout, -1, style);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+/*
+** Initialize, load and free a single class
+*/
+int initClass(classObj *class) {
+  class->status = MS_ON;
+  class->debug = MS_OFF;
+  MS_REFCNT_INIT(class);
+  class->isfallback = FALSE;
+
+  msInitExpression(&(class->expression));
+  class->name = NULL;
+  class->title = NULL;
+  msInitExpression(&(class->text));
+
+  class->template = NULL;
+
+  initHashTable(&(class->metadata));
+  initHashTable(&(class->validation));
+
+  class->maxscaledenom = class->minscaledenom = -1.0;
+  class->minfeaturesize = -1; /* no limit */
+
+  /* Set maxstyles = 0, styles[] will be allocated as needed on first call
+   * to msGrowClassStyles()
+   */
+  class->numstyles = class->maxstyles = 0;
+  class->styles = NULL;
+
+  class->numlabels = class->maxlabels = 0;
+  class->labels = NULL;
+
+  class->keyimage = NULL;
+
+  class->group = NULL;
+
+  class->leader = NULL;
+
+  class->sizeunits = MS_INHERIT;
+  class->scalefactor = 1.0;
+
+  return (0);
+}
+
+int freeClass(classObj *class) {
+  int i;
+
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(class)) {
+    return MS_FAILURE;
+  }
+
+  msFreeExpression(&(class->expression));
+  msFreeExpression(&(class->text));
+  msFree(class->name);
+  msFree(class->title);
+  msFree(class->template);
+  msFree(class->group);
+
+  msFreeHashItems(&(class->metadata));
+  msFreeHashItems(&(class->validation));
+
+  for (i = 0; i < class->numstyles; i++) { /* each style */
+    if (class->styles[i] != NULL) {
+      if (freeStyle(class->styles[i]) == MS_SUCCESS) {
+        msFree(class->styles[i]);
+      }
+    }
+  }
+  msFree(class->styles);
+
+  for (i = 0; i < class->numlabels; i++) { /* each label */
+    if (class->labels[i] != NULL) {
+      if (freeLabel(class->labels[i]) == MS_SUCCESS) {
+        msFree(class->labels[i]);
+      }
+    }
+  }
+  msFree(class->labels);
+
+  msFree(class->keyimage);
+
+  if (class->leader) {
+    freeLabelLeader(class->leader);
+    msFree(class->leader);
+    class->leader = NULL;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Ensure there is at least one free entry in the sttyles array of this
+** classObj. Grow the allocated styles array if necessary and allocate
+** a new style for styles[numstyles] if there is not already one,
+** setting its contents to all zero bytes (i.e. does not call initStyle()
+** on it).
+**
+** This function is safe to use for the initial allocation of the styles[]
+** array as well (i.e. when maxstyles==0 and styles==NULL)
+**
+** Returns a reference to the new styleObj on success, NULL on error.
+*/
+styleObj *msGrowClassStyles(classObj *class) {
+  /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
+   */
+  if (class->numstyles == class->maxstyles) {
+    styleObj **newStylePtr;
+    int i, newsize;
+
+    newsize = class->maxstyles + MS_STYLE_ALLOCSIZE;
+
+    /* Alloc/realloc styles */
+    newStylePtr =
+        (styleObj **)realloc(class->styles, newsize * sizeof(styleObj *));
+    MS_CHECK_ALLOC(newStylePtr, newsize * sizeof(styleObj *), NULL);
+
+    class->styles = newStylePtr;
+    class->maxstyles = newsize;
+    for (i = class->numstyles; i < class->maxstyles; i++) {
+      class->styles[i] = NULL;
+    }
+  }
+
+  if (class->styles[class->numstyles] == NULL) {
+    class->styles[class->numstyles] = (styleObj *)calloc(1, sizeof(styleObj));
+    MS_CHECK_ALLOC(class->styles[class->numstyles], sizeof(styleObj), NULL);
+  }
+
+  return class->styles[class->numstyles];
+}
+
+/* exactly the same as for a classObj */
+styleObj *msGrowLabelStyles(labelObj *label) {
+  /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
+   */
+  if (label->numstyles == label->maxstyles) {
+    styleObj **newStylePtr;
+    int i, newsize;
+
+    newsize = label->maxstyles + MS_STYLE_ALLOCSIZE;
+
+    /* Alloc/realloc styles */
+    newStylePtr =
+        (styleObj **)realloc(label->styles, newsize * sizeof(styleObj *));
+    MS_CHECK_ALLOC(newStylePtr, newsize * sizeof(styleObj *), NULL);
+
+    label->styles = newStylePtr;
+    label->maxstyles = newsize;
+    for (i = label->numstyles; i < label->maxstyles; i++) {
+      label->styles[i] = NULL;
+    }
+  }
+
+  if (label->styles[label->numstyles] == NULL) {
+    label->styles[label->numstyles] = (styleObj *)calloc(1, sizeof(styleObj));
+    MS_CHECK_ALLOC(label->styles[label->numstyles], sizeof(styleObj), NULL);
+  }
+
+  return label->styles[label->numstyles];
+}
+
+/* exactly the same as for a labelLeaderObj, needs refactoring */
+styleObj *msGrowLeaderStyles(labelLeaderObj *leader) {
+  /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
+   */
+  if (leader->numstyles == leader->maxstyles) {
+    styleObj **newStylePtr;
+    int i, newsize;
+
+    newsize = leader->maxstyles + MS_STYLE_ALLOCSIZE;
+
+    /* Alloc/realloc styles */
+    newStylePtr =
+        (styleObj **)realloc(leader->styles, newsize * sizeof(styleObj *));
+    MS_CHECK_ALLOC(newStylePtr, newsize * sizeof(styleObj *), NULL);
+
+    leader->styles = newStylePtr;
+    leader->maxstyles = newsize;
+    for (i = leader->numstyles; i < leader->maxstyles; i++) {
+      leader->styles[i] = NULL;
+    }
+  }
+
+  if (leader->styles[leader->numstyles] == NULL) {
+    leader->styles[leader->numstyles] = (styleObj *)calloc(1, sizeof(styleObj));
+    MS_CHECK_ALLOC(leader->styles[leader->numstyles], sizeof(styleObj), NULL);
+  }
+
+  return leader->styles[leader->numstyles];
+}
+
+/* msMaybeAllocateClassStyle()
+**
+** Ensure that requested style index exists and has been initialized.
+**
+** Returns MS_SUCCESS/MS_FAILURE.
+*/
+int msMaybeAllocateClassStyle(classObj *c, int idx) {
+  if (c == NULL)
+    return MS_FAILURE;
+
+  if (idx < 0) {
+    msSetError(MS_MISCERR, "Invalid style index: %d",
+               "msMaybeAllocateClassStyle()", idx);
+    return MS_FAILURE;
+  }
+
+  /* Alloc empty styles as needed up to idx.
+   * Nothing to do if requested style already exists
+   */
+  while (c->numstyles <= idx) {
+    if (msGrowClassStyles(c) == NULL)
+      return MS_FAILURE;
+
+    if (initStyle(c->styles[c->numstyles]) == MS_FAILURE) {
+      msSetError(MS_MISCERR, "Failed to init new styleObj",
+                 "msMaybeAllocateClassStyle()");
+      freeStyle(c->styles[c->numstyles]);
+      free(c->styles[c->numstyles]);
+      c->styles[c->numstyles] = NULL;
+      return (MS_FAILURE);
+    }
+    c->numstyles++;
+  }
+  return MS_SUCCESS;
+}
+
+/*
+ * Reset style info in the class to defaults
+ * the only members we don't touch are name, expression, and join/query stuff
+ * This is used with STYLEITEM before overwriting the contents of a class.
+ */
+void resetClassStyle(classObj *class) {
+  int i;
+
+  /* reset labels */
+  for (i = 0; i < class->numlabels; i++) {
+    if (class->labels[i] != NULL) {
+      if (freeLabel(class->labels[i]) == MS_SUCCESS) {
+        msFree(class->labels[i]);
+      }
+      class->labels[i] = NULL;
+    }
+  }
+  class->numlabels = 0;
+
+  msFreeExpression(&(class->text));
+  msInitExpression(&(class->text));
+
+  /* reset styles */
+  for (i = 0; i < class->numstyles; i++) {
+    if (class->styles[i] != NULL) {
+      if (freeStyle(class->styles[i]) == MS_SUCCESS) {
+        msFree(class->styles[i]);
+      }
+      class->styles[i] = NULL;
+    }
+  }
+  class->numstyles = 0;
+
+  class->layer = NULL;
+}
+
+labelObj *msGrowClassLabels(classObj *class) {
+
+  /* Do we need to increase the size of labels[] by MS_LABEL_ALLOCSIZE?
+   */
+  if (class->numlabels == class->maxlabels) {
+    labelObj **newLabelPtr;
+    int i, newsize;
+
+    newsize = class->maxlabels + MS_LABEL_ALLOCSIZE;
+
+    /* Alloc/realloc labels */
+    newLabelPtr =
+        (labelObj **)realloc(class->labels, newsize * sizeof(labelObj *));
+    MS_CHECK_ALLOC(newLabelPtr, newsize * sizeof(labelObj *), NULL);
+
+    class->labels = newLabelPtr;
+    class->maxlabels = newsize;
+    for (i = class->numlabels; i < class->maxlabels; i++) {
+      class->labels[i] = NULL;
+    }
+  }
+
+  if (class->labels[class->numlabels] == NULL) {
+    class->labels[class->numlabels] = (labelObj *)calloc(1, sizeof(labelObj));
+    MS_CHECK_ALLOC(class->labels[class->numlabels], sizeof(labelObj), NULL);
+  }
+
+  return class->labels[class->numlabels];
+}
+
+int loadClass(classObj *class, layerObj *layer) {
+  if (!class || !layer)
+    return (-1);
+
+  class->layer = (layerObj *)layer;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (CLASS):
+      break; /* for string loads */
+    case (DEBUG):
+      if ((class->debug = getSymbol(3, MS_ON, MS_OFF, MS_NUMBER)) == -1)
+        return (-1);
+      if (class->debug == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid DEBUG level, must be between 0 and 5 (line %d)",
+                     "loadClass()", msyylineno);
+          return (-1);
+        }
+        class->debug = (int)msyynumber;
+      }
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadClass()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (EXPRESSION):
+      if (loadExpression(&(class->expression)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (GROUP):
+      if (getString(&class->group) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (KEYIMAGE):
+      if (getString(&class->keyimage) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (LABEL):
+      if (msGrowClassLabels(class) == NULL)
+        return (-1);
+      initLabel(class->labels[class->numlabels]);
+      class->labels[class->numlabels]->size =
+          MS_MEDIUM; /* only set a default if the LABEL section is present */
+      if (loadLabel(class->labels[class->numlabels]) == -1) {
+        freeLabel(class->labels[class->numlabels]);
+        free(class->labels[class->numlabels]);
+        class->labels[class->numlabels] = NULL;
+        return (-1);
+      }
+      class->numlabels++;
+      break;
+    case (LEADER):
+      if (!class->leader) {
+        class->leader = msSmallMalloc(sizeof(labelLeaderObj));
+        initLeader(class->leader);
+      }
+      if (loadLeader(class->leader) == -1)
+        return (-1);
+      break;
+    case (MAXSCALE):
+    case (MAXSCALEDENOM):
+      if (getDouble(&(class->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (METADATA):
+      if (loadHashTable(&(class->metadata)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MINSCALE):
+    case (MINSCALEDENOM):
+      if (getDouble(&(class->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINFEATURESIZE):
+      if (getInteger(&(class->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (NAME):
+      if (getString(&class->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((class->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (STYLE):
+      if (msGrowClassStyles(class) == NULL)
+        return (-1);
+      initStyle(class->styles[class->numstyles]);
+      if (loadStyle(class->styles[class->numstyles]) != MS_SUCCESS) {
+        freeStyle(class->styles[class->numstyles]);
+        free(class->styles[class->numstyles]);
+        class->styles[class->numstyles] = NULL;
+        return (-1);
+      }
+      class->numstyles++;
+      break;
+    case (TEMPLATE):
+      if (getString(&class->template) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TEXT):
+      if (loadExpression(&(class->text)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      if ((class->text.type != MS_STRING) &&
+          (class->text.type != MS_EXPRESSION)) {
+        msSetError(
+            MS_MISCERR,
+            "Text expressions support constant or tagged replacement strings.",
+            "loadClass()");
+        return (-1);
+      }
+      break;
+    case (TITLE):
+      if (getString(&class->title) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (VALIDATION):
+      if (loadHashTable(&(class->validation)) != MS_SUCCESS)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadClass()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  }
+}
+
+static int classResolveSymbolNames(classObj *class) {
+  int i, j;
+  int try_addimage_if_notfound = MS_TRUE;
+
+  /* step through styles and labels to resolve symbol names */
+  /* class styles */
+  for (i = 0; i < class->numstyles; i++) {
+    if (class->styles[i]->symbolname) {
+      if ((class->styles[i]->symbol = msGetSymbolIndex(
+               &(class->layer->map->symbolset), class->styles[i]->symbolname,
+               try_addimage_if_notfound)) == -1) {
+        msSetError(MS_MISCERR,
+                   "Undefined symbol \"%s\" in class, style %d of layer %s.",
+                   "classResolveSymbolNames()", class->styles[i]->symbolname, i,
+                   class->layer->name);
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  /* label styles */
+  for (i = 0; i < class->numlabels; i++) {
+    for (j = 0; j < class->labels[i]->numstyles; j++) {
+      if (class->labels[i]->styles[j]->symbolname) {
+        if ((class->labels[i]->styles[j]->symbol =
+                 msGetSymbolIndex(&(class->layer->map->symbolset),
+                                  class->labels[i]->styles[j]->symbolname,
+                                  try_addimage_if_notfound)) == -1) {
+          msSetError(
+              MS_MISCERR,
+              "Undefined symbol \"%s\" in class, label style %d of layer %s.",
+              "classResolveSymbolNames()",
+              class->labels[i]->styles[j]->symbolname, j, class->layer->name);
+          return MS_FAILURE;
+        }
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+int msUpdateClassFromString(classObj *class, char *string) {
+  if (!class || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadClass(class, class->layer) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+
+  if (classResolveSymbolNames(class) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+static void writeClass(FILE *stream, int indent, classObj *class) {
+  int i;
+
+  if (class->status == MS_DELETE)
+    return;
+
+  indent++;
+  writeBlockBegin(stream, indent, "CLASS");
+  writeString(stream, indent, "NAME", NULL, class->name);
+  writeString(stream, indent, "GROUP", NULL, class->group);
+  writeNumber(stream, indent, "DEBUG", 0, class->debug);
+  writeExpression(stream, indent, "EXPRESSION", &(class->expression));
+  writeString(stream, indent, "KEYIMAGE", NULL, class->keyimage);
+  for (i = 0; i < class->numlabels; i++)
+    writeLabel(stream, indent, class->labels[i]);
+  if (class->leader)
+    writeLeader(stream, indent, class->leader);
+  writeNumber(stream, indent, "MAXSCALEDENOM", -1, class->maxscaledenom);
+  writeHashTable(stream, indent, "METADATA", &(class->metadata));
+  writeNumber(stream, indent, "MINSCALEDENOM", -1, class->minscaledenom);
+  writeNumber(stream, indent, "MINFEATURESIZE", -1, class->minfeaturesize);
+  writeKeyword(stream, indent, "STATUS", class->status, 1, MS_OFF, "OFF");
+  for (i = 0; i < class->numstyles; i++)
+    writeStyle(stream, indent, class->styles[i]);
+  writeString(stream, indent, "TEMPLATE", NULL, class->template);
+  writeExpression(stream, indent, "TEXT", &(class->text));
+  writeString(stream, indent, "TITLE", NULL, class->title);
+  writeHashTable(stream, indent, "VALIDATION", &(class->validation));
+  writeBlockEnd(stream, indent, "CLASS");
+}
+
+char *msWriteClassToString(classObj *class) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeClass(stdout, -1, class);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+int initCompositingFilter(CompositingFilter *filter) {
+  filter->filter = NULL;
+  filter->next = NULL;
+  return MS_SUCCESS;
+}
+
+void freeCompositingFilter(CompositingFilter *filter) {
+  if (!filter)
+    return;
+  if (filter->next)
+    freeCompositingFilter(filter->next);
+  free(filter->filter);
+  free(filter);
+}
+
+int initLayerCompositer(LayerCompositer *compositer) {
+  compositer->comp_op = MS_COMPOP_SRC_OVER;
+  compositer->opacity = 100;
+  compositer->next = NULL;
+  compositer->filter = NULL;
+  return MS_SUCCESS;
+}
+
+void freeLayerCompositer(LayerCompositer *compositer) {
+  if (!compositer)
+    return;
+  if (compositer->next)
+    freeLayerCompositer(compositer->next);
+  freeCompositingFilter(compositer->filter);
+  free(compositer);
+}
+
+/*
+** Initialize, load and free a single layer structure
+*/
+int initLayer(layerObj *layer, mapObj *map) {
+  if (layer == NULL) {
+    msSetError(MS_MEMERR, "Layer is null", "initLayer()");
+    return (-1);
+  }
+  layer->debug = (int)msGetGlobalDebugLevel();
+  MS_REFCNT_INIT(layer);
+
+  /* Set maxclasses = 0, class[] will be allocated as needed on first call
+   * to msGrowLayerClasses()
+   */
+  layer->numclasses = 0;
+  layer->maxclasses = 0;
+  layer->class = NULL;
+
+  layer->name = NULL;
+  layer->group = NULL;
+  layer->status = MS_OFF;
+  layer->data = NULL;
+  layer->rendermode = MS_FIRST_MATCHING_CLASS;
+
+  layer->map = map; /* point back to the encompassing structure */
+
+  layer->type = -1;
+
+  layer->toleranceunits = MS_PIXELS;
+  layer->tolerance =
+      -1; /* perhaps this should have a different value based on type */
+
+  layer->symbolscaledenom = -1.0; /* -1 means nothing is set */
+  layer->scalefactor = 1.0;
+  layer->maxscaledenom = -1.0;
+  layer->minscaledenom = -1.0;
+  layer->minfeaturesize = -1; /* no limit */
+  layer->maxgeowidth = -1.0;
+  layer->mingeowidth = -1.0;
+
+  layer->sizeunits = MS_PIXELS;
+
+  layer->maxfeatures = -1; /* no quota */
+  layer->startindex = -1;  /*used for pagination*/
+
+  layer->scaletokens = NULL;
+  layer->numscaletokens = 0;
+
+  layer->template = layer->header = layer->footer = NULL;
+
+  layer->transform = MS_TRUE;
+
+  layer->classitem = NULL;
+  layer->classitemindex = -1;
+
+  layer->units = MS_METERS;
+  if (msInitProjection(&(layer->projection)) == -1)
+    return (-1);
+
+  if (map) {
+    msProjectionInheritContextFrom(&(layer->projection), &(map->projection));
+  }
+
+  layer->project = MS_TRUE;
+  layer->reprojectorLayerToMap = NULL;
+  layer->reprojectorMapToLayer = NULL;
+
+  initCluster(&layer->cluster);
+
+  MS_INIT_COLOR(layer->offsite, -1, -1, -1, 255);
+
+  layer->labelcache = MS_ON;
+  layer->postlabelcache = MS_FALSE;
+
+  layer->labelitem = NULL;
+  layer->labelitemindex = -1;
+
+  layer->labelmaxscaledenom = -1;
+  layer->labelminscaledenom = -1;
+
+  layer->tileitem = msStrdup("location");
+  layer->tileitemindex = -1;
+  layer->tileindex = NULL;
+  layer->tilesrs = NULL;
+
+  layer->bandsitem = NULL;
+  layer->bandsitemindex = -1;
+
+  layer->currentfeature = layer->features = NULL;
+
+  layer->connection = NULL;
+  layer->plugin_library = NULL;
+  layer->plugin_library_original = NULL;
+  layer->connectiontype = MS_SHAPEFILE;
+  layer->vtable = NULL;
+  layer->classgroup = NULL;
+
+  layer->layerinfo = NULL;
+  layer->wfslayerinfo = NULL;
+
+  layer->items = NULL;
+  layer->iteminfo = NULL;
+  layer->numitems = 0;
+
+  layer->resultcache = NULL;
+
+  msInitExpression(&(layer->filter));
+  layer->filteritem = NULL;
+  layer->filteritemindex = -1;
+
+  layer->
+    requires
+  = layer->labelrequires = NULL;
+
+  initHashTable(&(layer->metadata));
+  initHashTable(&(layer->bindvals));
+  initHashTable(&(layer->validation));
+
+  layer->styleitem = NULL;
+  layer->styleitemindex = -1;
+
+  layer->numprocessing = 0;
+  layer->processing = NULL;
+  layer->numjoins = 0;
+  layer->joins = (joinObj *)malloc(MS_MAXJOINS * sizeof(joinObj));
+  MS_CHECK_ALLOC(layer->joins, MS_MAXJOINS * sizeof(joinObj), -1);
+
+  layer->extent.minx = -1.0;
+  layer->extent.miny = -1.0;
+  layer->extent.maxx = -1.0;
+  layer->extent.maxy = -1.0;
+
+  layer->mask = NULL;
+  layer->maskimage = NULL;
+  layer->grid = NULL;
+
+  msInitExpression(&(layer->_geomtransform));
+  layer->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
+
+  msInitExpression(&(layer->utfdata));
+  layer->utfitem = NULL;
+  layer->utfitemindex = -1;
+
+  layer->encoding = NULL;
+
+  layer->sortBy.nProperties = 0;
+  layer->sortBy.properties = NULL;
+  layer->orig_st = NULL;
+
+  layer->compositer = NULL;
+
+  initHashTable(&(layer->connectionoptions));
+
+  return (0);
+}
+
+int initScaleToken(scaleTokenObj *token) {
+  token->n_entries = 0;
+  token->name = NULL;
+  token->tokens = NULL;
+  return MS_SUCCESS;
+}
+
+int freeScaleTokenEntry(scaleTokenEntryObj *token) {
+  msFree(token->value);
+  return MS_SUCCESS;
+}
+
+int freeScaleToken(scaleTokenObj *scaletoken) {
+  int i;
+  msFree(scaletoken->name);
+  for (i = 0; i < scaletoken->n_entries; i++) {
+    freeScaleTokenEntry(&scaletoken->tokens[i]);
+  }
+  msFree(scaletoken->tokens);
+  return MS_SUCCESS;
+}
+
+int freeLayer(layerObj *layer) {
+  int i;
+  if (!layer)
+    return MS_FAILURE;
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(layer)) {
+    return MS_FAILURE;
+  }
+
+  if (layer->debug >= MS_DEBUGLEVEL_VVV)
+    msDebug("freeLayer(): freeing layer at %p.\n", layer);
+
+  if (msLayerIsOpen(layer))
+    msLayerClose(layer);
+
+  msFree(layer->name);
+  msFree(layer->encoding);
+  msFree(layer->group);
+  msFree(layer->data);
+  msFree(layer->classitem);
+  msFree(layer->labelitem);
+  msFree(layer->header);
+  msFree(layer->footer);
+  msFree(layer->template);
+  msFree(layer->tileindex);
+  msFree(layer->tileitem);
+  msFree(layer->tilesrs);
+  msFree(layer->bandsitem);
+  msFree(layer->plugin_library);
+  msFree(layer->plugin_library_original);
+  msFree(layer->connection);
+  msFree(layer->vtable);
+  msFree(layer->classgroup);
+
+  msProjectDestroyReprojector(layer->reprojectorLayerToMap);
+  msProjectDestroyReprojector(layer->reprojectorMapToLayer);
+  msFreeProjection(&(layer->projection));
+  msFreeExpression(&layer->_geomtransform);
+
+  freeCluster(&layer->cluster);
+
+  for (i = 0; i < layer->maxclasses; i++) {
+    if (layer->class[i] != NULL) {
+      layer->class[i]->layer = NULL;
+      if (freeClass(layer->class[i]) == MS_SUCCESS) {
+        msFree(layer->class[i]);
+      }
+    }
+  }
+  msFree(layer->class);
+
+  if (layer->numscaletokens > 0) {
+    for (i = 0; i < layer->numscaletokens; i++) {
+      freeScaleToken(&layer->scaletokens[i]);
+    }
+    msFree(layer->scaletokens);
+  }
+
+  if (layer->features)
+    freeFeatureList(layer->features);
+
+  if (layer->resultcache) {
+    cleanupResultCache(layer->resultcache);
+    msFree(layer->resultcache);
+  }
+
+  msFree(layer->styleitem);
+
+  msFree(layer->filteritem);
+  msFreeExpression(&(layer->filter));
+
+  msFree(layer->requires);
+  msFree(layer->labelrequires);
+
+  msFreeHashItems(&(layer->metadata));
+  msFreeHashItems(&(layer->validation));
+  msFreeHashItems(&layer->bindvals);
+
+  if (layer->numprocessing > 0)
+    msFreeCharArray(layer->processing, layer->numprocessing);
+
+  for (i = 0; i < layer->numjoins; i++) /* each join */
+    freeJoin(&(layer->joins[i]));
+  msFree(layer->joins);
+  layer->numjoins = 0;
+
+  layer->classgroup = NULL;
+
+  msFree(layer->mask);
+  if (layer->maskimage) {
+    msFreeImage(layer->maskimage);
+  }
+
+  if (layer->compositer) {
+    freeLayerCompositer(layer->compositer);
+  }
+
+  if (layer->grid) {
+    freeGrid(layer->grid);
+    msFree(layer->grid);
+  }
+
+  msFreeExpression(&(layer->utfdata));
+  msFree(layer->utfitem);
+
+  for (i = 0; i < layer->sortBy.nProperties; i++)
+    msFree(layer->sortBy.properties[i].item);
+  msFree(layer->sortBy.properties);
+
+  msFreeHashItems(&layer->connectionoptions);
+
+  return MS_SUCCESS;
+}
+
+/*
+** Ensure there is at least one free entry in the class array of this
+** layerObj. Grow the allocated class array if necessary and allocate
+** a new class for class[numclasses] if there is not already one,
+** setting its contents to all zero bytes (i.e. does not call initClass()
+** on it).
+**
+** This function is safe to use for the initial allocation of the class[]
+** array as well (i.e. when maxclasses==0 and class==NULL)
+**
+** Returns a reference to the new classObj on success, NULL on error.
+*/
+classObj *msGrowLayerClasses(layerObj *layer) {
+  /* Do we need to increase the size of class[] by  MS_CLASS_ALLOCSIZE?
+   */
+  if (layer->numclasses == layer->maxclasses) {
+    classObj **newClassPtr;
+    int i, newsize;
+
+    newsize = layer->maxclasses + MS_CLASS_ALLOCSIZE;
+
+    /* Alloc/realloc classes */
+    newClassPtr =
+        (classObj **)realloc(layer->class, newsize * sizeof(classObj *));
+    MS_CHECK_ALLOC(newClassPtr, newsize * sizeof(classObj *), NULL);
+
+    layer->class = newClassPtr;
+    layer->maxclasses = newsize;
+    for (i = layer->numclasses; i < layer->maxclasses; i++) {
+      layer->class[i] = NULL;
+    }
+  }
+
+  if (layer->class[layer->numclasses] == NULL) {
+    layer->class[layer->numclasses] = (classObj *)calloc(1, sizeof(classObj));
+    MS_CHECK_ALLOC(layer->class[layer->numclasses], sizeof(classObj), NULL);
+  }
+
+  return layer->class[layer->numclasses];
+}
+
+scaleTokenObj *msGrowLayerScaletokens(layerObj *layer) {
+  layer->scaletokens = msSmallRealloc(
+      layer->scaletokens, (layer->numscaletokens + 1) * sizeof(scaleTokenObj));
+  memset(&layer->scaletokens[layer->numscaletokens], 0, sizeof(scaleTokenObj));
+  return &layer->scaletokens[layer->numscaletokens];
+}
+
+int loadScaletoken(scaleTokenObj *token, layerObj *layer) {
+  (void)layer;
+  for (;;) {
+    int stop = 0;
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadScaletoken()");
+      return (MS_FAILURE);
+    case (NAME):
+      if (getString(&token->name) == MS_FAILURE)
+        return (MS_FAILURE);
+      break;
+    case (VALUES):
+      for (;;) {
+        if (stop)
+          break;
+        switch (msyylex()) {
+        case (EOF):
+          msSetError(MS_EOFERR, NULL, "loadScaletoken()");
+          return (MS_FAILURE);
+        case (END):
+          stop = 1;
+          if (token->n_entries == 0) {
+            msSetError(MS_PARSEERR,
+                       "Scaletoken (line:%d) has no VALUES defined",
+                       "loadScaleToken()", msyylineno);
+            return (MS_FAILURE);
+          }
+          token->tokens[token->n_entries - 1].maxscale = DBL_MAX;
+          break;
+        case (MS_STRING):
+          /* we have a key */
+          token->tokens =
+              msSmallRealloc(token->tokens, (token->n_entries + 1) *
+                                                sizeof(scaleTokenEntryObj));
+
+          if (1 != sscanf(msyystring_buffer, "%lf",
+                          &token->tokens[token->n_entries].minscale)) {
+            msSetError(MS_PARSEERR,
+                       "failed to parse SCALETOKEN VALUE (%s):(line %d), "
+                       "expecting \"minscale\"",
+                       "loadScaletoken()", msyystring_buffer, msyylineno);
+            return (MS_FAILURE);
+          }
+          if (token->n_entries == 0) {
+            /* check supplied value was 0*/
+            if (token->tokens[0].minscale != 0) {
+              msSetError(MS_PARSEERR,
+                         "First SCALETOKEN VALUE (%s):(line %d) must be zero, "
+                         "expecting \"0\"",
+                         "loadScaletoken()", msyystring_buffer, msyylineno);
+              return (MS_FAILURE);
+            }
+          } else {
+            /* set max scale of previous token */
+            token->tokens[token->n_entries - 1].maxscale =
+                token->tokens[token->n_entries].minscale;
+          }
+          token->tokens[token->n_entries].value = NULL;
+          if (getString(&(token->tokens[token->n_entries].value)) == MS_FAILURE)
+            return (MS_FAILURE);
+          token->n_entries++;
+          break;
+        default:
+          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                     "loadScaletoken()", msyystring_buffer, msyylineno);
+          return (MS_FAILURE);
+        }
+      }
+      break;
+    case (END):
+      if (!token->name || !*(token->name)) {
+        msSetError(MS_PARSEERR,
+                   "ScaleToken missing mandatory NAME entry (line %d)",
+                   "loadScaleToken()", msyylineno);
+        return MS_FAILURE;
+      }
+      if (token->n_entries == 0) {
+        msSetError(MS_PARSEERR,
+                   "ScaleToken missing at least one VALUES entry (line %d)",
+                   "loadScaleToken()", msyylineno);
+        return MS_FAILURE;
+      }
+      return MS_SUCCESS;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)",
+                 "loadScaletoken()", msyystring_buffer, msyylineno);
+      return (MS_FAILURE);
+    }
+  } /* next token*/
+}
+
+int loadLayerCompositer(LayerCompositer *compositer) {
+  for (;;) {
+    switch (msyylex()) {
+    case COMPFILTER: {
+      CompositingFilter **filter = &compositer->filter;
+      while (*filter) {
+        filter = &((*filter)->next);
+      }
+      *filter = msSmallMalloc(sizeof(CompositingFilter));
+      initCompositingFilter(*filter);
+      if (getString(&((*filter)->filter)) == MS_FAILURE)
+        return (MS_FAILURE);
+    } break;
+    case COMPOP: {
+      char *compop = NULL;
+      if (getString(&compop) == MS_FAILURE)
+        return (MS_FAILURE);
+      else if (!strcmp(compop, "clear"))
+        compositer->comp_op = MS_COMPOP_CLEAR;
+      else if (!strcmp(compop, "color-burn"))
+        compositer->comp_op = MS_COMPOP_COLOR_BURN;
+      else if (!strcmp(compop, "color-dodge"))
+        compositer->comp_op = MS_COMPOP_COLOR_DODGE;
+      else if (!strcmp(compop, "contrast"))
+        compositer->comp_op = MS_COMPOP_CONTRAST;
+      else if (!strcmp(compop, "darken"))
+        compositer->comp_op = MS_COMPOP_DARKEN;
+      else if (!strcmp(compop, "difference"))
+        compositer->comp_op = MS_COMPOP_DIFFERENCE;
+      else if (!strcmp(compop, "dst"))
+        compositer->comp_op = MS_COMPOP_DST;
+      else if (!strcmp(compop, "dst-atop"))
+        compositer->comp_op = MS_COMPOP_DST_ATOP;
+      else if (!strcmp(compop, "dst-in"))
+        compositer->comp_op = MS_COMPOP_DST_IN;
+      else if (!strcmp(compop, "dst-out"))
+        compositer->comp_op = MS_COMPOP_DST_OUT;
+      else if (!strcmp(compop, "dst-over"))
+        compositer->comp_op = MS_COMPOP_DST_OVER;
+      else if (!strcmp(compop, "exclusion"))
+        compositer->comp_op = MS_COMPOP_EXCLUSION;
+      else if (!strcmp(compop, "hard-light"))
+        compositer->comp_op = MS_COMPOP_HARD_LIGHT;
+      else if (!strcmp(compop, "invert"))
+        compositer->comp_op = MS_COMPOP_INVERT;
+      else if (!strcmp(compop, "invert-rgb"))
+        compositer->comp_op = MS_COMPOP_INVERT_RGB;
+      else if (!strcmp(compop, "lighten"))
+        compositer->comp_op = MS_COMPOP_LIGHTEN;
+      else if (!strcmp(compop, "minus"))
+        compositer->comp_op = MS_COMPOP_MINUS;
+      else if (!strcmp(compop, "multiply"))
+        compositer->comp_op = MS_COMPOP_MULTIPLY;
+      else if (!strcmp(compop, "overlay"))
+        compositer->comp_op = MS_COMPOP_OVERLAY;
+      else if (!strcmp(compop, "plus"))
+        compositer->comp_op = MS_COMPOP_PLUS;
+      else if (!strcmp(compop, "screen"))
+        compositer->comp_op = MS_COMPOP_SCREEN;
+      else if (!strcmp(compop, "soft-light"))
+        compositer->comp_op = MS_COMPOP_SOFT_LIGHT;
+      else if (!strcmp(compop, "src"))
+        compositer->comp_op = MS_COMPOP_SRC;
+      else if (!strcmp(compop, "src-atop"))
+        compositer->comp_op = MS_COMPOP_SRC_ATOP;
+      else if (!strcmp(compop, "src-in"))
+        compositer->comp_op = MS_COMPOP_SRC_IN;
+      else if (!strcmp(compop, "src-out"))
+        compositer->comp_op = MS_COMPOP_SRC_OUT;
+      else if (!strcmp(compop, "src-over"))
+        compositer->comp_op = MS_COMPOP_SRC_OVER;
+      else if (!strcmp(compop, "xor"))
+        compositer->comp_op = MS_COMPOP_XOR;
+      else {
+        msSetError(MS_PARSEERR, "Unknown COMPOP \"%s\"",
+                   "loadLayerCompositer()", compop);
+        free(compop);
+        return MS_FAILURE;
+      }
+      free(compop);
+    } break;
+    case END:
+      return MS_SUCCESS;
+    case OPACITY:
+      if (getInteger(&(compositer->opacity), MS_NUM_CHECK_RANGE, 0, 100) ==
+          -1) {
+        msSetError(MS_PARSEERR, "OPACITY must be between 0 and 100 (line %d)",
+                   "loadLayerCompositer()", msyylineno);
+        return MS_FAILURE;
+      }
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)",
+                 "loadLayerCompositer()", msyystring_buffer, msyylineno);
+      return (MS_FAILURE);
+    }
+  }
+}
+int loadLayer(layerObj *layer, mapObj *map) {
+  int type;
+
+  layer->map = (mapObj *)map;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (BINDVALS):
+      if (loadHashTable(&(layer->bindvals)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (CLASS):
+      if (msGrowLayerClasses(layer) == NULL)
+        return (-1);
+      initClass(layer->class[layer->numclasses]);
+      if (loadClass(layer->class[layer->numclasses], layer) == -1) {
+        freeClass(layer->class[layer->numclasses]);
+        free(layer->class[layer->numclasses]);
+        layer->class[layer->numclasses] = NULL;
+        return (-1);
+      }
+      layer->numclasses++;
+      break;
+    case (CLUSTER):
+      if (loadCluster(&layer->cluster) == -1)
+        return (-1);
+      break;
+    case (CLASSGROUP):
+      if (getString(&layer->classgroup) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (CLASSITEM):
+      if (getString(&layer->classitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (COMPOSITE): {
+      LayerCompositer *compositer = msSmallMalloc(sizeof(LayerCompositer));
+      initLayerCompositer(compositer);
+      if (MS_FAILURE == loadLayerCompositer(compositer)) {
+        freeLayerCompositer(compositer);
+        return -1;
+      }
+      if (!layer->compositer) {
+        layer->compositer = compositer;
+      } else {
+        LayerCompositer *lctmp = layer->compositer;
+        while (lctmp->next)
+          lctmp = lctmp->next;
+        lctmp->next = compositer;
+      }
+      break;
+    }
+    case (CONNECTION):
+      if (getString(&layer->connection) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (CONNECTIONTYPE):
+      if ((type = getSymbol(13, MS_OGR, MS_POSTGIS, MS_WMS, MS_ORACLESPATIAL,
+                            MS_WFS, MS_GRATICULE, MS_PLUGIN, MS_UNION,
+                            MS_UVRASTER, MS_CONTOUR, MS_KERNELDENSITY, MS_IDW,
+                            MS_FLATGEOBUF)) == -1)
+        return (-1);
+      layer->connectiontype = type;
+      break;
+    case (DATA):
+      if (getString(&layer->data) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (DEBUG):
+      if ((layer->debug = getSymbol(3, MS_ON, MS_OFF, MS_NUMBER)) == -1)
+        return (-1);
+      if (layer->debug == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid DEBUG level, must be between 0 and 5 (line %d)",
+                     "loadLayer()", msyylineno);
+          return (-1);
+        }
+        layer->debug = (int)msyynumber;
+      }
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLayer()");
+      return (-1);
+      break;
+    case (ENCODING):
+      if (getString(&layer->encoding) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END):
+      if ((int)layer->type == -1) {
+        msSetError(MS_MISCERR, "Layer type not set.", "loadLayer()");
+        return (-1);
+      }
+
+      return (0);
+      break;
+    case (EXTENT): {
+      if (getDouble(&(layer->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(layer->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(layer->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(layer->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (!MS_VALID_EXTENT(layer->extent)) {
+        msSetError(MS_MISCERR,
+                   "Given layer extent is invalid. Check that it is in the "
+                   "form: minx, miny, maxx, maxy",
+                   "loadLayer()");
+        return (-1);
+      }
+      break;
+    }
+    case (FEATURE):
+      if ((int)layer->type == -1) {
+        msSetError(MS_MISCERR,
+                   "Layer type must be set before defining inline features.",
+                   "loadLayer()");
+        return (-1);
+      }
+
+      if (layer->type == MS_LAYER_POLYGON)
+        type = MS_SHAPE_POLYGON;
+      else if (layer->type == MS_LAYER_LINE)
+        type = MS_SHAPE_LINE;
+      else
+        type = MS_SHAPE_POINT;
+
+      layer->connectiontype = MS_INLINE;
+
+      if (loadFeature(layer, type) == MS_FAILURE)
+        return (-1);
+      break;
+    case (FILTER):
+      if (loadExpression(&(layer->filter)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (FILTERITEM):
+      if (getString(&layer->filteritem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (FOOTER):
+      if (getString(&layer->footer) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (GRID):
+      layer->connectiontype = MS_GRATICULE;
+      if (layer->grid) {
+        freeGrid(layer->grid);
+        msFree(layer->grid);
+      }
+      layer->grid = (void *)malloc(sizeof(graticuleObj));
+      MS_CHECK_ALLOC(layer->grid, sizeof(graticuleObj), -1);
+
+      initGrid(layer->grid);
+      loadGrid(layer);
+      break;
+    case (GROUP):
+      if (getString(&layer->group) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (GEOMTRANSFORM): {
+      if (getSymbol(1, MS_EXPRESSION) == -1)
+        return (MS_FAILURE);
+      /* handle expression case here for the moment */
+      msFree(layer->_geomtransform.string);
+      layer->_geomtransform.string = msStrdup(msyystring_buffer);
+      layer->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
+    } break;
+    case (HEADER):
+      if (getString(&layer->header) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (JOIN):
+      if (layer->numjoins == MS_MAXJOINS) { /* no room */
+        msSetError(MS_IDENTERR, "Maximum number of joins reached.",
+                   "loadLayer()");
+        return (-1);
+      }
+
+      if (loadJoin(&(layer->joins[layer->numjoins])) == -1) {
+        freeJoin(&(layer->joins[layer->numjoins]));
+        return (-1);
+      }
+      layer->numjoins++;
+      break;
+    case (LABELCACHE):
+      if ((layer->labelcache = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (LABELITEM):
+      if (getString(&layer->labelitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (LABELMAXSCALE):
+    case (LABELMAXSCALEDENOM):
+      if (getDouble(&(layer->labelmaxscaledenom), MS_NUM_CHECK_GTE, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (LABELMINSCALE):
+    case (LABELMINSCALEDENOM):
+      if (getDouble(&(layer->labelminscaledenom), MS_NUM_CHECK_GTE, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (LABELREQUIRES):
+      if (getString(&layer->labelrequires) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (LAYER):
+      break; /* for string loads */
+    case (MASK):
+      if (getString(&layer->mask) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (MAXFEATURES):
+      if (getInteger(&(layer->maxfeatures), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXSCALE):
+    case (MAXSCALEDENOM):
+      if (getDouble(&(layer->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXGEOWIDTH):
+      if (getDouble(&(layer->maxgeowidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (METADATA):
+      if (loadHashTable(&(layer->metadata)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MINSCALE):
+    case (MINSCALEDENOM):
+      if (getDouble(&(layer->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINGEOWIDTH):
+      if (getDouble(&(layer->mingeowidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINFEATURESIZE):
+      if (getInteger(&(layer->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (NAME):
+      if (getString(&layer->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (OFFSITE):
+      if (loadColor(&(layer->offsite), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+
+    case (CONNECTIONOPTIONS):
+      if (loadHashTable(&(layer->connectionoptions)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MS_PLUGIN): {
+      int rv;
+      if (map->config) { // value *must* represent a config key
+        char *value = NULL;
+        const char *plugin_library = NULL;
+
+        if (getString(&value) == MS_FAILURE)
+          return (-1);
+        plugin_library = msConfigGetPlugin(map->config, value);
+        msFree(value);
+        if (!plugin_library) {
+          msSetError(MS_MISCERR,
+                     "Plugin value not found in config file. See "
+                     "mapserver.org/mapfile/config.html for more information.",
+                     "loadLayer()");
+          return (-1);
+        }
+        msFree(layer->plugin_library_original);
+        layer->plugin_library_original = strdup(plugin_library);
+      } else {
+        if (getString(&layer->plugin_library_original) == MS_FAILURE)
+          return (-1);
+      }
+      rv = msBuildPluginLibraryPath(&layer->plugin_library,
+                                    layer->plugin_library_original, map);
+      if (rv == MS_FAILURE)
+        return (-1);
+    } break;
+    case (PROCESSING): {
+      /* NOTE: processing array maintained as size+1 with NULL terminator.
+               This ensure that CSL (GDAL string list) functions can be
+               used on the list for easy processing. */
+      char *value = NULL;
+      if (getString(&value) == MS_FAILURE)
+        return (-1);
+      msLayerAddProcessing(layer, value);
+      free(value);
+      value = NULL;
+    } break;
+    case (POSTLABELCACHE):
+      if ((layer->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      if (layer->postlabelcache)
+        layer->labelcache = MS_OFF;
+      break;
+    case (PROJECTION):
+      if (loadProjection(&(layer->projection)) == -1)
+        return (-1);
+      layer->project = MS_TRUE;
+      break;
+    case (REQUIRES):
+      if (getString(&layer->requires) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (SCALETOKEN):
+      if (msGrowLayerScaletokens(layer) == NULL)
+        return (-1);
+      initScaleToken(&layer->scaletokens[layer->numscaletokens]);
+      if (loadScaletoken(&layer->scaletokens[layer->numscaletokens], layer) ==
+          -1) {
+        freeScaleToken(&layer->scaletokens[layer->numscaletokens]);
+        return (-1);
+      }
+      layer->numscaletokens++;
+      break;
+    case (SIZEUNITS):
+      if ((layer->sizeunits = getSymbol(
+               8, MS_INCHES, MS_FEET, MS_MILES, MS_METERS, MS_KILOMETERS,
+               MS_NAUTICALMILES, MS_DD, MS_PIXELS)) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((layer->status = getSymbol(3, MS_ON, MS_OFF, MS_DEFAULT)) == -1)
+        return (-1);
+      break;
+    case (STYLEITEM):
+      if (getString(&layer->styleitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (SYMBOLSCALE):
+    case (SYMBOLSCALEDENOM):
+      if (getDouble(&(layer->symbolscaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&layer->template) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TILEINDEX):
+      if (getString(&layer->tileindex) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TILEITEM):
+      if (getString(&layer->tileitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TILESRS):
+      if (getString(&layer->tilesrs) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TOLERANCE):
+      if (getDouble(&(layer->tolerance), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (TOLERANCEUNITS):
+      if ((layer->toleranceunits = getSymbol(
+               8, MS_INCHES, MS_FEET, MS_MILES, MS_METERS, MS_KILOMETERS,
+               MS_NAUTICALMILES, MS_DD, MS_PIXELS)) == -1)
+        return (-1);
+      break;
+    case (TRANSFORM):
+      if ((layer->transform =
+               getSymbol(11, MS_TRUE, MS_FALSE, MS_UL, MS_UC, MS_UR, MS_CL,
+                         MS_CC, MS_CR, MS_LL, MS_LC, MS_LR)) == -1)
+        return (-1);
+      break;
+    case (TYPE):
+      if ((type =
+               getSymbol(9, MS_LAYER_POINT, MS_LAYER_LINE, MS_LAYER_RASTER,
+                         MS_LAYER_POLYGON, MS_LAYER_ANNOTATION, MS_LAYER_QUERY,
+                         MS_LAYER_CIRCLE, MS_LAYER_CHART, TILEINDEX)) == -1)
+        return (-1);
+      if (type == TILEINDEX)
+        type = MS_LAYER_TILEINDEX; /* TILEINDEX is also a parameter */
+      if (type == MS_LAYER_ANNOTATION) {
+        msSetError(MS_IDENTERR,
+                   "Annotation Layers have been removed. To obtain same "
+                   "functionality, use a layer with label->styles and no "
+                   "class->styles",
+                   "loadLayer()");
+        return -1;
+      }
+      layer->type = type;
+      break;
+    case (UNITS):
+      if ((layer->units = getSymbol(9, MS_INCHES, MS_FEET, MS_MILES, MS_METERS,
+                                    MS_KILOMETERS, MS_NAUTICALMILES, MS_DD,
+                                    MS_PIXELS, MS_PERCENTAGES)) == -1)
+        return (-1);
+      break;
+    case (UTFDATA):
+      if (loadExpression(&(layer->utfdata)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (UTFITEM):
+      if (getString(&layer->utfitem) == MS_FAILURE)
+        return (-1);
+      break;
+    case (VALIDATION):
+      if (loadHashTable(&(layer->validation)) != MS_SUCCESS)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLayer()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  } /* next token */
+}
+
+int msUpdateLayerFromString(layerObj *layer, char *string) {
+  int i;
+
+  if (!layer || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadLayer(layer, layer->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+
+  /* step through classes to resolve symbol names */
+  for (i = 0; i < layer->numclasses; i++) {
+    if (classResolveSymbolNames(layer->class[i]) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+static void writeCompositingFilter(FILE *stream, int indent,
+                                   CompositingFilter *filter) {
+  while (filter) {
+    writeString(stream, indent, "COMPFILTER", "", filter->filter);
+    filter = filter->next;
+  }
+}
+
+static void writeLayerCompositer(FILE *stream, int indent,
+                                 LayerCompositer *compositor) {
+  indent++;
+  while (compositor) {
+    writeBlockBegin(stream, indent, "COMPOSITE");
+    writeCompositingFilter(stream, indent, compositor->filter);
+    if (compositor->comp_op != MS_COMPOP_SRC_OVER) {
+      switch (compositor->comp_op) {
+      case MS_COMPOP_CLEAR:
+        writeString(stream, indent, "COMPOP", NULL, "clear");
+        break;
+      case MS_COMPOP_COLOR_BURN:
+        writeString(stream, indent, "COMPOP", NULL, "color-burn");
+        break;
+      case MS_COMPOP_COLOR_DODGE:
+        writeString(stream, indent, "COMPOP", NULL, "color-dodge");
+        break;
+      case MS_COMPOP_CONTRAST:
+        writeString(stream, indent, "COMPOP", NULL, "contrast");
+        break;
+      case MS_COMPOP_DARKEN:
+        writeString(stream, indent, "COMPOP", NULL, "darken");
+        break;
+      case MS_COMPOP_DIFFERENCE:
+        writeString(stream, indent, "COMPOP", NULL, "difference");
+        break;
+      case MS_COMPOP_DST:
+        writeString(stream, indent, "COMPOP", NULL, "dst");
+        break;
+      case MS_COMPOP_DST_ATOP:
+        writeString(stream, indent, "COMPOP", NULL, "dst-atop");
+        break;
+      case MS_COMPOP_DST_IN:
+        writeString(stream, indent, "COMPOP", NULL, "dst-in");
+        break;
+      case MS_COMPOP_DST_OUT:
+        writeString(stream, indent, "COMPOP", NULL, "dst-out");
+        break;
+      case MS_COMPOP_DST_OVER:
+        writeString(stream, indent, "COMPOP", NULL, "dst-over");
+        break;
+      case MS_COMPOP_EXCLUSION:
+        writeString(stream, indent, "COMPOP", NULL, "exclusion");
+        break;
+      case MS_COMPOP_HARD_LIGHT:
+        writeString(stream, indent, "COMPOP", NULL, "hard-light");
+        break;
+      case MS_COMPOP_INVERT:
+        writeString(stream, indent, "COMPOP", NULL, "invert");
+        break;
+      case MS_COMPOP_INVERT_RGB:
+        writeString(stream, indent, "COMPOP", NULL, "invert-rgb");
+        break;
+      case MS_COMPOP_LIGHTEN:
+        writeString(stream, indent, "COMPOP", NULL, "lighten");
+        break;
+      case MS_COMPOP_MINUS:
+        writeString(stream, indent, "COMPOP", NULL, "minus");
+        break;
+      case MS_COMPOP_MULTIPLY:
+        writeString(stream, indent, "COMPOP", NULL, "multiply");
+        break;
+      case MS_COMPOP_OVERLAY:
+        writeString(stream, indent, "COMPOP", NULL, "overlay");
+        break;
+      case MS_COMPOP_PLUS:
+        writeString(stream, indent, "COMPOP", NULL, "plus");
+        break;
+      case MS_COMPOP_SCREEN:
+        writeString(stream, indent, "COMPOP", NULL, "screen");
+        break;
+      case MS_COMPOP_SOFT_LIGHT:
+        writeString(stream, indent, "COMPOP", NULL, "soft-light");
+        break;
+      case MS_COMPOP_SRC:
+        writeString(stream, indent, "COMPOP", NULL, "src");
+        break;
+      case MS_COMPOP_SRC_ATOP:
+        writeString(stream, indent, "COMPOP", NULL, "src-atop");
+        break;
+      case MS_COMPOP_SRC_IN:
+        writeString(stream, indent, "COMPOP", NULL, "src-in");
+        break;
+      case MS_COMPOP_SRC_OUT:
+        writeString(stream, indent, "COMPOP", NULL, "src-out");
+        break;
+      case MS_COMPOP_SRC_OVER:
+        writeString(stream, indent, "COMPOP", NULL, "src-over");
+        break;
+      case MS_COMPOP_XOR:
+        writeString(stream, indent, "COMPOP", NULL, "xor");
+        break;
+      }
+    }
+    writeNumber(stream, indent, "OPACITY", 100, compositor->opacity);
+    writeBlockEnd(stream, indent, "COMPOSITE");
+    compositor = compositor->next;
+  }
+}
+static void writeLayer(FILE *stream, int indent, layerObj *layer) {
+  int i;
+  featureListNodeObjPtr current = NULL;
+
+  if (layer->status == MS_DELETE)
+    return;
+
+  indent++;
+  writeBlockBegin(stream, indent, "LAYER");
+  writeHashTable(stream, indent, "BINDVALS", &(layer->bindvals));
+  /* class - see below */
+  writeString(stream, indent, "CLASSGROUP", NULL, layer->classgroup);
+  writeString(stream, indent, "CLASSITEM", NULL, layer->classitem);
+  writeCluster(stream, indent, &(layer->cluster));
+  writeLayerCompositer(stream, indent, layer->compositer);
+  writeString(stream, indent, "CONNECTION", NULL, layer->connection);
+  writeKeyword(stream, indent, "CONNECTIONTYPE", layer->connectiontype, 12,
+               MS_OGR, "OGR", MS_POSTGIS, "POSTGIS", MS_WMS, "WMS",
+               MS_ORACLESPATIAL, "ORACLESPATIAL", MS_WFS, "WFS", MS_PLUGIN,
+               "PLUGIN", MS_UNION, "UNION", MS_UVRASTER, "UVRASTER", MS_CONTOUR,
+               "CONTOUR", MS_KERNELDENSITY, "KERNELDENSITY", MS_IDW, "IDW",
+               MS_FLATGEOBUF, "FLATGEOBUF");
+  writeHashTable(stream, indent, "CONNECTIONOPTIONS",
+                 &(layer->connectionoptions));
+  writeString(stream, indent, "DATA", NULL, layer->data);
+  writeNumber(stream, indent, "DEBUG", 0,
+              layer->debug); /* is this right? see loadLayer() */
+  writeString(stream, indent, "ENCODING", NULL, layer->encoding);
+  writeExtent(stream, indent, "EXTENT", layer->extent);
+  writeExpression(stream, indent, "FILTER", &(layer->filter));
+  writeString(stream, indent, "FILTERITEM", NULL, layer->filteritem);
+  writeString(stream, indent, "FOOTER", NULL, layer->footer);
+  writeString(stream, indent, "GROUP", NULL, layer->group);
+
+  if (layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
+    writeIndent(stream, indent + 1);
+    fprintf(stream, "GEOMTRANSFORM (%s)\n", layer->_geomtransform.string);
+  }
+
+  writeString(stream, indent, "HEADER", NULL, layer->header);
+  /* join - see below */
+  writeKeyword(stream, indent, "LABELCACHE", layer->labelcache, 1, MS_OFF,
+               "OFF");
+  writeString(stream, indent, "LABELITEM", NULL, layer->labelitem);
+  writeNumber(stream, indent, "LABELMAXSCALEDENOM", -1,
+              layer->labelmaxscaledenom);
+  writeNumber(stream, indent, "LABELMINSCALEDENOM", -1,
+              layer->labelminscaledenom);
+  writeString(stream, indent, "LABELREQUIRES", NULL, layer->labelrequires);
+  writeNumber(stream, indent, "MAXFEATURES", -1, layer->maxfeatures);
+  writeNumber(stream, indent, "MAXGEOWIDTH", -1, layer->maxgeowidth);
+  writeNumber(stream, indent, "MAXSCALEDENOM", -1, layer->maxscaledenom);
+  writeString(stream, indent, "MASK", NULL, layer->mask);
+  writeHashTable(stream, indent, "METADATA", &(layer->metadata));
+  writeNumber(stream, indent, "MINGEOWIDTH", -1, layer->mingeowidth);
+  writeNumber(stream, indent, "MINSCALEDENOM", -1, layer->minscaledenom);
+  writeNumber(stream, indent, "MINFEATURESIZE", -1, layer->minfeaturesize);
+  writeString(stream, indent, "NAME", NULL, layer->name);
+  writeColor(stream, indent, "OFFSITE", NULL, &(layer->offsite));
+  writeString(stream, indent, "PLUGIN", NULL, layer->plugin_library_original);
+  writeKeyword(stream, indent, "POSTLABELCACHE", layer->postlabelcache, 1,
+               MS_TRUE, "TRUE");
+  for (i = 0; i < layer->numprocessing; i++)
+    writeString(stream, indent, "PROCESSING", NULL, layer->processing[i]);
+  writeProjection(stream, indent, &(layer->projection));
+  writeString(stream, indent, "REQUIRES", NULL, layer->requires);
+  writeKeyword(stream, indent, "SIZEUNITS", layer->sizeunits, 7, MS_INCHES,
+               "INCHES", MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS,
+               "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES,
+               "NAUTICALMILES", MS_DD, "DD");
+  writeKeyword(stream, indent, "STATUS", layer->status, 3, MS_ON, "ON", MS_OFF,
+               "OFF", MS_DEFAULT, "DEFAULT");
+  writeString(stream, indent, "STYLEITEM", NULL, layer->styleitem);
+  writeNumber(stream, indent, "SYMBOLSCALEDENOM", -1, layer->symbolscaledenom);
+  writeString(stream, indent, "TEMPLATE", NULL, layer->template);
+  writeString(stream, indent, "TILEINDEX", NULL, layer->tileindex);
+  writeString(stream, indent, "TILEITEM", NULL, layer->tileitem);
+  writeString(stream, indent, "TILESRS", NULL, layer->tilesrs);
+  writeNumber(stream, indent, "TOLERANCE", -1, layer->tolerance);
+  writeKeyword(stream, indent, "TOLERANCEUNITS", layer->toleranceunits, 7,
+               MS_INCHES, "INCHES", MS_FEET, "FEET", MS_MILES, "MILES",
+               MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS",
+               MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
+  writeKeyword(stream, indent, "TRANSFORM", layer->transform, 10, MS_FALSE,
+               "FALSE", MS_UL, "UL", MS_UC, "UC", MS_UR, "UR", MS_CL, "CL",
+               MS_CC, "CC", MS_CR, "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR");
+  writeKeyword(stream, indent, "TYPE", layer->type, 9, MS_LAYER_POINT, "POINT",
+               MS_LAYER_LINE, "LINE", MS_LAYER_POLYGON, "POLYGON",
+               MS_LAYER_RASTER, "RASTER", MS_LAYER_ANNOTATION, "ANNOTATION",
+               MS_LAYER_QUERY, "QUERY", MS_LAYER_CIRCLE, "CIRCLE",
+               MS_LAYER_TILEINDEX, "TILEINDEX", MS_LAYER_CHART, "CHART");
+  writeKeyword(stream, indent, "UNITS", layer->units, 9, MS_INCHES, "INCHES",
+               MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS, "METERS",
+               MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES",
+               MS_DD, "DD", MS_PIXELS, "PIXELS", MS_PERCENTAGES,
+               "PERCENTATGES");
+  writeExpression(stream, indent, "UTFDATA", &(layer->utfdata));
+  writeString(stream, indent, "UTFITEM", NULL, layer->utfitem);
+  writeHashTable(stream, indent, "VALIDATION", &(layer->validation));
+
+  /* write potentially multiply occuring objects last */
+  for (i = 0; i < layer->numscaletokens; i++)
+    writeScaleToken(stream, indent, &(layer->scaletokens[i]));
+  for (i = 0; i < layer->numjoins; i++)
+    writeJoin(stream, indent, &(layer->joins[i]));
+  for (i = 0; i < layer->numclasses; i++)
+    writeClass(stream, indent, layer->class[i]);
+
+  if (layer->grid && layer->connectiontype == MS_GRATICULE)
+    writeGrid(stream, indent, layer->grid);
+  else {
+    current = layer->features;
+    while (current != NULL) {
+      writeFeature(stream, indent, &(current->shape));
+      current = current->next;
+    }
+  }
+
+  writeBlockEnd(stream, indent, "LAYER");
+  writeLineFeed(stream);
+}
+
+char *msWriteLayerToString(layerObj *layer) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeLayer(stdout, -1, layer);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+/*
+** Initialize, load and free a referenceMapObj structure
+*/
+void initReferenceMap(referenceMapObj *ref) {
+  ref->height = ref->width = 0;
+  ref->extent.minx = ref->extent.miny = ref->extent.maxx = ref->extent.maxy =
+      -1.0;
+  ref->image = NULL;
+  MS_INIT_COLOR(ref->color, 255, 0, 0, 255);
+  MS_INIT_COLOR(ref->outlinecolor, 0, 0, 0, 255);
+  ref->status = MS_OFF;
+  ref->marker = 0;
+  ref->markername = NULL;
+  ref->markersize = 0;
+  ref->minboxsize = 3;
+  ref->maxboxsize = 0;
+  ref->map = NULL;
+}
+
+void freeReferenceMap(referenceMapObj *ref) {
+  msFree(ref->image);
+  msFree(ref->markername);
+}
+
+int loadReferenceMap(referenceMapObj *ref, mapObj *map) {
+  int state;
+
+  ref->map = (mapObj *)map;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadReferenceMap()");
+      return (-1);
+    case (END):
+      if (!ref->image) {
+        msSetError(MS_MISCERR, "No image defined for the reference map.",
+                   "loadReferenceMap()");
+        return (-1);
+      }
+      if (ref->width == 0 || ref->height == 0) {
+        msSetError(MS_MISCERR, "No image size defined for the reference map.",
+                   "loadReferenceMap()");
+        return (-1);
+      }
+      return (0);
+      break;
+    case (COLOR):
+      if (loadColor(&(ref->color), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (EXTENT):
+      if (getDouble(&(ref->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(ref->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(ref->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(ref->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (!MS_VALID_EXTENT(ref->extent)) {
+        msSetError(MS_MISCERR,
+                   "Given reference extent is invalid. Check that it "
+                   "is in the form: minx, miny, maxx, maxy",
+                   "loadReferenceMap()");
+        return (-1);
+      }
+      break;
+    case (IMAGE):
+      if (getString(&ref->image) == MS_FAILURE)
+        return (-1);
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(ref->outlinecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (SIZE):
+      if (getInteger(&(ref->width), MS_NUM_CHECK_RANGE, 5, ref->map->maxsize) ==
+          -1)
+        return (-1); // is 5 reasonable?
+      if (getInteger(&(ref->height), MS_NUM_CHECK_RANGE, 5,
+                     ref->map->maxsize) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((ref->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (MARKER):
+      if ((state = getSymbol(2, MS_NUMBER, MS_STRING)) == -1)
+        return (-1);
+
+      if (state == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid MARKER, must be greater than 0 (line %d)",
+                     "loadReferenceMap()", msyylineno);
+          return (-1);
+        }
+        ref->marker = (int)msyynumber;
+      } else {
+        if (ref->markername != NULL)
+          msFree(ref->markername);
+        ref->markername = msStrdup(msyystring_buffer);
+      }
+      break;
+    case (MARKERSIZE):
+      if (getInteger(&(ref->markersize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINBOXSIZE):
+      if (getInteger(&(ref->minboxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXBOXSIZE):
+      if (getInteger(&(ref->maxboxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (REFERENCE):
+      break; /* for string loads */
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadReferenceMap()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  } /* next token */
+}
+
+int msUpdateReferenceMapFromString(referenceMapObj *ref, char *string) {
+  if (!ref || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadReferenceMap(ref, ref->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+static void writeReferenceMap(FILE *stream, int indent, referenceMapObj *ref) {
+  colorObj c;
+
+  if (!ref->image)
+    return;
+
+  indent++;
+  writeBlockBegin(stream, indent, "REFERENCE");
+  MS_INIT_COLOR(c, 255, 0, 0, 255);
+  writeColor(stream, indent, "COLOR", &c, &(ref->color));
+  writeExtent(stream, indent, "EXTENT", ref->extent);
+  writeString(stream, indent, "IMAGE", NULL, ref->image);
+  MS_INIT_COLOR(c, 0, 0, 0, 255);
+  writeColor(stream, indent, "OUTLINECOLOR", &c, &(ref->outlinecolor));
+  writeDimension(stream, indent, "SIZE", ref->width, ref->height, NULL, NULL);
+  writeKeyword(stream, indent, "STATUS", ref->status, 2, MS_ON, "ON", MS_OFF,
+               "OFF");
+  writeNumberOrString(stream, indent, "MARKER", 0, ref->marker,
+                      ref->markername);
+  writeNumber(stream, indent, "MARKERSIZE", -1, ref->markersize);
+  writeNumber(stream, indent, "MAXBOXSIZE", -1, ref->maxboxsize);
+  writeNumber(stream, indent, "MINBOXSIZE", -1, ref->minboxsize);
+  writeBlockEnd(stream, indent, "REFERENCE");
+  writeLineFeed(stream);
+}
+
+char *msWriteReferenceMapToString(referenceMapObj *ref) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeReferenceMap(stdout, -1, ref);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+#define MAX_FORMATOPTIONS 100
+
+static int loadOutputFormat(mapObj *map) {
+  char *name = NULL;
+  char *mimetype = NULL;
+  char *driver = NULL;
+  char *extension = NULL;
+  int imagemode = MS_NOOVERRIDE;
+  int transparent = MS_NOOVERRIDE;
+  char *formatoptions[MAX_FORMATOPTIONS];
+  int numformatoptions = 0;
+  char *value = NULL;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadOutputFormat()");
+      goto load_output_error;
+
+    case (END): {
+      outputFormatObj *format;
+
+      if (driver == NULL) {
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT clause lacks DRIVER keyword near (%s):(%d)",
+                   "loadOutputFormat()", msyystring_buffer, msyylineno);
+        goto load_output_error;
+      }
+
+      format = msCreateDefaultOutputFormat(map, driver, name, NULL);
+      if (format == NULL) {
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT (%s) clause references driver (%s), but this "
+                   "driver isn't configured.",
+                   "loadOutputFormat()", name, driver);
+        goto load_output_error;
+      }
+      msFree(name);
+      name = NULL;
+      msFree(driver);
+      driver = NULL;
+
+      if (transparent != MS_NOOVERRIDE)
+        format->transparent = transparent;
+      if (extension != NULL) {
+        msFree(format->extension);
+        format->extension = extension;
+        extension = NULL;
+      }
+      if (mimetype != NULL) {
+        msFree(format->mimetype);
+        format->mimetype = mimetype;
+        mimetype = NULL;
+      }
+      if (imagemode != MS_NOOVERRIDE) {
+        if (format->renderer != MS_RENDER_WITH_AGG ||
+            imagemode != MS_IMAGEMODE_PC256) {
+          /* don't force to PC256 with agg, this can happen when using mapfile
+           * defined GD outputformats that are now falling back to agg/png8
+           */
+          format->imagemode = imagemode;
+        }
+
+        if (transparent == MS_NOOVERRIDE) {
+          if (imagemode == MS_IMAGEMODE_RGB)
+            format->transparent = MS_FALSE;
+          else if (imagemode == MS_IMAGEMODE_RGBA)
+            format->transparent = MS_TRUE;
+        }
+        if (format->imagemode == MS_IMAGEMODE_INT16 ||
+            format->imagemode == MS_IMAGEMODE_FLOAT32 ||
+            format->imagemode == MS_IMAGEMODE_BYTE)
+          format->renderer = MS_RENDER_WITH_RAWDATA;
+      }
+      while (numformatoptions--) {
+        char *key = strchr(formatoptions[numformatoptions], '=');
+        if (!key || !*(key + 1)) {
+          msSetError(
+              MS_MISCERR,
+              "Failed to parse FORMATOPTION, expecting \"KEY=VALUE\" syntax.",
+              "loadOutputFormat()");
+          goto load_output_error;
+        }
+        *key = 0;
+        key++;
+        msSetOutputFormatOption(format, formatoptions[numformatoptions], key);
+        free(formatoptions[numformatoptions]);
+      }
+
+      format->inmapfile = MS_TRUE;
+
+      msOutputFormatValidate(format, MS_FALSE);
+      return (0);
+    }
+    case (NAME):
+      msFree(name);
+      if ((name = getToken()) == NULL)
+        goto load_output_error;
+      break;
+    case (MIMETYPE):
+      if (getString(&mimetype) == MS_FAILURE)
+        goto load_output_error;
+      break;
+    case (DRIVER): {
+      int s;
+      if ((s = getSymbol(2, MS_STRING, TEMPLATE)) ==
+          -1) /* allow the template to be quoted or not in the mapfile */
+        goto load_output_error;
+      free(driver);
+      if (s == MS_STRING)
+        driver = msStrdup(msyystring_buffer);
+      else
+        driver = msStrdup("TEMPLATE");
+    } break;
+    case (EXTENSION):
+      if (getString(&extension) == MS_FAILURE)
+        goto load_output_error;
+      if (extension[0] == '.') {
+        char *temp = msStrdup(extension + 1);
+        free(extension);
+        extension = temp;
+      }
+      break;
+    case (FORMATOPTION):
+      if (getString(&value) == MS_FAILURE)
+        goto load_output_error;
+      if (numformatoptions < MAX_FORMATOPTIONS)
+        formatoptions[numformatoptions++] = value;
+      value = NULL;
+      break;
+    case (IMAGEMODE):
+      value = getToken();
+      if (strcasecmp(value, "PC256") == 0)
+        imagemode = MS_IMAGEMODE_PC256;
+      else if (strcasecmp(value, "RGB") == 0)
+        imagemode = MS_IMAGEMODE_RGB;
+      else if (strcasecmp(value, "RGBA") == 0)
+        imagemode = MS_IMAGEMODE_RGBA;
+      else if (strcasecmp(value, "INT16") == 0)
+        imagemode = MS_IMAGEMODE_INT16;
+      else if (strcasecmp(value, "FLOAT32") == 0)
+        imagemode = MS_IMAGEMODE_FLOAT32;
+      else if (strcasecmp(value, "BYTE") == 0)
+        imagemode = MS_IMAGEMODE_BYTE;
+      else if (strcasecmp(value, "FEATURE") == 0)
+        imagemode = MS_IMAGEMODE_FEATURE;
+      else {
+        msSetError(MS_IDENTERR,
+                   "Parsing error near (%s):(line %d), expected PC256, RGB, "
+                   "RGBA, FEATURE, BYTE, INT16, or FLOAT32 for IMAGEMODE.",
+                   "loadOutputFormat()", msyystring_buffer, msyylineno);
+        goto load_output_error;
+      }
+      free(value);
+      value = NULL;
+      break;
+    case (TRANSPARENT):
+      if ((transparent = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        goto load_output_error;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadOutputFormat()", msyystring_buffer, msyylineno);
+      goto load_output_error;
+    }
+  } /* next token */
+load_output_error:
+  msFree(driver);
+  msFree(extension);
+  msFree(mimetype);
+  msFree(name);
+  msFree(value);
+  return -1;
+}
+
+/*
+** utility function to write an output format structure to file
+*/
+static void writeOutputformatobject(FILE *stream, int indent,
+                                    outputFormatObj *outputformat) {
+  int i = 0;
+  if (!outputformat)
+    return;
+
+  indent++;
+  writeBlockBegin(stream, indent, "OUTPUTFORMAT");
+  writeString(stream, indent, "NAME", NULL, outputformat->name);
+  writeString(stream, indent, "MIMETYPE", NULL, outputformat->mimetype);
+  writeString(stream, indent, "DRIVER", NULL, outputformat->driver);
+  writeString(stream, indent, "EXTENSION", NULL, outputformat->extension);
+  writeKeyword(stream, indent, "IMAGEMODE", outputformat->imagemode, 7,
+               MS_IMAGEMODE_PC256, "PC256", MS_IMAGEMODE_RGB, "RGB",
+               MS_IMAGEMODE_RGBA, "RGBA", MS_IMAGEMODE_INT16, "INT16",
+               MS_IMAGEMODE_FLOAT32, "FLOAT32", MS_IMAGEMODE_BYTE, "BYTE",
+               MS_IMAGEMODE_FEATURE, "FEATURE");
+  writeKeyword(stream, indent, "TRANSPARENT", outputformat->transparent, 2,
+               MS_TRUE, "TRUE", MS_FALSE, "FALSE");
+  for (i = 0; i < outputformat->numformatoptions; i++)
+    writeString(stream, indent, "FORMATOPTION", NULL,
+                outputformat->formatoptions[i]);
+  writeBlockEnd(stream, indent, "OUTPUTFORMAT");
+  writeLineFeed(stream);
+}
+
+/*
+** Write the output formats to file
+*/
+static void writeOutputformat(FILE *stream, int indent, mapObj *map) {
+  int i = 0;
+  if (!map->outputformat)
+    return;
+
+  writeOutputformatobject(stream, indent, map->outputformat);
+  for (i = 0; i < map->numoutputformats; i++) {
+    if (map->outputformatlist[i]->inmapfile == MS_TRUE &&
+        strcmp(map->outputformatlist[i]->name, map->outputformat->name) != 0)
+      writeOutputformatobject(stream, indent, map->outputformatlist[i]);
+  }
+}
+
+/*
+** Initialize, load and free a legendObj structure
+*/
+void initLegend(legendObj *legend) {
+  legend->height = legend->width = 0;
+  MS_INIT_COLOR(legend->imagecolor, 255, 255, 255, 255); /* white */
+  MS_INIT_COLOR(legend->outlinecolor, -1, -1, -1, 255);
+  initLabel(&legend->label);
+  legend->label.position = MS_XY; /* override */
+  legend->keysizex = 20;
+  legend->keysizey = 10;
+  legend->keyspacingx = 5;
+  legend->keyspacingy = 5;
+  legend->status = MS_OFF;
+  legend->transparent = MS_NOOVERRIDE;
+  legend->position = MS_LL;
+  legend->postlabelcache = MS_FALSE; /* draw with labels */
+  legend->template = NULL;
+  legend->map = NULL;
+}
+
+void freeLegend(legendObj *legend) {
+  if (legend->template)
+    free(legend->template);
+  freeLabel(&(legend->label));
+}
+
+int loadLegend(legendObj *legend, mapObj *map) {
+  legend->map = (mapObj *)map;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLegend()");
+      return (-1);
+    case (END):
+      legend->label.position = MS_XY; /* overrides go here */
+      return (0);
+      break;
+    case (IMAGECOLOR):
+      if (loadColor(&(legend->imagecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (KEYSIZE):
+      if (getInteger(&(legend->keysizex), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1)
+        return (-1);
+      if (getInteger(&(legend->keysizey), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1)
+        return (-1);
+      break;
+    case (KEYSPACING):
+      if (getInteger(&(legend->keyspacingx), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1)
+        return (-1);
+      if (getInteger(&(legend->keyspacingy), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1)
+        return (-1);
+      break;
+    case (LABEL):
+      if (loadLabel(&(legend->label)) == -1)
+        return (-1);
+      legend->label.angle = 0; /* force */
+      break;
+    case (LEGEND):
+      break; /* for string loads */
+    case (OUTLINECOLOR):
+      if (loadColor(&(legend->outlinecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (POSITION):
+      if ((legend->position =
+               getSymbol(6, MS_UL, MS_UR, MS_LL, MS_LR, MS_UC, MS_LC)) == -1)
+        return (-1);
+      break;
+    case (POSTLABELCACHE):
+      if ((legend->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((legend->status = getSymbol(3, MS_ON, MS_OFF, MS_EMBED)) == -1)
+        return (-1);
+      break;
+    case (TRANSPARENT):
+      if ((legend->transparent = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&legend->template) == MS_FAILURE)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLegend()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  } /* next token */
+}
+
+int msUpdateLegendFromString(legendObj *legend, char *string) {
+  if (!legend || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadLegend(legend, legend->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+static void writeLegend(FILE *stream, int indent, legendObj *legend) {
+  colorObj c;
+
+  indent++;
+  writeBlockBegin(stream, indent, "LEGEND");
+  MS_INIT_COLOR(c, 255, 255, 255, 255);
+  writeColor(stream, indent, "IMAGECOLOR", &c, &(legend->imagecolor));
+  writeDimension(stream, indent, "KEYSIZE", legend->keysizex, legend->keysizey,
+                 NULL, NULL);
+  writeDimension(stream, indent, "KEYSPACING", legend->keyspacingx,
+                 legend->keyspacingy, NULL, NULL);
+  writeLabel(stream, indent, &(legend->label));
+  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(legend->outlinecolor));
+  if (legend->status == MS_EMBED)
+    writeKeyword(stream, indent, "POSITION", legend->position, 6, MS_LL, "LL",
+                 MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC,
+                 "LC");
+  writeKeyword(stream, indent, "POSTLABELCACHE", legend->postlabelcache, 1,
+               MS_TRUE, "TRUE");
+  writeKeyword(stream, indent, "STATUS", legend->status, 3, MS_ON, "ON", MS_OFF,
+               "OFF", MS_EMBED, "EMBED");
+  writeKeyword(stream, indent, "TRANSPARENT", legend->transparent, 2, MS_TRUE,
+               "TRUE", MS_FALSE, "FALSE");
+  writeString(stream, indent, "TEMPLATE", NULL, legend->template);
+  writeBlockEnd(stream, indent, "LEGEND");
+  writeLineFeed(stream);
+}
+
+char *msWriteLegendToString(legendObj *legend) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeLegend(stdout, -1, legend);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+/*
+** Initialize, load and free a scalebarObj structure
+*/
+void initScalebar(scalebarObj *scalebar) {
+  MS_INIT_COLOR(scalebar->imagecolor, -1, -1, -1, 255);
+  scalebar->width = 200;
+  scalebar->height = 3;
+  scalebar->style = 0; /* only 2 styles at this point */
+  scalebar->intervals = 4;
+  initLabel(&scalebar->label);
+  scalebar->label.position = MS_XY; /* override */
+  MS_INIT_COLOR(scalebar->backgroundcolor, -1, -1, -1,
+                255); /* if not set, scalebar creation needs to set this to
+                         match the background color */
+  MS_INIT_COLOR(scalebar->color, 0, 0, 0, 255); /* default to black */
+  MS_INIT_COLOR(scalebar->outlinecolor, -1, -1, -1, 255);
+  scalebar->units = MS_MILES;
+  scalebar->status = MS_OFF;
+  scalebar->position = MS_LL;
+  scalebar->transparent = MS_NOOVERRIDE; /* no transparency */
+  scalebar->postlabelcache = MS_FALSE;   /* draw with labels */
+  scalebar->align = MS_ALIGN_CENTER;
+  scalebar->offsetx = 0;
+  scalebar->offsety = 0;
+}
+
+void freeScalebar(scalebarObj *scalebar) { freeLabel(&(scalebar->label)); }
+
+int loadScalebar(scalebarObj *scalebar) {
+  for (;;) {
+    switch (msyylex()) {
+    case (ALIGN):
+      if ((scalebar->align = getSymbol(3, MS_ALIGN_LEFT, MS_ALIGN_CENTER,
+                                       MS_ALIGN_RIGHT)) == -1)
+        return (-1);
+      break;
+    case (BACKGROUNDCOLOR):
+      if (loadColor(&(scalebar->backgroundcolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (COLOR):
+      if (loadColor(&(scalebar->color), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadScalebar()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (IMAGECOLOR):
+      if (loadColor(&(scalebar->imagecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (INTERVALS):
+      if (getInteger(&(scalebar->intervals), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_INTERVALS_MIN,
+                     MS_SCALEBAR_INTERVALS_MAX) == -1)
+        return (-1);
+      break;
+    case (LABEL):
+      if (loadLabel(&(scalebar->label)) == -1)
+        return (-1);
+      scalebar->label.angle = 0;
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(scalebar->outlinecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (POSITION):
+      if ((scalebar->position =
+               getSymbol(6, MS_UL, MS_UR, MS_LL, MS_LR, MS_UC, MS_LC)) == -1)
+        return (-1);
+      break;
+    case (POSTLABELCACHE):
+      if ((scalebar->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (SCALEBAR):
+      break; /* for string loads */
+    case (SIZE):
+      if (getInteger(&(scalebar->width), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_WIDTH_MIN, MS_SCALEBAR_WIDTH_MAX) == -1)
+        return (-1);
+      if (getInteger(&(scalebar->height), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_HEIGHT_MIN, MS_SCALEBAR_HEIGHT_MAX) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((scalebar->status = getSymbol(3, MS_ON, MS_OFF, MS_EMBED)) == -1)
+        return (-1);
+      break;
+    case (STYLE):
+      if (getInteger(&(scalebar->style), MS_NUM_CHECK_RANGE, 0, 1) == -1)
+        return (-1); // only 2 styles: 0 and 1
+      break;
+    case (TRANSPARENT):
+      if ((scalebar->transparent = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (UNITS):
+      if ((scalebar->units =
+               getSymbol(6, MS_INCHES, MS_FEET, MS_MILES, MS_METERS,
+                         MS_KILOMETERS, MS_NAUTICALMILES)) == -1)
+        return (-1);
+      break;
+    case (OFFSET):
+      if (getInteger(&(scalebar->offsetx), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1)
+        return (-1);
+      if (getInteger(&(scalebar->offsety), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadScalebar()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  } /* next token */
+}
+
+int msUpdateScalebarFromString(scalebarObj *scalebar, char *string) {
+  if (!scalebar || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadScalebar(scalebar) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+static void writeScalebar(FILE *stream, int indent, scalebarObj *scalebar) {
+  colorObj c;
+
+  indent++;
+  writeBlockBegin(stream, indent, "SCALEBAR");
+  writeKeyword(stream, indent, "ALIGN", scalebar->align, 2, MS_ALIGN_LEFT,
+               "LEFT", MS_ALIGN_RIGHT, "RIGHT");
+  writeColor(stream, indent, "BACKGROUNDCOLOR", NULL,
+             &(scalebar->backgroundcolor));
+  MS_INIT_COLOR(c, 0, 0, 0, 255);
+  writeColor(stream, indent, "COLOR", &c, &(scalebar->color));
+  writeColor(stream, indent, "IMAGECOLOR", NULL, &(scalebar->imagecolor));
+  writeNumber(stream, indent, "INTERVALS", -1, scalebar->intervals);
+  writeLabel(stream, indent, &(scalebar->label));
+  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(scalebar->outlinecolor));
+  if (scalebar->status == MS_EMBED)
+    writeKeyword(stream, indent, "POSITION", scalebar->position, 6, MS_LL, "LL",
+                 MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC,
+                 "LC");
+  writeKeyword(stream, indent, "POSTLABELCACHE", scalebar->postlabelcache, 1,
+               MS_TRUE, "TRUE");
+  writeDimension(stream, indent, "SIZE", scalebar->width, scalebar->height,
+                 NULL, NULL);
+  writeKeyword(stream, indent, "STATUS", scalebar->status, 3, MS_ON, "ON",
+               MS_OFF, "OFF", MS_EMBED, "EMBED");
+  writeNumber(stream, indent, "STYLE", 0, scalebar->style);
+  writeKeyword(stream, indent, "TRANSPARENT", scalebar->transparent, 2, MS_TRUE,
+               "TRUE", MS_FALSE, "FALSE");
+  writeKeyword(stream, indent, "UNITS", scalebar->units, 6, MS_INCHES, "INCHES",
+               MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS, "METERS",
+               MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES");
+  writeBlockEnd(stream, indent, "SCALEBAR");
+  writeLineFeed(stream);
+}
+
+char *msWriteScalebarToString(scalebarObj *scalebar) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeScalebar(stdout, -1, scalebar);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+/*
+** Initialize a queryMapObj structure
+*/
+void initQueryMap(queryMapObj *querymap) {
+  querymap->width = querymap->height = -1;
+  querymap->style = MS_HILITE;
+  querymap->status = MS_OFF;
+  MS_INIT_COLOR(querymap->color, 255, 255, 0, 255); /* yellow */
+}
+
+int loadQueryMap(queryMapObj *querymap, mapObj *map) {
+  querymap->map = (mapObj *)map;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (QUERYMAP):
+      break; /* for string loads */
+    case (COLOR):
+      if (loadColor(&(querymap->color), NULL) != MS_SUCCESS)
+        return MS_FAILURE;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadQueryMap()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (SIZE):
+      /*
+       ** we do -1 (and avoid 0) here to maintain backwards compatability as
+       *older versions write "SIZE -1 -1" when saving a mapfile
+       */
+      if (getInteger(&(querymap->width), MS_NUM_CHECK_RANGE, -1,
+                     querymap->map->maxsize) == -1 ||
+          querymap->width == 0) {
+        msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()",
+                   msyylineno);
+        return (-1);
+      }
+      if (getInteger(&(querymap->height), MS_NUM_CHECK_RANGE, -1,
+                     querymap->map->maxsize) == -1 ||
+          querymap->height == 0) {
+        msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()",
+                   msyylineno);
+        return (-1);
+      }
+      break;
+    case (STATUS):
+      if ((querymap->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (STYLE):
+    case (TYPE):
+      if ((querymap->style = getSymbol(3, MS_NORMAL, MS_HILITE, MS_SELECTED)) ==
+          -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadQueryMap()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  }
+}
+
+int msUpdateQueryMapFromString(queryMapObj *querymap, char *string) {
+  if (!querymap || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadQueryMap(querymap, querymap->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+static void writeQueryMap(FILE *stream, int indent, queryMapObj *querymap) {
+  colorObj c;
+
+  indent++;
+  writeBlockBegin(stream, indent, "QUERYMAP");
+  MS_INIT_COLOR(c, 255, 255, 0, 255);
+  writeColor(stream, indent, "COLOR", &c, &(querymap->color));
+  if (querymap->width != -1 &&
+      querymap->height != -1) // don't write SIZE if not explicitly set
+    writeDimension(stream, indent, "SIZE", querymap->width, querymap->height,
+                   NULL, NULL);
+  writeKeyword(stream, indent, "STATUS", querymap->status, 2, MS_ON, "ON",
+               MS_OFF, "OFF");
+  writeKeyword(stream, indent, "STYLE", querymap->style, 3, MS_NORMAL, "NORMAL",
+               MS_HILITE, "HILITE", MS_SELECTED, "SELECTED");
+  writeBlockEnd(stream, indent, "QUERYMAP");
+  writeLineFeed(stream);
+}
+
+char *msWriteQueryMapToString(queryMapObj *querymap) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeQueryMap(stdout, -1, querymap);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+/*
+** Initialize a webObj structure
+*/
+void initWeb(webObj *web) {
+  web->template = NULL;
+  web->header = web->footer = NULL;
+  web->error = web->empty = NULL;
+  web->mintemplate = web->maxtemplate = NULL;
+  web->minscaledenom = web->maxscaledenom = -1;
+  web->imagepath = msStrdup("");
+  web->temppath = NULL;
+  web->imageurl = msStrdup("");
+
+  initHashTable(&(web->metadata));
+  initHashTable(&(web->validation));
+
+  web->map = NULL;
+  web->queryformat = msStrdup("text/html");
+  web->legendformat = msStrdup("text/html");
+  web->browseformat = msStrdup("text/html");
+}
+
+void freeWeb(webObj *web) {
+  msFree(web->template);
+  msFree(web->header);
+  msFree(web->footer);
+  msFree(web->error);
+  msFree(web->empty);
+  msFree(web->maxtemplate);
+  msFree(web->mintemplate);
+  msFree(web->imagepath);
+  msFree(web->temppath);
+  msFree(web->imageurl);
+  msFree(web->queryformat);
+  msFree(web->legendformat);
+  msFree(web->browseformat);
+  msFreeHashItems(&(web->metadata));
+  msFreeHashItems(&(web->validation));
+}
+
+static void writeWeb(FILE *stream, int indent, webObj *web) {
+  indent++;
+  writeBlockBegin(stream, indent, "WEB");
+  writeString(stream, indent, "BROWSEFORMAT", "text/html", web->browseformat);
+  writeString(stream, indent, "EMPTY", NULL, web->empty);
+  writeString(stream, indent, "ERROR", NULL, web->error);
+  writeString(stream, indent, "FOOTER", NULL, web->footer);
+  writeString(stream, indent, "HEADER", NULL, web->header);
+  writeString(stream, indent, "IMAGEPATH", "", web->imagepath);
+  writeString(stream, indent, "TEMPPATH", NULL, web->temppath);
+  writeString(stream, indent, "IMAGEURL", "", web->imageurl);
+  writeString(stream, indent, "LEGENDFORMAT", "text/html", web->legendformat);
+  writeNumber(stream, indent, "MAXSCALEDENOM", -1, web->maxscaledenom);
+  writeString(stream, indent, "MAXTEMPLATE", NULL, web->maxtemplate);
+  writeHashTable(stream, indent, "METADATA", &(web->metadata));
+  writeNumber(stream, indent, "MINSCALEDENOM", -1, web->minscaledenom);
+  writeString(stream, indent, "MINTEMPLATE", NULL, web->mintemplate);
+  writeString(stream, indent, "QUERYFORMAT", "text/html", web->queryformat);
+  writeString(stream, indent, "TEMPLATE", NULL, web->template);
+  writeHashTable(stream, indent, "VALIDATION", &(web->validation));
+  writeBlockEnd(stream, indent, "WEB");
+  writeLineFeed(stream);
+}
+
+char *msWriteWebToString(webObj *web) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeWeb(stdout, -1, web);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+int loadWeb(webObj *web, mapObj *map) {
+  web->map = (mapObj *)map;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (BROWSEFORMAT): /* change to use validation in 6.0 */
+      free(web->browseformat);
+      web->browseformat = NULL; /* there is a default */
+      if (getString(&web->browseformat) == MS_FAILURE)
+        return (-1);
+      break;
+    case (EMPTY):
+      if (getString(&web->empty) == MS_FAILURE)
+        return (-1);
+      break;
+    case (WEB):
+      break; /* for string loads */
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadWeb()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (ERROR):
+      if (getString(&web->error) == MS_FAILURE)
+        return (-1);
+      break;
+    case (FOOTER):
+      if (getString(&web->footer) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (HEADER):
+      if (getString(&web->header) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (IMAGEPATH):
+      if (getString(&web->imagepath) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TEMPPATH):
+      if (getString(&web->temppath) == MS_FAILURE)
+        return (-1);
+      break;
+    case (IMAGEURL):
+      if (getString(&web->imageurl) == MS_FAILURE)
+        return (-1);
+      break;
+    case (LEGENDFORMAT): /* change to use validation in 6.0 */
+      free(web->legendformat);
+      web->legendformat = NULL; /* there is a default */
+      if (getString(&web->legendformat) == MS_FAILURE)
+        return (-1);
+      break;
+    case (MAXSCALEDENOM):
+      if (getDouble(&web->maxscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXTEMPLATE):
+      if (getString(&web->maxtemplate) == MS_FAILURE)
+        return (-1);
+      break;
+    case (METADATA):
+      if (loadHashTable(&(web->metadata)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MINSCALEDENOM):
+      if (getDouble(&web->minscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINTEMPLATE):
+      if (getString(&web->mintemplate) == MS_FAILURE)
+        return (-1);
+      break;
+    case (QUERYFORMAT): /* change to use validation in 6.0 */
+      free(web->queryformat);
+      web->queryformat = NULL; /* there is a default */
+      if (getString(&web->queryformat) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&web->template) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (VALIDATION):
+      if (loadHashTable(&(web->validation)) != MS_SUCCESS)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadWeb()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
+    }
+  }
+}
+
+int msUpdateWebFromString(webObj *web, char *string) {
+  if (!web || !string)
+    return MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = string;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 */
+
+  if (loadWeb(web, web->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  msyylex_destroy();
+  return MS_SUCCESS;
+}
+
+/*
+** Initialize, load and free a mapObj structure
+**
+** This really belongs in mapobject.c, but currently it also depends on
+** lots of other init methods in this file.
+*/
+
+int initMap(mapObj *map) {
+  int i = 0;
+  MS_REFCNT_INIT(map);
+
+  map->debug = (int)msGetGlobalDebugLevel();
+
+  /* Set maxlayers = 0, layers[] and layerorder[] will be allocated as needed,
+   * on the first call to msGrowMapLayers()
+   */
+  map->numlayers = 0;
+  map->maxlayers = 0;
+  map->layers = NULL;
+  map->layerorder =
+      NULL; /* used to modify the order in which the layers are drawn */
+
+  map->status = MS_ON;
+  map->name = msStrdup("MS");
+  map->extent.minx = map->extent.miny = map->extent.maxx = map->extent.maxy =
+      -1.0;
+
+  map->scaledenom = -1.0;
+  map->resolution = MS_DEFAULT_RESOLUTION;    /* pixels per inch */
+  map->defresolution = MS_DEFAULT_RESOLUTION; /* pixels per inch */
+
+  map->height = map->width = -1;
+  map->maxsize = MS_MAXIMAGESIZE_DEFAULT;
+
+  map->gt.need_geotransform = MS_FALSE;
+  map->gt.rotation_angle = 0.0;
+
+  map->units = MS_METERS;
+  map->cellsize = 0;
+  map->shapepath = NULL;
+  map->mappath = NULL;
+  map->sldurl = NULL;
+
+  MS_INIT_COLOR(map->imagecolor, 255, 255, 255, 255); /* white */
+
+  map->numoutputformats = 0;
+  map->outputformatlist = NULL;
+  map->outputformat = NULL;
+
+  /* map->configoptions = msCreateHashTable();; */
+  initHashTable(&(map->configoptions));
+
+  map->imagetype = NULL;
+
+  map->palette.numcolors = 0;
+
+  for (i = 0; i < MS_MAX_LABEL_PRIORITY; i++) {
+    map->labelcache.slots[i].labels =
+        NULL; /* cache is initialize at draw time */
+    map->labelcache.slots[i].cachesize = 0;
+    map->labelcache.slots[i].numlabels = 0;
+    map->labelcache.slots[i].markers = NULL;
+    map->labelcache.slots[i].markercachesize = 0;
+    map->labelcache.slots[i].nummarkers = 0;
+  }
+
+  map->fontset.filename = NULL;
+  map->fontset.numfonts = 0;
+
+  /* map->fontset.fonts = NULL; */
+  initHashTable(&(map->fontset.fonts));
+
+  msInitSymbolSet(&map->symbolset);
+  map->symbolset.fontset = &(map->fontset);
+  map->symbolset.map = map;
+
+  initLegend(&map->legend);
+  initScalebar(&map->scalebar);
+  initWeb(&map->web);
+  initReferenceMap(&map->reference);
+  initQueryMap(&map->querymap);
+
+  map->projContext = msProjectionContextGetFromPool();
+
+  if (msInitProjection(&(map->projection)) == -1)
+    return (-1);
+  if (msInitProjection(&(map->latlon)) == -1)
+    return (-1);
+
+  msProjectionSetContext(&(map->projection), map->projContext);
+  msProjectionSetContext(&(map->latlon), map->projContext);
+
+  /* initialize a default "geographic" projection */
+  map->latlon.numargs = 2;
+  map->latlon.args[0] = msStrdup("proj=latlong");
+  map->latlon.args[1] =
+      msStrdup("ellps=WGS84"); /* probably want a different ellipsoid */
+  if (msProcessProjection(&(map->latlon)) == -1)
+    return (-1);
+
+  map->templatepattern = map->datapattern = NULL;
+
+  /* Encryption key information - see mapcrypto.c */
+  map->encryption_key_loaded = MS_FALSE;
+
+  msInitQuery(&(map->query));
+
+#ifdef USE_V8_MAPSCRIPT
+  map->v8context = NULL;
+#endif
+
+  map->config = NULL;
+
+  return (0);
+}
+
+/*
+** Ensure there is at least one free entry in the layers and layerorder
+** arrays of this mapObj. Grow the allocated layers/layerorder arrays if
+** necessary and allocate a new layer for layers[numlayers] if there is
+** not already one, setting its contents to all zero bytes (i.e. does not
+** call initLayer() on it).
+**
+** This function is safe to use for the initial allocation of the layers[]
+** and layerorder[] arrays as well (i.e. when maxlayers==0 and layers==NULL)
+**
+** Returns a reference to the new layerObj on success, NULL on error.
+*/
+layerObj *msGrowMapLayers(mapObj *map) {
+  /* Do we need to increase the size of layers/layerorder by
+   * MS_LAYER_ALLOCSIZE?
+   */
+  if (map->numlayers == map->maxlayers) {
+    layerObj **newLayersPtr;
+    int *newLayerorderPtr;
+    int i, newsize;
+
+    newsize = map->maxlayers + MS_LAYER_ALLOCSIZE;
+
+    /* Alloc/realloc layers */
+    newLayersPtr =
+        (layerObj **)realloc(map->layers, newsize * sizeof(layerObj *));
+    MS_CHECK_ALLOC(newLayersPtr, newsize * sizeof(layerObj *), NULL);
+
+    map->layers = newLayersPtr;
+
+    /* Alloc/realloc layerorder */
+    newLayerorderPtr = (int *)realloc(map->layerorder, newsize * sizeof(int));
+    MS_CHECK_ALLOC(newLayerorderPtr, newsize * sizeof(int), NULL);
+
+    map->layerorder = newLayerorderPtr;
+
+    map->maxlayers = newsize;
+    for (i = map->numlayers; i < map->maxlayers; i++) {
+      map->layers[i] = NULL;
+      map->layerorder[i] = 0;
+    }
+  }
+
+  if (map->layers[map->numlayers] == NULL) {
+    map->layers[map->numlayers] = (layerObj *)calloc(1, sizeof(layerObj));
+    MS_CHECK_ALLOC(map->layers[map->numlayers], sizeof(layerObj), NULL);
+  }
+
+  return map->layers[map->numlayers];
+}
+
+int msFreeLabelCacheSlot(labelCacheSlotObj *cacheslot) {
+  int i, j;
+
+  /* free the labels */
+  if (cacheslot->labels) {
+    for (i = 0; i < cacheslot->numlabels; i++) {
+
+      for (j = 0; j < cacheslot->labels[i].numtextsymbols; j++) {
+        freeTextSymbol(cacheslot->labels[i].textsymbols[j]);
+        free(cacheslot->labels[i].textsymbols[j]);
+      }
+      msFree(cacheslot->labels[i].textsymbols);
+
+      if (cacheslot->labels[i].leaderline) {
+        msFree(cacheslot->labels[i].leaderline->point);
+        msFree(cacheslot->labels[i].leaderline);
+        msFree(cacheslot->labels[i].leaderbbox);
+      }
+    }
+  }
+  msFree(cacheslot->labels);
+  cacheslot->labels = NULL;
+  cacheslot->cachesize = 0;
+  cacheslot->numlabels = 0;
+
+  msFree(cacheslot->markers);
+  cacheslot->markers = NULL;
+  cacheslot->markercachesize = 0;
+  cacheslot->nummarkers = 0;
+
+  return (MS_SUCCESS);
+}
+
+int msFreeLabelCache(labelCacheObj *cache) {
+  int p;
+
+  for (p = 0; p < MS_MAX_LABEL_PRIORITY; p++) {
+    if (msFreeLabelCacheSlot(&(cache->slots[p])) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  cache->num_allocated_rendered_members = cache->num_rendered_members = 0;
+  msFree(cache->rendered_text_symbols);
+
+  return MS_SUCCESS;
+}
+
+int msInitLabelCacheSlot(labelCacheSlotObj *cacheslot) {
+
+  if (cacheslot->labels || cacheslot->markers)
+    msFreeLabelCacheSlot(cacheslot);
+
+  cacheslot->labels = (labelCacheMemberObj *)malloc(
+      sizeof(labelCacheMemberObj) * MS_LABELCACHEINITSIZE);
+  MS_CHECK_ALLOC(cacheslot->labels,
+                 sizeof(labelCacheMemberObj) * MS_LABELCACHEINITSIZE,
+                 MS_FAILURE);
+
+  cacheslot->cachesize = MS_LABELCACHEINITSIZE;
+  cacheslot->numlabels = 0;
+
+  cacheslot->markers = (markerCacheMemberObj *)malloc(
+      sizeof(markerCacheMemberObj) * MS_LABELCACHEINITSIZE);
+  MS_CHECK_ALLOC(cacheslot->markers,
+                 sizeof(markerCacheMemberObj) * MS_LABELCACHEINITSIZE,
+                 MS_FAILURE);
+
+  cacheslot->markercachesize = MS_LABELCACHEINITSIZE;
+  cacheslot->nummarkers = 0;
+
+  return (MS_SUCCESS);
+}
+
+int msInitLabelCache(labelCacheObj *cache) {
+  int p;
+
+  for (p = 0; p < MS_MAX_LABEL_PRIORITY; p++) {
+    if (msInitLabelCacheSlot(&(cache->slots[p])) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+  cache->gutter = 0;
+  cache->num_allocated_rendered_members = cache->num_rendered_members = 0;
+  cache->rendered_text_symbols = NULL;
+
+  return MS_SUCCESS;
+}
+
+static void writeMap(FILE *stream, int indent, mapObj *map) {
+  int i;
+  colorObj c;
+
+  writeBlockBegin(stream, indent, "MAP");
+  writeNumber(stream, indent, "ANGLE", 0, map->gt.rotation_angle);
+  writeHashTableInline(stream, indent, "CONFIG", &(map->configoptions));
+  writeNumber(stream, indent, "DEBUG", 0, map->debug);
+  writeNumber(stream, indent, "DEFRESOLUTION", 72.0, map->defresolution);
+  writeExtent(stream, indent, "EXTENT", map->extent);
+  writeString(stream, indent, "FONTSET", NULL, map->fontset.filename);
+  MS_INIT_COLOR(c, 255, 255, 255, 255);
+  writeColor(stream, indent, "IMAGECOLOR", &c, &(map->imagecolor));
+  writeString(stream, indent, "IMAGETYPE", NULL, map->imagetype);
+  writeNumber(stream, indent, "MAXSIZE", MS_MAXIMAGESIZE_DEFAULT, map->maxsize);
+  writeString(stream, indent, "NAME", NULL, map->name);
+  writeNumber(stream, indent, "RESOLUTION", 72.0, map->resolution);
+  writeString(stream, indent, "SHAPEPATH", NULL, map->shapepath);
+  writeDimension(stream, indent, "SIZE", map->width, map->height, NULL, NULL);
+  writeKeyword(stream, indent, "STATUS", map->status, 2, MS_ON, "ON", MS_OFF,
+               "OFF");
+  writeString(stream, indent, "SYMBOLSET", NULL, map->symbolset.filename);
+  writeKeyword(stream, indent, "UNITS", map->units, 7, MS_INCHES, "INCHES",
+               MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS, "METERS",
+               MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES",
+               MS_DD, "DD");
+  writeLineFeed(stream);
+
+  writeOutputformat(stream, indent, map);
+
+  /* write symbol with INLINE tag in mapfile */
+  for (i = 0; i < map->symbolset.numsymbols; i++) {
+    if (map->symbolset.symbol[i]->inmapfile)
+      writeSymbol(map->symbolset.symbol[i], stream);
+  }
+
+  writeProjection(stream, indent, &(map->projection));
+
+  writeLegend(stream, indent, &(map->legend));
+  writeQueryMap(stream, indent, &(map->querymap));
+  writeReferenceMap(stream, indent, &(map->reference));
+  writeScalebar(stream, indent, &(map->scalebar));
+  writeWeb(stream, indent, &(map->web));
+
+  for (i = 0; i < map->numlayers; i++)
+    writeLayer(stream, indent, GET_LAYER(map, map->layerorder[i]));
+
+  writeBlockEnd(stream, indent, "MAP");
+}
+
+char *msWriteMapToString(mapObj *map) {
+  msIOContext context;
+  msIOBuffer buffer;
+
+  context.label = NULL;
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = &buffer;
+  buffer.data = NULL;
+  buffer.data_len = 0;
+  buffer.data_offset = 0;
+
+  msIO_installHandlers(NULL, &context, NULL);
+
+  writeMap(stdout, 0, map);
+  msIO_bufferWrite(&buffer, "", 1);
+
+  msIO_installHandlers(NULL, NULL, NULL);
+
+  return (char *)buffer.data;
+}
+
+int msSaveMap(mapObj *map, char *filename) {
+  FILE *stream;
+  char szPath[MS_MAXPATHLEN];
+
+  if (!map) {
+    msSetError(MS_MISCERR, "Map is undefined.", "msSaveMap()");
+    return (-1);
+  }
+
+  if (!filename) {
+    msSetError(MS_MISCERR, "Filename is undefined.", "msSaveMap()");
+    return (-1);
+  }
+
+  stream = fopen(msBuildPath(szPath, map->mappath, filename), "w");
+  if (!stream) {
+    msSetError(MS_IOERR, "(%s)", "msSaveMap()", filename);
+    return (-1);
+  }
+
+  writeMap(stream, 0, map);
+  fclose(stream);
+
+  return (0);
+}
+
+static void writeConfig(FILE *stream, int indent, configObj *config) {
+  writeBlockBegin(stream, indent, "CONFIG");
+  writeHashTable(stream, indent, "ENV", &(config->env));
+  writeHashTable(stream, indent, "MAPS", &(config->maps));
+  writeBlockEnd(stream, indent, "CONFIG");
+}
+
+int msSaveConfig(configObj *config, const char *filename) {
+  FILE *stream;
+
+  if (!config) {
+    msSetError(MS_MISCERR, "Config is undefined.", "msSaveConfigMap()");
+    return (-1);
+  }
+
+  if (!filename) {
+    msSetError(MS_MISCERR, "Filename is undefined.", "msSaveConfigMap()");
+    return (-1);
+  }
+
+  stream = fopen(filename, "w");
+  if (!stream) {
+    msSetError(MS_IOERR, "(%s)", "msSaveConfig()", filename);
+    return (-1);
+  }
+
+  writeConfig(stream, 0, config);
+  fclose(stream);
+
+  return (0);
+}
+
+static int loadMapInternal(mapObj *map) {
+  int foundMapToken = MS_FALSE;
+  int foundBomToken = MS_FALSE;
+  int token;
+
+  for (;;) {
+
+    token = msyylex();
+
+    if (!foundBomToken && token == BOM) {
+      foundBomToken = MS_TRUE;
+      if (!foundMapToken) {
+        continue; /*skip a leading bom*/
+      }
+    }
+    if (!foundMapToken && token != MAP) {
+      msSetError(MS_IDENTERR,
+                 "First token must be MAP, this doesn't look like a mapfile.",
+                 "msLoadMap()");
+      return (MS_FAILURE);
+    }
+
+    switch (token) {
+
+    case (CONFIG): {
+      char *key = NULL, *value = NULL;
+
+      if (getString(&key) == MS_FAILURE)
+        return MS_FAILURE;
+
+      if (getString(&value) == MS_FAILURE) {
+        free(key);
+        return MS_FAILURE;
+      }
+
+      if (msSetConfigOption(map, key, value) == MS_FAILURE) {
+        free(key);
+        free(value);
+        return MS_FAILURE;
+      }
+
+      free(key);
+      free(value);
+    } break;
+    case (DEBUG):
+      if ((map->debug = getSymbol(3, MS_ON, MS_OFF, MS_NUMBER)) == -1)
+        return MS_FAILURE;
+      if (map->debug == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid DEBUG level, must be between 0 and 5 (line %d)",
+                     "msLoadMap()", msyylineno);
+          return (-1);
+        }
+        map->debug = (int)msyynumber;
+      }
+      break;
+    case (END):
+      if (msyyin) {
+        fclose(msyyin);
+        msyyin = NULL;
+      }
+
+      /*** Make config options current ***/
+      msApplyMapConfigOptions(map);
+
+      /*** Compute rotated extent info if applicable ***/
+      msMapComputeGeotransform(map);
+
+      /*** OUTPUTFORMAT related setup ***/
+      if (msPostMapParseOutputFormatSetup(map) == MS_FAILURE)
+        return MS_FAILURE;
+
+      if (loadSymbolSet(&(map->symbolset), map) == -1)
+        return MS_FAILURE;
+
+      if (resolveSymbolNames(map) == MS_FAILURE)
+        return MS_FAILURE;
+
+      if (msLoadFontSet(&(map->fontset), map) == -1)
+        return MS_FAILURE;
+
+      return MS_SUCCESS;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "msLoadMap()");
+      return MS_FAILURE;
+    case (EXTENT): {
+      if (getDouble(&(map->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (getDouble(&(map->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (getDouble(&(map->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (getDouble(&(map->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (!MS_VALID_EXTENT(map->extent)) {
+        msSetError(MS_MISCERR,
+                   "Given map extent is invalid. Check that it "
+                   "is in the form: minx, miny, maxx, maxy",
+                   "loadMapInternal()");
+        return MS_FAILURE;
+      }
+    } break;
+    case (ANGLE): {
+      double rotation_angle;
+      if (getDouble(&(rotation_angle), MS_NUM_CHECK_RANGE, -360, 360) == -1)
+        return MS_FAILURE;
+      msMapSetRotation(map, rotation_angle);
+    } break;
+    case (FONTSET):
+      if (getString(&map->fontset.filename) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (IMAGECOLOR):
+      if (loadColor(&(map->imagecolor), NULL) != MS_SUCCESS)
+        return MS_FAILURE;
+      break;
+    case (IMAGETYPE):
+      msFree(map->imagetype);
+      map->imagetype = getToken();
+      break;
+    case (LATLON):
+      if (loadProjection(&map->latlon) == -1)
+        return MS_FAILURE;
+      break;
+    case (LAYER):
+      if (msGrowMapLayers(map) == NULL)
+        return MS_FAILURE;
+      if (initLayer((GET_LAYER(map, map->numlayers)), map) == -1)
+        return MS_FAILURE;
+      if (loadLayer((GET_LAYER(map, map->numlayers)), map) == -1)
+        return MS_FAILURE;
+      GET_LAYER(map, map->numlayers)->index =
+          map->numlayers; /* save the index */
+      /* Update the layer order list with the layer's index. */
+      map->layerorder[map->numlayers] = map->numlayers;
+      map->numlayers++;
+      break;
+    case (OUTPUTFORMAT):
+      if (loadOutputFormat(map) == -1)
+        return MS_FAILURE;
+      break;
+    case (LEGEND):
+      if (loadLegend(&(map->legend), map) == -1)
+        return MS_FAILURE;
+      break;
+    case (MAP):
+      foundMapToken = MS_TRUE;
+      break;
+    case (MAXSIZE):
+      if (getInteger(&(map->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return MS_FAILURE;
+      break;
+    case (NAME):
+      free(map->name);
+      map->name = NULL; /* erase default */
+      if (getString(&map->name) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (PROJECTION):
+      if (loadProjection(&map->projection) == -1)
+        return MS_FAILURE;
+      break;
+    case (QUERYMAP):
+      if (loadQueryMap(&(map->querymap), map) == -1)
+        return MS_FAILURE;
+      break;
+    case (REFERENCE):
+      if (loadReferenceMap(&(map->reference), map) == -1)
+        return MS_FAILURE;
+      break;
+    case (RESOLUTION):
+      if (getDouble(&(map->resolution), MS_NUM_CHECK_RANGE, MS_RESOLUTION_MIN,
+                    MS_RESOLUTION_MAX) == -1)
+        return MS_FAILURE;
+      break;
+    case (DEFRESOLUTION):
+      if (getDouble(&(map->defresolution), MS_NUM_CHECK_RANGE,
+                    MS_RESOLUTION_MIN, MS_RESOLUTION_MAX) == -1)
+        return MS_FAILURE;
+      break;
+    case (SCALE):
+    case (SCALEDENOM):
+      if (getDouble(&(map->scaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1)
+        return MS_FAILURE;
+      break;
+    case (SCALEBAR):
+      if (loadScalebar(&(map->scalebar)) == -1)
+        return MS_FAILURE;
+      break;
+    case (SHAPEPATH):
+      if (getString(&map->shapepath) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (SIZE):
+      if (getInteger(&(map->width), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1)
+        return MS_FAILURE;
+      if (getInteger(&(map->height), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1)
+        return MS_FAILURE;
+      break;
+    case (STATUS):
+      if ((map->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return MS_FAILURE;
+      break;
+    case (SYMBOL):
+      if (msGrowSymbolSet(&(map->symbolset)) == NULL)
+        return MS_FAILURE;
+      if ((loadSymbol(map->symbolset.symbol[map->symbolset.numsymbols],
+                      map->mappath) == -1)) {
+        msFreeSymbol(map->symbolset.symbol[map->symbolset.numsymbols]);
+        free(map->symbolset.symbol[map->symbolset.numsymbols]);
+        map->symbolset.symbol[map->symbolset.numsymbols] = NULL;
+        return MS_FAILURE;
+      }
+      map->symbolset.symbol[map->symbolset.numsymbols]->inmapfile = MS_TRUE;
+      map->symbolset.numsymbols++;
+      break;
+    case (SYMBOLSET):
+      if (getString(&map->symbolset.filename) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (UNITS):
+      if ((int)(map->units =
+                    getSymbol(7, MS_INCHES, MS_FEET, MS_MILES, MS_METERS,
+                              MS_KILOMETERS, MS_NAUTICALMILES, MS_DD)) == -1)
+        return MS_FAILURE;
+      break;
+    case (WEB):
+      if (loadWeb(&(map->web), map) == -1)
+        return MS_FAILURE;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "msLoadMap()", msyystring_buffer, msyylineno);
+      return MS_FAILURE;
+    }
+  } /* next token */
+}
+
+static bool msGetCWD(char *szBuffer, size_t nBufferSize,
+                     const char *pszFunctionName) {
+  if (NULL == getcwd(szBuffer, nBufferSize)) {
+#ifndef _WIN32
+    if (errno == EACCES)
+      msSetError(MS_MISCERR,
+                 "getcwd() failed with EACCES: you may need to force the "
+                 "current directory in the mapserver launcher "
+                 "(e.g -d option of spawn-fcgi)",
+                 pszFunctionName);
+    else if (errno == ENAMETOOLONG)
+      msSetError(MS_MISCERR, "getcwd() returned a too long path",
+                 pszFunctionName);
+    else
+      msSetError(MS_MISCERR, "getcwd() failed with errno code %d",
+                 pszFunctionName, errno);
+#else
+    msSetError(MS_MISCERR, "getcwd() returned a too long path",
+               pszFunctionName);
+#endif
+    return FALSE;
+  }
+  return TRUE;
+}
+
+/*
+ * Apply any SLD styles referenced in a LAYER's STYLEITEM
+ */
+static void applyStyleItemToLayer(mapObj *map) {
+
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *layer = GET_LAYER(map, i);
+
+    if (layer->styleitem && STARTS_WITH_CI(layer->styleitem, "sld://")) {
+      const char *filename = layer->styleitem + strlen("sld://");
+
+      if (*filename == '\0') {
+        msSetError(MS_IOERR, "Empty SLD filename: \"%s\".",
+                   "applyLayerDefaultSubstitutions()", layer->styleitem);
+      } else {
+        msSLDApplyFromFile(map, layer, filename);
+      }
+    }
+  }
+}
+
+/*
+** Sets up string-based mapfile loading and calls loadMapInternal to do the
+*work.
+*/
+mapObj *msLoadMapFromString(char *buffer, char *new_mappath,
+                            const configObj *config) {
+  mapObj *map;
+  struct mstimeval starttime = {0}, endtime = {0};
+  char szPath[MS_MAXPATHLEN], szCWDPath[MS_MAXPATHLEN];
+  char *mappath = NULL;
+  int debuglevel;
+
+  debuglevel = (int)msGetGlobalDebugLevel();
+
+  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
+    /* In debug mode, track time spent loading/parsing mapfile. */
+    msGettimeofday(&starttime, NULL);
+  }
+
+  if (!buffer) {
+    msSetError(MS_MISCERR, "No buffer to load.", "msLoadMapFromString()");
+    return (NULL);
+  }
+
+  /*
+  ** Allocate mapObj structure
+  */
+  map = (mapObj *)calloc(sizeof(mapObj), 1);
+  MS_CHECK_ALLOC(map, sizeof(mapObj), NULL);
+
+  if (initMap(map) == -1) { /* initialize this map */
+    msFreeMap(map);
+    return (NULL);
+  }
+
+  map->config = config; // create a read-only reference
+
+  msAcquireLock(TLOCK_PARSER); /* might need to move this lock a bit higher, yup
+                                  (bug 2108) */
+
+  msyystate = MS_TOKENIZE_STRING;
+  msyystring = buffer;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 1; /* start at line 1 (do lines mean anything here?) */
+
+  /* If new_mappath is provided then use it, otherwise use the CWD */
+  if (!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMapFromString()")) {
+    msFreeMap(map);
+    msReleaseLock(TLOCK_PARSER);
+  }
+  if (new_mappath) {
+    mappath = msStrdup(new_mappath);
+    map->mappath = msStrdup(msBuildPath(szPath, szCWDPath, mappath));
+  } else
+    map->mappath = msStrdup(szCWDPath);
+
+  msyybasepath = map->mappath; /* for INCLUDEs */
+
+  if (loadMapInternal(map) != MS_SUCCESS) {
+    msFreeMap(map);
+    msReleaseLock(TLOCK_PARSER);
+    if (mappath != NULL)
+      free(mappath);
+    return NULL;
+  }
+
+  if (mappath != NULL)
+    free(mappath);
+  msyylex_destroy();
+
+  msReleaseLock(TLOCK_PARSER);
+
+  applyStyleItemToLayer(map);
+
+  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
+    /* In debug mode, report time spent loading/parsing mapfile. */
+    msGettimeofday(&endtime, NULL);
+    msDebug("msLoadMapFromString(): %.3fs\n",
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+  }
+
+  if (resolveSymbolNames(map) == MS_FAILURE)
+    return NULL;
+
+  return map;
+}
+
+/*
+** Sets up file-based mapfile loading and calls loadMapInternal to do the work.
+*/
+mapObj *msLoadMap(const char *filename, const char *new_mappath,
+                  const configObj *config) {
+  mapObj *map;
+  struct mstimeval starttime = {0}, endtime = {0};
+  char szPath[MS_MAXPATHLEN], szCWDPath[MS_MAXPATHLEN];
+  int debuglevel;
+
+  debuglevel = (int)msGetGlobalDebugLevel();
+
+  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
+    /* In debug mode, track time spent loading/parsing mapfile. */
+    msGettimeofday(&starttime, NULL);
+  }
+
+  if (!filename) {
+    msSetError(MS_MISCERR, "Filename is undefined.", "msLoadMap()");
+    return (NULL);
+  }
+
+  const char *ms_mapfile_pattern =
+      CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
+  if (msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
+    msSetError(MS_REGEXERR, "Filename validation failed.", "msLoadMap()");
+    return (NULL);
+  }
+
+  /*
+  ** Allocate mapObj structure
+  */
+  map = (mapObj *)calloc(sizeof(mapObj), 1);
+  MS_CHECK_ALLOC(map, sizeof(mapObj), NULL);
+
+  if (initMap(map) == -1) { /* initialize this map */
+    msFreeMap(map);
+    return (NULL);
+  }
+
+  map->config = config; // create a read-only reference
+
+  msAcquireLock(TLOCK_PARSER); /* Steve: might need to move this lock a bit
+                                  higher; Umberto: done */
+
+#ifdef USE_XMLMAPFILE
+  /* If the mapfile is an xml mapfile, transform it */
+  const char *ms_xmlmapfile_xslt =
+      CPLGetConfigOption("MS_XMLMAPFILE_XSLT", NULL);
+  if (ms_xmlmapfile_xslt &&
+      (msEvalRegex(MS_DEFAULT_XMLMAPFILE_PATTERN, filename) == MS_TRUE)) {
+
+    msyyin = tmpfile();
+    if (msyyin == NULL) {
+      msSetError(MS_IOERR, "tmpfile() failed to create temporary file",
+                 "msLoadMap()");
+      msReleaseLock(TLOCK_PARSER);
+      msFreeMap(map);
+      return NULL;
+    }
+
+    if (msTransformXmlMapfile(ms_xmlmapfile_xslt, filename, msyyin) !=
+        MS_SUCCESS) {
+      fclose(msyyin);
+      msFreeMap(map);
+      return NULL;
+    }
+    fseek(msyyin, 0, SEEK_SET);
+  } else {
+#endif
+    if ((msyyin = fopen(filename, "r")) == NULL) {
+      msSetError(MS_IOERR, "(%s)", "msLoadMap()", filename);
+      msReleaseLock(TLOCK_PARSER);
+      msFreeMap(map);
+      return NULL;
+    }
+#ifdef USE_XMLMAPFILE
+  }
+#endif
+
+  msyystate = MS_TOKENIZE_FILE;
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyyrestart(msyyin); /* start at line begining, line 1 */
+  msyylineno = 1;
+
+  /* If new_mappath is provided then use it, otherwise use the location */
+  /* of the mapfile as the default path */
+  if (!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMap()")) {
+    msReleaseLock(TLOCK_PARSER);
+    msFreeMap(map);
+    return NULL;
+  }
+
+  if (new_mappath)
+    map->mappath = msStrdup(msBuildPath(szPath, szCWDPath, new_mappath));
+  else {
+    char *path = msGetPath(filename);
+    map->mappath = msStrdup(msBuildPath(szPath, szCWDPath, path));
+    free(path);
+  }
+
+  msyybasepath = map->mappath; /* for INCLUDEs */
+
+  if (loadMapInternal(map) != MS_SUCCESS) {
+    msFreeMap(map);
+    msReleaseLock(TLOCK_PARSER);
+    if (msyyin) {
+      msyycleanup_includes();
+      fclose(msyyin);
+      msyyin = NULL;
+    }
+    return NULL;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  applyStyleItemToLayer(map);
+
+  if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
+    /* In debug mode, report time spent loading/parsing mapfile. */
+    msGettimeofday(&endtime, NULL);
+    msDebug("msLoadMap(): %.3fs\n",
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+  }
+
+  return map;
+}
+
+static void hashTableSubstituteString(hashTableObj *hash, const char *from,
+                                      const char *to) {
+  const char *key, *val;
+  char *new_val;
+  key = msFirstKeyFromHashTable(hash);
+  while (key != NULL) {
+    val = msLookupHashTable(hash, key);
+    if (strcasestr(val, from)) {
+      new_val = msCaseReplaceSubstring(msStrdup(val), from, to);
+      msInsertHashTable(hash, key, new_val);
+      msFree(new_val);
+    }
+    key = msNextKeyFromHashTable(hash, key);
+  }
+}
+
+static void classSubstituteString(classObj *class, const char *from,
+                                  const char *to) {
+  if (class->expression.string)
+    class->expression.string =
+        msCaseReplaceSubstring(class->expression.string, from, to);
+  if (class->text.string)
+    class->text.string = msCaseReplaceSubstring(class->text.string, from, to);
+  if (class->title)
+    class->title = msCaseReplaceSubstring(class->title, from, to);
+}
+
+static void layerSubstituteString(layerObj *layer, const char *from,
+                                  const char *to) {
+  int c;
+  if (layer->data)
+    layer->data = msCaseReplaceSubstring(layer->data, from, to);
+  if (layer->tileindex)
+    layer->tileindex = msCaseReplaceSubstring(layer->tileindex, from, to);
+  if (layer->connection)
+    layer->connection = msCaseReplaceSubstring(layer->connection, from, to);
+  if (layer->filter.string)
+    layer->filter.string =
+        msCaseReplaceSubstring(layer->filter.string, from, to);
+  if (layer->mask)
+    layer->mask = msCaseReplaceSubstring(layer->mask, from, to); // new for 8.0
+
+  /* The bindvalues are most useful when able to substitute values from the URL
+   */
+  hashTableSubstituteString(&layer->bindvals, from, to);
+  hashTableSubstituteString(&layer->metadata, from, to);
+  msLayerSubstituteProcessing(layer, from, to);
+  for (c = 0; c < layer->numclasses; c++) {
+    classSubstituteString(layer->class[c], from, to);
+  }
+}
+
+static void mapSubstituteString(mapObj *map, const char *from, const char *to) {
+  int l;
+  for (l = 0; l < map->numlayers; l++) {
+    layerSubstituteString(GET_LAYER(map, l), from, to);
+  }
+
+  /* output formats (#3751) */
+  for (l = 0; l < map->numoutputformats; l++) {
+    int o;
+    for (o = 0; o < map->outputformatlist[l]->numformatoptions; o++) {
+      map->outputformatlist[l]->formatoptions[o] = msCaseReplaceSubstring(
+          map->outputformatlist[l]->formatoptions[o], from, to);
+    }
+  }
+
+  hashTableSubstituteString(&map->web.metadata, from, to);
+  if (map->web.template)
+    map->web.template = msCaseReplaceSubstring(map->web.template, from, to);
+}
+
+static void applyOutputFormatDefaultSubstitutions(outputFormatObj *format,
+                                                  const char *option,
+                                                  hashTableObj *table) {
+  const char *filename;
+
+  filename = msGetOutputFormatOption(format, option, NULL);
+  if (filename && strlen(filename) > 0) {
+    char *tmpfilename = msStrdup(filename);
+    const char *default_key = msFirstKeyFromHashTable(table);
+    while (default_key) {
+      if (!strncasecmp(default_key, "default_", 8)) {
+        char *new_filename = NULL;
+        size_t buffer_size = (strlen(default_key) - 5);
+        char *tag = (char *)msSmallMalloc(buffer_size);
+        snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
+
+        new_filename = msStrdup(tmpfilename);
+        new_filename = msCaseReplaceSubstring(
+            new_filename, tag, msLookupHashTable(table, default_key));
+        free(tag);
+
+        msSetOutputFormatOption(format, option, new_filename);
+        free(new_filename);
+      }
+      default_key = msNextKeyFromHashTable(table, default_key);
+    }
+    msFree(tmpfilename);
+  }
+  return;
+}
+
+static void applyClassDefaultSubstitutions(classObj *class,
+                                           hashTableObj *table) {
+  const char *default_key = msFirstKeyFromHashTable(table);
+  while (default_key) {
+    if (!strncasecmp(default_key, "default_", 8)) {
+      size_t buffer_size = (strlen(default_key) - 5);
+      char *tag = (char *)msSmallMalloc(buffer_size);
+      snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
+
+      classSubstituteString(class, tag, msLookupHashTable(table, default_key));
+      free(tag);
+    }
+    default_key = msNextKeyFromHashTable(table, default_key);
+  }
+  return;
+}
+
+static void applyLayerDefaultSubstitutions(layerObj *layer,
+                                           hashTableObj *table) {
+  int i;
+  const char *default_key = msFirstKeyFromHashTable(table);
+  while (default_key) {
+    if (!strncasecmp(default_key, "default_", 8)) {
+      size_t buffer_size = (strlen(default_key) - 5);
+      const char *to = msLookupHashTable(table, default_key);
+      char *tag = (char *)msSmallMalloc(buffer_size);
+      snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
+
+      for (i = 0; i < layer->numclasses; i++) {
+        classSubstituteString(layer->class[i], tag, to);
+      }
+      layerSubstituteString(layer, tag, to);
+      free(tag);
+    }
+    default_key = msNextKeyFromHashTable(table, default_key);
+  }
+
+  return;
+}
+
+static void applyHashTableDefaultSubstitutions(hashTableObj *hashTab,
+                                               hashTableObj *table) {
+  const char *default_key = msFirstKeyFromHashTable(table);
+  while (default_key) {
+    if (!strncasecmp(default_key, "default_", 8)) {
+      size_t buffer_size = (strlen(default_key) - 5);
+      const char *to = msLookupHashTable(table, default_key);
+      char *tag = (char *)msSmallMalloc(buffer_size);
+      snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
+
+      hashTableSubstituteString(hashTab, tag, to);
+      free(tag);
+    }
+    default_key = msNextKeyFromHashTable(table, default_key);
+  }
+  return;
+}
+
+/*
+** Loop through layer metadata for keys that have a default_%key% pattern to
+*replace
+** remaining %key% entries by their default value.
+*/
+void msApplyDefaultSubstitutions(mapObj *map) {
+  int i, j;
+
+  /* output formats (#3751) */
+  for (i = 0; i < map->numoutputformats; i++) {
+    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "filename",
+                                          &(map->web.validation));
+    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "JSONP",
+                                          &(map->web.validation));
+  }
+
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *layer = GET_LAYER(map, i);
+
+    for (j = 0; j < layer->numclasses;
+         j++) { /* class settings take precedence...  */
+      classObj *class = GET_CLASS(map, i, j);
+      applyClassDefaultSubstitutions(class, &(class->validation));
+    }
+
+    applyLayerDefaultSubstitutions(
+        layer, &(layer->validation)); /* ...then layer settings... */
+    applyLayerDefaultSubstitutions(
+        layer, &(map->web.validation)); /* ...and finally web settings */
+  }
+  applyHashTableDefaultSubstitutions(&map->web.metadata,
+                                     &(map->web.validation));
+}
+
+char *_get_param_value(const char *key, char **names, char **values,
+                       int npairs) {
+  if (npairs <= 0)
+    return NULL; // bail, no point searching
+
+  if (getenv(key)) { /* environment override */
+    return getenv(key);
+  }
+  while (npairs) {
+    npairs--;
+    if (strcasecmp(key, names[npairs]) == 0) {
+      return values[npairs];
+    }
+  }
+  return NULL;
+}
+
+void msApplySubstitutions(mapObj *map, char **names, char **values,
+                          int npairs) {
+  int l;
+  const char *key, *value, *validation;
+  char *tag;
+  for (l = 0; l < map->numlayers; l++) {
+    int c;
+    layerObj *lp = GET_LAYER(map, l);
+    for (c = 0; c < lp->numclasses; c++) {
+      classObj *cp = lp->class[c];
+      key = NULL;
+      while ((key = msNextKeyFromHashTable(&cp->validation, key))) {
+        value = _get_param_value(key, names, values, npairs);
+        if (!value)
+          continue; /*parameter was not in url*/
+        validation = msLookupHashTable(&cp->validation, key);
+        if (msEvalRegex(validation, value)) {
+          /* we've found a substitution and it validates correctly, now let's
+           * apply it */
+          tag = msSmallMalloc(strlen(key) + 3);
+          sprintf(tag, "%%%s%%", key);
+          classSubstituteString(cp, tag, value);
+          free(tag);
+        } else {
+          msSetError(MS_REGEXERR, "Parameter pattern validation failed.",
+                     "msApplySubstitutions()");
+          if (map->debug || lp->debug) {
+            msDebug("layer (%s), class %d: failed to validate (%s=%s) for "
+                    "regex (%s)\n",
+                    lp->name, c, key, value, validation);
+          }
+        }
+      }
+    }
+    key = NULL;
+    while ((key = msNextKeyFromHashTable(&lp->validation, key))) {
+      value = _get_param_value(key, names, values, npairs);
+      if (!value)
+        continue; /*parameter was not in url*/
+      validation = msLookupHashTable(&lp->validation, key);
+      if (msEvalRegex(validation, value)) {
+        /* we've found a substitution and it validates correctly, now let's
+         * apply it */
+        tag = msSmallMalloc(strlen(key) + 3);
+        sprintf(tag, "%%%s%%", key);
+        layerSubstituteString(lp, tag, value);
+        free(tag);
+      } else {
+        msSetError(MS_REGEXERR, "Parameter pattern validation failed.",
+                   "msApplySubstitutions()");
+        if (map->debug || lp->debug) {
+          msDebug("layer (%s): failed to validate (%s=%s) for regex (%s)\n",
+                  lp->name, key, value, validation);
+        }
+      }
+    }
+  }
+  key = NULL;
+  while ((key = msNextKeyFromHashTable(&map->web.validation, key))) {
+    value = _get_param_value(key, names, values, npairs);
+    if (!value)
+      continue; /*parameter was not in url*/
+    validation = msLookupHashTable(&map->web.validation, key);
+    if (msEvalRegex(validation, value)) {
+      /* we've found a substitution and it validates correctly, now let's apply
+       * it */
+      tag = msSmallMalloc(strlen(key) + 3);
+      sprintf(tag, "%%%s%%", key);
+      mapSubstituteString(map, tag, value);
+      free(tag);
+    } else {
+      msSetError(MS_REGEXERR, "Parameter pattern validation failed.",
+                 "msApplySubstitutions()");
+      if (map->debug) {
+        msDebug("failed to validate (%s=%s) for regex (%s)\n", key, value,
+                validation);
+      }
+    }
+  }
+}
+
+/*
+** Returns an array with one entry per mapfile token.  Useful to manipulate
+** mapfiles in MapScript.
+**
+** The returned array should be freed using msFreeCharArray().
+*/
+static char **tokenizeMapInternal(char *filename, int *ret_numtokens) {
+  char **tokens = NULL;
+  int numtokens = 0, numtokens_allocated = 0;
+  size_t buffer_size = 0;
+
+  *ret_numtokens = 0;
+
+  if (!filename) {
+    msSetError(MS_MISCERR, "Filename is undefined.", "msTokenizeMap()");
+    return NULL;
+  }
+
+  /*
+  ** Check map filename to make sure it's legal
+  */
+  const char *ms_mapfile_pattern =
+      CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
+  if (msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
+    msSetError(MS_REGEXERR, "Filename validation failed.", "msTokenizeMap()");
+    return (NULL);
+  }
+
+  if ((msyyin = fopen(filename, "r")) == NULL) {
+    msSetError(MS_IOERR, "(%s)", "msTokenizeMap()", filename);
+    return NULL;
+  }
+
+  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return
+                                   comments */
+  msyylex();
+  msyyreturncomments = 1; /* want all tokens, including comments */
+
+  msyyrestart(msyyin); /* start at line begining, line 1 */
+  msyylineno = 1;
+
+  numtokens = 0;
+  numtokens_allocated = 256;
+  tokens = (char **)malloc(numtokens_allocated * sizeof(char *));
+  if (tokens == NULL) {
+    msSetError(MS_MEMERR, NULL, "msTokenizeMap()");
+    fclose(msyyin);
+    return NULL;
+  }
+
+  for (;;) {
+
+    if (numtokens_allocated <= numtokens) {
+      numtokens_allocated *=
+          2; /* double size of the array every time we reach the limit */
+      char **tokensNew =
+          (char **)realloc(tokens, numtokens_allocated * sizeof(char *));
+      if (tokensNew == NULL) {
+        msSetError(MS_MEMERR, "Realloc() error.", "msTokenizeMap()");
+        fclose(msyyin);
+        for (int i = 0; i < numtokens; i++)
+          msFree(tokens[i]);
+        msFree(tokens);
+        return NULL;
+      }
+      tokens = tokensNew;
+    }
+
+    switch (msyylex()) {
+    case (EOF): /* This is the normal way out... cleanup and exit */
+      fclose(msyyin);
+      *ret_numtokens = numtokens;
+      return (tokens);
+      break;
+    case (MS_STRING):
+      buffer_size = strlen(msyystring_buffer) + 2 + 1;
+      tokens[numtokens] = (char *)msSmallMalloc(buffer_size);
+      snprintf(tokens[numtokens], buffer_size, "\"%s\"", msyystring_buffer);
+      break;
+    case (MS_EXPRESSION):
+      buffer_size = strlen(msyystring_buffer) + 2 + 1;
+      tokens[numtokens] = (char *)msSmallMalloc(buffer_size);
+      snprintf(tokens[numtokens], buffer_size, "(%s)", msyystring_buffer);
+      break;
+    case (MS_REGEX):
+      buffer_size = strlen(msyystring_buffer) + 2 + 1;
+      tokens[numtokens] = (char *)msSmallMalloc(buffer_size);
+      snprintf(tokens[numtokens], buffer_size, "/%s/", msyystring_buffer);
+      break;
+    default:
+      tokens[numtokens] = msStrdup(msyystring_buffer);
+      break;
+    }
+
+    if (tokens[numtokens] == NULL) {
+      int i;
+      msSetError(MS_MEMERR, NULL, "msTokenizeMap()");
+      fclose(msyyin);
+      for (i = 0; i < numtokens; i++)
+        msFree(tokens[i]);
+      msFree(tokens);
+      return NULL;
+    }
+
+    numtokens++;
+  }
+
+  return NULL; /* should never get here */
+}
+
+/*
+** Wraps tokenizeMapInternal
+*/
+char **msTokenizeMap(char *filename, int *numtokens) {
+  char **tokens;
+
+  msAcquireLock(TLOCK_PARSER);
+  tokens = tokenizeMapInternal(filename, numtokens);
+  msReleaseLock(TLOCK_PARSER);
+
+  return tokens;
+}
+
+void msCloseConnections(mapObj *map) {
+  int i;
+  layerObj *lp;
+
+  for (i = 0; i < map->numlayers; i++) {
+    lp = (GET_LAYER(map, i));
+
+    /* If the vtable is null, then the layer is never accessed or used -> skip
+     * it
+     */
+    if (lp->vtable) {
+      lp->vtable->LayerCloseConnection(lp);
+    }
+  }
+}
+
+void initResultCache(resultCacheObj *resultcache) {
+  if (resultcache) {
+    resultcache->results = NULL;
+    resultcache->numresults = 0;
+    resultcache->cachesize = 0;
+    resultcache->bounds.minx = resultcache->bounds.miny =
+        resultcache->bounds.maxx = resultcache->bounds.maxy = -1;
+    resultcache->previousBounds = resultcache->bounds;
+  }
+}
+
+void cleanupResultCache(resultCacheObj *resultcache) {
+  if (resultcache) {
+    if (resultcache->results) {
+      int i;
+      for (i = 0; i < resultcache->numresults; i++) {
+        if (resultcache->results[i].shape) {
+          msFreeShape(resultcache->results[i].shape);
+          msFree(resultcache->results[i].shape);
+        }
+      }
+      free(resultcache->results);
+    }
+    resultcache->results = NULL;
+    initResultCache(resultcache);
+  }
+}
+
+static int resolveSymbolNames(mapObj *map) {
+  int i, j;
+
+  /* step through layers and classes to resolve symbol names */
+  for (i = 0; i < map->numlayers; i++) {
+    for (j = 0; j < GET_LAYER(map, i)->numclasses; j++) {
+      if (classResolveSymbolNames(GET_LAYER(map, i)->class[j]) != MS_SUCCESS)
+        return MS_FAILURE;
+    }
+  }
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapfile.dtd 8.2.0~beta1-1~exp1/src/mapfile.dtd
--- 8.0.1-5/src/mapfile.dtd	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapfile.dtd	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,243 @@
+<!-- MapServer Map File DTD -->
+
+<!-- 
+  top level MAP object 
+
+<!ELEMENT MAP 
+  ((EXTENT|FONTSET|IMAGECOLOR|IMAGETYPE|IMAGEQUALITY|INTERLACE|SHAPEPATH|SIZE|SYMBOLSET|TRANSPARENT|UNITS|METADATA)*,(LEGEND|PROJECTION|QUERYMAP|REFERENCE|SCALEBAR|WEB)*,(SYMBOL|LAYER)+)
+>
+
+  -->
+<!ELEMENT MAP 
+  (EXTENT|FONTSET|IMAGECOLOR|IMAGETYPE|IMAGEQUALITY|INTERLACE|SHAPEPATH|SIZE|SYMBOLSET|TRANSPARENT|UNITS|METADATA|LEGEND|PROJECTION|QUERYMAP|REFERENCE|SCALEBAR|WEB|SYMBOL|LAYER)*
+>
+<!ATTLIST MAP 
+  NAME NMTOKEN #REQUIRED
+  STATUS (ON|OFF) "ON"
+>
+<!ELEMENT EXTENT (#PCDATA)>
+<!ELEMENT FONTSET (#PCDATA)>
+<!ELEMENT IMAGECOLOR (#PCDATA)>
+<!ELEMENT IMAGETYPE (#PCDATA)>
+<!ELEMENT IMAGEQUALITY (#PCDATA)>
+<!ELEMENT INTERLACE (#PCDATA)>
+<!ELEMENT SHAPEPATH (#PCDATA)>
+<!ELEMENT SIZE (#PCDATA)>
+<!ELEMENT SYMBOLSET (#PCDATA)>
+<!ELEMENT TRANSPARENT (#PCDATA)>
+<!ELEMENT UNITS (#PCDATA)>
+
+<!-- 
+  LEGEND object
+  -->
+<!ELEMENT LEGEND 
+  (IMAGECOLOR|INTERLACE|KEYSIZE|KEYSPACING|LABEL|OUTLINECOLOR|POSITION|POSTLABELCACHE|TRANSPARENT)*
+>
+<!ATTLIST LEGEND
+  STATUS (ON|OFF|EMBED) "OFF"
+>
+<!-- IMAGECOLOR already declared -->
+<!-- INTERLACE already declared -->
+<!ELEMENT KEYSIZE (#PCDATA)>
+<!ELEMENT KEYSPACING (#PCDATA)>
+<!ELEMENT OUTLINECOLOR (#PCDATA)>
+<!ELEMENT POSITION (#PCDATA)>
+<!ELEMENT POSTLABELCACHE (#PCDATA)>
+<!-- TRANSPARENT already declared -->
+
+<!-- 
+  QUERYMAP object
+  -->
+<!ELEMENT QUERYMAP 
+  (COLOR|SIZE)*
+>
+<!ATTLIST QUERYMAP   
+  STATUS (ON|OFF) "OFF"
+  STYLE (HILITE|NORMAL|SELECTED) "HILITE"
+>
+<!ELEMENT COLOR (#PCDATA)>
+<!-- SIZE already declared -->
+
+<!-- 
+  a PROJECTION object - nothing more that character data 
+  -->
+<!ELEMENT PROJECTION (#PCDATA)>
+
+<!-- 
+  a SCALEBAR object
+  -->
+<!ELEMENT SCALEBAR 
+  (BACKGROUNDCOLOR|COLOR|IMAGECOLOR|INTERLACE|INTERVALS|LABEL|OUTLINECOLOR|POSITION|POSTLABELCACHE|SIZE|TRANSPARENT|UNITS)*
+>
+<!ATTLIST SCALEBAR
+  STATUS (ON|OFF|EMBED) "OFF"
+  STYLE (0|1) "0"
+>
+<!ELEMENT BACKGROUNDCOLOR (#PCDATA)>
+<!-- ELEMENT COLOR (#PCDATA) -->
+<!-- IMAGECOLOR already declared -->
+<!-- INTERLACE already declared -->
+<!ELEMENT INTERVALS (#PCDATA)>
+<!-- OUTLINECOLOR already declared -->
+<!-- POSITION already declared -->
+<!-- POSTLABELCACHE already declared -->
+<!-- SIZE already declared -->
+<!-- TRANSPARENT already declared -->
+<!-- UNITS already declared -->
+
+<!-- 
+  a REFERENCE map object
+  -->
+<!ELEMENT REFERENCE
+  (COLOR|EXTENT|IMAGE|OUTLINECOLOR|SIZE)*
+>
+<!ATTLIST REFERENCE
+  STATUS (ON|OFF) "OFF"
+>
+<!-- COLOR already declared -->
+<!-- EXTENT already declared -->
+<!ELEMENT IMAGE (#PCDATA)>
+<!-- OUTLINECOLOR already declared -->
+<!-- SIZE already declared -->
+
+<!-- 
+  a WEB object
+  -->
+<!ELEMENT WEB
+  (ERROR|EMPTY|FOOTER|HEADER|IMAGEPATH|IMAGEURL|LOG|MAXSCALE|MAXTEMPLATE|MINSCALE|MINTEMPLATE|TEMPLATE|METADATA)*
+>
+<!ELEMENT EMPTY (#PCDATA)>
+<!ELEMENT ERROR (#PCDATA)>
+<!ELEMENT FOOTER (#PCDATA)>
+<!ELEMENT HEADER (#PCDATA)>
+<!ELEMENT IMAGEPATH (#PCDATA)>
+<!ELEMENT IMAGEURL (#PCDATA)>
+<!ELEMENT LOG (#PCDATA)>
+<!ELEMENT MAXSCALE (#PCDATA)>
+<!ELEMENT MAXTEMPLATE (#PCDATA)>
+<!ELEMENT MINSCALE (#PCDATA)>
+<!ELEMENT MINTEMPLATE (#PCDATA)>
+<!ELEMENT TEMPLATE (#PCDATA)>
+<!ELEMENT METADATA (#PCDATA)>
+
+<!--
+  a LAYER object
+  -->
+<!ELEMENT LAYER 
+  (CLASS|CLASSITEM|CONNECTION|CONNECTIONTYPE|DATA|DESCRIPTION|FEATURE|FILTER|FILTERITEM|FOOTER|GROUP|HEADER|TEMPLATE|LABELANGLEITEM|LABELCACHE|LABELITEM|LABELMAXSCALE|LABELMINSCALE|LABELREQUIRES|LABELSIZEITEM|MAXFEATURES|MAXSCALE|MINSCALE|OFFSITE|POSTLABELCACHE|PROJECTION|REQUIRES|SYMBOLSCALE|TILEINDEX|TILEITEM|TILESRS|TOLERANCE|TOLERANCEUNITS|TRANSFORM|TRANSPARENCY|METADATA)*
+>
+<!ATTLIST LAYER 
+  NAME NMTOKEN #REQUIRED
+  STATUS (ON|OFF|DEFAULT) "OFF"
+  TYPE (ANNOTATION|POINT|LINE|POLYGON|POLYLINE|QUERY|RASTER) #REQUIRED
+>
+<!ELEMENT CLASSITEM (#PCDATA)>
+<!ELEMENT CONNECTION (#PCDATA)>
+<!ELEMENT CONNECTIONTYPE (#PCDATA)>
+<!ELEMENT DATA (#PCDATA)>
+<!ELEMENT DESCRIPTION (#PCDATA)>
+<!-- ELEMENT FEATURE (#PCDATA) -->
+<!ELEMENT FILTER (#PCDATA)>
+<!ELEMENT FILTERITEM (#PCDATA)>
+<!-- FOOTER already declared -->
+<!ELEMENT GROUP (#PCDATA)>
+<!-- HEADER already declared -->
+<!ELEMENT LABELANGLEITEM (#PCDATA)>
+<!ELEMENT LABELCACHE (#PCDATA)>
+<!ELEMENT LABELITEM (#PCDATA)>
+<!ELEMENT LABELMAXSCALE (#PCDATA)>
+<!ELEMENT LABELMINSCALE (#PCDATA)>
+<!ELEMENT LABELREQUIRES (#PCDATA)>
+<!ELEMENT LABELSIZEITEM (#PCDATA)>
+<!ELEMENT MAXFEATURES (#PCDATA)>
+<!-- MAXSCALE already declared -->
+<!-- MINSCALE already declared -->
+<!ELEMENT OFFSITE (#PCDATA)>
+<!-- POSTLABELCACHE already declared -->
+<!ELEMENT REQUIRES (#PCDATA)>
+<!ELEMENT SYMBOLSCALE (#PCDATA)>
+<!ELEMENT TILEINDEX (#PCDATA)>
+<!ELEMENT TILEITEM (#PCDATA)>
+<!ELEMENT TILESRS (#PCDATA)>
+<!ELEMENT TOLERANCE (#PCDATA)>
+<!ELEMENT TOLERANCEUNITS (#PCDATA)>
+<!ELEMENT TRANSFORM (#PCDATA)>
+<!ELEMENT TRANSPARENCY (#PCDATA)>
+
+<!--
+  a FEATURE object
+  -->
+<!ELEMENT FEATURE
+  (POINTS|TEXT)*
+>
+<!ELEMENT POINTS (#PCDATA)>
+<!ELEMENT TEXT (#PCDATA)>
+
+<!--
+  a CLASS object
+  -->
+<!ELEMENT CLASS
+  (BACKGROUNDCOLOR|COLOR|EXPRESSION|LABEL|MAXSIZE|MINSIZE|OUTLINECOLOR|OVERLAYBACKGROUNDCOLOR|OVERLAYCOLOR|OVERLAYMAXSIZE|OVERLAYMINSIZE|OVERLAYOUTLINECOLOR|OVERLAYSIZE|OVERLAYSYMBOL|SIZE|SYMBOL|TEMPLATE|TEXT|TYPE)*
+>
+<!ATTLIST CLASS
+  NAME CDATA #IMPLIED
+>
+<!-- BACKGROUNDCOLOR already declared -->
+<!-- COLOR already declared -->
+<!ELEMENT EXPRESSION (#PCDATA)>
+<!ELEMENT MAXSIZE (#PCDATA)>
+<!ELEMENT MINSIZE (#PCDATA)>
+<!-- OUTLINECOLOR already declared -->
+<!ELEMENT OVERLAYBACKGROUNDCOLOR (#PCDATA)>
+<!ELEMENT OVERLAYCOLOR (#PCDATA)>
+<!ELEMENT OVERLAYMAXSIZE (#PCDATA)>
+<!ELEMENT OVERLAYMINSIZE (#PCDATA)>
+<!ELEMENT OVERLAYOUTLINECOLOR (#PCDATA)>
+<!ELEMENT OVERLAYSIZE (#PCDATA)>
+<!ELEMENT OVERLAYSYMBOL (#PCDATA)>
+<!-- SIZE already declared -->
+<!ELEMENT SYMBOL (#PCDATA)>
+<!-- TEMPLATE already declared -->
+<!-- TEXT already declared -->
+<!ELEMENT TYPE (#PCDATA)>
+
+<!--
+  a LABEL object
+  -->
+<!ELEMENT LABEL
+ (ANGLE|ANTIALIAS|BUFFER|BACKGROUNDCOLOR|BACKGROUNDSHADOWCOLOR|BACKGROUNDSHADOWSIZE|COLOR|FONT|FORCE|MAXSIZE|MINDISTANCE|MINFEATURESIZE|MINSIZE|OFFSET|OUTLINECOLOR|PARTIALS|POSITION|SHADOWCOLOR|SHADOWSIZE|SIZE|WRAP)*
+>
+<!ATTLIST LABEL   
+  TYPE (BITMAP|TRUETYPE) #REQUIRED
+>
+<!ELEMENT ANGLE (#PCDATA)>
+<!ELEMENT ANTIALIAS (#PCDATA)>
+<!ELEMENT BUFFER (#PCDATA)>
+<!-- BACKGROUNDCOLOR already declared -->
+<!ELEMENT BACKGROUNDSHADOWCOLOR (#PCDATA)>
+<!ELEMENT BACKGROUNDSHADOWSIZE (#PCDATA)>
+<!-- COLOR already declared -->
+<!ELEMENT FONT (#PCDATA)>
+<!ELEMENT FORCE (#PCDATA)>
+<!-- MAXSIZE already declared -->
+<!ELEMENT MINDISTANCE (#PCDATA)>
+<!ELEMENT MINFEATURESIZE (#PCDATA)>
+<!-- MINSIZE already declared -->
+<!-- OFFSET already declared -->
+<!ELEMENT OFFSET (#PCDATA)>
+<!-- OUTLINECOLOR already declared -->
+<!ELEMENT PARTIALS (#PCDATA)>
+<!-- POSITION already declared -->
+<!ELEMENT SHADOWCOLOR (#PCDATA)>
+<!ELEMENT SHADOWSIZE (#PCDATA)>
+<!-- SIZE already declared -->
+<!ELEMENT WRAP (#PCDATA)>
+
+<!--
+  a JOIN object (still under development)
+  -->
+
+<!--
+  a SYMBOL object
+  -->
+  
diff -pruN 8.0.1-5/src/mapfile.h 8.2.0~beta1-1~exp1/src/mapfile.h
--- 8.0.1-5/src/mapfile.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapfile.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,324 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Keyword definitions for the mapfiles and symbolfiles.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPFILE_H
+#define MAPFILE_H
+
+enum MS_LEXER_STATES {
+  MS_TOKENIZE_DEFAULT = 0,
+  MS_TOKENIZE_FILE,
+  MS_TOKENIZE_STRING,
+  MS_TOKENIZE_EXPRESSION,
+  MS_TOKENIZE_VALUE,
+  MS_TOKENIZE_NAME,
+  MS_TOKENIZE_CONFIG
+};
+enum MS_TOKEN_SOURCES { MS_FILE_TOKENS = 0, MS_STRING_TOKENS };
+
+/*
+** Keyword definitions for the mapfiles and symbolfiles (used by lexer)
+*/
+#define ANGLE 1000
+#define ANTIALIAS 1001
+#define BACKGROUNDCOLOR 1002
+#define BUFFER 1003
+#define CLASS 1004
+#define CLASSITEM 1005
+#define COLOR 1006
+#define DATA 1007
+#define DD 1008
+
+#define EMPTY 1010
+#define END 1011
+#define ERROR 1012
+#define EXPRESSION 1013
+#define EXTENT 1014
+#define FEATURE 1015
+#define FILLED 1016
+#define FOOTER 1017
+#define FONT 1018
+#define FONTSET 1019
+#define FROM 1020
+#define GROUP 1021
+#define HEADER 1022
+#define IMAGE 1023
+#define IMAGECOLOR 1024
+#define IMAGEPATH 1025
+#define IMAGEURL 1026
+#define INDEX 1027
+#define INTERLACE 1028
+#define INTERVALS 1029
+#define JOIN 1030
+#define KEYSIZE 1031
+#define KEYSPACING 1032
+#define LABEL 1033
+#define LABELCACHE 1035
+#define LABELITEM 1036
+#define LABELMAXSCALE 1037
+#define LABELMINSCALE 1038
+#define LAYER 1040
+#define LEGEND 1041
+
+#define LOG 1043
+#define MAP 1044
+
+#define MAXFEATURES 1047
+#define MAXSCALE 1048
+#define MAXSIZE 1049
+#define MAXTEMPLATE 1050
+#define MINDISTANCE 1051
+#define MINFEATURESIZE 1053
+#define MINSCALE 1054
+#define MINSIZE 1055
+#define MINTEMPLATE 1056
+#define NAME 1057
+#define NFTEMPLATE 1058
+
+#define OFFSET 1060
+#define OFFSITE 1061
+#define OUTLINECOLOR 1062
+#define PARTIALS 1063
+#define POINTS 1064
+#define POSITION 1065
+#define POSTLABELCACHE 1098
+#define PROJECTION 1066
+#define QUERY 1067
+#define QUERYITEM 1068
+#define QUERYMAP 1069
+#define REFERENCE 1070
+#define SCALE 1071
+#define SCALEBAR 1072
+
+#define SHADOWCOLOR 1074
+#define SHADOWSIZE 1075
+#define SHAPEPATH 1076
+#define SIZE 1077
+#define STATUS 1078
+
+#define STYLE 1080
+#define SYMBOL 1081
+#define SYMBOLSCALE 1082
+#define TABLE 1083
+#define TEMPLATE 1084
+#define TEXT 1085
+#define TEXTITEM 1086
+
+#define TILEINDEX 1088
+#define TILEITEM 1089
+#define TOLERANCE 1090
+#define TO 1091
+#define TRANSPARENT 1092
+#define TRANSFORM 1093
+#define TYPE 1094
+#define UNITS 1095
+#define WEB 1096
+#define WRAP 1097
+
+#define FORCE 1098
+#define TOLERANCEUNITS 1099
+#define CHARACTER 1100
+
+#define CONNECTION 1101
+#define CONNECTIONTYPE 1102
+
+#define SYMBOLSET 1105
+
+#define IMAGETYPE 1113
+#define IMAGEQUALITY 1114
+
+#define GAP 1115
+
+#define FILTER 1116
+#define FILTERITEM 1117
+
+#define REQUIRES 1118
+#define LABELREQUIRES 1119
+
+#define METADATA 1120
+#define LATLON 1121
+
+#define RESOLUTION 1122
+
+#define SIZEUNITS 1123
+
+#define STYLEITEM 1124
+
+#define TITLE 1126
+
+#define LINECAP 1127
+#define LINEJOIN 1128
+#define LINEJOINMAXSIZE 1129
+
+#define TRANSPARENCY 1130
+
+#define MARKER 1131
+#define MARKERSIZE 1132
+#define MINBOXSIZE 1133
+#define MAXBOXSIZE 1134
+
+#define OUTPUTFORMAT 1135
+#define MIMETYPE 1136
+#define DRIVER 1137
+#define IMAGEMODE 1138
+#define FORMATOPTION 1139
+
+#define GRATICULE 1140
+#define GRID 1141
+
+#define MAXARCS 1142
+#define MINARCS 1143
+#define MAXINTERVAL 1144
+#define MININTERVAL 1145
+#define MAXSUBDIVIDE 1146
+#define MINSUBDIVIDE 1147
+#define LABELFORMAT 1148
+
+#define PROCESSING 1153
+
+/* The DEBUG macro is also used to request debugging output.  Redefine
+   for keyword purposes.  */
+
+#ifdef DEBUG
+#undef DEBUG
+#endif
+
+#define DEBUG 1154
+
+#define EXTENSION 1155
+
+#define KEYIMAGE 1156
+#define QUERYFORMAT 1157
+
+#define CONFIG 1158
+#define BANDSITEM 1159
+
+#define ENCODING 1162
+
+#define WIDTH 1163
+#define MINWIDTH 1164
+#define MAXWIDTH 1165
+
+#define OUTLINEWIDTH 1166
+
+/* Color Range support (was Gradient Support)*/
+#define COLORRANGE 1170
+#define DATARANGE 1172
+#define RANGEITEM 1173
+
+/* WKT support (bug 1466) */
+#define WKT 1180
+
+#define LEGENDFORMAT 1190 /* bug 1518 */
+#define BROWSEFORMAT 1191
+
+#define RELATIVETO 1192
+
+#define OPACITY 1193
+#define PRIORITY 1194
+#define PATTERN 1195
+
+#define MAXSCALEDENOM 1196
+#define MINSCALEDENOM 1197
+#define LABELMAXSCALEDENOM 1198
+#define LABELMINSCALEDENOM 1199
+#define SYMBOLSCALEDENOM 1200
+#define SCALEDENOM 1201
+
+#define CLASSGROUP 1202
+
+#define ALIGN 1203 /* bug 2468 */
+
+#define MAXGEOWIDTH 1204
+#define MINGEOWIDTH 1205
+
+#define ITEMS 1206
+
+/* rfc40 label wrapping */
+#define MAXLENGTH 1210
+
+/* rfc44 URL configuration support */
+#define VALIDATION 1212
+
+/* rfc48 geometry transforms */
+#define GEOMTRANSFORM 1220
+
+/* rfc55 output resolution */
+#define DEFRESOLUTION 1221
+
+/* label repeat enhancement */
+#define REPEATDISTANCE 1222
+
+/* rfc60 label collision detection */
+#define MAXOVERLAPANGLE 1223
+
+/* rfc66 temporary path */
+#define TEMPPATH 1224
+
+/* rfc68 union connection type */
+#define UNION 1225
+
+/* rfc69 cluster */
+#define CLUSTER 1226
+#define MAXDISTANCE 1227
+#define REGION 1228
+
+#define INITIALGAP 1229
+#define ANCHORPOINT 1230
+
+#define MASK 1250
+
+#define POLAROFFSET 1251
+
+/* rfc78 leader-lines labels */
+#define LEADER 1260
+#define GRIDSTEP 1261
+
+/* rfc 86 scale-dependant token substitutions */
+#define SCALETOKEN 1270
+#define VALUES 1271
+
+#define TILESRS 1272
+
+/* rfc 93 support for utfgrid */
+#define UTFDATA 1280
+#define UTFITEM 1281
+
+/* rfc 113 layer compositing */
+#define COMPOSITE 1290
+#define COMPOP 1291
+#define COMPFILTER 1292
+
+#define BOM 1300
+
+/* rfc59 bindvals objects */
+#define BINDVALS 2000
+
+#define CONNECTIONOPTIONS 2001
+
+#endif /* MAPFILE_H */
diff -pruN 8.0.1-5/src/mapflatgeobuf.c 8.2.0~beta1-1~exp1/src/mapflatgeobuf.c
--- 8.0.1-5/src/mapflatgeobuf.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapflatgeobuf.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,368 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implements support for FlatGeobuf access.
+ * Authors:  Björn Harrtell
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#define NEED_IGNORE_RET_VAL
+
+#include <limits.h>
+#include <assert.h>
+#include "mapserver.h"
+#include "mapows.h"
+
+#include "flatgeobuf/flatgeobuf_c.h"
+
+#include <cpl_conv.h>
+#include <ogr_srs_api.h>
+
+static void msFGBPassThroughFieldDefinitions(layerObj *layer,
+                                             flatgeobuf_ctx *ctx) {
+  for (int i = 0; i < ctx->columns_len; i++) {
+    char item[255];
+    char gml_width[32], gml_precision[32];
+    const char *gml_type = NULL;
+
+    const flatgeobuf_column *column = &(ctx->columns[i]);
+    strncpy(item, column->name, 255 - 1);
+
+    gml_width[0] = '\0';
+    gml_precision[0] = '\0';
+
+    switch (column->type) {
+    case flatgeobuf_column_type_byte:
+    case flatgeobuf_column_type_ubyte:
+    case flatgeobuf_column_type_bool:
+    case flatgeobuf_column_type_short:
+    case flatgeobuf_column_type_ushort:
+    case flatgeobuf_column_type_int:
+    case flatgeobuf_column_type_uint:
+      gml_type = "Integer";
+      sprintf(gml_width, "%d", 4);
+      break;
+    case flatgeobuf_column_type_long:
+    case flatgeobuf_column_type_ulong:
+      gml_type = "Long";
+      sprintf(gml_width, "%d", 8);
+      break;
+    case flatgeobuf_column_type_float:
+    case flatgeobuf_column_type_double:
+      gml_type = "Real";
+      sprintf(gml_width, "%d", 8);
+      sprintf(gml_precision, "%d", 15);
+      break;
+    case flatgeobuf_column_type_string:
+    case flatgeobuf_column_type_json:
+    case flatgeobuf_column_type_datetime:
+    default:
+      gml_type = "Character";
+      sprintf(gml_width, "%d", 4096);
+      break;
+    }
+
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision,
+                             0);
+  }
+}
+
+void msFlatGeobufLayerFreeItemInfo(layerObj *layer) {
+  if (layer->iteminfo) {
+    free(layer->iteminfo);
+    layer->iteminfo = NULL;
+  }
+}
+
+int msFlatGeobufLayerInitItemInfo(layerObj *layer) {
+  if (!layer->layerinfo) {
+    msSetError(MS_FGBERR, "FlatGeobuf layer has not been opened.",
+               "msFlatGeobufLayerInitItemInfo()");
+    return MS_FAILURE;
+  }
+
+  msFlatGeobufLayerFreeItemInfo(layer);
+
+  flatgeobuf_ctx *ctx;
+  ctx = layer->layerinfo;
+  if (!ctx)
+    return MS_FAILURE;
+
+  for (int j = 0; j < ctx->columns_len; j++) {
+    ctx->columns[j].itemindex = -1;
+    for (int i = 0; i < layer->numitems; i++) {
+      if (strcasecmp(layer->items[i], ctx->columns[j].name) == 0) {
+        ctx->columns[j].itemindex = i;
+        break;
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+int msFlatGeobufLayerOpen(layerObj *layer) {
+  char szPath[MS_MAXPATHLEN];
+  int ret;
+
+  if (layer->layerinfo)
+    return MS_SUCCESS;
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  flatgeobuf_ctx *ctx = flatgeobuf_init_ctx();
+  layer->layerinfo = ctx;
+
+  ctx->file =
+      VSIFOpenL(msBuildPath(szPath, layer->map->mappath, layer->data), "rb");
+  if (!ctx->file)
+    ctx->file = VSIFOpenL(msBuildPath3(szPath, layer->map->mappath,
+                                       layer->map->shapepath, layer->data),
+                          "rb");
+  if (!ctx->file) {
+    layer->layerinfo = NULL;
+    flatgeobuf_free_ctx(ctx);
+    return MS_FAILURE;
+  }
+
+  ret = flatgeobuf_check_magicbytes(ctx);
+  if (ret == -1) {
+    layer->layerinfo = NULL;
+    flatgeobuf_free_ctx(ctx);
+    return MS_FAILURE;
+  }
+
+  ret = flatgeobuf_decode_header(ctx);
+  if (ret == -1) {
+    layer->layerinfo = NULL;
+    flatgeobuf_free_ctx(ctx);
+    return MS_FAILURE;
+  }
+
+  if (layer->projection.numargs > 0 &&
+      EQUAL(layer->projection.args[0], "auto")) {
+    OGRSpatialReferenceH hSRS = OSRNewSpatialReference(NULL);
+    char *pszWKT = NULL;
+    if (ctx->srid > 0) {
+      if (OSRImportFromEPSG(hSRS, ctx->srid) != OGRERR_NONE) {
+        OSRDestroySpatialReference(hSRS);
+        flatgeobuf_free_ctx(ctx);
+        return MS_FAILURE;
+      }
+      if (OSRExportToWkt(hSRS, &pszWKT) != OGRERR_NONE) {
+        OSRDestroySpatialReference(hSRS);
+        flatgeobuf_free_ctx(ctx);
+        return MS_FAILURE;
+      }
+    } else if (ctx->wkt == NULL) {
+      OSRDestroySpatialReference(hSRS);
+      return MS_SUCCESS;
+    }
+    int bOK = MS_FALSE;
+    if (msOGCWKT2ProjectionObj(ctx->wkt ? ctx->wkt : pszWKT,
+                               &(layer->projection),
+                               layer->debug) == MS_SUCCESS)
+      bOK = MS_TRUE;
+    CPLFree(pszWKT);
+    OSRDestroySpatialReference(hSRS);
+    if (bOK != MS_TRUE)
+      if (layer->debug || layer->map->debug)
+        msDebug("Unable to get SRS from FlatGeobuf '%s' for layer '%s'.\n",
+                szPath, layer->name);
+  }
+
+  return MS_SUCCESS;
+}
+
+int msFlatGeobufLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return MS_TRUE;
+  else
+    return MS_FALSE;
+}
+
+int msFlatGeobufLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  (void)isQuery;
+  flatgeobuf_ctx *ctx;
+  ctx = layer->layerinfo;
+  if (!ctx)
+    return MS_FAILURE;
+
+  if (!ctx->has_extent || !ctx->index_node_size)
+    return MS_SUCCESS;
+
+  if (msRectOverlap(&ctx->bounds, &rect) != MS_TRUE)
+    return MS_DONE;
+
+  if (msRectContained(&ctx->bounds, &rect) == MS_FALSE &&
+      ctx->index_node_size > 0) {
+    flatgeobuf_index_search(ctx, &rect);
+    if (ctx->search_result_len == 0)
+      return MS_DONE;
+  } else {
+    flatgeobuf_index_skip(ctx);
+  }
+
+  return MS_SUCCESS;
+}
+
+int msFlatGeobufLayerNextShape(layerObj *layer, shapeObj *shape) {
+  flatgeobuf_ctx *ctx;
+  ctx = layer->layerinfo;
+  if (!ctx)
+    return MS_FAILURE;
+
+  do {
+    if (ctx->search_result) {
+      if (ctx->search_index >= ctx->search_result_len)
+        return MS_DONE;
+      flatgeobuf_search_item item = ctx->search_result[ctx->search_index];
+      if (VSIFSeekL(ctx->file, ctx->feature_offset + item.offset, SEEK_SET) ==
+          -1) {
+        msSetError(MS_FGBERR, "Unable to seek in file",
+                   "msFlatGeobufLayerNextShape");
+        return MS_FAILURE;
+      }
+      ctx->offset = ctx->feature_offset + item.offset;
+      ctx->search_index++;
+      ctx->feature_index = item.index;
+    }
+    int ret = flatgeobuf_decode_feature(ctx, layer, shape);
+    if (ret == -1)
+      return MS_FAILURE;
+    shape->index = ctx->feature_index;
+    if (!ctx->search_result)
+      ctx->feature_index++;
+    if (ctx->done)
+      return MS_DONE;
+    if (ctx->is_null_geom) {
+      msFreeCharArray(shape->values, shape->numvalues);
+      shape->values = NULL;
+    }
+  } while (ctx->is_null_geom);
+
+  return MS_SUCCESS;
+}
+
+int msFlatGeobufLayerGetShape(layerObj *layer, shapeObj *shape,
+                              resultObj *record) {
+
+  (void)shape;
+  (void)record;
+  flatgeobuf_ctx *ctx;
+  ctx = layer->layerinfo;
+  if (!ctx)
+    return MS_FAILURE;
+  long i = record->shapeindex;
+  if (i < 0 || (uint64_t)i >= ctx->features_count) {
+    msSetError(MS_MISCERR, "Invalid feature id", "msFlatGeobufLayerGetShape");
+    return MS_FAILURE;
+  }
+  uint64_t offset;
+  flatgeobuf_read_feature_offset(ctx, i, &offset);
+  if (VSIFSeekL(ctx->file, ctx->feature_offset + offset, SEEK_SET) == -1) {
+    msSetError(MS_FGBERR, "Unable to seek in file",
+               "msFlatGeobufLayerGetShape");
+    return MS_FAILURE;
+  }
+  int ret = flatgeobuf_decode_feature(ctx, layer, shape);
+  if (ret == -1)
+    return MS_FAILURE;
+  return MS_SUCCESS;
+}
+
+int msFlatGeobufLayerClose(layerObj *layer) {
+  flatgeobuf_ctx *ctx;
+  ctx = layer->layerinfo;
+  if (!ctx)
+    return MS_SUCCESS;
+  VSIFCloseL(ctx->file);
+  flatgeobuf_free_ctx(ctx);
+  layer->layerinfo = NULL;
+  return MS_SUCCESS;
+}
+
+int msFlatGeobufLayerGetItems(layerObj *layer) {
+  const char *value;
+  flatgeobuf_ctx *ctx;
+  ctx = layer->layerinfo;
+  if (!ctx)
+    return MS_FAILURE;
+  layer->numitems = ctx->columns_len;
+
+  char **items = (char **)malloc(sizeof(char *) * ctx->columns_len);
+  for (int i = 0; i < ctx->columns_len; i++)
+    items[i] = msStrdup(ctx->columns[i].name);
+  layer->items = items;
+
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    msFGBPassThroughFieldDefinitions(layer, ctx);
+
+  return msLayerInitItemInfo(layer);
+}
+
+int msFlatGeobufLayerGetExtent(layerObj *layer, rectObj *extent) {
+  flatgeobuf_ctx *ctx;
+  ctx = layer->layerinfo;
+  extent->minx = ctx->xmin;
+  extent->miny = ctx->ymin;
+  extent->maxx = ctx->xmax;
+  extent->maxy = ctx->ymax;
+  return MS_SUCCESS;
+}
+
+int msFlatGeobufLayerSupportsCommonFilters(layerObj *layer) {
+  (void)layer;
+  return MS_TRUE;
+}
+
+int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerSupportsCommonFilters =
+      msFlatGeobufLayerSupportsCommonFilters;
+  layer->vtable->LayerInitItemInfo = msFlatGeobufLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msFlatGeobufLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msFlatGeobufLayerOpen;
+  layer->vtable->LayerIsOpen = msFlatGeobufLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msFlatGeobufLayerWhichShapes;
+  layer->vtable->LayerNextShape = msFlatGeobufLayerNextShape;
+  layer->vtable->LayerGetShape = msFlatGeobufLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msFlatGeobufLayerClose;
+  layer->vtable->LayerGetItems = msFlatGeobufLayerGetItems;
+  layer->vtable->LayerGetExtent = msFlatGeobufLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerCloseConnection, use default */
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  /* layer->vtable->LayerTranslateFilter, use default */
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapflatgeobuf.h 8.2.0~beta1-1~exp1/src/mapflatgeobuf.h
--- 8.0.1-5/src/mapflatgeobuf.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapflatgeobuf.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,47 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  FlatGeobuf access API
+ * Author:   Björn Harrtell.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPFLATGEOBUF_H
+#define MAPFLATGEOBUF_H
+
+#include <stdio.h>
+#include "mapprimitive.h"
+#include "mapproject.h"
+
+#include "cpl_vsi.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPFLATGEOBUF_H */
diff -pruN 8.0.1-5/src/mapgdal.cpp 8.2.0~beta1-1~exp1/src/mapgdal.cpp
--- 8.0.1-5/src/mapgdal.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgdal.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,691 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of support for output using GDAL.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2002, Frank Warmerdam
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapthread.h"
+#include "mapgdal.h"
+#include <assert.h>
+
+#include "cpl_conv.h"
+#include "cpl_string.h"
+#include "ogr_srs_api.h"
+
+#include "gdal.h"
+
+static int bGDALInitialized = 0;
+
+/************************************************************************/
+/*                          msGDALInitialize()                          */
+/************************************************************************/
+
+void msGDALInitialize(void)
+
+{
+  if (!bGDALInitialized) {
+    msAcquireLock(TLOCK_GDAL);
+
+    GDALAllRegister();
+    CPLPushErrorHandler(CPLQuietErrorHandler);
+    msReleaseLock(TLOCK_GDAL);
+
+    bGDALInitialized = 1;
+  }
+}
+
+/************************************************************************/
+/*                           msGDALCleanup()                            */
+/************************************************************************/
+
+void msGDALCleanup(void)
+
+{
+  if (bGDALInitialized) {
+    int iRepeat = 5;
+
+    /*
+    ** Cleanup any unreferenced but open datasets as will tend
+    ** to exist due to deferred close requests.  We are careful
+    ** to only close one file at a time before refecting the
+    ** list as closing some datasets may cause others to be
+    ** closed (subdatasets in a VRT for instance).
+    */
+    GDALDatasetH *pahDSList = NULL;
+    int nDSCount = 0;
+    int bDidSomething;
+
+    msAcquireLock(TLOCK_GDAL);
+
+    do {
+      int i;
+      GDALGetOpenDatasets(&pahDSList, &nDSCount);
+      bDidSomething = FALSE;
+      for (i = 0; i < nDSCount && !bDidSomething; i++) {
+        if (GDALReferenceDataset(pahDSList[i]) == 1) {
+          GDALClose(pahDSList[i]);
+          bDidSomething = TRUE;
+        } else
+          GDALDereferenceDataset(pahDSList[i]);
+      }
+    } while (bDidSomething);
+
+    while (iRepeat--)
+      CPLPopErrorHandler();
+
+    msReleaseLock(TLOCK_GDAL);
+
+    bGDALInitialized = 0;
+  }
+}
+
+/************************************************************************/
+/*                          msCleanVSIDir()                             */
+/*                                                                      */
+/*      For the temporary /vsimem/msout directory we need to be sure    */
+/*      things are clean before we start, and after we are done.        */
+/************************************************************************/
+
+void msCleanVSIDir(const char *pszDir)
+
+{
+  char **papszFiles = CPLReadDir(pszDir);
+  int i, nFileCount = CSLCount(papszFiles);
+
+  for (i = 0; i < nFileCount; i++) {
+    if (strcasecmp(papszFiles[i], ".") == 0 ||
+        strcasecmp(papszFiles[i], "..") == 0)
+      continue;
+
+    VSIUnlink(CPLFormFilename(pszDir, papszFiles[i], NULL));
+  }
+
+  CSLDestroy(papszFiles);
+}
+
+/************************************************************************/
+/*                          msSaveImageGDAL()                           */
+/************************************************************************/
+
+int msSaveImageGDAL(mapObj *map, imageObj *image, const char *filenameIn)
+
+{
+  int bFileIsTemporary = MS_FALSE;
+  GDALDatasetH hMemDS, hOutputDS;
+  GDALDriverH hMemDriver, hOutputDriver;
+  int nBands = 1;
+  int iLine;
+  outputFormatObj *format = image->format;
+  rasterBufferObj rb;
+  GDALDataType eDataType = GDT_Byte;
+  int bUseXmp = MS_FALSE;
+  const char *filename = NULL;
+  char *filenameToFree = NULL;
+  const char *gdal_driver_shortname = format->driver + 5;
+
+  msGDALInitialize();
+  memset(&rb, 0, sizeof(rasterBufferObj));
+
+#ifdef USE_EXEMPI
+  if (map != NULL) {
+    bUseXmp = msXmpPresent(map);
+  }
+#endif
+
+  /* -------------------------------------------------------------------- */
+  /*      Identify the proposed output driver.                            */
+  /* -------------------------------------------------------------------- */
+  msAcquireLock(TLOCK_GDAL);
+  hOutputDriver = GDALGetDriverByName(gdal_driver_shortname);
+  if (hOutputDriver == NULL) {
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to find %s driver.", "msSaveImageGDAL()",
+               gdal_driver_shortname);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      We will need to write the output to a temporary file and        */
+  /*      then stream to stdout if no filename is passed.  If the         */
+  /*      driver supports virtualio then we hold the temporary file in    */
+  /*      memory, otherwise we try to put it in a reasonable temporary    */
+  /*      file location.                                                  */
+  /* -------------------------------------------------------------------- */
+  if (filenameIn == NULL) {
+    const char *pszExtension = format->extension;
+    if (pszExtension == NULL)
+      pszExtension = "img.tmp";
+
+    if (bUseXmp == MS_FALSE &&
+        msGDALDriverSupportsVirtualIOOutput(hOutputDriver)) {
+      msCleanVSIDir("/vsimem/msout");
+      filenameToFree = msTmpFile(map, NULL, "/vsimem/msout/", pszExtension);
+    }
+
+    if (filenameToFree == NULL && map != NULL)
+      filenameToFree = msTmpFile(map, map->mappath, NULL, pszExtension);
+    else if (filenameToFree == NULL) {
+      filenameToFree = msTmpFile(map, NULL, NULL, pszExtension);
+    }
+    filename = filenameToFree;
+
+    bFileIsTemporary = MS_TRUE;
+  } else {
+    filename = filenameIn;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Establish the characteristics of our memory, and final          */
+  /*      dataset.                                                        */
+  /* -------------------------------------------------------------------- */
+
+  if (format->imagemode == MS_IMAGEMODE_RGB) {
+    nBands = 3;
+    assert(MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer);
+    if (MS_UNLIKELY(MS_FAILURE ==
+                    format->vtable->getRasterBufferHandle(image, &rb))) {
+      msReleaseLock(TLOCK_GDAL);
+      msFree(filenameToFree);
+      return MS_FAILURE;
+    }
+  } else if (format->imagemode == MS_IMAGEMODE_RGBA) {
+    nBands = 4;
+    assert(MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer);
+    if (MS_UNLIKELY(MS_FAILURE ==
+                    format->vtable->getRasterBufferHandle(image, &rb))) {
+      msReleaseLock(TLOCK_GDAL);
+      msFree(filenameToFree);
+      return MS_FAILURE;
+    }
+  } else if (format->imagemode == MS_IMAGEMODE_INT16) {
+    nBands = format->bands;
+    eDataType = GDT_Int16;
+  } else if (format->imagemode == MS_IMAGEMODE_FLOAT32) {
+    nBands = format->bands;
+    eDataType = GDT_Float32;
+  } else if (format->imagemode == MS_IMAGEMODE_BYTE) {
+    nBands = format->bands;
+    eDataType = GDT_Byte;
+  } else {
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MEMERR, "Unknown format. This is a bug.",
+               "msSaveImageGDAL()");
+    msFree(filenameToFree);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create a memory dataset which we can use as a source for a      */
+  /*      CreateCopy().                                                   */
+  /* -------------------------------------------------------------------- */
+  hMemDriver = GDALGetDriverByName("MEM");
+  if (hMemDriver == NULL) {
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to find MEM driver.", "msSaveImageGDAL()");
+    msFree(filenameToFree);
+    return MS_FAILURE;
+  }
+
+  hMemDS = GDALCreate(hMemDriver, "msSaveImageGDAL_temp", image->width,
+                      image->height, nBands, eDataType, NULL);
+  if (hMemDS == NULL) {
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to create MEM dataset.",
+               "msSaveImageGDAL()");
+    msFree(filenameToFree);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Copy the gd image into the memory dataset.                      */
+  /* -------------------------------------------------------------------- */
+  for (iLine = 0; iLine < image->height; iLine++) {
+    int iBand;
+
+    for (iBand = 0; iBand < nBands; iBand++) {
+      CPLErr eErr;
+      GDALRasterBandH hBand = GDALGetRasterBand(hMemDS, iBand + 1);
+
+      if (format->imagemode == MS_IMAGEMODE_INT16) {
+        eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                            image->img.raw_16bit + iLine * image->width +
+                                iBand * image->width * image->height,
+                            image->width, 1, GDT_Int16, 2, 0);
+
+      } else if (format->imagemode == MS_IMAGEMODE_FLOAT32) {
+        eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                            image->img.raw_float + iLine * image->width +
+                                iBand * image->width * image->height,
+                            image->width, 1, GDT_Float32, 4, 0);
+      } else if (format->imagemode == MS_IMAGEMODE_BYTE) {
+        eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                            image->img.raw_byte + iLine * image->width +
+                                iBand * image->width * image->height,
+                            image->width, 1, GDT_Byte, 1, 0);
+      } else {
+        GByte *pabyData;
+        unsigned char *pixptr = NULL;
+        assert(rb.type == MS_BUFFER_BYTE_RGBA);
+        switch (iBand) {
+        case 0:
+          pixptr = rb.data.rgba.r;
+          break;
+        case 1:
+          pixptr = rb.data.rgba.g;
+          break;
+        case 2:
+          pixptr = rb.data.rgba.b;
+          break;
+        case 3:
+          pixptr = rb.data.rgba.a;
+          break;
+        }
+        assert(pixptr);
+        if (pixptr == NULL) {
+          msReleaseLock(TLOCK_GDAL);
+          msSetError(MS_MISCERR, "Missing RGB or A buffer.\n",
+                     "msSaveImageGDAL()");
+          GDALClose(hMemDS);
+          msFree(filenameToFree);
+          return MS_FAILURE;
+        }
+
+        pabyData = (GByte *)(pixptr + iLine * rb.data.rgba.row_step);
+
+        if (rb.data.rgba.a == NULL || iBand == 3) {
+          eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                              pabyData, image->width, 1, GDT_Byte,
+                              rb.data.rgba.pixel_step, 0);
+        } else { /* We need to un-pre-multiple RGB by alpha. */
+          GByte *pabyUPM = (GByte *)malloc(image->width);
+          GByte *pabyAlpha =
+              (GByte *)(rb.data.rgba.a + iLine * rb.data.rgba.row_step);
+          int i;
+
+          for (i = 0; i < image->width; i++) {
+            int alpha = pabyAlpha[i * rb.data.rgba.pixel_step];
+
+            if (alpha == 0)
+              pabyUPM[i] = 0;
+            else {
+              int result =
+                  (pabyData[i * rb.data.rgba.pixel_step] * 255) / alpha;
+
+              if (result > 255)
+                result = 255;
+
+              pabyUPM[i] = result;
+            }
+          }
+
+          eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                              pabyUPM, image->width, 1, GDT_Byte, 1, 0);
+          free(pabyUPM);
+        }
+      }
+      if (eErr != CE_None) {
+        msReleaseLock(TLOCK_GDAL);
+        msSetError(MS_MISCERR, "GDALRasterIO() failed.\n", "msSaveImageGDAL()");
+        GDALClose(hMemDS);
+        msFree(filenameToFree);
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Attach the palette if appropriate.                              */
+  /* -------------------------------------------------------------------- */
+  if (format->imagemode == MS_IMAGEMODE_RGB) {
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 1), GCI_RedBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 2),
+                                     GCI_GreenBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 3),
+                                     GCI_BlueBand);
+  } else if (format->imagemode == MS_IMAGEMODE_RGBA) {
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 1), GCI_RedBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 2),
+                                     GCI_GreenBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 3),
+                                     GCI_BlueBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 4),
+                                     GCI_AlphaBand);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Assign the projection and coordinate system to the memory       */
+  /*      dataset.                                                        */
+  /* -------------------------------------------------------------------- */
+
+  if (map != NULL) {
+    char *pszWKT;
+
+    GDALSetGeoTransform(hMemDS, map->gt.geotransform);
+
+    pszWKT = msProjectionObj2OGCWKT(&(map->projection));
+    if (pszWKT != NULL) {
+      GDALSetProjection(hMemDS, pszWKT);
+      msFree(pszWKT);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Possibly assign a nodata value.                                 */
+  /* -------------------------------------------------------------------- */
+  const char *nullvalue = msGetOutputFormatOption(format, "NULLVALUE", NULL);
+  if (nullvalue != NULL) {
+    const double dfNullValue = atof(nullvalue);
+    for (int iBand = 0; iBand < nBands; iBand++) {
+      GDALRasterBandH hBand = GDALGetRasterBand(hMemDS, iBand + 1);
+      GDALSetRasterNoDataValue(hBand, dfNullValue);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Try to save resolution in the output file.                          */
+  /* -------------------------------------------------------------------- */
+  if (image->resolution > 0) {
+    char res[30];
+
+    sprintf(res, "%lf", image->resolution);
+    GDALSetMetadataItem(hMemDS, "TIFFTAG_XRESOLUTION", res, NULL);
+    GDALSetMetadataItem(hMemDS, "TIFFTAG_YRESOLUTION", res, NULL);
+    GDALSetMetadataItem(hMemDS, "TIFFTAG_RESOLUTIONUNIT", "2", NULL);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Separate creation options from metadata items.                  */
+  /* -------------------------------------------------------------------- */
+  std::vector<char *> apszCreationOptions;
+  for (int i = 0; i < format->numformatoptions; i++) {
+    char *option = format->formatoptions[i];
+
+    // MDI stands for MetaDataItem
+    if (STARTS_WITH(option, "mdi_")) {
+      const char *option_without_band = option + strlen("mdi_");
+      GDALMajorObjectH hObject = (GDALMajorObjectH)hMemDS;
+      if (STARTS_WITH(option_without_band, "BAND_")) {
+        int nBandNumber = atoi(option_without_band + strlen("BAND_"));
+        if (nBandNumber > 0 && nBandNumber <= nBands) {
+          const char *pszAfterBand =
+              strchr(option_without_band + strlen("BAND_"), '_');
+          if (pszAfterBand != NULL) {
+            hObject = (GDALMajorObjectH)GDALGetRasterBand(hMemDS, nBandNumber);
+            option_without_band = pszAfterBand + 1;
+          }
+        } else {
+          msDebug("Invalid band number %d in metadata item option %s",
+                  nBandNumber, option);
+        }
+      }
+      if (hObject) {
+        std::string osDomain(option_without_band);
+        size_t nUnderscorePos = osDomain.find('_');
+        if (nUnderscorePos != std::string::npos) {
+          std::string osKeyValue = osDomain.substr(nUnderscorePos + 1);
+          osDomain.resize(nUnderscorePos);
+          if (osDomain == "default")
+            osDomain.clear();
+          size_t nEqualPos = osKeyValue.find('=');
+          if (nEqualPos != std::string::npos) {
+            GDALSetMetadataItem(
+                hObject, osKeyValue.substr(0, nEqualPos).c_str(),
+                osKeyValue.substr(nEqualPos + 1).c_str(), osDomain.c_str());
+          }
+        } else {
+          msDebug("Invalid format in metadata item option %s", option);
+        }
+      }
+    } else {
+      apszCreationOptions.emplace_back(option);
+    }
+  }
+  apszCreationOptions.emplace_back(nullptr);
+
+  /* -------------------------------------------------------------------- */
+  /*      Create a disk image in the selected output format from the      */
+  /*      memory image.                                                   */
+  /* -------------------------------------------------------------------- */
+  hOutputDS = GDALCreateCopy(hOutputDriver, filename, hMemDS, FALSE,
+                             &apszCreationOptions[0], NULL, NULL);
+
+  if (hOutputDS == NULL) {
+    GDALClose(hMemDS);
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to create output %s file.\n%s",
+               "msSaveImageGDAL()", format->driver + 5, CPLGetLastErrorMsg());
+    msFree(filenameToFree);
+    return MS_FAILURE;
+  }
+
+  /* closing the memory DS also frees all associated resources. */
+  GDALClose(hMemDS);
+
+  GDALClose(hOutputDS);
+  msReleaseLock(TLOCK_GDAL);
+
+  /* -------------------------------------------------------------------- */
+  /*      Are we writing license info into the image?                     */
+  /*      If so, add it to the temp file on disk now.                     */
+  /* -------------------------------------------------------------------- */
+#ifdef USE_EXEMPI
+  if (bUseXmp == MS_TRUE) {
+    if (msXmpWrite(map, filename) == MS_FAILURE) {
+      /* Something bad happened. */
+      msSetError(MS_MISCERR, "XMP write to %s failed.\n", "msSaveImageGDAL()",
+                 filename);
+      msFree(filenameToFree);
+      return MS_FAILURE;
+    }
+  }
+#endif
+
+  /* -------------------------------------------------------------------- */
+  /*      Is this supposed to be a temporary file?  If so, stream to      */
+  /*      stdout and delete the file.                                     */
+  /* -------------------------------------------------------------------- */
+  if (bFileIsTemporary) {
+    VSILFILE *fp;
+    unsigned char block[4000];
+    int bytes_read;
+
+    if (msIO_needBinaryStdout() == MS_FAILURE) {
+      msFree(filenameToFree);
+      return MS_FAILURE;
+    }
+
+    /* We aren't sure how far back GDAL exports the VSI*L API, so
+       we only use it if we suspect we need it.  But we do need it if
+       holding temporary file in memory. */
+    fp = VSIFOpenL(filename, "rb");
+    if (fp == NULL) {
+      msSetError(MS_MISCERR, "Failed to open %s for streaming to stdout.",
+                 "msSaveImageGDAL()", filename);
+      msFree(filenameToFree);
+      return MS_FAILURE;
+    }
+
+    while ((bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0)
+      msIO_fwrite(block, 1, bytes_read, stdout);
+
+    VSIFCloseL(fp);
+
+    VSIUnlink(filename);
+    msCleanVSIDir("/vsimem/msout");
+  }
+  msFree(filenameToFree);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msInitGDALOutputFormat()                       */
+/************************************************************************/
+
+int msInitDefaultGDALOutputFormat(outputFormatObj *format)
+
+{
+  GDALDriverH hDriver;
+
+  msGDALInitialize();
+
+  /* -------------------------------------------------------------------- */
+  /*      check that this driver exists.  Note visiting drivers should    */
+  /*      be pretty threadsafe so don't bother acquiring the GDAL         */
+  /*      lock.                                                           */
+  /* -------------------------------------------------------------------- */
+  hDriver = GDALGetDriverByName(format->driver + 5);
+  if (hDriver == NULL) {
+    msSetError(MS_MISCERR, "No GDAL driver named `%s' available.",
+               "msInitGDALOutputFormat()", format->driver + 5);
+    return MS_FAILURE;
+  }
+
+  if (GDALGetMetadataItem(hDriver, GDAL_DCAP_CREATE, NULL) == NULL &&
+      GDALGetMetadataItem(hDriver, GDAL_DCAP_CREATECOPY, NULL) == NULL) {
+    msSetError(MS_MISCERR, "GDAL `%s' driver does not support output.",
+               "msInitGDALOutputFormat()", format->driver + 5);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize the object.                                          */
+  /* -------------------------------------------------------------------- */
+  format->imagemode = MS_IMAGEMODE_RGB;
+  format->renderer = MS_RENDER_WITH_AGG;
+
+  if (GDALGetMetadataItem(hDriver, GDAL_DMD_MIMETYPE, NULL) != NULL)
+    format->mimetype =
+        msStrdup(GDALGetMetadataItem(hDriver, GDAL_DMD_MIMETYPE, NULL));
+  if (GDALGetMetadataItem(hDriver, GDAL_DMD_EXTENSION, NULL) != NULL)
+    format->extension =
+        msStrdup(GDALGetMetadataItem(hDriver, GDAL_DMD_EXTENSION, NULL));
+
+  return MS_SUCCESS;
+}
+
+char **msGetStringListFromHashTable(hashTableObj *table) {
+  struct hashObj *tp = NULL;
+  int i;
+  char **papszRet = NULL;
+
+  if (!table)
+    return NULL;
+  if (msHashIsEmpty(table))
+    return NULL;
+
+  for (i = 0; i < MS_HASHSIZE; ++i) {
+    if (table->items[i] != NULL) {
+      for (tp = table->items[i]; tp != NULL; tp = tp->next) {
+        papszRet = CSLSetNameValue(papszRet, tp->key, tp->data);
+      }
+    }
+  }
+  return papszRet;
+}
+
+/************************************************************************/
+/*                      msProjectionObj2OGCWKT()                        */
+/*                                                                      */
+/*      We stick to the C API for OGRSpatialReference object access     */
+/*      to allow MapServer+GDAL to be built without C++                 */
+/*      complications.                                                  */
+/*                                                                      */
+/*      Note that this function will return NULL on failure, and the    */
+/*      returned string should be freed with msFree().                  */
+/************************************************************************/
+
+char *msProjectionObj2OGCWKT(projectionObj *projection)
+
+{
+  OGRSpatialReferenceH hSRS;
+  char *pszWKT = NULL, *pszProj4, *pszInitEpsg = NULL;
+  int nLength = 0, i;
+  OGRErr eErr;
+
+  if (projection->proj == NULL)
+    return NULL;
+
+  hSRS = OSRNewSpatialReference(NULL);
+  /* -------------------------------------------------------------------- */
+  /*      Look for an EPSG-like projection argument                       */
+  /* -------------------------------------------------------------------- */
+  if (projection->numargs == 1 &&
+      (pszInitEpsg = strcasestr(projection->args[0], "init=epsg:"))) {
+    int nEpsgCode = atoi(pszInitEpsg + strlen("init=epsg:"));
+    eErr = OSRImportFromEPSG(hSRS, nEpsgCode);
+  } else {
+    /* -------------------------------------------------------------------- */
+    /*      Form arguments into a full Proj.4 definition string.            */
+    /* -------------------------------------------------------------------- */
+    for (i = 0; i < projection->numargs; i++)
+      nLength += strlen(projection->args[i]) + 2;
+
+    pszProj4 = (char *)CPLMalloc(nLength + 2);
+    pszProj4[0] = '\0';
+
+    for (i = 0; i < projection->numargs; i++) {
+      strcat(pszProj4, "+");
+      strcat(pszProj4, projection->args[i]);
+      strcat(pszProj4, " ");
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Ingest the string into OGRSpatialReference.                     */
+    /* -------------------------------------------------------------------- */
+    eErr = OSRImportFromProj4(hSRS, pszProj4);
+    CPLFree(pszProj4);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Export as a WKT string.                                         */
+  /* -------------------------------------------------------------------- */
+  if (eErr == OGRERR_NONE)
+    OSRExportToWkt(hSRS, &pszWKT);
+
+  OSRDestroySpatialReference(hSRS);
+
+  if (pszWKT) {
+    char *pszWKT2 = msStrdup(pszWKT);
+    CPLFree(pszWKT);
+
+    return pszWKT2;
+  } else
+    return NULL;
+}
+
+/************************************************************************/
+/*                    msGDALDriverSupportsVirtualIOOutput()             */
+/************************************************************************/
+
+int msGDALDriverSupportsVirtualIOOutput(GDALDriverH hDriver) {
+  /* We need special testing here for the netCDF driver, since recent */
+  /* GDAL versions advertize VirtualIO support, but this is only for the */
+  /* read-side of the driver, not the write-side. */
+  return GDALGetMetadataItem(hDriver, GDAL_DCAP_VIRTUALIO, NULL) != NULL &&
+         !EQUAL(GDALGetDescription(hDriver), "netCDF");
+}
diff -pruN 8.0.1-5/src/mapgdal.h 8.2.0~beta1-1~exp1/src/mapgdal.h
--- 8.0.1-5/src/mapgdal.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgdal.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,46 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  GDAL interface
+ * Author:   Even Rouault <even.rouault at spatialys.com>
+ *
+ ******************************************************************************
+ * Copyright (c) 2020, Even Rouault <even.rouault at spatialys.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPGDAL_H
+#define MAPGDAL_H
+
+#include "mapserver.h"
+#include "gdal.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+int msGDALDriverSupportsVirtualIOOutput(GDALDriverH hDriver);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPGDAL_H */
diff -pruN 8.0.1-5/src/mapgeomtransform.c 8.2.0~beta1-1~exp1/src/mapgeomtransform.c
--- 8.0.1-5/src/mapgeomtransform.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgeomtransform.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,320 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose: RFC48 implementation of geometry transformations for styling
+ * Author:   Thomas Bonfort , Camptocamp (thomas.bonfort at camptocamp.com)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "mapthread.h"
+
+extern int yyparse(parseObj *p);
+
+void msStyleSetGeomTransform(styleObj *s, const char *transform) {
+  msFree(s->_geomtransform.string);
+  if (!transform) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
+    s->_geomtransform.string = NULL;
+    return;
+  }
+  s->_geomtransform.string = msStrdup(transform);
+  if (!strncasecmp("start", transform, 5)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_START;
+  } else if (!strncasecmp("end", transform, 3)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_END;
+  } else if (!strncasecmp("vertices", transform, 8)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_VERTICES;
+  } else if (!strncasecmp("bbox", transform, 4)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_BBOX;
+  } else if (!strncasecmp("labelpnt", transform, 8)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
+  } else if (!strncasecmp("labelpoly", transform, 9)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOLY;
+  } else if (!strncasecmp("labelcenter", transform, 11)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_LABELCENTER;
+  } else if (!strncasecmp("centroid", transform, 8)) {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_CENTROID;
+  } else {
+    s->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
+    msSetError(MS_MISCERR, "unknown transform expression",
+               "msStyleSetGeomTransform()");
+    msFree(s->_geomtransform.string);
+    s->_geomtransform.string = NULL;
+  }
+}
+
+/*
+ * return a copy of the geometry transform expression
+ * returned char* must be freed by the caller
+ */
+char *msStyleGetGeomTransform(styleObj *s) {
+  return msStrdup(s->_geomtransform.string);
+}
+
+double calcOrientation(pointObj *p1, pointObj *p2) {
+  double theta;
+  theta = atan2(p2->x - p1->x, p2->y - p1->y);
+  return MS_RAD_TO_DEG * (theta - MS_PI2);
+}
+
+double calcMidAngle(pointObj *p1, pointObj *p2, pointObj *p3) {
+  pointObj p1n;
+  double dx12, dy12, dx23, dy23, l12, l23;
+
+  /* We treat both segments as vector 1-2 and vector 2-3 and
+   * compute their dx,dy and length
+   */
+  dx12 = p2->x - p1->x;
+  dy12 = p2->y - p1->y;
+  l12 = sqrt(dx12 * dx12 + dy12 * dy12);
+  dx23 = p3->x - p2->x;
+  dy23 = p3->y - p2->y;
+  l23 = sqrt(dx23 * dx23 + dy23 * dy23);
+
+  /* Normalize length of vector 1-2 to same as length of vector 2-3 */
+  if (l12 > 0.0) {
+    p1n.x = p2->x - dx12 * (l23 / l12);
+    p1n.y = p2->y - dy12 * (l23 / l12);
+  } else
+    p1n = *p2; /* segment 1-2 is 0-length, use segment 2-3 for orientation */
+
+  /* Return the orientation defined by the sum of the normalized vectors */
+  return calcOrientation(&p1n, p3);
+}
+
+/*
+ * RFC48 implementation:
+ *  - transform the original shapeobj
+ *  - use the styleObj to render the transformed shapeobj
+ */
+int msDrawTransformedShape(mapObj *map, imageObj *image, shapeObj *shape,
+                           styleObj *style, double scalefactor) {
+  int type = style->_geomtransform.type;
+  int i, j, status = MS_SUCCESS;
+  switch (type) {
+  case MS_GEOMTRANSFORM_END: /*render point on last vertex only*/
+    for (j = 0; j < shape->numlines; j++) {
+      lineObj *line = &(shape->line[j]);
+      pointObj *p = &(line->point[line->numpoints - 1]);
+      if (p->x < 0 || p->x > image->width || p->y < 0 || p->y > image->height)
+        continue;
+      if (style->autoangle == MS_TRUE && line->numpoints > 1) {
+        style->angle = calcOrientation(&(line->point[line->numpoints - 2]), p);
+      }
+      status = msDrawMarkerSymbol(map, image, p, style, scalefactor);
+    }
+    break;
+  case MS_GEOMTRANSFORM_START: /*render point on first vertex only*/
+    for (j = 0; j < shape->numlines; j++) {
+      lineObj *line = &(shape->line[j]);
+      pointObj *p = &(line->point[0]);
+      /*skip if outside image*/
+      if (p->x < 0 || p->x > image->width || p->y < 0 || p->y > image->height)
+        continue;
+      if (style->autoangle == MS_TRUE && line->numpoints > 1) {
+        style->angle = calcOrientation(p, &(line->point[1]));
+      }
+      status = msDrawMarkerSymbol(map, image, p, style, scalefactor);
+    }
+    break;
+  case MS_GEOMTRANSFORM_VERTICES:
+    for (j = 0; j < shape->numlines; j++) {
+      lineObj *line = &(shape->line[j]);
+      for (i = 1; i < line->numpoints - 1; i++) {
+        pointObj *p = &(line->point[i]);
+        /*skip points outside image*/
+        if (p->x < 0 || p->x > image->width || p->y < 0 || p->y > image->height)
+          continue;
+        if (style->autoangle == MS_TRUE) {
+          style->angle = calcMidAngle(&(line->point[i - 1]), &(line->point[i]),
+                                      &(line->point[i + 1]));
+        }
+        status = msDrawMarkerSymbol(map, image, p, style, scalefactor);
+      }
+    }
+    break;
+  case MS_GEOMTRANSFORM_BBOX: {
+    shapeObj bbox;
+    lineObj bbox_line;
+    pointObj bbox_points[5];
+    int padding = MS_MAX(style->width, style->size) +
+                  3; /* so clipped shape does not extent into image */
+
+    /*create a shapeObj representing the bounding box (clipped by the image
+     * size)*/
+    bbox.numlines = 1;
+    bbox.line = &bbox_line;
+    bbox.line->numpoints = 5;
+    bbox.line->point = bbox_points;
+
+    msComputeBounds(shape);
+    bbox_points[0].x = bbox_points[4].x = bbox_points[1].x =
+        (shape->bounds.minx < -padding) ? -padding : shape->bounds.minx;
+    /* cppcheck-suppress unreadVariable */
+    bbox_points[2].x = bbox_points[3].x =
+        (shape->bounds.maxx > image->width + padding) ? image->width + padding
+                                                      : shape->bounds.maxx;
+    bbox_points[0].y = bbox_points[4].y = bbox_points[3].y =
+        (shape->bounds.miny < -padding) ? -padding : shape->bounds.miny;
+    /* cppcheck-suppress unreadVariable */
+    bbox_points[1].y = bbox_points[2].y =
+        (shape->bounds.maxy > image->height + padding) ? image->height + padding
+                                                       : shape->bounds.maxy;
+    status = msDrawShadeSymbol(map, image, &bbox, style, scalefactor);
+  } break;
+  case MS_GEOMTRANSFORM_CENTROID: {
+    double unused; /*used by centroid function*/
+    pointObj centroid;
+    if (MS_SUCCESS ==
+        msGetPolygonCentroid(shape, &centroid, &unused, &unused)) {
+      status = msDrawMarkerSymbol(map, image, &centroid, style, scalefactor);
+    }
+  } break;
+  case MS_GEOMTRANSFORM_EXPRESSION: {
+    int status;
+    shapeObj *tmpshp;
+    parseObj p;
+
+    p.shape = shape; /* set a few parser globals (hence the lock) */
+    p.expr = &(style->_geomtransform);
+
+    if (p.expr->tokens == NULL) { /* this could happen if drawing originates
+                                     from legend code (#5193) */
+      status = msTokenizeExpression(p.expr, NULL, NULL);
+      if (status != MS_SUCCESS) {
+        msSetError(MS_MISCERR, "Unable to tokenize expression.",
+                   "msDrawTransformedShape()");
+        return MS_FAILURE;
+      }
+    }
+
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_SHAPE;
+
+    status = yyparse(&p);
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to process shape expression: %s",
+                 "msDrawTransformedShape", style->_geomtransform.string);
+      return MS_FAILURE;
+    }
+    tmpshp = p.result.shpval;
+
+    switch (tmpshp->type) {
+    case MS_SHAPE_POINT:
+    case MS_SHAPE_POLYGON:
+      /* cppcheck-suppress unreadVariable */
+      status = msDrawShadeSymbol(map, image, tmpshp, style, scalefactor);
+      break;
+    case MS_SHAPE_LINE:
+      /* cppcheck-suppress unreadVariable */
+      status = msDrawLineSymbol(map, image, tmpshp, style, scalefactor);
+      break;
+    }
+
+    msFreeShape(tmpshp);
+    msFree(tmpshp);
+  } break;
+  case MS_GEOMTRANSFORM_LABELPOINT:
+  case MS_GEOMTRANSFORM_LABELPOLY:
+    break;
+  default:
+    msSetError(MS_MISCERR, "unknown geomtransform", "msDrawTransformedShape()");
+    return MS_FAILURE;
+  }
+  return status;
+}
+
+/*
+ * RFC89 implementation:
+ *  - transform directly the shapeobj
+ */
+int msGeomTransformShape(mapObj *map, layerObj *layer, shapeObj *shape) {
+  int i;
+  expressionObj *e = &layer->_geomtransform;
+
+#ifdef USE_V8_MAPSCRIPT
+  if (!map->v8context) {
+    msV8CreateContext(map);
+    if (!map->v8context) {
+      msSetError(MS_V8ERR, "Unable to create v8 context.",
+                 "msGeomTransformShape()");
+      return MS_FAILURE;
+    }
+  }
+
+  msV8ContextSetLayer(map, layer);
+#endif
+
+  switch (e->type) {
+  case MS_GEOMTRANSFORM_EXPRESSION: {
+    int status;
+    shapeObj *tmpshp;
+    parseObj p;
+
+    p.shape = shape; /* set a few parser globals (hence the lock) */
+    p.expr = e;
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_SHAPE;
+    p.dblval = map->cellsize * (msInchesPerUnit(map->units, 0) /
+                                msInchesPerUnit(layer->units, 0));
+    p.dblval2 = 0;
+    /* data_cellsize is only set with contour layer */
+    if (layer->connectiontype == MS_CONTOUR) {
+      const char *value =
+          msLookupHashTable(&layer->metadata, "__data_cellsize__");
+      if (value)
+        p.dblval2 = atof(value);
+    }
+
+    status = yyparse(&p);
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to process shape expression: %s",
+                 "msGeomTransformShape()", e->string);
+      return MS_FAILURE;
+    }
+
+    tmpshp = p.result.shpval;
+
+    for (i = 0; i < shape->numlines; i++)
+      free(shape->line[i].point);
+    shape->numlines = 0;
+    if (shape->line)
+      free(shape->line);
+    shape->line = NULL;
+    shape->type = tmpshp->type; /* might have been a change (e.g. centerline) */
+
+    for (i = 0; i < tmpshp->numlines; i++)
+      msAddLine(shape, &(tmpshp->line[i])); /* copy each line */
+
+    msFreeShape(tmpshp);
+    msFree(tmpshp);
+  } break;
+  default:
+    msSetError(MS_MISCERR, "unknown geomtransform", "msGeomTransformShape()");
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapgeomutil.cpp 8.2.0~beta1-1~exp1/src/mapgeomutil.cpp
--- 8.0.1-5/src/mapgeomutil.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgeomutil.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,108 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Rendering utility functions
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2011 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "renderers/agg/include/agg_arc.h"
+#include "renderers/agg/include/agg_basics.h"
+
+shapeObj *msRasterizeArc(double x0, double y0, double radius, double startAngle,
+                         double endAngle, int isSlice) {
+  static int allocated_size = 100;
+  shapeObj *shape = (shapeObj *)calloc(1, sizeof(shapeObj));
+  MS_CHECK_ALLOC(shape, sizeof(shapeObj), NULL);
+  mapserver::arc arc(x0, y0, radius, radius, startAngle * MS_DEG_TO_RAD,
+                     endAngle * MS_DEG_TO_RAD, true);
+  arc.approximation_scale(1);
+  arc.rewind(1);
+  msInitShape(shape);
+
+  lineObj *line = (lineObj *)calloc(1, sizeof(lineObj));
+  if (!line) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msRasterizeArc()", __FILE__, __LINE__,
+               (unsigned int)sizeof(lineObj));
+    free(shape);
+    return NULL;
+  }
+  shape->line = line;
+  shape->numlines = 1;
+  line->point = (pointObj *)calloc(allocated_size, sizeof(pointObj));
+  if (!line->point) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msRasterizeArc()", __FILE__, __LINE__,
+               (unsigned int)(allocated_size * sizeof(pointObj)));
+    free(line);
+    free(shape);
+    return NULL;
+  }
+
+  line->numpoints = 0;
+
+  double x, y;
+
+  // first segment from center to first point of arc
+  if (isSlice) {
+    line->point[0].x = x0;
+    line->point[0].y = y0;
+    line->numpoints = 1;
+  }
+  while (arc.vertex(&x, &y) != mapserver::path_cmd_stop) {
+    if (line->numpoints == allocated_size) {
+      allocated_size *= 2;
+      line->point =
+          (pointObj *)realloc(line->point, allocated_size * sizeof(pointObj));
+      if (!line->point) {
+        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                   "msRasterizeArc()", __FILE__, __LINE__,
+                   (unsigned int)(allocated_size * sizeof(pointObj)));
+        free(line);
+        free(shape);
+        return NULL;
+      }
+    }
+    line->point[line->numpoints].x = x;
+    line->point[line->numpoints].y = y;
+    line->numpoints++;
+  }
+
+  // make sure the shape is closed
+  if (line->point[line->numpoints - 1].x != line->point[0].x ||
+      line->point[line->numpoints - 1].y != line->point[0].y) {
+    if (line->numpoints == allocated_size) {
+      allocated_size *= 2;
+      line->point = (pointObj *)msSmallRealloc(
+          line->point, allocated_size * sizeof(pointObj));
+    }
+    line->point[line->numpoints].x = line->point[0].x;
+    line->point[line->numpoints].y = line->point[0].y;
+    line->numpoints++;
+  }
+
+  return shape;
+}
diff -pruN 8.0.1-5/src/mapgeos.c 8.2.0~beta1-1~exp1/src/mapgeos.c
--- 8.0.1-5/src/mapgeos.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgeos.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1777 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  MapServer-GEOS integration.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "mapgraph.h"
+
+#ifdef USE_GEOS
+
+// To avoid accidental use of non reentrant GEOS API.
+// (check only effective in GEOS >= 3.5)
+#define GEOS_USE_ONLY_R_API
+
+#include <geos_c.h>
+
+/*
+** Error handling...
+*/
+static void msGEOSError(const char *format, ...) {
+  va_list args;
+
+  va_start(args, format);
+  msSetError(MS_GEOSERR, format, "msGEOSError()",
+             args); /* just pass along to MapServer error handling */
+  va_end(args);
+
+  return;
+}
+
+static void msGEOSNotice(const char *fmt, ...) {
+  (void)fmt; /* do nothing with notices at this point */
+}
+
+#ifndef USE_THREAD
+static GEOSContextHandle_t geos_handle;
+
+static inline GEOSContextHandle_t msGetGeosContextHandle() {
+  return geos_handle;
+}
+
+#else
+#include "mapthread.h"
+typedef struct geos_thread_info {
+  struct geos_thread_info *next;
+  void *thread_id;
+  GEOSContextHandle_t geos_handle;
+} geos_thread_info_t;
+
+static geos_thread_info_t *geos_list = NULL;
+
+static GEOSContextHandle_t msGetGeosContextHandle() {
+  geos_thread_info_t *link;
+  GEOSContextHandle_t ret_obj;
+  void *thread_id;
+
+  msAcquireLock(TLOCK_GEOS);
+
+  thread_id = msGetThreadId();
+
+  /* find link for this thread */
+
+  for (link = geos_list;
+       link != NULL && link->thread_id != thread_id && link->next != NULL &&
+       link->next->thread_id != thread_id;
+       link = link->next) {
+  }
+
+  /* If the target thread link is already at the head of the list were ok */
+  if (geos_list != NULL && geos_list->thread_id == thread_id) {
+  }
+
+  /* We don't have one ... initialize one. */
+  else if (link == NULL || link->next == NULL) {
+    geos_thread_info_t *new_link;
+    new_link = (geos_thread_info_t *)malloc(sizeof(geos_thread_info_t));
+    new_link->next = geos_list;
+    new_link->thread_id = thread_id;
+    new_link->geos_handle = initGEOS_r(msGEOSNotice, msGEOSError);
+
+    geos_list = new_link;
+  }
+
+  /* If the link is not already at the head of the list, promote it */
+  else {
+    geos_thread_info_t *target = link->next;
+
+    link->next = link->next->next;
+    target->next = geos_list;
+    geos_list = target;
+  }
+
+  ret_obj = geos_list->geos_handle;
+
+  msReleaseLock(TLOCK_GEOS);
+
+  return ret_obj;
+}
+#endif
+
+/*
+** Setup/Cleanup wrappers
+*/
+void msGEOSSetup() {
+#ifndef USE_THREAD
+  geos_handle = initGEOS_r(msGEOSNotice, msGEOSError);
+#endif
+}
+
+void msGEOSCleanup() {
+#ifndef USE_THREAD
+  finishGEOS_r(geos_handle);
+  geos_handle = NULL;
+#else
+  geos_thread_info_t *link;
+  msAcquireLock(TLOCK_GEOS);
+  for (link = geos_list; link != NULL;) {
+    geos_thread_info_t *cur = link;
+    link = link->next;
+    finishGEOS_r(cur->geos_handle);
+    free(cur);
+  }
+  geos_list = NULL;
+  msReleaseLock(TLOCK_GEOS);
+#endif
+}
+
+/*
+** Translation functions
+*/
+static GEOSGeom msGEOSShape2Geometry_point(pointObj *point) {
+  GEOSCoordSeq coords;
+  GEOSGeom g;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!point)
+    return NULL;
+
+  coords = GEOSCoordSeq_create_r(handle, 1, 2); /* todo handle z's */
+  if (!coords)
+    return NULL;
+
+  GEOSCoordSeq_setX_r(handle, coords, 0, point->x);
+  GEOSCoordSeq_setY_r(handle, coords, 0, point->y);
+  /* GEOSCoordSeq_setY(coords, 0, point->z); */
+
+  g = GEOSGeom_createPoint_r(handle,
+                             coords); /* g owns the coordinate in coords */
+
+  return g;
+}
+
+static GEOSGeom msGEOSShape2Geometry_multipoint(lineObj *multipoint) {
+  int i;
+  GEOSGeom g;
+  GEOSGeom *points;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!multipoint)
+    return NULL;
+
+  points = malloc(multipoint->numpoints * sizeof(GEOSGeom));
+  if (!points)
+    return NULL;
+
+  for (i = 0; i < multipoint->numpoints; i++)
+    points[i] = msGEOSShape2Geometry_point(&(multipoint->point[i]));
+
+  g = GEOSGeom_createCollection_r(handle, GEOS_MULTIPOINT, points,
+                                  multipoint->numpoints);
+
+  free(points);
+
+  return g;
+}
+
+static GEOSGeom msGEOSShape2Geometry_line(lineObj *line) {
+  int i;
+  GEOSGeom g;
+  GEOSCoordSeq coords;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!line)
+    return NULL;
+
+  coords =
+      GEOSCoordSeq_create_r(handle, line->numpoints, 2); /* todo handle z's */
+  if (!coords)
+    return NULL;
+
+  for (i = 0; i < line->numpoints; i++) {
+    GEOSCoordSeq_setX_r(handle, coords, i, line->point[i].x);
+    GEOSCoordSeq_setY_r(handle, coords, i, line->point[i].y);
+    /* GEOSCoordSeq_setZ(coords, i, line->point[i].z); */
+  }
+
+  g = GEOSGeom_createLineString_r(
+      handle, coords); /* g owns the coordinates in coords */
+
+  return g;
+}
+
+static GEOSGeom msGEOSShape2Geometry_multiline(shapeObj *multiline) {
+  int i;
+  GEOSGeom g;
+  GEOSGeom *lines;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!multiline)
+    return NULL;
+
+  lines = malloc(multiline->numlines * sizeof(GEOSGeom));
+  if (!lines)
+    return NULL;
+
+  for (i = 0; i < multiline->numlines; i++)
+    lines[i] = msGEOSShape2Geometry_line(&(multiline->line[i]));
+
+  g = GEOSGeom_createCollection_r(handle, GEOS_MULTILINESTRING, lines,
+                                  multiline->numlines);
+
+  free(lines);
+
+  return g;
+}
+
+static GEOSGeom msGEOSShape2Geometry_simplepolygon(shapeObj *shape, int r,
+                                                   int *outerList) {
+  int i, j, k;
+  GEOSCoordSeq coords;
+  GEOSGeom g;
+  GEOSGeom outerRing;
+  GEOSGeom *innerRings = NULL;
+  int numInnerRings = 0, *innerList;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape || !outerList)
+    return NULL;
+
+  /* build the outer shell */
+  coords = GEOSCoordSeq_create_r(handle, shape->line[r].numpoints,
+                                 2); /* todo handle z's */
+  if (!coords)
+    return NULL;
+
+  for (i = 0; i < shape->line[r].numpoints; i++) {
+    GEOSCoordSeq_setX_r(handle, coords, i, shape->line[r].point[i].x);
+    GEOSCoordSeq_setY_r(handle, coords, i, shape->line[r].point[i].y);
+    /* GEOSCoordSeq_setZ(coords, i, shape->line[r].point[i].z); */
+  }
+
+  outerRing = GEOSGeom_createLinearRing_r(
+      handle, coords); /* outerRing owns the coordinates in coords */
+
+  /* build the holes */
+  innerList = msGetInnerList(shape, r, outerList);
+  for (j = 0; j < shape->numlines; j++)
+    if (innerList[j] == MS_TRUE)
+      numInnerRings++;
+
+  if (numInnerRings > 0) {
+    k = 0; /* inner ring counter */
+
+    innerRings = msSmallMalloc(numInnerRings * sizeof(GEOSGeom));
+
+    for (j = 0; j < shape->numlines; j++) {
+      if (innerList[j] == MS_FALSE)
+        continue;
+
+      coords = GEOSCoordSeq_create_r(handle, shape->line[j].numpoints,
+                                     2); /* todo handle z's */
+      if (!coords) {
+        free(innerRings);
+        free(innerList);
+        return NULL; /* todo, this will leak memory (shell + allocated holes) */
+      }
+
+      for (i = 0; i < shape->line[j].numpoints; i++) {
+        GEOSCoordSeq_setX_r(handle, coords, i, shape->line[j].point[i].x);
+        GEOSCoordSeq_setY_r(handle, coords, i, shape->line[j].point[i].y);
+        /* GEOSCoordSeq_setZ(coords, i, shape->line[j].point[i].z); */
+      }
+
+      innerRings[k] = GEOSGeom_createLinearRing_r(
+          handle, coords); /* innerRings[k] owns the coordinates in coords */
+      k++;
+    }
+  }
+
+  g = GEOSGeom_createPolygon_r(handle, outerRing, innerRings, numInnerRings);
+
+  free(innerList);  /* clean up */
+  free(innerRings); /* clean up */
+
+  return g;
+}
+
+static GEOSGeom msGEOSShape2Geometry_polygon(shapeObj *shape) {
+  int i, j;
+  GEOSGeom *polygons;
+  int *outerList, numOuterRings = 0, lastOuterRing = 0;
+  GEOSGeom g;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  outerList = msGetOuterList(shape);
+  for (i = 0; i < shape->numlines; i++) {
+    if (outerList[i] == MS_TRUE) {
+      numOuterRings++;
+      lastOuterRing = i; /* save for the simple case */
+    }
+  }
+
+  if (numOuterRings == 1) {
+    g = msGEOSShape2Geometry_simplepolygon(shape, lastOuterRing, outerList);
+  } else { /* a true multipolygon */
+    polygons = msSmallMalloc(numOuterRings * sizeof(GEOSGeom));
+
+    j = 0; /* part counter */
+    for (i = 0; i < shape->numlines; i++) {
+      if (outerList[i] == MS_FALSE)
+        continue;
+      polygons[j] = msGEOSShape2Geometry_simplepolygon(
+          shape, i, outerList); /* TODO: account for NULL return values */
+      j++;
+    }
+
+    g = GEOSGeom_createCollection_r(handle, GEOS_MULTIPOLYGON, polygons,
+                                    numOuterRings);
+    free(polygons);
+  }
+
+  free(outerList);
+  return g;
+}
+
+GEOSGeom msGEOSShape2Geometry(shapeObj *shape) {
+  if (!shape)
+    return NULL; /* a NULL shape generates a NULL geometry */
+
+  switch (shape->type) {
+  case MS_SHAPE_POINT:
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints == 0) /* not enough info for a point */
+      return NULL;
+
+    if (shape->line[0].numpoints == 1) /* simple point */
+      return msGEOSShape2Geometry_point(&(shape->line[0].point[0]));
+    else /* multi-point */
+      return msGEOSShape2Geometry_multipoint(&(shape->line[0]));
+    break;
+  case MS_SHAPE_LINE:
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints < 2) /* not enough info for a line */
+      return NULL;
+
+    if (shape->numlines == 1) /* simple line */
+      return msGEOSShape2Geometry_line(&(shape->line[0]));
+    else /* multi-line */
+      return msGEOSShape2Geometry_multiline(shape);
+    break;
+  case MS_SHAPE_POLYGON:
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints <
+            4) /* not enough info for a polygon (first=last) */
+      return NULL;
+
+    return msGEOSShape2Geometry_polygon(
+        shape); /* simple and multipolygon cases are addressed */
+    break;
+  default:
+    break;
+  }
+
+  return NULL; /* should not get here */
+}
+
+static shapeObj *msGEOSGeometry2Shape_point(GEOSGeom g) {
+  GEOSCoordSeq coords;
+  shapeObj *shape = NULL;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!g)
+    return NULL;
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  msInitShape(shape);
+
+  shape->type = MS_SHAPE_POINT;
+  shape->line = (lineObj *)malloc(sizeof(lineObj));
+  shape->numlines = 1;
+  shape->line[0].point = (pointObj *)malloc(sizeof(pointObj));
+  shape->line[0].numpoints = 1;
+  shape->geometry = (GEOSGeom)g;
+
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, g);
+
+  GEOSCoordSeq_getX_r(handle, coords, 0, &(shape->line[0].point[0].x));
+  GEOSCoordSeq_getY_r(handle, coords, 0, &(shape->line[0].point[0].y));
+  /* GEOSCoordSeq_getZ(coords, 0, &(shape->line[0].point[0].z)); */
+
+  shape->bounds.minx = shape->bounds.maxx = shape->line[0].point[0].x;
+  shape->bounds.miny = shape->bounds.maxy = shape->line[0].point[0].y;
+
+  return shape;
+}
+
+static shapeObj *msGEOSGeometry2Shape_multipoint(GEOSGeom g) {
+  int i;
+  int numPoints;
+  GEOSCoordSeq coords;
+  GEOSGeom point;
+
+  shapeObj *shape = NULL;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!g)
+    return NULL;
+  numPoints = GEOSGetNumGeometries_r(handle, g); /* each geometry has 1 point */
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  msInitShape(shape);
+
+  shape->type = MS_SHAPE_POINT;
+  shape->line = (lineObj *)malloc(sizeof(lineObj));
+  shape->numlines = 1;
+  shape->line[0].point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
+  shape->line[0].numpoints = numPoints;
+  shape->geometry = (GEOSGeom)g;
+
+  for (i = 0; i < numPoints; i++) {
+    point = (GEOSGeom)GEOSGetGeometryN_r(handle, g, i);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, point);
+
+    GEOSCoordSeq_getX_r(handle, coords, 0, &(shape->line[0].point[i].x));
+    GEOSCoordSeq_getY_r(handle, coords, 0, &(shape->line[0].point[i].y));
+    /* GEOSCoordSeq_getZ(coords, 0, &(shape->line[0].point[i].z)); */
+  }
+
+  msComputeBounds(shape);
+
+  return shape;
+}
+
+static shapeObj *msGEOSGeometry2Shape_line(GEOSGeom g) {
+  shapeObj *shape = NULL;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  int i;
+  int numPoints;
+  GEOSCoordSeq coords;
+
+  if (!g)
+    return NULL;
+  numPoints = GEOSGetNumCoordinates_r(handle, g);
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, g);
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  msInitShape(shape);
+
+  shape->type = MS_SHAPE_LINE;
+  shape->line = (lineObj *)malloc(sizeof(lineObj));
+  shape->numlines = 1;
+  shape->line[0].point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
+  shape->line[0].numpoints = numPoints;
+  shape->geometry = (GEOSGeom)g;
+
+  for (i = 0; i < numPoints; i++) {
+    GEOSCoordSeq_getX_r(handle, coords, i, &(shape->line[0].point[i].x));
+    GEOSCoordSeq_getY_r(handle, coords, i, &(shape->line[0].point[i].y));
+    /* GEOSCoordSeq_getZ(coords, i, &(shape->line[0].point[i].z)); */
+  }
+
+  msComputeBounds(shape);
+
+  return shape;
+}
+
+static void msGEOSGeometry2Shape_multiline_part(GEOSContextHandle_t handle,
+                                                GEOSGeom part,
+                                                shapeObj *shape) {
+  int i;
+  int type, numGeometries, numPoints;
+  GEOSCoordSeq coords;
+  lineObj line;
+
+  type = GEOSGeomTypeId_r(handle, part);
+  if (type == GEOS_MULTILINESTRING) {
+    numGeometries = GEOSGetNumGeometries_r(handle, part);
+
+    for (i = 0; i < numGeometries; i++) {
+      GEOSGeom subPart = (GEOSGeom)GEOSGetGeometryN_r(handle, part, i);
+      msGEOSGeometry2Shape_multiline_part(handle, subPart, shape);
+    }
+  } else {
+    numPoints = GEOSGetNumCoordinates_r(handle, part);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, part);
+    line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
+    line.numpoints = numPoints;
+
+    for (i = 0; i < numPoints; i++) {
+      GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+      GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
+      /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
+    }
+
+    msAddLineDirectly(shape, &line);
+  }
+}
+
+static shapeObj *msGEOSGeometry2Shape_multiline(GEOSGeom g) {
+  int i;
+  int numGeometries;
+  GEOSGeom part;
+
+  shapeObj *shape = NULL;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!g)
+    return NULL;
+  numGeometries = GEOSGetNumGeometries_r(handle, g);
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  msInitShape(shape);
+
+  shape->type = MS_SHAPE_LINE;
+  shape->geometry = (GEOSGeom)g;
+
+  for (i = 0; i < numGeometries; i++) {
+    part = (GEOSGeom)GEOSGetGeometryN_r(handle, g, i);
+    msGEOSGeometry2Shape_multiline_part(handle, part, shape);
+  }
+
+  msComputeBounds(shape);
+
+  return shape;
+}
+
+static shapeObj *msGEOSGeometry2Shape_polygon(GEOSGeom g) {
+  shapeObj *shape = NULL;
+  lineObj line;
+  int numPoints, numRings;
+  int i, j;
+
+  GEOSCoordSeq coords;
+  GEOSGeom ring;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!g)
+    return NULL;
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  msInitShape(shape);
+  shape->type = MS_SHAPE_POLYGON;
+  shape->geometry = (GEOSGeom)g;
+
+  /* exterior ring */
+  ring = (GEOSGeom)GEOSGetExteriorRing_r(handle, g);
+  numPoints = GEOSGetNumCoordinates_r(handle, ring);
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
+
+  line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
+  line.numpoints = numPoints;
+
+  for (i = 0; i < numPoints; i++) {
+    GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+    GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
+    /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
+  }
+  msAddLineDirectly(shape, &line);
+
+  /* interior rings */
+  numRings = GEOSGetNumInteriorRings_r(handle, g);
+  for (j = 0; j < numRings; j++) {
+    ring = (GEOSGeom)GEOSGetInteriorRingN_r(handle, g, j);
+    if (GEOSisRing_r(handle, ring) != 1)
+      continue; /* skip it */
+
+    numPoints = GEOSGetNumCoordinates_r(handle, ring);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
+
+    line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
+    line.numpoints = numPoints;
+
+    for (i = 0; i < numPoints; i++) {
+      GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+      GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
+      /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
+    }
+    msAddLineDirectly(shape, &line);
+  }
+
+  msComputeBounds(shape);
+
+  return shape;
+}
+
+static shapeObj *msGEOSGeometry2Shape_multipolygon(GEOSGeom g) {
+  int i, j, k;
+  shapeObj *shape = NULL;
+  lineObj line;
+  int numPoints, numRings, numPolygons;
+
+  GEOSCoordSeq coords;
+  GEOSGeom polygon, ring;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!g)
+    return NULL;
+  numPolygons = GEOSGetNumGeometries_r(handle, g);
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  msInitShape(shape);
+  shape->type = MS_SHAPE_POLYGON;
+  shape->geometry = (GEOSGeom)g;
+
+  for (k = 0; k < numPolygons; k++) { /* for each polygon */
+    polygon = (GEOSGeom)GEOSGetGeometryN_r(handle, g, k);
+
+    /* exterior ring */
+    ring = (GEOSGeom)GEOSGetExteriorRing_r(handle, polygon);
+    numPoints = GEOSGetNumCoordinates_r(handle, ring);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
+
+    line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
+    line.numpoints = numPoints;
+
+    for (i = 0; i < numPoints; i++) {
+      GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+      GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
+      /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
+    }
+    msAddLineDirectly(shape, &line);
+
+    /* interior rings */
+    numRings = GEOSGetNumInteriorRings_r(handle, polygon);
+
+    for (j = 0; j < numRings; j++) {
+      ring = (GEOSGeom)GEOSGetInteriorRingN_r(handle, polygon, j);
+      if (GEOSisRing_r(handle, ring) != 1)
+        continue; /* skip it */
+
+      numPoints = GEOSGetNumCoordinates_r(handle, ring);
+      coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
+
+      line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
+      line.numpoints = numPoints;
+
+      for (i = 0; i < numPoints; i++) {
+        GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+        GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
+        /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
+      }
+      msAddLineDirectly(shape, &line);
+    }
+  } /* next polygon */
+
+  msComputeBounds(shape);
+
+  return shape;
+}
+
+shapeObj *msGEOSGeometry2Shape(GEOSGeom g) {
+  int type;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!g)
+    return NULL; /* a NULL geometry generates a NULL shape */
+
+  type = GEOSGeomTypeId_r(handle, g);
+  switch (type) {
+  case GEOS_POINT:
+    return msGEOSGeometry2Shape_point(g);
+    break;
+  case GEOS_MULTIPOINT:
+    return msGEOSGeometry2Shape_multipoint(g);
+    break;
+  case GEOS_LINESTRING:
+    return msGEOSGeometry2Shape_line(g);
+    break;
+  case GEOS_MULTILINESTRING:
+    return msGEOSGeometry2Shape_multiline(g);
+    break;
+  case GEOS_POLYGON:
+    return msGEOSGeometry2Shape_polygon(g);
+    break;
+  case GEOS_MULTIPOLYGON:
+    return msGEOSGeometry2Shape_multipolygon(g);
+    break;
+  case GEOS_GEOMETRYCOLLECTION:
+    if (!GEOSisEmpty_r(handle, g)) {
+      shapeObj *shape = (shapeObj *)malloc(sizeof(shapeObj));
+      msInitShape(shape);
+      shape->type = MS_SHAPE_LINE;
+      shape->geometry = (GEOSGeom)g;
+
+      const int numGeoms = GEOSGetNumGeometries_r(handle, g);
+      for (int i = 0; i < numGeoms; i++) { /* for each geometry */
+        shapeObj *shape2 =
+            msGEOSGeometry2Shape((GEOSGeom)GEOSGetGeometryN_r(handle, g, i));
+        if (shape2) {
+          for (int j = 0; j < shape2->numlines; j++)
+            msAddLineDirectly(shape, &shape2->line[j]);
+          shape2->numlines = 0;
+          shape2->geometry = NULL; /* not owned */
+          msFreeShape(shape2);
+        }
+      }
+      msComputeBounds(shape);
+      return shape;
+    }
+    break;
+  default:
+    msSetError(MS_GEOSERR, "Unsupported GEOS geometry type (%d).",
+               "msGEOSGeometry2Shape()", type);
+  }
+  return NULL;
+}
+#endif
+
+/*
+** Maintenence functions exposed to MapServer/MapScript.
+*/
+
+void msGEOSFreeGeometry(shapeObj *shape) {
+#ifdef USE_GEOS
+  GEOSGeom g = NULL;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape || !shape->geometry)
+    return;
+
+  g = (GEOSGeom)shape->geometry;
+  GEOSGeom_destroy_r(handle, g);
+  shape->geometry = NULL;
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSFreeGEOSGeom()");
+  return;
+#endif
+}
+
+/*
+** WKT input and output functions
+*/
+shapeObj *msGEOSShapeFromWKT(const char *wkt) {
+#ifdef USE_GEOS
+  GEOSGeom g;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!wkt)
+    return NULL;
+
+  g = GEOSGeomFromWKT_r(handle, wkt);
+  if (!g) {
+    msSetError(MS_GEOSERR, "Error reading WKT geometry \"%s\".",
+               "msGEOSShapeFromWKT()", wkt);
+    return NULL;
+  } else {
+    return msGEOSGeometry2Shape(g);
+  }
+
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSShapeFromWKT()");
+  return NULL;
+#endif
+}
+
+/* Return should be freed with msGEOSFreeWKT */
+char *msGEOSShapeToWKT(shapeObj *shape) {
+#ifdef USE_GEOS
+  GEOSGeom g;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  /* if we have a geometry, we should update it*/
+  msGEOSFreeGeometry(shape);
+
+  shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g = (GEOSGeom)shape->geometry;
+  if (!g)
+    return NULL;
+
+  return GEOSGeomToWKT_r(handle, g);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSShapeToWKT()");
+  return NULL;
+#endif
+}
+
+void msGEOSFreeWKT(char *pszGEOSWKT) {
+#ifdef USE_GEOS
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+#if GEOS_VERSION_MAJOR > 3 ||                                                  \
+    (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 2)
+  GEOSFree_r(handle, pszGEOSWKT);
+#endif
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSFreeWKT()");
+#endif
+}
+
+shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset) {
+#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 ||                             \
+                         (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
+  int typeChanged = 0;
+  GEOSGeom g1, g2 = NULL;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!p)
+    return NULL;
+
+  /*
+   * GEOSOffsetCurve_r() uses BufferBuilder.bufferLineSingleSided(), which
+   * works with lines, naturally. In order to allow offsets for a MapServer
+   * polygonObj, it has to be processed as line and afterwards reverted.
+   */
+  if (p->type == MS_SHAPE_POLYGON) {
+    p->type = MS_SHAPE_LINE;
+    typeChanged = 1;
+    msGEOSFreeGeometry(p);
+  }
+
+  if (typeChanged || !p->geometry)
+    p->geometry = (GEOSGeom)msGEOSShape2Geometry(p);
+
+  g1 = (GEOSGeom)p->geometry;
+  if (!g1)
+    return NULL;
+
+  if (GEOSGeomTypeId_r(handle, g1) == GEOS_MULTILINESTRING) {
+    GEOSGeom *lines = malloc(p->numlines * sizeof(GEOSGeom));
+    if (!lines)
+      return NULL;
+    for (int i = 0; i < p->numlines; i++) {
+      lines[i] =
+          GEOSOffsetCurve_r(handle, GEOSGetGeometryN_r(handle, g1, i), offset,
+                            4, GEOSBUF_JOIN_MITRE, fabs(offset * 1.5));
+    }
+    g2 = GEOSGeom_createCollection_r(handle, GEOS_MULTILINESTRING, lines,
+                                     p->numlines);
+    free(lines);
+  } else {
+    g2 = GEOSOffsetCurve_r(handle, g1, offset, 4, GEOSBUF_JOIN_MITRE,
+                           fabs(offset * 1.5));
+  }
+
+  /*
+   * Undo change of geometry type. We won't re-create the geos gemotry here,
+   * it's up to each geos function to create it.
+   */
+  if (typeChanged) {
+    msGEOSFreeGeometry(p);
+    p->type = MS_SHAPE_POLYGON;
+  }
+
+  if (g2)
+    return msGEOSGeometry2Shape(g2);
+
+  return NULL;
+#else
+  msSetError(MS_GEOSERR, "GEOS Offset Curve support is not available.",
+             "msGEOSingleSidedBuffer()");
+  return NULL;
+#endif
+}
+
+/*
+** Analytical functions exposed to MapServer/MapScript.
+*/
+
+shapeObj *msGEOSBuffer(shapeObj *shape, double width) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSBuffer_r(handle, g1, width, 30);
+  return msGEOSGeometry2Shape(g2);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSBuffer()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSSimplify_r(handle, g1, tolerance);
+  return msGEOSGeometry2Shape(g2);
+#else
+  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.",
+             "msGEOSSimplify()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape, double tolerance) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSTopologyPreserveSimplify_r(handle, g1, tolerance);
+  return msGEOSGeometry2Shape(g2);
+#else
+  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.",
+             "msGEOSTopologyPreservingSimplify()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSConvexHull(shapeObj *shape) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSConvexHull_r(handle, g1);
+  return msGEOSGeometry2Shape(g2);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSConvexHull()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSBoundary(shapeObj *shape) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSBoundary_r(handle, g1);
+  return msGEOSGeometry2Shape(g2);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSBoundary()");
+  return NULL;
+#endif
+}
+
+pointObj *msGEOSGetCentroid(shapeObj *shape) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  GEOSCoordSeq coords;
+  pointObj *point;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSGetCentroid_r(handle, g1);
+  if (!g2)
+    return NULL;
+
+  point = (pointObj *)malloc(sizeof(pointObj));
+
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, g2);
+
+  GEOSCoordSeq_getX_r(handle, coords, 0, &(point->x));
+  GEOSCoordSeq_getY_r(handle, coords, 0, &(point->y));
+  /* GEOSCoordSeq_getZ(coords, 0, &(point->z)); */
+
+  GEOSGeom_destroy_r(handle, g2);
+
+  return point;
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSGetCentroid()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2, g3;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return NULL;
+
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
+
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
+
+  g3 = GEOSUnion_r(handle, g1, g2);
+  return msGEOSGeometry2Shape(g3);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSUnion()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2, g3;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return NULL;
+
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
+
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
+
+  g3 = GEOSIntersection_r(handle, g1, g2);
+  return msGEOSGeometry2Shape(g3);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSIntersection()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2, g3;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return NULL;
+
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
+
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
+
+  g3 = GEOSDifference_r(handle, g1, g2);
+  return msGEOSGeometry2Shape(g3);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSDifference()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2, g3;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return NULL;
+
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
+
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
+
+  g3 = GEOSSymDifference_r(handle, g1, g2);
+  return msGEOSGeometry2Shape(g3);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSSymDifference()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSLineMerge(shapeObj *shape) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_LINE)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSLineMerge_r(handle, g1);
+  return msGEOSGeometry2Shape(g2);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSLineMerge()");
+  return NULL;
+#endif
+}
+
+shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance,
+                               int onlyEdges) {
+#if defined(USE_GEOS) &&                                                       \
+    (GEOS_VERSION_MAJOR > 3 ||                                                 \
+     (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
+  GEOSGeom g1, g2;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return NULL;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
+
+  g2 = GEOSVoronoiDiagram_r(handle, g1, NULL, tolerance, onlyEdges);
+  return msGEOSGeometry2Shape(g2);
+#else
+  msSetError(
+      MS_GEOSERR,
+      "GEOS support is not available or GEOS version is not 3.5 or higher.",
+      "msGEOSVoronoiDiagram()");
+  return NULL;
+#endif
+}
+
+static int keepEdge(lineObj *segment, shapeObj *polygon) {
+  int i, j;
+
+  if (segment->numpoints < 2)
+    return MS_FALSE;
+  if (msIntersectPointPolygon(&segment->point[0], polygon) != MS_TRUE)
+    return MS_FALSE;
+  if (msIntersectPointPolygon(&segment->point[1], polygon) != MS_TRUE)
+    return MS_FALSE;
+
+  for (i = 0; i < polygon->numlines; i++)
+    for (j = 1; j < polygon->line[i].numpoints; j++)
+      if (msIntersectSegments(&(segment->point[0]), &(segment->point[1]),
+                              &(polygon->line[i].point[j - 1]),
+                              &(polygon->line[i].point[j])) == MS_TRUE)
+        return (MS_FALSE);
+
+  return (MS_TRUE);
+}
+
+#define ARE_SAME_POINTS(a, b)                                                  \
+  (((a).x != (b).x || (a).y != (b).y) ? MS_FALSE : MS_TRUE)
+
+// returns the index of the node, we use z to store a count of points at the
+// same coordinate
+static int buildNodes(multipointObj *nodes, pointObj *point) {
+  int i;
+
+  for (i = 0; i < nodes->numpoints; i++) {
+    if (ARE_SAME_POINTS(nodes->point[i], *point)) { // found it
+      nodes->point[i].z++;
+      return i;
+    }
+  }
+
+  // not found, add it
+  nodes->point[i].x = point->x;
+  nodes->point[i].y = point->y;
+  nodes->point[i].z = 1;
+  nodes->numpoints++;
+
+  return i;
+}
+
+shapeObj *msGEOSCenterline(shapeObj *shape) {
+#if defined(USE_GEOS) &&                                                       \
+    (GEOS_VERSION_MAJOR > 3 ||                                                 \
+     (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
+  int i;
+  shapeObj *shape2 = NULL;
+
+  multipointObj nodes;
+  graphObj *graph;
+
+  int *path = NULL; // array of node indexes
+  int path_size = 0;
+  double path_dist = -1, max_path_dist = -1;
+
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_POLYGON) {
+    msSetError(MS_GEOSERR,
+               "Centerlines can only be computed for polygon shapes.",
+               "msGEOSCenterline()");
+    return NULL;
+  }
+
+  shape2 = msGEOSVoronoiDiagram(shape, 0.0, MS_TRUE);
+  if (!shape2) {
+    msSetError(MS_GEOSERR, "Voronoi diagram generation failed.",
+               "msGEOSCenterline()");
+    return NULL;
+  }
+
+  // process the edges and build a graph representation
+  nodes.point = (pointObj *)malloc(shape2->numlines * sizeof(pointObj) * 2);
+  nodes.numpoints = 0;
+  if (!nodes.point) {
+    msFreeShape(shape2);
+    free(shape2);
+    return NULL;
+  }
+
+  graph = msCreateGraph(shape2->numlines * 2);
+  if (!graph) {
+    msFreeShape(shape2);
+    free(shape2);
+    free(nodes.point);
+    return NULL;
+  }
+
+  for (i = 0; i < shape2->numlines; i++) {
+    if (keepEdge(&shape2->line[i], shape) == MS_TRUE) {
+      int src = buildNodes(&nodes, &shape2->line[i].point[0]);
+      int dest = buildNodes(&nodes, &shape2->line[i].point[1]);
+      msGraphAddEdge(graph, src, dest,
+                     msDistancePointToPoint(&shape2->line[i].point[0],
+                                            &shape2->line[i].point[1]));
+    }
+  }
+  msFreeShape(shape2); // done with voronoi geometry, shape2 is still allocated
+                       // though, just empty
+  shape2->type = MS_SHAPE_LINE; // will fill with centerline
+
+  if (nodes.numpoints == 0) {
+    msSetError(MS_GEOSERR,
+               "Centerline generation failed, try densifying the shapes.",
+               "msGEOSCenterline()");
+    free(shape2);
+    msFreeGraph(graph);
+    free(nodes.point);
+    return NULL;
+  }
+
+  // step through edge nodes (z=1)
+  for (i = 0; i < nodes.numpoints; i++) {
+    if (nodes.point[i].z != 1)
+      continue; // skip
+
+    if (!path) { // first one, keep this path
+      path = msGraphGetLongestShortestPath(graph, i, &path_size, &path_dist);
+      max_path_dist = path_dist;
+    } else {
+      int *tmp_path = NULL;
+      int tmp_path_size = 0;
+      double tmp_path_dist = -1;
+
+      if (i == path[path_size - 1])
+        continue; // skip, graph is bi-directional so it can't be any longer
+      tmp_path = msGraphGetLongestShortestPath(graph, i, &tmp_path_size,
+                                               &tmp_path_dist);
+      if (tmp_path_dist > max_path_dist) {
+        free(path);
+        path = tmp_path;
+        path_size = tmp_path_size;
+        path_dist = tmp_path_dist;
+        max_path_dist = tmp_path_dist;
+      } else { // skip path
+        msFree(tmp_path);
+      }
+    }
+  }
+  msFreeGraph(graph); // done with graph
+
+  // transform the path into a shape
+  if (!path) {
+    msSetError(MS_GEOSERR, "Centerline generation failed.",
+               "msGEOSCenterline()");
+    free(shape2);
+    free(nodes.point);
+    return NULL;
+  } else {
+    lineObj line;
+    line.point = (pointObj *)malloc(path_size * sizeof(pointObj));
+    if (!line.point) {
+      free(shape2);
+      free(path);
+      free(nodes.point);
+      return NULL;
+    }
+    line.numpoints = path_size;
+
+    for (i = 0; i < path_size; i++) {
+      line.point[i].x = nodes.point[path[i]].x;
+      line.point[i].y = nodes.point[path[i]].y;
+    }
+    msAddLineDirectly(shape2, &line);
+  }
+
+  free(path); // clean up
+  free(nodes.point);
+
+  return shape2;
+#else
+  msSetError(
+      MS_GEOSERR,
+      "GEOS support is not available or GEOS version is not 3.5 or higher.",
+      "msGEOSCenterline()");
+  return NULL;
+#endif
+}
+
+/*
+** Binary predicates exposed to MapServer/MapScript
+*/
+
+/*
+** Does shape1 contain shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSContains(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSContains_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSContains()");
+  return -1;
+#endif
+}
+
+/*
+** Does shape1 overlap shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSOverlaps_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSOverlaps()");
+  return -1;
+#endif
+}
+
+/*
+** Is shape1 within shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSWithin(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSWithin_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSWithin()");
+  return -1;
+#endif
+}
+
+/*
+** Does shape1 cross shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSCrosses_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSCrosses()");
+  return -1;
+#endif
+}
+
+/*
+** Does shape1 intersect shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSIntersects_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  if (!shape1 || !shape2)
+    return -1;
+
+  switch (shape1->type) { /* todo: deal with point shapes */
+  case (MS_SHAPE_LINE):
+    switch (shape2->type) {
+    case (MS_SHAPE_LINE):
+      return msIntersectPolylines(shape1, shape2);
+    case (MS_SHAPE_POLYGON):
+      return msIntersectPolylinePolygon(shape1, shape2);
+    }
+    break;
+  case (MS_SHAPE_POLYGON):
+    switch (shape2->type) {
+    case (MS_SHAPE_LINE):
+      return msIntersectPolylinePolygon(shape2, shape1);
+    case (MS_SHAPE_POLYGON):
+      return msIntersectPolygons(shape1, shape2);
+    }
+    break;
+  }
+
+  return -1;
+#endif
+}
+
+/*
+** Does shape1 touch shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSTouches(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSTouches_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSTouches()");
+  return -1;
+#endif
+}
+
+/*
+** Does shape1 equal shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSEquals(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSEquals_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSEquals()");
+  return -1;
+#endif
+}
+
+/*
+** Are shape1 and shape2 disjoint, returns MS_TRUE/MS_FALSE or -1 for an error.
+*/
+int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSDisjoint_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSDisjoint()");
+  return -1;
+#endif
+}
+
+/*
+** Useful misc. functions that return -1 on failure.
+*/
+double msGEOSArea(shapeObj *shape) {
+#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) &&                   \
+    defined(GEOS_CAPI_VERSION_MINOR) &&                                        \
+    (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
+  GEOSGeom g;
+  double area;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return -1;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g = (GEOSGeom)shape->geometry;
+  if (!g)
+    return -1;
+
+  result = GEOSArea_r(handle, g, &area);
+  return ((result == 0) ? -1 : area);
+#elif defined(USE_GEOS)
+  msSetError(MS_GEOSERR,
+             "GEOS support enabled, but old version lacks GEOSArea().",
+             "msGEOSArea()");
+  return -1;
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSArea()");
+  return -1;
+#endif
+}
+
+double msGEOSLength(shapeObj *shape) {
+#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) &&                   \
+    defined(GEOS_CAPI_VERSION_MINOR) &&                                        \
+    (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
+
+  GEOSGeom g;
+  double length;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape)
+    return -1;
+
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g = (GEOSGeom)shape->geometry;
+  if (!g)
+    return -1;
+
+  result = GEOSLength_r(handle, g, &length);
+  return ((result == 0) ? -1 : length);
+#elif defined(USE_GEOS)
+  msSetError(MS_GEOSERR,
+             "GEOS support enabled, but old version lacks GEOSLength().",
+             "msGEOSLength()");
+  return -1;
+#else
+  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSLength()");
+  return -1;
+#endif
+}
+
+double msGEOSDistance(shapeObj *shape1, shapeObj *shape2) {
+#ifdef USE_GEOS
+  GEOSGeom g1, g2;
+  double distance;
+  int result;
+  GEOSContextHandle_t handle = msGetGeosContextHandle();
+
+  if (!shape1 || !shape2)
+    return -1;
+
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
+
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
+
+  result = GEOSDistance_r(handle, g1, g2, &distance);
+  return ((result == 0) ? -1 : distance);
+#else
+  return msDistanceShapeToShape(
+      shape1, shape2); /* fall back on brute force method (for MapScript) */
+#endif
+}
diff -pruN 8.0.1-5/src/mapgml.c 8.2.0~beta1-1~exp1/src/mapgml.c
--- 8.0.1-5/src/mapgml.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgml.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2539 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  shapeObj to GML output via MapServer queries.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapows.h"
+#include "mapgml.h"
+#include "maptime.h"
+
+/* Use only mapgml.c if WMS or WFS is available (with minor exceptions at end)
+ */
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR)
+
+static int msGMLGeometryLookup(gmlGeometryListObj *geometryList,
+                               const char *type);
+
+/*
+** Functions that write the feature boundary geometry (i.e. a rectObj).
+*/
+
+/* GML 2.1.2 */
+static int gmlWriteBounds_GML2(FILE *stream, rectObj *rect, const char *srsname,
+                               const char *tab, const char *pszTopPrefix) {
+  char *srsname_encoded;
+
+  if (!stream)
+    return (MS_FAILURE);
+  if (!rect)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
+
+  msIO_fprintf(stream, "%s<%s:boundedBy>\n", tab, pszTopPrefix);
+  if (srsname) {
+    srsname_encoded = msEncodeHTMLEntities(srsname);
+    msIO_fprintf(stream, "%s\t<gml:Box srsName=\"%s\">\n", tab,
+                 srsname_encoded);
+    msFree(srsname_encoded);
+  } else
+    msIO_fprintf(stream, "%s\t<gml:Box>\n", tab);
+
+  msIO_fprintf(stream, "%s\t\t<gml:coordinates>", tab);
+  msIO_fprintf(stream, "%.6f,%.6f %.6f,%.6f", rect->minx, rect->miny,
+               rect->maxx, rect->maxy);
+  msIO_fprintf(stream, "</gml:coordinates>\n");
+  msIO_fprintf(stream, "%s\t</gml:Box>\n", tab);
+  msIO_fprintf(stream, "%s</%s:boundedBy>\n", tab, pszTopPrefix);
+
+  return MS_SUCCESS;
+}
+
+/* GML 3.1 or GML 3.2 (MapServer limits GML encoding to the level 0 profile) */
+static int gmlWriteBounds_GML3(FILE *stream, rectObj *rect, const char *srsname,
+                               const char *tab, const char *pszTopPrefix) {
+  char *srsname_encoded;
+
+  if (!stream)
+    return (MS_FAILURE);
+  if (!rect)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
+
+  msIO_fprintf(stream, "%s<%s:boundedBy>\n", tab, pszTopPrefix);
+  if (srsname) {
+    srsname_encoded = msEncodeHTMLEntities(srsname);
+    msIO_fprintf(stream, "%s\t<gml:Envelope srsName=\"%s\">\n", tab,
+                 srsname_encoded);
+    msFree(srsname_encoded);
+  } else
+    msIO_fprintf(stream, "%s\t<gml:Envelope>\n", tab);
+
+  msIO_fprintf(stream, "%s\t\t<gml:lowerCorner>%.6f %.6f</gml:lowerCorner>\n",
+               tab, rect->minx, rect->miny);
+  msIO_fprintf(stream, "%s\t\t<gml:upperCorner>%.6f %.6f</gml:upperCorner>\n",
+               tab, rect->maxx, rect->maxy);
+
+  msIO_fprintf(stream, "%s\t</gml:Envelope>\n", tab);
+  msIO_fprintf(stream, "%s</%s:boundedBy>\n", tab, pszTopPrefix);
+
+  return MS_SUCCESS;
+}
+
+static void gmlStartGeometryContainer(FILE *stream, const char *name,
+                                      const char *namespace, const char *tab) {
+  const char *tag_name = OWS_GML_DEFAULT_GEOMETRY_NAME;
+
+  if (name)
+    tag_name = name;
+
+  if (namespace)
+    msIO_fprintf(stream, "%s<%s:%s>\n", tab, namespace, tag_name);
+  else
+    msIO_fprintf(stream, "%s<%s>\n", tab, tag_name);
+}
+
+static void gmlEndGeometryContainer(FILE *stream, const char *name,
+                                    const char *namespace, const char *tab) {
+  const char *tag_name = OWS_GML_DEFAULT_GEOMETRY_NAME;
+
+  if (name)
+    tag_name = name;
+
+  if (namespace)
+    msIO_fprintf(stream, "%s</%s:%s>\n", tab, namespace, tag_name);
+  else
+    msIO_fprintf(stream, "%s</%s>\n", tab, tag_name);
+}
+
+/* GML 2.1.2 */
+static int gmlWriteGeometry_GML2(FILE *stream, gmlGeometryListObj *geometryList,
+                                 shapeObj *shape, const char *srsname,
+                                 const char *namespace, const char *tab,
+                                 int nSRSDimension, int geometry_precision) {
+  int i, j, k;
+  int *innerlist, *outerlist = NULL, numouters;
+  char *srsname_encoded = NULL;
+
+  int geometry_aggregate_index, geometry_simple_index;
+  char *geometry_aggregate_name = NULL, *geometry_simple_name = NULL;
+
+  if (!stream)
+    return (MS_FAILURE);
+  if (!shape)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
+  if (!geometryList)
+    return (MS_FAILURE);
+
+  if (shape->numlines <= 0)
+    return (MS_SUCCESS); /* empty shape, nothing to output */
+
+  if (srsname)
+    srsname_encoded = msEncodeHTMLEntities(srsname);
+
+  /* feature geometry */
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1)) { /* write a Point(s) */
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          gmlStartGeometryContainer(stream, geometry_simple_name, namespace,
+                                    tab);
+
+          /* Point */
+          if (srsname_encoded)
+            msIO_fprintf(stream, "%s<gml:Point srsName=\"%s\">\n", tab,
+                         srsname_encoded);
+          else
+            msIO_fprintf(stream, "%s<gml:Point>\n", tab);
+
+          if (nSRSDimension == 3)
+            msIO_fprintf(
+                stream,
+                "%s  <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n", tab,
+                geometry_precision, shape->line[i].point[j].x,
+                geometry_precision, shape->line[i].point[j].y,
+                geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
+
+            msIO_fprintf(stream,
+                         "%s  <gml:coordinates>%.*f,%.*f</gml:coordinates>\n",
+                         tab, geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y);
+
+          msIO_fprintf(stream, "%s</gml:Point>\n", tab);
+
+          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+        }
+      }
+    } else if ((geometry_aggregate_index != -1) ||
+               (geometryList->numgeometries == 0)) { /* write a MultiPoint */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiPoint */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s<gml:MultiPoint srsName=\"%s\">\n", tab,
+                     srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s<gml:MultiPoint>\n", tab);
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          msIO_fprintf(stream, "%s  <gml:pointMember>\n", tab);
+          msIO_fprintf(stream, "%s    <gml:Point>\n", tab);
+          if (nSRSDimension == 3)
+            msIO_fprintf(
+                stream,
+                "%s      <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n",
+                tab, geometry_precision, shape->line[i].point[j].x,
+                geometry_precision, shape->line[i].point[j].y,
+                geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(
+                stream, "%s      <gml:coordinates>%f,%f</gml:coordinates>\n",
+                tab, shape->line[i].point[j].x, shape->line[i].point[j].y);
+          msIO_fprintf(stream, "%s    </gml:Point>\n", tab);
+          msIO_fprintf(stream, "%s  </gml:pointMember>\n", tab);
+        }
+      }
+
+      msIO_fprintf(stream, "%s</gml:MultiPoint>\n", tab);
+
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "point/multipoint geometry defined. -->\n");
+    }
+
+    break;
+  case (MS_SHAPE_LINE):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a LineStrings(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
+
+        /* LineString */
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s<gml:LineString srsName=\"%s\">\n", tab,
+                       srsname_encoded);
+        else
+          msIO_fprintf(stream, "%s<gml:LineString>\n", tab);
+
+        msIO_fprintf(stream, "%s  <gml:coordinates>", tab);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+        msIO_fprintf(stream, "</gml:coordinates>\n");
+
+        msIO_fprintf(stream, "%s</gml:LineString>\n", tab);
+
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+      }
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiCurve */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiLineString */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s<gml:MultiLineString srsName=\"%s\">\n", tab,
+                     srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s<gml:MultiLineString>\n", tab);
+
+      for (j = 0; j < shape->numlines; j++) {
+        msIO_fprintf(stream, "%s  <gml:lineStringMember>\n",
+                     tab); /* no srsname at this point */
+        msIO_fprintf(stream, "%s    <gml:LineString>\n",
+                     tab); /* no srsname at this point */
+
+        msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
+        for (i = 0; i < shape->line[j].numpoints; i++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                         shape->line[j].point[i].x, geometry_precision,
+                         shape->line[j].point[i].y, geometry_precision,
+                         shape->line[j].point[i].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                         shape->line[j].point[i].x, geometry_precision,
+                         shape->line[j].point[i].y);
+        }
+        msIO_fprintf(stream, "</gml:coordinates>\n");
+        msIO_fprintf(stream, "%s    </gml:LineString>\n", tab);
+        msIO_fprintf(stream, "%s  </gml:lineStringMember>\n", tab);
+      }
+
+      msIO_fprintf(stream, "%s</gml:MultiLineString>\n", tab);
+
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "line/multiline geometry defined. -->\n");
+    }
+
+    break;
+  case (
+      MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
+    geometry_aggregate_index =
+        msGMLGeometryLookup(geometryList, "multipolygon");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    /* get a list of outter rings for this polygon */
+    outerlist = msGetOuterList(shape);
+
+    numouters = 0;
+    for (i = 0; i < shape->numlines; i++)
+      if (outerlist[i] == MS_TRUE)
+        numouters++;
+
+    if ((geometry_simple_index != -1 && numouters == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a Polygon(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        if (outerlist[i] == MS_FALSE)
+          break; /* skip non-outer rings, each outer ring is a new polygon */
+
+        /* get a list of inner rings for this polygon */
+        innerlist = msGetInnerList(shape, i, outerlist);
+
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
+
+        /* Polygon */
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s<gml:Polygon srsName=\"%s\">\n", tab,
+                       srsname_encoded);
+        else
+          msIO_fprintf(stream, "%s<gml:Polygon>\n", tab);
+
+        msIO_fprintf(stream, "%s  <gml:outerBoundaryIs>\n", tab);
+        msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
+
+        msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+        msIO_fprintf(stream, "</gml:coordinates>\n");
+
+        msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
+        msIO_fprintf(stream, "%s  </gml:outerBoundaryIs>\n", tab);
+
+        for (k = 0; k < shape->numlines;
+             k++) { /* now step through all the inner rings */
+          if (innerlist[k] == MS_TRUE) {
+            msIO_fprintf(stream, "%s  <gml:innerBoundaryIs>\n", tab);
+            msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
+
+            msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
+            for (j = 0; j < shape->line[k].numpoints; j++) {
+              if (nSRSDimension == 3)
+                msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y, geometry_precision,
+                             shape->line[k].point[j].z);
+              else
+                /* fall-through */
+                msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y);
+            }
+            msIO_fprintf(stream, "</gml:coordinates>\n");
+
+            msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
+            msIO_fprintf(stream, "%s  </gml:innerBoundaryIs>\n", tab);
+          }
+        }
+
+        msIO_fprintf(stream, "%s</gml:Polygon>\n", tab);
+        free(innerlist);
+
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+      }
+      free(outerlist);
+      outerlist = NULL;
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiPolygon */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiPolygon */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s<gml:MultiPolygon srsName=\"%s\">\n", tab,
+                     srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s<gml:MultiPolygon>\n", tab);
+
+      for (i = 0; i < shape->numlines; i++) { /* step through the outer rings */
+        if (outerlist[i] == MS_TRUE) {
+          innerlist = msGetInnerList(shape, i, outerlist);
+
+          msIO_fprintf(stream, "%s<gml:polygonMember>\n", tab);
+          msIO_fprintf(stream, "%s  <gml:Polygon>\n", tab);
+
+          msIO_fprintf(stream, "%s    <gml:outerBoundaryIs>\n", tab);
+          msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
+
+          msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
+          for (j = 0; j < shape->line[i].numpoints; j++) {
+            if (nSRSDimension == 3)
+              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y, geometry_precision,
+                           shape->line[i].point[j].z);
+            else
+              /* fall-through */
+              msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y);
+          }
+          msIO_fprintf(stream, "</gml:coordinates>\n");
+
+          msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+          msIO_fprintf(stream, "%s    </gml:outerBoundaryIs>\n", tab);
+
+          for (k = 0; k < shape->numlines;
+               k++) { /* now step through all the inner rings */
+            if (innerlist[k] == MS_TRUE) {
+              msIO_fprintf(stream, "%s    <gml:innerBoundaryIs>\n", tab);
+              msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
+
+              msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
+              for (j = 0; j < shape->line[k].numpoints; j++) {
+                if (nSRSDimension == 3)
+                  msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y, geometry_precision,
+                               shape->line[k].point[j].z);
+                else
+                  /* fall-through */
+                  msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y);
+              }
+              msIO_fprintf(stream, "</gml:coordinates>\n");
+
+              msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+              msIO_fprintf(stream, "%s    </gml:innerBoundaryIs>\n", tab);
+            }
+          }
+
+          msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
+          msIO_fprintf(stream, "%s</gml:polygonMember>\n", tab);
+
+          free(innerlist);
+        }
+      }
+      msIO_fprintf(stream, "%s</gml:MultiPolygon>\n", tab);
+
+      free(outerlist);
+      outerlist = NULL;
+
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "polygon/multipolygon geometry defined. -->\n");
+    }
+
+    break;
+  default:
+    break;
+  }
+
+  /* clean-up */
+  msFree(srsname_encoded);
+  msFree(outerlist);
+
+  return (MS_SUCCESS);
+}
+
+static char *gmlCreateGeomId(OWSGMLVersion nGMLVersion, const char *pszFID,
+                             int *p_id) {
+  char *pszGMLId;
+  if (nGMLVersion == OWS_GML32) {
+    pszGMLId =
+        (char *)msSmallMalloc(strlen(pszFID) + 1 + strlen(" gml:id=\"\"") + 10);
+    sprintf(pszGMLId, " gml:id=\"%s.%d\"", pszFID, *p_id);
+    (*p_id)++;
+  } else
+    pszGMLId = msStrdup("");
+  return pszGMLId;
+}
+
+/* GML 3.1 or GML 3.2 (MapServer limits GML encoding to the level 0 profile) */
+static int gmlWriteGeometry_GML3(FILE *stream, gmlGeometryListObj *geometryList,
+                                 shapeObj *shape, const char *srsname,
+                                 const char *namespace, const char *tab,
+                                 const char *pszFID, OWSGMLVersion nGMLVersion,
+                                 int nSRSDimension, int geometry_precision) {
+  int i, j, k, id = 1;
+  int *innerlist, *outerlist = NULL, numouters;
+  char *srsname_encoded = NULL;
+  char *pszGMLId;
+
+  int geometry_aggregate_index, geometry_simple_index;
+  char *geometry_aggregate_name = NULL, *geometry_simple_name = NULL;
+
+  if (!stream)
+    return (MS_FAILURE);
+  if (!shape)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
+  if (!geometryList)
+    return (MS_FAILURE);
+
+  if (shape->numlines <= 0)
+    return (MS_SUCCESS); /* empty shape, nothing to output */
+
+  if (srsname)
+    srsname_encoded = msEncodeHTMLEntities(srsname);
+
+  /* feature geometry */
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1)) { /* write a Point(s) */
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          gmlStartGeometryContainer(stream, geometry_simple_name, namespace,
+                                    tab);
+
+          /* Point */
+          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+          if (srsname_encoded)
+            msIO_fprintf(stream, "%s  <gml:Point%s srsName=\"%s\">\n", tab,
+                         pszGMLId, srsname_encoded);
+          else
+            msIO_fprintf(stream, "%s  <gml:Point%s>\n", tab, pszGMLId);
+
+          if (nSRSDimension == 3)
+            msIO_fprintf(
+                stream,
+                "%s    <gml:pos srsDimension=\"3\">%.*f %.*f %.*f</gml:pos>\n",
+                tab, geometry_precision, shape->line[i].point[j].x,
+                geometry_precision, shape->line[i].point[j].y,
+                geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%s    <gml:pos>%.*f %.*f</gml:pos>\n", tab,
+                         geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y);
+
+          msIO_fprintf(stream, "%s  </gml:Point>\n", tab);
+
+          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+          msFree(pszGMLId);
+        }
+      }
+    } else if ((geometry_aggregate_index != -1) ||
+               (geometryList->numgeometries == 0)) { /* write a MultiPoint */
+      pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiPoint */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s  <gml:MultiPoint%s srsName=\"%s\">\n", tab,
+                     pszGMLId, srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s  <gml:MultiPoint%s>\n", tab, pszGMLId);
+
+      msFree(pszGMLId);
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          msIO_fprintf(stream, "%s    <gml:pointMember>\n", tab);
+          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+          msIO_fprintf(stream, "%s      <gml:Point%s>\n", tab, pszGMLId);
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream,
+                         "%s        <gml:pos srsDimension=\"3\">%.*f %.*f "
+                         "%.*f</gml:pos>\n",
+                         tab, geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y,
+                         geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%s        <gml:pos>%.*f %.*f</gml:pos>\n",
+                         tab, geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y);
+          msIO_fprintf(stream, "%s      </gml:Point>\n", tab);
+          msFree(pszGMLId);
+          msIO_fprintf(stream, "%s    </gml:pointMember>\n", tab);
+        }
+      }
+
+      msIO_fprintf(stream, "%s  </gml:MultiPoint>\n", tab);
+
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "point/multipoint geometry defined. -->\n");
+    }
+
+    break;
+  case (MS_SHAPE_LINE):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a LineStrings(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
+
+        /* LineString (should be Curve?) */
+        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s  <gml:LineString%s srsName=\"%s\">\n", tab,
+                       pszGMLId, srsname_encoded);
+        else
+          msIO_fprintf(stream, "%s  <gml:LineString%s>\n", tab, pszGMLId);
+        msFree(pszGMLId);
+
+        msIO_fprintf(stream, "%s    <gml:posList srsDimension=\"%d\">", tab,
+                     nSRSDimension);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+        msIO_fprintf(stream, "</gml:posList>\n");
+
+        msIO_fprintf(stream, "%s  </gml:LineString>\n", tab);
+
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+      }
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiCurve */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiCurve */
+      pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s  <gml:MultiCurve%s srsName=\"%s\">\n", tab,
+                     pszGMLId, srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s  <gml:MultiCurve%s>\n", tab, pszGMLId);
+      msFree(pszGMLId);
+
+      for (i = 0; i < shape->numlines; i++) {
+        msIO_fprintf(stream, "%s    <gml:curveMember>\n", tab);
+        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+        msIO_fprintf(stream, "%s      <gml:LineString%s>\n", tab,
+                     pszGMLId); /* no srsname at this point */
+        msFree(pszGMLId);
+
+        msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab,
+                     nSRSDimension);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+
+        msIO_fprintf(stream, "</gml:posList>\n");
+        msIO_fprintf(stream, "%s      </gml:LineString>\n", tab);
+        msIO_fprintf(stream, "%s    </gml:curveMember>\n", tab);
+      }
+
+      msIO_fprintf(stream, "%s  </gml:MultiCurve>\n", tab);
+
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "line/multiline geometry defined. -->\n");
+    }
+
+    break;
+  case (
+      MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
+    geometry_aggregate_index =
+        msGMLGeometryLookup(geometryList, "multipolygon");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    /* get a list of outter rings for this polygon */
+    outerlist = msGetOuterList(shape);
+
+    numouters = 0;
+    for (i = 0; i < shape->numlines; i++)
+      if (outerlist[i] == MS_TRUE)
+        numouters++;
+
+    if ((geometry_simple_index != -1 && numouters == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a Polygon(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        if (outerlist[i] == MS_FALSE)
+          break; /* skip non-outer rings, each outer ring is a new polygon */
+
+        /* get a list of inner rings for this polygon */
+        innerlist = msGetInnerList(shape, i, outerlist);
+
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
+
+        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+
+        /* Polygon (should be Surface?) */
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s  <gml:Polygon%s srsName=\"%s\">\n", tab,
+                       pszGMLId, srsname_encoded);
+        else
+          msIO_fprintf(stream, "%s  <gml:Polygon%s>\n", tab, pszGMLId);
+        msFree(pszGMLId);
+
+        msIO_fprintf(stream, "%s    <gml:exterior>\n", tab);
+        msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
+
+        msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab,
+                     nSRSDimension);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+
+        msIO_fprintf(stream, "</gml:posList>\n");
+
+        msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+        msIO_fprintf(stream, "%s    </gml:exterior>\n", tab);
+
+        for (k = 0; k < shape->numlines;
+             k++) { /* now step through all the inner rings */
+          if (innerlist[k] == MS_TRUE) {
+            msIO_fprintf(stream, "%s    <gml:interior>\n", tab);
+            msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
+
+            msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">",
+                         tab, nSRSDimension);
+            for (j = 0; j < shape->line[k].numpoints; j++) {
+              if (nSRSDimension == 3)
+                msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y, geometry_precision,
+                             shape->line[k].point[j].z);
+              else
+                /* fall-through */
+                msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y);
+            }
+
+            msIO_fprintf(stream, "</gml:posList>\n");
+
+            msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+            msIO_fprintf(stream, "%s    </gml:interior>\n", tab);
+          }
+        }
+
+        msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
+        free(innerlist);
+
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+      }
+      free(outerlist);
+      outerlist = NULL;
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiSurface */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+
+      /* MultiSurface */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s  <gml:MultiSurface%s srsName=\"%s\">\n", tab,
+                     pszGMLId, srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s  <gml:MultiSurface%s>\n", tab, pszGMLId);
+      msFree(pszGMLId);
+
+      for (i = 0; i < shape->numlines; i++) { /* step through the outer rings */
+        if (outerlist[i] == MS_TRUE) {
+          msIO_fprintf(stream, "%s    <gml:surfaceMember>\n", tab);
+
+          /* get a list of inner rings for this polygon */
+          innerlist = msGetInnerList(shape, i, outerlist);
+
+          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+
+          msIO_fprintf(stream, "%s      <gml:Polygon%s>\n", tab, pszGMLId);
+          msFree(pszGMLId);
+
+          msIO_fprintf(stream, "%s        <gml:exterior>\n", tab);
+          msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
+
+          msIO_fprintf(stream,
+                       "%s            <gml:posList srsDimension=\"%d\">", tab,
+                       nSRSDimension);
+          for (j = 0; j < shape->line[i].numpoints; j++) {
+            if (nSRSDimension == 3)
+              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y, geometry_precision,
+                           shape->line[i].point[j].z);
+            else
+              /* fall-through */
+              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y);
+          }
+
+          msIO_fprintf(stream, "</gml:posList>\n");
+
+          msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
+          msIO_fprintf(stream, "%s        </gml:exterior>\n", tab);
+
+          for (k = 0; k < shape->numlines;
+               k++) { /* now step through all the inner rings */
+            if (innerlist[k] == MS_TRUE) {
+              msIO_fprintf(stream, "%s        <gml:interior>\n", tab);
+              msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
+
+              msIO_fprintf(stream,
+                           "%s            <gml:posList srsDimension=\"%d\">",
+                           tab, nSRSDimension);
+              for (j = 0; j < shape->line[k].numpoints; j++) {
+                if (nSRSDimension == 3)
+                  msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y, geometry_precision,
+                               shape->line[k].point[j].z);
+                else
+                  /* fall-through */
+                  msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y);
+              }
+              msIO_fprintf(stream, "</gml:posList>\n");
+
+              msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
+              msIO_fprintf(stream, "%s        </gml:interior>\n", tab);
+            }
+          }
+
+          msIO_fprintf(stream, "%s      </gml:Polygon>\n", tab);
+
+          free(innerlist);
+          msIO_fprintf(stream, "%s    </gml:surfaceMember>\n", tab);
+        }
+      }
+      msIO_fprintf(stream, "%s  </gml:MultiSurface>\n", tab);
+
+      free(outerlist);
+      outerlist = NULL;
+
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "polygon/multipolygon geometry defined. -->\n");
+    }
+
+    break;
+  default:
+    break;
+  }
+
+  /* clean-up */
+  msFree(outerlist);
+  msFree(srsname_encoded);
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Wrappers for the format specific encoding functions.
+*/
+static int gmlWriteBounds(FILE *stream, OWSGMLVersion format, rectObj *rect,
+                          const char *srsname, const char *tab,
+                          const char *pszTopPrefix) {
+  switch (format) {
+  case (OWS_GML2):
+    return gmlWriteBounds_GML2(stream, rect, srsname, tab, pszTopPrefix);
+    break;
+  case (OWS_GML3):
+  case (OWS_GML32):
+    return gmlWriteBounds_GML3(stream, rect, srsname, tab, pszTopPrefix);
+    break;
+  default:
+    msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteBounds()");
+  }
+
+  return (MS_FAILURE);
+}
+
+static int gmlWriteGeometry(FILE *stream, gmlGeometryListObj *geometryList,
+                            OWSGMLVersion format, shapeObj *shape,
+                            const char *srsname, const char *namespace,
+                            const char *tab, const char *pszFID,
+                            int nSRSDimension, int geometry_precision) {
+  switch (format) {
+  case (OWS_GML2):
+    return gmlWriteGeometry_GML2(stream, geometryList, shape, srsname,
+                                 namespace, tab, nSRSDimension,
+                                 geometry_precision);
+    break;
+  case (OWS_GML3):
+  case (OWS_GML32):
+    return gmlWriteGeometry_GML3(stream, geometryList, shape, srsname,
+                                 namespace, tab, pszFID, format, nSRSDimension,
+                                 geometry_precision);
+    break;
+  default:
+    msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteGeometry()");
+  }
+
+  return (MS_FAILURE);
+}
+
+/*
+** GML specific metadata handling functions.
+*/
+
+int msItemInGroups(const char *name, gmlGroupListObj *groupList) {
+  int i, j;
+  gmlGroupObj *group;
+
+  if (!groupList)
+    return MS_FALSE; /* no groups */
+
+  for (i = 0; i < groupList->numgroups; i++) {
+    group = &(groupList->groups[i]);
+    for (j = 0; j < group->numitems; j++) {
+      if (strcasecmp(name, group->items[j]) == 0)
+        return MS_TRUE;
+    }
+  }
+
+  return MS_FALSE;
+}
+
+static int msGMLGeometryLookup(gmlGeometryListObj *geometryList,
+                               const char *type) {
+  int i;
+
+  if (!geometryList || !type)
+    return -1; /* nothing to look for */
+
+  for (i = 0; i < geometryList->numgeometries; i++)
+    if (geometryList->geometries[i].type &&
+        (strcasecmp(geometryList->geometries[i].type, type) == 0))
+      return i;
+
+  if (geometryList->numgeometries == 1 &&
+      geometryList->geometries[0].type == NULL)
+    return 0;
+
+  return -1; /* not found */
+}
+
+gmlGeometryListObj *msGMLGetGeometries(layerObj *layer,
+                                       const char *metadata_namespaces,
+                                       int bWithDefaultGeom) {
+  int i;
+
+  const char *value = NULL;
+  char tag[64];
+
+  char **names = NULL;
+  int numnames = 0;
+
+  gmlGeometryListObj *geometryList = NULL;
+  gmlGeometryObj *geometry = NULL;
+
+  /* allocate memory and initialize the item collection */
+  geometryList = (gmlGeometryListObj *)malloc(sizeof(gmlGeometryListObj));
+  MS_CHECK_ALLOC(geometryList, sizeof(gmlGeometryListObj), NULL);
+  geometryList->geometries = NULL;
+  geometryList->numgeometries = 0;
+
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "geometries")) != NULL) {
+    names = msStringSplit(value, ',', &numnames);
+
+    /* allocation an array of gmlGeometryObj's */
+    geometryList->numgeometries = numnames;
+    geometryList->geometries = (gmlGeometryObj *)malloc(
+        sizeof(gmlGeometryObj) * geometryList->numgeometries);
+    if (geometryList->geometries == NULL) {
+      msSetError(
+          MS_MEMERR, "Out of memory allocating %u bytes.\n",
+          "msGMLGetGeometries()",
+          (unsigned int)(sizeof(gmlGeometryObj) * geometryList->numgeometries));
+      free(geometryList);
+      return NULL;
+    }
+
+    for (i = 0; i < geometryList->numgeometries; i++) {
+      geometry = &(geometryList->geometries[i]);
+
+      geometry->name = msStrdup(names[i]); /* initialize a few things */
+      geometry->type = NULL;
+      geometry->occurmin = 0;
+      geometry->occurmax = 1;
+
+      snprintf(tag, 64, "%s_type", names[i]);
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+        geometry->type = msStrdup(value); /* TODO: validate input value */
+
+      snprintf(tag, 64, "%s_occurances", names[i]);
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL) {
+        char **occur;
+        int numoccur;
+
+        occur = msStringSplit(value, ',', &numoccur);
+        if (numoccur == 2) { /* continue (TODO: throw an error if != 2) */
+          geometry->occurmin = atof(occur[0]);
+          if (strcasecmp(occur[1], "UNBOUNDED") == 0)
+            geometry->occurmax = OWS_GML_OCCUR_UNBOUNDED;
+          else
+            geometry->occurmax = atof(occur[1]);
+        }
+        msFreeCharArray(occur, numoccur);
+      }
+    }
+
+    msFreeCharArray(names, numnames);
+  } else if (bWithDefaultGeom) {
+    geometryList->numgeometries = 1;
+    geometryList->geometries =
+        (gmlGeometryObj *)calloc(1, sizeof(gmlGeometryObj));
+    geometryList->geometries[0].name = msStrdup(OWS_GML_DEFAULT_GEOMETRY_NAME);
+    geometryList->geometries[0].type = NULL;
+    geometryList->geometries[0].occurmin = 0;
+    geometryList->geometries[0].occurmax = 1;
+  }
+
+  return geometryList;
+}
+
+void msGMLFreeGeometries(gmlGeometryListObj *geometryList) {
+  int i;
+
+  if (!geometryList)
+    return;
+
+  for (i = 0; i < geometryList->numgeometries; i++) {
+    msFree(geometryList->geometries[i].name);
+    msFree(geometryList->geometries[i].type);
+  }
+  free(geometryList->geometries);
+
+  free(geometryList);
+}
+
+static void msGMLWriteItem(FILE *stream, gmlItemObj *item, const char *value,
+                           const char *namespace, const char *tab,
+                           OWSGMLVersion outputformat, const char *pszFID) {
+  char *encoded_value = NULL, *tag_name;
+  int add_namespace = MS_TRUE;
+  char gmlid[256];
+  gmlid[0] = 0;
+
+  if (!stream || !item)
+    return;
+  if (!item->visible)
+    return;
+
+  if (!namespace)
+    add_namespace = MS_FALSE;
+
+  if (item->alias)
+    tag_name = item->alias;
+  else
+    tag_name = item->name;
+  if (strchr(tag_name, ':') != NULL)
+    add_namespace = MS_FALSE;
+
+  if (item->type &&
+      (EQUAL(item->type, "Date") || EQUAL(item->type, "DateTime") ||
+       EQUAL(item->type, "Time"))) {
+    struct tm tm;
+    if (msParseTime(value, &tm) == MS_TRUE) {
+      const char *pszStartTag = "";
+      const char *pszEndTag = "";
+
+      encoded_value = (char *)msSmallMalloc(256);
+      if (outputformat == OWS_GML32) {
+        if (pszFID != NULL)
+          snprintf(gmlid, 256, " gml:id=\"%s.%s\"", pszFID, tag_name);
+        pszStartTag = "<gml:timePosition>";
+        pszEndTag = "</gml:timePosition>";
+      }
+
+      if (EQUAL(item->type, "Date"))
+        snprintf(encoded_value, 256, "%s%04d-%02d-%02d%s", pszStartTag,
+                 tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, pszEndTag);
+      else if (EQUAL(item->type, "Time"))
+        snprintf(encoded_value, 256, "%s%02d:%02d:%02dZ%s", pszStartTag,
+                 tm.tm_hour, tm.tm_min, tm.tm_sec, pszEndTag);
+      else {
+        // Detected date time already formatted as YYYY-MM-DDTHH:mm:SS+ab:cd
+        // because msParseTime() can't handle time zones.
+        if (strlen(value) ==
+                4 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 &&
+            value[4] == '-' && value[7] == '-' && value[10] == 'T' &&
+            value[13] == ':' && value[16] == ':' &&
+            (value[19] == '+' || value[19] == '-') && value[22] == ':') {
+          snprintf(encoded_value, 256, "%s%s%s", pszStartTag, value, pszEndTag);
+        } else {
+          snprintf(encoded_value, 256, "%s%04d-%02d-%02dT%02d:%02d:%02dZ%s",
+                   pszStartTag, tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
+                   tm.tm_hour, tm.tm_min, tm.tm_sec, pszEndTag);
+        }
+      }
+    }
+  }
+
+  if (encoded_value == NULL) {
+    if (item->encode == MS_TRUE)
+      encoded_value = msEncodeHTMLEntities(value);
+    else
+      encoded_value = msStrdup(value);
+  }
+
+  if (!item->template) { /* build the tag from pieces */
+
+    if (add_namespace == MS_TRUE && msIsXMLTagValid(tag_name) == MS_FALSE)
+      msIO_fprintf(stream,
+                   "<!-- WARNING: The value '%s' is not valid in a XML tag "
+                   "context. -->\n",
+                   tag_name);
+
+    if (add_namespace == MS_TRUE)
+      msIO_fprintf(stream, "%s<%s:%s%s>%s</%s:%s>\n", tab, namespace, tag_name,
+                   gmlid, encoded_value, namespace, tag_name);
+    else
+      msIO_fprintf(stream, "%s<%s%s>%s</%s>\n", tab, tag_name, gmlid,
+                   encoded_value, tag_name);
+  } else {
+    char *tag = NULL;
+
+    tag = msStrdup(item->template);
+    tag = msReplaceSubstring(tag, "$value", encoded_value);
+    if (namespace)
+      tag = msReplaceSubstring(tag, "$namespace", namespace);
+    msIO_fprintf(stream, "%s%s\n", tab, tag);
+    free(tag);
+  }
+
+  free(encoded_value);
+
+  return;
+}
+
+gmlNamespaceListObj *msGMLGetNamespaces(webObj *web,
+                                        const char *metadata_namespaces) {
+  int i;
+  const char *value = NULL;
+  char tag[64];
+
+  char **prefixes = NULL;
+  int numprefixes = 0;
+
+  gmlNamespaceListObj *namespaceList = NULL;
+  gmlNamespaceObj *namespace = NULL;
+
+  /* allocate the collection */
+  namespaceList = (gmlNamespaceListObj *)malloc(sizeof(gmlNamespaceListObj));
+  MS_CHECK_ALLOC(namespaceList, sizeof(gmlNamespaceListObj), NULL);
+  namespaceList->namespaces = NULL;
+  namespaceList->numnamespaces = 0;
+
+  /* list of namespaces (TODO: make this automatic by parsing metadata) */
+  if ((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces,
+                                   "external_namespace_prefixes")) != NULL) {
+    prefixes = msStringSplit(value, ',', &numprefixes);
+
+    /* allocation an array of gmlNamespaceObj's */
+    namespaceList->numnamespaces = numprefixes;
+    namespaceList->namespaces = (gmlNamespaceObj *)malloc(
+        sizeof(gmlNamespaceObj) * namespaceList->numnamespaces);
+    if (namespaceList->namespaces == NULL) {
+      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n",
+                 "msGMLGetNamespaces()",
+                 (unsigned int)(sizeof(gmlNamespaceObj) *
+                                namespaceList->numnamespaces));
+      free(namespaceList);
+      return NULL;
+    }
+
+    for (i = 0; i < namespaceList->numnamespaces; i++) {
+      namespace = &(namespaceList->namespaces[i]);
+
+      namespace->prefix = msStrdup(prefixes[i]); /* initialize a few things */
+      namespace->uri = NULL;
+      namespace->schemalocation = NULL;
+
+      snprintf(tag, 64, "%s_uri", namespace->prefix);
+      if ((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+      namespace->uri = msStrdup(value);
+
+      snprintf(tag, 64, "%s_schema_location", namespace->prefix);
+      if ((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+      namespace->schemalocation = msStrdup(value);
+    }
+
+    msFreeCharArray(prefixes, numprefixes);
+  }
+
+  return namespaceList;
+}
+
+void msGMLFreeNamespaces(gmlNamespaceListObj *namespaceList) {
+  int i;
+
+  if (!namespaceList)
+    return;
+
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    msFree(namespaceList->namespaces[i].prefix);
+    msFree(namespaceList->namespaces[i].uri);
+    msFree(namespaceList->namespaces[i].schemalocation);
+  }
+
+  free(namespaceList);
+}
+
+gmlConstantListObj *msGMLGetConstants(layerObj *layer,
+                                      const char *metadata_namespaces) {
+  int i;
+  const char *value = NULL;
+  char tag[64];
+
+  char **names = NULL;
+  int numnames = 0;
+
+  gmlConstantListObj *constantList = NULL;
+  gmlConstantObj *constant = NULL;
+
+  /* allocate the collection */
+  constantList = (gmlConstantListObj *)malloc(sizeof(gmlConstantListObj));
+  MS_CHECK_ALLOC(constantList, sizeof(gmlConstantListObj), NULL);
+  constantList->constants = NULL;
+  constantList->numconstants = 0;
+
+  /* list of constants (TODO: make this automatic by parsing metadata) */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "constants")) != NULL) {
+    names = msStringSplit(value, ',', &numnames);
+
+    /* allocation an array of gmlConstantObj's */
+    constantList->numconstants = numnames;
+    constantList->constants = (gmlConstantObj *)malloc(
+        sizeof(gmlConstantObj) * constantList->numconstants);
+    if (constantList->constants == NULL) {
+      msSetError(
+          MS_MEMERR, "Out of memory allocating %u bytes.\n",
+          "msGMLGetConstants()",
+          (unsigned int)(sizeof(gmlConstantObj) * constantList->numconstants));
+      free(constantList);
+      return NULL;
+    }
+
+    for (i = 0; i < constantList->numconstants; i++) {
+      constant = &(constantList->constants[i]);
+
+      constant->name = msStrdup(names[i]); /* initialize a few things */
+      constant->value = NULL;
+      constant->type = NULL;
+
+      snprintf(tag, 64, "%s_value", constant->name);
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+        constant->value = msStrdup(value);
+
+      snprintf(tag, 64, "%s_type", constant->name);
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+        constant->type = msStrdup(value);
+    }
+
+    msFreeCharArray(names, numnames);
+  }
+
+  return constantList;
+}
+
+void msGMLFreeConstants(gmlConstantListObj *constantList) {
+  int i;
+
+  if (!constantList)
+    return;
+
+  for (i = 0; i < constantList->numconstants; i++) {
+    msFree(constantList->constants[i].name);
+    msFree(constantList->constants[i].value);
+    msFree(constantList->constants[i].type);
+  }
+
+  free(constantList);
+}
+
+static void msGMLWriteConstant(FILE *stream, gmlConstantObj *constant,
+                               const char *namespace, const char *tab) {
+  int add_namespace = MS_TRUE;
+
+  if (!stream || !constant)
+    return;
+  if (!constant->value)
+    return;
+
+  if (!namespace)
+    add_namespace = MS_FALSE;
+  if (strchr(constant->name, ':') != NULL)
+    add_namespace = MS_FALSE;
+
+  if (add_namespace == MS_TRUE && msIsXMLTagValid(constant->name) == MS_FALSE)
+    msIO_fprintf(
+        stream,
+        "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n",
+        constant->name);
+
+  if (add_namespace == MS_TRUE)
+    msIO_fprintf(stream, "%s<%s:%s>%s</%s:%s>\n", tab, namespace,
+                 constant->name, constant->value, namespace, constant->name);
+  else
+    msIO_fprintf(stream, "%s<%s>%s</%s>\n", tab, constant->name,
+                 constant->value, constant->name);
+
+  return;
+}
+
+static void msGMLWriteGroup(FILE *stream, gmlGroupObj *group, shapeObj *shape,
+                            gmlItemListObj *itemList,
+                            gmlConstantListObj *constantList,
+                            const char *namespace, const char *tab,
+                            OWSGMLVersion outputformat, const char *pszFID) {
+  int i, j;
+  int add_namespace = MS_TRUE;
+  char *itemtab;
+
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
+
+  if (!stream || !group)
+    return;
+
+  /* setup the item/constant tab */
+  itemtab = (char *)msSmallMalloc(sizeof(char) * strlen(tab) + 3);
+
+  sprintf(itemtab, "%s  ", tab);
+
+  if (!namespace || strchr(group->name, ':') != NULL)
+    add_namespace = MS_FALSE;
+
+  /* start the group */
+  if (add_namespace == MS_TRUE)
+    msIO_fprintf(stream, "%s<%s:%s>\n", tab, namespace, group->name);
+  else
+    msIO_fprintf(stream, "%s<%s>\n", tab, group->name);
+
+  /* now the items/constants in the group */
+  for (i = 0; i < group->numitems; i++) {
+    for (j = 0; j < constantList->numconstants; j++) {
+      constant = &(constantList->constants[j]);
+      if (strcasecmp(constant->name, group->items[i]) == 0) {
+        msGMLWriteConstant(stream, constant, namespace, itemtab);
+        break;
+      }
+    }
+    if (j != constantList->numconstants)
+      continue; /* found this one */
+    for (j = 0; j < itemList->numitems; j++) {
+      item = &(itemList->items[j]);
+      if (strcasecmp(item->name, group->items[i]) == 0) {
+        /* the number of items matches the number of values exactly */
+        msGMLWriteItem(stream, item, shape->values[j], namespace, itemtab,
+                       outputformat, pszFID);
+        break;
+      }
+    }
+  }
+
+  /* end the group */
+  if (add_namespace == MS_TRUE)
+    msIO_fprintf(stream, "%s</%s:%s>\n", tab, namespace, group->name);
+  else
+    msIO_fprintf(stream, "%s</%s>\n", tab, group->name);
+
+  msFree(itemtab);
+
+  return;
+}
+#endif
+
+gmlGroupListObj *msGMLGetGroups(layerObj *layer,
+                                const char *metadata_namespaces) {
+  int i;
+  const char *value = NULL;
+  char tag[64];
+
+  char **names = NULL;
+  int numnames = 0;
+
+  gmlGroupListObj *groupList = NULL;
+  gmlGroupObj *group = NULL;
+
+  /* allocate the collection */
+  groupList = (gmlGroupListObj *)malloc(sizeof(gmlGroupListObj));
+  MS_CHECK_ALLOC(groupList, sizeof(gmlGroupListObj), NULL);
+  groupList->groups = NULL;
+  groupList->numgroups = 0;
+
+  /* list of groups (TODO: make this automatic by parsing metadata) */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "groups")) != NULL &&
+      value[0] != '\0') {
+    names = msStringSplit(value, ',', &numnames);
+
+    /* allocation an array of gmlGroupObj's */
+    groupList->numgroups = numnames;
+    groupList->groups =
+        (gmlGroupObj *)malloc(sizeof(gmlGroupObj) * groupList->numgroups);
+    if (groupList->groups == NULL) {
+      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n",
+                 "msGMLGetGroups()",
+                 (unsigned int)(sizeof(gmlGroupObj) * groupList->numgroups));
+      free(groupList);
+      return NULL;
+    }
+
+    for (i = 0; i < groupList->numgroups; i++) {
+      group = &(groupList->groups[i]);
+
+      group->name = msStrdup(names[i]); /* initialize a few things */
+      group->items = NULL;
+      group->numitems = 0;
+      group->type = NULL;
+
+      snprintf(tag, 64, "%s_group", group->name);
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+        group->items = msStringSplit(value, ',', &group->numitems);
+
+      snprintf(tag, 64, "%s_type", group->name);
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+        group->type = msStrdup(value);
+    }
+
+    msFreeCharArray(names, numnames);
+  }
+
+  return groupList;
+}
+
+void msGMLFreeGroups(gmlGroupListObj *groupList) {
+  int i;
+
+  if (!groupList)
+    return;
+
+  for (i = 0; i < groupList->numgroups; i++) {
+    msFree(groupList->groups[i].name);
+    msFreeCharArray(groupList->groups[i].items, groupList->groups[i].numitems);
+    msFree(groupList->groups[i].type);
+  }
+  msFree(groupList->groups);
+
+  free(groupList);
+}
+
+/* Dump GML query results for WMS GetFeatureInfo */
+int msGMLWriteQuery(mapObj *map, char *filename, const char *namespaces) {
+#if defined(USE_WMS_SVR)
+  int status;
+  int i, j, k;
+  layerObj *lp = NULL;
+  shapeObj shape;
+  FILE *stream_to_free = NULL;
+  FILE *stream = stdout; /* defaults to stdout */
+  char szPath[MS_MAXPATHLEN];
+  char *value;
+  char *pszMapSRS = NULL;
+
+  gmlGroupListObj *groupList = NULL;
+  gmlItemListObj *itemList = NULL;
+  gmlConstantListObj *constantList = NULL;
+  gmlGeometryListObj *geometryList = NULL;
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
+
+  msInitShape(&shape);
+
+  if (filename &&
+      strlen(filename) > 0) { /* deal with the filename if present */
+    stream_to_free = fopen(msBuildPath(szPath, map->mappath, filename), "w");
+    if (!stream_to_free) {
+      msSetError(MS_IOERR, "(%s)", "msGMLWriteQuery()", filename);
+      return (MS_FAILURE);
+    }
+    stream = stream_to_free;
+  }
+
+  msIO_fprintf(stream, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");
+  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces,
+                             "rootname", OWS_NOERR, "<%s ", "msGMLOutput");
+
+  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "uri",
+                           OWS_NOERR, "xmlns=\"%s\"", NULL);
+  msIO_fprintf(stream, "\n\t xmlns:gml=\"http://www.opengis.net/gml\"");
+  msIO_fprintf(stream, "\n\t xmlns:xlink=\"http://www.w3.org/1999/xlink\"");
+  msIO_fprintf(stream,
+               "\n\t xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
+  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "schema",
+                           OWS_NOERR, "\n\t xsi:schemaLocation=\"%s\"", NULL);
+  msIO_fprintf(stream, ">\n");
+
+  /* a schema *should* be required */
+  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                           "description", OWS_NOERR,
+                           "\t<gml:description>%s</gml:description>\n", NULL);
+
+  /* Look up map SRS. We need an EPSG code for GML, if not then we get null and
+   * we'll fall back on the layer's SRS */
+  msOWSGetEPSGProj(&(map->projection), NULL, namespaces, MS_TRUE, &pszMapSRS);
+
+  /* step through the layers looking for query results */
+  for (i = 0; i < map->numlayers; i++) {
+    char *pszOutputSRS = NULL;
+    int nSRSDimension = 2;
+    const char *geomtype;
+    lp = (GET_LAYER(map, map->layerorder[i]));
+
+    if (lp->resultcache &&
+        lp->resultcache->numresults > 0) { /* found results */
+
+      reprojectionObj *reprojector = NULL;
+
+      /* Determine output SRS, if map has none, then try using layer's native
+       * SRS */
+      if ((pszOutputSRS = pszMapSRS) == NULL) {
+        msOWSGetEPSGProj(&(lp->projection), NULL, namespaces, MS_TRUE,
+                         &pszOutputSRS);
+        if (pszOutputSRS == NULL) {
+          msSetError(
+              MS_WMSERR,
+              "No valid EPSG code in map or layer projection for GML output",
+              "msGMLWriteQuery()");
+          continue; /* No EPSG code, cannot output this layer */
+        }
+      }
+
+      /* start this collection (layer) */
+      /* if no layer name provided fall back on the layer name + "_layer" */
+      value = (char *)msSmallMalloc(strlen(lp->name) + 7);
+      sprintf(value, "%s_layer", lp->name);
+      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                 "layername", OWS_NOERR, "\t<%s>\n", value);
+      msFree(value);
+
+      value = (char *)msOWSLookupMetadata(&(lp->metadata), "OM", "title");
+      if (value) {
+        msOWSPrintEncodeMetadata(stream, &(lp->metadata), namespaces, "title",
+                                 OWS_NOERR, "\t<gml:name>%s</gml:name>\n",
+                                 value);
+      }
+
+      geomtype = msOWSLookupMetadata(&(lp->metadata), "OFG", "geomtype");
+      if (geomtype != NULL && (strstr(geomtype, "25d") != NULL ||
+                               strstr(geomtype, "25D") != NULL)) {
+        nSRSDimension = 3;
+      }
+
+      /* populate item and group metadata structures */
+      itemList = msGMLGetItems(lp, namespaces);
+      constantList = msGMLGetConstants(lp, namespaces);
+      groupList = msGMLGetGroups(lp, namespaces);
+      geometryList = msGMLGetGeometries(lp, namespaces, MS_FALSE);
+      if (itemList == NULL || constantList == NULL || groupList == NULL ||
+          geometryList == NULL) {
+        msSetError(MS_MISCERR,
+                   "Unable to populate item and group metadata structures",
+                   "msGMLWriteQuery()");
+        if (stream_to_free != NULL)
+          fclose(stream_to_free);
+        return MS_FAILURE;
+      }
+
+      if (pszOutputSRS == pszMapSRS &&
+          msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+        reprojector =
+            msProjectCreateReprojector(&(lp->projection), &(map->projection));
+        if (reprojector == NULL) {
+          msGMLFreeGroups(groupList);
+          msGMLFreeConstants(constantList);
+          msGMLFreeItems(itemList);
+          msGMLFreeGeometries(geometryList);
+          msFree(pszOutputSRS);
+          if (stream_to_free != NULL)
+            fclose(stream_to_free);
+          return MS_FAILURE;
+        }
+      }
+
+      for (j = 0; j < lp->resultcache->numresults; j++) {
+        status = msLayerGetShape(lp, &shape, &(lp->resultcache->results[j]));
+        if (status != MS_SUCCESS) {
+          msGMLFreeGroups(groupList);
+          msGMLFreeConstants(constantList);
+          msGMLFreeItems(itemList);
+          msGMLFreeGeometries(geometryList);
+          msProjectDestroyReprojector(reprojector);
+          msFree(pszOutputSRS);
+          if (stream_to_free != NULL)
+            fclose(stream_to_free);
+          return MS_FAILURE;
+        }
+
+        /* project the shape into the map projection (if necessary), note that
+         * this projects the bounds as well */
+        if (reprojector) {
+          status = msProjectShapeEx(reprojector, &shape);
+          if (status != MS_SUCCESS) {
+            msIO_fprintf(stream,
+                         "<!-- Warning: Failed to reproject shape: %s -->\n",
+                         msGetErrorString(","));
+            msFreeShape(&shape);
+            continue;
+          }
+        }
+
+        /* start this feature */
+        /* specify a feature name, if nothing provided fall back on the layer
+         * name + "_feature" */
+        value = (char *)msSmallMalloc(strlen(lp->name) + 9);
+        sprintf(value, "%s_feature", lp->name);
+        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                   "featurename", OWS_NOERR, "\t\t<%s>\n",
+                                   value);
+        msFree(value);
+
+        /* Write the feature geometry and bounding box unless 'none' was
+         * requested. */
+        /* Default to bbox only if nothing specified and output full geometry
+         * only if explicitly requested */
+        if (!(geometryList && geometryList->numgeometries == 1 &&
+              strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
+          gmlWriteBounds(stream, OWS_GML2, &(shape.bounds), pszOutputSRS,
+                         "\t\t\t", "gml");
+          if (geometryList && geometryList->numgeometries > 0)
+            gmlWriteGeometry(stream, geometryList, OWS_GML2, &(shape),
+                             pszOutputSRS, NULL, "\t\t\t", "", nSRSDimension,
+                             6);
+        }
+
+        /* write any item/values */
+        for (k = 0; k < itemList->numitems; k++) {
+          item = &(itemList->items[k]);
+          if (msItemInGroups(item->name, groupList) == MS_FALSE)
+            msGMLWriteItem(stream, item, shape.values[k], NULL, "\t\t\t",
+                           OWS_GML2, NULL);
+        }
+
+        /* write any constants */
+        for (k = 0; k < constantList->numconstants; k++) {
+          constant = &(constantList->constants[k]);
+          if (msItemInGroups(constant->name, groupList) == MS_FALSE)
+            msGMLWriteConstant(stream, constant, NULL, "\t\t\t");
+        }
+
+        /* write any groups */
+        for (k = 0; k < groupList->numgroups; k++)
+          msGMLWriteGroup(stream, &(groupList->groups[k]), &shape, itemList,
+                          constantList, NULL, "\t\t\t", OWS_GML2, NULL);
+
+        /* end this feature */
+        /* specify a feature name if nothing provided */
+        /* fall back on the layer name + "Feature" */
+        value = (char *)msSmallMalloc(strlen(lp->name) + 9);
+        sprintf(value, "%s_feature", lp->name);
+        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                   "featurename", OWS_NOERR, "\t\t</%s>\n",
+                                   value);
+        msFree(value);
+
+        msFreeShape(&shape); /* init too */
+      }
+
+      msProjectDestroyReprojector(reprojector);
+
+      /* end this collection (layer) */
+      /* if no layer name provided fall back on the layer name + "_layer" */
+      value = (char *)msSmallMalloc(strlen(lp->name) + 7);
+      sprintf(value, "%s_layer", lp->name);
+      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                 "layername", OWS_NOERR, "\t</%s>\n", value);
+      msFree(value);
+
+      msGMLFreeGroups(groupList);
+      msGMLFreeConstants(constantList);
+      msGMLFreeItems(itemList);
+      msGMLFreeGeometries(geometryList);
+
+      /* msLayerClose(lp); */
+    }
+    if (pszOutputSRS != pszMapSRS) {
+      msFree(pszOutputSRS);
+    }
+  } /* next layer */
+
+  /* end this document */
+  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces,
+                             "rootname", OWS_NOERR, "</%s>\n", "msGMLOutput");
+
+  if (stream_to_free != NULL)
+    fclose(stream_to_free);
+  msFree(pszMapSRS);
+
+  return (MS_SUCCESS);
+
+#else /* Stub for mapscript */
+  msSetError(MS_MISCERR, "WMS server support not enabled", "msGMLWriteQuery()");
+  return MS_FAILURE;
+#endif
+}
+
+#ifdef USE_WFS_SVR
+void msGMLWriteWFSBounds(mapObj *map, FILE *stream, const char *tab,
+                         OWSGMLVersion outputformat, int nWFSVersion,
+                         int bUseURN) {
+  rectObj resultBounds = {-1.0, -1.0, -1.0, -1.0};
+
+  /*add a check to see if the map projection is set to be north-east*/
+  int bSwapAxis = msIsAxisInvertedProj(&(map->projection));
+
+  /* Need to start with BBOX of the whole resultset */
+  if (msGetQueryResultBounds(map, &resultBounds) > 0) {
+    char *srs = NULL;
+    if (bSwapAxis) {
+      double tmp;
+
+      tmp = resultBounds.minx;
+      resultBounds.minx = resultBounds.miny;
+      resultBounds.miny = tmp;
+
+      tmp = resultBounds.maxx;
+      resultBounds.maxx = resultBounds.maxy;
+      resultBounds.maxy = tmp;
+    }
+    if (bUseURN) {
+      srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
+      if (!srs)
+        srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO",
+                              MS_TRUE);
+    } else {
+      msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
+      if (!srs)
+        msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO",
+                         MS_TRUE, &srs);
+    }
+
+    gmlWriteBounds(stream, outputformat, &resultBounds, srs, tab,
+                   (nWFSVersion == OWS_2_0_0) ? "wfs" : "gml");
+    msFree(srs);
+  }
+}
+
+#endif
+
+/*
+** msGMLWriteWFSQuery()
+**
+** Similar to msGMLWriteQuery() but tuned for use with WFS
+*/
+int msGMLWriteWFSQuery(mapObj *map, FILE *stream,
+                       const char *default_namespace_prefix,
+                       OWSGMLVersion outputformat, int nWFSVersion, int bUseURN,
+                       int bGetPropertyValueRequest) {
+#ifdef USE_WFS_SVR
+  int status;
+  int i, j, k;
+  layerObj *lp = NULL;
+  shapeObj shape;
+
+  gmlGroupListObj *groupList = NULL;
+  gmlItemListObj *itemList = NULL;
+  gmlConstantListObj *constantList = NULL;
+  gmlGeometryListObj *geometryList = NULL;
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
+
+  const char *namespace_prefix = NULL;
+  int bSwapAxis;
+
+  msInitShape(&shape);
+
+  /*add a check to see if the map projection is set to be north-east*/
+  bSwapAxis = msIsAxisInvertedProj(&(map->projection));
+
+  /* Need to start with BBOX of the whole resultset */
+  if (!bGetPropertyValueRequest) {
+    msGMLWriteWFSBounds(map, stream, "      ", outputformat, nWFSVersion,
+                        bUseURN);
+  }
+  /* step through the layers looking for query results */
+  for (i = 0; i < map->numlayers; i++) {
+
+    lp = GET_LAYER(map, map->layerorder[i]);
+
+    if (lp->resultcache &&
+        lp->resultcache->numresults > 0) { /* found results */
+      char *layerName;
+      const char *value;
+      int featureIdIndex = -1; /* no feature id */
+      char *srs = NULL;
+      int bOutputGMLIdOnly = MS_FALSE;
+      int nSRSDimension = 2;
+      const char *geomtype;
+      reprojectionObj *reprojector = NULL;
+      int geometry_precision = 6;
+
+      /* setup namespace, a layer can override the default */
+      namespace_prefix =
+          msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
+      if (!namespace_prefix)
+        namespace_prefix = default_namespace_prefix;
+
+      geomtype = msOWSLookupMetadata(&(lp->metadata), "OFG", "geomtype");
+      if (geomtype != NULL && (strstr(geomtype, "25d") != NULL ||
+                               strstr(geomtype, "25D") != NULL)) {
+        nSRSDimension = 3;
+      }
+
+      value = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
+      if (value) { /* find the featureid amongst the items for this layer */
+        for (j = 0; j < lp->numitems; j++) {
+          if (strcasecmp(lp->items[j], value) == 0) { /* found it */
+            featureIdIndex = j;
+            break;
+          }
+        }
+
+        /* Produce a warning if a featureid was set but the corresponding item
+         * is not found. */
+        if (featureIdIndex == -1)
+          msIO_fprintf(stream,
+                       "<!-- WARNING: FeatureId item '%s' not found in "
+                       "typename '%s'. -->\n",
+                       value, lp->name);
+      } else if (outputformat == OWS_GML32)
+        msIO_fprintf(stream,
+                     "<!-- WARNING: No featureid defined for typename '%s'. "
+                     "Output will not validate. -->\n",
+                     lp->name);
+
+      /* populate item and group metadata structures */
+      itemList = msGMLGetItems(lp, "G");
+      constantList = msGMLGetConstants(lp, "G");
+      groupList = msGMLGetGroups(lp, "G");
+      geometryList = msGMLGetGeometries(lp, "GFO", MS_FALSE);
+      if (itemList == NULL || constantList == NULL || groupList == NULL ||
+          geometryList == NULL) {
+        msSetError(MS_MISCERR,
+                   "Unable to populate item and group metadata structures",
+                   "msGMLWriteWFSQuery()");
+        return MS_FAILURE;
+      }
+
+      if (bGetPropertyValueRequest) {
+        const char *value =
+            msOWSLookupMetadata(&(lp->metadata), "G", "include_items");
+        if (value != NULL && strcmp(value, "@gml:id") == 0)
+          bOutputGMLIdOnly = MS_TRUE;
+      }
+
+      if (namespace_prefix) {
+        layerName = (char *)msSmallMalloc(strlen(namespace_prefix) +
+                                          strlen(lp->name) + 2);
+        sprintf(layerName, "%s:%s", namespace_prefix, lp->name);
+      } else {
+        layerName = msStrdup(lp->name);
+      }
+
+      if (bUseURN) {
+        srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
+        if (!srs)
+          srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO",
+                                MS_TRUE);
+        if (!srs)
+          srs = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FGO",
+                                MS_TRUE);
+      } else {
+        msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
+        if (!srs)
+          msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO",
+                           MS_TRUE, &srs);
+        if (!srs)
+          msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FGO", MS_TRUE,
+                           &srs);
+      }
+
+      if (msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+        reprojector =
+            msProjectCreateReprojector(&(lp->projection), &(map->projection));
+        if (reprojector == NULL) {
+          msGMLFreeGroups(groupList);
+          msGMLFreeConstants(constantList);
+          msGMLFreeItems(itemList);
+          msGMLFreeGeometries(geometryList);
+          msFree(layerName);
+          msFree(srs);
+          return MS_FAILURE;
+        }
+      }
+
+      for (j = 0; j < lp->resultcache->numresults; j++) {
+        char *pszFID;
+
+        if (lp->resultcache->results[j].shape) {
+          /* msDebug("Using cached shape %ld\n",
+           * lp->resultcache->results[j].shapeindex); */
+          msCopyShape(lp->resultcache->results[j].shape, &shape);
+        } else {
+          status = msLayerGetShape(lp, &shape, &(lp->resultcache->results[j]));
+          if (status != MS_SUCCESS) {
+            msGMLFreeGroups(groupList);
+            msGMLFreeConstants(constantList);
+            msGMLFreeItems(itemList);
+            msGMLFreeGeometries(geometryList);
+            msFree(layerName);
+            msProjectDestroyReprojector(reprojector);
+            msFree(srs);
+            return (status);
+          }
+        }
+
+        /* project the shape into the map projection (if necessary), note that
+         * this projects the bounds as well */
+        if (reprojector)
+          msProjectShapeEx(reprojector, &shape);
+
+        if (featureIdIndex != -1) {
+          pszFID = (char *)msSmallMalloc(
+              strlen(lp->name) + 1 + strlen(shape.values[featureIdIndex]) + 1);
+          sprintf(pszFID, "%s.%s", lp->name, shape.values[featureIdIndex]);
+        } else
+          pszFID = msStrdup("");
+
+        if (bOutputGMLIdOnly) {
+          msIO_fprintf(stream, "    <wfs:member>%s</wfs:member>\n", pszFID);
+          msFree(pszFID);
+          msFreeShape(&shape); /* init too */
+          continue;
+        }
+
+        /*
+        ** start this feature
+        */
+        if (nWFSVersion == OWS_2_0_0)
+          msIO_fprintf(stream, "    <wfs:member>\n");
+        else
+          msIO_fprintf(stream, "    <gml:featureMember>\n");
+        if (msIsXMLTagValid(layerName) == MS_FALSE)
+          msIO_fprintf(stream,
+                       "<!-- WARNING: The value '%s' is not valid in a XML tag "
+                       "context. -->\n",
+                       layerName);
+        if (featureIdIndex != -1) {
+          if (!bGetPropertyValueRequest) {
+            if (outputformat == OWS_GML2)
+              msIO_fprintf(stream, "      <%s fid=\"%s\">\n", layerName,
+                           pszFID);
+            else /* OWS_GML3 or OWS_GML32 */
+              msIO_fprintf(stream, "      <%s gml:id=\"%s\">\n", layerName,
+                           pszFID);
+          }
+        } else {
+          if (!bGetPropertyValueRequest)
+            msIO_fprintf(stream, "      <%s>\n", layerName);
+        }
+
+        if (bSwapAxis)
+          msAxisSwapShape(&shape);
+
+        /* write the feature geometry and bounding box */
+        if (!(geometryList && geometryList->numgeometries == 1 &&
+              strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
+          if (!bGetPropertyValueRequest)
+            gmlWriteBounds(stream, outputformat, &(shape.bounds), srs,
+                           "        ", "gml");
+
+          if (msOWSLookupMetadata(&(lp->metadata), "F", "geometry_precision")) {
+            geometry_precision = atoi(msOWSLookupMetadata(
+                &(lp->metadata), "F", "geometry_precision"));
+          } else if (msOWSLookupMetadata(&map->web.metadata, "F",
+                                         "geometry_precision")) {
+            geometry_precision = atoi(msOWSLookupMetadata(
+                &map->web.metadata, "F", "geometry_precision"));
+          }
+
+          gmlWriteGeometry(stream, geometryList, outputformat, &(shape), srs,
+                           namespace_prefix, "        ", pszFID, nSRSDimension,
+                           geometry_precision);
+        }
+
+        /* write any item/values */
+        for (k = 0; k < itemList->numitems; k++) {
+          item = &(itemList->items[k]);
+          if (msItemInGroups(item->name, groupList) == MS_FALSE)
+            msGMLWriteItem(stream, item, shape.values[k], namespace_prefix,
+                           "        ", outputformat, pszFID);
+        }
+
+        /* write any constants */
+        for (k = 0; k < constantList->numconstants; k++) {
+          constant = &(constantList->constants[k]);
+          if (msItemInGroups(constant->name, groupList) == MS_FALSE)
+            msGMLWriteConstant(stream, constant, namespace_prefix, "        ");
+        }
+
+        /* write any groups */
+        for (k = 0; k < groupList->numgroups; k++)
+          msGMLWriteGroup(stream, &(groupList->groups[k]), &shape, itemList,
+                          constantList, namespace_prefix, "        ",
+                          outputformat, pszFID);
+
+        if (!bGetPropertyValueRequest)
+          /* end this feature */
+          msIO_fprintf(stream, "      </%s>\n", layerName);
+
+        if (nWFSVersion == OWS_2_0_0)
+          msIO_fprintf(stream, "    </wfs:member>\n");
+        else
+          msIO_fprintf(stream, "    </gml:featureMember>\n");
+
+        msFree(pszFID);
+        pszFID = NULL;
+        msFreeShape(&shape); /* init too */
+      }
+
+      msProjectDestroyReprojector(reprojector);
+
+      msFree(srs);
+
+      /* done with this layer, do a little clean-up */
+      msFree(layerName);
+
+      msGMLFreeGroups(groupList);
+      msGMLFreeConstants(constantList);
+      msGMLFreeItems(itemList);
+      msGMLFreeGeometries(geometryList);
+
+      /* msLayerClose(lp); */
+    }
+
+  } /* next layer */
+
+  return (MS_SUCCESS);
+
+#else  /* Stub for mapscript */
+  msSetError(MS_MISCERR, "WFS server support not enabled",
+             "msGMLWriteWFSQuery()");
+  return MS_FAILURE;
+#endif /* USE_WFS_SVR */
+}
+
+#ifdef USE_LIBXML2
+
+/**
+ * msGML3BoundedBy()
+ *
+ * returns an object of BoundedBy as per GML 3
+ *
+ * @param xmlNsPtr psNs the namespace object
+ * @param minx minx
+ * @param miny miny
+ * @param maxx maxx
+ * @param mayy mayy
+ * @param psEpsg epsg code
+ * @param dimension number of dimensions
+ *
+ * @return psNode xmlNodePtr of XML construct
+ *
+ */
+
+xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx,
+                           double maxy, const char *psEpsg) {
+  xmlNodePtr psNode = NULL, psSubNode = NULL;
+  char *pszTmp = NULL;
+  char *pszTmp2 = NULL;
+  char *pszEpsg = NULL;
+
+  psNode = xmlNewNode(psNs, BAD_CAST "boundedBy");
+  psSubNode = xmlNewChild(psNode, NULL, BAD_CAST "Envelope", NULL);
+
+  if (psEpsg) {
+    const size_t bufferSize = strlen(psEpsg) + 1;
+    pszEpsg = (char *)msSmallMalloc(bufferSize);
+    snprintf(pszEpsg, bufferSize, "%s", psEpsg);
+    msStringToLower(pszEpsg);
+    pszTmp = msStringConcatenate(pszTmp, "urn:ogc:crs:");
+    pszTmp = msStringConcatenate(pszTmp, pszEpsg);
+    xmlNewProp(psSubNode, BAD_CAST "srsName", BAD_CAST pszTmp);
+    free(pszEpsg);
+    free(pszTmp);
+    pszTmp = msIntToString(2);
+    xmlNewProp(psSubNode, BAD_CAST "srsDimension", BAD_CAST pszTmp);
+    free(pszTmp);
+  }
+
+  pszTmp = msDoubleToString(minx, MS_TRUE);
+  pszTmp = msStringConcatenate(pszTmp, " ");
+  pszTmp2 = msDoubleToString(miny, MS_TRUE);
+  pszTmp = msStringConcatenate(pszTmp, pszTmp2);
+  xmlNewChild(psSubNode, NULL, BAD_CAST "lowerCorner", BAD_CAST pszTmp);
+  free(pszTmp);
+  free(pszTmp2);
+
+  pszTmp = msDoubleToString(maxx, MS_TRUE);
+  pszTmp = msStringConcatenate(pszTmp, " ");
+  pszTmp2 = msDoubleToString(maxy, MS_TRUE);
+  pszTmp = msStringConcatenate(pszTmp, pszTmp2);
+  xmlNewChild(psSubNode, NULL, BAD_CAST "upperCorner", BAD_CAST pszTmp);
+  free(pszTmp);
+  free(pszTmp2);
+  return psNode;
+}
+
+/**
+ *msGML3Point()
+ *
+ * returns an object of Point as per GML 3
+ *
+ * @param xmlNsPtr psNs the gml namespace object
+ * @param pszSrsName EPSG code of geometry
+ * @param id
+ * @param x x coordinate
+ * @param y y coordinate
+ * @param z z coordinate
+ *
+ * @return psNode xmlNodePtr of XML construct
+ *
+ */
+
+xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id,
+                       double x, double y) {
+
+  xmlNodePtr psNode = xmlNewNode(psNs, BAD_CAST "Point");
+
+  if (id) {
+    xmlNewNsProp(psNode, psNs, BAD_CAST "id", BAD_CAST id);
+  }
+
+  if (psSrsName) {
+    const size_t bufferSize = strlen(psSrsName) + 1;
+    char *pszSrsName = (char *)msSmallMalloc(bufferSize);
+    snprintf(pszSrsName, bufferSize, "%s", psSrsName);
+    msStringToLower(pszSrsName);
+    char *pszTmp = NULL;
+    pszTmp = msStringConcatenate(pszTmp, "urn:ogc:crs:");
+    pszTmp = msStringConcatenate(pszTmp, pszSrsName);
+    xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszTmp);
+    free(pszSrsName);
+    free(pszTmp);
+    const int dimension = 2;
+    pszTmp = msIntToString(dimension);
+    xmlNewProp(psNode, BAD_CAST "srsDimension", BAD_CAST pszTmp);
+    free(pszTmp);
+  }
+
+  char *pszTmp = msDoubleToString(x, MS_TRUE);
+  pszTmp = msStringConcatenate(pszTmp, " ");
+  char *pszTmp2 = msDoubleToString(y, MS_TRUE);
+  pszTmp = msStringConcatenate(pszTmp, pszTmp2);
+  xmlNewChild(psNode, NULL, BAD_CAST "pos", BAD_CAST pszTmp);
+
+  free(pszTmp);
+  free(pszTmp2);
+  return psNode;
+}
+
+/**
+ * msGML3TimePeriod()
+ *
+ * returns an object of TimePeriod as per GML 3
+ *
+ * @param xmlNsPtr psNs the gml namespace object
+ * @param pszStart start time
+ * @param pszEnd end time
+ *
+ * @return psNode xmlNodePtr of XML construct
+ *
+ */
+
+xmlNodePtr msGML3TimePeriod(xmlNsPtr psNs, char *pszStart, char *pszEnd) {
+  xmlNodePtr psNode = NULL;
+
+  psNode = xmlNewNode(psNs, BAD_CAST "TimePeriod");
+  xmlNewChild(psNode, NULL, BAD_CAST "beginPosition", BAD_CAST pszStart);
+  if (pszEnd)
+    xmlNewChild(psNode, NULL, BAD_CAST "endPosition", BAD_CAST pszEnd);
+  else {
+    xmlNewChild(psNode, NULL, BAD_CAST "endPosition", NULL);
+    xmlNewProp(psNode, BAD_CAST "indeterminatePosition", BAD_CAST "now");
+  }
+  return psNode;
+}
+
+/**
+ * msGML3TimeInstant()
+ *
+ * returns an object of TimeInstant as per GML 3
+ *
+ * @param xmlNsPtr psNs the gml namespace object
+ * @param timeInstant time instant
+ *
+ * @return psNode xmlNodePtr of XML construct
+ *
+ */
+
+xmlNodePtr msGML3TimeInstant(xmlNsPtr psNs, char *pszTime) {
+  xmlNodePtr psNode = NULL;
+
+  psNode = xmlNewNode(psNs, BAD_CAST "TimeInstant");
+  xmlNewChild(psNode, NULL, BAD_CAST "timePosition", BAD_CAST pszTime);
+  return psNode;
+}
+
+#endif /* USE_LIBXML2 */
+
+/************************************************************************/
+/*      The following functions are enabled in all cases, even if       */
+/*      WMS and WFS are not available.                                  */
+/************************************************************************/
+
+gmlItemListObj *msGMLGetItems(layerObj *layer,
+                              const char *metadata_namespaces) {
+  int i, j;
+
+  char **xmlitems = NULL;
+  int numxmlitems = 0;
+
+  char **incitems = NULL;
+  int numincitems = 0;
+
+  char **excitems = NULL;
+  int numexcitems = 0;
+
+  char **optionalitems = NULL;
+  int numoptionalitems = 0;
+
+  char **mandatoryitems = NULL;
+  int nummandatoryitems = 0;
+
+  char **defaultitems = NULL;
+  int numdefaultitems = 0;
+
+  const char *value = NULL;
+  char tag[64];
+
+  gmlItemListObj *itemList = NULL;
+  gmlItemObj *item = NULL;
+
+  /* get a list of items that might be included in output */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "include_items")) != NULL)
+    incitems = msStringSplit(value, ',', &numincitems);
+
+  /* get a list of items that should be excluded in output */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "exclude_items")) != NULL)
+    excitems = msStringSplit(value, ',', &numexcitems);
+
+  /* get a list of items that should not be XML encoded */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "xml_items")) != NULL)
+    xmlitems = msStringSplit(value, ',', &numxmlitems);
+
+  /* get a list of items that should be indicated as optional in
+   * DescribeFeatureType */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "optional_items")) != NULL)
+    optionalitems = msStringSplit(value, ',', &numoptionalitems);
+
+  /* get a list of items that should be indicated as mandatory in
+   * DescribeFeatureType */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "mandatory_items")) != NULL)
+    mandatoryitems = msStringSplit(value, ',', &nummandatoryitems);
+
+  /* get a list of items that should be presented by default in GetFeature */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "default_items")) != NULL)
+    defaultitems = msStringSplit(value, ',', &numdefaultitems);
+
+  /* allocate memory and iinitialize the item collection */
+  itemList = (gmlItemListObj *)malloc(sizeof(gmlItemListObj));
+  if (itemList == NULL) {
+    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.",
+               "msGMLGetItems()");
+    return NULL;
+  }
+
+  itemList->numitems = layer->numitems;
+  itemList->items =
+      (gmlItemObj *)malloc(sizeof(gmlItemObj) * itemList->numitems);
+  if (!itemList->items) {
+    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.",
+               "msGMLGetItems()");
+    free(itemList);
+    return NULL;
+  }
+
+  for (i = 0; i < layer->numitems; i++) {
+    item = &(itemList->items[i]);
+
+    item->name = msStrdup(layer->items[i]); /* initialize the item */
+    item->alias = NULL;
+    item->type = NULL;
+    item->template = NULL;
+    item->encode = MS_TRUE;
+    item->visible = MS_FALSE;
+    item->width = 0;
+    item->precision = 0;
+    item->outputByDefault = (numdefaultitems == 0);
+    item->minOccurs = 0;
+
+    /* check visibility, included items first... */
+    if (numincitems == 1 && strcasecmp("all", incitems[0]) == 0) {
+      item->visible = MS_TRUE;
+    } else {
+      for (j = 0; j < numincitems; j++) {
+        if (strcasecmp(layer->items[i], incitems[j]) == 0)
+          item->visible = MS_TRUE;
+      }
+    }
+
+    /* ...and now excluded items */
+    for (j = 0; j < numexcitems; j++) {
+      if (strcasecmp(layer->items[i], excitems[j]) == 0)
+        item->visible = MS_FALSE;
+    }
+
+    /* check encoding */
+    for (j = 0; j < numxmlitems; j++) {
+      if (strcasecmp(layer->items[i], xmlitems[j]) == 0)
+        item->encode = MS_FALSE;
+    }
+
+    /* check optional */
+    if (numoptionalitems == 1 && strcasecmp("all", optionalitems[0]) == 0) {
+      item->minOccurs = 0;
+    } else if (numoptionalitems > 0) {
+      item->minOccurs = 1;
+      for (j = 0; j < numoptionalitems; j++) {
+        if (strcasecmp(layer->items[i], optionalitems[j]) == 0)
+          item->minOccurs = 0;
+      }
+    }
+
+    /* check mandatory */
+    if (nummandatoryitems == 1 && strcasecmp("all", mandatoryitems[0]) == 0) {
+      item->minOccurs = 1;
+    } else if (nummandatoryitems > 0) {
+      item->minOccurs = 0;
+      for (j = 0; j < nummandatoryitems; j++) {
+        if (strcasecmp(layer->items[i], mandatoryitems[j]) == 0)
+          item->minOccurs = 1;
+      }
+    }
+
+    /* check default */
+    for (j = 0; j < numdefaultitems; j++) {
+      if (strcasecmp(layer->items[i], defaultitems[j]) == 0)
+        item->outputByDefault = 1;
+    }
+
+    snprintf(tag, sizeof(tag), "%s_alias", layer->items[i]);
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
+      item->alias = msStrdup(value);
+
+    snprintf(tag, sizeof(tag), "%s_type", layer->items[i]);
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
+      item->type = msStrdup(value);
+
+    snprintf(tag, sizeof(tag), "%s_template", layer->items[i]);
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
+      item->template = msStrdup(value);
+
+    snprintf(tag, sizeof(tag), "%s_width", layer->items[i]);
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
+      item->width = atoi(value);
+
+    snprintf(tag, sizeof(tag), "%s_precision", layer->items[i]);
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
+      item->precision = atoi(value);
+  }
+
+  msFreeCharArray(incitems, numincitems);
+  msFreeCharArray(excitems, numexcitems);
+  msFreeCharArray(xmlitems, numxmlitems);
+  msFreeCharArray(optionalitems, numoptionalitems);
+  msFreeCharArray(mandatoryitems, nummandatoryitems);
+  msFreeCharArray(defaultitems, numdefaultitems);
+
+  return itemList;
+}
+
+void msGMLFreeItems(gmlItemListObj *itemList) {
+  int i;
+
+  if (!itemList)
+    return;
+
+  for (i = 0; i < itemList->numitems; i++) {
+    msFree(itemList->items[i].name);
+    msFree(itemList->items[i].alias);
+    msFree(itemList->items[i].type);
+    msFree(itemList->items[i].template);
+  }
+
+  if (itemList->items != NULL)
+    free(itemList->items);
+
+  free(itemList);
+}
diff -pruN 8.0.1-5/src/mapgml.h 8.2.0~beta1-1~exp1/src/mapgml.h
--- 8.0.1-5/src/mapgml.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgml.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,47 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Headers for mapgml.c.  shapeObj to GML output via MapServer
+ *           queries.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPGML_H
+#define MAPGML_H
+
+#ifdef USE_LIBXML2
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+
+xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx,
+                           double maxy, const char *psEpsg);
+xmlNodePtr msGML3TimePeriod(xmlNsPtr psNs, char *pszStart, char *pszEnd);
+xmlNodePtr msGML3TimeInstant(xmlNsPtr psNs, char *timeInstant);
+xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id,
+                       double x, double y);
+
+#endif /* USE_LIBXML2 */
+
+#endif
diff -pruN 8.0.1-5/src/mapgraph.cpp 8.2.0~beta1-1~exp1/src/mapgraph.cpp
--- 8.0.1-5/src/mapgraph.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgraph.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,378 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Functions for basic undirected, weighted graph support.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapgraph.h"
+#include <algorithm> // for std::swap
+
+graphObj *msCreateGraph(signed int numnodes) {
+  graphObj *graph = nullptr;
+
+  if (numnodes <= 0)
+    return nullptr;
+
+  graph = (graphObj *)malloc(sizeof(graphObj));
+  if (!graph)
+    return nullptr;
+
+  graph->head = (graphNodeObj **)calloc(numnodes, sizeof(graphNodeObj *));
+  if (!graph->head) {
+    free(graph);
+    return nullptr;
+  }
+  graph->numnodes = numnodes;
+
+  return graph;
+}
+
+void msFreeGraph(graphObj *graph) {
+  if (!graph)
+    return;
+
+  graphNodeObj *tmp = nullptr;
+
+  for (int i = 0; i < graph->numnodes; i++) {
+    while (graph->head[i] != nullptr) {
+      tmp = graph->head[i];
+      graph->head[i] = graph->head[i]->next;
+      free(tmp);
+    }
+  }
+
+  free(graph->head);
+  free(graph);
+}
+
+int msGraphAddEdge(graphObj *graph, int src, int dest, double weight) {
+  graphNodeObj *node = nullptr;
+
+  if (!graph)
+    return MS_FAILURE;
+
+  // src -> dest
+  node = (graphNodeObj *)malloc(sizeof(graphNodeObj));
+  if (!node)
+    return MS_FAILURE;
+
+  node->dest = dest;
+  node->weight = weight;
+  node->next = graph->head[src];
+  graph->head[src] = node;
+
+  // dest -> src
+  node = (graphNodeObj *)malloc(sizeof(graphNodeObj));
+  if (!node)
+    return MS_FAILURE;
+
+  node->dest = src;
+  node->weight = weight;
+  node->next = graph->head[dest];
+  graph->head[dest] = node;
+
+  return MS_SUCCESS;
+}
+
+void msPrintGraph(graphObj *graph) {
+  int i;
+
+  if (!graph)
+    return;
+
+  for (i = 0; i < graph->numnodes; i++) {
+    graphNodeObj *node = graph->head[i];
+    if (node != nullptr) {
+      do {
+        msDebug("%d -> %d (%.6f)\t", i, node->dest, node->weight);
+        node = node->next;
+      } while (node != nullptr);
+      msDebug("\n");
+    }
+  }
+}
+
+/*
+** Derived from an number web resources including:
+**
+**
+*https://www.geeksforgeeks.org/dijkstras-algorithm-for-adjacency-list-representation-greedy-algo-8/
+**   https://youtube.com/watch?v=pSqmAO-m7Lk
+**   https://en.wikipedia.org/wiki/Dijkstra%27s_algorithm
+**
+** Much of the bulk here is for min-heap (key,value) management.
+*/
+
+typedef struct {
+  int idx;
+  double dist;
+} minHeapNodeObj;
+
+typedef struct {
+  int size;
+  int capacity;
+  int *pos;
+  minHeapNodeObj **nodes;
+} minHeapObj;
+
+static minHeapNodeObj *newMinHeapNode(int idx, double dist) {
+  minHeapNodeObj *node = (minHeapNodeObj *)malloc(sizeof(minHeapNodeObj));
+  if (!node)
+    return nullptr;
+  node->idx = idx;
+  node->dist = dist;
+  return node;
+}
+
+static void freeMinHeap(minHeapObj *minHeap) {
+  if (!minHeap)
+    return;
+
+  free(minHeap->pos);
+  for (int i = 0; i < minHeap->size; i++) {
+    free(minHeap->nodes[i]);
+  }
+  free(minHeap->nodes);
+  free(minHeap);
+}
+
+static minHeapObj *createMinHeap(signed int capacity) {
+  minHeapObj *minHeap = (minHeapObj *)malloc(sizeof(minHeapObj));
+  if (!minHeap)
+    return nullptr;
+
+  minHeap->pos = (int *)malloc(capacity * sizeof(int));
+  if (!minHeap->pos) {
+    free(minHeap);
+    return nullptr;
+  }
+  minHeap->size = 0;
+  minHeap->capacity = capacity;
+  minHeap->nodes =
+      (minHeapNodeObj **)malloc(capacity * sizeof(minHeapNodeObj *));
+  if (!minHeap->nodes) {
+    free(minHeap->pos);
+    free(minHeap);
+    return nullptr;
+  }
+  return minHeap;
+}
+
+static void minHeapify(minHeapObj *minHeap, int idx) {
+  int smallest = idx;
+  const int left = 2 * idx + 1;
+  const int right = 2 * idx + 2;
+
+  if (left < minHeap->size &&
+      minHeap->nodes[left]->dist < minHeap->nodes[smallest]->dist)
+    smallest = left;
+
+  if (right < minHeap->size &&
+      minHeap->nodes[right]->dist < minHeap->nodes[smallest]->dist)
+    smallest = right;
+
+  if (smallest != idx) {
+    minHeapNodeObj *smallestNode = minHeap->nodes[smallest];
+    minHeapNodeObj *idxNode = minHeap->nodes[idx];
+
+    minHeap->pos[smallestNode->idx] = idx; // swap positions
+    minHeap->pos[idxNode->idx] = smallest;
+
+    std::swap(minHeap->nodes[smallest], minHeap->nodes[idx]); // swap nodes
+    minHeapify(minHeap, smallest);
+  }
+}
+
+static bool isEmpty(const minHeapObj *minHeap) { return minHeap->size == 0; }
+
+static minHeapNodeObj *extractMin(minHeapObj *minHeap) {
+  if (isEmpty(minHeap))
+    return nullptr;
+
+  // store root node
+  minHeapNodeObj *root = minHeap->nodes[0];
+
+  // replace root node with last node
+  minHeapNodeObj *lastNode = minHeap->nodes[minHeap->size - 1];
+  minHeap->nodes[0] = lastNode;
+
+  // update position of last node
+  minHeap->pos[root->idx] = minHeap->size - 1;
+  minHeap->pos[lastNode->idx] = 0;
+
+  // Reduce heap size and heapify root
+  --minHeap->size;
+  minHeapify(minHeap, 0);
+
+  return root;
+}
+
+static void decreaseKey(minHeapObj *minHeap, int idx, int dist) {
+  // get the index of idx in min heap nodes
+  int i = minHeap->pos[idx];
+
+  // get the node and update its dist value
+  minHeap->nodes[i]->dist = dist;
+
+  // travel up while the complete tree is not hepified (this is a O(Logn) loop)
+  while (i && minHeap->nodes[i]->dist < minHeap->nodes[(i - 1) / 2]->dist) {
+    // swap this node with its parent
+    minHeap->pos[minHeap->nodes[i]->idx] = (i - 1) / 2;
+    minHeap->pos[minHeap->nodes[(i - 1) / 2]->idx] = i;
+    std::swap(minHeap->nodes[i], minHeap->nodes[(i - 1) / 2]);
+
+    // move to parent index
+    i = (i - 1) / 2;
+  }
+}
+
+static bool isInMinHeap(const minHeapObj *minHeap, int idx) {
+  return minHeap->pos[idx] < minHeap->size;
+}
+
+typedef struct {
+  double *dist;
+  int *prev;
+} dijkstraOutputObj;
+
+static dijkstraOutputObj *dijkstra(graphObj *graph, int src) {
+  int n = graph->numnodes;
+
+  minHeapObj *minHeap =
+      createMinHeap(n); // priority queue implemented as a min heap structure
+  if (!minHeap)
+    return nullptr;
+
+  dijkstraOutputObj *output = nullptr;
+  output = (dijkstraOutputObj *)malloc(sizeof(dijkstraOutputObj));
+  output->dist = (double *)malloc(n * sizeof(double));
+  output->prev = (int *)malloc(n * sizeof(int));
+  if (!output->dist || !output->prev) {
+    msFree(output->dist);
+    msFree(output->prev);
+    free(output);
+    freeMinHeap(minHeap);
+    return nullptr;
+  }
+
+  // initialize
+  for (int i = 0; i < n; i++) {
+    output->dist[i] = HUGE_VAL;
+    output->prev[i] = -1;
+    minHeap->nodes[i] = newMinHeapNode(
+        i, output->dist[i]); // allocate a min heap node for each graph node
+    minHeap->pos[i] = i;
+  }
+
+  // make dist value of src vertex as 0 so that it is extracted first
+  minHeap->pos[src] = src;
+  output->dist[src] = 0;
+  decreaseKey(minHeap, src, output->dist[src]);
+
+  // initially size of min heap is equal to graph->numnodes (n)
+  minHeap->size = n;
+
+  // In the following loop, minHeap contains all nodes
+  // whose shortest distance is not yet finalized.
+  while (!isEmpty(minHeap)) {
+
+    // extract the vertex with minimum distance value and store the node index
+    minHeapNodeObj *minHeapNode = extractMin(minHeap);
+    int u = minHeapNode->idx;
+    free(minHeapNode); // done with this node
+
+    // traverse through all adjacent nodes of u and update their distance values
+    graphNodeObj *node = graph->head[u];
+    while (node != nullptr) {
+      int v = node->dest;
+
+      // if shortest distance to v is not finalized yet, and distance to v
+      // through u is less than its previously calculated distance
+      if (isInMinHeap(minHeap, v) && output->dist[u] != HUGE_VAL &&
+          node->weight + output->dist[u] < output->dist[v]) {
+        output->dist[v] = output->dist[u] + node->weight;
+        output->prev[v] = u;
+        decreaseKey(minHeap, v, output->dist[v]);
+      }
+      node = node->next;
+    }
+  }
+
+  freeMinHeap(minHeap);
+
+  return output;
+}
+
+int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size,
+                                   double *path_dist) {
+  if (!graph || src < 0 || src > graph->numnodes)
+    return nullptr;
+
+  int *path =
+      (int *)malloc((graph->numnodes) *
+                    sizeof(int)); // worst case is path traverses all nodes
+  if (!path)
+    return nullptr;
+
+  dijkstraOutputObj *output = dijkstra(graph, src);
+  if (!output) {
+    free(path);
+    return nullptr; // algorithm failed for some reason
+  }
+
+  // get longest shortest distance from src to another node (our dest)
+  *path_dist = -1;
+  int dest = -1;
+  for (int i = 0; i < graph->numnodes; i++) {
+    if (output->dist[i] != HUGE_VAL && *path_dist < output->dist[i]) {
+      *path_dist = output->dist[i];
+      dest = i;
+    }
+  }
+
+  if (dest == -1) { // unable to determine destination node
+    free(path);
+    free(output->dist);
+    free(output->prev);
+    free(output);
+    return nullptr;
+  }
+
+  // construct the path from src to dest
+  int j = 0;
+  for (int i = dest; i != -1; i = output->prev[i], j++)
+    path[j] = i;
+  std::reverse(path, path + j);
+  *path_size = j;
+
+  // clean up dijkstra output
+  free(output->dist);
+  free(output->prev);
+  free(output);
+
+  return path;
+}
diff -pruN 8.0.1-5/src/mapgraph.h 8.2.0~beta1-1~exp1/src/mapgraph.h
--- 8.0.1-5/src/mapgraph.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgraph.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,60 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Declarations for basic undirected, wighted graph support.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPGRAPH_H
+#define MAPGRAPH_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct graphNodeObj {
+  int dest;
+  double weight;
+  struct graphNodeObj *next;
+} graphNodeObj;
+
+typedef struct {
+  int numnodes;
+  struct graphNodeObj **head;
+} graphObj;
+
+graphObj *msCreateGraph(int numnodes);
+void msFreeGraph(graphObj *graph);
+int msGraphAddEdge(graphObj *graph, int src, int dest, double weight);
+void msPrintGraph(graphObj *graph);
+
+int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size,
+                                   double *path_dist);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPGRAPH_H */
diff -pruN 8.0.1-5/src/mapgraticule.c 8.2.0~beta1-1~exp1/src/mapgraticule.c
--- 8.0.1-5/src/mapgraticule.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapgraticule.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1336 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Graticule Renderer
+ * Author:   John Novak, Novacell Technologies (jnovak@novacell.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2003, John Novak, Novacell Technologies
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include <assert.h>
+#include "mapproject.h"
+
+/**********************************************************************************************************************
+ *
+ */
+typedef enum { posBottom = 1, posTop, posLeft, posRight } msGraticulePosition;
+
+typedef enum {
+  lpDefault = 0,
+  lpDDMMSS = 1,
+  lpDDMM,
+  lpDD
+} msLabelProcessingType;
+
+void DefineAxis(int iTickCountTarget, double *Min, double *Max, double *Inc);
+static int _AdjustLabelPosition(layerObj *pLayer, shapeObj *pShape,
+                                msGraticulePosition ePosition);
+static void _FormatLabel(layerObj *pLayer, shapeObj *pShape,
+                         double dDataToFormat);
+
+int msGraticuleLayerInitItemInfo(layerObj *layer);
+
+#define MAPGRATICULE_ARC_SUBDIVISION_DEFAULT (256)
+#define MAPGRATICULE_ARC_MINIMUM (16)
+#define MAPGRATICULE_FORMAT_STRING_DEFAULT "%5.2g"
+#define MAPGRATICULE_FORMAT_STRING_DDMMSS "%3d %02d %02d"
+#define MAPGRATICULE_FORMAT_STRING_DDMM "%3d %02d"
+#define MAPGRATICULE_FORMAT_STRING_DD "%3d"
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerOpen(layerObj *layer) {
+  graticuleObj *pInfo = layer->grid;
+
+  if (pInfo == NULL)
+    return MS_FAILURE;
+
+  pInfo->dincrementlatitude = 15.0;
+  pInfo->dincrementlongitude = 15.0;
+  pInfo->dwhichlatitude = -90.0;
+  pInfo->dwhichlongitude = -180.0;
+  pInfo->bvertical = 1;
+
+  if (layer->numclasses == 0)
+    msDebug("GRID layer has no classes, nothing will be rendered.\n");
+
+  if (layer->numclasses > 0 && layer->class[0] -> numlabels > 0)
+    pInfo->blabelaxes = 1;
+  else
+    pInfo->blabelaxes = 0;
+
+  if (pInfo->labelformat == NULL) {
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DEFAULT) + 1);
+    pInfo->ilabeltype = (int)lpDefault;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DEFAULT);
+  } else if (strcmp(pInfo->labelformat, "DDMMSS") == 0) {
+    msFree(pInfo->labelformat);
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DDMMSS) + 1);
+    pInfo->ilabeltype = (int)lpDDMMSS;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMMSS);
+  } else if (strcmp(pInfo->labelformat, "DDMM") == 0) {
+    msFree(pInfo->labelformat);
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DDMM) + 1);
+    pInfo->ilabeltype = (int)lpDDMM;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMM);
+  } else if (strcmp(pInfo->labelformat, "DD") == 0) {
+    msFree(pInfo->labelformat);
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DD) + 1);
+    pInfo->ilabeltype = (int)lpDD;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DD);
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ * Return MS_TRUE if layer is open, MS_FALSE otherwise.
+ */
+int msGraticuleLayerIsOpen(layerObj *layer) {
+  if (layer->grid)
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerClose(layerObj *layer) {
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  (void)isQuery;
+  graticuleObj *pInfo = layer->grid;
+  int iAxisTickCount = 0;
+  rectObj rectMapCoordinates;
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  pInfo->dstartlatitude = rect.miny;
+  pInfo->dstartlongitude = rect.minx;
+  pInfo->dendlatitude = rect.maxy;
+  pInfo->dendlongitude = rect.maxx;
+  pInfo->bvertical = 1;
+  pInfo->extent = rect;
+
+  if (pInfo->minincrement > 0.0) {
+    pInfo->dincrementlongitude = pInfo->minincrement;
+    pInfo->dincrementlatitude = pInfo->minincrement;
+  } else if (pInfo->maxincrement > 0.0) {
+    pInfo->dincrementlongitude = pInfo->maxincrement;
+    pInfo->dincrementlatitude = pInfo->maxincrement;
+  } else {
+    pInfo->dincrementlongitude = 0;
+    pInfo->dincrementlatitude = 0;
+  }
+
+  if (pInfo->maxarcs > 0)
+    iAxisTickCount = (int)pInfo->maxarcs;
+  else if (pInfo->minarcs > 0)
+    iAxisTickCount = (int)pInfo->minarcs;
+
+  DefineAxis(iAxisTickCount, &pInfo->dstartlongitude, &pInfo->dendlongitude,
+             &pInfo->dincrementlongitude);
+  DefineAxis(iAxisTickCount, &pInfo->dstartlatitude, &pInfo->dendlatitude,
+             &pInfo->dincrementlatitude);
+
+  pInfo->dwhichlatitude = pInfo->dstartlatitude;
+  pInfo->dwhichlongitude = pInfo->dstartlongitude;
+
+  if (pInfo->minincrement > 0.0 && pInfo->maxincrement > 0.0 &&
+      pInfo->minincrement == pInfo->maxincrement) {
+    pInfo->dincrementlongitude = pInfo->minincrement;
+    pInfo->dincrementlatitude = pInfo->minincrement;
+  } else if (pInfo->minincrement > 0.0) {
+    pInfo->dincrementlongitude = pInfo->minincrement;
+    pInfo->dincrementlatitude = pInfo->minincrement;
+  } else if (pInfo->maxincrement > 0.0) {
+    pInfo->dincrementlongitude = pInfo->maxincrement;
+    pInfo->dincrementlatitude = pInfo->maxincrement;
+  }
+
+  /*
+   * If using PROJ, project rect back into map system, and generate rect corner
+   * points in native system. These lines will be used when generating labels to
+   * get correct placement at arc/rect edge intersections.
+   */
+  rectMapCoordinates = layer->map->extent;
+
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(layer->map->projection));
+  if (layer->project && strstr(layer->map->projection.args[0], "epsg:3857") &&
+      msProjIsGeographicCRS(&(layer->projection))) {
+    if (rectMapCoordinates.minx < -20037508)
+      rectMapCoordinates.minx = -20037508;
+    if (rectMapCoordinates.maxx > 20037508)
+      rectMapCoordinates.maxx = 20037508;
+  }
+
+  msFree(pInfo->pboundinglines);
+  pInfo->pboundinglines = (lineObj *)msSmallMalloc(sizeof(lineObj) * 4);
+  msFree(pInfo->pboundingpoints);
+  pInfo->pboundingpoints = (pointObj *)msSmallMalloc(sizeof(pointObj) * 8);
+
+  {
+
+    /*
+     * top
+     */
+    pInfo->pboundinglines[0].numpoints = 2;
+    pInfo->pboundinglines[0].point = &pInfo->pboundingpoints[0];
+    pInfo->pboundinglines[0].point[0].x = rectMapCoordinates.minx;
+    pInfo->pboundinglines[0].point[0].y = rectMapCoordinates.maxy;
+    pInfo->pboundinglines[0].point[1].x = rectMapCoordinates.maxx;
+    pInfo->pboundinglines[0].point[1].y = rectMapCoordinates.maxy;
+
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[0]);
+
+    /*
+     * bottom
+     */
+    pInfo->pboundinglines[1].numpoints = 2;
+    pInfo->pboundinglines[1].point = &pInfo->pboundingpoints[2];
+    pInfo->pboundinglines[1].point[0].x = rectMapCoordinates.minx;
+    pInfo->pboundinglines[1].point[0].y = rectMapCoordinates.miny;
+    pInfo->pboundinglines[1].point[1].x = rectMapCoordinates.maxx;
+    pInfo->pboundinglines[1].point[1].y = rectMapCoordinates.miny;
+
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[1]);
+
+    /*
+     * left
+     */
+    pInfo->pboundinglines[2].numpoints = 2;
+    pInfo->pboundinglines[2].point = &pInfo->pboundingpoints[4];
+    pInfo->pboundinglines[2].point[0].x = rectMapCoordinates.minx;
+    pInfo->pboundinglines[2].point[0].y = rectMapCoordinates.miny;
+    pInfo->pboundinglines[2].point[1].x = rectMapCoordinates.minx;
+    pInfo->pboundinglines[2].point[1].y = rectMapCoordinates.maxy;
+
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[2]);
+
+    /*
+     * right
+     */
+    pInfo->pboundinglines[3].numpoints = 2;
+    pInfo->pboundinglines[3].point = &pInfo->pboundingpoints[6];
+    pInfo->pboundinglines[3].point[0].x = rectMapCoordinates.maxx;
+    pInfo->pboundinglines[3].point[0].y = rectMapCoordinates.miny;
+    pInfo->pboundinglines[3].point[1].x = rectMapCoordinates.maxx;
+    pInfo->pboundinglines[3].point[1].y = rectMapCoordinates.maxy;
+
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[3]);
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerNextShape(layerObj *layer, shapeObj *shape) {
+  graticuleObj *pInfo = layer->grid;
+
+  if (pInfo->minsubdivides <= 0.0 || pInfo->maxsubdivides <= 0.0)
+    pInfo->minsubdivides = pInfo->maxsubdivides =
+        MAPGRATICULE_ARC_SUBDIVISION_DEFAULT;
+
+  shape->numlines = 1;
+  shape->type = MS_SHAPE_LINE;
+  shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj));
+  shape->line->numpoints = (int)pInfo->maxsubdivides;
+  shape->line->point = NULL;
+
+  /*
+   * Subdivide and draw current arc, rendering the arc labels first
+   */
+  if (pInfo->bvertical) {
+    int iPointIndex;
+    double dArcDelta = (pInfo->dendlatitude - pInfo->dstartlatitude) /
+                       (double)shape->line->numpoints;
+    double dArcPosition = pInfo->dstartlatitude + dArcDelta;
+    double dStartY, dDeltaX;
+
+    switch (pInfo->ilabelstate) {
+    case 0:
+      if (!pInfo->blabelaxes) { /* Bottom */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
+
+      dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[1].point[0].x) /
+                (pInfo->pboundinglines[1].point[1].x -
+                 pInfo->pboundinglines[1].point[0].x);
+      if (dDeltaX < 0)
+        dDeltaX = dDeltaX * -1;
+
+      dStartY = (pInfo->pboundinglines[1].point[1].y -
+                 pInfo->pboundinglines[1].point[0].y) *
+                    dDeltaX +
+                pInfo->pboundinglines[1].point[0].y;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = pInfo->dwhichlongitude;
+      shape->line->point[0].y = dStartY;
+      shape->line->point[1].x = pInfo->dwhichlongitude;
+      shape->line->point[1].y = dStartY + dArcDelta;
+
+      _FormatLabel(layer, shape, shape->line->point[0].x);
+      if (_AdjustLabelPosition(layer, shape, posBottom) != MS_SUCCESS) {
+        msFreeShape(shape);
+        pInfo->ilabelstate++;
+        return MS_SUCCESS;
+      }
+
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
+
+    case 1:
+      if (!pInfo->blabelaxes) { /* Top */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
+
+      dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[0].point[0].x) /
+                (pInfo->pboundinglines[0].point[1].x -
+                 pInfo->pboundinglines[0].point[0].x);
+      if (dDeltaX < 0)
+        dDeltaX = dDeltaX * -1;
+
+      dStartY = (pInfo->pboundinglines[0].point[1].y -
+                 pInfo->pboundinglines[0].point[0].y) *
+                    dDeltaX +
+                pInfo->pboundinglines[0].point[1].y;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = pInfo->dwhichlongitude;
+      shape->line->point[0].y = dStartY - dArcDelta;
+      shape->line->point[1].x = pInfo->dwhichlongitude;
+      shape->line->point[1].y = dStartY;
+
+      _FormatLabel(layer, shape, shape->line->point[0].x);
+      if (_AdjustLabelPosition(layer, shape, posTop) != MS_SUCCESS) {
+        msFreeShape(shape);
+        pInfo->ilabelstate++;
+        return MS_SUCCESS;
+      }
+
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
+
+    case 2:
+      shape->line->numpoints = (int)shape->line->numpoints + 1;
+      shape->line->point =
+          (pointObj *)msSmallMalloc(sizeof(pointObj) * shape->line->numpoints);
+
+      shape->line->point[0].x = pInfo->dwhichlongitude;
+      shape->line->point[0].y = pInfo->dstartlatitude;
+
+      for (iPointIndex = 1; iPointIndex < shape->line->numpoints;
+           iPointIndex++) {
+        shape->line->point[iPointIndex].x = pInfo->dwhichlongitude;
+        shape->line->point[iPointIndex].y = dArcPosition;
+
+        dArcPosition += dArcDelta;
+      }
+
+      pInfo->ilabelstate = 0;
+
+      pInfo->dwhichlongitude += pInfo->dincrementlongitude;
+      break;
+
+    default:
+      pInfo->ilabelstate = 0;
+      break;
+    }
+
+  } else { /*horizontal*/
+    int iPointIndex;
+    double dArcDelta = (pInfo->dendlongitude - pInfo->dstartlongitude) /
+                       (double)shape->line->numpoints;
+    double dArcPosition = pInfo->dstartlongitude + dArcDelta;
+    double dStartX, dDeltaY;
+
+    switch (pInfo->ilabelstate) {
+    case 0:
+      if (!pInfo->blabelaxes) { /* Left side */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
+
+      dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[2].point[0].y) /
+                (pInfo->pboundinglines[2].point[1].y -
+                 pInfo->pboundinglines[2].point[0].y);
+      if (dDeltaY < 0)
+        dDeltaY = dDeltaY * -1;
+
+      dStartX = (pInfo->pboundinglines[2].point[1].x -
+                 pInfo->pboundinglines[2].point[0].x) *
+                    dDeltaY +
+                pInfo->pboundinglines[2].point[0].x;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = dStartX;
+      shape->line->point[0].y = pInfo->dwhichlatitude;
+      shape->line->point[1].x = dStartX + dArcDelta;
+      shape->line->point[1].y = pInfo->dwhichlatitude;
+
+      _FormatLabel(layer, shape, shape->line->point[0].y);
+      if (_AdjustLabelPosition(layer, shape, posLeft) != MS_SUCCESS) {
+        msFreeShape(shape);
+        pInfo->ilabelstate++;
+        return MS_SUCCESS;
+      }
+
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
+
+    case 1:
+      if (!pInfo->blabelaxes) { /* Right side */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
+
+      dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[3].point[0].y) /
+                (pInfo->pboundinglines[3].point[1].y -
+                 pInfo->pboundinglines[3].point[0].y);
+      if (dDeltaY < 0)
+        dDeltaY = dDeltaY * -1;
+
+      dStartX = (pInfo->pboundinglines[3].point[1].x -
+                 pInfo->pboundinglines[3].point[0].x) *
+                    dDeltaY +
+                pInfo->pboundinglines[3].point[0].x;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = dStartX - dArcDelta;
+      shape->line->point[0].y = pInfo->dwhichlatitude;
+      shape->line->point[1].x = dStartX;
+      shape->line->point[1].y = pInfo->dwhichlatitude;
+
+      _FormatLabel(layer, shape, shape->line->point[0].y);
+      if (_AdjustLabelPosition(layer, shape, posRight) != MS_SUCCESS) {
+        msFreeShape(shape);
+        pInfo->ilabelstate++;
+        return MS_SUCCESS;
+      }
+
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
+
+    case 2:
+      shape->line->numpoints = (int)shape->line->numpoints + 1;
+      shape->line->point =
+          (pointObj *)msSmallMalloc(sizeof(pointObj) * shape->line->numpoints);
+
+      shape->line->point[0].x = pInfo->dstartlongitude;
+      shape->line->point[0].y = pInfo->dwhichlatitude;
+
+      for (iPointIndex = 1; iPointIndex < shape->line->numpoints;
+           iPointIndex++) {
+        shape->line->point[iPointIndex].x = dArcPosition;
+        shape->line->point[iPointIndex].y = pInfo->dwhichlatitude;
+
+        dArcPosition += dArcDelta;
+      }
+
+      pInfo->ilabelstate = 0;
+      pInfo->dwhichlatitude += pInfo->dincrementlatitude;
+      break;
+
+    default:
+      pInfo->ilabelstate = 0;
+      break;
+    }
+  }
+
+  /*
+   * Increment and move to next arc
+   */
+
+  if (pInfo->bvertical && pInfo->dwhichlongitude > pInfo->dendlongitude) {
+    pInfo->dwhichlatitude = pInfo->dstartlatitude;
+    pInfo->bvertical = 0;
+  }
+
+  if (pInfo->dwhichlatitude > pInfo->dendlatitude) {
+    /* free the lineObj and pointObj that have been erroneously allocated
+     * beforehand */
+    msFreeShape(shape);
+    return MS_DONE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerGetItems(layerObj *layer) {
+  char **ppItemName = (char **)msSmallMalloc(sizeof(char *));
+
+  *ppItemName = (char *)msSmallMalloc(64); /* why is this necessary? */
+  strcpy(*ppItemName, "Graticule");
+
+  layer->numitems = 1;
+  layer->items = ppItemName;
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerInitItemInfo(layerObj *layer) {
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+void msGraticuleLayerFreeItemInfo(layerObj *layer) { (void)layer; }
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerGetShape(layerObj *layer, shapeObj *shape,
+                             resultObj *record) {
+  (void)layer;
+  (void)shape;
+  (void)record;
+  return MS_FAILURE;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerGetExtent(layerObj *layer, rectObj *extent) {
+  graticuleObj *pInfo = layer->grid;
+
+  if (pInfo) {
+    *extent = pInfo->extent;
+    return MS_SUCCESS;
+  }
+
+  return MS_FAILURE;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                 shapeObj *shape) {
+  (void)map;
+  (void)layer;
+  (void)c;
+  (void)shape;
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                  msGraticuleLayerFreeIntersectionPoints              */
+/*                                                                      */
+/*      Free intersection object.                                       */
+/************************************************************************/
+void msGraticuleLayerFreeIntersectionPoints(graticuleIntersectionObj *psValue) {
+  if (psValue) {
+    for (int i = 0; i < psValue->nTop; i++)
+      msFree(psValue->papszTopLabels[i]);
+    msFree(psValue->papszTopLabels);
+    msFree(psValue->pasTop);
+
+    for (int i = 0; i < psValue->nBottom; i++)
+      msFree(psValue->papszBottomLabels[i]);
+    msFree(psValue->papszBottomLabels);
+    msFree(psValue->pasBottom);
+
+    for (int i = 0; i < psValue->nLeft; i++)
+      msFree(psValue->papszLeftLabels[i]);
+    msFree(psValue->papszLeftLabels);
+    msFree(psValue->pasLeft);
+
+    for (int i = 0; i < psValue->nRight; i++)
+      msFree(psValue->papszRightLabels[i]);
+    msFree(psValue->papszRightLabels);
+    msFree(psValue->pasRight);
+
+    msFree(psValue);
+  }
+}
+
+/************************************************************************/
+/*                  msGraticuleLayerInitIntersectionPoints              */
+/*                                                                      */
+/*      init intersection object.                                       */
+/************************************************************************/
+static void
+msGraticuleLayerInitIntersectionPoints(graticuleIntersectionObj *psValue) {
+  if (psValue) {
+    psValue->nTop = 0;
+    psValue->pasTop = NULL;
+    psValue->papszTopLabels = NULL;
+    psValue->nBottom = 0;
+    psValue->pasBottom = NULL;
+    psValue->papszBottomLabels = NULL;
+    psValue->nLeft = 0;
+    psValue->pasLeft = NULL;
+    psValue->papszLeftLabels = NULL;
+    psValue->nRight = 0;
+    psValue->pasRight = NULL;
+    psValue->papszRightLabels = NULL;
+  }
+}
+
+/************************************************************************/
+/*                  msGraticuleLayerGetIntersectionPoints               */
+/*                                                                      */
+/*      Utility function thar returns all intersection positions and    */
+/*      labels (4 sides of the map) for a grid layer.                   */
+/************************************************************************/
+graticuleIntersectionObj *
+msGraticuleLayerGetIntersectionPoints(mapObj *map, layerObj *layer) {
+
+  shapeObj shapegrid, tmpshape;
+  rectObj searchrect;
+  int status;
+  pointObj oFirstPoint;
+  pointObj oLastPoint;
+  lineObj oLineObj;
+  rectObj cliprect;
+  graticuleObj *pInfo = NULL;
+  double dfTmp;
+  int i = 0;
+
+  if (layer->connectiontype != MS_GRATICULE)
+    return NULL;
+
+  pInfo = layer->grid;
+
+  /*set cellsize if bnot already set*/
+  if (map->cellsize == 0)
+    map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+
+  if (layer->transform == MS_TRUE)
+    searchrect = map->extent;
+  else {
+    searchrect.minx = searchrect.miny = 0;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
+  }
+
+  if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
+
+  status = msLayerOpen(layer);
+  if (status != MS_SUCCESS)
+    return NULL;
+
+  status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
+  if (status == MS_DONE) { /* no overlap */
+    msLayerClose(layer);
+    return NULL;
+  } else if (status != MS_SUCCESS) {
+    msLayerClose(layer);
+    return NULL;
+  }
+
+  /* step through the target shapes */
+  msInitShape(&shapegrid);
+  cliprect.minx = map->extent.minx - map->cellsize;
+  cliprect.miny = map->extent.miny - map->cellsize;
+  cliprect.maxx = map->extent.maxx + map->cellsize;
+  cliprect.maxy = map->extent.maxy + map->cellsize;
+
+  /* clip using the layer projection */
+  /* msProjectRect(&map->projection , &layer->projection,  &cliprect); */
+
+  graticuleIntersectionObj *psValues =
+      (graticuleIntersectionObj *)msSmallMalloc(
+          sizeof(graticuleIntersectionObj));
+  msGraticuleLayerInitIntersectionPoints(psValues);
+
+  while ((status = msLayerNextShape(layer, &shapegrid)) == MS_SUCCESS) {
+    /*don't really need a class here*/
+    /*
+      shapegrid.classindex = msShapeGetClass(layer, &shapegrid, map->scaledenom,
+    NULL, 0); if((shapegrid.classindex == -1) ||
+    (layer->class[shapegrid.classindex]->status == MS_OFF)) {
+    msFreeShape(&shapegrid);
+    continue;
+    }
+    */
+
+    msInitShape(&tmpshape);
+    msCopyShape(&shapegrid, &tmpshape);
+    /* status = msDrawShape(map, layer, &tmpshape, image, -1); */
+
+    if (layer->project) {
+      if (layer->reprojectorLayerToMap == NULL) {
+        layer->reprojectorLayerToMap =
+            msProjectCreateReprojector(&layer->projection, &map->projection);
+      }
+      if (layer->reprojectorLayerToMap)
+        msProjectShapeEx(layer->reprojectorLayerToMap, &shapegrid);
+    }
+
+    msClipPolylineRect(&shapegrid, cliprect);
+
+    msTransformShapeToPixelRound(&shapegrid, map->extent, map->cellsize);
+
+    if (shapegrid.numlines <= 0 ||
+        shapegrid.line[0].numpoints <
+            2) { /* once clipped the shape didn't need to be drawn */
+      msFreeShape(&shapegrid);
+      msFreeShape(&tmpshape);
+      continue;
+    }
+
+    {
+      int iTmpLine = 0;
+      int nNumPoints = 0;
+      /*grid code seems to retunr lines that can double cross the extenst??*/
+      /*creating a more than one clipped shape. Take the shape that has the most
+        points, which should be the most likley to be correct*/
+
+      if (shapegrid.numlines > 1) {
+        for (i = 0; i < shapegrid.numlines; i++) {
+          if (shapegrid.line[i].numpoints > nNumPoints) {
+            nNumPoints = shapegrid.line[i].numpoints;
+            iTmpLine = i;
+          }
+        }
+      }
+      /* get the first and last point*/
+      oFirstPoint.x = shapegrid.line[iTmpLine].point[0].x;
+      oFirstPoint.y = shapegrid.line[iTmpLine].point[0].y;
+      oLineObj = shapegrid.line[iTmpLine];
+      oLastPoint.x = oLineObj.point[oLineObj.numpoints - 1].x;
+      oLastPoint.y = oLineObj.point[oLineObj.numpoints - 1].y;
+
+      if (pInfo->bvertical) { /*vertical*/
+        /*SHAPES ARE DRAWN FROM BOTTOM TO TOP.*/
+        /*Normally lines are drawn FROM BOTTOM TO TOP but not always for some
+        reason, so make sure that firstpoint < lastpoint in y, We are in pixel
+        coordinates so y increases as we we go down*/
+        if (oFirstPoint.y < oLastPoint.y) {
+          dfTmp = oFirstPoint.x;
+          oFirstPoint.x = oLastPoint.x;
+          oLastPoint.x = dfTmp;
+          dfTmp = oFirstPoint.y;
+          oFirstPoint.y = oLastPoint.y;
+          oLastPoint.y = dfTmp;
+        }
+
+        /*first point should cross the BOTTOM base where y== map->height*/
+
+        if (abs((int)oFirstPoint.y - map->height) <= 1) {
+          char *pszLabel = NULL;
+          oFirstPoint.y = map->height;
+
+          /*validate point is in map width/height*/
+          if (oFirstPoint.x < 0 || oFirstPoint.x > map->width)
+            continue;
+
+          /*validate point is in map width/height*/
+          if (oLastPoint.x < 0 || oLastPoint.x > map->width)
+            continue;
+
+          if (shapegrid.text)
+            pszLabel = msStrdup(shapegrid.text);
+          else {
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].x);
+            if (tmpshape.text)
+              pszLabel = msStrdup(tmpshape.text);
+            else
+              pszLabel = msStrdup("unknown");
+          }
+          /*validate that the  value is not already in the array*/
+          if (psValues->nBottom > 0) {
+            /* if (psValues->pasBottom[psValues->nBottom-1].x == oFirstPoint.x)
+                 continue; */
+
+            for (i = 0; i < psValues->nBottom; i++) {
+              if (psValues->pasBottom[i].x == oFirstPoint.x)
+                break;
+            }
+            if (i < psValues->nBottom) {
+              msFree(pszLabel);
+              continue;
+            }
+          }
+          if (psValues->pasBottom == NULL) {
+            psValues->pasBottom = (pointObj *)msSmallMalloc(sizeof(pointObj));
+            psValues->papszBottomLabels =
+                (char **)msSmallMalloc(sizeof(char *));
+            psValues->nBottom = 1;
+          } else {
+            psValues->nBottom++;
+            psValues->pasBottom = (pointObj *)msSmallRealloc(
+                psValues->pasBottom, sizeof(pointObj) * psValues->nBottom);
+            psValues->papszBottomLabels =
+                (char **)msSmallRealloc(psValues->papszBottomLabels,
+                                        sizeof(char *) * psValues->nBottom);
+          }
+
+          psValues->pasBottom[psValues->nBottom - 1].x = oFirstPoint.x;
+          psValues->pasBottom[psValues->nBottom - 1].y = oFirstPoint.y;
+          psValues->papszBottomLabels[psValues->nBottom - 1] = pszLabel;
+        }
+        /*first point should cross the TOP base where y==0*/
+        if (abs((int)oLastPoint.y) <= 1) {
+          char *pszLabel = NULL;
+          oLastPoint.y = 0;
+
+          /*validate point is in map width/height*/
+          if (oLastPoint.x < 0 || oLastPoint.x > map->width)
+            continue;
+
+          if (shapegrid.text)
+            pszLabel = msStrdup(shapegrid.text);
+          else {
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].x);
+            if (tmpshape.text)
+              pszLabel = msStrdup(tmpshape.text);
+            else
+              pszLabel = msStrdup("unknown");
+          }
+          /*validate if same value is not already there*/
+          if (psValues->nTop > 0) {
+            /* if (psValues->pasTop[psValues->nTop-1].x == oLastPoint.x)
+                 continue; */
+
+            for (i = 0; i < psValues->nTop; i++) {
+              if (psValues->pasTop[i].x == oLastPoint.x ||
+                  strcasecmp(pszLabel, psValues->papszTopLabels[i]) == 0)
+                break;
+            }
+            if (i < psValues->nTop) {
+              msFree(pszLabel);
+              continue;
+            }
+          }
+
+          if (psValues->pasTop == NULL) {
+            psValues->pasTop = (pointObj *)msSmallMalloc(sizeof(pointObj));
+            psValues->papszTopLabels = (char **)msSmallMalloc(sizeof(char *));
+            psValues->nTop = 1;
+          } else {
+            psValues->nTop++;
+            psValues->pasTop = (pointObj *)msSmallRealloc(
+                psValues->pasTop, sizeof(pointObj) * psValues->nTop);
+            psValues->papszTopLabels = (char **)msSmallRealloc(
+                psValues->papszTopLabels, sizeof(char *) * psValues->nTop);
+          }
+
+          psValues->pasTop[psValues->nTop - 1].x = oLastPoint.x;
+          psValues->pasTop[psValues->nTop - 1].y = oLastPoint.y;
+          psValues->papszTopLabels[psValues->nTop - 1] = pszLabel;
+        }
+      } else { /*horzontal*/
+        /*Normally lines are drawn from left to right but not always for some
+          reason, so make sure that firstpoint < lastpoint in x*/
+        if (oFirstPoint.x > oLastPoint.x) {
+
+          dfTmp = oFirstPoint.x;
+          oFirstPoint.x = oLastPoint.x;
+          oLastPoint.x = dfTmp;
+          dfTmp = oFirstPoint.y;
+          oFirstPoint.y = oLastPoint.y;
+          oLastPoint.y = dfTmp;
+        }
+        /*first point should cross the LEFT base where x=0 axis*/
+        if (abs((int)oFirstPoint.x) <= 1) {
+          char *pszLabel = NULL;
+          oFirstPoint.x = 0;
+
+          /*validate point is in map width/height*/
+          if (oFirstPoint.y < 0 || oFirstPoint.y > map->height)
+            continue;
+
+          if (shapegrid.text)
+            pszLabel = msStrdup(shapegrid.text);
+          else {
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].y);
+            if (tmpshape.text)
+              pszLabel = msStrdup(tmpshape.text);
+            else
+              pszLabel = msStrdup("unknown");
+          }
+
+          /*validate that the previous value is not the same*/
+          if (psValues->nLeft > 0) {
+            /* if (psValues->pasLeft[psValues->nLeft-1].y == oFirstPoint.y)
+                 continue; */
+
+            for (i = 0; i < psValues->nLeft; i++) {
+              if (psValues->pasLeft[i].y == oFirstPoint.y)
+                break;
+            }
+            if (i < psValues->nLeft) {
+              msFree(pszLabel);
+              continue;
+            }
+          }
+          if (psValues->pasLeft == NULL) {
+            psValues->pasLeft = (pointObj *)msSmallMalloc(sizeof(pointObj));
+            psValues->papszLeftLabels = (char **)msSmallMalloc(sizeof(char *));
+            psValues->nLeft = 1;
+          } else {
+            psValues->nLeft++;
+            psValues->pasLeft = (pointObj *)msSmallRealloc(
+                psValues->pasLeft, sizeof(pointObj) * psValues->nLeft);
+            psValues->papszLeftLabels = (char **)msSmallRealloc(
+                psValues->papszLeftLabels, sizeof(char *) * psValues->nLeft);
+          }
+
+          psValues->pasLeft[psValues->nLeft - 1].x = oFirstPoint.x;
+          psValues->pasLeft[psValues->nLeft - 1].y = oFirstPoint.y;
+          psValues->papszLeftLabels[psValues->nLeft - 1] =
+              pszLabel; /* takes ownership of allocated pszLabel */
+        }
+        /*first point should cross the RIGHT base where x=map=>width axis*/
+        if (abs((int)oLastPoint.x - map->width) <= 1) {
+          char *pszLabel = NULL;
+          oLastPoint.x = map->width;
+
+          /*validate point is in map width/height*/
+          if (oLastPoint.y < 0 || oLastPoint.y > map->height)
+            continue;
+
+          if (shapegrid.text)
+            pszLabel = msStrdup(shapegrid.text);
+          else {
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].y);
+            if (tmpshape.text)
+              pszLabel = msStrdup(tmpshape.text);
+            else
+              pszLabel = msStrdup("unknown");
+          }
+
+          /*validate that the previous value is not the same*/
+          if (psValues->nRight > 0) {
+            /* if (psValues->pasRight[psValues->nRight-1].y == oLastPoint.y)
+                 continue; */
+            for (i = 0; i < psValues->nRight; i++) {
+              if (psValues->pasRight[i].y == oLastPoint.y)
+                break;
+            }
+            if (i < psValues->nRight) {
+              msFree(pszLabel);
+              continue;
+            }
+          }
+          if (psValues->pasRight == NULL) {
+            psValues->pasRight = (pointObj *)msSmallMalloc(sizeof(pointObj));
+            psValues->papszRightLabels = (char **)msSmallMalloc(sizeof(char *));
+            psValues->nRight = 1;
+          } else {
+            psValues->nRight++;
+            psValues->pasRight = (pointObj *)msSmallRealloc(
+                psValues->pasRight, sizeof(pointObj) * psValues->nRight);
+            psValues->papszRightLabels = (char **)msSmallRealloc(
+                psValues->papszRightLabels, sizeof(char *) * psValues->nRight);
+          }
+
+          psValues->pasRight[psValues->nRight - 1].x = oLastPoint.x;
+          psValues->pasRight[psValues->nRight - 1].y = oLastPoint.y;
+          psValues->papszRightLabels[psValues->nRight - 1] = pszLabel;
+        }
+      }
+      msFreeShape(&shapegrid);
+      msFreeShape(&tmpshape);
+    }
+    msInitShape(&shapegrid);
+  }
+  msLayerClose(layer);
+  return psValues;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+int msGraticuleLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerInitItemInfo =
+      msGraticuleLayerInitItemInfo; /* should use defaults for item info
+                                       functions */
+  layer->vtable->LayerFreeItemInfo = msGraticuleLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msGraticuleLayerOpen;
+  layer->vtable->LayerIsOpen = msGraticuleLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msGraticuleLayerWhichShapes;
+  layer->vtable->LayerNextShape = msGraticuleLayerNextShape;
+  /* layer->vtable->LayerResultsGetShape, use default */
+  layer->vtable->LayerGetShape = msGraticuleLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msGraticuleLayerClose;
+  layer->vtable->LayerGetItems = msGraticuleLayerGetItems;
+  layer->vtable->LayerGetExtent = msGraticuleLayerGetExtent;
+  layer->vtable->LayerGetAutoStyle = msGraticuleLayerGetAutoStyle;
+  /* layer->vtable->LayerCloseConnection, use default */;
+  layer->vtable->LayerSetTimeFilter = msLayerMakePlainTimeFilter;
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ *
+ */
+static void _FormatLabel(layerObj *pLayer, shapeObj *pShape,
+                         double dDataToFormat) {
+  graticuleObj *pInfo = pLayer->grid;
+  char cBuffer[32];
+  int iDegrees, iMinutes;
+
+  switch (pInfo->ilabeltype) {
+  case lpDDMMSS:
+    iDegrees = (int)dDataToFormat;
+    dDataToFormat = fabs(dDataToFormat - (double)iDegrees);
+    iMinutes = (int)(dDataToFormat * 60.0);
+    dDataToFormat = dDataToFormat - (((double)iMinutes) / 60.0);
+    sprintf(cBuffer, pInfo->labelformat, iDegrees, iMinutes,
+            (int)(dDataToFormat * 3600.0));
+    break;
+  case lpDDMM:
+    iDegrees = (int)dDataToFormat;
+    dDataToFormat = fabs(dDataToFormat - (double)iDegrees);
+    sprintf(cBuffer, pInfo->labelformat, iDegrees, (int)(dDataToFormat * 60.0));
+    break;
+  case lpDD:
+    iDegrees = (int)dDataToFormat;
+    sprintf(cBuffer, pInfo->labelformat, iDegrees);
+    break;
+  case lpDefault:
+  default:
+    sprintf(cBuffer, pInfo->labelformat, dDataToFormat);
+  }
+
+  pShape->text = msStrdup(cBuffer);
+}
+
+/**********************************************************************************************************************
+ *
+ *  Move label position into display area by adjusting underlying shape line.
+ */
+static int _AdjustLabelPosition(layerObj *pLayer, shapeObj *pShape,
+                                msGraticulePosition ePosition) {
+  graticuleObj *pInfo = pLayer->grid;
+  rectObj rectLabel;
+  pointObj ptPoint;
+  double size = -1;
+  char *labeltxt;
+
+  if (pInfo == NULL || pShape == NULL) {
+    msSetError(MS_MISCERR,
+               "Assertion failed: Null shape or non-configured grid!, ",
+               "_AdjustLabelPosition()");
+    return MS_FAILURE;
+  }
+
+  assert(pLayer->class[0] -> numlabels >= 1);
+
+  if (msCheckParentPointer(pLayer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  ptPoint = pShape->line->point[0];
+
+  if (pLayer->project) {
+    if (pLayer->reprojectorLayerToMap == NULL) {
+      pLayer->reprojectorLayerToMap = msProjectCreateReprojector(
+          &pLayer->projection, &pLayer->map->projection);
+    }
+    if (pLayer->reprojectorLayerToMap)
+      msProjectShapeEx(pLayer->reprojectorLayerToMap, pShape);
+
+    /* Poor man detection of reprojection failure */
+    if (msProjIsGeographicCRS(&(pLayer->projection)) !=
+        msProjIsGeographicCRS(&(pLayer->map->projection))) {
+      if (ptPoint.x == pShape->line->point[0].x &&
+          ptPoint.y == pShape->line->point[0].y) {
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  if (pLayer->transform) {
+    msTransformShapeToPixelRound(pShape, pLayer->map->extent,
+                                 pLayer->map->cellsize);
+  }
+
+  size = pLayer->class[0]
+             ->labels[0]
+             ->size; /* TODO someday: adjust minsize/maxsize/resolution*/
+  /* We only use the first label as there's no use (yet) in defining multiple
+   lables for GRID layers, as the only label to represent is the longitude or
+   latitude */
+  labeltxt =
+      msShapeGetLabelAnnotation(pLayer, pShape, pLayer->class[0] -> labels[0]);
+  assert(labeltxt);
+  if (msGetStringSize(pLayer->map, pLayer->class[0] -> labels[0], size,
+                      labeltxt, &rectLabel) != MS_SUCCESS) {
+    free(labeltxt);
+    return MS_FAILURE; /* msSetError already called */
+  }
+  free(labeltxt);
+
+  switch (ePosition) {
+  case posBottom:
+    pShape->line->point[1].y = pLayer->map->height;
+    pShape->line->point[0].y =
+        pLayer->map->height - (fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5);
+    break;
+  case posTop:
+    pShape->line->point[1].y = 0;
+    pShape->line->point[0].y = fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5;
+    break;
+  case posLeft:
+    pShape->line->point[0].x = 0;
+    pShape->line->point[1].x = fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5;
+    break;
+  case posRight:
+    pShape->line->point[1].x = pLayer->map->width;
+    pShape->line->point[0].x =
+        pLayer->map->width - (fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5);
+    break;
+  }
+
+  if (pLayer->transform)
+    msTransformPixelToShape(pShape, pLayer->map->extent, pLayer->map->cellsize);
+
+  if (pLayer->project) {
+    /* Clamp coordinates into the validity area of the projection, in the */
+    /* particular case of EPSG:3857 (WebMercator) to longlat reprojection */
+    if (strstr(pLayer->map->projection.args[0], "epsg:3857") &&
+        msProjIsGeographicCRS(&(pLayer->projection))) {
+      if (!pLayer->map->projection.gt.need_geotransform &&
+          ePosition == posLeft && pShape->line->point[0].x < -20037508) {
+        pShape->line->point[1].x =
+            -20037508 + (pShape->line->point[1].x - pShape->line->point[0].x);
+        pShape->line->point[0].x = -20037508;
+      } else if (pLayer->map->projection.gt.need_geotransform &&
+                 ePosition == posLeft &&
+                 pLayer->map->projection.gt.geotransform[0] +
+                         pShape->line->point[0].x *
+                             pLayer->map->projection.gt.geotransform[1] +
+                         pShape->line->point[0].y *
+                             pLayer->map->projection.gt.geotransform[2] <
+                     -20037508) {
+        double y_tmp;
+        double width = pShape->line->point[1].x - pShape->line->point[0].x;
+
+        y_tmp = pLayer->map->projection.gt.geotransform[3] +
+                pShape->line->point[0].x *
+                    pLayer->map->projection.gt.geotransform[4] +
+                pShape->line->point[0].y *
+                    pLayer->map->projection.gt.geotransform[5];
+        pShape->line->point[0].x =
+            pLayer->map->projection.gt.invgeotransform[0] +
+            -20037508 * pLayer->map->projection.gt.invgeotransform[1] +
+            y_tmp * pLayer->map->projection.gt.invgeotransform[2];
+        pShape->line->point[1].x = pShape->line->point[0].x + width;
+      }
+
+      if (!pLayer->map->projection.gt.need_geotransform &&
+          ePosition == posRight && pShape->line->point[1].x > 20037508) {
+        pShape->line->point[0].x =
+            20037508 - (pShape->line->point[1].x - pShape->line->point[0].x);
+        pShape->line->point[1].x = 20037508;
+      } else if (pLayer->map->projection.gt.need_geotransform &&
+                 ePosition == posRight &&
+                 pLayer->map->projection.gt.geotransform[0] +
+                         pShape->line->point[1].x *
+                             pLayer->map->projection.gt.geotransform[1] +
+                         pShape->line->point[1].y *
+                             pLayer->map->projection.gt.geotransform[2] >
+                     20037508) {
+        double y_tmp;
+        double width = pShape->line->point[1].x - pShape->line->point[0].x;
+
+        y_tmp = pLayer->map->projection.gt.geotransform[3] +
+                pShape->line->point[1].x *
+                    pLayer->map->projection.gt.geotransform[4] +
+                pShape->line->point[1].y *
+                    pLayer->map->projection.gt.geotransform[5];
+        pShape->line->point[1].x =
+            pLayer->map->projection.gt.invgeotransform[0] +
+            20037508 * pLayer->map->projection.gt.invgeotransform[1] +
+            y_tmp * pLayer->map->projection.gt.invgeotransform[2];
+        pShape->line->point[0].x = pShape->line->point[1].x - width;
+      }
+    }
+
+    if (pLayer->reprojectorMapToLayer == NULL) {
+      pLayer->reprojectorMapToLayer = msProjectCreateReprojector(
+          &pLayer->map->projection, &pLayer->projection);
+    }
+    if (pLayer->reprojectorMapToLayer)
+      msProjectShapeEx(pLayer->reprojectorMapToLayer, pShape);
+  }
+
+  switch (ePosition) {
+  case posBottom:
+  case posTop:
+    pShape->line->point[1].x = ptPoint.x;
+    pShape->line->point[0].x = ptPoint.x;
+    break;
+  case posLeft:
+  case posRight:
+    pShape->line->point[1].y = ptPoint.y;
+    pShape->line->point[0].y = ptPoint.y;
+    break;
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************************************************************
+ **********************************************************************************************************************
+ * DefineAxes - Copyright (c) 2000, Michael P.D. Bramley.
+ *
+ * Permission is granted to use this code without restriction as long as
+ * this copyright notice appears in all source files.
+ *
+ * Minor tweaks to incrment calculations - jnovak
+ */
+void DefineAxis(int iTickCountTarget, double *Min, double *Max, double *Inc) {
+  /* define local variables... */
+
+  double Test_inc,         /* candidate increment value */
+      Test_min,            /* minimum scale value */
+      Test_max,            /* maximum scale value */
+      Range = *Max - *Min; /* range of data */
+
+  int i = 0; /* counter */
+
+  /* don't create problems -- solve them */
+
+  if (Range < 0) {
+    *Inc = 0;
+    return;
+  }
+
+  /* handle special case of repeated values */
+
+  else if (Range == 0) {
+    *Min = ceil(*Max) - 1;
+    *Max = *Min + 1;
+    *Inc = 1;
+    return;
+  }
+
+  /* compute candidate for increment */
+
+  Test_inc = pow(10.0, ceil(log10(Range / 10)));
+  if (*Inc > 0 && (Test_inc < *Inc || Test_inc > *Inc))
+    Test_inc = *Inc;
+
+  /* establish maximum scale value... */
+  Test_max = ((long)(*Max / Test_inc)) * Test_inc;
+
+  if (Test_max < *Max)
+    Test_max += Test_inc;
+
+  /* establish minimum scale value... */
+  Test_min = Test_max;
+  do {
+    ++i;
+    Test_min -= Test_inc;
+  } while (Test_min > *Min);
+
+  /* subtracting small values can screw up the scale limits, */
+  /* eg: if DefineAxis is called with (min,max)=(0.01, 0.1), */
+  /* then the calculated scale is 1.0408E17 TO 0.05 BY 0.01. */
+  /* the following if statment corrects for this... */
+
+  /* if(fabs(Test_min) < 1E-10) */
+  /* Test_min = 0 ; */
+
+  /* adjust for too few tick marks */
+
+  if (iTickCountTarget <= 0)
+    iTickCountTarget = MAPGRATICULE_ARC_MINIMUM;
+
+  while (i < iTickCountTarget) {
+    Test_inc /= 2;
+    i *= 2;
+  }
+
+  if (i < 6 && 0) {
+    Test_inc /= 2;
+    if ((Test_min + Test_inc) <= *Min)
+      Test_min += Test_inc;
+    if ((Test_max - Test_inc) >= *Max)
+      Test_max -= Test_inc;
+  }
+
+  /* pass back axis definition to caller */
+
+  *Min = Test_min;
+  *Max = Test_max;
+  *Inc = Test_inc;
+}
+
+/**********************************************************************************************************************
+ **********************************************************************************************************************/
diff -pruN 8.0.1-5/src/maphash.c 8.2.0~beta1-1~exp1/src/maphash.c
--- 8.0.1-5/src/maphash.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maphash.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,246 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implement hashTableObj class.
+ * Author:   Sean Gillies, sgillies@frii.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <ctype.h>
+
+#include "mapserver.h"
+#include "maphash.h"
+
+static unsigned hash(const char *key) {
+  unsigned hashval;
+
+  for (hashval = 0; *key != '\0'; key++)
+    hashval = tolower(*key) + 31 * hashval;
+
+  return (hashval % MS_HASHSIZE);
+}
+
+hashTableObj *msCreateHashTable() {
+  int i;
+  hashTableObj *table;
+
+  table = (hashTableObj *)msSmallMalloc(sizeof(hashTableObj));
+  table->items =
+      (struct hashObj **)msSmallMalloc(sizeof(struct hashObj *) * MS_HASHSIZE);
+
+  for (i = 0; i < MS_HASHSIZE; i++)
+    table->items[i] = NULL;
+  table->numitems = 0;
+
+  return table;
+}
+
+int initHashTable(hashTableObj *table) {
+  int i;
+
+  table->items =
+      (struct hashObj **)malloc(sizeof(struct hashObj *) * MS_HASHSIZE);
+  MS_CHECK_ALLOC(table->items, sizeof(struct hashObj *) * MS_HASHSIZE,
+                 MS_FAILURE);
+
+  for (i = 0; i < MS_HASHSIZE; i++)
+    table->items[i] = NULL;
+  table->numitems = 0;
+  return MS_SUCCESS;
+}
+
+void msFreeHashTable(hashTableObj *table) {
+  if (table != NULL) {
+    msFreeHashItems(table);
+    free(table);
+  }
+}
+
+int msHashIsEmpty(const hashTableObj *table) {
+  if (table->numitems == 0)
+    return MS_TRUE;
+  else
+    return MS_FALSE;
+}
+
+void msFreeHashItems(hashTableObj *table) {
+  int i;
+  struct hashObj *tp = NULL;
+  struct hashObj *prev_tp = NULL;
+
+  if (table) {
+    if (table->items) {
+      for (i = 0; i < MS_HASHSIZE; i++) {
+        if (table->items[i] != NULL) {
+          for (tp = table->items[i]; tp != NULL;
+               prev_tp = tp, tp = tp->next, free(prev_tp)) {
+            msFree(tp->key);
+            msFree(tp->data);
+          }
+        }
+      }
+      free(table->items);
+      table->items = NULL;
+    } else {
+      msSetError(MS_HASHERR, "No items allocated.", "msFreeHashItems()");
+    }
+  } else {
+    msSetError(MS_HASHERR, "Can't free NULL table", "msFreeHashItems()");
+  }
+}
+
+struct hashObj *msInsertHashTable(hashTableObj *table, const char *key,
+                                  const char *value) {
+  struct hashObj *tp;
+  unsigned hashval;
+
+  if (!table || !key || !value) {
+    msSetError(MS_HASHERR, "Invalid hash table or key", "msInsertHashTable");
+    return NULL;
+  }
+
+  for (tp = table->items[hash(key)]; tp != NULL; tp = tp->next)
+    if (strcasecmp(key, tp->key) == 0)
+      break;
+
+  if (tp == NULL) { /* not found */
+    tp = (struct hashObj *)malloc(sizeof(*tp));
+    MS_CHECK_ALLOC(tp, sizeof(*tp), NULL);
+    tp->key = msStrdup(key);
+    hashval = hash(key);
+    tp->next = table->items[hashval];
+    table->items[hashval] = tp;
+    table->numitems++;
+  } else {
+    free(tp->data);
+  }
+
+  if ((tp->data = msStrdup(value)) == NULL)
+    return NULL;
+
+  return tp;
+}
+
+const char *msLookupHashTable(const hashTableObj *table, const char *key) {
+  struct hashObj *tp;
+
+  if (!table || !key) {
+    return (NULL);
+  }
+
+  for (tp = table->items[hash(key)]; tp != NULL; tp = tp->next)
+    if (strcasecmp(key, tp->key) == 0)
+      return (tp->data);
+
+  return NULL;
+}
+
+int msRemoveHashTable(hashTableObj *table, const char *key) {
+  struct hashObj *tp;
+  struct hashObj *prev_tp = NULL;
+  int status = MS_FAILURE;
+
+  if (!table || !key) {
+    msSetError(MS_HASHERR, "No hash table", "msRemoveHashTable");
+    return MS_FAILURE;
+  }
+
+  tp = table->items[hash(key)];
+  if (!tp) {
+    msSetError(MS_HASHERR, "No such hash entry", "msRemoveHashTable");
+    return MS_FAILURE;
+  }
+
+  prev_tp = NULL;
+  while (tp != NULL) {
+    if (strcasecmp(key, tp->key) == 0) {
+      status = MS_SUCCESS;
+      if (prev_tp) {
+        prev_tp->next = tp->next;
+        msFree(tp->key);
+        msFree(tp->data);
+        free(tp);
+        break;
+      } else {
+        table->items[hash(key)] = tp->next;
+        msFree(tp->key);
+        msFree(tp->data);
+        free(tp);
+        break;
+      }
+    }
+    prev_tp = tp;
+    tp = tp->next;
+  }
+
+  if (status == MS_SUCCESS)
+    table->numitems--;
+
+  return status;
+}
+
+const char *msFirstKeyFromHashTable(const hashTableObj *table) {
+  int hash_index;
+
+  if (!table) {
+    msSetError(MS_HASHERR, "No hash table", "msFirstKeyFromHashTable");
+    return NULL;
+  }
+
+  for (hash_index = 0; hash_index < MS_HASHSIZE; hash_index++) {
+    if (table->items[hash_index] != NULL)
+      return table->items[hash_index]->key;
+  }
+
+  return NULL;
+}
+
+const char *msNextKeyFromHashTable(const hashTableObj *table,
+                                   const char *lastKey) {
+  int hash_index;
+  struct hashObj *link;
+
+  if (!table) {
+    msSetError(MS_HASHERR, "No hash table", "msNextKeyFromHashTable");
+    return NULL;
+  }
+
+  if (lastKey == NULL)
+    return msFirstKeyFromHashTable(table);
+
+  hash_index = hash(lastKey);
+  for (link = table->items[hash_index];
+       link != NULL && strcasecmp(lastKey, link->key) != 0; link = link->next) {
+  }
+
+  if (link != NULL && link->next != NULL)
+    return link->next->key;
+
+  while (++hash_index < MS_HASHSIZE) {
+    if (table->items[hash_index] != NULL)
+      return table->items[hash_index]->key;
+  }
+
+  return NULL;
+}
diff -pruN 8.0.1-5/src/maphash.h 8.2.0~beta1-1~exp1/src/maphash.h
--- 8.0.1-5/src/maphash.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maphash.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,166 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Declarations for the hashTableObj and related stuff.
+ * Author:   Sean Gillies, sgillies@frii.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPHASH__H
+#define MAPHASH__H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#define MS_DLL_EXPORT __declspec(dllexport)
+#else
+#define MS_DLL_EXPORT
+#endif
+
+#define MS_HASHSIZE 41
+
+/* =========================================================================
+ * Structs
+ * ========================================================================= */
+
+#ifndef SWIG
+struct hashObj {
+  struct hashObj *next; /* pointer to next item */
+  char *key;            /* string key that is hashed */
+  char *data;           /* string stored in this item */
+};
+#endif /*SWIG*/
+
+/**
+ * An object to store key-value pairs
+ *
+ */
+typedef struct {
+#ifndef SWIG
+  struct hashObj **items; /* the hash table */
+#endif
+#ifdef SWIG
+    %immutable;
+#endif          /*SWIG*/
+  int numitems; ///< \**immutable** number of items
+#ifdef SWIG
+    %mutable;
+#endif /*SWIG*/
+} hashTableObj;
+
+/* =========================================================================
+ * Functions
+ * ========================================================================= */
+
+#ifndef SWIG
+/* msCreateHashTable - create a hash table
+ * ARGS:
+ *     None
+ * RETURNS:
+ *     New hash table
+ */
+MS_DLL_EXPORT hashTableObj *msCreateHashTable(void);
+
+/* For use in mapfile.c with hashTableObj structure members */
+MS_DLL_EXPORT int initHashTable(hashTableObj *table);
+
+/* msFreeHashTable - free allocated memory
+ * ARGS:
+ *     table - target hash table
+ * RETURNS:
+ *     None
+ */
+MS_DLL_EXPORT void msFreeHashTable(hashTableObj *table);
+
+/* Free only the items for hashTableObj structure members (metadata, &c) */
+MS_DLL_EXPORT void msFreeHashItems(hashTableObj *table);
+
+/* msInsertHashTable - insert new item
+ * ARGS:
+ *     table - the target hash table
+ *     key   - key string for new item
+ *     value - data string for new item
+ * RETURNS:
+ *     pointer to the new item or NULL
+ * EXCEPTIONS:
+ *     raise MS_HASHERR on failure
+ */
+MS_DLL_EXPORT struct hashObj *
+msInsertHashTable(hashTableObj *table, const char *key, const char *value);
+
+/* msLookupHashTable - get the value of an item by its key
+ * ARGS:
+ *     table - the target hash table
+ *     key   - key string of item
+ * RETURNS:
+ *     string value of item
+ */
+MS_DLL_EXPORT const char *msLookupHashTable(const hashTableObj *table,
+                                            const char *key);
+
+/* msRemoveHashTable - remove item from table at key
+ * ARGS:
+ *     table - target hash table
+ *     key   - key string
+ * RETURNS:
+ *     MS_SUCCESS or MS_FAILURE
+ */
+MS_DLL_EXPORT int msRemoveHashTable(hashTableObj *table, const char *key);
+
+/* msFirstKeyFromHashTable - get key of first item
+ * ARGS:
+ *     table - target hash table
+ * RETURNS:
+ *     first key as a string
+ */
+MS_DLL_EXPORT const char *msFirstKeyFromHashTable(const hashTableObj *table);
+
+/* msNextKeyFromHashTable - get next key
+ * ARGS:
+ *     table - target hash table
+ *     prevkey - the previous key
+ * RETURNS:
+ *     the key of the item of following prevkey as a string
+ */
+MS_DLL_EXPORT const char *msNextKeyFromHashTable(const hashTableObj *table,
+                                                 const char *prevkey);
+
+/* msHashIsEmpty - get next key
+ * ARGS:
+ *     table - target hash table
+ * RETURNS:
+ *     MS_TRUE if the table is empty and MS_FALSE if the table has items
+ */
+
+MS_DLL_EXPORT int msHashIsEmpty(const hashTableObj *table);
+
+#endif /*SWIG*/
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPHASH__H */
diff -pruN 8.0.1-5/src/maphttp.c 8.2.0~beta1-1~exp1/src/maphttp.c
--- 8.0.1-5/src/maphttp.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maphttp.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,972 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Utility functions to access files via HTTP (requires libcurl)
+ * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2001-2003, Daniel Morissette, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#define NEED_IGNORE_RET_VAL
+
+/* For now this code is enabled only when WMS/WFS client is enabled.
+ * This should be changed to a test on the presence of libcurl which
+ * is really what the real dependency is.
+ */
+#include "mapserver-config.h"
+#if defined(USE_CURL)
+
+#include "mapserver.h"
+#include "maphttp.h"
+#include "maperror.h"
+#include "mapthread.h"
+#include "mapows.h"
+
+#include "cpl_conv.h"
+
+#include <time.h>
+#ifndef _WIN32
+#include <sys/time.h>
+#include <unistd.h>
+
+#endif
+
+/*
+ * Note: This code uses libcurl to access remote files via the HTTP protocol.
+ * Requires libcurl v 7.10 or more recent.
+ * See http://curl.haxx.se/libcurl/c/ for the lib source code and docs.
+ */
+#include <curl/curl.h>
+
+#ifndef CURL_AT_LEAST_VERSION
+#define CURL_VERSION_BITS(x, y, z) ((x) << 16 | (y) << 8 | z)
+#define CURL_AT_LEAST_VERSION(x, y, z)                                         \
+  (LIBCURL_VERSION_NUM >= CURL_VERSION_BITS(x, y, z))
+#endif // #ifndef CURL_AT_LEAST_VERSION
+
+#define unchecked_curl_easy_setopt(handle, opt, param)                         \
+  IGNORE_RET_VAL(curl_easy_setopt(handle, opt, param))
+
+/**********************************************************************
+ *                          msHTTPInit()
+ *
+ * This function is called to init libcurl before the first HTTP request
+ * in this process is executed.
+ * On further calls (when gbCurlInitialized = MS_TRUE) it simply doest nothing.
+ *
+ * Returns MS_SUCCESS/MS_FAILURE.
+ *
+ * msHTTPCleanup() will have to be called in msCleanup() when this process
+ * exits.
+ **********************************************************************/
+static int gbCurlInitialized = MS_FALSE;
+
+int msHTTPInit() {
+  /* curl_global_init() should only be called once (no matter how
+   * many threads or libcurl sessions that'll be used) by every
+   * application that uses libcurl.
+   */
+
+  msAcquireLock(TLOCK_OWS);
+  if (!gbCurlInitialized && curl_global_init(CURL_GLOBAL_ALL) != 0) {
+    msReleaseLock(TLOCK_OWS);
+    msSetError(MS_HTTPERR, "Libcurl initialization failed.", "msHTTPInit()");
+    return MS_FAILURE;
+  }
+
+  gbCurlInitialized = MS_TRUE;
+
+  msReleaseLock(TLOCK_OWS);
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                          msHTTPCleanup()
+ *
+ **********************************************************************/
+void msHTTPCleanup() {
+  msAcquireLock(TLOCK_OWS);
+  if (gbCurlInitialized)
+    curl_global_cleanup();
+
+  gbCurlInitialized = MS_FALSE;
+  msReleaseLock(TLOCK_OWS);
+}
+
+/**********************************************************************
+ *                          msHTTPInitRequestObj()
+ *
+ * Should be called on a new array of httpRequestObj to initialize them
+ * for use with msHTTPExecuteRequest(), etc.
+ *
+ **********************************************************************/
+void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests) {
+  int i;
+
+  for (i = 0; i < numRequests; i++) {
+    pasReqInfo[i].pszGetUrl = NULL;
+    pasReqInfo[i].pszPostRequest = NULL;
+    pasReqInfo[i].pszPostContentType = NULL;
+    pasReqInfo[i].pszOutputFile = NULL;
+    pasReqInfo[i].nLayerId = 0;
+    pasReqInfo[i].nTimeout = 0;
+    pasReqInfo[i].nMaxBytes = 0;
+    pasReqInfo[i].nStatus = 0;
+    pasReqInfo[i].pszContentType = NULL;
+    pasReqInfo[i].pszErrBuf = NULL;
+    pasReqInfo[i].pszUserAgent = NULL;
+    pasReqInfo[i].pszHTTPCookieData = NULL;
+    pasReqInfo[i].pszProxyAddress = NULL;
+    pasReqInfo[i].pszProxyUsername = NULL;
+    pasReqInfo[i].pszProxyPassword = NULL;
+    pasReqInfo[i].pszHttpUsername = NULL;
+    pasReqInfo[i].pszHttpPassword = NULL;
+
+    pasReqInfo[i].debug = MS_FALSE;
+
+    pasReqInfo[i].curl_handle = NULL;
+    pasReqInfo[i].fp = NULL;
+    pasReqInfo[i].result_data = NULL;
+    pasReqInfo[i].result_size = 0;
+    pasReqInfo[i].result_buf_size = 0;
+  }
+}
+
+/**********************************************************************
+ *                          msHTTPFreeRequestObj()
+ *
+ **********************************************************************/
+void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests) {
+  int i;
+  for (i = 0; i < numRequests; i++) {
+    if (pasReqInfo[i].pszGetUrl)
+      free(pasReqInfo[i].pszGetUrl);
+    pasReqInfo[i].pszGetUrl = NULL;
+
+    if (pasReqInfo[i].pszPostRequest)
+      free(pasReqInfo[i].pszPostRequest);
+    pasReqInfo[i].pszPostRequest = NULL;
+
+    if (pasReqInfo[i].pszPostContentType)
+      free(pasReqInfo[i].pszPostContentType);
+    pasReqInfo[i].pszPostContentType = NULL;
+
+    if (pasReqInfo[i].pszOutputFile)
+      free(pasReqInfo[i].pszOutputFile);
+    pasReqInfo[i].pszOutputFile = NULL;
+
+    if (pasReqInfo[i].pszContentType)
+      free(pasReqInfo[i].pszContentType);
+    pasReqInfo[i].pszContentType = NULL;
+
+    if (pasReqInfo[i].pszErrBuf)
+      free(pasReqInfo[i].pszErrBuf);
+    pasReqInfo[i].pszErrBuf = NULL;
+
+    if (pasReqInfo[i].pszUserAgent)
+      free(pasReqInfo[i].pszUserAgent);
+    pasReqInfo[i].pszUserAgent = NULL;
+
+    if (pasReqInfo[i].pszHTTPCookieData)
+      free(pasReqInfo[i].pszHTTPCookieData);
+    pasReqInfo[i].pszHTTPCookieData = NULL;
+
+    pasReqInfo[i].curl_handle = NULL;
+
+    free(pasReqInfo[i].result_data);
+    pasReqInfo[i].result_data = NULL;
+    pasReqInfo[i].result_size = 0;
+    pasReqInfo[i].result_buf_size = 0;
+  }
+}
+
+/**********************************************************************
+ *                          msHTTPWriteFct()
+ *
+ * CURL_OPTWRITEFUNCTION, called to write blocks of data to the file we
+ * are downloading.  Should return the number of bytes that were taken
+ * care of.  If that  amount  differs  from  the  amount passed to it
+ * it'll signal an error to the library and it will abort the transfer
+ * and produce a CURLE_WRITE_ERROR.
+ *
+ **********************************************************************/
+static size_t msHTTPWriteFct(void *buffer, size_t size, size_t nmemb,
+                             void *reqInfo) {
+  httpRequestObj *psReq;
+
+  psReq = (httpRequestObj *)reqInfo;
+
+  if (psReq->debug) {
+    msDebug("msHTTPWriteFct(id=%d, %d bytes)\n", psReq->nLayerId,
+            (int)(size * nmemb));
+  }
+
+  if (psReq->nMaxBytes > 0 &&
+      (psReq->result_size + size * nmemb) > (size_t)psReq->nMaxBytes) {
+    msSetError(MS_HTTPERR,
+               "Requested transfer larger than configured maximum %d.",
+               "msHTTPWriteFct()", psReq->nMaxBytes);
+    return -1;
+  }
+  /* Case where we are writing to a disk file. */
+  if (psReq->fp != NULL) {
+    psReq->result_size += size * nmemb;
+    return fwrite(buffer, size, nmemb, psReq->fp);
+  }
+
+  /* Case where we build up the result in memory */
+  else {
+    if (psReq->result_data == NULL) {
+      psReq->result_buf_size = size * nmemb + 10000;
+      psReq->result_data = (char *)msSmallMalloc(psReq->result_buf_size);
+    } else if (psReq->result_size + nmemb * size >
+               (size_t)psReq->result_buf_size) {
+      psReq->result_buf_size = psReq->result_size + nmemb * size + 10000;
+      psReq->result_data =
+          (char *)msSmallRealloc(psReq->result_data, psReq->result_buf_size);
+    }
+
+    if (psReq->result_data == NULL) {
+      msSetError(MS_HTTPERR, "Unable to grow HTTP result buffer to size %d.",
+                 "msHTTPWriteFct()", psReq->result_buf_size);
+      psReq->result_buf_size = 0;
+      psReq->result_size = 0;
+      return -1;
+    }
+
+    memcpy(psReq->result_data + psReq->result_size, buffer, size * nmemb);
+    psReq->result_size += size * nmemb;
+
+    return size * nmemb;
+  }
+}
+
+/**********************************************************************
+ *                          msGetCURLAuthType()
+ *
+ * Returns the equivalent CURL CURLAUTH_ constant given a
+ * MS_HTTP_AUTH_TYPE, or CURLAUTH_BASIC if no match is found.
+ **********************************************************************/
+long msGetCURLAuthType(enum MS_HTTP_AUTH_TYPE authType) {
+  switch (authType) {
+  case MS_BASIC:
+    return CURLAUTH_BASIC;
+  case MS_DIGEST:
+    return CURLAUTH_DIGEST;
+  case MS_NTLM:
+    return CURLAUTH_NTLM;
+  case MS_ANY:
+    return CURLAUTH_ANY;
+  case MS_ANYSAFE:
+    return CURLAUTH_ANYSAFE;
+  default:
+    return CURLAUTH_BASIC;
+  }
+}
+
+/**********************************************************************
+ *                          msHTTPAuthProxySetup()
+ *
+ * Common code used by msPrepareWFSLayerRequest() and
+ * msPrepareWMSLayerRequest() to handle proxy / http auth for requests
+ *
+ * Return value:
+ * MS_SUCCESS if all requests completed succesfully.
+ * MS_FAILURE if a fatal error happened
+ **********************************************************************/
+int msHTTPAuthProxySetup(hashTableObj *mapmd, hashTableObj *lyrmd,
+                         httpRequestObj *pasReqInfo, int numRequests,
+                         mapObj *map, const char *namespaces) {
+
+  const char *pszTmp;
+  char *pszProxyHost = NULL;
+  long nProxyPort = 0;
+  char *pszProxyUsername = NULL, *pszProxyPassword = NULL;
+  char *pszHttpAuthUsername = NULL, *pszHttpAuthPassword = NULL;
+  enum MS_HTTP_AUTH_TYPE eHttpAuthType = MS_BASIC;
+  enum MS_HTTP_AUTH_TYPE eProxyAuthType = MS_BASIC;
+  enum MS_HTTP_PROXY_TYPE eProxyType = MS_HTTP;
+
+  /* ------------------------------------------------------------------
+   * Check for authentication and proxying metadata. If the metadata is not
+   * found in the layer metadata, check the map-level metadata.
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "proxy_host")) !=
+      NULL) {
+    pszProxyHost = msStrdup(pszTmp);
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "proxy_port")) !=
+      NULL) {
+    nProxyPort = atol(pszTmp);
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "proxy_type")) !=
+      NULL) {
+
+    if (strcasecmp(pszTmp, "HTTP") == 0)
+      eProxyType = MS_HTTP;
+    else if (strcasecmp(pszTmp, "SOCKS5") == 0)
+      eProxyType = MS_SOCKS5;
+    else {
+      msSetError(MS_WMSERR, "Invalid proxy_type metadata '%s' specified",
+                 "msHTTPAuthProxySetup()", pszTmp);
+      return MS_FAILURE;
+    }
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
+                                     "proxy_auth_type")) != NULL) {
+    if (strcasecmp(pszTmp, "BASIC") == 0)
+      eProxyAuthType = MS_BASIC;
+    else if (strcasecmp(pszTmp, "DIGEST") == 0)
+      eProxyAuthType = MS_DIGEST;
+    else if (strcasecmp(pszTmp, "NTLM") == 0)
+      eProxyAuthType = MS_NTLM;
+    else if (strcasecmp(pszTmp, "ANY") == 0)
+      eProxyAuthType = MS_ANY;
+    else if (strcasecmp(pszTmp, "ANYSAFE") == 0)
+      eProxyAuthType = MS_ANYSAFE;
+    else {
+      msSetError(MS_WMSERR, "Invalid proxy_auth_type metadata '%s' specified",
+                 "msHTTPAuthProxySetup()", pszTmp);
+      return MS_FAILURE;
+    }
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
+                                     "proxy_username")) != NULL) {
+    pszProxyUsername = msStrdup(pszTmp);
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
+                                     "proxy_password")) != NULL) {
+    pszProxyPassword = msDecryptStringTokens(map, pszTmp);
+    if (pszProxyPassword == NULL) {
+      msFree(pszProxyHost);
+      msFree(pszProxyUsername);
+      return (MS_FAILURE); /* An error should already have been produced */
+    }
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "auth_type")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "BASIC") == 0)
+      eHttpAuthType = MS_BASIC;
+    else if (strcasecmp(pszTmp, "DIGEST") == 0)
+      eHttpAuthType = MS_DIGEST;
+    else if (strcasecmp(pszTmp, "NTLM") == 0)
+      eHttpAuthType = MS_NTLM;
+    else if (strcasecmp(pszTmp, "ANY") == 0)
+      eHttpAuthType = MS_ANY;
+    else if (strcasecmp(pszTmp, "ANYSAFE") == 0)
+      eHttpAuthType = MS_ANYSAFE;
+    else {
+      msSetError(MS_WMSERR, "Invalid auth_type metadata '%s' specified",
+                 "msHTTPAuthProxySetup()", pszTmp);
+      return MS_FAILURE;
+    }
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
+                                     "auth_username")) != NULL) {
+    pszHttpAuthUsername = msStrdup(pszTmp);
+  }
+
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
+                                     "auth_password")) != NULL) {
+    pszHttpAuthPassword = msDecryptStringTokens(map, pszTmp);
+    if (pszHttpAuthPassword == NULL) {
+      msFree(pszHttpAuthUsername);
+      msFree(pszProxyHost);
+      msFree(pszProxyUsername);
+      msFree(pszProxyPassword);
+      return (MS_FAILURE); /* An error should already have been produced */
+    }
+  }
+
+  pasReqInfo[numRequests].pszProxyAddress = pszProxyHost;
+  pasReqInfo[numRequests].nProxyPort = nProxyPort;
+  pasReqInfo[numRequests].eProxyType = eProxyType;
+  pasReqInfo[numRequests].eProxyAuthType = eProxyAuthType;
+  pasReqInfo[numRequests].pszProxyUsername = pszProxyUsername;
+  pasReqInfo[numRequests].pszProxyPassword = pszProxyPassword;
+  pasReqInfo[numRequests].eHttpAuthType = eHttpAuthType;
+  pasReqInfo[numRequests].pszHttpUsername = pszHttpAuthUsername;
+  pasReqInfo[numRequests].pszHttpPassword = pszHttpAuthPassword;
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                          msHTTPExecuteRequests()
+ *
+ * Fetch a map slide via HTTP request and save to specified temp file.
+ *
+ * If bCheckLocalCache==MS_TRUE then if the pszOutputfile already exists
+ * then it is not downloaded again, and status 242 is returned.
+ *
+ * Return value:
+ * MS_SUCCESS if all requests completed successfully.
+ * MS_FAILURE if a fatal error happened
+ * MS_DONE if some requests failed with 40x status for instance (not fatal)
+ **********************************************************************/
+int msHTTPExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
+                          int bCheckLocalCache) {
+  int i, nStatus = MS_SUCCESS, nTimeout, still_running = 0, num_msgs = 0;
+  CURLM *multi_handle;
+  CURLMsg *curl_msg;
+  char debug = MS_FALSE;
+  const char *pszCurlCABundle = NULL;
+
+  if (numRequests == 0)
+    return MS_SUCCESS; /* Nothing to do */
+
+  if (!gbCurlInitialized)
+    msHTTPInit();
+
+  /* Establish the timeout (seconds) for how long we are going to wait
+   * for a response.
+   * We use the longest timeout value in the array of requests
+   */
+  nTimeout = pasReqInfo[0].nTimeout;
+  for (i = 0; i < numRequests; i++) {
+    if (pasReqInfo[i].nTimeout > nTimeout)
+      nTimeout = pasReqInfo[i].nTimeout;
+
+    if (pasReqInfo[i].debug)
+      debug = MS_TRUE; /* For the download loop */
+  }
+
+  if (nTimeout <= 0)
+    nTimeout = 30;
+
+  /* Check if we've got a CURL_CA_BUNDLE env. var.
+   * If set then the value is the full path to the ca-bundle.crt file
+   * e.g. CURL_CA_BUNDLE=/usr/local/share/curl/curl-ca-bundle.crt
+   */
+  pszCurlCABundle = CPLGetConfigOption("CURL_CA_BUNDLE", NULL);
+
+  if (debug) {
+    msDebug("HTTP: Starting to prepare HTTP requests.\n");
+    if (pszCurlCABundle)
+      msDebug("Using CURL_CA_BUNDLE=%s\n", pszCurlCABundle);
+  }
+
+  const char *pszHttpVersion = CPLGetConfigOption("CURL_HTTP_VERSION", NULL);
+
+  /* Alloc a curl-multi handle, and add a curl-easy handle to it for each
+   * file to download.
+   */
+  multi_handle = curl_multi_init();
+  if (multi_handle == NULL) {
+    msSetError(MS_HTTPERR, "curl_multi_init() failed.",
+               "msHTTPExecuteRequests()");
+    return (MS_FAILURE);
+  }
+
+  for (i = 0; i < numRequests; i++) {
+    CURL *http_handle;
+    FILE *fp;
+
+    if (pasReqInfo[i].pszGetUrl == NULL) {
+      msSetError(MS_HTTPERR, "URL or output file parameter missing.",
+                 "msHTTPExecuteRequests()");
+      return (MS_FAILURE);
+    }
+
+    if (pasReqInfo[i].debug) {
+      msDebug("HTTP request: id=%d, %s\n", pasReqInfo[i].nLayerId,
+              pasReqInfo[i].pszGetUrl);
+    }
+
+    /* Reset some members */
+    pasReqInfo[i].nStatus = 0;
+    if (pasReqInfo[i].pszContentType)
+      free(pasReqInfo[i].pszContentType);
+    pasReqInfo[i].pszContentType = NULL;
+
+    /* Check local cache if requested */
+    if (bCheckLocalCache && pasReqInfo[i].pszOutputFile != NULL) {
+      fp = fopen(pasReqInfo[i].pszOutputFile, "r");
+      if (fp) {
+        /* File already there, don't download again. */
+        if (pasReqInfo[i].debug)
+          msDebug("HTTP request: id=%d, found in cache, skipping.\n",
+                  pasReqInfo[i].nLayerId);
+        fclose(fp);
+        pasReqInfo[i].nStatus = 242;
+        pasReqInfo[i].pszContentType = msStrdup("unknown/cached");
+        continue;
+      }
+    }
+
+    /* Alloc curl handle */
+    http_handle = curl_easy_init();
+    if (http_handle == NULL) {
+      msSetError(MS_HTTPERR, "curl_easy_init() failed.",
+                 "msHTTPExecuteRequests()");
+      return (MS_FAILURE);
+    }
+
+    pasReqInfo[i].curl_handle = http_handle;
+
+    /* set URL, note that curl keeps only a ref to our string buffer */
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL,
+                               pasReqInfo[i].pszGetUrl);
+
+#if CURL_AT_LEAST_VERSION(7, 85, 0)
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_PROTOCOLS_STR,
+                               "http,https");
+#else
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_PROTOCOLS,
+                               CURLPROTO_HTTP | CURLPROTO_HTTPS);
+#endif
+
+    if (pszHttpVersion && strcmp(pszHttpVersion, "1.0") == 0)
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
+                                 CURL_HTTP_VERSION_1_0);
+    else if (pszHttpVersion && strcmp(pszHttpVersion, "1.1") == 0)
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
+                                 CURL_HTTP_VERSION_1_1);
+
+    /* Set User-Agent (auto-generate if not set by caller */
+    if (pasReqInfo[i].pszUserAgent == NULL) {
+      curl_version_info_data *psCurlVInfo;
+
+      psCurlVInfo = curl_version_info(CURLVERSION_NOW);
+
+      pasReqInfo[i].pszUserAgent = (char *)msSmallMalloc(100 * sizeof(char));
+
+      if (pasReqInfo[i].pszUserAgent) {
+        sprintf(pasReqInfo[i].pszUserAgent, "MapServer/%s libcurl/%d.%d.%d",
+                MS_VERSION, psCurlVInfo->version_num / 0x10000 & 0xff,
+                psCurlVInfo->version_num / 0x100 & 0xff,
+                psCurlVInfo->version_num & 0xff);
+      }
+    }
+    if (pasReqInfo[i].pszUserAgent) {
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_USERAGENT,
+                                 pasReqInfo[i].pszUserAgent);
+    }
+
+    /* Enable following redirections.  Requires libcurl 7.10.1 at least */
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_FOLLOWLOCATION, 1);
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_MAXREDIRS, 10);
+
+    /* Set timeout.*/
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_TIMEOUT, nTimeout);
+
+    /* Pass CURL_CA_BUNDLE if set */
+    if (pszCurlCABundle)
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_CAINFO, pszCurlCABundle);
+
+    /* Set proxying settings */
+    if (pasReqInfo[i].pszProxyAddress != NULL &&
+        strlen(pasReqInfo[i].pszProxyAddress) > 0) {
+      long nProxyType = CURLPROXY_HTTP;
+
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXY,
+                                 pasReqInfo[i].pszProxyAddress);
+
+      if (pasReqInfo[i].nProxyPort > 0 && pasReqInfo[i].nProxyPort < 65535) {
+        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYPORT,
+                                   pasReqInfo[i].nProxyPort);
+      }
+
+      switch (pasReqInfo[i].eProxyType) {
+      case MS_HTTP:
+        nProxyType = CURLPROXY_HTTP;
+        break;
+      case MS_SOCKS5:
+        nProxyType = CURLPROXY_SOCKS5;
+        break;
+      }
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYTYPE, nProxyType);
+
+      /* If there is proxy authentication information, set it */
+      if (pasReqInfo[i].pszProxyUsername != NULL &&
+          pasReqInfo[i].pszProxyPassword != NULL &&
+          strlen(pasReqInfo[i].pszProxyUsername) > 0 &&
+          strlen(pasReqInfo[i].pszProxyPassword) > 0) {
+        char szUsernamePasswd[128];
+#if LIBCURL_VERSION_NUM >= 0x070a07
+        long nProxyAuthType = CURLAUTH_BASIC;
+        /* CURLOPT_PROXYAUTH available only in Curl 7.10.7 and up */
+        nProxyAuthType = msGetCURLAuthType(pasReqInfo[i].eProxyAuthType);
+        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYAUTH,
+                                   nProxyAuthType);
+#else
+        /* We log an error but don't abort processing */
+        msSetError(MS_HTTPERR,
+                   "CURLOPT_PROXYAUTH not supported. Requires Curl 7.10.7 and "
+                   "up. *_proxy_auth_type setting ignored.",
+                   "msHTTPExecuteRequests()");
+#endif /* LIBCURL_VERSION_NUM */
+
+        snprintf(szUsernamePasswd, 127, "%s:%s", pasReqInfo[i].pszProxyUsername,
+                 pasReqInfo[i].pszProxyPassword);
+        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYUSERPWD,
+                                   szUsernamePasswd);
+      }
+    }
+
+    /* Set HTTP Authentication settings */
+    if (pasReqInfo[i].pszHttpUsername != NULL &&
+        pasReqInfo[i].pszHttpPassword != NULL &&
+        strlen(pasReqInfo[i].pszHttpUsername) > 0 &&
+        strlen(pasReqInfo[i].pszHttpPassword) > 0) {
+      char szUsernamePasswd[128];
+      long nHttpAuthType = CURLAUTH_BASIC;
+
+      snprintf(szUsernamePasswd, 127, "%s:%s", pasReqInfo[i].pszHttpUsername,
+               pasReqInfo[i].pszHttpPassword);
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_USERPWD,
+                                 szUsernamePasswd);
+
+      nHttpAuthType = msGetCURLAuthType(pasReqInfo[i].eHttpAuthType);
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTPAUTH, nHttpAuthType);
+    }
+
+    /* NOSIGNAL should be set to true for timeout to work in multithread
+     * environments on Unix, requires libcurl 7.10 or more recent.
+     * (this force avoiding the use of sgnal handlers)
+     */
+#ifdef CURLOPT_NOSIGNAL
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_NOSIGNAL, 1);
+#endif
+
+    /* If we are writing file to disk, open the file now. */
+    if (pasReqInfo[i].pszOutputFile != NULL) {
+      if ((fp = fopen(pasReqInfo[i].pszOutputFile, "wb")) == NULL) {
+        msSetError(MS_HTTPERR, "Can't open output file %s.",
+                   "msHTTPExecuteRequests()", pasReqInfo[i].pszOutputFile);
+        return (MS_FAILURE);
+      }
+
+      pasReqInfo[i].fp = fp;
+    }
+
+    /* coverity[bad_sizeof] */
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEDATA,
+                               &(pasReqInfo[i]));
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEFUNCTION,
+                               msHTTPWriteFct);
+
+    /* Provide a buffer where libcurl can write human readable error msgs
+     */
+    if (pasReqInfo[i].pszErrBuf == NULL)
+      pasReqInfo[i].pszErrBuf =
+          (char *)msSmallMalloc((CURL_ERROR_SIZE + 1) * sizeof(char));
+    pasReqInfo[i].pszErrBuf[0] = '\0';
+
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_ERRORBUFFER,
+                               pasReqInfo[i].pszErrBuf);
+
+    pasReqInfo[i].curl_headers = NULL;
+
+    if (pasReqInfo[i].pszPostRequest != NULL) {
+      char szBuf[100];
+
+      snprintf(szBuf, 100, "Content-Type: %s",
+               pasReqInfo[i].pszPostContentType);
+      pasReqInfo[i].curl_headers = curl_slist_append(NULL, szBuf);
+
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_POST, 1);
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_POSTFIELDS,
+                                 pasReqInfo[i].pszPostRequest);
+      if (debug) {
+        msDebug("HTTP: POST = %s", pasReqInfo[i].pszPostRequest);
+      }
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTPHEADER,
+                                 pasReqInfo[i].curl_headers);
+    }
+
+    /* Added by RFC-42 HTTP Cookie Forwarding */
+    if (pasReqInfo[i].pszHTTPCookieData != NULL) {
+      /* Check if there's no end of line in the Cookie string */
+      /* This could break the HTTP Header */
+      for (size_t nPos = 0; nPos < strlen(pasReqInfo[i].pszHTTPCookieData);
+           nPos++) {
+        if (pasReqInfo[i].pszHTTPCookieData[nPos] == '\n') {
+          msSetError(MS_HTTPERR,
+                     "Can't use cookie containing a newline character.",
+                     "msHTTPExecuteRequests()");
+          return (MS_FAILURE);
+        }
+      }
+
+      /* Set the Curl option to send Cookie */
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_COOKIE,
+                                 pasReqInfo[i].pszHTTPCookieData);
+    }
+
+    /* Add to multi handle */
+    curl_multi_add_handle(multi_handle, http_handle);
+  }
+
+  if (debug) {
+    msDebug("HTTP: Before download loop\n");
+  }
+
+  /* DOWNLOAD LOOP ... inspired from multi-double.c example */
+
+  /* we start some action by calling perform right away */
+  while (CURLM_CALL_MULTI_PERFORM ==
+         curl_multi_perform(multi_handle, &still_running))
+    ;
+
+  while (still_running) {
+    struct timeval timeout;
+    int rc; /* select() return code */
+
+    fd_set fdread;
+    fd_set fdwrite;
+    fd_set fdexcep;
+    int maxfd;
+
+    FD_ZERO(&fdread);
+    FD_ZERO(&fdwrite);
+    FD_ZERO(&fdexcep);
+
+    /* set a suitable timeout to play around with */
+    timeout.tv_sec = 0;
+    timeout.tv_usec = 100000;
+
+    /* get file descriptors from the transfers */
+    curl_multi_fdset(multi_handle, &fdread, &fdwrite, &fdexcep, &maxfd);
+
+    rc = select(maxfd + 1, &fdread, &fdwrite, &fdexcep, &timeout);
+
+    switch (rc) {
+    case -1:
+      /* select error */
+
+      /* ==================================================================== */
+      /*      On Windows the select function (just above) returns -1 when     */
+      /*      it is called the second time and all the calls after            */
+      /*      that. This causes an infinite loop.                             */
+      /*      I do not really know why.                                       */
+      /*      To solve the problem the break from case -1 has been removed.   */
+      /* ==================================================================== */
+#ifndef _WIN32
+      break;
+#endif
+    case 0:
+    default:
+      /* timeout or readable/writable sockets */
+      curl_multi_perform(multi_handle, &still_running);
+      break;
+    }
+  }
+
+  if (debug)
+    msDebug("HTTP: After download loop\n");
+
+  /* Scan message stack from CURL and report fatal errors*/
+
+  while ((curl_msg = curl_multi_info_read(multi_handle, &num_msgs)) != NULL) {
+    httpRequestObj *psReq = NULL;
+
+    if (curl_msg->msg == CURLMSG_DONE && curl_msg->data.result != CURLE_OK) {
+      /* Something went wrong with this transfer... report error */
+
+      for (i = 0; i < numRequests; i++) {
+        if (pasReqInfo[i].curl_handle == curl_msg->easy_handle) {
+          psReq = &(pasReqInfo[i]);
+          break;
+        }
+      }
+
+      if (psReq != NULL) {
+        /* Record error code in nStatus as a negative value */
+        psReq->nStatus = -curl_msg->data.result;
+      }
+    }
+  }
+
+  if (debug) {
+    /* Print a msDebug header for timings reported in the loop below */
+    msDebug("msHTTPExecuteRequests() timing summary per layer (connect_time + "
+            "time_to_first_packet + download_time = total_time in seconds)\n");
+  }
+
+  /* Check status of all requests, close files, report errors and cleanup
+   * handles
+   */
+  for (i = 0; i < numRequests; i++) {
+    httpRequestObj *psReq;
+    CURL *http_handle;
+    long lVal = 0;
+
+    psReq = &(pasReqInfo[i]);
+
+    if (psReq->nStatus == 242)
+      continue; /* Nothing to do here, this file was in cache already */
+
+    if (psReq->fp)
+      fclose(psReq->fp);
+    psReq->fp = NULL;
+
+    http_handle = (CURL *)(psReq->curl_handle);
+
+    if (psReq->nStatus == 0 &&
+        curl_easy_getinfo(http_handle, CURLINFO_HTTP_CODE, &lVal) == CURLE_OK) {
+      char *pszContentType = NULL;
+
+      psReq->nStatus = lVal;
+
+      /* Fetch content type of response */
+      if (curl_easy_getinfo(http_handle, CURLINFO_CONTENT_TYPE,
+                            &pszContentType) == CURLE_OK &&
+          pszContentType != NULL) {
+        psReq->pszContentType = msStrdup(pszContentType);
+      }
+    }
+
+    if (!MS_HTTP_SUCCESS(psReq->nStatus)) {
+      /* Set status to MS_DONE to indicate that transfers were  */
+      /* completed but may not be succesfull */
+      nStatus = MS_DONE;
+
+      if (psReq->nStatus == -(CURLE_OPERATION_TIMEOUTED)) {
+        /* Timeout isn't a fatal error */
+        if (psReq->debug)
+          msDebug("HTTP: TIMEOUT of %d seconds exceeded for %s\n", nTimeout,
+                  psReq->pszGetUrl);
+
+        msSetError(MS_HTTPERR, "HTTP: TIMEOUT of %d seconds exceeded for %s\n",
+                   "msHTTPExecuteRequests()", nTimeout, psReq->pszGetUrl);
+
+        /* Rewrite error message, the curl timeout message isn't
+         * of much use to our users.
+         */
+        sprintf(psReq->pszErrBuf, "TIMEOUT of %d seconds exceeded.", nTimeout);
+      } else if (psReq->nStatus > 0) {
+        /* Got an HTTP Error, e.g. 404, etc. */
+
+        if (psReq->debug)
+          msDebug("HTTP: HTTP GET request failed with status %d (%s)"
+                  " for %s\n",
+                  psReq->nStatus, psReq->pszErrBuf, psReq->pszGetUrl);
+
+        msSetError(MS_HTTPERR,
+                   "HTTP GET request failed with status %d (%s) "
+                   "for %s",
+                   "msHTTPExecuteRequests()", psReq->nStatus, psReq->pszErrBuf,
+                   psReq->pszGetUrl);
+      } else {
+        /* Got a curl error */
+
+        errorObj *error = msGetErrorObj();
+        if (psReq->debug)
+          msDebug("HTTP: request failed with curl error "
+                  "code %d (%s) for %s",
+                  -psReq->nStatus, psReq->pszErrBuf, psReq->pszGetUrl);
+
+        if (!error ||
+            error->code ==
+                MS_NOERR) /* only set error if one hasn't already been set */
+          msSetError(MS_HTTPERR,
+                     "HTTP: request failed with curl error "
+                     "code %d (%s) for %s",
+                     "msHTTPExecuteRequests()", -psReq->nStatus,
+                     psReq->pszErrBuf, psReq->pszGetUrl);
+      }
+    }
+
+    /* Report download times foreach handle, in debug mode */
+    if (psReq->debug) {
+      double dConnectTime = 0.0, dTotalTime = 0.0, dStartTfrTime = 0.0;
+
+      curl_easy_getinfo(http_handle, CURLINFO_CONNECT_TIME, &dConnectTime);
+      curl_easy_getinfo(http_handle, CURLINFO_STARTTRANSFER_TIME,
+                        &dStartTfrTime);
+      curl_easy_getinfo(http_handle, CURLINFO_TOTAL_TIME, &dTotalTime);
+      /* STARTTRANSFER_TIME includes CONNECT_TIME, but TOTAL_TIME
+       * doesn't, so we need to add it.
+       */
+      dTotalTime += dConnectTime;
+
+      msDebug("Layer %d: %.3f + %.3f + %.3f = %.3fs\n", psReq->nLayerId,
+              dConnectTime, dStartTfrTime - dConnectTime,
+              dTotalTime - dStartTfrTime, dTotalTime);
+    }
+
+    /* Cleanup this handle */
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL, "");
+    curl_multi_remove_handle(multi_handle, http_handle);
+    curl_easy_cleanup(http_handle);
+    psReq->curl_handle = NULL;
+    curl_slist_free_all(psReq->curl_headers); // free the header list
+  }
+
+  /* Cleanup multi handle, each handle had to be cleaned up individually */
+  curl_multi_cleanup(multi_handle);
+
+  return nStatus;
+}
+
+/**********************************************************************
+ *                          msHTTPGetFile()
+ *
+ * Wrapper to call msHTTPExecuteRequests() for a single file.
+ **********************************************************************/
+int msHTTPGetFile(const char *pszGetUrl, const char *pszOutputFile,
+                  int *pnHTTPStatus, int nTimeout, int bCheckLocalCache,
+                  int bDebug, int nMaxBytes) {
+  httpRequestObj *pasReqInfo;
+
+  /* Alloc httpRequestInfo structs through which status of each request
+   * will be returned.
+   * We need to alloc 2 instance of requestobj so that the last
+   * object in the array can be set to NULL.
+   */
+  pasReqInfo = (httpRequestObj *)calloc(2, sizeof(httpRequestObj));
+  MS_CHECK_ALLOC(pasReqInfo, 2 * sizeof(httpRequestObj), MS_FAILURE);
+
+  msHTTPInitRequestObj(pasReqInfo, 2);
+
+  pasReqInfo[0].pszGetUrl = msStrdup(pszGetUrl);
+  pasReqInfo[0].pszOutputFile = msStrdup(pszOutputFile);
+  pasReqInfo[0].debug = (char)bDebug;
+  pasReqInfo[0].nTimeout = nTimeout;
+  pasReqInfo[0].nMaxBytes = nMaxBytes;
+
+  if (msHTTPExecuteRequests(pasReqInfo, 1, bCheckLocalCache) != MS_SUCCESS) {
+    *pnHTTPStatus = pasReqInfo[0].nStatus;
+    if (pasReqInfo[0].debug)
+      msDebug("HTTP request failed for %s.\n", pszGetUrl);
+    msHTTPFreeRequestObj(pasReqInfo, 2);
+    free(pasReqInfo);
+    return MS_FAILURE;
+  }
+
+  *pnHTTPStatus = pasReqInfo[0].nStatus;
+
+  msHTTPFreeRequestObj(pasReqInfo, 2);
+  free(pasReqInfo);
+
+  return MS_SUCCESS;
+}
+
+#endif /* defined(USE_WMS_LYR) || defined(USE_WMS_SVR) */
diff -pruN 8.0.1-5/src/maphttp.h 8.2.0~beta1-1~exp1/src/maphttp.h
--- 8.0.1-5/src/maphttp.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maphttp.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,110 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  http requests related functions
+ * Author:   MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPHTTP_H
+#define MAPHTTP_H
+
+#include "mapprimitive.h"
+#include <stdio.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define MS_HTTP_SUCCESS(status) (status == 200 || status == 242)
+
+enum MS_HTTP_PROXY_TYPE { MS_HTTP, MS_SOCKS5 };
+
+enum MS_HTTP_AUTH_TYPE { MS_BASIC, MS_DIGEST, MS_NTLM, MS_ANY, MS_ANYSAFE };
+
+typedef struct http_request_info {
+  int nLayerId;
+  char *pszGetUrl;
+  char *pszOutputFile;
+  int nTimeout;
+  int nMaxBytes;
+  rectObj bbox;
+  int width;
+  int height;
+  int nStatus;              /* 200=success, value < 0 if request failed */
+  char *pszContentType;     /* Content-Type of the response */
+  char *pszErrBuf;          /* Buffer where curl can write errors */
+  char *pszPostRequest;     /* post request content (NULL for GET) */
+  char *pszPostContentType; /* post request MIME type */
+  char *pszUserAgent;       /* User-Agent, auto-generated if not set */
+  char *pszHTTPCookieData;  /* HTTP Cookie data */
+
+  char *pszProxyAddress; /* The address (IP or hostname) of proxy svr */
+  long nProxyPort;       /* The proxy's port                          */
+  enum MS_HTTP_PROXY_TYPE eProxyType;    /* The type of proxy                 */
+  enum MS_HTTP_AUTH_TYPE eProxyAuthType; /* Auth method against proxy     */
+  char *pszProxyUsername; /* Proxy authentication username             */
+  char *pszProxyPassword; /* Proxy authentication password             */
+
+  enum MS_HTTP_AUTH_TYPE eHttpAuthType; /* HTTP Authentication type        */
+  char *pszHttpUsername; /* HTTP Authentication username              */
+  char *pszHttpPassword; /* HTTP Authentication password              */
+
+  /* For debugging/profiling */
+  int debug; /* Debug mode?  MS_TRUE/MS_FALSE */
+
+  /* Private members */
+  void *curl_headers; /* property to store a curl_slist handle */
+  void *curl_handle;  /* CURLM * handle */
+  FILE *fp;           /* FILE * used during download */
+
+  char *result_data; /* output if pszOutputFile is NULL */
+  int result_size;
+  int result_buf_size;
+
+} httpRequestObj;
+
+#ifdef USE_CURL
+
+int msHTTPInit(void);
+void msHTTPCleanup(void);
+
+void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests);
+void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests);
+int msHTTPExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
+                          int bCheckLocalCache);
+int msHTTPGetFile(const char *pszGetUrl, const char *pszOutputFile,
+                  int *pnHTTPStatus, int nTimeout, int bCheckLocalCache,
+                  int bDebug, int nMaxBytes);
+
+int msHTTPAuthProxySetup(hashTableObj *mapmd, hashTableObj *lyrmd,
+                         httpRequestObj *pasReqInfo, int numRequests,
+                         mapObj *map, const char *namespaces);
+#endif /*USE_CURL*/
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPHTTP_H */
diff -pruN 8.0.1-5/src/mapiconv.c 8.2.0~beta1-1~exp1/src/mapiconv.c
--- 8.0.1-5/src/mapiconv.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapiconv.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,34 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Wrapper for iconv functions
+ * Author:   Even Rouault
+ *
+ ******************************************************************************
+ * Copyright (c) 2020 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapiconv.h"
+
+size_t msIconv(iconv_t cd, char **inbuf, size_t *inbytesleft, char **outbuf,
+               size_t *outbytesleft) {
+  return iconv(cd, inbuf, inbytesleft, outbuf, outbytesleft);
+}
diff -pruN 8.0.1-5/src/mapiconv.h 8.2.0~beta1-1~exp1/src/mapiconv.h
--- 8.0.1-5/src/mapiconv.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapiconv.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,46 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Wrapper for iconv functions
+ * Author:   Even Rouault
+ *
+ ******************************************************************************
+ * Copyright (c) 2020 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#ifndef MAPICONV_H
+#define MAPICONV_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <iconv.h>
+
+/* Wrapper of iconv() to be used from C++ */
+size_t msIconv(iconv_t cd, char **inbuf, size_t *inbytesleft, char **outbuf,
+               size_t *outbytesleft);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/mapimageio.c 8.2.0~beta1-1~exp1/src/mapimageio.c
--- 8.0.1-5/src/mapimageio.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapimageio.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1163 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Low level PNG/JPEG/GIF image io native functions
+ * Author:   Thomas Bonfort (tbonfort)
+ *
+ ******************************************************************************
+ * Copyright (c) 2009 Thomas Bonfort
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include <png.h>
+#include <setjmp.h>
+#include <assert.h>
+#include <jpeglib.h>
+#include <stdlib.h>
+
+#ifdef USE_GIF
+#include <gif_lib.h>
+#endif
+
+typedef struct _streamInfo {
+  FILE *fp;
+  bufferObj *buffer;
+} streamInfo;
+
+static void png_write_data_to_stream(png_structp png_ptr, png_bytep data,
+                                     png_size_t length) {
+  FILE *fp = ((streamInfo *)png_get_io_ptr(png_ptr))->fp;
+  msIO_fwrite(data, length, 1, fp);
+}
+
+static void png_write_data_to_buffer(png_structp png_ptr, png_bytep data,
+                                     png_size_t length) {
+  bufferObj *buffer = ((streamInfo *)png_get_io_ptr(png_ptr))->buffer;
+  msBufferAppend(buffer, data, length);
+}
+
+static void png_flush_data(png_structp png_ptr) {
+  (void)png_ptr;
+  /* do nothing */
+}
+
+typedef struct {
+  struct jpeg_destination_mgr pub;
+  unsigned char *data;
+} ms_destination_mgr;
+
+typedef struct {
+  ms_destination_mgr mgr;
+  FILE *stream;
+} ms_stream_destination_mgr;
+
+typedef struct {
+  ms_destination_mgr mgr;
+  bufferObj *buffer;
+} ms_buffer_destination_mgr;
+
+#define OUTPUT_BUF_SIZE 4096
+
+static void jpeg_init_destination(j_compress_ptr cinfo) {
+  ms_destination_mgr *dest = (ms_destination_mgr *)cinfo->dest;
+
+  /* Allocate the output buffer --- it will be released when done with image */
+  dest->data = (unsigned char *)(*cinfo->mem->alloc_small)(
+      (j_common_ptr)cinfo, JPOOL_IMAGE,
+      OUTPUT_BUF_SIZE * sizeof(unsigned char));
+
+  dest->pub.next_output_byte = dest->data;
+  dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
+}
+
+static void jpeg_stream_term_destination(j_compress_ptr cinfo) {
+  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr *)cinfo->dest;
+  msIO_fwrite(dest->mgr.data, OUTPUT_BUF_SIZE - dest->mgr.pub.free_in_buffer, 1,
+              dest->stream);
+  dest->mgr.pub.next_output_byte = dest->mgr.data;
+  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
+}
+
+static void jpeg_buffer_term_destination(j_compress_ptr cinfo) {
+  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr *)cinfo->dest;
+  msBufferAppend(dest->buffer, dest->mgr.data,
+                 OUTPUT_BUF_SIZE - dest->mgr.pub.free_in_buffer);
+  dest->mgr.pub.next_output_byte = dest->mgr.data;
+  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
+}
+
+static boolean jpeg_stream_empty_output_buffer(j_compress_ptr cinfo) {
+  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr *)cinfo->dest;
+  msIO_fwrite(dest->mgr.data, OUTPUT_BUF_SIZE, 1, dest->stream);
+  dest->mgr.pub.next_output_byte = dest->mgr.data;
+  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
+  return TRUE;
+}
+
+static boolean jpeg_buffer_empty_output_buffer(j_compress_ptr cinfo) {
+  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr *)cinfo->dest;
+  msBufferAppend(dest->buffer, dest->mgr.data, OUTPUT_BUF_SIZE);
+  dest->mgr.pub.next_output_byte = dest->mgr.data;
+  dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
+  return TRUE;
+}
+
+static void msJPEGErrorExit(j_common_ptr cinfo) {
+  jmp_buf *pJmpBuffer = (jmp_buf *)cinfo->client_data;
+  char buffer[JMSG_LENGTH_MAX];
+
+  /* Create the message */
+  (*cinfo->err->format_message)(cinfo, buffer);
+
+  msSetError(MS_MISCERR, "libjpeg: %s", "jpeg_ErrorExit()", buffer);
+
+  /* Return control to the setjmp point */
+  longjmp(*pJmpBuffer, 1);
+}
+
+int saveAsJPEG(mapObj *map, rasterBufferObj *rb, streamInfo *info,
+               outputFormatObj *format) {
+  struct jpeg_compress_struct cinfo;
+  struct jpeg_error_mgr jerr;
+  int quality;
+  const char *pszOptimized;
+  int optimized;
+  int arithmetic;
+  ms_destination_mgr *dest;
+  JSAMPLE *rowdata = NULL;
+  unsigned int row;
+  jmp_buf setjmp_buffer;
+
+  quality = atoi(msGetOutputFormatOption(format, "QUALITY", "75"));
+  pszOptimized = msGetOutputFormatOption(format, "OPTIMIZED", "YES");
+  optimized = EQUAL(pszOptimized, "YES") || EQUAL(pszOptimized, "ON") ||
+              EQUAL(pszOptimized, "TRUE");
+  arithmetic = EQUAL(pszOptimized, "ARITHMETIC");
+
+  if (setjmp(setjmp_buffer)) {
+    jpeg_destroy_compress(&cinfo);
+    free(rowdata);
+    return MS_FAILURE;
+  }
+
+  cinfo.err = jpeg_std_error(&jerr);
+  jerr.error_exit = msJPEGErrorExit;
+  cinfo.client_data = (void *)&(setjmp_buffer);
+  jpeg_create_compress(&cinfo);
+
+  if (cinfo.dest == NULL) {
+    if (info->fp) {
+      cinfo.dest = (struct jpeg_destination_mgr *)(*cinfo.mem->alloc_small)(
+          (j_common_ptr)&cinfo, JPOOL_PERMANENT,
+          sizeof(ms_stream_destination_mgr));
+      ((ms_stream_destination_mgr *)cinfo.dest)->mgr.pub.empty_output_buffer =
+          jpeg_stream_empty_output_buffer;
+      ((ms_stream_destination_mgr *)cinfo.dest)->mgr.pub.term_destination =
+          jpeg_stream_term_destination;
+      ((ms_stream_destination_mgr *)cinfo.dest)->stream = info->fp;
+    } else {
+
+      cinfo.dest = (struct jpeg_destination_mgr *)(*cinfo.mem->alloc_small)(
+          (j_common_ptr)&cinfo, JPOOL_PERMANENT,
+          sizeof(ms_buffer_destination_mgr));
+      ((ms_buffer_destination_mgr *)cinfo.dest)->mgr.pub.empty_output_buffer =
+          jpeg_buffer_empty_output_buffer;
+      ((ms_buffer_destination_mgr *)cinfo.dest)->mgr.pub.term_destination =
+          jpeg_buffer_term_destination;
+      ((ms_buffer_destination_mgr *)cinfo.dest)->buffer = info->buffer;
+    }
+  }
+  dest = (ms_destination_mgr *)cinfo.dest;
+  dest->pub.init_destination = jpeg_init_destination;
+
+  cinfo.image_width = rb->width;
+  cinfo.image_height = rb->height;
+  cinfo.input_components = 3;
+  cinfo.in_color_space = JCS_RGB;
+  jpeg_set_defaults(&cinfo);
+  jpeg_set_quality(&cinfo, quality, TRUE);
+  if (arithmetic)
+    cinfo.arith_code = TRUE;
+  else if (optimized)
+    cinfo.optimize_coding = TRUE;
+
+  if (arithmetic || optimized) {
+    /* libjpeg turbo 1.5.2 honours max_memory_to_use, but has no backing */
+    /* store implementation, so better not set max_memory_to_use ourselves. */
+    /* See https://github.com/libjpeg-turbo/libjpeg-turbo/issues/162 */
+    if (cinfo.mem->max_memory_to_use > 0) {
+      if (map == NULL || msGetConfigOption(map, "JPEGMEM") == NULL) {
+        /* If the user doesn't provide a value for JPEGMEM, we want to be sure
+         */
+        /* that at least the image size will be used before creating the
+         * temporary file */
+        cinfo.mem->max_memory_to_use =
+            MS_MAX(cinfo.mem->max_memory_to_use,
+                   cinfo.input_components * rb->width * rb->height);
+      }
+    }
+  }
+
+  jpeg_start_compress(&cinfo, TRUE);
+  rowdata =
+      (JSAMPLE *)malloc(sizeof(JSAMPLE) * rb->width * cinfo.input_components);
+
+  for (row = 0; row < rb->height; row++) {
+    JSAMPLE *pixptr = rowdata;
+    unsigned char *r, *g, *b;
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
+      *(pixptr++) = *r;
+      *(pixptr++) = *g;
+      *(pixptr++) = *b;
+      r += rb->data.rgba.pixel_step;
+      g += rb->data.rgba.pixel_step;
+      b += rb->data.rgba.pixel_step;
+    }
+    (void)jpeg_write_scanlines(&cinfo, &rowdata, 1);
+  }
+
+  /* Step 6: Finish compression */
+
+  jpeg_finish_compress(&cinfo);
+  jpeg_destroy_compress(&cinfo);
+  free(rowdata);
+  return MS_SUCCESS;
+}
+
+/*
+ * sort a given list of rgba entries so that all the opaque pixels are at the
+ * end
+ */
+int remapPaletteForPNG(rasterBufferObj *rb, rgbPixel *rgb, unsigned char *a,
+                       int *num_a) {
+  int bot_idx, top_idx;
+  unsigned x;
+  int remap[256];
+  unsigned int maxval = rb->data.palette.scaling_maxval;
+
+  assert(rb->type == MS_BUFFER_BYTE_PALETTE);
+
+  /*
+  ** remap the palette colors so that all entries with
+  ** the maximal alpha value (i.e., fully opaque) are at the end and can
+  ** therefore be omitted from the tRNS chunk.  Note that the ordering of
+  ** opaque entries is reversed from how they were previously arranged
+  ** --not that this should matter to anyone.
+  */
+
+  for (top_idx = (int)rb->data.palette.num_entries - 1, bot_idx = x = 0;
+       x < rb->data.palette.num_entries; ++x) {
+    if (rb->data.palette.palette[x].a == maxval)
+      remap[x] = top_idx--;
+    else
+      remap[x] = bot_idx++;
+  }
+  /* sanity check:  top and bottom indices should have just crossed paths */
+  if (bot_idx != top_idx + 1) {
+    msSetError(MS_MISCERR, "quantization sanity check failed",
+               "createPNGPalette()");
+    return MS_FAILURE;
+  }
+
+  *num_a = bot_idx;
+
+  for (x = 0; x < rb->width * rb->height; x++)
+    rb->data.palette.pixels[x] = remap[rb->data.palette.pixels[x]];
+
+  for (x = 0; x < rb->data.palette.num_entries; ++x) {
+    if (maxval == 255) {
+      a[remap[x]] = rb->data.palette.palette[x].a;
+      rgb[remap[x]].r = rb->data.palette.palette[x].r;
+      rgb[remap[x]].g = rb->data.palette.palette[x].g;
+      rgb[remap[x]].b = rb->data.palette.palette[x].b;
+    } else {
+      /* rescale palette */
+      rgb[remap[x]].r =
+          (rb->data.palette.palette[x].r * 255 + (maxval >> 1)) / maxval;
+      rgb[remap[x]].g =
+          (rb->data.palette.palette[x].g * 255 + (maxval >> 1)) / maxval;
+      rgb[remap[x]].b =
+          (rb->data.palette.palette[x].b * 255 + (maxval >> 1)) / maxval;
+      a[remap[x]] =
+          (rb->data.palette.palette[x].a * 255 + (maxval >> 1)) / maxval;
+    }
+    if (a[remap[x]] != 255) {
+      /* un-premultiply pixels */
+      double da = 255.0 / a[remap[x]];
+      rgb[remap[x]].r *= da;
+      rgb[remap[x]].g *= da;
+      rgb[remap[x]].b *= da;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+int savePalettePNG(rasterBufferObj *rb, streamInfo *info, int compression) {
+  png_infop info_ptr;
+  rgbPixel rgb[256];
+  unsigned char a[256];
+  int num_a;
+  int sample_depth;
+  png_structp png_ptr =
+      png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
+
+  assert(rb->type == MS_BUFFER_BYTE_PALETTE);
+
+  if (!png_ptr)
+    return (MS_FAILURE);
+
+  png_set_compression_level(png_ptr, compression);
+  png_set_filter(png_ptr, 0, PNG_FILTER_NONE);
+
+  info_ptr = png_create_info_struct(png_ptr);
+  if (!info_ptr) {
+    png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
+    return (MS_FAILURE);
+  }
+
+  if (setjmp(png_jmpbuf(png_ptr))) {
+    png_destroy_write_struct(&png_ptr, &info_ptr);
+    return (MS_FAILURE);
+  }
+  if (info->fp)
+    png_set_write_fn(png_ptr, info, png_write_data_to_stream, png_flush_data);
+  else
+    png_set_write_fn(png_ptr, info, png_write_data_to_buffer, png_flush_data);
+
+  if (rb->data.palette.num_entries <= 2)
+    sample_depth = 1;
+  else if (rb->data.palette.num_entries <= 4)
+    sample_depth = 2;
+  else if (rb->data.palette.num_entries <= 16)
+    sample_depth = 4;
+  else
+    sample_depth = 8;
+
+  png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height, sample_depth,
+               PNG_COLOR_TYPE_PALETTE, 0, PNG_COMPRESSION_TYPE_DEFAULT,
+               PNG_FILTER_TYPE_DEFAULT);
+
+  remapPaletteForPNG(rb, rgb, a, &num_a);
+
+  png_set_PLTE(png_ptr, info_ptr, (png_colorp)(rgb),
+               rb->data.palette.num_entries);
+  if (num_a)
+    png_set_tRNS(png_ptr, info_ptr, a, num_a, NULL);
+
+  png_write_info(png_ptr, info_ptr);
+  png_set_packing(png_ptr);
+
+  for (unsigned row = 0; row < rb->height; row++) {
+    unsigned char *rowptr = &(rb->data.palette.pixels[row * rb->width]);
+    png_write_row(png_ptr, rowptr);
+  }
+  png_write_end(png_ptr, info_ptr);
+  png_destroy_write_struct(&png_ptr, &info_ptr);
+  return MS_SUCCESS;
+}
+
+int readPalette(const char *palette, rgbaPixel *entries, unsigned int *nEntries,
+                int useAlpha) {
+  FILE *stream = NULL;
+  char buffer[MS_BUFFER_LENGTH];
+  *nEntries = 0;
+
+  stream = fopen(palette, "r");
+  if (!stream) {
+    msSetError(MS_IOERR, "Error opening palette file %s.", "readPalette()",
+               palette);
+    return MS_FAILURE;
+  }
+
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) && *nEntries < 256) {
+    int r, g, b, a = 0;
+    /* while there are colors to load */
+    if (buffer[0] == '#' || buffer[0] == '\n' || buffer[0] == '\r')
+      continue; /* skip comments and blank lines */
+    if (!useAlpha) {
+      if (3 != sscanf(buffer, "%d,%d,%d\n", &r, &g, &b)) {
+        fclose(stream);
+        msSetError(MS_MISCERR,
+                   "failed to parse color %d r,g,b triplet in line \"%s\" from "
+                   "file %s",
+                   "readPalette()", *nEntries + 1, buffer, palette);
+        return MS_FAILURE;
+      }
+    } else {
+      if (4 != sscanf(buffer, "%d,%d,%d,%d\n", &r, &g, &b, &a)) {
+        fclose(stream);
+        msSetError(MS_MISCERR,
+                   "failed to parse color %d r,g,b,a quadruplet in line \"%s\" "
+                   "from file %s",
+                   "readPalette()", *nEntries + 1, buffer, palette);
+        return MS_FAILURE;
+      }
+    }
+    if (useAlpha && a != 255) {
+      double da = a / 255.0;
+      entries[*nEntries].r = r * da;
+      entries[*nEntries].g = g * da;
+      entries[*nEntries].b = b * da;
+      entries[*nEntries].a = a;
+    } else {
+      entries[*nEntries].r = r;
+      entries[*nEntries].g = g;
+      entries[*nEntries].b = b;
+      entries[*nEntries].a = 255;
+    }
+    (*nEntries)++;
+  }
+  fclose(stream);
+  return MS_SUCCESS;
+}
+
+int saveAsPNG(mapObj *map, rasterBufferObj *rb, streamInfo *info,
+              outputFormatObj *format) {
+  int force_pc256 = MS_FALSE;
+  int force_palette = MS_FALSE;
+
+  const char *force_string, *zlib_compression;
+  int compression = -1;
+
+  zlib_compression = msGetOutputFormatOption(format, "COMPRESSION", NULL);
+  if (zlib_compression && *zlib_compression) {
+    char *endptr;
+    compression = strtol(zlib_compression, &endptr, 10);
+    if (*endptr || compression < -1 || compression > 9) {
+      msSetError(MS_MISCERR,
+                 "failed to parse FORMATOPTION \"COMPRESSION=%s\", expecting "
+                 "integer from 0 to 9.",
+                 "saveAsPNG()", zlib_compression);
+      return MS_FAILURE;
+    }
+  }
+
+  force_string = msGetOutputFormatOption(format, "QUANTIZE_FORCE", NULL);
+  if (force_string && (strcasecmp(force_string, "on") == 0 ||
+                       strcasecmp(force_string, "yes") == 0 ||
+                       strcasecmp(force_string, "true") == 0))
+    force_pc256 = MS_TRUE;
+
+  force_string = msGetOutputFormatOption(format, "PALETTE_FORCE", NULL);
+  if (force_string && (strcasecmp(force_string, "on") == 0 ||
+                       strcasecmp(force_string, "yes") == 0 ||
+                       strcasecmp(force_string, "true") == 0))
+    force_palette = MS_TRUE;
+
+  if (force_pc256 || force_palette) {
+    rasterBufferObj qrb;
+    rgbaPixel palette[256], paletteGiven[256];
+    unsigned int numPaletteGivenEntries;
+    memset(&qrb, 0, sizeof(rasterBufferObj));
+    qrb.type = MS_BUFFER_BYTE_PALETTE;
+    qrb.width = rb->width;
+    qrb.height = rb->height;
+    qrb.data.palette.pixels =
+        (unsigned char *)malloc(sizeof(unsigned char) * qrb.width * qrb.height);
+    qrb.data.palette.scaling_maxval = 255;
+    int ret;
+    if (force_pc256) {
+      qrb.data.palette.palette = palette;
+      qrb.data.palette.num_entries =
+          atoi(msGetOutputFormatOption(format, "QUANTIZE_COLORS", "256"));
+      ret = msQuantizeRasterBuffer(rb, &(qrb.data.palette.num_entries),
+                                   qrb.data.palette.palette, NULL, 0,
+                                   &qrb.data.palette.scaling_maxval);
+    } else {
+      unsigned colorsWanted = (unsigned)atoi(
+          msGetOutputFormatOption(format, "QUANTIZE_COLORS", "0"));
+      const char *palettePath =
+          msGetOutputFormatOption(format, "PALETTE", "palette.txt");
+      char szPath[MS_MAXPATHLEN];
+      if (map) {
+        msBuildPath(szPath, map->mappath, palettePath);
+        palettePath = szPath;
+      }
+      if (readPalette(palettePath, paletteGiven, &numPaletteGivenEntries,
+                      format->transparent) != MS_SUCCESS) {
+        msFree(qrb.data.palette.pixels);
+        return MS_FAILURE;
+      }
+
+      if (numPaletteGivenEntries == 256 || colorsWanted == 0) {
+        qrb.data.palette.palette = paletteGiven;
+        qrb.data.palette.num_entries = numPaletteGivenEntries;
+        ret = MS_SUCCESS;
+
+        /* we have a full palette and don't want an additional quantization step
+         */
+      } else {
+        /* quantize the image, and mix our colours in the resulting palette */
+        qrb.data.palette.palette = palette;
+        qrb.data.palette.num_entries =
+            MS_MAX(colorsWanted, numPaletteGivenEntries);
+        ret = msQuantizeRasterBuffer(rb, &(qrb.data.palette.num_entries),
+                                     qrb.data.palette.palette, paletteGiven,
+                                     numPaletteGivenEntries,
+                                     &qrb.data.palette.scaling_maxval);
+      }
+    }
+    if (ret != MS_FAILURE) {
+      msClassifyRasterBuffer(rb, &qrb);
+      ret = savePalettePNG(&qrb, info, compression);
+    }
+    msFree(qrb.data.palette.pixels);
+    return ret;
+  } else if (rb->type == MS_BUFFER_BYTE_RGBA) {
+    png_infop info_ptr;
+    int color_type;
+    unsigned int *rowdata;
+    png_structp png_ptr =
+        png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
+
+    if (!png_ptr)
+      return (MS_FAILURE);
+
+    png_set_compression_level(png_ptr, compression);
+    png_set_filter(png_ptr, 0, PNG_FILTER_NONE);
+
+    info_ptr = png_create_info_struct(png_ptr);
+    if (!info_ptr) {
+      png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
+      return (MS_FAILURE);
+    }
+
+    if (setjmp(png_jmpbuf(png_ptr))) {
+      png_destroy_write_struct(&png_ptr, &info_ptr);
+      return (MS_FAILURE);
+    }
+    if (info->fp)
+      png_set_write_fn(png_ptr, info, png_write_data_to_stream, png_flush_data);
+    else
+      png_set_write_fn(png_ptr, info, png_write_data_to_buffer, png_flush_data);
+
+    if (rb->data.rgba.a)
+      color_type = PNG_COLOR_TYPE_RGB_ALPHA;
+    else
+      color_type = PNG_COLOR_TYPE_RGB;
+
+    png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height, 8, color_type,
+                 PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT,
+                 PNG_FILTER_TYPE_DEFAULT);
+
+    png_write_info(png_ptr, info_ptr);
+
+    if (!rb->data.rgba.a && rb->data.rgba.pixel_step == 4)
+      png_set_filler(png_ptr, 0, PNG_FILLER_AFTER);
+
+    rowdata = (unsigned int *)malloc(rb->width * sizeof(unsigned int));
+    for (unsigned row = 0; row < rb->height; row++) {
+      unsigned int *pixptr = rowdata;
+      unsigned char *a, *r, *g, *b;
+      r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+      g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+      b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+      if (rb->data.rgba.a) {
+        a = rb->data.rgba.a + row * rb->data.rgba.row_step;
+        for (unsigned col = 0; col < rb->width; col++) {
+          if (*a) {
+            double da = *a / 255.0;
+            unsigned char *pix = (unsigned char *)pixptr;
+            pix[0] = *r / da;
+            pix[1] = *g / da;
+            pix[2] = *b / da;
+            pix[3] = *a;
+          } else {
+            *pixptr = 0;
+          }
+          pixptr++;
+          a += rb->data.rgba.pixel_step;
+          r += rb->data.rgba.pixel_step;
+          g += rb->data.rgba.pixel_step;
+          b += rb->data.rgba.pixel_step;
+        }
+      } else {
+        for (unsigned col = 0; col < rb->width; col++) {
+          unsigned char *pix = (unsigned char *)pixptr;
+          pix[0] = *r;
+          pix[1] = *g;
+          pix[2] = *b;
+          pixptr++;
+          r += rb->data.rgba.pixel_step;
+          g += rb->data.rgba.pixel_step;
+          b += rb->data.rgba.pixel_step;
+        }
+      }
+
+      png_write_row(png_ptr, (png_bytep)rowdata);
+    }
+    png_write_end(png_ptr, info_ptr);
+    free(rowdata);
+    png_destroy_write_struct(&png_ptr, &info_ptr);
+    return MS_SUCCESS;
+  } else {
+    msSetError(MS_MISCERR, "Unknown buffer type", "saveAsPNG()");
+    return MS_FAILURE;
+  }
+}
+
+/* For platforms with incomplete ANSI defines. Fortunately,
+   SEEK_SET is defined to be zero by the standard. */
+
+#ifndef SEEK_SET
+#define SEEK_SET 0
+#endif /* SEEK_SET */
+
+int readPNG(char *path, rasterBufferObj *rb) {
+  png_uint_32 width, height;
+  unsigned char *a, *r, *g, *b;
+  int bit_depth, color_type;
+  unsigned char **row_pointers;
+  png_structp png_ptr = NULL;
+  png_infop info_ptr = NULL;
+
+  FILE *stream = fopen(path, "rb");
+  if (!stream)
+    return MS_FAILURE;
+
+  /* could pass pointers to user-defined error handlers instead of NULLs: */
+  png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
+  if (!png_ptr) {
+    fclose(stream);
+    return MS_FAILURE; /* out of memory */
+  }
+
+  info_ptr = png_create_info_struct(png_ptr);
+  if (!info_ptr) {
+    png_destroy_read_struct(&png_ptr, NULL, NULL);
+    fclose(stream);
+    return MS_FAILURE; /* out of memory */
+  }
+
+  if (setjmp(png_jmpbuf(png_ptr))) {
+    png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
+    fclose(stream);
+    return MS_FAILURE;
+  }
+
+  png_init_io(png_ptr, stream);
+  png_read_info(png_ptr, info_ptr);
+  png_get_IHDR(png_ptr, info_ptr, &width, &height, &bit_depth, &color_type,
+               NULL, NULL, NULL);
+
+  rb->width = width;
+  rb->height = height;
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->data.rgba.pixels =
+      (unsigned char *)malloc(sizeof(unsigned char) * width * height * 4);
+  row_pointers = (unsigned char **)malloc(height * sizeof(unsigned char *));
+  rb->data.rgba.pixel_step = 4;
+  rb->data.rgba.row_step = width * 4;
+  b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
+  g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
+  r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
+  a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
+
+  for (unsigned i = 0; i < height; i++) {
+    row_pointers[i] = &(rb->data.rgba.pixels[i * rb->data.rgba.row_step]);
+  }
+
+  if (color_type == PNG_COLOR_TYPE_PALETTE)
+    /* expand palette images to RGB */
+    png_set_expand(png_ptr);
+  if (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8)
+    /* expand low bit-depth grayscale to 8bits */
+    png_set_expand(png_ptr);
+  if (png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS))
+    /* expand transparency chunks to full alpha */
+    png_set_expand(png_ptr);
+  if (bit_depth == 16)
+    /* scale 16bits down to 8 */
+    png_set_strip_16(png_ptr);
+  if (color_type == PNG_COLOR_TYPE_GRAY ||
+      color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
+    /* convert grayscale to rgba */
+    png_set_gray_to_rgb(png_ptr);
+
+  png_set_bgr(png_ptr);
+  if (color_type == PNG_COLOR_TYPE_RGB || color_type == PNG_COLOR_TYPE_GRAY ||
+      color_type == PNG_COLOR_TYPE_PALETTE)
+    png_set_add_alpha(png_ptr, 0xff, PNG_FILLER_AFTER);
+
+  png_read_update_info(png_ptr, info_ptr);
+  assert(png_get_rowbytes(png_ptr, info_ptr) == rb->data.rgba.row_step);
+
+  png_read_image(png_ptr, row_pointers);
+  free(row_pointers);
+  row_pointers = NULL;
+  png_read_end(png_ptr, NULL);
+  png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
+
+  /*premultiply data*/
+  for (unsigned i = 0; i < width * height; i++) {
+    if (*a < 255) {
+      if (*a == 0) {
+        *r = *g = *b = 0;
+      } else {
+        *r = (*r * *a + 255) >> 8;
+        *g = (*g * *a + 255) >> 8;
+        *b = (*b * *a + 255) >> 8;
+      }
+    }
+    a += 4;
+    b += 4;
+    g += 4;
+    r += 4;
+  }
+
+  fclose(stream);
+  return MS_SUCCESS;
+}
+
+int msSaveRasterBuffer(mapObj *map, rasterBufferObj *rb, FILE *stream,
+                       outputFormatObj *format) {
+  if (strcasestr(format->driver, "/png")) {
+    streamInfo info;
+    info.fp = stream;
+    info.buffer = NULL;
+
+    return saveAsPNG(map, rb, &info, format);
+  } else if (strcasestr(format->driver, "/jpeg")) {
+    streamInfo info;
+    info.fp = stream;
+    info.buffer = NULL;
+
+    return saveAsJPEG(map, rb, &info, format);
+  } else {
+    msSetError(MS_MISCERR, "unsupported image format\n",
+               "msSaveRasterBuffer()");
+    return MS_FAILURE;
+  }
+}
+
+int msSaveRasterBufferToBuffer(rasterBufferObj *data, bufferObj *buffer,
+                               outputFormatObj *format) {
+  if (strcasestr(format->driver, "/png")) {
+    streamInfo info;
+    info.fp = NULL;
+    info.buffer = buffer;
+    return saveAsPNG(NULL, data, &info, format);
+  } else if (strcasestr(format->driver, "/jpeg")) {
+    streamInfo info;
+    info.fp = NULL;
+    info.buffer = buffer;
+    return saveAsJPEG(NULL, data, &info, format);
+  } else {
+    msSetError(MS_MISCERR, "unsupported image format\n",
+               "msSaveRasterBuffer()");
+    return MS_FAILURE;
+  }
+}
+
+#ifdef USE_GIF
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+static char const *gif_error_msg(int code)
+#else
+static char const *gif_error_msg()
+#endif
+{
+  static char msg[80];
+
+#if (!defined GIFLIB_MAJOR) || (GIFLIB_MAJOR < 5)
+  int code = GifLastError();
+#endif
+  switch (code) {
+  case E_GIF_ERR_OPEN_FAILED: /* should not see this */
+    return "Failed to open given file";
+
+  case E_GIF_ERR_WRITE_FAILED:
+    return "Write failed";
+
+  case E_GIF_ERR_HAS_SCRN_DSCR: /* should not see this */
+    return "Screen descriptor already passed to giflib";
+
+  case E_GIF_ERR_HAS_IMAG_DSCR: /* should not see this */
+    return "Image descriptor already passed to giflib";
+
+  case E_GIF_ERR_NO_COLOR_MAP: /* should not see this */
+    return "Neither global nor local color map set";
+
+  case E_GIF_ERR_DATA_TOO_BIG: /* should not see this */
+    return "Too much pixel data passed to giflib";
+
+  case E_GIF_ERR_NOT_ENOUGH_MEM:
+    return "Out of memory";
+
+  case E_GIF_ERR_DISK_IS_FULL:
+    return "Disk is full";
+
+  case E_GIF_ERR_CLOSE_FAILED: /* should not see this */
+    return "File close failed";
+
+  case E_GIF_ERR_NOT_WRITEABLE: /* should not see this */
+    return "File not writable";
+
+  case D_GIF_ERR_OPEN_FAILED:
+    return "Failed to open file";
+
+  case D_GIF_ERR_READ_FAILED:
+    return "Failed to read from file";
+
+  case D_GIF_ERR_NOT_GIF_FILE:
+    return "File is not a GIF file";
+
+  case D_GIF_ERR_NO_SCRN_DSCR:
+    return "No screen descriptor detected - invalid file";
+
+  case D_GIF_ERR_NO_IMAG_DSCR:
+    return "No image descriptor detected - invalid file";
+
+  case D_GIF_ERR_NO_COLOR_MAP:
+    return "No global or local color map found";
+
+  case D_GIF_ERR_WRONG_RECORD:
+    return "Wrong record type detected - invalid file?";
+
+  case D_GIF_ERR_DATA_TOO_BIG:
+    return "Data in file too big for image";
+
+  case D_GIF_ERR_NOT_ENOUGH_MEM:
+    return "Out of memory";
+
+  case D_GIF_ERR_CLOSE_FAILED:
+    return "Close failed";
+
+  case D_GIF_ERR_NOT_READABLE:
+    return "File not opened for read";
+
+  case D_GIF_ERR_IMAGE_DEFECT:
+    return "Defective image";
+
+  case D_GIF_ERR_EOF_TOO_SOON:
+    return "Unexpected EOF - invalid file";
+
+  default:
+    sprintf(msg, "Unknown giflib error code %d", code);
+    return msg;
+  }
+}
+
+/* not fully implemented and tested */
+/* missing: set the first pointer to a,r,g,b */
+int readGIF(char *path, rasterBufferObj *rb) {
+  int codeSize, extCode, firstImageRead = MS_FALSE;
+  unsigned char *r, *g, *b, *a;
+  int transIdx = -1;
+  GifFileType *image;
+  GifPixelType *line;
+  GifRecordType recordType;
+  GifByteType *codeBlock, *extension;
+  ColorMapObject *cmap;
+  int interlacedOffsets[] = {0, 4, 2, 1};
+  int interlacedJumps[] = {8, 8, 4, 2};
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+  int errcode;
+#endif
+
+  rb->type = MS_BUFFER_BYTE_RGBA;
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+  image = DGifOpenFileName(path, &errcode);
+  if (image == NULL) {
+    msSetError(MS_MISCERR, "failed to load gif image: %s", "readGIF()",
+               gif_error_msg(errcode));
+    return MS_FAILURE;
+  }
+#else
+  image = DGifOpenFileName(path);
+  if (image == NULL) {
+    msSetError(MS_MISCERR, "failed to load gif image: %s", "readGIF()",
+               gif_error_msg());
+    return MS_FAILURE;
+  }
+#endif
+  rb->width = image->SWidth;
+  rb->height = image->SHeight;
+  rb->data.rgba.row_step = rb->width * 4;
+  rb->data.rgba.pixel_step = 4;
+  rb->data.rgba.pixels = (unsigned char *)malloc(sizeof(unsigned char) *
+                                                 rb->width * rb->height * 4);
+  b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
+  g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
+  r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
+  a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
+
+  cmap = (image->Image.ColorMap) ? image->Image.ColorMap : image->SColorMap;
+  for (unsigned i = 0; i < rb->width * rb->height; i++) {
+    *a = 255;
+    *r = cmap->Colors[image->SBackGroundColor].Red;
+    *g = cmap->Colors[image->SBackGroundColor].Green;
+    *b = cmap->Colors[image->SBackGroundColor].Blue;
+    a += rb->data.rgba.pixel_step;
+    r += rb->data.rgba.pixel_step;
+    g += rb->data.rgba.pixel_step;
+    b += rb->data.rgba.pixel_step;
+  }
+
+  do {
+    if (DGifGetRecordType(image, &recordType) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+      msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                 gif_error_msg(image->Error));
+#else
+      msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                 gif_error_msg());
+#endif
+      return MS_FAILURE;
+    }
+
+    switch (recordType) {
+    case SCREEN_DESC_RECORD_TYPE:
+      DGifGetScreenDesc(image);
+      break;
+    case IMAGE_DESC_RECORD_TYPE:
+      if (DGifGetImageDesc(image) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg(image->Error));
+#else
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg());
+#endif
+        return MS_FAILURE;
+      }
+      if (!firstImageRead) {
+
+        unsigned row = image->Image.Top;
+        unsigned col = image->Image.Left;
+        unsigned width = image->Image.Width;
+        unsigned height = image->Image.Height;
+
+        /* sanity check: */
+        if (col + width > rb->width || row + height > rb->height) {
+          msSetError(MS_MISCERR,
+                     "corrupted gif image, img size exceeds screen size",
+                     "readGIF()");
+          return MS_FAILURE;
+        }
+
+        line = (GifPixelType *)malloc(width * sizeof(GifPixelType));
+        if (image->Image.Interlace) {
+          int count;
+          for (count = 0; count < 4; count++) {
+            for (unsigned i = row + interlacedOffsets[count]; i < row + height;
+                 i += interlacedJumps[count]) {
+              int offset =
+                  i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
+              a = rb->data.rgba.a + offset;
+              r = rb->data.rgba.r + offset;
+              g = rb->data.rgba.g + offset;
+              b = rb->data.rgba.b + offset;
+              if (DGifGetLine(image, line, width) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+                msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                           gif_error_msg(image->Error));
+#else
+                msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                           gif_error_msg());
+#endif
+                return MS_FAILURE;
+              }
+
+              for (unsigned j = 0; j < width; j++) {
+                GifPixelType pix = line[j];
+                if (transIdx == -1 || pix != transIdx) {
+                  *a = 255;
+                  *r = cmap->Colors[pix].Red;
+                  *g = cmap->Colors[pix].Green;
+                  *b = cmap->Colors[pix].Blue;
+                } else {
+                  *a = *r = *g = *b = 0;
+                }
+                a += rb->data.rgba.pixel_step;
+                r += rb->data.rgba.pixel_step;
+                g += rb->data.rgba.pixel_step;
+                b += rb->data.rgba.pixel_step;
+              }
+            }
+          }
+        } else {
+          for (unsigned i = 0; i < height; i++) {
+            int offset =
+                i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
+            a = rb->data.rgba.a + offset;
+            r = rb->data.rgba.r + offset;
+            g = rb->data.rgba.g + offset;
+            b = rb->data.rgba.b + offset;
+            if (DGifGetLine(image, line, width) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+              msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                         gif_error_msg(image->Error));
+#else
+              msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                         gif_error_msg());
+#endif
+              return MS_FAILURE;
+            }
+            for (unsigned j = 0; j < width; j++) {
+              GifPixelType pix = line[j];
+              if (transIdx == -1 || pix != transIdx) {
+                *a = 255;
+                *r = cmap->Colors[pix].Red;
+                *g = cmap->Colors[pix].Green;
+                *b = cmap->Colors[pix].Blue;
+              } else {
+                *a = *r = *g = *b = 0;
+              }
+              a += rb->data.rgba.pixel_step;
+              r += rb->data.rgba.pixel_step;
+              g += rb->data.rgba.pixel_step;
+              b += rb->data.rgba.pixel_step;
+            }
+          }
+        }
+        free((char *)line);
+        firstImageRead = MS_TRUE;
+      } else {
+        /* Skip all next images */
+        if (DGifGetCode(image, &codeSize, &codeBlock) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg(image->Error));
+#else
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg());
+#endif
+          return MS_FAILURE;
+        }
+        while (codeBlock != NULL) {
+          if (DGifGetCodeNext(image, &codeBlock) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+            msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                       gif_error_msg(image->Error));
+#else
+            msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                       gif_error_msg());
+#endif
+            return MS_FAILURE;
+          }
+        }
+      }
+      break;
+    case EXTENSION_RECORD_TYPE:
+      /* skip all extension blocks */
+      if (DGifGetExtension(image, &extCode, &extension) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg(image->Error));
+#else
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg());
+#endif
+        return MS_FAILURE;
+      }
+      if (extCode == 249 && (extension[1] & 1))
+        transIdx = extension[4];
+      for (;;) {
+        if (DGifGetExtensionNext(image, &extension) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg(image->Error));
+#else
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg());
+#endif
+          return MS_FAILURE;
+        }
+        if (extension == NULL)
+          break;
+        if (extension[1] & 1)
+          transIdx = extension[4];
+      }
+      break;
+    case UNDEFINED_RECORD_TYPE:
+      break;
+    case TERMINATE_RECORD_TYPE:
+      break;
+    default:
+      break;
+    }
+
+  } while (recordType != TERMINATE_RECORD_TYPE);
+
+#if defined GIFLIB_MAJOR && GIFLIB_MINOR &&                                    \
+    ((GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1) || (GIFLIB_MAJOR > 5))
+  if (DGifCloseFile(image, &errcode) == GIF_ERROR) {
+    msSetError(MS_MISCERR, "failed to close gif after loading: %s", "readGIF()",
+               gif_error_msg(errcode));
+    return MS_FAILURE;
+  }
+#else
+  if (DGifCloseFile(image) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+    msSetError(MS_MISCERR, "failed to close gif after loading: %s", "readGIF()",
+               gif_error_msg(image->Error));
+#else
+    msSetError(MS_MISCERR, "failed to close gif after loading: %s", "readGIF()",
+               gif_error_msg());
+#endif
+    return MS_FAILURE;
+  }
+#endif
+
+  return MS_SUCCESS;
+}
+#endif
+
+int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb) {
+  FILE *stream;
+  unsigned char signature[8];
+  int ret = MS_FAILURE;
+  stream = fopen(path, "rb");
+  if (!stream) {
+    msSetError(MS_MISCERR, "unable to open file %s for reading",
+               "msLoadMSRasterBufferFromFile()", path);
+    return MS_FAILURE;
+  }
+  if (1 != fread(signature, 8, 1, stream)) {
+    fclose(stream);
+    msSetError(MS_MISCERR, "Unable to read header from image file %s",
+               "msLoadMSRasterBufferFromFile()", path);
+    return MS_FAILURE;
+  }
+  fclose(stream);
+  if (png_sig_cmp(signature, 0, 8) == 0) {
+    ret = readPNG(path, rb);
+  } else if (!strncmp((char *)signature, "GIF", 3)) {
+#ifdef USE_GIF
+    ret = readGIF(path, rb);
+#else
+    msSetError(MS_MISCERR,
+               "pixmap %s seems to be GIF formatted, but this server is "
+               "compiled without GIF support",
+               "readImage()", path);
+    return MS_FAILURE;
+#endif
+  } else {
+    msSetError(MS_MISCERR, "unsupported pixmap format", "readImage()");
+    return MS_FAILURE;
+  }
+  return ret;
+}
diff -pruN 8.0.1-5/src/mapimagemap.c 8.2.0~beta1-1~exp1/src/mapimagemap.c
--- 8.0.1-5/src/mapimagemap.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapimagemap.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,745 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implements imagemap outputformat support.
+ * Author:   Attila Csipa
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "dxfcolor.h"
+
+#include <stdarg.h>
+#include <time.h>
+
+#ifdef _WIN32
+#include <fcntl.h>
+#include <io.h>
+#endif
+
+#define MYDEBUG 0
+#define DEBUG_IF if (MYDEBUG > 2)
+
+/*
+ * Client-side imagemap support was originally written by
+ * Attila Csipa (http://prometheus.org.yu/me.php).  C. Scott Ananian
+ * (http://cscott.net) cleaned up the code somewhat and made it more flexible:
+ * you can now customize the generated HREFs and create mouseover and
+ * mouseout attributes.
+ *
+ * Use
+ *   IMAGETYPE imagemap
+ * to select this driver.
+ *
+ * The following FORMATOPTIONs are available. If any are set to the empty
+ * string the associated attribute will be suppressed.
+ *   POLYHREF   the href string to use for the <area> elements.
+ *              use a %s to interpolate the area title.
+ *              default:   "javascript:Clicked('%s');"
+ *   POLYMOUSEOVER the onMouseOver string to use for the <area> elements.
+ *              use a %s to interpolate the area title.
+ *              default:   "" (ie the attribute is suppressed)
+ *   POLYMOUSEOUT the onMouseOut string to use for the <area> elements.
+ *              use a %s to interpolate the area title.
+ *              default:   "" (ie the attribute is suppressed)
+ *   SYMBOLMOUSEOVER and SYMBOLMOUSEOUT are equivalent properties for
+ *              <area> tags representing symbols, with the same defaults.
+ *   MAPNAME    the string which will be used in the name attribute
+ *              of the <map> tag.  There is no %s interpolation.
+ *              default: "map1"
+ *   SUPPRESS   if "yes", then we will suppress area declarations with
+ *              no title.
+ *              default: "NO"
+ *
+ * For example, http://vevo.verifiedvoting.org/verifier contains this
+ * .map file fragment:
+ *         OUTPUTFORMAT
+ *              NAME imagemap
+ *              DRIVER imagemap
+ *              FORMATOPTION "POLYHREF=/verifier/map.php?state=%s"
+ *              FORMATOPTION "SYMBOLHREF=#"
+ *              FORMATOPTION "SUPPRESS=YES"
+ *              FORMATOPTION "MAPNAME=map-48"
+ *              FORMATOPTION "POLYMOUSEOUT=return nd();"
+ *              FORMATOPTION "POLYMOUSEOVER=return overlib('%s');"
+ *         END
+ */
+
+/*-------------------------------------------------------------------------*/
+
+/* A pString is a variable-length (appendable) string, stored as a triple:
+ * character pointer, allocated length, and used length.  The one wrinkle
+ * is that we use pointers to the allocated size and character pointer,
+ * in order to support refering to fields declared elsewhere (ie in the
+ * 'image' data structure) for these.  The 'iprintf' function appends
+ * to a pString. */
+typedef struct pString {
+  /* these two fields are somewhere else */
+  char **string;
+  int *alloc_size;
+  /* this field is stored locally. */
+  int string_len;
+} pString;
+/* These are the pStrings we declare statically.  One is the 'output'
+ * imagemap/dxf file; parts of this live in another data structure and
+ * are only referenced indirectly here.  The other contains layer-specific
+ * information for the dxf output. */
+static char *layerlist = NULL;
+static int layersize = 0;
+static pString imgStr, layerStr = {&layerlist, &layersize, 0};
+
+/* Format strings for the various bits of a client-side imagemap. */
+static const char *polyHrefFmt, *polyMOverFmt, *polyMOutFmt;
+static const char *symbolHrefFmt, *symbolMOverFmt, *symbolMOutFmt;
+static const char *mapName;
+/* Should we suppress AREA declarations in imagemaps with no title? */
+static int suppressEmpty = 0;
+
+/* Prevent buffer-overrun and format-string attacks by "sanitizing" any
+ * provided format string to fit the number of expected string arguments
+ * (MAX) exactly. */
+static const char *makeFmtSafe(const char *fmt, int MAX) {
+  /* format string should have exactly 'MAX' %s */
+
+  char *result = msSmallMalloc(strlen(fmt) + 1 + 3 * MAX), *cp;
+  int numstr = 0, saw_percent = 0;
+
+  strcpy(result, fmt);
+  for (cp = result; *cp; cp++) {
+    if (saw_percent) {
+      if (*cp == '%') {
+        /* safe */
+      } else if (*cp == 's' && numstr < MAX) {
+        numstr++; /* still safe */
+      } else {
+        /* disable this unsafe format string! */
+        *(cp - 1) = ' ';
+      }
+      saw_percent = 0;
+    } else if (*cp == '%')
+      saw_percent = 1;
+  }
+  /* fixup format strings without enough %s in them */
+  while (numstr < MAX) {
+    strcpy(cp, "%.s"); /* print using zero-length precision */
+    cp += 3;
+    numstr++;
+  }
+  return result;
+}
+
+/* Append the given printf-style formatted string to the pString 'ps'.
+ * This is much cleaner (and faster) than the technique this file
+ * used to use! */
+static void im_iprintf(pString *ps, const char *fmt, ...) {
+  int n, remaining;
+  va_list ap;
+  do {
+    remaining = *(ps->alloc_size) - ps->string_len;
+    va_start(ap, fmt);
+#if defined(HAVE_VSNPRINTF)
+    n = vsnprintf((*(ps->string)) + ps->string_len, remaining, fmt, ap);
+#else
+    /* If vsnprintf() is not available then require a minimum
+     * of 512 bytes of free space to prevent a buffer overflow
+     * This is not fully bulletproof but should help, see bug 1613
+     */
+    if (remaining < 512)
+      n = -1;
+    else
+      n = vsprintf((*(ps->string)) + ps->string_len, fmt, ap);
+#endif
+    va_end(ap);
+    /* if that worked, we're done! */
+    if (-1 < n && n < remaining) {
+      ps->string_len += n;
+      return;
+    } else {                  /* double allocated string size */
+      *(ps->alloc_size) *= 2; /* these keeps realloc linear.*/
+      if (*(ps->alloc_size) < 1024)
+        /* careful: initial size can be 0 */
+        *(ps->alloc_size) = 1024;
+      if (n > -1 && *(ps->alloc_size) <= (n + ps->string_len))
+        /* ensure at least as much as what is needed */
+        *(ps->alloc_size) = n + ps->string_len + 1;
+      *(ps->string) = (char *)msSmallRealloc(*(ps->string), *(ps->alloc_size));
+      /* if realloc doesn't work, we're screwed! */
+    }
+  } while (1); /* go back and try again. */
+}
+
+static int lastcolor = -1;
+static int matchdxfcolor(colorObj col) {
+  int best = 7;
+  int delta = 128 * 255;
+  int tcolor = 0;
+  if (lastcolor != -1)
+    return lastcolor;
+  while (tcolor < 256 &&
+         (ctable[tcolor].r != col.red || ctable[tcolor].g != col.green ||
+          ctable[tcolor].b != col.blue)) {
+    const int dr = ctable[tcolor].r - col.red;
+    const int dg = ctable[tcolor].g - col.green;
+    const int db = ctable[tcolor].b - col.blue;
+    const int newdelta = dr * dr + dg * dg + db * db;
+    if (newdelta < delta) {
+      best = tcolor;
+      delta = newdelta;
+    }
+    tcolor++;
+  }
+  if (tcolor >= 256)
+    tcolor = best;
+  /* DEBUG_IF printf("%d/%d/%d (%d/%d - %d), %d : %d/%d/%d<BR>\n",
+   * ctable[tcolor].r, ctable[tcolor].g, ctable[tcolor].b, tcolor, best, delta,
+   * lastcolor, col.red, col.green, col.blue); */
+  lastcolor = tcolor;
+  return tcolor;
+}
+
+static char *lname;
+static int dxf;
+
+void msImageStartLayerIM(mapObj *map, layerObj *layer, imageObj *image) {
+  (void)map;
+  (void)image;
+  DEBUG_IF printf("ImageStartLayerIM\n<BR>");
+  free(lname);
+  if (layer->name)
+    lname = msStrdup(layer->name);
+  else
+    lname = msStrdup("NONE");
+  if (dxf == 2) {
+    im_iprintf(&layerStr, "LAYER\n%s\n", lname);
+  } else if (dxf) {
+    im_iprintf(&layerStr,
+               "  0\nLAYER\n  2\n%s\n"
+               " 70\n  64\n 6\nCONTINUOUS\n",
+               lname);
+  }
+  lastcolor = -1;
+}
+
+/*
+ * Utility function to create a IM image. Returns
+ * a pointer to an imageObj structure.
+ */
+imageObj *msImageCreateIM(int width, int height, outputFormatObj *format,
+                          char *imagepath, char *imageurl, double resolution,
+                          double defresolution) {
+  imageObj *image = NULL;
+  if (setvbuf(stdout, NULL, _IONBF, 0)) {
+    printf("Whoops...");
+  };
+  DEBUG_IF printf("msImageCreateIM<BR>\n");
+  if (width > 0 && height > 0) {
+    image = (imageObj *)msSmallCalloc(1, sizeof(imageObj));
+    imgStr.string = &(image->img.imagemap);
+    imgStr.alloc_size = &(image->size);
+
+    image->format = format;
+    format->refcount++;
+
+    image->width = width;
+    image->height = height;
+    image->imagepath = NULL;
+    image->imageurl = NULL;
+    image->resolution = resolution;
+    image->resolutionfactor = resolution / defresolution;
+
+    if (strcasecmp("ON", msGetOutputFormatOption(format, "DXF", "OFF")) == 0) {
+      dxf = 1;
+      im_iprintf(&layerStr, "  2\nLAYER\n 70\n  10\n");
+    } else
+      dxf = 0;
+
+    if (strcasecmp("ON", msGetOutputFormatOption(format, "SCRIPT", "OFF")) ==
+        0) {
+      dxf = 2;
+      im_iprintf(&layerStr, "");
+    }
+
+    /* get href formation string options */
+    polyHrefFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "POLYHREF",
+                                            "javascript:Clicked('%s');"),
+                    1);
+    polyMOverFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "POLYMOUSEOVER", ""), 1);
+    polyMOutFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "POLYMOUSEOUT", ""), 1);
+    symbolHrefFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "SYMBOLHREF",
+                                            "javascript:SymbolClicked();"),
+                    1);
+    symbolMOverFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "SYMBOLMOUSEOVER", ""), 1);
+    symbolMOutFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "SYMBOLMOUSEOUT", ""), 1);
+    /* get name of client-side image map */
+    mapName = msGetOutputFormatOption(format, "MAPNAME", "map1");
+    /* should we suppress area declarations with no title? */
+    if (strcasecmp("YES", msGetOutputFormatOption(format, "SUPPRESS", "NO")) ==
+        0) {
+      suppressEmpty = 1;
+    }
+
+    lname = msStrdup("NONE");
+    *(imgStr.string) = msStrdup("");
+    if (*(imgStr.string)) {
+      *(imgStr.alloc_size) = imgStr.string_len = strlen(*(imgStr.string));
+    } else {
+      *(imgStr.alloc_size) = imgStr.string_len = 0;
+    }
+    if (imagepath) {
+      image->imagepath = msStrdup(imagepath);
+    }
+    if (imageurl) {
+      image->imageurl = msStrdup(imageurl);
+    }
+
+    return image;
+  } else {
+    msSetError(MS_IMGERR, "Cannot create IM image of size %d x %d.",
+               "msImageCreateIM()", width, height);
+  }
+  return image;
+}
+
+/* ------------------------------------------------------------------------- */
+/* Draw a single marker symbol of the specified size and color               */
+/* ------------------------------------------------------------------------- */
+void msDrawMarkerSymbolIM(mapObj *map, imageObj *img, pointObj *p,
+                          styleObj *style, double scalefactor) {
+  symbolObj *symbol;
+  int ox, oy;
+  double size;
+
+  DEBUG_IF printf("msDrawMarkerSymbolIM\n<BR>");
+
+  /* skip this, we don't do text */
+
+  if (!p)
+    return;
+
+  if (style->symbol > map->symbolset.numsymbols || style->symbol < 0)
+    return; /* no such symbol, 0 is OK */
+  symbol = map->symbolset.symbol[style->symbol];
+  ox = style->offsetx * scalefactor;
+  oy = style->offsety * scalefactor;
+  if (style->size == -1) {
+    size = msSymbolGetDefaultSize(symbol);
+    size = MS_NINT(size * scalefactor);
+  } else
+    size = MS_NINT(style->size * scalefactor);
+  size = MS_MAX(size, style->minsize * img->resolutionfactor);
+  size = MS_MIN(size, style->maxsize * img->resolutionfactor);
+
+  if (size < 1)
+    return; /* size too small */
+
+  /* DEBUG_IF printf(".%d.%d.%d.", symbol->type, style->symbol, fc); */
+  if (style->symbol ==
+      0) { /* simply draw a single pixel of the specified color */
+
+    if (dxf) {
+      if (dxf == 2)
+        im_iprintf(&imgStr, "POINT\n%.0f %.0f\n%d\n", p->x + ox, p->y + oy,
+                   matchdxfcolor(style->color));
+      else
+        im_iprintf(&imgStr,
+                   "  0\nPOINT\n 10\n%f\n 20\n%f\n 30\n0.0\n"
+                   " 62\n%6d\n  8\n%s\n",
+                   p->x + ox, p->y + oy, matchdxfcolor(style->color), lname);
+    } else {
+      im_iprintf(&imgStr, "<area ");
+      if (strcmp(symbolHrefFmt, "%.s") != 0) {
+        im_iprintf(&imgStr, "href=\"");
+        im_iprintf(&imgStr, symbolHrefFmt, lname);
+        im_iprintf(&imgStr, "\" ");
+      }
+      if (strcmp(symbolMOverFmt, "%.s") != 0) {
+        im_iprintf(&imgStr, "onMouseOver=\"");
+        im_iprintf(&imgStr, symbolMOverFmt, lname);
+        im_iprintf(&imgStr, "\" ");
+      }
+      if (strcmp(symbolMOutFmt, "%.s") != 0) {
+        im_iprintf(&imgStr, "onMouseOut=\"");
+        im_iprintf(&imgStr, symbolMOutFmt, lname);
+        im_iprintf(&imgStr, "\" ");
+      }
+      im_iprintf(&imgStr, "shape=\"circle\" coords=\"%.0f,%.0f, 3\" />\n",
+                 p->x + ox, p->y + oy);
+    }
+
+    /* point2 = &( p->line[j].point[i] ); */
+    /* if(point1->y == point2->y) {} */
+    return;
+  }
+  DEBUG_IF printf("A");
+  switch (symbol->type) {
+  case (MS_SYMBOL_TRUETYPE):
+    DEBUG_IF printf("T");
+    break;
+  case (MS_SYMBOL_PIXMAP):
+    DEBUG_IF printf("P");
+    break;
+  case (MS_SYMBOL_VECTOR):
+    DEBUG_IF printf("V");
+    {
+      double d, offset_x, offset_y;
+
+      d = size / symbol->sizey;
+      offset_x = MS_NINT(p->x - d * .5 * symbol->sizex + ox);
+      offset_y = MS_NINT(p->y - d * .5 * symbol->sizey + oy);
+
+      /* For now I only render filled vector symbols in imagemap, and no */
+      /* dxf support available yet.  */
+      if (symbol->filled && !dxf /* && fc >= 0 */) {
+        /* char *title=(p->numvalues) ? p->values[0] : ""; */
+        char *title = "";
+        int j;
+
+        im_iprintf(&imgStr, "<area ");
+        if (strcmp(symbolHrefFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "href=\"");
+          im_iprintf(&imgStr, symbolHrefFmt, lname);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(symbolMOverFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOver=\"");
+          im_iprintf(&imgStr, symbolMOverFmt, lname);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(symbolMOutFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOut=\"");
+          im_iprintf(&imgStr, symbolMOutFmt, lname);
+          im_iprintf(&imgStr, "\" ");
+        }
+
+        im_iprintf(&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
+
+        for (j = 0; j < symbol->numpoints; j++) {
+          im_iprintf(&imgStr, "%s %d,%d", j == 0 ? "" : ",",
+                     (int)MS_NINT(d * symbol->points[j].x + offset_x),
+                     (int)MS_NINT(d * symbol->points[j].y + offset_y));
+        }
+        im_iprintf(&imgStr, "\" />\n");
+      } /* end of imagemap, filled case. */
+    }
+    break;
+
+  default:
+    DEBUG_IF printf("DEF");
+    break;
+  } /* end switch statement */
+
+  return;
+}
+
+/* ------------------------------------------------------------------------- */
+/* Draw a line symbol of the specified size and color                        */
+/* ------------------------------------------------------------------------- */
+void msDrawLineSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                        styleObj *style, double scalefactor_ignored) {
+  (void)img;
+  (void)scalefactor_ignored;
+  symbolObj *symbol;
+  int i, j, l;
+  char first = 1;
+  DEBUG_IF printf("msDrawLineSymbolIM<BR>\n");
+
+  if (!p)
+    return;
+  if (p->numlines <= 0)
+    return;
+
+  if (style->symbol > map->symbolset.numsymbols || style->symbol < 0)
+    return; /* no such symbol, 0 is OK */
+  symbol = map->symbolset.symbol[style->symbol];
+
+  if (suppressEmpty && p->numvalues == 0)
+    return;                 /* suppress area with empty title */
+  if (style->symbol == 0) { /* just draw a single width line */
+    for (l = 0, j = 0; j < p->numlines; j++) {
+      if (dxf == 2) {
+        im_iprintf(&imgStr, "LINE\n%d\n", matchdxfcolor(style->color));
+      } else if (dxf) {
+        im_iprintf(&imgStr, "  0\nPOLYLINE\n 70\n     0\n 62\n%6d\n  8\n%s\n",
+                   matchdxfcolor(style->color), lname);
+      } else {
+        char *title;
+
+        first = 1;
+        title = (p->numvalues) ? p->values[0] : "";
+        im_iprintf(&imgStr, "<area ");
+        if (strcmp(polyHrefFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "href=\"");
+          im_iprintf(&imgStr, polyHrefFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(polyMOverFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOver=\"");
+          im_iprintf(&imgStr, polyMOverFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(polyMOutFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOut=\"");
+          im_iprintf(&imgStr, polyMOutFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        im_iprintf(&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
+      }
+      /* point1 = &( p->line[j].point[p->line[j].numpoints-1] ); */
+      for (i = 0; i < p->line[j].numpoints; i++, l++) {
+        if (dxf == 2) {
+          im_iprintf(&imgStr, "%.0f %.0f\n", p->line[j].point[i].x,
+                     p->line[j].point[i].y);
+        } else if (dxf) {
+          im_iprintf(&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n",
+                     p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
+        } else {
+          im_iprintf(&imgStr, "%s %.0f,%.0f", first ? "" : ",",
+                     p->line[j].point[i].x, p->line[j].point[i].y);
+        }
+        first = 0;
+
+        /* point2 = &( p->line[j].point[i] ); */
+        /* if(point1->y == point2->y) {} */
+      }
+      im_iprintf(&imgStr, dxf ? (dxf == 2 ? "" : "  0\nSEQEND\n") : "\" />\n");
+    }
+
+    /* DEBUG_IF printf ("%d, ",strlen(img->img.imagemap) ); */
+    return;
+  }
+
+  DEBUG_IF printf("-%d-", symbol->type);
+
+  return;
+}
+
+/* ------------------------------------------------------------------------- */
+/* Draw a shade symbol of the specified size and color                       */
+/* ------------------------------------------------------------------------- */
+void msDrawShadeSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                         styleObj *style, double scalefactor_ignored) {
+  (void)img;
+  (void)scalefactor_ignored;
+  symbolObj *symbol;
+  int i, j, l;
+  char first = 1;
+
+  DEBUG_IF printf("msDrawShadeSymbolIM\n<BR>");
+  if (!p)
+    return;
+  if (p->numlines <= 0)
+    return;
+
+  symbol = map->symbolset.symbol[style->symbol];
+
+  if (suppressEmpty && p->numvalues == 0)
+    return; /* suppress area with empty title */
+  if (style->symbol ==
+      0) { /* simply draw a single pixel of the specified color //     */
+    for (l = 0, j = 0; j < p->numlines; j++) {
+      if (dxf == 2) {
+        im_iprintf(&imgStr, "POLY\n%d\n", matchdxfcolor(style->color));
+      } else if (dxf) {
+        im_iprintf(&imgStr, "  0\nPOLYLINE\n 73\n     1\n 62\n%6d\n  8\n%s\n",
+                   matchdxfcolor(style->color), lname);
+      } else {
+        char *title = (p->numvalues) ? p->values[0] : "";
+        first = 1;
+        im_iprintf(&imgStr, "<area ");
+        if (strcmp(polyHrefFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "href=\"");
+          im_iprintf(&imgStr, polyHrefFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(polyMOverFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOver=\"");
+          im_iprintf(&imgStr, polyMOverFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(polyMOutFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOut=\"");
+          im_iprintf(&imgStr, polyMOutFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        im_iprintf(&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
+      }
+
+      /* point1 = &( p->line[j].point[p->line[j].numpoints-1] ); */
+      for (i = 0; i < p->line[j].numpoints; i++, l++) {
+        if (dxf == 2) {
+          im_iprintf(&imgStr, "%.0f %.0f\n", p->line[j].point[i].x,
+                     p->line[j].point[i].y);
+        } else if (dxf) {
+          im_iprintf(&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n",
+                     p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
+        } else {
+          im_iprintf(&imgStr, "%s %.0f,%.0f", first ? "" : ",",
+                     p->line[j].point[i].x, p->line[j].point[i].y);
+        }
+        first = 0;
+
+        /* point2 = &( p->line[j].point[i] ); */
+        /* if(point1->y == point2->y) {} */
+      }
+      im_iprintf(&imgStr, dxf ? (dxf == 2 ? "" : "  0\nSEQEND\n") : "\" />\n");
+    }
+
+    return;
+  }
+  /* DEBUG_IF printf ("d"); */
+  DEBUG_IF printf("-%d-", symbol->type);
+  return;
+}
+
+/*
+ * Simply draws a label based on the label point and the supplied label object.
+ */
+int msDrawTextIM(mapObj *map, imageObj *img, pointObj labelPnt, char *string,
+                 labelObj *label, double scalefactor) {
+  (void)map;
+  (void)img;
+  DEBUG_IF printf("msDrawText<BR>\n");
+  if (!string)
+    return (0); /* not errors, just don't want to do anything */
+  if (strlen(string) == 0)
+    return (0);
+  if (!dxf)
+    return (0);
+
+  if (dxf == 2) {
+    im_iprintf(&imgStr, "TEXT\n%d\n%s\n%.0f\n%.0f\n%.0f\n",
+               matchdxfcolor(label->color), string, labelPnt.x, labelPnt.y,
+               -label->angle);
+  } else {
+    im_iprintf(&imgStr,
+               "  0\nTEXT\n  1\n%s\n 10\n%f\n 20\n%f\n 30\n0.0\n 40\n%f\n "
+               "50\n%f\n 62\n%6d\n  8\n%s\n 73\n   2\n 72\n   1\n",
+               string, labelPnt.x, labelPnt.y, label->size * scalefactor * 100,
+               -label->angle, matchdxfcolor(label->color), lname);
+  }
+  return (0);
+}
+
+/*
+ * Save an image to a file named filename, if filename is NULL it goes to stdout
+ */
+
+int msSaveImageIM(imageObj *img, const char *filename, outputFormatObj *format)
+
+{
+  FILE *stream_to_free = NULL;
+  FILE *stream;
+  char workbuffer[5000];
+
+  DEBUG_IF printf("msSaveImageIM\n<BR>");
+
+  if (filename != NULL && strlen(filename) > 0) {
+    stream_to_free = fopen(filename, "wb");
+    if (!stream_to_free) {
+      msSetError(MS_IOERR, "(%s)", "msSaveImage()", filename);
+      return (MS_FAILURE);
+    }
+    stream = stream_to_free;
+  } else { /* use stdout */
+
+#ifdef _WIN32
+    /*
+     * Change stdout mode to binary on win32 platforms
+     */
+    if (_setmode(_fileno(stdout), _O_BINARY) == -1) {
+      msSetError(MS_IOERR, "Unable to change stdout to binary mode.",
+                 "msSaveImage()");
+      return (MS_FAILURE);
+    }
+#endif
+    stream = stdout;
+  }
+
+  if (strcasecmp(format->driver, "imagemap") == 0) {
+    DEBUG_IF printf("ALLOCD %d<BR>\n", img->size);
+    /* DEBUG_IF printf("F %s<BR>\n", img->img.imagemap); */
+    DEBUG_IF printf("FLEN %d<BR>\n", (int)strlen(img->img.imagemap));
+    if (dxf == 2) {
+      msIO_fprintf(stream, "%s", layerlist);
+    } else if (dxf) {
+      msIO_fprintf(
+          stream,
+          "  0\nSECTION\n  2\nHEADER\n  9\n$ACADVER\n  1\nAC1009\n0\nENDSEC\n  "
+          "0\nSECTION\n  2\nTABLES\n  0\nTABLE\n%s0\nENDTAB\n0\nENDSEC\n  "
+          "0\nSECTION\n  2\nBLOCKS\n0\nENDSEC\n  0\nSECTION\n  2\nENTITIES\n",
+          layerlist);
+    } else {
+      msIO_fprintf(stream, "<map name=\"%s\" width=\"%d\" height=\"%d\">\n",
+                   mapName, img->width, img->height);
+    }
+    const int nSize = sizeof(workbuffer);
+
+    const int size = strlen(img->img.imagemap);
+    if (size > nSize) {
+      int iIndice = 0;
+      while ((iIndice + nSize) <= size) {
+        snprintf(workbuffer, sizeof(workbuffer), "%s",
+                 img->img.imagemap + iIndice);
+        workbuffer[nSize - 1] = '\0';
+        msIO_fwrite(workbuffer, strlen(workbuffer), 1, stream);
+        iIndice += nSize - 1;
+      }
+      if (iIndice < size) {
+        sprintf(workbuffer, "%s", img->img.imagemap + iIndice);
+        msIO_fprintf(stream, "%s", workbuffer);
+      }
+    } else
+      msIO_fwrite(img->img.imagemap, size, 1, stream);
+    if (strcasecmp("OFF",
+                   msGetOutputFormatOption(format, "SKIPENDTAG", "OFF")) == 0) {
+      if (dxf == 2)
+        msIO_fprintf(stream, "END");
+      else if (dxf)
+        msIO_fprintf(stream, "0\nENDSEC\n0\nEOF\n");
+      else
+        msIO_fprintf(stream, "</map>");
+    }
+  } else {
+    msSetError(MS_MISCERR, "Unknown output image type driver: %s.",
+               "msSaveImage()", format->driver);
+    if (stream_to_free != NULL)
+      fclose(stream_to_free);
+    return (MS_FAILURE);
+  }
+
+  if (stream_to_free != NULL)
+    fclose(stream_to_free);
+  return (MS_SUCCESS);
+}
+
+/*
+ * Free gdImagePtr
+ */
+void msFreeImageIM(imageObj *img) { free(img->img.imagemap); }
diff -pruN 8.0.1-5/src/mapio.c 8.2.0~beta1-1~exp1/src/mapio.c
--- 8.0.1-5/src/mapio.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapio.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1066 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementations for MapServer IO redirection capability.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2004, Frank Warmerdam <warmerdam@pobox.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <stdarg.h>
+
+#include "mapserver.h"
+#include "mapthread.h"
+
+#ifdef _WIN32
+#include <fcntl.h>
+#include <io.h>
+#endif
+
+#ifdef MOD_WMS_ENABLED
+#include "httpd.h"
+#include "apr_strings.h"
+#endif
+
+static int is_msIO_initialized = MS_FALSE;
+static int is_msIO_header_enabled = MS_TRUE;
+
+typedef struct msIOContextGroup_t {
+  msIOContext stdin_context;
+  msIOContext stdout_context;
+  msIOContext stderr_context;
+
+  void *thread_id;
+  struct msIOContextGroup_t *next;
+} msIOContextGroup;
+
+static msIOContextGroup default_contexts;
+static msIOContextGroup *io_context_list = NULL;
+static void msIO_Initialize(void);
+
+#ifdef msIO_printf
+#undef msIO_printf
+#undef msIO_fprintf
+#undef msIO_fwrite
+#undef msIO_fread
+#undef msIO_vfprintf
+#endif
+
+/************************************************************************/
+/*                            msIO_Cleanup()                            */
+/************************************************************************/
+
+void msIO_Cleanup()
+
+{
+  if (is_msIO_initialized)
+
+  {
+    is_msIO_initialized = MS_FALSE;
+    while (io_context_list != NULL) {
+      msIOContextGroup *last = io_context_list;
+      io_context_list = io_context_list->next;
+      free(last);
+    }
+  }
+}
+
+/************************************************************************/
+/*                        msIO_GetContextGroup()                        */
+/************************************************************************/
+
+static msIOContextGroup *msIO_GetContextGroup()
+
+{
+  void *nThreadId = msGetThreadId();
+  msIOContextGroup *prev = NULL, *group = io_context_list;
+
+  if (group != NULL && group->thread_id == nThreadId)
+    return group;
+
+  /* -------------------------------------------------------------------- */
+  /*      Search for group for this thread                                */
+  /* -------------------------------------------------------------------- */
+  msAcquireLock(TLOCK_IOCONTEXT);
+  msIO_Initialize();
+
+  group = io_context_list;
+  while (group != NULL && group->thread_id != nThreadId) {
+    prev = group;
+    group = group->next;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If we found it, make sure it is pushed to the front of the      */
+  /*      link for faster finding next time, and return it.               */
+  /* -------------------------------------------------------------------- */
+  if (group != NULL) {
+    if (prev != NULL) {
+      prev->next = group->next;
+      group->next = io_context_list;
+      io_context_list = group;
+    }
+
+    msReleaseLock(TLOCK_IOCONTEXT);
+    return group;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create a new context group for this thread.                     */
+  /* -------------------------------------------------------------------- */
+  group = (msIOContextGroup *)calloc(sizeof(msIOContextGroup), 1);
+
+  group->stdin_context = default_contexts.stdin_context;
+  group->stdout_context = default_contexts.stdout_context;
+  group->stderr_context = default_contexts.stderr_context;
+  group->thread_id = nThreadId;
+
+  group->next = io_context_list;
+  io_context_list = group;
+
+  msReleaseLock(TLOCK_IOCONTEXT);
+
+  return group;
+}
+
+/* returns MS_TRUE if the msIO standard output hasn't been redirected */
+int msIO_isStdContext() {
+  msIOContextGroup *group = io_context_list;
+  void *nThreadId = msGetThreadId();
+  if (!group || group->thread_id != nThreadId) {
+    group = msIO_GetContextGroup();
+    if (!group) {
+      return MS_FALSE; /* probably a bug */
+    }
+  }
+  if (group->stderr_context.cbData == (void *)stderr &&
+      group->stdin_context.cbData == (void *)stdin &&
+      group->stdout_context.cbData == (void *)stdout)
+    return MS_TRUE;
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                          msIO_getHandler()                           */
+/************************************************************************/
+
+msIOContext *msIO_getHandler(FILE *fp)
+
+{
+  void *nThreadId = msGetThreadId();
+  msIOContextGroup *group = io_context_list;
+
+  msIO_Initialize();
+
+  if (group == NULL || group->thread_id != nThreadId) {
+    group = msIO_GetContextGroup();
+    if (group == NULL)
+      return NULL;
+  }
+
+  if (fp == stdin || fp == NULL || strcmp((const char *)fp, "stdin") == 0)
+    return &(group->stdin_context);
+  else if (fp == stdout || strcmp((const char *)fp, "stdout") == 0)
+    return &(group->stdout_context);
+  else if (fp == stderr || strcmp((const char *)fp, "stderr") == 0)
+    return &(group->stderr_context);
+  else
+    return NULL;
+}
+
+/************************************************************************/
+/*                      msIO_setHeaderEnabled()                         */
+/************************************************************************/
+
+void msIO_setHeaderEnabled(int bFlag) { is_msIO_header_enabled = bFlag; }
+
+/************************************************************************/
+/*                           msIO_setHeader()                           */
+/************************************************************************/
+
+void msIO_setHeader(const char *header, const char *value, ...) {
+  va_list args;
+  va_start(args, value);
+#ifdef MOD_WMS_ENABLED
+  msIOContext *ioctx = msIO_getHandler(stdout);
+  if (ioctx && !strcmp(ioctx->label, "apache")) {
+
+    request_rec *r = (request_rec *)(ioctx->cbData);
+    char *fullvalue = apr_pvsprintf(r->pool, value, args);
+    if (strcasecmp(header, "Content-Type") == 0) {
+      r->content_type = fullvalue;
+    } else if (strcasecmp(header, "Status") == 0) {
+      r->status = atoi(fullvalue);
+    } else {
+      apr_table_setn(r->headers_out, apr_pstrdup(r->pool, header), fullvalue);
+    }
+  } else {
+#endif // MOD_WMS_ENABLED
+    if (is_msIO_header_enabled) {
+      msIO_fprintf(stdout, "%s: ", header);
+      msIO_vfprintf(stdout, value, args);
+      msIO_fprintf(stdout, "\r\n");
+    }
+#ifdef MOD_WMS_ENABLED
+  }
+#endif
+  va_end(args);
+}
+
+void msIO_sendHeaders() {
+#ifdef MOD_WMS_ENABLED
+  msIOContext *ioctx = msIO_getHandler(stdout);
+  if (ioctx && !strcmp(ioctx->label, "apache"))
+    return;
+#endif // !MOD_WMS_ENABLED
+  if (is_msIO_header_enabled) {
+    msIO_printf("\r\n");
+    fflush(stdout);
+  }
+}
+
+/************************************************************************/
+/*                        msIO_installHandlers()                        */
+/************************************************************************/
+
+int msIO_installHandlers(msIOContext *stdin_context,
+                         msIOContext *stdout_context,
+                         msIOContext *stderr_context)
+
+{
+  msIOContextGroup *group;
+
+  msIO_Initialize();
+
+  group = msIO_GetContextGroup();
+
+  if (stdin_context == NULL)
+    group->stdin_context = default_contexts.stdin_context;
+  else if (stdin_context != &group->stdin_context)
+    group->stdin_context = *stdin_context;
+
+  if (stdout_context == NULL)
+    group->stdout_context = default_contexts.stdout_context;
+  else if (stdout_context != &group->stdout_context)
+    group->stdout_context = *stdout_context;
+
+  if (stderr_context == NULL)
+    group->stderr_context = default_contexts.stderr_context;
+  else if (stderr_context != &group->stderr_context)
+    group->stderr_context = *stderr_context;
+
+  return MS_TRUE;
+}
+
+/************************************************************************/
+/*                          msIO_contextRead()                          */
+/************************************************************************/
+
+int msIO_contextRead(msIOContext *context, void *data, int byteCount)
+
+{
+  if (context->write_channel == MS_TRUE)
+    return 0;
+  else
+    return context->readWriteFunc(context->cbData, data, byteCount);
+}
+
+/************************************************************************/
+/*                         msIO_contextWrite()                          */
+/************************************************************************/
+
+int msIO_contextWrite(msIOContext *context, const void *data, int byteCount)
+
+{
+  if (context->write_channel == MS_FALSE)
+    return 0;
+  else
+    return context->readWriteFunc(context->cbData, (void *)data, byteCount);
+}
+
+/* ==================================================================== */
+/* ==================================================================== */
+/*      Stdio-like cover functions.                                     */
+/* ==================================================================== */
+/* ==================================================================== */
+
+/************************************************************************/
+/*                            _ms_vsprintf()                            */
+/************************************************************************/
+
+static int _ms_vsprintf(char **workBufPtr, const char *format, va_list ap)
+
+{
+  int ret_val;
+  int workBufSize = 16000;
+
+  *workBufPtr = (char *)malloc(workBufSize * sizeof(char));
+  if (*workBufPtr == NULL) {
+    msSetError(MS_MEMERR, NULL, "_ms_vsprintf()");
+    return -1;
+  }
+
+#if defined(HAVE_VSNPRINTF)
+  /* This should grow a big enough buffer to hold any formatted result. */
+  {
+    va_list wrk_args;
+
+#ifdef va_copy
+    va_copy(wrk_args, ap);
+#else
+    wrk_args = ap;
+#endif
+
+    while ((ret_val = vsnprintf(*workBufPtr, workBufSize, format, wrk_args)) >=
+               workBufSize - 1 ||
+           ret_val == -1) {
+      workBufSize *= 4;
+      *workBufPtr = (char *)realloc(*workBufPtr, workBufSize);
+      if (*workBufPtr == NULL) {
+        msSetError(MS_MEMERR, NULL, "_ms_vsprintf()");
+        va_end(wrk_args);
+        return -1;
+      }
+#ifdef va_copy
+      va_end(wrk_args);
+      va_copy(wrk_args, ap);
+#else
+      wrk_args = ap;
+#endif
+    }
+    va_end(wrk_args);
+  }
+#else
+  /* We do not have vsnprintf()... there is a risk of buffer overrun */
+  ret_val = vsprintf(*workBufPtr, format, ap);
+
+  if (ret_val < 0 || ret_val >= workBufSize) {
+    msSetError(MS_MISCERR, "Possible buffer overrun.", "_ms_vsprintf()");
+    msFree(*workBufPtr);
+    *workBufPtr = NULL;
+    return -1;
+  }
+#endif
+
+  return ret_val;
+}
+
+/************************************************************************/
+/*                            msIO_printf()                             */
+/************************************************************************/
+
+int msIO_printf(const char *format, ...)
+
+{
+  va_list args;
+  int ret;
+  va_start(args, format);
+  ret = msIO_vfprintf(stdout, format, args);
+  va_end(args);
+  return ret;
+}
+
+/************************************************************************/
+/*                            msIO_fprintf()                            */
+/************************************************************************/
+
+int msIO_fprintf(FILE *fp, const char *format, ...)
+
+{
+  va_list args;
+  int ret;
+  va_start(args, format);
+  ret = msIO_vfprintf(fp, format, args);
+  va_end(args);
+  return ret;
+}
+
+/************************************************************************/
+/*                            msIO_vfprintf()                           */
+/************************************************************************/
+
+int msIO_vfprintf(FILE *fp, const char *format, va_list ap)
+
+{
+  int return_val;
+  msIOContext *context;
+  char workBuf[8000];
+
+#if !defined(HAVE_VSNPRINTF)
+  return_val = vsprintf(workBuf, format, ap);
+
+  if (return_val < 0 || return_val >= sizeof(workBuf)) {
+    msSetError(MS_MISCERR, "Possible buffer overrun.", "msIO_vfprintf()");
+    return -1;
+  }
+
+  char *outbuf = workBuf;
+
+#else
+
+  va_list args_copy;
+#ifdef va_copy
+  va_copy(args_copy, ap);
+#else
+  args_copy = ap;
+#endif /* va_copy */
+
+  char *largerBuf = NULL;
+  return_val = vsnprintf(workBuf, sizeof(workBuf), format, ap);
+  if (return_val == -1 || return_val >= (int)sizeof(workBuf) - 1) {
+    return_val = _ms_vsprintf(&largerBuf, format, args_copy);
+  }
+  va_end(args_copy);
+
+  if (return_val < 0)
+    return -1;
+
+  char *outbuf = largerBuf ? largerBuf : workBuf;
+
+#endif /* HAVE_VSNPRINTF */
+
+  context = msIO_getHandler(fp);
+  if (context == NULL)
+    return_val = fwrite(outbuf, 1, return_val, fp);
+  else
+    return_val = msIO_contextWrite(context, outbuf, return_val);
+
+#if defined(HAVE_VSNPRINTF)
+  msFree(largerBuf);
+#endif
+
+  return return_val;
+}
+
+/************************************************************************/
+/*                            msIO_fwrite()                             */
+/************************************************************************/
+
+int msIO_fwrite(const void *data, size_t size, size_t nmemb, FILE *fp)
+
+{
+  msIOContext *context;
+
+  if (size == 0 || nmemb == 0)
+    return 0;
+
+  context = msIO_getHandler(fp);
+  if (context == NULL)
+    return fwrite(data, size, nmemb, fp);
+  else
+    return msIO_contextWrite(context, data, size * nmemb) / size;
+}
+
+/************************************************************************/
+/*                            msIO_fread()                              */
+/************************************************************************/
+
+int msIO_fread(void *data, size_t size, size_t nmemb, FILE *fp)
+
+{
+  msIOContext *context;
+
+  if (size == 0 || nmemb == 0)
+    return 0;
+
+  context = msIO_getHandler(fp);
+  if (context == NULL)
+    return fread(data, size, nmemb, fp);
+  else
+    return msIO_contextRead(context, data, size * nmemb) / size;
+}
+
+/* ==================================================================== */
+/* ==================================================================== */
+/*      Internal default callbacks implementing stdio reading and       */
+/*      writing.                                                        */
+/* ==================================================================== */
+/* ==================================================================== */
+
+/************************************************************************/
+/*                           msIO_stdioRead()                           */
+/*                                                                      */
+/*      This is the default implementation via stdio.                   */
+/************************************************************************/
+
+static int msIO_stdioRead(void *cbData, void *data, int byteCount)
+
+{
+  return fread(data, 1, byteCount, (FILE *)cbData);
+}
+
+/************************************************************************/
+/*                          msIO_stdioWrite()                           */
+/*                                                                      */
+/*      This is the default implementation via stdio.                   */
+/************************************************************************/
+
+static int msIO_stdioWrite(void *cbData, void *data, int byteCount)
+
+{
+  return fwrite(data, 1, byteCount, (FILE *)cbData);
+}
+
+/************************************************************************/
+/*                          msIO_Initialize()                           */
+/************************************************************************/
+
+static void msIO_Initialize(void)
+
+{
+  if (is_msIO_initialized == MS_TRUE)
+    return;
+
+  default_contexts.stdin_context.label = "stdio";
+  default_contexts.stdin_context.write_channel = MS_FALSE;
+  default_contexts.stdin_context.readWriteFunc = msIO_stdioRead;
+  default_contexts.stdin_context.cbData = (void *)stdin;
+
+  default_contexts.stdout_context.label = "stdio";
+  default_contexts.stdout_context.write_channel = MS_TRUE;
+  default_contexts.stdout_context.readWriteFunc = msIO_stdioWrite;
+  default_contexts.stdout_context.cbData = (void *)stdout;
+
+  default_contexts.stderr_context.label = "stdio";
+  default_contexts.stderr_context.write_channel = MS_TRUE;
+  default_contexts.stderr_context.readWriteFunc = msIO_stdioWrite;
+  default_contexts.stderr_context.cbData = (void *)stderr;
+
+  default_contexts.next = NULL;
+  default_contexts.thread_id = 0;
+
+  is_msIO_initialized = MS_TRUE;
+}
+
+/* ==================================================================== */
+/* ==================================================================== */
+/*      FastCGI output redirection functions.                           */
+/* ==================================================================== */
+/* ==================================================================== */
+
+/************************************************************************/
+/*                       msIO_needBinaryStdout()                        */
+/*                                                                      */
+/*      This function is intended to ensure that stdout is in binary    */
+/*      mode.                                                           */
+/*                                                                      */
+/*      But don't do it we are using FastCGI.  We will take care of     */
+/*      doing it in the libfcgi library in that case for the normal     */
+/*      cgi case, and for the fastcgi case the _setmode() call          */
+/*      causes a crash.                                                 */
+/************************************************************************/
+
+int msIO_needBinaryStdout()
+
+{
+#if defined(_WIN32) && !defined(USE_FASTCGI)
+  if (_setmode(_fileno(stdout), _O_BINARY) == -1) {
+    msSetError(MS_IOERR, "Unable to change stdout to binary mode.",
+               "msIO_needBinaryStdout()");
+    return (MS_FAILURE);
+  }
+#endif
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                        msIO_needBinaryStdin()                        */
+/*                                                                      */
+/*      This function is intended to ensure that stdin is in binary     */
+/*      mode.                                                           */
+/*                                                                      */
+/*      But don't do it we are using FastCGI.  We will take care of     */
+/*      doing it in the libfcgi library in that case for the normal     */
+/*      cgi case, and for the fastcgi case the _setmode() call          */
+/*      causes a crash.                                                 */
+/************************************************************************/
+
+int msIO_needBinaryStdin()
+
+{
+#if defined(_WIN32) && !defined(USE_FASTCGI)
+  if (_setmode(_fileno(stdin), _O_BINARY) == -1) {
+    msSetError(MS_IOERR, "Unable to change stdin to binary mode.",
+               "msIO_needBinaryStdin()");
+    return (MS_FAILURE);
+  }
+#endif
+
+  return MS_SUCCESS;
+}
+
+/* ==================================================================== */
+/*      memory buffer io handling functions.                            */
+/* ==================================================================== */
+
+/************************************************************************/
+/*                         msIO_resetHandlers()                         */
+/************************************************************************/
+
+void msIO_resetHandlers()
+
+{
+  msIOContextGroup *group = msIO_GetContextGroup();
+
+  if (group == NULL)
+    return;
+
+  if (strcmp(group->stdin_context.label, "buffer") == 0) {
+    msIOBuffer *buf = (msIOBuffer *)group->stdin_context.cbData;
+
+    if (buf->data != NULL)
+      free(buf->data);
+    free(buf);
+  }
+
+  if (strcmp(group->stdout_context.label, "buffer") == 0) {
+    msIOBuffer *buf = (msIOBuffer *)group->stdout_context.cbData;
+
+    if (buf->data != NULL)
+      free(buf->data);
+    free(buf);
+  }
+
+  if (strcmp(group->stderr_context.label, "buffer") == 0) {
+    msIOBuffer *buf = (msIOBuffer *)group->stderr_context.cbData;
+
+    if (buf->data != NULL)
+      free(buf->data);
+    free(buf);
+  }
+
+  msIO_installHandlers(NULL, NULL, NULL);
+}
+
+/************************************************************************/
+/*                     msIO_installStdoutToBuffer()                     */
+/************************************************************************/
+
+void msIO_installStdoutToBuffer()
+
+{
+  msIOContextGroup *group = msIO_GetContextGroup();
+  msIOContext context;
+
+  context.label = "buffer";
+  context.write_channel = MS_TRUE;
+  context.readWriteFunc = msIO_bufferWrite;
+  context.cbData = calloc(sizeof(msIOBuffer), 1);
+
+  msIO_installHandlers(&group->stdin_context, &context, &group->stderr_context);
+}
+
+/************************************************************************/
+/*               msIO_pushStdoutToBufferAndGetOldContext()              */
+/*                                                                      */
+/* This function installs a temporary buffer I/O context and returns    */
+/* previously installed stdout handler. This previous stdout handler    */
+/* should later be restored with msIO_restoreOldStdoutContext().        */
+/* This function can be for example used when wanting to ingest into    */
+/* libxml objects XML generated by msIO_fprintf()                       */
+/************************************************************************/
+
+msIOContext *msIO_pushStdoutToBufferAndGetOldContext()
+
+{
+  msIOContextGroup *group = msIO_GetContextGroup();
+  msIOContext *old_context;
+
+  /* Backup current context */
+  old_context = (msIOContext *)msSmallMalloc(sizeof(msIOContext));
+  memcpy(old_context, &group->stdout_context, sizeof(msIOContext));
+
+  msIO_installStdoutToBuffer();
+
+  return old_context;
+}
+
+/************************************************************************/
+/*                    msIO_restoreOldStdoutContext()                    */
+/************************************************************************/
+
+void msIO_restoreOldStdoutContext(msIOContext *context_to_restore) {
+  msIOContextGroup *group = msIO_GetContextGroup();
+  msIOContext *prev_context = &group->stdout_context;
+  msIOBuffer *buffer;
+
+  /* Free memory associated to our temporary context */
+  assert(strcmp(prev_context->label, "buffer") == 0);
+
+  buffer = (msIOBuffer *)prev_context->cbData;
+  msFree(buffer->data);
+  msFree(buffer);
+
+  /* Restore old context */
+  msIO_installHandlers(&group->stdin_context, context_to_restore,
+                       &group->stderr_context);
+
+  msFree(context_to_restore);
+}
+
+/************************************************************************/
+/*                    msIO_installStdinFromBuffer()                     */
+/************************************************************************/
+
+void msIO_installStdinFromBuffer()
+
+{
+  msIOContextGroup *group = msIO_GetContextGroup();
+  msIOContext context;
+
+  context.label = "buffer";
+  context.write_channel = MS_FALSE;
+  context.readWriteFunc = msIO_bufferRead;
+  context.cbData = calloc(sizeof(msIOBuffer), 1);
+
+  msIO_installHandlers(&context, &group->stdout_context,
+                       &group->stderr_context);
+}
+
+/************************************************************************/
+/*              msIO_getAndStripStdoutBufferMimeHeaders()               */
+/*                                                                      */
+/************************************************************************/
+
+hashTableObj *msIO_getAndStripStdoutBufferMimeHeaders() {
+  /* -------------------------------------------------------------------- */
+  /*      Find stdout buffer.                                             */
+  /* -------------------------------------------------------------------- */
+  msIOContext *ctx = msIO_getHandler((FILE *)"stdout");
+  msIOBuffer *buf;
+  int start_of_mime_header, current_pos;
+  hashTableObj *hashTable;
+
+  if (ctx == NULL || ctx->write_channel == MS_FALSE ||
+      strcmp(ctx->label, "buffer") != 0) {
+    msSetError(MS_MISCERR, "Can't identify msIO buffer.",
+               "msIO_getAndStripStdoutBufferMimeHeaders");
+    return NULL;
+  }
+
+  buf = (msIOBuffer *)ctx->cbData;
+
+  hashTable = msCreateHashTable();
+
+  /* -------------------------------------------------------------------- */
+  /*      Loop over all headers.                                          */
+  /* -------------------------------------------------------------------- */
+  current_pos = 0;
+  while (MS_TRUE) {
+    int pos_of_column = -1;
+    char *key, *value;
+
+    start_of_mime_header = current_pos;
+    while (current_pos < buf->data_offset) {
+      if (buf->data[current_pos] == '\r') {
+        if (current_pos + 1 == buf->data_offset ||
+            buf->data[current_pos + 1] != '\n') {
+          pos_of_column = -1;
+          break;
+        }
+        break;
+      }
+      if (buf->data[current_pos] == ':') {
+        pos_of_column = current_pos;
+        if (current_pos + 1 == buf->data_offset ||
+            buf->data[current_pos + 1] != ' ') {
+          pos_of_column = -1;
+          break;
+        }
+      }
+      current_pos++;
+    }
+
+    if (pos_of_column < 0 || current_pos == buf->data_offset) {
+      msSetError(MS_MISCERR, "Corrupt mime headers.",
+                 "msIO_getAndStripStdoutBufferMimeHeaders");
+      msFreeHashTable(hashTable);
+      return NULL;
+    }
+
+    key = (char *)malloc(pos_of_column - start_of_mime_header + 1);
+    memcpy(key, buf->data + start_of_mime_header,
+           pos_of_column - start_of_mime_header);
+    key[pos_of_column - start_of_mime_header] = '\0';
+
+    value = (char *)malloc(current_pos - (pos_of_column + 2) + 1);
+    memcpy(value, buf->data + pos_of_column + 2,
+           current_pos - (pos_of_column + 2));
+    value[current_pos - (pos_of_column + 2)] = '\0';
+
+    msInsertHashTable(hashTable, key, value);
+
+    msFree(key);
+    msFree(value);
+
+    /* -------------------------------------------------------------------- */
+    /*      Go to next line.                                                */
+    /* -------------------------------------------------------------------- */
+    current_pos += 2;
+    if (current_pos == buf->data_offset) {
+      msSetError(MS_MISCERR, "Corrupt mime headers.",
+                 "msIO_getAndStripStdoutBufferMimeHeaders");
+      msFreeHashTable(hashTable);
+      return NULL;
+    }
+
+    /* If next line is a '\r', this is the end of mime headers. */
+    if (buf->data[current_pos] == '\r') {
+      current_pos++;
+      if (current_pos == buf->data_offset || buf->data[current_pos] != '\n') {
+        msSetError(MS_MISCERR, "Corrupt mime headers.",
+                   "msIO_getAndStripStdoutBufferMimeHeaders");
+        msFreeHashTable(hashTable);
+        return NULL;
+      }
+      current_pos++;
+      break;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Move data to front of buffer, and reset length.                 */
+  /* -------------------------------------------------------------------- */
+  memmove(buf->data, buf->data + current_pos, buf->data_offset - current_pos);
+  buf->data[buf->data_offset - current_pos] = '\0';
+  buf->data_offset -= current_pos;
+
+  return hashTable;
+}
+
+/************************************************************************/
+/*                 msIO_stripStdoutBufferContentType()                  */
+/*                                                                      */
+/*      Strip off Content-Type header from buffer, and return to        */
+/*      caller.  Returned string is the callers responsibility to       */
+/*      call msFree() on to deallocate.  This function will return      */
+/*      NULL if there is no Content-Type header.                        */
+/************************************************************************/
+
+char *msIO_stripStdoutBufferContentType()
+
+{
+  /* -------------------------------------------------------------------- */
+  /*      Find stdout buffer.                                             */
+  /* -------------------------------------------------------------------- */
+  msIOContext *ctx = msIO_getHandler((FILE *)"stdout");
+  msIOBuffer *buf;
+  char *content_type = NULL;
+  int end_of_ct, start_of_data;
+
+  if (ctx == NULL || ctx->write_channel == MS_FALSE ||
+      strcmp(ctx->label, "buffer") != 0) {
+    msSetError(MS_MISCERR, "Can't identify msIO buffer.",
+               "msIO_stripStdoutBufferContentType");
+    return NULL;
+  }
+
+  buf = (msIOBuffer *)ctx->cbData;
+
+  /* -------------------------------------------------------------------- */
+  /*      Return NULL if we don't have a Content-Type header.             */
+  /* -------------------------------------------------------------------- */
+  if (buf->data_offset < 14 ||
+      strncasecmp((const char *)buf->data, "Content-Type: ", 14) != 0)
+    return NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Find newline marker at end of content type argument.            */
+  /* -------------------------------------------------------------------- */
+  end_of_ct = 13;
+  while (end_of_ct + 1 < buf->data_offset && buf->data[end_of_ct + 1] != '\r')
+    end_of_ct++;
+
+  if (end_of_ct + 1 == buf->data_offset) {
+    msSetError(MS_MISCERR, "Corrupt Content-Type header.",
+               "msIO_stripStdoutBufferContentType");
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Continue on to the start of data ...                            */
+  /*      Go to next line and skip if empty.                              */
+  /* -------------------------------------------------------------------- */
+  start_of_data = end_of_ct + 3;
+  if (start_of_data < buf->data_offset && buf->data[start_of_data] == '\r')
+    start_of_data += 2;
+
+  if (start_of_data == buf->data_offset) {
+    msSetError(MS_MISCERR, "Corrupt Content-Type header.",
+               "msIO_stripStdoutBufferContentType");
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Copy out content type. Note we go against the coding guidelines */
+  /*      here and use strncpy() instead of strlcpy() as the source       */
+  /*      buffer may not be NULL terminated - strlcpy() requires NULL     */
+  /*      terminated sources (see issue #4672).                           */
+  /* -------------------------------------------------------------------- */
+  content_type = (char *)malloc(end_of_ct - 14 + 2);
+  strncpy(content_type, (const char *)buf->data + 14, end_of_ct - 14 + 2);
+  content_type[end_of_ct - 14 + 1] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*      Move data to front of buffer, and reset length.                 */
+  /* -------------------------------------------------------------------- */
+  memmove(buf->data, buf->data + start_of_data,
+          buf->data_offset - start_of_data);
+  buf->data[buf->data_offset - start_of_data] = '\0';
+  buf->data_offset -= start_of_data;
+
+  return content_type;
+}
+
+/************************************************************************/
+/*                 msIO_stripStdoutBufferContentHeaders()               */
+/*                                                                      */
+/*      Strip off Content-* headers from buffer.                        */
+/************************************************************************/
+
+void msIO_stripStdoutBufferContentHeaders() {
+  /* -------------------------------------------------------------------- */
+  /*      Find stdout buffer.                                             */
+  /* -------------------------------------------------------------------- */
+  msIOContext *ctx = msIO_getHandler((FILE *)"stdout");
+  msIOBuffer *buf;
+  int start_of_data;
+
+  if (ctx == NULL || ctx->write_channel == MS_FALSE ||
+      strcmp(ctx->label, "buffer") != 0) {
+    msSetError(MS_MISCERR, "Can't identify msIO buffer.",
+               "msIO_stripStdoutBufferContentHeaders");
+    return;
+  }
+
+  buf = (msIOBuffer *)ctx->cbData;
+
+  /* -------------------------------------------------------------------- */
+  /*      Exit if we don't have any content-* header.                     */
+  /* -------------------------------------------------------------------- */
+  if (buf->data_offset < 8 ||
+      strncasecmp((const char *)buf->data, "Content-", 8) != 0)
+    return;
+
+  /* -------------------------------------------------------------------- */
+  /*      Loop over all content-* headers.                                */
+  /* -------------------------------------------------------------------- */
+  start_of_data = 0;
+  while (buf->data_offset > start_of_data &&
+         strncasecmp((const char *)buf->data + start_of_data, "Content-", 8) ==
+             0) {
+    /* -------------------------------------------------------------------- */
+    /*      Find newline marker at end of content-* header argument.        */
+    /* -------------------------------------------------------------------- */
+    start_of_data += 7;
+    while (start_of_data + 1 < buf->data_offset &&
+           buf->data[start_of_data + 1] != '\r')
+      start_of_data++;
+
+    if (start_of_data + 1 == buf->data_offset) {
+      msSetError(MS_MISCERR, "Corrupt Content-* header.",
+                 "msIO_stripStdoutBufferContentHeaders");
+      return;
+    }
+    /* -------------------------------------------------------------------- */
+    /*      Go to next line.                                                */
+    /* -------------------------------------------------------------------- */
+    start_of_data += 3;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Continue on to the start of data ...                            */
+  /*      Skip next line if empty.                                        */
+  /* -------------------------------------------------------------------- */
+  if (start_of_data < buf->data_offset && buf->data[start_of_data] == '\r')
+    start_of_data += 2;
+
+  if (start_of_data == buf->data_offset) {
+    msSetError(MS_MISCERR, "Corrupt Content-* header.",
+               "msIO_stripStdoutBufferContentHeaders");
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Move data to front of buffer, and reset length.                 */
+  /* -------------------------------------------------------------------- */
+  memmove(buf->data, buf->data + start_of_data,
+          buf->data_offset - start_of_data);
+  buf->data[buf->data_offset - start_of_data] = '\0';
+  buf->data_offset -= start_of_data;
+
+  return;
+}
+
+/************************************************************************/
+/*                          msIO_bufferWrite()                          */
+/************************************************************************/
+
+int msIO_bufferWrite(void *cbData, void *data, int byteCount)
+
+{
+  msIOBuffer *buf = (msIOBuffer *)cbData;
+
+  /*
+  ** Grow buffer if needed (reserve one extra byte to put nul character)
+  */
+  if (buf->data_offset + byteCount >= buf->data_len) {
+    buf->data_len = buf->data_len * 2 + byteCount + 100;
+    if (buf->data == NULL)
+      buf->data = (unsigned char *)malloc(buf->data_len);
+    else
+      buf->data = (unsigned char *)realloc(buf->data, buf->data_len);
+
+    if (buf->data == NULL) {
+      msSetError(MS_MEMERR, "Failed to allocate %d bytes for capture buffer.",
+                 "msIO_bufferWrite()", buf->data_len);
+      buf->data_len = 0;
+      return 0;
+    }
+  }
+
+  /*
+  ** Copy result into buffer.
+  */
+
+  memcpy(buf->data + buf->data_offset, data, byteCount);
+  buf->data_offset += byteCount;
+  buf->data[buf->data_offset] = '\0';
+
+  return byteCount;
+}
+
+/************************************************************************/
+/*                          msIO_bufferRead()                           */
+/************************************************************************/
+
+int msIO_bufferRead(void *cbData, void *data, int byteCount)
+
+{
+  (void)cbData;
+  (void)data;
+  (void)byteCount;
+  /* not implemented yet. */
+  return 0;
+}
diff -pruN 8.0.1-5/src/mapio.h 8.2.0~beta1-1~exp1/src/mapio.h
--- 8.0.1-5/src/mapio.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapio.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,132 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Definitions for MapServer IO redirection capability.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2004, Frank Warmerdam <warmerdam@pobox.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPIO_H
+#define MAPIO_H
+
+/*
+** We deliberately emulate stdio functions in the msIO cover functions.
+** This makes it easy for folks to understand the semantics, and means we
+** can just #define things to use stdio in the simplest case.
+*/
+
+#include <stdarg.h>
+#include "maphash.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifndef MS_PRINT_FUNC_FORMAT
+#if defined(__GNUC__) && __GNUC__ >= 3 && !defined(DOXYGEN_SKIP)
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)                              \
+  __attribute__((__format__(__printf__, format_idx, arg_idx)))
+#else
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)
+#endif
+#endif
+
+/* stdio analogs */
+int MS_DLL_EXPORT msIO_printf(const char *format, ...)
+    MS_PRINT_FUNC_FORMAT(1, 2);
+int MS_DLL_EXPORT msIO_fprintf(FILE *stream, const char *format, ...)
+    MS_PRINT_FUNC_FORMAT(2, 3);
+int MS_DLL_EXPORT msIO_fwrite(const void *ptr, size_t size, size_t nmemb,
+                              FILE *stream);
+int MS_DLL_EXPORT msIO_fread(void *ptr, size_t size, size_t nmemb,
+                             FILE *stream);
+int MS_DLL_EXPORT msIO_vfprintf(FILE *fp, const char *format, va_list ap)
+    MS_PRINT_FUNC_FORMAT(2, 0);
+
+/*
+** Definitions for the callback function and the details of the IO
+** channel contexts.
+*/
+
+typedef int (*msIO_llReadWriteFunc)(void *cbData, void *data, int byteCount);
+
+typedef struct msIOContext_t {
+  const char *label;
+  int write_channel; /* 1 for stdout/stderr, 0 for stdin */
+  msIO_llReadWriteFunc readWriteFunc;
+  void *cbData;
+} msIOContext;
+
+int MS_DLL_EXPORT msIO_installHandlers(msIOContext *stdin_context,
+                                       msIOContext *stdout_context,
+                                       msIOContext *stderr_context);
+msIOContext MS_DLL_EXPORT *msIO_getHandler(FILE *);
+void MS_DLL_EXPORT msIO_setHeaderEnabled(int bFlag);
+void msIO_setHeader(const char *header, const char *value, ...)
+    MS_PRINT_FUNC_FORMAT(2, 3);
+void msIO_sendHeaders(void);
+
+/*
+** These can be used instead of the stdio style functions if you have
+** msIOContext's for the channel in question.
+*/
+int msIO_contextRead(msIOContext *context, void *data, int byteCount);
+int msIO_contextWrite(msIOContext *context, const void *data, int byteCount);
+
+/*
+** For redirecting IO to a memory buffer.
+*/
+
+typedef struct {
+  unsigned char *data;
+  int data_len;    /* really buffer length */
+  int data_offset; /* really buffer used */
+} msIOBuffer;
+
+int MS_DLL_EXPORT msIO_bufferRead(void *, void *, int);
+int MS_DLL_EXPORT msIO_bufferWrite(void *, void *, int);
+
+void MS_DLL_EXPORT msIO_resetHandlers(void);
+void MS_DLL_EXPORT msIO_installStdoutToBuffer(void);
+void MS_DLL_EXPORT msIO_installStdinFromBuffer(void);
+void MS_DLL_EXPORT msIO_Cleanup(void);
+char MS_DLL_EXPORT *msIO_stripStdoutBufferContentType(void);
+void MS_DLL_EXPORT msIO_stripStdoutBufferContentHeaders(void);
+hashTableObj MS_DLL_EXPORT *msIO_getAndStripStdoutBufferMimeHeaders(void);
+
+msIOContext *msIO_pushStdoutToBufferAndGetOldContext(void);
+void msIO_restoreOldStdoutContext(msIOContext *context_to_restore);
+
+int MS_DLL_EXPORT msIO_isStdContext(void);
+
+/* this is just for setting normal stdout's to binary mode on windows */
+
+int msIO_needBinaryStdout(void);
+int msIO_needBinaryStdin(void);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* nef MAPIO_H */
diff -pruN 8.0.1-5/src/mapjoin.c 8.2.0~beta1-1~exp1/src/mapjoin.c
--- 8.0.1-5/src/mapjoin.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapjoin.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,901 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implements MapServer joins.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#define ROW_ALLOCATION_SIZE 10
+
+/* DBF/XBase function prototypes */
+int msDBFJoinConnect(layerObj *layer, joinObj *join);
+int msDBFJoinPrepare(joinObj *join, shapeObj *shape);
+int msDBFJoinNext(joinObj *join);
+int msDBFJoinClose(joinObj *join);
+int msDBFJoinTable(layerObj *layer, joinObj *join, shapeObj *shape);
+
+/* CSV (comma delimited text file) function prototypes */
+int msCSVJoinConnect(layerObj *layer, joinObj *join);
+int msCSVJoinPrepare(joinObj *join, shapeObj *shape);
+int msCSVJoinNext(joinObj *join);
+int msCSVJoinClose(joinObj *join);
+int msCSVJoinTable(layerObj *layer, joinObj *join, shapeObj *shape);
+
+/* MySQL function prototypes */
+int msMySQLJoinConnect(layerObj *layer, joinObj *join);
+int msMySQLJoinPrepare(joinObj *join, shapeObj *shape);
+int msMySQLJoinNext(joinObj *join);
+int msMySQLJoinClose(joinObj *join);
+int msMySQLJoinTable(layerObj *layer, joinObj *join, shapeObj *shape);
+
+/* PostgreSQL function prototypes */
+int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join);
+int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape);
+int msPOSTGRESQLJoinNext(joinObj *join);
+int msPOSTGRESQLJoinClose(joinObj *join);
+
+/* wrapper function for DB specific join functions */
+int msJoinConnect(layerObj *layer, joinObj *join) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinConnect(layer, join);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinConnect(layer, join);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinConnect(layer, join);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinConnect(layer, join);
+    break;
+  default:
+    break;
+  }
+
+  msSetError(MS_JOINERR, "Unsupported join connection type.",
+             "msJoinConnect()");
+  return MS_FAILURE;
+}
+
+int msJoinPrepare(joinObj *join, shapeObj *shape) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinPrepare(join, shape);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinPrepare(join, shape);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinPrepare(join, shape);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinPrepare(join, shape);
+    break;
+  default:
+    break;
+  }
+
+  msSetError(MS_JOINERR, "Unsupported join connection type.",
+             "msJoinPrepare()");
+  return MS_FAILURE;
+}
+
+int msJoinNext(joinObj *join) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinNext(join);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinNext(join);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinNext(join);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinNext(join);
+    break;
+  default:
+    break;
+  }
+
+  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinNext()");
+  return MS_FAILURE;
+}
+
+int msJoinClose(joinObj *join) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinClose(join);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinClose(join);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinClose(join);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinClose(join);
+    break;
+  default:
+    break;
+  }
+
+  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinClose()");
+  return MS_FAILURE;
+}
+
+/*  */
+/* XBASE join functions */
+/*  */
+typedef struct {
+  DBFHandle hDBF;
+  int fromindex, toindex;
+  char *target;
+  int nextrecord;
+} msDBFJoinInfo;
+
+int msDBFJoinConnect(layerObj *layer, joinObj *join) {
+  int i;
+  char szPath[MS_MAXPATHLEN];
+  msDBFJoinInfo *joininfo;
+
+  if (join->joininfo)
+    return (MS_SUCCESS); /* already open */
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  /* allocate a msDBFJoinInfo struct */
+  joininfo = (msDBFJoinInfo *)malloc(sizeof(msDBFJoinInfo));
+  if (!joininfo) {
+    msSetError(MS_MEMERR, "Error allocating XBase table info structure.",
+               "msDBFJoinConnect()");
+    return (MS_FAILURE);
+  }
+
+  /* initialize any members that won't get set later on in this function */
+  joininfo->target = NULL;
+  joininfo->nextrecord = 0;
+
+  join->joininfo = joininfo;
+
+  /* open the XBase file */
+  if ((joininfo->hDBF =
+           msDBFOpen(msBuildPath3(szPath, layer->map->mappath,
+                                  layer->map->shapepath, join->table),
+                     "rb")) == NULL) {
+    if ((joininfo->hDBF =
+             msDBFOpen(msBuildPath(szPath, layer->map->mappath, join->table),
+                       "rb")) == NULL) {
+      msSetError(MS_IOERR, "(%s)", "msDBFJoinConnect()", join->table);
+      return (MS_FAILURE);
+    }
+  }
+
+  /* get "to" item index */
+  if ((joininfo->toindex = msDBFGetItemIndex(joininfo->hDBF, join->to)) == -1) {
+    msSetError(MS_DBFERR, "Item %s not found in table %s.",
+               "msDBFJoinConnect()", join->to, join->table);
+    return (MS_FAILURE);
+  }
+
+  /* get "from" item index   */
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) { /* found it */
+      joininfo->fromindex = i;
+      break;
+    }
+  }
+
+  if (i == layer->numitems) {
+    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
+               "msDBFJoinConnect()", join->from, layer->name);
+    return (MS_FAILURE);
+  }
+
+  /* finally store away the item names in the XBase table */
+  join->numitems = msDBFGetFieldCount(joininfo->hDBF);
+  join->items = msDBFGetItems(joininfo->hDBF);
+  if (!join->items)
+    return (MS_FAILURE);
+
+  return (MS_SUCCESS);
+}
+
+int msDBFJoinPrepare(joinObj *join, shapeObj *shape) {
+  msDBFJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msDBFJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape) {
+    msSetError(MS_JOINERR, "Shape to be joined is empty.",
+               "msDBFJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape->values) {
+    msSetError(MS_JOINERR, "Shape to be joined has no attributes.",
+               "msDBFJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  joininfo->nextrecord = 0; /* starting with the first record */
+
+  if (joininfo->target)
+    free(joininfo->target); /* clear last target */
+  joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
+
+  return (MS_SUCCESS);
+}
+
+int msDBFJoinNext(joinObj *join) {
+  int i, n;
+  msDBFJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msDBFJoinNext()");
+    return (MS_FAILURE);
+  }
+
+  if (!joininfo->target) {
+    msSetError(MS_JOINERR, "No target specified, run msDBFJoinPrepare() first.",
+               "msDBFJoinNext()");
+    return (MS_FAILURE);
+  }
+
+  /* clear any old data */
+  if (join->values) {
+    msFreeCharArray(join->values, join->numitems);
+    join->values = NULL;
+  }
+
+  n = msDBFGetRecordCount(joininfo->hDBF);
+
+  for (i = joininfo->nextrecord; i < n; i++) { /* find a match */
+    if (strcmp(joininfo->target, msDBFReadStringAttribute(joininfo->hDBF, i,
+                                                          joininfo->toindex)) ==
+        0)
+      break;
+  }
+
+  if (i == n) { /* unable to do the join */
+    if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+        NULL) {
+      msSetError(MS_MEMERR, NULL, "msDBFJoinNext()");
+      return (MS_FAILURE);
+    }
+    for (i = 0; i < join->numitems; i++)
+      join->values[i] = msStrdup("\0"); /* intialize to zero length strings */
+
+    joininfo->nextrecord = n;
+    return (MS_DONE);
+  }
+
+  if ((join->values = msDBFGetValues(joininfo->hDBF, i)) == NULL)
+    return (MS_FAILURE);
+
+  joininfo->nextrecord =
+      i + 1; /* so we know where to start looking next time through */
+
+  return (MS_SUCCESS);
+}
+
+int msDBFJoinClose(joinObj *join) {
+  msDBFJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo)
+    return (MS_SUCCESS); /* already closed */
+
+  if (joininfo->hDBF)
+    msDBFClose(joininfo->hDBF);
+  if (joininfo->target)
+    free(joininfo->target);
+  free(joininfo);
+  joininfo = NULL;
+
+  return (MS_SUCCESS);
+}
+
+/*  */
+/* CSV (comma separated value) join functions */
+/*  */
+typedef struct {
+  int fromindex, toindex;
+  char *target;
+  char ***rows;
+  int numrows;
+  int nextrow;
+} msCSVJoinInfo;
+
+int msCSVJoinConnect(layerObj *layer, joinObj *join) {
+  int i;
+  FILE *stream;
+  char szPath[MS_MAXPATHLEN];
+  msCSVJoinInfo *joininfo;
+  char buffer[MS_BUFFER_LENGTH];
+
+  if (join->joininfo)
+    return (MS_SUCCESS); /* already open */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  /* allocate a msCSVJoinInfo struct */
+  if ((joininfo = (msCSVJoinInfo *)malloc(sizeof(msCSVJoinInfo))) == NULL) {
+    msSetError(MS_MEMERR, "Error allocating CSV table info structure.",
+               "msCSVJoinConnect()");
+    return (MS_FAILURE);
+  }
+
+  /* initialize any members that won't get set later on in this function */
+  joininfo->target = NULL;
+  joininfo->nextrow = 0;
+
+  join->joininfo = joininfo;
+
+  /* open the CSV file */
+  if ((stream = fopen(msBuildPath3(szPath, layer->map->mappath,
+                                   layer->map->shapepath, join->table),
+                      "r")) == NULL) {
+    if ((stream = fopen(msBuildPath(szPath, layer->map->mappath, join->table),
+                        "r")) == NULL) {
+      msSetError(MS_IOERR, "(%s)", "msCSVJoinConnect()", join->table);
+      return (MS_FAILURE);
+    }
+  }
+
+  /* once through to get the number of rows */
+  joininfo->numrows = 0;
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL)
+    joininfo->numrows++;
+  rewind(stream);
+
+  if ((joininfo->rows =
+           (char ***)malloc(joininfo->numrows * sizeof(char **))) == NULL) {
+    fclose(stream);
+    msSetError(MS_MEMERR, "Error allocating rows.", "msCSVJoinConnect()");
+    return (MS_FAILURE);
+  }
+
+  /* load the rows */
+  i = 0;
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+    msStringTrimEOL(buffer);
+    joininfo->rows[i] = msStringSplitComplex(buffer, ",", &(join->numitems),
+                                             MS_ALLOWEMPTYTOKENS);
+    i++;
+  }
+  fclose(stream);
+
+  /* get "from" item index   */
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) { /* found it */
+      joininfo->fromindex = i;
+      break;
+    }
+  }
+
+  if (i == layer->numitems) {
+    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
+               "msCSVJoinConnect()", join->from, layer->name);
+    return (MS_FAILURE);
+  }
+
+  /* get "to" index (for now the user tells us which column, 1..n) */
+  joininfo->toindex = atoi(join->to) - 1;
+  if (joininfo->toindex < 0 || joininfo->toindex > join->numitems) {
+    msSetError(MS_JOINERR, "Invalid column index %s.", "msCSVJoinConnect()",
+               join->to);
+    return (MS_FAILURE);
+  }
+
+  /* store away the column names (1..n) */
+  if ((join->items = (char **)malloc(sizeof(char *) * join->numitems)) ==
+      NULL) {
+    msSetError(MS_MEMERR, "Error allocating space for join item names.",
+               "msCSVJoinConnect()");
+    return (MS_FAILURE);
+  }
+  for (i = 0; i < join->numitems; i++) {
+    join->items[i] = (char *)malloc(12); /* plenty of space */
+    sprintf(join->items[i], "%d", i + 1);
+  }
+
+  return (MS_SUCCESS);
+}
+
+int msCSVJoinPrepare(joinObj *join, shapeObj *shape) {
+  msCSVJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msCSVJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape) {
+    msSetError(MS_JOINERR, "Shape to be joined is empty.",
+               "msCSVJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape->values) {
+    msSetError(MS_JOINERR, "Shape to be joined has no attributes.",
+               "msCSVJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  joininfo->nextrow = 0; /* starting with the first record */
+
+  if (joininfo->target)
+    free(joininfo->target); /* clear last target */
+  joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
+
+  return (MS_SUCCESS);
+}
+
+int msCSVJoinNext(joinObj *join) {
+  int i, j;
+  msCSVJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msCSVJoinNext()");
+    return (MS_FAILURE);
+  }
+
+  /* clear any old data */
+  if (join->values) {
+    msFreeCharArray(join->values, join->numitems);
+    join->values = NULL;
+  }
+
+  for (i = joininfo->nextrow; i < joininfo->numrows; i++) { /* find a match */
+    if (strcmp(joininfo->target, joininfo->rows[i][joininfo->toindex]) == 0)
+      break;
+  }
+
+  if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+      NULL) {
+    msSetError(MS_MEMERR, NULL, "msCSVJoinNext()");
+    return (MS_FAILURE);
+  }
+
+  if (i == joininfo->numrows) { /* unable to do the join     */
+    for (j = 0; j < join->numitems; j++)
+      join->values[j] = msStrdup("\0"); /* intialize to zero length strings */
+
+    joininfo->nextrow = joininfo->numrows;
+    return (MS_DONE);
+  }
+
+  for (j = 0; j < join->numitems; j++)
+    join->values[j] = msStrdup(joininfo->rows[i][j]);
+
+  joininfo->nextrow =
+      i + 1; /* so we know where to start looking next time through */
+
+  return (MS_SUCCESS);
+}
+
+int msCSVJoinClose(joinObj *join) {
+  int i;
+  msCSVJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo)
+    return (MS_SUCCESS); /* already closed */
+
+  for (i = 0; i < joininfo->numrows; i++)
+    msFreeCharArray(joininfo->rows[i], join->numitems);
+  free(joininfo->rows);
+  if (joininfo->target)
+    free(joininfo->target);
+  free(joininfo);
+  joininfo = NULL;
+
+  return (MS_SUCCESS);
+}
+
+#ifdef USE_MYSQL
+
+#ifndef _mysql_h
+#include <mysql/mysql.h>
+#endif
+
+char *DB_HOST = NULL;
+char *DB_USER = NULL;
+char *DB_PASSWD = NULL;
+char *DB_DATABASE = NULL;
+char *delim;
+
+#define MYDEBUG if (0)
+
+MYSQL_RES *msMySQLQuery(char *q, MYSQL *conn) {
+  MYSQL_RES *qresult = NULL;
+  if (mysql_query(conn, q) < 0) {
+    mysql_close(conn);
+    msSetError(MS_QUERYERR, "Bad mysql query (%s)", "msMySQLQuery()", q);
+    return qresult;
+  }
+  if (!(qresult = mysql_store_result(conn))) {
+    mysql_close(conn);
+    msSetError(MS_QUERYERR, "mysql query failed (%s)", "msMySQLQuery()", q);
+    return qresult;
+  }
+  return qresult;
+}
+
+/*  */
+/* mysql join functions */
+/*  */
+typedef struct {
+  MYSQL mysql, *conn;
+  MYSQL_RES *qresult;
+  MYSQL_ROW row;
+  int rows;
+  int fromindex;
+  char *tocolumn;
+  char *target;
+  int nextrecord;
+} msMySQLJoinInfo;
+#endif
+
+int msMySQLJoinConnect(layerObj *layer, joinObj *join) {
+  (void)layer;
+  (void)join;
+#ifndef USE_MYSQL
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinConnect()");
+  return (MS_FAILURE);
+#else
+  int i;
+  char qbuf[4000];
+  char *conn_decrypted;
+  msMySQLJoinInfo *joininfo;
+
+  MYDEBUG if (setvbuf(stdout, NULL, _IONBF, 0)) { printf("Whoops..."); };
+  if (join->joininfo)
+    return (MS_SUCCESS); /* already open */
+
+  /* allocate a msMySQLJoinInfo struct */
+  joininfo = (msMySQLJoinInfo *)malloc(sizeof(msMySQLJoinInfo));
+  if (!joininfo) {
+    msSetError(MS_MEMERR, "Error allocating mysql table info structure.",
+               "msMySQLJoinConnect()");
+    return (MS_FAILURE);
+  }
+
+  /* initialize any members that won't get set later on in this function */
+  joininfo->qresult = NULL;
+  joininfo->target = NULL;
+  joininfo->nextrecord = 0;
+
+  join->joininfo = joininfo;
+
+  /* open the mysql connection */
+
+  if (join->connection == NULL) {
+    msSetError(
+        MS_QUERYERR,
+        "Error parsing MYSQL JOIN: nothing specified in CONNECTION statement.",
+        "msMySQLJoinConnect()");
+
+    return (MS_FAILURE);
+  }
+
+  conn_decrypted = msDecryptStringTokens(layer->map, join->connection);
+  if (conn_decrypted == NULL) {
+    msSetError(
+        MS_QUERYERR,
+        "Error parsing MYSQL JOIN: unable to decrypt CONNECTION statement.",
+        "msMySQLJoinConnect()");
+    return (MS_FAILURE);
+  }
+
+  delim = msStrdup(":");
+  DB_HOST = msStrdup(strtok(conn_decrypted, delim));
+  DB_USER = msStrdup(strtok(NULL, delim));
+  DB_PASSWD = msStrdup(strtok(NULL, delim));
+  DB_DATABASE = msStrdup(strtok(NULL, delim));
+  free(conn_decrypted);
+
+  if (DB_HOST == NULL || DB_USER == NULL || DB_PASSWD == NULL ||
+      DB_DATABASE == NULL) {
+    msSetError(MS_QUERYERR,
+               "DB param error: at least one of HOST, USER, PASSWD or DATABASE "
+               "is null!",
+               "msMySQLJoinConnect()");
+    return MS_FAILURE;
+  }
+  if (strcmp(DB_PASSWD, "none") == 0)
+    strcpy(DB_PASSWD, "");
+
+#if MYSQL_VERSION_ID >= 40000
+  mysql_init(&(joininfo->mysql));
+  if (!(joininfo->conn = mysql_real_connect(
+            &(joininfo->mysql), DB_HOST, DB_USER, DB_PASSWD, NULL, 0, NULL, 0)))
+#else
+  if (!(joininfo->conn =
+            mysql_connect(&(joininfo->mysql), DB_HOST, DB_USER, DB_PASSWD)))
+#endif
+  {
+    char tmp[4000];
+    snprintf(tmp, sizeof(tmp),
+             "Failed to connect to SQL server: Error: %s\nHost: "
+             "%s\nUsername:%s\nPassword:%s\n",
+             mysql_error(joininfo->conn), DB_HOST, DB_USER, DB_PASSWD);
+    msSetError(MS_QUERYERR, "%s", "msMYSQLLayerOpen()", tmp);
+    free(joininfo);
+    return MS_FAILURE;
+  }
+
+  MYDEBUG printf("msMYSQLLayerOpen2 called<br>\n");
+  if (mysql_select_db(joininfo->conn, DB_DATABASE) < 0) {
+    mysql_close(joininfo->conn);
+  }
+  MYDEBUG printf("msMYSQLLayerOpen3 called<br>\n");
+  if (joininfo->qresult != NULL) { /* query leftover */
+    MYDEBUG printf("msMYSQLLayerOpen4 called<br>\n");
+    mysql_free_result(joininfo->qresult);
+  }
+  MYDEBUG printf("msMYSQLLayerOpen5 called<br>\n");
+  snprintf(qbuf, sizeof(qbuf), "SELECT count(%s) FROM %s", join->to,
+           join->table);
+  MYDEBUG printf("%s<br>\n", qbuf);
+  if ((joininfo->qresult =
+           msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found,
+                                                     write 'em out for debug */
+    int numrows = mysql_affected_rows(joininfo->conn);
+    MYDEBUG printf("%d rows<br>\n", numrows);
+    for (i = 0; i < numrows; i++) {
+      MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
+      MYDEBUG printf("(%s)<BR>\n", row[0]);
+      joininfo->rows = atoi(row[0]);
+    }
+  } else {
+    msSetError(MS_DBFERR, "Item %s not found in table %s.",
+               "msMySQLJoinConnect()", join->to, join->table);
+    return (MS_FAILURE);
+  }
+  snprintf(qbuf, sizeof(qbuf), "EXPLAIN %s", join->table);
+  if ((joininfo->qresult =
+           msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found,
+                                                     write 'em out for debug */
+    join->numitems = mysql_affected_rows(joininfo->conn);
+    if ((join->items = (char **)malloc(sizeof(char *) * join->numitems)) ==
+        NULL) {
+      msSetError(MS_MEMERR, NULL, "msMySQLJoinConnect()");
+      return (MS_FAILURE);
+    }
+    MYDEBUG printf("%d rows<br>\n", join->numitems);
+    for (i = 0; i < join->numitems; i++) {
+      MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
+      MYDEBUG printf("(%s)<BR>\n", row[0]);
+      join->items[i] = msStrdup(row[0]);
+    }
+  } else {
+    msSetError(MS_DBFERR, "Item %s not found in table %s.",
+               "msMySQLJoinConnect()", join->to, join->table);
+    return (MS_FAILURE);
+  }
+  joininfo->tocolumn = msStrdup(join->to);
+
+  /* get "from" item index   */
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) { /* found it */
+      joininfo->fromindex = i;
+      break;
+    }
+  }
+
+  if (i == layer->numitems) {
+    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
+               "msMySQLJoinConnect()", join->from, layer->name);
+    return (MS_FAILURE);
+  }
+
+  /* finally store away the item names in the XBase table */
+  if (!join->items)
+    return (MS_FAILURE);
+
+  return (MS_SUCCESS);
+#endif
+}
+
+int msMySQLJoinPrepare(joinObj *join, shapeObj *shape) {
+  (void)join;
+  (void)shape;
+#ifndef USE_MYSQL
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinPrepare()");
+  return (MS_FAILURE);
+#else
+  msMySQLJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msMySQLJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape) {
+    msSetError(MS_JOINERR, "Shape to be joined is empty.",
+               "msMySQLJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape->values) {
+    msSetError(MS_JOINERR, "Shape to be joined has no attributes.",
+               "msMySQLJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  joininfo->nextrecord = 0; /* starting with the first record */
+
+  if (joininfo->target)
+    free(joininfo->target); /* clear last target */
+  joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
+
+  return (MS_SUCCESS);
+#endif
+}
+
+int msMySQLJoinNext(joinObj *join) {
+  (void)join;
+#ifndef USE_MYSQL
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinNext()");
+  return (MS_FAILURE);
+#else
+  int i;
+  char qbuf[4000];
+  msMySQLJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msMySQLJoinNext()");
+    return (MS_FAILURE);
+  }
+
+  if (!joininfo->target) {
+    msSetError(MS_JOINERR,
+               "No target specified, run msMySQLJoinPrepare() first.",
+               "msMySQLJoinNext()");
+    return (MS_FAILURE);
+  }
+
+  /* clear any old data */
+  if (join->values) {
+    msFreeCharArray(join->values, join->numitems);
+    join->values = NULL;
+  }
+
+  /* int n = joininfo->rows; */
+
+  /* for(i=joininfo->nextrecord; i<n; i++) { // find a match */
+  /* if(strcmp(joininfo->target, msMySQLReadStringAttribute(joininfo->conn, i,
+   * joininfo->toindex)) == 0) break; */
+  /* }   */
+  snprintf(qbuf, sizeof(qbuf), "SELECT * FROM %s WHERE %s = %s", join->table,
+           joininfo->tocolumn, joininfo->target);
+  MYDEBUG printf("%s<BR>\n", qbuf);
+  if ((joininfo->qresult =
+           msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found,
+                                                     write 'em out for debug */
+    int numrows = mysql_affected_rows(joininfo->conn);
+    int numfields = mysql_field_count(joininfo->conn);
+    MYDEBUG printf("%d rows<br>\n", numrows);
+    if (numrows > 0) {
+      MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
+      for (i = 0; i < numfields; i++) {
+        MYDEBUG printf("%s,", row[i]);
+      }
+      MYDEBUG printf("<BR>\n");
+      free(join->values);
+      if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+          NULL) {
+        msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
+        return (MS_FAILURE);
+      }
+      for (i = 0; i < join->numitems; i++) {
+        /* join->values[i] = msStrdup("\0"); */ /* intialize to zero length
+                                                   strings */
+        join->values[i] =
+            msStrdup(row[i]); /* intialize to zero length strings */
+        /* rows = atoi(row[0]); */
+      }
+    } else {
+      if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+          NULL) {
+        msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
+        return (MS_FAILURE);
+      }
+      for (i = 0; i < join->numitems; i++)
+        join->values[i] = msStrdup("\0"); /* intialize to zero length strings */
+
+      return (MS_DONE);
+    }
+  } else {
+    msSetError(MS_QUERYERR, "Query error (%s)", "msMySQLJoinNext()", qbuf);
+    return (MS_FAILURE);
+  }
+
+#ifdef __NOTDEF__
+  if (i == n) { /* unable to do the join */
+    if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+        NULL) {
+      msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
+      return (MS_FAILURE);
+    }
+    for (i = 0; i < join->numitems; i++)
+      join->values[i] = msStrdup("\0"); /* intialize to zero length strings  */
+
+    joininfo->nextrecord = n;
+    return (MS_DONE);
+  }
+
+  if ((join->values = msMySQLGetValues(joininfo->conn, i)) == NULL)
+    return (MS_FAILURE);
+
+  joininfo->nextrecord =
+      i + 1; /* so we know where to start looking next time through */
+#endif /* __NOTDEF__ */
+
+  return (MS_SUCCESS);
+#endif
+}
+
+int msMySQLJoinClose(joinObj *join) {
+  (void)join;
+#ifndef USE_MYSQL
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinClose()");
+  return (MS_FAILURE);
+#else
+  msMySQLJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo)
+    return (MS_SUCCESS); /* already closed */
+
+  mysql_close(joininfo->conn);
+  if (joininfo->target)
+    free(joininfo->target);
+  free(joininfo);
+  joininfo = NULL;
+
+  return (MS_SUCCESS);
+#endif
+}
diff -pruN 8.0.1-5/src/mapkml.cpp 8.2.0~beta1-1~exp1/src/mapkml.cpp
--- 8.0.1-5/src/mapkml.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapkml.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,235 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Headers for mapkml.cpp Google Earth KML output
+ * Author:   David Kana and the MapServer team
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2009 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+#include "mapserver.h"
+
+#ifdef USE_KML
+
+#include "mapkmlrenderer.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+KmlRenderer *getKmlRenderer(imageObj *img) {
+  return (KmlRenderer *)img->img.plugin;
+}
+
+imageObj *msCreateImageKml(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
+  imageObj *image = NULL;
+
+  image = (imageObj *)malloc(sizeof(imageObj));
+  MS_CHECK_ALLOC(image, sizeof(imageObj), NULL);
+  memset(image, 0, sizeof(imageObj));
+
+  KmlRenderer *ren = new KmlRenderer(width, height, format, bg);
+  image->img.plugin = (void *)ren;
+
+  return image;
+}
+
+int msSaveImageKml(imageObj *img, mapObj * /*map*/, FILE *fp,
+                   outputFormatObj *format) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  return renderer->saveImage(img, fp, format);
+}
+
+int msRenderLineKml(imageObj *img, shapeObj *p, strokeStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderLine(img, p, style);
+  return MS_SUCCESS;
+}
+
+int msRenderPolygonKml(imageObj *img, shapeObj *p, colorObj *color) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderPolygon(img, p, color);
+  return MS_SUCCESS;
+}
+
+int msRenderPolygonTiledKml(imageObj * /*img*/, shapeObj * /*p*/,
+                            imageObj * /*tile*/) {
+  /*KmlRenderer* renderer = getKmlRenderer(img);*/
+  return MS_SUCCESS;
+}
+
+int msRenderLineTiledKml(imageObj * /*img*/, shapeObj * /*p*/,
+                         imageObj * /*tile*/) {
+  return MS_SUCCESS;
+}
+
+int msRenderGlyphsKml(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                      colorObj *oc, int ow, int /*isMarker*/) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderGlyphs(img, ts, c, oc, ow);
+  return MS_SUCCESS;
+}
+
+int msRenderVectorSymbolKml(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderVectorSymbol(img, x, y, symbol, style);
+  return MS_SUCCESS;
+}
+
+int msRenderPixmapSymbolKml(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderPixmapSymbol(img, x, y, symbol, style);
+  return MS_SUCCESS;
+}
+
+int msRenderEllipseSymbolKml(imageObj *image, double x, double y,
+                             symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(image);
+  renderer->renderEllipseSymbol(image, x, y, symbol, style);
+  return MS_SUCCESS;
+}
+
+int msRenderTruetypeSymbolKml(imageObj *image, double x, double y,
+                              symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(image);
+  renderer->renderTruetypeSymbol(image, x, y, symbol, style);
+  return MS_SUCCESS;
+}
+
+int msRenderTileKml(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/,
+                    double /*y*/) {
+  return MS_SUCCESS;
+}
+
+int msGetRasterBufferKml(imageObj * /*img*/, rasterBufferObj * /*rb*/) {
+  return MS_FAILURE; // not supported for kml
+}
+
+int msGetTruetypeTextBBoxKml(rendererVTableObj * /*r*/, char ** /*fonts*/,
+                             int /*numfonts*/, double size, char *string,
+                             rectObj *rect, double **advances,
+                             int /*bAdjustBaseline*/) {
+  rect->minx = 0.0;
+  rect->maxx = 0.0;
+  rect->miny = 0.0;
+  rect->maxy = 0.0;
+  if (advances) {
+    int numglyphs = msGetNumGlyphs(string);
+    *advances = (double *)msSmallMalloc(numglyphs * sizeof(double));
+    for (int i = 0; i < numglyphs; i++) {
+      (*advances)[i] = size;
+    }
+  }
+  return MS_SUCCESS;
+}
+
+int msStartNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  return renderer->startNewLayer(img, layer);
+}
+
+int msCloseNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  return renderer->closeNewLayer(img, layer);
+}
+
+int msFreeImageKml(imageObj *image) {
+  KmlRenderer *renderer = getKmlRenderer(image);
+  if (renderer) {
+    delete renderer;
+  }
+  image->img.plugin = NULL;
+  return MS_SUCCESS;
+}
+
+int msFreeSymbolKml(symbolObj * /*symbol*/) { return MS_SUCCESS; }
+
+int msStartShapeKml(imageObj *img, shapeObj *shape) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->startShape(img, shape);
+  return MS_SUCCESS;
+}
+
+int msEndShapeKml(imageObj *img, shapeObj *shape) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->endShape(img, shape);
+  return MS_SUCCESS;
+}
+
+int msMergeRasterBufferKml(imageObj *dest, rasterBufferObj *overlay,
+                           double /*opacity*/, int /*srcX*/, int /*srcY*/,
+                           int /*dstX*/, int /*dstY*/, int /*width*/,
+                           int /*height*/) {
+  KmlRenderer *renderer = getKmlRenderer(dest);
+  return renderer->mergeRasterBuffer(dest, overlay);
+}
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /*USE_KML*/
+
+int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height,
+                              int mode);
+
+int msPopulateRendererVTableKML(rendererVTableObj *renderer) {
+#ifdef USE_KML
+  renderer->supports_pixel_buffer = 0;
+  renderer->supports_clipping = 0;
+  renderer->use_imagecache = 0;
+  renderer->default_transform_mode = MS_TRANSFORM_NONE;
+
+  renderer->startLayer = msStartNewLayerKml;
+  renderer->endLayer = msCloseNewLayerKml;
+  renderer->renderLine = &msRenderLineKml;
+  renderer->createImage = &msCreateImageKml;
+  renderer->saveImage = &msSaveImageKml;
+  renderer->renderPolygon = &msRenderPolygonKml;
+  renderer->renderGlyphs = &msRenderGlyphsKml;
+  renderer->renderEllipseSymbol = &msRenderEllipseSymbolKml;
+  renderer->renderVectorSymbol = &msRenderVectorSymbolKml;
+  renderer->renderPixmapSymbol = &msRenderPixmapSymbolKml;
+  renderer->mergeRasterBuffer = &msMergeRasterBufferKml;
+  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
+  renderer->initializeRasterBuffer = aggInitializeRasterBuffer;
+  renderer->renderTile = &msRenderTileKml;
+  renderer->renderPolygonTiled = &msRenderPolygonTiledKml;
+  renderer->renderLineTiled = NULL;
+  renderer->freeSymbol = &msFreeSymbolKml;
+  renderer->freeImage = &msFreeImageKml;
+  renderer->mergeRasterBuffer = msMergeRasterBufferKml;
+  renderer->compositeRasterBuffer = NULL;
+
+  renderer->startShape = &msStartShapeKml;
+  renderer->endShape = &msEndShapeKml;
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "KML Driver requested but is not built in",
+             "msPopulateRendererVTableKML()");
+  return MS_FAILURE;
+#endif
+}
diff -pruN 8.0.1-5/src/mapkmlrenderer.cpp 8.2.0~beta1-1~exp1/src/mapkmlrenderer.cpp
--- 8.0.1-5/src/mapkmlrenderer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapkmlrenderer.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1323 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Google Earth KML output
+ * Author:   David Kana and the MapServer team
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2009 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver-config.h"
+#ifdef USE_KML
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapkmlrenderer.h"
+#include "mapio.h"
+#include "mapows.h"
+
+#include "cpl_conv.h"
+#include "cpl_vsi.h"
+
+#define KML_MAXFEATURES_TODRAW 1000
+
+KmlRenderer::KmlRenderer(int width, int height, outputFormatObj * /*format*/,
+                         colorObj * /*color*/)
+    : Width(width), Height(height), MapCellsize(1.0), XmlDoc(NULL),
+      LayerNode(NULL), GroundOverlayNode(NULL), PlacemarkNode(NULL),
+      GeomNode(NULL), Items(NULL), NumItems(0), FirstLayer(MS_TRUE), map(NULL),
+      currentLayer(NULL), mElevationFromAttribute(false),
+      mElevationAttributeIndex(-1), mCurrentElevationValue(0.0)
+
+{
+  /*private variables*/
+  pszLayerDescMetadata = NULL;
+  papszLayerIncludeItems = NULL;
+  nIncludeItems = 0;
+  papszLayerExcludeItems = NULL;
+  nExcludeItems = 0;
+  pszLayerNameAttributeMetadata =
+      NULL; /*metadata to use for a name for each feature*/
+
+  LineStyle = NULL;
+  numLineStyle = 0;
+
+  xmlNodePtr styleNode;
+  xmlNodePtr listStyleNode;
+  /*  Create document.*/
+  XmlDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  xmlNodePtr rootNode = xmlNewNode(NULL, BAD_CAST "kml");
+
+  /*  Name spaces*/
+  xmlSetNs(rootNode,
+           xmlNewNs(rootNode, BAD_CAST "http://www.opengis.net/kml/2.2", NULL));
+
+  xmlDocSetRootElement(XmlDoc, rootNode);
+
+  DocNode = xmlNewChild(rootNode, NULL, BAD_CAST "Document", NULL);
+
+  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
+  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_check");
+  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
+  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "check");
+
+  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
+  xmlNewProp(styleNode, BAD_CAST "id",
+             BAD_CAST "LayerFolder_checkHideChildren");
+  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
+  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType",
+              BAD_CAST "checkHideChildren");
+
+  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
+  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_checkOffOnly");
+  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
+  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType",
+              BAD_CAST "checkOffOnly");
+
+  styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
+  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_radioFolder");
+  listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
+  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType",
+              BAD_CAST "radioFolder");
+
+  StyleHashTable = msCreateHashTable();
+}
+
+KmlRenderer::~KmlRenderer() {
+  if (XmlDoc)
+    xmlFreeDoc(XmlDoc);
+
+  if (StyleHashTable)
+    msFreeHashTable(StyleHashTable);
+
+  if (LineStyle)
+    msFree(LineStyle);
+
+  xmlCleanupParser();
+}
+
+imageObj *KmlRenderer::createImage(int, int, outputFormatObj *, colorObj *) {
+  return NULL;
+}
+
+int KmlRenderer::saveImage(imageObj *, FILE *fp, outputFormatObj *format) {
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document.                                         */
+  /* -------------------------------------------------------------------- */
+
+  int bufSize = 0;
+  xmlChar *buf = NULL;
+  msIOContext *context = NULL;
+  int chunkSize = 4096;
+  int bZip = MS_FALSE;
+
+  if (msIO_needBinaryStdout() == MS_FAILURE)
+    return MS_FAILURE;
+
+  xmlDocDumpFormatMemoryEnc(XmlDoc, &buf, &bufSize, "UTF-8", 1);
+
+  if (format && format->driver && strcasecmp(format->driver, "kmz") == 0) {
+    bZip = MS_TRUE;
+  }
+
+  if (bZip) {
+    VSILFILE *fpZip;
+    int bytes_read;
+    char buffer[1024];
+    char *zip_filename = NULL;
+    void *hZip = NULL;
+
+    zip_filename = msTmpFile(NULL, NULL, "/vsimem/kmlzip/", "kmz");
+    hZip = CPLCreateZip(zip_filename, NULL);
+    CPLCreateFileInZip(hZip, "mapserver.kml", NULL);
+    for (int i = 0; i < bufSize; i += chunkSize) {
+      int size = chunkSize;
+      if (i + size > bufSize)
+        size = bufSize - i;
+      CPLWriteFileInZip(hZip, buf + i, size);
+    }
+    CPLCloseFileInZip(hZip);
+    CPLCloseZip(hZip);
+
+    context = msIO_getHandler(fp);
+    fpZip = VSIFOpenL(zip_filename, "r");
+
+    while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fpZip)) > 0) {
+      if (context)
+        msIO_contextWrite(context, buffer, bytes_read);
+      else
+        msIO_fwrite(buffer, 1, bytes_read, fp);
+    }
+    VSIFCloseL(fpZip);
+    msFree(zip_filename);
+    xmlFree(buf);
+    return (MS_SUCCESS);
+  }
+
+  context = msIO_getHandler(fp);
+
+  for (int i = 0; i < bufSize; i += chunkSize) {
+    int size = chunkSize;
+    if (i + size > bufSize)
+      size = bufSize - i;
+
+    if (context)
+      msIO_contextWrite(context, buf + i, size);
+    else
+      msIO_fwrite(buf + i, 1, size, fp);
+  }
+
+  xmlFree(buf);
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                               processLayer                           */
+/*                                                                      */
+/*      Set parameters that make sense to a kml output.                 */
+/************************************************************************/
+void KmlRenderer::processLayer(layerObj *layer, outputFormatObj *format) {
+  int i;
+  const char *asRaster = NULL;
+  int nMaxFeatures = -1;
+  const char *pszTmp;
+  char szTmp[10];
+
+  if (!layer)
+    return;
+
+  /*turn of labelcache*/
+  layer->labelcache = MS_OFF;
+
+  /*if there are labels we want the coordinates to
+    be the center of the element.*/
+  for (i = 0; i < layer->numclasses; i++)
+    if (layer->_class[i]->numlabels > 0)
+      layer->_class[i]->labels[0]->position = MS_XY;
+
+  /*we do not want to draw multiple styles.
+    the new rendering architecture does not allow
+    to know if we are dealing with a multi-style.
+    So here we remove all styles beside the first one*/
+
+  for (i = 0; i < layer->numclasses; i++) {
+    while (layer->_class[i]->numstyles > 1)
+      msDeleteStyle(layer->_class[i], layer->_class[i]->numstyles - 1);
+  }
+
+  /*if layer has a metadata KML_OUTPUTASRASTER set to true, add a processing
+    directive to use an agg driver*/
+  asRaster = msLookupHashTable(&layer->metadata, "kml_outputasraster");
+  if (!asRaster)
+    asRaster =
+        msLookupHashTable(&(layer->map->web.metadata), "kml_outputasraster");
+  if (asRaster &&
+      (strcasecmp(asRaster, "true") == 0 || strcasecmp(asRaster, "yes") == 0))
+    msLayerAddProcessing(layer, "RENDERER=png24");
+
+  /*set a maxfeaturestodraw, if not already set*/
+
+  pszTmp = msLookupHashTable(&layer->metadata, "maxfeaturestodraw");
+  if (pszTmp)
+    nMaxFeatures = atoi(pszTmp);
+  else {
+    pszTmp = msLookupHashTable(&layer->map->web.metadata, "maxfeaturestodraw");
+    if (pszTmp)
+      nMaxFeatures = atoi(pszTmp);
+  }
+  if (nMaxFeatures < 0 && format)
+    nMaxFeatures =
+        atoi(msGetOutputFormatOption(format, "maxfeaturestodraw", "-1"));
+
+  if (nMaxFeatures < 0 && format) {
+    snprintf(szTmp, sizeof(szTmp), "%d", KML_MAXFEATURES_TODRAW);
+    msSetOutputFormatOption(format, "maxfeaturestodraw", szTmp);
+  }
+}
+
+/************************************************************************/
+/*                               getLayerName                           */
+/*                                                                      */
+/*      Internal utility function to build name used fo rthe layer.     */
+/************************************************************************/
+char *KmlRenderer::getLayerName(layerObj *layer) {
+  char stmp[20];
+  const char *name = NULL;
+  ;
+
+  if (!layer)
+    return NULL;
+
+  name = msLookupHashTable(&layer->metadata, "ows_name");
+  if (name && strlen(name) > 0)
+    return msStrdup(name);
+
+  if (layer->name && strlen(layer->name) > 0)
+    return msStrdup(layer->name);
+
+  sprintf(stmp, "Layer%d", layer->index);
+  return msStrdup(stmp);
+}
+
+const char *KmlRenderer::getAliasName(layerObj *lp, char *pszItemName,
+                                      const char *namespaces) {
+  const char *pszAlias = NULL;
+  if (lp && pszItemName && strlen(pszItemName) > 0) {
+    char szTmp[256];
+    snprintf(szTmp, sizeof(szTmp), "%s_alias", pszItemName);
+    pszAlias = msOWSLookupMetadata(&(lp->metadata), namespaces, szTmp);
+  }
+  return pszAlias;
+}
+
+int KmlRenderer::startNewLayer(imageObj *img, layerObj *layer) {
+  char *layerName = NULL;
+  const char *value = NULL;
+
+  LayerNode = xmlNewNode(NULL, BAD_CAST "Folder");
+
+  layerName = getLayerName(layer);
+  xmlNewChild(LayerNode, NULL, BAD_CAST "name", BAD_CAST layerName);
+  msFree(layerName);
+
+  const char *layerVisibility = layer->status != MS_OFF ? "1" : "0";
+  xmlNewChild(LayerNode, NULL, BAD_CAST "visibility", BAD_CAST layerVisibility);
+
+  const char *layerDsiplayFolder =
+      msLookupHashTable(&(layer->metadata), "kml_folder_display");
+  if (layerDsiplayFolder == NULL)
+    layerDsiplayFolder =
+        msLookupHashTable(&(layer->map->web.metadata), "kml_folder_display");
+  if (!layerDsiplayFolder || strlen(layerDsiplayFolder) <= 0) {
+    xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                BAD_CAST "#LayerFolder_check");
+  }
+
+  else {
+    if (strcasecmp(layerDsiplayFolder, "checkHideChildren") == 0)
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_checkHideChildren");
+    else if (strcasecmp(layerDsiplayFolder, "checkOffOnly") == 0)
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_checkOffOnly");
+    else if (strcasecmp(layerDsiplayFolder, "radioFolder") == 0)
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_radioFolder");
+    else
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_check");
+  }
+
+  /*Init few things on the first layer*/
+  if (FirstLayer) {
+    FirstLayer = MS_FALSE;
+    map = layer->map;
+
+    if (layer->map->mappath)
+      snprintf(MapPath, sizeof(MapPath), "%s", layer->map->mappath);
+
+    /*First rendered layer - check mapfile projection*/
+    checkProjection(layer->map);
+
+    /*check for image path and image url*/
+    if (layer->map->debug &&
+        (layer->map->web.imageurl == NULL || layer->map->web.imagepath == NULL))
+      msDebug("KmlRenderer::startNewLayer: imagepath and imageurl should be "
+              "set in the web object\n");
+
+    /*map rect for ground overlay*/
+    MapExtent = layer->map->extent;
+    MapCellsize = layer->map->cellsize;
+    BgColor = layer->map->imagecolor;
+
+    xmlNewChild(DocNode, NULL, BAD_CAST "name", BAD_CAST layer->map->name);
+    aggFormat = msSelectOutputFormat(layer->map, "png24");
+    aggFormat->transparent = MS_TRUE;
+  }
+
+  currentLayer = layer;
+
+  if (!msLayerIsOpen(layer)) {
+    if (msLayerOpen(layer) != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "msLayerOpen failed",
+                 "KmlRenderer::startNewLayer");
+      return MS_FAILURE;
+    }
+  }
+
+  /*pre process the layer to set things that make sense for kml output*/
+  if (img)
+    processLayer(layer, img->format);
+  else
+    processLayer(layer, NULL);
+
+  if (msLookupHashTable(&layer->metadata, "kml_description"))
+    pszLayerDescMetadata =
+        msLookupHashTable(&layer->metadata, "kml_description");
+  else if (msLookupHashTable(&layer->metadata, "ows_description"))
+    pszLayerDescMetadata =
+        msLookupHashTable(&layer->metadata, "ows_description");
+
+  value = msLookupHashTable(&layer->metadata, "kml_include_items");
+  if (!value)
+    value = msLookupHashTable(&layer->metadata, "ows_include_items");
+  if (value)
+    papszLayerIncludeItems = msStringSplit(value, ',', &nIncludeItems);
+
+  value = msLookupHashTable(&layer->metadata, "kml_exclude_items");
+  if (!value)
+    value = msLookupHashTable(&layer->metadata, "ows_exclude_items");
+  if (value)
+    papszLayerExcludeItems = msStringSplit(value, ',', &nExcludeItems);
+
+  if (msLookupHashTable(&layer->metadata, "kml_name_item"))
+    pszLayerNameAttributeMetadata =
+        msLookupHashTable(&layer->metadata, "kml_name_item");
+
+  /*get all attributes*/
+  if (msLayerWhichItems(layer, MS_TRUE, NULL) != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  NumItems = layer->numitems;
+  if (NumItems) {
+    Items = (char **)msSmallCalloc(NumItems, sizeof(char *));
+    for (int i = 0; i < NumItems; i++)
+      Items[i] = msStrdup(layer->items[i]);
+  }
+
+  const char *elevationAttribute =
+      msLookupHashTable(&layer->metadata, "kml_elevation_attribute");
+  if (elevationAttribute) {
+    mElevationFromAttribute = true;
+    for (int i = 0; i < layer->numitems; ++i) {
+      if (strcasecmp(layer->items[i], elevationAttribute) == 0) {
+        mElevationAttributeIndex = i;
+      }
+    }
+  }
+
+  setupRenderingParams(&layer->metadata);
+  return MS_SUCCESS;
+}
+
+int KmlRenderer::closeNewLayer(imageObj *, layerObj *) {
+  flushPlacemark();
+
+  xmlAddChild(DocNode, LayerNode);
+
+  if (Items) {
+    msFreeCharArray(Items, NumItems);
+    Items = NULL;
+    NumItems = 0;
+  }
+
+  if (pszLayerDescMetadata)
+    pszLayerDescMetadata = NULL;
+  if (pszLayerNameAttributeMetadata)
+    pszLayerNameAttributeMetadata = NULL;
+
+  if (papszLayerIncludeItems && nIncludeItems > 0)
+    msFreeCharArray(papszLayerIncludeItems, nIncludeItems);
+  papszLayerIncludeItems = NULL;
+
+  if (papszLayerExcludeItems && nExcludeItems > 0)
+    msFreeCharArray(papszLayerExcludeItems, nExcludeItems);
+  papszLayerExcludeItems = NULL;
+
+  return MS_SUCCESS;
+}
+
+int KmlRenderer::mergeRasterBuffer(imageObj *image, rasterBufferObj *rb) {
+  assert(rb && rb->type == MS_BUFFER_BYTE_RGBA);
+  char *tmpFileName = NULL;
+  char *tmpUrl = NULL;
+  FILE *tmpFile = NULL;
+
+  tmpFileName = msTmpFile(NULL, MapPath, image->imagepath, "png");
+  tmpFile = fopen(tmpFileName, "wb");
+  if (tmpFile) {
+
+    if (!aggFormat->vtable)
+      msInitializeRendererVTable(aggFormat);
+
+    msSaveRasterBuffer(map, rb, tmpFile, aggFormat);
+    tmpUrl = msStrdup(image->imageurl);
+    tmpUrl = msStringConcatenate(tmpUrl, (char *)(msGetBasename(tmpFileName)));
+    tmpUrl = msStringConcatenate(tmpUrl, ".png");
+
+    createGroundOverlayNode(LayerNode, tmpUrl, currentLayer);
+    msFree(tmpFileName);
+    msFree(tmpUrl);
+    fclose(tmpFile);
+    return MS_SUCCESS;
+  } else {
+    msSetError(MS_IOERR, "Failed to create file for kml overlay",
+               "KmlRenderer::mergeRasterBuffer()");
+    return MS_FAILURE;
+  }
+}
+
+void KmlRenderer::setupRenderingParams(hashTableObj *layerMetadata) {
+  AltitudeMode = 0;
+  Extrude = 0;
+  Tessellate = 0;
+
+  const char *altitudeModeVal =
+      msLookupHashTable(layerMetadata, "kml_altitudeMode");
+  if (altitudeModeVal) {
+    if (strcasecmp(altitudeModeVal, "absolute") == 0)
+      AltitudeMode = absolute;
+    else if (strcasecmp(altitudeModeVal, "relativeToGround") == 0)
+      AltitudeMode = relativeToGround;
+    else if (strcasecmp(altitudeModeVal, "clampToGround") == 0)
+      AltitudeMode = clampToGround;
+  }
+
+  const char *extrudeVal = msLookupHashTable(layerMetadata, "kml_extrude");
+  if (altitudeModeVal) {
+    Extrude = atoi(extrudeVal);
+  }
+
+  const char *tessellateVal =
+      msLookupHashTable(layerMetadata, "kml_tessellate");
+  if (tessellateVal) {
+    Tessellate = atoi(tessellateVal);
+  }
+}
+
+int KmlRenderer::checkProjection(mapObj *map) {
+  projectionObj *projection = &map->projection;
+  if (projection && projection->numargs > 0 &&
+      msProjIsGeographicCRS(projection)) {
+    return MS_SUCCESS;
+  } else {
+    char epsg_string[100];
+    rectObj sRect;
+    projectionObj out;
+
+    /* for layer the do not have any projection set, set them with the current
+       map projection*/
+    if (projection && projection->numargs > 0) {
+      layerObj *lp = NULL;
+      int i = 0;
+      char *pszMapProjectString = msGetProjectionString(projection);
+      if (pszMapProjectString) {
+        for (i = 0; i < map->numlayers; i++) {
+          lp = GET_LAYER(map, i);
+          if (lp->projection.numargs == 0 && lp->transform == MS_TRUE) {
+            msFreeProjection(&lp->projection);
+            msLoadProjectionString(&lp->projection, pszMapProjectString);
+          }
+        }
+        msFree(pszMapProjectString);
+      }
+    }
+    strcpy(epsg_string, "epsg:4326");
+    msInitProjection(&out);
+    msProjectionInheritContextFrom(&out, projection);
+    msLoadProjectionString(&out, epsg_string);
+
+    sRect = map->extent;
+    msProjectRect(projection, &out, &sRect);
+    msFreeProjectionExceptContext(projection);
+    msLoadProjectionString(projection, epsg_string);
+
+    /*change also units and extents*/
+    map->extent = sRect;
+    map->units = MS_DD;
+
+    if (map->debug)
+      msDebug("KmlRenderer::checkProjection: Mapfile projection set to "
+              "epsg:4326\n");
+
+    return MS_SUCCESS;
+  }
+}
+
+xmlNodePtr KmlRenderer::createPlacemarkNode(xmlNodePtr parentNode,
+                                            char *styleUrl) {
+  xmlNodePtr placemarkNode =
+      xmlNewChild(parentNode, NULL, BAD_CAST "Placemark", NULL);
+  /*always add a name. It will be replaced by a text value if available*/
+  char tmpid[100];
+  char *stmp = NULL, *layerName = NULL;
+  if (CurrentShapeName && strlen(CurrentShapeName) > 0) {
+    xmlNewChild(placemarkNode, NULL, BAD_CAST "name",
+                BAD_CAST CurrentShapeName);
+  } else {
+    sprintf(tmpid, ".%d", CurrentShapeIndex);
+    layerName = getLayerName(currentLayer);
+    stmp = msStringConcatenate(stmp, layerName);
+    stmp = msStringConcatenate(stmp, tmpid);
+    xmlNewChild(placemarkNode, NULL, BAD_CAST "name", BAD_CAST stmp);
+  }
+  msFree(layerName);
+  msFree(stmp);
+  if (styleUrl)
+    xmlNewChild(placemarkNode, NULL, BAD_CAST "styleUrl", BAD_CAST styleUrl);
+
+  return placemarkNode;
+}
+
+void KmlRenderer::renderLine(imageObj *, shapeObj *p, strokeStyleObj *style) {
+  if (p->numlines == 0)
+    return;
+
+  if (PlacemarkNode == NULL)
+    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
+
+  if (!PlacemarkNode)
+    return;
+
+  addLineStyleToList(style);
+  SymbologyFlag[Line] = 1;
+
+  /*p->index > CurrentDrawnShapeIndexneed to be reviewd. Added since the hight
+    level code caches shapes when rendering lines*/
+  if (CurrentDrawnShapeIndex == -1 || p->index > CurrentDrawnShapeIndex) {
+    xmlNodePtr geomNode = getGeomParentNode("LineString");
+    addAddRenderingSpecifications(geomNode);
+    addCoordsNode(geomNode, p->line[0].point, p->line[0].numpoints);
+
+    /* more than one line => MultiGeometry*/
+    if (p->numlines > 1) {
+      geomNode = getGeomParentNode("LineString"); // returns MultiGeom Node
+      for (int i = 1; i < p->numlines; i++) {
+        xmlNodePtr lineStringNode =
+            xmlNewChild(geomNode, NULL, BAD_CAST "LineString", NULL);
+        addAddRenderingSpecifications(lineStringNode);
+        addCoordsNode(lineStringNode, p->line[i].point, p->line[i].numpoints);
+      }
+    }
+
+    CurrentDrawnShapeIndex = p->index;
+  }
+}
+
+void KmlRenderer::renderPolygon(imageObj *, shapeObj *p, colorObj *color) {
+  if (PlacemarkNode == NULL)
+    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
+
+  if (!PlacemarkNode)
+    return;
+
+  memcpy(&PolygonColor, color, sizeof(colorObj));
+  SymbologyFlag[Polygon] = 1;
+
+  if (p->index != CurrentDrawnShapeIndex) {
+
+    xmlNodePtr geomParentNode = getGeomParentNode("Polygon");
+
+    for (int i = 0; i < p->numlines; i++) {
+      xmlNodePtr bdryNode = NULL;
+
+      if (i == 0) /* __TODO__ check ring order*/
+        bdryNode =
+            xmlNewChild(geomParentNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
+      else
+        bdryNode =
+            xmlNewChild(geomParentNode, NULL, BAD_CAST "innerBoundaryIs", NULL);
+
+      xmlNodePtr ringNode =
+          xmlNewChild(bdryNode, NULL, BAD_CAST "LinearRing", NULL);
+      addAddRenderingSpecifications(ringNode);
+      addCoordsNode(ringNode, p->line[i].point, p->line[i].numpoints);
+    }
+
+    CurrentDrawnShapeIndex = p->index;
+  }
+}
+
+void KmlRenderer::addCoordsNode(xmlNodePtr parentNode, pointObj *pts,
+                                int numPts) {
+  char lineBuf[128];
+
+  xmlNodePtr coordsNode =
+      xmlNewChild(parentNode, NULL, BAD_CAST "coordinates", NULL);
+  xmlNodeAddContent(coordsNode, BAD_CAST "\n");
+
+  for (int i = 0; i < numPts; i++) {
+    if (mElevationFromAttribute) {
+      sprintf(lineBuf, "\t%.8f,%.8f,%.8f\n", pts[i].x, pts[i].y,
+              mCurrentElevationValue);
+    } else if (AltitudeMode == relativeToGround || AltitudeMode == absolute) {
+      sprintf(lineBuf, "\t%.8f,%.8f,%.8f\n", pts[i].x, pts[i].y, pts[i].z);
+    } else
+      sprintf(lineBuf, "\t%.8f,%.8f\n", pts[i].x, pts[i].y);
+
+    xmlNodeAddContent(coordsNode, BAD_CAST lineBuf);
+  }
+  xmlNodeAddContent(coordsNode, BAD_CAST "\t");
+}
+
+void KmlRenderer::renderGlyphs(imageObj *, const textSymbolObj *ts,
+                               colorObj *clr, colorObj * /*oc*/, int /*ow*/) {
+  if (ts->annotext == NULL || ts->textpath->numglyphs == 0)
+    return;
+
+  if (PlacemarkNode == NULL)
+    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
+
+  if (!PlacemarkNode)
+    return;
+
+  memcpy(&LabelColor, clr, sizeof(colorObj));
+  SymbologyFlag[Label] = 1;
+
+  /*there is alaws a default name (layer.shapeid). Replace it*/
+  for (xmlNodePtr node = PlacemarkNode->children; node; node = node->next) {
+    if (node->type != XML_ELEMENT_NODE)
+      continue;
+
+    if (strcmp((char *)node->name, "name") == 0) {
+      xmlNodeSetContent(node, BAD_CAST ts->annotext);
+      break;
+    }
+  }
+
+  /*xmlNewChild(PlacemarkNode, NULL, BAD_CAST "name", BAD_CAST text);*/
+
+  xmlNodePtr geomNode = getGeomParentNode("Point");
+  addAddRenderingSpecifications(geomNode);
+
+  pointObj pt;
+  pt.x = ts->textpath->glyphs[0].pnt.x;
+  pt.y = ts->textpath->glyphs[0].pnt.y;
+  pt.z = 0.0;
+  addCoordsNode(geomNode, &pt, 1);
+}
+
+void KmlRenderer::addAddRenderingSpecifications(xmlNodePtr node) {
+  /*
+    <extrude>0</extrude>                   <!-- boolean -->
+    <tessellate>0</tessellate>             <!-- boolean -->
+    <altitudeMode>clampToGround</altitudeMode>
+  */
+
+  if (Extrude)
+    xmlNewChild(node, NULL, BAD_CAST "extrude", BAD_CAST "1");
+
+  if (Tessellate)
+    xmlNewChild(node, NULL, BAD_CAST "tessellate", BAD_CAST "1");
+
+  if (AltitudeMode == absolute)
+    xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "absolute");
+  else if (AltitudeMode == relativeToGround)
+    xmlNewChild(node, NULL, BAD_CAST "altitudeMode",
+                BAD_CAST "relativeToGround");
+  else if (AltitudeMode == clampToGround)
+    xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "clampToGround");
+}
+
+imageObj *agg2CreateImage(int width, int height, outputFormatObj *format,
+                          colorObj *bg);
+
+int KmlRenderer::createIconImage(char *fileName, symbolObj *symbol,
+                                 symbolStyleObj *symstyle) {
+  pointObj p;
+  int status;
+
+  imageObj *tmpImg = NULL;
+
+  tmpImg =
+      agg2CreateImage((int)(symbol->sizex * symstyle->scale),
+                      (int)(symbol->sizey * symstyle->scale), aggFormat, NULL);
+  tmpImg->format = aggFormat;
+  if (!aggFormat->vtable)
+    msInitializeRendererVTable(aggFormat);
+
+  p.x = symbol->sizex * symstyle->scale / 2;
+  p.y = symbol->sizey * symstyle->scale / 2;
+  p.z = 0.0;
+
+  status = msDrawMarkerSymbol(map, tmpImg, &p, symstyle->style, 1);
+  if (status != MS_SUCCESS)
+    return status;
+
+  return msSaveImage(map, tmpImg, fileName);
+}
+
+void KmlRenderer::renderSymbol(imageObj *img, double x, double y,
+                               symbolObj *symbol, symbolStyleObj *style) {
+  if (PlacemarkNode == NULL)
+    PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
+
+  if (!PlacemarkNode)
+    return;
+
+  snprintf(SymbolUrl, sizeof(SymbolUrl), "%s",
+           lookupSymbolUrl(img, symbol, style));
+  SymbologyFlag[Symbol] = 1;
+
+  xmlNodePtr geomNode = getGeomParentNode("Point");
+  addAddRenderingSpecifications(geomNode);
+
+  pointObj pt;
+  pt.x = x;
+  pt.y = y;
+  pt.z = 0.0;
+  addCoordsNode(geomNode, &pt, 1);
+}
+
+void KmlRenderer::renderPixmapSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
+  renderSymbol(img, x, y, symbol, style);
+}
+
+void KmlRenderer::renderVectorSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
+  renderSymbol(img, x, y, symbol, style);
+}
+
+void KmlRenderer::renderEllipseSymbol(imageObj *img, double x, double y,
+                                      symbolObj *symbol,
+                                      symbolStyleObj *style) {
+  renderSymbol(img, x, y, symbol, style);
+}
+
+void KmlRenderer::renderTruetypeSymbol(imageObj *img, double x, double y,
+                                       symbolObj *symbol,
+                                       symbolStyleObj *style) {
+  renderSymbol(img, x, y, symbol, style);
+}
+
+xmlNodePtr KmlRenderer::createGroundOverlayNode(xmlNodePtr parentNode,
+                                                char *imageHref,
+                                                layerObj *layer) {
+  /*
+    <?xml version="1.0" encoding="UTF-8"?>
+    <kml xmlns="http://www.opengis.net/kml/2.2">
+    <GroundOverlay>
+    <name>GroundOverlay.kml</name>
+    <color>7fffffff</color>
+    <drawOrder>1</drawOrder>
+    <Icon>
+    <href>http://www.google.com/intl/en/images/logo.gif</href>
+    <refreshMode>onInterval</refreshMode>
+    <refreshInterval>86400</refreshInterval>
+    <viewBoundScale>0.75</viewBoundScale>
+    </Icon>
+    <LatLonBox>
+    <north>37.83234</north>
+    <south>37.832122</south>
+    <east>-122.373033</east>
+    <west>-122.373724</west>
+    <rotation>45</rotation>
+    </LatLonBox>
+    </GroundOverlay>
+    </kml>
+  */
+  char layerHexColor[32];
+  xmlNodePtr groundOverlayNode =
+      xmlNewChild(parentNode, NULL, BAD_CAST "GroundOverlay", NULL);
+  char *layerName = getLayerName(layer);
+  xmlNewChild(groundOverlayNode, NULL, BAD_CAST "name", BAD_CAST layerName);
+  if (layer->compositer && layer->compositer->opacity > 0 &&
+      layer->compositer->opacity < 100) {
+    sprintf(layerHexColor, "%02xffffff",
+            (unsigned int)MS_NINT(layer->compositer->opacity * 2.55));
+    xmlNewChild(groundOverlayNode, NULL, BAD_CAST "color",
+                BAD_CAST layerHexColor);
+  } else
+    xmlNewChild(groundOverlayNode, NULL, BAD_CAST "color", BAD_CAST "ffffffff");
+  char stmp[20];
+  sprintf(stmp, "%d", layer->index);
+  xmlNewChild(groundOverlayNode, NULL, BAD_CAST "drawOrder", BAD_CAST stmp);
+
+  if (imageHref) {
+    xmlNodePtr iconNode =
+        xmlNewChild(groundOverlayNode, NULL, BAD_CAST "Icon", NULL);
+    xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST imageHref);
+  }
+
+  char crdStr[64];
+  rectObj mapextent;
+  if (map->gt.need_geotransform == MS_TRUE)
+    mapextent = currentLayer->map->saved_extent;
+  else
+    mapextent = currentLayer->map->extent;
+
+  xmlNodePtr latLonBoxNode =
+      xmlNewChild(groundOverlayNode, NULL, BAD_CAST "LatLonBox", NULL);
+  sprintf(crdStr, "%.8f", mapextent.maxy);
+  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "north", BAD_CAST crdStr);
+
+  sprintf(crdStr, "%.8f", mapextent.miny);
+  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "south", BAD_CAST crdStr);
+
+  sprintf(crdStr, "%.8f", mapextent.minx);
+  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "west", BAD_CAST crdStr);
+
+  sprintf(crdStr, "%.8f", mapextent.maxx);
+  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "east", BAD_CAST crdStr);
+
+  xmlNewChild(latLonBoxNode, NULL, BAD_CAST "rotation", BAD_CAST "0.0");
+
+  return groundOverlayNode;
+}
+
+void KmlRenderer::startShape(imageObj *, shapeObj *shape) {
+  if (PlacemarkNode)
+    flushPlacemark();
+
+  CurrentShapeIndex = -1;
+  CurrentDrawnShapeIndex = -1;
+  CurrentShapeName = NULL;
+
+  /*should be done at endshape but the plugin architecture does not call
+   * endshape yet*/
+  if (LineStyle) {
+    msFree(LineStyle);
+
+    LineStyle = NULL;
+    numLineStyle = 0;
+  }
+
+  CurrentShapeIndex = shape->index;
+  if (pszLayerNameAttributeMetadata) {
+    for (int i = 0; i < currentLayer->numitems; i++) {
+      if (strcasecmp(currentLayer->items[i], pszLayerNameAttributeMetadata) ==
+              0 &&
+          shape->values[i]) {
+        CurrentShapeName = msStrdup(shape->values[i]);
+        break;
+      }
+    }
+  }
+  PlacemarkNode = NULL;
+  GeomNode = NULL;
+
+  DescriptionNode = createDescriptionNode(shape);
+
+  if (mElevationFromAttribute && shape->numvalues > mElevationAttributeIndex &&
+      mElevationAttributeIndex >= 0 &&
+      shape->values[mElevationAttributeIndex]) {
+    mCurrentElevationValue = atof(shape->values[mElevationAttributeIndex]);
+  }
+
+  memset(SymbologyFlag, 0, NumSymbologyFlag);
+}
+
+void KmlRenderer::endShape(imageObj *, shapeObj *) {
+  CurrentShapeIndex = -1;
+  if (CurrentShapeName)
+    msFree(CurrentShapeName);
+  CurrentShapeName = NULL;
+}
+
+xmlNodePtr KmlRenderer::getGeomParentNode(const char *geomName) {
+  /*we do not need a multi-geometry for point layers*/
+  if (currentLayer->type != MS_LAYER_POINT &&
+      currentLayer->type != MS_LAYER_ANNOTATION && GeomNode) {
+    /*placemark geometry already defined, we need multigeometry node*/
+    xmlNodePtr multiGeomNode = xmlNewNode(NULL, BAD_CAST "MultiGeometry");
+    xmlAddChild(multiGeomNode, GeomNode);
+    GeomNode = multiGeomNode;
+
+    xmlNodePtr geomNode =
+        xmlNewChild(multiGeomNode, NULL, BAD_CAST geomName, NULL);
+    return geomNode;
+  } else {
+    GeomNode = xmlNewNode(NULL, BAD_CAST geomName);
+    return GeomNode;
+  }
+}
+
+const char *KmlRenderer::lookupSymbolUrl(imageObj *img, symbolObj *symbol,
+                                         symbolStyleObj *symstyle) {
+  char symbolHexColor[32];
+  /*
+      <Style id="randomColorIcon">
+      <IconStyle>
+      <color>ff00ff00</color>
+      <colorMode>random</colorMode>
+      <scale>1.1</scale>
+      <Icon>
+      <href>http://maps.google.com/mapfiles/kml/pal3/icon21.png</href>
+      </Icon>
+      </IconStyle>
+      </Style>
+  */
+
+  sprintf(symbolHexColor, "%02x%02x%02x%02x", symstyle->style->color.alpha,
+          symstyle->style->color.blue, symstyle->style->color.green,
+          symstyle->style->color.red);
+  snprintf(SymbolName, sizeof(SymbolName), "symbol_%s_%.1f_%s", symbol->name,
+           symstyle->scale, symbolHexColor);
+
+  const char *symbolUrl = msLookupHashTable(StyleHashTable, SymbolName);
+  if (!symbolUrl) {
+    char iconFileName[MS_MAXPATHLEN];
+    char iconUrl[MS_MAXPATHLEN];
+
+    if (img->imagepath) {
+      char *tmpFileName = msTmpFile(NULL, MapPath, img->imagepath, "png");
+      snprintf(iconFileName, sizeof(iconFileName), "%s", tmpFileName);
+      msFree(tmpFileName);
+    } else {
+      sprintf(iconFileName, "symbol_%s_%.1f.%s", symbol->name, symstyle->scale,
+              "png");
+    }
+
+    if (createIconImage(iconFileName, symbol, symstyle) != MS_SUCCESS) {
+      msSetError(MS_IOERR, "Error creating icon file '%s'",
+                 "KmlRenderer::lookupSymbolStyle()", iconFileName);
+      return NULL;
+    }
+
+    if (img->imageurl)
+      sprintf(iconUrl, "%s%s.%s", img->imageurl, msGetBasename(iconFileName),
+              "png");
+    else
+      snprintf(iconUrl, sizeof(iconUrl), "%s", iconFileName);
+
+    hashObj *hash = msInsertHashTable(StyleHashTable, SymbolName, iconUrl);
+    symbolUrl = hash->data;
+  }
+
+  return symbolUrl;
+}
+
+const char *KmlRenderer::lookupPlacemarkStyle() {
+  char lineHexColor[32];
+  char polygonHexColor[32];
+  char labelHexColor[32];
+  char *styleName = NULL;
+
+  styleName = msStringConcatenate(styleName, "style");
+
+  if (SymbologyFlag[Line]) {
+    /*
+      <LineStyle id="ID">
+      <!-- inherited from ColorStyle -->
+      <color>ffffffff</color>            <!-- kml:color -->
+      <colorMode>normal</colorMode>      <!-- colorModeEnum: normal or random
+      -->
+
+      <!-- specific to LineStyle -->
+      <width>1</width>                   <!-- float -->
+      </LineStyle>
+    */
+
+    for (int i = 0; i < numLineStyle; i++) {
+      if (currentLayer && currentLayer->compositer &&
+          currentLayer->compositer->opacity > 0 &&
+          currentLayer->compositer->opacity < 100 &&
+          LineStyle[i].color->alpha == 255)
+        LineStyle[i].color->alpha =
+            MS_NINT(currentLayer->compositer->opacity * 2.55);
+
+      sprintf(lineHexColor, "%02x%02x%02x%02x", LineStyle[i].color->alpha,
+              LineStyle[0].color->blue, LineStyle[i].color->green,
+              LineStyle[i].color->red);
+
+      char lineStyleName[64];
+      snprintf(lineStyleName, sizeof(lineStyleName), "_line_%s_w%.1f",
+               lineHexColor, LineStyle[i].width);
+      styleName = msStringConcatenate(styleName, lineStyleName);
+    }
+  }
+
+  if (SymbologyFlag[Polygon]) {
+    /*
+      <PolyStyle id="ID">
+      <!-- inherited from ColorStyle -->
+      <color>ffffffff</color>            <!-- kml:color -->
+      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or
+      random -->
+
+      <!-- specific to PolyStyle -->
+      <fill>1</fill>                     <!-- boolean -->
+      <outline>1</outline>               <!-- boolean -->
+      </PolyStyle>
+    */
+
+    if (currentLayer && currentLayer->compositer &&
+        currentLayer->compositer->opacity > 0 &&
+        currentLayer->compositer->opacity < 100 && PolygonColor.alpha == 255)
+      PolygonColor.alpha = MS_NINT(currentLayer->compositer->opacity * 2.55);
+    sprintf(polygonHexColor, "%02x%02x%02x%02x", PolygonColor.alpha,
+            PolygonColor.blue, PolygonColor.green, PolygonColor.red);
+
+    char polygonStyleName[64];
+    sprintf(polygonStyleName, "_polygon_%s", polygonHexColor);
+    styleName = msStringConcatenate(styleName, polygonStyleName);
+  }
+
+  if (SymbologyFlag[Label]) {
+    /*
+      <LabelStyle id="ID">
+      <!-- inherited from ColorStyle -->
+      <color>ffffffff</color>            <!-- kml:color -->
+      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or
+      random -->
+
+      <!-- specific to LabelStyle -->
+      <scale>1</scale>                   <!-- float -->
+      </LabelStyle>
+    */
+
+    if (currentLayer && currentLayer->compositer &&
+        currentLayer->compositer->opacity > 0 &&
+        currentLayer->compositer->opacity < 100 && LabelColor.alpha == 255)
+      LabelColor.alpha = MS_NINT(currentLayer->compositer->opacity * 2.55);
+    sprintf(labelHexColor, "%02x%02x%02x%02x", LabelColor.alpha,
+            LabelColor.blue, LabelColor.green, LabelColor.red);
+
+    // __TODO__ add label scale
+
+    char labelStyleName[64];
+    sprintf(labelStyleName, "_label_%s", labelHexColor);
+    styleName = msStringConcatenate(styleName, labelStyleName);
+  }
+
+  if (SymbologyFlag[Symbol]) {
+    /*
+    <Style id="randomColorIcon">
+            <IconStyle>
+            <color>ff00ff00</color>
+            <colorMode>random</colorMode>
+            <scale>1.1</scale>
+            <Icon>
+            <href>http://maps.google.com/mapfiles/kml/pal3/icon21.png</href>
+            </Icon>
+            </IconStyle>
+    </Style>
+    */
+
+    /* __TODO__ add label scale */
+
+    styleName = msStringConcatenate(styleName, "_");
+    styleName = msStringConcatenate(styleName, SymbolName);
+  }
+
+  const char *styleUrl = msLookupHashTable(StyleHashTable, styleName);
+  if (!styleUrl) {
+    char *styleValue = NULL;
+    styleValue = msStringConcatenate(styleValue, "#");
+    styleValue = msStringConcatenate(styleValue, styleName);
+    hashObj *hash = msInsertHashTable(StyleHashTable, styleName, styleValue);
+    styleUrl = hash->data;
+    msFree(styleValue);
+
+    /* Insert new Style node into Document node*/
+    xmlNodePtr styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
+    xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST styleName);
+
+    if (SymbologyFlag[Polygon]) {
+      xmlNodePtr polyStyleNode =
+          xmlNewChild(styleNode, NULL, BAD_CAST "PolyStyle", NULL);
+      xmlNewChild(polyStyleNode, NULL, BAD_CAST "color",
+                  BAD_CAST polygonHexColor);
+    }
+
+    if (SymbologyFlag[Line]) {
+      for (int i = 0; i < numLineStyle; i++) {
+        xmlNodePtr lineStyleNode =
+            xmlNewChild(styleNode, NULL, BAD_CAST "LineStyle", NULL);
+        sprintf(lineHexColor, "%02x%02x%02x%02x", LineStyle[i].color->alpha,
+                LineStyle[i].color->blue, LineStyle[i].color->green,
+                LineStyle[i].color->red);
+        xmlNewChild(lineStyleNode, NULL, BAD_CAST "color",
+                    BAD_CAST lineHexColor);
+
+        char width[16];
+        sprintf(width, "%.1f", LineStyle[i].width);
+        xmlNewChild(lineStyleNode, NULL, BAD_CAST "width", BAD_CAST width);
+      }
+    }
+
+    if (SymbologyFlag[Symbol]) {
+      xmlNodePtr iconStyleNode =
+          xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
+
+      xmlNodePtr iconNode =
+          xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
+      xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST SymbolUrl);
+
+      /*char scale[16];
+        sprintf(scale, "%.1f", style->scale);
+        xmlNewChild(iconStyleNode, NULL, BAD_CAST "scale", BAD_CAST scale);*/
+    } else {
+      const char *value =
+          msLookupHashTable(&currentLayer->metadata, "kml_default_symbol_href");
+      if (value && strlen(value) > 0) {
+        xmlNodePtr iconStyleNode =
+            xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
+
+        xmlNodePtr iconNode =
+            xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
+        xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST value);
+      }
+    }
+
+    if (SymbologyFlag[Label]) {
+      xmlNodePtr labelStyleNode =
+          xmlNewChild(styleNode, NULL, BAD_CAST "LabelStyle", NULL);
+      xmlNewChild(labelStyleNode, NULL, BAD_CAST "color",
+                  BAD_CAST labelHexColor);
+
+      /*char scale[16];
+        sprintf(scale, "%.1f", style->scale);
+        xmlNewChild(iconStyleNode, NULL, BAD_CAST "scale", BAD_CAST scale);*/
+    }
+  }
+
+  if (styleName)
+    msFree(styleName);
+
+  return styleUrl;
+}
+
+void KmlRenderer::flushPlacemark() {
+  if (PlacemarkNode) {
+    const char *styleUrl = lookupPlacemarkStyle();
+    xmlNewChild(PlacemarkNode, NULL, BAD_CAST "styleUrl", BAD_CAST styleUrl);
+
+    if (DescriptionNode)
+      xmlAddChild(PlacemarkNode, DescriptionNode);
+
+    if (GeomNode)
+      xmlAddChild(PlacemarkNode, GeomNode);
+  }
+}
+
+xmlNodePtr KmlRenderer::createDescriptionNode(shapeObj *shape) {
+  /*
+    <description>
+    <![CDATA[
+    special characters here
+    ]]>
+    <description>
+  */
+
+  /*description nodes for vector layers:
+    - if kml_description is set, use it
+    - if not, dump the attributes */
+
+  if (pszLayerDescMetadata) {
+    char *pszTmp = NULL;
+    char *pszTmpDesc = NULL;
+    size_t bufferSize = 0;
+    pszTmpDesc = msStrdup(pszLayerDescMetadata);
+
+    for (int i = 0; i < currentLayer->numitems; i++) {
+      bufferSize = strlen(currentLayer->items[i]) + 3;
+      pszTmp = (char *)msSmallMalloc(bufferSize);
+      snprintf(pszTmp, bufferSize, "%%%s%%", currentLayer->items[i]);
+      if (strcasestr(pszTmpDesc, pszTmp))
+        pszTmpDesc =
+            msCaseReplaceSubstring(pszTmpDesc, pszTmp, shape->values[i]);
+      msFree(pszTmp);
+    }
+    xmlNodePtr descriptionNode = xmlNewNode(NULL, BAD_CAST "description");
+    xmlNodeAddContent(descriptionNode, BAD_CAST pszTmpDesc);
+    msFree(pszTmpDesc);
+    return descriptionNode;
+  } else if ((papszLayerIncludeItems && nIncludeItems > 0) ||
+             (papszLayerExcludeItems && nExcludeItems > 0)) {
+    /* -------------------------------------------------------------------- */
+    /*      preffered way is to use the ExtendedData tag (#3728)            */
+    /*      http://code.google.com/apis/kml/documentation/extendeddata.html */
+    /* -------------------------------------------------------------------- */
+
+    xmlNodePtr extendedDataNode = xmlNewNode(NULL, BAD_CAST "ExtendedData");
+    xmlNodePtr dataNode = NULL;
+    const char *pszAlias = NULL;
+    int bIncludeAll = MS_FALSE;
+
+    if (papszLayerIncludeItems && nIncludeItems == 1 &&
+        strcasecmp(papszLayerIncludeItems[0], "all") == 0)
+      bIncludeAll = MS_TRUE;
+
+    for (int i = 0; i < currentLayer->numitems; i++) {
+      int j = 0, k = 0;
+
+      /*TODO optimize to calculate this only once per layer*/
+      for (j = 0; j < nIncludeItems; j++) {
+        if (strcasecmp(currentLayer->items[i], papszLayerIncludeItems[j]) == 0)
+          break;
+      }
+      if (j < nIncludeItems || bIncludeAll) {
+        if (papszLayerExcludeItems && nExcludeItems > 0) {
+          for (k = 0; k < nExcludeItems; k++) {
+            if (strcasecmp(currentLayer->items[i], papszLayerExcludeItems[k]) ==
+                0)
+              break;
+          }
+        }
+        if (nExcludeItems == 0 || k == nExcludeItems) {
+          dataNode = xmlNewNode(NULL, BAD_CAST "Data");
+          xmlNewProp(dataNode, BAD_CAST "name",
+                     BAD_CAST currentLayer->items[i]);
+          pszAlias = getAliasName(currentLayer, currentLayer->items[i], "GO");
+          if (pszAlias)
+            xmlNewChild(dataNode, NULL, BAD_CAST "displayName",
+                        BAD_CAST pszAlias);
+          else
+            xmlNewChild(dataNode, NULL, BAD_CAST "displayName",
+                        BAD_CAST currentLayer->items[i]);
+          if (shape->values[i] && strlen(shape->values[i]))
+            xmlNewChild(dataNode, NULL, BAD_CAST "value",
+                        BAD_CAST shape->values[i]);
+          else
+            xmlNewChild(dataNode, NULL, BAD_CAST "value", NULL);
+          xmlAddChild(extendedDataNode, dataNode);
+        }
+      }
+    }
+
+    return extendedDataNode;
+  }
+
+  return NULL;
+}
+
+void KmlRenderer::addLineStyleToList(strokeStyleObj *style) {
+  /*actually this is not necessary. kml only uses the last LineStyle
+    so we should not bother keeping them all*/
+  int i = 0;
+  for (i = 0; i < numLineStyle; i++) {
+    if (style->width == LineStyle[i].width &&
+        LineStyle[i].color->alpha == style->color->alpha &&
+        LineStyle[i].color->red == style->color->red &&
+        LineStyle[i].color->green == style->color->green &&
+        LineStyle[i].color->blue == style->color->blue)
+      break;
+  }
+  if (i == numLineStyle) {
+    numLineStyle++;
+    if (LineStyle == NULL)
+      LineStyle = (strokeStyleObj *)msSmallMalloc(sizeof(strokeStyleObj));
+    else
+      LineStyle = (strokeStyleObj *)msSmallRealloc(
+          LineStyle, sizeof(strokeStyleObj) * numLineStyle);
+
+    memcpy(&LineStyle[numLineStyle - 1], style, sizeof(strokeStyleObj));
+  }
+}
+
+#endif
diff -pruN 8.0.1-5/src/mapkmlrenderer.h 8.2.0~beta1-1~exp1/src/mapkmlrenderer.h
--- 8.0.1-5/src/mapkmlrenderer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapkmlrenderer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,186 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Headers for mapkmlrenderer.cpp Google Earth KML output
+ * Author:   David Kana and the MapServer team
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2009 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#ifndef MAPKMLRENDERER_H
+#define MAPKMLRENDERER_H
+
+#include "mapserver-config.h"
+#if defined(USE_KML)
+
+#include "mapserver.h"
+#include "maplibxml2.h"
+
+class KmlRenderer {
+private:
+  const char *pszLayerDescMetadata = nullptr; /*if the kml_description is set*/
+  char **papszLayerIncludeItems = nullptr;
+  int nIncludeItems = 0;
+  char **papszLayerExcludeItems = nullptr;
+  int nExcludeItems = 0;
+  const char *pszLayerNameAttributeMetadata = nullptr;
+
+protected:
+  // map properties
+  int Width = 0, Height = 0;
+  rectObj MapExtent = {0, 0, 0, 0};
+  double MapCellsize = 0;
+  colorObj BgColor = {0, 0, 0, 0};
+  char MapPath[MS_MAXPATHLEN] = {0};
+
+  // xml nodes pointers
+  xmlDocPtr XmlDoc = nullptr;
+  xmlNodePtr DocNode = nullptr;
+  xmlNodePtr LayerNode = nullptr;
+  xmlNodePtr GroundOverlayNode = nullptr;
+
+  xmlNodePtr PlacemarkNode = nullptr;
+  xmlNodePtr GeomNode = nullptr;
+  xmlNodePtr DescriptionNode = nullptr;
+
+  int CurrentShapeIndex = 0;
+  int CurrentDrawnShapeIndex = 0;
+  char *CurrentShapeName = nullptr;
+  char **Items = nullptr;
+  int NumItems = 0;
+  int DumpAttributes = 0;
+
+  // placemark symbology
+  hashTableObj *StyleHashTable = nullptr;
+
+  colorObj LabelColor = {0, 0, 0, 0};
+  strokeStyleObj *LineStyle = nullptr;
+  int numLineStyle = 0;
+  colorObj PolygonColor = {0, 0, 0, 0};
+
+  char SymbolName[128] = {0};
+  char SymbolUrl[128] = {0};
+
+  enum { NumSymbologyFlag = 4 };
+  char SymbologyFlag[NumSymbologyFlag] = {0, 0, 0, 0};
+
+  enum symbFlagsEnum { Label, Line, Polygon, Symbol };
+
+  int FirstLayer = 0;
+
+  mapObj *map = nullptr;
+  layerObj *currentLayer = nullptr;
+
+  int AltitudeMode = 0;
+  int Tessellate = 0;
+  int Extrude = 0;
+
+  enum altitudeModeEnum {
+    undefined,
+    clampToGround,
+    relativeToGround,
+    absolute
+  };
+  /**True if elevation is taken from a feature attribute*/
+  bool mElevationFromAttribute = false;
+  /**Attribute index of elevation (or -1 if elevation is not attribute driven*/
+  int mElevationAttributeIndex = 0;
+  double mCurrentElevationValue = 0;
+
+  outputFormatObj *aggFormat = nullptr;
+
+protected:
+  imageObj *createInternalImage();
+  xmlNodePtr createPlacemarkNode(xmlNodePtr parentNode, char *styleUrl);
+  xmlNodePtr createGroundOverlayNode(xmlNodePtr parentNode, char *imageHref,
+                                     layerObj *layer);
+  xmlNodePtr createDescriptionNode(shapeObj *shape);
+
+  const char *lookupSymbolUrl(imageObj *img, symbolObj *symbol,
+                              symbolStyleObj *style);
+
+  void addCoordsNode(xmlNodePtr parentNode, pointObj *pts, int numPts);
+
+  void setupRenderingParams(hashTableObj *layerMetadata);
+  void addAddRenderingSpecifications(xmlNodePtr node);
+
+  int checkProjection(mapObj *map);
+
+  int createIconImage(char *fileName, symbolObj *symbol, symbolStyleObj *style);
+
+  void renderSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                    symbolStyleObj *style);
+
+  //////////////////////////////////////////////////////////////////////////////
+
+  void renderLineVector(imageObj *img, shapeObj *p, strokeStyleObj *style);
+  void renderPolygonVector(imageObj *img, shapeObj *p, colorObj *color);
+
+  const char *lookupPlacemarkStyle();
+  void flushPlacemark();
+  xmlNodePtr getGeomParentNode(const char *geomName);
+  char *getLayerName(layerObj *layer);
+  void processLayer(layerObj *layer, outputFormatObj *format);
+  void addLineStyleToList(strokeStyleObj *style);
+  const char *getAliasName(layerObj *lp, char *pszItemName,
+                           const char *namespaces);
+
+public:
+  KmlRenderer(int width, int height, outputFormatObj *format,
+              colorObj *color = NULL);
+  virtual ~KmlRenderer();
+
+  imageObj *createImage(int width, int height, outputFormatObj *format,
+                        colorObj *bg);
+  int saveImage(imageObj *img, FILE *fp, outputFormatObj *format);
+
+  int startNewLayer(imageObj *img, layerObj *layer);
+  int closeNewLayer(imageObj *img, layerObj *layer);
+
+  void startShape(imageObj *img, shapeObj *shape);
+  void endShape(imageObj *img, shapeObj *shape);
+
+  void renderLine(imageObj *img, shapeObj *p, strokeStyleObj *style);
+  void renderPolygon(imageObj *img, shapeObj *p, colorObj *color);
+
+  void renderGlyphs(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                    colorObj *oc, int ow);
+
+  // Symbols
+  void renderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                          symbolStyleObj *style);
+  void renderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                          symbolStyleObj *style);
+  void renderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                           symbolStyleObj *style);
+  void renderTruetypeSymbol(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style);
+
+  int getTruetypeTextBBox(imageObj *img, char **fonts, int numfonts,
+                          double size, char *string, rectObj *rect,
+                          double **advances);
+  int mergeRasterBuffer(imageObj *image, rasterBufferObj *rb);
+};
+
+#endif /* USE_KML */
+#endif
diff -pruN 8.0.1-5/src/maplabel.c 8.2.0~beta1-1~exp1/src/maplabel.c
--- 8.0.1-5/src/maplabel.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maplabel.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1348 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Labeling Implementation.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/*
+** maplabel.c: Routines to enable text drawing, BITMAP or TRUETYPE.
+*/
+
+#include <assert.h>
+#include <float.h>
+
+#include "mapserver.h"
+#include "fontcache.h"
+
+#include "cpl_vsi.h"
+#include "cpl_string.h"
+
+void initTextPath(textPathObj *ts) { memset(ts, 0, sizeof(*ts)); }
+
+int WARN_UNUSED msLayoutTextSymbol(mapObj *map, textSymbolObj *ts,
+                                   textPathObj *tgret);
+
+#if defined(USE_EXTENDED_DEBUG) && 0
+static void msDebugTextPath(textSymbolObj *ts) {
+  int i;
+  msDebug("text: %s\n", ts->annotext);
+  if (ts->textpath) {
+    for (i = 0; i < ts->textpath->numglyphs; i++) {
+      glyphObj *g = &ts->textpath->glyphs[i];
+      msDebug("glyph %d: pos: %f %f\n", g->glyph->key.codepoint, g->pnt.x,
+              g->pnt.y);
+    }
+  } else {
+    msDebug("no glyphs\n");
+  }
+  msDebug("\n=========================================\n");
+}
+#endif
+
+int msComputeTextPath(mapObj *map, textSymbolObj *ts) {
+  textPathObj *tgret = msSmallMalloc(sizeof(textPathObj));
+  assert(ts->annotext && *ts->annotext);
+  initTextPath(tgret);
+  ts->textpath = tgret;
+  tgret->absolute = 0;
+  tgret->glyph_size = ts->label->size * ts->scalefactor;
+  tgret->glyph_size =
+      MS_MAX(tgret->glyph_size, ts->label->minsize * ts->resolutionfactor);
+  tgret->glyph_size = MS_NINT(
+      MS_MIN(tgret->glyph_size, ts->label->maxsize * ts->resolutionfactor));
+  tgret->line_height = ceil(tgret->glyph_size * 1.33);
+  return msLayoutTextSymbol(map, ts, tgret);
+}
+
+void initTextSymbol(textSymbolObj *ts) { memset(ts, 0, sizeof(*ts)); }
+
+void freeTextPath(textPathObj *tp) {
+  free(tp->glyphs);
+  if (tp->bounds.poly) {
+    free(tp->bounds.poly->point);
+    free(tp->bounds.poly);
+  }
+}
+
+void freeTextSymbol(textSymbolObj *ts) { freeTextSymbolEx(ts, MS_TRUE); }
+
+void freeTextSymbolEx(textSymbolObj *ts, int doFreeLabel) {
+  if (ts->textpath) {
+    freeTextPath(ts->textpath);
+    free(ts->textpath);
+  }
+  if (ts->label->numstyles) {
+    if (ts->style_bounds) {
+      int i;
+      for (i = 0; i < ts->label->numstyles; i++) {
+        if (ts->style_bounds[i]) {
+          if (ts->style_bounds[i]->poly) {
+            free(ts->style_bounds[i]->poly->point);
+            free(ts->style_bounds[i]->poly);
+          }
+          free(ts->style_bounds[i]);
+        }
+      }
+      free(ts->style_bounds);
+    }
+  }
+  free(ts->annotext);
+  if (doFreeLabel && freeLabel(ts->label) == MS_SUCCESS) {
+    free(ts->label);
+  }
+}
+
+void msCopyTextPath(textPathObj *dst, textPathObj *src) {
+  int i;
+  *dst = *src;
+  if (src->bounds.poly) {
+    dst->bounds.poly = msSmallMalloc(sizeof(lineObj));
+    dst->bounds.poly->numpoints = src->bounds.poly->numpoints;
+    dst->bounds.poly->point =
+        msSmallMalloc(src->bounds.poly->numpoints * sizeof(pointObj));
+    for (i = 0; i < src->bounds.poly->numpoints; i++) {
+      dst->bounds.poly->point[i] = src->bounds.poly->point[i];
+    }
+  } else {
+    dst->bounds.poly = NULL;
+  }
+  if (dst->numglyphs > 0) {
+    dst->glyphs = msSmallMalloc(dst->numglyphs * sizeof(glyphObj));
+    for (i = 0; i < dst->numglyphs; i++)
+      dst->glyphs[i] = src->glyphs[i];
+  }
+}
+
+void msCopyTextSymbol(textSymbolObj *dst, textSymbolObj *src) {
+  *dst = *src;
+  MS_REFCNT_INCR(src->label);
+  dst->annotext = msStrdup(src->annotext);
+  if (src->textpath) {
+    dst->textpath = msSmallMalloc(sizeof(textPathObj));
+    msCopyTextPath(dst->textpath, src->textpath);
+  }
+  if (src->style_bounds) {
+    int i;
+    dst->style_bounds =
+        msSmallCalloc(src->label->numstyles, sizeof(label_bounds *));
+    for (i = 0; i < src->label->numstyles; i++) {
+      if (src->style_bounds[i]) {
+        dst->style_bounds[i] = msSmallMalloc(sizeof(label_bounds));
+        copyLabelBounds(dst->style_bounds[i], src->style_bounds[i]);
+      }
+    }
+  }
+}
+
+static int labelNeedsDeepCopy(labelObj *label) {
+  int i;
+  if (label->numbindings > 0)
+    return MS_TRUE;
+  for (i = 0; i < label->numstyles; i++) {
+    if (label->styles[i]->numbindings > 0) {
+      return MS_TRUE;
+    }
+  }
+  return MS_FALSE;
+}
+
+void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l,
+                                           char *string, double scalefactor,
+                                           double resolutionfactor,
+                                           label_cache_mode cache) {
+  if (cache == duplicate_always) {
+    ts->label = msSmallMalloc(sizeof(labelObj));
+    initLabel(ts->label);
+    msCopyLabel(ts->label, l);
+  } else if (cache == duplicate_never) {
+    ts->label = l;
+    MS_REFCNT_INCR(l);
+  } else if (cache == duplicate_if_needed && labelNeedsDeepCopy(l)) {
+    ts->label = msSmallMalloc(sizeof(labelObj));
+    initLabel(ts->label);
+    msCopyLabel(ts->label, l);
+  } else {
+    ts->label = l;
+    MS_REFCNT_INCR(l);
+  }
+  ts->resolutionfactor = resolutionfactor;
+  ts->scalefactor = scalefactor;
+  ts->annotext = string; /* we take the ownership of the annotation text */
+  ts->rotation = l->angle * MS_DEG_TO_RAD;
+}
+
+int msAddLabelGroup(mapObj *map, imageObj *image, layerObj *layer,
+                    int classindex, shapeObj *shape, pointObj *point,
+                    double featuresize) {
+  int l, s, priority;
+  labelCacheSlotObj *cacheslot;
+
+  labelCacheMemberObj *cachePtr = NULL;
+  layerObj *layerPtr = NULL;
+  classObj *classPtr = NULL;
+  int numtextsymbols = 0;
+  textSymbolObj **textsymbols, *ts;
+  int layerindex = layer->index;
+
+  // We cannot use GET_LAYER here because in drawQuery the drawing may happen
+  // on a temp layer only.
+  layerPtr = layer;
+  classPtr = layer->class[classindex];
+
+  if (classPtr->numlabels == 0)
+    return MS_SUCCESS; /* not an error just nothing to do */
+
+  /* check that the label intersects the layer mask */
+  if (layerPtr->mask) {
+    int maskLayerIdx = msGetLayerIndex(map, layerPtr->mask);
+    layerObj *maskLayer = GET_LAYER(map, maskLayerIdx);
+    unsigned char *alphapixptr;
+    if (maskLayer->maskimage &&
+        MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
+      rasterBufferObj rb;
+      int x, y;
+      memset(&rb, 0, sizeof(rasterBufferObj));
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      MS_IMAGE_RENDERER(maskLayer->maskimage)
+                          ->getRasterBufferHandle(maskLayer->maskimage, &rb))) {
+        return MS_FAILURE;
+      }
+      x = MS_NINT(point->x);
+      y = MS_NINT(point->y);
+      /* Using label repeatdistance, we might have a point with x/y below 0. See
+       * #4764 */
+      if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
+        assert(rb.type == MS_BUFFER_BYTE_RGBA);
+        alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y +
+                      rb.data.rgba.pixel_step * x;
+        if (!*alphapixptr) {
+          /* label point does not intersect mask */
+          return MS_SUCCESS;
+        }
+      } else {
+        return MS_SUCCESS; /* label point does not intersect image extent, we
+                             cannot know if it intersects mask, so we discard it
+                             (#5237)*/
+      }
+    } else {
+      msSetError(MS_MISCERR,
+                 "Layer (%s) references references a mask layer, but the "
+                 "selected renderer does not support them",
+                 "msAddLabelGroup()", layerPtr->name);
+      return (MS_FAILURE);
+    }
+  }
+
+  textsymbols = msSmallMalloc(classPtr->numlabels * sizeof(textSymbolObj *));
+
+  for (l = 0; l < classPtr->numlabels; l++) {
+    labelObj *lbl = classPtr->labels[l];
+    char *annotext;
+    if (msGetLabelStatus(map, layerPtr, shape, lbl) == MS_OFF) {
+      continue;
+    }
+    annotext = msShapeGetLabelAnnotation(layerPtr, shape, lbl);
+    if (!annotext) {
+      for (s = 0; s < lbl->numstyles; s++) {
+        if (lbl->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
+          break; /* we have a "symbol only label, so we shouldn't skip this
+                    label */
+      }
+      if (s == lbl->numstyles) {
+        continue; /* no anno text, and no label symbols */
+      }
+    }
+    ts = msSmallMalloc(sizeof(textSymbolObj));
+    initTextSymbol(ts);
+    msPopulateTextSymbolForLabelAndString(
+        ts, lbl, annotext, layerPtr->scalefactor, image->resolutionfactor, 1);
+
+    if (annotext && *annotext && lbl->autominfeaturesize && featuresize > 0) {
+      if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
+        freeTextSymbol(ts);
+        free(ts);
+        return MS_FAILURE;
+      }
+      if (featuresize <
+          (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
+        /* feature is too big to be drawn, skip it */
+        freeTextSymbol(ts);
+        free(ts);
+        continue;
+      }
+    }
+    textsymbols[numtextsymbols] = ts;
+    numtextsymbols++;
+  }
+
+  if (numtextsymbols == 0) {
+    free(textsymbols);
+    return MS_SUCCESS;
+  }
+
+  /* Validate label priority value and get ref on label cache for it */
+  priority =
+      classPtr->labels[0]->priority; /* take priority from the first label */
+  if (priority < 1)
+    priority = 1;
+  else if (priority > MS_MAX_LABEL_PRIORITY)
+    priority = MS_MAX_LABEL_PRIORITY;
+
+  cacheslot = &(map->labelcache.slots[priority - 1]);
+
+  if (cacheslot->numlabels ==
+      cacheslot->cachesize) { /* just add it to the end */
+    cacheslot->labels = (labelCacheMemberObj *)realloc(
+        cacheslot->labels, sizeof(labelCacheMemberObj) *
+                               (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+    MS_CHECK_ALLOC(cacheslot->labels,
+                   sizeof(labelCacheMemberObj) *
+                       (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                   MS_FAILURE);
+    cacheslot->cachesize += MS_LABELCACHEINCREMENT;
+  }
+
+  cachePtr = &(cacheslot->labels[cacheslot->numlabels]);
+
+  cachePtr->layerindex =
+      layerindex; /* so we can get back to this *raw* data if necessary */
+
+  cachePtr->classindex = classindex;
+
+  cachePtr->point = *point; /* the actual label point */
+
+  cachePtr->leaderline = NULL;
+  cachePtr->leaderbbox = NULL;
+
+  cachePtr->markerid = -1;
+
+  cachePtr->status = MS_FALSE;
+
+  if (layerPtr->type == MS_LAYER_POINT && classPtr->numstyles > 0) {
+    /* cache the marker placement, it's already on the map */
+    /* TO DO: at the moment only checks the bottom style, perhaps should check
+     * all of them */
+    /* #2347: after RFC-24 classPtr->styles could be NULL so we check it */
+    double w, h;
+    if (msGetMarkerSize(map, classPtr->styles[0], &w, &h,
+                        layerPtr->scalefactor) != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    if (cacheslot->nummarkers ==
+        cacheslot->markercachesize) { /* just add it to the end */
+      cacheslot->markers = (markerCacheMemberObj *)realloc(
+          cacheslot->markers,
+          sizeof(markerCacheMemberObj) *
+              (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+      MS_CHECK_ALLOC(cacheslot->markers,
+                     sizeof(markerCacheMemberObj) *
+                         (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                     MS_FAILURE);
+      cacheslot->markercachesize += MS_LABELCACHEINCREMENT;
+    }
+
+    cacheslot->markers[cacheslot->nummarkers].bounds.minx = (point->x - .5 * w);
+    cacheslot->markers[cacheslot->nummarkers].bounds.miny = (point->y - .5 * h);
+    cacheslot->markers[cacheslot->nummarkers].bounds.maxx =
+        cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w - 1);
+    cacheslot->markers[cacheslot->nummarkers].bounds.maxy =
+        cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h - 1);
+    cacheslot->markers[cacheslot->nummarkers].id = cacheslot->numlabels;
+
+    cachePtr->markerid = cacheslot->nummarkers;
+    cacheslot->nummarkers++;
+  }
+  cachePtr->textsymbols = textsymbols;
+  cachePtr->numtextsymbols = numtextsymbols;
+
+  cacheslot->numlabels++;
+
+  return (MS_SUCCESS);
+}
+
+int msAddLabel(mapObj *map, imageObj *image, labelObj *label, int layerindex,
+               int classindex, shapeObj *shape, pointObj *point,
+               double featuresize, textSymbolObj *ts) {
+  int i;
+  labelCacheSlotObj *cacheslot;
+  labelCacheMemberObj *cachePtr = NULL;
+  const char *annotext = NULL;
+  char *annotextToFree = NULL;
+  layerObj *layerPtr;
+  classObj *classPtr;
+
+  layerPtr = GET_LAYER(map, layerindex);
+  assert(layerPtr);
+
+  assert(classindex < layerPtr->numclasses);
+  classPtr = layerPtr->class[classindex];
+
+  assert(label);
+
+  if (ts)
+    annotext = ts->annotext;
+  else if (shape) {
+    annotextToFree = msShapeGetLabelAnnotation(layerPtr, shape, label);
+    annotext = annotextToFree;
+  }
+
+  if (!annotext) {
+    /* check if we have a labelpnt style */
+    for (i = 0; i < label->numstyles; i++) {
+      if (label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
+        break;
+    }
+    if (i == label->numstyles) {
+      /* label has no text or marker symbols */
+      if (ts) {
+        freeTextSymbol(ts);
+        free(ts);
+      }
+      return MS_SUCCESS;
+    }
+  }
+
+  if (classPtr->leader) {
+    if (ts && ts->textpath && ts->textpath->absolute) {
+      msSetError(MS_MISCERR, "LEADERs are not supported on ANGLE FOLLOW labels",
+                 "msAddLabel()");
+      return MS_FAILURE;
+    }
+  }
+  /* check that the label intersects the layer mask */
+
+  if (layerPtr->mask) {
+    int maskLayerIdx = msGetLayerIndex(map, layerPtr->mask);
+    layerObj *maskLayer = GET_LAYER(map, maskLayerIdx);
+    unsigned char *alphapixptr;
+    if (maskLayer->maskimage &&
+        MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
+      rasterBufferObj rb;
+      memset(&rb, 0, sizeof(rasterBufferObj));
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      MS_IMAGE_RENDERER(maskLayer->maskimage)
+                          ->getRasterBufferHandle(maskLayer->maskimage, &rb))) {
+        msFree(annotextToFree);
+        return MS_FAILURE;
+      }
+      assert(rb.type == MS_BUFFER_BYTE_RGBA);
+      if (point) {
+        int x = MS_NINT(point->x);
+        int y = MS_NINT(point->y);
+        /* Using label repeatdistance, we might have a point with x/y below 0.
+         * See #4764 */
+        if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
+          alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y +
+                        rb.data.rgba.pixel_step * x;
+          if (!*alphapixptr) {
+            /* label point does not intersect mask */
+            if (ts) {
+              freeTextSymbol(ts);
+              free(ts);
+            }
+            msFree(annotextToFree);
+            return MS_SUCCESS;
+          }
+        } else {
+          msFree(annotextToFree);
+          return MS_SUCCESS; /* label point does not intersect image extent, we
+                                cannot know if it intersects mask, so we discard
+                                it (#5237)*/
+        }
+      } else if (ts && ts->textpath) {
+        int i = 0;
+        for (i = 0; i < ts->textpath->numglyphs; i++) {
+          int x = MS_NINT(ts->textpath->glyphs[i].pnt.x);
+          int y = MS_NINT(ts->textpath->glyphs[i].pnt.y);
+          if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
+            alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y +
+                          rb.data.rgba.pixel_step * x;
+            if (!*alphapixptr) {
+              freeTextSymbol(ts);
+              free(ts);
+              msFree(annotextToFree);
+              return MS_SUCCESS;
+            }
+          } else {
+            freeTextSymbol(ts);
+            free(ts);
+            msFree(annotextToFree);
+            return MS_SUCCESS; /* label point does not intersect image extent,
+                                  we cannot know if it intersects mask, so we
+                                  discard it (#5237)*/
+          }
+        }
+      }
+    } else {
+      msSetError(MS_MISCERR,
+                 "Layer (%s) references references a mask layer, but the "
+                 "selected renderer does not support them",
+                 "msAddLabel()", layerPtr->name);
+      msFree(annotextToFree);
+      return (MS_FAILURE);
+    }
+  }
+
+  if (!ts) {
+    ts = msSmallMalloc(sizeof(textSymbolObj));
+    initTextSymbol(ts);
+    msPopulateTextSymbolForLabelAndString(ts, label, annotextToFree,
+                                          layerPtr->scalefactor,
+                                          image->resolutionfactor, 1);
+    // annotextToFree = NULL;
+  }
+
+  if (annotext && label->autominfeaturesize && featuresize > 0) {
+    if (!ts->textpath) {
+      if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts)))
+        return MS_FAILURE;
+    }
+    if (!ts->textpath) {
+      return MS_FAILURE;
+    }
+    if (featuresize >
+        (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
+      /* feature is too big to be drawn, skip it */
+      freeTextSymbol(ts);
+      free(ts);
+      return MS_SUCCESS;
+    }
+  }
+
+  /* Validate label priority value and get ref on label cache for it */
+  if (label->priority < 1)
+    label->priority = 1;
+  else if (label->priority > MS_MAX_LABEL_PRIORITY)
+    label->priority = MS_MAX_LABEL_PRIORITY;
+
+  cacheslot = &(map->labelcache.slots[label->priority - 1]);
+
+  if (cacheslot->numlabels ==
+      cacheslot->cachesize) { /* just add it to the end */
+    cacheslot->labels = (labelCacheMemberObj *)realloc(
+        cacheslot->labels, sizeof(labelCacheMemberObj) *
+                               (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+    MS_CHECK_ALLOC(cacheslot->labels,
+                   sizeof(labelCacheMemberObj) *
+                       (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                   MS_FAILURE);
+    cacheslot->cachesize += MS_LABELCACHEINCREMENT;
+  }
+
+  cachePtr = &(cacheslot->labels[cacheslot->numlabels]);
+
+  cachePtr->layerindex =
+      layerindex; /* so we can get back to this *raw* data if necessary */
+  cachePtr->classindex = classindex;
+  cachePtr->leaderline = NULL;
+  cachePtr->leaderbbox = NULL;
+
+  /* Store the label point or the label path (Bug #1620) */
+  if (point) {
+    cachePtr->point = *point; /* the actual label point */
+  } else {
+    assert(ts && ts->textpath && ts->textpath->absolute &&
+           ts->textpath->numglyphs > 0);
+    /* Use the middle point of the labelpath for mindistance calculations */
+    cachePtr->point = ts->textpath->glyphs[ts->textpath->numglyphs / 2].pnt;
+  }
+
+  /* copy the label */
+  cachePtr->numtextsymbols = 1;
+  cachePtr->textsymbols =
+      (textSymbolObj **)msSmallMalloc(sizeof(textSymbolObj *));
+  cachePtr->textsymbols[0] = ts;
+  cachePtr->markerid = -1;
+
+  cachePtr->status = MS_FALSE;
+
+  if (layerPtr->type == MS_LAYER_POINT &&
+      classPtr->numstyles >
+          0) { /* cache the marker placement, it's already on the map */
+    double w, h;
+
+    if (cacheslot->nummarkers ==
+        cacheslot->markercachesize) { /* just add it to the end */
+      cacheslot->markers = (markerCacheMemberObj *)realloc(
+          cacheslot->markers,
+          sizeof(markerCacheMemberObj) *
+              (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+      MS_CHECK_ALLOC(cacheslot->markers,
+                     sizeof(markerCacheMemberObj) *
+                         (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                     MS_FAILURE);
+      cacheslot->markercachesize += MS_LABELCACHEINCREMENT;
+    }
+
+    i = cacheslot->nummarkers;
+
+    /* TO DO: at the moment only checks the bottom style, perhaps should check
+     * all of them */
+    /* #2347: after RFC-24 classPtr->styles could be NULL so we check it */
+    if (classPtr->styles != NULL) {
+      if (msGetMarkerSize(map, classPtr->styles[0], &w, &h,
+                          layerPtr->scalefactor) != MS_SUCCESS)
+        return (MS_FAILURE);
+      assert(point);
+      cacheslot->markers[cacheslot->nummarkers].bounds.minx =
+          (point->x - .5 * w);
+      cacheslot->markers[cacheslot->nummarkers].bounds.miny =
+          (point->y - .5 * h);
+      cacheslot->markers[cacheslot->nummarkers].bounds.maxx =
+          cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w - 1);
+      cacheslot->markers[cacheslot->nummarkers].bounds.maxy =
+          cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h - 1);
+      cacheslot->markers[i].id = cacheslot->numlabels;
+
+      cachePtr->markerid = i;
+
+      cacheslot->nummarkers++;
+    }
+  }
+
+  cacheslot->numlabels++;
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Is a label completely in the image, reserving a gutter (in pixels) inside
+** image for no labels (effectively making image larger. The gutter can be
+** negative in cases where a label has a buffer around it.
+*/
+static int labelInImage(int width, int height, lineObj *lpoly, rectObj *bounds,
+                        int gutter) {
+  int j;
+
+  /* do a bbox test first */
+  if (bounds->minx >= gutter && bounds->miny >= gutter &&
+      bounds->maxx < width - gutter && bounds->maxy < height - gutter) {
+    return MS_TRUE;
+  }
+
+  if (lpoly) {
+    for (j = 1; j < lpoly->numpoints; j++) {
+      if (lpoly->point[j].x < gutter)
+        return (MS_FALSE);
+      if (lpoly->point[j].x >= width - gutter)
+        return (MS_FALSE);
+      if (lpoly->point[j].y < gutter)
+        return (MS_FALSE);
+      if (lpoly->point[j].y >= height - gutter)
+        return (MS_FALSE);
+    }
+  } else {
+    /* if no poly, then return false as the boundong box intersected */
+    return MS_FALSE;
+  }
+
+  return (MS_TRUE);
+}
+
+void insertRenderedLabelMember(mapObj *map, labelCacheMemberObj *cachePtr) {
+  if (map->labelcache.num_rendered_members ==
+      map->labelcache.num_allocated_rendered_members) {
+    if (map->labelcache.num_rendered_members == 0) {
+      map->labelcache.num_allocated_rendered_members = 50;
+    } else {
+      map->labelcache.num_allocated_rendered_members *= 2;
+    }
+    map->labelcache.rendered_text_symbols =
+        msSmallRealloc(map->labelcache.rendered_text_symbols,
+                       map->labelcache.num_allocated_rendered_members *
+                           sizeof(labelCacheMemberObj *));
+  }
+  map->labelcache
+      .rendered_text_symbols[map->labelcache.num_rendered_members++] = cachePtr;
+}
+
+static inline int testSegmentLabelBBoxIntersection(const rectObj *leaderbbox,
+                                                   const pointObj *lp1,
+                                                   const pointObj *lp2,
+                                                   const label_bounds *test) {
+  if (msRectOverlap(leaderbbox, &test->bbox)) {
+    if (test->poly) {
+      int pp;
+      for (pp = 1; pp < test->poly->numpoints; pp++) {
+        if (msIntersectSegments(&(test->poly->point[pp - 1]),
+                                &(test->poly->point[pp]), lp1,
+                                lp2) == MS_TRUE) {
+          return (MS_FALSE);
+        }
+      }
+    } else {
+      pointObj tp1 = {0}, tp2 = {0};
+      tp1.x = test->bbox.minx;
+      tp1.y = test->bbox.miny;
+      tp2.x = test->bbox.minx;
+      tp2.y = test->bbox.maxy;
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
+        return MS_FALSE;
+      tp2.x = test->bbox.maxx;
+      tp2.y = test->bbox.miny;
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
+        return MS_FALSE;
+      tp1.x = test->bbox.maxx;
+      tp1.y = test->bbox.maxy;
+      tp2.x = test->bbox.minx;
+      tp2.y = test->bbox.maxy;
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
+        return MS_FALSE;
+      tp2.x = test->bbox.maxx;
+      tp2.y = test->bbox.miny;
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
+        return MS_FALSE;
+    }
+  }
+  return MS_TRUE;
+}
+
+int msTestLabelCacheLeaderCollision(mapObj *map, pointObj *lp1, pointObj *lp2) {
+  int p;
+  rectObj leaderbbox;
+  leaderbbox.minx = MS_MIN(lp1->x, lp2->x);
+  leaderbbox.maxx = MS_MAX(lp1->x, lp2->x);
+  leaderbbox.miny = MS_MIN(lp1->y, lp2->y);
+  leaderbbox.maxy = MS_MAX(lp1->y, lp2->y);
+  for (p = 0; p < map->labelcache.num_rendered_members; p++) {
+    labelCacheMemberObj *curCachePtr = map->labelcache.rendered_text_symbols[p];
+    if (msRectOverlap(&leaderbbox, &(curCachePtr->bbox))) {
+      /* leaderbbox interesects with the curCachePtr's global bbox */
+      int t;
+      for (t = 0; t < curCachePtr->numtextsymbols; t++) {
+        int s;
+        textSymbolObj *ts = curCachePtr->textsymbols[t];
+        /* check for intersect with textpath */
+        if (ts->textpath &&
+            testSegmentLabelBBoxIntersection(
+                &leaderbbox, lp1, lp2, &ts->textpath->bounds) == MS_FALSE) {
+          return MS_FALSE;
+        }
+        /* check for intersect with label's labelpnt styles */
+        if (ts->style_bounds) {
+          for (s = 0; s < ts->label->numstyles; s++) {
+            if (ts->label->styles[s]->_geomtransform.type ==
+                MS_GEOMTRANSFORM_LABELPOINT) {
+              if (testSegmentLabelBBoxIntersection(
+                      &leaderbbox, lp1, lp2, ts->style_bounds[s]) == MS_FALSE) {
+                return MS_FALSE;
+              }
+            }
+          }
+        }
+      }
+      if (curCachePtr->leaderbbox) {
+        if (msIntersectSegments(lp1, lp2, &(curCachePtr->leaderline->point[0]),
+                                &(curCachePtr->leaderline->point[1])) ==
+            MS_TRUE) {
+          return MS_FALSE;
+        }
+      }
+    }
+  }
+  return MS_TRUE;
+}
+
+/* msTestLabelCacheCollisions()
+**
+** Compares label bounds (in *bounds) against labels already drawn and markers
+from cache and
+** returns MS_FALSE if it collides with another label, or collides with a
+marker.
+**
+** This function is used by the various msDrawLabelCacheXX() implementations.
+
+int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr,
+label_bounds *bounds, int current_priority, int current_label);
+*/
+int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr,
+                               label_bounds *lb, int current_priority,
+                               int current_label) {
+  labelCacheObj *labelcache = &(map->labelcache);
+  int i, p, ll;
+
+  /*
+   * Check against image bounds first
+   */
+  if (!cachePtr->textsymbols[0]->label->partials) {
+    if (labelInImage(map->width, map->height, lb->poly, &lb->bbox,
+                     labelcache->gutter) == MS_FALSE) {
+      return MS_FALSE;
+    }
+  }
+
+  /* Compare against all rendered markers from this priority level and higher.
+  ** Labels can overlap their own marker and markers from lower priority levels
+  */
+  for (p = current_priority; p < MS_MAX_LABEL_PRIORITY; p++) {
+    labelCacheSlotObj *markerslot;
+    markerslot = &(labelcache->slots[p]);
+
+    for (ll = 0; ll < markerslot->nummarkers; ll++) {
+      if (!(p == current_priority &&
+            current_label ==
+                markerslot->markers[ll]
+                    .id)) { /* labels can overlap their own marker */
+        if (intersectLabelPolygons(NULL, &markerslot->markers[ll].bounds,
+                                   lb->poly, &lb->bbox) == MS_TRUE) {
+          return MS_FALSE;
+        }
+      }
+    }
+  }
+
+  for (p = 0; p < labelcache->num_rendered_members; p++) {
+    labelCacheMemberObj *curCachePtr = labelcache->rendered_text_symbols[p];
+    if (msRectOverlap(&curCachePtr->bbox, &lb->bbox)) {
+      for (i = 0; i < curCachePtr->numtextsymbols; i++) {
+        int j;
+        textSymbolObj *ts = curCachePtr->textsymbols[i];
+        if (ts->textpath &&
+            intersectLabelPolygons(ts->textpath->bounds.poly,
+                                   &ts->textpath->bounds.bbox, lb->poly,
+                                   &lb->bbox) == MS_TRUE) {
+          return MS_FALSE;
+        }
+        if (ts->style_bounds) {
+          for (j = 0; j < ts->label->numstyles; j++) {
+            if (ts->style_bounds[j] &&
+                ts->label->styles[j]->_geomtransform.type ==
+                    MS_GEOMTRANSFORM_LABELPOINT) {
+              if (intersectLabelPolygons(ts->style_bounds[j]->poly,
+                                         &ts->style_bounds[j]->bbox, lb->poly,
+                                         &lb->bbox)) {
+                return MS_FALSE;
+              }
+            }
+          }
+        }
+      }
+    }
+    if (curCachePtr->leaderline) {
+      if (testSegmentLabelBBoxIntersection(
+              curCachePtr->leaderbbox, &curCachePtr->leaderline->point[0],
+              &curCachePtr->leaderline->point[1], lb) == MS_FALSE) {
+        return MS_FALSE;
+      }
+    }
+  }
+  return MS_TRUE;
+}
+
+/* utility function to get the rect of a string outside of a rendering loop,
+ i.e. without going through textpath layouts */
+int msGetStringSize(mapObj *map, labelObj *label, int size, char *string,
+                    rectObj *r) {
+  textSymbolObj ts;
+  double lsize = label->size;
+  initTextSymbol(&ts);
+  label->size = size;
+  msPopulateTextSymbolForLabelAndString(&ts, label, msStrdup(string), 1, 1, 0);
+  if (MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map, &ts, r)))
+    return MS_FAILURE;
+  label->size = lsize;
+  freeTextSymbol(&ts);
+  return MS_SUCCESS;
+}
+
+int msInitFontSet(fontSetObj *fontset) {
+  fontset->filename = NULL;
+
+  /* fontset->fonts = NULL; */
+  initHashTable(&(fontset->fonts));
+
+  fontset->numfonts = 0;
+  fontset->map = NULL;
+  return (0);
+}
+
+int msFreeFontSet(fontSetObj *fontset) {
+  if (fontset->filename)
+    free(fontset->filename);
+  fontset->filename = NULL;
+  msFreeHashItems(&(fontset->fonts));
+  /* fontset->fonts = NULL; */
+  fontset->numfonts = 0;
+
+  return (0);
+}
+
+int msLoadFontSet(fontSetObj *fontset, mapObj *map) {
+  VSILFILE *stream;
+  const char *line;
+  char *path;
+  char szPath[MS_MAXPATHLEN];
+  int i;
+  int bFullPath = 0;
+  const char *realpath;
+
+  if (fontset->numfonts != 0) /* already initialized */
+    return (0);
+
+  if (!fontset->filename)
+    return (0);
+
+  fontset->map = (mapObj *)map;
+
+  path = msGetPath(fontset->filename);
+
+  /* fontset->fonts = msCreateHashTable(); // create font hash */
+  /* if(!fontset->fonts) { */
+  /* msSetError(MS_HASHERR, "Error initializing font hash.", "msLoadFontSet()");
+   */
+  /* return(-1); */
+  /* } */
+
+  realpath = msBuildPath(szPath, fontset->map->mappath, fontset->filename);
+  if (!realpath) {
+    free(path);
+    return -1;
+  }
+  stream = VSIFOpenL(realpath, "rb");
+  if (!stream) {
+    msSetError(MS_IOERR, "Error opening fontset %s.", "msLoadFontset()",
+               fontset->filename);
+    free(path);
+    return (-1);
+  }
+
+  i = 0;
+  while ((line = CPLReadLineL(stream)) !=
+         NULL) { /* while there's something to load */
+
+    if (line[0] == '#' || line[0] == '\n' || line[0] == '\r' || line[0] == ' ')
+      continue; /* skip comments and blank lines */
+
+    char alias[64];
+    snprintf(alias, sizeof(alias), "%s", line);
+    char *ptr = strpbrk(alias, " \t");
+    if (!ptr)
+      continue;
+    *ptr = '\0';
+
+    const char *file1StartPtr = line + (ptr - alias);
+    file1StartPtr++;
+    /* Skip leading spaces */
+    while (isspace((int)*file1StartPtr))
+      file1StartPtr++;
+
+    if (!(*file1StartPtr) || !(*alias))
+      continue;
+
+    char file1[MS_PATH_LENGTH];
+    snprintf(file1, sizeof(file1), "%s", file1StartPtr);
+    /* Remove trailing spaces */
+    ptr = file1 + strlen(file1) - 1;
+    while (ptr >= file1 && isspace((int)*ptr)) {
+      *ptr = '\0';
+      --ptr;
+    }
+
+    bFullPath = 0;
+#if defined(_WIN32) && !defined(__CYGWIN__)
+    if (file1[0] == '\\' || (strlen(file1) > 1 && (file1[1] == ':')))
+      bFullPath = 1;
+#else
+    if (file1[0] == '/')
+      bFullPath = 1;
+#endif
+
+    if (bFullPath) { /* already full path */
+      msInsertHashTable(&(fontset->fonts), alias, file1);
+    } else {
+      char file2[MS_PATH_LENGTH];
+      snprintf(file2, sizeof(file2), "%s%s", path, file1);
+      /* msInsertHashTable(fontset->fonts, alias, file2); */
+
+      /*
+      ** msBuildPath is use here, but if we have to save the fontset file
+      ** the msBuildPath must be done everywhere the fonts are used and
+      ** removed here.
+      */
+      msInsertHashTable(&(fontset->fonts), alias,
+                        msBuildPath(szPath, fontset->map->mappath, file2));
+    }
+
+    i++;
+  }
+
+  fontset->numfonts = i;
+  VSIFCloseL(stream); /* close the file */
+  free(path);
+
+  return (0);
+}
+
+int msGetTextSymbolSize(mapObj *map, textSymbolObj *ts, rectObj *r) {
+  if (!ts->textpath) {
+    if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts)))
+      return MS_FAILURE;
+  }
+  if (!ts->textpath)
+    return MS_FAILURE;
+  *r = ts->textpath->bounds.bbox;
+  return MS_SUCCESS;
+}
+/*
+** Note: All these routines assume a reference point at the LL corner of the
+*text. GD's
+** bitmapped fonts use UL and this is compensated for. Note the rect is relative
+*to the
+** LL corner of the text to be rendered, this is first line for TrueType fonts.
+*/
+
+#define MARKER_SLOP 2
+
+pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy,
+                     double rotation, int buffer, label_bounds *bounds) {
+  pointObj q = {0}; // initialize
+  double x1 = 0, y1 = 0, x2 = 0, y2 = 0;
+  double sin_a, cos_a;
+  double w, h, x, y;
+
+  w = tp->bounds.bbox.maxx - tp->bounds.bbox.minx;
+  h = tp->bounds.bbox.maxy - tp->bounds.bbox.miny;
+
+  switch (position) {
+  case MS_UL:
+    x1 = -w - ox;
+    y1 = -oy;
+    break;
+  case MS_UC:
+    x1 = -(w / 2.0);
+    y1 = -oy - MARKER_SLOP;
+    break;
+  case MS_UR:
+    x1 = ox;
+    y1 = -oy;
+    break;
+  case MS_CL:
+    x1 = -w - ox - MARKER_SLOP;
+    if (oy > 0 && tp->numlines == 1)
+      y1 = oy;
+    else
+      y1 = (h / 2.0);
+    break;
+  case MS_CC:
+    x1 = -(w / 2.0) + ox;
+    y1 = (h / 2.0) + oy;
+    break;
+  case MS_CR:
+    x1 = ox + MARKER_SLOP;
+    if (oy > 0 && tp->numlines == 1)
+      y1 = oy;
+    else
+      y1 = (h / 2.0);
+    break;
+  case MS_LL:
+    x1 = -w - ox;
+    y1 = h + oy;
+    break;
+  case MS_LC:
+    x1 = -(w / 2.0);
+    y1 = h + oy + MARKER_SLOP;
+    break;
+  case MS_LR:
+    x1 = ox;
+    y1 = h + oy;
+    break;
+  }
+
+  if (rotation) {
+    sin_a = sin(rotation);
+    cos_a = cos(rotation);
+
+    x = x1 - tp->bounds.bbox.minx;
+    y = tp->bounds.bbox.maxy - y1;
+    q.x = p->x + (x * cos_a - (y)*sin_a);
+    q.y = p->y - (x * sin_a + (y)*cos_a);
+
+    if (bounds) {
+      x2 = x1 - buffer; /* ll */
+      y2 = y1 + buffer;
+      bounds->poly->point[0].x = p->x + (x2 * cos_a - (-y2) * sin_a);
+      bounds->poly->point[0].y = p->y - (x2 * sin_a + (-y2) * cos_a);
+
+      x2 = x1 - buffer; /* ul */
+      y2 = y1 - h - buffer;
+      bounds->poly->point[1].x = p->x + (x2 * cos_a - (-y2) * sin_a);
+      bounds->poly->point[1].y = p->y - (x2 * sin_a + (-y2) * cos_a);
+
+      x2 = x1 + w + buffer; /* ur */
+      y2 = y1 - h - buffer;
+      bounds->poly->point[2].x = p->x + (x2 * cos_a - (-y2) * sin_a);
+      bounds->poly->point[2].y = p->y - (x2 * sin_a + (-y2) * cos_a);
+
+      x2 = x1 + w + buffer; /* lr */
+      y2 = y1 + buffer;
+      bounds->poly->point[3].x = p->x + (x2 * cos_a - (-y2) * sin_a);
+      bounds->poly->point[3].y = p->y - (x2 * sin_a + (-y2) * cos_a);
+
+      bounds->poly->point[4].x = bounds->poly->point[0].x;
+      bounds->poly->point[4].y = bounds->poly->point[0].y;
+      fastComputeBounds(bounds->poly, &bounds->bbox);
+    }
+  } else {
+    q.x = p->x + x1 - tp->bounds.bbox.minx;
+    q.y = p->y + y1 - tp->bounds.bbox.maxy;
+
+    if (bounds) {
+      /* no rotation, we only need to return a bbox */
+      bounds->poly = NULL;
+
+      bounds->bbox.minx = q.x - buffer;
+      bounds->bbox.maxy = q.y + buffer + tp->bounds.bbox.maxy;
+      bounds->bbox.maxx = q.x + w + buffer;
+      bounds->bbox.miny = bounds->bbox.maxy - h - buffer * 2;
+    }
+  }
+  return (q);
+}
+
+int intersectTextSymbol(textSymbolObj *ts, label_bounds *lb) {
+  if (ts->textpath && ts->textpath->absolute) {
+    if (intersectLabelPolygons(lb->poly, &lb->bbox, ts->textpath->bounds.poly,
+                               &ts->textpath->bounds.bbox))
+      return MS_TRUE;
+  }
+  if (ts->style_bounds) {
+    int s;
+    for (s = 0; s < ts->label->numstyles; s++) {
+      if (ts->style_bounds[s] &&
+          ts->label->styles[s]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOINT &&
+          intersectLabelPolygons(lb->poly, &lb->bbox, ts->style_bounds[s]->poly,
+                                 &ts->style_bounds[s]->bbox))
+        return MS_TRUE;
+    }
+  }
+  return MS_FALSE;
+}
+
+/*
+** Variation on msIntersectPolygons. Label polygons aren't like shapefile
+*polygons. They
+** have no holes, and often do have overlapping parts (i.e. road symbols).
+*/
+int intersectLabelPolygons(lineObj *l1, rectObj *r1, lineObj *l2, rectObj *r2) {
+  int v1, v2;
+  pointObj *point;
+  lineObj *p1, *p2, sp1, sp2;
+  pointObj pnts1[5], pnts2[5];
+
+  /* STEP 0: check bounding boxes */
+  if (!msRectOverlap(r1, r2)) { /* from alans@wunderground.com */
+    return (MS_FALSE);
+  }
+  if (!l1 && !l2)
+    return MS_TRUE;
+
+  if (!l1) {
+    p1 = &sp1;
+    p1->numpoints = 5;
+    p1->point = pnts1;
+    pnts1[0].x = pnts1[1].x = pnts1[4].x = r1->minx;
+    pnts1[2].x = pnts1[3].x = r1->maxx;
+    pnts1[0].y = pnts1[3].y = pnts1[4].y = r1->miny;
+    pnts1[1].y = pnts1[2].y = r1->maxy;
+  } else {
+    p1 = l1;
+  }
+  if (!l2) {
+    p2 = &sp2;
+    p2->numpoints = 5;
+    p2->point = pnts2;
+    pnts2[0].x = pnts2[1].x = pnts2[4].x = r2->minx;
+    pnts2[2].x = pnts2[3].x = r2->maxx;
+    pnts2[0].y = pnts2[3].y = pnts2[4].y = r2->miny;
+    pnts2[1].y = pnts2[2].y = r2->maxy;
+  } else {
+    p2 = l2;
+  }
+  (void)pnts1[0].x;
+  (void)pnts1[0].y;
+  (void)pnts1[1].x;
+  (void)pnts1[1].y;
+  (void)pnts1[2].x;
+  (void)pnts1[2].y;
+  (void)pnts1[3].x;
+  (void)pnts1[3].y;
+  (void)pnts1[4].x;
+  (void)pnts1[4].y;
+  (void)pnts2[0].x;
+  (void)pnts2[0].y;
+  (void)pnts2[1].x;
+  (void)pnts2[1].y;
+  (void)pnts2[2].x;
+  (void)pnts2[2].y;
+  (void)pnts2[3].x;
+  (void)pnts2[3].y;
+  (void)pnts2[4].x;
+  (void)pnts2[4].y;
+
+  /* STEP 1: look for intersecting line segments */
+  for (v1 = 1; v1 < p1->numpoints; v1++)
+    for (v2 = 1; v2 < p2->numpoints; v2++)
+      if (msIntersectSegments(&(p1->point[v1 - 1]), &(p1->point[v1]),
+                              &(p2->point[v2 - 1]),
+                              &(p2->point[v2])) == MS_TRUE) {
+        return (MS_TRUE);
+      }
+
+  /* STEP 2: polygon one completely contains two (only need to check one point
+   * from each part) */
+  point = &(p2->point[0]);
+  if (msPointInPolygon(point, p1) ==
+      MS_TRUE) /* ok, the point is in a polygon */
+    return (MS_TRUE);
+
+  /* STEP 3: polygon two completely contains one (only need to check one point
+   * from each part) */
+  point = &(p1->point[0]);
+  if (msPointInPolygon(point, p2) ==
+      MS_TRUE) /* ok, the point is in a polygon */
+    return (MS_TRUE);
+
+  return (MS_FALSE);
+}
+
+/* For MapScript, exactly the same the msInsertStyle */
+int msInsertLabelStyle(labelObj *label, styleObj *style, int nStyleIndex) {
+  if (!style) {
+    msSetError(MS_CHILDERR, "Can't insert a NULL Style",
+               "msInsertLabelStyle()");
+    return -1;
+  }
+
+  /* Ensure there is room for a new style */
+  if (msGrowLabelStyles(label) == NULL) {
+    return -1;
+  }
+  /* Catch attempt to insert past end of styles array */
+  else if (nStyleIndex >= label->numstyles) {
+    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d",
+               "insertLabelStyle()", label->numstyles - 1);
+    return -1;
+  } else if (nStyleIndex < 0) { /* Insert at the end by default */
+    label->styles[label->numstyles] = style;
+    MS_REFCNT_INCR(style);
+    label->numstyles++;
+    return label->numstyles - 1;
+  } else {
+    /* Move styles existing at the specified nStyleIndex or greater */
+    /* to a higher nStyleIndex */
+    for (int i = label->numstyles - 1; i >= nStyleIndex; i--) {
+      label->styles[i + 1] = label->styles[i];
+    }
+    label->styles[nStyleIndex] = style;
+    MS_REFCNT_INCR(style);
+    label->numstyles++;
+    return nStyleIndex;
+  }
+}
+
+/**
+ * Move the style up inside the array of styles.
+ */
+int msMoveLabelStyleUp(labelObj *label, int nStyleIndex) {
+  if (label && nStyleIndex < label->numstyles && nStyleIndex > 0) {
+    styleObj *psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
+    initStyle(psTmpStyle);
+
+    msCopyStyle(psTmpStyle, label->styles[nStyleIndex]);
+
+    msCopyStyle(label->styles[nStyleIndex], label->styles[nStyleIndex - 1]);
+
+    msCopyStyle(label->styles[nStyleIndex - 1], psTmpStyle);
+
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLabelStyleUp()",
+             nStyleIndex);
+  return (MS_FAILURE);
+}
+
+/**
+ * Move the style down inside the array of styles.
+ */
+int msMoveLabelStyleDown(labelObj *label, int nStyleIndex) {
+  styleObj *psTmpStyle = NULL;
+
+  if (label && nStyleIndex < label->numstyles - 1 && nStyleIndex >= 0) {
+    psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
+    initStyle(psTmpStyle);
+
+    msCopyStyle(psTmpStyle, label->styles[nStyleIndex]);
+
+    msCopyStyle(label->styles[nStyleIndex], label->styles[nStyleIndex + 1]);
+
+    msCopyStyle(label->styles[nStyleIndex + 1], psTmpStyle);
+
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLabelStyleDown()",
+             nStyleIndex);
+  return (MS_FAILURE);
+}
+
+/**
+ * Delete the style identified by the index and shift
+ * styles that follows the deleted style.
+ */
+int msDeleteLabelStyle(labelObj *label, int nStyleIndex) {
+  if (label && nStyleIndex < label->numstyles && nStyleIndex >= 0) {
+    if (freeStyle(label->styles[nStyleIndex]) == MS_SUCCESS)
+      msFree(label->styles[nStyleIndex]);
+    for (int i = nStyleIndex; i < label->numstyles - 1; i++) {
+      label->styles[i] = label->styles[i + 1];
+    }
+    label->styles[label->numstyles - 1] = NULL;
+    label->numstyles--;
+    return (MS_SUCCESS);
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msDeleteLabelStyle()",
+             nStyleIndex);
+  return (MS_FAILURE);
+}
+
+styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex) {
+  int i;
+  styleObj *style;
+  if (nStyleIndex < 0 || nStyleIndex >= label->numstyles) {
+    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d",
+               "removeLabelStyle()", nStyleIndex);
+    return NULL;
+  } else {
+    style = label->styles[nStyleIndex];
+    for (i = nStyleIndex; i < label->numstyles - 1; i++) {
+      label->styles[i] = label->styles[i + 1];
+    }
+    label->styles[label->numstyles - 1] = NULL;
+    label->numstyles--;
+    MS_REFCNT_DECR(style);
+    return style;
+  }
+}
diff -pruN 8.0.1-5/src/maplayer.c 8.2.0~beta1-1~exp1/src/maplayer.c
--- 8.0.1-5/src/maplayer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maplayer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2645 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of most layerObj functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maptime.h"
+#include "mapogcfilter.h"
+#include "mapthread.h"
+#include "mapfile.h"
+#include "mapows.h"
+#include "mapparser.h"
+#include "mapogcsld.h"
+
+#include <assert.h>
+
+#ifndef cppcheck_assert
+#define cppcheck_assert(x)                                                     \
+  do {                                                                         \
+  } while (0)
+#endif
+
+static int populateVirtualTable(layerVTableObj *vtable);
+
+/*
+** Iteminfo is a layer parameter that holds information necessary to retrieve an
+*individual item for
+** a particular source. It is an array built from a list of items. The type of
+*iteminfo will vary by
+** source. For shapefiles and OGR it is simply an array of integers where each
+*value is an index for
+** the item. For SDE it's a ESRI specific type that contains index and column
+*type information. Two
+** helper functions below initialize and free that structure member which is
+*used locally by layer
+** specific functions.
+*/
+int msLayerInitItemInfo(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerInitItemInfo(layer);
+}
+
+void msLayerFreeItemInfo(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return;
+  }
+  cppcheck_assert(layer->vtable);
+  layer->vtable->LayerFreeItemInfo(layer);
+
+  /*
+   * Layer expressions with attribute binding hold a numeric index pointing
+   * to an iteminfo (node->tokenval.bindval.index). If iteminfo changes,
+   * an expression may be no longer valid. (#5161)
+   */
+  msLayerFreeExpressions(layer);
+}
+
+int msLayerRestoreFromScaletokens(layerObj *layer) {
+  if (!layer->scaletokens || !layer->orig_st) {
+    return MS_SUCCESS;
+  }
+  if (layer->orig_st->data) {
+    msFree(layer->data);
+    layer->data = layer->orig_st->data;
+  }
+  if (layer->orig_st->tileindex) {
+    msFree(layer->tileindex);
+    layer->tileindex = layer->orig_st->tileindex;
+  }
+  if (layer->orig_st->tileitem) {
+    msFree(layer->tileitem);
+    layer->tileitem = layer->orig_st->tileitem;
+  }
+  if (layer->orig_st->filter) {
+    msLoadExpressionString(&(layer->filter), layer->orig_st->filter);
+    msFree(layer->orig_st->filter);
+  }
+  if (layer->orig_st->filteritem) {
+    msFree(layer->filteritem);
+    layer->filteritem = layer->orig_st->filteritem;
+  }
+  if (layer->orig_st->n_processing) {
+    int i;
+    for (i = 0; i < layer->orig_st->n_processing; i++) {
+      msFree(layer->processing[layer->orig_st->processing_idx[i]]);
+      layer->processing[layer->orig_st->processing_idx[i]] =
+          layer->orig_st->processing[i];
+    }
+    msFree(layer->orig_st->processing);
+    msFree(layer->orig_st->processing_idx);
+  }
+  msFree(layer->orig_st);
+  layer->orig_st = NULL;
+  return MS_SUCCESS;
+}
+
+#define check_st_alloc(l)                                                      \
+  if (!l->orig_st)                                                             \
+    l->orig_st = msSmallCalloc(1, sizeof(originalScaleTokenStrings));
+int msLayerApplyScaletokens(layerObj *layer, double scale) {
+  int i, p;
+  if (!layer->scaletokens) {
+    return MS_SUCCESS;
+  }
+  msLayerRestoreFromScaletokens(layer);
+  for (i = 0; i < layer->numscaletokens; i++) {
+    scaleTokenObj *st = &layer->scaletokens[i];
+    scaleTokenEntryObj *ste = NULL;
+    if (scale <= 0) {
+      ste = &(st->tokens[0]);
+      /* no scale defined, use first entry */
+    } else {
+      int tokenindex = 0;
+      while (tokenindex < st->n_entries) {
+        ste = &(st->tokens[tokenindex]);
+        if (scale < ste->maxscale && scale >= ste->minscale)
+          break; /* current token is the correct one */
+        tokenindex++;
+        ste = NULL;
+      }
+    }
+    assert(ste);
+    if (layer->data && strstr(layer->data, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->data (%s) for "
+                "scale=%f\n",
+                st->name, ste->value, layer->name, scale);
+      }
+      check_st_alloc(layer);
+      layer->orig_st->data = layer->data;
+      layer->data = msStrdup(layer->data);
+      layer->data = msReplaceSubstring(layer->data, st->name, ste->value);
+    }
+    if (layer->tileindex && strstr(layer->tileindex, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->tileindex (%s) "
+                "for scale=%f\n",
+                st->name, ste->value, layer->name, scale);
+      }
+      check_st_alloc(layer);
+      layer->orig_st->tileindex = layer->tileindex;
+      layer->tileindex = msStrdup(layer->tileindex);
+      layer->tileindex =
+          msReplaceSubstring(layer->tileindex, st->name, ste->value);
+    }
+    if (layer->tileitem && strstr(layer->tileitem, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->tileitem (%s) "
+                "for scale=%f\n",
+                st->name, ste->value, layer->name, scale);
+      }
+      check_st_alloc(layer);
+      layer->orig_st->tileitem = layer->tileitem;
+      layer->tileitem = msStrdup(layer->tileitem);
+      layer->tileitem =
+          msReplaceSubstring(layer->tileitem, st->name, ste->value);
+    }
+    if (layer->filteritem && strstr(layer->filteritem, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->filteritem (%s) "
+                "for scale=%f\n",
+                st->name, ste->value, layer->name, scale);
+      }
+      check_st_alloc(layer);
+      layer->orig_st->filteritem = layer->filteritem;
+      layer->filteritem = msStrdup(layer->filteritem);
+      layer->filteritem =
+          msReplaceSubstring(layer->filteritem, st->name, ste->value);
+    }
+    if (layer->filter.string && strstr(layer->filter.string, st->name)) {
+      char *tmpval;
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->filter (%s) for "
+                "scale=%f\n",
+                st->name, ste->value, layer->name, scale);
+      }
+      check_st_alloc(layer);
+      layer->orig_st->filter = msStrdup(layer->filter.string);
+      tmpval = msStrdup(layer->filter.string);
+      tmpval = msReplaceSubstring(tmpval, st->name, ste->value);
+      if (msLoadExpressionString(&(layer->filter), tmpval) == -1)
+        return (MS_FAILURE); /* msLoadExpressionString() cleans up previously
+                                allocated expression */
+      msFree(tmpval);
+    }
+    for (p = 0; p < layer->numprocessing; p++) {
+      if (strstr(layer->processing[p], st->name)) {
+        check_st_alloc(layer);
+        layer->orig_st->n_processing++;
+        layer->orig_st->processing =
+            msSmallRealloc(layer->orig_st->processing,
+                           layer->orig_st->n_processing * sizeof(char *));
+        layer->orig_st->processing_idx =
+            msSmallRealloc(layer->orig_st->processing_idx,
+                           layer->orig_st->n_processing * sizeof(int));
+        layer->orig_st->processing[layer->orig_st->n_processing - 1] =
+            layer->processing[p];
+        layer->orig_st->processing_idx[layer->orig_st->n_processing - 1] = p;
+        layer->processing[p] = msStrdup(layer->processing[p]);
+        layer->processing[p] =
+            msReplaceSubstring(layer->processing[p], st->name, ste->value);
+      }
+    }
+  }
+  return MS_SUCCESS;
+}
+
+/*
+** Does exactly what it implies, readies a layer for processing.
+*/
+int msLayerOpen(layerObj *layer) {
+  int rv;
+
+  /* RFC-86 Scale dependant token replacements*/
+  rv = msLayerApplyScaletokens(layer,
+                               (layer->map) ? layer->map->scaledenom : -1);
+  if (rv != MS_SUCCESS)
+    return rv;
+
+  /* RFC-69 clustering support */
+  if (layer->cluster.region)
+    return msClusterLayerOpen(layer);
+
+  if (layer->features && layer->connectiontype != MS_GRATICULE)
+    layer->connectiontype = MS_INLINE;
+
+  if (layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
+    layer->connectiontype = MS_TILED_SHAPEFILE;
+
+  if (layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS &&
+      layer->connectiontype != MS_KERNELDENSITY)
+    layer->connectiontype = MS_RASTER;
+
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerOpen(layer);
+}
+
+/*
+** Returns MS_TRUE if layer has been opened using msLayerOpen(), MS_FALSE
+*otherwise
+*/
+int msLayerIsOpen(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerIsOpen(layer);
+}
+
+/*
+** Returns MS_TRUE is a layer supports the common expression/filter syntax (RFC
+*64) and MS_FALSE otherwise.
+*/
+int msLayerSupportsCommonFilters(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerSupportsCommonFilters(layer);
+}
+
+int msLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                           char *filteritem) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerTranslateFilter(layer, filter, filteritem);
+}
+
+/*
+** Performs a spatial, and optionally an attribute based feature search. The
+*function basically
+** prepares things so that candidate features can be accessed by query or
+*drawing functions. For
+** OGR and shapefiles this sets an internal bit vector that indicates whether a
+*particular feature
+** is to processed. For SDE it executes an SQL statement on the SDE server. Once
+*run the msLayerNextShape
+** function should be called to actually access the shapes.
+**
+** Note that for shapefiles we apply any maxfeatures constraint at this point.
+*That may be the only
+** connection type where this is feasible.
+*/
+int msLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  if (!msLayerSupportsCommonFilters(layer))
+    msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
+
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerWhichShapes(layer, rect, isQuery);
+}
+
+/*
+** Called after msWhichShapes has been called to actually retrieve shapes within
+*a given area
+** and matching a vendor specific filter (i.e. layer FILTER attribute).
+**
+** Shapefiles: NULL shapes (shapes with attributes but NO vertices are skipped)
+*/
+int msLayerNextShape(layerObj *layer, shapeObj *shape) {
+  int rv, filter_passed;
+
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+
+#ifdef USE_V8_MAPSCRIPT
+  /* we need to force the GetItems for the geomtransform attributes */
+  if (!layer->items &&
+      layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION &&
+      strstr(layer->_geomtransform.string, "javascript"))
+    msLayerGetItems(layer);
+#endif
+
+  /* At the end of switch case (default -> break; -> return MS_FAILURE),
+   * was following TODO ITEM:
+   *
+   * TO DO! This is where dynamic joins will happen. Joined attributes will be
+   * tagged on to the main attributes with the naming scheme [join name].[item
+   * name]. We need to leverage the iteminfo (I think) at this point
+   */
+
+  /* RFC 91: MapServer-based filtering is done at a more general level. */
+  do {
+    rv = layer->vtable->LayerNextShape(layer, shape);
+    if (rv != MS_SUCCESS)
+      return rv;
+
+    /* attributes need to be iconv'd to UTF-8 before any filter logic is applied
+     */
+    if (layer->encoding) {
+      rv = msLayerEncodeShapeAttributes(layer, shape);
+      if (rv != MS_SUCCESS)
+        return rv;
+    }
+
+    filter_passed = msEvalExpression(layer, shape, &(layer->filter),
+                                     layer->filteritemindex);
+
+    if (!filter_passed)
+      msFreeShape(shape);
+  } while (!filter_passed);
+
+  /* RFC89 Apply Layer GeomTransform */
+  if (layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE && rv == MS_SUCCESS) {
+    rv = msGeomTransformShape(layer->map, layer, shape);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+
+  return rv;
+}
+
+/*
+** Used to retrieve a shape from a result set by index. Result sets are created
+*by the various
+** msQueryBy...() functions. The index is assigned by the data source.
+*/
+/* int msLayerResultsGetShape(layerObj *layer, shapeObj *shape, int tile, long
+record)
+{
+  if ( ! layer->vtable) {
+    int rv =  msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+
+  return layer->vtable->LayerResultsGetShape(layer, shape, tile, record);
+} */
+
+/*
+** Used to retrieve a shape by index. All data sources must be capable of random
+*access using
+** a record number(s) of some sort.
+*/
+int msLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  int rv;
+
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+
+  /*
+  ** TODO: This is where dynamic joins could happen. Joined attributes would be
+  ** tagged on to the main attributes with the naming scheme [join name].[item
+  *name].
+  */
+
+  rv = layer->vtable->LayerGetShape(layer, shape, record);
+  if (rv != MS_SUCCESS)
+    return rv;
+
+  /* RFC89 Apply Layer GeomTransform */
+  if (layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
+    rv = msGeomTransformShape(layer->map, layer, shape);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+
+  if (layer->encoding) {
+    rv = msLayerEncodeShapeAttributes(layer, shape);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+
+  return rv;
+}
+
+/*
+** Returns the number of shapes that match the potential filter and extent.
+* rectProjection is the projection in which rect is expressed, or can be NULL if
+* rect should be considered in the layer projection.
+* This should be equivalent to calling msLayerWhichShapes() and counting the
+* number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
+* limitation if layer->maxfeatures>=0, and honouring layer->startindex if
+* layer->startindex >= 1 and paging is enabled.
+* Returns -1 in case of failure.
+*/
+int msLayerGetShapeCount(layerObj *layer, rectObj rect,
+                         projectionObj *rectProjection) {
+  int rv;
+
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return -1;
+  }
+  cppcheck_assert(layer->vtable);
+
+  return layer->vtable->LayerGetShapeCount(layer, rect, rectProjection);
+}
+
+/*
+** Closes resources used by a particular layer.
+*/
+void msLayerClose(layerObj *layer) {
+  /* no need for items once the layer is closed */
+  msLayerFreeItemInfo(layer);
+  if (layer->items) {
+    msFreeCharArray(layer->items, layer->numitems);
+    layer->items = NULL;
+    layer->numitems = 0;
+  }
+
+  /* clear out items used as part of expressions (bug #2702) -- what about the
+   * layer filter? */
+  msLayerFreeExpressions(layer);
+
+  if (layer->vtable) {
+    layer->vtable->LayerClose(layer);
+  }
+  msLayerRestoreFromScaletokens(layer);
+}
+
+/*
+** Clear out items used as part of expressions.
+*/
+void msLayerFreeExpressions(layerObj *layer) {
+  int i, j, k;
+
+  msFreeExpressionTokens(&(layer->filter));
+  msFreeExpressionTokens(&(layer->cluster.group));
+  msFreeExpressionTokens(&(layer->cluster.filter));
+  for (i = 0; i < layer->numclasses; i++) {
+    msFreeExpressionTokens(&(layer->class[i] -> expression));
+    msFreeExpressionTokens(&(layer->class[i] -> text));
+    for (j = 0; j < layer->class[i] -> numstyles; j++)
+      msFreeExpressionTokens(&(layer->class[i] -> styles[j] -> _geomtransform));
+    for (k = 0; k < layer->class[i] -> numlabels; k++) {
+      msFreeExpressionTokens(&(layer->class[i] -> labels[k] -> expression));
+      msFreeExpressionTokens(&(layer->class[i] -> labels[k] -> text));
+    }
+  }
+}
+
+/*
+** Retrieves a list of attributes available for this layer. Most sources also
+*set the iteminfo array
+** at this point. This function is used when processing query results to expose
+*attributes to query
+** templates. At that point all attributes are fair game.
+*/
+int msLayerGetItems(layerObj *layer) {
+  const char *itemNames;
+  /* clean up any previously allocated instances */
+  msLayerFreeItemInfo(layer);
+  if (layer->items) {
+    msFreeCharArray(layer->items, layer->numitems);
+    layer->items = NULL;
+    layer->numitems = 0;
+  }
+
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+
+  /* At the end of switch case (default -> break; -> return MS_FAILURE),
+   * was following TODO ITEM:
+   */
+  /* TO DO! Need to add any joined itemd on to the core layer items, one long
+   * list!  */
+  itemNames = msLayerGetProcessingKey(layer, "ITEMS");
+  if (itemNames) {
+    layer->items = msStringSplit(itemNames, ',', &layer->numitems);
+    /* populate the iteminfo array */
+    return (msLayerInitItemInfo(layer));
+  } else
+    return layer->vtable->LayerGetItems(layer);
+}
+
+/*
+** Returns extent of spatial coverage for a layer.
+**
+** If layer->extent is set then this value is used, otherwise the
+** driver-specific implementation is called (this can be expensive).
+**
+** If layer is not already opened then it is opened and closed (so this
+** function can be called on both opened or closed layers).
+**
+** Returns MS_SUCCESS/MS_FAILURE.
+*/
+int msLayerGetExtent(layerObj *layer, rectObj *extent) {
+  int need_to_close = MS_FALSE, status = MS_SUCCESS;
+
+  if (MS_VALID_EXTENT(layer->extent)) {
+    *extent = layer->extent;
+    return MS_SUCCESS;
+  }
+
+  if (!msLayerIsOpen(layer)) {
+    if (msLayerOpen(layer) != MS_SUCCESS)
+      return MS_FAILURE;
+    need_to_close = MS_TRUE;
+  }
+
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS) {
+      if (need_to_close)
+        msLayerClose(layer);
+      return rv;
+    }
+  }
+  cppcheck_assert(layer->vtable);
+  status = layer->vtable->LayerGetExtent(layer, extent);
+
+  if (status == MS_SUCCESS) {
+    layer->extent = *extent;
+  }
+
+  if (need_to_close)
+    msLayerClose(layer);
+
+  return (status);
+}
+
+int msLayerGetItemIndex(layerObj *layer, char *item) {
+  int i;
+
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], item) == 0)
+      return (i);
+  }
+
+  return -1; /* item not found */
+}
+
+static int string2list(char **list, int *listsize, char *string) {
+  int i;
+
+  for (i = 0; i < (*listsize); i++) {
+    if (strcasecmp(list[i], string) == 0) {
+      /* printf("string2list (duplicate): %s %d\n", string, i); */
+      return (i);
+    }
+  }
+
+  list[i] = msStrdup(string);
+  (*listsize)++;
+
+  /* printf("string2list: %s %d\n", string, i); */
+
+  return (i);
+}
+
+extern int msyylex(void);
+extern int msyylex_destroy(void);
+
+extern int msyystate;
+extern char *msyystring; /* string to tokenize */
+
+extern double msyynumber; /* token containers */
+extern char *msyystring_buffer;
+
+const char *msExpressionTokenToString(int token) {
+  switch (token) {
+  case '(':
+    return "(";
+  case ')':
+    return ")";
+  case ',':
+    return ",";
+  case '+':
+    return "+";
+  case '-':
+    return "-";
+  case '/':
+    return "/";
+  case '*':
+    return "*";
+  case '%':
+    return "%";
+
+  case MS_TOKEN_LOGICAL_AND:
+    return " and ";
+  case MS_TOKEN_LOGICAL_OR:
+    return " or ";
+  case MS_TOKEN_LOGICAL_NOT:
+    return " not ";
+
+  case MS_TOKEN_COMPARISON_EQ:
+    return " = ";
+  case MS_TOKEN_COMPARISON_NE:
+    return " != ";
+  case MS_TOKEN_COMPARISON_GT:
+    return " > ";
+  case MS_TOKEN_COMPARISON_GE:
+    return " >= ";
+  case MS_TOKEN_COMPARISON_LT:
+    return " < ";
+  case MS_TOKEN_COMPARISON_LE:
+    return " <= ";
+  case MS_TOKEN_COMPARISON_IEQ:
+    return "";
+  case MS_TOKEN_COMPARISON_RE:
+    return " ~ ";
+  case MS_TOKEN_COMPARISON_IRE:
+    return " ~* ";
+  case MS_TOKEN_COMPARISON_IN:
+    return " in ";
+
+  case MS_TOKEN_COMPARISON_INTERSECTS:
+    return "intersects";
+  case MS_TOKEN_COMPARISON_DISJOINT:
+    return "disjoint";
+  case MS_TOKEN_COMPARISON_TOUCHES:
+    return "touches";
+  case MS_TOKEN_COMPARISON_OVERLAPS:
+    return "overlaps";
+  case MS_TOKEN_COMPARISON_CROSSES:
+    return "crosses";
+  case MS_TOKEN_COMPARISON_WITHIN:
+    return "within";
+  case MS_TOKEN_COMPARISON_CONTAINS:
+    return "contains";
+  case MS_TOKEN_COMPARISON_EQUALS:
+    return "equals";
+  case MS_TOKEN_COMPARISON_BEYOND:
+    return "beyond";
+  case MS_TOKEN_COMPARISON_DWITHIN:
+    return "dwithin";
+
+  case MS_TOKEN_FUNCTION_LENGTH:
+    return "length";
+  case MS_TOKEN_FUNCTION_TOSTRING:
+    return "tostring";
+  case MS_TOKEN_FUNCTION_COMMIFY:
+    return "commify";
+  case MS_TOKEN_FUNCTION_AREA:
+    return "area";
+  case MS_TOKEN_FUNCTION_ROUND:
+    return "round";
+  case MS_TOKEN_FUNCTION_BUFFER:
+    return "buffer";
+  case MS_TOKEN_FUNCTION_DIFFERENCE:
+    return "difference";
+  case MS_TOKEN_FUNCTION_SIMPLIFY:
+    return "simplify";
+  // case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+  case MS_TOKEN_FUNCTION_GENERALIZE:
+    return "generalize";
+  default:
+    return NULL;
+  }
+}
+
+int msTokenizeExpression(expressionObj *expression, char **list,
+                         int *listsize) {
+  tokenListNodeObjPtr node;
+  int token;
+
+  /* TODO: make sure the constants can't somehow reference invalid expression
+   * types */
+  /* if(expression->type != MS_EXPRESSION && expression->type !=
+   * MS_GEOMTRANSFORM_EXPRESSION) return MS_SUCCESS; */
+
+  msAcquireLock(TLOCK_PARSER);
+  msyystate = MS_TOKENIZE_EXPRESSION;
+  msyystring = expression->string; /* the thing we're tokenizing */
+
+  while ((token = msyylex()) !=
+         0) { /* keep processing tokens until the end of the string (\0) */
+
+    if ((node = (tokenListNodeObjPtr)malloc(sizeof(tokenListNodeObj))) ==
+        NULL) {
+      msSetError(MS_MEMERR, NULL, "msTokenizeExpression()");
+      goto parse_error;
+    }
+
+    node->tokensrc = NULL;
+
+    node->tailifhead = NULL;
+    node->next = NULL;
+
+    switch (token) {
+    case MS_TOKEN_LITERAL_BOOLEAN:
+    case MS_TOKEN_LITERAL_NUMBER:
+      node->token = token;
+      node->tokenval.dblval = msyynumber;
+      break;
+    case MS_TOKEN_LITERAL_STRING:
+      node->token = token;
+      node->tokenval.strval = msStrdup(msyystring_buffer);
+      break;
+    case MS_TOKEN_LITERAL_TIME:
+      node->tokensrc = msStrdup(msyystring_buffer);
+      node->token = token;
+      msTimeInit(&(node->tokenval.tmval));
+      if (msParseTime(msyystring_buffer, &(node->tokenval.tmval)) != MS_TRUE) {
+        msSetError(MS_PARSEERR, "Parsing time value failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+      break;
+    case MS_TOKEN_BINDING_DOUBLE: /* we've encountered an attribute (binding)
+                                     reference */
+    case MS_TOKEN_BINDING_INTEGER:
+    case MS_TOKEN_BINDING_STRING:
+    case MS_TOKEN_BINDING_TIME:
+      node->token = token; /* binding type */
+      node->tokenval.bindval.item = msStrdup(msyystring_buffer);
+      if (list)
+        node->tokenval.bindval.index =
+            string2list(list, listsize, msyystring_buffer);
+      break;
+    case MS_TOKEN_BINDING_SHAPE:
+      node->token = token;
+      break;
+    case MS_TOKEN_BINDING_MAP_CELLSIZE:
+      node->token = token;
+      break;
+    case MS_TOKEN_BINDING_DATA_CELLSIZE:
+      node->token = token;
+      break;
+    case MS_TOKEN_FUNCTION_FROMTEXT: /* we want to process a shape from WKT once
+                                        and not for every feature being
+                                        evaluated */
+      if ((token = msyylex()) != 40) { /* ( */
+        msSetError(MS_PARSEERR, "Parsing fromText function failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+
+      if ((token = msyylex()) != MS_TOKEN_LITERAL_STRING) {
+        msSetError(MS_PARSEERR, "Parsing fromText function failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+
+      node->token = MS_TOKEN_LITERAL_SHAPE;
+      node->tokenval.shpval = msShapeFromWKT(msyystring_buffer);
+
+      if (!node->tokenval.shpval) {
+        msSetError(MS_PARSEERR,
+                   "Parsing fromText function failed, WKT processing failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+
+      /* todo: perhaps process optional args (e.g. projection) */
+
+      if ((token = msyylex()) != 41) { /* ) */
+        msSetError(MS_PARSEERR, "Parsing fromText function failed.",
+                   "msTokenizeExpression()");
+        msFreeShape(node->tokenval.shpval);
+        free(node->tokenval.shpval);
+        free(node);
+        goto parse_error;
+      }
+      break;
+    default:
+      node->token = token; /* for everything else */
+      break;
+    }
+
+    /* add node to token list */
+    if (expression->tokens == NULL) {
+      expression->tokens = node;
+    } else {
+      if (expression->tokens->tailifhead !=
+          NULL) /* this should never be NULL, but just in case */
+        expression->tokens->tailifhead->next =
+            node; /* put the node at the end of the list */
+    }
+
+    /* repoint the head of the list to the end  - our new element
+       this causes a loop if we are at the head, be careful not to
+       walk in a loop */
+    expression->tokens->tailifhead = node;
+  }
+
+  expression->curtoken = expression->tokens; /* point at the first token */
+
+  msReleaseLock(TLOCK_PARSER);
+  return MS_SUCCESS;
+
+parse_error:
+  msReleaseLock(TLOCK_PARSER);
+  return MS_FAILURE;
+}
+
+static void buildLayerItemList(layerObj *layer) {
+  int i, j, k, l;
+  /*
+  ** build layer item list, compute item indexes for explicity item references
+  *(e.g. classitem) or item bindings
+  */
+
+  /* layer items */
+  if (layer->classitem)
+    layer->classitemindex =
+        string2list(layer->items, &(layer->numitems), layer->classitem);
+  if (layer->filteritem)
+    layer->filteritemindex =
+        string2list(layer->items, &(layer->numitems), layer->filteritem);
+  if (layer->styleitem && (strcasecmp(layer->styleitem, "AUTO") != 0) &&
+      !STARTS_WITH_CI(layer->styleitem, "javascript://") &&
+      !STARTS_WITH_CI(layer->styleitem, "sld://"))
+    layer->styleitemindex =
+        string2list(layer->items, &(layer->numitems), layer->styleitem);
+  if (layer->labelitem)
+    layer->labelitemindex =
+        string2list(layer->items, &(layer->numitems), layer->labelitem);
+  if (layer->utfitem)
+    layer->utfitemindex =
+        string2list(layer->items, &(layer->numitems), layer->utfitem);
+
+  /* layer classes */
+  for (i = 0; i < layer->numclasses; i++) {
+
+    // if classgroup has been set we can ignore any fields required
+    // for rendering unused classes
+    if (layer->class[i] -> group && layer -> classgroup &&strcasecmp(
+                                                 layer->class[i] -> group,
+                                                 layer -> classgroup) != 0)
+      continue;
+
+    if (layer->class[i] -> expression.type ==
+                               MS_EXPRESSION) /* class expression */
+      msTokenizeExpression(&(layer->class[i] -> expression), layer->items,
+                           &(layer->numitems));
+
+    /* class styles (items, bindings, geomtransform) */
+    for (j = 0; j < layer->class[i] -> numstyles; j++) {
+      if (layer->class[i] -> styles[j] -> rangeitem)
+        layer->class[i]->styles[j]->rangeitemindex =
+            string2list(layer->items, &(layer->numitems),
+                        layer->class[i] -> styles[j] -> rangeitem);
+      for (k = 0; k < MS_STYLE_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> styles[j] -> bindings[k].item)
+          layer->class[i]->styles[j]->bindings[k].index =
+              string2list(layer->items, &(layer->numitems),
+                          layer->class[i] -> styles[j] -> bindings[k].item);
+        if (layer->class[i] -> styles[j] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
+          msTokenizeExpression(
+              &(layer->class[i] -> styles[j] -> exprBindings[k]), layer->items,
+              &(layer->numitems));
+        }
+      }
+      if (layer->class[i] -> styles[j] -> _geomtransform.type ==
+                                              MS_GEOMTRANSFORM_EXPRESSION)
+        msTokenizeExpression(&(layer->class[i] -> styles[j] -> _geomtransform),
+                             layer->items, &(layer->numitems));
+    }
+
+    /* class labels and label styles (items, bindings, geomtransform) */
+    for (l = 0; l < layer->class[i] -> numlabels; l++) {
+      for (j = 0; j < layer->class[i] -> labels[l] -> numstyles; j++) {
+        if (layer->class[i] -> labels[l] -> styles[j] -> rangeitem)
+          layer->class[i]->labels[l]->styles[j]->rangeitemindex = string2list(
+              layer->items, &(layer->numitems),
+              layer->class[i] -> labels[l] -> styles[j] -> rangeitem);
+        for (k = 0; k < MS_STYLE_BINDING_LENGTH; k++) {
+          if (layer->class[i] -> labels[l] -> styles[j] -> bindings[k].item)
+            layer->class[i]->labels[l]->styles[j]->bindings[k].index =
+                string2list(layer->items, &(layer->numitems),
+                            layer->class[i] -> labels[l] -> styles[j]
+                            -> bindings[k].item);
+          if (layer->class[i] -> labels[l] -> styles[j]
+              -> _geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
+            msTokenizeExpression(
+                &(layer->class[i] -> labels[l] -> styles[j] -> _geomtransform),
+                layer->items, &(layer->numitems));
+        }
+      }
+      for (k = 0; k < MS_LABEL_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> labels[l] -> bindings[k].item)
+          layer->class[i]->labels[l]->bindings[k].index =
+              string2list(layer->items, &(layer->numitems),
+                          layer->class[i] -> labels[l] -> bindings[k].item);
+        if (layer->class[i] -> labels[l] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
+          msTokenizeExpression(
+              &(layer->class[i] -> labels[l] -> exprBindings[k]), layer->items,
+              &(layer->numitems));
+        }
+      }
+
+      /* label expression */
+      if (layer->class[i] -> labels[l] -> expression.type == MS_EXPRESSION)
+        msTokenizeExpression(&(layer->class[i] -> labels[l] -> expression),
+                             layer->items, &(layer->numitems));
+
+      /* label text */
+      if (layer->class[i] -> labels[l]
+          -> text.type == MS_EXPRESSION ||
+                 (layer->class[i] -> labels[l]
+                  -> text.string &&strchr(
+                         layer->class[i] -> labels[l] -> text.string, '[') !=
+                             NULL &&
+                         strchr(layer->class[i] -> labels[l] -> text.string,
+                                ']') != NULL))
+        msTokenizeExpression(&(layer->class[i] -> labels[l] -> text),
+                             layer->items, &(layer->numitems));
+    }
+
+    /* class text */
+    if (layer->class[i]
+        -> text.type == MS_EXPRESSION ||
+               (layer->class[i]
+                -> text.string &&strchr(layer->class[i] -> text.string, '[') !=
+                           NULL &&
+                       strchr(layer->class[i] -> text.string, ']') != NULL))
+      msTokenizeExpression(&(layer->class[i] -> text), layer->items,
+                           &(layer->numitems));
+  }
+
+  /* layer filter */
+  if (layer->filter.type == MS_EXPRESSION)
+    msTokenizeExpression(&(layer->filter), layer->items, &(layer->numitems));
+
+  /* cluster expressions */
+  if (layer->cluster.group.type == MS_EXPRESSION)
+    msTokenizeExpression(&(layer->cluster.group), layer->items,
+                         &(layer->numitems));
+  if (layer->cluster.filter.type == MS_EXPRESSION)
+    msTokenizeExpression(&(layer->cluster.filter), layer->items,
+                         &(layer->numitems));
+
+  /* utfdata */
+  if (layer->utfdata.type == MS_EXPRESSION ||
+      (layer->utfdata.string && strchr(layer->utfdata.string, '[') != NULL &&
+       strchr(layer->utfdata.string, ']') != NULL)) {
+    msTokenizeExpression(&(layer->utfdata), layer->items, &(layer->numitems));
+  }
+}
+
+/*
+** This function builds a list of items necessary to draw or query a particular
+*layer by
+** examining the contents of the various xxxxitem parameters and expressions.
+*That list is
+** then used to set the iteminfo variable.
+*/
+int msLayerWhichItems(layerObj *layer, int get_all, const char *metadata) {
+  int i, j, k, l, rv;
+  int nt = 0;
+
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+
+  /* Cleanup any previous item selection */
+  msLayerFreeItemInfo(layer);
+  if (layer->items) {
+    msFreeCharArray(layer->items, layer->numitems);
+    layer->items = NULL;
+    layer->numitems = 0;
+  }
+
+  /*
+  ** need a count of potential items/attributes needed
+  */
+
+  /* layer level counts */
+  layer->classitemindex = -1;
+  layer->filteritemindex = -1;
+  layer->styleitemindex = -1;
+  layer->labelitemindex = -1;
+  layer->utfitemindex = -1;
+
+  if (layer->classitem)
+    nt++;
+  if (layer->filteritem)
+    nt++;
+  if (layer->styleitem && (strcasecmp(layer->styleitem, "AUTO") != 0) &&
+      !STARTS_WITH_CI(layer->styleitem, "javascript://") &&
+      !STARTS_WITH_CI(layer->styleitem, "sld://"))
+    nt++;
+
+  if (layer->filter.type == MS_EXPRESSION)
+    nt += msCountChars(layer->filter.string, '[');
+
+  if (layer->cluster.group.type == MS_EXPRESSION)
+    nt += msCountChars(layer->cluster.group.string, '[');
+
+  if (layer->cluster.filter.type == MS_EXPRESSION)
+    nt += msCountChars(layer->cluster.filter.string, '[');
+
+  if (layer->labelitem)
+    nt++;
+  if (layer->utfitem)
+    nt++;
+
+  if (layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
+    msTokenizeExpression(&layer->_geomtransform, layer->items,
+                         &(layer->numitems));
+
+  /* class level counts */
+  for (i = 0; i < layer->numclasses; i++) {
+
+    for (j = 0; j < layer->class[i] -> numstyles; j++) {
+      if (layer->class[i] -> styles[j] -> rangeitem)
+        nt++;
+      nt += layer->class[i]->styles[j]->numbindings;
+      if (layer->class[i] -> styles[j] -> _geomtransform.type ==
+                                              MS_GEOMTRANSFORM_EXPRESSION)
+        nt += msCountChars(
+            layer->class[i] -> styles[j] -> _geomtransform.string, '[');
+      for (k = 0; k < MS_STYLE_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> styles[j] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
+          nt += msCountChars(
+              layer->class[i] -> styles[j] -> exprBindings[k].string, '[');
+        }
+      }
+    }
+
+    if (layer->class[i] -> expression.type == MS_EXPRESSION)
+      nt += msCountChars(layer->class[i] -> expression.string, '[');
+
+    for (l = 0; l < layer->class[i] -> numlabels; l++) {
+      nt += layer->class[i]->labels[l]->numbindings;
+      for (j = 0; j < layer->class[i] -> labels[l] -> numstyles; j++) {
+        if (layer->class[i] -> labels[l] -> styles[j] -> rangeitem)
+          nt++;
+        nt += layer->class[i]->labels[l]->styles[j]->numbindings;
+        if (layer->class[i] -> labels[l] -> styles[j]
+            -> _geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
+          nt += msCountChars(layer->class[i] -> labels[l] -> styles[j]
+                             -> _geomtransform.string,
+                             '[');
+      }
+      for (k = 0; k < MS_LABEL_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> labels[l] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
+          nt += msCountChars(
+              layer->class[i] -> labels[l] -> exprBindings[k].string, '[');
+        }
+      }
+
+      if (layer->class[i] -> labels[l] -> expression.type == MS_EXPRESSION)
+        nt += msCountChars(layer->class[i] -> labels[l] -> expression.string,
+                           '[');
+      if (layer->class[i] -> labels[l]
+          -> text.type == MS_EXPRESSION ||
+                 (layer->class[i] -> labels[l]
+                  -> text.string &&strchr(
+                         layer->class[i] -> labels[l] -> text.string, '[') !=
+                             NULL &&
+                         strchr(layer->class[i] -> labels[l] -> text.string,
+                                ']') != NULL))
+        nt += msCountChars(layer->class[i] -> labels[l] -> text.string, '[');
+    }
+
+    if (layer->class[i]
+        -> text.type == MS_EXPRESSION ||
+               (layer->class[i]
+                -> text.string &&strchr(layer->class[i] -> text.string, '[') !=
+                           NULL &&
+                       strchr(layer->class[i] -> text.string, ']') != NULL))
+      nt += msCountChars(layer->class[i] -> text.string, '[');
+  }
+
+  /* utfgrid count */
+  if (layer->utfdata.type == MS_EXPRESSION ||
+      (layer->utfdata.string && strchr(layer->utfdata.string, '[') != NULL &&
+       strchr(layer->utfdata.string, ']') != NULL))
+    nt += msCountChars(layer->utfdata.string, '[');
+
+  // if we are using a GetMap request with a WMS filter we don't need to return
+  // all items
+  if (msOWSLookupMetadata(&(layer->metadata), "G", "wmsfilter_flag") != NULL) {
+    get_all = MS_FALSE;
+  }
+
+  if (metadata == NULL) {
+    // check item set by mapwfs.cpp to restrict the number of columns selected
+    metadata = msOWSLookupMetadata(&(layer->metadata), "G", "select_items");
+    if (metadata) {
+      /* get only selected items */
+      get_all = MS_FALSE;
+    }
+  }
+
+  /* always retrieve all items in some cases */
+  if (layer->connectiontype == MS_INLINE ||
+      (layer->map->outputformat &&
+       layer->map->outputformat->renderer == MS_RENDER_WITH_KML)) {
+    get_all = MS_TRUE;
+  }
+
+  /*
+  ** allocate space for the item list (worse case size)
+  */
+  if (get_all) {
+    rv = msLayerGetItems(layer);
+    if (nt > 0) /* need to realloc the array to accept the possible new items*/
+      layer->items = (char **)msSmallRealloc(
+          layer->items, sizeof(char *) * (layer->numitems + nt));
+  } else {
+    rv = layer->vtable->LayerCreateItems(layer, nt);
+  }
+  if (rv != MS_SUCCESS)
+    return rv;
+
+  buildLayerItemList(layer);
+
+  if (metadata) {
+    char **tokens;
+    int n = 0;
+    int j;
+
+    tokens = msStringSplit(metadata, ',', &n);
+    if (tokens) {
+      for (i = 0; i < n; i++) {
+        int bFound = 0;
+        for (j = 0; j < layer->numitems; j++) {
+          if (strcasecmp(tokens[i], layer->items[j]) == 0) {
+            bFound = 1;
+            break;
+          }
+        }
+
+        if (!bFound) {
+          layer->numitems++;
+          layer->items = (char **)msSmallRealloc(
+              layer->items, sizeof(char *) * (layer->numitems));
+          layer->items[layer->numitems - 1] = msStrdup(tokens[i]);
+        }
+      }
+      msFreeCharArray(tokens, n);
+    }
+
+    /* If we didn't retrieve all items of the layer, then do it, so that the */
+    /* order of the layer->items array is consistent with it. This is */
+    /* important so that WFS DescribeFeatureType and GetFeature requests */
+    /* return items in the same order */
+    if (!get_all && layer->numitems) {
+      char **unsorted_items = layer->items;
+      int numitems = layer->numitems;
+
+      /* Retrieve all items */
+      layer->items = NULL;
+      layer->numitems = 0;
+      rv = msLayerGetItems(layer);
+      if (rv != MS_SUCCESS) {
+        msFreeCharArray(unsorted_items, numitems);
+        return rv;
+      }
+
+      /* Sort unsorted_items in the order of layer->items */
+      char **sorted_items = (char **)msSmallMalloc(sizeof(char *) * numitems);
+      int num_sorted_items = 0;
+      for (i = 0; i < layer->numitems; i++) {
+        if (layer->items[i]) {
+          for (j = 0; j < numitems; j++) {
+            if (unsorted_items[j] &&
+                strcasecmp(layer->items[i], unsorted_items[j]) == 0) {
+              sorted_items[num_sorted_items] = layer->items[i];
+              num_sorted_items++;
+
+              layer->items[i] = NULL;
+              msFree(unsorted_items[j]);
+              unsorted_items[j] = NULL;
+              break;
+            }
+          }
+        }
+      }
+
+      /* Add items that are not returned by msLayerGetItems() (not sure if that
+       * can happen) */
+      for (j = 0; j < numitems; j++) {
+        if (unsorted_items[j]) {
+          sorted_items[num_sorted_items] = unsorted_items[j];
+          num_sorted_items++;
+        }
+      }
+
+      if (layer->numitems > 0) {
+        msFreeCharArray(layer->items, layer->numitems);
+      }
+      msFreeCharArray(unsorted_items, numitems);
+
+      layer->items = sorted_items;
+      layer->numitems = numitems;
+
+      /* Re-run buildLayerItemList() with the now correctly sorted items */
+      buildLayerItemList(layer);
+    }
+  }
+
+  /* populate the iteminfo array */
+  if (layer->numitems == 0)
+    return (MS_SUCCESS);
+
+  return (msLayerInitItemInfo(layer));
+}
+
+/*
+** A helper function to set the items to be retrieved with a particular shape.
+*Unused at the moment but will be used
+** from within MapScript. Should not need modification.
+*/
+int msLayerSetItems(layerObj *layer, char **items, int numitems) {
+  int i;
+  /* Cleanup any previous item selection */
+  msLayerFreeItemInfo(layer);
+  if (layer->items) {
+    msFreeCharArray(layer->items, layer->numitems);
+    layer->items = NULL;
+    layer->numitems = 0;
+  }
+
+  /* now allocate and set the layer item parameters  */
+  layer->items = (char **)malloc(sizeof(char *) * numitems);
+  MS_CHECK_ALLOC(layer->items, sizeof(char *) * numitems, MS_FAILURE);
+
+  for (i = 0; i < numitems; i++)
+    layer->items[i] = msStrdup(items[i]);
+  layer->numitems = numitems;
+
+  /* populate the iteminfo array */
+  return (msLayerInitItemInfo(layer));
+}
+
+/*
+** Fills a classObj with style info from the specified shape.  This is used
+** with STYLEITEM AUTO when rendering shapes.
+** For optimal results, this should be called immediately after
+** GetNextShape() or GetShape() so that the shape doesn't have to be read
+** twice.
+**
+*/
+int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                        shapeObj *shape) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerGetAutoStyle(map, layer, c, shape);
+}
+
+/*
+** Fills a classObj with style info from the specified attribute.  This is used
+** with STYLEITEM "attribute" when rendering shapes.
+**
+*/
+int msLayerGetFeatureStyle(mapObj *map, layerObj *layer, classObj *c,
+                           shapeObj *shape) {
+  char *stylestring = NULL;
+  if (layer->styleitem && layer->styleitemindex >= 0) {
+    stylestring = msStrdup(shape->values[layer->styleitemindex]);
+  } else if (layer->styleitem &&
+             strncasecmp(layer->styleitem, "javascript://", 13) == 0) {
+#ifdef USE_V8_MAPSCRIPT
+    char *filename = layer->styleitem + 13;
+
+    if (!map->v8context) {
+      msV8CreateContext(map);
+      if (!map->v8context) {
+        msSetError(MS_V8ERR, "Unable to create v8 context.",
+                   "msLayerGetFeatureStyle()");
+        return MS_FAILURE;
+      }
+    }
+
+    if (*filename == '\0') {
+      msSetError(MS_V8ERR, "Invalid javascript filename: \"%s\".",
+                 "msLayerGetFeatureStyle()", layer->styleitem);
+      return MS_FAILURE;
+    }
+
+    stylestring = msV8GetFeatureStyle(map, filename, layer, shape);
+#else
+    msSetError(MS_V8ERR, "V8 Javascript support is not available.",
+               "msLayerGetFeatureStyle()");
+    return MS_FAILURE;
+#endif
+  } else if (layer->styleitem && STARTS_WITH_CI(layer->styleitem, "sld://")) {
+    // ignore the SLD styleitem
+    return MS_SUCCESS;
+  } else { /* unknown styleitem */
+    return MS_FAILURE;
+  }
+
+  /* try to find out the current style format */
+  if (!stylestring)
+    return MS_FAILURE;
+
+  if (strncasecmp(stylestring, "style", 5) == 0) {
+    resetClassStyle(c);
+    c->layer = layer;
+    if (msMaybeAllocateClassStyle(c, 0)) {
+      free(stylestring);
+      return (MS_FAILURE);
+    }
+
+    msUpdateStyleFromString(c->styles[0], stylestring);
+    if (c->styles[0]->symbolname) {
+      if ((c->styles[0]->symbol = msGetSymbolIndex(
+               &(map->symbolset), c->styles[0]->symbolname, MS_TRUE)) == -1) {
+        msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class of layer %s.",
+                   "msLayerGetFeatureStyle()", c->styles[0]->symbolname,
+                   layer->name);
+        free(stylestring);
+        return MS_FAILURE;
+      }
+    }
+  } else if (strncasecmp(stylestring, "class", 5) == 0) {
+    if (strcasestr(stylestring, " style ") != NULL) {
+      /* reset style if stylestring contains style definitions */
+      resetClassStyle(c);
+      c->layer = layer;
+    }
+    msUpdateClassFromString(c, stylestring);
+  } else if (strncasecmp(stylestring, "pen", 3) == 0 ||
+             strncasecmp(stylestring, "brush", 5) == 0 ||
+             strncasecmp(stylestring, "symbol", 6) == 0 ||
+             strncasecmp(stylestring, "label", 5) == 0) {
+    msOGRUpdateStyleFromString(map, layer, c, stylestring);
+  } else if (strcasestr(stylestring, "StyledLayerDescriptor>") != NULL) {
+    // check for the closing tag of an SLD document </StyledLayerDescriptor> or
+    // with a namespace e.g. </sld:StyledLayerDescriptor>
+    msSLDApplySLD(map, stylestring, layer->index, NULL, NULL);
+  } else {
+    resetClassStyle(c);
+  }
+
+  free(stylestring);
+  return MS_SUCCESS;
+}
+
+/*
+Returns the number of inline feature of a layer
+*/
+int msLayerGetNumFeatures(layerObj *layer) {
+  int need_to_close = MS_FALSE, result = -1;
+
+  if (!msLayerIsOpen(layer)) {
+    if (msLayerOpen(layer) != MS_SUCCESS)
+      return result;
+    need_to_close = MS_TRUE;
+  }
+
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return result;
+  }
+  cppcheck_assert(layer->vtable);
+
+  result = layer->vtable->LayerGetNumFeatures(layer);
+
+  if (need_to_close)
+    msLayerClose(layer);
+
+  return (result);
+}
+
+void msLayerSetProcessingKey(layerObj *layer, const char *key,
+                             const char *value)
+
+{
+  int len = strlen(key);
+  int i;
+  char *directive = NULL;
+
+  if (value != NULL) {
+    directive = (char *)msSmallMalloc(strlen(key) + strlen(value) + 2);
+    sprintf(directive, "%s=%s", key, value);
+  }
+
+  for (i = 0; i < layer->numprocessing; i++) {
+    if (strncasecmp(key, layer->processing[i], len) == 0 &&
+        layer->processing[i][len] == '=') {
+      free(layer->processing[i]);
+
+      /*
+      ** Either replace the existing entry with a new one or
+      ** clear the entry.
+      */
+      if (directive != NULL)
+        layer->processing[i] = directive;
+      else {
+        layer->processing[i] = layer->processing[layer->numprocessing - 1];
+        layer->processing[layer->numprocessing - 1] = NULL;
+        layer->numprocessing--;
+      }
+      return;
+    }
+  }
+
+  /* otherwise add the directive at the end. */
+
+  if (directive != NULL) {
+    msLayerAddProcessing(layer, directive);
+    free(directive);
+  }
+}
+
+void msLayerSubstituteProcessing(layerObj *layer, const char *from,
+                                 const char *to) {
+  int i;
+  for (i = 0; i < layer->numprocessing; i++) {
+    layer->processing[i] =
+        msCaseReplaceSubstring(layer->processing[i], from, to);
+  }
+}
+
+void msLayerAddProcessing(layerObj *layer, const char *directive)
+
+{
+  layer->numprocessing++;
+  if (layer->numprocessing == 1)
+    layer->processing = (char **)msSmallMalloc(2 * sizeof(char *));
+  else
+    layer->processing = (char **)msSmallRealloc(
+        layer->processing, sizeof(char *) * (layer->numprocessing + 1));
+  layer->processing[layer->numprocessing - 1] = msStrdup(directive);
+  layer->processing[layer->numprocessing] = NULL;
+}
+
+const char *msLayerGetProcessing(const layerObj *layer, int proc_index) {
+  if (proc_index < 0 || proc_index >= layer->numprocessing) {
+    msSetError(MS_CHILDERR, "Invalid processing index.",
+               "msLayerGetProcessing()");
+    return NULL;
+  } else {
+    return layer->processing[proc_index];
+  }
+}
+
+const char *msLayerGetProcessingKey(const layerObj *layer, const char *key) {
+  int i, len = strlen(key);
+
+  for (i = 0; i < layer->numprocessing; i++) {
+    if (strncasecmp(layer->processing[i], key, len) == 0 &&
+        layer->processing[i][len] == '=')
+      return layer->processing[i] + len + 1;
+  }
+
+  return NULL;
+}
+
+/************************************************************************/
+/*                       msLayerGetMaxFeaturesToDraw                    */
+/*                                                                      */
+/*      Check to see if maxfeaturestodraw is set as a metadata or an    */
+/*      output format option. Used for vector layers to limit the       */
+/*      number of fatures rendered.                                     */
+/************************************************************************/
+int msLayerGetMaxFeaturesToDraw(layerObj *layer, outputFormatObj *format) {
+  int nMaxFeatures = -1;
+  const char *pszTmp = NULL;
+  if (layer) {
+    nMaxFeatures = layer->maxfeatures;
+    pszTmp = msLookupHashTable(&layer->metadata, "maxfeaturestodraw");
+    if (pszTmp)
+      nMaxFeatures = atoi(pszTmp);
+    else {
+      pszTmp =
+          msLookupHashTable(&layer->map->web.metadata, "maxfeaturestodraw");
+      if (pszTmp)
+        nMaxFeatures = atoi(pszTmp);
+    }
+  }
+  if (format) {
+    if (nMaxFeatures < 0)
+      nMaxFeatures =
+          atoi(msGetOutputFormatOption(format, "maxfeaturestodraw", "-1"));
+  }
+
+  return nMaxFeatures;
+}
+int msLayerClearProcessing(layerObj *layer) {
+  if (layer->numprocessing > 0) {
+    msFreeCharArray(layer->processing, layer->numprocessing);
+    layer->processing = NULL;
+    layer->numprocessing = 0;
+  }
+  return layer->numprocessing;
+}
+
+int makeTimeFilter(layerObj *lp, const char *timestring, const char *timefield,
+                   const int addtimebacktics) {
+
+  char **atimes, **tokens = NULL;
+  int numtimes, i, ntmp = 0;
+  char *pszBuffer = NULL;
+  int bOnlyExistingFilter = 0;
+
+  if (!lp || !timestring || !timefield)
+    return MS_FALSE;
+
+  /* parse the time string. We support dicrete times (eg 2004-09-21),  */
+  /* multiple times (2004-09-21, 2004-09-22, ...) */
+  /* and range(s) (2004-09-21/2004-09-25, 2004-09-27/2004-09-29) */
+
+  if (strstr(timestring, ",") == NULL &&
+      strstr(timestring, "/") == NULL) { /* discrete time */
+    /*
+    if(lp->filteritem) free(lp->filteritem);
+    lp->filteritem = msStrdup(timefield);
+    if (&lp->filter)
+      msFreeExpression(&lp->filter);
+    */
+
+    /* if the filter is set and it's a sting type, concatenate it with
+       the time. If not just free it */
+    if (lp->filter.string && lp->filter.type == MS_STRING) {
+      pszBuffer = msStringConcatenate(pszBuffer, "((");
+      pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
+      pszBuffer = msStringConcatenate(pszBuffer, ") and ");
+    } else if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
+      char *pszExpressionString = msGetExpressionString(&(lp->filter));
+      pszBuffer = msStringConcatenate(pszBuffer, "(");
+      pszBuffer = msStringConcatenate(pszBuffer, pszExpressionString);
+      pszBuffer = msStringConcatenate(pszBuffer, " and ");
+      msFree(pszExpressionString);
+    } else {
+      msFreeExpression(&lp->filter);
+    }
+
+    pszBuffer = msStringConcatenate(pszBuffer, "(");
+    if (addtimebacktics)
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+    if (addtimebacktics)
+      pszBuffer = msStringConcatenate(pszBuffer, "[");
+    pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
+    if (addtimebacktics)
+      pszBuffer = msStringConcatenate(pszBuffer, "]");
+    if (addtimebacktics)
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+    pszBuffer = msStringConcatenate(pszBuffer, " = ");
+    if (addtimebacktics)
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
+    else
+      pszBuffer = msStringConcatenate(pszBuffer, "'");
+
+    pszBuffer = msStringConcatenate(pszBuffer, (char *)timestring);
+    if (addtimebacktics)
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
+    else
+      pszBuffer = msStringConcatenate(pszBuffer, "'");
+
+    pszBuffer = msStringConcatenate(pszBuffer, ")");
+
+    /* if there was a filter, It was concatenate with an And ans should be
+     * closed*/
+    if (lp->filter.string &&
+        (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION))
+      pszBuffer = msStringConcatenate(pszBuffer, ")");
+
+    msLoadExpressionString(&lp->filter, pszBuffer);
+
+    if (pszBuffer)
+      msFree(pszBuffer);
+    return MS_TRUE;
+  }
+
+  atimes = msStringSplit(timestring, ',', &numtimes);
+  if (atimes == NULL || numtimes < 1) {
+    msFreeCharArray(atimes, numtimes);
+    return MS_FALSE;
+  }
+
+  if (lp->filter.string && lp->filter.type == MS_STRING) {
+    pszBuffer = msStringConcatenate(pszBuffer, "((");
+    pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
+    pszBuffer = msStringConcatenate(pszBuffer, ") and ");
+    /*this flag is used to indicate that the buffer contains only the
+      existing filter. It is set to 0 when time filter parts are
+      added to the buffer */
+    bOnlyExistingFilter = 1;
+  } else if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
+    char *pszExpressionString = msGetExpressionString(&(lp->filter));
+    pszBuffer = msStringConcatenate(pszBuffer, "(");
+    pszBuffer = msStringConcatenate(pszBuffer, pszExpressionString);
+    pszBuffer = msStringConcatenate(pszBuffer, " and ");
+    msFree(pszExpressionString);
+    bOnlyExistingFilter = 1;
+  } else
+    msFreeExpression(&lp->filter);
+
+  /* check to see if we have ranges by parsing the first entry */
+  tokens = msStringSplit(atimes[0], '/', &ntmp);
+  if (ntmp == 2) { /* ranges */
+    msFreeCharArray(tokens, ntmp);
+    for (i = 0; i < numtimes; i++) {
+      tokens = msStringSplit(atimes[i], '/', &ntmp);
+      if (ntmp == 2) {
+        if (pszBuffer && strlen(pszBuffer) > 0 && bOnlyExistingFilter == 0)
+          pszBuffer = msStringConcatenate(pszBuffer, " OR ");
+        else
+          pszBuffer = msStringConcatenate(pszBuffer, "(");
+
+        bOnlyExistingFilter = 0;
+
+        pszBuffer = msStringConcatenate(pszBuffer, "(");
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "[");
+        pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "]");
+
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+        pszBuffer = msStringConcatenate(pszBuffer, " >= ");
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+        else
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
+
+        pszBuffer = msStringConcatenate(pszBuffer, tokens[0]);
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+        else
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
+        pszBuffer = msStringConcatenate(pszBuffer, " AND ");
+
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "[");
+        pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "]");
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+        pszBuffer = msStringConcatenate(pszBuffer, " <= ");
+
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+        else
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
+        pszBuffer = msStringConcatenate(pszBuffer, tokens[1]);
+        if (addtimebacktics)
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
+        else
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
+        pszBuffer = msStringConcatenate(pszBuffer, ")");
+      }
+
+      msFreeCharArray(tokens, ntmp);
+    }
+    if (pszBuffer && strlen(pszBuffer) > 0 && bOnlyExistingFilter == 0)
+      pszBuffer = msStringConcatenate(pszBuffer, ")");
+  } else if (ntmp == 1) { /* multiple times */
+    msFreeCharArray(tokens, ntmp);
+    pszBuffer = msStringConcatenate(pszBuffer, "(");
+    for (i = 0; i < numtimes; i++) {
+      if (i > 0)
+        pszBuffer = msStringConcatenate(pszBuffer, " OR ");
+
+      pszBuffer = msStringConcatenate(pszBuffer, "(");
+      if (addtimebacktics)
+        pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+      if (addtimebacktics)
+        pszBuffer = msStringConcatenate(pszBuffer, "[");
+      pszBuffer = msStringConcatenate(pszBuffer, (char *)timefield);
+      if (addtimebacktics)
+        pszBuffer = msStringConcatenate(pszBuffer, "]");
+
+      if (addtimebacktics)
+        pszBuffer = msStringConcatenate(pszBuffer, "`");
+
+      pszBuffer = msStringConcatenate(pszBuffer, " = ");
+
+      if (addtimebacktics)
+        pszBuffer = msStringConcatenate(pszBuffer, "`");
+      else
+        pszBuffer = msStringConcatenate(pszBuffer, "'");
+      pszBuffer = msStringConcatenate(pszBuffer, atimes[i]);
+      if (addtimebacktics)
+        pszBuffer = msStringConcatenate(pszBuffer, "`");
+      else
+        pszBuffer = msStringConcatenate(pszBuffer, "'");
+      pszBuffer = msStringConcatenate(pszBuffer, ")");
+    }
+    pszBuffer = msStringConcatenate(pszBuffer, ")");
+  } else {
+    msFreeCharArray(tokens, ntmp);
+    msFreeCharArray(atimes, numtimes);
+    msFree(pszBuffer);
+    return MS_FALSE;
+  }
+
+  msFreeCharArray(atimes, numtimes);
+
+  /* load the string to the filter */
+  if (pszBuffer && strlen(pszBuffer) > 0) {
+    if (lp->filter.string &&
+        (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION))
+      pszBuffer = msStringConcatenate(pszBuffer, ")");
+    /*
+    if(lp->filteritem)
+      free(lp->filteritem);
+    lp->filteritem = msStrdup(timefield);
+    */
+
+    msLoadExpressionString(&lp->filter, pszBuffer);
+  }
+  msFree(pszBuffer);
+  return MS_TRUE;
+}
+
+/**
+  set the filter parameter for a time filter
+**/
+
+int msLayerSetTimeFilter(layerObj *layer, const char *timestring,
+                         const char *timefield) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerSetTimeFilter(layer, timestring, timefield);
+}
+
+int msLayerMakeBackticsTimeFilter(layerObj *lp, const char *timestring,
+                                  const char *timefield) {
+  return makeTimeFilter(lp, timestring, timefield, MS_TRUE);
+}
+
+int msLayerMakePlainTimeFilter(layerObj *lp, const char *timestring,
+                               const char *timefield) {
+  return makeTimeFilter(lp, timestring, timefield, MS_FALSE);
+}
+
+/*
+ * Dummies / default actions for layers
+ */
+int LayerDefaultInitItemInfo(layerObj *layer) {
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+void LayerDefaultFreeItemInfo(layerObj *layer) { (void)layer; }
+
+int LayerDefaultOpen(layerObj *layer) {
+  (void)layer;
+  return MS_FAILURE;
+}
+
+int LayerDefaultIsOpen(layerObj *layer) {
+  (void)layer;
+  return MS_FALSE;
+}
+
+int LayerDefaultWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  (void)layer;
+  (void)rect;
+  (void)isQuery;
+  return MS_SUCCESS;
+}
+
+int LayerDefaultNextShape(layerObj *layer, shapeObj *shape) {
+  (void)layer;
+  (void)shape;
+  return MS_FAILURE;
+}
+
+int LayerDefaultGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  (void)layer;
+  (void)shape;
+  (void)record;
+  return MS_FAILURE;
+}
+
+int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect,
+                              projectionObj *rectProjection) {
+  int status;
+  shapeObj shape, searchshape;
+  int nShapeCount = 0;
+  rectObj searchrect = rect;
+  reprojectionObj *reprojector = NULL;
+
+  msInitShape(&searchshape);
+  msRectToPolygon(searchrect, &searchshape);
+
+  if (rectProjection != NULL) {
+    if (layer->project &&
+        msProjectionsDiffer(&(layer->projection), rectProjection))
+      msProjectRect(rectProjection, &(layer->projection),
+                    &searchrect); /* project the searchrect to source coords */
+    else
+      layer->project = MS_FALSE;
+  }
+
+  status = msLayerWhichShapes(layer, searchrect, MS_TRUE);
+  if (status == MS_FAILURE) {
+    msFreeShape(&searchshape);
+    return -1;
+  } else if (status == MS_DONE) {
+    msFreeShape(&searchshape);
+    return 0;
+  }
+
+  msInitShape(&shape);
+  while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+    if (rectProjection != NULL) {
+      if (layer->project &&
+          msProjectionsDiffer(&(layer->projection), rectProjection)) {
+        if (reprojector == NULL)
+          reprojector =
+              msProjectCreateReprojector(&(layer->projection), rectProjection);
+        if (reprojector)
+          msProjectShapeEx(reprojector, &shape);
+      } else
+        layer->project = MS_FALSE;
+
+      if (msRectContained(&shape.bounds, &rect) ==
+          MS_TRUE) { /* if the whole shape is in, don't intersect */
+        status = MS_TRUE;
+      } else {
+        switch (shape.type) { /* make sure shape actually intersects the qrect
+                                 (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
+        case MS_SHAPE_POINT:
+          status = msIntersectMultipointPolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_LINE:
+          status = msIntersectPolylinePolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_POLYGON:
+          status = msIntersectPolygons(&shape, &searchshape);
+          break;
+        default:
+          break;
+        }
+      }
+    } else
+      status = MS_TRUE;
+
+    if (status == MS_TRUE)
+      nShapeCount++;
+    msFreeShape(&shape);
+    if (layer->maxfeatures > 0 && layer->maxfeatures == nShapeCount)
+      break;
+  }
+
+  msFreeShape(&searchshape);
+  msProjectDestroyReprojector(reprojector);
+
+  return nShapeCount;
+}
+
+int LayerDefaultClose(layerObj *layer) {
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+int LayerDefaultGetItems(layerObj *layer) {
+  (void)layer;
+  return MS_SUCCESS; /* returning no items is legit */
+}
+
+int msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                     int iLayerIndex) {
+  return FLTLayerApplyCondSQLFilterToLayer(psNode, map, iLayerIndex);
+}
+
+int msLayerSupportsPaging(layerObj *layer) {
+  if (layer && ((layer->connectiontype == MS_ORACLESPATIAL) ||
+                (layer->connectiontype == MS_POSTGIS)))
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                   int iLayerIndex);
+
+/*
+ * msLayerSupportsSorting()
+ *
+ * Returns MS_TRUE if the layer supports sorting/ordering.
+ */
+int msLayerSupportsSorting(layerObj *layer) {
+  if (layer &&
+      ((layer->connectiontype == MS_OGR) ||
+       (layer->connectiontype == MS_POSTGIS) ||
+       (layer->connectiontype == MS_ORACLESPATIAL) ||
+       ((layer->connectiontype == MS_PLUGIN) &&
+        (strstr(layer->plugin_library, "msplugin_oracle") != NULL)) ||
+       ((layer->connectiontype == MS_PLUGIN) &&
+        (strstr(layer->plugin_library, "msplugin_mssql2008") != NULL))))
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+/*
+ * msLayerSetSort()
+ *
+ * Copy the sortBy clause passed as an argument into the layer sortBy member.
+ */
+void msLayerSetSort(layerObj *layer, const sortByClause *sortBy) {
+  int i;
+  for (i = 0; i < layer->sortBy.nProperties; i++)
+    msFree(layer->sortBy.properties[i].item);
+  msFree(layer->sortBy.properties);
+
+  layer->sortBy.nProperties = sortBy->nProperties;
+  layer->sortBy.properties = (sortByProperties *)msSmallMalloc(
+      sortBy->nProperties * sizeof(sortByProperties));
+  for (i = 0; i < layer->sortBy.nProperties; i++) {
+    layer->sortBy.properties[i].item = msStrdup(sortBy->properties[i].item);
+    layer->sortBy.properties[i].sortOrder = sortBy->properties[i].sortOrder;
+  }
+}
+
+/*
+ * msLayerBuildSQLOrderBy()
+ *
+ * Returns the content of a SQL ORDER BY clause from the sortBy member of
+ * the layer. The string does not contain the "ORDER BY" keywords itself.
+ */
+char *msLayerBuildSQLOrderBy(layerObj *layer) {
+  char *strOrderBy = NULL;
+  if (layer->sortBy.nProperties > 0) {
+    int i;
+    for (i = 0; i < layer->sortBy.nProperties; i++) {
+      char *escaped =
+          msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
+      if (i > 0)
+        strOrderBy = msStringConcatenate(strOrderBy, ", ");
+      strOrderBy = msStringConcatenate(strOrderBy, escaped);
+      if (layer->sortBy.properties[i].sortOrder == SORT_DESC)
+        strOrderBy = msStringConcatenate(strOrderBy, " DESC");
+      msFree(escaped);
+    }
+  }
+  return strOrderBy;
+}
+
+int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                   int iLayerIndex) {
+  return FLTLayerApplyPlainFilterToLayer(psNode, map, iLayerIndex);
+}
+
+int msLayerGetPaging(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "Unable to initialize virtual table",
+                 "msLayerGetPaging()");
+      return MS_FAILURE;
+    }
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerGetPaging(layer);
+}
+
+void msLayerEnablePaging(layerObj *layer, int value) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "Unable to initialize virtual table",
+                 "msLayerEnablePaging()");
+      return;
+    }
+  }
+  cppcheck_assert(layer->vtable);
+  layer->vtable->LayerEnablePaging(layer, value);
+}
+
+/** Returns a cached reprojector from the layer projection to the map projection
+ */
+reprojectionObj *msLayerGetReprojectorToMap(layerObj *layer, mapObj *map) {
+  if (layer->reprojectorLayerToMap != NULL &&
+      !msProjectIsReprojectorStillValid(layer->reprojectorLayerToMap)) {
+    msProjectDestroyReprojector(layer->reprojectorLayerToMap);
+    layer->reprojectorLayerToMap = NULL;
+  }
+
+  if (layer->reprojectorLayerToMap == NULL) {
+    layer->reprojectorLayerToMap =
+        msProjectCreateReprojector(&layer->projection, &map->projection);
+  }
+  return layer->reprojectorLayerToMap;
+}
+
+int LayerDefaultGetExtent(layerObj *layer, rectObj *extent) {
+  (void)layer;
+  (void)extent;
+  return MS_FAILURE;
+}
+
+int LayerDefaultGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                             shapeObj *shape) {
+  (void)map;
+  (void)layer;
+  (void)c;
+  (void)shape;
+  msSetError(MS_MISCERR, "'STYLEITEM AUTO' not supported for this data source.",
+             "msLayerGetAutoStyle()");
+  return MS_FAILURE;
+}
+
+int LayerDefaultCloseConnection(layerObj *layer) {
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+int LayerDefaultCreateItems(layerObj *layer, const int nt) {
+  if (nt > 0) {
+    layer->items = (char **)calloc(
+        nt, sizeof(char *)); /* should be more than enough space */
+    MS_CHECK_ALLOC(layer->items, sizeof(char *), MS_FAILURE);
+
+    layer->numitems = 0;
+  }
+  return MS_SUCCESS;
+}
+
+int LayerDefaultGetNumFeatures(layerObj *layer) {
+  rectObj extent;
+  int status;
+  int result;
+  shapeObj shape;
+
+  /* calculate layer extent */
+  if (!MS_VALID_EXTENT(layer->extent)) {
+    if (msLayerGetExtent(layer, &extent) != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "Unable to get layer extent",
+                 "LayerDefaultGetNumFeatures()");
+      return -1;
+    }
+  } else
+    extent = layer->extent;
+
+  /* Cleanup any previous item selection */
+  msLayerFreeItemInfo(layer);
+  if (layer->items) {
+    msFreeCharArray(layer->items, layer->numitems);
+    layer->items = NULL;
+    layer->numitems = 0;
+  }
+
+  status = msLayerWhichShapes(layer, extent, MS_FALSE);
+  if (status == MS_DONE) { /* no overlap */
+    return 0;
+  } else if (status != MS_SUCCESS) {
+    return -1;
+  }
+
+  result = 0;
+  while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+    ++result;
+    msFreeShape(&shape);
+  }
+
+  return result;
+}
+
+int LayerDefaultAutoProjection(layerObj *layer, projectionObj *projection) {
+  (void)layer;
+  (void)projection;
+  msSetError(MS_MISCERR,
+             "This data driver does not implement AUTO projection support",
+             "LayerDefaultAutoProjection()");
+  return MS_FAILURE;
+}
+
+int LayerDefaultSupportsCommonFilters(layerObj *layer) {
+  (void)layer;
+  return MS_FALSE;
+}
+
+int LayerDefaultTranslateFilter(layerObj *layer, expressionObj *filter,
+                                char *filteritem) {
+  (void)layer;
+  (void)filteritem;
+  if (!filter->string)
+    return MS_SUCCESS; /* nothing to do, not an error */
+
+  msSetError(MS_MISCERR,
+             "This data driver does not implement filter translation support",
+             "LayerDefaultTranslateFilter()");
+  return MS_FAILURE;
+}
+
+int msLayerDefaultGetPaging(layerObj *layer) {
+  (void)layer;
+  return MS_FALSE;
+}
+
+void msLayerDefaultEnablePaging(layerObj *layer, int value) {
+  (void)layer;
+  (void)value;
+}
+
+/************************************************************************/
+/*                          LayerDefaultEscapeSQLParam                  */
+/*                                                                      */
+/*      Default function used to escape strings and avoid sql           */
+/*      injection. Specific drivers should redefine if an escaping      */
+/*      function is available in the driver.                            */
+/************************************************************************/
+char *LayerDefaultEscapeSQLParam(layerObj *layer, const char *pszString) {
+  (void)layer;
+  char *pszEscapedStr = NULL;
+  if (pszString) {
+    int nSrcLen;
+    char c;
+    int i = 0, j = 0;
+    nSrcLen = (int)strlen(pszString);
+    pszEscapedStr = (char *)msSmallMalloc(2 * nSrcLen + 1);
+    for (i = 0, j = 0; i < nSrcLen; i++) {
+      c = pszString[i];
+      if (c == '\'') {
+        pszEscapedStr[j++] = '\'';
+        pszEscapedStr[j++] = '\'';
+      } else if (c == '\\') {
+        pszEscapedStr[j++] = '\\';
+        pszEscapedStr[j++] = '\\';
+      } else
+        pszEscapedStr[j++] = c;
+    }
+    pszEscapedStr[j] = 0;
+  }
+  return pszEscapedStr;
+}
+
+/************************************************************************/
+/*                          LayerDefaultEscapePropertyName              */
+/*                                                                      */
+/*      Return the property name in a properly escaped and quoted form. */
+/************************************************************************/
+char *LayerDefaultEscapePropertyName(layerObj *layer, const char *pszString) {
+  char *pszEscapedStr = NULL;
+  int i, j = 0;
+
+  if (layer && pszString && strlen(pszString) > 0) {
+    int nLength = strlen(pszString);
+
+    pszEscapedStr = (char *)msSmallMalloc(1 + 2 * nLength + 1 + 1);
+    pszEscapedStr[j++] = '"';
+
+    for (i = 0; i < nLength; i++) {
+      char c = pszString[i];
+      if (c == '"') {
+        pszEscapedStr[j++] = '"';
+        pszEscapedStr[j++] = '"';
+      } else if (c == '\\') {
+        pszEscapedStr[j++] = '\\';
+        pszEscapedStr[j++] = '\\';
+      } else
+        pszEscapedStr[j++] = c;
+    }
+    pszEscapedStr[j++] = '"';
+    pszEscapedStr[j++] = 0;
+  }
+  return pszEscapedStr;
+}
+
+/*
+ * msConnectLayer
+ *
+ * This will connect layer object to the new layer type.
+ * Caller is responsible to close previous layer correctly.
+ * For Internal types the library_str is ignored, for PLUGIN it's
+ * define what plugin to use. Returns MS_FAILURE or MS_SUCCESS.
+ */
+int msConnectLayer(layerObj *layer, const int connectiontype,
+                   const char *library_str) {
+  layer->connectiontype = connectiontype;
+  /* For internal types, library_str is ignored */
+  if (connectiontype == MS_PLUGIN) {
+    int rv;
+
+    msFree(layer->plugin_library_original);
+    layer->plugin_library_original = msStrdup(library_str);
+
+    rv = msBuildPluginLibraryPath(&layer->plugin_library,
+                                  layer->plugin_library_original, layer->map);
+    if (rv != MS_SUCCESS) {
+      return rv;
+    }
+  }
+  return msInitializeVirtualTable(layer);
+}
+
+static int populateVirtualTable(layerVTableObj *vtable) {
+  assert(vtable != NULL);
+
+  vtable->LayerSupportsCommonFilters = LayerDefaultSupportsCommonFilters;
+  vtable->LayerTranslateFilter = LayerDefaultTranslateFilter;
+
+  vtable->LayerInitItemInfo = LayerDefaultInitItemInfo;
+  vtable->LayerFreeItemInfo = LayerDefaultFreeItemInfo;
+  vtable->LayerOpen = LayerDefaultOpen;
+  vtable->LayerIsOpen = LayerDefaultIsOpen;
+  vtable->LayerWhichShapes = LayerDefaultWhichShapes;
+
+  vtable->LayerNextShape = LayerDefaultNextShape;
+  /* vtable->LayerResultsGetShape = LayerDefaultResultsGetShape; */
+  vtable->LayerGetShape = LayerDefaultGetShape;
+  vtable->LayerGetShapeCount = LayerDefaultGetShapeCount;
+  vtable->LayerClose = LayerDefaultClose;
+  vtable->LayerGetItems = LayerDefaultGetItems;
+  vtable->LayerGetExtent = LayerDefaultGetExtent;
+
+  vtable->LayerGetAutoStyle = LayerDefaultGetAutoStyle;
+  vtable->LayerCloseConnection = LayerDefaultCloseConnection;
+  vtable->LayerSetTimeFilter = msLayerMakePlainTimeFilter;
+
+  vtable->LayerApplyFilterToLayer = msLayerApplyPlainFilterToLayer;
+
+  vtable->LayerCreateItems = LayerDefaultCreateItems;
+
+  vtable->LayerGetNumFeatures = LayerDefaultGetNumFeatures;
+
+  vtable->LayerGetAutoProjection = LayerDefaultAutoProjection;
+
+  vtable->LayerEscapeSQLParam = LayerDefaultEscapeSQLParam;
+
+  vtable->LayerEscapePropertyName = LayerDefaultEscapePropertyName;
+
+  vtable->LayerEnablePaging = msLayerDefaultEnablePaging;
+  vtable->LayerGetPaging = msLayerDefaultGetPaging;
+
+  return MS_SUCCESS;
+}
+
+static int createVirtualTable(layerVTableObj **vtable) {
+  *vtable = malloc(sizeof(**vtable));
+  MS_CHECK_ALLOC(*vtable, sizeof(**vtable), MS_FAILURE);
+
+  return populateVirtualTable(*vtable);
+}
+
+static int destroyVirtualTable(layerVTableObj **vtable) {
+  memset(*vtable, 0, sizeof(**vtable));
+  msFree(*vtable);
+  *vtable = NULL;
+  return MS_SUCCESS;
+}
+
+int msInitializeVirtualTable(layerObj *layer) {
+  if (layer->vtable) {
+    destroyVirtualTable(&layer->vtable);
+  }
+  createVirtualTable(&layer->vtable);
+
+  if (layer->features && layer->connectiontype != MS_GRATICULE)
+    layer->connectiontype = MS_INLINE;
+
+  if (layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
+    layer->connectiontype = MS_TILED_SHAPEFILE;
+
+  if (layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS &&
+      layer->connectiontype != MS_KERNELDENSITY)
+    layer->connectiontype = MS_RASTER;
+
+  switch (layer->connectiontype) {
+  case (MS_INLINE):
+    return (msINLINELayerInitializeVirtualTable(layer));
+    break;
+  case (MS_SHAPEFILE):
+    return (msSHPLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_TILED_SHAPEFILE):
+    return (msTiledSHPLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_OGR):
+    return (msOGRLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_FLATGEOBUF):
+    return (msFlatGeobufLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_POSTGIS):
+    return (msPostGISLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_WMS):
+    /* WMS should be treated as a raster layer */
+    return (msRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_KERNELDENSITY):
+    /* KERNELDENSITY should be treated as a raster layer */
+    return (msRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_ORACLESPATIAL):
+    return (msOracleSpatialLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_WFS):
+    return (msWFSLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_GRATICULE):
+    return (msGraticuleLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_RASTER):
+    return (msRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_PLUGIN):
+    return (msPluginLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_UNION):
+    return (msUnionLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_UVRASTER):
+    return (msUVRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_CONTOUR):
+    return (msContourLayerInitializeVirtualTable(layer));
+    break;
+  default:
+    msSetError(MS_MISCERR, "Unknown connectiontype, it was %d",
+               "msInitializeVirtualTable()", layer->connectiontype);
+    return MS_FAILURE;
+    break;
+  }
+
+  /* not reached */
+  return MS_FAILURE;
+}
+
+/*
+ * INLINE: Virtual table functions
+ */
+
+typedef struct {
+  rectObj searchrect;
+  int is_relative; /* relative coordinates? */
+} msINLINELayerInfo;
+
+int msINLINELayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return (MS_TRUE);
+  else
+    return (MS_FALSE);
+}
+
+msINLINELayerInfo *msINLINECreateLayerInfo(void) {
+  msINLINELayerInfo *layerinfo = msSmallMalloc(sizeof(msINLINELayerInfo));
+  layerinfo->searchrect.minx = -1.0;
+  layerinfo->searchrect.miny = -1.0;
+  layerinfo->searchrect.maxx = -1.0;
+  layerinfo->searchrect.maxy = -1.0;
+  layerinfo->is_relative = MS_FALSE;
+  return layerinfo;
+}
+
+int msINLINELayerOpen(layerObj *layer) {
+  msINLINELayerInfo *layerinfo;
+
+  if (layer->layerinfo) {
+    if (layer->debug) {
+      msDebug("msINLINELayerOpen: Layer is already open!\n");
+    }
+    return MS_SUCCESS; /* already open */
+  }
+
+  /*
+  ** Initialize the layerinfo
+  **/
+  layerinfo = msINLINECreateLayerInfo();
+
+  layer->currentfeature =
+      layer->features; /* point to the begining of the feature list */
+
+  layer->layerinfo = (void *)layerinfo;
+
+  return (MS_SUCCESS);
+}
+
+int msINLINELayerClose(layerObj *layer) {
+  if (layer->layerinfo) {
+    free(layer->layerinfo);
+    layer->layerinfo = NULL;
+  }
+
+  return MS_SUCCESS;
+}
+
+int msINLINELayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  (void)isQuery;
+  msINLINELayerInfo *layerinfo = NULL;
+  layerinfo = (msINLINELayerInfo *)layer->layerinfo;
+
+  layerinfo->searchrect = rect;
+  layerinfo->is_relative =
+      (layer->transform != MS_FALSE && layer->transform != MS_TRUE);
+
+  return MS_SUCCESS;
+}
+
+/* Author: Cristoph Spoerri and Sean Gillies */
+int msINLINELayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  int i = 0;
+  featureListNodeObjPtr current;
+
+  int shapeindex = record->shapeindex; /* only index necessary */
+
+  current = layer->features;
+  while (current != NULL && i != shapeindex) {
+    i++;
+    current = current->next;
+  }
+  if (current == NULL) {
+    msSetError(MS_SHPERR, "No inline feature with this index.",
+               "msINLINELayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  if (msCopyShape(&(current->shape), shape) != MS_SUCCESS) {
+    msSetError(
+        MS_SHPERR,
+        "Cannot retrieve inline shape. There some problem with the shape",
+        "msINLINELayerGetShape()");
+    return MS_FAILURE;
+  }
+  /* check for the expected size of the values array */
+  if (layer->numitems > shape->numvalues) {
+    shape->values = (char **)msSmallRealloc(shape->values,
+                                            sizeof(char *) * (layer->numitems));
+    for (i = shape->numvalues; i < layer->numitems; i++)
+      shape->values[i] = msStrdup("");
+  }
+  msComputeBounds(shape);
+  return MS_SUCCESS;
+}
+
+int msINLINELayerNextShape(layerObj *layer, shapeObj *shape) {
+  msINLINELayerInfo *layerinfo = NULL;
+  shapeObj *s;
+
+  layerinfo = (msINLINELayerInfo *)layer->layerinfo;
+
+  while (1) {
+
+    if (!(layer->currentfeature)) {
+      /* out of features */
+      return (MS_DONE);
+    }
+
+    s = &(layer->currentfeature->shape);
+    layer->currentfeature = layer->currentfeature->next;
+    msComputeBounds(s);
+
+    if (layerinfo->is_relative ||
+        msRectOverlap(&s->bounds, &layerinfo->searchrect)) {
+
+      msCopyShape(s, shape);
+
+      /* check for the expected size of the values array */
+      if (layer->numitems > shape->numvalues) {
+        int i;
+        shape->values = (char **)msSmallRealloc(
+            shape->values, sizeof(char *) * (layer->numitems));
+        for (i = shape->numvalues; i < layer->numitems; i++)
+          shape->values[i] = msStrdup("");
+        shape->numvalues = layer->numitems;
+      }
+
+      break;
+    }
+  }
+
+  return (MS_SUCCESS);
+}
+
+int msINLINELayerGetNumFeatures(layerObj *layer) {
+  int i = 0;
+  featureListNodeObjPtr current;
+
+  current = layer->features;
+  while (current != NULL) {
+    i++;
+    current = current->next;
+  }
+  return i;
+}
+
+/*
+Returns an escaped string
+*/
+char *msLayerEscapeSQLParam(layerObj *layer, const char *pszString) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return "";
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerEscapeSQLParam(layer, pszString);
+}
+
+char *msLayerEscapePropertyName(layerObj *layer, const char *pszString) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return "";
+  }
+  cppcheck_assert(layer->vtable);
+  return layer->vtable->LayerEscapePropertyName(layer, pszString);
+}
+
+int msINLINELayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  /* layer->vtable->LayerInitItemInfo, use default */
+  /* layer->vtable->LayerFreeItemInfo, use default */
+  layer->vtable->LayerOpen = msINLINELayerOpen;
+  layer->vtable->LayerIsOpen = msINLINELayerIsOpen;
+  layer->vtable->LayerWhichShapes = msINLINELayerWhichShapes;
+  layer->vtable->LayerNextShape = msINLINELayerNextShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerGetShape = msINLINELayerGetShape;
+  layer->vtable->LayerClose = msINLINELayerClose;
+  /* layer->vtable->LayerGetItems, use default */
+
+  /*
+   * Original code contained following
+   * TODO: need to compute extents
+   */
+  /* layer->vtable->LayerGetExtent, use default */
+
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerCloseConnection, use default */
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+
+  /* layer->vtable->LayerCreateItems, use default */
+  layer->vtable->LayerGetNumFeatures = msINLINELayerGetNumFeatures;
+
+  /*layer->vtable->LayerEscapeSQLParam, use default*/
+  /*layer->vtable->LayerEscapePropertyName, use default*/
+
+  /* layer->vtable->LayerEnablePaging, use default */
+  /* layer->vtable->LayerGetPaging, use default */
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/maplegend.c 8.2.0~beta1-1~exp1/src/maplegend.c
--- 8.0.1-5/src/maplegend.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maplegend.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1084 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Legend generation.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+
+#define PSF .8
+#define VMARGIN 5 /* margin at top and bottom of legend graphic */
+#define HMARGIN 5 /* margin at left and right of legend graphic */
+
+static int msDrawGradientSymbol(rendererVTableObj *renderer,
+                                imageObj *image_draw, double x_center,
+                                double y_center, int width, int height,
+                                styleObj *style) {
+  unsigned char *r, *g, *b, *a;
+  symbolObj symbol;
+  rasterBufferObj *rb;
+  symbolStyleObj symbolStyle;
+  int ret;
+
+  initSymbol(&symbol);
+  rb = (rasterBufferObj *)calloc(1, sizeof(rasterBufferObj));
+  symbol.pixmap_buffer = rb;
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->width = width;
+  rb->height = height;
+  rb->data.rgba.row_step = rb->width * 4;
+  rb->data.rgba.pixel_step = 4;
+  rb->data.rgba.pixels = (unsigned char *)malloc(sizeof(unsigned char) *
+                                                 rb->width * rb->height * 4);
+  b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
+  g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
+  r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
+  a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
+  for (unsigned j = 0; j < rb->height; j++) {
+    for (unsigned i = 0; i < rb->width; i++) {
+      msValueToRange(style,
+                     style->minvalue + (double)i / rb->width *
+                                           (style->maxvalue - style->minvalue),
+                     MS_COLORSPACE_RGB);
+      b[4 * (j * rb->width + i)] = style->color.blue;
+      g[4 * (j * rb->width + i)] = style->color.green;
+      r[4 * (j * rb->width + i)] = style->color.red;
+      a[4 * (j * rb->width + i)] = style->color.alpha;
+    }
+  }
+  INIT_SYMBOL_STYLE(symbolStyle);
+  ret = renderer->renderPixmapSymbol(image_draw, x_center, y_center, &symbol,
+                                     &symbolStyle);
+  msFreeSymbol(&symbol);
+  return ret;
+}
+
+/*
+ * generic function for drawing a legend icon. (added for bug #2348)
+ * renderer specific drawing functions shouldn't be called directly, but through
+ * this function
+ */
+int msDrawLegendIcon(mapObj *map, layerObj *lp, classObj *theclass, int width,
+                     int height, imageObj *image, int dstX, int dstY,
+                     int scale_independant, class_hittest *hittest) {
+  int i, type, hasmarkersymbol, ret = MS_SUCCESS;
+  double offset;
+  double polygon_contraction =
+      0.5; /* used to account for the width of a polygon's outline */
+  shapeObj box, zigzag;
+  lineObj box_line, zigzag_line;
+  pointObj box_point[5], zigzag_point[4];
+  pointObj marker;
+  char szPath[MS_MAXPATHLEN];
+  styleObj outline_style;
+  imageObj *image_draw = image;
+  rendererVTableObj *renderer;
+  outputFormatObj *transFormat = NULL, *altFormat = NULL;
+  const char *alternativeFormatString = NULL;
+
+  if (!MS_RENDERER_PLUGIN(image->format)) {
+    msSetError(MS_MISCERR, "unsupported image format", "msDrawLegendIcon()");
+    return MS_FAILURE;
+  }
+
+  alternativeFormatString = msLayerGetProcessingKey(lp, "RENDERER");
+  if (MS_RENDERER_PLUGIN(image_draw->format) &&
+      alternativeFormatString != NULL &&
+      (altFormat = msSelectOutputFormat(map, alternativeFormatString))) {
+    msInitializeRendererVTable(altFormat);
+
+    image_draw = msImageCreate(
+        image->width, image->height, altFormat, image->imagepath,
+        image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
+    image_draw->map = map;
+    renderer = MS_IMAGE_RENDERER(image_draw);
+  } else {
+    renderer = MS_IMAGE_RENDERER(image_draw);
+    if (lp->compositer && renderer->compositeRasterBuffer) {
+      image_draw = msImageCreate(image->width, image->height, image->format,
+                                 image->imagepath, image->imageurl,
+                                 map->resolution, map->defresolution, NULL);
+      if (!image_draw) {
+        msSetError(MS_MISCERR,
+                   "Unable to initialize temporary transparent image.",
+                   "msDrawLegendIcon()");
+        return (MS_FAILURE);
+      }
+      image_draw->map = map;
+    }
+  }
+
+  if (renderer->supports_clipping && MS_VALID_COLOR(map->legend.outlinecolor)) {
+    /* keep GD specific code here for now as it supports clipping */
+    rectObj clip;
+    clip.maxx = dstX + width - 1;
+    clip.maxy = dstY + height - 1;
+    clip.minx = dstX;
+    clip.miny = dstY;
+    renderer->setClip(image_draw, clip);
+  }
+
+  /* if the class has a keyimage, treat it as a point layer
+   * (the keyimage will be treated there) */
+  if (theclass->keyimage != NULL) {
+    type = MS_LAYER_POINT;
+  } else {
+    /* some polygon layers may be better drawn using zigzag if there is no fill
+     */
+    type = lp->type;
+    if (type == MS_LAYER_POLYGON) {
+      type = MS_LAYER_LINE;
+      for (i = 0; i < theclass->numstyles; i++) {
+        if (MS_VALID_COLOR(theclass->styles[i]->color)) { /* there is a fill */
+          type = MS_LAYER_POLYGON;
+        }
+        if (MS_VALID_COLOR(
+                theclass->styles[i]->outlinecolor)) { /* there is an outline */
+          polygon_contraction =
+              MS_MAX(polygon_contraction, theclass->styles[i]->width / 2.0);
+        }
+      }
+    }
+  }
+
+  /* initialize the box used for polygons and for outlines */
+  msInitShape(&box);
+  box.line = &box_line;
+  box.numlines = 1;
+  box.line[0].point = box_point;
+  box.line[0].numpoints = 5;
+  box.type = MS_SHAPE_POLYGON;
+
+  box.line[0].point[0].x = dstX + polygon_contraction;
+  box.line[0].point[0].y = dstY + polygon_contraction;
+  box.line[0].point[1].x = dstX + width - polygon_contraction;
+  box.line[0].point[1].y = dstY + polygon_contraction;
+  box.line[0].point[2].x = dstX + width - polygon_contraction;
+  box.line[0].point[2].y = dstY + height - polygon_contraction;
+  box.line[0].point[3].x = dstX + polygon_contraction;
+  box.line[0].point[3].y = dstY + height - polygon_contraction;
+  box.line[0].point[4].x = box.line[0].point[0].x;
+  box.line[0].point[4].y = box.line[0].point[0].y;
+
+  /*
+  ** now draw the appropriate color/symbol/size combination
+  */
+
+  /* Scalefactor will be infinity when SIZEUNITS is set in LAYER */
+  if (lp->sizeunits != MS_PIXELS) {
+    lp->scalefactor = 1.0;
+  }
+
+  switch (type) {
+  case MS_LAYER_POINT:
+    marker.x = dstX + MS_NINT(width / 2.0);
+    marker.y = dstY + MS_NINT(height / 2.0);
+    if (theclass->keyimage != NULL) {
+      int symbolNum;
+      styleObj imgStyle;
+      symbolObj *symbol = NULL;
+      symbolNum =
+          msAddImageSymbol(&(map->symbolset), msBuildPath(szPath, map->mappath,
+                                                          theclass->keyimage));
+      if (symbolNum == -1) {
+        msSetError(MS_IMGERR, "Failed to open legend key image",
+                   "msCreateLegendIcon()");
+        return (MS_FAILURE);
+      }
+
+      symbol = map->symbolset.symbol[symbolNum];
+
+      initStyle(&imgStyle);
+      /*set size so that symbol will be scaled properly #3296*/
+      if (width / symbol->sizex < height / symbol->sizey)
+        imgStyle.size = symbol->sizey * (width / symbol->sizex);
+      else
+        imgStyle.size = symbol->sizey * (height / symbol->sizey);
+
+      if (imgStyle.size > imgStyle.maxsize)
+        imgStyle.maxsize = imgStyle.size;
+
+      imgStyle.symbol = symbolNum;
+      ret = msDrawMarkerSymbol(map, image_draw, &marker, &imgStyle, 1.0);
+      if (MS_UNLIKELY(ret == MS_FAILURE))
+        goto legend_icon_cleanup;
+      /* TO DO: we may want to handle this differently depending on the relative
+       * size of the keyimage */
+    } else {
+      for (i = 0; i < theclass->numstyles; i++) {
+        if (!scale_independant && map->scaledenom > 0) {
+          styleObj *lp = theclass->styles[i];
+          if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+            continue;
+          if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+            continue;
+        }
+        if (hittest && hittest->stylehits[i].status == 0)
+          continue;
+        ret = msDrawMarkerSymbol(map, image_draw, &marker, theclass->styles[i],
+                                 lp->scalefactor * image->resolutionfactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      }
+    }
+    break;
+  case MS_LAYER_LINE:
+    offset = 1;
+    /* To set the offset, we only check the size/width parameter of the first
+     * style */
+    if (theclass->numstyles > 0) {
+      if (theclass->styles[0]->symbol > 0 &&
+          theclass->styles[0]->symbol < map->symbolset.numsymbols &&
+          map->symbolset.symbol[theclass->styles[0]->symbol]->type !=
+              MS_SYMBOL_SIMPLE)
+        offset = theclass->styles[0]->size / 2;
+      else
+        offset = theclass->styles[0]->width / 2;
+    }
+    msInitShape(&zigzag);
+    zigzag.line = &zigzag_line;
+    zigzag.numlines = 1;
+    zigzag.line[0].point = zigzag_point;
+    zigzag.line[0].numpoints = 4;
+    zigzag.type = MS_SHAPE_LINE;
+
+    zigzag.line[0].point[0].x = dstX + offset;
+    zigzag.line[0].point[0].y = dstY + height - offset;
+    zigzag.line[0].point[1].x = dstX + MS_NINT(width / 3.0) - 1;
+    zigzag.line[0].point[1].y = dstY + offset;
+    zigzag.line[0].point[2].x = dstX + MS_NINT(2.0 * width / 3.0) - 1;
+    zigzag.line[0].point[2].y = dstY + height - offset;
+    zigzag.line[0].point[3].x = dstX + width - offset;
+    zigzag.line[0].point[3].y = dstY + offset;
+
+    for (i = 0; i < theclass->numstyles; i++) {
+      if (!scale_independant && map->scaledenom > 0) {
+        styleObj *lp = theclass->styles[i];
+        if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+          continue;
+        if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+          continue;
+      }
+      if (hittest && hittest->stylehits[i].status == 0)
+        continue;
+      if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOINT ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+        if (theclass->styles[i]->outlinewidth > 0) {
+          /* Swap the style contents to render the outline first,
+           * and then restore the style to render the interior of the line
+           */
+          msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
+          ret =
+              msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i],
+                               lp->scalefactor * image_draw->resolutionfactor);
+          msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
+          if (MS_UNLIKELY(ret == MS_FAILURE))
+            goto legend_icon_cleanup;
+        }
+        ret = msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i],
+                               lp->scalefactor * image_draw->resolutionfactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      } else {
+        if (theclass->styles[i]->outlinewidth > 0) {
+          /* Swap the style contents to render the outline first,
+           * and then restore the style to render the interior of the line
+           */
+          msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
+          ret = msDrawTransformedShape(
+              map, image_draw, &zigzag, theclass->styles[i],
+              lp->scalefactor * image_draw->resolutionfactor);
+          msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
+          if (MS_UNLIKELY(ret == MS_FAILURE))
+            goto legend_icon_cleanup;
+        }
+        ret = msDrawTransformedShape(
+            map, image_draw, &zigzag, theclass->styles[i],
+            lp->scalefactor * image_draw->resolutionfactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      }
+    }
+
+    break;
+  case MS_LAYER_CIRCLE:
+  case MS_LAYER_RASTER:
+  case MS_LAYER_CHART:
+  case MS_LAYER_POLYGON:
+    for (i = 0; i < theclass->numstyles; i++) {
+      if (!scale_independant && map->scaledenom > 0) {
+        styleObj *lp = theclass->styles[i];
+        if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+          continue;
+        if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+          continue;
+      }
+      if (hittest && hittest->stylehits[i].status == 0)
+        continue;
+      if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOINT ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+
+        if (MS_VALID_COLOR(theclass->styles[i]->mincolor)) {
+          ret = msDrawGradientSymbol(
+              renderer, image_draw, dstX + width / 2., dstY + height / 2.0,
+              width - 2 * polygon_contraction, height - 2 * polygon_contraction,
+              theclass->styles[i]);
+        } else {
+          ret =
+              msDrawShadeSymbol(map, image_draw, &box, theclass->styles[i],
+                                lp->scalefactor * image_draw->resolutionfactor);
+        }
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      } else {
+        ret = msDrawTransformedShape(map, image_draw, &box, theclass->styles[i],
+                                     lp->scalefactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      }
+    }
+    break;
+  default:
+    return MS_FAILURE;
+    break;
+  } /* end symbol drawing */
+
+  /* handle label styles */
+  for (i = 0; i < theclass->numlabels; i++) {
+    labelObj *l = theclass->labels[i];
+    if (!scale_independant && map->scaledenom > 0) {
+      if (msScaleInBounds(map->scaledenom, l->minscaledenom,
+                          l->maxscaledenom)) {
+        int j;
+        for (j = 0; j < l->numstyles; j++) {
+          styleObj *s = l->styles[j];
+          marker.x = dstX + MS_NINT(width / 2.0);
+          marker.y = dstY + MS_NINT(height / 2.0);
+          if (s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
+            ret = msDrawMarkerSymbol(map, image_draw, &marker, s,
+                                     lp->scalefactor);
+            if (MS_UNLIKELY(ret == MS_FAILURE))
+              goto legend_icon_cleanup;
+          }
+        }
+      }
+    }
+  }
+
+  /* handle "pure" text layers, i.e. layers with no symbology */
+  hasmarkersymbol = 0;
+  if (theclass->numstyles == 0) {
+    for (i = 0; i < theclass->numlabels; i++) {
+      labelObj *l = theclass->labels[i];
+      if (!scale_independant && map->scaledenom > 0) {
+        if (msScaleInBounds(map->scaledenom, l->minscaledenom,
+                            l->maxscaledenom)) {
+          int j;
+          for (j = 0; j < l->numstyles; j++) {
+            styleObj *s = l->styles[j];
+            if (s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
+              hasmarkersymbol = 1;
+            }
+          }
+        }
+      }
+    }
+  } else {
+    hasmarkersymbol = 1;
+  }
+
+  if (!hasmarkersymbol && theclass->numlabels > 0) {
+    textSymbolObj ts;
+    pointObj textstartpt;
+    marker.x = dstX + MS_NINT(width / 2.0);
+    marker.y = dstY + MS_NINT(height / 2.0);
+    initTextSymbol(&ts);
+    msPopulateTextSymbolForLabelAndString(
+        &ts, theclass->labels[0], msStrdup("Az"),
+        lp->scalefactor * image_draw->resolutionfactor,
+        image_draw->resolutionfactor, duplicate_always);
+    ts.label->size = height - 1;
+    ts.rotation = 0;
+    ret = msComputeTextPath(map, &ts);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    textstartpt = get_metrics(&marker, MS_CC, ts.textpath, 0, 0, 0, 0, NULL);
+    ret = msDrawTextSymbol(map, image_draw, textstartpt, &ts);
+    freeTextSymbol(&ts);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+  }
+
+  /* handle an outline if necessary */
+  if (MS_VALID_COLOR(map->legend.outlinecolor)) {
+    initStyle(&outline_style);
+    outline_style.color = map->legend.outlinecolor;
+    ret = msDrawLineSymbol(map, image_draw, &box, &outline_style,
+                           image_draw->resolutionfactor);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    /* reset clipping rectangle */
+    if (renderer->supports_clipping)
+      renderer->resetClip(image_draw);
+  }
+
+  if (altFormat) {
+    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
+    rendererVTableObj *altrenderer = MS_IMAGE_RENDERER(image_draw);
+    rasterBufferObj rb;
+    memset(&rb, 0, sizeof(rasterBufferObj));
+
+    ret = altrenderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    ret = renderer->mergeRasterBuffer(
+        image, &rb, ((lp->compositer) ? lp->compositer->opacity * 0.01 : 1.0),
+        0, 0, 0, 0, rb.width, rb.height);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    /*
+     * hack to work around bug #3834: if we have use an alternate renderer, the
+     * symbolset may contain symbols that reference it. We want to remove those
+     * references before the altFormat is destroyed to avoid a segfault and/or a
+     * leak, and so the the main renderer doesn't pick the cache up thinking
+     * it's for him.
+     */
+    for (i = 0; i < map->symbolset.numsymbols; i++) {
+      if (map->symbolset.symbol[i] != NULL) {
+        symbolObj *s = map->symbolset.symbol[i];
+        if (s->renderer == altrenderer) {
+          altrenderer->freeSymbol(s);
+          s->renderer = NULL;
+        }
+      }
+    }
+
+  } else if (image != image_draw) {
+    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
+    rasterBufferObj rb;
+    memset(&rb, 0, sizeof(rasterBufferObj));
+
+    ret = renderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    ret = renderer->mergeRasterBuffer(
+        image, &rb, ((lp->compositer) ? lp->compositer->opacity * 0.01 : 1.0),
+        0, 0, 0, 0, rb.width, rb.height);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+
+    /* deref and possibly free temporary transparent output format.  */
+    msApplyOutputFormat(&transFormat, NULL, MS_NOOVERRIDE);
+  }
+
+legend_icon_cleanup:
+  if (image != image_draw) {
+    msFreeImage(image_draw);
+  }
+  return ret;
+}
+
+imageObj *msCreateLegendIcon(mapObj *map, layerObj *lp, classObj *class,
+                             int width, int height, int scale_independant) {
+  imageObj *image;
+  outputFormatObj *format = NULL;
+
+  rendererVTableObj *renderer = MS_MAP_RENDERER(map);
+
+  if (!renderer) {
+    msSetError(MS_MISCERR, "invalid map outputformat", "msCreateLegendIcon()");
+    return (NULL);
+  }
+
+  /* ensure we have an image format representing the options for the legend */
+  msApplyOutputFormat(&format, map->outputformat, map->legend.transparent);
+
+  image = msImageCreate(width, height, format, map->web.imagepath,
+                        map->web.imageurl, map->resolution, map->defresolution,
+                        &(map->legend.imagecolor));
+
+  /* drop this reference to output format */
+  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
+
+  if (image == NULL) {
+    msSetError(MS_IMGERR, "Unable to initialize image.",
+               "msCreateLegendIcon()");
+    return (NULL);
+  }
+  image->map = map;
+
+  /* Call drawLegendIcon with destination (0, 0) */
+  /* Return an empty image if lp==NULL || class=NULL  */
+  /* (If class is NULL draw the legend for all classes. Modifications done */
+  /* Fev 2004 by AY) */
+  if (lp) {
+    if (class) {
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msDrawLegendIcon(map, lp, class, width, height, image, 0,
+                                       0, scale_independant, NULL))) {
+        msFreeImage(image);
+        return NULL;
+      }
+    } else {
+      for (int i = 0; i < lp->numclasses; i++) {
+        if (MS_UNLIKELY(MS_FAILURE == msDrawLegendIcon(map, lp, lp->class[i],
+                                                       width, height, image, 0,
+                                                       0, scale_independant,
+                                                       NULL))) {
+          msFreeImage(image);
+          return NULL;
+        }
+      }
+    }
+  }
+  return image;
+}
+
+/*
+ * Calculates the optimal size for the legend. If the optional layerObj
+ * argument is given, the legend size will be calculated for only that
+ * layer. Otherwise, the legend size is calculated for all layers that
+ * are not MS_OFF or of MS_LAYER_QUERY type.
+ *
+ * Returns one of:
+ *   MS_SUCCESS
+ *   MS_FAILURE
+ */
+int msLegendCalcSize(mapObj *map, int scale_independent, int *size_x,
+                     int *size_y, int *layer_index, int num_layers,
+                     map_hittest *hittest, double resolutionfactor) {
+  int i, j;
+  int status, maxwidth = 0, nLegendItems = 0;
+  char *text;
+  layerObj *lp;
+  rectObj rect;
+  int current_layers = 0;
+
+  /* reset sizes */
+  *size_x = 0;
+  *size_y = 0;
+
+  /* enable scale-dependent calculations */
+  if (!scale_independent) {
+    map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+    status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                              map->resolution, &map->scaledenom);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  /*
+   * step through all map classes, and for each one that will be displayed
+   * calculate the label size
+   */
+  if (layer_index != NULL && num_layers > 0)
+    current_layers = num_layers;
+  else
+    current_layers = map->numlayers;
+
+  for (i = 0; i < current_layers; i++) {
+    int layerindex;
+    if (layer_index != NULL && num_layers > 0)
+      layerindex = layer_index[i];
+    else
+      layerindex = map->layerorder[i];
+
+    lp = (GET_LAYER(map, layerindex));
+
+    if ((lp->status == MS_OFF && (layer_index == NULL || num_layers <= 0)) ||
+        (lp->type == MS_LAYER_QUERY)) /* skip it */
+      continue;
+
+    if (hittest && hittest->layerhits[layerindex].status == 0)
+      continue;
+
+    if (!scale_independent && map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
+    }
+
+    for (j = lp->numclasses - 1; j >= 0; j--) {
+      textSymbolObj ts;
+      text = lp->class[j]->title
+                 ? lp->class[j]->title
+                 : lp->class[j]->name; /* point to the right legend text, title
+                                          takes precedence */
+      if (!text)
+        continue; /* skip it */
+
+      /* skip the class if the classgroup is defined */
+      if (lp->classgroup &&
+          (lp->class[j] -> group == NULL || strcasecmp(lp->class[j] -> group,
+                                                       lp -> classgroup) != 0))
+        continue;
+
+      /* verify class scale */
+      if (!scale_independent && map->scaledenom > 0) {
+        if ((lp->class[j] -> maxscaledenom > 0) &&
+            (map->scaledenom > lp->class[j] -> maxscaledenom))
+          continue;
+        if ((lp->class[j] -> minscaledenom > 0) &&
+            (map->scaledenom <= lp->class[j] -> minscaledenom))
+          continue;
+      }
+      if (hittest && hittest->layerhits[layerindex].classhits[j].status == 0)
+        continue;
+
+      if (*text) {
+        initTextSymbol(&ts);
+        msPopulateTextSymbolForLabelAndString(&ts, &map->legend.label,
+                                              msStrdup(text), resolutionfactor,
+                                              resolutionfactor, 0);
+        if (MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map, &ts, &rect))) {
+          freeTextSymbol(&ts);
+          return MS_FAILURE;
+        }
+        freeTextSymbol(&ts);
+
+        maxwidth = MS_MAX(maxwidth, MS_NINT(rect.maxx - rect.minx));
+        *size_y += MS_MAX(MS_NINT(rect.maxy - rect.miny), map->legend.keysizey);
+      } else {
+        *size_y += map->legend.keysizey;
+      }
+      nLegendItems++;
+    }
+  }
+
+  /* Calculate the size of the legend: */
+  /*   - account for the Y keyspacing */
+  *size_y += (2 * VMARGIN) + ((nLegendItems - 1) * map->legend.keyspacingy);
+  /*   - determine the legend width */
+  *size_x =
+      (2 * HMARGIN) + maxwidth + map->legend.keyspacingx + map->legend.keysizex;
+
+  if (*size_y <= 0 || *size_x <= 0)
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+/*
+** Creates a GD image of a legend for a specific map. msDrawLegend()
+** respects the current scale, and classes without a name are not
+** added to the legend.
+**
+** scale_independent is used for WMS GetLegendGraphic. It should be set to
+** MS_FALSE in most cases. If it is set to MS_TRUE then the layers' minscale
+** and maxscale are ignored and layers that are currently out of scale still
+** show up in the legend.
+*/
+imageObj *msDrawLegend(mapObj *map, int scale_independent,
+                       map_hittest *hittest) {
+  int i, j, ret = MS_SUCCESS; /* loop counters */
+  pointObj pnt;
+  int size_x, size_y = 0;
+  layerObj *lp;
+  rectObj rect;
+  imageObj *image = NULL;
+  outputFormatObj *format = NULL;
+  char *text;
+
+  struct legend_struct {
+    int height;
+    textSymbolObj ts;
+    int layerindex, classindex;
+    struct legend_struct *pred;
+  };
+  typedef struct legend_struct legendlabel;
+  legendlabel *head = NULL;
+
+  if (!MS_RENDERER_PLUGIN(map->outputformat)) {
+    msSetError(MS_MISCERR, "unsupported output format", "msDrawLegend()");
+    return NULL;
+  }
+  if (msValidateContexts(map) != MS_SUCCESS)
+    return NULL; /* make sure there are no recursive REQUIRES or LABELREQUIRES
+                    expressions */
+  if (msLegendCalcSize(map, scale_independent, &size_x, &size_y, NULL, 0,
+                       hittest,
+                       map->resolution / map->defresolution) != MS_SUCCESS)
+    return NULL;
+
+  /*
+   * step through all map classes, and for each one that will be displayed
+   * keep a reference to its label size and text
+   */
+
+  for (i = 0; i < map->numlayers; i++) {
+    lp = (GET_LAYER(map, map->layerorder[i]));
+
+    if ((lp->status == MS_OFF) || (lp->type == MS_LAYER_QUERY)) /* skip it */
+      continue;
+
+    if (hittest && hittest->layerhits[map->layerorder[i]].status == 0)
+      continue;
+
+    if (!scale_independent && map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
+    }
+
+    if (!scale_independent && lp->maxscaledenom <= 0 &&
+        lp->minscaledenom <= 0) {
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
+    }
+
+    /* set the scale factor so that scale dependant symbols are drawn in the
+     * legend with their default size */
+    if (lp->sizeunits != MS_PIXELS) {
+      map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+      lp->scalefactor =
+          (msInchesPerUnit(lp->sizeunits, 0) / msInchesPerUnit(map->units, 0)) /
+          map->cellsize;
+    }
+
+    for (j = lp->numclasses - 1; j >= 0; j--) {
+      text = lp->class[j]->title
+                 ? lp->class[j]->title
+                 : lp->class[j]->name; /* point to the right legend text, title
+                                          takes precedence */
+      if (!text)
+        continue; /* skip it */
+
+      /* skip the class if the classgroup is defined */
+      if (lp->classgroup &&
+          (lp->class[j] -> group == NULL || strcasecmp(lp->class[j] -> group,
+                                                       lp -> classgroup) != 0))
+        continue;
+
+      if (!scale_independent &&
+          map->scaledenom > 0) { /* verify class scale here */
+        if ((lp->class[j] -> maxscaledenom > 0) &&
+            (map->scaledenom > lp->class[j] -> maxscaledenom))
+          continue;
+        if ((lp->class[j] -> minscaledenom > 0) &&
+            (map->scaledenom <= lp->class[j] -> minscaledenom))
+          continue;
+      }
+
+      if (hittest &&
+          hittest->layerhits[map->layerorder[i]].classhits[j].status == 0) {
+        continue;
+      }
+
+      legendlabel *cur = (legendlabel *)msSmallMalloc(sizeof(legendlabel));
+      initTextSymbol(&cur->ts);
+      if (*text) {
+        msPopulateTextSymbolForLabelAndString(
+            &cur->ts, &map->legend.label, msStrdup(text),
+            map->resolution / map->defresolution,
+            map->resolution / map->defresolution, 0);
+        if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, &cur->ts))) {
+          ret = MS_FAILURE;
+          goto cleanup;
+        }
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msGetTextSymbolSize(map, &cur->ts, &rect))) {
+          ret = MS_FAILURE;
+          goto cleanup;
+        }
+        cur->height =
+            MS_MAX(MS_NINT(rect.maxy - rect.miny), map->legend.keysizey);
+      } else {
+        cur->height = map->legend.keysizey;
+      }
+
+      cur->classindex = j;
+      cur->layerindex = map->layerorder[i];
+      cur->pred = head;
+      head = cur;
+    }
+  }
+
+  /* ensure we have an image format representing the options for the legend. */
+  msApplyOutputFormat(&format, map->outputformat, map->legend.transparent);
+
+  /* initialize the legend image */
+  image = msImageCreate(size_x, size_y, format, map->web.imagepath,
+                        map->web.imageurl, map->resolution, map->defresolution,
+                        &map->legend.imagecolor);
+  if (!image) {
+    msSetError(MS_MISCERR, "Unable to initialize image.", "msDrawLegend()");
+    return NULL;
+  }
+  image->map = map;
+
+  /* image =
+   * renderer->createImage(size_x,size_y,format,&(map->legend.imagecolor)); */
+
+  /* drop this reference to output format */
+  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
+
+  pnt.y = VMARGIN;
+  pnt.x = HMARGIN + map->legend.keysizex + map->legend.keyspacingx;
+
+  while (head) { /* head initially points on the last legend item, i.e. the one
+                    that should be at the top */
+    legendlabel *cur = head;
+    class_hittest *ch = NULL;
+
+    /* set the scale factor so that scale dependant symbols are drawn in the
+     * legend with their default size */
+    if (map->layers[cur->layerindex]->sizeunits != MS_PIXELS) {
+      map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+      map->layers[cur->layerindex]->scalefactor =
+          (msInchesPerUnit(map->layers[cur->layerindex]->sizeunits, 0) /
+           msInchesPerUnit(map->units, 0)) /
+          map->cellsize;
+    }
+    if (hittest) {
+      ch = &hittest->layerhits[cur->layerindex].classhits[cur->classindex];
+    }
+    ret = msDrawLegendIcon(map, map->layers[cur->layerindex],
+                           map->layers[cur->layerindex]->class[cur->classindex],
+                           map -> legend.keysizex, map->legend.keysizey, image,
+                           HMARGIN, (int)pnt.y, scale_independent, ch);
+    if (MS_UNLIKELY(ret != MS_SUCCESS))
+      goto cleanup;
+
+    pnt.y += cur->height;
+
+    if (cur->ts.annotext) {
+      pointObj textPnt = pnt;
+      textPnt.y -= cur->ts.textpath->bounds.bbox.maxy;
+      textPnt.y += map->legend.label.offsety;
+      textPnt.x += map->legend.label.offsetx;
+      ret = msDrawTextSymbol(map, image, textPnt, &cur->ts);
+      if (MS_UNLIKELY(ret == MS_FAILURE))
+        goto cleanup;
+      /* Coverity Scan is confused by label refcount, and wrongly believe we */
+      /* might free &map->legend.label, so make it clear we won't */
+      freeTextSymbolEx(&cur->ts, MS_FALSE);
+      MS_REFCNT_DECR(cur->ts.label);
+    }
+
+    pnt.y += map->legend.keyspacingy; /* bump y for next label */
+
+    /* clean up */
+    head = cur->pred;
+    free(cur);
+  } /* next legend */
+
+cleanup:
+  while (head) {
+    legendlabel *cur = head;
+    /* Coverity Scan is confused by label refcount, and wrongly believe we */
+    /* might free &map->legend.label, so make it clear we won't */
+    freeTextSymbolEx(&cur->ts, MS_FALSE);
+    MS_REFCNT_DECR(cur->ts.label);
+    head = cur->pred;
+    free(cur);
+  }
+  if (MS_UNLIKELY(ret != MS_SUCCESS)) {
+    if (image)
+      msFreeImage(image);
+    return NULL;
+  }
+  return (image);
+}
+
+/* TODO */
+int msEmbedLegend(mapObj *map, imageObj *img) {
+  pointObj point;
+  imageObj *image = NULL;
+  symbolObj *legendSymbol;
+  char *imageType = NULL;
+  const char *const LEGEND_SYMBOL_NAME = "legend";
+
+  rendererVTableObj *renderer;
+
+  int symbolIdx =
+      msGetSymbolIndex(&(map->symbolset), LEGEND_SYMBOL_NAME, MS_FALSE);
+  if (symbolIdx != -1)
+    msRemoveSymbol(&(map->symbolset),
+                   symbolIdx); /* solves some caching issues in AGG with
+                                  long-running processes */
+
+  if (msGrowSymbolSet(&map->symbolset) == NULL)
+    return -1;
+  symbolIdx = map->symbolset.numsymbols;
+  legendSymbol = map->symbolset.symbol[symbolIdx];
+  map->symbolset.numsymbols++;
+  initSymbol(legendSymbol);
+
+  if (!MS_RENDERER_PLUGIN(map->outputformat) ||
+      !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
+    imageType = msStrdup(map->imagetype); /* save format */
+    if MS_DRIVER_CAIRO (map->outputformat)
+      map->outputformat = msSelectOutputFormat(map, "cairopng");
+    else
+      map->outputformat = msSelectOutputFormat(map, "png");
+
+    msInitializeRendererVTable(map->outputformat);
+  }
+  renderer = MS_MAP_RENDERER(map);
+
+  /* render the legend. */
+  image = msDrawLegend(map, MS_FALSE, NULL);
+  if (image == NULL) {
+    msFree(imageType);
+    return MS_FAILURE;
+  }
+
+  if (imageType) {
+    map->outputformat =
+        msSelectOutputFormat(map, imageType); /* restore format */
+    msFree(imageType);
+  }
+
+  /* copy renderered legend image into symbol */
+  legendSymbol->pixmap_buffer = calloc(1, sizeof(rasterBufferObj));
+  MS_CHECK_ALLOC(legendSymbol->pixmap_buffer, sizeof(rasterBufferObj),
+                 MS_FAILURE);
+
+  if (MS_SUCCESS !=
+      renderer->getRasterBufferCopy(image, legendSymbol->pixmap_buffer))
+    return MS_FAILURE;
+  legendSymbol->renderer = renderer;
+
+  msFreeImage(image);
+
+  if (!legendSymbol->pixmap_buffer)
+    return (MS_FAILURE); /* something went wrong creating scalebar */
+
+  legendSymbol->type = MS_SYMBOL_PIXMAP; /* intialize a few things */
+  legendSymbol->name = msStrdup(LEGEND_SYMBOL_NAME);
+  legendSymbol->sizex = legendSymbol->pixmap_buffer->width;
+  legendSymbol->sizey = legendSymbol->pixmap_buffer->height;
+
+  /* I'm not too sure this test is sufficient ... NFW. */
+  /* if(map->legend.transparent == MS_ON) */
+  /*  gdImageColorTransparent(legendSymbol->img_deprecated, 0); */
+
+  switch (map->legend.position) {
+  case (MS_LL):
+    point.x = MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = map->height - MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_LR):
+    point.x = map->width - MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = map->height - MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_LC):
+    point.x = MS_NINT(map->width / 2.0);
+    point.y = map->height - MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_UR):
+    point.x = map->width - MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_UL):
+    point.x = MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_UC):
+    point.x = MS_NINT(map->width / 2.0);
+    point.y = MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  }
+
+  const char *const EMBED_LEGEND_LAYER_NAME = "__embed__legend";
+  int layerIdx = msGetLayerIndex(map, EMBED_LEGEND_LAYER_NAME);
+  if (layerIdx == -1) {
+    if (msGrowMapLayers(map) == NULL)
+      return (-1);
+    layerIdx = map->numlayers;
+    map->numlayers++;
+    layerObj *layer = GET_LAYER(map, layerIdx);
+    if (initLayer(layer, map) == -1)
+      return (-1);
+    layer->name = msStrdup(EMBED_LEGEND_LAYER_NAME);
+    layer->type = MS_LAYER_POINT;
+
+    if (msGrowLayerClasses(layer) == NULL)
+      return (-1);
+    if (initClass(layer->class[0]) == -1)
+      return (-1);
+    layer->numclasses = 1; /* so we make sure to free it */
+
+    /* update the layer order list with the layer's index. */
+    map->layerorder[layerIdx] = layerIdx;
+  }
+
+  layerObj *layer = GET_LAYER(map, layerIdx);
+
+  layer->status = MS_ON;
+
+  classObj *klass = layer->class[0];
+  if (map->legend.postlabelcache) { /* add it directly to the image */
+    if (MS_UNLIKELY(msMaybeAllocateClassStyle(klass, 0) == MS_FAILURE))
+      return MS_FAILURE;
+    klass->styles[0]->symbol = symbolIdx;
+    if (MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, img, &point,
+                                                     klass->styles[0], 1.0)))
+      return MS_FAILURE;
+  } else {
+    if (!klass->labels) {
+      if (msGrowClassLabels(klass) == NULL)
+        return MS_FAILURE;
+      labelObj *label = klass->labels[0];
+      initLabel(label);
+      klass->numlabels = 1;
+      label->force = MS_TRUE;
+      label->size =
+          MS_MEDIUM; /* must set a size to have a valid label definition */
+      label->priority = MS_MAX_LABEL_PRIORITY;
+    }
+    labelObj *label = klass->labels[0];
+    if (label->numstyles == 0) {
+      if (msGrowLabelStyles(label) == NULL)
+        return (MS_FAILURE);
+      label->numstyles = 1;
+      initStyle(label->styles[0]);
+      label->styles[0]->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
+    }
+    label->styles[0]->symbol = symbolIdx;
+    if (MS_UNLIKELY(MS_FAILURE == msAddLabel(map, img, label, layerIdx, 0, NULL,
+                                             &point, -1, NULL)))
+      return MS_FAILURE;
+  }
+
+  /* Mark layer as deleted so that it doesn't interfere with html legends or
+   * with saving maps */
+  layer->status = MS_DELETE;
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/maplexer.c 8.2.0~beta1-1~exp1/src/maplexer.c
--- 8.0.1-5/src/maplexer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maplexer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5576 @@
+#line 2 "/home/even/mapserver/mapserver/maplexer.c"
+
+#line 4 "/home/even/mapserver/mapserver/maplexer.c"
+
+#define  YY_INT_ALIGNED short int
+
+/* A lexical scanner generated by flex */
+
+#define yy_create_buffer msyy_create_buffer
+#define yy_delete_buffer msyy_delete_buffer
+#define yy_scan_buffer msyy_scan_buffer
+#define yy_scan_string msyy_scan_string
+#define yy_scan_bytes msyy_scan_bytes
+#define yy_init_buffer msyy_init_buffer
+#define yy_flush_buffer msyy_flush_buffer
+#define yy_load_buffer_state msyy_load_buffer_state
+#define yy_switch_to_buffer msyy_switch_to_buffer
+#define yypush_buffer_state msyypush_buffer_state
+#define yypop_buffer_state msyypop_buffer_state
+#define yyensure_buffer_stack msyyensure_buffer_stack
+#define yy_flex_debug msyy_flex_debug
+#define yyin msyyin
+#define yyleng msyyleng
+#define yylex msyylex
+#define yylineno msyylineno
+#define yyout msyyout
+#define yyrestart msyyrestart
+#define yytext msyytext
+#define yywrap msyywrap
+#define yyalloc msyyalloc
+#define yyrealloc msyyrealloc
+#define yyfree msyyfree
+
+#define FLEX_SCANNER
+#define YY_FLEX_MAJOR_VERSION 2
+#define YY_FLEX_MINOR_VERSION 6
+#define YY_FLEX_SUBMINOR_VERSION 4
+#if YY_FLEX_SUBMINOR_VERSION > 0
+#define FLEX_BETA
+#endif
+
+#ifdef yy_create_buffer
+#define msyy_create_buffer_ALREADY_DEFINED
+#else
+#define yy_create_buffer msyy_create_buffer
+#endif
+
+#ifdef yy_delete_buffer
+#define msyy_delete_buffer_ALREADY_DEFINED
+#else
+#define yy_delete_buffer msyy_delete_buffer
+#endif
+
+#ifdef yy_scan_buffer
+#define msyy_scan_buffer_ALREADY_DEFINED
+#else
+#define yy_scan_buffer msyy_scan_buffer
+#endif
+
+#ifdef yy_scan_string
+#define msyy_scan_string_ALREADY_DEFINED
+#else
+#define yy_scan_string msyy_scan_string
+#endif
+
+#ifdef yy_scan_bytes
+#define msyy_scan_bytes_ALREADY_DEFINED
+#else
+#define yy_scan_bytes msyy_scan_bytes
+#endif
+
+#ifdef yy_init_buffer
+#define msyy_init_buffer_ALREADY_DEFINED
+#else
+#define yy_init_buffer msyy_init_buffer
+#endif
+
+#ifdef yy_flush_buffer
+#define msyy_flush_buffer_ALREADY_DEFINED
+#else
+#define yy_flush_buffer msyy_flush_buffer
+#endif
+
+#ifdef yy_load_buffer_state
+#define msyy_load_buffer_state_ALREADY_DEFINED
+#else
+#define yy_load_buffer_state msyy_load_buffer_state
+#endif
+
+#ifdef yy_switch_to_buffer
+#define msyy_switch_to_buffer_ALREADY_DEFINED
+#else
+#define yy_switch_to_buffer msyy_switch_to_buffer
+#endif
+
+#ifdef yypush_buffer_state
+#define msyypush_buffer_state_ALREADY_DEFINED
+#else
+#define yypush_buffer_state msyypush_buffer_state
+#endif
+
+#ifdef yypop_buffer_state
+#define msyypop_buffer_state_ALREADY_DEFINED
+#else
+#define yypop_buffer_state msyypop_buffer_state
+#endif
+
+#ifdef yyensure_buffer_stack
+#define msyyensure_buffer_stack_ALREADY_DEFINED
+#else
+#define yyensure_buffer_stack msyyensure_buffer_stack
+#endif
+
+#ifdef yylex
+#define msyylex_ALREADY_DEFINED
+#else
+#define yylex msyylex
+#endif
+
+#ifdef yyrestart
+#define msyyrestart_ALREADY_DEFINED
+#else
+#define yyrestart msyyrestart
+#endif
+
+#ifdef yylex_init
+#define msyylex_init_ALREADY_DEFINED
+#else
+#define yylex_init msyylex_init
+#endif
+
+#ifdef yylex_init_extra
+#define msyylex_init_extra_ALREADY_DEFINED
+#else
+#define yylex_init_extra msyylex_init_extra
+#endif
+
+#ifdef yylex_destroy
+#define msyylex_destroy_ALREADY_DEFINED
+#else
+#define yylex_destroy msyylex_destroy
+#endif
+
+#ifdef yyget_debug
+#define msyyget_debug_ALREADY_DEFINED
+#else
+#define yyget_debug msyyget_debug
+#endif
+
+#ifdef yyset_debug
+#define msyyset_debug_ALREADY_DEFINED
+#else
+#define yyset_debug msyyset_debug
+#endif
+
+#ifdef yyget_extra
+#define msyyget_extra_ALREADY_DEFINED
+#else
+#define yyget_extra msyyget_extra
+#endif
+
+#ifdef yyset_extra
+#define msyyset_extra_ALREADY_DEFINED
+#else
+#define yyset_extra msyyset_extra
+#endif
+
+#ifdef yyget_in
+#define msyyget_in_ALREADY_DEFINED
+#else
+#define yyget_in msyyget_in
+#endif
+
+#ifdef yyset_in
+#define msyyset_in_ALREADY_DEFINED
+#else
+#define yyset_in msyyset_in
+#endif
+
+#ifdef yyget_out
+#define msyyget_out_ALREADY_DEFINED
+#else
+#define yyget_out msyyget_out
+#endif
+
+#ifdef yyset_out
+#define msyyset_out_ALREADY_DEFINED
+#else
+#define yyset_out msyyset_out
+#endif
+
+#ifdef yyget_leng
+#define msyyget_leng_ALREADY_DEFINED
+#else
+#define yyget_leng msyyget_leng
+#endif
+
+#ifdef yyget_text
+#define msyyget_text_ALREADY_DEFINED
+#else
+#define yyget_text msyyget_text
+#endif
+
+#ifdef yyget_lineno
+#define msyyget_lineno_ALREADY_DEFINED
+#else
+#define yyget_lineno msyyget_lineno
+#endif
+
+#ifdef yyset_lineno
+#define msyyset_lineno_ALREADY_DEFINED
+#else
+#define yyset_lineno msyyset_lineno
+#endif
+
+#ifdef yywrap
+#define msyywrap_ALREADY_DEFINED
+#else
+#define yywrap msyywrap
+#endif
+
+#ifdef yyalloc
+#define msyyalloc_ALREADY_DEFINED
+#else
+#define yyalloc msyyalloc
+#endif
+
+#ifdef yyrealloc
+#define msyyrealloc_ALREADY_DEFINED
+#else
+#define yyrealloc msyyrealloc
+#endif
+
+#ifdef yyfree
+#define msyyfree_ALREADY_DEFINED
+#else
+#define yyfree msyyfree
+#endif
+
+#ifdef yytext
+#define msyytext_ALREADY_DEFINED
+#else
+#define yytext msyytext
+#endif
+
+#ifdef yyleng
+#define msyyleng_ALREADY_DEFINED
+#else
+#define yyleng msyyleng
+#endif
+
+#ifdef yyin
+#define msyyin_ALREADY_DEFINED
+#else
+#define yyin msyyin
+#endif
+
+#ifdef yyout
+#define msyyout_ALREADY_DEFINED
+#else
+#define yyout msyyout
+#endif
+
+#ifdef yy_flex_debug
+#define msyy_flex_debug_ALREADY_DEFINED
+#else
+#define yy_flex_debug msyy_flex_debug
+#endif
+
+#ifdef yylineno
+#define msyylineno_ALREADY_DEFINED
+#else
+#define yylineno msyylineno
+#endif
+
+/* First, we deal with  platform-specific or compiler-specific issues. */
+
+/* begin standard C headers. */
+#include <stdio.h>
+#include <string.h>
+#include <errno.h>
+#include <stdlib.h>
+
+/* end standard C headers. */
+
+/* flex integer type definitions */
+
+#ifndef FLEXINT_H
+#define FLEXINT_H
+
+/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */
+
+#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
+
+/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
+ * if you want the limit (max/min) macros for int types. 
+ */
+#ifndef __STDC_LIMIT_MACROS
+#define __STDC_LIMIT_MACROS 1
+#endif
+
+#include <inttypes.h>
+typedef int8_t flex_int8_t;
+typedef uint8_t flex_uint8_t;
+typedef int16_t flex_int16_t;
+typedef uint16_t flex_uint16_t;
+typedef int32_t flex_int32_t;
+typedef uint32_t flex_uint32_t;
+#else
+typedef signed char flex_int8_t;
+typedef short int flex_int16_t;
+typedef int flex_int32_t;
+typedef unsigned char flex_uint8_t; 
+typedef unsigned short int flex_uint16_t;
+typedef unsigned int flex_uint32_t;
+
+/* Limits of integral types. */
+#ifndef INT8_MIN
+#define INT8_MIN               (-128)
+#endif
+#ifndef INT16_MIN
+#define INT16_MIN              (-32767-1)
+#endif
+#ifndef INT32_MIN
+#define INT32_MIN              (-2147483647-1)
+#endif
+#ifndef INT8_MAX
+#define INT8_MAX               (127)
+#endif
+#ifndef INT16_MAX
+#define INT16_MAX              (32767)
+#endif
+#ifndef INT32_MAX
+#define INT32_MAX              (2147483647)
+#endif
+#ifndef UINT8_MAX
+#define UINT8_MAX              (255U)
+#endif
+#ifndef UINT16_MAX
+#define UINT16_MAX             (65535U)
+#endif
+#ifndef UINT32_MAX
+#define UINT32_MAX             (4294967295U)
+#endif
+
+#ifndef SIZE_MAX
+#define SIZE_MAX               (~(size_t)0)
+#endif
+
+#endif /* ! C99 */
+
+#endif /* ! FLEXINT_H */
+
+/* begin standard C++ headers. */
+
+/* TODO: this is always defined, so inline it */
+#define yyconst const
+
+#if defined(__GNUC__) && __GNUC__ >= 3
+#define yynoreturn __attribute__((__noreturn__))
+#else
+#define yynoreturn
+#endif
+
+/* Returned upon end-of-file. */
+#define YY_NULL 0
+
+/* Promotes a possibly negative, possibly signed char to an
+ *   integer in range [0..255] for use as an array index.
+ */
+#define YY_SC_TO_UI(c) ((YY_CHAR) (c))
+
+/* Enter a start condition.  This macro really ought to take a parameter,
+ * but we do it the disgusting crufty way forced on us by the ()-less
+ * definition of BEGIN.
+ */
+#define BEGIN (yy_start) = 1 + 2 *
+/* Translate the current start state into a value that can be later handed
+ * to BEGIN to return to the state.  The YYSTATE alias is for lex
+ * compatibility.
+ */
+#define YY_START (((yy_start) - 1) / 2)
+#define YYSTATE YY_START
+/* Action number for EOF rule of a given start state. */
+#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
+/* Special action meaning "start processing a new file". */
+#define YY_NEW_FILE yyrestart( yyin  )
+#define YY_END_OF_BUFFER_CHAR 0
+
+/* Size of default input buffer. */
+#ifndef YY_BUF_SIZE
+#ifdef __ia64__
+/* On IA-64, the buffer size is 16k, not 8k.
+ * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
+ * Ditto for the __ia64__ case accordingly.
+ */
+#define YY_BUF_SIZE 32768
+#else
+#define YY_BUF_SIZE 16384
+#endif /* __ia64__ */
+#endif
+
+/* The state buf must be large enough to hold one state per character in the main buffer.
+ */
+#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))
+
+#ifndef YY_TYPEDEF_YY_BUFFER_STATE
+#define YY_TYPEDEF_YY_BUFFER_STATE
+typedef struct yy_buffer_state *YY_BUFFER_STATE;
+#endif
+
+#ifndef YY_TYPEDEF_YY_SIZE_T
+#define YY_TYPEDEF_YY_SIZE_T
+typedef size_t yy_size_t;
+#endif
+
+extern int yyleng;
+
+extern FILE *yyin, *yyout;
+
+#define EOB_ACT_CONTINUE_SCAN 0
+#define EOB_ACT_END_OF_FILE 1
+#define EOB_ACT_LAST_MATCH 2
+    
+    #define YY_LESS_LINENO(n)
+    #define YY_LINENO_REWIND_TO(ptr)
+    
+/* Return all but the first "n" matched characters back to the input stream. */
+#define yyless(n) \
+	do \
+		{ \
+		/* Undo effects of setting up yytext. */ \
+        int yyless_macro_arg = (n); \
+        YY_LESS_LINENO(yyless_macro_arg);\
+		*yy_cp = (yy_hold_char); \
+		YY_RESTORE_YY_MORE_OFFSET \
+		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
+		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
+		} \
+	while ( 0 )
+#define unput(c) yyunput( c, (yytext_ptr)  )
+
+#ifndef YY_STRUCT_YY_BUFFER_STATE
+#define YY_STRUCT_YY_BUFFER_STATE
+struct yy_buffer_state
+	{
+	FILE *yy_input_file;
+
+	char *yy_ch_buf;		/* input buffer */
+	char *yy_buf_pos;		/* current position in input buffer */
+
+	/* Size of input buffer in bytes, not including room for EOB
+	 * characters.
+	 */
+	int yy_buf_size;
+
+	/* Number of characters read into yy_ch_buf, not including EOB
+	 * characters.
+	 */
+	int yy_n_chars;
+
+	/* Whether we "own" the buffer - i.e., we know we created it,
+	 * and can realloc() it to grow it, and should free() it to
+	 * delete it.
+	 */
+	int yy_is_our_buffer;
+
+	/* Whether this is an "interactive" input source; if so, and
+	 * if we're using stdio for input, then we want to use getc()
+	 * instead of fread(), to make sure we stop fetching input after
+	 * each newline.
+	 */
+	int yy_is_interactive;
+
+	/* Whether we're considered to be at the beginning of a line.
+	 * If so, '^' rules will be active on the next match, otherwise
+	 * not.
+	 */
+	int yy_at_bol;
+
+    int yy_bs_lineno; /**< The line count. */
+    int yy_bs_column; /**< The column count. */
+
+	/* Whether to try to fill the input buffer when we reach the
+	 * end of it.
+	 */
+	int yy_fill_buffer;
+
+	int yy_buffer_status;
+
+#define YY_BUFFER_NEW 0
+#define YY_BUFFER_NORMAL 1
+	/* When an EOF's been seen but there's still some text to process
+	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
+	 * shouldn't try reading from the input source any more.  We might
+	 * still have a bunch of tokens to match, though, because of
+	 * possible backing-up.
+	 *
+	 * When we actually see the EOF, we change the status to "new"
+	 * (via yyrestart()), so that the user can continue scanning by
+	 * just pointing yyin at a new input file.
+	 */
+#define YY_BUFFER_EOF_PENDING 2
+
+	};
+#endif /* !YY_STRUCT_YY_BUFFER_STATE */
+
+/* Stack of input buffers. */
+static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
+static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
+static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */
+
+/* We provide macros for accessing buffer states in case in the
+ * future we want to put the buffer states in a more general
+ * "scanner state".
+ *
+ * Returns the top of the stack, or NULL.
+ */
+#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
+                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
+                          : NULL)
+/* Same as previous macro, but useful when we know that the buffer stack is not
+ * NULL or when we need an lvalue. For internal use only.
+ */
+#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]
+
+/* yy_hold_char holds the character lost when yytext is formed. */
+static char yy_hold_char;
+static int yy_n_chars;		/* number of characters read into yy_ch_buf */
+int yyleng;
+
+/* Points to current character in buffer. */
+static char *yy_c_buf_p = NULL;
+static int yy_init = 0;		/* whether we need to initialize */
+static int yy_start = 0;	/* start state number */
+
+/* Flag which is used to allow yywrap()'s to do buffer switches
+ * instead of setting up a fresh yyin.  A bit of a hack ...
+ */
+static int yy_did_buffer_switch_on_eof;
+
+void yyrestart ( FILE *input_file  );
+void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
+YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
+void yy_delete_buffer ( YY_BUFFER_STATE b  );
+void yy_flush_buffer ( YY_BUFFER_STATE b  );
+void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
+void yypop_buffer_state ( void );
+
+static void yyensure_buffer_stack ( void );
+static void yy_load_buffer_state ( void );
+static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
+#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )
+
+YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
+YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
+YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );
+
+void *yyalloc ( yy_size_t  );
+void *yyrealloc ( void *, yy_size_t  );
+void yyfree ( void *  );
+
+#define yy_new_buffer yy_create_buffer
+#define yy_set_interactive(is_interactive) \
+	{ \
+	if ( ! YY_CURRENT_BUFFER ){ \
+        yyensure_buffer_stack (); \
+		YY_CURRENT_BUFFER_LVALUE =    \
+            yy_create_buffer( yyin, YY_BUF_SIZE ); \
+	} \
+	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
+	}
+#define yy_set_bol(at_bol) \
+	{ \
+	if ( ! YY_CURRENT_BUFFER ){\
+        yyensure_buffer_stack (); \
+		YY_CURRENT_BUFFER_LVALUE =    \
+            yy_create_buffer( yyin, YY_BUF_SIZE ); \
+	} \
+	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
+	}
+#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)
+
+/* Begin user sect3 */
+typedef flex_uint8_t YY_CHAR;
+
+FILE *yyin = NULL, *yyout = NULL;
+
+typedef int yy_state_type;
+
+extern int yylineno;
+int yylineno = 1;
+
+extern char *yytext;
+#ifdef yytext_ptr
+#undef yytext_ptr
+#endif
+#define yytext_ptr yytext
+
+static yy_state_type yy_get_previous_state ( void );
+static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
+static int yy_get_next_buffer ( void );
+static void yynoreturn yy_fatal_error ( const char* msg  );
+
+/* Done after the current pattern has been matched and before the
+ * corresponding action - sets up yytext.
+ */
+#define YY_DO_BEFORE_ACTION \
+	(yytext_ptr) = yy_bp; \
+	yyleng = (int) (yy_cp - yy_bp); \
+	(yy_hold_char) = *yy_cp; \
+	*yy_cp = '\0'; \
+	(yy_c_buf_p) = yy_cp;
+#define YY_NUM_RULES 344
+#define YY_END_OF_BUFFER 345
+/* This struct is not used in this scanner,
+   but its presence is necessary. */
+struct yy_trans_info
+	{
+	flex_int32_t yy_verify;
+	flex_int32_t yy_nxt;
+	};
+static const flex_int16_t yy_accept[1732] =
+    {   0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,  345,  342,    1,  340,  333,    2,  342,  342,
+      326,  339,  326,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  342,  342,  342,
+      343,    1,  341,    1,   14,  338,  343,  338,  343,  327,
+      327,   18,   15,   17,  343,  343,  343,  343,  343,  343,
+      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
+      343,  343,  343,  341,   21,  341,  344,    1,  344,  344,
+      336,  334,  334,  335,    5,    7,    6,  339,  339,  339,
+
+      339,  339,    1,    2,    0,  331,  326,  326,  339,  326,
+      339,    0,    3,  339,    2,  326,    0,  339,  339,  339,
+      339,  339,  339,  339,  339,  244,  339,  339,  339,  248,
+      339,  249,  339,  339,  254,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  268,  339,  339,  271,  272,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  284,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+
+      339,  339,  339,  339,  223,  339,  339,  310,  311,  339,
+      312,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,    0,  319,    0,  332,    0,   16,    0,   13,    0,
+      327,  327,  327,    0,  327,    0,   20,   22,   15,   19,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+       15,    0,    0,    0,   19,   17,   24,    0,   20,    0,
+       18,    0,   12,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,  323,    0,    0,  328,
+       23,    0,  337,    0,  336,  334,  334,  335,    5,    4,
+        2,  339,  339,  339,  339,  326,    0,    0,  339,  326,
+
+        0,  330,  339,  330,    2,    2,    2,  326,    0,    0,
+      326,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  250,  339,  339,  339,  339,  339,  339,
+      339,  339,   88,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  103,  339,  339,  339,
+      339,  339,  339,  339,  339,  263,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  142,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+
+      281,  282,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  304,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  234,  317,  339,  236,  318,
+      339,   68,    0,    0,    0,    0,    0,  327,  327,    0,
+        0,  327,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,   14,    0,    0,    0,    0,    0,
+
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        2,  339,    9,  339,  339,  326,  329,  329,    2,    2,
+        0,  326,  339,  339,  339,  339,  339,  239,  339,  339,
+      339,  339,  339,  339,  339,  243,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,   83,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      258,  339,  339,  339,  339,   98,  339,  339,  339,  102,
+      339,  339,  339,  105,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  121,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  269,  339,  270,  339,  145,
+
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  175,  339,
+      279,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  207,
+      339,  339,  339,  339,  339,  339,  339,  218,  339,  306,
+      339,  339,  339,  339,  308,  228,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  237,  324,    0,  327,   25,
+
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,   56,    0,
+        0,    0,    0,    0,  325,  339,   10,  339,    2,   61,
+      339,   63,  339,  339,  240,  339,  339,  241,  339,  339,
+      339,  339,  339,  339,  246,  339,   72,  339,   76,  339,
+      339,  339,  339,  339,  339,   84,  339,  339,  339,  339,
+      256,   86,  339,   89,  339,  339,  257,  339,  339,  339,
+      339,  339,  339,  339,  100,  339,  339,  260,  339,  339,
+      108,  261,  339,  339,  110,  339,  339,  118,  339,  339,
+
+      186,  339,  339,  339,  339,  339,  125,  267,  339,  135,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  276,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  277,  339,  252,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  291,  339,  339,  339,  339,  339,  339,  339,
+      339,  295,  339,  339,  339,  339,  339,  339,  339,  339,
+      297,  298,  200,  339,  339,  339,  339,  339,  339,  302,
+      339,  339,  210,  339,  216,  339,  339,  339,  339,  222,
+
+      339,  339,  339,  339,  313,  229,  339,  339,  339,  339,
+      339,  339,  235,    0,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,   57,    0,    0,    0,    0,   43,
+        0,    0,    0,   31,   42,    0,   29,    0,    0,    0,
+        0,   30,    0,    0,    0,    0,  339,  339,  339,  339,
+      339,  339,  339,  339,  242,  339,   70,  245,  339,  247,
+      339,  339,  339,  339,  339,   79,  339,   80,  339,  339,
+      339,  339,  339,   85,  339,  339,  339,  339,   91,  339,
+       94,   95,  339,  259,  339,   97,  339,  339,  339,  339,
+      109,  264,  339,  339,  339,  339,  339,  265,  339,  339,
+
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  134,  136,  137,  339,  339,  143,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      273,  339,  274,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  280,  176,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  290,  289,
+      294,  185,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  296,  339,  195,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  300,  301,  339,
+      303,  209,  339,  212,  339,  339,  339,  339,  339,  339,
+
+      339,  339,  339,  339,  339,  339,  339,  339,  233,  316,
+       53,   34,    0,    0,    0,    0,    0,    0,    0,    0,
+       52,    0,    0,    0,    0,    0,    0,   26,    0,    0,
+        0,    0,    0,   50,    0,    0,    0,    8,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,   75,
+      339,  339,  339,  339,  315,  339,  253,  339,  255,  339,
+      339,  339,   93,  339,  339,   99,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  117,  339,  339,  339,  339,
+      123,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      139,  339,  339,  146,  339,  339,  339,  339,  339,  339,
+
+      339,  339,  155,  339,  339,  339,  339,  339,  161,  339,
+      339,  339,  339,  339,  339,  171,  339,  339,  339,  339,
+      339,  177,  339,  178,  339,  339,  339,  339,  184,  339,
+      339,  292,  339,  293,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  221,  339,  339,  339,  339,  339,  230,  231,  339,
+      339,    0,   28,    0,   49,   41,    0,    0,   54,    0,
+        0,    0,   32,    0,    0,    0,    0,    0,    0,   47,
+        0,    0,  320,   11,  339,  339,  339,  339,  339,   67,
+
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+       87,  339,  339,  339,  339,  339,  339,  339,  106,  339,
+      339,  339,  339,  116,  339,  339,  339,  122,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  140,  339,  339,
+      339,  339,  339,  339,  339,  339,  151,  339,  339,  158,
+      159,  160,  339,  339,  339,  339,  339,  168,  339,  339,
+      174,  278,  339,  339,  339,  339,  339,  339,  339,  183,
+      339,  339,  187,  339,  339,  189,  339,  339,  339,  193,
+      339,  339,  339,  339,  197,  339,  202,  339,  339,  299,
+      339,  339,  339,  339,  339,  339,  339,  217,  115,  339,
+
+      220,  339,  339,  339,  307,  309,  314,  339,    0,   51,
+        0,   46,   33,   55,    0,    0,    0,   48,   36,    0,
+       27,    0,    0,  339,  339,   64,  339,   66,  339,   71,
+      339,   73,  339,  339,   78,  339,   59,  339,  339,   92,
+      339,  339,  339,  339,  107,  339,  113,  114,  112,  339,
+      120,  339,  339,  339,  339,  339,  128,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  154,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
+      339,  339,  339,  339,  339,   60,  194,  339,  339,  339,
+
+      339,  339,  339,  339,  206,  208,  211,  339,  215,  219,
+      224,  227,  339,  339,    0,    0,    0,    0,    0,    0,
+       39,    0,    0,  339,  238,  339,  339,   74,   58,   77,
+       81,  339,   90,   96,  283,  339,  339,  111,  119,  339,
+      124,  266,  126,  339,  339,  339,  339,  339,  339,  144,
+      147,  339,  339,  339,  339,  339,  339,  339,  339,  162,
+      339,  339,  339,  339,  339,  339,  339,  339,  339,  285,
+      339,  339,  339,  339,  339,  339,  251,  339,  190,  191,
+      339,  196,  339,  198,  201,  203,  339,  205,  339,  339,
+      339,  232,   40,   35,   38,   45,   44,   37,    0,    0,
+
+       62,  339,  339,  339,  339,  339,  339,  339,  339,  127,
+      339,  339,  339,  339,  339,  148,  149,  153,  150,  339,
+      339,  339,  157,  163,  339,  170,  167,  339,  339,  173,
+      339,  286,  339,  339,  339,  339,  288,  305,  339,  192,
+      339,  204,  213,  339,  226,    0,    0,  339,   69,  339,
+      339,  339,  101,  339,  339,  339,  339,  339,  138,  339,
+      339,  339,  156,  339,  339,  172,  339,  339,  180,  181,
+      182,  339,  339,  339,  339,    0,    0,  339,  339,  339,
+      199,  104,  262,  129,  131,  133,  339,  339,  152,  339,
+      169,  275,  287,  339,  339,  339,  339,    0,    0,  339,
+
+      339,   82,  339,  339,  339,  339,  166,  188,  164,  339,
+      225,    0,  321,   65,  339,  339,  339,  141,  165,  339,
+      322,  339,  339,  339,  214,  179,  339,  339,  130,  132,
+        0
+    } ;
+
+static const YY_CHAR yy_ec[256] =
+    {   0,
+        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
+        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    2,    5,    6,    7,    1,    1,    8,    9,   10,
+       11,   12,   13,    1,   14,   15,   16,   17,   17,   18,
+       17,   17,   17,   17,   17,   17,   17,    1,    1,   19,
+       20,   21,    1,    1,   22,   23,   24,   25,   26,   27,
+       28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
+       38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
+       48,   49,   50,    1,   51,   52,   53,   54,   55,   56,
+
+       57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
+       67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
+       77,   78,   79,   80,   81,   82,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,   83,    1,    1,    1,
+       84,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,   85,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1
+    } ;
+
+static const YY_CHAR yy_meta[87] =
+    {   0,
+        1,    1,    2,    1,    1,    3,    1,    1,    4,    1,
+        1,    5,    1,    6,    6,    6,    6,    6,    1,    6,
+        1,    6,    6,    6,    6,    6,    6,    6,    6,    6,
+        6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
+        6,    6,    6,    6,    6,    6,    6,    1,    7,    1,
+        6,    1,    6,    6,    6,    6,    6,    6,    6,    6,
+        6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
+        6,    6,    6,    6,    6,    6,    6,    6,    1,    1,
+        1,    1,    1,    1,    1,    1
+    } ;
+
+static const flex_int16_t yy_base[1756] =
+    {   0,
+        0,    0,   86,    0,  171,  172,  173,  177,  181,  182,
+      226,    0, 1024, 3975,  185, 3975, 3975,    0, 1000,  173,
+      296,  353,  310,  304,  353,  416,  359,  354,  421,  436,
+      356,  467,  156,  290,  474,  473,  354,  483,  532,  275,
+      533,  579,  585,  540,  374,  631,    0,  938,  812,  757,
+     3975,  193, 3975,  194,  760,  711,  740,  697,  184,  314,
+      611,  713,  188,  679,  424,  479,  521,  615,  280,  644,
+      575,  284,  299,  628,  624,  636,  306,  637,  355,  343,
+      367,  678,  155,  613,  675, 3975, 3975,  202,  676,  668,
+        0,  411,  418,  475,    0, 3975,  633,  611,  473,  477,
+
+      492,  484,  207,    0,  608,  573,  690,  704,    0,  706,
+      199,  564, 3975,  763,  849,  720,  201,  531,  759,  525,
+      649,  524,  645,  551,  686,    0,  685,  703,  687,  756,
+      755,    0,  686,  690,    0,  727,  725,  758,  769,  771,
+      754,  760,  766,  781,  769,  782,  836,  769,  771,  774,
+      841,  851,  823,  852,  843,  833,  856,  855,  856,  853,
+      845,  853,  897,    0,  897,  855,    0,    0,  900,  901,
+      913,  859,  901,  910,  914,  931,  920,  934,  939,  940,
+      922,  925,  926,  936,  940,  968,  969,  960,  967,  982,
+      959,  958,  981,  971,  984, 1008,  992,  974, 1003,  993,
+
+      989, 1003, 1014, 1025, 1011, 1039, 1025,    0,    0, 1033,
+        0, 1037, 1026, 1034, 1044, 1047, 1031, 1047, 1035, 1037,
+     1056,  524, 3975,  489,  456,  432, 3975,  420, 3975,  417,
+     1087, 1099, 1093,  207, 1103,  316, 3975, 3975, 3975, 3975,
+     1059, 1061, 1060, 1095, 1088, 1092, 1088, 1093, 1103, 1101,
+     1090, 1100, 1095, 1099, 1101, 3975, 1110, 1095, 1104, 1097,
+     3975, 1101, 3975, 1105, 1121, 1106, 1115, 1116, 1144, 1126,
+     1138, 1140,  411, 1163, 1168, 1159, 3975,  401,  274, 3975,
+     3975,  444, 3975,  435,    0, 3975, 3975, 3975,    0, 3975,
+     1221, 1154, 1210, 1156, 1163, 1184,  451,  326,  559,  718,
+
+      392, 1177, 1307, 1178,  627, 1393, 1479, 1226, 1178,  722,
+      724, 1186, 1208, 1213, 1211, 1218, 1213, 1218, 1226, 1228,
+     1230, 1222, 1213, 1231, 1218, 1219, 1222, 1238, 1223, 1224,
+     1229, 1230, 1294,    0, 1277, 1280, 1305, 1288, 1302, 1307,
+     1293, 1300,    0, 1301, 1299, 1313, 1300, 1300, 1301, 1310,
+     1304, 1313, 1306, 1307, 1383, 1315,    0, 1316, 1319, 1343,
+     1383, 1371, 1392, 1393, 1389,    0, 1392, 1392, 1396, 1382,
+     1398, 1392, 1392, 1393, 1400, 1393, 1405, 1404, 1400, 1408,
+     1410, 1395, 1411, 1444,    0, 1450, 1461, 1544, 1464, 1473,
+     1476, 1477, 1598, 1478, 1464, 1468, 1481, 1467, 1484, 1477,
+
+     1472,    0,  390, 1490, 1491, 1483, 1476, 1477, 1495, 1518,
+     1494, 1488, 1533, 1540, 1520, 1575, 1534, 1548, 1537, 1556,
+     1561, 1571, 1570, 1572, 1581, 1589, 1594, 1598, 1606, 1609,
+     1596, 1607, 1610, 1607, 1619, 1602, 1611,    0, 1624, 1617,
+     1616, 1614, 1632, 1615, 1635, 1650, 1644, 1658, 1656, 1657,
+     1649, 1663, 1665, 1661, 1653,    0,    0, 1654,    0,    0,
+     1659, 3975,  295,  522,  291,  573,  735,  799, 1680, 1687,
+      849,  871, 1680, 1672, 1682, 1671, 1681, 1676, 1680, 1683,
+     1701, 1698, 1689, 1709, 1692, 1695, 1702, 1712, 1700, 1716,
+     1718, 1723, 1719, 1723, 3975, 1724, 1713, 1718, 1718, 1720,
+
+     1716, 1734, 1738, 1739, 1739, 1729, 1740, 1752,  583, 1033,
+     1752, 1758,    0, 1751, 1764, 1010, 3975,    0, 1763, 1764,
+     1180, 1186, 1762, 1762, 1774, 1762, 1782,  320, 1778, 1767,
+     1776, 1767, 1789, 1772, 1788,    0, 1789, 1795, 1785, 1779,
+     1779, 1782, 1803, 1796, 1801, 1796, 1794, 1816, 1805, 1827,
+     1828, 1818, 1831, 1813, 1835, 1823, 1839, 1831, 1842, 1827,
+        0, 1845, 1846, 1845, 1838, 1836, 1851, 1853, 1858,    0,
+     1840, 1841, 1853, 1848, 1852, 1863, 1868, 1854, 1872, 1875,
+     1864, 1864, 1885, 1877, 1877,    0, 1892, 1887, 1894, 1888,
+     1894, 1902, 1894, 1894, 1908,    0, 1900, 1912, 1912,    0,
+
+     1900, 1905, 1912, 1918, 1919, 1915, 1925, 1911, 1947, 1930,
+     1927, 1918, 1938, 1929, 1938, 1938, 1941, 1947, 1954, 1960,
+     1964, 1957, 1971, 1967, 1966, 1958, 1968, 1967,    0, 1973,
+        0, 1982, 1986, 1964, 1976, 1974, 1988, 1977, 1992, 1999,
+     2004, 2000, 2017, 2010, 2000, 2003, 2017, 2005, 2024, 2009,
+     2025, 2028, 2009, 2032, 2033, 2021, 2026, 2022, 2043, 2036,
+     2034, 2027, 2044, 2048, 2051, 2042, 2054, 2048, 2051, 2045,
+     2059, 2056, 2059, 2076, 2067, 2078, 2077,    0, 2077,    0,
+     2082, 2074, 2076, 2084, 2079,    0, 2086, 2082, 2102, 2084,
+     2087, 2103, 2103, 2094, 2102,    0, 3975, 1257, 1307, 3975,
+
+     2101, 2111, 2114, 2112, 2121, 2106, 2119, 2128, 2121, 2134,
+     2131, 2139, 2125, 2128, 2131, 2148, 2136, 2137, 2138, 2138,
+     2142, 2143, 2150, 2159, 2153, 2146, 2150, 2161, 3975, 2152,
+     2162, 2176, 1360, 2174, 3975, 2169,    0, 2172,    0,    0,
+     2165,    0, 2183, 2175,    0, 2177, 2189,    0, 2203, 2190,
+     2202, 2192, 2193, 2210,    0, 2211, 2210, 2215, 2204, 2214,
+     2208, 2218, 2225, 2209, 2230,    0, 2220, 2214, 2216, 2217,
+        0,    0, 2230,    0, 2221, 2226,    0, 2225, 2245, 2234,
+     2252, 2237, 2261, 2250,    0, 2249, 2254,    0, 2270, 2255,
+        0,    0, 2260, 2274, 2292, 2265, 2281,    0, 2285, 2265,
+
+        0, 2277, 2289, 2266, 2292, 2289, 2324,    0, 2284,    0,
+     2283, 2303, 2313, 2304, 2304, 2325, 2307, 2315, 2334, 2325,
+     2321, 2332, 2342, 2347, 2323, 2349, 2339, 2350, 2342, 2355,
+     2338,    0, 2335, 2360, 2343, 2350, 2369, 2359, 2355, 2375,
+     2355, 2382, 2376, 2386,    0, 2376,    0, 2390, 2383, 2376,
+     2377, 2384, 2382, 2398, 2390, 2388, 2408, 2392, 2397, 2394,
+     2398, 2402, 2398, 2403, 2404, 2413, 2420, 2424, 2422, 2413,
+     2433, 2445, 2428, 2425, 2441, 2438, 2445, 2435, 2439, 2438,
+        0,    0, 2471, 2441, 2441, 2449, 2461, 2465, 2457,    0,
+     2467, 2457, 2469, 2467,    0, 2479, 2480, 2473, 2466,    0,
+
+     2493, 2492, 2492, 2475,    0,    0, 2485, 2508, 2494, 2515,
+     2498, 2501,    0, 2516, 2503, 2505, 2520, 2518, 2523, 2526,
+     2515, 2525, 2526, 2518, 3975, 2535, 2535, 2540, 2541, 3975,
+     2524, 2543, 2541, 3975, 3975, 2552, 3975, 2546, 2548, 2551,
+     2556, 3975, 2548, 1446, 2567, 2570, 2560, 2562, 2562, 2559,
+     2572, 2567, 2563, 2573,    0, 2582,    0,    0, 2569,    0,
+     2572, 2574, 2577, 2596, 2588,    0, 2593,    0, 2583, 2586,
+     2591, 2588, 2596,    0, 2610, 2603, 2599, 2613,    0, 2618,
+        0, 2615, 2612,    0, 2609,    0, 2615, 2631, 2616, 2633,
+        0,    0, 2625, 2626, 2642, 2619, 2627,    0, 2642, 2638,
+
+     2650, 2648, 2649, 2652, 2656, 2642, 2663, 2650, 2646, 2676,
+     2662,    0,    0, 2664, 2657, 2670, 2661, 2665, 2667, 2669,
+     2671, 2669, 2689, 2692, 2682, 2690, 2698, 2701, 2690, 2687,
+        0, 2689,    0, 2696, 2694, 2695, 2698, 2699, 2698, 2719,
+     2714, 2722, 2724, 2713, 2712, 2723, 2738,    0,    0, 2736,
+      321, 2717, 2727, 2742, 2742, 2739, 2739, 2734,    0,    0,
+        0,    0, 2750, 2747, 2747, 2745, 2760, 2765, 2748, 2750,
+     2751, 2759, 2774, 2756,    0, 2766,    0, 2759, 2779, 2781,
+     2768, 2788, 2785, 2776, 2789, 2794, 2800,    0,    0, 2794,
+        0,    0, 2784, 2789, 2789, 2790, 2811, 2811, 2799, 2809,
+
+     2809, 2825, 2815, 2813, 2829, 2818, 2828, 2816,    0,    0,
+     3975, 3975, 2825, 2813, 2828, 2824, 2820, 2843, 2836, 2837,
+     3975, 2851, 2829, 2844, 2843, 2858, 2847, 3975, 2850, 2864,
+     2852, 2858, 2856, 3975, 2875, 2881,  273,    0, 2858, 2865,
+     2876, 2887, 2868, 2886, 2873, 2878, 2890, 2883, 2894,    0,
+     2886, 2885, 2887, 2903,    0, 2906,    0, 2902,    0, 2908,
+     2909, 2906,    0, 2905, 2925,    0, 2912, 2918, 2921, 2918,
+     2923, 2933, 2919, 2924, 2929,    0, 2935, 2935, 2943, 2945,
+        0, 2942, 2948, 2951, 2937, 2952, 2936, 2947, 2945, 2952,
+        0, 2955, 2965,    0, 2966, 2975, 2956, 2971, 2965, 2967,
+
+     2977, 2985,    0, 2985, 2983, 2988, 2996, 2994,    0, 2992,
+     3001, 2982, 2995, 2991, 3005,    0, 3003, 3001, 3007, 3011,
+     3005,    0, 3009,    0, 3003, 3026, 3008, 3012,    0, 3035,
+     3031,    0, 3024,    0, 3020, 3037, 3020, 3042, 3043, 3038,
+     3041, 3053, 3056, 3056, 3054, 3045, 3056, 3048, 3057, 3061,
+     3070, 3060, 3068, 3058, 3059, 3076, 3081, 3080, 3083, 3088,
+     3085,    0, 3096, 3082, 3083, 3099, 3102,    0,    0, 3093,
+     3104, 3105, 3975, 3099, 3975, 3975, 3105, 3100, 3975, 3105,
+     3103, 3116, 3975, 3123, 3118, 3109, 3108, 3125, 3129, 3975,
+     3132, 3131, 3975,    0, 3130, 3125, 3122, 3132, 3134,    0,
+
+     3130, 3135, 3134, 3149, 3156, 3161, 3164, 3158, 3170, 3155,
+        0, 3165, 3167, 3177, 3162, 3165, 3168, 3183,    0, 3174,
+     3185, 3183, 3187,    0, 3194, 3177, 3184,    0, 3185, 3183,
+     3194, 3190, 3192, 3189, 3190, 3189, 3197, 3204, 3198, 3199,
+     3214, 3213, 3231, 3215, 3230, 3241, 3239, 3222, 3244,    0,
+        0,    0, 3221, 3235, 3232, 3247, 3230, 3249, 3232, 3256,
+        0,    0, 3245, 3259, 3247, 3262, 3249, 3256, 3249,    0,
+     3263, 3252,    0, 3255, 3265,    0, 3265, 3271, 3274,    0,
+     3277, 3288, 3277, 3280,    0, 3285,    0, 3289, 3300,    0,
+     3294, 3281, 3301, 3292, 3299, 3312, 3294,    0,    0, 3291,
+
+        0, 3311, 3306, 3315,    0,    0,    0, 3307, 3309, 3975,
+     3322, 3975, 3975, 3975, 3300, 3307, 3313, 3975, 3316, 3332,
+     3975, 3336, 3337, 3325, 3327,    0, 3348,    0, 3342,    0,
+     3343,    0, 3356, 3344,    0, 3353,    0, 3348, 3355,    0,
+     3358, 3367, 3365, 3369,    0, 3358,    0,    0,    0, 3361,
+        0, 3359, 3374, 3363, 3379, 3384,    0, 3384, 3385, 3380,
+     3378, 3393, 3390, 3391, 3394, 3396, 3383, 3409,    0, 3395,
+     3409, 3408, 3401, 3418, 3421, 3424, 3410, 3430, 3428, 3426,
+     3416, 3428, 3424, 3434, 3420, 3431, 3440, 3433, 3442, 3444,
+     3438, 3448, 3446, 3442, 3456,    0,    0, 3443, 3439, 3449,
+
+     3452, 3458, 3458, 3471,    0,    0,    0, 3467,    0,    0,
+     3462,    0, 3471, 3472, 3486, 3487, 3488, 3476, 3477, 3478,
+     3975, 3489, 3480, 3480,    0, 3499, 3504,    0,    0,    0,
+     3491, 3499,    0,    0,    0, 3497, 3498,    0,    0, 3506,
+        0,    0,    0, 3499, 3519, 3520, 3507, 3526, 3510,    0,
+        0, 3530, 3519, 3532, 3529, 3544, 3533, 3544, 3544,    0,
+     3548, 3535, 3547, 3545, 3545, 3556, 3556, 3550, 3538,    0,
+     3555, 3552, 3548, 3569, 3554, 3554,    0, 3574,    0,    0,
+     3557,    0, 3580,    0,    0,    0, 3564,    0, 3578, 3573,
+     3569,    0, 3975, 3975, 3975, 3975, 3975, 3975, 3578, 3587,
+
+        0, 3585, 3582, 3587, 3584, 3595, 3597, 3597, 3597,    0,
+     3607, 3609, 3617, 3603, 3605,    0,    0,    0,    0, 3611,
+     3611, 3624,    0,    0, 3621,    0,    0, 3617, 3630,    0,
+     3631,    0, 3636, 3620, 3631, 3623,    0,    0, 3641,    0,
+     3631,    0, 3643, 3640,    0, 3642, 3633, 3646,    0, 3644,
+     3649, 3658,    0, 3660, 3652, 3674, 3676, 3664,    0, 3675,
+     3678, 3673,    0, 3661, 3675,    0, 3672, 3680,    0,    0,
+        0, 3685, 3691, 3692, 3678, 3673, 3702, 3686, 3696, 3701,
+        0,    0,    0, 3705, 3707,    0, 3687, 3708,    0, 3716,
+        0,    0,    0, 3721, 3722, 3719, 3715, 3730,  265, 3721,
+
+     3726,    0, 3738, 3740, 3741, 3742,    0,    0,    0, 3733,
+        0,  160, 3975,    0, 3735, 3736, 3739,    0,    0, 3741,
+     3975, 3736, 3741, 3745,    0,    0, 3748, 3749,    0,    0,
+     3975, 3814, 3821, 3828, 3835, 3842,  199, 3849, 3856, 3863,
+     3870, 3877, 3884, 3891, 3898, 3904, 3911, 3918, 3925, 3932,
+     3939, 3946, 3953, 3960, 3967
+    } ;
+
+static const flex_int16_t yy_def[1756] =
+    {   0,
+     1731,    1, 1731,    3, 1732, 1732, 1733, 1733, 1734, 1734,
+     1731,   11, 1731, 1731, 1731, 1731, 1731, 1735, 1736, 1731,
+     1737, 1738, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1739, 1740, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1741, 1742, 1731, 1731, 1731, 1731, 1731, 1743, 1744,
+     1745, 1731, 1731, 1731, 1746, 1731, 1731, 1737, 1737, 1737,
+
+     1737, 1737, 1731, 1735, 1736, 1736, 1731, 1731, 1737, 1737,
+     1737, 1747, 1731, 1748, 1749, 1731, 1731, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1739, 1731, 1740, 1740, 1731, 1731, 1750, 1731, 1751,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1741, 1741, 1741, 1741, 1731, 1742, 1752, 1731,
+     1731, 1743, 1731, 1744, 1745, 1731, 1731, 1731, 1746, 1731,
+     1753, 1737, 1737, 1737, 1737, 1731, 1731, 1731, 1737, 1737,
+
+     1747, 1731, 1748, 1737, 1754, 1749, 1753, 1731, 1731, 1731,
+     1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1731, 1750, 1750, 1751, 1751, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+
+     1731, 1731, 1731, 1731, 1731, 1741, 1741, 1741, 1752, 1752,
+      307, 1737, 1737, 1737, 1737, 1731, 1731, 1737, 1755,  307,
+     1731, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1731, 1731, 1731, 1731,
+
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1741, 1741, 1741, 1731, 1737, 1737, 1737, 1755, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1741, 1741, 1741, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1741, 1741, 1741, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1741, 1741, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1741, 1741, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1741, 1741, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1731, 1731, 1731, 1731, 1731, 1731, 1741, 1741,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1741, 1741, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1741, 1741, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1741, 1741, 1737,
+
+     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1737, 1741, 1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+     1731, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737, 1737,
+        0, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731
+    } ;
+
+static const flex_int16_t yy_nxt[4062] =
+    {   0,
+       14,   15,   16,   15,   14,   17,   18,   14,   17,   19,
+       14,   14,   14,   20,   21,   22,   23,   23,   14,   14,
+       14,   24,   25,   26,   27,   28,   29,   30,   31,   32,
+       33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
+       43,   44,   45,   46,   47,   47,   47,   48,   14,   14,
+       14,   14,   24,   25,   26,   27,   28,   29,   30,   31,
+       32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
+       42,   43,   44,   45,   46,   47,   47,   47,   49,   14,
+       14,   14,   14,   14,   50,   14,   51,   52,   53,   54,
+       55,   56,   51,   57,   58,   51,   51,   51,   51,   59,
+
+       60,   51,   61,   61,   62,   63,   64,   65,   66,   67,
+       68,   69,   70,   71,   51,   72,   73,   51,   74,   51,
+       75,   76,   51,   51,   77,   78,   79,   80,   51,   81,
+       51,   51,   51,   82,   51,   51,   51,   83,   65,   66,
+       67,   68,   69,   70,   71,   51,   72,   73,   51,   74,
+       51,   75,   76,   51,   51,   77,   78,   79,   80,   51,
+       81,   51,   51,   51,   51,   84,   51,   85,   51,   51,
+       51,   86,   88,   88,   88,   88,   89,   89,   92,   90,
+       90,   93,   92,   96,   96,   93,  103,  107,  103,  108,
+      108,  160,   97,   97,  103,  103,  103,  103,  231,  238,
+
+      232,  232,  279,  103,  109,  103,  280,  239,  103, 1721,
+      103,  298,  299,  310,  310,  300,  300,  311,  311,  467,
+      467,   94,  160,  468,  468,   94,   14,   15,   16,   15,
+       14,   17,   18,   14,   17,   14,   14,   14,   14,   14,
+       47,   98,   14,   14,   14,   14,   14,   47,   47,   99,
+       47,  100,   47,   47,   47,   47,   47,   47,   47,  101,
+       47,   47,  102,   47,   47,   47,   47,   47,   47,   47,
+       47,   47,   47,   14,   14,   14,   14,   14,   47,   47,
+       99,   47,  100,   47,   47,   47,   47,   47,   47,   47,
+      101,   47,   47,  102,   47,   47,   47,   47,   47,   47,
+
+       47,   47,   47,   47,   14,   14,   14,   14,   14,   14,
+       14,   14,  110,  110, 1713,  161,  188,  251,  257,  162,
+      258,  111, 1293,  510,  116,  280,  108,  108,  471,  471,
+      233,  233,  472,  472, 1223,  117,  118,  745,  119,  234,
+      466,  266,  516,  516,  464,  120,  161,  188,  251,  257,
+      162,  258,  111,  112,  112,  112,  112,  112,  112,  112,
+      112,  112,  112,  112,  113,  112,  117,  118,  115,  119,
+      234,  112,  266,  112,  121,  174,  120,  153,  122,  271,
+      134,  154,  123,  135,  136,  155,  138,  139,  140,  175,
+      269,  124,  141,  270,  125,  214,  272,  137,  142,  215,
+
+      112,  112,  112,  634,  112,  121,  174,  302,  153,  122,
+      271,  134,  154,  123,  135,  136,  155,  138,  139,  140,
+      175,  269,  124,  141,  270,  125,  214,  272,  137,  142,
+      215,  112,  112,  112,  112,  112,  112,  112,  112,  126,
+      286,  127,  143,  283,  128,  129,  144,  287,  130,  283,
+      145,  131,  280,  146,  132,  133,  147,  149,  241,  148,
+      277,  150,  242,  298,  298,  151,  466,  516,  516,  464,
+      126,  286,  127,  143,  152,  128,  129,  144,  287,  130,
+      288,  145,  131,  288,  146,  132,  133,  147,  149,  241,
+      148,  156,  150,  242,  169,  163,  151,  164,  170,  165,
+
+      157,  158,  171,  166,  243,  152,  167,  159,  292,  176,
+      177,  293,  168,  294,  172,  462,  295,  178,  173,  179,
+      244,  180,  156,  288,  181,  169,  163,  697,  164,  170,
+      165,  157,  158,  171,  166,  243,  225,  167,  159,  292,
+      176,  177,  293,  168,  294,  172,  245,  295,  178,  173,
+      179,  244,  180,  182,  189,  181,  246,  183,  190,  247,
+      312,  184,  191,  208,  185,  317,  320,  186,  192,  225,
+      187,  464,  209,  223,  210,  300,  300,  245,  211,  302,
+      212,  697,  213,  106,  182,  189,  323,  246,  183,  190,
+      247,  312,  184,  191,  208,  185,  317,  320,  186,  192,
+
+      255,  187,  193,  209,  194,  210,  202,  195,  196,  211,
+      203,  212,  197,  213,  204,  256,  198,  323,  106,  199,
+      205,  200,  466,  206,  201,  235,  291,  232,  232,  301,
+      207,  255,  510,  193,  280,  194,  236,  202,  195,  196,
+      248,  203,  519,  197,  249,  204,  256,  198,  290,  227,
+      199,  205,  200,  259,  206,  201,  216,  217,  250,  262,
+      218,  207,  219,  260,  220,  252,  267,  236,  261,  221,
+      268,  248,  318,  253,  263,  249,  283,  264,  265,  321,
+      227,  283,  254,  319,  259,  322,  281,  216,  217,  250,
+      262,  218,  263,  219,  260,  220,  252,  267,  240,  261,
+
+      221,  268,  274,  318,  253,  263,  296,  296,  264,  265,
+      321,  275,  324,  254,  319,  297,  322,  276,  116,  326,
+      108,  108,  110,  110,  327,  328,  325,  277,  334,  117,
+      335,  111,  237,  274,  300,  300,  308,  308,  311,  311,
+      311,  311,  275,  324,  230,  309,  297,  229,  276,  336,
+      326,  468,  468,  337,  338,  327,  328,  325,  228,  334,
+      117,  335,  111,  301,  301,  301,  301,  301,  301,  301,
+      301,  301,  301,  301,  301,  301,  309,  329,  304,  227,
+      336,  301,  313,  301,  337,  338,  314,  331,  332,  333,
+      339,  340,  344,  315,  342,  343,  345,  330,  347,  316,
+
+      346,  350,  348,  351,  356,  341,  349,  357,  329,  358,
+      301,  301,  301,  313,  301,  468,  468,  314,  331,  332,
+      333,  339,  340,  344,  315,  342,  343,  345,  330,  347,
+      316,  346,  350,  348,  351,  356,  341,  349,  357,  226,
+      358,  301,  301,  301,  301,  301,  301,  301,  301,  305,
+      305,  301,  305,  305,  305,  305,  305,  305,  305,  305,
+      305,  305,  359,  363,  307,  472,  472,  305,  352,  305,
+      353,  354,  360,  364,  355,  365,  366,  367,  368,  369,
+      361,  372,  373,  374,  370,  376,  362,  472,  472,  384,
+      375,  395,  225,  359,  363,  371,  305,  305,  305,  352,
+
+      305,  353,  354,  360,  364,  355,  365,  366,  367,  368,
+      369,  361,  372,  373,  374,  370,  376,  362,  381,  377,
+      384,  375,  395,  382,  383,  389,  371,  305,  305,  305,
+      305,  305,  305,  305,  305,  378,  385,  379,  386,  387,
+      396,  390,  380,  397,  388,  391,  392,  393,  399,  381,
+      377,  398,  400,  394,  382,  383,  389,  401,  402,  403,
+      404,  405,  406,  407,  409,  408,  378,  385,  379,  386,
+      387,  396,  390,  380,  397,  388,  391,  392,  393,  399,
+      410,  411,  398,  400,  394,  417,  426,  223,  401,  402,
+      403,  404,  405,  406,  407,  409,  408,  412,  415,  427,
+
+      413,  418,  428,  429,  416,  430,  419,  414,  420,  421,
+      106,  410,  411,  434,  422,  435,  417,  426,  423,  424,
+      438,  425,  439, 1731,  436,  440,  516,  516,  412,  415,
+      427,  413,  418,  428,  429,  416,  430,  419,  414,  420,
+      421,  431,  432,  446,  434,  422,  435,  441,  437,  423,
+      424,  438,  425,  439,  433,  436,  440,  443,  442,  444,
+      447,  450,  451,  452,  453,  445,  454,  455,  448,  456,
+      457,  458,  431,  432,  446,  459,  460,  461,  441,  437,
+      449, 1731,  510,  229,  735,  433,  473, 1731,  443,  442,
+      444,  447,  450,  451,  452,  453,  445,  454,  455,  448,
+
+      456,  457,  458,  233,  233,  474,  459,  460,  461,  233,
+      233,  449,  234,  235,  229,  232,  232,  473,  234,  469,
+      469,  475,  476,  479,  236,  477,  478,  480,  470,  481,
+      483,  484,  485,  486,  487,  488,  474,  492,  493,  489,
+      494,  495,  482,  234,  490,  496,  497,  498,  499,  234,
+      491,  500,  475,  476,  479,  236,  477,  478,  480,  470,
+      481,  483,  484,  485,  486,  487,  488,  503,  492,  493,
+      489,  494,  495,  482,  504,  490,  496,  497,  498,  499,
+      505,  491,  500,  501,  506,  502, 1731,  508,  512,  507,
+      521,  521,  514, 1731,  522,  522,  522,  522,  503, 1731,
+
+      296,  296,  522,  522,  515,  504,  517,  518,  277,  297,
+     1731,  505,  277,  523,  501,  506,  502,  277,  508,  512,
+      507,  104,  104,  514,  104,  104,  104,  104,  104,  104,
+      104,  104,  104,  104,  343,  515,  524,  517,  518,  104,
+      297,  104,  308,  308,  523,  525,  526,  527,  528,  529,
+      530,  309,  513,  531,  532,  533,  534,  535,  536,  537,
+      538,  539,  540,  541,  542,  343,  543,  524,  104,  104,
+      104, 1731,  104,  699,  699, 1731,  525,  526,  527,  528,
+      529,  530,  309,  513,  531,  532,  533,  534,  535,  536,
+      537,  538,  539,  540,  541,  542, 1731,  543,  547,  104,
+
+      104,  104,  104,  104,  104,  104,  104,  301,  301,  301,
+      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
+      544,  548,  304,  699,  699,  301,  549,  301,  545,  547,
+      551,  552,  553,  554,  546,  555,  556,  557,  558,  559,
+      560,  561,  562,  550,  564,  565,  566,  567,  570,  571,
+      563,  544,  548,  572,  301,  301,  301,  549,  301,  545,
+     1731,  551,  552,  553,  554,  546,  555,  556,  557,  558,
+      559,  560,  561,  562,  550,  564,  565,  566,  567,  570,
+      571,  563, 1731,  573,  572,  301,  301,  301,  301,  301,
+      301,  301,  301,  305,  305,  301,  305,  305,  305,  305,
+
+      305,  305,  305,  305,  305,  305,  568,  574,  307,  277,
+      945,  305,  575,  305,  573,  576,  569,  577,  578,  579,
+      580,  582,  583,  584,  581,  585,  586,  587,  590,  588,
+      591,  592,  593,  594,  595,  596,  597,  568,  574,  589,
+      305,  305,  305,  575,  305, 1731,  576,  569,  577,  578,
+      579,  580,  582,  583,  584,  581,  585,  586,  587,  590,
+      588,  591,  592,  593,  594,  595,  596,  597, 1731,  598,
+      589,  305,  305,  305,  305,  305,  305,  305,  305,  104,
+      104,  599,  104,  104,  104,  104,  104,  104,  104,  104,
+      104,  104,  600,  612,  613,  277, 1135,  104,  614,  104,
+
+      598,  615,  616,  626,  627,  628,  629,  630,  520,  631,
+      632,  633,  599,  635,  636,  637,  639,  640,  641,  638,
+     1731,  644,  645,  600,  612,  613,  104,  104,  104,  614,
+      104, 1731,  615,  616,  626,  627,  628,  629,  630,  520,
+      631,  632,  633,  642,  635,  636,  637,  639,  640,  641,
+      638,  643,  644,  645,  646,  650, 1731,  104,  104,  104,
+      104,  104,  104,  104,  104,  601,  602, 1731,  603,  648,
+      604,  605,  653,  606,  642,  654,  607,  655,  647,  608,
+      649,  656,  643,  609,  610,  646,  650,  611, 1731, 1731,
+      657, 1731,  658, 1731, 1731,  659,  601,  602,  651,  603,
+
+      648,  604,  605,  653,  606,  652,  654,  607,  655,  647,
+      608,  649,  656,  660,  609,  610,  661,  662,  611,  617,
+      618,  657,  619,  658,  620,  621,  659,  622,  663,  651,
+      664,  665,  668,  666,  669,  670,  652,  623,  624,  671,
+      672,  625,  673,  674,  660,  667,  675,  661,  662,  676,
+      617,  618,  677,  619,  678,  620,  621,  679,  622,  663,
+      680,  664,  665,  668,  666,  669,  670,  681,  623,  624,
+      671,  672,  625,  673,  674,  682,  667,  675,  683,  684,
+      676,  685,  686,  677,  687,  678,  691,  689,  679,  688,
+      692,  680,  690,  694,  695,  696,  469,  469,  681,  698,
+
+      698,  700,  693,  699,  699,  470,  682,  701,  702,  683,
+      684,  703,  685,  686,  704,  687,  705,  691,  689,  706,
+      688,  692,  707,  690,  694,  695,  696,  708,  709,  710,
+      711,  712,  700,  693,  713,  714,  470,  715,  701,  702,
+      716,  717,  703,  718,  719,  704,  720,  705,  721,  722,
+      706,  723,  724,  707,  725,  726,  727,  728,  708,  709,
+      710,  711,  712,  729,  730,  713,  714,  731,  715,  732,
+     1731,  716,  717,  734,  718,  719,  733,  720,  277,  721,
+      722,  511,  723,  724,  736,  725,  726,  727,  728,  277,
+      737,  738,  739,  511,  729,  730,  740,  741,  731,  742,
+
+      732,  277,  743,  744,  734,  746,  747,  733,  748,  749,
+      750,  751,  511,  752,  753,  736,  754,  756,  757,  758,
+      759,  737,  738,  739,  511,  762,  763,  740,  741,  760,
+      742,  764,  765,  743,  744,  755,  746,  747,  761,  748,
+      749,  750,  751,  766,  752,  753,  767,  754,  756,  757,
+      758,  759,  768,  769,  770,  771,  762,  763,  772,  773,
+      760,  774,  764,  765,  775,  776,  755,  777,  778,  761,
+      779,  780,  781,  782,  766,  783,  784,  767,  785,  786,
+      787,  788,  789,  768,  769,  770,  771,  790,  791,  772,
+      773,  792,  774,  793,  794,  775,  776,  795,  777,  778,
+
+      796,  779,  780,  781,  782,  797,  783,  784,  798,  785,
+      786,  787,  788,  789,  799,  800,  801,  802,  790,  791,
+      803,  806,  792,  804,  793,  794,  807,  808,  795,  809,
+      805,  796,  810,  811,  812,  813,  797,  815,  816,  798,
+      817,  818,  814,  819,  820,  799,  800,  801,  802,  821,
+      822,  803,  806,  823,  804,  827,  828,  807,  808,  829,
+      809,  805,  830,  810,  811,  812,  813,  831,  815,  816,
+      824,  817,  818,  814,  819,  820,  825,  832,  833,  834,
+      821,  822,  835,  836,  823,  837,  827,  828,  826,  838,
+      829,  839,  843,  830,  840,  844,  845,  846,  831,  847,
+
+      841,  824,  848,  849,  852,  853,  854,  825,  832,  833,
+      834,  850,  842,  835,  836,  851,  837,  855,  856,  826,
+      838,  857,  839,  843,  858,  840,  844,  845,  846,  859,
+      847,  841,  860,  848,  849,  852,  853,  854,  861,  862,
+      863,  864,  850,  842,  865,  866,  851,  869,  855,  856,
+      870,  867,  857,  871,  872,  858,  868,  873,  874,  875,
+      859,  876,  877,  860,  878,  879,  880,  881,  882,  861,
+      862,  863,  864,  883,  884,  865,  866,  885,  869,  886,
+      887,  870,  867,  888,  871,  872,  889,  868,  873,  874,
+      875,  890,  876,  877,  891,  878,  879,  880,  881,  882,
+
+      892,  893,  894,  895,  883,  884,  898,  900,  885,  896,
+      886,  887,  901,  897,  888,  902,  899,  889,  903,  904,
+      905,  906,  890,  907,  908,  891,  909,  910,  911,  912,
+      913,  892,  893,  894,  895,  914,  915,  898,  900,  916,
+      896,  917,  918,  901,  897,  919,  902,  899,  920,  903,
+      904,  905,  906,  921,  907,  908,  922,  909,  910,  911,
+      912,  913,  923,  924,  925,  926,  914,  915,  927,  928,
+      916,  929,  917,  918,  930,  931,  919,  932,  933,  920,
+      934,  935,  936,  937,  921,  938,  939,  922,  940,  941,
+      942,  943, 1731,  923,  924,  925,  926,  944,  947,  927,
+
+      928,  948,  929,  949,  950,  930,  931,  951,  932,  933,
+      946,  934,  935,  936,  937,  952,  938,  939,  953,  940,
+      941,  942,  943,  277,  954,  277,  955,  956,  944,  947,
+      957,  958,  948,  959,  949,  950,  960,  961,  951,  962,
+      963,  946,  964,  965,  966,  968,  952,  967,  969,  953,
+      970,  971,  972,  973,  974,  954,  975,  955,  956,  976,
+      977,  957,  958,  980,  959,  978,  979,  960,  961,  981,
+      962,  963,  982,  964,  965,  966,  968,  983,  967,  969,
+      984,  970,  971,  972,  973,  974,  985,  975,  986,  987,
+      976,  977,  988,  989,  980,  990,  978,  979,  991,  992,
+
+      981, 1731, 1731,  982,  998,  999, 1000, 1001,  983, 1002,
+     1003,  984, 1004, 1005, 1006,  993, 1731,  985, 1012,  986,
+      987, 1013, 1731,  988,  989,  994,  990, 1014,  995,  991,
+      992, 1731,  996,  997, 1015,  998,  999, 1000, 1001, 1016,
+     1002, 1003, 1017, 1004, 1005, 1006,  993, 1007, 1018, 1012,
+     1008, 1019, 1013, 1009, 1020, 1021,  994, 1010, 1014,  995,
+     1022, 1023, 1011,  996,  997, 1015, 1024, 1025, 1026, 1027,
+     1016, 1028, 1029, 1017, 1030, 1031, 1032, 1033, 1007, 1018,
+     1034, 1008, 1019, 1035, 1009, 1020, 1021, 1036, 1010, 1037,
+     1038, 1022, 1023, 1011, 1039, 1040, 1041, 1024, 1025, 1026,
+
+     1027, 1042, 1028, 1029, 1043, 1030, 1031, 1032, 1033, 1044,
+     1045, 1034, 1046, 1047, 1035, 1048, 1049, 1050, 1036, 1051,
+     1037, 1038, 1052, 1053, 1054, 1039, 1040, 1041, 1055, 1056,
+     1057, 1058, 1042, 1059, 1060, 1043, 1061, 1062, 1063, 1064,
+     1044, 1045, 1065, 1046, 1047, 1068, 1048, 1049, 1050, 1066,
+     1051, 1069, 1070, 1052, 1053, 1054, 1071, 1074, 1067, 1055,
+     1056, 1057, 1058, 1075, 1059, 1060, 1076, 1061, 1062, 1063,
+     1064, 1072, 1077, 1065, 1078, 1079, 1068, 1080, 1073, 1081,
+     1066, 1085, 1069, 1070, 1086, 1087, 1088, 1071, 1074, 1067,
+     1089, 1090, 1091, 1082, 1075, 1083, 1092, 1076, 1093, 1094,
+
+     1095, 1096, 1072, 1077, 1099, 1078, 1079, 1097, 1080, 1073,
+     1081, 1084, 1085, 1098, 1100, 1086, 1087, 1088, 1101, 1103,
+     1104, 1089, 1090, 1091, 1082, 1105, 1083, 1092, 1102, 1093,
+     1094, 1095, 1096, 1106, 1107, 1099, 1108, 1109, 1097, 1110,
+     1111, 1112, 1084, 1113, 1098, 1100, 1114, 1115, 1116, 1101,
+     1103, 1104, 1117, 1118, 1119, 1120, 1105, 1121, 1122, 1102,
+     1123, 1124, 1125, 1126, 1106, 1107, 1127, 1108, 1109, 1128,
+     1110, 1111, 1112, 1129, 1113, 1130, 1131, 1114, 1115, 1116,
+     1132, 1133, 1134, 1117, 1118, 1119, 1120, 1138, 1121, 1122,
+     1136, 1123, 1124, 1125, 1126, 1137, 1139, 1127, 1140, 1141,
+
+     1128, 1142, 1143, 1144, 1129, 1145, 1130, 1131, 1146, 1147,
+     1148, 1132, 1133, 1134, 1149, 1150,  277, 1151, 1138,  277,
+     1152, 1136, 1153, 1154, 1155, 1156, 1137, 1139, 1157, 1140,
+     1141, 1158, 1142, 1143, 1144, 1159, 1145, 1160, 1161, 1146,
+     1147, 1148, 1162, 1163, 1164, 1149, 1150, 1165, 1151, 1166,
+     1167, 1152, 1168, 1153, 1154, 1155, 1156, 1169, 1170, 1157,
+     1171, 1172, 1158, 1173, 1174, 1175, 1159, 1176, 1160, 1161,
+     1177, 1178, 1179, 1162, 1163, 1164, 1180, 1181, 1165, 1182,
+     1166, 1167, 1183, 1168, 1184, 1185, 1186, 1189, 1169, 1170,
+     1190, 1171, 1172, 1191, 1173, 1174, 1175, 1187, 1176, 1192,
+
+     1193, 1177, 1178, 1179, 1194, 1188, 1195, 1180, 1181, 1196,
+     1182, 1197, 1198, 1183, 1199, 1184, 1185, 1186, 1189, 1200,
+     1201, 1190, 1202, 1203, 1191, 1204, 1205, 1206, 1187, 1207,
+     1192, 1193, 1208, 1209, 1210, 1194, 1188, 1195, 1211, 1212,
+     1196, 1213, 1197, 1198, 1214, 1199, 1215, 1216, 1217, 1218,
+     1200, 1201, 1219, 1202, 1203, 1220, 1204, 1205, 1206, 1221,
+     1207, 1222, 1224, 1208, 1209, 1210, 1225, 1226, 1227, 1211,
+     1212, 1228, 1213, 1229, 1230, 1214, 1231, 1215, 1216, 1217,
+     1218, 1232, 1233, 1219, 1234, 1235, 1220, 1236, 1237, 1238,
+     1221, 1239, 1222, 1224, 1240, 1241, 1242, 1225, 1226, 1227,
+
+     1243, 1244, 1228, 1245, 1229, 1230, 1246, 1231, 1247, 1248,
+     1249, 1250, 1232, 1233, 1251, 1234, 1235, 1252, 1236, 1237,
+     1238, 1254, 1239, 1255, 1256, 1240, 1241, 1242, 1257, 1258,
+     1259, 1243, 1244, 1253, 1245, 1260, 1261, 1246, 1262, 1247,
+     1248, 1249, 1250, 1263, 1264, 1251, 1265, 1266, 1252, 1267,
+     1268, 1269, 1254, 1270, 1255, 1256, 1271, 1272, 1273, 1257,
+     1258, 1259, 1274, 1275, 1253, 1276, 1260, 1261, 1277, 1262,
+     1278, 1279, 1280, 1281, 1263, 1264, 1282, 1265, 1266, 1283,
+     1267, 1268, 1269, 1284, 1270, 1285, 1286, 1271, 1272, 1273,
+     1287, 1288, 1289, 1274, 1275, 1290, 1276, 1294, 1291, 1277,
+
+     1295, 1278, 1279, 1280, 1281, 1296, 1292, 1282, 1297, 1298,
+     1283, 1299, 1300, 1301, 1284, 1302, 1285, 1286, 1303, 1304,
+     1305, 1287, 1288, 1289,  277, 1306, 1290, 1307, 1294, 1291,
+      277, 1295, 1308, 1309, 1310, 1311, 1296, 1292, 1312, 1297,
+     1298, 1313, 1299, 1300, 1301, 1314, 1302, 1315, 1316, 1303,
+     1304, 1305, 1317, 1318, 1319, 1320, 1306, 1321, 1307, 1322,
+     1323, 1324, 1325, 1308, 1309, 1310, 1311, 1326, 1327, 1312,
+     1328, 1329, 1313, 1330, 1331, 1332, 1314, 1333, 1315, 1316,
+     1334, 1335, 1336, 1317, 1318, 1319, 1320, 1337, 1321, 1338,
+     1322, 1323, 1324, 1325, 1339, 1340, 1341, 1342, 1326, 1327,
+
+     1343, 1328, 1329, 1344, 1330, 1331, 1332, 1345, 1333, 1346,
+     1347, 1334, 1335, 1336, 1348, 1349, 1350, 1351, 1337, 1352,
+     1338, 1353, 1354, 1355, 1356, 1339, 1340, 1341, 1342, 1357,
+     1358, 1343, 1359, 1360, 1344, 1361, 1362, 1363, 1345, 1366,
+     1346, 1347, 1364, 1369, 1365, 1348, 1349, 1350, 1351, 1367,
+     1352, 1370, 1353, 1354, 1355, 1356, 1371, 1372, 1373, 1374,
+     1357, 1358, 1375, 1359, 1360, 1376, 1361, 1362, 1363, 1368,
+     1366, 1377, 1378, 1364, 1369, 1365, 1379, 1380, 1381, 1382,
+     1367, 1383, 1370, 1384, 1385, 1386, 1387, 1371, 1372, 1373,
+     1374, 1388, 1389, 1375, 1390, 1391, 1376, 1392, 1393, 1394,
+
+     1368, 1395, 1377, 1378, 1396, 1398, 1397, 1379, 1380, 1381,
+     1382, 1399, 1383, 1400, 1384, 1385, 1386, 1387, 1401, 1402,
+     1403, 1404, 1388, 1389, 1405, 1390, 1391, 1406, 1392, 1393,
+     1394, 1407, 1395, 1408, 1409, 1396, 1398, 1397, 1410, 1411,
+     1412, 1413, 1399, 1414, 1400, 1415, 1416, 1417, 1418, 1401,
+     1402, 1403, 1404, 1419, 1420, 1405, 1421, 1422, 1406, 1424,
+     1425, 1426, 1407, 1423, 1408, 1409, 1427, 1428, 1429, 1410,
+     1411, 1412, 1413, 1430, 1414, 1431, 1415, 1416, 1417, 1418,
+      277,  277, 1432, 1433, 1419, 1420, 1434, 1421, 1422, 1435,
+     1424, 1425, 1426, 1436, 1423, 1437, 1438, 1427, 1428, 1429,
+
+     1439, 1440, 1441, 1442, 1430, 1443, 1431, 1444, 1445, 1446,
+     1447, 1448, 1449, 1432, 1433, 1450, 1451, 1434, 1452, 1453,
+     1435, 1454, 1455, 1456, 1436, 1457, 1437, 1438, 1458, 1459,
+     1460, 1439, 1440, 1441, 1442, 1461, 1443, 1462, 1444, 1445,
+     1446, 1447, 1448, 1449, 1463, 1464, 1450, 1451, 1465, 1452,
+     1453, 1466, 1454, 1455, 1456, 1467, 1457, 1468, 1469, 1458,
+     1459, 1460, 1470, 1471, 1472, 1473, 1461, 1474, 1462, 1475,
+     1476, 1477, 1478, 1479, 1480, 1463, 1464, 1481, 1482, 1465,
+     1483, 1484, 1466, 1485, 1486, 1487, 1467, 1488, 1468, 1469,
+     1489, 1490, 1491, 1470, 1471, 1472, 1473, 1492, 1474, 1493,
+
+     1475, 1476, 1477, 1478, 1479, 1480, 1494, 1495, 1481, 1482,
+     1496, 1483, 1484, 1497, 1485, 1486, 1487, 1498, 1488, 1499,
+     1500, 1489, 1490, 1491, 1501, 1502, 1503, 1504, 1492, 1505,
+     1493, 1506, 1507, 1508, 1509, 1510, 1511, 1494, 1495, 1512,
+     1513, 1496, 1514, 1515, 1497, 1516, 1517, 1518, 1498, 1519,
+     1499, 1500, 1520, 1521, 1731, 1501, 1502, 1503, 1504, 1524,
+     1505, 1525, 1506, 1507, 1508, 1509, 1510, 1511, 1522, 1523,
+     1512, 1513, 1526, 1514, 1515, 1527, 1516, 1517, 1518, 1528,
+     1519, 1529, 1530, 1520, 1521,  277,  277, 1531, 1532, 1533,
+     1524, 1534, 1525, 1535, 1536, 1537, 1538, 1539, 1540, 1522,
+
+     1523, 1541, 1542, 1526, 1543, 1544, 1527, 1545, 1546, 1547,
+     1528, 1548, 1529, 1530, 1549, 1550, 1551, 1552, 1531, 1532,
+     1533, 1553, 1534, 1554, 1535, 1536, 1537, 1538, 1539, 1540,
+     1555, 1556, 1541, 1542, 1557, 1543, 1544, 1558, 1545, 1546,
+     1547, 1559, 1548, 1560, 1561, 1549, 1550, 1551, 1552, 1562,
+     1563, 1564, 1553, 1565, 1554, 1566, 1567, 1568, 1569, 1570,
+     1571, 1555, 1556, 1572, 1573, 1557, 1574, 1575, 1558, 1576,
+     1577, 1578, 1559, 1579, 1560, 1561, 1580, 1581, 1582, 1583,
+     1562, 1563, 1564, 1584, 1565, 1585, 1566, 1567, 1568, 1569,
+     1570, 1571, 1586, 1587, 1572, 1573, 1588, 1574, 1575, 1589,
+
+     1576, 1577, 1578, 1590, 1579, 1591, 1592, 1580, 1581, 1582,
+     1583, 1593, 1594, 1595, 1584, 1596, 1585, 1597, 1598, 1600,
+     1601, 1599, 1602, 1586, 1587, 1603, 1604, 1588, 1606,  277,
+     1589, 1605, 1607, 1608, 1590, 1609, 1591, 1592,  277, 1610,
+     1611, 1612, 1593, 1594, 1595, 1613, 1596, 1614, 1597, 1598,
+     1600, 1601, 1599, 1602, 1615, 1616, 1603, 1604, 1617, 1606,
+     1618, 1619, 1605, 1607, 1608, 1620, 1609, 1621, 1622, 1623,
+     1610, 1611, 1612, 1624, 1625, 1626, 1613, 1627, 1614, 1628,
+     1629, 1630, 1631, 1632, 1633, 1615, 1616, 1634, 1635, 1617,
+     1636, 1618, 1619, 1637, 1638, 1639, 1620, 1640, 1621, 1622,
+
+     1623, 1641, 1642, 1643, 1624, 1625, 1626, 1644, 1627, 1645,
+     1628, 1629, 1630, 1631, 1632, 1633, 1647, 1646, 1634, 1635,
+     1648, 1636, 1649, 1650, 1637, 1638, 1639,  277, 1640, 1651,
+     1652, 1653, 1641, 1642, 1643, 1654,  277, 1655, 1644, 1656,
+     1645, 1657, 1658, 1659, 1660, 1661, 1662, 1647, 1646, 1663,
+     1664, 1648, 1665, 1649, 1650, 1666, 1667, 1668, 1669, 1670,
+     1651, 1652, 1653, 1671, 1672, 1673, 1654, 1674, 1655, 1675,
+     1656, 1676, 1657, 1658, 1659, 1660, 1661, 1662, 1678, 1677,
+     1663, 1664,  277, 1665, 1679, 1680, 1666, 1667, 1668, 1669,
+     1670,  277, 1681, 1682, 1671, 1672, 1673, 1683, 1674, 1684,
+
+     1675, 1685, 1676, 1686, 1687, 1688, 1689, 1690, 1691, 1678,
+     1677, 1692, 1693, 1694, 1695, 1679, 1680, 1696, 1697, 1698,
+     1731, 1700,  277, 1681, 1682, 1701, 1702, 1699, 1683, 1703,
+     1684, 1704, 1685, 1705, 1686, 1687, 1688, 1689, 1690, 1691,
+     1706, 1707, 1692, 1693, 1694, 1695, 1708, 1709, 1696, 1697,
+     1698,  277, 1700, 1710, 1711, 1712, 1701, 1702, 1699, 1714,
+     1703, 1715, 1704, 1716, 1705, 1717, 1718, 1719, 1720, 1722,
+     1723, 1706, 1707, 1724, 1725, 1726, 1727, 1708, 1709,  277,
+     1728, 1729, 1730, 1731, 1710, 1711, 1712, 1731, 1731, 1731,
+     1714, 1731, 1715, 1731, 1716, 1731, 1717, 1718, 1719, 1720,
+
+     1722, 1723, 1731, 1731, 1724, 1725, 1726, 1727, 1731, 1731,
+     1731, 1728, 1729, 1730,   87,   87,   87,   87,   87,   87,
+       87,   91,   91,   91,   91,   91,   91,   91,   95,   95,
+       95,   95,   95,   95,   95,  104, 1731,  104,  104,  104,
+      104,  104,  105, 1731,  105,  105,  105,  105,  105,  114,
+      114,  114,  114,  114,  114,  114,  222,  222,  222,  222,
+      222,  222,  222,  224, 1731,  224,  224,  224,  224,  224,
+      273,  273,  273,  273,  273,  273,  273,  278,  278,  278,
+      278,  278,  278,  278,  282,  282,  282,  282,  282,  282,
+      282,  284,  284,  284,  284,  284,  284,  284,  285,  285,
+
+     1731, 1731,  285,  285,  289, 1731,  289,  289, 1731,  289,
+      289,  301,  301,  301,  301,  301,  301,  301,  303,  303,
+      303,  303,  303,  303,  303,  306,  306,  306,  306,  306,
+      306,  306,  463,  463, 1731,  463,  463,  463,  463,  465,
+      465,  465, 1731,  465,  465,  465,  509,  509,  509,  509,
+      509,  509,  509,  511, 1731,  511,  511,  511,  511,  511,
+      305,  305,  305,  305,  305,  305,  305,  104, 1731,  104,
+      104,  104,  104,  104,   13, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731
+    } ;
+
+static const flex_int16_t yy_chk[4062] =
+    {   0,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,    1,    1,    3,    3,    3,    3,
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
+        3,    3,    5,    6,    5,    6,    5,    6,    7,    5,
+        6,    7,    8,    9,   10,    8,   15,   20,   15,   20,
+       20,   33,    9,   10,   52,   54,   52,   54,   59,   63,
+
+       59,   59,   83,   88, 1737,   88,   83,   63,  103, 1712,
+      103,  111,  111,  117,  117,  111,  111,  117,  117,  234,
+      234,    7,   33,  234,  234,    8,   11,   11,   11,   11,
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+
+       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
+       11,   11,   21,   21, 1699,   34,   40,   69,   72,   34,
+       73,   21, 1137,  279,   23,  279,   23,   23,  236,  236,
+       60,   60,  236,  236, 1051,   23,   24,  528,   24,   60,
+      465,   77,  298,  298,  463,   24,   34,   40,   69,   72,
+       34,   73,   21,   22,   22,   22,   22,   22,   22,   22,
+       22,   22,   22,   22,   22,   22,   23,   24,   22,   24,
+       60,   22,   77,   22,   25,   37,   24,   31,   25,   80,
+       27,   31,   25,   27,   27,   31,   28,   28,   28,   37,
+       79,   25,   28,   79,   25,   45,   81,   27,   28,   45,
+
+       22,   22,   22,  403,   22,   25,   37,  301,   31,   25,
+       80,   27,   31,   25,   27,   27,   31,   28,   28,   28,
+       37,   79,   25,   28,   79,   25,   45,   81,   27,   28,
+       45,   22,   22,   22,   22,   22,   22,   22,   22,   26,
+       92,   26,   29,  284,   26,   26,   29,   93,   26,  282,
+       29,   26,  278,   29,   26,   26,   29,   30,   65,   29,
+      273,   30,   65,  297,  297,   30,  230,  297,  297,  228,
+       26,   92,   26,   29,   30,   26,   26,   29,   93,   26,
+       94,   29,   26,   94,   29,   26,   26,   29,   30,   65,
+       29,   32,   30,   65,   36,   35,   30,   35,   36,   35,
+
+       32,   32,   36,   35,   66,   30,   35,   32,   99,   38,
+       38,  100,   35,  101,   36,  226,  102,   38,   36,   38,
+       66,   38,   32,   94,   38,   36,   35,  464,   35,   36,
+       35,   32,   32,   36,   35,   66,  225,   35,   32,   99,
+       38,   38,  100,   35,  101,   36,   67,  102,   38,   36,
+       38,   66,   38,   39,   41,   38,   67,   39,   41,   67,
+      118,   39,   41,   44,   39,  120,  122,   39,   41,  224,
+       39,  464,   44,  222,   44,  299,  299,   67,   44,  112,
+       44,  466,   44,  106,   39,   41,  124,   67,   39,   41,
+       67,  118,   39,   41,   44,   39,  120,  122,   39,   41,
+
+       71,   39,   42,   44,   42,   44,   43,   42,   42,   44,
+       43,   44,   42,   44,   43,   71,   42,  124,  105,   42,
+       43,   42,  466,   43,   42,   61,   98,   61,   61,  305,
+       43,   71,  509,   42,  509,   42,   61,   43,   42,   42,
+       68,   43,  305,   42,   68,   43,   71,   42,   97,   75,
+       42,   43,   42,   74,   43,   42,   46,   46,   68,   75,
+       46,   43,   46,   74,   46,   70,   78,   61,   74,   46,
+       78,   68,  121,   70,   76,   68,   90,   76,   76,  123,
+       75,   89,   70,  121,   74,  123,   85,   46,   46,   68,
+       75,   46,   84,   46,   74,   46,   70,   78,   64,   74,
+
+       46,   78,   82,  121,   70,   76,  107,  107,   76,   76,
+      123,   82,  125,   70,  121,  107,  123,   82,  108,  127,
+      108,  108,  110,  110,  128,  129,  125,   82,  133,  108,
+      134,  110,   62,   82,  300,  300,  116,  116,  310,  310,
+      311,  311,   82,  125,   58,  116,  107,   57,   82,  136,
+      127,  467,  467,  136,  137,  128,  129,  125,   56,  133,
+      108,  134,  110,  114,  114,  114,  114,  114,  114,  114,
+      114,  114,  114,  114,  114,  114,  116,  130,  114,   55,
+      136,  114,  119,  114,  136,  137,  119,  131,  131,  131,
+      138,  139,  141,  119,  140,  140,  142,  130,  143,  119,
+
+      142,  145,  144,  146,  148,  139,  144,  149,  130,  150,
+      114,  114,  114,  119,  114,  468,  468,  119,  131,  131,
+      131,  138,  139,  141,  119,  140,  140,  142,  130,  143,
+      119,  142,  145,  144,  146,  148,  139,  144,  149,   50,
+      150,  114,  114,  114,  114,  114,  114,  114,  114,  115,
+      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
+      115,  115,  151,  153,  115,  471,  471,  115,  147,  115,
+      147,  147,  152,  154,  147,  155,  156,  157,  158,  158,
+      152,  159,  160,  161,  158,  162,  152,  472,  472,  166,
+      161,  172,   49,  151,  153,  158,  115,  115,  115,  147,
+
+      115,  147,  147,  152,  154,  147,  155,  156,  157,  158,
+      158,  152,  159,  160,  161,  158,  162,  152,  165,  163,
+      166,  161,  172,  165,  165,  170,  158,  115,  115,  115,
+      115,  115,  115,  115,  115,  163,  169,  163,  169,  169,
+      173,  170,  163,  174,  169,  171,  171,  171,  175,  165,
+      163,  174,  175,  171,  165,  165,  170,  176,  177,  178,
+      179,  180,  181,  182,  183,  182,  163,  169,  163,  169,
+      169,  173,  170,  163,  174,  169,  171,  171,  171,  175,
+      184,  185,  174,  175,  171,  188,  191,   48,  176,  177,
+      178,  179,  180,  181,  182,  183,  182,  186,  187,  192,
+
+      186,  189,  193,  194,  187,  195,  189,  186,  190,  190,
+       19,  184,  185,  197,  190,  198,  188,  191,  190,  190,
+      200,  190,  201,   13,  199,  202,  516,  516,  186,  187,
+      192,  186,  189,  193,  194,  187,  195,  189,  186,  190,
+      190,  196,  196,  205,  197,  190,  198,  203,  199,  190,
+      190,  200,  190,  201,  196,  199,  202,  204,  203,  204,
+      206,  207,  210,  212,  213,  204,  214,  215,  206,  216,
+      217,  218,  196,  196,  205,  219,  220,  221,  203,  199,
+      206,    0,  510,  241,  510,  196,  242,    0,  204,  203,
+      204,  206,  207,  210,  212,  213,  204,  214,  215,  206,
+
+      216,  217,  218,  231,  231,  243,  219,  220,  221,  233,
+      233,  206,  231,  232,  241,  232,  232,  242,  233,  235,
+      235,  244,  245,  247,  232,  246,  246,  248,  235,  249,
+      250,  251,  252,  253,  254,  255,  243,  258,  259,  257,
+      260,  262,  249,  231,  257,  264,  265,  266,  267,  233,
+      257,  268,  244,  245,  247,  232,  246,  246,  248,  235,
+      249,  250,  251,  252,  253,  254,  255,  270,  258,  259,
+      257,  260,  262,  249,  271,  257,  264,  265,  266,  267,
+      272,  257,  268,  269,  274,  269,    0,  276,  292,  275,
+      309,  309,  294,    0,  309,  309,  521,  521,  270,    0,
+
+      296,  296,  522,  522,  295,  271,  302,  304,  276,  296,
+        0,  272,  274,  312,  269,  274,  269,  275,  276,  292,
+      275,  291,  291,  294,  291,  291,  291,  291,  291,  291,
+      291,  291,  291,  291,  293,  295,  313,  302,  304,  291,
+      296,  291,  308,  308,  312,  314,  315,  316,  317,  318,
+      319,  308,  293,  320,  321,  322,  323,  324,  325,  326,
+      327,  328,  329,  330,  331,  293,  332,  313,  291,  291,
+      291,    0,  291,  698,  698,    0,  314,  315,  316,  317,
+      318,  319,  308,  293,  320,  321,  322,  323,  324,  325,
+      326,  327,  328,  329,  330,  331,    0,  332,  335,  291,
+
+      291,  291,  291,  291,  291,  291,  291,  303,  303,  303,
+      303,  303,  303,  303,  303,  303,  303,  303,  303,  303,
+      333,  336,  303,  699,  699,  303,  337,  303,  333,  335,
+      338,  339,  340,  341,  333,  342,  344,  345,  346,  347,
+      348,  349,  350,  337,  351,  352,  353,  354,  356,  358,
+      350,  333,  336,  359,  303,  303,  303,  337,  303,  333,
+        0,  338,  339,  340,  341,  333,  342,  344,  345,  346,
+      347,  348,  349,  350,  337,  351,  352,  353,  354,  356,
+      358,  350,    0,  360,  359,  303,  303,  303,  303,  303,
+      303,  303,  303,  306,  306,  306,  306,  306,  306,  306,
+
+      306,  306,  306,  306,  306,  306,  355,  361,  306,  733,
+      733,  306,  362,  306,  360,  363,  355,  364,  365,  367,
+      368,  369,  370,  371,  368,  372,  373,  374,  376,  375,
+      377,  378,  379,  380,  381,  382,  383,  355,  361,  375,
+      306,  306,  306,  362,  306,    0,  363,  355,  364,  365,
+      367,  368,  369,  370,  371,  368,  372,  373,  374,  376,
+      375,  377,  378,  379,  380,  381,  382,  383,    0,  384,
+      375,  306,  306,  306,  306,  306,  306,  306,  306,  307,
+      307,  386,  307,  307,  307,  307,  307,  307,  307,  307,
+      307,  307,  387,  389,  390,  944,  944,  307,  390,  307,
+
+      384,  391,  392,  394,  395,  396,  397,  398,  307,  399,
+      400,  401,  386,  404,  405,  406,  407,  408,  409,  406,
+        0,  411,  412,  387,  389,  390,  307,  307,  307,  390,
+      307,    0,  391,  392,  394,  395,  396,  397,  398,  307,
+      399,  400,  401,  410,  404,  405,  406,  407,  408,  409,
+      406,  410,  411,  412,  413,  415,    0,  307,  307,  307,
+      307,  307,  307,  307,  307,  388,  388,    0,  388,  414,
+      388,  388,  417,  388,  410,  418,  388,  419,  413,  388,
+      414,  420,  410,  388,  388,  413,  415,  388,    0,    0,
+      421,    0,  422,    0,    0,  423,  388,  388,  416,  388,
+
+      414,  388,  388,  417,  388,  416,  418,  388,  419,  413,
+      388,  414,  420,  424,  388,  388,  425,  426,  388,  393,
+      393,  421,  393,  422,  393,  393,  423,  393,  427,  416,
+      428,  429,  431,  430,  432,  433,  416,  393,  393,  434,
+      435,  393,  436,  437,  424,  430,  439,  425,  426,  440,
+      393,  393,  441,  393,  442,  393,  393,  443,  393,  427,
+      444,  428,  429,  431,  430,  432,  433,  445,  393,  393,
+      434,  435,  393,  436,  437,  446,  430,  439,  447,  448,
+      440,  449,  450,  441,  451,  442,  453,  452,  443,  451,
+      454,  444,  452,  455,  458,  461,  469,  469,  445,  470,
+
+      470,  473,  454,  470,  470,  469,  446,  474,  475,  447,
+      448,  476,  449,  450,  477,  451,  478,  453,  452,  479,
+      451,  454,  480,  452,  455,  458,  461,  481,  482,  483,
+      484,  485,  473,  454,  486,  487,  469,  488,  474,  475,
+      489,  490,  476,  491,  492,  477,  493,  478,  494,  496,
+      479,  497,  498,  480,  499,  500,  501,  502,  481,  482,
+      483,  484,  485,  503,  504,  486,  487,  505,  488,  506,
+        0,  489,  490,  508,  491,  492,  507,  493,  506,  494,
+      496,  511,  497,  498,  512,  499,  500,  501,  502,  507,
+      514,  515,  519,  520,  503,  504,  523,  524,  505,  525,
+
+      506,  508,  526,  527,  508,  529,  530,  507,  531,  532,
+      533,  534,  511,  535,  537,  512,  538,  539,  540,  541,
+      542,  514,  515,  519,  520,  544,  545,  523,  524,  543,
+      525,  546,  547,  526,  527,  538,  529,  530,  543,  531,
+      532,  533,  534,  548,  535,  537,  549,  538,  539,  540,
+      541,  542,  550,  551,  552,  553,  544,  545,  554,  555,
+      543,  556,  546,  547,  557,  558,  538,  559,  560,  543,
+      562,  563,  564,  565,  548,  566,  567,  549,  568,  569,
+      571,  572,  573,  550,  551,  552,  553,  574,  575,  554,
+      555,  576,  556,  577,  578,  557,  558,  579,  559,  560,
+
+      580,  562,  563,  564,  565,  581,  566,  567,  582,  568,
+      569,  571,  572,  573,  583,  584,  585,  587,  574,  575,
+      588,  590,  576,  589,  577,  578,  591,  592,  579,  593,
+      589,  580,  594,  595,  597,  598,  581,  599,  601,  582,
+      602,  603,  598,  604,  605,  583,  584,  585,  587,  606,
+      607,  588,  590,  608,  589,  610,  611,  591,  592,  612,
+      593,  589,  613,  594,  595,  597,  598,  614,  599,  601,
+      609,  602,  603,  598,  604,  605,  609,  615,  616,  617,
+      606,  607,  618,  619,  608,  620,  610,  611,  609,  621,
+      612,  622,  624,  613,  623,  625,  626,  627,  614,  628,
+
+      623,  609,  630,  632,  634,  635,  636,  609,  615,  616,
+      617,  633,  623,  618,  619,  633,  620,  637,  638,  609,
+      621,  639,  622,  624,  640,  623,  625,  626,  627,  641,
+      628,  623,  642,  630,  632,  634,  635,  636,  643,  644,
+      645,  646,  633,  623,  647,  648,  633,  650,  637,  638,
+      651,  649,  639,  652,  653,  640,  649,  654,  655,  656,
+      641,  657,  658,  642,  659,  660,  661,  662,  663,  643,
+      644,  645,  646,  664,  665,  647,  648,  666,  650,  667,
+      668,  651,  649,  669,  652,  653,  670,  649,  654,  655,
+      656,  671,  657,  658,  672,  659,  660,  661,  662,  663,
+
+      673,  674,  675,  676,  664,  665,  679,  681,  666,  677,
+      667,  668,  682,  677,  669,  683,  679,  670,  684,  685,
+      687,  688,  671,  689,  690,  672,  691,  692,  693,  694,
+      695,  673,  674,  675,  676,  701,  702,  679,  681,  703,
+      677,  704,  705,  682,  677,  706,  683,  679,  707,  684,
+      685,  687,  688,  708,  689,  690,  709,  691,  692,  693,
+      694,  695,  710,  711,  712,  713,  701,  702,  714,  715,
+      703,  716,  704,  705,  717,  718,  706,  719,  720,  707,
+      721,  722,  723,  724,  708,  725,  726,  709,  727,  728,
+      730,  731,    0,  710,  711,  712,  713,  732,  736,  714,
+
+      715,  738,  716,  741,  743,  717,  718,  744,  719,  720,
+      734,  721,  722,  723,  724,  746,  725,  726,  747,  727,
+      728,  730,  731,  734,  749,  732,  750,  751,  732,  736,
+      752,  753,  738,  754,  741,  743,  756,  757,  744,  757,
+      758,  734,  759,  760,  761,  762,  746,  761,  763,  747,
+      764,  765,  767,  768,  769,  749,  770,  750,  751,  773,
+      775,  752,  753,  778,  754,  776,  776,  756,  757,  779,
+      757,  758,  780,  759,  760,  761,  762,  781,  761,  763,
+      782,  764,  765,  767,  768,  769,  783,  770,  784,  786,
+      773,  775,  787,  789,  778,  790,  776,  776,  793,  794,
+
+      779,    0,    0,  780,  796,  797,  799,  800,  781,  802,
+      803,  782,  804,  805,  806,  795,    0,  783,  809,  784,
+      786,  811,    0,  787,  789,  795,  790,  812,  795,  793,
+      794,    0,  795,  795,  813,  796,  797,  799,  800,  814,
+      802,  803,  815,  804,  805,  806,  795,  807,  816,  809,
+      807,  817,  811,  807,  818,  819,  795,  807,  812,  795,
+      820,  821,  807,  795,  795,  813,  822,  823,  824,  825,
+      814,  826,  827,  815,  828,  829,  830,  831,  807,  816,
+      833,  807,  817,  834,  807,  818,  819,  835,  807,  836,
+      837,  820,  821,  807,  838,  839,  840,  822,  823,  824,
+
+      825,  841,  826,  827,  842,  828,  829,  830,  831,  843,
+      844,  833,  846,  848,  834,  849,  850,  851,  835,  852,
+      836,  837,  853,  854,  855,  838,  839,  840,  856,  857,
+      858,  859,  841,  860,  861,  842,  862,  863,  864,  865,
+      843,  844,  866,  846,  848,  868,  849,  850,  851,  867,
+      852,  869,  870,  853,  854,  855,  871,  873,  867,  856,
+      857,  858,  859,  874,  860,  861,  875,  862,  863,  864,
+      865,  872,  876,  866,  877,  878,  868,  879,  872,  880,
+      867,  884,  869,  870,  885,  886,  887,  871,  873,  867,
+      888,  889,  891,  883,  874,  883,  892,  875,  893,  894,
+
+      896,  897,  872,  876,  899,  877,  878,  898,  879,  872,
+      880,  883,  884,  898,  901,  885,  886,  887,  902,  903,
+      904,  888,  889,  891,  883,  907,  883,  892,  902,  893,
+      894,  896,  897,  908,  909,  899,  910,  911,  898,  912,
+      914,  915,  883,  916,  898,  901,  917,  918,  919,  902,
+      903,  904,  920,  921,  922,  923,  907,  924,  926,  902,
+      927,  928,  929,  931,  908,  909,  932,  910,  911,  933,
+      912,  914,  915,  936,  916,  938,  939,  917,  918,  919,
+      940,  941,  943,  920,  921,  922,  923,  947,  924,  926,
+      945,  927,  928,  929,  931,  946,  948,  932,  949,  950,
+
+      933,  951,  952,  953,  936,  954,  938,  939,  956,  959,
+      961,  940,  941,  943,  962,  963,  945,  964,  947,  946,
+      965,  945,  967,  969,  970,  971,  946,  948,  972,  949,
+      950,  973,  951,  952,  953,  975,  954,  976,  977,  956,
+      959,  961,  978,  980,  982,  962,  963,  983,  964,  985,
+      987,  965,  988,  967,  969,  970,  971,  989,  990,  972,
+      993,  994,  973,  995,  996,  997,  975,  999,  976,  977,
+     1000, 1001, 1002,  978,  980,  982, 1003, 1004,  983, 1005,
+      985,  987, 1006,  988, 1007, 1008, 1009, 1011,  989,  990,
+     1014,  993,  994, 1015,  995,  996,  997, 1010,  999, 1016,
+
+     1017, 1000, 1001, 1002, 1018, 1010, 1019, 1003, 1004, 1020,
+     1005, 1021, 1022, 1006, 1023, 1007, 1008, 1009, 1011, 1024,
+     1025, 1014, 1026, 1027, 1015, 1028, 1029, 1030, 1010, 1032,
+     1016, 1017, 1034, 1035, 1036, 1018, 1010, 1019, 1037, 1038,
+     1020, 1039, 1021, 1022, 1040, 1023, 1041, 1042, 1043, 1044,
+     1024, 1025, 1045, 1026, 1027, 1046, 1028, 1029, 1030, 1047,
+     1032, 1050, 1052, 1034, 1035, 1036, 1053, 1054, 1055, 1037,
+     1038, 1056, 1039, 1057, 1058, 1040, 1063, 1041, 1042, 1043,
+     1044, 1064, 1065, 1045, 1066, 1067, 1046, 1068, 1069, 1070,
+     1047, 1071, 1050, 1052, 1072, 1073, 1074, 1053, 1054, 1055,
+
+     1076, 1078, 1056, 1079, 1057, 1058, 1080, 1063, 1081, 1082,
+     1083, 1084, 1064, 1065, 1085, 1066, 1067, 1086, 1068, 1069,
+     1070, 1087, 1071, 1090, 1093, 1072, 1073, 1074, 1094, 1095,
+     1096, 1076, 1078, 1086, 1079, 1097, 1098, 1080, 1099, 1081,
+     1082, 1083, 1084, 1100, 1101, 1085, 1102, 1103, 1086, 1104,
+     1105, 1106, 1087, 1107, 1090, 1093, 1108, 1113, 1114, 1094,
+     1095, 1096, 1115, 1116, 1086, 1117, 1097, 1098, 1118, 1099,
+     1119, 1120, 1122, 1123, 1100, 1101, 1124, 1102, 1103, 1125,
+     1104, 1105, 1106, 1126, 1107, 1127, 1129, 1108, 1113, 1114,
+     1130, 1131, 1132, 1115, 1116, 1133, 1117, 1139, 1135, 1118,
+
+     1140, 1119, 1120, 1122, 1123, 1141, 1136, 1124, 1142, 1143,
+     1125, 1144, 1145, 1146, 1126, 1147, 1127, 1129, 1148, 1149,
+     1151, 1130, 1131, 1132, 1135, 1152, 1133, 1153, 1139, 1135,
+     1136, 1140, 1154, 1156, 1158, 1160, 1141, 1136, 1161, 1142,
+     1143, 1162, 1144, 1145, 1146, 1164, 1147, 1165, 1167, 1148,
+     1149, 1151, 1168, 1169, 1170, 1171, 1152, 1172, 1153, 1173,
+     1174, 1175, 1177, 1154, 1156, 1158, 1160, 1178, 1179, 1161,
+     1180, 1182, 1162, 1183, 1184, 1185, 1164, 1186, 1165, 1167,
+     1187, 1188, 1189, 1168, 1169, 1170, 1171, 1190, 1172, 1192,
+     1173, 1174, 1175, 1177, 1193, 1195, 1196, 1197, 1178, 1179,
+
+     1198, 1180, 1182, 1199, 1183, 1184, 1185, 1200, 1186, 1201,
+     1202, 1187, 1188, 1189, 1204, 1205, 1206, 1207, 1190, 1208,
+     1192, 1210, 1211, 1212, 1213, 1193, 1195, 1196, 1197, 1214,
+     1215, 1198, 1217, 1218, 1199, 1219, 1220, 1221, 1200, 1225,
+     1201, 1202, 1223, 1227, 1223, 1204, 1205, 1206, 1207, 1226,
+     1208, 1228, 1210, 1211, 1212, 1213, 1230, 1231, 1233, 1235,
+     1214, 1215, 1236, 1217, 1218, 1237, 1219, 1220, 1221, 1226,
+     1225, 1238, 1239, 1223, 1227, 1223, 1240, 1241, 1242, 1243,
+     1226, 1244, 1228, 1245, 1246, 1247, 1248, 1230, 1231, 1233,
+     1235, 1249, 1250, 1236, 1251, 1252, 1237, 1253, 1254, 1255,
+
+     1226, 1256, 1238, 1239, 1257, 1258, 1257, 1240, 1241, 1242,
+     1243, 1259, 1244, 1260, 1245, 1246, 1247, 1248, 1261, 1263,
+     1264, 1265, 1249, 1250, 1266, 1251, 1252, 1267, 1253, 1254,
+     1255, 1270, 1256, 1271, 1272, 1257, 1258, 1257, 1274, 1277,
+     1278, 1280, 1259, 1281, 1260, 1282, 1284, 1285, 1286, 1261,
+     1263, 1264, 1265, 1287, 1288, 1266, 1289, 1291, 1267, 1295,
+     1296, 1297, 1270, 1292, 1271, 1272, 1298, 1299, 1301, 1274,
+     1277, 1278, 1280, 1302, 1281, 1303, 1282, 1284, 1285, 1286,
+     1292, 1291, 1304, 1305, 1287, 1288, 1306, 1289, 1291, 1307,
+     1295, 1296, 1297, 1308, 1292, 1309, 1310, 1298, 1299, 1301,
+
+     1312, 1313, 1314, 1315, 1302, 1316, 1303, 1317, 1318, 1320,
+     1321, 1322, 1323, 1304, 1305, 1325, 1326, 1306, 1327, 1329,
+     1307, 1330, 1331, 1332, 1308, 1333, 1309, 1310, 1334, 1335,
+     1336, 1312, 1313, 1314, 1315, 1337, 1316, 1338, 1317, 1318,
+     1320, 1321, 1322, 1323, 1339, 1340, 1325, 1326, 1341, 1327,
+     1329, 1342, 1330, 1331, 1332, 1343, 1333, 1344, 1345, 1334,
+     1335, 1336, 1346, 1347, 1348, 1349, 1337, 1353, 1338, 1354,
+     1355, 1356, 1357, 1358, 1359, 1339, 1340, 1360, 1363, 1341,
+     1364, 1365, 1342, 1366, 1367, 1368, 1343, 1369, 1344, 1345,
+     1371, 1372, 1374, 1346, 1347, 1348, 1349, 1375, 1353, 1377,
+
+     1354, 1355, 1356, 1357, 1358, 1359, 1378, 1379, 1360, 1363,
+     1381, 1364, 1365, 1382, 1366, 1367, 1368, 1383, 1369, 1384,
+     1386, 1371, 1372, 1374, 1388, 1389, 1391, 1392, 1375, 1393,
+     1377, 1394, 1395, 1396, 1397, 1400, 1402, 1378, 1379, 1403,
+     1404, 1381, 1408, 1409, 1382, 1411, 1415, 1416, 1383, 1417,
+     1384, 1386, 1419, 1420,    0, 1388, 1389, 1391, 1392, 1424,
+     1393, 1425, 1394, 1395, 1396, 1397, 1400, 1402, 1422, 1423,
+     1403, 1404, 1427, 1408, 1409, 1429, 1411, 1415, 1416, 1431,
+     1417, 1433, 1434, 1419, 1420, 1422, 1423, 1436, 1438, 1439,
+     1424, 1441, 1425, 1442, 1443, 1444, 1446, 1450, 1452, 1422,
+
+     1423, 1453, 1454, 1427, 1455, 1456, 1429, 1458, 1459, 1460,
+     1431, 1461, 1433, 1434, 1462, 1463, 1464, 1465, 1436, 1438,
+     1439, 1466, 1441, 1467, 1442, 1443, 1444, 1446, 1450, 1452,
+     1468, 1470, 1453, 1454, 1471, 1455, 1456, 1472, 1458, 1459,
+     1460, 1473, 1461, 1474, 1475, 1462, 1463, 1464, 1465, 1476,
+     1477, 1478, 1466, 1479, 1467, 1480, 1481, 1482, 1483, 1484,
+     1485, 1468, 1470, 1486, 1487, 1471, 1488, 1489, 1472, 1490,
+     1491, 1492, 1473, 1493, 1474, 1475, 1494, 1495, 1498, 1499,
+     1476, 1477, 1478, 1500, 1479, 1501, 1480, 1481, 1482, 1483,
+     1484, 1485, 1502, 1503, 1486, 1487, 1504, 1488, 1489, 1508,
+
+     1490, 1491, 1492, 1511, 1493, 1513, 1514, 1494, 1495, 1498,
+     1499, 1515, 1516, 1517, 1500, 1518, 1501, 1519, 1520, 1523,
+     1524, 1522, 1526, 1502, 1503, 1527, 1531, 1504, 1532, 1523,
+     1508, 1531, 1536, 1537, 1511, 1540, 1513, 1514, 1522, 1544,
+     1545, 1546, 1515, 1516, 1517, 1547, 1518, 1548, 1519, 1520,
+     1523, 1524, 1522, 1526, 1549, 1552, 1527, 1531, 1553, 1532,
+     1554, 1555, 1531, 1536, 1537, 1556, 1540, 1557, 1558, 1559,
+     1544, 1545, 1546, 1561, 1562, 1563, 1547, 1564, 1548, 1565,
+     1566, 1567, 1568, 1569, 1571, 1549, 1552, 1572, 1573, 1553,
+     1574, 1554, 1555, 1575, 1576, 1578, 1556, 1581, 1557, 1558,
+
+     1559, 1583, 1587, 1589, 1561, 1562, 1563, 1590, 1564, 1591,
+     1565, 1566, 1567, 1568, 1569, 1571, 1600, 1599, 1572, 1573,
+     1602, 1574, 1603, 1604, 1575, 1576, 1578, 1599, 1581, 1605,
+     1606, 1607, 1583, 1587, 1589, 1608, 1600, 1609, 1590, 1611,
+     1591, 1612, 1613, 1614, 1615, 1620, 1621, 1600, 1599, 1622,
+     1625, 1602, 1628, 1603, 1604, 1629, 1631, 1633, 1634, 1635,
+     1605, 1606, 1607, 1636, 1639, 1641, 1608, 1643, 1609, 1644,
+     1611, 1646, 1612, 1613, 1614, 1615, 1620, 1621, 1648, 1647,
+     1622, 1625, 1647, 1628, 1650, 1651, 1629, 1631, 1633, 1634,
+     1635, 1646, 1652, 1654, 1636, 1639, 1641, 1655, 1643, 1656,
+
+     1644, 1657, 1646, 1658, 1660, 1661, 1662, 1664, 1665, 1648,
+     1647, 1667, 1668, 1672, 1673, 1650, 1651, 1674, 1675, 1676,
+        0, 1678, 1676, 1652, 1654, 1679, 1680, 1677, 1655, 1684,
+     1656, 1685, 1657, 1687, 1658, 1660, 1661, 1662, 1664, 1665,
+     1688, 1690, 1667, 1668, 1672, 1673, 1694, 1695, 1674, 1675,
+     1676, 1677, 1678, 1696, 1697, 1698, 1679, 1680, 1677, 1700,
+     1684, 1701, 1685, 1703, 1687, 1704, 1705, 1706, 1710, 1715,
+     1716, 1688, 1690, 1717, 1720, 1722, 1723, 1694, 1695, 1698,
+     1724, 1727, 1728,    0, 1696, 1697, 1698,    0,    0,    0,
+     1700,    0, 1701,    0, 1703,    0, 1704, 1705, 1706, 1710,
+
+     1715, 1716,    0,    0, 1717, 1720, 1722, 1723,    0,    0,
+        0, 1724, 1727, 1728, 1732, 1732, 1732, 1732, 1732, 1732,
+     1732, 1733, 1733, 1733, 1733, 1733, 1733, 1733, 1734, 1734,
+     1734, 1734, 1734, 1734, 1734, 1735,    0, 1735, 1735, 1735,
+     1735, 1735, 1736,    0, 1736, 1736, 1736, 1736, 1736, 1738,
+     1738, 1738, 1738, 1738, 1738, 1738, 1739, 1739, 1739, 1739,
+     1739, 1739, 1739, 1740,    0, 1740, 1740, 1740, 1740, 1740,
+     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1742, 1742, 1742,
+     1742, 1742, 1742, 1742, 1743, 1743, 1743, 1743, 1743, 1743,
+     1743, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1745, 1745,
+
+        0,    0, 1745, 1745, 1746,    0, 1746, 1746,    0, 1746,
+     1746, 1747, 1747, 1747, 1747, 1747, 1747, 1747, 1748, 1748,
+     1748, 1748, 1748, 1748, 1748, 1749, 1749, 1749, 1749, 1749,
+     1749, 1749, 1750, 1750,    0, 1750, 1750, 1750, 1750, 1751,
+     1751, 1751,    0, 1751, 1751, 1751, 1752, 1752, 1752, 1752,
+     1752, 1752, 1752, 1753,    0, 1753, 1753, 1753, 1753, 1753,
+     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1755,    0, 1755,
+     1755, 1755, 1755, 1755, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
+     1731
+    } ;
+
+static yy_state_type yy_last_accepting_state;
+static char *yy_last_accepting_cpos;
+
+extern int yy_flex_debug;
+int yy_flex_debug = 0;
+
+/* The intent behind this definition is that it'll catch
+ * any uses of REJECT which flex missed.
+ */
+#define REJECT reject_used_but_not_detected
+#define yymore() yymore_used_but_not_detected
+#define YY_MORE_ADJ 0
+#define YY_RESTORE_YY_MORE_OFFSET
+char *yytext;
+#line 1 "maplexer.l"
+#line 4 "maplexer.l"
+/*
+** READ ME FIRST!
+**
+** When this file is altered, it is necessary to do "make lexer".  Due to
+** problems detailed in #2310 the lexer is no longer automatically rebuilt
+** when maplexer.l is altered.
+*/
+
+#define YY_NO_INPUT
+
+/* C declarations */
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <math.h>
+
+#include <time.h>
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapfile.h"
+#include "maptime.h"
+#include "mapsymbol.h"
+#include "mapparser.h"
+#include "mapprimitive.h"
+
+/* msyylineno is required for flex 2.5.4 and older, but is already defined by
+ * flex 2.5.31 (bug 975).
+ * Unfortunately there is no clean way to differenciate the two versions,
+ * so we use the symbol YY_CURRENT_BUFFER_LVALUE to base our test since it
+ * was not present in 2.5.4 and is present in 2.5.31. Hopefully that won't
+ * put us in trouble with other versions. If that happens then we can
+ * switch to using autoconf to detect the version.
+ */
+#ifndef YY_CURRENT_BUFFER_LVALUE
+int msyylineno = 1;
+#endif
+
+#define YY_NO_INPUT
+
+/* Below is a redefinition of the default YY_INPUT() macro but replacing the
+ * YY_FATAL_ERROR() macro with a call to msSetError().
+ */
+/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
+ * is returned in "result".
+ */
+#define YY_INPUT(buf,result,max_size) \
+	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
+		{ \
+		int c = '*'; \
+		int n; \
+		for ( n = 0; n < max_size && \
+			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
+			buf[n] = (char) c; \
+		if ( c == '\n' ) \
+			buf[n++] = (char) c; \
+		if ( c == EOF && ferror( yyin ) ) \
+            msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
+		result = n; \
+		} \
+	else \
+		{ \
+		errno=0; \
+		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
+			{ \
+			if( errno != EINTR) \
+				{ \
+                msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
+				break; \
+				} \
+			errno=0; \
+			clearerr(yyin); \
+			} \
+		}
+
+int msyysource=MS_STRING_TOKENS;
+double msyynumber;
+int msyystate=MS_TOKENIZE_DEFAULT;
+const char *msyystring=NULL;
+char *msyybasepath=NULL;
+int  msyystring_buffer_size = 0;
+int  msyystring_size;
+char msyystring_begin;
+char *msyystring_buffer = NULL;
+int  msyystring_icase = MS_FALSE;
+int  msyystring_return_state;
+int  msyystring_begin_state;
+
+int msyyreturncomments = 0;
+
+#define MS_LEXER_STRING_REALLOC(string, string_size, max_size)   \
+  do { \
+   const int string_size_macro = (int)(string_size); \
+   if (string_size_macro >= (int)(max_size)) {         \
+       max_size = (((int)(max_size)*2) > string_size_macro) ? ((int)(max_size))*2 : string_size_macro+1;   \
+       string = (char *) msSmallRealloc(string, sizeof(char *) * (max_size));  \
+   } \
+  } while(0)
+
+#define MS_LEXER_RETURN_TOKEN(token) \
+   MS_LEXER_STRING_REALLOC(msyystring_buffer, strlen(msyytext),  \
+                           msyystring_buffer_size); \
+   strcpy(msyystring_buffer, msyytext); \
+   return(token); 
+
+#define MAX_INCLUDE_DEPTH 5
+YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
+int include_lineno[MAX_INCLUDE_DEPTH];
+int include_stack_ptr = 0;
+char path[MS_MAXPATHLEN];
+
+#line 2287 "/home/even/mapserver/mapserver/maplexer.c"
+
+#line 2289 "/home/even/mapserver/mapserver/maplexer.c"
+
+#define INITIAL 0
+#define EXPRESSION_STRING 1
+#define INCLUDE 2
+#define MSSTRING 3
+#define MULTILINE_COMMENT 4
+#define CONFIG_FILE 5
+
+#ifndef YY_EXTRA_TYPE
+#define YY_EXTRA_TYPE void *
+#endif
+
+static int yy_init_globals ( void );
+
+/* Accessor methods to globals.
+   These are made visible to non-reentrant scanners for convenience. */
+
+int yylex_destroy ( void );
+
+int yyget_debug ( void );
+
+void yyset_debug ( int debug_flag  );
+
+YY_EXTRA_TYPE yyget_extra ( void );
+
+void yyset_extra ( YY_EXTRA_TYPE user_defined  );
+
+FILE *yyget_in ( void );
+
+void yyset_in  ( FILE * _in_str  );
+
+FILE *yyget_out ( void );
+
+void yyset_out  ( FILE * _out_str  );
+
+			int yyget_leng ( void );
+
+char *yyget_text ( void );
+
+int yyget_lineno ( void );
+
+void yyset_lineno ( int _line_number  );
+
+/* Macros after this point can all be overridden by user definitions in
+ * section 1.
+ */
+
+#ifndef YY_SKIP_YYWRAP
+#ifdef __cplusplus
+extern "C" int yywrap ( void );
+#else
+extern int yywrap ( void );
+#endif
+#endif
+
+#ifndef YY_NO_UNPUT
+    
+    static void yyunput ( int c, char *buf_ptr  );
+    
+#endif
+
+#ifndef yytext_ptr
+static void yy_flex_strncpy ( char *, const char *, int );
+#endif
+
+#ifdef YY_NEED_STRLEN
+static int yy_flex_strlen ( const char * );
+#endif
+
+#ifndef YY_NO_INPUT
+#ifdef __cplusplus
+static int yyinput ( void );
+#else
+static int input ( void );
+#endif
+
+#endif
+
+/* Amount of stuff to slurp up with each read. */
+#ifndef YY_READ_BUF_SIZE
+#ifdef __ia64__
+/* On IA-64, the buffer size is 16k, not 8k */
+#define YY_READ_BUF_SIZE 16384
+#else
+#define YY_READ_BUF_SIZE 8192
+#endif /* __ia64__ */
+#endif
+
+/* Copy whatever the last rule matched to the standard output. */
+#ifndef ECHO
+/* This used to be an fputs(), but since the string might contain NUL's,
+ * we now use fwrite().
+ */
+#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
+#endif
+
+/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
+ * is returned in "result".
+ */
+#ifndef YY_INPUT
+#define YY_INPUT(buf,result,max_size) \
+	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
+		{ \
+		int c = '*'; \
+		int n; \
+		for ( n = 0; n < max_size && \
+			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
+			buf[n] = (char) c; \
+		if ( c == '\n' ) \
+			buf[n++] = (char) c; \
+		if ( c == EOF && ferror( yyin ) ) \
+			YY_FATAL_ERROR( "input in flex scanner failed" ); \
+		result = n; \
+		} \
+	else \
+		{ \
+		errno=0; \
+		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
+			{ \
+			if( errno != EINTR) \
+				{ \
+				YY_FATAL_ERROR( "input in flex scanner failed" ); \
+				break; \
+				} \
+			errno=0; \
+			clearerr(yyin); \
+			} \
+		}\
+\
+
+#endif
+
+/* No semi-colon after return; correct usage is to write "yyterminate();" -
+ * we don't want an extra ';' after the "return" because that will cause
+ * some compilers to complain about unreachable statements.
+ */
+#ifndef yyterminate
+#define yyterminate() return YY_NULL
+#endif
+
+/* Number of entries by which start-condition stack grows. */
+#ifndef YY_START_STACK_INCR
+#define YY_START_STACK_INCR 25
+#endif
+
+/* Report a fatal error. */
+#ifndef YY_FATAL_ERROR
+#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
+#endif
+
+/* end tables serialization structures and prototypes */
+
+/* Default declaration of generated scanner - a define so the user can
+ * easily add parameters.
+ */
+#ifndef YY_DECL
+#define YY_DECL_IS_OURS 1
+
+extern int yylex (void);
+
+#define YY_DECL int yylex (void)
+#endif /* !YY_DECL */
+
+/* Code executed at the beginning of each rule, after yytext and yyleng
+ * have been set up.
+ */
+#ifndef YY_USER_ACTION
+#define YY_USER_ACTION
+#endif
+
+/* Code executed at the end of each rule. */
+#ifndef YY_BREAK
+#define YY_BREAK /*LINTED*/break;
+#endif
+
+#define YY_RULE_SETUP \
+	YY_USER_ACTION
+
+/** The main scanner function which does all the work.
+ */
+YY_DECL
+{
+	yy_state_type yy_current_state;
+	char *yy_cp, *yy_bp;
+	int yy_act;
+    
+	if ( !(yy_init) )
+		{
+		(yy_init) = 1;
+
+#ifdef YY_USER_INIT
+		YY_USER_INIT;
+#endif
+
+		if ( ! (yy_start) )
+			(yy_start) = 1;	/* first start state */
+
+		if ( ! yyin )
+			yyin = stdin;
+
+		if ( ! yyout )
+			yyout = stdout;
+
+		if ( ! YY_CURRENT_BUFFER ) {
+			yyensure_buffer_stack ();
+			YY_CURRENT_BUFFER_LVALUE =
+				yy_create_buffer( yyin, YY_BUF_SIZE );
+		}
+
+		yy_load_buffer_state(  );
+		}
+
+	{
+#line 123 "maplexer.l"
+
+#line 125 "maplexer.l"
+       if (msyystring_buffer == NULL)
+       {
+           msyystring_buffer_size = 256;
+           msyystring_buffer = (char*) msSmallMalloc(sizeof(char) * msyystring_buffer_size);
+       }
+
+       msyystring_buffer[0] = '\0';
+       switch(msyystate) {
+       case(MS_TOKENIZE_DEFAULT):
+         (void) yyunput; /* just to avoid warning about it being unrefed */ 
+         break;
+       case(MS_TOKENIZE_FILE):
+         BEGIN(INITIAL);
+         msyystring_begin_state = INITIAL;
+         msyysource=MS_FILE_TOKENS;
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyystring=NULL;
+         msyyreturncomments=0;
+         include_stack_ptr=0;
+         return(0);
+         break;
+       case(MS_TOKENIZE_STRING):
+         BEGIN(INITIAL);
+         msyystring_begin_state = INITIAL;
+         msyy_delete_buffer(YY_CURRENT_BUFFER);
+         msyy_scan_string(msyystring);
+         msyysource=MS_STRING_TOKENS;
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyyin=NULL;
+         msyyreturncomments=0;
+         include_stack_ptr=0;
+         return(0);
+         break;
+       case(MS_TOKENIZE_EXPRESSION):
+         BEGIN(EXPRESSION_STRING);
+         msyystring_begin_state = EXPRESSION_STRING;
+         msyy_delete_buffer(YY_CURRENT_BUFFER);
+         msyy_scan_string(msyystring);
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyyreturncomments=0;
+         break;
+       case(MS_TOKENIZE_CONFIG):
+         BEGIN(CONFIG_FILE);
+         msyystring_begin_state = CONFIG_FILE;
+         msyysource=MS_FILE_TOKENS;
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyystring=NULL;
+         msyyreturncomments=0;
+         return(0);
+         break;
+       case(99):
+         BEGIN(INITIAL); /* may not need this one */
+         msyystring_begin_state = INITIAL;
+         msyy_delete_buffer(YY_CURRENT_BUFFER);
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyystring=NULL;
+         msyyreturncomments=0; 
+         return(0);
+         break;
+       default:
+         break;
+       }
+
+#line 2569 "/home/even/mapserver/mapserver/maplexer.c"
+
+	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
+		{
+		yy_cp = (yy_c_buf_p);
+
+		/* Support of yytext. */
+		*yy_cp = (yy_hold_char);
+
+		/* yy_bp points to the position in yy_ch_buf of the start of
+		 * the current run.
+		 */
+		yy_bp = yy_cp;
+
+		yy_current_state = (yy_start);
+yy_match:
+		do
+			{
+			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
+			if ( yy_accept[yy_current_state] )
+				{
+				(yy_last_accepting_state) = yy_current_state;
+				(yy_last_accepting_cpos) = yy_cp;
+				}
+			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
+				{
+				yy_current_state = (int) yy_def[yy_current_state];
+				if ( yy_current_state >= 1732 )
+					yy_c = yy_meta[yy_c];
+				}
+			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
+			++yy_cp;
+			}
+		while ( yy_current_state != 1731 );
+		yy_cp = (yy_last_accepting_cpos);
+		yy_current_state = (yy_last_accepting_state);
+
+yy_find_action:
+		yy_act = yy_accept[yy_current_state];
+
+		YY_DO_BEFORE_ACTION;
+
+do_action:	/* This label is used only to access EOF actions. */
+
+		switch ( yy_act )
+	{ /* beginning of action switch */
+			case 0: /* must back up */
+			/* undo the effects of YY_DO_BEFORE_ACTION */
+			*yy_cp = (yy_hold_char);
+			yy_cp = (yy_last_accepting_cpos);
+			yy_current_state = (yy_last_accepting_state);
+			goto yy_find_action;
+
+case 1:
+YY_RULE_SETUP
+#line 188 "maplexer.l"
+;
+	YY_BREAK
+case 2:
+YY_RULE_SETUP
+#line 190 "maplexer.l"
+{ if (msyyreturncomments) return(MS_COMMENT); }
+	YY_BREAK
+case 3:
+YY_RULE_SETUP
+#line 192 "maplexer.l"
+{ BEGIN(MULTILINE_COMMENT); }
+	YY_BREAK
+case 4:
+YY_RULE_SETUP
+#line 193 "maplexer.l"
+{ BEGIN(INITIAL); }
+	YY_BREAK
+case 5:
+YY_RULE_SETUP
+#line 194 "maplexer.l"
+;
+	YY_BREAK
+case 6:
+YY_RULE_SETUP
+#line 195 "maplexer.l"
+;
+	YY_BREAK
+case 7:
+/* rule 7 can match eol */
+YY_RULE_SETUP
+#line 196 "maplexer.l"
+{ msyylineno++; }
+	YY_BREAK
+case 8:
+YY_RULE_SETUP
+#line 198 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION); }
+	YY_BREAK
+case 9:
+YY_RULE_SETUP
+#line 199 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_ENV); }
+	YY_BREAK
+case 10:
+YY_RULE_SETUP
+#line 200 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_MAPS); }
+	YY_BREAK
+case 11:
+YY_RULE_SETUP
+#line 201 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_PLUGINS) }
+	YY_BREAK
+case 12:
+YY_RULE_SETUP
+#line 203 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_OR); }
+	YY_BREAK
+case 13:
+YY_RULE_SETUP
+#line 204 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_AND); }
+	YY_BREAK
+case 14:
+YY_RULE_SETUP
+#line 205 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_NOT); }
+	YY_BREAK
+case 15:
+YY_RULE_SETUP
+#line 206 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQ); }
+	YY_BREAK
+case 16:
+YY_RULE_SETUP
+#line 207 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_NE); }
+	YY_BREAK
+case 17:
+YY_RULE_SETUP
+#line 208 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GT); }
+	YY_BREAK
+case 18:
+YY_RULE_SETUP
+#line 209 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LT); }
+	YY_BREAK
+case 19:
+YY_RULE_SETUP
+#line 210 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GE); }
+	YY_BREAK
+case 20:
+YY_RULE_SETUP
+#line 211 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LE); }
+	YY_BREAK
+case 21:
+YY_RULE_SETUP
+#line 212 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_RE); }
+	YY_BREAK
+case 22:
+YY_RULE_SETUP
+#line 214 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IEQ); }
+	YY_BREAK
+case 23:
+YY_RULE_SETUP
+#line 215 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IRE); }
+	YY_BREAK
+case 24:
+YY_RULE_SETUP
+#line 217 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IN); /* was IN */ }
+	YY_BREAK
+case 25:
+YY_RULE_SETUP
+#line 219 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_AREA); }
+	YY_BREAK
+case 26:
+YY_RULE_SETUP
+#line 220 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LENGTH); }
+	YY_BREAK
+case 27:
+YY_RULE_SETUP
+#line 221 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_TOSTRING); }
+	YY_BREAK
+case 28:
+YY_RULE_SETUP
+#line 222 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_COMMIFY); }
+	YY_BREAK
+case 29:
+YY_RULE_SETUP
+#line 223 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_ROUND); }
+	YY_BREAK
+case 30:
+YY_RULE_SETUP
+#line 224 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_UPPER); }
+	YY_BREAK
+case 31:
+YY_RULE_SETUP
+#line 225 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LOWER); }
+	YY_BREAK
+case 32:
+YY_RULE_SETUP
+#line 226 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INITCAP); }
+	YY_BREAK
+case 33:
+YY_RULE_SETUP
+#line 227 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FIRSTCAP); }
+	YY_BREAK
+case 34:
+YY_RULE_SETUP
+#line 229 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_BUFFER); }
+	YY_BREAK
+case 35:
+YY_RULE_SETUP
+#line 230 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DIFFERENCE); }
+	YY_BREAK
+case 36:
+YY_RULE_SETUP
+#line 231 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFY); }
+	YY_BREAK
+case 37:
+YY_RULE_SETUP
+#line 232 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFYPT); }
+	YY_BREAK
+case 38:
+YY_RULE_SETUP
+#line 233 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_GENERALIZE); }
+	YY_BREAK
+case 39:
+YY_RULE_SETUP
+#line 234 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SMOOTHSIA); }
+	YY_BREAK
+case 40:
+YY_RULE_SETUP
+#line 235 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_CENTERLINE); }
+	YY_BREAK
+case 41:
+YY_RULE_SETUP
+#line 236 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DENSIFY); }
+	YY_BREAK
+case 42:
+YY_RULE_SETUP
+#line 237 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_OUTER); }
+	YY_BREAK
+case 43:
+YY_RULE_SETUP
+#line 238 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INNER); } 
+	YY_BREAK
+case 44:
+YY_RULE_SETUP
+#line 239 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_JAVASCRIPT); }
+	YY_BREAK
+case 45:
+YY_RULE_SETUP
+#line 241 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_INTERSECTS); }
+	YY_BREAK
+case 46:
+YY_RULE_SETUP
+#line 242 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DISJOINT); }
+	YY_BREAK
+case 47:
+YY_RULE_SETUP
+#line 243 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_TOUCHES); }
+	YY_BREAK
+case 48:
+YY_RULE_SETUP
+#line 244 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_OVERLAPS); }
+	YY_BREAK
+case 49:
+YY_RULE_SETUP
+#line 245 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CROSSES); }
+	YY_BREAK
+case 50:
+YY_RULE_SETUP
+#line 246 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_WITHIN); }
+	YY_BREAK
+case 51:
+YY_RULE_SETUP
+#line 247 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CONTAINS); }
+	YY_BREAK
+case 52:
+YY_RULE_SETUP
+#line 248 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQUALS); }
+	YY_BREAK
+case 53:
+YY_RULE_SETUP
+#line 249 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_BEYOND); }
+	YY_BREAK
+case 54:
+YY_RULE_SETUP
+#line 250 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DWITHIN); }
+	YY_BREAK
+case 55:
+YY_RULE_SETUP
+#line 252 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FROMTEXT); }
+	YY_BREAK
+case 56:
+YY_RULE_SETUP
+#line 254 "maplexer.l"
+{ msyynumber=MS_TRUE; return(MS_TOKEN_LITERAL_BOOLEAN); }
+	YY_BREAK
+case 57:
+YY_RULE_SETUP
+#line 255 "maplexer.l"
+{ msyynumber=MS_FALSE; return(MS_TOKEN_LITERAL_BOOLEAN); }
+	YY_BREAK
+case 58:
+YY_RULE_SETUP
+#line 257 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(COLORRANGE); }
+	YY_BREAK
+case 59:
+YY_RULE_SETUP
+#line 258 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(DATARANGE); }
+	YY_BREAK
+case 60:
+YY_RULE_SETUP
+#line 259 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(RANGEITEM); }
+	YY_BREAK
+case 61:
+YY_RULE_SETUP
+#line 261 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(ALIGN); }
+	YY_BREAK
+case 62:
+YY_RULE_SETUP
+#line 262 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(ANCHORPOINT); }
+	YY_BREAK
+case 63:
+YY_RULE_SETUP
+#line 263 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(ANGLE); }
+	YY_BREAK
+case 64:
+YY_RULE_SETUP
+#line 264 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(ANTIALIAS); }
+	YY_BREAK
+case 65:
+YY_RULE_SETUP
+#line 265 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(BACKGROUNDCOLOR); }
+	YY_BREAK
+case 66:
+YY_RULE_SETUP
+#line 266 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(BANDSITEM); }
+	YY_BREAK
+case 67:
+YY_RULE_SETUP
+#line 267 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(BINDVALS); }
+	YY_BREAK
+case 68:
+YY_RULE_SETUP
+#line 268 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(BOM); }
+	YY_BREAK
+case 69:
+YY_RULE_SETUP
+#line 269 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(BROWSEFORMAT); }
+	YY_BREAK
+case 70:
+YY_RULE_SETUP
+#line 270 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(BUFFER); }
+	YY_BREAK
+case 71:
+YY_RULE_SETUP
+#line 271 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CHARACTER); }
+	YY_BREAK
+case 72:
+YY_RULE_SETUP
+#line 272 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CLASS); }
+	YY_BREAK
+case 73:
+YY_RULE_SETUP
+#line 273 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CLASSITEM); }
+	YY_BREAK
+case 74:
+YY_RULE_SETUP
+#line 274 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CLASSGROUP); }
+	YY_BREAK
+case 75:
+YY_RULE_SETUP
+#line 275 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CLUSTER); }
+	YY_BREAK
+case 76:
+YY_RULE_SETUP
+#line 276 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(COLOR); }
+	YY_BREAK
+case 77:
+YY_RULE_SETUP
+#line 277 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(COMPFILTER); }
+	YY_BREAK
+case 78:
+YY_RULE_SETUP
+#line 278 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(COMPOSITE); }
+	YY_BREAK
+case 79:
+YY_RULE_SETUP
+#line 279 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(COMPOP); }
+	YY_BREAK
+case 80:
+YY_RULE_SETUP
+#line 280 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CONFIG); }
+	YY_BREAK
+case 81:
+YY_RULE_SETUP
+#line 281 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CONNECTION); }
+	YY_BREAK
+case 82:
+YY_RULE_SETUP
+#line 282 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CONNECTIONTYPE); }
+	YY_BREAK
+case 83:
+YY_RULE_SETUP
+#line 283 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(DATA); }
+	YY_BREAK
+case 84:
+YY_RULE_SETUP
+#line 284 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(DEBUG); }
+	YY_BREAK
+case 85:
+YY_RULE_SETUP
+#line 285 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(DRIVER); }
+	YY_BREAK
+case 86:
+YY_RULE_SETUP
+#line 286 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(EMPTY); }
+	YY_BREAK
+case 87:
+YY_RULE_SETUP
+#line 287 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(ENCODING); }
+	YY_BREAK
+case 88:
+YY_RULE_SETUP
+#line 288 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(END); }
+	YY_BREAK
+case 89:
+YY_RULE_SETUP
+#line 289 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(ERROR); }
+	YY_BREAK
+case 90:
+YY_RULE_SETUP
+#line 290 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(EXPRESSION); }
+	YY_BREAK
+case 91:
+YY_RULE_SETUP
+#line 291 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(EXTENT); }
+	YY_BREAK
+case 92:
+YY_RULE_SETUP
+#line 292 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(EXTENSION); }
+	YY_BREAK
+case 93:
+YY_RULE_SETUP
+#line 293 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FEATURE); }
+	YY_BREAK
+case 94:
+YY_RULE_SETUP
+#line 294 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FILLED); }
+	YY_BREAK
+case 95:
+YY_RULE_SETUP
+#line 295 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FILTER); }
+	YY_BREAK
+case 96:
+YY_RULE_SETUP
+#line 296 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FILTERITEM); }
+	YY_BREAK
+case 97:
+YY_RULE_SETUP
+#line 297 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FOOTER); }
+	YY_BREAK
+case 98:
+YY_RULE_SETUP
+#line 298 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FONT); }
+	YY_BREAK
+case 99:
+YY_RULE_SETUP
+#line 299 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FONTSET); }
+	YY_BREAK
+case 100:
+YY_RULE_SETUP
+#line 300 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FORCE); }
+	YY_BREAK
+case 101:
+YY_RULE_SETUP
+#line 301 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FORMATOPTION); }
+	YY_BREAK
+case 102:
+YY_RULE_SETUP
+#line 302 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(FROM); }
+	YY_BREAK
+case 103:
+YY_RULE_SETUP
+#line 303 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(GAP); }
+	YY_BREAK
+case 104:
+YY_RULE_SETUP
+#line 304 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(GEOMTRANSFORM); }
+	YY_BREAK
+case 105:
+YY_RULE_SETUP
+#line 305 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(GRID); }
+	YY_BREAK
+case 106:
+YY_RULE_SETUP
+#line 306 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(GRIDSTEP); }
+	YY_BREAK
+case 107:
+YY_RULE_SETUP
+#line 307 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(GRATICULE); }
+	YY_BREAK
+case 108:
+YY_RULE_SETUP
+#line 308 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(GROUP); }
+	YY_BREAK
+case 109:
+YY_RULE_SETUP
+#line 309 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(HEADER); }
+	YY_BREAK
+case 110:
+YY_RULE_SETUP
+#line 310 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(IMAGE); }
+	YY_BREAK
+case 111:
+YY_RULE_SETUP
+#line 311 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(IMAGECOLOR); }
+	YY_BREAK
+case 112:
+YY_RULE_SETUP
+#line 312 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(IMAGETYPE); }
+	YY_BREAK
+case 113:
+YY_RULE_SETUP
+#line 313 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(IMAGEMODE); }
+	YY_BREAK
+case 114:
+YY_RULE_SETUP
+#line 314 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(IMAGEPATH); }
+	YY_BREAK
+case 115:
+YY_RULE_SETUP
+#line 315 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TEMPPATH); }
+	YY_BREAK
+case 116:
+YY_RULE_SETUP
+#line 316 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(IMAGEURL); }
+	YY_BREAK
+case 117:
+YY_RULE_SETUP
+#line 317 "maplexer.l"
+{ BEGIN(INCLUDE); }
+	YY_BREAK
+case 118:
+YY_RULE_SETUP
+#line 318 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(INDEX); }
+	YY_BREAK
+case 119:
+YY_RULE_SETUP
+#line 319 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(INITIALGAP); }
+	YY_BREAK
+case 120:
+YY_RULE_SETUP
+#line 320 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(INTERVALS); } 
+	YY_BREAK
+case 121:
+YY_RULE_SETUP
+#line 321 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(JOIN); }
+	YY_BREAK
+case 122:
+YY_RULE_SETUP
+#line 322 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(KEYIMAGE); }
+	YY_BREAK
+case 123:
+YY_RULE_SETUP
+#line 323 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(KEYSIZE); }
+	YY_BREAK
+case 124:
+YY_RULE_SETUP
+#line 324 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(KEYSPACING); }
+	YY_BREAK
+case 125:
+YY_RULE_SETUP
+#line 325 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABEL); }
+	YY_BREAK
+case 126:
+YY_RULE_SETUP
+#line 326 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELCACHE); }
+	YY_BREAK
+case 127:
+YY_RULE_SETUP
+#line 327 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELFORMAT); }
+	YY_BREAK
+case 128:
+YY_RULE_SETUP
+#line 328 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELITEM); }
+	YY_BREAK
+case 129:
+YY_RULE_SETUP
+#line 329 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELMAXSCALE); }
+	YY_BREAK
+case 130:
+YY_RULE_SETUP
+#line 330 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELMAXSCALEDENOM); }
+	YY_BREAK
+case 131:
+YY_RULE_SETUP
+#line 331 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELMINSCALE); }
+	YY_BREAK
+case 132:
+YY_RULE_SETUP
+#line 332 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELMINSCALEDENOM); }
+	YY_BREAK
+case 133:
+YY_RULE_SETUP
+#line 333 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LABELREQUIRES); }
+	YY_BREAK
+case 134:
+YY_RULE_SETUP
+#line 334 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LATLON); }
+	YY_BREAK
+case 135:
+YY_RULE_SETUP
+#line 335 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LAYER); }
+	YY_BREAK
+case 136:
+YY_RULE_SETUP
+#line 336 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LEADER); }
+	YY_BREAK
+case 137:
+YY_RULE_SETUP
+#line 337 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LEGEND); }
+	YY_BREAK
+case 138:
+YY_RULE_SETUP
+#line 338 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LEGENDFORMAT); }
+	YY_BREAK
+case 139:
+YY_RULE_SETUP
+#line 339 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LINECAP); }
+	YY_BREAK
+case 140:
+YY_RULE_SETUP
+#line 340 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LINEJOIN); }
+	YY_BREAK
+case 141:
+YY_RULE_SETUP
+#line 341 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(LINEJOINMAXSIZE); }
+	YY_BREAK
+case 142:
+YY_RULE_SETUP
+#line 342 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAP); }
+	YY_BREAK
+case 143:
+YY_RULE_SETUP
+#line 343 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MARKER); }
+	YY_BREAK
+case 144:
+YY_RULE_SETUP
+#line 344 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MARKERSIZE); }
+	YY_BREAK
+case 145:
+YY_RULE_SETUP
+#line 345 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MASK); }
+	YY_BREAK
+case 146:
+YY_RULE_SETUP
+#line 346 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXARCS); }
+	YY_BREAK
+case 147:
+YY_RULE_SETUP
+#line 347 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXBOXSIZE); }
+	YY_BREAK
+case 148:
+YY_RULE_SETUP
+#line 348 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXDISTANCE); }
+	YY_BREAK
+case 149:
+YY_RULE_SETUP
+#line 349 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXFEATURES); }
+	YY_BREAK
+case 150:
+YY_RULE_SETUP
+#line 350 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXINTERVAL); }
+	YY_BREAK
+case 151:
+YY_RULE_SETUP
+#line 351 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXSCALE); }
+	YY_BREAK
+case 152:
+YY_RULE_SETUP
+#line 352 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXSCALEDENOM); }
+	YY_BREAK
+case 153:
+YY_RULE_SETUP
+#line 353 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXGEOWIDTH); }
+	YY_BREAK
+case 154:
+YY_RULE_SETUP
+#line 354 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXLENGTH); }
+	YY_BREAK
+case 155:
+YY_RULE_SETUP
+#line 355 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXSIZE); }
+	YY_BREAK
+case 156:
+YY_RULE_SETUP
+#line 356 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXSUBDIVIDE); }
+	YY_BREAK
+case 157:
+YY_RULE_SETUP
+#line 357 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXTEMPLATE); }
+	YY_BREAK
+case 158:
+YY_RULE_SETUP
+#line 358 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXWIDTH); }
+	YY_BREAK
+case 159:
+YY_RULE_SETUP
+#line 359 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(METADATA); }
+	YY_BREAK
+case 160:
+YY_RULE_SETUP
+#line 360 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MIMETYPE); }
+	YY_BREAK
+case 161:
+YY_RULE_SETUP
+#line 361 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINARCS); }
+	YY_BREAK
+case 162:
+YY_RULE_SETUP
+#line 362 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINBOXSIZE); }
+	YY_BREAK
+case 163:
+YY_RULE_SETUP
+#line 363 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINDISTANCE); }
+	YY_BREAK
+case 164:
+YY_RULE_SETUP
+#line 364 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(REPEATDISTANCE); }
+	YY_BREAK
+case 165:
+YY_RULE_SETUP
+#line 365 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MAXOVERLAPANGLE); } 
+	YY_BREAK
+case 166:
+YY_RULE_SETUP
+#line 366 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINFEATURESIZE); }
+	YY_BREAK
+case 167:
+YY_RULE_SETUP
+#line 367 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MININTERVAL); }
+	YY_BREAK
+case 168:
+YY_RULE_SETUP
+#line 368 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINSCALE); }
+	YY_BREAK
+case 169:
+YY_RULE_SETUP
+#line 369 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINSCALEDENOM); }
+	YY_BREAK
+case 170:
+YY_RULE_SETUP
+#line 370 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINGEOWIDTH); }
+	YY_BREAK
+case 171:
+YY_RULE_SETUP
+#line 371 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINSIZE); }
+	YY_BREAK
+case 172:
+YY_RULE_SETUP
+#line 372 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINSUBDIVIDE); }
+	YY_BREAK
+case 173:
+YY_RULE_SETUP
+#line 373 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINTEMPLATE); }
+	YY_BREAK
+case 174:
+YY_RULE_SETUP
+#line 374 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MINWIDTH); }
+	YY_BREAK
+case 175:
+YY_RULE_SETUP
+#line 375 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(NAME); }
+	YY_BREAK
+case 176:
+YY_RULE_SETUP
+#line 376 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(OFFSET); }
+	YY_BREAK
+case 177:
+YY_RULE_SETUP
+#line 377 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(OFFSITE); }
+	YY_BREAK
+case 178:
+YY_RULE_SETUP
+#line 378 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(OPACITY); }
+	YY_BREAK
+case 179:
+YY_RULE_SETUP
+#line 379 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(CONNECTIONOPTIONS); }
+	YY_BREAK
+case 180:
+YY_RULE_SETUP
+#line 380 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(OUTLINECOLOR); }
+	YY_BREAK
+case 181:
+YY_RULE_SETUP
+#line 381 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(OUTLINEWIDTH); }
+	YY_BREAK
+case 182:
+YY_RULE_SETUP
+#line 382 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(OUTPUTFORMAT); }
+	YY_BREAK
+case 183:
+YY_RULE_SETUP
+#line 383 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(PARTIALS); }
+	YY_BREAK
+case 184:
+YY_RULE_SETUP
+#line 384 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(PATTERN); }
+	YY_BREAK
+case 185:
+YY_RULE_SETUP
+#line 385 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(POINTS); }
+	YY_BREAK
+case 186:
+YY_RULE_SETUP
+#line 386 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(ITEMS); }
+	YY_BREAK
+case 187:
+YY_RULE_SETUP
+#line 387 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(POSITION); }
+	YY_BREAK
+case 188:
+YY_RULE_SETUP
+#line 388 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(POSTLABELCACHE); }
+	YY_BREAK
+case 189:
+YY_RULE_SETUP
+#line 389 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(PRIORITY); }
+	YY_BREAK
+case 190:
+YY_RULE_SETUP
+#line 390 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(PROCESSING); }
+	YY_BREAK
+case 191:
+YY_RULE_SETUP
+#line 391 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(PROJECTION); }
+	YY_BREAK
+case 192:
+YY_RULE_SETUP
+#line 392 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(QUERYFORMAT); }
+	YY_BREAK
+case 193:
+YY_RULE_SETUP
+#line 393 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(QUERYMAP); }
+	YY_BREAK
+case 194:
+YY_RULE_SETUP
+#line 394 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(REFERENCE); }
+	YY_BREAK
+case 195:
+YY_RULE_SETUP
+#line 395 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(REGION); }
+	YY_BREAK
+case 196:
+YY_RULE_SETUP
+#line 396 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(RELATIVETO); }
+	YY_BREAK
+case 197:
+YY_RULE_SETUP
+#line 397 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(REQUIRES); }
+	YY_BREAK
+case 198:
+YY_RULE_SETUP
+#line 398 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(RESOLUTION); }
+	YY_BREAK
+case 199:
+YY_RULE_SETUP
+#line 399 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(DEFRESOLUTION); }
+	YY_BREAK
+case 200:
+YY_RULE_SETUP
+#line 400 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SCALE); }
+	YY_BREAK
+case 201:
+YY_RULE_SETUP
+#line 401 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SCALEDENOM); }
+	YY_BREAK
+case 202:
+YY_RULE_SETUP
+#line 402 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SCALEBAR); }
+	YY_BREAK
+case 203:
+YY_RULE_SETUP
+#line 403 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SCALETOKEN); }
+	YY_BREAK
+case 204:
+YY_RULE_SETUP
+#line 404 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SHADOWCOLOR); }
+	YY_BREAK
+case 205:
+YY_RULE_SETUP
+#line 405 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SHADOWSIZE); }
+	YY_BREAK
+case 206:
+YY_RULE_SETUP
+#line 406 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SHAPEPATH); }
+	YY_BREAK
+case 207:
+YY_RULE_SETUP
+#line 407 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SIZE); }
+	YY_BREAK
+case 208:
+YY_RULE_SETUP
+#line 408 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SIZEUNITS); }
+	YY_BREAK
+case 209:
+YY_RULE_SETUP
+#line 409 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(STATUS); }
+	YY_BREAK
+case 210:
+YY_RULE_SETUP
+#line 410 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(STYLE); }
+	YY_BREAK
+case 211:
+YY_RULE_SETUP
+#line 411 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(STYLEITEM); }
+	YY_BREAK
+case 212:
+YY_RULE_SETUP
+#line 412 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SYMBOL); }
+	YY_BREAK
+case 213:
+YY_RULE_SETUP
+#line 413 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SYMBOLSCALE); }
+	YY_BREAK
+case 214:
+YY_RULE_SETUP
+#line 414 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SYMBOLSCALEDENOM); }
+	YY_BREAK
+case 215:
+YY_RULE_SETUP
+#line 415 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(SYMBOLSET); }
+	YY_BREAK
+case 216:
+YY_RULE_SETUP
+#line 416 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TABLE); }
+	YY_BREAK
+case 217:
+YY_RULE_SETUP
+#line 417 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TEMPLATE); }
+	YY_BREAK
+case 218:
+YY_RULE_SETUP
+#line 418 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TEXT); }
+	YY_BREAK
+case 219:
+YY_RULE_SETUP
+#line 419 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TILEINDEX); }
+	YY_BREAK
+case 220:
+YY_RULE_SETUP
+#line 420 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TILEITEM); }
+	YY_BREAK
+case 221:
+YY_RULE_SETUP
+#line 421 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TILESRS); }
+	YY_BREAK
+case 222:
+YY_RULE_SETUP
+#line 422 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TITLE); }
+	YY_BREAK
+case 223:
+YY_RULE_SETUP
+#line 423 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TO); }
+	YY_BREAK
+case 224:
+YY_RULE_SETUP
+#line 424 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TOLERANCE); }
+	YY_BREAK
+case 225:
+YY_RULE_SETUP
+#line 425 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TOLERANCEUNITS); }
+	YY_BREAK
+case 226:
+YY_RULE_SETUP
+#line 426 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TRANSPARENT); }
+	YY_BREAK
+case 227:
+YY_RULE_SETUP
+#line 427 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TRANSFORM); }
+	YY_BREAK
+case 228:
+YY_RULE_SETUP
+#line 428 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(TYPE); }
+	YY_BREAK
+case 229:
+YY_RULE_SETUP
+#line 429 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(UNITS); }
+	YY_BREAK
+case 230:
+YY_RULE_SETUP
+#line 430 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(UTFDATA); }
+	YY_BREAK
+case 231:
+YY_RULE_SETUP
+#line 431 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(UTFITEM); }
+	YY_BREAK
+case 232:
+YY_RULE_SETUP
+#line 432 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(VALIDATION); }
+	YY_BREAK
+case 233:
+YY_RULE_SETUP
+#line 433 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(VALUES); }
+	YY_BREAK
+case 234:
+YY_RULE_SETUP
+#line 434 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(WEB); }
+	YY_BREAK
+case 235:
+YY_RULE_SETUP
+#line 435 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(WIDTH); }
+	YY_BREAK
+case 236:
+YY_RULE_SETUP
+#line 436 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(WKT); }
+	YY_BREAK
+case 237:
+YY_RULE_SETUP
+#line 437 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(WRAP); }
+	YY_BREAK
+case 238:
+YY_RULE_SETUP
+#line 439 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_ANNOTATION); }
+	YY_BREAK
+case 239:
+YY_RULE_SETUP
+#line 440 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_AUTO); }
+	YY_BREAK
+case 240:
+YY_RULE_SETUP
+#line 441 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_AUTO2); }
+	YY_BREAK
+case 241:
+YY_RULE_SETUP
+#line 442 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CJC_BEVEL); }
+	YY_BREAK
+case 242:
+YY_RULE_SETUP
+#line 443 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_BITMAP); }
+	YY_BREAK
+case 243:
+YY_RULE_SETUP
+#line 444 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CJC_BUTT); }
+	YY_BREAK
+case 244:
+YY_RULE_SETUP
+#line 445 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CC); }
+	YY_BREAK
+case 245:
+YY_RULE_SETUP
+#line 446 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_ALIGN_CENTER); }
+	YY_BREAK
+case 246:
+YY_RULE_SETUP
+#line 447 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_CHART); }
+	YY_BREAK
+case 247:
+YY_RULE_SETUP
+#line 448 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_CIRCLE); }
+	YY_BREAK
+case 248:
+YY_RULE_SETUP
+#line 449 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CL); }
+	YY_BREAK
+case 249:
+YY_RULE_SETUP
+#line 450 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CR); }
+	YY_BREAK
+case 250:
+YY_RULE_SETUP
+#line 451 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_DB_CSV); }
+	YY_BREAK
+case 251:
+YY_RULE_SETUP
+#line 452 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_DB_POSTGRES); }
+	YY_BREAK
+case 252:
+YY_RULE_SETUP
+#line 453 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_DB_MYSQL); }
+	YY_BREAK
+case 253:
+YY_RULE_SETUP
+#line 454 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_DEFAULT); }
+	YY_BREAK
+case 254:
+YY_RULE_SETUP
+#line 455 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_DD); }
+	YY_BREAK
+case 255:
+YY_RULE_SETUP
+#line 456 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_ELLIPSE); }
+	YY_BREAK
+case 256:
+YY_RULE_SETUP
+#line 457 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_EMBED); }
+	YY_BREAK
+case 257:
+YY_RULE_SETUP
+#line 458 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_FALSE); }
+	YY_BREAK
+case 258:
+YY_RULE_SETUP
+#line 459 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_FEET); }
+	YY_BREAK
+case 259:
+YY_RULE_SETUP
+#line 460 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_FOLLOW); }
+	YY_BREAK
+case 260:
+YY_RULE_SETUP
+#line 461 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_GIANT); }
+	YY_BREAK
+case 261:
+YY_RULE_SETUP
+#line 462 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_HATCH); }
+	YY_BREAK
+case 262:
+YY_RULE_SETUP
+#line 463 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_KERNELDENSITY); }
+	YY_BREAK
+case 263:
+YY_RULE_SETUP
+#line 464 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_IDW); }
+	YY_BREAK
+case 264:
+YY_RULE_SETUP
+#line 465 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_HILITE); }
+	YY_BREAK
+case 265:
+YY_RULE_SETUP
+#line 466 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_INCHES); }
+	YY_BREAK
+case 266:
+YY_RULE_SETUP
+#line 467 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_KILOMETERS); }
+	YY_BREAK
+case 267:
+YY_RULE_SETUP
+#line 468 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LARGE); }
+	YY_BREAK
+case 268:
+YY_RULE_SETUP
+#line 469 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LC); }
+	YY_BREAK
+case 269:
+YY_RULE_SETUP
+#line 470 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_ALIGN_LEFT); }
+	YY_BREAK
+case 270:
+YY_RULE_SETUP
+#line 471 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_LINE); }
+	YY_BREAK
+case 271:
+YY_RULE_SETUP
+#line 472 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LL); }
+	YY_BREAK
+case 272:
+YY_RULE_SETUP
+#line 473 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LR); }
+	YY_BREAK
+case 273:
+YY_RULE_SETUP
+#line 474 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_MEDIUM); }
+	YY_BREAK
+case 274:
+YY_RULE_SETUP
+#line 475 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_METERS); }
+	YY_BREAK
+case 275:
+YY_RULE_SETUP
+#line 476 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_NAUTICALMILES); }
+	YY_BREAK
+case 276:
+YY_RULE_SETUP
+#line 477 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_MILES); }
+	YY_BREAK
+case 277:
+YY_RULE_SETUP
+#line 478 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CJC_MITER); }
+	YY_BREAK
+case 278:
+YY_RULE_SETUP
+#line 479 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_MULTIPLE); }
+	YY_BREAK
+case 279:
+YY_RULE_SETUP
+#line 480 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CJC_NONE); }
+	YY_BREAK
+case 280:
+YY_RULE_SETUP
+#line 481 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_NORMAL); }
+	YY_BREAK
+case 281:
+YY_RULE_SETUP
+#line 482 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_OFF); }
+	YY_BREAK
+case 282:
+YY_RULE_SETUP
+#line 483 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_OGR); }
+	YY_BREAK
+case 283:
+YY_RULE_SETUP
+#line 484 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_FLATGEOBUF); }
+	YY_BREAK
+case 284:
+YY_RULE_SETUP
+#line 485 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_ON); }
+	YY_BREAK
+case 285:
+YY_RULE_SETUP
+#line 486 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_ONE); }
+	YY_BREAK
+case 286:
+YY_RULE_SETUP
+#line 487 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_MANY); }
+	YY_BREAK
+case 287:
+YY_RULE_SETUP
+#line 488 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_ORACLESPATIAL); }
+	YY_BREAK
+case 288:
+YY_RULE_SETUP
+#line 489 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_PERCENTAGES); }
+	YY_BREAK
+case 289:
+YY_RULE_SETUP
+#line 490 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_PIXMAP); }
+	YY_BREAK
+case 290:
+YY_RULE_SETUP
+#line 491 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_PIXELS); }
+	YY_BREAK
+case 291:
+YY_RULE_SETUP
+#line 492 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_POINT); }
+	YY_BREAK
+case 292:
+YY_RULE_SETUP
+#line 493 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_POLYGON); }
+	YY_BREAK
+case 293:
+YY_RULE_SETUP
+#line 494 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_POSTGIS); }
+	YY_BREAK
+case 294:
+YY_RULE_SETUP
+#line 495 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_PLUGIN); }
+	YY_BREAK
+case 295:
+YY_RULE_SETUP
+#line 496 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_QUERY); }
+	YY_BREAK
+case 296:
+YY_RULE_SETUP
+#line 497 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_LAYER_RASTER); }
+	YY_BREAK
+case 297:
+YY_RULE_SETUP
+#line 498 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_ALIGN_RIGHT); }
+	YY_BREAK
+case 298:
+YY_RULE_SETUP
+#line 499 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CJC_ROUND); }
+	YY_BREAK
+case 299:
+YY_RULE_SETUP
+#line 500 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SELECTED); }
+	YY_BREAK
+case 300:
+YY_RULE_SETUP
+#line 501 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SIMPLE); }
+	YY_BREAK
+case 301:
+YY_RULE_SETUP
+#line 502 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SINGLE); }
+	YY_BREAK
+case 302:
+YY_RULE_SETUP
+#line 503 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SMALL); }
+	YY_BREAK
+case 303:
+YY_RULE_SETUP
+#line 504 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CJC_SQUARE); }
+	YY_BREAK
+case 304:
+YY_RULE_SETUP
+#line 505 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SVG); }
+	YY_BREAK
+case 305:
+YY_RULE_SETUP
+#line 506 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(POLAROFFSET); }
+	YY_BREAK
+case 306:
+YY_RULE_SETUP
+#line 507 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TINY); }
+	YY_BREAK
+case 307:
+YY_RULE_SETUP
+#line 508 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CJC_TRIANGLE); }
+	YY_BREAK
+case 308:
+YY_RULE_SETUP
+#line 509 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TRUE); }
+	YY_BREAK
+case 309:
+YY_RULE_SETUP
+#line 510 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_TRUETYPE); }
+	YY_BREAK
+case 310:
+YY_RULE_SETUP
+#line 511 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_UC); }
+	YY_BREAK
+case 311:
+YY_RULE_SETUP
+#line 512 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_UL); }
+	YY_BREAK
+case 312:
+YY_RULE_SETUP
+#line 513 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_UR); }
+	YY_BREAK
+case 313:
+YY_RULE_SETUP
+#line 514 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_UNION); }
+	YY_BREAK
+case 314:
+YY_RULE_SETUP
+#line 515 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_UVRASTER); }
+	YY_BREAK
+case 315:
+YY_RULE_SETUP
+#line 516 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_CONTOUR); }
+	YY_BREAK
+case 316:
+YY_RULE_SETUP
+#line 517 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_SYMBOL_VECTOR); }
+	YY_BREAK
+case 317:
+YY_RULE_SETUP
+#line 518 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_WFS); }
+	YY_BREAK
+case 318:
+YY_RULE_SETUP
+#line 519 "maplexer.l"
+{ MS_LEXER_RETURN_TOKEN(MS_WMS); }
+	YY_BREAK
+case 319:
+/* rule 319 can match eol */
+YY_RULE_SETUP
+#line 521 "maplexer.l"
+{
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer,msyytext);
+                                                 return(MS_BINDING);
+                                               }
+	YY_BREAK
+case 320:
+YY_RULE_SETUP
+#line 530 "maplexer.l"
+{ 
+  /* attribute binding - shape (fixed value) */
+  return(MS_TOKEN_BINDING_SHAPE);
+}
+	YY_BREAK
+case 321:
+YY_RULE_SETUP
+#line 534 "maplexer.l"
+{ 
+  /* attribute binding - map cellsize */
+  return(MS_TOKEN_BINDING_MAP_CELLSIZE);
+}
+	YY_BREAK
+case 322:
+YY_RULE_SETUP
+#line 538 "maplexer.l"
+{ 
+  /* attribute binding - data cellsize */
+  return(MS_TOKEN_BINDING_DATA_CELLSIZE);
+}
+	YY_BREAK
+case 323:
+/* rule 323 can match eol */
+YY_RULE_SETUP
+#line 542 "maplexer.l"
+{
+  /* attribute binding - numeric (no quotes) */
+  msyytext++;
+  msyytext[msyyleng-1-1] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_BINDING_DOUBLE);
+}
+	YY_BREAK
+case 324:
+/* rule 324 can match eol */
+YY_RULE_SETUP
+#line 551 "maplexer.l"
+{
+  /* attribute binding - string (single or double quotes) */
+  msyytext+=2;
+  msyytext[msyyleng-2-2] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_BINDING_STRING);
+}
+	YY_BREAK
+case 325:
+/* rule 325 can match eol */
+YY_RULE_SETUP
+#line 560 "maplexer.l"
+{
+  /* attribute binding - time */
+  msyytext+=2;
+  msyytext[msyyleng-2-2] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng,
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_BINDING_TIME);
+}
+	YY_BREAK
+case 326:
+YY_RULE_SETUP
+#line 570 "maplexer.l"
+{
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer,msyytext);
+  msyynumber = atof(msyytext);
+  return(MS_NUMBER); 
+}
+	YY_BREAK
+case 327:
+YY_RULE_SETUP
+#line 578 "maplexer.l"
+{
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer,msyytext);
+  msyynumber = atof(msyytext);
+  return(MS_TOKEN_LITERAL_NUMBER);
+}
+	YY_BREAK
+case 328:
+/* rule 328 can match eol */
+YY_RULE_SETUP
+#line 586 "maplexer.l"
+{
+  msyytext++;
+  msyytext[msyyleng-1-1] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_LITERAL_TIME);
+}
+	YY_BREAK
+case 329:
+/* rule 329 can match eol */
+YY_RULE_SETUP
+#line 595 "maplexer.l"
+{
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-2] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_IREGEX);
+                                               }
+	YY_BREAK
+case 330:
+/* rule 330 can match eol */
+YY_RULE_SETUP
+#line 604 "maplexer.l"
+{
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_REGEX);
+                                               }
+	YY_BREAK
+case 331:
+YY_RULE_SETUP
+#line 613 "maplexer.l"
+{
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_EXPRESSION);
+                                               }
+	YY_BREAK
+case 332:
+YY_RULE_SETUP
+#line 622 "maplexer.l"
+{
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_LIST);
+                                               }
+	YY_BREAK
+case 333:
+YY_RULE_SETUP
+#line 631 "maplexer.l"
+{
+                                                 msyystring_return_state = MS_STRING;
+                                                 msyystring_begin = msyytext[0]; 
+                                                 msyystring_size = 0;
+                                                 msyystring_buffer[0] = '\0';
+                                                 BEGIN(MSSTRING);
+                                              }
+	YY_BREAK
+case 334:
+YY_RULE_SETUP
+#line 639 "maplexer.l"
+{
+                                                if (msyystring_begin == msyytext[0]) {
+                                                   BEGIN(msyystring_begin_state);
+                                                   if (msyystring_return_state == MS_STRING) {
+                                                      if (msyystring_icase && msyyleng==2) {
+                                                         msyystring_icase = MS_FALSE; // reset
+                                                         return MS_ISTRING;
+                                                      } else
+                                                        return MS_STRING;
+                                                   }
+                                                   return msyystring_return_state;
+
+                                                }
+                                                else {
+                                                  int old_size = msyystring_size;
+                                                  msyystring_size += (msyyleng==2) ? 2 : 1;
+                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
+                                                                          msyystring_buffer_size);
+                                                  msyystring_buffer[old_size] = *msyytext;
+                                                  if (msyyleng==2) {
+                                                     msyystring_buffer[old_size+1] = msyytext[1];
+                                                  }
+                                                  msyystring_buffer[msyystring_size] = '\0';
+                                                }
+                                              }
+	YY_BREAK
+case 335:
+YY_RULE_SETUP
+#line 665 "maplexer.l"
+{ 
+                                                ++msyystring_size;
+                                                MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
+                                                                        msyystring_buffer_size);
+
+                                                if (msyyleng == 2)
+                                                    msyystring_buffer[msyystring_size-1] = msyytext[1]; 
+                                                else
+                                                    msyystring_buffer[msyystring_size-1] = msyytext[0];
+                                                msyystring_buffer[msyystring_size] = '\0';
+                                             }
+	YY_BREAK
+case 336:
+/* rule 336 can match eol */
+YY_RULE_SETUP
+#line 677 "maplexer.l"
+{
+                                                 int old_size = msyystring_size;
+                                                 msyystring_size += msyyleng;
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
+                                                                         msyystring_buffer_size);
+                                                 memcpy(msyystring_buffer + old_size, msyytext, msyyleng + 1);
+                                             }
+	YY_BREAK
+case 337:
+/* rule 337 can match eol */
+YY_RULE_SETUP
+#line 685 "maplexer.l"
+{
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+
+                                                 if(include_stack_ptr >= MAX_INCLUDE_DEPTH) {
+                                                   msSetError(MS_IOERR, "Includes nested to deeply.", "msyylex()");
+                                                   return(-1);
+                                                 }
+
+                                                 msyyin = fopen(msBuildPath(path, msyybasepath, msyytext), "r");
+                                                 if(!msyyin) {
+                                                   msSetError(MS_IOERR, "Error opening included file \"%s\".", "msyylex()", msyytext);
+                                                   msyyin = YY_CURRENT_BUFFER->yy_input_file;
+                                                   return(-1);
+                                                 }
+
+                                                 include_stack[include_stack_ptr] = YY_CURRENT_BUFFER; /* save state */
+                                                 include_lineno[include_stack_ptr] = msyylineno;
+                                                 include_stack_ptr++;
+
+                                                 msyy_switch_to_buffer( msyy_create_buffer(msyyin, YY_BUF_SIZE) );
+                                                 msyylineno = 1;
+
+                                                 BEGIN(INITIAL);
+                                               }
+	YY_BREAK
+case 338:
+YY_RULE_SETUP
+#line 711 "maplexer.l"
+{
+                                                 msyystring_return_state = MS_TOKEN_LITERAL_STRING;
+                                                 msyystring_begin = msyytext[0]; 
+                                                 msyystring_size = 0;
+                                                 msyystring_buffer[0] = '\0';
+                                                 BEGIN(MSSTRING);
+                                              }
+	YY_BREAK
+case 339:
+YY_RULE_SETUP
+#line 719 "maplexer.l"
+{ 
+                                                    MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                            msyystring_buffer_size);
+                                                    strcpy(msyystring_buffer, msyytext); 
+                                                    return(MS_STRING); 
+                                                }
+	YY_BREAK
+case 340:
+/* rule 340 can match eol */
+YY_RULE_SETUP
+#line 726 "maplexer.l"
+{ msyylineno++; }
+	YY_BREAK
+case YY_STATE_EOF(INITIAL):
+case YY_STATE_EOF(CONFIG_FILE):
+#line 728 "maplexer.l"
+{
+                                                  if( --include_stack_ptr < 0 )
+                                                    return(EOF); /* end of main file */
+                                                  else {
+                                                    fclose(YY_CURRENT_BUFFER->yy_input_file);
+                                                    msyy_delete_buffer( YY_CURRENT_BUFFER );
+                                                    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
+                                                    msyylineno = include_lineno[include_stack_ptr];
+                                                  }
+                                                }
+	YY_BREAK
+case 341:
+/* rule 341 can match eol */
+YY_RULE_SETUP
+#line 739 "maplexer.l"
+{
+  return(0); 
+}
+	YY_BREAK
+case 342:
+YY_RULE_SETUP
+#line 743 "maplexer.l"
+{ 
+                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                          msyystring_buffer_size);
+                                                  strcpy(msyystring_buffer, msyytext); 
+                                                  return(0); 
+                                                }
+	YY_BREAK
+case 343:
+YY_RULE_SETUP
+#line 749 "maplexer.l"
+{ return(msyytext[0]); }
+	YY_BREAK
+case 344:
+YY_RULE_SETUP
+#line 750 "maplexer.l"
+ECHO;
+	YY_BREAK
+#line 4543 "/home/even/mapserver/mapserver/maplexer.c"
+case YY_STATE_EOF(EXPRESSION_STRING):
+case YY_STATE_EOF(INCLUDE):
+case YY_STATE_EOF(MSSTRING):
+case YY_STATE_EOF(MULTILINE_COMMENT):
+	yyterminate();
+
+	case YY_END_OF_BUFFER:
+		{
+		/* Amount of text matched not including the EOB char. */
+		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;
+
+		/* Undo the effects of YY_DO_BEFORE_ACTION. */
+		*yy_cp = (yy_hold_char);
+		YY_RESTORE_YY_MORE_OFFSET
+
+		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
+			{
+			/* We're scanning a new file or input source.  It's
+			 * possible that this happened because the user
+			 * just pointed yyin at a new source and called
+			 * yylex().  If so, then we have to assure
+			 * consistency between YY_CURRENT_BUFFER and our
+			 * globals.  Here is the right place to do so, because
+			 * this is the first action (other than possibly a
+			 * back-up) that will match for the new input source.
+			 */
+			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
+			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
+			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
+			}
+
+		/* Note that here we test for yy_c_buf_p "<=" to the position
+		 * of the first EOB in the buffer, since yy_c_buf_p will
+		 * already have been incremented past the NUL character
+		 * (since all states make transitions on EOB to the
+		 * end-of-buffer state).  Contrast this with the test
+		 * in input().
+		 */
+		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
+			{ /* This was really a NUL. */
+			yy_state_type yy_next_state;
+
+			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;
+
+			yy_current_state = yy_get_previous_state(  );
+
+			/* Okay, we're now positioned to make the NUL
+			 * transition.  We couldn't have
+			 * yy_get_previous_state() go ahead and do it
+			 * for us because it doesn't know how to deal
+			 * with the possibility of jamming (and we don't
+			 * want to build jamming into it because then it
+			 * will run more slowly).
+			 */
+
+			yy_next_state = yy_try_NUL_trans( yy_current_state );
+
+			yy_bp = (yytext_ptr) + YY_MORE_ADJ;
+
+			if ( yy_next_state )
+				{
+				/* Consume the NUL. */
+				yy_cp = ++(yy_c_buf_p);
+				yy_current_state = yy_next_state;
+				goto yy_match;
+				}
+
+			else
+				{
+				yy_cp = (yy_last_accepting_cpos);
+				yy_current_state = (yy_last_accepting_state);
+				goto yy_find_action;
+				}
+			}
+
+		else switch ( yy_get_next_buffer(  ) )
+			{
+			case EOB_ACT_END_OF_FILE:
+				{
+				(yy_did_buffer_switch_on_eof) = 0;
+
+				if ( yywrap(  ) )
+					{
+					/* Note: because we've taken care in
+					 * yy_get_next_buffer() to have set up
+					 * yytext, we can now set up
+					 * yy_c_buf_p so that if some total
+					 * hoser (like flex itself) wants to
+					 * call the scanner after we return the
+					 * YY_NULL, it'll still work - another
+					 * YY_NULL will get returned.
+					 */
+					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;
+
+					yy_act = YY_STATE_EOF(YY_START);
+					goto do_action;
+					}
+
+				else
+					{
+					if ( ! (yy_did_buffer_switch_on_eof) )
+						YY_NEW_FILE;
+					}
+				break;
+				}
+
+			case EOB_ACT_CONTINUE_SCAN:
+				(yy_c_buf_p) =
+					(yytext_ptr) + yy_amount_of_matched_text;
+
+				yy_current_state = yy_get_previous_state(  );
+
+				yy_cp = (yy_c_buf_p);
+				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
+				goto yy_match;
+
+			case EOB_ACT_LAST_MATCH:
+				(yy_c_buf_p) =
+				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];
+
+				yy_current_state = yy_get_previous_state(  );
+
+				yy_cp = (yy_c_buf_p);
+				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
+				goto yy_find_action;
+			}
+		break;
+		}
+
+	default:
+		YY_FATAL_ERROR(
+			"fatal flex scanner internal error--no action found" );
+	} /* end of action switch */
+		} /* end of scanning one token */
+	} /* end of user's declarations */
+} /* end of yylex */
+
+/* yy_get_next_buffer - try to read in a new buffer
+ *
+ * Returns a code representing an action:
+ *	EOB_ACT_LAST_MATCH -
+ *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
+ *	EOB_ACT_END_OF_FILE - end of file
+ */
+static int yy_get_next_buffer (void)
+{
+    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
+	char *source = (yytext_ptr);
+	int number_to_move, i;
+	int ret_val;
+
+	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
+		YY_FATAL_ERROR(
+		"fatal flex scanner internal error--end of buffer missed" );
+
+	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
+		{ /* Don't try to fill the buffer, so this is an EOF. */
+		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
+			{
+			/* We matched a single character, the EOB, so
+			 * treat this as a final EOF.
+			 */
+			return EOB_ACT_END_OF_FILE;
+			}
+
+		else
+			{
+			/* We matched some text prior to the EOB, first
+			 * process it.
+			 */
+			return EOB_ACT_LAST_MATCH;
+			}
+		}
+
+	/* Try to read more data. */
+
+	/* First move last chars to start of buffer. */
+	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);
+
+	for ( i = 0; i < number_to_move; ++i )
+		*(dest++) = *(source++);
+
+	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
+		/* don't do the read, it's not guaranteed to return an EOF,
+		 * just force an EOF
+		 */
+		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;
+
+	else
+		{
+			int num_to_read =
+			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;
+
+		while ( num_to_read <= 0 )
+			{ /* Not enough room in the buffer - grow it. */
+
+			/* just a shorter name for the current buffer */
+			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;
+
+			int yy_c_buf_p_offset =
+				(int) ((yy_c_buf_p) - b->yy_ch_buf);
+
+			if ( b->yy_is_our_buffer )
+				{
+				int new_size = b->yy_buf_size * 2;
+
+				if ( new_size <= 0 )
+					b->yy_buf_size += b->yy_buf_size / 8;
+				else
+					b->yy_buf_size *= 2;
+
+				b->yy_ch_buf = (char *)
+					/* Include room in for 2 EOB chars. */
+					yyrealloc( (void *) b->yy_ch_buf,
+							 (yy_size_t) (b->yy_buf_size + 2)  );
+				}
+			else
+				/* Can't grow it, we don't own it. */
+				b->yy_ch_buf = NULL;
+
+			if ( ! b->yy_ch_buf )
+				YY_FATAL_ERROR(
+				"fatal error - scanner input buffer overflow" );
+
+			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];
+
+			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
+						number_to_move - 1;
+
+			}
+
+		if ( num_to_read > YY_READ_BUF_SIZE )
+			num_to_read = YY_READ_BUF_SIZE;
+
+		/* Read in more data. */
+		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
+			(yy_n_chars), num_to_read );
+
+		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
+		}
+
+	if ( (yy_n_chars) == 0 )
+		{
+		if ( number_to_move == YY_MORE_ADJ )
+			{
+			ret_val = EOB_ACT_END_OF_FILE;
+			yyrestart( yyin  );
+			}
+
+		else
+			{
+			ret_val = EOB_ACT_LAST_MATCH;
+			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
+				YY_BUFFER_EOF_PENDING;
+			}
+		}
+
+	else
+		ret_val = EOB_ACT_CONTINUE_SCAN;
+
+	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
+		/* Extend the array by 50%, plus the number we really need. */
+		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
+		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
+			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
+		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
+			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
+		/* "- 2" to take care of EOB's */
+		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
+	}
+
+	(yy_n_chars) += number_to_move;
+	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
+	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;
+
+	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];
+
+	return ret_val;
+}
+
+/* yy_get_previous_state - get the state just before the EOB char was reached */
+
+    static yy_state_type yy_get_previous_state (void)
+{
+	yy_state_type yy_current_state;
+	char *yy_cp;
+    
+	yy_current_state = (yy_start);
+
+	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
+		{
+		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 86);
+		if ( yy_accept[yy_current_state] )
+			{
+			(yy_last_accepting_state) = yy_current_state;
+			(yy_last_accepting_cpos) = yy_cp;
+			}
+		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
+			{
+			yy_current_state = (int) yy_def[yy_current_state];
+			if ( yy_current_state >= 1732 )
+				yy_c = yy_meta[yy_c];
+			}
+		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
+		}
+
+	return yy_current_state;
+}
+
+/* yy_try_NUL_trans - try to make a transition on the NUL character
+ *
+ * synopsis
+ *	next_state = yy_try_NUL_trans( current_state );
+ */
+    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
+{
+	int yy_is_jam;
+    	char *yy_cp = (yy_c_buf_p);
+
+	YY_CHAR yy_c = 86;
+	if ( yy_accept[yy_current_state] )
+		{
+		(yy_last_accepting_state) = yy_current_state;
+		(yy_last_accepting_cpos) = yy_cp;
+		}
+	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
+		{
+		yy_current_state = (int) yy_def[yy_current_state];
+		if ( yy_current_state >= 1732 )
+			yy_c = yy_meta[yy_c];
+		}
+	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
+	yy_is_jam = (yy_current_state == 1731);
+
+		return yy_is_jam ? 0 : yy_current_state;
+}
+
+#ifndef YY_NO_UNPUT
+
+    static void yyunput (int c, char * yy_bp )
+{
+	char *yy_cp;
+    
+    yy_cp = (yy_c_buf_p);
+
+	/* undo effects of setting up yytext */
+	*yy_cp = (yy_hold_char);
+
+	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
+		{ /* need to shift things up to make room */
+		/* +2 for EOB chars. */
+		int number_to_move = (yy_n_chars) + 2;
+		char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
+					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
+		char *source =
+				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];
+
+		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
+			*--dest = *--source;
+
+		yy_cp += (int) (dest - source);
+		yy_bp += (int) (dest - source);
+		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
+			(yy_n_chars) = (int) YY_CURRENT_BUFFER_LVALUE->yy_buf_size;
+
+		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
+			YY_FATAL_ERROR( "flex scanner push-back overflow" );
+		}
+
+	*--yy_cp = (char) c;
+
+	(yytext_ptr) = yy_bp;
+	(yy_hold_char) = *yy_cp;
+	(yy_c_buf_p) = yy_cp;
+}
+
+#endif
+
+#ifndef YY_NO_INPUT
+#ifdef __cplusplus
+    static int yyinput (void)
+#else
+    static int input  (void)
+#endif
+
+{
+	int c;
+    
+	*(yy_c_buf_p) = (yy_hold_char);
+
+	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
+		{
+		/* yy_c_buf_p now points to the character we want to return.
+		 * If this occurs *before* the EOB characters, then it's a
+		 * valid NUL; if not, then we've hit the end of the buffer.
+		 */
+		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
+			/* This was really a NUL. */
+			*(yy_c_buf_p) = '\0';
+
+		else
+			{ /* need more input */
+			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
+			++(yy_c_buf_p);
+
+			switch ( yy_get_next_buffer(  ) )
+				{
+				case EOB_ACT_LAST_MATCH:
+					/* This happens because yy_g_n_b()
+					 * sees that we've accumulated a
+					 * token and flags that we need to
+					 * try matching the token before
+					 * proceeding.  But for input(),
+					 * there's no matching to consider.
+					 * So convert the EOB_ACT_LAST_MATCH
+					 * to EOB_ACT_END_OF_FILE.
+					 */
+
+					/* Reset buffer status. */
+					yyrestart( yyin );
+
+					/*FALLTHROUGH*/
+
+				case EOB_ACT_END_OF_FILE:
+					{
+					if ( yywrap(  ) )
+						return 0;
+
+					if ( ! (yy_did_buffer_switch_on_eof) )
+						YY_NEW_FILE;
+#ifdef __cplusplus
+					return yyinput();
+#else
+					return input();
+#endif
+					}
+
+				case EOB_ACT_CONTINUE_SCAN:
+					(yy_c_buf_p) = (yytext_ptr) + offset;
+					break;
+				}
+			}
+		}
+
+	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
+	*(yy_c_buf_p) = '\0';	/* preserve yytext */
+	(yy_hold_char) = *++(yy_c_buf_p);
+
+	return c;
+}
+#endif	/* ifndef YY_NO_INPUT */
+
+/** Immediately switch to a different input stream.
+ * @param input_file A readable stream.
+ * 
+ * @note This function does not reset the start condition to @c INITIAL .
+ */
+    void yyrestart  (FILE * input_file )
+{
+    
+	if ( ! YY_CURRENT_BUFFER ){
+        yyensure_buffer_stack ();
+		YY_CURRENT_BUFFER_LVALUE =
+            yy_create_buffer( yyin, YY_BUF_SIZE );
+	}
+
+	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
+	yy_load_buffer_state(  );
+}
+
+/** Switch to a different input buffer.
+ * @param new_buffer The new input buffer.
+ * 
+ */
+    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
+{
+    
+	/* TODO. We should be able to replace this entire function body
+	 * with
+	 *		yypop_buffer_state();
+	 *		yypush_buffer_state(new_buffer);
+     */
+	yyensure_buffer_stack ();
+	if ( YY_CURRENT_BUFFER == new_buffer )
+		return;
+
+	if ( YY_CURRENT_BUFFER )
+		{
+		/* Flush out information for old buffer. */
+		*(yy_c_buf_p) = (yy_hold_char);
+		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
+		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
+		}
+
+	YY_CURRENT_BUFFER_LVALUE = new_buffer;
+	yy_load_buffer_state(  );
+
+	/* We don't actually know whether we did this switch during
+	 * EOF (yywrap()) processing, but the only time this flag
+	 * is looked at is after yywrap() is called, so it's safe
+	 * to go ahead and always set it.
+	 */
+	(yy_did_buffer_switch_on_eof) = 1;
+}
+
+static void yy_load_buffer_state  (void)
+{
+    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
+	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
+	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
+	(yy_hold_char) = *(yy_c_buf_p);
+}
+
+/** Allocate and initialize an input buffer state.
+ * @param file A readable stream.
+ * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
+ * 
+ * @return the allocated buffer state.
+ */
+    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
+{
+	YY_BUFFER_STATE b;
+    
+	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
+	if ( ! b )
+		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );
+
+	b->yy_buf_size = size;
+
+	/* yy_ch_buf has to be 2 characters longer than the size given because
+	 * we need to put in 2 end-of-buffer characters.
+	 */
+	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
+	if ( ! b->yy_ch_buf )
+		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );
+
+	b->yy_is_our_buffer = 1;
+
+	yy_init_buffer( b, file );
+
+	return b;
+}
+
+/** Destroy the buffer.
+ * @param b a buffer created with yy_create_buffer()
+ * 
+ */
+    void yy_delete_buffer (YY_BUFFER_STATE  b )
+{
+    
+	if ( ! b )
+		return;
+
+	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
+		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;
+
+	if ( b->yy_is_our_buffer )
+		yyfree( (void *) b->yy_ch_buf  );
+
+	yyfree( (void *) b  );
+}
+
+/* Initializes or reinitializes a buffer.
+ * This function is sometimes called more than once on the same buffer,
+ * such as during a yyrestart() or at EOF.
+ */
+    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )
+
+{
+	int oerrno = errno;
+    
+	yy_flush_buffer( b );
+
+	b->yy_input_file = file;
+	b->yy_fill_buffer = 1;
+
+    /* If b is the current buffer, then yy_init_buffer was _probably_
+     * called from yyrestart() or through yy_get_next_buffer.
+     * In that case, we don't want to reset the lineno or column.
+     */
+    if (b != YY_CURRENT_BUFFER){
+        b->yy_bs_lineno = 1;
+        b->yy_bs_column = 0;
+    }
+
+        b->yy_is_interactive = 0;
+    
+	errno = oerrno;
+}
+
+/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
+ * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
+ * 
+ */
+    void yy_flush_buffer (YY_BUFFER_STATE  b )
+{
+    	if ( ! b )
+		return;
+
+	b->yy_n_chars = 0;
+
+	/* We always need two end-of-buffer characters.  The first causes
+	 * a transition to the end-of-buffer state.  The second causes
+	 * a jam in that state.
+	 */
+	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
+	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;
+
+	b->yy_buf_pos = &b->yy_ch_buf[0];
+
+	b->yy_at_bol = 1;
+	b->yy_buffer_status = YY_BUFFER_NEW;
+
+	if ( b == YY_CURRENT_BUFFER )
+		yy_load_buffer_state(  );
+}
+
+/** Pushes the new state onto the stack. The new state becomes
+ *  the current state. This function will allocate the stack
+ *  if necessary.
+ *  @param new_buffer The new state.
+ *  
+ */
+void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
+{
+    	if (new_buffer == NULL)
+		return;
+
+	yyensure_buffer_stack();
+
+	/* This block is copied from yy_switch_to_buffer. */
+	if ( YY_CURRENT_BUFFER )
+		{
+		/* Flush out information for old buffer. */
+		*(yy_c_buf_p) = (yy_hold_char);
+		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
+		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
+		}
+
+	/* Only push if top exists. Otherwise, replace top. */
+	if (YY_CURRENT_BUFFER)
+		(yy_buffer_stack_top)++;
+	YY_CURRENT_BUFFER_LVALUE = new_buffer;
+
+	/* copied from yy_switch_to_buffer. */
+	yy_load_buffer_state(  );
+	(yy_did_buffer_switch_on_eof) = 1;
+}
+
+/** Removes and deletes the top of the stack, if present.
+ *  The next element becomes the new top.
+ *  
+ */
+void yypop_buffer_state (void)
+{
+    	if (!YY_CURRENT_BUFFER)
+		return;
+
+	yy_delete_buffer(YY_CURRENT_BUFFER );
+	YY_CURRENT_BUFFER_LVALUE = NULL;
+	if ((yy_buffer_stack_top) > 0)
+		--(yy_buffer_stack_top);
+
+	if (YY_CURRENT_BUFFER) {
+		yy_load_buffer_state(  );
+		(yy_did_buffer_switch_on_eof) = 1;
+	}
+}
+
+/* Allocates the stack if it does not exist.
+ *  Guarantees space for at least one push.
+ */
+static void yyensure_buffer_stack (void)
+{
+	yy_size_t num_to_alloc;
+    
+	if (!(yy_buffer_stack)) {
+
+		/* First allocation is just for 2 elements, since we don't know if this
+		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
+		 * immediate realloc on the next call.
+         */
+      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
+		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
+								(num_to_alloc * sizeof(struct yy_buffer_state*)
+								);
+		if ( ! (yy_buffer_stack) )
+			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
+
+		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
+
+		(yy_buffer_stack_max) = num_to_alloc;
+		(yy_buffer_stack_top) = 0;
+		return;
+	}
+
+	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){
+
+		/* Increase the buffer to prepare for a possible push. */
+		yy_size_t grow_size = 8 /* arbitrary grow size */;
+
+		num_to_alloc = (yy_buffer_stack_max) + grow_size;
+		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
+								((yy_buffer_stack),
+								num_to_alloc * sizeof(struct yy_buffer_state*)
+								);
+		if ( ! (yy_buffer_stack) )
+			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
+
+		/* zero only the new slots.*/
+		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
+		(yy_buffer_stack_max) = num_to_alloc;
+	}
+}
+
+/** Setup the input buffer state to scan directly from a user-specified character buffer.
+ * @param base the character buffer
+ * @param size the size in bytes of the character buffer
+ * 
+ * @return the newly allocated buffer state object.
+ */
+YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
+{
+	YY_BUFFER_STATE b;
+    
+	if ( size < 2 ||
+	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
+	     base[size-1] != YY_END_OF_BUFFER_CHAR )
+		/* They forgot to leave room for the EOB's. */
+		return NULL;
+
+	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
+	if ( ! b )
+		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );
+
+	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
+	b->yy_buf_pos = b->yy_ch_buf = base;
+	b->yy_is_our_buffer = 0;
+	b->yy_input_file = NULL;
+	b->yy_n_chars = b->yy_buf_size;
+	b->yy_is_interactive = 0;
+	b->yy_at_bol = 1;
+	b->yy_fill_buffer = 0;
+	b->yy_buffer_status = YY_BUFFER_NEW;
+
+	yy_switch_to_buffer( b  );
+
+	return b;
+}
+
+/** Setup the input buffer state to scan a string. The next call to yylex() will
+ * scan from a @e copy of @a str.
+ * @param yystr a NUL-terminated string to scan
+ * 
+ * @return the newly allocated buffer state object.
+ * @note If you want to scan bytes that may contain NUL values, then use
+ *       yy_scan_bytes() instead.
+ */
+YY_BUFFER_STATE yy_scan_string (const char * yystr )
+{
+    
+	return yy_scan_bytes( yystr, (int) strlen(yystr) );
+}
+
+/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
+ * scan from a @e copy of @a bytes.
+ * @param yybytes the byte buffer to scan
+ * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
+ * 
+ * @return the newly allocated buffer state object.
+ */
+YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
+{
+	YY_BUFFER_STATE b;
+	char *buf;
+	yy_size_t n;
+	int i;
+    
+	/* Get memory for full buffer, including space for trailing EOB's. */
+	n = (yy_size_t) (_yybytes_len + 2);
+	buf = (char *) yyalloc( n  );
+	if ( ! buf )
+		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );
+
+	for ( i = 0; i < _yybytes_len; ++i )
+		buf[i] = yybytes[i];
+
+	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;
+
+	b = yy_scan_buffer( buf, n );
+	if ( ! b )
+		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );
+
+	/* It's okay to grow etc. this buffer, and we should throw it
+	 * away when we're done.
+	 */
+	b->yy_is_our_buffer = 1;
+
+	return b;
+}
+
+#ifndef YY_EXIT_FAILURE
+#define YY_EXIT_FAILURE 2
+#endif
+
+static void yynoreturn yy_fatal_error (const char* msg )
+{
+			fprintf( stderr, "%s\n", msg );
+	exit( YY_EXIT_FAILURE );
+}
+
+/* Redefine yyless() so it works in section 3 code. */
+
+#undef yyless
+#define yyless(n) \
+	do \
+		{ \
+		/* Undo effects of setting up yytext. */ \
+        int yyless_macro_arg = (n); \
+        YY_LESS_LINENO(yyless_macro_arg);\
+		yytext[yyleng] = (yy_hold_char); \
+		(yy_c_buf_p) = yytext + yyless_macro_arg; \
+		(yy_hold_char) = *(yy_c_buf_p); \
+		*(yy_c_buf_p) = '\0'; \
+		yyleng = yyless_macro_arg; \
+		} \
+	while ( 0 )
+
+/* Accessor  methods (get/set functions) to struct members. */
+
+/** Get the current line number.
+ * 
+ */
+int yyget_lineno  (void)
+{
+    
+    return yylineno;
+}
+
+/** Get the input stream.
+ * 
+ */
+FILE *yyget_in  (void)
+{
+        return yyin;
+}
+
+/** Get the output stream.
+ * 
+ */
+FILE *yyget_out  (void)
+{
+        return yyout;
+}
+
+/** Get the length of the current token.
+ * 
+ */
+int yyget_leng  (void)
+{
+        return yyleng;
+}
+
+/** Get the current token.
+ * 
+ */
+
+char *yyget_text  (void)
+{
+        return yytext;
+}
+
+/** Set the current line number.
+ * @param _line_number line number
+ * 
+ */
+void yyset_lineno (int  _line_number )
+{
+    
+    yylineno = _line_number;
+}
+
+/** Set the input stream. This does not discard the current
+ * input buffer.
+ * @param _in_str A readable stream.
+ * 
+ * @see yy_switch_to_buffer
+ */
+void yyset_in (FILE *  _in_str )
+{
+        yyin = _in_str ;
+}
+
+void yyset_out (FILE *  _out_str )
+{
+        yyout = _out_str ;
+}
+
+int yyget_debug  (void)
+{
+        return yy_flex_debug;
+}
+
+void yyset_debug (int  _bdebug )
+{
+        yy_flex_debug = _bdebug ;
+}
+
+static int yy_init_globals (void)
+{
+        /* Initialization is the same as for the non-reentrant scanner.
+     * This function is called from yylex_destroy(), so don't allocate here.
+     */
+
+    (yy_buffer_stack) = NULL;
+    (yy_buffer_stack_top) = 0;
+    (yy_buffer_stack_max) = 0;
+    (yy_c_buf_p) = NULL;
+    (yy_init) = 0;
+    (yy_start) = 0;
+
+/* Defined in main.c */
+#ifdef YY_STDINIT
+    yyin = stdin;
+    yyout = stdout;
+#else
+    yyin = NULL;
+    yyout = NULL;
+#endif
+
+    /* For future reference: Set errno on error, since we are called by
+     * yylex_init()
+     */
+    return 0;
+}
+
+/* yylex_destroy is for both reentrant and non-reentrant scanners. */
+int yylex_destroy  (void)
+{
+    
+    /* Pop the buffer stack, destroying each element. */
+	while(YY_CURRENT_BUFFER){
+		yy_delete_buffer( YY_CURRENT_BUFFER  );
+		YY_CURRENT_BUFFER_LVALUE = NULL;
+		yypop_buffer_state();
+	}
+
+	/* Destroy the stack itself. */
+	yyfree((yy_buffer_stack) );
+	(yy_buffer_stack) = NULL;
+
+    /* Reset the globals. This is important in a non-reentrant scanner so the next time
+     * yylex() is called, initialization will occur. */
+    yy_init_globals( );
+
+    return 0;
+}
+
+/*
+ * Internal utility routines.
+ */
+
+#ifndef yytext_ptr
+static void yy_flex_strncpy (char* s1, const char * s2, int n )
+{
+		
+	int i;
+	for ( i = 0; i < n; ++i )
+		s1[i] = s2[i];
+}
+#endif
+
+#ifdef YY_NEED_STRLEN
+static int yy_flex_strlen (const char * s )
+{
+	int n;
+	for ( n = 0; s[n]; ++n )
+		;
+
+	return n;
+}
+#endif
+
+void *yyalloc (yy_size_t  size )
+{
+			return malloc(size);
+}
+
+void *yyrealloc  (void * ptr, yy_size_t  size )
+{
+		
+	/* The cast to (char *) in the following accommodates both
+	 * implementations that use char* generic pointers, and those
+	 * that use void* generic pointers.  It works with the latter
+	 * because both ANSI C and C++ allow castless assignment from
+	 * any pointer type to void*, and deal with argument conversions
+	 * as though doing an assignment.
+	 */
+	return realloc(ptr, size);
+}
+
+void yyfree (void * ptr )
+{
+			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
+}
+
+#define YYTABLES_NAME "yytables"
+
+#line 750 "maplexer.l"
+
+
+/*
+** Any extra C functions
+*/
+
+int msyywrap() /* override */
+{
+  return(1);
+}
+
+int msyyerror(char *s) {
+  msSetError(MS_PARSEERR, "%s", "msyyparse()", s);
+  return(0);
+}
+
+/* cleanup any open includes */
+void msyycleanup_includes() {
+  while( --include_stack_ptr >= 0 ) {
+    fclose(YY_CURRENT_BUFFER->yy_input_file);
+    msyy_delete_buffer( YY_CURRENT_BUFFER );
+    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
+  }
+}
+
diff -pruN 8.0.1-5/src/maplexer.l 8.2.0~beta1-1~exp1/src/maplexer.l
--- 8.0.1-5/src/maplexer.l	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maplexer.l	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,772 @@
+%option never-interactive
+
+%{
+/*
+** READ ME FIRST!
+**
+** When this file is altered, it is necessary to do "make lexer".  Due to
+** problems detailed in #2310 the lexer is no longer automatically rebuilt
+** when maplexer.l is altered.
+*/
+
+#define YY_NO_INPUT
+
+/* C declarations */
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <math.h>
+
+#include <time.h>
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapfile.h"
+#include "maptime.h"
+#include "mapsymbol.h"
+#include "mapparser.h"
+#include "mapprimitive.h"
+
+/* msyylineno is required for flex 2.5.4 and older, but is already defined by
+ * flex 2.5.31 (bug 975).
+ * Unfortunately there is no clean way to differenciate the two versions,
+ * so we use the symbol YY_CURRENT_BUFFER_LVALUE to base our test since it
+ * was not present in 2.5.4 and is present in 2.5.31. Hopefully that won't
+ * put us in trouble with other versions. If that happens then we can
+ * switch to using autoconf to detect the version.
+ */
+#ifndef YY_CURRENT_BUFFER_LVALUE
+int msyylineno = 1;
+#endif
+
+#define YY_NO_INPUT
+
+/* Below is a redefinition of the default YY_INPUT() macro but replacing the
+ * YY_FATAL_ERROR() macro with a call to msSetError().
+ */
+/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
+ * is returned in "result".
+ */
+#define YY_INPUT(buf,result,max_size) \
+	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
+		{ \
+		int c = '*'; \
+		int n; \
+		for ( n = 0; n < max_size && \
+			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
+			buf[n] = (char) c; \
+		if ( c == '\n' ) \
+			buf[n++] = (char) c; \
+		if ( c == EOF && ferror( yyin ) ) \
+            msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
+		result = n; \
+		} \
+	else \
+		{ \
+		errno=0; \
+		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
+			{ \
+			if( errno != EINTR) \
+				{ \
+                msSetError(MS_PARSEERR, "%s", "msyyparse()", "input in flex scanner failed"); \
+				break; \
+				} \
+			errno=0; \
+			clearerr(yyin); \
+			} \
+		}
+
+int msyysource=MS_STRING_TOKENS;
+double msyynumber;
+int msyystate=MS_TOKENIZE_DEFAULT;
+const char *msyystring=NULL;
+char *msyybasepath=NULL;
+int  msyystring_buffer_size = 0;
+int  msyystring_size;
+char msyystring_begin;
+char *msyystring_buffer = NULL;
+int  msyystring_icase = MS_FALSE;
+int  msyystring_return_state;
+int  msyystring_begin_state;
+
+int msyyreturncomments = 0;
+
+#define MS_LEXER_STRING_REALLOC(string, string_size, max_size)   \
+  do { \
+   const int string_size_macro = (int)(string_size); \
+   if (string_size_macro >= (int)(max_size)) {         \
+       max_size = (((int)(max_size)*2) > string_size_macro) ? ((int)(max_size))*2 : string_size_macro+1;   \
+       string = (char *) msSmallRealloc(string, sizeof(char *) * (max_size));  \
+   } \
+  } while(0)
+
+#define MS_LEXER_RETURN_TOKEN(token) \
+   MS_LEXER_STRING_REALLOC(msyystring_buffer, strlen(msyytext),  \
+                           msyystring_buffer_size); \
+   strcpy(msyystring_buffer, msyytext); \
+   return(token); 
+
+#define MAX_INCLUDE_DEPTH 5
+YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
+int include_lineno[MAX_INCLUDE_DEPTH];
+int include_stack_ptr = 0;
+char path[MS_MAXPATHLEN];
+
+%}
+
+%s EXPRESSION_STRING
+%s INCLUDE
+%s MSSTRING
+%s MULTILINE_COMMENT
+%s CONFIG_FILE
+
+%%
+       if (msyystring_buffer == NULL)
+       {
+           msyystring_buffer_size = 256;
+           msyystring_buffer = (char*) msSmallMalloc(sizeof(char) * msyystring_buffer_size);
+       }
+
+       msyystring_buffer[0] = '\0';
+       switch(msyystate) {
+       case(MS_TOKENIZE_DEFAULT):
+         (void) yyunput; /* just to avoid warning about it being unrefed */ 
+         break;
+       case(MS_TOKENIZE_FILE):
+         BEGIN(INITIAL);
+         msyystring_begin_state = INITIAL;
+         msyysource=MS_FILE_TOKENS;
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyystring=NULL;
+         msyyreturncomments=0;
+         include_stack_ptr=0;
+         return(0);
+         break;
+       case(MS_TOKENIZE_STRING):
+         BEGIN(INITIAL);
+         msyystring_begin_state = INITIAL;
+         msyy_delete_buffer(YY_CURRENT_BUFFER);
+         msyy_scan_string(msyystring);
+         msyysource=MS_STRING_TOKENS;
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyyin=NULL;
+         msyyreturncomments=0;
+         include_stack_ptr=0;
+         return(0);
+         break;
+       case(MS_TOKENIZE_EXPRESSION):
+         BEGIN(EXPRESSION_STRING);
+         msyystring_begin_state = EXPRESSION_STRING;
+         msyy_delete_buffer(YY_CURRENT_BUFFER);
+         msyy_scan_string(msyystring);
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyyreturncomments=0;
+         break;
+       case(MS_TOKENIZE_CONFIG):
+         BEGIN(CONFIG_FILE);
+         msyystring_begin_state = CONFIG_FILE;
+         msyysource=MS_FILE_TOKENS;
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyystring=NULL;
+         msyyreturncomments=0;
+         return(0);
+         break;
+       case(99):
+         BEGIN(INITIAL); /* may not need this one */
+         msyystring_begin_state = INITIAL;
+         msyy_delete_buffer(YY_CURRENT_BUFFER);
+         msyystate=MS_TOKENIZE_DEFAULT;
+         msyystring=NULL;
+         msyyreturncomments=0; 
+         return(0);
+         break;
+       default:
+         break;
+       }
+
+<INITIAL,EXPRESSION_STRING,INCLUDE,CONFIG_FILE>[ \t\r]+             ;
+
+<INITIAL,CONFIG_FILE>(\/\/|#).*                { if (msyyreturncomments) return(MS_COMMENT); }
+
+<INITIAL>\/\*                                  { BEGIN(MULTILINE_COMMENT); }
+<MULTILINE_COMMENT>\*\/                        { BEGIN(INITIAL); }
+<MULTILINE_COMMENT>[^*\n]+                     ;
+<MULTILINE_COMMENT>\*                          ;
+<MULTILINE_COMMENT>\n                          { msyylineno++; }
+
+<CONFIG_FILE>config                            { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION); }
+<CONFIG_FILE>env                               { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_ENV); }
+<CONFIG_FILE>maps                              { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_MAPS); }
+<CONFIG_FILE>plugins                           { MS_LEXER_RETURN_TOKEN(MS_CONFIG_SECTION_PLUGINS) }
+
+<EXPRESSION_STRING>or|\|\|                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_OR); }
+<EXPRESSION_STRING>and|&&                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_AND); }
+<EXPRESSION_STRING>not|!                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_LOGICAL_NOT); }
+<EXPRESSION_STRING>eq|=|==                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQ); }
+<EXPRESSION_STRING>ne|!=                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_NE); }
+<EXPRESSION_STRING>gt|>                        { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GT); }
+<EXPRESSION_STRING>lt|<                        { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LT); }
+<EXPRESSION_STRING>ge|>=                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_GE); }
+<EXPRESSION_STRING>le|<=                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_LE); }
+<EXPRESSION_STRING>~                           { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_RE); }
+
+<EXPRESSION_STRING>=\*                         { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IEQ); }
+<EXPRESSION_STRING>~\*                         { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IRE); }
+
+<EXPRESSION_STRING>in                          { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_IN); /* was IN */ }
+
+<EXPRESSION_STRING>area                        { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_AREA); }
+<EXPRESSION_STRING>length                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LENGTH); }
+<EXPRESSION_STRING>tostring                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_TOSTRING); }
+<EXPRESSION_STRING>commify                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_COMMIFY); }
+<EXPRESSION_STRING>round                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_ROUND); }
+<EXPRESSION_STRING>upper                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_UPPER); }
+<EXPRESSION_STRING>lower                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_LOWER); }
+<EXPRESSION_STRING>initcap                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INITCAP); }
+<EXPRESSION_STRING>firstcap                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FIRSTCAP); }
+
+<EXPRESSION_STRING>buffer                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_BUFFER); }
+<EXPRESSION_STRING>difference                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DIFFERENCE); }
+<EXPRESSION_STRING>simplify                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFY); }
+<EXPRESSION_STRING>simplifypt                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SIMPLIFYPT); }
+<EXPRESSION_STRING>generalize                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_GENERALIZE); }
+<EXPRESSION_STRING>smoothsia                   { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_SMOOTHSIA); }
+<EXPRESSION_STRING>centerline                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_CENTERLINE); }
+<EXPRESSION_STRING>densify                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_DENSIFY); }
+<EXPRESSION_STRING>outer                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_OUTER); }
+<EXPRESSION_STRING>inner                       { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_INNER); } 
+<EXPRESSION_STRING>javascript                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_JAVASCRIPT); }
+
+<EXPRESSION_STRING>intersects                  { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_INTERSECTS); }
+<EXPRESSION_STRING>disjoint                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DISJOINT); }
+<EXPRESSION_STRING>touches                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_TOUCHES); }
+<EXPRESSION_STRING>overlaps                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_OVERLAPS); }
+<EXPRESSION_STRING>crosses                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CROSSES); }
+<EXPRESSION_STRING>within                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_WITHIN); }
+<EXPRESSION_STRING>contains                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_CONTAINS); }
+<EXPRESSION_STRING>equals                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_EQUALS); }
+<EXPRESSION_STRING>beyond                      { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_BEYOND); }
+<EXPRESSION_STRING>dwithin                     { MS_LEXER_RETURN_TOKEN(MS_TOKEN_COMPARISON_DWITHIN); }
+
+<EXPRESSION_STRING>fromtext                    { MS_LEXER_RETURN_TOKEN(MS_TOKEN_FUNCTION_FROMTEXT); }
+
+<EXPRESSION_STRING>true                        { msyynumber=MS_TRUE; return(MS_TOKEN_LITERAL_BOOLEAN); }
+<EXPRESSION_STRING>false                       { msyynumber=MS_FALSE; return(MS_TOKEN_LITERAL_BOOLEAN); }
+
+<INITIAL>colorrange                            { MS_LEXER_RETURN_TOKEN(COLORRANGE); }
+<INITIAL>datarange                             { MS_LEXER_RETURN_TOKEN(DATARANGE); }
+<INITIAL>rangeitem                             { MS_LEXER_RETURN_TOKEN(RANGEITEM); }
+
+<INITIAL>align                                 { MS_LEXER_RETURN_TOKEN(ALIGN); }
+<INITIAL>anchorpoint                           { MS_LEXER_RETURN_TOKEN(ANCHORPOINT); }
+<INITIAL>angle                                 { MS_LEXER_RETURN_TOKEN(ANGLE); }
+<INITIAL>antialias                             { MS_LEXER_RETURN_TOKEN(ANTIALIAS); }
+<INITIAL>backgroundcolor                       { MS_LEXER_RETURN_TOKEN(BACKGROUNDCOLOR); }
+<INITIAL>bandsitem                             { MS_LEXER_RETURN_TOKEN(BANDSITEM); }
+<INITIAL>bindvals                              { MS_LEXER_RETURN_TOKEN(BINDVALS); }
+<INITIAL>\xEF\xBB\xBF                          { MS_LEXER_RETURN_TOKEN(BOM); }
+<INITIAL>browseformat                          { MS_LEXER_RETURN_TOKEN(BROWSEFORMAT); }
+<INITIAL>buffer                                { MS_LEXER_RETURN_TOKEN(BUFFER); }
+<INITIAL>character                             { MS_LEXER_RETURN_TOKEN(CHARACTER); }
+<INITIAL>class                                 { MS_LEXER_RETURN_TOKEN(CLASS); }
+<INITIAL>classitem                             { MS_LEXER_RETURN_TOKEN(CLASSITEM); }
+<INITIAL>classgroup                            { MS_LEXER_RETURN_TOKEN(CLASSGROUP); }
+<INITIAL>cluster                               { MS_LEXER_RETURN_TOKEN(CLUSTER); }
+<INITIAL>color                                 { MS_LEXER_RETURN_TOKEN(COLOR); }
+<INITIAL>compfilter                            { MS_LEXER_RETURN_TOKEN(COMPFILTER); }
+<INITIAL>composite                             { MS_LEXER_RETURN_TOKEN(COMPOSITE); }
+<INITIAL>compop                                { MS_LEXER_RETURN_TOKEN(COMPOP); }
+<INITIAL>config                                { MS_LEXER_RETURN_TOKEN(CONFIG); }
+<INITIAL>connection                            { MS_LEXER_RETURN_TOKEN(CONNECTION); }
+<INITIAL>connectiontype                        { MS_LEXER_RETURN_TOKEN(CONNECTIONTYPE); }
+<INITIAL>data                                  { MS_LEXER_RETURN_TOKEN(DATA); }
+<INITIAL>debug                                 { MS_LEXER_RETURN_TOKEN(DEBUG); }
+<INITIAL>driver                                { MS_LEXER_RETURN_TOKEN(DRIVER); }
+<INITIAL>empty                                 { MS_LEXER_RETURN_TOKEN(EMPTY); }
+<INITIAL>encoding                              { MS_LEXER_RETURN_TOKEN(ENCODING); }
+<INITIAL,CONFIG_FILE>end                       { MS_LEXER_RETURN_TOKEN(END); }
+<INITIAL>error                                 { MS_LEXER_RETURN_TOKEN(ERROR); }
+<INITIAL>expression                            { MS_LEXER_RETURN_TOKEN(EXPRESSION); }
+<INITIAL>extent                                { MS_LEXER_RETURN_TOKEN(EXTENT); }
+<INITIAL>extension                             { MS_LEXER_RETURN_TOKEN(EXTENSION); }
+<INITIAL>feature                               { MS_LEXER_RETURN_TOKEN(FEATURE); }
+<INITIAL>filled                                { MS_LEXER_RETURN_TOKEN(FILLED); }
+<INITIAL>filter                                { MS_LEXER_RETURN_TOKEN(FILTER); }
+<INITIAL>filteritem                            { MS_LEXER_RETURN_TOKEN(FILTERITEM); }
+<INITIAL>footer                                { MS_LEXER_RETURN_TOKEN(FOOTER); }
+<INITIAL>font                                  { MS_LEXER_RETURN_TOKEN(FONT); }
+<INITIAL>fontset                               { MS_LEXER_RETURN_TOKEN(FONTSET); }
+<INITIAL>force                                 { MS_LEXER_RETURN_TOKEN(FORCE); }
+<INITIAL>formatoption                          { MS_LEXER_RETURN_TOKEN(FORMATOPTION); }
+<INITIAL>from                                  { MS_LEXER_RETURN_TOKEN(FROM); }
+<INITIAL>gap                                   { MS_LEXER_RETURN_TOKEN(GAP); }
+<INITIAL>geomtransform                         { MS_LEXER_RETURN_TOKEN(GEOMTRANSFORM); }
+<INITIAL>grid                                  { MS_LEXER_RETURN_TOKEN(GRID); }
+<INITIAL>gridstep                              { MS_LEXER_RETURN_TOKEN(GRIDSTEP); }
+<INITIAL>graticule                             { MS_LEXER_RETURN_TOKEN(GRATICULE); }
+<INITIAL>group                                 { MS_LEXER_RETURN_TOKEN(GROUP); }
+<INITIAL>header                                { MS_LEXER_RETURN_TOKEN(HEADER); }
+<INITIAL>image                                 { MS_LEXER_RETURN_TOKEN(IMAGE); }
+<INITIAL>imagecolor                            { MS_LEXER_RETURN_TOKEN(IMAGECOLOR); }
+<INITIAL>imagetype                             { MS_LEXER_RETURN_TOKEN(IMAGETYPE); }
+<INITIAL>imagemode                             { MS_LEXER_RETURN_TOKEN(IMAGEMODE); }
+<INITIAL>imagepath                             { MS_LEXER_RETURN_TOKEN(IMAGEPATH); }
+<INITIAL>temppath                              { MS_LEXER_RETURN_TOKEN(TEMPPATH); }
+<INITIAL>imageurl                              { MS_LEXER_RETURN_TOKEN(IMAGEURL); }
+<INITIAL>include                               { BEGIN(INCLUDE); }
+<INITIAL>index                                 { MS_LEXER_RETURN_TOKEN(INDEX); }
+<INITIAL>initialgap                            { MS_LEXER_RETURN_TOKEN(INITIALGAP); }
+<INITIAL>intervals                             { MS_LEXER_RETURN_TOKEN(INTERVALS); } 
+<INITIAL>join                                  { MS_LEXER_RETURN_TOKEN(JOIN); }
+<INITIAL>keyimage                              { MS_LEXER_RETURN_TOKEN(KEYIMAGE); }
+<INITIAL>keysize                               { MS_LEXER_RETURN_TOKEN(KEYSIZE); }
+<INITIAL>keyspacing                            { MS_LEXER_RETURN_TOKEN(KEYSPACING); }
+<INITIAL>label                                 { MS_LEXER_RETURN_TOKEN(LABEL); }
+<INITIAL>labelcache                            { MS_LEXER_RETURN_TOKEN(LABELCACHE); }
+<INITIAL>labelformat                           { MS_LEXER_RETURN_TOKEN(LABELFORMAT); }
+<INITIAL>labelitem                             { MS_LEXER_RETURN_TOKEN(LABELITEM); }
+<INITIAL>labelmaxscale                         { MS_LEXER_RETURN_TOKEN(LABELMAXSCALE); }
+<INITIAL>labelmaxscaledenom                    { MS_LEXER_RETURN_TOKEN(LABELMAXSCALEDENOM); }
+<INITIAL>labelminscale                         { MS_LEXER_RETURN_TOKEN(LABELMINSCALE); }
+<INITIAL>labelminscaledenom                    { MS_LEXER_RETURN_TOKEN(LABELMINSCALEDENOM); }
+<INITIAL>labelrequires                         { MS_LEXER_RETURN_TOKEN(LABELREQUIRES); }
+<INITIAL>latlon                                { MS_LEXER_RETURN_TOKEN(LATLON); }
+<INITIAL>layer                                 { MS_LEXER_RETURN_TOKEN(LAYER); }
+<INITIAL>leader                                { MS_LEXER_RETURN_TOKEN(LEADER); }
+<INITIAL>legend                                { MS_LEXER_RETURN_TOKEN(LEGEND); }
+<INITIAL>legendformat                          { MS_LEXER_RETURN_TOKEN(LEGENDFORMAT); }
+<INITIAL>linecap                               { MS_LEXER_RETURN_TOKEN(LINECAP); }
+<INITIAL>linejoin                              { MS_LEXER_RETURN_TOKEN(LINEJOIN); }
+<INITIAL>linejoinmaxsize                       { MS_LEXER_RETURN_TOKEN(LINEJOINMAXSIZE); }
+<INITIAL>map                                   { MS_LEXER_RETURN_TOKEN(MAP); }
+<INITIAL>marker                                { MS_LEXER_RETURN_TOKEN(MARKER); }
+<INITIAL>markersize                            { MS_LEXER_RETURN_TOKEN(MARKERSIZE); }
+<INITIAL>mask                                  { MS_LEXER_RETURN_TOKEN(MASK); }
+<INITIAL>maxarcs                               { MS_LEXER_RETURN_TOKEN(MAXARCS); }
+<INITIAL>maxboxsize                            { MS_LEXER_RETURN_TOKEN(MAXBOXSIZE); }
+<INITIAL>maxdistance                           { MS_LEXER_RETURN_TOKEN(MAXDISTANCE); }
+<INITIAL>maxfeatures                           { MS_LEXER_RETURN_TOKEN(MAXFEATURES); }
+<INITIAL>maxinterval                           { MS_LEXER_RETURN_TOKEN(MAXINTERVAL); }
+<INITIAL>maxscale                              { MS_LEXER_RETURN_TOKEN(MAXSCALE); }
+<INITIAL>maxscaledenom                         { MS_LEXER_RETURN_TOKEN(MAXSCALEDENOM); }
+<INITIAL>maxgeowidth                           { MS_LEXER_RETURN_TOKEN(MAXGEOWIDTH); }
+<INITIAL>maxlength                             { MS_LEXER_RETURN_TOKEN(MAXLENGTH); }
+<INITIAL>maxsize                               { MS_LEXER_RETURN_TOKEN(MAXSIZE); }
+<INITIAL>maxsubdivide                          { MS_LEXER_RETURN_TOKEN(MAXSUBDIVIDE); }
+<INITIAL>maxtemplate                           { MS_LEXER_RETURN_TOKEN(MAXTEMPLATE); }
+<INITIAL>maxwidth                              { MS_LEXER_RETURN_TOKEN(MAXWIDTH); }
+<INITIAL>metadata                              { MS_LEXER_RETURN_TOKEN(METADATA); }
+<INITIAL>mimetype                              { MS_LEXER_RETURN_TOKEN(MIMETYPE); }
+<INITIAL>minarcs                               { MS_LEXER_RETURN_TOKEN(MINARCS); }
+<INITIAL>minboxsize                            { MS_LEXER_RETURN_TOKEN(MINBOXSIZE); }
+<INITIAL>mindistance                           { MS_LEXER_RETURN_TOKEN(MINDISTANCE); }
+<INITIAL>repeatdistance                        { MS_LEXER_RETURN_TOKEN(REPEATDISTANCE); }
+<INITIAL>maxoverlapangle                       { MS_LEXER_RETURN_TOKEN(MAXOVERLAPANGLE); } 
+<INITIAL>minfeaturesize                        { MS_LEXER_RETURN_TOKEN(MINFEATURESIZE); }
+<INITIAL>mininterval                           { MS_LEXER_RETURN_TOKEN(MININTERVAL); }
+<INITIAL>minscale                              { MS_LEXER_RETURN_TOKEN(MINSCALE); }
+<INITIAL>minscaledenom                         { MS_LEXER_RETURN_TOKEN(MINSCALEDENOM); }
+<INITIAL>mingeowidth                           { MS_LEXER_RETURN_TOKEN(MINGEOWIDTH); }
+<INITIAL>minsize                               { MS_LEXER_RETURN_TOKEN(MINSIZE); }
+<INITIAL>minsubdivide                          { MS_LEXER_RETURN_TOKEN(MINSUBDIVIDE); }
+<INITIAL>mintemplate                           { MS_LEXER_RETURN_TOKEN(MINTEMPLATE); }
+<INITIAL>minwidth                              { MS_LEXER_RETURN_TOKEN(MINWIDTH); }
+<INITIAL>name                                  { MS_LEXER_RETURN_TOKEN(NAME); }
+<INITIAL>offset                                { MS_LEXER_RETURN_TOKEN(OFFSET); }
+<INITIAL>offsite                               { MS_LEXER_RETURN_TOKEN(OFFSITE); }
+<INITIAL>opacity                               { MS_LEXER_RETURN_TOKEN(OPACITY); }
+<INITIAL>connectionoptions                     { MS_LEXER_RETURN_TOKEN(CONNECTIONOPTIONS); }
+<INITIAL>outlinecolor                          { MS_LEXER_RETURN_TOKEN(OUTLINECOLOR); }
+<INITIAL>outlinewidth                          { MS_LEXER_RETURN_TOKEN(OUTLINEWIDTH); }
+<INITIAL>outputformat                          { MS_LEXER_RETURN_TOKEN(OUTPUTFORMAT); }
+<INITIAL>partials                              { MS_LEXER_RETURN_TOKEN(PARTIALS); }
+<INITIAL>pattern                               { MS_LEXER_RETURN_TOKEN(PATTERN); }
+<INITIAL>points                                { MS_LEXER_RETURN_TOKEN(POINTS); }
+<INITIAL>items                                 { MS_LEXER_RETURN_TOKEN(ITEMS); }
+<INITIAL>position                              { MS_LEXER_RETURN_TOKEN(POSITION); }
+<INITIAL>postlabelcache                        { MS_LEXER_RETURN_TOKEN(POSTLABELCACHE); }
+<INITIAL>priority                              { MS_LEXER_RETURN_TOKEN(PRIORITY); }
+<INITIAL>processing                            { MS_LEXER_RETURN_TOKEN(PROCESSING); }
+<INITIAL>projection                            { MS_LEXER_RETURN_TOKEN(PROJECTION); }
+<INITIAL>queryformat                           { MS_LEXER_RETURN_TOKEN(QUERYFORMAT); }
+<INITIAL>querymap                              { MS_LEXER_RETURN_TOKEN(QUERYMAP); }
+<INITIAL>reference                             { MS_LEXER_RETURN_TOKEN(REFERENCE); }
+<INITIAL>region                                { MS_LEXER_RETURN_TOKEN(REGION); }
+<INITIAL>relativeto                            { MS_LEXER_RETURN_TOKEN(RELATIVETO); }
+<INITIAL>requires                              { MS_LEXER_RETURN_TOKEN(REQUIRES); }
+<INITIAL>resolution                            { MS_LEXER_RETURN_TOKEN(RESOLUTION); }
+<INITIAL>defresolution                         { MS_LEXER_RETURN_TOKEN(DEFRESOLUTION); }
+<INITIAL>scale                                 { MS_LEXER_RETURN_TOKEN(SCALE); }
+<INITIAL>scaledenom                            { MS_LEXER_RETURN_TOKEN(SCALEDENOM); }
+<INITIAL>scalebar                              { MS_LEXER_RETURN_TOKEN(SCALEBAR); }
+<INITIAL>scaletoken                            { MS_LEXER_RETURN_TOKEN(SCALETOKEN); }
+<INITIAL>shadowcolor                           { MS_LEXER_RETURN_TOKEN(SHADOWCOLOR); }
+<INITIAL>shadowsize                            { MS_LEXER_RETURN_TOKEN(SHADOWSIZE); }
+<INITIAL>shapepath                             { MS_LEXER_RETURN_TOKEN(SHAPEPATH); }
+<INITIAL>size                                  { MS_LEXER_RETURN_TOKEN(SIZE); }
+<INITIAL>sizeunits                             { MS_LEXER_RETURN_TOKEN(SIZEUNITS); }
+<INITIAL>status                                { MS_LEXER_RETURN_TOKEN(STATUS); }
+<INITIAL>style                                 { MS_LEXER_RETURN_TOKEN(STYLE); }
+<INITIAL>styleitem                             { MS_LEXER_RETURN_TOKEN(STYLEITEM); }
+<INITIAL>symbol                                { MS_LEXER_RETURN_TOKEN(SYMBOL); }
+<INITIAL>symbolscale                           { MS_LEXER_RETURN_TOKEN(SYMBOLSCALE); }
+<INITIAL>symbolscaledenom                      { MS_LEXER_RETURN_TOKEN(SYMBOLSCALEDENOM); }
+<INITIAL>symbolset                             { MS_LEXER_RETURN_TOKEN(SYMBOLSET); }
+<INITIAL>table                                 { MS_LEXER_RETURN_TOKEN(TABLE); }
+<INITIAL>template                              { MS_LEXER_RETURN_TOKEN(TEMPLATE); }
+<INITIAL>text                                  { MS_LEXER_RETURN_TOKEN(TEXT); }
+<INITIAL>tileindex                             { MS_LEXER_RETURN_TOKEN(TILEINDEX); }
+<INITIAL>tileitem                              { MS_LEXER_RETURN_TOKEN(TILEITEM); }
+<INITIAL>tilesrs                               { MS_LEXER_RETURN_TOKEN(TILESRS); }
+<INITIAL>title                                 { MS_LEXER_RETURN_TOKEN(TITLE); }
+<INITIAL>to                                    { MS_LEXER_RETURN_TOKEN(TO); }
+<INITIAL>tolerance                             { MS_LEXER_RETURN_TOKEN(TOLERANCE); }
+<INITIAL>toleranceunits                        { MS_LEXER_RETURN_TOKEN(TOLERANCEUNITS); }
+<INITIAL>transparent                           { MS_LEXER_RETURN_TOKEN(TRANSPARENT); }
+<INITIAL>transform                             { MS_LEXER_RETURN_TOKEN(TRANSFORM); }
+<INITIAL>type                                  { MS_LEXER_RETURN_TOKEN(TYPE); }
+<INITIAL>units                                 { MS_LEXER_RETURN_TOKEN(UNITS); }
+<INITIAL>utfdata                               { MS_LEXER_RETURN_TOKEN(UTFDATA); }
+<INITIAL>utfitem                               { MS_LEXER_RETURN_TOKEN(UTFITEM); }
+<INITIAL>validation                            { MS_LEXER_RETURN_TOKEN(VALIDATION); }
+<INITIAL>values                                { MS_LEXER_RETURN_TOKEN(VALUES); }
+<INITIAL>web                                   { MS_LEXER_RETURN_TOKEN(WEB); }
+<INITIAL>width                                 { MS_LEXER_RETURN_TOKEN(WIDTH); }
+<INITIAL>wkt                                   { MS_LEXER_RETURN_TOKEN(WKT); }
+<INITIAL>wrap                                  { MS_LEXER_RETURN_TOKEN(WRAP); }
+
+<INITIAL>annotation                            { MS_LEXER_RETURN_TOKEN(MS_LAYER_ANNOTATION); }
+<INITIAL>auto                                  { MS_LEXER_RETURN_TOKEN(MS_AUTO); }
+<INITIAL>auto2                                 { MS_LEXER_RETURN_TOKEN(MS_AUTO2); }
+<INITIAL>bevel                                 { MS_LEXER_RETURN_TOKEN(MS_CJC_BEVEL); }
+<INITIAL>bitmap                                { MS_LEXER_RETURN_TOKEN(MS_BITMAP); }
+<INITIAL>butt                                  { MS_LEXER_RETURN_TOKEN(MS_CJC_BUTT); }
+<INITIAL>cc                                    { MS_LEXER_RETURN_TOKEN(MS_CC); }
+<INITIAL>center                                { MS_LEXER_RETURN_TOKEN(MS_ALIGN_CENTER); }
+<INITIAL>chart                                 { MS_LEXER_RETURN_TOKEN(MS_LAYER_CHART); }
+<INITIAL>circle                                { MS_LEXER_RETURN_TOKEN(MS_LAYER_CIRCLE); }
+<INITIAL>cl                                    { MS_LEXER_RETURN_TOKEN(MS_CL); }
+<INITIAL>cr                                    { MS_LEXER_RETURN_TOKEN(MS_CR); }
+<INITIAL>csv                                   { MS_LEXER_RETURN_TOKEN(MS_DB_CSV); }
+<INITIAL>postgresql                            { MS_LEXER_RETURN_TOKEN(MS_DB_POSTGRES); }
+<INITIAL>mysql                                 { MS_LEXER_RETURN_TOKEN(MS_DB_MYSQL); }
+<INITIAL>default                               { MS_LEXER_RETURN_TOKEN(MS_DEFAULT); }
+<INITIAL>dd                                    { MS_LEXER_RETURN_TOKEN(MS_DD); }
+<INITIAL>ellipse                               { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_ELLIPSE); }
+<INITIAL>embed                                 { MS_LEXER_RETURN_TOKEN(MS_EMBED); }
+<INITIAL>false                                 { MS_LEXER_RETURN_TOKEN(MS_FALSE); }
+<INITIAL>feet                                  { MS_LEXER_RETURN_TOKEN(MS_FEET); }
+<INITIAL>follow                                { MS_LEXER_RETURN_TOKEN(MS_FOLLOW); }
+<INITIAL>giant                                 { MS_LEXER_RETURN_TOKEN(MS_GIANT); }
+<INITIAL>hatch                                 { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_HATCH); }
+<INITIAL>kerneldensity                         { MS_LEXER_RETURN_TOKEN(MS_KERNELDENSITY); }
+<INITIAL>idw                                   { MS_LEXER_RETURN_TOKEN(MS_IDW); }
+<INITIAL>hilite                                { MS_LEXER_RETURN_TOKEN(MS_HILITE); }
+<INITIAL>inches                                { MS_LEXER_RETURN_TOKEN(MS_INCHES); }
+<INITIAL>kilometers                            { MS_LEXER_RETURN_TOKEN(MS_KILOMETERS); }
+<INITIAL>large                                 { MS_LEXER_RETURN_TOKEN(MS_LARGE); }
+<INITIAL>lc                                    { MS_LEXER_RETURN_TOKEN(MS_LC); }
+<INITIAL>left                                  { MS_LEXER_RETURN_TOKEN(MS_ALIGN_LEFT); }
+<INITIAL>line                                  { MS_LEXER_RETURN_TOKEN(MS_LAYER_LINE); }
+<INITIAL>ll                                    { MS_LEXER_RETURN_TOKEN(MS_LL); }
+<INITIAL>lr                                    { MS_LEXER_RETURN_TOKEN(MS_LR); }
+<INITIAL>medium                                { MS_LEXER_RETURN_TOKEN(MS_MEDIUM); }
+<INITIAL>meters                                { MS_LEXER_RETURN_TOKEN(MS_METERS); }
+<INITIAL>nauticalmiles                         { MS_LEXER_RETURN_TOKEN(MS_NAUTICALMILES); }
+<INITIAL>miles                                 { MS_LEXER_RETURN_TOKEN(MS_MILES); }
+<INITIAL>miter                                 { MS_LEXER_RETURN_TOKEN(MS_CJC_MITER); }
+<INITIAL>multiple                              { MS_LEXER_RETURN_TOKEN(MS_MULTIPLE); }
+<INITIAL>none                                  { MS_LEXER_RETURN_TOKEN(MS_CJC_NONE); }
+<INITIAL>normal                                { MS_LEXER_RETURN_TOKEN(MS_NORMAL); }
+<INITIAL>off                                   { MS_LEXER_RETURN_TOKEN(MS_OFF); }
+<INITIAL>ogr                                   { MS_LEXER_RETURN_TOKEN(MS_OGR); }
+<INITIAL>flatgeobuf                            { MS_LEXER_RETURN_TOKEN(MS_FLATGEOBUF); }
+<INITIAL>on                                    { MS_LEXER_RETURN_TOKEN(MS_ON); }
+<INITIAL>one-to-one                            { MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_ONE); }
+<INITIAL>one-to-many                           { MS_LEXER_RETURN_TOKEN(MS_JOIN_ONE_TO_MANY); }
+<INITIAL>oraclespatial                         { MS_LEXER_RETURN_TOKEN(MS_ORACLESPATIAL); }
+<INITIAL>percentages                           { MS_LEXER_RETURN_TOKEN(MS_PERCENTAGES); }
+<INITIAL>pixmap                                { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_PIXMAP); }
+<INITIAL>pixels                                { MS_LEXER_RETURN_TOKEN(MS_PIXELS); }
+<INITIAL>point                                 { MS_LEXER_RETURN_TOKEN(MS_LAYER_POINT); }
+<INITIAL>polygon                               { MS_LEXER_RETURN_TOKEN(MS_LAYER_POLYGON); }
+<INITIAL>postgis                               { MS_LEXER_RETURN_TOKEN(MS_POSTGIS); }
+<INITIAL>plugin                                { MS_LEXER_RETURN_TOKEN(MS_PLUGIN); }
+<INITIAL>query                                 { MS_LEXER_RETURN_TOKEN(MS_LAYER_QUERY); }
+<INITIAL>raster                                { MS_LEXER_RETURN_TOKEN(MS_LAYER_RASTER); }
+<INITIAL>right                                 { MS_LEXER_RETURN_TOKEN(MS_ALIGN_RIGHT); }
+<INITIAL>round                                 { MS_LEXER_RETURN_TOKEN(MS_CJC_ROUND); }
+<INITIAL>selected                              { MS_LEXER_RETURN_TOKEN(MS_SELECTED); }
+<INITIAL>simple                                { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SIMPLE); }
+<INITIAL>single                                { MS_LEXER_RETURN_TOKEN(MS_SINGLE); }
+<INITIAL>small                                 { MS_LEXER_RETURN_TOKEN(MS_SMALL); }
+<INITIAL>square                                { MS_LEXER_RETURN_TOKEN(MS_CJC_SQUARE); }
+<INITIAL>svg                                   { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_SVG); }
+<INITIAL>polaroffset                           { MS_LEXER_RETURN_TOKEN(POLAROFFSET); }
+<INITIAL>tiny                                  { MS_LEXER_RETURN_TOKEN(MS_TINY); }
+<INITIAL>triangle                              { MS_LEXER_RETURN_TOKEN(MS_CJC_TRIANGLE); }
+<INITIAL>true                                  { MS_LEXER_RETURN_TOKEN(MS_TRUE); }
+<INITIAL>truetype                              { MS_LEXER_RETURN_TOKEN(MS_TRUETYPE); }
+<INITIAL>uc                                    { MS_LEXER_RETURN_TOKEN(MS_UC); }
+<INITIAL>ul                                    { MS_LEXER_RETURN_TOKEN(MS_UL); }
+<INITIAL>ur                                    { MS_LEXER_RETURN_TOKEN(MS_UR); }
+<INITIAL>union                                 { MS_LEXER_RETURN_TOKEN(MS_UNION); }
+<INITIAL>uvraster                              { MS_LEXER_RETURN_TOKEN(MS_UVRASTER); }
+<INITIAL>contour                               { MS_LEXER_RETURN_TOKEN(MS_CONTOUR); }
+<INITIAL>vector                                { MS_LEXER_RETURN_TOKEN(MS_SYMBOL_VECTOR); }
+<INITIAL>wfs                                   { MS_LEXER_RETURN_TOKEN(MS_WFS); }
+<INITIAL>wms                                   { MS_LEXER_RETURN_TOKEN(MS_WMS); }
+
+<INITIAL>\[[^\]]*\]                            {
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer,msyytext);
+                                                 return(MS_BINDING);
+                                               }
+
+<EXPRESSION_STRING>\[shape\] { 
+  /* attribute binding - shape (fixed value) */
+  return(MS_TOKEN_BINDING_SHAPE);
+}
+<EXPRESSION_STRING>\[map_cellsize\] { 
+  /* attribute binding - map cellsize */
+  return(MS_TOKEN_BINDING_MAP_CELLSIZE);
+}
+<EXPRESSION_STRING>\[data_cellsize\] { 
+  /* attribute binding - data cellsize */
+  return(MS_TOKEN_BINDING_DATA_CELLSIZE);
+}
+<EXPRESSION_STRING>\[[^\]]*\] {
+  /* attribute binding - numeric (no quotes) */
+  msyytext++;
+  msyytext[msyyleng-1-1] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_BINDING_DOUBLE);
+}
+<EXPRESSION_STRING>\"\[[^\"]*\]\"|\'\[[^\']*\]\' {
+  /* attribute binding - string (single or double quotes) */
+  msyytext+=2;
+  msyytext[msyyleng-2-2] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_BINDING_STRING);
+}
+<EXPRESSION_STRING>\`\[[^\`]*\]\` {
+  /* attribute binding - time */
+  msyytext+=2;
+  msyytext[msyyleng-2-2] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng,
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_BINDING_TIME);
+}
+
+<INITIAL>-?[0-9]+|-?[0-9]+\.[0-9]*|-?\.[0-9]*|-?[0-9]+[eE][+-]?[0-9]+|-?[0-9]+\.[0-9]*[eE][+-]?[0-9]+|-?\.[0-9]*[eE][+-]?[0-9]+ {
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer,msyytext);
+  msyynumber = atof(msyytext);
+  return(MS_NUMBER); 
+}
+
+<EXPRESSION_STRING>-?[0-9]+|-?[0-9]+\.[0-9]*|-?\.[0-9]*|-?[0-9]+[eE][+-]?[0-9]+|-?[0-9]+\.[0-9]*[eE][+-]?[0-9]+|-?\.[0-9]*[eE][+-]?[0-9]+ {
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer,msyytext);
+  msyynumber = atof(msyytext);
+  return(MS_TOKEN_LITERAL_NUMBER);
+}
+
+<EXPRESSION_STRING>\`[^\`]*\` {
+  msyytext++;
+  msyytext[msyyleng-1-1] = '\0';
+  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                          msyystring_buffer_size);
+  strcpy(msyystring_buffer, msyytext);
+  return(MS_TOKEN_LITERAL_TIME);
+}
+
+<INITIAL>\/[^*]{1}[^\/]*\/i         {
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-2] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_IREGEX);
+                                               }
+
+<INITIAL>\/[^*]{1}[^\/]*\/          {
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_REGEX);
+                                               }
+
+<INITIAL>\(.*\)                     {
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_EXPRESSION);
+                                               }
+
+<INITIAL>\{.*\}                     {
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                         msyystring_buffer_size);
+                                                 strcpy(msyystring_buffer, msyytext);
+                                                 return(MS_LIST);
+                                               }
+
+<INITIAL,CONFIG_FILE>\'|\"         {
+                                                 msyystring_return_state = MS_STRING;
+                                                 msyystring_begin = msyytext[0]; 
+                                                 msyystring_size = 0;
+                                                 msyystring_buffer[0] = '\0';
+                                                 BEGIN(MSSTRING);
+                                              }
+
+<MSSTRING>\'|\"|\"i|\'i                       {
+                                                if (msyystring_begin == msyytext[0]) {
+                                                   BEGIN(msyystring_begin_state);
+                                                   if (msyystring_return_state == MS_STRING) {
+                                                      if (msyystring_icase && msyyleng==2) {
+                                                         msyystring_icase = MS_FALSE; // reset
+                                                         return MS_ISTRING;
+                                                      } else
+                                                        return MS_STRING;
+                                                   }
+                                                   return msyystring_return_state;
+
+                                                }
+                                                else {
+                                                  int old_size = msyystring_size;
+                                                  msyystring_size += (msyyleng==2) ? 2 : 1;
+                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
+                                                                          msyystring_buffer_size);
+                                                  msyystring_buffer[old_size] = *msyytext;
+                                                  if (msyyleng==2) {
+                                                     msyystring_buffer[old_size+1] = msyytext[1];
+                                                  }
+                                                  msyystring_buffer[msyystring_size] = '\0';
+                                                }
+                                              }
+
+<MSSTRING>\\\'|\\\"|\\\\|\\                  { 
+                                                ++msyystring_size;
+                                                MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
+                                                                        msyystring_buffer_size);
+
+                                                if (msyyleng == 2)
+                                                    msyystring_buffer[msyystring_size-1] = msyytext[1]; 
+                                                else
+                                                    msyystring_buffer[msyystring_size-1] = msyytext[0];
+                                                msyystring_buffer[msyystring_size] = '\0';
+                                             }
+
+<MSSTRING>[^\\\'\\\"]+                       {
+                                                 int old_size = msyystring_size;
+                                                 msyystring_size += msyyleng;
+                                                 MS_LEXER_STRING_REALLOC(msyystring_buffer, msyystring_size,
+                                                                         msyystring_buffer_size);
+                                                 memcpy(msyystring_buffer + old_size, msyytext, msyyleng + 1);
+                                             }
+
+<INCLUDE>\"[^\"]*\"|\'[^\']*\'                 {
+                                                 msyytext++;
+                                                 msyytext[msyyleng-1-1] = '\0';
+
+                                                 if(include_stack_ptr >= MAX_INCLUDE_DEPTH) {
+                                                   msSetError(MS_IOERR, "Includes nested to deeply.", "msyylex()");
+                                                   return(-1);
+                                                 }
+
+                                                 msyyin = fopen(msBuildPath(path, msyybasepath, msyytext), "r");
+                                                 if(!msyyin) {
+                                                   msSetError(MS_IOERR, "Error opening included file \"%s\".", "msyylex()", msyytext);
+                                                   msyyin = YY_CURRENT_BUFFER->yy_input_file;
+                                                   return(-1);
+                                                 }
+
+                                                 include_stack[include_stack_ptr] = YY_CURRENT_BUFFER; /* save state */
+                                                 include_lineno[include_stack_ptr] = msyylineno;
+                                                 include_stack_ptr++;
+
+                                                 msyy_switch_to_buffer( msyy_create_buffer(msyyin, YY_BUF_SIZE) );
+                                                 msyylineno = 1;
+
+                                                 BEGIN(INITIAL);
+                                               }
+
+<EXPRESSION_STRING>\'|\"                      {
+                                                 msyystring_return_state = MS_TOKEN_LITERAL_STRING;
+                                                 msyystring_begin = msyytext[0]; 
+                                                 msyystring_size = 0;
+                                                 msyystring_buffer[0] = '\0';
+                                                 BEGIN(MSSTRING);
+                                              }
+
+<INITIAL,CONFIG_FILE>[a-z/\.][a-z0-9/\._\-\=]*   { 
+                                                    MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                            msyystring_buffer_size);
+                                                    strcpy(msyystring_buffer, msyytext); 
+                                                    return(MS_STRING); 
+                                                }
+
+<INITIAL,CONFIG_FILE>\n                        { msyylineno++; }
+
+<INITIAL,CONFIG_FILE><<EOF>>                    {
+                                                  if( --include_stack_ptr < 0 )
+                                                    return(EOF); /* end of main file */
+                                                  else {
+                                                    fclose(YY_CURRENT_BUFFER->yy_input_file);
+                                                    msyy_delete_buffer( YY_CURRENT_BUFFER );
+                                                    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
+                                                    msyylineno = include_lineno[include_stack_ptr];
+                                                  }
+                                                }
+
+<EXPRESSION_STRING>[\r|\n|\0] {
+  return(0); 
+}
+
+<INITIAL,CONFIG_FILE>.                          { 
+                                                  MS_LEXER_STRING_REALLOC(msyystring_buffer, msyyleng, 
+                                                                          msyystring_buffer_size);
+                                                  strcpy(msyystring_buffer, msyytext); 
+                                                  return(0); 
+                                                }
+<EXPRESSION_STRING>.                            { return(msyytext[0]); }
+%%
+
+/*
+** Any extra C functions
+*/
+
+int msyywrap() /* override */
+{
+  return(1);
+}
+
+int msyyerror(char *s) {
+  msSetError(MS_PARSEERR, "%s", "msyyparse()", s);
+  return(0);
+}
+
+/* cleanup any open includes */
+void msyycleanup_includes() {
+  while( --include_stack_ptr >= 0 ) {
+    fclose(YY_CURRENT_BUFFER->yy_input_file);
+    msyy_delete_buffer( YY_CURRENT_BUFFER );
+    msyy_switch_to_buffer(include_stack[include_stack_ptr]);
+  }
+}
diff -pruN 8.0.1-5/src/maplibxml2.c 8.2.0~beta1-1~exp1/src/maplibxml2.c
--- 8.0.1-5/src/maplibxml2.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maplibxml2.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,127 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  libxml2 convenience wrapper functions
+ * Author:   Tom Kralidis (tomkralidis@gmail.com)
+ *
+ ******************************************************************************
+ * Copyright (c) 2007, Tom Kralidis
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#ifdef USE_LIBXML2
+
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+#include <libxml/xpath.h>
+#include <libxml/xpathInternals.h>
+
+/**
+ * msLibXml2GenerateList()
+ *
+ * Convenience function to produce a series of XML elements from a delimited
+ * list
+ *
+ * @param xmlNodePtr psParent the encompassing node
+ * @param xmlNsPtr psNs the namespace object
+ * @param const char *elname the list member element name
+ * @param const char *values the list member element values
+ * @param char delim the delimiter
+ *
+ */
+
+void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs,
+                           const char *elname, const char *values, char delim) {
+  char **tokens = NULL;
+  int n = 0;
+  int i = 0;
+  tokens = msStringSplit(values, delim, &n);
+  for (i = 0; i < n; i++) {
+    // Not sure we really need to distinguish empty vs non-empty case, but
+    // this does change the result of
+    // msautotest/wxs/expected/wcs_empty_cap111.xml otherwise
+    if (tokens[i] && tokens[i][0] != '\0')
+      xmlNewTextChild(psParent, psNs, BAD_CAST elname, BAD_CAST tokens[i]);
+    else
+      xmlNewChild(psParent, psNs, BAD_CAST elname, BAD_CAST tokens[i]);
+  }
+  msFreeCharArray(tokens, n);
+}
+
+/**
+ * msLibXml2GetXPath()
+ *
+ * Convenience function to fetch an XPath
+ *
+ * @param xmlDocPtr doc the XML doc pointer
+ * @param xmlXPathContextPtr the context pointer
+ * @param xmlChar *xpath the xpath value
+ *
+ * @return result xmlXPathObjectPtr pointer
+ *
+ */
+
+xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context,
+                                    xmlChar *xpath) {
+  (void)doc;
+  xmlXPathObjectPtr result;
+  result = xmlXPathEval(xpath, context);
+  if (result == NULL) {
+    return NULL;
+  }
+  if (xmlXPathNodeSetIsEmpty(result->nodesetval)) {
+    xmlXPathFreeObject(result);
+    return NULL;
+  }
+  return result;
+}
+
+/**
+ * msLibXml2GetXPathTree
+ *
+ * Convenience function to fetch an XPath and children
+ *
+ * @param xmlDocPtr doc the XML doc pointer
+ * @param xmlXPathObjectPtr the xpath object
+ *
+ * @return result string
+ *
+ */
+
+char *msLibXml2GetXPathTree(xmlDocPtr doc, xmlXPathObjectPtr xpath) {
+  xmlBufferPtr xbuf;
+  char *result = NULL;
+
+  xbuf = xmlBufferCreate();
+
+  if (xpath) {
+    if (xmlNodeDump(xbuf, doc, xpath->nodesetval->nodeTab[0], 0, 0) == -1) {
+      return NULL;
+    }
+    result = msStrdup((char *)xbuf->content);
+  }
+  xmlBufferFree(xbuf);
+  return result;
+}
+
+#endif /* defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/src/maplibxml2.h 8.2.0~beta1-1~exp1/src/maplibxml2.h
--- 8.0.1-5/src/maplibxml2.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maplibxml2.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,60 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  libxml2 convenience wrapper functions include file
+ * Author:   Tom Kralidis (tomkralidis@gmail.com)
+ *
+ ******************************************************************************
+ * Copyright (c) 2007, Tom Kralidis
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPLIBXML2_H
+#define MAPLIBXML2_H
+
+#ifdef USE_LIBXML2
+
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+#include <libxml/xpath.h>
+#include <libxml/xpathInternals.h>
+#include <libxml/xmlschemas.h>
+#include <libxml/xmlschemastypes.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context,
+                                    xmlChar *xpath);
+
+void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs,
+                           const char *elname, const char *values, char delim);
+
+char *msLibXml2GetXPathTree(xmlDocPtr doc, xmlXPathObjectPtr xpath);
+
+#ifdef __cplusplus
+} /* extern C */
+#endif
+
+#endif /* defined(USE_LIBXML2) */
+
+#endif /* MAPLIBXML2_H */
diff -pruN 8.0.1-5/src/mapmetadata.c 8.2.0~beta1-1~exp1/src/mapmetadata.c
--- 8.0.1-5/src/mapmetadata.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapmetadata.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1001 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Metadata implementation
+ * Author:   Tom Kralidis (tomkralidis@gmail.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2017, Tom Kralidis
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+#include "mapowscommon.h"
+#include "maplibxml2.h"
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+
+#ifdef USE_LIBXML2
+
+static int msMetadataParseRequest(cgiRequestObj *request,
+                                  metadataParamsObj *metadataparams);
+
+/************************************************************************/
+/*                   _msMetadataGetCharacterString                      */
+/*                                                                      */
+/*      Create a gmd:name/gmd:CharacterString element pattern           */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetCharacterString(xmlNsPtr namespace,
+                                                const char *name,
+                                                const char *value,
+                                                xmlNsPtr *ppsNsGco) {
+
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST name);
+
+  if (!value)
+    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
+  else
+    xmlNewChild(psNode, *ppsNsGco, BAD_CAST "CharacterString", BAD_CAST value);
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetURL                                  */
+/*                                                                      */
+/*      Create a gmd:name/gmd:URL element pattern                       */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetURL(xmlNsPtr namespace, const char *name,
+                                    const char *value, xmlNsPtr *ppsNsGco) {
+
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST name);
+
+  if (!value)
+    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
+  else
+    xmlNewChild(psNode, namespace, BAD_CAST "URL", BAD_CAST value);
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetOnline                               */
+/*                                                                      */
+/*               Create a gmd:onLine element pattern                    */
+/************************************************************************/
+
+static char *_stringConcatenateAndEncodeHTML(char *str, const char *appendStr) {
+  char *pszTmp = msEncodeHTMLEntities(appendStr);
+  str = msStringConcatenate(str, pszTmp);
+  msFree(pszTmp);
+  return str;
+}
+
+static xmlNodePtr _msMetadataGetOnline(xmlNsPtr namespace, layerObj *layer,
+                                       const char *service, const char *format,
+                                       const char *desc, const char *url_in,
+                                       xmlNsPtr *ppsNsGco) {
+
+  int status;
+  const char *link_protocol = "unknown protocol";
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST "onLine");
+  xmlNodePtr psORNode =
+      xmlNewChild(psNode, namespace, BAD_CAST "CI_OnlineResource", NULL);
+
+  char *url = msStrdup(url_in);
+
+  if (strcasecmp(service, "M") == 0) {
+    url = _stringConcatenateAndEncodeHTML(
+        url, "service=WMS&version=1.3.0&request=GetMap&width=500&height=300&"
+             "styles=&layers=");
+    url = _stringConcatenateAndEncodeHTML(url, layer->name);
+    url = _stringConcatenateAndEncodeHTML(url, "&format=");
+    url = _stringConcatenateAndEncodeHTML(url, format);
+    url = _stringConcatenateAndEncodeHTML(url, "&crs=");
+    {
+      char *epsg_str = NULL;
+      msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO",
+                       MS_TRUE, &epsg_str);
+      url = _stringConcatenateAndEncodeHTML(url, epsg_str);
+      msFree(epsg_str);
+    }
+    link_protocol = "WWW:DOWNLOAD-1.0-http-get-map";
+
+    rectObj rect;
+    status = msLayerGetExtent(layer, &rect);
+
+    if (status == 0) {
+      char buffer[32];
+      url = _stringConcatenateAndEncodeHTML(url, "&bbox=");
+      sprintf(buffer, "%f", rect.miny);
+      url = msStringConcatenate(url, buffer);
+      url = msStringConcatenate(url, ",");
+      sprintf(buffer, "%f", rect.minx);
+      url = msStringConcatenate(url, buffer);
+      url = msStringConcatenate(url, ",");
+      sprintf(buffer, "%f", rect.maxy);
+      url = msStringConcatenate(url, buffer);
+      url = msStringConcatenate(url, ",");
+      sprintf(buffer, "%f", rect.maxx);
+      url = msStringConcatenate(url, buffer);
+    }
+  } else if (strcasecmp(service, "F") == 0) {
+    link_protocol = "WWW:DOWNLOAD-1.0-http--download";
+    url = _stringConcatenateAndEncodeHTML(
+        url, "service=WFS&version=1.1.0&request=GetFeature&typename=");
+    url = _stringConcatenateAndEncodeHTML(url, layer->name);
+    url = _stringConcatenateAndEncodeHTML(url, "&outputformat=");
+    url = _stringConcatenateAndEncodeHTML(url, format);
+  } else if (strcasecmp(service, "C") == 0) {
+    link_protocol = "WWW:DOWNLOAD-1.0-http--download";
+    url = _stringConcatenateAndEncodeHTML(
+        url, "service=WCS&version=2.0.1&request=GetCoverage&coverageid=");
+    url = _stringConcatenateAndEncodeHTML(url, layer->name);
+    url = _stringConcatenateAndEncodeHTML(url, "&format=");
+    url = _stringConcatenateAndEncodeHTML(url, format);
+  }
+
+  xmlAddChild(psORNode, _msMetadataGetURL(namespace, "linkage", url, ppsNsGco));
+  msFree(url);
+
+  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "protocol",
+                                                      link_protocol, ppsNsGco));
+  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "name",
+                                                      layer->name, ppsNsGco));
+
+  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "description",
+                                                      desc, ppsNsGco));
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetInteger                              */
+/*                                                                      */
+/*      Create a gmd:name/gmd:Integer element pattern                   */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetInteger(xmlNsPtr namespace, const char *name,
+                                        int value, xmlNsPtr *ppsNsGco) {
+  char buffer[8];
+  sprintf(buffer, "%d", value);
+
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST name);
+
+  if (!value)
+    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
+  else
+    xmlNewChild(psNode, *ppsNsGco, BAD_CAST "Integer", BAD_CAST buffer);
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetDecimal                              */
+/*                                                                      */
+/*      Create a gmd:name/gmd:Decimal element pattern                   */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetDecimal(xmlNsPtr namespace, const char *name,
+                                        double value, xmlNsPtr *ppsNsGco) {
+  char buffer[32];
+  snprintf(buffer, sizeof(buffer), "%.6f", value);
+
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST name);
+
+  if (!value)
+    xmlNewNsProp(psNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
+  else
+    xmlNewChild(psNode, *ppsNsGco, BAD_CAST "Decimal", BAD_CAST buffer);
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetCodeList                             */
+/*                                                                      */
+/*      Create a gmd:name/gmd:* code list element pattern               */
+/************************************************************************/
+
+xmlNodePtr _msMetadataGetCodeList(xmlNsPtr namespace,
+                                  const char *parent_element, const char *name,
+                                  const char *value) {
+  char *codelist = NULL;
+  codelist = msStrdup(
+      "http://www.isotc211.org/2005/resources/Codelist/gmxCodelists.xml#");
+  codelist = msStringConcatenate(codelist, name);
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST parent_element);
+  xmlNodePtr psCodeNode =
+      xmlNewChild(psNode, namespace, BAD_CAST name, BAD_CAST value);
+  xmlNewProp(psCodeNode, BAD_CAST "codeSpace", BAD_CAST "ISOTC211/19115");
+  xmlNewProp(psCodeNode, BAD_CAST "codeList", BAD_CAST codelist);
+  xmlNewProp(psCodeNode, BAD_CAST "codeListValue", BAD_CAST value);
+  msFree(codelist);
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetGMLTimePeriod                        */
+/*                                                                      */
+/*      Create a gml:TimePeriod element pattern                         */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetGMLTimePeriod(char **temporal) {
+  xmlNsPtr psNsGml =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
+  xmlNodePtr psNode = xmlNewNode(psNsGml, BAD_CAST "TimePeriod");
+  xmlNewNsProp(psNode, psNsGml, BAD_CAST "id", BAD_CAST "T001");
+  xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
+  xmlSetNs(psNode, psNsGml);
+  xmlNewChild(psNode, psNsGml, BAD_CAST "beginPosition", BAD_CAST temporal[0]);
+  xmlNewChild(psNode, psNsGml, BAD_CAST "endPosition", BAD_CAST temporal[1]);
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetExtent                               */
+/*                                                                      */
+/*            Create a gmd:extent element pattern                       */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetExtent(xmlNsPtr namespace, layerObj *layer,
+                                       xmlNsPtr *ppsNsGco) {
+  int n = 0;
+  int status;
+  char **temporal = NULL;
+
+  rectObj rect;
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST "extent");
+  xmlNodePtr psEXNode =
+      xmlNewChild(psNode, namespace, BAD_CAST "EX_Extent", NULL);
+
+  /* scan for geospatial extent */
+  status = msLayerGetExtent(layer, &rect);
+
+  if (status == 0) {
+    /* always project to lat long */
+    msOWSProjectToWGS84(&layer->projection, &rect);
+
+    xmlNodePtr psGNode =
+        xmlNewChild(psEXNode, namespace, BAD_CAST "geographicElement", NULL);
+    xmlNodePtr psGNode2 = xmlNewChild(
+        psGNode, namespace, BAD_CAST "EX_GeographicBoundingBox", NULL);
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "westBoundLongitude",
+                                                rect.minx, ppsNsGco));
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "eastBoundLongitude",
+                                                rect.maxx, ppsNsGco));
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "southBoundLatitude",
+                                                rect.miny, ppsNsGco));
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "northBoundLatitude",
+                                                rect.maxy, ppsNsGco));
+  }
+
+  /* scan for temporal extent */
+  const char *value =
+      msOWSLookupMetadata(&(layer->metadata), "MO", "timeextent");
+  if (value) { /* WMS */
+    temporal = msStringSplit(value, '/', &n);
+  } else { /* WCS */
+    value = msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition");
+    if (value) {
+      /* split extent */
+      temporal = msStringSplit(value, ',', &n);
+    }
+  }
+  if (!value) { /* SOS */
+    value =
+        msOWSLookupMetadata(&(layer->metadata), "SO", "offering_timeextent");
+    if (value)
+      temporal = msStringSplit(value, '/', &n);
+  }
+  if (value) {
+    if (temporal && n > 0) {
+      xmlNodePtr psTNode =
+          xmlNewChild(psEXNode, namespace, BAD_CAST "temporalElement", NULL);
+      xmlNodePtr psTNode2 =
+          xmlNewChild(psTNode, namespace, BAD_CAST "EX_TemporalExtent", NULL);
+      xmlNodePtr psENode =
+          xmlNewChild(psTNode2, namespace, BAD_CAST "extent", NULL);
+      xmlAddChild(psENode, _msMetadataGetGMLTimePeriod(temporal));
+    }
+  }
+  msFreeCharArray(temporal, n);
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetReferenceSystemInfo                  */
+/*                                                                      */
+/*      Create a gmd:referenceSystemInfo element pattern                */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetReferenceSystemInfo(xmlNsPtr namespace,
+                                                    layerObj *layer,
+                                                    xmlNsPtr *ppsNsGco) {
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST "referenceSystemInfo");
+  xmlNodePtr psRSNode =
+      xmlNewChild(psNode, namespace, BAD_CAST "MD_ReferenceSystem", NULL);
+  xmlNodePtr psRSINode = xmlNewChild(
+      psRSNode, namespace, BAD_CAST "referenceSystemIdentifier", NULL);
+  xmlNodePtr psRSINode2 =
+      xmlNewChild(psRSINode, namespace, BAD_CAST "RS_Identifier", NULL);
+
+  char *epsg_str = NULL;
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO", MS_TRUE,
+                   &epsg_str);
+  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "code",
+                                                        epsg_str, ppsNsGco));
+  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(
+                              namespace, "codeSpace",
+                              "http://www.epsg-registry.org", ppsNsGco));
+  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "version",
+                                                        "6.14", ppsNsGco));
+  msFree(epsg_str);
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetContact                              */
+/*                                                                      */
+/*      Create a gmd:contact element pattern                            */
+/************************************************************************/
+
+xmlNodePtr _msMetadataGetContact(xmlNsPtr namespace, char *contact_element,
+                                 mapObj *map, xmlNsPtr *ppsNsGco) {
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST contact_element);
+  xmlNodePtr psCNode =
+      xmlNewChild(psNode, namespace, BAD_CAST "CI_ResponsibleParty", NULL);
+  xmlNewProp(psCNode, BAD_CAST "id", BAD_CAST contact_element);
+
+  const char *value =
+      msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactperson");
+  if (value)
+    xmlAddChild(psCNode, _msMetadataGetCharacterString(
+                             namespace, "individualName", value, ppsNsGco));
+
+  value =
+      msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactorganization");
+  if (value)
+    xmlAddChild(psCNode, _msMetadataGetCharacterString(
+                             namespace, "organisationName", value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactposition");
+  if (value)
+    xmlAddChild(psCNode, _msMetadataGetCharacterString(
+                             namespace, "positionName", value, ppsNsGco));
+
+  xmlNodePtr psCINode =
+      xmlNewChild(psCNode, namespace, BAD_CAST "contactInfo", NULL);
+  xmlNodePtr psCINode2 =
+      xmlNewChild(psCINode, namespace, BAD_CAST "CI_Contact", NULL);
+  xmlNodePtr psPhoneNode =
+      xmlNewChild(psCINode2, namespace, BAD_CAST "phone", NULL);
+  xmlNodePtr psCIPhoneNode =
+      xmlNewChild(psPhoneNode, namespace, BAD_CAST "CI_Telephone", NULL);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                              "contactvoicetelephone");
+  if (value)
+    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(namespace, "voice",
+                                                             value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                              "contactfacsimiletelephone");
+  if (value)
+    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(
+                                   namespace, "facsimile", value, ppsNsGco));
+
+  xmlNodePtr psAddressNode =
+      xmlNewChild(psCINode2, namespace, BAD_CAST "address", NULL);
+  xmlNodePtr psCIAddressNode =
+      xmlNewChild(psAddressNode, namespace, BAD_CAST "CI_Address", NULL);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO", "address");
+  if (value)
+    xmlAddChild(psCIAddressNode,
+                _msMetadataGetCharacterString(namespace, "deliveryPoint", value,
+                                              ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO", "city");
+  if (value)
+    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(
+                                     namespace, "city", value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO", "stateorprovince");
+  if (value)
+    xmlAddChild(psCIAddressNode,
+                _msMetadataGetCharacterString(namespace, "administrativeArea",
+                                              value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO", "postcode");
+  if (value)
+    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(
+                                     namespace, "postalCode", value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO", "country");
+  if (value)
+    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(
+                                     namespace, "country", value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                              "contactelectronicmailaddress");
+  if (value)
+    xmlAddChild(psCIAddressNode,
+                _msMetadataGetCharacterString(
+                    namespace, "electronicMailAddress", value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "MCFO", "onlineresource");
+  if (value) {
+    xmlNodePtr psORNode =
+        xmlNewChild(psCINode2, namespace, BAD_CAST "onlineResource", NULL);
+    xmlNodePtr psORNode2 =
+        xmlNewChild(psORNode, namespace, BAD_CAST "CI_OnlineResource", NULL);
+    xmlAddChild(psORNode2,
+                _msMetadataGetURL(namespace, "linkage", value, ppsNsGco));
+  }
+
+  xmlAddChild(psCNode, _msMetadataGetCodeList(namespace, "role", "CI_RoleCode",
+                                              "pointOfContact"));
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetIdentificationInfo                   */
+/*                                                                      */
+/*      Create a gmd:identificationInfo element pattern                 */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetIdentificationInfo(xmlNsPtr namespace,
+                                                   mapObj *map, layerObj *layer,
+                                                   xmlNsPtr *ppsNsGco) {
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST "identificationInfo");
+
+  xmlNodePtr psDINode =
+      xmlNewChild(psNode, namespace, BAD_CAST "MD_DataIdentification", NULL);
+  xmlNewProp(psDINode, BAD_CAST "id", BAD_CAST layer->name);
+  xmlNodePtr psCNode =
+      xmlNewChild(psDINode, namespace, BAD_CAST "citation", NULL);
+  xmlNodePtr psCINode =
+      xmlNewChild(psCNode, namespace, BAD_CAST "CI_Citation", NULL);
+
+  const char *value = msOWSLookupMetadata(&(layer->metadata), "MCFGO", "title");
+  if (!value)
+    value = msOWSLookupMetadata(&(layer->metadata), "S", "offering_name");
+  xmlAddChild(psCINode, _msMetadataGetCharacterString(namespace, "title", value,
+                                                      ppsNsGco));
+
+  xmlNodePtr psDNode = xmlNewChild(psCINode, namespace, BAD_CAST "date", NULL);
+  xmlNewNsProp(psDNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
+
+  value = msOWSLookupMetadata(&(layer->metadata), "MCFGO", "attribution_title");
+  if (value) {
+    xmlAddChild(psCINode,
+                _msMetadataGetCharacterString(namespace, "otherCitationDetails",
+                                              value, ppsNsGco));
+  }
+
+  value = msOWSLookupMetadata(&(layer->metadata), "MCFGO", "abstract");
+  if (!value)
+    value =
+        msOWSLookupMetadata(&(layer->metadata), "S", "offering_description");
+  xmlAddChild(psDINode, _msMetadataGetCharacterString(namespace, "abstract",
+                                                      value, ppsNsGco));
+
+  value = msOWSLookupMetadata(&(layer->metadata), "MCFSGO", "keywordlist");
+
+  if (value) {
+    xmlNodePtr psKWNode =
+        xmlNewChild(psDINode, namespace, BAD_CAST "descriptiveKeywords", NULL);
+    xmlNodePtr psMDKNode =
+        xmlNewChild(psKWNode, namespace, BAD_CAST "MD_Keywords", NULL);
+
+    int n = 0;
+    char **tokens = msStringSplit(value, ',', &n);
+    if (tokens && n > 0) {
+      for (int i = 0; i < n; i++) {
+        xmlAddChild(psMDKNode, _msMetadataGetCharacterString(
+                                   namespace, "keyword", tokens[i], ppsNsGco));
+      }
+    }
+    msFreeCharArray(tokens, n);
+  }
+
+  xmlAddChild(psDINode,
+              _msMetadataGetCharacterString(
+                  namespace, "language",
+                  (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
+  xmlAddChild(psDINode, _msMetadataGetExtent(namespace, layer, ppsNsGco));
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetSpatialRepresentationInfo            */
+/*                                                                      */
+/*      Create a gmd:spatialRepresentationInfo element pattern          */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetSpatialRepresentationInfo(xmlNsPtr namespace,
+                                                          layerObj *layer,
+                                                          xmlNsPtr *ppsNsGco) {
+  xmlNodePtr psNode =
+      xmlNewNode(namespace, BAD_CAST "spatialRepresentationInfo");
+
+  if (layer->type == MS_LAYER_RASTER) {
+    xmlNodePtr psSRNode = xmlNewChild(
+        psNode, namespace, BAD_CAST "MD_GridSpatialRepresentation", NULL);
+    xmlAddChild(psSRNode, _msMetadataGetInteger(namespace, "numberOfDimensions",
+                                                2, ppsNsGco));
+    xmlAddChild(psSRNode,
+                _msMetadataGetCodeList(namespace, "cellGeometry",
+                                       "MD_CellGeometryCode", "area"));
+  } else {
+    xmlNodePtr psSRNode = xmlNewChild(
+        psNode, namespace, BAD_CAST "MD_VectorSpatialRepresentation", NULL);
+    xmlAddChild(psSRNode,
+                _msMetadataGetCodeList(namespace, "topologyLevel",
+                                       "MD_TopologyLevelCode", "geometryOnly"));
+    xmlNodePtr psGONode =
+        xmlNewChild(psSRNode, namespace, BAD_CAST "geometricObjects", NULL);
+    xmlNodePtr psGONode2 =
+        xmlNewChild(psGONode, namespace, BAD_CAST "MD_GeometricObjects", NULL);
+    const char *value;
+    if (layer->type == MS_LAYER_POINT)
+      value = "point";
+    else if (layer->type == MS_LAYER_LINE)
+      value = "curve";
+    else if (layer->type == MS_LAYER_POLYGON)
+      value = "surface";
+    else
+      value = "complex";
+    xmlAddChild(psGONode2,
+                _msMetadataGetCodeList(namespace, "geometricObjectType",
+                                       "MD_GeometricObjectTypeCode", value));
+    // TODO: find way to get feature count in a fast way
+    /* xmlAddChild(psGONode2, _msMetadataGetInteger(namespace,
+     * "geometricObjectCount", msLayerGetNumFeatures(layer))); */
+  }
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   _msMetadataGetDistributionInfo                     */
+/*                                                                      */
+/*      Create a gmd:identificationInfo element pattern                 */
+/************************************************************************/
+
+static xmlNodePtr _msMetadataGetDistributionInfo(xmlNsPtr namespace,
+                                                 mapObj *map, layerObj *layer,
+                                                 cgiRequestObj *cgi_request,
+                                                 xmlNsPtr *ppsNsGco) {
+  char *url = NULL;
+
+  xmlNodePtr psNode = xmlNewNode(namespace, BAD_CAST "distributionInfo");
+  xmlNodePtr psMDNode =
+      xmlNewChild(psNode, namespace, BAD_CAST "MD_Distribution", NULL);
+
+  {
+    char *pszTmp =
+        msOWSGetOnlineResource(map, "MFCSGO", "onlineresource", cgi_request);
+    url = msEncodeHTMLEntities(pszTmp);
+    msFree(pszTmp);
+  }
+
+  /* gmd:distributor */
+  xmlNodePtr psDNode =
+      xmlNewChild(psMDNode, namespace, BAD_CAST "distributor", NULL);
+  xmlNodePtr psDNode2 =
+      xmlNewChild(psDNode, namespace, BAD_CAST "MD_Distributor", NULL);
+  xmlAddChild(psDNode2, _msMetadataGetContact(namespace, "distributorContact",
+                                              map, ppsNsGco));
+
+  /* gmd:transferOptions */
+  xmlNodePtr psTONode =
+      xmlNewChild(psMDNode, namespace, BAD_CAST "transferOptions", NULL);
+  xmlNodePtr psDTONode = xmlNewChild(
+      psTONode, namespace, BAD_CAST "MD_DigitalTransferOptions", NULL);
+  xmlAddChild(psDTONode, _msMetadataGetCharacterString(
+                             namespace, "unitsOfDistribution", "KB", ppsNsGco));
+
+  /* links */
+
+  /* WMS */
+  xmlAddChild(psDTONode,
+              _msMetadataGetOnline(namespace, layer, "M", "image/png",
+                                   "PNG Format", url, ppsNsGco));
+  xmlAddChild(psDTONode,
+              _msMetadataGetOnline(namespace, layer, "M", "image/jpeg",
+                                   "JPEG Format", url, ppsNsGco));
+
+  /* WCS */
+  if (layer->type == MS_LAYER_RASTER) {
+    xmlAddChild(psDTONode,
+                _msMetadataGetOnline(namespace, layer, "C", "image/tiff",
+                                     "GeoTIFF Format", url, ppsNsGco));
+  }
+  /* WFS */
+  else {
+    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML2",
+                                                "GML2 Format", url, ppsNsGco));
+    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML3",
+                                                "GML3 Format", url, ppsNsGco));
+  }
+
+  msFree(url);
+
+  return psNode;
+}
+
+/************************************************************************/
+/*                   msMetadataGetExceptionReport                       */
+/*                                                                      */
+/*              Generate an OWS Common Exception Report                 */
+/************************************************************************/
+
+static xmlNodePtr msMetadataGetExceptionReport(mapObj *map, char *code,
+                                               char *locator, char *message,
+                                               xmlNsPtr *ppsNsOws) {
+  char *schemas_location = NULL;
+
+  xmlNodePtr psRootNode = NULL;
+
+  schemas_location = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  *ppsNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+
+  psRootNode = msOWSCommonExceptionReport(
+      *ppsNsOws, OWS_1_1_0, schemas_location, "1.1.0",
+      msOWSGetLanguage(map, "exception"), code, locator, message);
+  msFree(schemas_location);
+
+  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+           BAD_CAST "ows");
+
+  return psRootNode;
+}
+
+/************************************************************************/
+/*                   msMetadataGetLayerMetadata                         */
+/*                                                                      */
+/*      Generate an ISO 19139-1:2019 representation of layer metadata   */
+/************************************************************************/
+
+static xmlNodePtr
+msMetadataGetLayerMetadata(mapObj *map, metadataParamsObj *paramsObj,
+                           cgiRequestObj *cgi_request, xmlNsPtr *ppsNsOws,
+                           xmlNsPtr *ppsNsXsi, xmlNsPtr *ppsNsGmd,
+                           xmlNsPtr *ppsNsGco) {
+  int i;
+  int layer_found = MS_FALSE;
+
+  xmlNodePtr psRootNode = NULL;
+
+  layerObj *layer = NULL;
+
+  /* Check that layer requested exists in mapfile */
+  for (i = 0; i < map->numlayers; i++) {
+    if (strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
+      layer_found = MS_TRUE;
+      layer = GET_LAYER(map, i);
+      // when checking a layer with clustering msLayerGetExtent does not have
+      // access to the source layer, so remove clustering first
+      if (layer->cluster.region) {
+        layer->cluster.region = NULL;
+      }
+      break;
+    }
+  }
+
+  if (layer_found == MS_FALSE) {
+    psRootNode = msMetadataGetExceptionReport(
+        map, "InvalidParameterValue", "layer", "Layer not found", ppsNsOws);
+  }
+
+  /* Check that outputschema is valid */
+  else if (paramsObj->pszOutputSchema &&
+           strcasecmp(paramsObj->pszOutputSchema,
+                      "http://www.isotc211.org/2005/gmd") != 0) {
+    psRootNode = msMetadataGetExceptionReport(
+        map, "InvalidParameterValue", "outputschema",
+        "OUTPUTSCHEMA must be \"http://www.isotc211.org/2005/gmd\"", ppsNsOws);
+  }
+
+  else {
+    *ppsNsXsi =
+        xmlNewNs(NULL, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",
+                 BAD_CAST "xsi");
+    *ppsNsGmd = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gmd");
+    /* root element */
+    psRootNode = xmlNewNode(NULL, BAD_CAST "MD_Metadata");
+    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gmd",
+             BAD_CAST "gmd");
+    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gco",
+             BAD_CAST "gco");
+    xmlNewNs(psRootNode, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",
+             BAD_CAST "xsi");
+    xmlSetNs(psRootNode, *ppsNsGmd);
+
+    xmlNewNsProp(psRootNode, *ppsNsXsi, BAD_CAST "schemaLocation",
+                 BAD_CAST "http://www.isotc211.org/2005/gmd "
+                          "http://www.isotc211.org/2005/gmd/gmd.xsd");
+
+    /* gmd:identifier */
+    xmlAddChild(psRootNode,
+                _msMetadataGetCharacterString(*ppsNsGmd, "fileIdentifier",
+                                              layer->name, ppsNsGco));
+
+    /* gmd:language */
+    xmlAddChild(psRootNode,
+                _msMetadataGetCharacterString(
+                    *ppsNsGmd, "language",
+                    (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
+
+    /* gmd:hierarchyLevel */
+    xmlAddChild(psRootNode, _msMetadataGetCodeList(*ppsNsGmd, "hierarchyLevel",
+                                                   "MD_ScopeCode", "dataset"));
+
+    /* gmd:contact */
+    xmlAddChild(psRootNode,
+                _msMetadataGetContact(*ppsNsGmd, "contact", map, ppsNsGco));
+
+    /* gmd:dateStamp */
+    /* TODO: nil for now, find way to derive this automagically */
+    xmlAddChild(psRootNode, _msMetadataGetCharacterString(
+                                *ppsNsGmd, "dateStamp", NULL, ppsNsGco));
+
+    /* gmd:metadataStandardName */
+    xmlAddChild(psRootNode,
+                _msMetadataGetCharacterString(
+                    *ppsNsGmd, "metadataStandardName",
+                    "ISO 19115:2003 - Geographic information - Metadata",
+                    ppsNsGco));
+
+    /* gmd:metadataStandardVersion */
+    xmlAddChild(psRootNode, _msMetadataGetCharacterString(
+                                *ppsNsGmd, "metadataStandardVersion",
+                                "ISO 19115:2003", ppsNsGco));
+
+    /* gmd:spatialRepresentationInfo */
+    xmlAddChild(psRootNode, _msMetadataGetSpatialRepresentationInfo(
+                                *ppsNsGmd, layer, ppsNsGco));
+
+    /* gmd:referenceSystemInfo */
+    xmlAddChild(psRootNode,
+                _msMetadataGetReferenceSystemInfo(*ppsNsGmd, layer, ppsNsGco));
+
+    /* gmd:identificationInfo */
+    xmlAddChild(psRootNode, _msMetadataGetIdentificationInfo(*ppsNsGmd, map,
+                                                             layer, ppsNsGco));
+
+    /* gmd:distributionInfo */
+    xmlAddChild(psRootNode, _msMetadataGetDistributionInfo(
+                                *ppsNsGmd, map, layer, cgi_request, ppsNsGco));
+  }
+
+  return psRootNode;
+}
+
+/************************************************************************/
+/*                  msMetadataDispatch                                  */
+/*                                                                      */
+/* Entry point for metadata requests.                                   */
+/*                                                                      */
+/* - If this is a valid request then it is processed and MS_SUCCESS     */
+/*   is returned on success, or MS_FAILURE on failure.                  */
+/*                                                                      */
+/* - If this does not appear to be a valid WFS request then MS_DONE     */
+/*   is returned and MapServer is expected to process this as a regular */
+/*   MapServer request.                                                 */
+/************************************************************************/
+
+int msMetadataDispatch(mapObj *map, cgiRequestObj *cgi_request) {
+  int i;
+  int status = MS_SUCCESS;
+  xmlNodePtr psRootNode = NULL;
+  xmlDocPtr xml_document;
+  metadataParamsObj *paramsObj;
+  layerObj *layer = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlNsPtr psNsXsi = NULL;
+  xmlNsPtr psNsGmd = NULL;
+  xmlNsPtr psNsGco = NULL;
+
+  /* Populate the Params object based on the request */
+
+  paramsObj = msMetadataCreateParamsObj();
+
+  xml_document = xmlNewDoc(BAD_CAST "1.0");
+
+  if (msMetadataParseRequest(cgi_request, paramsObj) == MS_FAILURE) {
+    psRootNode = msMetadataGetExceptionReport(
+        map, "InvalidRequest", "layer", "Request parsing failed", &psNsOws);
+    status = MS_FAILURE;
+  }
+
+  /* if layer= is not specified, */
+  if (paramsObj->pszLayer == NULL || strlen(paramsObj->pszLayer) == 0) {
+    psRootNode =
+        msMetadataGetExceptionReport(map, "MissingParameterValue", "layer",
+                                     "Missing layer parameter", &psNsOws);
+    status = MS_FAILURE;
+  }
+
+  if (status == MS_SUCCESS) { /* Start dispatching request */
+    /* Check that layer requested exists in mapfile */
+    for (i = 0; i < map->numlayers; i++) {
+      if (strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
+        layer = GET_LAYER(map, i);
+        break;
+      }
+    }
+    if (layer != NULL &&
+        msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href")) {
+      msIO_setHeader("Status", "301 Moved Permanently");
+      msIO_setHeader(
+          "Location", "%s",
+          msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href"));
+      msIO_sendHeaders();
+    } else {
+      psRootNode = msMetadataGetLayerMetadata(
+          map, paramsObj, cgi_request, &psNsOws, &psNsXsi, &psNsGmd, &psNsGco);
+    }
+  }
+
+  if (psRootNode != NULL) {
+    xmlChar *xml_buffer = NULL;
+    int buffersize = 0;
+    xmlDocSetRootElement(xml_document, psRootNode);
+
+    msIO_setHeader("Content-type", "text/xml; charset=UTF-8");
+    msIO_sendHeaders();
+
+    msIOContext *context = NULL;
+
+    context = msIO_getHandler(stdout);
+
+    xmlDocDumpFormatMemoryEnc(xml_document, &xml_buffer, &buffersize, "UTF-8",
+                              1);
+    msIO_contextWrite(context, xml_buffer, buffersize);
+
+    xmlFree(xml_buffer);
+  }
+  xmlFreeDoc(xml_document);
+  if (psNsOws)
+    xmlFreeNs(psNsOws);
+  if (psNsXsi)
+    xmlFreeNs(psNsXsi);
+  if (psNsGmd)
+    xmlFreeNs(psNsGmd);
+  if (psNsGco)
+    xmlFreeNs(psNsGco);
+
+  msMetadataFreeParamsObj(paramsObj);
+
+  return status;
+}
+
+#endif /* USE_LIBXML2 */
+
+/************************************************************************/
+/*                           msMetadataCreateParamsObj                  */
+/*                                                                      */
+/*   Create a parameter object, initialize it.                          */
+/*   The caller should free the object using msMetadataFreeParamsObj.   */
+/************************************************************************/
+
+metadataParamsObj *msMetadataCreateParamsObj() {
+  metadataParamsObj *paramsObj =
+      (metadataParamsObj *)calloc(1, sizeof(metadataParamsObj));
+  MS_CHECK_ALLOC(paramsObj, sizeof(metadataParamsObj), NULL);
+
+  paramsObj->pszLayer = NULL;
+  paramsObj->pszOutputSchema = NULL;
+  return paramsObj;
+}
+
+/************************************************************************/
+/*                            msMetadataFreeParmsObj                    */
+/*                                                                      */
+/*      Free params object.                                             */
+/************************************************************************/
+
+void msMetadataFreeParamsObj(metadataParamsObj *metadataparams) {
+  if (metadataparams) {
+    free(metadataparams->pszRequest);
+    free(metadataparams->pszLayer);
+    free(metadataparams->pszOutputSchema);
+    free(metadataparams);
+  }
+}
+
+/************************************************************************/
+/*                            msMetadataParseRequest                    */
+/*                                                                      */
+/*      Parse request into the params object.                           */
+/************************************************************************/
+
+static int msMetadataParseRequest(cgiRequestObj *request,
+                                  metadataParamsObj *metadataparams) {
+  if (!request || !metadataparams)
+    return MS_FAILURE;
+
+  if (request->NumParams > 0) {
+    for (int i = 0; i < request->NumParams; i++) {
+      if (request->ParamNames[i] && request->ParamValues[i]) {
+        if (strcasecmp(request->ParamNames[i], "LAYER") == 0)
+          metadataparams->pszLayer = msStrdup(request->ParamValues[i]);
+        if (strcasecmp(request->ParamNames[i], "OUTPUTSCHEMA") == 0)
+          metadataparams->pszOutputSchema = msStrdup(request->ParamValues[i]);
+      }
+    }
+  }
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                            msMetadataSetGetMetadataURL               */
+/*                                                                      */
+/*      Parse request into the params object.                           */
+/************************************************************************/
+
+void msMetadataSetGetMetadataURL(layerObj *lp, const char *url) {
+  char *pszMetadataURL = NULL;
+
+  pszMetadataURL = msStrdup(url);
+  msDecodeHTMLEntities(pszMetadataURL);
+  pszMetadataURL =
+      msStringConcatenate(pszMetadataURL, "request=GetMetadata&layer=");
+  pszMetadataURL = msStringConcatenate(pszMetadataURL, lp->name);
+
+  msInsertHashTable(&(lp->metadata), "ows_metadataurl_href", pszMetadataURL);
+  msInsertHashTable(&(lp->metadata), "ows_metadataurl_type", "TC211");
+  msInsertHashTable(&(lp->metadata), "ows_metadataurl_format", "text/xml");
+  msInsertHashTable(&(lp->metadata), "ows_metadatalink_href", pszMetadataURL);
+  msInsertHashTable(&(lp->metadata), "ows_metadatalink_type", "TC211");
+  msInsertHashTable(&(lp->metadata), "ows_metadatalink_format", "text/xml");
+  msFree(pszMetadataURL);
+}
+
+#endif
diff -pruN 8.0.1-5/src/mapmssql2008.c 8.2.0~beta1-1~exp1/src/mapmssql2008.c
--- 8.0.1-5/src/mapmssql2008.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapmssql2008.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4142 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  MS SQL Server Layer Connector
+ * Author:   Richard Hillman - based on PostGIS and SpatialDB connectors
+ *           Tamas Szekeres - maintenance
+ *
+ ******************************************************************************
+ * Copyright (c) 2007 IS Consulting (www.mapdotnet.com)
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ******************************************************************************
+ *
+ * Revision 1.0  2007/7/1
+ * Created.
+ *
+ */
+#ifndef _WIN32
+#define _GNU_SOURCE
+#endif
+
+#define _CRT_SECURE_NO_WARNINGS 1
+
+/* $Id$ */
+#include <assert.h>
+#include "mapserver.h"
+#include "maptime.h"
+#include "mapows.h"
+
+#ifdef USE_MSSQL2008
+
+#ifdef _WIN32
+#include <windows.h>
+#endif
+#include <sql.h>
+#include <sqlext.h>
+#include <sqltypes.h>
+
+#include <string.h>
+#include <ctype.h> /* tolower() */
+
+/*   SqlGeometry/SqlGeography serialization format
+
+Simple Point (SerializationProps & IsSinglePoint)
+  [SRID][0x01][SerializationProps][Point][z][m]
+
+Simple Line Segment (SerializationProps & IsSingleLineSegment)
+  [SRID][0x01][SerializationProps][Point1][Point2][z1][z2][m1][m2]
+
+Complex Geometries
+  [SRID][VersionAttribute][SerializationProps][NumPoints][Point1]..[PointN][z1]..[zN][m1]..[mN]
+  [NumFigures][Figure]..[Figure][NumShapes][Shape]..[Shape]
+
+Complex Geometries (FigureAttribute == Curve)
+  [SRID][VersionAttribute][SerializationProps][NumPoints][Point1]..[PointN][z1]..[zN][m1]..[mN]
+  [NumFigures][Figure]..[Figure][NumShapes][Shape]..[Shape][NumSegments][SegmentType]..[SegmentType]
+
+VersionAttribute (1 byte)
+  0x01 = Katmai (MSSQL2008+)
+  0x02 = Denali (MSSQL2012+)
+
+SRID
+  Spatial Reference Id (4 bytes)
+
+SerializationProps (bitmask) 1 byte
+  0x01 = HasZValues
+  0x02 = HasMValues
+  0x04 = IsValid
+  0x08 = IsSinglePoint
+  0x10 = IsSingleLineSegment
+  0x20 = IsLargerThanAHemisphere
+
+Point (2-4)x8 bytes, size depends on SerializationProps & HasZValues &
+HasMValues [x][y]                  - SqlGeometry [latitude][longitude]   -
+SqlGeography
+
+Figure
+  [FigureAttribute][PointOffset]
+
+FigureAttribute - Katmai (1 byte)
+  0x00 = Interior Ring
+  0x01 = Stroke
+  0x02 = Exterior Ring
+
+FigureAttribute - Denali (1 byte)
+  0x00 = None
+  0x01 = Line
+  0x02 = Arc
+  0x03 = Curve
+
+Shape
+  [ParentFigureOffset][FigureOffset][ShapeType]
+
+ShapeType (1 byte)
+  0x00 = Unknown
+  0x01 = Point
+  0x02 = LineString
+  0x03 = Polygon
+  0x04 = MultiPoint
+  0x05 = MultiLineString
+  0x06 = MultiPolygon
+  0x07 = GeometryCollection
+  -- Denali
+  0x08 = CircularString
+  0x09 = CompoundCurve
+  0x0A = CurvePolygon
+  0x0B = FullGlobe
+
+SegmentType (1 byte)
+  0x00 = Line
+  0x01 = Arc
+  0x02 = FirstLine
+  0x03 = FirstArc
+
+*/
+
+/* Native geometry parser macros */
+
+/* parser error codes */
+#define NOERROR 0
+#define NOT_ENOUGH_DATA 1
+#define CORRUPT_DATA 2
+#define UNSUPPORTED_GEOMETRY_TYPE 3
+
+/* geometry format to transfer geometry column */
+#define MSSQLGEOMETRY_NATIVE 0
+#define MSSQLGEOMETRY_WKB 1
+#define MSSQLGEOMETRY_WKT 2
+
+/* geometry column types */
+#define MSSQLCOLTYPE_GEOMETRY 0
+#define MSSQLCOLTYPE_GEOGRAPHY 1
+#define MSSQLCOLTYPE_BINARY 2
+#define MSSQLCOLTYPE_TEXT 3
+
+#define SP_NONE 0
+#define SP_HASZVALUES 1
+#define SP_HASMVALUES 2
+#define SP_ISVALID 4
+#define SP_ISSINGLEPOINT 8
+#define SP_ISSINGLELINESEGMENT 0x10
+#define SP_ISLARGERTHANAHEMISPHERE 0x20
+
+#define ST_UNKNOWN 0
+#define ST_POINT 1
+#define ST_LINESTRING 2
+#define ST_POLYGON 3
+#define ST_MULTIPOINT 4
+#define ST_MULTILINESTRING 5
+#define ST_MULTIPOLYGON 6
+#define ST_GEOMETRYCOLLECTION 7
+#define ST_CIRCULARSTRING 8
+#define ST_COMPOUNDCURVE 9
+#define ST_CURVEPOLYGON 10
+#define ST_FULLGLOBE 11
+
+#define SMT_LINE 0
+#define SMT_ARC 1
+#define SMT_FIRSTLINE 2
+#define SMT_FIRSTARC 3
+
+#define ReadInt32(nPos) (*((unsigned int *)(gpi->pszData + (nPos))))
+
+#define ReadByte(nPos) (gpi->pszData[nPos])
+
+#define ReadDouble(nPos) (*((double *)(gpi->pszData + (nPos))))
+
+#define ParentOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape)*9))
+#define FigureOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape)*9 + 4))
+#define ShapeType(iShape) (ReadByte(gpi->nShapePos + (iShape)*9 + 8))
+#define SegmentType(iSegment) (ReadByte(gpi->nSegmentPos + (iSegment)))
+
+#define NextFigureOffset(iShape)                                               \
+  (iShape + 1 < gpi->nNumShapes ? FigureOffset((iShape) + 1) : gpi->nNumFigures)
+
+#define FigureAttribute(iFigure) (ReadByte(gpi->nFigurePos + (iFigure)*5))
+#define PointOffset(iFigure) (ReadInt32(gpi->nFigurePos + (iFigure)*5 + 1))
+#define NextPointOffset(iFigure)                                               \
+  (iFigure + 1 < gpi->nNumFigures ? PointOffset((iFigure) + 1)                 \
+                                  : (unsigned)gpi->nNumPoints)
+
+#define ReadX(iPoint) (ReadDouble(gpi->nPointPos + 16 * (iPoint)))
+#define ReadY(iPoint) (ReadDouble(gpi->nPointPos + 16 * (iPoint) + 8))
+#define ReadZ(iPoint)                                                          \
+  (ReadDouble(gpi->nPointPos + 16 * gpi->nNumPoints + 8 * (iPoint)))
+#define ReadM(iPoint)                                                          \
+  (ReadDouble(gpi->nPointPos + 24 * gpi->nNumPoints + 8 * (iPoint)))
+
+#define FP_EPSILON 1e-12
+#define SEGMENT_ANGLE 5.0
+#define SEGMENT_MINPOINTS 10
+
+/* Native geometry parser struct */
+typedef struct msGeometryParserInfo_t {
+  unsigned char *pszData;
+  int nLen;
+  /* version */
+  char chVersion;
+  /* serialization properties */
+  char chProps;
+  /* point array */
+  int nPointSize;
+  int nPointPos;
+  int nNumPoints;
+  int nNumPointsRead;
+  /* figure array */
+  int nFigurePos;
+  int nNumFigures;
+  /* shape array */
+  int nShapePos;
+  int nNumShapes;
+  int nSRSId;
+  /* segment array */
+  int nSegmentPos;
+  int nNumSegments;
+  /* geometry or geography */
+  int nColType;
+  /* bounds */
+  double minx;
+  double miny;
+  double maxx;
+  double maxy;
+} msGeometryParserInfo;
+
+/* Structure for connection to an ODBC database (Microsoft preferred way to
+ * connect to SQL Server 2005 from c/c++) */
+typedef struct msODBCconn_t {
+  SQLHENV henv;            /* ODBC HENV */
+  SQLHDBC hdbc;            /* ODBC HDBC */
+  SQLHSTMT hstmt;          /* ODBC HSTMNT */
+  char errorMessage[1024]; /* Last error message if any */
+} msODBCconn;
+
+typedef struct ms_MSSQL2008_layer_info_t {
+  char *sql;         /* sql query to send to DB */
+  long row_num;      /* what row is the NEXT to be read (for random access) */
+  char *geom_column; /* name of the actual geometry column parsed from the
+                        LAYER's DATA field */
+  char *geom_column_type; /* the type of the geometry column */
+  char *geom_table; /* the table name or sub-select decalred in the LAYER's DATA
+                       field */
+  char *urid_name;  /* name of user-specified unique identifier or OID */
+  char *
+      user_srid; /* zero length = calculate, non-zero means using this value! */
+  char *index_name; /* hopefully this isn't necessary - but if the optimizer
+                       ain't cuttin' it... */
+  char *sort_spec;  /* the sort by specification which should be applied to the
+                       generated select statement */
+  int mssqlversion_major; /* the sql server major version number */
+  int paging; /* Driver handling of pagination, enabled by default */
+  SQLSMALLINT
+  *itemtypes; /* storing the sql field types for further reference */
+
+  msODBCconn *conn;         /* Connection to db */
+  msGeometryParserInfo gpi; /* struct for the geometry parser */
+  int geometry_format; /* Geometry format to be retrieved from the database */
+  tokenListNodeObjPtr current_node; /* filter expression translation */
+} msMSSQL2008LayerInfo;
+
+#define SQL_COLUMN_NAME_MAX_LENGTH 128
+#define SQL_TABLE_NAME_MAX_LENGTH 128
+
+#define DATA_ERROR_MESSAGE                                                     \
+  "%s"                                                                         \
+  "Error with MSSQL2008 data variable. You specified '%s'.<br>\n"              \
+  "Standard ways of specifiying are : <br>\n(1) 'geometry_column from "        \
+  "geometry_table' <br>\n(2) 'geometry_column from (&lt;sub query&gt;) as "    \
+  "foo using unique &lt;column name&gt; using SRID=&lt;srid#&gt;' "            \
+  "<br><br>\n\n"                                                               \
+  "Make sure you utilize the 'using unique  &lt;column name&gt;' and 'using "  \
+  "with &lt;index name&gt;' clauses in.\n\n<br><br>"                           \
+  "For more help, please see http://www.mapdotnet.com \n\n<br><br>"            \
+  "mapmssql2008.c - version of 2007/7/1.\n"
+
+/* Native geometry parser code */
+void ReadPoint(msGeometryParserInfo *gpi, pointObj *p, int iPoint) {
+  if (gpi->nColType == MSSQLCOLTYPE_GEOGRAPHY) {
+    p->x = ReadY(iPoint);
+    p->y = ReadX(iPoint);
+  } else {
+    p->x = ReadX(iPoint);
+    p->y = ReadY(iPoint);
+  }
+  /* calculate bounds */
+  if (gpi->nNumPointsRead++ == 0) {
+    gpi->minx = gpi->maxx = p->x;
+    gpi->miny = gpi->maxy = p->y;
+  } else {
+    if (gpi->minx > p->x)
+      gpi->minx = p->x;
+    else if (gpi->maxx < p->x)
+      gpi->maxx = p->x;
+    if (gpi->miny > p->y)
+      gpi->miny = p->y;
+    else if (gpi->maxy < p->y)
+      gpi->maxy = p->y;
+  }
+
+  if ((gpi->chProps & SP_HASZVALUES) && (gpi->chProps & SP_HASMVALUES)) {
+    p->z = ReadZ(iPoint);
+    p->m = ReadM(iPoint);
+  } else if (gpi->chProps & SP_HASZVALUES) {
+    p->z = ReadZ(iPoint);
+    p->m = 0.0;
+  } else if (gpi->chProps & SP_HASMVALUES) {
+    p->z = 0.0;
+    p->m = ReadZ(iPoint);
+  } else {
+    p->z = 0.0;
+    p->m = 0.0;
+  }
+}
+
+int StrokeArcToLine(msGeometryParserInfo *gpi, lineObj *line, int index) {
+  if (index > 1) {
+    double x, y, x1, y1, x2, y2, x3, y3, dxa, dya, sxa, sya, dxb, dyb;
+    double d, sxb, syb, ox, oy, a1, a3, sa, da, a, radius;
+    int numpoints;
+    double z;
+    z = line->point[index].z; /* must be equal for arc segments */
+    /* first point */
+    x1 = line->point[index - 2].x;
+    y1 = line->point[index - 2].y;
+    /* second point */
+    x2 = line->point[index - 1].x;
+    y2 = line->point[index - 1].y;
+    /* third point */
+    x3 = line->point[index].x;
+    y3 = line->point[index].y;
+
+    sxa = (x1 + x2);
+    sya = (y1 + y2);
+    dxa = x2 - x1;
+    dya = y2 - y1;
+
+    sxb = (x2 + x3);
+    syb = (y2 + y3);
+    dxb = x3 - x2;
+    dyb = y3 - y2;
+
+    d = (dxa * dyb - dya * dxb) * 2;
+
+    if (fabs(d) < FP_EPSILON) {
+      /* points are colinear, nothing to do here */
+      return index;
+    }
+
+    /* calculating the center of circle */
+    ox = ((sya - syb) * dya * dyb + sxa * dyb * dxa - sxb * dya * dxb) / d;
+    oy = ((sxb - sxa) * dxa * dxb + syb * dyb * dxa - sya * dya * dxb) / d;
+
+    radius = sqrt((x1 - ox) * (x1 - ox) + (y1 - oy) * (y1 - oy));
+
+    /* calculating the angle to be used */
+    a1 = atan2(y1 - oy, x1 - ox);
+    a3 = atan2(y3 - oy, x3 - ox);
+
+    if (d > 0) {
+      /* draw counterclockwise */
+      if (a3 > a1) /* Wrapping past 180? */
+        sa = a3 - a1;
+      else
+        sa = a3 - a1 + 2.0 * M_PI;
+    } else {
+      if (a3 > a1) /* Wrapping past 180? */
+        sa = a3 - a1 + 2.0 * M_PI;
+      else
+        sa = a3 - a1;
+    }
+
+    numpoints = (int)floor(fabs(sa) * 180 / SEGMENT_ANGLE / M_PI);
+    if (numpoints < SEGMENT_MINPOINTS)
+      numpoints = SEGMENT_MINPOINTS;
+
+    da = sa / numpoints;
+
+    /* extend the point array */
+    line->numpoints += numpoints - 2;
+    line->point =
+        msSmallRealloc(line->point, sizeof(pointObj) * line->numpoints);
+    --index;
+
+    a = a1 + da;
+    while (numpoints > 1) {
+      line->point[index].x = x = ox + radius * cos(a);
+      line->point[index].y = y = oy + radius * sin(a);
+      line->point[index].z = z;
+
+      /* calculate bounds */
+      if (gpi->minx > x)
+        gpi->minx = x;
+      else if (gpi->maxx < x)
+        gpi->maxx = x;
+      if (gpi->miny > y)
+        gpi->miny = y;
+      else if (gpi->maxy < y)
+        gpi->maxy = y;
+
+      a += da;
+      ++index;
+      --numpoints;
+    }
+    /* set last point */
+    line->point[index].x = x3;
+    line->point[index].y = y3;
+    line->point[index].z = z;
+  }
+  return index;
+}
+
+int ParseSqlGeometry(msMSSQL2008LayerInfo *layerinfo, shapeObj *shape) {
+  msGeometryParserInfo *gpi = &layerinfo->gpi;
+
+  gpi->nNumPointsRead = 0;
+
+  if (gpi->nLen < 10) {
+    msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+    return NOT_ENOUGH_DATA;
+  }
+
+  /* store the SRS id for further use */
+  gpi->nSRSId = ReadInt32(0);
+
+  gpi->chVersion = ReadByte(4);
+
+  if (gpi->chVersion > 2) {
+    msDebug("ParseSqlGeometry CORRUPT_DATA\n");
+    return CORRUPT_DATA;
+  }
+
+  gpi->chProps = ReadByte(5);
+
+  gpi->nPointSize = 16;
+
+  if (gpi->chProps & SP_HASMVALUES)
+    gpi->nPointSize += 8;
+
+  if (gpi->chProps & SP_HASZVALUES)
+    gpi->nPointSize += 8;
+
+  if (gpi->chProps & SP_ISSINGLEPOINT) {
+    // single point geometry
+    gpi->nNumPoints = 1;
+    if (gpi->nLen < 6 + gpi->nPointSize) {
+      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+      return NOT_ENOUGH_DATA;
+    }
+
+    shape->type = MS_SHAPE_POINT;
+    shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj));
+    shape->numlines = 1;
+    shape->line[0].point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+    shape->line[0].numpoints = 1;
+    gpi->nPointPos = 6;
+
+    ReadPoint(gpi, &shape->line[0].point[0], 0);
+  } else if (gpi->chProps & SP_ISSINGLELINESEGMENT) {
+    // single line segment with 2 points
+    gpi->nNumPoints = 2;
+    if (gpi->nLen < 6 + 2 * gpi->nPointSize) {
+      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+      return NOT_ENOUGH_DATA;
+    }
+
+    shape->type = MS_SHAPE_LINE;
+    shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj));
+    shape->numlines = 1;
+    shape->line[0].point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+    shape->line[0].numpoints = 2;
+    gpi->nPointPos = 6;
+
+    ReadPoint(gpi, &shape->line[0].point[0], 0);
+    ReadPoint(gpi, &shape->line[0].point[1], 1);
+  } else {
+    int iShape, iFigure, iSegment = 0;
+    // complex geometries
+    gpi->nNumPoints = ReadInt32(6);
+
+    if (gpi->nNumPoints <= 0) {
+      return NOERROR;
+    }
+
+    // position of the point array
+    gpi->nPointPos = 10;
+
+    // position of the figures
+    gpi->nFigurePos = gpi->nPointPos + gpi->nPointSize * gpi->nNumPoints + 4;
+
+    if (gpi->nLen < gpi->nFigurePos) {
+      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+      return NOT_ENOUGH_DATA;
+    }
+
+    gpi->nNumFigures = ReadInt32(gpi->nFigurePos - 4);
+
+    if (gpi->nNumFigures <= 0) {
+      return NOERROR;
+    }
+
+    // position of the shapes
+    gpi->nShapePos = gpi->nFigurePos + 5 * gpi->nNumFigures + 4;
+
+    if (gpi->nLen < gpi->nShapePos) {
+      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+      return NOT_ENOUGH_DATA;
+    }
+
+    gpi->nNumShapes = ReadInt32(gpi->nShapePos - 4);
+
+    if (gpi->nLen < gpi->nShapePos + 9 * gpi->nNumShapes) {
+      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+      return NOT_ENOUGH_DATA;
+    }
+
+    if (gpi->nNumShapes <= 0) {
+      return NOERROR;
+    }
+
+    // pick up the root shape
+    if (ParentOffset(0) != 0xFFFFFFFF) {
+      msDebug("ParseSqlGeometry CORRUPT_DATA\n");
+      return CORRUPT_DATA;
+    }
+
+    // determine the shape type
+    for (iShape = 0; iShape < gpi->nNumShapes; iShape++) {
+      unsigned char shapeType = ShapeType(iShape);
+      if (shapeType == ST_POINT || shapeType == ST_MULTIPOINT) {
+        shape->type = MS_SHAPE_POINT;
+        break;
+      } else if (shapeType == ST_LINESTRING ||
+                 shapeType == ST_MULTILINESTRING ||
+                 shapeType == ST_CIRCULARSTRING ||
+                 shapeType == ST_COMPOUNDCURVE) {
+        shape->type = MS_SHAPE_LINE;
+        break;
+      } else if (shapeType == ST_POLYGON || shapeType == ST_MULTIPOLYGON ||
+                 shapeType == ST_CURVEPOLYGON) {
+        shape->type = MS_SHAPE_POLYGON;
+        break;
+      }
+    }
+
+    shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj) * gpi->nNumFigures);
+    shape->numlines = gpi->nNumFigures;
+    gpi->nNumSegments = 0;
+
+    // read figures
+    for (iFigure = 0; iFigure < gpi->nNumFigures; iFigure++) {
+      int iPoint, iNextPoint, i;
+      iPoint = PointOffset(iFigure);
+      iNextPoint = NextPointOffset(iFigure);
+
+      shape->line[iFigure].point =
+          (pointObj *)msSmallMalloc(sizeof(pointObj) * (iNextPoint - iPoint));
+      shape->line[iFigure].numpoints = iNextPoint - iPoint;
+      i = 0;
+
+      if (gpi->chVersion == 0x02 && FigureAttribute(iFigure) >= 0x02) {
+        int nPointPrepared = 0;
+        lineObj *line = &shape->line[iFigure];
+        if (FigureAttribute(iFigure) == 0x03) {
+          if (gpi->nNumSegments == 0) {
+            /* position of the segment types */
+            gpi->nSegmentPos = gpi->nShapePos + 9 * gpi->nNumShapes + 4;
+            gpi->nNumSegments = ReadInt32(gpi->nSegmentPos - 4);
+            if (gpi->nLen < gpi->nSegmentPos + gpi->nNumSegments) {
+              msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+              return NOT_ENOUGH_DATA;
+            }
+            iSegment = 0;
+          }
+
+          while (iPoint < iNextPoint && iSegment < gpi->nNumSegments) {
+            ReadPoint(gpi, &line->point[i], iPoint);
+            ++iPoint;
+            ++nPointPrepared;
+
+            if (nPointPrepared == 2 &&
+                (SegmentType(iSegment) == SMT_FIRSTLINE ||
+                 SegmentType(iSegment) == SMT_LINE)) {
+              ++iSegment;
+              nPointPrepared = 1;
+            } else if (nPointPrepared == 3 &&
+                       (SegmentType(iSegment) == SMT_FIRSTARC ||
+                        SegmentType(iSegment) == SMT_ARC)) {
+              i = StrokeArcToLine(gpi, line, i);
+              ++iSegment;
+              nPointPrepared = 1;
+            }
+            ++i;
+          }
+        } else {
+          while (iPoint < iNextPoint) {
+            ReadPoint(gpi, &line->point[i], iPoint);
+            ++iPoint;
+            ++nPointPrepared;
+            if (nPointPrepared == 3) {
+              i = StrokeArcToLine(gpi, line, i);
+              nPointPrepared = 1;
+            }
+            ++i;
+          }
+        }
+      } else {
+        while (iPoint < iNextPoint) {
+          ReadPoint(gpi, &shape->line[iFigure].point[i], iPoint);
+          ++iPoint;
+          ++i;
+        }
+      }
+    }
+  }
+
+  /* set bounds */
+  shape->bounds.minx = gpi->minx;
+  shape->bounds.miny = gpi->miny;
+  shape->bounds.maxx = gpi->maxx;
+  shape->bounds.maxy = gpi->maxy;
+
+  return NOERROR;
+}
+
+/* MS SQL driver code*/
+
+msMSSQL2008LayerInfo *getMSSQL2008LayerInfo(const layerObj *layer) {
+  return layer->layerinfo;
+}
+
+void setMSSQL2008LayerInfo(layerObj *layer,
+                           msMSSQL2008LayerInfo *MSSQL2008layerinfo) {
+  layer->layerinfo = (void *)MSSQL2008layerinfo;
+}
+
+void handleSQLError(layerObj *layer) {
+  SQLCHAR SqlState[6], Msg[SQL_MAX_MESSAGE_LENGTH];
+  SQLINTEGER NativeError;
+  SQLSMALLINT i, MsgLen;
+  SQLRETURN rc;
+  msMSSQL2008LayerInfo *layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (layerinfo == NULL)
+    return;
+
+  // Get the status records.
+  i = 1;
+  while ((rc = SQLGetDiagRec(SQL_HANDLE_STMT, layerinfo->conn->hstmt, i,
+                             SqlState, &NativeError, Msg, sizeof(Msg),
+                             &MsgLen)) != SQL_NO_DATA) {
+    if (layer->debug) {
+      msDebug("SQLError: %s\n", Msg);
+    }
+    i++;
+  }
+}
+
+/* TODO Take a look at glibc's strcasestr */
+static char *strstrIgnoreCase(const char *haystack, const char *needle) {
+  char *hay_lower;
+  char *needle_lower;
+  size_t len_hay, len_need, match;
+  int found = MS_FALSE;
+  char *loc;
+
+  len_hay = strlen(haystack);
+  len_need = strlen(needle);
+
+  hay_lower = (char *)msSmallMalloc(len_hay + 1);
+  needle_lower = (char *)msSmallMalloc(len_need + 1);
+
+  size_t t;
+  for (t = 0; t < len_hay; t++) {
+    hay_lower[t] = (char)tolower(haystack[t]);
+  }
+  hay_lower[t] = 0;
+
+  for (t = 0; t < len_need; t++) {
+    needle_lower[t] = (char)tolower(needle[t]);
+  }
+  needle_lower[t] = 0;
+
+  loc = strstr(hay_lower, needle_lower);
+  if (loc) {
+    match = loc - hay_lower;
+    found = MS_TRUE;
+  }
+
+  msFree(hay_lower);
+  msFree(needle_lower);
+
+  return (char *)(found == MS_FALSE ? NULL : haystack + match);
+}
+
+static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name,
+                                     char **geom_column_type, char **table_name,
+                                     char **urid_name, char **user_srid,
+                                     char **index_name, char **sort_spec,
+                                     int debug);
+
+/* Close connection and handles */
+static void msMSSQL2008CloseConnection(void *conn_handle) {
+  msODBCconn *conn = (msODBCconn *)conn_handle;
+
+  if (!conn) {
+    return;
+  }
+
+  if (conn->hstmt) {
+    SQLFreeHandle(SQL_HANDLE_STMT, conn->hstmt);
+  }
+  if (conn->hdbc) {
+    SQLDisconnect(conn->hdbc);
+    SQLFreeHandle(SQL_HANDLE_DBC, conn->hdbc);
+  }
+  if (conn->henv) {
+    SQLFreeHandle(SQL_HANDLE_ENV, conn->henv);
+  }
+
+  msFree(conn);
+}
+
+/* Set the error string for the connection */
+static void setConnError(msODBCconn *conn) {
+  SQLSMALLINT len;
+
+  SQLGetDiagField(SQL_HANDLE_DBC, conn->hdbc, 1, SQL_DIAG_MESSAGE_TEXT,
+                  (SQLPOINTER)conn->errorMessage, sizeof(conn->errorMessage),
+                  &len);
+
+  conn->errorMessage[len] = 0;
+}
+
+#ifdef USE_ICONV
+static SQLWCHAR *convertCwchartToSQLWCHAR(const wchar_t *inStr) {
+  SQLWCHAR *outStr;
+  int i, len;
+  for (len = 0; inStr[len] != 0; ++len) {
+    /* do nothing */
+  }
+  outStr = (SQLWCHAR *)msSmallMalloc(sizeof(SQLWCHAR) * (len + 1));
+  for (i = 0; i <= len; i++) {
+    outStr[i] = (SQLWCHAR)inStr[i];
+  }
+  return outStr;
+}
+#endif
+
+/* Connect to db */
+static msODBCconn *mssql2008Connect(const char *connString) {
+  SQLSMALLINT outConnStringLen;
+  SQLRETURN rc;
+  msODBCconn *conn = msSmallMalloc(sizeof(msODBCconn));
+  char fullConnString[1024];
+
+  memset(conn, 0, sizeof(*conn));
+
+  SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &conn->henv);
+
+  SQLSetEnvAttr(conn->henv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)SQL_OV_ODBC3, 0);
+
+  SQLAllocHandle(SQL_HANDLE_DBC, conn->henv, &conn->hdbc);
+
+  if (strcasestr(connString, "DRIVER=") == 0) {
+    snprintf(fullConnString, sizeof(fullConnString), "DRIVER={SQL Server};%s",
+             connString);
+
+    connString = fullConnString;
+  }
+
+  {
+#ifdef USE_ICONV
+    wchar_t *decodedConnString =
+        msConvertWideStringFromUTF8(connString, "UCS-2LE");
+    SQLWCHAR outConnString[1024];
+    SQLWCHAR *decodedConnStringSQLWCHAR =
+        convertCwchartToSQLWCHAR(decodedConnString);
+    rc = SQLDriverConnectW(conn->hdbc, NULL, decodedConnStringSQLWCHAR, SQL_NTS,
+                           outConnString, 1024, &outConnStringLen,
+                           SQL_DRIVER_NOPROMPT);
+    msFree(decodedConnString);
+    msFree(decodedConnStringSQLWCHAR);
+#else
+    SQLCHAR outConnString[1024];
+    rc = SQLDriverConnect(conn->hdbc, NULL, (SQLCHAR *)connString, SQL_NTS,
+                          outConnString, 1024, &outConnStringLen,
+                          SQL_DRIVER_NOPROMPT);
+#endif
+  }
+
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    setConnError(conn);
+
+    return conn;
+  }
+
+  SQLAllocHandle(SQL_HANDLE_STMT, conn->hdbc, &conn->hstmt);
+
+  return conn;
+}
+
+/* Set the error string for the statement execution */
+static void setStmntError(msODBCconn *conn) {
+  SQLSMALLINT len;
+
+  SQLGetDiagField(SQL_HANDLE_STMT, conn->hstmt, 1, SQL_DIAG_MESSAGE_TEXT,
+                  (SQLPOINTER)conn->errorMessage, sizeof(conn->errorMessage),
+                  &len);
+
+  conn->errorMessage[len] = 0;
+}
+
+/* Execute SQL against connection. Set error string  if failed */
+static int executeSQL(msODBCconn *conn, const char *sql) {
+  SQLRETURN rc;
+
+  SQLCloseCursor(conn->hstmt);
+
+#ifdef USE_ICONV
+  {
+    wchar_t *decodedSql = msConvertWideStringFromUTF8(sql, "UCS-2LE");
+    SQLWCHAR *decodedSqlSQLWCHAR = convertCwchartToSQLWCHAR(decodedSql);
+    rc = SQLExecDirectW(conn->hstmt, decodedSqlSQLWCHAR, SQL_NTS);
+    msFree(decodedSql);
+    msFree(decodedSqlSQLWCHAR);
+  }
+#else
+  rc = SQLExecDirect(conn->hstmt, (SQLCHAR *)sql, SQL_NTS);
+#endif
+
+  if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
+    return 1;
+  } else {
+    setStmntError(conn);
+    return 0;
+  }
+}
+
+/* Get columns name from query results */
+static int columnName(msODBCconn *conn, int index, char *buffer,
+                      int bufferLength, layerObj *layer, char pass_field_def,
+                      SQLSMALLINT *itemType) {
+  SQLRETURN rc;
+
+  SQLCHAR columnName[SQL_COLUMN_NAME_MAX_LENGTH + 1];
+  SQLSMALLINT columnNameLen;
+  SQLSMALLINT dataType;
+  SQLULEN columnSize;
+  SQLSMALLINT decimalDigits;
+  SQLSMALLINT nullable;
+
+  rc = SQLDescribeCol(conn->hstmt, (SQLUSMALLINT)index, columnName,
+                      SQL_COLUMN_NAME_MAX_LENGTH, &columnNameLen, &dataType,
+                      &columnSize, &decimalDigits, &nullable);
+
+  if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
+    if (bufferLength < SQL_COLUMN_NAME_MAX_LENGTH + 1)
+      strlcpy(buffer, (const char *)columnName, bufferLength);
+    else
+      strlcpy(buffer, (const char *)columnName, SQL_COLUMN_NAME_MAX_LENGTH + 1);
+
+    *itemType = dataType;
+
+    if (pass_field_def) {
+      char gml_width[32], gml_precision[32];
+      const char *gml_type = NULL;
+
+      gml_width[0] = '\0';
+      gml_precision[0] = '\0';
+
+      switch (dataType) {
+      case SQL_INTEGER:
+      case SQL_SMALLINT:
+      case SQL_TINYINT:
+        gml_type = "Integer";
+        break;
+
+      case SQL_BIGINT:
+        gml_type = "Long";
+        break;
+
+      case SQL_REAL:
+      case SQL_FLOAT:
+      case SQL_DOUBLE:
+      case SQL_DECIMAL:
+      case SQL_NUMERIC:
+        gml_type = "Real";
+        if (decimalDigits > 0)
+          sprintf(gml_precision, "%d", decimalDigits);
+        break;
+
+      case SQL_TYPE_DATE:
+        gml_type = "Date";
+        break;
+      case SQL_TYPE_TIME:
+        gml_type = "Time";
+        break;
+      case SQL_TYPE_TIMESTAMP:
+        gml_type = "DateTime";
+        break;
+
+      case SQL_BIT:
+        gml_type = "Boolean";
+        break;
+
+      default:
+        gml_type = "Character";
+        break;
+      }
+
+      if (columnSize > 0)
+        sprintf(gml_width, "%u", (unsigned int)columnSize);
+
+      msUpdateGMLFieldMetadata(layer, buffer, gml_type, gml_width,
+                               gml_precision, (const short)nullable);
+    }
+    return 1;
+  } else {
+    setStmntError(conn);
+    return 0;
+  }
+}
+
+/* open up a connection to the MS SQL 2008 database using the connection string
+ * in layer->connection */
+/* ie. "driver=<driver>;server=<server>;database=<database>;integrated
+ * security=?;user id=<username>;password=<password>" */
+int msMSSQL2008LayerOpen(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *conn_decrypted = NULL;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerOpen called datastatement: %s\n", layer->data);
+  }
+
+  if (getMSSQL2008LayerInfo(layer)) {
+    if (layer->debug) {
+      msDebug("msMSSQL2008LayerOpen :: layer is already open!!\n");
+    }
+    return MS_SUCCESS; /* already open */
+  }
+
+  if (!layer->data) {
+    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerOpen()", "",
+               "Error parsing MSSQL2008 data variable: nothing specified in "
+               "DATA statement.<br><br>\n\nMore Help:<br><br>\n\n");
+
+    return MS_FAILURE;
+  }
+
+  if (!layer->connection) {
+    msSetError(MS_QUERYERR, "MSSQL connection parameter not specified.",
+               "msMSSQL2008LayerOpen()");
+    return MS_FAILURE;
+  }
+
+  /* have to setup a connection to the database */
+
+  layerinfo =
+      (msMSSQL2008LayerInfo *)msSmallMalloc(sizeof(msMSSQL2008LayerInfo));
+
+  layerinfo->sql = NULL; /* calc later */
+  layerinfo->row_num = 0;
+  layerinfo->geom_column = NULL;
+  layerinfo->geom_column_type = NULL;
+  layerinfo->geom_table = NULL;
+  layerinfo->urid_name = NULL;
+  layerinfo->user_srid = NULL;
+  layerinfo->index_name = NULL;
+  layerinfo->sort_spec = NULL;
+  layerinfo->conn = NULL;
+  layerinfo->itemtypes = NULL;
+  layerinfo->mssqlversion_major = 0;
+  layerinfo->paging = MS_TRUE;
+
+  layerinfo->conn = (msODBCconn *)msConnPoolRequest(layer);
+
+  if (!layerinfo->conn) {
+    if (layer->debug) {
+      msDebug("MSMSSQL2008LayerOpen -- shared connection not available.\n");
+    }
+
+    /* Decrypt any encrypted token in connection and attempt to connect */
+    conn_decrypted = msDecryptStringTokens(layer->map, layer->connection);
+    if (conn_decrypted == NULL) {
+      return (MS_FAILURE); /* An error should already have been produced */
+    }
+
+    layerinfo->conn = mssql2008Connect(conn_decrypted);
+
+    msFree(conn_decrypted);
+    conn_decrypted = NULL;
+
+    if (!layerinfo->conn || layerinfo->conn->errorMessage[0]) {
+      char *errMess = "Out of memory";
+
+      if (layer->debug)
+        msDebug("MSMSSQL2008LayerOpen: Connection failure.\n");
+
+      if (layerinfo->conn) {
+        errMess = layerinfo->conn->errorMessage;
+      }
+
+      msDebug(
+          "Couldn't make connection to MS SQL Server with connect string "
+          "'%s'.\n"
+          "Error reported was '%s'.\n\n"
+          "This error occured when trying to make a connection to the "
+          "specified SQL server.\n"
+          "Most commonly this is caused by: \n"
+          "(1) incorrect connection string \n"
+          "(2) you didn't specify a 'user id=...' in your connection string \n"
+          "(3) SQL server isnt running \n"
+          "(4) TCPIP not enabled for SQL Client or server \n\n",
+          layer->connection, errMess);
+      msSetError(MS_QUERYERR,
+                 "Database connection failed. Check server logs for more "
+                 "details. Is SQL Server running? Is it allowing connections? "
+                 "Does the specified user exist? Is the password valid? Is the "
+                 "database on the standard port?",
+                 "MSMSSQL2008LayerOpen()");
+
+      msMSSQL2008CloseConnection(layerinfo->conn);
+      msFree(layerinfo);
+      return MS_FAILURE;
+    }
+
+    msConnPoolRegister(layer, layerinfo->conn, msMSSQL2008CloseConnection);
+  }
+
+  setMSSQL2008LayerInfo(layer, layerinfo);
+
+  if (msMSSQL2008LayerParseData(
+          layer, &layerinfo->geom_column, &layerinfo->geom_column_type,
+          &layerinfo->geom_table, &layerinfo->urid_name, &layerinfo->user_srid,
+          &layerinfo->index_name, &layerinfo->sort_spec,
+          layer->debug) != MS_SUCCESS) {
+    msSetError(MS_QUERYERR, "Could not parse the layer data",
+               "msMSSQL2008LayerOpen()");
+    return MS_FAILURE;
+  }
+
+  /* identify the geometry transfer type */
+  if (msLayerGetProcessingKey(layer, "MSSQL_READ_WKB") != NULL)
+    layerinfo->geometry_format = MSSQLGEOMETRY_WKB;
+  else {
+    layerinfo->geometry_format = MSSQLGEOMETRY_NATIVE;
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
+      layerinfo->gpi.nColType = MSSQLCOLTYPE_GEOGRAPHY;
+    else
+      layerinfo->gpi.nColType = MSSQLCOLTYPE_GEOMETRY;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
+int msMSSQL2008LayerIsOpen(layerObj *layer) {
+  return getMSSQL2008LayerInfo(layer) ? MS_TRUE : MS_FALSE;
+}
+
+/* Free the itemindexes array in a layer. */
+void msMSSQL2008LayerFreeItemInfo(layerObj *layer) {
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerFreeItemInfo called\n");
+  }
+
+  if (layer->iteminfo) {
+    msFree(layer->iteminfo);
+  }
+
+  layer->iteminfo = NULL;
+}
+
+/* allocate the iteminfo index array - same order as the item list */
+int msMSSQL2008LayerInitItemInfo(layerObj *layer) {
+  int i;
+  int *itemindexes;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerInitItemInfo called\n");
+  }
+
+  if (layer->numitems == 0) {
+    return MS_SUCCESS;
+  }
+
+  msFree(layer->iteminfo);
+
+  layer->iteminfo = (int *)msSmallMalloc(sizeof(int) * layer->numitems);
+
+  itemindexes = (int *)layer->iteminfo;
+
+  for (i = 0; i < layer->numitems; i++) {
+    itemindexes[i] =
+        i; /* last one is always the geometry one - the rest are non-geom */
+  }
+
+  return MS_SUCCESS;
+}
+
+static int getMSSQLMajorVersion(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo = getMSSQL2008LayerInfo(layer);
+  if (layerinfo == NULL)
+    return 0;
+
+  if (layerinfo->mssqlversion_major == 0) {
+    const char *mssqlversion_major =
+        msLayerGetProcessingKey(layer, "MSSQL_VERSION_MAJOR");
+    if (mssqlversion_major != NULL) {
+      layerinfo->mssqlversion_major = atoi(mssqlversion_major);
+    } else {
+      /* need to query from database */
+      if (executeSQL(layerinfo->conn,
+                     "SELECT SERVERPROPERTY('ProductVersion')")) {
+        SQLRETURN rc = SQLFetch(layerinfo->conn->hstmt);
+        if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
+          /* process results */
+          char result_data[256];
+          SQLLEN retLen = 0;
+
+          rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                          sizeof(result_data), &retLen);
+
+          if (rc != SQL_ERROR) {
+            result_data[retLen] = 0;
+            layerinfo->mssqlversion_major = atoi(result_data);
+          }
+        }
+      }
+    }
+  }
+
+  return layerinfo->mssqlversion_major;
+}
+
+static int addFilter(layerObj *layer, char **query) {
+  if (layer->filter.native_string) {
+    (*query) = msStringConcatenate(*query, " WHERE (");
+    (*query) = msStringConcatenate(*query, layer->filter.native_string);
+    (*query) = msStringConcatenate(*query, ")");
+    return MS_TRUE;
+  } else if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+    (*query) = msStringConcatenate(*query, " WHERE (");
+    (*query) = msStringConcatenate(
+        *query, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
+    (*query) = msStringConcatenate(*query, ")");
+    return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/* Get the layer extent as specified in the mapfile or a largest area */
+/* covering all features */
+int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *query = 0;
+  char result_data[256];
+  SQLLEN retLen;
+  SQLRETURN rc;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetExtent called\n");
+  }
+
+  if (!(layer->extent.minx == -1.0 && layer->extent.miny == -1.0 &&
+        layer->extent.maxx == -1.0 && layer->extent.maxy == -1.0)) {
+    /* extent was already set */
+    extent->minx = layer->extent.minx;
+    extent->miny = layer->extent.miny;
+    extent->maxx = layer->extent.maxx;
+    extent->maxy = layer->extent.maxy;
+  }
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "GetExtent called with layerinfo = NULL",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  /* set up statement */
+  if (getMSSQLMajorVersion(layer) >= 11) {
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
+      query = msStringConcatenate(
+          query, "WITH extent(extentcol) AS (SELECT "
+                 "geometry::EnvelopeAggregate(geometry::STGeomFromWKB(");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STAsBinary(), ");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STSrid)");
+    } else {
+      query = msStringConcatenate(
+          query,
+          "WITH extent(extentcol) AS (SELECT geometry::EnvelopeAggregate(");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+    }
+    query = msStringConcatenate(query, ") AS extentcol FROM ");
+    query = msStringConcatenate(query, layerinfo->geom_table);
+
+    /* adding attribute filter */
+    addFilter(layer, &query);
+
+    query = msStringConcatenate(
+        query,
+        ") SELECT extentcol.STPointN(1).STX, extentcol.STPointN(1).STY, "
+        "extentcol.STPointN(3).STX, extentcol.STPointN(3).STY FROM extent");
+  } else {
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
+      query = msStringConcatenate(
+          query, "WITH ENVELOPE as (SELECT geometry::STGeomFromWKB(");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STAsBinary(), ");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STSrid)");
+    } else {
+      query = msStringConcatenate(query, "WITH ENVELOPE as (SELECT ");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+    }
+    query = msStringConcatenate(query, ".STEnvelope() as envelope from ");
+    query = msStringConcatenate(query, layerinfo->geom_table);
+
+    /* adding attribute filter */
+    addFilter(layer, &query);
+
+    query = msStringConcatenate(
+        query, "), CORNERS as (SELECT envelope.STPointN(1) as point from "
+               "ENVELOPE UNION ALL select envelope.STPointN(3) from ENVELOPE) "
+               "SELECT MIN(point.STX), MIN(point.STY), MAX(point.STX), "
+               "MAX(point.STY) FROM CORNERS");
+  }
+
+  if (!executeSQL(layerinfo->conn, query)) {
+    msFree(query);
+    return MS_FAILURE;
+  }
+
+  msFree(query);
+
+  /* process results */
+  rc = SQLFetch(layerinfo->conn->hstmt);
+
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (layer->debug) {
+      msDebug("msMSSQL2008LayerGetExtent: No results found.\n");
+    }
+    return MS_FAILURE;
+  }
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MinX value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  result_data[retLen] = 0;
+
+  extent->minx = atof(result_data);
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 2, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MinY value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  result_data[retLen] = 0;
+
+  extent->miny = atof(result_data);
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 3, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MaxX value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  result_data[retLen] = 0;
+
+  extent->maxx = atof(result_data);
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 4, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MaxY value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  result_data[retLen] = 0;
+
+  extent->maxy = atof(result_data);
+
+  return MS_SUCCESS;
+}
+
+/* Get the layer feature count */
+int msMSSQL2008LayerGetNumFeatures(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *query = 0;
+  char result_data[256];
+  SQLLEN retLen;
+  SQLRETURN rc;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetNumFeatures called\n");
+  }
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "GetNumFeatures called with layerinfo = NULL",
+               "msMSSQL2008LayerGetNumFeatures()");
+    return -1;
+  }
+
+  /* set up statement */
+  query = msStringConcatenate(query, "SELECT count(*) FROM ");
+  query = msStringConcatenate(query, layerinfo->geom_table);
+
+  /* adding attribute filter */
+  addFilter(layer, &query);
+
+  if (!executeSQL(layerinfo->conn, query)) {
+    msFree(query);
+    return -1;
+  }
+
+  msFree(query);
+
+  rc = SQLFetch(layerinfo->conn->hstmt);
+
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (layer->debug) {
+      msDebug("msMSSQL2008LayerGetNumFeatures: No results found.\n");
+    }
+
+    return -1;
+  }
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+
+  if (rc == SQL_ERROR) {
+    msSetError(MS_QUERYERR, "Failed to get feature count",
+               "msMSSQL2008LayerGetNumFeatures()");
+    return -1;
+  }
+
+  result_data[retLen] = 0;
+
+  return atoi(result_data);
+}
+
+/* Prepare and execute the SQL statement for this layer */
+static int prepare_database(layerObj *layer, rectObj rect, char **query_string,
+                            int isQuery) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *query = 0;
+  char *data_source = 0;
+  char *f_table_name = 0;
+  char *geom_table = 0;
+  char *tmp = 0;
+  char *paging_query = 0;
+  /*
+    "Geometry::STGeomFromText('POLYGON(())',)" + terminator = 40 chars
+    Plus 10 formatted doubles (15 digits of precision, a decimal point, a
+    space/comma delimiter each = 17 chars each) Plus SRID + comma - if SRID is a
+    long...we'll be safe with 10 chars
+
+    or for geography columns
+
+    "Geography::STGeomFromText('CURVEPOLYGON(())',)" + terminator = 46 chars
+    Plus 18 formatted doubles (15 digits of precision, a decimal point, a
+    space/comma delimiter each = 17 chars each) Plus SRID + comma - if SRID is a
+    long...we'll be safe with 10 chars
+  */
+  char box3d[46 + 18 * 22 + 11];
+  int t;
+
+  char *pos_from, *pos_ftab, *pos_space, *pos_paren;
+  int hasFilter = MS_FALSE;
+  const rectObj rectInvalid = MS_INIT_INVALID_RECT;
+  const int bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  /* Extract the proper f_table_name from the geom_table string.
+   * We are expecting the geom_table to be either a single word
+   * or a sub-select clause that possibly includes a join --
+   *
+   * (select column[,column[,...]] from ftab[ natural join table2]) as foo
+   *
+   * We are expecting whitespace or a ')' after the ftab name.
+   *
+   */
+
+  geom_table = msStrdup(layerinfo->geom_table);
+  pos_from = strstrIgnoreCase(geom_table, " from ");
+
+  if (!pos_from) {
+    f_table_name = (char *)msSmallMalloc(strlen(geom_table) + 1);
+    strcpy(f_table_name, geom_table);
+  } else {                   /* geom_table is a sub-select clause */
+    pos_ftab = pos_from + 6; /* This should be the start of the ftab name */
+    pos_space = strstr(pos_ftab, " "); /* First space */
+
+    /* TODO strrchr is POSIX and C99, rindex is neither */
+#if defined(_WIN32) && !defined(__CYGWIN__)
+    pos_paren = strrchr(pos_ftab, ')');
+#else
+    pos_paren = rindex(pos_ftab, ')');
+#endif
+
+    if (!pos_space || !pos_paren) {
+      msSetError(
+          MS_QUERYERR, DATA_ERROR_MESSAGE, "prepare_database()", geom_table,
+          "Error parsing MSSQL2008 data variable: Something is wrong with your "
+          "subselect statement.<br><br>\n\nMore Help:<br><br>\n\n");
+
+      return MS_FAILURE;
+    }
+
+    if (pos_paren < pos_space) { /* closing parenthesis preceeds any space */
+      f_table_name = (char *)msSmallMalloc(pos_paren - pos_ftab + 1);
+      strlcpy(f_table_name, pos_ftab, pos_paren - pos_ftab + 1);
+    } else {
+      f_table_name = (char *)msSmallMalloc(pos_space - pos_ftab + 1);
+      strlcpy(f_table_name, pos_ftab, pos_space - pos_ftab + 1);
+    }
+  }
+
+  if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
+    /* create point shape for rectangles with zero area */
+    sprintf(box3d,
+            "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
+            layerinfo->geom_column_type, rect.minx, rect.miny,
+            layerinfo->user_srid);
+  } else if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
+    /* SQL Server has a problem when x is -180 or 180 */
+    double minx = rect.minx <= -180 ? -179.999 : rect.minx;
+    double maxx = rect.maxx >= 180 ? 179.999 : rect.maxx;
+    double miny = rect.miny < -90 ? -90 : rect.miny;
+    double maxy = rect.maxy > 90 ? 90 : rect.maxy;
+    sprintf(box3d,
+            "Geography::STGeomFromText('CURVEPOLYGON((%.15g %.15g,%.15g "
+            "%.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g "
+            "%.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
+            minx, miny, minx + (maxx - minx) / 2, miny, maxx, miny, maxx,
+            miny + (maxy - miny) / 2, maxx, maxy, minx + (maxx - minx) / 2,
+            maxy, minx, maxy, minx, miny + (maxy - miny) / 2, minx, miny,
+            layerinfo->user_srid);
+  } else {
+    sprintf(box3d,
+            "Geometry::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g "
+            "%.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
+            rect.minx, rect.miny, rect.maxx, rect.miny, rect.maxx, rect.maxy,
+            rect.minx, rect.maxy, rect.minx, rect.miny, layerinfo->user_srid);
+  }
+
+  /* substitute token '!BOX!' in geom_table with the box3d - do an unlimited #
+   * of subs */
+  /* to not undo the work here, we need to make sure that data_source is
+   * malloc'd here */
+
+  if (!strstr(geom_table, "!BOX!")) {
+    data_source = (char *)msSmallMalloc(strlen(geom_table) + 1);
+    strcpy(data_source, geom_table);
+  } else {
+    char *result = NULL;
+
+    while (strstr(geom_table, "!BOX!")) {
+      /* need to do a substition */
+      char *start, *end;
+      char *oldresult = result;
+      start = strstr(geom_table, "!BOX!");
+      end = start + 5;
+
+      result = (char *)msSmallMalloc((start - geom_table) + strlen(box3d) +
+                                     strlen(end) + 1);
+
+      strlcpy(result, geom_table, start - geom_table + 1);
+      strcpy(result + (start - geom_table), box3d);
+      strcat(result, end);
+
+      geom_table = result;
+      msFree(oldresult);
+    }
+
+    /* if we're here, this will be a malloc'd string, so no need to copy it */
+    data_source = (char *)geom_table;
+  }
+
+  /* start creating the query */
+
+  query = msStringConcatenate(query, "SELECT ");
+  if (layerinfo->paging && (layer->maxfeatures >= 0 || layer->startindex > 0))
+    paging_query = msStringConcatenate(paging_query, "SELECT ");
+
+  /* adding items to the select list */
+  for (t = 0; t < layer->numitems; t++) {
+#ifdef USE_ICONV
+    query = msStringConcatenate(query, "convert(nvarchar(max), [");
+#else
+    query = msStringConcatenate(query, "convert(varchar(max), [");
+#endif
+    query = msStringConcatenate(query, layer->items[t]);
+    query = msStringConcatenate(query, "]) '");
+    tmp = msIntToString(t);
+    query = msStringConcatenate(query, tmp);
+    if (paging_query) {
+      paging_query = msStringConcatenate(paging_query, "[");
+      paging_query = msStringConcatenate(paging_query, tmp);
+      paging_query = msStringConcatenate(paging_query, "], ");
+    }
+    msFree(tmp);
+    query = msStringConcatenate(query, "',");
+  }
+
+  /* adding geometry column */
+  query = msStringConcatenate(query, "[");
+  query = msStringConcatenate(query, layerinfo->geom_column);
+  if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
+    query = msStringConcatenate(query, "] 'geom',");
+  else {
+    query = msStringConcatenate(query, "].STAsBinary() 'geom',");
+  }
+
+  /* adding id column */
+  query = msStringConcatenate(query, "convert(varchar(36), [");
+  query = msStringConcatenate(query, layerinfo->urid_name);
+  if (paging_query) {
+    paging_query = msStringConcatenate(paging_query, "[geom], [id] FROM (");
+    query = msStringConcatenate(query, "]) 'id', row_number() over (");
+    if (layerinfo->sort_spec) {
+      query = msStringConcatenate(query, layerinfo->sort_spec);
+    }
+
+    if (layer->sortBy.nProperties > 0) {
+      tmp = msLayerBuildSQLOrderBy(layer);
+      if (layerinfo->sort_spec) {
+        query = msStringConcatenate(query, ", ");
+      } else {
+        query = msStringConcatenate(query, " ORDER BY ");
+      }
+      query = msStringConcatenate(query, tmp);
+      msFree(tmp);
+    } else {
+      if (!layerinfo->sort_spec) {
+        // use the unique Id as the default sort for paging
+        query = msStringConcatenate(query, "ORDER BY ");
+        query = msStringConcatenate(query, layerinfo->urid_name);
+      }
+    }
+    query = msStringConcatenate(query, ") 'rownum' FROM ");
+  } else {
+    query = msStringConcatenate(query, "]) 'id' FROM ");
+  }
+
+  /* adding the source */
+  query = msStringConcatenate(query, data_source);
+  msFree(data_source);
+  msFree(f_table_name);
+
+  /* use the index hint if provided */
+  if (layerinfo->index_name) {
+    query = msStringConcatenate(query, " WITH (INDEX(");
+    query = msStringConcatenate(query, layerinfo->index_name);
+    query = msStringConcatenate(query, "))");
+  }
+
+  /* adding attribute filter */
+  hasFilter = addFilter(layer, &query);
+
+  if (bIsValidRect) {
+    /* adding spatial filter */
+    if (hasFilter == MS_FALSE)
+      query = msStringConcatenate(query, " WHERE ");
+    else
+      query = msStringConcatenate(query, " AND ");
+
+    query = msStringConcatenate(query, layerinfo->geom_column);
+    query = msStringConcatenate(query, ".STIntersects(");
+    query = msStringConcatenate(query, box3d);
+    query = msStringConcatenate(query, ") = 1 ");
+  }
+
+  if (paging_query) {
+    paging_query = msStringConcatenate(paging_query, query);
+    paging_query = msStringConcatenate(paging_query, ") tbl where [rownum] ");
+    if (layer->startindex > 0) {
+      tmp = msIntToString(layer->startindex);
+      paging_query = msStringConcatenate(paging_query, ">= ");
+      paging_query = msStringConcatenate(paging_query, tmp);
+      if (layer->maxfeatures >= 0) {
+        msFree(tmp);
+        tmp = msIntToString(layer->startindex + layer->maxfeatures);
+        paging_query = msStringConcatenate(paging_query, " and [rownum] < ");
+        paging_query = msStringConcatenate(paging_query, tmp);
+      }
+    } else {
+      tmp = msIntToString(layer->maxfeatures);
+      paging_query = msStringConcatenate(paging_query, "< ");
+      paging_query = msStringConcatenate(paging_query, tmp);
+    }
+    msFree(tmp);
+    msFree(query);
+    query = paging_query;
+  } else {
+    if (layerinfo->sort_spec) {
+      query = msStringConcatenate(query, layerinfo->sort_spec);
+    }
+
+    /* Add extra sort by */
+    if (layer->sortBy.nProperties > 0) {
+      char *pszTmp = msLayerBuildSQLOrderBy(layer);
+      if (layerinfo->sort_spec)
+        query = msStringConcatenate(query, ", ");
+      else
+        query = msStringConcatenate(query, " ORDER BY ");
+      query = msStringConcatenate(query, pszTmp);
+      msFree(pszTmp);
+    } else if (isQuery && !layerinfo->sort_spec) {
+      /* Add orderby to make the result set order deterministic */
+      query = msStringConcatenate(query, " ORDER BY [");
+      query = msStringConcatenate(query, layerinfo->urid_name);
+      query = msStringConcatenate(query, "]");
+    }
+  }
+
+  if (layer->debug) {
+    msDebug("query:%s\n", query);
+  }
+
+  if (executeSQL(layerinfo->conn, query)) {
+    char pass_field_def = 0;
+    int t;
+    const char *value;
+    *query_string = query;
+    /* collect result information */
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) !=
+            NULL &&
+        strcasecmp(value, "auto") == 0)
+      pass_field_def = 1;
+
+    msFree(layerinfo->itemtypes);
+    layerinfo->itemtypes =
+        msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
+    for (t = 0; t < layer->numitems; t++) {
+      char colBuff[256];
+      SQLSMALLINT itemType = 0;
+
+      columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer,
+                 pass_field_def, &itemType);
+      layerinfo->itemtypes[t] = itemType;
+    }
+
+    return MS_SUCCESS;
+  } else {
+    msSetError(
+        MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n",
+        "msMSSQL2008LayerGetShape()", query, layerinfo->conn->errorMessage);
+
+    msFree(query);
+
+    return MS_FAILURE;
+  }
+}
+
+/* Execute SQL query for this layer */
+int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  (void)isQuery;
+  msMSSQL2008LayerInfo *layerinfo = 0;
+  char *query_str = 0;
+  int set_up_result;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerWhichShapes called\n");
+  }
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    /* layer not opened yet */
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerWhichShapes called on unopened layer "
+               "(layerinfo = NULL)",
+               "msMSSQL2008LayerWhichShapes()");
+
+    return MS_FAILURE;
+  }
+
+  if (!layer->data) {
+    msSetError(MS_QUERYERR,
+               "Missing DATA clause in MSSQL2008 Layer definition.  DATA "
+               "statement must contain 'geometry_column from table_name' or "
+               "'geometry_column from (sub-query) as foo'.",
+               "msMSSQL2008LayerWhichShapes()");
+
+    return MS_FAILURE;
+  }
+
+  set_up_result = prepare_database(layer, rect, &query_str, isQuery);
+
+  if (set_up_result != MS_SUCCESS) {
+    msFree(query_str);
+
+    return set_up_result; /* relay error */
+  }
+
+  msFree(layerinfo->sql);
+  layerinfo->sql = query_str;
+  layerinfo->row_num = 0;
+
+  return MS_SUCCESS;
+}
+
+/* Close the MSSQL2008 record set and connection */
+int msMSSQL2008LayerClose(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (layer->debug) {
+    char *data = "";
+
+    if (layer->data) {
+      data = layer->data;
+    }
+
+    msDebug("msMSSQL2008LayerClose datastatement: %s\n", data);
+  }
+
+  if (layer->debug && !layerinfo) {
+    msDebug("msMSSQL2008LayerClose -- layerinfo is  NULL\n");
+  }
+
+  if (layerinfo) {
+    msConnPoolRelease(layer, layerinfo->conn);
+
+    layerinfo->conn = NULL;
+
+    if (layerinfo->user_srid) {
+      msFree(layerinfo->user_srid);
+      layerinfo->user_srid = NULL;
+    }
+
+    if (layerinfo->urid_name) {
+      msFree(layerinfo->urid_name);
+      layerinfo->urid_name = NULL;
+    }
+
+    if (layerinfo->index_name) {
+      msFree(layerinfo->index_name);
+      layerinfo->index_name = NULL;
+    }
+
+    if (layerinfo->sort_spec) {
+      msFree(layerinfo->sort_spec);
+      layerinfo->sort_spec = NULL;
+    }
+
+    if (layerinfo->sql) {
+      msFree(layerinfo->sql);
+      layerinfo->sql = NULL;
+    }
+
+    if (layerinfo->geom_column) {
+      msFree(layerinfo->geom_column);
+      layerinfo->geom_column = NULL;
+    }
+
+    if (layerinfo->geom_column_type) {
+      msFree(layerinfo->geom_column_type);
+      layerinfo->geom_column_type = NULL;
+    }
+
+    if (layerinfo->geom_table) {
+      msFree(layerinfo->geom_table);
+      layerinfo->geom_table = NULL;
+    }
+
+    if (layerinfo->itemtypes) {
+      msFree(layerinfo->itemtypes);
+      layerinfo->itemtypes = NULL;
+    }
+
+    setMSSQL2008LayerInfo(layer, NULL);
+    msFree(layerinfo);
+  }
+
+  return MS_SUCCESS;
+}
+
+/* ******************************************************* */
+/* wkb is assumed to be 2d (force_2d) */
+/* and wkb is a GEOMETRYCOLLECTION (force_collection) */
+/* and wkb is in the endian of this computer (asbinary(...,'[XN]DR')) */
+/* each of the sub-geom inside the collection are point,linestring, or polygon
+ */
+/*  */
+/* also, int is 32bits long */
+/* double is 64bits long */
+/* ******************************************************* */
+
+/* convert the wkb into points */
+/* points -> pass through */
+/* lines->   constituent points */
+/* polys->   treat ring like line and pull out the consituent points */
+
+static int force_to_points(char *wkb, shapeObj *shape) {
+  /* we're going to make a 'line' for each entity (point, line or ring) in the
+   * geom collection */
+
+  int offset = 0;
+  int ngeoms;
+  int t, u, v;
+  int type, nrings, npoints;
+  lineObj line = {0, NULL};
+
+  shape->type = MS_SHAPE_NULL; /* nothing in it */
+
+  memcpy(&ngeoms, &wkb[5], 4);
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
+
+    if (type == 1) {
+      /* Point */
+      shape->type = MS_SHAPE_POINT;
+      line.numpoints = 1;
+      line.point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+
+      memcpy(&line.point[0].x, &wkb[offset + 5], 8);
+      memcpy(&line.point[0].y, &wkb[offset + 5 + 8], 8);
+      offset += 5 + 16;
+      msAddLine(shape, &line);
+      msFree(line.point);
+    } else if (type == 2) {
+      /* Linestring */
+      shape->type = MS_SHAPE_POINT;
+
+      memcpy(&line.numpoints, &wkb[offset + 5], 4); /* num points */
+      line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * line.numpoints);
+      for (u = 0; u < line.numpoints; u++) {
+        memcpy(&line.point[u].x, &wkb[offset + 9 + (16 * u)], 8);
+        memcpy(&line.point[u].y, &wkb[offset + 9 + (16 * u) + 8], 8);
+      }
+      offset += 9 + 16 * line.numpoints; /* length of object */
+      msAddLine(shape, &line);
+      msFree(line.point);
+    } else if (type == 3) {
+      /* Polygon */
+      shape->type = MS_SHAPE_POINT;
+
+      memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
+      /* add a line for each polygon ring */
+      offset += 9; /* now points at 1st linear ring */
+      for (u = 0; u < nrings; u++) {
+        /* for each ring, make a line */
+        memcpy(&npoints, &wkb[offset], 4); /* num points */
+        line.numpoints = npoints;
+        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
+        /* point struct */
+        for (v = 0; v < npoints; v++) {
+          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
+          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
+        }
+        /* make offset point to next linear ring */
+        msAddLine(shape, &line);
+        msFree(line.point);
+        offset += 4 + 16 * npoints;
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/* convert the wkb into lines */
+/* points-> remove */
+/* lines -> pass through */
+/* polys -> treat rings as lines */
+
+static int force_to_lines(char *wkb, shapeObj *shape) {
+  int offset = 0;
+  int ngeoms;
+  int t, u, v;
+  int type, nrings, npoints;
+  lineObj line = {0, NULL};
+
+  shape->type = MS_SHAPE_NULL; /* nothing in it */
+
+  memcpy(&ngeoms, &wkb[5], 4);
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
+
+    /* cannot do anything with a point */
+
+    if (type == 2) {
+      /* Linestring */
+      shape->type = MS_SHAPE_LINE;
+
+      memcpy(&line.numpoints, &wkb[offset + 5], 4);
+      line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * line.numpoints);
+      for (u = 0; u < line.numpoints; u++) {
+        memcpy(&line.point[u].x, &wkb[offset + 9 + (16 * u)], 8);
+        memcpy(&line.point[u].y, &wkb[offset + 9 + (16 * u) + 8], 8);
+      }
+      offset += 9 + 16 * line.numpoints; /* length of object */
+      msAddLine(shape, &line);
+      msFree(line.point);
+    } else if (type == 3) {
+      /* polygon */
+      shape->type = MS_SHAPE_LINE;
+
+      memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
+      /* add a line for each polygon ring */
+      offset += 9; /* now points at 1st linear ring */
+      for (u = 0; u < nrings; u++) {
+        /* for each ring, make a line */
+        memcpy(&npoints, &wkb[offset], 4);
+        line.numpoints = npoints;
+        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
+        /* point struct */
+        for (v = 0; v < npoints; v++) {
+          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
+          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
+        }
+        /* make offset point to next linear ring */
+        msAddLine(shape, &line);
+        msFree(line.point);
+        offset += 4 + 16 * npoints;
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/* point   -> reject */
+/* line    -> reject */
+/* polygon -> lines of linear rings */
+static int force_to_polygons(char *wkb, shapeObj *shape) {
+  int offset = 0;
+  int ngeoms;
+  int t, u, v;
+  int type, nrings, npoints;
+  lineObj line = {0, NULL};
+
+  shape->type = MS_SHAPE_NULL; /* nothing in it */
+
+  memcpy(&ngeoms, &wkb[5], 4);
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
+
+    if (type == 3) {
+      /* polygon */
+      shape->type = MS_SHAPE_POLYGON;
+
+      memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
+      /* add a line for each polygon ring */
+      offset += 9; /* now points at 1st linear ring */
+      for (u = 0; u < nrings; u++) {
+        /* for each ring, make a line */
+        memcpy(&npoints, &wkb[offset], 4); /* num points */
+        line.numpoints = npoints;
+        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
+        for (v = 0; v < npoints; v++) {
+          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
+          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
+        }
+        /* make offset point to next linear ring */
+        msAddLine(shape, &line);
+        msFree(line.point);
+        offset += 4 + 16 * npoints;
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/* if there is any polygon in wkb, return force_polygon */
+/* if there is any line in wkb, return force_line */
+/* otherwise return force_point */
+
+static int dont_force(char *wkb, shapeObj *shape) {
+  int offset = 0;
+  int ngeoms;
+  int type, t;
+  int best_type;
+
+  best_type = MS_SHAPE_NULL; /* nothing in it */
+
+  memcpy(&ngeoms, &wkb[5], 4);
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
+
+    if (type == 3) {
+      best_type = MS_SHAPE_POLYGON;
+    } else if (type == 2 && best_type != MS_SHAPE_POLYGON) {
+      best_type = MS_SHAPE_LINE;
+    } else if (type == 1 && best_type == MS_SHAPE_NULL) {
+      best_type = MS_SHAPE_POINT;
+    }
+  }
+
+  if (best_type == MS_SHAPE_POINT) {
+    return force_to_points(wkb, shape);
+  }
+  if (best_type == MS_SHAPE_LINE) {
+    return force_to_lines(wkb, shape);
+  }
+  if (best_type == MS_SHAPE_POLYGON) {
+    return force_to_polygons(wkb, shape);
+  }
+
+  return MS_FAILURE; /* unknown type */
+}
+
+#if 0
+/* ******************************************************* */
+/* wkb assumed to be same endian as this machine.  */
+/* Should be in little endian (default if created by Microsoft platforms) */
+/* ******************************************************* */
+/* convert the wkb into points */
+/* points -> pass through */
+/* lines->   constituent points */
+/* polys->   treat ring like line and pull out the consituent points */
+static int  force_to_shapeType(char *wkb, shapeObj *shape, int msShapeType)
+{
+  int     offset = 0;
+  int     ngeoms = 1;
+  int     u, v;
+  int     type, nrings, npoints;
+  lineObj line = {0, NULL};
+
+  shape->type = MS_SHAPE_NULL;  /* nothing in it */
+
+  do {
+    ngeoms--;
+
+    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
+
+    if (type == 1) {
+      /* Point */
+      shape->type = msShapeType;
+      line.numpoints = 1;
+      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj));
+
+      memcpy(&line.point[0].x, &wkb[offset + 5], 8);
+      memcpy(&line.point[0].y, &wkb[offset + 5 + 8], 8);
+      offset += 5 + 16;
+
+      if (msShapeType == MS_SHAPE_POINT) {
+        msAddLine(shape, &line);
+      }
+
+      msFree(line.point);
+    } else if(type == 2) {
+      /* Linestring */
+      shape->type = msShapeType;
+
+      memcpy(&line.numpoints, &wkb[offset+5], 4); /* num points */
+      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj) * line.numpoints);
+      for(u = 0; u < line.numpoints; u++) {
+        memcpy( &line.point[u].x, &wkb[offset+9 + (16 * u)], 8);
+        memcpy( &line.point[u].y, &wkb[offset+9 + (16 * u)+8], 8);
+      }
+      offset += 9 + 16 * line.numpoints;  /* length of object */
+
+      if ((msShapeType == MS_SHAPE_POINT) || (msShapeType == MS_SHAPE_LINE)) {
+        msAddLine(shape, &line);
+      }
+
+      msFree(line.point);
+    } else if(type == 3) {
+      /* Polygon */
+      shape->type = msShapeType;
+
+      memcpy(&nrings, &wkb[offset+5],4); /* num rings */
+      /* add a line for each polygon ring */
+      offset += 9; /* now points at 1st linear ring */
+      for(u = 0; u < nrings; u++) {
+        /* for each ring, make a line */
+        memcpy(&npoints, &wkb[offset], 4); /* num points */
+        line.numpoints = npoints;
+        line.point = (pointObj *) msSmallMalloc(sizeof(pointObj)* npoints);
+        /* point struct */
+        for(v = 0; v < npoints; v++) {
+          memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
+          memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
+        }
+        /* make offset point to next linear ring */
+        msAddLine(shape, &line);
+        msFree(line.point);
+        offset += 4 + 16 *npoints;
+      }
+    } else if(type >= 4 && type <= 7) {
+      int cnt = 0;
+
+      offset += 5;
+
+      memcpy(&cnt, &wkb[offset], 4);
+      offset += 4;  /* were the first geometry is */
+
+      ngeoms += cnt;
+    }
+  } while (ngeoms > 0);
+
+  return MS_SUCCESS;
+}
+#endif
+
+///* if there is any polygon in wkb, return force_polygon */
+///* if there is any line in wkb, return force_line */
+///* otherwise return force_point */
+// static int  dont_force(char *wkb, shapeObj *shape)
+//{
+//     int     offset =0;
+//     int     ngeoms = 1;
+//     int     type;
+//     int     best_type;
+//     int     u;
+//     int     nrings, npoints;
+//
+//     best_type = MS_SHAPE_NULL;  /* nothing in it */
+//
+//     do
+//     {
+//         ngeoms--;
+//
+//         memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
+//
+//         if(type == 3) {
+//             best_type = MS_SHAPE_POLYGON;
+//         } else if(type ==2 && best_type != MS_SHAPE_POLYGON) {
+//             best_type = MS_SHAPE_LINE;
+//         } else if(type == 1 && best_type == MS_SHAPE_NULL) {
+//             best_type = MS_SHAPE_POINT;
+//         }
+//
+//         if (type == 1)
+//         {
+//             /* Point */
+//             offset += 5 + 16;
+//         }
+//         else if(type == 2)
+//         {
+//             int numPoints;
+//
+//             memcpy(&numPoints, &wkb[offset+5], 4); /* num points */
+//             /* Linestring */
+//             offset += 9 + 16 * numPoints;  /* length of object */
+//         }
+//         else if(type == 3)
+//         {
+//             /* Polygon */
+//             memcpy(&nrings, &wkb[offset+5],4); /* num rings */
+//             offset += 9; /* now points at 1st linear ring */
+//             for(u = 0; u < nrings; u++) {
+//                 /* for each ring, make a line */
+//                 memcpy(&npoints, &wkb[offset], 4); /* num points */
+//                 offset += 4 + 16 *npoints;
+//             }
+//         }
+//         else if(type >= 4 && type <= 7)
+//         {
+//             int cnt = 0;
+//
+//             offset += 5;
+//
+//             memcpy(&cnt, &wkb[offset], 4);
+//             offset += 4;  /* were the first geometry is */
+//
+//             ngeoms += cnt;
+//         }
+//     }
+//     while (ngeoms > 0);
+//
+//     return force_to_shapeType(wkb, shape, best_type);
+// }
+//
+/* find the bounds of the shape */
+static void find_bounds(shapeObj *shape) {
+  int t, u;
+  int first_one = 1;
+
+  for (t = 0; t < shape->numlines; t++) {
+    for (u = 0; u < shape->line[t].numpoints; u++) {
+      if (first_one) {
+        shape->bounds.minx = shape->line[t].point[u].x;
+        shape->bounds.maxx = shape->line[t].point[u].x;
+
+        shape->bounds.miny = shape->line[t].point[u].y;
+        shape->bounds.maxy = shape->line[t].point[u].y;
+        first_one = 0;
+      } else {
+        if (shape->line[t].point[u].x < shape->bounds.minx) {
+          shape->bounds.minx = shape->line[t].point[u].x;
+        }
+        if (shape->line[t].point[u].x > shape->bounds.maxx) {
+          shape->bounds.maxx = shape->line[t].point[u].x;
+        }
+
+        if (shape->line[t].point[u].y < shape->bounds.miny) {
+          shape->bounds.miny = shape->line[t].point[u].y;
+        }
+        if (shape->line[t].point[u].y > shape->bounds.maxy) {
+          shape->bounds.maxy = shape->line[t].point[u].y;
+        }
+      }
+    }
+  }
+}
+
+/* Used by NextShape() to access a shape in the query set */
+int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape,
+                                   long *record) {
+  msMSSQL2008LayerInfo *layerinfo;
+  SQLLEN needLen = 0;
+  SQLLEN retLen = 0;
+  char dummyBuffer[1];
+  char *wkbBuffer;
+  char *valueBuffer;
+  char oidBuffer[16]; /* assuming the OID will always be a long this should be
+                         enough */
+  long record_oid;
+  int t;
+
+  /* for coercing single types into geometry collections */
+  char *wkbTemp;
+  int geomType;
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "GetShape called with layerinfo = NULL",
+               "msMSSQL2008LayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  if (!layerinfo->conn) {
+    msSetError(MS_QUERYERR,
+               "NextShape called on MSSQL2008 layer with no connection to DB.",
+               "msMSSQL2008LayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  shape->type = MS_SHAPE_NULL;
+
+  while (shape->type == MS_SHAPE_NULL) {
+    /* SQLRETURN rc = SQLFetchScroll(layerinfo->conn->hstmt, SQL_FETCH_ABSOLUTE,
+     * (SQLLEN) (*record) + 1); */
+
+    /* We only do forward fetches. the parameter 'record' is ignored, but is
+     * incremented */
+    SQLRETURN rc = SQLFetch(layerinfo->conn->hstmt);
+
+    /* Any error assume out of recordset bounds */
+    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+      handleSQLError(layer);
+      return MS_DONE;
+    }
+
+    /* retreive an item */
+
+    {
+      /* have to retrieve shape attributes */
+      shape->values = (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
+      shape->numvalues = layer->numitems;
+
+      for (t = 0; t < layer->numitems; t++) {
+        /* Startwith a 64 character long buffer. This may need to be increased
+         * after calling SQLGetData. */
+        SQLLEN emptyLen = 64;
+        valueBuffer = (char *)msSmallMalloc(emptyLen);
+        if (valueBuffer == NULL) {
+          msSetError(MS_QUERYERR, "Could not allocate value buffer.",
+                     "msMSSQL2008LayerGetShapeRandom()");
+          return MS_FAILURE;
+        }
+
+#ifdef USE_ICONV
+        SQLSMALLINT targetType = SQL_WCHAR;
+#else
+        SQLSMALLINT targetType = SQL_CHAR;
+#endif
+        SQLLEN totalLen = 0;
+        char *bufferLocation = valueBuffer;
+        int r = 0;
+        while (r < 20) {
+          rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(t + 1),
+                          targetType, bufferLocation, emptyLen, &retLen);
+
+          if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO)
+            totalLen +=
+                retLen > emptyLen || retLen == SQL_NO_TOTAL ? emptyLen : retLen;
+
+          if (rc == SQL_SUCCESS_WITH_INFO && rc != SQL_NO_DATA) {
+            /* We must compensate for the last null termination that SQLGetData
+             * include */
+            /* If we get SQL_NO_TOTAL we do not know how big buffer we need so
+             * we increase it with 512. */
+#ifdef USE_ICONV
+            totalLen -= sizeof(wchar_t);
+            emptyLen = retLen != SQL_NO_TOTAL
+                           ? retLen - emptyLen + 2 * sizeof(wchar_t)
+                           : 512;
+#else
+            totalLen -= sizeof(char);
+            emptyLen = retLen != SQL_NO_TOTAL
+                           ? retLen - emptyLen + 2 * sizeof(char)
+                           : 512;
+#endif
+
+            valueBuffer =
+                (char *)msSmallRealloc(valueBuffer, totalLen + emptyLen);
+            bufferLocation = valueBuffer + totalLen;
+          } else
+            break;
+
+          r++;
+        }
+
+        if (rc == SQL_ERROR)
+          handleSQLError(layer);
+
+        if (totalLen > 0) {
+          /* Pop the value into the shape's value array */
+#ifdef USE_ICONV
+          shape->values[t] =
+              msConvertWideStringToUTF8((wchar_t *)valueBuffer, "UCS-2LE");
+          msFree(valueBuffer);
+#else
+          shape->values[t] = valueBuffer;
+#endif
+        } else {
+          /* Copy empty sting for NULL values */
+          shape->values[t] = msStrdup("");
+          msFree(valueBuffer);
+        }
+      }
+
+      /* Get shape geometry */
+      {
+        /* Set up to request the size of the buffer needed */
+        rc = SQLGetData(layerinfo->conn->hstmt,
+                        (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY,
+                        dummyBuffer, 0, &needLen);
+        if (rc == SQL_ERROR)
+          handleSQLError(layer);
+
+        /* allow space for coercion to geometry collection if needed*/
+        wkbTemp = (char *)msSmallMalloc(needLen + 9);
+
+        /* write data above space allocated for geometry collection coercion */
+        wkbBuffer = wkbTemp + 9;
+
+        if (wkbBuffer == NULL) {
+          msSetError(MS_QUERYERR, "Could not allocate value buffer.",
+                     "msMSSQL2008LayerGetShapeRandom()");
+          return MS_FAILURE;
+        }
+
+        /* Grab the WKB */
+        rc = SQLGetData(layerinfo->conn->hstmt,
+                        (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY,
+                        wkbBuffer, needLen, &retLen);
+        if (rc == SQL_ERROR || rc == SQL_SUCCESS_WITH_INFO)
+          handleSQLError(layer);
+
+        if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE) {
+          layerinfo->gpi.pszData = (unsigned char *)wkbBuffer;
+          layerinfo->gpi.nLen = (int)retLen;
+
+          if (!ParseSqlGeometry(layerinfo, shape)) {
+            switch (layer->type) {
+            case MS_LAYER_POINT:
+              shape->type = MS_SHAPE_POINT;
+              break;
+
+            case MS_LAYER_LINE:
+              shape->type = MS_SHAPE_LINE;
+              break;
+
+            case MS_LAYER_POLYGON:
+              shape->type = MS_SHAPE_POLYGON;
+              break;
+
+            default:
+              break;
+            }
+          }
+        } else {
+          memcpy(&geomType, wkbBuffer + 1, 4);
+
+          /* is this a single type? */
+          if (geomType < 4) {
+            /* copy byte order marker (although we don't check it) */
+            wkbTemp[0] = wkbBuffer[0];
+            wkbBuffer = wkbTemp;
+
+            /* indicate type is geometry collection (although geomType + 3 would
+             * also work) */
+            wkbBuffer[1] = (char)7;
+            wkbBuffer[2] = (char)0;
+            wkbBuffer[3] = (char)0;
+            wkbBuffer[4] = (char)0;
+
+            /* indicate 1 shape */
+            wkbBuffer[5] = (char)1;
+            wkbBuffer[6] = (char)0;
+            wkbBuffer[7] = (char)0;
+            wkbBuffer[8] = (char)0;
+          }
+
+          switch (layer->type) {
+          case MS_LAYER_POINT:
+            /*result =*/force_to_points(wkbBuffer, shape);
+            break;
+
+          case MS_LAYER_LINE:
+            /*result =*/force_to_lines(wkbBuffer, shape);
+            break;
+
+          case MS_LAYER_POLYGON:
+            /*result =*/force_to_polygons(wkbBuffer, shape);
+            break;
+
+          case MS_LAYER_QUERY:
+          case MS_LAYER_CHART:
+            /*result =*/dont_force(wkbBuffer, shape);
+            break;
+
+          case MS_LAYER_RASTER:
+            msDebug("Ignoring MS_LAYER_RASTER in mapMSSQL2008.c\n");
+            break;
+
+          case MS_LAYER_CIRCLE:
+            msDebug("Ignoring MS_LAYER_CIRCLE in mapMSSQL2008.c\n");
+            break;
+
+          default:
+            msDebug("Unsupported layer type in msMSSQL2008LayerNextShape()!");
+            break;
+          }
+          find_bounds(shape);
+        }
+
+        // free(wkbBuffer);
+        msFree(wkbTemp);
+      }
+
+      /* Next get unique id for row - since the OID shouldn't be larger than a
+       * long we'll assume billions as a limit */
+      rc = SQLGetData(layerinfo->conn->hstmt,
+                      (SQLUSMALLINT)(layer->numitems + 2), SQL_C_BINARY,
+                      oidBuffer, sizeof(oidBuffer) - 1, &retLen);
+      if (rc == SQL_ERROR || rc == SQL_SUCCESS_WITH_INFO)
+        handleSQLError(layer);
+
+      if (retLen < (int)sizeof(oidBuffer)) {
+        oidBuffer[retLen] = 0;
+        record_oid = strtol(oidBuffer, NULL, 10);
+        shape->index = record_oid;
+      } else {
+        /* non integer fid column, use single pass */
+        shape->index = -1;
+      }
+
+      shape->resultindex = (*record);
+
+      (*record)++; /* move to next shape */
+
+      if (shape->type != MS_SHAPE_NULL) {
+        return MS_SUCCESS;
+      } else {
+        msDebug("msMSSQL2008LayerGetShapeRandom bad shape: %ld\n", *record);
+      }
+      /* if (layer->type == MS_LAYER_POINT) {return MS_DONE;} */
+    }
+  }
+
+  msFreeShape(shape);
+
+  return MS_FAILURE;
+}
+
+/* find the next shape with the appropriate shape type (convert it if necessary)
+ */
+/* also, load in the attribute data */
+/* MS_DONE => no more data */
+int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape) {
+  int result;
+
+  msMSSQL2008LayerInfo *layerinfo;
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "NextShape called with layerinfo = NULL",
+               "msMSSQL2008LayerNextShape()");
+    return MS_FAILURE;
+  }
+
+  result = msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num));
+  /* getshaperandom will increment the row_num */
+  /* layerinfo->row_num   ++; */
+
+  return result;
+}
+
+/* Execute a query on the DB based on the query result. */
+int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape,
+                             resultObj *record) {
+  char *query_str;
+  char *columns_wanted = 0;
+
+  msMSSQL2008LayerInfo *layerinfo;
+  int t;
+  char buffer[32000] = "";
+  long shapeindex = record->shapeindex;
+  long resultindex = record->resultindex;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetShape called for shapeindex = %ld\n",
+            shapeindex);
+  }
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    /* Layer not open */
+    msSetError(
+        MS_QUERYERR,
+        "msMSSQL2008LayerGetShape called on unopened layer (layerinfo = NULL)",
+        "msMSSQL2008LayerGetShape()");
+
+    return MS_FAILURE;
+  }
+
+  if (resultindex >= 0 && layerinfo->sql) {
+    /* trying to provide the result from the current resultset (single-pass
+     * query) */
+    if (resultindex < layerinfo->row_num) {
+      /* re-issue the query */
+      if (!executeSQL(layerinfo->conn, layerinfo->sql)) {
+        msSetError(MS_QUERYERR,
+                   "Error executing MSSQL2008 SQL statement: %s\n-%s\n",
+                   "msMSSQL2008LayerGetShape()", layerinfo->sql,
+                   layerinfo->conn->errorMessage);
+
+        return MS_FAILURE;
+      }
+      layerinfo->row_num = 0;
+    }
+    while (layerinfo->row_num < resultindex) {
+      /* move forward until we reach the desired index */
+      if (msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num)) !=
+          MS_SUCCESS)
+        return MS_FAILURE;
+    }
+
+    return msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num));
+  }
+
+  /* non single-pass case, fetch the record from the database */
+
+  if (layer->numitems == 0) {
+    if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
+      snprintf(buffer, sizeof(buffer), "%s, convert(varchar(36), %s)",
+               layerinfo->geom_column, layerinfo->urid_name);
+    else
+      snprintf(buffer, sizeof(buffer),
+               "%s.STAsBinary(), convert(varchar(36), %s)",
+               layerinfo->geom_column, layerinfo->urid_name);
+    columns_wanted = msStrdup(buffer);
+  } else {
+    for (t = 0; t < layer->numitems; t++) {
+      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer),
+               "convert(varchar(max), %s),", layer->items[t]);
+    }
+
+    if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
+      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer),
+               "%s, convert(varchar(36), %s)", layerinfo->geom_column,
+               layerinfo->urid_name);
+    else
+      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer),
+               "%s.STAsBinary(), convert(varchar(36), %s)",
+               layerinfo->geom_column, layerinfo->urid_name);
+
+    columns_wanted = msStrdup(buffer);
+  }
+
+  /* index_name is ignored here since the hint should be for the spatial index,
+   * not the PK index */
+  snprintf(buffer, sizeof(buffer), "select %s from %s where %s = %ld",
+           columns_wanted, layerinfo->geom_table, layerinfo->urid_name,
+           shapeindex);
+
+  query_str = msStrdup(buffer);
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetShape: %s \n", query_str);
+  }
+
+  msFree(columns_wanted);
+
+  if (!executeSQL(layerinfo->conn, query_str)) {
+    msSetError(
+        MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n",
+        "msMSSQL2008LayerGetShape()", query_str, layerinfo->conn->errorMessage);
+
+    msFree(query_str);
+
+    return MS_FAILURE;
+  }
+
+  /* we don't preserve the query string in this case (cannot be re-used) */
+  msFree(query_str);
+  layerinfo->row_num = 0;
+
+  return msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num));
+}
+
+/*
+** Returns the number of shapes that match the potential filter and extent.
+* rectProjection is the projection in which rect is expressed, or can be NULL if
+* rect should be considered in the layer projection.
+* This should be equivalent to calling msLayerWhichShapes() and counting the
+* number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
+* limitation if layer->maxfeatures>=0, and honouring layer->startindex if
+* layer->startindex >= 1 and paging is enabled.
+* Returns -1 in case of failure.
+*/
+int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect,
+                                  projectionObj *rectProjection) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *query = 0;
+  char result_data[256];
+  char box3d[40 + 10 * 22 + 11];
+  SQLLEN retLen;
+  SQLRETURN rc;
+  int hasFilter = MS_FALSE;
+  const rectObj rectInvalid = MS_INIT_INVALID_RECT;
+  const int bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
+
+  rectObj searchrectInLayerProj = rect;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetShapeCount called.\n");
+  }
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    /* Layer not open */
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerGetShapeCount called on unopened layer "
+               "(layerinfo = NULL)",
+               "msMSSQL2008LayerGetShapeCount()");
+
+    return MS_FAILURE;
+  }
+
+  // Special processing if the specified projection for the rect is different
+  // from the layer projection We want to issue a WHERE that includes
+  // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT
+  // ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
+  if (rectProjection != NULL && layer->project &&
+      msProjectionsDiffer(&(layer->projection), rectProjection)) {
+    // If we cannot guess the EPSG code of the rectProjection, fallback on slow
+    // implementation
+    if (rectProjection->numargs < 1 ||
+        strncasecmp(rectProjection->args[0],
+                    "init=epsg:", (int)strlen("init=epsg:")) != 0) {
+      if (layer->debug) {
+        msDebug("msMSSQL2008LayerGetShapeCount(): cannot find EPSG code of "
+                "rectProjection. Falling back on client-side feature count.\n");
+      }
+      return LayerDefaultGetShapeCount(layer, rect, rectProjection);
+    }
+
+    // Reproject the passed rect into the layer projection and get
+    // the SRID from the rectProjection
+    msProjectRect(
+        rectProjection, &(layer->projection),
+        &searchrectInLayerProj); /* project the searchrect to source coords */
+  }
+
+  if (searchrectInLayerProj.minx == searchrectInLayerProj.maxx ||
+      searchrectInLayerProj.miny == searchrectInLayerProj.maxy) {
+    /* create point shape for rectangles with zero area */
+    snprintf(box3d, sizeof(box3d),
+             "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
+             layerinfo->geom_column_type, searchrectInLayerProj.minx,
+             searchrectInLayerProj.miny, layerinfo->user_srid);
+  } else {
+    snprintf(box3d, sizeof(box3d),
+             "%s::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g "
+             "%.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
+             layerinfo->geom_column_type, searchrectInLayerProj.minx,
+             searchrectInLayerProj.miny, searchrectInLayerProj.maxx,
+             searchrectInLayerProj.miny, searchrectInLayerProj.maxx,
+             searchrectInLayerProj.maxy, searchrectInLayerProj.minx,
+             searchrectInLayerProj.maxy, searchrectInLayerProj.minx,
+             searchrectInLayerProj.miny, layerinfo->user_srid);
+  }
+
+  msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
+
+  /* set up statement */
+  query = msStringConcatenate(query, "SELECT count(*) FROM ");
+  query = msStringConcatenate(query, layerinfo->geom_table);
+
+  /* adding attribute filter */
+  hasFilter = addFilter(layer, &query);
+
+  if (bIsValidRect) {
+    /* adding spatial filter */
+    if (hasFilter == MS_FALSE)
+      query = msStringConcatenate(query, " WHERE ");
+    else
+      query = msStringConcatenate(query, " AND ");
+
+    query = msStringConcatenate(query, layerinfo->geom_column);
+    query = msStringConcatenate(query, ".STIntersects(");
+    query = msStringConcatenate(query, box3d);
+    query = msStringConcatenate(query, ") = 1 ");
+  }
+
+  if (layer->debug) {
+    msDebug("query:%s\n", query);
+  }
+
+  if (!executeSQL(layerinfo->conn, query)) {
+    msFree(query);
+    return -1;
+  }
+
+  msFree(query);
+
+  rc = SQLFetch(layerinfo->conn->hstmt);
+
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (layer->debug) {
+      msDebug("msMSSQL2008LayerGetShapeCount: No results found.\n");
+    }
+
+    return -1;
+  }
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+
+  if (rc == SQL_ERROR) {
+    msSetError(MS_QUERYERR, "Failed to get feature count",
+               "msMSSQL2008LayerGetShapeCount()");
+    return -1;
+  }
+
+  result_data[retLen] = 0;
+
+  return atoi(result_data);
+}
+
+/* Query the DB for info about the requested table */
+int msMSSQL2008LayerGetItems(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *sql = NULL;
+  size_t sqlSize;
+  char found_geom = 0;
+  int t, item_num;
+  SQLSMALLINT cols = 0;
+  const char *value;
+  /*
+   * Pass the field definitions through to the layer metadata in the
+   * "gml_[item]_{type,width,precision}" set of metadata items for
+   * defining fields.
+   */
+  char pass_field_def = 0;
+
+  if (layer->debug) {
+    msDebug("in msMSSQL2008LayerGetItems  (find column names)\n");
+  }
+
+  layerinfo = getMSSQL2008LayerInfo(layer);
+
+  if (!layerinfo) {
+    /* layer not opened yet */
+    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called on unopened layer",
+               "msMSSQL2008LayerGetItems()");
+
+    return MS_FAILURE;
+  }
+
+  if (!layerinfo->conn) {
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerGetItems called on MSSQL2008 layer with no "
+               "connection to DB.",
+               "msMSSQL2008LayerGetItems()");
+
+    return MS_FAILURE;
+  }
+
+  sqlSize = strlen(layerinfo->geom_table) + 30;
+  sql = msSmallMalloc(sizeof(char *) * sqlSize);
+
+  snprintf(sql, sqlSize, "SELECT top 0 * FROM %s", layerinfo->geom_table);
+
+  if (!executeSQL(layerinfo->conn, sql)) {
+    msFree(sql);
+    return MS_FAILURE;
+  }
+
+  msFree(sql);
+
+  SQLNumResultCols(layerinfo->conn->hstmt, &cols);
+
+  layer->numitems = cols - 1; /* dont include the geometry column */
+
+  layer->items = msSmallMalloc(
+      sizeof(char *) *
+      (layer->numitems +
+       1)); /* +1 in case there is a problem finding goeometry column */
+  layerinfo->itemtypes =
+      msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
+  /* it will return an error if there is no geometry column found, */
+  /* so this isnt a problem */
+
+  found_geom = 0; /* havent found the geom field */
+  item_num = 0;
+
+  /* consider populating the field definitions in metadata */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    pass_field_def = 1;
+
+  for (t = 0; t < cols; t++) {
+    char colBuff[256];
+    SQLSMALLINT itemType = 0;
+
+    columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer,
+               pass_field_def, &itemType);
+
+    if (strcmp(colBuff, layerinfo->geom_column) != 0) {
+      /* this isnt the geometry column */
+      layer->items[item_num] = (char *)msSmallMalloc(strlen(colBuff) + 1);
+      strcpy(layer->items[item_num], colBuff);
+      layerinfo->itemtypes[item_num] = itemType;
+      item_num++;
+    } else {
+      found_geom = 1;
+    }
+  }
+
+  if (!found_geom) {
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerGetItems: tried to find the geometry column in "
+               "the results from the database, but couldnt find it.  Is it "
+               "miss-capitialized? '%s'",
+               "msMSSQL2008LayerGetItems()", layerinfo->geom_column);
+    return MS_FAILURE;
+  }
+
+  return msMSSQL2008LayerInitItemInfo(layer);
+}
+
+/* Get primary key column of table */
+int msMSSQL2008LayerRetrievePK(layerObj *layer, char **urid_name,
+                               char *table_name, int debug) {
+
+  char sql[1024];
+  msMSSQL2008LayerInfo *layerinfo = 0;
+  SQLRETURN rc;
+
+  snprintf(sql, sizeof(sql),
+           "SELECT     convert(varchar(50), sys.columns.name) AS ColumnName, "
+           "sys.indexes.name "
+           "FROM         sys.columns INNER JOIN "
+           "                     sys.indexes INNER JOIN "
+           "                     sys.tables ON sys.indexes.object_id = "
+           "sys.tables.object_id INNER JOIN "
+           "                     sys.index_columns ON sys.indexes.object_id = "
+           "sys.index_columns.object_id AND sys.indexes.index_id = "
+           "sys.index_columns.index_id ON "
+           "                     sys.columns.object_id = "
+           "sys.index_columns.object_id AND sys.columns.column_id = "
+           "sys.index_columns.column_id "
+           "WHERE     (sys.indexes.is_primary_key = 1) AND (sys.tables.name = "
+           "N'%s') ",
+           table_name);
+
+  if (debug) {
+    msDebug("msMSSQL2008LayerRetrievePK: query = %s\n", sql);
+  }
+
+  layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
+
+  if (layerinfo->conn == NULL) {
+
+    msSetError(MS_QUERYERR, "Layer does not have a MSSQL2008 connection.",
+               "msMSSQL2008LayerRetrievePK()");
+
+    return (MS_FAILURE);
+  }
+
+  /* error somewhere above here in this method */
+
+  if (!executeSQL(layerinfo->conn, sql)) {
+    char *tmp1;
+    char *tmp2 = NULL;
+
+    tmp1 = "Error executing MSSQL2008 statement (msMSSQL2008LayerRetrievePK():";
+    tmp2 =
+        (char *)msSmallMalloc(sizeof(char) * (strlen(tmp1) + strlen(sql) + 1));
+    strcpy(tmp2, tmp1);
+    strcat(tmp2, sql);
+    msSetError(MS_QUERYERR, "%s", "msMSSQL2008LayerRetrievePK()", tmp2);
+    msFree(tmp2);
+    return (MS_FAILURE);
+  }
+
+  rc = SQLFetch(layerinfo->conn->hstmt);
+
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (debug) {
+      msDebug("msMSSQL2008LayerRetrievePK: No results found.\n");
+    }
+
+    return MS_FAILURE;
+  }
+
+  {
+    char buff[100];
+    SQLLEN retLen;
+    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_BINARY, buff, sizeof(buff),
+                    &retLen);
+
+    rc = SQLFetch(layerinfo->conn->hstmt);
+
+    if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
+      if (debug) {
+        msDebug("msMSSQL2008LayerRetrievePK: Multiple primary key columns are "
+                "not supported in MapServer\n");
+      }
+
+      return MS_FAILURE;
+    }
+
+    buff[retLen] = 0;
+
+    *urid_name = msStrdup(buff);
+  }
+
+  return MS_SUCCESS;
+}
+
+/* Function to parse the Mapserver DATA parameter for geometry
+ * column name, table name and name of a column to serve as a
+ * unique record id
+ */
+static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name,
+                                     char **geom_column_type, char **table_name,
+                                     char **urid_name, char **user_srid,
+                                     char **index_name, char **sort_spec,
+                                     int debug) {
+  char *pos_opt, *pos_scn, *tmp, *pos_srid, *pos_urid, *pos_geomtype,
+      *pos_geomtype2, *pos_indexHint, *data, *pos_order;
+  size_t slength;
+
+  data = msStrdup(layer->data);
+  /* replace tabs with spaces */
+  msReplaceChar(data, '\t', ' ');
+
+  /* given a string of the from 'geom from ctivalues' or 'geom from () as foo'
+   * return geom_column_name as 'geom'
+   * and table name as 'ctivalues' or 'geom from () as foo'
+   */
+
+  /* First look for the optional ' using unique ID' string */
+  pos_urid = strstrIgnoreCase(data, " using unique ");
+
+  if (pos_urid) {
+    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id
+     * using srid=33' */
+    tmp = strstr(pos_urid + 14, " ");
+    if (!tmp) {
+      tmp = pos_urid + strlen(pos_urid);
+    }
+    *urid_name = (char *)msSmallMalloc((tmp - (pos_urid + 14)) + 1);
+    strlcpy(*urid_name, pos_urid + 14, (tmp - (pos_urid + 14)) + 1);
+  }
+
+  /* Find the srid */
+  pos_srid = strstrIgnoreCase(data, " using SRID=");
+  if (!pos_srid) {
+    *user_srid = (char *)msSmallMalloc(2);
+    (*user_srid)[0] = '0';
+    (*user_srid)[1] = 0;
+  } else {
+    slength = strspn(pos_srid + 12, "-0123456789");
+    if (!slength) {
+      msSetError(
+          MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+          "Error parsing MSSQL2008 data variable: You specified 'using SRID=#' "
+          "but didn't have any numbers!<br><br>\n\nMore Help:<br><br>\n\n",
+          data);
+
+      msFree(data);
+      return MS_FAILURE;
+    } else {
+      *user_srid = (char *)msSmallMalloc(slength + 1);
+      strlcpy(*user_srid, pos_srid + 12, slength + 1);
+    }
+  }
+
+  pos_indexHint = strstrIgnoreCase(data, " using index ");
+  if (pos_indexHint) {
+    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id
+     * using srid=33' */
+    tmp = strstr(pos_indexHint + 13, " ");
+    if (!tmp) {
+      tmp = pos_indexHint + strlen(pos_indexHint);
+    }
+    *index_name = (char *)msSmallMalloc((tmp - (pos_indexHint + 13)) + 1);
+    strlcpy(*index_name, pos_indexHint + 13, tmp - (pos_indexHint + 13) + 1);
+  }
+
+  /* this is a little hack so the rest of the code works.  If the ' using SRID='
+   * comes before */
+  /* the ' using unique ', then make sure pos_opt points to where the ' using
+   * SRID' starts! */
+  pos_opt = pos_urid;
+  if (!pos_opt || (pos_srid && pos_srid < pos_opt))
+    pos_opt = pos_srid;
+  if (!pos_opt || (pos_indexHint && pos_indexHint < pos_opt))
+    pos_opt = pos_indexHint;
+  if (!pos_opt)
+    pos_opt = data + strlen(data);
+
+  /* Scan for the table or sub-select clause */
+  pos_scn = strstrIgnoreCase(data, " from ");
+  if (!pos_scn) {
+    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+               "Error parsing MSSQL2008 data variable.  Must contain "
+               "'geometry_column from table_name' or 'geom from (subselect) as "
+               "foo' (couldn't find ' from ').  More help: <br><br>\n\n",
+               data);
+
+    msFree(data);
+    return MS_FAILURE;
+  }
+
+  /* Scanning the geometry column type */
+  pos_geomtype = data;
+  while (pos_geomtype < pos_scn && *pos_geomtype != '(' && *pos_geomtype != 0)
+    ++pos_geomtype;
+
+  if (*pos_geomtype == '(') {
+    pos_geomtype2 = pos_geomtype;
+    while (pos_geomtype2 < pos_scn && *pos_geomtype2 != ')' &&
+           *pos_geomtype2 != 0)
+      ++pos_geomtype2;
+    if (*pos_geomtype2 != ')' || pos_geomtype2 == pos_geomtype) {
+      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+                 "Error parsing MSSQL2008 data variable.  Invalid syntax near "
+                 "geometry column type.",
+                 data);
+      msFree(data);
+      return MS_FAILURE;
+    }
+
+    *geom_column_name = (char *)msSmallMalloc((pos_geomtype - data) + 1);
+    strlcpy(*geom_column_name, data, pos_geomtype - data + 1);
+
+    *geom_column_type = (char *)msSmallMalloc(pos_geomtype2 - pos_geomtype);
+    strlcpy(*geom_column_type, pos_geomtype + 1, pos_geomtype2 - pos_geomtype);
+  } else {
+    /* Copy the geometry column name */
+    *geom_column_name = (char *)msSmallMalloc((pos_scn - data) + 1);
+    strlcpy(*geom_column_name, data, pos_scn - data + 1);
+    *geom_column_type = msStrdup("geometry");
+  }
+
+  /* Copy out the table name or sub-select clause */
+  *table_name = (char *)msSmallMalloc((pos_opt - (pos_scn + 6)) + 1);
+  strlcpy(*table_name, pos_scn + 6, pos_opt - (pos_scn + 6) + 1);
+
+  if (strlen(*table_name) < 1 || strlen(*geom_column_name) < 1) {
+    msSetError(
+        MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+        "Error parsing MSSQL2008 data variable.  Must contain 'geometry_column "
+        "from table_name' or 'geom from (subselect) as foo' (couldnt find a "
+        "geometry_column or table/subselect).  More help: <br><br>\n\n",
+        data);
+
+    msFree(data);
+    return MS_FAILURE;
+  }
+
+  if (!pos_urid) {
+    if (msMSSQL2008LayerRetrievePK(layer, urid_name, *table_name, debug) !=
+        MS_SUCCESS) {
+      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+                 "No primary key defined for table, or primary key contains "
+                 "more that one column\n\n",
+                 *table_name);
+
+      msFree(data);
+      return MS_FAILURE;
+    }
+  }
+
+  /* Find the order by */
+  pos_order = strstrIgnoreCase(pos_opt, " order by ");
+
+  if (pos_order) {
+    *sort_spec = msStrdup(pos_order);
+  }
+
+  if (debug) {
+    msDebug("msMSSQL2008LayerParseData: unique column = %s, srid='%s', "
+            "geom_column_name = %s, table_name=%s\n",
+            *urid_name, *user_srid, *geom_column_name, *table_name);
+  }
+
+  msFree(data);
+  return MS_SUCCESS;
+}
+
+char *msMSSQL2008LayerEscapePropertyName(layerObj *layer,
+                                         const char *pszString) {
+  (void)layer;
+  char *pszEscapedStr = NULL;
+  int j = 0;
+
+  if (pszString && strlen(pszString) > 0) {
+    size_t nLength = strlen(pszString);
+
+    pszEscapedStr = (char *)msSmallMalloc(1 + nLength + 1 + 1);
+    pszEscapedStr[j++] = '[';
+
+    for (size_t i = 0; i < nLength; i++)
+      pszEscapedStr[j++] = pszString[i];
+
+    pszEscapedStr[j++] = ']';
+    pszEscapedStr[j++] = 0;
+  }
+  return pszEscapedStr;
+}
+
+char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString) {
+  (void)layer;
+  char *pszEscapedStr = NULL;
+  if (pszString) {
+    int nSrcLen;
+    char c;
+    int i = 0, j = 0;
+    nSrcLen = (int)strlen(pszString);
+    pszEscapedStr = (char *)msSmallMalloc(2 * nSrcLen + 1);
+    for (i = 0, j = 0; i < nSrcLen; i++) {
+      c = pszString[i];
+      if (c == '\'') {
+        pszEscapedStr[j++] = '\'';
+        pszEscapedStr[j++] = '\'';
+      } else
+        pszEscapedStr[j++] = c;
+    }
+    pszEscapedStr[j] = 0;
+  }
+  return pszEscapedStr;
+}
+
+int msMSSQL2008GetPaging(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo = NULL;
+
+  if (!msMSSQL2008LayerIsOpen(layer))
+    return MS_TRUE;
+
+  assert(layer->layerinfo != NULL);
+  layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
+
+  return layerinfo->paging;
+}
+
+void msMSSQL2008EnablePaging(layerObj *layer, int value) {
+  msMSSQL2008LayerInfo *layerinfo = NULL;
+
+  if (!msMSSQL2008LayerIsOpen(layer)) {
+    if (msMSSQL2008LayerOpen(layer) != MS_SUCCESS) {
+      return;
+    }
+  }
+
+  assert(layer->layerinfo != NULL);
+  layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
+
+  layerinfo->paging = value;
+}
+
+int process_node(layerObj *layer, expressionObj *filter) {
+  char *snippet = NULL;
+  char *strtmpl = NULL;
+  char *stresc = NULL;
+  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
+
+  if (!layerinfo->current_node) {
+    msSetError(MS_MISCERR, "Unecpected end of expression",
+               "msMSSQL2008LayerTranslateFilter()");
+    return 0;
+  }
+
+  switch (layerinfo->current_node->token) {
+  case '(':
+    filter->native_string = msStringConcatenate(filter->native_string, "(");
+    /* process subexpression */
+    layerinfo->current_node = layerinfo->current_node->next;
+    while (layerinfo->current_node != NULL) {
+      if (!process_node(layer, filter))
+        return 0;
+      if (!layerinfo->current_node)
+        break;
+      if (layerinfo->current_node->token == ')')
+        break;
+      layerinfo->current_node = layerinfo->current_node->next;
+    }
+    break;
+  case ')':
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
+  /* argument separator */
+  case ',':
+    break;
+  /* literal tokens */
+  case MS_TOKEN_LITERAL_BOOLEAN:
+    if (layerinfo->current_node->tokenval.dblval == MS_TRUE)
+      filter->native_string = msStringConcatenate(filter->native_string, "1");
+    else
+      filter->native_string = msStringConcatenate(filter->native_string, "0");
+    break;
+  case MS_TOKEN_LITERAL_NUMBER: {
+    char buffer[32];
+    snprintf(buffer, sizeof(buffer), "%.18g",
+             layerinfo->current_node->tokenval.dblval);
+    filter->native_string = msStringConcatenate(filter->native_string, buffer);
+    break;
+  }
+  case MS_TOKEN_LITERAL_STRING:
+    strtmpl = "'%s'";
+    stresc = msMSSQL2008LayerEscapeSQLParam(
+        layer, layerinfo->current_node->tokenval.strval);
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(stresc));
+    sprintf(snippet, strtmpl, stresc);
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(snippet);
+    msFree(stresc);
+    break;
+  case MS_TOKEN_LITERAL_TIME: {
+    int resolution = msTimeGetResolution(layerinfo->current_node->tokensrc);
+    snippet = (char *)msSmallMalloc(128);
+    switch (resolution) {
+    case TIME_RESOLUTION_YEAR:
+      sprintf(snippet, "'%d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900));
+      break;
+    case TIME_RESOLUTION_MONTH:
+      sprintf(snippet, "'%d-%02d-01'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1));
+      break;
+    case TIME_RESOLUTION_DAY:
+      sprintf(snippet, "'%d-%02d-%02d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday);
+      break;
+    case TIME_RESOLUTION_HOUR:
+      sprintf(snippet, "'%d-%02d-%02d %02d:00'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday,
+              layerinfo->current_node->tokenval.tmval.tm_hour);
+      break;
+    case TIME_RESOLUTION_MINUTE:
+      sprintf(snippet, "%d-%02d-%02d %02d:%02d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday,
+              layerinfo->current_node->tokenval.tmval.tm_hour,
+              layerinfo->current_node->tokenval.tmval.tm_min);
+      break;
+    case TIME_RESOLUTION_SECOND:
+      sprintf(snippet, "'%d-%02d-%02d %02d:%02d:%02d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday,
+              layerinfo->current_node->tokenval.tmval.tm_hour,
+              layerinfo->current_node->tokenval.tmval.tm_min,
+              layerinfo->current_node->tokenval.tmval.tm_sec);
+      break;
+    }
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(snippet);
+  } break;
+  case MS_TOKEN_LITERAL_SHAPE:
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
+      filter->native_string = msStringConcatenate(
+          filter->native_string, "geography::STGeomFromText('");
+    else
+      filter->native_string = msStringConcatenate(filter->native_string,
+                                                  "geometry::STGeomFromText('");
+    filter->native_string = msStringConcatenate(
+        filter->native_string,
+        msShapeToWKT(layerinfo->current_node->tokenval.shpval));
+    filter->native_string = msStringConcatenate(filter->native_string, "'");
+    if (layerinfo->user_srid && strcmp(layerinfo->user_srid, "") != 0) {
+      filter->native_string = msStringConcatenate(filter->native_string, ", ");
+      filter->native_string =
+          msStringConcatenate(filter->native_string, layerinfo->user_srid);
+    }
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
+  case MS_TOKEN_BINDING_TIME:
+  case MS_TOKEN_BINDING_DOUBLE:
+  case MS_TOKEN_BINDING_INTEGER:
+  case MS_TOKEN_BINDING_STRING:
+    if (layerinfo->current_node->next->token == MS_TOKEN_COMPARISON_IRE)
+      strtmpl = "LOWER(%s)";
+    else
+      strtmpl = "%s";
+
+    stresc = msMSSQL2008LayerEscapePropertyName(
+        layer, layerinfo->current_node->tokenval.bindval.item);
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(stresc));
+    sprintf(snippet, strtmpl, stresc);
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(snippet);
+    msFree(stresc);
+    break;
+  case MS_TOKEN_BINDING_SHAPE:
+    filter->native_string =
+        msStringConcatenate(filter->native_string, layerinfo->geom_column);
+    break;
+  case MS_TOKEN_BINDING_MAP_CELLSIZE: {
+    char buffer[32];
+    snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
+    filter->native_string = msStringConcatenate(filter->native_string, buffer);
+    break;
+  }
+
+  /* comparisons */
+  case MS_TOKEN_COMPARISON_IN:
+    filter->native_string = msStringConcatenate(filter->native_string, " IN ");
+    break;
+  case MS_TOKEN_COMPARISON_RE:
+  case MS_TOKEN_COMPARISON_IRE: {
+    /* process regexp */
+    size_t i = 0, j = 0;
+    char c;
+    char c_next;
+    int bCaseInsensitive =
+        (layerinfo->current_node->token == MS_TOKEN_COMPARISON_IRE);
+    int nEscapeLen = 0;
+    if (bCaseInsensitive)
+      filter->native_string =
+          msStringConcatenate(filter->native_string, " LIKE LOWER(");
+    else
+      filter->native_string =
+          msStringConcatenate(filter->native_string, " LIKE ");
+
+    layerinfo->current_node = layerinfo->current_node->next;
+    if (layerinfo->current_node->token != MS_TOKEN_LITERAL_STRING)
+      return 0;
+
+    strtmpl = msStrdup(layerinfo->current_node->tokenval.strval);
+    if (strtmpl[0] == '/') {
+      stresc = strtmpl + 1;
+      strtmpl[strlen(strtmpl) - 1] = '\0';
+    } else if (strtmpl[0] == '^')
+      stresc = strtmpl + 1;
+    else
+      stresc = strtmpl;
+
+    while (*stresc) {
+      c = stresc[i];
+      if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
+        nEscapeLen++;
+      }
+      stresc++;
+    }
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + nEscapeLen + 3);
+    snippet[j++] = '\'';
+    while (i < strlen(strtmpl)) {
+      c = strtmpl[i];
+      c_next = strtmpl[i + 1];
+
+      if (i == 0 && c == '^') {
+        i++;
+        continue;
+      }
+      if (c == '$' && c_next == 0 && strtmpl[0] == '^')
+        break;
+
+      if (c == '\\') {
+        i++;
+        c = c_next;
+      }
+
+      if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
+        snippet[j++] = '\\';
+      }
+
+      if (c == '.' && c_next == '*') {
+        i++;
+        c = '%';
+      } else if (c == '.')
+        c = '_';
+
+      snippet[j++] = c;
+      i++;
+    }
+    snippet[j++] = '\'';
+    snippet[j] = '\0';
+
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(strtmpl);
+    msFree(snippet);
+
+    if (bCaseInsensitive)
+      filter->native_string = msStringConcatenate(filter->native_string, ")");
+
+    if (nEscapeLen > 0)
+      filter->native_string =
+          msStringConcatenate(filter->native_string, " ESCAPE '\\'");
+  } break;
+  case MS_TOKEN_COMPARISON_EQ:
+    filter->native_string = msStringConcatenate(filter->native_string, " = ");
+    break;
+  case MS_TOKEN_COMPARISON_NE:
+    filter->native_string = msStringConcatenate(filter->native_string, " != ");
+    break;
+  case MS_TOKEN_COMPARISON_GT:
+    filter->native_string = msStringConcatenate(filter->native_string, " > ");
+    break;
+  case MS_TOKEN_COMPARISON_GE:
+    filter->native_string = msStringConcatenate(filter->native_string, " >= ");
+    break;
+  case MS_TOKEN_COMPARISON_LT:
+    filter->native_string = msStringConcatenate(filter->native_string, " < ");
+    break;
+  case MS_TOKEN_COMPARISON_LE:
+    filter->native_string = msStringConcatenate(filter->native_string, " <= ");
+    break;
+
+  /* logical ops */
+  case MS_TOKEN_LOGICAL_AND:
+    filter->native_string = msStringConcatenate(filter->native_string, " AND ");
+    break;
+  case MS_TOKEN_LOGICAL_OR:
+    filter->native_string = msStringConcatenate(filter->native_string, " OR ");
+    break;
+  case MS_TOKEN_LOGICAL_NOT:
+    filter->native_string = msStringConcatenate(filter->native_string, " NOT ");
+    break;
+
+  /* spatial comparison tokens */
+  case MS_TOKEN_COMPARISON_INTERSECTS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STIntersects(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_DISJOINT:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STDisjoint(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_TOUCHES:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STTouches(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_OVERLAPS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STOverlaps(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_CROSSES:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STCrosses(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_WITHIN:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STWithin(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_CONTAINS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STContains(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_EQUALS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STEquals(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
+
+  case MS_TOKEN_COMPARISON_BEYOND:
+    msSetError(MS_MISCERR, "Beyond operator is unsupported.",
+               "msMSSQL2008LayerTranslateFilter()");
+    return 0;
+
+  case MS_TOKEN_COMPARISON_DWITHIN:
+    msSetError(MS_MISCERR, "DWithin operator is unsupported.",
+               "msMSSQL2008LayerTranslateFilter()");
+    return 0;
+
+  /* spatial functions */
+  case MS_TOKEN_FUNCTION_AREA:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STArea()");
+    break;
+
+  case MS_TOKEN_FUNCTION_BUFFER:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STBuffer(");
+    if (!process_node(layer, filter))
+      return 0;
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
+
+  case MS_TOKEN_FUNCTION_DIFFERENCE:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STDifference(");
+    if (!process_node(layer, filter))
+      return 0;
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
+
+  case MS_TOKEN_FUNCTION_FROMTEXT:
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
+      filter->native_string = msStringConcatenate(filter->native_string,
+                                                  "geography::STGeomFromText");
+    else
+      filter->native_string = msStringConcatenate(filter->native_string,
+                                                  "geometry::STGeomFromText");
+    break;
+
+  case MS_TOKEN_FUNCTION_LENGTH:
+    filter->native_string = msStringConcatenate(filter->native_string, "len");
+    break;
+
+  case MS_TOKEN_FUNCTION_ROUND:
+    filter->native_string = msStringConcatenate(filter->native_string, "round");
+    break;
+
+  case MS_TOKEN_FUNCTION_TOSTRING:
+    break;
+
+  case MS_TOKEN_FUNCTION_COMMIFY:
+    break;
+
+  case MS_TOKEN_FUNCTION_SIMPLIFY:
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".Reduce");
+    break;
+  case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+    break;
+  case MS_TOKEN_FUNCTION_GENERALIZE:
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".Reduce");
+    break;
+
+  default:
+    msSetError(MS_MISCERR, "Translation to native SQL failed.",
+               "msMSSQL2008LayerTranslateFilter()");
+    if (layer->debug) {
+      msDebug("Token not caught, exiting: Token is %i\n",
+              layerinfo->current_node->token);
+    }
+    return 0;
+  }
+  return 1;
+}
+
+/* Translate filter expression to native msssql filter */
+int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                    char *filteritem) {
+  char *snippet = NULL;
+  char *strtmpl = NULL;
+  char *stresc = NULL;
+  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
+
+  if (!filter->string)
+    return MS_SUCCESS;
+
+  msFree(filter->native_string);
+  filter->native_string = NULL;
+
+  if (filter->type == MS_STRING && filter->string &&
+      filteritem) { /* item/value pair */
+    stresc = msMSSQL2008LayerEscapePropertyName(layer, filteritem);
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      filter->native_string =
+          msStringConcatenate(filter->native_string, "upper(");
+      filter->native_string =
+          msStringConcatenate(filter->native_string, stresc);
+      filter->native_string =
+          msStringConcatenate(filter->native_string, ") = upper(");
+    } else {
+      filter->native_string =
+          msStringConcatenate(filter->native_string, stresc);
+      filter->native_string = msStringConcatenate(filter->native_string, " = ");
+    }
+    msFree(stresc);
+
+    strtmpl = "'%s'"; /* don't have a type for the righthand literal so assume
+                         it's a string and we quote */
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    free(snippet);
+
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      filter->native_string = msStringConcatenate(filter->native_string, ")");
+
+  } else if (filter->type == MS_REGEX && filter->string &&
+             filteritem) { /* item/regex pair */
+    /* NOTE: regex is not supported by MSSQL natively. We should install it in
+       CLR UDF according to
+       https://msdn.microsoft.com/en-us/magazine/cc163473.aspx*/
+    filter->native_string =
+        msStringConcatenate(filter->native_string, "dbo.RegexMatch(");
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      filter->native_string =
+          msStringConcatenate(filter->native_string, "'(?i)");
+    }
+    filter->native_string = msStrdup(filteritem);
+    filter->native_string = msStringConcatenate(filter->native_string, ", ");
+    strtmpl = "'%s'";
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+
+    filter->native_string = msStringConcatenate(filter->native_string, "')");
+    free(snippet);
+  } else if (filter->type == MS_EXPRESSION) {
+
+    if (layer->debug >= 2)
+      msDebug("msMSSQL2008LayerTranslateFilter. String: %s.\n", filter->string);
+
+    if (!filter->tokens) {
+      if (layer->debug >= 2)
+        msDebug("msMSSQL2008LayerTranslateFilter. There are tokens to "
+                "process... \n");
+      return MS_SUCCESS;
+    }
+
+    /* start processing nodes */
+    layerinfo->current_node = filter->tokens;
+    while (layerinfo->current_node != NULL) {
+      if (!process_node(layer, filter)) {
+        msFree(filter->native_string);
+        filter->native_string = 0;
+        return MS_FAILURE;
+      }
+
+      if (!layerinfo->current_node)
+        break;
+
+      layerinfo->current_node = layerinfo->current_node->next;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+#else
+
+/* prototypes if MSSQL2008 isnt supposed to be compiled */
+
+int msMSSQL2008LayerOpen(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerOpen called but unimplemented!  (mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerOpen()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerIsOpen(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008IsLayerOpen called but unimplemented!  (mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerIsOpen()");
+  return MS_FALSE;
+}
+
+void msMSSQL2008LayerFreeItemInfo(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerFreeItemInfo called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerFreeItemInfo()");
+}
+
+int msMSSQL2008LayerInitItemInfo(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerInitItemInfo called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerInitItemInfo()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerWhichShapes called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerWhichShapes()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerClose(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerClose called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerClose()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerNextShape called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerNextShape()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape, long record) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetShape called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetShape()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect,
+                                  projectionObj *rectProjection) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetShapeCount called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetShapeCount()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetExtent called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetExtent()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerGetNumFeatures(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetNumFeatures called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetNumFeatures()");
+  return -1;
+}
+
+int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape,
+                                   long *record) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetShapeRandom called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetShapeRandom()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerGetItems(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetItems called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetItems()");
+  return MS_FAILURE;
+}
+
+void msMSSQL2008EnablePaging(layerObj *layer, int value) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008EnablePaging called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008EnablePaging()");
+  return;
+}
+
+int msMSSQL2008GetPaging(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008GetPaging called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008GetPaging()");
+  return MS_FAILURE;
+}
+
+int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                    char *filteritem) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerTranslateFilter called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerTranslateFilter()");
+  return MS_FAILURE;
+}
+
+char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008EscapeSQLParam called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerEscapeSQLParam()");
+  return NULL;
+}
+
+char *msMSSQL2008LayerEscapePropertyName(layerObj *layer,
+                                         const char *pszString) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerEscapePropertyName called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerEscapePropertyName()");
+  return NULL;
+}
+
+/* end above's #ifdef USE_MSSQL2008 */
+#endif
+
+#ifdef USE_MSSQL2008_PLUGIN
+
+MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj *vtable,
+                                               layerObj *layer) {
+  assert(layer != NULL);
+  assert(vtable != NULL);
+
+  vtable->LayerEnablePaging = msMSSQL2008EnablePaging;
+  vtable->LayerGetPaging = msMSSQL2008GetPaging;
+  vtable->LayerTranslateFilter = msMSSQL2008LayerTranslateFilter;
+  vtable->LayerEscapeSQLParam = msMSSQL2008LayerEscapeSQLParam;
+  vtable->LayerEscapePropertyName = msMSSQL2008LayerEscapePropertyName;
+
+  vtable->LayerInitItemInfo = msMSSQL2008LayerInitItemInfo;
+  vtable->LayerFreeItemInfo = msMSSQL2008LayerFreeItemInfo;
+  vtable->LayerOpen = msMSSQL2008LayerOpen;
+  vtable->LayerIsOpen = msMSSQL2008LayerIsOpen;
+  vtable->LayerWhichShapes = msMSSQL2008LayerWhichShapes;
+  vtable->LayerNextShape = msMSSQL2008LayerNextShape;
+  vtable->LayerGetShape = msMSSQL2008LayerGetShape;
+  vtable->LayerGetShapeCount = msMSSQL2008LayerGetShapeCount;
+
+  vtable->LayerClose = msMSSQL2008LayerClose;
+
+  vtable->LayerGetItems = msMSSQL2008LayerGetItems;
+  vtable->LayerGetExtent = msMSSQL2008LayerGetExtent;
+
+  vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
+
+  /* vtable->LayerGetAutoStyle, not supported for this layer */
+  vtable->LayerCloseConnection = msMSSQL2008LayerClose;
+
+  vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  /* vtable->LayerCreateItems, use default */
+  vtable->LayerGetNumFeatures = msMSSQL2008LayerGetNumFeatures;
+  /* layer->vtable->LayerGetAutoProjection, use defaut*/
+
+  return MS_SUCCESS;
+}
+
+#endif
+
+int msMSSQL2008LayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerEnablePaging = msMSSQL2008EnablePaging;
+  layer->vtable->LayerGetPaging = msMSSQL2008GetPaging;
+  layer->vtable->LayerTranslateFilter = msMSSQL2008LayerTranslateFilter;
+  layer->vtable->LayerEscapeSQLParam = msMSSQL2008LayerEscapeSQLParam;
+  layer->vtable->LayerEscapePropertyName = msMSSQL2008LayerEscapePropertyName;
+
+  layer->vtable->LayerInitItemInfo = msMSSQL2008LayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msMSSQL2008LayerFreeItemInfo;
+  layer->vtable->LayerOpen = msMSSQL2008LayerOpen;
+  layer->vtable->LayerIsOpen = msMSSQL2008LayerIsOpen;
+  layer->vtable->LayerWhichShapes = msMSSQL2008LayerWhichShapes;
+  layer->vtable->LayerNextShape = msMSSQL2008LayerNextShape;
+  layer->vtable->LayerGetShape = msMSSQL2008LayerGetShape;
+  layer->vtable->LayerGetShapeCount = msMSSQL2008LayerGetShapeCount;
+
+  layer->vtable->LayerClose = msMSSQL2008LayerClose;
+
+  layer->vtable->LayerGetItems = msMSSQL2008LayerGetItems;
+  layer->vtable->LayerGetExtent = msMSSQL2008LayerGetExtent;
+
+  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
+
+  /* layer->vtable->LayerGetAutoStyle, not supported for this layer */
+  layer->vtable->LayerCloseConnection = msMSSQL2008LayerClose;
+
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  layer->vtable->LayerGetNumFeatures = msMSSQL2008LayerGetNumFeatures;
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapmvt.c 8.2.0~beta1-1~exp1/src/mapmvt.c
--- 8.0.1-5/src/mapmvt.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapmvt.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,676 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  MapBox Vector Tile rendering.
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2015 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "maptile.h"
+
+#ifdef USE_PBF
+#include "vector_tile.pb-c.h"
+#include "mapows.h"
+#include "uthash.h"
+#include <float.h>
+
+#define MOVETO 1
+#define LINETO 2
+#define CLOSEPATH 7
+
+#define FEATURES_INCREMENT_SIZE 5
+
+enum MS_RING_DIRECTION {
+  MS_DIRECTION_INVALID_RING,
+  MS_DIRECTION_CLOCKWISE,
+  MS_DIRECTION_COUNTERCLOCKWISE
+};
+
+typedef struct {
+  char *value;
+  unsigned int index;
+  UT_hash_handle hh;
+} value_lookup;
+
+typedef struct {
+  value_lookup *cache;
+} value_lookup_table;
+
+#define COMMAND(id, count) (((id)&0x7) | ((count) << 3))
+#define PARAMETER(n) (((n) << 1) ^ ((n) >> 31))
+
+static double getTriangleHeight(lineObj *ring) {
+  int i;
+  double s = 0, b = 0;
+
+  if (ring->numpoints != 4)
+    return -1; /* not a triangle */
+
+  for (i = 0; i < ring->numpoints - 1; i++) {
+    s += (ring->point[i].x * ring->point[i + 1].y -
+          ring->point[i + 1].x * ring->point[i].y);
+    b = MS_MAX(b, msDistancePointToPoint(&ring->point[i], &ring->point[i + 1]));
+  }
+
+  return (MS_ABS(s / b));
+}
+
+static enum MS_RING_DIRECTION mvtGetRingDirection(lineObj *ring) {
+  int i, sum = 0;
+
+  if (ring->numpoints < 4)
+    return MS_DIRECTION_INVALID_RING;
+
+  /* step throught the edges */
+  for (i = 0; i < ring->numpoints - 1; i++) {
+    sum += ring->point[i].x * ring->point[i + 1].y -
+           ring->point[i + 1].x * ring->point[i].y;
+  }
+
+  return sum > 0   ? MS_DIRECTION_CLOCKWISE
+         : sum < 0 ? MS_DIRECTION_COUNTERCLOCKWISE
+                   : MS_DIRECTION_INVALID_RING;
+}
+
+static void mvtReverseRingDirection(lineObj *ring) {
+  pointObj temp;
+  int start = 1, end = ring->numpoints -
+                       2; /* first and last points are the same so skip 'em */
+
+  while (start < end) {
+    temp.x = ring->point[start].x;
+    temp.y = ring->point[start].y;
+    ring->point[start].x = ring->point[end].x;
+    ring->point[start].y = ring->point[end].y;
+    ring->point[end].x = temp.x;
+    ring->point[end].y = temp.y;
+    start++;
+    end--;
+  }
+}
+
+static void mvtReorderRings(shapeObj *shape, int *outers) {
+  int i, j;
+  int t1;
+  lineObj t2;
+
+  for (i = 0; i < (shape->numlines - 1); i++) {
+    for (j = 0; j < (shape->numlines - i - 1); j++) {
+      if (outers[j] < outers[j + 1]) {
+        /* swap */
+        t1 = outers[j];
+        outers[j] = outers[j + 1];
+        outers[j + 1] = t1;
+
+        t2 = shape->line[j];
+        shape->line[j] = shape->line[j + 1];
+        shape->line[j + 1] = t2;
+      }
+    }
+  }
+}
+
+static int mvtTransformShape(shapeObj *shape, rectObj *extent, int layer_type,
+                             int mvt_layer_extent) {
+  double scale_x, scale_y;
+  int i, j, outj;
+
+  int *outers = NULL, ring_direction;
+
+  scale_x = (double)mvt_layer_extent / (extent->maxx - extent->minx);
+  scale_y = (double)mvt_layer_extent / (extent->maxy - extent->miny);
+
+  if (layer_type == MS_LAYER_POLYGON) {
+    outers = msGetOuterList(shape); /* compute before we muck with the shape */
+    if (outers[0] == 0)             /* first ring must be an outer */
+      mvtReorderRings(shape, outers);
+  }
+
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0, outj = 0; j < shape->line[i].numpoints; j++) {
+
+      shape->line[i].point[outj].x =
+          (int)((shape->line[i].point[j].x - extent->minx) * scale_x);
+      shape->line[i].point[outj].y =
+          mvt_layer_extent -
+          (int)((shape->line[i].point[j].y - extent->miny) * scale_y);
+
+      if (!outj ||
+          shape->line[i].point[outj].x != shape->line[i].point[outj - 1].x ||
+          shape->line[i].point[outj].y != shape->line[i].point[outj - 1].y)
+        outj++; /* add the point to the shape only if it's the first one or if
+                   it's different than the previous one */
+    }
+    shape->line[i].numpoints = outj;
+
+    if (layer_type == MS_LAYER_POLYGON) {
+      if (shape->line[i].numpoints == 4 &&
+          getTriangleHeight(&shape->line[i]) < 1) {
+        shape->line[i].numpoints = 0; /* so it's not considered anymore */
+        continue;                     /* next ring */
+      }
+
+      ring_direction = mvtGetRingDirection(&shape->line[i]);
+      if (ring_direction == MS_DIRECTION_INVALID_RING)
+        shape->line[i].numpoints = 0; /* so it's not considered anymore */
+      else if ((outers[i] && ring_direction != MS_DIRECTION_CLOCKWISE) ||
+               (!outers[i] && ring_direction != MS_DIRECTION_COUNTERCLOCKWISE))
+        mvtReverseRingDirection(&shape->line[i]);
+    }
+  }
+
+  msComputeBounds(
+      shape); /* TODO: might need to limit this to just valid parts... */
+  msFree(outers);
+
+  return (shape->numlines == 0) ? MS_FAILURE
+                                : MS_SUCCESS; /* sucess if at least one line */
+}
+
+static int mvtClipShape(shapeObj *shape, int layer_type, int buffer,
+                        int mvt_layer_extent) {
+  rectObj tile_rect;
+  tile_rect.minx = tile_rect.miny = -buffer * 16;
+  tile_rect.maxx = tile_rect.maxy = mvt_layer_extent + buffer * 16;
+
+  if (layer_type == MS_LAYER_POLYGON) {
+    msClipPolygonRect(shape, tile_rect);
+  } else if (layer_type == MS_LAYER_LINE) {
+    msClipPolylineRect(shape, tile_rect);
+  }
+
+  /* success if at least one line and not a degenerate bounding box */
+  if (shape->numlines > 0 && (layer_type == MS_LAYER_POINT ||
+                              (shape->bounds.minx != shape->bounds.maxx ||
+                               shape->bounds.miny != shape->bounds.maxy)))
+    return MS_SUCCESS;
+  else
+    return MS_FAILURE;
+}
+
+static void freeMvtFeature(VectorTile__Tile__Feature *mvt_feature) {
+  if (mvt_feature->tags)
+    msFree(mvt_feature->tags);
+  if (mvt_feature->geometry)
+    msFree(mvt_feature->geometry);
+}
+
+static void freeMvtValue(VectorTile__Tile__Value *mvt_value) {
+  if (mvt_value->string_value)
+    msFree(mvt_value->string_value);
+}
+
+static void freeMvtLayer(VectorTile__Tile__Layer *mvt_layer) {
+  if (mvt_layer->keys) {
+    for (unsigned i = 0; i < mvt_layer->n_keys; i++) {
+      msFree(mvt_layer->keys[i]);
+    }
+    msFree(mvt_layer->keys);
+  }
+  if (mvt_layer->values) {
+    for (unsigned i = 0; i < mvt_layer->n_values; i++) {
+      freeMvtValue(mvt_layer->values[i]);
+      msFree(mvt_layer->values[i]);
+    }
+    msFree(mvt_layer->values);
+  }
+  if (mvt_layer->features) {
+    for (unsigned i = 0; i < mvt_layer->n_features; i++) {
+      freeMvtFeature(mvt_layer->features[i]);
+      msFree(mvt_layer->features[i]);
+    }
+    msFree(mvt_layer->features);
+  }
+}
+
+int mvtWriteShape(layerObj *layer, shapeObj *shape,
+                  VectorTile__Tile__Layer *mvt_layer, gmlItemListObj *item_list,
+                  value_lookup_table *value_lookup_cache,
+                  rectObj *unbuffered_bbox, int buffer) {
+  VectorTile__Tile__Feature *mvt_feature;
+  int i, j, iout;
+  value_lookup *value;
+  long int n_geometry;
+
+  /* could consider an intersection test here */
+
+  if (mvtTransformShape(shape, unbuffered_bbox, layer->type,
+                        mvt_layer->extent) != MS_SUCCESS) {
+    return MS_SUCCESS; /* degenerate shape */
+  }
+  if (mvtClipShape(shape, layer->type, buffer, mvt_layer->extent) !=
+      MS_SUCCESS) {
+    return MS_SUCCESS; /* no features left after clipping */
+  }
+
+  n_geometry = 0;
+  if (layer->type == MS_LAYER_POINT) {
+    for (i = 0; i < shape->numlines; i++)
+      n_geometry += shape->line[i].numpoints * 2;
+    if (n_geometry)
+      n_geometry++; /* one MOVETO */
+  } else if (layer->type == MS_LAYER_LINE) {
+    for (i = 0; i < shape->numlines; i++)
+      if (shape->line[i].numpoints >= 2)
+        n_geometry +=
+            2 + shape->line[i].numpoints * 2; /* one MOVETO, one LINETO */
+  } else {                                    /* MS_LAYER_POLYGON */
+    for (i = 0; i < shape->numlines; i++)
+      if (shape->line[i].numpoints >= 4)
+        n_geometry += 3 + (shape->line[i].numpoints - 1) *
+                              2; /* one MOVETO, one LINETO, one CLOSEPATH (don't
+                                    consider last duplicate point) */
+  }
+
+  if (n_geometry == 0)
+    return MS_SUCCESS;
+
+  mvt_layer->features[mvt_layer->n_features++] =
+      msSmallMalloc(sizeof(VectorTile__Tile__Feature));
+  mvt_feature = mvt_layer->features[mvt_layer->n_features - 1];
+  vector_tile__tile__feature__init(mvt_feature);
+  mvt_feature->n_tags = mvt_layer->n_keys * 2;
+  mvt_feature->tags = msSmallMalloc(mvt_feature->n_tags * sizeof(uint32_t));
+  mvt_feature->id = shape->index;
+  mvt_feature->has_id = 1;
+
+  if (layer->type == MS_LAYER_POLYGON)
+    mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__POLYGON;
+  else if (layer->type == MS_LAYER_LINE)
+    mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__LINESTRING;
+  else
+    mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__POINT;
+  mvt_feature->has_type = 1;
+
+  /* output values */
+  for (i = 0, iout = 0; i < item_list->numitems; i++) {
+    gmlItemObj *item = item_list->items + i;
+
+    if (!item->visible)
+      continue;
+
+    UT_HASH_FIND_STR(value_lookup_cache->cache, shape->values[i], value);
+    if (!value) {
+      VectorTile__Tile__Value *mvt_value;
+      value = msSmallMalloc(sizeof(value_lookup));
+      value->value = msStrdup(shape->values[i]);
+      value->index = mvt_layer->n_values;
+      mvt_layer->values = msSmallRealloc(mvt_layer->values,
+                                         (++mvt_layer->n_values) *
+                                             sizeof(VectorTile__Tile__Value *));
+      mvt_layer->values[mvt_layer->n_values - 1] =
+          msSmallMalloc(sizeof(VectorTile__Tile__Value));
+      mvt_value = mvt_layer->values[mvt_layer->n_values - 1];
+      vector_tile__tile__value__init(mvt_value);
+
+      if (item->type && EQUAL(item->type, "Integer")) {
+        mvt_value->int_value = atoi(value->value);
+        mvt_value->has_int_value = 1;
+      } else if (item->type && EQUAL(item->type, "Long")) { /* signed */
+        mvt_value->sint_value = atol(value->value);
+        mvt_value->has_sint_value = 1;
+      } else if (item->type && EQUAL(item->type, "Real")) {
+        mvt_value->float_value = atof(value->value);
+        mvt_value->has_float_value = 1;
+      } else if (item->type && EQUAL(item->type, "Boolean")) {
+        if (EQUAL(value->value, "0") || EQUAL(value->value, "false"))
+          mvt_value->bool_value = 0;
+        else
+          mvt_value->bool_value = 1;
+        mvt_value->has_bool_value = 1;
+      } else {
+        mvt_value->string_value = msStrdup(value->value);
+      }
+      UT_HASH_ADD_KEYPTR(hh, value_lookup_cache->cache, value->value,
+                         strlen(value->value), value);
+    }
+    mvt_feature->tags[iout * 2] = iout;
+    mvt_feature->tags[iout * 2 + 1] = value->index;
+
+    iout++;
+  }
+
+  /* output geom */
+  mvt_feature->n_geometry = n_geometry;
+  mvt_feature->geometry =
+      msSmallMalloc(mvt_feature->n_geometry * sizeof(uint32_t));
+
+  if (layer->type == MS_LAYER_POINT) {
+    int idx = 0, lastx = 0, lasty = 0;
+    mvt_feature->geometry[idx++] =
+        COMMAND(MOVETO, (mvt_feature->n_geometry - 1) / 2);
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].x) - lastx);
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].y) - lasty);
+        lastx = MS_NINT(shape->line[i].point[j].x);
+        lasty = MS_NINT(shape->line[i].point[j].y);
+      }
+    }
+  } else { /* MS_LAYER_LINE or MS_LAYER_POLYGON */
+    int numpoints;
+    int idx = 0, lastx = 0, lasty = 0;
+    for (i = 0; i < shape->numlines; i++) {
+
+      if ((layer->type == MS_LAYER_LINE && !(shape->line[i].numpoints >= 2)) ||
+          (layer->type == MS_LAYER_POLYGON &&
+           !(shape->line[i].numpoints >= 4))) {
+        continue; /* skip malformed parts */
+      }
+
+      numpoints = (layer->type == MS_LAYER_LINE)
+                      ? shape->line[i].numpoints
+                      : (shape->line[i].numpoints -
+                         1); /* don't consider last point for polygons */
+      for (j = 0; j < numpoints; j++) {
+        if (j == 0) {
+          mvt_feature->geometry[idx++] = COMMAND(MOVETO, 1);
+        } else if (j == 1) {
+          mvt_feature->geometry[idx++] = COMMAND(LINETO, numpoints - 1);
+        }
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].x) - lastx);
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].y) - lasty);
+        lastx = MS_NINT(shape->line[i].point[j].x);
+        lasty = MS_NINT(shape->line[i].point[j].y);
+      }
+      if (layer->type == MS_LAYER_POLYGON) {
+        mvt_feature->geometry[idx++] = COMMAND(CLOSEPATH, 1);
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+static void freeMvtTile(VectorTile__Tile *mvt_tile) {
+  for (unsigned iLayer = 0; iLayer < mvt_tile->n_layers; iLayer++) {
+    freeMvtLayer(mvt_tile->layers[iLayer]);
+    msFree(mvt_tile->layers[iLayer]);
+  }
+  msFree(mvt_tile->layers);
+}
+
+int msMVTWriteTile(mapObj *map, int sendheaders) {
+  int iLayer, retcode = MS_SUCCESS;
+  unsigned len;
+  void *buf;
+  const char *mvt_extent =
+      msGetOutputFormatOption(map->outputformat, "EXTENT", "4096");
+  const char *mvt_buffer =
+      msGetOutputFormatOption(map->outputformat, "EDGE_BUFFER", "10");
+  int buffer = MS_ABS(atoi(mvt_buffer));
+  VectorTile__Tile mvt_tile = VECTOR_TILE__TILE__INIT;
+  mvt_tile.layers =
+      msSmallCalloc(map->numlayers, sizeof(VectorTile__Tile__Layer *));
+
+  /* make sure we have a scale and cellsize computed */
+  map->cellsize = MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width);
+  msCalculateScale(map->extent, map->units, map->width, map->height,
+                   map->resolution, &map->scaledenom);
+
+  /* expand the map->extent so it goes from pixel center (MapServer) to pixel
+   * edge (OWS) */
+  map->extent.minx -= map->cellsize * 0.5;
+  map->extent.maxx += map->cellsize * 0.5;
+  map->extent.miny -= map->cellsize * 0.5;
+  map->extent.maxy += map->cellsize * 0.5;
+
+  for (iLayer = 0; iLayer < map->numlayers; iLayer++) {
+    int status = MS_SUCCESS;
+    layerObj *layer = GET_LAYER(map, iLayer);
+    int i;
+    shapeObj shape;
+    gmlItemListObj *item_list = NULL;
+    VectorTile__Tile__Layer *mvt_layer;
+    value_lookup_table value_lookup_cache = {NULL};
+    value_lookup *cur_value_lookup, *tmp_value_lookup;
+    rectObj rect;
+
+    int nclasses = 0;
+    int *classgroup = NULL;
+
+    unsigned features_size = 0;
+
+    if (!msLayerIsVisible(map, layer))
+      continue;
+
+    if (layer->type != MS_LAYER_POINT && layer->type != MS_LAYER_POLYGON &&
+        layer->type != MS_LAYER_LINE)
+      continue;
+
+    status = msLayerOpen(layer);
+    if (status != MS_SUCCESS) {
+      retcode = status;
+      goto layer_cleanup;
+    }
+
+    status = msLayerWhichItems(
+        layer, MS_TRUE,
+        NULL); /* we want all items - behaves like a query in that sense */
+    if (status != MS_SUCCESS) {
+      retcode = status;
+      goto layer_cleanup;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Will we need to reproject?                                      */
+    /* -------------------------------------------------------------------- */
+    layer->project =
+        msProjectionsDiffer(&(layer->projection), &(map->projection));
+
+    rect = map->extent;
+    if (layer->project)
+      msProjectRect(&(map->projection), &(layer->projection), &rect);
+
+    status = msLayerWhichShapes(layer, rect, MS_TRUE);
+    if (status == MS_DONE) { /* no overlap - that's ok */
+      retcode = MS_SUCCESS;
+      goto layer_cleanup;
+    } else if (status != MS_SUCCESS) {
+      retcode = status;
+      goto layer_cleanup;
+    }
+
+    mvt_tile.layers[mvt_tile.n_layers++] =
+        msSmallMalloc(sizeof(VectorTile__Tile__Layer));
+    mvt_layer = mvt_tile.layers[mvt_tile.n_layers - 1];
+    vector_tile__tile__layer__init(mvt_layer);
+    mvt_layer->version = 2;
+    mvt_layer->name = layer->name;
+
+    mvt_layer->extent = MS_ABS(atoi(mvt_extent));
+    mvt_layer->has_extent = 1;
+
+    /* -------------------------------------------------------------------- */
+    /*      Create appropriate attributes on this layer.                    */
+    /* -------------------------------------------------------------------- */
+    item_list = msGMLGetItems(layer, "G");
+    assert(item_list->numitems == layer->numitems);
+
+    mvt_layer->keys = msSmallMalloc(layer->numitems * sizeof(char *));
+
+    for (i = 0; i < layer->numitems; i++) {
+      gmlItemObj *item = item_list->items + i;
+
+      if (!item->visible)
+        continue;
+
+      if (item->alias)
+        mvt_layer->keys[mvt_layer->n_keys++] = msStrdup(item->alias);
+      else
+        mvt_layer->keys[mvt_layer->n_keys++] = msStrdup(item->name);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Setup joins if needed.  This is likely untested.                */
+    /* -------------------------------------------------------------------- */
+    if (layer->numjoins > 0) {
+      int j;
+      for (j = 0; j < layer->numjoins; j++) {
+        status = msJoinConnect(layer, &(layer->joins[j]));
+        if (status != MS_SUCCESS) {
+          retcode = status;
+          goto layer_cleanup;
+        }
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Setup classgroup if needed.                                     */
+    /* -------------------------------------------------------------------- */
+    if (layer->classgroup && layer->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(layer, &nclasses);
+
+    mvt_layer->features = msSmallCalloc(FEATURES_INCREMENT_SIZE,
+                                        sizeof(VectorTile__Tile__Feature *));
+    features_size = FEATURES_INCREMENT_SIZE;
+
+    msInitShape(&shape);
+    i = 0;
+    for (;;) {
+      if (layer->resultcache) {
+        status = (i < layer->resultcache->numresults)
+                     ? msLayerGetShape(layer, &shape,
+                                       &(layer->resultcache->results[i]))
+                     : MS_DONE;
+        i++;
+      } else {
+        status = msLayerNextShape(layer, &shape);
+      }
+
+      if (status != MS_SUCCESS)
+        goto feature_cleanup;
+
+      if (layer->numclasses > 0) {
+        /* Should be equivalent to shape.classindex =
+         * layer->resultcache->results[i].classindex; */
+        shape.classindex =
+            msShapeGetClass(layer, map, &shape, classgroup,
+                            nclasses); /* Perform classification, and some
+                                          annotation related magic. */
+
+        if (shape.classindex < 0)
+          goto feature_cleanup; /* no matching CLASS found, skip this feature */
+      }
+
+      /*
+      ** prepare any necessary JOINs here (one-to-one only)
+      */
+      if (layer->numjoins > 0) {
+        int j;
+
+        for (j = 0; j < layer->numjoins; j++) {
+          if (layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
+            msJoinPrepare(&(layer->joins[j]), &shape);
+            msJoinNext(&(layer->joins[j])); /* fetch the first row */
+          }
+        }
+      }
+
+      if (mvt_layer->n_features ==
+          features_size) { /* need to allocate more space */
+        features_size += FEATURES_INCREMENT_SIZE;
+        mvt_layer->features = msSmallRealloc(
+            mvt_layer->features,
+            sizeof(VectorTile__Tile__Feature *) * (features_size));
+      }
+
+      if (layer->project) {
+        if (layer->reprojectorLayerToMap == NULL) {
+          layer->reprojectorLayerToMap =
+              msProjectCreateReprojector(&layer->projection, &map->projection);
+        }
+        if (layer->reprojectorLayerToMap)
+          status = msProjectShapeEx(layer->reprojectorLayerToMap, &shape);
+        else
+          status = MS_FAILURE;
+      }
+      if (status == MS_SUCCESS) {
+        status = mvtWriteShape(layer, &shape, mvt_layer, item_list,
+                               &value_lookup_cache, &map->extent, buffer);
+      }
+
+    feature_cleanup:
+      msFreeShape(&shape);
+      if (status != MS_SUCCESS)
+        goto layer_cleanup;
+    } /* next shape */
+  layer_cleanup:
+    if (classgroup)
+      msFree(classgroup);
+    msLayerClose(layer);
+    msGMLFreeItems(item_list);
+    UT_HASH_ITER(hh, value_lookup_cache.cache, cur_value_lookup,
+                 tmp_value_lookup) {
+      msFree(cur_value_lookup->value);
+      UT_HASH_DEL(value_lookup_cache.cache, cur_value_lookup);
+      msFree(cur_value_lookup);
+    }
+    if (retcode != MS_SUCCESS)
+      goto cleanup;
+  } /* next layer */
+
+  len = vector_tile__tile__get_packed_size(
+      &mvt_tile); // This is the calculated packing length
+
+  buf = msSmallMalloc(len); // Allocate memory
+  vector_tile__tile__pack(&mvt_tile, buf);
+  if (sendheaders) {
+    msIO_fprintf(stdout,
+                 "Content-Length: %d\r\n"
+                 "Content-Type: %s\r\n\r\n",
+                 len, MS_IMAGE_MIME_TYPE(map->outputformat));
+  }
+  msIO_fwrite(buf, len, 1, stdout);
+  msFree(buf);
+
+cleanup:
+  freeMvtTile(&mvt_tile);
+
+  return retcode;
+}
+
+int msPopulateRendererVTableMVT(rendererVTableObj *renderer) {
+  (void)renderer;
+  return MS_SUCCESS;
+}
+#else
+int msPopulateRendererVTableMVT(rendererVTableObj *renderer) {
+  msSetError(MS_MISCERR,
+             "Vector Tile Driver requested but support is not compiled in",
+             "msPopulateRendererVTableMVT()");
+  return MS_FAILURE;
+}
+
+int msMVTWriteTile(mapObj *map, int sendheaders) {
+  msSetError(MS_MISCERR, "Vector Tile support is not available.",
+             "msMVTWriteTile()");
+  return MS_FAILURE;
+}
+#endif
diff -pruN 8.0.1-5/src/mapobject.c 8.2.0~beta1-1~exp1/src/mapobject.c
--- 8.0.1-5/src/mapobject.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapobject.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,782 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Functions for operating on a mapObj that don't belong in a
+ *           more specific file such as mapfile.c, or mapdraw.c.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2004, Frank Warmerdam
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#include "gdal.h"
+#include "cpl_conv.h"
+
+void freeWeb(webObj *web);
+void freeScalebar(scalebarObj *scalebar);
+void freeReferenceMap(referenceMapObj *ref);
+void freeLegend(legendObj *legend);
+
+/************************************************************************/
+/*                            msNewMapObj()                             */
+/*                                                                      */
+/*      Create a new initialized map object.                            */
+/************************************************************************/
+
+mapObj *msNewMapObj() {
+  mapObj *map = NULL;
+
+  /* create an empty map, no layers etc... */
+  map = (mapObj *)calloc(sizeof(mapObj), 1);
+
+  if (!map) {
+    msSetError(MS_MEMERR, NULL, "msCreateMap()");
+    return NULL;
+  }
+
+  if (initMap(map) == -1) {
+    msFreeMap(map);
+    return NULL;
+  }
+
+  if (msPostMapParseOutputFormatSetup(map) == MS_FAILURE) {
+    msFreeMap(map);
+    return NULL;
+  }
+
+  return map;
+}
+
+/************************************************************************/
+/*                             msFreeMap()                              */
+/************************************************************************/
+
+void msFreeMap(mapObj *map) {
+  int i;
+
+  if (!map)
+    return;
+
+  /* printf("msFreeMap(): maybe freeing map at %p count=%d.\n",map,
+   * map->refcount); */
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(map)) {
+    return;
+  }
+  if (map->debug >= MS_DEBUGLEVEL_VV)
+    msDebug("msFreeMap(): freeing map at %p.\n", map);
+
+  msCloseConnections(map);
+
+  msFree(map->name);
+  msFree(map->shapepath);
+  msFree(map->mappath);
+
+  msFreeProjection(&(map->projection));
+  msFreeProjection(&(map->latlon));
+  msProjectionContextReleaseToPool(map->projContext);
+
+  msFreeLabelCache(&(map->labelcache));
+
+  msFree(map->imagetype);
+
+  msFreeFontSet(&(map->fontset));
+
+  msFreeSymbolSet(&map->symbolset); /* free symbols */
+  msFree(map->symbolset.filename);
+
+  freeWeb(&(map->web));
+
+  freeScalebar(&(map->scalebar));
+  freeReferenceMap(&(map->reference));
+  freeLegend(&(map->legend));
+
+  for (i = 0; i < map->maxlayers; i++) {
+    if (GET_LAYER(map, i) != NULL) {
+      GET_LAYER(map, i)->map = NULL;
+      if (freeLayer((GET_LAYER(map, i))) == MS_SUCCESS)
+        free(GET_LAYER(map, i));
+    }
+  }
+  msFree(map->layers);
+
+  if (map->layerorder)
+    free(map->layerorder);
+
+  msFree(map->templatepattern);
+  msFree(map->datapattern);
+  msFreeHashItems(&(map->configoptions));
+  if (map->outputformat && map->outputformat->refcount > 0 &&
+      --map->outputformat->refcount < 1)
+    msFreeOutputFormat(map->outputformat);
+
+  for (i = 0; i < map->numoutputformats; i++) {
+    if (map->outputformatlist[i]->refcount > 0 &&
+        --map->outputformatlist[i]->refcount < 1)
+      msFreeOutputFormat(map->outputformatlist[i]);
+  }
+  if (map->outputformatlist != NULL)
+    msFree(map->outputformatlist);
+
+  msFreeQuery(&(map->query));
+
+#ifdef USE_V8_MAPSCRIPT
+  if (map->v8context)
+    msV8FreeContext(map);
+#endif
+
+  msFree(map);
+}
+
+/************************************************************************/
+/*                         msGetConfigOption()                          */
+/************************************************************************/
+
+const char *msGetConfigOption(mapObj *map, const char *key)
+
+{
+  return msLookupHashTable(&(map->configoptions), key);
+}
+
+/************************************************************************/
+/*                         msSetConfigOption()                          */
+/************************************************************************/
+
+int msSetConfigOption(mapObj *map, const char *key, const char *value)
+
+{
+  /* We have special "early" handling of this so that it will be */
+  /* in effect when the projection blocks are parsed and pj_init is called. */
+  if (strcasecmp(key, "PROJ_DATA") == 0 || strcasecmp(key, "PROJ_LIB") == 0) {
+    /* value may be relative to map path */
+    msSetPROJ_DATA(value, map->mappath);
+  }
+
+  /* Same for MS_ERRORFILE, we want it to kick in as early as possible
+   * to catch parsing errors.
+   * Value can be relative to mapfile, unless it's already absolute
+   */
+  if (strcasecmp(key, "MS_ERRORFILE") == 0) {
+    if (msSetErrorFile(value, map->mappath) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  if (msLookupHashTable(&(map->configoptions), key) != NULL)
+    msRemoveHashTable(&(map->configoptions), key);
+  msInsertHashTable(&(map->configoptions), key, value);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                         msTestConfigOption()                         */
+/************************************************************************/
+
+int msTestConfigOption(mapObj *map, const char *key, int default_result)
+
+{
+  const char *result = msGetConfigOption(map, key);
+
+  if (result == NULL)
+    return default_result;
+
+  if (strcasecmp(result, "YES") == 0 || strcasecmp(result, "ON") == 0 ||
+      strcasecmp(result, "TRUE") == 0)
+    return MS_TRUE;
+  else
+    return MS_FALSE;
+}
+
+/************************************************************************/
+/*                      msApplyMapConfigOptions()                       */
+/************************************************************************/
+
+void msApplyMapConfigOptions(mapObj *map)
+
+{
+  const char *key;
+
+  for (key = msFirstKeyFromHashTable(&(map->configoptions)); key != NULL;
+       key = msNextKeyFromHashTable(&(map->configoptions), key)) {
+    const char *value = msLookupHashTable(&(map->configoptions), key);
+    if (strcasecmp(key, "PROJ_DATA") == 0 || strcasecmp(key, "PROJ_LIB") == 0) {
+      msSetPROJ_DATA(value, map->mappath);
+    } else if (strcasecmp(key, "MS_ERRORFILE") == 0) {
+      msSetErrorFile(value, map->mappath);
+    } else {
+      CPLSetConfigOption(key, value);
+    }
+  }
+}
+
+/************************************************************************/
+/*                         msMapIgnoreMissingData() */
+/************************************************************************/
+
+int msMapIgnoreMissingData(mapObj *map) {
+  const char *result = msGetConfigOption(map, "ON_MISSING_DATA");
+  const int default_result =
+#ifndef IGNORE_MISSING_DATA
+      MS_MISSING_DATA_FAIL;
+#else
+      MS_MISSING_DATA_LOG;
+#endif
+
+  if (result == NULL)
+    return default_result;
+
+  if (strcasecmp(result, "FAIL") == 0)
+    return MS_MISSING_DATA_FAIL;
+  else if (strcasecmp(result, "LOG") == 0)
+    return MS_MISSING_DATA_LOG;
+  else if (strcasecmp(result, "IGNORE") == 0)
+    return MS_MISSING_DATA_IGNORE;
+
+  return default_result;
+}
+
+/************************************************************************/
+/*                           msMapSetExtent()                           */
+/************************************************************************/
+
+int msMapSetExtent(mapObj *map, double minx, double miny, double maxx,
+                   double maxy) {
+
+  map->extent.minx = minx;
+  map->extent.miny = miny;
+  map->extent.maxx = maxx;
+  map->extent.maxy = maxy;
+
+  if (!MS_VALID_EXTENT(map->extent)) {
+    msSetError(MS_MISCERR,
+               "Given map extent is invalid. Check that it "
+               "is in the form: minx, miny, maxx, maxy",
+               "setExtent()");
+    return MS_FAILURE;
+  }
+
+  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+
+  /* if the map size is also set, recompute scale, ignore errors? */
+  if (map->width != -1 || map->height != -1)
+    msCalculateScale(map->extent, map->units, map->width, map->height,
+                     map->resolution, &(map->scaledenom));
+
+  return msMapComputeGeotransform(map);
+}
+
+/************************************************************************/
+/*                           msMapOffsetExtent()                        */
+/************************************************************************/
+
+int msMapOffsetExtent(mapObj *map, double x, double y) {
+  return msMapSetExtent(map, map->extent.minx + x, map->extent.miny + y,
+                        map->extent.maxx + x, map->extent.maxy + y);
+}
+
+/************************************************************************/
+/*                           msMapScaleExtent()                         */
+/************************************************************************/
+
+int msMapScaleExtent(mapObj *map, double zoomfactor, double minscaledenom,
+                     double maxscaledenom) {
+  double geo_width, geo_height, center_x, center_y, md;
+
+  if (zoomfactor <= 0.0) {
+    msSetError(MS_MISCERR, "The given zoomfactor is invalid",
+               "msMapScaleExtent()");
+  }
+
+  geo_width = map->extent.maxx - map->extent.minx;
+  geo_height = map->extent.maxy - map->extent.miny;
+
+  center_x = map->extent.minx + geo_width * 0.5;
+  center_y = map->extent.miny + geo_height * 0.5;
+
+  geo_width *= zoomfactor;
+
+  if (minscaledenom > 0 || maxscaledenom > 0) {
+    /* ensure we are within the valid scale domain */
+    md = (map->width - 1) /
+         (map->resolution * msInchesPerUnit(map->units, center_y));
+    if (minscaledenom > 0 && geo_width < minscaledenom * md)
+      geo_width = minscaledenom * md;
+    if (maxscaledenom > 0 && geo_width > maxscaledenom * md)
+      geo_width = maxscaledenom * md;
+  }
+
+  geo_width *= 0.5;
+  geo_height = geo_width * map->height / map->width;
+
+  return msMapSetExtent(map, center_x - geo_width, center_y - geo_height,
+                        center_x + geo_width, center_y + geo_height);
+}
+
+/************************************************************************/
+/*                           msMapSetCenter()                           */
+/************************************************************************/
+
+int msMapSetCenter(mapObj *map, pointObj *center) {
+  return msMapOffsetExtent(
+      map, center->x - (map->extent.minx + map->extent.maxx) * 0.5,
+      center->y - (map->extent.miny + map->extent.maxy) * 0.5);
+}
+
+/************************************************************************/
+/*                           msMapSetRotation()                         */
+/************************************************************************/
+
+int msMapSetRotation(mapObj *map, double rotation_angle)
+
+{
+  map->gt.rotation_angle = rotation_angle;
+  if (map->gt.rotation_angle != 0.0)
+    map->gt.need_geotransform = MS_TRUE;
+  else
+    map->gt.need_geotransform = MS_FALSE;
+
+  return msMapComputeGeotransform(map);
+}
+
+/************************************************************************/
+/*                             msMapSetSize()                           */
+/************************************************************************/
+
+int msMapSetSize(mapObj *map, int width, int height)
+
+{
+  map->width = width;
+  map->height = height;
+
+  return msMapComputeGeotransform(map); /* like SetRotation -- sean */
+}
+
+/************************************************************************/
+/*                      msMapComputeGeotransform()                      */
+/************************************************************************/
+
+extern int InvGeoTransform(double *gt_in, double *gt_out);
+
+int msMapComputeGeotransformEx(mapObj *map, double resolutionX,
+                               double resolutionY)
+
+{
+  double rot_angle;
+  double geo_width, geo_height, center_x, center_y;
+
+  map->saved_extent = map->extent;
+
+  rot_angle = map->gt.rotation_angle * MS_PI / 180.0;
+
+  geo_width = map->extent.maxx - map->extent.minx;
+  geo_height = map->extent.maxy - map->extent.miny;
+
+  center_x = map->extent.minx + geo_width * 0.5;
+  center_y = map->extent.miny + geo_height * 0.5;
+
+  /*
+  ** Per bug 1916 we have to adjust for the fact that map extents
+  ** are based on the center of the edge pixels, not the outer
+  ** edges as is expected in a geotransform.
+  */
+  map->gt.geotransform[1] = cos(rot_angle) * resolutionX;
+  map->gt.geotransform[2] = sin(rot_angle) * resolutionY;
+  map->gt.geotransform[0] = center_x -
+                            (map->width * 0.5) * map->gt.geotransform[1] -
+                            (map->height * 0.5) * map->gt.geotransform[2];
+
+  map->gt.geotransform[4] = sin(rot_angle) * resolutionX;
+  map->gt.geotransform[5] = -cos(rot_angle) * resolutionY;
+  map->gt.geotransform[3] = center_y -
+                            (map->width * 0.5) * map->gt.geotransform[4] -
+                            (map->height * 0.5) * map->gt.geotransform[5];
+
+  if (InvGeoTransform(map->gt.geotransform, map->gt.invgeotransform))
+    return MS_SUCCESS;
+  else
+    return MS_FAILURE;
+}
+
+int msMapComputeGeotransform(mapObj *map)
+
+{
+  /* Do we have all required parameters? */
+  if (map->extent.minx == map->extent.maxx || map->width <= 1 ||
+      map->height <= 1)
+    return MS_FAILURE;
+
+  const double geo_width = map->extent.maxx - map->extent.minx;
+  const double geo_height = map->extent.maxy - map->extent.miny;
+  return msMapComputeGeotransformEx(map, geo_width / (map->width - 1),
+                                    geo_height / (map->height - 1));
+}
+
+/************************************************************************/
+/*                         msMapPixelToGeoref()                         */
+/************************************************************************/
+
+void msMapPixelToGeoref(mapObj *map, double *x, double *y)
+
+{
+  (void)map;
+  (void)x;
+  (void)y;
+  msSetError(MS_MISCERR, NULL, "msMapPixelToGeoref() not yet implemented");
+}
+
+/************************************************************************/
+/*                         msMapGeorefToPixel()                         */
+/************************************************************************/
+
+void msMapGeorefToPixel(mapObj *map, double *x, double *y)
+
+{
+  (void)map;
+  (void)x;
+  (void)y;
+  msSetError(MS_MISCERR, NULL, "msMapGeorefToPixel() not yet implemented");
+}
+
+/************************************************************************/
+/*                        msMapSetFakedExtent()                         */
+/************************************************************************/
+
+int msMapSetFakedExtent(mapObj *map)
+
+{
+  int i;
+  /* -------------------------------------------------------------------- */
+  /*      Remember the original map extents so we can restore them        */
+  /*      later.                                                          */
+  /* -------------------------------------------------------------------- */
+  map->saved_extent = map->extent;
+
+  /* -------------------------------------------------------------------- */
+  /*      Set extents such that the bottom left corner is 0,0 and the     */
+  /*      top right is width,height.  Note this is upside down from       */
+  /*      the normal sense of pixel/line coordiantes, but we do this      */
+  /*      so that the normal "extent" concept of coordinates              */
+  /*      increasing to the right, and up is maintained (like in          */
+  /*      georeferenced coordinate systems).                              */
+  /* -------------------------------------------------------------------- */
+  map->extent.minx = 0;
+  map->extent.maxx = map->width;
+  map->extent.miny = 0;
+  map->extent.maxy = map->height;
+  map->cellsize = 1.0;
+
+  /* -------------------------------------------------------------------- */
+  /*      When we copy the geotransform into the projection object we     */
+  /*      have to flip it to account for the preceeding upside-down       */
+  /*      coordinate system.                                              */
+  /* -------------------------------------------------------------------- */
+  map->projection.gt = map->gt;
+
+  map->projection.gt.geotransform[0] += map->height * map->gt.geotransform[2];
+  map->projection.gt.geotransform[3] += map->height * map->gt.geotransform[5];
+
+  map->projection.gt.geotransform[2] *= -1;
+  map->projection.gt.geotransform[5] *= -1;
+
+  for (i = 0; i < map->numlayers; i++)
+    GET_LAYER(map, i)->project = MS_TRUE;
+
+  return InvGeoTransform(map->projection.gt.geotransform,
+                         map->projection.gt.invgeotransform);
+}
+
+/************************************************************************/
+/*                      msMapRestoreRealExtent()                        */
+/************************************************************************/
+
+int msMapRestoreRealExtent(mapObj *map)
+
+{
+  map->projection.gt.need_geotransform = MS_FALSE;
+  map->extent = map->saved_extent;
+  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                      msInsertLayer()                                 */
+/************************************************************************/
+/* Returns the index at which the layer was inserted
+ */
+
+int msInsertLayer(mapObj *map, layerObj *layer, int nIndex) {
+  if (!layer) {
+    msSetError(MS_CHILDERR, "Can't insert a NULL Layer", "msInsertLayer()");
+    return -1;
+  }
+
+  /* Ensure there is room for a new layer */
+  if (map->numlayers == map->maxlayers) {
+    if (msGrowMapLayers(map) == NULL)
+      return -1;
+  }
+
+  /* msGrowMapLayers allocates the new layer which we don't need to do since we
+     have 1 that we are inserting not sure if it is possible for this to be non
+     null otherwise, but better to check since this function replaces the value
+   */
+  if (map->layers[map->numlayers] != NULL)
+    free(map->layers[map->numlayers]);
+
+  /* Catch attempt to insert past end of layers array */
+  if (nIndex >= map->numlayers) {
+    msSetError(MS_CHILDERR, "Cannot insert layer beyond index %d",
+               "msInsertLayer()", map->numlayers - 1);
+    return -1;
+  } else if (nIndex < 0) { /* Insert at the end by default */
+    map->layerorder[map->numlayers] = map->numlayers;
+    GET_LAYER(map, map->numlayers) = layer;
+    GET_LAYER(map, map->numlayers)->index = map->numlayers;
+    GET_LAYER(map, map->numlayers)->map = map;
+    MS_REFCNT_INCR(layer);
+    map->numlayers++;
+    return map->numlayers - 1;
+  } else {
+    /* Move existing layers at the specified nIndex or greater */
+    /* to an index one higher */
+    int i;
+    for (i = map->numlayers; i > nIndex; i--) {
+      GET_LAYER(map, i) = GET_LAYER(map, i - 1);
+      GET_LAYER(map, i)->index = i;
+    }
+
+    /* assign new layer to specified index */
+    GET_LAYER(map, nIndex) = layer;
+    GET_LAYER(map, nIndex)->index = nIndex;
+    GET_LAYER(map, nIndex)->map = map;
+
+    /* adjust layers drawing order */
+    for (i = map->numlayers; i > nIndex; i--) {
+      map->layerorder[i] = map->layerorder[i - 1];
+      if (map->layerorder[i] >= nIndex)
+        map->layerorder[i]++;
+    }
+    for (i = 0; i < nIndex; i++) {
+      if (map->layerorder[i] >= nIndex)
+        map->layerorder[i]++;
+    }
+    map->layerorder[nIndex] = nIndex;
+
+    /* increment number of layers and return */
+    MS_REFCNT_INCR(layer);
+    map->numlayers++;
+    return nIndex;
+  }
+}
+
+/************************************************************************/
+/*                           msRemoveLayer()                            */
+/************************************************************************/
+layerObj *msRemoveLayer(mapObj *map, int nIndex) {
+  int i;
+  int order_index;
+  layerObj *layer;
+
+  if (nIndex < 0 || nIndex >= map->numlayers) {
+    msSetError(MS_CHILDERR, "Cannot remove Layer, invalid index %d",
+               "msRemoveLayer()", nIndex);
+    return NULL;
+  } else {
+    layer = GET_LAYER(map, nIndex);
+    /* msCopyLayer(layer, (GET_LAYER(map, nIndex))); */
+
+    /* Iteratively copy the higher index layers down one index */
+    for (i = nIndex; i < map->numlayers - 1; i++) {
+      /* freeLayer((GET_LAYER(map, i))); */
+      /* initLayer((GET_LAYER(map, i)), map); */
+      /* msCopyLayer(GET_LAYER(map, i), GET_LAYER(map, i+1)); */
+      GET_LAYER(map, i) = GET_LAYER(map, i + 1);
+      GET_LAYER(map, i)->index = i;
+    }
+    /* Free the extra layer at the end */
+    /* freeLayer((GET_LAYER(map, map->numlayers-1))); */
+    GET_LAYER(map, map->numlayers - 1) = NULL;
+
+    /* Adjust drawing order */
+    order_index = 0;
+    for (i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] > nIndex)
+        map->layerorder[i]--;
+      if (map->layerorder[i] == nIndex) {
+        order_index = i;
+        break;
+      }
+    }
+    for (i = order_index; i < map->numlayers - 1; i++) {
+      map->layerorder[i] = map->layerorder[i + 1];
+      if (map->layerorder[i] > nIndex)
+        map->layerorder[i]--;
+    }
+
+    /* decrement number of layers and return copy of removed layer */
+    map->numlayers--;
+    layer->map = NULL;
+    MS_REFCNT_DECR(layer);
+    return layer;
+  }
+}
+
+/*
+** Move the layer's order for drawing purpose. Moving it up here
+** will have the effect of drawing the layer earlier.
+*/
+int msMoveLayerUp(mapObj *map, int nLayerIndex) {
+  int iCurrentIndex = -1;
+  if (map && nLayerIndex < map->numlayers && nLayerIndex >= 0) {
+    for (int i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] == nLayerIndex) {
+        iCurrentIndex = i;
+        break;
+      }
+    }
+    if (iCurrentIndex >= 0) {
+      /* we do not need to promote if it is the first one. */
+      if (iCurrentIndex == 0)
+        return MS_FAILURE;
+
+      map->layerorder[iCurrentIndex] = map->layerorder[iCurrentIndex - 1];
+      map->layerorder[iCurrentIndex - 1] = nLayerIndex;
+
+      return MS_SUCCESS;
+    }
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLayerUp()", nLayerIndex);
+  return MS_FAILURE;
+}
+
+/*
+** Move the layer's order for drawing purpose. Moving it down here
+** will have the effect of drawing the layer later.
+*/
+int msMoveLayerDown(mapObj *map, int nLayerIndex) {
+  int iCurrentIndex = -1;
+  if (map && nLayerIndex < map->numlayers && nLayerIndex >= 0) {
+    for (int i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] == nLayerIndex) {
+        iCurrentIndex = i;
+        break;
+      }
+    }
+    if (iCurrentIndex >= 0) {
+      /* we do not need to demote if it is the last one. */
+      if (iCurrentIndex == map->numlayers - 1)
+        return MS_FAILURE;
+
+      map->layerorder[iCurrentIndex] = map->layerorder[iCurrentIndex + 1];
+      map->layerorder[iCurrentIndex + 1] = nLayerIndex;
+
+      return MS_SUCCESS;
+    }
+  }
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLayerDown()",
+             nLayerIndex);
+  return MS_FAILURE;
+}
+
+/*
+** Set the array used for the drawing order. The array passed must contain
+** all the layer's index ordered by the drawing priority.
+** Ex : for 3 layers in the map file, if
+**                          panIndexes[0] = 2
+**                          panIndexes[1] = 0
+**                          panIndexes[2] = 1
+**                          will set the darwing order to layer 2, layer 0,
+**                          and then layer 1.
+**
+** Note : It is assumed that the index panIndexes has the same number of
+**        of elements as the number of layers in the map.
+** Return TRUE on success else FALSE.
+*/
+int msSetLayersdrawingOrder(mapObj *self, int *panIndexes) {
+  if (self && panIndexes) {
+    const int nElements = self->numlayers;
+    for (int i = 0; i < nElements; i++) {
+      int bFound = 0;
+      for (int j = 0; j < nElements; j++) {
+        if (panIndexes[j] == i) {
+          bFound = 1;
+          break;
+        }
+      }
+      if (!bFound)
+        return 0;
+    }
+    /* -------------------------------------------------------------------- */
+    /*    At this point the array is valid so update the layers order array.*/
+    /* -------------------------------------------------------------------- */
+    for (int i = 0; i < nElements; i++) {
+      self->layerorder[i] = panIndexes[i];
+    }
+    return 1;
+  }
+  return 0;
+}
+
+/* =========================================================================
+   msMapLoadOWSParameters
+
+   Function to support mapscript mapObj::loadOWSParameters
+   ========================================================================= */
+
+int msMapLoadOWSParameters(mapObj *map, cgiRequestObj *request,
+                           const char *wmtver) {
+#ifdef USE_WMS_SVR
+  int version;
+  char *wms_exception_format = NULL;
+  const char *wms_request = NULL;
+  int result, i = 0;
+  owsRequestObj ows_request;
+
+  msOWSInitRequestObj(&ows_request);
+
+  version = msOWSParseVersionString(wmtver);
+  for (i = 0; i < request->NumParams; i++) {
+    if (strcasecmp(request->ParamNames[i], "EXCEPTIONS") == 0)
+      wms_exception_format = request->ParamValues[i];
+    else if (strcasecmp(request->ParamNames[i], "REQUEST") == 0)
+      wms_request = request->ParamValues[i];
+  }
+
+  msOWSRequestLayersEnabled(map, "M", wms_request, &ows_request);
+
+  result = msWMSLoadGetMapParams(
+      map, version, request->ParamNames, request->ParamValues,
+      request->NumParams, wms_exception_format, wms_request, &ows_request);
+
+  msOWSClearRequestObj(&ows_request);
+
+  return result;
+
+#else
+  msSetError(MS_WMSERR, "WMS server support is not available.",
+             "msMapLoadOWSParameters()");
+  return MS_FAILURE;
+#endif
+}
diff -pruN 8.0.1-5/src/mapogcapi.cpp 8.2.0~beta1-1~exp1/src/mapogcapi.cpp
--- 8.0.1-5/src/mapogcapi.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcapi.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2038 @@
+/**********************************************************************
+ * $id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGCAPI Implementation
+ * Author:   Steve Lime and the MapServer team.
+ *
+ **********************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+#include "mapserver.h"
+#include "mapogcapi.h"
+#include "mapows.h"
+#include "mapgml.h"
+#include "maptime.h"
+
+#include "cpl_conv.h"
+
+#include "third-party/include_nlohmann_json.hpp"
+#include "third-party/include_pantor_inja.hpp"
+
+#include <algorithm>
+#include <map>
+#include <string>
+#include <iostream>
+#include <utility>
+
+using namespace inja;
+using json = nlohmann::json;
+
+#define OGCAPI_DEFAULT_TITLE "MapServer OGC API"
+
+/*
+** HTML Templates
+*/
+#define OGCAPI_TEMPLATE_HTML_LANDING "landing.html"
+#define OGCAPI_TEMPLATE_HTML_CONFORMANCE "conformance.html"
+#define OGCAPI_TEMPLATE_HTML_COLLECTION "collection.html"
+#define OGCAPI_TEMPLATE_HTML_COLLECTIONS "collections.html"
+#define OGCAPI_TEMPLATE_HTML_COLLECTION_ITEMS "collection-items.html"
+#define OGCAPI_TEMPLATE_HTML_COLLECTION_ITEM "collection-item.html"
+#define OGCAPI_TEMPLATE_HTML_OPENAPI "openapi.html"
+
+enum class OGCAPIFormat { JSON, GeoJSON, OpenAPI_V3, HTML };
+
+#define OGCAPI_MIMETYPE_JSON "application/json"
+#define OGCAPI_MIMETYPE_GEOJSON "application/geo+json"
+#define OGCAPI_MIMETYPE_OPENAPI_V3                                             \
+  "application/vnd.oai.openapi+json;version=3.0"
+#define OGCAPI_MIMETYPE_HTML "text/html"
+
+#define OGCAPI_DEFAULT_LIMIT 10 // by specification
+#define OGCAPI_MAX_LIMIT 10000
+
+#define OGCAPI_DEFAULT_GEOMETRY_PRECISION 6
+
+constexpr const char *EPSG_PREFIX_URL =
+    "http://www.opengis.net/def/crs/EPSG/0/";
+constexpr const char *CRS84_URL =
+    "http://www.opengis.net/def/crs/OGC/1.3/CRS84";
+
+#ifdef USE_OGCAPI_SVR
+
+// Error types
+typedef enum {
+  OGCAPI_SERVER_ERROR = 0,
+  OGCAPI_CONFIG_ERROR = 1,
+  OGCAPI_PARAM_ERROR = 2,
+  OGCAPI_NOT_FOUND_ERROR = 3,
+} OGCAPIErrorType;
+
+/*
+** Returns a JSON object using and a description.
+*/
+static void outputError(OGCAPIErrorType errorType,
+                        const std::string &description) {
+  const char *code = "";
+  const char *status = "";
+  switch (errorType) {
+  case OGCAPI_SERVER_ERROR: {
+    code = "ServerError";
+    status = "500";
+    break;
+  }
+  case OGCAPI_CONFIG_ERROR: {
+    code = "ConfigError";
+    status = "500";
+    break;
+  }
+  case OGCAPI_PARAM_ERROR: {
+    code = "InvalidParameterValue";
+    status = "400";
+    break;
+  }
+  case OGCAPI_NOT_FOUND_ERROR: {
+    code = "NotFound";
+    status = "404";
+    break;
+  }
+  }
+
+  json j = {{"code", code}, {"description", description}};
+
+  msIO_setHeader("Content-Type", "%s", OGCAPI_MIMETYPE_JSON);
+  msIO_setHeader("Status", "%s", status);
+  msIO_sendHeaders();
+  msIO_printf("%s\n", j.dump().c_str());
+}
+
+static int includeLayer(mapObj *map, layerObj *layer) {
+  if (!msOWSRequestIsEnabled(map, layer, "AO", "OGCAPI", MS_FALSE) ||
+      !msWFSIsLayerSupported(layer) || !msIsLayerQueryable(layer)) {
+    return MS_FALSE;
+  } else {
+    return MS_TRUE;
+  }
+}
+
+/*
+** Get stuff...
+*/
+
+/*
+** Returns the value associated with an item from the request's query string and
+*NULL if the item was not found.
+*/
+static const char *getRequestParameter(cgiRequestObj *request,
+                                       const char *item) {
+  int i;
+
+  for (i = 0; i < request->NumParams; i++) {
+    if (strcmp(item, request->ParamNames[i]) == 0)
+      return request->ParamValues[i];
+  }
+
+  return NULL;
+}
+
+static int getMaxLimit(mapObj *map, layerObj *layer) {
+  int max_limit = OGCAPI_MAX_LIMIT;
+  const char *value;
+
+  // check metadata, layer then map
+  value = msOWSLookupMetadata(&(layer->metadata), "A", "max_limit");
+  if (value == NULL)
+    value = msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
+
+  if (value != NULL) {
+    int status = msStringToInt(value, &max_limit, 10);
+    if (status != MS_SUCCESS)
+      max_limit = OGCAPI_MAX_LIMIT; // conversion failed
+  }
+
+  return max_limit;
+}
+
+static int getDefaultLimit(mapObj *map, layerObj *layer) {
+  int default_limit = OGCAPI_DEFAULT_LIMIT;
+
+  // check metadata, layer then map
+  const char *value =
+      msOWSLookupMetadata(&(layer->metadata), "A", "default_limit");
+  if (value == NULL)
+    value = msOWSLookupMetadata(&(map->web.metadata), "A", "default_limit");
+
+  if (value != NULL) {
+    int status = msStringToInt(value, &default_limit, 10);
+    if (status != MS_SUCCESS)
+      default_limit = OGCAPI_DEFAULT_LIMIT; // conversion failed
+  }
+
+  return default_limit;
+}
+
+/*
+** Returns the limit as an int - between 1 and getMaxLimit(). We always return a
+*valid value...
+*/
+static int getLimit(mapObj *map, cgiRequestObj *request, layerObj *layer,
+                    int *limit) {
+  int status;
+  const char *p;
+
+  int max_limit;
+  max_limit = getMaxLimit(map, layer);
+
+  p = getRequestParameter(request, "limit");
+  if (!p || (p && strlen(p) == 0)) { // missing or empty
+    *limit = MS_MIN(getDefaultLimit(map, layer),
+                    max_limit); // max could be smaller than the default
+  } else {
+    status = msStringToInt(p, limit, 10);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+
+    if (*limit <= 0) {
+      *limit = MS_MIN(getDefaultLimit(map, layer),
+                      max_limit); // max could be smaller than the default
+    } else {
+      *limit = MS_MIN(*limit, max_limit);
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+// Return the content of the "crs" member of the /collections/{name} response
+static json getCrsList(mapObj *map, layerObj *layer) {
+  char *pszSRSList = NULL;
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "AOF", MS_FALSE,
+                   &pszSRSList);
+  if (!pszSRSList)
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "AOF", MS_FALSE,
+                     &pszSRSList);
+  json jCrsList;
+  if (pszSRSList) {
+    const auto tokens = msStringSplit(pszSRSList, ' ');
+    for (const auto &crs : tokens) {
+      if (crs.find("EPSG:") == 0) {
+        if (jCrsList.empty()) {
+          jCrsList.push_back(CRS84_URL);
+        }
+        const std::string url =
+            std::string(EPSG_PREFIX_URL) + crs.substr(strlen("EPSG:"));
+        jCrsList.push_back(url);
+      }
+    }
+    msFree(pszSRSList);
+  }
+  return jCrsList;
+}
+
+// Return the content of the "storageCrs" member of the /collections/{name}
+// response
+static std::string getStorageCrs(layerObj *layer) {
+  std::string storageCrs;
+  char *pszFirstSRS = nullptr;
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "AOF", MS_TRUE,
+                   &pszFirstSRS);
+  if (pszFirstSRS) {
+    if (std::string(pszFirstSRS).find("EPSG:") == 0) {
+      storageCrs =
+          std::string(EPSG_PREFIX_URL) + (pszFirstSRS + strlen("EPSG:"));
+    }
+    msFree(pszFirstSRS);
+  }
+  return storageCrs;
+}
+
+/*
+** Returns the bbox in output CRS (CRS84 by default, or "crs" request parameter
+*when specified)
+*/
+static bool getBbox(mapObj *map, layerObj *layer, cgiRequestObj *request,
+                    rectObj *bbox, projectionObj *outputProj) {
+  int status;
+
+  const char *bboxParam = getRequestParameter(request, "bbox");
+  if (!bboxParam ||
+      strlen(bboxParam) == 0) { // missing or empty - assign map->extent (no
+                                // projection necessary)
+    bbox->minx = map->extent.minx;
+    bbox->miny = map->extent.miny;
+    bbox->maxx = map->extent.maxx;
+    bbox->maxy = map->extent.maxy;
+  } else {
+    const auto tokens = msStringSplit(bboxParam, ',');
+    if (tokens.size() != 4) {
+      outputError(OGCAPI_PARAM_ERROR, "Bad value for bbox.");
+      return false;
+    }
+
+    double values[4];
+    for (int i = 0; i < 4; i++) {
+      status = msStringToDouble(tokens[i].c_str(), &values[i]);
+      if (status != MS_SUCCESS) {
+        outputError(OGCAPI_PARAM_ERROR, "Bad value for bbox.");
+        return false;
+      }
+    }
+
+    bbox->minx = values[0]; // assign
+    bbox->miny = values[1];
+    bbox->maxx = values[2];
+    bbox->maxy = values[3];
+
+    // validate bbox is well-formed (degenerate is ok)
+    if (MS_VALID_SEARCH_EXTENT(*bbox) != MS_TRUE) {
+      outputError(OGCAPI_PARAM_ERROR, "Bad value for bbox.");
+      return false;
+    }
+
+    std::string bboxCrs = "EPSG:4326";
+    bool axisInverted =
+        false; // because above EPSG:4326 is meant to be OGC:CRS84 actually
+    const char *bboxCrsParam = getRequestParameter(request, "bbox-crs");
+    if (bboxCrsParam) {
+      bool isExpectedCrs = false;
+      for (const auto &crsItem : getCrsList(map, layer)) {
+        if (bboxCrsParam == crsItem.get<std::string>()) {
+          isExpectedCrs = true;
+          break;
+        }
+      }
+      if (!isExpectedCrs) {
+        outputError(OGCAPI_PARAM_ERROR, "Bad value for bbox-crs.");
+        return false;
+      }
+      if (std::string(bboxCrsParam) != CRS84_URL) {
+        if (std::string(bboxCrsParam).find(EPSG_PREFIX_URL) == 0) {
+          const char *code = bboxCrsParam + strlen(EPSG_PREFIX_URL);
+          bboxCrs = std::string("EPSG:") + code;
+          axisInverted = msIsAxisInverted(atoi(code));
+        }
+      }
+    }
+    if (axisInverted) {
+      std::swap(bbox->minx, bbox->miny);
+      std::swap(bbox->maxx, bbox->maxy);
+    }
+
+    projectionObj bboxProj;
+    msInitProjection(&bboxProj);
+    msProjectionInheritContextFrom(&bboxProj, &(map->projection));
+    if (msLoadProjectionString(&bboxProj, bboxCrs.c_str()) != 0) {
+      msFreeProjection(&bboxProj);
+      outputError(OGCAPI_SERVER_ERROR, "Cannot process bbox-crs.");
+      return false;
+    }
+
+    status = msProjectRect(&bboxProj, outputProj, bbox);
+    msFreeProjection(&bboxProj);
+    if (status != MS_SUCCESS) {
+      outputError(OGCAPI_SERVER_ERROR,
+                  "Cannot reproject bbox from bbox-crs to output CRS.");
+      return false;
+    }
+  }
+
+  return true;
+}
+
+/*
+** Returns the template directory location or NULL if it isn't set.
+*/
+static std::string getTemplateDirectory(mapObj *map, const char *key,
+                                        const char *envvar) {
+  const char *directory;
+
+  directory = msOWSLookupMetadata(&(map->web.metadata), "A", key);
+
+  if (directory == NULL) {
+    directory = CPLGetConfigOption(envvar, NULL);
+  }
+
+  std::string s;
+  if (directory != NULL) {
+    s = directory;
+    if (!s.empty() && (s.back() != '/' && s.back() != '\\')) {
+      // add a trailing slash if missing
+      std::string slash = "/";
+#ifdef _WIN32
+      slash = "\\";
+#endif
+      s += slash;
+    }
+  }
+
+  return s;
+}
+
+/*
+** Returns the service title from oga_{key} and/or ows_{key} or a default value
+*if not set.
+*/
+static const char *getWebMetadata(mapObj *map, const char *domain,
+                                  const char *key, const char *defaultVal) {
+  const char *value;
+
+  if ((value = msOWSLookupMetadata(&(map->web.metadata), domain, key)) != NULL)
+    return value;
+  else
+    return defaultVal;
+}
+
+/*
+** Returns the service title from oga|ows_title or a default value if not set.
+*/
+static const char *getTitle(mapObj *map) {
+  return getWebMetadata(map, "OA", "title", OGCAPI_DEFAULT_TITLE);
+}
+
+/*
+** Returns the API root URL from oga_onlineresource or builds a value if not
+*set.
+*/
+static std::string getApiRootUrl(mapObj *map) {
+  const char *root;
+
+  if ((root = msOWSLookupMetadata(&(map->web.metadata), "A",
+                                  "onlineresource")) != NULL)
+    return std::string(root);
+  else
+    return "http://" + std::string(getenv("SERVER_NAME")) + ":" +
+           std::string(getenv("SERVER_PORT")) +
+           std::string(getenv("SCRIPT_NAME")) +
+           std::string(getenv("PATH_INFO"));
+}
+
+static json getFeatureConstant(const gmlConstantObj *constant) {
+  json j; // empty (null)
+
+  if (!constant)
+    throw std::runtime_error("Null constant metadata.");
+  if (!constant->value)
+    return j;
+
+  // initialize
+  j = {{constant->name, constant->value}};
+
+  return j;
+}
+
+static json getFeatureItem(const gmlItemObj *item, const char *value) {
+  json j; // empty (null)
+  const char *key;
+
+  if (!item)
+    throw std::runtime_error("Null item metadata.");
+  if (!item->visible)
+    return j;
+
+  if (item->alias)
+    key = item->alias;
+  else
+    key = item->name;
+
+  // initialize
+  j = {{key, value}};
+
+  if (item->type &&
+      (EQUAL(item->type, "Date") || EQUAL(item->type, "DateTime") ||
+       EQUAL(item->type, "Time"))) {
+    struct tm tm;
+    if (msParseTime(value, &tm) == MS_TRUE) {
+      char tmpValue[64];
+      if (EQUAL(item->type, "Date"))
+        snprintf(tmpValue, sizeof(tmpValue), "%04d-%02d-%02d",
+                 tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday);
+      else if (EQUAL(item->type, "Time"))
+        snprintf(tmpValue, sizeof(tmpValue), "%02d:%02d:%02dZ", tm.tm_hour,
+                 tm.tm_min, tm.tm_sec);
+      else
+        snprintf(tmpValue, sizeof(tmpValue), "%04d-%02d-%02dT%02d:%02d:%02dZ",
+                 tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour,
+                 tm.tm_min, tm.tm_sec);
+
+      j = {{key, tmpValue}};
+    }
+  } else if (item->type &&
+             (EQUAL(item->type, "Integer") || EQUAL(item->type, "Long"))) {
+    try {
+      j = {{key, std::stoll(value)}};
+    } catch (const std::exception &) {
+    }
+  } else if (item->type && EQUAL(item->type, "Real")) {
+    try {
+      j = {{key, std::stod(value)}};
+    } catch (const std::exception &) {
+    }
+  } else if (item->type && EQUAL(item->type, "Boolean")) {
+    if (EQUAL(value, "0") || EQUAL(value, "false")) {
+      j = {{key, false}};
+    } else {
+      j = {{key, true}};
+    }
+  }
+
+  return j;
+}
+
+static double round_down(double value, int decimal_places) {
+  const double multiplier = std::pow(10.0, decimal_places);
+  return std::floor(value * multiplier) / multiplier;
+}
+// https://stackoverflow.com/questions/25925290/c-round-a-double-up-to-2-decimal-places
+static double round_up(double value, int decimal_places) {
+  const double multiplier = std::pow(10.0, decimal_places);
+  return std::ceil(value * multiplier) / multiplier;
+}
+
+static json getFeatureGeometry(shapeObj *shape, int precision,
+                               bool outputCrsAxisInverted) {
+  json geometry; // empty (null)
+  int *outerList = NULL, numOuterRings = 0;
+
+  if (!shape)
+    throw std::runtime_error("Null shape.");
+
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints == 0) // not enough info for a point
+      return geometry;
+
+    if (shape->line[0].numpoints == 1) {
+      geometry["type"] = "Point";
+      double x = shape->line[0].point[0].x;
+      double y = shape->line[0].point[0].y;
+      if (outputCrsAxisInverted)
+        std::swap(x, y);
+      geometry["coordinates"] = {round_up(x, precision),
+                                 round_up(y, precision)};
+    } else {
+      geometry["type"] = "MultiPoint";
+      geometry["coordinates"] = json::array();
+      for (int j = 0; j < shape->line[0].numpoints; j++) {
+        double x = shape->line[0].point[j].x;
+        double y = shape->line[0].point[j].y;
+        if (outputCrsAxisInverted)
+          std::swap(x, y);
+        geometry["coordinates"].push_back(
+            {round_up(x, precision), round_up(y, precision)});
+      }
+    }
+    break;
+  case (MS_SHAPE_LINE):
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints < 2) // not enough info for a line
+      return geometry;
+
+    if (shape->numlines == 1) {
+      geometry["type"] = "LineString";
+      geometry["coordinates"] = json::array();
+      for (int j = 0; j < shape->line[0].numpoints; j++) {
+        double x = shape->line[0].point[j].x;
+        double y = shape->line[0].point[j].y;
+        if (outputCrsAxisInverted)
+          std::swap(x, y);
+        geometry["coordinates"].push_back(
+            {round_up(x, precision), round_up(y, precision)});
+      }
+    } else {
+      geometry["type"] = "MultiLineString";
+      geometry["coordinates"] = json::array();
+      for (int i = 0; i < shape->numlines; i++) {
+        json part = json::array();
+        for (int j = 0; j < shape->line[i].numpoints; j++) {
+          double x = shape->line[i].point[j].x;
+          double y = shape->line[i].point[j].y;
+          if (outputCrsAxisInverted)
+            std::swap(x, y);
+          part.push_back({round_up(x, precision), round_up(y, precision)});
+        }
+        geometry["coordinates"].push_back(part);
+      }
+    }
+    break;
+  case (MS_SHAPE_POLYGON):
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints <
+            4) // not enough info for a polygon (first=last)
+      return geometry;
+
+    outerList = msGetOuterList(shape);
+    if (outerList == NULL)
+      throw std::runtime_error("Unable to allocate list of outer rings.");
+    for (int k = 0; k < shape->numlines; k++) {
+      if (outerList[k] == MS_TRUE)
+        numOuterRings++;
+    }
+
+    if (numOuterRings == 1) {
+      geometry["type"] = "Polygon";
+      geometry["coordinates"] = json::array();
+      for (int i = 0; i < shape->numlines; i++) {
+        json part = json::array();
+        for (int j = 0; j < shape->line[i].numpoints; j++) {
+          double x = shape->line[i].point[j].x;
+          double y = shape->line[i].point[j].y;
+          if (outputCrsAxisInverted)
+            std::swap(x, y);
+          part.push_back({round_up(x, precision), round_up(y, precision)});
+        }
+        geometry["coordinates"].push_back(part);
+      }
+    } else {
+      geometry["type"] = "MultiPolygon";
+      geometry["coordinates"] = json::array();
+
+      for (int k = 0; k < shape->numlines; k++) {
+        if (outerList[k] ==
+            MS_TRUE) { // outer ring: generate polygon and add to coordinates
+          int *innerList = msGetInnerList(shape, k, outerList);
+          if (innerList == NULL) {
+            msFree(outerList);
+            throw std::runtime_error("Unable to allocate list of inner rings.");
+          }
+
+          json polygon = json::array();
+          for (int i = 0; i < shape->numlines; i++) {
+            if (i == k ||
+                outerList[i] ==
+                    MS_TRUE) { // add outer ring (k) and any inner rings
+              json part = json::array();
+              for (int j = 0; j < shape->line[i].numpoints; j++) {
+                double x = shape->line[i].point[j].x;
+                double y = shape->line[i].point[j].y;
+                if (outputCrsAxisInverted)
+                  std::swap(x, y);
+                part.push_back(
+                    {round_up(x, precision), round_up(y, precision)});
+              }
+              polygon.push_back(part);
+            }
+          }
+
+          msFree(innerList);
+          geometry["coordinates"].push_back(polygon);
+        }
+      }
+    }
+    msFree(outerList);
+    break;
+  default:
+    throw std::runtime_error("Invalid shape type.");
+    break;
+  }
+
+  return geometry;
+}
+
+/*
+** Return a GeoJSON representation of a shape.
+*/
+static json getFeature(layerObj *layer, shapeObj *shape, gmlItemListObj *items,
+                       gmlConstantListObj *constants, int geometry_precision,
+                       bool outputCrsAxisInverted) {
+  int i;
+  json feature; // empty (null)
+
+  if (!layer || !shape)
+    throw std::runtime_error("Null arguments.");
+
+  // initialize
+  feature = {{"type", "Feature"}, {"properties", json::object()}};
+
+  // id
+  const char *featureIdItem =
+      msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
+  if (featureIdItem == NULL)
+    throw std::runtime_error(
+        "Missing required featureid metadata."); // should have been trapped
+                                                 // earlier
+  for (i = 0; i < items->numitems; i++) {
+    if (strcasecmp(featureIdItem, items->items[i].name) == 0) {
+      feature["id"] = shape->values[i];
+      break;
+    }
+  }
+
+  if (i == items->numitems)
+    throw std::runtime_error("Feature id not found.");
+
+  // properties - build from items and constants, no group support for now
+
+  for (int i = 0; i < items->numitems; i++) {
+    try {
+      json item = getFeatureItem(&(items->items[i]), shape->values[i]);
+      if (!item.is_null())
+        feature["properties"].insert(item.begin(), item.end());
+    } catch (const std::runtime_error &) {
+      throw std::runtime_error("Error fetching item.");
+    }
+  }
+
+  for (int i = 0; i < constants->numconstants; i++) {
+    try {
+      json constant = getFeatureConstant(&(constants->constants[i]));
+      if (!constant.is_null())
+        feature["properties"].insert(constant.begin(), constant.end());
+    } catch (const std::runtime_error &) {
+      throw std::runtime_error("Error fetching constant.");
+    }
+  }
+
+  // geometry
+  try {
+    json geometry =
+        getFeatureGeometry(shape, geometry_precision, outputCrsAxisInverted);
+    if (!geometry.is_null())
+      feature["geometry"] = std::move(geometry);
+  } catch (const std::runtime_error &) {
+    throw std::runtime_error("Error fetching geometry.");
+  }
+
+  return feature;
+}
+
+static json getLink(hashTableObj *metadata, const std::string &name) {
+  json link;
+
+  const char *href =
+      msOWSLookupMetadata(metadata, "A", (name + "_href").c_str());
+  if (!href)
+    throw std::runtime_error("Missing required link href property.");
+
+  const char *title =
+      msOWSLookupMetadata(metadata, "A", (name + "_title").c_str());
+  const char *type =
+      msOWSLookupMetadata(metadata, "A", (name + "_type").c_str());
+
+  link = {{"href", href},
+          {"title", title ? title : href},
+          {"type", type ? type : "text/html"}};
+
+  return link;
+}
+
+static const char *getCollectionDescription(layerObj *layer) {
+  const char *description =
+      msOWSLookupMetadata(&(layer->metadata), "A", "description");
+  if (!description)
+    description = msOWSLookupMetadata(&(layer->metadata), "OF",
+                                      "abstract"); // fallback on abstract
+  if (!description)
+    description =
+        "<!-- Warning: unable to set the collection description. -->"; // finally
+                                                                       // a
+                                                                       // warning...
+  return description;
+}
+
+static const char *getCollectionTitle(layerObj *layer) {
+  const char *title = msOWSLookupMetadata(&(layer->metadata), "AOF", "title");
+  if (!title)
+    title = layer->name; // revert to layer name if no title found
+  return title;
+}
+
+static int getGeometryPrecision(mapObj *map, layerObj *layer) {
+  int geometry_precision = OGCAPI_DEFAULT_GEOMETRY_PRECISION;
+  if (msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision")) {
+    geometry_precision = atoi(
+        msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision"));
+  } else if (msOWSLookupMetadata(&map->web.metadata, "AF",
+                                 "geometry_precision")) {
+    geometry_precision = atoi(
+        msOWSLookupMetadata(&map->web.metadata, "AF", "geometry_precision"));
+  }
+  return geometry_precision;
+}
+
+static json getCollection(mapObj *map, layerObj *layer, OGCAPIFormat format) {
+  json collection; // empty (null)
+  rectObj bbox;
+
+  if (!map || !layer)
+    return collection;
+
+  if (!includeLayer(map, layer))
+    return collection;
+
+  // initialize some things
+  std::string api_root = getApiRootUrl(map);
+
+  if (msOWSGetLayerExtent(map, layer, "AOF", &bbox) == MS_SUCCESS) {
+    if (layer->projection.numargs > 0)
+      msOWSProjectToWGS84(&layer->projection, &bbox);
+    else if (map->projection.numargs > 0)
+      msOWSProjectToWGS84(&map->projection, &bbox);
+    else
+      throw std::runtime_error(
+          "Unable to transform bounding box, no projection defined.");
+  } else {
+    throw std::runtime_error(
+        "Unable to get collection bounding box."); // might be too harsh since
+                                                   // extent is optional
+  }
+
+  const char *description = getCollectionDescription(layer);
+  const char *title = getCollectionTitle(layer);
+
+  const char *id = layer->name;
+  char *id_encoded = msEncodeUrl(id); // free after use
+
+  const int geometry_precision = getGeometryPrecision(map, layer);
+
+  // build collection object
+  collection = {{"id", id},
+                {"description", description},
+                {"title", title},
+                {"extent",
+                 {{"spatial",
+                   {{"bbox",
+                     {{round_down(bbox.minx, geometry_precision),
+                       round_down(bbox.miny, geometry_precision),
+                       round_up(bbox.maxx, geometry_precision),
+                       round_up(bbox.maxy, geometry_precision)}}},
+                    {"crs", CRS84_URL}}}}},
+                {"links",
+                 {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+                   {"type", OGCAPI_MIMETYPE_JSON},
+                   {"title", "This collection as JSON"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "?f=json"}},
+                  {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+                   {"type", OGCAPI_MIMETYPE_HTML},
+                   {"title", "This collection as HTML"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "?f=html"}},
+                  {{"rel", "items"},
+                   {"type", OGCAPI_MIMETYPE_GEOJSON},
+                   {"title", "Items for this collection as GeoJSON"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "/items?f=json"}},
+                  {{"rel", "items"},
+                   {"type", OGCAPI_MIMETYPE_HTML},
+                   {"title", "Items for this collection as HTML"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "/items?f=html"}}
+
+                 }},
+                {"itemType", "feature"}};
+
+  msFree(id_encoded); // done
+
+  // handle optional configuration (keywords and links)
+  const char *value = msOWSLookupMetadata(&(layer->metadata), "A", "keywords");
+  if (!value)
+    value = msOWSLookupMetadata(&(layer->metadata), "OF",
+                                "keywordlist"); // fallback on keywordlist
+  if (value) {
+    std::vector<std::string> keywords = msStringSplit(value, ',');
+    for (const std::string &keyword : keywords) {
+      collection["keywords"].push_back(keyword);
+    }
+  }
+
+  value = msOWSLookupMetadata(&(layer->metadata), "A", "links");
+  if (value) {
+    std::vector<std::string> names = msStringSplit(value, ',');
+    for (const std::string &name : names) {
+      try {
+        json link = getLink(&(layer->metadata), name);
+        collection["links"].push_back(link);
+      } catch (const std::runtime_error &e) {
+        throw e;
+      }
+    }
+  }
+
+  // Part 2 - CRS support
+  // Inspect metadata to set the "crs": [] member and "storageCrs" member
+
+  json jCrsList = getCrsList(map, layer);
+  if (!jCrsList.empty()) {
+    collection["crs"] = std::move(jCrsList);
+
+    std::string storageCrs = getStorageCrs(layer);
+    if (!storageCrs.empty()) {
+      collection["storageCrs"] = std::move(storageCrs);
+    }
+  }
+
+  return collection;
+}
+
+/*
+** Output stuff...
+*/
+
+static void outputJson(const json &j, const char *mimetype,
+                       const std::map<std::string, std::string> &extraHeaders) {
+  std::string js;
+
+  try {
+    js = j.dump();
+  } catch (...) {
+    outputError(OGCAPI_CONFIG_ERROR, "Invalid UTF-8 data, check encoding.");
+    return;
+  }
+
+  msIO_setHeader("Content-Type", "%s", mimetype);
+  for (const auto &kvp : extraHeaders) {
+    msIO_setHeader(kvp.first.c_str(), "%s", kvp.second.c_str());
+  }
+  msIO_sendHeaders();
+  msIO_printf("%s\n", js.c_str());
+}
+
+static void outputTemplate(const char *directory, const char *filename,
+                           const json &j, const char *mimetype) {
+  std::string _directory(directory);
+  std::string _filename(filename);
+  Environment env{_directory}; // catch
+
+  // ERB-style instead of Mustache (we'll see)
+  // env.set_expression("<%=", "%>");
+  // env.set_statement("<%", "%>");
+
+  // callbacks, need:
+  //   - match (regex)
+  //   - contains (substring)
+  //   - URL encode
+
+  try {
+    std::string js = j.dump();
+  } catch (...) {
+    outputError(OGCAPI_CONFIG_ERROR, "Invalid UTF-8 data, check encoding.");
+    return;
+  }
+
+  try {
+    Template t = env.parse_template(_filename); // catch
+    std::string result = env.render(t, j);
+
+    msIO_setHeader("Content-Type", "%s", mimetype);
+    msIO_sendHeaders();
+    msIO_printf("%s\n", result.c_str());
+  } catch (const inja::RenderError &e) {
+    outputError(OGCAPI_CONFIG_ERROR, "Template rendering error. " +
+                                         std::string(e.what()) + " (" +
+                                         std::string(filename) + ").");
+    return;
+  } catch (const inja::InjaError &e) {
+    outputError(OGCAPI_CONFIG_ERROR, "InjaError error. " +
+                                         std::string(e.what()) + " (" +
+                                         std::string(filename) + ")." + " (" +
+                                         std::string(directory) + ").");
+    return;
+  } catch (...) {
+    outputError(OGCAPI_SERVER_ERROR, "General template handling error.");
+    return;
+  }
+}
+
+/*
+** Generic response output.
+*/
+static void
+outputResponse(mapObj *map, cgiRequestObj *request, OGCAPIFormat format,
+               const char *filename, const json &response,
+               const std::map<std::string, std::string> &extraHeaders =
+                   std::map<std::string, std::string>()) {
+  std::string path;
+  char fullpath[MS_MAXPATHLEN];
+
+  if (format == OGCAPIFormat::JSON) {
+    outputJson(response, OGCAPI_MIMETYPE_JSON, extraHeaders);
+  } else if (format == OGCAPIFormat::GeoJSON) {
+    outputJson(response, OGCAPI_MIMETYPE_GEOJSON, extraHeaders);
+  } else if (format == OGCAPIFormat::OpenAPI_V3) {
+    outputJson(response, OGCAPI_MIMETYPE_OPENAPI_V3, extraHeaders);
+  } else if (format == OGCAPIFormat::HTML) {
+    path = getTemplateDirectory(map, "html_template_directory",
+                                "OGCAPI_HTML_TEMPLATE_DIRECTORY");
+    if (path.empty()) {
+      outputError(OGCAPI_CONFIG_ERROR, "Template directory not set.");
+      return; // bail
+    }
+    msBuildPath(fullpath, map->mappath, path.c_str());
+
+    json j;
+
+    j["response"] = response; // nest the response so we could write the whole
+                              // object in the template
+
+    // extend the JSON with a few things that we need for templating
+    j["template"] = {{"path", json::array()},
+                     {"params", json::object()},
+                     {"api_root", getApiRootUrl(map)},
+                     {"title", getTitle(map)},
+                     {"tags", json::object()}};
+
+    // api path
+    for (int i = 0; i < request->api_path_length; i++)
+      j["template"]["path"].push_back(request->api_path[i]);
+
+    // parameters (optional)
+    for (int i = 0; i < request->NumParams; i++) {
+      if (request->ParamValues[i] &&
+          strlen(request->ParamValues[i]) > 0) { // skip empty params
+        j["template"]["params"].update(
+            {{request->ParamNames[i], request->ParamValues[i]}});
+      }
+    }
+
+    // add custom tags (optional)
+    const char *tags =
+        msOWSLookupMetadata(&(map->web.metadata), "A", "html_tags");
+    if (tags) {
+      std::vector<std::string> names = msStringSplit(tags, ',');
+      for (std::string name : names) {
+        const char *value = msOWSLookupMetadata(&(map->web.metadata), "A",
+                                                ("tag_" + name).c_str());
+        if (value) {
+          j["template"]["tags"].update({{name, value}}); // add object
+        }
+      }
+    }
+
+    outputTemplate(fullpath, filename, j, OGCAPI_MIMETYPE_HTML);
+  } else {
+    outputError(OGCAPI_PARAM_ERROR, "Unsupported format requested.");
+  }
+}
+
+/*
+** Process stuff...
+*/
+static int processLandingRequest(mapObj *map, cgiRequestObj *request,
+                                 OGCAPIFormat format) {
+  json response;
+
+  // define ambiguous elements
+  const char *description =
+      msOWSLookupMetadata(&(map->web.metadata), "A", "description");
+  if (!description)
+    description =
+        msOWSLookupMetadata(&(map->web.metadata), "OF",
+                            "abstract"); // fallback on abstract if necessary
+
+  // define api root url
+  std::string api_root = getApiRootUrl(map);
+
+  // build response object
+  //   - consider conditionally excluding links for HTML format
+  response = {
+      {"title", getTitle(map)},
+      {"description", description ? description : ""},
+      {"links",
+       {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title", "This document as JSON"},
+         {"href", api_root + "?f=json"}},
+        {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "This document as HTML"},
+         {"href", api_root + "?f=html"}},
+        {{"rel", "conformance"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title",
+          "OCG API conformance classes implemented by this server (JSON)"},
+         {"href", api_root + "/conformance?f=json"}},
+        {{"rel", "conformance"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "OCG API conformance classes implemented by this server"},
+         {"href", api_root + "/conformance?f=html"}},
+        {{"rel", "data"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title", "Information about feature collections available from this "
+                   "server (JSON)"},
+         {"href", api_root + "/collections?f=json"}},
+        {{"rel", "data"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title",
+          "Information about feature collections available from this server"},
+         {"href", api_root + "/collections?f=html"}},
+        {{"rel", "service-desc"},
+         {"type", OGCAPI_MIMETYPE_OPENAPI_V3},
+         {"title", "OpenAPI document"},
+         {"href", api_root + "/api?f=json"}},
+        {{"rel", "service-doc"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "API documentation"},
+         {"href", api_root + "/api?f=html"}}}}};
+
+  // handle custom links (optional)
+  const char *links = msOWSLookupMetadata(&(map->web.metadata), "A", "links");
+  if (links) {
+    std::vector<std::string> names = msStringSplit(links, ',');
+    for (std::string name : names) {
+      try {
+        json link = getLink(&(map->web.metadata), name);
+        response["links"].push_back(link);
+      } catch (const std::runtime_error &e) {
+        outputError(OGCAPI_CONFIG_ERROR, std::string(e.what()));
+        return MS_SUCCESS;
+      }
+    }
+  }
+
+  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_LANDING, response);
+  return MS_SUCCESS;
+}
+
+static int processConformanceRequest(mapObj *map, cgiRequestObj *request,
+                                     OGCAPIFormat format) {
+  json response;
+
+  // build response object
+  response = {
+      {"conformsTo",
+       {
+           "http://www.opengis.net/spec/ogcapi-common-1/1.0/conf/core",
+           "http://www.opengis.net/spec/ogcapi-common-2/1.0/conf/collections",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/core",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/oas30",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/html",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/geojson",
+           "http://www.opengis.net/spec/ogcapi-features-2/1.0/conf/crs",
+       }}};
+
+  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_CONFORMANCE,
+                 response);
+  return MS_SUCCESS;
+}
+
+static int processCollectionItemsRequest(mapObj *map, cgiRequestObj *request,
+                                         const char *collectionId,
+                                         const char *featureId,
+                                         OGCAPIFormat format) {
+  json response;
+  int i;
+  layerObj *layer;
+
+  int limit;
+  rectObj bbox;
+
+  int numberMatched = 0;
+
+  // find the right layer
+  for (i = 0; i < map->numlayers; i++) {
+    if (strcmp(map->layers[i]->name, collectionId) == 0)
+      break; // match
+  }
+
+  if (i == map->numlayers) { // invalid collectionId
+    outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
+    return MS_SUCCESS;
+  }
+
+  layer = map->layers[i]; // for convenience
+  layer->status = MS_ON;  // force on (do we need to save and reset?)
+
+  if (!includeLayer(map, layer)) {
+    outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
+    return MS_SUCCESS;
+  }
+
+  //
+  // handle parameters specific to this endpoint
+  //
+  if (getLimit(map, request, layer, &limit) != MS_SUCCESS) {
+    outputError(OGCAPI_PARAM_ERROR, "Bad value for limit.");
+    return MS_SUCCESS;
+  }
+
+  const char *crs = getRequestParameter(request, "crs");
+
+  std::string outputCrs = "EPSG:4326";
+  bool outputCrsAxisInverted =
+      false; // because above EPSG:4326 is meant to be OGC:CRS84 actually
+  std::map<std::string, std::string> extraHeaders;
+  if (crs) {
+    bool isExpectedCrs = false;
+    for (const auto &crsItem : getCrsList(map, layer)) {
+      if (crs == crsItem.get<std::string>()) {
+        isExpectedCrs = true;
+        break;
+      }
+    }
+    if (!isExpectedCrs) {
+      outputError(OGCAPI_PARAM_ERROR, "Bad value for crs.");
+      return MS_SUCCESS;
+    }
+    extraHeaders["Content-Crs"] = '<' + std::string(crs) + '>';
+    if (std::string(crs) != CRS84_URL) {
+      if (std::string(crs).find(EPSG_PREFIX_URL) == 0) {
+        const char *code = crs + strlen(EPSG_PREFIX_URL);
+        outputCrs = std::string("EPSG:") + code;
+        outputCrsAxisInverted = msIsAxisInverted(atoi(code));
+      }
+    }
+  } else {
+    extraHeaders["Content-Crs"] = '<' + std::string(CRS84_URL) + '>';
+  }
+
+  struct ReprojectionObjects {
+    reprojectionObj *reprojector = NULL;
+    projectionObj proj;
+
+    ReprojectionObjects() { msInitProjection(&proj); }
+
+    ~ReprojectionObjects() {
+      msProjectDestroyReprojector(reprojector);
+      msFreeProjection(&proj);
+    }
+
+    int executeQuery(mapObj *map) {
+      projectionObj backupMapProjection = map->projection;
+      map->projection = proj;
+      int ret = msExecuteQuery(map);
+      map->projection = backupMapProjection;
+      return ret;
+    }
+  };
+  ReprojectionObjects reprObjs;
+
+  msProjectionInheritContextFrom(&reprObjs.proj, &(map->projection));
+  if (msLoadProjectionString(&reprObjs.proj, outputCrs.c_str()) != 0) {
+    outputError(OGCAPI_SERVER_ERROR, "Cannot instanciate output CRS.");
+    return MS_SUCCESS;
+  }
+
+  if (layer->projection.numargs > 0) {
+    if (msProjectionsDiffer(&(layer->projection), &reprObjs.proj)) {
+      reprObjs.reprojector =
+          msProjectCreateReprojector(&(layer->projection), &reprObjs.proj);
+      if (reprObjs.reprojector == NULL) {
+        outputError(OGCAPI_SERVER_ERROR, "Error creating re-projector.");
+        return MS_SUCCESS;
+      }
+    }
+  } else if (map->projection.numargs > 0) {
+    if (msProjectionsDiffer(&(map->projection), &reprObjs.proj)) {
+      reprObjs.reprojector =
+          msProjectCreateReprojector(&(map->projection), &reprObjs.proj);
+      if (reprObjs.reprojector == NULL) {
+        outputError(OGCAPI_SERVER_ERROR, "Error creating re-projector.");
+        return MS_SUCCESS;
+      }
+    }
+  } else {
+    outputError(OGCAPI_CONFIG_ERROR,
+                "Unable to transform geometries, no projection defined.");
+    return MS_SUCCESS;
+  }
+
+  if (map->projection.numargs > 0) {
+    msProjectRect(&(map->projection), &reprObjs.proj, &map->extent);
+  }
+
+  if (!getBbox(map, layer, request, &bbox, &reprObjs.proj)) {
+    return MS_SUCCESS;
+  }
+
+  int offset = 0;
+  if (featureId) {
+    const char *featureIdItem =
+        msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
+    if (featureIdItem == NULL) {
+      outputError(OGCAPI_CONFIG_ERROR, "Missing required featureid metadata.");
+      return MS_SUCCESS;
+    }
+
+    // TODO: does featureIdItem exist in the data?
+
+    // optional validation
+    const char *featureIdValidation =
+        msLookupHashTable(&(layer->validation), featureIdItem);
+    if (featureIdValidation &&
+        msValidateParameter(featureId, featureIdValidation, NULL, NULL, NULL) !=
+            MS_SUCCESS) {
+      outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid feature id.");
+      return MS_SUCCESS;
+    }
+
+    map->query.type = MS_QUERY_BY_FILTER;
+    map->query.mode = MS_QUERY_SINGLE;
+    map->query.layer = i;
+    map->query.rect = bbox;
+    map->query.filteritem = strdup(featureIdItem);
+
+    msInitExpression(&map->query.filter);
+    map->query.filter.type = MS_STRING;
+    map->query.filter.string = strdup(featureId);
+
+    if (reprObjs.executeQuery(map) != MS_SUCCESS) {
+      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items id query failed.");
+      return MS_SUCCESS;
+    }
+
+    if (!layer->resultcache || layer->resultcache->numresults != 1) {
+      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items id query failed.");
+      return MS_SUCCESS;
+    }
+  } else { // bbox query
+
+    const char *compliance_mode =
+        msOWSLookupMetadata(&(map->web.metadata), "A", "compliance_mode");
+    if (compliance_mode != NULL && strcasecmp(compliance_mode, "true") == 0) {
+      for (int j = 0; j < request->NumParams; j++) {
+        const char *paramName = request->ParamNames[j];
+        if (strcmp(paramName, "f") == 0 || strcmp(paramName, "bbox") == 0 ||
+            strcmp(paramName, "bbox-crs") == 0 ||
+            strcmp(paramName, "datetime") == 0 ||
+            strcmp(paramName, "limit") == 0 ||
+            strcmp(paramName, "offset") == 0 || strcmp(paramName, "crs") == 0) {
+          // ok
+        } else {
+          outputError(
+              OGCAPI_PARAM_ERROR,
+              (std::string("Unknown query parameter: ") + paramName).c_str());
+          return MS_SUCCESS;
+        }
+      }
+    }
+
+    map->query.type = MS_QUERY_BY_RECT;
+    map->query.mode = MS_QUERY_MULTIPLE;
+    map->query.layer = i;
+    map->query.rect = bbox;
+    map->query.only_cache_result_count = MS_TRUE;
+
+    // get number matched
+    if (reprObjs.executeQuery(map) != MS_SUCCESS) {
+      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
+      return MS_SUCCESS;
+    }
+
+    if (!layer->resultcache) {
+      outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
+      return MS_SUCCESS;
+    }
+
+    numberMatched = layer->resultcache->numresults;
+
+    if (numberMatched > 0) {
+      map->query.only_cache_result_count = MS_FALSE;
+      map->query.maxfeatures = limit;
+
+      const char *offsetStr = getRequestParameter(request, "offset");
+      if (offsetStr) {
+        if (msStringToInt(offsetStr, &offset, 10) != MS_SUCCESS) {
+          outputError(OGCAPI_PARAM_ERROR, "Bad value for offset.");
+          return MS_SUCCESS;
+        }
+
+        if (offset < 0 || offset >= numberMatched) {
+          outputError(OGCAPI_PARAM_ERROR, "Offset out of range.");
+          return MS_SUCCESS;
+        }
+
+        // msExecuteQuery() use a 1-based offset convention, whereas the API
+        // uses a 0-based offset convention.
+        map->query.startindex = 1 + offset;
+        layer->startindex = 1 + offset;
+      }
+
+      if (reprObjs.executeQuery(map) != MS_SUCCESS || !layer->resultcache) {
+        outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
+        return MS_SUCCESS;
+      }
+    }
+  }
+
+  // build response object
+  if (!featureId) {
+    std::string api_root = getApiRootUrl(map);
+    const char *id = layer->name;
+    char *id_encoded = msEncodeUrl(id); // free after use
+
+    std::string extra_kvp = "&limit=" + std::to_string(limit);
+    extra_kvp += "&offset=" + std::to_string(offset);
+
+    std::string other_extra_kvp;
+    if (crs)
+      other_extra_kvp += "&crs=" + std::string(crs);
+    const char *bbox = getRequestParameter(request, "bbox");
+    if (bbox)
+      other_extra_kvp += "&bbox=" + std::string(bbox);
+    const char *bboxCrs = getRequestParameter(request, "bbox-crs");
+    if (bboxCrs)
+      other_extra_kvp += "&bbox-crs=" + std::string(bboxCrs);
+
+    response = {
+        {"type", "FeatureCollection"},
+        {"numberMatched", numberMatched},
+        {"numberReturned", layer->resultcache->numresults},
+        {"features", json::array()},
+        {"links",
+         {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+           {"type", OGCAPI_MIMETYPE_GEOJSON},
+           {"title", "Items for this collection as GeoJSON"},
+           {"href", api_root + "/collections/" + std::string(id_encoded) +
+                        "/items?f=json" + extra_kvp + other_extra_kvp}},
+          {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+           {"type", OGCAPI_MIMETYPE_HTML},
+           {"title", "Items for this collection as HTML"},
+           {"href", api_root + "/collections/" + std::string(id_encoded) +
+                        "/items?f=html" + extra_kvp + other_extra_kvp}}}}};
+
+    if (offset + layer->resultcache->numresults < numberMatched) {
+      response["links"].push_back(
+          {{"rel", "next"},
+           {"type", format == OGCAPIFormat::JSON ? OGCAPI_MIMETYPE_GEOJSON
+                                                 : OGCAPI_MIMETYPE_HTML},
+           {"title", "next page"},
+           {"href",
+            api_root + "/collections/" + std::string(id_encoded) +
+                "/items?f=" + (format == OGCAPIFormat::JSON ? "json" : "html") +
+                "&limit=" + std::to_string(limit) + "&offset=" +
+                std::to_string(offset + limit) + other_extra_kvp}});
+    }
+
+    if (offset > 0) {
+      response["links"].push_back(
+          {{"rel", "prev"},
+           {"type", format == OGCAPIFormat::JSON ? OGCAPI_MIMETYPE_GEOJSON
+                                                 : OGCAPI_MIMETYPE_HTML},
+           {"title", "previous page"},
+           {"href",
+            api_root + "/collections/" + std::string(id_encoded) +
+                "/items?f=" + (format == OGCAPIFormat::JSON ? "json" : "html") +
+                "&limit=" + std::to_string(limit) +
+                "&offset=" + std::to_string(MS_MAX(0, (offset - limit))) +
+                other_extra_kvp}});
+    }
+
+    msFree(id_encoded); // done
+  }
+
+  // features (items)
+  {
+    shapeObj shape;
+    msInitShape(&shape);
+
+    // we piggyback on GML configuration
+    gmlItemListObj *items = msGMLGetItems(layer, "AG");
+    gmlConstantListObj *constants = msGMLGetConstants(layer, "AG");
+
+    if (!items || !constants) {
+      msGMLFreeItems(items);
+      msGMLFreeConstants(constants);
+      outputError(OGCAPI_SERVER_ERROR,
+                  "Error fetching layer attribute metadata.");
+      return MS_SUCCESS;
+    }
+
+    const int geometry_precision = getGeometryPrecision(map, layer);
+
+    for (i = 0; i < layer->resultcache->numresults; i++) {
+      int status =
+          msLayerGetShape(layer, &shape, &(layer->resultcache->results[i]));
+      if (status != MS_SUCCESS) {
+        msGMLFreeItems(items);
+        msGMLFreeConstants(constants);
+        outputError(OGCAPI_SERVER_ERROR, "Error fetching feature.");
+        return MS_SUCCESS;
+      }
+
+      if (reprObjs.reprojector) {
+        status = msProjectShapeEx(reprObjs.reprojector, &shape);
+        if (status != MS_SUCCESS) {
+          msGMLFreeItems(items);
+          msGMLFreeConstants(constants);
+          msFreeShape(&shape);
+          outputError(OGCAPI_SERVER_ERROR, "Error reprojecting feature.");
+          return MS_SUCCESS;
+        }
+      }
+
+      try {
+        json feature = getFeature(layer, &shape, items, constants,
+                                  geometry_precision, outputCrsAxisInverted);
+        if (featureId) {
+          response = std::move(feature);
+        } else {
+          response["features"].emplace_back(std::move(feature));
+        }
+      } catch (const std::runtime_error &e) {
+        msGMLFreeItems(items);
+        msGMLFreeConstants(constants);
+        msFreeShape(&shape);
+        outputError(OGCAPI_SERVER_ERROR,
+                    "Error getting feature. " + std::string(e.what()));
+        return MS_SUCCESS;
+      }
+
+      msFreeShape(&shape); // next
+    }
+
+    msGMLFreeItems(items); // clean up
+    msGMLFreeConstants(constants);
+  }
+
+  // extend the response a bit for templating (HERE)
+  if (format == OGCAPIFormat::HTML) {
+    const char *title = getCollectionTitle(layer);
+    const char *id = layer->name;
+    response["collection"] = {{"id", id}, {"title", title ? title : ""}};
+  }
+
+  if (featureId) {
+    std::string api_root = getApiRootUrl(map);
+    const char *id = layer->name;
+    char *id_encoded = msEncodeUrl(id); // free after use
+
+    response["links"] = {
+        {{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_GEOJSON},
+         {"title", "This document as GeoJSON"},
+         {"href", api_root + "/collections/" + std::string(id_encoded) +
+                      "/items/" + featureId + "?f=json"}},
+        {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "This document as HTML"},
+         {"href", api_root + "/collections/" + std::string(id_encoded) +
+                      "/items/" + featureId + "?f=html"}},
+        {{"rel", "collection"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title", "This collection as JSON"},
+         {"href",
+          api_root + "/collections/" + std::string(id_encoded) + "?f=json"}},
+        {{"rel", "collection"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "This collection as HTML"},
+         {"href",
+          api_root + "/collections/" + std::string(id_encoded) + "?f=html"}}};
+
+    msFree(id_encoded);
+
+    outputResponse(
+        map, request,
+        format == OGCAPIFormat::JSON ? OGCAPIFormat::GeoJSON : format,
+        OGCAPI_TEMPLATE_HTML_COLLECTION_ITEM, response, extraHeaders);
+  } else {
+    outputResponse(
+        map, request,
+        format == OGCAPIFormat::JSON ? OGCAPIFormat::GeoJSON : format,
+        OGCAPI_TEMPLATE_HTML_COLLECTION_ITEMS, response, extraHeaders);
+  }
+  return MS_SUCCESS;
+}
+
+static int processCollectionRequest(mapObj *map, cgiRequestObj *request,
+                                    const char *collectionId,
+                                    OGCAPIFormat format) {
+  json response;
+  int l;
+
+  for (l = 0; l < map->numlayers; l++) {
+    if (strcmp(map->layers[l]->name, collectionId) == 0)
+      break; // match
+  }
+
+  if (l == map->numlayers) { // invalid collectionId
+    outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
+    return MS_SUCCESS;
+  }
+
+  try {
+    response = getCollection(map, map->layers[l], format);
+    if (response.is_null()) { // same as not found
+      outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
+      return MS_SUCCESS;
+    }
+  } catch (const std::runtime_error &e) {
+    outputError(OGCAPI_CONFIG_ERROR,
+                "Error getting collection. " + std::string(e.what()));
+    return MS_SUCCESS;
+  }
+
+  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION,
+                 response);
+  return MS_SUCCESS;
+}
+
+static int processCollectionsRequest(mapObj *map, cgiRequestObj *request,
+                                     OGCAPIFormat format) {
+  json response;
+  int i;
+
+  // define api root url
+  std::string api_root = getApiRootUrl(map);
+
+  // build response object
+  response = {{"links",
+               {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+                 {"type", OGCAPI_MIMETYPE_JSON},
+                 {"title", "This document as JSON"},
+                 {"href", api_root + "/collections?f=json"}},
+                {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+                 {"type", OGCAPI_MIMETYPE_HTML},
+                 {"title", "This document as HTML"},
+                 {"href", api_root + "/collections?f=html"}}}},
+              {"collections", json::array()}};
+
+  for (i = 0; i < map->numlayers; i++) {
+    try {
+      json collection = getCollection(map, map->layers[i], format);
+      if (!collection.is_null())
+        response["collections"].push_back(collection);
+    } catch (const std::runtime_error &e) {
+      outputError(OGCAPI_CONFIG_ERROR,
+                  "Error getting collection." + std::string(e.what()));
+      return MS_SUCCESS;
+    }
+  }
+
+  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTIONS,
+                 response);
+  return MS_SUCCESS;
+}
+
+static int processApiRequest(mapObj *map, cgiRequestObj *request,
+                             OGCAPIFormat format) {
+  // Strongly inspired from
+  // https://github.com/geopython/pygeoapi/blob/master/pygeoapi/openapi.py
+
+  json response;
+
+  response = {
+      {"openapi", "3.0.2"},
+      {"tags", json::array()},
+  };
+
+  response["info"] = {
+      {"title", getTitle(map)},
+      {"version", getWebMetadata(map, "A", "version", "1.0.0")},
+  };
+
+  for (const char *item : {"description", "termsOfService"}) {
+    const char *value = getWebMetadata(map, "AO", item, nullptr);
+    if (value) {
+      response["info"][item] = value;
+    }
+  }
+
+  for (const auto &pair : {
+           std::make_pair("name", "contactperson"),
+           std::make_pair("url", "contacturl"),
+           std::make_pair("email", "contactelectronicmailaddress"),
+       }) {
+    const char *value = getWebMetadata(map, "AO", pair.second, nullptr);
+    if (value) {
+      response["info"]["contact"][pair.first] = value;
+    }
+  }
+
+  for (const auto &pair : {
+           std::make_pair("name", "licensename"),
+           std::make_pair("url", "licenseurl"),
+       }) {
+    const char *value = getWebMetadata(map, "AO", pair.second, nullptr);
+    if (value) {
+      response["info"]["license"][pair.first] = value;
+    }
+  }
+
+  {
+    const char *value = getWebMetadata(map, "AO", "keywords", nullptr);
+    if (value) {
+      response["info"]["x-keywords"] = value;
+    }
+  }
+
+  json server;
+  server["url"] = getApiRootUrl(map);
+  {
+    const char *value =
+        getWebMetadata(map, "AO", "server_description", nullptr);
+    if (value) {
+      server["description"] = value;
+    }
+  }
+  response["servers"].push_back(server);
+
+  const std::string oapif_schema_base_url = msOWSGetSchemasLocation(map);
+  const std::string oapif_yaml_url = oapif_schema_base_url +
+                                     "/ogcapi/features/part1/1.0/openapi/"
+                                     "ogcapi-features-1.yaml";
+  const std::string oapif_part2_yaml_url = oapif_schema_base_url +
+                                           "/ogcapi/features/part2/1.0/openapi/"
+                                           "ogcapi-features-2.yaml";
+
+  json paths;
+
+  paths["/"]["get"] = {
+      {"summary", "Landing page"},
+      {"description", "Landing page"},
+      {"tags", {"server"}},
+      {"operationId", "getLandingPage"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200",
+         {{"$ref", oapif_yaml_url + "#/components/responses/LandingPage"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"500",
+         {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+  paths["/api"]["get"] = {
+      {"summary", "API documentation"},
+      {"description", "API documentation"},
+      {"tags", {"server"}},
+      {"operationId", "getOpenapi"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200", {{"$ref", "#/components/responses/200"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"default", {{"$ref", "#/components/responses/default"}}}}}};
+
+  paths["/conformance"]["get"] = {
+      {"summary", "API conformance definition"},
+      {"description", "API conformance definition"},
+      {"tags", {"server"}},
+      {"operationId", "getConformanceDeclaration"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/ConformanceDeclaration"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"500",
+         {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+  paths["/collections"]["get"] = {
+      {"summary", "Collections"},
+      {"description", "Collections"},
+      {"tags", {"server"}},
+      {"operationId", "getCollections"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200",
+         {{"$ref", oapif_yaml_url + "#/components/responses/Collections"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"500",
+         {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *layer = map->layers[i];
+    if (!includeLayer(map, layer)) {
+      continue;
+    }
+
+    json collection_get = {
+        {"summary",
+         std::string("Get ") + getCollectionTitle(layer) + " metadata"},
+        {"description", getCollectionDescription(layer)},
+        {"tags", {layer->name}},
+        {"operationId", "describe" + std::string(layer->name) + "Collection"},
+        {"parameters",
+         {
+             {{"$ref", "#/components/parameters/f"}},
+         }},
+        {"responses",
+         {{"200",
+           {{"$ref", oapif_yaml_url + "#/components/responses/Collection"}}},
+          {"400",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+          {"500",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+    std::string collectionNamePath("/collections/");
+    collectionNamePath += layer->name;
+    paths[collectionNamePath]["get"] = std::move(collection_get);
+
+    // check metadata, layer then map
+    const char *max_limit_str =
+        msOWSLookupMetadata(&(layer->metadata), "A", "max_limit");
+    if (max_limit_str == nullptr)
+      max_limit_str =
+          msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
+    const int max_limit =
+        max_limit_str ? atoi(max_limit_str) : OGCAPI_MAX_LIMIT;
+    const int default_limit = getDefaultLimit(map, layer);
+
+    json items_get = {
+        {"summary", std::string("Get ") + getCollectionTitle(layer) + " items"},
+        {"description", getCollectionDescription(layer)},
+        {"tags", {layer->name}},
+        {"operationId", "get" + std::string(layer->name) + "Features"},
+        {"parameters",
+         {
+             {{"$ref", "#/components/parameters/f"}},
+             {{"$ref", oapif_yaml_url + "#/components/parameters/bbox"}},
+             {{"$ref", oapif_yaml_url + "#/components/parameters/datetime"}},
+             {{"$ref",
+               oapif_part2_yaml_url + "#/components/parameters/bbox-crs"}},
+             {{"$ref", oapif_part2_yaml_url + "#/components/parameters/crs"}},
+             {{"$ref", "#/components/parameters/offset"}},
+         }},
+        {"responses",
+         {{"200",
+           {{"$ref", oapif_yaml_url + "#/components/responses/Features"}}},
+          {"400",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+          {"500",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+    json param_limit = {
+        {"name", "limit"},
+        {"in", "query"},
+        {"description", "The optional limit parameter limits the number of "
+                        "items that are presented in the response document."},
+        {"required", false},
+        {"schema",
+         {
+             {"type", "integer"},
+             {"minimum", 1},
+             {"maximum", max_limit},
+             {"default", default_limit},
+         }},
+        {"style", "form"},
+        {"explode", false},
+    };
+    items_get["parameters"].emplace_back(param_limit);
+
+    std::string itemsPath(collectionNamePath + "/items");
+    paths[itemsPath]["get"] = std::move(items_get);
+
+    json feature_id_get = {
+        {"summary",
+         std::string("Get ") + getCollectionTitle(layer) + " item by id"},
+        {"description", getCollectionDescription(layer)},
+        {"tags", {layer->name}},
+        {"operationId", "get" + std::string(layer->name) + "Feature"},
+        {"parameters",
+         {
+             {{"$ref", "#/components/parameters/f"}},
+             {{"$ref", oapif_yaml_url + "#/components/parameters/featureId"}},
+         }},
+        {"responses",
+         {{"200",
+           {{"$ref", oapif_yaml_url + "#/components/responses/Feature"}}},
+          {"400",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+          {"404",
+           {{"$ref", oapif_yaml_url + "#/components/responses/NotFound"}}},
+          {"500",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+    std::string itemsFeatureIdPath(collectionNamePath + "/items/{featureId}");
+    paths[itemsFeatureIdPath]["get"] = std::move(feature_id_get);
+  }
+
+  response["paths"] = std::move(paths);
+
+  json components;
+  components["responses"]["200"] = {{"description", "successful operation"}};
+  components["responses"]["default"] = {
+      {"description", "unexpected error"},
+      {"content",
+       {{"application/json",
+         {{"schema",
+           {{"$ref", "https://raw.githubusercontent.com/opengeospatial/"
+                     "ogcapi-processes/master/core/openapi/schemas/"
+                     "exception.yaml"}}}}}}}};
+
+  json parameters;
+  parameters["f"] = {
+      {"name", "f"},
+      {"in", "query"},
+      {"description", "The optional f parameter indicates the output format "
+                      "which the server shall provide as part of the response "
+                      "document.  The default format is GeoJSON."},
+      {"required", false},
+      {"schema",
+       {{"type", "string"}, {"enum", {"json", "html"}}, {"default", "json"}}},
+      {"style", "form"},
+      {"explode", false},
+  };
+
+  parameters["offset"] = {
+      {"name", "offset"},
+      {"in", "query"},
+      {"description",
+       "The optional offset parameter indicates the index within the result "
+       "set from which the server shall begin presenting results in the "
+       "response document.  The first element has an index of 0 (default)."},
+      {"required", false},
+      {"schema",
+       {
+           {"type", "integer"},
+           {"minimum", 0},
+           {"default", 0},
+       }},
+      {"style", "form"},
+      {"explode", false},
+  };
+
+  components["parameters"] = std::move(parameters);
+
+  response["components"] = std::move(components);
+
+  // TODO: "tags" array ?
+
+  outputResponse(map, request,
+                 format == OGCAPIFormat::JSON ? OGCAPIFormat::OpenAPI_V3
+                                              : format,
+                 OGCAPI_TEMPLATE_HTML_OPENAPI, response);
+  return MS_SUCCESS;
+}
+
+#endif
+
+int msOGCAPIDispatchRequest(mapObj *map, cgiRequestObj *request) {
+#ifdef USE_OGCAPI_SVR
+
+  // make sure ogcapi requests are enabled for this map
+  int status = msOWSRequestIsEnabled(map, NULL, "AO", "OGCAPI", MS_FALSE);
+  if (status != MS_TRUE) {
+    msSetError(MS_OGCAPIERR, "OGC API requests are not enabled.",
+               "msCGIDispatchAPIRequest()");
+    return MS_FAILURE; // let normal error handling take over
+  }
+
+  for (int i = 0; i < request->NumParams; i++) {
+    for (int j = i + 1; j < request->NumParams; j++) {
+      if (strcmp(request->ParamNames[i], request->ParamNames[j]) == 0) {
+        std::string errorMsg("Query parameter ");
+        errorMsg += request->ParamNames[i];
+        errorMsg += " is repeated";
+        outputError(OGCAPI_PARAM_ERROR, errorMsg.c_str());
+        return MS_SUCCESS;
+      }
+    }
+  }
+
+  OGCAPIFormat format; // all endpoints need a format
+  const char *p = getRequestParameter(request, "f");
+
+  // if f= query parameter is not specified, use HTTP Accept header if available
+  if (p == nullptr) {
+    const char *accept = getenv("HTTP_ACCEPT");
+    if (accept) {
+      if (strcmp(accept, "*/*") == 0)
+        p = OGCAPI_MIMETYPE_JSON;
+      else
+        p = accept;
+    }
+  }
+
+  if (p &&
+      (strcmp(p, "json") == 0 || strstr(p, OGCAPI_MIMETYPE_JSON) != nullptr ||
+       strstr(p, OGCAPI_MIMETYPE_GEOJSON) != nullptr ||
+       strstr(p, OGCAPI_MIMETYPE_OPENAPI_V3) != nullptr)) {
+    format = OGCAPIFormat::JSON;
+  } else if (p && (strcmp(p, "html") == 0 ||
+                   strstr(p, OGCAPI_MIMETYPE_HTML) != nullptr)) {
+    format = OGCAPIFormat::HTML;
+  } else if (p) {
+    std::string errorMsg("Unsupported format requested: ");
+    errorMsg += p;
+    outputError(OGCAPI_PARAM_ERROR, errorMsg.c_str());
+    return MS_SUCCESS; // avoid any downstream MapServer processing
+  } else {
+    format = OGCAPIFormat::HTML; // default for now
+  }
+
+  if (request->api_path_length == 2) {
+
+    return processLandingRequest(map, request, format);
+
+  } else if (request->api_path_length == 3) {
+
+    if (strcmp(request->api_path[2], "conformance") == 0) {
+      return processConformanceRequest(map, request, format);
+    } else if (strcmp(request->api_path[2], "conformance.html") == 0) {
+      return processConformanceRequest(map, request, OGCAPIFormat::HTML);
+    } else if (strcmp(request->api_path[2], "collections") == 0) {
+      return processCollectionsRequest(map, request, format);
+    } else if (strcmp(request->api_path[2], "collections.html") == 0) {
+      return processCollectionsRequest(map, request, OGCAPIFormat::HTML);
+    } else if (strcmp(request->api_path[2], "api") == 0) {
+      return processApiRequest(map, request, format);
+    }
+
+  } else if (request->api_path_length == 4) {
+
+    if (strcmp(request->api_path[2], "collections") ==
+        0) { // next argument (3) is collectionId
+      return processCollectionRequest(map, request, request->api_path[3],
+                                      format);
+    }
+
+  } else if (request->api_path_length == 5) {
+
+    if (strcmp(request->api_path[2], "collections") == 0 &&
+        strcmp(request->api_path[4], "items") ==
+            0) { // middle argument (3) is the collectionId
+      return processCollectionItemsRequest(map, request, request->api_path[3],
+                                           NULL, format);
+    }
+
+  } else if (request->api_path_length == 6) {
+
+    if (strcmp(request->api_path[2], "collections") == 0 &&
+        strcmp(request->api_path[4], "items") ==
+            0) { // middle argument (3) is the collectionId, last argument (5)
+                 // is featureId
+      return processCollectionItemsRequest(map, request, request->api_path[3],
+                                           request->api_path[5], format);
+    }
+  }
+
+  outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid API path.");
+  return MS_SUCCESS; // avoid any downstream MapServer processing
+#else
+  msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.",
+             "msOGCAPIDispatchRequest()");
+  return MS_FAILURE;
+#endif
+}
diff -pruN 8.0.1-5/src/mapogcapi.h 8.2.0~beta1-1~exp1/src/mapogcapi.h
--- 8.0.1-5/src/mapogcapi.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcapi.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,42 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGCAPI Implementation
+ * Author:   Steve Lime and the MapServer team.
+ *
+ **********************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#ifndef MAPOGCAPI_H
+#define MAPOGCAPI_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+int msOGCAPIDispatchRequest(mapObj *map, cgiRequestObj *request);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/mapogcfilter.cpp 8.2.0~beta1-1~exp1/src/mapogcfilter.cpp
--- 8.0.1-5/src/mapogcfilter.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcfilter.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3430 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC Filter Encoding implementation
+ * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver-config.h"
+
+#include "cpl_minixml.h"
+#include "cpl_string.h"
+
+#include "mapogcfilter.h"
+#include "mapserver.h"
+#include "mapowscommon.h"
+#include "maptime.h"
+#include "mapows.h"
+#include <ctype.h>
+
+#if 0
+static int FLTHasUniqueTopLevelDuringFilter(FilterEncodingNode *psFilterNode);
+#endif
+
+#if !(defined(_WIN32) && !defined(__CYGWIN__))
+static inline void IGUR_double(double ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
+#endif
+
+int FLTIsNumeric(const char *pszValue) {
+  if (pszValue != NULL && *pszValue != '\0' && !isspace(*pszValue)) {
+    /*the regex seems to have a problem on windows when mapserver is built using
+      PHP regex*/
+#if defined(_WIN32) && !defined(__CYGWIN__)
+    int i = 0, nLength = 0, bString = 0;
+
+    nLength = strlen(pszValue);
+    for (i = 0; i < nLength; i++) {
+      if (i == 0) {
+        if (!isdigit(pszValue[i]) && pszValue[i] != '-') {
+          bString = 1;
+          break;
+        }
+      } else if (!isdigit(pszValue[i]) && pszValue[i] != '.') {
+        bString = 1;
+        break;
+      }
+    }
+    if (!bString)
+      return MS_TRUE;
+#else
+    char *p;
+    IGUR_double(strtod(pszValue, &p));
+    if (p != pszValue && *p == '\0')
+      return MS_TRUE;
+#endif
+  }
+
+  return MS_FALSE;
+}
+
+/*
+** Apply an expression to the layer's filter element.
+**
+*/
+int FLTApplyExpressionToLayer(layerObj *lp, const char *pszExpression) {
+  char *pszFinalExpression = NULL, *pszBuffer = NULL;
+  /*char *escapedTextString=NULL;*/
+  int bConcatWhere = 0, bHasAWhere = 0;
+
+  if (lp && pszExpression) {
+    if (lp->connectiontype == MS_POSTGIS ||
+        lp->connectiontype == MS_ORACLESPATIAL ||
+        lp->connectiontype == MS_PLUGIN) {
+      pszFinalExpression = msStrdup("(");
+      pszFinalExpression =
+          msStringConcatenate(pszFinalExpression, pszExpression);
+      pszFinalExpression = msStringConcatenate(pszFinalExpression, ")");
+    } else if (lp->connectiontype == MS_OGR) {
+      pszFinalExpression = msStrdup(pszExpression);
+      if (lp->filter.type != MS_EXPRESSION) {
+        bConcatWhere = 1;
+      } else {
+        if (lp->filter.string && EQUALN(lp->filter.string, "WHERE ", 6)) {
+          bHasAWhere = 1;
+          bConcatWhere = 1;
+        }
+      }
+
+    } else
+      pszFinalExpression = msStrdup(pszExpression);
+
+    if (bConcatWhere)
+      pszBuffer = msStringConcatenate(pszBuffer, "WHERE ");
+    /* if the filter is set and it's an expression type, concatenate it with
+                this filter. If not just free it */
+    if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
+      pszBuffer = msStringConcatenate(pszBuffer, "((");
+      if (bHasAWhere)
+        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string + 6);
+      else
+        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
+      pszBuffer = msStringConcatenate(pszBuffer, ") and ");
+    } else if (lp->filter.string)
+      msFreeExpression(&lp->filter);
+
+    pszBuffer = msStringConcatenate(pszBuffer, pszFinalExpression);
+
+    if (lp->filter.string && lp->filter.type == MS_EXPRESSION)
+      pszBuffer = msStringConcatenate(pszBuffer, ")");
+
+    /*assuming that expression was properly escaped
+          escapedTextString = msStringEscape(pszBuffer);
+          msLoadExpressionString(&lp->filter,
+                                 (char*)CPLSPrintf("%s", escapedTextString));
+          msFree(escapedTextString);
+    */
+    msLoadExpressionString(&lp->filter, pszBuffer);
+
+    msFree(pszFinalExpression);
+
+    if (pszBuffer)
+      msFree(pszBuffer);
+
+    return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+char *FLTGetExpressionForValuesRanges(layerObj *lp, const char *item,
+                                      const char *value, int forcecharcter) {
+  int bIscharacter;
+  char *pszExpression = NULL, *pszTmpExpression = NULL;
+  char **paszElements = NULL, **papszRangeElements = NULL;
+  int numelements, i, nrangeelements;
+
+  /* double minval, maxval; */
+  if (lp && item && value) {
+    if (strstr(value, "/") == NULL) {
+      /*value(s)*/
+      paszElements = msStringSplit(value, ',', &numelements);
+      if (paszElements && numelements > 0) {
+        if (forcecharcter)
+          bIscharacter = MS_TRUE;
+        else
+          bIscharacter = !FLTIsNumeric(paszElements[0]);
+
+        pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
+        for (i = 0; i < numelements; i++) {
+          pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
+          {
+            if (bIscharacter)
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
+            if (bIscharacter)
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
+          }
+          if (bIscharacter) {
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, " = \"");
+          } else
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, " = ");
+
+          {
+            char *pszEscapedStr = msLayerEscapeSQLParam(lp, paszElements[i]);
+            pszTmpExpression =
+                msStringConcatenate(pszTmpExpression, pszEscapedStr);
+            msFree(pszEscapedStr);
+          }
+
+          if (bIscharacter) {
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
+          }
+          pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
+
+          if (pszExpression != NULL)
+            pszExpression = msStringConcatenate(pszExpression, " OR ");
+
+          pszExpression = msStringConcatenate(pszExpression, pszTmpExpression);
+
+          msFree(pszTmpExpression);
+          pszTmpExpression = NULL;
+        }
+        pszExpression = msStringConcatenate(pszExpression, ")");
+      }
+      msFreeCharArray(paszElements, numelements);
+    } else {
+      /*range(s)*/
+      paszElements = msStringSplit(value, ',', &numelements);
+      if (paszElements && numelements > 0) {
+        pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
+        for (i = 0; i < numelements; i++) {
+          papszRangeElements =
+              msStringSplit(paszElements[i], '/', &nrangeelements);
+          if (papszRangeElements && nrangeelements > 0) {
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
+            if (nrangeelements == 2 || nrangeelements == 3) {
+              /*
+              minval = atof(papszRangeElements[0]);
+              maxval = atof(papszRangeElements[1]);
+              */
+              {
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
+              }
+
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, " >= ");
+
+              {
+                char *pszEscapedStr =
+                    msLayerEscapeSQLParam(lp, papszRangeElements[0]);
+                pszTmpExpression =
+                    msStringConcatenate(pszTmpExpression, pszEscapedStr);
+                msFree(pszEscapedStr);
+              }
+
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, " AND ");
+
+              {
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
+              }
+
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, " <= ");
+
+              {
+                char *pszEscapedStr =
+                    msLayerEscapeSQLParam(lp, papszRangeElements[1]);
+                pszTmpExpression =
+                    msStringConcatenate(pszTmpExpression, pszEscapedStr);
+                msFree(pszEscapedStr);
+              }
+
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
+            } else if (nrangeelements == 1) {
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
+              {
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, "[");
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, item);
+                pszTmpExpression = msStringConcatenate(pszTmpExpression, "]");
+              }
+
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, " = ");
+
+              {
+                char *pszEscapedStr =
+                    msLayerEscapeSQLParam(lp, papszRangeElements[0]);
+                pszTmpExpression =
+                    msStringConcatenate(pszTmpExpression, pszEscapedStr);
+                msFree(pszEscapedStr);
+              }
+
+              pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
+            }
+
+            if (pszExpression != NULL)
+              pszExpression = msStringConcatenate(pszExpression, " OR ");
+
+            pszExpression =
+                msStringConcatenate(pszExpression, pszTmpExpression);
+            msFree(pszTmpExpression);
+            pszTmpExpression = NULL;
+          }
+          msFreeCharArray(papszRangeElements, nrangeelements);
+        }
+        pszExpression = msStringConcatenate(pszExpression, ")");
+      }
+      msFreeCharArray(paszElements, numelements);
+    }
+  }
+  msFree(pszTmpExpression);
+  return pszExpression;
+}
+
+int FLTogrConvertGeometry(OGRGeometryH hGeometry, shapeObj *psShape,
+                          OGRwkbGeometryType nType) {
+  return msOGRGeometryToShape(hGeometry, psShape, nType);
+}
+
+static int FLTShapeFromGMLTree(CPLXMLNode *psTree, shapeObj *psShape,
+                               char **ppszSRS) {
+  const char *pszSRS = NULL;
+  if (psTree && psShape) {
+    CPLXMLNode *psNext = psTree->psNext;
+    OGRGeometryH hGeometry = NULL;
+
+    psTree->psNext = NULL;
+    hGeometry = OGR_G_CreateFromGMLTree(psTree);
+    psTree->psNext = psNext;
+
+    if (hGeometry) {
+      OGRwkbGeometryType nType;
+      nType = OGR_G_GetGeometryType(hGeometry);
+      if (nType == wkbPolygon25D || nType == wkbMultiPolygon25D)
+        nType = wkbPolygon;
+      else if (nType == wkbLineString25D || nType == wkbMultiLineString25D)
+        nType = wkbLineString;
+      else if (nType == wkbPoint25D || nType == wkbMultiPoint25D)
+        nType = wkbPoint;
+      FLTogrConvertGeometry(hGeometry, psShape, nType);
+
+      OGR_G_DestroyGeometry(hGeometry);
+
+      pszSRS = CPLGetXMLValue(psTree, "srsName", NULL);
+      if (ppszSRS && pszSRS)
+        *ppszSRS = msStrdup(pszSRS);
+
+      return MS_TRUE;
+    }
+  }
+
+  return MS_FALSE;
+}
+
+int FLTGetGeosOperator(char *pszValue) {
+  if (!pszValue)
+    return -1;
+
+  if (strcasecmp(pszValue, "Equals") == 0)
+    return MS_GEOS_EQUALS;
+  else if (strcasecmp(pszValue, "Intersect") == 0 ||
+           strcasecmp(pszValue, "Intersects") == 0)
+    return MS_GEOS_INTERSECTS;
+  else if (strcasecmp(pszValue, "Disjoint") == 0)
+    return MS_GEOS_DISJOINT;
+  else if (strcasecmp(pszValue, "Touches") == 0)
+    return MS_GEOS_TOUCHES;
+  else if (strcasecmp(pszValue, "Crosses") == 0)
+    return MS_GEOS_CROSSES;
+  else if (strcasecmp(pszValue, "Within") == 0)
+    return MS_GEOS_WITHIN;
+  else if (strcasecmp(pszValue, "Contains") == 0)
+    return MS_GEOS_CONTAINS;
+  else if (strcasecmp(pszValue, "Overlaps") == 0)
+    return MS_GEOS_OVERLAPS;
+  else if (strcasecmp(pszValue, "Beyond") == 0)
+    return MS_GEOS_BEYOND;
+  else if (strcasecmp(pszValue, "DWithin") == 0)
+    return MS_GEOS_DWITHIN;
+
+  return -1;
+}
+
+int FLTIsGeosNode(char *pszValue) {
+  if (FLTGetGeosOperator(pszValue) == -1)
+    return MS_FALSE;
+
+  return MS_TRUE;
+}
+
+/************************************************************************/
+/*                        FLTIsSimpleFilterNoSpatial                    */
+/*                                                                      */
+/*      Filter encoding with only attribute queries                     */
+/************************************************************************/
+int FLTIsSimpleFilterNoSpatial(FilterEncodingNode *psNode) {
+  if (FLTIsSimpleFilter(psNode) && FLTNumberOfFilterType(psNode, "BBOX") == 0)
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                      FLTApplySimpleSQLFilter()                       */
+/************************************************************************/
+
+int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode, mapObj *map,
+                            int iLayerIndex) {
+  layerObj *lp = NULL;
+  char *szExpression = NULL;
+  rectObj sQueryRect = map->extent;
+  const char *szEPSG = NULL;
+  projectionObj sProjTmp;
+  char *pszBuffer = NULL;
+  int bConcatWhere = 0;
+  int bHasAWhere = 0;
+  char *pszTmp = NULL, *pszTmp2 = NULL;
+  char *tmpfilename = NULL;
+  const char *pszTimeField = NULL;
+  const char *pszTimeValue = NULL;
+
+  lp = (GET_LAYER(map, iLayerIndex));
+
+  /* if there is a bbox use it */
+  szEPSG = FLTGetBBOX(psNode, &sQueryRect);
+  if (szEPSG && map->projection.numargs > 0) {
+    msInitProjection(&sProjTmp);
+    msProjectionInheritContextFrom(&sProjTmp, &map->projection);
+    /* Use the non EPSG variant since axis swapping is done in
+     * FLTDoAxisSwappingIfNecessary */
+    if (msLoadProjectionString(&sProjTmp, szEPSG) == 0) {
+      msProjectRect(&sProjTmp, &map->projection, &sQueryRect);
+    }
+    msFreeProjection(&sProjTmp);
+  }
+
+  if (lp->connectiontype == MS_OGR) {
+    pszTimeValue = FLTGetDuring(psNode, &pszTimeField);
+  }
+
+  /* make sure that the layer can be queried*/
+  if (!lp->_template)
+    lp->_template = msStrdup("ttt.html");
+
+  /* if there is no class, create at least one, so that query by rect would work
+   */
+  if (lp->numclasses == 0) {
+    if (msGrowLayerClasses(lp) == NULL)
+      return MS_FAILURE;
+    initClass(lp->_class[0]);
+  }
+
+  bConcatWhere = 0;
+  bHasAWhere = 0;
+  if (lp->connectiontype == MS_POSTGIS ||
+      lp->connectiontype == MS_ORACLESPATIAL ||
+      lp->connectiontype == MS_PLUGIN) {
+    szExpression = FLTGetSQLExpression(psNode, lp);
+    if (szExpression) {
+      pszTmp = msStrdup("(");
+      pszTmp = msStringConcatenate(pszTmp, szExpression);
+      pszTmp = msStringConcatenate(pszTmp, ")");
+      msFree(szExpression);
+      szExpression = pszTmp;
+    }
+  }
+  /* concatenates the WHERE clause for OGR layers. This only applies if
+     the expression was empty or not of an expression string. If there
+     is an sql type expression, it is assumed to have the WHERE clause.
+     If it is an expression and does not have a WHERE it is assumed to be a
+     mapserver type expression*/
+  else if (lp->connectiontype == MS_OGR) {
+    if (lp->filter.type != MS_EXPRESSION) {
+      szExpression = FLTGetSQLExpression(psNode, lp);
+      bConcatWhere = 1;
+    } else {
+      if (lp->filter.string && EQUALN(lp->filter.string, "WHERE ", 6)) {
+        szExpression = FLTGetSQLExpression(psNode, lp);
+        bHasAWhere = 1;
+        bConcatWhere = 1;
+      } else {
+        szExpression = FLTGetCommonExpression(psNode, lp);
+      }
+    }
+  } else {
+    szExpression = FLTGetCommonExpression(psNode, lp);
+  }
+
+  if (szExpression) {
+    if (bConcatWhere)
+      pszBuffer = msStringConcatenate(pszBuffer, "WHERE ");
+
+    /* if the filter is set and it's an expression type, concatenate it with
+                 this filter. If not just free it */
+    if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
+      pszBuffer = msStringConcatenate(pszBuffer, "((");
+      if (bHasAWhere)
+        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string + 6);
+      else
+        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
+      pszBuffer = msStringConcatenate(pszBuffer, ") and ");
+    } else if (lp->filter.string)
+      msFreeExpression(&lp->filter);
+
+    pszBuffer = msStringConcatenate(pszBuffer, szExpression);
+
+    if (lp->filter.string && lp->filter.type == MS_EXPRESSION)
+      pszBuffer = msStringConcatenate(pszBuffer, ")");
+
+    msLoadExpressionString(&lp->filter, pszBuffer);
+    free(szExpression);
+  }
+
+  if (pszTimeField && pszTimeValue)
+    msLayerSetTimeFilter(lp, pszTimeValue, pszTimeField);
+
+  if (pszBuffer)
+    free(pszBuffer);
+
+  map->query.type = MS_QUERY_BY_RECT;
+  map->query.mode = MS_QUERY_MULTIPLE;
+  map->query.layer = lp->index;
+  map->query.rect = sQueryRect;
+
+  if (map->debug == MS_DEBUGLEVEL_VVV) {
+    tmpfilename = msTmpFile(map, map->mappath, NULL, "_filter.map");
+    if (tmpfilename == NULL) {
+      tmpfilename = msTmpFile(map, NULL, NULL, "_filter.map");
+    }
+    if (tmpfilename) {
+      msSaveMap(map, tmpfilename);
+      msDebug(
+          "FLTApplySimpleSQLFilter(): Map file after Filter was applied %s\n",
+          tmpfilename);
+      msFree(tmpfilename);
+    }
+  }
+
+  /*for oracle connection, if we have a simple filter with no spatial
+    constraints we should set the connection function to NONE to have a better
+    performance
+    (#2725)*/
+
+  if (lp->connectiontype == MS_ORACLESPATIAL &&
+      FLTIsSimpleFilterNoSpatial(psNode)) {
+    if (strcasestr(lp->data, "USING") == 0)
+      lp->data = msStringConcatenate(lp->data, " USING NONE");
+    else if (strcasestr(lp->data, "NONE") == 0) {
+      /*if one of the functions is used, just replace it with NONE*/
+      if (strcasestr(lp->data, "FILTER"))
+        lp->data = msCaseReplaceSubstring(lp->data, "FILTER", "NONE");
+      else if (strcasestr(lp->data, "GEOMRELATE"))
+        lp->data = msCaseReplaceSubstring(lp->data, "GEOMRELATE", "NONE");
+      else if (strcasestr(lp->data, "RELATE"))
+        lp->data = msCaseReplaceSubstring(lp->data, "RELATE", "NONE");
+      else if (strcasestr(lp->data, "VERSION")) {
+        /*should add NONE just before the VERSION. Cases are:
+          DATA "ORA_GEOMETRY FROM data USING VERSION 10g
+          DATA "ORA_GEOMETRY FROM data  USING UNIQUE FID VERSION 10g"
+         */
+        pszTmp = (char *)strcasestr(lp->data, "VERSION");
+        pszTmp2 = msStringConcatenate(pszTmp2, " NONE ");
+        pszTmp2 = msStringConcatenate(pszTmp2, pszTmp);
+
+        lp->data = msCaseReplaceSubstring(lp->data, pszTmp, pszTmp2);
+
+        msFree(pszTmp2);
+
+      } else if (strcasestr(lp->data, "SRID")) {
+        lp->data = msStringConcatenate(lp->data, " NONE");
+      }
+    }
+  }
+
+  return msQueryByRect(map);
+
+  /* return MS_SUCCESS; */
+}
+
+/************************************************************************/
+/*                            FLTSplitFilters                           */
+/*                                                                      */
+/*    Split filters separated by parentheses into an array of strings.  */
+/************************************************************************/
+char **FLTSplitFilters(const char *pszStr, int *pnTokens) {
+  const char *pszTokenBegin;
+  char **papszRet = NULL;
+  int nTokens = 0;
+  char chStringQuote = '\0';
+  int nXMLIndent = 0;
+  int bInBracket = FALSE;
+
+  if (*pszStr != '(') {
+    *pnTokens = 0;
+    return NULL;
+  }
+  pszStr++;
+  pszTokenBegin = pszStr;
+  while (*pszStr != '\0') {
+    /* Ignore any character until end of quoted string */
+    if (chStringQuote != '\0') {
+      if (*pszStr == chStringQuote)
+        chStringQuote = 0;
+    }
+    /* Detect begin of quoted string only for an XML attribute, i.e. between <
+       and > */
+    else if (bInBracket && (*pszStr == '\'' || *pszStr == '"')) {
+      chStringQuote = *pszStr;
+    }
+    /* Begin of XML element */
+    else if (*pszStr == '<') {
+      bInBracket = TRUE;
+      if (pszStr[1] == '/')
+        nXMLIndent--;
+      else if (pszStr[1] != '!')
+        nXMLIndent++;
+    }
+    /* <something /> case */
+    else if (*pszStr == '/' && pszStr[1] == '>') {
+      bInBracket = FALSE;
+      nXMLIndent--;
+      pszStr++;
+    }
+    /* End of XML element */
+    else if (*pszStr == '>') {
+      bInBracket = FALSE;
+    }
+    /* Only detect and of filter when XML indentation goes back to zero */
+    else if (nXMLIndent == 0 && *pszStr == ')') {
+      papszRet =
+          (char **)msSmallRealloc(papszRet, sizeof(char *) * (nTokens + 1));
+      papszRet[nTokens] = msStrdup(pszTokenBegin);
+      papszRet[nTokens][pszStr - pszTokenBegin] = '\0';
+      nTokens++;
+      if (pszStr[1] != '(') {
+        break;
+      }
+      pszStr++;
+      pszTokenBegin = pszStr + 1;
+    }
+    pszStr++;
+  }
+  *pnTokens = nTokens;
+  return papszRet;
+}
+
+/************************************************************************/
+/*                            FLTIsSimpleFilter                         */
+/*                                                                      */
+/*      Filter encoding with only attribute queries and only one bbox.  */
+/************************************************************************/
+int FLTIsSimpleFilter(FilterEncodingNode *psNode) {
+  if (FLTValidForBBoxFilter(psNode)) {
+    if (FLTNumberOfFilterType(psNode, "DWithin") == 0 &&
+        FLTNumberOfFilterType(psNode, "Intersect") == 0 &&
+        FLTNumberOfFilterType(psNode, "Intersects") == 0 &&
+        FLTNumberOfFilterType(psNode, "Equals") == 0 &&
+        FLTNumberOfFilterType(psNode, "Disjoint") == 0 &&
+        FLTNumberOfFilterType(psNode, "Touches") == 0 &&
+        FLTNumberOfFilterType(psNode, "Crosses") == 0 &&
+        FLTNumberOfFilterType(psNode, "Within") == 0 &&
+        FLTNumberOfFilterType(psNode, "Contains") == 0 &&
+        FLTNumberOfFilterType(psNode, "Overlaps") == 0 &&
+        FLTNumberOfFilterType(psNode, "Beyond") == 0)
+      return TRUE;
+  }
+
+  return FALSE;
+}
+
+/************************************************************************/
+/*                          FLTApplyFilterToLayer                       */
+/*                                                                      */
+/*      Use the filter encoding node to create mapserver expressions    */
+/*      and apply it to the layer.                                      */
+/************************************************************************/
+int FLTApplyFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                          int iLayerIndex) {
+  layerObj *layer = GET_LAYER(map, iLayerIndex);
+
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
+  }
+  if (!layer->vtable)
+    return MS_FAILURE;
+  return layer->vtable->LayerApplyFilterToLayer(psNode, map, iLayerIndex);
+}
+
+/************************************************************************/
+/*               FLTLayerApplyCondSQLFilterToLayer                       */
+/*                                                                      */
+/* Helper function for layer virtual table architecture                 */
+/************************************************************************/
+int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                      int iLayerIndex) {
+  return FLTLayerApplyPlainFilterToLayer(psNode, map, iLayerIndex);
+}
+
+/************************************************************************/
+/*                           FLTGetTopBBOX                              */
+/*                                                                      */
+/* Return the "top" BBOX if there's a unique one.                       */
+/************************************************************************/
+static int FLTGetTopBBOXInternal(FilterEncodingNode *psNode,
+                                 FilterEncodingNode **ppsTopBBOX,
+                                 int *pnCount) {
+  if (psNode->pszValue && strcasecmp(psNode->pszValue, "BBOX") == 0) {
+    (*pnCount)++;
+    if (*pnCount == 1) {
+      *ppsTopBBOX = psNode;
+      return TRUE;
+    }
+    *ppsTopBBOX = NULL;
+    return FALSE;
+  } else if (psNode->pszValue && strcasecmp(psNode->pszValue, "AND") == 0) {
+    return FLTGetTopBBOXInternal(psNode->psLeftNode, ppsTopBBOX, pnCount) &&
+           FLTGetTopBBOXInternal(psNode->psRightNode, ppsTopBBOX, pnCount);
+  } else {
+    return TRUE;
+  }
+}
+
+static FilterEncodingNode *FLTGetTopBBOX(FilterEncodingNode *psNode) {
+  int nCount = 0;
+  FilterEncodingNode *psTopBBOX = NULL;
+  FLTGetTopBBOXInternal(psNode, &psTopBBOX, &nCount);
+  return psTopBBOX;
+}
+
+/************************************************************************/
+/*                   FLTLayerSetInvalidRectIfSupported                  */
+/*                                                                      */
+/*  This function will set in *rect a very huge extent if the layer     */
+/*  wfs_use_default_extent_for_getfeature metadata item is set to false */
+/*  and the layer supports such degenerate rectangle, as a hint that    */
+/*  they should not issue a spatial filter.                             */
+/************************************************************************/
+
+int FLTLayerSetInvalidRectIfSupported(layerObj *lp, rectObj *rect) {
+  const char *pszUseDefaultExtent = msOWSLookupMetadata(
+      &(lp->metadata), "F", "use_default_extent_for_getfeature");
+  if (pszUseDefaultExtent && !CSLTestBoolean(pszUseDefaultExtent) &&
+      (lp->connectiontype == MS_OGR ||
+       ((lp->connectiontype == MS_PLUGIN) &&
+        (strstr(lp->plugin_library, "msplugin_mssql2008") != NULL)))) {
+    const rectObj rectInvalid = MS_INIT_INVALID_RECT;
+    *rect = rectInvalid;
+    return MS_TRUE;
+  }
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                   FLTLayerApplyPlainFilterToLayer                    */
+/*                                                                      */
+/* Helper function for layer virtual table architecture                 */
+/************************************************************************/
+int FLTLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                    int iLayerIndex) {
+  char *pszExpression = NULL;
+  int status = MS_FALSE;
+  layerObj *lp = GET_LAYER(map, iLayerIndex);
+
+  pszExpression = FLTGetCommonExpression(psNode, lp);
+  if (pszExpression) {
+    FilterEncodingNode *psTopBBOX;
+    rectObj rect = map->extent;
+
+    FLTLayerSetInvalidRectIfSupported(lp, &rect);
+
+    psTopBBOX = FLTGetTopBBOX(psNode);
+    if (psTopBBOX) {
+      int can_remove_expression = MS_TRUE;
+      const char *pszEPSG = FLTGetBBOX(psNode, &rect);
+      if (pszEPSG && map->projection.numargs > 0) {
+        projectionObj sProjTmp;
+        msInitProjection(&sProjTmp);
+        msProjectionInheritContextFrom(&sProjTmp, &map->projection);
+        /* Use the non EPSG variant since axis swapping is done in
+         * FLTDoAxisSwappingIfNecessary */
+        if (msLoadProjectionString(&sProjTmp, pszEPSG) == 0) {
+          rectObj oldRect = rect;
+          msProjectRect(&sProjTmp, &map->projection, &rect);
+          /* If reprojection is involved, do not remove the expression */
+          if (rect.minx != oldRect.minx || rect.miny != oldRect.miny ||
+              rect.maxx != oldRect.maxx || rect.maxy != oldRect.maxy) {
+            can_remove_expression = MS_FALSE;
+          }
+        }
+        msFreeProjection(&sProjTmp);
+      }
+
+      /* Small optimization: if the query is just a BBOX, then do a */
+      /* msQueryByRect() */
+      if (psTopBBOX == psNode && can_remove_expression) {
+        msFree(pszExpression);
+        pszExpression = NULL;
+      }
+    }
+
+    if (map->debug == MS_DEBUGLEVEL_VVV) {
+      if (pszExpression)
+        msDebug("FLTLayerApplyPlainFilterToLayer(): %s, "
+                "rect=%.15g,%.15g,%.15g,%.15g\n",
+                pszExpression, rect.minx, rect.miny, rect.maxx, rect.maxy);
+      else
+        msDebug(
+            "FLTLayerApplyPlainFilterToLayer(): rect=%.15g,%.15g,%.15g,%.15g\n",
+            rect.minx, rect.miny, rect.maxx, rect.maxy);
+    }
+
+    status = FLTApplyFilterToLayerCommonExpressionWithRect(map, iLayerIndex,
+                                                           pszExpression, rect);
+    msFree(pszExpression);
+  }
+
+  return status;
+}
+
+/************************************************************************/
+/*            FilterNode *FLTPaserFilterEncoding(char *szXMLString)     */
+/*                                                                      */
+/*      Parses an Filter Encoding XML string and creates a              */
+/*      FilterEncodingNodes corresponding to the string.                */
+/*      Returns a pointer to the first node or NULL if                  */
+/*      unsuccessfull.                                                  */
+/*      Calling function should use FreeFilterEncodingNode function     */
+/*      to free memeory.                                                */
+/************************************************************************/
+FilterEncodingNode *FLTParseFilterEncoding(const char *szXMLString) {
+  CPLXMLNode *psRoot = NULL, *psChild = NULL, *psFilter = NULL;
+  FilterEncodingNode *psFilterNode = NULL;
+
+  if (szXMLString == NULL || strlen(szXMLString) == 0 ||
+      (strstr(szXMLString, "Filter") == NULL))
+    return NULL;
+
+  psRoot = CPLParseXMLString(szXMLString);
+
+  if (psRoot == NULL)
+    return NULL;
+
+  /* strip namespaces. We srtip all name spaces (#1350)*/
+  CPLStripXMLNamespace(psRoot, NULL, 1);
+
+  /* -------------------------------------------------------------------- */
+  /*      get the root element (Filter).                                  */
+  /* -------------------------------------------------------------------- */
+  psFilter = CPLGetXMLNode(psRoot, "=Filter");
+  if (!psFilter) {
+    CPLDestroyXMLNode(psRoot);
+    return NULL;
+  }
+
+  psChild = psFilter->psChild;
+  while (psChild) {
+    if (FLTIsSupportedFilterType(psChild)) {
+      psFilterNode = FLTCreateFilterEncodingNode();
+      FLTInsertElementInNode(psFilterNode, psChild);
+      break;
+    } else
+      psChild = psChild->psNext;
+  }
+
+  CPLDestroyXMLNode(psRoot);
+
+  /* -------------------------------------------------------------------- */
+  /*      validate the node tree to make sure that all the nodes are valid.*/
+  /* -------------------------------------------------------------------- */
+  if (!FLTValidFilterNode(psFilterNode)) {
+    FLTFreeFilterEncodingNode(psFilterNode);
+    return NULL;
+  }
+
+  return psFilterNode;
+}
+
+/************************************************************************/
+/*      int FLTValidFilterNode(FilterEncodingNode *psFilterNode)        */
+/*                                                                      */
+/*      Validate that all the nodes are filled properly. We could       */
+/*      have parts of the nodes that are correct and part which         */
+/*      could be incorrect if the filter string sent is corrupted       */
+/*      (eg missing a value :<PropertyName><PropertyName>)              */
+/************************************************************************/
+int FLTValidFilterNode(FilterEncodingNode *psFilterNode) {
+  if (!psFilterNode)
+    return 0;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_UNDEFINED)
+    return 0;
+
+  if (psFilterNode->psLeftNode) {
+    const int bReturn = FLTValidFilterNode(psFilterNode->psLeftNode);
+    if (bReturn == 0)
+      return 0;
+    else if (psFilterNode->psRightNode)
+      return FLTValidFilterNode(psFilterNode->psRightNode);
+  }
+
+  return 1;
+}
+
+/************************************************************************/
+/*                       FLTIsGeometryFilterNodeType                    */
+/************************************************************************/
+
+static int FLTIsGeometryFilterNodeType(int eType) {
+  return (eType == FILTER_NODE_TYPE_GEOMETRY_POINT ||
+          eType == FILTER_NODE_TYPE_GEOMETRY_LINE ||
+          eType == FILTER_NODE_TYPE_GEOMETRY_POLYGON);
+}
+
+/************************************************************************/
+/*                          FLTFreeFilterEncodingNode                   */
+/*                                                                      */
+/*      recursive freeing of Filter Encoding nodes.                      */
+/************************************************************************/
+void FLTFreeFilterEncodingNode(FilterEncodingNode *psFilterNode) {
+  if (psFilterNode) {
+    if (psFilterNode->psLeftNode) {
+      FLTFreeFilterEncodingNode(psFilterNode->psLeftNode);
+      psFilterNode->psLeftNode = NULL;
+    }
+    if (psFilterNode->psRightNode) {
+      FLTFreeFilterEncodingNode(psFilterNode->psRightNode);
+      psFilterNode->psRightNode = NULL;
+    }
+
+    if (psFilterNode->pszSRS)
+      free(psFilterNode->pszSRS);
+
+    if (psFilterNode->pOther) {
+      if (psFilterNode->pszValue != NULL &&
+          strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0) {
+        FEPropertyIsLike *propIsLike = (FEPropertyIsLike *)psFilterNode->pOther;
+        if (propIsLike->pszWildCard)
+          free(propIsLike->pszWildCard);
+        if (propIsLike->pszSingleChar)
+          free(propIsLike->pszSingleChar);
+        if (propIsLike->pszEscapeChar)
+          free(propIsLike->pszEscapeChar);
+      } else if (FLTIsGeometryFilterNodeType(psFilterNode->eType)) {
+        msFreeShape((shapeObj *)(psFilterNode->pOther));
+      }
+      /* else */
+      /* TODO free pOther special fields */
+      free(psFilterNode->pOther);
+    }
+
+    /* Cannot free pszValue before, 'cause we are testing it above */
+    if (psFilterNode->pszValue)
+      free(psFilterNode->pszValue);
+
+    free(psFilterNode);
+  }
+}
+
+/************************************************************************/
+/*                         FLTCreateFilterEncodingNode                  */
+/*                                                                      */
+/*      return a FilterEncoding node.                                    */
+/************************************************************************/
+FilterEncodingNode *FLTCreateFilterEncodingNode(void) {
+  FilterEncodingNode *psFilterNode = NULL;
+
+  psFilterNode = (FilterEncodingNode *)malloc(sizeof(FilterEncodingNode));
+  psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+  psFilterNode->pszValue = NULL;
+  psFilterNode->pOther = NULL;
+  psFilterNode->pszSRS = NULL;
+  psFilterNode->psLeftNode = NULL;
+  psFilterNode->psRightNode = NULL;
+
+  return psFilterNode;
+}
+
+FilterEncodingNode *FLTCreateBinaryCompFilterEncodingNode(void) {
+  FilterEncodingNode *psFilterNode = NULL;
+
+  psFilterNode = FLTCreateFilterEncodingNode();
+  /* used to store case sensitivity flag. Default is 0 meaning the
+     comparing is case sensititive */
+  psFilterNode->pOther = (int *)malloc(sizeof(int));
+  (*(int *)(psFilterNode->pOther)) = 0;
+
+  return psFilterNode;
+}
+
+/************************************************************************/
+/*                           FLTFindGeometryNode                        */
+/*                                                                      */
+/************************************************************************/
+
+static CPLXMLNode *FLTFindGeometryNode(CPLXMLNode *psXMLNode, int *pbPoint,
+                                       int *pbLine, int *pbPolygon) {
+  CPLXMLNode *psGMLElement = NULL;
+
+  psGMLElement = CPLGetXMLNode(psXMLNode, "Point");
+  if (!psGMLElement)
+    psGMLElement = CPLGetXMLNode(psXMLNode, "PointType");
+  if (psGMLElement)
+    *pbPoint = 1;
+  else {
+    psGMLElement = CPLGetXMLNode(psXMLNode, "Polygon");
+    if (psGMLElement)
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiPolygon")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Surface")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiSurface")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Box")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Envelope")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "LineString")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiLineString")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Curve")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiCurve")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiPoint")))
+      *pbPoint = 1;
+  }
+  return psGMLElement;
+}
+
+/************************************************************************/
+/*                           FLTGetPropertyName                         */
+/************************************************************************/
+static const char *FLTGetPropertyName(CPLXMLNode *psXMLNode) {
+  const char *pszPropertyName;
+
+  pszPropertyName = CPLGetXMLValue(psXMLNode, "PropertyName", NULL);
+  if (pszPropertyName == NULL) /* FE 2.0 ? */
+    pszPropertyName = CPLGetXMLValue(psXMLNode, "ValueReference", NULL);
+  return pszPropertyName;
+}
+
+/************************************************************************/
+/*                          FLTGetFirstChildNode                        */
+/************************************************************************/
+static CPLXMLNode *FLTGetFirstChildNode(CPLXMLNode *psXMLNode) {
+  if (psXMLNode == NULL)
+    return NULL;
+  psXMLNode = psXMLNode->psChild;
+  while (psXMLNode != NULL) {
+    if (psXMLNode->eType == CXT_Element)
+      return psXMLNode;
+    psXMLNode = psXMLNode->psNext;
+  }
+  return NULL;
+}
+
+/************************************************************************/
+/*                        FLTGetNextSibblingNode                        */
+/************************************************************************/
+static CPLXMLNode *FLTGetNextSibblingNode(CPLXMLNode *psXMLNode) {
+  if (psXMLNode == NULL)
+    return NULL;
+  psXMLNode = psXMLNode->psNext;
+  while (psXMLNode != NULL) {
+    if (psXMLNode->eType == CXT_Element)
+      return psXMLNode;
+    psXMLNode = psXMLNode->psNext;
+  }
+  return NULL;
+}
+
+/************************************************************************/
+/*                           FLTInsertElementInNode                     */
+/*                                                                      */
+/*      Utility function to parse an XML node and transfer the          */
+/*      contents into the Filter Encoding node structure.               */
+/************************************************************************/
+void FLTInsertElementInNode(FilterEncodingNode *psFilterNode,
+                            CPLXMLNode *psXMLNode) {
+  char *pszTmp = NULL;
+  FilterEncodingNode *psCurFilNode = NULL;
+  CPLXMLNode *psCurXMLNode = NULL;
+  CPLXMLNode *psTmpNode = NULL;
+  CPLXMLNode *psFeatureIdNode = NULL;
+  const char *pszFeatureId = NULL;
+  char *pszFeatureIdList = NULL;
+
+  if (psFilterNode && psXMLNode && psXMLNode->pszValue) {
+    psFilterNode->pszValue = msStrdup(psXMLNode->pszValue);
+    psFilterNode->psLeftNode = NULL;
+    psFilterNode->psRightNode = NULL;
+
+    /* -------------------------------------------------------------------- */
+    /*      Logical filter. AND, OR and NOT are supported. Example of       */
+    /*      filer using logical filters :                                   */
+    /*      <Filter>                                                        */
+    /*        <And>                                                         */
+    /*          <PropertyIsGreaterThan>                                     */
+    /*            <PropertyName>Person/Age</PropertyName>                   */
+    /*            <Literal>50</Literal>                                     */
+    /*          </PropertyIsGreaterThan>                                    */
+    /*          <PropertyIsEqualTo>                                         */
+    /*             <PropertyName>Person/Address/City</PropertyName>         */
+    /*             <Literal>Toronto</Literal>                               */
+    /*          </PropertyIsEqualTo>                                        */
+    /*        </And>                                                        */
+    /*      </Filter>                                                       */
+    /* -------------------------------------------------------------------- */
+    if (FLTIsLogicalFilterType(psXMLNode->pszValue)) {
+      psFilterNode->eType = FILTER_NODE_TYPE_LOGICAL;
+      if (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
+          strcasecmp(psFilterNode->pszValue, "OR") == 0) {
+        CPLXMLNode *psFirstNode = FLTGetFirstChildNode(psXMLNode);
+        CPLXMLNode *psSecondNode = FLTGetNextSibblingNode(psFirstNode);
+        if (psFirstNode && psSecondNode) {
+          /*2 operators */
+          CPLXMLNode *psNextNode = FLTGetNextSibblingNode(psSecondNode);
+          if (psNextNode == NULL) {
+            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+            FLTInsertElementInNode(psFilterNode->psLeftNode, psFirstNode);
+            psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
+            FLTInsertElementInNode(psFilterNode->psRightNode, psSecondNode);
+          } else {
+            psCurXMLNode = psFirstNode;
+            psCurFilNode = psFilterNode;
+            while (psCurXMLNode) {
+              psNextNode = FLTGetNextSibblingNode(psCurXMLNode);
+              if (FLTGetNextSibblingNode(psNextNode)) {
+                psCurFilNode->psLeftNode = FLTCreateFilterEncodingNode();
+                FLTInsertElementInNode(psCurFilNode->psLeftNode, psCurXMLNode);
+                psCurFilNode->psRightNode = FLTCreateFilterEncodingNode();
+                psCurFilNode->psRightNode->eType = FILTER_NODE_TYPE_LOGICAL;
+                psCurFilNode->psRightNode->pszValue =
+                    msStrdup(psFilterNode->pszValue);
+
+                psCurFilNode = psCurFilNode->psRightNode;
+                psCurXMLNode = psNextNode;
+              } else { /*last 2 operators*/
+                psCurFilNode->psLeftNode = FLTCreateFilterEncodingNode();
+                FLTInsertElementInNode(psCurFilNode->psLeftNode, psCurXMLNode);
+
+                psCurFilNode->psRightNode = FLTCreateFilterEncodingNode();
+                FLTInsertElementInNode(psCurFilNode->psRightNode, psNextNode);
+                break;
+              }
+            }
+          }
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      } else if (strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
+        CPLXMLNode *psFirstNode = FLTGetFirstChildNode(psXMLNode);
+        if (psFirstNode) {
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          FLTInsertElementInNode(psFilterNode->psLeftNode, psFirstNode);
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      } else
+        psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+    } /* end if is logical */
+    /* -------------------------------------------------------------------- */
+    /*      Spatial Filter.                                                 */
+    /*      BBOX :                                                          */
+    /*      <Filter>                                                        */
+    /*       <BBOX>                                                         */
+    /*        <PropertyName>Geometry</PropertyName>                         */
+    /*        <gml:Box srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
+    /*          <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
+    /*        </gml:Box>                                                    */
+    /*       </BBOX>                                                        */
+    /*      </Filter>                                                       */
+    /*                                                                      */
+    /*       DWithin                                                        */
+    /*                                                                      */
+    /*      <xsd:element name="DWithin"                                     */
+    /*      type="ogc:DistanceBufferType"                                   */
+    /*      substitutionGroup="ogc:spatialOps"/>                            */
+    /*                                                                      */
+    /*      <xsd:complexType name="DistanceBufferType">                     */
+    /*         <xsd:complexContent>                                         */
+    /*            <xsd:extension base="ogc:SpatialOpsType">                 */
+    /*               <xsd:sequence>                                         */
+    /*                  <xsd:element ref="ogc:PropertyName"/>               */
+    /*                  <xsd:element ref="gml:_Geometry"/>                  */
+    /*                  <xsd:element name="Distance" type="ogc:DistanceType"/>*/
+    /*               </xsd:sequence>                                        */
+    /*            </xsd:extension>                                          */
+    /*         </xsd:complexContent>                                        */
+    /*      </xsd:complexType>                                              */
+    /*                                                                      */
+    /*                                                                      */
+    /*       <Filter>                                                       */
+    /*       <DWithin>                                                      */
+    /*        <PropertyName>Geometry</PropertyName>                         */
+    /*        <gml:Point>                                                   */
+    /*          <gml:coordinates>13.0983,31.5899</gml:coordinates>          */
+    /*        </gml:Point>                                                  */
+    /*        <Distance units="url#m">10</Distance>                         */
+    /*       </DWithin>                                                     */
+    /*      </Filter>                                                       */
+    /*                                                                      */
+    /*       Intersect                                                      */
+    /*                                                                      */
+    /*       type="ogc:BinarySpatialOpType"
+       substitutionGroup="ogc:spatialOps"/>*/
+    /*      <xsd:element name="Intersects"                                  */
+    /*      type="ogc:BinarySpatialOpType"                                  */
+    /*      substitutionGroup="ogc:spatialOps"/>                            */
+    /*                                                                      */
+    /*      <xsd:complexType name="BinarySpatialOpType">                    */
+    /*      <xsd:complexContent>                                            */
+    /*      <xsd:extension base="ogc:SpatialOpsType">                       */
+    /*      <xsd:sequence>                                                  */
+    /*      <xsd:element ref="ogc:PropertyName"/>                           */
+    /*      <xsd:choice>                                                    */
+    /*      <xsd:element ref="gml:_Geometry"/>                              */
+    /*      <xsd:element ref="gml:Box"/>                                    */
+    /*      </xsd:sequence>                                                 */
+    /*      </xsd:extension>                                                */
+    /*      </xsd:complexContent>                                           */
+    /*      </xsd:complexType>                                              */
+    /* -------------------------------------------------------------------- */
+    else if (FLTIsSpatialFilterType(psXMLNode->pszValue)) {
+      psFilterNode->eType = FILTER_NODE_TYPE_SPATIAL;
+
+      if (strcasecmp(psXMLNode->pszValue, "BBOX") == 0) {
+        char *pszSRS = NULL;
+        const char *pszPropertyName = NULL;
+        CPLXMLNode *psBox = NULL, *psEnvelope = NULL;
+        rectObj sBox = {0, 0, 0, 0};
+
+        int bCoordinatesValid = 0;
+
+        pszPropertyName = FLTGetPropertyName(psXMLNode);
+        psBox = CPLGetXMLNode(psXMLNode, "Box");
+        if (!psBox)
+          psBox = CPLGetXMLNode(psXMLNode, "BoxType");
+
+        /*FE 1.0 used box FE1.1 uses envelop*/
+        if (psBox)
+          bCoordinatesValid = FLTParseGMLBox(psBox, &sBox, &pszSRS);
+        else if ((psEnvelope = CPLGetXMLNode(psXMLNode, "Envelope")))
+          bCoordinatesValid = FLTParseGMLEnvelope(psEnvelope, &sBox, &pszSRS);
+
+        if (bCoordinatesValid) {
+          /*set the srs if available*/
+          if (pszSRS)
+            psFilterNode->pszSRS = pszSRS;
+
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+          /* PropertyName is optional since FE 1.1.0, in which case */
+          /* the BBOX must apply to all geometry fields. As we support */
+          /* currently only one geometry field, this doesn't make much */
+          /* difference to further processing. */
+          if (pszPropertyName != NULL) {
+            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+          }
+
+          /* coordinates */
+          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_BBOX;
+          psFilterNode->psRightNode->pOther =
+              (rectObj *)msSmallMalloc(sizeof(rectObj));
+          ((rectObj *)psFilterNode->psRightNode->pOther)->minx = sBox.minx;
+          ((rectObj *)psFilterNode->psRightNode->pOther)->miny = sBox.miny;
+          ((rectObj *)psFilterNode->psRightNode->pOther)->maxx = sBox.maxx;
+          ((rectObj *)psFilterNode->psRightNode->pOther)->maxy = sBox.maxy;
+        } else {
+          msFree(pszSRS);
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+        }
+      } else if (strcasecmp(psXMLNode->pszValue, "DWithin") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Beyond") == 0)
+
+      {
+        shapeObj *psShape = NULL;
+        int bPoint = 0, bLine = 0, bPolygon = 0;
+        const char *pszUnits = NULL;
+        const char *pszDistance = NULL;
+        const char *pszPropertyName;
+        char *pszSRS = NULL;
+
+        CPLXMLNode *psGMLElement = NULL, *psDistance = NULL;
+
+        pszPropertyName = FLTGetPropertyName(psXMLNode);
+
+        psGMLElement =
+            FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
+
+        psDistance = CPLGetXMLNode(psXMLNode, "Distance");
+        if (psDistance != NULL)
+          pszDistance = CPLGetXMLValue(psDistance, NULL, NULL);
+        if (pszPropertyName != NULL && psGMLElement && psDistance != NULL) {
+          pszUnits = CPLGetXMLValue(psDistance, "units", NULL);
+          if (pszUnits == NULL) /* FE 2.0 */
+            pszUnits = CPLGetXMLValue(psDistance, "uom", NULL);
+          psShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+          msInitShape(psShape);
+          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS)) {
+            /*set the srs if available*/
+            if (pszSRS)
+              psFilterNode->pszSRS = pszSRS;
+
+            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+
+            psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
+            if (bPoint)
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POINT;
+            else if (bLine)
+              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_LINE;
+            else if (bPolygon)
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POLYGON;
+            psFilterNode->psRightNode->pOther = (shapeObj *)psShape;
+            /*the value will be distance;units*/
+            psFilterNode->psRightNode->pszValue = msStrdup(pszDistance);
+            if (pszUnits) {
+              psFilterNode->psRightNode->pszValue =
+                  msStringConcatenate(psFilterNode->psRightNode->pszValue, ";");
+              psFilterNode->psRightNode->pszValue = msStringConcatenate(
+                  psFilterNode->psRightNode->pszValue, pszUnits);
+            }
+          } else {
+            free(psShape);
+            msFree(pszSRS);
+            psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+          }
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      } else if (strcasecmp(psXMLNode->pszValue, "Intersect") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Intersects") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Equals") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Disjoint") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Touches") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Crosses") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Within") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Contains") == 0 ||
+                 strcasecmp(psXMLNode->pszValue, "Overlaps") == 0) {
+        shapeObj *psShape = NULL;
+        int bLine = 0, bPolygon = 0, bPoint = 0;
+        char *pszSRS = NULL;
+        const char *pszPropertyName;
+
+        CPLXMLNode *psGMLElement = NULL;
+
+        pszPropertyName = FLTGetPropertyName(psXMLNode);
+
+        psGMLElement =
+            FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
+
+        if (pszPropertyName != NULL && psGMLElement) {
+          psShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+          msInitShape(psShape);
+          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS)) {
+            /*set the srs if available*/
+            if (pszSRS)
+              psFilterNode->pszSRS = pszSRS;
+
+            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+
+            psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
+            if (bPoint)
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POINT;
+            else if (bLine)
+              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_LINE;
+            else if (bPolygon)
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POLYGON;
+            psFilterNode->psRightNode->pOther = (shapeObj *)psShape;
+
+          } else {
+            free(psShape);
+            msFree(pszSRS);
+            psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+          }
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      }
+
+    } /* end of is spatial */
+
+    /* -------------------------------------------------------------------- */
+    /*      Comparison Filter                                               */
+    /* -------------------------------------------------------------------- */
+    else if (FLTIsComparisonFilterType(psXMLNode->pszValue)) {
+      psFilterNode->eType = FILTER_NODE_TYPE_COMPARISON;
+      /* -------------------------------------------------------------------- */
+      /*      binary comaparison types. Example :                             */
+      /*                                                                      */
+      /*      <Filter>                                                        */
+      /*        <PropertyIsEqualTo>                                           */
+      /*          <PropertyName>SomeProperty</PropertyName>                   */
+      /*          <Literal>100</Literal>                                      */
+      /*        </PropertyIsEqualTo>                                          */
+      /*      </Filter>                                                       */
+      /* -------------------------------------------------------------------- */
+      if (FLTIsBinaryComparisonFilterType(psXMLNode->pszValue)) {
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        if (pszPropertyName != NULL) {
+
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+
+          psTmpNode = CPLSearchXMLNode(psXMLNode, "Literal");
+          if (psTmpNode) {
+            const char *pszLiteral = CPLGetXMLValue(psTmpNode, NULL, NULL);
+
+            psFilterNode->psRightNode = FLTCreateBinaryCompFilterEncodingNode();
+            psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
+
+            if (pszLiteral != NULL) {
+              const char *pszMatchCase;
+
+              psFilterNode->psRightNode->pszValue = msStrdup(pszLiteral);
+
+              pszMatchCase = CPLGetXMLValue(psXMLNode, "matchCase", NULL);
+
+              /*check if the matchCase attribute is set*/
+              if (pszMatchCase != NULL &&
+                  strcasecmp(pszMatchCase, "false") == 0) {
+                (*(int *)psFilterNode->psRightNode->pOther) = 1;
+              }
+
+            }
+            /* special case where the user puts an empty value */
+            /* for the Literal so it can end up as an empty  */
+            /* string query in the expression */
+            else
+              psFilterNode->psRightNode->pszValue = NULL;
+          }
+        }
+        if (psFilterNode->psLeftNode == NULL ||
+            psFilterNode->psRightNode == NULL)
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      PropertyIsBetween filter : extract property name and boudary    */
+      /*      values. The boundary  values are stored in the right            */
+      /*      node. The values are separated by a semi-column (;)             */
+      /*      Eg of Filter :                                                  */
+      /*      <PropertyIsBetween>                                             */
+      /*         <PropertyName>DEPTH</PropertyName>                           */
+      /*         <LowerBoundary><Literal>400</Literal></LowerBoundary>        */
+      /*         <UpperBoundary><Literal>800</Literal></UpperBoundary>        */
+      /*      </PropertyIsBetween>                                            */
+      /*                                                                      */
+      /*      Or                                                              */
+      /*      <PropertyIsBetween>                                             */
+      /*         <PropertyName>DEPTH</PropertyName>                           */
+      /*         <LowerBoundary>400</LowerBoundary>                           */
+      /*         <UpperBoundary>800</UpperBoundary>                           */
+      /*      </PropertyIsBetween>                                            */
+      /* -------------------------------------------------------------------- */
+      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsBetween") == 0) {
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        CPLXMLNode *psLowerBoundary = CPLGetXMLNode(psXMLNode, "LowerBoundary");
+        CPLXMLNode *psUpperBoundary = CPLGetXMLNode(psXMLNode, "UpperBoundary");
+        const char *pszLowerNode = NULL;
+        const char *pszUpperNode = NULL;
+        if (psLowerBoundary != NULL) {
+          /* check if the <Literal> is there */
+          if (CPLGetXMLNode(psLowerBoundary, "Literal") != NULL)
+            pszLowerNode = CPLGetXMLValue(psLowerBoundary, "Literal", NULL);
+          else
+            pszLowerNode = CPLGetXMLValue(psLowerBoundary, NULL, NULL);
+        }
+        if (psUpperBoundary != NULL) {
+          if (CPLGetXMLNode(psUpperBoundary, "Literal") != NULL)
+            pszUpperNode = CPLGetXMLValue(psUpperBoundary, "Literal", NULL);
+          else
+            pszUpperNode = CPLGetXMLValue(psUpperBoundary, NULL, NULL);
+        }
+        if (pszPropertyName != NULL && pszLowerNode != NULL &&
+            pszUpperNode != NULL) {
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+
+          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_BOUNDARY;
+
+          /* adding a ; between bounary values */
+          const int nStrLength =
+              strlen(pszLowerNode) + strlen(pszUpperNode) + 2;
+
+          psFilterNode->psRightNode->pszValue =
+              (char *)malloc(sizeof(char) * (nStrLength));
+          strcpy(psFilterNode->psRightNode->pszValue, pszLowerNode);
+          strlcat(psFilterNode->psRightNode->pszValue, ";", nStrLength);
+          strlcat(psFilterNode->psRightNode->pszValue, pszUpperNode,
+                  nStrLength);
+
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+
+      } /* end of PropertyIsBetween  */
+      /* -------------------------------------------------------------------- */
+      /*      PropertyIsLike                                                  */
+      /*                                                                      */
+      /*      <Filter>                                                        */
+      /*      <PropertyIsLike wildCard="*" singleChar="#" escape="!">         */
+      /*      <PropertyName>LAST_NAME</PropertyName>                          */
+      /*      <Literal>JOHN*</Literal>                                        */
+      /*      </PropertyIsLike>                                               */
+      /*      </Filter>                                                       */
+      /* -------------------------------------------------------------------- */
+      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsLike") == 0) {
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        const char *pszLiteral = CPLGetXMLValue(psXMLNode, "Literal", NULL);
+        const char *pszWildCard = CPLGetXMLValue(psXMLNode, "wildCard", NULL);
+        const char *pszSingleChar =
+            CPLGetXMLValue(psXMLNode, "singleChar", NULL);
+        const char *pszEscapeChar = CPLGetXMLValue(psXMLNode, "escape", NULL);
+        if (pszEscapeChar == NULL)
+          pszEscapeChar = CPLGetXMLValue(psXMLNode, "escapeChar", NULL);
+        if (pszPropertyName != NULL && pszLiteral != NULL &&
+            pszWildCard != NULL && pszSingleChar != NULL &&
+            pszEscapeChar != NULL) {
+          FEPropertyIsLike *propIsLike;
+
+          propIsLike = (FEPropertyIsLike *)malloc(sizeof(FEPropertyIsLike));
+
+          psFilterNode->pOther = propIsLike;
+          propIsLike->bCaseInsensitive = 0;
+          propIsLike->pszWildCard = msStrdup(pszWildCard);
+          propIsLike->pszSingleChar = msStrdup(pszSingleChar);
+          propIsLike->pszEscapeChar = msStrdup(pszEscapeChar);
+
+          pszTmp = (char *)CPLGetXMLValue(psXMLNode, "matchCase", NULL);
+          if (pszTmp && strcasecmp(pszTmp, "false") == 0) {
+            propIsLike->bCaseInsensitive = 1;
+          }
+          /* --------------------------------------------------------------------
+           */
+          /*      Create left and right node for the attribute and the value. */
+          /* --------------------------------------------------------------------
+           */
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+
+          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
+
+          psFilterNode->psRightNode->pszValue = msStrdup(pszLiteral);
+
+          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+
+      }
+
+      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsNull") == 0) {
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        if (pszPropertyName != NULL) {
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      }
+
+      else if (strcasecmp(psXMLNode->pszValue, "PropertyIsNil") == 0) {
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        if (pszPropertyName != NULL) {
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      }
+    }
+    /* -------------------------------------------------------------------- */
+    /*      FeatureId Filter                                                */
+    /*                                                                      */
+    /*      <ogc:Filter>                                                    */
+    /*      <ogc:FeatureId fid="INWATERA_1M.1013"/>                         */
+    /*      <ogc:FeatureId fid="INWATERA_1M.10"/>                           */
+    /*      <ogc:FeatureId fid="INWATERA_1M.13"/>                           */
+    /*      <ogc:FeatureId fid="INWATERA_1M.140"/>                          */
+    /*      <ogc:FeatureId fid="INWATERA_1M.5001"/>                         */
+    /*      <ogc:FeatureId fid="INWATERA_1M.2001"/>                         */
+    /*      </ogc:Filter>                                                   */
+    /*                                                                      */
+    /*                                                                      */
+    /*      Note that for FES1.1.0 the featureid has been depricated in     */
+    /*      favor of GmlObjectId                                            */
+    /*      <GmlObjectId gml:id="TREESA_1M.1234"/>                          */
+    /*                                                                      */
+    /*      And in FES 2.0, in favor of <fes:ResourceId rid="foo.1234"/>    */
+    /* -------------------------------------------------------------------- */
+    else if (FLTIsFeatureIdFilterType(psXMLNode->pszValue)) {
+      psFilterNode->eType = FILTER_NODE_TYPE_FEATUREID;
+      pszFeatureIdList = NULL;
+
+      psFeatureIdNode = psXMLNode;
+      while (psFeatureIdNode) {
+        pszFeatureId = CPLGetXMLValue(psFeatureIdNode, "fid", NULL);
+        if (!pszFeatureId)
+          pszFeatureId = CPLGetXMLValue(psFeatureIdNode, "id", NULL);
+        if (!pszFeatureId)
+          pszFeatureId = CPLGetXMLValue(psFeatureIdNode, "rid", NULL);
+
+        if (pszFeatureId) {
+          if (pszFeatureIdList)
+            pszFeatureIdList = msStringConcatenate(pszFeatureIdList, ",");
+
+          pszFeatureIdList =
+              msStringConcatenate(pszFeatureIdList, pszFeatureId);
+        }
+        psFeatureIdNode = psFeatureIdNode->psNext;
+      }
+
+      if (pszFeatureIdList) {
+        msFree(psFilterNode->pszValue);
+        psFilterNode->pszValue = msStrdup(pszFeatureIdList);
+        msFree(pszFeatureIdList);
+      } else
+        psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Temporal Filter.                                                */
+    /*
+    <fes:During>
+    <fes:ValueReference>gml:TimeInstant</fes:ValueReference>
+    <gml:TimePeriod gml:id="TP1">
+    <gml:begin>
+    <gml:TimeInstant gml:id="TI1">
+    <gml:timePosition>2005-05-17T00:00:00Z</gml:timePosition>
+    </gml:TimeInstant>
+    </gml:begin>
+    <gml:end>
+    <gml:TimeInstant gml:id="TI2">
+    <gml:timePosition>2005-05-23T00:00:00Z</gml:timePosition>
+    </gml:TimeInstant>
+    </gml:end>
+    </gml:TimePeriod>
+    </fes:During>
+    */
+    /* -------------------------------------------------------------------- */
+    else if (FLTIsTemporalFilterType(psXMLNode->pszValue)) {
+      psFilterNode->eType = FILTER_NODE_TYPE_TEMPORAL;
+
+      if (strcasecmp(psXMLNode->pszValue, "During") == 0) {
+        const char *pszPropertyName = NULL;
+        const char *pszBeginTime;
+        const char *pszEndTime;
+
+        pszPropertyName = FLTGetPropertyName(psXMLNode);
+        pszBeginTime = CPLGetXMLValue(
+            psXMLNode, "TimePeriod.begin.TimeInstant.timePosition", NULL);
+        if (pszBeginTime == NULL)
+          pszBeginTime =
+              CPLGetXMLValue(psXMLNode, "TimePeriod.beginPosition", NULL);
+        pszEndTime = CPLGetXMLValue(
+            psXMLNode, "TimePeriod.end.TimeInstant.timePosition", NULL);
+        if (pszEndTime == NULL)
+          pszEndTime =
+              CPLGetXMLValue(psXMLNode, "TimePeriod.endPosition", NULL);
+
+        if (pszPropertyName && pszBeginTime && pszEndTime &&
+            strchr(pszBeginTime, '\'') == NULL &&
+            strchr(pszBeginTime, '\\') == NULL &&
+            strchr(pszEndTime, '\'') == NULL &&
+            strchr(pszEndTime, '\\') == NULL &&
+            msTimeGetResolution(pszBeginTime) >= 0 &&
+            msTimeGetResolution(pszEndTime) >= 0) {
+
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+
+          psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_TIME_PERIOD;
+          psFilterNode->psRightNode->pszValue = static_cast<char *>(
+              msSmallMalloc(strlen(pszBeginTime) + strlen(pszEndTime) + 2));
+          sprintf(psFilterNode->psRightNode->pszValue, "%s/%s", pszBeginTime,
+                  pszEndTime);
+        } else
+          psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      } else {
+        psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+      }
+
+    } /* end of is temporal */
+  }
+}
+
+/************************************************************************/
+/*            int FLTIsLogicalFilterType((char *pszValue)                  */
+/*                                                                      */
+/*      return TRUE if the value of the node is of logical filter       */
+/*       encoding type.                                                 */
+/************************************************************************/
+int FLTIsLogicalFilterType(const char *pszValue) {
+  if (pszValue) {
+    if (strcasecmp(pszValue, "AND") == 0 || strcasecmp(pszValue, "OR") == 0 ||
+        strcasecmp(pszValue, "NOT") == 0)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*         int FLTIsBinaryComparisonFilterType(char *pszValue)             */
+/*                                                                      */
+/*      Binary comparison filter type.                                  */
+/************************************************************************/
+int FLTIsBinaryComparisonFilterType(const char *pszValue) {
+  if (pszValue) {
+    if (strcasecmp(pszValue, "PropertyIsEqualTo") == 0 ||
+        strcasecmp(pszValue, "PropertyIsNotEqualTo") == 0 ||
+        strcasecmp(pszValue, "PropertyIsLessThan") == 0 ||
+        strcasecmp(pszValue, "PropertyIsGreaterThan") == 0 ||
+        strcasecmp(pszValue, "PropertyIsLessThanOrEqualTo") == 0 ||
+        strcasecmp(pszValue, "PropertyIsGreaterThanOrEqualTo") == 0)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*            int FLTIsComparisonFilterType(char *pszValue)                */
+/*                                                                      */
+/*      return TRUE if the value of the node is of comparison filter    */
+/*      encoding type.                                                  */
+/************************************************************************/
+int FLTIsComparisonFilterType(const char *pszValue) {
+  if (pszValue) {
+    if (FLTIsBinaryComparisonFilterType(pszValue) ||
+        strcasecmp(pszValue, "PropertyIsLike") == 0 ||
+        strcasecmp(pszValue, "PropertyIsBetween") == 0 ||
+        strcasecmp(pszValue, "PropertyIsNull") == 0 ||
+        strcasecmp(pszValue, "PropertyIsNil") == 0)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*            int FLTIsFeatureIdFilterType(char *pszValue)              */
+/*                                                                      */
+/*      return TRUE if the value of the node is of featureid filter     */
+/*      encoding type.                                                  */
+/************************************************************************/
+int FLTIsFeatureIdFilterType(const char *pszValue) {
+  if (pszValue && (strcasecmp(pszValue, "FeatureId") == 0 ||
+                   strcasecmp(pszValue, "GmlObjectId") == 0 ||
+                   strcasecmp(pszValue, "ResourceId") == 0))
+
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*            int FLTIsSpatialFilterType(char *pszValue)                */
+/*                                                                      */
+/*      return TRUE if the value of the node is of spatial filter       */
+/*      encoding type.                                                  */
+/************************************************************************/
+int FLTIsSpatialFilterType(const char *pszValue) {
+  if (pszValue) {
+    if (strcasecmp(pszValue, "BBOX") == 0 ||
+        strcasecmp(pszValue, "DWithin") == 0 ||
+        strcasecmp(pszValue, "Intersect") == 0 ||
+        strcasecmp(pszValue, "Intersects") == 0 ||
+        strcasecmp(pszValue, "Equals") == 0 ||
+        strcasecmp(pszValue, "Disjoint") == 0 ||
+        strcasecmp(pszValue, "Touches") == 0 ||
+        strcasecmp(pszValue, "Crosses") == 0 ||
+        strcasecmp(pszValue, "Within") == 0 ||
+        strcasecmp(pszValue, "Contains") == 0 ||
+        strcasecmp(pszValue, "Overlaps") == 0 ||
+        strcasecmp(pszValue, "Beyond") == 0)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*            int FLTIsTemportalFilterType(char *pszValue)              */
+/*                                                                      */
+/*      return TRUE if the value of the node is of temporal filter      */
+/*      encoding type.                                                  */
+/************************************************************************/
+int FLTIsTemporalFilterType(const char *pszValue) {
+  if (pszValue) {
+    if (strcasecmp(pszValue, "During") == 0)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*           int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode)           */
+/*                                                                      */
+/*      Verfify if the value of the node is one of the supported        */
+/*      filter type.                                                    */
+/************************************************************************/
+int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode) {
+  if (psXMLNode) {
+    if (FLTIsLogicalFilterType(psXMLNode->pszValue) ||
+        FLTIsSpatialFilterType(psXMLNode->pszValue) ||
+        FLTIsComparisonFilterType(psXMLNode->pszValue) ||
+        FLTIsFeatureIdFilterType(psXMLNode->pszValue) ||
+        FLTIsTemporalFilterType(psXMLNode->pszValue))
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                          FLTNumberOfFilterType                       */
+/*                                                                      */
+/*      Loop trhough the nodes and return the number of nodes of        */
+/*      specified value.                                                */
+/************************************************************************/
+int FLTNumberOfFilterType(FilterEncodingNode *psFilterNode,
+                          const char *szType) {
+  int nCount = 0;
+  int nLeftNode = 0, nRightNode = 0;
+
+  if (!psFilterNode || !szType || !psFilterNode->pszValue)
+    return 0;
+
+  if (strcasecmp(psFilterNode->pszValue, (char *)szType) == 0)
+    nCount++;
+
+  if (psFilterNode->psLeftNode)
+    nLeftNode = FLTNumberOfFilterType(psFilterNode->psLeftNode, szType);
+
+  nCount += nLeftNode;
+
+  if (psFilterNode->psRightNode)
+    nRightNode = FLTNumberOfFilterType(psFilterNode->psRightNode, szType);
+  nCount += nRightNode;
+
+  return nCount;
+}
+
+/************************************************************************/
+/*                          FLTValidForBBoxFilter                       */
+/*                                                                      */
+/*      Validate if there is only one BBOX filter node. Here is waht    */
+/*      is supported (is valid) :                                       */
+/*        - one node which is a BBOX                                    */
+/*        - a logical AND with a valid BBOX                             */
+/*                                                                      */
+/*      eg 1: <Filter>                                                  */
+/*            <BBOX>                                                    */
+/*              <PropertyName>Geometry</PropertyName>                   */
+/*              <gml:Box
+ * srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
+/*                <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
+/*              </gml:Box>                                              */
+/*            </BBOX>                                                   */
+/*          </Filter>                                                   */
+/*                                                                      */
+/*      eg 2 :<Filter>                                                  */
+/*              <AND>                                                   */
+/*               <BBOX>                                                 */
+/*                <PropertyName>Geometry</PropertyName>                  */
+/*                <gml:Box
+ * srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
+/*                  <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
+/*                </gml:Box>                                            */
+/*               </BBOX>                                                */
+/*               <PropertyIsEqualTo>                                    */
+/*               <PropertyName>SomeProperty</PropertyName>              */
+/*                <Literal>100</Literal>                                */
+/*              </PropertyIsEqualTo>                                    */
+/*             </AND>                                                   */
+/*           </Filter>                                                  */
+/*                                                                      */
+/************************************************************************/
+int FLTValidForBBoxFilter(FilterEncodingNode *psFilterNode) {
+  int nCount = 0;
+
+  if (!psFilterNode || !psFilterNode->pszValue)
+    return 1;
+
+  nCount = FLTNumberOfFilterType(psFilterNode, "BBOX");
+
+  if (nCount > 1)
+    return 0;
+  else if (nCount == 0)
+    return 1;
+
+  /* nCount ==1  */
+  if (strcasecmp(psFilterNode->pszValue, "BBOX") == 0)
+    return 1;
+
+  if (strcasecmp(psFilterNode->pszValue, "AND") == 0) {
+    return FLTValidForBBoxFilter(psFilterNode->psLeftNode) &&
+           FLTValidForBBoxFilter(psFilterNode->psRightNode);
+  }
+
+  return 0;
+}
+
+#if 0
+static int FLTHasUniqueTopLevelDuringFilter(FilterEncodingNode *psFilterNode)
+{
+  int nCount = 0;
+
+  if (!psFilterNode || !psFilterNode->pszValue)
+    return 1;
+
+  nCount = FLTNumberOfFilterType(psFilterNode, "During");
+
+  if (nCount > 1)
+    return 0;
+  else if (nCount == 0)
+    return 1;
+
+  /* nCount ==1  */
+  if (strcasecmp(psFilterNode->pszValue, "During") == 0)
+    return 1;
+
+  if (strcasecmp(psFilterNode->pszValue, "AND") == 0) {
+    return FLTHasUniqueTopLevelDuringFilter(psFilterNode->psLeftNode) &&
+           FLTHasUniqueTopLevelDuringFilter(psFilterNode->psRightNode);
+  }
+
+  return 0;
+}
+#endif
+
+int FLTIsLineFilter(FilterEncodingNode *psFilterNode) {
+  if (!psFilterNode || !psFilterNode->pszValue)
+    return 0;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
+      psFilterNode->psRightNode &&
+      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_GEOMETRY_LINE)
+    return 1;
+
+  return 0;
+}
+
+int FLTIsPolygonFilter(FilterEncodingNode *psFilterNode) {
+  if (!psFilterNode || !psFilterNode->pszValue)
+    return 0;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
+      psFilterNode->psRightNode &&
+      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_GEOMETRY_POLYGON)
+    return 1;
+
+  return 0;
+}
+
+int FLTIsPointFilter(FilterEncodingNode *psFilterNode) {
+  if (!psFilterNode || !psFilterNode->pszValue)
+    return 0;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
+      psFilterNode->psRightNode &&
+      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_GEOMETRY_POINT)
+    return 1;
+
+  return 0;
+}
+
+int FLTIsBBoxFilter(FilterEncodingNode *psFilterNode) {
+  if (!psFilterNode || !psFilterNode->pszValue)
+    return 0;
+
+  if (strcasecmp(psFilterNode->pszValue, "BBOX") == 0)
+    return 1;
+
+  return 0;
+}
+
+shapeObj *FLTGetShape(FilterEncodingNode *psFilterNode, double *pdfDistance,
+                      int *pnUnit) {
+  char **tokens = NULL;
+  int nTokens = 0;
+  FilterEncodingNode *psNode = psFilterNode;
+  char *szUnitStr = NULL;
+  char *szUnit = NULL;
+
+  if (psNode) {
+    if (psNode->eType == FILTER_NODE_TYPE_SPATIAL && psNode->psRightNode)
+      psNode = psNode->psRightNode;
+
+    if (FLTIsGeometryFilterNodeType(psNode->eType)) {
+
+      if (psNode->pszValue && pdfDistance) {
+        /*
+        sytnax expected is "distance;unit" or just "distance"
+        if unit is there syntax is "URI#unit" (eg http://..../#m)
+        or just "unit"
+        */
+        tokens = msStringSplit(psNode->pszValue, ';', &nTokens);
+        if (tokens && nTokens >= 1) {
+          *pdfDistance = atof(tokens[0]);
+
+          if (nTokens == 2 && pnUnit) {
+            szUnitStr = msStrdup(tokens[1]);
+            msFreeCharArray(tokens, nTokens);
+            nTokens = 0;
+            tokens = msStringSplit(szUnitStr, '#', &nTokens);
+            msFree(szUnitStr);
+            if (tokens && nTokens >= 1) {
+              if (nTokens == 1)
+                szUnit = tokens[0];
+              else
+                szUnit = tokens[1];
+
+              if (strcasecmp(szUnit, "m") == 0 ||
+                  strcasecmp(szUnit, "meters") == 0)
+                *pnUnit = MS_METERS;
+              else if (strcasecmp(szUnit, "km") == 0 ||
+                       strcasecmp(szUnit, "kilometers") == 0)
+                *pnUnit = MS_KILOMETERS;
+              else if (strcasecmp(szUnit, "NM") == 0 ||
+                       strcasecmp(szUnit, "nauticalmiles") == 0)
+                *pnUnit = MS_NAUTICALMILES;
+              else if (strcasecmp(szUnit, "mi") == 0 ||
+                       strcasecmp(szUnit, "miles") == 0)
+                *pnUnit = MS_MILES;
+              else if (strcasecmp(szUnit, "in") == 0 ||
+                       strcasecmp(szUnit, "inches") == 0)
+                *pnUnit = MS_INCHES;
+              else if (strcasecmp(szUnit, "ft") == 0 ||
+                       strcasecmp(szUnit, "feet") == 0)
+                *pnUnit = MS_FEET;
+              else if (strcasecmp(szUnit, "deg") == 0 ||
+                       strcasecmp(szUnit, "dd") == 0)
+                *pnUnit = MS_DD;
+              else if (strcasecmp(szUnit, "px") == 0)
+                *pnUnit = MS_PIXELS;
+            }
+          }
+        }
+        msFreeCharArray(tokens, nTokens);
+      }
+
+      return (shapeObj *)psNode->pOther;
+    }
+  }
+  return NULL;
+}
+
+/************************************************************************/
+/*                                FLTGetBBOX                            */
+/*                                                                      */
+/*      Loop through the nodes are return the coordinates of the        */
+/*      first bbox node found. The retrun value is the epsg code of     */
+/*      the bbox.                                                       */
+/************************************************************************/
+const char *FLTGetBBOX(FilterEncodingNode *psFilterNode, rectObj *psRect) {
+  const char *pszReturn = NULL;
+
+  if (!psFilterNode || !psRect)
+    return NULL;
+
+  if (psFilterNode->pszValue &&
+      strcasecmp(psFilterNode->pszValue, "BBOX") == 0) {
+    if (psFilterNode->psRightNode && psFilterNode->psRightNode->pOther) {
+      rectObj *pRect = (rectObj *)psFilterNode->psRightNode->pOther;
+      psRect->minx = pRect->minx;
+      psRect->miny = pRect->miny;
+      psRect->maxx = pRect->maxx;
+      psRect->maxy = pRect->maxy;
+
+      return psFilterNode->pszSRS;
+    }
+  } else {
+    pszReturn = FLTGetBBOX(psFilterNode->psLeftNode, psRect);
+    if (pszReturn)
+      return pszReturn;
+    else
+      return FLTGetBBOX(psFilterNode->psRightNode, psRect);
+  }
+
+  return pszReturn;
+}
+
+const char *FLTGetDuring(FilterEncodingNode *psFilterNode,
+                         const char **ppszTimeField) {
+  const char *pszReturn = NULL;
+
+  if (!psFilterNode || !ppszTimeField)
+    return NULL;
+
+  if (psFilterNode->pszValue &&
+      strcasecmp(psFilterNode->pszValue, "During") == 0) {
+    *ppszTimeField = psFilterNode->psLeftNode->pszValue;
+    return psFilterNode->psRightNode->pszValue;
+  } else {
+    pszReturn = FLTGetDuring(psFilterNode->psLeftNode, ppszTimeField);
+    if (pszReturn)
+      return pszReturn;
+    else
+      return FLTGetDuring(psFilterNode->psRightNode, ppszTimeField);
+  }
+
+  return pszReturn;
+}
+
+/************************************************************************/
+/*                           FLTGetSQLExpression                        */
+/*                                                                      */
+/*      Build SQL expressions from the mapserver nodes.                 */
+/************************************************************************/
+char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode, layerObj *lp) {
+  char *pszExpression = NULL;
+
+  if (psFilterNode == NULL || lp == NULL)
+    return NULL;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON) {
+    if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
+      if (FLTIsBinaryComparisonFilterType(psFilterNode->pszValue)) {
+        pszExpression = FLTGetBinaryComparisonSQLExpresssion(psFilterNode, lp);
+      } else if (strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0) {
+        pszExpression =
+            FLTGetIsBetweenComparisonSQLExpresssion(psFilterNode, lp);
+      } else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0) {
+        pszExpression = FLTGetIsLikeComparisonSQLExpression(psFilterNode, lp);
+      }
+    }
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL) {
+    if (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
+        strcasecmp(psFilterNode->pszValue, "OR") == 0) {
+      pszExpression = FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
+
+    } else if (strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
+      pszExpression = FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
+    }
+  }
+
+  else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL) {
+    /* TODO */
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_FEATUREID) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+    if (psFilterNode->pszValue) {
+      const char *pszAttribute =
+          msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
+      if (pszAttribute) {
+        int nTokens = 0;
+        char **tokens = msStringSplit(psFilterNode->pszValue, ',', &nTokens);
+        int bString = 0;
+        if (tokens && nTokens > 0) {
+          for (int i = 0; i < nTokens; i++) {
+            char *pszEscapedStr = NULL;
+            const char *pszId = tokens[i];
+            const char *pszDot = strchr(pszId, '.');
+            if (pszDot)
+              pszId = pszDot + 1;
+
+            if (strlen(pszId) <= 0)
+              continue;
+
+            if (FLTIsNumeric(pszId) == MS_FALSE)
+              bString = 1;
+
+            pszEscapedStr = msLayerEscapeSQLParam(lp, pszId);
+            char szTmp[256];
+            if (bString) {
+              if (lp->connectiontype == MS_OGR ||
+                  lp->connectiontype == MS_POSTGIS)
+                snprintf(szTmp, sizeof(szTmp),
+                         "(CAST(%s AS CHARACTER(255)) = '%s')", pszAttribute,
+                         pszEscapedStr);
+              else
+                snprintf(szTmp, sizeof(szTmp), "(%s = '%s')", pszAttribute,
+                         pszEscapedStr);
+            } else
+              snprintf(szTmp, sizeof(szTmp), "(%s = %s)", pszAttribute,
+                       pszEscapedStr);
+
+            msFree(pszEscapedStr);
+            pszEscapedStr = NULL;
+
+            if (pszExpression != NULL)
+              pszExpression = msStringConcatenate(pszExpression, " OR ");
+            else
+              /*opening and closing brackets*/
+              pszExpression = msStringConcatenate(pszExpression, "(");
+
+            pszExpression = msStringConcatenate(pszExpression, szTmp);
+          }
+        }
+        msFreeCharArray(tokens, nTokens);
+      }
+      /*opening and closing brackets*/
+      if (pszExpression)
+        pszExpression = msStringConcatenate(pszExpression, ")");
+    }
+#else
+    msSetError(MS_MISCERR, "OWS support is not available.",
+               "FLTGetSQLExpression()");
+    return NULL;
+#endif
+
+  } else if (lp->connectiontype != MS_OGR &&
+             psFilterNode->eType == FILTER_NODE_TYPE_TEMPORAL)
+    pszExpression = msStrdup(FLTGetTimeExpression(psFilterNode, lp).c_str());
+
+  return pszExpression;
+}
+
+/************************************************************************/
+/*                     FLTGetLogicalComparisonSQLExpresssion            */
+/*                                                                      */
+/*      Return the expression for logical comparison expression.        */
+/************************************************************************/
+char *FLTGetLogicalComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                            layerObj *lp) {
+  char *pszBuffer = NULL;
+  char *pszTmp = NULL;
+
+  if (lp == NULL)
+    return NULL;
+
+  /* ==================================================================== */
+  /*      special case for BBOX node.                                     */
+  /* ==================================================================== */
+  if (psFilterNode->psLeftNode && psFilterNode->psRightNode &&
+      ((strcasecmp(psFilterNode->psLeftNode->pszValue, "BBOX") == 0) ||
+       (strcasecmp(psFilterNode->psRightNode->pszValue, "BBOX") == 0))) {
+    if (strcasecmp(psFilterNode->psLeftNode->pszValue, "BBOX") != 0)
+      pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
+    else
+      pszTmp = FLTGetSQLExpression(psFilterNode->psRightNode, lp);
+
+    if (!pszTmp)
+      return NULL;
+
+    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) + 1));
+    sprintf(pszBuffer, "%s", pszTmp);
+  }
+
+  /* ==================================================================== */
+  /*      special case for temporal filter node (OGR layer only)          */
+  /* ==================================================================== */
+  else if (lp->connectiontype == MS_OGR && psFilterNode->psLeftNode &&
+           psFilterNode->psRightNode &&
+           (psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_TEMPORAL ||
+            psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_TEMPORAL)) {
+    if (psFilterNode->psLeftNode->eType != FILTER_NODE_TYPE_TEMPORAL)
+      pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
+    else
+      pszTmp = FLTGetSQLExpression(psFilterNode->psRightNode, lp);
+
+    if (!pszTmp)
+      return NULL;
+
+    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) + 1));
+    sprintf(pszBuffer, "%s", pszTmp);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      OR and AND                                                      */
+  /* -------------------------------------------------------------------- */
+  else if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
+    pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
+    if (!pszTmp)
+      return NULL;
+
+    pszBuffer = (char *)malloc(
+        sizeof(char) * (strlen(pszTmp) + strlen(psFilterNode->pszValue) + 5));
+    pszBuffer[0] = '\0';
+    strcat(pszBuffer, " (");
+    strcat(pszBuffer, pszTmp);
+    strcat(pszBuffer, " ");
+    strcat(pszBuffer, psFilterNode->pszValue);
+    strcat(pszBuffer, " ");
+
+    free(pszTmp);
+
+    const size_t nTmp = strlen(pszBuffer);
+    pszTmp = FLTGetSQLExpression(psFilterNode->psRightNode, lp);
+    if (!pszTmp) {
+      free(pszBuffer);
+      return NULL;
+    }
+
+    pszBuffer = (char *)msSmallRealloc(
+        pszBuffer, sizeof(char) * (strlen(pszTmp) + nTmp + 3));
+    strcat(pszBuffer, pszTmp);
+    strcat(pszBuffer, ") ");
+  }
+  /* -------------------------------------------------------------------- */
+  /*      NOT                                                             */
+  /* -------------------------------------------------------------------- */
+  else if (psFilterNode->psLeftNode &&
+           strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
+    pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
+    if (!pszTmp)
+      return NULL;
+
+    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) + 9));
+    pszBuffer[0] = '\0';
+
+    strcat(pszBuffer, " (NOT ");
+    strcat(pszBuffer, pszTmp);
+    strcat(pszBuffer, ") ");
+  } else
+    return NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Cleanup.                                                        */
+  /* -------------------------------------------------------------------- */
+  if (pszTmp != NULL)
+    free(pszTmp);
+  return pszBuffer;
+}
+
+/************************************************************************/
+/*                      FLTGetBinaryComparisonSQLExpresssion            */
+/*                                                                      */
+/*      Return the expression for a binary comparison filter node.      */
+/************************************************************************/
+char *FLTGetBinaryComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                           layerObj *lp) {
+  const size_t bufferSize = 1024;
+  char szBuffer[1024];
+  int bString = 0;
+  char szTmp[256];
+  char *pszEscapedStr = NULL;
+
+  szBuffer[0] = '\0';
+  if (!psFilterNode || !FLTIsBinaryComparisonFilterType(psFilterNode->pszValue))
+    return NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      check if the value is a numeric value or alphanumeric. If it    */
+  /*      is alphanumeric, add quotes around attribute and values.        */
+  /* -------------------------------------------------------------------- */
+  bString = 0;
+  if (psFilterNode->psRightNode->pszValue) {
+    const char *pszOFGType;
+    snprintf(szTmp, sizeof(szTmp), "%s_type",
+             psFilterNode->psLeftNode->pszValue);
+    pszOFGType = msOWSLookupMetadata(&(lp->metadata), "OFG", szTmp);
+    if (pszOFGType != NULL && strcasecmp(pszOFGType, "Character") == 0)
+      bString = 1;
+
+    else if (FLTIsNumeric(psFilterNode->psRightNode->pszValue) == MS_FALSE)
+      bString = 1;
+  }
+
+  /* specical case to be able to have empty strings in the expression. */
+  if (psFilterNode->psRightNode->pszValue == NULL)
+    bString = 1;
+
+  /*opening bracket*/
+  strlcat(szBuffer, " (", bufferSize);
+
+  pszEscapedStr =
+      msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
+
+  /* attribute */
+  /*case insensitive set ? */
+  if (bString && strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0 &&
+      psFilterNode->psRightNode->pOther &&
+      (*(int *)psFilterNode->psRightNode->pOther) == 1) {
+    snprintf(szTmp, sizeof(szTmp), "lower(%s) ", pszEscapedStr);
+    strlcat(szBuffer, szTmp, bufferSize);
+  } else
+    strlcat(szBuffer, pszEscapedStr, bufferSize);
+
+  msFree(pszEscapedStr);
+  pszEscapedStr = NULL;
+
+  /* logical operator */
+  if (strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0)
+    strlcat(szBuffer, "=", bufferSize);
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsNotEqualTo") == 0)
+    strlcat(szBuffer, "<>", bufferSize);
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThan") == 0)
+    strlcat(szBuffer, "<", bufferSize);
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsGreaterThan") == 0)
+    strlcat(szBuffer, ">", bufferSize);
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThanOrEqualTo") ==
+           0)
+    strlcat(szBuffer, "<=", bufferSize);
+  else if (strcasecmp(psFilterNode->pszValue,
+                      "PropertyIsGreaterThanOrEqualTo") == 0)
+    strlcat(szBuffer, ">=", bufferSize);
+
+  strlcat(szBuffer, " ", bufferSize);
+
+  /* value */
+
+  if (bString && psFilterNode->psRightNode->pszValue &&
+      strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0 &&
+      psFilterNode->psRightNode->pOther &&
+      (*(int *)psFilterNode->psRightNode->pOther) == 1) {
+    char *pszEscapedStr;
+    pszEscapedStr =
+        msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
+    snprintf(szTmp, sizeof(szTmp), "lower('%s') ", pszEscapedStr);
+    msFree(pszEscapedStr);
+    strlcat(szBuffer, szTmp, bufferSize);
+  } else {
+    if (bString)
+      strlcat(szBuffer, "'", bufferSize);
+
+    if (psFilterNode->psRightNode->pszValue) {
+      if (bString) {
+        char *pszEscapedStr;
+        pszEscapedStr =
+            msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
+        strlcat(szBuffer, pszEscapedStr, bufferSize);
+        msFree(pszEscapedStr);
+        pszEscapedStr = NULL;
+      } else
+        strlcat(szBuffer, psFilterNode->psRightNode->pszValue, bufferSize);
+    }
+
+    if (bString)
+      strlcat(szBuffer, "'", bufferSize);
+  }
+  /*closing bracket*/
+  strlcat(szBuffer, ") ", bufferSize);
+
+  return msStrdup(szBuffer);
+}
+
+/************************************************************************/
+/*                    FLTGetIsBetweenComparisonSQLExpresssion           */
+/*                                                                      */
+/*      Build an SQL expresssion for IsBteween Filter.                  */
+/************************************************************************/
+char *FLTGetIsBetweenComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                              layerObj *lp) {
+  const size_t bufferSize = 1024;
+  char szBuffer[1024];
+  char **aszBounds = NULL;
+  int nBounds = 0;
+  int bString = 0;
+  char szTmp[256];
+  char *pszEscapedStr;
+
+  szBuffer[0] = '\0';
+  if (!psFilterNode ||
+      !(strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0))
+    return NULL;
+
+  if (!psFilterNode->psLeftNode || !psFilterNode->psRightNode)
+    return NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Get the bounds value which are stored like boundmin;boundmax    */
+  /* -------------------------------------------------------------------- */
+  aszBounds = msStringSplit(psFilterNode->psRightNode->pszValue, ';', &nBounds);
+  if (nBounds != 2) {
+    msFreeCharArray(aszBounds, nBounds);
+    return NULL;
+  }
+  /* -------------------------------------------------------------------- */
+  /*      check if the value is a numeric value or alphanumeric. If it    */
+  /*      is alphanumeric, add quotes around attribute and values.        */
+  /* -------------------------------------------------------------------- */
+  bString = 0;
+  if (aszBounds[0]) {
+    const char *pszOFGType;
+    snprintf(szTmp, sizeof(szTmp), "%s_type",
+             psFilterNode->psLeftNode->pszValue);
+    pszOFGType = msOWSLookupMetadata(&(lp->metadata), "OFG", szTmp);
+    if (pszOFGType != NULL && strcasecmp(pszOFGType, "Character") == 0)
+      bString = 1;
+    else if (FLTIsNumeric(aszBounds[0]) == MS_FALSE)
+      bString = 1;
+  }
+  if (!bString) {
+    if (aszBounds[1]) {
+      if (FLTIsNumeric(aszBounds[1]) == MS_FALSE)
+        bString = 1;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      build expresssion.                                              */
+  /* -------------------------------------------------------------------- */
+  /*opening paranthesis */
+  strlcat(szBuffer, " (", bufferSize);
+
+  /* attribute */
+  pszEscapedStr =
+      msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
+
+  strlcat(szBuffer, pszEscapedStr, bufferSize);
+  msFree(pszEscapedStr);
+  pszEscapedStr = NULL;
+
+  /*between*/
+  strlcat(szBuffer, " BETWEEN ", bufferSize);
+
+  /*bound 1*/
+  if (bString)
+    strlcat(szBuffer, "'", bufferSize);
+  pszEscapedStr = msLayerEscapeSQLParam(lp, aszBounds[0]);
+  strlcat(szBuffer, pszEscapedStr, bufferSize);
+  msFree(pszEscapedStr);
+  pszEscapedStr = NULL;
+
+  if (bString)
+    strlcat(szBuffer, "'", bufferSize);
+
+  strlcat(szBuffer, " AND ", bufferSize);
+
+  /*bound 2*/
+  if (bString)
+    strlcat(szBuffer, "'", bufferSize);
+  pszEscapedStr = msLayerEscapeSQLParam(lp, aszBounds[1]);
+  strlcat(szBuffer, pszEscapedStr, bufferSize);
+  msFree(pszEscapedStr);
+  pszEscapedStr = NULL;
+
+  if (bString)
+    strlcat(szBuffer, "'", bufferSize);
+
+  /*closing paranthesis*/
+  strlcat(szBuffer, ")", bufferSize);
+
+  msFreeCharArray(aszBounds, nBounds);
+
+  return msStrdup(szBuffer);
+}
+
+/************************************************************************/
+/*                      FLTGetIsLikeComparisonSQLExpression             */
+/*                                                                      */
+/*      Build an sql expression for IsLike filter.                      */
+/************************************************************************/
+char *FLTGetIsLikeComparisonSQLExpression(FilterEncodingNode *psFilterNode,
+                                          layerObj *lp) {
+  const size_t bufferSize = 1024;
+  char szBuffer[1024];
+  char *pszValue = NULL;
+
+  const char *pszWild = NULL;
+  const char *pszSingle = NULL;
+  const char *pszEscape = NULL;
+  char szTmp[4];
+
+  int nLength = 0, i = 0, j = 0;
+  int bCaseInsensitive = 0;
+
+  char *pszEscapedStr = NULL;
+  FEPropertyIsLike *propIsLike;
+
+  if (!psFilterNode || !psFilterNode->pOther || !psFilterNode->psLeftNode ||
+      !psFilterNode->psRightNode || !psFilterNode->psRightNode->pszValue)
+    return NULL;
+
+  propIsLike = (FEPropertyIsLike *)psFilterNode->pOther;
+  pszWild = propIsLike->pszWildCard;
+  pszSingle = propIsLike->pszSingleChar;
+  pszEscape = propIsLike->pszEscapeChar;
+  bCaseInsensitive = propIsLike->bCaseInsensitive;
+
+  if (!pszWild || strlen(pszWild) == 0 || !pszSingle ||
+      strlen(pszSingle) == 0 || !pszEscape || strlen(pszEscape) == 0)
+    return NULL;
+
+  if (pszEscape[0] == '\'') {
+    /* This might be valid, but the risk of SQL injection is too high */
+    /* and the below code is not ready for that */
+    /* Someone who does this has clearly suspect intentions ! */
+    msSetError(
+        MS_MISCERR,
+        "Single quote character is not allowed as an escaping character.",
+        "FLTGetIsLikeComparisonSQLExpression()");
+    return NULL;
+  }
+
+  szBuffer[0] = '\0';
+  /*opening bracket*/
+  strlcat(szBuffer, " (", bufferSize);
+
+  /* attribute name */
+  pszEscapedStr =
+      msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
+
+  strlcat(szBuffer, pszEscapedStr, bufferSize);
+  msFree(pszEscapedStr);
+  pszEscapedStr = NULL;
+
+  if (lp->connectiontype == MS_POSTGIS) {
+    if (bCaseInsensitive == 1)
+      strlcat(szBuffer, "::text ilike '", bufferSize);
+    else
+      strlcat(szBuffer, "::text like '", bufferSize);
+  } else
+    strlcat(szBuffer, " like '", bufferSize);
+
+  pszValue = psFilterNode->psRightNode->pszValue;
+  nLength = strlen(pszValue);
+
+  pszEscapedStr = (char *)msSmallMalloc(3 * nLength + 1);
+
+  for (i = 0, j = 0; i < nLength; i++) {
+    char c = pszValue[i];
+    if (c != pszWild[0] && c != pszSingle[0] && c != pszEscape[0]) {
+      if (c == '\'') {
+        pszEscapedStr[j++] = '\'';
+        pszEscapedStr[j++] = '\'';
+      } else if (c == '\\') {
+        pszEscapedStr[j++] = '\\';
+        pszEscapedStr[j++] = '\\';
+      } else
+        pszEscapedStr[j++] = c;
+    } else if (c == pszSingle[0]) {
+      pszEscapedStr[j++] = '_';
+    } else if (c == pszEscape[0]) {
+      pszEscapedStr[j++] = pszEscape[0];
+      if (i + 1 < nLength) {
+        char nextC = pszValue[i + 1];
+        i++;
+        if (nextC == '\'') {
+          pszEscapedStr[j++] = '\'';
+          pszEscapedStr[j++] = '\'';
+        } else
+          pszEscapedStr[j++] = nextC;
+      }
+    } else if (c == pszWild[0]) {
+      pszEscapedStr[j++] = '%';
+    }
+  }
+  pszEscapedStr[j++] = 0;
+  strlcat(szBuffer, pszEscapedStr, bufferSize);
+  msFree(pszEscapedStr);
+
+  strlcat(szBuffer, "'", bufferSize);
+  if (lp->connectiontype != MS_OGR) {
+    if (lp->connectiontype == MS_POSTGIS && pszEscape[0] == '\\')
+      strlcat(szBuffer, " escape E'", bufferSize);
+    else
+      strlcat(szBuffer, " escape '", bufferSize);
+    szTmp[0] = pszEscape[0];
+    if (pszEscape[0] == '\\') {
+      szTmp[1] = '\\';
+      szTmp[2] = '\'';
+      szTmp[3] = '\0';
+    } else {
+      szTmp[1] = '\'';
+      szTmp[2] = '\0';
+    }
+
+    strlcat(szBuffer, szTmp, bufferSize);
+  }
+  strlcat(szBuffer, ") ", bufferSize);
+
+  return msStrdup(szBuffer);
+}
+
+/************************************************************************/
+/*                           FLTHasSpatialFilter                        */
+/*                                                                      */
+/*      Utility function to see if a spatial filter is included in      */
+/*      the node.                                                       */
+/************************************************************************/
+int FLTHasSpatialFilter(FilterEncodingNode *psNode) {
+  int bResult = MS_FALSE;
+
+  if (!psNode)
+    return MS_FALSE;
+
+  if (psNode->eType == FILTER_NODE_TYPE_LOGICAL) {
+    if (psNode->psLeftNode)
+      bResult = FLTHasSpatialFilter(psNode->psLeftNode);
+
+    if (bResult)
+      return MS_TRUE;
+
+    if (psNode->psRightNode)
+      bResult = FLTHasSpatialFilter(psNode->psRightNode);
+
+    if (bResult)
+      return MS_TRUE;
+  } else if (FLTIsBBoxFilter(psNode) || FLTIsPointFilter(psNode) ||
+             FLTIsLineFilter(psNode) || FLTIsPolygonFilter(psNode))
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                     FLTCreateFeatureIdFilterEncoding                 */
+/*                                                                      */
+/*      Utility function to create a filter node of FeatureId type.     */
+/************************************************************************/
+FilterEncodingNode *FLTCreateFeatureIdFilterEncoding(const char *pszString) {
+  FilterEncodingNode *psFilterNode = NULL;
+
+  if (pszString) {
+    psFilterNode = FLTCreateFilterEncodingNode();
+    psFilterNode->eType = FILTER_NODE_TYPE_FEATUREID;
+    psFilterNode->pszValue = msStrdup(pszString);
+    return psFilterNode;
+  }
+  return NULL;
+}
+
+/************************************************************************/
+/*                              FLTParseGMLBox                          */
+/*                                                                      */
+/*      Parse gml box. Used for FE 1.0                                  */
+/************************************************************************/
+int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox, char **ppszSRS) {
+  int bCoordinatesValid = 0;
+  CPLXMLNode *psCoordinates = NULL;
+  CPLXMLNode *psCoord1 = NULL, *psCoord2 = NULL;
+  char **papszCoords = NULL, **papszMin = NULL, **papszMax = NULL;
+  int nCoords = 0, nCoordsMin = 0, nCoordsMax = 0;
+  const char *pszTmpCoord = NULL;
+  const char *pszSRS = NULL;
+  const char *pszTS = NULL;
+  const char *pszCS = NULL;
+  double minx = 0.0, miny = 0.0, maxx = 0.0, maxy = 0.0;
+
+  if (psBox) {
+    pszSRS = CPLGetXMLValue(psBox, "srsName", NULL);
+    if (ppszSRS && pszSRS)
+      *ppszSRS = msStrdup(pszSRS);
+
+    psCoordinates = CPLGetXMLNode(psBox, "coordinates");
+    pszTS = CPLGetXMLValue(psCoordinates, "ts", NULL);
+    if (pszTS == NULL)
+      pszTS = " ";
+    pszCS = CPLGetXMLValue(psCoordinates, "cs", NULL);
+    if (pszCS == NULL)
+      pszCS = ",";
+    pszTmpCoord = CPLGetXMLValue(psCoordinates, NULL, NULL);
+
+    if (pszTmpCoord) {
+      papszCoords = msStringSplit(pszTmpCoord, pszTS[0], &nCoords);
+      if (papszCoords && nCoords == 2) {
+        papszMin = msStringSplit(papszCoords[0], pszCS[0], &nCoordsMin);
+        if (papszMin && nCoordsMin == 2) {
+          papszMax = msStringSplit(papszCoords[1], pszCS[0], &nCoordsMax);
+        }
+        if (papszMax && nCoordsMax == 2) {
+          bCoordinatesValid = 1;
+          minx = atof(papszMin[0]);
+          miny = atof(papszMin[1]);
+          maxx = atof(papszMax[0]);
+          maxy = atof(papszMax[1]);
+        }
+
+        msFreeCharArray(papszMin, nCoordsMin);
+        msFreeCharArray(papszMax, nCoordsMax);
+      }
+
+      msFreeCharArray(papszCoords, nCoords);
+    } else {
+      psCoord1 = CPLGetXMLNode(psBox, "coord");
+      psCoord2 = FLTGetNextSibblingNode(psCoord1);
+      if (psCoord1 && psCoord2 && strcmp(psCoord2->pszValue, "coord") == 0) {
+        const char *pszX = CPLGetXMLValue(psCoord1, "X", NULL);
+        const char *pszY = CPLGetXMLValue(psCoord1, "Y", NULL);
+        if (pszX && pszY) {
+          minx = atof(pszX);
+          miny = atof(pszY);
+
+          pszX = CPLGetXMLValue(psCoord2, "X", NULL);
+          pszY = CPLGetXMLValue(psCoord2, "Y", NULL);
+          if (pszX && pszY) {
+            maxx = atof(pszX);
+            maxy = atof(pszY);
+            bCoordinatesValid = 1;
+          }
+        }
+      }
+    }
+  }
+
+  if (bCoordinatesValid) {
+    psBbox->minx = minx;
+    psBbox->miny = miny;
+
+    psBbox->maxx = maxx;
+    psBbox->maxy = maxy;
+  }
+
+  return bCoordinatesValid;
+}
+/************************************************************************/
+/*                           FLTParseGMLEnvelope                        */
+/*                                                                      */
+/*      Utility function to parse a gml:Envelope (used for SOS and FE1.1)*/
+/************************************************************************/
+int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox, char **ppszSRS) {
+  CPLXMLNode *psUpperCorner = NULL, *psLowerCorner = NULL;
+  const char *pszLowerCorner = NULL, *pszUpperCorner = NULL;
+  int bValid = 0;
+  char **tokens;
+  int n;
+
+  if (psRoot && psBbox && psRoot->eType == CXT_Element &&
+      EQUAL(psRoot->pszValue, "Envelope")) {
+    /*Get the srs if available*/
+    if (ppszSRS) {
+      const char *pszSRS = CPLGetXMLValue(psRoot, "srsName", NULL);
+      if (pszSRS != NULL)
+        *ppszSRS = msStrdup(pszSRS);
+    }
+    psLowerCorner = CPLSearchXMLNode(psRoot, "lowerCorner");
+    psUpperCorner = CPLSearchXMLNode(psRoot, "upperCorner");
+
+    if (psLowerCorner && psUpperCorner) {
+      pszLowerCorner = CPLGetXMLValue(psLowerCorner, NULL, NULL);
+      pszUpperCorner = CPLGetXMLValue(psUpperCorner, NULL, NULL);
+
+      if (pszLowerCorner && pszUpperCorner) {
+        tokens = msStringSplit(pszLowerCorner, ' ', &n);
+        if (tokens && n >= 2) {
+          psBbox->minx = atof(tokens[0]);
+          psBbox->miny = atof(tokens[1]);
+
+          msFreeCharArray(tokens, n);
+
+          tokens = msStringSplit(pszUpperCorner, ' ', &n);
+          if (tokens && n >= 2) {
+            psBbox->maxx = atof(tokens[0]);
+            psBbox->maxy = atof(tokens[1]);
+            bValid = 1;
+          }
+        }
+        msFreeCharArray(tokens, n);
+      }
+    }
+  }
+
+  return bValid;
+}
+
+/************************************************************************/
+/*                        FLTNeedSRSSwapping                            */
+/************************************************************************/
+
+static int FLTNeedSRSSwapping(mapObj *map, const char *pszSRS) {
+  int bNeedSwapping = MS_FALSE;
+  projectionObj sProjTmp;
+  msInitProjection(&sProjTmp);
+  if (map) {
+    msProjectionInheritContextFrom(&sProjTmp, &map->projection);
+  }
+  if (msLoadProjectionStringEPSG(&sProjTmp, pszSRS) == 0) {
+    bNeedSwapping = msIsAxisInvertedProj(&sProjTmp);
+  }
+  msFreeProjection(&sProjTmp);
+  return bNeedSwapping;
+}
+
+/************************************************************************/
+/*                      FLTDoAxisSwappingIfNecessary                    */
+/*                                                                      */
+/*      Explore all geometries and BBOX to do axis swapping when the    */
+/*      SRS requires it. If no explicit SRS is attached to the geometry */
+/*      the bDefaultSRSNeedsAxisSwapping is taken into account. The     */
+/*      caller will have to determine its value from a more general     */
+/*      context.                                                        */
+/************************************************************************/
+void FLTDoAxisSwappingIfNecessary(mapObj *map, FilterEncodingNode *psFilterNode,
+                                  int bDefaultSRSNeedsAxisSwapping) {
+  if (psFilterNode == NULL)
+    return;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
+      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_BBOX) {
+    rectObj *rect = (rectObj *)psFilterNode->psRightNode->pOther;
+    const char *pszSRS = psFilterNode->pszSRS;
+    if ((pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
+        (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping)) {
+      double tmp;
+
+      tmp = rect->minx;
+      rect->minx = rect->miny;
+      rect->miny = tmp;
+
+      tmp = rect->maxx;
+      rect->maxx = rect->maxy;
+      rect->maxy = tmp;
+    }
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
+             FLTIsGeometryFilterNodeType(psFilterNode->psRightNode->eType)) {
+    shapeObj *shape = (shapeObj *)(psFilterNode->psRightNode->pOther);
+    const char *pszSRS = psFilterNode->pszSRS;
+    if ((pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
+        (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping)) {
+      msAxisSwapShape(shape);
+    }
+  } else {
+    FLTDoAxisSwappingIfNecessary(map, psFilterNode->psLeftNode,
+                                 bDefaultSRSNeedsAxisSwapping);
+    FLTDoAxisSwappingIfNecessary(map, psFilterNode->psRightNode,
+                                 bDefaultSRSNeedsAxisSwapping);
+  }
+}
+
+static void FLTReplacePropertyName(FilterEncodingNode *psFilterNode,
+                                   const char *pszOldName,
+                                   const char *pszNewName) {
+  if (psFilterNode && pszOldName && pszNewName) {
+    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+      if (psFilterNode->pszValue &&
+          strcasecmp(psFilterNode->pszValue, pszOldName) == 0) {
+        msFree(psFilterNode->pszValue);
+        psFilterNode->pszValue = msStrdup(pszNewName);
+      }
+    }
+    if (psFilterNode->psLeftNode)
+      FLTReplacePropertyName(psFilterNode->psLeftNode, pszOldName, pszNewName);
+    if (psFilterNode->psRightNode)
+      FLTReplacePropertyName(psFilterNode->psRightNode, pszOldName, pszNewName);
+  }
+}
+
+static int FLTIsGMLDefaultProperty(const char *pszName) {
+  return (strcmp(pszName, "gml:name") == 0 ||
+          strcmp(pszName, "gml:description") == 0 ||
+          strcmp(pszName, "gml:descriptionReference") == 0 ||
+          strcmp(pszName, "gml:identifier") == 0 ||
+          strcmp(pszName, "gml:boundedBy") == 0 ||
+          strcmp(pszName, "@gml:id") == 0);
+}
+
+static void
+FLTStripNameSpacesFromPropertyName(FilterEncodingNode *psFilterNode) {
+  char **tokens = NULL;
+  int n = 0;
+
+  if (psFilterNode) {
+
+    if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+        psFilterNode->psLeftNode != NULL &&
+        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME &&
+        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue)) {
+      return;
+    }
+
+    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+      if (psFilterNode->pszValue && strstr(psFilterNode->pszValue, ":")) {
+        tokens = msStringSplit(psFilterNode->pszValue, ':', &n);
+        if (tokens && n == 2) {
+          msFree(psFilterNode->pszValue);
+          psFilterNode->pszValue = msStrdup(tokens[1]);
+        }
+        msFreeCharArray(tokens, n);
+      }
+    }
+    if (psFilterNode->psLeftNode)
+      FLTStripNameSpacesFromPropertyName(psFilterNode->psLeftNode);
+    if (psFilterNode->psRightNode)
+      FLTStripNameSpacesFromPropertyName(psFilterNode->psRightNode);
+  }
+}
+
+static void FLTRemoveGroupName(FilterEncodingNode *psFilterNode,
+                               gmlGroupListObj *groupList) {
+  int i;
+
+  if (psFilterNode) {
+
+    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+      if (psFilterNode->pszValue != NULL) {
+        const char *pszPropertyName = psFilterNode->pszValue;
+        const char *pszSlash = strchr(pszPropertyName, '/');
+        if (pszSlash != NULL) {
+          const char *pszColon = strchr(pszPropertyName, ':');
+          if (pszColon != NULL && pszColon < pszSlash)
+            pszPropertyName = pszColon + 1;
+          for (i = 0; i < groupList->numgroups; i++) {
+            const char *pszGroupName = groupList->groups[i].name;
+            size_t nGroupNameLen = strlen(pszGroupName);
+            if (strncasecmp(pszPropertyName, pszGroupName, nGroupNameLen) ==
+                    0 &&
+                pszPropertyName[nGroupNameLen] == '/') {
+              char *pszTmp;
+              pszPropertyName = pszPropertyName + nGroupNameLen + 1;
+              pszColon = strchr(pszPropertyName, ':');
+              if (pszColon != NULL)
+                pszPropertyName = pszColon + 1;
+              pszTmp = msStrdup(pszPropertyName);
+              msFree(psFilterNode->pszValue);
+              psFilterNode->pszValue = pszTmp;
+              break;
+            }
+          }
+        }
+      }
+    }
+
+    if (psFilterNode->psLeftNode)
+      FLTRemoveGroupName(psFilterNode->psLeftNode, groupList);
+    if (psFilterNode->psRightNode)
+      FLTRemoveGroupName(psFilterNode->psRightNode, groupList);
+  }
+}
+
+/************************************************************************/
+/*                    FLTPreParseFilterForAliasAndGroup                 */
+/*                                                                      */
+/*      Utility function to replace aliased' and grouped attributes     */
+/*      with their internal name.                                       */
+/************************************************************************/
+void FLTPreParseFilterForAliasAndGroup(FilterEncodingNode *psFilterNode,
+                                       mapObj *map, int i,
+                                       const char *namespaces) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+  if (psFilterNode && map && i >= 0 && i < map->numlayers) {
+    /*strip name spaces before hand*/
+    FLTStripNameSpacesFromPropertyName(psFilterNode);
+
+    layerObj *lp = GET_LAYER(map, i);
+    int layerWasOpened = msLayerIsOpen(lp);
+    if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
+
+      /* Remove group names from property names if using groupname/itemname
+       * syntax */
+      gmlGroupListObj *groupList = msGMLGetGroups(lp, namespaces);
+      if (groupList && groupList->numgroups > 0)
+        FLTRemoveGroupName(psFilterNode, groupList);
+      msGMLFreeGroups(groupList);
+
+      for (i = 0; i < lp->numitems; i++) {
+        if (!lp->items[i] || strlen(lp->items[i]) <= 0)
+          continue;
+        char szTmp[256];
+        snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
+        const char *pszFullName =
+            msOWSLookupMetadata(&(lp->metadata), namespaces, szTmp);
+        if (pszFullName) {
+          FLTReplacePropertyName(psFilterNode, pszFullName, lp->items[i]);
+        }
+      }
+      if (!layerWasOpened) /* do not close the layer if it has been opened
+                              somewhere else (paging?) */
+        msLayerClose(lp);
+    }
+  }
+#else
+  msSetError(MS_MISCERR, "OWS support is not available.",
+             "FLTPreParseFilterForAlias()");
+
+#endif
+}
+
+/************************************************************************/
+/*                        FLTCheckFeatureIdFilters                      */
+/*                                                                      */
+/*      Check that FeatureId filters match features in the active       */
+/*      layer.                                                          */
+/************************************************************************/
+int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i) {
+  int status = MS_SUCCESS;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_FEATUREID) {
+    char **tokens;
+    int nTokens = 0;
+    layerObj *lp;
+    int j;
+
+    lp = GET_LAYER(map, i);
+    tokens = msStringSplit(psFilterNode->pszValue, ',', &nTokens);
+    for (j = 0; j < nTokens; j++) {
+      const char *pszId = tokens[j];
+      const char *pszDot = strrchr(pszId, '.');
+      if (pszDot) {
+        if (static_cast<size_t>(pszDot - pszId) != strlen(lp->name) ||
+            strncasecmp(pszId, lp->name, strlen(lp->name)) != 0) {
+          msSetError(MS_MISCERR,
+                     "Feature id %s not consistent with feature type name %s.",
+                     "FLTPreParseFilterForAlias()", pszId, lp->name);
+          status = MS_FAILURE;
+          break;
+        }
+      }
+    }
+    msFreeCharArray(tokens, nTokens);
+  }
+
+  if (psFilterNode->psLeftNode) {
+    status = FLTCheckFeatureIdFilters(psFilterNode->psLeftNode, map, i);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTCheckFeatureIdFilters(psFilterNode->psRightNode, map, i);
+    }
+  }
+  return status;
+}
+
+/************************************************************************/
+/*                        FLTCheckInvalidOperand                        */
+/*                                                                      */
+/*      Check that the operand of a comparison operator is valid        */
+/*      Currently only detects use of boundedBy in a binary comparison  */
+/************************************************************************/
+int FLTCheckInvalidOperand(FilterEncodingNode *psFilterNode) {
+  int status = MS_SUCCESS;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+    if (strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") == 0 &&
+        strcmp(psFilterNode->pszValue, "PropertyIsNull") != 0 &&
+        strcmp(psFilterNode->pszValue, "PropertyIsNil") != 0) {
+      msSetError(MS_MISCERR, "Operand '%s' is invalid in comparison.",
+                 "FLTCheckInvalidOperand()",
+                 psFilterNode->psLeftNode->pszValue);
+      return MS_FAILURE;
+    }
+  }
+  if (psFilterNode->psLeftNode) {
+    status = FLTCheckInvalidOperand(psFilterNode->psLeftNode);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTCheckInvalidOperand(psFilterNode->psRightNode);
+    }
+  }
+  return status;
+}
+
+/************************************************************************/
+/*                       FLTProcessPropertyIsNull                       */
+/*                                                                      */
+/*      HACK for PropertyIsNull processing. PostGIS & Spatialite only   */
+/*      for now.                                                        */
+/************************************************************************/
+int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i) {
+  int status = MS_SUCCESS;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME &&
+      strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
+      !FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue)) {
+    layerObj *lp;
+    int layerWasOpened;
+
+    lp = GET_LAYER(map, i);
+    layerWasOpened = msLayerIsOpen(lp);
+
+    /* Horrible HACK to compensate for the lack of null testing in MapServer */
+    if (lp->connectiontype == MS_POSTGIS ||
+        (lp->connectiontype == MS_OGR && msOGRSupportsIsNull(lp))) {
+      msFree(psFilterNode->pszValue);
+      psFilterNode->pszValue = msStrdup("PropertyIsEqualTo");
+      psFilterNode->psRightNode = FLTCreateBinaryCompFilterEncodingNode();
+      psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
+      psFilterNode->psRightNode->pszValue = msStrdup("_MAPSERVER_NULL_");
+    }
+
+    if (!layerWasOpened) /* do not close the layer if it has been opened
+                            somewhere else (paging?) */
+      msLayerClose(lp);
+  }
+
+  if (psFilterNode->psLeftNode) {
+    status = FLTProcessPropertyIsNull(psFilterNode->psLeftNode, map, i);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTProcessPropertyIsNull(psFilterNode->psRightNode, map, i);
+    }
+  }
+  return status;
+}
+
+/************************************************************************/
+/*                        FLTCheckInvalidProperty                       */
+/*                                                                      */
+/*      Check that property names are known                             */
+/************************************************************************/
+int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode, mapObj *map,
+                            int i) {
+  int status = MS_SUCCESS;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+    layerObj *lp;
+    int layerWasOpened;
+    int bFound = MS_FALSE;
+
+    if ((strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
+         strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0) &&
+        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue)) {
+      return MS_SUCCESS;
+    }
+
+    lp = GET_LAYER(map, i);
+    layerWasOpened = msLayerIsOpen(lp);
+    if ((layerWasOpened || msLayerOpen(lp) == MS_SUCCESS) &&
+        msLayerGetItems(lp) == MS_SUCCESS) {
+      int i;
+      gmlItemListObj *items = msGMLGetItems(lp, "G");
+      for (i = 0; i < items->numitems; i++) {
+        if (!items->items[i].name || strlen(items->items[i].name) == 0 ||
+            !items->items[i].visible)
+          continue;
+        if (strcasecmp(items->items[i].name,
+                       psFilterNode->psLeftNode->pszValue) == 0) {
+          bFound = MS_TRUE;
+          break;
+        }
+      }
+      msGMLFreeItems(items);
+    }
+
+    if (!layerWasOpened) /* do not close the layer if it has been opened
+                            somewhere else (paging?) */
+      msLayerClose(lp);
+
+    if (!bFound) {
+      msSetError(MS_MISCERR, "Property '%s' is unknown.",
+                 "FLTCheckInvalidProperty()",
+                 psFilterNode->psLeftNode->pszValue);
+      return MS_FAILURE;
+    }
+  }
+
+  if (psFilterNode->psLeftNode) {
+    status = FLTCheckInvalidProperty(psFilterNode->psLeftNode, map, i);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTCheckInvalidProperty(psFilterNode->psRightNode, map, i);
+    }
+  }
+  return status;
+}
+
+/************************************************************************/
+/*                           FLTSimplify                                */
+/*                                                                      */
+/*      Simplify the expression by removing parts that evaluate to      */
+/*      constants.                                                      */
+/*      The passed psFilterNode is potentially consumed by the function */
+/*      and replaced by the returned value.                             */
+/*      If the function returns NULL, *pnEvaluation = MS_FALSE means    */
+/*      that  the filter evaluates to FALSE, or MS_TRUE that it         */
+/*      evaluates to TRUE                                               */
+/************************************************************************/
+FilterEncodingNode *FLTSimplify(FilterEncodingNode *psFilterNode,
+                                int *pnEvaluation) {
+  *pnEvaluation = -1;
+
+  /* There are no nullable or nillable property in WFS currently */
+  /* except gml:name or gml:description that are null */
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      (strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
+       strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0) &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+    if (strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
+        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) &&
+        strcmp(psFilterNode->psLeftNode->pszValue, "@gml:id") != 0 &&
+        strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") != 0)
+      *pnEvaluation = MS_TRUE;
+    else
+      *pnEvaluation = MS_FALSE;
+    FLTFreeFilterEncodingNode(psFilterNode);
+    return NULL;
+  }
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL &&
+      strcasecmp(psFilterNode->pszValue, "NOT") == 0 &&
+      psFilterNode->psLeftNode != NULL) {
+    int nEvaluation;
+    psFilterNode->psLeftNode =
+        FLTSimplify(psFilterNode->psLeftNode, &nEvaluation);
+    if (psFilterNode->psLeftNode == NULL) {
+      *pnEvaluation = 1 - nEvaluation;
+      FLTFreeFilterEncodingNode(psFilterNode);
+      return NULL;
+    }
+  }
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL &&
+      (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
+       strcasecmp(psFilterNode->pszValue, "OR") == 0) &&
+      psFilterNode->psLeftNode != NULL && psFilterNode->psRightNode != NULL) {
+    FilterEncodingNode *psOtherNode;
+    int nEvaluation;
+    int nExpectedValForFastExit;
+    psFilterNode->psLeftNode =
+        FLTSimplify(psFilterNode->psLeftNode, &nEvaluation);
+
+    if (strcasecmp(psFilterNode->pszValue, "AND") == 0)
+      nExpectedValForFastExit = MS_FALSE;
+    else
+      nExpectedValForFastExit = MS_TRUE;
+
+    if (psFilterNode->psLeftNode == NULL) {
+      if (nEvaluation == nExpectedValForFastExit) {
+        *pnEvaluation = nEvaluation;
+        FLTFreeFilterEncodingNode(psFilterNode);
+        return NULL;
+      }
+      psOtherNode = psFilterNode->psRightNode;
+      psFilterNode->psRightNode = NULL;
+      FLTFreeFilterEncodingNode(psFilterNode);
+      return FLTSimplify(psOtherNode, pnEvaluation);
+    }
+
+    psFilterNode->psRightNode =
+        FLTSimplify(psFilterNode->psRightNode, &nEvaluation);
+    if (psFilterNode->psRightNode == NULL) {
+      if (nEvaluation == nExpectedValForFastExit) {
+        *pnEvaluation = nEvaluation;
+        FLTFreeFilterEncodingNode(psFilterNode);
+        return NULL;
+      }
+      psOtherNode = psFilterNode->psLeftNode;
+      psFilterNode->psLeftNode = NULL;
+      FLTFreeFilterEncodingNode(psFilterNode);
+      return FLTSimplify(psOtherNode, pnEvaluation);
+    }
+  }
+
+  return psFilterNode;
+}
+
+#ifdef USE_LIBXML2
+
+xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent, xmlNsPtr psNsOgc,
+                              int bTemporal) {
+  xmlNodePtr psRootNode = NULL, psNode = NULL, psSubNode = NULL,
+             psSubSubNode = NULL;
+
+  psRootNode = xmlNewNode(psNsParent, BAD_CAST "Filter_Capabilities");
+
+  psNode =
+      xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Spatial_Capabilities", NULL);
+
+  psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "GeometryOperands", NULL);
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:Point");
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:LineString");
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:Polygon");
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:Envelope");
+
+  psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "SpatialOperators", NULL);
+#ifdef USE_GEOS
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Equals");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Disjoint");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Touches");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Within");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Overlaps");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Crosses");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Intersects");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Contains");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "DWithin");
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Beyond");
+#endif
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "BBOX");
+
+  if (bTemporal) {
+    psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Temporal_Capabilities",
+                         NULL);
+    psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "TemporalOperands", NULL);
+    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand",
+                BAD_CAST "gml:TimePeriod");
+    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand",
+                BAD_CAST "gml:TimeInstant");
+
+    psSubNode =
+        xmlNewChild(psNode, psNsOgc, BAD_CAST "TemporalOperators", NULL);
+    psSubSubNode =
+        xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperator", NULL);
+    xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "TM_Equals");
+  }
+  psNode =
+      xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Scalar_Capabilities", NULL);
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "LogicalOperators", NULL);
+  psNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperators", NULL);
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "LessThan");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "GreaterThan");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "LessThanEqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "GreaterThanEqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "EqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "NotEqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "Like");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "Between");
+
+  psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Id_Capabilities", NULL);
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "EID", NULL);
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "FID", NULL);
+  return psRootNode;
+}
+#endif
diff -pruN 8.0.1-5/src/mapogcfilter.h 8.2.0~beta1-1~exp1/src/mapogcfilter.h
--- 8.0.1-5/src/mapogcfilter.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcfilter.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,181 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC Filter Encoding implementation
+ * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#ifndef MAPOGCFILTER_H
+#define MAPOGCFILTER_H
+
+#include "mapserver.h"
+
+/* There is a dependency to OGR for the MiniXML parser */
+#include "cpl_minixml.h"
+
+#ifdef USE_LIBXML2
+
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct {
+  char *pszWildCard;
+  char *pszSingleChar;
+  char *pszEscapeChar;
+  int bCaseInsensitive;
+} FEPropertyIsLike;
+
+/* -------------------------------------------------------------------- */
+/*      prototypes.                                                     */
+/* -------------------------------------------------------------------- */
+MS_DLL_EXPORT int FLTIsNumeric(const char *pszValue);
+MS_DLL_EXPORT int FLTApplyExpressionToLayer(layerObj *lp,
+                                            const char *pszExpression);
+MS_DLL_EXPORT char *FLTGetExpressionForValuesRanges(layerObj *lp,
+                                                    const char *item,
+                                                    const char *value,
+                                                    int forcecharcter);
+
+MS_DLL_EXPORT FilterEncodingNode *
+FLTParseFilterEncoding(const char *szXMLString);
+MS_DLL_EXPORT FilterEncodingNode *FLTCreateFilterEncodingNode(void);
+MS_DLL_EXPORT char **FLTSplitFilters(const char *pszStr, int *pnTokens);
+MS_DLL_EXPORT int FLTApplyFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                        int iLayerIndex);
+
+MS_DLL_EXPORT int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode,
+                                                    mapObj *map,
+                                                    int iLayerIndex);
+MS_DLL_EXPORT int FLTLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode,
+                                                  mapObj *map, int iLayerIndex);
+
+MS_DLL_EXPORT void FLTFreeFilterEncodingNode(FilterEncodingNode *psFilterNode);
+
+MS_DLL_EXPORT int FLTValidFilterNode(FilterEncodingNode *psFilterNode);
+MS_DLL_EXPORT int FLTValidForBBoxFilter(FilterEncodingNode *psFilterNode);
+MS_DLL_EXPORT int FLTNumberOfFilterType(FilterEncodingNode *psFilterNode,
+                                        const char *szType);
+MS_DLL_EXPORT int FLTIsBBoxFilter(FilterEncodingNode *psFilterNode);
+MS_DLL_EXPORT int FLTIsPointFilter(FilterEncodingNode *psFilterNode);
+MS_DLL_EXPORT int FLTIsLineFilter(FilterEncodingNode *psFilterNode);
+MS_DLL_EXPORT int FLTIsPolygonFilter(FilterEncodingNode *psFilterNode);
+
+MS_DLL_EXPORT int
+FLTValidForPropertyIsLikeFilter(FilterEncodingNode *psFilterNode);
+MS_DLL_EXPORT int FLTIsOnlyPropertyIsLike(FilterEncodingNode *psFilterNode);
+
+MS_DLL_EXPORT void FLTInsertElementInNode(FilterEncodingNode *psFilterNode,
+                                          CPLXMLNode *psXMLNode);
+MS_DLL_EXPORT int FLTIsLogicalFilterType(const char *pszValue);
+MS_DLL_EXPORT int FLTIsBinaryComparisonFilterType(const char *pszValue);
+MS_DLL_EXPORT int FLTIsComparisonFilterType(const char *pszValue);
+MS_DLL_EXPORT int FLTIsFeatureIdFilterType(const char *pszValue);
+MS_DLL_EXPORT int FLTIsSpatialFilterType(const char *pszValue);
+MS_DLL_EXPORT int FLTIsTemporalFilterType(const char *pszValue);
+MS_DLL_EXPORT int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode);
+
+MS_DLL_EXPORT const char *FLTGetBBOX(FilterEncodingNode *psFilterNode,
+                                     rectObj *psRect);
+const char *FLTGetDuring(FilterEncodingNode *psFilterNode,
+                         const char **ppszTimeField);
+
+MS_DLL_EXPORT shapeObj *FLTGetShape(FilterEncodingNode *psFilterNode,
+                                    double *pdfDistance, int *pnUnit);
+
+MS_DLL_EXPORT int FLTHasSpatialFilter(FilterEncodingNode *psFilterNode);
+
+/*SQL expressions related functions.*/
+MS_DLL_EXPORT int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode,
+                                          mapObj *map, int iLayerIndex);
+
+MS_DLL_EXPORT char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode,
+                                        layerObj *lp);
+MS_DLL_EXPORT char *
+FLTGetBinaryComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                     layerObj *lp);
+MS_DLL_EXPORT char *
+FLTGetIsBetweenComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                        layerObj *lp);
+MS_DLL_EXPORT char *
+FLTGetIsLikeComparisonSQLExpression(FilterEncodingNode *psFilterNode,
+                                    layerObj *lp);
+
+MS_DLL_EXPORT char *
+FLTGetLogicalComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                      layerObj *lp);
+MS_DLL_EXPORT int FLTIsSimpleFilter(FilterEncodingNode *psFilterNode);
+
+MS_DLL_EXPORT FilterEncodingNode *
+FLTCreateFeatureIdFilterEncoding(const char *pszString);
+
+MS_DLL_EXPORT int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox,
+                                      char **ppszSRS);
+MS_DLL_EXPORT int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox,
+                                 char **ppszSRS);
+
+/*common-expressions*/
+MS_DLL_EXPORT char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode,
+                                           layerObj *lp);
+MS_DLL_EXPORT int
+FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex,
+                                      const char *pszExpression);
+
+#ifdef USE_LIBXML2
+MS_DLL_EXPORT xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent,
+                                            xmlNsPtr psNsOgc, int bTemporal);
+#endif
+
+void FLTDoAxisSwappingIfNecessary(mapObj *map, FilterEncodingNode *psFilterNode,
+                                  int bDefaultSRSNeedsAxisSwapping);
+
+void FLTPreParseFilterForAliasAndGroup(FilterEncodingNode *psFilterNode,
+                                       mapObj *map, int i,
+                                       const char *namespaces);
+int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i);
+int FLTCheckInvalidOperand(FilterEncodingNode *psFilterNode);
+int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode, mapObj *map,
+                            int i);
+FilterEncodingNode *FLTSimplify(FilterEncodingNode *psFilterNode,
+                                int *pnEvaluation);
+int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex,
+                                                  const char *pszExpression,
+                                                  rectObj rect);
+int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i);
+int FLTLayerSetInvalidRectIfSupported(layerObj *lp, rectObj *rect);
+
+#ifdef __cplusplus
+}
+std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode,
+                                 layerObj *lp);
+
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/mapogcfiltercommon.cpp 8.2.0~beta1-1~exp1/src/mapogcfiltercommon.cpp
--- 8.0.1-5/src/mapogcfiltercommon.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcfiltercommon.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,692 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC Filter Encoding implementation
+ * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapogcfilter.h"
+#include "mapserver.h"
+#include "mapows.h"
+#include "mapowscommon.h"
+#include "cpl_minixml.h"
+
+#include <string>
+
+static std::string
+FLTGetIsLikeComparisonCommonExpression(FilterEncodingNode *psFilterNode) {
+  /* From
+   * http://pubs.opengroup.org/onlinepubs/009695399/basedefs/xbd_chap09.html#tag_09_04
+   */
+  /* also add double quote because we are within a string */
+  const char *pszRegexSpecialCharsAndDoubleQuote = "\\^${[().*+?|\"";
+
+  if (!psFilterNode || !psFilterNode->pOther || !psFilterNode->psLeftNode ||
+      !psFilterNode->psRightNode || !psFilterNode->psRightNode->pszValue)
+    return std::string();
+
+  const FEPropertyIsLike *propIsLike =
+      (const FEPropertyIsLike *)psFilterNode->pOther;
+  const char *pszWild = propIsLike->pszWildCard;
+  const char *pszSingle = propIsLike->pszSingleChar;
+  const char *pszEscape = propIsLike->pszEscapeChar;
+  const bool bCaseInsensitive = propIsLike->bCaseInsensitive != 0;
+
+  if (!pszWild || strlen(pszWild) == 0 || !pszSingle ||
+      strlen(pszSingle) == 0 || !pszEscape || strlen(pszEscape) == 0)
+    return std::string();
+
+  /* -------------------------------------------------------------------- */
+  /*      Use operand with regular expressions.                           */
+  /* -------------------------------------------------------------------- */
+  std::string expr("(\"[");
+
+  /* attribute */
+  expr += psFilterNode->psLeftNode->pszValue;
+
+  /* #3521 */
+  if (bCaseInsensitive)
+    expr += "]\" ~* \"";
+  else
+    expr += "]\" ~ \"";
+
+  const char *pszValue = psFilterNode->psRightNode->pszValue;
+  const size_t nLength = strlen(pszValue);
+
+  if (nLength > 0) {
+    expr += '^';
+  }
+  for (size_t i = 0; i < nLength; i++) {
+    if (pszValue[i] == pszSingle[0]) {
+      expr += '.';
+      /* The Filter escape character is supposed to only escape the single,
+       * wildcard and escape character */
+    } else if (pszValue[i] == pszEscape[0] &&
+               (pszValue[i + 1] == pszSingle[0] ||
+                pszValue[i + 1] == pszWild[0] ||
+                pszValue[i + 1] == pszEscape[0])) {
+      if (pszValue[i + 1] == '\\') {
+        /* Tricky case: \ must be escaped ncce in the regular expression context
+           so that the regexp matches it as an ordinary character.
+           But as \ is also the escape character for MapServer string, we
+           must escape it again. */
+        expr += "\\"
+                "\\"
+                "\\"
+                "\\";
+      } else {
+        /* If the escaped character is itself a regular expression special
+         * character */
+        /* we need to regular-expression-escape-it ! */
+        if (strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i + 1])) {
+          expr += '\\';
+        }
+        expr += pszValue[i + 1];
+      }
+      i++;
+    } else if (pszValue[i] == pszWild[0]) {
+      expr += ".*";
+    }
+    /* Escape regular expressions special characters and double quote */
+    else if (strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i])) {
+      if (pszValue[i] == '\\') {
+        /* See above explantation */
+        expr += "\\"
+                "\\"
+                "\\"
+                "\\";
+      } else {
+        expr += '\\';
+        expr += pszValue[i];
+      }
+    } else {
+      expr += pszValue[i];
+    }
+  }
+  if (nLength > 0) {
+    expr += '$';
+  }
+  expr += "\")";
+  return expr;
+}
+
+static std::string
+FLTGetIsBetweenComparisonCommonExpresssion(FilterEncodingNode *psFilterNode,
+                                           layerObj *lp) {
+  if (psFilterNode->psLeftNode == NULL || psFilterNode->psRightNode == NULL)
+    return std::string();
+
+  /* -------------------------------------------------------------------- */
+  /*      Get the bounds value which are stored like boundmin;boundmax    */
+  /* -------------------------------------------------------------------- */
+  const auto bounds = msStringSplit(psFilterNode->psRightNode->pszValue, ';');
+  if (bounds.size() != 2) {
+    return std::string();
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      check if the value is a numeric value or alphanumeric. If it    */
+  /*      is alphanumeric, add quotes around attribute and values.        */
+  /* -------------------------------------------------------------------- */
+  bool bString = false;
+  bool bDateTime = false;
+
+  const char *pszType = msOWSLookupMetadata(
+      &(lp->metadata), "OFG",
+      (std::string(psFilterNode->psLeftNode->pszValue) + "_type").c_str());
+  if (pszType != NULL && (strcasecmp(pszType, "Character") == 0))
+    bString = true;
+  else if (pszType != NULL && (strcasecmp(pszType, "Date") == 0))
+    bDateTime = true;
+  else if (FLTIsNumeric(bounds[0].c_str()) == MS_FALSE)
+    bString = true;
+
+  if (!bString && !bDateTime) {
+    if (FLTIsNumeric(bounds[1].c_str()) == MS_FALSE)
+      bString = true;
+  }
+
+  std::string expr;
+  /* -------------------------------------------------------------------- */
+  /*      build expresssion.                                              */
+  /* -------------------------------------------------------------------- */
+  /* attribute */
+  if (bString)
+    expr += "(\"[";
+  else
+    expr += "([";
+
+  expr += psFilterNode->psLeftNode->pszValue;
+
+  if (bString)
+    expr += "]\" ";
+  else
+    expr += "] ";
+
+  expr += " >= ";
+
+  if (bString) {
+    expr += '\"';
+  } else if (bDateTime) {
+    expr += '`';
+  }
+
+  expr += msStdStringEscape(bounds[0].c_str());
+
+  if (bString) {
+    expr += '\"';
+  } else if (bDateTime) {
+    expr += '`';
+  }
+
+  expr += " AND ";
+
+  if (bString)
+    expr += " \"[";
+  else
+    expr += " [";
+
+  /* attribute */
+  expr += psFilterNode->psLeftNode->pszValue;
+
+  if (bString)
+    expr += "]\" ";
+  else
+    expr += "] ";
+
+  expr += " <= ";
+
+  if (bString) {
+    expr += '\"';
+  } else if (bDateTime) {
+    expr += '`';
+  }
+
+  expr += msStdStringEscape(bounds[1].c_str());
+
+  if (bString) {
+    expr += '\"';
+  } else if (bDateTime) {
+    expr += '`';
+  }
+  expr += ')';
+
+  return expr;
+}
+
+static std::string
+FLTGetBinaryComparisonCommonExpression(FilterEncodingNode *psFilterNode,
+                                       layerObj *lp) {
+  /* -------------------------------------------------------------------- */
+  /*      check if the value is a numeric value or alphanumeric. If it    */
+  /*      is alphanumeric, add quotes around attribute and values.        */
+  /* -------------------------------------------------------------------- */
+  bool bString = false;
+  bool bDateTime = false;
+  if (psFilterNode->psRightNode->pszValue) {
+    const char *pszType = msOWSLookupMetadata(
+        &(lp->metadata), "OFG",
+        (std::string(psFilterNode->psLeftNode->pszValue) + "_type").c_str());
+    if (pszType != NULL && (strcasecmp(pszType, "Character") == 0))
+      bString = true;
+    else if (pszType != NULL && (strcasecmp(pszType, "Date") == 0))
+      bDateTime = true;
+    else if (FLTIsNumeric(psFilterNode->psRightNode->pszValue) == MS_FALSE)
+      bString = true;
+  }
+
+  /* specical case to be able to have empty strings in the expression. */
+  /* propertyislike is always treated as string */
+  if (psFilterNode->psRightNode->pszValue == NULL ||
+      strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
+    bString = true;
+
+  /* attribute */
+  std::string expr;
+  if (bString)
+    expr = "(\"[";
+  else
+    expr = "([";
+  expr += psFilterNode->psLeftNode->pszValue;
+
+  if (bString)
+    expr += "]\" ";
+  else
+    expr += "] ";
+
+  if (strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0) {
+    /* case insensitive set ? */
+    if (psFilterNode->psRightNode->pOther &&
+        (*(int *)psFilterNode->psRightNode->pOther) == 1)
+      expr += "=*";
+    else
+      expr += "=";
+  } else if (strcasecmp(psFilterNode->pszValue, "PropertyIsNotEqualTo") == 0)
+    expr += "!=";
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThan") == 0)
+    expr += "<";
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsGreaterThan") == 0)
+    expr += ">";
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThanOrEqualTo") ==
+           0)
+    expr += "<=";
+  else if (strcasecmp(psFilterNode->pszValue,
+                      "PropertyIsGreaterThanOrEqualTo") == 0)
+    expr += ">=";
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
+    expr += "~";
+  expr += ' ';
+
+  /* value */
+  if (bString) {
+    expr += "\"";
+  } else if (bDateTime) {
+    expr += "`";
+  }
+
+  if (psFilterNode->psRightNode->pszValue) {
+    expr += msStdStringEscape(psFilterNode->psRightNode->pszValue);
+  }
+
+  if (bString) {
+    expr += "\"";
+  } else if (bDateTime) {
+    expr += "`";
+  }
+
+  expr += ")";
+
+  return expr;
+}
+
+static std::string
+FLTGetLogicalComparisonCommonExpression(FilterEncodingNode *psFilterNode,
+                                        layerObj *lp) {
+  std::string expr;
+  /* -------------------------------------------------------------------- */
+  /*      OR and AND                                                      */
+  /* -------------------------------------------------------------------- */
+  if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
+    char *pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
+    if (!pszTmp)
+      return std::string();
+
+    expr = '(';
+    expr += pszTmp;
+    msFree(pszTmp);
+    expr += ' ';
+    expr += psFilterNode->pszValue;
+    expr += ' ';
+
+    pszTmp = FLTGetCommonExpression(psFilterNode->psRightNode, lp);
+    if (!pszTmp) {
+      return std::string();
+    }
+
+    expr += pszTmp;
+    msFree(pszTmp);
+    expr += ')';
+  }
+  /* -------------------------------------------------------------------- */
+  /*      NOT                                                             */
+  /* -------------------------------------------------------------------- */
+  else if (psFilterNode->psLeftNode &&
+           strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
+    char *pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
+    if (!pszTmp)
+      return std::string();
+
+    expr = "(NOT ";
+    expr += pszTmp;
+    msFree(pszTmp);
+    expr += ')';
+  }
+
+  return expr;
+}
+
+static std::string
+FLTGetSpatialComparisonCommonExpression(FilterEncodingNode *psNode,
+                                        layerObj *lp) {
+  std::string expr;
+  double dfDistance = -1;
+  shapeObj *psTmpShape = NULL;
+  bool bBBoxQuery = false;
+  bool bAlreadyReprojected = false;
+
+  if (lp == NULL)
+    return std::string();
+
+  /* get the shape */
+  if (FLTIsBBoxFilter(psNode)) {
+    rectObj sQueryRect;
+    FLTGetBBOX(psNode, &sQueryRect);
+
+    char szPolygon[512];
+    snprintf(szPolygon, sizeof(szPolygon),
+             "POLYGON((%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f "
+             "%.18f))",
+             sQueryRect.minx, sQueryRect.miny, sQueryRect.minx, sQueryRect.maxy,
+             sQueryRect.maxx, sQueryRect.maxy, sQueryRect.maxx, sQueryRect.miny,
+             sQueryRect.minx, sQueryRect.miny);
+
+    psTmpShape = msShapeFromWKT(szPolygon);
+
+    /*
+    ** This is a horrible hack to deal with world-extent requests and
+    ** reprojection. msProjectRect() detects if reprojection from longlat to
+    ** projected SRS, and in that case it transforms the bbox to
+    *-1e-15,-1e-15,1e15,1e15
+    ** to ensure that all features are returned.
+    **
+    ** Make wfs_200_cite_filter_bbox_world.xml and
+    *wfs_200_cite_postgis_bbox_world.xml pass
+    */
+    if (fabs(sQueryRect.minx - -180.0) < 1e-5 &&
+        fabs(sQueryRect.miny - -90.0) < 1e-5 &&
+        fabs(sQueryRect.maxx - 180.0) < 1e-5 &&
+        fabs(sQueryRect.maxy - 90.0) < 1e-5) {
+      if (lp->projection.numargs > 0) {
+        projectionObj sProjTmp;
+        if (psNode->pszSRS) {
+          msInitProjection(&sProjTmp);
+          msProjectionInheritContextFrom(&sProjTmp, &lp->projection);
+        }
+        if (psNode->pszSRS) {
+          /* Use the non EPSG variant since axis swapping is done in
+           * FLTDoAxisSwappingIfNecessary */
+          if (msLoadProjectionString(&sProjTmp, psNode->pszSRS) == 0) {
+            msProjectRect(&sProjTmp, &lp->projection, &sQueryRect);
+          }
+        } else if (lp->map->projection.numargs > 0)
+          msProjectRect(&lp->map->projection, &lp->projection, &sQueryRect);
+        if (psNode->pszSRS)
+          msFreeProjection(&sProjTmp);
+      }
+      if (sQueryRect.minx <= -1e14) {
+        msFreeShape(psTmpShape);
+        msFree(psTmpShape);
+        psTmpShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+        msInitShape(psTmpShape);
+        msRectToPolygon(sQueryRect, psTmpShape);
+        bAlreadyReprojected = true;
+      }
+    }
+
+    bBBoxQuery = true;
+  } else {
+    /* other geos type operations */
+
+    /* project shape to layer projection. If the proj is not part of the filter
+      query, assume that the cooredinates are in the map projection */
+
+    int nUnit = -1;
+    shapeObj *psQueryShape = FLTGetShape(psNode, &dfDistance, &nUnit);
+
+    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 ||
+         strcasecmp(psNode->pszValue, "Beyond") == 0) &&
+        dfDistance > 0) {
+      int nLayerUnit = lp->units;
+      if (nLayerUnit == -1)
+        nLayerUnit = GetMapserverUnitUsingProj(&lp->projection);
+      if (nLayerUnit == -1)
+        nLayerUnit = lp->map->units;
+      if (nLayerUnit == -1)
+        nLayerUnit = GetMapserverUnitUsingProj(&lp->map->projection);
+
+      if (nUnit >= 0 && nUnit != nLayerUnit)
+        dfDistance *=
+            msInchesPerUnit(nUnit, 0) /
+            msInchesPerUnit(nLayerUnit, 0); /* target is layer units */
+    }
+
+    psTmpShape = psQueryShape;
+  }
+
+  if (psTmpShape) {
+
+    /*
+    ** target is layer projection
+    */
+    if (!bAlreadyReprojected && lp->projection.numargs > 0) {
+      projectionObj sProjTmp;
+      if (psNode->pszSRS) {
+        msInitProjection(&sProjTmp);
+        msProjectionInheritContextFrom(&sProjTmp, &lp->projection);
+      }
+      if (psNode->pszSRS) {
+        /* Use the non EPSG variant since axis swapping is done in
+         * FLTDoAxisSwappingIfNecessary */
+        if (msLoadProjectionString(&sProjTmp, psNode->pszSRS) == 0) {
+          msProjectShape(&sProjTmp, &lp->projection, psTmpShape);
+        }
+      } else if (lp->map->projection.numargs > 0)
+        msProjectShape(&lp->map->projection, &lp->projection, psTmpShape);
+      if (psNode->pszSRS)
+        msFreeProjection(&sProjTmp);
+    }
+
+    /* function name */
+    if (bBBoxQuery) {
+      expr = "intersects";
+    } else {
+      if (strncasecmp(psNode->pszValue, "intersect", 9) == 0)
+        expr = "intersects";
+      else {
+        expr = msStringToLower(std::string(psNode->pszValue));
+      }
+    }
+    /* geometry binding */
+    expr += "([shape],fromText('";
+
+    /* filter geometry */
+    char *pszWktText = msGEOSShapeToWKT(psTmpShape);
+    expr += pszWktText ? pszWktText : "Cannot translate shape to WKT";
+    expr += "')";
+    msGEOSFreeWKT(pszWktText);
+
+    /* (optional) beyond/dwithin distance, always 0.0 since we apply the
+     * distance as a buffer earlier */
+    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 ||
+         strcasecmp(psNode->pszValue, "Beyond") == 0)) {
+      char szBuffer[256];
+      sprintf(szBuffer, ",%g", dfDistance);
+      expr += szBuffer;
+    }
+
+    /* terminate the function */
+    expr += ") = TRUE";
+  }
+
+  /*
+  ** Cleanup
+  */
+  if (bBBoxQuery) {
+    msFreeShape(psTmpShape);
+    msFree(psTmpShape);
+  }
+
+  return expr;
+}
+
+static std::string
+FLTGetFeatureIdCommonExpression(FilterEncodingNode *psFilterNode,
+                                layerObj *lp) {
+  std::string expr;
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+  if (psFilterNode->pszValue) {
+    const char *pszAttribute =
+        msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
+    if (pszAttribute) {
+      const auto tokens = msStringSplit(psFilterNode->pszValue, ',');
+      if (!tokens.empty()) {
+        for (size_t i = 0; i < tokens.size(); i++) {
+          const char *pszId = tokens[i].c_str();
+          const char *pszDot = strrchr(pszId, '.');
+          if (pszDot)
+            pszId = pszDot + 1;
+
+          bool bString = false;
+          if (i == 0) {
+            if (FLTIsNumeric(pszId) == MS_FALSE)
+              bString = true;
+          }
+
+          if (!expr.empty())
+            expr += " OR ";
+          else
+            expr = '(';
+
+          if (bString) {
+            expr += "(\"[";
+            expr += pszAttribute;
+            expr += "]\" == \"";
+            expr += pszId;
+            expr += "\")";
+          } else {
+            expr += "([";
+            expr += pszAttribute;
+            expr += "] == ";
+            expr += pszId;
+            expr += ")";
+          }
+        }
+      }
+    }
+
+    /* opening and closing brackets are needed for mapserver expressions */
+    if (!expr.empty())
+      expr += ')';
+  }
+#endif
+
+  return expr;
+}
+
+std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode,
+                                 layerObj *lp) {
+  if (lp == NULL)
+    return std::string();
+
+  std::string expr;
+  const char *pszTimeField = nullptr;
+  const char *pszTimeValue = FLTGetDuring(psFilterNode, &pszTimeField);
+  if (pszTimeField && pszTimeValue) {
+    expressionObj old_filter;
+    msInitExpression(&old_filter);
+    msCopyExpression(&old_filter, &lp->filter); /* save existing filter */
+    msFreeExpression(&lp->filter);
+    if (msLayerSetTimeFilter(lp, pszTimeValue, pszTimeField) == MS_TRUE &&
+        lp->filter.string) {
+      expr = lp->filter.string;
+    }
+    msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
+    msFreeExpression(&old_filter);
+  }
+  return expr;
+}
+
+char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp) {
+  char *pszExpression = NULL;
+
+  if (!psFilterNode)
+    return NULL;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON) {
+    if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
+      if (FLTIsBinaryComparisonFilterType(psFilterNode->pszValue))
+        pszExpression = msStrdup(
+            FLTGetBinaryComparisonCommonExpression(psFilterNode, lp).c_str());
+      else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
+        pszExpression = msStrdup(
+            FLTGetIsLikeComparisonCommonExpression(psFilterNode).c_str());
+      else if (strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0)
+        pszExpression = msStrdup(
+            FLTGetIsBetweenComparisonCommonExpresssion(psFilterNode, lp)
+                .c_str());
+    }
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL) {
+    pszExpression = msStrdup(
+        FLTGetLogicalComparisonCommonExpression(psFilterNode, lp).c_str());
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL) {
+    pszExpression = msStrdup(
+        FLTGetSpatialComparisonCommonExpression(psFilterNode, lp).c_str());
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_FEATUREID) {
+    pszExpression =
+        msStrdup(FLTGetFeatureIdCommonExpression(psFilterNode, lp).c_str());
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_TEMPORAL) {
+    pszExpression = msStrdup(FLTGetTimeExpression(psFilterNode, lp).c_str());
+  }
+
+  return pszExpression;
+}
+
+int FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex,
+                                          const char *pszExpression) {
+  return FLTApplyFilterToLayerCommonExpressionWithRect(
+      map, iLayerIndex, pszExpression, map->extent);
+}
+
+/* rect must be in map->projection */
+int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex,
+                                                  const char *pszExpression,
+                                                  rectObj rect) {
+  int retval;
+
+  const int save_startindex = map->query.startindex;
+  const int save_maxfeatures = map->query.maxfeatures;
+  const int save_only_cache_result_count = map->query.only_cache_result_count;
+  const int save_cache_shapes = map->query.cache_shapes;
+  const int save_max_cached_shape_count = map->query.max_cached_shape_count;
+  const int save_max_cached_shape_ram_amount =
+      map->query.max_cached_shape_ram_amount;
+  msInitQuery(&(map->query));
+  map->query.startindex = save_startindex;
+  map->query.maxfeatures = save_maxfeatures;
+  map->query.only_cache_result_count = save_only_cache_result_count;
+  map->query.cache_shapes = save_cache_shapes;
+  map->query.max_cached_shape_count = save_max_cached_shape_count;
+  map->query.max_cached_shape_ram_amount = save_max_cached_shape_ram_amount;
+
+  map->query.mode = MS_QUERY_MULTIPLE;
+  map->query.layer = iLayerIndex;
+
+  map->query.rect = rect;
+
+  if (pszExpression) {
+    map->query.type = MS_QUERY_BY_FILTER;
+    msInitExpression(&map->query.filter);
+    map->query.filter.string = msStrdup(pszExpression);
+    map->query.filter.type = MS_EXPRESSION; /* a logical expression */
+
+    retval = msQueryByFilter(map);
+  } else {
+    map->query.type = MS_QUERY_BY_RECT;
+    retval = msQueryByRect(map);
+  }
+
+  return retval;
+}
diff -pruN 8.0.1-5/src/mapogcsld.cpp 8.2.0~beta1-1~exp1/src/mapogcsld.cpp
--- 8.0.1-5/src/mapogcsld.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcsld.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5502 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC SLD implementation
+ * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapogcsld.h"
+#include "mapogcfilter.h"
+#include "mapserver.h"
+#include "mapows.h"
+#include "mapcopy.h"
+#include "cpl_string.h"
+
+extern "C" {
+extern int yyparse(parseObj *);
+}
+
+static inline void IGUR_sizet(size_t ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
+
+#define SLD_LINE_SYMBOL_NAME "sld_line_symbol"
+#define SLD_LINE_SYMBOL_DASH_NAME "sld_line_symbol_dash"
+#define SLD_MARK_SYMBOL_SQUARE "sld_mark_symbol_square"
+#define SLD_MARK_SYMBOL_SQUARE_FILLED "sld_mark_symbol_square_filled"
+#define SLD_MARK_SYMBOL_CIRCLE "sld_mark_symbol_circle"
+#define SLD_MARK_SYMBOL_CIRCLE_FILLED "sld_mark_symbol_circle_filled"
+#define SLD_MARK_SYMBOL_TRIANGLE "sld_mark_symbol_triangle"
+#define SLD_MARK_SYMBOL_TRIANGLE_FILLED "sld_mark_symbol_triangle_filled"
+#define SLD_MARK_SYMBOL_STAR "sld_mark_symbol_star"
+#define SLD_MARK_SYMBOL_STAR_FILLED "sld_mark_symbol_star_filled"
+#define SLD_MARK_SYMBOL_CROSS "sld_mark_symbol_cross"
+#define SLD_MARK_SYMBOL_CROSS_FILLED "sld_mark_symbol_cross_filled"
+#define SLD_MARK_SYMBOL_X "sld_mark_symbol_x"
+#define SLD_MARK_SYMBOL_X_FILLED "sld_mark_symbol_x_filled"
+
+/************************************************************************/
+/*                             msSLDApplySLDURL                         */
+/*                                                                      */
+/*      Use the SLD document given through a URL and apply the SLD      */
+/*      on the map. Layer name and Named Layer's name parameter are     */
+/*      used to do the match.                                           */
+/************************************************************************/
+int msSLDApplySLDURL(mapObj *map, const char *szURL, int iLayer,
+                     const char *pszStyleLayerName, char **ppszLayerNames) {
+  /* needed for libcurl function msHTTPGetFile in maphttp.c */
+#if defined(USE_CURL)
+
+  char *pszSLDTmpFile = NULL;
+  int status = 0;
+  char *pszSLDbuf = NULL;
+  FILE *fp = NULL;
+  int nStatus = MS_FAILURE;
+
+  if (map && szURL) {
+    map->sldurl = (char *)szURL;
+    pszSLDTmpFile = msTmpFile(map, map->mappath, NULL, "sld.xml");
+    if (pszSLDTmpFile == NULL) {
+      pszSLDTmpFile = msTmpFile(map, NULL, NULL, "sld.xml");
+    }
+    if (pszSLDTmpFile == NULL) {
+      msSetError(
+          MS_WMSERR,
+          "Could not determine temporary file. Please make sure that the "
+          "temporary path is set. The temporary path can be defined for "
+          "example by setting TEMPPATH in the map file. Please check the "
+          "MapServer documentation on temporary path settings.",
+          "msSLDApplySLDURL()");
+    } else {
+      int nMaxRemoteSLDBytes;
+      const char *pszMaxRemoteSLDBytes = msOWSLookupMetadata(
+          &(map->web.metadata), "MO", "remote_sld_max_bytes");
+      if (!pszMaxRemoteSLDBytes) {
+        nMaxRemoteSLDBytes = 1024 * 1024; /* 1 megaByte */
+      } else {
+        nMaxRemoteSLDBytes = atoi(pszMaxRemoteSLDBytes);
+      }
+      if (msHTTPGetFile(szURL, pszSLDTmpFile, &status, -1, 0, 0,
+                        nMaxRemoteSLDBytes) == MS_SUCCESS) {
+        if ((fp = fopen(pszSLDTmpFile, "rb")) != NULL) {
+          int nBufsize = 0;
+          fseek(fp, 0, SEEK_END);
+          nBufsize = ftell(fp);
+          if (nBufsize > 0) {
+            rewind(fp);
+            pszSLDbuf = (char *)malloc((nBufsize + 1) * sizeof(char));
+            if (pszSLDbuf == NULL) {
+              msSetError(MS_MEMERR, "Failed to open SLD file.",
+                         "msSLDApplySLDURL()");
+            } else {
+              IGUR_sizet(fread(pszSLDbuf, 1, nBufsize, fp));
+              pszSLDbuf[nBufsize] = '\0';
+            }
+          } else {
+            msSetError(MS_WMSERR, "Could not open SLD %s as it appears empty",
+                       "msSLDApplySLDURL", szURL);
+          }
+          fclose(fp);
+          unlink(pszSLDTmpFile);
+        }
+      } else {
+        unlink(pszSLDTmpFile);
+        msSetError(
+            MS_WMSERR,
+            "Could not open SLD %s and save it in a temporary file. Please "
+            "make sure that the sld url is valid and that the temporary path "
+            "is set. The temporary path can be defined for example by setting "
+            "TEMPPATH in the map file. Please check the MapServer "
+            "documentation on temporary path settings.",
+            "msSLDApplySLDURL", szURL);
+      }
+      msFree(pszSLDTmpFile);
+      if (pszSLDbuf)
+        nStatus = msSLDApplySLD(map, pszSLDbuf, iLayer, pszStyleLayerName,
+                                ppszLayerNames);
+    }
+    map->sldurl = NULL;
+  }
+
+  msFree(pszSLDbuf);
+
+  return nStatus;
+
+#else
+  msSetError(MS_MISCERR, "WMS/WFS client support is not enabled .",
+             "msSLDApplySLDURL()");
+  return (MS_FAILURE);
+#endif
+}
+
+/************************************************************************/
+/*                             msSLDApplyFromFile                       */
+/*                                                                      */
+/*      Apply SLD from a file on disk to the layerObj                   */
+/************************************************************************/
+int msSLDApplyFromFile(mapObj *map, layerObj *layer, const char *filename) {
+
+  FILE *fp = NULL;
+
+  int nStatus = MS_FAILURE;
+
+  /* open SLD file */
+  char szPath[MS_MAXPATHLEN];
+  char *pszSLDbuf = NULL;
+  const char *realpath = msBuildPath(szPath, map->mappath, filename);
+
+  if ((fp = fopen(realpath, "rb")) != NULL) {
+    int nBufsize = 0;
+    fseek(fp, 0, SEEK_END);
+    nBufsize = ftell(fp);
+    if (nBufsize > 0) {
+      rewind(fp);
+      pszSLDbuf = (char *)malloc((nBufsize + 1) * sizeof(char));
+      if (pszSLDbuf == NULL) {
+        msSetError(MS_MEMERR, "Failed to read SLD file.",
+                   "msSLDApplyFromFile()");
+      } else {
+        IGUR_sizet(fread(pszSLDbuf, 1, nBufsize, fp));
+        pszSLDbuf[nBufsize] = '\0';
+      }
+    } else {
+      msSetError(MS_IOERR, "Could not open SLD %s as it appears empty",
+                 "msSLDApplyFromFile", realpath);
+    }
+    fclose(fp);
+  }
+  if (pszSLDbuf) {
+    // if not set, then use the first NamedStyle in the SLD file
+    // even if the names don't match
+    const char *pszMetadataName = "SLD_USE_FIRST_NAMEDLAYER";
+    const char *pszValue =
+        msLookupHashTable(&(layer->metadata), pszMetadataName);
+    if (pszValue == NULL) {
+      msInsertHashTable(&(layer->metadata), pszMetadataName, "true");
+    }
+    nStatus = msSLDApplySLD(map, pszSLDbuf, layer->index, NULL, NULL);
+  } else {
+    msSetError(MS_IOERR, "Invalid SLD filename: \"%s\".",
+               "msSLDApplyFromFile()", realpath);
+  }
+
+  msFree(pszSLDbuf);
+  return nStatus;
+}
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+/* -------------------------------------------------------------------- */
+/*      If the same layer is given more that once, we need to           */
+/*      duplicate it.                                                   */
+/* -------------------------------------------------------------------- */
+static void msSLDApplySLD_DuplicateLayers(mapObj *map, int nSLDLayers,
+                                          layerObj *pasSLDLayers) {
+  int m;
+  for (m = 0; m < nSLDLayers; m++) {
+    int l;
+    int nIndex = msGetLayerIndex(map, pasSLDLayers[m].name);
+    if (pasSLDLayers[m].name == NULL)
+      continue;
+    if (nIndex < 0)
+      continue;
+    for (l = m + 1; l < nSLDLayers; l++) {
+      if (pasSLDLayers[l].name == NULL)
+        continue;
+      if (strcasecmp(pasSLDLayers[m].name, pasSLDLayers[l].name) == 0) {
+        layerObj *psTmpLayer = (layerObj *)malloc(sizeof(layerObj));
+        char tmpId[128];
+
+        initLayer(psTmpLayer, map);
+        msCopyLayer(psTmpLayer, GET_LAYER(map, nIndex));
+        /* open the source layer */
+        if (!psTmpLayer->vtable) {
+          if (msInitializeVirtualTable(psTmpLayer) != MS_SUCCESS) {
+            MS_REFCNT_DECR(psTmpLayer);
+            continue;
+          }
+        }
+
+        /*make the name unique*/
+        snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d", (long)time(NULL),
+                 (int)getpid(), map->numlayers);
+        if (psTmpLayer->name)
+          msFree(psTmpLayer->name);
+        psTmpLayer->name = msStrdup(tmpId);
+        msFree(pasSLDLayers[l].name);
+        pasSLDLayers[l].name = msStrdup(tmpId);
+        msInsertLayer(map, psTmpLayer, -1);
+        MS_REFCNT_DECR(psTmpLayer);
+      }
+    }
+  }
+}
+#endif
+
+static int msApplySldLayerToMapLayer(layerObj *sldLayer, layerObj *lp) {
+
+  if (sldLayer->numclasses > 0) {
+    int iClass = 0;
+    bool bSLDHasNamedClass = false;
+
+    lp->type = sldLayer->type;
+    lp->rendermode = MS_ALL_MATCHING_CLASSES;
+
+    for (int k = 0; k < sldLayer->numclasses; k++) {
+      if (sldLayer->_class[k]->group) {
+        bSLDHasNamedClass = true;
+        break;
+      }
+    }
+
+    for (int k = 0; k < lp->numclasses; k++) {
+      if (lp->_class[k] != NULL) {
+        lp->_class[k]->layer = NULL;
+        if (freeClass(lp->_class[k]) == MS_SUCCESS) {
+          msFree(lp->_class[k]);
+          lp->_class[k] = NULL;
+        }
+      }
+    }
+    lp->numclasses = 0;
+
+    if (bSLDHasNamedClass && sldLayer->classgroup) {
+      /* Set the class group to the class that has UserStyle.IsDefaultf
+       */
+      msFree(lp->classgroup);
+      lp->classgroup = msStrdup(sldLayer->classgroup);
+    } else {
+      /*unset the classgroup on the layer if it was set. This allows the
+      layer to render with all the classes defined in the SLD*/
+      msFree(lp->classgroup);
+      lp->classgroup = NULL;
+    }
+
+    for (int k = 0; k < sldLayer->numclasses; k++) {
+      if (msGrowLayerClasses(lp) == NULL)
+        return MS_FAILURE;
+
+      initClass(lp->_class[iClass]);
+      msCopyClass(lp->_class[iClass], sldLayer->_class[k], NULL);
+      lp->_class[iClass]->layer = lp;
+      lp->numclasses++;
+
+      /*aliases may have been used as part of the sld text symbolizer
+        for label element. Try to process it if that is the case #3114*/
+
+      const int layerWasOpened = msLayerIsOpen(lp);
+
+      if (layerWasOpened || (msLayerOpen(lp) == MS_SUCCESS &&
+                             msLayerGetItems(lp) == MS_SUCCESS)) {
+
+        if (lp->_class[iClass]->text.string) {
+          for (int z = 0; z < lp->numitems; z++) {
+            if (!lp->items[z] || strlen(lp->items[z]) == 0)
+              continue;
+
+            char *pszTmp1 = msStrdup(lp->_class[iClass]->text.string);
+            const char *pszFullName = msOWSLookupMetadata(
+                &(lp->metadata), "G",
+                std::string(lp->items[z]).append("_alias").c_str());
+
+            if (pszFullName != NULL && (strstr(pszTmp1, pszFullName) != NULL)) {
+              pszTmp1 = msReplaceSubstring(pszTmp1, pszFullName, lp->items[z]);
+              std::string osTmp("(");
+              osTmp.append(pszTmp1).append(")");
+              // Silence false positive Coverity Scan warnings which wrongly
+              // believes that osTmp.c_str() might be used by
+              // msLoadExpressionString() after osTmp is destroyed.
+              // coverity[escape]
+              msLoadExpressionString(&(lp->_class[iClass]->text),
+                                     osTmp.c_str());
+            }
+            msFree(pszTmp1);
+          }
+        }
+        if (!layerWasOpened) { // don't close the layer if already
+                               // open
+          msLayerClose(lp);
+        }
+      }
+      iClass++;
+    }
+  } else {
+    /*this is probably an SLD that uses Named styles*/
+    if (sldLayer->classgroup) {
+      int k;
+      for (k = 0; k < lp->numclasses; k++) {
+        if (lp->_class[k]->group &&
+            strcasecmp(lp->_class[k]->group, sldLayer->classgroup) == 0)
+          break;
+      }
+      if (k < lp->numclasses) {
+        msFree(lp->classgroup);
+        lp->classgroup = msStrdup(sldLayer->classgroup);
+      } else {
+        /* TODO  we throw an exception ?*/
+      }
+    }
+  }
+  if (sldLayer->labelitem) {
+    if (lp->labelitem)
+      free(lp->labelitem);
+
+    lp->labelitem = msStrdup(sldLayer->labelitem);
+  }
+
+  if (sldLayer->classitem) {
+    if (lp->classitem)
+      free(lp->classitem);
+
+    lp->classitem = msStrdup(sldLayer->classitem);
+  }
+
+  /* opacity for sld raster */
+  if (lp->type == MS_LAYER_RASTER && sldLayer->compositer &&
+      sldLayer->compositer->opacity != 100)
+    msSetLayerOpacity(lp, sldLayer->compositer->opacity);
+
+  /* mark as auto-generate SLD */
+  if (lp->connectiontype == MS_WMS)
+    msInsertHashTable(&(lp->metadata), "wms_sld_body", "auto");
+
+  /* The SLD might have a FeatureTypeConstraint */
+  if (sldLayer->filter.type == MS_EXPRESSION) {
+    if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
+      char *pszBuffer = msStringConcatenate(NULL, "((");
+      pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
+      pszBuffer = msStringConcatenate(pszBuffer, ") AND (");
+      pszBuffer = msStringConcatenate(pszBuffer, sldLayer->filter.string);
+      pszBuffer = msStringConcatenate(pszBuffer, "))");
+      msFreeExpression(&lp->filter);
+      msInitExpression(&lp->filter);
+      lp->filter.string = pszBuffer;
+      lp->filter.type = MS_EXPRESSION;
+    } else {
+      msFreeExpression(&lp->filter);
+      msInitExpression(&lp->filter);
+      lp->filter.string = msStrdup(sldLayer->filter.string);
+      lp->filter.type = MS_EXPRESSION;
+    }
+  }
+
+  /*in some cases it would make sense to concatenate all the class
+    expressions and use it to set the filter on the layer. This
+    could increase performance. Will do it for db types layers
+    #2840*/
+  if (lp->filter.string == NULL ||
+      (lp->filter.string && lp->filter.type == MS_STRING && !lp->filteritem)) {
+    if (lp->connectiontype == MS_POSTGIS ||
+        lp->connectiontype == MS_ORACLESPATIAL ||
+        lp->connectiontype == MS_PLUGIN) {
+      if (lp->numclasses > 0) {
+        /* check first that all classes have an expression type.
+          That is the only way we can concatenate them and set the
+          filter expression */
+        int k;
+        for (k = 0; k < lp->numclasses; k++) {
+          if (lp->_class[k]->expression.type != MS_EXPRESSION)
+            break;
+        }
+        if (k == lp->numclasses) {
+          char szTmp[512];
+          char *pszBuffer = NULL;
+          for (k = 0; k < lp->numclasses; k++) {
+            if (pszBuffer == NULL)
+              snprintf(szTmp, sizeof(szTmp), "%s",
+                       "(("); /* we a building a string expression,
+                                 explicitly set type below */
+            else
+              snprintf(szTmp, sizeof(szTmp), "%s", " OR ");
+
+            pszBuffer = msStringConcatenate(pszBuffer, szTmp);
+            pszBuffer = msStringConcatenate(pszBuffer,
+                                            lp->_class[k]->expression.string);
+          }
+
+          snprintf(szTmp, sizeof(szTmp), "%s", "))");
+          pszBuffer = msStringConcatenate(pszBuffer, szTmp);
+
+          msFreeExpression(&lp->filter);
+          msInitExpression(&lp->filter);
+          lp->filter.string = msStrdup(pszBuffer);
+          lp->filter.type = MS_EXPRESSION;
+
+          msFree(pszBuffer);
+        }
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                              msSLDApplySLD                           */
+/*                                                                      */
+/*      Parses the SLD into array of layers. Go through the map and     */
+/*      compare the SLD layers and the map layers using the name. If    */
+/*      they have the same name, copy the classes associated with       */
+/*      the SLD layers onto the map layers.                             */
+/************************************************************************/
+int msSLDApplySLD(mapObj *map, const char *psSLDXML, int iLayer,
+                  const char *pszStyleLayerName, char **ppszLayerNames) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+  int nSLDLayers = 0;
+  layerObj *pasSLDLayers = NULL;
+  int nStatus = MS_SUCCESS;
+  /*const char *pszSLDNotSupported = NULL;*/
+
+  pasSLDLayers = msSLDParseSLD(map, psSLDXML, &nSLDLayers);
+  if (pasSLDLayers == NULL) {
+    errorObj *psError = msGetErrorObj();
+    if (psError && psError->code != MS_NOERR)
+      return MS_FAILURE;
+  }
+
+  if (pasSLDLayers && nSLDLayers > 0) {
+    int i;
+
+    msSLDApplySLD_DuplicateLayers(map, nSLDLayers, pasSLDLayers);
+
+    for (i = 0; i < map->numlayers; i++) {
+      layerObj *lp = NULL;
+      const char *pszWMSLayerName = NULL;
+      int j;
+      int bUseSpecificLayer = 0;
+
+      if (iLayer >= 0 && iLayer < map->numlayers) {
+        i = iLayer;
+        bUseSpecificLayer = 1;
+      }
+
+      lp = GET_LAYER(map, i);
+
+      /* compare layer name to wms_name as well */
+      pszWMSLayerName = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
+
+      bool bSldApplied = false;
+
+      for (j = 0; j < nSLDLayers; j++) {
+        layerObj *sldLayer = &pasSLDLayers[j];
+
+        /* --------------------------------------------------------------------
+         */
+        /*      copy :  - class */
+        /*              - layer's labelitem */
+        /* --------------------------------------------------------------------
+         */
+        if ((sldLayer->name && pszStyleLayerName == NULL &&
+             ((strcasecmp(lp->name, sldLayer->name) == 0 ||
+               (pszWMSLayerName &&
+                strcasecmp(pszWMSLayerName, sldLayer->name) == 0)) ||
+              (lp->group && strcasecmp(lp->group, sldLayer->name) == 0))) ||
+            (bUseSpecificLayer && pszStyleLayerName && sldLayer->name &&
+             strcasecmp(sldLayer->name, pszStyleLayerName) == 0)) {
+#ifdef notdef
+          /*this is a test code if we decide to flag some layers as not
+           * supporting SLD*/
+          pszSLDNotSupported =
+              msOWSLookupMetadata(&(lp->metadata), "M", "SLD_NOT_SUPPORTED");
+          if (pszSLDNotSupported) {
+            msSetError(MS_WMSERR, "Layer %s does not support SLD",
+                       "msSLDApplySLD", sldLayer->name);
+            nsStatus = MS_FAILURE;
+            goto sld_cleanup;
+          }
+#endif
+          if (msApplySldLayerToMapLayer(sldLayer, lp) == MS_FAILURE) {
+            nStatus = MS_FAILURE;
+            goto sld_cleanup;
+          };
+          bSldApplied = true;
+          break;
+        }
+      }
+      if (bUseSpecificLayer) {
+        if (!bSldApplied) {
+          // there was no name match between the map layer and the SLD named
+          // layer - check if we should apply the first SLD layer anyway
+          const char *pszSLDUseFirstNamedLayer =
+              msLookupHashTable(&(lp->metadata), "SLD_USE_FIRST_NAMEDLAYER");
+          if (pszSLDUseFirstNamedLayer) {
+            if (strcasecmp(pszSLDUseFirstNamedLayer, "true") == 0) {
+              layerObj *firstSldLayer = &pasSLDLayers[0];
+              if (msApplySldLayerToMapLayer(firstSldLayer, lp) == MS_FAILURE) {
+                nStatus = MS_FAILURE;
+                goto sld_cleanup;
+              };
+            }
+          }
+        }
+        break;
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      if needed return a comma separated list of the layers found     */
+    /*      in the sld.                                                     */
+    /* -------------------------------------------------------------------- */
+    if (ppszLayerNames) {
+      char *pszTmp = NULL;
+      for (i = 0; i < nSLDLayers; i++) {
+        if (pasSLDLayers[i].name) {
+          if (pszTmp != NULL)
+            pszTmp = msStringConcatenate(pszTmp, ",");
+          pszTmp = msStringConcatenate(pszTmp, pasSLDLayers[i].name);
+        }
+      }
+      *ppszLayerNames = pszTmp;
+    }
+  }
+
+  nStatus = MS_SUCCESS;
+
+sld_cleanup:
+
+  if (pasSLDLayers) {
+    for (int i = 0; i < nSLDLayers; i++)
+      freeLayer(&pasSLDLayers[i]);
+    msFree(pasSLDLayers);
+  }
+
+  if (map->debug == MS_DEBUGLEVEL_VVV) {
+    char *tmpfilename = msTmpFile(map, map->mappath, NULL, "_sld.map");
+    if (tmpfilename == NULL) {
+      tmpfilename = msTmpFile(map, NULL, NULL, "_sld.map");
+    }
+    if (tmpfilename) {
+      msSaveMap(map, tmpfilename);
+      msDebug("msApplySLD(): Map file after SLD was applied %s\n", tmpfilename);
+      msFree(tmpfilename);
+    }
+  }
+  return nStatus;
+
+#else
+  msSetError(MS_MISCERR, "OWS support is not available.", "msSLDApplySLD()");
+  return (MS_FAILURE);
+#endif
+}
+
+static CPLXMLNode *FindNextChild(CPLXMLNode *psNode, const char *pszChildName) {
+  while (psNode) {
+    if (psNode->eType == CXT_Element &&
+        strcasecmp(psNode->pszValue, pszChildName) == 0) {
+      return psNode;
+    }
+    psNode = psNode->psNext;
+  }
+  return NULL;
+}
+
+#define LOOP_ON_CHILD_ELEMENT(psParent_, psChild_, pszChildName_)              \
+  for (psChild_ = FindNextChild(psParent_->psChild, pszChildName_);            \
+       psChild_ != NULL;                                                       \
+       psChild_ = FindNextChild(psChild_->psNext, pszChildName_))
+
+/************************************************************************/
+/*                              msSLDParseSLD                           */
+/*                                                                      */
+/*      Parse the sld document into layers : for each named layer       */
+/*      there is one mapserver layer created with appropriate           */
+/*      classes and styles.                                             */
+/*      Returns an array of mapserver layers. The pnLayres if           */
+/*      provided will indicate the size of the returned array.          */
+/************************************************************************/
+layerObj *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers) {
+  CPLXMLNode *psRoot = NULL;
+  CPLXMLNode *psSLD, *psNamedLayer;
+  layerObj *pasLayers = NULL;
+  int iLayer = 0;
+  int nLayers = 0;
+
+  if (map == NULL || psSLDXML == NULL || strlen(psSLDXML) == 0 ||
+      (strstr(psSLDXML, "StyledLayerDescriptor") == NULL)) {
+    msSetError(MS_WMSERR, "Invalid SLD document", "");
+    return NULL;
+  }
+
+  psRoot = CPLParseXMLString(psSLDXML);
+  if (psRoot == NULL) {
+    msSetError(MS_WMSERR, "Invalid SLD document : %s", "", psSLDXML);
+    return NULL;
+  }
+
+  /* strip namespaces ogc and sld and gml */
+  CPLStripXMLNamespace(psRoot, "ogc", 1);
+  CPLStripXMLNamespace(psRoot, "sld", 1);
+  CPLStripXMLNamespace(psRoot, "gml", 1);
+  CPLStripXMLNamespace(psRoot, "se", 1);
+
+  /* -------------------------------------------------------------------- */
+  /*      get the root element (StyledLayerDescriptor).                   */
+  /* -------------------------------------------------------------------- */
+  psSLD = CPLGetXMLNode(psRoot, "=StyledLayerDescriptor");
+  if (!psSLD) {
+    msSetError(MS_WMSERR, "Invalid SLD document : %s", "", psSLDXML);
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse the named layers.                                         */
+  /* -------------------------------------------------------------------- */
+  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer") { nLayers++; }
+
+  if (nLayers > 0)
+    pasLayers = (layerObj *)malloc(sizeof(layerObj) * nLayers);
+  else
+    return NULL;
+
+  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer") {
+    CPLXMLNode *psName = CPLGetXMLNode(psNamedLayer, "Name");
+    initLayer(&pasLayers[iLayer], map);
+
+    if (psName && psName->psChild && psName->psChild->pszValue)
+      pasLayers[iLayer].name = msStrdup(psName->psChild->pszValue);
+
+    if (msSLDParseNamedLayer(psNamedLayer, &pasLayers[iLayer]) != MS_SUCCESS) {
+      int i;
+      for (i = 0; i <= iLayer; i++)
+        freeLayer(&pasLayers[i]);
+      msFree(pasLayers);
+      nLayers = 0;
+      pasLayers = NULL;
+      break;
+    }
+
+    iLayer++;
+  }
+
+  if (pnLayers)
+    *pnLayers = nLayers;
+
+  if (psRoot)
+    CPLDestroyXMLNode(psRoot);
+
+  return pasLayers;
+}
+
+/************************************************************************/
+/*                           _SLDApplyRuleValues                        */
+/*                                                                      */
+/*      Utility function to set the scale, title/name for the          */
+/*      classes created by a Rule.                                      */
+/************************************************************************/
+void _SLDApplyRuleValues(CPLXMLNode *psRule, layerObj *psLayer,
+                         int nNewClasses) {
+  CPLXMLNode *psMinScale = NULL, *psMaxScale = NULL;
+  CPLXMLNode *psName = NULL, *psTitle = NULL;
+  double dfMinScale = 0, dfMaxScale = 0;
+  char *pszName = NULL, *pszTitle = NULL;
+
+  if (psRule && psLayer && nNewClasses > 0) {
+    /* -------------------------------------------------------------------- */
+    /*      parse minscale and maxscale.                                    */
+    /* -------------------------------------------------------------------- */
+    psMinScale = CPLGetXMLNode(psRule, "MinScaleDenominator");
+    if (psMinScale && psMinScale->psChild && psMinScale->psChild->pszValue)
+      dfMinScale = atof(psMinScale->psChild->pszValue);
+
+    psMaxScale = CPLGetXMLNode(psRule, "MaxScaleDenominator");
+    if (psMaxScale && psMaxScale->psChild && psMaxScale->psChild->pszValue)
+      dfMaxScale = atof(psMaxScale->psChild->pszValue);
+
+    /* -------------------------------------------------------------------- */
+    /*      parse name and title.                                           */
+    /* -------------------------------------------------------------------- */
+    psName = CPLGetXMLNode(psRule, "Name");
+    if (psName && psName->psChild && psName->psChild->pszValue)
+      pszName = psName->psChild->pszValue;
+
+    psTitle = CPLGetXMLNode(psRule, "Title");
+    if (psTitle && psTitle->psChild && psTitle->psChild->pszValue)
+      pszTitle = psTitle->psChild->pszValue;
+
+    /* -------------------------------------------------------------------- */
+    /*      set the scale to all the classes created by the rule.           */
+    /* -------------------------------------------------------------------- */
+    if (dfMinScale > 0 || dfMaxScale > 0) {
+      for (int i = 0; i < nNewClasses; i++) {
+        if (dfMinScale > 0)
+          psLayer->_class[psLayer->numclasses - 1 - i]->minscaledenom =
+              dfMinScale;
+        if (dfMaxScale)
+          psLayer->_class[psLayer->numclasses - 1 - i]->maxscaledenom =
+              dfMaxScale;
+      }
+    }
+    /* -------------------------------------------------------------------- */
+    /*      set name and title to the classes created by the rule.          */
+    /* -------------------------------------------------------------------- */
+    for (int i = 0; i < nNewClasses; i++) {
+      if (!psLayer->_class[psLayer->numclasses - 1 - i]->name) {
+        if (pszName)
+          psLayer->_class[psLayer->numclasses - 1 - i]->name =
+              msStrdup(pszName);
+        else if (pszTitle)
+          psLayer->_class[psLayer->numclasses - 1 - i]->name =
+              msStrdup(pszTitle);
+        else {
+          // Build a name from layer and class info
+          char szTmp[256];
+          snprintf(szTmp, sizeof(szTmp), "%s#%d", psLayer->name,
+                   psLayer->numclasses - 1 - i);
+          psLayer->_class[psLayer->numclasses - 1 - i]->name = msStrdup(szTmp);
+        }
+      }
+    }
+    if (pszTitle) {
+      for (int i = 0; i < nNewClasses; i++) {
+        psLayer->_class[psLayer->numclasses - 1 - i]->title =
+            msStrdup(pszTitle);
+      }
+    }
+  }
+}
+
+/************************************************************************/
+/*                     msSLDGetCommonExpressionFromFilter               */
+/*                                                                      */
+/*      Get a common expression valid from the filter valid for the    */
+/*      temporary layer.                                                */
+/************************************************************************/
+static char *msSLDGetCommonExpressionFromFilter(CPLXMLNode *psFilter,
+                                                layerObj *psLayer) {
+  char *pszExpression = NULL;
+  CPLXMLNode *psTmpNextNode = NULL;
+  CPLXMLNode *psTmpNode = NULL;
+  FilterEncodingNode *psNode = NULL;
+  char *pszTmpFilter = NULL;
+  layerObj *psCurrentLayer = NULL;
+  const char *pszWmsName = NULL;
+  const char *key = NULL;
+
+  /* clone the tree and set the next node to null */
+  /* so we only have the Filter node */
+  psTmpNode = CPLCloneXMLTree(psFilter);
+  psTmpNextNode = psTmpNode->psNext;
+  psTmpNode->psNext = NULL;
+  pszTmpFilter = CPLSerializeXMLTree(psTmpNode);
+  psTmpNode->psNext = psTmpNextNode;
+  CPLDestroyXMLNode(psTmpNode);
+
+  if (pszTmpFilter) {
+    psNode = FLTParseFilterEncoding(pszTmpFilter);
+
+    CPLFree(pszTmpFilter);
+  }
+
+  if (psNode) {
+    int j;
+
+    /*preparse the filter for possible gml aliases set on the layer's metadata:
+    "gml_NA3DESC_alias" "alias_name" and filter could be
+    <ogc:PropertyName>alias_name</ogc:PropertyName> #3079*/
+    for (j = 0; j < psLayer->map->numlayers; j++) {
+      psCurrentLayer = GET_LAYER(psLayer->map, j);
+
+      pszWmsName =
+          msOWSLookupMetadata(&(psCurrentLayer->metadata), "MO", "name");
+
+      if ((psCurrentLayer->name && psLayer->name &&
+           strcasecmp(psCurrentLayer->name, psLayer->name) == 0) ||
+          (psCurrentLayer->group && psLayer->name &&
+           strcasecmp(psCurrentLayer->group, psLayer->name) == 0) ||
+          (psLayer->name && pszWmsName &&
+           strcasecmp(pszWmsName, psLayer->name) == 0))
+        break;
+    }
+    if (j < psLayer->map->numlayers) {
+      /*make sure that the tmp layer has all the metadata that
+      the original layer has, allowing to do parsing for
+      such things as gml_attribute_type #3052*/
+      while (1) {
+        key = msNextKeyFromHashTable(&psCurrentLayer->metadata, key);
+        if (!key)
+          break;
+        else
+          msInsertHashTable(&psLayer->metadata, key,
+                            msLookupHashTable(&psCurrentLayer->metadata, key));
+      }
+      FLTPreParseFilterForAliasAndGroup(psNode, psLayer->map, j, "G");
+    }
+
+    pszExpression = FLTGetCommonExpression(psNode, psLayer);
+    FLTFreeFilterEncodingNode(psNode);
+  }
+
+  return pszExpression;
+}
+
+/************************************************************************/
+/*                          msSLDParseUserStyle                         */
+/*                                                                      */
+/*      Parse UserStyle node.                                           */
+/************************************************************************/
+
+static void msSLDParseUserStyle(CPLXMLNode *psUserStyle, layerObj *psLayer) {
+  CPLXMLNode *psFeatureTypeStyle;
+  const char *pszUserStyleName = CPLGetXMLValue(psUserStyle, "Name", NULL);
+  if (pszUserStyleName) {
+    const char *pszIsDefault = CPLGetXMLValue(psUserStyle, "IsDefault", "0");
+    if (EQUAL(pszIsDefault, "true") || EQUAL(pszIsDefault, "1")) {
+      msFree(psLayer->classgroup);
+      psLayer->classgroup = msStrdup(pszUserStyleName);
+    }
+  }
+
+  LOOP_ON_CHILD_ELEMENT(psUserStyle, psFeatureTypeStyle, "FeatureTypeStyle") {
+    CPLXMLNode *psRule;
+
+    /* -------------------------------------------------------------------- */
+    /*      Parse rules with no Else filter.                                */
+    /* -------------------------------------------------------------------- */
+    LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule") {
+      CPLXMLNode *psFilter = NULL;
+      CPLXMLNode *psElseFilter = NULL;
+      int nNewClasses = 0, nClassBeforeFilter = 0, nClassAfterFilter = 0;
+      int nClassAfterRule = 0, nClassBeforeRule = 0;
+
+      /* used for scale setting */
+      nClassBeforeRule = psLayer->numclasses;
+
+      psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
+      nClassBeforeFilter = psLayer->numclasses;
+      if (psElseFilter == NULL)
+        msSLDParseRule(psRule, psLayer, pszUserStyleName);
+      nClassAfterFilter = psLayer->numclasses;
+
+      /* -------------------------------------------------------------------- */
+      /*      Parse the filter and apply it to the latest class created by    */
+      /*      the rule.                                                       */
+      /*      NOTE : Spatial Filter is not supported.                         */
+      /* -------------------------------------------------------------------- */
+      psFilter = CPLGetXMLNode(psRule, "Filter");
+      if (psFilter && psFilter->psChild && psFilter->psChild->pszValue) {
+        char *pszExpression =
+            msSLDGetCommonExpressionFromFilter(psFilter, psLayer);
+        if (pszExpression) {
+          int i;
+          nNewClasses = nClassAfterFilter - nClassBeforeFilter;
+          for (i = 0; i < nNewClasses; i++) {
+            expressionObj *exp =
+                &(psLayer->_class[psLayer->numclasses - 1 - i]->expression);
+            msFreeExpression(exp);
+            msInitExpression(exp);
+            exp->string = msStrdup(pszExpression);
+            exp->type = MS_EXPRESSION;
+          }
+          msFree(pszExpression);
+          pszExpression = NULL;
+        }
+      }
+      nClassAfterRule = psLayer->numclasses;
+      nNewClasses = nClassAfterRule - nClassBeforeRule;
+
+      /* apply scale and title to newly created classes */
+      _SLDApplyRuleValues(psRule, psLayer, nNewClasses);
+
+      /* TODO : parse legendgraphic */
+    }
+    /* -------------------------------------------------------------------- */
+    /*      First parse rules with the else filter. These rules will        */
+    /*      create the classes that are placed at the end of class          */
+    /*      list. (See how classes are applied to layers in function        */
+    /*      msSLDApplySLD).                                                 */
+    /* -------------------------------------------------------------------- */
+    LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule") {
+      CPLXMLNode *psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
+      if (psElseFilter) {
+        msSLDParseRule(psRule, psLayer, pszUserStyleName);
+        _SLDApplyRuleValues(psRule, psLayer, 1);
+        psLayer->_class[psLayer->numclasses - 1]->isfallback = TRUE;
+      }
+    }
+  }
+}
+
+/************************************************************************/
+/*                           msSLDParseNamedLayer                       */
+/*                                                                      */
+/*      Parse NamedLayer root.                                          */
+/************************************************************************/
+int msSLDParseNamedLayer(CPLXMLNode *psRoot, layerObj *psLayer) {
+  CPLXMLNode *psLayerFeatureConstraints = NULL;
+
+  if (!psRoot || !psLayer)
+    return MS_FAILURE;
+
+  if (CPLGetXMLNode(psRoot, "UserStyle")) {
+    CPLXMLNode *psUserStyle;
+    LOOP_ON_CHILD_ELEMENT(psRoot, psUserStyle, "UserStyle") {
+      msSLDParseUserStyle(psUserStyle, psLayer);
+    }
+  }
+  /* check for Named styles*/
+  else {
+    CPLXMLNode *psNamedStyle = CPLGetXMLNode(psRoot, "NamedStyle");
+    if (psNamedStyle) {
+      CPLXMLNode *psSLDName = CPLGetXMLNode(psNamedStyle, "Name");
+      if (psSLDName && psSLDName->psChild && psSLDName->psChild->pszValue) {
+        msFree(psLayer->classgroup);
+        psLayer->classgroup = msStrdup(psSLDName->psChild->pszValue);
+      }
+    }
+  }
+
+  /* Deal with LayerFeatureConstraints */
+  psLayerFeatureConstraints = CPLGetXMLNode(psRoot, "LayerFeatureConstraints");
+  if (psLayerFeatureConstraints != NULL) {
+    CPLXMLNode *psIter = psLayerFeatureConstraints->psChild;
+    CPLXMLNode *psFeatureTypeConstraint = NULL;
+    for (; psIter != NULL; psIter = psIter->psNext) {
+      if (psIter->eType == CXT_Element &&
+          strcmp(psIter->pszValue, "FeatureTypeConstraint") == 0) {
+        if (psFeatureTypeConstraint == NULL) {
+          psFeatureTypeConstraint = psIter;
+        } else {
+          msSetError(MS_WMSERR,
+                     "Only one single FeatureTypeConstraint element "
+                     "per LayerFeatureConstraints is supported",
+                     "");
+          return MS_FAILURE;
+        }
+      }
+    }
+    if (psFeatureTypeConstraint != NULL) {
+      CPLXMLNode *psFilter;
+      if (CPLGetXMLNode(psFeatureTypeConstraint, "FeatureTypeName") != NULL) {
+        msSetError(MS_WMSERR,
+                   "FeatureTypeName element is not "
+                   "supported in FeatureTypeConstraint",
+                   "");
+        return MS_FAILURE;
+      }
+      if (CPLGetXMLNode(psFeatureTypeConstraint, "Extent") != NULL) {
+        msSetError(MS_WMSERR,
+                   "Extent element is not "
+                   "supported in FeatureTypeConstraint",
+                   "");
+        return MS_FAILURE;
+      }
+      psFilter = CPLGetXMLNode(psFeatureTypeConstraint, "Filter");
+      if (psFilter && psFilter->psChild && psFilter->psChild->pszValue) {
+        char *pszExpression =
+            msSLDGetCommonExpressionFromFilter(psFilter, psLayer);
+        if (pszExpression) {
+          msFreeExpression(&psLayer->filter);
+          msInitExpression(&psLayer->filter);
+          psLayer->filter.string = pszExpression;
+          psLayer->filter.type = MS_EXPRESSION;
+        }
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                      msSLDParseRule()                                */
+/*                                                                      */
+/*      Parse a Rule node into classes for a specific layer.            */
+/************************************************************************/
+int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer,
+                   const char *pszUserStyleName) {
+  CPLXMLNode *psLineSymbolizer = NULL;
+  CPLXMLNode *psPolygonSymbolizer = NULL;
+  CPLXMLNode *psPointSymbolizer = NULL;
+  CPLXMLNode *psTextSymbolizer = NULL;
+  CPLXMLNode *psRasterSymbolizer = NULL;
+
+  int nSymbolizer = 0;
+
+  if (!psRoot || !psLayer)
+    return MS_FAILURE;
+
+  /* TODO : parse name of the rule */
+  /* ==================================================================== */
+  /*      For each rule a new class is created. If there are more than    */
+  /*      one symbolizer, a style is added in the same class.             */
+  /* ==================================================================== */
+
+  /* Raster symbolizer */
+  LOOP_ON_CHILD_ELEMENT(psRoot, psRasterSymbolizer, "RasterSymbolizer") {
+    msSLDParseRasterSymbolizer(psRasterSymbolizer, psLayer, pszUserStyleName);
+    /* cppcheck-suppress knownConditionTrueFalse */
+    if (nSymbolizer == 0) {
+      psLayer->type = MS_LAYER_RASTER;
+    }
+  }
+
+  /* Polygon symbolizer */
+  LOOP_ON_CHILD_ELEMENT(psRoot, psPolygonSymbolizer, "PolygonSymbolizer") {
+    /* cppcheck-suppress knownConditionTrueFalse */
+    const int bNewClass = (nSymbolizer == 0);
+    msSLDParsePolygonSymbolizer(psPolygonSymbolizer, psLayer, bNewClass,
+                                pszUserStyleName);
+    psLayer->type = MS_LAYER_POLYGON;
+    nSymbolizer++;
+  }
+
+  /* line symbolizer */
+  LOOP_ON_CHILD_ELEMENT(psRoot, psLineSymbolizer, "LineSymbolizer") {
+    const int bNewClass = (nSymbolizer == 0);
+    msSLDParseLineSymbolizer(psLineSymbolizer, psLayer, bNewClass,
+                             pszUserStyleName);
+    if (bNewClass) {
+      psLayer->type = MS_LAYER_LINE;
+    }
+    if (psLayer->type == MS_LAYER_POLYGON) {
+      const int nClassId = psLayer->numclasses - 1;
+      if (nClassId >= 0) {
+        const int nStyleId = psLayer->_class[nClassId]->numstyles - 1;
+        if (nStyleId >= 0) {
+          styleObj *psStyle = psLayer->_class[nClassId]->styles[nStyleId];
+          psStyle->outlinecolor = psStyle->color;
+          MS_INIT_COLOR(psStyle->color, -1, -1, -1, 255);
+          MS_COPYSTRING(
+              psStyle->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].string,
+              psStyle->exprBindings[MS_STYLE_BINDING_COLOR].string);
+          psStyle->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].type =
+              psStyle->exprBindings[MS_STYLE_BINDING_COLOR].type;
+          msFreeExpression(&(psStyle->exprBindings[MS_STYLE_BINDING_COLOR]));
+          msInitExpression(&(psStyle->exprBindings[MS_STYLE_BINDING_COLOR]));
+        }
+      }
+    }
+    nSymbolizer++;
+  }
+
+  /* Point Symbolizer */
+  LOOP_ON_CHILD_ELEMENT(psRoot, psPointSymbolizer, "PointSymbolizer") {
+    const int bNewClass = (nSymbolizer == 0);
+    msSLDParsePointSymbolizer(psPointSymbolizer, psLayer, bNewClass,
+                              pszUserStyleName);
+    if (bNewClass) {
+      psLayer->type = MS_LAYER_POINT;
+    }
+    if (psLayer->type == MS_LAYER_POLYGON || psLayer->type == MS_LAYER_LINE ||
+        psLayer->type == MS_LAYER_RASTER) {
+      const int nClassId = psLayer->numclasses - 1;
+      if (nClassId >= 0) {
+        const int nStyleId = psLayer->_class[nClassId]->numstyles - 1;
+        if (nStyleId >= 0) {
+          styleObj *psStyle = psLayer->_class[nClassId]->styles[nStyleId];
+          msStyleSetGeomTransform(psStyle, "centroid");
+        }
+      }
+    }
+    nSymbolizer++;
+  }
+
+  /* Text symbolizer */
+  /* ==================================================================== */
+  /*      For text symbolizer, here is how it is translated into          */
+  /*      mapserver classes :                                             */
+  /*        - If there are other symbolizers(line, polygon, symbol),      */
+  /*      the label object created will be created in the same class      */
+  /*      (the last class) as the  symbolizer. This allows to have for    */
+  /*      example of point layer with labels.                             */
+  /*        - If there are no other symbolizers, a new class will be      */
+  /*      created to contain the label object.                            */
+  /* ==================================================================== */
+  LOOP_ON_CHILD_ELEMENT(psRoot, psTextSymbolizer, "TextSymbolizer") {
+    if (nSymbolizer == 0)
+      psLayer->type = MS_LAYER_POINT;
+    msSLDParseTextSymbolizer(psTextSymbolizer, psLayer, nSymbolizer > 0,
+                             pszUserStyleName);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                            getClassId()                              */
+/************************************************************************/
+
+static int getClassId(layerObj *psLayer, int bNewClass,
+                      const char *pszUserStyleName) {
+  int nClassId;
+  if (bNewClass || psLayer->numclasses <= 0) {
+    if (msGrowLayerClasses(psLayer) == NULL)
+      return -1;
+    initClass(psLayer->_class[psLayer->numclasses]);
+    nClassId = psLayer->numclasses;
+    if (pszUserStyleName)
+      psLayer->_class[nClassId]->group = msStrdup(pszUserStyleName);
+    psLayer->numclasses++;
+  } else {
+    nClassId = psLayer->numclasses - 1;
+  }
+  return nClassId;
+}
+
+/************************************************************************/
+/*                      msSLDParseUomAttribute()                        */
+/************************************************************************/
+
+int msSLDParseUomAttribute(CPLXMLNode *node, enum MS_UNITS *sizeunits) {
+  const struct {
+    enum MS_UNITS unit;
+    const char *const values[10];
+  } known_uoms[] = {
+      {MS_INCHES, {"inch", "inches", NULL}},
+      {MS_FEET,
+       {"foot", "feet", "http://www.opengeospatial.org/se/units/foot", NULL}},
+      {MS_MILES, {"mile", "miles", NULL}},
+      {MS_METERS,
+       {"meter", "meters", "metre", "metres",
+        "http://www.opengeospatial.org/se/units/metre", NULL}},
+      {MS_KILOMETERS,
+       {"kilometer", "kilometers", "kilometre", "kilometres", NULL}},
+      {MS_DD, {"dd", NULL}},
+      {MS_PIXELS,
+       {"pixel", "pixels", "px", "http://www.opengeospatial.org/se/units/pixel",
+        NULL}},
+      {MS_PERCENTAGES,
+       {"percent", "percents", "percentage", "percentages", NULL}},
+      {MS_NAUTICALMILES,
+       {"nauticalmile", "nauticalmiles", "nautical_mile", "nautical_miles",
+        NULL}},
+      {MS_INCHES, {NULL}}};
+
+  const char *uom = CPLGetXMLValue(node, "uom", NULL);
+  if (uom) {
+    for (int i = 0; known_uoms[i].values[0]; i++)
+      for (int j = 0; known_uoms[i].values[j]; j++)
+        if (strcmp(uom, known_uoms[i].values[j]) == 0) {
+          // Match found
+          *sizeunits = known_uoms[i].unit;
+          return MS_SUCCESS;
+        }
+    // No match was found
+    return MS_FAILURE;
+  }
+  // No uom was found
+  *sizeunits = MS_PIXELS;
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                 msSLDParseLineSymbolizer()                           */
+/*                                                                      */
+/*      Parses the LineSymbolizer rule and creates a class in the       */
+/*      layer.                                                          */
+/*                                                                      */
+/*      <xs:element name="LineSymbolizer">                              */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
+/*      <xs:element ref="sld:Stroke" minOccurs="0"/>                    */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      <xs:element name="Stroke">                                      */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:choice minOccurs="0">                                       */
+/*      <xs:element ref="sld:GraphicFill"/>                             */
+/*      <xs:element ref="sld:GraphicStroke"/>                           */
+/*      </xs:choice>                                                    */
+/*      <xs:element ref="sld:CssParameter" minOccurs="0"                */
+/*      maxOccurs="unbounded"/>                                         */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      Example of a rule :                                             */
+/*      ...                                                             */
+/*      <Rule>                                                          */
+/*      <LineSymbolizer>                                                */
+/*      <Geometry>                                                      */
+/*      <ogc:PropertyName>center-line</ogc:PropertyName>                */
+/*      </Geometry>                                                     */
+/*      <Stroke>                                                        */
+/*      <CssParameter name="stroke">#0000ff</CssParameter>              */
+/*      <CssParameter name="stroke-width">5.0</CssParameter>            */
+/*      <CssParameter name="stroke-dasharray">10.0 5 5 10</CssParameter>*/
+/*      </Stroke>                                                       */
+/*      </LineSymbolizer>                                               */
+/*      </Rule>                                                         */
+/*       ...                                                            */
+/************************************************************************/
+int msSLDParseLineSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                             int bNewClass, const char *pszUserStyleName) {
+  CPLXMLNode *psStroke = NULL, *psOffset = NULL;
+
+  if (!psRoot || !psLayer)
+    return MS_FAILURE;
+
+  // Get uom if any, defaults to MS_PIXELS
+  enum MS_UNITS sizeunits = MS_PIXELS;
+  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS) {
+    msSetError(MS_WMSERR, "Invalid uom attribute value.",
+               "msSLDParsePolygonSymbolizer()");
+    return MS_FAILURE;
+  }
+
+  psStroke = CPLGetXMLNode(psRoot, "Stroke");
+  if (psStroke) {
+    int nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
+    if (nClassId < 0)
+      return MS_FAILURE;
+
+    const int iStyle = psLayer->_class[nClassId]->numstyles;
+    msMaybeAllocateClassStyle(psLayer->_class[nClassId], iStyle);
+    psLayer->_class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
+
+    msSLDParseStroke(psStroke, psLayer->_class[nClassId]->styles[iStyle],
+                     psLayer->map, 0);
+
+    /*parse PerpendicularOffset SLD 1.1.10*/
+    psOffset = CPLGetXMLNode(psRoot, "PerpendicularOffset");
+    if (psOffset && psOffset->psChild && psOffset->psChild->pszValue) {
+      psLayer->_class[nClassId]->styles[iStyle]->offsetx =
+          atoi(psOffset->psChild->pszValue);
+      psLayer->_class[nClassId]->styles[iStyle]->offsety =
+          MS_STYLE_SINGLE_SIDED_OFFSET;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*           void msSLDParseStroke(CPLXMLNode *psStroke, styleObj       */
+/*      *psStyle, int iColorParam)                                      */
+/*                                                                      */
+/*      Parse Stroke content into a style object.                       */
+/*      The iColorParm is used to indicate which color object to use    */
+/*      :                                                               */
+/*        0 : for color                                                 */
+/*        1 : outlinecolor                                              */
+/************************************************************************/
+int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle, mapObj *map,
+                     int iColorParam) {
+  CPLXMLNode *psCssParam = NULL, *psGraphicFill = NULL;
+  char *psStrkName = NULL;
+  char *pszDashValue = NULL;
+
+  if (!psStroke || !psStyle)
+    return MS_FAILURE;
+
+  /* parse css parameters */
+  psCssParam = CPLGetXMLNode(psStroke, "CssParameter");
+  /*sld 1.1 used SvgParameter*/
+  if (psCssParam == NULL)
+    psCssParam = CPLGetXMLNode(psStroke, "SvgParameter");
+
+  while (psCssParam && psCssParam->pszValue &&
+         (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
+          strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
+    psStrkName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+
+    if (psStrkName) {
+      if (strcasecmp(psStrkName, "stroke") == 0) {
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          switch (iColorParam) {
+          case 0:
+            msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                    MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+            break;
+          case 1:
+            msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                    MS_STYLE_BINDING_OUTLINECOLOR,
+                                    MS_OBJ_STYLE);
+            break;
+          }
+        }
+      } else if (strcasecmp(psStrkName, "stroke-width") == 0) {
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                  MS_STYLE_BINDING_WIDTH, MS_OBJ_STYLE);
+        }
+      } else if (strcasecmp(psStrkName, "stroke-dasharray") == 0) {
+        if (psCssParam->psChild && psCssParam->psChild->psNext &&
+            psCssParam->psChild->psNext->pszValue) {
+          int nDash = 0, i;
+          char **aszValues = NULL;
+          int nMaxDash;
+          if (pszDashValue)
+            free(pszDashValue); /* free previous if multiple stroke-dasharray
+                                   attributes were found */
+          pszDashValue = msStrdup(psCssParam->psChild->psNext->pszValue);
+          aszValues = msStringSplit(pszDashValue, ' ', &nDash);
+          if (nDash > 0) {
+            nMaxDash = nDash;
+            if (nDash > MS_MAXPATTERNLENGTH)
+              nMaxDash = MS_MAXPATTERNLENGTH;
+
+            psStyle->patternlength = nMaxDash;
+            for (i = 0; i < nMaxDash; i++)
+              psStyle->pattern[i] = atof(aszValues[i]);
+
+            psStyle->linecap = MS_CJC_BUTT;
+          }
+          msFreeCharArray(aszValues, nDash);
+        }
+      } else if (strcasecmp(psStrkName, "stroke-opacity") == 0) {
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                  MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
+        }
+      }
+    }
+    psCssParam = psCssParam->psNext;
+  }
+
+  /* parse graphic fill or stroke */
+  /* graphic fill and graphic stroke pare parsed the same way :  */
+  /* TODO : It seems inconsistent to me since the only difference */
+  /* between them seems to be fill (fill) or not fill (stroke). And */
+  /* then again the fill parameter can be used inside both elements. */
+  psGraphicFill = CPLGetXMLNode(psStroke, "GraphicFill");
+  if (psGraphicFill)
+    msSLDParseGraphicFillOrStroke(psGraphicFill, pszDashValue, psStyle, map);
+  psGraphicFill = CPLGetXMLNode(psStroke, "GraphicStroke");
+  if (psGraphicFill)
+    msSLDParseGraphicFillOrStroke(psGraphicFill, pszDashValue, psStyle, map);
+
+  if (pszDashValue)
+    free(pszDashValue);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*  int msSLDParseOgcExpression(CPLXMLNode *psRoot, styleObj *psStyle,  */
+/*                              enum MS_STYLE_BINDING_ENUM binding)     */
+/*                                                                      */
+/*              Parse an OGC expression in a <SvgParameter>             */
+/************************************************************************/
+int msSLDParseOgcExpression(CPLXMLNode *psRoot, void *psObj, int binding,
+                            enum objType objtype) {
+  int status = MS_FAILURE;
+  const char *ops = "Add+Sub-Mul*Div/";
+  styleObj *psStyle = static_cast<styleObj *>(psObj);
+  labelObj *psLabel = static_cast<labelObj *>(psObj);
+  int lbinding;
+  expressionObj *exprBindings;
+  int *nexprbindings;
+  enum { MS_STYLE_BASE = 0, MS_LABEL_BASE = 100 };
+
+  switch (objtype) {
+  case MS_OBJ_STYLE:
+    lbinding = binding + MS_STYLE_BASE;
+    exprBindings = psStyle->exprBindings;
+    nexprbindings = &psStyle->nexprbindings;
+    break;
+  case MS_OBJ_LABEL:
+    lbinding = binding + MS_LABEL_BASE;
+    exprBindings = psLabel->exprBindings;
+    nexprbindings = &psLabel->nexprbindings;
+    break;
+  default:
+    return MS_FAILURE;
+    break;
+  }
+
+  switch (psRoot->eType) {
+  case CXT_Text:
+    // Parse a raw value
+    {
+      msStringBuffer *literal = msStringBufferAlloc();
+      msStringBufferAppend(literal, "(");
+      msStringBufferAppend(literal, psRoot->pszValue);
+      msStringBufferAppend(literal, ")");
+      msFreeExpression(&(exprBindings[binding]));
+      msInitExpression(&(exprBindings[binding]));
+      exprBindings[binding].string =
+          msStringBufferReleaseStringAndFree(literal);
+      exprBindings[binding].type = MS_STRING;
+    }
+    switch (lbinding) {
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_X:
+      psStyle->offsetx = atoi(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_Y:
+      psStyle->offsety = atoi(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_ANGLE:
+      psStyle->angle = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_SIZE:
+      psStyle->size = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_WIDTH:
+      psStyle->width = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OPACITY:
+      psStyle->opacity = atof(psRoot->pszValue) * 100;
+      status = MS_SUCCESS;
+      // Apply opacity as the alpha channel color(s)
+      if (psStyle->opacity < 100) {
+        int alpha = MS_NINT(psStyle->opacity * 2.55);
+        psStyle->color.alpha = alpha;
+        psStyle->outlinecolor.alpha = alpha;
+        psStyle->mincolor.alpha = alpha;
+        psStyle->maxcolor.alpha = alpha;
+      }
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psStyle->color.red = msHexToInt(psRoot->pszValue + 1);
+        psStyle->color.green = msHexToInt(psRoot->pszValue + 3);
+        psStyle->color.blue = msHexToInt(psRoot->pszValue + 5);
+        status = MS_SUCCESS;
+      }
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psStyle->outlinecolor.red = msHexToInt(psRoot->pszValue + 1);
+        psStyle->outlinecolor.green = msHexToInt(psRoot->pszValue + 3);
+        psStyle->outlinecolor.blue = msHexToInt(psRoot->pszValue + 5);
+        status = MS_SUCCESS;
+      }
+      break;
+
+    case MS_LABEL_BASE + MS_LABEL_BINDING_SIZE:
+      psLabel->size = atof(psRoot->pszValue);
+      if (psLabel->size <= 0.0) {
+        psLabel->size = 10.0;
+      }
+      status = MS_SUCCESS;
+      break;
+    case MS_LABEL_BASE + MS_LABEL_BINDING_ANGLE:
+      psLabel->angle = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psLabel->color.red = msHexToInt(psRoot->pszValue + 1);
+        psLabel->color.green = msHexToInt(psRoot->pszValue + 3);
+        psLabel->color.blue = msHexToInt(psRoot->pszValue + 5);
+        status = MS_SUCCESS;
+      }
+      break;
+    case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psLabel->outlinecolor.red = msHexToInt(psRoot->pszValue + 1);
+        psLabel->outlinecolor.green = msHexToInt(psRoot->pszValue + 3);
+        psLabel->outlinecolor.blue = msHexToInt(psRoot->pszValue + 5);
+        status = MS_SUCCESS;
+      }
+      break;
+    default:
+      break;
+    }
+    break;
+  case CXT_Element:
+    if (strcasecmp(psRoot->pszValue, "Literal") == 0 && psRoot->psChild) {
+      // Parse a <ogc:Literal> element
+      status =
+          msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
+    } else if (strcasecmp(psRoot->pszValue, "PropertyName") == 0 &&
+               psRoot->psChild) {
+      // Parse a <ogc:PropertyName> element
+      msStringBuffer *property = msStringBufferAlloc();
+      const char *strDelim = "";
+
+      switch (lbinding) {
+      case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
+      case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
+      case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
+      case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
+        strDelim = "\"";
+        /* FALLTHROUGH */
+      default:
+        msStringBufferAppend(property, strDelim);
+        msStringBufferAppend(property, "[");
+        msStringBufferAppend(property, psRoot->psChild->pszValue);
+        msStringBufferAppend(property, "]");
+        msStringBufferAppend(property, strDelim);
+        msInitExpression(&(exprBindings[binding]));
+        exprBindings[binding].string =
+            msStringBufferReleaseStringAndFree(property);
+        exprBindings[binding].type = MS_EXPRESSION;
+        (*nexprbindings)++;
+        break;
+      }
+      status = MS_SUCCESS;
+    } else if (strcasecmp(psRoot->pszValue, "Function") == 0 &&
+               psRoot->psChild && CPLGetXMLValue(psRoot, "name", NULL) &&
+               psRoot->psChild->psNext) {
+      // Parse a <ogc:Function> element
+      msStringBuffer *function = msStringBufferAlloc();
+
+      // Parse function name
+      const char *funcname = CPLGetXMLValue(psRoot, "name", NULL);
+      msStringBufferAppend(function, funcname);
+      msStringBufferAppend(function, "(");
+      msInitExpression(&(exprBindings[binding]));
+
+      // Parse arguments
+      const char *sep = "";
+      for (CPLXMLNode *argument = psRoot->psChild->psNext; argument;
+           argument = argument->psNext) {
+        status = msSLDParseOgcExpression(argument, psObj, binding, objtype);
+        if (status != MS_SUCCESS)
+          break;
+        msStringBufferAppend(function, sep);
+        msStringBufferAppend(function, exprBindings[binding].string);
+        msFree(exprBindings[binding].string);
+        msInitExpression(&(exprBindings[binding]));
+        sep = ",";
+      }
+      msStringBufferAppend(function, ")");
+      exprBindings[binding].string =
+          msStringBufferReleaseStringAndFree(function);
+      exprBindings[binding].type = MS_EXPRESSION;
+      (*nexprbindings)++;
+      status = MS_SUCCESS;
+    } else if (strstr(ops, psRoot->pszValue) && psRoot->psChild &&
+               psRoot->psChild->psNext) {
+      // Parse an arithmetic element <ogc:Add>, <ogc:Sub>, <ogc:Mul>, <ogc:Div>
+      const char op[2] = {*(strstr(ops, psRoot->pszValue) + 3), '\0'};
+      msStringBuffer *expression = msStringBufferAlloc();
+
+      // Parse first operand
+      msStringBufferAppend(expression, "(");
+      msInitExpression(&(exprBindings[binding]));
+      status =
+          msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
+
+      // Parse second operand
+      if (status == MS_SUCCESS) {
+        msStringBufferAppend(expression, exprBindings[binding].string);
+        msStringBufferAppend(expression, op);
+        msFree(exprBindings[binding].string);
+        msInitExpression(&(exprBindings[binding]));
+        status = msSLDParseOgcExpression(psRoot->psChild->psNext, psObj,
+                                         binding, objtype);
+        if (status == MS_SUCCESS) {
+          msStringBufferAppend(expression, exprBindings[binding].string);
+          msStringBufferAppend(expression, ")");
+          msFree(exprBindings[binding].string);
+          exprBindings[binding].string =
+              msStringBufferReleaseStringAndFree(expression);
+          expression = NULL;
+          exprBindings[binding].type = MS_EXPRESSION;
+          (*nexprbindings)++;
+        }
+      }
+      if (expression != NULL) {
+        msStringBufferFree(expression);
+        msInitExpression(&(exprBindings[binding]));
+      }
+    }
+    break;
+  default:
+    break;
+  }
+
+  return status;
+}
+
+/************************************************************************/
+/*                      msSLDParsePolygonSymbolizer()                   */
+/*                                                                      */
+/*      <xs:element name="PolygonSymbolizer">                           */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
+/*      <xs:element ref="sld:Fill" minOccurs="0"/>                      */
+/*      <xs:element ref="sld:Stroke" minOccurs="0"/>                    */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*                                                                      */
+/*      <xs:element name="Fill">                                        */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:GraphicFill" minOccurs="0"/>               */
+/*      <xs:element ref="sld:CssParameter" minOccurs="0"                */
+/*      maxOccurs="unbounded"/>                                         */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      Here, the CssParameter names are fill instead of stroke and     */
+/*      fill-opacity instead of stroke-opacity. None of the other
+ * CssParameters*/
+/*      in Stroke are available for filling and the default value for the fill
+ * color in this context is 50% gray (value #808080).*/
+/*                                                                      */
+/*                                                                      */
+/*      <xs:element name="GraphicFill">                                 */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:Graphic"/>                                 */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*                                                                      */
+/*      <xs:element name="Graphic">                                     */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:choice minOccurs="0" maxOccurs="unbounded">                 */
+/*      <xs:element ref="sld:ExternalGraphic"/>                         */
+/*      <xs:element ref="sld:Mark"/>                                    */
+/*      </xs:choice>                                                    */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:Opacity" minOccurs="0"/>                   */
+/*      <xs:element ref="sld:Size" minOccurs="0"/>                      */
+/*      <xs:element ref="sld:Rotation" minOccurs="0"/>                  */
+/*      </xs:sequence>                                                  */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      The default if neither an ExternalGraphic nor a Mark is specified is to
+ * use the default*/
+/*      mark of a square with a 50%-gray fill and a black outline, with a size
+ * of 6 pixels.*/
+/*                                                                      */
+/*                                                                      */
+/*      <xs:element name="Mark">                                        */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:WellKnownName" minOccurs="0"/>             */
+/*      <xs:element ref="sld:Fill" minOccurs="0"/>                      */
+/*      <xs:element ref="sld:Stroke" minOccurs="0"/>                    */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      <xs:element name="WellKnownName" type="xs:string"/>             */
+/*                                                                      */
+/*      The WellKnownName element gives the well-known name of the shape of the
+ * mark.*/
+/*      Allowed values include at least square, circle, triangle, star, cross,*/
+/*      and x, though map servers may draw a different symbol instead if they
+ * don't have a*/
+/*      shape for all of these. The default WellKnownName is square. Renderings
+ * of these*/
+/*      marks may be made solid or hollow depending on Fill and Stroke
+ * elements.*/
+/*                                                                      */
+/************************************************************************/
+int msSLDParsePolygonSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                                int bNewClass, const char *pszUserStyleName) {
+  CPLXMLNode *psFill, *psStroke;
+  CPLXMLNode *psDisplacement = NULL, *psDisplacementX = NULL,
+             *psDisplacementY = NULL;
+  int nOffsetX = -1, nOffsetY = -1;
+
+  if (!psRoot || !psLayer)
+    return MS_FAILURE;
+
+  // Get uom if any, defaults to MS_PIXELS
+  enum MS_UNITS sizeunits = MS_PIXELS;
+  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS) {
+    msSetError(MS_WMSERR, "Invalid uom attribute value.",
+               "msSLDParsePolygonSymbolizer()");
+    return MS_FAILURE;
+  }
+
+  /*parse displacement for SLD 1.1.0*/
+  psDisplacement = CPLGetXMLNode(psRoot, "Displacement");
+  if (psDisplacement) {
+    psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
+    psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
+    /* psCssParam->psChild->psNext->pszValue) */
+    if (psDisplacementX && psDisplacementX->psChild &&
+        psDisplacementX->psChild->pszValue && psDisplacementY &&
+        psDisplacementY->psChild && psDisplacementY->psChild->pszValue) {
+      nOffsetX = atoi(psDisplacementX->psChild->pszValue);
+      nOffsetY = atoi(psDisplacementY->psChild->pszValue);
+    }
+  }
+
+  psFill = CPLGetXMLNode(psRoot, "Fill");
+  if (psFill) {
+    const int nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
+    if (nClassId < 0)
+      return MS_FAILURE;
+
+    const int iStyle = psLayer->_class[nClassId]->numstyles;
+    msMaybeAllocateClassStyle(psLayer->_class[nClassId], iStyle);
+    psLayer->_class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
+
+    msSLDParsePolygonFill(psFill, psLayer->_class[nClassId]->styles[iStyle],
+                          psLayer->map);
+
+    if (nOffsetX > 0 && nOffsetY > 0) {
+      psLayer->_class[nClassId]->styles[iStyle]->offsetx = nOffsetX;
+      psLayer->_class[nClassId]->styles[iStyle]->offsety = nOffsetY;
+    }
+  }
+  /* stroke which corresponds to the outline in mapserver */
+  /* is drawn after the fill */
+  psStroke = CPLGetXMLNode(psRoot, "Stroke");
+  if (psStroke) {
+    /* -------------------------------------------------------------------- */
+    /*      there was a fill so add a style to the last class created       */
+    /*      by the fill                                                     */
+    /* -------------------------------------------------------------------- */
+    int nClassId;
+    int iStyle;
+    if (psFill && psLayer->numclasses > 0) {
+      nClassId = psLayer->numclasses - 1;
+      iStyle = psLayer->_class[nClassId]->numstyles;
+      msMaybeAllocateClassStyle(psLayer->_class[nClassId], iStyle);
+      psLayer->_class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
+    } else {
+      nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
+      if (nClassId < 0)
+        return MS_FAILURE;
+
+      iStyle = psLayer->_class[nClassId]->numstyles;
+      msMaybeAllocateClassStyle(psLayer->_class[nClassId], iStyle);
+      psLayer->_class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
+    }
+    msSLDParseStroke(psStroke, psLayer->_class[nClassId]->styles[iStyle],
+                     psLayer->map, 1);
+
+    if (nOffsetX > 0 && nOffsetY > 0) {
+      psLayer->_class[nClassId]->styles[iStyle]->offsetx = nOffsetX;
+      psLayer->_class[nClassId]->styles[iStyle]->offsety = nOffsetY;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*    void msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle, */
+/*                                 mapObj *map)                         */
+/*                                                                      */
+/*      Parse the Fill node for a polygon into a style.                 */
+/************************************************************************/
+int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle, mapObj *map) {
+  CPLXMLNode *psCssParam, *psGraphicFill;
+  char *psFillName = NULL;
+
+  if (!psFill || !psStyle || !map)
+    return MS_FAILURE;
+
+  /* sets the default fill color defined in the spec #808080 */
+  psStyle->color.red = 128;
+  psStyle->color.green = 128;
+  psStyle->color.blue = 128;
+
+  psCssParam = CPLGetXMLNode(psFill, "CssParameter");
+  /*sld 1.1 used SvgParameter*/
+  if (psCssParam == NULL)
+    psCssParam = CPLGetXMLNode(psFill, "SvgParameter");
+
+  while (psCssParam && psCssParam->pszValue &&
+         (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
+          strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
+    psFillName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+    if (psFillName) {
+      if (strcasecmp(psFillName, "fill") == 0) {
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                  MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+        }
+      } else if (strcasecmp(psFillName, "fill-opacity") == 0) {
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                  MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
+        }
+      }
+    }
+    psCssParam = psCssParam->psNext;
+  }
+
+  /* graphic fill and graphic stroke pare parsed the same way :  */
+  /* TODO : It seems inconsistent to me since the only diffrence */
+  /* between them seems to be fill (fill) or not fill (stroke). And */
+  /* then again the fill parameter can be used inside both elements. */
+  psGraphicFill = CPLGetXMLNode(psFill, "GraphicFill");
+  if (psGraphicFill)
+    msSLDParseGraphicFillOrStroke(psGraphicFill, NULL, psStyle, map);
+  psGraphicFill = CPLGetXMLNode(psFill, "GraphicStroke");
+  if (psGraphicFill)
+    msSLDParseGraphicFillOrStroke(psGraphicFill, NULL, psStyle, map);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                      msSLDParseGraphicFillOrStroke                   */
+/*                                                                      */
+/*      Parse the GraphicFill Or GraphicStroke node : look for a        */
+/*      Marker symbol and set the style for that symbol.                */
+/************************************************************************/
+int msSLDParseGraphicFillOrStroke(CPLXMLNode *psRoot, char *pszDashValue_unused,
+                                  styleObj *psStyle, mapObj *map) {
+  (void)pszDashValue_unused;
+  CPLXMLNode *psCssParam, *psGraphic, *psExternalGraphic, *psMark, *psSize,
+      *psGap, *psInitialGap;
+  CPLXMLNode *psWellKnownName, *psStroke, *psFill;
+  CPLXMLNode *psDisplacement = NULL, *psDisplacementX = NULL,
+             *psDisplacementY = NULL;
+  CPLXMLNode *psOpacity = NULL, *psRotation = NULL;
+  char *psName = NULL, *psValue = NULL;
+  char *pszSymbolName = NULL;
+  int bFilled = 0;
+
+  if (!psRoot || !psStyle || !map)
+    return MS_FAILURE;
+  /* ==================================================================== */
+  /*      This a definition taken from the specification (11.3.2) :       */
+  /*      Graphics can either be referenced from an external URL in a common
+   * format (such as*/
+  /*      GIF or SVG) or may be derived from a Mark. Multiple external URLs and
+   * marks may be*/
+  /*      referenced with the semantic that they all provide the equivalent
+   * graphic in different*/
+  /*      formats.                                                        */
+  /*                                                                      */
+  /*      For this reason, we only need to support one Mark and one       */
+  /*      ExtrnalGraphic ????                                             */
+  /* ==================================================================== */
+  psGraphic = CPLGetXMLNode(psRoot, "Graphic");
+  if (psGraphic) {
+    /* extract symbol size */
+    psSize = CPLGetXMLNode(psGraphic, "Size");
+    if (psSize && psSize->psChild) {
+      msSLDParseOgcExpression(psSize->psChild, psStyle, MS_STYLE_BINDING_SIZE,
+                              MS_OBJ_STYLE);
+    } else {
+      /*do not set a default for external symbols #2305*/
+      psExternalGraphic = CPLGetXMLNode(psGraphic, "ExternalGraphic");
+      if (!psExternalGraphic)
+        psStyle->size = 6; /* default value */
+    }
+
+    /*SLD 1.1.0 extract opacity, rotation, displacement*/
+    psOpacity = CPLGetXMLNode(psGraphic, "Opacity");
+    if (psOpacity && psOpacity->psChild) {
+      msSLDParseOgcExpression(psOpacity->psChild, psStyle,
+                              MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
+    }
+
+    psRotation = CPLGetXMLNode(psGraphic, "Rotation");
+    if (psRotation && psRotation->psChild) {
+      msSLDParseOgcExpression(psRotation->psChild, psStyle,
+                              MS_STYLE_BINDING_ANGLE, MS_OBJ_STYLE);
+    }
+    psDisplacement = CPLGetXMLNode(psGraphic, "Displacement");
+    if (psDisplacement && psDisplacement->psChild) {
+      psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
+      if (psDisplacementX && psDisplacementX->psChild) {
+        msSLDParseOgcExpression(psDisplacementX->psChild, psStyle,
+                                MS_STYLE_BINDING_OFFSET_X, MS_OBJ_STYLE);
+      }
+      psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
+      if (psDisplacementY && psDisplacementY->psChild) {
+        msSLDParseOgcExpression(psDisplacementY->psChild, psStyle,
+                                MS_STYLE_BINDING_OFFSET_Y, MS_OBJ_STYLE);
+      }
+    }
+    /* extract symbol */
+    psMark = CPLGetXMLNode(psGraphic, "Mark");
+    if (psMark) {
+      pszSymbolName = NULL;
+      psWellKnownName = CPLGetXMLNode(psMark, "WellKnownName");
+      if (psWellKnownName && psWellKnownName->psChild &&
+          psWellKnownName->psChild->pszValue)
+        pszSymbolName = msStrdup(psWellKnownName->psChild->pszValue);
+
+      /* default symbol is square */
+
+      if (!pszSymbolName || !*pszSymbolName ||
+          (strcasecmp(pszSymbolName, "square") != 0 &&
+           strcasecmp(pszSymbolName, "circle") != 0 &&
+           strcasecmp(pszSymbolName, "triangle") != 0 &&
+           strcasecmp(pszSymbolName, "star") != 0 &&
+           strcasecmp(pszSymbolName, "cross") != 0 &&
+           strcasecmp(pszSymbolName, "x") != 0)) {
+        if (!pszSymbolName || !*pszSymbolName ||
+            msGetSymbolIndex(&map->symbolset, pszSymbolName, MS_FALSE) < 0) {
+          msFree(pszSymbolName);
+          pszSymbolName = msStrdup("square");
+        }
+      }
+
+      /* check if the symbol should be filled or not */
+      psFill = CPLGetXMLNode(psMark, "Fill");
+      psStroke = CPLGetXMLNode(psMark, "Stroke");
+
+      if (psFill || psStroke) {
+        if (psFill)
+          bFilled = 1;
+        else
+          bFilled = 0;
+
+        if (psFill) {
+          psCssParam = CPLGetXMLNode(psFill, "CssParameter");
+          /*sld 1.1 used SvgParameter*/
+          if (psCssParam == NULL)
+            psCssParam = CPLGetXMLNode(psFill, "SvgParameter");
+
+          while (psCssParam && psCssParam->pszValue &&
+                 (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
+                  strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
+            psName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+            if (psName && strcasecmp(psName, "fill") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                        MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+              }
+            } else if (psName && strcasecmp(psName, "fill-opacity") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                psValue = psCssParam->psChild->psNext->pszValue;
+                if (psValue) {
+                  psStyle->color.alpha = (int)(atof(psValue) * 255);
+                }
+              }
+            }
+
+            psCssParam = psCssParam->psNext;
+          }
+        }
+        if (psStroke) {
+          psCssParam = CPLGetXMLNode(psStroke, "CssParameter");
+          /*sld 1.1 used SvgParameter*/
+          if (psCssParam == NULL)
+            psCssParam = CPLGetXMLNode(psStroke, "SvgParameter");
+
+          while (psCssParam && psCssParam->pszValue &&
+                 (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
+                  strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
+            psName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+            if (psName && strcasecmp(psName, "stroke") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                if (bFilled) {
+                  msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                          MS_STYLE_BINDING_OUTLINECOLOR,
+                                          MS_OBJ_STYLE);
+                } else {
+                  msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                          MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+                }
+              }
+            } else if (psName && strcasecmp(psName, "stroke-opacity") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                psValue = psCssParam->psChild->psNext->pszValue;
+                if (psValue) {
+                  if (bFilled) {
+                    psStyle->outlinecolor.alpha = (int)(atof(psValue) * 255);
+                  } else {
+                    psStyle->color.alpha = (int)(atof(psValue) * 255);
+                  }
+                }
+              }
+            } else if (psName && strcasecmp(psName, "stroke-width") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                        MS_STYLE_BINDING_WIDTH, MS_OBJ_STYLE);
+              }
+            }
+
+            psCssParam = psCssParam->psNext;
+          }
+        }
+      }
+      /* set the default color if color is not not already set */
+      if ((psStyle->color.red < 0 || psStyle->color.green == -1 ||
+           psStyle->color.blue == -1) &&
+          (psStyle->outlinecolor.red == -1 ||
+           psStyle->outlinecolor.green == -1 ||
+           psStyle->outlinecolor.blue == -1)) {
+        psStyle->color.red = 128;
+        psStyle->color.green = 128;
+        psStyle->color.blue = 128;
+      }
+
+      /* Get the corresponding symbol id  */
+      psStyle->symbol = msSLDGetMarkSymbol(map, pszSymbolName, bFilled);
+      if (psStyle->symbol > 0 && psStyle->symbol < map->symbolset.numsymbols)
+        psStyle->symbolname =
+            msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
+
+    } else {
+      psExternalGraphic = CPLGetXMLNode(psGraphic, "ExternalGraphic");
+      if (psExternalGraphic)
+        msSLDParseExternalGraphic(psExternalGraphic, psStyle, map);
+    }
+    msFree(pszSymbolName);
+  }
+  psGap = CPLGetXMLNode(psRoot, "Gap");
+  if (psGap && psGap->psChild && psGap->psChild->pszValue) {
+    psStyle->gap = atof(psGap->psChild->pszValue);
+  }
+  psInitialGap = CPLGetXMLNode(psRoot, "InitialGap");
+  if (psInitialGap && psInitialGap->psChild &&
+      psInitialGap->psChild->pszValue) {
+    psStyle->initialgap = atof(psInitialGap->psChild->pszValue);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                            msSLDGetMarkSymbol                        */
+/*                                                                      */
+/*      Get a Mark symbol using the name. Mark symbols can be           */
+/*      square, circle, triangle, star, cross, x.                       */
+/*      If the symbol does not exist add it to the symbol list.        */
+/************************************************************************/
+int msSLDGetMarkSymbol(mapObj *map, char *pszSymbolName, int bFilled) {
+  int nSymbolId = 0;
+  symbolObj *psSymbol = NULL;
+
+  if (!map || !pszSymbolName)
+    return 0;
+
+  if (strcasecmp(pszSymbolName, "square") == 0) {
+    if (bFilled)
+      nSymbolId = msGetSymbolIndex(&map->symbolset,
+                                   SLD_MARK_SYMBOL_SQUARE_FILLED, MS_FALSE);
+    else
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_SQUARE, MS_FALSE);
+  } else if (strcasecmp(pszSymbolName, "circle") == 0) {
+
+    if (bFilled)
+      nSymbolId = msGetSymbolIndex(&map->symbolset,
+                                   SLD_MARK_SYMBOL_CIRCLE_FILLED, MS_FALSE);
+    else
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_CIRCLE, MS_FALSE);
+  } else if (strcasecmp(pszSymbolName, "triangle") == 0) {
+
+    if (bFilled)
+      nSymbolId = msGetSymbolIndex(&map->symbolset,
+                                   SLD_MARK_SYMBOL_TRIANGLE_FILLED, MS_FALSE);
+    else
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_TRIANGLE, MS_FALSE);
+  } else if (strcasecmp(pszSymbolName, "star") == 0) {
+
+    if (bFilled)
+      nSymbolId = msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_STAR_FILLED,
+                                   MS_FALSE);
+    else
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_STAR, MS_FALSE);
+  } else if (strcasecmp(pszSymbolName, "cross") == 0) {
+
+    if (bFilled)
+      nSymbolId = msGetSymbolIndex(&map->symbolset,
+                                   SLD_MARK_SYMBOL_CROSS_FILLED, MS_FALSE);
+    else
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_CROSS, MS_FALSE);
+  } else if (strcasecmp(pszSymbolName, "x") == 0) {
+
+    if (bFilled)
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_X_FILLED, MS_FALSE);
+    else
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_X, MS_FALSE);
+  } else {
+    nSymbolId = msGetSymbolIndex(&map->symbolset, pszSymbolName, MS_FALSE);
+  }
+
+  if (nSymbolId <= 0) {
+    if ((psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
+      return 0; /* returns 0 for no symbol */
+
+    nSymbolId = map->symbolset.numsymbols;
+    map->symbolset.numsymbols++;
+    initSymbol(psSymbol);
+    psSymbol->inmapfile = MS_TRUE;
+    psSymbol->sizex = 1;
+    psSymbol->sizey = 1;
+
+    if (strcasecmp(pszSymbolName, "square") == 0) {
+      if (bFilled)
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_SQUARE_FILLED);
+      else
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_SQUARE);
+
+      psSymbol->type = MS_SYMBOL_VECTOR;
+      if (bFilled)
+        psSymbol->filled = MS_TRUE;
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 0;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 0;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+    } else if (strcasecmp(pszSymbolName, "circle") == 0) {
+      if (bFilled)
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CIRCLE_FILLED);
+      else
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CIRCLE);
+
+      psSymbol->type = MS_SYMBOL_ELLIPSE;
+      if (bFilled)
+        psSymbol->filled = MS_TRUE;
+
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->sizex = 1;
+      psSymbol->sizey = 1;
+      psSymbol->numpoints++;
+    } else if (strcasecmp(pszSymbolName, "triangle") == 0) {
+      if (bFilled)
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_TRIANGLE_FILLED);
+      else
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_TRIANGLE);
+
+      psSymbol->type = MS_SYMBOL_VECTOR;
+      if (bFilled)
+        psSymbol->filled = MS_TRUE;
+
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.5;
+      psSymbol->points[psSymbol->numpoints].y = 0;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+
+    } else if (strcasecmp(pszSymbolName, "star") == 0) {
+      if (bFilled)
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_STAR_FILLED);
+      else
+        psSymbol->name = msStrdup(SLD_MARK_SYMBOL_STAR);
+
+      psSymbol->type = MS_SYMBOL_VECTOR;
+      if (bFilled)
+        psSymbol->filled = MS_TRUE;
+
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 0.375;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.35;
+      psSymbol->points[psSymbol->numpoints].y = 0.375;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.5;
+      psSymbol->points[psSymbol->numpoints].y = 0;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.65;
+      psSymbol->points[psSymbol->numpoints].y = 0.375;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 0.375;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.75;
+      psSymbol->points[psSymbol->numpoints].y = 0.625;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.875;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.5;
+      psSymbol->points[psSymbol->numpoints].y = 0.75;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.125;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.25;
+      psSymbol->points[psSymbol->numpoints].y = 0.625;
+      psSymbol->numpoints++;
+    }
+    /* cross is like plus (+) since there is also X symbol ?? */
+    else if (strcasecmp(pszSymbolName, "cross") == 0) {
+      /* NEVER FILL CROSS */
+      /* if (bFilled) */
+      /* psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CROSS_FILLED); */
+      /* else */
+      psSymbol->name = msStrdup(SLD_MARK_SYMBOL_CROSS);
+
+      psSymbol->type = MS_SYMBOL_VECTOR;
+      /* if (bFilled) */
+      /* psSymbol->filled = MS_TRUE; */
+
+      psSymbol->points[psSymbol->numpoints].x = 0.5;
+      psSymbol->points[psSymbol->numpoints].y = 0;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0.5;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = -99;
+      psSymbol->points[psSymbol->numpoints].y = -99;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 0.5;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 0.5;
+      psSymbol->numpoints++;
+    } else if (strcasecmp(pszSymbolName, "x") == 0) {
+      /* NEVER FILL X */
+      /* if (bFilled) */
+      /* psSymbol->name = msStrdup(SLD_MARK_SYMBOL_X_FILLED); */
+      /* else */
+      psSymbol->name = msStrdup(SLD_MARK_SYMBOL_X);
+
+      psSymbol->type = MS_SYMBOL_VECTOR;
+      /* if (bFilled) */
+      /* psSymbol->filled = MS_TRUE; */
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 0;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = -99;
+      psSymbol->points[psSymbol->numpoints].y = -99;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 0;
+      psSymbol->points[psSymbol->numpoints].y = 1;
+      psSymbol->numpoints++;
+      psSymbol->points[psSymbol->numpoints].x = 1;
+      psSymbol->points[psSymbol->numpoints].y = 0;
+      psSymbol->numpoints++;
+    }
+  }
+
+  return nSymbolId;
+}
+
+/************************************************************************/
+/*                          msSLDGetGraphicSymbol                       */
+/*                                                                      */
+/*      Create a symbol entry for an inmap pixmap symbol. Returns       */
+/*      the symbol id.                                                  */
+/************************************************************************/
+int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName, char *extGraphicName,
+                          int nGap_ignored) {
+  (void)nGap_ignored;
+  int nSymbolId = 0;
+  symbolObj *psSymbol = NULL;
+
+  if (map && pszFileName) {
+    if ((psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
+      return 0; /* returns 0 for no symbol */
+    nSymbolId = map->symbolset.numsymbols;
+    map->symbolset.numsymbols++;
+    initSymbol(psSymbol);
+    psSymbol->inmapfile = MS_TRUE;
+    psSymbol->type = MS_SYMBOL_PIXMAP;
+    psSymbol->name = msStrdup(extGraphicName);
+    psSymbol->imagepath = msStrdup(pszFileName);
+    psSymbol->full_pixmap_path = msStrdup(pszFileName);
+  }
+  return nSymbolId;
+}
+
+/************************************************************************/
+/*      msSLDParsePointSymbolizer                                       */
+/*                                                                      */
+/*      Parse point symbolizer.                                         */
+/*                                                                      */
+/*      <xs:element name="PointSymbolizer">                             */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
+/*      <xs:element ref="sld:Graphic" minOccurs="0"/>                   */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/************************************************************************/
+int msSLDParsePointSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                              int bNewClass, const char *pszUserStyleName) {
+  int nClassId = 0;
+  int iStyle = 0;
+
+  if (!psRoot || !psLayer)
+    return MS_FAILURE;
+
+  nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
+  if (nClassId < 0)
+    return MS_FAILURE;
+
+  // Get uom if any, defaults to MS_PIXELS
+  enum MS_UNITS sizeunits = MS_PIXELS;
+  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS) {
+    msSetError(MS_WMSERR, "Invalid uom attribute value.",
+               "msSLDParsePolygonSymbolizer()");
+    return MS_FAILURE;
+  }
+
+  iStyle = psLayer->_class[nClassId]->numstyles;
+  msMaybeAllocateClassStyle(psLayer->_class[nClassId], iStyle);
+  psLayer->_class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
+
+  msSLDParseGraphicFillOrStroke(
+      psRoot, NULL, psLayer->_class[nClassId]->styles[iStyle], psLayer->map);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                        msSLDParseExternalGraphic                     */
+/*                                                                      */
+/*      Parse external graphic node : download the symbol referenced    */
+/*      by the URL and create a PIXMAP inmap symbol. Only GIF and       */
+/*      PNG are supported.                                              */
+/************************************************************************/
+int msSLDParseExternalGraphic(CPLXMLNode *psExternalGraphic, styleObj *psStyle,
+                              mapObj *map) {
+  char *pszFormat = NULL;
+  CPLXMLNode *psURL = NULL, *psFormat = NULL, *psTmp = NULL;
+  char *pszURL = NULL;
+
+  if (!psExternalGraphic || !psStyle || !map)
+    return MS_FAILURE;
+
+  psFormat = CPLGetXMLNode(psExternalGraphic, "Format");
+  if (psFormat && psFormat->psChild && psFormat->psChild->pszValue)
+    pszFormat = psFormat->psChild->pszValue;
+
+  /* supports GIF and PNG and SVG */
+  if (pszFormat && (strcasecmp(pszFormat, "GIF") == 0 ||
+                    strcasecmp(pszFormat, "image/gif") == 0 ||
+                    strcasecmp(pszFormat, "PNG") == 0 ||
+                    strcasecmp(pszFormat, "image/png") == 0 ||
+                    strcasecmp(pszFormat, "image/svg+xml") == 0)) {
+
+    /* <OnlineResource xmlns:xlink="http://www.w3.org/1999/xlink"
+     * xlink:type="simple" xlink:href="http://www.vendor.com/geosym/2267.svg"/>
+     */
+    psURL = CPLGetXMLNode(psExternalGraphic, "OnlineResource");
+    if (psURL && psURL->psChild) {
+      psTmp = psURL->psChild;
+      while (psTmp != NULL && psTmp->pszValue &&
+             strcasecmp(psTmp->pszValue, "xlink:href") != 0) {
+        psTmp = psTmp->psNext;
+      }
+      if (psTmp && psTmp->psChild) {
+        pszURL = (char *)psTmp->psChild->pszValue;
+
+        char *symbolurl = NULL;
+        // Handle relative URL for ExternalGraphic
+        if (map->sldurl && !strstr(pszURL, "://")) {
+          char *baseurl = NULL;
+          char *relpath = NULL;
+          symbolurl = static_cast<char *>(malloc(sizeof(char) * MS_MAXPATHLEN));
+          if (pszURL[0] != '/') {
+            // Symbol file is relative to SLD file
+            // e.g. SLD   : http://example.com/path/to/sld.xml
+            //  and symbol: assets/symbol.svg
+            //     lead to: http://example.com/path/to/assets/symbol.svg
+            baseurl = msGetPath(map->sldurl);
+            relpath = pszURL;
+          } else {
+            // Symbol file is relative to the root of SLD server
+            // e.g. SLD   : http://example.com/path/to/sld.xml
+            //  and symbol: /path/to/assets/symbol.svg
+            //     lead to: http://example.com/path/to/assets/symbol.svg
+            baseurl = msStrdup(map->sldurl);
+            relpath = pszURL + 1;
+            char *sep = strstr(baseurl, "://");
+            if (sep)
+              sep += 3;
+            else
+              sep = baseurl;
+            sep = strchr(sep, '/');
+            if (!sep)
+              sep = baseurl + strlen(baseurl);
+            sep[1] = '\0';
+          }
+          msBuildPath(symbolurl, baseurl, relpath);
+          msFree(baseurl);
+        } else {
+          // Absolute URL
+          // e.g. symbol: http://example.com/path/to/assets/symbol.svg
+          symbolurl = msStrdup(pszURL);
+        }
+
+        /* validate the ExternalGraphic parameter */
+        if (msValidateParameter(symbolurl,
+                                msLookupHashTable(&(map->web.validation),
+                                                  "sld_external_graphic"),
+                                NULL, NULL, NULL) != MS_SUCCESS) {
+          msSetError(MS_WEBERR,
+                     "SLD ExternalGraphic OnlineResource value fails to "
+                     "validate against sld_external_graphic VALIDATION",
+                     "mapserv()");
+          msFree(symbolurl);
+          return MS_FAILURE;
+        }
+
+        /*external symbols using http will be automaticallly downloaded. The
+          file should be saved in a temporary directory (msAddImageSymbol)
+          #2305*/
+        psStyle->symbol = msGetSymbolIndex(&map->symbolset, symbolurl, MS_TRUE);
+        msFree(symbolurl);
+
+        if (psStyle->symbol > 0 && psStyle->symbol < map->symbolset.numsymbols)
+          psStyle->symbolname =
+              msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
+
+        /* set the color parameter if not set. Does not make sense */
+        /* for pixmap but mapserver needs it. */
+        if (psStyle->color.red == -1 || psStyle->color.green ||
+            psStyle->color.blue) {
+          psStyle->color.red = 0;
+          psStyle->color.green = 0;
+          psStyle->color.blue = 0;
+        }
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                         msSLDParseTextSymbolizer                     */
+/*                                                                      */
+/*      Parse text symbolizer.                                          */
+/*                                                                      */
+/*      <xs:element name="TextSymbolizer">                              */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
+/*      <xs:element ref="sld:Label" minOccurs="0"/>                     */
+/*      <xs:element ref="sld:Font" minOccurs="0"/>                      */
+/*      <xs:element ref="sld:LabelPlacement" minOccurs="0"/>            */
+/*      <xs:element ref="sld:Halo" minOccurs="0"/>                      */
+/*      <xs:element ref="sld:Fill" minOccurs="0"/>                      */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      <xs:element name="Label" type="sld:ParameterValueType"/         */
+/*                                                                      */
+/*      <xs:element name="Font">                                        */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:CssParameter" minOccurs="0"                */
+/*      maxOccurs="unbounded"/>                                         */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      Four types of CssParameter are allowed, font-family, font-style,*/
+/*      fontweight,and font-size.                                       */
+/*                                                                      */
+/*      <xs:element name="LabelPlacement">                              */
+/*      <xs:complexType>                                                */
+/*      <xs:choice>                                                     */
+/*      <xs:element ref="sld:PointPlacement"/>                          */
+/*      <xs:element ref="sld:LinePlacement"/>                           */
+/*      </xs:choice>                                                    */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      <xs:element name="PointPlacement">                              */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:AnchorPoint" minOccurs="0"/>               */
+/*      <xs:element ref="sld:Displacement" minOccurs="0"/>              */
+/*      <xs:element ref="sld:Rotation" minOccurs="0"/>                  */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      <xs:element name="AnchorPoint">                                 */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:AnchorPointX"/>                            */
+/*      <xs:element ref="sld:AnchorPointY"/>                            */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*      <xs:element name="AnchorPointX" type="sld:ParameterValueType"/> */
+/*      <xs:element name="AnchorPointY"                                 */
+/*      type="sld:ParameterValueType"/>                                 */
+/*                                                                      */
+/*      The coordinates are given as two floating-point numbers in      */
+/*      the AnchorPointX and AnchorPointY elements each with values     */
+/*      between 0.0 and 1.0 inclusive. The bounding box of the label    */
+/*      to be rendered is considered to be in a coorindate space        */
+/*      from 0.0 (lowerleft corner) to 1.0 (upper-right corner), and    */
+/*      the anchor position is specified as a point in  this            */
+/*      space. The default point is X=0, Y=0.5, which is at the         */
+/*      middle height of the lefthand side of the label.                */
+/*                                                                      */
+/*      <xs:element name="Displacement">                                */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:DisplacementX"/>                           */
+/*      <xs:element ref="sld:DisplacementY"/>                           */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*      <xs:element name="DisplacementX" type="sld:ParameterValueType"/>*/
+/*      <xs:element name="DisplacementY"                                */
+/*      type="sld:ParameterValueType"/>                                 */
+/*                                                                      */
+/*      <xs:element name="LinePlacement">                               */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:PerpendicularOffset" minOccurs="0"/>       */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/************************************************************************/
+int msSLDParseTextSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                             int bOtherSymboliser,
+                             const char *pszUserStyleName) {
+  int nStyleId = 0, nClassId = 0;
+
+  if (!psRoot || !psLayer)
+    return MS_FAILURE;
+
+  if (!bOtherSymboliser) {
+    if (msGrowLayerClasses(psLayer) == NULL)
+      return MS_FAILURE;
+    initClass(psLayer->_class[psLayer->numclasses]);
+    nClassId = psLayer->numclasses;
+    if (pszUserStyleName)
+      psLayer->_class[nClassId]->group = msStrdup(pszUserStyleName);
+    psLayer->numclasses++;
+    msMaybeAllocateClassStyle(psLayer->_class[nClassId], 0);
+    nStyleId = 0;
+  } else {
+    nClassId = psLayer->numclasses - 1;
+    if (nClassId >= 0) /* should always be true */
+      nStyleId = psLayer->_class[nClassId]->numstyles - 1;
+  }
+
+  if (nStyleId >= 0 && nClassId >= 0) /* should always be true */
+    msSLDParseTextParams(psRoot, psLayer, psLayer->_class[nClassId]);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                        msSLDParseRasterSymbolizer                    */
+/*                                                                      */
+/*      Supports the ColorMap parameter in a Raster Symbolizer. In      */
+/*      the ColorMap, only color and quantity are used here.            */
+/*                                                                      */
+/*      <xs:element name="RasterSymbolizer">                            */
+/*      <xs:complexType>                                                */
+/*      <xs:sequence>                                                   */
+/*      <xs:element ref="sld:Geometry" minOccurs="0"/>                  */
+/*      <xs:element ref="sld:Opacity" minOccurs="0"/>                   */
+/*      <xs:element ref="sld:ChannelSelection" minOccurs="0"/>          */
+/*      <xs:element ref="sld:OverlapBehavior" minOccurs="0"/>           */
+/*      <xs:element ref="sld:ColorMap" minOccurs="0"/>                  */
+/*      <xs:element ref="sld:ContrastEnhancement" minOccurs="0"/>       */
+/*      <xs:element ref="sld:ShadedRelief" minOccurs="0"/>              */
+/*      <xs:element ref="sld:ImageOutline" minOccurs="0"/>              */
+/*      </xs:sequence>                                                  */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      <xs:element name="ColorMap">                                    */
+/*      <xs:complexType>                                                */
+/*      <xs:choice minOccurs="0" maxOccurs="unbounded">                 */
+/*      <xs:element ref="sld:ColorMapEntry"/>                           */
+/*      </xs:choice>                                                    */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*      <xs:element name="ColorMapEntry">                               */
+/*      <xs:complexType>                                                */
+/*      <xs:attribute name="color" type="xs:string" use="required"/>    */
+/*      <xs:attribute name="opacity" type="xs:double"/>                 */
+/*      <xs:attribute name="quantity" type="xs:double"/>                */
+/*      <xs:attribute name="label" type="xs:string"/>                   */
+/*      </xs:complexType>                                               */
+/*      </xs:element>                                                   */
+/*                                                                      */
+/*      SLD 1.1                                                         */
+/*                                                                      */
+/*      <xsd:element name="RasterSymbolizer" type="se:RasterSymbolizerType"
+ * substitutionGroup="se:Symbolizer"/>*/
+/*      <xsd:complexType name="RasterSymbolizerType">                   */
+/*      <xsd:complexContent>                                            */
+/*      <xsd:extension base="se:SymbolizerType">                        */
+/*      <xsd:sequence>                                                  */
+/*      <xsd:element ref="se:Geometry" minOccurs="0"/>                  */
+/*      <xsd:element ref="se:Opacity" minOccurs="0"/>                   */
+/*      <xsd:element ref="se:ChannelSelection" minOccurs="0"/>          */
+/*      <xsd:element ref="se:OverlapBehavior" minOccurs="0"/>           */
+/*      <xsd:element ref="se:ColorMap" minOccurs="0"/>                  */
+/*      <xsd:element ref="se:ContrastEnhancement" minOccurs="0"/>       */
+/*      <xsd:element ref="se:ShadedRelief" minOccurs="0"/>              */
+/*      <xsd:element ref="se:ImageOutline" minOccurs="0"/>              */
+/*      </xsd:sequence>                                                 */
+/*      </xsd:extension>                                                */
+/*      </xsd:complexContent>                                           */
+/*      </xsd:complexType>                                              */
+/*                                                                      */
+/*      <xsd:element name="ColorMap" type="se:ColorMapType"/>           */
+/*      <xsd:complexType name="ColorMapType">                           */
+/*      <xsd:choice>                                                    */
+/*      <xsd:element ref="se:Categorize"/>                              */
+/*      <xsd:element ref="se:Interpolate"/>                             */
+/*      </xsd:choice>                                                   */
+/*      </xsd:complexType>                                              */
+/*                                                                      */
+/*      <xsd:element name="Categorize" type="se:CategorizeType"
+ * substitutionGroup="se:Function"/>*/
+/*      <xsd:complexType name="CategorizeType">                         */
+/*      <xsd:complexContent>                                            */
+/*      <xsd:extension base="se:FunctionType">                          */
+/*      <xsd:sequence>                                                  */
+/*      <xsd:element ref="se:LookupValue"/>                             */
+/*      <xsd:element ref="se:Value"/>                                   */
+/*      <xsd:sequence minOccurs="0" maxOccurs="unbounded">              */
+/*      <xsd:element ref="se:Threshold"/>                               */
+/*      <xsd:element ref="se:Value"/>                                   */
+/*      </xsd:sequence>                                                 */
+/*      </xsd:sequence>                                                 */
+/*      <xsd:attribute name="threshholdsBelongTo"
+ * type="se:ThreshholdsBelongToType" use="optional"/>*/
+/*      </xsd:extension>                                                */
+/*      </xsd:complexContent>                                           */
+/*      </xsd:complexType>                                              */
+/*      <xsd:element name="LookupValue" type="se:ParameterValueType"/>  */
+/*      <xsd:element name="Value" type=" se:ParameterValueType"/>       */
+/*      <xsd:element name="Threshold" type=" se:ParameterValueType"/>   */
+/*      <xsd:simpleType name="ThreshholdsBelongToType">                 */
+/*      <xsd:restriction base="xsd:token">                              */
+/*      <xsd:enumeration value="succeeding"/>                           */
+/*      <xsd:enumeration value="preceding"/>                            */
+/*      </xsd:restriction>                                              */
+/*      </xsd:simpleType>                                               */
+/*                                                                      */
+/************************************************************************/
+int msSLDParseRasterSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                               const char *pszUserStyleName) {
+  CPLXMLNode *psColorMap = NULL, *psColorEntry = NULL, *psOpacity = NULL;
+  char *pszColor = NULL, *pszQuantity = NULL;
+  char *pszPreviousColor = NULL, *pszPreviousQuality = NULL;
+  colorObj sColor;
+  char szExpression[100];
+  double dfOpacity = 1.0;
+  char *pszLabel = NULL, *pszPreviousLabel = NULL;
+  char *pch = NULL, *pchPrevious = NULL;
+
+  CPLXMLNode *psNode = NULL, *psCategorize = NULL;
+  char *pszTmp = NULL;
+  int nValues = 0, nThresholds = 0;
+  int i, nMaxValues = 100, nMaxThreshold = 100;
+
+  if (!psRoot || !psLayer)
+    return MS_FAILURE;
+
+  psOpacity = CPLGetXMLNode(psRoot, "Opacity");
+  if (psOpacity) {
+    if (psOpacity->psChild && psOpacity->psChild->pszValue)
+      dfOpacity = atof(psOpacity->psChild->pszValue);
+
+    /* values in sld goes from 0.0 (for transparent) to 1.0 (for full opacity);
+     */
+    if (dfOpacity >= 0.0 && dfOpacity <= 1.0)
+      msSetLayerOpacity(psLayer, (int)(dfOpacity * 100));
+    else {
+      msSetError(MS_WMSERR,
+                 "Invalid opacity value. Values should be between 0.0 and 1.0",
+                 "msSLDParseRasterSymbolizer()");
+      return MS_FAILURE;
+    }
+  }
+  psColorMap = CPLGetXMLNode(psRoot, "ColorMap");
+  if (psColorMap) {
+    psColorEntry = CPLGetXMLNode(psColorMap, "ColorMapEntry");
+
+    if (psColorEntry) { /*SLD 1.0*/
+      while (psColorEntry && psColorEntry->pszValue &&
+             strcasecmp(psColorEntry->pszValue, "ColorMapEntry") == 0) {
+        pszColor = (char *)CPLGetXMLValue(psColorEntry, "color", NULL);
+        pszQuantity = (char *)CPLGetXMLValue(psColorEntry, "quantity", NULL);
+        pszLabel = (char *)CPLGetXMLValue(psColorEntry, "label", NULL);
+
+        if (pszColor && pszQuantity) {
+          if (pszPreviousColor && pszPreviousQuality) {
+            if (strlen(pszPreviousColor) == 7 && pszPreviousColor[0] == '#' &&
+                strlen(pszColor) == 7 && pszColor[0] == '#') {
+              sColor.red = msHexToInt(pszPreviousColor + 1);
+              sColor.green = msHexToInt(pszPreviousColor + 3);
+              sColor.blue = msHexToInt(pszPreviousColor + 5);
+
+              /* pszQuantity and pszPreviousQuality may be integer or float */
+              pchPrevious = strchr(pszPreviousQuality, '.');
+              pch = strchr(pszQuantity, '.');
+              if (pchPrevious == NULL && pch == NULL) {
+                snprintf(szExpression, sizeof(szExpression),
+                         "([pixel] >= %d AND [pixel] < %d)",
+                         atoi(pszPreviousQuality), atoi(pszQuantity));
+              } else if (pchPrevious != NULL && pch == NULL) {
+                snprintf(szExpression, sizeof(szExpression),
+                         "([pixel] >= %f AND [pixel] < %d)",
+                         atof(pszPreviousQuality), atoi(pszQuantity));
+              } else if (pchPrevious == NULL && pch != NULL) {
+                snprintf(szExpression, sizeof(szExpression),
+                         "([pixel] >= %d AND [pixel] < %f)",
+                         atoi(pszPreviousQuality), atof(pszQuantity));
+              } else {
+                snprintf(szExpression, sizeof(szExpression),
+                         "([pixel] >= %f AND [pixel] < %f)",
+                         atof(pszPreviousQuality), atof(pszQuantity));
+              }
+
+              if (msGrowLayerClasses(psLayer) == NULL)
+                return MS_FAILURE;
+              else {
+                initClass(psLayer->_class[psLayer->numclasses]);
+                psLayer->numclasses++;
+                const int nClassId = psLayer->numclasses - 1;
+                if (pszUserStyleName)
+                  psLayer->_class[nClassId]->group = msStrdup(pszUserStyleName);
+
+                /*set the class name using the label. If label not defined
+                  set it with the quantity*/
+                if (pszPreviousLabel)
+                  psLayer->_class[nClassId]->name = msStrdup(pszPreviousLabel);
+                else
+                  psLayer->_class[nClassId]->name =
+                      msStrdup(pszPreviousQuality);
+
+                msMaybeAllocateClassStyle(psLayer->_class[nClassId], 0);
+
+                psLayer->_class[nClassId]->styles[0]->color.red = sColor.red;
+                psLayer->_class[nClassId]->styles[0]->color.green =
+                    sColor.green;
+                psLayer->_class[nClassId]->styles[0]->color.blue = sColor.blue;
+
+                if (!psLayer->classitem ||
+                    strcasecmp(psLayer->classitem, "[pixel]") != 0) {
+                  free(psLayer->classitem);
+                  psLayer->classitem = msStrdup("[pixel]");
+                }
+
+                msLoadExpressionString(&psLayer->_class[nClassId]->expression,
+                                       szExpression);
+              }
+            } else {
+              msSetError(MS_WMSERR, "Invalid ColorMap Entry.",
+                         "msSLDParseRasterSymbolizer()");
+              return MS_FAILURE;
+            }
+          }
+
+          pszPreviousColor = pszColor;
+          pszPreviousQuality = pszQuantity;
+          pszPreviousLabel = pszLabel;
+        }
+        psColorEntry = psColorEntry->psNext;
+      }
+      /* do the last Color Map Entry */
+      if (pszColor && pszQuantity) {
+        if (strlen(pszColor) == 7 && pszColor[0] == '#') {
+          sColor.red = msHexToInt(pszColor + 1);
+          sColor.green = msHexToInt(pszColor + 3);
+          sColor.blue = msHexToInt(pszColor + 5);
+
+          /* pszQuantity may be integer or float */
+          pch = strchr(pszQuantity, '.');
+          if (pch == NULL) {
+            snprintf(szExpression, sizeof(szExpression), "([pixel] = %d)",
+                     atoi(pszQuantity));
+          } else {
+            snprintf(szExpression, sizeof(szExpression), "([pixel] = %f)",
+                     atof(pszQuantity));
+          }
+
+          if (msGrowLayerClasses(psLayer) == NULL)
+            return MS_FAILURE;
+          else {
+            initClass(psLayer->_class[psLayer->numclasses]);
+            psLayer->numclasses++;
+            const int nClassId = psLayer->numclasses - 1;
+            if (pszUserStyleName)
+              psLayer->_class[nClassId]->group = msStrdup(pszUserStyleName);
+
+            msMaybeAllocateClassStyle(psLayer->_class[nClassId], 0);
+            if (pszLabel)
+              psLayer->_class[nClassId]->name = msStrdup(pszLabel);
+            else
+              psLayer->_class[nClassId]->name = msStrdup(pszQuantity);
+            psLayer->_class[nClassId]->numstyles = 1;
+            psLayer->_class[nClassId]->styles[0]->color.red = sColor.red;
+            psLayer->_class[nClassId]->styles[0]->color.green = sColor.green;
+            psLayer->_class[nClassId]->styles[0]->color.blue = sColor.blue;
+
+            if (!psLayer->classitem ||
+                strcasecmp(psLayer->classitem, "[pixel]") != 0) {
+              free(psLayer->classitem);
+              psLayer->classitem = msStrdup("[pixel]");
+            }
+
+            msLoadExpressionString(&psLayer->_class[nClassId]->expression,
+                                   szExpression);
+          }
+        }
+      }
+    } else if ((psCategorize = CPLGetXMLNode(psColorMap, "Categorize"))) {
+      char **papszValues = (char **)msSmallMalloc(sizeof(char *) * nMaxValues);
+      char **papszThresholds =
+          (char **)msSmallMalloc(sizeof(char *) * nMaxThreshold);
+      psNode = CPLGetXMLNode(psCategorize, "Value");
+      while (psNode && psNode->pszValue && psNode->psChild &&
+             psNode->psChild->pszValue)
+
+      {
+        if (strcasecmp(psNode->pszValue, "Value") == 0) {
+          papszValues[nValues] = psNode->psChild->pszValue;
+          nValues++;
+          if (nValues == nMaxValues) {
+            nMaxValues += 100;
+            papszValues = (char **)msSmallRealloc(papszValues,
+                                                  sizeof(char *) * nMaxValues);
+          }
+        } else if (strcasecmp(psNode->pszValue, "Threshold") == 0) {
+          papszThresholds[nThresholds] = psNode->psChild->pszValue;
+          nThresholds++;
+          if (nValues == nMaxThreshold) {
+            nMaxThreshold += 100;
+            papszThresholds = (char **)msSmallRealloc(
+                papszThresholds, sizeof(char *) * nMaxThreshold);
+          }
+        }
+        psNode = psNode->psNext;
+      }
+
+      if (nThresholds > 0 && nValues == nThresholds + 1) {
+        /*free existing classes*/
+        for (i = 0; i < psLayer->numclasses; i++) {
+          if (psLayer->_class[i] != NULL) {
+            psLayer->_class[i]->layer = NULL;
+            if (freeClass(psLayer->_class[i]) == MS_SUCCESS) {
+              msFree(psLayer->_class[i]);
+              psLayer->_class[i] = NULL;
+            }
+          }
+        }
+        psLayer->numclasses = 0;
+        for (i = 0; i < nValues; i++) {
+          pszTmp = (papszValues[i]);
+          if (pszTmp && strlen(pszTmp) == 7 && pszTmp[0] == '#') {
+            sColor.red = msHexToInt(pszTmp + 1);
+            sColor.green = msHexToInt(pszTmp + 3);
+            sColor.blue = msHexToInt(pszTmp + 5);
+            if (i == 0) {
+              if (strchr(papszThresholds[i], '.'))
+                snprintf(szExpression, sizeof(szExpression), "([pixel] < %f)",
+                         atof(papszThresholds[i]));
+              else
+                snprintf(szExpression, sizeof(szExpression), "([pixel] < %d)",
+                         atoi(papszThresholds[i]));
+
+            } else if (i < nValues - 1) {
+              if (strchr(papszThresholds[i], '.'))
+                snprintf(szExpression, sizeof(szExpression),
+                         "([pixel] >= %f AND [pixel] < %f)",
+                         atof(papszThresholds[i - 1]),
+                         atof(papszThresholds[i]));
+              else
+                snprintf(szExpression, sizeof(szExpression),
+                         "([pixel] >= %d AND [pixel] < %d)",
+                         atoi(papszThresholds[i - 1]),
+                         atoi(papszThresholds[i]));
+            } else {
+              if (strchr(papszThresholds[i - 1], '.'))
+                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %f)",
+                         atof(papszThresholds[i - 1]));
+              else
+                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %d)",
+                         atoi(papszThresholds[i - 1]));
+            }
+            if (msGrowLayerClasses(psLayer)) {
+              initClass(psLayer->_class[psLayer->numclasses]);
+              psLayer->numclasses++;
+              const int nClassId = psLayer->numclasses - 1;
+              if (pszUserStyleName)
+                psLayer->_class[nClassId]->group = msStrdup(pszUserStyleName);
+              msMaybeAllocateClassStyle(psLayer->_class[nClassId], 0);
+              psLayer->_class[nClassId]->numstyles = 1;
+              psLayer->_class[nClassId]->styles[0]->color.red = sColor.red;
+              psLayer->_class[nClassId]->styles[0]->color.green = sColor.green;
+              psLayer->_class[nClassId]->styles[0]->color.blue = sColor.blue;
+              if (psLayer->classitem &&
+                  strcasecmp(psLayer->classitem, "[pixel]") != 0)
+                free(psLayer->classitem);
+              psLayer->classitem = msStrdup("[pixel]");
+              msLoadExpressionString(&psLayer->_class[nClassId]->expression,
+                                     szExpression);
+            }
+          }
+        }
+      }
+      msFree(papszValues);
+      msFree(papszThresholds);
+
+    } else {
+      msSetError(MS_WMSERR, "Invalid SLD document. msSLDParseRaster", "");
+      return MS_FAILURE;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+/************************************************************************/
+/*                           msSLDParseTextParams                       */
+/*                                                                      */
+/*      Parse text parameters like font, placement and color.           */
+/************************************************************************/
+int msSLDParseTextParams(CPLXMLNode *psRoot, layerObj *psLayer,
+                         classObj *psClass) {
+  char szFontName[100];
+
+  CPLXMLNode *psLabel = NULL, *psFont = NULL;
+  CPLXMLNode *psCssParam = NULL;
+  char *pszName = NULL, *pszFontFamily = NULL, *pszFontStyle = NULL;
+  char *pszFontWeight = NULL;
+  CPLXMLNode *psLabelPlacement = NULL, *psPointPlacement = NULL,
+             *psLinePlacement = NULL;
+  CPLXMLNode *psFill = NULL, *psHalo = NULL, *psHaloRadius = NULL,
+             *psHaloFill = NULL;
+  labelObj *psLabelObj = NULL;
+  szFontName[0] = '\0';
+
+  if (!psRoot || !psClass || !psLayer)
+    return MS_FAILURE;
+
+  if (psClass->numlabels == 0) {
+    if (msGrowClassLabels(psClass) == NULL)
+      return (MS_FAILURE);
+    initLabel(psClass->labels[0]);
+    psClass->numlabels++;
+  }
+  psLabelObj = psClass->labels[0];
+
+  /*set the angle by default to auto. the angle can be
+    modified Label Placement #2806*/
+  psLabelObj->anglemode = MS_AUTO;
+
+  /* label  */
+  /* support literal expression  and  propertyname
+   - <TextSymbolizer><Label>MY_COLUMN</Label>
+   -
+  <TextSymbolizer><Label><ogc:PropertyName>MY_COLUMN</ogc:PropertyName></Label>
+  Bug 1857 */
+  psLabel = CPLGetXMLNode(psRoot, "Label");
+  if (psLabel) {
+    const char *sep = "";
+    msStringBuffer *classtext = msStringBufferAlloc();
+    msStringBufferAppend(classtext, "(");
+    for (CPLXMLNode *psTmpNode = psLabel->psChild; psTmpNode;
+         psTmpNode = psTmpNode->psNext) {
+      if (psTmpNode->eType == CXT_Text && psTmpNode->pszValue) {
+        msStringBufferAppend(classtext, sep);
+        msStringBufferAppend(classtext, "\"");
+        msStringBufferAppend(classtext, psTmpNode->pszValue);
+        msStringBufferAppend(classtext, "\"");
+        sep = "+";
+      } else if (psTmpNode->eType == CXT_Element &&
+                 strcasecmp(psTmpNode->pszValue, "Literal") == 0 &&
+                 psTmpNode->psChild) {
+        msStringBufferAppend(classtext, sep);
+        msStringBufferAppend(classtext, "\"");
+        msStringBufferAppend(classtext, psTmpNode->psChild->pszValue);
+        msStringBufferAppend(classtext, "\"");
+        sep = "+";
+      } else if (psTmpNode->eType == CXT_Element &&
+                 strcasecmp(psTmpNode->pszValue, "PropertyName") == 0 &&
+                 psTmpNode->psChild) {
+        msStringBufferAppend(classtext, sep);
+        msStringBufferAppend(classtext, "\"[");
+        msStringBufferAppend(classtext, psTmpNode->psChild->pszValue);
+        msStringBufferAppend(classtext, "]\"");
+        sep = "+";
+      } else if (psTmpNode->eType == CXT_Element &&
+                 strcasecmp(psTmpNode->pszValue, "Function") == 0 &&
+                 psTmpNode->psChild) {
+        msStringBufferAppend(classtext, sep);
+        msStringBufferAppend(classtext, "tostring(");
+
+        labelObj tempExpressionCollector;
+        initLabel(&tempExpressionCollector);
+        msSLDParseOgcExpression(psTmpNode, &tempExpressionCollector,
+                                MS_LABEL_BINDING_SIZE, MS_OBJ_LABEL);
+        msStringBufferAppend(
+            classtext,
+            tempExpressionCollector.exprBindings[MS_LABEL_BINDING_SIZE].string);
+        freeLabel(&tempExpressionCollector);
+
+        msStringBufferAppend(classtext, ",\"%g\")");
+        sep = "+";
+      }
+    }
+    msStringBufferAppend(classtext, ")");
+    const char *expressionstring = msStringBufferGetString(classtext);
+    if (strlen(expressionstring) > 2) {
+      msLoadExpressionString(&psClass->text, (char *)expressionstring);
+    }
+    msStringBufferFree(classtext);
+
+    {
+      /* font */
+      psFont = CPLGetXMLNode(psRoot, "Font");
+      if (psFont) {
+        psCssParam = CPLGetXMLNode(psFont, "CssParameter");
+        /*sld 1.1 used SvgParameter*/
+        if (psCssParam == NULL)
+          psCssParam = CPLGetXMLNode(psFont, "SvgParameter");
+
+        while (psCssParam && psCssParam->pszValue &&
+               (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
+                strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
+          pszName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+          if (pszName) {
+            if (strcasecmp(pszName, "font-family") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext &&
+                  psCssParam->psChild->psNext->pszValue)
+                pszFontFamily = psCssParam->psChild->psNext->pszValue;
+            }
+            /* normal, italic, oblique */
+            else if (strcasecmp(pszName, "font-style") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext &&
+                  psCssParam->psChild->psNext->pszValue)
+                pszFontStyle = psCssParam->psChild->psNext->pszValue;
+            }
+            /* normal or bold */
+            else if (strcasecmp(pszName, "font-weight") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext &&
+                  psCssParam->psChild->psNext->pszValue)
+                pszFontWeight = psCssParam->psChild->psNext->pszValue;
+            }
+            /* default is 10 pix */
+            else if (strcasecmp(pszName, "font-size") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                msSLDParseOgcExpression(psCssParam->psChild->psNext, psLabelObj,
+                                        MS_LABEL_BINDING_SIZE, MS_OBJ_LABEL);
+              }
+            }
+          }
+          psCssParam = psCssParam->psNext;
+        }
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      parse the label placement.                                      */
+      /* -------------------------------------------------------------------- */
+      psLabelPlacement = CPLGetXMLNode(psRoot, "LabelPlacement");
+      if (psLabelPlacement) {
+        psPointPlacement = CPLGetXMLNode(psLabelPlacement, "PointPlacement");
+        psLinePlacement = CPLGetXMLNode(psLabelPlacement, "LinePlacement");
+        if (psPointPlacement)
+          ParseTextPointPlacement(psPointPlacement, psClass);
+        if (psLinePlacement)
+          ParseTextLinePlacement(psLinePlacement, psClass);
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      build the font name using the font font-family, font-style      */
+      /*      and font-weight. The name building uses a - between these       */
+      /*      parameters and the resulting name is compared to the list of    */
+      /*      available fonts. If the name exists, it will be used else we    */
+      /*      go to the bitmap fonts.                                         */
+      /* -------------------------------------------------------------------- */
+      if (pszFontFamily) {
+        snprintf(szFontName, sizeof(szFontName), "%s", pszFontFamily);
+        if (pszFontWeight && strcasecmp(pszFontWeight, "normal") != 0) {
+          strlcat(szFontName, "-", sizeof(szFontName));
+          strlcat(szFontName, pszFontWeight, sizeof(szFontName));
+        }
+        if (pszFontStyle && strcasecmp(pszFontStyle, "normal") != 0) {
+          strlcat(szFontName, "-", sizeof(szFontName));
+          strlcat(szFontName, pszFontStyle, sizeof(szFontName));
+        }
+
+        if ((msLookupHashTable(&(psLayer->map->fontset.fonts), szFontName) !=
+             NULL)) {
+          psLabelObj->font = msStrdup(szFontName);
+        }
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      parse the halo parameter.                                       */
+      /* -------------------------------------------------------------------- */
+      psHalo = CPLGetXMLNode(psRoot, "Halo");
+      if (psHalo) {
+        psHaloRadius = CPLGetXMLNode(psHalo, "Radius");
+        if (psHaloRadius && psHaloRadius->psChild &&
+            psHaloRadius->psChild->pszValue)
+          psLabelObj->outlinewidth = atoi(psHaloRadius->psChild->pszValue);
+
+        psHaloFill = CPLGetXMLNode(psHalo, "Fill");
+        if (psHaloFill) {
+          psCssParam = CPLGetXMLNode(psHaloFill, "CssParameter");
+          /*sld 1.1 used SvgParameter*/
+          if (psCssParam == NULL)
+            psCssParam = CPLGetXMLNode(psHaloFill, "SvgParameter");
+
+          while (psCssParam && psCssParam->pszValue &&
+                 (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
+                  strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
+            pszName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+            if (pszName) {
+              if (strcasecmp(pszName, "fill") == 0) {
+                if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                  msSLDParseOgcExpression(
+                      psCssParam->psChild->psNext, psLabelObj,
+                      MS_LABEL_BINDING_OUTLINECOLOR, MS_OBJ_LABEL);
+                }
+              }
+            }
+            psCssParam = psCssParam->psNext;
+          }
+        }
+      }
+      /* -------------------------------------------------------------------- */
+      /*      Parse the color                                                 */
+      /* -------------------------------------------------------------------- */
+      psFill = CPLGetXMLNode(psRoot, "Fill");
+      if (psFill) {
+        psCssParam = CPLGetXMLNode(psFill, "CssParameter");
+        /*sld 1.1 used SvgParameter*/
+        if (psCssParam == NULL)
+          psCssParam = CPLGetXMLNode(psFill, "SvgParameter");
+
+        while (psCssParam && psCssParam->pszValue &&
+               (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
+                strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
+          pszName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+          if (pszName) {
+            if (strcasecmp(pszName, "fill") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                msSLDParseOgcExpression(psCssParam->psChild->psNext, psLabelObj,
+                                        MS_LABEL_BINDING_COLOR, MS_OBJ_LABEL);
+              }
+            }
+          }
+          psCssParam = psCssParam->psNext;
+        }
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                         ParseTextPointPlacement                      */
+/*                                                                      */
+/*      point placement node for the text symbolizer.                  */
+/************************************************************************/
+int ParseTextPointPlacement(CPLXMLNode *psRoot, classObj *psClass) {
+  CPLXMLNode *psAnchor, *psAnchorX, *psAnchorY;
+  CPLXMLNode *psDisplacement, *psDisplacementX, *psDisplacementY;
+  CPLXMLNode *psRotation = NULL;
+  labelObj *psLabelObj = NULL;
+
+  if (!psRoot || !psClass)
+    return MS_FAILURE;
+  if (psClass->numlabels == 0) {
+    if (msGrowClassLabels(psClass) == NULL)
+      return (MS_FAILURE);
+    initLabel(psClass->labels[0]);
+    psClass->numlabels++;
+  }
+  psLabelObj = psClass->labels[0];
+
+  /* init the label with the default position */
+  psLabelObj->position = MS_CL;
+
+  /* -------------------------------------------------------------------- */
+  /*      parse anchor point. see function msSLDParseTextSymbolizer       */
+  /*      for documentation.                                              */
+  /* -------------------------------------------------------------------- */
+  psAnchor = CPLGetXMLNode(psRoot, "AnchorPoint");
+  if (psAnchor) {
+    psAnchorX = CPLGetXMLNode(psAnchor, "AnchorPointX");
+    psAnchorY = CPLGetXMLNode(psAnchor, "AnchorPointY");
+    /* psCssParam->psChild->psNext->pszValue) */
+    if (psAnchorX && psAnchorX->psChild && psAnchorX->psChild->pszValue &&
+        psAnchorY && psAnchorY->psChild && psAnchorY->psChild->pszValue) {
+      const double dfAnchorX = atof(psAnchorX->psChild->pszValue);
+      const double dfAnchorY = atof(psAnchorY->psChild->pszValue);
+
+      if ((dfAnchorX == 0 || dfAnchorX == 0.5 || dfAnchorX == 1) &&
+          (dfAnchorY == 0 || dfAnchorY == 0.5 || dfAnchorY == 1)) {
+        if (dfAnchorX == 0 && dfAnchorY == 0)
+          psLabelObj->position = MS_LL;
+        if (dfAnchorX == 0 && dfAnchorY == 0.5)
+          psLabelObj->position = MS_CL;
+        if (dfAnchorX == 0 && dfAnchorY == 1)
+          psLabelObj->position = MS_UL;
+
+        if (dfAnchorX == 0.5 && dfAnchorY == 0)
+          psLabelObj->position = MS_LC;
+        if (dfAnchorX == 0.5 && dfAnchorY == 0.5)
+          psLabelObj->position = MS_CC;
+        if (dfAnchorX == 0.5 && dfAnchorY == 1)
+          psLabelObj->position = MS_UC;
+
+        if (dfAnchorX == 1 && dfAnchorY == 0)
+          psLabelObj->position = MS_LR;
+        if (dfAnchorX == 1 && dfAnchorY == 0.5)
+          psLabelObj->position = MS_CR;
+        if (dfAnchorX == 1 && dfAnchorY == 1)
+          psLabelObj->position = MS_UR;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse displacement                                              */
+  /* -------------------------------------------------------------------- */
+  psDisplacement = CPLGetXMLNode(psRoot, "Displacement");
+  if (psDisplacement) {
+    psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
+    psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
+    /* psCssParam->psChild->psNext->pszValue) */
+    if (psDisplacementX && psDisplacementX->psChild &&
+        psDisplacementX->psChild->pszValue && psDisplacementY &&
+        psDisplacementY->psChild && psDisplacementY->psChild->pszValue) {
+      psLabelObj->offsetx = atoi(psDisplacementX->psChild->pszValue);
+      psLabelObj->offsety = atoi(psDisplacementY->psChild->pszValue);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      parse rotation.                                                 */
+  /* -------------------------------------------------------------------- */
+  psRotation = CPLGetXMLNode(psRoot, "Rotation");
+  if (psRotation && psRotation->psChild) {
+    msSLDParseOgcExpression(psRotation->psChild, psLabelObj,
+                            MS_LABEL_BINDING_ANGLE, MS_OBJ_LABEL);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                          ParseTextLinePlacement                      */
+/*                                                                      */
+/*      Lineplacement node fro the text symbolizer.                     */
+/************************************************************************/
+int ParseTextLinePlacement(CPLXMLNode *psRoot, classObj *psClass) {
+  CPLXMLNode *psOffset = NULL, *psAligned = NULL;
+  labelObj *psLabelObj = NULL;
+
+  if (!psRoot || !psClass)
+    return MS_FAILURE;
+
+  if (psClass->numlabels == 0) {
+    if (msGrowClassLabels(psClass) == NULL)
+      return (MS_FAILURE);
+    initLabel(psClass->labels[0]);
+    psClass->numlabels++;
+  }
+  psLabelObj = psClass->labels[0];
+
+  /*if there is a line placement, we will assume that the
+    best setting for mapserver would be for the text to follow
+    the line #2806*/
+  psLabelObj->anglemode = MS_FOLLOW;
+
+  /*sld 1.1.0 has a parameter IsAligned. default value is true*/
+  psAligned = CPLGetXMLNode(psRoot, "IsAligned");
+  if (psAligned && psAligned->psChild && psAligned->psChild->pszValue &&
+      strcasecmp(psAligned->psChild->pszValue, "false") == 0) {
+    psLabelObj->anglemode = MS_NONE;
+  }
+  psOffset = CPLGetXMLNode(psRoot, "PerpendicularOffset");
+  if (psOffset && psOffset->psChild && psOffset->psChild->pszValue) {
+    psLabelObj->offsetx = atoi(psOffset->psChild->pszValue);
+    psLabelObj->offsety = MS_LABEL_PERPENDICULAR_OFFSET;
+
+    /*if there is a PerpendicularOffset, we will assume that the
+      best setting for mapserver would be to use angle=0 and the
+      the offset #2806*/
+    /* since sld 1.1.0 introduces the IsAligned parameter, only
+       set the angles if the parameter is not set*/
+    if (!psAligned) {
+      psLabelObj->anglemode = MS_NONE;
+      psLabelObj->offsety = psLabelObj->offsetx;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*           void msSLDSetColorObject(char *psHexColor, colorObj        */
+/*      *psColor)                                                       */
+/*                                                                      */
+/*      Utility function to extract rgb values from an hexadecimal     */
+/*      color string (format is : #aaff08) and set it in the color      */
+/*      object.                                                         */
+/************************************************************************/
+int msSLDSetColorObject(char *psHexColor, colorObj *psColor) {
+  if (psHexColor && psColor && strlen(psHexColor) == 7 &&
+      psHexColor[0] == '#') {
+
+    psColor->red = msHexToInt(psHexColor + 1);
+    psColor->green = msHexToInt(psHexColor + 3);
+    psColor->blue = msHexToInt(psHexColor + 5);
+  }
+
+  return MS_SUCCESS;
+}
+
+/* -------------------------------------------------------------------- */
+/*      client sld support functions                                    */
+/* -------------------------------------------------------------------- */
+
+/************************************************************************/
+/*                msSLDGenerateSLD(mapObj *map, int iLayer)             */
+/*                                                                      */
+/*      Return an SLD document for all layers that are on or            */
+/*      default. The second argument should be set to -1 to generate    */
+/*      on all layers. Or set to the layer index to generate an SLD     */
+/*      for a specific layer.                                           */
+/*                                                                      */
+/*      The caller should free the returned string.                     */
+/************************************************************************/
+char *msSLDGenerateSLD(mapObj *map, int iLayer, const char *pszVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+
+  char szTmp[500];
+  int i = 0;
+  char *pszTmp = NULL;
+  char *pszSLD = NULL;
+  char *schemalocation = NULL;
+  int sld_version = OWS_VERSION_NOTSET;
+
+  sld_version = msOWSParseVersionString(pszVersion);
+
+  if (sld_version == OWS_VERSION_NOTSET ||
+      (sld_version != OWS_1_0_0 && sld_version != OWS_1_1_0))
+    sld_version = OWS_1_0_0;
+
+  if (map) {
+    schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    if (sld_version == OWS_1_0_0)
+      snprintf(szTmp, sizeof(szTmp),
+               "<StyledLayerDescriptor version=\"1.0.0\" "
+               "xmlns=\"http://www.opengis.net/sld\" "
+               "xmlns:gml=\"http://www.opengis.net/gml\" "
+               "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+               "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+               "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+               "xsi:schemaLocation=\"http://www.opengis.net/sld "
+               "%s/sld/1.0.0/StyledLayerDescriptor.xsd\">\n",
+               schemalocation);
+    else
+      snprintf(szTmp, sizeof(szTmp),
+               "<StyledLayerDescriptor version=\"1.1.0\" "
+               "xsi:schemaLocation=\"http://www.opengis.net/sld "
+               "%s/sld/1.1.0/StyledLayerDescriptor.xsd\" "
+               "xmlns=\"http://www.opengis.net/sld\" "
+               "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+               "xmlns:se=\"http://www.opengis.net/se\" "
+               "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+               "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">\n",
+               schemalocation);
+
+    free(schemalocation);
+
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+    if (iLayer < 0 || iLayer > map->numlayers - 1) {
+      for (i = 0; i < map->numlayers; i++) {
+        pszTmp = msSLDGenerateSLDLayer(GET_LAYER(map, i), sld_version);
+        if (pszTmp) {
+          pszSLD = msStringConcatenate(pszSLD, pszTmp);
+          free(pszTmp);
+        }
+      }
+    } else {
+      pszTmp = msSLDGenerateSLDLayer(GET_LAYER(map, iLayer), sld_version);
+      if (pszTmp) {
+        pszSLD = msStringConcatenate(pszSLD, pszTmp);
+        free(pszTmp);
+      }
+    }
+    snprintf(szTmp, sizeof(szTmp), "%s", "</StyledLayerDescriptor>\n");
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+  }
+
+  return pszSLD;
+
+#else
+  msSetError(MS_MISCERR, "OWS support is not available.",
+             "msSLDGenerateSLDLayer()");
+  return NULL;
+
+#endif
+}
+
+/************************************************************************/
+/*                            msSLDGetGraphicSLD                        */
+/*                                                                      */
+/*      Get an SLD for a style containing a symbol (Mark or external).  */
+/************************************************************************/
+char *msSLDGetGraphicSLD(styleObj *psStyle, layerObj *psLayer,
+                         int bNeedMarkSybol, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+
+  msStringBuffer *sldString = msStringBufferAlloc();
+  int nSymbol = -1;
+  symbolObj *psSymbol = NULL;
+  char szTmp[512];
+  char szFormat[4];
+  int i = 0, nLength = 0;
+  int bColorAvailable = 0;
+  int bGenerateDefaultSymbol = 0;
+  char *pszSymbolName = NULL;
+  char sNameSpace[10];
+  char sCssParam[30];
+
+  sCssParam[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sCssParam, "se:SvgParameter");
+  else
+    strcpy(sCssParam, "CssParameter");
+
+  sNameSpace[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sNameSpace, "se:");
+
+  if (psStyle && psLayer && psLayer->map) {
+    nSymbol = -1;
+    if (psStyle->symbol > 0)
+      nSymbol = psStyle->symbol;
+    else if (psStyle->symbolname)
+      nSymbol = msGetSymbolIndex(&psLayer->map->symbolset, psStyle->symbolname,
+                                 MS_FALSE);
+
+    bGenerateDefaultSymbol = 0;
+
+    if (bNeedMarkSybol &&
+        (nSymbol <= 0 || nSymbol >= psLayer->map->symbolset.numsymbols))
+      bGenerateDefaultSymbol = 1;
+
+    if (nSymbol > 0 && nSymbol < psLayer->map->symbolset.numsymbols) {
+      psSymbol = psLayer->map->symbolset.symbol[nSymbol];
+      if (psSymbol->type == MS_SYMBOL_VECTOR ||
+          psSymbol->type == MS_SYMBOL_ELLIPSE) {
+        /* Mark symbol */
+        if (psSymbol->name)
+
+        {
+          if (strcasecmp(psSymbol->name, "square") == 0 ||
+              strcasecmp(psSymbol->name, "circle") == 0 ||
+              strcasecmp(psSymbol->name, "triangle") == 0 ||
+              strcasecmp(psSymbol->name, "star") == 0 ||
+              strcasecmp(psSymbol->name, "cross") == 0 ||
+              strcasecmp(psSymbol->name, "x") == 0)
+            pszSymbolName = msStrdup(psSymbol->name);
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_square", 22) ==
+                   0)
+            pszSymbolName = msStrdup("square");
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_triangle",
+                               24) == 0)
+            pszSymbolName = msStrdup("triangle");
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_circle", 22) ==
+                   0)
+            pszSymbolName = msStrdup("circle");
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_star", 20) == 0)
+            pszSymbolName = msStrdup("star");
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_cross", 21) ==
+                   0)
+            pszSymbolName = msStrdup("cross");
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_x", 17) == 0)
+            pszSymbolName = msStrdup("X");
+
+          if (pszSymbolName) {
+            colorObj sTmpFillColor = {128, 128, 128, 255};
+            colorObj sTmpStrokeColor = {0, 0, 0, 255};
+            int hasFillColor = 0;
+            int hasStrokeColor = 0;
+
+            snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            snprintf(szTmp, sizeof(szTmp), "<%sMark>\n", sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            snprintf(szTmp, sizeof(szTmp),
+                     "<%sWellKnownName>%s</%sWellKnownName>\n", sNameSpace,
+                     pszSymbolName, sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
+                psStyle->color.blue != -1) {
+              sTmpFillColor.red = psStyle->color.red;
+              sTmpFillColor.green = psStyle->color.green;
+              sTmpFillColor.blue = psStyle->color.blue;
+              sTmpFillColor.alpha = psStyle->color.alpha;
+              hasFillColor = 1;
+            }
+            if (psStyle->outlinecolor.red != -1 &&
+                psStyle->outlinecolor.green != -1 &&
+                psStyle->outlinecolor.blue != -1) {
+              sTmpStrokeColor.red = psStyle->outlinecolor.red;
+              sTmpStrokeColor.green = psStyle->outlinecolor.green;
+              sTmpStrokeColor.blue = psStyle->outlinecolor.blue;
+              sTmpStrokeColor.alpha = psStyle->outlinecolor.alpha;
+              hasStrokeColor = 1;
+              // Make defaults implicit
+              if (sTmpStrokeColor.red == 0 && sTmpStrokeColor.green == 0 &&
+                  sTmpStrokeColor.blue == 0 && sTmpStrokeColor.alpha == 255 &&
+                  psStyle->width == 1) {
+                hasStrokeColor = 0;
+              }
+            }
+            if (!hasFillColor && !hasStrokeColor) {
+              sTmpFillColor.red = 128;
+              sTmpFillColor.green = 128;
+              sTmpFillColor.blue = 128;
+              sTmpFillColor.alpha = 255;
+              hasFillColor = 1;
+            }
+
+            if (hasFillColor) {
+              snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%s name=\"fill\">#%02x%02x%02x</%s>\n", sCssParam,
+                       sTmpFillColor.red, sTmpFillColor.green,
+                       sTmpFillColor.blue, sCssParam);
+              msStringBufferAppend(sldString, szTmp);
+              if (sTmpFillColor.alpha != 255 && sTmpFillColor.alpha != -1) {
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%s name=\"fill-opacity\">%.2f</%s>\n", sCssParam,
+                         (float)sTmpFillColor.alpha / 255.0, sCssParam);
+                msStringBufferAppend(sldString, szTmp);
+              }
+              snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+            }
+            if (hasStrokeColor) {
+              snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%s name=\"stroke\">#%02x%02x%02x</%s>\n", sCssParam,
+                       sTmpStrokeColor.red, sTmpStrokeColor.green,
+                       sTmpStrokeColor.blue, sCssParam);
+              msStringBufferAppend(sldString, szTmp);
+              if (psStyle->width > 0) {
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%s name=\"stroke-width\">%g</%s>\n", sCssParam,
+                         psStyle->width, sCssParam);
+                msStringBufferAppend(sldString, szTmp);
+              }
+              if (sTmpStrokeColor.alpha != 255 && sTmpStrokeColor.alpha != -1) {
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%s name=\"stroke-opacity\">%.2f</%s>\n", sCssParam,
+                         (float)sTmpStrokeColor.alpha / 255.0, sCssParam);
+                msStringBufferAppend(sldString, szTmp);
+              }
+              snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+            }
+
+            snprintf(szTmp, sizeof(szTmp), "</%sMark>\n", sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            if (psStyle->size > 0) {
+              snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n",
+                       sNameSpace, psStyle->size, sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+            }
+
+            if (fmod(psStyle->angle, 360)) {
+              snprintf(szTmp, sizeof(szTmp), "<%sRotation>%g</%sRotation>\n",
+                       sNameSpace, psStyle->angle, sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+            }
+            // Style opacity is already reported to alpha channel of color and
+            // outlinecolor if (psStyle->opacity < 100)
+            // {
+            //   snprintf(szTmp, sizeof(szTmp), "<%sOpacity>%g</%sOpacity>\n",
+            //       sNameSpace, psStyle->opacity/100.0, sNameSpace);
+            //   pszSLD = msStringConcatenate(pszSLD, szTmp);
+            // }
+
+            if (psStyle->offsetx != 0 || psStyle->offsety != 0) {
+              snprintf(szTmp, sizeof(szTmp), "<%sDisplacement>\n", sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%sDisplacementX>%g</%sDisplacementX>\n", sNameSpace,
+                       psStyle->offsetx, sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%sDisplacementY>%g</%sDisplacementY>\n", sNameSpace,
+                       psStyle->offsety, sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+              snprintf(szTmp, sizeof(szTmp), "</%sDisplacement>\n", sNameSpace);
+              msStringBufferAppend(sldString, szTmp);
+            }
+
+            snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            if (pszSymbolName)
+              free(pszSymbolName);
+          }
+        } else
+          bGenerateDefaultSymbol = 1;
+      } else if (psSymbol->type == MS_SYMBOL_PIXMAP ||
+                 psSymbol->type == MS_SYMBOL_SVG) {
+        if (psSymbol->name) {
+          const char *pszURL =
+              msLookupHashTable(&(psLayer->metadata), "WMS_SLD_SYMBOL_URL");
+          if (!pszURL)
+            pszURL = msLookupHashTable(&(psLayer->map->web.metadata),
+                                       "WMS_SLD_SYMBOL_URL");
+
+          if (pszURL) {
+            snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            snprintf(szTmp, sizeof(szTmp), "<%sExternalGraphic>\n", sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            snprintf(szTmp, sizeof(szTmp),
+                     "<%sOnlineResource "
+                     "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                     "xlink:type=\"simple\" xlink:href=\"%s%s\"/>\n",
+                     sNameSpace, pszURL, psSymbol->imagepath);
+            msStringBufferAppend(sldString, szTmp);
+            /* TODO : extract format from symbol */
+
+            szFormat[0] = '\0';
+            nLength = strlen(psSymbol->imagepath);
+            if (nLength > 3) {
+              for (i = 0; i <= 2; i++)
+                szFormat[2 - i] = psSymbol->imagepath[nLength - 1 - i];
+              szFormat[3] = '\0';
+            }
+            if (strlen(szFormat) > 0 && ((strcasecmp(szFormat, "GIF") == 0) ||
+                                         (strcasecmp(szFormat, "PNG") == 0))) {
+              if (strcasecmp(szFormat, "GIF") == 0)
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%sFormat>image/gif</%sFormat>\n", sNameSpace,
+                         sNameSpace);
+              else
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%sFormat>image/png</%sFormat>\n", sNameSpace,
+                         sNameSpace);
+            } else
+              snprintf(szTmp, sizeof(szTmp), "<%sFormat>%s</%sFormat>\n",
+                       sNameSpace,
+                       (psSymbol->type == MS_SYMBOL_SVG) ? "image/svg+xml"
+                                                         : "image/gif",
+                       sNameSpace);
+
+            msStringBufferAppend(sldString, szTmp);
+
+            snprintf(szTmp, sizeof(szTmp), "</%sExternalGraphic>\n",
+                     sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            if (psStyle->size > 0)
+              snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n",
+                       sNameSpace, psStyle->size, sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+
+            snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
+            msStringBufferAppend(sldString, szTmp);
+          }
+        }
+      }
+    }
+    if (bGenerateDefaultSymbol) { /* generate a default square symbol */
+      snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
+      msStringBufferAppend(sldString, szTmp);
+
+      snprintf(szTmp, sizeof(szTmp), "<%sMark>\n", sNameSpace);
+      msStringBufferAppend(sldString, szTmp);
+
+      snprintf(szTmp, sizeof(szTmp), "<%sWellKnownName>%s</%sWellKnownName>\n",
+               sNameSpace, "square", sNameSpace);
+      msStringBufferAppend(sldString, szTmp);
+
+      bColorAvailable = 0;
+      if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
+          psStyle->color.blue != -1) {
+        snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
+        msStringBufferAppend(sldString, szTmp);
+        snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
+                 sCssParam, psStyle->color.red, psStyle->color.green,
+                 psStyle->color.blue, sCssParam);
+        msStringBufferAppend(sldString, szTmp);
+        snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
+        msStringBufferAppend(sldString, szTmp);
+        bColorAvailable = 1;
+      }
+      if (psStyle->outlinecolor.red != -1 &&
+          psStyle->outlinecolor.green != -1 &&
+          psStyle->outlinecolor.blue != -1) {
+        snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
+        msStringBufferAppend(sldString, szTmp);
+        snprintf(szTmp, sizeof(szTmp),
+                 "<%s name=\"Stroke\">#%02x%02x%02x</%s>\n", sCssParam,
+                 psStyle->outlinecolor.red, psStyle->outlinecolor.green,
+                 psStyle->outlinecolor.blue, sCssParam);
+        msStringBufferAppend(sldString, szTmp);
+        snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
+        msStringBufferAppend(sldString, szTmp);
+        bColorAvailable = 1;
+      }
+      if (!bColorAvailable) {
+        /* default color */
+        snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
+        msStringBufferAppend(sldString, szTmp);
+        snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">%s</%s>\n", sCssParam,
+                 "#808080", sCssParam);
+        msStringBufferAppend(sldString, szTmp);
+        snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
+        msStringBufferAppend(sldString, szTmp);
+      }
+
+      snprintf(szTmp, sizeof(szTmp), "</%sMark>\n", sNameSpace);
+      msStringBufferAppend(sldString, szTmp);
+
+      if (psStyle->size > 0)
+        snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n", sNameSpace,
+                 psStyle->size, sNameSpace);
+      else
+        snprintf(szTmp, sizeof(szTmp), "<%sSize>%d</%sSize>\n", sNameSpace, 1,
+                 sNameSpace);
+      msStringBufferAppend(sldString, szTmp);
+
+      snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
+      msStringBufferAppend(sldString, szTmp);
+    }
+  }
+
+  return msStringBufferReleaseStringAndFree(sldString);
+
+#else
+  return NULL;
+
+#endif
+}
+
+/************************************************************************/
+/*                           msSLDGenerateLineSLD                       */
+/*                                                                      */
+/*      Generate SLD for a Line layer.                                  */
+/************************************************************************/
+char *msSLDGenerateLineSLD(styleObj *psStyle, layerObj *psLayer, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+
+  char *pszSLD = NULL;
+  char szTmp[100];
+  char szHexColor[7];
+  int nSymbol = -1;
+  int i = 0;
+  double dfSize = 1.0;
+  char *pszDashArray = NULL;
+  char *pszGraphicSLD = NULL;
+  char sCssParam[30];
+  char sNameSpace[10];
+
+  if (msCheckParentPointer(psLayer->map, "map") == MS_FAILURE)
+    return NULL;
+
+  sCssParam[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sCssParam, "se:SvgParameter");
+  else
+    strcpy(sCssParam, "CssParameter");
+
+  sNameSpace[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sNameSpace, "se:");
+
+  snprintf(szTmp, sizeof(szTmp), "<%sLineSymbolizer>\n", sNameSpace);
+
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
+
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
+  if (pszGraphicSLD) {
+    snprintf(szTmp, sizeof(szTmp), "<%sGraphicStroke>\n", sNameSpace);
+
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
+
+    if (nVersion >= OWS_1_1_0) {
+      if (psStyle->gap > 0) {
+        snprintf(szTmp, sizeof(szTmp), "<%sGap>%.2f</%sGap>\n", sNameSpace,
+                 psStyle->gap, sNameSpace);
+      }
+      if (psStyle->initialgap > 0) {
+        snprintf(szTmp, sizeof(szTmp), "<%sInitialGap>%.2f</%sInitialGap>\n",
+                 sNameSpace, psStyle->initialgap, sNameSpace);
+      }
+    }
+
+    snprintf(szTmp, sizeof(szTmp), "</%sGraphicStroke>\n", sNameSpace);
+
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    free(pszGraphicSLD);
+    pszGraphicSLD = NULL;
+  }
+
+  if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
+      psStyle->color.blue != -1)
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->color.red,
+            psStyle->color.green, psStyle->color.blue);
+  else
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->outlinecolor.red,
+            psStyle->outlinecolor.green, psStyle->outlinecolor.blue);
+
+  snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke\">#%s</%s>\n", sCssParam,
+           szHexColor, sCssParam);
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  if (psStyle->color.alpha != 255 && psStyle->color.alpha != -1) {
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-opacity\">%.2f</%s>\n",
+             sCssParam, (float)psStyle->color.alpha / 255.0, sCssParam);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+  }
+
+  nSymbol = -1;
+
+  if (psStyle->symbol >= 0)
+    nSymbol = psStyle->symbol;
+  else if (psStyle->symbolname)
+    nSymbol = msGetSymbolIndex(&psLayer->map->symbolset, psStyle->symbolname,
+                               MS_FALSE);
+
+  if (nSymbol < 0)
+    dfSize = 1.0;
+  else {
+    if (psStyle->size > 0)
+      dfSize = psStyle->size;
+    else if (psStyle->width > 0)
+      dfSize = psStyle->width;
+    else
+      dfSize = 1;
+  }
+
+  snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-width\">%.2f</%s>\n",
+           sCssParam, dfSize, sCssParam);
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  /* -------------------------------------------------------------------- */
+  /*      dash array                                                      */
+  /* -------------------------------------------------------------------- */
+
+  if (psStyle->patternlength > 0) {
+    for (i = 0; i < psStyle->patternlength; i++) {
+      snprintf(szTmp, sizeof(szTmp), "%.2f ", psStyle->pattern[i]);
+      pszDashArray = msStringConcatenate(pszDashArray, szTmp);
+    }
+    // remove the final trailing space from the last pattern value
+    msStringTrimBlanks(pszDashArray);
+
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-dasharray\">%s</%s>\n",
+             sCssParam, pszDashArray, sCssParam);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+    msFree(pszDashArray);
+  }
+
+  snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
+
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  snprintf(szTmp, sizeof(szTmp), "</%sLineSymbolizer>\n", sNameSpace);
+
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  return pszSLD;
+
+#else
+  return NULL;
+#endif
+}
+
+/************************************************************************/
+/*                         msSLDGeneratePolygonSLD                      */
+/*                                                                      */
+/*       Generate SLD for a Polygon layer.                              */
+/************************************************************************/
+char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer,
+                              int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+
+  char szTmp[100];
+  char *pszSLD = NULL;
+  char szHexColor[7];
+  double dfSize;
+  char sCssParam[30];
+  char sNameSpace[10];
+
+  sCssParam[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sCssParam, "se:SvgParameter");
+  else
+    strcpy(sCssParam, "CssParameter");
+
+  sNameSpace[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sNameSpace, "se:");
+
+  snprintf(szTmp, sizeof(szTmp), "<%sPolygonSymbolizer>\n", sNameSpace);
+
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+  /* fill */
+  if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
+      psStyle->color.blue != -1) {
+
+    snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
+
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    char *pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
+    if (pszGraphicSLD) {
+      snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n", sNameSpace);
+
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+      pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
+
+      snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n", sNameSpace);
+
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+      free(pszGraphicSLD);
+    }
+
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->color.red,
+            psStyle->color.green, psStyle->color.blue);
+
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%s</%s>\n", sCssParam,
+             szHexColor, sCssParam);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    if (psStyle->color.alpha != 255 && psStyle->color.alpha != -1) {
+      snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill-opacity\">%.2f</%s>\n",
+               sCssParam, (float)psStyle->color.alpha / 255, sCssParam);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+    }
+
+    snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
+
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+  }
+  /* stroke */
+  if (psStyle->outlinecolor.red != -1 && psStyle->outlinecolor.green != -1 &&
+      psStyle->outlinecolor.blue != -1) {
+    snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    /* If there is a symbol to be used for stroke, the color in the */
+    /* style should be set to -1. Else It won't apply here. */
+    if (psStyle->color.red == -1 && psStyle->color.green == -1 &&
+        psStyle->color.blue == -1) {
+      char *pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
+      if (pszGraphicSLD) {
+        snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n", sNameSpace);
+        pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+        pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
+        snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n", sNameSpace);
+        pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+        free(pszGraphicSLD);
+      }
+    }
+
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->outlinecolor.red,
+            psStyle->outlinecolor.green, psStyle->outlinecolor.blue);
+
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke\">#%s</%s>\n", sCssParam,
+             szHexColor, sCssParam);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    dfSize = 1.0;
+    if (psStyle->size > 0)
+      dfSize = psStyle->size;
+    else if (psStyle->width > 0)
+      dfSize = psStyle->width;
+
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-width\">%.2f</%s>\n",
+             sCssParam, dfSize, sCssParam);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    if (psStyle->outlinecolor.alpha != 255 &&
+        psStyle->outlinecolor.alpha != -1) {
+      snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-opacity\">%.2f</%s>\n",
+               sCssParam, psStyle->outlinecolor.alpha / 255.0, sCssParam);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+    }
+
+    snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+  }
+
+  snprintf(szTmp, sizeof(szTmp), "</%sPolygonSymbolizer>\n", sNameSpace);
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  return pszSLD;
+
+#else
+  return NULL;
+#endif
+}
+
+/************************************************************************/
+/*                          msSLDGeneratePointSLD                       */
+/*                                                                      */
+/*      Generate SLD for a Point layer.                                 */
+/************************************************************************/
+char *msSLDGeneratePointSLD(styleObj *psStyle, layerObj *psLayer,
+                            int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+  char *pszSLD = NULL;
+  char *pszGraphicSLD = NULL;
+  char szTmp[100];
+  char sNameSpace[10];
+
+  sNameSpace[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sNameSpace, "se:");
+
+  snprintf(szTmp, sizeof(szTmp), "<%sPointSymbolizer>\n", sNameSpace);
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 1, nVersion);
+  if (pszGraphicSLD) {
+    pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
+    free(pszGraphicSLD);
+  }
+
+  snprintf(szTmp, sizeof(szTmp), "</%sPointSymbolizer>\n", sNameSpace);
+  pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+  return pszSLD;
+
+#else
+  return NULL;
+
+#endif
+}
+
+/************************************************************************/
+/*                           msSLDGenerateTextSLD                       */
+/*                                                                      */
+/*      Generate a TextSymboliser SLD xml based on the class's label    */
+/*      object.                                                         */
+/************************************************************************/
+char *msSLDGenerateTextSLD(classObj *psClass, layerObj *psLayer, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+  char *pszSLD = NULL;
+
+  char szTmp[1000];
+  char **aszFontsParts = NULL;
+  int nFontParts = 0;
+  char szHexColor[7];
+  double dfAnchorX = 0.5, dfAnchorY = 0.5;
+  int i = 0;
+  int lid;
+  char sCssParam[30];
+  char sNameSpace[10];
+  labelObj *psLabelObj = NULL;
+
+  sCssParam[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sCssParam, "se:SvgParameter");
+  else
+    strcpy(sCssParam, "CssParameter");
+
+  sNameSpace[0] = '\0';
+  if (nVersion > OWS_1_0_0)
+    strcpy(sNameSpace, "se:");
+
+  if (!psLayer || !psClass)
+    return pszSLD;
+
+  for (lid = 0; lid < psClass->numlabels; lid++) {
+    char *psLabelText;
+    expressionObj psLabelExpr;
+    parseObj p;
+
+    msInitExpression(&psLabelExpr);
+    psLabelObj = psClass->labels[lid];
+
+    if (psLabelObj->text.string) {
+      psLabelExpr.string = msStrdup(psLabelObj->text.string);
+      psLabelExpr.type = psLabelObj->text.type;
+    } else if (psClass->text.string) {
+      psLabelExpr.string = msStrdup(psClass->text.string);
+      psLabelExpr.type = psClass->text.type;
+    } else if (psLayer->labelitem) {
+      psLabelExpr.string = msStrdup(psLayer->labelitem);
+      psLabelExpr.type = MS_STRING;
+    } else {
+      msFreeExpression(&psLabelExpr);
+      continue; // Can't find text content for this <Label>
+    }
+
+    if (psLabelExpr.type == MS_STRING) {
+      // Rewrite string to an expression so that literal strings and attributes
+      // are explicitely concatenated, e.g.:
+      //   "area is: [area]" becomes ("area is: "+"[area]"+"")
+      //             ^^^^^^                     ^^^^^^^^^^^^
+      char *result;
+      result = msStrdup("\"");
+      result = msStringConcatenate(result, psLabelExpr.string);
+      result = msStringConcatenate(result, "\"");
+      msTokenizeExpression(&psLabelExpr, NULL, NULL);
+      for (tokenListNodeObjPtr t = psLabelExpr.tokens; t; t = t->next) {
+        if (t->token == MS_TOKEN_BINDING_DOUBLE ||
+            t->token == MS_TOKEN_BINDING_INTEGER ||
+            t->token == MS_TOKEN_BINDING_STRING) {
+          char *target = static_cast<char *>(
+              msSmallMalloc(strlen(t->tokenval.bindval.item) + 3));
+          char *replacement = static_cast<char *>(
+              msSmallMalloc(strlen(t->tokenval.bindval.item) + 9));
+          sprintf(target, "[%s]", t->tokenval.bindval.item);
+          sprintf(replacement, "\"+\"[%s]\"+\"", t->tokenval.bindval.item);
+          result = msReplaceSubstring(result, target, replacement);
+          msFree(target);
+          msFree(replacement);
+        }
+      }
+      msFreeExpression(&psLabelExpr);
+      psLabelExpr.string = msStrdup(result);
+      psLabelExpr.type = MS_EXPRESSION;
+      msFree(result);
+    }
+
+    // Parse label expression to generate SLD tags from MapFile syntax
+    msTokenizeExpression(&psLabelExpr, NULL, NULL);
+    p.expr = &psLabelExpr;
+    p.shape = NULL;
+    p.type = MS_PARSE_TYPE_SLD;
+    yyparse(&p);
+    psLabelText = msStrdup(p.result.strval);
+    msFree(p.result.strval);
+    msFreeExpression(&psLabelExpr);
+
+    snprintf(szTmp, sizeof(szTmp), "<%sTextSymbolizer>\n", sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    snprintf(szTmp, sizeof(szTmp), "<%sLabel>\n%s</%sLabel>\n", sNameSpace,
+             psLabelText, sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    /* -------------------------------------------------------------------- */
+    /*      only true type fonts are exported. Font name should be          */
+    /*      something like arial-bold-italic. There are 3 parts to the      */
+    /*      name font-family, font-style (italic, oblique, normal),         */
+    /*      font-weight (bold, normal). These 3 elements are separated      */
+    /*      with -.                                                         */
+    /* -------------------------------------------------------------------- */
+    if (psLabelObj->font) {
+      aszFontsParts = msStringSplit(psLabelObj->font, '-', &nFontParts);
+      if (nFontParts > 0) {
+        snprintf(szTmp, sizeof(szTmp), "<%sFont>\n", sNameSpace);
+        pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+        /* assuming first one is font-family */
+        snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-family\">%s</%s>\n",
+                 sCssParam, aszFontsParts[0], sCssParam);
+        pszSLD = msStringConcatenate(pszSLD, szTmp);
+        for (i = 1; i < nFontParts; i++) {
+          if (strcasecmp(aszFontsParts[i], "italic") == 0 ||
+              strcasecmp(aszFontsParts[i], "oblique") == 0) {
+            snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-style\">%s</%s>\n",
+                     sCssParam, aszFontsParts[i], sCssParam);
+            pszSLD = msStringConcatenate(pszSLD, szTmp);
+          } else if (strcasecmp(aszFontsParts[i], "bold") == 0) {
+            snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-weight\">%s</%s>\n",
+                     sCssParam, aszFontsParts[i], sCssParam);
+            pszSLD = msStringConcatenate(pszSLD, szTmp);
+          }
+        }
+        /* size */
+        if (psLabelObj->size > 0) {
+          snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-size\">%d</%s>\n",
+                   sCssParam, psLabelObj->size, sCssParam);
+          pszSLD = msStringConcatenate(pszSLD, szTmp);
+        }
+        snprintf(szTmp, sizeof(szTmp), "</%sFont>\n", sNameSpace);
+        pszSLD = msStringConcatenate(pszSLD, szTmp);
+      }
+      msFreeCharArray(aszFontsParts, nFontParts);
+    }
+
+    /* label placement */
+    snprintf(szTmp, sizeof(szTmp), "<%sLabelPlacement>\n<%sPointPlacement>\n",
+             sNameSpace, sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPoint>\n", sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    if (psLabelObj->position == MS_LL) {
+      dfAnchorX = 0;
+      dfAnchorY = 0;
+    } else if (psLabelObj->position == MS_CL) {
+      dfAnchorX = 0;
+      dfAnchorY = 0.5;
+    } else if (psLabelObj->position == MS_UL) {
+      dfAnchorX = 0;
+      dfAnchorY = 1;
+    }
+
+    else if (psLabelObj->position == MS_LC) {
+      dfAnchorX = 0.5;
+      dfAnchorY = 0;
+    } else if (psLabelObj->position == MS_CC) {
+      dfAnchorX = 0.5;
+      dfAnchorY = 0.5;
+    } else if (psLabelObj->position == MS_UC) {
+      dfAnchorX = 0.5;
+      dfAnchorY = 1;
+    }
+
+    else if (psLabelObj->position == MS_LR) {
+      dfAnchorX = 1;
+      dfAnchorY = 0;
+    } else if (psLabelObj->position == MS_CR) {
+      dfAnchorX = 1;
+      dfAnchorY = 0.5;
+    } else if (psLabelObj->position == MS_UR) {
+      dfAnchorX = 1;
+      dfAnchorY = 1;
+    }
+    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPointX>%.1f</%sAnchorPointX>\n",
+             sNameSpace, dfAnchorX, sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPointY>%.1f</%sAnchorPointY>\n",
+             sNameSpace, dfAnchorY, sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    snprintf(szTmp, sizeof(szTmp), "</%sAnchorPoint>\n", sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    /* displacement */
+    if (psLabelObj->offsetx > 0 || psLabelObj->offsety > 0) {
+      snprintf(szTmp, sizeof(szTmp), "<%sDisplacement>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+      if (psLabelObj->offsetx > 0) {
+        snprintf(szTmp, sizeof(szTmp),
+                 "<%sDisplacementX>%d</%sDisplacementX>\n", sNameSpace,
+                 psLabelObj->offsetx, sNameSpace);
+        pszSLD = msStringConcatenate(pszSLD, szTmp);
+      }
+      if (psLabelObj->offsety > 0) {
+        snprintf(szTmp, sizeof(szTmp),
+                 "<%sDisplacementY>%d</%sDisplacementY>\n", sNameSpace,
+                 psLabelObj->offsety, sNameSpace);
+        pszSLD = msStringConcatenate(pszSLD, szTmp);
+      }
+
+      snprintf(szTmp, sizeof(szTmp), "</%sDisplacement>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+    }
+
+    /* rotation */
+    if (psLabelObj->angle > 0) {
+      snprintf(szTmp, sizeof(szTmp), "<%sRotation>%.2f</%sRotation>\n",
+               sNameSpace, psLabelObj->angle, sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+    }
+
+    snprintf(szTmp, sizeof(szTmp), "</%sPointPlacement>\n</%sLabelPlacement>\n",
+             sNameSpace, sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    if (psLabelObj->outlinecolor.red != -1 &&
+        psLabelObj->outlinecolor.green != -1 &&
+        psLabelObj->outlinecolor.blue != -1) {
+      snprintf(szTmp, sizeof(szTmp), "<%sHalo>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+      snprintf(szTmp, sizeof(szTmp), "<%sRadius>%d</%sRadius>\n", sNameSpace,
+               psLabelObj->outlinewidth, sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+      snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+      snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
+               sCssParam, psLabelObj->outlinecolor.red,
+               psLabelObj->outlinecolor.green, psLabelObj->outlinecolor.blue,
+               sCssParam);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+      snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+      snprintf(szTmp, sizeof(szTmp), "</%sHalo>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+    }
+
+    /* color */
+    if (psLabelObj->color.red != -1 && psLabelObj->color.green != -1 &&
+        psLabelObj->color.blue != -1) {
+      snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+      sprintf(szHexColor, "%02hhx%02hhx%02hhx",
+              (unsigned char)psLabelObj->color.red,
+              (unsigned char)psLabelObj->color.green,
+              (unsigned char)psLabelObj->color.blue);
+
+      snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%s</%s>\n", sCssParam,
+               szHexColor, sCssParam);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+      snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
+      pszSLD = msStringConcatenate(pszSLD, szTmp);
+    }
+
+    snprintf(szTmp, sizeof(szTmp), "</%sTextSymbolizer>\n", sNameSpace);
+    pszSLD = msStringConcatenate(pszSLD, szTmp);
+
+    msFree(psLabelText);
+  }
+  return pszSLD;
+
+#else
+  return NULL;
+#endif
+}
+
+#if (defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||   \
+     defined(USE_SOS_SVR))
+
+static void msSLDAppendName(msStringBuffer *sb, const char *pszName,
+                            int nVersion) {
+  char *pszEncoded = msEncodeHTMLEntities(pszName);
+  msStringBufferAppend(sb, (nVersion > OWS_1_0_0) ? "<se:Name>" : "<Name>");
+  msStringBufferAppend(sb, pszEncoded);
+  msStringBufferAppend(sb,
+                       (nVersion > OWS_1_0_0) ? "</se:Name>\n" : "</Name>\n");
+  msFree(pszEncoded);
+}
+
+static void msSLDGenerateUserStyle(msStringBuffer *sb, layerObj *psLayer,
+                                   int nVersion, const char *pszTargetGroup) {
+  const char *pszWfsFilter;
+
+  msStringBufferAppend(sb, "<UserStyle>\n");
+
+  if (pszTargetGroup) {
+    msSLDAppendName(sb, pszTargetGroup, nVersion);
+    if (psLayer->classgroup &&
+        strcmp(psLayer->classgroup, pszTargetGroup) == 0) {
+      msStringBufferAppend(sb, nVersion > OWS_1_0_0
+                                   ? "<se:IsDefault>true</se:IsDefault>\n"
+                                   : "<IsDefault>true</IsDefault>\n");
+    }
+  }
+
+  msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "<se:FeatureTypeStyle>\n"
+                                                : "<FeatureTypeStyle>\n");
+
+  pszWfsFilter = msLookupHashTable(&(psLayer->metadata), "wfs_filter");
+  if (psLayer->numclasses > 0) {
+    int i;
+    for (i = 0; i < psLayer->numclasses; i++) {
+      char *pszFilter;
+      double dfMinScale = -1, dfMaxScale = -1;
+
+      /* Only write down classes that match the group of interest */
+      if (psLayer->_class[i]->group) {
+        if (pszTargetGroup == NULL ||
+            strcmp(psLayer->_class[i]->group, pszTargetGroup) != 0) {
+          continue;
+        }
+      } else if (pszTargetGroup != NULL) {
+        continue;
+      }
+
+      msStringBufferAppend(sb,
+                           nVersion > OWS_1_0_0 ? "<se:Rule>\n" : "<Rule>\n");
+
+      /* if class has a name, use it as the RULE name */
+      if (psLayer->_class[i]->name) {
+        msSLDAppendName(sb, psLayer->_class[i]->name, nVersion);
+      }
+      /* -------------------------------------------------------------------- */
+      /*      get the Filter if there is a class expression.                  */
+      /* -------------------------------------------------------------------- */
+      pszFilter = msSLDGetFilter(psLayer->_class[i], pszWfsFilter);
+
+      if (pszFilter) {
+        msStringBufferAppend(sb, pszFilter);
+        free(pszFilter);
+      }
+      /* -------------------------------------------------------------------- */
+      /*      generate the min/max scale.                                     */
+      /* -------------------------------------------------------------------- */
+      dfMinScale = -1.0;
+      if (psLayer->_class[i]->minscaledenom > 0)
+        dfMinScale = psLayer->_class[i]->minscaledenom;
+      else if (psLayer->minscaledenom > 0)
+        dfMinScale = psLayer->minscaledenom;
+      else if (psLayer->map && psLayer->map->web.minscaledenom > 0)
+        dfMinScale = psLayer->map->web.minscaledenom;
+      if (dfMinScale > 0) {
+        char szTmp[100];
+        if (nVersion > OWS_1_0_0)
+          snprintf(szTmp, sizeof(szTmp),
+                   "<se:MinScaleDenominator>%f</se:MinScaleDenominator>\n",
+                   dfMinScale);
+        else
+          snprintf(szTmp, sizeof(szTmp),
+                   "<MinScaleDenominator>%f</MinScaleDenominator>\n",
+                   dfMinScale);
+
+        msStringBufferAppend(sb, szTmp);
+      }
+
+      dfMaxScale = -1.0;
+      if (psLayer->_class[i]->maxscaledenom > 0)
+        dfMaxScale = psLayer->_class[i]->maxscaledenom;
+      else if (psLayer->maxscaledenom > 0)
+        dfMaxScale = psLayer->maxscaledenom;
+      else if (psLayer->map && psLayer->map->web.maxscaledenom > 0)
+        dfMaxScale = psLayer->map->web.maxscaledenom;
+      if (dfMaxScale > 0) {
+        char szTmp[100];
+        if (nVersion > OWS_1_0_0)
+          snprintf(szTmp, sizeof(szTmp),
+                   "<se:MaxScaleDenominator>%f</se:MaxScaleDenominator>\n",
+                   dfMaxScale);
+        else
+          snprintf(szTmp, sizeof(szTmp),
+                   "<MaxScaleDenominator>%f</MaxScaleDenominator>\n",
+                   dfMaxScale);
+
+        msStringBufferAppend(sb, szTmp);
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      Line symbolizer.                                                */
+      /*                                                                      */
+      /*      Right now only generates a stroke element containing css        */
+      /*      parameters.                                                     */
+      /*      Lines using symbols TODO (specially for dash lines)             */
+      /* -------------------------------------------------------------------- */
+      if (psLayer->type == MS_LAYER_LINE) {
+        int j;
+        for (j = 0; j < psLayer->_class[i]->numstyles; j++) {
+          styleObj *psStyle = psLayer->_class[i]->styles[j];
+          char *pszSLD = msSLDGenerateLineSLD(psStyle, psLayer, nVersion);
+          if (pszSLD) {
+            msStringBufferAppend(sb, pszSLD);
+            free(pszSLD);
+          }
+        }
+
+      } else if (psLayer->type == MS_LAYER_POLYGON) {
+        int j;
+        for (j = 0; j < psLayer->_class[i]->numstyles; j++) {
+          styleObj *psStyle = psLayer->_class[i]->styles[j];
+          char *pszSLD = msSLDGeneratePolygonSLD(psStyle, psLayer, nVersion);
+          if (pszSLD) {
+            msStringBufferAppend(sb, pszSLD);
+            free(pszSLD);
+          }
+        }
+
+      } else if (psLayer->type == MS_LAYER_POINT) {
+        int j;
+        for (j = 0; j < psLayer->_class[i]->numstyles; j++) {
+          styleObj *psStyle = psLayer->_class[i]->styles[j];
+          char *pszSLD = msSLDGeneratePointSLD(psStyle, psLayer, nVersion);
+          if (pszSLD) {
+            msStringBufferAppend(sb, pszSLD);
+            free(pszSLD);
+          }
+        }
+      }
+      {
+        /* label if it exists */
+        char *pszSLD =
+            msSLDGenerateTextSLD(psLayer->_class[i], psLayer, nVersion);
+        if (pszSLD) {
+          msStringBufferAppend(sb, pszSLD);
+          free(pszSLD);
+        }
+      }
+      msStringBufferAppend(sb,
+                           nVersion > OWS_1_0_0 ? "</se:Rule>\n" : "</Rule>\n");
+    }
+  }
+
+  msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "</se:FeatureTypeStyle>\n"
+                                                : "</FeatureTypeStyle>\n");
+  msStringBufferAppend(sb, "</UserStyle>\n");
+}
+
+#endif
+
+/************************************************************************/
+/*                          msSLDGenerateSLDLayer                       */
+/*                                                                      */
+/*      Generate an SLD XML string based on the layer's classes.        */
+/************************************************************************/
+char *msSLDGenerateSLDLayer(layerObj *psLayer, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+
+  const char *pszWMSLayerName = NULL;
+  msStringBuffer *sb = msStringBufferAlloc();
+
+  if (psLayer && (psLayer->status == MS_ON || psLayer->status == MS_DEFAULT) &&
+      (psLayer->type == MS_LAYER_POINT || psLayer->type == MS_LAYER_LINE ||
+       psLayer->type == MS_LAYER_POLYGON)) {
+
+    int i;
+    int numClassGroupNames = 0;
+    char **papszClassGroupNames =
+        (char **)msSmallMalloc(sizeof(char *) * psLayer->numclasses);
+    for (i = 0; i < psLayer->numclasses; i++) {
+      const char *group = psLayer->_class[i]->group;
+      int j;
+      for (j = 0; j < numClassGroupNames; j++) {
+        if (group == NULL) {
+          if (papszClassGroupNames[j] == NULL)
+            break;
+        } else if (papszClassGroupNames[j] != NULL &&
+                   strcmp(papszClassGroupNames[j], group) == 0) {
+          break;
+        }
+      }
+      if (j >= numClassGroupNames) {
+        papszClassGroupNames[numClassGroupNames] =
+            group ? msStrdup(group) : NULL;
+        numClassGroupNames++;
+      }
+    }
+
+    msStringBufferAppend(sb, "<NamedLayer>\n");
+
+    pszWMSLayerName = msOWSLookupMetadata(&(psLayer->metadata), "MO", "name");
+    msSLDAppendName(sb,
+                    pszWMSLayerName ? pszWMSLayerName
+                    : psLayer->name ? psLayer->name
+                                    : "NamedLayer",
+                    nVersion);
+
+    for (i = 0; i < numClassGroupNames; i++) {
+      msSLDGenerateUserStyle(sb, psLayer, nVersion, papszClassGroupNames[i]);
+      msFree(papszClassGroupNames[i]);
+    }
+    msFree(papszClassGroupNames);
+
+    msStringBufferAppend(sb, "</NamedLayer>\n");
+  }
+  return msStringBufferReleaseStringAndFree(sb);
+
+#else
+  msSetError(MS_MISCERR, "OWS support is not available.",
+             "msSLDGenerateSLDLayer()");
+  return NULL;
+#endif
+}
+
+static const char *msSLDGetComparisonValue(const char *pszExpression) {
+  if (!pszExpression)
+    return NULL;
+
+  if (strstr(pszExpression, "<=") || strstr(pszExpression, " le "))
+    return "PropertyIsLessThanOrEqualTo";
+  else if (strstr(pszExpression, "=~"))
+    return "PropertyIsLike";
+  else if (strstr(pszExpression, "~*"))
+    return "PropertyIsLike";
+  else if (strstr(pszExpression, ">=") || strstr(pszExpression, " ge "))
+    return "PropertyIsGreaterThanOrEqualTo";
+  else if (strstr(pszExpression, "!=") || strstr(pszExpression, " ne "))
+    return "PropertyIsNotEqualTo";
+  else if (strstr(pszExpression, "=") || strstr(pszExpression, " eq "))
+    return "PropertyIsEqualTo";
+  else if (strstr(pszExpression, "<") || strstr(pszExpression, " lt "))
+    return "PropertyIsLessThan";
+  else if (strstr(pszExpression, ">") || strstr(pszExpression, " gt "))
+    return "PropertyIsGreaterThan";
+
+  return NULL;
+}
+
+static const char *msSLDGetLogicalOperator(const char *pszExpression) {
+
+  if (!pszExpression)
+    return NULL;
+
+  if (strcasestr(pszExpression, " AND ") || strcasestr(pszExpression, "AND("))
+    return "And";
+
+  if (strcasestr(pszExpression, " OR ") || strcasestr(pszExpression, "OR("))
+    return "Or";
+
+  if (strcasestr(pszExpression, "NOT ") || strcasestr(pszExpression, "NOT("))
+    return "Not";
+
+  return NULL;
+}
+
+static char *msSLDGetRightExpressionOfOperator(const char *pszExpression) {
+  const char *pszAnd = NULL, *pszOr = NULL, *pszNot = NULL;
+
+  pszAnd = strcasestr(pszExpression, " AND ");
+
+  if (!pszAnd) {
+    pszAnd = strcasestr(pszExpression, "AND(");
+  }
+
+  if (pszAnd)
+    return msStrdup(pszAnd + 4);
+  else {
+    pszOr = strcasestr(pszExpression, " OR ");
+
+    if (!pszOr) {
+      pszOr = strcasestr(pszExpression, "OR(");
+    }
+
+    if (pszOr)
+      return msStrdup(pszOr + 3);
+    else {
+      pszNot = strcasestr(pszExpression, "NOT ");
+
+      if (!pszNot)
+        pszNot = strcasestr(pszExpression, "NOT(");
+
+      if (pszNot)
+        return msStrdup(pszNot + 4);
+    }
+  }
+  return NULL;
+}
+
+static char *msSLDGetLeftExpressionOfOperator(const char *pszExpression) {
+  char *pszReturn = NULL;
+  int nLength = 0, iReturn = 0;
+
+  if (!pszExpression || (nLength = strlen(pszExpression)) <= 0)
+    return NULL;
+
+  pszReturn = (char *)malloc(sizeof(char) * (nLength + 1));
+  pszReturn[0] = '\0';
+  if (strcasestr(pszExpression, " AND ")) {
+    for (int i = 0; i < nLength - 5; i++) {
+      if (pszExpression[i] == ' ' && (toupper(pszExpression[i + 1]) == 'A') &&
+          (toupper(pszExpression[i + 2]) == 'N') &&
+          (toupper(pszExpression[i + 3]) == 'D') &&
+          (pszExpression[i + 4] == ' '))
+        break;
+      else {
+        pszReturn[iReturn++] = pszExpression[i];
+      }
+      pszReturn[iReturn] = '\0';
+    }
+  } else if (strcasestr(pszExpression, "AND(")) {
+    for (int i = 0; i < nLength - 4; i++) {
+      if ((toupper(pszExpression[i]) == 'A') &&
+          (toupper(pszExpression[i + 1]) == 'N') &&
+          (toupper(pszExpression[i + 2]) == 'D') &&
+          (pszExpression[i + 3] == '('))
+        break;
+      else {
+        pszReturn[iReturn++] = pszExpression[i];
+      }
+      pszReturn[iReturn] = '\0';
+    }
+  } else if (strcasestr(pszExpression, " OR ")) {
+    for (int i = 0; i < nLength - 4; i++) {
+      if (pszExpression[i] == ' ' && (toupper(pszExpression[i + 1]) == 'O') &&
+          (toupper(pszExpression[i + 2]) == 'R') && pszExpression[i + 3] == ' ')
+        break;
+      else {
+        pszReturn[iReturn++] = pszExpression[i];
+      }
+      pszReturn[iReturn] = '\0';
+    }
+  } else if (strcasestr(pszExpression, "OR(")) {
+    for (int i = 0; i < nLength - 3; i++) {
+      if ((toupper(pszExpression[i]) == 'O') &&
+          (toupper(pszExpression[i + 1]) == 'R') && pszExpression[i + 2] == '(')
+        break;
+      else {
+        pszReturn[iReturn++] = pszExpression[i];
+      }
+      pszReturn[iReturn] = '\0';
+    }
+  } else {
+    msFree(pszReturn);
+    return NULL;
+  }
+
+  return pszReturn;
+}
+
+static int msSLDNumberOfLogicalOperators(const char *pszExpression) {
+  const char *pszAnd = NULL;
+  const char *pszOr = NULL;
+  const char *pszNot = NULL;
+  const char *pszSecondAnd = NULL, *pszSecondOr = NULL;
+  if (!pszExpression)
+    return 0;
+
+  /* -------------------------------------------------------------------- */
+  /*      tests here are minimal to be able to parse simple expression    */
+  /*      like A AND B, A OR B, NOT A.                                    */
+  /* -------------------------------------------------------------------- */
+  pszAnd = strcasestr(pszExpression, " AND ");
+  pszOr = strcasestr(pszExpression, " OR ");
+  pszNot = strcasestr(pszExpression, "NOT ");
+
+  if (!pszAnd && !pszOr) {
+    pszAnd = strcasestr(pszExpression, "AND(");
+    pszOr = strcasestr(pszExpression, "OR(");
+  }
+
+  if (!pszNot) {
+    pszNot = strcasestr(pszExpression, "NOT(");
+  }
+
+  if (!pszAnd && !pszOr && !pszNot)
+    return 0;
+
+  /* doen not matter how many exactly if there are 2 or more */
+  if ((pszAnd && pszOr) || (pszAnd && pszNot) || (pszOr && pszNot))
+    return 2;
+
+  if (pszAnd) {
+    pszSecondAnd = strcasestr(pszAnd + 3, " AND ");
+    pszSecondOr = strcasestr(pszAnd + 3, " OR ");
+  } else if (pszOr) {
+    pszSecondAnd = strcasestr(pszOr + 2, " AND ");
+    pszSecondOr = strcasestr(pszOr + 2, " OR ");
+  }
+
+  if (!pszSecondAnd && !pszSecondOr)
+    return 1;
+  else
+    return 2;
+}
+
+static char *msSLDGetAttributeNameOrValue(const char *pszExpression,
+                                          const char *pszComparionValue,
+                                          int bReturnName) {
+  char **aszValues = NULL;
+  char *pszAttributeName = NULL;
+  char *pszAttributeValue = NULL;
+  char cCompare = '=';
+  char szCompare[3] = {0};
+  char szCompare2[3] = {0};
+  int bOneCharCompare = -1, nTokens = 0, nLength = 0;
+  int iValue = 0, i = 0, iValueIndex = 0;
+  int bStartCopy = 0, iAtt = 0;
+  char *pszFinalAttributeName = NULL, *pszFinalAttributeValue = NULL;
+  int bSingleQuote = 0, bDoubleQuote = 0;
+
+  if (!pszExpression || !pszComparionValue || strlen(pszExpression) == 0)
+    return NULL;
+
+  szCompare[0] = '\0';
+  szCompare2[0] = '\0';
+
+  if (strcasecmp(pszComparionValue, "PropertyIsEqualTo") == 0) {
+    cCompare = '=';
+    szCompare[0] = 'e';
+    szCompare[1] = 'q';
+    szCompare[2] = '\0';
+
+    bOneCharCompare = 1;
+  }
+  if (strcasecmp(pszComparionValue, "PropertyIsNotEqualTo") == 0) {
+    szCompare[0] = 'n';
+    szCompare[1] = 'e';
+    szCompare[2] = '\0';
+
+    szCompare2[0] = '!';
+    szCompare2[1] = '=';
+    szCompare2[2] = '\0';
+
+    bOneCharCompare = 0;
+  } else if (strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
+    szCompare[0] = '=';
+    szCompare[1] = '~';
+    szCompare[2] = '\0';
+
+    szCompare2[0] = '~';
+    szCompare2[1] = '*';
+    szCompare2[2] = '\0';
+
+    bOneCharCompare = 0;
+  } else if (strcasecmp(pszComparionValue, "PropertyIsLessThan") == 0) {
+    cCompare = '<';
+    szCompare[0] = 'l';
+    szCompare[1] = 't';
+    szCompare[2] = '\0';
+    bOneCharCompare = 1;
+  } else if (strcasecmp(pszComparionValue, "PropertyIsLessThanOrEqualTo") ==
+             0) {
+    szCompare[0] = 'l';
+    szCompare[1] = 'e';
+    szCompare[2] = '\0';
+
+    szCompare2[0] = '<';
+    szCompare2[1] = '=';
+    szCompare2[2] = '\0';
+
+    bOneCharCompare = 0;
+  } else if (strcasecmp(pszComparionValue, "PropertyIsGreaterThan") == 0) {
+    cCompare = '>';
+    szCompare[0] = 'g';
+    szCompare[1] = 't';
+    szCompare[2] = '\0';
+    bOneCharCompare = 1;
+  } else if (strcasecmp(pszComparionValue, "PropertyIsGreaterThanOrEqualTo") ==
+             0) {
+    szCompare[0] = 'g';
+    szCompare[1] = 'e';
+    szCompare[2] = '\0';
+
+    szCompare2[0] = '>';
+    szCompare2[1] = '=';
+    szCompare2[2] = '\0';
+
+    bOneCharCompare = 0;
+  }
+
+  if (bOneCharCompare == 1) {
+    aszValues = msStringSplit(pszExpression, cCompare, &nTokens);
+    if (nTokens > 1) {
+      pszAttributeName = msStrdup(aszValues[0]);
+      pszAttributeValue = msStrdup(aszValues[1]);
+    } else {
+      nLength = strlen(pszExpression);
+      pszAttributeName = (char *)malloc(sizeof(char) * (nLength + 1));
+      iValue = 0;
+      for (i = 0; i < nLength - 2; i++) {
+        if (pszExpression[i] != szCompare[0] &&
+            pszExpression[i] != toupper(szCompare[0])) {
+          pszAttributeName[iValue++] = pszExpression[i];
+        } else {
+          if ((pszExpression[i + 1] == szCompare[1] ||
+               pszExpression[i + 1] == toupper(szCompare[1])) &&
+              (pszExpression[i + 2] == ' ')) {
+            iValueIndex = i + 3;
+            pszAttributeValue = msStrdup(pszExpression + iValueIndex);
+            break;
+          } else
+            pszAttributeName[iValue++] = pszExpression[i];
+        }
+      }
+      pszAttributeName[iValue] = '\0';
+    }
+    msFreeCharArray(aszValues, nTokens);
+  } else if (bOneCharCompare == 0) {
+    nLength = strlen(pszExpression);
+    pszAttributeName = (char *)malloc(sizeof(char) * (nLength + 1));
+    iValue = 0;
+    for (i = 0; i < nLength - 2; i++) {
+      if ((pszExpression[i] != szCompare[0] ||
+           pszExpression[i] != toupper(szCompare[0])) &&
+          (pszExpression[i] != szCompare2[0] ||
+           pszExpression[i] != toupper(szCompare2[0])))
+
+      {
+        pszAttributeName[iValue++] = pszExpression[i];
+      } else {
+        if (((pszExpression[i + 1] == szCompare[1] ||
+              pszExpression[i + 1] == toupper(szCompare[1])) ||
+             (pszExpression[i + 1] == szCompare2[1] ||
+              pszExpression[i + 1] == toupper(szCompare2[1]))) &&
+            (pszExpression[i + 2] == ' ')) {
+          iValueIndex = i + 3;
+          pszAttributeValue = msStrdup(pszExpression + iValueIndex);
+          break;
+        } else
+          pszAttributeName[iValue++] = pszExpression[i];
+      }
+    }
+    pszAttributeName[iValue] = '\0';
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Return the name of the attribute : It is supposed to be         */
+  /*      inside []                                                       */
+  /* -------------------------------------------------------------------- */
+  if (bReturnName) {
+    if (!pszAttributeName) {
+      msFree(pszAttributeValue);
+      return NULL;
+    }
+
+    nLength = strlen(pszAttributeName);
+    pszFinalAttributeName = (char *)malloc(sizeof(char) * (nLength + 1));
+    bStartCopy = 0;
+    iAtt = 0;
+    for (i = 0; i < nLength; i++) {
+      if (pszAttributeName[i] == ' ' && bStartCopy == 0)
+        continue;
+
+      if (pszAttributeName[i] == '[') {
+        bStartCopy = 1;
+        continue;
+      }
+      if (pszAttributeName[i] == ']')
+        break;
+      if (bStartCopy) {
+        pszFinalAttributeName[iAtt++] = pszAttributeName[i];
+      }
+      pszFinalAttributeName[iAtt] = '\0';
+    }
+
+    msFree(pszAttributeName);
+    msFree(pszAttributeValue);
+    return pszFinalAttributeName;
+  } else {
+
+    if (!pszAttributeValue) {
+      msFree(pszAttributeName);
+      return NULL;
+    }
+    nLength = strlen(pszAttributeValue);
+    pszFinalAttributeValue = (char *)malloc(sizeof(char) * (nLength + 1));
+    pszFinalAttributeValue[0] = '\0';
+    bStartCopy = 0;
+    iAtt = 0;
+    for (i = 0; i < nLength; i++) {
+      if (pszAttributeValue[i] == ' ' && bStartCopy == 0)
+        continue;
+
+      if (pszAttributeValue[i] == '\'' && bStartCopy == 0) {
+        bSingleQuote = 1;
+        bStartCopy = 1;
+        continue;
+      } else if (pszAttributeValue[i] == '"' && bStartCopy == 0) {
+        bDoubleQuote = 1;
+        bStartCopy = 1;
+        continue;
+      } else
+        bStartCopy = 1;
+
+      if (bStartCopy) {
+        if (pszAttributeValue[i] == '\'' && bSingleQuote)
+          break;
+        else if (pszAttributeValue[i] == '"' && bDoubleQuote)
+          break;
+        else if (pszAttributeValue[i] == ')') {
+          // remove any spaces prior to the closing bracket
+          msStringTrimBlanks(pszFinalAttributeValue);
+          break;
+        }
+        pszFinalAttributeValue[iAtt++] = pszAttributeValue[i];
+      }
+      pszFinalAttributeValue[iAtt] = '\0';
+    }
+
+    /*trim  for regular expressions*/
+    if (strlen(pszFinalAttributeValue) > 2 &&
+        strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
+      int len = strlen(pszFinalAttributeValue);
+      msStringTrimBlanks(pszFinalAttributeValue);
+      if (pszFinalAttributeValue[0] == '/' &&
+          (pszFinalAttributeValue[len - 1] == '/' ||
+           (pszFinalAttributeValue[len - 1] == 'i' &&
+            pszFinalAttributeValue[len - 2] == '/'))) {
+        if (pszFinalAttributeValue[len - 1] == '/')
+          pszFinalAttributeValue[len - 1] = '\0';
+        else
+          pszFinalAttributeValue[len - 2] = '\0';
+
+        memmove(pszFinalAttributeValue,
+                pszFinalAttributeValue +
+                    ((pszFinalAttributeValue[1] == '^') ? 2 : 1),
+                len - 1);
+
+        /*replace wild card string .* with * */
+        pszFinalAttributeValue =
+            msReplaceSubstring(pszFinalAttributeValue, ".*", "*");
+      }
+    }
+    msFree(pszAttributeName);
+    msFree(pszAttributeValue);
+    return pszFinalAttributeValue;
+  }
+}
+
+static char *msSLDGetAttributeName(const char *pszExpression,
+                                   const char *pszComparionValue) {
+  return msSLDGetAttributeNameOrValue(pszExpression, pszComparionValue, 1);
+}
+
+static char *msSLDGetAttributeValue(const char *pszExpression,
+                                    const char *pszComparionValue) {
+  return msSLDGetAttributeNameOrValue(pszExpression, pszComparionValue, 0);
+}
+
+/************************************************************************/
+/*                           BuildExpressionTree                        */
+/*                                                                      */
+/*      Build a filter expression node based on mapserver's class       */
+/*      expression. This is limited to simple expressions like :        */
+/*        A = B, A < B, A <= B, A > B, A >= B, A != B                   */
+/*       It also handles one level of logical expressions :             */
+/*        A AND B                                                       */
+/*        A OR B                                                        */
+/*        NOT A                                                         */
+/************************************************************************/
+static FilterEncodingNode *BuildExpressionTree(const char *pszExpression,
+                                               FilterEncodingNode *psNode) {
+  int nOperators = 0;
+
+  if (!pszExpression || strlen(pszExpression) == 0)
+    return NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      First we check how many logical operators are there :           */
+  /*       - if none : It means It is a comparison operator (like =,      */
+  /*      >, >= .... We get the comparison value as well as the           */
+  /*      attribute and the attribute's value and assign it to the node   */
+  /*      passed in argument.                                             */
+  /*       - if there is one operator, we assign the operator to the      */
+  /*      node and adds the expressions into the left and right nodes.    */
+  /* -------------------------------------------------------------------- */
+  nOperators = msSLDNumberOfLogicalOperators(pszExpression);
+  if (nOperators == 0) {
+    if (!psNode)
+      psNode = FLTCreateFilterEncodingNode();
+
+    const char *pszComparionValue = msSLDGetComparisonValue(pszExpression);
+    char *pszAttibuteName =
+        msSLDGetAttributeName(pszExpression, pszComparionValue);
+    char *pszAttibuteValue =
+        msSLDGetAttributeValue(pszExpression, pszComparionValue);
+    if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
+      psNode->eType = FILTER_NODE_TYPE_COMPARISON;
+      psNode->pszValue = msStrdup(pszComparionValue);
+
+      psNode->psLeftNode = FLTCreateFilterEncodingNode();
+      psNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+      psNode->psLeftNode->pszValue = msStrdup(pszAttibuteName);
+
+      psNode->psRightNode = FLTCreateFilterEncodingNode();
+      psNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
+      psNode->psRightNode->pszValue = msStrdup(pszAttibuteValue);
+
+      if (strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
+        psNode->pOther = (FEPropertyIsLike *)malloc(sizeof(FEPropertyIsLike));
+        ((FEPropertyIsLike *)psNode->pOther)->bCaseInsensitive = 0;
+        ((FEPropertyIsLike *)psNode->pOther)->pszWildCard = msStrdup("*");
+        ((FEPropertyIsLike *)psNode->pOther)->pszSingleChar = msStrdup("#");
+        ((FEPropertyIsLike *)psNode->pOther)->pszEscapeChar = msStrdup("!");
+      }
+    }
+    free(pszAttibuteName);
+    free(pszAttibuteValue);
+    return psNode;
+
+  } else if (nOperators == 1) {
+    const char *pszOperator = msSLDGetLogicalOperator(pszExpression);
+    if (pszOperator) {
+      if (!psNode)
+        psNode = FLTCreateFilterEncodingNode();
+
+      psNode->eType = FILTER_NODE_TYPE_LOGICAL;
+      psNode->pszValue = msStrdup(pszOperator);
+
+      char *pszLeftExpression = msSLDGetLeftExpressionOfOperator(pszExpression);
+      char *pszRightExpression =
+          msSLDGetRightExpressionOfOperator(pszExpression);
+
+      if (pszLeftExpression || pszRightExpression) {
+        if (pszLeftExpression) {
+          const char *pszComparionValue =
+              msSLDGetComparisonValue(pszLeftExpression);
+          char *pszAttibuteName =
+              msSLDGetAttributeName(pszLeftExpression, pszComparionValue);
+          char *pszAttibuteValue =
+              msSLDGetAttributeValue(pszLeftExpression, pszComparionValue);
+
+          if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
+            psNode->psLeftNode = FLTCreateFilterEncodingNode();
+            psNode->psLeftNode->eType = FILTER_NODE_TYPE_COMPARISON;
+            psNode->psLeftNode->pszValue = msStrdup(pszComparionValue);
+
+            psNode->psLeftNode->psLeftNode = FLTCreateFilterEncodingNode();
+            psNode->psLeftNode->psLeftNode->eType =
+                FILTER_NODE_TYPE_PROPERTYNAME;
+            psNode->psLeftNode->psLeftNode->pszValue =
+                msStrdup(pszAttibuteName);
+
+            psNode->psLeftNode->psRightNode = FLTCreateFilterEncodingNode();
+            psNode->psLeftNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
+            psNode->psLeftNode->psRightNode->pszValue =
+                msStrdup(pszAttibuteValue);
+          }
+
+          free(pszAttibuteName);
+          free(pszAttibuteValue);
+          free(pszLeftExpression);
+        }
+        if (pszRightExpression) {
+          const char *pszComparionValue =
+              msSLDGetComparisonValue(pszRightExpression);
+          char *pszAttibuteName =
+              msSLDGetAttributeName(pszRightExpression, pszComparionValue);
+          char *pszAttibuteValue =
+              msSLDGetAttributeValue(pszRightExpression, pszComparionValue);
+
+          if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
+            psNode->psRightNode = FLTCreateFilterEncodingNode();
+            psNode->psRightNode->eType = FILTER_NODE_TYPE_COMPARISON;
+            psNode->psRightNode->pszValue = msStrdup(pszComparionValue);
+
+            psNode->psRightNode->psLeftNode = FLTCreateFilterEncodingNode();
+            psNode->psRightNode->psLeftNode->eType =
+                FILTER_NODE_TYPE_PROPERTYNAME;
+            psNode->psRightNode->psLeftNode->pszValue =
+                msStrdup(pszAttibuteName);
+
+            psNode->psRightNode->psRightNode = FLTCreateFilterEncodingNode();
+            psNode->psRightNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
+            psNode->psRightNode->psRightNode->pszValue =
+                msStrdup(pszAttibuteValue);
+          }
+          free(pszAttibuteName);
+          free(pszAttibuteValue);
+          free(pszRightExpression);
+        }
+      }
+    }
+
+    return psNode;
+  } else {
+    return NULL;
+  }
+}
+
+static char *msSLDBuildFilterEncoding(const FilterEncodingNode *psNode) {
+  char *pszTmp = NULL;
+  char szTmp[200];
+  char *pszExpression = NULL;
+
+  if (!psNode)
+    return NULL;
+
+  if (psNode->eType == FILTER_NODE_TYPE_COMPARISON && psNode->pszValue &&
+      psNode->psLeftNode && psNode->psLeftNode->pszValue &&
+      psNode->psRightNode && psNode->psRightNode->pszValue) {
+    snprintf(szTmp, sizeof(szTmp),
+             "<ogc:%s><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</"
+             "ogc:Literal></ogc:%s>",
+             psNode->pszValue, psNode->psLeftNode->pszValue,
+             psNode->psRightNode->pszValue, psNode->pszValue);
+    pszExpression = msStrdup(szTmp);
+  } else if (psNode->eType == FILTER_NODE_TYPE_LOGICAL && psNode->pszValue &&
+             ((psNode->psLeftNode && psNode->psLeftNode->pszValue) ||
+              (psNode->psRightNode && psNode->psRightNode->pszValue))) {
+    snprintf(szTmp, sizeof(szTmp), "<ogc:%s>", psNode->pszValue);
+    pszExpression = msStringConcatenate(pszExpression, szTmp);
+    if (psNode->psLeftNode) {
+      pszTmp = msSLDBuildFilterEncoding(psNode->psLeftNode);
+      if (pszTmp) {
+        pszExpression = msStringConcatenate(pszExpression, pszTmp);
+        free(pszTmp);
+      }
+    }
+    if (psNode->psRightNode) {
+      pszTmp = msSLDBuildFilterEncoding(psNode->psRightNode);
+      if (pszTmp) {
+        pszExpression = msStringConcatenate(pszExpression, pszTmp);
+        free(pszTmp);
+      }
+    }
+    snprintf(szTmp, sizeof(szTmp), "</ogc:%s>", psNode->pszValue);
+    pszExpression = msStringConcatenate(pszExpression, szTmp);
+  }
+  return pszExpression;
+}
+
+static char *msSLDParseLogicalExpression(const char *pszExpression,
+                                         const char *pszWfsFilter) {
+  FilterEncodingNode *psNode = NULL;
+  char *pszFLTExpression = NULL;
+  char *pszTmp = NULL;
+
+  if (!pszExpression || strlen(pszExpression) == 0)
+    return NULL;
+
+  psNode = BuildExpressionTree(pszExpression, NULL);
+
+  if (psNode) {
+    pszFLTExpression = msSLDBuildFilterEncoding(psNode);
+    if (pszFLTExpression) {
+      pszTmp = msStringConcatenate(pszTmp, "<ogc:Filter>");
+      if (pszWfsFilter) {
+        pszTmp = msStringConcatenate(pszTmp, "<ogc:And>");
+        pszTmp = msStringConcatenate(pszTmp, (char *)pszWfsFilter);
+      }
+      pszTmp = msStringConcatenate(pszTmp, pszFLTExpression);
+
+      if (pszWfsFilter)
+        pszTmp = msStringConcatenate(pszTmp, "</ogc:And>");
+
+      pszTmp = msStringConcatenate(pszTmp, "</ogc:Filter>\n");
+
+      free(pszFLTExpression);
+      pszFLTExpression = pszTmp;
+    }
+    FLTFreeFilterEncodingNode(psNode);
+  }
+
+  return pszFLTExpression;
+}
+
+/************************************************************************/
+/*                     msSLDConvertRegexExpToOgcIsLike                  */
+/*                                                                      */
+/*      Convert mapserver regex expression to ogc is like property      */
+/*      expression.                                                     */
+/*                                                                      */
+/*      Review bug 1644 for details. Here are the current rules:        */
+/*                                                                      */
+/*       The filter encoding property like is more limited compared     */
+/*      to regular expression that can be built in mapserver. I         */
+/*      think we should define what is possible to convert properly     */
+/*      and do those, and also identify potential problems.  Example :  */
+/*        - any time there is a .* in the expression it will be         */
+/*      converted to *                                                  */
+/*        - any other character plus all the metacharacters . ^ $ * +   */
+/*      ? { [ ] \ | ( ) would be outputted as is. (In case of           */
+/*      mapserver, when we read the the ogc filter expression, we       */
+/*      convert the wild card character to .*, and we convert the       */
+/*      single character to .  and the escape character to \ all        */
+/*      other are outputted as is)                                      */
+/*        - the  ogc tag would look like <ogc:PropertyIsLike            */
+/*      wildCard="*"  singleChar="." escape="\">                        */
+/*                                                                      */
+/*        - type of potential problem :                                 */
+/*           * if an expression is like /T (star)/ it will be           */
+/*      converted to T* which is not correct.                           */
+/*                                                                      */
+/************************************************************************/
+
+static char *msSLDConvertRegexExpToOgcIsLike(const char *pszRegex) {
+  char szBuffer[1024];
+  int iBuffer = 0, i = 0;
+  int nLength = 0;
+
+  if (!pszRegex || strlen(pszRegex) == 0)
+    return NULL;
+
+  szBuffer[0] = '\0';
+  nLength = strlen(pszRegex);
+
+  while (i < nLength) {
+    if (pszRegex[i] != '.') {
+      szBuffer[iBuffer++] = pszRegex[i];
+      i++;
+    } else {
+      if (i < nLength - 1 && pszRegex[i + 1] == '*') {
+        szBuffer[iBuffer++] = '*';
+        i = i + 2;
+      } else {
+        szBuffer[iBuffer++] = pszRegex[i];
+        i++;
+      }
+    }
+  }
+  szBuffer[iBuffer] = '\0';
+
+  return msStrdup(szBuffer);
+}
+
+/************************************************************************/
+/*                          XMLEscape                                   */
+/************************************************************************/
+static std::string XMLEscape(const char *pszValue) {
+  char *pszEscaped = CPLEscapeString(pszValue, -1, CPLES_XML);
+  std::string osRet(pszEscaped);
+  CPLFree(pszEscaped);
+  return osRet;
+}
+
+static std::string GetPropertyIsEqualTo(const char *pszPropertyName,
+                                        const char *pszLiteral) {
+  std::string osFilter("<ogc:PropertyIsEqualTo><ogc:PropertyName>");
+  osFilter += XMLEscape(pszPropertyName);
+  osFilter += "</ogc:PropertyName><ogc:Literal>";
+  osFilter += XMLEscape(pszLiteral);
+  osFilter += "</ogc:Literal></ogc:PropertyIsEqualTo>";
+  return osFilter;
+}
+
+static std::string GetPropertyIsLike(const char *pszPropertyName,
+                                     const char *pszLiteral) {
+  std::string osFilter("<ogc:PropertyIsLike wildCard=\"*\" singleChar=\".\" "
+                       "escape=\"\\\"><ogc:PropertyName>");
+  osFilter += XMLEscape(pszPropertyName);
+  osFilter += "</ogc:PropertyName><ogc:Literal>";
+  osFilter += XMLEscape(pszLiteral);
+  osFilter += "</ogc:Literal></ogc:PropertyIsLike>";
+  return osFilter;
+}
+
+/************************************************************************/
+/*                              msSLDGetFilter                          */
+/*                                                                      */
+/*      Get the corresponding ogc Filter based on the class             */
+/*      expression. TODO : move function to mapogcfilter.c when         */
+/*      finished.                                                       */
+/************************************************************************/
+char *msSLDGetFilter(classObj *psClass, const char *pszWfsFilter) {
+  char *pszFilter = NULL;
+  char *pszOgcFilter = NULL;
+
+  if (psClass && psClass->expression.string) {
+
+    char *pszExpression = msStrdup(psClass->expression.string);
+
+    /* string expression */
+    if (psClass->expression.type == MS_STRING) {
+
+      // ensure any trailing whitespace is removed
+      msStringTrimBlanks(pszExpression);
+      if (psClass->layer && psClass->layer->classitem) {
+        std::string osFilter("<ogc:Filter>");
+        if (pszWfsFilter) {
+          osFilter += "<ogc:And>";
+          osFilter += pszWfsFilter;
+        }
+        osFilter +=
+            GetPropertyIsEqualTo(psClass->layer->classitem, pszExpression);
+        if (pszWfsFilter) {
+          osFilter += "</ogc:And>";
+        }
+        osFilter += "</ogc:Filter>\n";
+        pszFilter = msStrdup(osFilter.c_str());
+      }
+    } else if (psClass->expression.type == MS_EXPRESSION) {
+      msStringTrimBlanks(pszExpression);
+      pszFilter = msSLDParseLogicalExpression(pszExpression, pszWfsFilter);
+    } else if (psClass->expression.type == MS_LIST) {
+      if (psClass->layer && psClass->layer->classitem) {
+
+        char **listExpressionValues = NULL;
+        int numListExpressionValues = 0;
+        int i = 0;
+        int tokenCount = 0;
+        std::string osOrFilters;
+
+        listExpressionValues =
+            msStringSplit(pszExpression, ',', &numListExpressionValues);
+
+        // loop through all values in the list and create a PropertyIsEqualTo
+        // for each value
+        for (i = 0; i < numListExpressionValues; i++) {
+          if (listExpressionValues[i] && listExpressionValues[i][0] != '\0') {
+            osOrFilters += GetPropertyIsEqualTo(psClass->layer->classitem,
+                                                listExpressionValues[i]);
+            osOrFilters += '\n';
+            tokenCount++;
+          }
+        }
+
+        std::string osFilter("<ogc:Filter>");
+
+        // no need for an OR clause if there is only one item in the list
+        if (tokenCount == 1) {
+          osFilter += osOrFilters;
+        } else if (tokenCount > 1) {
+          osFilter += "<ogc:Or>";
+          osFilter += osOrFilters;
+          osFilter += "</ogc:Or>";
+        }
+        osFilter += "</ogc:Filter>";
+
+        // don't filter when the list is empty
+        if (tokenCount > 0) {
+          pszFilter = msStrdup(osFilter.c_str());
+        }
+        msFreeCharArray(listExpressionValues, numListExpressionValues);
+      }
+    } else if (psClass->expression.type == MS_REGEX) {
+      if (psClass->layer && psClass->layer->classitem) {
+        pszOgcFilter =
+            msSLDConvertRegexExpToOgcIsLike(psClass->expression.string);
+
+        std::string osFilter("<ogc:Filter>");
+        if (pszWfsFilter) {
+          osFilter += "<ogc:And>";
+          osFilter += pszWfsFilter;
+        }
+        osFilter += GetPropertyIsLike(psClass->layer->classitem, pszOgcFilter);
+
+        free(pszOgcFilter);
+
+        if (pszWfsFilter) {
+          osFilter += "</ogc:And>";
+        }
+        osFilter += "</ogc:Filter>\n";
+        pszFilter = msStrdup(osFilter.c_str());
+      }
+    }
+
+    msFree(pszExpression);
+  } else if (pszWfsFilter) {
+    std::string osFilter("<ogc:Filter>");
+    osFilter += pszWfsFilter;
+    osFilter += "</ogc:Filter>\n";
+    pszFilter = msStrdup(osFilter.c_str());
+  }
+  return pszFilter;
+}
diff -pruN 8.0.1-5/src/mapogcsld.h 8.2.0~beta1-1~exp1/src/mapogcsld.h
--- 8.0.1-5/src/mapogcsld.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcsld.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,106 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC SLD implementation
+ * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2003, Y. Assefa, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+MS_DLL_EXPORT char *msSLDGenerateSLD(mapObj *map, int iLayer,
+                                     const char *pszVersion);
+MS_DLL_EXPORT int msSLDApplySLDURL(mapObj *map, const char *szURL, int iLayer,
+                                   const char *pszStyleLayerName,
+                                   char **ppszLayerNames);
+MS_DLL_EXPORT int msSLDApplySLD(mapObj *map, const char *psSLDXML, int iLayer,
+                                const char *pszStyleLayerName,
+                                char **ppszLayerNames);
+int msSLDApplyFromFile(mapObj *map, layerObj *layer, const char *filename);
+
+/* There is a dependency to OGR for the MiniXML parser */
+#include "cpl_minixml.h"
+
+enum objType { MS_OBJ_STYLE, MS_OBJ_LABEL };
+
+/* -------------------------------------------------------------------- */
+/*      prototypes.                                                     */
+/* -------------------------------------------------------------------- */
+layerObj *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers);
+int msSLDParseNamedLayer(CPLXMLNode *psRoot, layerObj *layer);
+int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer,
+                   const char *pszUserStyleName);
+int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle, mapObj *map,
+                     int iColorParam);
+int msSLDParseOgcExpression(CPLXMLNode *psRoot, void *psObj, int binding,
+                            enum objType objtype);
+int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle, mapObj *map);
+
+int msSLDParseLineSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                             int bNewClass, const char *pszUserStyleName);
+int msSLDParsePolygonSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                                int bNewClass, const char *pszUserStyleName);
+int msSLDParsePointSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                              int bNewClass, const char *pszUserStyleName);
+int msSLDParseTextSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                             int bOtherSymboliser,
+                             const char *pszUserStyleName);
+int msSLDParseRasterSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                               const char *pszUserStyleName);
+
+int msSLDParseGraphicFillOrStroke(CPLXMLNode *psGraphicFill, char *pszDashValue,
+                                  styleObj *psStyle, mapObj *map);
+int msSLDParseExternalGraphic(CPLXMLNode *psExternalGraphic, styleObj *psStyle,
+                              mapObj *map);
+
+int msSLDGetLineSymbol(mapObj *map);
+int msSLDGetDashLineSymbol(mapObj *map, char *pszDashArray);
+int msSLDGetMarkSymbol(mapObj *map, char *pszSymbolName, int bFilled);
+int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName, char *extGraphicName,
+                          int nGap);
+
+int msSLDSetColorObject(char *psHexColor, colorObj *psColor);
+
+int msSLDParseTextParams(CPLXMLNode *psRoot, layerObj *psLayer,
+                         classObj *psClass);
+int ParseTextPointPlacement(CPLXMLNode *psRoot, classObj *psClass);
+int ParseTextLinePlacement(CPLXMLNode *psRoot, classObj *psClass);
+
+char *msSLDGenerateSLDLayer(layerObj *psLayer, int nVersion);
+
+char *msSLDGetFilter(classObj *psClass, const char *pszWfsFilter);
+char *msSLDGenerateLineSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
+char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer,
+                              int nVersion);
+char *msSLDGeneratePointSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
+char *msSLDGenerateTextSLD(classObj *psClass, layerObj *psLayer, int nVersion);
+FilterEncodingNode *BuildExpressionTree(char *pszExpression,
+                                        FilterEncodingNode *psNode);
+
+#ifdef __cplusplus
+} /* extern C */
+#endif
diff -pruN 8.0.1-5/src/mapogcsos.c 8.2.0~beta1-1~exp1/src/mapogcsos.c
--- 8.0.1-5/src/mapogcsos.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogcsos.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3512 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC SOS implementation
+ * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2006, Y. Assefa, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#define _GNU_SOURCE
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
+
+#include "maperror.h"
+#include "mapthread.h"
+#include "mapows.h"
+#include "maptime.h"
+#include "mapgml.h"
+#include "mapogcfilter.h"
+
+#include "mapowscommon.h"
+#include "maplibxml2.h"
+
+#include "libxml/parser.h"
+#include "libxml/tree.h"
+#include "libxml/xpath.h"
+#include "libxml/xpathInternals.h"
+
+const char *pszSOSVersion = "1.0.0";
+const char *pszSOSNamespaceUri = "http://www.opengis.net/sos/1.0";
+const char *pszSOSNamespacePrefix = "sos";
+const char *pszOMNamespaceUri = "http://www.opengis.net/om/1.0";
+const char *pszOMNamespacePrefix = "om";
+const char *pszSOSDescribeSensorMimeType =
+    "text/xml; subtype=\"sensorML/1.0.0\"";
+const char *pszSOSGetObservationMimeType = "text/xml; subtype=\"om/1.0.0\"";
+
+typedef struct {
+  char *pszProcedure;
+  xmlNodePtr psResultNode;
+} SOSProcedureNode;
+
+int msSOSParseRequest(mapObj *map, cgiRequestObj *request,
+                      sosParamsObj *sosparams);
+void msSOSFreeParamsObj(sosParamsObj *sosparams);
+
+/*
+** msSOSException()
+**
+** Report current MapServer error in XML exception format.
+** Wrapper function around msOWSCommonExceptionReport. Merely
+** passes SOS specific info.
+**
+*/
+
+static int msSOSException(mapObj *map, char *locator, char *exceptionCode) {
+  int size = 0;
+  char *errorString = NULL;
+  char *schemasLocation = NULL;
+
+  xmlDocPtr psDoc = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
+
+  psNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+
+  errorString = msGetErrorString("\n");
+  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_1_0, schemasLocation, pszSOSVersion,
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+           BAD_CAST "ows");
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+
+  msIO_printf("%s", buffer);
+
+  /*free buffer and the document */
+  free(errorString);
+  free(schemasLocation);
+  xmlFree(buffer);
+  xmlFreeDoc(psDoc);
+  xmlFreeNs(psNsOws);
+
+  /*
+  ** The typical pattern is to call msSOSException() right after
+  ** msSetError().  In order to prevent mapserv.c from re-reporting this
+  ** error at a higher level, we mark it as reported here. #3571
+  */
+  {
+    errorObj *err = msGetErrorObj();
+    if (err != NULL && err->code != MS_NOERR)
+      err->isreported = MS_TRUE;
+  }
+
+  return MS_FAILURE;
+}
+
+static int _IsInList(char **papsProcedures, int nDistinctProcedures,
+                     char *pszProcedure) {
+  int i = 0;
+  if (papsProcedures && nDistinctProcedures > 0 && pszProcedure) {
+    for (i = 0; i < nDistinctProcedures; i++) {
+      if (papsProcedures[i] && strcmp(papsProcedures[i], pszProcedure) == 0)
+        return 1;
+    }
+  }
+  return 0;
+}
+
+/************************************************************************/
+/*                           msSOSValidateFilter                        */
+/*                                                                      */
+/*      Look if the filter's property names have an equivalent          */
+/*      layre's attribute.                                              */
+/************************************************************************/
+static int msSOSValidateFilter(FilterEncodingNode *psFilterNode, layerObj *lp) {
+  int i = 0, bFound = 0;
+  /* assuming here that the layer is opened*/
+  if (psFilterNode && lp) {
+    if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+      for (i = 0; i < lp->numitems; i++) {
+        if (strcasecmp(lp->items[i], psFilterNode->pszValue) == 0) {
+          bFound = 1;
+          break;
+        }
+      }
+      if (!bFound)
+        return MS_FALSE;
+    }
+    if (psFilterNode->psLeftNode &&
+        psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
+      if (msSOSValidateFilter(psFilterNode->psLeftNode, lp) == MS_FALSE)
+        return MS_FALSE;
+    }
+    if (psFilterNode->psRightNode &&
+        psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
+      if (msSOSValidateFilter(psFilterNode->psRightNode, lp) == MS_FALSE)
+        return MS_FALSE;
+    }
+  }
+
+  return MS_TRUE;
+}
+
+/************************************************************************/
+/*                        msSOSAddMetadataChildNode                     */
+/*                                                                      */
+/*      Utility function to add a metadata node.                        */
+/************************************************************************/
+void msSOSAddMetadataChildNode(xmlNodePtr psParent, const char *psNodeName,
+                               xmlNsPtr psNs, hashTableObj *metadata,
+                               const char *psNamespaces,
+                               const char *psMetadataName,
+                               const char *psDefaultValue) {
+  xmlNodePtr psNode = NULL;
+  char *psValue = NULL;
+
+  if (psParent && psNodeName) {
+    psValue = msOWSGetEncodeMetadata(metadata, psNamespaces, psMetadataName,
+                                     psDefaultValue);
+    if (psValue) {
+      psNode =
+          xmlNewChild(psParent, NULL, BAD_CAST psNodeName, BAD_CAST psValue);
+      if (psNs)
+        xmlSetNs(psNode, psNs);
+      free(psValue);
+    }
+  }
+}
+
+/************************************************************************/
+/*                      msSOSGetFirstLayerForOffering                   */
+/*                                                                      */
+/*      return the first layer for the offering.                        */
+/************************************************************************/
+layerObj *msSOSGetFirstLayerForOffering(mapObj *map, const char *pszOffering,
+                                        const char *pszProperty) {
+  layerObj *lp = NULL;
+  const char *pszTmp = NULL;
+  int i = 0;
+
+  if (pszOffering && map) {
+    for (i = 0; i < map->numlayers; i++) {
+      pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                   "offering_id");
+      if (pszTmp && (strcasecmp(pszTmp, pszOffering) == 0)) {
+        if (pszProperty) {
+          pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                       "observedproperty_id");
+          if (pszTmp && (strcasecmp(pszTmp, pszProperty) == 0)) {
+            lp = (GET_LAYER(map, i));
+            break;
+          }
+        } else {
+          lp = (GET_LAYER(map, i));
+          break;
+        }
+      }
+    }
+  }
+  return lp;
+}
+
+xmlNodePtr msSOSAddTimeNode(xmlNsPtr psNs, xmlNsPtr psNsGml, char *pszStart,
+                            char *pszEnd) {
+  xmlNodePtr psNode = NULL;
+
+  char *timeel = NULL;
+
+  if (strcmp((char *)psNs->prefix, "sos") == 0)
+    timeel = "time";
+  if (strcmp((char *)psNs->prefix, "om") == 0)
+    timeel = "samplingTime";
+  else
+    timeel = "time";
+
+  psNode = xmlNewNode(psNs, BAD_CAST timeel);
+  xmlAddChild(psNode, msGML3TimePeriod(psNsGml, pszStart, pszEnd));
+  return psNode;
+}
+
+void msSOSAddPropertyNode(xmlNsPtr psNsSwe, xmlNsPtr psNsXLink,
+                          xmlNodePtr psParent, layerObj *lp, xmlNsPtr psNsGml,
+                          char *pszCompositePhenomenonId) {
+  const char *pszValue = NULL;
+  char *pszTmpVal = NULL, *pszFullName = NULL;
+  xmlNodePtr psCompNode, psNode;
+  int i, j = 0;
+  char szTmp[256];
+  const char *pszComponentBase = "urn:ogc:def:property:";
+
+  if (psParent && lp) {
+    psNode = xmlNewChild(psParent, NULL, BAD_CAST "observedProperty", NULL);
+    psCompNode =
+        xmlNewChild(psNode, psNsSwe, BAD_CAST "CompositePhenomenon", NULL);
+    pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id");
+    pszTmpVal = msStrdup(pszValue);
+
+    if (pszCompositePhenomenonId !=
+        NULL) { /* unique value needs to be constructed */
+      pszTmpVal = msStringConcatenate(pszTmpVal, "_");
+      pszTmpVal = msStringConcatenate(pszTmpVal, pszCompositePhenomenonId);
+    }
+
+    if (pszTmpVal) { /*should always be true */
+      xmlNewNsProp(psCompNode, psNsGml, BAD_CAST "id", BAD_CAST pszTmpVal);
+      msFree(pszTmpVal);
+    }
+
+    pszValue =
+        msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_name");
+    if (pszValue)
+      (void)xmlNewTextChild(psCompNode, psNsGml, BAD_CAST "name",
+                            BAD_CAST pszValue);
+
+    /* add components */
+
+    /*assuming that the layer is opened and msLayerGetItems called*/
+    for (i = 0; i < lp->numitems; i++) {
+      pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
+                                     "observedproperty_authority");
+
+      if (pszValue)
+        pszTmpVal = msStrdup(pszValue);
+      else
+        pszTmpVal = msStrdup("OGC-SWE");
+
+      pszFullName = msStrdup(pszComponentBase);
+
+      pszFullName = msStringConcatenate(pszFullName, pszTmpVal);
+
+      free(pszTmpVal);
+
+      pszFullName = msStringConcatenate(pszFullName, ":");
+
+      pszValue =
+          msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_version");
+
+      if (pszValue)
+        pszTmpVal = msStrdup(pszValue);
+      else
+        pszTmpVal = msStrdup("1");
+
+      pszFullName = msStringConcatenate(pszFullName, pszTmpVal);
+
+      free(pszTmpVal);
+
+      pszFullName = msStringConcatenate(pszFullName, ":");
+
+      snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
+      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
+
+      if (pszValue)
+        pszTmpVal = msStrdup(pszValue);
+      else
+        pszTmpVal = msStrdup(lp->items[i]);
+
+      pszFullName = msStringConcatenate(pszFullName, pszTmpVal);
+
+      psNode = xmlNewChild(psCompNode, psNsSwe, BAD_CAST "component", NULL);
+
+      xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszFullName);
+      free(pszFullName);
+      free(pszTmpVal);
+      j++;
+    }
+    pszTmpVal = msIntToString(j);
+    xmlNewNsProp(psCompNode, NULL, BAD_CAST "dimension", BAD_CAST pszTmpVal);
+    free(pszTmpVal);
+  }
+}
+
+/************************************************************************/
+/*                           msSOSAddGeometryNode                       */
+/*                                                                      */
+/*      Outout gml 2 gemptry nodes based on a shape. All logic comes    */
+/*      from gmlWriteGeometry_GML2. Should be merged at one point if    */
+/*      possible.                                                       */
+/************************************************************************/
+void msSOSAddGeometryNode(xmlNsPtr psNsGml, xmlNsPtr psNsMs,
+                          xmlNodePtr psParent, mapObj *map, layerObj *lp,
+                          shapeObj *psShape, const char *pszEpsg_in) {
+  char *pszTmp = NULL;
+  int i, j = 0;
+  xmlNodePtr psPointNode, psNode, psLineNode, psPolygonNode;
+  int *panOuterList = NULL, *panInnerList = NULL;
+  const char *pszEpsg = pszEpsg_in;
+  char *pszEpsg_buf = NULL;
+
+  if (psParent && psShape) {
+    if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
+      reprojectionObj *reprojector = msLayerGetReprojectorToMap(lp, map);
+      if (reprojector) {
+        msProjectShapeEx(reprojector, psShape);
+      }
+      msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE,
+                       &pszEpsg_buf);
+      pszEpsg = pszEpsg_buf;
+    }
+    switch (psShape->type) {
+    case (MS_SHAPE_POINT):
+      psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
+      xmlSetNs(psNode, psNsMs);
+      if (psShape->line[0].numpoints > 1) {
+        psPointNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiPoint", NULL);
+        xmlSetNs(psPointNode, psNsGml);
+
+        if (pszEpsg)
+          xmlNewProp(psPointNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+      } else
+        psPointNode = psNode;
+
+      /*add all points */
+      for (i = 0; i < psShape->line[0].numpoints; i++) {
+        psNode =
+            xmlAddChild(psPointNode, msGML3Point(psNsGml, pszEpsg, NULL,
+                                                 psShape->line[0].point[i].x,
+                                                 psShape->line[0].point[i].y));
+      }
+      break;
+
+    case (MS_SHAPE_LINE):
+      psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
+      xmlSetNs(psNode, xmlNewNs(psNode, NULL, NULL));
+      if (psShape->numlines > 1) {
+        psLineNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "MultiLineString", NULL);
+        xmlSetNs(psLineNode,
+                 xmlNewNs(psLineNode, BAD_CAST "http://www.opengis.net/gml",
+                          BAD_CAST "gml"));
+
+        if (pszEpsg)
+          xmlNewProp(psLineNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+      } else
+        psLineNode = psNode;
+
+      for (i = 0; i < psShape->numlines; i++) {
+        if (psShape->numlines > 1) {
+          psNode =
+              xmlNewChild(psLineNode, NULL, BAD_CAST "lineStringMember", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+          psNode = xmlNewChild(psNode, NULL, BAD_CAST "LineString", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+        } else {
+          psNode = xmlNewChild(psLineNode, NULL, BAD_CAST "LineString", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+        }
+        if (pszEpsg)
+          xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+
+        pszTmp = NULL;
+        for (j = 0; j < psShape->line[i].numpoints; j++) {
+          char *doubleTmp =
+              msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, ",");
+          free(doubleTmp);
+          doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, ",");
+          free(doubleTmp);
+        }
+        psNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+        free(pszTmp);
+      }
+
+      break;
+
+    case (MS_SHAPE_POLYGON):
+      psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
+      xmlSetNs(psNode, xmlNewNs(psNode, NULL, NULL));
+      if (psShape->numlines > 1) {
+        psPolygonNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "MultiPolygon", NULL);
+        xmlSetNs(psPolygonNode,
+                 xmlNewNs(psPolygonNode, BAD_CAST "http://www.opengis.net/gml",
+                          BAD_CAST "gml"));
+
+        if (pszEpsg)
+          xmlNewProp(psPolygonNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+      } else
+        psPolygonNode = psNode;
+
+      panOuterList = msGetOuterList(psShape);
+
+      for (i = 0; i < psShape->numlines; i++) {
+        if (panOuterList[i] != MS_TRUE)
+          continue;
+
+        panInnerList = msGetInnerList(psShape, i, panOuterList);
+
+        if (psShape->numlines > 1) {
+          psNode =
+              xmlNewChild(psPolygonNode, NULL, BAD_CAST "polygonMember", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+          psNode = xmlNewChild(psNode, NULL, BAD_CAST "Polygon", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+        } else {
+          psNode = xmlNewChild(psPolygonNode, NULL, BAD_CAST "Polygon", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+        }
+        if (pszEpsg)
+          xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+
+        psNode = xmlNewChild(psNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+        psNode = xmlNewChild(psNode, NULL, BAD_CAST "LinearRing", NULL);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+
+        pszTmp = NULL;
+        for (j = 0; j < psShape->line[i].numpoints; j++) {
+          char *doubleTmp;
+          doubleTmp = msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, ",");
+          free(doubleTmp);
+          doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, " ");
+          free(doubleTmp);
+        }
+        psNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+        free(pszTmp);
+
+        if (panInnerList)
+          free(panInnerList);
+      }
+
+      if (panOuterList)
+        free(panOuterList);
+
+      break;
+
+    default:
+      break;
+    }
+  }
+  msFree(pszEpsg_buf);
+}
+
+/************************************************************************/
+/*          void msSOSAddDataBlockDefinition(xmlNodePtr psParent,       */
+/*      layerObj *lp)                                                   */
+/*                                                                      */
+/*      Add a databalock used for GetObservation request.               */
+/************************************************************************/
+void msSOSAddDataBlockDefinition(xmlNsPtr psNsSwe, xmlNodePtr psParent,
+                                 layerObj *lp) {
+  xmlNodePtr psNode, psRecordNode, psCompNode, psSubNode, psEncNode;
+  const char *pszDefinition = NULL, *pszUom = NULL, *pszValue = NULL,
+             *pszName = NULL;
+  char szTmp[100];
+  int i = 0;
+  char *pszTokenValue = NULL;
+  char *pszBlockValue = NULL;
+  const char *pszBlockSep = NULL, *pszTokenSep = NULL;
+
+  if (psParent) {
+    psNode = xmlNewChild(psParent, NULL, BAD_CAST "DataBlockDefinition", NULL);
+    xmlSetNs(psNode, psNsSwe);
+
+    /* -------------------------------------------------------------------- */
+    /*      Add components.                                                 */
+    /* -------------------------------------------------------------------- */
+    psCompNode = xmlNewChild(psNode, NULL, BAD_CAST "components", NULL);
+    psEncNode = xmlNewChild(psNode, NULL, BAD_CAST "encoding", NULL);
+    psRecordNode = xmlNewChild(psCompNode, NULL, BAD_CAST "DataRecord", NULL);
+
+    /*always add a time field if timeitem is defined*/
+    if (msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem")) {
+      psNode = xmlNewChild(psRecordNode, NULL, BAD_CAST "field", NULL);
+      xmlNewNsProp(psNode, NULL, BAD_CAST "name", BAD_CAST "time");
+      psNode = xmlNewChild(psNode, NULL, BAD_CAST "Time", NULL);
+      xmlNewNsProp(psNode, NULL, BAD_CAST "definition",
+                   BAD_CAST "urn:ogc:phenomenon:time:iso8601");
+    }
+    /*add all other fields*/
+    /*assuming that the layer is open */
+    for (i = 0; i < lp->numitems; i++) {
+      snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
+      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
+      if (pszValue) {
+        psNode = xmlNewChild(psRecordNode, NULL, BAD_CAST "field", NULL);
+
+        /* check if there is an alias/full name used */
+        snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
+        pszName = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
+        if (!pszName)
+          pszName = lp->items[i];
+
+        xmlNewNsProp(psNode, NULL, BAD_CAST "name", BAD_CAST pszName);
+
+        psNode = xmlNewChild(psNode, NULL, BAD_CAST "Quantity", NULL);
+
+        /* get definition and uom */
+        snprintf(szTmp, sizeof(szTmp), "%s_definition", lp->items[i]);
+        pszDefinition = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
+
+        if (pszDefinition == NULL)
+          pszDefinition = "urn:ogc:object:definition";
+
+        xmlNewNsProp(psNode, NULL, BAD_CAST "definition",
+                     BAD_CAST pszDefinition);
+
+        snprintf(szTmp, sizeof(szTmp), "%s_uom", lp->items[i]);
+        pszUom = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
+
+        if (pszUom == NULL)
+          pszUom = "urn:ogc:object:uom";
+
+        psNode = xmlNewChild(psNode, NULL, BAD_CAST "uom", NULL);
+        xmlNewNsProp(psNode, NULL, BAD_CAST "code", BAD_CAST pszUom);
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Add encoding block.                                             */
+    /* -------------------------------------------------------------------- */
+    pszBlockSep = msOWSLookupMetadata(&(lp->map->web.metadata), "S",
+                                      "encoding_blockSeparator");
+    pszTokenSep = msOWSLookupMetadata(&(lp->map->web.metadata), "S",
+                                      "encoding_tokenSeparator");
+
+    psSubNode = xmlNewChild(psEncNode, NULL, BAD_CAST "TextBlock", NULL);
+
+    if (pszTokenSep)
+      pszTokenValue = msStringConcatenate(pszTokenValue, (char *)pszTokenSep);
+    else
+      pszTokenValue = msStringConcatenate(pszTokenValue, ",");
+
+    xmlNewNsProp(psSubNode, NULL, BAD_CAST "tokenSeparator",
+                 BAD_CAST pszTokenValue);
+
+    if (pszBlockSep)
+      pszBlockValue = msStringConcatenate(pszBlockValue, (char *)pszBlockSep);
+    else
+      pszBlockValue = msStringConcatenate(pszBlockValue, "\n");
+
+    xmlNewNsProp(psSubNode, NULL, BAD_CAST "blockSeparator",
+                 BAD_CAST pszBlockValue);
+
+    xmlNewNsProp(psSubNode, NULL, BAD_CAST "decimalSeparator", BAD_CAST ".");
+
+    msFree(pszTokenValue);
+    msFree(pszBlockValue);
+  }
+}
+
+/************************************************************************/
+/*                            msSOSAddMemberNode                        */
+/*                                                                      */
+/*      Add a memeber node corresponding to a feature.                  */
+/*      Assuming that the layer is opened and msLayerGetItems is        */
+/*      called on it.                                                   */
+/************************************************************************/
+void msSOSAddMemberNode(xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe,
+                        xmlNsPtr psNsXLink, xmlNsPtr psNsMs,
+                        xmlNodePtr psParent, mapObj *map, layerObj *lp,
+                        int iFeatureId, const char *script_url,
+                        const char *opLayerName) {
+  xmlNodePtr psObsNode, psNode, psLayerNode = NULL;
+  const char *pszValue = NULL;
+  char *pszEpsg = NULL;
+  int status, i, j;
+  shapeObj sShape;
+  char szTmp[256];
+  layerObj *lpfirst = NULL;
+  const char *pszTimeField = NULL;
+  char *pszTmp = NULL;
+  char *pszOid = NULL;
+  char *pszTime = NULL;
+  char *pszValueShape = NULL;
+  const char *pszFeatureId = NULL;
+
+  if (psParent) {
+    msInitShape(&sShape);
+
+    status =
+        msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
+    if (status != MS_SUCCESS) {
+      xmlFreeNs(psNsOm);
+      return;
+    }
+
+    psNode = xmlNewChild(psParent, NULL, BAD_CAST "member", NULL);
+
+    psObsNode =
+        xmlNewChild(psNode, NULL, BAD_CAST "Observation", BAD_CAST pszValue);
+
+    pszFeatureId = msOWSLookupMetadata(&(lp->metadata), "OSG", "featureid");
+
+    if (pszFeatureId && msLayerGetItems(lp) == MS_SUCCESS) {
+      /* find the featureid amongst the items for this layer */
+      for (j = 0; j < lp->numitems; j++) {
+        if (strcasecmp(lp->items[j], pszFeatureId) == 0) { /* found it  */
+          break;
+        }
+      }
+      if (j < lp->numitems) {
+        pszOid = msStringConcatenate(pszOid, "o_");
+        pszOid = msStringConcatenate(pszOid, sShape.values[j]);
+        xmlNewNsProp(psObsNode, psNsGml, BAD_CAST "id", BAD_CAST pszOid);
+      }
+    }
+
+    /* order of elements is time, location, procedure, observedproperty
+     featureofinterest, result */
+
+    /* time*/
+    pszTimeField = msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem");
+    if (pszTimeField && sShape.values) {
+      for (i = 0; i < lp->numitems; i++) {
+        if (strcasecmp(lp->items[i], pszTimeField) == 0) {
+          if (sShape.values[i] && strlen(sShape.values[i]) > 0) {
+            pszTime = msStringConcatenate(pszTime, sShape.values[i]);
+            psNode =
+                xmlNewChild(psObsNode, psNsOm, BAD_CAST "samplingTime", NULL);
+            xmlAddChild(psNode, msGML3TimeInstant(psNsGml, pszTime));
+            msFree(pszTime);
+          }
+          break;
+        }
+      }
+    }
+    /*TODO add location*/
+
+    /*procedure*/
+    /* if a procedure_item is defined, we should extract the value for the
+       attributes. If not dump what is found in the procedure metadata bug
+       2054*/
+    if ((pszValue =
+             msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))) {
+      lpfirst = msSOSGetFirstLayerForOffering(
+          map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+          msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
+
+      if (lp != lpfirst)
+        status = msLayerOpen(lpfirst);
+      if (status == MS_SUCCESS && msLayerGetItems(lpfirst) == MS_SUCCESS) {
+        for (i = 0; i < lpfirst->numitems; i++) {
+          if (strcasecmp(lpfirst->items[i], pszValue) == 0) {
+            break;
+          }
+        }
+        if (i < lpfirst->numitems && sShape.values) {
+          snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
+          pszTmp = msStringConcatenate(pszTmp, szTmp);
+          pszValueShape = msEncodeHTMLEntities(sShape.values[i]);
+          pszTmp = msStringConcatenate(pszTmp, pszValueShape);
+
+          psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
+          xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
+          msFree(pszTmp);
+          pszTmp = NULL;
+          msFree(pszValueShape);
+        }
+        /*else should we generate a warning !*/
+        if (lp != lpfirst)
+          msLayerClose(lpfirst);
+      }
+
+    } else if ((pszValue =
+                    msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))) {
+      if (!msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))
+        xmlAddSibling(
+            psNode,
+            xmlNewComment(
+                BAD_CAST
+                "WARNING: Optional metadata \"sos_procedure_item\" missing for "
+                "sos:procedure.  If you have more than 1 procedures, "
+                "sos:procedure will output them incorrectly."));
+
+      snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
+      pszTmp = msStringConcatenate(pszTmp, szTmp);
+      pszTmp = msStringConcatenate(pszTmp, (char *)pszValue);
+
+      psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
+      xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
+      msFree(pszTmp);
+      pszTmp = NULL;
+    }
+
+    /*observed property*/
+    pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id");
+    if (pszValue)
+      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lp, psNsGml, pszOid);
+    msFree(pszOid);
+    pszOid = NULL;
+
+    /*TODO add featureofinterest*/
+
+    pszTmp = msStringConcatenate(pszTmp, (char *)script_url);
+    pszTmp = msStringConcatenate(
+        pszTmp,
+        "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
+    pszTmp = msStringConcatenate(pszTmp, (char *)opLayerName);
+
+    psNode = xmlNewChild(psObsNode, psNsOm, BAD_CAST "featureOfInterest", NULL);
+    xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
+
+    msFree(pszTmp);
+    pszTmp = NULL;
+
+    /* add result : gml:featureMember of all selected elements */
+    psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "result", NULL);
+
+    /*TODO should we add soemwhere the units of the value :
+      <om:result uom="units.xml#cm">29.00</om:result> */
+
+    if (msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+      reprojectionObj *reprojector = msLayerGetReprojectorToMap(lp, map);
+      if (reprojector) {
+        msProjectShapeEx(reprojector, &sShape);
+      }
+    }
+
+    psNode = xmlNewChild(psNode, psNsGml, BAD_CAST "featureMember", NULL);
+    /* xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+     * BAD_CAST "gml")); */
+
+    /*TODO : add namespaces like wfs " ms and a url to mapserve ? */
+    psLayerNode = xmlNewChild(psNode, psNsMs, BAD_CAST lp->name, NULL);
+
+    /* fetch gml:id */
+
+    pszFeatureId = msOWSLookupMetadata(&(lp->metadata), "OSG", "featureid");
+
+    if (pszFeatureId && msLayerOpen(lp) == MS_SUCCESS &&
+        msLayerGetItems(lp) == MS_SUCCESS)
+
+      xmlSetNs(psLayerNode, psNsMs);
+
+    /*bbox*/
+
+    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE,
+                     &pszEpsg);
+    if (!pszEpsg)
+      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "SO", MS_TRUE,
+                       &pszEpsg);
+
+    if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE)
+      msProjectRect(&lp->projection, &map->projection, &sShape.bounds);
+
+    psNode = xmlAddChild(psLayerNode,
+                         msGML3BoundedBy(psNsGml, sShape.bounds.minx,
+                                         sShape.bounds.miny, sShape.bounds.maxx,
+                                         sShape.bounds.maxy, pszEpsg));
+
+    /*geometry*/
+    msSOSAddGeometryNode(psNsGml, psNsMs, psLayerNode, map, lp, &sShape,
+                         pszEpsg);
+    msFree(pszEpsg);
+
+    /*attributes */
+    /* TODO only output attributes where there is a sos_%s_alias (to be
+     * discussed)*/
+    /* the first layer is the one that has to have all the metadata defined */
+    lpfirst = msSOSGetFirstLayerForOffering(
+        map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+        msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
+
+    if (lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
+        msLayerGetItems(lpfirst) == MS_SUCCESS) {
+      for (i = 0; i < lpfirst->numitems; i++) {
+        snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
+        pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
+        if (pszValue && sShape.values) {
+          for (j = 0; j < lp->numitems; j++) {
+            if (strcasecmp(lpfirst->items[i], lpfirst->items[j]) == 0) {
+              /*if there is an alias used, use it to output the
+                parameter name : eg "sos_AMMON_DIS_alias" "Amonia"  */
+              snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
+              pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
+              pszValueShape = msEncodeHTMLEntities(sShape.values[j]);
+
+              if (pszValue) {
+                pszTmp = msEncodeHTMLEntities(pszValue);
+                psNode = xmlNewChild(psLayerNode, psNsMs, BAD_CAST pszValue,
+                                     BAD_CAST pszValueShape);
+                free(pszTmp);
+              } else {
+                pszTmp = msEncodeHTMLEntities(lpfirst->items[i]);
+                psNode =
+                    xmlNewChild(psLayerNode, psNsMs, BAD_CAST lpfirst->items[i],
+                                BAD_CAST pszValueShape);
+                free(pszTmp);
+              }
+
+              free(pszValueShape);
+              xmlSetNs(psNode, psNsMs);
+              break;
+            }
+          }
+        }
+      }
+      if (lp->index != lpfirst->index)
+        msLayerClose(lpfirst);
+    }
+    msFreeShape(&sShape);
+  }
+}
+
+/************************************************************************/
+/*                           msSOSReturnMemberResult                    */
+/*                                                                      */
+/*      Add a result string to the result node (used for                */
+/*      GetObservation using "observation" as the response output.      */
+/*      Assuming here that the layer is already opened.                 */
+/************************************************************************/
+char *msSOSReturnMemberResult(layerObj *lp, int iFeatureId,
+                              char **ppszProcedure) {
+  char *pszFinalValue = NULL;
+  shapeObj sShape;
+  int i, j, status;
+  layerObj *lpfirst;
+  const char *pszTimeField = NULL, *pszValue = NULL, *pszProcedureField = NULL;
+  char *pszValueShape = NULL;
+  char szTmp[100];
+  const char *pszSep = NULL;
+
+  msInitShape(&sShape);
+  status =
+      msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
+  if (status != MS_SUCCESS)
+    return NULL;
+
+  pszTimeField = msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem");
+  if (pszTimeField && sShape.values) {
+    for (i = 0; i < lp->numitems; i++) {
+      if (strcasecmp(lp->items[i], pszTimeField) == 0) {
+        pszFinalValue = msStringConcatenate(pszFinalValue, sShape.values[i]);
+        break;
+      }
+    }
+  }
+  if (ppszProcedure && sShape.values) {
+    pszProcedureField =
+        msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item");
+    for (i = 0; i < lp->numitems; i++) {
+      if (strcasecmp(lp->items[i], pszProcedureField) == 0) {
+        (*ppszProcedure) = msStrdup(sShape.values[i]);
+        break;
+      }
+    }
+  }
+
+  /* the first layer is the one that has to have all the metadata defined */
+  lpfirst = msSOSGetFirstLayerForOffering(
+      lp->map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+      msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
+
+  if (sShape.values &&
+      (lp == lpfirst || (lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
+                         msLayerGetItems(lpfirst) == MS_SUCCESS))) {
+    pszSep = msOWSLookupMetadata(&(lp->map->web.metadata), "S",
+                                 "encoding_tokenSeparator");
+    for (i = 0; i < lpfirst->numitems; i++) {
+      snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
+      pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
+      if (pszValue) {
+        for (j = 0; j < lp->numitems; j++) {
+          if (strcasecmp(lpfirst->items[i], lpfirst->items[j]) == 0) {
+            pszValueShape = msEncodeHTMLEntities(sShape.values[j]);
+
+            if (pszFinalValue) {
+              if (pszSep)
+                pszFinalValue =
+                    msStringConcatenate(pszFinalValue, (char *)pszSep);
+              else
+                pszFinalValue = msStringConcatenate(pszFinalValue, ",");
+            }
+            pszFinalValue = msStringConcatenate(pszFinalValue, pszValueShape);
+
+            msFree(pszValueShape);
+          }
+        }
+      }
+    }
+  }
+  msFreeShape(&sShape);
+  return pszFinalValue;
+}
+
+/************************************************************************/
+/*                      msSOSAddMemberNodeObservation                   */
+/*                                                                      */
+/*      Add a member node used for getObservation request using         */
+/*      Observation as the result format.                               */
+/************************************************************************/
+static xmlNodePtr msSOSAddMemberNodeObservation(
+    xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe, xmlNsPtr psNsXLink,
+    xmlNodePtr psParent, mapObj *map, layerObj *lp, const char *pszProcedure) {
+  char *pszTmp = NULL;
+  xmlNodePtr psNode = NULL, psObsNode = NULL, psMemberNode = NULL;
+  layerObj *lpfirst;
+  const char *value = NULL;
+
+  /*always featch the first layer that has the same offering id and observered
+  propery. This allows to only define all the attributes and components on the
+  first layer if the user wants to present several mapserver layers as the same
+  offering.*/
+  lpfirst = msSOSGetFirstLayerForOffering(
+      map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+      msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
+  if (psParent) {
+    psMemberNode = xmlNewChild(psParent, NULL, BAD_CAST "member", NULL);
+    psObsNode = xmlNewChild(psMemberNode, NULL, BAD_CAST "Observation", NULL);
+
+    /*time*/
+    /* ??TODO : sampling time is a manadatory element but uses a non mandatory
+     * metadata sos_offering_timeextent */
+    value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_timeextent");
+    if (value) {
+      char **tokens;
+      int n;
+      char *pszEndTime = NULL;
+      tokens = msStringSplit(value, '/', &n);
+      if (tokens == NULL || (n != 1 && n != 2)) {
+        msSetError(MS_SOSERR,
+                   "Wrong number of arguments for sos_offering_timeextent.",
+                   "msSOSGetObservation()");
+        msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
+        return NULL;
+      }
+
+      if (n == 2) /* end time is empty. It is going to be set as "now*/
+        pszEndTime = tokens[1];
+
+      psNode = xmlAddChild(
+          psObsNode, msSOSAddTimeNode(psNsOm, psNsGml, tokens[0], pszEndTime));
+      msFreeCharArray(tokens, n);
+    }
+
+    /* procedure */
+    if (pszProcedure) { /*this should always be true since procedure is a
+                           manadtory element*/
+      if (!msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item") &&
+          msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))
+        xmlAddSibling(
+            psNode,
+            xmlNewComment(
+                BAD_CAST
+                "WARNING: Optional metadata \"sos_procedure_item\" missing for "
+                "sos:procedure.  If you have more than 1 procedures, "
+                "sos:procedure will output them incorrectly."));
+
+      pszTmp = msStringConcatenate(pszTmp, "urn:ogc:def:procedure:");
+      pszTmp = msStringConcatenate(pszTmp, (char *)pszProcedure);
+      psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
+      /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST
+       * "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST "href",
+       * BAD_CAST pszTmp); */
+      xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
+      msFree(pszTmp);
+      pszTmp = NULL;
+    }
+
+    /*observed propery and components*/
+    if (lp != lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
+        msLayerGetItems(lpfirst) == MS_SUCCESS) {
+      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml,
+                           NULL);
+      msLayerClose(lpfirst);
+    } else
+      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml,
+                           NULL);
+
+    /* result definition*/
+    psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "resultDefinition", NULL);
+    msSOSAddDataBlockDefinition(psNsSwe, psNode, lpfirst);
+  }
+
+  return psObsNode;
+}
+
+/************************************************************************/
+/*                            msSOSParseTimeGML                         */
+/*                                                                      */
+/*      Utility function to convert a gml time value to a               */
+/*      string. Supported gml times are :                               */
+/*                                                                      */
+/*       -  <gml:TimePeriod>                                            */
+/*           <gml:beginPosition>2005-09-01T11:54:32</gml:beginPosition> */
+/*            <gml:endPosition>2005-09-02T14:54:32</gml:endPosition>    */
+/*          </gml:TimePeriod>                                           */
+/*        This will be converted to startime/endtime                    */
+/*                                                                      */
+/*       - <gml:TimeInstant>                                            */
+/*           <gml:timePosition>2003-02-13T12:28-08:00</gml:timePosition>*/
+/*           </gml:TimeInstant>                                         */
+/*       This will retunr the timevalue as a string.                    */
+/*                                                                      */
+/*       The caller of the function should free the return value.       */
+/************************************************************************/
+char *msSOSParseTimeGML(char *pszGmlTime) {
+  char *pszReturn = NULL, *pszBegin = NULL, *pszEnd = NULL;
+  CPLXMLNode *psRoot = NULL, *psChild = NULL;
+  CPLXMLNode *psTime = NULL, *psBegin = NULL, *psEnd = NULL;
+  struct tm tm_struct;
+
+  if (pszGmlTime) {
+    psRoot = CPLParseXMLString(pszGmlTime);
+    if (!psRoot)
+      return NULL;
+    CPLStripXMLNamespace(psRoot, "gml", 1);
+
+    if (psRoot->eType == CXT_Element &&
+        (EQUAL(psRoot->pszValue, "TimePeriod") ||
+         EQUAL(psRoot->pszValue, "TimeInstant"))) {
+      if (EQUAL(psRoot->pszValue, "TimeInstant")) {
+        psChild = psRoot->psChild;
+        if (psChild && EQUAL(psChild->pszValue, "timePosition")) {
+          psTime = psChild->psNext;
+          if (psTime && psTime->pszValue && psTime->eType == CXT_Text) {
+            if (msParseTime(psTime->pszValue, &tm_struct) == MS_TRUE)
+              pszReturn = msStrdup(psTime->pszValue);
+          }
+        }
+      } else {
+        psBegin = psRoot->psChild;
+        if (psBegin)
+          psEnd = psBegin->psNext;
+
+        if (psBegin && EQUAL(psBegin->pszValue, "beginPosition") && psEnd &&
+            EQUAL(psEnd->pszValue, "endPosition")) {
+          if (psBegin->psChild && psBegin->psChild->pszValue &&
+              psBegin->psChild->eType == CXT_Text)
+            pszBegin = msStrdup(psBegin->psChild->pszValue);
+
+          if (psEnd->psChild && psEnd->psChild->pszValue &&
+              psEnd->psChild->eType == CXT_Text)
+            pszEnd = msStrdup(psEnd->psChild->pszValue);
+
+          if (pszBegin && pszEnd) {
+            if (msParseTime(pszBegin, &tm_struct) == MS_TRUE &&
+                msParseTime(pszEnd, &tm_struct) == MS_TRUE) {
+              pszReturn = msStrdup(pszBegin);
+              pszReturn = msStringConcatenate(pszReturn, "/");
+              pszReturn = msStringConcatenate(pszReturn, pszEnd);
+            }
+          }
+          msFree(pszBegin);
+          msFree(pszEnd);
+        }
+      }
+    }
+  }
+  CPLDestroyXMLNode(psRoot);
+  return pszReturn;
+}
+
+/************************************************************************/
+/*                           msSOSGetCapabilities                       */
+/*                                                                      */
+/*      getCapabilities request handler.                                */
+/************************************************************************/
+int msSOSGetCapabilities(mapObj *map, sosParamsObj *sosparams,
+                         cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode, psMainNode, psNode;
+  xmlNodePtr psOfferingNode;
+
+  char *schemalocation = NULL;
+  char *xsi_schemaLocation = NULL;
+  char *script_url = NULL;
+  const char *updatesequence = NULL;
+
+  int i, j, k;
+  layerObj *lp = NULL, *lpTmp = NULL;
+  const char *value = NULL;
+  char *pszTmp = NULL;
+  char *pszProcedure = NULL;
+  char szTmp[256];
+
+  /* array of offering */
+  char **papsOfferings = NULL;
+  int nOfferings = 0, nCurrentOff = -1;
+  int nProperties = 0;
+  char **papszProperties = NULL;
+
+  int iItemPosition = -1;
+  shapeObj sShape;
+  int status;
+
+  /* for each layer it indicates the indice to be used in papsOfferings
+     (to associate it with the offering) */
+  int *panOfferingLayers = NULL;
+
+  char **papsProcedures = NULL;
+  int nDistinctProcedures = 0;
+
+  xmlNsPtr psNsGml = NULL;
+  xmlNsPtr psNsSos = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlNsPtr psNsOgc = NULL;
+  xmlNsPtr psNsXLink = NULL;
+  xmlNsPtr psNsSwe = NULL;
+
+  xmlChar *buffer = NULL;
+  int size = 0;
+  msIOContext *context = NULL;
+
+  int ows_version = OWS_1_1_0;
+
+  int sosSupportedVersions[] = {OWS_1_0_0};
+  int sosNumSupportedVersions = 1;
+
+  /* acceptversions: do OWS Common style of version negotiation */
+  if (sosparams->pszAcceptVersions) {
+    char **tokens;
+    int i, j, k = -1;
+
+    tokens = msStringSplit(sosparams->pszAcceptVersions, ',', &j);
+
+    for (i = 0; i < j; i++) {
+      int iVersion = 0;
+
+      iVersion = msOWSParseVersionString(tokens[i]);
+
+      if (iVersion == -1) {
+        msSetError(MS_SOSERR, "Invalid version format : %s.",
+                   "msSOSGetCapabilities()", tokens[i]);
+        msFreeCharArray(tokens, j);
+        return msSOSException(map, "acceptversions",
+                              "VersionNegotiationFailed");
+      }
+
+      /* negotiate version */
+      k = msOWSCommonNegotiateVersion(iVersion, sosSupportedVersions,
+                                      sosNumSupportedVersions);
+
+      if (k != -1)
+        break;
+    }
+    msFreeCharArray(tokens, j);
+
+    if (k == -1) {
+      msSetError(
+          MS_SOSERR,
+          "ACCEPTVERSIONS list (%s) does not match supported versions (%s)",
+          "msSOSGetCapabilities()", sosparams->pszAcceptVersions,
+          pszSOSVersion);
+      return msSOSException(map, "acceptversions", "VersionNegotiationFailed");
+    }
+  }
+
+  /* updateSequence */
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "SO", "updatesequence");
+
+  if (sosparams->pszUpdateSequence != NULL) {
+    i = msOWSNegotiateUpdateSequence(sosparams->pszUpdateSequence,
+                                     updatesequence);
+    if (i == 0) { /* current */
+      msSetError(MS_SOSERR,
+                 "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+                 "msSOSGetCapabilities()", sosparams->pszUpdateSequence,
+                 updatesequence);
+      return msSOSException(map, "updatesequence", "CurrentUpdateSequence");
+    }
+    if (i > 0) { /* invalid */
+      msSetError(MS_SOSERR,
+                 "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+                 "msSOSGetCapabilities()", sosparams->pszUpdateSequence,
+                 updatesequence);
+      return msSOSException(map, "updatesequence", "InvalidUpdateSequence");
+    }
+  }
+
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "Capabilities");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  psNsGml =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
+  psNsSos = xmlNewNs(NULL, BAD_CAST pszSOSNamespaceUri,
+                     BAD_CAST pszSOSNamespacePrefix);
+  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                     BAD_CAST "swe");
+
+  /* name spaces */
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml",
+                    BAD_CAST "gml"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0",
+                    BAD_CAST "om"));
+
+  psNsOws = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+                     BAD_CAST "ows");
+  xmlSetNs(psRootNode, psNsOws);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                    BAD_CAST "swe"));
+
+  psNsXLink =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlSetNs(psRootNode, psNsXLink);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri,
+                                BAD_CAST pszSOSNamespacePrefix));
+
+  /*version fixed for now*/
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST pszSOSVersion);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "SO", "updatesequence");
+
+  if (value)
+    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST value);
+
+  /*schema fixed*/
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStrdup(pszSOSNamespaceUri);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/sos/");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)pszSOSVersion);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/sosGetCapabilities.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+
+  /*service identification*/
+  xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
+                              psNsOws, map, "SOS", pszSOSVersion, "SO", NULL));
+
+  /*service provider*/
+  xmlAddChild(psRootNode,
+              msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "SO", NULL));
+
+  /*operation metadata */
+
+  if ((script_url = msOWSGetOnlineResource(map, "SO", "onlineresource", req)) ==
+      NULL) {
+    free(xsi_schemaLocation);
+    free(schemalocation);
+    return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
+  }
+
+  psMainNode = xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psNsOws));
+
+  psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                       psNsOws, psNsXLink, "GetCapabilities",
+                                       OWS_METHOD_GETPOST, (char *)script_url));
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "service", "SOS"));
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "version",
+                          (char *)pszSOSVersion));
+
+  if (msOWSRequestIsEnabled(map, NULL, "S", "DescribeSensor", MS_TRUE)) {
+    psNode =
+        xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                    psNsOws, psNsXLink, "DescribeSensor",
+                                    OWS_METHOD_GETPOST, (char *)script_url));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "service", "SOS"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "version",
+                            (char *)pszSOSVersion));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "sensorid",
+                            "urn:ogc:object:procedure"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "outputFormat",
+                            (char *)pszSOSDescribeSensorMimeType));
+  }
+
+  if (msOWSRequestIsEnabled(map, NULL, "S", "DescribeObservationType",
+                            MS_TRUE)) {
+    psNode = xmlAddChild(psMainNode,
+                         msOWSCommonOperationsMetadataOperation(
+                             psNsOws, psNsXLink, "DescribeObservationType",
+                             OWS_METHOD_GETPOST, (char *)script_url));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "service", "SOS"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "version",
+                            (char *)pszSOSVersion));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "observedproperty",
+                    "urn:ogc:object:observedproperty"));
+  }
+
+  if (msOWSRequestIsEnabled(map, NULL, "S", "GetObservation", MS_TRUE)) {
+    psNode =
+        xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                    psNsOws, psNsXLink, "GetObservation",
+                                    OWS_METHOD_GETPOST, (char *)script_url));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "service", "SOS"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "version",
+                            (char *)pszSOSVersion));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "offering",
+                            "urn:ogc:object:offering"));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "observedproperty",
+                    "urn:ogc:object:observedproperty"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "eventtime",
+                            "sos:time"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "procedure",
+                            "urn:ogc:object:sensor"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter",
+                            "featureofinterest", "gml:location"));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "result", "ogc:Filter"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "responseFormat",
+                            (char *)pszSOSGetObservationMimeType));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "resultModel",
+                            "Observation,Measurement"));
+  }
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "SO", "maxfeatures");
+
+  if (value) {
+    psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(
+                                         ows_version, psNsOws, "Constraint",
+                                         "DefaultMaxFeatures", (char *)value));
+  }
+
+  /*<ogc:Filter_Capabilities> */
+  xmlAddChild(psRootNode, FLTGetCapabilities(psNsSos, psNsOgc, MS_TRUE));
+
+  /*Offerings */
+  psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Contents", NULL);
+  psMainNode =
+      xmlNewChild(psNode, NULL, BAD_CAST "ObservationOfferingList", NULL);
+
+  /*go through the layers and check for metadata sos_offering_id.
+    One or more layers could have the same offering id. In that case they
+    are adverized as the same offering. The first layer that has*/
+
+  if (map->numlayers) {
+    papsOfferings = (char **)malloc(sizeof(char *) * map->numlayers);
+    panOfferingLayers = (int *)malloc(sizeof(int) * map->numlayers);
+    for (i = 0; i < map->numlayers; i++)
+      panOfferingLayers[i] = -1;
+
+    for (i = 0; i < map->numlayers; i++) {
+      lp = (GET_LAYER(map, i));
+
+      if (lp->status == MS_DELETE)
+        continue;
+
+      value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_id");
+      if (value && (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                     ows_request->numlayers))) {
+        nCurrentOff = -1;
+        for (j = 0; j < nOfferings; j++) {
+          if (strcasecmp(value, papsOfferings[j]) == 0) {
+            nCurrentOff = j;
+            break;
+          }
+        }
+        if (nCurrentOff >= 0) /* existing offering */
+          panOfferingLayers[i] = nCurrentOff;
+        else { /*new offering */
+          papsOfferings[nOfferings] = msStrdup(value);
+          panOfferingLayers[i] = nOfferings;
+          nOfferings++;
+        }
+      }
+    }
+
+    if (nOfferings > 0) {
+      for (i = 0; i < nOfferings; i++) {
+        psOfferingNode =
+            xmlNewChild(psMainNode, NULL, BAD_CAST "ObservationOffering", NULL);
+        xmlNewNsProp(psOfferingNode, psNsGml, BAD_CAST "id",
+                     BAD_CAST papsOfferings[i]);
+        for (j = 0; j < map->numlayers; j++) {
+          if (panOfferingLayers[j] == i) /*first layer of the offering */
+            break;
+        }
+
+        lp = (GET_LAYER(map, j));
+
+        /*description*/
+        value =
+            msOWSLookupMetadata(&(lp->metadata), "S", "offering_description");
+        if (value)
+          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "description",
+                               BAD_CAST value);
+        else
+          xmlAddSibling(
+              psNode,
+              xmlNewComment(
+                  BAD_CAST
+                  "WARNING: Optional metadata \"sos_offering_description\" "
+                  "missing for gml:description"));
+
+        /*name*/
+        value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_name");
+        if (value)
+          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "name",
+                               BAD_CAST value);
+        else
+          xmlAddSibling(
+              psNode,
+              xmlNewComment(BAD_CAST
+                            "WARNING: Optional metadata \"sos_offering_name\" "
+                            "missing for gml:name"));
+
+        /* srsName */
+        value = msOWSLookupMetadata(&(map->web.metadata), "SO", "srs");
+
+        if (value)
+          msLibXml2GenerateList(psOfferingNode, psNsGml, "srsName", value, ' ');
+        else
+          xmlAddSibling(psNode,
+                        xmlNewComment(BAD_CAST
+                                      "WARNING: Required metadata \"sos_srs\" "
+                                      "missing for gml:srsName"));
+
+        /*bounding box */
+        /*TODO : if sos_offering_extent does not exist compute extents
+                 Check also what happen if epsg not present */
+        value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_extent");
+        if (value) {
+          char **tokens, *pszLayerEPSG;
+          int n;
+          tokens = msStringSplit(value, ',', &n);
+          if (tokens == NULL || n != 4) {
+            msSetError(MS_SOSERR,
+                       "Wrong number of arguments for sos_offering_extent.",
+                       "msSOSGetCapabilities()");
+            return msSOSException(map, "sos_offering_extent",
+                                  "InvalidParameterValue");
+          }
+          msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "SO", MS_TRUE,
+                           &pszLayerEPSG);
+          if (pszLayerEPSG) {
+            psNode =
+                xmlAddChild(psOfferingNode,
+                            msGML3BoundedBy(psNsGml, atof(tokens[0]),
+                                            atof(tokens[1]), atof(tokens[2]),
+                                            atof(tokens[3]), pszLayerEPSG));
+            msFree(pszLayerEPSG);
+          }
+          msFreeCharArray(tokens, n);
+        }
+
+        /* intended application */
+
+        value = msOWSLookupMetadata(&(lp->metadata), "S",
+                                    "offering_intendedapplication");
+
+        if (value)
+          psNode = xmlNewChild(psOfferingNode, psNsSos,
+                               BAD_CAST "intendedApplication", BAD_CAST value);
+        else
+          xmlAddSibling(psNode,
+                        xmlNewComment(BAD_CAST
+                                      "WARNING: Optional metadata "
+                                      "\"sos_offering_intendedapplication\" "
+                                      "missing for sos:intendedApplication"));
+
+        /*time*/
+        value =
+            msOWSLookupMetadata(&(lp->metadata), "S", "offering_timeextent");
+        if (value) {
+          char **tokens;
+          int n;
+          char *pszEndTime = NULL;
+          tokens = msStringSplit(value, '/', &n);
+          if (tokens == NULL || (n != 1 && n != 2)) {
+            msSetError(MS_SOSERR,
+                       "Wrong number of arguments for sos_offering_timeextent.",
+                       "msSOSGetCapabilities()");
+            return msSOSException(map, "sos_offering_timeextent",
+                                  "InvalidParameterValue");
+          }
+
+          if (n == 2) /* end time is empty. It is going to be set as "now*/
+            pszEndTime = tokens[1];
+
+          psNode = xmlAddChild(
+              psOfferingNode,
+              msSOSAddTimeNode(psNsSos, psNsGml, tokens[0], pszEndTime));
+          msFreeCharArray(tokens, n);
+        }
+
+        /*procedure : output all procedure links for the offering */
+        for (j = 0; j < map->numlayers; j++) {
+          if (panOfferingLayers[j] == i) {
+            value = msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata), "S",
+                                        "procedure");
+            if (value && strlen(value) > 0) {
+              /*value could be a list of procedure*/
+              char **tokens;
+              int n = 0;
+              tokens = msStringSplit(value, ' ', &n);
+              for (k = 0; k < n; k++) {
+                /*TODO review the urn output */
+                snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
+                pszTmp = msStringConcatenate(pszTmp, szTmp);
+                pszTmp = msStringConcatenate(pszTmp, tokens[k]);
+
+                psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "procedure",
+                                     NULL);
+                /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST
+                 * "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST
+                 * "href", BAD_CAST pszTmp); */
+                xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href",
+                             BAD_CAST pszTmp);
+                msFree(pszTmp);
+                pszTmp = NULL;
+              }
+              msFreeCharArray(tokens, n);
+            } else if ((value =
+                            msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata),
+                                                "S", "procedure_item"))) {
+              /* if a procedure_item is used, it means that the procedure
+                 (or sensor) need to be extracted from the data. Thus we need to
+                 query the layer and get the values from each feature */
+
+              lpTmp = GET_LAYER(map, j);
+              if (lpTmp->template == NULL)
+                lpTmp->template = msStrdup("ttt");
+
+              map->query.type = MS_QUERY_BY_RECT;
+              map->query.mode = MS_QUERY_MULTIPLE;
+              map->query.layer = j;
+              map->query.rect = map->extent;
+              msQueryByRect(map);
+
+              /*check if the attribute specified in the procedure_item is
+                available on the layer*/
+              iItemPosition = -1;
+              if (msLayerGetItems(lpTmp) == MS_SUCCESS && lpTmp->resultcache &&
+                  lpTmp->resultcache->numresults > 0) {
+                for (k = 0; k < lpTmp->numitems; k++) {
+                  if (strcasecmp(lpTmp->items[k], value) == 0) {
+                    iItemPosition = k;
+                    break;
+                  }
+                }
+                if (iItemPosition == -1) {
+                  msSetError(
+                      MS_SOSERR,
+                      "procedure_item %s could not be found on the layer %s",
+                      "msSOSGetCapabilities()", value, lpTmp->name);
+                  return msSOSException(map, "mapserv", "NoApplicableCode");
+                }
+
+                /*for each selected feature, grab the value of the
+                 * prodedire_item*/
+                /* do not duplicate sensor ids if they are the same */
+
+                /*keep list of distinct procedures*/
+                papsProcedures = (char **)malloc(
+                    sizeof(char *) * lpTmp->resultcache->numresults);
+                nDistinctProcedures = 0;
+                for (k = 0; k < lpTmp->resultcache->numresults; k++)
+                  papsProcedures[k] = NULL;
+
+                for (k = 0; k < lpTmp->resultcache->numresults; k++) {
+                  msInitShape(&sShape);
+                  status = msLayerGetShape(lp, &sShape,
+                                           &(lpTmp->resultcache->results[k]));
+                  if (status != MS_SUCCESS)
+                    continue;
+
+                  if (sShape.values[iItemPosition]) {
+                    pszProcedure = msStringConcatenate(
+                        pszProcedure, sShape.values[iItemPosition]);
+                    if (!_IsInList(papsProcedures, nDistinctProcedures,
+                                   pszProcedure)) {
+                      papsProcedures[nDistinctProcedures] =
+                          msStrdup(pszProcedure);
+                      nDistinctProcedures++;
+                      snprintf(szTmp, sizeof(szTmp), "%s",
+                               "urn:ogc:def:procedure:");
+                      pszTmp = msStringConcatenate(pszTmp, szTmp);
+                      pszTmp = msStringConcatenate(pszTmp, pszProcedure);
+
+                      psNode = xmlNewChild(psOfferingNode, NULL,
+                                           BAD_CAST "procedure", NULL);
+                      xmlNewNsProp(psNode,
+                                   xmlNewNs(NULL,
+                                            BAD_CAST
+                                            "http://www.w3.org/1999/xlink",
+                                            BAD_CAST "xlink"),
+                                   BAD_CAST "href", BAD_CAST pszTmp);
+                      msFree(pszTmp);
+                      pszTmp = NULL;
+                    }
+                    msFree(pszProcedure);
+                    pszProcedure = NULL;
+                  }
+                }
+                for (k = 0; k < lpTmp->resultcache->numresults; k++)
+                  if (papsProcedures[k] != NULL)
+                    msFree(papsProcedures[k]);
+                msFree(papsProcedures);
+
+              } else {
+                msSetError(MS_SOSERR, "Invalid procedure %s",
+                           "msSOSGetCapabilities()", value);
+                return msSOSException(map, "procedure",
+                                      "InvalidParameterValue");
+              }
+            } else {
+              msSetError(MS_SOSERR,
+                         "Mandatory metadata procedure_item could not be found "
+                         "on the layer %s",
+                         "msSOSGetCapabilities()", GET_LAYER(map, j)->name);
+              return msSOSException(map, "mapserv", "NoApplicableCode");
+            }
+          }
+        }
+        /*observed property */
+        /* observed property are equivalent to layers. We can group
+           sevaral layers using the same sos_observedproperty_id. The
+           components are the attributes. Components are exposed
+           using the metadata sos_%s_aliasl */
+
+        nProperties = 0;
+        papszProperties = (char **)malloc(sizeof(char *) * map->numlayers);
+
+        for (j = 0; j < map->numlayers; j++) {
+          if (panOfferingLayers[j] == i) {
+            if ((value = msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata),
+                                             "S", "observedproperty_id"))) {
+              for (k = 0; k < nProperties; k++) {
+                if (strcasecmp(value, papszProperties[k]) == 0)
+                  break;
+              }
+              if (k == nProperties) { /*not found*/
+                papszProperties[nProperties] = msStrdup(value);
+                nProperties++;
+                lpTmp = GET_LAYER(map, j);
+                if (msLayerOpen(lpTmp) == MS_SUCCESS &&
+                    msLayerGetItems(lpTmp) == MS_SUCCESS) {
+                  msSOSAddPropertyNode(psNsSwe, psNsXLink, psOfferingNode,
+                                       lpTmp, psNsGml, NULL);
+                  msLayerClose(lpTmp);
+                }
+              }
+            }
+          }
+        }
+        for (j = 0; j < nProperties; j++)
+          free(papszProperties[j]);
+        free(papszProperties);
+
+        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "featureOfInterest",
+                             NULL);
+        xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href",
+                     BAD_CAST "urn:ogc:def:feature:OGC-SWE:3:transient");
+
+        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "responseFormat",
+                             BAD_CAST pszSOSGetObservationMimeType);
+        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "resultModel",
+                             BAD_CAST "om:Observation");
+        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "resultModel",
+                             BAD_CAST "om:Measurement");
+        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "responseMode",
+                             BAD_CAST "inline");
+
+      } /*end of offerings*/
+    }
+
+    if (papsOfferings && nOfferings > 0) {
+      for (i = 0; i < nOfferings; i++)
+        msFree(papsOfferings[i]);
+    }
+    msFree(papsOfferings);
+    if (panOfferingLayers)
+      msFree(panOfferingLayers);
+
+  } /* end of offerings */
+
+  if (msIO_needBinaryStdout() == MS_FAILURE)
+    return MS_FAILURE;
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  /*TODO* : check the encoding validity. Internally libxml2 uses UTF-8
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
+                           "SO", "encoding", OWS_NOERR,
+                           "<?xml version='1.0' encoding=\"%s\"
+  standalone=\"no\" ?>\n", "ISO-8859-1");
+  */
+  /*xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, (encoding ? encoding :
+   * "ISO-8859-1"), 1);*/
+
+  /* xmlDocDump crashs withe the prebuild windows binaries distibutes at the
+   libxml site???. It works with locally build binaries*/
+
+  context = msIO_getHandler(stdout);
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+  msIO_contextWrite(context, buffer, size);
+  xmlFree(buffer);
+
+  /*free buffer and the document */
+  /*xmlFree(buffer);*/
+  xmlFreeDoc(psDoc);
+  xmlFreeNs(psNsGml);
+  xmlFreeNs(psNsSos);
+  xmlFreeNs(psNsOgc);
+  xmlFreeNs(psNsSwe);
+
+  free(xsi_schemaLocation);
+  free(schemalocation);
+  msFree(script_url);
+
+  /*
+   *Free the global variables that may
+   *have been allocated by the parser.
+   */
+  xmlCleanupParser();
+
+  return (MS_SUCCESS);
+
+  /*
+  nSize = sizeof(workbuffer);
+  nSize = nSize-1;*/ /* the last character for the '\0' */
+
+  /*
+  if (size > nSize)
+  {
+       iIndice = 0;
+       while ((iIndice + nSize) <= size)
+       {
+           snprintf(workbuffer, (sizeof(workbuffer)-1), "%s", buffer+iIndice );
+           workbuffer[sizeof(workbuffer)-1] = '\0';
+           msIO_printf("%s", workbuffer);
+
+           iIndice +=nSize;
+       }
+       if (iIndice < size)
+       {
+            sprintf(workbuffer, "%s", buffer+iIndice );
+            msIO_printf("%s", workbuffer);
+       }
+   }
+  else
+  {
+      msIO_printf("%s", buffer);
+  }
+  */
+}
+
+/************************************************************************/
+/*                           msSOSGetObservation                        */
+/*                                                                      */
+/*      GetObservation request handler                                  */
+/************************************************************************/
+int msSOSGetObservation(mapObj *map, sosParamsObj *sosparams,
+                        cgiRequestObj *req, owsRequestObj *ows_request) {
+  char *schemalocation = NULL;
+  char *xsi_schemaLocation = NULL;
+  const char *pszTmp = NULL, *pszTmp2 = NULL;
+  const char *user_namespace_uri = "http://mapserver.gis.umn.edu/mapserver";
+  const char *user_namespace_prefix = "ms";
+  char *script_url = NULL;
+  int i, j, k, bLayerFound = 0;
+  layerObj *lp = NULL, *lpfirst = NULL;
+  const char *pszTimeExtent = NULL, *pszTimeField = NULL, *pszValue = NULL;
+  FilterEncodingNode *psFilterNode = NULL;
+  rectObj sBbox;
+
+  xmlDocPtr psDoc = NULL;
+  xmlNodePtr psRootNode, psNode;
+  char **tokens = NULL, **tokens1;
+  int n = 0, n1 = 0;
+  xmlNsPtr psNsGml = NULL;
+  xmlNsPtr psNsOm = NULL;
+  xmlNsPtr psNsSwe = NULL;
+  xmlNsPtr psNsXLink = NULL;
+  xmlNsPtr psNsSos = NULL;
+  xmlNsPtr psNsMs = NULL;
+  const char *opLayerName = NULL;
+  char *pszBuffer = NULL;
+  const char *pszProcedureItem = NULL;
+  int bSpatialDB = 0;
+  xmlChar *buffer = NULL;
+  int size = 0;
+  msIOContext *context = NULL;
+  xmlNodePtr psObservationNode = NULL, psResultNode = NULL;
+  const char *pszProcedure = NULL;
+  const char *pszBlockSep = NULL;
+  int nDiffrentProc = 0;
+  SOSProcedureNode *paDiffrentProc = NULL;
+  int iItemPosition, status;
+  shapeObj sShape;
+
+  sBbox = map->extent;
+
+  /* establish local namespace */
+  pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SFO", "namespace_uri");
+
+  if (pszTmp)
+    user_namespace_uri = pszTmp;
+
+  pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SFO", "namespace_prefix");
+  if (pszTmp)
+    user_namespace_prefix = pszTmp;
+
+  /* validates mandatory request elements */
+  if (!sosparams->pszOffering) {
+    msSetError(MS_SOSERR, "Missing OFFERING parameter.",
+               "msSOSGetObservation()");
+    return msSOSException(map, "offering", "MissingParameterValue");
+  }
+
+  if (!sosparams->pszObservedProperty) {
+    msSetError(MS_SOSERR, "Missing OBSERVEDPROPERTY parameter.",
+               "msSOSGetObservation()");
+    return msSOSException(map, "observedproperty", "MissingParameterValue");
+  }
+
+  if (!sosparams->pszResponseFormat) {
+    msSetError(MS_SOSERR, "Missing RESPONSEFORMAT parameter.",
+               "msSOSGetObservation()");
+    return msSOSException(map, "responseformat", "MissingParameterValue");
+  }
+
+  if (strcasecmp(sosparams->pszResponseFormat, pszSOSGetObservationMimeType) !=
+      0) {
+    msSetError(MS_SOSERR,
+               "Invalid RESPONSEFORMAT parameter %s.  Allowable values are: %s",
+               "msSOSGetObservation()", sosparams->pszResponseFormat,
+               pszSOSGetObservationMimeType);
+    return msSOSException(map, "responseformat", "InvalidParameterValue");
+  }
+
+  if (sosparams->pszResponseMode &&
+      strcasecmp(sosparams->pszResponseMode, "inline") != 0) {
+    msSetError(
+        MS_SOSERR,
+        "Invalid RESPONSEMODE parameter %s.  Allowable values are: \"inline\"",
+        "msSOSGetObservation()", sosparams->pszResponseMode);
+    return msSOSException(map, "responsemode", "InvalidParameterValue");
+  }
+
+  /*validate if offering exists*/
+  for (i = 0; i < map->numlayers; i++) {
+    pszTmp =
+        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
+    if (pszTmp && (strcasecmp(pszTmp, sosparams->pszOffering) == 0) &&
+        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers)))
+      break;
+  }
+
+  if (i == map->numlayers) {
+    msSetError(MS_SOSERR,
+               "Offering %s not found. A layer might be disabled for \
+this request. Check sos/ows_enable_request settings.",
+               "msSOSGetObservation()", sosparams->pszOffering);
+    return msSOSException(map, "offering", "InvalidParameterValue");
+  }
+
+  /*validate if observed property exist*/
+  /* Allow more the 1 oberved property comma separated (specs is unclear on it).
+     If we do it, we need to see if other parameters like result (filter
+     encoding) should be given for each property too) */
+
+  bLayerFound = 0;
+  tokens = msStringSplit(sosparams->pszObservedProperty, ',', &n);
+
+  for (i = 0; i < map->numlayers; i++) {
+    pszTmp =
+        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
+    pszTmp2 = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                  "observedproperty_id");
+
+    GET_LAYER(map, i)->status = MS_OFF;
+
+    if (pszTmp && pszTmp2) {
+      if (strcasecmp(pszTmp, sosparams->pszOffering) == 0) {
+        if (tokens && n > 0) {
+          for (j = 0; j < n; j++) {
+            if (strcasecmp(pszTmp2, tokens[j]) == 0) {
+              GET_LAYER(map, i)->status = MS_ON;
+              /* opLayerName = msStrdup(GET_LAYER(map, i)->name); */
+              opLayerName = GET_LAYER(map, i)->name;
+              /* Force setting a template to enable query. */
+              if (!GET_LAYER(map, i)->template)
+                GET_LAYER(map, i)->template = msStrdup("ttt.html");
+              bLayerFound = 1;
+              break;
+            }
+          }
+        }
+      }
+    }
+  }
+  if (tokens && n > 0)
+    msFreeCharArray(tokens, n);
+
+  if (bLayerFound == 0) {
+    msSetError(MS_SOSERR, "ObservedProperty %s not found.",
+               "msSOSGetObservation()", sosparams->pszObservedProperty);
+    return msSOSException(map, "observedproperty", "InvalidParameterValue");
+  }
+
+  /* apply procedure : could be a comma separated list.
+     set status to on those layers that have the sos_procedure metadata
+     equals to this parameter. Note that the layer should already have it's
+     status at ON by the  offering,observedproperty filter done above */
+
+  if (sosparams->pszProcedure) {
+    bLayerFound = 0;
+    tokens = msStringSplit(sosparams->pszProcedure, ',', &n);
+
+    if (tokens && n > 0) {
+      for (i = 0; i < map->numlayers; i++) {
+        if (GET_LAYER(map, i)->status == MS_ON) {
+          pszValue = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                         "procedure");
+
+          if (pszValue) {
+            /* the procedure metadata can be a list "sensor1 sensor2..."*/
+            tokens1 = msStringSplit(pszValue, ' ', &n1);
+
+            for (j = 0; j < n; j++) {
+              for (k = 0; k < n1; k++) {
+                if (strcasecmp(tokens1[k], tokens[j]) == 0) { /* found */
+                  bLayerFound = 1;
+                  break;
+                }
+              }
+              if (k < n1)
+                break;
+            }
+            if (j == n) /*not found*/
+              GET_LAYER(map, i)->status = MS_OFF;
+
+            if (tokens1)
+              msFreeCharArray(tokens1, n1);
+
+            if (bLayerFound == 0) {
+              msSetError(MS_SOSERR, "Procedure %s not found.",
+                         "msSOSGetObservation()", sosparams->pszProcedure);
+              msFreeCharArray(tokens, n);
+              return msSOSException(map, "procedure", "InvalidParameterValue");
+            }
+          }
+
+          /* if there is a procedure_item defined on the layer, we will */
+          /* use it to set the filter parameter of the layer */
+
+          if ((GET_LAYER(map, i)->status == MS_ON) &&
+              (pszProcedureItem = msOWSLookupMetadata(
+                   &(GET_LAYER(map, i)->metadata), "S", "procedure_item"))) {
+
+            lp = GET_LAYER(map, i);
+
+            /* HACK BEGIN */
+
+            if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                    "procedure") == NULL) {
+              /* if sos_procedure_item is used, and sos_procedure is not, it
+               * means that */
+              /* the procedure or sensor) need to be extracted from the data.
+               * Thus we */
+              /* need to query the layer and get the values from each feature */
+
+              if (lp->template == NULL)
+                lp->template = msStrdup("ttt");
+
+              map->query.type = MS_QUERY_BY_RECT;
+              map->query.mode = MS_QUERY_MULTIPLE;
+              map->query.layer = i;
+              map->query.rect = map->extent;
+              msQueryByRect(map);
+
+              /*check if the attribute specified in the procedure_item is
+               * available */
+              /*on the layer*/
+              iItemPosition = -1;
+              if (msLayerGetItems(lp) == MS_SUCCESS && lp->resultcache &&
+                  lp->resultcache->numresults > 0) {
+                for (k = 0; k < lp->numitems; k++) {
+                  if (strcasecmp(lp->items[k], pszProcedureItem) == 0) {
+                    iItemPosition = k;
+                    break;
+                  }
+                }
+                if (iItemPosition == -1) {
+                  msSetError(MS_SOSERR,
+                             "sos_procedure_item %s could not be found on the "
+                             "layer %s",
+                             "msSOSGetCapabilities()", pszProcedureItem,
+                             lp->name);
+                  return msSOSException(map, "mapserv", "NoApplicableCode");
+                }
+
+                /*for each selected feature, grab the value of the
+                 * procedure_item*/
+                bLayerFound = 0;
+
+                for (k = 0; k < lp->resultcache->numresults; k++) {
+                  msInitShape(&sShape);
+                  status = msLayerGetShape(lp, &sShape,
+                                           &(lp->resultcache->results[k]));
+                  if (status != MS_SUCCESS)
+                    continue;
+
+                  if (sShape.values[iItemPosition]) {
+                    tokens = msStringSplit(sosparams->pszProcedure, ',', &n);
+                    for (j = 0; j < n; j++) {
+                      if (strcasecmp(sShape.values[iItemPosition], tokens[j]) ==
+                          0) { /* found */
+                        bLayerFound = 1;
+                        break;
+                      }
+                    }
+                  }
+
+                  if (bLayerFound)
+                    break;
+                }
+
+                if (bLayerFound == 0) {
+                  msSetError(MS_SOSERR, "Invalid procedure value %s",
+                             "msSOSGetCapabilities()", sosparams->pszProcedure);
+                  return msSOSException(map, "procedure",
+                                        "InvalidParameterValue");
+                }
+              }
+            }
+            /* HACK END */
+
+            pszBuffer = NULL;
+            if (lp->filter.string && strlen(lp->filter.string) > 0)
+              msFreeExpression(&lp->filter);
+
+            /*The filter should reflect the underlying db*/
+            /*for ogr add a where clause */
+            bSpatialDB = 0;
+            if (lp->connectiontype == MS_POSTGIS ||
+                lp->connectiontype == MS_ORACLESPATIAL ||
+                lp->connectiontype == MS_OGR)
+              bSpatialDB = 1;
+
+            if (bSpatialDB) {
+              if (lp->connectiontype != MS_OGR)
+                pszBuffer = msStringConcatenate(pszBuffer, "(");
+              else
+                pszBuffer = msStringConcatenate(pszBuffer, "WHERE ");
+            } else
+              pszBuffer = msStringConcatenate(pszBuffer, "(");
+
+            for (j = 0; j < n; j++) {
+              if (j > 0)
+                pszBuffer = msStringConcatenate(pszBuffer, " OR ");
+
+              pszBuffer = msStringConcatenate(pszBuffer, "(");
+
+              if (!bSpatialDB) {
+                pszBuffer = msStringConcatenate(pszBuffer, "'[");
+                pszBuffer =
+                    msStringConcatenate(pszBuffer, (char *)pszProcedureItem);
+              } else {
+                char *pszEscapedStr =
+                    msLayerEscapePropertyName(lp, (char *)pszProcedureItem);
+                pszBuffer = msStringConcatenate(pszBuffer, pszEscapedStr);
+                msFree(pszEscapedStr);
+              }
+
+              if (!bSpatialDB)
+                pszBuffer = msStringConcatenate(pszBuffer, "]'");
+
+              pszBuffer = msStringConcatenate(pszBuffer, " = '");
+              {
+                char *pszEscapedStr = msLayerEscapeSQLParam(lp, tokens[j]);
+                pszBuffer = msStringConcatenate(pszBuffer, pszEscapedStr);
+                msFree(pszEscapedStr);
+              }
+              pszBuffer = msStringConcatenate(pszBuffer, "')");
+            }
+
+            if (!bSpatialDB || lp->connectiontype != MS_OGR)
+              pszBuffer = msStringConcatenate(pszBuffer, ")");
+
+            msLoadExpressionString(&lp->filter, pszBuffer);
+            if (pszBuffer)
+              msFree(pszBuffer);
+          }
+        }
+      }
+      msFreeCharArray(tokens, n);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      supports 2 types of gml:Time : TimePeriod and TimeInstant :     */
+  /*      - <gml:TimePeriod>                                              */
+  /*          <gml:beginPosition>2005-09-01T11:54:32</gml:beginPosition>  */
+  /*         <gml:endPosition>2005-09-02T14:54:32</gml:endPosition>       */
+  /*       </gml:TimePeriod>                                              */
+  /*                                                                      */
+  /*      - <gml:TimeInstant>                                             */
+  /*           <gml:timePosition>2003-02-13T12:28-08:00</gml:timePosition>*/
+  /*         </gml:TimeInstant>                                           */
+  /*                                                                      */
+  /*       The user can specify mutilple times separated by commas.       */
+  /*                                                                      */
+  /*       The gml will be parsed and trasformed into a sting tah         */
+  /*      looks like timestart/timeend,...                                */
+  /* -------------------------------------------------------------------- */
+
+  /*apply time filter if available */
+  if (sosparams->pszEventTime) {
+    char **apszTimes = NULL;
+    int numtimes = 0;
+    char *pszTimeString = NULL, *pszTmp = NULL;
+
+    /* Because SOS has specific TemporalOperator which extends FES 1.1, the time
+     * filter  */
+    /* passed is different than what mapogcfilter (per 1.0.0) supports. */
+    /*                                                                                   */
+    /* Because, in XML POST mode, we traverse directly to
+     * gml:TimePeriod|gml:TimeInstant */
+    /* this is passed directly to mapogcfilter. */
+    /* for GET requests, we strip the parent element before passing */
+
+    pszTmp = msStrdup(sosparams->pszEventTime);
+
+    pszTmp = msCaseReplaceSubstring(pszTmp, "<ogc:TM_Equals>", "");
+    pszTmp = msCaseReplaceSubstring(pszTmp, "<TM_Equals>", "");
+    pszTmp = msCaseReplaceSubstring(pszTmp, "</ogc:TM_Equals>", "");
+    pszTmp = msCaseReplaceSubstring(pszTmp, "</TM_Equals>", "");
+
+    apszTimes = msStringSplit(pszTmp, ',', &numtimes);
+    msFree(pszTmp);
+
+    if (numtimes >= 1) {
+      for (i = 0; i < numtimes; i++) {
+        pszTmp = msSOSParseTimeGML(apszTimes[i]);
+        if (pszTmp) {
+          if (pszTimeString)
+            pszTimeString = msStringConcatenate(pszTimeString, ",");
+          pszTimeString = msStringConcatenate(pszTimeString, pszTmp);
+          msFree(pszTmp);
+        }
+      }
+      msFreeCharArray(apszTimes, numtimes);
+    }
+    if (!pszTimeString) {
+      msSetError(MS_SOSERR,
+                 "Invalid time value given for the eventTime parameter %s",
+                 "msSOSGetObservation()", sosparams->pszEventTime);
+      return msSOSException(map, "eventtime", "InvalidParameterValue");
+    }
+    for (i = 0; i < map->numlayers; i++) {
+      if (GET_LAYER(map, i)->status == MS_ON) {
+        /* the sos_offering_timeextent should be used for time validation*/
+        /*TODO : too documented  ?*/
+        lpfirst = msSOSGetFirstLayerForOffering(
+            map,
+            msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                "offering_id"),
+            NULL);
+        if (lpfirst)
+          pszTimeExtent = msOWSLookupMetadata(&lpfirst->metadata, "S",
+                                              "offering_timeextent");
+
+        pszTimeField = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "SO",
+                                           "timeitem");
+
+        if (pszTimeField) {
+          /*validate only if time extent is set.*/
+          if (pszTimeExtent) {
+            if (msValidateTimeValue(pszTimeString, pszTimeExtent) == MS_TRUE)
+              msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString,
+                                   pszTimeField);
+            else {
+              /*we should turn the layer off since the eventTime is not in the
+               * time extent*/
+              GET_LAYER(map, i)->status = MS_OFF;
+            }
+          } else
+            msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString,
+                                 pszTimeField);
+        }
+      }
+    }
+    if (pszTimeString)
+      msFree(pszTimeString);
+  }
+
+  /*bbox*/
+  /* this is a gml feature
+  <gml:Envelope xmlns:gml="http://www.opengis.net/gml">
+  <gml:lowerCorner srsName="EPSG:4326">-66 43</gml:lowerCorner>
+  <upperCorner srsName="EPSG:4326">-62 45</upperCorner>
+  </gml:Envelope>
+  */
+
+  if (sosparams->pszFeatureOfInterest) {
+    int bValid = 0;
+    CPLXMLNode *psRoot = NULL;
+    char *pszSRS = NULL;
+
+    psRoot = CPLParseXMLString(sosparams->pszFeatureOfInterest);
+    if (!psRoot) {
+      msSetError(MS_SOSERR,
+                 "Invalid gml:Envelope value given for featureOfInterest.",
+                 "msSOSGetObservation()");
+      return msSOSException(map, "featureofinterest", "InvalidParameterValue");
+    }
+
+    CPLStripXMLNamespace(psRoot, "gml", 1);
+    bValid = FLTParseGMLEnvelope(psRoot, &sBbox, &pszSRS);
+
+    /* TODO we should reproject the bbox to the map projection if there is an
+     * srs defined */
+    if (!bValid) {
+      msSetError(MS_SOSERR,
+                 "Invalid gml:Envelope value given for featureOfInterest %s.",
+                 "msSOSGetObservation()", sosparams->pszEventTime);
+      return msSOSException(map, "featureofinterest", "InvalidParameterValue");
+    }
+    map->extent.minx = sBbox.minx;
+    map->extent.miny = sBbox.miny;
+    map->extent.maxx = sBbox.maxx;
+    map->extent.maxy = sBbox.maxy;
+
+    CPLDestroyXMLNode(psRoot);
+    msFree(pszSRS);
+  }
+
+  if (sosparams->pszSrsName) { /* validate against MAP.WEB.METADATA.sos_srs */
+    int iUnits = -1;
+    char **tokens = NULL;
+    const char *pszSRSList = NULL;
+    int n = 0;
+    int bFound = 0;
+    int k;
+    char srsbuffer[100];
+    projectionObj po;
+
+    pszSRSList = msOWSLookupMetadata(&(map->web.metadata), "SO", "srs");
+
+    if (pszSRSList) {
+      tokens = msStringSplit(pszSRSList, ' ', &n);
+
+      if (tokens && n > 0) {
+        for (k = 0; k < n; k++) {
+          if (strncasecmp(tokens[k], "EPSG:", strlen("EPSG:")) == 0 &&
+              strcasecmp(sosparams->pszSrsName, tokens[k]) == 0) { /* match */
+            bFound = 1;
+
+            /* project MAP.EXTENT to this SRS */
+            msInitProjection(&po);
+            msProjectionInheritContextFrom(&po, &map->projection);
+
+            snprintf(srsbuffer, sizeof(srsbuffer), "+init=epsg:%.20s",
+                     sosparams->pszSrsName + strlen("EPSG:"));
+
+            if (msLoadProjectionString(&po, srsbuffer) != 0) {
+              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"",
+                         "msSOSGetObservation()", sosparams->pszSrsName);
+              return msSOSException(map, "mapserv", "NoApplicableCode");
+            }
+
+            if (msProjectionsDiffer(&map->projection, &po) == MS_TRUE) {
+              msProjectRect(&map->projection, &po, &map->extent);
+              sBbox = map->extent;
+            }
+
+            /* set map->projection to this SRS */
+            if (msLoadProjectionString(&(map->projection), srsbuffer) != 0) {
+              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"",
+                         "msSOSGetObservation()", sosparams->pszSrsName);
+              return msSOSException(map, "mapserv", "NoApplicableCode");
+            }
+
+            iUnits = GetMapserverUnitUsingProj(&(map->projection));
+            if (iUnits != -1)
+              map->units = iUnits;
+
+            msFreeProjection(&po);
+            break;
+          }
+        }
+        msFreeCharArray(tokens, n);
+      }
+      if (bFound == 0) {
+        msSetError(MS_SOSERR, "srsName value \"%s\" unsupported / invalid",
+                   "msSOSGetObservation()", sosparams->pszSrsName);
+        return msSOSException(map, "srsName", "InvalidParameterValue");
+      }
+    } else {
+      msSetError(MS_SOSERR, "MAP.WEB.METADATA.sos_srs not set",
+                 "msSOSGetObservation()");
+      return msSOSException(map, "mapserv", "NoApplicableCode");
+    }
+  }
+
+  /* apply filter */
+  if (sosparams->pszResult) {
+    psFilterNode = FLTParseFilterEncoding(sosparams->pszResult);
+
+    if (!psFilterNode) {
+      msSetError(MS_SOSERR,
+                 "Invalid or Unsupported RESULT in GetObservation: %s",
+                 "msSOSGetObservation()", sosparams->pszResult);
+      return msSOSException(map, "result", "InvalidParameterValue");
+    }
+    /* apply the filter to all layers that are on */
+    for (i = 0; i < map->numlayers; i++) {
+      lp = GET_LAYER(map, i);
+      if (lp->status == MS_ON) {
+        /* preparse parser so that alias for fields can be used */
+        FLTPreParseFilterForAliasAndGroup(psFilterNode, map, i, "S");
+        /* validate that the property names used are valid
+          (there is a corresponding layer attribute) */
+        if (msLayerOpen(lp) == MS_SUCCESS &&
+            msLayerGetItems(lp) == MS_SUCCESS) {
+          if (msSOSValidateFilter(psFilterNode, lp) == MS_FALSE) {
+            msSetError(MS_SOSERR, "Invalid component name in RESULT statement",
+                       "msSOSGetObservation()");
+            return msSOSException(map, "result", "InvalidParameterValue");
+          }
+          msLayerClose(lp);
+        }
+        FLTApplyFilterToLayer(psFilterNode, map, i);
+      }
+    }
+
+    FLTFreeFilterEncodingNode(psFilterNode);
+  }
+
+  /* this is just a fall back if bbox is enetered. The bbox parameter is not
+     supported by the sos specs */
+  if (sosparams->pszBBox && !sosparams->pszFeatureOfInterest) {
+    char **tokens;
+    int n;
+
+    tokens = msStringSplit(sosparams->pszBBox, ',', &n);
+    if (tokens == NULL || n != 4) {
+      msSetError(MS_SOSERR, "Wrong number of arguments for bounding box.",
+                 "msSOSGetObservation()");
+      return msSOSException(map, "bbox", "InvalidParameterValue");
+    }
+    sBbox.minx = atof(tokens[0]);
+    sBbox.miny = atof(tokens[1]);
+    sBbox.maxx = atof(tokens[2]);
+    sBbox.maxy = atof(tokens[3]);
+    msFreeCharArray(tokens, n);
+  }
+
+  /* do the query if the filter encoding (pszResult) is not part of the request.
+     If pszResult is available, the query on the layers will be done when the
+     filter is parsed*/
+  if (!sosparams->pszResult) {
+    map->query.type = MS_QUERY_BY_RECT;
+    map->query.mode = MS_QUERY_MULTIPLE;
+    map->query.layer = -1;
+    map->query.rect = sBbox;
+    msQueryByRect(map);
+  }
+
+  /*get the first layers of the offering*/
+  for (i = 0; i < map->numlayers; i++) {
+    pszTmp =
+        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
+    if (pszTmp && (strcasecmp(pszTmp, sosparams->pszOffering) == 0)) {
+      lp = (GET_LAYER(map, i));
+      break;
+    }
+  }
+
+  /* build xml return tree*/
+
+  psNsSos =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/sos/1.0", BAD_CAST "sos");
+  psNsGml =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
+  psNsOm =
+      xmlNewNs(NULL, BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix);
+  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                     BAD_CAST "swe");
+  psNsXLink = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  psNsMs = xmlNewNs(NULL, BAD_CAST user_namespace_uri,
+                    BAD_CAST user_namespace_prefix);
+
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+  psRootNode = xmlNewNode(NULL, BAD_CAST "ObservationCollection");
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml",
+                    BAD_CAST "gml"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+                    BAD_CAST "ows"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                    BAD_CAST "swe"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri,
+                                BAD_CAST pszSOSNamespacePrefix));
+  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST user_namespace_uri,
+                                BAD_CAST user_namespace_prefix));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0",
+                    BAD_CAST "om"));
+
+  xmlNewNsProp(psRootNode, psNsGml, BAD_CAST "id",
+               BAD_CAST sosparams->pszOffering);
+
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  if ((script_url = msOWSGetOnlineResource(map, "SO", "onlineresource", req)) ==
+      NULL) {
+    free(schemalocation);
+    return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
+  }
+
+  xsi_schemaLocation = msStrdup("http://www.opengis.net/om/1.0 ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/om/1.0.0/om.xsd ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)user_namespace_uri);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)script_url);
+  xsi_schemaLocation = msStringConcatenate(
+      xsi_schemaLocation,
+      "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)opLayerName);
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+
+  /* description */
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_description");
+  if (pszTmp) {
+    psNode =
+        xmlNewChild(psRootNode, NULL, BAD_CAST "description", BAD_CAST pszTmp);
+    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                              BAD_CAST "gml"));
+  }
+
+  /* name */
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_name");
+  if (pszTmp) {
+    psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "name", BAD_CAST pszTmp);
+    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                              BAD_CAST "gml"));
+  }
+
+  /* extent */
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_extent");
+
+  if (pszTmp) {
+    char **tokens;
+    char *pszMapEpsg;
+    int n;
+    rectObj envelope;
+
+    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE,
+                     &pszMapEpsg);
+
+    tokens = msStringSplit(pszTmp, ',', &n);
+    if (tokens == NULL || n != 4) {
+      msSetError(MS_SOSERR,
+                 "Wrong number of arguments for sos_offering_extent.",
+                 "msSOSGetCapabilities()");
+      msFree(script_url);
+      return msSOSException(map, "sos_offering_extent",
+                            "InvalidParameterValue");
+    }
+
+    envelope.minx = atof(tokens[0]);
+    envelope.miny = atof(tokens[1]);
+    envelope.maxx = atof(tokens[2]);
+    envelope.maxy = atof(tokens[3]);
+
+    if (map &&
+        msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
+      if (msProjectRect(&lp->projection, &map->projection, &envelope) ==
+          MS_FAILURE) {
+        msSetError(MS_SOSERR,
+                   "Coordinates transformation failed.  Raised in "
+                   "msProjectRect() of file %s line %d",
+                   "msSOSGetCapabilities()", __FILE__, __LINE__);
+        msFree(script_url);
+        return msSOSException(map, "sos_offering_extent",
+                              "InvalidParameterValue");
+      }
+    }
+
+    psNode = xmlAddChild(
+        psRootNode, msGML3BoundedBy(psNsGml, envelope.minx, envelope.miny,
+                                    envelope.maxx, envelope.maxy, pszMapEpsg));
+    msFreeCharArray(tokens, n);
+    msFree(pszMapEpsg);
+  }
+
+  /* time
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "S","offering_timeextent");
+  if (pszTmp)
+  {
+      char **tokens;
+      int n;
+      char *pszEndTime = NULL;
+      tokens = msStringSplit(pszTmp, '/', &n);
+      if (tokens==NULL || (n != 1 && n!=2)) {
+          msSetError(MS_SOSERR, "Wrong number of arguments for
+  sos_offering_timeextent.", "msSOSGetCapabilities()"); return
+  msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
+      }
+  */
+  /*    if (n == 2) */ /* end time is empty. It is going to be set as "now" */
+  /*      pszEndTime = tokens[1];
+
+        psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(xmlNewNs(NULL,
+  BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix), tokens[0],
+  pszEndTime)); psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(psNsOm,
+  psNsGml, tokens[0], pszEndTime)); msFreeCharArray(tokens, n);
+
+  }
+  */
+
+  if (sosparams->pszResultModel &&
+      strcasecmp(sosparams->pszResultModel, "om:Measurement") != 0 &&
+      strcasecmp(sosparams->pszResultModel, "om:Observation") != 0) {
+    msSetError(MS_SOSERR,
+               "resultModel should be om:Measurement or om:Observation",
+               "msSOSGetObservation()");
+    free(xsi_schemaLocation);
+    free(schemalocation);
+    msFree(script_url);
+    xmlFreeNs(psNsSos);
+    xmlFreeNs(psNsGml);
+    xmlFreeNs(psNsOm);
+    xmlFreeNs(psNsSwe);
+    xmlFreeNs(psNsXLink);
+    xmlFreeNs(psNsMs);
+    xmlFreeDoc(psDoc);
+    return msSOSException(map, "resultModel", "InvalidParameterValue");
+  }
+
+  else {
+    /* output result members */
+    for (i = 0; i < map->numlayers; i++) {
+      if (GET_LAYER(map, i)->resultcache &&
+          GET_LAYER(map, i)->resultcache->numresults > 0) {
+        msLayerGetItems((GET_LAYER(map, i)));
+        pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SO", "maxfeatures");
+        if (pszTmp != NULL)
+          n1 = atoi(pszTmp);
+        else
+          n1 = 0;
+
+        if (sosparams->pszResultModel == NULL ||
+            strcasecmp(sosparams->pszResultModel, "om:Measurement") == 0) {
+          for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++) {
+            msSOSAddMemberNode(psNsGml, psNsOm, psNsSwe, psNsXLink, psNsMs,
+                               psRootNode, map, (GET_LAYER(map, i)), j,
+                               script_url, opLayerName);
+            if (j == n1 - 1)
+              break;
+          }
+        } else { /*assuming here that pszResultModel = observation */
+          /*layer does not define a procedure_item: this means one procedure per
+            layer defined using sos_procedure)*/
+          if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                  "procedure_item") == NULL) {
+            pszProcedure =
+                msOWSLookupMetadata(&(lp->metadata), "S", "procedure");
+            psObservationNode = msSOSAddMemberNodeObservation(
+                psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map,
+                (GET_LAYER(map, i)), pszProcedure);
+            /*add a result node*/
+            psResultNode =
+                xmlNewChild(psObservationNode, NULL, BAD_CAST "result", NULL);
+            for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++) {
+              /*add a block separator*/
+              if (j > 0) {
+                pszBlockSep = msOWSLookupMetadata(&(map->web.metadata), "S",
+                                                  "encoding_blockSeparator");
+                if (pszBlockSep)
+                  xmlNodeAddContent(psResultNode, BAD_CAST pszBlockSep);
+                else
+                  xmlNodeAddContent(psResultNode, BAD_CAST "\n");
+              }
+              {
+                char *pszResult =
+                    msSOSReturnMemberResult((GET_LAYER(map, i)), j, NULL);
+                if (pszResult) {
+                  xmlNodeAddContent(psResultNode, BAD_CAST pszResult);
+                  msFree(pszResult);
+                }
+              }
+            }
+          }
+          /*this is the case where procedure_item is used. Needs more management
+            since the same data on a layer contains different procedures
+            (procedures are one of the fields of the record)*/
+          else {
+
+            for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++) {
+              char *pszProcedureValue = NULL;
+              char *pszResult = msSOSReturnMemberResult((GET_LAYER(map, i)), j,
+                                                        &pszProcedureValue);
+              if (!pszProcedureValue || !pszResult) {
+                msFree(pszProcedureValue);
+                msFree(pszResult);
+                continue;
+              }
+              for (k = 0; k < nDiffrentProc; k++) {
+                if (strcasecmp(paDiffrentProc[k].pszProcedure,
+                               pszProcedureValue) == 0) {
+                  pszBlockSep = msOWSLookupMetadata(&(map->web.metadata), "S",
+                                                    "encoding_blockSeparator");
+                  if (pszBlockSep)
+                    xmlNodeAddContent(paDiffrentProc[k].psResultNode,
+                                      BAD_CAST pszBlockSep);
+                  else
+                    xmlNodeAddContent(paDiffrentProc[k].psResultNode,
+                                      BAD_CAST "\n");
+                  xmlNodeAddContent(paDiffrentProc[k].psResultNode,
+                                    BAD_CAST pszResult);
+                  break;
+                }
+              }
+              if (k == nDiffrentProc) { /*a new procedure*/
+                nDiffrentProc++;
+                if (paDiffrentProc == NULL)
+                  paDiffrentProc =
+                      (SOSProcedureNode *)malloc(sizeof(SOSProcedureNode));
+                else
+                  paDiffrentProc = (SOSProcedureNode *)realloc(
+                      paDiffrentProc, sizeof(SOSProcedureNode) * nDiffrentProc);
+
+                paDiffrentProc[nDiffrentProc - 1].pszProcedure =
+                    msStrdup(pszProcedureValue);
+                psObservationNode = msSOSAddMemberNodeObservation(
+                    psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map,
+                    (GET_LAYER(map, i)), pszProcedureValue);
+
+                paDiffrentProc[nDiffrentProc - 1].psResultNode = xmlNewChild(
+                    psObservationNode, NULL, BAD_CAST "result", NULL);
+
+                xmlNodeAddContent(
+                    paDiffrentProc[nDiffrentProc - 1].psResultNode,
+                    BAD_CAST pszResult);
+              }
+              msFree(pszProcedureValue);
+              msFree(pszResult);
+            }
+            if (paDiffrentProc) {
+              for (k = 0; k < nDiffrentProc; k++)
+                msFree(paDiffrentProc[k].pszProcedure);
+              free(paDiffrentProc);
+            }
+          }
+        }
+      }
+    }
+  }
+
+  /* output results */
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  context = msIO_getHandler(stdout);
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+  msIO_contextWrite(context, buffer, size);
+  free(schemalocation);
+  free(xsi_schemaLocation);
+  xmlFreeNs(psNsSos);
+  xmlFreeNs(psNsGml);
+  xmlFreeNs(psNsOm);
+  xmlFreeNs(psNsSwe);
+  xmlFreeNs(psNsXLink);
+  xmlFreeNs(psNsMs);
+  xmlFree(buffer);
+  msFree(script_url);
+
+  /*free  document */
+  xmlFreeDoc(psDoc);
+  /*
+   *Free the global variables that may
+   *have been allocated by the parser.
+   */
+  xmlCleanupParser();
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                           msSOSDescribeSensor                        */
+/*                                                                      */
+/*      Describe sensor request handler.                               */
+/************************************************************************/
+int msSOSDescribeSensor(mapObj *map, sosParamsObj *sosparams,
+                        owsRequestObj *ows_request) {
+  char *pszEncodedUrl = NULL;
+  const char *pszId = NULL, *pszUrl = NULL;
+  int i = 0, j = 0, k = 0;
+  layerObj *lp = NULL;
+  int iItemPosition = -1;
+  shapeObj sShape;
+  int status;
+  char *tmpstr = NULL, *pszTmp = NULL, *pszProcedureURI = NULL,
+       *pszProcedureId = NULL;
+
+  if (!sosparams->pszOutputFormat) {
+    msSetError(MS_SOSERR, "Missing mandatory parameter outputFormat.",
+               "msSOSDescribeSensor()");
+    return msSOSException(map, "outputformat", "MissingParameterValue");
+  }
+
+  if (strcasecmp(sosparams->pszOutputFormat, pszSOSDescribeSensorMimeType) !=
+      0) {
+    msSetError(MS_SOSERR,
+               "Invalid outputformat parameter %s.  Allowable values are: %s",
+               "msSOSDescribeSensor()", sosparams->pszOutputFormat,
+               pszSOSDescribeSensorMimeType);
+    return msSOSException(map, "outputformat", "InvalidParameterValue");
+  }
+
+  if (!sosparams->pszProcedure) {
+    msSetError(MS_SOSERR, "Missing mandatory parameter procedure",
+               "msSOSDescribeSensor()");
+    return msSOSException(map, "procedure", "MissingParameterValue");
+  }
+
+  for (i = 0; i < map->numlayers; i++) {
+    lp = GET_LAYER(map, i);
+    pszId = msOWSLookupMetadata(&(lp->metadata), "S", "procedure");
+    if (pszId && strlen(pszId) > 0) {
+      /*procedure could be a list*/
+      char **tokens = NULL;
+      int n = 0;
+      int bFound = 0;
+      tokens = msStringSplit(pszId, ' ', &n);
+      for (k = 0; k < n; k++) {
+        if (tokens[k] && strlen(tokens[k]) > 0) {
+          pszProcedureURI = msStrdup("urn:ogc:def:procedure:");
+          pszProcedureURI = msStringConcatenate(pszProcedureURI, tokens[k]);
+          if ((pszProcedureURI &&
+               strcasecmp(pszProcedureURI, sosparams->pszProcedure) == 0) &&
+              (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                ows_request->numlayers))) {
+            bFound = 1;
+            pszProcedureId = msStrdup(tokens[k]);
+            msFree(pszProcedureURI);
+            break;
+          }
+          msFree(pszProcedureURI);
+        }
+      }
+      msFreeCharArray(tokens, n);
+      if (bFound) {
+        pszUrl =
+            msOWSLookupMetadata(&(lp->metadata), "S", "describesensor_url");
+        if (pszUrl) {
+          pszTmp = msStrdup(pszUrl);
+
+          /* %procedure% is the hardcoded variable name to use
+             within sos_describesensor_url */
+          tmpstr = (char *)malloc(sizeof(char) * strlen("procedure") + 3);
+          sprintf(tmpstr, "%%%s%%", "procedure");
+          if (strcasestr(pszUrl, tmpstr) != NULL)
+            pszTmp = msCaseReplaceSubstring(pszTmp, tmpstr, pszProcedureId);
+          msFree(tmpstr);
+
+          pszEncodedUrl = msEncodeHTMLEntities(pszTmp);
+          msIO_printf("Location: %s\n\n", pszEncodedUrl);
+          msFree(pszTmp);
+          msFree(pszEncodedUrl);
+          msFree(pszProcedureId);
+          return (MS_SUCCESS);
+        } else {
+          msSetError(
+              MS_SOSERR,
+              "Missing mandatory metadata sos_describesensor_url on layer %s",
+              "msSOSDescribeSensor()", lp->name);
+          return msSOSException(map, "sos_describesensor_url",
+                                "MissingParameterValue");
+        }
+      }
+    } else if ((pszId = msOWSLookupMetadata(&(lp->metadata), "S",
+                                            "procedure_item"))) {
+      iItemPosition = -1;
+      if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
+        for (j = 0; j < lp->numitems; j++) {
+          if (strcasecmp(lp->items[j], pszId) == 0) {
+            iItemPosition = j;
+            break;
+          }
+        }
+        msLayerClose(lp);
+      }
+      if (iItemPosition >= 0) {
+        if (lp->template == NULL)
+          lp->template = msStrdup("ttt");
+
+        map->query.type = MS_QUERY_BY_RECT;
+        map->query.mode = MS_QUERY_MULTIPLE;
+        map->query.layer = i;
+        map->query.rect = map->extent;
+        msQueryByRect(map);
+
+        msLayerGetItems(lp);
+
+        if (lp->resultcache && lp->resultcache->numresults > 0) {
+          for (j = 0; j < lp->resultcache->numresults; j++) {
+            msInitShape(&sShape);
+            status =
+                msLayerGetShape(lp, &sShape, &(lp->resultcache->results[j]));
+            if (status != MS_SUCCESS)
+              continue;
+
+            if (sShape.values[iItemPosition]) {
+              pszProcedureURI = msStrdup("urn:ogc:def:procedure:");
+              pszProcedureURI = msStringConcatenate(
+                  pszProcedureURI, sShape.values[iItemPosition]);
+              if (strcasecmp(pszProcedureURI, sosparams->pszProcedure) == 0) {
+                pszUrl = msOWSLookupMetadata(&(lp->metadata), "S",
+                                             "describesensor_url");
+                pszProcedureId = msStrdup(sShape.values[iItemPosition]);
+                if (pszUrl) {
+                  pszTmp = msStrdup(pszUrl);
+
+                  /* %procedure% is the hardcoded variable names to use
+                     within sos_describesensor_url */
+                  tmpstr =
+                      (char *)malloc(sizeof(char) * strlen("procedure") + 3);
+                  sprintf(tmpstr, "%%%s%%", "procedure");
+                  if (strcasestr(pszUrl, tmpstr) != NULL)
+                    pszTmp =
+                        msCaseReplaceSubstring(pszTmp, tmpstr, pszProcedureId);
+                  msFree(tmpstr);
+
+                  pszEncodedUrl = msEncodeHTMLEntities(pszTmp);
+                  msIO_printf("Location: %s\n\n", pszEncodedUrl);
+                  msFree(pszTmp);
+                  return (MS_SUCCESS);
+                } else {
+                  msSetError(MS_SOSERR,
+                             "Missing mandatory metadata "
+                             "sos_describesensor_url on layer %s",
+                             "msSOSDescribeSensor()", lp->name);
+                  return msSOSException(map, "mapserv", "NoApplicableCode");
+                }
+              }
+            }
+          }
+        }
+      }
+    }
+  }
+  msSetError(MS_SOSERR, "procedure %s not found.", "msSOSDescribeSensor()",
+             sosparams->pszProcedure);
+  return msSOSException(map, "procedure", "InvalidParameterValue");
+}
+
+/************************************************************************/
+/*                           msSOSDescribeObservationType               */
+/*                                                                      */
+/*      DescribeObserrvationType request handler                        */
+/************************************************************************/
+int msSOSDescribeObservationType(mapObj *map, sosParamsObj *sosparams,
+                                 cgiRequestObj *req,
+                                 owsRequestObj *ows_request) {
+  int i, j, n = 0, bLayerFound = 0;
+  char **tokens = NULL;
+  char *script_url = NULL;
+  const char *pszTmp = NULL;
+  char *pszTmp2 = NULL;
+  const char *opLayerName = NULL;
+
+  if (!sosparams->pszObservedProperty) {
+    msSetError(MS_SOSERR, "Missing mandatory parameter observedproperty",
+               "msSOSDescribeObservationType()");
+    return msSOSException(map, "observedproperty", "MissingParameterValue");
+  }
+
+  tokens = msStringSplit(sosparams->pszObservedProperty, ',', &n);
+
+  for (i = 0; i < map->numlayers; i++) {
+    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
+      continue;
+    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                 "observedproperty_id");
+    if (pszTmp) {
+      if (strcasecmp(pszTmp, sosparams->pszObservedProperty) == 0) {
+        if (tokens && n > 0) {
+          for (j = 0; j < n; j++) {
+            if (strcasecmp(pszTmp, tokens[j]) == 0) {
+              opLayerName = GET_LAYER(map, i)->name;
+              bLayerFound = 1;
+              break;
+            }
+          }
+        }
+      }
+    }
+  }
+  if (tokens && n > 0)
+    msFreeCharArray(tokens, n);
+
+  if (bLayerFound == 0) {
+    msSetError(MS_SOSERR, "ObservedProperty %s not found.",
+               "msSOSGetObservation()", sosparams->pszObservedProperty);
+    return msSOSException(map, "observedproperty", "InvalidParameterValue");
+  }
+
+  if ((script_url = msOWSGetOnlineResource(map, "SO", "onlineresource", req)) ==
+      NULL)
+    return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
+
+  pszTmp2 = msStringConcatenate(pszTmp2, (char *)script_url);
+  pszTmp2 = msStringConcatenate(
+      pszTmp2,
+      "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
+  pszTmp2 = msStringConcatenate(pszTmp2, (char *)opLayerName);
+
+  msIO_printf("Location: %s\n\n", pszTmp2);
+  msFree(pszTmp2);
+  msFree(script_url);
+  return (MS_SUCCESS);
+}
+
+#endif /* defined(USE_WCS_SVR) && defined(USE_LIBXML2) */
+
+/*
+** msSOSDispatch() is the entry point for SOS requests.
+** - If this is a valid request then it is processed and MS_SUCCESS is returned
+**   on success, or MS_FAILURE on failure.
+*/
+int msSOSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request) {
+#if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
+  int returnvalue = MS_DONE;
+  sosParamsObj *paramsObj = (sosParamsObj *)calloc(1, sizeof(sosParamsObj));
+
+  if (msSOSParseRequest(map, req, paramsObj) == MS_FAILURE) {
+    msSOSFreeParamsObj(paramsObj);
+    free(paramsObj);
+    return MS_FAILURE;
+  }
+
+  /* SERVICE must be specified and be SOS */
+  if (paramsObj->pszService && strcasecmp(paramsObj->pszService, "SOS") ==
+                                   0) { /* this is an SOS request */
+    if (!paramsObj->pszRequest) {
+      msSetError(MS_SOSERR, "Missing REQUEST Parameter", "msSOSDispatch()");
+      msSOSFreeParamsObj(paramsObj);
+      free(paramsObj);
+      paramsObj = NULL;
+      return msSOSException(map, "request", "MissingParameterValue");
+    }
+
+    msOWSRequestLayersEnabled(map, "S", paramsObj->pszRequest, ows_request);
+    if (ows_request->numlayers == 0) {
+      msSetError(
+          MS_SOSERR,
+          "SOS request not enabled. Check sos/ows_enable_request settings.",
+          "msSOSDispatch()");
+      msSOSFreeParamsObj(paramsObj);
+      free(paramsObj);
+      paramsObj = NULL;
+      return msSOSException(map, "request", "InvalidParameterValue");
+    }
+
+    if (strcasecmp(paramsObj->pszRequest, "GetCapabilities") == 0) {
+      returnvalue = msSOSGetCapabilities(map, paramsObj, req, ows_request);
+      msSOSFreeParamsObj(paramsObj);
+      free(paramsObj);
+      paramsObj = NULL;
+      return returnvalue;
+    }
+
+    else if (strcasecmp(paramsObj->pszRequest, "DescribeSensor") == 0 ||
+             strcasecmp(paramsObj->pszRequest, "GetObservation") == 0 ||
+             strcasecmp(paramsObj->pszRequest, "DescribeObservationType") ==
+                 0) {
+      /* check version */
+      if (!paramsObj->pszVersion) {
+        msSetError(MS_SOSERR, "Missing VERSION parameter", "msSOSDispatch()");
+        msSOSFreeParamsObj(paramsObj);
+        free(paramsObj);
+        paramsObj = NULL;
+        return msSOSException(map, "version", "MissingParameterValue");
+      }
+
+      if (msOWSParseVersionString(paramsObj->pszVersion) != OWS_1_0_0) {
+        msSetError(MS_SOSERR,
+                   "VERSION %s not supported.  Supported versions are: %s.",
+                   "msSOSDispatch()", paramsObj->pszVersion, pszSOSVersion);
+        msSOSFreeParamsObj(paramsObj);
+        free(paramsObj);
+        paramsObj = NULL;
+        return msSOSException(map, "version", "InvalidParameterValue");
+      }
+
+      if (strcasecmp(paramsObj->pszRequest, "DescribeSensor") == 0)
+        returnvalue = msSOSDescribeSensor(map, paramsObj, ows_request);
+
+      else if (strcasecmp(paramsObj->pszRequest, "GetObservation") == 0)
+        returnvalue = msSOSGetObservation(map, paramsObj, req, ows_request);
+
+      else if (strcasecmp(paramsObj->pszRequest, "DescribeObservationType") ==
+               0)
+        returnvalue =
+            msSOSDescribeObservationType(map, paramsObj, req, ows_request);
+
+      msSOSFreeParamsObj(paramsObj);
+      free(paramsObj);
+      paramsObj = NULL;
+      return returnvalue;
+    } else {
+      msSetError(MS_SOSERR, "Invalid REQUEST parameter: %s", "msSOSDispatch()",
+                 paramsObj->pszRequest);
+      msSOSFreeParamsObj(paramsObj);
+      free(paramsObj);
+      paramsObj = NULL;
+      return msSOSException(map, "request", "InvalidParameterValue");
+    }
+  } else {
+    msSOSFreeParamsObj(paramsObj);
+    free(paramsObj);
+    return MS_DONE; /* Not an SOS request */
+  }
+#else
+  msSetError(MS_SOSERR, "SOS support is not available.", "msSOSDispatch()");
+  return (MS_FAILURE);
+#endif
+}
+
+#if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
+
+int msSOSParseRequest(mapObj *map, cgiRequestObj *request,
+                      sosParamsObj *sosparams) {
+  int i;
+  xmlDocPtr doc;
+  xmlXPathContextPtr context;
+  xmlNodeSetPtr nodeset;
+  xmlXPathObjectPtr psXPathTmp;
+  char *pszTmp = NULL;
+
+  if (request->NumParams) { /* this is a GET request */
+    for (i = 0; i < request->NumParams; i++) {
+      if (strcasecmp(request->ParamNames[i], "SERVICE") == 0)
+        sosparams->pszService = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "VERSION") == 0)
+        sosparams->pszVersion = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "ACCEPTVERSIONS") == 0)
+        sosparams->pszAcceptVersions = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "REQUEST") == 0)
+        sosparams->pszRequest = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "UPDATESEQUENCE") == 0)
+        sosparams->pszUpdateSequence = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "SENSORID") == 0)
+        sosparams->pszSensorId = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "PROCEDURE") == 0)
+        sosparams->pszProcedure = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "OUTPUTFORMAT") == 0)
+        sosparams->pszOutputFormat = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "OFFERING") == 0)
+        sosparams->pszOffering = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "OBSERVEDPROPERTY") == 0)
+        sosparams->pszObservedProperty = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "EVENTTIME") == 0)
+        sosparams->pszEventTime = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "RESULT") == 0)
+        sosparams->pszResult = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "RESULTMODEL") == 0)
+        sosparams->pszResultModel = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "RESPONSEFORMAT") == 0)
+        sosparams->pszResponseFormat = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "RESPONSEMODE") == 0)
+        sosparams->pszResponseMode = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "BBOX") == 0)
+        sosparams->pszBBox = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "SRSNAME") == 0)
+        sosparams->pszSrsName = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "FEATUREOFINTEREST") == 0)
+        sosparams->pszFeatureOfInterest = msStrdup(request->ParamValues[i]);
+    }
+  }
+
+  if (request->postrequest) { /* this a POST request */
+    /* load document */
+    doc = xmlParseDoc((xmlChar *)request->postrequest);
+    if (doc == NULL) {
+      msSetError(MS_SOSERR, "Invalid POST request.  XML is not well-formed",
+                 "msSOSParseRequest()");
+      return msSOSException(map, "request", "InvalidRequest");
+    }
+
+    /* load context */
+    context = xmlXPathNewContext(doc);
+    if (context == NULL) {
+      msSetError(MS_SOSERR, "Could not create context (xmlXPathNewContext)",
+                 "msSOSParseRequest()");
+      return msSOSException(map, "request", "NoApplicableCode");
+    }
+
+    /* register namespaces */
+    if (xmlXPathRegisterNs(context, (xmlChar *)"sos",
+                           (xmlChar *)"http://www.opengis.net/sos/1.0") != 0 ||
+        xmlXPathRegisterNs(context, (xmlChar *)"ows",
+                           (xmlChar *)"http://www.opengis.net/ows/1.1") != 0 ||
+        xmlXPathRegisterNs(context, (xmlChar *)"ogc",
+                           (xmlChar *)"http://www.opengis.net/ogc") != 0 ||
+        xmlXPathRegisterNs(context, (xmlChar *)"gml",
+                           (xmlChar *)"http://www.opengis.net/gml") != 0) {
+      msSetError(MS_SOSERR,
+                 "Could not register namespaces (xmlXPathRegisterNs)",
+                 "msSOSParseRequest()");
+      return msSOSException(map, "request", "NoApplicableCode");
+    }
+
+    /* check for service */
+    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/*/@service");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszService = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for updateSequence*/
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/*/@updateSequence");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszUpdateSequence = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for version */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context,
+        (xmlChar *)"/*/ows:AcceptVersions/ows:Version|/*/@version");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszVersion = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for request */
+
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetCapabilities");
+
+    if (psXPathTmp)
+      sosparams->pszRequest = msStrdup("GetCapabilities");
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor");
+
+    if (psXPathTmp)
+      sosparams->pszRequest = msStrdup("DescribeSensor");
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation");
+
+    if (psXPathTmp)
+      sosparams->pszRequest = msStrdup("GetObservation");
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    psXPathTmp = msLibXml2GetXPath(doc, context,
+                                   (xmlChar *)"/sos:DescribeObservationType");
+
+    if (psXPathTmp)
+      sosparams->pszRequest = msStrdup("DescribeObservationType");
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for outputformat */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:DescribeSensor/@outputFormat");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszOutputFormat = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for Procedure */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:DescribeSensor/sos:procedure");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszProcedure = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for offering */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:offering");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszOffering = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for observedproperty */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:observedProperty");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszObservedProperty = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for procedure */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:procedure");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszProcedure = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for responseFormat */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:responseFormat");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszResponseFormat = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for resultModel */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:resultModel");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszResultModel = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for responseMode */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:responseMode");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszResponseMode = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for srsName */
+    psXPathTmp = msLibXml2GetXPath(doc, context,
+                                   (xmlChar *)"/sos:GetObservation/@srsName");
+
+    if (psXPathTmp) {
+      nodeset = psXPathTmp->nodesetval;
+      sosparams->pszSrsName = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for result (chunk of XML) */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:result/child::*");
+
+    if (psXPathTmp) {
+      sosparams->pszResult = msLibXml2GetXPathTree(doc, psXPathTmp);
+      pszTmp = msStringConcatenate(pszTmp, "<ogc:Filter>");
+      pszTmp = msStringConcatenate(pszTmp, sosparams->pszResult);
+      pszTmp = msStringConcatenate(pszTmp, "</ogc:Filter>");
+      msFree(sosparams->pszResult);
+      sosparams->pszResult = msStrdup(pszTmp);
+      msFree(pszTmp);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for featureOfInterest (chunk of XML) */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context,
+        (xmlChar *)"/sos:GetObservation/sos:featureOfInterest/ogc:BBOX/"
+                   "gml:Envelope");
+
+    if (psXPathTmp) {
+      sosparams->pszFeatureOfInterest =
+          (char *)msLibXml2GetXPathTree(doc, psXPathTmp);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+
+    /* check for eventTime (chunk of XML) */
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context,
+        (xmlChar *)"/sos:GetObservation/sos:eventTime/*/gml:TimeInstant|/"
+                   "sos:GetObservation/sos:eventTime/*/gml:TimePeriod");
+
+    if (psXPathTmp) {
+      sosparams->pszEventTime = (char *)msLibXml2GetXPathTree(doc, psXPathTmp);
+    }
+
+    xmlXPathFreeObject(psXPathTmp);
+    xmlXPathFreeContext(context);
+    xmlFreeDoc(doc);
+    xmlCleanupParser();
+  }
+  return MS_SUCCESS;
+}
+
+void msSOSFreeParamsObj(sosParamsObj *sosparams) {
+  if (sosparams) {
+    if (sosparams->pszService)
+      free(sosparams->pszService);
+    if (sosparams->pszVersion)
+      free(sosparams->pszVersion);
+    if (sosparams->pszAcceptVersions)
+      free(sosparams->pszAcceptVersions);
+    if (sosparams->pszUpdateSequence)
+      free(sosparams->pszUpdateSequence);
+    if (sosparams->pszRequest)
+      free(sosparams->pszRequest);
+    if (sosparams->pszOutputFormat)
+      free(sosparams->pszOutputFormat);
+    if (sosparams->pszSensorId)
+      free(sosparams->pszSensorId);
+    if (sosparams->pszProcedure)
+      free(sosparams->pszProcedure);
+    if (sosparams->pszOffering)
+      free(sosparams->pszOffering);
+    if (sosparams->pszObservedProperty)
+      free(sosparams->pszObservedProperty);
+    if (sosparams->pszEventTime)
+      free(sosparams->pszEventTime);
+    if (sosparams->pszResult)
+      free(sosparams->pszResult);
+    if (sosparams->pszResponseFormat)
+      free(sosparams->pszResponseFormat);
+    if (sosparams->pszResultModel)
+      free(sosparams->pszResultModel);
+    if (sosparams->pszResponseMode)
+      free(sosparams->pszResponseMode);
+    if (sosparams->pszSrsName)
+      free(sosparams->pszSrsName);
+    if (sosparams->pszFeatureOfInterest)
+      free(sosparams->pszFeatureOfInterest);
+  }
+}
+#endif /* defined(USE_SOS_SVR) && defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/src/mapogl.cpp 8.2.0~beta1-1~exp1/src/mapogl.cpp
--- 8.0.1-5/src/mapogl.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogl.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,260 @@
+/******************************************************************************
+ * $id: mapogl.cpp 7725 2011-04-09 15:56:58Z toby $
+ *
+ * Project:  MapServer
+ * Purpose:  Various template processing functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#ifdef USE_OGL
+#include <stdio.h>
+#include <assert.h>
+#include "mapoglrenderer.h"
+#include "mapoglcontext.h"
+
+imageObj *createImageObjOgl(OglRenderer *renderer) {
+  if (!renderer->isValid())
+    return NULL;
+  imageObj *pNewImage = (imageObj *)calloc(1, sizeof(imageObj));
+  if (!pNewImage)
+    return pNewImage;
+  pNewImage->img.plugin = (void *)renderer;
+  return pNewImage;
+}
+
+OglRenderer *getOglRenderer(imageObj *img) {
+  return (OglRenderer *)img->img.plugin;
+}
+
+int msSaveImageOgl(imageObj *img, mapObj *map, FILE *fp,
+                   outputFormatObj *format) {
+  rasterBufferObj data;
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->readRasterBuffer(&data);
+  return msSaveRasterBuffer(NULL, &data, fp, img->format);
+}
+
+int msDrawLineOgl(imageObj *img, shapeObj *p, strokeStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderPolyline(p, style->color, style->width, style->patternlength,
+                           style->pattern);
+  return MS_SUCCESS;
+}
+
+int msDrawPolygonOgl(imageObj *img, shapeObj *p, colorObj *color) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderPolygon(p, color, NULL, 0);
+  return MS_SUCCESS;
+}
+
+// void msFreeTileOgl(imageObj *tile)
+//{
+//     delete (OglCache*)tile;
+// }
+
+int msDrawLineTiledOgl(imageObj *img, shapeObj *p, imageObj *tile) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderPolylineTile(p, getOglRenderer(tile)->getTexture());
+  return MS_SUCCESS;
+}
+
+int msDrawPolygonTiledOgl(imageObj *img, shapeObj *p, imageObj *tile) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderPolygon(p, NULL, NULL, 0.0,
+                          getOglRenderer(tile)->getTexture());
+  return MS_SUCCESS;
+}
+
+int msRenderPixmapOgl(imageObj *img, double x, double y, symbolObj *symbol,
+                      symbolStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderPixmap(symbol, x, y, style->rotation, style->scale);
+  return MS_SUCCESS;
+}
+
+int msRenderVectorSymbolOgl(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderVectorSymbol(x, y, symbol, style->scale, style->rotation,
+                               style->color, style->outlinecolor,
+                               style->outlinewidth);
+  return MS_SUCCESS;
+}
+
+int msRenderTruetypeSymbolOgl(imageObj *img, double x, double y,
+                              symbolObj *symbol, symbolStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
+  double size = style->scale * 72.0;
+  renderer->renderGlyphs(0, 0, style->color, style->outlinecolor, size,
+                         symbol->font, symbol->character, style->rotation, NULL,
+                         0, 0);
+  return MS_SUCCESS;
+}
+
+int msRenderTileOgl(imageObj *img, imageObj *tile, double x, double y) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderTile(getOglRenderer(tile)->getTexture(), x, y, 0.0);
+  return MS_SUCCESS;
+}
+
+int msGetTruetypeTextBBoxOgl(rendererVTableObj *renderer, char **fonts,
+                             int numfonts, double size, char *string,
+                             rectObj *rect, double **advances,
+                             int bAdjustBaseline) {
+  if (OglRenderer::getStringBBox(fonts[0], size, string, rect, advances)) {
+    return MS_SUCCESS;
+  } else {
+    return MS_FAILURE;
+  }
+}
+
+int msRenderGlyphsOgl(imageObj *img, double x, double y, labelStyleObj *style,
+                      char *text) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderGlyphs(x, y, style->color, style->outlinecolor, style->size,
+                         style->fonts[0], text, style->rotation, NULL, 0.0,
+                         0.0);
+  return MS_SUCCESS;
+}
+
+int msMergeRasterBufferOgl(imageObj *dest, rasterBufferObj *overlay,
+                           double opacity, int srcX, int srcY, int dstX,
+                           int dstY, int width, int height) {
+  OglRenderer *renderer = getOglRenderer(dest);
+  renderer->drawRasterBuffer(overlay, opacity, srcX, srcY, dstX, dstY, width,
+                             height);
+  return MS_SUCCESS;
+}
+
+imageObj *msImageCreateOgl(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
+  imageObj *pNewImage = NULL;
+
+  if (format->imagemode != MS_IMAGEMODE_RGB &&
+      format->imagemode != MS_IMAGEMODE_RGBA) {
+    msSetError(MS_OGLERR,
+               "OpenGL driver only supports RGB or RGBA pixel models.",
+               "msImageCreateOGL()");
+    return NULL;
+  }
+  return createImageObjOgl(new OglRenderer(width, height, bg));
+}
+
+int msRenderEllipseOgl(imageObj *image, double x, double y, symbolObj *symbol,
+                       symbolStyleObj *style) {
+
+  OglRenderer *renderer = getOglRenderer(image);
+  renderer->renderEllipse(x, y, style->rotation, symbol->sizex, symbol->sizey,
+                          style->color, style->outlinecolor,
+                          style->outlinewidth);
+  return MS_SUCCESS;
+}
+
+int msFreeImageOgl(imageObj *img) {
+  OglRenderer *renderer = getOglRenderer(img);
+  if (renderer) {
+    delete renderer;
+  }
+  img->img.plugin = NULL;
+  return MS_SUCCESS;
+}
+
+int msStartLayerOgl(imageObj *img, mapObj *map, layerObj *layer) {
+  getOglRenderer(img)->setTransparency((double)layer->opacity / 100);
+  return MS_SUCCESS;
+}
+
+int msEndLayerOgl(imageObj *img, mapObj *map, layerObj *layer) {
+  getOglRenderer(img)->setTransparency(1.0);
+  return MS_SUCCESS;
+}
+
+int msFreeSymbolOgl(symbolObj *s) { return MS_SUCCESS; }
+
+int msGetRasterBufferCopyOgl(imageObj *img, rasterBufferObj *rb) {
+  getOglRenderer(img)->readRasterBuffer(rb);
+  return MS_SUCCESS;
+}
+
+int msGetRasterBufferHandleOgl(imageObj *img, rasterBufferObj *rb) {
+  getOglRenderer(img)->readRasterBuffer(rb);
+  return MS_SUCCESS;
+}
+
+int msInitializeRasterBufferOgl(rasterBufferObj *rb, int width, int height,
+                                int mode) {
+  OglRenderer::initializeRasterBuffer(rb, width, height,
+                                      mode == MS_IMAGEMODE_RGBA);
+  return MS_SUCCESS;
+}
+
+#endif /* USE_OGL */
+
+int msPopulateRendererVTableOGL(rendererVTableObj *renderer) {
+#ifdef USE_OGL
+  renderer->supports_transparent_layers = 1;
+  renderer->supports_pixel_buffer = 1;
+  renderer->supports_clipping = 0;
+  renderer->use_imagecache = 0;
+  renderer->supports_bitmap_fonts = 0;
+  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
+  renderer->startLayer = msStartLayerOgl;
+  renderer->endLayer = msEndLayerOgl;
+
+  renderer->createImage = &msImageCreateOgl;
+  renderer->saveImage = &msSaveImageOgl;
+
+  renderer->renderLine = &msDrawLineOgl;
+  renderer->renderPolygon = &msDrawPolygonOgl;
+  renderer->renderGlyphs = &msRenderGlyphsOgl;
+  renderer->renderEllipseSymbol = &msRenderEllipseOgl;
+  renderer->renderVectorSymbol = &msRenderVectorSymbolOgl;
+  renderer->renderPixmapSymbol = &msRenderPixmapOgl;
+  renderer->renderTruetypeSymbol = &msRenderTruetypeSymbolOgl;
+
+  renderer->renderTile = &msRenderTileOgl;
+  renderer->renderPolygonTiled = &msDrawPolygonTiledOgl;
+  renderer->renderLineTiled = &msDrawLineTiledOgl;
+
+  renderer->getTruetypeTextBBox = &msGetTruetypeTextBBoxOgl;
+
+  renderer->getRasterBufferHandle = msGetRasterBufferHandleOgl;
+  renderer->getRasterBufferCopy = msGetRasterBufferCopyOgl;
+  renderer->initializeRasterBuffer = msInitializeRasterBufferOgl;
+  renderer->mergeRasterBuffer = msMergeRasterBufferOgl;
+  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
+
+  renderer->freeSymbol = &msFreeSymbolOgl;
+  renderer->freeImage = &msFreeImageOgl;
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR,
+             "OGL driver requested but it is not compiled in this release",
+             "msPopulateRendererVTableOGL()");
+  return MS_FAILURE;
+#endif
+}
diff -pruN 8.0.1-5/src/mapoglcontext.cpp 8.2.0~beta1-1~exp1/src/mapoglcontext.cpp
--- 8.0.1-5/src/mapoglcontext.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapoglcontext.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,535 @@
+/******************************************************************************
+ * $id: mapoglcontext.cpp 7725 2011-04-09 15:56:58Z toby $
+ *
+ * Project:  MapServer
+ * Purpose:  Various template processing functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifdef USE_OGL
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapoglcontext.h"
+
+#define _T(x) __TEXT(x)
+
+ms_uint32 OglContext::MAX_MULTISAMPLE_SAMPLES = 16;
+ms_uint32 OglContext::MAX_ANISOTROPY = 0;
+ms_uint32 OglContext::MAX_TEXTURE_SIZE = 0;
+ms_uint32 OglContext::MIN_TEXTURE_SIZE = 0;
+OglContext *OglContext::current = NULL;
+
+OglContext::OglContext(ms_uint32 width, ms_uint32 height) : valid(false) {
+  if (!window && !initWindow())
+    return;
+  if (!sharingContext && !initSharingContext())
+    return;
+
+  if (!(this->width = getTextureSize(GL_TEXTURE_WIDTH, width)))
+    return;
+  if (!(this->height = getTextureSize(GL_TEXTURE_HEIGHT, height)))
+    return;
+
+  if (!createPBuffer(this->width, this->height))
+    return;
+  if (!makeCurrent())
+    return;
+  valid = true;
+}
+
+ms_uint32 OglContext::getTextureSize(GLuint dimension, ms_uint32 value) {
+  glTexImage2D(GL_PROXY_TEXTURE_2D, 0, GL_RGBA, value, value, 0, GL_RGBA,
+               GL_UNSIGNED_BYTE, NULL);
+  GLint check = 0;
+  glGetTexLevelParameteriv(GL_PROXY_TEXTURE_2D, 0, dimension, &check);
+
+  if (glGetError() != GL_NO_ERROR) {
+    msSetError(MS_OGLERR, "glGetTexLevelParameteriv failed. glError: %d",
+               "OglContext::getTextureSize()", glGetError());
+  }
+
+  if (check == 0) {
+    return MS_MAX(MS_MIN(NextPowerOf2(value), OglContext::MAX_TEXTURE_SIZE),
+                  OglContext::MIN_TEXTURE_SIZE);
+  } else {
+    msSetError(MS_OGLERR, "Unable to create opengl texture of map size",
+               "OglContext::getTextureSize()");
+    return value;
+  }
+}
+
+GLuint OglContext::NextPowerOf2(GLuint in) {
+  in -= 1;
+
+  in |= in >> 16;
+  in |= in >> 8;
+  in |= in >> 4;
+  in |= in >> 2;
+  in |= in >> 1;
+
+  return in + 1;
+}
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+
+HDC OglContext::window = NULL;
+HGLRC OglContext::sharingContext = NULL;
+
+LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam,
+                         LPARAM lParam) {
+  return (1L);
+}
+
+OglContext::~OglContext() {
+  // TODO
+}
+
+bool OglContext::makeCurrent() {
+  if (current != this) {
+    current = this;
+    if (!wglMakeContextCurrentARB(hPBufferDC, hPBufferDC, hPBufferRC)) {
+      msSetError(MS_OGLERR, "Can't Activate The GL Rendering pbuffer.",
+                 "OglContext::makeCurrent()");
+      return FALSE;
+    }
+  }
+  return true;
+}
+
+bool OglContext::initWindow() {
+  int windowPixelFormat;
+  WNDCLASS wc;
+  DWORD dwExStyle;
+  DWORD dwStyle;
+  RECT WindowRect;
+  HMODULE hInstance = NULL;
+  HWND hWnd = NULL;
+  WindowRect.left = (long)0;
+  WindowRect.right = (long)0;
+  WindowRect.top = (long)0;
+  WindowRect.bottom = (long)0;
+  hInstance = GetModuleHandle(NULL);
+  wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
+  wc.cbClsExtra = 0;
+  wc.cbWndExtra = 0;
+  wc.lpfnWndProc = (WNDPROC)WndProc;
+  wc.hInstance = hInstance;
+  wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
+  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
+  wc.hbrBackground = NULL;
+  wc.lpszMenuName = NULL;
+  wc.lpszClassName = _T("OpenGL");
+
+  if (!RegisterClass(&wc)) {
+    msSetError(MS_OGLERR, "Failed To Register The Window Class.",
+               "OglContext::initWindow()");
+    return FALSE;
+  }
+  dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
+  dwStyle = WS_OVERLAPPEDWINDOW;
+
+  AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);
+
+  if (!(hWnd = CreateWindowEx(dwExStyle, _T("OpenGL"), _T("temp"),
+                              dwStyle | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 0, 0,
+                              WindowRect.right - WindowRect.left,
+                              WindowRect.bottom - WindowRect.top, NULL, NULL,
+                              hInstance, NULL))) {
+    msSetError(MS_OGLERR, "Window Creation Error.", "OglContext::initWindow()");
+    return FALSE;
+  }
+
+  static PIXELFORMATDESCRIPTOR pfd = {
+      sizeof(PIXELFORMATDESCRIPTOR),
+      1,
+      PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
+      PFD_TYPE_RGBA,
+      24, // Select Our Color Depth
+      0,
+      0,
+      0,
+      0,
+      0,
+      0, // Color Bits Ignored
+      8, // Alpha Buffer
+      0, // Shift Bit Ignored
+      0, // No Accumulation Buffer
+      0,
+      0,
+      0,
+      0,              // Accumulation Bits Ignored
+      16,             // 16Bit Z-Buffer (Depth Buffer)
+      0,              // No Stencil Buffer
+      0,              // No Auxiliary Buffer
+      PFD_MAIN_PLANE, // Main Drawing Layer
+      0,              // Reserved
+      0,
+      0,
+      0 // Layer Masks Ignored
+  };
+
+  if (!(window = GetDC(hWnd))) {
+    msSetError(MS_OGLERR, "Can't Create A GL Device Context.. Last Error: %d",
+               "OglContext::initWindow()", GetLastError());
+    return FALSE;
+  }
+
+  if (!(windowPixelFormat = ChoosePixelFormat(window, &pfd))) {
+    msSetError(MS_OGLERR,
+               "Can't Find A Suitable windowPixelFormat. Last Error: %d",
+               "OglContext::initWindow()", GetLastError());
+    return FALSE;
+  }
+
+  if (!SetPixelFormat(window, windowPixelFormat, &pfd)) {
+    msSetError(MS_OGLERR, "Can't Set The windowPixelFormat. Last Error: %d",
+               "OglContext::initWindow()", GetLastError());
+    return FALSE;
+  }
+  return TRUE;
+}
+
+bool OglContext::initSharingContext() {
+  if (!(sharingContext = wglCreateContext(window))) {
+    msSetError(MS_OGLERR, "Can't Create A GL Rendering Context.",
+               "OglContext::createContext()");
+    return FALSE;
+  }
+
+  if (!wglMakeCurrent(window, sharingContext)) {
+    msSetError(MS_OGLERR, "Can't Activate The GL Rendering Context.",
+               "OglContext::createContext()");
+    return FALSE;
+  }
+
+  if (!(wglChoosePixelFormatARB = (PFNWGLCHOOSEPIXELFORMATARBPROC)
+            wglGetProcAddress("wglChoosePixelFormatARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglChoosePixelFormatARB method.",
+               "OglContext::createContext()");
+    return FALSE;
+  }
+
+  if (!(wglCreatePbufferARB = (PFNWGLCREATEPBUFFERARBPROC)wglGetProcAddress(
+            "wglCreatePbufferARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglCreatePbufferARB method.",
+               "OglContext::createContext()");
+    return FALSE;
+  }
+
+  if (!(wglGetPbufferDCARB = (PFNWGLGETPBUFFERDCARBPROC)wglGetProcAddress(
+            "wglGetPbufferDCARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglGetPbufferDCARB method.",
+               "OglContext::createContext()");
+    return FALSE;
+  }
+
+  if (!(wglReleasePbufferDCARB = (PFNWGLRELEASEPBUFFERDCARBPROC)
+            wglGetProcAddress("wglReleasePbufferDCARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglReleasePbufferDCARB method.",
+               "OglContext::createContext()");
+    return FALSE;
+  }
+
+  if (!(wglMakeContextCurrentARB = (PFNWGLMAKECONTEXTCURRENTARBPROC)
+            wglGetProcAddress("wglMakeContextCurrentARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglMakeContextCurrentARB method.",
+               "OglContext::createContext()");
+    return FALSE;
+  }
+
+  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint *)&MAX_ANISOTROPY);
+  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint *)&MAX_TEXTURE_SIZE);
+
+  MIN_TEXTURE_SIZE = 8;
+
+  return TRUE;
+}
+
+bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height) {
+  HPBUFFERARB hPBuffer = NULL;
+  hPBufferDC = NULL;
+  hPBufferRC = NULL;
+
+  int pixelFormat;
+  int valid = false;
+  UINT numFormats = 0;
+  float fAttributes[] = {0, 0};
+  int samples = MAX_MULTISAMPLE_SAMPLES;
+
+  while ((!valid || numFormats == 0) && samples >= 0) {
+    int iAttributes[] = {WGL_SAMPLES_ARB,
+                         samples,
+                         WGL_DRAW_TO_PBUFFER_ARB,
+                         GL_TRUE,
+                         WGL_SUPPORT_OPENGL_ARB,
+                         GL_TRUE,
+                         WGL_ACCELERATION_ARB,
+                         WGL_FULL_ACCELERATION_ARB,
+                         WGL_COLOR_BITS_ARB,
+                         24,
+                         WGL_ALPHA_BITS_ARB,
+                         8,
+                         WGL_DEPTH_BITS_ARB,
+                         16,
+                         WGL_STENCIL_BITS_ARB,
+                         0,
+                         WGL_SAMPLE_BUFFERS_ARB,
+                         GL_TRUE,
+                         WGL_PIXEL_TYPE_ARB,
+                         WGL_TYPE_RGBA_ARB,
+                         0,
+                         0};
+
+    valid = wglChoosePixelFormatARB(window, iAttributes, fAttributes, 1,
+                                    &pixelFormat, &numFormats);
+    if (!valid || numFormats == 0)
+      samples -= 2;
+  }
+
+  if (numFormats == 0) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to find an acceptable pixel format.",
+               "OglContext::createPBuffer()");
+    return FALSE;
+  }
+
+  if (!(hPBuffer =
+            wglCreatePbufferARB(window, pixelFormat, width, height, 0))) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to create P-buffer. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
+    return FALSE;
+  }
+  if (!(hPBufferDC = wglGetPbufferDCARB(hPBuffer))) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to get P-buffer DC. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
+    return FALSE;
+  }
+  if (!(hPBufferRC = wglCreateContext(hPBufferDC))) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to get P-buffer DC. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
+    return FALSE;
+  }
+
+  if (wglShareLists(sharingContext, hPBufferRC) == FALSE) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to share display lists. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
+    return FALSE;
+  }
+
+  return TRUE;
+}
+
+PFNWGLCHOOSEPIXELFORMATARBPROC OglContext::wglChoosePixelFormatARB = NULL;
+PFNWGLCREATEPBUFFERARBPROC OglContext::wglCreatePbufferARB = NULL;
+PFNWGLGETPBUFFERDCARBPROC OglContext::wglGetPbufferDCARB = NULL;
+PFNWGLRELEASEPBUFFERDCARBPROC OglContext::wglReleasePbufferDCARB = NULL;
+PFNWGLMAKECONTEXTCURRENTARBPROC OglContext::wglMakeContextCurrentARB = NULL;
+
+#else /* UNIX */
+
+Display *OglContext::window = NULL;
+GLXContext OglContext::sharingContext = NULL;
+GLXFBConfig *OglContext::configs = NULL;
+
+OglContext::~OglContext() {
+  // TODO
+}
+
+bool OglContext::makeCurrent() {
+  if (current != this) {
+    current = this;
+    if (!glXMakeCurrent(window, pbuffer, sharingContext)) {
+      msSetError(MS_OGLERR, "glXMakeCurrent failed. glError: %d",
+                 "OglContext::makeCurrent()", glGetError());
+      return false;
+    }
+  }
+  return true;
+}
+
+bool OglContext::initSharingContext() {
+  int fb_attributes[] = {GLX_SAMPLES_ARB,
+                         MAX_MULTISAMPLE_SAMPLES,
+                         GLX_RENDER_TYPE,
+                         GLX_RGBA_BIT,
+                         GLX_DRAWABLE_TYPE,
+                         GLX_PBUFFER_BIT,
+                         GLX_RED_SIZE,
+                         8,
+                         GLX_GREEN_SIZE,
+                         8,
+                         GLX_BLUE_SIZE,
+                         8,
+                         GLX_ALPHA_SIZE,
+                         8,
+                         GLX_DEPTH_SIZE,
+                         16,
+                         GLX_DOUBLEBUFFER,
+                         0,
+                         GLX_SAMPLE_BUFFERS_ARB,
+                         1,
+                         0};
+
+  int num_configs = 0;
+  while (num_configs == 0 && fb_attributes[1] >= 0) {
+    configs = glXChooseFBConfig(window, DefaultScreen(window), fb_attributes,
+                                &num_configs);
+    fb_attributes[1] -= 2;
+  }
+
+  if (configs == NULL || num_configs == 0) {
+    msSetError(MS_OGLERR,
+               "glXChooseFBConfig could not find any configs. Likely your "
+               "video card or drivers are not supported. glError: %d",
+               "OglContext::init()", glGetError());
+    return false;
+  }
+
+  sharingContext =
+      glXCreateNewContext(window, *configs, GLX_RGBA_TYPE, NULL, 1);
+  if (sharingContext == NULL) {
+    msSetError(MS_OGLERR, "glXCreateNewContext failed. glError: %d",
+               "OglContext::initSharingContext()", glGetError());
+    return false;
+  }
+
+  return true;
+}
+
+bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height) {
+  int maxHeight, maxWidth;
+
+  glXGetFBConfigAttrib(window, *configs, GLX_MAX_PBUFFER_WIDTH, &maxWidth);
+  glXGetFBConfigAttrib(window, *configs, GLX_MAX_PBUFFER_HEIGHT, &maxHeight);
+
+  ms_uint32 uMaxHeight = maxHeight, uMaxWidth = maxWidth;
+
+  this->width = MS_MIN(width, uMaxWidth);
+  this->height = MS_MIN(height, uMaxHeight);
+
+  int iPbufferAttributes[] = {GLX_PBUFFER_WIDTH,
+                              this->width,
+                              GLX_PBUFFER_HEIGHT,
+                              this->height,
+                              GLX_LARGEST_PBUFFER,
+                              false,
+                              0,
+                              0};
+
+  pbuffer = glXCreatePbuffer(window, *configs, iPbufferAttributes);
+  if (pbuffer == 0) {
+    msSetError(MS_OGLERR, "glXCreatePbuffer failed. glError: %d",
+               "OglContext::init()", glGetError());
+    return false;
+  }
+
+  return true;
+}
+
+bool OglContext::initWindow() {
+  const char *const display_name = getenv("DISPLAY");
+  if (!display_name) {
+    msSetError(MS_OGLERR, "DISPLAY environment variable not set",
+               "OglContext::init()");
+    return false;
+  }
+
+  window = XOpenDisplay(display_name);
+  if (!window) {
+    msSetError(MS_OGLERR, "XOpenDisplay() failed.", "OglContext::init()");
+    return false;
+  }
+
+  const int fb_attributes[] = {GLX_RENDER_TYPE,
+                               GLX_RGBA_BIT,
+                               GLX_DRAWABLE_TYPE,
+                               GLX_PBUFFER_BIT,
+                               GLX_RED_SIZE,
+                               8,
+                               GLX_GREEN_SIZE,
+                               8,
+                               GLX_BLUE_SIZE,
+                               8,
+                               GLX_ALPHA_SIZE,
+                               8,
+                               GLX_DEPTH_SIZE,
+                               16,
+                               GLX_DOUBLEBUFFER,
+                               0,
+                               GLX_SAMPLE_BUFFERS_ARB,
+                               1,
+                               0};
+
+  int num_configs = 0;
+  GLXFBConfig *tempConfigs = glXChooseFBConfig(window, DefaultScreen(window),
+                                               fb_attributes, &num_configs);
+
+  if (tempConfigs == NULL || num_configs == 0) {
+    msSetError(MS_OGLERR,
+               "glXChooseFBConfig could not find any configs. Likely your "
+               "video card or drivers are not supported.",
+               "OglContext::initWindow()");
+    return false;
+  }
+
+  GLXContext tempContext =
+      glXCreateNewContext(window, *tempConfigs, GLX_RGBA_TYPE, NULL, 1);
+  if (tempContext == NULL) {
+    msSetError(MS_OGLERR, "glXCreateNewContext failed.",
+               "OglContext::initWindow()");
+    return false;
+  }
+
+  int iPbufferAttributes[] = {0, 0};
+
+  GLXPbuffer tempBuffer =
+      glXCreatePbuffer(window, *tempConfigs, iPbufferAttributes);
+  if (tempBuffer == 0) {
+    msSetError(MS_OGLERR, "glXCreatePbuffer failed.",
+               "OglContext::initWindow()");
+    return false;
+  }
+
+  if (!glXMakeCurrent(window, tempBuffer, tempContext)) {
+    msSetError(MS_OGLERR, "glXMakeCurrent failed.", "OglContext::initWindow()");
+    return false;
+  }
+
+  glGetIntegerv(GL_MAX_SAMPLES_EXT, (GLint *)&MAX_MULTISAMPLE_SAMPLES);
+  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint *)&MAX_ANISOTROPY);
+  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint *)&MAX_TEXTURE_SIZE);
+
+  MIN_TEXTURE_SIZE = 8;
+
+  return true;
+}
+
+#endif /* UNIX */
+
+#endif /* USE_OGL */
diff -pruN 8.0.1-5/src/mapoglcontext.h 8.2.0~beta1-1~exp1/src/mapoglcontext.h
--- 8.0.1-5/src/mapoglcontext.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapoglcontext.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,117 @@
+/******************************************************************************
+ * $id: mapoglcontext.h 7725 2011-04-09 15:56:58Z toby $
+ *
+ * Project:  MapServer
+ * Purpose:  Various template processing functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPOGLCONTEXT_H_
+#define MAPOGLCONTEXT_H_
+
+#ifdef USE_OGL
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+
+#include <windows.h>
+#include <GL/gl.h>
+#include <GL/glu.h>
+
+#include "opengl/glext.h"
+#include "opengl/wglext.h"
+
+typedef HDC OGL_WINDOW;
+typedef HGLRC OGL_CONTEXT;
+typedef HGLRC OGL_PBUFFER;
+
+#define CALLBACK __stdcall
+
+#else
+
+#include <GL/gl.h>
+#include <GL/glx.h>
+#include <GL/glu.h>
+
+typedef Display *OGL_WINDOW;
+typedef GLXContext OGL_CONTEXT;
+typedef GLXPbuffer OGL_PBUFFER;
+
+#define CALLBACK
+
+#endif
+
+class OglRenderer;
+
+class OglContext {
+private:
+  static OglContext *current;
+  static bool initWindow();
+  static bool initSharingContext();
+  static ms_uint32 getTextureSize(GLuint dimension, ms_uint32 value);
+  static GLuint NextPowerOf2(GLuint in);
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+  static HDC window;
+  static HGLRC sharingContext;
+  HDC hPBufferDC;
+  HGLRC hPBufferRC;
+#else
+  static Display *window;
+  static GLXContext sharingContext;
+  static GLXFBConfig *configs;
+  GLXPbuffer pbuffer;
+#endif
+
+public:
+  static ms_uint32 MAX_MULTISAMPLE_SAMPLES;
+  static ms_uint32 MAX_ANISOTROPY;
+  static ms_uint32 MAX_TEXTURE_SIZE;
+  static ms_uint32 MIN_TEXTURE_SIZE;
+
+  OglContext(ms_uint32 width, ms_uint32 height);
+  ~OglContext();
+  int getHeight() const { return height; }
+  int getWidth() const { return width; }
+  bool isValid() const { return valid; }
+  bool makeCurrent();
+  void bindPBufferToTexture();
+
+private:
+  bool createPBuffer(ms_uint32 width, ms_uint32 height);
+  ms_uint32 width;
+  ms_uint32 height;
+  bool valid;
+  int windowPixelFormat;
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+  static PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB;
+  static PFNWGLCREATEPBUFFERARBPROC wglCreatePbufferARB;
+  static PFNWGLGETPBUFFERDCARBPROC wglGetPbufferDCARB;
+  static PFNWGLRELEASEPBUFFERDCARBPROC wglReleasePbufferDCARB;
+  static PFNWGLMAKECONTEXTCURRENTARBPROC wglMakeContextCurrentARB;
+#endif
+};
+
+#endif /* USE_OGL */
+#endif /* MAPOGLCONTEXT_H_ */
diff -pruN 8.0.1-5/src/mapoglrenderer.cpp 8.2.0~beta1-1~exp1/src/mapoglrenderer.cpp
--- 8.0.1-5/src/mapoglrenderer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapoglrenderer.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,765 @@
+/******************************************************************************
+ * $id: mapoglrenderer.cpp 7725 2011-04-09 15:56:58Z toby $
+ *
+ * Project:  MapServer
+ * Purpose:  Various template processing functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifdef USE_OGL
+
+#include <algorithm>
+#include <fstream>
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapoglrenderer.h"
+
+using namespace std;
+
+double OglRenderer::SIZE_RES = 100.0 / 72.0;
+ms_uint32 OglRenderer::OUTLINE_WIDTH = 2;
+ms_uint32 OglRenderer::FONT_SIZE = 20;
+ms_uint32 OglRenderer::FONT_RES = 200;
+double OglRenderer::OGL_PI = 3.14159265;
+ms_uint32 OglRenderer::SHAPE_CIRCLE_RES = 10;
+double OglRenderer::SHAPE_CIRCLE_RADIUS = 10.0;
+
+OglRenderer::fontCache_t OglRenderer::fontCache = OglRenderer::fontCache_t();
+OglRenderer::dashCache_t OglRenderer::dashCache = OglRenderer::dashCache_t();
+std::vector<GLuint> OglRenderer::shapes = std::vector<GLuint>();
+
+GLvoid CALLBACK beginCallback(GLenum which);
+GLvoid CALLBACK errorCallback(GLenum errorCode);
+GLvoid CALLBACK endCallback(void);
+GLvoid CALLBACK combineDataCallback(GLdouble coords[3],
+                                    GLdouble *vertex_data[4], GLfloat weight[4],
+                                    void **dataOut, void *polygon_data);
+GLvoid CALLBACK vertexCallback(GLdouble *vertex);
+
+OglRenderer::OglRenderer(ms_uint32 width, ms_uint32 height, colorObj *color)
+    : width(width), height(height), texture(NULL), transparency(1.0),
+      valid(false) {
+  context = new OglContext(width, height);
+  if (!context->isValid())
+    return;
+  if (!context->makeCurrent())
+    return;
+
+  int viewPort[4];
+  glGetIntegerv(GL_VIEWPORT, viewPort);
+  viewportX = viewPort[0];
+  viewportY = viewPort[1];
+  viewportWidth = viewPort[2];
+  viewportHeight = viewPort[3];
+
+  glPushMatrix();
+
+  // set read/write context to pbuffer
+  glEnable(GL_MULTISAMPLE_ARB);
+  glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);
+
+  glEnable(GL_TEXTURE_2D);
+  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
+  glEnable(GL_BLEND);
+  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+
+  glDisable(GL_DEPTH_TEST);
+  glDepthFunc(GL_LEQUAL);
+
+  // draw & read the front buffer of pbuffer
+  glDrawBuffer(GL_FRONT);
+  glReadBuffer(GL_FRONT);
+
+  if (!(tess = gluNewTess())) {
+    msSetError(MS_OGLERR, "P-buffer Error: Unable to create tessalotor",
+               "OglRenderer");
+    return;
+  }
+
+  gluTessCallback(tess, GLU_TESS_VERTEX,
+                  (void(CALLBACK *)(void))vertexCallback);
+  gluTessCallback(tess, GLU_TESS_BEGIN, (void(CALLBACK *)(void))beginCallback);
+  gluTessCallback(tess, GLU_TESS_END, (void(CALLBACK *)(void))endCallback);
+  gluTessCallback(tess, GLU_TESS_ERROR, (void(CALLBACK *)(void))errorCallback);
+  gluTessCallback(tess, GLU_TESS_COMBINE_DATA,
+                  (void(CALLBACK *)(void))combineDataCallback);
+
+  if (color) {
+    glClearColor((double)color->red / 255, (double)color->green / 255,
+                 (double)color->blue / 255, (double)color->alpha / 100);
+  } else {
+    glClearColor(0.0, 0.0, 0.0, 0.0);
+  }
+  glClear(GL_COLOR_BUFFER_BIT);
+
+  glViewport(0, 0, width, height);
+  glMatrixMode(GL_PROJECTION);
+  glLoadIdentity();
+  glOrtho(0.0, width, 0.0, height, -3.0, 3.0);
+
+  createShapes();
+  valid = true;
+}
+
+OglRenderer::~OglRenderer() {
+  makeCurrent();
+  glViewport(viewportX, viewportY, viewportWidth, viewportHeight);
+  glPopMatrix();
+  delete context;
+}
+
+OglCachePtr OglRenderer::getTexture() {
+  if (!texture) {
+    makeCurrent();
+    texture = new OglCache();
+    texture->texture =
+        createTexture(0, 0); // TEXTURE_BORDER/2, TEXTURE_BORDER/2);
+    texture->width = this->width;
+    texture->height = this->height;
+  }
+  return texture;
+}
+
+GLuint OglRenderer::createTexture(ms_uint32 offsetX, ms_uint32 offsetY) {
+  GLuint texture = 0;
+  glGenTextures(1, &texture);
+  glBindTexture(GL_TEXTURE_2D, texture);
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
+  glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE);
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
+  if (OglContext::MAX_ANISOTROPY != 0) {
+    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT,
+                    OglContext::MAX_ANISOTROPY);
+  }
+  glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, offsetX, offsetY,
+                   context->getWidth(), context->getHeight(), 0);
+  glBindTexture(GL_TEXTURE_2D, 0);
+  return texture;
+}
+
+bool OglRenderer::getStringBBox(char *font, double size, char *string,
+                                rectObj *rect, double **advances) {
+  FTFont *face = getFTFont(font, size);
+  if (!face) {
+    msSetError(MS_OGLERR, "Failed to load font (%s).",
+               "OglRenderer::getStringBBox()", font);
+    return false;
+  }
+
+  float llx = 0.0f, lly = 0.0f, llz = 0.0f, urx = 0.0f, ury = 0.0f, urz = 0.0f;
+  glPushAttrib(GL_ALL_ATTRIB_BITS);
+  FTBBox boundingBox = face->BBox(string);
+  glPopAttrib();
+
+  rect->minx = boundingBox.Lower().X();
+  rect->maxx = boundingBox.Upper().X();
+  rect->miny = -boundingBox.Upper().Y();
+  rect->maxy = -boundingBox.Lower().Y();
+
+  if (advances) {
+    int length = strlen(string);
+    *advances = new double[length];
+    for (int i = 0; i < length; ++i) {
+      (*advances)[i] = face->Advance(&string[i], 1);
+    }
+  }
+
+  return true;
+}
+
+void OglRenderer::initializeRasterBuffer(rasterBufferObj *rb, int width,
+                                         int height, bool useAlpha) {
+  unsigned char *buffer = new unsigned char[4 * width * height];
+  rb->data.rgba.pixels = buffer;
+  rb->data.rgba.r = &buffer[2];
+  rb->data.rgba.g = &buffer[1];
+  rb->data.rgba.b = &buffer[0];
+  if (useAlpha)
+    rb->data.rgba.a = &buffer[3];
+
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->data.rgba.row_step = 4 * width;
+  rb->data.rgba.pixel_step = 4;
+  rb->width = width;
+  rb->height = height;
+}
+
+void OglRenderer::readRasterBuffer(rasterBufferObj *rb) {
+  makeCurrent();
+  unsigned char *buffer = new unsigned char[4 * width * height];
+  glReadPixels(0, 0, width, height, GL_BGRA, GL_UNSIGNED_BYTE, buffer);
+
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->data.rgba.pixels = buffer;
+  rb->data.rgba.row_step = 4 * width;
+  rb->data.rgba.pixel_step = 4;
+  rb->width = width;
+  rb->height = height;
+  rb->data.rgba.r = &buffer[2];
+  rb->data.rgba.g = &buffer[1];
+  rb->data.rgba.b = &buffer[0];
+  rb->data.rgba.a = NULL;
+}
+
+void OglRenderer::drawRasterBuffer(rasterBufferObj *overlay, double opacity,
+                                   int srcX, int srcY, int dstX, int dstY,
+                                   int width, int height) {
+  // todo to support all alpha and srcx/y this needs to be done by creating a
+  // texture
+  makeCurrent();
+  glDrawPixels(width, height, GL_BGRA, GL_UNSIGNED_BYTE,
+               overlay->data.rgba.pixels);
+}
+
+void OglRenderer::setTransparency(double transparency) {
+  this->transparency = transparency;
+}
+
+void OglRenderer::setColor(colorObj *color) {
+  if (color && MS_VALID_COLOR(*color)) {
+    glColor4d((double)color->red / 255, (double)color->green / 255,
+              (double)color->blue / 255, transparency);
+  } else {
+    glColor4d(0.0, 0.0, 0.0, 1.0);
+  }
+}
+
+void OglRenderer::drawVectorLineStrip(symbolObj *symbol, double width) {
+  glPushMatrix();
+  glLineWidth(width);
+  glBegin(GL_LINE_STRIP);
+  for (int i = 0; i < symbol->numpoints; i++) {
+    if (symbol->points[i].x < 0 && symbol->points[i].y < 0) {
+      glEnd();
+      glBegin(GL_LINE_STRIP);
+    } else {
+      glVertex2d(symbol->points[i].x, symbol->points[i].y);
+    }
+  }
+  glEnd();
+
+  glPopMatrix();
+}
+
+double OglRenderer::drawTriangles(pointObj *p1, pointObj *p2, double width,
+                                  double tilelength, double textureStart) {
+  double dx = p1->x - p2->x;
+  double dy = p1->y - p2->y;
+  double dist = sqrt(dx * dx + dy * dy);
+  double theta;
+  if (dx != 0)
+    theta = atan(dy / dx);
+  else
+    theta = (dy > 0 ? 1 : -1) * OGL_PI / 2;
+
+  double xw = sin(theta) * width / 2;
+  double yw = cos(theta) * width / 2;
+
+  double textureEnd = dist / tilelength;
+
+  glTexCoord2d(textureStart, 1);
+  glVertex2d(p1->x + xw, p1->y - yw); // Bottom Left Of The Texture and Quad
+  glTexCoord2d(textureStart, 0);
+  glVertex2d(p1->x - xw, p1->y + yw); // Bottom Right Of The Texture and Quad
+  glTexCoord2d(textureStart + textureEnd, 1);
+  glVertex2d(p2->x + xw, p2->y - yw); // Top Right Of The Texture and Quad
+  glTexCoord2d(textureStart + textureEnd, 0);
+  glVertex2d(p2->x - xw, p2->y + yw); // Top Left Of The Texture and Quad
+
+  return dist;
+}
+
+double OglRenderer::drawQuad(pointObj *p1, pointObj *p2, double width,
+                             double tilelength, double textureStart) {
+  double dx = p1->x - p2->x;
+  double dy = p1->y - p2->y;
+  double dist = sqrt(dx * dx + dy * dy);
+  double theta;
+  if (dx)
+    theta = atan(dy / dx);
+  else
+    theta = (dy > 0 ? 1 : -1) * OGL_PI / 2;
+
+  glPushMatrix();
+  glTranslated(p1->x, p1->y, 0);
+  glRotated((p1->x < p2->x ? 0 : 180) + theta * (180 / OGL_PI), 0, 0, 1);
+  glTranslated(-p1->x, -p1->y, 0);
+
+  glBegin(GL_QUADS);
+  glTexCoord2d(textureStart, 1);
+  glVertex2d(p1->x, p1->y - width / 2); // Bottom Left Of The Texture and Quad
+  glTexCoord2d(textureStart + (dist / tilelength), 1);
+  glVertex2d(p1->x + dist,
+             p1->y - width / 2); // Bottom Right Of The Texture and Quad
+  glTexCoord2d(textureStart + (dist / tilelength), 0);
+  glVertex2d(p1->x + dist,
+             p1->y + width / 2); // Top Right Of The Texture and Quad
+  glTexCoord2d(textureStart, 0);
+  glVertex2d(p1->x, p1->y + width / 2); // Top Left Of The Texture and Quad
+  glEnd();
+
+  glPopMatrix();
+
+  return dist;
+}
+
+void OglRenderer::renderTile(const OglCachePtr &tile, double x, double y,
+                             double angle) {
+  makeCurrent();
+  glEnable(GL_SAMPLE_ALPHA_TO_COVERAGE_ARB);
+  glBindTexture(GL_TEXTURE_2D, tile->texture);
+  glPushMatrix();
+  glTranslated(x, y, 0);
+  if (angle) {
+    glRotated(angle, 0, 0, 1);
+  }
+  glTranslated(-x, -y, 0);
+  glBegin(GL_QUADS);
+  glTexCoord2d(0, 1);
+  glVertex2d(x - (tile->width / 2),
+             y + (tile->height / 2)); // Bottom Left Of The Texture and Quad
+  glTexCoord2d(1, 1);
+  glVertex2d(x + (tile->width / 2),
+             y + (tile->height / 2)); // Bottom Right Of The Texture and Quad
+  glTexCoord2d(1, 0);
+  glVertex2d(x + (tile->width / 2),
+             y - (tile->height / 2)); // Top Right Of The Texture and Quad
+  glTexCoord2d(0, 0);
+  glVertex2d(x - (tile->width / 2),
+             y - (tile->height / 2)); // Top Left Of The Texture and Quad
+  glEnd();
+
+  glPopMatrix();
+  glBindTexture(GL_TEXTURE_2D, 0);
+  glDisable(GL_SAMPLE_ALPHA_TO_COVERAGE_ARB);
+}
+
+void OglRenderer::renderPolylineTile(shapeObj *shape, const OglCachePtr &tile) {
+  makeCurrent();
+  glBindTexture(GL_TEXTURE_2D, tile->texture); // Select Our Texture
+  glBegin(GL_TRIANGLE_STRIP);
+
+  double place = 0.0;
+  for (int i = 0; i < shape->numlines; i++) {
+    for (int j = 0; j < shape->line[i].numpoints - 1; j++) {
+      double dist =
+          drawTriangles(&shape->line[i].point[j], &shape->line[i].point[j + 1],
+                        tile->height, tile->width, place / tile->width);
+      place = (place + dist);
+      while (place >= tile->width)
+        place -= tile->width;
+    }
+  }
+  glEnd();
+  glBindTexture(GL_TEXTURE_2D, 0);
+}
+
+void OglRenderer::renderVectorSymbol(double x, double y, symbolObj *symbol,
+                                     double scale, double angle, colorObj *c,
+                                     colorObj *oc, double ow) {
+  makeCurrent();
+  glPushMatrix();
+  glTranslated(x, y, 0);
+  glRotated(angle, 0, 0, 1);
+  glScaled(scale, scale, 0);
+
+  glTranslated(-symbol->sizex / 2, -symbol->sizey / 2, 0.0);
+
+  if (oc != NULL && MS_VALID_COLOR(*oc) && ow > 0) {
+    setColor(oc);
+    drawVectorLineStrip(symbol, ow);
+  }
+
+  if (c != NULL && MS_VALID_COLOR(*c) && ow > 0) {
+    setColor(c);
+    drawVectorLineStrip(symbol, ow);
+  }
+
+  glPopMatrix();
+}
+
+void OglRenderer::renderPolyline(shapeObj *p, colorObj *c, double width,
+                                 int patternlength, double *pattern,
+                                 int lineCap, int joinStyle,
+                                 colorObj *outlinecolor, double outlinewidth) {
+  makeCurrent();
+  if (outlinecolor) {
+    glEnable(GL_DEPTH_TEST);
+    glPushMatrix();
+    glTranslated(0, 0, 1);
+  }
+
+  setColor(c);
+
+  if (patternlength > 0) {
+    if (p->renderer_cache == NULL) {
+      loadLine(p, width, patternlength, pattern);
+    }
+    /* FIXME */
+    if (p->renderer_cache == NULL)
+      return;
+    OglCache *cache = (OglCache *)p->renderer_cache;
+    GLuint texture = cache->texture;
+    if (cache->patternDistance > 0) {
+      glBindTexture(GL_TEXTURE_2D, texture);
+      double place = 0;
+      glBegin(GL_TRIANGLE_STRIP);
+      for (int j = 0; j < p->numlines; j++) {
+        for (int i = 0; i < p->line[j].numpoints - 1; i++) {
+          double dist = drawTriangles(
+              &p->line[j].point[i], &p->line[j].point[i + 1], width,
+              cache->patternDistance, place / cache->patternDistance);
+          place = (place + dist);
+          while (place >= cache->patternDistance)
+            place -= cache->patternDistance; // better than mod, no rounding
+        }
+      }
+      glEnd();
+      glBindTexture(GL_TEXTURE_2D, 0);
+    }
+  } else {
+    float widthRange[2];
+    glGetFloatv(GL_LINE_WIDTH_RANGE, widthRange);
+    bool quads = !(width >= widthRange[0] && width <= widthRange[1]);
+    double circleScale = width / SHAPE_CIRCLE_RADIUS / 2;
+    glLineWidth(width);
+    if (quads || (width > 1.0 &&
+                  (lineCap == MS_CJC_ROUND || joinStyle == MS_CJC_ROUND))) {
+      for (int j = 0; j < p->numlines; j++) {
+        for (int i = 0; i < p->line[j].numpoints; i++) {
+          if (i != p->line[j].numpoints - 1) {
+            if (quads) {
+              drawQuad(&p->line[j].point[i], &p->line[j].point[i + 1], width);
+            } else {
+              glBegin(GL_LINES);
+              glVertex2f(p->line[j].point[i].x, p->line[j].point[i].y);
+              glVertex2f(p->line[j].point[i + 1].x, p->line[j].point[i + 1].y);
+              glEnd();
+            }
+          }
+          if ((lineCap == MS_CJC_ROUND &&
+               (i == 0 || i == p->line[j].numpoints - 1)) ||
+              (joinStyle == MS_CJC_ROUND &&
+               (i > 0 && i < p->line[j].numpoints - 1))) {
+            glPushMatrix();
+            glTranslated(p->line[j].point[i].x, p->line[j].point[i].y, 0);
+            glScaled(circleScale, circleScale, 0);
+            glCallList(shapes[circle]);
+            glPopMatrix();
+          }
+        }
+      }
+    } else {
+      for (int j = 0; j < p->numlines; j++) {
+        glBegin(GL_LINE_STRIP);
+        for (int i = 0; i < p->line[j].numpoints; i++) {
+          glVertex2f(p->line[j].point[i].x, p->line[j].point[i].y);
+        }
+        glEnd();
+      }
+    }
+  }
+
+  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor)) {
+    glPopMatrix();
+    double owidth = MS_MAX(width + OUTLINE_WIDTH, outlinewidth);
+    glPushMatrix();
+    glTranslated(0, 0, -1);
+    renderPolyline(p, outlinecolor, owidth, patternlength, pattern, lineCap,
+                   joinStyle);
+    glPopMatrix();
+    glDisable(GL_DEPTH_TEST);
+  }
+}
+
+void OglRenderer::renderPolygon(shapeObj *p, colorObj *color,
+                                colorObj *outlinecolor, double outlinewidth,
+                                const OglCachePtr &tile, int lineCap,
+                                int joinStyle) {
+  /*
+   OpenGL cannot draw complex polygons so we need to use a Tessallator to draw
+   the polygon using a GL_TRIANGLE_FAN
+
+   ISSUE: There's a problem here. It would seem that changing the dimensions or
+   bounding box area breaks the code. Reports need for a combine callback.
+   */
+  makeCurrent();
+  std::vector<GLdouble *> pointers;
+  double texWidth = 0;
+  double texHeight = 0;
+
+  if (tile) {
+    glBindTexture(GL_TEXTURE_2D, tile->texture); // Select Our Texture
+    texWidth = tile->width;
+    texHeight = tile->height;
+  }
+  setColor(color);
+  gluTessBeginPolygon(tess, NULL);
+  for (int j = 0; j < p->numlines; j++) {
+    gluTessBeginContour(tess);
+    for (int i = 0; i < p->line[j].numpoints; i++) {
+      // create temp array and place
+      GLdouble *dbls = new GLdouble[5];
+      pointers.push_back(dbls);
+      dbls[0] = p->line[j].point[i].x;
+      dbls[1] = p->line[j].point[i].y;
+      dbls[2] = 0.0;
+      dbls[3] = texWidth;
+      dbls[4] = texHeight;
+      gluTessVertex(tess, dbls, dbls);
+    }
+    gluTessEndContour(tess);
+  }
+  gluTessEndPolygon(tess);
+
+  // destroy temp arrays
+  for (std::vector<GLdouble *>::iterator iter = pointers.begin();
+       iter != pointers.end(); iter++) {
+    delete[] * iter;
+  }
+
+  glBindTexture(GL_TEXTURE_2D, 0); // Select Our Texture
+
+  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor) &&
+      outlinewidth > 0) {
+    renderPolyline(p, outlinecolor, outlinewidth, 0, NULL, lineCap, joinStyle);
+  }
+}
+
+void OglRenderer::renderGlyphs(double x, double y, colorObj *color,
+                               colorObj *outlinecolor, double size,
+                               const char *font, char *thechars, double angle,
+                               colorObj *shadowcolor, double shdx,
+                               double shdy) {
+  makeCurrent();
+  FTFont *face = getFTFont(font, size);
+  if (!face) {
+    msSetError(MS_OGLERR, "Failed to load font (%s).",
+               "OglRenderer::renderGlyphs()", font);
+    return;
+  }
+
+  glPushAttrib(GL_ALL_ATTRIB_BITS);
+  glPushMatrix();
+
+  glTranslated(floor(x), floor(y), 0);
+  glScaled(1.0, -1.0, 1);
+  glRotated(angle * (180 / OGL_PI), 0, 0, 1);
+
+  if (outlinecolor && MS_VALID_COLOR(*outlinecolor)) {
+    setColor(outlinecolor);
+    for (int i = -1; i <= 1; i++) {
+      for (int j = -1; j <= 1; j++) {
+        if (i || j) {
+          glPushMatrix();
+          glTranslated(i, j, 0);
+          face->Render(thechars);
+          glPopMatrix();
+        }
+      }
+    }
+  }
+  if (color != NULL && MS_VALID_COLOR(*color)) {
+    setColor(color);
+    face->Render(thechars);
+  }
+
+  glPopMatrix();
+  glPopAttrib();
+}
+
+void OglRenderer::renderPixmap(symbolObj *symbol, double x, double y,
+                               double angle, double scale) {
+  makeCurrent();
+
+  float zoomX, zoomY;
+  glGetFloatv(GL_ZOOM_X, &zoomX);
+  glGetFloatv(GL_ZOOM_Y, &zoomY);
+
+  GLubyte *imgdata = symbol->pixmap_buffer->data.rgba.pixels;
+  glPixelZoom(zoomX * scale, zoomY * scale);
+  glRasterPos2d(x - symbol->pixmap_buffer->width / 2,
+                y - symbol->pixmap_buffer->height / 2);
+  glDrawPixels(symbol->pixmap_buffer->width, symbol->pixmap_buffer->height,
+               GL_BGRA, GL_UNSIGNED_BYTE, imgdata);
+  glPixelZoom(zoomX, zoomY);
+}
+
+void OglRenderer::renderEllipse(double x, double y, double angle, double width,
+                                double height, colorObj *color,
+                                colorObj *outlinecolor,
+                                double outlinewidth = 1.0) {
+  makeCurrent();
+  if (outlinecolor && MS_VALID_COLOR(*outlinecolor)) {
+    glEnable(GL_DEPTH_TEST);
+    glPushMatrix();
+    glTranslated(0, 0, 1);
+  }
+
+  setColor(color);
+
+  glPushMatrix();
+  if (angle) {
+    glRotated(angle, 0, 0, 1);
+  }
+  glTranslated(x, y, 0);
+  glScaled(width / SHAPE_CIRCLE_RADIUS / 2, height / SHAPE_CIRCLE_RADIUS / 2,
+           1);
+  glCallList(shapes[circle]);
+  glPopMatrix();
+
+  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor)) {
+    glPopMatrix();
+    glPushMatrix();
+    glTranslated(0, 0, -1);
+    renderEllipse(x, y, angle, width + outlinewidth, height, outlinecolor, NULL,
+                  0);
+    glPopMatrix();
+    glDisable(GL_DEPTH_TEST);
+  }
+}
+
+bool OglRenderer::loadLine(shapeObj *shape, double width, int patternlength,
+                           double *pattern) {
+  /*    OglCache* cache = (OglCache*) shape->renderer_cache;
+
+      if (cache->patternDistance == 0)
+      {
+          for (int i = 0; i < patternlength; i++)
+          {
+              cache->patternDistance += pattern[i];
+          }
+      }
+      GLubyte imgdata[TEX_SIZE * TEX_SIZE * 4];
+      int pow2length = min(max(NextPowerOf2(cache->patternDistance),
+     MIN_TEX_SIZE), TEX_SIZE); int pow2width = min(max(NextPowerOf2(width),
+     MIN_TEX_SIZE), TEX_SIZE);
+
+      double lengthScale = (double) pow2length / cache->patternDistance;
+      glColor3d(0, 0, 0);
+      double place = 0;
+      double xRadii = width / 2 * lengthScale;
+      double yRadii = pow2width / 2;
+      for (int i = 0; i < patternlength; i++)
+      {
+          double next = pattern[i] * lengthScale;
+          if (i % 2 == 0)
+          {
+
+              glPushMatrix();
+              glTranslated(place + xRadii, yRadii, 0);
+              glScaled(xRadii / SHAPE_CIRCLE_RADIUS,
+                      yRadii / SHAPE_CIRCLE_RADIUS, 0);
+              glCallList(shapes[circle]);
+              glPopMatrix();
+
+              glBegin(GL_QUADS);
+              glVertex2d(place + pow2width / 2, 0);
+              glVertex2d(place + next - pow2width / 2, 0);
+              glVertex2d(place + next - pow2width / 2, pow2width);
+              glVertex2d(place + pow2width / 2, pow2width);
+              glEnd();
+
+              glPushMatrix();
+              glTranslated(place + next - xRadii, yRadii, 0);
+              glScaled(xRadii / SHAPE_CIRCLE_RADIUS,
+                      yRadii / SHAPE_CIRCLE_RADIUS, 0);
+              glCallList(shapes[circle]);
+              glPopMatrix();
+
+          }
+          place += next;
+      }
+
+      glReadPixels(0, 0, pow2length, pow2width, GL_RGBA, GL_UNSIGNED_BYTE,
+              imgdata);
+      //createTexture(pow2length, pow2width, GL_ALPHA, imgdata);*/
+  return true;
+}
+
+FTFont *OglRenderer::getFTFont(const char *font, double size) {
+  FTFont **face = &fontCache[font][size];
+  if (*face == NULL && ifstream(font)) {
+    *face = new FTGLTextureFont(font);
+    if (*face) {
+      (*face)->UseDisplayList(true);
+      (*face)->FaceSize(size * SIZE_RES);
+    }
+  }
+  return *face;
+}
+
+GLvoid CALLBACK beginCallback(GLenum which) { glBegin(which); }
+
+GLvoid CALLBACK errorCallback(GLenum errorCode) {
+  const GLubyte *estring;
+  estring = gluErrorString(errorCode);
+  fprintf(stderr, "Tessellation Error: %d %s\n", errorCode, estring);
+  exit(0);
+}
+
+GLvoid CALLBACK endCallback(void) { glEnd(); }
+
+GLvoid CALLBACK combineDataCallback(GLdouble coords[3],
+                                    GLdouble *vertex_data[4], GLfloat weight[4],
+                                    void **dataOut, void *polygon_data) {
+  GLdouble *vertex;
+  vertex = (GLdouble *)malloc(5 * sizeof(GLdouble));
+  vertex[0] = coords[0];
+  vertex[1] = coords[1];
+  vertex[2] = coords[2];
+  vertex[3] = vertex_data[0][3];
+  vertex[4] = vertex_data[0][4];
+  *dataOut = vertex;
+}
+
+GLvoid CALLBACK vertexCallback(GLdouble *vertex) {
+  if (vertex[3] > 0)
+    glTexCoord2d(vertex[0] / vertex[3], vertex[1] / vertex[4]);
+  glVertex3dv(vertex);
+}
+
+void OglRenderer::createShapes() {
+  double da = MS_MIN(OGL_PI / 2, OGL_PI / SHAPE_CIRCLE_RES);
+  GLuint circle = glGenLists(1);
+  glNewList(circle, GL_COMPILE);
+  glBegin(GL_TRIANGLE_FAN);
+  glVertex2d(0, 0);
+  for (double a = 0.0; a <= 2 * OGL_PI; a += da) {
+    glVertex2d(0 + cos(a) * SHAPE_CIRCLE_RADIUS,
+               0 + sin(a) * SHAPE_CIRCLE_RADIUS);
+  }
+  glVertex2d(0 + SHAPE_CIRCLE_RADIUS, 0);
+  glEnd();
+
+  glEndList();
+  shapes.push_back(circle);
+}
+
+void OglRenderer::makeCurrent() { context->makeCurrent(); }
+
+#endif
diff -pruN 8.0.1-5/src/mapoglrenderer.h 8.2.0~beta1-1~exp1/src/mapoglrenderer.h
--- 8.0.1-5/src/mapoglrenderer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapoglrenderer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,148 @@
+/******************************************************************************
+ * $id: mapoglrenderer.h 7725 2011-04-09 15:56:58Z toby $
+ *
+ * Project:  MapServer
+ * Purpose:  Various template processing functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef OGL_H
+#define OGL_H
+
+#ifdef USE_OGL
+
+#include "mapoglcontext.h"
+#include "mapserver.h"
+
+#include <vector>
+#include <map>
+#include <memory>
+
+#include <FTGL/ftgl.h>
+#include <FTGL/FTGLTextureFont.h>
+
+class OglCache {
+public:
+  ~OglCache() { glDeleteTextures(1, &texture); }
+  GLuint texture;
+  ms_uint32 width;
+  ms_uint32 height;
+  ms_uint32 patternDistance;
+};
+
+typedef OglCache *OglCachePtr;
+
+class OglRenderer {
+public:
+  OglRenderer(ms_uint32 width, ms_uint32 height, colorObj *color = NULL);
+  virtual ~OglRenderer();
+
+  void renderPolyline(shapeObj *p, colorObj *c, double width, int patternlength,
+                      double *pattern, int lineCap = MS_CJC_ROUND,
+                      int joinStyle = MS_CJC_ROUND,
+                      colorObj *outlinecolor = NULL, double outlinewidth = 0);
+  void renderPolygon(shapeObj *, colorObj *color, colorObj *outlinecolor,
+                     double outlinewidth,
+                     const OglCachePtr &tile = OglCachePtr(),
+                     int lineCap = MS_CJC_ROUND, int joinStyle = MS_CJC_ROUND);
+  void renderGlyphs(double x, double y, colorObj *color, colorObj *outlinecolor,
+                    double size, const char *font, char *thechars, double angle,
+                    colorObj *shadowcolor, double shdx, double shdy);
+  void renderPixmap(symbolObj *symbol, double x, double y, double angle,
+                    double scale);
+  void renderEllipse(double x, double y, double angle, double w, double h,
+                     colorObj *color, colorObj *outlinecolor,
+                     double outlinewidth);
+  void renderVectorSymbol(double x, double y, symbolObj *symbol, double scale,
+                          double angle, colorObj *c, colorObj *oc, double ow);
+  void renderTile(const OglCachePtr &tile, double x, double y, double angle);
+  void renderPolylineTile(shapeObj *p, const OglCachePtr &tile);
+
+  static bool getStringBBox(char *font, double size, char *string,
+                            rectObj *rect, double **advances);
+  void setTransparency(double transparency);
+
+  void readRasterBuffer(rasterBufferObj *rb);
+  void drawRasterBuffer(rasterBufferObj *overlay, double opacity, int srcX,
+                        int srcY, int dstX, int dstY, int width, int height);
+  static void initializeRasterBuffer(rasterBufferObj *rb, int width, int height,
+                                     bool useAlpha);
+
+  OglCachePtr getTexture();
+  int getWidth() const { return width; }
+  int getHeight() const { return height; }
+  bool isValid() const { return valid && context->isValid(); }
+
+protected:
+  OglCachePtr texture;
+
+  ms_uint32 width;
+  ms_uint32 height;
+  double transparency;
+  bool valid;
+
+  GLint viewportX;
+  GLint viewportY;
+  GLsizei viewportWidth;
+  GLsizei viewportHeight;
+
+  typedef std::map<const char *, std::map<double, FTFont *>> fontCache_t;
+  typedef std::map<symbolObj *, std::map<double, GLuint>> dashCache_t;
+
+  static FTFont *getFTFont(const char *font, double size);
+  bool loadLine(shapeObj *shape, double width, int patternlength,
+                double *pattern);
+  double drawQuad(pointObj *p1, pointObj *p2, double width,
+                  double tilelength = 0.0, double textureStart = 0.0);
+  double drawTriangles(pointObj *p1, pointObj *p2, double width,
+                       double tilelength = 0.0, double textureStart = 0.0);
+  void drawVectorLineStrip(symbolObj *symbol, double width);
+  void drawFan(pointObj *center, pointObj *from, pointObj *to, int resolution);
+  void createShapes();
+
+  GLuint createTexture(ms_uint32 x, ms_uint32 y);
+
+  void makeCurrent();
+  void setColor(colorObj *color);
+
+  GLUtesselator *tess;
+  enum shapes_t { circle = 0 };
+
+  OglContext *context;
+
+  static dashCache_t dashCache;
+  static fontCache_t fontCache;
+  static std::vector<GLuint> shapes;
+  static std::vector<symbolObj *> testSymbols;
+  static ms_uint32 OUTLINE_WIDTH;
+  static ms_uint32 FONT_SIZE;
+  static ms_uint32 FONT_RES;
+  static double OGL_PI;
+  static ms_uint32 SHAPE_CIRCLE_RES;
+  static double SHAPE_CIRCLE_RADIUS;
+  static double SIZE_RES;
+};
+
+#endif /* USE_OGL */
+#endif
diff -pruN 8.0.1-5/src/mapogr.cpp 8.2.0~beta1-1~exp1/src/mapogr.cpp
--- 8.0.1-5/src/mapogr.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogr.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5376 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGR Link
+ * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
+ *           Frank Warmerdam (warmerdam@pobox.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2000-2005, Daniel Morissette, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "mapproject.h"
+#include "mapthread.h"
+#include "mapows.h"
+#include <string>
+#include <vector>
+
+#include "gdal.h"
+#include "cpl_conv.h"
+#include "cpl_string.h"
+#include "ogr_srs_api.h"
+
+#include <memory>
+
+#define ACQUIRE_OGR_LOCK msAcquireLock(TLOCK_OGR)
+#define RELEASE_OGR_LOCK msReleaseLock(TLOCK_OGR)
+
+// GDAL 1.x API
+#include "ogr_api.h"
+
+typedef struct ms_ogr_file_info_t {
+  char *pszFname;
+  char *pszLayerDef;
+  int nLayerIndex;
+  OGRDataSourceH hDS;
+  OGRLayerH hLayer;
+  OGRFeatureH hLastFeature;
+
+  int nTileId;             /* applies on the tiles themselves. */
+  projectionObj sTileProj; /* applies on the tiles themselves. */
+
+  struct ms_ogr_file_info_t *poCurTile; /* exists on tile index, -> tiles */
+  bool rect_is_defined;
+  rectObj rect; /* set by TranslateMsExpression (possibly) and WhichShapes */
+
+  int last_record_index_read;
+
+  const char *dialect; /* NULL, Spatialite or PostgreSQL */
+  char *pszSelect;
+  char *pszSpatialFilterTableName;
+  char *pszSpatialFilterGeometryColumn;
+  char *pszMainTableName;
+  char *pszRowId;
+  int bIsOKForSQLCompose;
+  bool bHasSpatialIndex; // used only for spatialite for now
+  char *pszTablePrefix;  // prefix to qualify field names. used only for
+                         // spatialite & gpkg for now when a join is done for
+                         // spatial filtering.
+
+  int bPaging;
+
+  char *pszWHERE;
+
+} msOGRFileInfo;
+
+static int msOGRLayerIsOpen(layerObj *layer);
+static int msOGRLayerInitItemInfo(layerObj *layer);
+static int msOGRLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                  shapeObj *shape);
+static void msOGRCloseConnection(void *conn_handle);
+
+/* ==================================================================
+ * Geometry conversion functions
+ * ================================================================== */
+
+/**********************************************************************
+ *                     ogrPointsAddPoint()
+ *
+ * NOTE: This function assumes the line->point array already has been
+ * allocated large enough for the point to be added, but that numpoints
+ * does not include this new point.
+ **********************************************************************/
+static void ogrPointsAddPoint(lineObj *line, double dX, double dY, double dZ,
+                              int lineindex, rectObj *bounds) {
+  /* Keep track of shape bounds */
+  if (line->numpoints == 0 && lineindex == 0) {
+    bounds->minx = bounds->maxx = dX;
+    bounds->miny = bounds->maxy = dY;
+  } else {
+    if (dX < bounds->minx)
+      bounds->minx = dX;
+    if (dX > bounds->maxx)
+      bounds->maxx = dX;
+    if (dY < bounds->miny)
+      bounds->miny = dY;
+    if (dY > bounds->maxy)
+      bounds->maxy = dY;
+  }
+
+  line->point[line->numpoints].x = dX;
+  line->point[line->numpoints].y = dY;
+  line->point[line->numpoints].z = dZ;
+  line->point[line->numpoints].m = 0.0;
+  line->numpoints++;
+}
+
+/**********************************************************************
+ *                     ogrGeomPoints()
+ **********************************************************************/
+static int ogrGeomPoints(OGRGeometryH hGeom, shapeObj *outshp) {
+  int i;
+  int numpoints;
+
+  if (hGeom == NULL)
+    return 0;
+
+  OGRwkbGeometryType eGType = wkbFlatten(OGR_G_GetGeometryType(hGeom));
+
+  /* -------------------------------------------------------------------- */
+  /*      Container types result in recursive invocation on each          */
+  /*      subobject to add a set of points to the current list.           */
+  /* -------------------------------------------------------------------- */
+  switch (eGType) {
+  case wkbGeometryCollection:
+  case wkbMultiLineString:
+  case wkbMultiPolygon:
+  case wkbPolygon: {
+    /* Treat it as GeometryCollection */
+    for (int iGeom = 0; iGeom < OGR_G_GetGeometryCount(hGeom); iGeom++) {
+      if (ogrGeomPoints(OGR_G_GetGeometryRef(hGeom, iGeom), outshp) == -1)
+        return -1;
+    }
+
+    return 0;
+  } break;
+
+  case wkbPoint:
+  case wkbMultiPoint:
+  case wkbLineString:
+  case wkbLinearRing:
+    /* We will handle these directly */
+    break;
+
+  default:
+    /* There shouldn't be any more cases should there? */
+    msSetError(MS_OGRERR, "OGRGeometry type `%s' not supported yet.",
+               "ogrGeomPoints()", OGR_G_GetGeometryName(hGeom));
+    return (-1);
+  }
+
+  /* ------------------------------------------------------------------
+   * Count total number of points
+   * ------------------------------------------------------------------ */
+  if (eGType == wkbPoint) {
+    numpoints = 1;
+  } else if (eGType == wkbLineString || eGType == wkbLinearRing) {
+    numpoints = OGR_G_GetPointCount(hGeom);
+  } else if (eGType == wkbMultiPoint) {
+    numpoints = OGR_G_GetGeometryCount(hGeom);
+  } else {
+    msSetError(MS_OGRERR, "OGRGeometry type `%s' not supported yet.",
+               "ogrGeomPoints()", OGR_G_GetGeometryName(hGeom));
+    return (-1);
+  }
+
+  /* ------------------------------------------------------------------
+   * Do we need to allocate a line object to contain all our points?
+   * ------------------------------------------------------------------ */
+  if (outshp->numlines == 0) {
+    lineObj newline;
+
+    newline.numpoints = 0;
+    newline.point = NULL;
+    msAddLine(outshp, &newline);
+  }
+
+  /* ------------------------------------------------------------------
+   * Extend the point array for the new of points to add from the
+   * current geometry.
+   * ------------------------------------------------------------------ */
+  lineObj *line = outshp->line + outshp->numlines - 1;
+
+  if (line->point == NULL)
+    line->point = (pointObj *)malloc(sizeof(pointObj) * numpoints);
+  else
+    line->point = (pointObj *)realloc(
+        line->point, sizeof(pointObj) * (numpoints + line->numpoints));
+
+  if (!line->point) {
+    msSetError(MS_MEMERR, "Unable to allocate temporary point cache.",
+               "ogrGeomPoints()");
+    return (-1);
+  }
+
+  /* ------------------------------------------------------------------
+   * alloc buffer and filter/transform points
+   * ------------------------------------------------------------------ */
+  if (eGType == wkbPoint) {
+    ogrPointsAddPoint(line, OGR_G_GetX(hGeom, 0), OGR_G_GetY(hGeom, 0),
+                      OGR_G_GetZ(hGeom, 0), outshp->numlines - 1,
+                      &(outshp->bounds));
+  } else if (eGType == wkbLineString || eGType == wkbLinearRing) {
+    for (i = 0; i < numpoints; i++)
+      ogrPointsAddPoint(line, OGR_G_GetX(hGeom, i), OGR_G_GetY(hGeom, i),
+                        OGR_G_GetZ(hGeom, i), outshp->numlines - 1,
+                        &(outshp->bounds));
+  } else if (eGType == wkbMultiPoint) {
+    for (i = 0; i < numpoints; i++) {
+      OGRGeometryH hPoint = OGR_G_GetGeometryRef(hGeom, i);
+      ogrPointsAddPoint(line, OGR_G_GetX(hPoint, 0), OGR_G_GetY(hPoint, 0),
+                        OGR_G_GetZ(hPoint, 0), outshp->numlines - 1,
+                        &(outshp->bounds));
+    }
+  }
+
+  outshp->type = MS_SHAPE_POINT;
+
+  return (0);
+}
+
+/**********************************************************************
+ *                     ogrGeomLine()
+ *
+ * Recursively convert any OGRGeometry into a shapeObj.  Each part becomes
+ * a line in the overall shapeObj.
+ **********************************************************************/
+static int ogrGeomLine(OGRGeometryH hGeom, shapeObj *outshp, int bCloseRings) {
+  if (hGeom == NULL)
+    return 0;
+
+  /* ------------------------------------------------------------------
+   * Use recursive calls for complex geometries
+   * ------------------------------------------------------------------ */
+  OGRwkbGeometryType eGType = wkbFlatten(OGR_G_GetGeometryType(hGeom));
+
+  if (eGType == wkbPolygon || eGType == wkbGeometryCollection ||
+      eGType == wkbMultiLineString || eGType == wkbMultiPolygon) {
+    if (eGType == wkbPolygon && outshp->type == MS_SHAPE_NULL)
+      outshp->type = MS_SHAPE_POLYGON;
+
+    /* Treat it as GeometryCollection */
+    for (int iGeom = 0; iGeom < OGR_G_GetGeometryCount(hGeom); iGeom++) {
+      if (ogrGeomLine(OGR_G_GetGeometryRef(hGeom, iGeom), outshp,
+                      bCloseRings) == -1)
+        return -1;
+    }
+  }
+  /* ------------------------------------------------------------------
+   * OGRPoint and OGRMultiPoint
+   * ------------------------------------------------------------------ */
+  else if (eGType == wkbPoint || eGType == wkbMultiPoint) {
+    /* Hummmm a point when we're drawing lines/polygons... just drop it! */
+  }
+  /* ------------------------------------------------------------------
+   * OGRLinearRing/OGRLineString ... both are of type wkbLineString
+   * ------------------------------------------------------------------ */
+  else if (eGType == wkbLineString) {
+    int j, numpoints;
+    lineObj line = {0, NULL};
+    double dX, dY;
+
+    if ((numpoints = OGR_G_GetPointCount(hGeom)) < 2)
+      return 0;
+
+    if (outshp->type == MS_SHAPE_NULL)
+      outshp->type = MS_SHAPE_LINE;
+
+    line.numpoints = 0;
+    line.point = (pointObj *)malloc(sizeof(pointObj) * (numpoints + 1));
+    if (!line.point) {
+      msSetError(MS_MEMERR, "Unable to allocate temporary point cache.",
+                 "ogrGeomLine");
+      return (-1);
+    }
+
+    OGR_G_GetPoints(hGeom, &(line.point[0].x), sizeof(pointObj),
+                    &(line.point[0].y), sizeof(pointObj), &(line.point[0].z),
+                    sizeof(pointObj));
+
+    for (j = 0; j < numpoints; j++) {
+      dX = line.point[j].x = OGR_G_GetX(hGeom, j);
+      dY = line.point[j].y = OGR_G_GetY(hGeom, j);
+
+      /* Keep track of shape bounds */
+      if (j == 0 && outshp->numlines == 0) {
+        outshp->bounds.minx = outshp->bounds.maxx = dX;
+        outshp->bounds.miny = outshp->bounds.maxy = dY;
+      } else {
+        if (dX < outshp->bounds.minx)
+          outshp->bounds.minx = dX;
+        if (dX > outshp->bounds.maxx)
+          outshp->bounds.maxx = dX;
+        if (dY < outshp->bounds.miny)
+          outshp->bounds.miny = dY;
+        if (dY > outshp->bounds.maxy)
+          outshp->bounds.maxy = dY;
+      }
+    }
+    line.numpoints = numpoints;
+
+    if (bCloseRings && (line.point[line.numpoints - 1].x != line.point[0].x ||
+                        line.point[line.numpoints - 1].y != line.point[0].y)) {
+      line.point[line.numpoints].x = line.point[0].x;
+      line.point[line.numpoints].y = line.point[0].y;
+      line.point[line.numpoints].z = line.point[0].z;
+      line.numpoints++;
+    }
+
+    msAddLineDirectly(outshp, &line);
+  } else {
+    msSetError(MS_OGRERR, "OGRGeometry type `%s' not supported.",
+               "ogrGeomLine()", OGR_G_GetGeometryName(hGeom));
+    return (-1);
+  }
+
+  return (0);
+}
+
+/**********************************************************************
+ *                     ogrGetLinearGeometry()
+ *
+ * Fetch geometry from OGR feature. If using GDAL 2.0 or later, the geometry
+ * might be of curve type, so linearize it.
+ **********************************************************************/
+static OGRGeometryH ogrGetLinearGeometry(OGRFeatureH hFeature) {
+  /* Convert in place and reassign to the feature */
+  OGRGeometryH hGeom = OGR_F_StealGeometry(hFeature);
+  if (hGeom != NULL) {
+    hGeom = OGR_G_ForceTo(hGeom, OGR_GT_GetLinear(OGR_G_GetGeometryType(hGeom)),
+                          NULL);
+    OGR_F_SetGeometryDirectly(hFeature, hGeom);
+  }
+  return hGeom;
+}
+
+/**********************************************************************
+ *                     ogrConvertGeometry()
+ *
+ * Convert OGR geometry into a shape object doing the best possible
+ * job to match OGR Geometry type and layer type.
+ *
+ * If layer type is incompatible with geometry, then shape is returned with
+ * shape->type = MS_SHAPE_NULL
+ **********************************************************************/
+static int ogrConvertGeometry(OGRGeometryH hGeom, shapeObj *outshp,
+                              enum MS_LAYER_TYPE layertype) {
+  /* ------------------------------------------------------------------
+   * Process geometry according to layer type
+   * ------------------------------------------------------------------ */
+  int nStatus = MS_SUCCESS;
+
+  if (hGeom == NULL) {
+    // Empty geometry... this is not an error... we'll just skip it
+    return MS_SUCCESS;
+  }
+
+  switch (layertype) {
+    /* ------------------------------------------------------------------
+     *      POINT layer - Any geometry can be converted to point/multipoint
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_POINT:
+    if (ogrGeomPoints(hGeom, outshp) == -1) {
+      nStatus = MS_FAILURE; // Error message already produced.
+    }
+    break;
+    /* ------------------------------------------------------------------
+     *      LINE layer
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_LINE:
+    if (ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
+      nStatus = MS_FAILURE; // Error message already produced.
+    }
+    if (outshp->type != MS_SHAPE_LINE && outshp->type != MS_SHAPE_POLYGON)
+      outshp->type = MS_SHAPE_NULL; // Incompatible type for this layer
+    break;
+    /* ------------------------------------------------------------------
+     *      POLYGON layer
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_POLYGON:
+    if (ogrGeomLine(hGeom, outshp, MS_TRUE) == -1) {
+      nStatus = MS_FAILURE; // Error message already produced.
+    }
+    if (outshp->type != MS_SHAPE_POLYGON)
+      outshp->type = MS_SHAPE_NULL; // Incompatible type for this layer
+    break;
+    /* ------------------------------------------------------------------
+     *      Chart or Query layers - return real feature type
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_CHART:
+  case MS_LAYER_QUERY:
+    switch (OGR_G_GetGeometryType(hGeom)) {
+    case wkbPoint:
+    case wkbPoint25D:
+    case wkbMultiPoint:
+    case wkbMultiPoint25D:
+      if (ogrGeomPoints(hGeom, outshp) == -1) {
+        nStatus = MS_FAILURE; // Error message already produced.
+      }
+      break;
+    default:
+      // Handle any non-point types as lines/polygons ... ogrGeomLine()
+      // will decide the shape type
+      if (ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
+        nStatus = MS_FAILURE; // Error message already produced.
+      }
+    }
+    break;
+
+  default:
+    msSetError(MS_MISCERR, "Unknown or unsupported layer type.",
+               "msOGRLayerNextShape()");
+    nStatus = MS_FAILURE;
+  } /* switch layertype */
+
+  return nStatus;
+}
+
+/**********************************************************************
+ *                     msOGRGeometryToShape()
+ *
+ * Utility function to convert from OGR geometry to a mapserver shape
+ * object.
+ **********************************************************************/
+int msOGRGeometryToShape(OGRGeometryH hGeometry, shapeObj *psShape,
+                         OGRwkbGeometryType nType) {
+  if (hGeometry && psShape && nType > 0) {
+    if (nType == wkbPoint || nType == wkbMultiPoint)
+      return ogrConvertGeometry(hGeometry, psShape, MS_LAYER_POINT);
+    else if (nType == wkbLineString || nType == wkbMultiLineString)
+      return ogrConvertGeometry(hGeometry, psShape, MS_LAYER_LINE);
+    else if (nType == wkbPolygon || nType == wkbMultiPolygon)
+      return ogrConvertGeometry(hGeometry, psShape, MS_LAYER_POLYGON);
+    else
+      return MS_FAILURE;
+  } else
+    return MS_FAILURE;
+}
+
+/* ==================================================================
+ * Attributes handling functions
+ * ================================================================== */
+
+// Special field index codes for handling text string and angle coming from
+// OGR style strings.
+
+#define MSOGR_FID_INDEX -99
+
+#define MSOGR_LABELNUMITEMS 21
+#define MSOGR_LABELFONTNAMENAME "OGR:LabelFont"
+#define MSOGR_LABELFONTNAMEINDEX -100
+#define MSOGR_LABELSIZENAME "OGR:LabelSize"
+#define MSOGR_LABELSIZEINDEX -101
+#define MSOGR_LABELTEXTNAME "OGR:LabelText"
+#define MSOGR_LABELTEXTINDEX -102
+#define MSOGR_LABELANGLENAME "OGR:LabelAngle"
+#define MSOGR_LABELANGLEINDEX -103
+#define MSOGR_LABELFCOLORNAME "OGR:LabelFColor"
+#define MSOGR_LABELFCOLORINDEX -104
+#define MSOGR_LABELBCOLORNAME "OGR:LabelBColor"
+#define MSOGR_LABELBCOLORINDEX -105
+#define MSOGR_LABELPLACEMENTNAME "OGR:LabelPlacement"
+#define MSOGR_LABELPLACEMENTINDEX -106
+#define MSOGR_LABELANCHORNAME "OGR:LabelAnchor"
+#define MSOGR_LABELANCHORINDEX -107
+#define MSOGR_LABELDXNAME "OGR:LabelDx"
+#define MSOGR_LABELDXINDEX -108
+#define MSOGR_LABELDYNAME "OGR:LabelDy"
+#define MSOGR_LABELDYINDEX -109
+#define MSOGR_LABELPERPNAME "OGR:LabelPerp"
+#define MSOGR_LABELPERPINDEX -110
+#define MSOGR_LABELBOLDNAME "OGR:LabelBold"
+#define MSOGR_LABELBOLDINDEX -111
+#define MSOGR_LABELITALICNAME "OGR:LabelItalic"
+#define MSOGR_LABELITALICINDEX -112
+#define MSOGR_LABELUNDERLINENAME "OGR:LabelUnderline"
+#define MSOGR_LABELUNDERLINEINDEX -113
+#define MSOGR_LABELPRIORITYNAME "OGR:LabelPriority"
+#define MSOGR_LABELPRIORITYINDEX -114
+#define MSOGR_LABELSTRIKEOUTNAME "OGR:LabelStrikeout"
+#define MSOGR_LABELSTRIKEOUTINDEX -115
+#define MSOGR_LABELSTRETCHNAME "OGR:LabelStretch"
+#define MSOGR_LABELSTRETCHINDEX -116
+#define MSOGR_LABELADJHORNAME "OGR:LabelAdjHor"
+#define MSOGR_LABELADJHORINDEX -117
+#define MSOGR_LABELADJVERTNAME "OGR:LabelAdjVert"
+#define MSOGR_LABELADJVERTINDEX -118
+#define MSOGR_LABELHCOLORNAME "OGR:LabelHColor"
+#define MSOGR_LABELHCOLORINDEX -119
+#define MSOGR_LABELOCOLORNAME "OGR:LabelOColor"
+#define MSOGR_LABELOCOLORINDEX -120
+// Special codes for the OGR style parameters
+#define MSOGR_LABELPARAMNAME "OGR:LabelParam"
+#define MSOGR_LABELPARAMNAMELEN 14
+#define MSOGR_LABELPARAMINDEX -500
+#define MSOGR_BRUSHPARAMNAME "OGR:BrushParam"
+#define MSOGR_BRUSHPARAMNAMELEN 14
+#define MSOGR_BRUSHPARAMINDEX -600
+#define MSOGR_PENPARAMNAME "OGR:PenParam"
+#define MSOGR_PENPARAMNAMELEN 12
+#define MSOGR_PENPARAMINDEX -700
+#define MSOGR_SYMBOLPARAMNAME "OGR:SymbolParam"
+#define MSOGR_SYMBOLPARAMNAMELEN 15
+#define MSOGR_SYMBOLPARAMINDEX -800
+
+/**********************************************************************
+ *                     msOGRGetValues()
+ *
+ * Load selected item (i.e. field) values into a char array
+ *
+ * Some special attribute names are used to return some OGRFeature params
+ * like for instance stuff encoded in the OGRStyleString.
+ * For now the following pseudo-attribute names are supported:
+ *  "OGR:TextString"  OGRFeatureStyle's text string if present
+ *  "OGR:TextAngle"   OGRFeatureStyle's text angle, or 0 if not set
+ **********************************************************************/
+static char **msOGRGetValues(layerObj *layer, OGRFeatureH hFeature) {
+  char **values;
+  const char *pszValue = NULL;
+  int i;
+
+  if (layer->numitems == 0)
+    return (NULL);
+
+  if (!layer->iteminfo) // Should not happen... but just in case!
+    if (msOGRLayerInitItemInfo(layer) != MS_SUCCESS)
+      return NULL;
+
+  if ((values = (char **)malloc(sizeof(char *) * layer->numitems)) == NULL) {
+    msSetError(MS_MEMERR, NULL, "msOGRGetValues()");
+    return (NULL);
+  }
+
+  OGRStyleMgrH hStyleMgr = NULL;
+  OGRStyleToolH hLabelStyle = NULL;
+  OGRStyleToolH hPenStyle = NULL;
+  OGRStyleToolH hBrushStyle = NULL;
+  OGRStyleToolH hSymbolStyle = NULL;
+
+  int *itemindexes = (int *)layer->iteminfo;
+
+  int nYear;
+  int nMonth;
+  int nDay;
+  int nHour;
+  int nMinute;
+  int nSecond;
+  int nTZFlag;
+
+  for (i = 0; i < layer->numitems; i++) {
+    if (itemindexes[i] >= 0) {
+      // Extract regular attributes
+      const char *pszValue = OGR_F_GetFieldAsString(hFeature, itemindexes[i]);
+      if (pszValue[0] == 0) {
+        values[i] = msStrdup("");
+      } else {
+        OGRFieldDefnH hFieldDefnRef =
+            OGR_F_GetFieldDefnRef(hFeature, itemindexes[i]);
+        switch (OGR_Fld_GetType(hFieldDefnRef)) {
+        case OFTTime:
+          OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth,
+                                   &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
+          switch (nTZFlag) {
+          case 0: // Unknown time zone
+          case 1: // Local time zone (not specified)
+            values[i] =
+                msStrdup(CPLSPrintf("%02d:%02d:%02d", nHour, nMinute, nSecond));
+            break;
+          case 100: // GMT
+            values[i] = msStrdup(
+                CPLSPrintf("%02d:%02d:%02dZ", nHour, nMinute, nSecond));
+            break;
+          default: // Offset (in quarter-hour units) from GMT
+            const int TZOffset = std::abs(nTZFlag - 100) * 15;
+            const int TZHour = TZOffset / 60;
+            const int TZMinute = TZOffset % 60;
+            const char TZSign = (nTZFlag > 100) ? '+' : '-';
+            values[i] =
+                msStrdup(CPLSPrintf("%02d:%02d:%02d%c%02d:%02d", nHour, nMinute,
+                                    nSecond, TZSign, TZHour, TZMinute));
+          }
+          break;
+        case OFTDate:
+          OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth,
+                                   &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
+          values[i] =
+              msStrdup(CPLSPrintf("%04d-%02d-%02d", nYear, nMonth, nDay));
+          break;
+        case OFTDateTime:
+          OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth,
+                                   &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
+          switch (nTZFlag) {
+          case 0: // Unknown time zone
+          case 1: // Local time zone (not specified)
+            values[i] =
+                msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02d", nYear,
+                                    nMonth, nDay, nHour, nMinute, nSecond));
+            break;
+          case 100: // GMT
+            values[i] =
+                msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02dZ", nYear,
+                                    nMonth, nDay, nHour, nMinute, nSecond));
+            break;
+          default: // Offset (in quarter-hour units) from GMT
+            const int TZOffset = std::abs(nTZFlag - 100) * 15;
+            const int TZHour = TZOffset / 60;
+            const int TZMinute = TZOffset % 60;
+            const char TZSign = (nTZFlag > 100) ? '+' : '-';
+            values[i] = msStrdup(CPLSPrintf(
+                "%04d-%02d-%02dT%02d:%02d:%02d%c%02d:%02d", nYear, nMonth, nDay,
+                nHour, nMinute, nSecond, TZSign, TZHour, TZMinute));
+          }
+          break;
+        default:
+          values[i] = msStrdup(pszValue);
+          break;
+        }
+      }
+    } else if (itemindexes[i] == MSOGR_FID_INDEX) {
+      values[i] =
+          msStrdup(CPLSPrintf(CPL_FRMT_GIB, (GIntBig)OGR_F_GetFID(hFeature)));
+    } else {
+      // Handle special OGR attributes coming from StyleString
+      if (!hStyleMgr) {
+        hStyleMgr = OGR_SM_Create(NULL);
+        OGR_SM_InitFromFeature(hStyleMgr, hFeature);
+        int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
+        for (int i = 0; i < numParts; i++) {
+          OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
+          if (hStylePart) {
+            if (OGR_ST_GetType(hStylePart) == OGRSTCLabel && !hLabelStyle)
+              hLabelStyle = hStylePart;
+            else if (OGR_ST_GetType(hStylePart) == OGRSTCPen && !hPenStyle)
+              hPenStyle = hStylePart;
+            else if (OGR_ST_GetType(hStylePart) == OGRSTCBrush && !hBrushStyle)
+              hBrushStyle = hStylePart;
+            else if (OGR_ST_GetType(hStylePart) == OGRSTCSymbol &&
+                     !hSymbolStyle)
+              hSymbolStyle = hStylePart;
+            else {
+              OGR_ST_Destroy(hStylePart);
+              hStylePart = NULL;
+            }
+          }
+          /* Setting up the size units according to msOGRLayerGetAutoStyle*/
+          if (hStylePart && layer->map)
+            OGR_ST_SetUnit(hStylePart, OGRSTUPixel,
+                           layer->map->cellsize * layer->map->resolution /
+                               layer->map->defresolution * 72.0 * 39.37);
+        }
+      }
+      int bDefault;
+      if (itemindexes[i] == MSOGR_LABELTEXTINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelTextString,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELTEXTNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELANGLEINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAngle,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELANGLENAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELSIZEINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelSize,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELSIZENAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELFCOLORINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFColor,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("#000000");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELFCOLORNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELFONTNAMEINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFontName,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("Arial");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELFONTNAMENAME " =       \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELBCOLORINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelBColor,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("#000000");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELBCOLORNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELPLACEMENTINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelPlacement,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELPLACEMENTNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELANCHORINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAnchor,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELANCHORNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELDXINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelDx,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELDXNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELDYINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelDy,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELDYNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELPERPINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelPerp,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELPERPNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELBOLDINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelBold,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELBOLDNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELITALICINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelItalic,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELITALICNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELUNDERLINEINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelUnderline,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELUNDERLINENAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELPRIORITYINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelPriority,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELPRIORITYNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELSTRIKEOUTINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelStrikeout,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELSTRIKEOUTNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELSTRETCHINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelStretch,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("0");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELSTRETCHNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELADJHORINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAdjHor,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELADJHORNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELADJVERTINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAdjVert,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELADJVERTNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELHCOLORINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelHColor,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELHCOLORNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] == MSOGR_LABELOCOLORINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelOColor,
+                                            &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELOCOLORNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] >= MSOGR_LABELPARAMINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hLabelStyle, itemindexes[i] - MSOGR_LABELPARAMINDEX,
+                  &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_LABELPARAMNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] >= MSOGR_BRUSHPARAMINDEX) {
+        if (hBrushStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hBrushStyle, itemindexes[i] - MSOGR_BRUSHPARAMINDEX,
+                  &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_BRUSHPARAMNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] >= MSOGR_PENPARAMINDEX) {
+        if (hPenStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hPenStyle, itemindexes[i] - MSOGR_PENPARAMINDEX,
+                  &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_PENPARAMNAME " = \"%s\"\n", values[i]);
+      } else if (itemindexes[i] >= MSOGR_SYMBOLPARAMINDEX) {
+        if (hSymbolStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hSymbolStyle, itemindexes[i] - MSOGR_SYMBOLPARAMINDEX,
+                  &bDefault)) == NULL))
+          values[i] = msStrdup("");
+        else
+          values[i] = msStrdup(pszValue);
+
+        if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug(MSOGR_SYMBOLPARAMNAME " = \"%s\"\n", values[i]);
+      } else {
+        msFreeCharArray(values, i);
+
+        OGR_SM_Destroy(hStyleMgr);
+        OGR_ST_Destroy(hLabelStyle);
+        OGR_ST_Destroy(hPenStyle);
+        OGR_ST_Destroy(hBrushStyle);
+        OGR_ST_Destroy(hSymbolStyle);
+
+        msSetError(MS_OGRERR, "Invalid field index!?!", "msOGRGetValues()");
+        return (NULL);
+      }
+    }
+  }
+
+  OGR_SM_Destroy(hStyleMgr);
+  OGR_ST_Destroy(hLabelStyle);
+  OGR_ST_Destroy(hPenStyle);
+  OGR_ST_Destroy(hBrushStyle);
+  OGR_ST_Destroy(hSymbolStyle);
+
+  return (values);
+}
+
+/**********************************************************************
+ *                     msOGRSpatialRef2ProjectionObj()
+ *
+ * Init a MapServer projectionObj using an OGRSpatialRef
+ * Works only with PROJECTION AUTO
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+static int msOGRSpatialRef2ProjectionObj(OGRSpatialReferenceH hSRS,
+                                         projectionObj *proj, int debug_flag) {
+  // First flush the "auto" name from the projargs[]...
+  msFreeProjectionExceptContext(proj);
+
+  if (hSRS == NULL || OSRIsLocal(hSRS)) {
+    // Dataset had no set projection or is NonEarth (LOCAL_CS)...
+    // Nothing else to do. Leave proj empty and no reprojection will happen!
+    return MS_SUCCESS;
+  }
+
+  // This helps avoiding going through potentially lossy PROJ4 strings
+  const char *pszAuthName = OSRGetAuthorityName(hSRS, NULL);
+  if (pszAuthName && EQUAL(pszAuthName, "EPSG")) {
+    const char *pszAuthCode = OSRGetAuthorityCode(hSRS, NULL);
+    if (pszAuthCode) {
+      char szInitStr[32];
+      sprintf(szInitStr, "init=epsg:%d", atoi(pszAuthCode));
+
+      if (debug_flag)
+        msDebug("AUTO = %s\n", szInitStr);
+
+      return msLoadProjectionString(proj, szInitStr) == 0 ? MS_SUCCESS
+                                                          : MS_FAILURE;
+    }
+  }
+
+  // Export OGR SRS to a PROJ4 string
+  char *pszProj = NULL;
+
+  if (OSRExportToProj4(hSRS, &pszProj) != OGRERR_NONE || pszProj == NULL ||
+      strlen(pszProj) == 0) {
+    msSetError(MS_OGRERR, "Conversion from OGR SRS to PROJ4 failed.",
+               "msOGRSpatialRef2ProjectionObj()");
+    CPLFree(pszProj);
+    return (MS_FAILURE);
+  }
+
+  if (debug_flag)
+    msDebug("AUTO = %s\n", pszProj);
+
+  if (msLoadProjectionString(proj, pszProj) != 0)
+    return MS_FAILURE;
+
+  CPLFree(pszProj);
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGCWKT2ProjectionObj()
+ *
+ * Init a MapServer projectionObj using an OGC WKT definition.
+ * Works only with PROJECTION AUTO
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+
+int msOGCWKT2ProjectionObj(const char *pszWKT, projectionObj *proj,
+                           int debug_flag)
+
+{
+  OGRSpatialReferenceH hSRS;
+  char *pszAltWKT = (char *)pszWKT;
+  OGRErr eErr;
+  int ms_result;
+
+  hSRS = OSRNewSpatialReference(NULL);
+
+  if (!EQUALN(pszWKT, "GEOGCS", 6) && !EQUALN(pszWKT, "PROJCS", 6) &&
+      !EQUALN(pszWKT, "LOCAL_CS", 8))
+    eErr = OSRSetFromUserInput(hSRS, pszWKT);
+  else
+    eErr = OSRImportFromWkt(hSRS, &pszAltWKT);
+
+  if (eErr != OGRERR_NONE) {
+    OSRDestroySpatialReference(hSRS);
+    msSetError(MS_OGRERR, "Ingestion of WKT string '%s' failed.",
+               "msOGCWKT2ProjectionObj()", pszWKT);
+    return MS_FAILURE;
+  }
+
+  ms_result = msOGRSpatialRef2ProjectionObj(hSRS, proj, debug_flag);
+
+  OSRDestroySpatialReference(hSRS);
+  return ms_result;
+}
+
+/**********************************************************************
+ *                     msOGRFileOpen()
+ *
+ * Open an OGR connection, and initialize a msOGRFileInfo.
+ **********************************************************************/
+
+static int bOGRDriversRegistered = MS_FALSE;
+
+void msOGRInitialize(void)
+
+{
+  /* ------------------------------------------------------------------
+   * Register OGR Drivers, only once per execution
+   * ------------------------------------------------------------------ */
+  if (!bOGRDriversRegistered) {
+    ACQUIRE_OGR_LOCK;
+
+    OGRRegisterAll();
+    CPLPushErrorHandler(CPLQuietErrorHandler);
+
+    /* ------------------------------------------------------------------
+     * Pass config option GML_FIELDTYPES=ALWAYS_STRING to OGR so that all
+     * GML attributes are returned as strings to MapServer. This is most
+     * efficient and prevents problems with autodetection of some attribute
+     * types.
+     * ------------------------------------------------------------------ */
+    CPLSetConfigOption("GML_FIELDTYPES", "ALWAYS_STRING");
+
+    bOGRDriversRegistered = MS_TRUE;
+
+    RELEASE_OGR_LOCK;
+  }
+}
+
+/* ==================================================================
+ * The following functions closely relate to the API called from
+ * maplayer.c, but are intended to be used for the tileindex or direct
+ * layer access.
+ * ================================================================== */
+
+static void msOGRFileOpenSpatialite(layerObj *layer, const char *pszLayerDef,
+                                    msOGRFileInfo *psInfo);
+
+/**********************************************************************
+ *                     msOGRFileOpen()
+ *
+ * Open an OGR connection, and initialize a msOGRFileInfo.
+ **********************************************************************/
+
+static msOGRFileInfo *msOGRFileOpen(layerObj *layer, const char *connection)
+
+{
+  char *conn_decrypted = NULL;
+
+  msOGRInitialize();
+
+  /* ------------------------------------------------------------------
+   * Make sure any encrypted token in the connection string are decrypted
+   * ------------------------------------------------------------------ */
+  if (connection) {
+    conn_decrypted = msDecryptStringTokens(layer->map, connection);
+    if (conn_decrypted == NULL)
+      return NULL; /* An error should already have been reported */
+  }
+
+  /* ------------------------------------------------------------------
+   * Parse connection string into dataset name, and layer name.
+   * ------------------------------------------------------------------ */
+  char *pszDSName = NULL, *pszLayerDef = NULL;
+
+  if (conn_decrypted == NULL) {
+    /* we don't have anything */
+  } else if (layer->data != NULL) {
+    pszDSName = CPLStrdup(conn_decrypted);
+    pszLayerDef = CPLStrdup(layer->data);
+  } else {
+    char **papszTokens = NULL;
+
+    papszTokens = CSLTokenizeStringComplex(conn_decrypted, ",", TRUE, FALSE);
+
+    if (CSLCount(papszTokens) > 0)
+      pszDSName = CPLStrdup(papszTokens[0]);
+    if (CSLCount(papszTokens) > 1)
+      pszLayerDef = CPLStrdup(papszTokens[1]);
+
+    CSLDestroy(papszTokens);
+  }
+
+  /* Get rid of decrypted connection string. We'll use the original (not
+   * decrypted) string for debug and error messages in the rest of the code.
+   */
+  msFree(conn_decrypted);
+  conn_decrypted = NULL;
+
+  if (pszDSName == NULL) {
+    msSetError(MS_OGRERR,
+               "Error parsing OGR connection information in layer `%s'",
+               "msOGRFileOpen()", layer->name ? layer->name : "(null)");
+    return NULL;
+  }
+
+  if (pszLayerDef == NULL)
+    pszLayerDef = CPLStrdup("0");
+
+  /* -------------------------------------------------------------------- */
+  /*      Can we get an existing connection for this layer?               */
+  /* -------------------------------------------------------------------- */
+  OGRDataSourceH hDS;
+
+  hDS = (OGRDataSourceH)msConnPoolRequest(layer);
+
+  /* -------------------------------------------------------------------- */
+  /*      If not, open now, and register this connection with the         */
+  /*      pool.                                                           */
+  /* -------------------------------------------------------------------- */
+  if (hDS == NULL) {
+    char szPath[MS_MAXPATHLEN] = "";
+    const char *pszDSSelectedName = pszDSName;
+
+    if (layer->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("msOGRFileOpen(%s)...\n", connection);
+    }
+
+    CPLErrorReset();
+    if (msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                        pszDSName) != NULL ||
+        msTryBuildPath(szPath, layer->map->mappath, pszDSName) != NULL) {
+      /* Use relative path */
+      pszDSSelectedName = szPath;
+    }
+
+    if (layer->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("GDALOpenEx(%s)\n", pszDSSelectedName);
+    }
+
+    ACQUIRE_OGR_LOCK;
+    char **connectionoptions =
+        msGetStringListFromHashTable(&(layer->connectionoptions));
+    hDS = (OGRDataSourceH)GDALOpenEx(pszDSSelectedName, GDAL_OF_VECTOR, NULL,
+                                     (const char *const *)connectionoptions,
+                                     NULL);
+    CSLDestroy(connectionoptions);
+    RELEASE_OGR_LOCK;
+
+    if (hDS == NULL) {
+      msSetError(MS_OGRERR,
+                 "Open failed for OGR connection in layer `%s'.  "
+                 "File not found or unsupported format. Check server logs.",
+                 "msOGRFileOpen()", layer->name ? layer->name : "(null)");
+      if (strlen(CPLGetLastErrorMsg()) == 0)
+        msDebug("Open failed for OGR connection in layer `%s'.\n%s\n",
+                layer->name ? layer->name : "(null)", CPLGetLastErrorMsg());
+      CPLFree(pszDSName);
+      CPLFree(pszLayerDef);
+      return NULL;
+    }
+
+    msConnPoolRegister(layer, hDS, msOGRCloseConnection);
+  }
+
+  CPLFree(pszDSName);
+  pszDSName = NULL;
+
+  /* ------------------------------------------------------------------
+   * Find the layer selected.
+   * ------------------------------------------------------------------ */
+
+  int nLayerIndex = 0;
+  OGRLayerH hLayer = NULL;
+
+  int iLayer;
+
+  if (EQUALN(pszLayerDef, "SELECT ", 7)) {
+    ACQUIRE_OGR_LOCK;
+    hLayer = OGR_DS_ExecuteSQL(hDS, pszLayerDef, NULL, NULL);
+    if (hLayer == NULL) {
+      msSetError(MS_OGRERR, "ExecuteSQL() failed. Check server logs.",
+                 "msOGRFileOpen()");
+      if (strlen(CPLGetLastErrorMsg()) == 0)
+        msDebug("ExecuteSQL(%s) failed.\n%s\n", pszLayerDef,
+                CPLGetLastErrorMsg());
+      RELEASE_OGR_LOCK;
+      msConnPoolRelease(layer, hDS);
+      CPLFree(pszLayerDef);
+      return NULL;
+    }
+    RELEASE_OGR_LOCK;
+    nLayerIndex = -1;
+  }
+
+  for (iLayer = 0; hLayer == NULL && iLayer < OGR_DS_GetLayerCount(hDS);
+       iLayer++) {
+    hLayer = OGR_DS_GetLayer(hDS, iLayer);
+    if (hLayer != NULL && EQUAL(OGR_L_GetName(hLayer), pszLayerDef)) {
+      nLayerIndex = iLayer;
+      break;
+    } else
+      hLayer = NULL;
+  }
+
+  if (hLayer == NULL && (atoi(pszLayerDef) > 0 || EQUAL(pszLayerDef, "0"))) {
+    nLayerIndex = atoi(pszLayerDef);
+    if (nLayerIndex < OGR_DS_GetLayerCount(hDS))
+      hLayer = OGR_DS_GetLayer(hDS, nLayerIndex);
+  }
+
+  if (hLayer == NULL) {
+    msSetError(MS_OGRERR, "GetLayer(%s) failed for OGR connection. Check logs.",
+               "msOGRFileOpen()", pszLayerDef);
+    msDebug("GetLayer(%s) failed for OGR connection `%s'.\n", pszLayerDef,
+            connection);
+    CPLFree(pszLayerDef);
+    msConnPoolRelease(layer, hDS);
+    return NULL;
+  }
+
+  /* ------------------------------------------------------------------
+   * OK... open succeded... alloc and fill msOGRFileInfo inside layer obj
+   * ------------------------------------------------------------------ */
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)CPLCalloc(1, sizeof(msOGRFileInfo));
+
+  psInfo->pszFname = CPLStrdup(OGR_DS_GetName(hDS));
+  psInfo->pszLayerDef = pszLayerDef;
+  psInfo->nLayerIndex = nLayerIndex;
+  psInfo->hDS = hDS;
+  psInfo->hLayer = hLayer;
+
+  psInfo->nTileId = 0;
+  msInitProjection(&(psInfo->sTileProj));
+  msProjectionInheritContextFrom(&(psInfo->sTileProj), &(layer->projection));
+  psInfo->poCurTile = NULL;
+  psInfo->rect_is_defined = false;
+  psInfo->rect.minx = psInfo->rect.maxx = 0;
+  psInfo->rect.miny = psInfo->rect.maxy = 0;
+  psInfo->last_record_index_read = -1;
+  psInfo->dialect = NULL;
+
+  psInfo->pszSelect = NULL;
+  psInfo->pszSpatialFilterTableName = NULL;
+  psInfo->pszSpatialFilterGeometryColumn = NULL;
+  psInfo->pszMainTableName = NULL;
+  psInfo->pszRowId = NULL;
+  psInfo->bIsOKForSQLCompose = true;
+  psInfo->bPaging = false;
+  psInfo->bHasSpatialIndex = false;
+  psInfo->pszTablePrefix = NULL;
+  psInfo->pszWHERE = NULL;
+
+  // GDAL 1.x API
+  OGRSFDriverH dr = OGR_DS_GetDriver(hDS);
+  const char *name = OGR_Dr_GetName(dr);
+  if (strcmp(name, "SQLite") == 0) {
+    bool have_spatialite = false;
+
+    CPLPushErrorHandler(CPLQuietErrorHandler);
+
+    // test for Spatialite support in driver
+    const char *test_spatialite = "SELECT spatialite_version()";
+    OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_spatialite, NULL, NULL);
+    if (l) {
+      OGR_DS_ReleaseResultSet(hDS, l);
+      have_spatialite = true;
+    }
+
+    // test for Spatialite enabled db
+    if (have_spatialite) {
+      have_spatialite = false;
+      const char *test_sql =
+          "select 1 from sqlite_master where name = 'geometry_columns' and sql "
+          "LIKE '%spatial_index_enabled%'";
+      OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_sql, NULL, NULL);
+      if (l) {
+        if (OGR_L_GetFeatureCount(l, TRUE) == 1)
+          have_spatialite = true;
+        OGR_DS_ReleaseResultSet(hDS, l);
+      }
+    }
+
+    CPLPopErrorHandler();
+    CPLErrorReset();
+
+    if (have_spatialite)
+      psInfo->dialect = "Spatialite";
+    else {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug(
+            "msOGRFileOpen: Native SQL not available, no Spatialite support "
+            "and/or not a Spatialite enabled db\n");
+      }
+    }
+  } else if (strcmp(name, "PostgreSQL") == 0) {
+    psInfo->dialect = "PostgreSQL";
+    // todo: PostgreSQL not yet tested
+
+  } else if (strcmp(name, "GPKG") == 0 && nLayerIndex >= 0 &&
+             atoi(GDALVersionInfo("VERSION_NUM")) >= 2000000) {
+
+    bool has_rtree = false;
+    const char *test_rtree =
+        CPLSPrintf("SELECT 1 FROM sqlite_master WHERE name = 'rtree_%s_%s'",
+                   OGR_L_GetName(hLayer), OGR_L_GetGeometryColumn(hLayer));
+    OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_rtree, NULL, NULL);
+    if (l) {
+      if (OGR_L_GetFeatureCount(l, TRUE) == 1) {
+        has_rtree = true;
+      }
+      OGR_DS_ReleaseResultSet(hDS, l);
+    }
+    if (has_rtree) {
+      bool have_gpkg_spatialite = false;
+
+      CPLPushErrorHandler(CPLQuietErrorHandler);
+
+      // test for Spatialite >= 4.3 support in driver
+      const char *test_spatialite = "SELECT spatialite_version()";
+      l = OGR_DS_ExecuteSQL(hDS, test_spatialite, NULL, NULL);
+      if (l) {
+        OGRFeatureH hFeat = OGR_L_GetNextFeature(l);
+        if (hFeat) {
+          const char *pszVersion = OGR_F_GetFieldAsString(hFeat, 0);
+          have_gpkg_spatialite = atof(pszVersion) >= 4.3;
+          OGR_F_Destroy(hFeat);
+        }
+        OGR_DS_ReleaseResultSet(hDS, l);
+      }
+      CPLPopErrorHandler();
+      CPLErrorReset();
+
+      if (have_gpkg_spatialite) {
+        psInfo->pszMainTableName = msStrdup(OGR_L_GetName(hLayer));
+        psInfo->pszTablePrefix = msStrdup(psInfo->pszMainTableName);
+        psInfo->pszSpatialFilterTableName = msStrdup(OGR_L_GetName(hLayer));
+        psInfo->pszSpatialFilterGeometryColumn =
+            msStrdup(OGR_L_GetGeometryColumn(hLayer));
+        psInfo->dialect = "GPKG";
+        psInfo->bPaging = true;
+        psInfo->bHasSpatialIndex = true;
+      } else if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("msOGRFileOpen: Spatialite support in GPKG not enabled\n");
+      }
+    } else {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("msOGRFileOpen: RTree index not available\n");
+      }
+    }
+  }
+
+  if (psInfo->dialect != NULL && EQUAL(psInfo->dialect, "Spatialite"))
+    msOGRFileOpenSpatialite(layer, pszLayerDef, psInfo);
+
+  return psInfo;
+}
+
+/************************************************************************/
+/*                      msOGRFileOpenSpatialite()                       */
+/************************************************************************/
+
+static void msOGRFileOpenSpatialite(layerObj *layer, const char *pszLayerDef,
+                                    msOGRFileInfo *psInfo) {
+  // In the case of a SQLite DB, check that we can identify the
+  // underlying table
+  if (psInfo->nLayerIndex == -1) {
+    psInfo->bIsOKForSQLCompose = false;
+
+    const char *from = strstr(psInfo->pszLayerDef, " from ");
+    if (from == NULL)
+      from = strstr(psInfo->pszLayerDef, " FROM ");
+    if (from) {
+      const char *pszBeginningOfTable = from + strlen(" FROM ");
+      const char *pszIter = pszBeginningOfTable;
+      while (*pszIter && *pszIter != ' ')
+        pszIter++;
+      if (strchr(pszIter, ',') == NULL && strstr(pszIter, " where ") == NULL &&
+          strstr(pszIter, " WHERE ") == NULL &&
+          strstr(pszIter, " join ") == NULL &&
+          strstr(pszIter, " JOIN ") == NULL &&
+          strstr(pszIter, " order by ") == NULL &&
+          strstr(pszIter, " ORDER BY ") == NULL) {
+        psInfo->bIsOKForSQLCompose = true;
+        psInfo->pszMainTableName = msStrdup(pszBeginningOfTable);
+        psInfo->pszMainTableName[pszIter - pszBeginningOfTable] = '\0';
+        psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
+        psInfo->pszSpatialFilterGeometryColumn =
+            msStrdup(OGR_L_GetGeometryColumn(psInfo->hLayer));
+
+        char *pszRequest = NULL;
+        pszRequest = msStringConcatenate(pszRequest,
+                                         "SELECT name FROM sqlite_master WHERE "
+                                         "type = 'table' AND name = lower('");
+        pszRequest = msStringConcatenate(pszRequest, psInfo->pszMainTableName);
+        pszRequest = msStringConcatenate(pszRequest, "')");
+        OGRLayerH hLayer =
+            OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+        msFree(pszRequest);
+
+        if (hLayer) {
+          OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+          psInfo->bIsOKForSQLCompose = (hFeature != NULL);
+          if (hFeature) {
+            msFree(psInfo->pszMainTableName);
+            msFree(psInfo->pszSpatialFilterTableName);
+            psInfo->pszMainTableName =
+                msStrdup(OGR_F_GetFieldAsString(hFeature, 0));
+            psInfo->pszSpatialFilterTableName =
+                msStrdup(psInfo->pszMainTableName);
+            OGR_F_Destroy(hFeature);
+          }
+          OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+        }
+        if (psInfo->bIsOKForSQLCompose) {
+          psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
+        } else {
+          // Test if it is a spatial view
+          pszRequest = msStringConcatenate(
+              NULL, "SELECT f_table_name, f_geometry_column, view_rowid FROM "
+                    "views_geometry_columns WHERE view_name = lower('");
+          pszRequest =
+              msStringConcatenate(pszRequest, psInfo->pszMainTableName);
+          pszRequest = msStringConcatenate(pszRequest, "')");
+          CPLPushErrorHandler(CPLQuietErrorHandler);
+          OGRLayerH hLayer =
+              OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+          CPLPopErrorHandler();
+          msFree(pszRequest);
+
+          if (hLayer) {
+            OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+            psInfo->bIsOKForSQLCompose = (hFeature != NULL);
+            if (hFeature) {
+              psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
+              msFree(psInfo->pszSpatialFilterTableName);
+              psInfo->pszSpatialFilterTableName =
+                  msStrdup(OGR_F_GetFieldAsString(hFeature, 0));
+              CPLFree(psInfo->pszSpatialFilterGeometryColumn);
+              psInfo->pszSpatialFilterGeometryColumn =
+                  msStrdup(OGR_F_GetFieldAsString(hFeature, 1));
+              psInfo->pszRowId = msStrdup(OGR_F_GetFieldAsString(hFeature, 2));
+              OGR_F_Destroy(hFeature);
+            }
+            OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+          }
+        }
+      }
+    }
+  } else {
+    psInfo->bIsOKForSQLCompose = false;
+
+    char *pszRequest = NULL;
+    pszRequest = msStringConcatenate(
+        pszRequest,
+        "SELECT * FROM sqlite_master WHERE type = 'table' AND name = lower('");
+    pszRequest = msStringConcatenate(
+        pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+    pszRequest = msStringConcatenate(pszRequest, "')");
+    OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+    msFree(pszRequest);
+
+    if (hLayer) {
+      OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+      psInfo->bIsOKForSQLCompose = (hFeature != NULL);
+      if (hFeature)
+        OGR_F_Destroy(hFeature);
+      OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+    }
+    if (psInfo->bIsOKForSQLCompose) {
+      psInfo->pszMainTableName =
+          msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+      psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
+      psInfo->pszSpatialFilterGeometryColumn =
+          msStrdup(OGR_L_GetGeometryColumn(psInfo->hLayer));
+    } else {
+      // Test if it is a spatial view
+      pszRequest = msStringConcatenate(
+          NULL, "SELECT f_table_name, f_geometry_column, view_rowid FROM "
+                "views_geometry_columns WHERE view_name = lower('");
+      pszRequest = msStringConcatenate(
+          pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+      pszRequest = msStringConcatenate(pszRequest, "')");
+      CPLPushErrorHandler(CPLQuietErrorHandler);
+      OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+      CPLPopErrorHandler();
+      msFree(pszRequest);
+
+      if (hLayer) {
+        OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+        psInfo->bIsOKForSQLCompose = (hFeature != NULL);
+        if (hFeature) {
+          psInfo->pszMainTableName =
+              msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+          psInfo->pszSpatialFilterTableName =
+              msStrdup(OGR_F_GetFieldAsString(hFeature, 0));
+          psInfo->pszSpatialFilterGeometryColumn =
+              msStrdup(OGR_F_GetFieldAsString(hFeature, 1));
+          psInfo->pszRowId = msStrdup(OGR_F_GetFieldAsString(hFeature, 2));
+          OGR_F_Destroy(hFeature);
+        }
+        OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+      }
+    }
+  }
+
+  // in the case we cannot handle the native string, go back to the client
+  // side evaluation by unsetting it.
+  if (!psInfo->bIsOKForSQLCompose && psInfo->dialect != NULL) {
+    if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+      msDebug("msOGRFileOpen(): Falling back to MapServer only evaluation\n");
+    }
+    psInfo->dialect = NULL;
+  }
+
+  // Check if spatial index has been disabled (testing purposes)
+  if (msLayerGetProcessingKey(layer, "USE_SPATIAL_INDEX") != NULL &&
+      !CSLTestBoolean(msLayerGetProcessingKey(layer, "USE_SPATIAL_INDEX"))) {
+    if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+      msDebug("msOGRFileOpen(): Layer %s has spatial index disabled by "
+              "processing option\n",
+              pszLayerDef);
+    }
+  }
+  // Test if spatial index is available
+  else if (psInfo->dialect != NULL) {
+    char *pszRequest = NULL;
+    pszRequest = msStringConcatenate(
+        pszRequest,
+        "SELECT * FROM sqlite_master WHERE type = 'table' AND name = 'idx_");
+    pszRequest =
+        msStringConcatenate(pszRequest, psInfo->pszSpatialFilterTableName);
+    pszRequest = msStringConcatenate(pszRequest, "_");
+    pszRequest = msStringConcatenate(pszRequest,
+                                     OGR_L_GetGeometryColumn(psInfo->hLayer));
+    pszRequest = msStringConcatenate(pszRequest, "'");
+
+    psInfo->bHasSpatialIndex = false;
+    // msDebug("msOGRFileOpen(): %s", pszRequest);
+
+    OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+    if (hLayer) {
+      OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+      if (hFeature) {
+        psInfo->bHasSpatialIndex = true;
+        OGR_F_Destroy(hFeature);
+      }
+      OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+    }
+    msFree(pszRequest);
+    pszRequest = NULL;
+
+    if (!psInfo->bHasSpatialIndex) {
+      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+        msDebug("msOGRFileOpen(): Layer %s has no spatial index table\n",
+                pszLayerDef);
+      }
+    } else {
+      pszRequest = msStringConcatenate(
+          pszRequest,
+          "SELECT * FROM geometry_columns WHERE f_table_name = lower('");
+      pszRequest =
+          msStringConcatenate(pszRequest, psInfo->pszSpatialFilterTableName);
+      pszRequest =
+          msStringConcatenate(pszRequest, "') AND f_geometry_column = lower('");
+      pszRequest = msStringConcatenate(pszRequest,
+                                       psInfo->pszSpatialFilterGeometryColumn);
+      pszRequest =
+          msStringConcatenate(pszRequest, "') AND spatial_index_enabled = 1");
+
+      psInfo->bHasSpatialIndex = false;
+
+      OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+      if (hLayer) {
+        OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+        if (hFeature) {
+          psInfo->bHasSpatialIndex = true;
+          OGR_F_Destroy(hFeature);
+        }
+        OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+      }
+      msFree(pszRequest);
+      pszRequest = NULL;
+
+      if (!psInfo->bHasSpatialIndex) {
+        if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("msOGRFileOpen(): Layer %s has spatial index disabled\n",
+                  pszLayerDef);
+        }
+      } else {
+        if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("msOGRFileOpen(): Layer %s has spatial index enabled\n",
+                  pszLayerDef);
+        }
+
+        psInfo->pszTablePrefix = msStrdup(psInfo->pszMainTableName);
+      }
+    }
+  }
+
+  psInfo->bPaging = (psInfo->dialect != NULL);
+}
+
+/************************************************************************/
+/*                        msOGRCloseConnection()                        */
+/*                                                                      */
+/*      Callback for thread pool to actually release an OGR             */
+/*      connection.                                                     */
+/************************************************************************/
+
+static void msOGRCloseConnection(void *conn_handle)
+
+{
+  OGRDataSourceH hDS = (OGRDataSourceH)conn_handle;
+
+  ACQUIRE_OGR_LOCK;
+  OGR_DS_Destroy(hDS);
+  RELEASE_OGR_LOCK;
+}
+
+/**********************************************************************
+ *                     msOGRFileClose()
+ **********************************************************************/
+static int msOGRFileClose(layerObj *layer, msOGRFileInfo *psInfo) {
+  if (!psInfo)
+    return MS_SUCCESS;
+
+  if (layer->debug)
+    msDebug("msOGRFileClose(%s,%d).\n", psInfo->pszFname, psInfo->nLayerIndex);
+
+  CPLFree(psInfo->pszFname);
+  CPLFree(psInfo->pszLayerDef);
+
+  ACQUIRE_OGR_LOCK;
+  if (psInfo->hLastFeature)
+    OGR_F_Destroy(psInfo->hLastFeature);
+
+  /* If nLayerIndex == -1 then the layer is an SQL result ... free it */
+  if (psInfo->nLayerIndex == -1)
+    OGR_DS_ReleaseResultSet(psInfo->hDS, psInfo->hLayer);
+
+  // Release (potentially close) the datasource connection.
+  // Make sure we aren't holding the lock when the callback may need it.
+  RELEASE_OGR_LOCK;
+  msConnPoolRelease(layer, psInfo->hDS);
+
+  // Free current tile if there is one.
+  if (psInfo->poCurTile != NULL)
+    msOGRFileClose(layer, psInfo->poCurTile);
+
+  msFreeProjection(&(psInfo->sTileProj));
+  msFree(psInfo->pszSelect);
+  msFree(psInfo->pszSpatialFilterTableName);
+  msFree(psInfo->pszSpatialFilterGeometryColumn);
+  msFree(psInfo->pszMainTableName);
+  msFree(psInfo->pszRowId);
+  msFree(psInfo->pszTablePrefix);
+  msFree(psInfo->pszWHERE);
+
+  CPLFree(psInfo);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                           msOGREscapeSQLParam                        */
+/************************************************************************/
+static char *msOGREscapeSQLParam(layerObj *layer, const char *pszString) {
+  char *pszEscapedStr = NULL;
+  if (layer && pszString) {
+    char *pszEscapedOGRStr =
+        CPLEscapeString(pszString, strlen(pszString), CPLES_SQL);
+    pszEscapedStr = msStrdup(pszEscapedOGRStr);
+    CPLFree(pszEscapedOGRStr);
+  }
+  return pszEscapedStr;
+}
+
+// http://www.sqlite.org/lang_expr.html
+// http://www.gaia-gis.it/gaia-sins/spatialite-sql-4.3.0.html
+
+static char *msOGRGetQuotedItem(layerObj *layer, const char *pszItem) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  char *ret = NULL;
+  char *escapedItem = msLayerEscapePropertyName(layer, pszItem);
+  if (psInfo->pszTablePrefix) {
+    char *escapedTable =
+        msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
+    ret = msStringConcatenate(ret, "\"");
+    ret = msStringConcatenate(ret, escapedTable);
+    ret = msStringConcatenate(ret, "\".\"");
+    ret = msStringConcatenate(ret, escapedItem);
+    ret = msStringConcatenate(ret, "\"");
+    msFree(escapedTable);
+  } else {
+    ret = msStringConcatenate(ret, "\"");
+    ret = msStringConcatenate(ret, escapedItem);
+    ret = msStringConcatenate(ret, "\"");
+  }
+  msFree(escapedItem);
+  return ret;
+}
+
+static char *msOGRGetToken(layerObj *layer, tokenListNodeObjPtr *node) {
+  msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
+  tokenListNodeObjPtr n = *node;
+  if (!n)
+    return NULL;
+  char *out = NULL;
+  size_t nOutSize;
+
+  switch (n->token) {
+  case MS_TOKEN_LOGICAL_AND:
+    out = msStrdup(" AND ");
+    break;
+  case MS_TOKEN_LOGICAL_OR:
+    out = msStrdup(" OR ");
+    break;
+  case MS_TOKEN_LOGICAL_NOT:
+    out = msStrdup(" NOT ");
+    break;
+  case MS_TOKEN_LITERAL_NUMBER:
+    nOutSize = 32;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "%.18g", n->tokenval.dblval);
+    break;
+  case MS_TOKEN_LITERAL_STRING: {
+    char *stresc = msOGREscapeSQLParam(layer, n->tokenval.strval);
+    nOutSize = strlen(stresc) + 3;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "'%s'", stresc);
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_LITERAL_TIME:
+    // seems to require METADATA gml_types => auto
+    nOutSize = 80;
+    out = (char *)msSmallMalloc(nOutSize);
+#if 0
+        // FIXME? or perhaps just remove me. tm_zone is not supported on Windows, and not used anywhere else in the code base
+        if (n->tokenval.tmval.tm_zone)
+            snprintf(out, nOutSize, "'%d-%02d-%02dT%02d:%02d:%02d%s'",
+                     n->tokenval.tmval.tm_year+1900, n->tokenval.tmval.tm_mon+1, n->tokenval.tmval.tm_mday,
+                     n->tokenval.tmval.tm_hour, n->tokenval.tmval.tm_min, n->tokenval.tmval.tm_sec,
+                     n->tokenval.tmval.tm_zone);
+        else
+#endif
+    snprintf(out, nOutSize, "'%d-%02d-%02dT%02d:%02d:%02d'",
+             n->tokenval.tmval.tm_year + 1900, n->tokenval.tmval.tm_mon + 1,
+             n->tokenval.tmval.tm_mday, n->tokenval.tmval.tm_hour,
+             n->tokenval.tmval.tm_min, n->tokenval.tmval.tm_sec);
+    break;
+  case MS_TOKEN_LITERAL_SHAPE: {
+    // assumed to be in right srs after FLTGetSpatialComparisonCommonExpression
+    char *wkt = msShapeToWKT(n->tokenval.shpval);
+    char *stresc = msOGRGetQuotedItem(
+        layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
+    nOutSize = strlen(wkt) + strlen(stresc) + 35;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "ST_GeomFromText('%s',ST_SRID(%s))", wkt, stresc);
+    msFree(wkt);
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_LITERAL_BOOLEAN:
+    out = msStrdup(n->tokenval.dblval == 0 ? "FALSE" : "TRUE");
+    break;
+  case MS_TOKEN_COMPARISON_EQ:
+    if (n->next != NULL && n->next->token == MS_TOKEN_LITERAL_STRING &&
+        strcmp(n->next->tokenval.strval, "_MAPSERVER_NULL_") == 0) {
+      out = msStrdup(" IS NULL");
+      n = n->next;
+      break;
+    }
+
+    out = msStrdup(" = ");
+    break;
+  case MS_TOKEN_COMPARISON_NE:
+    out = msStrdup(" != ");
+    break;
+  case MS_TOKEN_COMPARISON_GT:
+    out = msStrdup(" > ");
+    break;
+  case MS_TOKEN_COMPARISON_LT:
+    out = msStrdup(" < ");
+    break;
+  case MS_TOKEN_COMPARISON_LE:
+    out = msStrdup(" <= ");
+    break;
+  case MS_TOKEN_COMPARISON_GE:
+    out = msStrdup(" >= ");
+    break;
+  case MS_TOKEN_COMPARISON_IEQ:
+    out = msStrdup(" = ");
+    break;
+  case MS_TOKEN_COMPARISON_IN:
+    out = msStrdup(" IN ");
+    break;
+  // the origin may be mapfile (complex regexes, layer->map.query.filter.string
+  // == NULL, regex may have //) or OGC Filter (simple patterns only,
+  // layer->map.query.filter.string != NULL)
+  case MS_TOKEN_COMPARISON_RE:
+  case MS_TOKEN_COMPARISON_IRE: {
+    int case_sensitive = n->token == MS_TOKEN_COMPARISON_RE;
+    // in PostgreSQL and OGR: LIKE (case sensitive) and ILIKE (case insensitive)
+    // in SQLite: LIKE (case insensitive) and GLOB (case sensitive)
+    const char *op = case_sensitive ? "LIKE" : "ILIKE";
+    char wild_any = '%';
+    char wild_one = '_';
+
+    if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG")) {
+      if (case_sensitive) {
+        op = "GLOB";
+        wild_any = '*';
+        wild_one = '?';
+      } else {
+        op = "LIKE";
+      }
+    }
+
+    n = n->next;
+    if (n->token != MS_TOKEN_LITERAL_STRING)
+      return NULL;
+
+    char *regex = msStrdup(n->tokenval.strval);
+    int complex_regex = *n->tokenval.strval ==
+                        '/'; // could be non-complex but that is soo corner case
+
+    // PostgreSQL has POSIX regexes, SQLite does not by default, OGR does not
+    if (complex_regex) {
+      if (!EQUAL(info->dialect, "PostgreSQL")) {
+        msFree(regex);
+        return NULL;
+      }
+      // remove //
+      regex++;
+      regex[strlen(regex) - 1] = '\0';
+      if (case_sensitive)
+        op = "~";
+      else
+        op = "~*";
+    }
+
+    const size_t regex_len = strlen(regex);
+    char *re = (char *)msSmallMalloc(2 * regex_len + 3);
+    size_t i = 0, j = 0;
+    re[j++] = '\'';
+    while (i < regex_len) {
+      char c = regex[i];
+      char c_next = regex[i + 1];
+
+      if (c == '.' && c_next == '*') {
+        i++;
+        c = wild_any;
+      } else if (c == '.')
+        c = wild_one;
+      else if (i == 0 && c == '^') {
+        i++;
+        continue;
+      } else if (c == '$' && c_next == 0) {
+        break;
+      } else if (c == '\'') {
+        re[j++] = '\'';
+      } else if (c == '\\') {
+        if (c_next == 0) {
+          break;
+        }
+        i++;
+        c = c_next;
+      }
+
+      re[j++] = c;
+      i++;
+    }
+    re[j++] = '\'';
+    re[j] = '\0';
+
+    nOutSize = 1 + strlen(op) + 1 + strlen(re) + 1;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, " %s %s", op, re);
+    msFree(re);
+    msFree(regex);
+    break;
+  }
+  case MS_TOKEN_COMPARISON_INTERSECTS:
+    out = msStrdup("ST_Intersects");
+    break;
+  case MS_TOKEN_COMPARISON_DISJOINT:
+    out = msStrdup("ST_Disjoint");
+    break;
+  case MS_TOKEN_COMPARISON_TOUCHES:
+    out = msStrdup("ST_Touches");
+    break;
+  case MS_TOKEN_COMPARISON_OVERLAPS:
+    out = msStrdup("ST_Overlaps");
+    break;
+  case MS_TOKEN_COMPARISON_CROSSES:
+    out = msStrdup("ST_Crosses");
+    break;
+  case MS_TOKEN_COMPARISON_WITHIN:
+    out = msStrdup("ST_Within");
+    break;
+  case MS_TOKEN_COMPARISON_DWITHIN:
+    out = msStrdup("ST_Distance");
+    break;
+  case MS_TOKEN_COMPARISON_BEYOND:
+    out = msStrdup("ST_Distance");
+    break;
+  case MS_TOKEN_COMPARISON_CONTAINS:
+    out = msStrdup("ST_Contains");
+    break;
+  case MS_TOKEN_COMPARISON_EQUALS:
+    out = msStrdup("ST_Equals");
+    break;
+  case MS_TOKEN_FUNCTION_LENGTH:
+    out = msStrdup("ST_Length");
+    break;
+  case MS_TOKEN_FUNCTION_AREA:
+    out = msStrdup("ST_Area");
+    break;
+  case MS_TOKEN_BINDING_DOUBLE: {
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + +30;
+    out = (char *)msSmallMalloc(nOutSize);
+
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             n->tokenval.bindval.item);
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Do not cast if the variable is of the appropriate type as it can
+    // prevent using database indexes, such as for SQlite
+    if (type != NULL && (EQUAL(type, "Integer") || EQUAL(type, "Long") ||
+                         EQUAL(type, "Real"))) {
+      snprintf(out, nOutSize, "%s", stresc);
+    } else {
+      const char *SQLtype = "float(16)";
+      if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG"))
+        SQLtype = "REAL";
+      else if (EQUAL(info->dialect, "PostgreSQL"))
+        SQLtype = "double precision";
+      snprintf(out, nOutSize, "CAST(%s AS %s)", stresc, SQLtype);
+    }
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_INTEGER: {
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + 20;
+    out = (char *)msSmallMalloc(nOutSize);
+
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             n->tokenval.bindval.item);
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Do not cast if the variable is of the appropriate type as it can
+    // prevent using database indexes, such as for SQlite
+    if (type != NULL && (EQUAL(type, "Integer") || EQUAL(type, "Long") ||
+                         EQUAL(type, "Real"))) {
+      snprintf(out, nOutSize, "%s", stresc);
+    } else {
+      snprintf(out, nOutSize, "CAST(%s AS integer)", stresc);
+    }
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_STRING: {
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + 30;
+    out = (char *)msSmallMalloc(nOutSize);
+
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             n->tokenval.bindval.item);
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Do not cast if the variable is of the appropriate type as it can
+    // prevent using database indexes, such as for SQlite
+    if (type != NULL && EQUAL(type, "Character")) {
+      snprintf(out, nOutSize, "%s", stresc);
+    } else {
+      snprintf(out, nOutSize, "CAST(%s AS text)", stresc);
+    }
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_TIME: {
+    // won't get here unless col is parsed as time and they are not
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + 10;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "%s", stresc);
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_SHAPE: {
+    char *stresc = msOGRGetQuotedItem(
+        layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
+    nOutSize = strlen(stresc) + 10;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "%s", stresc);
+    msFree(stresc);
+    break;
+  }
+
+    // unhandled below until default
+
+  case MS_TOKEN_FUNCTION_TOSTRING:
+  case MS_TOKEN_FUNCTION_COMMIFY:
+  case MS_TOKEN_FUNCTION_ROUND:
+  case MS_TOKEN_FUNCTION_FROMTEXT:
+  case MS_TOKEN_FUNCTION_BUFFER:
+  case MS_TOKEN_FUNCTION_DIFFERENCE:
+  case MS_TOKEN_FUNCTION_SIMPLIFY:
+  case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+  case MS_TOKEN_FUNCTION_GENERALIZE:
+  case MS_TOKEN_FUNCTION_SMOOTHSIA:
+  case MS_TOKEN_FUNCTION_JAVASCRIPT:
+  case MS_TOKEN_FUNCTION_UPPER:
+  case MS_TOKEN_FUNCTION_LOWER:
+  case MS_TOKEN_FUNCTION_INITCAP:
+  case MS_TOKEN_FUNCTION_FIRSTCAP:
+  case MS_TOKEN_BINDING_MAP_CELLSIZE:
+  case MS_TOKEN_BINDING_DATA_CELLSIZE:
+  case MS_PARSE_TYPE_BOOLEAN:
+  case MS_PARSE_TYPE_STRING:
+  case MS_PARSE_TYPE_SHAPE:
+    break;
+
+  default:
+    if (n->token < 128) {
+      char c = n->token;
+      out = (char *)msSmallMalloc(2);
+      sprintf(out, "%c", c);
+    }
+    break;
+  }
+
+  n = n->next;
+  *node = n;
+  return out;
+}
+
+/*
+ * msOGRLayerBuildSQLOrderBy()
+ *
+ * Returns the content of a SQL ORDER BY clause from the sortBy member of
+ * the layer. The string does not contain the "ORDER BY" keywords itself.
+ */
+static char *msOGRLayerBuildSQLOrderBy(layerObj *layer, msOGRFileInfo *psInfo) {
+  char *strOrderBy = NULL;
+  if (layer->sortBy.nProperties > 0) {
+    int i;
+    for (i = 0; i < layer->sortBy.nProperties; i++) {
+      if (i > 0)
+        strOrderBy = msStringConcatenate(strOrderBy, ", ");
+      char *escapedItem =
+          msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
+      if (psInfo->pszTablePrefix) {
+        char *escapedTable =
+            msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
+        strOrderBy = msStringConcatenate(strOrderBy, escapedTable);
+        strOrderBy = msStringConcatenate(strOrderBy, "\".\"");
+        strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
+        msFree(escapedTable);
+      } else {
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
+        strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
+      }
+      msFree(escapedItem);
+      if (layer->sortBy.properties[i].sortOrder == SORT_DESC)
+        strOrderBy = msStringConcatenate(strOrderBy, " DESC");
+    }
+  }
+  return strOrderBy;
+}
+
+/**********************************************************************
+ *                     msOGRFileWhichShapes()
+ *
+ * Init OGR layer structs ready for calls to msOGRFileNextShape().
+ *
+ * Returns MS_SUCCESS/MS_FAILURE, or MS_DONE if no shape matching the
+ * layer's FILTER overlaps the selected region.
+ **********************************************************************/
+static int msOGRFileWhichShapes(layerObj *layer, rectObj rect,
+                                msOGRFileInfo *psInfo) {
+  // rect is from BBOX parameter in query (In lieu of a FEATUREID or FILTER) or
+  // mapfile somehow
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRFileWhichShapes()");
+    return (MS_FAILURE);
+  }
+
+  char *select = (psInfo->pszSelect) ? msStrdup(psInfo->pszSelect) : NULL;
+  const rectObj rectInvalid = MS_INIT_INVALID_RECT;
+  bool bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
+
+  // we'll go strictly two possible ways:
+  // 1) GetLayer + SetFilter
+  // 2) ExecuteSQL (psInfo->hLayer is an SQL result OR sortBy was requested OR
+  // have native_string and start from the second
+
+  if (psInfo->bIsOKForSQLCompose &&
+      (psInfo->nLayerIndex == -1 || layer->sortBy.nProperties > 0 ||
+       layer->filter.native_string ||
+       (psInfo->bPaging && layer->maxfeatures > 0))) {
+
+    const bool bHasGeometry = OGR_L_GetGeomType(psInfo->hLayer) != wkbNone;
+
+    if (psInfo->nLayerIndex == -1 && select == NULL) {
+      select = msStrdup(psInfo->pszLayerDef);
+      /* If nLayerIndex == -1 then the layer is an SQL result ... free it */
+      OGR_DS_ReleaseResultSet(psInfo->hDS, psInfo->hLayer);
+      psInfo->hLayer = NULL;
+    } else if (select == NULL) {
+      const char *pszGeometryColumn;
+      int i;
+      select = msStringConcatenate(select, "SELECT ");
+      for (i = 0; i < layer->numitems; i++) {
+        if (i > 0)
+          select = msStringConcatenate(select, ", ");
+        char *escaped = msOGRGetQuotedItem(layer, layer->items[i]);
+        select = msStringConcatenate(select, escaped);
+        msFree(escaped);
+        if (psInfo->pszTablePrefix) {
+          select = msStringConcatenate(select, " AS \"");
+          escaped = msLayerEscapePropertyName(layer, layer->items[i]);
+          select = msStringConcatenate(select, escaped);
+          msFree(escaped);
+          select = msStringConcatenate(select, "\"");
+        }
+      }
+      if (layer->numitems > 0)
+        select = msStringConcatenate(select, ", ");
+      pszGeometryColumn = OGR_L_GetGeometryColumn(psInfo->hLayer);
+      if (pszGeometryColumn != NULL && pszGeometryColumn[0] != '\0') {
+        char *escaped = msOGRGetQuotedItem(layer, pszGeometryColumn);
+        select = msStringConcatenate(select, escaped);
+        msFree(escaped);
+        if (psInfo->pszTablePrefix) {
+          select = msStringConcatenate(select, " AS \"");
+          escaped = msLayerEscapePropertyName(layer, pszGeometryColumn);
+          select = msStringConcatenate(select, escaped);
+          msFree(escaped);
+          select = msStringConcatenate(select, "\"");
+        }
+      } else {
+        /* Add ", *" so that we still have an hope to get the geometry */
+        if (psInfo->pszTablePrefix) {
+          select = msStringConcatenate(select, "\"");
+          char *escaped =
+              msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
+          select = msStringConcatenate(select, escaped);
+          msFree(escaped);
+          select = msStringConcatenate(select, "\".");
+        }
+        select = msStringConcatenate(select, "*");
+      }
+      select = msStringConcatenate(select, " FROM ");
+      if (psInfo->nLayerIndex == -1) {
+        select = msStringConcatenate(select, "(");
+        select = msStringConcatenate(select, psInfo->pszLayerDef);
+        select = msStringConcatenate(select, ") MSSUBSELECT");
+      } else {
+        select = msStringConcatenate(select, "\"");
+        char *escaped = msLayerEscapePropertyName(
+            layer, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+        select = msStringConcatenate(select, escaped);
+        msFree(escaped);
+        select = msStringConcatenate(select, "\"");
+      }
+    }
+
+    char *filter = NULL;
+    if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+      filter = msStringConcatenate(filter, "(");
+      filter = msStringConcatenate(
+          filter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
+      filter = msStringConcatenate(filter, ")");
+    }
+
+    /* ------------------------------------------------------------------
+     * Set Spatial filter... this may result in no features being returned
+     * if layer does not overlap current view.
+     *
+     * __TODO__ We should return MS_DONE if no shape overlaps the selected
+     * region and matches the layer's FILTER expression, but there is currently
+     * no _efficient_ way to do that with OGR.
+     * ------------------------------------------------------------------ */
+    if (psInfo->rect_is_defined) {
+      rect.minx = MAX(psInfo->rect.minx, rect.minx);
+      rect.miny = MAX(psInfo->rect.miny, rect.miny);
+      rect.maxx = MIN(psInfo->rect.maxx, rect.maxx);
+      rect.maxy = MIN(psInfo->rect.maxy, rect.maxy);
+      bIsValidRect = true;
+    }
+    psInfo->rect = rect;
+
+    bool bSpatialiteOrGPKGAddOrderByFID = false;
+
+    const char *sql = layer->filter.native_string;
+    if (psInfo->dialect && sql && *sql != '\0' &&
+        (EQUAL(psInfo->dialect, "Spatialite") ||
+         EQUAL(psInfo->dialect, "GPKG") ||
+         EQUAL(psInfo->dialect, "PostgreSQL"))) {
+      if (filter)
+        filter = msStringConcatenate(filter, " AND ");
+      filter = msStringConcatenate(filter, "(");
+      filter = msStringConcatenate(filter, sql);
+      filter = msStringConcatenate(filter, ")");
+    } else if (psInfo->pszWHERE) {
+      if (filter)
+        filter = msStringConcatenate(filter, " AND ");
+      filter = msStringConcatenate(filter, "(");
+      filter = msStringConcatenate(filter, psInfo->pszWHERE);
+      filter = msStringConcatenate(filter, ")");
+    }
+
+    // use spatial index
+    if (psInfo->dialect && bIsValidRect) {
+      if (EQUAL(psInfo->dialect, "PostgreSQL")) {
+        if (filter)
+          filter = msStringConcatenate(filter, " AND");
+        const char *col =
+            OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
+        filter = msStringConcatenate(filter, " (\"");
+        char *escaped = msLayerEscapePropertyName(layer, col);
+        filter = msStringConcatenate(filter, escaped);
+        msFree(escaped);
+        filter = msStringConcatenate(filter, "\" && ST_MakeEnvelope(");
+        char *points = (char *)msSmallMalloc(30 * 2 * 5);
+        snprintf(points, 30 * 4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny,
+                 rect.maxx, rect.maxy);
+        filter = msStringConcatenate(filter, points);
+        msFree(points);
+        filter = msStringConcatenate(filter, "))");
+      } else if (psInfo->dialect &&
+                 (EQUAL(psInfo->dialect, "Spatialite") ||
+                  EQUAL(psInfo->dialect, "GPKG")) &&
+                 psInfo->pszMainTableName != NULL) {
+        if ((EQUAL(psInfo->dialect, "Spatialite") &&
+             psInfo->bHasSpatialIndex) ||
+            EQUAL(psInfo->dialect, "GPKG")) {
+          if (filter)
+            filter = msStringConcatenate(filter, " AND ");
+          char *pszEscapedMainTableName =
+              msLayerEscapePropertyName(layer, psInfo->pszMainTableName);
+          filter = msStringConcatenate(filter, "\"");
+          filter = msStringConcatenate(filter, pszEscapedMainTableName);
+          msFree(pszEscapedMainTableName);
+          filter = msStringConcatenate(filter, "\".");
+          if (psInfo->pszRowId) {
+            char *pszEscapedRowId =
+                msLayerEscapePropertyName(layer, psInfo->pszRowId);
+            filter = msStringConcatenate(filter, "\"");
+            filter = msStringConcatenate(filter, pszEscapedRowId);
+            filter = msStringConcatenate(filter, "\"");
+            msFree(pszEscapedRowId);
+          } else
+            filter = msStringConcatenate(filter, "ROWID");
+
+          filter = msStringConcatenate(filter, " IN ");
+          filter = msStringConcatenate(filter, "(");
+          filter = msStringConcatenate(filter, "SELECT ");
+
+          if (EQUAL(psInfo->dialect, "Spatialite"))
+            filter = msStringConcatenate(filter, "ms_spat_idx.pkid");
+          else
+            filter = msStringConcatenate(filter, "ms_spat_idx.id");
+
+          filter = msStringConcatenate(filter, " FROM ");
+
+          char szSpatialIndexName[256];
+          snprintf(szSpatialIndexName, sizeof(szSpatialIndexName), "%s_%s_%s",
+                   EQUAL(psInfo->dialect, "Spatialite") ? "idx" : "rtree",
+                   psInfo->pszSpatialFilterTableName,
+                   psInfo->pszSpatialFilterGeometryColumn);
+          char *pszEscapedSpatialIndexName =
+              msLayerEscapePropertyName(layer, szSpatialIndexName);
+
+          filter = msStringConcatenate(filter, "\"");
+          filter = msStringConcatenate(filter, pszEscapedSpatialIndexName);
+          msFree(pszEscapedSpatialIndexName);
+
+          filter = msStringConcatenate(filter, "\" ms_spat_idx WHERE ");
+
+          char szCond[256];
+          if (EQUAL(psInfo->dialect, "Spatialite")) {
+            snprintf(
+                szCond, sizeof(szCond),
+                "ms_spat_idx.xmin <= %.15g AND ms_spat_idx.xmax >= %.15g AND "
+                "ms_spat_idx.ymin <= %.15g AND ms_spat_idx.ymax >= %.15g",
+                rect.maxx, rect.minx, rect.maxy, rect.miny);
+          } else {
+            snprintf(
+                szCond, sizeof(szCond),
+                "ms_spat_idx.minx <= %.15g AND ms_spat_idx.maxx >= %.15g AND "
+                "ms_spat_idx.miny <= %.15g AND ms_spat_idx.maxy >= %.15g",
+                rect.maxx, rect.minx, rect.maxy, rect.miny);
+          }
+          filter = msStringConcatenate(filter, szCond);
+
+          filter = msStringConcatenate(filter, ")");
+
+          bSpatialiteOrGPKGAddOrderByFID = true;
+        }
+
+        const bool isGPKG = EQUAL(psInfo->dialect, "GPKG");
+        if (filter)
+          filter = msStringConcatenate(filter, " AND");
+        const char *col =
+            OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
+        filter = msStringConcatenate(filter, " Intersects(");
+        if (isGPKG) {
+          // Casting GeoPackage geometries to spatialie ones is done
+          // automatically normally, since GDAL enables the
+          // "amphibious" mode, but without it
+          // explicilty specified, spatialite 4.3.0a does an
+          // out-of-bounds access.
+          filter = msStringConcatenate(filter, "GeomFromGPB(");
+        }
+        filter = msStringConcatenate(filter, "\"");
+        char *escaped = msLayerEscapePropertyName(layer, col);
+        filter = msStringConcatenate(filter, escaped);
+        msFree(escaped);
+        filter = msStringConcatenate(filter, "\"");
+        if (isGPKG)
+          filter = msStringConcatenate(filter, ")");
+        char *points = (char *)msSmallMalloc(30 * 2 * 5);
+        if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
+          filter = msStringConcatenate(filter, ",  ST_GeomFromText(");
+          snprintf(points, 30 * 4, "'POINT(%lf %lf)'", rect.minx, rect.miny);
+        } else {
+          filter = msStringConcatenate(filter, ", BuildMbr(");
+          snprintf(points, 30 * 4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny,
+                   rect.maxx, rect.maxy);
+        }
+        filter = msStringConcatenate(filter, points);
+        msFree(points);
+        filter = msStringConcatenate(filter, "))");
+      }
+    }
+
+    /* get sortBy */
+    char *sort = NULL;
+    if (layer->sortBy.nProperties > 0) {
+
+      char *strOrderBy = msOGRLayerBuildSQLOrderBy(layer, psInfo);
+      if (strOrderBy) {
+        if (psInfo->nLayerIndex == -1) {
+          if (strcasestr(psInfo->pszLayerDef, " ORDER BY ") == NULL)
+            sort = msStringConcatenate(sort, " ORDER BY ");
+          else
+            sort = msStringConcatenate(sort, ", ");
+        } else {
+          sort = msStringConcatenate(sort, " ORDER BY ");
+        }
+        sort = msStringConcatenate(sort, strOrderBy);
+        msFree(strOrderBy);
+      }
+    }
+
+    if (bSpatialiteOrGPKGAddOrderByFID) {
+      if (sort == NULL)
+        sort = msStringConcatenate(NULL, " ORDER BY ");
+      else
+        sort = msStringConcatenate(sort, ", ");
+      char *pszEscapedMainTableName =
+          msLayerEscapePropertyName(layer, psInfo->pszMainTableName);
+      sort = msStringConcatenate(sort, "\"");
+      sort = msStringConcatenate(sort, pszEscapedMainTableName);
+      sort = msStringConcatenate(sort, "\".");
+      msFree(pszEscapedMainTableName);
+      if (psInfo->pszRowId) {
+        char *pszEscapedRowId =
+            msLayerEscapePropertyName(layer, psInfo->pszRowId);
+        sort = msStringConcatenate(sort, "\"");
+        sort = msStringConcatenate(sort, pszEscapedRowId);
+        sort = msStringConcatenate(sort, "\"");
+        msFree(pszEscapedRowId);
+      } else
+        sort = msStringConcatenate(sort, "ROWID");
+    }
+
+    // compose SQL
+    if (filter) {
+      select = msStringConcatenate(select, " WHERE ");
+      select = msStringConcatenate(select, filter);
+      msFree(filter);
+    }
+    if (sort) {
+      select = msStringConcatenate(select, " ");
+      select = msStringConcatenate(select, sort);
+      msFree(sort);
+    }
+
+    if (psInfo->bPaging && layer->maxfeatures >= 0) {
+      char szLimit[50];
+      snprintf(szLimit, sizeof(szLimit), " LIMIT %d", layer->maxfeatures);
+      select = msStringConcatenate(select, szLimit);
+    }
+
+    if (psInfo->bPaging && layer->startindex > 0) {
+      char szOffset[50];
+      snprintf(szOffset, sizeof(szOffset), " OFFSET %d", layer->startindex - 1);
+      select = msStringConcatenate(select, szOffset);
+    }
+
+    if (layer->debug)
+      msDebug("msOGRFileWhichShapes: SQL = %s.\n", select);
+
+    ACQUIRE_OGR_LOCK;
+    if (psInfo->nLayerIndex == -1 && psInfo->hLayer != NULL) {
+      OGR_DS_ReleaseResultSet(psInfo->hDS, psInfo->hLayer);
+    }
+
+    OGRGeometryH hGeom = NULL;
+    if (psInfo->dialect == NULL && bHasGeometry && bIsValidRect) {
+      if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
+        hGeom = OGR_G_CreateGeometry(wkbPoint);
+        OGR_G_SetPoint_2D(hGeom, 0, rect.minx, rect.miny);
+      } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
+        hGeom = OGR_G_CreateGeometry(wkbLineString);
+        OGR_G_AddPoint_2D(hGeom, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hGeom, rect.maxx, rect.maxy);
+      } else {
+        hGeom = OGR_G_CreateGeometry(wkbPolygon);
+        OGRGeometryH hRing = OGR_G_CreateGeometry(wkbLinearRing);
+
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddGeometryDirectly(hGeom, hRing);
+      }
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+        msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g "
+                "%.15g %.15g\n",
+                rect.minx, rect.miny, rect.maxx, rect.maxy);
+      }
+    }
+
+    psInfo->hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, select, hGeom, NULL);
+    psInfo->nLayerIndex = -1;
+    if (hGeom != NULL)
+      OGR_G_DestroyGeometry(hGeom);
+
+    if (psInfo->hLayer == NULL) {
+      RELEASE_OGR_LOCK;
+      msSetError(MS_OGRERR, "ExecuteSQL() failed. Check logs.",
+                 "msOGRFileWhichShapes()");
+      msDebug("ExecuteSQL(%s) failed.\n%s\n", select, CPLGetLastErrorMsg());
+      msFree(select);
+      return MS_FAILURE;
+    }
+
+    // Update itemindexes / layer->iteminfo
+    msOGRLayerInitItemInfo(layer);
+  } else {
+
+    // case of 1) GetLayer + SetFilter
+
+    char *pszOGRFilter = NULL;
+    if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+      pszOGRFilter = msStringConcatenate(pszOGRFilter, "(");
+      pszOGRFilter = msStringConcatenate(
+          pszOGRFilter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
+      pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
+    }
+
+    if (psInfo->pszWHERE) {
+      if (pszOGRFilter) {
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, " AND (");
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
+      } else {
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
+      }
+    }
+
+    ACQUIRE_OGR_LOCK;
+
+    if (OGR_L_GetGeomType(psInfo->hLayer) != wkbNone && bIsValidRect) {
+      if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
+        OGRGeometryH hSpatialFilterPoint = OGR_G_CreateGeometry(wkbPoint);
+
+        OGR_G_SetPoint_2D(hSpatialFilterPoint, 0, rect.minx, rect.miny);
+        OGR_L_SetSpatialFilter(psInfo->hLayer, hSpatialFilterPoint);
+        OGR_G_DestroyGeometry(hSpatialFilterPoint);
+      } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
+        OGRGeometryH hSpatialFilterLine = OGR_G_CreateGeometry(wkbLineString);
+
+        OGR_G_AddPoint_2D(hSpatialFilterLine, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hSpatialFilterLine, rect.maxx, rect.maxy);
+        OGR_L_SetSpatialFilter(psInfo->hLayer, hSpatialFilterLine);
+        OGR_G_DestroyGeometry(hSpatialFilterLine);
+      } else {
+        OGRGeometryH hSpatialFilterPolygon = OGR_G_CreateGeometry(wkbPolygon);
+        OGRGeometryH hRing = OGR_G_CreateGeometry(wkbLinearRing);
+
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddGeometryDirectly(hSpatialFilterPolygon, hRing);
+        OGR_L_SetSpatialFilter(psInfo->hLayer, hSpatialFilterPolygon);
+        OGR_G_DestroyGeometry(hSpatialFilterPolygon);
+      }
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+        msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g "
+                "%.15g %.15g\n",
+                rect.minx, rect.miny, rect.maxx, rect.maxy);
+      }
+    }
+
+    psInfo->rect = rect;
+
+    /* ------------------------------------------------------------------
+     * Apply an attribute filter if we have one prefixed with a WHERE
+     * keyword in the filter string.  Otherwise, ensure the attribute
+     * filter is clear.
+     * ------------------------------------------------------------------ */
+    if (pszOGRFilter != NULL) {
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("msOGRFileWhichShapes: Setting attribute filter to %s\n",
+                pszOGRFilter);
+
+      CPLErrorReset();
+      if (OGR_L_SetAttributeFilter(psInfo->hLayer, pszOGRFilter) !=
+          OGRERR_NONE) {
+        msSetError(
+            MS_OGRERR, "SetAttributeFilter() failed on layer %s. Check logs.",
+            "msOGRFileWhichShapes()", layer->name ? layer->name : "(null)");
+        msDebug("SetAttributeFilter(%s) failed on layer %s.\n%s\n",
+                pszOGRFilter, layer->name ? layer->name : "(null)",
+                CPLGetLastErrorMsg());
+        RELEASE_OGR_LOCK;
+        msFree(pszOGRFilter);
+        msFree(select);
+        return MS_FAILURE;
+      }
+      msFree(pszOGRFilter);
+    } else
+      OGR_L_SetAttributeFilter(psInfo->hLayer, NULL);
+  }
+
+  msFree(select);
+
+  /* ------------------------------------------------------------------
+   * Reset current feature pointer
+   * ------------------------------------------------------------------ */
+  OGR_L_ResetReading(psInfo->hLayer);
+  psInfo->last_record_index_read = -1;
+
+  RELEASE_OGR_LOCK;
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGRPassThroughFieldDefinitions()
+ *
+ * Pass the field definitions through to the layer metadata in the
+ * "gml_[item]_{type,width,precision}" set of metadata items for
+ * defining fields.
+ **********************************************************************/
+
+static void msOGRPassThroughFieldDefinitions(layerObj *layer,
+                                             msOGRFileInfo *psInfo)
+
+{
+  OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn(psInfo->hLayer);
+  int numitems, i;
+
+  numitems = OGR_FD_GetFieldCount(hDefn);
+
+  for (i = 0; i < numitems; i++) {
+    OGRFieldDefnH hField = OGR_FD_GetFieldDefn(hDefn, i);
+    OGRFieldSubType eFieldSubType = OGR_Fld_GetSubType(hField);
+
+    char gml_width[32], gml_precision[32];
+    const char *gml_type = NULL;
+    const char *item = OGR_Fld_GetNameRef(hField);
+
+    gml_width[0] = '\0';
+    gml_precision[0] = '\0';
+
+    switch (OGR_Fld_GetType(hField)) {
+    case OFTInteger:
+      if (eFieldSubType == OFSTBoolean) {
+        gml_type = "Boolean";
+      } else {
+        gml_type = "Integer";
+        if (OGR_Fld_GetWidth(hField) > 0)
+          sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      }
+      break;
+
+    case OFTInteger64:
+      gml_type = "Long";
+      if (OGR_Fld_GetWidth(hField) > 0)
+        sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      break;
+
+    case OFTReal:
+      gml_type = "Real";
+      if (OGR_Fld_GetWidth(hField) > 0)
+        sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      if (OGR_Fld_GetPrecision(hField) > 0)
+        sprintf(gml_precision, "%d", OGR_Fld_GetPrecision(hField));
+      break;
+
+    case OFTString:
+      gml_type = "Character";
+      if (OGR_Fld_GetWidth(hField) > 0)
+        sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      break;
+
+    case OFTDate:
+      gml_type = "Date";
+      break;
+    case OFTTime:
+      gml_type = "Time";
+      break;
+    case OFTDateTime:
+      gml_type = "DateTime";
+      break;
+
+    default:
+      gml_type = "Character";
+      break;
+    }
+
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision,
+                             0);
+  }
+
+  /* Should we try to address style items, or other special items? */
+}
+
+/**********************************************************************
+ *                     msOGRFileGetItems()
+ *
+ * Returns a list of field names in a NULL terminated list of strings.
+ **********************************************************************/
+static char **msOGRFileGetItems(layerObj *layer, msOGRFileInfo *psInfo) {
+  OGRFeatureDefnH hDefn;
+  int i, numitems, totalnumitems;
+  int numStyleItems = MSOGR_LABELNUMITEMS;
+  char **items;
+  const char *getShapeStyleItems, *value;
+
+  if ((hDefn = OGR_L_GetLayerDefn(psInfo->hLayer)) == NULL) {
+    msSetError(MS_OGRERR,
+               "OGR Connection for layer `%s' contains no field definition.",
+               "msOGRFileGetItems()", layer->name ? layer->name : "(null)");
+    return NULL;
+  }
+
+  totalnumitems = numitems = OGR_FD_GetFieldCount(hDefn);
+
+  getShapeStyleItems = msLayerGetProcessingKey(layer, "GETSHAPE_STYLE_ITEMS");
+  if (getShapeStyleItems && EQUAL(getShapeStyleItems, "all"))
+    totalnumitems += numStyleItems;
+
+  if ((items = (char **)malloc(sizeof(char *) * (totalnumitems + 1))) == NULL) {
+    msSetError(MS_MEMERR, NULL, "msOGRFileGetItems()");
+    return NULL;
+  }
+
+  for (i = 0; i < numitems; i++) {
+    OGRFieldDefnH hField = OGR_FD_GetFieldDefn(hDefn, i);
+    items[i] = msStrdup(OGR_Fld_GetNameRef(hField));
+  }
+
+  if (getShapeStyleItems && EQUAL(getShapeStyleItems, "all")) {
+    assert(numStyleItems == 21);
+    items[i++] = msStrdup(MSOGR_LABELFONTNAMENAME);
+    items[i++] = msStrdup(MSOGR_LABELSIZENAME);
+    items[i++] = msStrdup(MSOGR_LABELTEXTNAME);
+    items[i++] = msStrdup(MSOGR_LABELANGLENAME);
+    items[i++] = msStrdup(MSOGR_LABELFCOLORNAME);
+    items[i++] = msStrdup(MSOGR_LABELBCOLORNAME);
+    items[i++] = msStrdup(MSOGR_LABELPLACEMENTNAME);
+    items[i++] = msStrdup(MSOGR_LABELANCHORNAME);
+    items[i++] = msStrdup(MSOGR_LABELDXNAME);
+    items[i++] = msStrdup(MSOGR_LABELDYNAME);
+    items[i++] = msStrdup(MSOGR_LABELPERPNAME);
+    items[i++] = msStrdup(MSOGR_LABELBOLDNAME);
+    items[i++] = msStrdup(MSOGR_LABELITALICNAME);
+    items[i++] = msStrdup(MSOGR_LABELUNDERLINENAME);
+    items[i++] = msStrdup(MSOGR_LABELPRIORITYNAME);
+    items[i++] = msStrdup(MSOGR_LABELSTRIKEOUTNAME);
+    items[i++] = msStrdup(MSOGR_LABELSTRETCHNAME);
+    items[i++] = msStrdup(MSOGR_LABELADJHORNAME);
+    items[i++] = msStrdup(MSOGR_LABELADJVERTNAME);
+    items[i++] = msStrdup(MSOGR_LABELHCOLORNAME);
+    items[i++] = msStrdup(MSOGR_LABELOCOLORNAME);
+  }
+  items[i++] = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      consider populating the field definitions in metadata.          */
+  /* -------------------------------------------------------------------- */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    msOGRPassThroughFieldDefinitions(layer, psInfo);
+
+  return items;
+}
+
+/**********************************************************************
+ *                     msOGRFileNextShape()
+ *
+ * Returns shape sequentially from OGR data source.
+ * msOGRLayerWhichShape() must have been called first.
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+static int msOGRFileNextShape(layerObj *layer, shapeObj *shape,
+                              msOGRFileInfo *psInfo) {
+  OGRFeatureH hFeature = NULL;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRFileNextShape()");
+    return (MS_FAILURE);
+  }
+
+  /* ------------------------------------------------------------------
+   * Read until we find a feature that matches attribute filter and
+   * whose geometry is compatible with current layer type.
+   * ------------------------------------------------------------------ */
+  msFreeShape(shape);
+  shape->type = MS_SHAPE_NULL;
+
+  ACQUIRE_OGR_LOCK;
+  while (shape->type == MS_SHAPE_NULL) {
+    if (hFeature)
+      OGR_F_Destroy(hFeature);
+
+    if ((hFeature = OGR_L_GetNextFeature(psInfo->hLayer)) == NULL) {
+      psInfo->last_record_index_read = -1;
+      if (CPLGetLastErrorType() == CE_Failure) {
+        msSetError(MS_OGRERR, "OGR GetNextFeature() error'd. Check logs.",
+                   "msOGRFileNextShape()");
+        msDebug("msOGRFileNextShape(): %s\n", CPLGetLastErrorMsg());
+        RELEASE_OGR_LOCK;
+        return MS_FAILURE;
+      } else {
+        RELEASE_OGR_LOCK;
+        if (layer->debug >= MS_DEBUGLEVEL_VV)
+          msDebug("msOGRFileNextShape: Returning MS_DONE (no more shapes)\n");
+        return MS_DONE; // No more features to read
+      }
+    }
+
+    psInfo->last_record_index_read++;
+
+    if (layer->numitems > 0) {
+      if (shape->values)
+        msFreeCharArray(shape->values, shape->numvalues);
+      shape->values = msOGRGetValues(layer, hFeature);
+      shape->numvalues = layer->numitems;
+      if (!shape->values) {
+        OGR_F_Destroy(hFeature);
+        RELEASE_OGR_LOCK;
+        return (MS_FAILURE);
+      }
+    }
+
+    // Feature matched filter expression... process geometry
+    // shape->type will be set if geom is compatible with layer type
+    if (ogrConvertGeometry(ogrGetLinearGeometry(hFeature), shape,
+                           layer->type) == MS_SUCCESS) {
+      if (shape->type != MS_SHAPE_NULL)
+        break; // Shape is ready to be returned!
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("msOGRFileNextShape: Rejecting feature (shapeid = " CPL_FRMT_GIB
+                ", tileid=%d) of incompatible type for this layer (feature "
+                "wkbType %d, layer type %d)\n",
+                (GIntBig)OGR_F_GetFID(hFeature), psInfo->nTileId,
+                OGR_F_GetGeometryRef(hFeature) == NULL
+                    ? wkbFlatten(wkbUnknown)
+                    : wkbFlatten(OGR_G_GetGeometryType(
+                          OGR_F_GetGeometryRef(hFeature))),
+                layer->type);
+
+    } else {
+      msFreeShape(shape);
+      OGR_F_Destroy(hFeature);
+      RELEASE_OGR_LOCK;
+      return MS_FAILURE; // Error message already produced.
+    }
+
+    // Feature rejected... free shape to clear attributes values.
+    msFreeShape(shape);
+    shape->type = MS_SHAPE_NULL;
+  }
+
+  shape->index = (int)OGR_F_GetFID(
+      hFeature); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
+  shape->resultindex = psInfo->last_record_index_read;
+  shape->tileindex = psInfo->nTileId;
+
+  if (layer->debug >= MS_DEBUGLEVEL_VVV)
+    msDebug("msOGRFileNextShape: Returning shape=%ld, tile=%d\n", shape->index,
+            shape->tileindex);
+
+  // Keep ref. to last feature read in case we need style info.
+  if (psInfo->hLastFeature)
+    OGR_F_Destroy(psInfo->hLastFeature);
+  psInfo->hLastFeature = hFeature;
+
+  RELEASE_OGR_LOCK;
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGRFileGetShape()
+ *
+ * Returns shape from OGR data source by id.
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+static int msOGRFileGetShape(layerObj *layer, shapeObj *shape, long record,
+                             msOGRFileInfo *psInfo, int record_is_fid) {
+  OGRFeatureH hFeature;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRFileNextShape()");
+    return (MS_FAILURE);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Clear previously loaded shape.                                  */
+  /* -------------------------------------------------------------------- */
+  msFreeShape(shape);
+  shape->type = MS_SHAPE_NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Support reading feature by fid.                                 */
+  /* -------------------------------------------------------------------- */
+  if (record_is_fid) {
+    ACQUIRE_OGR_LOCK;
+    if ((hFeature = OGR_L_GetFeature(psInfo->hLayer, record)) == NULL) {
+      RELEASE_OGR_LOCK;
+      return MS_FAILURE;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Support reading shape by offset within the current              */
+  /*      resultset.                                                      */
+  /* -------------------------------------------------------------------- */
+  else {
+    ACQUIRE_OGR_LOCK;
+    if (record <= psInfo->last_record_index_read ||
+        psInfo->last_record_index_read == -1) {
+      OGR_L_ResetReading(psInfo->hLayer);
+      psInfo->last_record_index_read = -1;
+    }
+
+    hFeature = NULL;
+    while (psInfo->last_record_index_read < record) {
+      if (hFeature != NULL) {
+        OGR_F_Destroy(hFeature);
+        hFeature = NULL;
+      }
+      if ((hFeature = OGR_L_GetNextFeature(psInfo->hLayer)) == NULL) {
+        RELEASE_OGR_LOCK;
+        return MS_FAILURE;
+      }
+      psInfo->last_record_index_read++;
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * Handle shape geometry...
+   * ------------------------------------------------------------------ */
+  // shape->type will be set if geom is compatible with layer type
+  if (ogrConvertGeometry(ogrGetLinearGeometry(hFeature), shape, layer->type) !=
+      MS_SUCCESS) {
+    RELEASE_OGR_LOCK;
+    return MS_FAILURE; // Error message already produced.
+  }
+
+  if (shape->type == MS_SHAPE_NULL) {
+    msSetError(MS_OGRERR, "Requested feature is incompatible with layer type",
+               "msOGRLayerGetShape()");
+    RELEASE_OGR_LOCK;
+    return MS_FAILURE;
+  }
+
+  /* ------------------------------------------------------------------
+   * Process shape attributes
+   * ------------------------------------------------------------------ */
+  if (layer->numitems > 0) {
+    shape->values = msOGRGetValues(layer, hFeature);
+    shape->numvalues = layer->numitems;
+    if (!shape->values) {
+      RELEASE_OGR_LOCK;
+      return (MS_FAILURE);
+    }
+  }
+
+  if (record_is_fid) {
+    shape->index = record;
+    shape->resultindex = -1;
+  } else {
+    shape->index = (int)OGR_F_GetFID(
+        hFeature); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
+    shape->resultindex = record;
+  }
+
+  shape->tileindex = psInfo->nTileId;
+
+  // Keep ref. to last feature read in case we need style info.
+  if (psInfo->hLastFeature)
+    OGR_F_Destroy(psInfo->hLastFeature);
+  psInfo->hLastFeature = hFeature;
+
+  RELEASE_OGR_LOCK;
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                         msOGRFileReadTile()                          */
+/*                                                                      */
+/*      Advance to the next tile (or if targetTile is not -1 advance    */
+/*      to that tile), causing the tile to become the poCurTile in      */
+/*      the tileindexes psInfo structure.  Returns MS_DONE if there     */
+/*      are no more available tiles.                                    */
+/*                                                                      */
+/*      Newly loaded tiles are automatically "WhichShaped" based on     */
+/*      the current rectangle.                                          */
+/************************************************************************/
+
+int msOGRFileReadTile(layerObj *layer, msOGRFileInfo *psInfo,
+                      int targetTile = -1)
+
+{
+  int nFeatureId;
+
+  /* -------------------------------------------------------------------- */
+  /*      Close old tile if one is open.                                  */
+  /* -------------------------------------------------------------------- */
+  if (psInfo->poCurTile != NULL) {
+    msOGRFileClose(layer, psInfo->poCurTile);
+    psInfo->poCurTile = NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If -2 is passed, then seek reset reading of the tileindex.      */
+  /*      We want to start from the beginning even if this file is        */
+  /*      shared between layers or renders.                               */
+  /* -------------------------------------------------------------------- */
+  ACQUIRE_OGR_LOCK;
+  if (targetTile == -2) {
+    OGR_L_ResetReading(psInfo->hLayer);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Get the name (connection string really) of the next tile.       */
+  /* -------------------------------------------------------------------- */
+  OGRFeatureH hFeature;
+  char *connection = NULL;
+  msOGRFileInfo *psTileInfo = NULL;
+  int status;
+
+#ifndef IGNORE_MISSING_DATA
+NextFile:
+#endif
+
+  if (targetTile < 0)
+    hFeature = OGR_L_GetNextFeature(psInfo->hLayer);
+
+  else
+    hFeature = OGR_L_GetFeature(psInfo->hLayer, targetTile);
+
+  if (hFeature == NULL) {
+    RELEASE_OGR_LOCK;
+    if (targetTile == -1)
+      return MS_DONE;
+    else
+      return MS_FAILURE;
+  }
+
+  connection = msStrdup(OGR_F_GetFieldAsString(hFeature, layer->tileitemindex));
+
+  char *pszSRS = NULL;
+  if (layer->tilesrs != NULL) {
+    int idx = OGR_F_GetFieldIndex(hFeature, layer->tilesrs);
+    if (idx >= 0) {
+      pszSRS = msStrdup(OGR_F_GetFieldAsString(hFeature, idx));
+    }
+  }
+
+  nFeatureId = (int)OGR_F_GetFID(
+      hFeature); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
+
+  OGR_F_Destroy(hFeature);
+
+  RELEASE_OGR_LOCK;
+
+  /* -------------------------------------------------------------------- */
+  /*      Open the new tile file.                                         */
+  /* -------------------------------------------------------------------- */
+  psTileInfo = msOGRFileOpen(layer, connection);
+
+  free(connection);
+
+#ifndef IGNORE_MISSING_DATA
+  if (psTileInfo == NULL && targetTile == -1) {
+    msFree(pszSRS);
+    goto NextFile;
+  }
+#endif
+
+  if (psTileInfo == NULL) {
+    msFree(pszSRS);
+    return MS_FAILURE;
+  }
+
+  if (pszSRS != NULL) {
+    if (msOGCWKT2ProjectionObj(pszSRS, &(psInfo->sTileProj), layer->debug) !=
+        MS_SUCCESS) {
+      msFree(pszSRS);
+      return MS_FAILURE;
+    }
+    msFree(pszSRS);
+  }
+
+  psTileInfo->nTileId = nFeatureId;
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize the spatial query on this file.                      */
+  /* -------------------------------------------------------------------- */
+  if (psInfo->rect.minx != 0 || psInfo->rect.maxx != 0) {
+    rectObj rect = psInfo->rect;
+
+    if (layer->tileindex != NULL && psInfo->sTileProj.numargs > 0) {
+      msProjectRect(&(layer->projection), &(psInfo->sTileProj), &rect);
+    }
+
+    status = msOGRFileWhichShapes(layer, rect, psTileInfo);
+    if (status != MS_SUCCESS)
+      return status;
+  }
+
+  psInfo->poCurTile = psTileInfo;
+
+  /* -------------------------------------------------------------------- */
+  /*      Update the iteminfo in case this layer has a different field    */
+  /*      list.                                                           */
+  /* -------------------------------------------------------------------- */
+  msOGRLayerInitItemInfo(layer);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                               msExprNode                             */
+/************************************************************************/
+
+class msExprNode {
+public:
+  std::vector<std::unique_ptr<msExprNode>> m_aoChildren{};
+  int m_nToken = 0;
+  std::string m_osVal{};
+  double m_dfVal = 0;
+  struct tm m_tmVal {};
+};
+
+/************************************************************************/
+/*                        exprGetPriority()                             */
+/************************************************************************/
+
+static int exprGetPriority(int token) {
+  if (token == MS_TOKEN_LOGICAL_NOT)
+    return 9;
+  else if (token == '*' || token == '/' || token == '%')
+    return 8;
+  else if (token == '+' || token == '-')
+    return 7;
+  else if (token == MS_TOKEN_COMPARISON_GE || token == MS_TOKEN_COMPARISON_GT ||
+           token == MS_TOKEN_COMPARISON_LE || token == MS_TOKEN_COMPARISON_LT ||
+           token == MS_TOKEN_COMPARISON_IN)
+    return 6;
+  else if (token == MS_TOKEN_COMPARISON_EQ ||
+           token == MS_TOKEN_COMPARISON_IEQ ||
+           token == MS_TOKEN_COMPARISON_RE ||
+           token == MS_TOKEN_COMPARISON_IRE || token == MS_TOKEN_COMPARISON_NE)
+    return 5;
+  else if (token == MS_TOKEN_LOGICAL_AND)
+    return 4;
+  else if (token == MS_TOKEN_LOGICAL_OR)
+    return 3;
+  else
+    return 0;
+}
+
+/************************************************************************/
+/*                           BuildExprTree()                            */
+/************************************************************************/
+
+static std::unique_ptr<msExprNode> BuildExprTree(tokenListNodeObjPtr node,
+                                                 tokenListNodeObjPtr *pNodeNext,
+                                                 int nParenthesisLevel) {
+  std::vector<std::unique_ptr<msExprNode>> aoStackOp, aoStackVal;
+  while (node != NULL) {
+    if (node->token == '(') {
+      auto subExpr = BuildExprTree(node->next, &node, nParenthesisLevel + 1);
+      if (subExpr == NULL) {
+        return nullptr;
+      }
+      aoStackVal.emplace_back(std::move(subExpr));
+      continue;
+    } else if (node->token == ')') {
+      if (nParenthesisLevel > 0) {
+        break;
+      }
+      return nullptr;
+    } else if (node->token == '+' || node->token == '-' || node->token == '*' ||
+               node->token == '/' || node->token == '%' ||
+               node->token == MS_TOKEN_LOGICAL_NOT ||
+               node->token == MS_TOKEN_LOGICAL_AND ||
+               node->token == MS_TOKEN_LOGICAL_OR ||
+               node->token == MS_TOKEN_COMPARISON_GE ||
+               node->token == MS_TOKEN_COMPARISON_GT ||
+               node->token == MS_TOKEN_COMPARISON_LE ||
+               node->token == MS_TOKEN_COMPARISON_LT ||
+               node->token == MS_TOKEN_COMPARISON_EQ ||
+               node->token == MS_TOKEN_COMPARISON_IEQ ||
+               node->token == MS_TOKEN_COMPARISON_NE ||
+               node->token == MS_TOKEN_COMPARISON_RE ||
+               node->token == MS_TOKEN_COMPARISON_IRE ||
+               node->token == MS_TOKEN_COMPARISON_IN) {
+      while (!aoStackOp.empty() &&
+             exprGetPriority(node->token) <=
+                 exprGetPriority(aoStackOp.back()->m_nToken)) {
+        std::unique_ptr<msExprNode> val1;
+        std::unique_ptr<msExprNode> val2;
+        if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT) {
+          if (aoStackVal.empty())
+            return nullptr;
+          val2.reset(aoStackVal.back().release());
+          aoStackVal.pop_back();
+        }
+        if (aoStackVal.empty())
+          return nullptr;
+        val1.reset(aoStackVal.back().release());
+        aoStackVal.pop_back();
+
+        std::unique_ptr<msExprNode> newNode(new msExprNode);
+        newNode->m_nToken = aoStackOp.back()->m_nToken;
+        newNode->m_aoChildren.emplace_back(std::move(val1));
+        if (val2)
+          newNode->m_aoChildren.emplace_back(std::move(val2));
+        aoStackVal.emplace_back(std::move(newNode));
+        aoStackOp.pop_back();
+      }
+
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      aoStackOp.emplace_back(std::move(newNode));
+    } else if (node->token == ',') {
+    } else if (node->token == MS_TOKEN_COMPARISON_INTERSECTS ||
+               node->token == MS_TOKEN_COMPARISON_DISJOINT ||
+               node->token == MS_TOKEN_COMPARISON_TOUCHES ||
+               node->token == MS_TOKEN_COMPARISON_OVERLAPS ||
+               node->token == MS_TOKEN_COMPARISON_CROSSES ||
+               node->token == MS_TOKEN_COMPARISON_DWITHIN ||
+               node->token == MS_TOKEN_COMPARISON_BEYOND ||
+               node->token == MS_TOKEN_COMPARISON_WITHIN ||
+               node->token == MS_TOKEN_COMPARISON_CONTAINS ||
+               node->token == MS_TOKEN_COMPARISON_EQUALS ||
+               node->token == MS_TOKEN_FUNCTION_LENGTH ||
+               node->token == MS_TOKEN_FUNCTION_TOSTRING ||
+               node->token == MS_TOKEN_FUNCTION_COMMIFY ||
+               node->token == MS_TOKEN_FUNCTION_AREA ||
+               node->token == MS_TOKEN_FUNCTION_ROUND ||
+               node->token == MS_TOKEN_FUNCTION_FROMTEXT ||
+               node->token == MS_TOKEN_FUNCTION_BUFFER ||
+               node->token == MS_TOKEN_FUNCTION_DIFFERENCE ||
+               node->token == MS_TOKEN_FUNCTION_SIMPLIFY ||
+               node->token == MS_TOKEN_FUNCTION_SIMPLIFYPT ||
+               node->token == MS_TOKEN_FUNCTION_GENERALIZE ||
+               node->token == MS_TOKEN_FUNCTION_SMOOTHSIA ||
+               node->token == MS_TOKEN_FUNCTION_JAVASCRIPT ||
+               node->token == MS_TOKEN_FUNCTION_UPPER ||
+               node->token == MS_TOKEN_FUNCTION_LOWER ||
+               node->token == MS_TOKEN_FUNCTION_INITCAP ||
+               node->token == MS_TOKEN_FUNCTION_FIRSTCAP) {
+      if (node->next && node->next->token == '(') {
+        int node_token = node->token;
+        auto subExpr =
+            BuildExprTree(node->next->next, &node, nParenthesisLevel + 1);
+        if (subExpr == NULL) {
+          return nullptr;
+        }
+        std::unique_ptr<msExprNode> newNode(new msExprNode);
+        newNode->m_nToken = node_token;
+        if (subExpr->m_nToken == 0) {
+          newNode->m_aoChildren = std::move(subExpr->m_aoChildren);
+        } else {
+          newNode->m_aoChildren.emplace_back(std::move(subExpr));
+        }
+        aoStackVal.emplace_back(std::move(newNode));
+        continue;
+      } else
+        return nullptr;
+    } else if (node->token == MS_TOKEN_LITERAL_NUMBER ||
+               node->token == MS_TOKEN_LITERAL_BOOLEAN) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_dfVal = node->tokenval.dblval;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_LITERAL_STRING) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_osVal = node->tokenval.strval;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_LITERAL_TIME) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_tmVal = node->tokenval.tmval;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_LITERAL_SHAPE) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      char *wkt = msShapeToWKT(node->tokenval.shpval);
+      newNode->m_osVal = wkt;
+      msFree(wkt);
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_BINDING_DOUBLE ||
+               node->token == MS_TOKEN_BINDING_INTEGER ||
+               node->token == MS_TOKEN_BINDING_STRING ||
+               node->token == MS_TOKEN_BINDING_TIME) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_osVal = node->tokenval.bindval.item;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      aoStackVal.emplace_back(std::move(newNode));
+    }
+
+    node = node->next;
+  }
+
+  while (!aoStackOp.empty()) {
+    std::unique_ptr<msExprNode> val1 = NULL;
+    std::unique_ptr<msExprNode> val2 = NULL;
+    if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT) {
+      if (aoStackVal.empty())
+        return nullptr;
+      val2.reset(aoStackVal.back().release());
+      aoStackVal.pop_back();
+    }
+    if (aoStackVal.empty())
+      return nullptr;
+    val1.reset(aoStackVal.back().release());
+    aoStackVal.pop_back();
+
+    std::unique_ptr<msExprNode> newNode(new msExprNode);
+    newNode->m_nToken = aoStackOp.back()->m_nToken;
+    newNode->m_aoChildren.emplace_back(std::move(val1));
+    if (val2)
+      newNode->m_aoChildren.emplace_back(std::move(val2));
+    aoStackVal.emplace_back(std::move(newNode));
+    aoStackOp.pop_back();
+  }
+
+  std::unique_ptr<msExprNode> poRet;
+  if (aoStackVal.size() == 1)
+    poRet.reset(aoStackVal.back().release());
+  else if (aoStackVal.size() > 1) {
+    poRet.reset(new msExprNode);
+    poRet->m_aoChildren = std::move(aoStackVal);
+  }
+
+  if (pNodeNext)
+    *pNodeNext = node ? node->next : NULL;
+
+  return poRet;
+}
+
+/**********************************************************************
+ *                 msOGRExtractTopSpatialFilter()
+ *
+ * Recognize expressions like "Intersects([shape], wkt) == TRUE [AND ....]"
+ **********************************************************************/
+static int msOGRExtractTopSpatialFilter(msOGRFileInfo *info,
+                                        const msExprNode *expr,
+                                        const msExprNode **pSpatialFilterNode) {
+  if (expr == NULL)
+    return MS_FALSE;
+
+  if (expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
+      expr->m_aoChildren.size() == 2 &&
+      expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_BOOLEAN &&
+      expr->m_aoChildren[1]->m_dfVal == 1.0) {
+    return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
+                                        pSpatialFilterNode);
+  }
+
+  if ((((expr->m_nToken == MS_TOKEN_COMPARISON_INTERSECTS ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_OVERLAPS ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_CROSSES ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_WITHIN ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_CONTAINS) &&
+        expr->m_aoChildren.size() == 2) ||
+       (expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN &&
+        expr->m_aoChildren.size() == 3)) &&
+      expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_SHAPE) {
+    if (info->rect_is_defined) {
+      // Several intersects...
+      *pSpatialFilterNode = NULL;
+      info->rect_is_defined = MS_FALSE;
+      return MS_FALSE;
+    }
+    OGRGeometryH hSpatialFilter = NULL;
+    char *wkt = const_cast<char *>(expr->m_aoChildren[1]->m_osVal.c_str());
+    OGRErr e = OGR_G_CreateFromWkt(&wkt, NULL, &hSpatialFilter);
+    if (e == OGRERR_NONE) {
+      OGREnvelope env;
+      if (expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN) {
+        OGRGeometryH hBuffer =
+            OGR_G_Buffer(hSpatialFilter, expr->m_aoChildren[2]->m_dfVal, 30);
+        OGR_G_GetEnvelope(hBuffer ? hBuffer : hSpatialFilter, &env);
+        OGR_G_DestroyGeometry(hBuffer);
+      } else {
+        OGR_G_GetEnvelope(hSpatialFilter, &env);
+      }
+      info->rect.minx = env.MinX;
+      info->rect.miny = env.MinY;
+      info->rect.maxx = env.MaxX;
+      info->rect.maxy = env.MaxY;
+      info->rect_is_defined = true;
+      *pSpatialFilterNode = expr;
+      OGR_G_DestroyGeometry(hSpatialFilter);
+      return MS_TRUE;
+    }
+    return MS_FALSE;
+  }
+
+  if (expr->m_nToken == MS_TOKEN_LOGICAL_AND &&
+      expr->m_aoChildren.size() == 2) {
+    return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
+                                        pSpatialFilterNode) &&
+           msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[1].get(),
+                                        pSpatialFilterNode);
+  }
+
+  return MS_TRUE;
+}
+
+/**********************************************************************
+ *                 msOGRTranslatePartialMSExpressionToOGRSQL()
+ *
+ * Tries to partially translate a mapserver expression to SQL
+ **********************************************************************/
+
+static std::string msOGRGetTokenText(int nToken) {
+  switch (nToken) {
+  case '*':
+  case '+':
+  case '-':
+  case '/':
+  case '%':
+    return std::string(1, static_cast<char>(nToken));
+
+  case MS_TOKEN_COMPARISON_GE:
+    return ">=";
+  case MS_TOKEN_COMPARISON_GT:
+    return ">";
+  case MS_TOKEN_COMPARISON_LE:
+    return "<=";
+  case MS_TOKEN_COMPARISON_LT:
+    return "<";
+  case MS_TOKEN_COMPARISON_EQ:
+    return "=";
+  case MS_TOKEN_COMPARISON_NE:
+    return "!=";
+
+  default:
+    return std::string();
+  }
+}
+
+static std::string
+msOGRTranslatePartialInternal(layerObj *layer, const msExprNode *expr,
+                              const msExprNode *spatialFilterNode,
+                              bool &bPartialFilter) {
+  switch (expr->m_nToken) {
+  case MS_TOKEN_LOGICAL_NOT: {
+    std::string osTmp(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    if (osTmp.empty())
+      return std::string();
+    return "(NOT " + osTmp + ")";
+  }
+
+  case MS_TOKEN_LOGICAL_AND: {
+    // We can deal with partially translated children
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osTmp2(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter));
+    if (!osTmp1.empty() && !osTmp2.empty()) {
+      return "(" + osTmp1 + " AND " + osTmp2 + ")";
+    } else if (!osTmp1.empty())
+      return osTmp1;
+    else
+      return osTmp2;
+  }
+
+  case MS_TOKEN_LOGICAL_OR: {
+    // We can NOT deal with partially translated children
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osTmp2(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter));
+    if (!osTmp1.empty() && !osTmp2.empty()) {
+      return "(" + osTmp1 + " OR " + osTmp2 + ")";
+    } else
+      return std::string();
+  }
+
+  case '*':
+  case '+':
+  case '-':
+  case '/':
+  case '%':
+  case MS_TOKEN_COMPARISON_GE:
+  case MS_TOKEN_COMPARISON_GT:
+  case MS_TOKEN_COMPARISON_LE:
+  case MS_TOKEN_COMPARISON_LT:
+  case MS_TOKEN_COMPARISON_EQ:
+  case MS_TOKEN_COMPARISON_NE: {
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osTmp2(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter));
+    if (!osTmp1.empty() && !osTmp2.empty()) {
+      if (expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
+          osTmp2 == "'_MAPSERVER_NULL_'") {
+        return "(" + osTmp1 + " IS NULL )";
+      }
+      if (expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_STRING) {
+        char md_item_name[256];
+        snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+                 expr->m_aoChildren[0]->m_osVal.c_str());
+        const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+        // Cast if needed (or unsure)
+        if (type == NULL || !EQUAL(type, "Character")) {
+          osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
+        }
+      }
+      return "(" + osTmp1 + " " + msOGRGetTokenText(expr->m_nToken) + " " +
+             osTmp2 + ")";
+    } else
+      return std::string();
+  }
+
+  case MS_TOKEN_COMPARISON_RE: {
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    if (expr->m_aoChildren[1]->m_nToken != MS_TOKEN_LITERAL_STRING) {
+      return std::string();
+    }
+    std::string osRE("'");
+    const size_t nSize = expr->m_aoChildren[1]->m_osVal.size();
+    bool bHasUsedEscape = false;
+    for (size_t i = 0; i < nSize; i++) {
+      if (i == 0 && expr->m_aoChildren[1]->m_osVal[i] == '^')
+        continue;
+      if (i == nSize - 1 && expr->m_aoChildren[1]->m_osVal[i] == '$')
+        break;
+      if (expr->m_aoChildren[1]->m_osVal[i] == '.') {
+        if (i + 1 < nSize && expr->m_aoChildren[1]->m_osVal[i + 1] == '*') {
+          osRE += "%";
+          i++;
+        } else {
+          osRE += "_";
+        }
+      } else if (expr->m_aoChildren[1]->m_osVal[i] == '\\' && i + 1 < nSize) {
+        bHasUsedEscape = true;
+        osRE += 'X';
+        osRE += expr->m_aoChildren[1]->m_osVal[i + 1];
+        i++;
+      } else if (expr->m_aoChildren[1]->m_osVal[i] == 'X' ||
+                 expr->m_aoChildren[1]->m_osVal[i] == '%' ||
+                 expr->m_aoChildren[1]->m_osVal[i] == '_') {
+        bHasUsedEscape = true;
+        osRE += 'X';
+        osRE += expr->m_aoChildren[1]->m_osVal[i];
+      } else {
+        osRE += expr->m_aoChildren[1]->m_osVal[i];
+      }
+    }
+    osRE += "'";
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             expr->m_aoChildren[0]->m_osVal.c_str());
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Cast if needed (or unsure)
+    if (type == NULL || !EQUAL(type, "Character")) {
+      osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
+    }
+    std::string osRet("(" + osTmp1 + " LIKE " + osRE);
+    if (bHasUsedEscape)
+      osRet += " ESCAPE 'X'";
+    osRet += ")";
+    return osRet;
+  }
+
+  case MS_TOKEN_COMPARISON_IN: {
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osRet = "(" + osTmp1 + " IN (";
+    for (size_t i = 0; i < expr->m_aoChildren[1]->m_aoChildren.size(); ++i) {
+      if (i > 0)
+        osRet += ", ";
+      osRet += msOGRTranslatePartialInternal(
+          layer, expr->m_aoChildren[1]->m_aoChildren[i].get(),
+          spatialFilterNode, bPartialFilter);
+    }
+    osRet += ")";
+    return osRet;
+  }
+
+  case MS_TOKEN_LITERAL_NUMBER:
+  case MS_TOKEN_LITERAL_BOOLEAN: {
+    return std::string(CPLSPrintf("%.18g", expr->m_dfVal));
+  }
+
+  case MS_TOKEN_LITERAL_STRING: {
+    char *stresc = msOGREscapeSQLParam(layer, expr->m_osVal.c_str());
+    std::string osRet("'" + std::string(stresc) + "'");
+    msFree(stresc);
+    return osRet;
+  }
+
+  case MS_TOKEN_LITERAL_TIME: {
+#ifdef notdef
+    // Breaks tests in msautotest/wxs/wfs_time_ogr.map
+    return std::string(CPLSPrintf(
+        "'%04d/%02d/%02d %02d:%02d:%02d'", expr->m_tmVal.tm_year + 1900,
+        expr->m_tmVal.tm_mon + 1, expr->m_tmVal.tm_mday, expr->m_tmVal.tm_hour,
+        expr->m_tmVal.tm_min, expr->m_tmVal.tm_sec));
+#endif
+    return std::string();
+  }
+
+  case MS_TOKEN_BINDING_DOUBLE:
+  case MS_TOKEN_BINDING_INTEGER:
+  case MS_TOKEN_BINDING_STRING:
+  case MS_TOKEN_BINDING_TIME: {
+    char *pszTmp = msOGRGetQuotedItem(layer, expr->m_osVal.c_str());
+    std::string osRet(pszTmp);
+    msFree(pszTmp);
+    return osRet;
+  }
+
+  case MS_TOKEN_COMPARISON_INTERSECTS: {
+    if (expr != spatialFilterNode)
+      bPartialFilter = true;
+    return std::string();
+  }
+
+  default: {
+    bPartialFilter = true;
+    return std::string();
+  }
+  }
+}
+
+/* ==================================================================
+ * Here comes the REAL stuff... the functions below are called by maplayer.c
+ * ================================================================== */
+
+/**********************************************************************
+ *                     msOGRTranslateMsExpressionToOGRSQL()
+ *
+ * Tries to translate a mapserver expression to OGR or driver native SQL
+ **********************************************************************/
+static int msOGRTranslateMsExpressionToOGRSQL(layerObj *layer,
+                                              expressionObj *psFilter,
+                                              char *filteritem) {
+  msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
+
+  msFree(layer->filter.native_string);
+  layer->filter.native_string = NULL;
+
+  msFree(info->pszWHERE);
+  info->pszWHERE = NULL;
+
+  // reasons to not produce native string: not simple layer, or an explicit deny
+  const char *do_this =
+      msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
+  if (do_this && strcmp(do_this, "NO") == 0) {
+    return MS_SUCCESS;
+  }
+
+  tokenListNodeObjPtr node = psFilter->tokens;
+  auto expr = BuildExprTree(node, NULL, 0);
+  info->rect_is_defined = MS_FALSE;
+  const msExprNode *spatialFilterNode = NULL;
+  if (expr)
+    msOGRExtractTopSpatialFilter(info, expr.get(), &spatialFilterNode);
+
+  // more reasons to not produce native string: not a recognized driver
+  if (!info->dialect) {
+    // in which case we might still want to try to get a partial WHERE clause
+    if (filteritem == NULL && expr) {
+      bool bPartialFilter = false;
+      std::string osSQL(msOGRTranslatePartialInternal(
+          layer, expr.get(), spatialFilterNode, bPartialFilter));
+      if (!osSQL.empty()) {
+        info->pszWHERE = msStrdup(osSQL.c_str());
+        if (bPartialFilter) {
+          msDebug("Full filter has only been partially "
+                  "translated to OGR filter %s\n",
+                  info->pszWHERE);
+        }
+      } else if (bPartialFilter) {
+        msDebug("Filter could not be translated to OGR filter\n");
+      }
+    }
+    return MS_SUCCESS;
+  }
+
+  char *sql = NULL;
+
+  // node may be NULL if layer->filter.string != NULL and filteritem != NULL
+  // this is simple filter but string is regex
+  if (node == NULL && filteritem != NULL && layer->filter.string != NULL) {
+    sql = msStringConcatenate(sql, "\"");
+    sql = msStringConcatenate(sql, filteritem);
+    sql = msStringConcatenate(sql, "\"");
+    if (EQUAL(info->dialect, "PostgreSQL")) {
+      sql = msStringConcatenate(sql, " ~ ");
+    } else {
+      sql = msStringConcatenate(sql, " LIKE ");
+    }
+    sql = msStringConcatenate(sql, "'");
+    sql = msStringConcatenate(sql, layer->filter.string);
+    sql = msStringConcatenate(sql, "'");
+  }
+
+  while (node != NULL) {
+
+    if (node->next && node->next->token == MS_TOKEN_COMPARISON_IEQ) {
+      char *left = msOGRGetToken(layer, &node);
+      node = node->next; // skip =
+      char *right = msOGRGetToken(layer, &node);
+      sql = msStringConcatenate(sql, "upper(");
+      sql = msStringConcatenate(sql, left);
+      sql = msStringConcatenate(sql, ")");
+      sql = msStringConcatenate(sql, "=");
+      sql = msStringConcatenate(sql, "upper(");
+      sql = msStringConcatenate(sql, right);
+      sql = msStringConcatenate(sql, ")");
+      int ok = left && right;
+      msFree(left);
+      msFree(right);
+      if (!ok) {
+        goto fail;
+      }
+      continue;
+    }
+
+    switch (node->token) {
+    case MS_TOKEN_COMPARISON_INTERSECTS:
+    case MS_TOKEN_COMPARISON_DISJOINT:
+    case MS_TOKEN_COMPARISON_TOUCHES:
+    case MS_TOKEN_COMPARISON_OVERLAPS:
+    case MS_TOKEN_COMPARISON_CROSSES:
+    case MS_TOKEN_COMPARISON_DWITHIN:
+    case MS_TOKEN_COMPARISON_BEYOND:
+    case MS_TOKEN_COMPARISON_WITHIN:
+    case MS_TOKEN_COMPARISON_CONTAINS:
+    case MS_TOKEN_COMPARISON_EQUALS: {
+      int token = node->token;
+      char *fct = msOGRGetToken(layer, &node);
+      node = node->next; // skip (
+      char *a1 = msOGRGetToken(layer, &node);
+      node = node->next; // skip ,
+      char *a2 = msOGRGetToken(layer, &node);
+      char *a3 = NULL;
+      if (token == MS_TOKEN_COMPARISON_DWITHIN ||
+          token == MS_TOKEN_COMPARISON_BEYOND) {
+        node = node->next; // skip ,
+        a3 = msOGRGetToken(layer, &node);
+      }
+      node = node->next; // skip )
+      char *eq = msOGRGetToken(layer, &node);
+      char *rval = msOGRGetToken(layer, &node);
+      if ((eq && strcmp(eq, " != ") == 0) ||
+          (rval && strcmp(rval, "FALSE") == 0)) {
+        sql = msStringConcatenate(sql, "NOT ");
+      }
+      // FIXME: case rval is more complex
+      sql = msStringConcatenate(sql, fct);
+      sql = msStringConcatenate(sql, "(");
+      sql = msStringConcatenate(sql, a1);
+      sql = msStringConcatenate(sql, ",");
+      sql = msStringConcatenate(sql, a2);
+      if (token == MS_TOKEN_COMPARISON_DWITHIN ||
+          token == MS_TOKEN_COMPARISON_BEYOND) {
+        sql = msStringConcatenate(sql, ")");
+        if (token == MS_TOKEN_COMPARISON_DWITHIN)
+          sql = msStringConcatenate(sql, "<=");
+        else
+          sql = msStringConcatenate(sql, ">");
+        sql = msStringConcatenate(sql, a3);
+      } else {
+        sql = msStringConcatenate(sql, ")");
+      }
+      int ok = fct && a1 && a2 && eq && rval;
+      if (token == MS_TOKEN_COMPARISON_DWITHIN) {
+        ok = ok && a3;
+      }
+      msFree(fct);
+      msFree(a1);
+      msFree(a2);
+      msFree(a3);
+      msFree(eq);
+      msFree(rval);
+      if (!ok) {
+        goto fail;
+      }
+      break;
+    }
+    default: {
+      char *token = msOGRGetToken(layer, &node);
+      if (!token) {
+        goto fail;
+      }
+      sql = msStringConcatenate(sql, token);
+      msFree(token);
+    }
+    }
+  }
+
+  layer->filter.native_string = sql;
+  return MS_SUCCESS;
+fail:
+  // error producing native string
+  msDebug("Note: Error parsing token list, could produce only: %s. Trying in "
+          "partial mode\n",
+          sql);
+  msFree(sql);
+
+  // in which case we might still want to try to get a partial WHERE clause
+  if (expr) {
+    bool bPartialFilter = false;
+    std::string osSQL(msOGRTranslatePartialInternal(
+        layer, expr.get(), spatialFilterNode, bPartialFilter));
+    if (!osSQL.empty()) {
+      info->pszWHERE = msStrdup(osSQL.c_str());
+      if (bPartialFilter) {
+        msDebug("Full filter has only been partially "
+                "translated to OGR filter %s\n",
+                info->pszWHERE);
+      }
+    } else if (bPartialFilter) {
+      msDebug("Filter could not be translated to OGR filter\n");
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGRLayerOpen()
+ *
+ * Open OGR data source for the specified map layer.
+ *
+ * If pszOverrideConnection != NULL then this value is used as the connection
+ * string instead of lp->connection.  This is used for instance to open
+ * a WFS layer, in this case lp->connection is the WFS url, but we want
+ * OGR to open the local file on disk that was previously downloaded.
+ *
+ * An OGR connection string is:   <dataset_filename>[,<layer_index>]
+ *  <dataset_filename>   is file format specific
+ *  <layer_index>        (optional) is the OGR layer index
+ *                       default is 0, the first layer.
+ *
+ * One can use the "ogrinfo" program to find out the layer indices in a dataset
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+int msOGRLayerOpen(layerObj *layer, const char *pszOverrideConnection) {
+  msOGRFileInfo *psInfo;
+
+  if (layer->layerinfo != NULL) {
+    return MS_SUCCESS; // Nothing to do... layer is already opened
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If this is not a tiled layer, just directly open the target.    */
+  /* -------------------------------------------------------------------- */
+  if (layer->tileindex == NULL) {
+    psInfo = msOGRFileOpen(layer, (pszOverrideConnection ? pszOverrideConnection
+                                                         : layer->connection));
+    layer->layerinfo = psInfo;
+    layer->tileitemindex = -1;
+
+    if (layer->layerinfo == NULL)
+      return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise we open the tile index, identify the tile item        */
+  /*      index and try to select the first file matching our query       */
+  /*      region.                                                         */
+  /* -------------------------------------------------------------------- */
+  else {
+    // Open tile index
+
+    psInfo = msOGRFileOpen(layer, layer->tileindex);
+    layer->layerinfo = psInfo;
+
+    if (layer->layerinfo == NULL)
+      return MS_FAILURE;
+
+    // Identify TILEITEM
+    OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn(psInfo->hLayer);
+    layer->tileitemindex = OGR_FD_GetFieldIndex(hDefn, layer->tileitem);
+    if (layer->tileitemindex < 0) {
+      msSetError(MS_OGRERR,
+                 "Can't identify TILEITEM %s field in TILEINDEX `%s'.",
+                 "msOGRLayerOpen()", layer->tileitem, layer->tileindex);
+      msOGRFileClose(layer, psInfo);
+      layer->layerinfo = NULL;
+      return MS_FAILURE;
+    }
+
+    // Identify TILESRS
+    if (layer->tilesrs != NULL &&
+        OGR_FD_GetFieldIndex(hDefn, layer->tilesrs) < 0) {
+      msSetError(MS_OGRERR,
+                 "Can't identify TILESRS %s field in TILEINDEX `%s'.",
+                 "msOGRLayerOpen()", layer->tilesrs, layer->tileindex);
+      msOGRFileClose(layer, psInfo);
+      layer->layerinfo = NULL;
+      return MS_FAILURE;
+    }
+    if (layer->tilesrs != NULL && layer->projection.numargs == 0) {
+      msSetError(MS_OGRERR,
+                 "A layer with TILESRS set in TILEINDEX `%s' must have a "
+                 "projection set on itself.",
+                 "msOGRLayerOpen()", layer->tileindex);
+      msOGRFileClose(layer, psInfo);
+      layer->layerinfo = NULL;
+      return MS_FAILURE;
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * If projection was "auto" then set proj to the dataset's projection.
+   * For a tile index, it is assume the tile index has the projection.
+   * ------------------------------------------------------------------ */
+  if (layer->projection.numargs > 0 &&
+      EQUAL(layer->projection.args[0], "auto")) {
+    ACQUIRE_OGR_LOCK;
+    OGRSpatialReferenceH hSRS = OGR_L_GetSpatialRef(psInfo->hLayer);
+
+    if (msOGRSpatialRef2ProjectionObj(hSRS, &(layer->projection),
+                                      layer->debug) != MS_SUCCESS) {
+      errorObj *ms_error = msGetErrorObj();
+
+      RELEASE_OGR_LOCK;
+      msSetError(MS_OGRERR,
+                 "%s  "
+                 "PROJECTION AUTO cannot be used for this "
+                 "OGR connection (in layer `%s').",
+                 "msOGRLayerOpen()", ms_error->message,
+                 layer->name ? layer->name : "(null)");
+      msOGRFileClose(layer, psInfo);
+      layer->layerinfo = NULL;
+      return (MS_FAILURE);
+    }
+    RELEASE_OGR_LOCK;
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGRLayerOpenVT()
+ *
+ * Overloaded version of msOGRLayerOpen for virtual table architecture
+ **********************************************************************/
+static int msOGRLayerOpenVT(layerObj *layer) {
+  return msOGRLayerOpen(layer, NULL);
+}
+
+/**********************************************************************
+ *                     msOGRLayerClose()
+ **********************************************************************/
+int msOGRLayerClose(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+
+  if (psInfo) {
+    if (layer->debug)
+      msDebug("msOGRLayerClose(%s).\n", layer->connection);
+
+    msOGRFileClose(layer, psInfo);
+    layer->layerinfo = NULL;
+  }
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGRLayerIsOpen()
+ **********************************************************************/
+static int msOGRLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+int msOGRSupportsIsNull(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  if (psInfo && psInfo->dialect &&
+      (EQUAL(psInfo->dialect, "Spatialite") ||
+       EQUAL(psInfo->dialect, "GPKG"))) {
+    // reasons to not produce native string: not simple layer, or an explicit
+    // deny
+    const char *do_this =
+        msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
+    if (do_this && strcmp(do_this, "NO") == 0) {
+      return MS_FALSE;
+    }
+    return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/**********************************************************************
+ *                     msOGRLayerWhichShapes()
+ *
+ * Init OGR layer structs ready for calls to msOGRLayerNextShape().
+ *
+ * Returns MS_SUCCESS/MS_FAILURE, or MS_DONE if no shape matching the
+ * layer's FILTER overlaps the selected region.
+ **********************************************************************/
+int msOGRLayerWhichShapes(layerObj *layer, rectObj rect, int /*isQuery*/) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int status;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerWhichShapes()");
+    return (MS_FAILURE);
+  }
+
+  status = msOGRFileWhichShapes(layer, rect, psInfo);
+
+  if (status != MS_SUCCESS || layer->tileindex == NULL)
+    return status;
+
+  // If we are using a tile index, we need to advance to the first
+  // tile matching the spatial query, and load it.
+
+  return msOGRFileReadTile(layer, psInfo);
+}
+
+/**********************************************************************
+ *                     msOGRLayerGetItems()
+ *
+ * Load item (i.e. field) names in a char array.  If we are working
+ * with a tiled layer, ensure a tile is loaded and use it for the items.
+ * It is implicitly assumed that the schemas will match on all tiles.
+ **********************************************************************/
+int msOGRLayerGetItems(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerGetItems()");
+    return (MS_FAILURE);
+  }
+
+  if (layer->tileindex != NULL) {
+    if (psInfo->poCurTile == NULL &&
+        msOGRFileReadTile(layer, psInfo) != MS_SUCCESS)
+      return MS_FAILURE;
+
+    psInfo = psInfo->poCurTile;
+  }
+
+  layer->numitems = 0;
+  layer->items = msOGRFileGetItems(layer, psInfo);
+  if (layer->items == NULL)
+    return MS_FAILURE;
+
+  while (layer->items[layer->numitems] != NULL)
+    layer->numitems++;
+
+  return msOGRLayerInitItemInfo(layer);
+}
+
+/**********************************************************************
+ *                     msOGRLayerInitItemInfo()
+ *
+ * Init the itemindexes array after items[] has been reset in a layer.
+ **********************************************************************/
+static int msOGRLayerInitItemInfo(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int i;
+  OGRFeatureDefnH hDefn;
+
+  if (layer->numitems == 0)
+    return MS_SUCCESS;
+
+  if (layer->tileindex != NULL) {
+    if (psInfo->poCurTile == NULL &&
+        msOGRFileReadTile(layer, psInfo, -2) != MS_SUCCESS)
+      return MS_FAILURE;
+
+    psInfo = psInfo->poCurTile;
+  }
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerInitItemInfo()");
+    return (MS_FAILURE);
+  }
+
+  if ((hDefn = OGR_L_GetLayerDefn(psInfo->hLayer)) == NULL) {
+    msSetError(MS_OGRERR, "Layer contains no fields.",
+               "msOGRLayerInitItemInfo()");
+    return (MS_FAILURE);
+  }
+
+  if (layer->iteminfo)
+    free(layer->iteminfo);
+  if ((layer->iteminfo = (int *)malloc(sizeof(int) * layer->numitems)) ==
+      NULL) {
+    msSetError(MS_MEMERR, NULL, "msOGRLayerInitItemInfo()");
+    return (MS_FAILURE);
+  }
+
+  int *itemindexes = (int *)layer->iteminfo;
+  for (i = 0; i < layer->numitems; i++) {
+    // Special case for handling text string and angle coming from
+    // OGR style strings.  We use special attribute snames.
+    if (EQUAL(layer->items[i], MSOGR_LABELFONTNAMENAME))
+      itemindexes[i] = MSOGR_LABELFONTNAMEINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELSIZENAME))
+      itemindexes[i] = MSOGR_LABELSIZEINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELTEXTNAME))
+      itemindexes[i] = MSOGR_LABELTEXTINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELANGLENAME))
+      itemindexes[i] = MSOGR_LABELANGLEINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELFCOLORNAME))
+      itemindexes[i] = MSOGR_LABELFCOLORINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELBCOLORNAME))
+      itemindexes[i] = MSOGR_LABELBCOLORINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELPLACEMENTNAME))
+      itemindexes[i] = MSOGR_LABELPLACEMENTINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELANCHORNAME))
+      itemindexes[i] = MSOGR_LABELANCHORINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELDXNAME))
+      itemindexes[i] = MSOGR_LABELDXINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELDYNAME))
+      itemindexes[i] = MSOGR_LABELDYINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELPERPNAME))
+      itemindexes[i] = MSOGR_LABELPERPINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELBOLDNAME))
+      itemindexes[i] = MSOGR_LABELBOLDINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELITALICNAME))
+      itemindexes[i] = MSOGR_LABELITALICINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELUNDERLINENAME))
+      itemindexes[i] = MSOGR_LABELUNDERLINEINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELPRIORITYNAME))
+      itemindexes[i] = MSOGR_LABELPRIORITYINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELSTRIKEOUTNAME))
+      itemindexes[i] = MSOGR_LABELSTRIKEOUTINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELSTRETCHNAME))
+      itemindexes[i] = MSOGR_LABELSTRETCHINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELADJHORNAME))
+      itemindexes[i] = MSOGR_LABELADJHORINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELADJVERTNAME))
+      itemindexes[i] = MSOGR_LABELADJVERTINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELHCOLORNAME))
+      itemindexes[i] = MSOGR_LABELHCOLORINDEX;
+    else if (EQUAL(layer->items[i], MSOGR_LABELOCOLORNAME))
+      itemindexes[i] = MSOGR_LABELOCOLORINDEX;
+    else if (EQUALN(layer->items[i], MSOGR_LABELPARAMNAME,
+                    MSOGR_LABELPARAMNAMELEN))
+      itemindexes[i] = MSOGR_LABELPARAMINDEX +
+                       atoi(layer->items[i] + MSOGR_LABELPARAMNAMELEN);
+    else if (EQUALN(layer->items[i], MSOGR_BRUSHPARAMNAME,
+                    MSOGR_BRUSHPARAMNAMELEN))
+      itemindexes[i] = MSOGR_BRUSHPARAMINDEX +
+                       atoi(layer->items[i] + MSOGR_BRUSHPARAMNAMELEN);
+    else if (EQUALN(layer->items[i], MSOGR_PENPARAMNAME, MSOGR_PENPARAMNAMELEN))
+      itemindexes[i] =
+          MSOGR_PENPARAMINDEX + atoi(layer->items[i] + MSOGR_PENPARAMNAMELEN);
+    else if (EQUALN(layer->items[i], MSOGR_SYMBOLPARAMNAME,
+                    MSOGR_SYMBOLPARAMNAMELEN))
+      itemindexes[i] = MSOGR_SYMBOLPARAMINDEX +
+                       atoi(layer->items[i] + MSOGR_SYMBOLPARAMNAMELEN);
+    else {
+      itemindexes[i] = OGR_FD_GetFieldIndex(hDefn, layer->items[i]);
+      if (itemindexes[i] == -1) {
+        if (EQUAL(layer->items[i], OGR_L_GetFIDColumn(psInfo->hLayer))) {
+          itemindexes[i] = MSOGR_FID_INDEX;
+        }
+      }
+    }
+    if (itemindexes[i] == -1) {
+      msSetError(MS_OGRERR, "Invalid Field name: %s in layer `%s'",
+                 "msOGRLayerInitItemInfo()", layer->items[i],
+                 layer->name ? layer->name : "(null)");
+      return (MS_FAILURE);
+    }
+  }
+
+  return (MS_SUCCESS);
+}
+
+/**********************************************************************
+ *                     msOGRLayerFreeItemInfo()
+ *
+ * Free the itemindexes array in a layer.
+ **********************************************************************/
+void msOGRLayerFreeItemInfo(layerObj *layer) {
+
+  if (layer->iteminfo)
+    free(layer->iteminfo);
+  layer->iteminfo = NULL;
+}
+
+/**********************************************************************
+ *                     msOGRLayerNextShape()
+ *
+ * Returns shape sequentially from OGR data source.
+ * msOGRLayerWhichShape() must have been called first.
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+int msOGRLayerNextShape(layerObj *layer, shapeObj *shape) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int status;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerNextShape()");
+    return (MS_FAILURE);
+  }
+
+  if (layer->tileindex == NULL)
+    return msOGRFileNextShape(layer, shape, psInfo);
+
+  // Do we need to load the first tile?
+  if (psInfo->poCurTile == NULL) {
+    status = msOGRFileReadTile(layer, psInfo);
+    if (status != MS_SUCCESS)
+      return status;
+  }
+
+  do {
+    // Try getting a shape from this tile.
+    status = msOGRFileNextShape(layer, shape, psInfo->poCurTile);
+    if (status != MS_DONE) {
+      if (psInfo->sTileProj.numargs > 0) {
+        msProjectShape(&(psInfo->sTileProj), &(layer->projection), shape);
+      }
+
+      return status;
+    }
+
+    // try next tile.
+    status = msOGRFileReadTile(layer, psInfo);
+    if (status != MS_SUCCESS)
+      return status;
+  } while (status == MS_SUCCESS);
+  return status; // make compiler happy. this is never reached however
+}
+
+/**********************************************************************
+ *                     msOGRLayerGetShape()
+ *
+ * Returns shape from OGR data source by fid.
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+
+  long shapeindex = record->shapeindex;
+  int tileindex = record->tileindex;
+  int resultindex = record->resultindex;
+  int record_is_fid = TRUE;
+
+  /* set the resultindex as shapeindex if available */
+  if (resultindex >= 0) {
+    record_is_fid = FALSE;
+    shapeindex = resultindex;
+  }
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerGetShape()");
+    return (MS_FAILURE);
+  }
+
+  if (layer->tileindex == NULL)
+    return msOGRFileGetShape(layer, shape, shapeindex, psInfo, record_is_fid);
+  else {
+    if (psInfo->poCurTile == NULL || psInfo->poCurTile->nTileId != tileindex) {
+      if (msOGRFileReadTile(layer, psInfo, tileindex) != MS_SUCCESS)
+        return MS_FAILURE;
+    }
+
+    int status = msOGRFileGetShape(layer, shape, shapeindex, psInfo->poCurTile,
+                                   record_is_fid);
+    if (status == MS_SUCCESS && psInfo->sTileProj.numargs > 0) {
+      msProjectShape(&(psInfo->sTileProj), &(layer->projection), shape);
+    }
+    return status;
+  }
+}
+
+/**********************************************************************
+ *                     msOGRLayerGetExtent()
+ *
+ * Returns the layer extents.
+ *
+ * Returns MS_SUCCESS/MS_FAILURE
+ **********************************************************************/
+int msOGRLayerGetExtent(layerObj *layer, rectObj *extent) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  OGREnvelope oExtent;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerGetExtent()");
+    return (MS_FAILURE);
+  }
+
+  /* ------------------------------------------------------------------
+   * Call OGR's GetExtent()... note that for some formats this will
+   * result in a scan of the whole layer and can be an expensive call.
+   *
+   * For tile indexes layers we assume it is sufficient to get the
+   * extents of the tile index.
+   * ------------------------------------------------------------------ */
+  ACQUIRE_OGR_LOCK;
+  if (OGR_L_GetExtent(psInfo->hLayer, &oExtent, TRUE) != OGRERR_NONE) {
+    RELEASE_OGR_LOCK;
+    msSetError(MS_MISCERR, "Unable to get extents for this layer.",
+               "msOGRLayerGetExtent()");
+    return (MS_FAILURE);
+  }
+  RELEASE_OGR_LOCK;
+
+  extent->minx = oExtent.MinX;
+  extent->miny = oExtent.MinY;
+  extent->maxx = oExtent.MaxX;
+  extent->maxy = oExtent.MaxY;
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGRLayerGetNumFeatures()
+ *
+ * Returns the layer feature count.
+ *
+ * Returns the number of features on success, -1 on error
+ **********************************************************************/
+int msOGRLayerGetNumFeatures(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int result;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerGetNumFeatures()");
+    return -1;
+  }
+
+  /* ------------------------------------------------------------------
+   * Call OGR's GetFeatureCount()... note that for some formats this will
+   * result in a scan of the whole layer and can be an expensive call.
+   * ------------------------------------------------------------------ */
+  ACQUIRE_OGR_LOCK;
+  result = (int)OGR_L_GetFeatureCount(psInfo->hLayer, TRUE);
+  RELEASE_OGR_LOCK;
+
+  return result;
+}
+
+/**********************************************************************
+ *                     msOGRGetSymbolId()
+ *
+ * Returns a MapServer symbol number matching one of the symbols from
+ * the OGR symbol id string.  If not found then try to locate the
+ * default symbol name, and if not found return 0.
+ **********************************************************************/
+static int msOGRGetSymbolId(symbolSetObj *symbolset, const char *pszSymbolId,
+                            const char *pszDefaultSymbol,
+                            int try_addimage_if_notfound) {
+  // Symbol name mapping:
+  // First look for the native symbol name, then the ogr-...
+  // generic name, and in last resort try pszDefaultSymbol if
+  // provided by user.
+  char **params;
+  int numparams;
+  int nSymbol = -1;
+
+  if (pszSymbolId && pszSymbolId[0] != '\0') {
+    params = msStringSplit(pszSymbolId, ',', &numparams);
+    if (params != NULL) {
+      for (int j = 0; j < numparams && nSymbol == -1; j++) {
+        nSymbol =
+            msGetSymbolIndex(symbolset, params[j], try_addimage_if_notfound);
+      }
+      msFreeCharArray(params, numparams);
+    }
+  }
+  if (nSymbol == -1 && pszDefaultSymbol) {
+    nSymbol = msGetSymbolIndex(symbolset, (char *)pszDefaultSymbol,
+                               try_addimage_if_notfound);
+  }
+  if (nSymbol == -1)
+    nSymbol = 0;
+
+  return nSymbol;
+}
+
+static int msOGRUpdateStyleParseLabel(mapObj *map, layerObj *layer, classObj *c,
+                                      OGRStyleToolH hLabelStyle);
+static int msOGRUpdateStyleParsePen(mapObj *map, layerObj *layer, styleObj *s,
+                                    OGRStyleToolH hPenStyle, int bIsBrush,
+                                    int *pbPriority);
+static int msOGRUpdateStyleParseBrush(mapObj *map, layerObj *layer, styleObj *s,
+                                      OGRStyleToolH hBrushStyle, int *pbIsBrush,
+                                      int *pbPriority);
+static int msOGRUpdateStyleParseSymbol(mapObj *map, styleObj *s,
+                                       OGRStyleToolH hSymbolStyle,
+                                       int *pbPriority);
+static int msOGRAddBgColorStyleParseBrush(styleObj *s,
+                                          OGRStyleToolH hSymbolStyle);
+
+static int msOGRUpdateStyleCheckPenBrushOnly(OGRStyleMgrH hStyleMgr) {
+  int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
+  int countPen = 0, countBrush = 0;
+  int bIsNull;
+
+  for (int i = 0; i < numParts; i++) {
+    OGRSTClassId eStylePartType;
+    OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
+    if (!hStylePart)
+      continue;
+
+    eStylePartType = OGR_ST_GetType(hStylePart);
+    if (eStylePartType == OGRSTCPen) {
+      countPen++;
+      OGR_ST_GetParamNum(hStylePart, OGRSTPenPriority, &bIsNull);
+      if (!bIsNull) {
+        OGR_ST_Destroy(hStylePart);
+        return MS_FALSE;
+      }
+    } else if (eStylePartType == OGRSTCBrush) {
+      countBrush++;
+      OGR_ST_GetParamNum(hStylePart, OGRSTBrushPriority, &bIsNull);
+      if (!bIsNull) {
+        OGR_ST_Destroy(hStylePart);
+        return MS_FALSE;
+      }
+    } else if (eStylePartType == OGRSTCSymbol) {
+      OGR_ST_Destroy(hStylePart);
+      return MS_FALSE;
+    }
+    OGR_ST_Destroy(hStylePart);
+  }
+  return (countPen == 1 && countBrush == 1);
+}
+
+/**********************************************************************
+ *                     msOGRUpdateStyle()
+ *
+ * Update the mapserver style according to the ogr style.
+ * The function is called by msOGRGetAutoStyle and
+ * msOGRUpdateStyleFromString
+ **********************************************************************/
+
+typedef struct {
+  int nPriority; /* the explicit priority as specified by the 'l' option of PEN,
+                    BRUSH and SYMBOL tools */
+  int nApparitionIndex; /* the index of the tool as parsed from the OGR feature
+                           style string */
+} StyleSortStruct;
+
+static int msOGRUpdateStyleSortFct(const void *pA, const void *pB) {
+  StyleSortStruct *sssa = (StyleSortStruct *)pA;
+  StyleSortStruct *sssb = (StyleSortStruct *)pB;
+  if (sssa->nPriority < sssb->nPriority)
+    return -1;
+  else if (sssa->nPriority > sssb->nPriority)
+    return 1;
+  else if (sssa->nApparitionIndex < sssb->nApparitionIndex)
+    return -1;
+  else
+    return 1;
+}
+
+static int msOGRUpdateStyle(OGRStyleMgrH hStyleMgr, mapObj *map,
+                            layerObj *layer, classObj *c) {
+  int bIsBrush = MS_FALSE;
+  int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
+  int nPriority;
+  int bIsPenBrushOnly = msOGRUpdateStyleCheckPenBrushOnly(hStyleMgr);
+  StyleSortStruct *pasSortStruct =
+      (StyleSortStruct *)msSmallMalloc(sizeof(StyleSortStruct) * numParts);
+  int iSortStruct = 0;
+  int iBaseStyleIndex = c->numstyles;
+  int i;
+
+  /* ------------------------------------------------------------------
+   * Handle each part
+   * ------------------------------------------------------------------ */
+
+  for (i = 0; i < numParts; i++) {
+    OGRSTClassId eStylePartType;
+    OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
+    if (!hStylePart)
+      continue;
+    eStylePartType = OGR_ST_GetType(hStylePart);
+    nPriority = INT_MIN;
+
+    // We want all size values returned in pixels.
+    //
+    // The scale factor that OGR expect is the ground/paper scale
+    // e.g. if 1 ground unit = 0.01 paper unit then scale=1/0.01=100
+    // cellsize if number of ground units/pixel, and OGR assumes that
+    // there is 72*39.37 pixels/ground units (since meter is assumed
+    // for ground... but what ground units we have does not matter
+    // as long as use the same assumptions everywhere)
+    // That gives scale = cellsize*72*39.37
+
+    OGR_ST_SetUnit(hStylePart, OGRSTUPixel,
+                   map->cellsize * map->resolution / map->defresolution * 72.0 *
+                       39.37);
+
+    if (eStylePartType == OGRSTCLabel) {
+      int ret = msOGRUpdateStyleParseLabel(map, layer, c, hStylePart);
+      if (ret != MS_SUCCESS) {
+        OGR_ST_Destroy(hStylePart);
+        msFree(pasSortStruct);
+        return ret;
+      }
+    } else if (eStylePartType == OGRSTCPen) {
+      styleObj *s;
+      int nIndex;
+      if (bIsPenBrushOnly) {
+        /* Historic behaviour when there is a PEN and BRUSH only */
+        if (bIsBrush || layer->type == MS_LAYER_POLYGON)
+          // This is a multipart symbology, so pen defn goes in the
+          // overlaysymbol params
+          nIndex = c->numstyles + 1;
+        else
+          nIndex = c->numstyles;
+      } else
+        nIndex = c->numstyles;
+
+      if (msMaybeAllocateClassStyle(c, nIndex)) {
+        OGR_ST_Destroy(hStylePart);
+        msFree(pasSortStruct);
+        return (MS_FAILURE);
+      }
+      s = c->styles[nIndex];
+
+      msOGRUpdateStyleParsePen(map, layer, s, hStylePart, bIsBrush, &nPriority);
+
+    } else if (eStylePartType == OGRSTCBrush) {
+
+      styleObj *s;
+      int nIndex = 0;
+
+      int bBgColorIsNull = MS_TRUE;
+      OGR_ST_GetParamStr(hStylePart, OGRSTBrushBColor, &bBgColorIsNull);
+
+      if (!bBgColorIsNull) {
+
+        if (msMaybeAllocateClassStyle(c, nIndex)) {
+          OGR_ST_Destroy(hStylePart);
+          msFree(pasSortStruct);
+          return (MS_FAILURE);
+        }
+
+        // add a backgroundcolor as a separate style
+        s = c->styles[nIndex];
+        msOGRAddBgColorStyleParseBrush(s, hStylePart);
+      }
+
+      nIndex = (bIsPenBrushOnly) ? nIndex : c->numstyles;
+
+      if (!bBgColorIsNull) {
+        // if we have a bgcolor style we need to increase the index
+        nIndex += 1;
+      }
+
+      /* We need 1 style */
+      if (msMaybeAllocateClassStyle(c, nIndex)) {
+        OGR_ST_Destroy(hStylePart);
+        msFree(pasSortStruct);
+        return (MS_FAILURE);
+      }
+      s = c->styles[nIndex];
+
+      msOGRUpdateStyleParseBrush(map, layer, s, hStylePart, &bIsBrush,
+                                 &nPriority);
+
+    } else if (eStylePartType == OGRSTCSymbol) {
+      styleObj *s;
+      /* We need 1 style */
+      int nIndex = c->numstyles;
+      if (msMaybeAllocateClassStyle(c, nIndex)) {
+        OGR_ST_Destroy(hStylePart);
+        msFree(pasSortStruct);
+        return (MS_FAILURE);
+      }
+      s = c->styles[nIndex];
+
+      msOGRUpdateStyleParseSymbol(map, s, hStylePart, &nPriority);
+    }
+
+    /* Memorize the explicit priority and apparition order of the parsed
+     * tool/style */
+    if (!bIsPenBrushOnly &&
+        (eStylePartType == OGRSTCPen || eStylePartType == OGRSTCBrush ||
+         eStylePartType == OGRSTCSymbol)) {
+      pasSortStruct[iSortStruct].nPriority = nPriority;
+      pasSortStruct[iSortStruct].nApparitionIndex = iSortStruct;
+      iSortStruct++;
+    }
+
+    OGR_ST_Destroy(hStylePart);
+  }
+
+  if (iSortStruct > 1 && !bIsPenBrushOnly) {
+    /* Compute style order based on their explicit priority and apparition order
+     */
+    qsort(pasSortStruct, iSortStruct, sizeof(StyleSortStruct),
+          msOGRUpdateStyleSortFct);
+
+    /* Now reorder styles in c->styles */
+    styleObj **ppsStyleTmp =
+        (styleObj **)msSmallMalloc(iSortStruct * sizeof(styleObj *));
+    memcpy(ppsStyleTmp, c->styles + iBaseStyleIndex,
+           iSortStruct * sizeof(styleObj *));
+    for (i = 0; i < iSortStruct; i++) {
+      c->styles[iBaseStyleIndex + i] =
+          ppsStyleTmp[pasSortStruct[i].nApparitionIndex];
+    }
+    msFree(ppsStyleTmp);
+  }
+
+  msFree(pasSortStruct);
+
+  return MS_SUCCESS;
+}
+
+static int msOGRUpdateStyleParseLabel(mapObj *map, layerObj *layer, classObj *c,
+                                      OGRStyleToolH hLabelStyle) {
+  int bIsNull;
+  int r = 0, g = 0, b = 0, t = 0;
+
+  // Enclose the text string inside quotes to make sure it is seen
+  // as a string by the parser inside loadExpression(). (bug185)
+  /* See bug 3481 about the isalnum hack */
+  const char *labelTextString =
+      OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelTextString, &bIsNull);
+
+  if (c->numlabels == 0) {
+    /* allocate a new label object */
+    if (msGrowClassLabels(c) == NULL)
+      return MS_FAILURE;
+    c->numlabels++;
+    initLabel(c->labels[0]);
+  }
+  msFreeExpression(&c->labels[0]->text);
+  c->labels[0]->text.type = MS_STRING;
+  c->labels[0]->text.string = msStrdup(labelTextString);
+
+  c->labels[0]->angle =
+      OGR_ST_GetParamDbl(hLabelStyle, OGRSTLabelAngle, &bIsNull);
+
+  c->labels[0]->size =
+      OGR_ST_GetParamDbl(hLabelStyle, OGRSTLabelSize, &bIsNull);
+  if (c->labels[0]->size < 1) /* no point dropping to zero size */
+    c->labels[0]->size = 1;
+
+  // OGR default is anchor point = LL, so label is at UR of anchor
+  c->labels[0]->position = MS_UR;
+
+  int nPosition = OGR_ST_GetParamNum(hLabelStyle, OGRSTLabelAnchor, &bIsNull);
+  if (!bIsNull) {
+    switch (nPosition) {
+    case 1:
+      c->labels[0]->position = MS_UR;
+      break;
+    case 2:
+      c->labels[0]->position = MS_UC;
+      break;
+    case 3:
+      c->labels[0]->position = MS_UL;
+      break;
+    case 4:
+      c->labels[0]->position = MS_CR;
+      break;
+    case 5:
+      c->labels[0]->position = MS_CC;
+      break;
+    case 6:
+      c->labels[0]->position = MS_CL;
+      break;
+    case 7:
+      c->labels[0]->position = MS_LR;
+      break;
+    case 8:
+      c->labels[0]->position = MS_LC;
+      break;
+    case 9:
+      c->labels[0]->position = MS_LL;
+      break;
+    case 10:
+      c->labels[0]->position = MS_UR;
+      break; /*approximate*/
+    case 11:
+      c->labels[0]->position = MS_UC;
+      break;
+    case 12:
+      c->labels[0]->position = MS_UL;
+      break;
+    default:
+      break;
+    }
+  }
+
+  const char *pszColor =
+      OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hLabelStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(c->labels[0]->color, r, g, b, t);
+  }
+
+  pszColor = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelHColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hLabelStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(c->labels[0]->shadowcolor, r, g, b, t);
+  }
+
+  pszColor = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelOColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hLabelStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(c->labels[0]->outlinecolor, r, g, b, t);
+  }
+
+  const char *pszBold =
+      OGR_ST_GetParamNum(hLabelStyle, OGRSTLabelBold, &bIsNull) ? "-bold" : "";
+  const char *pszItalic =
+      OGR_ST_GetParamNum(hLabelStyle, OGRSTLabelItalic, &bIsNull) ? "-italic"
+                                                                  : "";
+  const char *pszFontName =
+      OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFontName, &bIsNull);
+  /* replace spaces with hyphens to allow mapping to a valid hashtable entry*/
+  char *pszFontNameEscaped = NULL;
+  if (pszFontName != NULL) {
+    pszFontNameEscaped = msStrdup(pszFontName);
+    msReplaceChar(pszFontNameEscaped, ' ', '-');
+  }
+
+  bool bFont = true;
+
+  if (pszFontNameEscaped != NULL && !bIsNull && pszFontNameEscaped[0] != '\0') {
+    const char *pszName =
+        CPLSPrintf("%s%s%s", pszFontNameEscaped, pszBold, pszItalic);
+    if (msLookupHashTable(&(map->fontset.fonts), (char *)pszName) != NULL) {
+      c->labels[0]->font = msStrdup(pszName);
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** Using '%s' TTF font **\n", pszName);
+    } else if ((strcmp(pszFontNameEscaped, pszName) != 0) &&
+               msLookupHashTable(&(map->fontset.fonts),
+                                 (char *)pszFontNameEscaped) != NULL) {
+      c->labels[0]->font = msStrdup(pszFontNameEscaped);
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** Using '%s' TTF font **\n", pszFontNameEscaped);
+    } else if (msLookupHashTable(&(map->fontset.fonts), "default") != NULL) {
+      c->labels[0]->font = msStrdup("default");
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** Using 'default' TTF font **\n");
+    } else
+      bFont = false;
+  }
+
+  msFree(pszFontNameEscaped);
+
+  if (!bFont) {
+    c->labels[0]->size = MS_MEDIUM;
+  }
+
+  return MS_SUCCESS;
+}
+
+static int msOGRUpdateStyleParsePen(mapObj *map, layerObj *layer, styleObj *s,
+                                    OGRStyleToolH hPenStyle, int bIsBrush,
+                                    int *pbPriority) {
+  int bIsNull;
+  int r = 0, g = 0, b = 0, t = 0;
+
+  const char *pszPenName, *pszPattern, *pszCap, *pszJoin;
+  colorObj oPenColor;
+  int nPenSymbol = 0;
+  int nPenSize = 1;
+  t = -1;
+  double pattern[MS_MAXPATTERNLENGTH];
+  int patternlength = 0;
+  int linecap = MS_CJC_DEFAULT_CAPS;
+  int linejoin = MS_CJC_DEFAULT_JOINS;
+  double offsetx = 0.0;
+  double offsety = 0.0;
+
+  // Make sure pen is always initialized
+  MS_INIT_COLOR(oPenColor, -1, -1, -1, 255);
+
+  pszPenName = OGR_ST_GetParamStr(hPenStyle, OGRSTPenId, &bIsNull);
+  if (bIsNull)
+    pszPenName = NULL;
+  // Check for Pen Pattern "ogr-pen-1": the invisible pen
+  // If that's what we have then set pen color to -1
+  if (pszPenName && strstr(pszPenName, "ogr-pen-1") != NULL) {
+    MS_INIT_COLOR(oPenColor, -1, -1, -1, 255);
+  } else {
+    const char *pszColor =
+        OGR_ST_GetParamStr(hPenStyle, OGRSTPenColor, &bIsNull);
+    if (!bIsNull &&
+        OGR_ST_GetRGBFromString(hPenStyle, pszColor, &r, &g, &b, &t)) {
+      MS_INIT_COLOR(oPenColor, r, g, b, t);
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** PEN COLOR = %d %d %d **\n", r, g, b);
+    }
+
+    nPenSize = OGR_ST_GetParamNum(hPenStyle, OGRSTPenWidth, &bIsNull);
+    if (bIsNull)
+      nPenSize = 1;
+    if (pszPenName != NULL) {
+      // Try to match pen name in symbol file
+      nPenSymbol =
+          msOGRGetSymbolId(&(map->symbolset), pszPenName, NULL, MS_FALSE);
+    }
+  }
+
+  if (layer->debug >= MS_DEBUGLEVEL_VVV)
+    msDebug("** PEN COLOR = %d %d %d **\n", oPenColor.red, oPenColor.green,
+            oPenColor.blue);
+
+  pszPattern = OGR_ST_GetParamStr(hPenStyle, OGRSTPenPattern, &bIsNull);
+  if (bIsNull)
+    pszPattern = NULL;
+  if (pszPattern != NULL) {
+    char **papszTokens =
+        CSLTokenizeStringComplex(pszPattern, " ", FALSE, FALSE);
+    int nTokenCount = CSLCount(papszTokens);
+    int bValidFormat = TRUE;
+    if (nTokenCount >= 2 && nTokenCount <= MS_MAXPATTERNLENGTH) {
+      for (int i = 0; i < nTokenCount; i++) {
+        if (strlen(papszTokens[i]) > 2 &&
+            strcmp(papszTokens[i] + strlen(papszTokens[i]) - 2, "px") == 0) {
+          pattern[patternlength++] = CPLAtof(papszTokens[i]);
+        } else {
+          bValidFormat = FALSE;
+          patternlength = 0;
+          break;
+        }
+      }
+    } else
+      bValidFormat = FALSE;
+    if (!bValidFormat && layer->debug >= MS_DEBUGLEVEL_VVV)
+      msDebug("Invalid/unhandled pen pattern format = %s\n", pszPattern);
+    CSLDestroy(papszTokens);
+  }
+
+  pszCap = OGR_ST_GetParamStr(hPenStyle, OGRSTPenCap, &bIsNull);
+  if (bIsNull)
+    pszCap = NULL;
+  if (pszCap != NULL) {
+    /* Note: the default in OGR Feature style is BUTT, but the MapServer */
+    /* default is ROUND. Currently use MapServer default. */
+    if (strcmp(pszCap, "b") == 0) /* BUTT */
+      linecap = MS_CJC_BUTT;
+    else if (strcmp(pszCap, "r") == 0) /* ROUND */
+      linecap = MS_CJC_ROUND;
+    else if (strcmp(pszCap, "p") == 0) /* PROJECTING */
+      linecap = MS_CJC_SQUARE;
+    else if (layer->debug >= MS_DEBUGLEVEL_VVV)
+      msDebug("Invalid/unhandled pen cap = %s\n", pszCap);
+  }
+
+  pszJoin = OGR_ST_GetParamStr(hPenStyle, OGRSTPenJoin, &bIsNull);
+  if (bIsNull)
+    pszJoin = NULL;
+  if (pszJoin != NULL) {
+    /* Note: the default in OGR Feature style is MITER, but the MapServer */
+    /* default is NONE. Currently use MapServer default. */
+    if (strcmp(pszJoin, "m") == 0) /* MITTER */
+      linejoin = MS_CJC_MITER;
+    else if (strcmp(pszJoin, "r") == 0) /* ROUND */
+      linejoin = MS_CJC_ROUND;
+    else if (strcmp(pszJoin, "b") == 0) /* BEVEL */
+      linejoin = MS_CJC_BEVEL;
+    else if (layer->debug >= MS_DEBUGLEVEL_VVV)
+      msDebug("Invalid/unhandled pen join = %s\n", pszJoin);
+  }
+
+  offsetx = OGR_ST_GetParamDbl(hPenStyle, OGRSTPenPerOffset, &bIsNull);
+  if (bIsNull)
+    offsetx = 0;
+  if (offsetx != 0.0) {
+    /* OGR feature style and MapServer conventions related to offset */
+    /* sign are the same : negative values for left of line, positive for */
+    /* right of line */
+    offsety = MS_STYLE_SINGLE_SIDED_OFFSET;
+  }
+
+  if (bIsBrush || layer->type == MS_LAYER_POLYGON) {
+    // This is a multipart symbology, so pen defn goes in the
+    // overlaysymbol params
+    s->outlinecolor = oPenColor;
+  } else {
+    // Single part symbology
+    s->color = oPenColor;
+  }
+
+  s->symbol = nPenSymbol;
+  s->size = nPenSize;
+  s->width = nPenSize;
+  s->linecap = linecap;
+  s->linejoin = linejoin;
+  s->offsetx = offsetx;
+  s->offsety = offsety;
+  s->patternlength = patternlength;
+  if (patternlength > 0)
+    memcpy(s->pattern, pattern, sizeof(double) * patternlength);
+
+  int nPriority = OGR_ST_GetParamNum(hPenStyle, OGRSTPenPriority, &bIsNull);
+  if (!bIsNull)
+    *pbPriority = nPriority;
+
+  return MS_SUCCESS;
+}
+
+static int msOGRAddBgColorStyleParseBrush(styleObj *s,
+                                          OGRStyleToolH hBrushStyle) {
+  int bIsNull;
+  int r = 0, g = 0, b = 0, t = 0;
+  const char *pszColor =
+      OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushBColor, &bIsNull);
+
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hBrushStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(s->color, r, g, b, t);
+  }
+  return MS_SUCCESS;
+}
+
+static int msOGRUpdateStyleParseBrush(mapObj *map, layerObj *layer, styleObj *s,
+                                      OGRStyleToolH hBrushStyle, int *pbIsBrush,
+                                      int *pbPriority) {
+  int bIsNull;
+  int r = 0, g = 0, b = 0, t = 0;
+
+  const char *pszBrushName =
+      OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushId, &bIsNull);
+  if (bIsNull)
+    pszBrushName = NULL;
+
+  // Check for Brush Pattern "ogr-brush-1": the invisible fill
+  // If that's what we have then set fill color to -1
+  if (pszBrushName && strstr(pszBrushName, "ogr-brush-1") != NULL) {
+    MS_INIT_COLOR(s->color, -1, -1, -1, 255);
+  } else {
+    *pbIsBrush = TRUE;
+    const char *pszColor =
+        OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushFColor, &bIsNull);
+    if (!bIsNull &&
+        OGR_ST_GetRGBFromString(hBrushStyle, pszColor, &r, &g, &b, &t)) {
+      MS_INIT_COLOR(s->color, r, g, b, t);
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** BRUSH COLOR = %d %d %d **\n", r, g, b);
+    }
+
+    // Symbol name mapping:
+    // First look for the native symbol name, then the ogr-...
+    // generic name.
+    // If none provided or found then use 0: solid fill
+
+    const char *pszName =
+        OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushId, &bIsNull);
+    s->symbol = msOGRGetSymbolId(&(map->symbolset), pszName, NULL, MS_FALSE);
+
+    double angle = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushAngle, &bIsNull);
+    if (!bIsNull)
+      s->angle = angle;
+
+    double size = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushSize, &bIsNull);
+    if (!bIsNull)
+      s->size = size;
+
+    double spacingx = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDx, &bIsNull);
+    if (!bIsNull) {
+      double spacingy = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDy, &bIsNull);
+      if (!bIsNull) {
+        if (spacingx == spacingy)
+          s->gap = spacingx;
+        else if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug("Ignoring brush dx and dy since they don't have the same "
+                  "value\n");
+      }
+    }
+  }
+
+  int nPriority = OGR_ST_GetParamNum(hBrushStyle, OGRSTBrushPriority, &bIsNull);
+  if (!bIsNull)
+    *pbPriority = nPriority;
+
+  return MS_SUCCESS;
+}
+
+static int msOGRUpdateStyleParseSymbol(mapObj *map, styleObj *s,
+                                       OGRStyleToolH hSymbolStyle,
+                                       int *pbPriority) {
+  int bIsNull;
+  int r = 0, g = 0, b = 0, t = 0;
+
+  const char *pszColor =
+      OGR_ST_GetParamStr(hSymbolStyle, OGRSTSymbolColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hSymbolStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(s->color, r, g, b, t);
+  }
+
+  pszColor = OGR_ST_GetParamStr(hSymbolStyle, OGRSTSymbolOColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hSymbolStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(s->outlinecolor, r, g, b, t);
+  }
+
+  s->angle = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolAngle, &bIsNull);
+  double dfTmp = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolSize, &bIsNull);
+  if (!bIsNull)
+    s->size = dfTmp;
+
+  // Symbol name mapping:
+  // First look for the native symbol name, then the ogr-...
+  // generic name, and in last resort try "default-marker" if
+  // provided by user.
+  const char *pszName =
+      OGR_ST_GetParamStr(hSymbolStyle, OGRSTSymbolId, &bIsNull);
+  if (bIsNull)
+    pszName = NULL;
+
+  int try_addimage_if_notfound = MS_FALSE;
+#ifdef USE_CURL
+  if (pszName && strncasecmp(pszName, "http", 4) == 0)
+    try_addimage_if_notfound = MS_TRUE;
+#endif
+  if (!s->symbolname)
+    s->symbol = msOGRGetSymbolId(&(map->symbolset), pszName, "default-marker",
+                                 try_addimage_if_notfound);
+
+  int nPriority =
+      OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolPriority, &bIsNull);
+  if (!bIsNull)
+    *pbPriority = nPriority;
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                     msOGRLayerGetAutoStyle()
+ *
+ * Fills a classObj with style info from the specified shape.
+ * For optimal results, this should be called immediately after
+ * GetNextShape() or GetShape() so that the shape doesn't have to be read
+ * twice.
+ *
+ * The returned classObj is a ref. to a static structure valid only until
+ * the next call and that shouldn't be freed by the caller.
+ **********************************************************************/
+static int msOGRLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                  shapeObj *shape) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerGetAutoStyle()");
+    return (MS_FAILURE);
+  }
+
+  if (layer->tileindex != NULL) {
+    if ((psInfo->poCurTile == NULL ||
+         shape->tileindex != psInfo->poCurTile->nTileId) &&
+        msOGRFileReadTile(layer, psInfo) != MS_SUCCESS)
+      return MS_FAILURE;
+
+    psInfo = psInfo->poCurTile;
+  }
+
+  /* ------------------------------------------------------------------
+   * Read shape or reuse ref. to last shape read.
+   * ------------------------------------------------------------------ */
+  ACQUIRE_OGR_LOCK;
+  if (psInfo->hLastFeature == NULL ||
+      psInfo->last_record_index_read != shape->resultindex) {
+    RELEASE_OGR_LOCK;
+    msSetError(MS_MISCERR,
+               "Assertion failed: AutoStyle not requested on loaded shape.",
+               "msOGRLayerGetAutoStyle()");
+    return (MS_FAILURE);
+  }
+
+  /* ------------------------------------------------------------------
+   * Reset style info in the class to defaults
+   * the only members we don't touch are name, expression, and join/query stuff
+   * ------------------------------------------------------------------ */
+  resetClassStyle(c);
+  if (msMaybeAllocateClassStyle(c, 0)) {
+    RELEASE_OGR_LOCK;
+    return (MS_FAILURE);
+  }
+
+  // __TODO__ label cache incompatible with styleitem feature.
+  layer->labelcache = MS_OFF;
+
+  int nRetVal = MS_SUCCESS;
+  if (psInfo->hLastFeature) {
+    OGRStyleMgrH hStyleMgr = OGR_SM_Create(NULL);
+    OGR_SM_InitFromFeature(hStyleMgr, psInfo->hLastFeature);
+    nRetVal = msOGRUpdateStyle(hStyleMgr, map, layer, c);
+    OGR_SM_Destroy(hStyleMgr);
+  }
+
+  RELEASE_OGR_LOCK;
+  return nRetVal;
+}
+
+/**********************************************************************
+ *                     msOGRUpdateStyleFromString()
+ *
+ * Fills a classObj with style info from the specified style string.
+ * For optimal results, this should be called immediately after
+ * GetNextShape() or GetShape() so that the shape doesn't have to be read
+ * twice.
+ *
+ * The returned classObj is a ref. to a static structure valid only until
+ * the next call and that shouldn't be freed by the caller.
+ **********************************************************************/
+int msOGRUpdateStyleFromString(mapObj *map, layerObj *layer, classObj *c,
+                               const char *stylestring) {
+  /* ------------------------------------------------------------------
+   * Reset style info in the class to defaults
+   * the only members we don't touch are name, expression, and join/query stuff
+   * ------------------------------------------------------------------ */
+  resetClassStyle(c);
+  if (msMaybeAllocateClassStyle(c, 0)) {
+    return (MS_FAILURE);
+  }
+
+  // __TODO__ label cache incompatible with styleitem feature.
+  layer->labelcache = MS_OFF;
+
+  int nRetVal = MS_SUCCESS;
+
+  ACQUIRE_OGR_LOCK;
+
+  OGRStyleMgrH hStyleMgr = OGR_SM_Create(NULL);
+  OGR_SM_InitStyleString(hStyleMgr, stylestring);
+  nRetVal = msOGRUpdateStyle(hStyleMgr, map, layer, c);
+  OGR_SM_Destroy(hStyleMgr);
+
+  RELEASE_OGR_LOCK;
+  return nRetVal;
+}
+
+/************************************************************************/
+/*                           msOGRLCleanup()                            */
+/************************************************************************/
+
+void msOGRCleanup(void)
+
+{
+  ACQUIRE_OGR_LOCK;
+  if (bOGRDriversRegistered == MS_TRUE) {
+    CPLPopErrorHandler();
+    bOGRDriversRegistered = MS_FALSE;
+  }
+  RELEASE_OGR_LOCK;
+}
+
+/************************************************************************/
+/*                           msOGREscapeSQLParam                        */
+/************************************************************************/
+char *msOGREscapePropertyName(layerObj *layer, const char *pszString) {
+  char *pszEscapedStr = NULL;
+  if (layer && pszString && strlen(pszString) > 0) {
+    pszEscapedStr = (char *)msSmallMalloc(strlen(pszString) * 2 + 1);
+    int j = 0;
+    for (int i = 0; pszString[i] != '\0'; ++i) {
+      if (pszString[i] == '"') {
+        pszEscapedStr[j++] = '"';
+        pszEscapedStr[j++] = '"';
+      } else
+        pszEscapedStr[j++] = pszString[i];
+    }
+    pszEscapedStr[j] = 0;
+  }
+  return pszEscapedStr;
+}
+
+static int msOGRLayerSupportsCommonFilters(layerObj *) { return MS_FALSE; }
+
+static void msOGREnablePaging(layerObj *layer, int value) {
+  msOGRFileInfo *layerinfo = NULL;
+
+  if (layer->debug) {
+    msDebug("msOGREnablePaging(%d) called.\n", value);
+  }
+
+  if (!msOGRLayerIsOpen(layer)) {
+    if (msOGRLayerOpenVT(layer) != MS_SUCCESS) {
+      return;
+    }
+  }
+
+  assert(layer->layerinfo != NULL);
+
+  layerinfo = (msOGRFileInfo *)layer->layerinfo;
+  layerinfo->bPaging = value;
+}
+
+static int msOGRGetPaging(layerObj *layer) {
+  msOGRFileInfo *layerinfo = NULL;
+
+  if (layer->debug) {
+    msDebug("msOGRGetPaging called.\n");
+  }
+
+  if (!msOGRLayerIsOpen(layer)) {
+    if (msOGRLayerOpenVT(layer) != MS_SUCCESS) {
+      return FALSE;
+    }
+  }
+
+  assert(layer->layerinfo != NULL);
+
+  layerinfo = (msOGRFileInfo *)layer->layerinfo;
+  return layerinfo->bPaging;
+}
+
+/************************************************************************/
+/*                  msOGRLayerInitializeVirtualTable()                  */
+/************************************************************************/
+int msOGRLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerTranslateFilter = msOGRTranslateMsExpressionToOGRSQL;
+
+  layer->vtable->LayerSupportsCommonFilters = msOGRLayerSupportsCommonFilters;
+  layer->vtable->LayerInitItemInfo = msOGRLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msOGRLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msOGRLayerOpenVT;
+  layer->vtable->LayerIsOpen = msOGRLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msOGRLayerWhichShapes;
+  layer->vtable->LayerNextShape = msOGRLayerNextShape;
+  layer->vtable->LayerGetShape = msOGRLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msOGRLayerClose;
+  layer->vtable->LayerGetItems = msOGRLayerGetItems;
+  layer->vtable->LayerGetExtent = msOGRLayerGetExtent;
+  layer->vtable->LayerGetAutoStyle = msOGRLayerGetAutoStyle;
+  /* layer->vtable->LayerCloseConnection, use default */
+  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  layer->vtable->LayerGetNumFeatures = msOGRLayerGetNumFeatures;
+  /* layer->vtable->LayerGetAutoProjection, use defaut*/
+
+  layer->vtable->LayerEscapeSQLParam = msOGREscapeSQLParam;
+  layer->vtable->LayerEscapePropertyName = msOGREscapePropertyName;
+  layer->vtable->LayerEnablePaging = msOGREnablePaging;
+  layer->vtable->LayerGetPaging = msOGRGetPaging;
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                         msOGRShapeFromWKT()                          */
+/************************************************************************/
+shapeObj *msOGRShapeFromWKT(const char *string) {
+
+  OGRGeometryH hGeom = NULL;
+  shapeObj *shape = NULL;
+
+  if (!string)
+    return NULL;
+
+  if (OGR_G_CreateFromWkt((char **)&string, NULL, &hGeom) != OGRERR_NONE) {
+    msSetError(MS_OGRERR, "Failed to parse WKT string.", "msOGRShapeFromWKT()");
+    return NULL;
+  }
+
+  /* Initialize a corresponding shapeObj */
+
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
+  msInitShape(shape);
+
+  /* translate WKT into an OGRGeometry. */
+
+  if (msOGRGeometryToShape(hGeom, shape,
+                           wkbFlatten(OGR_G_GetGeometryType(hGeom))) ==
+      MS_FAILURE) {
+    msFreeShape(shape);
+    free(shape);
+    shape = NULL;
+  }
+
+  OGR_G_DestroyGeometry(hGeom);
+
+  return shape;
+}
+
+/************************************************************************/
+/*                          msOGRShapeToWKT()                           */
+/************************************************************************/
+char *msOGRShapeToWKT(shapeObj *shape) {
+  OGRGeometryH hGeom = NULL;
+  int i;
+  char *wkt = NULL;
+
+  if (!shape)
+    return NULL;
+
+  if (shape->type == MS_SHAPE_POINT && shape->numlines == 1 &&
+      shape->line[0].numpoints == 1) {
+    hGeom = OGR_G_CreateGeometry(wkbPoint);
+    OGR_G_SetPoint_2D(hGeom, 0, shape->line[0].point[0].x,
+                      shape->line[0].point[0].y);
+  } else if (shape->type == MS_SHAPE_POINT && shape->numlines == 1 &&
+             shape->line[0].numpoints > 1) {
+    hGeom = OGR_G_CreateGeometry(wkbMultiPoint);
+    for (i = 0; i < shape->line[0].numpoints; i++) {
+      OGRGeometryH hPoint;
+
+      hPoint = OGR_G_CreateGeometry(wkbPoint);
+      OGR_G_SetPoint_2D(hPoint, 0, shape->line[0].point[i].x,
+                        shape->line[0].point[i].y);
+      OGR_G_AddGeometryDirectly(hGeom, hPoint);
+    }
+  } else if (shape->type == MS_SHAPE_LINE && shape->numlines == 1) {
+    hGeom = OGR_G_CreateGeometry(wkbLineString);
+    for (i = 0; i < shape->line[0].numpoints; i++) {
+      OGR_G_AddPoint_2D(hGeom, shape->line[0].point[i].x,
+                        shape->line[0].point[i].y);
+    }
+  } else if (shape->type == MS_SHAPE_LINE && shape->numlines > 1) {
+    OGRGeometryH hMultiLine = OGR_G_CreateGeometry(wkbMultiLineString);
+    int iLine;
+
+    for (iLine = 0; iLine < shape->numlines; iLine++) {
+      hGeom = OGR_G_CreateGeometry(wkbLineString);
+      for (i = 0; i < shape->line[iLine].numpoints; i++) {
+        OGR_G_AddPoint_2D(hGeom, shape->line[iLine].point[i].x,
+                          shape->line[iLine].point[i].y);
+      }
+
+      OGR_G_AddGeometryDirectly(hMultiLine, hGeom);
+    }
+
+    hGeom = hMultiLine;
+  } else if (shape->type == MS_SHAPE_POLYGON) {
+    int iLine;
+
+    /* actually, it is pretty hard to be sure rings 1+ are interior */
+    hGeom = OGR_G_CreateGeometry(wkbPolygon);
+    for (iLine = 0; iLine < shape->numlines; iLine++) {
+      OGRGeometryH hRing;
+      hRing = OGR_G_CreateGeometry(wkbLinearRing);
+
+      for (i = 0; i < shape->line[iLine].numpoints; i++) {
+        OGR_G_AddPoint_2D(hRing, shape->line[iLine].point[i].x,
+                          shape->line[iLine].point[i].y);
+      }
+      OGR_G_AddGeometryDirectly(hGeom, hRing);
+    }
+  } else {
+    msSetError(MS_OGRERR, "OGR support is not available.", "msOGRShapeToWKT()");
+  }
+
+  if (hGeom != NULL) {
+    char *pszOGRWkt;
+
+    OGR_G_ExportToWkt(hGeom, &pszOGRWkt);
+    wkt = msStrdup(pszOGRWkt);
+    CPLFree(pszOGRWkt);
+  }
+
+  return wkt;
+}
diff -pruN 8.0.1-5/src/mapogroutput.cpp 8.2.0~beta1-1~exp1/src/mapogroutput.cpp
--- 8.0.1-5/src/mapogroutput.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapogroutput.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1361 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGR Output (for WFS)
+ * Author:   Frank Warmerdam (warmerdam@pobox.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2010, Frank Warmerdam <warmerdam@pobox.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "mapproject.h"
+#include "mapthread.h"
+#include "mapows.h"
+
+#include "ogr_api.h"
+#include "ogr_srs_api.h"
+#include "cpl_conv.h"
+#include "cpl_vsi.h"
+#include "cpl_string.h"
+
+#include <string>
+
+/************************************************************************/
+/*                   msInitDefaultOGROutputFormat()                     */
+/************************************************************************/
+
+int msInitDefaultOGROutputFormat(outputFormatObj *format)
+
+{
+  OGRSFDriverH hDriver;
+
+  msOGRInitialize();
+
+  /* -------------------------------------------------------------------- */
+  /*      check that this driver exists.  Note visiting drivers should    */
+  /*      be pretty threadsafe so don't bother acquiring the GDAL         */
+  /*      lock.                                                           */
+  /* -------------------------------------------------------------------- */
+  hDriver = OGRGetDriverByName(format->driver + 4);
+  if (hDriver == NULL) {
+    msSetError(MS_MISCERR, "No OGR driver named `%s' available.",
+               "msInitDefaultOGROutputFormat()", format->driver + 4);
+    return MS_FAILURE;
+  }
+
+  if (!OGR_Dr_TestCapability(hDriver, ODrCCreateDataSource)) {
+    msSetError(MS_MISCERR, "OGR `%s' driver does not support output.",
+               "msInitDefaultOGROutputFormat()", format->driver + 4);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize the object.                                          */
+  /* -------------------------------------------------------------------- */
+  format->imagemode = MS_IMAGEMODE_FEATURE;
+  format->renderer = MS_RENDER_WITH_OGR;
+
+  /* perhaps we should eventually hardcode mimetypes and extensions
+     for some formats? */
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                        msCSLConcatenate()                            */
+/************************************************************************/
+
+static char **msCSLConcatenate(char **papszResult, char **papszToBeAdded) {
+  char **papszIter = papszToBeAdded;
+  while (papszIter && *papszIter) {
+    papszResult = CSLAddString(papszResult, *papszIter);
+    papszIter++;
+  }
+  return papszResult;
+}
+
+/************************************************************************/
+/*                       msOGRRecursiveFileList()                       */
+/*                                                                      */
+/*      Collect a list of all files under the named directory,          */
+/*      including those in subdirectories.                              */
+/************************************************************************/
+
+char **msOGRRecursiveFileList(const char *path) {
+  char **file_list;
+  char **result_list = NULL;
+  int i, count, change;
+
+  file_list = CPLReadDir(path);
+  count = CSLCount(file_list);
+
+  /* -------------------------------------------------------------------- */
+  /*      Sort the file list so we always get them back in the same       */
+  /*      order - it makes autotests more stable.                         */
+  /* -------------------------------------------------------------------- */
+  do {
+    change = 0;
+    for (i = 0; i < count - 1; i++) {
+      if (strcasecmp(file_list[i], file_list[i + 1]) > 0) {
+        char *temp = file_list[i];
+        file_list[i] = file_list[i + 1];
+        file_list[i + 1] = temp;
+        change = 1;
+      }
+    }
+  } while (change);
+
+  /* -------------------------------------------------------------------- */
+  /*      collect names we want and process subdirectories.               */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < count; i++) {
+    char full_filename[MS_MAXPATHLEN];
+    VSIStatBufL sStatBuf;
+
+    if (EQUAL(file_list[i], ".") || EQUAL(file_list[i], ".."))
+      continue;
+
+    strlcpy(full_filename, CPLFormFilename(path, file_list[i], NULL),
+            sizeof(full_filename));
+
+    if (VSIStatL(full_filename, &sStatBuf) != 0)
+      continue;
+
+    if (VSI_ISREG(sStatBuf.st_mode)) {
+      result_list = CSLAddString(result_list, full_filename);
+    } else if (VSI_ISDIR(sStatBuf.st_mode)) {
+      char **subfiles = msOGRRecursiveFileList(full_filename);
+
+      result_list = msCSLConcatenate(result_list, subfiles);
+
+      CSLDestroy(subfiles);
+    }
+  }
+
+  CSLDestroy(file_list);
+
+  return result_list;
+}
+
+/************************************************************************/
+/*                           msOGRCleanupDS()                           */
+/************************************************************************/
+static void msOGRCleanupDS(const char *datasource_name)
+
+{
+  char **file_list;
+  char path[MS_MAXPATHLEN];
+  int i;
+  VSIStatBufL sStatBuf;
+
+  if (VSIStatL(datasource_name, &sStatBuf) != 0)
+    return;
+  if (VSI_ISDIR(sStatBuf.st_mode))
+    strlcpy(path, datasource_name, sizeof(path));
+  else
+    strlcpy(path, CPLGetPath(datasource_name), sizeof(path));
+
+  file_list = CPLReadDir(path);
+
+  for (i = 0; file_list != NULL && file_list[i] != NULL; i++) {
+    char full_filename[MS_MAXPATHLEN];
+    VSIStatBufL sStatBuf;
+
+    if (EQUAL(file_list[i], ".") || EQUAL(file_list[i], ".."))
+      continue;
+
+    strlcpy(full_filename, CPLFormFilename(path, file_list[i], NULL),
+            sizeof(full_filename));
+
+    if (VSIStatL(full_filename, &sStatBuf) != 0)
+      continue;
+
+    if (VSI_ISREG(sStatBuf.st_mode)) {
+      VSIUnlink(full_filename);
+    } else if (VSI_ISDIR(sStatBuf.st_mode)) {
+      msOGRCleanupDS(full_filename);
+    }
+  }
+
+  CSLDestroy(file_list);
+
+  VSIRmdir(path);
+}
+
+/************************************************************************/
+/*                          msOGRSetPoints()                            */
+/************************************************************************/
+
+static void msOGRSetPoints(OGRGeometryH hGeom, lineObj *line,
+                           int bWant2DOutput) {
+  int i;
+  if (bWant2DOutput) {
+    for (i = 0; i < line->numpoints; i++) {
+      OGR_G_SetPoint_2D(hGeom, i, line->point[i].x, line->point[i].y);
+    }
+  } else {
+    for (i = 0; i < line->numpoints; i++) {
+      OGR_G_SetPoint(hGeom, i, line->point[i].x, line->point[i].y,
+                     line->point[i].z);
+    }
+  }
+}
+
+/************************************************************************/
+/*                          msOGRWriteShape()                           */
+/************************************************************************/
+
+static int msOGRWriteShape(OGRLayerH hOGRLayer, shapeObj *shape,
+                           gmlItemListObj *item_list, int nFirstOGRFieldIndex,
+                           const char *pszFeatureid, bool geomTypeForced)
+
+{
+  OGRGeometryH hGeom = NULL;
+  OGRFeatureH hFeat;
+  OGRErr eErr;
+  int i, out_field;
+  OGRwkbGeometryType eLayerGType, eFlattenLayerGType;
+  OGRFeatureDefnH hLayerDefn;
+  int bWant2DOutput;
+
+  hLayerDefn = OGR_L_GetLayerDefn(hOGRLayer);
+  eLayerGType = OGR_FD_GetGeomType(hLayerDefn);
+  eFlattenLayerGType = wkbFlatten(eLayerGType);
+  bWant2DOutput = (eLayerGType == eFlattenLayerGType);
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform point geometry.                                       */
+  /* -------------------------------------------------------------------- */
+  if (shape->type == MS_SHAPE_POINT) {
+    OGRGeometryH hMP = NULL;
+    int j;
+
+    if (shape->numlines == 1 && shape->line[0].numpoints > 1) {
+      hGeom = OGR_G_CreateGeometry(wkbMultiPoint);
+      for (j = 0; j < shape->line[0].numpoints; j++) {
+        OGRGeometryH hPoint = OGR_G_CreateGeometry(wkbPoint);
+        if (bWant2DOutput) {
+          OGR_G_SetPoint_2D(hPoint, 0, shape->line[0].point[j].x,
+                            shape->line[0].point[j].y);
+        } else {
+          OGR_G_SetPoint(hPoint, 0, shape->line[0].point[j].x,
+                         shape->line[0].point[j].y, shape->line[0].point[j].z);
+        }
+
+        OGR_G_AddGeometryDirectly(hGeom, hPoint);
+      }
+    } else {
+      if (shape->numlines > 1)
+        hMP = OGR_G_CreateGeometry(wkbMultiPoint);
+
+      for (j = 0; j < shape->numlines; j++) {
+        if (shape->line[j].numpoints != 1) {
+          msSetError(MS_MISCERR, "Failed on odd point geometry.",
+                     "msOGRWriteShape()");
+          return MS_FAILURE;
+        }
+
+        hGeom = OGR_G_CreateGeometry(wkbPoint);
+        if (bWant2DOutput) {
+          OGR_G_SetPoint_2D(hGeom, 0, shape->line[j].point[0].x,
+                            shape->line[j].point[0].y);
+        } else {
+          OGR_G_SetPoint(hGeom, 0, shape->line[j].point[0].x,
+                         shape->line[j].point[0].y, shape->line[j].point[0].z);
+        }
+
+        if (hMP != NULL) {
+          OGR_G_AddGeometryDirectly(hMP, hGeom);
+        }
+      }
+
+      if (hMP != NULL)
+        hGeom = hMP;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform line geometry.                                        */
+  /* -------------------------------------------------------------------- */
+  else if (shape->type == MS_SHAPE_LINE) {
+    OGRGeometryH hML = NULL;
+    int j;
+
+    if (shape->numlines > 1)
+      hML = OGR_G_CreateGeometry(wkbMultiLineString);
+
+    for (j = 0; j < shape->numlines; j++) {
+
+      if (shape->line[j].numpoints < 2) {
+        msSetError(MS_MISCERR, "Failed on odd line geometry.",
+                   "msOGRWriteShape()");
+        return MS_FAILURE;
+      }
+
+      hGeom = OGR_G_CreateGeometry(wkbLineString);
+
+      msOGRSetPoints(hGeom, &(shape->line[j]), bWant2DOutput);
+
+      if (hML != NULL) {
+        OGR_G_AddGeometryDirectly(hML, hGeom);
+        hGeom = hML;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform polygon geometry.                                     */
+  /* -------------------------------------------------------------------- */
+  else if (shape->type == MS_SHAPE_POLYGON) {
+    int iRing, iOuter;
+    int *outer_flags;
+    OGRGeometryH hMP = NULL;
+
+    outer_flags = msGetOuterList(shape);
+
+    for (iOuter = 0; iOuter < shape->numlines; iOuter++) {
+      int *inner_flags;
+      OGRGeometryH hRing;
+
+      if (!outer_flags[iOuter])
+        continue;
+
+      if (hGeom != nullptr) {
+        assert(hMP == nullptr);
+        hMP = OGR_G_CreateGeometry(wkbMultiPolygon);
+        OGR_G_AddGeometryDirectly(hMP, hGeom);
+      }
+      hGeom = OGR_G_CreateGeometry(wkbPolygon);
+
+      /* handle outer ring */
+
+      hRing = OGR_G_CreateGeometry(wkbLinearRing);
+
+      msOGRSetPoints(hRing, &(shape->line[iOuter]), bWant2DOutput);
+
+      OGR_G_AddGeometryDirectly(hGeom, hRing);
+
+      /* handle inner rings (holes) */
+      inner_flags = msGetInnerList(shape, iOuter, outer_flags);
+
+      for (iRing = 0; iRing < shape->numlines; iRing++) {
+        if (!inner_flags[iRing])
+          continue;
+
+        hRing = OGR_G_CreateGeometry(wkbLinearRing);
+
+        msOGRSetPoints(hRing, &(shape->line[iRing]), bWant2DOutput);
+
+        OGR_G_AddGeometryDirectly(hGeom, hRing);
+      }
+
+      free(inner_flags);
+
+      if (hMP) {
+        OGR_G_AddGeometryDirectly(hMP, hGeom);
+        hGeom = nullptr;
+      }
+    }
+
+    free(outer_flags);
+
+    if (hMP != nullptr) {
+      assert(hGeom == nullptr);
+      hGeom = hMP;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Consider trying to force the geometry to a new type if it       */
+  /*      doesn't match the layer.                                        */
+  /* -------------------------------------------------------------------- */
+  if (hGeom != NULL) {
+    OGRwkbGeometryType eFlattenFeatureGType =
+        wkbFlatten(OGR_G_GetGeometryType(hGeom));
+
+    if (eFlattenFeatureGType != eFlattenLayerGType) {
+      if (eFlattenLayerGType == wkbPolygon && geomTypeForced)
+        hGeom = OGR_G_ForceToPolygon(hGeom);
+
+      else if (eFlattenLayerGType == wkbMultiPolygon)
+        hGeom = OGR_G_ForceToMultiPolygon(hGeom);
+
+      else if (eFlattenLayerGType == wkbMultiPoint)
+        hGeom = OGR_G_ForceToMultiPoint(hGeom);
+
+      else if (eFlattenLayerGType == wkbMultiLineString)
+        hGeom = OGR_G_ForceToMultiLineString(hGeom);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Consider flattening the geometry to 2D if we want 2D            */
+  /*      output.                                                         */
+  /*      Note: this shouldn't be called in recent OGR versions where     */
+  /*      OGR_G_SetPoint_2D is properly honoured.                         */
+  /* -------------------------------------------------------------------- */
+
+  if (bWant2DOutput && hGeom != NULL) {
+    OGRwkbGeometryType eFeatureGType = OGR_G_GetGeometryType(hGeom);
+    if (eFeatureGType != wkbFlatten(eFeatureGType))
+      OGR_G_FlattenTo2D(hGeom);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create the feature, and attach the geometry.                    */
+  /* -------------------------------------------------------------------- */
+  hFeat = OGR_F_Create(hLayerDefn);
+
+  OGR_F_SetGeometryDirectly(hFeat, hGeom);
+
+  /* -------------------------------------------------------------------- */
+  /*      Set attributes.                                                 */
+  /* -------------------------------------------------------------------- */
+  out_field = nFirstOGRFieldIndex;
+  for (i = 0; i < item_list->numitems; i++) {
+    gmlItemObj *item = item_list->items + i;
+
+    if (pszFeatureid && !strcmp(pszFeatureid, item->name)) {
+      char *endptr;
+      long feature_id = strtol(shape->values[i], &endptr, 10);
+      if (endptr && *endptr == 0) {
+        /* only set the featureid if it is numeric */
+        OGR_F_SetFID(hFeat, feature_id);
+      }
+    }
+
+    if (!item->visible)
+      continue;
+
+    /* Avoid setting empty strings for numeric fields, so that OGR */
+    /* doesn't take them as 0. (#4633) */
+    if (shape->values[i][0] == '\0') {
+      OGRFieldDefnH hFieldDefn = OGR_FD_GetFieldDefn(hLayerDefn, out_field);
+      OGRFieldType eFieldType = OGR_Fld_GetType(hFieldDefn);
+      if (eFieldType == OFTInteger || eFieldType == OFTReal ||
+          eFieldType == OFTInteger64) {
+        out_field++;
+        continue;
+      }
+    }
+
+    const char *pszValue = shape->values[i];
+#if GDAL_VERSION_MAJOR == 3 && GDAL_VERSION_MINOR < 7
+    // Boolean true and false values are handled in GDAL 3.7+
+    // otherwise any string values revert to false
+    if (strcmp(pszValue, "true") == 0) {
+      OGRFieldDefnH hFieldDefn = OGR_FD_GetFieldDefn(hLayerDefn, out_field);
+      OGRFieldSubType eFieldSubType = OGR_Fld_GetSubType(hFieldDefn);
+      if (eFieldSubType == OFSTBoolean) {
+        pszValue = "1";
+      }
+    }
+
+    if (strcmp(pszValue, "false") == 0) {
+      OGRFieldDefnH hFieldDefn = OGR_FD_GetFieldDefn(hLayerDefn, out_field);
+      OGRFieldSubType eFieldSubType = OGR_Fld_GetSubType(hFieldDefn);
+      if (eFieldSubType == OFSTBoolean) {
+        pszValue = "0";
+      }
+    }
+#endif
+
+    OGR_F_SetFieldString(hFeat, out_field++, pszValue);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out and cleanup.                                          */
+  /* -------------------------------------------------------------------- */
+  eErr = OGR_L_CreateFeature(hOGRLayer, hFeat);
+
+  OGR_F_Destroy(hFeat);
+
+  if (eErr != OGRERR_NONE) {
+    msSetError(MS_OGRERR, "Attempt to write feature failed (code=%d):\n%s",
+               "msOGRWriteShape()", (int)eErr, CPLGetLastErrorMsg());
+  }
+
+  if (eErr == OGRERR_NONE)
+    return MS_SUCCESS;
+  else
+    return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                        msOGRStdoutWriteFunction()                    */
+/************************************************************************/
+
+/* Used by /vsistdout/ */
+static size_t msOGRStdoutWriteFunction(const void *ptr, size_t size,
+                                       size_t nmemb, FILE *stream) {
+  msIOContext *ioctx = (msIOContext *)stream;
+  return msIO_contextWrite(ioctx, ptr, size * nmemb) / size;
+}
+
+/************************************************************************/
+/*                      msOGROutputGetAdditonalFiles()                  */
+/*                                                                      */
+/*  Collect additional files specified in                               */
+/*  wfs/ows_additional_files_in_output of WEB.METADATA and LAYER.METADATA */
+/************************************************************************/
+
+/* Result to be freed with CSLDestroy() */
+static char **msOGROutputGetAdditonalFiles(mapObj *map) {
+  int i;
+  hashTableObj *hSetAdditionalFiles;
+  char **papszFiles = NULL;
+
+  hSetAdditionalFiles = msCreateHashTable();
+
+  for (i = -1; i < map->numlayers; i++) {
+    const char *value;
+    if (i < 0) {
+      value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                  "additional_files_in_output");
+    } else {
+      layerObj *layer = GET_LAYER(map, i);
+      if (!layer->resultcache || layer->resultcache->numresults == 0)
+        continue;
+      value = msOWSLookupMetadata(&(layer->metadata), "FO",
+                                  "additional_files_in_output");
+    }
+
+    if (value != NULL) {
+      char **papszList = CSLTokenizeString2(value, ",", CSLT_HONOURSTRINGS);
+      char **papszListIter = papszList;
+      while (papszListIter && *papszListIter) {
+        const char *file = *papszListIter;
+        VSIStatBufL sStat;
+
+        if (strncmp(file, "http://", strlen("http://")) == 0 ||
+            strncmp(file, "https://", strlen("https://")) == 0) {
+          /* Remote file ? We will use /vsicurl_streaming/ to read it */
+          if (msLookupHashTable(hSetAdditionalFiles, file) == NULL) {
+            msInsertHashTable(hSetAdditionalFiles, file, "YES");
+            papszFiles = CSLAddString(
+                papszFiles, CPLSPrintf("/vsicurl_streaming/%s", file));
+          }
+        } else {
+          int nLen = (int)strlen(file);
+          char filename[MS_MAXPATHLEN];
+
+          if (CPLIsFilenameRelative(file)) {
+            if (!map->shapepath)
+              msTryBuildPath(filename, map->mappath, file);
+            else
+              msTryBuildPath3(filename, map->mappath, map->shapepath, file);
+          } else
+            strlcpy(filename, file, MS_MAXPATHLEN);
+
+          if (nLen > 2 && (strcmp(file + nLen - 1, "/") == 0 ||
+                           strcmp(file + nLen - 2, "/*") == 0)) {
+            *strrchr(filename, '/') = '\0';
+          } else if (nLen > 2 && (strcmp(file + nLen - 1, "\\") == 0 ||
+                                  strcmp(file + nLen - 2, "\\*") == 0)) {
+            *strrchr(filename, '\\') = '\0';
+          }
+
+          if (msLookupHashTable(hSetAdditionalFiles, filename) == NULL) {
+            msInsertHashTable(hSetAdditionalFiles, filename, "YES");
+            if (VSIStatL(filename, &sStat) == 0) {
+              if (VSI_ISDIR(sStat.st_mode)) {
+                char **papszDirContent = msOGRRecursiveFileList(filename);
+                papszFiles = msCSLConcatenate(papszFiles, papszDirContent);
+                CSLDestroy(papszDirContent);
+              } else {
+                papszFiles = CSLAddString(papszFiles, filename);
+              }
+            } else {
+              msDebug("File %s does not exist.\n", filename);
+            }
+          }
+        }
+
+        papszListIter++;
+      }
+      CSLDestroy(papszList);
+    }
+  }
+
+  msFreeHashTable(hSetAdditionalFiles);
+
+  return papszFiles;
+}
+
+/************************************************************************/
+/*                        msOGRWriteFromQuery()                         */
+/************************************************************************/
+
+int msOGRWriteFromQuery(mapObj *map, outputFormatObj *format, int sendheaders)
+
+{
+  /* -------------------------------------------------------------------- */
+  /*      Variable declarations.                                          */
+  /* -------------------------------------------------------------------- */
+  OGRSFDriverH hDriver;
+  OGRDataSourceH hDS;
+  const char *storage;
+  const char *fo_filename;
+  const char *form;
+  char datasource_name[MS_MAXPATHLEN];
+  char base_dir[MS_MAXPATHLEN];
+  char *request_dir = NULL;
+  char **ds_options = NULL;
+  char **layer_options = NULL;
+  char **file_list = NULL;
+  int iLayer, i;
+  int bDataSourceNameIsRequestDir = FALSE;
+  int bUseFeatureId = MS_FALSE;
+  const char *pszMatchingFeatures;
+  int nMatchingFeatures = -1;
+  const char *pszFormatName = format->driver + 4;
+
+  pszMatchingFeatures =
+      msGetOutputFormatOption(format, "_matching_features_", "");
+  if (pszMatchingFeatures[0] != '\0')
+    nMatchingFeatures = atoi(pszMatchingFeatures);
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch the output format driver.                                 */
+  /* -------------------------------------------------------------------- */
+  msOGRInitialize();
+
+  hDriver = OGRGetDriverByName(pszFormatName);
+  if (hDriver == NULL) {
+    msSetError(MS_MISCERR, "No OGR driver named `%s' available.",
+               "msOGRWriteFromQuery()", pszFormatName);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Capture datasource and layer creation options.                  */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < format->numformatoptions; i++) {
+    if (strncasecmp(format->formatoptions[i], "LCO:", 4) == 0)
+      layer_options = CSLAddString(layer_options, format->formatoptions[i] + 4);
+    if (strncasecmp(format->formatoptions[i], "DSCO:", 5) == 0)
+      ds_options = CSLAddString(ds_options, format->formatoptions[i] + 5);
+  }
+  if (EQUAL(pszFormatName, "GeoJSON") && nMatchingFeatures >= 0) {
+    const char *pszNativeData =
+        CSLFetchNameValueDef(layer_options, "NATIVE_DATA", "{}");
+    if (pszNativeData[strlen(pszNativeData) - 1] == '}') {
+      std::string tmpl(pszNativeData);
+      tmpl.resize(tmpl.size() - 1);
+      if (strlen(pszNativeData) > 2)
+        tmpl += ',';
+      tmpl += "\"numberMatched\":";
+      tmpl += std::to_string(nMatchingFeatures);
+      tmpl += '}';
+      layer_options = CSLSetNameValue(layer_options, "NATIVE_MEDIA_TYPE",
+                                      "application/vnd.geo+json");
+      layer_options =
+          CSLSetNameValue(layer_options, "NATIVE_DATA", tmpl.c_str());
+    }
+  }
+  if (!strcasecmp("true",
+                  msGetOutputFormatOption(format, "USE_FEATUREID", "false"))) {
+    bUseFeatureId = MS_TRUE;
+  }
+
+  /* ==================================================================== */
+  /*      Determine the output datasource name to use.                    */
+  /* ==================================================================== */
+  storage = msGetOutputFormatOption(format, "STORAGE", "filesystem");
+  if (EQUAL(storage, "stream") && !msIO_isStdContext()) {
+    msIOContext *ioctx = msIO_getHandler(stdout);
+    if (ioctx != NULL)
+      VSIStdoutSetRedirection(msOGRStdoutWriteFunction, (FILE *)ioctx);
+    else
+      /* bug #4858, streaming output won't work if standard output has been
+       * redirected, we switch to memory output in this case
+       */
+      storage = "memory";
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Where are we putting stuff?                                     */
+  /* -------------------------------------------------------------------- */
+  if (EQUAL(storage, "filesystem")) {
+    base_dir[0] = '\0';
+  } else if (EQUAL(storage, "memory")) {
+    strcpy(base_dir, "/vsimem/ogr_out/");
+  } else if (EQUAL(storage, "stream")) {
+    /* handled later */
+  } else {
+    msSetError(MS_MISCERR, "STORAGE=%s value not supported.",
+               "msOGRWriteFromQuery()", storage);
+    CSLDestroy(layer_options);
+    CSLDestroy(ds_options);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create a subdirectory to handle this request.                   */
+  /* -------------------------------------------------------------------- */
+  if (!EQUAL(storage, "stream")) {
+    const char *dir_to_create;
+    if (strlen(base_dir) > 0)
+      request_dir = msTmpFile(map, NULL, base_dir, "");
+    else
+      request_dir = msTmpFile(map, NULL, NULL, "");
+
+    if (request_dir[strlen(request_dir) - 1] == '.')
+      request_dir[strlen(request_dir) - 1] = '\0';
+
+    dir_to_create = request_dir;
+    /* Workaround issue in GDAL versions released at this time :
+     * GDAL issue fixed per https://trac.osgeo.org/gdal/ticket/6991 */
+    if (EQUAL(storage, "memory") &&
+        EQUAL(format->driver + 4, "ESRI Shapefile")) {
+      dir_to_create = base_dir;
+    }
+
+    if (VSIMkdir(dir_to_create, 0777) != 0) {
+      msSetError(MS_MISCERR, "Attempt to create directory '%s' failed.",
+                 "msOGRWriteFromQuery()", dir_to_create);
+      msFree(request_dir);
+      CSLDestroy(layer_options);
+      CSLDestroy(ds_options);
+      return MS_FAILURE;
+    }
+  }
+  /*  else handled later */
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup the full datasource name.                                 */
+  /* -------------------------------------------------------------------- */
+  form = msGetOutputFormatOption(format, "FORM", "zip");
+
+  if (EQUAL(form, "zip"))
+    fo_filename = msGetOutputFormatOption(format, "FILENAME", "result.zip");
+  else
+    fo_filename = msGetOutputFormatOption(format, "FILENAME", "result.dat");
+
+  /* Validate that the filename does not contain any directory */
+  /* information, which might lead to removal of unwanted files. (#4086) */
+  if (strchr(fo_filename, '/') != NULL || strchr(fo_filename, ':') != NULL ||
+      strchr(fo_filename, '\\') != NULL) {
+    msSetError(MS_MISCERR,
+               "Invalid value for FILENAME option. "
+               "It must not contain any directory information.",
+               "msOGRWriteFromQuery()");
+    msFree(request_dir);
+    CSLDestroy(layer_options);
+    CSLDestroy(ds_options);
+    return MS_FAILURE;
+  }
+
+  if (!EQUAL(storage, "stream")) {
+    msBuildPath(datasource_name, request_dir, fo_filename);
+
+    if (EQUAL(form, "zip")) {
+      /* if generating a zip file, remove the zip extension for the internal */
+      /* filename */
+      if (EQUAL(CPLGetExtension(datasource_name), "zip")) {
+        *strrchr(datasource_name, '.') = '\0';
+      }
+
+      /* and add .dat extension if user didn't provide another extension */
+      if (EQUAL(CPLGetExtension(datasource_name), "")) {
+        strcat(datasource_name, ".dat");
+      }
+    }
+
+    /* Shapefile and MapInfo driver only properly work with multiple layers */
+    /* if the output dataset name is a directory */
+    if (EQUAL(format->driver + 4, "ESRI Shapefile") ||
+        EQUAL(format->driver + 4, "MapInfo File")) {
+      bDataSourceNameIsRequestDir = TRUE;
+      strcpy(datasource_name, request_dir);
+    }
+  } else
+    strcpy(datasource_name, "/vsistdout/");
+
+  msFree(request_dir);
+  request_dir = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Emit content type headers for stream output now.                */
+  /* -------------------------------------------------------------------- */
+  if (EQUAL(storage, "stream")) {
+    if (sendheaders && format->mimetype) {
+      msIO_setHeader("Content-Type", "%s", format->mimetype);
+      msIO_sendHeaders();
+    } else
+      msIO_fprintf(stdout, "%c", 10);
+  }
+
+  /* ==================================================================== */
+  /*      Create the datasource.                                          */
+  /* ==================================================================== */
+  hDS = OGR_Dr_CreateDataSource(hDriver, datasource_name, ds_options);
+  CSLDestroy(ds_options);
+
+  if (hDS == NULL) {
+    msOGRCleanupDS(datasource_name);
+    msSetError(MS_MISCERR,
+               "OGR CreateDataSource failed for '%s' with driver '%s'.",
+               "msOGRWriteFromQuery()", datasource_name, format->driver + 4);
+    CSLDestroy(layer_options);
+    return MS_FAILURE;
+  }
+
+  /* ==================================================================== */
+  /*      Process each layer with a resultset.                            */
+  /* ==================================================================== */
+  for (iLayer = 0; iLayer < map->numlayers; iLayer++) {
+    int status = 0;
+    layerObj *layer = GET_LAYER(map, iLayer);
+    shapeObj resultshape;
+    OGRLayerH hOGRLayer;
+    OGRwkbGeometryType eGeomType;
+    OGRSpatialReferenceH srs = NULL;
+    gmlItemListObj *item_list = NULL;
+    const char *value;
+    char *pszWKT;
+    int nFirstOGRFieldIndex = -1;
+    const char *pszFeatureid = NULL;
+
+    if (!layer->resultcache)
+      continue;
+
+    /* -------------------------------------------------------------------- */
+    /*      Will we need to reproject?                                      */
+    /* -------------------------------------------------------------------- */
+    if (layer->transform == MS_TRUE)
+      layer->project =
+          msProjectionsDiffer(&(layer->projection), &(layer->map->projection));
+
+    /* -------------------------------------------------------------------- */
+    /*      Establish the geometry type to use for the created layer.       */
+    /*      First we consult the wfs_geomtype field and fallback to         */
+    /*      deriving something from the type of the mapserver layer.        */
+    /* -------------------------------------------------------------------- */
+    value = msOWSLookupMetadata(&(layer->metadata), "FOG", "geomtype");
+    bool geomTypeForced = true;
+    if (value == NULL) {
+      geomTypeForced = false;
+      if (layer->type == MS_LAYER_POINT)
+        value = "Point";
+      else if (layer->type == MS_LAYER_LINE)
+        value = "LineString";
+      else if (layer->type == MS_LAYER_POLYGON)
+        value = "Polygon";
+      else
+        value = "Geometry";
+    }
+
+    if (bUseFeatureId)
+      pszFeatureid =
+          msOWSLookupMetadata(&(layer->metadata), "FOG", "featureid");
+
+    if (strcasecmp(value, "Point") == 0)
+      eGeomType = wkbPoint;
+    else if (strcasecmp(value, "LineString") == 0)
+      eGeomType = wkbLineString;
+    else if (strcasecmp(value, "Polygon") == 0)
+      eGeomType = wkbPolygon;
+    else if (strcasecmp(value, "MultiPoint") == 0)
+      eGeomType = wkbMultiPoint;
+    else if (strcasecmp(value, "MultiLineString") == 0)
+      eGeomType = wkbMultiLineString;
+    else if (strcasecmp(value, "MultiPolygon") == 0)
+      eGeomType = wkbMultiPolygon;
+    else if (strcasecmp(value, "GeometryCollection") == 0)
+      eGeomType = wkbGeometryCollection;
+    else if (strcasecmp(value, "Point25D") == 0)
+      eGeomType = wkbPoint25D;
+    else if (strcasecmp(value, "LineString25D") == 0)
+      eGeomType = wkbLineString25D;
+    else if (strcasecmp(value, "Polygon25D") == 0)
+      eGeomType = wkbPolygon25D;
+    else if (strcasecmp(value, "MultiPoint25D") == 0)
+      eGeomType = wkbMultiPoint25D;
+    else if (strcasecmp(value, "MultiLineString25D") == 0)
+      eGeomType = wkbMultiLineString25D;
+    else if (strcasecmp(value, "MultiPolygon25D") == 0)
+      eGeomType = wkbMultiPolygon25D;
+    else if (strcasecmp(value, "GeometryCollection25D") == 0)
+      eGeomType = wkbGeometryCollection25D;
+    else if (strcasecmp(value, "Unknown") == 0 ||
+             strcasecmp(value, "Geometry") == 0)
+      eGeomType = wkbUnknown;
+    else if (strcasecmp(value, "None") == 0)
+      eGeomType = wkbNone;
+    else
+      eGeomType = wkbUnknown;
+
+    /* -------------------------------------------------------------------- */
+    /*      Create a spatial reference.                                     */
+    /* -------------------------------------------------------------------- */
+    pszWKT = msProjectionObj2OGCWKT(&(map->projection));
+    if (pszWKT != NULL) {
+      srs = OSRNewSpatialReference(pszWKT);
+      msFree(pszWKT);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Create the corresponding OGR Layer.                             */
+    /* -------------------------------------------------------------------- */
+    hOGRLayer =
+        OGR_DS_CreateLayer(hDS, layer->name, srs, eGeomType, layer_options);
+    if (hOGRLayer == NULL) {
+      OGR_DS_Destroy(hDS);
+      msOGRCleanupDS(datasource_name);
+      msSetError(
+          MS_MISCERR,
+          "OGR OGR_DS_CreateLayer failed for layer '%s' with driver '%s'.",
+          "msOGRWriteFromQuery()", layer->name, format->driver + 4);
+      CSLDestroy(layer_options);
+      return MS_FAILURE;
+    }
+
+    if (srs != NULL)
+      OSRRelease(srs);
+
+    /* -------------------------------------------------------------------- */
+    /*      Create appropriate attributes on this layer.                    */
+    /* -------------------------------------------------------------------- */
+    item_list = msGMLGetItems(layer, "G");
+    assert(item_list->numitems == layer->numitems);
+
+    for (i = 0; i < layer->numitems; i++) {
+      OGRFieldDefnH hFldDefn;
+      OGRErr eErr;
+      const char *name;
+      gmlItemObj *item = item_list->items + i;
+      OGRFieldType eType;
+      OGRFieldSubType sType = OGRFieldSubType::OFSTNone;
+
+      if (!item->visible)
+        continue;
+
+      if (item->alias)
+        name = item->alias;
+      else
+        name = item->name;
+
+      if (item->type == NULL)
+        eType = OFTString;
+      else if (EQUAL(item->type, "Integer"))
+        eType = OFTInteger;
+      else if (EQUAL(item->type, "Long"))
+        eType = OFTInteger64;
+      else if (EQUAL(item->type, "Real"))
+        eType = OFTReal;
+      else if (EQUAL(item->type, "Character"))
+        eType = OFTString;
+      else if (EQUAL(item->type, "Date"))
+        eType = OFTDate;
+      else if (EQUAL(item->type, "Time"))
+        eType = OFTTime;
+      else if (EQUAL(item->type, "DateTime"))
+        eType = OFTDateTime;
+      else if (EQUAL(item->type, "Boolean")) {
+        eType = OFTInteger;
+        sType = OFSTBoolean;
+      } else
+        eType = OFTString;
+
+      hFldDefn = OGR_Fld_Create(name, eType);
+      if (sType != OGRFieldSubType::OFSTNone) {
+        OGR_Fld_SetSubType(hFldDefn, sType);
+      }
+      if (item->width != 0)
+        OGR_Fld_SetWidth(hFldDefn, item->width);
+      if (item->precision != 0)
+        OGR_Fld_SetPrecision(hFldDefn, item->precision);
+
+      eErr = OGR_L_CreateField(hOGRLayer, hFldDefn, TRUE);
+      OGR_Fld_Destroy(hFldDefn);
+
+      if (eErr != OGRERR_NONE) {
+        msSetError(MS_OGRERR,
+                   "Failed to create field '%s' in output feature schema:\n%s",
+                   "msOGRWriteFromQuery()", layer->items[i],
+                   CPLGetLastErrorMsg());
+
+        OGR_DS_Destroy(hDS);
+        msOGRCleanupDS(datasource_name);
+        msGMLFreeItems(item_list);
+        CSLDestroy(layer_options);
+        return MS_FAILURE;
+      }
+
+      /* The index of the first field we create is not necessarily 0 */
+      if (nFirstOGRFieldIndex < 0)
+        nFirstOGRFieldIndex =
+            OGR_FD_GetFieldCount(OGR_L_GetLayerDefn(hOGRLayer)) - 1;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Setup joins if needed.  This is likely untested.                */
+    /* -------------------------------------------------------------------- */
+    if (layer->numjoins > 0) {
+      int j;
+      for (j = 0; j < layer->numjoins; j++) {
+        status = msJoinConnect(layer, &(layer->joins[j]));
+        if (status != MS_SUCCESS) {
+          OGR_DS_Destroy(hDS);
+          msOGRCleanupDS(datasource_name);
+          msGMLFreeItems(item_list);
+          CSLDestroy(layer_options);
+          return status;
+        }
+      }
+    }
+
+    msInitShape(&resultshape);
+
+    /* -------------------------------------------------------------------- */
+    /*      Loop over all the shapes in the resultcache.                    */
+    /* -------------------------------------------------------------------- */
+    for (i = 0; i < layer->resultcache->numresults; i++) {
+
+      msFreeShape(&resultshape); /* init too */
+
+      /*
+      ** Read the shape.
+      */
+      bool shapeFromCache = false;
+      if (layer->resultcache->results[i].shape) {
+        /* msDebug("Using cached shape %ld\n",
+         * layer->resultcache->results[i].shapeindex); */
+        shapeFromCache = true;
+        status =
+            msCopyShape(layer->resultcache->results[i].shape, &resultshape);
+      } else {
+        status = msLayerGetShape(layer, &resultshape,
+                                 &(layer->resultcache->results[i]));
+      }
+
+      if (status != MS_SUCCESS) {
+        OGR_DS_Destroy(hDS);
+        msOGRCleanupDS(datasource_name);
+        msGMLFreeItems(item_list);
+        msFreeShape(&resultshape);
+        CSLDestroy(layer_options);
+        return status;
+      }
+
+      /*
+      ** Perform classification, and some annotation related magic.
+      */
+      resultshape.classindex =
+          msShapeGetClass(layer, map, &resultshape, NULL, -1);
+
+      if (resultshape.classindex >= 0 &&
+          (layer->_class[resultshape.classindex]->text.string ||
+           layer->labelitem) &&
+          layer->_class[resultshape.classindex]->numlabels > 0 &&
+          layer->_class[resultshape.classindex]->labels[0]->size != -1) {
+        resultshape.text = msShapeGetLabelAnnotation(
+            layer, &resultshape,
+            layer->_class[resultshape.classindex]->labels[0]);
+      }
+
+      /*
+      ** prepare any necessary JOINs here (one-to-one only)
+      */
+      if (layer->numjoins > 0) {
+        int j;
+
+        for (j = 0; j < layer->numjoins; j++) {
+          if (layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
+            msJoinPrepare(&(layer->joins[j]), &resultshape);
+            msJoinNext(&(layer->joins[j])); /* fetch the first row */
+          }
+        }
+      }
+
+      if (layer->project && resultshape.type != MS_SHAPE_NULL &&
+          shapeFromCache != true) {
+        reprojectionObj *reprojector =
+            msLayerGetReprojectorToMap(layer, layer->map);
+        if (reprojector)
+          status = msProjectShapeEx(reprojector, &resultshape);
+        else
+          status = MS_FAILURE;
+      }
+
+      /*
+      ** Write out the feature to OGR.
+      */
+
+      if (status == MS_SUCCESS)
+        status =
+            msOGRWriteShape(hOGRLayer, &resultshape, item_list,
+                            nFirstOGRFieldIndex, pszFeatureid, geomTypeForced);
+
+      if (status != MS_SUCCESS) {
+        OGR_DS_Destroy(hDS);
+        msOGRCleanupDS(datasource_name);
+        msGMLFreeItems(item_list);
+        msFreeShape(&resultshape);
+        CSLDestroy(layer_options);
+        return status;
+      }
+    }
+
+    msGMLFreeItems(item_list);
+    msFreeShape(&resultshape); /* init too */
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Close the datasource.                                           */
+  /* -------------------------------------------------------------------- */
+  OGR_DS_Destroy(hDS);
+
+  CSLDestroy(layer_options);
+
+  /* -------------------------------------------------------------------- */
+  /*      Get list of resulting files.                                    */
+  /* -------------------------------------------------------------------- */
+
+  if (EQUAL(form, "simple")) {
+    file_list = CSLAddString(NULL, datasource_name);
+  } else {
+    char datasource_path[MS_MAXPATHLEN];
+
+    if (bDataSourceNameIsRequestDir)
+      file_list = msOGRRecursiveFileList(datasource_name);
+    else {
+      strncpy(datasource_path, CPLGetPath(datasource_name), MS_MAXPATHLEN - 1);
+      file_list = msOGRRecursiveFileList(datasource_path);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If our "storage" is stream then the output has already been     */
+  /*      sent back to the client and we don't need to copy it now.       */
+  /* -------------------------------------------------------------------- */
+  if (EQUAL(storage, "stream")) {
+    /* already done */
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle case of simple file written to stdout.                   */
+  /* -------------------------------------------------------------------- */
+  else if (EQUAL(form, "simple")) {
+    char buffer[1024];
+    int bytes_read;
+    VSILFILE *fp;
+    const char *jsonp;
+
+    jsonp = msGetOutputFormatOption(format, "JSONP", NULL);
+    if (sendheaders) {
+      if (!jsonp)
+        msIO_setHeader("Content-Disposition", "attachment; filename=%s",
+                       CPLGetFilename(file_list[0]));
+      if (format->mimetype)
+        msIO_setHeader("Content-Type", "%s", format->mimetype);
+      msIO_sendHeaders();
+    } else
+      msIO_fprintf(stdout, "%c", 10);
+
+    fp = VSIFOpenL(file_list[0], "r");
+    if (fp == NULL) {
+      msSetError(MS_MISCERR, "Failed to open result file '%s'.",
+                 "msOGRWriteFromQuery()", file_list[0]);
+      msOGRCleanupDS(datasource_name);
+      return MS_FAILURE;
+    }
+
+    if (jsonp != NULL)
+      msIO_fprintf(stdout, "%s(", jsonp);
+
+    while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0)
+      msIO_fwrite(buffer, 1, bytes_read, stdout);
+    VSIFCloseL(fp);
+
+    if (jsonp != NULL)
+      msIO_fprintf(stdout, ");\n");
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle the case of a multi-part result.                         */
+  /* -------------------------------------------------------------------- */
+  else if (EQUAL(form, "multipart")) {
+    char **papszAdditionalFiles;
+    static const char *boundary = "xxOGRBoundaryxx";
+    msIO_setHeader("Content-Type", "multipart/mixed; boundary=%s", boundary);
+    msIO_sendHeaders();
+    msIO_fprintf(stdout, "--%s\r\n", boundary);
+
+    papszAdditionalFiles = msOGROutputGetAdditonalFiles(map);
+    file_list = msCSLConcatenate(file_list, papszAdditionalFiles);
+    CSLDestroy(papszAdditionalFiles);
+
+    for (i = 0; file_list != NULL && file_list[i] != NULL; i++) {
+      VSILFILE *fp;
+      int bytes_read;
+      char buffer[1024];
+
+      if (sendheaders)
+        msIO_fprintf(stdout,
+                     "Content-Disposition: attachment; filename=%s\r\n"
+                     "Content-Type: application/binary\r\n"
+                     "Content-Transfer-Encoding: binary\r\n\r\n",
+                     CPLGetFilename(file_list[i]));
+
+      fp = VSIFOpenL(file_list[i], "r");
+      if (fp == NULL) {
+        msSetError(MS_MISCERR, "Failed to open result file '%s'.",
+                   "msOGRWriteFromQuery()", file_list[0]);
+        msOGRCleanupDS(datasource_name);
+        return MS_FAILURE;
+      }
+
+      while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0)
+        msIO_fwrite(buffer, 1, bytes_read, stdout);
+      VSIFCloseL(fp);
+
+      if (file_list[i + 1] == NULL)
+        msIO_fprintf(stdout, "\r\n--%s--\r\n", boundary);
+      else
+        msIO_fprintf(stdout, "\r\n--%s\r\n", boundary);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle the case of a zip file result.                           */
+  /* -------------------------------------------------------------------- */
+  else if (EQUAL(form, "zip")) {
+    VSILFILE *fp;
+    char *zip_filename = msTmpFile(map, NULL, "/vsimem/ogrzip/", "zip");
+    void *hZip;
+    int bytes_read;
+    char buffer[1024];
+    char **papszAdditionalFiles;
+
+    hZip = CPLCreateZip(zip_filename, NULL);
+
+    papszAdditionalFiles = msOGROutputGetAdditonalFiles(map);
+    file_list = msCSLConcatenate(file_list, papszAdditionalFiles);
+    CSLDestroy(papszAdditionalFiles);
+
+    for (i = 0; file_list != NULL && file_list[i] != NULL; i++) {
+
+      const std::string osArchiveFilename(CPLGetFilename(file_list[i]));
+#if GDAL_VERSION_MAJOR > 3 ||                                                  \
+    (GDAL_VERSION_MAJOR == 3 && GDAL_VERSION_MINOR >= 7)
+      if (CPLAddFileInZip(hZip, osArchiveFilename.c_str(), file_list[i],
+                          nullptr, nullptr, nullptr, nullptr) != CE_None) {
+        msSetError(MS_MISCERR, "CPLAddFileInZip() failed for %s",
+                   "msOGRWriteFromQuery()", file_list[i]);
+        CPLCloseZip(hZip);
+        msOGRCleanupDS(datasource_name);
+        return MS_FAILURE;
+      }
+#else
+      if (CPLCreateFileInZip(hZip, osArchiveFilename.c_str(), NULL) !=
+          CE_None) {
+        msSetError(MS_MISCERR, "CPLWriteFileInZip() failed for %s",
+                   "msOGRWriteFromQuery()", file_list[i]);
+        CPLCloseZip(hZip);
+        msOGRCleanupDS(datasource_name);
+        return MS_FAILURE;
+      }
+
+      fp = VSIFOpenL(file_list[i], "r");
+      if (fp == NULL) {
+        CPLCloseZip(hZip);
+        msSetError(MS_MISCERR, "Failed to open result file '%s'.",
+                   "msOGRWriteFromQuery()", file_list[i]);
+        msOGRCleanupDS(datasource_name);
+        return MS_FAILURE;
+      }
+
+      while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0) {
+        if (CPLWriteFileInZip(hZip, buffer, bytes_read) != CE_None) {
+          msSetError(MS_MISCERR, "CPLWriteFileInZip() failed for %s",
+                     "msOGRWriteFromQuery()", file_list[i]);
+          VSIFCloseL(fp);
+          CPLCloseFileInZip(hZip);
+          CPLCloseZip(hZip);
+          msOGRCleanupDS(datasource_name);
+          return MS_FAILURE;
+        }
+      }
+      VSIFCloseL(fp);
+
+      CPLCloseFileInZip(hZip);
+#endif
+    }
+    CPLCloseZip(hZip);
+
+    if (sendheaders) {
+      const char *zip_filename = fo_filename;
+      /* Make sure the filename is ended by .zip */
+      if (!EQUAL(CPLGetExtension(zip_filename), "zip") &&
+          !EQUAL(CPLGetExtension(zip_filename), "kmz"))
+        zip_filename = CPLFormFilename(NULL, fo_filename, "zip");
+      msIO_setHeader("Content-Disposition", "attachment; filename=%s",
+                     zip_filename);
+      msIO_setHeader("Content-Type", "application/zip");
+      msIO_sendHeaders();
+    }
+
+    fp = VSIFOpenL(zip_filename, "r");
+    if (fp == NULL) {
+      msSetError(MS_MISCERR, "Failed to open zip file '%s'.",
+                 "msOGRWriteFromQuery()", file_list[0]);
+      msOGRCleanupDS(datasource_name);
+      return MS_FAILURE;
+    }
+
+    while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0)
+      msIO_fwrite(buffer, 1, bytes_read, stdout);
+    VSIFCloseL(fp);
+
+    msFree(zip_filename);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle illegal form value.                                      */
+  /* -------------------------------------------------------------------- */
+  else {
+    msSetError(MS_MISCERR, "Unsupported FORM=%s value.",
+               "msOGRWriteFromQuery()", form);
+    msOGRCleanupDS(datasource_name);
+    return MS_FAILURE;
+  }
+
+  msOGRCleanupDS(datasource_name);
+
+  CSLDestroy(file_list);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                     msPopulateRenderVTableOGR()                      */
+/************************************************************************/
+
+int msPopulateRendererVTableOGR(rendererVTableObj *renderer) {
+  (void)renderer;
+  /* we aren't really a normal renderer so we leave everything default */
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/maporaclespatial.c 8.2.0~beta1-1~exp1/src/maporaclespatial.c
--- 8.0.1-5/src/maporaclespatial.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maporaclespatial.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4809 @@
+/******************************************************************************
+ * Project: MapServer
+ * Purpose: Native access to Oracle Spatial (SDO) data.
+ * Author:  Fernando Simon (fsimon@univali.br)
+ *          Rodrigo Becke Cabral
+ *          Adriana Gomes Alves
+ *
+ * Notes: Developed under several funding agreements:
+ *
+ *   1) n.45/00 between CTTMAR/UNIVALI (www.cttmar.univali.br)
+ *      and CEPSUL/IBAMA (www.ibama.gov.br)
+ *
+ *   2) CNPq (www.cnpq.br) under process 401263.03-7
+ *
+ *   3) FUNCITEC (www.funcitec.rct-sc.br) under process FCTP1523-031
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "maptime.h"
+#include "mapows.h"
+#include <assert.h>
+
+#if defined(USE_ORACLESPATIAL) || defined(USE_ORACLE_PLUGIN)
+
+#include <oci.h>
+#include <ctype.h>
+
+#define ARRAY_SIZE 1024
+#define QUERY_SIZE 1
+#define TEXT_SIZE 4000 /* ticket #2260 */
+#define TYPE_OWNER "MDSYS"
+#define SDO_GEOMETRY TYPE_OWNER ".SDO_GEOMETRY"
+#define SDO_ORDINATE_ARRAY TYPE_OWNER ".SDO_ORDINATE_ARRAY"
+#define SDO_GEOMETRY_LEN strlen(SDO_GEOMETRY)
+#define FUNCTION_FILTER 1
+#define FUNCTION_RELATE 2
+#define FUNCTION_GEOMRELATE 3
+#define FUNCTION_NONE 4
+#define VERSION_8i 1
+#define VERSION_9i 2
+#define VERSION_10g 3
+#define TOLERANCE 0.001
+#define NULLERRCODE 1405
+#define TABLE_NAME_SIZE 2000
+
+typedef struct {
+  OCINumber x;
+  OCINumber y;
+  OCINumber z;
+} SDOPointObj;
+
+typedef struct {
+  OCINumber gtype;
+  OCINumber srid;
+  SDOPointObj point;
+  OCIArray *elem_info;
+  OCIArray *ordinates;
+} SDOGeometryObj;
+
+typedef struct {
+  OCIInd _atomic;
+  OCIInd x;
+  OCIInd y;
+  OCIInd z;
+} SDOPointInd;
+
+typedef struct {
+  OCIInd _atomic;
+  OCIInd gtype;
+  OCIInd srid;
+  SDOPointInd point;
+  OCIInd elem_info;
+  OCIInd ordinates;
+} SDOGeometryInd;
+
+typedef text item_text[TEXT_SIZE];
+
+typedef item_text item_text_array[ARRAY_SIZE];
+
+typedef item_text item_text_array_query[QUERY_SIZE];
+
+typedef ub2 query_dtype[ARRAY_SIZE];
+
+typedef struct {
+  /*Oracle handlers (global to connection)*/
+  OCIEnv *envhp;
+  OCIError *errhp;
+  OCISvcCtx *svchp;
+  int last_oci_status;
+  text last_oci_error[2048];
+  /* This references counter is to avoid the cache freed if there are other
+   * layers that could use it */
+  int ref_count;
+} msOracleSpatialHandler;
+
+typedef struct {
+  /* Oracle data handlers (global to connection) */
+  OCIDescribe *dschp;
+  OCIType *tdo;
+} msOracleSpatialDataHandler;
+
+typedef struct {
+  OCIStmt *stmthp;
+
+  /* fetch data buffer */
+  ub4 rows_count;   /* total number of rows (so far) within cursor */
+  ub4 row_num;      /* current row index within cursor results */
+  ub4 rows_fetched; /* total number of rows fetched into our buffer */
+  ub4 row;          /* current row index within our buffer */
+
+  item_text_array *items;             /* items buffer */
+  item_text_array_query *items_query; /* items buffer */
+  SDOGeometryObj *obj[ARRAY_SIZE];    /* spatial object buffer */
+  SDOGeometryInd *ind[ARRAY_SIZE];    /* object indicator (null) buffer */
+
+  int uniqueidindex; /*allows to keep which attribute id index is used as unique
+                        id*/
+
+} msOracleSpatialStatement;
+
+typedef struct {
+  /* oracle handlers */
+  msOracleSpatialHandler *orahandlers;
+
+  /* oracle data handlers */
+  msOracleSpatialDataHandler *oradatahandlers;
+  msOracleSpatialStatement *orastmt;
+
+  /* Following items are setup by WhichShapes
+   * used by NextShape, ResultGetShape
+   * disposed by CloseLayer (if set)
+   */
+  msOracleSpatialStatement *orastmt2;
+  /* Driver handling of pagination, enabled by default */
+  int paging;
+
+} msOracleSpatialLayerInfo;
+
+static OCIType *ordinates_tdo = NULL;
+static OCIArray *ordinates;
+
+/* local prototypes */
+static int TRY(msOracleSpatialHandler *hand, sword status);
+static int ERROR(char *routine, msOracleSpatialHandler *hand,
+                 msOracleSpatialDataHandler *dthand);
+static void msSplitLogin(char *connection, mapObj *map, char **username,
+                         char **password, char **dblink);
+static int msSplitData(char *data, char **geometry_column_name,
+                       char **table_name, char **unique, char **srid,
+                       char **indexfield, int *function, int *version);
+static void msOCICloseConnection(void *layerinfo);
+static msOracleSpatialHandler *msOCISetHandlers(char *username, char *password,
+                                                char *dblink);
+static int msOCISetDataHandlers(msOracleSpatialHandler *hand,
+                                msOracleSpatialDataHandler *dthand);
+static void msOCICloseDataHandlers(msOracleSpatialDataHandler *dthand);
+static void msOCICloseHandlers(msOracleSpatialHandler *hand);
+static void msOCIClearLayerInfo(msOracleSpatialLayerInfo *layerinfo);
+static int msOCIOpenStatement(msOracleSpatialHandler *hand,
+                              msOracleSpatialStatement *sthand);
+static void msOCIFinishStatement(msOracleSpatialStatement *sthand);
+static int msOCIGet2DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e, pointObj *pt);
+static int msOCIGet3DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e, pointObj *pt);
+static int msOCIGet4DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e, pointObj *pt);
+static int msOCIConvertCircle(pointObj *pt);
+static char *osFilteritem(layerObj *layer, int function, char *query_str,
+                          int mode);
+static char *osAggrGetExtent(layerObj *layer, char *query_str,
+                             char *geom_column_name, char *table_name);
+static char *osGeodeticData(int function, char *query_str,
+                            char *geom_column_name, char *index_column_name);
+static char *osNoGeodeticData(int function, int version, char *query_str,
+                              char *geom_column_name, char *index_column_name);
+static double osCalculateArcRadius(pointObj *pnt);
+static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius,
+                           double npoints, int side, lineObj arcline,
+                           shapeObj *shape);
+static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points,
+                          int i, int data3d, int data4d);
+static void osShapeBounds(shapeObj *shp);
+static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d,
+                         int data4d);
+static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape,
+                           SDOGeometryObj *obj, int start, int end,
+                           lineObj points, int interpretation, int data3d,
+                           int data4d);
+static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape,
+                    SDOGeometryObj *obj, int start, int end, lineObj points,
+                    pointObj *pnt, int data3d, int data4d);
+static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                            SDOGeometryObj *obj, int start, int end,
+                            lineObj points, int elem_type, int data3d,
+                            int data4d);
+static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape,
+                        SDOGeometryObj *obj, int start, int end, lineObj points,
+                        pointObj *pnt, int data3d, int data4d);
+static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape,
+                     SDOGeometryObj *obj, int start, int end, lineObj points,
+                     pointObj *pnt, int data3d, int data4d);
+static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                         SDOGeometryObj *obj, int start, int end,
+                         lineObj arcpoints, int elem_type, int data3d,
+                         int data4d);
+static int osGetOrdinates(msOracleSpatialDataHandler *dthand,
+                          msOracleSpatialHandler *hand, shapeObj *shape,
+                          SDOGeometryObj *obj, SDOGeometryInd *ind);
+static int osCheck2DGtype(int pIntGtype);
+static int osCheck3DGtype(int pIntGtype);
+static int osCheck4DGtype(int pIntGtype);
+
+/******************************************************************************
+ *                          Local Helper Functions                            *
+ ******************************************************************************/
+
+/* if an error ocurred call msSetError, sets last_oci_status to MS_FAILURE and
+ * return 0; otherwise returns 1 */
+static int TRY(msOracleSpatialHandler *hand, sword status) {
+  sb4 errcode = 0;
+
+  if (hand->last_oci_status == MS_FAILURE)
+    return 0; /* error from previous call */
+
+  switch (status) {
+  case OCI_SUCCESS_WITH_INFO:
+  case OCI_ERROR:
+    OCIErrorGet((dvoid *)hand->errhp, (ub4)1, (text *)NULL, &errcode,
+                hand->last_oci_error, (ub4)sizeof(hand->last_oci_error),
+                OCI_HTYPE_ERROR);
+    if (errcode == NULLERRCODE) {
+      hand->last_oci_error[0] = (text)'\0';
+      return 1;
+    }
+    hand->last_oci_error[sizeof(hand->last_oci_error) - 1] =
+        0; /* terminate string!? */
+    break;
+  case OCI_NEED_DATA:
+    strlcpy((char *)hand->last_oci_error, "OCI_NEED_DATA",
+            sizeof(hand->last_oci_error));
+    break;
+  case OCI_INVALID_HANDLE:
+    strlcpy((char *)hand->last_oci_error, "OCI_INVALID_HANDLE",
+            sizeof(hand->last_oci_error));
+    break;
+  case OCI_STILL_EXECUTING:
+    ((char *)hand->last_oci_error)[sizeof(hand->last_oci_error) - 1] = 0;
+    break;
+  case OCI_CONTINUE:
+    strlcpy((char *)hand->last_oci_error, "OCI_CONTINUE",
+            sizeof(hand->last_oci_error));
+    break;
+  default:
+    return 1; /* no error */
+  }
+
+  /* if I got here, there was an error */
+  hand->last_oci_status = MS_FAILURE;
+
+  return 0; /* error! */
+}
+
+OCIType *get_tdo(char *typename, msOracleSpatialHandler *hand,
+                 msOracleSpatialDataHandler *dthand) {
+  OCIParam *paramp = NULL;
+  OCIRef *type_ref = NULL;
+  OCIType *tdoe = NULL;
+  int success = 0;
+
+  success =
+      TRY(hand, OCIDescribeAny(hand->svchp, hand->errhp, (text *)typename,
+                               (ub4)strlen((char *)typename), OCI_OTYPE_NAME,
+                               (ub1)1, (ub1)OCI_PTYPE_TYPE, dthand->dschp)) &&
+      TRY(hand, OCIAttrGet((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE,
+                           (dvoid *)&paramp, (ub4 *)0, (ub4)OCI_ATTR_PARAM,
+                           hand->errhp)) &&
+      TRY(hand,
+          OCIAttrGet((dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref,
+                     (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp)) &&
+      TRY(hand,
+          OCIObjectPin(hand->envhp, hand->errhp, type_ref,
+                       (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION,
+                       OCI_LOCK_NONE, (dvoid **)&tdoe));
+  if (success)
+    return tdoe;
+
+  /* if failure, return NULL*/
+  return NULL;
+}
+
+/* check last_oci_status for MS_FAILURE (set by TRY()) if an error ocurred
+ * return 1; otherwise, returns 0 */
+static int ERROR(char *routine, msOracleSpatialHandler *hand,
+                 msOracleSpatialDataHandler *dthand) {
+  (void)dthand;
+  if (hand->last_oci_status == MS_FAILURE) {
+    /* there was an error */
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "OracleSpatial server returned an error, check logs for more details",
+        routine);
+    msDebug("OracleSpatial server returned an error in funtion (%s): %s.\n",
+            routine, (char *)hand->last_oci_error);
+
+    /* reset error flag */
+    hand->last_oci_status = MS_SUCCESS;
+
+    return 1; /* error processed */
+  } else
+    return 0; /* no error */
+}
+
+/* break layer->connection (username/password@dblink) into username, password
+ * and dblink */
+static void msSplitLogin(char *connection, mapObj *map, char **username,
+                         char **password, char **dblink) {
+  char *src, *tgt, *conn_decrypted;
+  size_t buffer_size = 0;
+
+  /* bad 'connection' */
+  if (connection == NULL)
+    return;
+
+  buffer_size = strlen(connection) + 1;
+  *username = (char *)malloc(buffer_size);
+  *password = (char *)malloc(buffer_size);
+  *dblink = (char *)malloc(buffer_size);
+
+  /* clearup */
+  **username = **password = **dblink = 0;
+
+  /* Decrypt any encrypted token */
+  conn_decrypted = msDecryptStringTokens(map, connection);
+  if (conn_decrypted == NULL)
+    return;
+
+  /* ok, split connection */
+  for (tgt = *username, src = conn_decrypted; *src; src++, tgt++)
+    if (*src == '/' || *src == '@')
+      break;
+    else
+      *tgt = *src;
+  *tgt = 0;
+  if (*src == '/') {
+    for (tgt = *password, ++src; *src; src++, tgt++)
+      if (*src == '@')
+        break;
+      else
+        *tgt = *src;
+    *tgt = 0;
+  }
+  if (*src == '@') {
+    strlcpy(*dblink, ++src, buffer_size);
+  }
+
+  msFree(conn_decrypted);
+}
+
+/* break layer->data into geometry_column_name, table_name and srid */
+static int msSplitData(char *data, char **geometry_column_name,
+                       char **table_name, char **unique, char **srid,
+                       char **indexfield, int *function, int *version) {
+  char *tok_from = "from";
+  char *tok_using = "using";
+  char *tok_unique = "unique";
+  char *tok_srid = "srid";
+  char *tok_indexfield = "indexfield";
+  char *tok_version = "version";
+  char data_version[4] = "";
+  char tok_function[11] = "";
+  int parenthesis, i;
+  char *src = data, *tgt;
+  int table_name_size = TABLE_NAME_SIZE;
+  size_t buffer_size = 0;
+
+  /* bad 'data' */
+  if (data == NULL)
+    return 0;
+
+  buffer_size = strlen(data) + 1;
+  *geometry_column_name = (char *)malloc(buffer_size);
+  *unique = (char *)malloc(buffer_size);
+  *srid = (char *)malloc(buffer_size);
+  *indexfield = (char *)malloc(buffer_size);
+
+  /* clearup */
+  **geometry_column_name = **table_name = 0;
+
+  /* parsing 'geometry_column_name' */
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+  for (tgt = *geometry_column_name; *src; src++, tgt++)
+    if (isspace(*src))
+      break;
+    else
+      *tgt = *src;
+  *tgt = 0;
+
+  /* parsing 'from' */
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+  for (; *src && *tok_from && tolower(*src) == *tok_from; src++, tok_from++)
+    ;
+  if (*tok_from != '\0')
+    return 0;
+
+  /* parsing 'table_name' or '(SELECT stmt)' */
+  i = 0;
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+  for (tgt = *table_name, parenthesis = 0; *src; src++, tgt++, ++i) {
+    if (*src == '(')
+      parenthesis++;
+    else if (*src == ')')
+      parenthesis--;
+    else if (parenthesis == 0 && isspace(*src))
+      break; /* stop on spaces */
+    /* double the size of the table_name array if necessary */
+    if (i == table_name_size) {
+      size_t tgt_offset = tgt - *table_name;
+      table_name_size *= 2;
+      *table_name =
+          (char *)realloc(*table_name, sizeof(char *) * table_name_size);
+      tgt = *table_name + tgt_offset;
+    }
+    *tgt = *src;
+  }
+  *tgt = 0;
+
+  strlcpy(*unique, "", buffer_size);
+  strlcpy(*srid, "NULL", buffer_size);
+  strlcpy(*indexfield, "", buffer_size);
+
+  *function = -1;
+  *version = -1;
+
+  /* parsing 'unique' */
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+  if (*src != '\0') {
+    /* parse 'using' */
+    for (; *src && *tok_using && tolower(*src) == *tok_using;
+         src++, tok_using++)
+      ;
+    if (*tok_using != '\0')
+      return 0;
+
+    /* parsing 'unique' */
+    for (; *src && isspace(*src); src++)
+      ; /* skip blanks */
+    for (; *src && *tok_unique && tolower(*src) == *tok_unique;
+         src++, tok_unique++)
+      ;
+
+    if (*tok_unique == '\0') {
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
+      if (*src == '\0')
+        return 0;
+      for (tgt = *unique; *src; src++, tgt++)
+        if (isspace(*src))
+          break;
+        else
+          *tgt = *src;
+      *tgt = 0;
+
+      if (*tok_unique != '\0')
+        return 0;
+    }
+
+    /* parsing 'srid' */
+    for (; *src && isspace(*src); src++)
+      ; /* skip blanks */
+    for (; *src && *tok_srid && tolower(*src) == *tok_srid; src++, tok_srid++)
+      ;
+    if (*tok_srid == '\0') {
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
+      if (*src == '\0')
+        return 0;
+      for (tgt = *srid; *src; src++, tgt++)
+        if (isspace(*src))
+          break;
+        else
+          *tgt = *src;
+      *tgt = 0;
+
+      if (*tok_srid != '\0')
+        return 0;
+    }
+
+    /* parsing 'indexfield' */
+    for (; *src && isspace(*src); src++)
+      ; /* skip blanks */
+    for (; *src && *tok_indexfield && tolower(*src) == *tok_indexfield;
+         src++, tok_indexfield++)
+      ;
+
+    if (*tok_indexfield == '\0') {
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
+      if (*src == '\0')
+        return 0;
+      for (tgt = *indexfield; *src; src++, tgt++)
+        if (isspace(*src))
+          break;
+        else
+          *tgt = *src;
+      *tgt = 0;
+
+      if (*tok_indexfield != '\0')
+        return 0;
+    }
+
+    /*parsing function/version */
+    for (; *src && isspace(*src); src++)
+      ;
+    if (*src != '\0') {
+      for (tgt = tok_function; *src; src++, tgt++)
+        if (isspace(*src))
+          break;
+        else
+          *tgt = *src;
+      *tgt = 0;
+    }
+
+    /*Upcase conversion for the FUNCTION/VERSION token*/
+    for (i = 0; tok_function[i] != '\0'; i++)
+      tok_function[i] = toupper(tok_function[i]);
+
+    if (strcmp(tok_function, "VERSION")) {
+      if (!strcmp(tok_function, "FILTER") || !strcmp(tok_function, ""))
+        *function = FUNCTION_FILTER;
+      else if (!strcmp(tok_function, "RELATE"))
+        *function = FUNCTION_RELATE;
+      else if (!strcmp(tok_function, "GEOMRELATE"))
+        *function = FUNCTION_GEOMRELATE;
+      else if (!strcmp(tok_function, "NONE"))
+        *function = FUNCTION_NONE;
+      else {
+        *function = -1;
+        return 0;
+      }
+
+      /*parsing VERSION token when user defined one function*/
+      for (; *src && isspace(*src); src++)
+        ;
+      for (; *src && *tok_version && tolower(*src) == *tok_version;
+           src++, tok_version++)
+        ;
+    } else {
+      for (tgt = "VERSION";
+           *tgt && *tok_version && toupper(*tgt) == toupper(*tok_version);
+           tgt++, tok_version++)
+        ;
+      *function = FUNCTION_FILTER;
+    }
+
+    /*parsing version*/
+    if (*tok_version == '\0') {
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
+      for (tgt = data_version; *src; src++, tgt++)
+        if (isspace(*src))
+          break;
+        else
+          *tgt = *src;
+      *tgt = 0;
+
+      for (i = 0; data_version[i] != '\0'; i++)
+        data_version[i] = tolower(data_version[i]);
+
+      if (!strcmp(data_version, "8i"))
+        *version = VERSION_8i;
+      else if (!strcmp(data_version, "9i"))
+        *version = VERSION_9i;
+      else if (!strcmp(data_version, "10g"))
+        *version = VERSION_10g;
+      else
+        return 0;
+    }
+  }
+  /* finish parsing */
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+
+  return (*src == '\0');
+}
+
+/******************************************************************************
+ *                          OCI Helper Functions                              *
+ ******************************************************************************/
+
+/* create statement handle from database connection */
+static int msOCIOpenStatement(msOracleSpatialHandler *hand,
+                              msOracleSpatialStatement *sthand) {
+  int success = 0;
+  char *cmd = "";
+
+  /* allocate stmthp */
+  success =
+      TRY(hand, OCIHandleAlloc((dvoid *)hand->envhp, (dvoid **)&sthand->stmthp,
+                               (ub4)OCI_HTYPE_STMT, (size_t)0, (dvoid **)0));
+
+  sthand->rows_count = 0;
+  sthand->row_num = 0;
+  sthand->rows_fetched = 0;
+  sthand->row = 0;
+  sthand->items = NULL;
+  sthand->items_query = NULL;
+
+  /* setting environment values to enable time parsing */
+
+  cmd = "alter session set NLS_DATE_FORMAT='yyyy-mm-dd hh24:mi:ss'";
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
+
+  cmd = "alter session set NLS_TIMESTAMP_TZ_FORMAT='yyyy-mm-dd hh24:mi:ss'";
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
+
+  cmd = "alter session set NLS_TIMESTAMP_FORMAT = 'yyyy-mm-dd hh24:mi:ss'";
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
+
+  cmd = "alter session set time_zone = 'GMT'";
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
+
+  /* fprintf(stderr, "Creating statement handle at %p\n", sthand->stmthp); */
+
+  return success;
+}
+
+/* create statement handle from database connection */
+static void msOCIFinishStatement(msOracleSpatialStatement *sthand) {
+  if (sthand != NULL) {
+    /* fprintf(stderr, "Freeing statement handle at %p\n", sthand->stmthp); */
+
+    if (sthand->stmthp != NULL)
+      OCIHandleFree((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT);
+    if (sthand->items != NULL)
+      free(sthand->items);
+    if (sthand->items_query != NULL)
+      free(sthand->items_query);
+    memset(sthand, 0, sizeof(msOracleSpatialStatement));
+    free(sthand);
+  }
+}
+
+static int msOCISetDataHandlers(msOracleSpatialHandler *hand,
+                                msOracleSpatialDataHandler *dthand) {
+  int success = 0;
+  OCIParam *paramp = NULL;
+  OCIRef *type_ref = NULL;
+
+  success =
+      TRY(hand,
+          /* allocate dschp */
+          OCIHandleAlloc(hand->envhp, (dvoid **)&dthand->dschp,
+                         (ub4)OCI_HTYPE_DESCRIBE, (size_t)0, (dvoid **)0)) &&
+      TRY(hand,
+          /* describe SDO_GEOMETRY in svchp (dschp) */
+          OCIDescribeAny(hand->svchp, hand->errhp, (text *)SDO_GEOMETRY,
+                         (ub4)SDO_GEOMETRY_LEN, OCI_OTYPE_NAME, (ub1)1,
+                         (ub1)OCI_PTYPE_TYPE, dthand->dschp)) &&
+      TRY(hand,
+          /* get param for SDO_GEOMETRY */
+          OCIAttrGet((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE,
+                     (dvoid *)&paramp, (ub4 *)0, (ub4)OCI_ATTR_PARAM,
+                     hand->errhp)) &&
+      TRY(hand,
+          /* get type_ref for SDO_GEOMETRY */
+          OCIAttrGet((dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref,
+                     (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp)) &&
+      TRY(hand,
+          /* get TDO for SDO_GEOMETRY */
+          OCIObjectPin(hand->envhp, hand->errhp, type_ref,
+                       (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION,
+                       OCI_LOCK_NONE, (dvoid **)&dthand->tdo));
+
+  return success;
+}
+
+/* connect to database */
+static msOracleSpatialHandler *msOCISetHandlers(char *username, char *password,
+                                                char *dblink) {
+  int success;
+
+  msOracleSpatialHandler *hand = NULL;
+
+  hand = (msOracleSpatialHandler *)malloc(sizeof(msOracleSpatialHandler));
+  if (hand == NULL) {
+    msSetError(MS_MEMERR, NULL, "msOCISetHandlers()");
+    return NULL;
+  }
+  memset(hand, 0, sizeof(msOracleSpatialHandler));
+
+  hand->ref_count = 1;
+  hand->last_oci_status = MS_SUCCESS;
+  hand->last_oci_error[0] = (text)'\0';
+
+  success = TRY(hand,
+  /* allocate envhp */
+#ifdef USE_THREAD
+                OCIEnvCreate(&hand->envhp, OCI_OBJECT | OCI_THREADED,
+                             (dvoid *)0, 0, 0, 0, (size_t)0, (dvoid **)0))
+#else
+                OCIEnvCreate(&hand->envhp, OCI_OBJECT, (dvoid *)0, 0, 0, 0,
+                             (size_t)0, (dvoid **)0))
+#endif
+            &&
+            TRY(hand,
+                /* allocate errhp */
+                OCIHandleAlloc((dvoid *)hand->envhp, (dvoid **)&hand->errhp,
+                               (ub4)OCI_HTYPE_ERROR, (size_t)0, (dvoid **)0)) &&
+            TRY(hand,
+                /* logon */
+                OCILogon(hand->envhp, hand->errhp, &hand->svchp,
+                         (text *)username, strlen(username), (text *)password,
+                         strlen(password), (text *)dblink, strlen(dblink)));
+
+  if (!success) {
+    msDebug("Cannot create OCI Handlers. "
+            "Connection failure."
+            "Error: %s."
+            "msOracleSpatialLayerOpen()\n",
+            hand->last_oci_error);
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "Cannot create OCI Handlers. "
+        "Connection failure. Check your logs and the connection string. ",
+        "msOracleSpatialLayerOpen()");
+
+    msOCICloseHandlers(hand);
+    return NULL;
+  }
+
+  return hand;
+}
+
+/* disconnect from database */
+static void msOCICloseHandlers(msOracleSpatialHandler *hand) {
+  if (hand->svchp != NULL)
+    OCILogoff(hand->svchp, hand->errhp);
+  if (hand->errhp != NULL)
+    OCIHandleFree((dvoid *)hand->errhp, (ub4)OCI_HTYPE_ERROR);
+  if (hand->envhp != NULL)
+    OCIHandleFree((dvoid *)hand->envhp, (ub4)OCI_HTYPE_ENV);
+  if (hand != NULL)
+    memset(hand, 0, sizeof(msOracleSpatialHandler));
+  free(hand);
+}
+
+static void msOCICloseDataHandlers(msOracleSpatialDataHandler *dthand) {
+  if (dthand->dschp != NULL)
+    OCIHandleFree((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE);
+  if (dthand != NULL)
+    memset(dthand, 0, sizeof(msOracleSpatialDataHandler));
+  free(dthand);
+}
+
+static void msOCIClearLayerInfo(msOracleSpatialLayerInfo *layerinfo) {
+  if (layerinfo != NULL) {
+    memset(layerinfo, 0, sizeof(msOracleSpatialLayerInfo));
+    free(layerinfo);
+  }
+}
+
+/*function that creates the correct sql for geoditical srid for version 9i*/
+static char *osGeodeticData(int function, char *query_str,
+                            char *geom_column_name, char *index_column_name) {
+  char *filter_field =
+      index_column_name[0] == '\0' ? geom_column_name : index_column_name;
+  switch (function) {
+  case FUNCTION_FILTER: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates ), :srid),"
+                   "'querytype=window') = 'TRUE'");
+    break;
+  }
+  case FUNCTION_RELATE: {
+    query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates ), :srid),"
+                   "'mask=anyinteract querytype=window') = 'TRUE'");
+    break;
+  }
+  case FUNCTION_GEOMRELATE: {
+    char tmpFloat[256];
+    snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
+
+    query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates), :srid),");
+    query_str = msStringConcatenate(query_str, tmpFloat);
+    query_str = msStringConcatenate(query_str, ") = 'TRUE' AND ");
+    query_str = msStringConcatenate(query_str, geom_column_name);
+    query_str = msStringConcatenate(query_str, " IS NOT NULL");
+    break;
+  }
+  case FUNCTION_NONE: {
+    break;
+  }
+  default: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates), :srid),"
+                   "'querytype=window') = 'TRUE'");
+  }
+  }
+  return query_str;
+}
+
+/*function that generate the correct sql for no geoditic srid's*/
+static char *osNoGeodeticData(int function, int version, char *query_str,
+                              char *geom_column_name, char *index_column_name) {
+  char *filter_field =
+      index_column_name[0] == '\0' ? geom_column_name : index_column_name;
+  switch (function) {
+  case FUNCTION_FILTER: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", MDSYS.SDO_GEOMETRY("
+                   "2003, :srid, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   /*   "MDSYS.SDO_ORDINATE_ARRAY(%.9g,%.9g,%.9g,%.9g)" */
+                   ":ordinates"
+                   " ),'querytype=window') = 'TRUE'");
+    break;
+  }
+  case FUNCTION_RELATE: {
+    if (version == VERSION_10g) {
+      query_str = msStringConcatenate(query_str, "SDO_ANYINTERACT( ");
+      query_str = msStringConcatenate(query_str, filter_field);
+      query_str =
+          msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
+                                         "2003, :srid, NULL,"
+                                         "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                                         ":ordinates)) = 'TRUE'");
+    } else {
+
+      query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
+      query_str = msStringConcatenate(query_str, geom_column_name);
+      query_str = msStringConcatenate(
+          query_str, ", MDSYS.SDO_GEOMETRY("
+                     "2003, :srid, NULL,"
+                     "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                     ":ordinates),"
+                     "'mask=anyinteract querytype=window') = 'TRUE'");
+    }
+    break;
+  }
+  case FUNCTION_GEOMRELATE: {
+    char tmpFloat[256];
+    snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
+
+    query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
+    query_str = msStringConcatenate(query_str, index_column_name);
+    query_str =
+        msStringConcatenate(query_str, ", 'anyinteract', MDSYS.SDO_GEOMETRY("
+                                       "2003, :srid, NULL,"
+                                       "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                                       ":ordinates),");
+    query_str = msStringConcatenate(query_str, tmpFloat);
+    query_str = msStringConcatenate(query_str, ") = 'TRUE' AND ");
+    query_str = msStringConcatenate(query_str, geom_column_name);
+    query_str = msStringConcatenate(query_str, " IS NOT NULL");
+    break;
+  }
+  case FUNCTION_NONE: {
+    break;
+  }
+  default: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str =
+        msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
+                                       "2003, :srid, NULL,"
+                                       "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                                       ":ordinates),"
+                                       "'querytype=window') = 'TRUE'");
+  }
+  }
+  return query_str;
+}
+
+/* get ordinates from SDO buffer */
+static int msOCIGet2DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e,
+                               pointObj *pt) {
+  double x, y;
+  int i, n, success = 1;
+  boolean exists;
+  OCINumber *oci_number;
+
+  for (i = s, n = 0; i < e && success; i += 2, n++) {
+    success = TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&x)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 1,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&y));
+
+    if (success) {
+      pt[n].x = x;
+      pt[n].y = y;
+    }
+  }
+
+  return success ? n : 0;
+}
+
+static int msOCIGet3DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e,
+                               pointObj *pt) {
+  double x, y;
+  int i, n, success = 1;
+  boolean exists;
+  double z;
+  boolean numnull;
+  OCINumber *oci_number;
+
+  for (i = s, n = 0; i < e && success; i += 3, n++) {
+    success = TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&x)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 1,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&y)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 2,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0));
+    if (success) {
+      success = TRY(
+          hand, OCINumberIsZero(hand->errhp, oci_number, (boolean *)&numnull));
+      if (success) {
+        success =
+            TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                      (uword)sizeof(double), (dvoid *)&z));
+      } else {
+        hand->last_oci_status = MS_SUCCESS;
+        strlcpy((char *)hand->last_oci_error,
+                "Retrieve z value, but NULL value for z. Setting z to 0.",
+                sizeof(hand->last_oci_error));
+        z = 0;
+        success = 1;
+      }
+    }
+    if (success) {
+      pt[n].x = x;
+      pt[n].y = y;
+      pt[n].z = z;
+    }
+  }
+
+  return success ? n : 0;
+}
+
+static int msOCIGet4DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e,
+                               pointObj *pt) {
+  double x, y;
+  int i, n, success = 1;
+  boolean exists;
+  double z;
+  boolean numnull;
+  OCINumber *oci_number;
+
+  for (i = s, n = 0; i < e && success; i += 4, n++) {
+    success = TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&x)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 1,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&y)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 2,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0));
+
+    if (success) {
+      success = TRY(
+          hand, OCINumberIsZero(hand->errhp, oci_number, (boolean *)&numnull));
+      if (success) {
+        success =
+            TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                      (uword)sizeof(double), (dvoid *)&z));
+      } else {
+        hand->last_oci_status = MS_SUCCESS;
+        strlcpy((char *)hand->last_oci_error,
+                "Retrieve z value, but NULL value for z. Setting z to 0.",
+                sizeof(hand->last_oci_error));
+        z = 0;
+        success = 1;
+      }
+    }
+
+    if (success) {
+      pt[n].x = x;
+      pt[n].y = y;
+      pt[n].z = z;
+    }
+  }
+  return success ? n : 0;
+}
+
+/* convert three-point circle to two-point rectangular bounds */
+static int msOCIConvertCircle(pointObj *pt) {
+  pointObj ptaux;
+  double dXa, dXb;
+  double ma, mb;
+  double cx, cy, r;
+  int success;
+
+  dXa = pt[1].x - pt[0].x;
+  success = (fabs(dXa) > 1e-8);
+  if (!success) {
+    /* switch points 1 & 2 */
+    ptaux = pt[1];
+    pt[1] = pt[2];
+    pt[2] = ptaux;
+    dXa = pt[1].x - pt[0].x;
+    success = (fabs(dXa) > 1e-8);
+  }
+  if (success) {
+    dXb = pt[2].x - pt[1].x;
+    success = (fabs(dXb) > 1e-8);
+    if (!success) {
+      /* insert point 2 before point 0 */
+      ptaux = pt[2];
+      pt[2] = pt[1];
+      pt[1] = pt[0];
+      pt[0] = ptaux;
+      dXb = dXa;               /* segment A has become B */
+      dXa = pt[1].x - pt[0].x; /* recalculate new segment A */
+      success = (fabs(dXa) > 1e-8);
+    }
+  }
+  if (success) {
+    ma = (pt[1].y - pt[0].y) / dXa;
+    mb = (pt[2].y - pt[1].y) / dXb;
+    success = (fabs(mb - ma) > 1e-8);
+  }
+  if (!success)
+    return 0;
+
+  /* calculate center and radius */
+  cx = (ma * mb * (pt[0].y - pt[2].y) + mb * (pt[0].x + pt[1].x) -
+        ma * (pt[1].x + pt[2].x)) /
+       (2 * (mb - ma));
+  cy = (fabs(ma) > 1e-8)
+           ? ((pt[0].y + pt[1].y) / 2 - (cx - (pt[0].x + pt[1].x) / 2) / ma)
+           : ((pt[1].y + pt[2].y) / 2 - (cx - (pt[1].x + pt[2].x) / 2) / mb);
+
+  r = sqrt(pow(pt[0].x - cx, 2) + pow(pt[0].y - cy, 2));
+
+  /* update pt buffer with rectangular bounds */
+  pt[0].x = cx - r;
+  pt[0].y = cy - r;
+  pt[1].x = cx + r;
+  pt[1].y = cy + r;
+
+  return 1;
+}
+
+/*function that creates the correct sql for filter and filteritem*/
+static char *osFilteritem(layerObj *layer, int function, char *query_str,
+                          int mode) {
+  if (layer->filter.native_string != NULL) {
+    if (mode == 1) {
+      query_str = msStringConcatenate(query_str, " WHERE ");
+    } else {
+      query_str = msStringConcatenate(query_str, " AND ");
+    }
+    size_t tmpBufSize =
+        (strlen(layer->filter.native_string) + 3) * sizeof(char);
+    char *tmpBuf = (char *)msSmallMalloc(tmpBufSize);
+    snprintf(tmpBuf, tmpBufSize, " %s ", layer->filter.native_string);
+
+    query_str = msStringConcatenate(query_str, tmpBuf);
+    msFree(tmpBuf);
+
+    if (function != FUNCTION_NONE) {
+      query_str = msStringConcatenate(query_str, " AND ");
+    }
+  } else {
+    if (function != FUNCTION_NONE) {
+      query_str = msStringConcatenate(query_str, " WHERE ");
+    }
+  }
+
+  /* Handle a native filter set as a PROCESSING option (#5001). */
+  if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+    if ((function == FUNCTION_NONE) && (layer->filter.native_string == NULL)) {
+      query_str = msStringConcatenate(query_str, " WHERE ");
+    }
+    if ((function == FUNCTION_NONE) && (layer->filter.native_string != NULL)) {
+      query_str = msStringConcatenate(query_str, " AND ");
+    }
+    size_t tmpSz;
+
+    const char *native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
+    char *tmpBuf = NULL;
+
+    tmpSz = sizeof(char) * (strlen(native_filter) + 2 + 1);
+    tmpBuf = msSmallMalloc(tmpSz);
+
+    snprintf(tmpBuf, tmpSz, " %s ", native_filter);
+    query_str = msStringConcatenate(query_str, tmpBuf);
+    msFree(tmpBuf);
+
+    if (function != FUNCTION_NONE) {
+      query_str = msStringConcatenate(query_str, " AND ");
+    }
+  }
+  return query_str;
+}
+
+static char *osAggrGetExtent(layerObj *layer, char *query_str,
+                             char *geom_column_name, char *table_name) {
+  char *query_str2 = NULL;
+  int i = 0;
+
+  query_str2 = msStringConcatenate(query_str2, "(SELECT");
+
+  for (i = 0; i < layer->numitems; ++i) {
+    size_t tmpSize = sizeof(char) * (strlen(layer->items[i]) + 1 /* '\0' */ +
+                                     2 /* " ", "," */);
+    char *tmpItem = (char *)msSmallMalloc(tmpSize);
+    snprintf(tmpItem, tmpSize, " %s,", layer->items[i]);
+
+    query_str2 = msStringConcatenate(query_str2, tmpItem);
+
+    msFree(tmpItem);
+  }
+
+  size_t tmpFromSize =
+      sizeof(char) * (7 + strlen(geom_column_name) + strlen(table_name) + 1);
+  char *tmpFrom = msSmallMalloc(tmpFromSize);
+  snprintf(tmpFrom, tmpFromSize, "%s FROM %s", geom_column_name, table_name);
+
+  query_str2 = msStringConcatenate(query_str2, tmpFrom);
+
+  msFree(tmpFrom);
+
+  query_str2 = osFilteritem(layer, FUNCTION_NONE, query_str2, 1);
+
+  query_str = msStringConcatenate(query_str, "SELECT SDO_AGGR_MBR(");
+  query_str = msStringConcatenate(query_str, geom_column_name);
+  query_str = msStringConcatenate(query_str, ") AS GEOM from ");
+  query_str = msStringConcatenate(query_str, query_str2);
+  query_str = msStringConcatenate(query_str, ")");
+
+  msFree(query_str2);
+
+  if (layer->debug)
+    msDebug("osAggrGetExtent was called: %s.\n", query_str);
+
+  return query_str;
+}
+
+static double osCalculateArcRadius(pointObj *pnt) {
+  double rc;
+  double r1, r2, r3;
+
+  r1 = sqrt(pow(pnt[0].x - pnt[1].x, 2) + pow(pnt[0].y - pnt[1].y, 2));
+  r2 = sqrt(pow(pnt[1].x - pnt[2].x, 2) + pow(pnt[1].y - pnt[2].y, 2));
+  r3 = sqrt(pow(pnt[2].x - pnt[0].x, 2) + pow(pnt[2].y - pnt[0].y, 2));
+  rc = (r1 + r2 + r3) / 2;
+
+  return ((r1 * r2 * r3) / (4 * sqrt(rc * (rc - r1) * (rc - r2) * (rc - r3))));
+}
+
+static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius,
+                           double npoints, int side, lineObj arcline,
+                           shapeObj *shape) {
+  double length, ctrl, angle;
+  double divbas, plusbas, cosbas, sinbas = 0;
+  double zrange = 0;
+  int i = 0;
+
+  if (npoints > 0) {
+    length = sqrt(((pnt[1].x - pnt[0].x) * (pnt[1].x - pnt[0].x)) +
+                  ((pnt[1].y - pnt[0].y) * (pnt[1].y - pnt[0].y)));
+    ctrl = length / (2 * radius);
+
+    if (data3d || data4d) {
+      /* is this cast (long) legit... ? */
+      zrange = labs((long)(pnt[0].z - pnt[1].z)) / npoints;
+      if ((pnt[0].z > pnt[1].z) && side == 1)
+        zrange *= -1;
+      else if ((pnt[0].z < pnt[1].z) && side == 1)
+        zrange = zrange;
+      else if ((pnt[0].z > pnt[1].z) && side != 1)
+        zrange *= -1;
+      else if ((pnt[0].z < pnt[1].z) && side != 1)
+        zrange = zrange;
+    }
+
+    if (ctrl <= 1) {
+      divbas = 2 * asin(ctrl);
+      plusbas = divbas / (npoints);
+      cosbas = (pnt[0].x - pnt[3].x) / radius;
+      sinbas = (pnt[0].y - pnt[3].y) / radius;
+      angle = plusbas;
+
+      arcline.point = (pointObj *)malloc(sizeof(pointObj) * (npoints + 1));
+      arcline.point[0].x = pnt[0].x;
+      arcline.point[0].y = pnt[0].y;
+      if (data3d || data4d)
+        arcline.point[0].z = pnt[0].z;
+
+      for (i = 1; i <= npoints; i++) {
+        if (side == 1) {
+          arcline.point[i].x = pnt[3].x + radius * ((cosbas * cos(angle)) -
+                                                    (sinbas * sin(angle)));
+          arcline.point[i].y = pnt[3].y + radius * ((sinbas * cos(angle)) +
+                                                    (cosbas * sin(angle)));
+          if (data3d || data4d)
+            arcline.point[i].z = pnt[0].z + (zrange * i);
+        } else {
+          if (side == -1) {
+            arcline.point[i].x = pnt[3].x + radius * ((cosbas * cos(angle)) +
+                                                      (sinbas * sin(angle)));
+            arcline.point[i].y = pnt[3].y + radius * ((sinbas * cos(angle)) -
+                                                      (cosbas * sin(angle)));
+            if (data3d || data4d)
+              arcline.point[i].z = pnt[0].z + (zrange * i);
+          } else {
+            arcline.point[i].x = pnt[0].x;
+            arcline.point[i].y = pnt[0].y;
+            if (data3d || data4d)
+              arcline.point[i].z = pnt[0].z;
+          }
+        }
+        angle += plusbas;
+      }
+
+      arcline.numpoints = npoints + 1;
+      msAddLine(shape, &arcline);
+      free(arcline.point);
+    }
+  } else {
+    arcline.point = (pointObj *)malloc(sizeof(pointObj) * (2));
+    arcline.point[0].x = pnt[0].x;
+    arcline.point[0].y = pnt[0].y;
+    arcline.point[1].x = pnt[1].x;
+    arcline.point[1].y = pnt[1].y;
+
+    if (data3d || data4d) {
+      arcline.point[0].z = pnt[0].z;
+      arcline.point[1].z = pnt[1].z;
+    }
+
+    arcline.numpoints = 2;
+
+    msAddLine(shape, &arcline);
+    free(arcline.point);
+  }
+}
+
+/* Part of this function was based on Terralib function TeGenerateArc
+ * found in TeGeometryAlgorith.cpp (www.terralib.org).
+ * Part of this function was based on Dr. Ialo (Univali/Cttmar) functions. */
+static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points,
+                          int i, int data3d, int data4d) {
+  double mult, plus1, plus2, plus3, bpoint;
+  double cx, cy;
+  double radius, side, area, npoints;
+  double dist1 = 0;
+  double dist2 = 0;
+  pointObj point5[4];
+
+  mult = (points.point[i + 1].x - points.point[i].x) *
+             (points.point[i + 2].y - points.point[i].y) -
+         (points.point[i + 1].y - points.point[i].y) *
+             (points.point[i + 2].x - points.point[i].x);
+
+  if (mult) {
+    /*point5 = (pointObj *)malloc(sizeof(pointObj)*(4));*/
+
+    plus1 = points.point[i].x * points.point[i].x +
+            points.point[i].y * points.point[i].y;
+    plus2 = points.point[i + 1].x * points.point[i + 1].x +
+            points.point[i + 1].y * points.point[i + 1].y;
+    plus3 = points.point[i + 2].x * points.point[i + 2].x +
+            points.point[i + 2].y * points.point[i + 2].y;
+
+    bpoint = plus1 * (points.point[i + 1].y - points.point[i + 2].y) +
+             plus2 * (points.point[i + 2].y - points.point[i].y) +
+             plus3 * (points.point[i].y - points.point[i + 1].y);
+
+    cx = bpoint / (2.0 * mult);
+
+    bpoint = plus1 * (points.point[i + 2].x - points.point[i + 1].x) +
+             plus2 * (points.point[i].x - points.point[i + 2].x) +
+             plus3 * (points.point[i + 1].x - points.point[i].x);
+
+    cy = bpoint / (2.0 * mult);
+
+    dist1 =
+        (points.point[i + 1].x - points.point[i].x) * (cy - points.point[i].y);
+    dist2 =
+        (points.point[i + 1].y - points.point[i].y) * (cx - points.point[i].x);
+    side = 0;
+
+    if ((dist1 - dist2) > 0)
+      side = 1;
+    else {
+      if ((dist1 - dist2) < 0)
+        side = -1;
+    }
+
+    point5[0] = points.point[i];
+    point5[1] = points.point[i + 1];
+    point5[2] = points.point[i + 2];
+    point5[3].x = cx;
+    point5[3].y = cy;
+
+    radius = osCalculateArcRadius(point5);
+
+    area = ((points.point[i].x + points.point[i + 1].x) *
+            (points.point[i + 1].y - points.point[i].y)) +
+           ((points.point[i + 1].x + points.point[i + 2].x) *
+            (points.point[i + 2].y - points.point[i + 1].y));
+
+    npoints = labs((long)(area / radius));
+
+    point5[0] = points.point[i];
+    point5[1] = points.point[i + 1];
+    osCalculateArc(point5, data3d, data4d, radius,
+                   (npoints > 1000) ? 1000 : npoints, side, arcline, shape);
+
+    point5[0] = points.point[i + 1];
+    point5[1] = points.point[i + 2];
+    osCalculateArc(point5, data3d, data4d, radius,
+                   (npoints > 1000) ? 1000 : npoints, side, arcline, shape);
+
+  } else {
+    arcline.point = (pointObj *)malloc(sizeof(pointObj) * (2));
+    arcline.point[0].x = points.point[i].x;
+    arcline.point[0].y = points.point[i].y;
+    arcline.point[1].x = points.point[i + 2].x;
+    arcline.point[1].y = points.point[i + 2].y;
+
+    if (data3d || data4d) {
+      arcline.point[0].z = points.point[i].z;
+      arcline.point[1].z = points.point[i + 2].z;
+    }
+
+    arcline.numpoints = 2;
+
+    msAddLine(shape, &arcline);
+    free(arcline.point);
+  }
+}
+
+static void osShapeBounds(shapeObj *shp) {
+  int i, f;
+
+  if ((shp->numlines > 0) && (shp->line[0].numpoints > 0)) {
+    shp->bounds.minx = shp->line[0].point[0].x;
+    shp->bounds.maxx = shp->line[0].point[0].x;
+    shp->bounds.miny = shp->line[0].point[0].y;
+    shp->bounds.maxy = shp->line[0].point[0].y;
+  }
+
+  for (i = 0; i < shp->numlines; i++) {
+    for (f = 0; f < shp->line[i].numpoints; f++) {
+      if (shp->line[i].point[f].x < shp->bounds.minx)
+        shp->bounds.minx = shp->line[i].point[f].x;
+      if (shp->line[i].point[f].x > shp->bounds.maxx)
+        shp->bounds.maxx = shp->line[i].point[f].x;
+      if (shp->line[i].point[f].y < shp->bounds.miny)
+        shp->bounds.miny = shp->line[i].point[f].y;
+      if (shp->line[i].point[f].y > shp->bounds.maxy)
+        shp->bounds.maxy = shp->line[i].point[f].y;
+    }
+  }
+}
+
+static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d,
+                         int data4d) {
+  int max_points = 0;
+  int i, f, g;
+  lineObj shapeline = {0, NULL};
+
+  for (i = 0; i < shape->numlines; i++)
+    max_points += shape->line[i].numpoints;
+
+  if (max_points > 0)
+    shapeline.point = (pointObj *)malloc(sizeof(pointObj) * max_points);
+
+  g = 0;
+  for (i = 0; i < shape->numlines; i++) {
+    for (f = 0; f < shape->line[i].numpoints && g <= max_points; f++, g++) {
+      shapeline.point[g].x = shape->line[i].point[f].x;
+      shapeline.point[g].y = shape->line[i].point[f].y;
+      if (data3d || data4d)
+        shapeline.point[g].z = shape->line[i].point[f].z;
+    }
+  }
+
+  if (g) {
+    shapeline.numpoints = g;
+    newshape->type = shape->type; /* jimk: 2009/09/23 Fixes compound linestrings
+                                     being converted to polygons */
+    msAddLine(newshape, &shapeline);
+  }
+}
+
+static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape,
+                           SDOGeometryObj *obj, int start, int end,
+                           lineObj points, int interpretation, int data3d,
+                           int data4d) {
+  int n;
+
+  n = (end - start) / 2;
+  /* n = interpretation; */
+
+  /* if (n == interpretation) { */
+  points.point = (pointObj *)malloc(sizeof(pointObj) * n);
+
+  if (data3d)
+    n = msOCIGet3DOrdinates(hand, obj, start, end, points.point);
+  else if (data4d)
+    n = msOCIGet4DOrdinates(hand, obj, start, end, points.point);
+  else
+    n = msOCIGet2DOrdinates(hand, obj, start, end, points.point);
+
+  if (n == interpretation && n > 0) {
+    shape->type = MS_SHAPE_POINT;
+    points.numpoints = n;
+    msAddLine(shape, &points);
+  }
+  free(points.point);
+  /* } */
+}
+
+static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape,
+                    SDOGeometryObj *obj, int start, int end, lineObj points,
+                    pointObj *pnt, int data3d, int data4d) {
+  int n;
+
+  if (data3d)
+    n = msOCIGet3DOrdinates(hand, obj, start, end, pnt);
+  else if (data4d)
+    n = msOCIGet4DOrdinates(hand, obj, start, end, pnt);
+  else
+    n = msOCIGet2DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
+
+  if (n == 1) {
+    shape->type = MS_SHAPE_POINT;
+    points.numpoints = 1;
+    points.point = pnt;
+    msAddLine(shape, &points);
+  }
+}
+
+static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                            SDOGeometryObj *obj, int start, int end,
+                            lineObj points, int elem_type, int data3d,
+                            int data4d) {
+  int n;
+
+  n = (end - start) / 2;
+  points.point = (pointObj *)malloc(sizeof(pointObj) * n);
+
+  if (data3d)
+    n = msOCIGet3DOrdinates(hand, obj, start, end, points.point);
+  else if (data4d)
+    n = msOCIGet4DOrdinates(hand, obj, start, end, points.point);
+  else
+    n = msOCIGet2DOrdinates(hand, obj, start, end, points.point);
+
+  if (n > 0) {
+    shape->type = (elem_type == 21) ? MS_SHAPE_LINE : MS_SHAPE_POLYGON;
+    points.numpoints = n;
+    msAddLine(shape, &points);
+  }
+  free(points.point);
+}
+
+static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape,
+                        SDOGeometryObj *obj, int start, int end, lineObj points,
+                        pointObj *pnt, int data3d, int data4d) {
+  int n;
+
+  if (data3d)
+    n = msOCIGet3DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
+  else if (data4d)
+    n = msOCIGet4DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
+  else
+    n = msOCIGet2DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
+
+  if (n == 2) {
+    shape->type = MS_SHAPE_POLYGON;
+    points.numpoints = 5;
+    points.point = pnt;
+
+    /* point5 [0] & [1] contains the lower-left and upper-right points of the
+     * rectangle */
+    pnt[2] = pnt[1];
+    pnt[1].x = pnt[0].x;
+    pnt[3].x = pnt[2].x;
+    pnt[3].y = pnt[0].y;
+    pnt[4] = pnt[0];
+    if (data3d || data4d) {
+      pnt[1].z = pnt[0].z;
+      pnt[3].z = pnt[2].z;
+    }
+
+    msAddLine(shape, &points);
+  }
+}
+
+static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape,
+                     SDOGeometryObj *obj, int start, int end, lineObj points,
+                     pointObj *pnt, int data3d, int data4d) {
+  int n;
+
+  if (data3d)
+    n = msOCIGet3DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
+  else if (data4d)
+    n = msOCIGet4DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
+  else
+    n = msOCIGet2DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
+
+  if (n == 3) {
+    if (msOCIConvertCircle(pnt)) {
+      shape->type = MS_SHAPE_POINT;
+      points.numpoints = 2;
+      points.point = pnt;
+      msAddLine(shape, &points);
+    } else {
+      strlcpy((char *)hand->last_oci_error,
+              "Points in circle object are colinear",
+              sizeof(hand->last_oci_error));
+      hand->last_oci_status = MS_FAILURE;
+    }
+  }
+}
+
+static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                         SDOGeometryObj *obj, int start, int end,
+                         lineObj arcpoints, int elem_type, int data3d,
+                         int data4d) {
+  int n, i;
+  lineObj points = {0, NULL};
+
+  n = (end - start) / 2;
+  points.point = (pointObj *)malloc(sizeof(pointObj) * n);
+
+  if (data3d)
+    n = msOCIGet3DOrdinates(hand, obj, start, end, points.point);
+  else if (data4d)
+    n = msOCIGet4DOrdinates(hand, obj, start, end, points.point);
+  else
+    n = msOCIGet2DOrdinates(hand, obj, start, end, points.point);
+
+  if (n > 2) {
+    shape->type = (elem_type == 32) ? MS_SHAPE_POLYGON : MS_SHAPE_LINE;
+    points.numpoints = n;
+
+    for (i = 0; i < n - 2; i = i + 2)
+      osGenerateArc(shape, arcpoints, points, i, data3d, data4d);
+  }
+  free(points.point);
+}
+
+static int osCheck2DGtype(int pIntGtype) {
+  if (pIntGtype > 2000 && pIntGtype < 2008) {
+    if (pIntGtype != 2004)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+static int osCheck3DGtype(int pIntGtype) {
+  if (pIntGtype > 3000 && pIntGtype < 3308) {
+    if (pIntGtype > 3007)
+      pIntGtype -= 300;
+
+    if (pIntGtype <= 3007 && pIntGtype != 3004)
+      return MS_TRUE;
+  }
+  /*
+   * Future version, untested
+   * return (pIntGtype & 2208 && (pIntGtype & 3000 || pIntGtype & 3296) &&
+   * pIntGtype & 3);
+   */
+  return MS_FALSE;
+}
+
+static int osCheck4DGtype(int pIntGtype) {
+
+  if (pIntGtype > 4000 && pIntGtype < 4408) {
+    if (pIntGtype > 4007)
+      pIntGtype -= 400;
+
+    if (pIntGtype <= 4007 && pIntGtype != 4004)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+static int osGetOrdinates(msOracleSpatialDataHandler *dthand,
+                          msOracleSpatialHandler *hand, shapeObj *shape,
+                          SDOGeometryObj *obj, SDOGeometryInd *ind) {
+  int gtype, elem_type, compound_type;
+  float compound_lenght, compound_count;
+  ub4 etype;
+  ub4 interpretation;
+  int nelems, nords, data3d, data4d;
+  int elem, ord_start, ord_end;
+  boolean exists;
+  OCINumber *oci_number;
+  double x, y;
+  double z;
+  int success;
+  lineObj points = {0, NULL};
+  pointObj point5[5]; /* for quick access */
+  shapeObj newshape;  /* for compound polygons */
+
+  /*stat the variables for compound polygons*/
+  compound_lenght = 0;
+  compound_type = 0;
+  compound_count = -1;
+  data3d = 0;
+  data4d = 0;
+
+  if (ind->_atomic != OCI_IND_NULL) { /* not a null object */
+    nelems = nords = 0;
+    success =
+        TRY(hand, OCICollSize(hand->envhp, hand->errhp,
+                              (OCIColl *)obj->elem_info, &nelems)) &&
+        TRY(hand, OCICollSize(hand->envhp, hand->errhp,
+                              (OCIColl *)obj->ordinates, &nords)) &&
+        TRY(hand, OCINumberToInt(hand->errhp, &(obj->gtype), (uword)sizeof(int),
+                                 OCI_NUMBER_SIGNED, (dvoid *)&gtype));
+    /*&& (nords%2==0 && nelems%3==0);*/ /* check %2==0 for 2D geometries; and
+                                           %3==0 for element info triplets */
+
+    if (success && osCheck2DGtype(gtype)) {
+      success = (nords % 2 == 0 && nelems % 3 == 0)
+                    ? 1
+                    : 0; /* check %2==0 for 2D geometries; and %3==0 for element
+                            info triplets */
+    } else if (success && osCheck3DGtype(gtype)) {
+      success = (nords % 3 == 0 && nelems % 3 == 0)
+                    ? 1
+                    : 0; /* check %2==0 for 2D geometries; and %3==0 for element
+                            info triplets */
+      data3d = 1;
+
+    } else if (success && osCheck4DGtype(gtype)) {
+      success = (nords % 4 == 0 && nelems % 3 == 0)
+                    ? 1
+                    : 0; /* check %2==0 for 2D geometries; and %3==0 for element
+                            info triplets */
+      data4d = 1;
+    }
+
+    if (success) {
+      /* reading SDO_POINT from SDO_GEOMETRY for a 2D/3D point geometry */
+      if ((gtype == 2001 || gtype == 3001 || gtype == 4001) &&
+          ind->point._atomic == OCI_IND_NOTNULL &&
+          ind->point.x == OCI_IND_NOTNULL && ind->point.y == OCI_IND_NOTNULL) {
+
+        success =
+            TRY(hand, OCINumberToReal(hand->errhp, &(obj->point.x),
+                                      (uword)sizeof(double), (dvoid *)&x)) &&
+            TRY(hand, OCINumberToReal(hand->errhp, &(obj->point.y),
+                                      (uword)sizeof(double), (dvoid *)&y));
+
+        if (ERROR("osGetOrdinates()", hand, dthand))
+          return MS_FAILURE;
+
+        shape->type = MS_SHAPE_POINT;
+
+        points.numpoints = 1;
+        points.point = point5;
+        point5[0].x = x;
+        point5[0].y = y;
+        if (data3d || data4d) {
+          if (ind->point.z == OCI_IND_NOTNULL) {
+            success =
+                TRY(hand, OCINumberToReal(hand->errhp, &(obj->point.z),
+                                          (uword)sizeof(double), (dvoid *)&z));
+            if (ERROR("osGetOrdinates()", hand, dthand))
+              return MS_FAILURE;
+            else
+              point5[0].z = z;
+          } else
+            point5[0].z = z;
+        }
+        msAddLine(shape, &points);
+        return MS_SUCCESS;
+      }
+      /* if SDO_POINT not fetched, proceed reading elements (element
+       * info/ordinates) */
+      success =
+          TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                   (OCIColl *)obj->elem_info, (sb4)0,
+                                   (boolean *)&exists, (dvoid *)&oci_number,
+                                   (dvoid **)0)) &&
+          TRY(hand, OCINumberToInt(hand->errhp, oci_number, (uword)sizeof(ub4),
+                                   OCI_NUMBER_SIGNED, (dvoid *)&ord_end));
+
+      elem = 0;
+      ord_end--; /* shifts offset from 1..n to 0..n-1 */
+
+      do {
+        ord_start = ord_end;
+        if (elem + 3 >= nelems) { /* processing last element */
+          ord_end = nords;
+          success = 1;
+        } else { /* get start ordinate position for next element which is
+                    ord_end for this element */
+          success =
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->elem_info, (sb4)elem + 3,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand,
+                  OCINumberToInt(hand->errhp, oci_number, (uword)sizeof(ub4),
+                                 OCI_NUMBER_SIGNED, (dvoid *)&ord_end));
+
+          ord_end--; /* shifts offset from 1..n to 0..n-1 */
+        }
+        success =
+            (success &&
+             TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                      (OCIColl *)obj->elem_info, (sb4)elem + 1,
+                                      (boolean *)&exists, (dvoid *)&oci_number,
+                                      (dvoid **)0)) &&
+             TRY(hand,
+                 OCINumberToInt(hand->errhp, oci_number, (uword)sizeof(ub4),
+                                OCI_NUMBER_UNSIGNED, (dvoid *)&etype)) &&
+             TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                      (OCIColl *)obj->elem_info, (sb4)elem + 2,
+                                      (boolean *)&exists, (dvoid *)&oci_number,
+                                      (dvoid **)0)) &&
+             TRY(hand, OCINumberToInt(hand->errhp, oci_number,
+                                      (uword)sizeof(ub4), OCI_NUMBER_UNSIGNED,
+                                      (dvoid *)&interpretation)));
+
+        if (ERROR("osGetOrdinates()", hand, dthand))
+          return MS_FAILURE;
+
+        if (etype == 1005 || etype == 2005 || etype == 4) {
+          compound_type = 1;
+          compound_lenght = interpretation;
+          compound_count = 0;
+          msInitShape(&newshape);
+        }
+
+        elem_type = (etype == 1 && interpretation > 1)
+                        ? 10
+                        : ((etype % 10) * 10 + interpretation);
+
+        /* msDebug("osGetOrdinates shape->index = %ld\telem_type =
+         * %d\n",shape->index, elem_type); */
+
+        switch (elem_type) {
+        case 10: /* point cluster with 'interpretation'-points */
+          osPointCluster(hand, shape, obj, ord_start, ord_end, points,
+                         interpretation, data3d, data4d);
+          break;
+        case 11: /* point type */
+          osPoint(hand, shape, obj, ord_start, ord_end, points, point5, data3d,
+                  data4d);
+          break;
+        case 21: /* line string whose vertices are connected by straight line
+                    segments */
+          if (compound_type)
+            osClosedPolygon(hand, &newshape, obj, ord_start,
+                            (compound_count < compound_lenght) ? ord_end + 2
+                                                               : ord_end,
+                            points, elem_type, data3d, data4d);
+          else
+            osClosedPolygon(hand, shape, obj, ord_start, ord_end, points,
+                            elem_type, data3d, data4d);
+          break;
+        case 22: /* compound type */
+          if (compound_type)
+            osArcPolygon(hand, &newshape, obj, ord_start,
+                         (compound_count < compound_lenght) ? ord_end + 2
+                                                            : ord_end,
+                         points, elem_type, data3d, data4d);
+          else
+            osArcPolygon(hand, shape, obj, ord_start, ord_end, points,
+                         elem_type, data3d, data4d);
+          break;
+        case 31: /* simple polygon with n points, last point equals the first
+                    one */
+          osClosedPolygon(hand, shape, obj, ord_start, ord_end, points,
+                          elem_type, data3d, data4d);
+          break;
+        case 32: /* Polygon with arcs */
+          osArcPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type,
+                       data3d, data4d);
+          break;
+        case 33: /* rectangle defined by 2 points */
+          osRectangle(hand, shape, obj, ord_start, ord_end, points, point5,
+                      data3d, data4d);
+          break;
+        case 34: /* circle defined by 3 points */
+          osCircle(hand, shape, obj, ord_start, ord_end, points, point5, data3d,
+                   data4d);
+          break;
+        }
+
+        if (compound_count >= compound_lenght) {
+          osCloneShape(&newshape, shape, data3d, data4d);
+          msFreeShape(&newshape);
+        }
+
+        if (ERROR("osGetOrdinates()", hand, dthand))
+          return MS_FAILURE;
+
+        /* prepare for next cycle */
+        ord_start = ord_end;
+        elem += 3;
+
+        if (compound_type)
+          compound_count++;
+
+      } while (elem < nelems); /* end of element loop */
+    }                          /* end of gtype big-if */
+  }                            /* end of not-null-object if */
+
+  if (compound_type) {
+    if (gtype == 2003 || gtype == 2007)
+      shape->type = MS_SHAPE_POLYGON;
+    msFreeShape(&newshape);
+  }
+
+  return MS_SUCCESS;
+}
+
+static void msOCICloseConnection(void *hand) {
+  msOCICloseHandlers((msOracleSpatialHandler *)hand);
+}
+
+/* opens a layer by connecting to db with username/password@database stored in
+ * layer->connection */
+int msOracleSpatialLayerOpen(layerObj *layer) {
+  char *username = NULL, *password = NULL, *dblink = NULL;
+
+  msOracleSpatialLayerInfo *layerinfo = NULL;
+  msOracleSpatialDataHandler *dthand = NULL;
+  msOracleSpatialStatement *sthand = NULL, *sthand2 = NULL;
+  msOracleSpatialHandler *hand = NULL;
+
+  if (layer->debug >= 2)
+    msDebug("msOracleSpatialLayerOpen called with: %s (Layer pointer %p)\n",
+            layer->data, layer);
+
+  if (layer->layerinfo != NULL) /* Skip if layer is already open */
+    return MS_SUCCESS;
+
+  if (layer->data == NULL) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be:"
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'."
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE.\n");
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "Error parsing OracleSpatial DATA variable. More info in server logs",
+        "msOracleSpatialLayerOpen()");
+
+    return MS_FAILURE;
+  }
+
+  layerinfo =
+      (msOracleSpatialLayerInfo *)malloc(sizeof(msOracleSpatialLayerInfo));
+  dthand =
+      (msOracleSpatialDataHandler *)malloc(sizeof(msOracleSpatialDataHandler));
+  sthand = (msOracleSpatialStatement *)malloc(sizeof(msOracleSpatialStatement));
+  sthand2 =
+      (msOracleSpatialStatement *)malloc(sizeof(msOracleSpatialStatement));
+
+  if ((dthand == NULL) || (layerinfo == NULL)) {
+    msSetError(MS_MEMERR, NULL, "msOracleSpatialLayerOpen()");
+    return MS_FAILURE;
+  }
+
+  memset(dthand, 0, sizeof(msOracleSpatialDataHandler));
+  memset(sthand, 0, sizeof(msOracleSpatialStatement));
+  memset(sthand2, 0, sizeof(msOracleSpatialStatement));
+  memset(layerinfo, 0, sizeof(msOracleSpatialLayerInfo));
+  layerinfo->paging = MS_TRUE;
+
+  msSplitLogin(layer->connection, layer->map, &username, &password, &dblink);
+
+  hand = (msOracleSpatialHandler *)msConnPoolRequest(layer);
+
+  if (hand == NULL) {
+
+    hand = msOCISetHandlers(username, password, dblink);
+
+    if (hand == NULL) {
+      msOCICloseDataHandlers(dthand);
+      msOCIFinishStatement(sthand);
+      msOCIFinishStatement(sthand2);
+      msOCIClearLayerInfo(layerinfo);
+
+      if (username)
+        free(username);
+      if (password)
+        free(password);
+      if (dblink)
+        free(dblink);
+
+      return MS_FAILURE;
+    }
+
+    if (layer->debug >= 2)
+      msDebug("msOracleSpatialLayerOpen. Shared connection not available. "
+              "Creating one.\n");
+
+    msConnPoolRegister(layer, hand, msOCICloseConnection);
+  } else {
+    hand->ref_count++;
+    hand->last_oci_status = MS_SUCCESS;
+    hand->last_oci_error[0] = (text)'\0';
+  }
+
+  if (!(msOCISetDataHandlers(hand, dthand) & msOCIOpenStatement(hand, sthand) &
+        msOCIOpenStatement(hand, sthand2))) {
+    msSetError(MS_ORACLESPATIALERR,
+               "Cannot create OCI LayerInfo. "
+               "Connection failure.",
+               "msOracleSpatialLayerOpen()");
+
+    if (layer->debug >= 2)
+      msDebug("msOracleSpatialLayerOpen. Cannot create OCI LayerInfo. "
+              "Connection failure.\n");
+
+    msOCICloseDataHandlers(dthand);
+    msOCICloseHandlers(hand);
+    msOCIClearLayerInfo(layerinfo);
+  }
+  layerinfo->orahandlers = hand;
+  layerinfo->oradatahandlers = dthand;
+  layerinfo->orastmt = sthand;
+  layerinfo->orastmt2 = sthand2;
+  layer->layerinfo = layerinfo;
+
+  if (username)
+    free(username);
+  if (password)
+    free(password);
+  if (dblink)
+    free(dblink);
+
+  return layer->layerinfo != NULL ? MS_SUCCESS : MS_FAILURE;
+}
+
+/* return MS_TRUE if layer is open, MS_FALSE otherwise.*/
+int msOracleSpatialLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo != NULL)
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+/* closes the layer, disconnecting from db if connected. layer->layerinfo is
+ * freed */
+int msOracleSpatialLayerClose(layerObj *layer) {
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
+  /*int lIntSuccessFree = 0;*/
+
+  if (layer->debug >= 2)
+    msDebug("msOracleSpatialLayerClose was called. Layer: %p, Layer name: %s\n",
+            layer, layer->name);
+
+  if (layerinfo != NULL) {
+
+    /*
+     * Some errors with the OCIObjectFree with query function
+     * If uncomment draw mode will work but no query modes
+     * Need to investigate the error cause
+     */
+    /*lIntSuccessFree = TRY (layerinfo->orahandlers,
+     *OCIObjectFree(layerinfo->orahandlers->envhp,
+     *layerinfo->orahandlers->errhp, (dvoid *)layerinfo->obj,
+     *(ub2)OCI_OBJECTFREE_FORCE)); if (!lIntSuccessFree) msDebug("Error: %s\n",
+     *layerinfo->orahandlers->last_oci_error);
+     */
+    /* Release Statement Handles */
+    if (layerinfo->orastmt != NULL) {
+      msOCIFinishStatement(layerinfo->orastmt);
+      layerinfo->orastmt = NULL;
+    }
+    if (layerinfo->orastmt2 != NULL) {
+      msOCIFinishStatement(layerinfo->orastmt2);
+      layerinfo->orastmt2 = NULL;
+    }
+
+    /* Release Datahandlers */
+    if (layer->debug >= 4)
+      msDebug("msOracleSpatialLayerClose. Cleaning layerinfo handlers.\n");
+    msOCICloseDataHandlers(layerinfo->oradatahandlers);
+    layerinfo->oradatahandlers = NULL;
+
+    /* Free the OCI cache only if there is no more layer that could use it */
+    layerinfo->orahandlers->ref_count--;
+    if (layerinfo->orahandlers->ref_count == 0)
+      OCICacheFree(layerinfo->orahandlers->envhp, layerinfo->orahandlers->errhp,
+                   layerinfo->orahandlers->svchp);
+
+    /* Release Mapserver Pool */
+    if (layer->debug >= 4)
+      msDebug("msOracleSpatialLayerClose. Release the Oracle Pool.\n");
+    msConnPoolRelease(layer, layerinfo->orahandlers);
+
+    /* Release Layerinfo */
+    layerinfo->orahandlers = NULL;
+
+    msOCIClearLayerInfo(layerinfo);
+    layer->layerinfo = NULL;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* create SQL statement for retrieving shapes */
+/* Sets up cursor for use in *NextShape and *GetShape */
+int msOracleSpatialLayerWhichShapes(layerObj *layer, rectObj rect,
+                                    int isQuery) {
+  int success, i;
+  int function = 0;
+  int version = 0;
+  char *query_str = NULL;
+  char query_str2[256];
+  char *tmp_str = NULL, *tmp1_str = NULL;
+  char *table_name;
+  char *geom_column_name = NULL, *unique = NULL, *srid = NULL,
+       *indexfield = NULL;
+  OCIDefine *adtp = NULL;
+  OCIDefine **items = NULL;
+  OCINumber oci_number;
+  OCIBind *bnd1p = NULL, *bnd2p = NULL;
+
+  int existunique = MS_FALSE;
+  int rownumisuniquekey = MS_FALSE;
+  int numitemsinselect = 0;
+
+  /* get layerinfo */
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialDataHandler *dthand = NULL;
+  msOracleSpatialHandler *hand = NULL;
+  msOracleSpatialStatement *sthand = NULL;
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerWhichShapes was called.\n");
+
+  if (layerinfo == NULL) {
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerWhichShapes called on unopened layer",
+               "msOracleSpatialLayerWhichShapes()");
+
+    return MS_FAILURE;
+  } else {
+    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
+    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt2;
+  }
+
+  /*init uniqueindex field*/
+  sthand->uniqueidindex = 0;
+
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  /* parse geom_column_name and table_name */
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be:"
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'."
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE."
+            "Your data statement: (%s)"
+            "in msOracleSpatialLayerWhichShapes()\n",
+            layer->data);
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "Error parsing OracleSpatial DATA variable. More info in server logs",
+        "msOracleSpatialLayerWhichShapes()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    free(table_name);
+    return MS_FAILURE;
+  }
+
+  /*rownum will be the first in the select if no UNIQUE key is defined or
+    will be added at the end of the select*/
+  rownumisuniquekey = MS_TRUE;
+  /*Define the unique*/
+  if (unique[0] == '\0')
+    strcpy(unique, "rownum");
+  else
+    rownumisuniquekey = MS_FALSE;
+
+  /* Check if the unique field is already in the items list */
+  existunique = MS_FALSE;
+  if (unique) {
+    for (i = 0; i < layer->numitems; ++i) {
+      if (strcasecmp(unique, layer->items[i]) == 0) {
+        sthand->uniqueidindex = i;
+        existunique = MS_TRUE;
+        break;
+      }
+    }
+  }
+
+  /* If no SRID is provided, set it to -1 (NULL) for binding */
+  if (strcmp(srid, "NULL") == 0)
+    strcpy(srid, "-1");
+
+  query_str = msStringConcatenate(query_str, "SELECT ");
+  numitemsinselect = layer->numitems;
+  /* allocate enough space for items */
+  if (layer->numitems >= 0) {
+    /*we will always add a rownumber in the selection*/
+    numitemsinselect++;
+
+    /*if unique key in the data is specfied and is not part of the current item
+      lists, we should add it to the select*/
+    if (existunique == MS_FALSE && rownumisuniquekey == MS_FALSE)
+      numitemsinselect++;
+
+    /*the usinque index is there was no uniqueid given or the uniqueid given was
+     * not part of the items lists*/
+    if (existunique == MS_FALSE)
+      sthand->uniqueidindex = layer->numitems;
+
+    sthand->items =
+        (item_text_array *)malloc(sizeof(item_text_array) * (numitemsinselect));
+    if (sthand->items == NULL) {
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items buffer",
+                 "msOracleSpatialLayerWhichShapes()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+      return MS_FAILURE;
+    }
+
+    items = (OCIDefine **)malloc(sizeof(OCIDefine *) * (numitemsinselect));
+    if (items == NULL) {
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                 "msOracleSpatialLayerWhichShapes()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      free(table_name);
+      if (query_str)
+        free(query_str);
+      return MS_FAILURE;
+    }
+    memset(items, 0, sizeof(OCIDefine *) * (numitemsinselect));
+  }
+
+  /* define SQL query */
+  for (i = 0; i < layer->numitems; ++i) {
+    query_str = msStringConcatenate(query_str, "\"");
+    query_str = msStringConcatenate(query_str, layer->items[i]);
+    query_str = msStringConcatenate(query_str, "\", ");
+  }
+
+  /*we add the uniqueid if it was not part of the current item list*/
+  if (existunique == MS_FALSE && rownumisuniquekey == MS_FALSE) {
+    query_str = msStringConcatenate(query_str, unique);
+    query_str = msStringConcatenate(query_str, ",");
+  }
+
+  /*we always want to add rownum in the selection to allow paging to work*/
+  query_str = msStringConcatenate(query_str, "rownum, ");
+
+  query_str = msStringConcatenate(query_str, geom_column_name);
+  query_str = msStringConcatenate(query_str, " FROM ");
+  query_str = msStringConcatenate(query_str, table_name);
+
+  query_str = osFilteritem(layer, function, query_str, 1);
+
+  if (layerinfo->paging && layer->maxfeatures > 0 && layer->startindex < 0) {
+    if (function == FUNCTION_NONE && layer->filter.native_string == NULL) {
+      query_str = msStringConcatenate(query_str, " WHERE ");
+    } else if (function == FUNCTION_NONE &&
+               layer->filter.native_string != NULL) {
+      query_str = msStringConcatenate(query_str, " AND ");
+    }
+    // avoiding an allocation on the heap here sounds acceptable
+    char tmpBuf[256];
+    snprintf(tmpBuf, sizeof(tmpBuf), " ROWNUM<=%d ", layer->maxfeatures);
+    query_str = msStringConcatenate(query_str, tmpBuf);
+
+    if (function != FUNCTION_NONE) {
+      query_str = msStringConcatenate(query_str, " AND ");
+    }
+  }
+
+  if ((((atol(srid) >= 8192) && (atol(srid) <= 8330)) || (atol(srid) == 2) ||
+       (atol(srid) == 5242888) || (atol(srid) == 2000001)) &&
+      (version == VERSION_9i)) {
+    query_str =
+        osGeodeticData(function, query_str, geom_column_name, indexfield);
+  } else {
+    query_str = osNoGeodeticData(function, version, query_str, geom_column_name,
+                                 indexfield);
+  }
+
+  if (layer->sortBy.nProperties > 0) {
+    msDebug("Layer sorting is requested\n");
+    tmp1_str = msLayerBuildSQLOrderBy(layer);
+    query_str = msStringConcatenate(query_str, " ORDER BY ");
+    query_str = msStringConcatenate(query_str, tmp1_str);
+    query_str = msStringConcatenate(query_str, "  ");
+    msFree(tmp1_str);
+  }
+
+  /*assuming startindex starts at 1*/
+  if (layerinfo->paging && layer->startindex > 0) {
+    tmp1_str = msStrdup("SELECT * from (SELECT atmp.*, ROWNUM rnum from (");
+    tmp_str = msStringConcatenate(tmp_str, tmp1_str);
+    msFree(tmp1_str);
+    tmp_str = msStringConcatenate(tmp_str, query_str);
+    /*oder by rowid does not seem to work with function using the spatial
+      filter, at least on layers loaded using ogr in a 11g database*/
+    if (function == FUNCTION_NONE || function == FUNCTION_RELATE ||
+        function == FUNCTION_GEOMRELATE)
+      tmp1_str = msStrdup("order by rowid");
+    /* Populate strOrderBy, if necessary */
+    else
+      tmp1_str = msStrdup("");
+
+    if (layer->maxfeatures > 0) {
+      snprintf(query_str2, sizeof(query_str2),
+               " %s) atmp where ROWNUM<=%d) where rnum >=%d", tmp1_str,
+               layer->maxfeatures + layer->startindex - 1, layer->startindex);
+    } else {
+      snprintf(query_str2, sizeof(query_str2), " %s) atmp) where rnum >=%d",
+               tmp1_str, layer->startindex);
+    }
+    msFree(tmp1_str);
+
+    tmp_str = msStringConcatenate(tmp_str, query_str2);
+    memset(query_str, 0, strlen(query_str));
+    query_str = msStringConcatenate(query_str, tmp_str);
+    msFree(tmp_str);
+  }
+
+  if (layer->debug)
+    msDebug("msOracleSpatialLayerWhichShapes. Using this Sql to retrieve the "
+            "data: %s\n",
+            query_str);
+
+  if (layer->debug)
+    msDebug("msOracleSpatialLayerWhichShapes. Bind values: srid:%s   minx:%f   "
+            "miny:%f  maxx:%f   maxy:%f \n",
+            srid, rect.minx, rect.miny, rect.maxx, rect.maxy);
+
+  /* prepare */
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (text *)query_str, (ub4)strlen(query_str),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+
+  if (layer->debug >= 4)
+    msDebug("msOracleSpatialLayerWhichShapes getting ordinate definition.\n");
+
+  /* get the object definition of the ordinate array */
+  ordinates_tdo = get_tdo(SDO_ORDINATE_ARRAY, hand, dthand);
+
+  if (layer->debug >= 4)
+    msDebug("msOracleSpatialLayerWhichShapes converting to OCIColl.\n");
+
+  /* initialized the collection array */
+  success = TRY(hand, OCIObjectNew(hand->envhp, hand->errhp, hand->svchp,
+                                   OCI_TYPECODE_VARRAY, ordinates_tdo,
+                                   (dvoid *)NULL, OCI_DURATION_SESSION, FALSE,
+                                   (dvoid **)&ordinates));
+
+  /* convert it to a OCI number and then append minx...maxy to the collection */
+  success =
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.minx),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates)) &&
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.miny),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates)) &&
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxx),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates)) &&
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxy),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates));
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerWhichShapes bind by name and object.\n");
+
+  /* do the actual binding */
+
+  if (success && function != FUNCTION_NONE) {
+    success =
+        TRY(hand,
+            /* bind in srid */
+            OCIBindByName(sthand->stmthp, &bnd2p, hand->errhp, (text *)":srid",
+                          strlen(":srid"), (ub1 *)srid, strlen(srid) + 1,
+                          SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0, (ub4)0,
+                          (ub4 *)0, OCI_DEFAULT)) &&
+        TRY(hand,
+            /* bind in rect by name */
+            OCIBindByName(sthand->stmthp, &bnd1p, hand->errhp,
+                          (text *)":ordinates", -1, (dvoid *)0, (sb4)0,
+                          SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)0,
+                          (ub4 *)0, (ub4)OCI_DEFAULT)) &&
+        TRY(hand,
+            /* bind in rect object */
+            OCIBindObject(bnd1p, hand->errhp, ordinates_tdo,
+                          (dvoid **)&ordinates, (ub4 *)0, (dvoid **)0,
+                          (ub4 *)0));
+
+    /* bind the variables from the bindvals hash */
+    const char *bind_key = msFirstKeyFromHashTable(&layer->bindvals);
+    while (bind_key != NULL) {
+      const char *bind_value = msLookupHashTable(&layer->bindvals, bind_key);
+      char *bind_tag = (char *)malloc(sizeof(char) * strlen(bind_key) + 2);
+      sprintf(bind_tag, ":%s", bind_key);
+
+      success =
+          success &&
+          TRY(hand, OCIBindByName(sthand->stmthp, &bnd2p, hand->errhp,
+                                  (text *)bind_tag, strlen(bind_tag),
+                                  (ub1 *)bind_value, strlen(bind_value) + 1,
+                                  SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0,
+                                  (ub4)0, (ub4 *)0, OCI_DEFAULT));
+      bind_key = msNextKeyFromHashTable(&layer->bindvals, bind_key);
+    }
+  }
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerWhichShapes name and object now bound.\n");
+
+  if (success && layer->numitems >= 0) {
+    for (i = 0; i < numitemsinselect && success; ++i) {
+      if (i < numitemsinselect - 1) {
+        // msDebug("Defining by POS, for %s\n", layer->items[i]);
+        // msDebug("datatype retrieved is %i\n", layer->iteminfo);
+      }
+      success = TRY(hand, OCIDefineByPos(sthand->stmthp, &items[i], hand->errhp,
+                                         (ub4)i + 1, (dvoid *)sthand->items[i],
+                                         (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0,
+                                         (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT));
+    }
+  }
+
+  if (success) {
+    int cursor_type = OCI_DEFAULT;
+    if (isQuery)
+      cursor_type = OCI_STMT_SCROLLABLE_READONLY;
+
+    success = TRY(hand,
+                  /* define spatial position adtp ADT object */
+                  OCIDefineByPos(sthand->stmthp, &adtp, hand->errhp,
+                                 (ub4)numitemsinselect + 1, (dvoid *)0, (sb4)0,
+                                 SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0,
+                                 (ub4)OCI_DEFAULT)) &&
+              TRY(hand,
+                  /* define object tdo from adtp */
+                  OCIDefineObject(adtp, hand->errhp, dthand->tdo,
+                                  (dvoid **)sthand->obj, (ub4 *)0,
+                                  (dvoid **)sthand->ind, (ub4 *)0)) &&
+              TRY(hand,
+                  /* execute */
+                  OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                                 (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                                 (OCISnapshot *)NULL, (ub4)cursor_type)) &&
+              TRY(hand,
+                  /* get rows fetched */
+                  OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                             (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                             (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp)) &&
+              TRY(hand,
+                  /* get rows count */
+                  OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                             (dvoid *)&sthand->rows_count, (ub4 *)0,
+                             (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
+  }
+
+  if (!success) {
+    msDebug("Error: %s . "
+            "Query statement: %s . "
+            "Check your data statement."
+            "msOracleSpatialLayerWhichShapes()\n",
+            hand->last_oci_error, query_str);
+    msSetError(MS_ORACLESPATIALERR, "Check your data statement and server logs",
+               "msOracleSpatialLayerWhichShapes()");
+
+    /* clean items */
+    free(items);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
+    free(table_name);
+
+    return MS_FAILURE;
+  }
+
+  /* should begin processing first row */
+  sthand->row_num = sthand->row = 0;
+
+  /* clean items */
+  free(items);
+  // TODO why not msFree() instead to avoid if statements ?
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (query_str)
+    free(query_str);
+  free(table_name);
+
+  return MS_SUCCESS;
+}
+
+/* fetch next shape from previous SELECT stmt (see *WhichShape()) */
+int msOracleSpatialLayerNextShape(layerObj *layer, shapeObj *shape) {
+  SDOGeometryObj *obj;
+  SDOGeometryInd *ind;
+  int success, /*lIntSuccessFree,*/ i;
+
+  /* get layerinfo */
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialDataHandler *dthand = NULL;
+  msOracleSpatialHandler *hand = NULL;
+  msOracleSpatialStatement *sthand = NULL;
+
+  if (layerinfo == NULL) {
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerWhichShapes called on unopened layer",
+               "msOracleSpatialLayerNextShape()");
+    return MS_FAILURE;
+  } else {
+    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
+    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt2;
+  }
+
+  /* no rows fetched */
+  if (sthand->rows_fetched == 0)
+    return MS_DONE;
+
+  if (layer->debug >= 5)
+    msDebug("msOracleSpatialLayerNextShape on layer %p, row_num: %d\n", layer,
+            sthand->row_num);
+
+  do {
+    /* is buffer empty? */
+    if (sthand->row >= sthand->rows_fetched) {
+      /* fetch more */
+      success =
+          TRY(hand,
+              OCIStmtFetch2(sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE,
+                            (ub2)OCI_FETCH_NEXT, (sb4)0, (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_count, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
+
+      if (!success || sthand->rows_fetched == 0 ||
+          sthand->row_num >= sthand->rows_count) {
+        hand->last_oci_status = MS_SUCCESS;
+        return MS_DONE;
+      }
+      if (layer->debug >= 4)
+        msDebug("msOracleSpatialLayerNextShape on layer %p, Fetched %d more "
+                "rows (%d total)\n",
+                layer, sthand->rows_fetched, sthand->rows_count);
+
+      sthand->row = 0; /* reset buffer row index */
+    }
+
+    /* set obj & ind for current row */
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
+
+    /* get the items for the shape */
+    shape->index = atol((char *)(sthand->items[sthand->uniqueidindex]
+                                              [sthand->row])); /* Primary Key */
+    shape->resultindex = sthand->row_num;
+    shape->numvalues = layer->numitems;
+
+    shape->values = (char **)malloc(sizeof(char *) * shape->numvalues);
+    if (shape->values == NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values",
+                 "msOracleSpatialLayerNextShape()");
+      return MS_FAILURE;
+    }
+
+    for (i = 0; i < shape->numvalues; ++i) {
+      shape->values[i] =
+          (char *)malloc(strlen((char *)sthand->items[i][sthand->row]) + 1);
+      if (shape->values[i] == NULL) {
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items",
+                   "msOracleSpatialLayerNextShape()");
+        return MS_FAILURE;
+      } else {
+        strcpy(shape->values[i], (char *)sthand->items[i][sthand->row]);
+        shape->values[i][strlen((char *)sthand->items[i][sthand->row])] = '\0';
+      }
+    }
+
+    /* fetch a layer->type object */
+    success = osGetOrdinates(dthand, hand, shape, obj, ind);
+
+    /* increment for next row */
+    sthand->row_num++;
+    sthand->row++;
+
+    if (success != MS_SUCCESS) {
+      return MS_FAILURE;
+    }
+
+    osShapeBounds(shape);
+  } while (shape->type == MS_SHAPE_NULL);
+
+  return MS_SUCCESS;
+}
+
+int msOracleSpatialLayerGetShape(layerObj *layer, shapeObj *shape,
+                                 resultObj *record) {
+  int success, i;
+  SDOGeometryObj *obj;
+  SDOGeometryInd *ind;
+  msOracleSpatialDataHandler *dthand = NULL;
+  msOracleSpatialHandler *hand = NULL;
+  msOracleSpatialLayerInfo *layerinfo;
+  msOracleSpatialStatement *sthand = NULL;
+
+  long shapeindex = record->shapeindex;
+  int resultindex = record->resultindex;
+
+  if (layer == NULL) {
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetShape called on unopened layer",
+               "msOracleSpatialLayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+
+  if (layerinfo == NULL) {
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "msOracleSpatialLayerGetShape called on unopened layer (layerinfo)",
+        "msOracleSpatialLayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  /* If resultindex is set, fetch the shape from the resultcache, otherwise
+   * fetch it from the DB  */
+  if (resultindex >= 0) {
+    long buffer_first_row_num, buffer_last_row_num;
+
+    /* get layerinfo */
+    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
+    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt2;
+
+    if (layer->resultcache == NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "msOracleSpatialLayerGetShape called before "
+                 "msOracleSpatialLayerWhichShapes()",
+                 "msOracleSpatialLayerGetShape()");
+      return MS_FAILURE;
+    }
+
+    if ((unsigned)resultindex >= sthand->rows_count) {
+      if (layer->debug >= 5)
+        msDebug("msOracleSpatialLayerGetShape problem with cursor. Trying to "
+                "fetch record = %d of %d, falling back to GetShape\n",
+                resultindex, sthand->rows_count);
+
+      msSetError(MS_ORACLESPATIALERR,
+                 "msOracleSpatialLayerGetShape record out of range",
+                 "msOracleSpatialLayerGetShape()");
+      return MS_FAILURE;
+    }
+
+    if (layer->debug >= 5)
+      msDebug("msOracleSpatialLayerGetShape was called. Using the record = %d "
+              "of %d. (shape: %ld should equal pkey: %ld)\n",
+              resultindex, layer->resultcache->numresults,
+              layer->resultcache->results[resultindex].shapeindex, shapeindex);
+
+    /* NOTE: with the way the resultcache works, we should see items in
+     * increasing order, but some may have been filtered out. */
+    /* Best case: item in buffer */
+    /* Next best case: item is in next fetch block */
+    /* Worst case: item is random access */
+    buffer_first_row_num =
+        sthand->row_num - sthand->row; /* cursor id of first item in buffer */
+    buffer_last_row_num = buffer_first_row_num + sthand->rows_fetched -
+                          1; /* cursor id of last item in buffer */
+    if (resultindex >= buffer_first_row_num &&
+        resultindex <= buffer_last_row_num) { /* Item is in buffer. Calculate
+                                                 position in buffer */
+      sthand->row +=
+          resultindex - sthand->row_num; /* move sthand row an row_num by offset
+                                            from last call */
+      sthand->row_num += resultindex - sthand->row_num;
+    } else { /* Item is not in buffer. Fetch item from Oracle */
+      if (layer->debug >= 4)
+        msDebug("msOracleSpatialLayerGetShape: Fetching result from DB start: "
+                "%ld end:%ld record: %d\n",
+                buffer_first_row_num, buffer_last_row_num, resultindex);
+
+      success =
+          TRY(hand, OCIStmtFetch2(sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE,
+                                  (ub2)OCI_FETCH_ABSOLUTE, (sb4)resultindex + 1,
+                                  (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp));
+
+      sthand->row_num = resultindex;
+      sthand->row = 0; /* reset row index */
+
+      if (ERROR("msOracleSpatialLayerGetShape", hand, dthand))
+        return MS_FAILURE;
+
+      if (!success || sthand->rows_fetched == 0) {
+        msSetError(
+            MS_ORACLESPATIALERR,
+            "msOracleSpatialLayerGetShape could not fetch specified record.",
+            "msOracleSpatialLayerGetShape()");
+        return MS_FAILURE;
+      }
+    }
+
+    /* set obj & ind for current row */
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
+
+    /* get the items for the shape */
+    shape->index = shapeindex; /* By definition this is what we asked for */
+    shape->numvalues = layer->numitems;
+
+    shape->values = (char **)malloc(sizeof(char *) * shape->numvalues);
+    if (shape->values == NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values",
+                 "msOracleSpatialLayerNextShape()");
+      return MS_FAILURE;
+    }
+
+    for (i = 0; i < shape->numvalues; ++i) {
+      shape->values[i] =
+          (char *)malloc(strlen((char *)sthand->items[i][sthand->row]) + 1);
+      if (shape->values[i] == NULL) {
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items",
+                   "msOracleSpatialLayerNextShape()");
+        return MS_FAILURE;
+      } else {
+        strcpy(shape->values[i], (char *)sthand->items[i][sthand->row]);
+        shape->values[i][strlen((char *)sthand->items[i][sthand->row])] = '\0';
+      }
+    }
+
+    /* fetch a layer->type object */
+    success = osGetOrdinates(dthand, hand, shape, obj, ind);
+
+    if (success != MS_SUCCESS) {
+      msSetError(MS_ORACLESPATIALERR, "Call to osGetOrdinates failed.",
+                 "msOracleSpatialLayerGetShape()");
+      return MS_FAILURE;
+    }
+
+    osShapeBounds(shape);
+    if (shape->type == MS_SHAPE_NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "Shape type is null... this probably means a record number "
+                 "was requested that could not have beeen in a result set (as "
+                 "returned by NextShape).",
+                 "msOracleSpatialLayerGetShape()");
+      return MS_FAILURE;
+    }
+
+    return (MS_SUCCESS);
+  } else { /* no resultindex, fetch the shape from the DB */
+    char *table_name;
+    char *query_str = NULL, *geom_column_name = NULL, *unique = NULL,
+         *srid = NULL, *indexfield = NULL;
+    int function = 0;
+    int version = 0;
+    sb2 *nullind = NULL;
+    /*OCIDefine *adtp = NULL, *items[QUERY_SIZE] = { NULL };*/
+    OCIDefine *adtp = NULL;
+    OCIDefine **items = NULL;
+
+    if (layer->debug >= 4)
+      msDebug(
+          "msOracleSpatialLayerGetShape was called. Using the record = %ld.\n",
+          shapeindex);
+
+    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
+    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
+
+    /* allocate enough space for items */
+    if (layer->numitems > 0) {
+      if (sthand->items_query == NULL)
+        sthand->items_query = (item_text_array_query *)malloc(
+            sizeof(item_text_array_query) * (layer->numitems));
+
+      if (sthand->items_query == NULL) {
+        msSetError(MS_ORACLESPATIALERR,
+                   "Cannot allocate layerinfo->items_query buffer",
+                   "msOracleSpatialLayerGetShape()");
+        return MS_FAILURE;
+      }
+
+      nullind = (sb2 *)malloc(sizeof(sb2) * (layer->numitems));
+      if (nullind == NULL) {
+        msSetError(MS_ORACLESPATIALERR, "Cannot allocate nullind buffer",
+                   "msOracleSpatialLayerGetShape()");
+        return MS_FAILURE;
+      }
+      memset(nullind, 0, sizeof(sb2) * (layer->numitems));
+
+      items = (OCIDefine **)malloc(sizeof(OCIDefine *) * layer->numitems);
+      if (items == NULL) {
+        msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                   "msOracleSpatialLayerWhichShapes()");
+
+        /* clean nullind  */
+        free(nullind);
+
+        return MS_FAILURE;
+      }
+      memset(items, 0, sizeof(OCIDefine *) * layer->numitems);
+    }
+
+    table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+    if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique,
+                     &srid, &indexfield, &function, &version)) {
+      msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+              "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+              "srid# FUNCTION]' or "
+              "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+              "srid# FUNCTION]'. "
+              "If want to set the FUNCTION statement you can use: FILTER, "
+              "RELATE, GEOMRELATE or NONE. "
+              "Your data statement: (%s) msOracleSpatialLayerGetShape()\n",
+              layer->data);
+      msSetError(
+          MS_ORACLESPATIALERR,
+          "Error parsing OracleSpatial DATA variable. Check server logs. ",
+          "msOracleSpatialLayerGetShape()");
+
+      /* clean nullind  */
+      free(nullind);
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      free(table_name);
+
+      return MS_FAILURE;
+    }
+
+    /*Define the first query to retrive itens*/
+    if (unique[0] == '\0') {
+      msSetError(
+          MS_ORACLESPATIALERR,
+          "Error parsing OracleSpatial DATA variable for query. To execute "
+          "query functions you need to define one "
+          "unique column [USING UNIQUE <#column>]",
+          "msOracleSpatialLayerGetShape()");
+
+      /* clean nullind  */
+      free(nullind);
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      free(table_name);
+
+      return MS_FAILURE;
+    } else {
+      query_str = msStringConcatenate(query_str, "SELECT");
+    }
+    /*Define the query*/
+    for (i = 0; i < layer->numitems; ++i) {
+      msStringConcatenate(query_str, " ");
+      msStringConcatenate(query_str, layer->items[i]);
+      msStringConcatenate(query_str, ",");
+    }
+    char tmpBuf[256];
+    snprintf(tmpBuf, sizeof(tmpBuf), "%ld", shapeindex);
+    query_str = msStringConcatenate(query_str, " ");
+    query_str = msStringConcatenate(query_str, geom_column_name);
+    query_str = msStringConcatenate(query_str, " FROM ");
+    query_str = msStringConcatenate(query_str, table_name);
+    query_str = msStringConcatenate(query_str, " WHERE ");
+    query_str = msStringConcatenate(query_str, unique);
+    query_str = msStringConcatenate(query_str, " = ");
+    query_str = msStringConcatenate(query_str, tmpBuf);
+
+    /*if (layer->filter.native_string != NULL)
+      sprintf( query_str + strlen(query_str), " AND %s",
+      (layer->filter.string));*/
+    query_str = osFilteritem(layer, FUNCTION_NONE, query_str, 2);
+
+    if (layer->debug)
+      msDebug("msOracleSpatialLayerGetShape. Sql: %s\n", query_str);
+
+    /*Prepare the handlers to the query*/
+    success =
+        TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp, (text *)query_str,
+                                 (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX,
+                                 (ub4)OCI_DEFAULT));
+
+    if (success && layer->numitems > 0) {
+      for (i = 0; i < layer->numitems && success; i++)
+        success = TRY(
+            hand, OCIDefineByPos(sthand->stmthp, &items[i], hand->errhp,
+                                 (ub4)i + 1, (dvoid *)sthand->items_query[i],
+                                 (sb4)TEXT_SIZE, SQLT_STR, (sb2 *)&nullind[i],
+                                 (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT));
+    }
+
+    if (!success) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "Error: %s . "
+                 "Query statement: %s . "
+                 "Check your data statement.",
+                 "msOracleSpatialLayerGetShape()\n", hand->last_oci_error,
+                 query_str);
+
+      /* clean nullind  */
+      free(nullind);
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+
+      return MS_FAILURE;
+    }
+
+    if (success) {
+      success =
+          TRY(hand, OCIDefineByPos(sthand->stmthp, &adtp, hand->errhp,
+                                   (ub4)layer->numitems + 1, (dvoid *)0, (sb4)0,
+                                   SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0,
+                                   (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIDefineObject(adtp, hand->errhp, dthand->tdo,
+                                    (dvoid **)sthand->obj, (ub4 *)0,
+                                    (dvoid **)sthand->ind, (ub4 *)0)) &&
+          TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                                   (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                                   (OCISnapshot *)NULL, (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
+    }
+
+    if (!success) {
+      msDebug("Error: %s . "
+              "Query statement: %s ."
+              "Check your data statement."
+              "in msOracleSpatialLayerGetShape()\n",
+              hand->last_oci_error, query_str);
+      msSetError(MS_ORACLESPATIALERR,
+                 "Error in Query statement. Check your server logs",
+                 "msOracleSpatialLayerGetShape()");
+
+      /* clean nullind  */
+      free(nullind);
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+
+      return MS_FAILURE;
+    }
+
+    shape->type = MS_SHAPE_NULL;
+
+    /* no rows fetched */
+    if (sthand->rows_fetched == 0) {
+      /* clean nullind  */
+      free(nullind);
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+
+      return (MS_DONE);
+    }
+
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
+
+    /* get the items for the shape */
+    shape->numvalues = layer->numitems;
+    shape->values = (char **)malloc(sizeof(char *) * layer->numitems);
+    if (shape->values == NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values.",
+                 "msOracleSpatialLayerGetShape()");
+
+      /* clean nullind  */
+      free(nullind);
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+
+      return MS_FAILURE;
+    }
+
+    shape->index = shapeindex;
+
+    for (i = 0; i < layer->numitems; ++i) {
+      shape->values[i] = (char *)malloc(
+          strlen((char *)sthand->items_query[sthand->row][i]) + 1);
+
+      if (shape->values[i] == NULL) {
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items buffer.",
+                   "msOracleSpatialLayerGetShape()");
+
+        /* clean nullind  */
+        free(nullind);
+
+        /* clean items */
+        free(items);
+
+        if (geom_column_name)
+          free(geom_column_name);
+        if (srid)
+          free(srid);
+        if (unique)
+          free(unique);
+        if (indexfield)
+          free(indexfield);
+        if (query_str)
+          free(query_str);
+        free(table_name);
+
+        return MS_FAILURE;
+      } else {
+        if (nullind[i] != OCI_IND_NULL) {
+          strcpy(shape->values[i], (char *)sthand->items_query[sthand->row][i]);
+          shape
+              ->values[i][strlen((char *)sthand->items_query[sthand->row][i])] =
+              '\0';
+        } else {
+          shape->values[i][0] = '\0';
+        }
+      }
+    }
+
+    /* increment for next row */
+    sthand->row_num++;
+    sthand->row++;
+
+    /* fetch a layer->type object */
+    success = osGetOrdinates(dthand, hand, shape, obj, ind);
+    if (success != MS_SUCCESS) {
+      msSetError(MS_ORACLESPATIALERR, "Cannot execute query",
+                 "msOracleSpatialLayerGetShape()");
+
+      /* clean nullind  */
+      free(nullind);
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+
+      return MS_FAILURE;
+    }
+    osShapeBounds(shape);
+    sthand->row = sthand->row_num = 0;
+
+    /* clean nullind  */
+    free(nullind);
+
+    /* clean items */
+    free(items);
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
+    free(table_name);
+
+    return (MS_SUCCESS);
+  }
+}
+
+int msOracleSpatialLayerInitItemInfo(layerObj *layer) {
+  int i;
+  int *itemindexes;
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerInitItemInfo was called.\n");
+
+  if (layer->numitems == 0)
+    return MS_SUCCESS;
+
+  if (layer->iteminfo)
+    free(layer->iteminfo);
+
+  if ((layer->iteminfo = (long *)malloc(sizeof(int) * layer->numitems)) ==
+      NULL) {
+    msSetError(MS_MEMERR, NULL, "msOracleSpatialLayerInitItemInfo()");
+    return MS_FAILURE;
+  }
+
+  itemindexes = (int *)layer->iteminfo;
+
+  for (i = 0; i < layer->numitems; i++) {
+    itemindexes[i] =
+        i; /*last one is always the geometry one - the rest are non-geom*/
+  }
+
+  return MS_SUCCESS;
+}
+
+/* AutoProjection Support for RFC 37 #3333
+ * TODO: Needs testing
+ */
+int msOracleSpatialLayerGetAutoProjection(layerObj *layer,
+                                          projectionObj *projection) {
+  char *table_name;
+  char *query_str, *geom_column_name = NULL, *unique = NULL, *srid = NULL,
+                   *indexfield = NULL;
+  int success;
+  int function = 0;
+  int version = 0;
+  char wktext[4000];
+
+  OCIDefine *def1p = NULL;
+  OCIBind *bnd1p = NULL, *bnd2p = NULL;
+
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialHandler *hand = NULL;
+  msOracleSpatialStatement *sthand = NULL;
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerGetAutoProjection was called.\n");
+
+  if (layerinfo == NULL) {
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetAutoProjection called on unopened layer",
+               "msOracleSpatialLayerGetAutoProjection()");
+    return MS_FAILURE;
+  } else {
+    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
+  }
+
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s) "
+            "in msOracleSpatialLayerGetAutoProjection()\n",
+            layer->data);
+
+    msSetError(MS_ORACLESPATIALERR, "Error parsing OracleSpatial DATA variable",
+               "msOracleSpatialLayerGetAutoProjection()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    free(table_name);
+
+    return MS_FAILURE;
+  }
+
+  query_str = "SELECT wktext FROM mdsys.all_sdo_geom_metadata m, mdsys.cs_srs "
+              "c WHERE c.srid = m.srid and m.owner||'.'||m.table_name = "
+              ":table_name and m.column_name = :geo_col_name "
+              "UNION SELECT wktext from mdsys.user_sdo_geom_metadata m, "
+              "mdsys.cs_srs c WHERE c.srid = m.srid and m.table_name = "
+              ":table_name and m.column_name = :geo_col_name";
+
+  if (layer->debug >= 2)
+    msDebug("msOracleSpatialLayerGetAutoProjection. Using this Sql to retrieve "
+            "the projection: %s.\n",
+            query_str);
+
+  /*Prepare the handlers to the query*/
+  success =
+      TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp, (text *)query_str,
+                               (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX,
+                               (ub4)OCI_DEFAULT)) &&
+      TRY(hand, OCIBindByName(sthand->stmthp, &bnd2p, hand->errhp,
+                              (text *)":table_name", strlen(":table_name"),
+                              (ub1 *)table_name, strlen(table_name) + 1,
+                              SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0, (ub4)0,
+                              (ub4 *)0, OCI_DEFAULT)) &&
+      TRY(hand,
+          OCIBindByName(sthand->stmthp, &bnd1p, hand->errhp,
+                        (text *)":geo_col_name", strlen(":geo_col_name"),
+                        (ub1 *)geom_column_name, strlen(geom_column_name) + 1,
+                        SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0, (ub4)0,
+                        (ub4 *)0, OCI_DEFAULT)) &&
+      TRY(hand, OCIDefineByPos(sthand->stmthp, &def1p, hand->errhp, (ub4)1,
+                               (dvoid *)wktext, (sb4)4000, SQLT_STR, (dvoid *)0,
+                               (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT)) &&
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp, (ub4)0,
+                               (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL,
+                               (ub4)OCI_DEFAULT)) &&
+      TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                           (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                           (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp));
+
+  if (!success) {
+    msDebug("Error: %s . "
+            "Query statement: %s . "
+            "Check your data statement."
+            "in msOracleSpatialLayerGetAutoProjection()\n",
+            hand->last_oci_error, query_str);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error "
+               "Check your data statement and server logs",
+               "msOracleSpatialLayerGetAutoProjection()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    free(table_name);
+    return MS_FAILURE;
+  }
+  do {
+    success = TRY(hand, OCIStmtFetch(sthand->stmthp, hand->errhp, (ub4)1,
+                                     (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT)) &&
+              TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                                   (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                                   (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp));
+    if (success && sthand->rows_fetched > 0) {
+
+      if (layer->debug)
+        msDebug("Found WKT projection for table %s: %s\n", table_name, wktext);
+
+      if (wktext != NULL && projection != NULL)
+        if (msOGCWKT2ProjectionObj(wktext, projection, layer->debug) ==
+            MS_FAILURE)
+          return (MS_FAILURE);
+    }
+  } while (sthand->rows_fetched > 0);
+
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  free(table_name);
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *             msOracleSpatialGetFieldDefn()
+ *
+ * Pass the field definitions through to the layer metadata in the
+ * "gml_[item]_{type,width,precision}" set of metadata items for
+ * defining fields.
+ **********************************************************************/
+static void msOracleSpatialGetFieldDefn(layerObj *layer,
+                                        msOracleSpatialHandler *hand,
+                                        const char *item, OCIParam *pard)
+
+{
+  const char *gml_type = "Character";
+  char gml_width[32], gml_precision[32];
+  int success;
+  ub2 rzttype, nOCILen;
+
+  gml_width[0] = '\0';
+  gml_precision[0] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*      Get basic parameter details.                                    */
+  /* -------------------------------------------------------------------- */
+  success = TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM,
+                                 (dvoid *)&rzttype, (ub4 *)0,
+                                 (ub4)OCI_ATTR_DATA_TYPE, hand->errhp)) &&
+            TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM,
+                                 (dvoid *)&nOCILen, (ub4 *)0,
+                                 (ub4)OCI_ATTR_DATA_SIZE, hand->errhp));
+
+  if (!success)
+    return;
+
+  switch (rzttype) {
+  case SQLT_CHR:
+  case SQLT_AFC:
+    gml_type = "Character";
+    if (nOCILen <= 4000)
+      sprintf(gml_width, "%d", nOCILen);
+    break;
+
+  case SQLT_NUM: {
+    /* NOTE: OCI docs say this should be ub1 type, but we have
+       determined that oracle is actually returning a short so we
+       use that type and try to compensate for possible problems by
+       initializing, and dividing by 256 if it is large. */
+    unsigned short byPrecision = 0;
+    sb1 nScale = 0;
+
+    if (!TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM,
+                              (dvoid *)&byPrecision, (ub4 *)0,
+                              (ub4)OCI_ATTR_PRECISION, hand->errhp)) ||
+        !TRY(hand,
+             OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM, (dvoid *)&nScale,
+                        (ub4 *)0, (ub4)OCI_ATTR_SCALE, hand->errhp)))
+      return;
+    if (byPrecision > 255)
+      byPrecision = byPrecision / 256;
+
+    if (nScale > 0) {
+      gml_type = "Real";
+      sprintf(gml_width, "%d", byPrecision);
+      sprintf(gml_precision, "%d", nScale);
+    } else if (nScale < 0)
+      gml_type = "Real";
+    else {
+      gml_type = "Integer";
+      if (byPrecision < 38)
+        sprintf(gml_width, "%d", byPrecision);
+    }
+  } break;
+
+  case SQLT_DAT:
+  case SQLT_DATE:
+    gml_type = "Date";
+    break;
+  case SQLT_TIMESTAMP:
+  case SQLT_TIMESTAMP_TZ:
+  case SQLT_TIMESTAMP_LTZ:
+    gml_type = "DateTime";
+    break;
+  case SQLT_TIME:
+  case SQLT_TIME_TZ:
+    gml_type = "Time";
+    break;
+
+  default:
+    gml_type = "Character";
+  }
+
+  msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
+}
+
+int msOracleSpatialLayerGetItems(layerObj *layer) {
+  char *rzt = "";
+  ub2 rzttype = 0;
+  char *flk = "";
+  int function = 0;
+  int version = 0;
+  int existgeom;
+  int count_item, flk_len, success, i;
+  char *table_name;
+  char *query_str = NULL, *geom_column_name = NULL, *unique = NULL,
+       *srid = NULL, *indexfield = NULL;
+  OCIParam *pard = (OCIParam *)0;
+
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialHandler *hand = NULL;
+  msOracleSpatialStatement *sthand = NULL;
+  int get_field_details = 0;
+  const char *value;
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerGetItems was called.\n");
+
+  if (layerinfo == NULL) {
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetItems called on unopened layer",
+               "msOracleSpatialLayerGetItems()");
+    return MS_FAILURE;
+  } else {
+    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
+  }
+
+  /* Will we want to capture the field details? */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    get_field_details = 1;
+
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s)"
+            "in msOracleSpatialLayerGetItems()\n",
+            layer->data);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error parsing OracleSpatial DATA variable. Check server logs. ",
+               "msOracleSpatialLayerGetItems()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    free(table_name);
+    return MS_FAILURE;
+  }
+  query_str = msStringConcatenate(query_str, "SELECT * FROM ");
+  query_str = msStringConcatenate(query_str, table_name);
+
+  success =
+      TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp, (text *)query_str,
+                               (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX,
+                               (ub4)OCI_DESCRIBE_ONLY)) &&
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DESCRIBE_ONLY)) &&
+      TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                           (dvoid *)&layer->numitems, (ub4 *)0,
+                           OCI_ATTR_PARAM_COUNT, hand->errhp));
+
+  if (!success) {
+    msSetError(MS_QUERYERR, "Cannot retrieve column list",
+               "msOracleSpatialLayerGetItems()");
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
+    free(table_name);
+    return MS_FAILURE;
+  }
+
+  sthand->row_num = sthand->row = 0;
+  layer->numitems = layer->numitems - 1;
+
+  layer->items = malloc(sizeof(char *) * (layer->numitems));
+  if (layer->items == NULL) {
+    msSetError(MS_ORACLESPATIALERR, "Cannot allocate items",
+               "msOracleSpatialLayerGetItems()");
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
+    free(table_name);
+    return MS_FAILURE;
+  }
+
+  if (layer->numitems > 0) {
+    if (sthand->items_query == NULL)
+      sthand->items_query = (item_text_array_query *)malloc(
+          sizeof(item_text_array_query) * (layer->numitems));
+
+    if (sthand->items_query == NULL) {
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                 "msOracleSpatialLayerGetItems()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+      return MS_FAILURE;
+    }
+  }
+
+  count_item = 0;
+  existgeom = 0;
+
+  /*Upcase conversion for the geom_column_name*/
+  for (i = 0; geom_column_name[i] != '\0'; i++)
+    geom_column_name[i] = toupper(geom_column_name[i]);
+
+  /*Retrive columns name from the user table*/
+  for (i = 0; i <= layer->numitems; i++) {
+
+    success =
+        TRY(hand, OCIParamGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                              hand->errhp, (dvoid *)&pard, (ub4)i + 1)) &&
+        TRY(hand,
+            OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM, (dvoid *)&rzttype,
+                       (ub4 *)0, (ub4)OCI_ATTR_DATA_TYPE, hand->errhp)) &&
+        TRY(hand, OCIParamGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                              hand->errhp, (dvoid *)&pard, (ub4)i + 1)) &&
+        TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM, (dvoid *)&rzt,
+                             (ub4 *)&flk_len, (ub4)OCI_ATTR_NAME, hand->errhp));
+
+    /*  if (layer->debug)
+           msDebug("msOracleSpatialLayerGetItems checking type. Column = %s Type
+       = %d\n", rzt, rzttype);  */
+    flk = (char *)malloc(sizeof(char *) * flk_len + 1);
+    if (flk == NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the items",
+                 "msOracleSpatialLayerGetItems()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+      return MS_FAILURE;
+    } else {
+      // layer->iteminfo->dtype[i]= 1;
+      strlcpy(flk, rzt, flk_len + 1);
+    }
+
+    /*Comapre the column name (flk) with geom_column_name and ignore with true*/
+    if (strcmp(flk, geom_column_name) != 0) {
+      if (rzttype != OCI_TYPECODE_BLOB) {
+        layer->items[count_item] = (char *)malloc(sizeof(char) * flk_len + 1);
+        if (layer->items[count_item] == NULL) {
+          msSetError(MS_ORACLESPATIALERR,
+                     "No memory avaliable to allocate the items buffer",
+                     "msOracleSpatialLayerGetItems()");
+          if (geom_column_name)
+            free(geom_column_name);
+          if (srid)
+            free(srid);
+          if (unique)
+            free(unique);
+          if (query_str)
+            free(query_str);
+          free(table_name);
+          return MS_FAILURE;
+        }
+
+        strcpy(layer->items[count_item], flk);
+        count_item++;
+
+        if (get_field_details)
+          msOracleSpatialGetFieldDefn(layer, hand, layer->items[count_item - 1],
+                                      pard);
+      }
+    } else
+      existgeom = 1;
+
+    strcpy(rzt, "");
+    free(flk); /* Better?!*/
+    flk_len = 0;
+  }
+
+  layer->numitems = count_item;
+
+  if (!(existgeom)) {
+    msSetError(MS_ORACLESPATIALERR, "No geometry column, check stmt",
+               "msOracleSpatialLayerGetItems()");
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
+    free(table_name);
+    return MS_FAILURE;
+  }
+
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (query_str)
+    free(query_str);
+  free(table_name);
+  return msOracleSpatialLayerInitItemInfo(layer);
+}
+
+int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent) {
+  char *table_name;
+  char *query_str = NULL, *geom_column_name = NULL, *unique = NULL,
+       *srid = NULL, *indexfield = NULL;
+  int success, i;
+  int function = 0;
+  int version = 0;
+  SDOGeometryObj *obj = NULL;
+  SDOGeometryInd *ind = NULL;
+  shapeObj shape;
+  rectObj bounds;
+  /*OCIDefine *adtp = NULL, *items[QUERY_SIZE] = { NULL };*/
+  OCIDefine *adtp = NULL;
+  OCIDefine **items = NULL;
+
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialDataHandler *dthand = NULL;
+  msOracleSpatialHandler *hand = NULL;
+  msOracleSpatialStatement *sthand = NULL;
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerGetExtent was called.\n");
+
+  if (layerinfo == NULL) {
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetExtent called on unopened layer",
+               "msOracleSpatialLayerGetExtent()");
+    return MS_FAILURE;
+  } else {
+    dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
+    hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
+  }
+
+  /* allocate enough space for items */
+  if (layer->numitems > 0) {
+    sthand->items_query = (item_text_array_query *)malloc(
+        sizeof(item_text_array_query) * (layer->numitems));
+    if (sthand->items_query == NULL) {
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items buffer",
+                 "msOracleSpatialLayerGetExtent()");
+      return MS_FAILURE;
+    }
+    items = (OCIDefine **)malloc(sizeof(OCIDefine *) * layer->numitems);
+    if (items == NULL) {
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                 "msOracleSpatialLayerWhichShapes()");
+      return MS_FAILURE;
+    }
+    memset(items, 0, sizeof(OCIDefine *) * layer->numitems);
+  }
+
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s) "
+            "in msOracleSpatialLayerGetExtent()\n",
+            layer->data);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error parsing OracleSpatial DATA variable. Check server logs. ",
+               "msOracleSpatialLayerGetExtent()");
+    /* clean items */
+    free(items);
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    free(table_name);
+
+    return MS_FAILURE;
+  }
+
+  query_str = osAggrGetExtent(layer, query_str, geom_column_name, table_name);
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerGetExtent. Using this Sql to retrieve the "
+            "extent: %s.\n",
+            query_str);
+
+  /*Prepare the handlers to the query*/
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (text *)query_str, (ub4)strlen(query_str),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+
+  if (success && layer->numitems > 0) {
+    for (i = 0; i < layer->numitems && success; ++i)
+      success =
+          TRY(hand, OCIDefineByPos(sthand->stmthp, &items[i], hand->errhp,
+                                   (ub4)i + 1, (dvoid *)sthand->items_query[i],
+                                   (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0,
+                                   (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT));
+  }
+
+  if (!success) {
+    msDebug("Error: %s . "
+            "Query statement: %s . "
+            "Check your data statement."
+            "in msOracleSpatialLayerGetExtent()\n",
+            hand->last_oci_error, query_str);
+
+    msSetError(MS_ORACLESPATIALERR, "Check your data statement and server logs",
+               "msOracleSpatialLayerGetExtent()");
+
+    /* clean items */
+    free(items);
+
+    if (query_str)
+      free(query_str);
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    free(table_name);
+
+    return MS_FAILURE;
+  }
+
+  if (success) {
+    success =
+        TRY(hand, OCIDefineByPos(sthand->stmthp, &adtp, hand->errhp,
+                                 (ub4)layer->numitems + 1, (dvoid *)0, (sb4)0,
+                                 SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0,
+                                 (ub4)OCI_DEFAULT)) &&
+        TRY(hand, OCIDefineObject(adtp, hand->errhp, dthand->tdo,
+                                  (dvoid **)sthand->obj, (ub4 *)0,
+                                  (dvoid **)sthand->ind, (ub4 *)0)) &&
+        TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                                 (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                                 (OCISnapshot *)NULL, (ub4)OCI_DEFAULT)) &&
+        TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                             (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                             (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
+  }
+
+  if (!success) {
+    msDebug("Error: %s . "
+            "Query statement: %s ."
+            "Check your data statement."
+            "in msOracleSpatialLayerGetExtent()\n",
+            hand->last_oci_error, query_str);
+    msSetError(MS_ORACLESPATIALERR, "Check your data statement and server logs",
+               "msOracleSpatialLayerGetExtent()");
+
+    /* clean items */
+    free(items);
+    if (query_str)
+      free(query_str);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    free(table_name);
+
+    return MS_FAILURE;
+  }
+
+  /* should begin processing first row */
+  sthand->row_num = sthand->row = 0;
+  msInitShape(&shape);
+  do {
+    /* is buffer empty? */
+    if (sthand->row_num >= sthand->rows_fetched) {
+      /* fetch more */
+      success =
+          TRY(hand, OCIStmtFetch(sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE,
+                                 (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
+
+      if (!success || sthand->rows_fetched == 0 ||
+          sthand->row_num >= sthand->rows_fetched) {
+        hand->last_oci_status = MS_SUCCESS;
+        break;
+      }
+
+      sthand->row = 0; /* reset row index */
+    }
+
+    /* no rows fetched */
+    if (sthand->rows_fetched == 0)
+      break;
+
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
+
+    /* get the items for the shape */
+    shape.numvalues = layer->numitems;
+    shape.values = (char **)malloc(sizeof(char *) * layer->numitems);
+    if (shape.values == NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values.",
+                 "msOracleSpatialLayerGetExtent()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+      return MS_FAILURE;
+    }
+
+    shape.index = sthand->row_num;
+
+    for (i = 0; i < layer->numitems; ++i) {
+      shape.values[i] = (char *)malloc(
+          strlen((char *)sthand->items_query[sthand->row][i]) + 1);
+
+      if (shape.values[i] == NULL) {
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items buffer.",
+                   "msOracleSpatialLayerGetExtent()");
+
+        /* clean items */
+        free(items);
+
+        if (geom_column_name)
+          free(geom_column_name);
+        if (srid)
+          free(srid);
+        if (unique)
+          free(unique);
+        if (indexfield)
+          free(indexfield);
+        if (query_str)
+          free(query_str);
+        free(table_name);
+
+        return MS_FAILURE;
+      } else {
+        strcpy(shape.values[i], (char *)sthand->items_query[sthand->row][i]);
+        shape.values[i][strlen((char *)sthand->items_query[sthand->row][i])] =
+            '\0';
+      }
+    }
+
+    /* increment for next row */
+    sthand->row_num++;
+    sthand->row++;
+
+    /* fetch a layer->type object */
+    success = osGetOrdinates(dthand, hand, &shape, obj, ind);
+    if (success != MS_SUCCESS) {
+      msSetError(MS_ORACLESPATIALERR, "Cannot execute query",
+                 "msOracleSpatialLayerGetExtent()");
+
+      /* clean items */
+      free(items);
+
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
+      free(table_name);
+
+      return MS_FAILURE;
+    }
+
+  } while (sthand->row <= sthand->rows_fetched);
+
+  sthand->row = sthand->row_num = 0;
+
+  osShapeBounds(&shape);
+  bounds = shape.bounds;
+
+  extent->minx = bounds.minx;
+  extent->miny = bounds.miny;
+  extent->maxx = bounds.maxx;
+  extent->maxy = bounds.maxy;
+
+  msFreeShape(&shape);
+
+  /* clean items */
+  free(items);
+
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (query_str)
+    free(query_str);
+  free(table_name);
+
+  return (MS_SUCCESS);
+}
+
+void msOracleSpatialLayerFreeItemInfo(layerObj *layer) {
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerFreeItemInfo was called.\n");
+
+  if (layer->iteminfo)
+    free(layer->iteminfo);
+
+  layer->iteminfo = NULL;
+  /* nothing to do */
+}
+
+int msOracleSpatialLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                     shapeObj *shape) {
+  (void)map;
+  (void)layer;
+  (void)c;
+  (void)shape;
+  msSetError(MS_ORACLESPATIALERR, "Function not implemented yet",
+             "msLayerGetAutoStyle()");
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                       msOracleSpatialEscapePropertyName              */
+/*                                                                      */
+/*      Return the property name in a properly escaped and quoted form. */
+/************************************************************************/
+char *msOracleSpatialEscapePropertyName(layerObj *layer,
+                                        const char *pszString) {
+  char *pszEscapedStr = NULL;
+  int i, j = 0;
+
+  if (layer && pszString && strlen(pszString) > 0) {
+    int nLength = strlen(pszString);
+
+    pszEscapedStr = (char *)msSmallMalloc(1 + 2 * nLength + 1 + 1);
+    // pszEscapedStr[j++] = '';
+
+    for (i = 0; i < nLength; i++) {
+      char c = pszString[i];
+      if (c == '"') {
+        pszEscapedStr[j++] = '"';
+        pszEscapedStr[j++] = '"';
+      } else if (c == '\\') {
+        pszEscapedStr[j++] = '\\';
+        pszEscapedStr[j++] = '\\';
+      } else
+        pszEscapedStr[j++] = c;
+    }
+    // pszEscapedStr[j++] = '';
+    pszEscapedStr[j++] = 0;
+  }
+  return pszEscapedStr;
+}
+
+int msOracleSpatialGetPaging(layerObj *layer) {
+  msOracleSpatialLayerInfo *layerinfo = NULL;
+
+  // if (layer->debug)
+  //   msDebug("msOracleSpatialLayerGetPaging was called.\n");
+
+  if (!msOracleSpatialLayerIsOpen(layer))
+    return MS_TRUE;
+
+  assert(layer->layerinfo != NULL);
+  layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+
+  return layerinfo->paging;
+}
+
+void msOracleSpatialEnablePaging(layerObj *layer, int value) {
+  msOracleSpatialLayerInfo *layerinfo = NULL;
+
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerEnablePaging was called.\n");
+
+  if (!msOracleSpatialLayerIsOpen(layer)) {
+    if (msOracleSpatialLayerOpen(layer) != MS_SUCCESS) {
+      return;
+    }
+  }
+
+  assert(layer->layerinfo != NULL);
+  layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+
+  layerinfo->paging = value;
+
+  return;
+}
+
+int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                        char *filteritem) {
+  char *native_string = NULL;
+
+  int nodeCount = 0;
+
+  int function = 0, version = 0, dwithin = 0, regexp_like = 0, case_ins = 0,
+      ieq = 0;
+  char *table_name = NULL;
+  char *geom_column_name = NULL, *unique = NULL, *srid = NULL,
+       *indexfield = NULL;
+  char *snippet = NULL;
+  char *strtmpl = NULL;
+  double dfDistance = -1;
+
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s)"
+            "in msOracleSpatialLayerGetExtent()\n",
+            layer->data);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error parsing OracleSpatial DATA variable. Check server logs. ",
+               "msOracleSpatialLayerGetExtent()");
+    /* clean items */
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (table_name)
+      free(table_name);
+
+    return MS_FAILURE;
+  }
+
+  // msDebug("filter.string was set: %s\n",filter->string);
+  if (!filter->string) {
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (table_name)
+      free(table_name);
+
+    return MS_SUCCESS;
+  }
+  /* for backwards compatibility we continue to allow SQL snippets as a string
+   */
+
+  if (filter->type == MS_STRING && filter->string &&
+      filteritem) { /* item/value pair */
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      native_string = msStringConcatenate(native_string, "upper(");
+      native_string = msStringConcatenate(native_string, filteritem);
+      native_string = msStringConcatenate(native_string, ") = upper(");
+    } else {
+      native_string = msStringConcatenate(native_string, filteritem);
+      native_string = msStringConcatenate(native_string, " = ");
+    }
+
+    strtmpl = "'%s'"; /* don't have a type for the righthand literal so assume
+                         it's a string and we quote */
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
+                                               // (msPostGISEscapeSQLParam)
+    native_string = msStringConcatenate(native_string, snippet);
+    free(snippet);
+
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      native_string = msStringConcatenate(native_string, ")");
+
+    if (layer->debug >= 2)
+      msDebug("msOracleSpatialLayerTranslateFilter: **item/value combo: %s\n",
+              native_string);
+  } else if (filter->type == MS_REGEX && filter->string &&
+             filteritem) { /* item/regex pair */
+    native_string = msStringConcatenate(native_string, "REGEXP_LIKE (");
+    native_string = msStrdup(filteritem);
+    native_string = msStringConcatenate(native_string, ", ");
+    strtmpl = "'%s'";
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
+                                               // (msPostGISEscapeSQLParam)
+    native_string = msStringConcatenate(native_string, snippet);
+
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      native_string = msStringConcatenate(native_string, ",i ");
+    }
+    native_string = msStringConcatenate(native_string, " )");
+    free(snippet);
+  } else if (filter->type == MS_EXPRESSION) {
+
+    tokenListNodeObjPtr node = NULL;
+    // tokenListNodeObjPtr nextNode = NULL;
+
+    if (layer->debug > 2)
+      msDebug("msOracleSpatialLayerTranslateFilter. String: %s \n",
+              filter->string);
+    if (layer->debug > 2 && !filter->tokens)
+      msDebug("msOracleSpatialLayerTranslateFilter. No tokens to process\n");
+
+    if (!filter->tokens)
+      return MS_SUCCESS; /* nothing to work from */
+
+    if (layer->debug > 2)
+      msDebug("msOracleSpatialLayerTranslateFilter. There are tokens to "
+              "process \n");
+
+    /* try to convert tokens */
+    node = filter->tokens;
+    while (node != NULL) {
+      // msDebug("token count :%i, token is %i\n", nodeCount, node->token);
+      switch (node->token) {
+      case '(':
+        // if (buffer == MS_FALSE)
+        native_string = msStringConcatenate(native_string, "( ");
+        break;
+      case ')':
+        if (regexp_like == MS_TRUE) {
+          if (case_ins == MS_TRUE) {
+            native_string = msStringConcatenate(native_string, ",'i' ");
+            case_ins = MS_FALSE;
+          }
+          regexp_like = MS_FALSE;
+          native_string = msStringConcatenate(native_string, " )");
+          msDebug("closing RE comparison\n");
+        }
+        native_string = msStringConcatenate(native_string, " )");
+        break;
+      case MS_TOKEN_LITERAL_NUMBER: {
+        char buffer[32];
+        if (dwithin == MS_TRUE) {
+          dfDistance = node->tokenval.dblval;
+          if (layer->units == MS_DD) {
+            dfDistance *=
+                msInchesPerUnit(MS_DD, 0) / msInchesPerUnit(MS_METERS, 0);
+            // msDebug("Converted Distance value is %lf\n", dfDistance);
+          }
+          snprintf(buffer, sizeof(buffer), "%.18g", dfDistance);
+          native_string = msStringConcatenate(native_string, "'distance=");
+          native_string = msStringConcatenate(native_string, buffer);
+          native_string = msStringConcatenate(native_string, "'");
+        } else {
+          snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
+          native_string = msStringConcatenate(native_string, buffer);
+        }
+        break;
+      }
+      case MS_TOKEN_LITERAL_STRING:
+        strtmpl = "%s";
+        snippet = (char *)msSmallMalloc(strlen(strtmpl) +
+                                        strlen(node->tokenval.strval));
+        sprintf(snippet, strtmpl, node->tokenval.strval); // TODO: escape strval
+        snippet = msReplaceSubstring(snippet, "'", "''");
+        native_string = msStringConcatenate(native_string, "'");
+        if (ieq == MS_TRUE) {
+          native_string = msStringConcatenate(native_string, "^");
+        }
+        native_string = msStringConcatenate(native_string, snippet);
+        if (ieq == MS_TRUE) {
+          native_string = msStringConcatenate(native_string, "$");
+        }
+        native_string = msStringConcatenate(native_string, "'");
+        if (ieq == MS_TRUE) {
+          native_string = msStringConcatenate(native_string, ")");
+          ieq = MS_FALSE;
+        }
+        msFree(snippet);
+        break;
+      case MS_TOKEN_LITERAL_BOOLEAN:
+        if (node->tokenval.dblval == MS_TRUE)
+          native_string = msStringConcatenate(native_string, "'TRUE'");
+        else
+          native_string = msStringConcatenate(native_string, "'FALSE'");
+        break;
+      case MS_TOKEN_LITERAL_TIME: {
+        int resolution = msTimeGetResolution(node->tokensrc);
+        snippet = (char *)msSmallMalloc(128);
+        switch (resolution) {
+        case TIME_RESOLUTION_YEAR:
+          strtmpl = "to_date('%d-01','YYYY-MM')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900));
+          break;
+        case TIME_RESOLUTION_MONTH:
+          strtmpl = "to_date('%d-%02d','YYYY-MM')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1));
+          break;
+        case TIME_RESOLUTION_DAY:
+          strtmpl = "to_date('%d-%02d-%02d','YYYY-MM-DD') ";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday);
+          break;
+        case TIME_RESOLUTION_HOUR:
+          strtmpl = "to_timestamp('%d-%02d-%02d %02d','YYYY-MM-DD hh24')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour);
+          break;
+        case TIME_RESOLUTION_MINUTE:
+          strtmpl =
+              "to_timestamp('%d-%02d-%02d %02d:%02d','YYYY-MM-DD hh24:mi')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour,
+                  node->tokenval.tmval.tm_min);
+          break;
+        case TIME_RESOLUTION_SECOND:
+          strtmpl = "to_timestamp('%d-%02d-%02d %02d:%02d:%02d','YYYY-MM-DD "
+                    "hh24:mi:ss')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour,
+                  node->tokenval.tmval.tm_min, node->tokenval.tmval.tm_sec);
+          break;
+        }
+        native_string = msStringConcatenate(native_string, snippet);
+        msFree(snippet);
+        break;
+      }
+      case MS_TOKEN_LITERAL_SHAPE:
+        native_string = msStringConcatenate(native_string, " SDO_GEOMETRY('");
+        native_string = msStringConcatenate(
+            native_string, msShapeToWKT(node->tokenval.shpval));
+        native_string = msStringConcatenate(native_string, "'");
+        if (srid && strcmp(srid, "") != 0) {
+          native_string = msStringConcatenate(native_string, ", ");
+          native_string = msStringConcatenate(native_string, srid);
+        }
+        native_string = msStringConcatenate(native_string, ") ");
+        // msDebug("------> srid node value: %s", node->tokenval.shpval);
+        break;
+      case MS_TOKEN_BINDING_DOUBLE:
+        native_string =
+            msStringConcatenate(native_string, node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_BINDING_INTEGER:
+        native_string =
+            msStringConcatenate(native_string, node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_BINDING_STRING:
+        if (node->next->token == MS_TOKEN_COMPARISON_RE ||
+            node->next->token == MS_TOKEN_COMPARISON_IRE ||
+            node->next->token == MS_TOKEN_COMPARISON_IEQ) {
+          native_string = msStringConcatenate(native_string, "REGEXP_LIKE( ");
+        }
+        strtmpl = "%s";
+        snippet = (char *)msSmallMalloc(strlen(strtmpl) +
+                                        strlen(node->tokenval.strval));
+        sprintf(snippet, strtmpl,
+                node->tokenval
+                    .strval); // TODO: escape strval (msPostGISEscapeSQLParam)
+        native_string = msStringConcatenate(native_string, snippet);
+        free(snippet);
+        break;
+      case MS_TOKEN_BINDING_TIME:
+        native_string =
+            msStringConcatenate(native_string, node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_BINDING_SHAPE:
+        native_string = msStringConcatenate(native_string, geom_column_name);
+        break;
+      case MS_TOKEN_BINDING_MAP_CELLSIZE: {
+        char buffer[32];
+        snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
+        native_string = msStringConcatenate(native_string, buffer);
+        break;
+      }
+      case MS_TOKEN_LOGICAL_AND:
+        native_string = msStringConcatenate(native_string, " AND ");
+        break;
+      case MS_TOKEN_LOGICAL_OR:
+        native_string = msStringConcatenate(native_string, " OR ");
+        break;
+      case MS_TOKEN_LOGICAL_NOT:
+        native_string = msStringConcatenate(native_string, " NOT ");
+        break;
+      case MS_TOKEN_COMPARISON_EQ:
+        native_string = msStringConcatenate(native_string, " = ");
+        break;
+      case MS_TOKEN_COMPARISON_NE:
+        native_string = msStringConcatenate(native_string, " != ");
+        break;
+      case MS_TOKEN_COMPARISON_GT:
+        native_string = msStringConcatenate(native_string, " > ");
+        break;
+      case MS_TOKEN_COMPARISON_GE:
+        native_string = msStringConcatenate(native_string, " >= ");
+        break;
+      case MS_TOKEN_COMPARISON_LT:
+        native_string = msStringConcatenate(native_string, " < ");
+        break;
+      case MS_TOKEN_COMPARISON_LE:
+        native_string = msStringConcatenate(native_string, " <= ");
+        break;
+      case MS_TOKEN_COMPARISON_IEQ:
+        // this is for  case insensitve equals check
+        msDebug("got a IEQ comparison\n");
+        regexp_like = MS_TRUE;
+        case_ins = MS_TRUE;
+        ieq = MS_TRUE;
+        native_string = msStringConcatenate(native_string, ", ");
+        break;
+      case MS_TOKEN_COMPARISON_RE:
+        // the regex formats that MS uses as Oracle users are different so just
+        // return and eval the regex's in MS
+        // return MS_SUCCESS;
+        msDebug("got a RE comparison\n");
+        regexp_like = MS_TRUE;
+        native_string = msStringConcatenate(native_string, ", ");
+        break;
+      case MS_TOKEN_COMPARISON_IRE:
+        // the regex formats that MS uses as Oracle users are different so just
+        // return and eval the regex's in MS
+        regexp_like = MS_TRUE;
+        case_ins = MS_TRUE;
+        native_string = msStringConcatenate(native_string, ", ");
+        break;
+      case MS_TOKEN_COMPARISON_IN:
+        native_string = msStringConcatenate(native_string, " IN ");
+        break;
+      case MS_TOKEN_COMPARISON_INTERSECTS:
+        native_string = msStringConcatenate(native_string, " ST_INTERSECTS ");
+        break;
+      case MS_TOKEN_COMPARISON_DISJOINT:
+        native_string =
+            msStringConcatenate(native_string, " NOT ST_INTERSECTS ");
+        break;
+      case MS_TOKEN_COMPARISON_TOUCHES:
+        native_string = msStringConcatenate(native_string, " ST_TOUCH ");
+        break;
+      case MS_TOKEN_COMPARISON_OVERLAPS:
+        native_string = msStringConcatenate(native_string, " ST_OVERLAPS ");
+        break;
+      case MS_TOKEN_COMPARISON_CROSSES:
+        native_string =
+            msStringConcatenate(native_string, " SDO_OVERLAPBDYDISJOINT ");
+        break;
+      case MS_TOKEN_COMPARISON_WITHIN:
+        native_string = msStringConcatenate(native_string, " ST_INSIDE ");
+        break;
+      case MS_TOKEN_COMPARISON_CONTAINS:
+        native_string = msStringConcatenate(native_string, " SDO_CONTAINS ");
+        break;
+      case MS_TOKEN_COMPARISON_EQUALS:
+        native_string = msStringConcatenate(native_string, " SDO_EQUAL ");
+        break;
+      case MS_TOKEN_COMPARISON_BEYOND:
+        // support for the wfs case
+        dwithin = MS_TRUE;
+        native_string =
+            msStringConcatenate(native_string, "NOT SDO_WITHIN_DISTANCE ");
+        break;
+      case MS_TOKEN_COMPARISON_DWITHIN:
+        dwithin = MS_TRUE;
+        native_string =
+            msStringConcatenate(native_string, "SDO_WITHIN_DISTANCE ");
+        break;
+      case MS_TOKEN_FUNCTION_LENGTH:
+        break;
+      case MS_TOKEN_FUNCTION_TOSTRING:
+        break;
+      case MS_TOKEN_FUNCTION_COMMIFY:
+        break;
+      case MS_TOKEN_FUNCTION_AREA:
+        native_string =
+            msStringConcatenate(native_string, "SDO_GEOM.SDO_AREA ");
+        break;
+      case MS_TOKEN_FUNCTION_ROUND:
+        native_string = msStringConcatenate(native_string, "ROUND ");
+        break;
+      case MS_TOKEN_FUNCTION_FROMTEXT:
+        native_string = msStringConcatenate(native_string, "SDO_GEOMETRY ");
+        break;
+      case MS_TOKEN_FUNCTION_BUFFER:
+        // native_string = msStringConcatenate(native_string, " SDO_BUFFER ");
+        // buffer = MS_TRUE;
+        break;
+      case MS_TOKEN_FUNCTION_DIFFERENCE:
+        native_string = msStringConcatenate(native_string, "ST_DIFFERENCE ");
+        break;
+      case MS_TOKEN_FUNCTION_SIMPLIFY:
+        native_string =
+            msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
+        break;
+      case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+        break;
+      case MS_TOKEN_FUNCTION_GENERALIZE:
+        native_string =
+            msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
+        break;
+      case ',':
+        native_string = msStringConcatenate(native_string, ",");
+        break;
+      case '~':
+        break;
+      default:
+        fprintf(stderr, "Translation to native SQL failed.\n");
+        msFree(native_string);
+        if (layer->debug) {
+          msDebug("Token not caught, exiting: Token is %i\n", node->token);
+        }
+
+        if (geom_column_name)
+          free(geom_column_name);
+        if (srid)
+          free(srid);
+        if (unique)
+          free(unique);
+        if (indexfield)
+          free(indexfield);
+        if (table_name)
+          free(table_name);
+
+        return MS_SUCCESS; /* not an error */
+      }
+      nodeCount++;
+      node = node->next;
+
+      // fprintf(stderr, "native filter: %s\n", native_string);
+    }
+
+    filter->native_string = msStrdup(native_string);
+    if (layer->debug >= 4)
+      msDebug("total filter tokens are %i\n,", nodeCount);
+    msFree(native_string);
+  }
+
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (table_name)
+    free(table_name);
+
+  return MS_SUCCESS;
+}
+
+#else
+/* OracleSpatial "not-supported" procedures */
+
+int msOracleSpatialLayerOpen(layerObj *layer) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerOpen()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerIsOpen(layerObj *layer) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerIsOpen()");
+  return MS_FALSE;
+}
+
+int msOracleSpatialLayerClose(layerObj *layer) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerClose()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerWhichShapes(layerObj *layer, rectObj rect,
+                                    int isQuery) {
+  (void)layer;
+  (void)rect;
+  (void)isQuery;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerWhichShapes()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerNextShape(layerObj *layer, shapeObj *shape) {
+  (void)layer;
+  (void)shape;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerNextShape()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerGetItems(layerObj *layer) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerGetItems()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerGetShape(layerObj *layer, shapeObj *shape,
+                                 resultObj *record) {
+  (void)layer;
+  (void)shape;
+  (void)record;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerGetShape()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent) {
+  (void)layer;
+  (void)extent;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerGetExtent()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerInitItemInfo(layerObj *layer) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerInitItemInfo()");
+  return MS_FAILURE;
+}
+
+void msOracleSpatialLayerFreeItemInfo(layerObj *layer) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerFreeItemInfo()");
+}
+
+int msOracleSpatialLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                     shapeObj *shape) {
+  (void)map;
+  (void)layer;
+  (void)c;
+  (void)shape;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerGetAutoStyle()");
+  return MS_FAILURE;
+}
+
+void msOracleSpatialEnablePaging(layerObj *layer, int value) {
+  (void)layer;
+  (void)value;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerEnablePaging()");
+  return;
+}
+
+int msOracleSpatialGetPaging(layerObj *layer) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerGetPaging()");
+  return MS_FAILURE;
+}
+
+int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                        char *filteritem) {
+  (void)layer;
+  (void)filter;
+  (void)filteritem;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerTranslateFilter()");
+  return MS_FAILURE;
+}
+
+char *msOracleSpatialEscapePropertyName(layerObj *layer,
+                                        const char *pszString) {
+  (void)layer;
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerEscapePropertyName()");
+  return msStrdup(pszString);
+}
+#endif
+
+#if defined USE_ORACLE_PLUGIN
+MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj *vtable,
+                                               layerObj *layer) {
+  assert(layer != NULL);
+  assert(vtable != NULL);
+
+  vtable->LayerTranslateFilter = msOracleSpatialLayerTranslateFilter;
+
+  vtable->LayerInitItemInfo = msOracleSpatialLayerInitItemInfo;
+  vtable->LayerFreeItemInfo = msOracleSpatialLayerFreeItemInfo;
+  vtable->LayerOpen = msOracleSpatialLayerOpen;
+  vtable->LayerIsOpen = msOracleSpatialLayerIsOpen;
+  vtable->LayerWhichShapes = msOracleSpatialLayerWhichShapes;
+  vtable->LayerNextShape = msOracleSpatialLayerNextShape;
+  vtable->LayerGetShape = msOracleSpatialLayerGetShape;
+  vtable->LayerClose = msOracleSpatialLayerClose;
+  vtable->LayerGetItems = msOracleSpatialLayerGetItems;
+  vtable->LayerGetExtent = msOracleSpatialLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  vtable->LayerCloseConnection = msOracleSpatialLayerClose;
+  vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
+  vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  // vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
+  // vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
+  /* layer->vtable->LayerGetNumFeatures, use default */
+  /* layer->vtable->LayerGetAutoProjection =
+   * msOracleSpatialLayerGetAutoProjection; Disabled until tested */
+  vtable->LayerEnablePaging = msOracleSpatialEnablePaging;
+  vtable->LayerGetPaging = msOracleSpatialGetPaging;
+
+  return MS_SUCCESS;
+}
+
+#else /*if ORACLE_PLUGIN is defined, then this file is not used by             \
+        libmapserver and therefre there is no need to include this function */
+int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerTranslateFilter = msOracleSpatialLayerTranslateFilter;
+
+  layer->vtable->LayerInitItemInfo = msOracleSpatialLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msOracleSpatialLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msOracleSpatialLayerOpen;
+  layer->vtable->LayerIsOpen = msOracleSpatialLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msOracleSpatialLayerWhichShapes;
+  layer->vtable->LayerNextShape = msOracleSpatialLayerNextShape;
+  layer->vtable->LayerGetShape = msOracleSpatialLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msOracleSpatialLayerClose;
+  layer->vtable->LayerGetItems = msOracleSpatialLayerGetItems;
+  layer->vtable->LayerGetExtent = msOracleSpatialLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  layer->vtable->LayerCloseConnection = msOracleSpatialLayerClose;
+  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  // layer->vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
+  // layer->vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+  /* layer->vtable->LayerGetAutoProjection =
+   * msOracleSpatialLayerGetAutoProjection; Disabled until tested */
+  layer->vtable->LayerEnablePaging = msOracleSpatialEnablePaging;
+  layer->vtable->LayerGetPaging = msOracleSpatialGetPaging;
+
+  return MS_SUCCESS;
+}
+#endif
diff -pruN 8.0.1-5/src/mapoutput.c 8.2.0~beta1-1~exp1/src/mapoutput.c
--- 8.0.1-5/src/mapoutput.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapoutput.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1183 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Various support code related to the outputFormatObj.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2002, Frank Warmerdam
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "mapows.h"
+
+static outputFormatObj *msAllocOutputFormat(mapObj *map, const char *name,
+                                            const char *driver);
+
+/*************************************************************************
+
+NOTES on outputFormatObj:
+
+typedef struct {
+  char *name;
+  char *mimetype;
+  char *driver;
+  int  imagemode; // MS_IMAGEMODE_* value.
+  int  transparent;
+  int  numformatoptions;
+  char **formatoptions;
+} outputFormatObj;
+
+ NAME - Associates an internal name with the declaration.  The value used
+        has not intrinsic meaning and is just used to associate with the
+        MAP level IMAGETYPE.  It is also the "name" used for the format
+        in WMS capabilities documents, and FORMAT= requests. (required)
+
+ MIMETYPE - The mime type to use for this format.  If omitted, the value
+            will be derived from the DRIVER or default to the value for
+            untyped binary data will be used.  (optional - may be NULL)
+
+ DRIVER - This indicates which internal driver mechanism is to be used.
+          Anything prefixed by "GDAL/" will be handled by the GDAL driver, with
+          the remainder taken as the GDAL format name. (required)
+
+ IMAGEMODE - Has one of "PC256", "RGB", or "RGBA" indicating whether
+             the imaging should be done to a 256 pseudo-colored, 24bit RGB, or
+             32bit RGBA (A=alpha/transparency) result image.  Note that the
+             IMAGEMODE actually affects how all the rendering for the map is
+             done, long before it is output to a particular output format.
+             The default value is the traditional "PC256".  Some output
+             formats can only support some IMAGEMODE values. (optional)
+
+             Translate as MS_IMAGEMODE_PC256, MS_IMAGEMODE_RGB and
+             MS_IMAGEMODE_RGBA.
+
+             For "GDAL/" drivers, the following extra imagemodes are supported:
+                "BYTE" / MS_IMAGEMODE_BYTE
+                "INT16" / MS_IMAGEMODE_INT16
+                "FLOAT32" / MS_IMAGEMODE_FLOAT32
+
+             Not too sure what this should be set to for output formats like
+             flash and SVG.
+
+ TRANSPARENT - A value of "ON" or "OFF" indicating whether transparency
+               support should be enabled.  Same as the old TRANSPARENT flag
+               at the MAP level.
+
+ FORMATOPTION - Contains an argument for the specific driver used.  There may
+                be any number of format options for a given OUTPUTFORMAT
+                declaration.  FORMATOPTION will be used to encode the older
+                INTERLACE, and QUALITY values.
+
+                Handled as a MapServer style CharArray.
+
+ *************************************************************************/
+
+struct defaultOutputFormatEntry {
+  const char *name;
+  const char *driver;
+  const char *mimetype;
+};
+
+struct defaultOutputFormatEntry defaultoutputformats[] = {
+    {"png", "AGG/PNG", "image/png"},
+    {"jpeg", "AGG/JPEG", "image/jpeg"},
+    {"png8", "AGG/PNG8", "image/png; mode=8bit"},
+    {"png24", "AGG/PNG", "image/png; mode=24bit"},
+    {"jpegpng", "AGG/MIXED", "image/vnd.jpeg-png"},
+    {"jpegpng8", "AGG/MIXED", "image/vnd.jpeg-png8"},
+#ifdef USE_CAIRO
+    {"pdf", "CAIRO/PDF", "application/x-pdf"},
+    {"svg", "CAIRO/SVG", "image/svg+xml"},
+    {"cairopng", "CAIRO/PNG", "image/png"},
+#endif
+    {"GTiff", "GDAL/GTiff", "image/tiff"},
+#ifdef USE_KML
+    {"kml", "KML", "application/vnd.google-earth.kml+xml"},
+    {"kmz", "KMZ", "application/vnd.google-earth.kmz"},
+#endif
+#ifdef USE_PBF
+    {"mvt", "MVT", "application/vnd.mapbox-vector-tile"},
+    // The following format is added to keep backward compatibility
+    // for the application/x-protobuf media type
+    {"mvtxprotobuf", "MVT", "application/x-protobuf"},
+#endif
+    {"json", "UTFGrid", "application/json"},
+    {NULL, NULL, NULL}};
+
+/************************************************************************/
+/*                  msPostMapParseOutputFormatSetup()                   */
+/************************************************************************/
+
+int msPostMapParseOutputFormatSetup(mapObj *map)
+
+{
+  outputFormatObj *format;
+
+  /* If IMAGETYPE not set use the first user defined OUTPUTFORMAT.
+     If none, use the first default format. */
+  if (map->imagetype == NULL && map->numoutputformats > 0)
+    map->imagetype = msStrdup(map->outputformatlist[0]->name);
+  if (map->imagetype == NULL)
+    map->imagetype = msStrdup(defaultoutputformats[0].name);
+
+  /* select the current outputformat into map->outputformat */
+  format = msSelectOutputFormat(map, map->imagetype);
+  if (format == NULL) {
+    msSetError(MS_MISCERR, "Unable to select IMAGETYPE `%s'.",
+               "msPostMapParseOutputFormatSetup()",
+               map->imagetype ? map->imagetype : "(null)");
+    return MS_FAILURE;
+  }
+
+  msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                    msCreateDefaultOutputFormat()                     */
+/************************************************************************/
+
+outputFormatObj *msCreateDefaultOutputFormat(mapObj *map, const char *driver,
+                                             const char *name,
+                                             const char *mimetype)
+
+{
+
+  outputFormatObj *format = NULL;
+  if (strncasecmp(driver, "GD/", 3) == 0) {
+    return msCreateDefaultOutputFormat(map, "AGG/PNG8", name, mimetype);
+  }
+
+  if (strcasecmp(driver, "UTFGRID") == 0) {
+    if (!name)
+      name = "utfgrid";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("application/json");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("json");
+    format->renderer = MS_RENDER_WITH_UTFGRID;
+  }
+
+  else if (strcasecmp(driver, "AGG/PNG") == 0) {
+    if (!name)
+      name = "png";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/png");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("png");
+    format->renderer = MS_RENDER_WITH_AGG;
+  }
+
+  else if (strcasecmp(driver, "AGG/PNG8") == 0) {
+    if (!name)
+      name = "png8";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/png; mode=8bit");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("png");
+    format->renderer = MS_RENDER_WITH_AGG;
+    msSetOutputFormatOption(format, "QUANTIZE_FORCE", "on");
+    msSetOutputFormatOption(format, "QUANTIZE_COLORS", "256");
+  }
+
+  else if (strcasecmp(driver, "AGG/JPEG") == 0) {
+    if (!name)
+      name = "jpeg";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/jpeg");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("jpg");
+    format->renderer = MS_RENDER_WITH_AGG;
+  }
+#if defined(USE_PBF)
+  else if (strcasecmp(driver, "MVT") == 0) {
+    if (!name)
+      name = "mvt";
+    format = msAllocOutputFormat(map, name, driver);
+    if (mimetype) {
+      format->mimetype = msStrdup(mimetype);
+    } else {
+      format->mimetype = msStrdup("application/vnd.mapbox-vector-tile");
+    }
+
+    format->imagemode = MS_IMAGEMODE_FEATURE;
+    format->extension = msStrdup("pbf");
+    format->renderer = MS_RENDER_WITH_MVT;
+  }
+#endif
+
+  else if (strcasecmp(driver, "AGG/MIXED") == 0 && name != NULL &&
+           strcasecmp(name, "jpegpng") == 0) {
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/vnd.jpeg-png");
+    format->imagemode = MS_IMAGEMODE_RGBA;
+    format->extension = msStrdup("XXX");
+    format->renderer = MS_RENDER_WITH_AGG;
+    msSetOutputFormatOption(format, "OPAQUE_FORMAT", "jpeg");
+    msSetOutputFormatOption(format, "TRANSPARENT_FORMAT", "png24");
+  }
+
+  else if (strcasecmp(driver, "AGG/MIXED") == 0 && name != NULL &&
+           strcasecmp(name, "jpegpng8") == 0) {
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/vnd.jpeg-png8");
+    format->imagemode = MS_IMAGEMODE_RGBA;
+    format->extension = msStrdup("XXX");
+    format->renderer = MS_RENDER_WITH_AGG;
+    msSetOutputFormatOption(format, "OPAQUE_FORMAT", "jpeg");
+    msSetOutputFormatOption(format, "TRANSPARENT_FORMAT", "png8");
+  }
+
+  else if (strcasecmp(driver, "AGG/MIXED") == 0) {
+    if (!name)
+      name = "mixed";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/mixed");
+    format->imagemode = MS_IMAGEMODE_RGBA;
+    format->extension = msStrdup("XXX");
+    format->renderer = MS_RENDER_WITH_AGG;
+  }
+
+#if defined(USE_CAIRO)
+  else if (strcasecmp(driver, "CAIRO/PNG") == 0) {
+    if (!name)
+      name = "cairopng";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/png; mode=24bit");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("png");
+    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
+  } else if (strcasecmp(driver, "CAIRO/JPEG") == 0) {
+    if (!name)
+      name = "cairojpeg";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/jpeg");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("jpg");
+    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
+  } else if (strcasecmp(driver, "CAIRO/PDF") == 0) {
+    if (!name)
+      name = "pdf";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("application/x-pdf");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("pdf");
+    format->renderer = MS_RENDER_WITH_CAIRO_PDF;
+  } else if (strcasecmp(driver, "CAIRO/SVG") == 0) {
+    if (!name)
+      name = "svg";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/svg+xml");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("svg");
+    format->renderer = MS_RENDER_WITH_CAIRO_SVG;
+  }
+#ifdef _WIN32
+  else if (strcasecmp(driver, "CAIRO/WINGDI") == 0) {
+    if (!name)
+      name = "cairowinGDI";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("");
+    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
+  } else if (strcasecmp(driver, "CAIRO/WINGDIPRINT") == 0) {
+    if (!name)
+      name = "cairowinGDIPrint";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("");
+    format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
+  }
+#endif
+#endif
+
+#if defined(USE_OGL)
+  else if (strcasecmp(driver, "OGL/PNG") == 0) {
+    if (!name)
+      name = "oglpng24";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("image/png; mode=24bit");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("png");
+    format->renderer = MS_RENDER_WITH_OGL;
+  }
+#endif
+
+#if defined(USE_KML)
+  else if (strcasecmp(driver, "KML") == 0) {
+    if (!name)
+      name = "kml";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("application/vnd.google-earth.kml+xml");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("kml");
+    format->renderer = MS_RENDER_WITH_KML;
+    msSetOutputFormatOption(format, "ATTACHMENT", "mapserver.kml");
+  } else if (strcasecmp(driver, "KMZ") == 0) {
+    if (!name)
+      name = "kmz";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("application/vnd.google-earth.kmz");
+    format->imagemode = MS_IMAGEMODE_RGB;
+    format->extension = msStrdup("kmz");
+    format->renderer = MS_RENDER_WITH_KML;
+    msSetOutputFormatOption(format, "ATTACHMENT", "mapserver.kmz");
+  }
+#endif
+
+  else if (strncasecmp(driver, "gdal/", 5) == 0) {
+    if (!name)
+      name = driver + 5;
+    format = msAllocOutputFormat(map, name, driver);
+    if (msInitDefaultGDALOutputFormat(format) == MS_FAILURE) {
+      if (map != NULL) {
+        map->numoutputformats--;
+        map->outputformatlist[map->numoutputformats] = NULL;
+      }
+
+      msFreeOutputFormat(format);
+      format = NULL;
+    }
+  }
+
+  else if (strncasecmp(driver, "ogr/", 4) == 0) {
+    if (!name)
+      name = driver + 4;
+    format = msAllocOutputFormat(map, name, driver);
+    if (msInitDefaultOGROutputFormat(format) == MS_FAILURE) {
+      if (map != NULL) {
+        map->numoutputformats--;
+        map->outputformatlist[map->numoutputformats] = NULL;
+      }
+
+      msFreeOutputFormat(format);
+      format = NULL;
+    }
+  }
+
+  else if (strcasecmp(driver, "imagemap") == 0) {
+    if (!name)
+      name = "imagemap";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("text/html; driver=imagemap");
+    format->extension = msStrdup("html");
+    format->imagemode = MS_IMAGEMODE_NULL;
+    format->renderer = MS_RENDER_WITH_IMAGEMAP;
+  }
+
+  else if (strcasecmp(driver, "template") == 0) {
+    if (!name)
+      name = "template";
+    format = msAllocOutputFormat(map, name, driver);
+    format->mimetype = msStrdup("text/html");
+    format->extension = msStrdup("html");
+    format->imagemode = MS_IMAGEMODE_FEATURE;
+    format->renderer = MS_RENDER_WITH_TEMPLATE;
+  }
+
+  if (format != NULL)
+    format->inmapfile = MS_FALSE;
+
+  return format;
+}
+
+/************************************************************************/
+/*                    msApplyDefaultOutputFormats()                     */
+/************************************************************************/
+
+void msApplyDefaultOutputFormats(mapObj *map) {
+  char *saved_imagetype;
+  struct defaultOutputFormatEntry *defEntry;
+
+  if (map->imagetype == NULL)
+    saved_imagetype = NULL;
+  else
+    saved_imagetype = msStrdup(map->imagetype);
+
+  defEntry = defaultoutputformats;
+  while (defEntry->name) {
+    if (msSelectOutputFormat(map, defEntry->name) == NULL)
+      msCreateDefaultOutputFormat(map, defEntry->driver, defEntry->name,
+                                  defEntry->mimetype);
+    defEntry++;
+  }
+  if (map->imagetype != NULL)
+    free(map->imagetype);
+  map->imagetype = saved_imagetype;
+}
+
+/************************************************************************/
+/*                         msFreeOutputFormat()                         */
+/************************************************************************/
+
+void msFreeOutputFormat(outputFormatObj *format)
+
+{
+  if (format == NULL)
+    return;
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(format)) {
+    return;
+  }
+
+  if (MS_RENDERER_PLUGIN(format) && format->vtable) {
+    format->vtable->cleanup(MS_RENDERER_CACHE(format->vtable));
+    free(format->vtable);
+  }
+  msFree(format->name);
+  msFree(format->mimetype);
+  msFree(format->driver);
+  msFree(format->extension);
+  msFreeCharArray(format->formatoptions, format->numformatoptions);
+  msFree(format);
+}
+
+/************************************************************************/
+/*                        msAllocOutputFormat()                         */
+/************************************************************************/
+
+static outputFormatObj *msAllocOutputFormat(mapObj *map, const char *name,
+                                            const char *driver)
+
+{
+  outputFormatObj *format;
+
+  /* -------------------------------------------------------------------- */
+  /*      Allocate the format object.                                     */
+  /* -------------------------------------------------------------------- */
+  format = (outputFormatObj *)calloc(1, sizeof(outputFormatObj));
+  if (format == NULL) {
+    msSetError(MS_MEMERR, NULL, "msAllocOutputFormat()");
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize various fields.                                      */
+  /* -------------------------------------------------------------------- */
+  format->bands = 1;
+  format->name = msStrdup(name);
+  format->driver = msStrdup(driver);
+  format->refcount = 0;
+  format->vtable = NULL;
+  format->device = NULL;
+  format->imagemode = MS_IMAGEMODE_RGB;
+
+  /* -------------------------------------------------------------------- */
+  /*      Attach to map.                                                  */
+  /* -------------------------------------------------------------------- */
+  if (map != NULL) {
+    map->numoutputformats++;
+    if (map->outputformatlist == NULL)
+      map->outputformatlist = (outputFormatObj **)malloc(sizeof(void *));
+    else
+      map->outputformatlist = (outputFormatObj **)realloc(
+          map->outputformatlist, sizeof(void *) * map->numoutputformats);
+
+    map->outputformatlist[map->numoutputformats - 1] = format;
+    format->refcount++;
+  }
+
+  return format;
+}
+
+/************************************************************************/
+/*                        msAppendOutputFormat()                        */
+/*                                                                      */
+/*      Add an output format  .                                         */
+/*      http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511           */
+/************************************************************************/
+int msAppendOutputFormat(mapObj *map, outputFormatObj *format) {
+  /* -------------------------------------------------------------------- */
+  /*      Attach to map.                                                  */
+  /* -------------------------------------------------------------------- */
+  assert(map);
+  map->numoutputformats++;
+  if (map->outputformatlist == NULL)
+    map->outputformatlist = (outputFormatObj **)malloc(sizeof(void *));
+  else
+    map->outputformatlist = (outputFormatObj **)realloc(
+        map->outputformatlist, sizeof(void *) * map->numoutputformats);
+
+  map->outputformatlist[map->numoutputformats - 1] = format;
+  MS_REFCNT_INCR(format);
+
+  return map->numoutputformats;
+}
+
+/************************************************************************/
+/*                        msRemoveOutputFormat()                        */
+/*                                                                      */
+/*      Remove an output format (by name).                              */
+/*      http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511           */
+/************************************************************************/
+int msRemoveOutputFormat(mapObj *map, const char *name) {
+  int i, j;
+  /* -------------------------------------------------------------------- */
+  /*      Detach from map.                                                */
+  /* -------------------------------------------------------------------- */
+  if (map != NULL) {
+    if (map->outputformatlist == NULL) {
+      msSetError(MS_CHILDERR, "Can't remove format from empty outputformatlist",
+                 "msRemoveOutputFormat()");
+      return MS_FAILURE;
+    } else {
+      i = msGetOutputFormatIndex(map, name);
+      if (i >= 0) {
+        map->numoutputformats--;
+        if (MS_REFCNT_DECR_IS_ZERO(map->outputformatlist[i]))
+          msFreeOutputFormat(map->outputformatlist[i]);
+
+        for (j = i; j < map->numoutputformats - 1; j++) {
+          map->outputformatlist[j] = map->outputformatlist[j + 1];
+        }
+      }
+      map->outputformatlist = (outputFormatObj **)realloc(
+          map->outputformatlist, sizeof(void *) * (map->numoutputformats));
+      return MS_SUCCESS;
+    }
+  }
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                       msGetOutputFormatIndex()                       */
+/*                                                                      */
+/*      Pulled this out of msSelectOutputFormat for use in other cases. */
+/************************************************************************/
+
+int msGetOutputFormatIndex(mapObj *map, const char *imagetype) {
+  int i;
+  /* -------------------------------------------------------------------- */
+  /*      Try to find the format in the maps list of formats, first by    */
+  /*      mime type, and then by output format name.                      */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < map->numoutputformats; i++) {
+    if (map->outputformatlist[i]->mimetype != NULL &&
+        strcasecmp(imagetype, map->outputformatlist[i]->mimetype) == 0)
+      return i;
+  }
+
+  for (i = 0; i < map->numoutputformats; i++) {
+    if (strcasecmp(imagetype, map->outputformatlist[i]->name) == 0)
+      return i;
+  }
+
+  return -1;
+}
+
+/************************************************************************/
+/*                        msSelectOutputFormat()                        */
+/************************************************************************/
+
+outputFormatObj *msSelectOutputFormat(mapObj *map, const char *imagetype)
+
+{
+  int index;
+  outputFormatObj *format = NULL;
+
+  if (map == NULL || imagetype == NULL || strlen(imagetype) == 0)
+    return NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Try to find the format in the maps list of formats, first by    */
+  /*      mime type, and then by output format name.                      */
+  /* -------------------------------------------------------------------- */
+  index = msGetOutputFormatIndex(map, imagetype);
+  if (index >= 0) {
+    format = map->outputformatlist[index];
+  } else {
+    struct defaultOutputFormatEntry *formatEntry = defaultoutputformats;
+    while (formatEntry->name) {
+      if (!strcasecmp(imagetype, formatEntry->name) ||
+          !strcasecmp(imagetype, formatEntry->mimetype)) {
+        format = msCreateDefaultOutputFormat(
+            map, formatEntry->driver, formatEntry->name, formatEntry->mimetype);
+        break;
+      }
+      formatEntry++;
+    }
+  }
+
+  if (format) {
+    if (map->imagetype)
+      free(map->imagetype);
+    map->imagetype = msStrdup(format->name);
+  }
+
+  if (format != NULL)
+    msOutputFormatValidate(format, MS_FALSE);
+
+  return format;
+}
+
+/************************************************************************/
+/*                        msApplyOutputFormat()                         */
+/************************************************************************/
+
+void msApplyOutputFormat(outputFormatObj **target, outputFormatObj *format,
+                         int transparent)
+
+{
+  int change_needed = MS_FALSE;
+  outputFormatObj *formatToFree = NULL;
+
+  assert(target != NULL);
+
+  if (*target != NULL && MS_REFCNT_DECR_IS_ZERO((*target))) {
+    formatToFree = *target;
+    *target = NULL;
+  }
+
+  if (format == NULL) {
+    if (formatToFree)
+      msFreeOutputFormat(formatToFree);
+    *target = NULL;
+    return;
+  }
+
+  msOutputFormatValidate(format, MS_FALSE);
+
+  /* -------------------------------------------------------------------- */
+  /*      Do we need to change any values?  If not, then just apply       */
+  /*      and return.                                                     */
+  /* -------------------------------------------------------------------- */
+  if (transparent != MS_NOOVERRIDE && !format->transparent != !transparent)
+    change_needed = MS_TRUE;
+
+  if (change_needed) {
+
+    if (format->refcount > 0)
+      format = msCloneOutputFormat(format);
+
+    if (transparent != MS_NOOVERRIDE) {
+      format->transparent = transparent;
+      if (format->imagemode == MS_IMAGEMODE_RGB)
+        format->imagemode = MS_IMAGEMODE_RGBA;
+    }
+  }
+
+  *target = format;
+  format->refcount++;
+  if (MS_RENDERER_PLUGIN(format)) {
+    msInitializeRendererVTable(format);
+  }
+
+  if (formatToFree)
+    msFreeOutputFormat(formatToFree);
+}
+
+/************************************************************************/
+/*                        msCloneOutputFormat()                         */
+/************************************************************************/
+
+outputFormatObj *msCloneOutputFormat(outputFormatObj *src)
+
+{
+  outputFormatObj *dst;
+  int i;
+
+  dst = msAllocOutputFormat(NULL, src->name, src->driver);
+
+  msFree(dst->mimetype);
+  if (src->mimetype)
+    dst->mimetype = msStrdup(src->mimetype);
+  else
+    dst->mimetype = NULL;
+
+  msFree(dst->extension);
+  if (src->extension)
+    dst->extension = msStrdup(src->extension);
+  else
+    dst->extension = NULL;
+
+  dst->imagemode = src->imagemode;
+  dst->renderer = src->renderer;
+
+  dst->transparent = src->transparent;
+  dst->bands = src->bands;
+
+  dst->numformatoptions = src->numformatoptions;
+  dst->formatoptions = (char **)malloc(sizeof(char *) * src->numformatoptions);
+
+  for (i = 0; i < src->numformatoptions; i++)
+    dst->formatoptions[i] = msStrdup(src->formatoptions[i]);
+
+  dst->inmapfile = src->inmapfile;
+
+  return dst;
+}
+
+/************************************************************************/
+/*                      msGetOutputFormatOption()                       */
+/*                                                                      */
+/*      Fetch the value of a particular option.  It is assumed the      */
+/*      options are in "KEY=VALUE" format.                              */
+/************************************************************************/
+
+const char *msGetOutputFormatOption(outputFormatObj *format,
+                                    const char *optionkey,
+                                    const char *defaultresult)
+
+{
+  int i, len = strlen(optionkey);
+
+  for (i = 0; i < format->numformatoptions; i++) {
+    if (strncasecmp(format->formatoptions[i], optionkey, len) == 0 &&
+        format->formatoptions[i][len] == '=')
+      return format->formatoptions[i] + len + 1;
+  }
+
+  return defaultresult;
+}
+
+/************************************************************************/
+/*                      msSetOutputFormatOption()                       */
+/************************************************************************/
+
+void msSetOutputFormatOption(outputFormatObj *format, const char *key,
+                             const char *value)
+
+{
+  char *newline;
+  int i, len;
+
+  if (value == NULL)
+    return;
+
+  /* -------------------------------------------------------------------- */
+  /*      Format the name=value pair into a newly allocated string.       */
+  /* -------------------------------------------------------------------- */
+  newline = (char *)malloc(strlen(key) + strlen(value) + 2);
+  if (newline == NULL) {
+    assert(newline != NULL);
+    return;
+  }
+
+  sprintf(newline, "%s=%s", key, value);
+
+  /* -------------------------------------------------------------------- */
+  /*      Does this key already occur?  If so replace it.                 */
+  /* -------------------------------------------------------------------- */
+  len = strlen(key);
+
+  for (i = 0; i < format->numformatoptions; i++) {
+    if (strncasecmp(format->formatoptions[i], key, len) == 0 &&
+        format->formatoptions[i][len] == '=') {
+      free(format->formatoptions[i]);
+      format->formatoptions[i] = newline;
+      return;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      otherwise, we need to grow the list.                            */
+  /* -------------------------------------------------------------------- */
+  format->numformatoptions++;
+  format->formatoptions = (char **)realloc(
+      format->formatoptions, sizeof(char *) * format->numformatoptions);
+
+  format->formatoptions[format->numformatoptions - 1] = newline;
+
+  /* -------------------------------------------------------------------- */
+  /*      Capture generic value(s) we are interested in.                  */
+  /* -------------------------------------------------------------------- */
+  if (strcasecmp(key, "BAND_COUNT") == 0)
+    format->bands = atoi(value);
+}
+
+/************************************************************************/
+/*                     msGetOutputFormatMimeList()                      */
+/************************************************************************/
+
+void msGetOutputFormatMimeList(mapObj *map, char **mime_list, int max_mime)
+
+{
+  int mime_count = 0, i;
+
+  msApplyDefaultOutputFormats(map);
+  for (i = 0; i < map->numoutputformats && mime_count < max_mime; i++) {
+    int j;
+
+    if (map->outputformatlist[i]->mimetype == NULL)
+      continue;
+
+    for (j = 0; j < mime_count; j++) {
+      if (strcasecmp(mime_list[j], map->outputformatlist[i]->mimetype) == 0)
+        break;
+    }
+
+    if (j == mime_count)
+      mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
+  }
+
+  if (mime_count < max_mime)
+    mime_list[mime_count] = NULL;
+}
+
+/************************************************************************/
+/*                     msGetOutputFormatMimeList()                      */
+/************************************************************************/
+void msGetOutputFormatMimeListImg(mapObj *map, const char **mime_list,
+                                  int max_mime)
+
+{
+  int mime_count = 0, i, j;
+  const char *format_list = NULL;
+  char **tokens = NULL;
+  int numtokens = 0;
+  outputFormatObj *format;
+
+  msApplyDefaultOutputFormats(map);
+  format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                    "getlegendgraphic_formatlist");
+  if (format_list && strlen(format_list) > 0)
+    tokens = msStringSplit(format_list, ',', &numtokens);
+
+  if (tokens && numtokens > 0) {
+    for (j = 0; j < numtokens; j++) {
+      format = msSelectOutputFormat(map, tokens[j]);
+      if (format != NULL) {
+        mime_list[mime_count++] = format->mimetype;
+      }
+    }
+  } else
+    for (i = 0; i < map->numoutputformats && mime_count < max_mime; i++) {
+      int j;
+
+      if (map->outputformatlist[i]->mimetype == NULL)
+        continue;
+
+      for (j = 0; j < mime_count; j++) {
+        if (strcasecmp(mime_list[j], map->outputformatlist[i]->mimetype) == 0)
+          break;
+      }
+
+      if (j == mime_count && map->outputformatlist[i]->driver &&
+          strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4) == 0)
+        mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
+    }
+
+  if (mime_count < max_mime)
+    mime_list[mime_count] = NULL;
+  if (tokens)
+    msFreeCharArray(tokens, numtokens);
+}
+
+/************************************************************************/
+/*                  msGetOutputFormatMimeListWMS()                      */
+/************************************************************************/
+
+void msGetOutputFormatMimeListWMS(mapObj *map, const char **mime_list,
+                                  int max_mime) {
+  int mime_count = 0, i, j;
+  const char *format_list = NULL;
+  char **tokens = NULL;
+  int numtokens = 0;
+  outputFormatObj *format;
+  msApplyDefaultOutputFormats(map);
+  format_list =
+      msOWSLookupMetadata(&(map->web.metadata), "M", "getmap_formatlist");
+  if (format_list && strlen(format_list) > 0)
+    tokens = msStringSplit(format_list, ',', &numtokens);
+
+  if (tokens && numtokens > 0) {
+    for (j = 0; j < numtokens; j++) {
+      format = msSelectOutputFormat(map, tokens[j]);
+      if (format != NULL) {
+        mime_list[mime_count++] = format->mimetype;
+      }
+    }
+  } else {
+    for (i = 0; i < map->numoutputformats && mime_count < max_mime; i++) {
+      int j;
+
+      if (map->outputformatlist[i]->mimetype == NULL)
+        continue;
+
+      for (j = 0; j < mime_count; j++) {
+        if (strcasecmp(mime_list[j], map->outputformatlist[i]->mimetype) == 0)
+          break;
+      }
+
+      if (j == mime_count && map->outputformatlist[i]->driver &&
+          (strncasecmp(map->outputformatlist[i]->driver, "GDAL/", 5) == 0 ||
+           strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4) == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "CAIRO/SVG") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "CAIRO/PDF") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "kml") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "kmz") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "mvt") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "UTFGRID") == 0))
+        mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
+    }
+  }
+  if (mime_count < max_mime)
+    mime_list[mime_count] = NULL;
+  if (tokens)
+    msFreeCharArray(tokens, numtokens);
+}
+
+/************************************************************************/
+/*                       msOutputFormatValidate()                       */
+/*                                                                      */
+/*      Do some validation of the output format, and report to debug    */
+/*      output if it doesn't seem valid.  Fixup in place as best as     */
+/*      possible.                                                       */
+/************************************************************************/
+
+int msOutputFormatValidate(outputFormatObj *format, int issue_error)
+
+{
+  int result = MS_TRUE;
+  char *driver_ext;
+
+  format->bands = atoi(msGetOutputFormatOption(format, "BAND_COUNT", "1"));
+
+  /* Enforce the requirement that JPEG be RGB and TRANSPARENT=OFF */
+  driver_ext = strstr(format->driver, "/");
+  if (driver_ext && ++driver_ext && !strcasecmp(driver_ext, "JPEG")) {
+    if (format->transparent) {
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is "
+                   "not supported.\n"
+                   "It has been disabled.\n",
+                   "msOutputFormatValidate()", format->name);
+      else
+        msDebug("JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is not "
+                "supported.\n"
+                "It has been disabled.\n",
+                format->name);
+
+      format->transparent = MS_FALSE;
+      result = MS_FALSE;
+    }
+    if (format->imagemode == MS_IMAGEMODE_RGBA) {
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not "
+                   "supported.\n"
+                   "IMAGEMODE forced to RGB.\n",
+                   "msOutputFormatValidate()", format->name);
+      else
+        msDebug("JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not "
+                "supported.\n"
+                "IMAGEMODE forced to RGB.\n",
+                format->name);
+
+      format->imagemode = MS_IMAGEMODE_RGB;
+      result = MS_FALSE;
+    }
+  }
+
+  if (format->transparent && format->imagemode == MS_IMAGEMODE_RGB) {
+    if (issue_error)
+      msSetError(MS_MISCERR,
+                 "OUTPUTFORMAT %s has TRANSPARENT set ON, but an IMAGEMODE\n"
+                 "of RGB instead of RGBA.  Changing imagemode to RGBA.\n",
+                 "msOutputFormatValidate()", format->name);
+    else
+      msDebug("OUTPUTFORMAT %s has TRANSPARENT set ON, but an IMAGEMODE\n"
+              "of RGB instead of RGBA.  Changing imagemode to RGBA.\n",
+              format->name);
+
+    format->imagemode = MS_IMAGEMODE_RGBA;
+    result = MS_FALSE;
+  }
+
+  /* Special checking around RAWMODE image modes. */
+  if (format->imagemode == MS_IMAGEMODE_INT16 ||
+      format->imagemode == MS_IMAGEMODE_FLOAT32 ||
+      format->imagemode == MS_IMAGEMODE_BYTE) {
+    if (strncmp(format->driver, "GDAL/", 5) != 0) {
+      result = MS_FALSE;
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this "
+                   "is only supported for GDAL drivers.",
+                   "msOutputFormatValidate()", format->name);
+      else
+        msDebug("OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this is "
+                "only supported for GDAL drivers.",
+                format->name);
+    }
+
+    if (format->renderer != MS_RENDER_WITH_RAWDATA) /* see bug 724 */
+      format->renderer = MS_RENDER_WITH_RAWDATA;
+  }
+
+  if (!strcasecmp(format->driver, "AGG/MIXED")) {
+    if (!msGetOutputFormatOption(format, "TRANSPARENT_FORMAT", NULL)) {
+      result = MS_FALSE;
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
+                   "msOutputFormatValidate()", format->name);
+      else
+        msDebug("OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
+                format->name);
+    }
+    if (!msGetOutputFormatOption(format, "OPAQUE_FORMAT", NULL)) {
+      result = MS_FALSE;
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
+                   "msOutputFormatValidate()", format->name);
+      else
+        msDebug("OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
+                format->name);
+    }
+  }
+
+  return result;
+}
+
+/************************************************************************/
+/*                     msInitializeRendererVTable()                     */
+/************************************************************************/
+
+int msInitializeRendererVTable(outputFormatObj *format) {
+  assert(format);
+  if (format->vtable) {
+    return MS_SUCCESS;
+  }
+  format->vtable = (rendererVTableObj *)calloc(1, sizeof(rendererVTableObj));
+
+  msInitializeDummyRenderer(format->vtable);
+
+  switch (format->renderer) {
+  case MS_RENDER_WITH_AGG:
+    return msPopulateRendererVTableAGG(format->vtable);
+  case MS_RENDER_WITH_UTFGRID:
+    return msPopulateRendererVTableUTFGrid(format->vtable);
+#ifdef USE_PBF
+  case MS_RENDER_WITH_MVT:
+    return msPopulateRendererVTableMVT(format->vtable);
+#endif
+#ifdef USE_CAIRO
+  case MS_RENDER_WITH_CAIRO_RASTER:
+    return msPopulateRendererVTableCairoRaster(format->vtable);
+  case MS_RENDER_WITH_CAIRO_PDF:
+    return msPopulateRendererVTableCairoPDF(format->vtable);
+  case MS_RENDER_WITH_CAIRO_SVG:
+    return msPopulateRendererVTableCairoSVG(format->vtable);
+#endif
+#ifdef USE_OGL
+  case MS_RENDER_WITH_OGL:
+    return msPopulateRendererVTableOGL(format->vtable);
+#endif
+#ifdef USE_KML
+  case MS_RENDER_WITH_KML:
+    return msPopulateRendererVTableKML(format->vtable);
+#endif
+
+  case MS_RENDER_WITH_OGR:
+    return msPopulateRendererVTableOGR(format->vtable);
+
+  default:
+    msSetError(MS_MISCERR, "unsupported RendererVtable renderer %d",
+               "msInitializeRendererVTable()", format->renderer);
+    return MS_FAILURE;
+  }
+  /* this code should never be executed */
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                    msOutputFormatResolveFromImage()                  */
+/************************************************************************/
+
+void msOutputFormatResolveFromImage(mapObj *map, imageObj *img) {
+  outputFormatObj *format = map->outputformat;
+  assert(img->format == format);
+  assert(img->format->refcount >= 2);
+
+  if (format->renderer == MS_RENDER_WITH_AGG &&
+      strcmp(format->driver, "AGG/MIXED") == 0 &&
+      (format->imagemode == MS_IMAGEMODE_RGB ||
+       format->imagemode == MS_IMAGEMODE_RGBA)) {
+    outputFormatObj *new_format;
+    int has_non_opaque_pixels = MS_FALSE;
+    const char *underlying_driver_type = NULL;
+    const char *underlying_driver_name = NULL;
+
+    // Check if the image has non opaque pixels
+    if (format->imagemode == MS_IMAGEMODE_RGBA) {
+      rasterBufferObj rb;
+      int ret;
+
+      ret = format->vtable->getRasterBufferHandle(img, &rb);
+      assert(ret == MS_SUCCESS);
+      (void)ret;
+      if (rb.data.rgba.a) {
+        for (unsigned row = 0; row < rb.height && !has_non_opaque_pixels;
+             row++) {
+          unsigned char *a;
+          a = rb.data.rgba.a + row * rb.data.rgba.row_step;
+          for (unsigned col = 0; col < rb.width && !has_non_opaque_pixels;
+               col++) {
+            if (*a < 255) {
+              has_non_opaque_pixels = MS_TRUE;
+            }
+            a += rb.data.rgba.pixel_step;
+          }
+        }
+      }
+    }
+
+    underlying_driver_type =
+        (has_non_opaque_pixels) ? "TRANSPARENT_FORMAT" : "OPAQUE_FORMAT";
+    underlying_driver_name =
+        msGetOutputFormatOption(format, underlying_driver_type, NULL);
+    if (underlying_driver_name == NULL) {
+      msSetError(MS_MISCERR, "Missing %s format option on %s.",
+                 "msOutputFormatResolveFromImage()", underlying_driver_type,
+                 format->name);
+      return;
+    }
+    new_format = msSelectOutputFormat(map, underlying_driver_name);
+    if (new_format == NULL) {
+      msSetError(MS_MISCERR, "Cannot find %s output format.",
+                 "msOutputFormatResolveFromImage()", underlying_driver_name);
+      return;
+    }
+    if (new_format->renderer != MS_RENDER_WITH_AGG) {
+      msSetError(
+          MS_MISCERR,
+          "%s cannot be used as the %s format of %s since it is not AGG based.",
+          "msOutputFormatResolveFromImage()", underlying_driver_name,
+          underlying_driver_type, format->name);
+      return;
+    }
+
+    msApplyOutputFormat(&(map->outputformat), new_format,
+                        has_non_opaque_pixels);
+
+    msFreeOutputFormat(format);
+    img->format = map->outputformat;
+    img->format->refcount++;
+  }
+}
diff -pruN 8.0.1-5/src/mapows.c 8.2.0~beta1-1~exp1/src/mapows.c
--- 8.0.1-5/src/mapows.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapows.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3162 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC Web Services (WMS, WFS) support functions
+ * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maptime.h"
+#include "maptemplate.h"
+#include "mapows.h"
+
+#if defined(USE_LIBXML2)
+#include "maplibxml2.h"
+#else
+#include "cpl_minixml.h"
+#include "cpl_error.h"
+#endif
+#include "mapowscommon.h"
+
+#include <ctype.h> /* isalnum() */
+#include <stdarg.h>
+#include <assert.h>
+
+/*
+** msOWSInitRequestObj() initializes an owsRequestObj; i.e: sets
+** all internal pointers to NULL.
+*/
+void msOWSInitRequestObj(owsRequestObj *ows_request) {
+  ows_request->numlayers = 0;
+  ows_request->numwmslayerargs = 0;
+  ows_request->enabled_layers = NULL;
+  ows_request->layerwmsfilterindex = NULL;
+
+  ows_request->service = NULL;
+  ows_request->version = NULL;
+  ows_request->request = NULL;
+  ows_request->document = NULL;
+}
+
+/*
+** msOWSClearRequestObj() releases all resources associated with an
+** owsRequestObj.
+*/
+void msOWSClearRequestObj(owsRequestObj *ows_request) {
+  msFree(ows_request->enabled_layers);
+  msFree(ows_request->layerwmsfilterindex);
+  msFree(ows_request->service);
+  msFree(ows_request->version);
+  msFree(ows_request->request);
+  if (ows_request->document) {
+#if defined(USE_LIBXML2)
+    xmlFreeDoc(ows_request->document);
+    xmlCleanupParser();
+#else
+    CPLDestroyXMLNode(ows_request->document);
+#endif
+  }
+}
+
+#if defined(USE_LIBXML2) && LIBXML_VERSION < 20900
+static int bExternalEntityAsked = MS_FALSE;
+static xmlParserInputPtr dummyEntityLoader(const char *URL, const char *ID,
+                                           xmlParserCtxtPtr context) {
+  bExternalEntityAsked = MS_TRUE;
+  return NULL;
+}
+#endif
+
+/*
+** msOWSPreParseRequest() parses a cgiRequestObj either with GET/KVP
+** or with POST/XML. Only SERVICE, VERSION (or WMTVER) and REQUEST are
+** being determined, all WxS (or SOS) specific parameters are parsed
+** within the according handler.
+** The results are saved within an owsRequestObj. If the request was
+** transmitted with POST/XML, either the document (if compiled with
+** libxml2) or the root CPLXMLNode is saved to the ows_request->document
+** field.
+** Returns MS_SUCCESS upon success, MS_FAILURE if severe errors occurred
+** or MS_DONE, if the service could not be determined.
+*/
+static int msOWSPreParseRequest(cgiRequestObj *request,
+                                owsRequestObj *ows_request) {
+  /* decide if KVP or XML */
+  if (request->type == MS_GET_REQUEST ||
+      (request->type == MS_POST_REQUEST && request->contenttype &&
+       strncmp(request->contenttype, "application/x-www-form-urlencoded",
+               strlen("application/x-www-form-urlencoded")) == 0)) {
+    int i;
+    /* parse KVP parameters service, version and request */
+    for (i = 0; i < request->NumParams; ++i) {
+      if (ows_request->service == NULL &&
+          EQUAL(request->ParamNames[i], "SERVICE")) {
+        ows_request->service = msStrdup(request->ParamValues[i]);
+      } else if (ows_request->version == NULL &&
+                 (EQUAL(request->ParamNames[i], "VERSION") ||
+                  EQUAL(request->ParamNames[i], "WMTVER"))) { /* for WMS */
+        ows_request->version = msStrdup(request->ParamValues[i]);
+      } else if (ows_request->request == NULL &&
+                 EQUAL(request->ParamNames[i], "REQUEST")) {
+        ows_request->request = msStrdup(request->ParamValues[i]);
+      }
+
+      /* stop if we have all necessary parameters */
+      if (ows_request->service && ows_request->version &&
+          ows_request->request) {
+        break;
+      }
+    }
+  } else if (request->type == MS_POST_REQUEST) {
+#if defined(USE_LIBXML2)
+    xmlNodePtr root = NULL;
+#if LIBXML_VERSION < 20900
+    xmlExternalEntityLoader oldExternalEntityLoader;
+#endif
+#else
+    CPLXMLNode *temp;
+#endif
+    if (!request->postrequest || !strlen(request->postrequest)) {
+      msSetError(MS_OWSERR, "POST request is empty.", "msOWSPreParseRequest()");
+      return MS_FAILURE;
+    }
+#if defined(USE_LIBXML2)
+#if LIBXML_VERSION < 20900
+    oldExternalEntityLoader = xmlGetExternalEntityLoader();
+    /* to avoid  XML External Entity vulnerability with libxml2 < 2.9 */
+    xmlSetExternalEntityLoader(dummyEntityLoader);
+    bExternalEntityAsked = MS_FALSE;
+#endif
+    /* parse to DOM-Structure with libxml2 and get the root element */
+    ows_request->document =
+        xmlParseMemory(request->postrequest, strlen(request->postrequest));
+#if LIBXML_VERSION < 20900
+    xmlSetExternalEntityLoader(oldExternalEntityLoader);
+    if (bExternalEntityAsked) {
+      msSetError(MS_OWSERR, "XML parsing error: %s", "msOWSPreParseRequest()",
+                 "External entity fetch");
+      return MS_FAILURE;
+    }
+#endif
+    if (ows_request->document == NULL ||
+        (root = xmlDocGetRootElement(ows_request->document)) == NULL) {
+      const xmlError *error = xmlGetLastError();
+      msSetError(MS_OWSERR, "XML parsing error: %s", "msOWSPreParseRequest()",
+                 error->message);
+      return MS_FAILURE;
+    }
+
+    /* Get service, version and request from root */
+    xmlChar *serviceTmp = xmlGetProp(root, BAD_CAST "service");
+    if (serviceTmp != NULL) {
+      ows_request->service = msStrdup((char *)serviceTmp);
+      xmlFree(serviceTmp);
+    }
+
+    xmlChar *versionTmp = xmlGetProp(root, BAD_CAST "version");
+    if (versionTmp != NULL) {
+      ows_request->version = msStrdup((char *)versionTmp);
+      xmlFree(versionTmp);
+    }
+
+    ows_request->request = msStrdup((char *)root->name);
+
+#else
+    /* parse with CPLXML */
+    ows_request->document = CPLParseXMLString(request->postrequest);
+    if (ows_request->document == NULL) {
+      msSetError(MS_OWSERR, "XML parsing error: %s", "msOWSPreParseRequest()",
+                 CPLGetLastErrorMsg());
+      return MS_FAILURE;
+    }
+
+    /* remove all namespaces */
+    CPLStripXMLNamespace(ows_request->document, NULL, 1);
+    for (temp = ows_request->document; temp != NULL; temp = temp->psNext) {
+
+      if (temp->eType == CXT_Element) {
+        const char *service, *version;
+        ows_request->request = msStrdup(temp->pszValue);
+
+        if ((service = CPLGetXMLValue(temp, "service", NULL)) != NULL) {
+          ows_request->service = msStrdup(service);
+        }
+        if ((version = CPLGetXMLValue(temp, "version", NULL)) != NULL) {
+          ows_request->version = msStrdup(version);
+        }
+        continue;
+      }
+    }
+#endif /* defined(USE_LIBXML2) */
+  } else {
+    msSetError(MS_OWSERR, "Unknown request method. Use either GET or POST.",
+               "msOWSPreParseRequest()");
+    return MS_FAILURE;
+  }
+
+  /* certain WMS requests do not require the service parameter */
+  /* see: http://trac.osgeo.org/mapserver/ticket/2531          */
+  if (ows_request->service == NULL && ows_request->request != NULL) {
+    if (EQUAL(ows_request->request, "GetMap") ||
+        EQUAL(ows_request->request, "GetFeatureInfo")) {
+      ows_request->service = msStrdup("WMS");
+    } else { /* service could not be determined */
+      return MS_DONE;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** msOWSDispatch() is the entry point for any OWS request (WMS, WFS, ...)
+** - If this is a valid request then it is processed and MS_SUCCESS is returned
+**   on success, or MS_FAILURE on failure.
+** - If force_ows_mode is true then an exception will be produced if the
+**   request is not recognized as a valid request.
+** - If force_ows_mode is false and this does not appear to be a valid OWS
+**   request then MS_DONE is returned and MapServer is expected to process
+**   this as a regular MapServer (traditional CGI) request.
+*/
+int msOWSDispatch(mapObj *map, cgiRequestObj *request, int ows_mode) {
+  int status = MS_DONE, force_ows_mode = 0;
+  owsRequestObj ows_request;
+
+  if (!request) {
+    return status;
+  }
+
+  force_ows_mode = (ows_mode == OWS || ows_mode == WFS);
+
+  msOWSInitRequestObj(&ows_request);
+  switch (msOWSPreParseRequest(request, &ows_request)) {
+  case MS_FAILURE: /* a severe error occurred */
+    return MS_FAILURE;
+  case MS_DONE:
+    /* OWS Service could not be determined              */
+    /* continue for now                                 */
+    status = MS_DONE;
+  }
+
+  if (ows_request.service == NULL) {
+#ifdef USE_LIBXML2
+    if (ows_request.request && EQUAL(ows_request.request, "GetMetadata")) {
+      status = msMetadataDispatch(map, request);
+      msOWSClearRequestObj(&ows_request);
+      return status;
+    }
+#endif
+#ifdef USE_WFS_SVR
+    if (msOWSLookupMetadata(&(map->web.metadata), "FO", "cite_wfs2") != NULL) {
+      status = msWFSException(map, "service",
+                              MS_OWS_ERROR_MISSING_PARAMETER_VALUE, NULL);
+    } else
+#endif
+
+      /* exit if service is not set */
+      if (force_ows_mode) {
+        msSetError(MS_MISCERR,
+                   "OWS Common exception: exceptionCode=MissingParameterValue, "
+                   "locator=SERVICE, ExceptionText=SERVICE parameter missing.",
+                   "msOWSDispatch()");
+        status = MS_FAILURE;
+      } else {
+        status = MS_DONE;
+      }
+  } else if (EQUAL(ows_request.service, "WMS")) {
+#ifdef USE_WMS_SVR
+    status = msWMSDispatch(map, request, &ows_request, MS_FALSE);
+#else
+    msSetError(
+        MS_WMSERR,
+        "SERVICE=WMS requested, but WMS support not configured in MapServer.",
+        "msOWSDispatch()");
+#endif
+  } else if (EQUAL(ows_request.service, "WFS")) {
+#ifdef USE_WFS_SVR
+    status = msWFSDispatch(map, request, &ows_request, (ows_mode == WFS));
+#else
+    msSetError(
+        MS_WFSERR,
+        "SERVICE=WFS requested, but WFS support not configured in MapServer.",
+        "msOWSDispatch()");
+#endif
+  } else if (EQUAL(ows_request.service, "WCS")) {
+#ifdef USE_WCS_SVR
+    status = msWCSDispatch(map, request, &ows_request);
+#else
+    msSetError(
+        MS_WCSERR,
+        "SERVICE=WCS requested, but WCS support not configured in MapServer.",
+        "msOWSDispatch()");
+#endif
+  } else if (EQUAL(ows_request.service, "SOS")) {
+#ifdef USE_SOS_SVR
+    status = msSOSDispatch(map, request, &ows_request);
+#else
+    msSetError(
+        MS_SOSERR,
+        "SERVICE=SOS requested, but SOS support not configured in MapServer.",
+        "msOWSDispatch()");
+#endif
+  } else if (force_ows_mode) {
+    msSetError(
+        MS_MISCERR,
+        "OWS Common exception: exceptionCode=InvalidParameterValue, "
+        "locator=SERVICE, ExceptionText=SERVICE parameter value invalid.",
+        "msOWSDispatch()");
+    status = MS_FAILURE;
+  }
+
+  msOWSClearRequestObj(&ows_request);
+  return status;
+}
+
+/*
+** msOWSIpParse()
+**
+** Parse the IP address or range into a binary array.
+** Supports ipv4 and ipv6 addresses
+** Ranges can be specified using the CIDR notation (ie: 192.100.100.0/24)
+**
+** Returns the parsed of the IP (4 or 16).
+*/
+int msOWSIpParse(const char *ip, unsigned char *ip1, unsigned char *mask) {
+  int len = 0, masklen, seps;
+
+  if (msCountChars((char *)ip, '.') == 3) {
+    /* ipv4 */
+    unsigned char *val = ip1;
+    len = 1;
+    masklen = 32;
+    *val = 0;
+    while (*ip) {
+      if (*ip >= '0' && *ip <= '9')
+        (*val) = 10 * (*val) + (*ip - '0');
+      else if (*ip == '.') {
+        ++val;
+        *val = 0;
+        ++len;
+      } else if (*ip == '/') {
+        masklen = atoi(ip + 1);
+        if (masklen > 32)
+          masklen = 32;
+        break;
+      } else
+        break;
+      ++ip;
+    }
+    if (len != 4)
+      return 0;
+    /* write mask */
+    if (mask) {
+      memset(mask, 0, len);
+      val = mask;
+      while (masklen) {
+        if (masklen >= 8) {
+          *val = 0xff;
+          masklen -= 8;
+        } else {
+          *val = -((unsigned char)pow(2, 8 - masklen));
+          break;
+        }
+        ++val;
+      }
+    }
+  } else if ((seps = msCountChars((char *)ip, ':')) > 1 && seps < 8) {
+    /* ipv6 */
+    unsigned short *val = (unsigned short *)ip1;
+    len = 2;
+    masklen = 128;
+    *val = 0;
+    while (*ip) {
+      if (*ip >= '0' && *ip <= '9')
+        (*val) = 16 * (*val) + (*ip - '0');
+      else if (*ip >= 'a' && *ip <= 'f')
+        (*val) = 16 * (*val) + (*ip - 'a' + 10);
+      else if (*ip >= 'A' && *ip <= 'F')
+        (*val) = 16 * (*val) + (*ip - 'A' + 10);
+      else if (*ip == ':') {
+        ++ip;
+        ++val;
+        len += 2;
+        *val = 0;
+        if (*ip == ':') {
+          /* insert 0 values */
+          while (seps <= 7) {
+            ++val;
+            len += 2;
+            *val = 0;
+            ++seps;
+          }
+        } else
+          continue;
+      } else if (*ip == '/') {
+        masklen = atoi(ip + 1);
+        if (masklen > 128)
+          masklen = 128;
+        break;
+      } else
+        break;
+      ++ip;
+    }
+    if (len != 16)
+      return 0;
+    /* write mask */
+    if (mask) {
+      memset(mask, 0, len);
+      val = (unsigned short *)mask;
+      while (masklen) {
+        if (masklen >= 16) {
+          *val = 0xffff;
+          masklen -= 16;
+        } else {
+          *val = -((unsigned short)pow(2, 16 - masklen));
+          break;
+        }
+        ++val;
+      }
+    }
+  }
+
+  return len;
+}
+
+/*
+** msOWSIpInList()
+**
+** Check if an ip is in a space separated list of IP addresses/ranges.
+** Supports ipv4 and ipv6 addresses
+** Ranges can be specified using the CIDR notation (ie: 192.100.100.0/24)
+**
+** Returns MS_TRUE if the IP is found.
+*/
+int msOWSIpInList(const char *ip_list, const char *ip) {
+  int i, j, numips, iplen;
+  unsigned char ip1[16];
+  unsigned char ip2[16];
+  unsigned char mask[16];
+  char **ips;
+
+  /* Parse input IP */
+  iplen = msOWSIpParse(ip, (unsigned char *)&ip1, NULL);
+  if (iplen != 4 && iplen != 16) /* ipv4 or ipv6 */
+    return MS_FALSE;
+
+  ips = msStringSplit(ip_list, ' ', &numips);
+  if (ips) {
+    for (i = 0; i < numips; i++) {
+      if (msOWSIpParse(ips[i], (unsigned char *)&ip2, (unsigned char *)&mask) ==
+          iplen) {
+        for (j = 0; j < iplen; j++) {
+          if ((ip1[j] & mask[j]) != (ip2[j] & mask[j]))
+            break;
+        }
+        if (j == iplen) {
+          msFreeCharArray(ips, numips);
+          return MS_TRUE; /* match found */
+        }
+      }
+    }
+    msFreeCharArray(ips, numips);
+  }
+
+  return MS_FALSE;
+}
+
+/*
+** msOWSIpDisabled()
+**
+** Check if an ip is in a list specified in the metadata section.
+**
+** Returns MS_TRUE if the IP is found.
+*/
+int msOWSIpInMetadata(const char *ip_list, const char *ip) {
+  FILE *stream;
+  char buffer[MS_BUFFER_LENGTH];
+  int found = MS_FALSE;
+
+  if (strncasecmp(ip_list, "file:", 5) == 0) {
+    stream = fopen(ip_list + 5, "r");
+    if (stream) {
+      found = MS_FALSE;
+      while (fgets(buffer, MS_BUFFER_LENGTH, stream)) {
+        if (msOWSIpInList(buffer, ip)) {
+          found = MS_TRUE;
+          break;
+        }
+      }
+      fclose(stream);
+    }
+  } else {
+    if (msOWSIpInList(ip_list, ip))
+      found = MS_TRUE;
+  }
+  return found;
+}
+
+/*
+** msOWSIpDisabled()
+**
+** Check if the layers are enabled or disabled by IP list.
+**
+** 'namespaces' is a string with a letter for each namespace to lookup
+** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
+** If namespaces is NULL then this function just does a regular metadata
+** lookup.
+**
+** Returns the disabled flag.
+*/
+int msOWSIpDisabled(hashTableObj *metadata, const char *namespaces,
+                    const char *ip) {
+  const char *ip_list;
+  int disabled = MS_FALSE;
+
+  if (!ip)
+    return MS_FALSE; /* no endpoint ip */
+
+  ip_list = msOWSLookupMetadata(metadata, namespaces, "allowed_ip_list");
+  if (!ip_list)
+    ip_list = msOWSLookupMetadata(metadata, "O", "allowed_ip_list");
+
+  if (ip_list) {
+    disabled = MS_TRUE;
+    if (msOWSIpInMetadata(ip_list, ip))
+      disabled = MS_FALSE;
+  }
+
+  ip_list = msOWSLookupMetadata(metadata, namespaces, "denied_ip_list");
+  if (!ip_list)
+    ip_list = msOWSLookupMetadata(metadata, "O", "denied_ip_list");
+
+  if (ip_list && msOWSIpInMetadata(ip_list, ip))
+    disabled = MS_TRUE;
+
+  return disabled;
+}
+
+/*
+** msOWSRequestIsEnabled()
+**
+** Check if a layer is visible for a specific OWS request.
+**
+** 'namespaces' is a string with a letter for each namespace to lookup in
+** the order they should be looked up. e.g. "MO" to lookup wms_ and ows_ If
+** namespaces is NULL then this function just does a regular metadata
+** lookup. If check_all_layers is set to MS_TRUE, the function will check
+** all layers to see if the request is enable. (returns as soon as one is found)
+*/
+int msOWSRequestIsEnabled(mapObj *map, layerObj *layer, const char *namespaces,
+                          const char *request, int check_all_layers) {
+  int disabled = MS_FALSE; /* explicitly disabled flag */
+  const char *enable_request;
+  const char *remote_ip;
+
+  if (request == NULL)
+    return MS_FALSE;
+
+  remote_ip = getenv("REMOTE_ADDR");
+
+  /* First, we check in the layer metadata */
+  if (layer && check_all_layers == MS_FALSE) {
+    enable_request =
+        msOWSLookupMetadata(&layer->metadata, namespaces, "enable_request");
+    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
+      return MS_TRUE;
+    if (disabled)
+      return MS_FALSE;
+
+    enable_request =
+        msOWSLookupMetadata(&layer->metadata, "O", "enable_request");
+    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
+      return MS_TRUE;
+    if (disabled)
+      return MS_FALSE;
+
+    if (msOWSIpDisabled(&layer->metadata, namespaces, remote_ip))
+      return MS_FALSE;
+  }
+
+  if (map && (check_all_layers == MS_FALSE || map->numlayers == 0)) {
+    /* then we check in the map metadata */
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
+    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
+      return MS_TRUE;
+    if (disabled)
+      return MS_FALSE;
+
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
+    if (msOWSParseRequestMetadata(enable_request, request, &disabled))
+      return MS_TRUE;
+    if (disabled)
+      return MS_FALSE;
+
+    if (msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
+      return MS_FALSE;
+  }
+
+  if (map && check_all_layers == MS_TRUE) {
+    int i, globally_enabled = MS_FALSE;
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
+    globally_enabled =
+        msOWSParseRequestMetadata(enable_request, request, &disabled);
+
+    if (!globally_enabled && !disabled) {
+      enable_request =
+          msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
+      globally_enabled =
+          msOWSParseRequestMetadata(enable_request, request, &disabled);
+    }
+
+    if (globally_enabled &&
+        msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
+      globally_enabled = MS_FALSE;
+
+    /* Check all layers */
+    for (i = 0; i < map->numlayers; i++) {
+      int result = MS_FALSE;
+      layerObj *lp;
+      lp = (GET_LAYER(map, i));
+
+      enable_request =
+          msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
+      result = msOWSParseRequestMetadata(enable_request, request, &disabled);
+      if (!result && disabled)
+        continue; /* if the request has been explicitly set to disabled,
+                     continue */
+
+      if (!result && !disabled) { /* if the request has not been found in the
+                                     wms metadata, */
+        /* check the ows namespace  */
+
+        enable_request =
+            msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
+        result = msOWSParseRequestMetadata(enable_request, request, &disabled);
+        if (!result && disabled)
+          continue;
+      }
+
+      if (msOWSIpDisabled(&lp->metadata, namespaces, remote_ip))
+        continue;
+
+      if (result || (!disabled && globally_enabled))
+        return MS_TRUE;
+    }
+
+    if (!disabled && globally_enabled)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+/*
+** msOWSRequestLayersEnabled()
+**
+** Check if the layers are visible for a specific OWS request.
+**
+** 'namespaces' is a string with a letter for each namespace to lookup
+** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
+** If namespaces is NULL then this function just does a regular metadata
+** lookup.
+**
+** Generates an array of the layer ids enabled.
+*/
+void msOWSRequestLayersEnabled(mapObj *map, const char *namespaces,
+                               const char *request,
+                               owsRequestObj *ows_request) {
+  int disabled = MS_FALSE; /* explicitly disabled flag */
+  int globally_enabled = MS_FALSE;
+  const char *enable_request;
+  const char *remote_ip;
+
+  if (ows_request->numlayers > 0)
+    msFree(ows_request->enabled_layers);
+
+  ows_request->numlayers = 0;
+  ows_request->enabled_layers = NULL;
+
+  if (request == NULL || (map == NULL) || (map->numlayers <= 0))
+    return;
+
+  remote_ip = getenv("REMOTE_ADDR");
+
+  enable_request =
+      msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
+  globally_enabled =
+      msOWSParseRequestMetadata(enable_request, request, &disabled);
+
+  if (!globally_enabled && !disabled) {
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
+    globally_enabled =
+        msOWSParseRequestMetadata(enable_request, request, &disabled);
+  }
+
+  if (globally_enabled &&
+      msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
+    globally_enabled = MS_FALSE;
+
+  if (map->numlayers) {
+    int i, layers_size = map->numlayers; /* for most of cases, this will be
+                                            relatively small */
+
+    ows_request->enabled_layers =
+        (int *)msSmallMalloc(sizeof(int) * layers_size);
+
+    for (i = 0; i < map->numlayers; i++) {
+      int result = MS_FALSE;
+      layerObj *lp;
+      lp = (GET_LAYER(map, i));
+
+      enable_request =
+          msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
+      result = msOWSParseRequestMetadata(enable_request, request, &disabled);
+      if (!result && disabled)
+        continue; /* if the request has been explicitly set to disabled,
+                     continue */
+
+      if (!result && !disabled) { /* if the request has not been found in the
+                                     wms metadata, */
+        /* check the ows namespace  */
+
+        enable_request =
+            msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
+        result = msOWSParseRequestMetadata(enable_request, request, &disabled);
+        if (!result && disabled)
+          continue;
+      }
+
+      if (msOWSIpDisabled(&lp->metadata, namespaces, remote_ip))
+        continue;
+
+      if (result || (!disabled && globally_enabled)) {
+        ows_request->enabled_layers[ows_request->numlayers] = lp->index;
+        ows_request->numlayers++;
+      }
+    }
+
+    if (ows_request->numlayers == 0) {
+      msFree(ows_request->enabled_layers);
+      ows_request->enabled_layers = NULL;
+    }
+  }
+}
+
+/* msOWSParseRequestMetadata
+ *
+ * This function parse a enable_request metadata string and check if the
+ * given request is present and enabled.
+ */
+int msOWSParseRequestMetadata(const char *metadata, const char *request,
+                              int *disabled) {
+  char requestBuffer[32];
+  int wordFlag = MS_FALSE;
+  int disableFlag = MS_FALSE;
+  int allFlag = MS_FALSE;
+  char *bufferPtr, *ptr = NULL;
+
+  *disabled = MS_FALSE;
+
+  if (metadata == NULL)
+    return MS_FALSE;
+
+  ptr = (char *)metadata;
+  const size_t len = strlen(ptr);
+  requestBuffer[0] = '\0';
+  bufferPtr = requestBuffer;
+
+  for (size_t i = 0; i <= len; ++i, ++ptr) {
+
+    if (!wordFlag && isspace(*ptr))
+      continue;
+
+    wordFlag = MS_TRUE;
+
+    if (*ptr == '!') {
+      disableFlag = MS_TRUE;
+      continue;
+    } else if ((*ptr == ' ') ||
+               (*ptr != '\0' && ptr[1] == '\0')) { /* end of word */
+      if (ptr[1] == '\0' && *ptr != ' ') {
+        *bufferPtr = *ptr;
+        ++bufferPtr;
+      }
+
+      *bufferPtr = '\0';
+      if (strcasecmp(request, requestBuffer) == 0) {
+        *disabled = MS_TRUE; /* explicitly found, will stop the process in
+                                msOWSRequestIsEnabled() */
+        return (disableFlag ? MS_FALSE : MS_TRUE);
+      } else {
+        if (strcmp("*", requestBuffer) ==
+            0) { /* check if we read the all flag */
+          if (disableFlag)
+            *disabled = MS_TRUE;
+          allFlag = disableFlag ? MS_FALSE : MS_TRUE;
+        }
+        /* reset flags */
+        wordFlag = MS_FALSE;
+        disableFlag = MS_FALSE;
+        bufferPtr = requestBuffer;
+      }
+    } else {
+      *bufferPtr = *ptr;
+      ++bufferPtr;
+    }
+  }
+
+  return allFlag;
+}
+
+/*
+** msOWSGetPrefixFromNamespace()
+**
+** Return the metadata name prefix from a character identifying the OWS
+** namespace.
+*/
+static const char *msOWSGetPrefixFromNamespace(char chNamespace) {
+  // Return should be a 3 character string, otherwise breaks assumption
+  // in msOWSLookupMetadata()
+  switch (chNamespace) {
+  case 'O':
+    return "ows";
+  case 'A':
+    return "oga"; /* oga_... (OGC Geospatial API) */
+  case 'M':
+    return "wms";
+  case 'F':
+    return "wfs";
+  case 'C':
+    return "wcs";
+  case 'G':
+    return "gml";
+  case 'S':
+    return "sos";
+  default:
+    /* We should never get here unless an invalid code (typo) is */
+    /* present in the code, but since this happened before... */
+    msSetError(MS_WMSERR, "Unsupported metadata namespace code (%c).",
+               "msOWSGetPrefixFromNamespace()", chNamespace);
+    assert(MS_FALSE);
+    return NULL;
+  }
+}
+
+/*
+** msOWSLookupMetadata()
+**
+** Attempts to lookup a given metadata name in multiple OWS namespaces.
+**
+** 'namespaces' is a string with a letter for each namespace to lookup
+** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
+** If namespaces is NULL then this function just does a regular metadata
+** lookup.
+*/
+const char *msOWSLookupMetadata(hashTableObj *metadata, const char *namespaces,
+                                const char *name) {
+  const char *value = NULL;
+
+  if (namespaces == NULL) {
+    value = msLookupHashTable(metadata, (char *)name);
+  } else {
+    char buf[100] = "ows_";
+
+    strlcpy(buf + 4, name, 96);
+
+    while (value == NULL && *namespaces != '\0') {
+      const char *prefix = msOWSGetPrefixFromNamespace(*namespaces);
+      if (prefix == NULL)
+        return NULL;
+      assert(strlen(prefix) == 3);
+      memcpy(buf, prefix, 3);
+      value = msLookupHashTable(metadata, buf);
+      namespaces++;
+    }
+  }
+
+  return value;
+}
+
+/*
+** msOWSLookupMetadataWithLanguage()
+**
+** Attempts to lookup a given metadata name in multiple OWS namespaces
+** for a specific language.
+*/
+const char *msOWSLookupMetadataWithLanguage(hashTableObj *metadata,
+                                            const char *namespaces,
+                                            const char *name,
+                                            const char *validated_language) {
+  const char *value = NULL;
+
+  if (name && validated_language && validated_language[0]) {
+    size_t bufferSize = strlen(name) + strlen(validated_language) + 2;
+    char *name2 = (char *)msSmallMalloc(bufferSize);
+    snprintf(name2, bufferSize, "%s.%s", name, validated_language);
+    value = msOWSLookupMetadata(metadata, namespaces, name2);
+    free(name2);
+  }
+
+  if (name && !value) {
+    value = msOWSLookupMetadata(metadata, namespaces, name);
+  }
+
+  return value;
+}
+
+/*
+** msOWSLookupMetadata2()
+**
+** Attempts to lookup a given metadata name in multiple hashTables, and
+** in multiple OWS namespaces within each. First searches the primary
+** table and if no result is found, attempts the search using the
+** secondary (fallback) table.
+**
+** 'namespaces' is a string with a letter for each namespace to lookup
+** in the order they should be looked up. e.g. "MO" to lookup wms_ and ows_
+** If namespaces is NULL then this function just does a regular metadata
+** lookup.
+*/
+const char *msOWSLookupMetadata2(hashTableObj *pri, hashTableObj *sec,
+                                 const char *namespaces, const char *name) {
+  const char *result;
+
+  if ((result = msOWSLookupMetadata(pri, namespaces, name)) == NULL) {
+    /* Try the secondary table */
+    result = msOWSLookupMetadata(sec, namespaces, name);
+  }
+
+  return result;
+}
+
+/* msOWSParseVersionString()
+**
+** Parse a version string in the format "a.b.c" or "a.b" and return an
+** integer in the format 0x0a0b0c suitable for regular integer comparisons.
+**
+** Returns one of OWS_VERSION_NOTSET or OWS_VERSION_BADFORMAT if version
+** could not be parsed.
+*/
+int msOWSParseVersionString(const char *pszVersion) {
+  char **digits = NULL;
+  int numDigits = 0;
+
+  if (pszVersion) {
+    int nVersion = 0;
+    digits = msStringSplit(pszVersion, '.', &numDigits);
+    if (digits == NULL || numDigits < 2 || numDigits > 3) {
+      msSetError(MS_OWSERR,
+                 "Invalid version (%s). Version must be in the "
+                 "format 'x.y' or 'x.y.z'",
+                 "msOWSParseVersionString()", pszVersion);
+      if (digits)
+        msFreeCharArray(digits, numDigits);
+      return OWS_VERSION_BADFORMAT;
+    }
+
+    nVersion = atoi(digits[0]) * 0x010000;
+    nVersion += atoi(digits[1]) * 0x0100;
+    if (numDigits > 2)
+      nVersion += atoi(digits[2]);
+
+    msFreeCharArray(digits, numDigits);
+
+    return nVersion;
+  }
+
+  return OWS_VERSION_NOTSET;
+}
+
+/* msOWSGetVersionString()
+**
+** Returns a OWS version string in the format a.b.c from the integer
+** version value passed as argument (0x0a0b0c)
+**
+** Fills in the pszBuffer and returns a reference to it. Recommended buffer
+** size is OWS_VERSION_MAXLEN chars.
+*/
+const char *msOWSGetVersionString(int nVersion, char *pszBuffer) {
+
+  if (pszBuffer)
+    snprintf(pszBuffer, OWS_VERSION_MAXLEN - 1, "%d.%d.%d",
+             (nVersion / 0x10000) % 0x100, (nVersion / 0x100) % 0x100,
+             nVersion % 0x100);
+
+  return pszBuffer;
+}
+
+/*
+** msOWSGetEPSGProj()
+**
+** Extract projection code for this layer/map.
+**
+** First look for a xxx_srs metadata. If not found then look for an EPSG
+** code in projectionObj, and if not found then return NULL.
+**
+** If bReturnOnlyFirstOne=TRUE and metadata contains multiple EPSG codes
+** then only the first one (which is assumed to be the layer's default
+** projection) is returned.
+*/
+void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne,
+                      char **epsgCode) {
+  const char *value;
+  *epsgCode = NULL;
+
+  /* metadata value should already be in format "EPSG:n" or "AUTO:..." */
+  if (metadata &&
+      ((value = msOWSLookupMetadata(metadata, namespaces, "srs")) != NULL)) {
+    const char *space_ptr;
+    if (!bReturnOnlyFirstOne || (space_ptr = strchr(value, ' ')) == NULL) {
+      *epsgCode = msStrdup(value);
+      return;
+    }
+
+    *epsgCode = msSmallMalloc((space_ptr - value + 1) * sizeof(char));
+    /* caller requested only first projection code, copy up to the first space
+     * character*/
+    strlcpy(*epsgCode, value, space_ptr - value + 1);
+    return;
+  } else if (proj && proj->numargs > 0 &&
+             (value = strstr(proj->args[0], "init=epsg:")) != NULL) {
+    *epsgCode = msSmallMalloc((strlen("EPSG:") + strlen(value + 10) + 1) *
+                              sizeof(char));
+    sprintf(*epsgCode, "EPSG:%s", value + 10);
+    return;
+  } else if (proj && proj->numargs > 0 &&
+             (value = strstr(proj->args[0], "init=crs:")) != NULL) {
+    *epsgCode =
+        msSmallMalloc((strlen("CRS:") + strlen(value + 9) + 1) * sizeof(char));
+    sprintf(*epsgCode, "CRS:%s", value + 9);
+    return;
+  } else if (proj && proj->numargs > 0 &&
+             (strncasecmp(proj->args[0], "AUTO:", 5) == 0 ||
+              strncasecmp(proj->args[0], "AUTO2:", 6) == 0)) {
+    *epsgCode = msStrdup(proj->args[0]);
+    return;
+  }
+}
+
+/*
+** msOWSProjectToWGS84()
+**
+** Reprojects the extent to WGS84.
+**
+*/
+void msOWSProjectToWGS84(projectionObj *srcproj, rectObj *ext) {
+  if (srcproj->proj && !msProjIsGeographicCRS(srcproj)) {
+    projectionObj wgs84;
+    msInitProjection(&wgs84);
+    msProjectionInheritContextFrom(&wgs84, srcproj);
+    msLoadProjectionString(&wgs84, "+proj=longlat +ellps=WGS84 +datum=WGS84");
+    msProjectRect(srcproj, &wgs84, ext);
+    msFreeProjection(&wgs84);
+  }
+}
+
+/* msOWSGetLanguage()
+**
+** returns the language via MAP/WEB/METADATA/ows_language
+**
+** Use value of "ows_language" metadata, if not set then
+** return "undefined" as a default
+*/
+const char *msOWSGetLanguage(mapObj *map, const char *context) {
+  const char *language;
+
+  /* if this is an exception, MapServer always returns Exception
+     messages in en-US
+  */
+  if (strcmp(context, "exception") == 0) {
+    language = MS_ERROR_LANGUAGE;
+  }
+  /* if not, fetch language from mapfile metadata */
+  else {
+    language = msLookupHashTable(&(map->web.metadata), "ows_language");
+
+    if (language == NULL) {
+      language = "undefined";
+    }
+  }
+  return language;
+}
+
+/* msOWSGetSchemasLocation()
+**
+** schemas location is the root of the web tree where all WFS-related
+** schemas can be found on this server.  These URLs must exist in order
+** to validate xml.
+**
+** Use value of "ows_schemas_location" metadata, if not set then
+** return ".." as a default
+*/
+const char *msOWSGetSchemasLocation(mapObj *map) {
+  const char *schemas_location;
+
+  schemas_location =
+      msLookupHashTable(&(map->web.metadata), "ows_schemas_location");
+  if (schemas_location == NULL)
+    schemas_location = OWS_DEFAULT_SCHEMAS_LOCATION;
+
+  return schemas_location;
+}
+
+/*
+** msOWSGetExpandedMetadataKey()
+*/
+static char *msOWSGetExpandedMetadataKey(const char *namespaces,
+                                         const char *metadata_name) {
+  char *pszRet = msStringConcatenate(NULL, "");
+  for (int i = 0; namespaces[i] != '\0'; ++i) {
+    if (i > 0)
+      pszRet = msStringConcatenate(pszRet, " or ");
+    pszRet = msStringConcatenate(pszRet, "\"");
+    pszRet =
+        msStringConcatenate(pszRet, msOWSGetPrefixFromNamespace(namespaces[i]));
+    pszRet = msStringConcatenate(pszRet, "_");
+    pszRet = msStringConcatenate(pszRet, metadata_name);
+    pszRet = msStringConcatenate(pszRet, "\"");
+  }
+  return pszRet;
+}
+
+/*
+** msOWSGetOnlineResource()
+**
+** Return the online resource for this service.  First try to lookup
+** specified metadata, and if not found then try to build the URL ourselves.
+**
+** Returns a newly allocated string that should be freed by the caller or
+** NULL in case of error.
+*/
+char *msOWSGetOnlineResource(mapObj *map, const char *namespaces,
+                             const char *metadata_name, cgiRequestObj *req) {
+  const char *value;
+  char *online_resource = NULL;
+
+  /* We need this script's URL, including hostname. */
+  /* Default to use the value of the "onlineresource" metadata, and if not */
+  /* set then build it: "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?" */
+  /* (+append the map=... param if it was explicitly passed in QUERY_STRING) */
+  /*  */
+  if ((value = msOWSLookupMetadata(&(map->web.metadata), namespaces,
+                                   metadata_name))) {
+    online_resource = msOWSTerminateOnlineResource(value);
+  } else {
+    if ((online_resource = msBuildOnlineResource(map, req)) == NULL) {
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, metadata_name);
+      msSetError(MS_CGIERR, "Please set %s metadata.",
+                 "msOWSGetOnlineResource()", pszExpandedMetadataKey);
+      msFree(pszExpandedMetadataKey);
+      return NULL;
+    }
+  }
+
+  return online_resource;
+}
+
+/*
+** msOWSTerminateOnlineResource()
+**
+** Append trailing "?" or "&" to an onlineresource URL if it doesn't have
+** one already. The returned string is then ready to append GET parameters
+** to it.
+**
+** Returns a newly allocated string that should be freed by the caller or
+** NULL in case of error.
+*/
+char *msOWSTerminateOnlineResource(const char *src_url) {
+  char *online_resource = NULL;
+  size_t buffer_size = 0;
+
+  if (src_url == NULL)
+    return NULL;
+
+  buffer_size = strlen(src_url) + 2;
+  online_resource = (char *)malloc(buffer_size);
+
+  if (online_resource == NULL) {
+    msSetError(MS_MEMERR, NULL, "msOWSTerminateOnlineResource()");
+    return NULL;
+  }
+
+  strlcpy(online_resource, src_url, buffer_size);
+
+  /* Append trailing '?' or '&' if missing. */
+  if (strchr(online_resource, '?') == NULL)
+    strlcat(online_resource, "?", buffer_size);
+  else {
+    char *c;
+    c = online_resource + strlen(online_resource) - 1;
+    if (*c != '?' && *c != '&')
+      strlcpy(c + 1, "&", buffer_size - strlen(online_resource));
+  }
+
+  return online_resource;
+}
+
+/************************************************************************/
+/*                         msUpdateGMLFieldMetadata                     */
+/*                                                                      */
+/*      Updates a fields GML metadata if it has not already             */
+/*      been set. Nullable is not implemented for all drivers           */
+/*      and can be set to 0 if unknown                                  */
+/************************************************************************/
+int msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name,
+                             const char *gml_type, const char *gml_width,
+                             const char *gml_precision, const short nullable) {
+
+  char md_item_name[256];
+
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type", field_name);
+  if (msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, gml_type);
+
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_width", field_name);
+  if (strlen(gml_width) > 0 &&
+      msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, gml_width);
+
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_precision", field_name);
+  if (strlen(gml_precision) > 0 &&
+      msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, gml_precision);
+
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_nillable", field_name);
+  if (nullable > 0 &&
+      msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, "true");
+
+  return MS_TRUE;
+}
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+
+/*
+** msRenameLayer()
+*/
+static int msRenameLayer(layerObj *lp, int count) {
+  char *newname;
+  newname = (char *)malloc((strlen(lp->name) + 5) * sizeof(char));
+  if (!newname) {
+    msSetError(MS_MEMERR, NULL, "msRenameLayer()");
+    return MS_FAILURE;
+  }
+  sprintf(newname, "%s_%2.2d", lp->name, count);
+  free(lp->name);
+  lp->name = newname;
+
+  return MS_SUCCESS;
+}
+
+/*
+** msOWSMakeAllLayersUnique()
+*/
+int msOWSMakeAllLayersUnique(mapObj *map) {
+  int i, j;
+
+  /* Make sure all layers in the map file have valid and unique names */
+  for (i = 0; i < map->numlayers; i++) {
+    int count = 1;
+    for (j = i + 1; j < map->numlayers; j++) {
+      if (GET_LAYER(map, i)->name == NULL || GET_LAYER(map, j)->name == NULL) {
+        continue;
+      }
+      if (strcasecmp(GET_LAYER(map, i)->name, GET_LAYER(map, j)->name) == 0 &&
+          msRenameLayer((GET_LAYER(map, j)), ++count) != MS_SUCCESS) {
+        return MS_FAILURE;
+      }
+    }
+
+    /* Don't forget to rename the first layer if duplicates were found */
+    if (count > 1 && msRenameLayer((GET_LAYER(map, i)), 1) != MS_SUCCESS) {
+      return MS_FAILURE;
+    }
+  }
+  return MS_SUCCESS;
+}
+
+/*
+** msOWSNegotiateVersion()
+**
+** returns the most suitable version an OWS is to support given a client
+** version parameter.
+**
+** supported_versions must be ordered from highest to lowest
+**
+** Returns a version integer of the supported version
+**
+*/
+
+int msOWSNegotiateVersion(int requested_version, const int supported_versions[],
+                          int num_supported_versions) {
+  int i;
+
+  /* if version is not set return highest version */
+  if (!requested_version)
+    return supported_versions[0];
+
+  /* if the requested version is lower than the lowest version return the lowest
+   * version  */
+  if (requested_version < supported_versions[num_supported_versions - 1])
+    return supported_versions[num_supported_versions - 1];
+
+  /* return the first entry that's lower than or equal to the requested version
+   */
+  for (i = 0; i < num_supported_versions; i++) {
+    if (supported_versions[i] <= requested_version)
+      return supported_versions[i];
+  }
+
+  return requested_version;
+}
+
+/*
+** msOWSGetOnlineResource()
+**
+** Return the online resource for this service and add language parameter.
+**
+** Returns a newly allocated string that should be freed by the caller or
+** NULL in case of error.
+*/
+char *msOWSGetOnlineResource2(mapObj *map, const char *namespaces,
+                              const char *metadata_name, cgiRequestObj *req,
+                              const char *validated_language) {
+  char *online_resource =
+      msOWSGetOnlineResource(map, namespaces, metadata_name, req);
+
+  if (online_resource && validated_language && validated_language[0]) {
+    /* online_resource is already terminated, so we can simply add language=...&
+     */
+    /* but first we need to make sure that online_resource has enough capacity
+     */
+    online_resource = (char *)msSmallRealloc(
+        online_resource,
+        strlen(online_resource) + strlen(validated_language) + 11);
+    strcat(online_resource, "language=");
+    strcat(online_resource, validated_language);
+    strcat(online_resource, "&");
+  }
+
+  return online_resource;
+}
+
+/* msOWSGetInspireSchemasLocation()
+**
+** schemas location is the root of the web tree where all Inspire-related
+** schemas can be found on this server.  These URLs must exist in order
+** to validate xml.
+**
+** Use value of "inspire_schemas_location" metadata
+*/
+const char *msOWSGetInspireSchemasLocation(mapObj *map) {
+  const char *schemas_location;
+
+  schemas_location =
+      msLookupHashTable(&(map->web.metadata), "inspire_schemas_location");
+  if (schemas_location == NULL)
+    schemas_location = "http://inspire.ec.europa.eu/schemas";
+
+  return schemas_location;
+}
+
+/* msOWSGetLanguageList
+**
+** Returns the list of languages that this service supports
+**
+** Use value of "languages" metadata (comma-separated list), or NULL if not set
+**
+** Returns a malloced char** of length numitems which must be freed
+** by the caller, or NULL (with numitems = 0)
+*/
+char **msOWSGetLanguageList(mapObj *map, const char *namespaces,
+                            int *numitems) {
+
+  const char *languages = NULL;
+
+  languages =
+      msOWSLookupMetadata(&(map->web.metadata), namespaces, "languages");
+  if (languages && strlen(languages) > 0) {
+    return msStringSplit(languages, ',', numitems);
+  } else {
+    *numitems = 0;
+    return NULL;
+  }
+}
+
+/* msOWSGetLanguageFromList
+**
+** Returns a language according to the language requested by the client
+**
+** If the requested language is in the languages metadata then use it,
+** otherwise ignore it and use the defaul language, which is the first entry in
+** the languages metadata list. Calling with a NULL requested_langauge
+** therefore returns this default language. If the language metadata list is
+** not defined then the language is set to NULL.
+**
+** Returns a malloced char* which must be freed by the caller, or NULL
+*/
+char *msOWSGetLanguageFromList(mapObj *map, const char *namespaces,
+                               const char *requested_language) {
+  int num_items = 0;
+  char **languages = msOWSGetLanguageList(map, namespaces, &num_items);
+  char *language = NULL;
+
+  if (languages && num_items > 0) {
+    if (!requested_language ||
+        !msStringInArray(requested_language, languages, num_items)) {
+      language = msStrdup(languages[0]);
+    } else {
+      language = msStrdup(requested_language);
+    }
+  }
+  msFreeCharArray(languages, num_items);
+
+  return language;
+}
+
+/* msOWSLanguageNegotiation
+**
+** Returns a language according to the accepted languages requested by the
+*client
+**
+** Returns a malloced char* which must be freed by the caller, or NULL
+*/
+char *msOWSLanguageNegotiation(mapObj *map, const char *namespaces,
+                               char **accept_languages,
+                               int num_accept_languages) {
+  int num_languages = 0;
+  char **languages = NULL;
+  char *result_language = NULL;
+
+  languages = msOWSGetLanguageList(map, namespaces, &num_languages);
+
+  if (languages && num_languages > 0) {
+    int i;
+    for (i = 0; i < num_accept_languages; ++i) {
+      const char *accept_language = accept_languages[i];
+
+      /* '*' means any language */
+      if (EQUAL(accept_language, "*")) {
+        result_language = msStrdup(languages[0]);
+        break;
+      } else if (msStringInArray(accept_language, languages, num_languages)) {
+        result_language = msStrdup(accept_language);
+        break;
+      }
+    }
+
+    if (result_language == NULL) {
+      result_language = msStrdup(languages[0]);
+    }
+  }
+
+  msFreeCharArray(languages, num_languages);
+  return result_language;
+}
+
+/* msOWSPrintInspireCommonExtendedCapabilities
+**
+** Output INSPIRE common extended capabilities items to stream
+** The currently supported items are metadata and languages
+**
+** tag_name is the name (including ns prefix) of the tag to include the whole
+** extended capabilities block in
+**
+** service is currently included for future compatibility when differing
+** extended capabilities elements are included for different service types
+**
+** Returns a status code; MS_NOERR if all ok, action_if_not_found otherwise
+*/
+int msOWSPrintInspireCommonExtendedCapabilities(
+    FILE *stream, mapObj *map, const char *namespaces, int action_if_not_found,
+    const char *tag_name, const char *tag_ns, const char *validated_language,
+    const OWSServiceType service) {
+
+  int metadataStatus = 0;
+  int languageStatus = 0;
+
+  if (tag_ns)
+    msIO_fprintf(stream, "  <%s %s>\n", tag_name, tag_ns);
+  else
+    msIO_fprintf(stream, "  <%s>\n", tag_name);
+
+  metadataStatus = msOWSPrintInspireCommonMetadata(
+      stream, map, namespaces, action_if_not_found, service);
+  languageStatus = msOWSPrintInspireCommonLanguages(
+      stream, map, namespaces, action_if_not_found, validated_language);
+
+  msIO_fprintf(stream, "  </%s>\n", tag_name);
+
+  return (metadataStatus != MS_NOERR) ? metadataStatus : languageStatus;
+}
+
+/* msOWSPrintInspireCommonMetadata
+**
+** Output INSPIRE common metadata items to a stream
+**
+** Returns a status code; MS_NOERR if all OK, action_if_not_found otherwise
+*/
+int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map,
+                                    const char *namespaces,
+                                    int action_if_not_found,
+                                    const OWSServiceType service) {
+
+  int status = MS_NOERR;
+  const char *inspire_capabilities = NULL;
+
+  inspire_capabilities = msOWSLookupMetadata(&(map->web.metadata), namespaces,
+                                             "inspire_capabilities");
+
+  if (!inspire_capabilities) {
+    if (OWS_WARN == action_if_not_found) {
+      msIO_fprintf(
+          stream,
+          "<!-- WARNING: missing metadata entry for 'inspire_capabilities', "
+          "one of 'embed' and 'url' must be supplied. -->\n");
+    }
+    return action_if_not_found;
+  }
+  if (strcasecmp("url", inspire_capabilities) == 0) {
+    if (msOWSLookupMetadata(&(map->web.metadata), namespaces,
+                            "inspire_metadataurl_href") != NULL) {
+      msIO_fprintf(stream,
+                   "    <inspire_common:MetadataUrl "
+                   "xsi:type=\"inspire_common:resourceLocatorType\">\n");
+      msOWSPrintEncodeMetadata(
+          stream, &(map->web.metadata), namespaces, "inspire_metadataurl_href",
+          OWS_WARN, "      <inspire_common:URL>%s</inspire_common:URL>\n", "");
+      msOWSPrintEncodeMetadata(
+          stream, &(map->web.metadata), namespaces,
+          "inspire_metadataurl_format", OWS_WARN,
+          "      <inspire_common:MediaType>%s</inspire_common:MediaType>\n",
+          "");
+      msIO_fprintf(stream, "    </inspire_common:MetadataUrl>\n");
+    } else {
+      status = action_if_not_found;
+      if (OWS_WARN == action_if_not_found) {
+        char *pszExpandedMetadataKey =
+            msOWSGetExpandedMetadataKey(namespaces, "inspire_metadataurl_href");
+        msIO_fprintf(stream,
+                     "<!-- WARNING: Mandatory metadata %s was missing in this "
+                     "context. -->\n",
+                     pszExpandedMetadataKey);
+        msFree(pszExpandedMetadataKey);
+      }
+    }
+  } else if (strcasecmp("embed", inspire_capabilities) == 0) {
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_resourcelocator", OWS_WARN,
+                             "    <inspire_common:ResourceLocator>\n      "
+                             "<inspire_common:URL>%s</inspire_common:URL>\n    "
+                             "</inspire_common:ResourceLocator>\n",
+                             NULL);
+    msIO_fprintf(
+        stream,
+        "    "
+        "<inspire_common:ResourceType>service</inspire_common:ResourceType>\n");
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_temporal_reference", OWS_WARN,
+                             "    <inspire_common:TemporalReference>\n      "
+                             "<inspire_common:DateOfLastRevision>%s</"
+                             "inspire_common:DateOfLastRevision>\n    "
+                             "</inspire_common:TemporalReference>\n",
+                             "");
+    msIO_fprintf(stream, "    <inspire_common:Conformity>\n");
+    msIO_fprintf(stream, "      <inspire_common:Specification>\n");
+    msIO_fprintf(stream,
+                 "        <inspire_common:Title>-</inspire_common:Title>\n");
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_temporal_reference", OWS_NOERR,
+                             "        "
+                             "<inspire_common:DateOfLastRevision>%s</"
+                             "inspire_common:DateOfLastRevision>\n",
+                             "");
+    msIO_fprintf(stream, "      </inspire_common:Specification>\n");
+    msIO_fprintf(
+        stream,
+        "      <inspire_common:Degree>notEvaluated</inspire_common:Degree>\n");
+    msIO_fprintf(stream, "    </inspire_common:Conformity>\n");
+    msIO_fprintf(stream, "    <inspire_common:MetadataPointOfContact>\n");
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_mpoc_name", OWS_WARN,
+                             "      "
+                             "<inspire_common:OrganisationName>%s</"
+                             "inspire_common:OrganisationName>\n",
+                             "");
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), namespaces, "inspire_mpoc_email",
+        OWS_WARN,
+        "      <inspire_common:EmailAddress>%s</inspire_common:EmailAddress>\n",
+        "");
+    msIO_fprintf(stream, "    </inspire_common:MetadataPointOfContact>\n");
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), namespaces, "inspire_metadatadate",
+        OWS_WARN,
+        "      <inspire_common:MetadataDate>%s</inspire_common:MetadataDate>\n",
+        "");
+    if (service == OWS_WFS || service == OWS_WCS)
+      msIO_fprintf(stream, "    "
+                           "<inspire_common:SpatialDataServiceType>download</"
+                           "inspire_common:SpatialDataServiceType>\n");
+    else
+      msIO_fprintf(stream, "    "
+                           "<inspire_common:SpatialDataServiceType>view</"
+                           "inspire_common:SpatialDataServiceType>\n");
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), namespaces, "inspire_keyword", OWS_WARN,
+        "    <inspire_common:MandatoryKeyword>\n      "
+        "<inspire_common:KeywordValue>%s</inspire_common:KeywordValue>\n    "
+        "</inspire_common:MandatoryKeyword>\n",
+        "");
+  } else {
+    status = action_if_not_found;
+    if (OWS_WARN == action_if_not_found) {
+      msIO_fprintf(
+          stream,
+          "<!-- WARNING: invalid value '%s' for 'inspire_capabilities', only "
+          "'embed' and 'url' are supported. -->\n",
+          inspire_capabilities);
+    }
+  }
+
+  return status;
+}
+
+/* msOWSPrintInspireCommonLanguages
+**
+** Output INSPIRE supported languages block to stream
+**
+** Returns a status code; MS_NOERR if all OK; action_if_not_found otherwise
+*/
+int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map,
+                                     const char *namespaces,
+                                     int action_if_not_found,
+                                     const char *validated_language) {
+  char *buffer =
+      NULL; /* temp variable for malloced strings that will need freeing */
+  int status = MS_NOERR;
+
+  char *default_language = msOWSGetLanguageFromList(map, namespaces, NULL);
+
+  if (validated_language && validated_language[0] && default_language) {
+    msIO_fprintf(stream, "    <inspire_common:SupportedLanguages>\n");
+    msIO_fprintf(
+        stream,
+        "      <inspire_common:DefaultLanguage><inspire_common:Language>%s"
+        "</inspire_common:Language></inspire_common:DefaultLanguage>\n",
+        buffer = msEncodeHTMLEntities(default_language));
+    msFree(buffer);
+
+    /* append _exclude to our default_language*/
+    default_language = msSmallRealloc(
+        default_language, strlen(default_language) + strlen("_exclude") + 1);
+    strcat(default_language, "_exclude");
+
+    msOWSPrintEncodeMetadataList(
+        stream, &(map->web.metadata), namespaces, "languages", NULL, NULL,
+        "      <inspire_common:SupportedLanguage><inspire_common:Language>%s"
+        "</inspire_common:Language></inspire_common:SupportedLanguage>\n",
+        default_language);
+    msIO_fprintf(stream, "    </inspire_common:SupportedLanguages>\n");
+    msIO_fprintf(
+        stream,
+        "    <inspire_common:ResponseLanguage><inspire_common:Language>%s"
+        "</inspire_common:Language></inspire_common:ResponseLanguage>\n",
+        validated_language);
+  } else {
+    status = action_if_not_found;
+    if (OWS_WARN == action_if_not_found) {
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, "languages");
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
+      msFree(pszExpandedMetadataKey);
+    }
+  }
+
+  msFree(default_language);
+
+  return status;
+}
+
+/*
+** msOWSPrintMetadata()
+**
+** Attempt to output a capability item.  If corresponding metadata is not
+** found then one of a number of predefined actions will be taken.
+** If a default value is provided and metadata is absent then the
+** default will be used.
+*/
+
+int msOWSPrintMetadata(FILE *stream, hashTableObj *metadata,
+                       const char *namespaces, const char *name,
+                       int action_if_not_found, const char *format,
+                       const char *default_value) {
+  const char *value = NULL;
+  int status = MS_NOERR;
+
+  if ((value = msOWSLookupMetadata(metadata, namespaces, name)) != NULL) {
+    msIO_fprintf(stream, format, value);
+  } else {
+    if (action_if_not_found == OWS_WARN) {
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
+      msFree(pszExpandedMetadataKey);
+      status = action_if_not_found;
+    }
+
+    if (default_value)
+      msIO_fprintf(stream, format, default_value);
+  }
+
+  return status;
+}
+
+/*
+** msOWSPrintEncodeMetadata()
+**
+** Attempt to output a capability item.  If corresponding metadata is not
+** found then one of a number of predefined actions will be taken.
+** If a default value is provided and metadata is absent then the
+** default will be used.
+** Also encode the value with msEncodeHTMLEntities.
+*/
+
+int msOWSPrintEncodeMetadata(FILE *stream, hashTableObj *metadata,
+                             const char *namespaces, const char *name,
+                             int action_if_not_found, const char *format,
+                             const char *default_value) {
+  return msOWSPrintEncodeMetadata2(stream, metadata, namespaces, name,
+                                   action_if_not_found, format, default_value,
+                                   NULL);
+}
+
+/*
+** msOWSPrintEncodeMetadata2()
+**
+** Attempt to output a capability item in the requested language.
+** Fallback using no language parameter.
+*/
+int msOWSPrintEncodeMetadata2(FILE *stream, hashTableObj *metadata,
+                              const char *namespaces, const char *name,
+                              int action_if_not_found, const char *format,
+                              const char *default_value,
+                              const char *validated_language) {
+  const char *value;
+  char *pszEncodedValue = NULL;
+  int status = MS_NOERR;
+
+  if ((value = msOWSLookupMetadataWithLanguage(metadata, namespaces, name,
+                                               validated_language))) {
+    pszEncodedValue = msEncodeHTMLEntities(value);
+    msIO_fprintf(stream, format, pszEncodedValue);
+    free(pszEncodedValue);
+  } else {
+    if (action_if_not_found == OWS_WARN) {
+      char *pszExpandedName = msStringConcatenate(NULL, name);
+      if (validated_language && validated_language[0]) {
+        pszExpandedName = msStringConcatenate(pszExpandedName, ".");
+        pszExpandedName =
+            msStringConcatenate(pszExpandedName, validated_language);
+      }
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, pszExpandedName);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
+      msFree(pszExpandedName);
+      msFree(pszExpandedMetadataKey);
+      status = action_if_not_found;
+    }
+
+    if (default_value) {
+      pszEncodedValue = msEncodeHTMLEntities(default_value);
+      msIO_fprintf(stream, format, default_value);
+      free(pszEncodedValue);
+    }
+  }
+
+  return status;
+}
+
+/*
+** msOWSGetEncodeMetadata()
+**
+** Equivalent to msOWSPrintEncodeMetadata. Returns en encoded value of the
+** metadata or the default value.
+** Caller should free the returned string.
+*/
+char *msOWSGetEncodeMetadata(hashTableObj *metadata, const char *namespaces,
+                             const char *name, const char *default_value) {
+  const char *value;
+  char *pszEncodedValue = NULL;
+  if ((value = msOWSLookupMetadata(metadata, namespaces, name)))
+    pszEncodedValue = msEncodeHTMLEntities(value);
+  else if (default_value)
+    pszEncodedValue = msEncodeHTMLEntities(default_value);
+
+  return pszEncodedValue;
+}
+
+/*
+** msOWSPrintValidateMetadata()
+**
+** Attempt to output a capability item.  If corresponding metadata is not
+** found then one of a number of predefined actions will be taken.
+** If a default value is provided and metadata is absent then the
+** default will be used.
+** Also validate the value with msIsXMLTagValid.
+*/
+
+int msOWSPrintValidateMetadata(FILE *stream, hashTableObj *metadata,
+                               const char *namespaces, const char *name,
+                               int action_if_not_found, const char *format,
+                               const char *default_value) {
+  const char *value;
+  int status = MS_NOERR;
+
+  if ((value = msOWSLookupMetadata(metadata, namespaces, name))) {
+    if (msIsXMLTagValid(value) == MS_FALSE)
+      msIO_fprintf(stream,
+                   "<!-- WARNING: The value '%s' is not valid in a "
+                   "XML tag context. -->\n",
+                   value);
+    msIO_fprintf(stream, format, value);
+  } else {
+    if (action_if_not_found == OWS_WARN) {
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
+      msFree(pszExpandedMetadataKey);
+      status = action_if_not_found;
+    }
+
+    if (default_value) {
+      if (msIsXMLTagValid(default_value) == MS_FALSE)
+        msIO_fprintf(stream,
+                     "<!-- WARNING: The value '%s' is not valid "
+                     "in a XML tag context. -->\n",
+                     default_value);
+      msIO_fprintf(stream, format, default_value);
+    }
+  }
+
+  return status;
+}
+
+/*
+** msOWSPrintGroupMetadata()
+**
+** Attempt to output a capability item.  If corresponding metadata is not
+** found then one of a number of predefined actions will be taken.
+** If a default value is provided and metadata is absent then the
+** default will be used.
+*/
+int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char *pszGroupName,
+                            const char *namespaces, const char *name,
+                            int action_if_not_found, const char *format,
+                            const char *default_value) {
+  return msOWSPrintGroupMetadata2(stream, map, pszGroupName, namespaces, name,
+                                  action_if_not_found, format, default_value,
+                                  NULL);
+}
+
+/*
+** msOWSPrintGroupMetadata2()
+**
+** Attempt to output a capability item in the requested language.
+** Fallback using no language parameter.
+*/
+int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char *pszGroupName,
+                             const char *namespaces, const char *name,
+                             int action_if_not_found, const char *format,
+                             const char *default_value,
+                             const char *validated_language) {
+  const char *value;
+  char *encoded;
+  int status = MS_NOERR;
+  int i;
+
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->group &&
+        (strcmp(GET_LAYER(map, i)->group, pszGroupName) == 0)) {
+      if ((value = msOWSLookupMetadataWithLanguage(
+               &(GET_LAYER(map, i)->metadata), namespaces, name,
+               validated_language))) {
+        encoded = msEncodeHTMLEntities(value);
+        msIO_fprintf(stream, format, encoded);
+        msFree(encoded);
+        return status;
+      }
+    }
+  }
+
+  if (action_if_not_found == OWS_WARN) {
+    char *pszExpandedMetadataKey =
+        msOWSGetExpandedMetadataKey(namespaces, name);
+    msIO_fprintf(stream,
+                 "<!-- WARNING: Mandatory metadata %s was missing in this "
+                 "context. -->\n",
+                 pszExpandedMetadataKey);
+    msFree(pszExpandedMetadataKey);
+    status = action_if_not_found;
+  }
+
+  if (default_value) {
+    encoded = msEncodeHTMLEntities(default_value);
+    msIO_fprintf(stream, format, encoded);
+    msFree(encoded);
+  }
+
+  return status;
+}
+
+/* msOWSPrintURLType()
+**
+** Attempt to output a URL item in capabilties.  If corresponding metadata
+** is not found then one of a number of predefined actions will be taken.
+** Since it's a capability item, five metadata will be used to populate the
+** XML elements.
+**
+** The 'name' argument is the basename of the metadata items relating to this
+** URL type and the suffixes _type, _width, _height, _format and _href will
+** be appended to the name in the metadata search.
+** e.g. passing name=metadataurl will result in the following medata entries
+** being used:
+**    ows_metadataurl_type
+**    ows_metadataurl_format
+**    ows_metadataurl_href
+**    ... (width and height are unused for metadata)
+**
+** As for all the msOWSPrint*() functions, the namespace argument specifies
+** which prefix (ows_, wms_, wcs_, etc.) is used for the metadata names above.
+**
+** Then the final string will be built from
+** the tag_name and the five metadata. The template is:
+** <tag_name%type%width%height%format>%href</tag_name>
+**
+** For example the width format will usually be " width=\"%s\"".
+** An extern format will be "> <Format>%s</Format"
+**
+** Another template template may be used, but it needs to contains 5 %s,
+** otherwise leave it to NULL. If tag_format is used then you don't need the
+** tag_name and the tabspace.
+**
+** Note that all values will be HTML-encoded.
+**/
+int msOWSPrintURLType(FILE *stream, hashTableObj *metadata,
+                      const char *namespaces, const char *name,
+                      int action_if_not_found, const char *tag_format,
+                      const char *tag_name, const char *type_format,
+                      const char *width_format, const char *height_format,
+                      const char *urlfrmt_format, const char *href_format,
+                      int type_is_mandatory, int width_is_mandatory,
+                      int height_is_mandatory, int format_is_mandatory,
+                      int href_is_mandatory, const char *default_type,
+                      const char *default_width, const char *default_height,
+                      const char *default_urlfrmt, const char *default_href,
+                      const char *tabspace) {
+  const char *value;
+  char *metadata_name;
+  char *encoded;
+  int status = MS_NOERR;
+  char *type = NULL, *width = NULL, *height = NULL, *urlfrmt = NULL,
+       *href = NULL;
+
+  const size_t buffer_size = strlen(name) + 10;
+  metadata_name = (char *)malloc(buffer_size);
+
+  /* Get type */
+  if (type_format != NULL) {
+    snprintf(metadata_name, buffer_size, "%s_type", name);
+    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
+    if (value != NULL) {
+      encoded = msEncodeHTMLEntities(value);
+      const size_t buffer_size_tmp = strlen(type_format) + strlen(encoded) + 1;
+      type = (char *)malloc(buffer_size_tmp);
+      snprintf(type, buffer_size_tmp, type_format, encoded);
+      msFree(encoded);
+    }
+  }
+
+  /* Get width */
+  if (width_format != NULL) {
+    snprintf(metadata_name, buffer_size, "%s_width", name);
+    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
+    if (value != NULL) {
+      encoded = msEncodeHTMLEntities(value);
+      const size_t buffer_size_tmp = strlen(width_format) + strlen(encoded) + 1;
+      width = (char *)malloc(buffer_size_tmp);
+      snprintf(width, buffer_size_tmp, width_format, encoded);
+      msFree(encoded);
+    }
+  }
+
+  /* Get height */
+  if (height_format != NULL) {
+    snprintf(metadata_name, buffer_size, "%s_height", name);
+    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
+    if (value != NULL) {
+      encoded = msEncodeHTMLEntities(value);
+      const size_t buffer_size_tmp =
+          strlen(height_format) + strlen(encoded) + 1;
+      height = (char *)malloc(buffer_size_tmp);
+      snprintf(height, buffer_size_tmp, height_format, encoded);
+      msFree(encoded);
+    }
+  }
+
+  /* Get format */
+  if (urlfrmt_format != NULL) {
+    snprintf(metadata_name, buffer_size, "%s_format", name);
+    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
+    if (value != NULL) {
+      encoded = msEncodeHTMLEntities(value);
+      const size_t buffer_size_tmp =
+          strlen(urlfrmt_format) + strlen(encoded) + 1;
+      urlfrmt = (char *)malloc(buffer_size_tmp);
+      snprintf(urlfrmt, buffer_size_tmp, urlfrmt_format, encoded);
+      msFree(encoded);
+    }
+  }
+
+  /* Get href */
+  if (href_format != NULL) {
+    snprintf(metadata_name, buffer_size, "%s_href", name);
+    value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
+    if (value != NULL) {
+      encoded = msEncodeHTMLEntities(value);
+      const size_t buffer_size_tmp = strlen(href_format) + strlen(encoded) + 1;
+      href = (char *)malloc(buffer_size_tmp);
+      snprintf(href, buffer_size_tmp, href_format, encoded);
+      msFree(encoded);
+    }
+  }
+
+  msFree(metadata_name);
+
+  if (type || width || height || urlfrmt || href ||
+      (!metadata && (default_type || default_width || default_height ||
+                     default_urlfrmt || default_href))) {
+    if ((!type && type_is_mandatory) || (!width && width_is_mandatory) ||
+        (!height && height_is_mandatory) || (!urlfrmt && format_is_mandatory) ||
+        (!href && href_is_mandatory)) {
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Some mandatory elements for '%s' are missing "
+                   "in this context. -->\n",
+                   tag_name);
+      if (action_if_not_found == OWS_WARN) {
+        char *pszExpandedMetadataKey =
+            msOWSGetExpandedMetadataKey(namespaces, name);
+        msIO_fprintf(stream,
+                     "<!-- WARNING: Mandatory metadata %s was missing in this "
+                     "context. -->\n",
+                     pszExpandedMetadataKey);
+        msFree(pszExpandedMetadataKey);
+        status = action_if_not_found;
+      }
+    } else {
+      if (!type && type_format && default_type) {
+        const size_t buffer_size_tmp =
+            strlen(type_format) + strlen(default_type) + 2;
+        type = (char *)malloc(buffer_size_tmp);
+        snprintf(type, buffer_size_tmp, type_format, default_type);
+      } else if (!type)
+        type = msStrdup("");
+      if (!width && width_format && default_width) {
+        const size_t buffer_size_tmp =
+            strlen(width_format) + strlen(default_width) + 2;
+        width = (char *)malloc(buffer_size_tmp);
+        snprintf(width, buffer_size_tmp, width_format, default_width);
+      } else if (!width)
+        width = msStrdup("");
+      if (!height && height_format && default_height) {
+        const size_t buffer_size_tmp =
+            strlen(height_format) + strlen(default_height) + 2;
+        height = (char *)malloc(buffer_size_tmp);
+        snprintf(height, buffer_size_tmp, height_format, default_height);
+      } else if (!height)
+        height = msStrdup("");
+      if (!urlfrmt && urlfrmt_format && default_urlfrmt) {
+        const size_t buffer_size_tmp =
+            strlen(urlfrmt_format) + strlen(default_urlfrmt) + 2;
+        urlfrmt = (char *)malloc(buffer_size_tmp);
+        snprintf(urlfrmt, buffer_size_tmp, urlfrmt_format, default_urlfrmt);
+      } else if (!urlfrmt)
+        urlfrmt = msStrdup("");
+      if (!href && href_format && default_href) {
+        const size_t buffer_size_tmp =
+            strlen(href_format) + strlen(default_href) + 2;
+        href = (char *)malloc(buffer_size_tmp);
+        snprintf(href, buffer_size_tmp, href_format, default_href);
+      } else if (!href)
+        href = msStrdup("");
+
+      if (tag_format == NULL)
+        msIO_fprintf(stream, "%s<%s%s%s%s%s>%s</%s>\n", tabspace, tag_name,
+                     type, width, height, urlfrmt, href, tag_name);
+      else
+        msIO_fprintf(stream, tag_format, type, width, height, urlfrmt, href);
+    }
+
+    msFree(type);
+    msFree(width);
+    msFree(height);
+    msFree(urlfrmt);
+    msFree(href);
+  } else {
+    if (action_if_not_found == OWS_WARN) {
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
+      msFree(pszExpandedMetadataKey);
+      status = action_if_not_found;
+    }
+  }
+
+  return status;
+}
+
+/* msOWSPrintParam()
+**
+** Same as printMetadata() but applied to mapfile parameters.
+**/
+int msOWSPrintParam(FILE *stream, const char *name, const char *value,
+                    int action_if_not_found, const char *format,
+                    const char *default_value) {
+  int status = MS_NOERR;
+
+  if (value && strlen(value) > 0) {
+    msIO_fprintf(stream, format, value);
+  } else {
+    if (action_if_not_found == OWS_WARN) {
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory mapfile parameter '%s' was missing "
+                   "in this context. -->\n",
+                   name);
+      status = action_if_not_found;
+    }
+
+    if (default_value)
+      msIO_fprintf(stream, format, default_value);
+  }
+
+  return status;
+}
+
+/* msOWSPrintEncodeParam()
+**
+** Same as printEncodeMetadata() but applied to mapfile parameters.
+**/
+int msOWSPrintEncodeParam(FILE *stream, const char *name, const char *value,
+                          int action_if_not_found, const char *format,
+                          const char *default_value) {
+  int status = MS_NOERR;
+  char *encode;
+
+  if (value && strlen(value) > 0) {
+    encode = msEncodeHTMLEntities(value);
+    msIO_fprintf(stream, format, encode);
+    msFree(encode);
+  } else {
+    if (action_if_not_found == OWS_WARN) {
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory mapfile parameter '%s' was missing "
+                   "in this context. -->\n",
+                   name);
+      status = action_if_not_found;
+    }
+
+    if (default_value) {
+      encode = msEncodeHTMLEntities(default_value);
+      msIO_fprintf(stream, format, encode);
+      msFree(encode);
+    }
+  }
+
+  return status;
+}
+
+/* msOWSPrintMetadataList()
+**
+** Prints comma-separated lists metadata.  (e.g. keywordList)
+** default_value serves 2 purposes if specified:
+** - won't be printed if part of MetadataList (default_value == key"_exclude")
+**  (exclusion)
+** - will be printed if MetadataList is empty (fallback)
+**/
+int msOWSPrintMetadataList(FILE *stream, hashTableObj *metadata,
+                           const char *namespaces, const char *name,
+                           const char *startTag, const char *endTag,
+                           const char *itemFormat, const char *default_value) {
+  const char *value;
+
+  value = msOWSLookupMetadata(metadata, namespaces, name);
+
+  if (value == NULL) {
+    value = default_value;
+    default_value = NULL;
+  }
+
+  if (value != NULL) {
+    char **keywords;
+    int numkeywords;
+
+    keywords = msStringSplit(value, ',', &numkeywords);
+    if (keywords && numkeywords > 0) {
+      int kw;
+      if (startTag)
+        msIO_fprintf(stream, "%s", startTag);
+      for (kw = 0; kw < numkeywords; kw++) {
+        if (default_value != NULL &&
+            strncasecmp(keywords[kw], default_value, strlen(keywords[kw])) ==
+                0 &&
+            strncasecmp("_exclude", default_value + strlen(default_value) - 8,
+                        8) == 0)
+          continue;
+
+        msIO_fprintf(stream, itemFormat, keywords[kw]);
+      }
+      if (endTag)
+        msIO_fprintf(stream, "%s", endTag);
+    }
+    msFreeCharArray(keywords, numkeywords);
+    return MS_TRUE;
+  }
+  return MS_FALSE;
+}
+
+/* msOWSPrintEncodeMetadataList()
+**
+** Prints comma-separated lists metadata.  (e.g. keywordList)
+** This will print HTML encoded values.
+** default_value serves 2 purposes if specified:
+** - won't be printed if part of MetadataList (default_value == key"_exclude")
+**  (exclusion)
+** - will be printed if MetadataList is empty (fallback)
+**/
+int msOWSPrintEncodeMetadataList(FILE *stream, hashTableObj *metadata,
+                                 const char *namespaces, const char *name,
+                                 const char *startTag, const char *endTag,
+                                 const char *itemFormat,
+                                 const char *default_value) {
+  const char *value;
+  char *encoded;
+  size_t default_value_len = 0;
+
+  value = msOWSLookupMetadata(metadata, namespaces, name);
+
+  if (value == NULL) {
+    value = default_value;
+    default_value = NULL;
+  }
+  if (default_value)
+    default_value_len = strlen(default_value);
+
+  if (value != NULL) {
+    char **keywords;
+    int numkeywords;
+
+    keywords = msStringSplit(value, ',', &numkeywords);
+    if (keywords && numkeywords > 0) {
+      int kw;
+      if (startTag)
+        msIO_fprintf(stream, "%s", startTag);
+      for (kw = 0; kw < numkeywords; kw++) {
+        if (default_value != NULL && default_value_len > 8 &&
+            strncasecmp(keywords[kw], default_value, strlen(keywords[kw])) ==
+                0 &&
+            strncasecmp("_exclude", default_value + default_value_len - 8, 8) ==
+                0)
+          continue;
+
+        encoded = msEncodeHTMLEntities(keywords[kw]);
+        msIO_fprintf(stream, itemFormat, encoded);
+        msFree(encoded);
+      }
+      if (endTag)
+        msIO_fprintf(stream, "%s", endTag);
+    }
+    msFreeCharArray(keywords, numkeywords);
+    return MS_TRUE;
+  }
+  return MS_FALSE;
+}
+
+/* msOWSPrintEncodeParamList()
+**
+** Same as msOWSPrintEncodeMetadataList() but applied to mapfile parameters.
+**/
+int msOWSPrintEncodeParamList(FILE *stream, const char *name, const char *value,
+                              int action_if_not_found, char delimiter,
+                              const char *startTag, const char *endTag,
+                              const char *format, const char *default_value) {
+  int status = MS_NOERR;
+  char *encoded;
+  char **items = NULL;
+  int numitems = 0, i;
+
+  if (value && strlen(value) > 0)
+    items = msStringSplit(value, delimiter, &numitems);
+  else {
+    if (action_if_not_found == OWS_WARN) {
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory mapfile parameter '%s' was missing "
+                   "in this context. -->\n",
+                   name);
+      status = action_if_not_found;
+    }
+
+    if (default_value)
+      items = msStringSplit(default_value, delimiter, &numitems);
+  }
+
+  if (items && numitems > 0) {
+    if (startTag)
+      msIO_fprintf(stream, "%s", startTag);
+    for (i = 0; i < numitems; i++) {
+      encoded = msEncodeHTMLEntities(items[i]);
+      msIO_fprintf(stream, format, encoded);
+      msFree(encoded);
+    }
+    if (endTag)
+      msIO_fprintf(stream, "%s", endTag);
+  }
+  msFreeCharArray(items, numitems);
+
+  return status;
+}
+
+/*
+** msOWSPrintEX_GeographicBoundingBox()
+**
+** Print a EX_GeographicBoundingBox tag for WMS1.3.0
+**
+*/
+void msOWSPrintEX_GeographicBoundingBox(FILE *stream, const char *tabspace,
+                                        rectObj *extent, projectionObj *srcproj)
+
+{
+  const char *pszTag = "EX_GeographicBoundingBox"; /* The default for WMS */
+  rectObj ext;
+
+  ext = *extent;
+
+  /* always project to lat long */
+  msOWSProjectToWGS84(srcproj, &ext);
+
+  msIO_fprintf(stream, "%s<%s>\n", tabspace, pszTag);
+  msIO_fprintf(stream, "%s    <westBoundLongitude>%.6f</westBoundLongitude>\n",
+               tabspace, ext.minx);
+  msIO_fprintf(stream, "%s    <eastBoundLongitude>%.6f</eastBoundLongitude>\n",
+               tabspace, ext.maxx);
+  msIO_fprintf(stream, "%s    <southBoundLatitude>%.6f</southBoundLatitude>\n",
+               tabspace, ext.miny);
+  msIO_fprintf(stream, "%s    <northBoundLatitude>%.6f</northBoundLatitude>\n",
+               tabspace, ext.maxy);
+  msIO_fprintf(stream, "%s</%s>\n", tabspace, pszTag);
+
+  /* msIO_fprintf(stream, "%s<%s minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\"
+     />\n", tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy); */
+}
+
+/*
+** msOWSPrintLatLonBoundingBox()
+**
+** Print a LatLonBoundingBox tag for WMS, or LatLongBoundingBox for WFS
+** ... yes, the tag name differs between WMS and WFS, yuck!
+**
+*/
+void msOWSPrintLatLonBoundingBox(FILE *stream, const char *tabspace,
+                                 rectObj *extent, projectionObj *srcproj,
+                                 projectionObj *wfsproj,
+                                 OWSServiceType nService) {
+  const char *pszTag = "LatLonBoundingBox"; /* The default for WMS */
+  rectObj ext;
+
+  ext = *extent;
+
+  if (nService == OWS_WMS) { /* always project to lat long */
+    msOWSProjectToWGS84(srcproj, &ext);
+  } else if (nService == OWS_WFS) { /* called from wfs 1.0.0 only: project to
+                                       map srs, if set */
+    pszTag = "LatLongBoundingBox";
+    if (wfsproj) {
+      if (msProjectionsDiffer(srcproj, wfsproj) == MS_TRUE)
+        msProjectRect(srcproj, wfsproj, &ext);
+    }
+  }
+
+  msIO_fprintf(
+      stream,
+      "%s<%s minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" maxy=\"%.6f\" />\n",
+      tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy);
+}
+
+/*
+** Emit a bounding box if we can find projection information.
+** If <namespaces>_bbox_extended is not set, emit a single bounding box
+** using the layer's native SRS (ignoring any <namespaces>_srs metadata).
+**
+** If <namespaces>_bbox_extended is set to true, emit a bounding box
+** for every projection listed in the <namespaces>_srs list.
+** Check the map level metadata for both _bbox_extended and _srs,
+** if there is no such metadata at the layer level.
+** (These settings make more sense at the global/map level anyways)
+*/
+void msOWSPrintBoundingBox(FILE *stream, const char *tabspace, rectObj *extent,
+                           projectionObj *srcproj, hashTableObj *layer_meta,
+                           hashTableObj *map_meta, const char *namespaces,
+                           int wms_version) {
+  const char *value, *resx, *resy, *wms_bbox_extended;
+  char *encoded, *encoded_resx, *encoded_resy, *epsg_str;
+  char **epsgs;
+  int i, num_epsgs;
+  projectionObj proj;
+  rectObj ext;
+
+  wms_bbox_extended =
+      msOWSLookupMetadata2(layer_meta, map_meta, namespaces, "bbox_extended");
+  if (wms_bbox_extended && strncasecmp(wms_bbox_extended, "true", 5) == 0) {
+    /* get a list of all projections from the metadata
+       try the layer metadata first, otherwise use the map's */
+    if (msOWSLookupMetadata(layer_meta, namespaces, "srs")) {
+      msOWSGetEPSGProj(srcproj, layer_meta, namespaces, MS_FALSE, &epsg_str);
+    } else {
+      msOWSGetEPSGProj(srcproj, map_meta, namespaces, MS_FALSE, &epsg_str);
+    }
+    epsgs = msStringSplit(epsg_str, ' ', &num_epsgs);
+    msFree(epsg_str);
+  } else {
+    /* Look for EPSG code in PROJECTION block only.  "wms_srs" metadata cannot
+     * be used to establish the native projection of a layer for BoundingBox
+     * purposes.
+     */
+    epsgs = (char **)msSmallMalloc(sizeof(char *));
+    num_epsgs = 1;
+    msOWSGetEPSGProj(srcproj, layer_meta, namespaces, MS_TRUE, &(epsgs[0]));
+  }
+
+  for (i = 0; i < num_epsgs; i++) {
+    value = epsgs[i];
+    if (value && *value) {
+      memcpy(&ext, extent, sizeof(rectObj));
+
+      /* reproject the extents for each SRS's bounding box */
+      msInitProjection(&proj);
+      msProjectionInheritContextFrom(&proj, srcproj);
+      if (msLoadProjectionStringEPSG(&proj, (char *)value) == 0) {
+        if (msProjectionsDiffer(srcproj, &proj) == MS_TRUE) {
+          msProjectRect(srcproj, &proj, &ext);
+        }
+        /*for wms 1.3.0 we need to make sure that we present the BBOX with
+          a reversed axes for some espg codes*/
+        if (wms_version >= OWS_1_3_0 && strncasecmp(value, "EPSG:", 5) == 0) {
+          msAxisNormalizePoints(&proj, 1, &(ext.minx), &(ext.miny));
+          msAxisNormalizePoints(&proj, 1, &(ext.maxx), &(ext.maxy));
+        }
+      }
+
+      encoded = msEncodeHTMLEntities(value);
+      if (msProjIsGeographicCRS(&proj))
+        msIO_fprintf(stream,
+                     "%s<BoundingBox %s=\"%s\"\n"
+                     "%s            minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" "
+                     "maxy=\"%.6f\"",
+                     tabspace, (wms_version >= OWS_1_3_0) ? "CRS" : "SRS",
+                     encoded, tabspace, ext.minx, ext.miny, ext.maxx, ext.maxy);
+      else
+        msIO_fprintf(
+            stream,
+            "%s<BoundingBox %s=\"%s\"\n"
+            "%s            minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\"",
+            tabspace, (wms_version >= OWS_1_3_0) ? "CRS" : "SRS", encoded,
+            tabspace, ext.minx, ext.miny, ext.maxx, ext.maxy);
+
+      msFree(encoded);
+      msFreeProjection(&proj);
+
+      if ((resx = msOWSLookupMetadata2(layer_meta, map_meta, "MFO", "resx")) !=
+              NULL &&
+          (resy = msOWSLookupMetadata2(layer_meta, map_meta, "MFO", "resy")) !=
+              NULL) {
+        encoded_resx = msEncodeHTMLEntities(resx);
+        encoded_resy = msEncodeHTMLEntities(resy);
+        msIO_fprintf(stream, "\n%s            resx=\"%s\" resy=\"%s\"",
+                     tabspace, encoded_resx, encoded_resy);
+        msFree(encoded_resx);
+        msFree(encoded_resy);
+      }
+
+      msIO_fprintf(stream, " />\n");
+    }
+  }
+  msFreeCharArray(epsgs, num_epsgs);
+}
+
+/*
+** Print the contact information
+*/
+void msOWSPrintContactInfo(FILE *stream, const char *tabspace, int nVersion,
+                           hashTableObj *metadata, const char *namespaces) {
+  /* contact information is a required element in 1.0.7 but the */
+  /* sub-elements such as ContactPersonPrimary, etc. are not! */
+  /* In 1.1.0, ContactInformation becomes optional. */
+  if (nVersion > OWS_1_0_0) {
+    msIO_fprintf(stream, "%s<ContactInformation>\n", tabspace);
+
+    /* ContactPersonPrimary is optional, but when present then all its  */
+    /* sub-elements are mandatory */
+
+    if (msOWSLookupMetadata(metadata, namespaces, "contactperson") ||
+        msOWSLookupMetadata(metadata, namespaces, "contactorganization")) {
+      msIO_fprintf(stream, "%s  <ContactPersonPrimary>\n", tabspace);
+
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactperson", OWS_WARN,
+          "      <ContactPerson>%s</ContactPerson>\n", NULL);
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactorganization", OWS_WARN,
+          "      <ContactOrganization>%s</ContactOrganization>\n", NULL);
+      msIO_fprintf(stream, "%s  </ContactPersonPrimary>\n", tabspace);
+    }
+
+    if (msOWSLookupMetadata(metadata, namespaces, "contactposition")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactposition", OWS_NOERR,
+          "      <ContactPosition>%s</ContactPosition>\n", NULL);
+    }
+
+    /* ContactAdress is optional, but when present then all its  */
+    /* sub-elements are mandatory */
+    if (msOWSLookupMetadata(metadata, namespaces, "addresstype") ||
+        msOWSLookupMetadata(metadata, namespaces, "address") ||
+        msOWSLookupMetadata(metadata, namespaces, "city") ||
+        msOWSLookupMetadata(metadata, namespaces, "stateorprovince") ||
+        msOWSLookupMetadata(metadata, namespaces, "postcode") ||
+        msOWSLookupMetadata(metadata, namespaces, "country")) {
+      msIO_fprintf(stream, "%s  <ContactAddress>\n", tabspace);
+
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "addresstype",
+                               OWS_WARN,
+                               "        <AddressType>%s</AddressType>\n", NULL);
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "address",
+                               OWS_WARN, "        <Address>%s</Address>\n",
+                               NULL);
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "city", OWS_WARN,
+                               "        <City>%s</City>\n", NULL);
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "stateorprovince", OWS_WARN,
+          "        <StateOrProvince>%s</StateOrProvince>\n", NULL);
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "postcode",
+                               OWS_WARN, "        <PostCode>%s</PostCode>\n",
+                               NULL);
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "country",
+                               OWS_WARN, "        <Country>%s</Country>\n",
+                               NULL);
+      msIO_fprintf(stream, "%s  </ContactAddress>\n", tabspace);
+    }
+
+    if (msOWSLookupMetadata(metadata, namespaces, "contactvoicetelephone")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactvoicetelephone", OWS_NOERR,
+          "      <ContactVoiceTelephone>%s</ContactVoiceTelephone>\n", NULL);
+    }
+
+    if (msOWSLookupMetadata(metadata, namespaces,
+                            "contactfacsimiletelephone")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactfacsimiletelephone", OWS_NOERR,
+          "      <ContactFacsimileTelephone>%s</ContactFacsimileTelephone>\n",
+          NULL);
+    }
+
+    if (msOWSLookupMetadata(metadata, namespaces,
+                            "contactelectronicmailaddress")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactelectronicmailaddress",
+          OWS_NOERR,
+          "  <ContactElectronicMailAddress>%s</ContactElectronicMailAddress>\n",
+          NULL);
+    }
+    msIO_fprintf(stream, "%s</ContactInformation>\n", tabspace);
+  }
+}
+
+/*
+** msOWSGetLayerExtent()
+**
+** Try to establish layer extent, first looking for "ows_extent" metadata, and
+** if not found then call msLayerGetExtent() which will lookup the
+** layer->extent member, and if not found will open layer to read extent.
+**
+*/
+int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces,
+                        rectObj *ext) {
+  (void)map;
+  const char *value;
+
+  if ((value = msOWSLookupMetadata(&(lp->metadata), namespaces, "extent")) !=
+      NULL) {
+    char **tokens;
+    int n;
+
+    tokens = msStringSplit(value, ' ', &n);
+    if (tokens == NULL || n != 4) {
+      msSetError(MS_WMSERR, "Wrong number of arguments for EXTENT metadata.",
+                 "msOWSGetLayerExtent()");
+      return MS_FAILURE;
+    }
+    ext->minx = atof(tokens[0]);
+    ext->miny = atof(tokens[1]);
+    ext->maxx = atof(tokens[2]);
+    ext->maxy = atof(tokens[3]);
+
+    msFreeCharArray(tokens, n);
+    return MS_SUCCESS;
+  } else {
+    return msLayerGetExtent(lp, ext);
+  }
+
+  return MS_FAILURE;
+}
+
+/**********************************************************************
+ *                          msOWSExecuteRequests()
+ *
+ * Execute a number of WFS/WMS HTTP requests in parallel, and then
+ * update layerObj information with the result of the requests.
+ **********************************************************************/
+int msOWSExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
+                         mapObj *map, int bCheckLocalCache) {
+  int nStatus, iReq;
+
+  /* Execute requests */
+#if defined(USE_CURL)
+  nStatus = msHTTPExecuteRequests(pasReqInfo, numRequests, bCheckLocalCache);
+#else
+  msSetError(MS_WMSERR,
+             "msOWSExecuteRequests() called apparently without libcurl "
+             "configured, msHTTPExecuteRequests() not available.",
+             "msOWSExecuteRequests()");
+  return MS_FAILURE;
+#endif
+
+  /* Scan list of layers and call the handler for each layer type to */
+  /* pass them the request results. */
+  for (iReq = 0; iReq < numRequests; iReq++) {
+    if (pasReqInfo[iReq].nLayerId >= 0 &&
+        pasReqInfo[iReq].nLayerId < map->numlayers) {
+      layerObj *lp;
+
+      lp = GET_LAYER(map, pasReqInfo[iReq].nLayerId);
+
+      if (lp->connectiontype == MS_WFS)
+        msWFSUpdateRequestInfo(lp, &(pasReqInfo[iReq]));
+    }
+  }
+
+  return nStatus;
+}
+
+/**********************************************************************
+ *                          msOWSProcessException()
+ *
+ **********************************************************************/
+void msOWSProcessException(layerObj *lp, const char *pszFname, int nErrorCode,
+                           const char *pszFuncName) {
+  FILE *fp;
+
+  if ((fp = fopen(pszFname, "r")) != NULL) {
+    char *pszBuf = NULL;
+    int nBufSize = 0;
+    char *pszStart, *pszEnd;
+
+    fseek(fp, 0, SEEK_END);
+    nBufSize = ftell(fp);
+    if (nBufSize < 0) {
+      msSetError(MS_IOERR, NULL, "msOWSProcessException()");
+      fclose(fp);
+      return;
+    }
+    rewind(fp);
+    pszBuf = (char *)malloc((nBufSize + 1) * sizeof(char));
+    if (pszBuf == NULL) {
+      msSetError(MS_MEMERR, NULL, "msOWSProcessException()");
+      fclose(fp);
+      return;
+    }
+
+    if ((int)fread(pszBuf, 1, nBufSize, fp) != nBufSize) {
+      msSetError(MS_IOERR, NULL, "msOWSProcessException()");
+      free(pszBuf);
+      fclose(fp);
+      return;
+    }
+
+    pszBuf[nBufSize] = '\0';
+
+    /* OK, got the data in the buffer.  Look for the <Message> tags */
+    if ((strstr(pszBuf, "<WFS_Exception>") && /* WFS style */
+         (pszStart = strstr(pszBuf, "<Message>")) &&
+         (pszEnd = strstr(pszStart, "</Message>"))) ||
+        (strstr(pszBuf, "<ServiceExceptionReport>") && /* WMS style */
+         (pszStart = strstr(pszBuf, "<ServiceException>")) &&
+         (pszEnd = strstr(pszStart, "</ServiceException>")))) {
+      pszStart = strchr(pszStart, '>') + 1;
+      *pszEnd = '\0';
+      msSetError(nErrorCode, "Got Remote Server Exception for layer %s: %s",
+                 pszFuncName, lp->name ? lp->name : "(null)", pszStart);
+    } else {
+      msSetError(
+          MS_WFSCONNERR,
+          "Unable to parse Remote Server Exception Message for layer %s.",
+          pszFuncName, lp->name ? lp->name : "(null)");
+    }
+
+    free(pszBuf);
+    fclose(fp);
+  }
+}
+
+/**********************************************************************
+ *                          msOWSBuildURLFilename()
+ *
+ * Build a unique filename for this URL to use in caching remote server
+ * requests.  Slashes and illegal characters will be turned into '_'
+ *
+ * Returns a newly allocated buffer that should be freed by the caller or
+ * NULL in case of error.
+ **********************************************************************/
+char *msOWSBuildURLFilename(const char *pszPath, const char *pszURL,
+                            const char *pszExt) {
+  char *pszBuf, *pszPtr;
+  int i;
+  size_t nBufLen = 0;
+
+  nBufLen = strlen(pszURL) + strlen(pszExt) + 2;
+  if (pszPath)
+    nBufLen += (strlen(pszPath) + 1);
+
+  pszBuf = (char *)malloc(nBufLen);
+  if (pszBuf == NULL) {
+    msSetError(MS_MEMERR, NULL, "msOWSBuildURLFilename()");
+    return NULL;
+  }
+  pszBuf[0] = '\0';
+
+  if (pszPath) {
+#ifdef _WIN32
+    if (pszPath[strlen(pszPath) - 1] != '/' &&
+        pszPath[strlen(pszPath) - 1] != '\\')
+      snprintf(pszBuf, nBufLen, "%s\\", pszPath);
+    else
+      snprintf(pszBuf, nBufLen, "%s", pszPath);
+#else
+    if (pszPath[strlen(pszPath) - 1] != '/')
+      snprintf(pszBuf, nBufLen, "%s/", pszPath);
+    else
+      snprintf(pszBuf, nBufLen, "%s", pszPath);
+#endif
+  }
+
+  pszPtr = pszBuf + strlen(pszBuf);
+
+  for (i = 0; pszURL[i] != '\0'; i++) {
+    if (isalnum(pszURL[i]))
+      *pszPtr = pszURL[i];
+    else
+      *pszPtr = '_';
+    pszPtr++;
+  }
+
+  strlcpy(pszPtr, pszExt, nBufLen);
+
+  return pszBuf;
+}
+
+/*
+** msOWSGetProjURN()
+**
+** Fetch an OGC URN for this layer or map.  Similar to msOWSGetEPSGProj()
+** but returns the result in the form "urn:ogc:def:crs:EPSG::27700".
+** The returned buffer is dynamically allocated, and must be freed by the
+** caller.
+*/
+char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne) {
+  char *result;
+  char **tokens;
+  int numtokens, i;
+  char *oldStyle = NULL;
+
+  msOWSGetEPSGProj(proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle);
+
+  if (oldStyle == NULL || strncmp(oldStyle, "CRS:", 4) == 0 ||
+      strncmp(oldStyle, "AUTO:", 5) == 0 ||
+      strncmp(oldStyle, "AUTO2:", 6) == 0) {
+    msFree(oldStyle);
+    return NULL;
+  }
+
+  result = msStrdup("");
+
+  tokens = msStringSplit(oldStyle, ' ', &numtokens);
+  msFree(oldStyle);
+  for (i = 0; tokens != NULL && i < numtokens; i++) {
+    char urn[100];
+    char *colon = strchr(tokens[i], ':');
+
+    if (colon != NULL && strchr(colon + 1, ':') == NULL) {
+      *colon = 0;
+      snprintf(urn, sizeof(urn), "urn:ogc:def:crs:%s::%s", tokens[i],
+               colon + 1);
+    } else if (strcasecmp(tokens[i], "imageCRS") == 0)
+      snprintf(urn, sizeof(urn), "urn:ogc:def:crs:OGC::imageCRS");
+    else if (strncmp(tokens[i], "urn:ogc:def:crs:", 16) == 0) {
+      strlcpy(urn, tokens[i], sizeof(urn));
+    } else {
+      strlcpy(urn, "", sizeof(urn));
+    }
+
+    if (strlen(urn) > 0) {
+      const size_t bufferSize = strlen(result) + strlen(urn) + 2;
+      result = (char *)msSmallRealloc(result, bufferSize);
+
+      if (strlen(result) > 0)
+        strlcat(result, " ", bufferSize);
+      strlcat(result, urn, bufferSize);
+    } else {
+      msDebug("msOWSGetProjURN(): Failed to process SRS '%s', ignored.",
+              tokens[i]);
+    }
+  }
+
+  msFreeCharArray(tokens, numtokens);
+
+  if (strlen(result) == 0) {
+    msFree(result);
+    return NULL;
+  } else
+    return result;
+}
+
+/*
+** msOWSGetProjURI()
+**
+** Fetch an OGC URI for this layer or map.  Similar to msOWSGetEPSGProj()
+** but returns the result in the form
+*"http://www.opengis.net/def/crs/EPSG/0/27700".
+** The returned buffer is dynamically allocated, and must be freed by the
+** caller.
+*/
+char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne) {
+  char *result;
+  char **tokens;
+  int numtokens, i;
+  char *oldStyle = NULL;
+
+  msOWSGetEPSGProj(proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle);
+
+  if (oldStyle == NULL || !EQUALN(oldStyle, "EPSG:", 5)) {
+    msFree(oldStyle); // avoid leak
+    return NULL;
+  }
+
+  result = msStrdup("");
+
+  tokens = msStringSplit(oldStyle, ' ', &numtokens);
+  msFree(oldStyle);
+  for (i = 0; tokens != NULL && i < numtokens; i++) {
+    char urn[100];
+
+    if (strncmp(tokens[i], "EPSG:", 5) == 0)
+      snprintf(urn, sizeof(urn), "http://www.opengis.net/def/crs/EPSG/0/%s",
+               tokens[i] + 5);
+    else if (strcasecmp(tokens[i], "imageCRS") == 0)
+      snprintf(urn, sizeof(urn),
+               "http://www.opengis.net/def/crs/OGC/0/imageCRS");
+    else if (strncmp(tokens[i], "http://www.opengis.net/def/crs/", 16) == 0)
+      snprintf(urn, sizeof(urn), "%s", tokens[i]);
+    else
+      strlcpy(urn, "", sizeof(urn));
+
+    if (strlen(urn) > 0) {
+      result = (char *)msSmallRealloc(result, strlen(result) + strlen(urn) + 2);
+
+      if (strlen(result) > 0)
+        strcat(result, " ");
+      strcat(result, urn);
+    } else {
+      msDebug("msOWSGetProjURI(): Failed to process SRS '%s', ignored.",
+              tokens[i]);
+    }
+  }
+
+  msFreeCharArray(tokens, numtokens);
+
+  if (strlen(result) == 0) {
+    msFree(result);
+    return NULL;
+  } else
+    return result;
+}
+
+/*
+** msOWSGetDimensionInfo()
+**
+** Extract dimension information from a layer's metadata
+**
+** Before 4.9, only the time dimension was support. With the addition of
+** Web Map Context 1.1.0, we need to support every dimension types.
+** This function get the dimension information from special metadata in
+** the layer, but can also return default values for the time dimension.
+**
+*/
+void msOWSGetDimensionInfo(layerObj *layer, const char *pszDimension,
+                           const char **papszDimUserValue,
+                           const char **papszDimUnits,
+                           const char **papszDimDefault,
+                           const char **papszDimNearValue,
+                           const char **papszDimUnitSymbol,
+                           const char **papszDimMultiValue) {
+  char *pszDimensionItem;
+  size_t bufferSize = 0;
+
+  if (pszDimension == NULL || layer == NULL)
+    return;
+
+  bufferSize = strlen(pszDimension) + 50;
+  pszDimensionItem = (char *)malloc(bufferSize);
+
+  /* units (mandatory in map context) */
+  if (papszDimUnits != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_units", pszDimension);
+    *papszDimUnits =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
+  }
+  /* unitSymbol (mandatory in map context) */
+  if (papszDimUnitSymbol != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_unitsymbol",
+             pszDimension);
+    *papszDimUnitSymbol =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
+  }
+  /* userValue (mandatory in map context) */
+  if (papszDimUserValue != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_uservalue",
+             pszDimension);
+    *papszDimUserValue =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
+  }
+  /* default */
+  if (papszDimDefault != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_default",
+             pszDimension);
+    *papszDimDefault =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
+  }
+  /* multipleValues */
+  if (papszDimMultiValue != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_multiplevalues",
+             pszDimension);
+    *papszDimMultiValue =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
+  }
+  /* nearestValue */
+  if (papszDimNearValue != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_nearestvalue",
+             pszDimension);
+    *papszDimNearValue =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
+  }
+
+  /* Use default time value if necessary */
+  if (strcasecmp(pszDimension, "time") == 0) {
+    if (papszDimUserValue != NULL && *papszDimUserValue == NULL)
+      *papszDimUserValue =
+          msOWSLookupMetadata(&(layer->metadata), "MO", "time");
+    if (papszDimDefault != NULL && *papszDimDefault == NULL)
+      *papszDimDefault =
+          msOWSLookupMetadata(&(layer->metadata), "MO", "timedefault");
+    if (papszDimUnits != NULL && *papszDimUnits == NULL)
+      *papszDimUnits = "ISO8601";
+    if (papszDimUnitSymbol != NULL && *papszDimUnitSymbol == NULL)
+      *papszDimUnitSymbol = "t";
+    if (papszDimNearValue != NULL && *papszDimNearValue == NULL)
+      *papszDimNearValue = "0";
+  }
+
+  free(pszDimensionItem);
+
+  return;
+}
+
+/**
+ * msOWSNegotiateUpdateSequence()
+ *
+ * returns the updateSequence value for an OWS
+ *
+ * @param requested_updatesequence the updatesequence passed by the client
+ * @param updatesequence the updatesequence set by the server
+ *
+ * @return result of comparison (-1, 0, 1)
+ * -1: lower / higher OR values not set by client or server
+ *  1: higher / lower
+ *  0: equal
+ */
+
+int msOWSNegotiateUpdateSequence(const char *requested_updatesequence,
+                                 const char *updatesequence) {
+  int valtype1 = 1; /* default datatype for updatesequence passed by client */
+  int valtype2 = 1; /* default datatype for updatesequence set by server */
+  struct tm tm_requested_updatesequence, tm_updatesequence;
+
+  /* if not specified by client, or set by server,
+     server responds with latest Capabilities XML */
+  if (!requested_updatesequence || !updatesequence)
+    return -1;
+
+  /* test to see if server value is an integer (1), string (2) or timestamp (3)
+   */
+  if (msStringIsInteger(updatesequence) == MS_FAILURE)
+    valtype1 = 2;
+
+  if (valtype1 == 2) { /* test if timestamp */
+    msTimeInit(&tm_updatesequence);
+    if (msParseTime(updatesequence, &tm_updatesequence) == MS_TRUE)
+      valtype1 = 3;
+    msResetErrorList();
+  }
+
+  /* test to see if client value is an integer (1), string (2) or timestamp (3)
+   */
+  if (msStringIsInteger(requested_updatesequence) == MS_FAILURE)
+    valtype2 = 2;
+
+  if (valtype2 == 2) { /* test if timestamp */
+    msTimeInit(&tm_requested_updatesequence);
+    if (msParseTime(requested_updatesequence, &tm_requested_updatesequence) ==
+        MS_TRUE)
+      valtype2 = 3;
+    msResetErrorList();
+  }
+
+  /* if the datatypes do not match, do not compare, */
+  if (valtype1 != valtype2)
+    return -1;
+
+  if (valtype1 == 1) { /* integer */
+    const int requested_updatesequence_i = atoi(requested_updatesequence);
+    const int updatesequence_i = atoi(updatesequence);
+    if (requested_updatesequence_i < updatesequence_i)
+      return -1;
+
+    if (requested_updatesequence_i > updatesequence_i)
+      return 1;
+
+    return 0;
+  }
+
+  if (valtype1 == 2) /* string */
+    return strcasecmp(requested_updatesequence, updatesequence);
+
+  assert(valtype1 == 3); /* timestamp */
+  /* compare timestamps */
+  return msDateCompare(&tm_requested_updatesequence, &tm_updatesequence) +
+         msTimeCompare(&tm_requested_updatesequence, &tm_updatesequence);
+}
+
+/************************************************************************/
+/*                         msOwsIsOutputFormatValid                     */
+/*                                                                      */
+/*      Utlity function to parse a comma separated list in a            */
+/*      metedata object and select and outputformat.                    */
+/************************************************************************/
+outputFormatObj *msOwsIsOutputFormatValid(mapObj *map, const char *format,
+                                          hashTableObj *metadata,
+                                          const char *namespaces,
+                                          const char *name) {
+  char **tokens = NULL;
+  int i, n;
+  outputFormatObj *psFormat = NULL;
+  const char *format_list = NULL;
+
+  if (map && format && metadata && namespaces && name) {
+    msApplyDefaultOutputFormats(map);
+    format_list = msOWSLookupMetadata(metadata, namespaces, name);
+    n = 0;
+    if (format_list)
+      tokens = msStringSplit(format_list, ',', &n);
+
+    if (tokens && n > 0) {
+      for (i = 0; i < n; i++) {
+        int iFormat = msGetOutputFormatIndex(map, tokens[i]);
+        const char *mimetype;
+        if (iFormat == -1)
+          continue;
+
+        mimetype = map->outputformatlist[iFormat]->mimetype;
+
+        msStringTrim(tokens[i]);
+        if (strcasecmp(tokens[i], format) == 0)
+          break;
+        if (mimetype && strcasecmp(mimetype, format) == 0)
+          break;
+      }
+      if (i < n)
+        psFormat = msSelectOutputFormat(map, format);
+    }
+    if (tokens)
+      msFreeCharArray(tokens, n);
+  }
+
+  return psFormat;
+}
+
+#endif /* defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined             \
+          (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) ||     \
+          defined(USE_WFS_LYR) */
diff -pruN 8.0.1-5/src/mapows.h 8.2.0~beta1-1~exp1/src/mapows.h
--- 8.0.1-5/src/mapows.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapows.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,625 @@
+/*****************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC Web Services (WMS, WFS, WCS) support function definitions
+ * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPOWS_H
+#define MAPOWS_H
+
+#include "maphttp.h"
+#include <time.h>
+
+/* This is the URL to the official OGC Schema Repository. We use it by
+ * default for OGC services unless the ows_schemas_lcoation web metadata
+ * is set in the mapfile.
+ */
+#define OWS_DEFAULT_SCHEMAS_LOCATION "http://schemas.opengis.net"
+
+#if defined USE_LIBXML2 && defined USE_WFS_SVR
+#include <libxml/tree.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*====================================================================
+ *   mapows.c
+ *====================================================================*/
+
+typedef struct {
+  char *pszVersion;
+  char *pszUpdateSequence;
+  char *pszRequest;
+  char *pszService;
+  char *pszTypeName;
+  char *pszFilter;
+  char *pszFilterLanguage;
+  char *pszGeometryName;
+  int nMaxFeatures;
+  char *pszBbox; /* only used with a Get Request */
+  char *pszOutputFormat;
+  char *pszFeatureId;
+  char *pszSrs;
+  char *pszResultType;
+  char *pszPropertyName;
+  int nStartIndex;
+  char *pszAcceptVersions;
+  char *pszSections;
+  char *pszSortBy;         /* Not implemented yet */
+  char *pszLanguage;       /* Inspire extension */
+  char *pszValueReference; /* For GetValueReference */
+  char *pszStoredQueryId;  /* For DescribeStoredQueries */
+  int countGetFeatureById; /* Number of
+                              urn:ogc:def:query:OGC-WFS::GetFeatureById
+                              GetFeature requests */
+  int bHasPostStoredQuery; /* TRUE if a XML GetFeature StoredQuery is present */
+} wfsParamsObj;
+
+/*
+ * sosParamsObj
+ * Used to preprocess SOS request parameters
+ *
+ */
+
+typedef struct {
+  char *pszVersion;
+  char *pszAcceptVersions;
+  char *pszUpdateSequence;
+  char *pszRequest;
+  char *pszService;
+  char *pszOutputFormat;
+  char *pszSensorId;
+  char *pszProcedure;
+  char *pszOffering;
+  char *pszObservedProperty;
+  char *pszEventTime;
+  char *pszResult;
+  char *pszResponseFormat;
+  char *pszResultModel;
+  char *pszResponseMode;
+  char *pszBBox;
+  char *pszFeatureOfInterest;
+  char *pszSrsName;
+} sosParamsObj;
+
+/* wmsParamsObj
+ *
+ * Used to preprocess WMS request parameters and combine layers that can
+ * be comined in a GetMap request.
+ */
+typedef struct {
+  char *onlineresource;
+  hashTableObj *params;
+  int numparams;
+  char *httpcookiedata;
+} wmsParamsObj;
+
+/* metadataParamsObj: Represent a metadata specific request with its enabled
+ * layers */
+typedef struct {
+  char *pszRequest;
+  char *pszLayer;
+  char *pszOutputSchema;
+} metadataParamsObj;
+
+/* owsRequestObj: Represent a OWS specific request with its enabled layers */
+typedef struct {
+  int numlayers;
+  int numwmslayerargs;
+  int *enabled_layers;
+  int *layerwmsfilterindex;
+
+  char *service;
+  char *version;
+  char *request;
+  void *document; /* xmlDocPtr or CPLXMLNode* */
+} owsRequestObj;
+
+MS_DLL_EXPORT int msOWSDispatch(mapObj *map, cgiRequestObj *request,
+                                int ows_mode);
+
+MS_DLL_EXPORT const char *msOWSLookupMetadata(hashTableObj *metadata,
+                                              const char *namespaces,
+                                              const char *name);
+MS_DLL_EXPORT const char *
+msOWSLookupMetadataWithLanguage(hashTableObj *metadata, const char *namespaces,
+                                const char *name,
+                                const char *validated_language);
+MS_DLL_EXPORT const char *msOWSLookupMetadata2(hashTableObj *pri,
+                                               hashTableObj *sec,
+                                               const char *namespaces,
+                                               const char *name);
+
+MS_DLL_EXPORT int
+msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name,
+                         const char *gml_type, const char *gml_width,
+                         const char *gml_precision, const short nullable);
+
+void msOWSInitRequestObj(owsRequestObj *ows_request);
+void msOWSClearRequestObj(owsRequestObj *ows_request);
+
+MS_DLL_EXPORT int msOWSRequestIsEnabled(mapObj *map, layerObj *layer,
+                                        const char *namespaces,
+                                        const char *name, int check_all_layers);
+MS_DLL_EXPORT void msOWSRequestLayersEnabled(mapObj *map,
+                                             const char *namespaces,
+                                             const char *request,
+                                             owsRequestObj *request_layers);
+MS_DLL_EXPORT int msOWSParseRequestMetadata(const char *metadata,
+                                            const char *request, int *disabled);
+
+/* Constants for OWS Service version numbers */
+#define OWS_0_1_2 0x000102
+#define OWS_0_1_4 0x000104
+#define OWS_0_1_6 0x000106
+#define OWS_0_1_7 0x000107
+#define OWS_1_0_0 0x010000
+#define OWS_1_0_1 0x010001
+#define OWS_1_0_6 0x010006
+#define OWS_1_0_7 0x010007
+#define OWS_1_0_8 0x010008
+#define OWS_1_1_0 0x010100
+#define OWS_1_1_1 0x010101
+#define OWS_1_1_2 0x010102
+#define OWS_1_3_0 0x010300
+#define OWS_2_0_0 0x020000
+#define OWS_2_0_1 0x020001
+#define OWS_VERSION_MAXLEN 20 /* Buffer size for msOWSGetVersionString() */
+#define OWS_VERSION_NOTSET -1
+#define OWS_VERSION_BADFORMAT -2
+
+MS_DLL_EXPORT int msOWSParseVersionString(const char *pszVersion);
+MS_DLL_EXPORT const char *msOWSGetVersionString(int nVersion, char *pszBuffer);
+
+MS_DLL_EXPORT const char *msOWSGetLanguage(mapObj *map, const char *context);
+MS_DLL_EXPORT char *msOWSGetOnlineResource(mapObj *map, const char *namespaces,
+                                           const char *metadata_name,
+                                           cgiRequestObj *req);
+MS_DLL_EXPORT const char *msOWSGetSchemasLocation(mapObj *map);
+MS_DLL_EXPORT char *msOWSTerminateOnlineResource(const char *src_url);
+
+void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne,
+                      char **epsgProj);
+void msOWSProjectToWGS84(projectionObj *srcproj, rectObj *ext);
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+
+MS_DLL_EXPORT int msOWSMakeAllLayersUnique(mapObj *map);
+MS_DLL_EXPORT int msOWSNegotiateVersion(int requested_version,
+                                        const int supported_versions[],
+                                        int num_supported_versions);
+MS_DLL_EXPORT char *msOWSGetOnlineResource2(mapObj *map, const char *namespaces,
+                                            const char *metadata_name,
+                                            cgiRequestObj *req,
+                                            const char *validated_language);
+MS_DLL_EXPORT const char *msOWSGetInspireSchemasLocation(mapObj *map);
+MS_DLL_EXPORT char **msOWSGetLanguageList(mapObj *map, const char *namespaces,
+                                          int *numitems);
+MS_DLL_EXPORT char *msOWSGetLanguageFromList(mapObj *map,
+                                             const char *namespaces,
+                                             const char *requested_language);
+MS_DLL_EXPORT char *msOWSLanguageNegotiation(mapObj *map,
+                                             const char *namespaces,
+                                             char **accept_languages,
+                                             int num_accept_languages);
+
+/* OWS_NOERR and OWS_WARN passed as action_if_not_found to printMetadata() */
+#define OWS_NOERR 0
+#define OWS_WARN 1
+
+/* OWS_WMS and OWS_WFS used for functions that differ in behavior between */
+/* WMS and WFS services (e.g. msOWSPrintLatLonBoundingBox()) */
+typedef enum { OWS_WMS = 1, OWS_WFS = 2, OWS_WCS = 3 } OWSServiceType;
+
+MS_DLL_EXPORT int msOWSPrintInspireCommonExtendedCapabilities(
+    FILE *stream, mapObj *map, const char *namespaces, int action_if_not_found,
+    const char *tag_name, const char *tag_ns, const char *validated_language,
+    const OWSServiceType service);
+int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map,
+                                    const char *namespaces,
+                                    int action_if_not_found,
+                                    const OWSServiceType service);
+int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map,
+                                     const char *namespaces,
+                                     int action_if_not_found,
+                                     const char *validated_language);
+
+MS_DLL_EXPORT int msOWSPrintMetadata(FILE *stream, hashTableObj *metadata,
+                                     const char *namespaces, const char *name,
+                                     int action_if_not_found,
+                                     const char *format,
+                                     const char *default_value);
+int msOWSPrintEncodeMetadata(FILE *stream, hashTableObj *metadata,
+                             const char *namespaces, const char *name,
+                             int action_if_not_found, const char *format,
+                             const char *default_value);
+int msOWSPrintEncodeMetadata2(FILE *stream, hashTableObj *metadata,
+                              const char *namespaces, const char *name,
+                              int action_if_not_found, const char *format,
+                              const char *default_value,
+                              const char *validated_language);
+char *msOWSGetEncodeMetadata(hashTableObj *metadata, const char *namespaces,
+                             const char *name, const char *default_value);
+
+int msOWSPrintValidateMetadata(FILE *stream, hashTableObj *metadata,
+                               const char *namespaces, const char *name,
+                               int action_if_not_found, const char *format,
+                               const char *default_value);
+int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char *pszGroupName,
+                            const char *namespaces, const char *name,
+                            int action_if_not_found, const char *format,
+                            const char *default_value);
+int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char *pszGroupName,
+                             const char *namespaces, const char *name,
+                             int action_if_not_found, const char *format,
+                             const char *default_value,
+                             const char *validated_language);
+int msOWSPrintURLType(FILE *stream, hashTableObj *metadata,
+                      const char *namespaces, const char *name,
+                      int action_if_not_found, const char *tag_format,
+                      const char *tag_name, const char *type_format,
+                      const char *width_format, const char *height_format,
+                      const char *urlfrmt_format, const char *href_format,
+                      int type_is_mandatory, int width_is_mandatory,
+                      int height_is_mandatory, int format_is_mandatory,
+                      int href_is_mandatory, const char *default_type,
+                      const char *default_width, const char *default_height,
+                      const char *default_urlfrmt, const char *default_href,
+                      const char *tabspace);
+int msOWSPrintParam(FILE *stream, const char *name, const char *value,
+                    int action_if_not_found, const char *format,
+                    const char *default_value);
+int msOWSPrintEncodeParam(FILE *stream, const char *name, const char *value,
+                          int action_if_not_found, const char *format,
+                          const char *default_value);
+int msOWSPrintMetadataList(FILE *stream, hashTableObj *metadata,
+                           const char *namespaces, const char *name,
+                           const char *startTag, const char *endTag,
+                           const char *itemFormat, const char *default_value);
+int msOWSPrintEncodeMetadataList(FILE *stream, hashTableObj *metadata,
+                                 const char *namespaces, const char *name,
+                                 const char *startTag, const char *endTag,
+                                 const char *itemFormat,
+                                 const char *default_value);
+int msOWSPrintEncodeParamList(FILE *stream, const char *name, const char *value,
+                              int action_if_not_found, char delimiter,
+                              const char *startTag, const char *endTag,
+                              const char *format, const char *default_value);
+void msOWSPrintLatLonBoundingBox(FILE *stream, const char *tabspace,
+                                 rectObj *extent, projectionObj *srcproj,
+                                 projectionObj *wfsproj,
+                                 OWSServiceType nService);
+void msOWSPrintEX_GeographicBoundingBox(FILE *stream, const char *tabspace,
+                                        rectObj *extent,
+                                        projectionObj *srcproj);
+
+void msOWSPrintBoundingBox(FILE *stream, const char *tabspace, rectObj *extent,
+                           projectionObj *srcproj, hashTableObj *layer_meta,
+                           hashTableObj *map_meta, const char *namespaces,
+                           int wms_version);
+void msOWSPrintContactInfo(FILE *stream, const char *tabspace, int nVersion,
+                           hashTableObj *metadata, const char *namespaces);
+int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces,
+                        rectObj *ext);
+
+int msOWSExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
+                         mapObj *map, int bCheckLocalCache);
+
+void msOWSProcessException(layerObj *lp, const char *pszFname, int nErrorCode,
+                           const char *pszFuncName);
+char *msOWSBuildURLFilename(const char *pszPath, const char *pszURL,
+                            const char *pszExt);
+char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne);
+char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne);
+
+void msOWSGetDimensionInfo(layerObj *layer, const char *pszDimension,
+                           const char **pszDimUserValue,
+                           const char **pszDimUnits, const char **pszDimDefault,
+                           const char **pszDimNearValue,
+                           const char **pszDimUnitSymbol,
+                           const char **pszDimMultiValue);
+
+int msOWSNegotiateUpdateSequence(const char *requested_updateSequence,
+                                 const char *updatesequence);
+
+outputFormatObj *msOwsIsOutputFormatValid(mapObj *map, const char *format,
+                                          hashTableObj *metadata,
+                                          const char *namespaces,
+                                          const char *name);
+#endif /* #if any wxs service enabled */
+
+/*====================================================================
+ *   mapgml.c
+ *====================================================================*/
+
+typedef enum {
+  OWS_GML2, /* 2.1.2 */
+  OWS_GML3, /* 3.1.1 */
+  OWS_GML32 /* 3.2.1 */
+} OWSGMLVersion;
+
+#define OWS_WFS_FEATURE_COLLECTION_NAME "msFeatureCollection"
+#define OWS_GML_DEFAULT_GEOMETRY_NAME "msGeometry"
+#define OWS_GML_OCCUR_UNBOUNDED -1
+
+/* TODO, there must be a better way to generalize these lists of objects... */
+
+typedef struct {
+  char *name;  /* name of the item */
+  char *alias; /* is the item aliased for presentation? (NULL if not) */
+  char *type; /* raw type for this item (NULL for a "string") (TODO: should this
+                 be a lookup table instead?) */
+#ifndef __cplusplus
+  char *template; /* presentation string for this item, needs to be a complete
+                     XML tag */
+#else
+  char *_template; /* presentation string for this item, needs to be a complete
+                      XML tag */
+#endif
+  int encode;    /* should the value be HTML encoded? Default is MS_TRUE */
+  int visible;   /* should this item be output, default is MS_FALSE */
+  int width;     /* field width, zero if unknown */
+  int precision; /* field precision (decimal places), zero if unknown or N/A */
+  int outputByDefault; /* whether this should be output in a GetFeature without
+                          PropertyName. MS_TRUE by default, unless
+                          gml_default_items is specified and the item name is
+                          not in it */
+  int minOccurs; /* 0 by default. Can be set to 1 by specifying item name in
+                    gml_mandatory_items */
+} gmlItemObj;
+
+typedef struct {
+  gmlItemObj *items;
+  int numitems;
+} gmlItemListObj;
+
+typedef struct {
+  char *name;  /* name of the constant */
+  char *type;  /* raw type for this item (NULL for a "string") */
+  char *value; /* output value for this constant (output will look like:
+                  <name>value</name>) */
+} gmlConstantObj;
+
+typedef struct {
+  gmlConstantObj *constants;
+  int numconstants;
+} gmlConstantListObj;
+
+typedef struct {
+  char *name;             /* name of the geometry (type of GML property) */
+  char *type;             /* raw type for these geometries
+                             (point|multipoint|line|multiline|polygon|multipolygon */
+  int occurmin, occurmax; /* number of occurances (default 0,1) */
+} gmlGeometryObj;
+
+typedef struct {
+  gmlGeometryObj *geometries;
+  int numgeometries;
+} gmlGeometryListObj;
+
+typedef struct {
+  char *name;   /* name of the group */
+  char **items; /* list of items in the group */
+  int numitems; /* number of items */
+  char *type;   /* name of the complex type */
+} gmlGroupObj;
+
+typedef struct {
+  gmlGroupObj *groups;
+  int numgroups;
+} gmlGroupListObj;
+
+typedef struct {
+  char *prefix;
+  char *uri;
+  char *schemalocation;
+} gmlNamespaceObj;
+
+typedef struct {
+  gmlNamespaceObj *namespaces;
+  int numnamespaces;
+} gmlNamespaceListObj;
+
+MS_DLL_EXPORT gmlItemListObj *msGMLGetItems(layerObj *layer,
+                                            const char *metadata_namespaces);
+MS_DLL_EXPORT void msGMLFreeItems(gmlItemListObj *itemList);
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR)
+
+MS_DLL_EXPORT int msItemInGroups(const char *name, gmlGroupListObj *groupList);
+MS_DLL_EXPORT gmlConstantListObj *
+msGMLGetConstants(layerObj *layer, const char *metadata_namespaces);
+MS_DLL_EXPORT void msGMLFreeConstants(gmlConstantListObj *constantList);
+MS_DLL_EXPORT gmlGeometryListObj *
+msGMLGetGeometries(layerObj *layer, const char *metadata_namespaces,
+                   int bWithDefaultGeom);
+MS_DLL_EXPORT void msGMLFreeGeometries(gmlGeometryListObj *geometryList);
+MS_DLL_EXPORT gmlNamespaceListObj *
+msGMLGetNamespaces(webObj *web, const char *metadata_namespaces);
+MS_DLL_EXPORT void msGMLFreeNamespaces(gmlNamespaceListObj *namespaceList);
+#endif
+
+MS_DLL_EXPORT gmlGroupListObj *msGMLGetGroups(layerObj *layer,
+                                              const char *metadata_namespaces);
+MS_DLL_EXPORT void msGMLFreeGroups(gmlGroupListObj *groupList);
+
+/* export to fix bug 851 */
+MS_DLL_EXPORT int msGMLWriteQuery(mapObj *map, char *filename,
+                                  const char *namespaces);
+
+#ifdef USE_WFS_SVR
+
+void msGMLWriteWFSBounds(mapObj *map, FILE *stream, const char *tab,
+                         OWSGMLVersion outputformat, int nWFSVersion,
+                         int bUseURN);
+
+MS_DLL_EXPORT int msGMLWriteWFSQuery(mapObj *map, FILE *stream,
+                                     const char *wfs_namespace,
+                                     OWSGMLVersion outputformat,
+                                     int nWFSVersion, int bUseURN,
+                                     int bGetPropertyValueRequest);
+#endif
+
+/*====================================================================
+ *   mapwms.c
+ *====================================================================*/
+int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request,
+                  int force_wms_mode);
+MS_DLL_EXPORT int msWMSLoadGetMapParams(mapObj *map, int nVersion, char **names,
+                                        char **values, int numentries,
+                                        const char *wms_exception_format,
+                                        const char *wms_request,
+                                        owsRequestObj *ows_request);
+
+/*====================================================================
+ *   mapwmslayer.c
+ *====================================================================*/
+
+#define WMS_GETMAP 1
+#define WMS_GETFEATUREINFO 2
+#define WMS_GETLEGENDGRAPHIC 3
+
+int msInitWmsParamsObj(wmsParamsObj *wmsparams);
+void msFreeWmsParamsObj(wmsParamsObj *wmsparams);
+
+int msPrepareWMSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
+                             int nRequestType,
+                             enum MS_CONNECTION_TYPE lastconnectiontype,
+                             wmsParamsObj *psLastWMSParams, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat,
+                             httpRequestObj *pasReqInfo, int *numRequests);
+int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo, int numRequests,
+                      mapObj *map, layerObj *lp, imageObj *img);
+MS_DLL_EXPORT char *msWMSGetFeatureInfoURL(mapObj *map, layerObj *lp,
+                                           int nClickX, int nClickY,
+                                           int nFeatureCount,
+                                           const char *pszInfoFormat);
+int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat, int type);
+
+/*====================================================================
+ *   mapmetadata.c
+ *====================================================================*/
+
+metadataParamsObj *msMetadataCreateParamsObj(void);
+void msMetadataFreeParamsObj(metadataParamsObj *metadataparams);
+int msMetadataDispatch(mapObj *map, cgiRequestObj *requestobj);
+void msMetadataSetGetMetadataURL(layerObj *lp, const char *url);
+
+/*====================================================================
+ *   mapwfs.c
+ *====================================================================*/
+
+MS_DLL_EXPORT int msWFSDispatch(mapObj *map, cgiRequestObj *requestobj,
+                                owsRequestObj *ows_request, int force_wfs_mode);
+wfsParamsObj *msWFSCreateParamsObj(void);
+int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *wfsparams,
+                              const char *pszFunction);
+void msWFSFreeParamsObj(wfsParamsObj *wfsparams);
+int msWFSIsLayerSupported(layerObj *lp);
+int msWFSException(mapObj *map, const char *locator, const char *code,
+                   const char *version);
+
+#ifdef USE_WFS_SVR
+const char *msWFSGetGeomElementName(mapObj *map, layerObj *lp);
+
+int msWFSException11(mapObj *map, const char *locator,
+                     const char *exceptionCode, const char *version);
+int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *wfsparams,
+                           cgiRequestObj *req, owsRequestObj *ows_request);
+#ifdef USE_LIBXML2
+xmlNodePtr msWFSDumpLayer11(mapObj *map, layerObj *lp, xmlNsPtr psNsOws,
+                            int nWFSVersion, const char *validate_language,
+                            char *script_url);
+#endif
+char *msWFSGetOutputFormatList(mapObj *map, layerObj *layer, int nWFSVersion);
+
+int msWFSException20(mapObj *map, const char *locator,
+                     const char *exceptionCode);
+int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request);
+int msWFSListStoredQueries20(mapObj *map, owsRequestObj *ows_request);
+int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
+                                 owsRequestObj *ows_request);
+char *msWFSGetResolvedStoredQuery20(mapObj *map, wfsParamsObj *wfsparams,
+                                    const char *id, hashTableObj *hashTable);
+
+#endif
+
+/*====================================================================
+ *   mapwfslayer.c
+ *====================================================================*/
+
+int msPrepareWFSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
+                             httpRequestObj *pasReqInfo, int *numRequests);
+void msWFSUpdateRequestInfo(layerObj *lp, httpRequestObj *pasReqInfo);
+int msWFSLayerOpen(layerObj *lp, const char *pszGMLFilename,
+                   rectObj *defaultBBOX);
+int msWFSLayerIsOpen(layerObj *lp);
+int msWFSLayerInitItemInfo(layerObj *layer);
+int msWFSLayerGetItems(layerObj *layer);
+int msWFSLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery);
+int msWFSLayerClose(layerObj *lp);
+MS_DLL_EXPORT char *msWFSExecuteGetFeature(layerObj *lp);
+
+/*====================================================================
+ *   mapcontext.c
+ *====================================================================*/
+
+MS_DLL_EXPORT int msWriteMapContext(mapObj *map, FILE *stream);
+MS_DLL_EXPORT int msSaveMapContext(mapObj *map, char *filename);
+MS_DLL_EXPORT int msLoadMapContext(mapObj *map, const char *filename,
+                                   int unique_layer_names);
+MS_DLL_EXPORT int msLoadMapContextURL(mapObj *map, char *urlfilename,
+                                      int unique_layer_names);
+
+/*====================================================================
+ *   mapwcs.c
+ *====================================================================*/
+
+int msWCSDispatch(mapObj *map, cgiRequestObj *requestobj,
+                  owsRequestObj *ows_request); /* only 1 public function */
+
+/*====================================================================
+ *   mapogsos.c
+ *====================================================================*/
+
+int msSOSDispatch(mapObj *map, cgiRequestObj *requestobj,
+                  owsRequestObj *ows_request); /* only 1 public function */
+
+#ifdef __cplusplus
+} /* extern "C" */
+#endif
+
+#endif /* MAPOWS_H */
diff -pruN 8.0.1-5/src/mapowscommon.c 8.2.0~beta1-1~exp1/src/mapowscommon.c
--- 8.0.1-5/src/mapowscommon.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapowscommon.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,932 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC OWS Common Implementation for use by MapServer OGC code
+ *           versions:
+ *           1.0.0 (OGC Document 05-008c1)
+ *           1.1.0 (OGC document 06-121r3)
+ *
+ * Author:   Tom Kralidis (tomkralidis@gmail.com)
+ *
+ ******************************************************************************
+ * Copyright (c) 2006, Tom Kralidis
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#ifdef USE_LIBXML2
+
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+
+#include "mapowscommon.h"
+#include "maplibxml2.h"
+
+/**
+ * msOWSCommonServiceIdentification()
+ *
+ * returns an object of ServiceIdentification as per:
+ *
+ * 1.0.0 subclause 7.4.3
+ * 1.1.1 subclause 7.4.4
+ *
+ * @param map mapObj used to fetch WEB/METADATA
+ * @param servicetype the OWS type
+ * @param supported_versions the supported version(s) of the OWS
+ *
+ * @return psRootNode xmlNodePtr of XML construct
+ *
+ */
+
+xmlNodePtr msOWSCommonServiceIdentification(xmlNsPtr psNsOws, mapObj *map,
+                                            const char *servicetype,
+                                            const char *supported_versions,
+                                            const char *namespaces,
+                                            const char *validated_language) {
+  const char *value = NULL;
+
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psNode = NULL;
+
+  if (_validateNamespace(psNsOws) == MS_FAILURE)
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+
+  /* create element name */
+  psRootNode = xmlNewNode(psNsOws, BAD_CAST "ServiceIdentification");
+
+  /* add child elements */
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "title", validated_language);
+
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Title", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_title\" missing for ows:Title"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "abstract", validated_language);
+
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Abstract", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(psNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_abstract\" "
+                                "was missing for ows:Abstract"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "keywordlist", validated_language);
+
+  if (value) {
+    psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Keywords", NULL);
+    msLibXml2GenerateList(psNode, psNsOws, "Keyword", value, ',');
+  }
+
+  else {
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_keywordlist\" "
+                               "was missing for ows:KeywordList"));
+  }
+
+  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceType",
+                           BAD_CAST servicetype);
+
+  xmlNewProp(psNode, BAD_CAST "codeSpace", BAD_CAST MS_OWSCOMMON_OGC_CODESPACE);
+
+  msLibXml2GenerateList(psRootNode, psNsOws, "ServiceTypeVersion",
+                        supported_versions, ',');
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "fees", validated_language);
+
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Fees", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(psNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_fees\" was "
+                                "missing for ows:Fees"));
+  }
+
+  value =
+      msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                      "accessconstraints", validated_language);
+
+  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "AccessConstraints",
+                           BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_accessconstraints\" "
+                      "was missing for ows:AccessConstraints"));
+  }
+
+  return psRootNode;
+}
+
+/**
+ * msOWSCommonServiceProvider()
+ *
+ * returns an object of ServiceProvider as per:
+ *
+ *
+ * 1.0.0 subclause 7.4.4
+ * 1.1.0 subclause 7.4.5
+ *
+ * @param map mapObj to fetch MAP/WEB/METADATA
+ *
+ * @return psRootNode xmlNodePtr pointer of XML construct
+ *
+ */
+
+xmlNodePtr msOWSCommonServiceProvider(xmlNsPtr psNsOws, xmlNsPtr psNsXLink,
+                                      mapObj *map, const char *namespaces,
+                                      const char *validated_language) {
+  const char *value = NULL;
+
+  xmlNodePtr psNode = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psSubNode = NULL;
+  xmlNodePtr psSubSubNode = NULL;
+  xmlNodePtr psSubSubSubNode = NULL;
+
+  if (_validateNamespace(psNsOws) == MS_FAILURE)
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+
+  psRootNode = xmlNewNode(psNsOws, BAD_CAST "ServiceProvider");
+
+  /* add child elements */
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactorganization",
+                                          validated_language);
+
+  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ProviderName",
+                           BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Mandatory metadata \"ows_contactorganization\" "
+                      "was missing for ows:ProviderName"));
+  }
+
+  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ProviderSite", NULL);
+
+  xmlNewNsProp(psNode, psNsXLink, BAD_CAST "type", BAD_CAST "simple");
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "service_onlineresource",
+                                          validated_language);
+
+  xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psNode, xmlNewComment(
+                    BAD_CAST
+                    "WARNING: Optional metadata \"ows_service_onlineresource\" "
+                    "was missing for ows:ProviderSite/@xlink:href"));
+  }
+
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceContact", NULL);
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactperson", validated_language);
+
+  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "IndividualName",
+                              BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_contactperson\" was "
+                      "missing for ows:IndividualName"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(
+      &(map->web.metadata), namespaces, "contactposition", validated_language);
+
+  psSubNode =
+      xmlNewTextChild(psNode, psNsOws, BAD_CAST "PositionName", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_contactposition\" was "
+                      "missing for ows:PositionName"));
+  }
+
+  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "ContactInfo", NULL);
+
+  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "Phone", NULL);
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactvoicetelephone",
+                                          validated_language);
+
+  psSubSubSubNode =
+      xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Voice", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(
+            BAD_CAST "WARNING: Optional metadata \"ows_contactvoicetelephone\" "
+                     "was missing for ows:Voice"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactfacsimiletelephone",
+                                          validated_language);
+
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Facsimile",
+                                    BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_contactfacsimiletelephone\" was "
+            "missing for ows:Facsimile"));
+  }
+
+  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "Address", NULL);
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "address", validated_language);
+
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws,
+                                    BAD_CAST "DeliveryPoint", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_address\" was "
+                               "missing for ows:DeliveryPoint"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "city", validated_language);
+
+  psSubSubSubNode =
+      xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "City", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(psSubSubSubNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_city\" was "
+                                "missing for ows:City"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(
+      &(map->web.metadata), namespaces, "stateorprovince", validated_language);
+
+  psSubSubSubNode = xmlNewTextChild(
+      psSubSubNode, psNsOws, BAD_CAST "AdministrativeArea", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_stateorprovince\" was "
+                      "missing for ows:AdministrativeArea"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "postcode", validated_language);
+
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws,
+                                    BAD_CAST "PostalCode", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(psSubSubSubNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_postcode\" "
+                                "was missing for ows:PostalCode"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "country", validated_language);
+
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Country",
+                                    BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_country\" was "
+                               "missing for ows:Country"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactelectronicmailaddress",
+                                          validated_language);
+
+  psSubSubSubNode = xmlNewTextChild(
+      psSubSubNode, psNsOws, BAD_CAST "ElectronicMailAddress", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_contactelectronicmailaddress\" "
+            "was missing for ows:ElectronicMailAddress"));
+  }
+
+  psSubSubNode =
+      xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "OnlineResource", NULL);
+
+  xmlNewNsProp(psSubSubNode, psNsXLink, BAD_CAST "type", BAD_CAST "simple");
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "service_onlineresource",
+                                          validated_language);
+
+  xmlNewNsProp(psSubSubNode, psNsXLink, BAD_CAST "href", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_service_onlineresource\" was "
+            "missing for ows:OnlineResource/@xlink:href"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "hoursofservice", validated_language);
+
+  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "HoursOfService",
+                                 BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_hoursofservice\" was "
+                      "missing for ows:HoursOfService"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactinstructions",
+                                          validated_language);
+
+  psSubSubNode = xmlNewTextChild(
+      psSubNode, psNsOws, BAD_CAST "ContactInstructions", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(
+        psSubSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_contactinstructions\" "
+                      "was missing for ows:ContactInstructions"));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "role", validated_language);
+
+  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "Role", BAD_CAST value);
+
+  if (!value) {
+    xmlAddSibling(psSubNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_role\" was "
+                                "missing for ows:Role"));
+  }
+
+  return psRootNode;
+}
+
+/**
+ * msOWSCommonOperationsMetadata()
+ *
+ * returns the root element of OperationsMetadata as per:
+ *
+ * 1.0.0 subclause 7.4.5
+ * 1.1.0 subclause 7.4.6
+ *
+ * @return psRootNode xmlNodePtr pointer of XML construct
+ *
+ */
+
+xmlNodePtr msOWSCommonOperationsMetadata(xmlNsPtr psNsOws) {
+  xmlNodePtr psRootNode = NULL;
+
+  if (_validateNamespace(psNsOws) == MS_FAILURE)
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+
+  psRootNode = xmlNewNode(psNsOws, BAD_CAST "OperationsMetadata");
+  return psRootNode;
+}
+
+/**
+ * msOWSCommonOperationsMetadataOperation()
+ *
+ * returns an Operation element of OperationsMetadata as per:
+ *
+ * 1.0.0 subclause 7.4.5
+ * 1.1.0 subclause 7.4.6
+ *
+ * @param name name of the Operation
+ * @param method HTTP method: OWS_METHOD_GET, OWS_METHOD_POST or
+ * OWS_METHOD_GETPOST)
+ * @param url online resource URL
+ *
+ * @return psRootNode xmlNodePtr pointer of XML construct
+ */
+
+xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws,
+                                                  xmlNsPtr psXLinkNs,
+                                                  const char *name, int method,
+                                                  const char *url) {
+  if (_validateNamespace(psNsOws) == MS_FAILURE)
+    psNsOws = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+
+  xmlNodePtr psRootNode = xmlNewNode(psNsOws, BAD_CAST "Operation");
+
+  xmlNewProp(psRootNode, BAD_CAST "name", BAD_CAST name);
+
+  xmlNodePtr psNode = xmlNewChild(psRootNode, psNsOws, BAD_CAST "DCP", NULL);
+
+  xmlNodePtr psSubNode = xmlNewChild(psNode, psNsOws, BAD_CAST "HTTP", NULL);
+
+  if (method == OWS_METHOD_GET || method == OWS_METHOD_GETPOST) {
+    xmlNodePtr psSubSubNode =
+        xmlNewChild(psSubNode, psNsOws, BAD_CAST "Get", NULL);
+    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "type", BAD_CAST "simple");
+    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "href", BAD_CAST url);
+  }
+
+  if (method == OWS_METHOD_POST || method == OWS_METHOD_GETPOST) {
+    xmlNodePtr psSubSubNode =
+        xmlNewChild(psSubNode, psNsOws, BAD_CAST "Post", NULL);
+    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "type", BAD_CAST "simple");
+    xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "href", BAD_CAST url);
+  }
+
+  return psRootNode;
+}
+
+/**
+ * msOWSCommonOperationsMetadataDomainType()
+ *
+ * returns a Parameter or Constraint element (which are of type ows:DomainType)
+ * of OperationsMetadata as per:
+ *
+ * 1.0.0 subclause 7.4.5
+ * 1.1.0 subclause 7.4.6
+ *
+ * @param version the integerized x.y.z version of OWS Common to use
+ * @param elname name of the element (Parameter | Constraint)
+ * @param name name of the Parameter
+ * @param values list of values (comma separated list) or NULL if none
+ *
+ * @return psRootNode xmlNodePtr pointer of XML construct
+ *
+ */
+
+xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version,
+                                                   xmlNsPtr psNsOws,
+                                                   const char *elname,
+                                                   const char *name,
+                                                   const char *values) {
+  if (_validateNamespace(psNsOws) == MS_FAILURE)
+    psNsOws = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+
+  xmlNodePtr psRootNode = xmlNewNode(psNsOws, BAD_CAST elname);
+
+  xmlNewProp(psRootNode, BAD_CAST "name", BAD_CAST name);
+
+  if (version == OWS_1_0_0) {
+    msLibXml2GenerateList(psRootNode, psNsOws, "Value", values, ',');
+  }
+  if (version == OWS_1_1_0 || version == OWS_2_0_0) {
+    xmlNodePtr psNode =
+        xmlNewChild(psRootNode, psNsOws, BAD_CAST "AllowedValues", NULL);
+    msLibXml2GenerateList(psNode, psNsOws, "Value", values, ',');
+  }
+
+  return psRootNode;
+}
+
+/**
+ * msOWSCommonExceptionReport()
+ *
+ * returns an object of ExceptionReport as per clause 8
+ *
+ * @param ows_version the version of OWS Common to use
+ * @param schemas_location URL to OGC Schemas Location base
+ * @param version the version of the calling specification
+ * @param language ISO3166 code of language
+ * @param exceptionCode a code from the calling specification's list of
+ * exceptions, or from OWS Common
+ * @param locator where the exception was encountered (i.e. "layers" keyword)
+ * @param ExceptionText the actual error message
+ *
+ * @return psRootNode xmlNodePtr pointer of XML construct
+ *
+ */
+
+xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version,
+                                      const char *schemas_location,
+                                      const char *version, const char *language,
+                                      const char *exceptionCode,
+                                      const char *locator,
+                                      const char *ExceptionText) {
+  char *xsi_schemaLocation = NULL;
+  char szVersionBuf[OWS_VERSION_MAXLEN];
+
+  xmlNsPtr psNsXsi = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psMainNode = NULL;
+
+  psRootNode = xmlNewNode(psNsOws, BAD_CAST "ExceptionReport");
+
+  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+
+  /* add attributes to root element */
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST version);
+
+  if (ows_version == OWS_1_0_0) {
+    xmlNewProp(psRootNode, BAD_CAST "language", BAD_CAST language);
+  }
+  if (ows_version == OWS_1_1_0) {
+    xmlNewProp(psRootNode, BAD_CAST "xml:lang", BAD_CAST language);
+  }
+
+  xsi_schemaLocation = msStrdup((char *)psNsOws->href);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)schemas_location);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/");
+  xsi_schemaLocation = msStringConcatenate(
+      xsi_schemaLocation,
+      (char *)msOWSGetVersionString(ows_version, szVersionBuf));
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
+
+  /* add namespace'd attributes to root element */
+  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+
+  /* add child element */
+  psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Exception", NULL);
+
+  /* add attributes to child */
+  xmlNewProp(psMainNode, BAD_CAST "exceptionCode", BAD_CAST exceptionCode);
+
+  if (locator != NULL) {
+    xmlNewProp(psMainNode, BAD_CAST "locator", BAD_CAST locator);
+  }
+
+  if (ExceptionText != NULL) {
+    xmlNewTextChild(psMainNode, NULL, BAD_CAST "ExceptionText",
+                    BAD_CAST ExceptionText);
+  }
+
+  free(xsi_schemaLocation);
+  return psRootNode;
+}
+
+/**
+ * msOWSCommonBoundingBox()
+ *
+ * returns an object of BoundingBox as per subclause 10.2.1
+ *
+ * If necessary (ie. an EPSG URN GCS such as 4326) the tuple axes will be
+ * reoriented to match the EPSG coordinate system expectations.
+ *
+ * @param psNsOws OWS namespace object
+ * @param crs the CRS / EPSG code
+ * @param dimensions number of dimensions of the coordinates
+ * @param minx minx
+ * @param miny miny
+ * @param maxx maxx
+ * @param maxy maxy
+ *
+ * @return psRootNode xmlNodePtr pointer of XML construct
+ */
+
+xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs,
+                                  int dimensions, double minx, double miny,
+                                  double maxx, double maxy) {
+  char LowerCorner[100];
+  char UpperCorner[100];
+  char dim_string[100];
+  xmlNodePtr psRootNode = NULL;
+
+  /* Do we need to reorient tuple axes? */
+  if (crs && strstr(crs, "imageCRS") == NULL) {
+    projectionObj proj;
+
+    msInitProjection(&proj);
+    if (msLoadProjectionString(&proj, (char *)crs) == 0) {
+      msAxisNormalizePoints(&proj, 1, &minx, &miny);
+      msAxisNormalizePoints(&proj, 1, &maxx, &maxy);
+    }
+    msFreeProjection(&proj);
+  }
+
+  if (_validateNamespace(psNsOws) == MS_FAILURE)
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+
+  /* create element name */
+  psRootNode = xmlNewNode(psNsOws, BAD_CAST "BoundingBox");
+
+  /* add attributes to the root element */
+  xmlNewProp(psRootNode, BAD_CAST "crs", BAD_CAST crs);
+
+  snprintf(dim_string, sizeof(dim_string), "%d", dimensions);
+  xmlNewProp(psRootNode, BAD_CAST "dimensions", BAD_CAST dim_string);
+
+  snprintf(LowerCorner, sizeof(LowerCorner), "%.15g %.15g", minx, miny);
+  snprintf(UpperCorner, sizeof(UpperCorner), "%.15g %.15g", maxx, maxy);
+
+  /* add child elements */
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "LowerCorner",
+              BAD_CAST LowerCorner);
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "UpperCorner",
+              BAD_CAST UpperCorner);
+
+  return psRootNode;
+}
+
+/**
+ * msOWSCommonWGS84BoundingBox()
+ *
+ * returns an object of WGS84BoundingBox as per subclause 10.2.2
+ *
+ * @param psNsOws OWS namespace object
+ * @param dimensions number of dimensions of the coordinates
+ * @param minx minx
+ * @param miny miny
+ * @param maxx maxx
+ * @param maxy maxy
+ *
+ * @return psRootNode xmlNodePtr pointer of XML construct
+ */
+
+xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions,
+                                       double minx, double miny, double maxx,
+                                       double maxy) {
+  char LowerCorner[100];
+  char UpperCorner[100];
+  char dim_string[100];
+
+  xmlNodePtr psRootNode = NULL;
+
+  if (_validateNamespace(psNsOws) == MS_FAILURE)
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+
+  /* create element name */
+  psRootNode = xmlNewNode(psNsOws, BAD_CAST "WGS84BoundingBox");
+
+  snprintf(dim_string, sizeof(dim_string), "%d", dimensions);
+  xmlNewProp(psRootNode, BAD_CAST "dimensions", BAD_CAST dim_string);
+
+  snprintf(LowerCorner, sizeof(LowerCorner), "%.6f %.6f", minx, miny);
+  snprintf(UpperCorner, sizeof(UpperCorner), "%.6f %.6f", maxx, maxy);
+
+  /* add child elements */
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "LowerCorner",
+              BAD_CAST LowerCorner);
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "UpperCorner",
+              BAD_CAST UpperCorner);
+
+  return psRootNode;
+}
+
+/**
+ * _validateNamespace()
+ *
+ * validates the namespace passed to this module's functions
+ *
+ * @param psNsOws namespace object
+ *
+ * @return MS_SUCCESS or MS_FAILURE
+ *
+ */
+
+int _validateNamespace(xmlNsPtr psNsOws) {
+  char namespace_prefix[10];
+  snprintf(namespace_prefix, sizeof(namespace_prefix), "%s", psNsOws->prefix);
+  if (strcmp(namespace_prefix, MS_OWSCOMMON_OWS_NAMESPACE_PREFIX) == 0)
+    return MS_SUCCESS;
+  else
+    return MS_FAILURE;
+}
+
+/*
+ * Valid an xml string against an XML schema
+ * Inpired from:
+ * http://xml.developpez.com/sources/?page=validation#validate_XSD_CppCLI_2
+ * taken from tinyows.org
+ */
+int msOWSSchemaValidation(const char *xml_schema, const char *xml) {
+  xmlSchemaPtr schema;
+  xmlSchemaParserCtxtPtr ctxt;
+  xmlSchemaValidCtxtPtr validctxt;
+  int ret;
+  xmlDocPtr doc;
+
+  if (!xml_schema || !xml)
+    return MS_FAILURE;
+
+  xmlInitParser();
+  schema = NULL;
+  ret = -1;
+
+  /* To valide WFS 2.0 requests, we might need to explicitely import */
+  /* GML and FES 2.0 */
+  if (strlen(xml_schema) > strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) &&
+      strcmp(xml_schema + strlen(xml_schema) -
+                 strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION),
+             MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) == 0) {
+    const size_t nLenBaseLocation =
+        strlen(xml_schema) - strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+    char *pszInMemSchema = NULL;
+    char *pszBaseLocation = (char *)msSmallMalloc(nLenBaseLocation + 1);
+    memcpy(pszBaseLocation, xml_schema, nLenBaseLocation);
+    pszBaseLocation[nLenBaseLocation] = '\0';
+
+    pszInMemSchema = msStringConcatenate(
+        pszInMemSchema,
+        "<schema elementFormDefault=\"qualified\" version=\"1.0.0\" "
+        "xmlns=\"http://www.w3.org/2001/XMLSchema\">\n");
+
+    pszInMemSchema = msStringConcatenate(
+        pszInMemSchema, "<import namespace=\"" MS_OWSCOMMON_WFS_20_NAMESPACE_URI
+                        "\" schemaLocation=\"");
+    pszInMemSchema = msStringConcatenate(pszInMemSchema, xml_schema);
+    pszInMemSchema = msStringConcatenate(pszInMemSchema, "\" />\n");
+
+    if (strstr(xml, MS_OWSCOMMON_FES_20_NAMESPACE_URI) != NULL) {
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema,
+          "<import namespace=\"" MS_OWSCOMMON_FES_20_NAMESPACE_URI
+          "\" schemaLocation=\"");
+      pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema, MS_OWSCOMMON_FES_20_SCHEMA_LOCATION "\" />\n");
+    }
+
+    if (strstr(xml, MS_OWSCOMMON_GML_32_NAMESPACE_URI) != NULL) {
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema,
+          "<import namespace=\"" MS_OWSCOMMON_GML_32_NAMESPACE_URI
+          "\" schemaLocation=\"");
+      pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema, MS_OWSCOMMON_GML_321_SCHEMA_LOCATION "\" />\n");
+
+    } else if (strstr(xml, MS_OWSCOMMON_GML_NAMESPACE_URI) != NULL) {
+      if (strstr(xml, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION) != NULL) {
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema,
+            "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI
+            "\" schemaLocation=\"");
+        pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION "\" />\n");
+      } else if (strstr(xml, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION) != NULL) {
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema,
+            "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI
+            "\" schemaLocation=\"");
+        pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION "\" />\n");
+      }
+    }
+
+    pszInMemSchema = msStringConcatenate(pszInMemSchema, "</schema>\n");
+
+    ctxt = xmlSchemaNewMemParserCtxt(pszInMemSchema, strlen(pszInMemSchema));
+    msFree(pszInMemSchema);
+    msFree(pszBaseLocation);
+  } else {
+    /* Open XML Schema File */
+    ctxt = xmlSchemaNewParserCtxt(xml_schema);
+  }
+
+  /*
+  xmlSchemaSetParserErrors(ctxt,
+                           (xmlSchemaValidityErrorFunc) libxml2_callback,
+                           (xmlSchemaValidityWarningFunc) libxml2_callback,
+  stderr);
+  */
+
+  schema = xmlSchemaParse(ctxt);
+  xmlSchemaFreeParserCtxt(ctxt);
+
+  /* If XML Schema hasn't been rightly loaded */
+  if (schema == NULL) {
+    xmlMemoryDump();
+    xmlCleanupParser();
+    return ret;
+  }
+
+  doc = xmlParseDoc((xmlChar *)xml);
+
+  if (doc != NULL) {
+    /* Loading XML Schema content */
+    validctxt = xmlSchemaNewValidCtxt(schema);
+    /*
+    xmlSchemaSetValidErrors(validctxt,
+                            (xmlSchemaValidityErrorFunc) libxml2_callback,
+                            (xmlSchemaValidityWarningFunc) libxml2_callback,
+    stderr);
+    */
+    /* validation */
+    ret = xmlSchemaValidateDoc(validctxt, doc);
+    xmlSchemaFreeValidCtxt(validctxt);
+  }
+
+  xmlSchemaFree(schema);
+  xmlFreeDoc(doc);
+  xmlCleanupParser();
+
+  return ret;
+}
+
+#endif /* defined(USE_LIBXML2) */
+
+/**
+ * msOWSCommonNegotiateVersion()
+ *
+ * returns a supported version as per subclause 7.3.2
+ *
+ * @param requested_version the version passed by the client
+ * @param supported_versions an array of supported versions
+ * @param num_supported_versions size of supported_versions
+ *
+ * @return supported version integer, or -1 on error
+ *
+ */
+
+int msOWSCommonNegotiateVersion(int requested_version,
+                                const int supported_versions[],
+                                int num_supported_versions) {
+  int i;
+
+  /* if version is not set return error */
+  if (!requested_version)
+    return -1;
+
+  /* return the first entry that's equal to the requested version */
+  for (i = 0; i < num_supported_versions; i++) {
+    if (supported_versions[i] == requested_version)
+      return supported_versions[i];
+  }
+
+  /* no match; calling code should throw an exception */
+  return -1;
+}
diff -pruN 8.0.1-5/src/mapowscommon.h 8.2.0~beta1-1~exp1/src/mapowscommon.h
--- 8.0.1-5/src/mapowscommon.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapowscommon.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,220 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC OWS Common Implementation include file
+ * Author:   Tom Kralidis (tomkralidis@gmail.com)
+ *
+ ******************************************************************************
+ * Copyright (c) 2006, Tom Kralidis
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPOWSCOMMON_H
+#define MAPOWSCOMMON_H
+
+#ifdef USE_LIBXML2
+
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+
+#endif
+
+/* W3C namespaces */
+
+#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI "http://www.w3.org/1999/xlink"
+#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX "xlink"
+
+#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI                                     \
+  "http://www.w3.org/2001/XMLSchema-instance"
+#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX "xsi"
+
+#define MS_OWSCOMMON_W3C_XS_NAMESPACE_URI "http://www.w3.org/2001/XMLSchema"
+#define MS_OWSCOMMON_W3C_XS_NAMESPACE_PREFIX "xs"
+
+/* OGC namespaces */
+
+#define MS_OWSCOMMON_OGC_NAMESPACE_URI "http://www.opengis.net/ogc"
+#define MS_OWSCOMMON_OGC_NAMESPACE_PREFIX "ogc"
+
+#define MS_OWSCOMMON_OWS_NAMESPACE_URI "http://www.opengis.net/ows"
+#define MS_OWSCOMMON_OWS_NAMESPACE_PREFIX "ows"
+
+#define MS_OWSCOMMON_OWS_110_NAMESPACE_URI "http://www.opengis.net/ows/1.1"
+
+#define MS_OWSCOMMON_OWS_20_NAMESPACE_URI "http://www.opengis.net/ows/2.0"
+#define MS_OWSCOMMON_OWS_20_SCHEMAS_LOCATION "/ows/2.0/owsAll.xsd"
+
+/* OGC URNs */
+
+#define MS_OWSCOMMON_URN_OGC_CRS_4326 "urn:opengis:def:crs:OGC:2:84"
+
+/* default OGC Schemas Location */
+
+#define MS_OWSCOMMON_SCHEMAS_LOCATION "http://schemas.opengis.net"
+
+/* OGC codespace */
+
+#define MS_OWSCOMMON_OGC_CODESPACE "OGC"
+
+/* WCS namespaces */
+
+#define MS_OWSCOMMON_WCS_20_NAMESPACE_URI "http://www.opengis.net/wcs/2.0"
+#define MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION "/wcs/2.0/wcsAll.xsd"
+#define MS_OWSCOMMON_WCS_NAMESPACE_PREFIX "wcs"
+
+/* GML namespaces */
+
+#define MS_OWSCOMMON_GML_NAMESPACE_URI "http://www.opengis.net/gml"
+#define MS_OWSCOMMON_GML_NAMESPACE_PREFIX "gml"
+
+#define MS_OWSCOMMON_GML_32_NAMESPACE_URI "http://www.opengis.net/gml/3.2"
+
+#define MS_OWSCOMMON_GML_212_SCHEMA_LOCATION "/gml/2.1.2/feature.xsd"
+#define MS_OWSCOMMON_GML_311_SCHEMA_LOCATION "/gml/3.1.1/base/gml.xsd"
+#define MS_OWSCOMMON_GML_321_SCHEMA_LOCATION "/gml/3.2.1/gml.xsd"
+
+/* WFS namespaces */
+
+#define MS_OWSCOMMON_WFS_NAMESPACE_PREFIX "wfs"
+#define MS_OWSCOMMON_WFS_NAMESPACE_URI "http://www.opengis.net/wfs"
+#define MS_OWSCOMMON_WFS_20_NAMESPACE_URI "http://www.opengis.net/wfs/2.0"
+
+#define MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION "/wfs/1.0.0/WFS-basic.xsd"
+#define MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION "/wfs/1.1.0/wfs.xsd"
+#define MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION "/wfs/2.0/wfs.xsd"
+
+/* FES namespaces */
+
+#define MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX "fes"
+#define MS_OWSCOMMON_FES_20_NAMESPACE_URI "http://www.opengis.net/fes/2.0"
+
+#define MS_OWSCOMMON_FES_20_SCHEMA_LOCATION "/filter/2.0/filterAll.xsd"
+
+/* GMLCov namespaces */
+
+#define MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI "http://www.opengis.net/gmlcov/1.0"
+#define MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX "gmlcov"
+
+/* SWE namespaces */
+#define MS_OWSCOMMON_SWE_20_NAMESPACE_URI "http://www.opengis.net/swe/2.0"
+#define MS_OWSCOMMON_SWE_NAMESPACE_PREFIX "swe"
+
+/* Inspire namespaces */
+
+#define MS_INSPIRE_COMMON_NAMESPACE_URI                                        \
+  "http://inspire.ec.europa.eu/schemas/common/1.0"
+#define MS_INSPIRE_COMMON_NAMESPACE_PREFIX "inspire_common"
+#define MS_INSPIRE_COMMON_SCHEMA_LOCATION "/common/1.0/common.xsd"
+
+#define MS_INSPIRE_VS_NAMESPACE_URI                                            \
+  "http://inspire.ec.europa.eu/schemas/inspire_vs/1.0"
+#define MS_INSPIRE_VS_NAMESPACE_PREFIX "inspire_vs"
+#define MS_INSPIRE_VS_SCHEMA_LOCATION "/inspire_vs/1.0/inspire_vs.xsd"
+
+#define MS_INSPIRE_DLS_NAMESPACE_URI                                           \
+  "http://inspire.ec.europa.eu/schemas/inspire_dls/1.0"
+#define MS_INSPIRE_DLS_NAMESPACE_PREFIX "inspire_dls"
+#define MS_INSPIRE_DLS_SCHEMA_LOCATION "/inspire_dls/1.0/inspire_dls.xsd"
+
+/* MapServer namespaces */
+#define MS_DEFAULT_NAMESPACE_PREFIX "ms"
+#define MS_DEFAULT_NAMESPACE_URI "http://mapserver.gis.umn.edu/mapserver"
+
+/* OWS errors */
+
+/* OWS 1.1.0 Table 25 */
+#define MS_OWS_ERROR_OPERATION_NOT_SUPPORTED "OperationNotSupported"
+#define MS_OWS_ERROR_MISSING_PARAMETER_VALUE "MissingParameterValue"
+#define MS_OWS_ERROR_INVALID_PARAMETER_VALUE "InvalidParameterValue"
+#define MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED "VersionNegotiationFailed"
+#define MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE "InvalidUpdateSequence"
+#define MS_OWS_ERROR_OPTION_NOT_SUPPORTED "OptionNotSupported"
+#define MS_OWS_ERROR_NO_APPLICABLE_CODE "NoApplicableCode"
+
+#define MS_OWS_ERROR_NOT_FOUND "NotFound"
+
+#define MS_WFS_ERROR_OPERATION_PROCESSING_FAILED "OperationProcessingFailed"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef USE_LIBXML2
+
+/* function prototypes */
+
+xmlNodePtr msOWSCommonServiceIdentification(xmlNsPtr psNsOws, mapObj *map,
+                                            const char *servicetype,
+                                            const char *version,
+                                            const char *namespaces,
+                                            const char *validated_language);
+
+xmlNodePtr msOWSCommonServiceProvider(xmlNsPtr psNsOws, xmlNsPtr psXLinkNs,
+                                      mapObj *map, const char *namespaces,
+                                      const char *validated_language);
+
+xmlNodePtr msOWSCommonOperationsMetadata(xmlNsPtr psNsOws);
+
+#define OWS_METHOD_GET 1
+#define OWS_METHOD_POST 2
+#define OWS_METHOD_GETPOST 3
+
+xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws,
+                                                  xmlNsPtr psXLinkNs,
+                                                  const char *name, int method,
+                                                  const char *url);
+
+xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version,
+                                                   xmlNsPtr psNsOws,
+                                                   const char *elname,
+                                                   const char *name,
+                                                   const char *values);
+
+xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version,
+                                      const char *schemas_location,
+                                      const char *version, const char *language,
+                                      const char *exceptionCode,
+                                      const char *locator,
+                                      const char *ExceptionText);
+
+xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs,
+                                  int dimensions, double minx, double miny,
+                                  double maxx, double maxy);
+
+xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions,
+                                       double minx, double miny, double maxx,
+                                       double maxy);
+
+int _validateNamespace(xmlNsPtr psNsOws);
+
+int msOWSSchemaValidation(const char *xml_schema, const char *xml);
+
+#endif /* defined(USE_LIBXML2) */
+
+int msOWSCommonNegotiateVersion(int requested_version,
+                                const int supported_versions[],
+                                int num_supported_versions);
+
+#ifdef __cplusplus
+} /* extern C */
+#endif
+
+#endif /* MAPOWSCOMMON_H */
diff -pruN 8.0.1-5/src/mapparser.c 8.2.0~beta1-1~exp1/src/mapparser.c
--- 8.0.1-5/src/mapparser.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapparser.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3349 @@
+/* A Bison parser, made by GNU Bison 3.0.4.  */
+
+/* Bison implementation for Yacc-like parsers in C
+
+   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.
+
+   This program is free software: you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation, either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+/* As a special exception, you may create a larger work that contains
+   part or all of the Bison parser skeleton and distribute that work
+   under terms of your choice, so long as that work isn't itself a
+   parser generator using the skeleton or a modified version thereof
+   as a parser skeleton.  Alternatively, if you modify or redistribute
+   the parser skeleton itself, you may (at your option) remove this
+   special exception, which will cause the skeleton and the resulting
+   Bison output files to be licensed under the GNU General Public
+   License without this special exception.
+
+   This special exception was added by the Free Software Foundation in
+   version 2.2 of Bison.  */
+
+/* C LALR(1) parser skeleton written by Richard Stallman, by
+   simplifying the original so-called "semantic" parser.  */
+
+/* All symbols defined below should begin with yy or YY, to avoid
+   infringing on user name space.  This should be done even for local
+   variables, as they might otherwise be expanded by user macros.
+   There are some unavoidable exceptions within include files to
+   define necessary library symbols; they are noted "INFRINGES ON
+   USER NAME SPACE" below.  */
+
+/* Identify Bison output.  */
+#define YYBISON 1
+
+/* Bison version.  */
+#define YYBISON_VERSION "3.0.4"
+
+/* Skeleton name.  */
+#define YYSKELETON_NAME "yacc.c"
+
+/* Pure parsers.  */
+#define YYPURE 1
+
+/* Push parsers.  */
+#define YYPUSH 0
+
+/* Pull parsers.  */
+#define YYPULL 1
+
+
+
+
+/* Copy the first part of user declarations.  */
+#line 5 "mapparser.y" /* yacc.c:339  */
+
+/* C declarations */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+#include <time.h>
+
+#include "mapserver.h" /* for TRUE/FALSE and REGEX includes */
+#include "maptime.h" /* for time comparison routines */
+#include "mapprimitive.h" /* for shapeObj */
+
+#include "mapparser.h" /* for YYSTYPE in the function prototype for yylex() */
+
+int yylex(YYSTYPE *, parseObj *); /* prototype functions, defined after the grammar */
+int yyerror(parseObj *, const char *);
+
+#line 84 "/vagrant/mapparser.c" /* yacc.c:339  */
+
+# ifndef YY_NULLPTR
+#  if defined __cplusplus && 201103L <= __cplusplus
+#   define YY_NULLPTR nullptr
+#  else
+#   define YY_NULLPTR 0
+#  endif
+# endif
+
+/* Enabling verbose error messages.  */
+#ifdef YYERROR_VERBOSE
+# undef YYERROR_VERBOSE
+# define YYERROR_VERBOSE 1
+#else
+# define YYERROR_VERBOSE 0
+#endif
+
+/* In a future release of Bison, this section will be replaced
+   by #include "mapparser.h".  */
+#ifndef YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
+# define YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
+/* Debug traces.  */
+#ifndef YYDEBUG
+# define YYDEBUG 0
+#endif
+#if YYDEBUG
+extern int yydebug;
+#endif
+
+/* Token type.  */
+#ifndef YYTOKENTYPE
+# define YYTOKENTYPE
+  enum yytokentype
+  {
+    BOOLEAN = 258,
+    NUMBER = 259,
+    STRING = 260,
+    TIME = 261,
+    SHAPE = 262,
+    OR = 263,
+    AND = 264,
+    NOT = 265,
+    RE = 266,
+    EQ = 267,
+    NE = 268,
+    LT = 269,
+    GT = 270,
+    LE = 271,
+    GE = 272,
+    IN = 273,
+    IEQ = 274,
+    IRE = 275,
+    INTERSECTS = 276,
+    DISJOINT = 277,
+    TOUCHES = 278,
+    OVERLAPS = 279,
+    CROSSES = 280,
+    WITHIN = 281,
+    CONTAINS = 282,
+    EQUALS = 283,
+    BEYOND = 284,
+    DWITHIN = 285,
+    AREA = 286,
+    LENGTH = 287,
+    COMMIFY = 288,
+    ROUND = 289,
+    UPPER = 290,
+    LOWER = 291,
+    INITCAP = 292,
+    FIRSTCAP = 293,
+    TOSTRING = 294,
+    YYBUFFER = 295,
+    INNER = 296,
+    OUTER = 297,
+    DIFFERENCE = 298,
+    DENSIFY = 299,
+    SIMPLIFY = 300,
+    SIMPLIFYPT = 301,
+    GENERALIZE = 302,
+    SMOOTHSIA = 303,
+    CENTERLINE = 304,
+    JAVASCRIPT = 305,
+    NEG = 306
+  };
+#endif
+/* Tokens.  */
+#define BOOLEAN 258
+#define NUMBER 259
+#define STRING 260
+#define TIME 261
+#define SHAPE 262
+#define OR 263
+#define AND 264
+#define NOT 265
+#define RE 266
+#define EQ 267
+#define NE 268
+#define LT 269
+#define GT 270
+#define LE 271
+#define GE 272
+#define IN 273
+#define IEQ 274
+#define IRE 275
+#define INTERSECTS 276
+#define DISJOINT 277
+#define TOUCHES 278
+#define OVERLAPS 279
+#define CROSSES 280
+#define WITHIN 281
+#define CONTAINS 282
+#define EQUALS 283
+#define BEYOND 284
+#define DWITHIN 285
+#define AREA 286
+#define LENGTH 287
+#define COMMIFY 288
+#define ROUND 289
+#define UPPER 290
+#define LOWER 291
+#define INITCAP 292
+#define FIRSTCAP 293
+#define TOSTRING 294
+#define YYBUFFER 295
+#define INNER 296
+#define OUTER 297
+#define DIFFERENCE 298
+#define DENSIFY 299
+#define SIMPLIFY 300
+#define SIMPLIFYPT 301
+#define GENERALIZE 302
+#define SMOOTHSIA 303
+#define CENTERLINE 304
+#define JAVASCRIPT 305
+#define NEG 306
+
+/* Value type.  */
+#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
+
+union YYSTYPE
+{
+#line 30 "mapparser.y" /* yacc.c:355  */
+
+  double dblval;
+  int intval;  
+  char *strval;  
+  struct tm tmval;
+  shapeObj *shpval;
+
+#line 234 "/vagrant/mapparser.c" /* yacc.c:355  */
+};
+
+typedef union YYSTYPE YYSTYPE;
+# define YYSTYPE_IS_TRIVIAL 1
+# define YYSTYPE_IS_DECLARED 1
+#endif
+
+
+
+int yyparse (parseObj *p);
+
+#endif /* !YY_YY_VAGRANT_MAPPARSER_H_INCLUDED  */
+
+/* Copy the second part of user declarations.  */
+
+#line 250 "/vagrant/mapparser.c" /* yacc.c:358  */
+
+#ifdef short
+# undef short
+#endif
+
+#ifdef YYTYPE_UINT8
+typedef YYTYPE_UINT8 yytype_uint8;
+#else
+typedef unsigned char yytype_uint8;
+#endif
+
+#ifdef YYTYPE_INT8
+typedef YYTYPE_INT8 yytype_int8;
+#else
+typedef signed char yytype_int8;
+#endif
+
+#ifdef YYTYPE_UINT16
+typedef YYTYPE_UINT16 yytype_uint16;
+#else
+typedef unsigned short int yytype_uint16;
+#endif
+
+#ifdef YYTYPE_INT16
+typedef YYTYPE_INT16 yytype_int16;
+#else
+typedef short int yytype_int16;
+#endif
+
+#ifndef YYSIZE_T
+# ifdef __SIZE_TYPE__
+#  define YYSIZE_T __SIZE_TYPE__
+# elif defined size_t
+#  define YYSIZE_T size_t
+# elif ! defined YYSIZE_T
+#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
+#  define YYSIZE_T size_t
+# else
+#  define YYSIZE_T unsigned int
+# endif
+#endif
+
+#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)
+
+#ifndef YY_
+# if defined YYENABLE_NLS && YYENABLE_NLS
+#  if ENABLE_NLS
+#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
+#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
+#  endif
+# endif
+# ifndef YY_
+#  define YY_(Msgid) Msgid
+# endif
+#endif
+
+#ifndef YY_ATTRIBUTE
+# if (defined __GNUC__                                               \
+      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
+     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
+#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
+# else
+#  define YY_ATTRIBUTE(Spec) /* empty */
+# endif
+#endif
+
+#ifndef YY_ATTRIBUTE_PURE
+# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
+#endif
+
+#ifndef YY_ATTRIBUTE_UNUSED
+# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
+#endif
+
+#if !defined _Noreturn \
+     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
+# if defined _MSC_VER && 1200 <= _MSC_VER
+#  define _Noreturn __declspec (noreturn)
+# else
+#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
+# endif
+#endif
+
+/* Suppress unused-variable warnings by "using" E.  */
+#if ! defined lint || defined __GNUC__
+# define YYUSE(E) ((void) (E))
+#else
+# define YYUSE(E) /* empty */
+#endif
+
+#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
+/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
+# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
+    _Pragma ("GCC diagnostic push") \
+    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
+    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
+# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
+    _Pragma ("GCC diagnostic pop")
+#else
+# define YY_INITIAL_VALUE(Value) Value
+#endif
+#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
+# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
+# define YY_IGNORE_MAYBE_UNINITIALIZED_END
+#endif
+#ifndef YY_INITIAL_VALUE
+# define YY_INITIAL_VALUE(Value) /* Nothing. */
+#endif
+
+
+#if ! defined yyoverflow || YYERROR_VERBOSE
+
+/* The parser invokes alloca or malloc; define the necessary symbols.  */
+
+# ifdef YYSTACK_USE_ALLOCA
+#  if YYSTACK_USE_ALLOCA
+#   ifdef __GNUC__
+#    define YYSTACK_ALLOC __builtin_alloca
+#   elif defined __BUILTIN_VA_ARG_INCR
+#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
+#   elif defined _AIX
+#    define YYSTACK_ALLOC __alloca
+#   elif defined _MSC_VER
+#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
+#    define alloca _alloca
+#   else
+#    define YYSTACK_ALLOC alloca
+#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
+#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
+      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
+#     ifndef EXIT_SUCCESS
+#      define EXIT_SUCCESS 0
+#     endif
+#    endif
+#   endif
+#  endif
+# endif
+
+# ifdef YYSTACK_ALLOC
+   /* Pacify GCC's 'empty if-body' warning.  */
+#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
+#  ifndef YYSTACK_ALLOC_MAXIMUM
+    /* The OS might guarantee only one guard page at the bottom of the stack,
+       and a page size can be as small as 4096 bytes.  So we cannot safely
+       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
+       to allow for a few compiler-allocated temporary stack slots.  */
+#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
+#  endif
+# else
+#  define YYSTACK_ALLOC YYMALLOC
+#  define YYSTACK_FREE YYFREE
+#  ifndef YYSTACK_ALLOC_MAXIMUM
+#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
+#  endif
+#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
+       && ! ((defined YYMALLOC || defined malloc) \
+             && (defined YYFREE || defined free)))
+#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
+#   ifndef EXIT_SUCCESS
+#    define EXIT_SUCCESS 0
+#   endif
+#  endif
+#  ifndef YYMALLOC
+#   define YYMALLOC malloc
+#   if ! defined malloc && ! defined EXIT_SUCCESS
+void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
+#   endif
+#  endif
+#  ifndef YYFREE
+#   define YYFREE free
+#   if ! defined free && ! defined EXIT_SUCCESS
+void free (void *); /* INFRINGES ON USER NAME SPACE */
+#   endif
+#  endif
+# endif
+#endif /* ! defined yyoverflow || YYERROR_VERBOSE */
+
+
+#if (! defined yyoverflow \
+     && (! defined __cplusplus \
+         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))
+
+/* A type that is properly aligned for any stack member.  */
+union yyalloc
+{
+  yytype_int16 yyss_alloc;
+  YYSTYPE yyvs_alloc;
+};
+
+/* The size of the maximum gap between one aligned stack and the next.  */
+# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)
+
+/* The size of an array large to enough to hold all stacks, each with
+   N elements.  */
+# define YYSTACK_BYTES(N) \
+     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
+      + YYSTACK_GAP_MAXIMUM)
+
+# define YYCOPY_NEEDED 1
+
+/* Relocate STACK from its old location to the new one.  The
+   local variables YYSIZE and YYSTACKSIZE give the old and new number of
+   elements in the stack, and YYPTR gives the new location of the
+   stack.  Advance YYPTR to a properly aligned location for the next
+   stack.  */
+# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
+    do                                                                  \
+      {                                                                 \
+        YYSIZE_T yynewbytes;                                            \
+        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
+        Stack = &yyptr->Stack_alloc;                                    \
+        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
+        yyptr += yynewbytes / sizeof (*yyptr);                          \
+      }                                                                 \
+    while (0)
+
+#endif
+
+#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
+/* Copy COUNT objects from SRC to DST.  The source and destination do
+   not overlap.  */
+# ifndef YYCOPY
+#  if defined __GNUC__ && 1 < __GNUC__
+#   define YYCOPY(Dst, Src, Count) \
+      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
+#  else
+#   define YYCOPY(Dst, Src, Count)              \
+      do                                        \
+        {                                       \
+          YYSIZE_T yyi;                         \
+          for (yyi = 0; yyi < (Count); yyi++)   \
+            (Dst)[yyi] = (Src)[yyi];            \
+        }                                       \
+      while (0)
+#  endif
+# endif
+#endif /* !YYCOPY_NEEDED */
+
+/* YYFINAL -- State number of the termination state.  */
+#define YYFINAL  86
+/* YYLAST -- Last index in YYTABLE.  */
+#define YYLAST   540
+
+/* YYNTOKENS -- Number of terminals.  */
+#define YYNTOKENS  61
+/* YYNNTS -- Number of nonterminals.  */
+#define YYNNTS  7
+/* YYNRULES -- Number of rules.  */
+#define YYNRULES  102
+/* YYNSTATES -- Number of states.  */
+#define YYNSTATES  306
+
+/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
+   by yylex, with out-of-bounds checking.  */
+#define YYUNDEFTOK  2
+#define YYMAXUTOK   306
+
+#define YYTRANSLATE(YYX)                                                \
+  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)
+
+/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
+   as returned by yylex, without out-of-bounds checking.  */
+static const yytype_uint8 yytranslate[] =
+{
+       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,    55,     2,     2,
+      58,    59,    53,    51,    60,    52,     2,    54,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,    57,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
+       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
+      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
+      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
+      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
+      45,    46,    47,    48,    49,    50,    56
+};
+
+#if YYDEBUG
+  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
+static const yytype_uint16 yyrline[] =
+{
+       0,    68,    68,    69,    82,    96,   110,   120,   121,   122,
+     126,   134,   143,   151,   160,   168,   177,   185,   194,   195,
+     196,   216,   236,   242,   248,   254,   260,   266,   272,   280,
+     288,   296,   304,   312,   320,   326,   332,   338,   344,   350,
+     356,   377,   397,   403,   411,   417,   434,   451,   468,   485,
+     502,   519,   536,   553,   570,   587,   604,   621,   638,   655,
+     672,   689,   705,   723,   724,   725,   726,   727,   728,   729,
+     736,   737,   738,   739,   750,   751,   754,   755,   756,   770,
+     784,   798,   812,   826,   840,   854,   868,   882,   896,   910,
+     924,   939,   961,   962,   963,   967,   972,   976,   980,   984,
+     988,   994,   995
+};
+#endif
+
+#if YYDEBUG || YYERROR_VERBOSE || 0
+/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
+   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
+static const char *const yytname[] =
+{
+  "$end", "error", "$undefined", "BOOLEAN", "NUMBER", "STRING", "TIME",
+  "SHAPE", "OR", "AND", "NOT", "RE", "EQ", "NE", "LT", "GT", "LE", "GE",
+  "IN", "IEQ", "IRE", "INTERSECTS", "DISJOINT", "TOUCHES", "OVERLAPS",
+  "CROSSES", "WITHIN", "CONTAINS", "EQUALS", "BEYOND", "DWITHIN", "AREA",
+  "LENGTH", "COMMIFY", "ROUND", "UPPER", "LOWER", "INITCAP", "FIRSTCAP",
+  "TOSTRING", "YYBUFFER", "INNER", "OUTER", "DIFFERENCE", "DENSIFY",
+  "SIMPLIFY", "SIMPLIFYPT", "GENERALIZE", "SMOOTHSIA", "CENTERLINE",
+  "JAVASCRIPT", "'+'", "'-'", "'*'", "'/'", "'%'", "NEG", "'^'", "'('",
+  "')'", "','", "$accept", "input", "logical_exp", "math_exp", "shape_exp",
+  "string_exp", "time_exp", YY_NULLPTR
+};
+#endif
+
+# ifdef YYPRINT
+/* YYTOKNUM[NUM] -- (External) token number corresponding to the
+   (internal) symbol number NUM (which must be that of a token).  */
+static const yytype_uint16 yytoknum[] =
+{
+       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
+     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
+     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
+     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
+     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
+     305,    43,    45,    42,    47,    37,   306,    94,    40,    41,
+      44
+};
+# endif
+
+#define YYPACT_NINF -56
+
+#define yypact_value_is_default(Yystate) \
+  (!!((Yystate) == (-56)))
+
+#define YYTABLE_NINF -1
+
+#define yytable_value_is_error(Yytable_value) \
+  0
+
+  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
+     STATE-NUM.  */
+static const yytype_int16 yypact[] =
+{
+     355,   -56,   -56,   -56,   -56,   -56,   355,   -55,   -48,   -35,
+     -33,     1,    19,    39,    48,    53,    54,    71,    72,    74,
+     116,   128,   130,   131,   132,   133,   134,   135,   157,   158,
+     159,   160,   173,   182,   183,   197,   198,    -3,   355,    51,
+     119,   211,    69,    56,   521,    44,   412,    69,    56,   203,
+     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
+       4,     4,    -3,     4,     4,     4,     4,    -3,   203,   203,
+     203,   203,   203,   203,   203,   203,   203,   203,   203,    -3,
+     102,    -1,   154,    -6,   403,   304,   -56,   355,   355,   355,
+     355,   355,    -3,    -3,    -3,    -3,    -3,    -3,     4,    -3,
+      -3,    -3,    -3,    -3,    -3,    -3,   203,   203,   203,   203,
+     203,   203,   203,   203,     4,     4,     4,     4,     4,     4,
+       4,     4,     4,     4,     4,    -4,    -4,    -4,    -4,    -4,
+      -4,    -4,   203,   152,   161,   199,   200,   209,   225,   228,
+     230,   242,   244,   247,     4,   -46,   -37,   101,   -27,   -25,
+     -24,   106,   381,   248,   255,   263,   264,   265,   266,   267,
+     268,    50,   270,   272,   316,   -56,   -56,   -56,   -56,   -56,
+      21,   258,    44,   412,   -56,   211,    21,   258,    44,   412,
+      -7,    -7,    -7,    -7,    -7,    -7,     6,    -7,    25,    25,
+     102,   102,   102,   102,   -56,   -56,   -56,   -56,   -56,   -56,
+     -56,   -56,     6,     6,     6,     6,     6,     6,     6,     6,
+       6,     6,   -56,    -4,   -56,   -56,   -56,   -56,   -56,   -56,
+     -56,   274,   203,   203,   203,   203,   203,   203,   203,   203,
+     203,   203,   -56,   163,   -56,   -56,   -56,    -3,   -56,   -56,
+     -56,   -56,     4,    -3,   -56,   -56,   203,    -3,    -3,    -3,
+      -3,   -56,    -3,   -56,     4,   280,   285,   286,   287,   288,
+     305,   307,   315,   347,   348,   349,   391,   240,   419,   351,
+     428,   437,   446,   455,   227,   241,   -56,   -56,   -56,   -56,
+     -56,   -56,   -56,   -56,    -3,    -3,   -56,   -56,   -56,   -56,
+     -56,   -56,   -56,   -56,   -56,    -3,   -56,   464,   473,   283,
+     -56,   -56,   -56,     4,   246,   -56
+};
+
+  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
+     Performed when YYTABLE does not specify something else to do.  Zero
+     means the default is an error.  */
+static const yytype_uint8 yydefact[] =
+{
+       2,     7,    63,    92,   101,    76,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       3,     4,     6,     5,     0,    18,    19,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+      70,     0,     0,     0,     0,     0,     1,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     8,    64,    77,    93,   102,
+      10,    12,    11,    13,     9,     0,    14,    16,    15,    17,
+      22,    23,    25,    24,    27,    26,    41,    42,    65,    66,
+      67,    69,    68,    71,    45,    48,    50,    52,    54,    56,
+      58,    60,    20,    28,    29,    31,    30,    33,    32,    40,
+      43,    21,    94,     0,    34,    35,    37,    36,    39,    38,
+      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,    73,     0,    72,    96,    75,     0,    97,    98,
+      99,   100,     0,     0,    79,    80,     0,     0,     0,     0,
+       0,    87,     0,    81,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
+       0,     0,     0,     0,     0,     0,    47,    49,    51,    53,
+      55,    57,    59,    46,     0,     0,    74,    95,    78,    82,
+      83,    84,    85,    86,    88,     0,    91,     0,     0,     0,
+      62,    61,    89,     0,     0,    90
+};
+
+  /* YYPGOTO[NTERM-NUM].  */
+static const yytype_int8 yypgoto[] =
+{
+     -56,   -56,    -2,    46,   126,     0,   -26
+};
+
+  /* YYDEFGOTO[NTERM-NUM].  */
+static const yytype_int8 yydefgoto[] =
+{
+      -1,    39,    40,    41,    47,    48,    44
+};
+
+  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
+     positive, shift that token.  If negative, reduce the rule whose
+     number is the opposite.  If YYTABLE_NINF, syntax error.  */
+static const yytype_uint16 yytable[] =
+{
+      43,     2,     4,    49,    45,   124,   106,    87,    88,     3,
+      50,    89,    85,   234,   124,   107,   108,   109,   110,   111,
+     112,   113,   235,    51,   124,    52,   124,   124,    17,    18,
+      88,    20,   238,    89,   239,   240,    81,    19,    84,    21,
+      22,    23,    24,    25,   100,   101,   102,   103,   104,    37,
+     105,    86,    46,   167,   213,    79,    89,   124,   165,    53,
+     145,   146,   144,   148,   149,   150,   151,   114,   115,   116,
+     117,   118,   119,   120,   121,   122,   123,    54,   102,   103,
+     104,   106,   105,    80,    82,   170,   172,   174,   176,   178,
+     107,   108,   109,   110,   111,   112,   113,    55,   186,   214,
+     215,   216,   217,   218,   219,   220,    56,   124,   147,   251,
+     252,    57,    58,   152,   202,   203,   204,   205,   206,   207,
+     208,   209,   210,   211,   212,   164,    42,    87,    88,    59,
+      60,    89,    61,   171,   173,   175,   177,   179,   180,   181,
+     182,   183,   184,   185,   233,   187,   188,   189,   190,   191,
+     192,   193,   100,   101,   102,   103,   104,   124,   105,   105,
+     236,   237,    90,    91,    83,   241,    92,    93,    94,    95,
+      96,    97,    98,    99,    62,   133,   134,   135,   136,   137,
+     138,   139,   140,   141,   142,   143,    63,   255,    64,    65,
+      66,    67,    68,    69,   153,   154,   155,   156,   157,   158,
+     159,   160,   161,   162,   163,   100,   101,   102,   103,   104,
+       5,   105,   222,   166,   124,    70,    71,    72,    73,    90,
+      91,   223,   168,    92,    93,    94,    95,    96,    97,    98,
+      99,    74,   194,   195,   196,   197,   198,   199,   200,   201,
+      75,    76,   267,    26,    27,    28,    29,    30,    31,    32,
+      33,    34,    35,    36,   275,    77,    78,     0,   221,   224,
+     225,   132,   100,   101,   102,   103,   104,    91,   105,   226,
+      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
+     102,   103,   104,   266,   105,   227,   294,   295,   228,   268,
+     229,   124,   124,   270,   271,   272,   273,   124,   274,   287,
+     296,     0,   230,   304,   231,   305,   232,     0,   243,   100,
+     101,   102,   103,   104,   244,   105,   125,   126,   127,   128,
+     129,   130,   245,   131,   246,   247,   248,   249,   250,   253,
+     297,   298,   254,   167,   100,   101,   102,   103,   104,   169,
+     105,   299,   302,   303,   276,   277,   278,   279,   256,   257,
+     258,   259,   260,   261,   262,   263,   264,   265,     1,     2,
+       3,     4,     5,   169,   280,     6,   281,   100,   101,   102,
+     103,   104,   269,   105,   282,   166,     7,     8,     9,    10,
+      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
+      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
+      31,    32,    33,    34,    35,    36,   283,    37,   284,   285,
+     289,     0,     0,    38,   114,   115,   116,   117,   118,   119,
+     120,   121,   122,   123,    92,    93,    94,    95,    96,    97,
+      98,    99,   100,   101,   102,   103,   104,     0,   105,     0,
+       0,   242,   100,   101,   102,   103,   104,     0,   105,     0,
+     286,     0,     0,     0,   124,     0,     0,     0,     0,     0,
+       0,     0,   168,   100,   101,   102,   103,   104,     0,   105,
+     100,   101,   102,   103,   104,     0,   105,     0,   288,   100,
+     101,   102,   103,   104,     0,   105,     0,   290,   100,   101,
+     102,   103,   104,     0,   105,     0,   291,   100,   101,   102,
+     103,   104,     0,   105,     0,   292,   100,   101,   102,   103,
+     104,     0,   105,     0,   293,   100,   101,   102,   103,   104,
+       0,   105,     0,   300,   100,   101,   102,   103,   104,     0,
+     105,     0,   301,   125,   126,   127,   128,   129,   130,     0,
+     131
+};
+
+static const yytype_int16 yycheck[] =
+{
+       0,     4,     6,    58,     6,    51,    12,     8,     9,     5,
+      58,    12,    38,    59,    51,    21,    22,    23,    24,    25,
+      26,    27,    59,    58,    51,    58,    51,    51,    31,    32,
+       9,    34,    59,    12,    59,    59,    38,    33,    38,    35,
+      36,    37,    38,    39,    51,    52,    53,    54,    55,    52,
+      57,     0,     6,    59,    58,    58,    12,    51,    59,    58,
+      60,    61,    58,    63,    64,    65,    66,    11,    12,    13,
+      14,    15,    16,    17,    18,    19,    20,    58,    53,    54,
+      55,    12,    57,    37,    38,    87,    88,    89,    90,    91,
+      21,    22,    23,    24,    25,    26,    27,    58,    98,   125,
+     126,   127,   128,   129,   130,   131,    58,    51,    62,    59,
+      60,    58,    58,    67,   114,   115,   116,   117,   118,   119,
+     120,   121,   122,   123,   124,    79,     0,     8,     9,    58,
+      58,    12,    58,    87,    88,    89,    90,    91,    92,    93,
+      94,    95,    96,    97,   144,    99,   100,   101,   102,   103,
+     104,   105,    51,    52,    53,    54,    55,    51,    57,    57,
+      59,    60,     8,     9,    38,    59,    12,    13,    14,    15,
+      16,    17,    18,    19,    58,    49,    50,    51,    52,    53,
+      54,    55,    56,    57,    58,    59,    58,   213,    58,    58,
+      58,    58,    58,    58,    68,    69,    70,    71,    72,    73,
+      74,    75,    76,    77,    78,    51,    52,    53,    54,    55,
+       7,    57,    60,    59,    51,    58,    58,    58,    58,     8,
+       9,    60,    59,    12,    13,    14,    15,    16,    17,    18,
+      19,    58,   106,   107,   108,   109,   110,   111,   112,   113,
+      58,    58,   242,    40,    41,    42,    43,    44,    45,    46,
+      47,    48,    49,    50,   254,    58,    58,    -1,   132,    60,
+      60,    58,    51,    52,    53,    54,    55,     9,    57,    60,
+      12,    13,    14,    15,    16,    17,    18,    19,    51,    52,
+      53,    54,    55,   237,    57,    60,    59,    60,    60,   243,
+      60,    51,    51,   247,   248,   249,   250,    51,   252,    59,
+      59,    -1,    60,   303,    60,    59,    59,    -1,    60,    51,
+      52,    53,    54,    55,    59,    57,    12,    13,    14,    15,
+      16,    17,    59,    19,    60,    60,    60,    60,    60,    59,
+     284,   285,    60,    59,    51,    52,    53,    54,    55,    59,
+      57,   295,    59,    60,    59,    59,    59,    59,   222,   223,
+     224,   225,   226,   227,   228,   229,   230,   231,     3,     4,
+       5,     6,     7,    59,    59,    10,    59,    51,    52,    53,
+      54,    55,   246,    57,    59,    59,    21,    22,    23,    24,
+      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
+      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
+      45,    46,    47,    48,    49,    50,    59,    52,    60,    60,
+      59,    -1,    -1,    58,    11,    12,    13,    14,    15,    16,
+      17,    18,    19,    20,    12,    13,    14,    15,    16,    17,
+      18,    19,    51,    52,    53,    54,    55,    -1,    57,    -1,
+      -1,    60,    51,    52,    53,    54,    55,    -1,    57,    -1,
+      59,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
+      -1,    -1,    59,    51,    52,    53,    54,    55,    -1,    57,
+      51,    52,    53,    54,    55,    -1,    57,    -1,    59,    51,
+      52,    53,    54,    55,    -1,    57,    -1,    59,    51,    52,
+      53,    54,    55,    -1,    57,    -1,    59,    51,    52,    53,
+      54,    55,    -1,    57,    -1,    59,    51,    52,    53,    54,
+      55,    -1,    57,    -1,    59,    51,    52,    53,    54,    55,
+      -1,    57,    -1,    59,    51,    52,    53,    54,    55,    -1,
+      57,    -1,    59,    12,    13,    14,    15,    16,    17,    -1,
+      19
+};
+
+  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
+     symbol of state STATE-NUM.  */
+static const yytype_uint8 yystos[] =
+{
+       0,     3,     4,     5,     6,     7,    10,    21,    22,    23,
+      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
+      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
+      44,    45,    46,    47,    48,    49,    50,    52,    58,    62,
+      63,    64,    65,    66,    67,    63,    64,    65,    66,    58,
+      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
+      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
+      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
+      64,    63,    64,    65,    66,    67,     0,     8,     9,    12,
+       8,     9,    12,    13,    14,    15,    16,    17,    18,    19,
+      51,    52,    53,    54,    55,    57,    12,    21,    22,    23,
+      24,    25,    26,    27,    11,    12,    13,    14,    15,    16,
+      17,    18,    19,    20,    51,    12,    13,    14,    15,    16,
+      17,    19,    58,    65,    65,    65,    65,    65,    65,    65,
+      65,    65,    65,    65,    58,    66,    66,    64,    66,    66,
+      66,    66,    64,    65,    65,    65,    65,    65,    65,    65,
+      65,    65,    65,    65,    64,    59,    59,    59,    59,    59,
+      63,    64,    63,    64,    63,    64,    63,    64,    63,    64,
+      64,    64,    64,    64,    64,    64,    66,    64,    64,    64,
+      64,    64,    64,    64,    65,    65,    65,    65,    65,    65,
+      65,    65,    66,    66,    66,    66,    66,    66,    66,    66,
+      66,    66,    66,    58,    67,    67,    67,    67,    67,    67,
+      67,    65,    60,    60,    60,    60,    60,    60,    60,    60,
+      60,    60,    59,    66,    59,    59,    59,    60,    59,    59,
+      59,    59,    60,    60,    59,    59,    60,    60,    60,    60,
+      60,    59,    60,    59,    60,    67,    65,    65,    65,    65,
+      65,    65,    65,    65,    65,    65,    64,    66,    64,    65,
+      64,    64,    64,    64,    64,    66,    59,    59,    59,    59,
+      59,    59,    59,    59,    60,    60,    59,    59,    59,    59,
+      59,    59,    59,    59,    59,    60,    59,    64,    64,    64,
+      59,    59,    59,    60,    66,    59
+};
+
+  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
+static const yytype_uint8 yyr1[] =
+{
+       0,    61,    62,    62,    62,    62,    62,    63,    63,    63,
+      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
+      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
+      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
+      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
+      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
+      63,    63,    63,    64,    64,    64,    64,    64,    64,    64,
+      64,    64,    64,    64,    64,    64,    65,    65,    65,    65,
+      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
+      65,    65,    66,    66,    66,    66,    66,    66,    66,    66,
+      66,    67,    67
+};
+
+  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
+static const yytype_uint8 yyr2[] =
+{
+       0,     2,     0,     1,     1,     1,     1,     1,     3,     3,
+       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
+       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
+       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
+       3,     3,     3,     3,     3,     3,     6,     6,     3,     6,
+       3,     6,     3,     6,     3,     6,     3,     6,     3,     6,
+       3,     8,     8,     1,     3,     3,     3,     3,     3,     3,
+       2,     3,     4,     4,     6,     4,     1,     3,     6,     4,
+       4,     4,     6,     6,     6,     6,     6,     4,     6,     8,
+      10,     6,     1,     3,     3,     6,     4,     4,     4,     4,
+       4,     1,     3
+};
+
+
+#define yyerrok         (yyerrstatus = 0)
+#define yyclearin       (yychar = YYEMPTY)
+#define YYEMPTY         (-2)
+#define YYEOF           0
+
+#define YYACCEPT        goto yyacceptlab
+#define YYABORT         goto yyabortlab
+#define YYERROR         goto yyerrorlab
+
+
+#define YYRECOVERING()  (!!yyerrstatus)
+
+#define YYBACKUP(Token, Value)                                  \
+do                                                              \
+  if (yychar == YYEMPTY)                                        \
+    {                                                           \
+      yychar = (Token);                                         \
+      yylval = (Value);                                         \
+      YYPOPSTACK (yylen);                                       \
+      yystate = *yyssp;                                         \
+      goto yybackup;                                            \
+    }                                                           \
+  else                                                          \
+    {                                                           \
+      yyerror (p, YY_("syntax error: cannot back up")); \
+      YYERROR;                                                  \
+    }                                                           \
+while (0)
+
+/* Error token number */
+#define YYTERROR        1
+#define YYERRCODE       256
+
+
+
+/* Enable debugging if requested.  */
+#if YYDEBUG
+
+# ifndef YYFPRINTF
+#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
+#  define YYFPRINTF fprintf
+# endif
+
+# define YYDPRINTF(Args)                        \
+do {                                            \
+  if (yydebug)                                  \
+    YYFPRINTF Args;                             \
+} while (0)
+
+/* This macro is provided for backward compatibility. */
+#ifndef YY_LOCATION_PRINT
+# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
+#endif
+
+
+# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
+do {                                                                      \
+  if (yydebug)                                                            \
+    {                                                                     \
+      YYFPRINTF (stderr, "%s ", Title);                                   \
+      yy_symbol_print (stderr,                                            \
+                  Type, Value, p); \
+      YYFPRINTF (stderr, "\n");                                           \
+    }                                                                     \
+} while (0)
+
+
+/*----------------------------------------.
+| Print this symbol's value on YYOUTPUT.  |
+`----------------------------------------*/
+
+static void
+yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parseObj *p)
+{
+  FILE *yyo = yyoutput;
+  YYUSE (yyo);
+  YYUSE (p);
+  if (!yyvaluep)
+    return;
+# ifdef YYPRINT
+  if (yytype < YYNTOKENS)
+    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
+# endif
+  YYUSE (yytype);
+}
+
+
+/*--------------------------------.
+| Print this symbol on YYOUTPUT.  |
+`--------------------------------*/
+
+static void
+yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parseObj *p)
+{
+  YYFPRINTF (yyoutput, "%s %s (",
+             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);
+
+  yy_symbol_value_print (yyoutput, yytype, yyvaluep, p);
+  YYFPRINTF (yyoutput, ")");
+}
+
+/*------------------------------------------------------------------.
+| yy_stack_print -- Print the state stack from its BOTTOM up to its |
+| TOP (included).                                                   |
+`------------------------------------------------------------------*/
+
+static void
+yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
+{
+  YYFPRINTF (stderr, "Stack now");
+  for (; yybottom <= yytop; yybottom++)
+    {
+      int yybot = *yybottom;
+      YYFPRINTF (stderr, " %d", yybot);
+    }
+  YYFPRINTF (stderr, "\n");
+}
+
+# define YY_STACK_PRINT(Bottom, Top)                            \
+do {                                                            \
+  if (yydebug)                                                  \
+    yy_stack_print ((Bottom), (Top));                           \
+} while (0)
+
+
+/*------------------------------------------------.
+| Report that the YYRULE is going to be reduced.  |
+`------------------------------------------------*/
+
+static void
+yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, parseObj *p)
+{
+  unsigned long int yylno = yyrline[yyrule];
+  int yynrhs = yyr2[yyrule];
+  int yyi;
+  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
+             yyrule - 1, yylno);
+  /* The symbols being reduced.  */
+  for (yyi = 0; yyi < yynrhs; yyi++)
+    {
+      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
+      yy_symbol_print (stderr,
+                       yystos[yyssp[yyi + 1 - yynrhs]],
+                       &(yyvsp[(yyi + 1) - (yynrhs)])
+                                              , p);
+      YYFPRINTF (stderr, "\n");
+    }
+}
+
+# define YY_REDUCE_PRINT(Rule)          \
+do {                                    \
+  if (yydebug)                          \
+    yy_reduce_print (yyssp, yyvsp, Rule, p); \
+} while (0)
+
+/* Nonzero means print parse trace.  It is left uninitialized so that
+   multiple parsers can coexist.  */
+int yydebug;
+#else /* !YYDEBUG */
+# define YYDPRINTF(Args)
+# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
+# define YY_STACK_PRINT(Bottom, Top)
+# define YY_REDUCE_PRINT(Rule)
+#endif /* !YYDEBUG */
+
+
+/* YYINITDEPTH -- initial size of the parser's stacks.  */
+#ifndef YYINITDEPTH
+# define YYINITDEPTH 200
+#endif
+
+/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
+   if the built-in stack extension method is used).
+
+   Do not make this value too large; the results are undefined if
+   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
+   evaluated with infinite-precision integer arithmetic.  */
+
+#ifndef YYMAXDEPTH
+# define YYMAXDEPTH 10000
+#endif
+
+
+#if YYERROR_VERBOSE
+
+# ifndef yystrlen
+#  if defined __GLIBC__ && defined _STRING_H
+#   define yystrlen strlen
+#  else
+/* Return the length of YYSTR.  */
+static YYSIZE_T
+yystrlen (const char *yystr)
+{
+  YYSIZE_T yylen;
+  for (yylen = 0; yystr[yylen]; yylen++)
+    continue;
+  return yylen;
+}
+#  endif
+# endif
+
+# ifndef yystpcpy
+#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
+#   define yystpcpy stpcpy
+#  else
+/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
+   YYDEST.  */
+static char *
+yystpcpy (char *yydest, const char *yysrc)
+{
+  char *yyd = yydest;
+  const char *yys = yysrc;
+
+  while ((*yyd++ = *yys++) != '\0')
+    continue;
+
+  return yyd - 1;
+}
+#  endif
+# endif
+
+# ifndef yytnamerr
+/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
+   quotes and backslashes, so that it's suitable for yyerror.  The
+   heuristic is that double-quoting is unnecessary unless the string
+   contains an apostrophe, a comma, or backslash (other than
+   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
+   null, do not copy; instead, return the length of what the result
+   would have been.  */
+static YYSIZE_T
+yytnamerr (char *yyres, const char *yystr)
+{
+  if (*yystr == '"')
+    {
+      YYSIZE_T yyn = 0;
+      char const *yyp = yystr;
+
+      for (;;)
+        switch (*++yyp)
+          {
+          case '\'':
+          case ',':
+            goto do_not_strip_quotes;
+
+          case '\\':
+            if (*++yyp != '\\')
+              goto do_not_strip_quotes;
+            /* Fall through.  */
+          default:
+            if (yyres)
+              yyres[yyn] = *yyp;
+            yyn++;
+            break;
+
+          case '"':
+            if (yyres)
+              yyres[yyn] = '\0';
+            return yyn;
+          }
+    do_not_strip_quotes: ;
+    }
+
+  if (! yyres)
+    return yystrlen (yystr);
+
+  return yystpcpy (yyres, yystr) - yyres;
+}
+# endif
+
+/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
+   about the unexpected token YYTOKEN for the state stack whose top is
+   YYSSP.
+
+   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
+   not large enough to hold the message.  In that case, also set
+   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
+   required number of bytes is too large to store.  */
+static int
+yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
+                yytype_int16 *yyssp, int yytoken)
+{
+  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
+  YYSIZE_T yysize = yysize0;
+  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
+  /* Internationalized format string. */
+  const char *yyformat = YY_NULLPTR;
+  /* Arguments of yyformat. */
+  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
+  /* Number of reported tokens (one for the "unexpected", one per
+     "expected"). */
+  int yycount = 0;
+
+  /* There are many possibilities here to consider:
+     - If this state is a consistent state with a default action, then
+       the only way this function was invoked is if the default action
+       is an error action.  In that case, don't check for expected
+       tokens because there are none.
+     - The only way there can be no lookahead present (in yychar) is if
+       this state is a consistent state with a default action.  Thus,
+       detecting the absence of a lookahead is sufficient to determine
+       that there is no unexpected or expected token to report.  In that
+       case, just report a simple "syntax error".
+     - Don't assume there isn't a lookahead just because this state is a
+       consistent state with a default action.  There might have been a
+       previous inconsistent state, consistent state with a non-default
+       action, or user semantic action that manipulated yychar.
+     - Of course, the expected token list depends on states to have
+       correct lookahead information, and it depends on the parser not
+       to perform extra reductions after fetching a lookahead from the
+       scanner and before detecting a syntax error.  Thus, state merging
+       (from LALR or IELR) and default reductions corrupt the expected
+       token list.  However, the list is correct for canonical LR with
+       one exception: it will still contain any token that will not be
+       accepted due to an error action in a later state.
+  */
+  if (yytoken != YYEMPTY)
+    {
+      int yyn = yypact[*yyssp];
+      yyarg[yycount++] = yytname[yytoken];
+      if (!yypact_value_is_default (yyn))
+        {
+          /* Start YYX at -YYN if negative to avoid negative indexes in
+             YYCHECK.  In other words, skip the first -YYN actions for
+             this state because they are default actions.  */
+          int yyxbegin = yyn < 0 ? -yyn : 0;
+          /* Stay within bounds of both yycheck and yytname.  */
+          int yychecklim = YYLAST - yyn + 1;
+          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
+          int yyx;
+
+          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
+            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
+                && !yytable_value_is_error (yytable[yyx + yyn]))
+              {
+                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
+                  {
+                    yycount = 1;
+                    yysize = yysize0;
+                    break;
+                  }
+                yyarg[yycount++] = yytname[yyx];
+                {
+                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
+                  if (! (yysize <= yysize1
+                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
+                    return 2;
+                  yysize = yysize1;
+                }
+              }
+        }
+    }
+
+  switch (yycount)
+    {
+# define YYCASE_(N, S)                      \
+      case N:                               \
+        yyformat = S;                       \
+      break
+      YYCASE_(0, YY_("syntax error"));
+      YYCASE_(1, YY_("syntax error, unexpected %s"));
+      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
+      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
+      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
+      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
+# undef YYCASE_
+    }
+
+  {
+    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
+    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
+      return 2;
+    yysize = yysize1;
+  }
+
+  if (*yymsg_alloc < yysize)
+    {
+      *yymsg_alloc = 2 * yysize;
+      if (! (yysize <= *yymsg_alloc
+             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
+        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
+      return 1;
+    }
+
+  /* Avoid sprintf, as that infringes on the user's name space.
+     Don't have undefined behavior even if the translation
+     produced a string with the wrong number of "%s"s.  */
+  {
+    char *yyp = *yymsg;
+    int yyi = 0;
+    while ((*yyp = *yyformat) != '\0')
+      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
+        {
+          yyp += yytnamerr (yyp, yyarg[yyi++]);
+          yyformat += 2;
+        }
+      else
+        {
+          yyp++;
+          yyformat++;
+        }
+  }
+  return 0;
+}
+#endif /* YYERROR_VERBOSE */
+
+/*-----------------------------------------------.
+| Release the memory associated to this symbol.  |
+`-----------------------------------------------*/
+
+static void
+yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parseObj *p)
+{
+  YYUSE (yyvaluep);
+  YYUSE (p);
+  if (!yymsg)
+    yymsg = "Deleting";
+  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);
+
+  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
+  YYUSE (yytype);
+  YY_IGNORE_MAYBE_UNINITIALIZED_END
+}
+
+
+
+
+/*----------.
+| yyparse.  |
+`----------*/
+
+int
+yyparse (parseObj *p)
+{
+/* The lookahead symbol.  */
+int yychar;
+
+
+/* The semantic value of the lookahead symbol.  */
+/* Default value used for initialization, for pacifying older GCCs
+   or non-GCC compilers.  */
+YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
+YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);
+
+    /* Number of syntax errors so far.  */
+    int yynerrs;
+
+    int yystate;
+    /* Number of tokens to shift before error messages enabled.  */
+    int yyerrstatus;
+
+    /* The stacks and their tools:
+       'yyss': related to states.
+       'yyvs': related to semantic values.
+
+       Refer to the stacks through separate pointers, to allow yyoverflow
+       to reallocate them elsewhere.  */
+
+    /* The state stack.  */
+    yytype_int16 yyssa[YYINITDEPTH];
+    yytype_int16 *yyss;
+    yytype_int16 *yyssp;
+
+    /* The semantic value stack.  */
+    YYSTYPE yyvsa[YYINITDEPTH];
+    YYSTYPE *yyvs;
+    YYSTYPE *yyvsp;
+
+    YYSIZE_T yystacksize;
+
+  int yyn;
+  int yyresult;
+  /* Lookahead token as an internal (translated) token number.  */
+  int yytoken = 0;
+  /* The variables used to return semantic value and location from the
+     action routines.  */
+  YYSTYPE yyval;
+
+#if YYERROR_VERBOSE
+  /* Buffer for error messages, and its allocated size.  */
+  char yymsgbuf[128];
+  char *yymsg = yymsgbuf;
+  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
+#endif
+
+#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))
+
+  /* The number of symbols on the RHS of the reduced rule.
+     Keep to zero when no symbol should be popped.  */
+  int yylen = 0;
+
+  yyssp = yyss = yyssa;
+  yyvsp = yyvs = yyvsa;
+  yystacksize = YYINITDEPTH;
+
+  YYDPRINTF ((stderr, "Starting parse\n"));
+
+  yystate = 0;
+  yyerrstatus = 0;
+  yynerrs = 0;
+  yychar = YYEMPTY; /* Cause a token to be read.  */
+  goto yysetstate;
+
+/*------------------------------------------------------------.
+| yynewstate -- Push a new state, which is found in yystate.  |
+`------------------------------------------------------------*/
+ yynewstate:
+  /* In all cases, when you get here, the value and location stacks
+     have just been pushed.  So pushing a state here evens the stacks.  */
+  yyssp++;
+
+ yysetstate:
+  *yyssp = yystate;
+
+  if (yyss + yystacksize - 1 <= yyssp)
+    {
+      /* Get the current used size of the three stacks, in elements.  */
+      YYSIZE_T yysize = yyssp - yyss + 1;
+
+#ifdef yyoverflow
+      {
+        /* Give user a chance to reallocate the stack.  Use copies of
+           these so that the &'s don't force the real ones into
+           memory.  */
+        YYSTYPE *yyvs1 = yyvs;
+        yytype_int16 *yyss1 = yyss;
+
+        /* Each stack pointer address is followed by the size of the
+           data in use in that stack, in bytes.  This used to be a
+           conditional around just the two extra args, but that might
+           be undefined if yyoverflow is a macro.  */
+        yyoverflow (YY_("memory exhausted"),
+                    &yyss1, yysize * sizeof (*yyssp),
+                    &yyvs1, yysize * sizeof (*yyvsp),
+                    &yystacksize);
+
+        yyss = yyss1;
+        yyvs = yyvs1;
+      }
+#else /* no yyoverflow */
+# ifndef YYSTACK_RELOCATE
+      goto yyexhaustedlab;
+# else
+      /* Extend the stack our own way.  */
+      if (YYMAXDEPTH <= yystacksize)
+        goto yyexhaustedlab;
+      yystacksize *= 2;
+      if (YYMAXDEPTH < yystacksize)
+        yystacksize = YYMAXDEPTH;
+
+      {
+        yytype_int16 *yyss1 = yyss;
+        union yyalloc *yyptr =
+          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
+        if (! yyptr)
+          goto yyexhaustedlab;
+        YYSTACK_RELOCATE (yyss_alloc, yyss);
+        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
+#  undef YYSTACK_RELOCATE
+        if (yyss1 != yyssa)
+          YYSTACK_FREE (yyss1);
+      }
+# endif
+#endif /* no yyoverflow */
+
+      yyssp = yyss + yysize - 1;
+      yyvsp = yyvs + yysize - 1;
+
+      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
+                  (unsigned long int) yystacksize));
+
+      if (yyss + yystacksize - 1 <= yyssp)
+        YYABORT;
+    }
+
+  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
+
+  if (yystate == YYFINAL)
+    YYACCEPT;
+
+  goto yybackup;
+
+/*-----------.
+| yybackup.  |
+`-----------*/
+yybackup:
+
+  /* Do appropriate processing given the current state.  Read a
+     lookahead token if we need one and don't already have one.  */
+
+  /* First try to decide what to do without reference to lookahead token.  */
+  yyn = yypact[yystate];
+  if (yypact_value_is_default (yyn))
+    goto yydefault;
+
+  /* Not known => get a lookahead token if don't already have one.  */
+
+  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
+  if (yychar == YYEMPTY)
+    {
+      YYDPRINTF ((stderr, "Reading a token: "));
+      yychar = yylex (&yylval, p);
+    }
+
+  if (yychar <= YYEOF)
+    {
+      yychar = yytoken = YYEOF;
+      YYDPRINTF ((stderr, "Now at end of input.\n"));
+    }
+  else
+    {
+      yytoken = YYTRANSLATE (yychar);
+      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
+    }
+
+  /* If the proper action on seeing token YYTOKEN is to reduce or to
+     detect an error, take that action.  */
+  yyn += yytoken;
+  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
+    goto yydefault;
+  yyn = yytable[yyn];
+  if (yyn <= 0)
+    {
+      if (yytable_value_is_error (yyn))
+        goto yyerrlab;
+      yyn = -yyn;
+      goto yyreduce;
+    }
+
+  /* Count tokens shifted since error; after three, turn off error
+     status.  */
+  if (yyerrstatus)
+    yyerrstatus--;
+
+  /* Shift the lookahead token.  */
+  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
+
+  /* Discard the shifted token.  */
+  yychar = YYEMPTY;
+
+  yystate = yyn;
+  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
+  *++yyvsp = yylval;
+  YY_IGNORE_MAYBE_UNINITIALIZED_END
+
+  goto yynewstate;
+
+
+/*-----------------------------------------------------------.
+| yydefault -- do the default action for the current state.  |
+`-----------------------------------------------------------*/
+yydefault:
+  yyn = yydefact[yystate];
+  if (yyn == 0)
+    goto yyerrlab;
+  goto yyreduce;
+
+
+/*-----------------------------.
+| yyreduce -- Do a reduction.  |
+`-----------------------------*/
+yyreduce:
+  /* yyn is the number of a rule to reduce with.  */
+  yylen = yyr2[yyn];
+
+  /* If YYLEN is nonzero, implement the default value of the action:
+     '$$ = $1'.
+
+     Otherwise, the following line sets YYVAL to garbage.
+     This behavior is undocumented and Bison
+     users should not rely upon it.  Assigning to YYVAL
+     unconditionally makes the parser a bit smaller, and it avoids a
+     GCC warning that YYVAL may be used uninitialized.  */
+  yyval = yyvsp[1-yylen];
+
+
+  YY_REDUCE_PRINT (yyn);
+  switch (yyn)
+    {
+        case 3:
+#line 69 "mapparser.y" /* yacc.c:1646  */
+    {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_BOOLEAN):
+      p->result.intval = (yyvsp[0].intval); 
+      break;
+    case(MS_PARSE_TYPE_STRING):
+      if((yyvsp[0].intval)) 
+        p->result.strval = msStrdup("true");
+      else
+        p->result.strval = msStrdup("false");
+      break;
+    }
+  }
+#line 1580 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 4:
+#line 82 "mapparser.y" /* yacc.c:1646  */
+    {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_BOOLEAN):
+      if((yyvsp[0].dblval) != 0)
+        p->result.intval = MS_TRUE;
+      else
+        p->result.intval = MS_FALSE;			    
+      break;
+    case(MS_PARSE_TYPE_STRING):
+      p->result.strval = (char *)malloc(64); /* large enough for a double */
+      snprintf(p->result.strval, 64, "%g", (yyvsp[0].dblval));
+      break;
+    }
+  }
+#line 1599 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 5:
+#line 96 "mapparser.y" /* yacc.c:1646  */
+    {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_BOOLEAN):
+      if((yyvsp[0].strval)) /* string is not NULL */
+        p->result.intval = MS_TRUE;
+      else
+        p->result.intval = MS_FALSE;
+      break;
+    case(MS_PARSE_TYPE_SLD):
+    case(MS_PARSE_TYPE_STRING):
+      p->result.strval = (yyvsp[0].strval); // msStrdup($1);
+      break;
+    }
+  }
+#line 1618 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 6:
+#line 110 "mapparser.y" /* yacc.c:1646  */
+    {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_SHAPE):
+      p->result.shpval = (yyvsp[0].shpval);
+      p->result.shpval->scratch = MS_FALSE;
+      break;
+    }
+  }
+#line 1631 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 8:
+#line 121 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.intval) = (yyvsp[-1].intval); }
+#line 1637 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 9:
+#line 122 "mapparser.y" /* yacc.c:1646  */
+    {
+    (yyval.intval) = MS_FALSE;
+    if((yyvsp[-2].intval) == (yyvsp[0].intval)) (yyval.intval) = MS_TRUE;
+  }
+#line 1646 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 10:
+#line 126 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].intval) == MS_TRUE)
+      (yyval.intval) = MS_TRUE;
+    else if((yyvsp[0].intval) == MS_TRUE)          
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1659 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 11:
+#line 134 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].intval) == MS_TRUE) {
+      if((yyvsp[0].intval) == MS_TRUE)
+        (yyval.intval) = MS_TRUE;
+      else
+        (yyval.intval) = MS_FALSE;
+    } else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1673 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 12:
+#line 143 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].intval) == MS_TRUE)
+      (yyval.intval) = MS_TRUE;
+    else if((yyvsp[0].dblval) != 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1686 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 13:
+#line 151 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].intval) == MS_TRUE) {
+      if((yyvsp[0].dblval) != 0)
+        (yyval.intval) = MS_TRUE;
+      else
+        (yyval.intval) = MS_FALSE;
+    } else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1700 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 14:
+#line 160 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) != 0)
+      (yyval.intval) = MS_TRUE;
+    else if((yyvsp[0].intval) == MS_TRUE)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1713 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 15:
+#line 168 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) != 0) {
+      if((yyvsp[0].intval) == MS_TRUE)
+        (yyval.intval) = MS_TRUE;
+      else
+        (yyval.intval) = MS_FALSE;
+    } else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1727 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 16:
+#line 177 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) != 0)
+      (yyval.intval) = MS_TRUE;
+    else if((yyvsp[0].dblval) != 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1740 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 17:
+#line 185 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) != 0) {
+      if((yyvsp[0].dblval) != 0)
+        (yyval.intval) = MS_TRUE;
+      else
+	(yyval.intval) = MS_FALSE;
+    } else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1754 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 18:
+#line 194 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.intval) = !(yyvsp[0].intval); }
+#line 1760 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 19:
+#line 195 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.intval) = !(yyvsp[0].dblval); }
+#line 1766 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 20:
+#line 196 "mapparser.y" /* yacc.c:1646  */
+    {
+    ms_regex_t re;
+
+    if(MS_STRING_IS_NULL_OR_EMPTY((yyvsp[-2].strval)) == MS_TRUE) {
+      (yyval.intval) = MS_FALSE;
+    } else {
+      if(ms_regcomp(&re, (yyvsp[0].strval), MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {      
+        (yyval.intval) = MS_FALSE;
+      } else {
+        if(ms_regexec(&re, (yyvsp[-2].strval), 0, NULL, 0) == 0)
+          (yyval.intval) = MS_TRUE;
+        else
+          (yyval.intval) = MS_FALSE;
+        ms_regfree(&re);
+      }
+    }
+
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1791 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 21:
+#line 216 "mapparser.y" /* yacc.c:1646  */
+    {
+    ms_regex_t re;
+
+    if(MS_STRING_IS_NULL_OR_EMPTY((yyvsp[-2].strval)) == MS_TRUE) {
+      (yyval.intval) = MS_FALSE;
+    } else {
+      if(ms_regcomp(&re, (yyvsp[0].strval), MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
+        (yyval.intval) = MS_FALSE;
+      } else {
+        if(ms_regexec(&re, (yyvsp[-2].strval), 0, NULL, 0) == 0)
+          (yyval.intval) = MS_TRUE;
+        else
+          (yyval.intval) = MS_FALSE;
+        ms_regfree(&re);
+      }
+    }
+
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1816 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 22:
+#line 236 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) == (yyvsp[0].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1827 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 23:
+#line 242 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) != (yyvsp[0].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1838 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 24:
+#line 248 "mapparser.y" /* yacc.c:1646  */
+    {    
+    if((yyvsp[-2].dblval) > (yyvsp[0].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1849 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 25:
+#line 254 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) < (yyvsp[0].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1860 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 26:
+#line 260 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) >= (yyvsp[0].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1871 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 27:
+#line 266 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) <= (yyvsp[0].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1882 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 28:
+#line 272 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) == 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1895 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 29:
+#line 280 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) != 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1908 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 30:
+#line 288 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) > 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1921 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 31:
+#line 296 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) < 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1934 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 32:
+#line 304 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) >= 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1947 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 33:
+#line 312 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(strcmp((yyvsp[-2].strval), (yyvsp[0].strval)) <= 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 1960 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 34:
+#line 320 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) == 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1971 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 35:
+#line 326 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) != 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1982 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 36:
+#line 332 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) > 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 1993 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 37:
+#line 338 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) < 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 2004 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 38:
+#line 344 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) >= 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 2015 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 39:
+#line 350 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) <= 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 2026 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 40:
+#line 356 "mapparser.y" /* yacc.c:1646  */
+    {
+    char *delim, *bufferp;
+
+    (yyval.intval) = MS_FALSE;
+    bufferp=(yyvsp[0].strval);
+
+    while((delim=strchr(bufferp,',')) != NULL) {
+      *delim='\0';
+      if(strcmp((yyvsp[-2].strval),bufferp) == 0) {
+        (yyval.intval) = MS_TRUE;
+        break;
+      } 
+      *delim=',';
+      bufferp=delim+1;
+    }
+
+    if((yyval.intval) == MS_FALSE && strcmp((yyvsp[-2].strval),bufferp) == 0) // test for last (or only) item
+      (yyval.intval) = MS_TRUE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 2052 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 41:
+#line 377 "mapparser.y" /* yacc.c:1646  */
+    {
+    char *delim,*bufferp;
+
+    (yyval.intval) = MS_FALSE;
+    bufferp=(yyvsp[0].strval);
+
+    while((delim=strchr(bufferp,',')) != NULL) {
+      *delim='\0';
+      if((yyvsp[-2].dblval) == atof(bufferp)) {
+        (yyval.intval) = MS_TRUE;
+        break;
+      } 
+      *delim=',';
+      bufferp=delim+1;
+    }
+
+    if((yyvsp[-2].dblval) == atof(bufferp)) // is this test necessary?
+      (yyval.intval) = MS_TRUE;  
+    free((yyvsp[0].strval));
+  }
+#line 2077 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 42:
+#line 397 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-2].dblval) == (yyvsp[0].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 2088 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 43:
+#line 403 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(strcasecmp((yyvsp[-2].strval), (yyvsp[0].strval)) == 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+    free((yyvsp[-2].strval));
+    free((yyvsp[0].strval));
+  }
+#line 2101 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 44:
+#line 411 "mapparser.y" /* yacc.c:1646  */
+    {
+    if(msTimeCompare(&((yyvsp[-2].tmval)), &((yyvsp[0].tmval))) == 0)
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 2112 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 45:
+#line 417 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSEquals((yyvsp[-2].shpval), (yyvsp[0].shpval));
+    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-2].shpval));
+      free((yyvsp[-2].shpval));
+    }
+    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[0].shpval));
+      free((yyvsp[0].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Equals (EQ or ==) operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2134 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 46:
+#line 434 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSEquals((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Equals function failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2156 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 47:
+#line 451 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSIntersects((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Intersects function failed.");
+      return(-1);
+    } else
+    (yyval.intval) = rval;
+  }
+#line 2178 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 48:
+#line 468 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSIntersects((yyvsp[-2].shpval), (yyvsp[0].shpval));
+    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-2].shpval));
+      free((yyvsp[-2].shpval));
+    }
+    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[0].shpval));
+      free((yyvsp[0].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Intersects operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2200 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 49:
+#line 485 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSDisjoint((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Disjoint function failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2222 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 50:
+#line 502 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSDisjoint((yyvsp[-2].shpval), (yyvsp[0].shpval));
+    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-2].shpval));
+      free((yyvsp[-2].shpval));
+    }
+    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[0].shpval));
+      free((yyvsp[0].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Disjoint operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2244 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 51:
+#line 519 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSTouches((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Touches function failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2266 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 52:
+#line 536 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSTouches((yyvsp[-2].shpval), (yyvsp[0].shpval));
+    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-2].shpval));
+      free((yyvsp[-2].shpval));
+    }
+    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[0].shpval));
+      free((yyvsp[0].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Touches operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2288 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 53:
+#line 553 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSOverlaps((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Overlaps function failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2310 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 54:
+#line 570 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+     rval = msGEOSOverlaps((yyvsp[-2].shpval), (yyvsp[0].shpval));
+     if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+       msFreeShape((yyvsp[-2].shpval));
+       free((yyvsp[-2].shpval));
+     }
+     if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+       msFreeShape((yyvsp[0].shpval));
+       free((yyvsp[0].shpval));
+     }
+    if(rval == -1) {
+      yyerror(p, "Overlaps operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2332 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 55:
+#line 587 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSCrosses((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Crosses function failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2354 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 56:
+#line 604 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSCrosses((yyvsp[-2].shpval), (yyvsp[0].shpval));
+    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-2].shpval));
+      free((yyvsp[-2].shpval));
+    }
+    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[0].shpval));
+      free((yyvsp[0].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Crosses operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2376 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 57:
+#line 621 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSWithin((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Within function failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2398 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 58:
+#line 638 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSWithin((yyvsp[-2].shpval), (yyvsp[0].shpval));
+    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-2].shpval));
+      free((yyvsp[-2].shpval));
+    }
+    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[0].shpval));
+      free((yyvsp[0].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Within operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2420 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 59:
+#line 655 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSContains((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Contains function failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2442 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 60:
+#line 672 "mapparser.y" /* yacc.c:1646  */
+    {
+    int rval;
+    rval = msGEOSContains((yyvsp[-2].shpval), (yyvsp[0].shpval));
+    if((yyvsp[-2].shpval) && (yyvsp[-2].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-2].shpval));
+      free((yyvsp[-2].shpval));
+    }
+    if((yyvsp[0].shpval) && (yyvsp[0].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[0].shpval));
+      free((yyvsp[0].shpval));
+    }
+    if(rval == -1) {
+      yyerror(p, "Contains operator failed.");
+      return(-1);
+    } else
+      (yyval.intval) = rval;
+  }
+#line 2464 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 61:
+#line 689 "mapparser.y" /* yacc.c:1646  */
+    {
+    double d;
+    d = msGEOSDistance((yyvsp[-5].shpval), (yyvsp[-3].shpval));
+    if((yyvsp[-5].shpval) && (yyvsp[-5].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-5].shpval));
+      free((yyvsp[-5].shpval));
+    }
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(d <= (yyvsp[-1].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 2485 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 62:
+#line 705 "mapparser.y" /* yacc.c:1646  */
+    {
+    double d;
+    d = msGEOSDistance((yyvsp[-5].shpval), (yyvsp[-3].shpval));
+    if((yyvsp[-5].shpval) && (yyvsp[-5].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-5].shpval));
+      free((yyvsp[-5].shpval));
+    }
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(d > (yyvsp[-1].dblval))
+      (yyval.intval) = MS_TRUE;
+    else
+      (yyval.intval) = MS_FALSE;
+  }
+#line 2506 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 64:
+#line 724 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (yyvsp[-1].dblval); }
+#line 2512 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 65:
+#line 725 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (yyvsp[-2].dblval) + (yyvsp[0].dblval); }
+#line 2518 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 66:
+#line 726 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (yyvsp[-2].dblval) - (yyvsp[0].dblval); }
+#line 2524 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 67:
+#line 727 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (yyvsp[-2].dblval) * (yyvsp[0].dblval); }
+#line 2530 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 68:
+#line 728 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (int)(yyvsp[-2].dblval) % (int)(yyvsp[0].dblval); }
+#line 2536 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 69:
+#line 729 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[0].dblval) == 0.0) {
+      yyerror(p, "Division by zero.");
+      return(-1);
+    } else
+      (yyval.dblval) = (yyvsp[-2].dblval) / (yyvsp[0].dblval); 
+  }
+#line 2548 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 70:
+#line 736 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (yyvsp[0].dblval); }
+#line 2554 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 71:
+#line 737 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = pow((yyvsp[-2].dblval), (yyvsp[0].dblval)); }
+#line 2560 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 72:
+#line 738 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = strlen((yyvsp[-1].strval)); }
+#line 2566 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 73:
+#line 739 "mapparser.y" /* yacc.c:1646  */
+    {
+    if((yyvsp[-1].shpval)->type != MS_SHAPE_POLYGON) {
+      yyerror(p, "Area can only be computed for polygon shapes.");
+      return(-1);
+    }
+    (yyval.dblval) = msGetPolygonArea((yyvsp[-1].shpval));
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+  }
+#line 2582 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 74:
+#line 750 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (MS_NINT((yyvsp[-3].dblval)/(yyvsp[-1].dblval)))*(yyvsp[-1].dblval); }
+#line 2588 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 75:
+#line 751 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.dblval) = (MS_NINT((yyvsp[-1].dblval))); }
+#line 2594 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 77:
+#line 755 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.shpval) = (yyvsp[-1].shpval); }
+#line 2600 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 78:
+#line 756 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msGEOSBuffer((yyvsp[-3].shpval), (yyvsp[-1].dblval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing buffer failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2619 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 79:
+#line 770 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msRings2Shape((yyvsp[-1].shpval), MS_FALSE);
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing inner failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2638 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 80:
+#line 784 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msRings2Shape((yyvsp[-1].shpval), MS_TRUE);
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing outer failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2657 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 81:
+#line 798 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msGEOSCenterline((yyvsp[-1].shpval));
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing centerline failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2676 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 82:
+#line 812 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msGEOSDifference((yyvsp[-3].shpval), (yyvsp[-1].shpval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing difference failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2695 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 83:
+#line 826 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msDensify((yyvsp[-3].shpval), (yyvsp[-1].dblval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing densify failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2714 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 84:
+#line 840 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msGEOSSimplify((yyvsp[-3].shpval), (yyvsp[-1].dblval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing simplify failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2733 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 85:
+#line 854 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msGEOSTopologyPreservingSimplify((yyvsp[-3].shpval), (yyvsp[-1].dblval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing simplifypt failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2752 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 86:
+#line 868 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msGeneralize((yyvsp[-3].shpval), (yyvsp[-1].dblval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing generalize failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2771 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 87:
+#line 882 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msSmoothShapeSIA((yyvsp[-1].shpval), 3, 1, NULL);
+    if((yyvsp[-1].shpval) && (yyvsp[-1].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-1].shpval));
+      free((yyvsp[-1].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2790 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 88:
+#line 896 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msSmoothShapeSIA((yyvsp[-3].shpval), (yyvsp[-1].dblval), 1, NULL);
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2809 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 89:
+#line 910 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msSmoothShapeSIA((yyvsp[-5].shpval), (yyvsp[-3].dblval), (yyvsp[-1].dblval), NULL);
+    if((yyvsp[-5].shpval) && (yyvsp[-5].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-5].shpval));
+      free((yyvsp[-5].shpval));
+    }
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2828 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 90:
+#line 924 "mapparser.y" /* yacc.c:1646  */
+    {
+    shapeObj *s;
+    s = msSmoothShapeSIA((yyvsp[-7].shpval), (yyvsp[-5].dblval), (yyvsp[-3].dblval), (yyvsp[-1].strval));
+    if((yyvsp[-7].shpval) && (yyvsp[-7].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-7].shpval));
+      free((yyvsp[-7].shpval));
+    }
+    free((yyvsp[-1].strval));
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+  }
+#line 2848 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 91:
+#line 939 "mapparser.y" /* yacc.c:1646  */
+    {
+#ifdef USE_V8_MAPSCRIPT
+    shapeObj *s;
+    s = msV8TransformShape((yyvsp[-3].shpval), (yyvsp[-1].strval));
+    if((yyvsp[-3].shpval) && (yyvsp[-3].shpval)->scratch == MS_TRUE) {
+      msFreeShape((yyvsp[-3].shpval));
+      free((yyvsp[-3].shpval));
+    }
+    free((yyvsp[-1].strval));
+    if(!s) {
+      yyerror(p, "Executing javascript failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    (yyval.shpval) = s;
+#else
+    yyerror(p, "Javascript support not compiled in");
+    return(-1);
+#endif
+  }
+#line 2873 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 93:
+#line 962 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.strval) = (yyvsp[-1].strval); }
+#line 2879 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 94:
+#line 963 "mapparser.y" /* yacc.c:1646  */
+    { 
+    (yyval.strval) = (char *)malloc(strlen((yyvsp[-2].strval)) + strlen((yyvsp[0].strval)) + 1);
+    sprintf((yyval.strval), "%s%s", (yyvsp[-2].strval), (yyvsp[0].strval)); free((yyvsp[-2].strval)); free((yyvsp[0].strval)); 
+  }
+#line 2888 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 95:
+#line 967 "mapparser.y" /* yacc.c:1646  */
+    {
+    (yyval.strval) = (char *) malloc(strlen((yyvsp[-1].strval)) + 64); /* Plenty big? Should use snprintf below... */
+    sprintf((yyval.strval), (yyvsp[-1].strval), (yyvsp[-3].dblval));
+    free((yyvsp[-1].strval));
+  }
+#line 2898 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 96:
+#line 972 "mapparser.y" /* yacc.c:1646  */
+    {  
+    (yyvsp[-1].strval) = msCommifyString((yyvsp[-1].strval)); 
+    (yyval.strval) = (yyvsp[-1].strval); 
+  }
+#line 2907 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 97:
+#line 976 "mapparser.y" /* yacc.c:1646  */
+    {  
+    msStringToUpper((yyvsp[-1].strval)); 
+    (yyval.strval) = (yyvsp[-1].strval); 
+  }
+#line 2916 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 98:
+#line 980 "mapparser.y" /* yacc.c:1646  */
+    {  
+    msStringToLower((yyvsp[-1].strval)); 
+    (yyval.strval) = (yyvsp[-1].strval); 
+  }
+#line 2925 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 99:
+#line 984 "mapparser.y" /* yacc.c:1646  */
+    {  
+    msStringInitCap((yyvsp[-1].strval)); 
+    (yyval.strval) = (yyvsp[-1].strval); 
+  }
+#line 2934 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 100:
+#line 988 "mapparser.y" /* yacc.c:1646  */
+    {  
+    msStringFirstCap((yyvsp[-1].strval)); 
+    (yyval.strval) = (yyvsp[-1].strval); 
+  }
+#line 2943 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+  case 102:
+#line 995 "mapparser.y" /* yacc.c:1646  */
+    { (yyval.tmval) = (yyvsp[-1].tmval); }
+#line 2949 "/vagrant/mapparser.c" /* yacc.c:1646  */
+    break;
+
+
+#line 2953 "/vagrant/mapparser.c" /* yacc.c:1646  */
+      default: break;
+    }
+  /* User semantic actions sometimes alter yychar, and that requires
+     that yytoken be updated with the new translation.  We take the
+     approach of translating immediately before every use of yytoken.
+     One alternative is translating here after every semantic action,
+     but that translation would be missed if the semantic action invokes
+     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
+     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
+     incorrect destructor might then be invoked immediately.  In the
+     case of YYERROR or YYBACKUP, subsequent parser actions might lead
+     to an incorrect destructor call or verbose syntax error message
+     before the lookahead is translated.  */
+  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);
+
+  YYPOPSTACK (yylen);
+  yylen = 0;
+  YY_STACK_PRINT (yyss, yyssp);
+
+  *++yyvsp = yyval;
+
+  /* Now 'shift' the result of the reduction.  Determine what state
+     that goes to, based on the state we popped back to and the rule
+     number reduced by.  */
+
+  yyn = yyr1[yyn];
+
+  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
+  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
+    yystate = yytable[yystate];
+  else
+    yystate = yydefgoto[yyn - YYNTOKENS];
+
+  goto yynewstate;
+
+
+/*--------------------------------------.
+| yyerrlab -- here on detecting error.  |
+`--------------------------------------*/
+yyerrlab:
+  /* Make sure we have latest lookahead translation.  See comments at
+     user semantic actions for why this is necessary.  */
+  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);
+
+  /* If not already recovering from an error, report this error.  */
+  if (!yyerrstatus)
+    {
+      ++yynerrs;
+#if ! YYERROR_VERBOSE
+      yyerror (p, YY_("syntax error"));
+#else
+# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
+                                        yyssp, yytoken)
+      {
+        char const *yymsgp = YY_("syntax error");
+        int yysyntax_error_status;
+        yysyntax_error_status = YYSYNTAX_ERROR;
+        if (yysyntax_error_status == 0)
+          yymsgp = yymsg;
+        else if (yysyntax_error_status == 1)
+          {
+            if (yymsg != yymsgbuf)
+              YYSTACK_FREE (yymsg);
+            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
+            if (!yymsg)
+              {
+                yymsg = yymsgbuf;
+                yymsg_alloc = sizeof yymsgbuf;
+                yysyntax_error_status = 2;
+              }
+            else
+              {
+                yysyntax_error_status = YYSYNTAX_ERROR;
+                yymsgp = yymsg;
+              }
+          }
+        yyerror (p, yymsgp);
+        if (yysyntax_error_status == 2)
+          goto yyexhaustedlab;
+      }
+# undef YYSYNTAX_ERROR
+#endif
+    }
+
+
+
+  if (yyerrstatus == 3)
+    {
+      /* If just tried and failed to reuse lookahead token after an
+         error, discard it.  */
+
+      if (yychar <= YYEOF)
+        {
+          /* Return failure if at end of input.  */
+          if (yychar == YYEOF)
+            YYABORT;
+        }
+      else
+        {
+          yydestruct ("Error: discarding",
+                      yytoken, &yylval, p);
+          yychar = YYEMPTY;
+        }
+    }
+
+  /* Else will try to reuse lookahead token after shifting the error
+     token.  */
+  goto yyerrlab1;
+
+
+/*---------------------------------------------------.
+| yyerrorlab -- error raised explicitly by YYERROR.  |
+`---------------------------------------------------*/
+yyerrorlab:
+
+  /* Pacify compilers like GCC when the user code never invokes
+     YYERROR and the label yyerrorlab therefore never appears in user
+     code.  */
+  if (/*CONSTCOND*/ 0)
+     goto yyerrorlab;
+
+  /* Do not reclaim the symbols of the rule whose action triggered
+     this YYERROR.  */
+  YYPOPSTACK (yylen);
+  yylen = 0;
+  YY_STACK_PRINT (yyss, yyssp);
+  yystate = *yyssp;
+  goto yyerrlab1;
+
+
+/*-------------------------------------------------------------.
+| yyerrlab1 -- common code for both syntax error and YYERROR.  |
+`-------------------------------------------------------------*/
+yyerrlab1:
+  yyerrstatus = 3;      /* Each real token shifted decrements this.  */
+
+  for (;;)
+    {
+      yyn = yypact[yystate];
+      if (!yypact_value_is_default (yyn))
+        {
+          yyn += YYTERROR;
+          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
+            {
+              yyn = yytable[yyn];
+              if (0 < yyn)
+                break;
+            }
+        }
+
+      /* Pop the current state because it cannot handle the error token.  */
+      if (yyssp == yyss)
+        YYABORT;
+
+
+      yydestruct ("Error: popping",
+                  yystos[yystate], yyvsp, p);
+      YYPOPSTACK (1);
+      yystate = *yyssp;
+      YY_STACK_PRINT (yyss, yyssp);
+    }
+
+  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
+  *++yyvsp = yylval;
+  YY_IGNORE_MAYBE_UNINITIALIZED_END
+
+
+  /* Shift the error token.  */
+  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);
+
+  yystate = yyn;
+  goto yynewstate;
+
+
+/*-------------------------------------.
+| yyacceptlab -- YYACCEPT comes here.  |
+`-------------------------------------*/
+yyacceptlab:
+  yyresult = 0;
+  goto yyreturn;
+
+/*-----------------------------------.
+| yyabortlab -- YYABORT comes here.  |
+`-----------------------------------*/
+yyabortlab:
+  yyresult = 1;
+  goto yyreturn;
+
+#if !defined yyoverflow || YYERROR_VERBOSE
+/*-------------------------------------------------.
+| yyexhaustedlab -- memory exhaustion comes here.  |
+`-------------------------------------------------*/
+yyexhaustedlab:
+  yyerror (p, YY_("memory exhausted"));
+  yyresult = 2;
+  /* Fall through.  */
+#endif
+
+yyreturn:
+  if (yychar != YYEMPTY)
+    {
+      /* Make sure we have latest lookahead translation.  See comments at
+         user semantic actions for why this is necessary.  */
+      yytoken = YYTRANSLATE (yychar);
+      yydestruct ("Cleanup: discarding lookahead",
+                  yytoken, &yylval, p);
+    }
+  /* Do not reclaim the symbols of the rule whose action triggered
+     this YYABORT or YYACCEPT.  */
+  YYPOPSTACK (yylen);
+  YY_STACK_PRINT (yyss, yyssp);
+  while (yyssp != yyss)
+    {
+      yydestruct ("Cleanup: popping",
+                  yystos[*yyssp], yyvsp, p);
+      YYPOPSTACK (1);
+    }
+#ifndef yyoverflow
+  if (yyss != yyssa)
+    YYSTACK_FREE (yyss);
+#endif
+#if YYERROR_VERBOSE
+  if (yymsg != yymsgbuf)
+    YYSTACK_FREE (yymsg);
+#endif
+  return yyresult;
+}
+#line 998 "mapparser.y" /* yacc.c:1906  */
+
+
+/*
+** Any extra C functions
+*/
+
+int yylex(YYSTYPE *lvalp, parseObj *p) 
+{
+  int token;
+  
+  if(p->expr->curtoken == NULL) return(0); /* done */
+
+  // fprintf(stderr, "in yylex() - curtoken=%d...\n", p->expr->curtoken->token);
+
+  token = p->expr->curtoken->token; /* may override */
+  switch(p->expr->curtoken->token) {
+  case MS_TOKEN_LITERAL_BOOLEAN:
+    token = BOOLEAN;
+    (*lvalp).intval = p->expr->curtoken->tokenval.dblval;
+    break;
+  case MS_TOKEN_LITERAL_NUMBER:
+    token = NUMBER;
+    (*lvalp).dblval = p->expr->curtoken->tokenval.dblval;
+    break;
+  case MS_TOKEN_LITERAL_SHAPE:
+    token = SHAPE;
+    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->expr->curtoken->tokenval.shpval));
+    (*lvalp).shpval = p->expr->curtoken->tokenval.shpval;
+    break;
+  case MS_TOKEN_LITERAL_STRING:
+    // printf("token value = %s\n", p->expr->curtoken->tokenval.strval); 
+    if (p->type == MS_PARSE_TYPE_SLD)
+    {
+      token = STRING;
+      if (*(p->expr->curtoken->tokenval.strval))
+      {
+        (*lvalp).strval = msStrdup("<![CDATA[");
+        (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.strval);
+        (*lvalp).strval = msStringConcatenate((*lvalp).strval,"]]>\n");
+      }
+      else
+      {
+        (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);
+      }
+    }
+    else
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);    
+    }
+    break;
+  case MS_TOKEN_LITERAL_TIME:
+    token = TIME;
+    (*lvalp).tmval = p->expr->curtoken->tokenval.tmval;
+    break;
+
+  case MS_TOKEN_COMPARISON_EQ: token = EQ; break;
+  case MS_TOKEN_COMPARISON_IEQ: token = IEQ; break;
+  case MS_TOKEN_COMPARISON_NE: token = NE; break;
+  case MS_TOKEN_COMPARISON_LT: token = LT; break;
+  case MS_TOKEN_COMPARISON_GT: token = GT; break;
+  case MS_TOKEN_COMPARISON_LE: token = LE; break;
+  case MS_TOKEN_COMPARISON_GE: token = GE; break;
+  case MS_TOKEN_COMPARISON_RE: token = RE; break;
+  case MS_TOKEN_COMPARISON_IRE: token = IRE; break;
+
+  case MS_TOKEN_COMPARISON_IN: token = IN; break;
+
+  case MS_TOKEN_COMPARISON_INTERSECTS: token = INTERSECTS; break;
+  case MS_TOKEN_COMPARISON_DISJOINT: token = DISJOINT; break;
+  case MS_TOKEN_COMPARISON_TOUCHES: token = TOUCHES; break;
+  case MS_TOKEN_COMPARISON_OVERLAPS: token = OVERLAPS; break; 
+  case MS_TOKEN_COMPARISON_CROSSES: token = CROSSES; break;
+  case MS_TOKEN_COMPARISON_WITHIN: token = WITHIN; break; 
+  case MS_TOKEN_COMPARISON_CONTAINS: token = CONTAINS; break;
+  case MS_TOKEN_COMPARISON_EQUALS: token = EQUALS; break;
+  case MS_TOKEN_COMPARISON_BEYOND: token = BEYOND; break;
+  case MS_TOKEN_COMPARISON_DWITHIN: token = DWITHIN; break;
+
+  case MS_TOKEN_LOGICAL_AND: token = AND; break;
+  case MS_TOKEN_LOGICAL_OR: token = OR; break;
+  case MS_TOKEN_LOGICAL_NOT: token = NOT; break;
+
+  case MS_TOKEN_BINDING_DOUBLE:
+  case MS_TOKEN_BINDING_INTEGER:
+    if (p->type == MS_PARSE_TYPE_SLD)
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
+    }
+    else
+    {
+      token = NUMBER;
+      (*lvalp).dblval = atof(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
+    }
+    break;
+  case MS_TOKEN_BINDING_STRING:
+    if (p->type == MS_PARSE_TYPE_SLD)
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
+    }
+    else
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
+    }
+    break;
+  case MS_TOKEN_BINDING_SHAPE:
+    token = SHAPE;
+    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->shape));
+    (*lvalp).shpval = p->shape;
+    break;
+  case MS_TOKEN_BINDING_MAP_CELLSIZE:
+    token = NUMBER;
+    (*lvalp).dblval = p->dblval;
+    break;
+  case MS_TOKEN_BINDING_DATA_CELLSIZE:
+    token = NUMBER;
+    (*lvalp).dblval = p->dblval2;
+    break;    
+  case MS_TOKEN_BINDING_TIME:
+    token = TIME;
+    msTimeInit(&((*lvalp).tmval));
+    if(msParseTime(p->shape->values[p->expr->curtoken->tokenval.bindval.index], &((*lvalp).tmval)) != MS_TRUE) {
+      yyerror(p, "Parsing time value failed.");
+      return(-1);
+    }
+    break;
+
+  case MS_TOKEN_FUNCTION_AREA: token = AREA; break;
+  case MS_TOKEN_FUNCTION_LENGTH: token = LENGTH; break;
+  case MS_TOKEN_FUNCTION_TOSTRING: token = TOSTRING; break;
+  case MS_TOKEN_FUNCTION_COMMIFY: token = COMMIFY; break;
+  case MS_TOKEN_FUNCTION_UPPER: token = UPPER; break;
+  case MS_TOKEN_FUNCTION_LOWER: token = LOWER; break;
+  case MS_TOKEN_FUNCTION_INITCAP: token = INITCAP; break;
+  case MS_TOKEN_FUNCTION_FIRSTCAP: token = FIRSTCAP; break;
+  case MS_TOKEN_FUNCTION_ROUND: token = ROUND; break;
+
+  case MS_TOKEN_FUNCTION_BUFFER: token = YYBUFFER; break;
+  case MS_TOKEN_FUNCTION_DIFFERENCE: token = DIFFERENCE; break;
+  case MS_TOKEN_FUNCTION_SIMPLIFY: token = SIMPLIFY; break;
+  case MS_TOKEN_FUNCTION_SIMPLIFYPT: token = SIMPLIFYPT; break;
+  case MS_TOKEN_FUNCTION_GENERALIZE: token = GENERALIZE; break;
+  case MS_TOKEN_FUNCTION_SMOOTHSIA: token = SMOOTHSIA; break;
+  case MS_TOKEN_FUNCTION_CENTERLINE: token = CENTERLINE; break;
+  case MS_TOKEN_FUNCTION_DENSIFY: token = DENSIFY; break;
+  case MS_TOKEN_FUNCTION_INNER: token = INNER; break;
+  case MS_TOKEN_FUNCTION_OUTER: token = OUTER; break;
+  case MS_TOKEN_FUNCTION_JAVASCRIPT: token = JAVASCRIPT; break;
+
+  default:
+    break;
+  }
+
+  p->expr->curtoken = p->expr->curtoken->next; /* re-position */ 
+  return(token);
+}
+
+int yyerror(parseObj *p, const char *s) {
+  (void)p;
+  msSetError(MS_PARSEERR, "%s", "yyparse()", s);
+  return(0);
+}
diff -pruN 8.0.1-5/src/mapparser.h 8.2.0~beta1-1~exp1/src/mapparser.h
--- 8.0.1-5/src/mapparser.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapparser.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,175 @@
+/* A Bison parser, made by GNU Bison 3.0.4.  */
+
+/* Bison interface for Yacc-like parsers in C
+
+   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.
+
+   This program is free software: you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation, either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+/* As a special exception, you may create a larger work that contains
+   part or all of the Bison parser skeleton and distribute that work
+   under terms of your choice, so long as that work isn't itself a
+   parser generator using the skeleton or a modified version thereof
+   as a parser skeleton.  Alternatively, if you modify or redistribute
+   the parser skeleton itself, you may (at your option) remove this
+   special exception, which will cause the skeleton and the resulting
+   Bison output files to be licensed under the GNU General Public
+   License without this special exception.
+
+   This special exception was added by the Free Software Foundation in
+   version 2.2 of Bison.  */
+
+#ifndef YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
+# define YY_YY_VAGRANT_MAPPARSER_H_INCLUDED
+/* Debug traces.  */
+#ifndef YYDEBUG
+# define YYDEBUG 0
+#endif
+#if YYDEBUG
+extern int yydebug;
+#endif
+
+/* Token type.  */
+#ifndef YYTOKENTYPE
+# define YYTOKENTYPE
+  enum yytokentype
+  {
+    BOOLEAN = 258,
+    NUMBER = 259,
+    STRING = 260,
+    TIME = 261,
+    SHAPE = 262,
+    OR = 263,
+    AND = 264,
+    NOT = 265,
+    RE = 266,
+    EQ = 267,
+    NE = 268,
+    LT = 269,
+    GT = 270,
+    LE = 271,
+    GE = 272,
+    IN = 273,
+    IEQ = 274,
+    IRE = 275,
+    INTERSECTS = 276,
+    DISJOINT = 277,
+    TOUCHES = 278,
+    OVERLAPS = 279,
+    CROSSES = 280,
+    WITHIN = 281,
+    CONTAINS = 282,
+    EQUALS = 283,
+    BEYOND = 284,
+    DWITHIN = 285,
+    AREA = 286,
+    LENGTH = 287,
+    COMMIFY = 288,
+    ROUND = 289,
+    UPPER = 290,
+    LOWER = 291,
+    INITCAP = 292,
+    FIRSTCAP = 293,
+    TOSTRING = 294,
+    YYBUFFER = 295,
+    INNER = 296,
+    OUTER = 297,
+    DIFFERENCE = 298,
+    DENSIFY = 299,
+    SIMPLIFY = 300,
+    SIMPLIFYPT = 301,
+    GENERALIZE = 302,
+    SMOOTHSIA = 303,
+    CENTERLINE = 304,
+    JAVASCRIPT = 305,
+    NEG = 306
+  };
+#endif
+/* Tokens.  */
+#define BOOLEAN 258
+#define NUMBER 259
+#define STRING 260
+#define TIME 261
+#define SHAPE 262
+#define OR 263
+#define AND 264
+#define NOT 265
+#define RE 266
+#define EQ 267
+#define NE 268
+#define LT 269
+#define GT 270
+#define LE 271
+#define GE 272
+#define IN 273
+#define IEQ 274
+#define IRE 275
+#define INTERSECTS 276
+#define DISJOINT 277
+#define TOUCHES 278
+#define OVERLAPS 279
+#define CROSSES 280
+#define WITHIN 281
+#define CONTAINS 282
+#define EQUALS 283
+#define BEYOND 284
+#define DWITHIN 285
+#define AREA 286
+#define LENGTH 287
+#define COMMIFY 288
+#define ROUND 289
+#define UPPER 290
+#define LOWER 291
+#define INITCAP 292
+#define FIRSTCAP 293
+#define TOSTRING 294
+#define YYBUFFER 295
+#define INNER 296
+#define OUTER 297
+#define DIFFERENCE 298
+#define DENSIFY 299
+#define SIMPLIFY 300
+#define SIMPLIFYPT 301
+#define GENERALIZE 302
+#define SMOOTHSIA 303
+#define CENTERLINE 304
+#define JAVASCRIPT 305
+#define NEG 306
+
+/* Value type.  */
+#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
+
+union YYSTYPE
+{
+#line 30 "mapparser.y" /* yacc.c:1909  */
+
+  double dblval;
+  int intval;  
+  char *strval;  
+  struct tm tmval;
+  shapeObj *shpval;
+
+#line 164 "/vagrant/mapparser.h" /* yacc.c:1909  */
+};
+
+typedef union YYSTYPE YYSTYPE;
+# define YYSTYPE_IS_TRIVIAL 1
+# define YYSTYPE_IS_DECLARED 1
+#endif
+
+
+
+int yyparse (parseObj *p);
+
+#endif /* !YY_YY_VAGRANT_MAPPARSER_H_INCLUDED  */
diff -pruN 8.0.1-5/src/mapparser.y 8.2.0~beta1-1~exp1/src/mapparser.y
--- 8.0.1-5/src/mapparser.y	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapparser.y	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1166 @@
+/*
+** Parser for the mapserver
+*/
+
+%{
+/* C declarations */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+#include <time.h>
+
+#include "mapserver.h" /* for TRUE/FALSE and REGEX includes */
+#include "maptime.h" /* for time comparison routines */
+#include "mapprimitive.h" /* for shapeObj */
+
+#include "mapparser.h" /* for YYSTYPE in the function prototype for yylex() */
+
+int yylex(YYSTYPE *, parseObj *); /* prototype functions, defined after the grammar */
+int yyerror(parseObj *, const char *);
+%}
+
+/* Bison/Yacc declarations */
+
+/* %define api.pure */
+%pure-parser
+%parse-param {parseObj *p}
+%lex-param {parseObj *p}
+
+%union {
+  double dblval;
+  int intval;  
+  char *strval;  
+  struct tm tmval;
+  shapeObj *shpval;
+}
+
+%token <intval> BOOLEAN
+%token <dblval> NUMBER
+%token <strval> STRING
+%token <tmval> TIME
+%token <shpval> SHAPE
+
+%left OR
+%left AND
+%left NOT
+%left RE EQ NE LT GT LE GE IN IEQ IRE
+%left INTERSECTS DISJOINT TOUCHES OVERLAPS CROSSES WITHIN CONTAINS EQUALS BEYOND DWITHIN
+%left AREA LENGTH COMMIFY ROUND
+%left UPPER LOWER INITCAP FIRSTCAP
+%left TOSTRING
+%left YYBUFFER INNER OUTER DIFFERENCE DENSIFY SIMPLIFY SIMPLIFYPT GENERALIZE SMOOTHSIA CENTERLINE JAVASCRIPT
+%left '+' '-'
+%left '*' '/' '%'
+%left NEG
+%right '^'
+
+%type <intval> logical_exp
+%type <dblval> math_exp
+%type <strval> string_exp
+%type <tmval> time_exp
+%type <shpval> shape_exp
+
+/* Bison/Yacc grammar */
+
+%%
+
+input: /* empty string */
+  | logical_exp {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_BOOLEAN):
+      p->result.intval = $1; 
+      break;
+    case(MS_PARSE_TYPE_STRING):
+      if($1) 
+        p->result.strval = msStrdup("true");
+      else
+        p->result.strval = msStrdup("false");
+      break;
+    }
+  }
+  | math_exp {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_BOOLEAN):
+      if($1 != 0)
+        p->result.intval = MS_TRUE;
+      else
+        p->result.intval = MS_FALSE;			    
+      break;
+    case(MS_PARSE_TYPE_STRING):
+      p->result.strval = (char *)malloc(64); /* large enough for a double */
+      snprintf(p->result.strval, 64, "%g", $1);
+      break;
+    }
+  }
+  | string_exp {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_BOOLEAN):
+      if($1) /* string is not NULL */
+        p->result.intval = MS_TRUE;
+      else
+        p->result.intval = MS_FALSE;
+      break;
+    case(MS_PARSE_TYPE_SLD):
+    case(MS_PARSE_TYPE_STRING):
+      p->result.strval = $1; // msStrdup($1);
+      break;
+    }
+  }
+  | shape_exp {
+    switch(p->type) {
+    case(MS_PARSE_TYPE_SHAPE):
+      p->result.shpval = $1;
+      p->result.shpval->scratch = MS_FALSE;
+      break;
+    }
+  }
+;
+
+logical_exp: BOOLEAN
+  | '(' logical_exp ')' { $$ = $2; }
+  | logical_exp EQ logical_exp {
+    $$ = MS_FALSE;
+    if($1 == $3) $$ = MS_TRUE;
+  }
+  | logical_exp OR logical_exp {
+    if($1 == MS_TRUE)
+      $$ = MS_TRUE;
+    else if($3 == MS_TRUE)          
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | logical_exp AND logical_exp {
+    if($1 == MS_TRUE) {
+      if($3 == MS_TRUE)
+        $$ = MS_TRUE;
+      else
+        $$ = MS_FALSE;
+    } else
+      $$ = MS_FALSE;
+  }
+  | logical_exp OR math_exp {
+    if($1 == MS_TRUE)
+      $$ = MS_TRUE;
+    else if($3 != 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | logical_exp AND math_exp {
+    if($1 == MS_TRUE) {
+      if($3 != 0)
+        $$ = MS_TRUE;
+      else
+        $$ = MS_FALSE;
+    } else
+      $$ = MS_FALSE;
+  }
+  | math_exp OR logical_exp {
+    if($1 != 0)
+      $$ = MS_TRUE;
+    else if($3 == MS_TRUE)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | math_exp AND logical_exp {
+    if($1 != 0) {
+      if($3 == MS_TRUE)
+        $$ = MS_TRUE;
+      else
+        $$ = MS_FALSE;
+    } else
+      $$ = MS_FALSE;
+  }
+  | math_exp OR math_exp {
+    if($1 != 0)
+      $$ = MS_TRUE;
+    else if($3 != 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | math_exp AND math_exp      {
+    if($1 != 0) {
+      if($3 != 0)
+        $$ = MS_TRUE;
+      else
+	$$ = MS_FALSE;
+    } else
+      $$ = MS_FALSE;
+  }
+  | NOT logical_exp { $$ = !$2; }
+  | NOT math_exp { $$ = !$2; }
+  | string_exp RE string_exp {
+    ms_regex_t re;
+
+    if(MS_STRING_IS_NULL_OR_EMPTY($1) == MS_TRUE) {
+      $$ = MS_FALSE;
+    } else {
+      if(ms_regcomp(&re, $3, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {      
+        $$ = MS_FALSE;
+      } else {
+        if(ms_regexec(&re, $1, 0, NULL, 0) == 0)
+          $$ = MS_TRUE;
+        else
+          $$ = MS_FALSE;
+        ms_regfree(&re);
+      }
+    }
+
+    free($1);
+    free($3);
+  }
+  | string_exp IRE string_exp {
+    ms_regex_t re;
+
+    if(MS_STRING_IS_NULL_OR_EMPTY($1) == MS_TRUE) {
+      $$ = MS_FALSE;
+    } else {
+      if(ms_regcomp(&re, $3, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
+        $$ = MS_FALSE;
+      } else {
+        if(ms_regexec(&re, $1, 0, NULL, 0) == 0)
+          $$ = MS_TRUE;
+        else
+          $$ = MS_FALSE;
+        ms_regfree(&re);
+      }
+    }
+
+    free($1);
+    free($3);
+  }
+  | math_exp EQ math_exp {
+    if($1 == $3)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | math_exp NE math_exp {
+    if($1 != $3)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  } 
+  | math_exp GT math_exp {    
+    if($1 > $3)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | math_exp LT math_exp {
+    if($1 < $3)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | math_exp GE math_exp {
+    if($1 >= $3)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | math_exp LE math_exp {
+    if($1 <= $3)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | string_exp EQ string_exp {
+    if(strcmp($1, $3) == 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+    free($1);
+    free($3);
+  }
+  | string_exp NE string_exp {
+    if(strcmp($1, $3) != 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+    free($1);
+    free($3);
+  }
+  | string_exp GT string_exp {
+    if(strcmp($1, $3) > 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+    free($1);
+    free($3);
+  }
+  | string_exp LT string_exp {
+    if(strcmp($1, $3) < 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+    free($1);
+    free($3);
+  }
+  | string_exp GE string_exp {
+    if(strcmp($1, $3) >= 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+    free($1);
+    free($3);
+  }
+  | string_exp LE string_exp {
+    if(strcmp($1, $3) <= 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+    free($1);
+    free($3);
+  }
+  | time_exp EQ time_exp {
+    if(msTimeCompare(&($1), &($3)) == 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | time_exp NE time_exp {
+    if(msTimeCompare(&($1), &($3)) != 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | time_exp GT time_exp {
+    if(msTimeCompare(&($1), &($3)) > 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | time_exp LT time_exp {
+    if(msTimeCompare(&($1), &($3)) < 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | time_exp GE time_exp {
+    if(msTimeCompare(&($1), &($3)) >= 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | time_exp LE time_exp {
+    if(msTimeCompare(&($1), &($3)) <= 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | string_exp IN string_exp {
+    char *delim, *bufferp;
+
+    $$ = MS_FALSE;
+    bufferp=$3;
+
+    while((delim=strchr(bufferp,',')) != NULL) {
+      *delim='\0';
+      if(strcmp($1,bufferp) == 0) {
+        $$ = MS_TRUE;
+        break;
+      } 
+      *delim=',';
+      bufferp=delim+1;
+    }
+
+    if($$ == MS_FALSE && strcmp($1,bufferp) == 0) // test for last (or only) item
+      $$ = MS_TRUE;
+    free($1);
+    free($3);
+  }
+  | math_exp IN string_exp {
+    char *delim,*bufferp;
+
+    $$ = MS_FALSE;
+    bufferp=$3;
+
+    while((delim=strchr(bufferp,',')) != NULL) {
+      *delim='\0';
+      if($1 == atof(bufferp)) {
+        $$ = MS_TRUE;
+        break;
+      } 
+      *delim=',';
+      bufferp=delim+1;
+    }
+
+    if($1 == atof(bufferp)) // is this test necessary?
+      $$ = MS_TRUE;  
+    free($3);
+  }
+  | math_exp IEQ math_exp {
+    if($1 == $3)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | string_exp IEQ string_exp {
+    if(strcasecmp($1, $3) == 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+    free($1);
+    free($3);
+  }
+  | time_exp IEQ time_exp {
+    if(msTimeCompare(&($1), &($3)) == 0)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | shape_exp EQ shape_exp {
+    int rval;
+    rval = msGEOSEquals($1, $3);
+    if($1 && $1->scratch == MS_TRUE) {
+      msFreeShape($1);
+      free($1);
+    }
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(rval == -1) {
+      yyerror(p, "Equals (EQ or ==) operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | EQUALS '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSEquals($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Equals function failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | INTERSECTS '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSIntersects($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Intersects function failed.");
+      return(-1);
+    } else
+    $$ = rval;
+  }
+  | shape_exp INTERSECTS shape_exp {
+    int rval;
+    rval = msGEOSIntersects($1, $3);
+    if($1 && $1->scratch == MS_TRUE) {
+      msFreeShape($1);
+      free($1);
+    }
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(rval == -1) {
+      yyerror(p, "Intersects operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | DISJOINT '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSDisjoint($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Disjoint function failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | shape_exp DISJOINT shape_exp {
+    int rval;
+    rval = msGEOSDisjoint($1, $3);
+    if($1 && $1->scratch == MS_TRUE) {
+      msFreeShape($1);
+      free($1);
+    }
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(rval == -1) {
+      yyerror(p, "Disjoint operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | TOUCHES '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSTouches($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Touches function failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | shape_exp TOUCHES shape_exp {
+    int rval;
+    rval = msGEOSTouches($1, $3);
+    if($1 && $1->scratch == MS_TRUE) {
+      msFreeShape($1);
+      free($1);
+    }
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(rval == -1) {
+      yyerror(p, "Touches operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | OVERLAPS '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSOverlaps($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Overlaps function failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | shape_exp OVERLAPS shape_exp {
+    int rval;
+     rval = msGEOSOverlaps($1, $3);
+     if($1 && $1->scratch == MS_TRUE) {
+       msFreeShape($1);
+       free($1);
+     }
+     if($3 && $3->scratch == MS_TRUE) {
+       msFreeShape($3);
+       free($3);
+     }
+    if(rval == -1) {
+      yyerror(p, "Overlaps operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | CROSSES '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSCrosses($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Crosses function failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | shape_exp CROSSES shape_exp {
+    int rval;
+    rval = msGEOSCrosses($1, $3);
+    if($1 && $1->scratch == MS_TRUE) {
+      msFreeShape($1);
+      free($1);
+    }
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(rval == -1) {
+      yyerror(p, "Crosses operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | WITHIN '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSWithin($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Within function failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | shape_exp WITHIN shape_exp {
+    int rval;
+    rval = msGEOSWithin($1, $3);
+    if($1 && $1->scratch == MS_TRUE) {
+      msFreeShape($1);
+      free($1);
+    }
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(rval == -1) {
+      yyerror(p, "Within operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | CONTAINS '(' shape_exp ',' shape_exp ')' {
+    int rval;
+    rval = msGEOSContains($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(rval == -1) {
+      yyerror(p, "Contains function failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | shape_exp CONTAINS shape_exp {
+    int rval;
+    rval = msGEOSContains($1, $3);
+    if($1 && $1->scratch == MS_TRUE) {
+      msFreeShape($1);
+      free($1);
+    }
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(rval == -1) {
+      yyerror(p, "Contains operator failed.");
+      return(-1);
+    } else
+      $$ = rval;
+  }
+  | DWITHIN '(' shape_exp ',' shape_exp ',' math_exp ')' {
+    double d;
+    d = msGEOSDistance($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(d <= $7)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+  | BEYOND '(' shape_exp ',' shape_exp ',' math_exp ')' {
+    double d;
+    d = msGEOSDistance($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if($5 && $5->scratch == MS_TRUE) {
+      msFreeShape($5);
+      free($5);
+    }
+    if(d > $7)
+      $$ = MS_TRUE;
+    else
+      $$ = MS_FALSE;
+  }
+;
+
+math_exp: NUMBER
+  | '(' math_exp ')' { $$ = $2; }
+  | math_exp '+' math_exp { $$ = $1 + $3; }
+  | math_exp '-' math_exp { $$ = $1 - $3; }
+  | math_exp '*' math_exp { $$ = $1 * $3; }
+  | math_exp '%' math_exp { $$ = (int)$1 % (int)$3; }
+  | math_exp '/' math_exp {
+    if($3 == 0.0) {
+      yyerror(p, "Division by zero.");
+      return(-1);
+    } else
+      $$ = $1 / $3; 
+  }
+  | '-' math_exp %prec NEG { $$ = $2; }
+  | math_exp '^' math_exp { $$ = pow($1, $3); }
+  | LENGTH '(' string_exp ')' { $$ = strlen($3); }
+  | AREA '(' shape_exp ')' {
+    if($3->type != MS_SHAPE_POLYGON) {
+      yyerror(p, "Area can only be computed for polygon shapes.");
+      return(-1);
+    }
+    $$ = msGetPolygonArea($3);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+  }
+  | ROUND '(' math_exp ',' math_exp ')' { $$ = (MS_NINT($3/$5))*$5; }
+  | ROUND '(' math_exp ')' { $$ = (MS_NINT($3)); }
+;
+
+shape_exp: SHAPE 
+  | '(' shape_exp ')' { $$ = $2; }
+  | YYBUFFER '(' shape_exp ',' math_exp ')' {
+    shapeObj *s;
+    s = msGEOSBuffer($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing buffer failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | INNER '(' shape_exp ')' {
+    shapeObj *s;
+    s = msRings2Shape($3, MS_FALSE);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing inner failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | OUTER '(' shape_exp ')' {
+    shapeObj *s;
+    s = msRings2Shape($3, MS_TRUE);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing outer failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | CENTERLINE '(' shape_exp ')' {
+    shapeObj *s;
+    s = msGEOSCenterline($3);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing centerline failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | DIFFERENCE '(' shape_exp ',' shape_exp ')' {
+    shapeObj *s;
+    s = msGEOSDifference($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing difference failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | DENSIFY '(' shape_exp ',' math_exp ')' {
+    shapeObj *s;
+    s = msDensify($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing densify failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | SIMPLIFY '(' shape_exp ',' math_exp ')' {
+    shapeObj *s;
+    s = msGEOSSimplify($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing simplify failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | SIMPLIFYPT '(' shape_exp ',' math_exp ')' {
+    shapeObj *s;
+    s = msGEOSTopologyPreservingSimplify($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing simplifypt failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | GENERALIZE '(' shape_exp ',' math_exp ')' {
+    shapeObj *s;
+    s = msGeneralize($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing generalize failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | SMOOTHSIA '(' shape_exp ')' {
+    shapeObj *s;
+    s = msSmoothShapeSIA($3, 3, 1, NULL);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | SMOOTHSIA '(' shape_exp ',' math_exp ')' {
+    shapeObj *s;
+    s = msSmoothShapeSIA($3, $5, 1, NULL);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | SMOOTHSIA '(' shape_exp ',' math_exp ',' math_exp ')' {
+    shapeObj *s;
+    s = msSmoothShapeSIA($3, $5, $7, NULL);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | SMOOTHSIA '(' shape_exp ',' math_exp ',' math_exp ',' string_exp ')' {
+    shapeObj *s;
+    s = msSmoothShapeSIA($3, $5, $7, $9);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    free($9);
+    if(!s) {
+      yyerror(p, "Executing smoothsia failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+  }
+  | JAVASCRIPT '(' shape_exp ',' string_exp ')' {
+#ifdef USE_V8_MAPSCRIPT
+    shapeObj *s;
+    s = msV8TransformShape($3, $5);
+    if($3 && $3->scratch == MS_TRUE) {
+      msFreeShape($3);
+      free($3);
+    }
+    free($5);
+    if(!s) {
+      yyerror(p, "Executing javascript failed.");
+      return(-1);
+    }
+    s->scratch = MS_TRUE;
+    $$ = s;
+#else
+    yyerror(p, "Javascript support not compiled in");
+    return(-1);
+#endif
+  }
+;
+
+string_exp: STRING
+  | '(' string_exp ')' { $$ = $2; }
+  | string_exp '+' string_exp { 
+    $$ = (char *)malloc(strlen($1) + strlen($3) + 1);
+    sprintf($$, "%s%s", $1, $3); free($1); free($3); 
+  }
+  | TOSTRING '(' math_exp ',' string_exp ')' {
+    $$ = (char *) malloc(strlen($5) + 64); /* Plenty big? Should use snprintf below... */
+    sprintf($$, $5, $3);
+    free($5);
+  }
+  | COMMIFY '(' string_exp ')' {  
+    $3 = msCommifyString($3); 
+    $$ = $3; 
+  }
+  | UPPER '(' string_exp ')' {  
+    msStringToUpper($3); 
+    $$ = $3; 
+  }
+  | LOWER '(' string_exp ')' {  
+    msStringToLower($3); 
+    $$ = $3; 
+  }
+  | INITCAP '(' string_exp ')' {  
+    msStringInitCap($3); 
+    $$ = $3; 
+  }
+  | FIRSTCAP '(' string_exp ')' {  
+    msStringFirstCap($3); 
+    $$ = $3; 
+  }
+;
+
+time_exp: TIME
+  | '(' time_exp ')' { $$ = $2; }
+;
+
+%%
+
+/*
+** Any extra C functions
+*/
+
+int yylex(YYSTYPE *lvalp, parseObj *p) 
+{
+  int token;
+  
+  if(p->expr->curtoken == NULL) return(0); /* done */
+
+  // fprintf(stderr, "in yylex() - curtoken=%d...\n", p->expr->curtoken->token);
+
+  token = p->expr->curtoken->token; /* may override */
+  switch(p->expr->curtoken->token) {
+  case MS_TOKEN_LITERAL_BOOLEAN:
+    token = BOOLEAN;
+    (*lvalp).intval = p->expr->curtoken->tokenval.dblval;
+    break;
+  case MS_TOKEN_LITERAL_NUMBER:
+    token = NUMBER;
+    (*lvalp).dblval = p->expr->curtoken->tokenval.dblval;
+    break;
+  case MS_TOKEN_LITERAL_SHAPE:
+    token = SHAPE;
+    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->expr->curtoken->tokenval.shpval));
+    (*lvalp).shpval = p->expr->curtoken->tokenval.shpval;
+    break;
+  case MS_TOKEN_LITERAL_STRING:
+    // printf("token value = %s\n", p->expr->curtoken->tokenval.strval); 
+    if (p->type == MS_PARSE_TYPE_SLD)
+    {
+      token = STRING;
+      if (*(p->expr->curtoken->tokenval.strval))
+      {
+        (*lvalp).strval = msStrdup("<![CDATA[");
+        (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.strval);
+        (*lvalp).strval = msStringConcatenate((*lvalp).strval,"]]>\n");
+      }
+      else
+      {
+        (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);
+      }
+    }
+    else
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup(p->expr->curtoken->tokenval.strval);    
+    }
+    break;
+  case MS_TOKEN_LITERAL_TIME:
+    token = TIME;
+    (*lvalp).tmval = p->expr->curtoken->tokenval.tmval;
+    break;
+
+  case MS_TOKEN_COMPARISON_EQ: token = EQ; break;
+  case MS_TOKEN_COMPARISON_IEQ: token = IEQ; break;
+  case MS_TOKEN_COMPARISON_NE: token = NE; break;
+  case MS_TOKEN_COMPARISON_LT: token = LT; break;
+  case MS_TOKEN_COMPARISON_GT: token = GT; break;
+  case MS_TOKEN_COMPARISON_LE: token = LE; break;
+  case MS_TOKEN_COMPARISON_GE: token = GE; break;
+  case MS_TOKEN_COMPARISON_RE: token = RE; break;
+  case MS_TOKEN_COMPARISON_IRE: token = IRE; break;
+
+  case MS_TOKEN_COMPARISON_IN: token = IN; break;
+
+  case MS_TOKEN_COMPARISON_INTERSECTS: token = INTERSECTS; break;
+  case MS_TOKEN_COMPARISON_DISJOINT: token = DISJOINT; break;
+  case MS_TOKEN_COMPARISON_TOUCHES: token = TOUCHES; break;
+  case MS_TOKEN_COMPARISON_OVERLAPS: token = OVERLAPS; break; 
+  case MS_TOKEN_COMPARISON_CROSSES: token = CROSSES; break;
+  case MS_TOKEN_COMPARISON_WITHIN: token = WITHIN; break; 
+  case MS_TOKEN_COMPARISON_CONTAINS: token = CONTAINS; break;
+  case MS_TOKEN_COMPARISON_EQUALS: token = EQUALS; break;
+  case MS_TOKEN_COMPARISON_BEYOND: token = BEYOND; break;
+  case MS_TOKEN_COMPARISON_DWITHIN: token = DWITHIN; break;
+
+  case MS_TOKEN_LOGICAL_AND: token = AND; break;
+  case MS_TOKEN_LOGICAL_OR: token = OR; break;
+  case MS_TOKEN_LOGICAL_NOT: token = NOT; break;
+
+  case MS_TOKEN_BINDING_DOUBLE:
+  case MS_TOKEN_BINDING_INTEGER:
+    if (p->type == MS_PARSE_TYPE_SLD)
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
+    }
+    else
+    {
+      token = NUMBER;
+      (*lvalp).dblval = atof(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
+    }
+    break;
+  case MS_TOKEN_BINDING_STRING:
+    if (p->type == MS_PARSE_TYPE_SLD)
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup("<ogc:PropertyName>");
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,p->expr->curtoken->tokenval.bindval.item);
+      (*lvalp).strval = msStringConcatenate((*lvalp).strval,"</ogc:PropertyName>\n");
+    }
+    else
+    {
+      token = STRING;
+      (*lvalp).strval = msStrdup(p->shape->values[p->expr->curtoken->tokenval.bindval.index]);
+    }
+    break;
+  case MS_TOKEN_BINDING_SHAPE:
+    token = SHAPE;
+    // fprintf(stderr, "token value = %s\n", msShapeToWKT(p->shape));
+    (*lvalp).shpval = p->shape;
+    break;
+  case MS_TOKEN_BINDING_MAP_CELLSIZE:
+    token = NUMBER;
+    (*lvalp).dblval = p->dblval;
+    break;
+  case MS_TOKEN_BINDING_DATA_CELLSIZE:
+    token = NUMBER;
+    (*lvalp).dblval = p->dblval2;
+    break;    
+  case MS_TOKEN_BINDING_TIME:
+    token = TIME;
+    msTimeInit(&((*lvalp).tmval));
+    if(msParseTime(p->shape->values[p->expr->curtoken->tokenval.bindval.index], &((*lvalp).tmval)) != MS_TRUE) {
+      yyerror(p, "Parsing time value failed.");
+      return(-1);
+    }
+    break;
+
+  case MS_TOKEN_FUNCTION_AREA: token = AREA; break;
+  case MS_TOKEN_FUNCTION_LENGTH: token = LENGTH; break;
+  case MS_TOKEN_FUNCTION_TOSTRING: token = TOSTRING; break;
+  case MS_TOKEN_FUNCTION_COMMIFY: token = COMMIFY; break;
+  case MS_TOKEN_FUNCTION_UPPER: token = UPPER; break;
+  case MS_TOKEN_FUNCTION_LOWER: token = LOWER; break;
+  case MS_TOKEN_FUNCTION_INITCAP: token = INITCAP; break;
+  case MS_TOKEN_FUNCTION_FIRSTCAP: token = FIRSTCAP; break;
+  case MS_TOKEN_FUNCTION_ROUND: token = ROUND; break;
+
+  case MS_TOKEN_FUNCTION_BUFFER: token = YYBUFFER; break;
+  case MS_TOKEN_FUNCTION_DIFFERENCE: token = DIFFERENCE; break;
+  case MS_TOKEN_FUNCTION_SIMPLIFY: token = SIMPLIFY; break;
+  case MS_TOKEN_FUNCTION_SIMPLIFYPT: token = SIMPLIFYPT; break;
+  case MS_TOKEN_FUNCTION_GENERALIZE: token = GENERALIZE; break;
+  case MS_TOKEN_FUNCTION_SMOOTHSIA: token = SMOOTHSIA; break;
+  case MS_TOKEN_FUNCTION_CENTERLINE: token = CENTERLINE; break;
+  case MS_TOKEN_FUNCTION_DENSIFY: token = DENSIFY; break;
+  case MS_TOKEN_FUNCTION_INNER: token = INNER; break;
+  case MS_TOKEN_FUNCTION_OUTER: token = OUTER; break;
+  case MS_TOKEN_FUNCTION_JAVASCRIPT: token = JAVASCRIPT; break;
+
+  default:
+    break;
+  }
+
+  p->expr->curtoken = p->expr->curtoken->next; /* re-position */ 
+  return(token);
+}
+
+int yyerror(parseObj *p, const char *s) {
+  (void)p;
+  msSetError(MS_PARSEERR, "%s", "yyparse()", s);
+  return(0);
+}
diff -pruN 8.0.1-5/src/mappluginlayer.c 8.2.0~beta1-1~exp1/src/mappluginlayer.c
--- 8.0.1-5/src/mappluginlayer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mappluginlayer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,249 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of plug-in layer functionality
+ * Author:   Jani Averbach, SRC,LLC  <javerbach@extendthereach.com>
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "mapthread.h"
+
+typedef struct {
+  char *name;
+  layerVTableObj vtable;
+} VTFactoryItemObj;
+
+typedef struct {
+  unsigned int size;
+  unsigned int first_free;
+  VTFactoryItemObj **vtItems;
+} VTFactoryObj;
+
+static VTFactoryObj gVirtualTableFactory = {0, 0, NULL};
+
+static VTFactoryItemObj *createVTFItem(const char *name) {
+  VTFactoryItemObj *pVTFI;
+
+  pVTFI = (VTFactoryItemObj *)malloc(sizeof(VTFactoryItemObj));
+  MS_CHECK_ALLOC(pVTFI, sizeof(VTFactoryItemObj), NULL);
+
+  pVTFI->name = msStrdup(name);
+  memset(&pVTFI->vtable, 0, sizeof(layerVTableObj));
+
+  return pVTFI;
+}
+
+static void destroyVTFItem(VTFactoryItemObj **pVTFI) {
+  free((*pVTFI)->name);
+  (*pVTFI)->name = NULL;
+  memset(&(*pVTFI)->vtable, 0, sizeof(layerVTableObj));
+  free(*pVTFI);
+  *pVTFI = NULL;
+}
+
+static VTFactoryItemObj *lookupVTFItem(VTFactoryObj *VTFactory,
+                                       const char *key) {
+  unsigned int i;
+  for (i = 0; i < VTFactory->size && VTFactory->vtItems[i]; ++i) {
+    if (0 == strcasecmp(key, VTFactory->vtItems[i]->name)) {
+      return VTFactory->vtItems[i];
+    }
+  }
+  return NULL;
+}
+
+static int insertNewVTFItem(VTFactoryObj *pVTFactory, VTFactoryItemObj *pVTFI) {
+  /* Ensure there is room for one more item in the array
+   * (safe to use for initial alloc of the array as well)
+   */
+  if (pVTFactory->first_free == pVTFactory->size) {
+    VTFactoryItemObj **vtItemPtr;
+    vtItemPtr = (VTFactoryItemObj **)realloc(
+        pVTFactory->vtItems,
+        (pVTFactory->size + MS_LAYER_ALLOCSIZE) * sizeof(VTFactoryItemObj *));
+    MS_CHECK_ALLOC(vtItemPtr,
+                   (pVTFactory->size + MS_LAYER_ALLOCSIZE) *
+                       sizeof(VTFactoryItemObj *),
+                   MS_FAILURE);
+
+    pVTFactory->size += MS_LAYER_ALLOCSIZE;
+    pVTFactory->vtItems = vtItemPtr;
+
+    for (unsigned i = pVTFactory->first_free; i < pVTFactory->size; i++)
+      pVTFactory->vtItems[i] = NULL;
+  }
+
+  /* Insert item */
+  pVTFactory->vtItems[pVTFactory->first_free] = pVTFI;
+  pVTFactory->first_free++;
+
+  return MS_SUCCESS;
+}
+
+static VTFactoryItemObj *loadCustomLayerDLL(layerObj *layer,
+                                            const char *library_path) {
+  int (*pfnPluginInitVTable)(layerVTableObj *, layerObj *);
+
+  VTFactoryItemObj *pVTFI;
+
+  pfnPluginInitVTable =
+      msGetSymbol(library_path, "PluginInitializeVirtualTable");
+  if (!pfnPluginInitVTable) {
+    msSetError(MS_MISCERR, "Failed to load dynamic Layer LIB: %s",
+               "loadCustomLayerDLL", library_path);
+    return NULL;
+  }
+
+  pVTFI = createVTFItem(library_path);
+  if (!pVTFI) {
+    return NULL;
+  }
+
+  if (pfnPluginInitVTable(&pVTFI->vtable, layer)) {
+    destroyVTFItem(&pVTFI);
+    msSetError(MS_MISCERR, "Failed to initialize dynamic Layer: %s",
+               "loadCustomLayerDLL", library_path);
+    return NULL;
+  }
+  return pVTFI;
+}
+
+/*
+ * copyVirtualTable
+ *
+ * copy one virtual table from dest to src. Both of dest and src
+ * have to be allocated already.
+ *
+ * If src contains NULL fields, those are NOT copied over.
+ *
+ * Because of that, it is possible for plugin layer to use default
+ * layer API default functions,  just leave those function pointers to NULL.
+ */
+static void copyVirtualTable(layerVTableObj *dest, const layerVTableObj *src) {
+  dest->LayerTranslateFilter = src->LayerTranslateFilter
+                                   ? src->LayerTranslateFilter
+                                   : dest->LayerTranslateFilter;
+  dest->LayerSupportsCommonFilters = src->LayerSupportsCommonFilters
+                                         ? src->LayerSupportsCommonFilters
+                                         : dest->LayerSupportsCommonFilters;
+  dest->LayerInitItemInfo =
+      src->LayerInitItemInfo ? src->LayerInitItemInfo : dest->LayerInitItemInfo;
+  dest->LayerFreeItemInfo =
+      src->LayerFreeItemInfo ? src->LayerFreeItemInfo : dest->LayerFreeItemInfo;
+  dest->LayerOpen = src->LayerOpen ? src->LayerOpen : dest->LayerOpen;
+  dest->LayerIsOpen = src->LayerIsOpen ? src->LayerIsOpen : dest->LayerIsOpen;
+  dest->LayerWhichShapes =
+      src->LayerWhichShapes ? src->LayerWhichShapes : dest->LayerWhichShapes;
+  dest->LayerNextShape =
+      src->LayerNextShape ? src->LayerNextShape : dest->LayerNextShape;
+  dest->LayerGetShape =
+      src->LayerGetShape ? src->LayerGetShape : dest->LayerGetShape;
+  /* dest->LayerResultsGetShape = src->LayerResultsGetShape ?
+   * src->LayerResultsGetShape : dest->LayerResultsGetShape; */
+  dest->LayerGetShapeCount = src->LayerGetShapeCount ? src->LayerGetShapeCount
+                                                     : dest->LayerGetShapeCount;
+  dest->LayerClose = src->LayerClose ? src->LayerClose : dest->LayerClose;
+  dest->LayerGetItems =
+      src->LayerGetItems ? src->LayerGetItems : dest->LayerGetItems;
+  dest->LayerGetExtent =
+      src->LayerGetExtent ? src->LayerGetExtent : dest->LayerGetExtent;
+  dest->LayerGetAutoStyle =
+      src->LayerGetAutoStyle ? src->LayerGetAutoStyle : dest->LayerGetAutoStyle;
+  dest->LayerCloseConnection = src->LayerCloseConnection
+                                   ? src->LayerCloseConnection
+                                   : dest->LayerCloseConnection;
+  dest->LayerSetTimeFilter = src->LayerSetTimeFilter ? src->LayerSetTimeFilter
+                                                     : dest->LayerSetTimeFilter;
+  dest->LayerApplyFilterToLayer = src->LayerApplyFilterToLayer
+                                      ? src->LayerApplyFilterToLayer
+                                      : dest->LayerApplyFilterToLayer;
+  dest->LayerCreateItems =
+      src->LayerCreateItems ? src->LayerCreateItems : dest->LayerCreateItems;
+  dest->LayerGetNumFeatures = src->LayerGetNumFeatures
+                                  ? src->LayerGetNumFeatures
+                                  : dest->LayerGetNumFeatures;
+  dest->LayerGetAutoProjection = src->LayerGetAutoProjection
+                                     ? src->LayerGetAutoProjection
+                                     : dest->LayerGetAutoProjection;
+  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam
+                                  ? src->LayerEscapeSQLParam
+                                  : dest->LayerEscapeSQLParam;
+  dest->LayerEscapePropertyName = src->LayerEscapePropertyName
+                                      ? src->LayerEscapePropertyName
+                                      : dest->LayerEscapePropertyName;
+  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam
+                                  ? src->LayerEscapeSQLParam
+                                  : dest->LayerEscapeSQLParam;
+  dest->LayerEnablePaging =
+      src->LayerEnablePaging ? src->LayerEnablePaging : dest->LayerEnablePaging;
+  dest->LayerGetPaging =
+      src->LayerGetPaging ? src->LayerGetPaging : dest->LayerGetPaging;
+}
+
+int msPluginLayerInitializeVirtualTable(layerObj *layer) {
+  VTFactoryItemObj *pVTFI;
+
+  if (!layer->plugin_library) {
+    return MS_FAILURE;
+  }
+
+  msAcquireLock(TLOCK_LAYER_VTABLE);
+
+  pVTFI = lookupVTFItem(&gVirtualTableFactory, layer->plugin_library);
+  if (!pVTFI) {
+    pVTFI = loadCustomLayerDLL(layer, layer->plugin_library);
+    if (!pVTFI) {
+      msReleaseLock(TLOCK_LAYER_VTABLE);
+      return MS_FAILURE;
+    }
+    if (insertNewVTFItem(&gVirtualTableFactory, pVTFI) != MS_SUCCESS) {
+      destroyVTFItem(&pVTFI);
+      msReleaseLock(TLOCK_LAYER_VTABLE);
+      return MS_FAILURE;
+    }
+  }
+  msReleaseLock(TLOCK_LAYER_VTABLE);
+
+  copyVirtualTable(layer->vtable, &pVTFI->vtable);
+  return MS_SUCCESS;
+}
+
+/* msPluginFreeVirtualTableFactory()
+** Called by msCleanup() to free the virtual table factory
+*/
+void msPluginFreeVirtualTableFactory() {
+  msAcquireLock(TLOCK_LAYER_VTABLE);
+
+  for (unsigned i = 0; i < gVirtualTableFactory.size; i++) {
+    if (gVirtualTableFactory.vtItems[i])
+      destroyVTFItem(&(gVirtualTableFactory.vtItems[i]));
+  }
+  free(gVirtualTableFactory.vtItems);
+  gVirtualTableFactory.vtItems = NULL;
+  gVirtualTableFactory.size = 0;
+  gVirtualTableFactory.first_free = 0;
+
+  msReleaseLock(TLOCK_LAYER_VTABLE);
+}
diff -pruN 8.0.1-5/src/mappool.c 8.2.0~beta1-1~exp1/src/mappool.c
--- 8.0.1-5/src/mappool.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mappool.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,459 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implement new style connection pooling.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ******************************************************************************
+
+             New MapServer Connection Pooling
+             ================================
+
+This attempts to describe how the new connection pooling support (introduced
+Sept/2004) works and what the maintainer of a connection type needs to do
+to take advantage of it.
+
+First, the new connection pooling support makes the assumption that
+a connection can be abstracted as a void pointer.  Further it assumes that
+the connection identify is unique defined by the connection string and
+the connection type on layers.  So if two layers have the same connection
+type and connection string that they can share a connection handle.
+
+The old connection sharing was based on searching previous layers in the
+same map for a layer to copy an existing connection from.  That was ok for
+sharing connection between layers in the same map, but didn't address the
+need to share connections over a longer term as is the case in a FastCGI
+situation where the cgi is long running and handles many CGI requests.
+
+The mapool.c code essentially maintains a cache of open connections with the
+following information for each:
+  - connectiontype / connection
+  - connection handle
+  - reference count
+  - life span indicator
+  - callback function to close the connection.
+
+The life span indicator is controlled by the CLOSE_CONNECTION PROCESSING
+option on the layer(s).  If this is set to NORMAL (or not set at all) the
+connection will be closed as soon as the reference count drops to zero.  This
+is MS_LIFE_ZEROREF, and in normal use results in connections only be shared
+between layers in a given map as the connection will be closed when no layers
+are open against it anymore.  The other possible value for the CLOSE_CONNECTION
+option is DEFER which basically results in the connection being kept open
+till the application closes (msCleanup() will ensure the connection is closed
+on exit if called).  This case is called MS_LIFE_FOREVER.
+The CLOSE_CONNECTION=ALWAYS setting provides to suppress the connection pooling
+for a particular layer. In this case the MS_LIFE_SINGLE setting is used, which
+ensures that a new connection is created for each request and it is always
+closed when the connection is released. This kind of connection cannot be
+reused.
+
+The callback is a function provided with the connection handle when it is
+registered.  It takes a single "void *" argument which is the connection
+handle.
+
+Updating a Driver
+-----------------
+
+The following are the steps to ensure a particular format/database supports
+connection pooling (ie. mappostgis.c, maporacle.c, mapogr.cpp, etc)
+We will use POSTGIS names for convenience.
+
+1) in msPOSTGISLayerOpen() call msConnPoolRequest(layer) in order to get
+   a database connection.
+
+        layerinfo->conn = (PGconn *) msConnPoolRequest( layer );
+
+2) In msPOSTGISLayerOpen(): if msConnPoolRequest() returned NULL then
+   manually open a connection to the database (ie. PQconnectcb()) and then
+   register this handle with the pool API by calling msmsConnPoolRegister().
+
+      layerinfo->conn = PQconnectdb( layer->connection );
+
+            if (PQstatus(layerinfo->conn) == CONNECTION_BAD)
+               <report error>
+            else
+                msConnPoolRegister( layer, layerinfo->conn,
+                                    msPOSTGISCloseConnection );
+
+3) Implement a callback function (msPOSTGISCloseConnection) that the
+   connection pooling API can call when it wants to close the connection.
+
+   static void msPOSTGISCloseConnection( void *conn_handle )
+
+   {
+       PQfinish( (PGconn*) conn_handle );
+   }
+
+4) In msPOSTGISLayerClose() release the connection handle instead of
+   directly closing it.
+
+            msConnPoolRelease( layer, layerinfo->conn );
+            layerinfo->conn = NULL;
+
+5) If there was any use of msCheckConnection() or the "sameconnection"
+   member of the layerObj, then old style connection pooling is already
+   present.  Remove it.
+
+Thats it!
+
+Other Notes
+-----------
+
+o The connection pooling API will report details about connection
+  registrations, requests, releases and closes if the layer debug flag is
+  on for the layers in question.
+
+o The connection pooling API will let a connection be used/referenced multiple
+  times from a single thread, but will not allow a connection to be shared
+  between different threads concurrently.  But if a connection is released
+  by one thread, it is available for use by another thread.
+
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapthread.h"
+
+/* defines for lifetime.
+   A positive number is a time-from-last use in seconds */
+
+#define MS_LIFE_FOREVER -1
+#define MS_LIFE_ZEROREF -2
+#define MS_LIFE_SINGLE -3
+
+typedef struct {
+  enum MS_CONNECTION_TYPE connectiontype;
+  char *connection;
+
+  int lifespan;
+  int ref_count;
+  void *thread_id;
+  int debug;
+
+  time_t last_used;
+
+  void *conn_handle;
+
+  void (*close)(void *);
+} connectionObj;
+
+/*
+** These static structures are protected by the TLOCK_POOL mutex.
+*/
+
+static int connectionCount = 0;
+static int connectionMax = 0;
+static connectionObj *connections = NULL;
+
+/************************************************************************/
+/*                         msConnPoolRegister()                         */
+/*                                                                      */
+/*      Register a new connection with the connection pool tracker.     */
+/************************************************************************/
+
+void msConnPoolRegister(layerObj *layer, void *conn_handle,
+                        void (*close_func)(void *))
+
+{
+  const char *close_connection = NULL;
+  connectionObj *conn = NULL;
+
+  if (layer->debug)
+    msDebug("msConnPoolRegister(%s,%s,%p)\n", layer->name, layer->connection,
+            conn_handle);
+
+  /* -------------------------------------------------------------------- */
+  /*      We can't meaningful keep a connection with no connection or     */
+  /*      connection type string on the layer.                            */
+  /* -------------------------------------------------------------------- */
+  if (layer->connection == NULL) {
+    if (layer->tileindex != NULL && layer->connectiontype == MS_OGR) {
+      /* this is ok, no need to make a fuss */
+    } else {
+      msDebug("%s: Missing CONNECTION on layer %s.\n", "msConnPoolRegister()",
+              layer->name);
+
+      msSetError(MS_MISCERR, "Missing CONNECTION on layer %s.",
+                 "msConnPoolRegister()", layer->name);
+    }
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Grow the array of connection information objects if needed.     */
+  /* -------------------------------------------------------------------- */
+  msAcquireLock(TLOCK_POOL);
+
+  if (connectionCount == connectionMax) {
+    connectionMax += 10;
+    connectionObj *newConnections = (connectionObj *)realloc(
+        connections, sizeof(connectionObj) * connectionMax);
+    if (newConnections == NULL) {
+      msSetError(MS_MEMERR, NULL, "msConnPoolRegister()");
+      msReleaseLock(TLOCK_POOL);
+      return;
+    }
+    connections = newConnections;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Set the new connection information.                             */
+  /* -------------------------------------------------------------------- */
+  conn = connections + connectionCount;
+
+  connectionCount++;
+
+  conn->connectiontype = layer->connectiontype;
+  conn->connection = msStrdup(layer->connection);
+  conn->close = close_func;
+  conn->ref_count = 1;
+  conn->thread_id = msGetThreadId();
+  conn->last_used = time(NULL);
+  conn->conn_handle = conn_handle;
+  conn->debug = layer->debug;
+
+  /* -------------------------------------------------------------------- */
+  /*      Categorize the connection handling information.                 */
+  /* -------------------------------------------------------------------- */
+  close_connection = msLayerGetProcessingKey(layer, "CLOSE_CONNECTION");
+
+  if (close_connection == NULL)
+    close_connection = "NORMAL";
+
+  if (strcasecmp(close_connection, "NORMAL") == 0)
+    conn->lifespan = MS_LIFE_ZEROREF;
+  else if (strcasecmp(close_connection, "DEFER") == 0)
+    conn->lifespan = MS_LIFE_FOREVER;
+  else if (strcasecmp(close_connection, "ALWAYS") == 0)
+    conn->lifespan = MS_LIFE_SINGLE;
+  else {
+    msDebug("msConnPoolRegister(): "
+            "Unrecognised CLOSE_CONNECTION value '%s'\n",
+            close_connection);
+
+    msSetError(MS_MISCERR, "Unrecognised CLOSE_CONNECTION value '%s'",
+               "msConnPoolRegister()", close_connection);
+    conn->lifespan = MS_LIFE_ZEROREF;
+  }
+
+  msReleaseLock(TLOCK_POOL);
+}
+
+/************************************************************************/
+/*                          msConnPoolClose()                           */
+/*                                                                      */
+/*      Close the indicated connection.  The index in the connection    */
+/*      table is passed.  Remove the connection from the table as       */
+/*      well.                                                           */
+/************************************************************************/
+
+static void msConnPoolClose(int conn_index)
+
+{
+  connectionObj *conn = connections + conn_index;
+
+  if (conn->ref_count > 0) {
+    if (conn->debug)
+      msDebug("msConnPoolClose(): "
+              "Closing connection %s even though ref_count=%d.\n",
+              conn->connection, conn->ref_count);
+
+    msSetError(MS_MISCERR, "Closing connection %s even though ref_count=%d.",
+               "msConnPoolClose()", conn->connection, conn->ref_count);
+  }
+
+  if (conn->debug)
+    msDebug("msConnPoolClose(%s,%p)\n", conn->connection, conn->conn_handle);
+
+  if (conn->close != NULL)
+    conn->close(conn->conn_handle);
+
+  /* free malloced() stuff in this connection */
+  free(conn->connection);
+
+  connectionCount--;
+  if (connectionCount == 0) {
+    /* if there are no connections left we will "cleanup".  */
+    connectionMax = 0;
+    free(connections);
+    connections = NULL;
+  } else {
+    /* move the last connection in place of our now closed one */
+    memcpy(connections + conn_index, connections + connectionCount,
+           sizeof(connectionObj));
+  }
+}
+
+/************************************************************************/
+/*                         msConnPoolRequest()                          */
+/*                                                                      */
+/*      Ask for a connection from the connection pool for use with      */
+/*      the current layer.  If found (CONNECTION and CONNECTIONTYPE     */
+/*      match) then return it and up the ref count.  Otherwise          */
+/*      return NULL.                                                    */
+/************************************************************************/
+
+void *msConnPoolRequest(layerObj *layer)
+
+{
+  int i;
+  const char *close_connection;
+
+  if (layer->connection == NULL)
+    return NULL;
+
+  /* check if we must always create a new connection */
+  close_connection = msLayerGetProcessingKey(layer, "CLOSE_CONNECTION");
+  if (close_connection && strcasecmp(close_connection, "ALWAYS") == 0)
+    return NULL;
+
+  msAcquireLock(TLOCK_POOL);
+  for (i = 0; i < connectionCount; i++) {
+    connectionObj *conn = connections + i;
+
+    if (layer->connectiontype == conn->connectiontype &&
+        strcasecmp(layer->connection, conn->connection) == 0 &&
+        (conn->ref_count == 0 || conn->thread_id == msGetThreadId()) &&
+        conn->lifespan != MS_LIFE_SINGLE) {
+      void *conn_handle = NULL;
+
+      conn->ref_count++;
+      conn->thread_id = msGetThreadId();
+      conn->last_used = time(NULL);
+
+      if (layer->debug) {
+        msDebug("msConnPoolRequest(%s,%s) -> got %p\n", layer->name,
+                layer->connection, conn->conn_handle);
+        conn->debug = layer->debug;
+      }
+
+      conn_handle = conn->conn_handle;
+
+      msReleaseLock(TLOCK_POOL);
+      return conn_handle;
+    }
+  }
+
+  msReleaseLock(TLOCK_POOL);
+
+  return NULL;
+}
+
+/************************************************************************/
+/*                         msConnPoolRelease()                          */
+/*                                                                      */
+/*      Release the passed connection for the given layer.              */
+/*      Internally the reference count is dropped, and the              */
+/*      connection may be closed.  We assume the caller has already     */
+/*      acquired the pool lock.                                         */
+/************************************************************************/
+
+void msConnPoolRelease(layerObj *layer, void *conn_handle)
+
+{
+  int i;
+
+  if (layer->debug)
+    msDebug("msConnPoolRelease(%s,%s,%p)\n", layer->name, layer->connection,
+            conn_handle);
+
+  if (layer->connection == NULL)
+    return;
+
+  msAcquireLock(TLOCK_POOL);
+  for (i = 0; i < connectionCount; i++) {
+    connectionObj *conn = connections + i;
+
+    if (layer->connectiontype == conn->connectiontype &&
+        strcasecmp(layer->connection, conn->connection) == 0 &&
+        conn->conn_handle == conn_handle) {
+      conn->ref_count--;
+      conn->last_used = time(NULL);
+
+      if (conn->ref_count == 0)
+        conn->thread_id = 0;
+
+      if (conn->ref_count == 0 && (conn->lifespan == MS_LIFE_ZEROREF ||
+                                   conn->lifespan == MS_LIFE_SINGLE))
+        msConnPoolClose(i);
+
+      msReleaseLock(TLOCK_POOL);
+      return;
+    }
+  }
+
+  msReleaseLock(TLOCK_POOL);
+
+  msDebug("%s: Unable to find handle for layer '%s'.\n", "msConnPoolRelease()",
+          layer->name);
+
+  msSetError(MS_MISCERR, "Unable to find handle for layer '%s'.",
+             "msConnPoolRelease()", layer->name);
+}
+
+/************************************************************************/
+/*                   msConnPoolMapCloseUnreferenced()                   */
+/*                                                                      */
+/*      Close any unreferenced connections.                             */
+/************************************************************************/
+
+void msConnPoolCloseUnreferenced()
+
+{
+  int i;
+
+  /* this really needs to be commented out before commiting.  */
+  /* msDebug( "msConnPoolCloseUnreferenced()\n" ); */
+
+  msAcquireLock(TLOCK_POOL);
+  for (i = connectionCount - 1; i >= 0; i--) {
+    connectionObj *conn = connections + i;
+
+    if (conn->ref_count == 0) {
+      /* for now we don't assume the locks are re-entrant, so release */
+      /* it so msConnPoolClose() can get it.  */
+      msConnPoolClose(i);
+    }
+  }
+  msReleaseLock(TLOCK_POOL);
+}
+
+/************************************************************************/
+/*                       msConnPoolFinalCleanup()                       */
+/*                                                                      */
+/*      Close any remaining open connections.   This is normally        */
+/*      called just before (voluntary) application termination.         */
+/************************************************************************/
+
+void msConnPoolFinalCleanup()
+
+{
+  /* this really needs to be commented out before commiting.  */
+  /* msDebug( "msConnPoolFinalCleanup()\n" ); */
+
+  msAcquireLock(TLOCK_POOL);
+  while (connectionCount > 0)
+    msConnPoolClose(0);
+  msReleaseLock(TLOCK_POOL);
+}
diff -pruN 8.0.1-5/src/mappostgis.cpp 8.2.0~beta1-1~exp1/src/mappostgis.cpp
--- 8.0.1-5/src/mappostgis.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mappostgis.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4030 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  PostGIS CONNECTIONTYPE support.
+ * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
+ *           Dave Blasby <dblasby@gmail.com>
+ *
+ ******************************************************************************
+ * Copyright (c) 2010 Paul Ramsey
+ * Copyright (c) 2002 Refractions Research
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/*
+** Some theory of operation:
+**
+** Build SQL from DATA statement and LAYER state. SQL is always of the form:
+**
+**    SELECT [this, that, other], geometry, uid
+**      FROM [table|(subquery) as sub]
+**      WHERE [box] AND [filter]
+**
+** So the geometry always resides at layer->numitems and the uid always
+** resides at layer->numitems + 1
+**
+** Geometry is requested as Hex encoded WKB. The endian is always requested
+** as the client endianness.
+**
+** msPostGISLayerWhichShapes creates SQL based on DATA and LAYER state,
+** executes it, and places the un-read PGresult handle in the
+*layerinfo->pgresult,
+** setting the layerinfo->rownum to 0.
+**
+** msPostGISNextShape reads a row, increments layerinfo->rownum, and returns
+** MS_SUCCESS, until rownum reaches ntuples, and it returns MS_DONE instead.
+**
+*/
+
+/* required for MSVC */
+#define _USE_MATH_DEFINES
+
+#include <assert.h>
+#include <string.h>
+#include <math.h>
+#include "mapserver.h"
+#include "maptime.h"
+#include "mappostgis.h"
+#include "mapows.h"
+
+#include <vector>
+
+#define FP_EPSILON 1e-12
+#define FP_EQ(a, b) (fabs((a) - (b)) < FP_EPSILON)
+#define FP_LEFT -1
+#define FP_RIGHT 1
+#define FP_COLINEAR 0
+
+#define SEGMENT_ANGLE 10.0
+#define SEGMENT_MINPOINTS 10
+
+#define WKBZOFFSET_NONISO 0x80000000
+#define WKBMOFFSET_NONISO 0x40000000
+
+#define HAS_Z 0x1
+#define HAS_M 0x2
+
+#if TRANSFER_ENCODING == 256
+#define RESULTSET_TYPE 1
+#else
+#define RESULTSET_TYPE 0
+#endif
+
+/* These are the OIDs for some builtin types, as returned by PQftype(). */
+/* They were copied from pg_type.h in src/include/catalog/pg_type.h */
+
+#ifndef BOOLOID
+#define BOOLOID 16
+#define BYTEAOID 17
+#define CHAROID 18
+#define NAMEOID 19
+#define INT8OID 20
+#define INT2OID 21
+#define INT2VECTOROID 22
+#define INT4OID 23
+#define REGPROCOID 24
+#define TEXTOID 25
+#define OIDOID 26
+#define TIDOID 27
+#define XIDOID 28
+#define CIDOID 29
+#define OIDVECTOROID 30
+#define FLOAT4OID 700
+#define FLOAT8OID 701
+#define INT4ARRAYOID 1007
+#define TEXTARRAYOID 1009
+#define BPCHARARRAYOID 1014
+#define VARCHARARRAYOID 1015
+#define FLOAT4ARRAYOID 1021
+#define FLOAT8ARRAYOID 1022
+#define BPCHAROID 1042
+#define VARCHAROID 1043
+#define DATEOID 1082
+#define TIMEOID 1083
+#define TIMETZOID 1266
+#define TIMESTAMPOID 1114
+#define TIMESTAMPTZOID 1184
+#define NUMERICOID 1700
+#endif
+
+#ifdef USE_POSTGIS
+
+static int wkbConvGeometryToShape(wkbObj *w, shapeObj *shape);
+static int arcStrokeCircularString(wkbObj *w, double segment_angle,
+                                   lineObj *line, int nZMFlag);
+
+/*
+** msPostGISCloseConnection()
+**
+** Handler registered witih msConnPoolRegister so that Mapserver
+** can clean up open connections during a shutdown.
+*/
+static void msPostGISCloseConnection(void *pgconn) {
+  PQfinish((PGconn *)pgconn);
+}
+
+/*
+** msPostGISCreateLayerInfo()
+*/
+static msPostGISLayerInfo *msPostGISCreateLayerInfo(void) {
+  msPostGISLayerInfo *layerinfo = new msPostGISLayerInfo;
+  layerinfo->paging = MS_TRUE;
+  layerinfo->force2d = MS_FALSE;
+  return layerinfo;
+}
+
+/*
+** msPostGISFreeLayerInfo()
+*/
+static void msPostGISFreeLayerInfo(layerObj *layer) {
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  if (layerinfo->pgresult)
+    PQclear(layerinfo->pgresult);
+  if (layerinfo->pgconn)
+    msConnPoolRelease(layer, layerinfo->pgconn);
+  delete layerinfo;
+  layer->layerinfo = nullptr;
+}
+
+/*
+** postgresqlNoticeHandler()
+**
+** Propagate messages from the database to the Mapserver log,
+** set in PQsetNoticeProcessor during layer open.
+*/
+static void postresqlNoticeHandler(void *arg, const char *message) {
+  layerObj *lp = (layerObj *)arg;
+
+  if (lp->debug) {
+    msDebug("%s\n", message);
+  }
+}
+
+/*
+** Expandable pointObj array. The lineObj unfortunately
+** is not useful for this purpose, so we have this one.
+*/
+static std::vector<pointObj> pointArrayNew(int maxpoints) {
+  auto v = std::vector<pointObj>();
+  v.reserve(maxpoints);
+  return v;
+}
+
+/*
+** Add a pointObj to the pointObjArray.
+*/
+static void pointArrayAddPoint(std::vector<pointObj> &v, const pointObj &p) {
+  v.push_back(p);
+}
+
+/*
+** Pass an input type number through the PostGIS version
+** type map array to handle the pre-2.0 incorrect WKB types
+*/
+
+static int wkbTypeMap(wkbObj *w, int type, int *pnZMFlag) {
+  *pnZMFlag = 0;
+  /* PostGIS >= 2 : ISO SQL/MM style Z types ? */
+  if (type >= 1000 && type < 2000) {
+    type -= 1000;
+    *pnZMFlag = HAS_Z;
+  }
+  /* PostGIS >= 2 : ISO SQL/MM style M types ? */
+  else if (type >= 2000 && type < 3000) {
+    type -= 2000;
+    *pnZMFlag = HAS_M;
+  }
+  /* PostGIS >= 2 : ISO SQL/MM style ZM types ? */
+  else if (type >= 3000 && type < 4000) {
+    type -= 3000;
+    *pnZMFlag = HAS_Z | HAS_M;
+  }
+  /* PostGIS 1.X EWKB : Extended WKB Z or ZM ? */
+  else if ((type & WKBZOFFSET_NONISO) != 0) {
+    if ((type & WKBMOFFSET_NONISO) != 0)
+      *pnZMFlag = HAS_Z | HAS_M;
+    else
+      *pnZMFlag = HAS_Z;
+    type &= 0x00FFFFFF;
+  }
+  /* PostGIS 1.X EWKB: Extended WKB M ? */
+  else if ((type & WKBMOFFSET_NONISO) != 0) {
+    *pnZMFlag = HAS_M;
+    type &= 0x00FFFFFF;
+  }
+  if (type >= 0 && type < WKB_TYPE_COUNT)
+    return w->typemap[type];
+  else
+    return 0;
+}
+
+/*
+** Read the WKB type number from a wkbObj without
+** advancing the read pointer.
+*/
+static int wkbType(wkbObj *w, int *pnZMFlag) {
+  int t;
+  memcpy(&t, (w->ptr + 1), sizeof(int));
+  return wkbTypeMap(w, t, pnZMFlag);
+}
+
+/*
+** Read the type number of the first element of a
+** collection without advancing the read pointer.
+*/
+static int wkbCollectionSubType(wkbObj *w, int *pnZMFlag) {
+  int t;
+  memcpy(&t, (w->ptr + 1 + 4 + 4 + 1), sizeof(int));
+  return wkbTypeMap(w, t, pnZMFlag);
+}
+
+/*
+** Read one byte from the WKB and advance the read pointer
+*/
+static char wkbReadChar(wkbObj *w) {
+  char c;
+  memcpy(&c, w->ptr, sizeof(char));
+  w->ptr += sizeof(char);
+  return c;
+}
+
+/*
+** Read one integer from the WKB and advance the read pointer.
+** We assume the endianess of the WKB is the same as this machine.
+*/
+static inline int wkbReadInt(wkbObj *w) {
+  int i;
+  memcpy(&i, w->ptr, sizeof(int));
+  w->ptr += sizeof(int);
+  return i;
+}
+
+/*
+** Read one pointObj (two doubles) from the WKB and advance the read pointer.
+** We assume the endianess of the WKB is the same as this machine.
+*/
+static inline void wkbReadPointP(wkbObj *w, pointObj *p, int nZMFlag) {
+  memcpy(&(p->x), w->ptr, sizeof(double));
+  w->ptr += sizeof(double);
+  memcpy(&(p->y), w->ptr, sizeof(double));
+  w->ptr += sizeof(double);
+  if (nZMFlag & HAS_Z) {
+    memcpy(&(p->z), w->ptr, sizeof(double));
+    w->ptr += sizeof(double);
+  } else {
+    p->z = 0;
+  }
+  if (nZMFlag & HAS_M) {
+    memcpy(&(p->m), w->ptr, sizeof(double));
+    w->ptr += sizeof(double);
+  } else {
+    p->m = 0;
+  }
+}
+
+/*
+** Read one pointObj (two doubles) from the WKB and advance the read pointer.
+** We assume the endianess of the WKB is the same as this machine.
+*/
+static inline pointObj wkbReadPoint(wkbObj *w, int nZMFlag) {
+  pointObj p;
+  wkbReadPointP(w, &p, nZMFlag);
+  return p;
+}
+
+/*
+** Read a "point array" and return an allocated lineObj.
+** A point array is a WKB fragment that starts with a
+** point count, which is followed by that number of doubles * 2.
+** Linestrings, circular strings, polygon rings, all show this
+** form.
+*/
+static void wkbReadLine(wkbObj *w, lineObj *line, int nZMFlag) {
+  pointObj p;
+  const int npoints = wkbReadInt(w);
+  if (npoints > (int)((w->size - (w->ptr - w->wkb)) / 16))
+    return;
+
+  line->numpoints = npoints;
+  line->point = (pointObj *)msSmallMalloc(npoints * sizeof(pointObj));
+  for (int i = 0; i < npoints; i++) {
+    wkbReadPointP(w, &p, nZMFlag);
+    line->point[i] = p;
+  }
+}
+
+/*
+** Advance the read pointer past a geometry without returning any
+** values. Used for skipping un-drawable elements in a collection.
+*/
+static void wkbSkipGeometry(wkbObj *w) {
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+  const int nCoordDim = 2 + (((nZMFlag & HAS_Z) != 0) ? 1 : 0) +
+                        (((nZMFlag & HAS_M) != 0) ? 1 : 0);
+  switch (type) {
+  case WKB_POINT:
+    w->ptr += nCoordDim * sizeof(double);
+    break;
+  case WKB_CIRCULARSTRING:
+  case WKB_LINESTRING: {
+    const int npoints = wkbReadInt(w);
+    w->ptr += sizeof(double) * npoints * nCoordDim;
+    break;
+  }
+  case WKB_POLYGON: {
+    const int nrings = wkbReadInt(w);
+    if (nrings > (int)((w->size - (w->ptr - w->wkb)) / 4))
+      return;
+    for (int i = 0; i < nrings; i++) {
+      const int npoints = wkbReadInt(w);
+      w->ptr += sizeof(double) * npoints * nCoordDim;
+    }
+    break;
+  }
+  case WKB_MULTIPOINT:
+  case WKB_MULTILINESTRING:
+  case WKB_MULTIPOLYGON:
+  case WKB_GEOMETRYCOLLECTION:
+  case WKB_COMPOUNDCURVE:
+  case WKB_CURVEPOLYGON:
+  case WKB_MULTICURVE:
+  case WKB_MULTISURFACE: {
+    const int ngeoms = wkbReadInt(w);
+    if (ngeoms > (int)((w->size - (w->ptr - w->wkb)) / 4))
+      return;
+    for (int i = 0; i < ngeoms; i++) {
+      wkbSkipGeometry(w);
+    }
+    break;
+  }
+  }
+}
+
+/*
+** Convert a WKB point to a shapeObj, advancing the read pointer as we go.
+*/
+static int wkbConvPointToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+
+  if (type != WKB_POINT)
+    return MS_FAILURE;
+
+  if (!(shape->type == MS_SHAPE_POINT))
+    return MS_FAILURE;
+  lineObj line;
+  line.numpoints = 1;
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+  line.point[0] = wkbReadPoint(w, nZMFlag);
+  msAddLineDirectly(shape, &line);
+  return MS_SUCCESS;
+}
+
+/*
+** Convert a WKB line string to a shapeObj, advancing the read pointer as we go.
+*/
+static int wkbConvLineStringToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+
+  if (type != WKB_LINESTRING)
+    return MS_FAILURE;
+
+  lineObj line;
+  wkbReadLine(w, &line, nZMFlag);
+  msAddLineDirectly(shape, &line);
+
+  return MS_SUCCESS;
+}
+
+/*
+** Convert a WKB polygon to a shapeObj, advancing the read pointer as we go.
+*/
+static int wkbConvPolygonToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+
+  if (type != WKB_POLYGON)
+    return MS_FAILURE;
+
+  /* How many rings? */
+  const int nrings = wkbReadInt(w);
+  if (nrings > (int)((w->size - (w->ptr - w->wkb)) / 4))
+    return MS_FAILURE;
+
+  /* Add each ring to the shape */
+  lineObj line;
+  for (int i = 0; i < nrings; i++) {
+    wkbReadLine(w, &line, nZMFlag);
+    msAddLineDirectly(shape, &line);
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Convert a WKB curve polygon to a shapeObj, advancing the read pointer as we
+*go.
+** The arc portions of the rings will be stroked to linestrings as they
+** are read by the underlying circular string handling.
+*/
+static int wkbConvCurvePolygonToShape(wkbObj *w, shapeObj *shape) {
+  const int was_poly = (shape->type == MS_SHAPE_POLYGON);
+
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+  if (type != WKB_CURVEPOLYGON)
+    return MS_FAILURE;
+
+  const int ncomponents = wkbReadInt(w);
+  if (ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4))
+    return MS_FAILURE;
+
+  /* Lower the allowed dimensionality so we can
+   *  catch the linear ring components */
+  shape->type = MS_SHAPE_LINE;
+
+  int failures = 0;
+  for (int i = 0; i < ncomponents; i++) {
+    if (wkbConvGeometryToShape(w, shape) == MS_FAILURE) {
+      wkbSkipGeometry(w);
+      failures++;
+    }
+  }
+
+  /* Go back to expected dimensionality */
+  if (was_poly)
+    shape->type = MS_SHAPE_POLYGON;
+
+  if (failures == ncomponents)
+    return MS_FAILURE;
+  else
+    return MS_SUCCESS;
+}
+
+/*
+** Convert a WKB circular string to a shapeObj, advancing the read pointer as we
+*go.
+** Arcs will be stroked to linestrings.
+*/
+static int wkbConvCircularStringToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+
+  if (type != WKB_CIRCULARSTRING)
+    return MS_FAILURE;
+
+  lineObj line = {0, nullptr};
+  /* Stroke the string into a point array */
+  if (arcStrokeCircularString(w, SEGMENT_ANGLE, &line, nZMFlag) == MS_FAILURE) {
+    if (line.point)
+      free(line.point);
+    return MS_FAILURE;
+  }
+
+  /* Fill in the lineObj */
+  if (line.numpoints > 0) {
+    msAddLine(shape, &line);
+    if (line.point)
+      free(line.point);
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Compound curves need special handling. First we load
+** each component of the curve on the a lineObj in a shape.
+** Then we merge those lineObjs into a single lineObj. This
+** allows compound curves to serve as closed rings in
+** curve polygons.
+*/
+static int wkbConvCompoundCurveToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+
+  /* Init our shape buffer */
+  shapeObj shapebuf;
+  msInitShape(&shapebuf);
+
+  if (type != WKB_COMPOUNDCURVE)
+    return MS_FAILURE;
+
+  /* How many components in the compound curve? */
+  const int ncomponents = wkbReadInt(w);
+  if (ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4))
+    return MS_FAILURE;
+
+  /* We'll load each component onto a line in a shape */
+  for (int i = 0; i < ncomponents; i++)
+    wkbConvGeometryToShape(w, &shapebuf);
+
+  /* Do nothing on empty */
+  if (shapebuf.numlines == 0)
+    return MS_FAILURE;
+
+  /* Count the total number of points */
+  int npoints = 0;
+  for (int i = 0; i < shapebuf.numlines; i++)
+    npoints += shapebuf.line[i].numpoints;
+
+  /* Do nothing on empty */
+  if (npoints == 0)
+    return MS_FAILURE;
+
+  lineObj line;
+  line.numpoints = npoints;
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
+
+  /* Copy in the points */
+  npoints = 0;
+  for (int i = 0; i < shapebuf.numlines; i++) {
+    for (int j = 0; j < shapebuf.line[i].numpoints; j++) {
+      /* Don't add a start point that duplicates an endpoint */
+      if (j == 0 && i > 0 &&
+          memcmp(&(line.point[npoints - 1]), &(shapebuf.line[i].point[j]),
+                 sizeof(pointObj)) == 0) {
+        continue;
+      }
+      line.point[npoints++] = shapebuf.line[i].point[j];
+    }
+  }
+  line.numpoints = npoints;
+
+  /* Clean up */
+  msFreeShape(&shapebuf);
+
+  /* Fill in the lineObj */
+  msAddLineDirectly(shape, &line);
+
+  return MS_SUCCESS;
+}
+
+/*
+** Convert a WKB collection string to a shapeObj, advancing the read pointer as
+*we go.
+** Many WKB types (MultiPoint, MultiLineString, MultiPolygon, MultiSurface,
+** MultiCurve, GeometryCollection) can be treated identically as collections
+** (they start with endian, type number and count of sub-elements, then provide
+*the
+** subelements as WKB) so are handled with this one function.
+*/
+static int wkbConvCollectionToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
+  int nZMFlag;
+  /*type = */ wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+  const int ncomponents = wkbReadInt(w);
+  if (ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4))
+    return MS_FAILURE;
+
+  /*
+   * If we can draw any portion of the collection, we will,
+   * but if all the components fail, we will draw nothing.
+   */
+  int failures = 0;
+  for (int i = 0; i < ncomponents; i++) {
+    if (wkbConvGeometryToShape(w, shape) == MS_FAILURE) {
+      wkbSkipGeometry(w);
+      failures++;
+    }
+  }
+  if (failures == ncomponents || ncomponents == 0)
+    return MS_FAILURE;
+  else
+    return MS_SUCCESS;
+}
+
+/*
+** Generic handler to switch to the appropriate function for the WKB type.
+** Note that we also handle switching here to avoid processing shapes
+** we will be unable to draw. Example: we can't draw point features as
+** a MS_SHAPE_LINE layer, so if the type is WKB_POINT and the layer is
+** MS_SHAPE_LINE, we exit before converting.
+*/
+static int wkbConvGeometryToShape(wkbObj *w, shapeObj *shape) {
+  int nZMFlag;
+  const int wkbtype = wkbType(w, &nZMFlag); /* Peak at the type number */
+
+  switch (wkbtype) {
+    /* Recurse into anonymous collections */
+  case WKB_GEOMETRYCOLLECTION:
+    return wkbConvCollectionToShape(w, shape);
+    /* Handle area types */
+  case WKB_POLYGON:
+    return wkbConvPolygonToShape(w, shape);
+  case WKB_MULTIPOLYGON:
+    return wkbConvCollectionToShape(w, shape);
+  case WKB_CURVEPOLYGON:
+    return wkbConvCurvePolygonToShape(w, shape);
+  case WKB_MULTISURFACE:
+    return wkbConvCollectionToShape(w, shape);
+  }
+
+  /* We can't convert any of the following types into polygons */
+  if (shape->type == MS_SHAPE_POLYGON)
+    return MS_FAILURE;
+
+  /* Handle linear types */
+  switch (wkbtype) {
+  case WKB_LINESTRING:
+    return wkbConvLineStringToShape(w, shape);
+  case WKB_CIRCULARSTRING:
+    return wkbConvCircularStringToShape(w, shape);
+  case WKB_COMPOUNDCURVE:
+    return wkbConvCompoundCurveToShape(w, shape);
+  case WKB_MULTILINESTRING:
+    return wkbConvCollectionToShape(w, shape);
+  case WKB_MULTICURVE:
+    return wkbConvCollectionToShape(w, shape);
+  }
+
+  /* We can't convert any of the following types into lines */
+  if (shape->type == MS_SHAPE_LINE)
+    return MS_FAILURE;
+
+  /* Handle point types */
+  switch (wkbtype) {
+  case WKB_POINT:
+    return wkbConvPointToShape(w, shape);
+  case WKB_MULTIPOINT:
+    return wkbConvCollectionToShape(w, shape);
+  }
+
+  /* This is a WKB type we don't know about! */
+  return MS_FAILURE;
+}
+
+/*
+** What side of p1->p2 is q on?
+*/
+static inline int arcSegmentSide(const pointObj &p1, const pointObj &p2,
+                                 const pointObj &q) {
+  double side = ((q.x - p1.x) * (p2.y - p1.y) - (p2.x - p1.x) * (q.y - p1.y));
+  if (FP_EQ(side, 0.0)) {
+    return FP_COLINEAR;
+  } else {
+    if (side < 0.0)
+      return FP_LEFT;
+    else
+      return FP_RIGHT;
+  }
+}
+
+/*
+** Calculate the center of the circle defined by three points.
+** Using matrix approach from
+*http://mathforum.org/library/drmath/view/55239.html
+*/
+static int arcCircleCenter(const pointObj &p1, const pointObj &p2,
+                           const pointObj &p3, pointObj *center,
+                           double *radius) {
+  pointObj c{}; // initialize
+  double r;
+
+  /* Circle is closed, so p2 must be opposite p1 & p3. */
+  if ((fabs(p1.x - p3.x) < FP_EPSILON) && (fabs(p1.y - p3.y) < FP_EPSILON)) {
+    c.x = p1.x + (p2.x - p1.x) / 2.0;
+    c.y = p1.y + (p2.y - p1.y) / 2.0;
+    r = sqrt(pow(c.x - p1.x, 2.0) + pow(c.y - p1.y, 2.0));
+  }
+  /* There is no circle here, the points are actually co-linear */
+  else if (arcSegmentSide(p1, p3, p2) == FP_COLINEAR) {
+    return MS_FAILURE;
+  }
+  /* Calculate the center and radius. */
+  else {
+
+    /* Radius */
+    const double dx21 = p2.x - p1.x;
+    const double dy21 = p2.y - p1.y;
+    const double dx31 = p3.x - p1.x;
+    const double dy31 = p3.y - p1.y;
+
+    const double h21 = pow(dx21, 2.0) + pow(dy21, 2.0);
+    const double h31 = pow(dx31, 2.0) + pow(dy31, 2.0);
+
+    /* 2 * |Cross product|, d<0 means clockwise and d>0 counterclockwise
+     * sweeping angle */
+    const double d = 2 * (dx21 * dy31 - dx31 * dy21);
+
+    c.x = p1.x + (h21 * dy31 - h31 * dy21) / d;
+    c.y = p1.y - (h21 * dx31 - h31 * dx21) / d;
+    r = sqrt(pow(c.x - p1.x, 2) + pow(c.y - p1.y, 2));
+  }
+
+  if (radius)
+    *radius = r;
+  if (center)
+    *center = c;
+
+  return MS_SUCCESS;
+}
+
+/*
+** Write a stroked version of the circle defined by three points into a
+** point buffer. The segment_angle (degrees) is the coverage of each stroke
+*segment,
+** and depending on whether this is the first arc in a circularstring,
+** you might want to include_first
+*/
+static int arcStrokeCircle(const pointObj &p1, const pointObj &p2,
+                           const pointObj &p3, double segment_angle,
+                           int include_first, std::vector<pointObj> &pa) {
+  const int side =
+      arcSegmentSide(p1, p3, p2); /* What side of p1,p3 is the middle point? */
+  int is_closed = MS_FALSE;
+
+  /* We need to know if we're dealing with a circle early */
+  if (FP_EQ(p1.x, p3.x) && FP_EQ(p1.y, p3.y))
+    is_closed = MS_TRUE;
+
+  /* Check if the "arc" is actually straight */
+  if (!is_closed && side == FP_COLINEAR) {
+    /* We just need to write in the end points */
+    if (include_first)
+      pointArrayAddPoint(pa, p1);
+    pointArrayAddPoint(pa, p3);
+    return MS_SUCCESS;
+  }
+
+  /* We should always be able to find the center of a non-linear arc */
+  pointObj center; /* Center of our circular arc */
+  double radius;   /* Radius of our circular arc */
+  if (arcCircleCenter(p1, p2, p3, &center, &radius) == MS_FAILURE)
+    return MS_FAILURE;
+
+  /* Calculate the angles relative to center that our three points represent */
+  const double a1 = atan2(p1.y - center.y, p1.x - center.x);
+  /* UNUSED
+  a2 = atan2(p2.y - center.y, p2.x - center.x);
+   */
+  const double a3 = atan2(p3.y - center.y, p3.x - center.x);
+  double segment_angle_r =
+      M_PI * segment_angle / 180.0; /* Segment angle in radians */
+
+  double sweep_angle_r; /* Total angular size of our circular arc in radians */
+  /* Closed-circle case, we sweep the whole circle! */
+  if (is_closed) {
+    sweep_angle_r = 2.0 * M_PI;
+  }
+  /* Clockwise sweep direction */
+  else if (side == FP_LEFT) {
+    if (a3 > a1) /* Wrapping past 180? */
+      sweep_angle_r = a1 + (2.0 * M_PI - a3);
+    else
+      sweep_angle_r = a1 - a3;
+  }
+  /* Counter-clockwise sweep direction */
+  else if (side == FP_RIGHT) {
+    if (a3 > a1) /* Wrapping past 180? */
+      sweep_angle_r = a3 - a1;
+    else
+      sweep_angle_r = a3 + (2.0 * M_PI - a1);
+  } else
+    sweep_angle_r = 0.0;
+
+  /* We don't have enough resolution, let's invert our strategy. */
+  if ((sweep_angle_r / segment_angle_r) < SEGMENT_MINPOINTS) {
+    segment_angle_r = sweep_angle_r / (SEGMENT_MINPOINTS + 1);
+  }
+
+  /* We don't have enough resolution to stroke this arc,
+   *  so just join the start to the end. */
+  if (sweep_angle_r < segment_angle_r) {
+    if (include_first)
+      pointArrayAddPoint(pa, p1);
+    pointArrayAddPoint(pa, p3);
+    return MS_SUCCESS;
+  }
+
+  /* How many edges to generate (we add the final edge
+   *  by sticking on the last point */
+  int num_edges = floor(sweep_angle_r / fabs(segment_angle_r));
+
+  /* Go backwards (negative angular steps) if we are stroking clockwise */
+  if (side == FP_LEFT)
+    segment_angle_r *= -1;
+
+  /* What point should we start with? */
+  double current_angle_r; /* What angle are we generating now (radians)? */
+  if (include_first) {
+    current_angle_r = a1;
+  } else {
+    current_angle_r = a1 + segment_angle_r;
+    num_edges--;
+  }
+
+  /* For each edge, increment or decrement by our segment angle */
+  for (int i = 0; i < num_edges; i++) {
+    if (segment_angle_r > 0.0 && current_angle_r > M_PI)
+      current_angle_r -= 2 * M_PI;
+    if (segment_angle_r < 0.0 && current_angle_r < -1 * M_PI)
+      current_angle_r -= 2 * M_PI;
+    pointObj p;
+    p.x = center.x + radius * cos(current_angle_r);
+    p.y = center.y + radius * sin(current_angle_r);
+    p.z = 0;
+    p.m = 0;
+    pointArrayAddPoint(pa, p);
+    current_angle_r += segment_angle_r;
+  }
+
+  /* Add the last point */
+  pointArrayAddPoint(pa, p3);
+  return MS_SUCCESS;
+}
+
+/*
+** This function does not actually take WKB as input, it takes the
+** WKB starting from the numpoints integer. Each three-point edge
+** is stroked into a linestring and appended into the lineObj
+** argument.
+*/
+static int arcStrokeCircularString(wkbObj *w, double segment_angle,
+                                   lineObj *line, int nZMFlag) {
+  if (!w || !line)
+    return MS_FAILURE;
+
+  const int npoints = wkbReadInt(w);
+  const int nedges = npoints / 2;
+
+  /* All CircularStrings have an odd number of points */
+  if (npoints < 3 || npoints % 2 != 1)
+    return MS_FAILURE;
+
+  /* Make a large guess at how much space we'll need */
+  auto pa = pointArrayNew(nedges * 180 / segment_angle);
+
+  pointObj p1, p2, p3;
+  wkbReadPointP(w, &p3, nZMFlag);
+
+  /* Fill out the point array with stroked arcs */
+  int edge = 0;
+  while (edge < nedges) {
+    p1 = p3;
+    wkbReadPointP(w, &p2, nZMFlag);
+    wkbReadPointP(w, &p3, nZMFlag);
+    if (arcStrokeCircle(p1, p2, p3, segment_angle, edge ? 0 : 1, pa) ==
+        MS_FAILURE) {
+      return MS_FAILURE;
+    }
+    edge++;
+  }
+
+  /* Copy the point array into the line */
+  line->numpoints = static_cast<int>(pa.size());
+  line->point = (pointObj *)msSmallMalloc(line->numpoints * sizeof(pointObj));
+  memcpy(line->point, pa.data(), line->numpoints * sizeof(pointObj));
+
+  return MS_SUCCESS;
+}
+
+/*
+** For LAYER types that are not the usual ones (charts,
+** annotations, etc) we will convert to a shape type
+** that "makes sense" given the WKB input. We do this
+** by peaking at the type number of the first collection
+** sub-element.
+*/
+static int msPostGISFindBestType(wkbObj *w, shapeObj *shape) {
+  /* What kind of geometry is this? */
+  int nZMFlag;
+  int wkbtype = wkbType(w, &nZMFlag);
+
+  /* Generic collection, we need to look a little deeper. */
+  if (wkbtype == WKB_GEOMETRYCOLLECTION)
+    wkbtype = wkbCollectionSubType(w, &nZMFlag);
+
+  switch (wkbtype) {
+  case WKB_POLYGON:
+  case WKB_CURVEPOLYGON:
+  case WKB_MULTIPOLYGON:
+    shape->type = MS_SHAPE_POLYGON;
+    break;
+  case WKB_LINESTRING:
+  case WKB_CIRCULARSTRING:
+  case WKB_COMPOUNDCURVE:
+  case WKB_MULTICURVE:
+  case WKB_MULTILINESTRING:
+    shape->type = MS_SHAPE_LINE;
+    break;
+  case WKB_POINT:
+  case WKB_MULTIPOINT:
+    shape->type = MS_SHAPE_POINT;
+    break;
+  default:
+    return MS_FAILURE;
+  }
+
+  return wkbConvGeometryToShape(w, shape);
+}
+
+/*
+** Get the PostGIS version number from the database as integer.
+** Versions are multiplied out as with PgSQL: 1.5.2 -> 10502, 2.0.0 -> 20000.
+*/
+static int msPostGISRetrieveVersion(PGconn *pgconn) {
+  static const char *sql = "SELECT postgis_version()";
+  if (!pgconn) {
+    msSetError(MS_QUERYERR, "No open connection.",
+               "msPostGISRetrieveVersion()");
+    return MS_FAILURE;
+  }
+
+  PGresult *pgresult =
+      PQexecParams(pgconn, sql, 0, nullptr, nullptr, nullptr, nullptr, 0);
+
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+    msDebug("Error executing SQL: (%s) in msPostGISRetrieveVersion()", sql);
+    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.",
+               "msPostGISRetrieveVersion()");
+    return MS_FAILURE;
+  }
+
+  if (PQgetisnull(pgresult, 0, 0)) {
+    PQclear(pgresult);
+    msSetError(MS_QUERYERR, "Null result returned.",
+               "msPostGISRetrieveVersion()");
+    return MS_FAILURE;
+  }
+
+  std::string strVersion = PQgetvalue(pgresult, 0, 0);
+  PQclear(pgresult);
+
+  char *ptr = &strVersion[0];
+  char *strParts[3] = {nullptr, nullptr, nullptr};
+  int j = 0;
+  strParts[j++] = &strVersion[0];
+  while (*ptr != '\0' && j < 3) {
+    if (*ptr == '.') {
+      *ptr = '\0';
+      strParts[j++] = ptr + 1;
+    }
+    if (*ptr == ' ') {
+      *ptr = '\0';
+      break;
+    }
+    ptr++;
+  }
+
+  int version = 0;
+  int factor = 10000;
+  for (int i = 0; i < j; i++) {
+    version += factor * atoi(strParts[i]);
+    factor = factor / 100;
+  }
+
+  return version;
+}
+
+/*
+** Get the PostgreSQL server version number from the database as integer.
+** 12.7.1 ==> 120701
+*/
+static int msPostGISRetrievePostgreSQLVersion(PGconn *pgconn) {
+  static const char *sql = "SELECT version()";
+  if (!pgconn) {
+    msSetError(MS_QUERYERR, "No open connection.",
+               "msPostGISRetrievePostgreSQLVersion()");
+    return MS_FAILURE;
+  }
+
+  PGresult *pgresult =
+      PQexecParams(pgconn, sql, 0, nullptr, nullptr, nullptr, nullptr, 0);
+
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+    msDebug("Error executing SQL: (%s) in msPostGISRetrievePostgreSQLVersion()",
+            sql);
+    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.",
+               "msPostGISRetrievePostgreSQLVersion()");
+    return MS_FAILURE;
+  }
+
+  if (PQgetisnull(pgresult, 0, 0)) {
+    PQclear(pgresult);
+    msSetError(MS_QUERYERR, "Null result returned.",
+               "msPostGISRetrievePostgreSQLVersion()");
+    return MS_FAILURE;
+  }
+
+  std::string strVersion = PQgetvalue(pgresult, 0, 0);
+  PQclear(pgresult);
+
+  // Skip leading "PostgreSQL " (or other vendorized name)
+  auto nPos = strVersion.find(' ');
+  if (nPos == std::string::npos)
+    return 0;
+
+  char *ptr = &strVersion[nPos + 1];
+  char *strParts[3] = {nullptr, nullptr, nullptr};
+  int j = 0;
+  strParts[j++] = ptr;
+  while (*ptr != '\0' && j < 3) {
+    if (*ptr == '.') {
+      *ptr = '\0';
+      strParts[j++] = ptr + 1;
+    }
+    if (*ptr == ' ') {
+      *ptr = '\0';
+      break;
+    }
+    ptr++;
+  }
+
+  int version = 0;
+  int factor = 10000;
+  for (int i = 0; i < j; i++) {
+    version += factor * atoi(strParts[i]);
+    factor = factor / 100;
+  }
+
+  return version;
+}
+
+/*
+** msPostGISRetrievePK()
+**
+** Find out that the primary key is for this layer.
+** The layerinfo->fromsource must already be populated and
+** must not be a subquery.
+*/
+static int msPostGISRetrievePK(layerObj *layer) {
+  char *sql = nullptr;
+
+  if (layer->debug) {
+    msDebug("msPostGISRetrievePK called.\n");
+  }
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  if (layerinfo->pgconn == nullptr) {
+    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.",
+               "msPostGISRetrievePK()");
+    return MS_FAILURE;
+  }
+
+  {
+    /* Attempt to separate fromsource into schema.table */
+    std::string schema;
+    std::string table;
+    const auto pos_sep = layerinfo->fromsource.find('.');
+    if (pos_sep != std::string::npos) {
+      schema = layerinfo->fromsource.substr(0, pos_sep);
+      table = layerinfo->fromsource.substr(pos_sep + 1);
+
+      if (layer->debug) {
+        msDebug("msPostGISRetrievePK(): Found schema %s, table %s.\n",
+                schema.c_str(), table.c_str());
+      }
+    }
+    /*
+    ** PostgreSQL v7.3 and later treat primary keys as constraints.
+    ** We only support single column primary keys, so multicolumn
+    ** pks are explicitly excluded from the query.
+    */
+    if (!schema.empty()) {
+      static const char *v73sql =
+          "select attname from pg_attribute, pg_constraint, pg_class, "
+          "pg_namespace where pg_constraint.conrelid = pg_class.oid and "
+          "pg_class.oid = pg_attribute.attrelid and pg_constraint.contype = "
+          "'p' and pg_constraint.conkey[1] = pg_attribute.attnum and "
+          "pg_class.relname = '%s' and pg_class.relnamespace = "
+          "pg_namespace.oid and pg_namespace.nspname = '%s' and "
+          "pg_constraint.conkey[2] is null";
+      sql = (char *)msSmallMalloc(schema.size() + table.size() +
+                                  strlen(v73sql) + 1);
+      sprintf(sql, v73sql, table.c_str(), schema.c_str());
+    } else {
+      static const char *v73sql =
+          "select attname from pg_attribute, pg_constraint, pg_class where "
+          "pg_constraint.conrelid = pg_class.oid and pg_class.oid = "
+          "pg_attribute.attrelid and pg_constraint.contype = 'p' and "
+          "pg_constraint.conkey[1] = pg_attribute.attnum and pg_class.relname "
+          "= '%s' and pg_table_is_visible(pg_class.oid) and "
+          "pg_constraint.conkey[2] is null";
+      sql = (char *)msSmallMalloc(layerinfo->fromsource.size() +
+                                  strlen(v73sql) + 1);
+      sprintf(sql, v73sql, layerinfo->fromsource.c_str());
+    }
+  }
+
+  if (layer->debug > 1) {
+    msDebug("msPostGISRetrievePK: %s\n", sql);
+  }
+
+  layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  if (layerinfo->pgconn == nullptr) {
+    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.",
+               "msPostGISRetrievePK()");
+    free(sql);
+    return MS_FAILURE;
+  }
+
+  PGresult *pgresult = PQexecParams(layerinfo->pgconn, sql, 0, nullptr, nullptr,
+                                    nullptr, nullptr, 0);
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+    msSetError(MS_QUERYERR, "%s", "msPostGISRetrievePK()",
+               (std::string("Error executing SQL: ") + sql).c_str());
+    return MS_FAILURE;
+  }
+
+  if (PQntuples(pgresult) < 1) {
+    if (layer->debug) {
+      msDebug("msPostGISRetrievePK: No results found.\n");
+    }
+    PQclear(pgresult);
+    free(sql);
+    return MS_FAILURE;
+  }
+  if (PQntuples(pgresult) > 1) {
+    if (layer->debug) {
+      msDebug("msPostGISRetrievePK: Multiple results found.\n");
+    }
+    PQclear(pgresult);
+    free(sql);
+    return MS_FAILURE;
+  }
+
+  if (PQgetisnull(pgresult, 0, 0)) {
+    if (layer->debug) {
+      msDebug("msPostGISRetrievePK: Null result returned.\n");
+    }
+    PQclear(pgresult);
+    free(sql);
+    return MS_FAILURE;
+  }
+
+  layerinfo->uid = PQgetvalue(pgresult, 0, 0);
+
+  PQclear(pgresult);
+  free(sql);
+  return MS_SUCCESS;
+}
+
+/*
+** msPostGISParseData()
+**
+** Parse the DATA string for geometry column name, table name,
+** unique id column, srid, and SQL string.
+*/
+static int msPostGISParseData(layerObj *layer) {
+  assert(layer != nullptr);
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)(layer->layerinfo);
+
+  if (layer->debug) {
+    msDebug("msPostGISParseData called.\n");
+  }
+
+  if (!layer->data) {
+    msSetError(
+        MS_QUERYERR,
+        "Missing DATA clause. DATA statement must contain 'geometry_column "
+        "from table_name' or 'geometry_column from (sub-query) as sub'.",
+        "msPostGISParseData()");
+    return MS_FAILURE;
+  }
+
+  std::string data(layer->data);
+  for (char &ch : data) {
+    if (ch == '\t' || ch == '\r' || ch == '\n') {
+      ch = ' ';
+    }
+  }
+
+  /*
+  ** Clean up any existing strings first, as we will be populating these fields.
+  */
+  layerinfo->srid.clear();
+  layerinfo->uid.clear();
+  layerinfo->geomcolumn.clear();
+  layerinfo->fromsource.clear();
+
+  /*
+  ** Look for the optional ' using ' clauses.
+  */
+  const char *pos_srid = nullptr;
+  const char *pos_uid = nullptr;
+  const char *pos_use_1st = nullptr;
+  const char *pos_use_2nd = nullptr;
+  {
+    const char *tmp = strcasestr(data.c_str(), " using ");
+    while (tmp) {
+      pos_use_1st = pos_use_2nd;
+      pos_use_2nd = tmp + 1;
+      tmp = strcasestr(tmp + 1, " using ");
+    }
+  }
+
+  /*
+  ** What clause appear after 2nd 'using', if set?
+  */
+  if (pos_use_2nd) {
+    const char *tmp;
+    for (tmp = pos_use_2nd + 5; *tmp == ' '; tmp++)
+      ;
+    if (strncasecmp(tmp, "unique ", 7) == 0)
+      for (pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++)
+        ;
+    if (strncasecmp(tmp, "srid=", 5) == 0)
+      pos_srid = tmp + 5;
+  };
+
+  /*
+  ** What clause appear after 1st 'using', if set?
+  */
+  if (pos_use_1st) {
+    const char *tmp;
+    for (tmp = pos_use_1st + 5; *tmp == ' '; tmp++)
+      ;
+    if (strncasecmp(tmp, "unique ", 7) == 0) {
+      if (pos_uid) {
+        msSetError(MS_QUERYERR,
+                   "Error parsing PostGIS DATA variable. Too many 'USING "
+                   "UNIQUE' found! %s",
+                   "msPostGISParseData()", layer->data);
+        return MS_FAILURE;
+      };
+      for (pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++)
+        ;
+    };
+    if (strncasecmp(tmp, "srid=", 5) == 0) {
+      if (pos_srid) {
+        msSetError(MS_QUERYERR,
+                   "Error parsing PostGIS DATA variable. Too many 'USING SRID' "
+                   "found! %s",
+                   "msPostGISParseData()", layer->data);
+        return MS_FAILURE;
+      }
+      pos_srid = tmp + 5;
+    }
+  }
+
+  /*
+  ** Look for the optional ' using unique ID' string first.
+  */
+  if (pos_uid) {
+    /* Find the end of this case 'using unique ftab_id using srid=33' */
+    const char *tmp = strstr(pos_uid, " ");
+    /* Find the end of this case 'using srid=33 using unique ftab_id' */
+    if (!tmp) {
+      tmp = pos_uid + strlen(pos_uid);
+    }
+    layerinfo->uid.assign(pos_uid, tmp - pos_uid);
+    msStringTrim(layerinfo->uid);
+  }
+
+  /*
+  ** Look for the optional ' using srid=333 ' string next.
+  */
+  if (pos_srid) {
+    const int slength = strspn(pos_srid, "-0123456789");
+    if (!slength) {
+      msSetError(MS_QUERYERR,
+                 "Error parsing PostGIS DATA variable. You specified 'USING "
+                 "SRID' but didn't have any numbers! %s",
+                 "msPostGISParseData()", layer->data);
+      return MS_FAILURE;
+    } else {
+      layerinfo->srid.assign(pos_srid, slength);
+      msStringTrim(layerinfo->srid);
+    }
+  }
+
+  /*
+   * This is a little hack so the rest of the code works.
+   * pos_opt should point to the start of the optional blocks.
+   *
+   * If they are both set, return the smaller one.
+   * If pos_use_1st set, then it smaller.
+   * If one or none is set, return the larger one.
+   */
+  const char *pos_opt = pos_use_1st ? pos_use_1st : pos_use_2nd;
+  /* No pos_opt? Move it to the end of the string. */
+  if (!pos_opt) {
+    pos_opt = data.c_str() + data.size();
+  }
+  /* Back after the last non-space character. */
+  while ((pos_opt > data.c_str()) && (*(pos_opt - 1) == ' ')) {
+    --pos_opt;
+  }
+
+  /*
+  ** Scan for the 'geometry from table' or 'geometry from () as foo' clause.
+  */
+
+  /* Find the first non-white character to start from */
+  const char *pos_geom;
+  for (pos_geom = data.c_str(); *pos_geom == ' '; pos_geom++) {
+  }
+
+  /* Find the end of the geom column name */
+  const char *pos_scn = strcasestr(data.c_str(), " from ");
+  if (!pos_scn) {
+    msSetError(MS_QUERYERR,
+               "Error parsing PostGIS DATA variable. Must contain 'geometry "
+               "from table' or 'geometry from (subselect) as foo'. %s",
+               "msPostGISParseData()", layer->data);
+    return MS_FAILURE;
+  }
+
+  /* Copy the geometry column name */
+  layerinfo->geomcolumn.assign(pos_geom, pos_scn - pos_geom);
+  msStringTrim(layerinfo->geomcolumn);
+
+  /* Copy the table name or sub-select clause */
+  for (pos_scn += 6; *pos_scn == ' '; pos_scn++)
+    ;
+  if (pos_opt - pos_scn < 1) {
+    msSetError(MS_QUERYERR,
+               "Error parsing PostGIS DATA variable.  Must contain 'geometry "
+               "from table' or 'geometry from (subselect) as foo'. %s",
+               "msPostGISParseData()", layer->data);
+    return MS_FAILURE;
+  };
+  layerinfo->fromsource.assign(layer->data + (pos_scn - data.c_str()),
+                               pos_opt - pos_scn);
+  msStringTrim(layerinfo->fromsource);
+
+  /* Something is wrong, our goemetry column and table references are not there.
+   */
+  if (layerinfo->fromsource.empty() || layerinfo->geomcolumn.empty()) {
+    msSetError(MS_QUERYERR,
+               "Error parsing PostGIS DATA variable.  Must contain 'geometry "
+               "from table' or 'geometry from (subselect) as foo'. %s",
+               "msPostGISParseData()", layer->data);
+    return MS_FAILURE;
+  }
+
+  /*
+  ** We didn't find a ' using unique ' in the DATA string so try and find a
+  ** primary key on the table.
+  */
+  if (layerinfo->uid.empty()) {
+    if (strstr(layerinfo->fromsource.c_str(), " ")) {
+      msSetError(
+          MS_QUERYERR,
+          "Error parsing PostGIS DATA variable.  You must specify 'using "
+          "unique' when supplying a subselect in the data definition.",
+          "msPostGISParseData()");
+      return MS_FAILURE;
+    }
+    if (msPostGISRetrievePK(layer) != MS_SUCCESS) {
+      if (layerinfo->pgconn &&
+          msPostGISRetrievePostgreSQLVersion(layerinfo->pgconn) < 120000) {
+        /* For PostgreSQL < 12: No user specified unique id so we will use the
+         * PostgreSQL oid */
+        layerinfo->uid = "oid";
+      } else {
+        msSetError(MS_QUERYERR,
+                   "Error parsing PostGIS DATA variable. "
+                   "No primary key was found. "
+                   "You must specify 'using unique'.",
+                   "msPostGISParseData()");
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  if (layer->debug) {
+    msDebug("msPostGISParseData: unique_column=%s, srid=%s, "
+            "geom_column_name=%s, table_name=%s\n",
+            layerinfo->uid.c_str(), layerinfo->srid.c_str(),
+            layerinfo->geomcolumn.c_str(), layerinfo->fromsource.c_str());
+  }
+  return MS_SUCCESS;
+}
+
+#if TRANSFER_ENCODING == 16
+
+// This is dead code given current settings in mappostgis.h
+
+/*
+** Decode a hex character.
+*/
+static const unsigned char msPostGISHexDecodeChar[256] = {
+    /* not Hex characters */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    /* 0-9 */
+    0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
+    /* not Hex characters */
+    64, 64, 64, 64, 64, 64, 64,
+    /* A-F */
+    10, 11, 12, 13, 14, 15,
+    /* not Hex characters */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64,
+    /* a-f */
+    10, 11, 12, 13, 14, 15, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    /* not Hex characters (upper 128 characters) */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64};
+
+/*
+** Decode hex string "src" (null terminated)
+** into "dest" (not null terminated).
+** Returns length of decoded array or 0 on failure.
+*/
+static int msPostGISHexDecode(unsigned char *dest, const char *src,
+                              int srclen) {
+
+  if (src && *src && (srclen % 2 == 0)) {
+
+    unsigned char *p = dest;
+    int i;
+
+    for (i = 0; i < srclen; i += 2) {
+      const unsigned char c1 = src[i];
+      const unsigned char c2 = src[i + 1];
+      const unsigned char b1 = msPostGISHexDecodeChar[c1];
+      const unsigned char b2 = msPostGISHexDecodeChar[c2];
+
+      *p++ = (b1 << 4) | b2;
+    }
+    return (p - dest);
+  }
+  return 0;
+}
+
+/*
+** Decode a base64 character.
+*/
+static const unsigned char msPostGISBase64DecodeChar[256] = {
+    /* not Base64 characters */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64,
+    /*  +  */
+    62,
+    /* not Base64 characters */
+    64, 64, 64,
+    /*  /  */
+    63,
+    /* 0-9 */
+    52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
+    /* not Base64 characters */
+    64, 64, 64, 64, 64, 64, 64,
+    /* A-Z */
+    0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
+    21, 22, 23, 24, 25,
+    /* not Base64 characters */
+    64, 64, 64, 64, 64, 64,
+    /* a-z */
+    26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44,
+    45, 46, 47, 48, 49, 50, 51,
+    /* not Base64 characters */
+    64, 64, 64, 64, 64,
+    /* not Base64 characters (upper 128 characters) */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64};
+
+/*
+** Decode base64 string "src" (null terminated)
+** into "dest" (not null terminated).
+** Returns length of decoded array or 0 on failure.
+*/
+static int msPostGISBase64Decode(unsigned char *dest, const char *src,
+                                 int srclen) {
+
+  if (src && *src) {
+
+    unsigned char *p = dest;
+    int i, j, k;
+    unsigned char *buf =
+        (unsigned char *)calloc(srclen + 1, sizeof(unsigned char));
+
+    /* Drop illegal chars first */
+    for (i = 0, j = 0; src[i]; i++) {
+      unsigned char c = src[i];
+      if ((msPostGISBase64DecodeChar[c] != 64) || (c == '=')) {
+        buf[j++] = c;
+      }
+    }
+
+    for (k = 0; k < j; k += 4) {
+      unsigned char c1 = 'A', c2 = 'A', c3 = 'A', c4 = 'A';
+      unsigned char b1 = 0, b2 = 0, b3 = 0, b4 = 0;
+
+      c1 = buf[k];
+
+      if (k + 1 < j) {
+        c2 = buf[k + 1];
+      }
+      if (k + 2 < j) {
+        c3 = buf[k + 2];
+      }
+      if (k + 3 < j) {
+        c4 = buf[k + 3];
+      }
+
+      b1 = msPostGISBase64DecodeChar[c1];
+      b2 = msPostGISBase64DecodeChar[c2];
+      b3 = msPostGISBase64DecodeChar[c3];
+      b4 = msPostGISBase64DecodeChar[c4];
+
+      *p++ = ((b1 << 2) | (b2 >> 4));
+      if (c3 != '=') {
+        *p++ = (((b2 & 0xf) << 4) | (b3 >> 2));
+      }
+      if (c4 != '=') {
+        *p++ = (((b3 & 0x3) << 6) | b4);
+      }
+    }
+    free(buf);
+    return (p - dest);
+  }
+  return 0;
+}
+
+#endif
+
+/*
+** msPostGISBuildSQLBox()
+**
+** Returns malloc'ed char* that must be freed by caller.
+*/
+static char *msPostGISBuildSQLBox(layerObj *layer, const rectObj *rect,
+                                  const char *strSRID) {
+
+  char *strBox = nullptr;
+  size_t sz;
+
+  if (layer->debug) {
+    msDebug("msPostGISBuildSQLBox called.\n");
+  }
+
+  const bool bIsPoint = rect->minx == rect->maxx && rect->miny == rect->maxy;
+
+  if (strSRID) {
+    static const char *strBoxTemplate =
+        "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g "
+        "%.15g,%.15g %.15g))',%s)";
+    static const char *strBoxTemplatePoint =
+        "ST_GeomFromText('POINT(%.15g %.15g)',%s)";
+    /* 10 doubles + 1 integer + template characters */
+    sz = 10 * 22 + strlen(strSRID) + strlen(strBoxTemplate);
+    strBox = (char *)msSmallMalloc(sz + 1); /* add space for terminating NULL */
+    if ((bIsPoint && sz <= static_cast<size_t>(
+                               snprintf(strBox, sz, strBoxTemplatePoint,
+                                        rect->minx, rect->miny, strSRID))) ||
+        (!bIsPoint &&
+         sz <= static_cast<size_t>(snprintf(
+                   strBox, sz, strBoxTemplate, rect->minx, rect->miny,
+                   rect->minx, rect->maxy, rect->maxx, rect->maxy, rect->maxx,
+                   rect->miny, rect->minx, rect->miny, strSRID)))) {
+      msSetError(MS_MISCERR, "Bounding box digits truncated.",
+                 "msPostGISBuildSQLBox");
+      return nullptr;
+    }
+  } else {
+    static const char *strBoxTemplate =
+        "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g "
+        "%.15g,%.15g %.15g))')";
+    static const char *strBoxTemplatePoint =
+        "ST_GeomFromText('POINT(%.15g %.15g)')";
+    /* 10 doubles + template characters */
+    sz = 10 * 22 + strlen(strBoxTemplate);
+    strBox = (char *)msSmallMalloc(sz + 1); /* add space for terminating NULL */
+    if ((bIsPoint &&
+         sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplatePoint,
+                                            rect->minx, rect->miny))) ||
+        (!bIsPoint &&
+         sz <= static_cast<size_t>(
+                   snprintf(strBox, sz, strBoxTemplate, rect->minx, rect->miny,
+                            rect->minx, rect->maxy, rect->maxx, rect->maxy,
+                            rect->maxx, rect->miny, rect->minx, rect->miny)))) {
+      msSetError(MS_MISCERR, "Bounding box digits truncated.",
+                 "msPostGISBuildSQLBox");
+      return nullptr;
+    }
+  }
+
+  return strBox;
+}
+
+/*
+** msPostGISBuildSQLItems()
+**
+** Returns malloc'ed char* that must be freed by caller.
+*/
+static std::string msPostGISBuildSQLItems(layerObj *layer) {
+
+  const char *strEndian = nullptr;
+  if (layer->debug) {
+    msDebug("msPostGISBuildSQLItems called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  if (layerinfo->geomcolumn.empty()) {
+    msSetError(MS_MISCERR, "layerinfo->geomcolumn is not initialized.",
+               "msPostGISBuildSQLItems()");
+    return std::string();
+  }
+
+  /*
+  ** Get the server to transform the geometry into our
+  ** native endian before transmitting it to us..
+  */
+  if (layerinfo->endian == LITTLE_ENDIAN) {
+    strEndian = "NDR";
+  } else {
+    strEndian = "XDR";
+  }
+
+  std::string strGeom;
+  {
+    /*
+    ** We transfer the geometry from server to client as a
+    ** hex or base64 encoded WKB byte-array. We will have to decode this
+    ** data once we get it. Forcing to 2D (via the AsBinary function
+    ** which includes a 2D force in it) removes ordinates we don't
+    ** need, saving transfer and encode/decode time.
+    */
+    const char *force2d = "";
+#if TRANSFER_ENCODING == 64
+    const char *strGeomTemplate =
+        "encode(ST_AsBinary(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
+#elif TRANSFER_ENCODING == 256
+    const char *strGeomTemplate =
+        "ST_AsBinary(%s(\"%s\"),'%s') as geom,\"%s\"::text";
+#else
+    const char *strGeomTemplate =
+        "encode(ST_AsBinary(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
+#endif
+    if (layerinfo->force2d) {
+      if (layerinfo->version >= 20100)
+        force2d = "ST_Force2D";
+      else
+        force2d = "ST_Force_2D";
+    } else if (layerinfo->version < 20000) {
+      /* Use AsEWKB() to get 3D */
+#if TRANSFER_ENCODING == 64
+      strGeomTemplate =
+          "encode(AsEWKB(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
+#elif TRANSFER_ENCODING == 256
+      strGeomTemplate = "AsEWKB(%s(\"%s\"),'%s') as geom,\"%s\"::text";
+#else
+      strGeomTemplate = "encode(AsEWKB(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
+#endif
+    }
+    strGeom.resize(strlen(strGeomTemplate) + strlen(force2d) +
+                   strlen(strEndian) + layerinfo->geomcolumn.size() +
+                   layerinfo->uid.size());
+    snprintf(&strGeom[0], strGeom.size(), strGeomTemplate, force2d,
+             layerinfo->geomcolumn.c_str(), strEndian, layerinfo->uid.c_str());
+    strGeom.resize(strlen(strGeom.data()));
+  }
+
+  if (layer->debug > 1) {
+    msDebug("msPostGISBuildSQLItems: %d items requested.\n", layer->numitems);
+  }
+
+  /*
+  ** Not requesting items? We just need geometry and unique id.
+  */
+  std::string strItems;
+  /*
+  ** Build SQL to pull all the items.
+  */
+  for (int t = 0; t < layer->numitems; t++) {
+    strItems += "\"";
+    strItems += layer->items[t];
+#if TRANSFER_ENCODING == 256
+    strItems += "\"::text,";
+#else
+    strItems += "\",";
+#endif
+  }
+  strItems += strGeom;
+
+  return strItems;
+}
+
+/*
+** msPostGISFindTableName()
+*/
+static std::string msPostGISFindTableName(const char *fromsource) {
+  std::string f_table_name;
+  const char *pos = strchr(fromsource, ' ');
+
+  if (!pos) {
+    /* target table is one word */
+    f_table_name = fromsource;
+  } else {
+    /* target table is hiding in sub-select clause */
+    pos = strcasestr(fromsource, " from ");
+    if (pos) {
+      pos += 6; /* should be start of table name */
+      const char *pos_paren = strstr(pos, ")"); /* first ) after table name */
+      const char *pos_space =
+          strstr(pos, " "); /* first space after table name */
+      if (pos_space < pos_paren) {
+        /* found space first */
+        f_table_name.assign(pos, pos_space - pos);
+      } else {
+        /* found ) first */
+        f_table_name.assign(pos, pos_paren - pos);
+      }
+    }
+  }
+  return f_table_name;
+}
+
+/*
+** msPostGISBuildSQLSRID()
+*/
+static std::string msPostGISBuildSQLSRID(layerObj *layer) {
+
+  std::string strSRID;
+
+  if (layer->debug) {
+    msDebug("msPostGISBuildSQLSRID called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  /* An SRID was already provided in the DATA line. */
+  if (!layerinfo->srid.empty()) {
+    strSRID = layerinfo->srid;
+    if (layer->debug > 1) {
+      msDebug("msPostGISBuildSQLSRID: SRID provided (%s)\n", strSRID.c_str());
+    }
+  }
+  /*
+  ** No SRID in data line, so extract target table from the 'fromsource'.
+  ** Either of form "thetable" (one word) or "(select ... from thetable)"
+  ** or "(select ... from thetable where ...)".
+  */
+  else {
+    if (layer->debug > 1) {
+      msDebug("msPostGISBuildSQLSRID: Building find_srid line.\n");
+    }
+
+    strSRID = "find_srid('','";
+    strSRID += msPostGISFindTableName(layerinfo->fromsource.c_str());
+    strSRID += "','";
+    strSRID += layerinfo->geomcolumn;
+    strSRID += "')";
+  }
+  return strSRID;
+}
+
+/*
+** msPostGISReplaceBoxToken()
+**
+** Convert a fromsource data statement into something usable by replacing the
+*!BOX! token.
+*/
+static std::string msPostGISReplaceBoxToken(layerObj *layer,
+                                            const rectObj *rect,
+                                            const char *fromsource) {
+  std::string result(fromsource);
+
+  if (layer->debug > 1) {
+    msDebug("msPostGISReplaceBoxToken called.\n");
+  }
+
+  if (strstr(fromsource, BOXTOKEN) && rect) {
+    char *strBox = nullptr;
+
+    /* We see to set the SRID on the box, but to what SRID? */
+    const std::string strSRID = msPostGISBuildSQLSRID(layer);
+    if (strSRID.empty()) {
+      return std::string();
+    }
+
+    /* Create a suitable SQL string from the rectangle and SRID. */
+    strBox = msPostGISBuildSQLBox(layer, rect, strSRID.c_str());
+    if (!strBox) {
+      msSetError(MS_MISCERR, "Unable to build box SQL.",
+                 "msPostGISReplaceBoxToken()");
+      return std::string();
+    }
+
+    /* Do the substitution. */
+    size_t pos = 0;
+    while (true) {
+      pos = result.find(BOXTOKEN, pos);
+      if (pos == std::string::npos) {
+        break;
+      }
+      const auto resultAfter(result.substr(pos + BOXTOKENLENGTH));
+      result.resize(pos);
+      result += strBox;
+      result += resultAfter;
+    }
+
+    free(strBox);
+  }
+  return result;
+}
+
+/*
+** msPostGISBuildSQLFrom()
+*/
+static std::string msPostGISBuildSQLFrom(layerObj *layer, const rectObj *rect) {
+  if (layer->debug) {
+    msDebug("msPostGISBuildSQLFrom called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  if (layerinfo->fromsource.empty()) {
+    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.",
+               "msPostGISBuildSQLFrom()");
+    return std::string();
+  }
+
+  /*
+  ** If there's a '!BOX!' in our source we need to substitute the
+  ** current rectangle for it...
+  */
+  return msPostGISReplaceBoxToken(layer, rect, layerinfo->fromsource.c_str());
+}
+
+/*
+** msPostGISBuildSQLWhere()
+*/
+static std::string msPostGISBuildSQLWhere(layerObj *layer, const rectObj *rect,
+                                          const long *uid,
+                                          const rectObj *rectInOtherSRID,
+                                          int otherSRID) {
+  if (layer->debug) {
+    msDebug("msPostGISBuildSQLWhere called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  if (layerinfo->fromsource.empty()) {
+    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.",
+               "msPostGISBuildSQLWhere()");
+    return std::string();
+  }
+
+  /* Populate strRect, if necessary. */
+  std::string strRect;
+  if (rect && !layerinfo->geomcolumn.empty()) {
+    /* We see to set the SRID on the box, but to what SRID? */
+    const std::string strSRID = msPostGISBuildSQLSRID(layer);
+    if (strSRID.empty()) {
+      return std::string();
+    }
+
+    char *strBox = msPostGISBuildSQLBox(layer, rect, strSRID.c_str());
+
+    if (!strBox) {
+      msSetError(MS_MISCERR, "Unable to build box SQL.",
+                 "msPostGISBuildSQLWhere()");
+      return std::string();
+    }
+
+    if (strSRID.find("find_srid(") == std::string::npos) {
+      // If the SRID is known, we can safely use ST_Intersects()
+      // otherwise if find_srid() would return 0, ST_Intersects() would not
+      // work at all, which breaks the msautotest/query/query_postgis.map
+      // tests, related to bdry_counpy2 layer that has no SRID
+      if (layerinfo->version >= 20500) {
+        strRect = "ST_Intersects(\"";
+        strRect += layerinfo->geomcolumn;
+        strRect += "\", ";
+        strRect += strBox;
+        strRect += ')';
+      } else {
+        // ST_Intersects() before PostGIS 2.5 doesn't support collections
+        // See
+        // https://github.com/MapServer/MapServer/pull/6355#issuecomment-877355007
+        strRect = "(\"";
+        strRect += layerinfo->geomcolumn;
+        strRect += "\" && ";
+        strRect += strBox;
+        strRect += ") AND ST_Distance(\"";
+        strRect += layerinfo->geomcolumn;
+        strRect += "\", ";
+        strRect += strBox;
+        strRect += ") = 0";
+      }
+    } else {
+      strRect = '"';
+      strRect += layerinfo->geomcolumn;
+      strRect += "\" && ";
+      strRect += strBox;
+    }
+    free(strBox);
+
+    /* Combine with other rectangle  expressed in another SRS */
+    /* (generally equivalent to the above in current code paths) */
+    if (rectInOtherSRID != nullptr && otherSRID > 0) {
+      strBox = msPostGISBuildSQLBox(layer, rectInOtherSRID,
+                                    std::to_string(otherSRID).c_str());
+      if (!strBox) {
+        msSetError(MS_MISCERR, "Unable to build box SQL.",
+                   "msPostGISBuildSQLWhere()");
+        return std::string();
+      }
+
+      std::string strRectOtherSRID = "ST_Intersects(ST_Transform(";
+      strRectOtherSRID += layerinfo->geomcolumn;
+      strRectOtherSRID += ',';
+      strRectOtherSRID += std::to_string(otherSRID);
+      strRectOtherSRID += "),";
+      strRectOtherSRID += strBox;
+      strRectOtherSRID += ')';
+
+      free(strBox);
+
+      std::string strTmp = "((";
+      strTmp += strRect;
+      strTmp += ") AND ";
+      strTmp += strRectOtherSRID;
+      strTmp += ')';
+
+      strRect = std::move(strTmp);
+    } else if (rectInOtherSRID != nullptr && otherSRID < 0) {
+      const std::string strSRID = msPostGISBuildSQLSRID(layer);
+      if (strSRID.empty()) {
+        return std::string();
+      }
+      char *strBox =
+          msPostGISBuildSQLBox(layer, rectInOtherSRID, strSRID.c_str());
+
+      if (!strBox) {
+        msSetError(MS_MISCERR, "Unable to build box SQL.",
+                   "msPostGISBuildSQLWhere()");
+        return std::string();
+      }
+
+      std::string strRectOtherSRID = "ST_Intersects(";
+      strRectOtherSRID += layerinfo->geomcolumn;
+      strRectOtherSRID += ',';
+      strRectOtherSRID += strBox;
+      strRectOtherSRID += ')';
+
+      free(strBox);
+
+      std::string strTmp = "((";
+      strTmp += strRect;
+      strTmp += ") AND ";
+      strTmp += strRectOtherSRID;
+      strTmp += ')';
+
+      strRect = std::move(strTmp);
+    }
+  }
+
+  bool insert_and = false;
+  std::string strWhere;
+  if (!strRect.empty()) {
+    strWhere += strRect;
+    insert_and = true;
+  }
+
+  /* Handle a translated filter (RFC91). */
+  if (layer->filter.native_string) {
+    if (insert_and) {
+      strWhere += " AND ";
+      insert_and = true;
+    }
+    strWhere += '(';
+    strWhere += layer->filter.native_string;
+    strWhere += ')';
+  }
+
+  /* Handle a native filter set as a PROCESSING option (#5001). */
+  const char *native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
+  if (native_filter) {
+    if (insert_and) {
+      strWhere += " AND ";
+      insert_and = true;
+    }
+    strWhere += '(';
+    strWhere += native_filter;
+    strWhere += ')';
+  }
+
+  if (uid) {
+    if (insert_and) {
+      strWhere += " AND ";
+    }
+    strWhere += '"';
+    strWhere += layerinfo->uid;
+    strWhere += "\" = ";
+    strWhere += std::to_string(*uid);
+  }
+
+  if (layer->sortBy.nProperties > 0) {
+    char *pszTmp = msLayerBuildSQLOrderBy(layer);
+    strWhere += " ORDER BY ";
+    strWhere += pszTmp;
+    msFree(pszTmp);
+  }
+
+  if (layerinfo->paging && layer->maxfeatures >= 0) {
+    strWhere += " LIMIT ";
+    strWhere += std::to_string(layer->maxfeatures);
+  }
+
+  /* Populate strOffset, if necessary. */
+  if (layerinfo->paging && layer->startindex > 0) {
+    strWhere += " OFFSET ";
+    strWhere += std::to_string(layer->startindex - 1);
+  }
+
+  if (strWhere.empty()) {
+    // return all records
+    strWhere = "true";
+  }
+
+  return strWhere;
+}
+
+/*
+** msPostGISBuildSQL()
+**
+** rect is the search rectangle in layer SRS. It can be set to NULL
+** uid can be set to NULL
+** rectInOtherSRID is an additional rectangle potentially in another SRS. It can
+*be set to NULL.
+** Only used if rect != NULL
+** otherSRID is the SRID of the additional rectangle. It can be set to -1 if
+** rectInOtherSRID is in the SRID of the layer.
+*/
+static std::string msPostGISBuildSQL(layerObj *layer, const rectObj *rect,
+                                     const long *uid,
+                                     const rectObj *rectInOtherSRID,
+                                     int otherSRID) {
+  if (layer->debug) {
+    msDebug("msPostGISBuildSQL called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  const std::string strItems = msPostGISBuildSQLItems(layer);
+  if (strItems.empty()) {
+    msSetError(MS_MISCERR, "Failed to build SQL items.", "msPostGISBuildSQL()");
+    return std::string();
+  }
+
+  const std::string strFrom = msPostGISBuildSQLFrom(layer, rect);
+  if (strFrom.empty()) {
+    msSetError(MS_MISCERR, "Failed to build SQL 'from'.",
+               "msPostGISBuildSQL()");
+    return std::string();
+  }
+
+  /* If there's BOX hackery going on, we don't want to append a box index test
+     at the end of the query, the user is going to be responsible for making
+     things work with their hackery. */
+  std::string strWhere;
+  if (strstr(layerinfo->fromsource.c_str(), BOXTOKEN))
+    strWhere =
+        msPostGISBuildSQLWhere(layer, nullptr, uid, rectInOtherSRID, otherSRID);
+  else
+    strWhere =
+        msPostGISBuildSQLWhere(layer, rect, uid, rectInOtherSRID, otherSRID);
+
+  if (strWhere.empty()) {
+    msSetError(MS_MISCERR, "Failed to build SQL 'where'.",
+               "msPostGISBuildSQL()");
+    return std::string();
+  }
+
+  std::string sql("SELECT ");
+  sql += strItems;
+  sql += " FROM ";
+  sql += strFrom;
+  sql += " WHERE ";
+  sql += strWhere;
+
+  return sql;
+}
+
+#define wkbstaticsize 4096
+static int msPostGISReadShape(layerObj *layer, shapeObj *shape) {
+  if (layer->debug) {
+    msDebug("msPostGISReadShape called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  /* Retrieve the geometry. */
+  const char *wkbstr =
+      PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems);
+  const int wkbstrlen =
+      PQgetlength(layerinfo->pgresult, layerinfo->rownum, layer->numitems);
+
+  if (!wkbstr) {
+    msSetError(MS_QUERYERR, "WKB returned is null!", "msPostGISReadShape()");
+    return MS_FAILURE;
+  }
+
+  unsigned char wkbstatic[wkbstaticsize];
+  unsigned char *wkb = nullptr;
+  if (wkbstrlen > wkbstaticsize) {
+    wkb =
+        static_cast<unsigned char *>(calloc(wkbstrlen, sizeof(unsigned char)));
+  } else {
+    wkb = wkbstatic;
+  }
+
+  wkbObj w;
+  int result = 0;
+#if TRANSFER_ENCODING == 64
+  result = msPostGISBase64Decode(wkb, wkbstr, wkbstrlen - 1);
+  w.size = (wkbstrlen - 1) / 2;
+  if (!result) {
+    if (wkb != wkbstatic)
+      free(wkb);
+    return MS_FAILURE;
+  }
+#elif TRANSFER_ENCODING == 256
+  memcpy(wkb, wkbstr, wkbstrlen);
+  w.size = wkbstrlen;
+#else
+  result = msPostGISHexDecode(wkb, wkbstr, wkbstrlen);
+  w.size = (wkbstrlen - 1) / 2;
+  if (!result) {
+    if (wkb != wkbstatic)
+      free(wkb);
+    return MS_FAILURE;
+  }
+#endif
+
+  /* Initialize our wkbObj */
+  w.wkb = (char *)wkb;
+  w.ptr = w.wkb;
+
+  /* Set the type map according to what version of PostGIS we are dealing with
+   */
+  if (layerinfo->version >= 20000) /* PostGIS 2.0+ */
+    w.typemap = wkb_postgis20;
+  else {
+    w.typemap = wkb_postgis15;
+    if (layerinfo->force2d == MS_FALSE) {
+      /* Is there SRID ? Skip it */
+      if (w.size >= 9 && (w.ptr[4] & 0x20) != 0) {
+        w.ptr[5] = w.ptr[1];
+        w.ptr[6] = w.ptr[2];
+        w.ptr[7] = w.ptr[3];
+        w.ptr[8] = w.ptr[4] & ~(0x20);
+        w.ptr[4] = 1;
+        w.ptr += 4;
+        w.size -= 4;
+      }
+    }
+  }
+
+  switch (layer->type) {
+
+  case MS_LAYER_POINT:
+    shape->type = MS_SHAPE_POINT;
+    result = wkbConvGeometryToShape(&w, shape);
+    break;
+
+  case MS_LAYER_LINE:
+    shape->type = MS_SHAPE_LINE;
+    result = wkbConvGeometryToShape(&w, shape);
+    break;
+
+  case MS_LAYER_POLYGON:
+    shape->type = MS_SHAPE_POLYGON;
+    result = wkbConvGeometryToShape(&w, shape);
+    break;
+
+  case MS_LAYER_QUERY:
+  case MS_LAYER_CHART:
+    result = msPostGISFindBestType(&w, shape);
+    break;
+
+  case MS_LAYER_RASTER:
+    msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
+    break;
+
+  case MS_LAYER_CIRCLE:
+    msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
+    break;
+
+  default:
+    msDebug("Unsupported layer type in msPostGISReadShape()!\n");
+    break;
+  }
+
+  /* All done with WKB geometry, free it! */
+  if (wkb != wkbstatic)
+    free(wkb);
+
+  if (result != MS_FAILURE) {
+    /* Found a drawable shape, so now retreive the attributes. */
+
+    shape->values = (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
+    for (int t = 0; t < layer->numitems; t++) {
+      const int size = PQgetlength(layerinfo->pgresult, layerinfo->rownum, t);
+      const char *val = PQgetvalue(layerinfo->pgresult, layerinfo->rownum, t);
+      const int isnull = PQgetisnull(layerinfo->pgresult, layerinfo->rownum, t);
+      if (isnull) {
+        shape->values[t] = msStrdup("");
+      } else {
+        shape->values[t] = (char *)msSmallMalloc(size + 1);
+        memcpy(shape->values[t], val, size);
+        shape->values[t][size] = '\0'; /* null terminate it */
+
+        // From https://www.postgresql.org/docs/9.0/datatype-character.html
+        // fields of type Char are blank padded, but this blank is semantically
+        // insignificant, so let's trim it
+        if (PQftype(layerinfo->pgresult, t) == CHAROID)
+          msStringTrimBlanks(shape->values[t]);
+      }
+      if (layer->debug > 4) {
+        msDebug("msPostGISReadShape: PQgetlength = %d\n", size);
+      }
+      if (layer->debug > 1) {
+        msDebug("msPostGISReadShape: [%s] \"%s\"\n", layer->items[t],
+                shape->values[t]);
+      }
+    }
+
+    /* layer->numitems is the geometry, layer->numitems+1 is the uid */
+    const char *tmp =
+        PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems + 1);
+    long uid = 0;
+    if (tmp) {
+      uid = strtol(tmp, nullptr, 10);
+    }
+    if (layer->debug > 4) {
+      msDebug("msPostGISReadShape: Setting shape->index = %ld\n", uid);
+      msDebug("msPostGISReadShape: Setting shape->resultindex = %ld\n",
+              layerinfo->rownum);
+    }
+    shape->index = uid;
+    shape->resultindex = layerinfo->rownum;
+
+    if (layer->debug > 2) {
+      msDebug("msPostGISReadShape: [index] %ld\n", shape->index);
+    }
+
+    shape->numvalues = layer->numitems;
+
+    msComputeBounds(shape);
+  } else {
+    shape->type = MS_SHAPE_NULL;
+  }
+
+  if (layer->debug > 2) {
+    char *tmp = msShapeToWKT(shape);
+    msDebug("msPostGISReadShape: [shape] %s\n", tmp);
+    free(tmp);
+  }
+
+  return MS_SUCCESS;
+}
+
+#endif /* USE_POSTGIS */
+
+/*
+** msPostGISLayerOpen()
+**
+** Registered vtable->LayerOpen function.
+*/
+static int msPostGISLayerOpen(layerObj *layer) {
+#ifdef USE_POSTGIS
+  assert(layer != nullptr);
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerOpen called: %s\n", layer->data);
+  }
+
+  if (layer->layerinfo) {
+    if (layer->debug) {
+      msDebug("msPostGISLayerOpen: Layer is already open!\n");
+    }
+    return MS_SUCCESS; /* already open */
+  }
+
+  if (!layer->data) {
+    msSetError(MS_QUERYERR, "Nothing specified in DATA statement.",
+               "msPostGISLayerOpen()");
+    return MS_FAILURE;
+  }
+
+  /*
+  ** Initialize the layerinfo
+  **/
+  msPostGISLayerInfo *layerinfo = msPostGISCreateLayerInfo();
+
+  int order_test = 1;
+  if (((char *)&order_test)[0] == 1) {
+    layerinfo->endian = LITTLE_ENDIAN;
+  } else {
+    layerinfo->endian = BIG_ENDIAN;
+  }
+
+  /*
+  ** Get a database connection from the pool.
+  */
+  layerinfo->pgconn = (PGconn *)msConnPoolRequest(layer);
+
+  /* No connection in the pool, so set one up. */
+  if (!layerinfo->pgconn) {
+    if (layer->debug) {
+      msDebug(
+          "msPostGISLayerOpen: No connection in pool, creating a fresh one.\n");
+    }
+
+    if (!layer->connection) {
+      msSetError(MS_MISCERR, "Missing CONNECTION keyword.",
+                 "msPostGISLayerOpen()");
+      delete layerinfo;
+      return MS_FAILURE;
+    }
+
+    /*
+    ** Decrypt any encrypted token in connection string and attempt to connect.
+    */
+    char *conn_decrypted = msDecryptStringTokens(layer->map, layer->connection);
+    if (conn_decrypted == nullptr) {
+      delete layerinfo;
+      return MS_FAILURE; /* An error should already have been produced */
+    }
+    layerinfo->pgconn = PQconnectdb(conn_decrypted);
+    msFree(conn_decrypted);
+    conn_decrypted = nullptr;
+
+    /*
+    ** Connection failed, return error message with passwords ***ed out.
+    */
+    if (!layerinfo->pgconn || PQstatus(layerinfo->pgconn) == CONNECTION_BAD) {
+      if (layer->debug)
+        msDebug("msPostGISLayerOpen: Connection failure.\n");
+
+      msDebug("Database connection failed (%s) with connect string '%s'\nIs "
+              "the database running? Is it allowing connections? Does the "
+              "specified user exist? Is the password valid? Is the database on "
+              "the standard port? in msPostGISLayerOpen()",
+              PQerrorMessage(layerinfo->pgconn), layer->connection);
+      msSetError(MS_QUERYERR,
+                 "Database connection failed. Check server logs for more "
+                 "details.Is the database running? Is it allowing connections? "
+                 "Does the specified user exist? Is the password valid? Is the "
+                 "database on the standard port?",
+                 "msPostGISLayerOpen()");
+
+      if (layerinfo->pgconn)
+        PQfinish(layerinfo->pgconn);
+      delete layerinfo;
+      return MS_FAILURE;
+    }
+
+    /* Register to receive notifications from the database. */
+    PQsetNoticeProcessor(layerinfo->pgconn, postresqlNoticeHandler,
+                         (void *)layer);
+
+    /* Save this connection in the pool for later. */
+    msConnPoolRegister(layer, layerinfo->pgconn, msPostGISCloseConnection);
+  } else {
+    /* Connection in the pool should be tested to see if backend is alive. */
+    if (PQstatus(layerinfo->pgconn) != CONNECTION_OK) {
+      /* Uh oh, bad connection. Can we reset it? */
+      PQreset(layerinfo->pgconn);
+      if (PQstatus(layerinfo->pgconn) != CONNECTION_OK) {
+        /* Nope, time to bail out. */
+        msSetError(MS_QUERYERR,
+                   "PostgreSQL database connection. Check server logs for more "
+                   "details",
+                   "msPostGISLayerOpen()");
+        msDebug("PostgreSQL database connection gone bad (%s) in "
+                "msPostGISLayerOpen()",
+                PQerrorMessage(layerinfo->pgconn));
+        delete layerinfo;
+        /* FIXME: we should also release the connection from the pool in this
+         * case, but it is stale... for the time being we do not release it so
+         * it can never be used again. If this happens multiple times there will
+         * be a leak... */
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  /* Get the PostGIS version number from the database */
+  layerinfo->version = msPostGISRetrieveVersion(layerinfo->pgconn);
+  if (layerinfo->version == MS_FAILURE) {
+    msConnPoolRelease(layer, layerinfo->pgconn);
+    delete layerinfo;
+    return MS_FAILURE;
+  }
+  if (layer->debug)
+    msDebug("msPostGISLayerOpen: Got PostGIS version %d.\n",
+            layerinfo->version);
+
+  const char *force2d_processing = msLayerGetProcessingKey(layer, "FORCE2D");
+  if (force2d_processing && !strcasecmp(force2d_processing, "no")) {
+    layerinfo->force2d = MS_FALSE;
+  } else if (force2d_processing && !strcasecmp(force2d_processing, "yes")) {
+    layerinfo->force2d = MS_TRUE;
+  }
+  if (layer->debug)
+    msDebug("msPostGISLayerOpen: Forcing 2D geometries: %s.\n",
+            (layerinfo->force2d) ? "yes" : "no");
+
+  /* Save the layerinfo in the layerObj. */
+  layer->layerinfo = (void *)layerinfo;
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerOpen()");
+  return MS_FAILURE;
+#endif
+}
+
+/*
+** msPostGISLayerClose()
+**
+** Registered vtable->LayerClose function.
+*/
+static int msPostGISLayerClose(layerObj *layer) {
+#ifdef USE_POSTGIS
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerClose called: %s\n", layer->data);
+  }
+
+  if (layer->layerinfo) {
+    msPostGISFreeLayerInfo(layer);
+  }
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerClose()");
+  return MS_FAILURE;
+#endif
+}
+
+/*
+** msPostGISLayerIsOpen()
+**
+** Registered vtable->LayerIsOpen function.
+*/
+static int msPostGISLayerIsOpen(layerObj *layer) {
+#ifdef USE_POSTGIS
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerIsOpen called.\n");
+  }
+
+  if (layer->layerinfo)
+    return MS_TRUE;
+  else
+    return MS_FALSE;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerIsOpen()");
+  return MS_FAILURE;
+#endif
+}
+
+/*
+** msPostGISLayerFreeItemInfo()
+**
+** Registered vtable->LayerFreeItemInfo function.
+*/
+static void msPostGISLayerFreeItemInfo(layerObj *layer) {
+#ifdef USE_POSTGIS
+  if (layer->debug) {
+    msDebug("msPostGISLayerFreeItemInfo called.\n");
+  }
+
+  if (layer->iteminfo) {
+    free(layer->iteminfo);
+  }
+  layer->iteminfo = nullptr;
+#endif
+}
+
+/*
+** msPostGISLayerInitItemInfo()
+**
+** Registered vtable->LayerInitItemInfo function.
+** Our iteminfo is list of indexes from 1..numitems.
+*/
+static int msPostGISLayerInitItemInfo(layerObj *layer) {
+#ifdef USE_POSTGIS
+  if (layer->debug) {
+    msDebug("msPostGISLayerInitItemInfo called.\n");
+  }
+
+  if (layer->numitems == 0) {
+    return MS_SUCCESS;
+  }
+
+  if (layer->iteminfo) {
+    free(layer->iteminfo);
+  }
+
+  layer->iteminfo = msSmallMalloc(sizeof(int) * layer->numitems);
+  if (!layer->iteminfo) {
+    msSetError(MS_MEMERR, "Out of memory.", "msPostGISLayerInitItemInfo()");
+    return MS_FAILURE;
+  }
+
+  int *itemindexes = (int *)layer->iteminfo;
+  for (int i = 0; i < layer->numitems; i++) {
+    itemindexes[i] =
+        i; /* Last item is always the geometry. The rest are non-geometry. */
+  }
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerInitItemInfo()");
+  return MS_FAILURE;
+#endif
+}
+
+#ifdef USE_POSTGIS
+static std::vector<const char *> buildBindValues(layerObj *layer) {
+  /* try to get the first bind value */
+  const char *bind_value = msLookupHashTable(&layer->bindvals, "1");
+  std::vector<const char *> layer_bind_values;
+  while (bind_value != nullptr) {
+    /* put the bind value on the stack */
+    layer_bind_values.push_back(bind_value);
+    /* get the bind_value */
+    bind_value = msLookupHashTable(
+        &layer->bindvals,
+        std::to_string(static_cast<size_t>(layer_bind_values.size()) + 1)
+            .c_str());
+  }
+  return layer_bind_values;
+}
+
+static PGresult *runPQexecParamsWithBindSubstitution(layerObj *layer,
+                                                     const char *strSQL,
+                                                     int binary) {
+  PGresult *pgresult = nullptr;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  const auto layer_bind_values = buildBindValues(layer);
+
+  if (!layer_bind_values.empty()) {
+    pgresult = PQexecParams(layerinfo->pgconn, strSQL,
+                            static_cast<int>(layer_bind_values.size()), nullptr,
+                            layer_bind_values.data(), nullptr, nullptr, binary);
+  } else {
+    pgresult = PQexecParams(layerinfo->pgconn, strSQL, 0, nullptr, nullptr,
+                            nullptr, nullptr, binary);
+  }
+
+  return pgresult;
+}
+#endif
+
+/*
+** msPostGISLayerWhichShapes()
+**
+** Registered vtable->LayerWhichShapes function.
+*/
+// cppcheck-suppress passedByValue
+static int msPostGISLayerWhichShapes(layerObj *layer, rectObj rect,
+                                     int isQuery) {
+  (void)isQuery;
+#ifdef USE_POSTGIS
+  assert(layer != nullptr);
+  assert(layer->layerinfo != nullptr);
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerWhichShapes called.\n");
+  }
+
+  /* Fill out layerinfo with our current DATA state. */
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  /*
+  ** This comes *after* parsedata, because parsedata fills in
+  ** layer->layerinfo.
+  */
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  /* Build a SQL query based on our current state. */
+  const std::string strSQL =
+      msPostGISBuildSQL(layer, &rect, nullptr, nullptr, -1);
+  if (strSQL.empty()) {
+    msSetError(MS_QUERYERR, "Failed to build query SQL.",
+               "msPostGISLayerWhichShapes()");
+    return MS_FAILURE;
+  }
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerWhichShapes query: %s\n", strSQL.c_str());
+  }
+
+  PGresult *pgresult = runPQexecParamsWithBindSubstitution(
+      layer, strSQL.c_str(), RESULTSET_TYPE);
+
+  if (layer->debug > 1) {
+    msDebug("msPostGISLayerWhichShapes query status: %s (%d)\n",
+            PQresStatus(PQresultStatus(pgresult)), PQresultStatus(pgresult));
+  }
+
+  /* Something went wrong. */
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+    msDebug("msPostGISLayerWhichShapes(): Error (%s) executing query: %s\n",
+            PQerrorMessage(layerinfo->pgconn), strSQL.c_str());
+    msSetError(MS_QUERYERR, "Error executing query. Check server logs",
+               "msPostGISLayerWhichShapes()");
+    if (pgresult) {
+      PQclear(pgresult);
+    }
+    return MS_FAILURE;
+  }
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerWhichShapes got %d records in result.\n",
+            PQntuples(pgresult));
+  }
+
+  /* Clean any existing pgresult before storing current one. */
+  if (layerinfo->pgresult)
+    PQclear(layerinfo->pgresult);
+  layerinfo->pgresult = pgresult;
+
+  layerinfo->sql = strSQL;
+
+  layerinfo->rownum = 0;
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerWhichShapes()");
+  return MS_FAILURE;
+#endif
+}
+
+/*
+** msPostGISLayerNextShape()
+**
+** Registered vtable->LayerNextShape function.
+*/
+static int msPostGISLayerNextShape(layerObj *layer, shapeObj *shape) {
+#ifdef USE_POSTGIS
+  if (layer->debug) {
+    msDebug("msPostGISLayerNextShape called.\n");
+  }
+
+  assert(layer != nullptr);
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  shape->type = MS_SHAPE_NULL;
+
+  /*
+  ** Roll through pgresult until we hit non-null shape (usually right away).
+  */
+  while (shape->type == MS_SHAPE_NULL) {
+    if (layerinfo->rownum < PQntuples(layerinfo->pgresult)) {
+      /* Retrieve this shape, cursor access mode. */
+      msPostGISReadShape(layer, shape);
+      if (shape->type != MS_SHAPE_NULL) {
+        (layerinfo->rownum)++; /* move to next shape */
+        return MS_SUCCESS;
+      } else {
+        (layerinfo->rownum)++; /* move to next shape */
+      }
+    } else {
+      return MS_DONE;
+    }
+  }
+
+  /* Found nothing, clean up and exit. */
+  msFreeShape(shape);
+
+  return MS_FAILURE;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerNextShape()");
+  return MS_FAILURE;
+#endif
+}
+
+/*
+** msPostGISLayerGetShape()
+**
+*/
+// cppcheck-suppress passedByValue
+static int msPostGISLayerGetShapeCount(layerObj *layer, rectObj rect,
+                                       projectionObj *rectProjection) {
+#ifdef USE_POSTGIS
+  int rectSRID = -1;
+  rectObj searchrectInLayerProj = rect;
+
+  assert(layer != nullptr);
+  assert(layer->layerinfo != nullptr);
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetShapeCount called.\n");
+  }
+
+  // Special processing if the specified projection for the rect is different
+  // from the layer projection We want to issue a WHERE that includes
+  // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT
+  // ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
+  if (rectProjection != NULL && layer->project &&
+      msProjectionsDiffer(&(layer->projection), rectProjection)) {
+    // If we cannot guess the EPSG code of the rectProjection, we cannot
+    // use ST_Transform, so fallback on slow implementation
+    if (rectProjection->numargs < 1 ||
+        strncasecmp(rectProjection->args[0],
+                    "init=epsg:", strlen("init=epsg:")) != 0) {
+      if (layer->debug) {
+        msDebug("msPostGISLayerGetShapeCount(): cannot find EPSG code of "
+                "rectProjection. Falling back on client-side feature count.\n");
+      }
+      return LayerDefaultGetShapeCount(layer, rect, rectProjection);
+    }
+
+    // Reproject the passed rect into the layer projection and get
+    // the SRID from the rectProjection
+    msProjectRect(
+        rectProjection, &(layer->projection),
+        &searchrectInLayerProj); /* project the searchrect to source coords */
+    rectSRID = atoi(rectProjection->args[0] + strlen("init=epsg:"));
+  }
+
+  msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
+
+  /* Fill out layerinfo with our current DATA state. */
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
+    return -1;
+  }
+
+  /*
+  ** This comes *after* parsedata, because parsedata fills in
+  ** layer->layerinfo.
+  */
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  /* Build a SQL query based on our current state. */
+  const std::string strSQL = msPostGISBuildSQL(layer, &searchrectInLayerProj,
+                                               nullptr, &rect, rectSRID);
+  if (strSQL.empty()) {
+    msSetError(MS_QUERYERR, "Failed to build query SQL.",
+               "msPostGISLayerGetShapeCount()");
+    return -1;
+  }
+
+  std::string strSQLCount = "SELECT COUNT(*) FROM (";
+  strSQLCount += strSQL;
+  strSQLCount += ") msQuery";
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetShapeCount query: %s\n", strSQLCount.c_str());
+  }
+
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, strSQLCount.c_str(), 0);
+
+  if (layer->debug > 1) {
+    msDebug("msPostGISLayerWhichShapes query status: %s (%d)\n",
+            PQresStatus(PQresultStatus(pgresult)), PQresultStatus(pgresult));
+  }
+
+  /* Something went wrong. */
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+    msDebug("msPostGISLayerGetShapeCount(): Error (%s) executing query: %s. "
+            "Falling back to client-side evaluation\n",
+            PQerrorMessage(layerinfo->pgconn), strSQLCount.c_str());
+    if (pgresult) {
+      PQclear(pgresult);
+    }
+    return LayerDefaultGetShapeCount(layer, rect, rectProjection);
+  }
+
+  const int nCount = atoi(PQgetvalue(pgresult, 0, 0));
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerWhichShapes return: %d.\n", nCount);
+  }
+  PQclear(pgresult);
+
+  return nCount;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetShapeCount()");
+  return -1;
+#endif
+}
+
+/*
+** msPostGISLayerGetShape()
+**
+** Registered vtable->LayerGetShape function. For pulling from a prepared and
+** undisposed result set.
+*/
+static int msPostGISLayerGetShape(layerObj *layer, shapeObj *shape,
+                                  resultObj *record) {
+#ifdef USE_POSTGIS
+
+  long shapeindex = record->shapeindex;
+  int resultindex = record->resultindex;
+
+  assert(layer != nullptr);
+  assert(layer->layerinfo != nullptr);
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetShape called for record = %i\n", resultindex);
+  }
+
+  /* If resultindex is set, fetch the shape from the resultcache, otherwise
+   * fetch it from the DB  */
+  if (resultindex >= 0) {
+    msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+    /* Check the validity of the open result. */
+    PGresult *pgresult = layerinfo->pgresult;
+    if (!pgresult) {
+      msSetError(MS_MISCERR, "PostgreSQL result set is null.",
+                 "msPostGISLayerGetShape()");
+      return MS_FAILURE;
+    }
+    ExecStatusType status = PQresultStatus(pgresult);
+    if (layer->debug > 1) {
+      msDebug("msPostGISLayerGetShape query status: %s (%d)\n",
+              PQresStatus(status), (int)status);
+    }
+    if (!(status == PGRES_COMMAND_OK || status == PGRES_TUPLES_OK)) {
+      msSetError(MS_MISCERR, "PostgreSQL result set is not ready.",
+                 "msPostGISLayerGetShape()");
+      return MS_FAILURE;
+    }
+
+    /* Check the validity of the requested record number. */
+    if (resultindex >= PQntuples(pgresult)) {
+      msDebug("msPostGISLayerGetShape got request for (%d) but only has %d "
+              "tuples.\n",
+              resultindex, PQntuples(pgresult));
+      msSetError(MS_MISCERR, "Got request larger than result set.",
+                 "msPostGISLayerGetShape()");
+      return MS_FAILURE;
+    }
+
+    layerinfo->rownum = resultindex; /* Only return one result. */
+
+    /* We don't know the shape type until we read the geometry. */
+    shape->type = MS_SHAPE_NULL;
+
+    /* Return the shape, cursor access mode. */
+    msPostGISReadShape(layer, shape);
+
+    return (shape->type == MS_SHAPE_NULL) ? MS_FAILURE : MS_SUCCESS;
+  } else { /* no resultindex, fetch the shape from the DB */
+    int num_tuples;
+
+    /* Fill out layerinfo with our current DATA state. */
+    if (msPostGISParseData(layer) != MS_SUCCESS) {
+      return MS_FAILURE;
+    }
+
+    /*
+    ** This comes *after* parsedata, because parsedata fills in
+    ** layer->layerinfo.
+    */
+    msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+    /* Build a SQL query based on our current state. */
+    const std::string strSQL =
+        msPostGISBuildSQL(layer, nullptr, &shapeindex, nullptr, -1);
+    if (strSQL.empty()) {
+      msSetError(MS_QUERYERR, "Failed to build query SQL.",
+                 "msPostGISLayerGetShape()");
+      return MS_FAILURE;
+    }
+
+    if (layer->debug) {
+      msDebug("msPostGISLayerGetShape query: %s\n", strSQL.c_str());
+    }
+
+    PGresult *pgresult = runPQexecParamsWithBindSubstitution(
+        layer, strSQL.c_str(), RESULTSET_TYPE);
+
+    /* Something went wrong. */
+    if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+      msDebug("msPostGISLayerGetShape(): Error (%s) executing SQL: %s\n",
+              PQerrorMessage(layerinfo->pgconn), strSQL.c_str());
+      msSetError(MS_QUERYERR, "Error executing SQL. Check server logs.",
+                 "msPostGISLayerGetShape()");
+
+      if (pgresult) {
+        PQclear(pgresult);
+      }
+      return MS_FAILURE;
+    }
+
+    /* Clean any existing pgresult before storing current one. */
+    if (layerinfo->pgresult)
+      PQclear(layerinfo->pgresult);
+    layerinfo->pgresult = pgresult;
+
+    /* Clean any existing SQL before storing current. */
+    layerinfo->sql = strSQL;
+
+    layerinfo->rownum = 0; /* Only return one result. */
+
+    /* We don't know the shape type until we read the geometry. */
+    shape->type = MS_SHAPE_NULL;
+
+    num_tuples = PQntuples(pgresult);
+    if (layer->debug) {
+      msDebug("msPostGISLayerGetShape number of records: %d\n", num_tuples);
+    }
+
+    if (num_tuples > 0) {
+      /* Get shape in random access mode. */
+      msPostGISReadShape(layer, shape);
+    }
+
+    return (shape->type == MS_SHAPE_NULL)
+               ? MS_FAILURE
+               : ((num_tuples > 0) ? MS_SUCCESS : MS_DONE);
+  }
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetShape()");
+  return MS_FAILURE;
+#endif
+}
+
+/**********************************************************************
+ *                     msPostGISPassThroughFieldDefinitions()
+ *
+ * Pass the field definitions through to the layer metadata in the
+ * "gml_[item]_{type,width,precision}" set of metadata items for
+ * defining fields.
+ **********************************************************************/
+
+#ifdef USE_POSTGIS
+static void msPostGISPassThroughFieldDefinitions(layerObj *layer,
+                                                 PGresult *pgresult)
+
+{
+  const int numitems = PQnfields(pgresult);
+  msPostGISLayerInfo *layerinfo =
+      static_cast<msPostGISLayerInfo *>(layer->layerinfo);
+
+  for (int i = 0; i < numitems; i++) {
+    const char *gml_type = "Character";
+    const char *item = PQfname(pgresult, i);
+    std::string gml_width;
+    std::string gml_precision;
+
+    /* skip geometry column */
+    if (item == layerinfo->geomcolumn)
+      continue;
+
+    const int oid = PQftype(pgresult, i);
+    const int fmod = PQfmod(pgresult, i);
+
+    if ((oid == BPCHAROID || oid == VARCHAROID) && fmod >= 4) {
+      gml_width = std::to_string(fmod - 4);
+
+    } else if (oid == BOOLOID) {
+      gml_type = "Boolean";
+
+    } else if (oid == INT2OID) {
+      gml_type = "Integer";
+      gml_width = '5';
+
+    } else if (oid == INT4OID) {
+      gml_type = "Integer";
+
+    } else if (oid == INT8OID) {
+      gml_type = "Long";
+
+    } else if (oid == FLOAT4OID || oid == FLOAT8OID) {
+      gml_type = "Real";
+
+    } else if (oid == NUMERICOID) {
+      gml_type = "Real";
+
+      if (fmod >= 4 && ((fmod - 4) & 0xFFFF) == 0) {
+        gml_type = "Integer";
+        gml_width = std::to_string((fmod - 4) >> 16);
+      } else if (fmod >= 4) {
+        gml_width = std::to_string((fmod - 4) >> 16);
+        gml_precision = std::to_string((fmod - 4) & 0xFFFF);
+      }
+    } else if (oid == DATEOID) {
+      gml_type = "Date";
+    } else if (oid == TIMEOID || oid == TIMETZOID) {
+      gml_type = "Time";
+    } else if (oid == TIMESTAMPOID || oid == TIMESTAMPTZOID) {
+      gml_type = "DateTime";
+    }
+
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width.c_str(),
+                             gml_precision.c_str(), 0);
+  }
+}
+#endif /* defined(USE_POSTGIS) */
+
+/*
+** msPostGISLayerGetItems()
+**
+** Registered vtable->LayerGetItems function. Query the database for
+** column information about the requested layer. Rather than look in
+** system tables, we just run a zero-cost query and read out of the
+** result header.
+*/
+static int msPostGISLayerGetItems(layerObj *layer) {
+#ifdef USE_POSTGIS
+  rectObj rect;
+
+  /* A useless rectangle for our useless query */
+  rect.minx = rect.miny = rect.maxx = rect.maxy = 0.0;
+
+  assert(layer != nullptr);
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  assert(layerinfo->pgconn);
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetItems called.\n");
+  }
+
+  /* Fill out layerinfo with our current DATA state. */
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+
+  /*
+  ** Both the "table" and "(select ...) as sub" cases can be handled with the
+  ** same SQL.
+  */
+  std::string sql("select * from ");
+  sql += msPostGISReplaceBoxToken(layer, &rect, layerinfo->fromsource.c_str());
+  sql += " where false limit 0";
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetItems executing SQL: %s\n", sql.c_str());
+  }
+
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, sql.c_str(), 0);
+
+  if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+    msDebug("msPostGISLayerGetItems(): Error (%s) executing SQL: %s\n",
+            PQerrorMessage(layerinfo->pgconn), sql.c_str());
+    msSetError(MS_QUERYERR, "Error executing SQL. Check server logs",
+               "msPostGISLayerGetItems()");
+    if (pgresult) {
+      PQclear(pgresult);
+    }
+    return MS_FAILURE;
+  }
+
+  layer->numitems = PQnfields(pgresult) -
+                    1; /* dont include the geometry column (last entry)*/
+  layer->items = static_cast<char **>(msSmallMalloc(
+      sizeof(char *) *
+      (layer->numitems +
+       1))); /* +1 in case there is a problem finding geometry column */
+
+  bool found_geom = false; /* havent found the geom field */
+  int item_num = 0;
+
+  for (int t = 0; t < PQnfields(pgresult); t++) {
+    const char *col = PQfname(pgresult, t);
+    if (col != layerinfo->geomcolumn) {
+      /* this isnt the geometry column */
+      layer->items[item_num] = msStrdup(col);
+      item_num++;
+    } else {
+      found_geom = true;
+    }
+  }
+
+  /*
+  ** consider populating the field definitions in metadata.
+  */
+  const char *value = msOWSLookupMetadata(&(layer->metadata), "G", "types");
+  if (value != nullptr && strcasecmp(value, "auto") == 0)
+    msPostGISPassThroughFieldDefinitions(layer, pgresult);
+
+  /*
+  ** Cleanup
+  */
+  PQclear(pgresult);
+
+  if (!found_geom) {
+    msSetError(MS_QUERYERR,
+               "Tried to find the geometry column in the database, but "
+               "couldn't find it.  Is it mis-capitalized? '%s'",
+               "msPostGISLayerGetItems()", layerinfo->geomcolumn.c_str());
+    return MS_FAILURE;
+  }
+
+  return msPostGISLayerInitItemInfo(layer);
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetItems()");
+  return MS_FAILURE;
+#endif
+}
+
+#ifdef USE_POSTGIS
+static std::string
+addTableNameAndFilterToSelectFrom(layerObj *layer,
+                                  const std::string &selectFrom) {
+  auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  /* if we have !BOX! substitution then we use just the table name */
+  std::string f_table_name;
+  if (strstr(layerinfo->fromsource.c_str(), BOXTOKEN))
+    f_table_name = msPostGISFindTableName(layerinfo->fromsource.c_str());
+  else
+    f_table_name = layerinfo->fromsource;
+
+  std::string strSQL = selectFrom;
+  strSQL += f_table_name;
+
+  /* Handle a translated filter (RFC91). */
+  if (layer->filter.native_string) {
+    strSQL += " WHERE (";
+    strSQL += layer->filter.native_string;
+    strSQL += ')';
+  }
+
+  /* Handle a native filter set as a PROCESSING option (#5001). */
+  const char *native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
+  if (native_filter) {
+    if (layer->filter.native_string)
+      strSQL += " AND (";
+    else
+      strSQL += " WHERE (";
+    strSQL += native_filter;
+    strSQL += ')';
+  }
+  return strSQL;
+}
+#endif
+
+/*
+** msPostGISLayerGetExtent()
+**
+** Registered vtable->LayerGetExtent function. Query the database for
+** the extent of the requested layer.
+*/
+static int msPostGISLayerGetExtent(layerObj *layer, rectObj *extent) {
+#ifdef USE_POSTGIS
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetExtent called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  const std::string strSQL(addTableNameAndFilterToSelectFrom(
+      layer, "SELECT ST_Extent(" + layerinfo->geomcolumn + ") FROM "));
+
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetExtent executing SQL: %s\n", strSQL.c_str());
+  }
+
+  /* executing the query */
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
+
+  if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+    msDebug("Error executing SQL: (%s) in msPostGISLayerGetExtent()",
+            PQerrorMessage(layerinfo->pgconn));
+    msSetError(MS_MISCERR, "Error executing SQL. Check server logs.",
+               "msPostGISLayerGetExtent()");
+    if (pgresult)
+      PQclear(pgresult);
+
+    return MS_FAILURE;
+  }
+
+  /* process results */
+  if (PQntuples(pgresult) < 1) {
+    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: No results found.",
+               "msPostGISLayerGetExtent()");
+    PQclear(pgresult);
+    return MS_FAILURE;
+  }
+
+  if (PQgetisnull(pgresult, 0, 0)) {
+    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: Null result returned.",
+               "msPostGISLayerGetExtent()");
+    PQclear(pgresult);
+    return MS_FAILURE;
+  }
+
+  if (sscanf(PQgetvalue(pgresult, 0, 0), "BOX(%lf %lf,%lf %lf)", &extent->minx,
+             &extent->miny, &extent->maxx, &extent->maxy) != 4) {
+    msSetError(MS_MISCERR, "Failed to process result data.",
+               "msPostGISLayerGetExtent()");
+    PQclear(pgresult);
+    return MS_FAILURE;
+  }
+
+  /* cleanup */
+  PQclear(pgresult);
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetExtent()");
+  return MS_FAILURE;
+#endif
+}
+
+/*
+** msPostGISLayerGetNumFeatures()
+**
+** Registered vtable->LayerGetNumFeatures function. Query the database for
+** the feature count of the requested layer.
+*/
+static int msPostGISLayerGetNumFeatures(layerObj *layer) {
+#ifdef USE_POSTGIS
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetNumFeatures called.\n");
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
+    return -1;
+  }
+
+  auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  const std::string strSQL(
+      addTableNameAndFilterToSelectFrom(layer, "SELECT count(*) FROM "));
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetNumFeatures executing SQL: %s\n", strSQL.c_str());
+  }
+
+  /* executing the query */
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
+
+  if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+    msDebug("Error executing SQL: (%s) in msPostGISLayerGetNumFeatures()",
+            PQerrorMessage(layerinfo->pgconn));
+    msSetError(MS_MISCERR, "Error executing SQL. Check server logs.",
+               "msPostGISLayerGetNumFeatures()");
+    if (pgresult)
+      PQclear(pgresult);
+
+    return -1;
+  }
+
+  /* process results */
+  if (PQntuples(pgresult) < 1) {
+    msSetError(MS_MISCERR, "msPostGISLayerGetNumFeatures: No results found.",
+               "msPostGISLayerGetNumFeatures()");
+    PQclear(pgresult);
+    return -1;
+  }
+
+  if (PQgetisnull(pgresult, 0, 0)) {
+    msSetError(MS_MISCERR,
+               "msPostGISLayerGetNumFeatures: Null result returned.",
+               "msPostGISLayerGetNumFeatures()");
+    PQclear(pgresult);
+    return -1;
+  }
+
+  const char *tmp = PQgetvalue(pgresult, 0, 0);
+  int result = 0;
+  if (tmp) {
+    result = strtol(tmp, nullptr, 10);
+  }
+
+  /* cleanup */
+  PQclear(pgresult);
+
+  return result;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetNumFeatures()");
+  return -1;
+#endif
+}
+
+#ifdef USE_POSTGIS
+/*
+ * make sure that the timestring is complete and acceptable
+ * to the date_trunc function :
+ * - if the resolution is year (2004) or month (2004-01),
+ * a complete string for time would be 2004-01-01
+ * - if the resolluion is hour or minute (2004-01-01 15), a
+ * complete time is 2004-01-01 15:00:00
+ */
+static int postgresTimeStampForTimeString(const char *timestring, char *dest,
+                                          size_t destsize) {
+  int nlength = strlen(timestring);
+  int timeresolution = msTimeGetResolution(timestring);
+  int bNoDate = (*timestring == 'T');
+  if (timeresolution < 0)
+    return MS_FALSE;
+
+  switch (timeresolution) {
+  case TIME_RESOLUTION_YEAR:
+    if (timestring[nlength - 1] != '-') {
+      snprintf(dest, destsize, "date '%s-01-01'", timestring);
+    } else {
+      snprintf(dest, destsize, "date '%s01-01'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_MONTH:
+    if (timestring[nlength - 1] != '-') {
+      snprintf(dest, destsize, "date '%s-01'", timestring);
+    } else {
+      snprintf(dest, destsize, "date '%s01'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_DAY:
+    snprintf(dest, destsize, "date '%s'", timestring);
+    break;
+  case TIME_RESOLUTION_HOUR:
+    if (timestring[nlength - 1] != ':') {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s:00:00'", timestring);
+      else
+        snprintf(dest, destsize, "timestamp '%s:00:00'", timestring);
+    } else {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s00:00'", timestring);
+      else
+        snprintf(dest, destsize, "timestamp '%s00:00'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_MINUTE:
+    if (timestring[nlength - 1] != ':') {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s:00'", timestring);
+      else
+        snprintf(dest, destsize, "timestamp '%s:00'", timestring);
+    } else {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s00'", timestring);
+      else
+        snprintf(dest, destsize, "timestamp '%s00'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_SECOND:
+    if (bNoDate)
+      snprintf(dest, destsize, "time '%s'", timestring);
+    else
+      snprintf(dest, destsize, "timestamp '%s'", timestring);
+    break;
+  default:
+    return MS_FAILURE;
+  }
+  return MS_SUCCESS;
+}
+
+/*
+ * create a postgresql where clause for the given timestring, taking into
+ * account the resolution (e.g. second, day, month...) of the given timestring
+ * we apply the date_trunc function on the given timestring and not on the time
+ * column in order for postgres to take advantage of an eventual index on the
+ * time column
+ *
+ * the generated sql is
+ *
+ * (
+ *    timecol >= date_trunc(timestring,resolution)
+ *      and
+ *    timecol < date_trunc(timestring,resolution) + interval '1 resolution'
+ * )
+ */
+static int createPostgresTimeCompareEquals(const char *timestring, char *dest,
+                                           size_t destsize) {
+  int timeresolution = msTimeGetResolution(timestring);
+  char timeStamp[100];
+  const char *interval;
+  if (timeresolution < 0)
+    return MS_FALSE;
+
+  postgresTimeStampForTimeString(timestring, timeStamp, 100);
+
+  switch (timeresolution) {
+  case TIME_RESOLUTION_YEAR:
+    interval = "year";
+    break;
+  case TIME_RESOLUTION_MONTH:
+    interval = "month";
+    break;
+  case TIME_RESOLUTION_DAY:
+    interval = "day";
+    break;
+  case TIME_RESOLUTION_HOUR:
+    interval = "hour";
+    break;
+  case TIME_RESOLUTION_MINUTE:
+    interval = "minute";
+    break;
+  case TIME_RESOLUTION_SECOND:
+    interval = "second";
+    break;
+  default:
+    return MS_FAILURE;
+  }
+  snprintf(dest, destsize,
+           " between date_trunc('%s',%s) and date_trunc('%s',%s) + interval '1 "
+           "%s' - interval '1 second'",
+           interval, timeStamp, interval, timeStamp, interval);
+  return MS_SUCCESS;
+}
+
+static int createPostgresTimeCompareGreaterThan(const char *timestring,
+                                                char *dest, size_t destsize) {
+  int timeresolution = msTimeGetResolution(timestring);
+  char timestamp[100];
+  const char *interval;
+  if (timeresolution < 0)
+    return MS_FALSE;
+
+  postgresTimeStampForTimeString(timestring, timestamp, 100);
+
+  switch (timeresolution) {
+  case TIME_RESOLUTION_YEAR:
+    interval = "year";
+    break;
+  case TIME_RESOLUTION_MONTH:
+    interval = "month";
+    break;
+  case TIME_RESOLUTION_DAY:
+    interval = "day";
+    break;
+  case TIME_RESOLUTION_HOUR:
+    interval = "hour";
+    break;
+  case TIME_RESOLUTION_MINUTE:
+    interval = "minute";
+    break;
+  case TIME_RESOLUTION_SECOND:
+    interval = "second";
+    break;
+  default:
+    return MS_FAILURE;
+  }
+
+  snprintf(dest, destsize, "date_trunc('%s',%s)", interval, timestamp);
+  return MS_SUCCESS;
+}
+
+/*
+ * create a postgresql where clause for the range given by the two input
+ * timestring, taking into account the resolution (e.g. second, day, month...)
+ * of each of the given timestrings (both timestrings can have different
+ * resolutions, although I don't know if that's a valid TIME range we apply the
+ * date_trunc function on the given timestrings and not on the time column in
+ * order for postgres to take advantage of an eventual index on the time column
+ *
+ * the generated sql is
+ *
+ * (
+ *    timecol >= date_trunc(mintimestring,minresolution)
+ *      and
+ *    timecol < date_trunc(maxtimestring,maxresolution) + interval '1
+ * maxresolution'
+ * )
+ */
+static int createPostgresTimeCompareLessThan(const char *timestring, char *dest,
+                                             size_t destsize) {
+  int timeresolution = msTimeGetResolution(timestring);
+  char timestamp[100];
+  const char *interval;
+  if (timeresolution < 0)
+    return MS_FALSE;
+
+  postgresTimeStampForTimeString(timestring, timestamp, 100);
+
+  switch (timeresolution) {
+  case TIME_RESOLUTION_YEAR:
+    interval = "year";
+    break;
+  case TIME_RESOLUTION_MONTH:
+    interval = "month";
+    break;
+  case TIME_RESOLUTION_DAY:
+    interval = "day";
+    break;
+  case TIME_RESOLUTION_HOUR:
+    interval = "hour";
+    break;
+  case TIME_RESOLUTION_MINUTE:
+    interval = "minute";
+    break;
+  case TIME_RESOLUTION_SECOND:
+    interval = "second";
+    break;
+  default:
+    return MS_FAILURE;
+  }
+  snprintf(dest, destsize,
+           "(date_trunc('%s',%s) + interval '1 %s' - interval '1 second')",
+           interval, timestamp, interval);
+  return MS_SUCCESS;
+}
+#endif
+
+static char *msPostGISEscapeSQLParam(layerObj *layer, const char *pszString) {
+#ifdef USE_POSTGIS
+  char *pszEscapedStr = nullptr;
+
+  if (layer && pszString) {
+    if (!msPostGISLayerIsOpen(layer))
+      msPostGISLayerOpen(layer);
+
+    assert(layer->layerinfo != nullptr);
+
+    msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+    size_t nSrcLen = strlen(pszString);
+    pszEscapedStr = (char *)msSmallMalloc(2 * nSrcLen + 1);
+    int nError = 0;
+    PQescapeStringConn(layerinfo->pgconn, pszEscapedStr, pszString, nSrcLen,
+                       &nError);
+    if (nError != 0) {
+      free(pszEscapedStr);
+      pszEscapedStr = nullptr;
+    }
+  }
+  return pszEscapedStr;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISEscapeSQLParam()");
+  return NULL;
+#endif
+}
+
+static void msPostGISEnablePaging(layerObj *layer, int value) {
+#ifdef USE_POSTGIS
+  if (layer->debug) {
+    msDebug("msPostGISEnablePaging called.\n");
+  }
+
+  if (!msPostGISLayerIsOpen(layer)) {
+    if (msPostGISLayerOpen(layer) != MS_SUCCESS) {
+      return;
+    }
+  }
+
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  layerinfo->paging = value;
+
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISEnablePaging()");
+#endif
+  return;
+}
+
+static int msPostGISGetPaging(layerObj *layer) {
+#ifdef USE_POSTGIS
+  if (layer->debug) {
+    msDebug("msPostGISGetPaging called.\n");
+  }
+
+  if (!msPostGISLayerIsOpen(layer))
+    return MS_TRUE;
+
+  assert(layer->layerinfo != nullptr);
+
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  return layerinfo->paging;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISEnablePaging()");
+  return MS_FAILURE;
+#endif
+}
+
+/*
+** msPostGISLayerTranslateFilter()
+**
+** Registered vtable->LayerTranslateFilter function.
+*/
+static int msPostGISLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                         char *filteritem) {
+#ifdef USE_POSTGIS
+  tokenListNodeObjPtr node = nullptr;
+
+  std::string native_string;
+
+  int comparisonToken = -1;
+  int bindingToken = -1;
+
+  msPostGISLayerInfo *layerinfo =
+      static_cast<msPostGISLayerInfo *>(layer->layerinfo);
+
+  if (!filter->string)
+    return MS_SUCCESS; /* not an error, just nothing to do */
+
+  // fprintf(stderr, "input: %s, %s, %d\n", filter->string, filteritem,
+  // filter->type);
+
+  /*
+  ** FILTERs use MapServer syntax *only* (#5001).
+  */
+  if (filter->type == MS_STRING && filter->string &&
+      filteritem) { /* item/value pair - add escaping */
+
+    char *stresc = msLayerEscapePropertyName(layer, filteritem);
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      native_string += "upper(";
+      native_string += stresc;
+      native_string += "::text) = upper(";
+    } else {
+      native_string += stresc;
+      native_string += "::text = ";
+    }
+    msFree(stresc);
+
+    /* don't have a type for the righthand literal so assume it's a string and
+     * we quote */
+    stresc = msPostGISEscapeSQLParam(layer, filter->string);
+    native_string += '\'';
+    native_string += stresc;
+    native_string += '\'';
+    msFree(stresc);
+
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      native_string += ")";
+  } else if (filter->type == MS_REGEX && filter->string &&
+             filteritem) { /* item/regex pair  - add escaping */
+
+    char *stresc = msLayerEscapePropertyName(layer, filteritem);
+    native_string += stresc;
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      native_string += "::text ~* ";
+    } else {
+      native_string += "::text ~ ";
+    }
+    msFree(stresc);
+
+    stresc = msPostGISEscapeSQLParam(layer, filter->string);
+    native_string += '\'';
+    native_string += stresc;
+    native_string += '\'';
+    msFree(stresc);
+  } else if (filter->type == MS_EXPRESSION) {
+    int ieq_expected = MS_FALSE;
+
+    if (msPostGISParseData(layer) != MS_SUCCESS)
+      return MS_FAILURE;
+
+    if (layer->debug >= 2)
+      msDebug("msPostGISLayerTranslateFilter. String: %s.\n", filter->string);
+    if (!filter->tokens)
+      return MS_SUCCESS;
+    if (layer->debug >= 2)
+      msDebug(
+          "msPostGISLayerTranslateFilter. There are tokens to process... \n");
+
+    node = filter->tokens;
+    while (node != nullptr) {
+
+      /*
+      ** Do any token caching/tracking here, easier to have it in one place.
+      */
+      if (node->token == MS_TOKEN_BINDING_TIME) {
+        bindingToken = node->token;
+      } else if (node->token == MS_TOKEN_COMPARISON_EQ ||
+                 node->token == MS_TOKEN_COMPARISON_IEQ ||
+                 node->token == MS_TOKEN_COMPARISON_NE ||
+                 node->token == MS_TOKEN_COMPARISON_GT ||
+                 node->token == MS_TOKEN_COMPARISON_GE ||
+                 node->token == MS_TOKEN_COMPARISON_LT ||
+                 node->token == MS_TOKEN_COMPARISON_LE ||
+                 node->token == MS_TOKEN_COMPARISON_IN) {
+        comparisonToken = node->token;
+      }
+
+      switch (node->token) {
+
+      /* literal tokens */
+      case MS_TOKEN_LITERAL_BOOLEAN:
+        if (node->tokenval.dblval == MS_TRUE)
+          native_string += "TRUE";
+        else
+          native_string += "FALSE";
+        break;
+      case MS_TOKEN_LITERAL_NUMBER: {
+        if (node->tokenval.dblval >= INT_MIN &&
+            node->tokenval.dblval <= INT_MAX &&
+            node->tokenval.dblval == (int)node->tokenval.dblval)
+          native_string += std::to_string((int)node->tokenval.dblval);
+        else {
+          char buffer[32];
+          snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
+          native_string += buffer;
+        }
+        break;
+      }
+      case MS_TOKEN_LITERAL_STRING:
+
+        if (comparisonToken == MS_TOKEN_COMPARISON_IN) { /* issue 5490 */
+          int nstrings = 0;
+          char **strings = msStringSplit(node->tokenval.strval, ',', &nstrings);
+          if (nstrings > 0) {
+            native_string += "(";
+            for (int i = 0; i < nstrings; i++) {
+              if (i != 0)
+                native_string += ",";
+              char *stresc = msPostGISEscapeSQLParam(layer, strings[i]);
+              native_string += '\'';
+              native_string += stresc;
+              native_string += '\'';
+              msFree(stresc);
+            }
+            native_string += ")";
+          }
+
+          msFreeCharArray(strings, nstrings);
+        } else {
+          const char *strbegin;
+          const char *strend;
+          if (comparisonToken == MS_TOKEN_COMPARISON_IEQ) {
+            strbegin = "lower('";
+            strend = "')";
+          } else {
+            strbegin = "'";
+            strend = "'";
+          }
+          char *stresc = msPostGISEscapeSQLParam(layer, node->tokenval.strval);
+          native_string += strbegin;
+          native_string += stresc;
+          native_string += strend;
+          msFree(stresc);
+        }
+
+        break;
+      case MS_TOKEN_LITERAL_TIME: {
+        char *snippet = (char *)msSmallMalloc(512);
+        if (comparisonToken == MS_TOKEN_COMPARISON_EQ) { // TODO: support !=
+          createPostgresTimeCompareEquals(node->tokensrc, snippet, 512);
+        } else if (comparisonToken == MS_TOKEN_COMPARISON_GT ||
+                   comparisonToken == MS_TOKEN_COMPARISON_GE) {
+          createPostgresTimeCompareGreaterThan(node->tokensrc, snippet, 512);
+        } else if (comparisonToken == MS_TOKEN_COMPARISON_LT ||
+                   comparisonToken == MS_TOKEN_COMPARISON_LE) {
+          createPostgresTimeCompareLessThan(node->tokensrc, snippet, 512);
+        } else {
+          msFree(snippet);
+          goto cleanup;
+        }
+
+        comparisonToken = -1;
+        bindingToken = -1; /* reset */
+        native_string += snippet;
+        msFree(snippet);
+        break;
+      }
+      case MS_TOKEN_LITERAL_SHAPE: {
+        char *wkt = msShapeToWKT(node->tokenval.shpval);
+        native_string += "ST_GeomFromText('";
+        native_string += wkt;
+        msFree(wkt);
+        native_string += "'";
+        if (!layerinfo->srid.empty()) {
+          native_string += ",";
+          native_string += layerinfo->srid;
+        }
+        native_string += ")";
+        break;
+      }
+
+        /* data binding tokens */
+      case MS_TOKEN_BINDING_TIME:
+      case MS_TOKEN_BINDING_DOUBLE:
+      case MS_TOKEN_BINDING_INTEGER:
+      case MS_TOKEN_BINDING_STRING: {
+        const char *strbegin = "";
+        const char *strend = "";
+        if (node->token == MS_TOKEN_BINDING_STRING &&
+            node->next->token == MS_TOKEN_COMPARISON_IEQ) {
+          strbegin = "lower(";
+          strend = "::text)";
+          ieq_expected = MS_TRUE;
+        } else if (node->token == MS_TOKEN_BINDING_STRING ||
+                   node->next->token == MS_TOKEN_COMPARISON_RE ||
+                   node->next->token == MS_TOKEN_COMPARISON_IRE)
+          strend = "::text"; /* explicit cast necessary for certain operators */
+
+        char *stresc =
+            msLayerEscapePropertyName(layer, node->tokenval.bindval.item);
+        native_string += strbegin;
+        native_string += stresc;
+        native_string += strend;
+        msFree(stresc);
+        break;
+      }
+      case MS_TOKEN_BINDING_SHAPE:
+        native_string += layerinfo->geomcolumn;
+        break;
+      case MS_TOKEN_BINDING_MAP_CELLSIZE: {
+        char buffer[32];
+        snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
+        native_string += buffer;
+        break;
+      }
+
+        /* spatial comparison tokens */
+      case MS_TOKEN_COMPARISON_INTERSECTS:
+      case MS_TOKEN_COMPARISON_DISJOINT:
+      case MS_TOKEN_COMPARISON_TOUCHES:
+      case MS_TOKEN_COMPARISON_OVERLAPS:
+      case MS_TOKEN_COMPARISON_CROSSES:
+      case MS_TOKEN_COMPARISON_WITHIN:
+      case MS_TOKEN_COMPARISON_CONTAINS:
+      case MS_TOKEN_COMPARISON_EQUALS:
+      case MS_TOKEN_COMPARISON_DWITHIN: {
+        if (node->next->token != '(')
+          goto cleanup;
+        native_string += "st_";
+        const char *str = msExpressionTokenToString(node->token);
+        if (str == nullptr)
+          goto cleanup;
+        native_string += str;
+        break;
+      }
+
+        /* functions */
+      case MS_TOKEN_FUNCTION_LENGTH:
+      case MS_TOKEN_FUNCTION_AREA:
+      case MS_TOKEN_FUNCTION_BUFFER:
+      case MS_TOKEN_FUNCTION_DIFFERENCE: {
+        native_string += "st_";
+        const char *str = msExpressionTokenToString(node->token);
+        if (str == nullptr)
+          goto cleanup;
+        native_string += str;
+        break;
+      }
+
+      case MS_TOKEN_COMPARISON_IEQ:
+        if (ieq_expected) {
+          native_string += "=";
+          ieq_expected = MS_FALSE;
+        } else {
+          goto cleanup;
+        }
+        break;
+
+        /* unsupported tokens */
+      case MS_TOKEN_COMPARISON_BEYOND:
+      case MS_TOKEN_FUNCTION_TOSTRING:
+      case MS_TOKEN_FUNCTION_ROUND:
+      case MS_TOKEN_FUNCTION_SIMPLIFY:
+      case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+      case MS_TOKEN_FUNCTION_GENERALIZE:
+        goto cleanup;
+        break;
+
+      default: {
+        /* by default accept the general token to string conversion */
+
+        if (node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr &&
+            node->next->token == MS_TOKEN_LITERAL_TIME)
+          break; /* skip, handled with the next token */
+        if (bindingToken == MS_TOKEN_BINDING_TIME &&
+            (node->token == MS_TOKEN_COMPARISON_EQ ||
+             node->token == MS_TOKEN_COMPARISON_NE))
+          break; /* skip, handled elsewhere */
+        if (node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr &&
+            node->next->token == MS_TOKEN_LITERAL_STRING &&
+            strcmp(node->next->tokenval.strval, "_MAPSERVER_NULL_") == 0) {
+          native_string += " IS NULL";
+          node = node->next;
+          break;
+        }
+
+        const char *str = msExpressionTokenToString(node->token);
+        if (str == nullptr)
+          goto cleanup;
+        native_string += str;
+        break;
+      }
+      }
+
+      node = node->next;
+    }
+  }
+
+  filter->native_string = msStrdup(native_string.c_str());
+
+  // fprintf(stderr, "output: %s\n", filter->native_string);
+
+  return MS_SUCCESS;
+
+cleanup:
+  msSetError(MS_MISCERR, "Translation to native SQL failed.",
+             "msPostGISLayerTranslateFilter()");
+  return MS_FAILURE;
+#else
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerTranslateFilter()");
+  return MS_FAILURE;
+#endif
+}
+
+int msPostGISLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != nullptr);
+  assert(layer->vtable != nullptr);
+
+  layer->vtable->LayerTranslateFilter = msPostGISLayerTranslateFilter;
+
+  layer->vtable->LayerInitItemInfo = msPostGISLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msPostGISLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msPostGISLayerOpen;
+  layer->vtable->LayerIsOpen = msPostGISLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msPostGISLayerWhichShapes;
+  layer->vtable->LayerNextShape = msPostGISLayerNextShape;
+  layer->vtable->LayerGetShape = msPostGISLayerGetShape;
+  layer->vtable->LayerGetShapeCount = msPostGISLayerGetShapeCount;
+  layer->vtable->LayerClose = msPostGISLayerClose;
+  layer->vtable->LayerGetItems = msPostGISLayerGetItems;
+  layer->vtable->LayerGetExtent = msPostGISLayerGetExtent;
+  layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
+  /* layer->vtable->LayerGetAutoStyle, not supported for this layer */
+  /* layer->vtable->LayerCloseConnection = msPostGISLayerClose; */
+  // layer->vtable->LayerSetTimeFilter = msPostGISLayerSetTimeFilter;
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  layer->vtable->LayerGetNumFeatures = msPostGISLayerGetNumFeatures;
+
+  /* layer->vtable->LayerGetAutoProjection, use defaut*/
+
+  layer->vtable->LayerEscapeSQLParam = msPostGISEscapeSQLParam;
+  layer->vtable->LayerEnablePaging = msPostGISEnablePaging;
+  layer->vtable->LayerGetPaging = msPostGISGetPaging;
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mappostgis.h 8.2.0~beta1-1~exp1/src/mappostgis.h
--- 8.0.1-5/src/mappostgis.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mappostgis.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,150 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  PostGIS CONNECTIONTYPE support.
+ * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
+ *           Dave Blasby <dblasby@gmail.com>
+ *
+ ******************************************************************************
+ * Copyright (c) 2010 Paul Ramsey
+ * Copyright (c) 2002 Refractions Research
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifdef USE_POSTGIS
+
+#include "libpq-fe.h"
+#include <string>
+
+#ifndef LITTLE_ENDIAN
+#define LITTLE_ENDIAN 1
+#endif
+#ifndef BIG_ENDIAN
+#define BIG_ENDIAN 2
+#endif
+
+/* HEX = 16, BASE64 = 64, RAW = 256*/
+#define TRANSFER_ENCODING 256
+
+/* Substitution token for box hackery */
+#define BOXTOKEN "!BOX!"
+#define BOXTOKENLENGTH 5
+
+/*
+** msPostGISLayerInfo
+**
+** Specific information needed for managing this layer.
+*/
+typedef struct {
+  std::string sql{};        /* SQL query to send to database */
+  PGconn *pgconn = nullptr; /* Connection to database */
+  long rownum = 0; /* What row is the next to be read (for random access) */
+  PGresult *pgresult = nullptr; /* For fetching rows from the database */
+  std::string uid{};  /* Name of user-specified unique identifier, if set */
+  std::string srid{}; /* Name of user-specified SRID: zero-length => calculate;
+                         non-zero => use this value! */
+  std::string
+      geomcolumn{}; /* Specified geometry column, eg "THEGEOM from thetable" */
+  std::string fromsource{}; /* Specified record source, ed "thegeom from
+                               THETABLE" or "thegeom from (SELECT..) AS FOO" */
+  int endian = 0;           /* Endianness of the mapserver host */
+  int version = 0;          /* PostGIS version of the database */
+  int paging = 0;  /* Driver handling of pagination, enabled by default */
+  int force2d = 0; /* Pass geometry through ST_Force2D */
+} msPostGISLayerInfo;
+
+/*
+** Utility structure for handling the WKB returned by the database while
+** reading.
+*/
+typedef struct {
+  char *wkb;          /* Pointer to front of WKB */
+  char *ptr;          /* Pointer to current write point */
+  size_t size;        /* Size of allocated space */
+  const int *typemap; /* Look-up array to valid OGC types */
+} wkbObj;
+
+/*
+** All the WKB type numbers from the OGC
+*/
+typedef enum {
+  WKB_POINT = 1,
+  WKB_LINESTRING = 2,
+  WKB_POLYGON = 3,
+  WKB_MULTIPOINT = 4,
+  WKB_MULTILINESTRING = 5,
+  WKB_MULTIPOLYGON = 6,
+  WKB_GEOMETRYCOLLECTION = 7,
+  WKB_CIRCULARSTRING = 8,
+  WKB_COMPOUNDCURVE = 9,
+  WKB_CURVEPOLYGON = 10,
+  WKB_MULTICURVE = 11,
+  WKB_MULTISURFACE = 12
+} wkb_typenum;
+
+/*
+** See below.
+*/
+#define WKB_TYPE_COUNT 16
+
+/*
+** Map the WKB type numbers returned by PostGIS < 2.0 to the
+** valid OGC numbers
+*/
+static const int wkb_postgis15[WKB_TYPE_COUNT] = {0,
+                                                  WKB_POINT,
+                                                  WKB_LINESTRING,
+                                                  WKB_POLYGON,
+                                                  WKB_MULTIPOINT,
+                                                  WKB_MULTILINESTRING,
+                                                  WKB_MULTIPOLYGON,
+                                                  WKB_GEOMETRYCOLLECTION,
+                                                  WKB_CIRCULARSTRING,
+                                                  WKB_COMPOUNDCURVE,
+                                                  0,
+                                                  0,
+                                                  0,
+                                                  WKB_CURVEPOLYGON,
+                                                  WKB_MULTICURVE,
+                                                  WKB_MULTISURFACE};
+
+/*
+** Map the WKB type numbers returned by PostGIS >= 2.0 to the
+** valid OGC numbers
+*/
+static const int wkb_postgis20[WKB_TYPE_COUNT] = {0,
+                                                  WKB_POINT,
+                                                  WKB_LINESTRING,
+                                                  WKB_POLYGON,
+                                                  WKB_MULTIPOINT,
+                                                  WKB_MULTILINESTRING,
+                                                  WKB_MULTIPOLYGON,
+                                                  WKB_GEOMETRYCOLLECTION,
+                                                  WKB_CIRCULARSTRING,
+                                                  WKB_COMPOUNDCURVE,
+                                                  WKB_CURVEPOLYGON,
+                                                  WKB_MULTICURVE,
+                                                  WKB_MULTISURFACE,
+                                                  0,
+                                                  0,
+                                                  0};
+
+#endif /* USE_POSTGIS */
diff -pruN 8.0.1-5/src/mappostgresql.c 8.2.0~beta1-1~exp1/src/mappostgresql.c
--- 8.0.1-5/src/mappostgresql.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mappostgresql.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,442 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Postgres CONNECTIONTYPE support.
+ * Author:   Mark Leslie, Refractions Research
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/* $Id$ */
+#include <assert.h>
+#include "mapserver.h"
+#include "maptime.h"
+
+#ifndef FLT_MAX
+#define FLT_MAX 25000000.0
+#endif
+
+#ifdef USE_POSTGIS
+
+#ifndef LITTLE_ENDIAN
+#define LITTLE_ENDIAN 1
+#endif
+#ifndef BIG_ENDIAN
+#define BIG_ENDIAN 2
+#endif
+
+#include "libpq-fe.h"
+#include <string.h>
+#include <ctype.h> /* tolower() */
+
+typedef struct {
+  PGconn *conn; /* connection to db */
+  long row_num; /* what row is the NEXT to be read (for random access) */
+  PGresult *query_result; /* for fetching rows from the db */
+  int from_index;
+  char *to_column;
+  char *from_value;
+  int layer_debug; /* there's no debug on the join, so use the layer */
+} msPOSTGRESQLJoinInfo;
+
+/************************************************************************/
+/*                      msPOSTGRESQLJoinConnect()                       */
+/*                                                                      */
+/* Creates and populates the joininfo struct, including establishing    */
+/* a connection to the database.  Since the join and layer won't always */
+/* share connection details, there is currently no mechanism to use     */
+/* pooled connections with joins.                                       */
+/************************************************************************/
+
+int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join) {
+  char *maskeddata, *temp, *sql, *column;
+  char *conn_decrypted;
+  int i, test;
+  PGresult *query_result;
+  msPOSTGRESQLJoinInfo *joininfo;
+
+  if (join->joininfo)
+    return MS_SUCCESS;
+
+  joininfo = (msPOSTGRESQLJoinInfo *)malloc(sizeof(msPOSTGRESQLJoinInfo));
+  if (!joininfo) {
+    msSetError(MS_MEMERR, "Error allocating join info struct.",
+               "msPOSTGRESQLJoinConnect()");
+    return MS_FAILURE;
+  }
+  joininfo->conn = NULL;
+  joininfo->row_num = 0;
+  joininfo->query_result = NULL;
+  joininfo->from_index = 0;
+  joininfo->to_column = join->to;
+  joininfo->from_value = NULL;
+  joininfo->layer_debug = layer->debug;
+  join->joininfo = joininfo;
+
+  /*
+   * We need three things at a minimum, the connection string, a table
+   * name, and a column to join on.
+   */
+  if (!join->connection) {
+    msSetError(MS_QUERYERR, "No connection information provided.",
+               "MSPOSTGRESQLJoinConnect()");
+    return MS_FAILURE;
+  }
+  if (!join->table) {
+    msSetError(MS_QUERYERR, "No join table name found.",
+               "msPOSTGRESQLJoinConnect()");
+    return MS_FAILURE;
+  }
+  if (!joininfo->to_column) {
+    msSetError(MS_QUERYERR, "No join to column name found.",
+               "msPOSTGRESQLJoinConnect()");
+    return MS_FAILURE;
+  }
+
+  /* Establish database connection */
+  conn_decrypted = msDecryptStringTokens(layer->map, join->connection);
+  if (conn_decrypted != NULL) {
+    joininfo->conn = PQconnectdb(conn_decrypted);
+    free(conn_decrypted);
+  }
+  if (!joininfo->conn || PQstatus(joininfo->conn) == CONNECTION_BAD) {
+    maskeddata = (char *)malloc(strlen(layer->connection) + 1);
+    strcpy(maskeddata, join->connection);
+    temp = strstr(maskeddata, "password=");
+    if (temp) {
+      temp = (char *)(temp + 9);
+      while (*temp != '\0' && *temp != ' ') {
+        *temp = '*';
+        temp++;
+      }
+    }
+    msSetError(MS_QUERYERR,
+               "Unable to connect to PostgreSQL using the string %s.\n  Error "
+               "reported: %s\n",
+               "msPOSTGRESQLJoinConnect()", maskeddata,
+               PQerrorMessage(joininfo->conn));
+    free(maskeddata);
+    if (!joininfo->conn) {
+      free(joininfo->conn);
+    }
+    free(joininfo);
+    join->joininfo = NULL;
+    return MS_FAILURE;
+  }
+
+  /* Determine the number and names of columns in the join table. */
+  sql = (char *)malloc(36 + strlen(join->table) + 1);
+  sprintf(sql, "SELECT * FROM %s WHERE false LIMIT 0", join->table);
+
+  if (joininfo->layer_debug) {
+    msDebug("msPOSTGRESQLJoinConnect(): executing %s.\n", sql);
+  }
+
+  query_result = PQexec(joininfo->conn, sql);
+  if (!query_result || PQresultStatus(query_result) != PGRES_TUPLES_OK) {
+    msSetError(MS_QUERYERR, "Error determining join items: %s.",
+               "msPOSTGRESQLJoinConnect()", PQerrorMessage(joininfo->conn));
+    if (query_result) {
+      PQclear(query_result);
+      query_result = NULL;
+    }
+    free(sql);
+    return MS_FAILURE;
+  }
+  free(sql);
+  join->numitems = PQnfields(query_result);
+  join->items = malloc(sizeof(char *) * (join->numitems));
+
+  /* We want the join-to column to be first in the list. */
+  test = 1;
+  for (i = 0; i < join->numitems; i++) {
+    column = PQfname(query_result, i);
+    if (strcmp(column, joininfo->to_column) != 0) {
+      join->items[i + test] = (char *)malloc(strlen(column) + 1);
+      strcpy(join->items[i + test], column);
+    } else {
+      test = 0;
+      join->items[0] = (char *)malloc(strlen(column) + 1);
+      strcpy(join->items[0], column);
+    }
+  }
+  PQclear(query_result);
+  query_result = NULL;
+  if (test == 1) {
+    msSetError(MS_QUERYERR, "Unable to find join to column: %s",
+               "msPOSTGRESQLJoinConnect()", joininfo->to_column);
+    return MS_FAILURE;
+  }
+
+  if (joininfo->layer_debug) {
+    for (i = 0; i < join->numitems; i++) {
+      msDebug("msPOSTGRESQLJoinConnect(): Column %d named %s\n", i,
+              join->items[i]);
+    }
+  }
+
+  /* Determine the index of the join from column. */
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) {
+      joininfo->from_index = i;
+      break;
+    }
+  }
+
+  if (i == layer->numitems) {
+    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
+               "msPOSTGRESQLJoinConnect()", join->from, layer->name);
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                                                                      */
+/*                       msPOSTGRESQLJoinPrepare()                      */
+/* Sets up the joininfo to be ready to join against the given shape.    */
+/* There's not much involved here, just freeing previous results and    */
+/* resources, and setting the next value to join to.                    */
+/************************************************************************/
+
+int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape) {
+
+  /* We need a connection, and a shape with values to join to. */
+  msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join has not been connected.",
+               "msPOSTGRESQLJoinPrepare()");
+    return MS_FAILURE;
+  }
+
+  if (!shape) {
+    msSetError(MS_JOINERR, "Null shape provided for join.",
+               "msPOSTGRESQLJoinPrepare()");
+    return MS_FAILURE;
+  }
+
+  if (!shape->values) {
+    msSetError(MS_JOINERR,
+               "Shape has no attributes.  Kinda hard to join against.",
+               "msPOSTGRESQLJoinPrepare()");
+    return MS_FAILURE;
+  }
+  joininfo->row_num = 0;
+
+  /* Free the previous join value, if any. */
+  if (joininfo->from_value) {
+    free(joininfo->from_value);
+  }
+
+  /* Free the previous results, if any. */
+  if (joininfo->query_result) {
+    PQclear(joininfo->query_result);
+    joininfo->query_result = NULL;
+  }
+
+  /* Copy the next join value from the shape. */
+  joininfo->from_value = msStrdup(shape->values[joininfo->from_index]);
+
+  if (joininfo->layer_debug) {
+    msDebug("msPOSTGRESQLJoinPrepare() preping for value %s.\n",
+            joininfo->from_value);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msPOSTGRESQLJoinNext()                         */
+/*                                                                      */
+/* The goal here is to populate join->values with the detail of the     */
+/* join against the previously prepared shapeObj.  This will be called  */
+/* only once for a one-to-one join, with msPOSTGRESQLJoinPrepare()      */
+/* being called before each.  It will be called repeatedly for          */
+/* one-to-many joins, until in returns MS_DONE.  To accomodate this,    */
+/* we store the next row number and query results in the joininfo and   */
+/* process the next tuple on each call.                                 */
+/************************************************************************/
+int msPOSTGRESQLJoinNext(joinObj *join) {
+  msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
+  int i, length, row_count;
+  char *sql, *columns;
+
+  /* We need a connection, and a join value. */
+  if (!joininfo || !joininfo->conn) {
+    msSetError(MS_JOINERR, "Join has not been connected.\n",
+               "msPOSTGRESQLJoinNext()");
+    return MS_FAILURE;
+  }
+
+  if (!joininfo->from_value) {
+    msSetError(MS_JOINERR, "Join has not been prepared.\n",
+               "msPOSTGRESQLJoinNext()");
+    return MS_FAILURE;
+  }
+
+  /* Free the previous results. */
+  if (join->values) {
+    msFreeCharArray(join->values, join->numitems);
+    join->values = NULL;
+  }
+
+  /* We only need to execute the query if no results exist. */
+  if (!joininfo->query_result) {
+    /* Write the list of column names. */
+    length = 0;
+    for (i = 0; i < join->numitems; i++) {
+      length += 8 + strlen(join->items[i]) + 2;
+    }
+
+    columns = (char *)malloc(length);
+    if (!columns) {
+      msSetError(MS_MEMERR, "Failure to malloc.\n", "msPOSTGRESQLJoinNext()");
+      return MS_FAILURE;
+    }
+
+    strcpy(columns, "");
+    for (i = 0; i < join->numitems; i++) {
+      strcat(columns, "\"");
+      strcat(columns, join->items[i]);
+      strcat(columns, "\"::text");
+      if (i != join->numitems - 1) {
+        strcat(columns, ", ");
+      }
+    }
+
+    /* Create the query string. */
+    sql = (char *)malloc(26 + strlen(columns) + strlen(join->table) +
+                         strlen(join->to) + strlen(joininfo->from_value));
+    if (!sql) {
+      msSetError(MS_MEMERR, "Failure to malloc.\n", "msPOSTGRESQLJoinNext()");
+      return MS_FAILURE;
+    }
+    sprintf(sql, "SELECT %s FROM %s WHERE %s = '%s'", columns, join->table,
+            join->to, joininfo->from_value);
+    if (joininfo->layer_debug) {
+      msDebug("msPOSTGRESQLJoinNext(): executing %s.\n", sql);
+    }
+
+    free(columns);
+
+    joininfo->query_result = PQexec(joininfo->conn, sql);
+
+    if (!joininfo->query_result ||
+        PQresultStatus(joininfo->query_result) != PGRES_TUPLES_OK) {
+      msSetError(MS_QUERYERR, "Error executing queri %s: %s\n",
+                 "msPOSTGRESQLJoinNext()", sql, PQerrorMessage(joininfo->conn));
+      if (joininfo->query_result) {
+        PQclear(joininfo->query_result);
+        joininfo->query_result = NULL;
+      }
+      free(sql);
+      return MS_FAILURE;
+    }
+    free(sql);
+  }
+  row_count = PQntuples(joininfo->query_result);
+
+  /* see if we're done processing this set */
+  if (joininfo->row_num >= row_count) {
+    return (MS_DONE);
+  }
+  if (joininfo->layer_debug) {
+    msDebug("msPOSTGRESQLJoinNext(): fetching row %ld.\n", joininfo->row_num);
+  }
+
+  /* Copy the resulting values into the joinObj. */
+  join->values = (char **)malloc(sizeof(char *) * join->numitems);
+  for (i = 0; i < join->numitems; i++) {
+    join->values[i] =
+        msStrdup(PQgetvalue(joininfo->query_result, joininfo->row_num, i));
+  }
+
+  joininfo->row_num++;
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msPOSTGRESQLJoinClose()                        */
+/*                                                                      */
+/* Closes the connection and frees the resources used by the joininfo.  */
+/************************************************************************/
+
+int msPOSTGRESQLJoinClose(joinObj *join) {
+  msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
+
+  if (!joininfo) {
+    msDebug("msPOSTGRESQLJoinClose() already close or never opened.\n");
+    return MS_SUCCESS;
+  }
+
+  if (joininfo->query_result) {
+    msDebug("msPOSTGRESQLJoinClose(): clearing query_result.\n");
+    PQclear(joininfo->query_result);
+    joininfo->query_result = NULL;
+  }
+
+  if (joininfo->conn) {
+    msDebug("msPOSTGRESQLJoinClose(): closing connection.\n");
+    PQfinish(joininfo->conn);
+    joininfo->conn = NULL;
+  }
+
+  /* removed free(joininfo->to_column), see bug #2936 */
+
+  if (joininfo->from_value) {
+    free(joininfo->from_value);
+  }
+
+  free(joininfo);
+  join->joininfo = NULL;
+
+  return MS_SUCCESS;
+}
+
+#else /* not USE_POSTGIS */
+int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinConnect()");
+  return MS_FAILURE;
+}
+
+int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinPrepare()");
+  return MS_FAILURE;
+}
+
+int msPOSTGRESQLJoinNext(joinObj *join) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinNext()");
+  return MS_FAILURE;
+}
+
+int msPOSTGRESQLJoinClose(joinObj *join) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinClose()");
+  return MS_FAILURE;
+}
+#endif
diff -pruN 8.0.1-5/src/mapprimitive.c 8.2.0~beta1-1~exp1/src/mapprimitive.c
--- 8.0.1-5/src/mapprimitive.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapprimitive.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2630 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementations for rectObj, pointObj, lineObj, shapeObj, etc.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+#include "mapserver.h"
+#include "mapprimitive.h"
+#include <assert.h>
+#include <locale.h>
+#include "fontcache.h"
+
+typedef enum { CLIP_LEFT, CLIP_MIDDLE, CLIP_RIGHT } CLIP_STATE;
+
+#define CLIP_CHECK(min, a, max)                                                \
+  ((a) < (min) ? CLIP_LEFT : ((a) > (max) ? CLIP_RIGHT : CLIP_MIDDLE));
+#define ROUND(a) ((a) + 0.5)
+#define SWAP(a, b, t) ((t) = (a), (a) = (b), (b) = (t))
+#define EDGE_CHECK(x0, x, x1)                                                  \
+  ((x) < MS_MIN((x0), (x1))                                                    \
+       ? CLIP_LEFT                                                             \
+       : ((x) > MS_MAX((x0), (x1)) ? CLIP_RIGHT : CLIP_MIDDLE))
+
+#ifndef INFINITY
+#define INFINITY (1.0e+30)
+#endif
+#define NEARZERO (1.0e-30) /* 1/INFINITY */
+
+void msPrintShape(shapeObj *p) {
+  int i, j;
+
+  msDebug("Shape contains %d parts.\n", p->numlines);
+  for (i = 0; i < p->numlines; i++) {
+    msDebug("\tPart %d contains %d points.\n", i, p->line[i].numpoints);
+    for (j = 0; j < p->line[i].numpoints; j++) {
+      msDebug("\t\t%d: (%f, %f)\n", j, p->line[i].point[j].x,
+              p->line[i].point[j].y);
+    }
+  }
+}
+
+shapeObj *msShapeFromWKT(const char *string) {
+#ifdef USE_GEOS
+  return msGEOSShapeFromWKT(string);
+#else
+  return msOGRShapeFromWKT(string);
+#endif
+}
+
+char *msShapeToWKT(shapeObj *shape) {
+#ifdef USE_GEOS
+  char *pszGEOSStr;
+  char *pszStr;
+  pszGEOSStr = msGEOSShapeToWKT(shape);
+  pszStr = (pszGEOSStr) ? msStrdup(pszGEOSStr) : NULL;
+  msGEOSFreeWKT(pszGEOSStr);
+  return pszStr;
+#else
+  return msOGRShapeToWKT(shape);
+#endif
+}
+
+void msInitShape(shapeObj *shape) {
+  /* spatial component */
+  shape->line = NULL;
+  shape->numlines = 0;
+  shape->type = MS_SHAPE_NULL;
+  shape->bounds.minx = shape->bounds.miny = -1;
+  shape->bounds.maxx = shape->bounds.maxy = -1;
+
+  /* attribute component */
+  shape->values = NULL;
+  shape->numvalues = 0;
+
+  shape->geometry = NULL;
+  shape->renderer_cache = NULL;
+
+  /* annotation component */
+  shape->text = NULL;
+
+  /* bookkeeping component */
+  shape->classindex = 0; /* default class */
+  shape->tileindex = shape->index = shape->resultindex = -1;
+
+  shape->scratch = MS_FALSE; /* not a temporary/scratch shape */
+}
+
+int msCopyShape(const shapeObj *from, shapeObj *to) {
+  int i;
+
+  if (!from || !to)
+    return (-1);
+
+  for (i = 0; i < from->numlines; i++)
+    msAddLine(to, &(from->line[i])); /* copy each line */
+
+  to->type = from->type;
+
+  to->bounds.minx = from->bounds.minx;
+  to->bounds.miny = from->bounds.miny;
+  to->bounds.maxx = from->bounds.maxx;
+  to->bounds.maxy = from->bounds.maxy;
+
+  if (from->text)
+    to->text = msStrdup(from->text);
+
+  to->classindex = from->classindex;
+  to->index = from->index;
+  to->tileindex = from->tileindex;
+  to->resultindex = from->resultindex;
+
+  if (from->values) {
+    if (to->values)
+      msFreeCharArray(to->values, to->numvalues);
+    to->values = (char **)msSmallMalloc(sizeof(char *) * from->numvalues);
+    for (i = 0; i < from->numvalues; i++)
+      to->values[i] = msStrdup(from->values[i]);
+    to->numvalues = from->numvalues;
+  }
+
+  to->geometry = NULL; /* GEOS code will build automatically if necessary */
+  to->scratch = from->scratch;
+
+  return (0);
+}
+
+void msFreeShape(shapeObj *shape) {
+  int c;
+
+  if (!shape)
+    return; /* for safety */
+
+  for (c = 0; c < shape->numlines; c++)
+    free(shape->line[c].point);
+
+  if (shape->line)
+    free(shape->line);
+  if (shape->values)
+    msFreeCharArray(shape->values, shape->numvalues);
+  if (shape->text)
+    free(shape->text);
+
+#ifdef USE_GEOS
+  msGEOSFreeGeometry(shape);
+#endif
+
+  msInitShape(shape); /* now reset */
+}
+
+int msGetShapeRAMSize(shapeObj *shape) {
+  int i;
+  int size = 0;
+  size += sizeof(shapeObj);
+  size += shape->numlines * sizeof(lineObj);
+  for (i = 0; i < shape->numlines; i++) {
+    size += shape->line[i].numpoints * sizeof(pointObj);
+  }
+  size += shape->numvalues * sizeof(char *);
+  for (i = 0; i < shape->numvalues; i++) {
+    if (shape->values[i])
+      size += strlen(shape->values[i]) + 1;
+  }
+  if (shape->text)
+    size += strlen(shape->text) + 1;
+  return size;
+}
+
+void msFreeLabelPathObj(labelPathObj *path) {
+  msFreeShape(&(path->bounds));
+  msFree(path->path.point);
+  msFree(path->angles);
+  msFree(path);
+}
+
+void msShapeDeleteLine(shapeObj *shape, int line) {
+  if (line < 0 || line >= shape->numlines) {
+    assert(0);
+    return;
+  }
+
+  free(shape->line[line].point);
+  if (line < shape->numlines - 1) {
+    memmove(shape->line + line, shape->line + line + 1,
+            sizeof(lineObj) * (shape->numlines - line - 1));
+  }
+  shape->numlines--;
+}
+
+void msComputeBounds(shapeObj *shape) {
+  int i, j;
+  if (shape->numlines <= 0)
+    return;
+  for (i = 0; i < shape->numlines; i++) {
+    if (shape->line[i].numpoints > 0) {
+      shape->bounds.minx = shape->bounds.maxx = shape->line[i].point[0].x;
+      shape->bounds.miny = shape->bounds.maxy = shape->line[i].point[0].y;
+      break;
+    }
+  }
+  if (i == shape->numlines)
+    return;
+
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0; j < shape->line[i].numpoints; j++) {
+      shape->bounds.minx =
+          MS_MIN(shape->bounds.minx, shape->line[i].point[j].x);
+      shape->bounds.maxx =
+          MS_MAX(shape->bounds.maxx, shape->line[i].point[j].x);
+      shape->bounds.miny =
+          MS_MIN(shape->bounds.miny, shape->line[i].point[j].y);
+      shape->bounds.maxy =
+          MS_MAX(shape->bounds.maxy, shape->line[i].point[j].y);
+    }
+  }
+}
+
+/* checks to see if ring r is an outer ring of shape */
+int msIsOuterRing(shapeObj *shape, int r) {
+  int i, status = MS_TRUE;
+  int result1, result2;
+
+  if (!shape)
+    return MS_FALSE;
+  if (shape->numlines == 1)
+    return MS_TRUE;
+  if (r < 0 || r >= shape->numlines)
+    return MS_FALSE; /* bad ring index */
+
+  for (i = 0; i < shape->numlines; i++) {
+    if (i == r)
+      continue;
+
+    /*
+    ** We have to test 2, or perhaps 3 points on the shape against the ring
+    *because
+    ** it is possible that at most one point could touch the ring and the
+    *function
+    ** msPointInPolygon() is indeterminite in that case. (bug #2434)
+    */
+    result1 = msPointInPolygon(&(shape->line[r].point[0]), &(shape->line[i]));
+    result2 = msPointInPolygon(&(shape->line[r].point[1]), &(shape->line[i]));
+    if (result1 ==
+        result2) { /* same result twice, neither point was on the edge */
+      if (result1 == MS_TRUE)
+        status = !status;
+    } else { /* one of the first 2 points were on the edge of the ring, the next
+                one isn't */
+      if (msPointInPolygon(&(shape->line[r].point[2]), &(shape->line[i])) ==
+          MS_TRUE)
+        status = !status;
+    }
+  }
+
+  return (status);
+}
+
+/*
+** Returns a list of outer rings for shape (the list has one entry for each
+*ring,
+** MS_TRUE for outer rings).
+*/
+int *msGetOuterList(shapeObj *shape) {
+  int i;
+  int *list;
+
+  if (!shape)
+    return NULL;
+
+  list = (int *)malloc(sizeof(int) * shape->numlines);
+  MS_CHECK_ALLOC(list, sizeof(int) * shape->numlines, NULL);
+
+  for (i = 0; i < shape->numlines; i++)
+    list[i] = msIsOuterRing(shape, i);
+
+  return list;
+}
+
+/*
+** Returns a list of inner rings for ring r in shape (given a list of outer
+*rings).
+*/
+int *msGetInnerList(shapeObj *shape, int r, int *outerlist) {
+  int i;
+  int *list;
+
+  if (!shape || !outerlist)
+    return NULL;
+  if (r < 0 || r >= shape->numlines)
+    return NULL; /* bad ring index */
+
+  list = (int *)malloc(sizeof(int) * shape->numlines);
+  MS_CHECK_ALLOC(list, sizeof(int) * shape->numlines, NULL);
+
+  for (i = 0; i < shape->numlines; i++) { /* test all rings against the ring */
+
+    if (outerlist[i] == MS_TRUE) { /* ring is an outer and can't be an inner */
+      list[i] = MS_FALSE;
+      continue;
+    }
+
+    /* A valid inner ring may touch its outer ring at most one point. */
+    /* In the case the first point matches a vertex of an outer ring, */
+    /* msPointInPolygon() might return 0 or 1 (depending on coordinate values,
+     */
+    /* see msGetOuterList()), so test a second point if the first test */
+    /* returned that the point is not inside the outer ring. */
+    /* Fixes #5299 */
+    /* Of course all of this assumes that the geometries are indeed valid in */
+    /* OGC terms, otherwise all logic of msIsOuterRing(), msGetOuterList(), */
+    /* and msGetInnerList() has undefined behaviour. */
+    list[i] = msPointInPolygon(&(shape->line[i].point[0]), &(shape->line[r])) ||
+              msPointInPolygon(&(shape->line[i].point[1]), &(shape->line[r]));
+  }
+
+  return (list);
+}
+
+/*
+** Add point to a line object.
+**
+** Note that reallocating the point array larger for each point can
+** be pretty inefficient, so use this function sparingly.  Mostly
+** geometries creators should create their own working lineObj and
+** then call msAddLine() to add it to a shape.
+*/
+
+int msAddPointToLine(lineObj *line, pointObj *point) {
+  line->numpoints += 1;
+
+  line->point = (pointObj *)msSmallRealloc(line->point,
+                                           sizeof(pointObj) * line->numpoints);
+  line->point[line->numpoints - 1] = *point;
+
+  return MS_SUCCESS;
+}
+
+int msAddLine(shapeObj *p, const lineObj *new_line) {
+  lineObj lineCopy;
+
+  lineCopy.numpoints = new_line->numpoints;
+  lineCopy.point = (pointObj *)malloc(new_line->numpoints * sizeof(pointObj));
+  MS_CHECK_ALLOC(lineCopy.point, new_line->numpoints * sizeof(pointObj),
+                 MS_FAILURE);
+
+  if (new_line->point)
+    memcpy(lineCopy.point, new_line->point,
+           sizeof(pointObj) * new_line->numpoints);
+
+  // cppcheck-suppress memleak
+  return msAddLineDirectly(p, &lineCopy);
+}
+
+/*
+** Same as msAddLine(), except that this version "seizes" the points
+** array from the passed in line and uses it instead of copying it.
+*/
+int msAddLineDirectly(shapeObj *p, lineObj *new_line) {
+  int c;
+
+  if (p->numlines == 0) {
+    p->line = (lineObj *)malloc(sizeof(lineObj));
+  } else {
+    lineObj *newline =
+        (lineObj *)realloc(p->line, (p->numlines + 1) * sizeof(lineObj));
+    if (!newline) {
+      free(p->line);
+    }
+    p->line = newline;
+  }
+  if (!p->line) {
+    free(new_line->point);
+    new_line->point = NULL;
+    new_line->numpoints = 0;
+  }
+  MS_CHECK_ALLOC(p->line, (p->numlines + 1) * sizeof(lineObj), MS_FAILURE);
+
+  /* Copy the new line onto the end of the extended line array */
+  c = p->numlines;
+  p->line[c].numpoints = new_line->numpoints;
+  p->line[c].point = new_line->point;
+
+  /* strip points reference off the passed in lineObj */
+  new_line->point = NULL;
+  new_line->numpoints = 0;
+
+  /* Update the polygon information */
+  p->numlines++;
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Converts a rect array to a shapeObj structure. Note order is CW assuming y
+*origin
+** is in the lower left corner (normal cartesian coordinate system). Also
+*polygon is
+** is closed (i.e. first=last). This conforms to the shapefile specification.
+*For image
+** coordinate systems (i.e. GD) this is back-ass-ward, which is fine cause the
+*function
+** that calculates direction assumes min y = lower left, this way it'll still
+*work. Drawing
+** functions are independent of direction. Orientation problems can cause some
+*nasty bugs.
+*/
+void msRectToPolygon(rectObj rect, shapeObj *poly) {
+  lineObj line = {0, NULL};
+
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 5);
+
+  line.point[0].x = rect.minx;
+  line.point[0].y = rect.miny;
+  line.point[1].x = rect.minx;
+  line.point[1].y = rect.maxy;
+  line.point[2].x = rect.maxx;
+  line.point[2].y = rect.maxy;
+  line.point[3].x = rect.maxx;
+  line.point[3].y = rect.miny;
+  line.point[4].x = line.point[0].x;
+  line.point[4].y = line.point[0].y;
+
+  line.numpoints = 5;
+
+  msAddLine(poly, &line);
+  if (poly->numlines == 1) { /* poly was empty to begin with */
+    poly->type = MS_SHAPE_POLYGON;
+    poly->bounds = rect;
+  } else
+    msMergeRect(&poly->bounds, &rect);
+  free(line.point);
+}
+
+/*
+** Private implementation of the Sutherland-Cohen algorithm. Inspired by
+** "Getting Graphic: Programming Fundamentals in C and C++" by Mark Finlay
+** and John Petritis. (pages 179-182)
+*/
+static int clipLine(double *x1, double *y1, double *x2, double *y2,
+                    rectObj rect) {
+  double x, y;
+  double slope;
+  CLIP_STATE check1, check2;
+
+  if (*x1 < rect.minx && *x2 < rect.minx)
+    return (MS_FALSE);
+  if (*x1 > rect.maxx && *x2 > rect.maxx)
+    return (MS_FALSE);
+
+  check1 = CLIP_CHECK(rect.minx, *x1, rect.maxx);
+  check2 = CLIP_CHECK(rect.minx, *x2, rect.maxx);
+  if (check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
+    slope = (*y2 - *y1) / (*x2 - *x1);
+    y = *y1 + (rect.minx - *x1) * slope;
+    if (check1 == CLIP_LEFT) {
+      *x1 = rect.minx;
+      *y1 = y;
+    } else {
+      *x2 = rect.minx;
+      *y2 = y;
+    }
+  }
+  if (check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
+    slope = (*y2 - *y1) / (*x2 - *x1);
+    y = *y1 + (rect.maxx - *x1) * slope;
+    if (check1 == CLIP_RIGHT) {
+      *x1 = rect.maxx;
+      *y1 = y;
+    } else {
+      *x2 = rect.maxx;
+      *y2 = y;
+    }
+  }
+
+  if (*y1 < rect.miny && *y2 < rect.miny)
+    return (MS_FALSE);
+  if (*y1 > rect.maxy && *y2 > rect.maxy)
+    return (MS_FALSE);
+
+  check1 = CLIP_CHECK(rect.miny, *y1, rect.maxy);
+  check2 = CLIP_CHECK(rect.miny, *y2, rect.maxy);
+  if (check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
+    slope = (*x2 - *x1) / (*y2 - *y1);
+    x = *x1 + (rect.miny - *y1) * slope;
+    if (check1 == CLIP_LEFT) {
+      *x1 = x;
+      *y1 = rect.miny;
+    } else {
+      *x2 = x;
+      *y2 = rect.miny;
+    }
+  }
+  if (check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
+    slope = (*x2 - *x1) / (*y2 - *y1);
+    x = *x1 + (rect.maxy - *y1) * slope;
+    if (check1 == CLIP_RIGHT) {
+      *x1 = x;
+      *y1 = rect.maxy;
+    } else {
+      *x2 = x;
+      *y2 = rect.maxy;
+    }
+  }
+
+  return (MS_TRUE);
+}
+
+/*
+** Routine for clipping a polyline, stored in a shapeObj struct, to a
+** rectangle. Uses clipLine() function to create a new shapeObj.
+*/
+void msClipPolylineRect(shapeObj *shape, rectObj rect) {
+  int i, j;
+  lineObj line = {0, NULL};
+  double x1, x2, y1, y2;
+  shapeObj tmp;
+
+  if (!shape || shape->numlines == 0) /* nothing to clip */
+    return;
+
+  memset(&tmp, 0, sizeof(shapeObj));
+
+  /*
+  ** Don't do any clip processing of shapes completely within the
+  ** clip rectangle based on a comparison of bounds.   We could do
+  ** something similar for completely outside, but that rarely occurs
+  ** since the spatial query at the layer read level has generally already
+  ** discarded all shapes completely outside the rect.
+  */
+  if (shape->bounds.maxx <= rect.maxx && shape->bounds.minx >= rect.minx &&
+      shape->bounds.maxy <= rect.maxy && shape->bounds.miny >= rect.miny) {
+    return;
+  }
+
+  for (i = 0; i < shape->numlines; i++) {
+
+    line.point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * shape->line[i].numpoints);
+    line.numpoints = 0;
+
+    x1 = shape->line[i].point[0].x;
+    y1 = shape->line[i].point[0].y;
+    for (j = 1; j < shape->line[i].numpoints; j++) {
+      x2 = shape->line[i].point[j].x;
+      y2 = shape->line[i].point[j].y;
+
+      if (clipLine(&x1, &y1, &x2, &y2, rect) == MS_TRUE) {
+        if (line.numpoints == 0) { /* first segment, add both points */
+          line.point[0].x = x1;
+          line.point[0].y = y1;
+          line.point[1].x = x2;
+          line.point[1].y = y2;
+          line.numpoints = 2;
+        } else { /* add just the last point */
+          line.point[line.numpoints].x = x2;
+          line.point[line.numpoints].y = y2;
+          line.numpoints++;
+        }
+
+        if ((x2 != shape->line[i].point[j].x) ||
+            (y2 != shape->line[i].point[j].y)) {
+          msAddLine(&tmp, &line);
+          line.numpoints = 0; /* new line */
+        }
+      }
+
+      x1 = shape->line[i].point[j].x;
+      y1 = shape->line[i].point[j].y;
+    }
+
+    if (line.numpoints > 0) {
+      msAddLineDirectly(&tmp, &line);
+    } else {
+      free(line.point);
+      line.numpoints = 0; /* new line */
+    }
+  }
+
+  for (i = 0; i < shape->numlines; i++)
+    free(shape->line[i].point);
+  free(shape->line);
+
+  shape->line = tmp.line;
+  shape->numlines = tmp.numlines;
+  msComputeBounds(shape);
+}
+
+/*
+** Slightly modified version of the Liang-Barsky polygon clipping algorithm
+*/
+void msClipPolygonRect(shapeObj *shape, rectObj rect) {
+  int i, j;
+  double deltax, deltay, xin, xout, yin, yout;
+  double tinx, tiny, toutx, touty, tin1, tin2, tout;
+  double x1, y1, x2, y2;
+
+  shapeObj tmp;
+  lineObj line = {0, NULL};
+
+  if (!shape || shape->numlines == 0) /* nothing to clip */
+    return;
+
+  msInitShape(&tmp);
+
+  /*
+  ** Don't do any clip processing of shapes completely within the
+  ** clip rectangle based on a comparison of bounds.   We could do
+  ** something similar for completely outside, but that rarely occurs
+  ** since the spatial query at the layer read level has generally already
+  ** discarded all shapes completely outside the rect.
+  */
+  if (shape->bounds.maxx <= rect.maxx && shape->bounds.minx >= rect.minx &&
+      shape->bounds.maxy <= rect.maxy && shape->bounds.miny >= rect.miny) {
+    return;
+  }
+
+  for (j = 0; j < shape->numlines; j++) {
+
+    line.point = (pointObj *)msSmallMalloc(
+        sizeof(pointObj) * 2 * shape->line[j].numpoints +
+        1); /* worst case scenario, +1 allows us to duplicate the 1st and last
+               point */
+    line.numpoints = 0;
+
+    for (i = 0; i < shape->line[j].numpoints - 1; i++) {
+
+      x1 = shape->line[j].point[i].x;
+      y1 = shape->line[j].point[i].y;
+      x2 = shape->line[j].point[i + 1].x;
+      y2 = shape->line[j].point[i + 1].y;
+
+      deltax = x2 - x1;
+      if (deltax == 0) { /* bump off of the vertical */
+        deltax = (x1 > rect.minx) ? -NEARZERO : NEARZERO;
+      }
+      deltay = y2 - y1;
+      if (deltay == 0) { /* bump off of the horizontal */
+        deltay = (y1 > rect.miny) ? -NEARZERO : NEARZERO;
+      }
+
+      if (deltax > 0) { /*  points to right */
+        xin = rect.minx;
+        xout = rect.maxx;
+      } else {
+        xin = rect.maxx;
+        xout = rect.minx;
+      }
+      if (deltay > 0) { /*  points up */
+        yin = rect.miny;
+        yout = rect.maxy;
+      } else {
+        yin = rect.maxy;
+        yout = rect.miny;
+      }
+
+      tinx = (xin - x1) / deltax;
+      tiny = (yin - y1) / deltay;
+
+      if (tinx < tiny) { /* hits x first */
+        tin1 = tinx;
+        tin2 = tiny;
+      } else { /* hits y first */
+        tin1 = tiny;
+        tin2 = tinx;
+      }
+
+      if (1 >= tin1) {
+        if (0 < tin1) {
+          line.point[line.numpoints].x = xin;
+          line.point[line.numpoints].y = yin;
+          line.numpoints++;
+        }
+        if (1 >= tin2) {
+          toutx = (xout - x1) / deltax;
+          touty = (yout - y1) / deltay;
+
+          tout = (toutx < touty) ? toutx : touty;
+
+          if (0 < tin2 || 0 < tout) {
+            if (tin2 <= tout) {
+              if (0 < tin2) {
+                if (tinx > tiny) {
+                  line.point[line.numpoints].x = xin;
+                  line.point[line.numpoints].y = y1 + tinx * deltay;
+                  line.numpoints++;
+                } else {
+                  line.point[line.numpoints].x = x1 + tiny * deltax;
+                  line.point[line.numpoints].y = yin;
+                  line.numpoints++;
+                }
+              }
+              if (1 > tout) {
+                if (toutx < touty) {
+                  line.point[line.numpoints].x = xout;
+                  line.point[line.numpoints].y = y1 + toutx * deltay;
+                  line.numpoints++;
+                } else {
+                  line.point[line.numpoints].x = x1 + touty * deltax;
+                  line.point[line.numpoints].y = yout;
+                  line.numpoints++;
+                }
+              } else {
+                line.point[line.numpoints].x = x2;
+                line.point[line.numpoints].y = y2;
+                line.numpoints++;
+              }
+            } else {
+              if (tinx > tiny) {
+                line.point[line.numpoints].x = xin;
+                line.point[line.numpoints].y = yout;
+                line.numpoints++;
+              } else {
+                line.point[line.numpoints].x = xout;
+                line.point[line.numpoints].y = yin;
+                line.numpoints++;
+              }
+            }
+          }
+        }
+      }
+    }
+
+    if (line.numpoints > 0) {
+      line.point[line.numpoints].x = line.point[0].x; /* force closure */
+      line.point[line.numpoints].y = line.point[0].y;
+      line.numpoints++;
+      msAddLineDirectly(&tmp, &line);
+    } else {
+      free(line.point);
+    }
+  } /* next line */
+
+  for (i = 0; i < shape->numlines; i++)
+    free(shape->line[i].point);
+  free(shape->line);
+
+  shape->line = tmp.line;
+  shape->numlines = tmp.numlines;
+  msComputeBounds(shape);
+
+  return;
+}
+
+/*
+** offsets a point relative to an image position
+*/
+void msOffsetPointRelativeTo(pointObj *point, layerObj *layer) {
+  double x = 0, y = 0;
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return;
+
+  if (layer->transform == MS_TRUE)
+    return; /* nothing to do */
+
+  if (layer->units == MS_PERCENTAGES) {
+    point->x *= (layer->map->width - 1);
+    point->y *= (layer->map->height - 1);
+  }
+
+  if (layer->transform == MS_FALSE || layer->transform == MS_UL)
+    return; /* done */
+
+  switch (layer->transform) {
+  case MS_UC:
+    x = (layer->map->width - 1) / 2;
+    y = 0;
+    break;
+  case MS_UR:
+    x = layer->map->width - 1;
+    y = 0;
+    break;
+  case MS_CL:
+    x = 0;
+    y = layer->map->height / 2;
+    break;
+  case MS_CC:
+    x = layer->map->width / 2;
+    y = layer->map->height / 2;
+    break;
+  case MS_CR:
+    x = layer->map->width - 1;
+    y = layer->map->height / 2;
+    break;
+  case MS_LL:
+    x = 0;
+    y = layer->map->height - 1;
+    break;
+  case MS_LC:
+    x = layer->map->width / 2;
+    y = layer->map->height - 1;
+    break;
+  case MS_LR:
+    x = layer->map->width - 1;
+    y = layer->map->height - 1;
+    break;
+  }
+
+  point->x += x;
+  point->y += y;
+
+  return;
+}
+
+/*
+** offsets a shape relative to an image position
+*/
+void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer) {
+  int i, j;
+  double x = 0, y = 0;
+
+  if (layer->transform == MS_TRUE)
+    return; /* nothing to do */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return;
+
+  if (layer->units == MS_PERCENTAGES) {
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x *= (layer->map->width - 1);
+        shape->line[i].point[j].y *= (layer->map->height - 1);
+      }
+    }
+  }
+
+  if (layer->transform == MS_FALSE || layer->transform == MS_UL)
+    return; /* done */
+
+  switch (layer->transform) {
+  case MS_UC:
+    x = (layer->map->width - 1) / 2;
+    y = 0;
+    break;
+  case MS_UR:
+    x = layer->map->width - 1;
+    y = 0;
+    break;
+  case MS_CL:
+    x = 0;
+    y = layer->map->height / 2;
+    break;
+  case MS_CC:
+    x = layer->map->width / 2;
+    y = layer->map->height / 2;
+    break;
+  case MS_CR:
+    x = layer->map->width - 1;
+    y = layer->map->height / 2;
+    break;
+  case MS_LL:
+    x = 0;
+    y = layer->map->height - 1;
+    break;
+  case MS_LC:
+    x = layer->map->width / 2;
+    y = layer->map->height - 1;
+    break;
+  case MS_LR:
+    x = layer->map->width - 1;
+    y = layer->map->height - 1;
+    break;
+  }
+
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0; j < shape->line[i].numpoints; j++) {
+      shape->line[i].point[j].x += x;
+      shape->line[i].point[j].y += y;
+    }
+  }
+
+  return;
+}
+
+void msTransformShapeSimplify(shapeObj *shape, rectObj extent,
+                              double cellsize) {
+  int i, j, k, beforelast; /* loop counters */
+  double dx, dy;
+  pointObj *point;
+  double inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
+  int ok = 0;
+  if (shape->numlines == 0)
+    return; /* nothing to transform */
+
+  if (shape->type == MS_SHAPE_LINE) {
+    /*
+     * loop through the shape's lines, and do naive simplification
+     * to discard the points that are too close to one another.
+     * currently the threshold is to discard points if they fall
+     * less than a pixel away from their predecessor.
+     * the simplified line is guaranteed to contain at
+     * least its first and last point
+     */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      if (shape->line[i].numpoints < 2) {
+        shape->line[i].numpoints = 0;
+        continue; /*skip degenerate lines*/
+      }
+      point = shape->line[i].point;
+      /*always keep first point*/
+      point[0].x = MS_MAP2IMAGE_X_IC_DBL(point[0].x, extent.minx, inv_cs);
+      point[0].y = MS_MAP2IMAGE_Y_IC_DBL(point[0].y, extent.maxy, inv_cs);
+      beforelast = shape->line[i].numpoints - 1;
+      for (j = 1, k = 1; j < beforelast;
+           j++) { /*loop from second point to first-before-last point*/
+        point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
+        point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
+        dx = (point[k].x - point[k - 1].x);
+        dy = (point[k].y - point[k - 1].y);
+        if (dx * dx + dy * dy > 1)
+          k++;
+      }
+      /* try to keep last point */
+      point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
+      point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
+      /* discard last point if equal to the one before it */
+      if (point[k].x != point[k - 1].x || point[k].y != point[k - 1].y) {
+        shape->line[i].numpoints = k + 1;
+      } else {
+        shape->line[i].numpoints = k;
+      }
+      /* skip degenerate line once more */
+      if (shape->line[i].numpoints < 2) {
+        shape->line[i].numpoints = 0;
+      } else {
+        ok = 1; /* we have at least one line with more than two points */
+      }
+    }
+  } else if (shape->type == MS_SHAPE_POLYGON) {
+    /*
+     * loop through the shape's lines, and do naive simplification
+     * to discard the points that are too close to one another.
+     * currently the threshold is to discard points if they fall
+     * less than a pixel away from their predecessor.
+     * the simplified polygon is guaranteed to contain at
+     * least its first, second and last point
+     */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      if (shape->line[i].numpoints < 4) {
+        shape->line[i].numpoints = 0;
+        continue; /*skip degenerate lines*/
+      }
+      point = shape->line[i].point;
+      /*always keep first and second point*/
+      point[0].x = MS_MAP2IMAGE_X_IC_DBL(point[0].x, extent.minx, inv_cs);
+      point[0].y = MS_MAP2IMAGE_Y_IC_DBL(point[0].y, extent.maxy, inv_cs);
+      point[1].x = MS_MAP2IMAGE_X_IC_DBL(point[1].x, extent.minx, inv_cs);
+      point[1].y = MS_MAP2IMAGE_Y_IC_DBL(point[1].y, extent.maxy, inv_cs);
+      beforelast = shape->line[i].numpoints - 2;
+      for (j = 2, k = 2; j < beforelast;
+           j++) { /*loop from second point to second-before-last point*/
+        point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
+        point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
+        dx = (point[k].x - point[k - 1].x);
+        dy = (point[k].y - point[k - 1].y);
+        if (dx * dx + dy * dy > 1)
+          k++;
+      }
+      /*always keep last two points (the last point is the repetition of the
+       * first one */
+      point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
+      point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
+      point[k + 1].x =
+          MS_MAP2IMAGE_X_IC_DBL(point[j + 1].x, extent.minx, inv_cs);
+      point[k + 1].y =
+          MS_MAP2IMAGE_Y_IC_DBL(point[j + 1].y, extent.maxy, inv_cs);
+      shape->line[i].numpoints = k + 2;
+      ok = 1;
+    }
+  } else { /* only for untyped shapes, as point layers don't go through this
+              function */
+    for (i = 0; i < shape->numlines; i++) {
+      point = shape->line[i].point;
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        point[j].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
+        point[j].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
+      }
+    }
+    ok = 1;
+  }
+  if (!ok) {
+    for (i = 0; i < shape->numlines; i++) {
+      free(shape->line[i].point);
+    }
+    shape->numlines = 0;
+  }
+}
+
+/**
+ * Generic function to transorm the shape coordinates to output coordinates
+ */
+void msTransformShape(shapeObj *shape, rectObj extent, double cellsize,
+                      imageObj *image) {
+  if (image != NULL && MS_RENDERER_PLUGIN(image->format)) {
+    rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
+    if (renderer->transform_mode == MS_TRANSFORM_SNAPTOGRID) {
+      msTransformShapeToPixelSnapToGrid(shape, extent, cellsize,
+                                        renderer->approximation_scale);
+    } else if (renderer->transform_mode == MS_TRANSFORM_SIMPLIFY) {
+      msTransformShapeSimplify(shape, extent, cellsize);
+    } else if (renderer->transform_mode == MS_TRANSFORM_ROUND) {
+      msTransformShapeToPixelRound(shape, extent, cellsize);
+    } else if (renderer->transform_mode == MS_TRANSFORM_FULLRESOLUTION) {
+      msTransformShapeToPixelDoublePrecision(shape, extent, cellsize);
+    } else if (renderer->transform_mode == MS_TRANSFORM_NONE) {
+      /* nothing to do */
+      return;
+    }
+    /* unknown, do nothing */
+    return;
+  }
+  msTransformShapeToPixelRound(shape, extent, cellsize);
+}
+
+void msTransformShapeToPixelSnapToGrid(shapeObj *shape, rectObj extent,
+                                       double cellsize,
+                                       double grid_resolution) {
+  int i, j, k; /* loop counters */
+  double inv_cs;
+  if (shape->numlines == 0)
+    return;
+  inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
+
+  if (shape->type == MS_SHAPE_LINE ||
+      shape->type == MS_SHAPE_POLYGON) {    /* remove duplicate vertices */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      int snap = 1;
+      const double x0 = MS_MAP2IMAGE_X_IC_SNAP(
+          shape->line[i].point[0].x, extent.minx, inv_cs, grid_resolution);
+      const double y0 = MS_MAP2IMAGE_Y_IC_SNAP(
+          shape->line[i].point[0].y, extent.maxy, inv_cs, grid_resolution);
+
+      /*do a quick heuristic: will we risk having a degenerate shape*/
+      if (shape->type == MS_SHAPE_LINE) {
+        /*a line is degenerate if it has a single pixel. we check that the first
+         * and last pixel are different*/
+        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints - 1].x, extent.minx,
+            inv_cs, grid_resolution);
+        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints - 1].y, extent.maxy,
+            inv_cs, grid_resolution);
+        if (x0 == x1 && y0 == y1) {
+          snap = 0;
+        }
+      } else /* if(shape->type == MS_SHAPE_POLYGON) */ {
+        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3].x, extent.minx,
+            inv_cs, grid_resolution);
+        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3].y, extent.maxy,
+            inv_cs, grid_resolution);
+        const double x2 = MS_MAP2IMAGE_X_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3 * 2].x,
+            extent.minx, inv_cs, grid_resolution);
+        const double y2 = MS_MAP2IMAGE_Y_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3 * 2].y,
+            extent.maxy, inv_cs, grid_resolution);
+        if ((x0 == x1 && y0 == y1) || (x0 == x2 && y0 == y2) ||
+            (x1 == x2 && y1 == y2)) {
+          snap = 0;
+        }
+      }
+
+      if (snap) {
+        shape->line[i].point[0].x = x0;
+        shape->line[i].point[0].y = y0;
+        for (j = 1, k = 1; j < shape->line[i].numpoints; j++) {
+          shape->line[i].point[k].x = MS_MAP2IMAGE_X_IC_SNAP(
+              shape->line[i].point[j].x, extent.minx, inv_cs, grid_resolution);
+          shape->line[i].point[k].y = MS_MAP2IMAGE_Y_IC_SNAP(
+              shape->line[i].point[j].y, extent.maxy, inv_cs, grid_resolution);
+          if (shape->line[i].point[k].x != shape->line[i].point[k - 1].x ||
+              shape->line[i].point[k].y != shape->line[i].point[k - 1].y)
+            k++;
+        }
+        shape->line[i].numpoints = k;
+      } else {
+        if (shape->type == MS_SHAPE_LINE) {
+          shape->line[i].point[0].x = MS_MAP2IMAGE_X_IC_DBL(
+              shape->line[i].point[0].x, extent.minx, inv_cs);
+          shape->line[i].point[0].y = MS_MAP2IMAGE_Y_IC_DBL(
+              shape->line[i].point[0].y, extent.maxy, inv_cs);
+          shape->line[i].point[1].x = MS_MAP2IMAGE_X_IC_DBL(
+              shape->line[i].point[shape->line[i].numpoints - 1].x, extent.minx,
+              inv_cs);
+          shape->line[i].point[1].y = MS_MAP2IMAGE_Y_IC_DBL(
+              shape->line[i].point[shape->line[i].numpoints - 1].y, extent.maxy,
+              inv_cs);
+          shape->line[i].numpoints = 2;
+        } else {
+          for (j = 0; j < shape->line[i].numpoints; j++) {
+            shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(
+                shape->line[i].point[j].x, extent.minx, inv_cs);
+            shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(
+                shape->line[i].point[j].y, extent.maxy, inv_cs);
+          }
+        }
+      }
+    }
+  } else {                                  /* points or untyped shapes */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 1; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(
+            shape->line[i].point[j].x, extent.minx, inv_cs);
+        shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(
+            shape->line[i].point[j].y, extent.maxy, inv_cs);
+      }
+    }
+  }
+}
+
+void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent,
+                                  double cellsize) {
+  int i, j, k; /* loop counters */
+  double inv_cs;
+  if (shape->numlines == 0)
+    return;
+  inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
+  if (shape->type == MS_SHAPE_LINE ||
+      shape->type == MS_SHAPE_POLYGON) {    /* remove duplicate vertices */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      shape->line[i].point[0].x =
+          MS_MAP2IMAGE_X_IC(shape->line[i].point[0].x, extent.minx, inv_cs);
+      ;
+      shape->line[i].point[0].y =
+          MS_MAP2IMAGE_Y_IC(shape->line[i].point[0].y, extent.maxy, inv_cs);
+      for (j = 1, k = 1; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[k].x =
+            MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
+        shape->line[i].point[k].y =
+            MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
+        if (shape->line[i].point[k].x != shape->line[i].point[k - 1].x ||
+            shape->line[i].point[k].y != shape->line[i].point[k - 1].y)
+          k++;
+      }
+      shape->line[i].numpoints = k;
+    }
+  } else {                                  /* points or untyped shapes */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x =
+            MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
+        shape->line[i].point[j].y =
+            MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
+      }
+    }
+  }
+}
+
+void msTransformShapeToPixelDoublePrecision(shapeObj *shape, rectObj extent,
+                                            double cellsize) {
+  int i, j;                       /* loop counters */
+  double inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0; j < shape->line[i].numpoints; j++) {
+      shape->line[i].point[j].x =
+          MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
+      shape->line[i].point[j].y =
+          MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
+    }
+  }
+}
+
+/*
+** Converts from map coordinates to image coordinates
+*/
+void msTransformPixelToShape(shapeObj *shape, rectObj extent, double cellsize) {
+  int i, j; /* loop counters */
+
+  if (shape->numlines == 0)
+    return; /* nothing to transform */
+
+  if (shape->type == MS_SHAPE_LINE ||
+      shape->type == MS_SHAPE_POLYGON) { /* remove co-linear vertices */
+
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x =
+            MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
+        shape->line[i].point[j].y =
+            MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
+      }
+    }
+  } else { /* points or untyped shapes */
+
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 1; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x =
+            MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
+        shape->line[i].point[j].y =
+            MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
+      }
+    }
+  }
+
+  return;
+}
+
+/*
+** Not a generic intersection test, we KNOW the lines aren't parallel or
+*coincident. To be used with the next
+** buffering code only. See code in mapsearch.c for a boolean test for
+*intersection.
+*/
+static pointObj generateLineIntersection(pointObj a, pointObj b, pointObj c,
+                                         pointObj d) {
+  pointObj p = {0}; // initialize
+  double r;
+  double denominator, numerator;
+
+  if (b.x == c.x && b.y == c.y)
+    return (b);
+
+  numerator = ((a.y - c.y) * (d.x - c.x) - (a.x - c.x) * (d.y - c.y));
+  denominator = ((b.x - a.x) * (d.y - c.y) - (b.y - a.y) * (d.x - c.x));
+
+  r = numerator / denominator;
+
+  p.x = MS_NINT(a.x + r * (b.x - a.x));
+  p.y = MS_NINT(a.y + r * (b.y - a.y));
+
+  return (p);
+}
+
+void bufferPolyline(shapeObj *p, shapeObj *op, int w) {
+  int i, j;
+  pointObj a = {0};
+  lineObj inside, outside;
+  double angle;
+  double dx, dy;
+
+  for (i = 0; i < p->numlines; i++) {
+
+    inside.point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * p->line[i].numpoints);
+    outside.point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * p->line[i].numpoints);
+    inside.numpoints = outside.numpoints = p->line[i].numpoints;
+
+    angle = asin(MS_ABS(p->line[i].point[1].x - p->line[i].point[0].x) /
+                 sqrt((((p->line[i].point[1].x - p->line[i].point[0].x) *
+                        (p->line[i].point[1].x - p->line[i].point[0].x)) +
+                       ((p->line[i].point[1].y - p->line[i].point[0].y) *
+                        (p->line[i].point[1].y - p->line[i].point[0].y)))));
+    if (p->line[i].point[0].x < p->line[i].point[1].x)
+      dy = sin(angle) * (w / 2);
+    else
+      dy = -sin(angle) * (w / 2);
+    if (p->line[i].point[0].y < p->line[i].point[1].y)
+      dx = -cos(angle) * (w / 2);
+    else
+      dx = cos(angle) * (w / 2);
+
+    inside.point[0].x = p->line[i].point[0].x + dx;
+    inside.point[1].x = p->line[i].point[1].x + dx;
+    inside.point[0].y = p->line[i].point[0].y + dy;
+    inside.point[1].y = p->line[i].point[1].y + dy;
+
+    outside.point[0].x = p->line[i].point[0].x - dx;
+    outside.point[1].x = p->line[i].point[1].x - dx;
+    outside.point[0].y = p->line[i].point[0].y - dy;
+    outside.point[1].y = p->line[i].point[1].y - dy;
+
+    for (j = 2; j < p->line[i].numpoints; j++) {
+
+      angle =
+          asin(MS_ABS(p->line[i].point[j].x - p->line[i].point[j - 1].x) /
+               sqrt((((p->line[i].point[j].x - p->line[i].point[j - 1].x) *
+                      (p->line[i].point[j].x - p->line[i].point[j - 1].x)) +
+                     ((p->line[i].point[j].y - p->line[i].point[j - 1].y) *
+                      (p->line[i].point[j].y - p->line[i].point[j - 1].y)))));
+      if (p->line[i].point[j - 1].x < p->line[i].point[j].x)
+        dy = sin(angle) * (w / 2);
+      else
+        dy = -sin(angle) * (w / 2);
+      if (p->line[i].point[j - 1].y < p->line[i].point[j].y)
+        dx = -cos(angle) * (w / 2);
+      else
+        dx = cos(angle) * (w / 2);
+
+      a.x = p->line[i].point[j - 1].x + dx;
+      inside.point[j].x = p->line[i].point[j].x + dx;
+      a.y = p->line[i].point[j - 1].y + dy;
+      inside.point[j].y = p->line[i].point[j].y + dy;
+      inside.point[j - 1] = generateLineIntersection(
+          inside.point[j - 2], inside.point[j - 1], a, inside.point[j]);
+
+      a.x = p->line[i].point[j - 1].x - dx;
+      outside.point[j].x = p->line[i].point[j].x - dx;
+      a.y = p->line[i].point[j - 1].y - dy;
+      outside.point[j].y = p->line[i].point[j].y - dy;
+      outside.point[j - 1] = generateLineIntersection(
+          outside.point[j - 2], outside.point[j - 1], a, outside.point[j]);
+    }
+
+    /* need a touch of code if 1st point equals last point in p (find
+     * intersection) */
+
+    msAddLine(op, &inside);
+    msAddLine(op, &outside);
+
+    free(inside.point);
+    free(outside.point);
+  }
+
+  return;
+}
+
+static double getRingArea(lineObj *ring) {
+  int i;
+  double s = 0;
+
+  for (i = 0; i < ring->numpoints - 1; i++)
+    s += (ring->point[i].x * ring->point[i + 1].y -
+          ring->point[i + 1].x * ring->point[i].y);
+
+  return (MS_ABS(s / 2));
+}
+
+double msGetPolygonArea(shapeObj *p) {
+  int i;
+  double area = 0;
+
+  if (!p)
+    return 0;
+
+  for (i = 0; i < p->numlines; i++) {
+    if (msIsOuterRing(p, i))
+      area += getRingArea(&(p->line[i]));
+    else
+      area -= getRingArea(&(p->line[i])); /* hole */
+  }
+
+  return area;
+}
+
+/*
+** Computes the center of gravity for a polygon based on it's largest outer ring
+*only.
+*/
+static int getPolygonCenterOfGravity(shapeObj *p, pointObj *lp) {
+  double sx = 0, sy = 0; /* sums */
+  double largestArea = 0;
+
+  for (int i = 0; i < p->numlines; i++) {
+    double tsx = 0;
+    double tsy = 0;
+    double s = 0; /* reset the ring sums */
+    for (int j = 0; j < p->line[i].numpoints - 1; j++) {
+      double a = p->line[i].point[j].x * p->line[i].point[j + 1].y -
+                 p->line[i].point[j + 1].x * p->line[i].point[j].y;
+      s += a;
+      tsx += (p->line[i].point[j].x + p->line[i].point[j + 1].x) * a;
+      tsy += (p->line[i].point[j].y + p->line[i].point[j + 1].y) * a;
+    }
+    double area = MS_ABS(s / 2);
+
+    if (area > largestArea) {
+      largestArea = area;
+      sx = s > 0 ? tsx : -tsx;
+      sy = s > 0 ? tsy : -tsy;
+    }
+  }
+  if (largestArea == 0) /*degenerate polygon*/
+    return MS_FAILURE;
+
+  lp->x = sx / (6 * largestArea);
+  lp->y = sy / (6 * largestArea);
+
+  return MS_SUCCESS;
+}
+
+int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny,
+                         double *maxy) {
+  int i, j;
+  double cent_weight_x = 0.0, cent_weight_y = 0.0;
+  double len, total_len = 0;
+
+  *miny = *maxy = p->line[0].point[0].y;
+  for (i = 0; i < p->numlines; i++) {
+    for (j = 1; j < p->line[i].numpoints; j++) {
+      *miny = MS_MIN(*miny, p->line[i].point[j].y);
+      *maxy = MS_MAX(*maxy, p->line[i].point[j].y);
+      len = msDistancePointToPoint(&(p->line[i].point[j - 1]),
+                                   &(p->line[i].point[j]));
+      cent_weight_x +=
+          len * ((p->line[i].point[j - 1].x + p->line[i].point[j].x) / 2);
+      cent_weight_y +=
+          len * ((p->line[i].point[j - 1].y + p->line[i].point[j].y) / 2);
+      total_len += len;
+    }
+  }
+
+  if (total_len == 0)
+    return (MS_FAILURE);
+
+  lp->x = cent_weight_x / total_len;
+  lp->y = cent_weight_y / total_len;
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Find a label point in a polygon.
+*/
+int msPolygonLabelPoint(shapeObj *p, pointObj *lp, double min_dimension) {
+  double slope;
+  pointObj *point1 = NULL, *point2 = NULL, cp;
+  int i, j, nfound;
+  double x, y, *intersect, temp;
+  double min, max;
+  int wrong_order, n;
+  double len, max_len = 0;
+  double minx, maxx, maxy, miny;
+
+#ifdef notdef
+  int method = 2;
+#endif
+
+  msComputeBounds(p);
+  minx = p->bounds.minx;
+  miny = p->bounds.miny;
+  maxx = p->bounds.maxx;
+  maxy = p->bounds.maxy;
+
+  if (min_dimension > 0)
+    if (MS_MIN(maxx - minx, maxy - miny) < min_dimension)
+      return (MS_FAILURE);
+
+  cp.x = (maxx + minx) / 2.0;
+  cp.y = (maxy + miny) / 2.0;
+
+#ifdef notdef
+  switch (method) {
+  case 0: /* MBR */
+    lp->x = cp.x;
+    lp->y = cp.y;
+    break;
+  case 1: /* centroid */
+    if (msGetPolygonCentroid(p, lp, &miny, &maxy) != MS_SUCCESS)
+      return (MS_FAILURE);
+    break;
+  case 2: /* center of gravity */
+    if (getPolygonCenterOfGravity(p, lp) != MS_SUCCESS)
+      return (MS_FAILURE);
+    break;
+  }
+#else
+  if (getPolygonCenterOfGravity(p, lp) != MS_SUCCESS)
+    return (MS_FAILURE);
+#endif
+
+  if (msIntersectPointPolygon(lp, p) == MS_TRUE) {
+    double dist, min_dist = -1;
+
+    /* compute a distance to the polygon */
+    for (j = 0; j < p->numlines; j++) {
+      for (i = 1; i < p->line[j].numpoints; i++) {
+        dist = msSquareDistancePointToSegment(lp, &(p->line[j].point[i - 1]),
+                                              &(p->line[j].point[i]));
+        if ((dist < min_dist) || (min_dist < 0))
+          min_dist = dist;
+      }
+    }
+    min_dist = sqrt(min_dist);
+
+    if (min_dist > .1 * MS_MAX(maxx - minx, maxy - miny))
+      return (MS_SUCCESS); /* point is not too close to the edge */
+  }
+
+  /* printf("label: %s\n", p->text);
+     printf("    bbox: %g %g %g %g\n",minx, miny, maxx, maxy);
+     printf("    center: %g %g\n", cp.x, cp.y);
+     printf("    center of gravity: %g %g\n", lp->x, lp->y);
+     printf("    dx: %g, dy: %g\n", lp->x-cp.x, lp->y-cp.y);
+     printf("    distance to parent shape: %g\n", min_dist);
+     return MS_SUCCESS; */
+
+  n = 0;
+  for (j = 0; j < p->numlines; j++) /* count total number of points */
+    n += p->line[j].numpoints;
+  intersect = (double *)calloc(n, sizeof(double));
+  MS_CHECK_ALLOC(intersect, n * sizeof(double), MS_FAILURE);
+
+  if (MS_ABS((int)lp->x - (int)cp.x) >
+      MS_ABS((int)lp->y - (int)cp.y)) { /* center horizontally, fix y */
+
+    y = lp->y;
+
+    /* need to find a y that won't intersect any vertices exactly */
+    max = y - 1; /* first initializing min, max to be any 2 pnts on either side
+                    of y */
+    min = y + 1;
+    for (j = 0; j < p->numlines; j++) {
+      if ((min < y) && (max >= y))
+        break;
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((min < y) && (max >= y))
+          break;
+        if (p->line[j].point[i].y < y)
+          min = p->line[j].point[i].y;
+        if (p->line[j].point[i].y >= y)
+          max = p->line[j].point[i].y;
+      }
+    }
+
+    n = 0;
+    for (j = 0; j < p->numlines; j++) {
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((p->line[j].point[i].y < y) &&
+            ((y - p->line[j].point[i].y) < (y - min)))
+          min = p->line[j].point[i].y;
+        if ((p->line[j].point[i].y >= y) &&
+            ((p->line[j].point[i].y - y) < (max - y)))
+          max = p->line[j].point[i].y;
+      }
+    }
+
+    if (min == max) {
+      msFree(intersect);
+      return (MS_FAILURE);
+    } else
+      y = (max + min) / 2.0;
+
+    nfound = 0;
+    for (j = 0; j < p->numlines; j++) { /* for each line */
+
+      point1 = &(p->line[j].point[p->line[j].numpoints - 1]);
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        point2 = &(p->line[j].point[i]);
+
+        if (EDGE_CHECK(point1->y, y, point2->y) == CLIP_MIDDLE) {
+
+          if (point1->y == point2->y)
+            continue; /* ignore horizontal edges */
+          else
+            slope = (point2->x - point1->x) / (point2->y - point1->y);
+
+          x = point1->x + (y - point1->y) * slope;
+          intersect[nfound++] = x;
+        } /* end checking this edge */
+
+        point1 = point2; /* next edge */
+      }
+    } /* finished line */
+
+    /* sort the intersections */
+    do {
+      wrong_order = 0;
+      for (i = 0; i < nfound - 1; i++) {
+        if (intersect[i] > intersect[i + 1]) {
+          wrong_order = 1;
+          SWAP(intersect[i], intersect[i + 1], temp);
+        }
+      }
+    } while (wrong_order);
+
+    /* find longest span */
+    for (i = 0; i < nfound; i += 2) {
+      len = fabs(intersect[i] - intersect[i + 1]);
+      if (len > max_len) {
+        max_len = len;
+        lp->x = (intersect[i] + intersect[i + 1]) / 2;
+        lp->y = y;
+      }
+    }
+  } else { /* center vertically, fix x */
+    x = lp->x;
+
+    /* need to find a x that won't intersect any vertices exactly */
+    max = x - 1; /* first initializing min, max to be any 2 pnts on either side
+                    of x */
+    min = x + 1;
+    for (j = 0; j < p->numlines; j++) {
+      if ((min < x) && (max >= x))
+        break;
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((min < x) && (max >= x))
+          break;
+        if (p->line[j].point[i].x < x)
+          min = p->line[j].point[i].x;
+        if (p->line[j].point[i].x >= x)
+          max = p->line[j].point[i].x;
+      }
+    }
+
+    n = 0;
+    for (j = 0; j < p->numlines; j++) {
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((p->line[j].point[i].x < x) &&
+            ((x - p->line[j].point[i].x) < (x - min)))
+          min = p->line[j].point[i].x;
+        if ((p->line[j].point[i].x >= x) &&
+            ((p->line[j].point[i].x - x) < (max - x)))
+          max = p->line[j].point[i].x;
+      }
+    }
+
+    if (min == max) {
+      msFree(intersect);
+      return (MS_FAILURE);
+    } else
+      x = (max + min) / 2.0;
+
+    nfound = 0;
+    for (j = 0; j < p->numlines; j++) { /* for each line */
+
+      point1 = &(p->line[j].point[p->line[j].numpoints - 1]);
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        point2 = &(p->line[j].point[i]);
+
+        if (EDGE_CHECK(point1->x, x, point2->x) == CLIP_MIDDLE) {
+
+          if (point1->x == point2->x)
+            continue; /* ignore vertical edges */
+          else if (point1->y == point2->y)
+            y = point1->y; /* for a horizontal edge we know y */
+          else {
+            slope = (point2->x - point1->x) / (point2->y - point1->y);
+            y = (x - point1->x) / slope + point1->y;
+          }
+
+          intersect[nfound++] = y;
+        } /* end checking this edge */
+
+        point1 = point2; /* next edge */
+      }
+    } /* finished line */
+
+    /* sort the intersections */
+    do {
+      wrong_order = 0;
+      for (i = 0; i < nfound - 1; i++) {
+        if (intersect[i] > intersect[i + 1]) {
+          wrong_order = 1;
+          SWAP(intersect[i], intersect[i + 1], temp);
+        }
+      }
+    } while (wrong_order);
+
+    /* find longest span */
+    for (i = 0; i < nfound; i += 2) {
+      len = fabs(intersect[i] - intersect[i + 1]);
+      if (len > max_len) {
+        max_len = len;
+        lp->y = (intersect[i] + intersect[i + 1]) / 2;
+        lp->x = x;
+      }
+    }
+  }
+
+  free(intersect);
+
+  if (max_len > 0)
+    return (MS_SUCCESS);
+  else
+    return (MS_FAILURE);
+}
+
+/* Compute all the lineString/segment lengths and determine the longest
+ * lineString of a multiLineString shape: in paramater, the multiLineString to
+ * compute. struct polyline_lengths pll: out parameter, all line and segment
+ * lengths
+ */
+void msPolylineComputeLineSegments(shapeObj *shape,
+                                   struct polyline_lengths *pll) {
+  int i, j;
+  double max_line_length = -1, max_segment_length = -1, segment_length;
+
+  pll->ll = msSmallMalloc(shape->numlines * sizeof(struct line_lengths));
+  pll->total_length = 0;
+  pll->longest_line_index = 0;
+
+  for (i = 0; i < shape->numlines; i++) {
+    struct line_lengths *ll = &pll->ll[i];
+    double max_subline_segment_length = -1;
+
+    if (shape->line[i].numpoints > 1) {
+      ll->segment_lengths = (double *)msSmallMalloc(
+          sizeof(double) * (shape->line[i].numpoints - 1));
+    } else {
+      ll->segment_lengths = NULL;
+    }
+    ll->total_length = 0;
+
+    for (j = 1; j < shape->line[i].numpoints; j++) {
+      segment_length =
+          sqrt((((shape->line[i].point[j].x - shape->line[i].point[j - 1].x) *
+                 (shape->line[i].point[j].x - shape->line[i].point[j - 1].x)) +
+                ((shape->line[i].point[j].y - shape->line[i].point[j - 1].y) *
+                 (shape->line[i].point[j].y - shape->line[i].point[j - 1].y))));
+      ll->total_length += segment_length;
+      ll->segment_lengths[j - 1] = segment_length;
+      if (segment_length > max_subline_segment_length) {
+        max_subline_segment_length = segment_length;
+        ll->longest_segment_index = j;
+      }
+      if (segment_length > max_segment_length) {
+        max_segment_length = segment_length;
+        pll->longest_segment_line_index = i;
+        pll->longest_segment_point_index = j;
+      }
+    }
+    pll->total_length += ll->total_length;
+
+    if (ll->total_length > max_line_length) {
+      max_line_length = ll->total_length;
+      pll->longest_line_index = i;
+    }
+  }
+}
+
+/*
+** If no repeatdistance, find center of longest segment in polyline p. The
+*polyline must have been converted
+** to image coordinates before calling this function.
+*/
+int msPolylineLabelPoint(mapObj *map, shapeObj *p, textSymbolObj *ts,
+                         labelObj *label, struct label_auto_result *lar,
+                         double resolutionfactor) {
+  struct polyline_lengths pll;
+  int i, ret = MS_SUCCESS;
+  double minfeaturesize = -1;
+  assert(ts == NULL || ts->annotext);
+
+  if (label && ts) {
+    if (label->autominfeaturesize) {
+      if (!ts->textpath) {
+        if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts)))
+          return MS_FAILURE;
+      }
+      if (!ts->textpath)
+        return MS_FAILURE;
+      minfeaturesize = ts->textpath->bounds.bbox.maxx;
+    } else if (label->minfeaturesize) {
+      minfeaturesize = label->minfeaturesize * resolutionfactor;
+    }
+  }
+
+  /* compute line lengths, in order to:
+    - extract the longest line if we're not repeating
+    - check that each line is longer than the text length if using
+    minfeaturesize auto
+    - check that each line is long enough if using minfeaturesize
+   */
+  msPolylineComputeLineSegments(p, &pll);
+
+  if (label && label->repeatdistance > 0) {
+    for (i = 0; i < p->numlines; i++) {
+      if (pll.ll[i].total_length > minfeaturesize) {
+        ret = msLineLabelPoint(map, &p->line[i], ts, &pll.ll[i], lar, label,
+                               resolutionfactor);
+      }
+    }
+  } else {
+    i = pll.longest_line_index;
+    if (pll.ll[i].total_length > minfeaturesize) {
+      ret = msLineLabelPoint(map, &p->line[i], ts, &pll.ll[i], lar, label,
+                             resolutionfactor);
+    }
+  }
+
+  /* freeing memory: allocated by msPolylineComputeLineSegments */
+  for (i = 0; i < p->numlines; i++) {
+    free(pll.ll[i].segment_lengths);
+  }
+  free(pll.ll);
+
+  return ret;
+}
+
+int msLineLabelPoint(mapObj *map, lineObj *p, textSymbolObj *ts,
+                     struct line_lengths *ll, struct label_auto_result *lar,
+                     labelObj *label, double resolutionfactor) {
+  (void)map;
+  int j, l, n, point_repeat;
+  double t, theta, fwd_length, point_distance;
+  double center_point_position, left_point_position, right_point_position,
+      point_position;
+  double repeat_distance = -1;
+  if (label) {
+    repeat_distance = label->repeatdistance * resolutionfactor;
+  }
+
+  if (MS_UNLIKELY(p->numpoints < 2))
+    return MS_FAILURE;
+  point_distance = 0;
+  point_repeat = 1;
+  left_point_position = right_point_position = center_point_position =
+      ll->total_length / 2.0;
+
+  if (repeat_distance > 0) {
+    point_repeat = ll->total_length / repeat_distance;
+
+    if (point_repeat > 1) {
+      if (point_repeat % 2 == 0)
+        point_repeat -= 1;
+      point_distance =
+          (ll->total_length / point_repeat); /* buffer allowed per point */
+
+      /* initial point position */
+      left_point_position -= ((point_repeat - 1) / 2 * point_distance);
+      right_point_position += ((point_repeat - 1) / 2 * point_distance);
+
+      point_repeat = (point_repeat - 1) / 2 + 1;
+    } else
+      point_repeat = 1;
+  }
+
+  for (l = 0; l < point_repeat; ++l) {
+    if (l ==
+        point_repeat - 1) { /* last point to place is always the center point */
+      point_position = center_point_position;
+      n = 1;
+    } else {
+      point_position = right_point_position;
+      n = 0;
+    }
+
+    do {
+      lar->angles = msSmallRealloc(lar->angles, (lar->num_label_points + 1) *
+                                                    sizeof(double));
+      lar->label_points = msSmallRealloc(
+          lar->label_points, (lar->num_label_points + 1) * sizeof(pointObj));
+
+      /* if there is only 1 label to place... put it in the middle of the
+       * current segment (as old behavior) */
+      if (point_repeat == 1) {
+        j = ll->longest_segment_index;
+        lar->label_points[lar->num_label_points].x =
+            (p->point[j - 1].x + p->point[j].x) / 2.0;
+        lar->label_points[lar->num_label_points].y =
+            (p->point[j - 1].y + p->point[j].y) / 2.0;
+      } else {
+        j = 0;
+        fwd_length = 0;
+        while (fwd_length < point_position) {
+          fwd_length += ll->segment_lengths[j++];
+        }
+        assert(j > 0);
+
+        t = 1 - (fwd_length - point_position) / ll->segment_lengths[j - 1];
+        lar->label_points[lar->num_label_points].x =
+            t * (p->point[j].x - p->point[j - 1].x) + p->point[j - 1].x;
+        lar->label_points[lar->num_label_points].y =
+            t * (p->point[j].y - p->point[j - 1].y) + p->point[j - 1].y;
+      }
+
+      if (label && ts) {
+        if (label->anglemode != MS_NONE) {
+          theta = atan2(p->point[j].x - p->point[j - 1].x,
+                        p->point[j].y - p->point[j - 1].y);
+          if (label->anglemode == MS_AUTO2) {
+            theta -= MS_PI2;
+          } else {                                   /* AUTO, FOLLOW */
+            if (p->point[j - 1].x < p->point[j].x) { /* i.e. to the left */
+              theta -= MS_PI2;
+            } else {
+              theta += MS_PI2;
+            }
+          }
+          lar->angles[lar->num_label_points] = theta;
+        } else {
+          lar->angles[lar->num_label_points] = MS_DEG_TO_RAD * ts->label->angle;
+        }
+      } else {
+        lar->angles[lar->num_label_points] = 0;
+      }
+      lar->num_label_points++;
+
+      point_position = left_point_position;
+      n++;
+    } while (n < 2); /* we place the right point then the left point. */
+
+    right_point_position -= point_distance;
+    left_point_position += point_distance;
+  }
+
+  return MS_SUCCESS;
+}
+
+/* Calculate the labelpath for each line if repeatdistance is enabled, else the
+ * labelpath of the longest line segment */
+int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p,
+                        textSymbolObj *ts, labelObj *label,
+                        struct label_follow_result *lfr) {
+  struct polyline_lengths pll;
+  int i, ret = MS_SUCCESS;
+  double minfeaturesize = -1;
+  assert(ts->annotext);
+  lfr->num_follow_labels = lfr->lar.num_label_points = 0;
+
+  /* we first offset the line if we want an offsetted label */
+  if (label->offsetx != 0 && IS_PERPENDICULAR_OFFSET(label->offsety)) {
+    double offset;
+    if (label->offsetx > 0) {
+      offset = label->offsetx + label->size / 2;
+    } else {
+      offset = label->offsetx - label->size / 2;
+    }
+    if (label->offsety == MS_LABEL_PERPENDICULAR_TOP_OFFSET &&
+        p->numlines > 0 && p->line[0].numpoints > 0) {
+      /* is the line mostly left-to-right or right-to-left ?
+       * FIXME this should be done line by line, by stepping through
+       * shape->lines, however the OffsetPolyline function works on shapeObjs,
+       * not lineObjs we only check the first line
+       */
+      if (p->line[0].point[0].x <
+          p->line[0].point[p->line[0].numpoints - 1].x) {
+        /* line is left to right */
+        offset = -offset;
+      }
+    }
+    p = msOffsetPolyline(p, offset, MS_STYLE_SINGLE_SIDED_OFFSET);
+    if (!p)
+      return MS_FAILURE;
+  }
+
+  /* compute line lengths, in order to:
+    - extract the longest line if we're not repeating
+    - check that each line is longer than the text length if using
+    minfeaturesize auto
+    - check that each line is long enough if using minfeaturesize
+   */
+  msPolylineComputeLineSegments(p, &pll);
+
+  if (label->autominfeaturesize) {
+    if (!ts->textpath) {
+      if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
+        return MS_FAILURE;
+      }
+    }
+    if (!ts->textpath)
+      return MS_FAILURE;
+    minfeaturesize = ts->textpath->bounds.bbox.maxx;
+  } else if (label->minfeaturesize) {
+    minfeaturesize = label->minfeaturesize * image->resolutionfactor;
+  }
+
+  if (label->repeatdistance > 0) {
+    for (i = 0; i < p->numlines; i++) {
+      if (pll.ll[i].total_length > minfeaturesize) {
+        ret = msLineLabelPath(map, image, &p->line[i], ts, &pll.ll[i], lfr,
+                              label);
+      }
+    }
+  } else {
+    i = pll.longest_line_index;
+    if (pll.ll[i].total_length > minfeaturesize) {
+      ret =
+          msLineLabelPath(map, image, &p->line[i], ts, &pll.ll[i], lfr, label);
+    }
+  }
+
+  /* freeing memory: allocated by msPolylineComputeLineSegments */
+  for (i = 0; i < p->numlines; i++) {
+    free(pll.ll[i].segment_lengths);
+  }
+  free(pll.ll);
+
+  if (IS_PERPENDICULAR_OFFSET(label->offsety) && label->offsetx != 0) {
+    msFreeShape(p);
+    msFree(p);
+  }
+  return ret;
+}
+
+static double compute_retry_offset(textSymbolObj *ts, int fail_idx,
+                                   double retried_offset, double max_dec_offset,
+                                   double max_inc_offset) {
+  /* fail_idx: the glyph index in the textpath that originally failed (i.e.
+   * before any displacement was tested */
+  /* retried_offset: the last offset that was tried and is failing, so we can
+   * return the next one (or 0 if none left)*/
+  int inc = 1, dec_found = 0, inc_found = 0;
+  double inc_offset = 0, dec_offset = 0;
+
+  retried_offset = fabs(retried_offset);
+  do {
+    if (fail_idx - inc - 1 >= 0) {
+      dec_offset += ts->textpath->glyphs[fail_idx - inc].glyph->metrics.advance;
+      if (dec_offset > max_dec_offset)
+        break;
+      if (dec_offset > retried_offset &&
+          msIsGlyphASpace(&ts->textpath->glyphs[fail_idx - inc - 1])) {
+        dec_found = 1;
+        dec_offset +=
+            ts->textpath->glyphs[fail_idx - inc - 1].glyph->metrics.advance /
+            2.0;
+        break;
+      }
+    }
+    inc++;
+  } while (dec_offset < max_dec_offset && fail_idx - inc > 0);
+
+  if (!dec_found) {
+    /* try the starting position */
+    dec_offset += ts->textpath->glyphs[0].glyph->metrics.advance;
+    if (dec_offset > retried_offset && dec_offset < max_dec_offset) {
+      dec_found = 1;
+    }
+  }
+
+  inc = 1;
+  inc_offset = ts->textpath->glyphs[fail_idx].glyph->metrics.advance;
+  do {
+    if (fail_idx + inc < ts->textpath->numglyphs - 1) {
+      if (inc_offset > retried_offset &&
+          msIsGlyphASpace(&ts->textpath->glyphs[fail_idx + inc])) {
+        inc_offset +=
+            ts->textpath->glyphs[fail_idx + inc].glyph->metrics.advance / 2;
+        if (inc_offset < max_inc_offset)
+          inc_found = 1;
+        break;
+      }
+      inc_offset += ts->textpath->glyphs[fail_idx + inc].glyph->metrics.advance;
+    }
+    inc++;
+  } while (inc_offset < max_inc_offset &&
+           fail_idx + inc < ts->textpath->numglyphs - 1);
+  if (!inc_found) {
+    inc_offset += ts->textpath->glyphs[ts->textpath->numglyphs - 1]
+                      .glyph->metrics.advance;
+    if (inc_offset > retried_offset && inc_offset < max_inc_offset) {
+      inc_found = 1;
+    }
+  }
+
+  if (!inc_found && !dec_found)
+    return 0.0;
+  if (inc_found && dec_found) {
+    if (inc_offset < dec_offset)
+      return -inc_offset;
+    else
+      return dec_offset;
+  }
+  if (inc_found)
+    return -inc_offset;
+  else
+    return dec_offset;
+}
+/*
+ * Calculate a series of label points for each character in the label for a
+ * given line. The resultant series of points is stored in *labelpath,
+ * which is added to the labelpaths array. Note that the points and bounds
+ * are allocated in this function.  The polyline must be converted to image
+ * coordinates before calling this function.
+ */
+int msLineLabelPath(mapObj *map, imageObj *img, lineObj *p, textSymbolObj *ts,
+                    struct line_lengths *ll, struct label_follow_result *lfr,
+                    labelObj *label) {
+  double distance_along_segment;
+  double repeat_distance = label->repeatdistance * ts->resolutionfactor;
+  double segment_length, fwd_line_length, rev_line_length, text_length,
+      text_start_length, label_buffer, text_end_length, cur_label_position,
+      first_label_position;
+  double max_retry_offset;
+
+  int j, k, l, inc, final_j, label_repeat;
+  double direction;
+  rectObj bbox;
+  lineObj *bounds;
+  double t;
+  double cx, cy; /* centre of a character, x & y values. */
+
+  double theta;
+  double dx, dy, w, cos_t, sin_t;
+
+  const double letterspacing = 1.00;
+  /* As per RFC 60, if label->maxoverlapangle == 0 then fall back on pre-6.0
+     behavior which was to use maxoverlapangle = 0.4*MS_PI ( 40% of 180 degrees
+     ) */
+  double maxoverlapangle = 0.4 * MS_PI;
+
+  if (p->numpoints < 2) { /* degenerate */
+    return MS_FAILURE;
+  }
+  if (p->numpoints == 2) /* use the regular angled text algorithm */
+    return msLineLabelPoint(map, p, ts, ll, &lfr->lar, label,
+                            img->resolutionfactor);
+
+  if (!ts->textpath) {
+    if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
+      return MS_FAILURE;
+    }
+  }
+  if (!ts->textpath) {
+    return MS_FAILURE;
+  }
+
+  /* skip the label and use the normal algorithm if it has fewer than 2
+   * characters */
+  if (ts->textpath->numglyphs < 2)
+    return msLineLabelPoint(map, p, ts, ll, &lfr->lar, label,
+                            img->resolutionfactor);
+
+  text_length = letterspacing * ts->textpath->bounds.bbox.maxx;
+
+  /*
+  ** if the text length is way longer than the line, skip adding the
+  ** label if it isn't forced (long extrapolated labels tend to be ugly)
+  */
+  if (text_length > 1.5 * ll->total_length) {
+    if (ts->label->force == MS_FALSE) {
+      return MS_SUCCESS;
+    } else {
+      repeat_distance = 0; /* disable repetition */
+    }
+  }
+
+  /* We compute the number of labels we can repeat in the line:
+     - space occupied by one label
+     - plus N times space occupied by one label + repeat_distance interspacing
+   */
+  label_buffer =
+      text_length + repeat_distance; /* distance occupied by one label +
+                                        inter-repeat spacing */
+  if (repeat_distance > 0 && ll->total_length > text_length) {
+    label_repeat = 1 + (int)((ll->total_length - text_length) / label_buffer);
+    max_retry_offset = repeat_distance / 2.1;
+  } else {
+    label_repeat = 1;
+    max_retry_offset = (ll->total_length - text_length) / 2.1;
+  }
+  /* compute the starting point of where we'll be placing the first label */
+  if (label_repeat % 2) {
+    /* odd number of labels: account for the center label that will be centered
+     * on the line
+     * ----llll_____llll_____llll----
+     */
+    first_label_position = (ll->total_length - text_length) / 2.0 -
+                           (label_repeat / 2) * label_buffer;
+  } else {
+    /* even number of labels:
+     * repeat_distance is centered on the line
+     * space for one label
+     * eventually space for label_repeat*2-1 labels+spacing
+     * ----llll_____llll----
+     * --llll_____llll_____llll_____llll--
+     */
+    first_label_position = (ll->total_length - repeat_distance) / 2.0 -
+                           text_length - (label_repeat / 2 - 1) * label_buffer;
+  }
+  if (label->maxoverlapangle > 0)
+    maxoverlapangle = label->maxoverlapangle * MS_DEG_TO_RAD; /* radian */
+
+  cur_label_position = first_label_position;
+  for (l = 0; l < label_repeat; l++) {
+
+    double retry_offset = 0.0;
+    int first_retry_idx = 0;
+    // max_dec_retry_offset = max_inc_retry_offset = max_retry_offset;
+    textPathObj *tp = msSmallCalloc(1, sizeof(textPathObj));
+    /* copy the textPath, we will be overriding the copy's positions and angles
+     */
+    msCopyTextPath(tp, ts->textpath);
+    tp->bounds.poly = msSmallMalloc(sizeof(lineObj));
+    bounds = tp->bounds.poly;
+
+    /*
+    ** The bounds will have two points for each character plus an endpoint:
+    ** the UL corners of each bbox will be tied together and the LL corners
+    ** will be tied together.
+    */
+    bounds->numpoints = 2 * tp->numglyphs + 1;
+    bounds->point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * bounds->numpoints);
+
+    do {
+      int overlap_collision_detected = 0;
+      text_start_length = cur_label_position + retry_offset;
+      text_end_length = 0;
+
+      for (k = 0; k < tp->numglyphs; k++) {
+        tp->glyphs[k].pnt.x = 0;
+        tp->glyphs[k].pnt.y = 0;
+      }
+
+      /* the points start at (line_length - text_length) / 2 in order to be
+       * centred */
+      /* text_start_length = (line_length - text_length) / 2.0; */
+
+      j = 0;
+      fwd_line_length = 0;
+      if (text_start_length >= 0.0) {
+        while (fwd_line_length < text_start_length)
+          fwd_line_length += ll->segment_lengths[j++];
+
+        j--;
+      }
+      final_j = p->numpoints - 1;
+      rev_line_length = 0;
+      if (text_start_length + text_length <= ll->total_length) {
+        text_end_length = ll->total_length - (text_start_length + text_length);
+        while (rev_line_length < text_end_length) {
+          rev_line_length += ll->segment_lengths[final_j - 1];
+          final_j--;
+        }
+        final_j++;
+      }
+
+      if (final_j == 0)
+        final_j = 1;
+
+      /* determine if the line is mostly left to right or right to left,
+       see bug 1620 discussion by Steve Woodbridge */
+      direction = p->point[final_j].x - p->point[j].x;
+
+      if (direction > 0) {
+        inc = 1; /* j is already correct */
+
+        /* length of the segment containing the starting point */
+        segment_length = ll->segment_lengths[j];
+
+        /* determine how far along the segment we need to go */
+        if (text_start_length < 0.0)
+          t = text_start_length / segment_length;
+        else
+          t = 1 - (fwd_line_length - text_start_length) / segment_length;
+      } else {
+        j = final_j;
+        inc = -1;
+
+        /* length of the segment containing the starting point */
+        segment_length = ll->segment_lengths[j - 1];
+        if (text_start_length < 0.0)
+          t = text_start_length / segment_length;
+        else
+          t = 1 - (rev_line_length - text_end_length) / segment_length;
+      }
+
+      distance_along_segment = t * segment_length; /* starting point */
+
+      theta = 0;
+      k = 0;
+      w = 0;
+      while (k < tp->numglyphs) {
+        double x, y;
+
+        x = t * (p->point[j + inc].x - p->point[j].x) + p->point[j].x;
+        y = t * (p->point[j + inc].y - p->point[j].y) + p->point[j].y;
+        tp->glyphs[k].pnt.x = x;
+        tp->glyphs[k].pnt.y = y;
+
+        w = letterspacing * tp->glyphs[k].glyph->metrics.advance;
+
+        /* add the character's width to the distance along the line */
+        distance_along_segment += w;
+
+        /* if we still have segments left and we've past the current segment,
+         * move to the next one */
+        if (inc == 1 && j < p->numpoints - 2) {
+
+          while (j < p->numpoints - 2 &&
+                 distance_along_segment > ll->segment_lengths[j]) {
+            distance_along_segment -= ll->segment_lengths[j];
+            j += inc; /* move to next segment */
+          }
+
+          segment_length = ll->segment_lengths[j];
+
+        } else if (inc == -1 && j > 1) {
+
+          while (j > 1 && distance_along_segment > ll->segment_lengths[j - 1]) {
+            distance_along_segment -= ll->segment_lengths[j - 1];
+            j += inc; /* move to next segment */
+          }
+
+          segment_length = ll->segment_lengths[j - 1];
+        }
+
+        /* Recalculate interpolation parameter */
+        t = distance_along_segment / segment_length;
+
+        k++;
+      }
+
+      /* pre-calc the character's centre y value.  Used for rotation adjustment.
+       */
+      cy = -ts->textpath->glyph_size / 2.0;
+#ifdef USE_KERNEL
+      tp->glyphs[0].pnt.x /= kernel_normal;
+      tp->glyphs[0].pnt.y /= kernel_normal;
+#endif
+
+      /* Average the points and calculate each angle */
+      overlap_collision_detected = 0;
+      for (k = 1; k <= tp->numglyphs; k++) {
+        double anglediff;
+        if (k < tp->numglyphs) {
+#ifdef USE_KERNEL
+          tp->glyphs[k].pnt.x /= kernel_normal;
+          tp->glyphs[k].pnt.y /= kernel_normal;
+#endif
+          dx = tp->glyphs[k].pnt.x - tp->glyphs[k - 1].pnt.x;
+          dy = tp->glyphs[k].pnt.y - tp->glyphs[k - 1].pnt.y;
+        } else {
+          /* Handle the last character */
+          dx = t * (p->point[j + inc].x - p->point[j].x) + p->point[j].x -
+               tp->glyphs[k - 1].pnt.x;
+          dy = t * (p->point[j + inc].y - p->point[j].y) + p->point[j].y -
+               tp->glyphs[k - 1].pnt.y;
+        }
+
+        if (dx || dy || k == 1) {
+
+          theta = -atan2(dy, dx);
+
+          if (maxoverlapangle > 0 && k > 1) {
+            /* no use testing for overlap if glyph or previous glyph is a space
+             */
+            if (!msIsGlyphASpace(&tp->glyphs[k - 1]) &&
+                !msIsGlyphASpace(&tp->glyphs[k - 2])) {
+              /* If the difference between the last char angle and the current
+               one is greater than the MAXOVERLAPANGLE value (set at 80% of
+               180deg by default) , bail the label */
+              anglediff = fabs(theta - tp->glyphs[k - 2].rot);
+              anglediff = MS_MIN(anglediff, MS_2PI - anglediff);
+              if (anglediff > maxoverlapangle) {
+                double max_dec_retry_offset;
+                double max_inc_retry_offset;
+                if (label_repeat == 1) {
+                  max_dec_retry_offset = max_inc_retry_offset =
+                      first_label_position;
+                } else if (l == 0) {
+                  if (direction > 0) {
+                    max_inc_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
+                    max_dec_retry_offset = max_retry_offset;
+                  } else {
+                    max_inc_retry_offset = max_retry_offset;
+                    max_dec_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
+                  }
+                } else if (l == label_repeat - 1) {
+                  if (direction > 0) {
+                    max_dec_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
+                    max_inc_retry_offset = max_retry_offset;
+                  } else {
+                    max_dec_retry_offset = max_retry_offset;
+                    max_inc_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
+                  }
+                } else {
+                  max_dec_retry_offset = max_inc_retry_offset =
+                      max_retry_offset;
+                }
+
+                overlap_collision_detected = 1;
+                if (retry_offset == 0.0) {
+                  first_retry_idx = k - 1;
+                }
+                retry_offset = compute_retry_offset(
+                    ts, first_retry_idx, retry_offset, max_dec_retry_offset,
+                    max_inc_retry_offset);
+                if (retry_offset != 0.0) { /* offsetted position to try */
+                  if (direction < 0) {
+                    retry_offset = -retry_offset;
+                  }
+                }
+                break;
+              }
+            }
+          }
+        } else {
+          /*
+           * handle the 0-advance case, as the complex text shaping may have
+           * placed multiple glyphs at the same position
+           */
+          theta = tp->glyphs[k - 2].rot;
+        }
+
+        /* msDebug("s: %c (x,y): (%0.2f,%0.2f) t: %0.2f\n", string[k-1],
+         * labelpath->path.point[k-1].x, labelpath->path.point[k-1].y, theta);
+         */
+
+        tp->glyphs[k - 1].rot = theta;
+
+        /* Move the previous point so that when the character is rotated and
+         placed it is centred on the line */
+        cos_t = cos(theta);
+        sin_t = sin(theta);
+
+        w = letterspacing * tp->glyphs[k - 1].glyph->metrics.advance;
+
+        cx = 0; /* Center the character vertically only */
+
+        dx = -(cx * cos_t + cy * sin_t);
+        dy = -(cy * cos_t - cx * sin_t);
+
+        tp->glyphs[k - 1].pnt.x += dx;
+        tp->glyphs[k - 1].pnt.y += dy;
+
+        /* Calculate the bounds */
+        bbox.minx = 0;
+        bbox.maxx = w;
+        bbox.maxy = 0;
+        bbox.miny = -ts->textpath->glyph_size;
+
+        /* Add the label buffer to the bounds */
+        bbox.maxx += ts->label->buffer * ts->resolutionfactor;
+        bbox.maxy += ts->label->buffer * ts->resolutionfactor;
+        bbox.minx -= ts->label->buffer * ts->resolutionfactor;
+        bbox.miny -= ts->label->buffer * ts->resolutionfactor;
+
+        if (k < tp->numglyphs) {
+          /* Transform the bbox too.  We take the UL and LL corners and rotate
+           then translate them. */
+          bounds->point[k - 1].x =
+              (bbox.minx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[k - 1].y =
+              (bbox.maxy * cos_t - bbox.minx * sin_t) + tp->glyphs[k - 1].pnt.y;
+
+          /* Start at end and work towards the half way point */
+          bounds->point[bounds->numpoints - k - 1].x =
+              (bbox.minx * cos_t + bbox.miny * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[bounds->numpoints - k - 1].y =
+              (bbox.miny * cos_t - bbox.minx * sin_t) + tp->glyphs[k - 1].pnt.y;
+
+        } else {
+
+          /* This is the last character in the string so we take the UR and LR
+           corners of the bbox */
+          bounds->point[k - 1].x =
+              (bbox.maxx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[k - 1].y =
+              (bbox.maxy * cos_t - bbox.maxx * sin_t) + tp->glyphs[k - 1].pnt.y;
+
+          bounds->point[bounds->numpoints - k - 1].x =
+              (bbox.maxx * cos_t + bbox.miny * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[bounds->numpoints - k - 1].y =
+              (bbox.miny * cos_t - bbox.maxx * sin_t) + tp->glyphs[k - 1].pnt.y;
+        }
+      }
+      if (overlap_collision_detected) {
+        continue;
+      }
+
+      /* Close the bounds */
+      bounds->point[bounds->numpoints - 1].x = bounds->point[0].x;
+      bounds->point[bounds->numpoints - 1].y = bounds->point[0].y;
+
+      /* compute the bounds */
+      fastComputeBounds(bounds, &tp->bounds.bbox);
+
+      {
+        textPathObj *tmptp;
+        textSymbolObj *tsnew;
+        lfr->num_follow_labels++;
+        lfr->follow_labels =
+            msSmallRealloc(lfr->follow_labels,
+                           lfr->num_follow_labels * sizeof(textSymbolObj *));
+        tmptp = ts->textpath;
+        ts->textpath = NULL;
+        lfr->follow_labels[lfr->num_follow_labels - 1] =
+            msSmallMalloc(sizeof(textSymbolObj));
+        tsnew = lfr->follow_labels[lfr->num_follow_labels - 1];
+        initTextSymbol(tsnew);
+        msCopyTextSymbol(tsnew, ts);
+        ts->textpath = tmptp;
+        tsnew->textpath = tp;
+        tp = NULL;
+        tsnew->textpath->absolute = 1;
+      }
+
+      cur_label_position += label_buffer;
+      retry_offset = 0;
+    } while (retry_offset);
+
+    if (tp) {
+      freeTextPath(tp);
+      free(tp);
+    }
+  }
+  return MS_SUCCESS;
+}
+
+/* ===========================================================================
+   Pretty printing of primitive objects
+   ======================================================================== */
+
+void msRectToFormattedString(rectObj *rect, char *format, char *buffer,
+                             int buffer_length) {
+  snprintf(buffer, buffer_length, format, rect->minx, rect->miny, rect->maxx,
+           rect->maxy);
+}
+
+void msPointToFormattedString(pointObj *point, const char *format, char *buffer,
+                              int buffer_length) {
+  snprintf(buffer, buffer_length, format, point->x, point->y, point->z,
+           point->m);
+}
+
+/* Returns true if a shape contains only degenerate parts */
+int msIsDegenerateShape(shapeObj *shape) {
+  int i;
+  int non_degenerate_parts = 0;
+  for (i = 0; i < shape->numlines; i++) { /* e.g. part */
+
+    /* skip degenerate parts, really should only happen with pixel output */
+    if ((shape->type == MS_SHAPE_LINE && shape->line[i].numpoints < 2) ||
+        (shape->type == MS_SHAPE_POLYGON && shape->line[i].numpoints < 3))
+      continue;
+
+    non_degenerate_parts++;
+  }
+  return (non_degenerate_parts == 0);
+}
+
+shapeObj *msRings2Shape(shapeObj *shape, int outer) {
+  shapeObj *shape2;
+  int i, rv, *outerList = NULL;
+
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_POLYGON)
+    return NULL;
+
+  outer = (outer) ? 1 : 0; // set explicitly to 1 or 0
+
+  shape2 = (shapeObj *)malloc(sizeof(shapeObj));
+  MS_CHECK_ALLOC(shape2, sizeof(shapeObj), NULL);
+  msInitShape(shape2);
+  shape2->type = shape->type;
+
+  outerList = msGetOuterList(shape);
+  if (!outerList) {
+    msFreeShape(shape2);
+    free(shape2);
+    return NULL;
+  }
+
+  for (i = 0; i < shape->numlines; i++) {
+    if (outerList[i] == outer) { // else inner
+      rv = msAddLine(shape2, &(shape->line[i]));
+      if (rv != MS_SUCCESS) {
+        msFreeShape(shape2);
+        free(shape2);
+        free(outerList);
+        return NULL;
+      }
+    }
+  }
+
+  free(outerList); // clean up
+  return shape2;
+}
+
+shapeObj *msDensify(shapeObj *shape, double tolerance) {
+  int i, j, k, l; // counters
+  int n;
+  shapeObj *shape2;
+  lineObj line;
+  double distance, length, c;
+
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_POLYGON && shape->type != MS_SHAPE_LINE)
+    return NULL;
+  if (tolerance <= 0)
+    return NULL; // must be positive
+
+  shape2 = (shapeObj *)malloc(sizeof(shapeObj));
+  MS_CHECK_ALLOC(shape2, sizeof(shapeObj), NULL);
+  msInitShape(shape2);
+  shape2->type = shape->type; // POLGYON or LINE
+
+  for (i = 0; i < shape->numlines; i++) {
+
+    line.numpoints = shape->line[i].numpoints;
+    line.point = (pointObj *)malloc(
+        sizeof(pointObj) *
+        line.numpoints); // best case we don't have to add any points
+    MS_CHECK_ALLOC(line.point, sizeof(pointObj) * line.numpoints, NULL);
+
+    for (j = 0, l = 0; j < shape->line[i].numpoints - 1; j++, l++) {
+      line.point[l] = shape->line[i].point[j];
+
+      distance = msDistancePointToPoint(&(shape->line[i].point[j]),
+                                        &(shape->line[i].point[j + 1]));
+      if (distance > tolerance) {
+        n = (int)floor(distance / tolerance); // number of new points, n+1 is
+                                              // the number of new segments
+        length = distance / (n + 1);          // segment length
+
+        line.numpoints += n;
+        line.point =
+            (pointObj *)realloc(line.point, sizeof(pointObj) * line.numpoints);
+        MS_CHECK_ALLOC(line.point, sizeof(pointObj) * line.numpoints, NULL);
+
+        for (k = 0; k < n; k++) {
+          c = (k + 1) * length / distance;
+          l++;
+          line.point[l].x =
+              shape->line[i].point[j].x +
+              c * (shape->line[i].point[j + 1].x - shape->line[i].point[j].x);
+          line.point[l].y =
+              shape->line[i].point[j].y +
+              c * (shape->line[i].point[j + 1].y - shape->line[i].point[j].y);
+        }
+      }
+    }
+    line.point[l] = shape->line[i].point[j];
+
+    msAddLineDirectly(shape2, &line);
+  }
+
+  return shape2;
+}
diff -pruN 8.0.1-5/src/mapprimitive.h 8.2.0~beta1-1~exp1/src/mapprimitive.h
--- 8.0.1-5/src/mapprimitive.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapprimitive.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,136 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Declarations for rectObj, pointObj, lineObj, shapeObj, etc.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPPRIMITIVE_H
+#define MAPPRIMITIVE_H
+
+/**
+A rectObj represents a rectangle or bounding box.
+A rectObj may be a lone object or an attribute of another object and has no
+other associations.
+*/
+typedef struct {
+  double minx; ///< Minimum easting
+  double miny; ///< Minimum northing
+  double maxx; ///< Maximum easting
+  double maxy; ///< Maximum northing
+} rectObj;
+
+#ifndef SWIG
+typedef struct {
+  double x;
+  double y;
+} vectorObj;
+#endif /*SWIG*/
+
+/**
+A :class:`pointObj` has an x, y, z and m values.
+A :class:`pointObj` instance may be associated with a :class:`lineObj`.
+*/
+typedef struct {
+  double x; ///< The x coordinate of the point
+  double y; ///< The y coordinate of the point
+  double z; ///< The z (height) coordinate of the point
+  double m; ///< The m (measure) of the point, used for linear referencing
+} pointObj;
+
+/**
+A :class:`lineObj` is composed of one or more :class:`pointObj` instances
+*/
+typedef struct {
+#ifdef SWIG
+  %immutable;
+#endif
+  int numpoints; ///< Number of points in the line
+#ifndef SWIG
+  pointObj *point;
+#endif
+#ifdef SWIG
+  %mutable;
+#endif
+} lineObj;
+
+/**
+Each feature of a layer's data is a :class:`shapeObj`. Each part of the shape is
+a closed :class:`lineObj`.
+*/
+typedef struct {
+
+#ifndef SWIG
+  lineObj *line;
+  char **values;
+  void *geometry;
+  void *renderer_cache;
+#endif
+
+#ifdef SWIG
+  %immutable;
+#endif
+  int numlines;  ///< Number of parts
+  int numvalues; ///< Number of shape attributes
+
+#ifdef SWIG
+  %mutable;
+#endif
+
+  rectObj bounds; ///< Bounding box of shape
+  int type;       ///< MS_SHAPE_POINT, MS_SHAPE_LINE, MS_SHAPE_POLYGON, or
+                  ///< MS_SHAPE_NULL
+  long index;     ///< Feature index within the layer
+  int tileindex;  ///< Index of tiled file for tile-indexed layers
+  int classindex; ///< The class index for features of a classified layer
+  char *text;     ///< Shape annotation
+
+  int scratch;
+  int resultindex; ///< Index within a query result set
+} shapeObj;
+
+typedef lineObj multipointObj;
+
+#ifndef SWIG
+/* attribute primitives */
+typedef struct {
+  char *name;
+  long type;
+  int index;
+  int size;
+  short numdecimals;
+} itemObj;
+#endif
+
+#ifndef SWIG
+typedef struct {
+  int need_geotransform;
+  double rotation_angle;
+  double geotransform[6];    /* Pixel/line to georef. */
+  double invgeotransform[6]; /* georef to pixel/line */
+} geotransformObj;
+#endif
+
+#endif /* MAPPRIMITIVE_H */
diff -pruN 8.0.1-5/src/mapproject.c 8.2.0~beta1-1~exp1/src/mapproject.c
--- 8.0.1-5/src/mapproject.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapproject.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2500 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  projectionObj / PROJ.4 interface.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapproject.h"
+#include "mapthread.h"
+#include <assert.h>
+#include <float.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include "mapaxisorder.h"
+
+#include "cpl_conv.h"
+#include "cpl_string.h"
+#include "ogr_srs_api.h"
+#include "proj_experimental.h"
+
+static char *ms_proj_data = NULL;
+static unsigned ms_proj_data_change_counter = 0;
+
+typedef struct LinkedListOfProjContext LinkedListOfProjContext;
+struct LinkedListOfProjContext {
+  LinkedListOfProjContext *next;
+  projectionContext *context;
+};
+
+static LinkedListOfProjContext *headOfLinkedListOfProjContext = NULL;
+
+static int msTestNeedWrap(pointObj pt1, pointObj pt2, pointObj pt2_geo,
+                          reprojectionObj *reprojector);
+
+static projectionContext *msProjectionContextCreate(void);
+static void msProjectionContextUnref(projectionContext *ctx);
+
+/* Helps considerably for use cases like msautotest/wxs/wms_inspire.map */
+/* which involve a number of layers with same SRS, and a number of exposed */
+/* output SRS */
+#define PJ_CACHE_ENTRY_SIZE 32
+
+typedef struct {
+  char *inStr;
+  char *outStr;
+  PJ *pj;
+} pjCacheEntry;
+
+struct projectionContext {
+  PJ_CONTEXT *proj_ctx;
+  unsigned ms_proj_data_change_counter;
+  int ref_count;
+  pjCacheEntry pj_cache[PJ_CACHE_ENTRY_SIZE];
+  int pj_cache_size;
+};
+
+/************************************************************************/
+/*                  msProjectHasLonWrapOrOver()                         */
+/************************************************************************/
+
+static int msProjectHasLonWrapOrOver(projectionObj *in) {
+  int i;
+  for (i = 0; i < in->numargs; i++) {
+    if (strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 ||
+        strcmp(in->args[i], "+over") == 0 || strcmp(in->args[i], "over") == 0) {
+      return MS_TRUE;
+    }
+  }
+  return MS_FALSE;
+}
+
+static char *getStringFromArgv(int argc, char **args) {
+  int i;
+  int len = 0;
+  for (i = 0; i < argc; i++) {
+    len += strlen(args[i]) + 1;
+  }
+  char *str = msSmallMalloc(len + 1);
+  len = 0;
+  for (i = 0; i < argc; i++) {
+    size_t arglen = strlen(args[i]);
+    memcpy(str + len, args[i], arglen);
+    len += arglen;
+    str[len] = ' ';
+    len++;
+  }
+  str[len] = 0;
+  return str;
+}
+
+/************************************************************************/
+/*                         createNormalizedPJ()                         */
+/************************************************************************/
+
+/* Return to be freed with proj_destroy() if *pbFreePJ = TRUE */
+static PJ *createNormalizedPJ(projectionObj *in, projectionObj *out,
+                              int *pbFreePJ) {
+  if (in->proj == out->proj) {
+    /* Special case to avoid out_str below to cause in_str to become invalid */
+    *pbFreePJ = TRUE;
+    return proj_create(in->proj_ctx->proj_ctx, "+proj=noop");
+  }
+
+  const char *const wkt_options[] = {"MULTILINE=NO", NULL};
+  const char *in_str = msProjectHasLonWrapOrOver(in)
+                           ? proj_as_proj_string(in->proj_ctx->proj_ctx,
+                                                 in->proj, PJ_PROJ_4, NULL)
+                           : proj_as_wkt(in->proj_ctx->proj_ctx, in->proj,
+                                         PJ_WKT2_2018, wkt_options);
+  const char *out_str = msProjectHasLonWrapOrOver(out)
+                            ? proj_as_proj_string(out->proj_ctx->proj_ctx,
+                                                  out->proj, PJ_PROJ_4, NULL)
+                            : proj_as_wkt(out->proj_ctx->proj_ctx, out->proj,
+                                          PJ_WKT2_2018, wkt_options);
+  PJ *pj_raw;
+  PJ *pj_normalized;
+  if (!in_str || !out_str)
+    return NULL;
+  char *in_str_for_cache = getStringFromArgv(in->numargs, in->args);
+  char *out_str_for_cache = getStringFromArgv(out->numargs, out->args);
+
+  if (in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx) {
+    int i;
+    pjCacheEntry *pj_cache = in->proj_ctx->pj_cache;
+    for (i = 0; i < in->proj_ctx->pj_cache_size; i++) {
+      if (strcmp(pj_cache[i].inStr, in_str_for_cache) == 0 &&
+          strcmp(pj_cache[i].outStr, out_str_for_cache) == 0) {
+        PJ *ret = pj_cache[i].pj;
+        if (i != 0) {
+          /* Move entry to top */
+          pjCacheEntry tmp;
+          memcpy(&tmp, &pj_cache[i], sizeof(pjCacheEntry));
+          memmove(&pj_cache[1], &pj_cache[0], i * sizeof(pjCacheEntry));
+          memcpy(&pj_cache[0], &tmp, sizeof(pjCacheEntry));
+        }
+#ifdef notdef
+        fprintf(stderr, "cache hit!\n");
+#endif
+        *pbFreePJ = FALSE;
+        msFree(in_str_for_cache);
+        msFree(out_str_for_cache);
+        return ret;
+      }
+    }
+  }
+
+#ifdef notdef
+  fprintf(stderr, "%s -> %s\n", in_str, out_str);
+  fprintf(stderr, "%p -> %p\n", in->proj_ctx->proj_ctx,
+          out->proj_ctx->proj_ctx);
+  fprintf(stderr, "cache miss!\n");
+#endif
+
+#if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR < 2
+  if (strstr(in_str, "+proj=") && strstr(in_str, "+over") &&
+      strstr(out_str, "+proj=") && strstr(out_str, "+over") &&
+      strlen(in_str) < 400 && strlen(out_str) < 400) {
+    // Fixed per PROJ commit
+    // https://github.com/OSGeo/PROJ/commit/78302efb70eb4b49610cda6a60bf9ce39b82264f
+    // and
+    // https://github.com/OSGeo/PROJ/commit/ae70b26b9cbae85a38d5b26533ba06da0ea13940
+    // Fix for wcs_get_capabilities_tileindexmixedsrs_26711.xml and
+    // wcs_20_getcov_bands_name_new_reproject.dat
+    char szPipeline[1024];
+    strcpy(szPipeline, "+proj=pipeline");
+    if (msProjIsGeographicCRS(in)) {
+      strcat(szPipeline, " +step +proj=unitconvert +xy_in=deg +xy_out=rad");
+    }
+    strcat(szPipeline, " +step +inv ");
+    strcat(szPipeline, in_str);
+    strcat(szPipeline, " +step ");
+    strcat(szPipeline, out_str);
+    if (msProjIsGeographicCRS(out)) {
+      strcat(szPipeline, " +step +proj=unitconvert +xy_in=rad +xy_out=deg");
+    }
+    /* We do not want datum=NAD83 to imply a transformation with towgs84=0,0,0
+     */
+    {
+      char *ptr = szPipeline;
+      while (1) {
+        ptr = strstr(ptr, " +datum=NAD83");
+        if (!ptr)
+          break;
+        memcpy(ptr, " +ellps=GRS80", 13);
+      }
+    }
+
+    /* Remove +nadgrids=@null as it doesn't work if going outside of [-180,180]
+     */
+    /* Fixed per
+     * https://github.com/OSGeo/PROJ/commit/10a30bb539be1afb25952b19af8bbe72e1b13b56
+     */
+    {
+      char *ptr = strstr(szPipeline, " +nadgrids=@null");
+      if (ptr)
+        memcpy(ptr, "                ", 16);
+    }
+
+    pj_normalized = proj_create(in->proj_ctx->proj_ctx, szPipeline);
+  } else
+#endif
+  {
+#if PROJ_VERSION_MAJOR > 6 ||                                                  \
+    (PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR >= 2)
+    pj_raw = proj_create_crs_to_crs_from_pj(in->proj_ctx->proj_ctx, in->proj,
+                                            out->proj, NULL, NULL);
+#else
+    pj_raw =
+        proj_create_crs_to_crs(in->proj_ctx->proj_ctx, in_str, out_str, NULL);
+#endif
+    if (!pj_raw) {
+      msFree(in_str_for_cache);
+      msFree(out_str_for_cache);
+      return NULL;
+    }
+    pj_normalized =
+        proj_normalize_for_visualization(in->proj_ctx->proj_ctx, pj_raw);
+    proj_destroy(pj_raw);
+  }
+  if (!pj_normalized) {
+    msFree(in_str_for_cache);
+    msFree(out_str_for_cache);
+    return NULL;
+  }
+
+  if (in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx) {
+    /* Insert entry into cache */
+    int i;
+    pjCacheEntry *pj_cache = in->proj_ctx->pj_cache;
+    if (in->proj_ctx->pj_cache_size < PJ_CACHE_ENTRY_SIZE) {
+      i = in->proj_ctx->pj_cache_size;
+      assert(pj_cache[i].inStr == NULL);
+      in->proj_ctx->pj_cache_size++;
+    } else {
+      i = 0;
+      /* Evict oldest entry */
+      msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].inStr);
+      msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].outStr);
+      proj_destroy(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].pj);
+      memmove(&pj_cache[1], &pj_cache[0],
+              (PJ_CACHE_ENTRY_SIZE - 1) * sizeof(pjCacheEntry));
+    }
+    pj_cache[i].inStr = msStrdup(in_str_for_cache);
+    pj_cache[i].outStr = msStrdup(out_str_for_cache);
+    pj_cache[i].pj = pj_normalized;
+    *pbFreePJ = FALSE;
+  } else {
+    *pbFreePJ = TRUE;
+  }
+
+  msFree(in_str_for_cache);
+  msFree(out_str_for_cache);
+
+  return pj_normalized;
+}
+
+/************************************************************************/
+/*                        getBaseGeographicCRS()                        */
+/************************************************************************/
+
+/* Return to be freed with proj_destroy() */
+static PJ *getBaseGeographicCRS(projectionObj *in) {
+  PJ_CONTEXT *ctxt;
+  PJ *geod_crs;
+  PJ *datum;
+  PJ *cs;
+  PJ *geog_crs;
+  assert(in && in->proj);
+  ctxt = in->proj_ctx->proj_ctx;
+  geod_crs = proj_crs_get_geodetic_crs(ctxt, in->proj);
+  if (geod_crs == NULL)
+    return NULL;
+#if PROJ_VERSION_MAJOR >= 8 ||                                                 \
+    (PROJ_VERSION_MAJOR == 7 && PROJ_VERSION_MINOR >= 2)
+  datum = proj_crs_get_datum_forced(ctxt, geod_crs);
+#else
+  datum = proj_crs_get_datum(ctxt, geod_crs);
+#endif
+  cs = proj_create_ellipsoidal_2D_cs(ctxt, PJ_ELLPS2D_LONGITUDE_LATITUDE, NULL,
+                                     0);
+  geog_crs = proj_create_geographic_crs_from_datum(ctxt, NULL, datum, cs);
+  proj_destroy(geod_crs);
+  proj_destroy(datum);
+  proj_destroy(cs);
+  if (proj_get_type(in->proj) == PJ_TYPE_BOUND_CRS) {
+    PJ *hub_crs;
+    PJ *transf;
+    PJ *ret;
+    hub_crs = proj_get_target_crs(ctxt, in->proj);
+    transf = proj_crs_get_coordoperation(ctxt, in->proj);
+    ret = proj_crs_create_bound_crs(ctxt, geog_crs, hub_crs, transf);
+    proj_destroy(geog_crs);
+    geog_crs = ret;
+    proj_destroy(hub_crs);
+    proj_destroy(transf);
+  }
+
+  return geog_crs;
+}
+
+/************************************************************************/
+/*                          msProjErrorLogger()                         */
+/************************************************************************/
+
+static void msProjErrorLogger(void *user_data, int level, const char *message) {
+  (void)user_data;
+  if (level == PJ_LOG_ERROR && msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_VV) {
+    msDebug("PROJ: Error: %s\n", message);
+  } else if (level == PJ_LOG_DEBUG) {
+    msDebug("PROJ: Debug: %s\n", message);
+  }
+}
+
+/************************************************************************/
+/*                        msProjectionContextCreate()                   */
+/************************************************************************/
+
+projectionContext *msProjectionContextCreate(void) {
+  projectionContext *ctx =
+      (projectionContext *)msSmallCalloc(1, sizeof(projectionContext));
+  ctx->proj_ctx = proj_context_create();
+  if (ctx->proj_ctx == NULL) {
+    msFree(ctx);
+    return NULL;
+  }
+  ctx->ref_count = 1;
+  proj_context_use_proj4_init_rules(ctx->proj_ctx, TRUE);
+  proj_log_func(ctx->proj_ctx, NULL, msProjErrorLogger);
+  return ctx;
+}
+
+/************************************************************************/
+/*                        msProjectionContextUnref()                    */
+/************************************************************************/
+
+void msProjectionContextUnref(projectionContext *ctx) {
+  if (!ctx)
+    return;
+  --ctx->ref_count;
+  if (ctx->ref_count == 0) {
+    int i;
+    for (i = 0; i < ctx->pj_cache_size; i++) {
+      msFree(ctx->pj_cache[i].inStr);
+      msFree(ctx->pj_cache[i].outStr);
+      proj_destroy(ctx->pj_cache[i].pj);
+    }
+    proj_context_destroy(ctx->proj_ctx);
+    msFree(ctx);
+  }
+}
+
+/************************************************************************/
+/*                        msProjectCreateReprojector()                  */
+/************************************************************************/
+
+/* The pointed objects need to remain valid during the lifetime of the
+ * reprojector, as only their pointer is stored.
+ *
+ * If the *content* of in and/or out is changed, then the reprojector is
+ * no longer valid. This can be detected with msProjectIsReprojectorStillValid()
+ */
+reprojectionObj *msProjectCreateReprojector(projectionObj *in,
+                                            projectionObj *out) {
+  reprojectionObj *obj =
+      (reprojectionObj *)msSmallCalloc(1, sizeof(reprojectionObj));
+  obj->in = in;
+  obj->out = out;
+  obj->generation_number_in = in ? in->generation_number : 0;
+  obj->generation_number_out = out ? out->generation_number : 0;
+  obj->lineCuttingCase = LINE_CUTTING_UNKNOWN;
+
+  /* -------------------------------------------------------------------- */
+  /*      If the source and destination are simple and equal, then do     */
+  /*      nothing.                                                        */
+  /* -------------------------------------------------------------------- */
+  if (in && in->numargs == 1 && out && out->numargs == 1 &&
+      strcmp(in->args[0], out->args[0]) == 0) {
+    /* do nothing, no transformation required */
+  }
+  /* -------------------------------------------------------------------- */
+  /*      If we have a fully defined input coordinate system and          */
+  /*      output coordinate system, then we will use createNormalizedPJ   */
+  /* -------------------------------------------------------------------- */
+  else if (in && in->proj && out && out->proj) {
+    PJ *pj = createNormalizedPJ(in, out, &(obj->bFreePJ));
+    if (!pj) {
+      msFree(obj);
+      return NULL;
+    }
+    obj->pj = pj;
+  }
+
+  /* nothing to do if the other coordinate system is also lat/long */
+  else if ((in == NULL || in->proj == NULL) &&
+           (out == NULL || out->proj == NULL || msProjIsGeographicCRS(out))) {
+    /* do nothing */
+  } else if (out == NULL && in != NULL && msProjIsGeographicCRS(in)) {
+    /* do nothing */
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise we assume that the NULL projectionObj is supposed to be */
+  /*      lat/long in the same datum as the other projectionObj.  This    */
+  /*      is essentially a backwards compatibility mode.                  */
+  /* -------------------------------------------------------------------- */
+  else {
+    PJ *pj = NULL;
+
+    if ((in == NULL || in->proj == NULL) && out &&
+        out->proj) { /* input coordinates are lat/lon */
+      PJ *source_crs = getBaseGeographicCRS(out);
+      projectionObj in_modified;
+      memset(&in_modified, 0, sizeof(in_modified));
+
+      in_modified.proj_ctx = out->proj_ctx;
+      in_modified.proj = source_crs;
+      pj = createNormalizedPJ(&in_modified, out, &(obj->bFreePJ));
+      proj_destroy(source_crs);
+    } else if (/* (out==NULL || out->proj==NULL) && */ in && in->proj) {
+      PJ *target_crs = getBaseGeographicCRS(in);
+      projectionObj out_modified;
+      memset(&out_modified, 0, sizeof(out_modified));
+
+      out_modified.proj_ctx = in->proj_ctx;
+      out_modified.proj = target_crs;
+      pj = createNormalizedPJ(in, &out_modified, &(obj->bFreePJ));
+      proj_destroy(target_crs);
+    }
+    if (!pj) {
+      msFree(obj);
+      return NULL;
+    }
+    obj->pj = pj;
+  }
+
+  return obj;
+}
+
+/************************************************************************/
+/*                      msProjectDestroyReprojector()                   */
+/************************************************************************/
+
+void msProjectDestroyReprojector(reprojectionObj *reprojector) {
+  if (!reprojector)
+    return;
+  if (reprojector->bFreePJ)
+    proj_destroy(reprojector->pj);
+  msFreeShape(&(reprojector->splitShape));
+  msFree(reprojector);
+}
+
+/************************************************************************/
+/*                       msProjectTransformPoints()                     */
+/************************************************************************/
+
+int msProjectTransformPoints(reprojectionObj *reprojector, int npoints,
+                             double *x, double *y) {
+  proj_trans_generic(reprojector->pj, PJ_FWD, x, sizeof(double), npoints, y,
+                     sizeof(double), npoints, NULL, 0, 0, NULL, 0, 0);
+  return MS_SUCCESS;
+}
+
+/*
+** Initialize, load and free a projectionObj structure
+*/
+int msInitProjection(projectionObj *p) {
+  p->gt.need_geotransform = MS_FALSE;
+  p->numargs = 0;
+  p->args = NULL;
+  p->wellknownprojection = wkp_none;
+  p->proj = NULL;
+  p->args = (char **)malloc(MS_MAXPROJARGS * sizeof(char *));
+  MS_CHECK_ALLOC(p->args, MS_MAXPROJARGS * sizeof(char *), -1);
+  p->proj_ctx = NULL;
+  p->generation_number = 0;
+  return (0);
+}
+
+void msFreeProjection(projectionObj *p) {
+  proj_destroy(p->proj);
+  p->proj = NULL;
+  msProjectionContextUnref(p->proj_ctx);
+  p->proj_ctx = NULL;
+
+  p->gt.need_geotransform = MS_FALSE;
+  p->wellknownprojection = wkp_none;
+  msFreeCharArray(p->args, p->numargs);
+  p->args = NULL;
+  p->numargs = 0;
+  p->generation_number++;
+}
+
+void msFreeProjectionExceptContext(projectionObj *p) {
+  projectionContext *ctx = p->proj_ctx;
+  p->proj_ctx = NULL;
+  msFreeProjection(p);
+  p->proj_ctx = ctx;
+}
+
+/************************************************************************/
+/*                 msProjectionInheritContextFrom()                     */
+/************************************************************************/
+
+void msProjectionInheritContextFrom(projectionObj *pDst,
+                                    const projectionObj *pSrc) {
+  if (pDst->proj_ctx == NULL && pSrc->proj_ctx != NULL) {
+    pDst->proj_ctx = pSrc->proj_ctx;
+    pDst->proj_ctx->ref_count++;
+  }
+}
+
+/************************************************************************/
+/*                      msProjectionSetContext()                        */
+/************************************************************************/
+
+void msProjectionSetContext(projectionObj *p, projectionContext *ctx) {
+  if (p->proj_ctx == NULL && ctx != NULL) {
+    p->proj_ctx = ctx;
+    p->proj_ctx->ref_count++;
+  }
+}
+
+/*
+** Handle OGC WMS/WFS AUTO projection in the format:
+**    "AUTO:proj_id,units_id,lon0,lat0"
+*/
+
+static int _msProcessAutoProjection(projectionObj *p) {
+  char **args;
+  int numargs, nProjId, nUnitsId, nZone;
+  double dLat0, dLon0;
+  const char *pszUnits = "m";
+  char szProjBuf[512] = "";
+
+  /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
+  args = msStringSplit(p->args[0], ',', &numargs);
+  if (numargs != 4 || (strncasecmp(args[0], "AUTO:", 5) != 0 &&
+                       strncasecmp(args[0], "AUTO2:", 6) != 0)) {
+    msSetError(MS_PROJERR,
+               "WMS/WFS AUTO/AUTO2 PROJECTION must be in the format "
+               "'AUTO:proj_id,units_id,lon0,lat0' or "
+               "'AUTO2:crs_id,factor,lon0,lat0'(got '%s').\n",
+               "_msProcessAutoProjection()", p->args[0]);
+    msFreeCharArray(args, numargs);
+    return -1;
+  }
+
+  if (strncasecmp(args[0], "AUTO:", 5) == 0)
+    nProjId = atoi(args[0] + 5);
+  else
+    nProjId = atoi(args[0] + 6);
+
+  nUnitsId = atoi(args[1]);
+  dLon0 = atof(args[2]);
+  dLat0 = atof(args[3]);
+
+  /*There is no unit parameter for AUTO2. The 2nd parameter is
+   factor. Set the units to always be meter*/
+  if (strncasecmp(args[0], "AUTO2:", 6) == 0)
+    nUnitsId = 9001;
+
+  msFreeCharArray(args, numargs);
+
+  /* Handle EPSG Units.  Only meters for now. */
+  switch (nUnitsId) {
+  case 9001: /* Meters */
+    pszUnits = "m";
+    break;
+  default:
+    msSetError(MS_PROJERR,
+               "WMS/WFS AUTO PROJECTION: EPSG Units %d not supported.\n",
+               "_msProcessAutoProjection()", nUnitsId);
+    return -1;
+  }
+
+  /* Build PROJ4 definition.
+   * This is based on the definitions found in annex E of the WMS 1.1.1
+   * spec and online at http://www.digitalearth.org/wmt/auto.html
+   * The conversion from the original WKT definitions to PROJ4 format was
+   * done using the MapScript setWKTProjection() function (based on OGR).
+   */
+  switch (nProjId) {
+  case 42001: /** WGS 84 / Auto UTM **/
+    nZone = (int)floor((dLon0 + 180.0) / 6.0) + 1;
+    sprintf(szProjBuf,
+            "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
+            "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            -183.0 + nZone * 6.0, (dLat0 >= 0.0) ? 0.0 : 10000000.0, pszUnits);
+    break;
+  case 42002: /** WGS 84 / Auto Tr. Mercator **/
+    sprintf(szProjBuf,
+            "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
+            "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            dLon0, (dLat0 >= 0.0) ? 0.0 : 10000000.0, pszUnits);
+    break;
+  case 42003: /** WGS 84 / Auto Orthographic **/
+    sprintf(szProjBuf,
+            "+proj=ortho+lon_0=%.16g+lat_0=%.16g+x_0=0+y_0=0"
+            "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            dLon0, dLat0, pszUnits);
+    break;
+  case 42004: /** WGS 84 / Auto Equirectangular **/
+    /* Note that we have to pass lon_0 as lon_ts for this one to */
+    /* work.  Either a PROJ4 bug or a PROJ4 documentation issue. */
+    sprintf(szProjBuf,
+            "+proj=eqc+lon_ts=%.16g+lat_ts=%.16g+x_0=0+y_0=0"
+            "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            dLon0, dLat0, pszUnits);
+    break;
+  case 42005: /** WGS 84 / Auto Mollweide **/
+    sprintf(szProjBuf,
+            "+proj=moll+lon_0=%.16g+x_0=0+y_0=0+ellps=WGS84"
+            "+datum=WGS84+units=%s+type=crs",
+            dLon0, pszUnits);
+    break;
+  default:
+    msSetError(MS_PROJERR, "WMS/WFS AUTO PROJECTION %d not supported.\n",
+               "_msProcessAutoProjection()", nProjId);
+    return -1;
+  }
+
+  /* msDebug("%s = %s\n", p->args[0], szProjBuf); */
+
+  /* OK, pass the definition to pj_init() */
+  args = msStringSplit(szProjBuf, '+', &numargs);
+
+  if (!(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, numargs, args))) {
+    int l_pj_errno = proj_context_errno(p->proj_ctx->proj_ctx);
+    msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
+               "msProcessProjection()", proj_errno_string(l_pj_errno),
+               szProjBuf);
+    msFreeCharArray(args, numargs);
+    return (-1);
+  }
+
+  msFreeCharArray(args, numargs);
+
+  return (0);
+}
+
+int msProcessProjection(projectionObj *p) {
+  assert(p->proj == NULL);
+
+  p->generation_number++;
+
+  if (strcasecmp(p->args[0], "GEOGRAPHIC") == 0) {
+    msSetError(MS_PROJERR,
+               "PROJECTION 'GEOGRAPHIC' no longer supported.\n"
+               "Provide explicit definition.\n"
+               "ie. proj=latlong\n"
+               "    ellps=clrk66\n",
+               "msProcessProjection()");
+    return (-1);
+  }
+
+  if (strcasecmp(p->args[0], "AUTO") == 0) {
+    p->proj = NULL;
+    return 0;
+  }
+
+  if (p->proj_ctx == NULL) {
+    p->proj_ctx = msProjectionContextCreate();
+    if (p->proj_ctx == NULL) {
+      return -1;
+    }
+  }
+  if (p->proj_ctx->ms_proj_data_change_counter != ms_proj_data_change_counter) {
+    msAcquireLock(TLOCK_PROJ);
+    p->proj_ctx->ms_proj_data_change_counter = ms_proj_data_change_counter;
+    {
+      if (ms_proj_data) {
+        int num_tokens = 0;
+#ifdef _WIN32
+        char sep = ';';
+#else
+        char sep = ':';
+#endif
+        char **paths = msStringSplit(ms_proj_data, sep, &num_tokens);
+        proj_context_set_search_paths(p->proj_ctx->proj_ctx, num_tokens,
+                                      (const char *const *)paths);
+        msFreeCharArray(paths, num_tokens);
+      } else {
+        proj_context_set_search_paths(p->proj_ctx->proj_ctx, 0, NULL);
+      }
+    }
+    msReleaseLock(TLOCK_PROJ);
+  }
+
+  if (strncasecmp(p->args[0], "AUTO:", 5) == 0 ||
+      strncasecmp(p->args[0], "AUTO2:", 6) == 0) {
+    /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
+    /*WMS 1.3.0: AUTO2:auto_crs_id,factor,lon0,lat0*/
+    return _msProcessAutoProjection(p);
+  }
+
+  if (p->numargs == 1 && strncmp(p->args[0], "init=", 5) != 0) {
+    /* Deal e.g. with EPSG:XXXX or ESRI:XXXX */
+    if (!(p->proj =
+              proj_create_argv(p->proj_ctx->proj_ctx, p->numargs, p->args))) {
+      int l_pj_errno = proj_context_errno(p->proj_ctx->proj_ctx);
+      msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
+                 "msProcessProjection()", proj_errno_string(l_pj_errno),
+                 p->args[0]);
+      return (-1);
+    }
+  } else {
+    char **args = (char **)msSmallMalloc(sizeof(char *) * (p->numargs + 1));
+    memcpy(args, p->args, sizeof(char *) * p->numargs);
+
+#if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR < 2
+    /* PROJ lookups are faster with EPSG in uppercase. Fixed in PROJ 6.2 */
+    /* Do that only for those versions, as it can create confusion if using */
+    /* a real old-style 'epsg' file... */
+    char szTemp[24];
+    if (p->numargs &&
+        strncmp(args[0], "init=epsg:", strlen("init=epsg:")) == 0 &&
+        strlen(args[0]) < 24) {
+      strcpy(szTemp, "init=EPSG:");
+      strcat(szTemp, args[0] + strlen("init=epsg:"));
+      args[0] = szTemp;
+    }
+#endif
+
+    args[p->numargs] = (char *)"type=crs";
+#if 0
+      for( int i = 0; i <  p->numargs + 1; i++ )
+          fprintf(stderr, "%s ", args[i]);
+      fprintf(stderr, "\n");
+#endif
+    if (!(p->proj =
+              proj_create_argv(p->proj_ctx->proj_ctx, p->numargs + 1, args))) {
+      int l_pj_errno = proj_context_errno(p->proj_ctx->proj_ctx);
+      if (p->numargs > 1) {
+        msSetError(MS_PROJERR, "proj error \"%s\" for \"%s:%s\"",
+                   "msProcessProjection()", proj_errno_string(l_pj_errno),
+                   p->args[0], p->args[1]);
+      } else {
+        msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
+                   "msProcessProjection()", proj_errno_string(l_pj_errno),
+                   p->args[0]);
+      }
+      free(args);
+      return (-1);
+    }
+    free(args);
+  }
+
+#ifdef USE_PROJ_FASTPATHS
+  if (strcasestr(p->args[0], "epsg:4326")) {
+    p->wellknownprojection = wkp_lonlat;
+  } else if (strcasestr(p->args[0], "epsg:3857")) {
+    p->wellknownprojection = wkp_gmerc;
+  } else {
+    p->wellknownprojection = wkp_none;
+  }
+#endif
+
+  return (0);
+}
+
+/************************************************************************/
+/*                           int msIsAxisInverted                       */
+/*      Check to see if we should invert the axis.                       */
+/*                                                                      */
+/************************************************************************/
+int msIsAxisInverted(int epsg_code) {
+  if (epsg_code < 0)
+    return MS_FALSE;
+  const unsigned int row = epsg_code / 8;
+  const unsigned char index = epsg_code % 8;
+
+  /*check the static table*/
+  if ((row < sizeof(axisOrientationEpsgCodes)) &&
+      (axisOrientationEpsgCodes[row] & (1 << index)))
+    return MS_TRUE;
+  else
+    return MS_FALSE;
+}
+
+/************************************************************************/
+/*                           msProjectPoint()                           */
+/************************************************************************/
+int msProjectPoint(projectionObj *in, projectionObj *out, pointObj *point) {
+  int ret;
+  reprojectionObj *reprojector = msProjectCreateReprojector(in, out);
+  if (!reprojector)
+    return MS_FAILURE;
+  ret = msProjectPointEx(reprojector, point);
+  msProjectDestroyReprojector(reprojector);
+  return ret;
+}
+
+/************************************************************************/
+/*                           msProjectPointEx()                         */
+/************************************************************************/
+int msProjectPointEx(reprojectionObj *reprojector, pointObj *point) {
+  projectionObj *in = reprojector->in;
+  projectionObj *out = reprojector->out;
+
+  if (in && in->gt.need_geotransform) {
+    double x_out, y_out;
+
+    x_out = in->gt.geotransform[0] + in->gt.geotransform[1] * point->x +
+            in->gt.geotransform[2] * point->y;
+    y_out = in->gt.geotransform[3] + in->gt.geotransform[4] * point->x +
+            in->gt.geotransform[5] * point->y;
+
+    point->x = x_out;
+    point->y = y_out;
+  }
+
+  if (reprojector->pj) {
+    PJ_COORD c;
+    c.xyzt.x = point->x;
+    c.xyzt.y = point->y;
+    c.xyzt.z = 0;
+    c.xyzt.t = 0;
+    c = proj_trans(reprojector->pj, PJ_FWD, c);
+    if (c.xyzt.x == HUGE_VAL || c.xyzt.y == HUGE_VAL) {
+      return MS_FAILURE;
+    }
+    point->x = c.xyzt.x;
+    point->y = c.xyzt.y;
+  }
+
+  if (out && out->gt.need_geotransform) {
+    double x_out, y_out;
+
+    x_out = out->gt.invgeotransform[0] + out->gt.invgeotransform[1] * point->x +
+            out->gt.invgeotransform[2] * point->y;
+    y_out = out->gt.invgeotransform[3] + out->gt.invgeotransform[4] * point->x +
+            out->gt.invgeotransform[5] * point->y;
+
+    point->x = x_out;
+    point->y = y_out;
+  }
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                         msProjectGrowRect()                          */
+/************************************************************************/
+static void msProjectGrowRect(reprojectionObj *reprojector, rectObj *prj_rect,
+                              pointObj *prj_point, int *failure)
+
+{
+  if (msProjectPointEx(reprojector, prj_point) == MS_SUCCESS) {
+    prj_rect->miny = MS_MIN(prj_rect->miny, prj_point->y);
+    prj_rect->maxy = MS_MAX(prj_rect->maxy, prj_point->y);
+    prj_rect->minx = MS_MIN(prj_rect->minx, prj_point->x);
+    prj_rect->maxx = MS_MAX(prj_rect->maxx, prj_point->x);
+  } else
+    (*failure)++;
+}
+
+/************************************************************************/
+/*                          msProjectSegment()                          */
+/*                                                                      */
+/*      Interpolate along a line segment for which one end              */
+/*      reprojects and the other end does not.  Finds the horizon.      */
+/************************************************************************/
+static int msProjectSegment(reprojectionObj *reprojector, pointObj *start,
+                            pointObj *end)
+
+{
+  pointObj testPoint, subStart, subEnd;
+
+  /* -------------------------------------------------------------------- */
+  /*      Without loss of generality we assume the first point            */
+  /*      reprojects, and the second doesn't.  If that is not the case    */
+  /*      then re-call with the points reversed.                          */
+  /* -------------------------------------------------------------------- */
+  testPoint = *start;
+  if (msProjectPointEx(reprojector, &testPoint) == MS_FAILURE) {
+    testPoint = *end;
+    if (msProjectPointEx(reprojector, &testPoint) == MS_FAILURE)
+      return MS_FAILURE;
+    else
+      return msProjectSegment(reprojector, end, start);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      We will apply a binary search till we are within out            */
+  /*      tolerance.                                                      */
+  /* -------------------------------------------------------------------- */
+  subStart = *start;
+  subEnd = *end;
+
+#define TOLERANCE 0.01
+
+  while (fabs(subStart.x - subEnd.x) + fabs(subStart.y - subEnd.y) >
+         TOLERANCE) {
+    pointObj midPoint = {0};
+
+    midPoint.x = (subStart.x + subEnd.x) * 0.5;
+    midPoint.y = (subStart.y + subEnd.y) * 0.5;
+
+    testPoint = midPoint;
+
+    if (msProjectPointEx(reprojector, &testPoint) == MS_FAILURE) {
+      if (midPoint.x == subEnd.x && midPoint.y == subEnd.y)
+        return MS_FAILURE; /* break infinite loop */
+
+      subEnd = midPoint;
+    } else {
+      if (midPoint.x == subStart.x && midPoint.y == subStart.y)
+        return MS_FAILURE; /* break infinite loop */
+
+      subStart = midPoint;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Now reproject the end points and return.                        */
+  /* -------------------------------------------------------------------- */
+  *end = subStart;
+
+  if (msProjectPointEx(reprojector, end) == MS_FAILURE ||
+      msProjectPointEx(reprojector, start) == MS_FAILURE)
+    return MS_FAILURE;
+  else
+    return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msProjectGetLineCuttingCase()                      */
+/************************************************************************/
+
+/* Detect projecting from north polar stereographic to longlat or EPSG:3857 */
+/* or from lonlat lon_wrap = 0 */
+#ifdef USE_GEOS
+static msLineCuttingCase
+msProjectGetLineCuttingCase(reprojectionObj *reprojector) {
+  if (reprojector->lineCuttingCase != LINE_CUTTING_UNKNOWN)
+    return reprojector->lineCuttingCase;
+
+  projectionObj *in = reprojector->in;
+  projectionObj *out = reprojector->out;
+  const double EPS = 1e-10;
+
+  if (!in->gt.need_geotransform && msProjIsGeographicCRS(in)) {
+    int i;
+    for (i = 0; i < in->numargs; i++) {
+      if (strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 &&
+          atof(in->args[i] + strlen("lon_wrap=")) == 0.0) {
+        reprojector->lineCuttingCase = LINE_CUTTING_FROM_LONGLAT_WRAP0;
+
+        msInitShape(&(reprojector->splitShape));
+        reprojector->splitShape.type = MS_SHAPE_POLYGON;
+        int j;
+        for (j = -1; j <= 1; j += 2) {
+          const double x = j * 180;
+          pointObj p = {0}; // initialize
+          lineObj newLine = {0, NULL};
+          p.x = x - EPS;
+          p.y = 90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x + EPS;
+          p.y = 90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x + EPS;
+          p.y = -90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x - EPS;
+          p.y = -90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x - EPS;
+          p.y = 90;
+          msAddPointToLine(&newLine, &p);
+          msAddLineDirectly(&(reprojector->splitShape), &newLine);
+        }
+
+        return reprojector->lineCuttingCase;
+      }
+    }
+  }
+
+  if (!(!in->gt.need_geotransform && !msProjIsGeographicCRS(in) &&
+        (msProjIsGeographicCRS(out) ||
+         (out->numargs == 1 && strcmp(out->args[0], "init=epsg:3857") == 0)))) {
+    reprojector->lineCuttingCase = LINE_CUTTING_NONE;
+    return reprojector->lineCuttingCase;
+  }
+
+  int srcIsPolar;
+  double extremeLongEasting;
+  if (msProjIsGeographicCRS(out)) {
+    pointObj p;
+    double gt3 = out->gt.need_geotransform ? out->gt.geotransform[3] : 0.0;
+    double gt4 = out->gt.need_geotransform ? out->gt.geotransform[4] : 0.0;
+    double gt5 = out->gt.need_geotransform ? out->gt.geotransform[5] : 1.0;
+    p.x = 0.0;
+    p.y = 0.0;
+    srcIsPolar = msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
+                 fabs(gt3 + p.x * gt4 + p.y * gt5 - 90) < 1e-8;
+    extremeLongEasting = 180;
+  } else {
+    pointObj p1;
+    pointObj p2;
+    double gt1 = out->gt.need_geotransform ? out->gt.geotransform[1] : 1.0;
+    p1.x = 0.0;
+    p1.y = -0.1;
+    p2.x = 0.0;
+    p2.y = 0.1;
+    srcIsPolar = msProjectPointEx(reprojector, &p1) == MS_SUCCESS &&
+                 msProjectPointEx(reprojector, &p2) == MS_SUCCESS &&
+                 fabs((p1.x - p2.x) * gt1) > 20e6;
+    extremeLongEasting = 20037508.3427892;
+  }
+  if (!srcIsPolar) {
+    reprojector->lineCuttingCase = LINE_CUTTING_NONE;
+    return reprojector->lineCuttingCase;
+  }
+
+  pointObj p = {0}; // initialize
+  double invgt0 = out->gt.need_geotransform ? out->gt.invgeotransform[0] : 0.0;
+  double invgt1 = out->gt.need_geotransform ? out->gt.invgeotransform[1] : 1.0;
+  double invgt3 = out->gt.need_geotransform ? out->gt.invgeotransform[3] : 0.0;
+  double invgt4 = out->gt.need_geotransform ? out->gt.invgeotransform[4] : 0.0;
+
+  lineObj newLine = {0, NULL};
+
+  p.x = invgt0 + -extremeLongEasting * (1 - EPS) * invgt1;
+  p.y = invgt3 + -extremeLongEasting * (1 - EPS) * invgt4;
+  /* coverity[swapped_arguments] */
+  msProjectPoint(out, in, &p);
+  pointObj first = p;
+  msAddPointToLine(&newLine, &p);
+
+  p.x = invgt0 + extremeLongEasting * (1 - EPS) * invgt1;
+  p.y = invgt3 + extremeLongEasting * (1 - EPS) * invgt4;
+  /* coverity[swapped_arguments] */
+  msProjectPoint(out, in, &p);
+  msAddPointToLine(&newLine, &p);
+
+  p.x = 0;
+  p.y = 0;
+  msAddPointToLine(&newLine, &p);
+
+  msAddPointToLine(&newLine, &first);
+
+  msInitShape(&(reprojector->splitShape));
+  reprojector->splitShape.type = MS_SHAPE_POLYGON;
+  msAddLineDirectly(&(reprojector->splitShape), &newLine);
+
+  reprojector->lineCuttingCase = LINE_CUTTING_FROM_POLAR;
+  return reprojector->lineCuttingCase;
+}
+#endif
+
+/************************************************************************/
+/*                msProjectIsReprojectorStillValid()                    */
+/************************************************************************/
+
+int msProjectIsReprojectorStillValid(reprojectionObj *reprojector) {
+  if (reprojector->in &&
+      reprojector->in->generation_number != reprojector->generation_number_in)
+    return MS_FALSE;
+  if (reprojector->out &&
+      reprojector->out->generation_number != reprojector->generation_number_out)
+    return MS_FALSE;
+  return MS_TRUE;
+}
+
+/************************************************************************/
+/*                         msProjectShapeLine()                         */
+/*                                                                      */
+/*      Reproject a single linestring, potentially splitting into       */
+/*      more than one line string if there are over the horizon         */
+/*      portions.                                                       */
+/*                                                                      */
+/*      For polygons, no splitting takes place, but over the horizon    */
+/*      points are clipped, and one segment is run from the fall        */
+/*      over the horizon point to the come back over the horizon point. */
+/************************************************************************/
+
+static int msProjectShapeLine(reprojectionObj *reprojector, shapeObj *shape,
+                              int line_index)
+
+{
+  int i;
+  pointObj lastPoint, thisPoint, wrkPoint;
+  lineObj *line = shape->line + line_index;
+  lineObj *line_out = line;
+  int valid_flag = 0; /* 1=true, -1=false, 0=unknown */
+  int numpoints_in = line->numpoints;
+  int line_alloc = numpoints_in;
+  int wrap_test;
+  projectionObj *in = reprojector->in;
+  projectionObj *out = reprojector->out;
+
+#ifdef USE_PROJ_FASTPATHS
+#define MAXEXTENT 20037508.34
+#define M_PIby360 .0087266462599716479
+#define MAXEXTENTby180 111319.4907777777777777777
+#define p_x line->point[i].x
+#define p_y line->point[i].y
+  if (in->wellknownprojection == wkp_lonlat &&
+      out->wellknownprojection == wkp_gmerc) {
+    for (i = line->numpoints - 1; i >= 0; i--) {
+      p_x *= MAXEXTENTby180;
+      p_y = log(tan((90 + p_y) * M_PIby360)) * MS_RAD_TO_DEG;
+      p_y *= MAXEXTENTby180;
+      if (p_x > MAXEXTENT)
+        p_x = MAXEXTENT;
+      if (p_x < -MAXEXTENT)
+        p_x = -MAXEXTENT;
+      if (p_y > MAXEXTENT)
+        p_y = MAXEXTENT;
+      if (p_y < -MAXEXTENT)
+        p_y = -MAXEXTENT;
+    }
+    return MS_SUCCESS;
+  }
+  if (in->wellknownprojection == wkp_gmerc &&
+      out->wellknownprojection == wkp_lonlat) {
+    for (i = line->numpoints - 1; i >= 0; i--) {
+      if (p_x > MAXEXTENT)
+        p_x = MAXEXTENT;
+      else if (p_x < -MAXEXTENT)
+        p_x = -MAXEXTENT;
+      if (p_y > MAXEXTENT)
+        p_y = MAXEXTENT;
+      else if (p_y < -MAXEXTENT)
+        p_y = -MAXEXTENT;
+      p_x = (p_x / MAXEXTENT) * 180;
+      p_y = (p_y / MAXEXTENT) * 180;
+      p_y = MS_RAD_TO_DEG * (2 * atan(exp(p_y * MS_DEG_TO_RAD)) - MS_PI2);
+    }
+    msComputeBounds(shape); /* fixes bug 1586 */
+    return MS_SUCCESS;
+  }
+#undef p_x
+#undef p_y
+#endif
+
+#ifdef USE_GEOS
+  int use_splitShape = MS_FALSE;
+  int use_splitShape_check_intersects = MS_FALSE;
+  if (shape->type == MS_SHAPE_LINE &&
+      msProjectGetLineCuttingCase(reprojector) == LINE_CUTTING_FROM_POLAR) {
+    use_splitShape = MS_TRUE;
+    use_splitShape_check_intersects = MS_TRUE;
+  } else if (shape->type == MS_SHAPE_LINE &&
+             msProjectGetLineCuttingCase(reprojector) ==
+                 LINE_CUTTING_FROM_LONGLAT_WRAP0) {
+    for (i = 0; i < numpoints_in; i++) {
+      if (fabs(line->point[i].x) > 180) {
+        use_splitShape = MS_TRUE;
+        break;
+      }
+    }
+  }
+
+  if (use_splitShape) {
+    shapeObj tmpShapeInputLine;
+    msInitShape(&tmpShapeInputLine);
+    tmpShapeInputLine.type = MS_SHAPE_LINE;
+    tmpShapeInputLine.numlines = 1;
+    tmpShapeInputLine.line = line;
+
+    shapeObj *diff = NULL;
+    if (use_splitShape_check_intersects == MS_FALSE ||
+        msGEOSIntersects(&tmpShapeInputLine, &(reprojector->splitShape))) {
+      diff = msGEOSDifference(&tmpShapeInputLine, &(reprojector->splitShape));
+    }
+
+    tmpShapeInputLine.numlines = 0;
+    tmpShapeInputLine.line = NULL;
+    msFreeShape(&tmpShapeInputLine);
+
+    if (diff) {
+      for (int j = 0; j < diff->numlines; j++) {
+        for (i = 0; i < diff->line[j].numpoints; i++) {
+          msProjectPointEx(reprojector, &(diff->line[j].point[i]));
+        }
+        if (j == 0) {
+          line_out->numpoints = diff->line[j].numpoints;
+          memcpy(line_out->point, diff->line[0].point,
+                 sizeof(pointObj) * line_out->numpoints);
+        } else {
+          msAddLineDirectly(shape, &(diff->line[j]));
+        }
+      }
+      msFreeShape(diff);
+      msFree(diff);
+      return MS_SUCCESS;
+    }
+  }
+#endif
+
+  wrap_test = out != NULL && out->proj != NULL && msProjIsGeographicCRS(out) &&
+              !msProjIsGeographicCRS(in);
+
+  line->numpoints = 0;
+
+  memset(&lastPoint, 0, sizeof(lastPoint));
+
+  /* -------------------------------------------------------------------- */
+  /*      Loop over all input points in linestring.                       */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < numpoints_in; i++) {
+    int ms_err;
+    wrkPoint = thisPoint = line->point[i];
+
+    ms_err = msProjectPointEx(reprojector, &wrkPoint);
+
+    /* -------------------------------------------------------------------- */
+    /*      Apply wrap logic.                                               */
+    /* -------------------------------------------------------------------- */
+    if (wrap_test && i > 0 && ms_err != MS_FAILURE) {
+      double dist;
+      pointObj pt1Geo;
+
+      if (line_out->numpoints > 0)
+        pt1Geo = line_out->point[line_out->numpoints - 1];
+      else
+        pt1Geo = wrkPoint; /* this is a cop out */
+
+      if (out->gt.need_geotransform && out->gt.geotransform[2] == 0) {
+        dist = out->gt.geotransform[1] * (wrkPoint.x - pt1Geo.x);
+      } else {
+        dist = wrkPoint.x - pt1Geo.x;
+      }
+
+      if (fabs(dist) > 180.0 &&
+          msTestNeedWrap(thisPoint, lastPoint, pt1Geo, reprojector)) {
+        if (out->gt.need_geotransform && out->gt.geotransform[2] == 0) {
+          if (dist > 0.0)
+            wrkPoint.x -= 360.0 * out->gt.invgeotransform[1];
+          else if (dist < 0.0)
+            wrkPoint.x += 360.0 * out->gt.invgeotransform[1];
+        } else {
+          if (dist > 0.0)
+            wrkPoint.x -= 360.0;
+          else if (dist < 0.0)
+            wrkPoint.x += 360.0;
+        }
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Put result into output line with appropriate logic for          */
+    /*      failure breaking lines, etc.                                    */
+    /* -------------------------------------------------------------------- */
+    if (ms_err == MS_FAILURE) {
+      /* We have started out invalid */
+      if (i == 0) {
+        valid_flag = -1;
+      }
+
+      /* valid data has ended, we need to work out the horizon */
+      else if (valid_flag == 1) {
+        pointObj startPoint, endPoint;
+
+        startPoint = lastPoint;
+        endPoint = thisPoint;
+        if (msProjectSegment(reprojector, &startPoint, &endPoint) ==
+            MS_SUCCESS) {
+          line_out->point[line_out->numpoints++] = endPoint;
+        }
+        valid_flag = -1;
+      }
+
+      /* Still invalid ... */
+      else if (valid_flag == -1) {
+        /* do nothing */
+      }
+    }
+
+    else {
+      /* starting out valid. */
+      if (i == 0) {
+        line_out->point[line_out->numpoints++] = wrkPoint;
+        valid_flag = 1;
+      }
+
+      /* Still valid, nothing special */
+      else if (valid_flag == 1) {
+        line_out->point[line_out->numpoints++] = wrkPoint;
+      }
+
+      /* we have come over the horizon, figure out where, start newline*/
+      else {
+        pointObj startPoint, endPoint;
+
+        startPoint = lastPoint;
+        endPoint = thisPoint;
+        if (msProjectSegment(reprojector, &endPoint, &startPoint) ==
+            MS_SUCCESS) {
+          lineObj newLine;
+
+          /* force pre-allocation of lots of points room */
+          if (line_out->numpoints > 0 && shape->type == MS_SHAPE_LINE) {
+            newLine.numpoints = numpoints_in - i + 1;
+            newLine.point = line->point;
+            msAddLine(shape, &newLine);
+
+            /* new line is now lineout, but start without any points */
+            line_out = shape->line + shape->numlines - 1;
+
+            line_out->numpoints = 0;
+
+            /* the shape->line array is realloc, refetch "line" */
+            line = shape->line + line_index;
+          } else if (line_out == line && line->numpoints >= i - 2) {
+            newLine.numpoints = numpoints_in;
+            newLine.point = line->point;
+            msAddLine(shape, &newLine);
+
+            line = shape->line + line_index;
+
+            line_out = shape->line + shape->numlines - 1;
+            line_out->numpoints = line->numpoints;
+            line->numpoints = 0;
+
+            /*
+             * Now realloc this array large enough to hold all
+             * the points we could possibly need to add.
+             */
+            line_alloc = line_alloc * 2;
+
+            line_out->point = (pointObj *)realloc(
+                line_out->point, sizeof(pointObj) * line_alloc);
+          }
+
+          line_out->point[line_out->numpoints++] = startPoint;
+        }
+        line_out->point[line_out->numpoints++] = wrkPoint;
+        valid_flag = 1;
+      }
+    }
+
+    lastPoint = thisPoint;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Make sure that polygons are closed, even if the trip over       */
+  /*      the horizon left them unclosed.                                 */
+  /* -------------------------------------------------------------------- */
+  if (shape->type == MS_SHAPE_POLYGON && line_out->numpoints > 2 &&
+      (line_out->point[0].x != line_out->point[line_out->numpoints - 1].x ||
+       line_out->point[0].y != line_out->point[line_out->numpoints - 1].y)) {
+    /* make a copy because msAddPointToLine can realloc the array */
+    pointObj sFirstPoint = line_out->point[0];
+    msAddPointToLine(line_out, &sFirstPoint);
+  }
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                           msProjectShape()                           */
+/************************************************************************/
+int msProjectShape(projectionObj *in, projectionObj *out, shapeObj *shape) {
+  int ret;
+  reprojectionObj *reprojector = msProjectCreateReprojector(in, out);
+  if (!reprojector)
+    return MS_FAILURE;
+  ret = msProjectShapeEx(reprojector, shape);
+  msProjectDestroyReprojector(reprojector);
+  return ret;
+}
+
+/************************************************************************/
+/*                          msProjectShapeEx()                          */
+/************************************************************************/
+int msProjectShapeEx(reprojectionObj *reprojector, shapeObj *shape) {
+  int i;
+#ifdef USE_PROJ_FASTPATHS
+  int j;
+
+#define p_x shape->line[i].point[j].x
+#define p_y shape->line[i].point[j].y
+  if (in->wellknownprojection == wkp_lonlat &&
+      out->wellknownprojection == wkp_gmerc) {
+    for (i = shape->numlines - 1; i >= 0; i--) {
+      for (j = shape->line[i].numpoints - 1; j >= 0; j--) {
+        p_x *= MAXEXTENTby180;
+        p_y = log(tan((90 + p_y) * M_PIby360)) * MS_RAD_TO_DEG;
+        p_y *= MAXEXTENTby180;
+        if (p_x > MAXEXTENT)
+          p_x = MAXEXTENT;
+        else if (p_x < -MAXEXTENT)
+          p_x = -MAXEXTENT;
+        if (p_y > MAXEXTENT)
+          p_y = MAXEXTENT;
+        else if (p_y < -MAXEXTENT)
+          p_y = -MAXEXTENT;
+      }
+    }
+    msComputeBounds(shape); /* fixes bug 1586 */
+    return MS_SUCCESS;
+  }
+  if (in->wellknownprojection == wkp_gmerc &&
+      out->wellknownprojection == wkp_lonlat) {
+    for (i = shape->numlines - 1; i >= 0; i--) {
+      for (j = shape->line[i].numpoints - 1; j >= 0; j--) {
+        if (p_x > MAXEXTENT)
+          p_x = MAXEXTENT;
+        else if (p_x < -MAXEXTENT)
+          p_x = -MAXEXTENT;
+        if (p_y > MAXEXTENT)
+          p_y = MAXEXTENT;
+        else if (p_y < -MAXEXTENT)
+          p_y = -MAXEXTENT;
+        p_x = (p_x / MAXEXTENT) * 180;
+        p_y = (p_y / MAXEXTENT) * 180;
+        p_y = MS_RAD_TO_DEG * (2 * atan(exp(p_y * MS_DEG_TO_RAD)) - MS_PI2);
+      }
+    }
+    msComputeBounds(shape); /* fixes bug 1586 */
+    return MS_SUCCESS;
+  }
+#undef p_x
+#undef p_y
+#endif
+
+  if (shape->numlines == 0) {
+    // don't attempt to project any NULL geometries
+    // but if we want to return the record's attributes we won't free the shape
+    // and throw an error
+    shape->type = MS_SHAPE_NULL;
+    return MS_SUCCESS;
+  } else {
+    for (i = shape->numlines - 1; i >= 0; i--) {
+      if (shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) {
+        if (msProjectShapeLine(reprojector, shape, i) == MS_FAILURE)
+          msShapeDeleteLine(shape, i);
+      } else if (msProjectLineEx(reprojector, shape->line + i) == MS_FAILURE) {
+        msShapeDeleteLine(shape, i);
+      }
+    }
+
+    if (shape->numlines == 0) {
+      msFreeShape(shape);
+      return MS_FAILURE;
+    } else {
+      msComputeBounds(shape); /* fixes bug 1586 */
+      return (MS_SUCCESS);
+    }
+  }
+}
+
+/************************************************************************/
+/*                           msProjectLine()                            */
+/************************************************************************/
+int msProjectLine(projectionObj *in, projectionObj *out, lineObj *line) {
+  int ret;
+  reprojectionObj *reprojector = msProjectCreateReprojector(in, out);
+  if (!reprojector)
+    return MS_FAILURE;
+  ret = msProjectLineEx(reprojector, line);
+  msProjectDestroyReprojector(reprojector);
+  return ret;
+}
+
+/************************************************************************/
+/*                         msProjectLineEx()                            */
+/*                                                                      */
+/*      This function is now normally only used for point data.         */
+/*      msProjectShapeLine() is used for lines and polygons and has     */
+/*      lots of logic to handle horizon crossing.                       */
+/************************************************************************/
+
+int msProjectLineEx(reprojectionObj *reprojector, lineObj *line) {
+  int be_careful = reprojector->out->proj != NULL &&
+                   msProjIsGeographicCRS(reprojector->out) &&
+                   !msProjIsGeographicCRS(reprojector->in);
+
+  if (be_careful) {
+    pointObj startPoint, thisPoint; /* locations in projected space */
+
+    startPoint = line->point[0];
+
+    for (int i = 0; i < line->numpoints; i++) {
+      double dist;
+
+      thisPoint = line->point[i];
+
+      /*
+      ** Read comments before msTestNeedWrap() to better understand
+      ** this dateline wrapping logic.
+      */
+      msProjectPointEx(reprojector, &(line->point[i]));
+      if (i > 0) {
+        dist = line->point[i].x - line->point[0].x;
+        if (fabs(dist) > 180.0) {
+          if (msTestNeedWrap(thisPoint, startPoint, line->point[0],
+                             reprojector)) {
+            if (dist > 0.0) {
+              line->point[i].x -= 360.0;
+            } else if (dist < 0.0) {
+              line->point[i].x += 360.0;
+            }
+          }
+        }
+      }
+    }
+  } else {
+    for (int i = 0; i < line->numpoints; i++) {
+      if (msProjectPointEx(reprojector, &(line->point[i])) == MS_FAILURE)
+        return MS_FAILURE;
+    }
+  }
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                           msProjectRectGrid()                        */
+/************************************************************************/
+
+#define NUMBER_OF_SAMPLE_POINTS 100
+
+static int msProjectRectGrid(reprojectionObj *reprojector, rectObj *rect) {
+  pointObj prj_point;
+  rectObj prj_rect;
+  int failure = 0;
+  int ix, iy;
+
+  double dx, dy;
+  double x, y;
+
+  prj_rect.minx = DBL_MAX;
+  prj_rect.miny = DBL_MAX;
+  prj_rect.maxx = -DBL_MAX;
+  prj_rect.maxy = -DBL_MAX;
+
+  dx = (rect->maxx - rect->minx) / NUMBER_OF_SAMPLE_POINTS;
+  dy = (rect->maxy - rect->miny) / NUMBER_OF_SAMPLE_POINTS;
+
+  /* first ensure the top left corner is processed, even if the rect
+     turns out to be degenerate. */
+
+  prj_point.x = rect->minx;
+  prj_point.y = rect->miny;
+  prj_point.z = 0.0;
+  prj_point.m = 0.0;
+
+  msProjectGrowRect(reprojector, &prj_rect, &prj_point, &failure);
+
+  failure = 0;
+  for (ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++) {
+    x = rect->minx + ix * dx;
+
+    for (iy = 0; iy <= NUMBER_OF_SAMPLE_POINTS; iy++) {
+      y = rect->miny + iy * dy;
+
+      prj_point.x = x;
+      prj_point.y = y;
+      msProjectGrowRect(reprojector, &prj_rect, &prj_point, &failure);
+    }
+  }
+
+  if (prj_rect.minx > prj_rect.maxx) {
+    rect->minx = 0;
+    rect->maxx = 0;
+    rect->miny = 0;
+    rect->maxy = 0;
+
+    msSetError(MS_PROJERR, "All points failed to reproject.",
+               "msProjectRect()");
+    return MS_FAILURE;
+  }
+
+  if (failure) {
+    msDebug("msProjectRect(): some points failed to reproject, doing internal "
+            "sampling.\n");
+  }
+
+  rect->minx = prj_rect.minx;
+  rect->miny = prj_rect.miny;
+  rect->maxx = prj_rect.maxx;
+  rect->maxy = prj_rect.maxy;
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                       msProjectRectAsPolygon()                       */
+/************************************************************************/
+
+int msProjectRectAsPolygon(reprojectionObj *reprojector, rectObj *rect) {
+  shapeObj polygonObj;
+  lineObj ring;
+  /*  pointObj ringPoints[NUMBER_OF_SAMPLE_POINTS*4+4]; */
+  pointObj *ringPoints;
+  int ix, iy, ixy;
+
+  double dx, dy;
+
+  /* If projecting from longlat to projected */
+  /* This hack was introduced for WFS 2.0 compliance testing, but is far */
+  /* from being perfect */
+  if (reprojector->out && !msProjIsGeographicCRS(reprojector->out) &&
+      reprojector->in && msProjIsGeographicCRS(reprojector->in) &&
+      fabs(rect->minx - -180.0) < 1e-5 && fabs(rect->miny - -90.0) < 1e-5 &&
+      fabs(rect->maxx - 180.0) < 1e-5 && fabs(rect->maxy - 90.0) < 1e-5) {
+    pointObj pointTest;
+    pointTest.x = -180;
+    pointTest.y = 85;
+    msProjectPointEx(reprojector, &pointTest);
+    /* Detect if we are reprojecting from EPSG:4326 to EPSG:3857 */
+    /* and if so use more plausible bounds to avoid issues with computed */
+    /* resolution for WCS */
+    if (fabs(pointTest.x - -20037508.3427892) < 1e-5 &&
+        fabs(pointTest.y - 19971868.8804086)) {
+      rect->minx = -20037508.3427892;
+      rect->miny = -20037508.3427892;
+      rect->maxx = 20037508.3427892;
+      rect->maxy = 20037508.3427892;
+    } else {
+      rect->minx = -1e15;
+      rect->miny = -1e15;
+      rect->maxx = 1e15;
+      rect->maxy = 1e15;
+    }
+    return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Build polygon as steps around the source rectangle              */
+  /*      and possibly its diagonal.                                      */
+  /* -------------------------------------------------------------------- */
+  dx = (rect->maxx - rect->minx) / NUMBER_OF_SAMPLE_POINTS;
+  dy = (rect->maxy - rect->miny) / NUMBER_OF_SAMPLE_POINTS;
+
+  if (dx == 0 && dy == 0) {
+    pointObj foo;
+    msDebug("msProjectRect(): Warning: degenerate rect {%f,%f,%f,%f}\n",
+            rect->minx, rect->miny, rect->minx, rect->miny);
+    foo.x = rect->minx;
+    foo.y = rect->miny;
+    msProjectPointEx(reprojector, &foo);
+    rect->minx = rect->maxx = foo.x;
+    rect->miny = rect->maxy = foo.y;
+    return MS_SUCCESS;
+  }
+
+  /* If there is more than two sample points we will also get samples from the
+   * diagonal line */
+  ringPoints =
+      (pointObj *)calloc(sizeof(pointObj), NUMBER_OF_SAMPLE_POINTS * 5 + 3);
+  ring.point = ringPoints;
+  ring.numpoints = 0;
+
+  msInitShape(&polygonObj);
+  polygonObj.type = MS_SHAPE_POLYGON;
+
+  /* sample along top */
+  if (dx != 0) {
+    for (ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++) {
+      ringPoints[ring.numpoints].x = rect->minx + ix * dx;
+      ringPoints[ring.numpoints++].y = rect->miny;
+    }
+  }
+
+  /* sample along right side */
+  if (dy != 0) {
+    for (iy = 1; iy <= NUMBER_OF_SAMPLE_POINTS; iy++) {
+      ringPoints[ring.numpoints].x = rect->maxx;
+      ringPoints[ring.numpoints++].y = rect->miny + iy * dy;
+    }
+  }
+
+  /* sample along bottom */
+  if (dx != 0) {
+    for (ix = NUMBER_OF_SAMPLE_POINTS - 1; ix >= 0; ix--) {
+      ringPoints[ring.numpoints].x = rect->minx + ix * dx;
+      ringPoints[ring.numpoints++].y = rect->maxy;
+    }
+  }
+
+  /* sample along left side */
+  if (dy != 0) {
+    for (iy = NUMBER_OF_SAMPLE_POINTS - 1; iy >= 0; iy--) {
+      ringPoints[ring.numpoints].x = rect->minx;
+      ringPoints[ring.numpoints++].y = rect->miny + iy * dy;
+    }
+  }
+
+  /* sample along diagonal line */
+  /* This is done to handle cases where reprojection from world covering
+   * projection to one */
+  /* which isn't could cause min and max values of the projected rectangle to be
+   * invalid */
+  if (dy != 0 && dx != 0) {
+    /* No need to compute corners as they've already been computed */
+    for (ixy = NUMBER_OF_SAMPLE_POINTS - 2; ixy >= 1; ixy--) {
+      ringPoints[ring.numpoints].x = rect->minx + ixy * dx;
+      ringPoints[ring.numpoints++].y = rect->miny + ixy * dy;
+    }
+  }
+
+  msAddLineDirectly(&polygonObj, &ring);
+
+#ifdef notdef
+  FILE *wkt = fopen("/tmp/www-before.wkt", "w");
+  char *tmp = msShapeToWKT(&polygonObj);
+  fprintf(wkt, "%s\n", tmp);
+  free(tmp);
+  fclose(wkt);
+#endif
+
+  /* -------------------------------------------------------------------- */
+  /*      Attempt to reproject.                                           */
+  /* -------------------------------------------------------------------- */
+  msProjectShapeLine(reprojector, &polygonObj, 0);
+
+  /* If no points reprojected, try a grid sampling */
+  if (polygonObj.numlines == 0 || polygonObj.line[0].numpoints == 0) {
+    msFreeShape(&polygonObj);
+    return msProjectRectGrid(reprojector, rect);
+  }
+
+#ifdef notdef
+  wkt = fopen("/tmp/www-after.wkt", "w");
+  tmp = msShapeToWKT(&polygonObj);
+  fprintf(wkt, "%s\n", tmp);
+  free(tmp);
+  fclose(wkt);
+#endif
+
+  /* -------------------------------------------------------------------- */
+  /*      Collect bounds.                                                 */
+  /* -------------------------------------------------------------------- */
+  rect->minx = rect->maxx = polygonObj.line[0].point[0].x;
+  rect->miny = rect->maxy = polygonObj.line[0].point[0].y;
+
+  for (ix = 1; ix < polygonObj.line[0].numpoints; ix++) {
+    pointObj *pnt = polygonObj.line[0].point + ix;
+
+    rect->minx = MS_MIN(rect->minx, pnt->x);
+    rect->maxx = MS_MAX(rect->maxx, pnt->x);
+    rect->miny = MS_MIN(rect->miny, pnt->y);
+    rect->maxy = MS_MAX(rect->maxy, pnt->y);
+  }
+
+  msFreeShape(&polygonObj);
+
+  /* -------------------------------------------------------------------- */
+  /*      Special case to handle reprojection from "more than the         */
+  /*      whole world" projected coordinates that sometimes produce a     */
+  /*      region greater than 360 degrees wide due to various wrapping    */
+  /*      logic.                                                          */
+  /* -------------------------------------------------------------------- */
+  if (reprojector->out && msProjIsGeographicCRS(reprojector->out) &&
+      reprojector->in && !msProjIsGeographicCRS(reprojector->in) &&
+      rect->maxx - rect->minx > 360.0 &&
+      !reprojector->out->gt.need_geotransform) {
+    rect->maxx = 180;
+    rect->minx = -180;
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                        msProjectHasLonWrap()                         */
+/************************************************************************/
+
+int msProjectHasLonWrap(projectionObj *in, double *pdfLonWrap) {
+  int i;
+  if (pdfLonWrap)
+    *pdfLonWrap = 0;
+
+  if (!msProjIsGeographicCRS(in))
+    return MS_FALSE;
+
+  for (i = 0; i < in->numargs; i++) {
+    if (strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0) {
+      if (pdfLonWrap)
+        *pdfLonWrap = atof(in->args[i] + strlen("lon_wrap="));
+      return MS_TRUE;
+    }
+  }
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                           msProjectRect()                            */
+/************************************************************************/
+
+int msProjectRect(projectionObj *in, projectionObj *out, rectObj *rect) {
+  char *over = "+over";
+  int ret;
+  int bFreeInOver = MS_FALSE;
+  int bFreeOutOver = MS_FALSE;
+  projectionObj in_over, out_over, *inp, *outp;
+  double dfLonWrap = 0.0;
+  reprojectionObj *reprojector = NULL;
+
+  /* Detect projecting from polar stereographic to longlat */
+  if (in && !in->gt.need_geotransform && out && !out->gt.need_geotransform &&
+      !msProjIsGeographicCRS(in) && msProjIsGeographicCRS(out)) {
+    reprojector = msProjectCreateReprojector(in, out);
+    for (int sign = 1; sign >= -1; sign -= 2) {
+      pointObj p;
+      p.x = 0.0;
+      p.y = 0.0;
+      if (reprojector && msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
+          fabs(p.y - sign * 90) < 1e-8) {
+        /* Is the pole in the rectangle ? */
+        if (0 >= rect->minx && 0 >= rect->miny && 0 <= rect->maxx &&
+            0 <= rect->maxy) {
+          if (msProjectRectAsPolygon(reprojector, rect) == MS_SUCCESS) {
+            rect->minx = -180.0;
+            rect->maxx = 180.0;
+            rect->maxy = sign * 90.0;
+            msProjectDestroyReprojector(reprojector);
+            return MS_SUCCESS;
+          }
+        }
+        /* Are we sure the dateline is not enclosed ? */
+        else if (rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0) {
+          ret = msProjectRectAsPolygon(reprojector, rect);
+          msProjectDestroyReprojector(reprojector);
+          return ret;
+        }
+      }
+    }
+  }
+
+  /* Detect projecting from polar stereographic to another projected system */
+  else if (in && !in->gt.need_geotransform && out &&
+           !out->gt.need_geotransform && !msProjIsGeographicCRS(in) &&
+           !msProjIsGeographicCRS(out)) {
+    reprojectionObj *reprojectorToLongLat =
+        msProjectCreateReprojector(in, NULL);
+    for (int sign = 1; sign >= -1; sign -= 2) {
+      pointObj p;
+      p.x = 0.0;
+      p.y = 0.0;
+      if (reprojectorToLongLat &&
+          msProjectPointEx(reprojectorToLongLat, &p) == MS_SUCCESS &&
+          fabs(p.y - 90) < 1e-8) {
+        reprojector = msProjectCreateReprojector(in, out);
+        /* Is the pole in the rectangle ? */
+        if (0 >= rect->minx && 0 >= rect->miny && 0 <= rect->maxx &&
+            0 <= rect->maxy) {
+          if (msProjectRectAsPolygon(reprojector, rect) == MS_SUCCESS) {
+            msProjectDestroyReprojector(reprojector);
+            msProjectDestroyReprojector(reprojectorToLongLat);
+            return MS_SUCCESS;
+          }
+        }
+        /* Are we sure the dateline is not enclosed ? */
+        else if (rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0) {
+          ret = msProjectRectAsPolygon(reprojector, rect);
+          msProjectDestroyReprojector(reprojector);
+          msProjectDestroyReprojector(reprojectorToLongLat);
+          return ret;
+        }
+      }
+    }
+    msProjectDestroyReprojector(reprojectorToLongLat);
+  }
+
+  if (in && msProjectHasLonWrap(in, &dfLonWrap) && dfLonWrap == 180.0) {
+    inp = in;
+    outp = out;
+    if (rect->maxx > 180.0) {
+      rect->minx = -180.0;
+      rect->maxx = 180.0;
+    }
+  }
+  /*
+   * Issue #4892: When projecting a rectangle we do not want proj to wrap
+   * resulting coordinates around the dateline, as in practice a requested
+   * bounding box of -22.000.000, -YYY, 22.000.000, YYY should be projected as
+   * -190,-YYY,190,YYY rather than 170,-YYY,-170,YYY as would happen when
+   * wrapping (and vice-versa when projecting from lonlat to metric). To enforce
+   * this, we clone the input projections and add the "+over" proj parameter in
+   * order to disable dateline wrapping.
+   */
+  else {
+    int apply_over = MS_TRUE;
+#if PROJ_VERSION_MAJOR >= 6 && PROJ_VERSION_MAJOR < 9
+    // Workaround PROJ [6,9[ bug (fixed per
+    // https://github.com/OSGeo/PROJ/pull/3055) that prevents datum shifts from
+    // being applied when +over is added to +init=epsg:XXXX This is far from
+    // being bullet proof but it should work for most common use cases
+    if (in && in->proj) {
+      if (in->numargs == 1 && EQUAL(in->args[0], "init=epsg:4326") &&
+          rect->minx >= -180 && rect->maxx <= 180) {
+        apply_over = MS_FALSE;
+      } else if (in->numargs == 1 && EQUAL(in->args[0], "init=epsg:3857") &&
+                 rect->minx >= -20037508.3427892 &&
+                 rect->maxx <= 20037508.3427892) {
+        apply_over = MS_FALSE;
+      }
+    }
+#endif
+    // cppcheck-suppress knownConditionTrueFalse
+    if (out && apply_over && out->numargs > 0 &&
+        (strncmp(out->args[0], "init=", 5) == 0 ||
+         strncmp(out->args[0], "proj=", 5) == 0)) {
+      bFreeOutOver = MS_TRUE;
+      msInitProjection(&out_over);
+      msCopyProjectionExtended(&out_over, out, &over, 1);
+      outp = &out_over;
+      if (reprojector) {
+        msProjectDestroyReprojector(reprojector);
+        reprojector = NULL;
+      }
+    } else {
+      outp = out;
+    }
+    // cppcheck-suppress knownConditionTrueFalse
+    if (in && apply_over && in->numargs > 0 &&
+        (strncmp(in->args[0], "init=", 5) == 0 ||
+         strncmp(in->args[0], "proj=", 5) == 0)) {
+      bFreeInOver = MS_TRUE;
+      msInitProjection(&in_over);
+      msCopyProjectionExtended(&in_over, in, &over, 1);
+      inp = &in_over;
+      /* coverity[dead_error_begin] */
+      if (reprojector) {
+        msProjectDestroyReprojector(reprojector);
+        reprojector = NULL;
+      }
+    } else {
+      inp = in;
+    }
+  }
+  if (reprojector == NULL) {
+    reprojector = msProjectCreateReprojector(inp, outp);
+  }
+  ret = reprojector ? msProjectRectAsPolygon(reprojector, rect) : MS_FAILURE;
+  msProjectDestroyReprojector(reprojector);
+  if (bFreeInOver)
+    msFreeProjection(&in_over);
+  if (bFreeOutOver)
+    msFreeProjection(&out_over);
+  return ret;
+}
+
+/************************************************************************/
+/*                        msProjectionsDiffer()                         */
+/************************************************************************/
+
+/*
+** Compare two projections, and return MS_TRUE if they differ.
+**
+** For now this is implemented by exact comparison of the projection
+** arguments, but eventually this should call a PROJ.4 function with
+** more awareness of the issues.
+**
+** NOTE: MS_FALSE is returned if either of the projection objects
+** has no arguments, since reprojection won't work anyways.
+*/
+
+static int msProjectionsDifferInternal(projectionObj *proj1,
+                                       projectionObj *proj2)
+
+{
+  int i;
+
+  if (proj1->numargs == 0 || proj2->numargs == 0)
+    return MS_FALSE;
+
+  if (proj1->numargs != proj2->numargs)
+    return MS_TRUE;
+
+  /* This test should be more rigerous. */
+  if (proj1->gt.need_geotransform || proj2->gt.need_geotransform)
+    return MS_TRUE;
+
+  for (i = 0; i < proj1->numargs; i++) {
+    if (strcmp(proj1->args[i], proj2->args[i]) != 0)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+int msProjectionsDiffer(projectionObj *proj1, projectionObj *proj2) {
+  return msProjectionsDifferInternal(proj1, proj2);
+}
+
+/************************************************************************/
+/*                           msTestNeedWrap()                           */
+/************************************************************************/
+/*
+
+Frank Warmerdam, Nov, 2001.
+
+See Also:
+
+http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=15
+
+Proposal:
+
+Modify msProjectLine() so that it "dateline wraps" objects when necessary
+in order to preserve their shape when reprojecting to lat/long.  This
+will be accomplished by:
+
+1) As each vertex is reprojected, compare the X distance between that
+   vertex and the previous vertex.  If it is less than 180 then proceed to
+   the next vertex without any special logic, otherwise:
+
+2) Reproject the center point of the line segment from the last vertex to
+   the current vertex into lat/long.  Does it's longitude lie between the
+   longitudes of the start and end point.  If yes, return to step 1) for
+   the next vertex ... everything is fine.
+
+3) We have determined that this line segment is suffering from 360 degree
+   wrap to keep in the -180 to +180 range.  Now add or subtract 360 degrees
+   as determined from the original sign of the distances.
+
+This is similar to the code there now (though disabled in CVS); however,
+it will ensure that big boxes will remain big, and not get dateline wrapped
+because of the extra test in step 2).  However step 2 is invoked only very
+rarely so this process takes little more than the normal process.  In fact,
+if we were sufficiently concerned about performance we could do a test on the
+shape MBR in lat/long space, and if the width is less than 180 we know we never
+need to even do test 1).
+
+What doesn't this resolve:
+
+This ensures that individual lines are kept in the proper shape when
+reprojected to geographic space.  However, it does not:
+
+ o Ensure that all rings of a polygon will get transformed to the same "side"
+   of the world.  Depending on starting points of the different rings it is
+   entirely possible for one ring to end up in the -180 area and another ring
+   from the same polygon to end up in the +180 area.  We might possibly be
+   able to achieve this though, by treating the multi-ring polygon as a whole
+   and testing the first point of each additional ring against the last
+   vertex of the previous ring (or any previous vertex for that matter).
+
+ o It does not address the need to cut up lines and polygons into distinct
+   chunks to preserve the correct semantics.  Really a polygon that
+   spaces the dateline in a -180 to 180 view should get split into two
+   polygons.  We haven't addressed that, though if it were to be addressed,
+   it could be done as a followon and distinct step from what we are doing
+   above.  In fact this sort of improvement (split polygons based on dateline
+   or view window) should be done for all lat/long shapes regardless of
+   whether they are being reprojected from another projection.
+
+ o It does not address issues related to viewing rectangles that go outside
+   the -180 to 180 longitude range.  For instance, it is entirely reasonable
+   to want a 160 to 200 longitude view to see an area on the dateline clearly.
+   Currently shapes in the -180 to -160 range which should be displayed in the
+   180 to 200 portion of that view will not be because there is no recogition
+   that they belong there.
+
+
+*/
+
+static int msTestNeedWrap(pointObj pt1, pointObj pt2, pointObj pt2_geo,
+                          reprojectionObj *reprojector)
+
+{
+  pointObj middle;
+  projectionObj *out = reprojector->out;
+
+  middle.x = (pt1.x + pt2.x) * 0.5;
+  middle.y = (pt1.y + pt2.y) * 0.5;
+
+  if (msProjectPointEx(reprojector, &pt1) == MS_FAILURE ||
+      msProjectPointEx(reprojector, &pt2) == MS_FAILURE ||
+      msProjectPointEx(reprojector, &middle) == MS_FAILURE)
+    return 0;
+
+  /*
+   * If the last point was moved, then we are considered due for a
+   * move to.
+   */
+  if (out->gt.need_geotransform && out->gt.geotransform[2] == 0) {
+    if (fabs((pt2_geo.x - pt2.x) * out->gt.geotransform[1]) > 180.0)
+      return 1;
+  } else {
+    if (fabs(pt2_geo.x - pt2.x) > 180.0)
+      return 1;
+  }
+
+  /*
+   * Otherwise, test to see if the middle point transforms
+   * to be between the end points. If yes, no wrapping is needed.
+   * Otherwise wrapping is needed.
+   */
+  if ((middle.x < pt1.x && middle.x < pt2_geo.x) ||
+      (middle.x > pt1.x && middle.x > pt2_geo.x))
+    return 1;
+  else
+    return 0;
+}
+
+/************************************************************************/
+/*                       msProjDataInitFromEnv()                        */
+/************************************************************************/
+void msProjDataInitFromEnv() {
+  const char *val;
+
+  if ((val = CPLGetConfigOption("PROJ_DATA", NULL)) != NULL ||
+      (val = CPLGetConfigOption("PROJ_LIB", NULL)) != NULL) {
+    msSetPROJ_DATA(val, NULL);
+  }
+}
+
+/************************************************************************/
+/*                           msSetPROJ_DATA()                           */
+/************************************************************************/
+void msSetPROJ_DATA(const char *proj_data, const char *pszRelToPath)
+
+{
+  char *extended_path = NULL;
+
+  /* Handle relative path if applicable */
+  if (proj_data && pszRelToPath && proj_data[0] != '/' &&
+      proj_data[0] != '\\' && !(proj_data[0] != '\0' && proj_data[1] == ':')) {
+    struct stat stat_buf;
+    extended_path =
+        (char *)msSmallMalloc(strlen(pszRelToPath) + strlen(proj_data) + 10);
+    sprintf(extended_path, "%s/%s", pszRelToPath, proj_data);
+
+#ifndef S_ISDIR
+#define S_ISDIR(x) ((x)&S_IFDIR)
+#endif
+
+    if (stat(extended_path, &stat_buf) == 0 && S_ISDIR(stat_buf.st_mode))
+      proj_data = extended_path;
+  }
+
+  msAcquireLock(TLOCK_PROJ);
+
+  if (proj_data == NULL && ms_proj_data == NULL) {
+    /* do nothing */
+  } else if (proj_data != NULL && ms_proj_data != NULL &&
+             strcmp(proj_data, ms_proj_data) == 0) {
+    /* do nothing */
+  } else {
+    ms_proj_data_change_counter++;
+    free(ms_proj_data);
+    ms_proj_data = proj_data ? msStrdup(proj_data) : NULL;
+  }
+
+  msReleaseLock(TLOCK_PROJ);
+
+  if (ms_proj_data != NULL) {
+#ifdef _WIN32
+    const char *sep = ";";
+#else
+    const char *sep = ":";
+#endif
+    char **papszPaths = CSLTokenizeString2(ms_proj_data, sep, 0);
+    OSRSetPROJSearchPaths((const char *const *)papszPaths);
+    CSLDestroy(papszPaths);
+  }
+
+  if (extended_path)
+    msFree(extended_path);
+}
+
+/************************************************************************/
+/*                       msGetProjectionString()                        */
+/*                                                                      */
+/*      Return the projection string.                                   */
+/************************************************************************/
+
+char *msGetProjectionString(projectionObj *proj) {
+  char *pszProjString = NULL;
+  int nLen = 0;
+
+  if (proj) {
+    /* -------------------------------------------------------------------- */
+    /*      Alloc buffer large enough to hold the whole projection defn     */
+    /* -------------------------------------------------------------------- */
+    for (int i = 0; i < proj->numargs; i++) {
+      if (proj->args[i])
+        nLen += (strlen(proj->args[i]) + 2);
+    }
+
+    pszProjString = (char *)malloc(sizeof(char) * nLen + 1);
+    pszProjString[0] = '\0';
+
+    /* -------------------------------------------------------------------- */
+    /*      Plug each arg into the string with a '+' prefix                 */
+    /* -------------------------------------------------------------------- */
+    for (int i = 0; i < proj->numargs; i++) {
+      if (!proj->args[i] || strlen(proj->args[i]) == 0)
+        continue;
+      if (pszProjString[0] == '\0') {
+        /* no space at beginning of line */
+        if (proj->args[i][0] != '+')
+          strcat(pszProjString, "+");
+      } else {
+        if (proj->args[i][0] != '+')
+          strcat(pszProjString, " +");
+        else
+          strcat(pszProjString, " ");
+      }
+      strcat(pszProjString, proj->args[i]);
+    }
+  }
+
+  return pszProjString;
+}
+
+/************************************************************************/
+/*                       msIsAxisInvertedProj()                         */
+/*                                                                      */
+/*      Return MS_TRUE is the proj object has epgsaxis=ne               */
+/************************************************************************/
+
+int msIsAxisInvertedProj(projectionObj *proj) {
+  int i;
+  const char *axis = NULL;
+
+  for (i = 0; i < proj->numargs; i++) {
+    if (strstr(proj->args[i], "epsgaxis=") != NULL) {
+      axis = strstr(proj->args[i], "=") + 1;
+      break;
+    }
+  }
+
+  if (axis == NULL)
+    return MS_FALSE;
+
+  if (strcasecmp(axis, "en") == 0)
+    return MS_FALSE;
+
+  if (strcasecmp(axis, "ne") != 0) {
+    msDebug("msIsAxisInvertedProj(): odd +epsgaxis= value: '%s'.", axis);
+    return MS_FALSE;
+  }
+
+  return MS_TRUE;
+}
+
+/************************************************************************/
+/*                       msAxisNormalizePoints()                        */
+/*                                                                      */
+/*      Convert the passed points to "easting, northing" axis           */
+/*      orientation if they are not already.                            */
+/************************************************************************/
+
+void msAxisNormalizePoints(projectionObj *proj, int count, double *x, double *y)
+
+{
+  int i;
+  if (!msIsAxisInvertedProj(proj))
+    return;
+
+  /* Switch axes */
+  for (i = 0; i < count; i++) {
+    double tmp;
+
+    tmp = x[i];
+    x[i] = y[i];
+    y[i] = tmp;
+  }
+}
+
+/************************************************************************/
+/*                             msAxisSwapShape                          */
+/*                                                                      */
+/*      Utility function to swap x and y coordiatesn Use for now for    */
+/*      WFS 1.1.x                                                       */
+/************************************************************************/
+void msAxisSwapShape(shapeObj *shape) {
+  double tmp;
+  int i, j;
+
+  if (shape) {
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        tmp = shape->line[i].point[j].x;
+        shape->line[i].point[j].x = shape->line[i].point[j].y;
+        shape->line[i].point[j].y = tmp;
+      }
+    }
+
+    /*swap bounds*/
+    tmp = shape->bounds.minx;
+    shape->bounds.minx = shape->bounds.miny;
+    shape->bounds.miny = tmp;
+
+    tmp = shape->bounds.maxx;
+    shape->bounds.maxx = shape->bounds.maxy;
+    shape->bounds.maxy = tmp;
+  }
+}
+
+/************************************************************************/
+/*                      msAxisDenormalizePoints()                       */
+/*                                                                      */
+/*      Convert points from easting,northing orientation to the         */
+/*      preferred epsg orientation of this projectionObj.               */
+/************************************************************************/
+
+void msAxisDenormalizePoints(projectionObj *proj, int count, double *x,
+                             double *y)
+
+{
+  /* For how this is essentially identical to normalizing */
+  msAxisNormalizePoints(proj, count, x, y);
+}
+
+/************************************************************************/
+/*                        msProjIsGeographicCRS()                       */
+/*                                                                      */
+/*      Returns whether a CRS is a geographic one.                      */
+/************************************************************************/
+
+int msProjIsGeographicCRS(projectionObj *proj) {
+  PJ_TYPE type;
+  if (!proj->proj)
+    return FALSE;
+  type = proj_get_type(proj->proj);
+  if (type == PJ_TYPE_GEOGRAPHIC_2D_CRS || type == PJ_TYPE_GEOGRAPHIC_3D_CRS)
+    return TRUE;
+  if (type == PJ_TYPE_BOUND_CRS) {
+    PJ *base_crs = proj_get_source_crs(proj->proj_ctx->proj_ctx, proj->proj);
+    type = proj_get_type(base_crs);
+    proj_destroy(base_crs);
+    return type == PJ_TYPE_GEOGRAPHIC_2D_CRS ||
+           type == PJ_TYPE_GEOGRAPHIC_3D_CRS;
+  }
+  return FALSE;
+}
+
+/************************************************************************/
+/*                        ConvertProjUnitStringToMS                     */
+/*                                                                      */
+/*       Returns mapserver's unit code corresponding to the proj        */
+/*      unit passed as argument.                                        */
+/*       Please refer to ./src/pj_units.c file in the Proj.4 module.    */
+/************************************************************************/
+static int ConvertProjUnitStringToMS(const char *pszProjUnit) {
+  if (strcmp(pszProjUnit, "m") == 0) {
+    return MS_METERS;
+  } else if (strcmp(pszProjUnit, "km") == 0) {
+    return MS_KILOMETERS;
+  } else if (strcmp(pszProjUnit, "mi") == 0 ||
+             strcmp(pszProjUnit, "us-mi") == 0) {
+    return MS_MILES;
+  } else if (strcmp(pszProjUnit, "in") == 0 ||
+             strcmp(pszProjUnit, "us-in") == 0) {
+    return MS_INCHES;
+  } else if (strcmp(pszProjUnit, "ft") == 0 ||
+             strcmp(pszProjUnit, "us-ft") == 0) {
+    return MS_FEET;
+  } else if (strcmp(pszProjUnit, "kmi") == 0) {
+    return MS_NAUTICALMILES;
+  }
+
+  return -1;
+}
+
+/************************************************************************/
+/*           int GetMapserverUnitUsingProj(projectionObj *psProj)       */
+/*                                                                      */
+/*      Return a mapserver unit corresponding to the projection         */
+/*      passed. Retunr -1 on failure                                    */
+/************************************************************************/
+int GetMapserverUnitUsingProj(projectionObj *psProj) {
+  if (msProjIsGeographicCRS(psProj))
+    return MS_DD;
+
+  const char *proj_str = proj_as_proj_string(psProj->proj_ctx->proj_ctx,
+                                             psProj->proj, PJ_PROJ_4, NULL);
+  if (proj_str == NULL)
+    return -1;
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle case of named units.                                     */
+  /* -------------------------------------------------------------------- */
+  if (strstr(proj_str, "units=") != NULL) {
+    char units[32];
+    char *blank;
+
+    strlcpy(units, (strstr(proj_str, "units=") + 6), sizeof(units));
+
+    blank = strchr(units, ' ');
+    if (blank != NULL)
+      *blank = '\0';
+
+    return ConvertProjUnitStringToMS(units);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle case of to_meter value.                                  */
+  /* -------------------------------------------------------------------- */
+  if (strstr(proj_str, "to_meter=") != NULL) {
+    char to_meter_str[32];
+    char *blank;
+    double to_meter;
+
+    strlcpy(to_meter_str, (strstr(proj_str, "to_meter=") + 9),
+            sizeof(to_meter_str));
+
+    blank = strchr(to_meter_str, ' ');
+    if (blank != NULL)
+      *blank = '\0';
+
+    to_meter = atof(to_meter_str);
+
+    if (fabs(to_meter - 1.0) < 0.0000001)
+      return MS_METERS;
+    else if (fabs(to_meter - 1000.0) < 0.00001)
+      return MS_KILOMETERS;
+    else if (fabs(to_meter - 0.3048) < 0.0001)
+      return MS_FEET;
+    else if (fabs(to_meter - 0.0254) < 0.0001)
+      return MS_INCHES;
+    else if (fabs(to_meter - 1609.344) < 0.001)
+      return MS_MILES;
+    else if (fabs(to_meter - 1852.0) < 0.1)
+      return MS_NAUTICALMILES;
+    else
+      return -1;
+  }
+
+  return -1;
+}
+
+/************************************************************************/
+/*                   msProjectionContextGetFromPool()                   */
+/*                                                                      */
+/*       Returns a projection context from the pool, or create a new    */
+/*       one if the pool is empty.                                      */
+/*       After use, it should normally be returned with                 */
+/*       msProjectionContextReleaseToPool()                             */
+/************************************************************************/
+
+projectionContext *msProjectionContextGetFromPool() {
+  projectionContext *context;
+  msAcquireLock(TLOCK_PROJ);
+
+  if (headOfLinkedListOfProjContext) {
+    LinkedListOfProjContext *next = headOfLinkedListOfProjContext->next;
+    context = headOfLinkedListOfProjContext->context;
+    msFree(headOfLinkedListOfProjContext);
+    headOfLinkedListOfProjContext = next;
+  } else {
+    context = msProjectionContextCreate();
+  }
+
+  msReleaseLock(TLOCK_PROJ);
+  return context;
+}
+
+/************************************************************************/
+/*                  msProjectionContextReleaseToPool()                  */
+/************************************************************************/
+
+void msProjectionContextReleaseToPool(projectionContext *ctx) {
+  LinkedListOfProjContext *link =
+      (LinkedListOfProjContext *)msSmallMalloc(sizeof(LinkedListOfProjContext));
+  link->context = ctx;
+  msAcquireLock(TLOCK_PROJ);
+  link->next = headOfLinkedListOfProjContext;
+  headOfLinkedListOfProjContext = link;
+  msReleaseLock(TLOCK_PROJ);
+}
+
+/************************************************************************/
+/*                   msProjectionContextPoolCleanup()                   */
+/************************************************************************/
+
+void msProjectionContextPoolCleanup() {
+  LinkedListOfProjContext *link;
+  msAcquireLock(TLOCK_PROJ);
+  link = headOfLinkedListOfProjContext;
+  while (link) {
+    LinkedListOfProjContext *next = link->next;
+    msProjectionContextUnref(link->context);
+    msFree(link);
+    link = next;
+  }
+  headOfLinkedListOfProjContext = NULL;
+  msReleaseLock(TLOCK_PROJ);
+}
diff -pruN 8.0.1-5/src/mapproject.h 8.2.0~beta1-1~exp1/src/mapproject.h
--- 8.0.1-5/src/mapproject.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapproject.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,173 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Declarations of the projectionObj and related functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPPROJECT_H
+#define MAPPROJECT_H
+
+#include "mapprimitive.h"
+#include "maphash.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <proj.h>
+
+#define wkp_none 0
+#define wkp_lonlat 1
+#define wkp_gmerc 2
+
+typedef struct projectionContext projectionContext;
+
+#ifndef SWIG
+typedef enum {
+  LINE_CUTTING_UNKNOWN = -1,
+  LINE_CUTTING_NONE = 0,
+  LINE_CUTTING_FROM_POLAR = 1,
+  LINE_CUTTING_FROM_LONGLAT_WRAP0 = 2
+} msLineCuttingCase;
+#endif
+
+/**
+The :ref:`PROJECTION <projection>` object
+MapServer's Maps and Layers have Projection attributes, and these are C
+projectionObj structures, but are not directly exposed by the mapscript module
+*/
+typedef struct {
+#ifndef SWIG
+  char **args; /* variable number of projection args */
+  PJ *proj;
+  projectionContext *proj_ctx;
+  geotransformObj gt; /* extra transformation to apply */
+#endif
+
+#ifdef SWIG
+    %immutable;
+#endif
+  int numargs; ///< Actual number of projection args
+  unsigned short
+      generation_number; ///< To be incremented when the content of the object
+                         ///< changes, so that a reprojector can be invalidated
+#ifdef SWIG
+    %mutable;
+#endif
+
+  int wellknownprojection; ///< One of ``wkp_none 0``, ``wkp_lonlat 1``, or
+                           ///< ``wkp_gmerc 2``
+} projectionObj;
+
+/**
+A holder object for projection coordinate transformations, introduced in RFC
+126. This allows caching of reprojections improving performance.
+*/
+typedef struct {
+#ifndef SWIG
+  projectionObj *in;
+  projectionObj *out;
+  PJ *pj;
+  msLineCuttingCase lineCuttingCase;
+  shapeObj splitShape;
+  int bFreePJ;
+#endif
+  unsigned short generation_number_in;  ///< A counter that is incremented when
+                                        ///< the input projectionObj changes
+  unsigned short generation_number_out; ///< A counter that is incremented when
+                                        ///< the output projectionObj changes
+} reprojectionObj;
+
+#ifndef SWIG
+
+MS_DLL_EXPORT reprojectionObj *msProjectCreateReprojector(projectionObj *in,
+                                                          projectionObj *out);
+MS_DLL_EXPORT void msProjectDestroyReprojector(reprojectionObj *reprojector);
+MS_DLL_EXPORT int
+msProjectIsReprojectorStillValid(reprojectionObj *reprojector);
+
+MS_DLL_EXPORT projectionContext *msProjectionContextGetFromPool(void);
+MS_DLL_EXPORT void msProjectionContextReleaseToPool(projectionContext *ctx);
+MS_DLL_EXPORT void msProjectionContextPoolCleanup(void);
+
+MS_DLL_EXPORT int msIsAxisInverted(int epsg_code);
+MS_DLL_EXPORT int msProjectPoint(projectionObj *in, projectionObj *out,
+                                 pointObj *point); /* legacy interface */
+MS_DLL_EXPORT int msProjectPointEx(reprojectionObj *reprojector,
+                                   pointObj *point);
+MS_DLL_EXPORT int msProjectShape(projectionObj *in, projectionObj *out,
+                                 shapeObj *shape); /* legacy interface */
+MS_DLL_EXPORT int msProjectShapeEx(reprojectionObj *reprojector,
+                                   shapeObj *shape);
+MS_DLL_EXPORT int msProjectLine(projectionObj *in, projectionObj *out,
+                                lineObj *line); /* legacy interface */
+MS_DLL_EXPORT int msProjectLineEx(reprojectionObj *reprojector, lineObj *line);
+MS_DLL_EXPORT int msProjectRect(projectionObj *in, projectionObj *out,
+                                rectObj *rect); /* legacy interface */
+MS_DLL_EXPORT int msProjectRectAsPolygon(reprojectionObj *reprojector,
+                                         rectObj *rect);
+MS_DLL_EXPORT int msProjectionsDiffer(projectionObj *, projectionObj *);
+MS_DLL_EXPORT int msOGCWKT2ProjectionObj(const char *pszWKT,
+                                         projectionObj *proj, int debug_flag);
+MS_DLL_EXPORT char *msProjectionObj2OGCWKT(projectionObj *proj);
+
+MS_DLL_EXPORT void msFreeProjection(projectionObj *p);
+MS_DLL_EXPORT void msFreeProjectionExceptContext(projectionObj *p);
+MS_DLL_EXPORT int msInitProjection(projectionObj *p);
+MS_DLL_EXPORT void msProjectionInheritContextFrom(projectionObj *pDst,
+                                                  const projectionObj *pSrc);
+MS_DLL_EXPORT void msProjectionSetContext(projectionObj *p,
+                                          projectionContext *ctx);
+MS_DLL_EXPORT int msProcessProjection(projectionObj *p);
+MS_DLL_EXPORT int msLoadProjectionString(projectionObj *p, const char *value);
+MS_DLL_EXPORT int msLoadProjectionStringEPSG(projectionObj *p,
+                                             const char *value);
+MS_DLL_EXPORT char *msGetProjectionString(projectionObj *proj);
+int msIsAxisInvertedProj(projectionObj *proj);
+void msAxisSwapShape(shapeObj *shape);
+MS_DLL_EXPORT void msAxisNormalizePoints(projectionObj *proj, int count,
+                                         double *x, double *y);
+MS_DLL_EXPORT void msAxisDenormalizePoints(projectionObj *proj, int count,
+                                           double *x, double *y);
+
+MS_DLL_EXPORT void msSetPROJ_DATA(const char *, const char *);
+MS_DLL_EXPORT void msProjDataInitFromEnv();
+
+int msProjIsGeographicCRS(projectionObj *proj);
+int msProjectTransformPoints(reprojectionObj *reprojector, int npoints,
+                             double *x, double *y);
+
+/*utility functions */
+MS_DLL_EXPORT int GetMapserverUnitUsingProj(projectionObj *psProj);
+
+int msProjectHasLonWrap(projectionObj *in, double *pdfLonWrap);
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPPROJECT_H */
diff -pruN 8.0.1-5/src/mapquantization.c 8.2.0~beta1-1~exp1/src/mapquantization.c
--- 8.0.1-5/src/mapquantization.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapquantization.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,741 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  RGB(A) to Palette Support Functions
+ * Author:   Thomas Bonfort
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ******************************************************************************
+ */
+/*
+ * derivations from pngquant and ppmquant
+ *
+ ** pngquant.c - quantize the colors in an alphamap down to a specified number
+ **
+ ** Copyright (C) 1989, 1991 by Jef Poskanzer.
+ ** Copyright (C) 1997, 2000, 2002 by Greg Roelofs; based on an idea by
+ **                                Stefan Schneider.
+ **
+ ** Permission to use, copy, modify, and distribute this software and its
+ ** documentation for any purpose and without fee is hereby granted, provided
+ ** that the above copyright notice appear in all copies and that both that
+ ** copyright notice and this permission notice appear in supporting
+ ** documentation.  This software is provided "as is" without express or
+ ** implied warranty.
+ */
+
+#include "mapserver.h"
+#include <stdlib.h>
+
+#define PAM_GETR(p) ((p).r)
+#define PAM_GETG(p) ((p).g)
+#define PAM_GETB(p) ((p).b)
+#define PAM_GETA(p) ((p).a)
+#define PAM_ASSIGN(p, red, grn, blu, alf)                                      \
+  do {                                                                         \
+    (p).r = (red);                                                             \
+    (p).g = (grn);                                                             \
+    (p).b = (blu);                                                             \
+    (p).a = (alf);                                                             \
+  } while (0)
+#define PAM_EQUAL(p, q)                                                        \
+  ((p).r == (q).r && (p).g == (q).g && (p).b == (q).b && (p).a == (q).a)
+#define PAM_DEPTH(newp, p, oldmaxval, newmaxval)                               \
+  PAM_ASSIGN((newp),                                                           \
+             ((int)PAM_GETR(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval), \
+             ((int)PAM_GETG(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval), \
+             ((int)PAM_GETB(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval), \
+             ((int)PAM_GETA(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval))
+
+/* from pamcmap.h */
+
+typedef struct acolorhist_item *acolorhist_vector;
+struct acolorhist_item {
+  rgbaPixel acolor;
+  int value;
+};
+
+typedef struct acolorhist_list_item *acolorhist_list;
+struct acolorhist_list_item {
+  struct acolorhist_item ch;
+  acolorhist_list next;
+};
+
+typedef acolorhist_list *acolorhash_table;
+
+#define MAXCOLORS 32767
+
+#define LARGE_NORM
+#define REP_AVERAGE_PIXELS
+
+typedef struct box *box_vector;
+struct box {
+  int ind;
+  int colors;
+  int sum;
+};
+
+static acolorhist_vector mediancut(acolorhist_vector achv, int colors, int sum,
+                                   unsigned char maxval, int newcolors);
+static int redcompare(const void *ch1, const void *ch2);
+static int greencompare(const void *ch1, const void *ch2);
+static int bluecompare(const void *ch1, const void *ch2);
+static int alphacompare(const void *ch1, const void *ch2);
+static int sumcompare(const void *b1, const void *b2);
+
+static acolorhist_vector pam_acolorhashtoacolorhist(acolorhash_table acht,
+                                                    int maxacolors);
+static acolorhist_vector pam_computeacolorhist(rgbaPixel **apixels, int cols,
+                                               int rows, int maxacolors,
+                                               int *acolorsP);
+static acolorhash_table pam_computeacolorhash(rgbaPixel **apixels, int cols,
+                                              int rows, int maxacolors,
+                                              int *acolorsP);
+static acolorhash_table pam_allocacolorhash(void);
+static int pam_addtoacolorhash(acolorhash_table acht, rgbaPixel *acolorP,
+                               int value);
+static int pam_lookupacolor(acolorhash_table acht, rgbaPixel *acolorP);
+static void pam_freeacolorhist(acolorhist_vector achv);
+static void pam_freeacolorhash(acolorhash_table acht);
+
+/**
+ * Compute a palette for the given RGBA rasterBuffer using a median cut
+ * quantization.
+ * - rb: the rasterBuffer to quantize
+ * - reqcolors: the desired number of colors the palette should contain. will be
+ * set with the actual number of entries in the computed palette
+ * - forced_palette: entries that should appear in the computed palette
+ * - num_forced_palette_entries: number of entries contained in "force_palette".
+ * if 0, "force_palette" can be NULL
+ * - palette_scaling_maxval: the quantization process may have to reduce the
+ * image depth by iteratively dividing the pixels by 2. In case
+ * palette_scaling_maxval is set to something different than 255, the returned
+ * palette colors have to be scaled back up to 255, and rb's pixels will have
+ * been scaled down to maxsize (see bug #3848)
+ */
+int msQuantizeRasterBuffer(rasterBufferObj *rb, unsigned int *reqcolors,
+                           rgbaPixel *palette,
+                           rgbaPixel *forced_palette_ignored,
+                           int num_forced_palette_entries_ignored,
+                           unsigned int *palette_scaling_maxval) {
+  (void)forced_palette_ignored;
+  (void)num_forced_palette_entries_ignored;
+  rgbaPixel **apixels =
+      NULL; /* pointer to the start rows of truecolor pixels */
+
+  register rgbaPixel *pP;
+
+  unsigned char newmaxval;
+  acolorhist_vector achv, acolormap = NULL;
+
+  int colors;
+  int newcolors = 0;
+
+  int x;
+  /*  int channels;  */
+
+  assert(rb->type == MS_BUFFER_BYTE_RGBA);
+
+  *palette_scaling_maxval = 255;
+
+  apixels = (rgbaPixel **)msSmallMalloc(rb->height * sizeof(rgbaPixel *));
+
+  for (unsigned row = 0; row < rb->height; row++) {
+    apixels[row] =
+        (rgbaPixel *)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));
+  }
+
+  /*
+   ** Step 2: attempt to make a histogram of the colors, unclustered.
+   ** If at first we don't succeed, lower maxval to increase color
+   ** coherence and try again.  This will eventually terminate, with
+   ** maxval at worst 15, since 32^3 is approximately MAXCOLORS.
+                [GRR POSSIBLE BUG:  what about 32^4 ?]
+   */
+  for (;;) {
+    achv = pam_computeacolorhist(apixels, rb->width, rb->height, MAXCOLORS,
+                                 &colors);
+    if (achv != (acolorhist_vector)0)
+      break;
+    newmaxval = *palette_scaling_maxval / 2;
+    for (unsigned row = 0; row < rb->height; ++row) {
+      pP = apixels[row];
+      for (unsigned col = 0; col < rb->width; ++col, ++pP)
+        PAM_DEPTH(*pP, *pP, *palette_scaling_maxval, newmaxval);
+    }
+    *palette_scaling_maxval = newmaxval;
+  }
+  newcolors = MS_MIN(colors, (int)*reqcolors);
+  acolormap = mediancut(achv, colors, rb->width * rb->height,
+                        *palette_scaling_maxval, newcolors);
+  pam_freeacolorhist(achv);
+
+  *reqcolors = newcolors;
+
+  for (x = 0; x < newcolors; ++x) {
+    palette[x].r = acolormap[x].acolor.r;
+    palette[x].g = acolormap[x].acolor.g;
+    palette[x].b = acolormap[x].acolor.b;
+    palette[x].a = acolormap[x].acolor.a;
+  }
+
+  free(acolormap);
+  free(apixels);
+  return MS_SUCCESS;
+}
+
+int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb) {
+  register int ind;
+  unsigned char *outrow, *pQ;
+  register rgbaPixel *pP;
+  acolorhash_table acht;
+  int usehash;
+  /*
+   ** Step 4: map the colors in the image to their closest match in the
+   ** new colormap, and write 'em out.
+   */
+  acht = pam_allocacolorhash();
+  usehash = 1;
+
+  for (unsigned row = 0; row < qrb->height; ++row) {
+    outrow = &(qrb->data.palette.pixels[row * qrb->width]);
+    unsigned col = 0;
+    pP = (rgbaPixel *)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));
+    ;
+    pQ = outrow;
+    do {
+      /* Check hash table to see if we have already matched this color. */
+      ind = pam_lookupacolor(acht, pP);
+      if (ind == -1) {
+        /* No; search acolormap for closest match. */
+        register int r1, g1, b1, a1, r2, g2, b2, a2;
+        register long dist, newdist;
+
+        r1 = PAM_GETR(*pP);
+        g1 = PAM_GETG(*pP);
+        b1 = PAM_GETB(*pP);
+        a1 = PAM_GETA(*pP);
+        dist = 2000000000;
+        for (unsigned i = 0; i < qrb->data.palette.num_entries; ++i) {
+          r2 = PAM_GETR(qrb->data.palette.palette[i]);
+          g2 = PAM_GETG(qrb->data.palette.palette[i]);
+          b2 = PAM_GETB(qrb->data.palette.palette[i]);
+          a2 = PAM_GETA(qrb->data.palette.palette[i]);
+          /* GRR POSSIBLE BUG */
+          newdist = (r1 - r2) * (r1 - r2) + /* may overflow? */
+                    (g1 - g2) * (g1 - g2) + (b1 - b2) * (b1 - b2) +
+                    (a1 - a2) * (a1 - a2);
+          if (newdist < dist) {
+            ind = i;
+            dist = newdist;
+          }
+        }
+        if (usehash) {
+          if (pam_addtoacolorhash(acht, pP, ind) < 0) {
+            usehash = 0;
+          }
+        }
+      }
+
+      /*          *pP = acolormap[ind].acolor;  */
+      *pQ = (unsigned char)ind;
+
+      ++col;
+      ++pP;
+      ++pQ;
+
+    } while (col != rb->width);
+  }
+  pam_freeacolorhash(acht);
+
+  return MS_SUCCESS;
+}
+
+/*
+ ** Here is the fun part, the median-cut colormap generator.  This is based
+ ** on Paul Heckbert's paper, "Color Image Quantization for Frame Buffer
+ ** Display," SIGGRAPH 1982 Proceedings, page 297.
+ */
+
+static acolorhist_vector mediancut(acolorhist_vector achv, int colors, int sum,
+                                   unsigned char maxval, int newcolors) {
+  acolorhist_vector acolormap;
+  box_vector bv;
+  register int bi, i;
+  int boxes;
+
+  bv = (box_vector)malloc(sizeof(struct box) * newcolors);
+  acolormap =
+      (acolorhist_vector)malloc(sizeof(struct acolorhist_item) * newcolors);
+  if (bv == (box_vector)0 || acolormap == (acolorhist_vector)0) {
+    fprintf(stderr, "  out of memory allocating box vector\n");
+    fflush(stderr);
+    exit(6);
+  }
+  for (i = 0; i < newcolors; ++i)
+    PAM_ASSIGN(acolormap[i].acolor, 0, 0, 0, 0);
+
+  /*
+   ** Set up the initial box.
+   */
+  bv[0].ind = 0;
+  bv[0].colors = colors;
+  bv[0].sum = sum;
+  boxes = 1;
+
+  /*
+   ** Main loop: split boxes until we have enough.
+   */
+  while (boxes < newcolors) {
+    register int indx, clrs;
+    int sm;
+    register int minr, maxr, ming, mina, maxg, minb, maxb, maxa, v;
+    int halfsum, lowersum;
+
+    /*
+     ** Find the first splittable box.
+     */
+    for (bi = 0; bi < boxes; ++bi)
+      if (bv[bi].colors >= 2)
+        break;
+    if (bi == boxes)
+      break; /* ran out of colors! */
+    indx = bv[bi].ind;
+    clrs = bv[bi].colors;
+    sm = bv[bi].sum;
+
+    /*
+     ** Go through the box finding the minimum and maximum of each
+     ** component - the boundaries of the box.
+     */
+    minr = maxr = PAM_GETR(achv[indx].acolor);
+    ming = maxg = PAM_GETG(achv[indx].acolor);
+    minb = maxb = PAM_GETB(achv[indx].acolor);
+    mina = maxa = PAM_GETA(achv[indx].acolor);
+    for (i = 1; i < clrs; ++i) {
+      v = PAM_GETR(achv[indx + i].acolor);
+      if (v < minr)
+        minr = v;
+      if (v > maxr)
+        maxr = v;
+      v = PAM_GETG(achv[indx + i].acolor);
+      if (v < ming)
+        ming = v;
+      if (v > maxg)
+        maxg = v;
+      v = PAM_GETB(achv[indx + i].acolor);
+      if (v < minb)
+        minb = v;
+      if (v > maxb)
+        maxb = v;
+      v = PAM_GETA(achv[indx + i].acolor);
+      if (v < mina)
+        mina = v;
+      if (v > maxa)
+        maxa = v;
+    }
+
+    /*
+     ** Find the largest dimension, and sort by that component.  I have
+     ** included two methods for determining the "largest" dimension;
+     ** first by simply comparing the range in RGB space, and second
+     ** by transforming into luminosities before the comparison.  You
+     ** can switch which method is used by switching the commenting on
+     ** the LARGE_ defines at the beginning of this source file.
+     */
+#ifdef LARGE_NORM
+    if (maxa - mina >= maxr - minr && maxa - mina >= maxg - ming &&
+        maxa - mina >= maxb - minb)
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            alphacompare);
+    else if (maxr - minr >= maxg - ming && maxr - minr >= maxb - minb)
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            redcompare);
+    else if (maxg - ming >= maxb - minb)
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            greencompare);
+    else
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            bluecompare);
+#endif /*LARGE_NORM*/
+#ifdef LARGE_LUM
+    {
+      apixel p;
+      float rl, gl, bl, al;
+
+      PAM_ASSIGN(p, maxr - minr, 0, 0, 0);
+      rl = PPM_LUMIN(p);
+      PAM_ASSIGN(p, 0, maxg - ming, 0, 0);
+      gl = PPM_LUMIN(p);
+      PAM_ASSIGN(p, 0, 0, maxb - minb, 0);
+      bl = PPM_LUMIN(p);
+
+      /*
+      GRR: treat alpha as grayscale and assign (maxa - mina) to each of R, G, B?
+      assign (maxa - mina)/3 to each?
+      use alpha-fractional luminosity?  (normalized_alpha * lum(r,g,b))
+      al = dunno ...
+      [probably should read Heckbert's paper to decide]
+       */
+
+      if (al >= rl && al >= gl && al >= bl)
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              alphacompare);
+      else if (rl >= gl && rl >= bl)
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              redcompare);
+      else if (gl >= bl)
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              greencompare);
+      else
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              bluecompare);
+    }
+#endif /*LARGE_LUM*/
+
+    /*
+     ** Now find the median based on the counts, so that about half the
+     ** pixels (not colors, pixels) are in each subdivision.
+     */
+    lowersum = achv[indx].value;
+    halfsum = sm / 2;
+    for (i = 1; i < clrs - 1; ++i) {
+      if (lowersum >= halfsum)
+        break;
+      lowersum += achv[indx + i].value;
+    }
+
+    /*
+     ** Split the box, and sort to bring the biggest boxes to the top.
+     */
+    bv[bi].colors = i;
+    bv[bi].sum = lowersum;
+    bv[boxes].ind = indx + i;
+    bv[boxes].colors = clrs - i;
+    bv[boxes].sum = sm - lowersum;
+    ++boxes;
+    qsort((char *)bv, boxes, sizeof(struct box), sumcompare);
+  }
+
+  /*
+   ** Ok, we've got enough boxes.  Now choose a representative color for
+   ** each box.  There are a number of possible ways to make this choice.
+   ** One would be to choose the center of the box; this ignores any structure
+   ** within the boxes.  Another method would be to average all the colors in
+   ** the box - this is the method specified in Heckbert's paper.  A third
+   ** method is to average all the pixels in the box.  You can switch which
+   ** method is used by switching the commenting on the REP_ defines at
+   ** the beginning of this source file.
+   */
+  for (bi = 0; bi < boxes; ++bi) {
+#ifdef REP_CENTER_BOX
+    register int indx = bv[bi].ind;
+    register int clrs = bv[bi].colors;
+    register int minr, maxr, ming, maxg, minb, maxb, mina, maxa, v;
+
+    minr = maxr = PAM_GETR(achv[indx].acolor);
+    ming = maxg = PAM_GETG(achv[indx].acolor);
+    minb = maxb = PAM_GETB(achv[indx].acolor);
+    mina = maxa = PAM_GETA(achv[indx].acolor);
+    for (i = 1; i < clrs; ++i) {
+      v = PAM_GETR(achv[indx + i].acolor);
+      minr = min(minr, v);
+      maxr = max(maxr, v);
+      v = PAM_GETG(achv[indx + i].acolor);
+      ming = min(ming, v);
+      maxg = max(maxg, v);
+      v = PAM_GETB(achv[indx + i].acolor);
+      minb = min(minb, v);
+      maxb = max(maxb, v);
+      v = PAM_GETA(achv[indx + i].acolor);
+      mina = min(mina, v);
+      maxa = max(maxa, v);
+    }
+    PAM_ASSIGN(acolormap[bi].acolor, (minr + maxr) / 2, (ming + maxg) / 2,
+               (minb + maxb) / 2, (mina + maxa) / 2);
+#endif /*REP_CENTER_BOX*/
+#ifdef REP_AVERAGE_COLORS
+    register int indx = bv[bi].ind;
+    register int clrs = bv[bi].colors;
+    register long r = 0, g = 0, b = 0, a = 0;
+
+    for (i = 0; i < clrs; ++i) {
+      r += PAM_GETR(achv[indx + i].acolor);
+      g += PAM_GETG(achv[indx + i].acolor);
+      b += PAM_GETB(achv[indx + i].acolor);
+      a += PAM_GETA(achv[indx + i].acolor);
+    }
+    r = r / clrs;
+    g = g / clrs;
+    b = b / clrs;
+    a = a / clrs;
+    PAM_ASSIGN(acolormap[bi].acolor, r, g, b, a);
+#endif /*REP_AVERAGE_COLORS*/
+#ifdef REP_AVERAGE_PIXELS
+    register int indx = bv[bi].ind;
+    register int clrs = bv[bi].colors;
+    register long r = 0, g = 0, b = 0, a = 0, sum = 0;
+
+    for (i = 0; i < clrs; ++i) {
+      r += (long)PAM_GETR(achv[indx + i].acolor) * achv[indx + i].value;
+      g += (long)PAM_GETG(achv[indx + i].acolor) * achv[indx + i].value;
+      b += (long)PAM_GETB(achv[indx + i].acolor) * achv[indx + i].value;
+      a += (long)PAM_GETA(achv[indx + i].acolor) * achv[indx + i].value;
+      sum += achv[indx + i].value;
+    }
+    if (sum > 0) {
+      r = r / sum;
+      if (r > maxval)
+        r = maxval; /* avoid math errors */
+      g = g / sum;
+      if (g > maxval)
+        g = maxval;
+      b = b / sum;
+      if (b > maxval)
+        b = maxval;
+      a = a / sum;
+      if (a > maxval)
+        a = maxval;
+    } else {
+      r = g = b = a = maxval;
+    }
+    /* GRR 20001228:  added casts to quiet warnings; 255 DEPENDENCY */
+    PAM_ASSIGN(acolormap[bi].acolor, (unsigned char)r, (unsigned char)g,
+               (unsigned char)b, (unsigned char)a);
+#endif /*REP_AVERAGE_PIXELS*/
+  }
+
+  /*
+   ** All done.
+   */
+  free(bv);
+  return acolormap;
+}
+
+static int redcompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETR(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETR(((acolorhist_vector)ch2)->acolor);
+}
+
+static int greencompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETG(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETG(((acolorhist_vector)ch2)->acolor);
+}
+
+static int bluecompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETB(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETB(((acolorhist_vector)ch2)->acolor);
+}
+
+static int alphacompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETA(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETA(((acolorhist_vector)ch2)->acolor);
+}
+
+static int sumcompare(const void *b1, const void *b2) {
+  return ((box_vector)b2)->sum - ((box_vector)b1)->sum;
+}
+
+/*===========================================================================*/
+
+/* libpam3.c - pam (portable alpha map) utility library part 3
+ **
+ ** Colormap routines.
+ **
+ ** Copyright (C) 1989, 1991 by Jef Poskanzer.
+ ** Copyright (C) 1997 by Greg Roelofs.
+ **
+ ** Permission to use, copy, modify, and distribute this software and its
+ ** documentation for any purpose and without fee is hereby granted, provided
+ ** that the above copyright notice appear in all copies and that both that
+ ** copyright notice and this permission notice appear in supporting
+ ** documentation.  This software is provided "as is" without express or
+ ** implied warranty.
+ */
+
+/*
+#include "pam.h"
+#include "pamcmap.h"
+ */
+
+#define HASH_SIZE 20023
+
+#define pam_hashapixel(p)                                                      \
+  ((((long)PAM_GETR(p) * 33023 + (long)PAM_GETG(p) * 30013 +                   \
+     (long)PAM_GETB(p) * 27011 + (long)PAM_GETA(p) * 24007) &                  \
+    0x7fffffff) %                                                              \
+   HASH_SIZE)
+
+static acolorhist_vector pam_computeacolorhist(apixels, cols, rows, maxacolors,
+                                               acolorsP)
+rgbaPixel **apixels;
+int cols, rows, maxacolors;
+int *acolorsP;
+{
+  acolorhash_table acht;
+  acolorhist_vector achv;
+
+  acht = pam_computeacolorhash(apixels, cols, rows, maxacolors, acolorsP);
+  if (acht == (acolorhash_table)0)
+    return (acolorhist_vector)0;
+  achv = pam_acolorhashtoacolorhist(acht, maxacolors);
+  pam_freeacolorhash(acht);
+  return achv;
+}
+
+static acolorhash_table pam_computeacolorhash(apixels, cols, rows, maxacolors,
+                                              acolorsP)
+rgbaPixel **apixels;
+int cols, rows, maxacolors;
+int *acolorsP;
+{
+  acolorhash_table acht;
+  register rgbaPixel *pP;
+  acolorhist_list achl;
+  int col, row, hash;
+
+  acht = pam_allocacolorhash();
+  *acolorsP = 0;
+
+  /* Go through the entire image, building a hash table of colors. */
+  for (row = 0; row < rows; ++row)
+    for (col = 0, pP = apixels[row]; col < cols; ++col, ++pP) {
+      hash = pam_hashapixel(*pP);
+      for (achl = acht[hash]; achl != (acolorhist_list)0; achl = achl->next)
+        if (PAM_EQUAL(achl->ch.acolor, *pP))
+          break;
+      if (achl != (acolorhist_list)0)
+        ++(achl->ch.value);
+      else {
+        if (++(*acolorsP) > maxacolors) {
+          pam_freeacolorhash(acht);
+          return (acolorhash_table)0;
+        }
+        achl = (acolorhist_list)malloc(sizeof(struct acolorhist_list_item));
+        if (achl == 0) {
+          fprintf(stderr, "  out of memory computing hash table\n");
+          exit(7);
+        }
+        achl->ch.acolor = *pP;
+        achl->ch.value = 1;
+        achl->next = acht[hash];
+        acht[hash] = achl;
+      }
+    }
+
+  return acht;
+}
+
+static acolorhash_table pam_allocacolorhash() {
+  acolorhash_table acht;
+  int i;
+
+  acht = (acolorhash_table)malloc(HASH_SIZE * sizeof(acolorhist_list));
+  if (acht == 0) {
+    fprintf(stderr, "  out of memory allocating hash table\n");
+    exit(8);
+  }
+
+  for (i = 0; i < HASH_SIZE; ++i)
+    acht[i] = (acolorhist_list)0;
+
+  return acht;
+}
+
+static int pam_addtoacolorhash(acht, acolorP, value)
+acolorhash_table acht;
+rgbaPixel *acolorP;
+int value;
+{
+  register int hash;
+  register acolorhist_list achl;
+
+  achl = (acolorhist_list)msSmallMalloc(sizeof(struct acolorhist_list_item));
+
+  hash = pam_hashapixel(*acolorP);
+  achl->ch.acolor = *acolorP;
+  achl->ch.value = value;
+  achl->next = acht[hash];
+  acht[hash] = achl;
+  return 0;
+}
+
+static acolorhist_vector pam_acolorhashtoacolorhist(acht, maxacolors)
+acolorhash_table acht;
+int maxacolors;
+{
+  acolorhist_vector achv;
+  acolorhist_list achl;
+  int i, j;
+
+  /* Now collate the hash table into a simple acolorhist array. */
+  achv = (acolorhist_vector)malloc(maxacolors * sizeof(struct acolorhist_item));
+  /* (Leave room for expansion by caller.) */
+  if (achv == (acolorhist_vector)0) {
+    fprintf(stderr, "  out of memory generating histogram\n");
+    exit(9);
+  }
+
+  /* Loop through the hash table. */
+  j = 0;
+  for (i = 0; i < HASH_SIZE; ++i)
+    for (achl = acht[i]; achl != (acolorhist_list)0; achl = achl->next) {
+      /* Add the new entry. */
+      achv[j] = achl->ch;
+      ++j;
+    }
+
+  /* All done. */
+  return achv;
+}
+
+static int pam_lookupacolor(acht, acolorP)
+acolorhash_table acht;
+rgbaPixel *acolorP;
+{
+  int hash;
+  acolorhist_list achl;
+
+  hash = pam_hashapixel(*acolorP);
+  for (achl = acht[hash]; achl != (acolorhist_list)0; achl = achl->next)
+    if (PAM_EQUAL(achl->ch.acolor, *acolorP))
+      return achl->ch.value;
+
+  return -1;
+}
+
+static void pam_freeacolorhist(achv) acolorhist_vector achv;
+{ free((char *)achv); }
+
+static void pam_freeacolorhash(acht) acolorhash_table acht;
+{
+  int i;
+  acolorhist_list achl, achlnext;
+
+  for (i = 0; i < HASH_SIZE; ++i)
+    for (achl = acht[i]; achl != (acolorhist_list)0; achl = achlnext) {
+      achlnext = achl->next;
+      free((char *)achl);
+    }
+  free((char *)acht);
+}
diff -pruN 8.0.1-5/src/mapquery.c 8.2.0~beta1-1~exp1/src/mapquery.c
--- 8.0.1-5/src/mapquery.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapquery.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2531 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Layer query support.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#include "limits.h"
+
+/* This object is used by the various mapQueryXXXXX() functions. It stores
+ * the total amount of shapes and their RAM footprint, when they are cached
+ * in the resultCacheObj* of layers. This is the total number accross all
+ * queried layers. However this is isn't persistant accross several calls to
+ * mapQueryXXXXX(), if the resultCacheObj* objects weren't cleaned up. This
+ * is not needed in the context of WFS, for which this is used for now.
+ */
+typedef struct {
+  int cachedShapeCountWarningEmitted;
+  int cachedShapeCount;
+  int cachedShapeRAMWarningEmitted;
+  int cachedShapeRAM;
+} queryCacheObj;
+
+int msInitQuery(queryObj *query) {
+  if (!query)
+    return MS_FAILURE;
+
+  msFreeQuery(query); /* clean up anything previously allocated */
+
+  query->type = MS_QUERY_IS_NULL; /* nothing defined */
+  query->mode = MS_QUERY_SINGLE;
+
+  query->layer = query->slayer = -1;
+
+  query->point.x = query->point.y = -1;
+  query->buffer = 0.0;
+  query->maxresults = 0; /* only used by msQueryByPoint() apparently */
+
+  query->rect.minx = query->rect.miny = query->rect.maxx = query->rect.maxy =
+      -1;
+  query->shape = NULL;
+
+  query->shapeindex = query->tileindex = -1;
+  query->clear_resultcache =
+      MS_TRUE; /* index queries allow the old results to persist */
+
+  query->maxfeatures = -1;
+  query->startindex = -1;
+  query->only_cache_result_count = 0;
+
+  query->filteritem = NULL;
+  msInitExpression(&query->filter);
+
+  query->cache_shapes = MS_FALSE;
+  query->max_cached_shape_count = 0;
+  query->max_cached_shape_ram_amount = 0;
+
+  return MS_SUCCESS;
+}
+
+void msFreeQuery(queryObj *query) {
+  if (query->shape) {
+    msFreeShape(query->shape);
+    free(query->shape);
+  }
+
+  if (query->filteritem)
+    free(query->filteritem);
+  msFreeExpression(&query->filter);
+}
+
+/*
+** Wrapper for all query functions, just feed is a mapObj with a populated
+*queryObj...
+*/
+int msExecuteQuery(mapObj *map) {
+  int tmp = -1, status;
+
+  /* handle slayer/qlayer management for feature queries */
+  if (map->query.slayer >= 0) {
+    tmp = map->query.layer;
+    map->query.layer = map->query.slayer;
+  }
+
+  switch (map->query.type) {
+  case MS_QUERY_BY_POINT:
+    status = msQueryByPoint(map);
+    break;
+  case MS_QUERY_BY_RECT:
+    status = msQueryByRect(map);
+    break;
+  case MS_QUERY_BY_FILTER:
+    status = msQueryByFilter(map);
+    break;
+  case MS_QUERY_BY_SHAPE:
+    status = msQueryByShape(map);
+    break;
+  case MS_QUERY_BY_INDEX:
+    status = msQueryByIndex(map);
+    break;
+  default:
+    msSetError(MS_QUERYERR, "Malformed queryObj.", "msExecuteQuery()");
+    return (MS_FAILURE);
+  }
+
+  if (map->query.slayer >= 0) {
+    map->query.layer = tmp; /* restore layer */
+    if (status == MS_SUCCESS)
+      status = msQueryByFeatures(map);
+  }
+
+  return status;
+}
+
+/*
+** msIsLayerQueryable()  returns MS_TRUE/MS_FALSE
+*/
+int msIsLayerQueryable(layerObj *lp) {
+  int i;
+
+  if (lp->type == MS_LAYER_TILEINDEX)
+    return MS_FALSE;
+
+  if (lp->template && strlen(lp->template) > 0)
+    return MS_TRUE;
+
+  for (i = 0; i < lp->numclasses; i++) {
+    if (lp->class[i] -> template &&strlen(lp->class[i] -> template) > 0)
+      return MS_TRUE;
+  }
+
+  return MS_FALSE;
+}
+
+static void initQueryCache(queryCacheObj *queryCache) {
+  queryCache->cachedShapeCountWarningEmitted = MS_FALSE;
+  queryCache->cachedShapeCount = 0;
+  queryCache->cachedShapeRAMWarningEmitted = MS_FALSE;
+  queryCache->cachedShapeRAM = 0;
+}
+
+/** Check whether we should store the shape in resultCacheObj* given the
+ * limits allowed in map->query.max_cached_shape_count and
+ * map->query.max_cached_shape_ram_amount.
+ */
+static int canCacheShape(mapObj *map, queryCacheObj *queryCache,
+                         int shape_ram_size) {
+  if (!map->query.cache_shapes)
+    return MS_FALSE;
+  if (queryCache->cachedShapeCountWarningEmitted ||
+      (map->query.max_cached_shape_count > 0 &&
+       queryCache->cachedShapeCount >= map->query.max_cached_shape_count)) {
+    if (!queryCache->cachedShapeCountWarningEmitted) {
+      queryCache->cachedShapeCountWarningEmitted = MS_TRUE;
+      if (map->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("map->query.max_cached_shape_count = %d reached. "
+                "Next features will not be cached.\n",
+                map->query.max_cached_shape_count);
+      }
+    }
+    return MS_FALSE;
+  }
+  if (queryCache->cachedShapeRAMWarningEmitted ||
+      (map->query.max_cached_shape_ram_amount > 0 &&
+       queryCache->cachedShapeRAM + shape_ram_size >
+           map->query.max_cached_shape_ram_amount)) {
+    if (!queryCache->cachedShapeRAMWarningEmitted) {
+      queryCache->cachedShapeRAMWarningEmitted = MS_TRUE;
+      if (map->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("map->query.max_cached_shape_ram_amount = %d reached after %d "
+                "cached features. "
+                "Next features will not be cached.\n",
+                map->query.max_cached_shape_ram_amount,
+                queryCache->cachedShapeCount);
+      }
+    }
+    return MS_FALSE;
+  }
+  return MS_TRUE;
+}
+
+static int addResult(mapObj *map, resultCacheObj *cache,
+                     queryCacheObj *queryCache, shapeObj *shape) {
+  int i;
+  int shape_ram_size = (map->query.max_cached_shape_ram_amount > 0)
+                           ? msGetShapeRAMSize(shape)
+                           : 0;
+  int store_shape = canCacheShape(map, queryCache, shape_ram_size);
+
+  if (cache->numresults == cache->cachesize) { /* just add it to the end */
+    if (cache->cachesize == 0)
+      cache->results =
+          (resultObj *)malloc(sizeof(resultObj) * MS_RESULTCACHEINCREMENT);
+    else
+      cache->results = (resultObj *)realloc(
+          cache->results,
+          sizeof(resultObj) * (cache->cachesize + MS_RESULTCACHEINCREMENT));
+    if (!cache->results) {
+      msSetError(MS_MEMERR, "Realloc() error.", "addResult()");
+      return (MS_FAILURE);
+    }
+    cache->cachesize += MS_RESULTCACHEINCREMENT;
+  }
+
+  i = cache->numresults;
+
+  cache->results[i].classindex = shape->classindex;
+  cache->results[i].tileindex = shape->tileindex;
+  cache->results[i].shapeindex = shape->index;
+  cache->results[i].resultindex = shape->resultindex;
+  if (store_shape) {
+    cache->results[i].shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+    msInitShape(cache->results[i].shape);
+    msCopyShape(shape, cache->results[i].shape);
+    queryCache->cachedShapeCount++;
+    queryCache->cachedShapeRAM += shape_ram_size;
+  } else
+    cache->results[i].shape = NULL;
+  cache->numresults++;
+
+  cache->previousBounds = cache->bounds;
+  if (cache->numresults == 1)
+    cache->bounds = shape->bounds;
+  else
+    msMergeRect(&(cache->bounds), &(shape->bounds));
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Serialize a query result set to disk.
+*/
+static int saveQueryResults(mapObj *map, char *filename) {
+  FILE *stream;
+  int i, j, n = 0;
+
+  if (!filename) {
+    msSetError(MS_MISCERR, "No filename provided to save query results to.",
+               "saveQueryResults()");
+    return MS_FAILURE;
+  }
+
+  stream = fopen(filename, "w");
+  if (!stream) {
+    msSetError(MS_IOERR, "(%s)", "saveQueryResults()", filename);
+    return MS_FAILURE;
+  }
+
+  fprintf(stream, "%s - Generated by msSaveQuery()\n",
+          MS_QUERY_RESULTS_MAGIC_STRING);
+
+  /* count the number of layers with results */
+  for (i = 0; i < map->numlayers; i++)
+    if (GET_LAYER(map, i)->resultcache)
+      n++;
+  fwrite(&n, sizeof(int), 1, stream);
+
+  /* now write the result set for each layer */
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->resultcache) {
+      fwrite(&i, sizeof(int), 1, stream); /* layer index */
+      fwrite(&(GET_LAYER(map, i)->resultcache->numresults), sizeof(int), 1,
+             stream); /* number of results */
+      fwrite(&(GET_LAYER(map, i)->resultcache->bounds), sizeof(rectObj), 1,
+             stream); /* bounding box */
+      for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++)
+        fwrite(&(GET_LAYER(map, i)->resultcache->results[j]), sizeof(resultObj),
+               1, stream); /* each result */
+    }
+  }
+
+  fclose(stream);
+  return MS_SUCCESS;
+}
+
+static int loadQueryResults(mapObj *map, FILE *stream) {
+  int i, j, k, n = 0;
+
+  if (1 != fread(&n, sizeof(int), 1, stream) || n > INT_MAX - 1) {
+    msSetError(MS_MISCERR, "failed to read query count from query file stream",
+               "loadQueryResults()");
+    return MS_FAILURE;
+  }
+
+  /* now load the result set for each layer found in the query file */
+  for (i = 0; i < n; i++) {
+    if (1 != fread(&j, sizeof(int), 1, stream)) { /* layer index */
+      msSetError(MS_MISCERR,
+                 "failed to read layer index from query file stream",
+                 "loadQueryResults()");
+      return MS_FAILURE;
+    }
+
+    if (j < 0 || j > map->numlayers) {
+      msSetError(MS_MISCERR, "Invalid layer index loaded from query file.",
+                 "loadQueryResults()");
+      return MS_FAILURE;
+    }
+
+    /* inialize the results for this layer */
+    GET_LAYER(map, j)->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    MS_CHECK_ALLOC(GET_LAYER(map, j)->resultcache, sizeof(resultCacheObj),
+                   MS_FAILURE);
+
+    if (1 != fread(&(GET_LAYER(map, j)->resultcache->numresults), sizeof(int),
+                   1, stream) ||
+        (GET_LAYER(map, j)->resultcache->numresults <
+         0)) { /* number of results */
+      msSetError(MS_MISCERR,
+                 "failed to read number of results from query file stream",
+                 "loadQueryResults()");
+      free(GET_LAYER(map, j)->resultcache);
+      GET_LAYER(map, j)->resultcache = NULL;
+      return MS_FAILURE;
+    }
+    GET_LAYER(map, j)->resultcache->cachesize =
+        GET_LAYER(map, j)->resultcache->numresults;
+
+    if (1 != fread(&(GET_LAYER(map, j)->resultcache->bounds), sizeof(rectObj),
+                   1, stream)) { /* bounding box */
+      msSetError(MS_MISCERR, "failed to read bounds from query file stream",
+                 "loadQueryResults()");
+      free(GET_LAYER(map, j)->resultcache);
+      GET_LAYER(map, j)->resultcache = NULL;
+      return MS_FAILURE;
+    }
+
+    GET_LAYER(map, j)->resultcache->results = (resultObj *)malloc(
+        sizeof(resultObj) * GET_LAYER(map, j)->resultcache->numresults);
+    if (GET_LAYER(map, j)->resultcache->results == NULL) {
+      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                 "loadQueryResults()", __FILE__, __LINE__,
+                 (unsigned int)(sizeof(resultObj) *
+                                GET_LAYER(map, j)->resultcache->numresults));
+      free(GET_LAYER(map, j)->resultcache);
+      GET_LAYER(map, j)->resultcache = NULL;
+      return MS_FAILURE;
+    }
+
+    for (k = 0; k < GET_LAYER(map, j)->resultcache->numresults; k++) {
+      if (1 != fread(&(GET_LAYER(map, j)->resultcache->results[k]),
+                     sizeof(resultObj), 1, stream)) { /* each result */
+        msSetError(MS_MISCERR,
+                   "failed to read result %d from query file stream",
+                   "loadQueryResults()", k);
+        free(GET_LAYER(map, j)->resultcache->results);
+        free(GET_LAYER(map, j)->resultcache);
+        GET_LAYER(map, j)->resultcache = NULL;
+        return MS_FAILURE;
+      }
+      if (!GET_LAYER(map, j)->tileindex)
+        GET_LAYER(map, j)->resultcache->results[k].tileindex =
+            -1; /* reset the tile index for non-tiled layers */
+      GET_LAYER(map, j)->resultcache->results[k].resultindex =
+          -1; /* all results loaded this way have a -1 result (set) index */
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Serialize the parameters necessary to duplicate a query to disk. (TODO: add
+*filter query...)
+*/
+static int saveQueryParams(mapObj *map, char *filename) {
+  FILE *stream;
+
+  if (!filename) {
+    msSetError(MS_MISCERR, "No filename provided to save query to.",
+               "saveQueryParams()");
+    return MS_FAILURE;
+  }
+
+  stream = fopen(filename, "w");
+  if (!stream) {
+    msSetError(MS_IOERR, "(%s)", "saveQueryParams()", filename);
+    return MS_FAILURE;
+  }
+
+  fprintf(stream, "%s - Generated by msSaveQuery()\n",
+          MS_QUERY_PARAMS_MAGIC_STRING);
+
+  fprintf(stream, "%d %d %d %d\n", map->query.mode, map->query.type,
+          map->query.layer, map->query.slayer); /* all queries */
+  fprintf(stream, "%.15g %.15g %g %d\n", map->query.point.x, map->query.point.y,
+          map->query.buffer, map->query.maxresults); /* by point */
+  fprintf(stream, "%.15g %.15g %.15g %.15g\n", map->query.rect.minx,
+          map->query.rect.miny, map->query.rect.maxx,
+          map->query.rect.maxy); /* by rect */
+  fprintf(stream, "%ld %ld %d\n", map->query.shapeindex, map->query.tileindex,
+          map->query.clear_resultcache); /* by index */
+
+  fprintf(stream, "%s\n",
+          (map->query.filteritem) ? map->query.filteritem
+                                  : "NULL"); /* by filter */
+  fprintf(stream, "%s\n",
+          (map->query.filter.string) ? map->query.filter.string : "NULL");
+
+  if (map->query.shape) { /* by shape */
+    int i, j;
+    shapeObj *s = map->query.shape;
+
+    fprintf(stream, "%d\n", s->type);
+    fprintf(stream, "%d\n", s->numlines);
+    for (i = 0; i < s->numlines; i++) {
+      fprintf(stream, "%d\n", s->line[i].numpoints);
+      for (j = 0; j < s->line[i].numpoints; j++)
+        fprintf(stream, "%.15g %.15g\n", s->line[i].point[j].x,
+                s->line[i].point[j].y);
+    }
+  } else {
+    fprintf(stream, "%d\n", MS_SHAPE_NULL); /* NULL shape */
+  }
+
+  fclose(stream);
+  return MS_SUCCESS;
+}
+
+static int loadQueryParams(mapObj *map, FILE *stream) {
+  char buffer[MS_BUFFER_LENGTH];
+  int lineno;
+
+  int shapetype, numlines, numpoints;
+
+  msInitQuery(&(map->query)); /* this will free any previous query as well */
+
+  lineno = 2; /* line 1 is the magic string */
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+    switch (lineno) {
+    case 2:
+      if (sscanf(buffer, "%d %d %d %d\n", &(map->query.mode),
+                 &(map->query.type), &(map->query.layer),
+                 &(map->query.slayer)) != 4)
+        goto parse_error;
+      break;
+    case 3:
+      if (sscanf(buffer, "%lf %lf %lf %d\n", &map->query.point.x,
+                 &map->query.point.y, &map->query.buffer,
+                 &map->query.maxresults) != 4)
+        goto parse_error;
+      break;
+    case 4:
+      if (sscanf(buffer, "%lf %lf %lf %lf\n", &map->query.rect.minx,
+                 &map->query.rect.miny, &map->query.rect.maxx,
+                 &map->query.rect.maxy) != 4)
+        goto parse_error;
+      break;
+    case 5:
+      if (sscanf(buffer, "%ld %ld %d\n", &map->query.shapeindex,
+                 &map->query.tileindex, &map->query.clear_resultcache) != 3)
+        goto parse_error;
+      break;
+    case 6:
+      if (strncmp(buffer, "NULL", 4) != 0) {
+        map->query.filteritem = msStrdup(buffer);
+        msStringChop(map->query.filteritem);
+      }
+      break;
+    case 7:
+      if (strncmp(buffer, "NULL", 4) != 0)
+        msLoadExpressionString(&map->query.filter, buffer); /* chop buffer */
+      break;
+    case 8:
+      if (sscanf(buffer, "%d\n", &shapetype) != 1)
+        goto parse_error;
+
+      if (shapetype != MS_SHAPE_NULL) { /* load the rest of the shape */
+        int i, j;
+        lineObj line;
+
+        map->query.shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+        msInitShape(map->query.shape);
+        map->query.shape->type = shapetype;
+
+        if (fscanf(stream, "%d\n", &numlines) != 1)
+          goto parse_error;
+        if (numlines > INT_MAX - 1)
+          goto parse_error;
+        for (i = 0; i < numlines; i++) {
+          if (fscanf(stream, "%d\n", &numpoints) != 1 || numpoints < 0 ||
+              numpoints > INT_MAX / (int)sizeof(pointObj))
+            goto parse_error;
+
+          line.numpoints = numpoints;
+          line.point =
+              (pointObj *)msSmallMalloc(line.numpoints * sizeof(pointObj));
+
+          for (j = 0; j < numpoints; j++)
+            if (fscanf(stream, "%lf %lf\n", &line.point[j].x,
+                       &line.point[j].y) != 2)
+              goto parse_error;
+
+          msAddLine(map->query.shape, &line);
+          free(line.point);
+        }
+      }
+      break;
+    default:
+      break;
+    }
+
+    lineno++;
+  }
+
+  /* TODO: should we throw an error if lineno != 10? */
+
+  /* force layer and slayer on */
+  if (map->query.layer >= 0 && map->query.layer < map->numlayers)
+    GET_LAYER(map, map->query.layer)->status = MS_ON;
+  if (map->query.slayer >= 0 && map->query.slayer < map->numlayers)
+    GET_LAYER(map, map->query.slayer)->status = MS_ON;
+
+  /* now execute the query */
+  return msExecuteQuery(map);
+
+parse_error:
+  msSetError(MS_MISCERR, "Parse error line %d.", "loadQueryParameters()",
+             lineno);
+  return MS_FAILURE;
+}
+
+/*
+** Save (serialize) a query to disk. There are two methods, one saves the query
+*parameters and the other saves
+** all the shape indexes. Note the latter can be very slow against certain data
+*sources but has a certain usefulness
+** on occation.
+*/
+int msSaveQuery(mapObj *map, char *filename, int results) {
+  if (results)
+    return saveQueryResults(map, filename);
+  else
+    return saveQueryParams(map, filename);
+}
+
+/*
+** Loads a query file contained either serialized 1) query parameters or 2)
+*query results (e.g. indexes).
+*/
+int msLoadQuery(mapObj *map, char *filename) {
+  FILE *stream;
+  char buffer[MS_BUFFER_LENGTH];
+  int retval = MS_FAILURE;
+
+  if (!filename) {
+    msSetError(MS_MISCERR, "No filename provided to load query from.",
+               "msLoadQuery()");
+    return MS_FAILURE;
+  }
+
+  /*
+  ** Make sure the file at least has the right extension.
+  */
+  if (msEvalRegex("\\.qy$", filename) != MS_TRUE) {
+    msSetError(MS_MISCERR, "Queryfile %s has incorrect file extension.",
+               "msLoadQuery()", filename);
+    return MS_FAILURE;
+  }
+
+  /*
+  ** Open the file and inspect the first line.
+  */
+  stream = fopen(filename, "r");
+  if (!stream) {
+    msSetError(MS_IOERR, "(%s)", "msLoadQuery()", filename);
+    return MS_FAILURE;
+  }
+
+  if (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+    /*
+    ** Call correct reader based on the magic string.
+    */
+    if (strncasecmp(buffer, MS_QUERY_RESULTS_MAGIC_STRING,
+                    strlen(MS_QUERY_RESULTS_MAGIC_STRING)) == 0) {
+      retval = loadQueryResults(map, stream);
+    } else if (strncasecmp(buffer, MS_QUERY_PARAMS_MAGIC_STRING,
+                           strlen(MS_QUERY_PARAMS_MAGIC_STRING)) == 0) {
+      retval = loadQueryParams(map, stream);
+    } else {
+      msSetError(
+          MS_WEBERR,
+          "Missing magic string, %s doesn't look like a MapServer query file.",
+          "msLoadQuery()", filename);
+      retval = MS_FAILURE;
+    }
+  } else {
+    msSetError(MS_WEBERR, "Empty file or failed read for %s.", "msLoadQuery()",
+               filename);
+    retval = MS_FAILURE;
+  }
+
+  fclose(stream);
+  return retval;
+}
+
+int msQueryByIndex(mapObj *map) {
+  layerObj *lp;
+  int status;
+
+  resultObj record;
+  queryCacheObj queryCache;
+
+  shapeObj shape;
+  double minfeaturesize = -1;
+
+  initQueryCache(&queryCache);
+
+  if (map->query.type != MS_QUERY_BY_INDEX) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByIndex()");
+    return (MS_FAILURE);
+  }
+
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers) {
+    msSetError(MS_QUERYERR, "No query layer defined.", "msQueryByIndex()");
+    return (MS_FAILURE);
+  }
+
+  lp = (GET_LAYER(map, map->query.layer));
+
+  if (!msIsLayerQueryable(lp)) {
+    msSetError(MS_QUERYERR, "Requested layer has no templates defined.",
+               "msQueryByIndex()");
+    return (MS_FAILURE);
+  }
+
+  if (map->query.clear_resultcache) {
+    if (lp->resultcache) {
+      cleanupResultCache(lp->resultcache);
+      free(lp->resultcache);
+      lp->resultcache = NULL;
+    }
+  }
+
+  msLayerClose(lp); /* reset */
+  status = msLayerOpen(lp);
+  if (status != MS_SUCCESS)
+    return (MS_FAILURE);
+  /* disable driver paging */
+  msLayerEnablePaging(lp, MS_FALSE);
+
+  /* build item list, we want *all* items */
+  status = msLayerWhichItems(lp, MS_TRUE, NULL);
+  if (status != MS_SUCCESS)
+    return (MS_FAILURE);
+
+  if (map->query.clear_resultcache || lp->resultcache == NULL) {
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
+    initResultCache(lp->resultcache);
+  }
+
+  msInitShape(&shape);
+
+  record.resultindex = -1;
+  record.shapeindex = map->query.shapeindex;
+  record.tileindex = map->query.tileindex;
+
+  status = msLayerGetShape(lp, &shape, &record);
+  if (status != MS_SUCCESS) {
+    msSetError(MS_QUERYERR, "Not valid record request.", "msQueryByIndex()");
+    return (MS_FAILURE);
+  }
+
+  /*
+   * The resultindex is used to retrieve a specific item from the result cache.
+   * Usually, the row number will be used as resultindex. But when working with
+   * databases and querying a single result, the row number is typically 0 and
+   * thus useless as the index in the result cache. See #4926 #4076. Only shape
+   * files and flatgeobuf are considered to have consistent row numbers.
+   */
+  if (!(lp->connectiontype == MS_SHAPEFILE ||
+        lp->connectiontype == MS_TILED_SHAPEFILE ||
+        lp->connectiontype == MS_FLATGEOBUF)) {
+    shape.resultindex = -1;
+  }
+
+  if (lp->minfeaturesize > 0)
+    minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
+
+  /* Check if the shape size is ok to be drawn */
+  if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+      (minfeaturesize > 0)) {
+
+    if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
+      msSetError(MS_QUERYERR,
+                 "Requested shape not valid against layer minfeaturesize.",
+                 "msQueryByIndex()");
+      msFreeShape(&shape);
+      msLayerClose(lp);
+      return (MS_FAILURE);
+    }
+  }
+
+  shape.classindex = msShapeGetClass(lp, map, &shape, NULL, 0);
+  if (!(lp->template) &&
+      ((shape.classindex == -1) ||
+       (lp->class[shape.classindex] -> status ==
+                                           MS_OFF))) { /* not a valid shape */
+    msSetError(MS_QUERYERR,
+               "Requested shape not valid against layer classification scheme.",
+               "msQueryByIndex()");
+    msFreeShape(&shape);
+    msLayerClose(lp);
+    return (MS_FAILURE);
+  }
+
+  if (!(lp->template) &&
+      !(lp->class[shape.classindex] -> template)) { /* no valid template */
+    msSetError(MS_QUERYERR,
+               "Requested shape does not have a valid template, no way to "
+               "present results.",
+               "msQueryByIndex()");
+    msFreeShape(&shape);
+    msLayerClose(lp);
+    return (MS_FAILURE);
+  }
+
+  addResult(map, lp->resultcache, &queryCache, &shape);
+
+  msFreeShape(&shape);
+  /* msLayerClose(lp); */
+
+  return (MS_SUCCESS);
+}
+
+static char *filterTranslateToLogical(expressionObj *filter, char *filteritem) {
+  char *string = NULL;
+
+  if (filter->type == MS_STRING && filteritem) {
+    string = msStrdup("'[");
+    string = msStringConcatenate(string, filteritem);
+    string = msStringConcatenate(string, "]'");
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      string = msStringConcatenate(string, " =* '");
+    else
+      string = msStringConcatenate(string, " = '");
+    string = msStringConcatenate(string, filter->string);
+    string = msStringConcatenate(string, "'");
+  } else if (filter->type == MS_REGEX && filteritem) {
+    string = msStrdup("'[");
+    string = msStringConcatenate(string, filteritem);
+    string = msStringConcatenate(string, "]'");
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      string = msStringConcatenate(string, " ~* '");
+    else
+      string = msStringConcatenate(string, " ~ '");
+    string = msStringConcatenate(string, filter->string);
+    string = msStringConcatenate(string, "'");
+  } else if (filter->type == MS_EXPRESSION) {
+    string = msStrdup(filter->string);
+  } else {
+    /* native expression, nothing we can do - sigh */
+  }
+
+  return string;
+}
+
+static expressionObj mergeFilters(expressionObj *filter1, char *filteritem1,
+                                  expressionObj *filter2, char *filteritem2) {
+  expressionObj filter;
+
+  char *tmpstr1 = NULL;
+  char *tmpstr2 = NULL;
+
+  msInitExpression(&filter);
+  filter.type = MS_EXPRESSION; /* we're building a logical expression */
+
+  tmpstr1 = filterTranslateToLogical(filter1, filteritem1);
+  if (!tmpstr1)
+    return filter; /* should only happen if the filter was a native filter */
+
+  tmpstr2 = filterTranslateToLogical(filter2, filteritem2);
+  if (!tmpstr2) {
+    msFree(tmpstr1);
+    return filter; /* should only happen if the filter was a native filter */
+  }
+
+  filter.string = msStrdup(tmpstr1);
+  filter.string = msStringConcatenate(filter.string, " AND ");
+  filter.string = msStringConcatenate(filter.string, tmpstr2);
+
+  msFree(tmpstr1);
+  msFree(tmpstr2);
+
+  return filter;
+}
+
+/*
+** Query using common expression syntax.
+*/
+int msQueryByFilter(mapObj *map) {
+  int l;
+  int start, stop = 0;
+
+  layerObj *lp;
+
+  char status;
+
+  char *old_filteritem = NULL;
+  expressionObj old_filter;
+
+  rectObj search_rect;
+  const rectObj invalid_rect = MS_INIT_INVALID_RECT;
+
+  shapeObj shape;
+  int paging;
+
+  int nclasses = 0;
+  int *classgroup = NULL;
+  double minfeaturesize = -1;
+  queryCacheObj queryCache;
+
+  initQueryCache(&queryCache);
+
+  if (map->query.type != MS_QUERY_BY_FILTER) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByFilter()");
+    return (MS_FAILURE);
+  }
+  if (!map->query.filter.string) {
+    msSetError(MS_QUERYERR, "Filter is not set.", "msQueryByFilter()");
+    return (MS_FAILURE);
+  }
+
+  // fprintf(stderr, "in msQueryByFilter: filter=%s, filteritem=%s\n",
+  // map->query.filter.string, map->query.filteritem);
+
+  msInitShape(&shape);
+
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
+  else
+    start = stop = map->query.layer;
+
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
+
+    lp = (GET_LAYER(map, l));
+    if (map->query.maxfeatures == 0)
+      break; /* nothing else to do */
+    else if (map->query.maxfeatures > 0)
+      lp->maxfeatures = map->query.maxfeatures;
+
+    /* using mapscript, the map->query.startindex will be unset... */
+    if (lp->startindex > 1 && map->query.startindex < 0)
+      map->query.startindex = lp->startindex;
+
+    /* conditions may have changed since this layer last drawn, so set
+       layer->project true to recheck projection needs (Bug #673) */
+    lp->project = MS_TRUE;
+
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
+      free(lp->resultcache);
+      lp->resultcache = NULL;
+    }
+
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
+    if (lp->type == MS_LAYER_RASTER)
+      continue; /* ok to skip? */
+
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
+    }
+
+    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
+    }
+
+    paging = msLayerGetPaging(lp);
+    msLayerClose(lp); /* reset */
+    status = msLayerOpen(lp);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+    msLayerEnablePaging(lp, paging);
+
+    /* disable driver paging */
+    // msLayerEnablePaging(lp, MS_FALSE);
+
+    old_filteritem = lp->filteritem; /* cache the existing filter/filteritem */
+    msInitExpression(&old_filter);
+    msCopyExpression(&old_filter, &lp->filter);
+
+    /*
+    ** Set the lp->filter and lp->filteritem (may need to merge). Remember
+    *filters are *always* MapServer syntax.
+    */
+    lp->filteritem = map->query.filteritem; /* re-point lp->filteritem */
+    if (old_filter.string !=
+        NULL) { /* need to merge filters to create one logical expression */
+      msFreeExpression(&lp->filter);
+      lp->filter = mergeFilters(&map->query.filter, map->query.filteritem,
+                                &old_filter, old_filteritem);
+      if (!lp->filter.string) {
+        msSetError(MS_MISCERR, "Filter merge failed, able to process query.",
+                   "msQueryByFilter()");
+        goto restore_old_filter;
+      }
+    } else {
+      msCopyExpression(&lp->filter, &map->query.filter); /* apply new filter */
+    }
+
+    /* build item list, we want *all* items, note this *also* build tokens for
+     * the layer filter */
+    status = msLayerWhichItems(lp, MS_TRUE, NULL);
+    if (status != MS_SUCCESS)
+      goto restore_old_filter;
+
+    search_rect = map->query.rect;
+
+    /* If only result count is needed, we can use msLayerGetShapeCount() */
+    /* that has optimizations to avoid retrieving individual features */
+    if (map->query.only_cache_result_count &&
+        lp->template != NULL && /* always TRUE for WFS case */
+        lp->minfeaturesize <= 0) {
+      int bUseLayerSRS = MS_FALSE;
+      int numFeatures = -1;
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+      /* Optimization to detect the case where a WFS query uses in fact the */
+      /* whole layer extent, but expressed in a map SRS different from the layer
+       * SRS */
+      /* In the case, we can directly request against the layer extent in its
+       * native SRS */
+      if (lp->project &&
+          memcmp(&search_rect, &invalid_rect, sizeof(search_rect)) != 0 &&
+          msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+        rectObj layerExtent;
+        if (msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS) {
+          rectObj ext = layerExtent;
+          ext.minx -= 1e-5;
+          ext.miny -= 1e-5;
+          ext.maxx += 1e-5;
+          ext.maxy += 1e-5;
+          msProjectRect(&(lp->projection), &(map->projection), &ext);
+          if (fabs(ext.minx - search_rect.minx) <= 2e-5 &&
+              fabs(ext.miny - search_rect.miny) <= 2e-5 &&
+              fabs(ext.maxx - search_rect.maxx) <= 2e-5 &&
+              fabs(ext.maxy - search_rect.maxy) <= 2e-5) {
+            bUseLayerSRS = MS_TRUE;
+            numFeatures =
+                msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
+          }
+        }
+      }
+#endif
+
+      if (!bUseLayerSRS)
+        numFeatures = msLayerGetShapeCount(lp, search_rect, &(map->projection));
+      if (numFeatures >= 0) {
+        lp->resultcache = (resultCacheObj *)malloc(sizeof(
+            resultCacheObj)); /* allocate and initialize the result cache */
+        MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
+        initResultCache(lp->resultcache);
+        lp->resultcache->numresults = numFeatures;
+        if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
+          lp->resultcache->numresults -= (map->query.startindex - 1);
+        }
+
+        lp->filteritem = old_filteritem; /* point back to original value */
+        msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
+        msFreeExpression(&old_filter);
+
+        continue;
+      }
+      // Fallback in case of error (should not happen normally)
+    }
+
+    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
+    if (lp->project &&
+        memcmp(&search_rect, &invalid_rect, sizeof(search_rect)) != 0)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &search_rect); /* project the searchrect to source coords */
+
+    status = msLayerWhichShapes(lp, search_rect, MS_TRUE);
+    if (status == MS_DONE) {           /* no overlap */
+      lp->filteritem = old_filteritem; /* point back to original value */
+      msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
+      msFreeExpression(&old_filter);
+      msLayerClose(lp);
+      continue;
+    } else if (status != MS_SUCCESS)
+      goto restore_old_filter;
+
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    initResultCache(lp->resultcache);
+
+    nclasses = 0;
+    classgroup = NULL;
+    if (lp->classgroup && lp->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(lp, &nclasses);
+
+    if (lp->minfeaturesize > 0)
+      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
+
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes - if necessary the filter is
+                            applied in msLayerNextShape(...) */
+
+      /* Check if the shape size is ok to be drawn */
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
+        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByFilter(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
+          msFreeShape(&shape);
+          continue;
+        }
+      }
+
+      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
+        }
+        msProjectShapeEx(reprojector, &shape);
+      }
+
+      /* Should we skip this feature? */
+      if (!paging && map->query.startindex > 1) {
+        --map->query.startindex;
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (map->query.only_cache_result_count)
+        lp->resultcache->numresults++;
+      else
+        addResult(map, lp->resultcache, &queryCache, &shape);
+      msFreeShape(&shape);
+
+      if (map->query.mode ==
+          MS_QUERY_SINGLE) { /* no need to look any further */
+        status = MS_DONE;
+        break;
+      }
+
+      /* check shape count */
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
+        status = MS_DONE;
+        break;
+      }
+    } /* next shape */
+
+    if (classgroup)
+      msFree(classgroup);
+
+    lp->filteritem = old_filteritem; /* point back to original value */
+    msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
+    msFreeExpression(&old_filter);
+
+    msProjectDestroyReprojector(reprojector);
+
+    if (status != MS_DONE)
+      return MS_FAILURE;
+    if (!map->query.only_cache_result_count && lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+  }                     /* next layer */
+
+  /* was anything found? */
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return MS_SUCCESS;
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_V) {
+    msDebug("msQueryByFilter(): No matching record(s) found.\n");
+  }
+  return (MS_SUCCESS);
+
+restore_old_filter:
+  lp->filteritem = old_filteritem;
+  msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
+  msFreeExpression(&old_filter);
+  msLayerClose(lp);
+  return MS_FAILURE;
+}
+
+int msQueryByRect(mapObj *map) {
+  int l; /* counters */
+  int start, stop = 0;
+
+  layerObj *lp;
+
+  char status;
+  shapeObj shape, searchshape;
+  rectObj searchrect, searchrectInMapProj;
+  const rectObj invalid_rect = MS_INIT_INVALID_RECT;
+  double layer_tolerance = 0, tolerance = 0;
+
+  int paging;
+  int nclasses = 0;
+  int *classgroup = NULL;
+  double minfeaturesize = -1;
+  queryCacheObj queryCache;
+
+  initQueryCache(&queryCache);
+
+  if (map->query.type != MS_QUERY_BY_RECT) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByRect()");
+    return (MS_FAILURE);
+  }
+
+  msInitShape(&shape);
+  msInitShape(&searchshape);
+
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
+  else
+    start = stop = map->query.layer;
+
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
+    lp = (GET_LAYER(map, l));
+    /* Set the global maxfeatures */
+    if (map->query.maxfeatures == 0)
+      break; /* nothing else to do */
+    else if (map->query.maxfeatures > 0)
+      lp->maxfeatures = map->query.maxfeatures;
+
+    /* using mapscript, the map->query.startindex will be unset... */
+    if (lp->startindex > 1 && map->query.startindex < 0)
+      map->query.startindex = lp->startindex;
+
+    /* conditions may have changed since this layer last drawn, so set
+       layer->project true to recheck projection needs (Bug #673) */
+    lp->project = MS_TRUE;
+
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
+      free(lp->resultcache);
+      lp->resultcache = NULL;
+    }
+
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
+
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
+    }
+
+    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
+    }
+
+    searchrect = map->query.rect;
+    if (lp->tolerance > 0) {
+      layer_tolerance = lp->tolerance;
+
+      if (lp->toleranceunits == MS_PIXELS)
+        tolerance = layer_tolerance *
+                    msAdjustExtent(&(map->extent), map->width, map->height);
+      else
+        tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                                       msInchesPerUnit(map->units, 0));
+
+      searchrect.minx -= tolerance;
+      searchrect.maxx += tolerance;
+      searchrect.miny -= tolerance;
+      searchrect.maxy += tolerance;
+    }
+    searchrectInMapProj = searchrect;
+
+    msRectToPolygon(searchrect, &searchshape);
+
+    /* Raster layers are handled specially. */
+    if (lp->type == MS_LAYER_RASTER) {
+      if (msRasterQueryByRect(map, lp, searchrect) == MS_FAILURE)
+        return MS_FAILURE;
+
+      continue;
+    }
+
+    /* Paging could have been disabled before */
+    paging = msLayerGetPaging(lp);
+    msLayerClose(lp); /* reset */
+    status = msLayerOpen(lp);
+    if (status != MS_SUCCESS) {
+      msFreeShape(&searchshape);
+      return (MS_FAILURE);
+    }
+    msLayerEnablePaging(lp, paging);
+
+    /* build item list, we want *all* items */
+    status = msLayerWhichItems(lp, MS_TRUE, NULL);
+
+    if (status != MS_SUCCESS) {
+      msFreeShape(&searchshape);
+      return (MS_FAILURE);
+    }
+
+    /* If only result count is needed, we can use msLayerGetShapeCount() */
+    /* that has optimizations to avoid retrieving individual features */
+    if (map->query.only_cache_result_count &&
+        lp->template != NULL && /* always TRUE for WFS case */
+        lp->minfeaturesize <= 0) {
+      int bUseLayerSRS = MS_FALSE;
+      int numFeatures = -1;
+
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+      /* Optimization to detect the case where a WFS query uses in fact the */
+      /* whole layer extent, but expressed in a map SRS different from the layer
+       * SRS */
+      /* In the case, we can directly request against the layer extent in its
+       * native SRS */
+      if (lp->project &&
+          memcmp(&searchrect, &invalid_rect, sizeof(searchrect)) != 0 &&
+          msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+        rectObj layerExtent;
+        if (msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS) {
+          rectObj ext = layerExtent;
+          ext.minx -= 1e-5;
+          ext.miny -= 1e-5;
+          ext.maxx += 1e-5;
+          ext.maxy += 1e-5;
+          msProjectRect(&(lp->projection), &(map->projection), &ext);
+          if (fabs(ext.minx - searchrect.minx) <= 2e-5 &&
+              fabs(ext.miny - searchrect.miny) <= 2e-5 &&
+              fabs(ext.maxx - searchrect.maxx) <= 2e-5 &&
+              fabs(ext.maxy - searchrect.maxy) <= 2e-5) {
+            bUseLayerSRS = MS_TRUE;
+            numFeatures =
+                msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
+          }
+        }
+      }
+#endif
+
+      if (!bUseLayerSRS)
+        numFeatures = msLayerGetShapeCount(lp, searchrect, &(map->projection));
+      if (numFeatures >= 0) {
+        lp->resultcache = (resultCacheObj *)malloc(sizeof(
+            resultCacheObj)); /* allocate and initialize the result cache */
+        MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
+        initResultCache(lp->resultcache);
+        lp->resultcache->numresults = numFeatures;
+        if (!paging && map->query.startindex > 1) {
+          lp->resultcache->numresults -= (map->query.startindex - 1);
+        }
+        msFreeShape(&searchshape);
+        continue;
+      }
+      // Fallback in case of error (should not happen normally)
+    }
+
+    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
+    if (lp->project &&
+        memcmp(&searchrect, &invalid_rect, sizeof(searchrect)) != 0)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &searchrect); /* project the searchrect to source coords */
+
+    status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
+    if (status == MS_DONE) { /* no overlap */
+      msLayerClose(lp);
+      continue;
+    } else if (status != MS_SUCCESS) {
+      msLayerClose(lp);
+      msFreeShape(&searchshape);
+      return (MS_FAILURE);
+    }
+
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
+    initResultCache(lp->resultcache);
+
+    nclasses = 0;
+    classgroup = NULL;
+    if (lp->classgroup && lp->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(lp, &nclasses);
+
+    if (lp->minfeaturesize > 0)
+      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
+
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes */
+
+      /* Check if the shape size is ok to be drawn */
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
+        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByRect(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
+          msFreeShape(&shape);
+          continue;
+        }
+      }
+
+      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
+        }
+        if (msProjectShapeEx(reprojector, &shape) != MS_SUCCESS) {
+          // msProjectShapeEx() calls msFreeShape() on error
+          continue;
+        }
+      }
+
+      if (msRectContained(&shape.bounds, &searchrectInMapProj) ==
+          MS_TRUE) { /* if the whole shape is in, don't intersect */
+        status = MS_TRUE;
+      } else {
+        switch (shape.type) { /* make sure shape actually intersects the qrect
+                                 (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
+        case MS_SHAPE_POINT:
+          status = msIntersectMultipointPolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_LINE:
+          status = msIntersectPolylinePolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_POLYGON:
+          status = msIntersectPolygons(&shape, &searchshape);
+          break;
+        case MS_SHAPE_NULL:
+          status = MS_TRUE;
+          break;
+        default:
+          break;
+        }
+      }
+
+      if (status == MS_TRUE) {
+        /* Should we skip this feature? */
+        if (!paging && map->query.startindex > 1) {
+          --map->query.startindex;
+          msFreeShape(&shape);
+          continue;
+        }
+        if (map->query.only_cache_result_count)
+          lp->resultcache->numresults++;
+        else
+          addResult(map, lp->resultcache, &queryCache, &shape);
+        --map->query.maxfeatures;
+      }
+      msFreeShape(&shape);
+
+      /* check shape count */
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
+        status = MS_DONE;
+        break;
+      }
+
+    } /* next shape */
+
+    if (classgroup)
+      msFree(classgroup);
+
+    msProjectDestroyReprojector(reprojector);
+
+    if (status != MS_DONE) {
+      msFreeShape(&searchshape);
+      return (MS_FAILURE);
+    }
+
+    if (!map->query.only_cache_result_count && lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+  }                     /* next layer */
+
+  msFreeShape(&searchshape);
+
+  /* was anything found? */
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_V) {
+    msDebug("msQueryByRect(): No matching record(s) found.\n");
+  }
+  return (MS_SUCCESS);
+}
+
+static int is_duplicate(resultCacheObj *resultcache, int shapeindex,
+                        int tileindex) {
+  int i;
+
+  for (i = 0; i < resultcache->numresults; i++)
+    if (resultcache->results[i].shapeindex == shapeindex &&
+        resultcache->results[i].tileindex == tileindex)
+      return (MS_TRUE);
+
+  return (MS_FALSE);
+}
+
+int msQueryByFeatures(mapObj *map) {
+  int i, l;
+  int start, stop = 0;
+  layerObj *lp, *slp;
+  char status;
+
+  double distance, tolerance, layer_tolerance;
+
+  rectObj searchrect;
+  shapeObj shape, selectshape;
+  int nclasses = 0;
+  int *classgroup = NULL;
+  double minfeaturesize = -1;
+
+  queryCacheObj queryCache;
+
+  initQueryCache(&queryCache);
+
+  /* is the selection layer valid and has it been queried */
+  if (map->query.slayer < 0 || map->query.slayer >= map->numlayers) {
+    msSetError(MS_QUERYERR, "Invalid selection layer index.",
+               "msQueryByFeatures()");
+    return (MS_FAILURE);
+  }
+  slp = (GET_LAYER(map, map->query.slayer));
+  if (!slp->resultcache) {
+    msSetError(MS_QUERYERR, "Selection layer has not been queried.",
+               "msQueryByFeatures()");
+    return (MS_FAILURE);
+  }
+
+  /* conditions may have changed since this layer last drawn, so set
+     layer->project true to recheck projection needs (Bug #673) */
+  slp->project = msProjectionsDiffer(&(slp->projection), &(map->projection));
+
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
+  else
+    start = stop = map->query.layer;
+
+  /* selection layers should already be open */
+  /* status = msLayerOpen(slp);
+  if(status != MS_SUCCESS) return(MS_FAILURE); */
+
+  msInitShape(&shape); /* initialize a few things */
+  msInitShape(&selectshape);
+
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
+    if (l == map->query.slayer)
+      continue; /* skip the selection layer */
+
+    lp = (GET_LAYER(map, l));
+    if (map->query.maxfeatures == 0)
+      break; /* nothing else to do */
+    else if (map->query.maxfeatures > 0)
+      lp->maxfeatures = map->query.maxfeatures;
+
+    /* using mapscript, the map->query.startindex will be unset... */
+    if (lp->startindex > 1 && map->query.startindex < 0)
+      map->query.startindex = lp->startindex;
+
+    /* conditions may have changed since this layer last drawn, so set
+       layer->project true to recheck projection needs (Bug #673) */
+    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
+
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
+      free(lp->resultcache);
+      lp->resultcache = NULL;
+    }
+
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
+
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
+    }
+
+    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
+    }
+
+    /* Get the layer tolerance default is 3 for point and line layers, 0 for
+     * others */
+    if (lp->tolerance == -1) {
+      if (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
+        layer_tolerance = 3;
+      else
+        layer_tolerance = 0;
+    } else
+      layer_tolerance = lp->tolerance;
+
+    if (lp->toleranceunits == MS_PIXELS)
+      tolerance = layer_tolerance *
+                  msAdjustExtent(&(map->extent), map->width, map->height);
+    else
+      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                                     msInchesPerUnit(map->units, 0));
+
+    msLayerClose(lp); /* reset */
+    status = msLayerOpen(lp);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+    msLayerEnablePaging(lp, MS_FALSE);
+
+    /* build item list, we want *all* items */
+    status = msLayerWhichItems(lp, MS_TRUE, NULL);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    /* for each selection shape */
+    for (i = 0; i < slp->resultcache->numresults; i++) {
+
+      status =
+          msLayerGetShape(slp, &selectshape, &(slp->resultcache->results[i]));
+      if (status != MS_SUCCESS) {
+        msLayerClose(lp);
+        msLayerClose(slp);
+        return (MS_FAILURE);
+      }
+
+      if (selectshape.type != MS_SHAPE_POLYGON &&
+          selectshape.type != MS_SHAPE_LINE) {
+        msLayerClose(lp);
+        msLayerClose(slp);
+        msSetError(MS_QUERYERR, "Selection features MUST be polygons or lines.",
+                   "msQueryByFeatures()");
+        return (MS_FAILURE);
+      }
+
+      if (slp->project)
+        msProjectShape(&(slp->projection), &(map->projection), &selectshape);
+
+      /* identify target shapes */
+      searchrect = selectshape.bounds;
+
+      searchrect.minx -=
+          tolerance; /* expand the search box to account for layer tolerances
+                        (e.g. buffered searches) */
+      searchrect.maxx += tolerance;
+      searchrect.miny -= tolerance;
+      searchrect.maxy += tolerance;
+
+      if (lp->project)
+        msProjectRect(
+            &(map->projection), &(lp->projection),
+            &searchrect); /* project the searchrect to source coords */
+
+      status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
+      if (status == MS_DONE) { /* no overlap */
+        msLayerClose(lp);
+        break; /* next layer */
+      } else if (status != MS_SUCCESS) {
+        msLayerClose(lp);
+        msLayerClose(slp);
+        return (MS_FAILURE);
+      }
+
+      if (i == 0) {
+        lp->resultcache = (resultCacheObj *)malloc(sizeof(
+            resultCacheObj)); /* allocate and initialize the result cache */
+        MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
+        initResultCache(lp->resultcache);
+      }
+
+      nclasses = 0;
+      classgroup = NULL;
+      if (lp->classgroup && lp->numclasses > 0)
+        classgroup = msAllocateValidClassGroups(lp, &nclasses);
+
+      if (lp->minfeaturesize > 0)
+        minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
+
+      while ((status = msLayerNextShape(lp, &shape)) ==
+             MS_SUCCESS) { /* step through the shapes */
+
+        /* check for dups when there are multiple selection shapes */
+        if (i > 0 &&
+            is_duplicate(lp->resultcache, shape.index, shape.tileindex))
+          continue;
+
+        /* Check if the shape size is ok to be drawn */
+        if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+            (minfeaturesize > 0)) {
+          if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
+            if (lp->debug >= MS_DEBUGLEVEL_V)
+              msDebug("msQueryByFeature(): Skipping shape (%ld) because "
+                      "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                      shape.index);
+            msFreeShape(&shape);
+            continue;
+          }
+        }
+
+        shape.classindex =
+            msShapeGetClass(lp, map, &shape, classgroup, nclasses);
+        if (!(lp->template) &&
+            ((shape.classindex == -1) ||
+             (lp->class[shape.classindex]
+              -> status == MS_OFF))) { /* not a valid shape */
+          msFreeShape(&shape);
+          continue;
+        }
+
+        if (!(lp->template) && !(lp->class[shape.classindex]
+                                 -> template)) { /* no valid template */
+          msFreeShape(&shape);
+          continue;
+        }
+
+        if (lp->project) {
+          if (reprojector == NULL) {
+            reprojector = msProjectCreateReprojector(&(lp->projection),
+                                                     &(map->projection));
+            if (reprojector == NULL) {
+              msFreeShape(&shape);
+              status = MS_FAILURE;
+              break;
+            }
+          }
+          msProjectShapeEx(reprojector, &shape);
+        }
+
+        switch (selectshape.type) { /* may eventually support types other than
+                                       polygon on line */
+        case MS_SHAPE_POLYGON:
+          switch (shape.type) { /* make sure shape actually intersects the
+                                   selectshape */
+          case MS_SHAPE_POINT:
+            if (tolerance == 0) /* just test for intersection */
+              status = msIntersectMultipointPolygon(&shape, &selectshape);
+            else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          case MS_SHAPE_LINE:
+            if (tolerance == 0) { /* just test for intersection */
+              status = msIntersectPolylinePolygon(&shape, &selectshape);
+            } else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          case MS_SHAPE_POLYGON:
+            if (tolerance == 0) /* just test for intersection */
+              status = msIntersectPolygons(&shape, &selectshape);
+            else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          default:
+            status = MS_FALSE;
+            break;
+          }
+          break;
+        case MS_SHAPE_LINE:
+          switch (shape.type) { /* make sure shape actually intersects the
+                                   selectshape */
+          case MS_SHAPE_POINT:
+            if (tolerance == 0) { /* just test for intersection */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance == 0)
+                status = MS_TRUE;
+            } else {
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          case MS_SHAPE_LINE:
+            if (tolerance == 0) { /* just test for intersection */
+              status = msIntersectPolylines(&shape, &selectshape);
+            } else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          case MS_SHAPE_POLYGON:
+            if (tolerance == 0) /* just test for intersection */
+              status = msIntersectPolylinePolygon(&selectshape, &shape);
+            else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          default:
+            status = MS_FALSE;
+            break;
+          }
+          break;
+        default:
+          break; /* should never get here as we test for selection shape type
+                    explicitly earlier */
+        }
+
+        if (status == MS_TRUE) {
+          /* Should we skip this feature? */
+          if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
+            --map->query.startindex;
+            msFreeShape(&shape);
+            continue;
+          }
+          addResult(map, lp->resultcache, &queryCache, &shape);
+        }
+        msFreeShape(&shape);
+
+        /* check shape count */
+        if (lp->maxfeatures > 0 &&
+            lp->maxfeatures == lp->resultcache->numresults) {
+          status = MS_DONE;
+          break;
+        }
+      } /* next shape */
+
+      if (classgroup)
+        msFree(classgroup);
+
+      msProjectDestroyReprojector(reprojector);
+
+      msFreeShape(&selectshape);
+
+      if (status != MS_DONE)
+        return (MS_FAILURE);
+
+    } /* next selection shape */
+
+    if (lp->resultcache == NULL || lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+  }                     /* next layer */
+
+  /* was anything found? */
+  for (l = start; l >= stop; l--) {
+    if (l == map->query.slayer)
+      continue; /* skip the selection layer */
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_V) {
+    msDebug("msQueryByFeatures(): No matching record(s) found.\n");
+  }
+  return (MS_SUCCESS);
+}
+
+/* msQueryByPoint()
+ *
+ * With mode=MS_QUERY_SINGLE:
+ *   Set maxresults = 0 to have a single result across all layers (the closest
+ *     shape from the first layer that finds a match).
+ *   Set maxresults = 1 to have up to one result per layer (the closest shape
+ *     from each layer).
+ *
+ * With mode=MS_QUERY_MULTIPLE:
+ *   Set maxresults = 0 to have an unlimited number of results.
+ *   Set maxresults > 0 to limit the number of results per layer (the shapes
+ *     returned are the first ones found in each layer and are not necessarily
+ *     the closest ones).
+ */
+int msQueryByPoint(mapObj *map) {
+  int l;
+  int start, stop = 0;
+
+  double d, t;
+  double layer_tolerance;
+
+  layerObj *lp;
+
+  int paging;
+  char status;
+  rectObj rect, searchrect;
+  shapeObj shape;
+  int nclasses = 0;
+  int *classgroup = NULL;
+  double minfeaturesize = -1;
+
+  queryCacheObj queryCache;
+
+  initQueryCache(&queryCache);
+
+  if (map->query.type != MS_QUERY_BY_POINT) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByPoint()");
+    return (MS_FAILURE);
+  }
+
+  msInitShape(&shape);
+
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
+  else
+    start = stop = map->query.layer;
+
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
+    lp = (GET_LAYER(map, l));
+    if (map->query.maxfeatures == 0)
+      break; /* nothing else to do */
+    else if (map->query.maxfeatures > 0)
+      lp->maxfeatures = map->query.maxfeatures;
+
+    /* using mapscript, the map->query.startindex will be unset... */
+    if (lp->startindex > 1 && map->query.startindex < 0)
+      map->query.startindex = lp->startindex;
+
+    /* conditions may have changed since this layer last drawn, so set
+       layer->project true to recheck projection needs (Bug #673) */
+    lp->project = MS_TRUE;
+
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
+      free(lp->resultcache);
+      lp->resultcache = NULL;
+    }
+
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
+
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
+    }
+
+    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
+    }
+
+    /* Raster layers are handled specially.  */
+    if (lp->type == MS_LAYER_RASTER) {
+      if (msRasterQueryByPoint(map, lp, map->query.mode, map->query.point,
+                               map->query.buffer,
+                               map->query.maxresults) == MS_FAILURE)
+        return MS_FAILURE;
+      continue;
+    }
+
+    /* Get the layer tolerance default is 3 for point and line layers, 0 for
+     * others */
+    if (lp->tolerance == -1) {
+      if (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
+        layer_tolerance = 3;
+      else
+        layer_tolerance = 0;
+    } else
+      layer_tolerance = lp->tolerance;
+
+    if (map->query.buffer <= 0) { /* use layer tolerance */
+      if (lp->toleranceunits == MS_PIXELS)
+        t = layer_tolerance *
+            MS_MAX(
+                MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
+                MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
+      else
+        t = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                               msInchesPerUnit(map->units, 0));
+    } else /* use buffer distance */
+      t = map->query.buffer;
+
+    rect.minx = map->query.point.x - t;
+    rect.maxx = map->query.point.x + t;
+    rect.miny = map->query.point.y - t;
+    rect.maxy = map->query.point.y + t;
+
+    /* Paging could have been disabled before */
+    paging = msLayerGetPaging(lp);
+    msLayerClose(lp); /* reset */
+    status = msLayerOpen(lp);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+    msLayerEnablePaging(lp, paging);
+
+    /* build item list, we want *all* items */
+    status = msLayerWhichItems(lp, MS_TRUE, NULL);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    /* identify target shapes */
+    searchrect = rect;
+    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
+    if (lp->project)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &searchrect); /* project the searchrect to source coords */
+
+    status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
+    if (status == MS_DONE) { /* no overlap */
+      msLayerClose(lp);
+      continue;
+    } else if (status != MS_SUCCESS) {
+      msLayerClose(lp);
+      return (MS_FAILURE);
+    }
+
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
+    initResultCache(lp->resultcache);
+
+    nclasses = 0;
+    classgroup = NULL;
+    if (lp->classgroup && lp->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(lp, &nclasses);
+
+    if (lp->minfeaturesize > 0)
+      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
+
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes */
+
+      /* Check if the shape size is ok to be drawn */
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
+        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByPoint(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
+          msFreeShape(&shape);
+          continue;
+        }
+      }
+
+      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
+        }
+        msProjectShapeEx(reprojector, &shape);
+      }
+
+      d = msDistancePointToShape(&(map->query.point), &shape);
+      if (d <= t) { /* found one */
+
+        /* Should we skip this feature? */
+        if (!paging && map->query.startindex > 1) {
+          --map->query.startindex;
+          msFreeShape(&shape);
+          continue;
+        }
+
+        if (map->query.mode == MS_QUERY_SINGLE) {
+          cleanupResultCache(lp->resultcache);
+          initQueryCache(&queryCache);
+          addResult(map, lp->resultcache, &queryCache, &shape);
+          t = d; /* next one must be closer */
+        } else {
+          addResult(map, lp->resultcache, &queryCache, &shape);
+        }
+      }
+
+      msFreeShape(&shape);
+
+      if (map->query.mode == MS_QUERY_MULTIPLE && map->query.maxresults > 0 &&
+          lp->resultcache->numresults == map->query.maxresults) {
+        status = MS_DONE; /* got enough results for this layer */
+        break;
+      }
+
+      /* check shape count */
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
+        status = MS_DONE;
+        break;
+      }
+    } /* next shape */
+
+    if (classgroup)
+      msFree(classgroup);
+
+    msProjectDestroyReprojector(reprojector);
+
+    if (status != MS_DONE)
+      return (MS_FAILURE);
+
+    if (lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+
+    if ((lp->resultcache->numresults > 0) &&
+        (map->query.mode == MS_QUERY_SINGLE) && (map->query.maxresults == 0))
+      break; /* no need to search any further */
+  }          /* next layer */
+
+  /* was anything found? */
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_V) {
+    msDebug("msQueryByPoint(): No matching record(s) found.\n");
+  }
+  return (MS_SUCCESS);
+}
+
+int msQueryByShape(mapObj *map) {
+  int start, stop = 0, l;
+  shapeObj shape, *qshape = NULL;
+  layerObj *lp;
+  char status;
+  double distance, tolerance, layer_tolerance;
+  rectObj searchrect;
+
+  int nclasses = 0;
+  int *classgroup = NULL;
+  double minfeaturesize = -1;
+  queryCacheObj queryCache;
+
+  initQueryCache(&queryCache);
+
+  if (map->query.type != MS_QUERY_BY_SHAPE) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByShape()");
+    return (MS_FAILURE);
+  }
+
+  if (!(map->query.shape)) {
+    msSetError(MS_QUERYERR, "Query shape is not defined.", "msQueryByShape()");
+    return (MS_FAILURE);
+  }
+  if (map->query.shape->type != MS_SHAPE_POLYGON &&
+      map->query.shape->type != MS_SHAPE_LINE &&
+      map->query.shape->type != MS_SHAPE_POINT) {
+    msSetError(MS_QUERYERR, "Query shape MUST be a polygon, line or point.",
+               "msQueryByShape()");
+    return (MS_FAILURE);
+  }
+
+  msInitShape(&shape);
+  qshape = map->query.shape; /* for brevity */
+
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
+  else
+    start = stop = map->query.layer;
+
+  msComputeBounds(qshape); /* make sure an accurate extent exists */
+
+  for (l = start; l >= stop; l--) { /* each layer */
+    reprojectionObj *reprojector = NULL;
+    lp = (GET_LAYER(map, l));
+    if (map->query.maxfeatures == 0)
+      break; /* nothing else to do */
+    else if (map->query.maxfeatures > 0)
+      lp->maxfeatures = map->query.maxfeatures;
+
+    /* using mapscript, the map->query.startindex will be unset... */
+    if (lp->startindex > 1 && map->query.startindex < 0)
+      map->query.startindex = lp->startindex;
+
+    /* conditions may have changed since this layer last drawn, so set
+       layer->project true to recheck projection needs (Bug #673) */
+    lp->project = MS_TRUE;
+
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
+      free(lp->resultcache);
+      lp->resultcache = NULL;
+    }
+
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
+
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
+    }
+
+    if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
+    }
+
+    /* Raster layers are handled specially. */
+    if (lp->type == MS_LAYER_RASTER) {
+      if (msRasterQueryByShape(map, lp, qshape) == MS_FAILURE)
+        return MS_FAILURE;
+      continue;
+    }
+
+    /* Get the layer tolerance default is 3 for point and line layers, 0 for
+     * others */
+    if (lp->tolerance == -1) {
+      if (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
+        layer_tolerance = 3;
+      else
+        layer_tolerance = 0;
+    } else
+      layer_tolerance = lp->tolerance;
+
+    if (lp->toleranceunits == MS_PIXELS)
+      tolerance = layer_tolerance *
+                  msAdjustExtent(&(map->extent), map->width, map->height);
+    else
+      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                                     msInchesPerUnit(map->units, 0));
+
+    msLayerClose(lp); /* reset */
+    status = msLayerOpen(lp);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+    /* disable driver paging */
+    msLayerEnablePaging(lp, MS_FALSE);
+
+    /* build item list, we want *all* items */
+    status = msLayerWhichItems(lp, MS_TRUE, NULL);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    /* identify target shapes */
+    searchrect = qshape->bounds;
+
+    searchrect.minx -= tolerance; /* expand the search box to account for layer
+                                     tolerances (e.g. buffered searches) */
+    searchrect.maxx += tolerance;
+    searchrect.miny -= tolerance;
+    searchrect.maxy += tolerance;
+
+    lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
+    if (lp->project)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &searchrect); /* project the searchrect to source coords */
+
+    status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
+    if (status == MS_DONE) { /* no overlap */
+      msLayerClose(lp);
+      continue;
+    } else if (status != MS_SUCCESS) {
+      msLayerClose(lp);
+      return (MS_FAILURE);
+    }
+
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
+    initResultCache(lp->resultcache);
+
+    nclasses = 0;
+    if (lp->classgroup && lp->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(lp, &nclasses);
+
+    if (lp->minfeaturesize > 0)
+      minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
+
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes */
+
+      /* Check if the shape size is ok to be drawn */
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
+        if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByShape(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
+          msFreeShape(&shape);
+          continue;
+        }
+      }
+
+      shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
+        msFreeShape(&shape);
+        continue;
+      }
+
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
+        }
+        msProjectShapeEx(reprojector, &shape);
+      }
+
+      switch (qshape->type) { /* may eventually support types other than polygon
+                                 or line */
+      case MS_SHAPE_POLYGON:
+        switch (
+            shape.type) { /* make sure shape actually intersects the shape */
+        case MS_SHAPE_POINT:
+          if (tolerance == 0) /* just test for intersection */
+            status = msIntersectMultipointPolygon(&shape, qshape);
+          else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        case MS_SHAPE_LINE:
+          if (tolerance == 0) { /* just test for intersection */
+            status = msIntersectPolylinePolygon(&shape, qshape);
+          } else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        case MS_SHAPE_POLYGON:
+          if (tolerance == 0) /* just test for intersection */
+            status = msIntersectPolygons(&shape, qshape);
+          else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        default:
+          break;
+        }
+        break;
+      case MS_SHAPE_LINE:
+        switch (shape.type) { /* make sure shape actually intersects the
+                                 selectshape */
+        case MS_SHAPE_POINT:
+          if (tolerance == 0) { /* just test for intersection */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance == 0)
+              status = MS_TRUE;
+          } else {
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        case MS_SHAPE_LINE:
+          if (tolerance == 0) { /* just test for intersection */
+            status = msIntersectPolylines(&shape, qshape);
+          } else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        case MS_SHAPE_POLYGON:
+          if (tolerance == 0) /* just test for intersection */
+            status = msIntersectPolylinePolygon(qshape, &shape);
+          else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        default:
+          status = MS_FALSE;
+          break;
+        }
+        break;
+      case MS_SHAPE_POINT:
+        distance = msDistanceShapeToShape(qshape, &shape);
+        status = MS_FALSE;
+        if (tolerance == 0 && distance == 0)
+          status = MS_TRUE; /* shapes intersect */
+        else if (distance < tolerance)
+          status = MS_TRUE; /* shapes are close enough */
+        break;
+      default:
+        break; /* should never get here as we test for selection shape type
+                  explicitly earlier */
+      }
+
+      if (status == MS_TRUE) {
+        /* Should we skip this feature? */
+        if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
+          --map->query.startindex;
+          msFreeShape(&shape);
+          continue;
+        }
+        addResult(map, lp->resultcache, &queryCache, &shape);
+      }
+      msFreeShape(&shape);
+
+      /* check shape count */
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
+        status = MS_DONE;
+        break;
+      }
+    } /* next shape */
+
+    free(classgroup);
+    classgroup = NULL;
+
+    msProjectDestroyReprojector(reprojector);
+
+    if (status != MS_DONE) {
+      return (MS_FAILURE);
+    }
+
+    if (lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+  }                     /* next layer */
+
+  /* was anything found? */
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
+  }
+
+  if (map->debug >= MS_DEBUGLEVEL_V) {
+    msDebug("msQueryByShape(): No matching record(s) found.\n");
+  }
+  return (MS_SUCCESS);
+}
+
+/* msGetQueryResultBounds()
+ *
+ * Compute the BBOX of all query results, returns the number of layers found
+ * that contained query results and were included in the BBOX.
+ * i.e. if we return 0 then the value in bounds is invalid.
+ */
+int msGetQueryResultBounds(mapObj *map, rectObj *bounds) {
+  int i, found = 0;
+  rectObj tmpBounds;
+
+  for (i = 0; i < map->numlayers; i++) {
+
+    layerObj *lp;
+    lp = (GET_LAYER(map, i));
+
+    if (!lp->resultcache)
+      continue;
+    if (lp->resultcache->numresults <= 0)
+      continue;
+
+    tmpBounds = lp->resultcache->bounds;
+
+    if (found == 0) {
+      *bounds = tmpBounds;
+    } else {
+      msMergeRect(bounds, &tmpBounds);
+    }
+
+    found++;
+  }
+
+  return found;
+}
+
+/* TODO: Rename this msFreeResultSet() or something along those lines... */
+/* msQueryFree()
+ *
+ * Free layer's query results. If qlayer == -1, all layers will be treated.
+ */
+void msQueryFree(mapObj *map, int qlayer) {
+  int l; /* counters */
+  int start, stop = 0;
+  layerObj *lp;
+
+  if (qlayer < 0 || qlayer >= map->numlayers)
+    start = map->numlayers - 1;
+  else
+    start = stop = qlayer;
+
+  for (l = start; l >= stop; l--) {
+    lp = (GET_LAYER(map, l));
+
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
+      free(lp->resultcache);
+      lp->resultcache = NULL;
+    }
+  }
+}
diff -pruN 8.0.1-5/src/mapraster.c 8.2.0~beta1-1~exp1/src/mapraster.c
--- 8.0.1-5/src/mapraster.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapraster.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1171 @@
+/******************************************************************************
+ * $id: mapraster.c 10772 2010-11-29 18:27:02Z aboudreault $
+ *
+ * Project:  MapServer
+ * Purpose:  msDrawRasterLayer(): generic raster layer drawing.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *           Pete Olson (LMIC)
+ *           Steve Lime
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2010 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "mapfile.h"
+#include "mapresample.h"
+#include "mapthread.h"
+
+extern int msyylex_destroy(void);
+extern int yyparse(parseObj *);
+
+extern parseResultObj yypresult; /* result of parsing, true/false */
+
+#include "gdal.h"
+#include "cpl_string.h"
+#include "mapraster.h"
+
+#define MAXCOLORS 256
+#define BUFLEN 1024
+#define HDRLEN 8
+
+#define CVT(x) ((x) >> 8) /* converts to 8-bit color value */
+
+#define NUMGRAYS 16
+
+/************************************************************************/
+/*                         msGetClass_String()                          */
+/************************************************************************/
+
+static int msGetClass_String(layerObj *layer, colorObj *color,
+                             const char *pixel_value, int firstClassToTry)
+
+{
+  int i;
+  const char *tmpstr1 = NULL;
+  int numitems;
+  char *item_names[4] = {"pixel", "red", "green", "blue"};
+  char *item_values[4];
+  char red_value[8], green_value[8], blue_value[8];
+
+  /* -------------------------------------------------------------------- */
+  /*      No need to do a lookup in the case of one default class.        */
+  /* -------------------------------------------------------------------- */
+  if ((layer->numclasses == 1) &&
+      !(layer->class[0] -> expression.string)) /* no need to do lookup */
+    return (0);
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup values list for expressions.                              */
+  /* -------------------------------------------------------------------- */
+  numitems = 4;
+  if (color->red == -1 && color->green == -1 && color->blue == -1) {
+    strcpy(red_value, "-1");
+    strcpy(green_value, "-1");
+    strcpy(blue_value, "-1");
+  } else {
+    sprintf(red_value, "%d", color->red);
+    sprintf(green_value, "%d", color->green);
+    sprintf(blue_value, "%d", color->blue);
+  }
+
+  item_values[0] = (char *)pixel_value;
+  item_values[1] = red_value;
+  item_values[2] = green_value;
+  item_values[3] = blue_value;
+
+  /* -------------------------------------------------------------------- */
+  /*      Loop over classes till we find a match.                         */
+  /* -------------------------------------------------------------------- */
+  if (firstClassToTry >= layer->numclasses)
+    firstClassToTry = -1;
+  for (i = 0; i < layer->numclasses; i++) {
+
+    const int idx = firstClassToTry < 0    ? i
+                    : i == 0               ? firstClassToTry
+                    : i <= firstClassToTry ? i - 1
+                                           : i;
+
+    /* check for correct classgroup, if set */
+    if (layer->class[idx] -> group && layer -> classgroup &&strcasecmp(
+                                                   layer->class[idx] -> group,
+                                                   layer -> classgroup) != 0)
+      continue;
+
+    /* Empty expression - always matches */
+    if (layer->class[idx] -> expression.string == NULL)
+      return (i);
+
+    switch (layer->class[idx] -> expression.type) {
+
+      /* -------------------------------------------------------------------- */
+      /*      Simple string match                                             */
+      /* -------------------------------------------------------------------- */
+    case (MS_STRING):
+      /* trim junk white space */
+      tmpstr1 = pixel_value;
+      while (*tmpstr1 == ' ')
+        tmpstr1++;
+
+      if (strcmp(layer->class[idx] -> expression.string, tmpstr1) == 0)
+        return (idx); /* matched */
+      break;
+
+      /* -------------------------------------------------------------------- */
+      /*      Regular expression.  Rarely used for raster.                    */
+      /* -------------------------------------------------------------------- */
+    case (MS_REGEX):
+      if (!layer->class[idx] -> expression.compiled) {
+        if (ms_regcomp(&(layer->class[idx] -> expression.regex),
+                       layer->class[idx] -> expression.string,
+                       MS_REG_EXTENDED | MS_REG_NOSUB) !=
+            0) { /* compile the expression  */
+          msSetError(MS_REGEXERR, "Invalid regular expression.",
+                     "msGetClass()");
+          return (-1);
+        }
+        layer->class[idx]->expression.compiled = MS_TRUE;
+      }
+
+      if (ms_regexec(&(layer->class[idx] -> expression.regex), pixel_value, 0,
+                     NULL, 0) == 0)
+        return (idx); /* got a match */
+      break;
+
+      /* -------------------------------------------------------------------- */
+      /*      Parsed expression.                                              */
+      /* -------------------------------------------------------------------- */
+    case (MS_EXPRESSION): {
+      int status;
+      parseObj p;
+      shapeObj dummy_shape;
+      expressionObj *expression = &(layer->class[idx] -> expression);
+
+      dummy_shape.numvalues = numitems;
+      dummy_shape.values = item_values;
+
+      if (expression->tokens == NULL)
+        msTokenizeExpression(expression, item_names, &numitems);
+
+      p.shape = &dummy_shape;
+      p.expr = expression;
+      p.expr->curtoken = p.expr->tokens; /* reset */
+      p.type = MS_PARSE_TYPE_BOOLEAN;
+
+      status = yyparse(&p);
+
+      if (status != 0) {
+        msSetError(MS_PARSEERR, "Failed to parse expression: %s",
+                   "msGetClass_FloatRGB", expression->string);
+        return -1;
+      }
+
+      if (p.result.intval)
+        return idx;
+      break;
+    }
+    }
+  }
+
+  return (-1); /* not found */
+}
+
+/************************************************************************/
+/*                             msGetClass()                             */
+/************************************************************************/
+
+int msGetClass(layerObj *layer, colorObj *color, int colormap_index) {
+  char pixel_value[12];
+
+  snprintf(pixel_value, sizeof(pixel_value), "%d", colormap_index);
+
+  return msGetClass_String(layer, color, pixel_value, -1);
+}
+
+/************************************************************************/
+/*                          msGetClass_FloatRGB()                       */
+/*                                                                      */
+/*      Returns the class based on classification of a floating         */
+/*      pixel value.                                                    */
+/************************************************************************/
+
+int msGetClass_FloatRGB(layerObj *layer, float fValue, int red, int green,
+                        int blue) {
+  return msGetClass_FloatRGB_WithFirstClassToTry(layer, fValue, red, green,
+                                                 blue, -1);
+}
+
+int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue,
+                                            int red, int green, int blue,
+                                            int firstClassToTry) {
+  char pixel_value[100];
+  colorObj color;
+
+  color.red = red;
+  color.green = green;
+  color.blue = blue;
+
+  snprintf(pixel_value, sizeof(pixel_value), "%18g", fValue);
+
+  return msGetClass_String(layer, &color, pixel_value, firstClassToTry);
+}
+
+/************************************************************************/
+/*                      msRasterSetupTileLayer()                        */
+/*                                                                      */
+/*      Setup the tile layer.                                           */
+/************************************************************************/
+
+int msDrawRasterSetupTileLayer(mapObj *map, layerObj *layer,
+                               rectObj *psearchrect, int is_query,
+                               int *ptilelayerindex, /* output */
+                               int *ptileitemindex,  /* output */
+                               int *ptilesrsindex,   /* output */
+                               layerObj **ptlp /* output */) {
+  int i;
+  char *requested_fields;
+  int status;
+  layerObj *tlp = NULL;
+
+  *ptilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
+  if (*ptilelayerindex ==
+      -1) { /* the tileindex references a file, not a layer */
+
+    /* so we create a temporary layer */
+    tlp = (layerObj *)malloc(sizeof(layerObj));
+    MS_CHECK_ALLOC(tlp, sizeof(layerObj), MS_FAILURE);
+
+    initLayer(tlp, map);
+    *ptlp = tlp;
+
+    /* set a few parameters for a very basic shapefile-based layer */
+    tlp->name = msStrdup("TILE");
+    tlp->type = MS_LAYER_TILEINDEX;
+    tlp->data = msStrdup(layer->tileindex);
+
+    if (is_query) {
+      tlp->map = map; /*needed when scaletokens are applied, to extract current
+                         map scale */
+      for (i = 0; i < layer->numscaletokens; i++) {
+        if (msGrowLayerScaletokens(tlp) == NULL) {
+          return MS_FAILURE;
+        }
+        initScaleToken(&tlp->scaletokens[i]);
+        msCopyScaleToken(&layer->scaletokens[i], &tlp->scaletokens[i]);
+        tlp->numscaletokens++;
+      }
+    }
+
+    if (layer->projection.numargs > 0 &&
+        EQUAL(layer->projection.args[0], "auto")) {
+      tlp->projection.numargs = 1;
+      tlp->projection.args[0] = msStrdup("auto");
+    }
+
+    if (layer->filteritem)
+      tlp->filteritem = msStrdup(layer->filteritem);
+    if (layer->filter.string) {
+      if (layer->filter.type == MS_EXPRESSION) {
+        char *pszTmp = (char *)msSmallMalloc(
+            sizeof(char) * (strlen(layer->filter.string) + 3));
+        sprintf(pszTmp, "(%s)", layer->filter.string);
+        msLoadExpressionString(&tlp->filter, pszTmp);
+        free(pszTmp);
+      } else if (layer->filter.type == MS_REGEX ||
+                 layer->filter.type == MS_IREGEX) {
+        char *pszTmp = (char *)msSmallMalloc(
+            sizeof(char) * (strlen(layer->filter.string) + 3));
+        sprintf(pszTmp, "/%s/", layer->filter.string);
+        msLoadExpressionString(&tlp->filter, pszTmp);
+        free(pszTmp);
+      } else
+        msLoadExpressionString(&tlp->filter, layer->filter.string);
+
+      tlp->filter.type = layer->filter.type;
+    }
+
+  } else {
+    if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+      return MS_FAILURE;
+    tlp = (GET_LAYER(layer->map, *ptilelayerindex));
+    *ptlp = tlp;
+  }
+  status = msLayerOpen(tlp);
+  if (status != MS_SUCCESS) {
+    return status;
+  }
+
+  /* fetch tileitem and tilesrs fields */
+  requested_fields = (char *)msSmallMalloc(
+      sizeof(char) * (strlen(layer->tileitem) + 1 +
+                      (layer->tilesrs ? strlen(layer->tilesrs) : 0) + 1));
+  if (layer->tilesrs != NULL)
+    sprintf(requested_fields, "%s,%s", layer->tileitem, layer->tilesrs);
+  else
+    strcpy(requested_fields, layer->tileitem);
+  status = msLayerWhichItems(tlp, MS_FALSE, requested_fields);
+  msFree(requested_fields);
+  if (status != MS_SUCCESS) {
+    return status;
+  }
+
+  /* get the tileitem and tilesrs index */
+  for (i = 0; i < tlp->numitems; i++) {
+    if (strcasecmp(tlp->items[i], layer->tileitem) == 0) {
+      *ptileitemindex = i;
+    }
+    if (layer->tilesrs != NULL &&
+        strcasecmp(tlp->items[i], layer->tilesrs) == 0) {
+      *ptilesrsindex = i;
+    }
+  }
+  if (*ptileitemindex < 0) { /* didn't find it */
+    msSetError(MS_MEMERR, "Could not find attribute %s in tileindex.",
+               "msDrawRasterLayerLow()", layer->tileitem);
+    return MS_FAILURE;
+  }
+  if (layer->tilesrs != NULL && *ptilesrsindex < 0) { /* didn't find it */
+    msSetError(MS_MEMERR, "Could not find attribute %s in tileindex.",
+               "msDrawRasterLayerLow()", layer->tilesrs);
+    return MS_FAILURE;
+  }
+
+  /* if necessary, project the searchrect to source coords */
+  if ((map->projection.numargs > 0) && (layer->projection.numargs > 0) &&
+      !EQUAL(layer->projection.args[0], "auto")) {
+    if (msProjectRect(&map->projection, &layer->projection, psearchrect) !=
+        MS_SUCCESS) {
+      msDebug("msDrawRasterLayerLow(%s): unable to reproject map request "
+              "rectangle into layer projection, canceling.\n",
+              layer->name);
+      return MS_FAILURE;
+    }
+  } else if ((map->projection.numargs > 0) && (tlp->projection.numargs > 0) &&
+             !EQUAL(tlp->projection.args[0], "auto")) {
+    if (msProjectRect(&map->projection, &tlp->projection, psearchrect) !=
+        MS_SUCCESS) {
+      msDebug("msDrawRasterLayerLow(%s): unable to reproject map request "
+              "rectangle into layer projection, canceling.\n",
+              layer->name);
+      return MS_FAILURE;
+    }
+  }
+  return msLayerWhichShapes(tlp, *psearchrect, MS_FALSE);
+}
+
+/************************************************************************/
+/*                msDrawRasterCleanupTileLayer()                        */
+/*                                                                      */
+/*      Cleanup the tile layer.                                         */
+/************************************************************************/
+
+void msDrawRasterCleanupTileLayer(layerObj *tlp, int tilelayerindex) {
+  msLayerClose(tlp);
+  if (tilelayerindex == -1) {
+    freeLayer(tlp);
+    free(tlp);
+  }
+}
+
+/************************************************************************/
+/*                   msDrawRasterIterateTileIndex()                     */
+/*                                                                      */
+/*      Iterate over the tile layer.                                    */
+/************************************************************************/
+
+int msDrawRasterIterateTileIndex(layerObj *layer, layerObj *tlp,
+                                 shapeObj *ptshp, /* input-output */
+                                 int tileitemindex, int tilesrsindex,
+                                 char *tilename, /* output */
+                                 size_t sizeof_tilename,
+                                 char *tilesrsname, /* output */
+                                 size_t sizeof_tilesrsname) {
+  int status;
+
+  status = msLayerNextShape(tlp, ptshp);
+  if (status == MS_FAILURE || status == MS_DONE) {
+    return status;
+  }
+
+  if (layer->data == NULL ||
+      strlen(layer->data) ==
+          0) { /* assume whole filename is in attribute field */
+    strlcpy(tilename, ptshp->values[tileitemindex], sizeof_tilename);
+  } else
+    snprintf(tilename, sizeof_tilename, "%s/%s", ptshp->values[tileitemindex],
+             layer->data);
+
+  tilesrsname[0] = '\0';
+
+  if (tilesrsindex >= 0) {
+    if (ptshp->values[tilesrsindex] != NULL)
+      strlcpy(tilesrsname, ptshp->values[tilesrsindex], sizeof_tilesrsname);
+  }
+
+  msFreeShape(ptshp); /* done with the shape */
+
+  return status;
+}
+
+/************************************************************************/
+/*                   msDrawRasterBuildRasterPath()                      */
+/*                                                                      */
+/*      Build the path of the raster to open.                           */
+/************************************************************************/
+
+int msDrawRasterBuildRasterPath(mapObj *map, layerObj *layer,
+                                const char *filename,
+                                char szPath[MS_MAXPATHLEN] /* output */) {
+  /*
+  ** If using a tileindex then build the path relative to that file if SHAPEPATH
+  *is not set.
+  */
+  if (layer->tileindex && !map->shapepath) {
+    char tiAbsFilePath[MS_MAXPATHLEN];
+    char *tiAbsDirPath = NULL;
+
+    msTryBuildPath(tiAbsFilePath, map->mappath,
+                   layer->tileindex); /* absolute path to tileindex file */
+    tiAbsDirPath = msGetPath(tiAbsFilePath); /* tileindex file's directory */
+    msBuildPath(szPath, tiAbsDirPath, filename);
+    free(tiAbsDirPath);
+  } else {
+    msTryBuildPath3(szPath, map->mappath, map->shapepath, filename);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msDrawRasterGetCPLErrorMsg()                       */
+/*                                                                      */
+/*      Return the CPL error message, and filter out sensitive info.    */
+/************************************************************************/
+
+const char *msDrawRasterGetCPLErrorMsg(const char *decrypted_path,
+                                       const char *szPath) {
+  const char *cpl_error_msg = CPLGetLastErrorMsg();
+
+  /* we wish to avoid reporting decrypted paths */
+  if (cpl_error_msg != NULL && strstr(cpl_error_msg, decrypted_path) != NULL &&
+      strcmp(decrypted_path, szPath) != 0)
+    cpl_error_msg = NULL;
+
+  /* we wish to avoid reporting the stock GDALOpen error messages */
+  if (cpl_error_msg != NULL &&
+      (strstr(cpl_error_msg, "not recognised as a supported") != NULL ||
+       strstr(cpl_error_msg, "does not exist") != NULL))
+    cpl_error_msg = NULL;
+
+  if (cpl_error_msg == NULL)
+    cpl_error_msg = "";
+
+  return cpl_error_msg;
+}
+
+/************************************************************************/
+/*                   msDrawRasterLoadProjection()                       */
+/*                                                                      */
+/*      Handle TILESRS or PROJECTION AUTO for each tile.                */
+/************************************************************************/
+
+int msDrawRasterLoadProjection(layerObj *layer, GDALDatasetH hDS,
+                               const char *filename, int tilesrsindex,
+                               const char *tilesrsname) {
+  /*
+  ** Generate the projection information if using TILESRS.
+  */
+  if (tilesrsindex >= 0) {
+    const char *pszWKT;
+    if (tilesrsname[0] != '\0')
+      pszWKT = tilesrsname;
+    else
+      pszWKT = GDALGetProjectionRef(hDS);
+    if (pszWKT != NULL && strlen(pszWKT) > 0) {
+      if (msOGCWKT2ProjectionObj(pszWKT, &(layer->projection), layer->debug) !=
+          MS_SUCCESS) {
+        char szLongMsg[MESSAGELENGTH * 2];
+        errorObj *ms_error = msGetErrorObj();
+
+        snprintf(szLongMsg, sizeof(szLongMsg),
+                 "%s\n"
+                 "PROJECTION '%s' cannot be used for this "
+                 "GDAL raster (`%s').",
+                 ms_error->message, pszWKT, filename);
+        szLongMsg[MESSAGELENGTH - 1] = '\0';
+
+        msSetError(MS_OGRERR, "%s", "msDrawRasterLayer()", szLongMsg);
+
+        return MS_FAILURE;
+      }
+    }
+  }
+  /*
+  ** Generate the projection information if using AUTO.
+  */
+  else if (layer->projection.numargs > 0 &&
+           EQUAL(layer->projection.args[0], "auto")) {
+    const char *pszWKT;
+
+    pszWKT = GDALGetProjectionRef(hDS);
+
+    if (pszWKT != NULL && strlen(pszWKT) > 0) {
+      if (msOGCWKT2ProjectionObj(pszWKT, &(layer->projection), layer->debug) !=
+          MS_SUCCESS) {
+        char szLongMsg[MESSAGELENGTH * 2];
+        errorObj *ms_error = msGetErrorObj();
+
+        snprintf(szLongMsg, sizeof(szLongMsg),
+                 "%s\n"
+                 "PROJECTION AUTO cannot be used for this "
+                 "GDAL raster (`%s').",
+                 ms_error->message, filename);
+        szLongMsg[MESSAGELENGTH - 1] = '\0';
+
+        msSetError(MS_OGRERR, "%s", "msDrawRasterLayer()", szLongMsg);
+
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+typedef enum {
+  CDRT_OK,
+  CDRT_RETURN_MS_FAILURE,
+  CDRT_CONTINUE_NEXT_TILE
+} CheckDatasetReturnType;
+
+/************************************************************************/
+/*              msDrawRasterLayerLowCheckDataset()                      */
+/************************************************************************/
+
+static CheckDatasetReturnType
+msDrawRasterLayerLowCheckDataset(mapObj *map, layerObj *layer, GDALDatasetH hDS,
+                                 const char *decrypted_path,
+                                 const char *szPath) {
+  /*
+  ** If GDAL doesn't recognise it, and it wasn't successfully opened
+  ** Generate an error.
+  */
+  if (hDS == NULL) {
+    int ignore_missing = msMapIgnoreMissingData(map);
+    const char *cpl_error_msg =
+        msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
+
+    if (ignore_missing == MS_MISSING_DATA_FAIL) {
+      msSetError(MS_IOERR,
+                 "Corrupt, empty or missing file '%s' for layer '%s'. %s",
+                 "msDrawRasterLayerLow()", szPath, layer->name, cpl_error_msg);
+      return (CDRT_RETURN_MS_FAILURE);
+    } else if (ignore_missing == MS_MISSING_DATA_LOG) {
+      if (layer->debug || layer->map->debug) {
+        msDebug("Corrupt, empty or missing file '%s' for layer '%s' ... "
+                "ignoring this missing data.  %s\n",
+                szPath, layer->name, cpl_error_msg);
+      }
+      return (CDRT_CONTINUE_NEXT_TILE);
+    } else if (ignore_missing == MS_MISSING_DATA_IGNORE) {
+      return (CDRT_CONTINUE_NEXT_TILE);
+    } else {
+      /* never get here */
+      msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.",
+                 "msDrawRasterLayerLow()");
+      return (CDRT_RETURN_MS_FAILURE);
+    }
+  }
+
+  return CDRT_OK;
+}
+
+/************************************************************************/
+/*              msDrawRasterLayerLowOpenDataset()                       */
+/************************************************************************/
+
+void *msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
+                                      const char *filename,
+                                      char szPath[MS_MAXPATHLEN],
+                                      char **p_decrypted_path) {
+  const char *pszPath;
+
+  msGDALInitialize();
+
+  if (layer->debug)
+    msDebug("msDrawRasterLayerLow(%s): Filename is: %s\n", layer->name,
+            filename);
+
+  if (strncmp(filename, "<VRTDataset", strlen("<VRTDataset")) == 0) {
+    pszPath = filename;
+  } else {
+    msDrawRasterBuildRasterPath(map, layer, filename, szPath);
+    pszPath = szPath;
+  }
+  if (layer->debug)
+    msDebug("msDrawRasterLayerLow(%s): Path is: %s\n", layer->name, pszPath);
+
+  /*
+  ** Note: because we do decryption after the above path expansion
+  ** which depends on actually finding a file, it essentially means that
+  ** fancy path manipulation is essentially disabled when using encrypted
+  ** components. But that is mostly ok, since stuff like sde,postgres and
+  ** oracle georaster do not use real paths.
+  */
+  *p_decrypted_path = msDecryptStringTokens(map, pszPath);
+  if (*p_decrypted_path == NULL)
+    return NULL;
+
+  msAcquireLock(TLOCK_GDAL);
+  if (!layer->tileindex) {
+    char **connectionoptions =
+        msGetStringListFromHashTable(&(layer->connectionoptions));
+    char **papszAllowedDrivers = NULL;
+    // ALLOWED_GDAL_DRIVERS typically set by msDrawWMSLayerLow()
+    const char *pszAllowedDrivers =
+        msLayerGetProcessingKey(layer, "ALLOWED_GDAL_DRIVERS");
+    if (pszAllowedDrivers && !EQUAL(pszAllowedDrivers, "*"))
+      papszAllowedDrivers = CSLTokenizeString2(pszAllowedDrivers, ",", 0);
+    GDALDatasetH hDS =
+        GDALOpenEx(*p_decrypted_path, GDAL_OF_RASTER | GDAL_OF_SHARED,
+                   (const char *const *)papszAllowedDrivers,
+                   (const char *const *)connectionoptions, NULL);
+    CSLDestroy(papszAllowedDrivers);
+    CSLDestroy(connectionoptions);
+
+    // Give a hint about which GDAL driver should be enabled, but only in
+    // debug mode.
+    if (layer->debug && hDS == NULL && pszAllowedDrivers &&
+        !EQUAL(pszAllowedDrivers, "*")) {
+      GDALDriverH hDrv = GDALIdentifyDriver(*p_decrypted_path, NULL);
+      if (hDrv) {
+        const char *pszDrvName = GDALGetDescription(hDrv);
+        bool bFound = false;
+        for (int i = 0; papszAllowedDrivers && papszAllowedDrivers[i]; ++i) {
+          if (EQUAL(papszAllowedDrivers[i], pszDrvName)) {
+            bFound = true;
+            break;
+          }
+        }
+        if (!bFound) {
+          msSetError(MS_IMGERR,
+                     "Failed to draw layer named '%s'. The image returned "
+                     "is recognized by GDAL driver %s, but it is not allowed "
+                     "currently.",
+                     "msDrawRasterLayerLowOpenDataset()", layer->name,
+                     pszDrvName);
+        }
+      }
+    }
+    return hDS;
+  } else {
+    return GDALOpenShared(*p_decrypted_path, GA_ReadOnly);
+  }
+}
+
+/************************************************************************/
+/*                msDrawRasterLayerLowCloseDataset()                    */
+/************************************************************************/
+
+void msDrawRasterLayerLowCloseDataset(layerObj *layer, void *hDS) {
+  if (hDS) {
+    const char *close_connection;
+    close_connection = msLayerGetProcessingKey(layer, "CLOSE_CONNECTION");
+
+    if (close_connection == NULL && layer->tileindex == NULL)
+      close_connection = "DEFER";
+
+    {
+      /* Due to how GDAL processes OVERVIEW_LEVEL, datasets returned are */
+      /* not shared, despite being asked to, so close them for real */
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      if (CSLFetchNameValue(connectionoptions, "OVERVIEW_LEVEL"))
+        close_connection = NULL;
+      CSLDestroy(connectionoptions);
+    }
+
+    if (close_connection != NULL &&
+        strcasecmp(close_connection, "DEFER") == 0) {
+      GDALDereferenceDataset((GDALDatasetH)hDS);
+    } else {
+      GDALClose((GDALDatasetH)hDS);
+    }
+    msReleaseLock(TLOCK_GDAL);
+  }
+}
+
+/************************************************************************/
+/*                msDrawRasterLayerLowCheckIfMustDraw()                 */
+/*                                                                      */
+/*      Return 1 if the layer should be drawn.                          */
+/************************************************************************/
+
+int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer) {
+  if (!layer->data && !layer->tileindex &&
+      !(layer->connectiontype == MS_KERNELDENSITY ||
+        layer->connectiontype == MS_IDW)) {
+    if (layer->debug)
+      msDebug("msDrawRasterLayerLow(%s): layer data and tileindex NULL ... "
+              "doing nothing.",
+              layer->name);
+    return (0);
+  }
+
+  if ((layer->status != MS_ON) && (layer->status != MS_DEFAULT)) {
+    if (layer->debug)
+      msDebug(
+          "msDrawRasterLayerLow(%s): not status ON or DEFAULT, doing nothing.",
+          layer->name);
+    return (0);
+  }
+
+  if (map->scaledenom > 0) {
+    if ((layer->maxscaledenom > 0) &&
+        (map->scaledenom > layer->maxscaledenom)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map scale %.2g > "
+                "MAXSCALEDENOM=%g\n",
+                layer->name, map->scaledenom, layer->maxscaledenom);
+      return (0);
+    }
+    if ((layer->minscaledenom > 0) &&
+        (map->scaledenom <= layer->minscaledenom)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map scale %.2g < "
+                "MINSCALEDENOM=%g\n",
+                layer->name, map->scaledenom, layer->minscaledenom);
+      return (0);
+    }
+  }
+
+  if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
+    if ((layer->maxgeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map width %.2g > "
+                "MAXSCALEDENOM=%g\n",
+                layer->name, (map->extent.maxx - map->extent.minx),
+                layer->maxgeowidth);
+      return (0);
+    }
+    if ((layer->mingeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map width %.2g < "
+                "MINSCALEDENOM=%g\n",
+                layer->name, (map->extent.maxx - map->extent.minx),
+                layer->mingeowidth);
+      return (0);
+    }
+  }
+
+  return 1;
+}
+
+/************************************************************************/
+/*                        msDrawRasterLayerLow()                        */
+/*                                                                      */
+/*      Check for various file types and act appropriately.  Handle     */
+/*      tile indexing.                                                  */
+/************************************************************************/
+
+int msDrawRasterLayerLow(mapObj *map, layerObj *layer, imageObj *image,
+                         rasterBufferObj *rb) {
+  return msDrawRasterLayerLowWithDataset(map, layer, image, rb, NULL);
+}
+
+int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer,
+                                    imageObj *image, rasterBufferObj *rb,
+                                    void *hDatasetIn) {
+  /* -------------------------------------------------------------------- */
+  /*      As of MapServer 6.0 GDAL is required for rendering raster       */
+  /*      imagery.                                                        */
+  /* -------------------------------------------------------------------- */
+  int status, done;
+  char *filename = NULL, tilename[MS_MAXPATHLEN], tilesrsname[1024];
+
+  layerObj *tlp = NULL; /* pointer to the tile layer either real or temporary */
+  int tileitemindex = -1, tilelayerindex = -1, tilesrsindex = -1;
+  shapeObj tshp;
+
+  char szPath[MS_MAXPATHLEN] = {0};
+  char *decrypted_path = NULL;
+  int final_status = MS_SUCCESS;
+
+  rectObj searchrect;
+  GDALDatasetH hDS;
+  double adfGeoTransform[6];
+  void *kernel_density_cleanup_ptr = NULL;
+
+  if (layer->debug > 0 || map->debug > 1)
+    msDebug("msDrawRasterLayerLow(%s): entering.\n", layer->name);
+
+  if (hDatasetIn == NULL && !msDrawRasterLayerLowCheckIfMustDraw(map, layer)) {
+    return MS_SUCCESS;
+  }
+
+  msGDALInitialize();
+
+  if (layer->tileindex) { /* we have an index file */
+    msInitShape(&tshp);
+    searchrect = map->extent;
+
+    status = msDrawRasterSetupTileLayer(map, layer, &searchrect, MS_FALSE,
+                                        &tilelayerindex, &tileitemindex,
+                                        &tilesrsindex, &tlp);
+    if (status != MS_SUCCESS) {
+      if (status != MS_DONE)
+        final_status = status;
+      goto cleanup;
+    }
+  }
+
+  done = MS_FALSE;
+  while (done != MS_TRUE) {
+
+    if (layer->tileindex) {
+      status = msDrawRasterIterateTileIndex(
+          layer, tlp, &tshp, tileitemindex, tilesrsindex, tilename,
+          sizeof(tilename), tilesrsname, sizeof(tilesrsname));
+      if (status == MS_FAILURE) {
+        final_status = MS_FAILURE;
+        break;
+      }
+
+      if (status == MS_DONE)
+        break; /* no more tiles/images */
+      filename = tilename;
+    } else {
+      filename = layer->data;
+      done = MS_TRUE; /* only one image so we're done after this */
+    }
+
+    if (layer->connectiontype == MS_KERNELDENSITY ||
+        layer->connectiontype == MS_IDW) {
+      msAcquireLock(TLOCK_GDAL);
+      status = msInterpolationDataset(map, image, layer, &hDS,
+                                      &kernel_density_cleanup_ptr);
+      if (status != MS_SUCCESS) {
+        msReleaseLock(TLOCK_GDAL);
+        final_status = status;
+        goto cleanup;
+      }
+      done = MS_TRUE;
+      if (msProjectionsDiffer(&map->projection, &layer->projection)) {
+        char *mapProjStr = msGetProjectionString(&(map->projection));
+
+        /* Set the projection to the map file projection */
+        if (msLoadProjectionString(&(layer->projection), mapProjStr) != 0) {
+          GDALClose(hDS);
+          msReleaseLock(TLOCK_GDAL);
+          msSetError(MS_CGIERR,
+                     "Unable to set projection on interpolation layer.",
+                     "msDrawRasterLayerLow()");
+          return (MS_FAILURE);
+        }
+        free(mapProjStr);
+      }
+    } else {
+      if (strlen(filename) == 0)
+        continue;
+      if (hDatasetIn) {
+        hDS = (GDALDatasetH)hDatasetIn;
+      } else {
+        hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
+            map, layer, filename, szPath, &decrypted_path);
+      }
+    }
+
+    if (hDatasetIn == NULL) {
+      CheckDatasetReturnType eRet = msDrawRasterLayerLowCheckDataset(
+          map, layer, hDS, decrypted_path, szPath);
+
+      msFree(decrypted_path);
+      decrypted_path = NULL;
+
+      if (eRet == CDRT_CONTINUE_NEXT_TILE) {
+        msReleaseLock(TLOCK_GDAL);
+        continue;
+      }
+      if (eRet == CDRT_RETURN_MS_FAILURE) {
+        msReleaseLock(TLOCK_GDAL);
+        return MS_FAILURE;
+      }
+    }
+
+    if (msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex,
+                                   tilesrsname) != MS_SUCCESS) {
+      if (hDatasetIn == NULL) {
+        GDALClose(hDS);
+        msReleaseLock(TLOCK_GDAL);
+      }
+      final_status = MS_FAILURE;
+      break;
+    }
+
+    msGetGDALGeoTransform(hDS, map, layer, adfGeoTransform);
+
+    /*
+    ** We want to resample if the source image is rotated, if
+    ** the projections differ or if resampling has been explicitly
+    ** requested, or if the image has north-down instead of north-up.
+    */
+
+    if (((adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0 ||
+          adfGeoTransform[5] > 0.0 || adfGeoTransform[1] < 0.0) &&
+         layer->transform) ||
+        msProjectionsDiffer(&(map->projection), &(layer->projection)) ||
+        CSLFetchNameValue(layer->processing, "RESAMPLE") != NULL) {
+      status = msResampleGDALToMap(map, layer, image, rb, hDS);
+    } else {
+      if (adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0) {
+        if (layer->debug || map->debug)
+          msDebug("Layer %s has rotational coefficients but we\n"
+                  "are unable to use them, projections support\n"
+                  "needs to be built in.",
+                  layer->name);
+      }
+      status = msDrawRasterLayerGDAL(map, layer, image, rb, hDS);
+    }
+
+    if (status == -1) {
+      if (hDatasetIn == NULL) {
+        GDALClose(hDS);
+        msReleaseLock(TLOCK_GDAL);
+      }
+      final_status = MS_FAILURE;
+      break;
+    }
+
+    /*
+    ** Should we keep this file open for future use?
+    ** default to keeping open for single data files, and
+    ** to closing for tile indexes
+    */
+    if (layer->connectiontype == MS_KERNELDENSITY ||
+        layer->connectiontype == MS_IDW) {
+      /*
+      ** Fix issue #5330
+      ** The in-memory kernel density heatmap gdal dataset handle (hDS) gets
+      *re-used
+      ** but the associated rasterband cache doesn't get flushed, which causes
+      *old data
+      ** to be rendered instead of the newly generated imagery. To fix, simply
+      *close the
+      ** the handle and prevent further re-use.
+      ** Note that instead of this workaround, we could explicitely set
+      ** CLOSE_CONNECTION=ALWAYS on the kerneldensity layer.
+      */
+      GDALClose(hDS);
+      msReleaseLock(TLOCK_GDAL);
+    } else {
+      if (hDatasetIn == NULL)
+        msDrawRasterLayerLowCloseDataset(layer, hDS);
+    }
+
+  } /* next tile */
+
+cleanup:
+  if (layer->tileindex) { /* tiling clean-up */
+    msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
+  }
+  if (kernel_density_cleanup_ptr) {
+    msCleanupInterpolationDataset(map, image, layer,
+                                  kernel_density_cleanup_ptr);
+  }
+
+  return final_status;
+}
+
+/************************************************************************/
+/*                         msDrawReferenceMap()                         */
+/************************************************************************/
+
+imageObj *msDrawReferenceMap(mapObj *map) {
+  double cellsize;
+  int x1, y1, x2, y2;
+  char szPath[MS_MAXPATHLEN];
+  int status = MS_SUCCESS;
+
+  imageObj *image = NULL;
+  styleObj style;
+
+  /* check to see if we have enough information to actually proceed */
+  if (!map->reference.image || map->reference.height == 0 ||
+      map->reference.width == 0) {
+    msSetError(MS_MISCERR, "Reference map configuration error.",
+               "msDrawReferenceMap()");
+    return NULL;
+  }
+
+  rendererVTableObj *renderer = MS_MAP_RENDERER(map);
+  rasterBufferObj *refImage =
+      (rasterBufferObj *)calloc(1, sizeof(rasterBufferObj));
+  MS_CHECK_ALLOC(refImage, sizeof(rasterBufferObj), NULL);
+
+  if (MS_SUCCESS !=
+      renderer->loadImageFromFile(
+          msBuildPath(szPath, map->mappath, map->reference.image), refImage)) {
+    msSetError(MS_MISCERR, "Error loading reference image %s.",
+               "msDrawReferenceMap()", szPath);
+    free(refImage);
+    return NULL;
+  }
+
+  image = msImageCreate(refImage->width, refImage->height, map->outputformat,
+                        map->web.imagepath, map->web.imageurl, map->resolution,
+                        map->defresolution, &(map->reference.color));
+  if (!image) {
+    free(refImage);
+    return NULL;
+  }
+
+  status = renderer->mergeRasterBuffer(image, refImage, 1.0, 0, 0, 0, 0,
+                                       refImage->width, refImage->height);
+  msFreeRasterBuffer(refImage);
+  free(refImage);
+  if (MS_UNLIKELY(status == MS_FAILURE))
+    return NULL;
+
+  /* make sure the extent given in mapfile fits the image */
+  cellsize =
+      msAdjustExtent(&(map->reference.extent), image->width, image->height);
+
+  /* convert map extent to reference image coordinates */
+  x1 = MS_MAP2IMAGE_X(map->extent.minx, map->reference.extent.minx, cellsize);
+  x2 = MS_MAP2IMAGE_X(map->extent.maxx, map->reference.extent.minx, cellsize);
+  y1 = MS_MAP2IMAGE_Y(map->extent.maxy, map->reference.extent.maxy, cellsize);
+  y2 = MS_MAP2IMAGE_Y(map->extent.miny, map->reference.extent.maxy, cellsize);
+
+  initStyle(&style);
+  style.color = map->reference.color;
+  style.outlinecolor = map->reference.outlinecolor;
+
+  /* if extent are smaller than minbox size */
+  /* draw that extent on the reference image */
+  if ((abs(x2 - x1) > map->reference.minboxsize) ||
+      (abs(y2 - y1) > map->reference.minboxsize)) {
+    shapeObj rect;
+    lineObj line;
+    pointObj points[5];
+    msInitShape(&rect);
+
+    line.point = points;
+    line.numpoints = 5;
+    rect.line = &line;
+    rect.numlines = 1;
+    rect.type = MS_SHAPE_POLYGON;
+
+    line.point[0].x = x1;
+    line.point[0].y = y1;
+    line.point[1].x = x1;
+    line.point[1].y = y2;
+    line.point[2].x = x2;
+    line.point[2].y = y2;
+    line.point[3].x = x2;
+    line.point[3].y = y1;
+    line.point[4].x = line.point[0].x;
+    line.point[4].y = line.point[0].y;
+
+    line.numpoints = 5;
+
+    if (map->reference.maxboxsize == 0 ||
+        ((abs(x2 - x1) < map->reference.maxboxsize) &&
+         (abs(y2 - y1) < map->reference.maxboxsize))) {
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msDrawShadeSymbol(map, image, &rect, &style, 1.0))) {
+        msFreeImage(image);
+        return NULL;
+      }
+    }
+
+  } else { /* else draw the marker symbol */
+    if (map->reference.maxboxsize == 0 ||
+        ((abs(x2 - x1) < map->reference.maxboxsize) &&
+         (abs(y2 - y1) < map->reference.maxboxsize))) {
+      style.size = map->reference.markersize;
+
+      /* if the marker symbol is specify draw this symbol else draw a cross */
+      if (map->reference.marker || map->reference.markername) {
+        pointObj point;
+        point.x = (double)(x1 + x2) / 2;
+        point.y = (double)(y1 + y2) / 2;
+
+        if (map->reference.marker) {
+          style.symbol = map->reference.marker;
+        } else {
+          style.symbol = msGetSymbolIndex(&map->symbolset,
+                                          map->reference.markername, MS_TRUE);
+        }
+
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawMarkerSymbol(map, image, &point, &style, 1.0))) {
+          msFreeImage(image);
+          return NULL;
+        }
+      } else {
+        int x21, y21;
+        shapeObj cross;
+        lineObj lines[4];
+        pointObj point[8];
+        int i;
+        /* determine the center point */
+        x21 = MS_NINT((x1 + x2) / 2);
+        y21 = MS_NINT((y1 + y2) / 2);
+
+        msInitShape(&cross);
+        cross.numlines = 4;
+        cross.line = lines;
+        for (i = 0; i < 4; i++) {
+          cross.line[i].numpoints = 2;
+          cross.line[i].point = &(point[2 * i]);
+        }
+        /* draw a cross */
+        cross.line[0].point[0].x = x21 - 8;
+        cross.line[0].point[0].y = y21;
+        cross.line[0].point[1].x = x21 - 3;
+        cross.line[0].point[1].y = y21;
+        cross.line[1].point[0].x = x21;
+        cross.line[1].point[0].y = y21 - 8;
+        cross.line[1].point[1].x = x21;
+        cross.line[1].point[1].y = y21 - 3;
+        cross.line[2].point[0].x = x21;
+        cross.line[2].point[0].y = y21 + 3;
+        cross.line[2].point[1].x = x21;
+        cross.line[2].point[1].y = y21 + 8;
+        cross.line[3].point[0].x = x21 + 3;
+        cross.line[3].point[0].y = y21;
+        cross.line[3].point[1].x = x21 + 8;
+        cross.line[3].point[1].y = y21;
+
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawLineSymbol(map, image, &cross, &style, 1.0))) {
+          msFreeImage(image);
+          return NULL;
+        }
+      }
+    }
+  }
+
+  return (image);
+}
diff -pruN 8.0.1-5/src/mapraster.h 8.2.0~beta1-1~exp1/src/mapraster.h
--- 8.0.1-5/src/mapraster.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapraster.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,60 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Private include file used by mapraster.c and maprasterquery.c
+ * Author:   Even Rouault
+ *
+ ******************************************************************************
+ * Copyright (c) 2013 Regents of the University of Minnesota.
+ *
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#ifndef MAPRASTER_H
+#define MAPRASTER_H
+
+int msDrawRasterSetupTileLayer(mapObj *map, layerObj *layer,
+                               rectObj *psearchrect, int is_query,
+                               int *ptilelayerindex, /* output */
+                               int *ptileitemindex,  /* output */
+                               int *ptilesrsindex,   /* output */
+                               layerObj **ptlp /* output */);
+
+void msDrawRasterCleanupTileLayer(layerObj *tlp, int tilelayerindex);
+
+int msDrawRasterIterateTileIndex(layerObj *layer, layerObj *tlp,
+                                 shapeObj *ptshp, /* input-output */
+                                 int tileitemindex, int tilesrsindex,
+                                 char *tilename, /* output */
+                                 size_t sizeof_tilename,
+                                 char *tilesrsname, /* output */
+                                 size_t sizeof_tilesrsname);
+
+int msDrawRasterBuildRasterPath(mapObj *map, layerObj *layer,
+                                const char *filename,
+                                char szPath[MS_MAXPATHLEN]);
+
+const char *msDrawRasterGetCPLErrorMsg(const char *decrypted_path,
+                                       const char *szPath);
+
+int msDrawRasterLoadProjection(layerObj *layer, GDALDatasetH hDS,
+                               const char *filename, int tilesrsindex,
+                               const char *tilesrsname);
+
+#endif /* MAPRASTER_H */
diff -pruN 8.0.1-5/src/maprasterquery.c 8.2.0~beta1-1~exp1/src/maprasterquery.c
--- 8.0.1-5/src/maprasterquery.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maprasterquery.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1424 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of query operations on rasters.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "mapresample.h"
+#include "mapthread.h"
+#include "mapraster.h"
+
+int msRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
+int msRASTERLayerGetItems(layerObj *layer);
+
+/* ==================================================================== */
+/*      For now the rasterLayerInfo lives here since it is just used    */
+/*      to hold information related to queries.                         */
+/* ==================================================================== */
+typedef struct {
+
+  /* query cache results */
+  int query_results;
+  int query_alloc_max;
+  int query_request_max;
+  int query_result_hard_max;
+  int raster_query_mode;
+  int band_count;
+
+  int refcount;
+
+  rectObj which_rect;
+  int next_shape;
+
+  double *qc_x;
+  double *qc_y;
+  double *qc_x_reproj;
+  double *qc_y_reproj;
+  float *qc_values;
+  int *qc_class;
+  int *qc_red;
+  int *qc_green;
+  int *qc_blue;
+  int *qc_count;
+  int *qc_tileindex;
+
+  /* query bound in force */
+  shapeObj *searchshape;
+
+  /* Only nearest result to this point. */
+  int range_mode; /* MS_QUERY_SINGLE, MS_QUERY_MULTIPLE or -1 (skip test) */
+  double range_dist;
+  pointObj target_point;
+
+  GDALColorTableH hCT;
+
+  double shape_tolerance;
+
+} rasterLayerInfo;
+
+#define RQM_UNKNOWN 0
+#define RQM_ENTRY_PER_PIXEL 1
+#define RQM_HIST_ON_CLASS 2
+#define RQM_HIST_ON_VALUE 3
+
+extern int InvGeoTransform(double *gt_in, double *gt_out);
+#define GEO_TRANS(tr, x, y) ((tr)[0] + (tr)[1] * (x) + (tr)[2] * (y))
+
+/************************************************************************/
+/*                             addResult()                              */
+/*                                                                      */
+/*      this is a copy of the code in mapquery.c.  Should we prepare    */
+/*      a small public API for managing results caches?                 */
+/************************************************************************/
+
+static int addResult(resultCacheObj *cache, int classindex, int shapeindex,
+                     int tileindex) {
+  int i;
+
+  if (cache->numresults == cache->cachesize) { /* just add it to the end */
+    if (cache->cachesize == 0)
+      cache->results =
+          (resultObj *)malloc(sizeof(resultObj) * MS_RESULTCACHEINCREMENT);
+    else
+      cache->results = (resultObj *)realloc(
+          cache->results,
+          sizeof(resultObj) * (cache->cachesize + MS_RESULTCACHEINCREMENT));
+    if (!cache->results) {
+      msSetError(MS_MEMERR, "Realloc() error.", "addResult()");
+      return (MS_FAILURE);
+    }
+    cache->cachesize += MS_RESULTCACHEINCREMENT;
+  }
+
+  i = cache->numresults;
+
+  cache->results[i].classindex = classindex;
+  cache->results[i].tileindex = tileindex;
+  cache->results[i].shapeindex = shapeindex;
+  cache->results[i].resultindex = -1; /* unused */
+  cache->results[i].shape = NULL;
+  cache->numresults++;
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                       msRasterLayerInfoFree()                        */
+/************************************************************************/
+
+static void msRasterLayerInfoFree(layerObj *layer)
+
+{
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  if (rlinfo == NULL)
+    return;
+
+  if (rlinfo->qc_x != NULL) {
+    free(rlinfo->qc_x);
+    free(rlinfo->qc_y);
+    free(rlinfo->qc_x_reproj);
+    free(rlinfo->qc_y_reproj);
+  }
+
+  if (rlinfo->qc_values)
+    free(rlinfo->qc_values);
+
+  if (rlinfo->qc_class) {
+    free(rlinfo->qc_class);
+  }
+
+  if (rlinfo->qc_red) {
+    free(rlinfo->qc_red);
+    free(rlinfo->qc_green);
+    free(rlinfo->qc_blue);
+  }
+
+  if (rlinfo->qc_count != NULL)
+    free(rlinfo->qc_count);
+
+  if (rlinfo->qc_tileindex != NULL)
+    free(rlinfo->qc_tileindex);
+
+  free(rlinfo);
+
+  layer->layerinfo = NULL;
+}
+
+/************************************************************************/
+/*                    msRasterLayerInfoInitialize()                     */
+/************************************************************************/
+
+static void msRasterLayerInfoInitialize(layerObj *layer)
+
+{
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  if (rlinfo != NULL)
+    return;
+
+  rlinfo = (rasterLayerInfo *)msSmallCalloc(1, sizeof(rasterLayerInfo));
+  layer->layerinfo = rlinfo;
+
+  rlinfo->band_count = -1;
+  rlinfo->raster_query_mode = RQM_ENTRY_PER_PIXEL;
+  rlinfo->range_mode = -1; /* inactive */
+  rlinfo->refcount = 0;
+  rlinfo->shape_tolerance = 0.0;
+
+  /* We need to do this or the layer->layerinfo will be interpreted */
+  /* as shapefile access info because the default connectiontype is */
+  /* MS_SHAPEFILE. */
+  if (layer->connectiontype != MS_WMS &&
+      layer->connectiontype != MS_KERNELDENSITY)
+    layer->connectiontype = MS_RASTER;
+
+  rlinfo->query_result_hard_max = 1000000;
+
+  if (CSLFetchNameValue(layer->processing, "RASTER_QUERY_MAX_RESULT") != NULL) {
+    rlinfo->query_result_hard_max =
+        atoi(CSLFetchNameValue(layer->processing, "RASTER_QUERY_MAX_RESULT"));
+  }
+}
+
+/************************************************************************/
+/*                       msRasterQueryAddPixel()                        */
+/************************************************************************/
+
+static void msRasterQueryAddPixel(layerObj *layer, pointObj *location,
+                                  pointObj *reprojectedLocation, float *values)
+
+{
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+  int red = 0, green = 0, blue = 0, nodata = FALSE;
+  int p_class = -1;
+
+  if (rlinfo->query_results == rlinfo->query_result_hard_max)
+    return;
+
+  /* -------------------------------------------------------------------- */
+  /*      Is this our first time in?  If so, do an initial allocation     */
+  /*      for the data arrays suitable to our purposes.                   */
+  /* -------------------------------------------------------------------- */
+  if (rlinfo->query_alloc_max == 0) {
+    rlinfo->query_alloc_max = 2;
+
+    switch (rlinfo->raster_query_mode) {
+    case RQM_ENTRY_PER_PIXEL:
+      rlinfo->qc_x =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_y =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_x_reproj =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_y_reproj =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_values = (float *)msSmallCalloc(
+          sizeof(float),
+          ((size_t)rlinfo->query_alloc_max) * rlinfo->band_count);
+      rlinfo->qc_red =
+          (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      rlinfo->qc_green =
+          (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      rlinfo->qc_blue =
+          (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      if (layer->numclasses > 0)
+        rlinfo->qc_class =
+            (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      break;
+
+    case RQM_HIST_ON_CLASS:
+      break;
+
+    case RQM_HIST_ON_VALUE:
+      break;
+
+    default:
+      assert(FALSE);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Reallocate the data arrays larger if they are near the max      */
+  /*      now.                                                            */
+  /* -------------------------------------------------------------------- */
+  if (rlinfo->query_results == rlinfo->query_alloc_max) {
+    rlinfo->query_alloc_max = rlinfo->query_alloc_max * 2 + 100;
+
+    if (rlinfo->qc_x != NULL)
+      rlinfo->qc_x = msSmallRealloc(rlinfo->qc_x,
+                                    sizeof(double) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_y != NULL)
+      rlinfo->qc_y = msSmallRealloc(rlinfo->qc_y,
+                                    sizeof(double) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_x_reproj != NULL)
+      rlinfo->qc_x_reproj = msSmallRealloc(
+          rlinfo->qc_x_reproj, sizeof(double) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_y_reproj != NULL)
+      rlinfo->qc_y_reproj = msSmallRealloc(
+          rlinfo->qc_y_reproj, sizeof(double) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_values != NULL)
+      rlinfo->qc_values = msSmallRealloc(
+          rlinfo->qc_values,
+          sizeof(float) * rlinfo->query_alloc_max * rlinfo->band_count);
+    if (rlinfo->qc_class != NULL)
+      rlinfo->qc_class = msSmallRealloc(rlinfo->qc_class,
+                                        sizeof(int) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_red != NULL)
+      rlinfo->qc_red =
+          msSmallRealloc(rlinfo->qc_red, sizeof(int) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_green != NULL)
+      rlinfo->qc_green = msSmallRealloc(rlinfo->qc_green,
+                                        sizeof(int) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_blue != NULL)
+      rlinfo->qc_blue = msSmallRealloc(rlinfo->qc_blue,
+                                       sizeof(int) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_count != NULL)
+      rlinfo->qc_count = msSmallRealloc(rlinfo->qc_count,
+                                        sizeof(int) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_tileindex != NULL)
+      rlinfo->qc_tileindex = msSmallRealloc(
+          rlinfo->qc_tileindex, sizeof(int) * rlinfo->query_alloc_max);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle colormap                                                 */
+  /* -------------------------------------------------------------------- */
+  if (rlinfo->hCT != NULL) {
+    int pct_index = (int)floor(values[0]);
+    GDALColorEntry sEntry;
+
+    if (GDALGetColorEntryAsRGB(rlinfo->hCT, pct_index, &sEntry)) {
+      red = sEntry.c1;
+      green = sEntry.c2;
+      blue = sEntry.c3;
+
+      if (sEntry.c4 == 0)
+        nodata = TRUE;
+    } else
+      nodata = TRUE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Color derived from greyscale value.                             */
+  /* -------------------------------------------------------------------- */
+  else {
+    if (rlinfo->band_count >= 3) {
+      red = (int)MS_MAX(0, MS_MIN(255, values[0]));
+      green = (int)MS_MAX(0, MS_MIN(255, values[1]));
+      blue = (int)MS_MAX(0, MS_MIN(255, values[2]));
+    } else {
+      red = green = blue = (int)MS_MAX(0, MS_MIN(255, values[0]));
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle classification.                                          */
+  /*                                                                      */
+  /*      NOTE: The following is really quite inadequate to deal with     */
+  /*      classifications based on [red], [green] and [blue] as           */
+  /*      described in:                                                   */
+  /*       http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1021         */
+  /* -------------------------------------------------------------------- */
+  if (rlinfo->qc_class != NULL) {
+    p_class = msGetClass_FloatRGB(layer, values[0], red, green, blue);
+
+    if (p_class == -1)
+      nodata = TRUE;
+    else {
+      nodata = FALSE;
+      rlinfo->qc_class[rlinfo->query_results] = p_class;
+      if (layer->class[p_class] -> numstyles > 0) {
+        red = layer->class[p_class]->styles[0]->color.red;
+        green = layer->class[p_class]->styles[0]->color.green;
+        blue = layer->class[p_class]->styles[0]->color.blue;
+      } else {
+        red = green = blue = 0;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Record the color.                                               */
+  /* -------------------------------------------------------------------- */
+  rlinfo->qc_red[rlinfo->query_results] = red;
+  rlinfo->qc_green[rlinfo->query_results] = green;
+  rlinfo->qc_blue[rlinfo->query_results] = blue;
+
+  /* -------------------------------------------------------------------- */
+  /*      Record spatial location.                                        */
+  /* -------------------------------------------------------------------- */
+  if (rlinfo->qc_x != NULL) {
+    rlinfo->qc_x[rlinfo->query_results] = location->x;
+    rlinfo->qc_y[rlinfo->query_results] = location->y;
+    rlinfo->qc_x_reproj[rlinfo->query_results] = reprojectedLocation->x;
+    rlinfo->qc_y_reproj[rlinfo->query_results] = reprojectedLocation->y;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Record actual pixel value(s).                                   */
+  /* -------------------------------------------------------------------- */
+  if (rlinfo->qc_values != NULL)
+    memcpy(rlinfo->qc_values + rlinfo->query_results * rlinfo->band_count,
+           values, sizeof(float) * rlinfo->band_count);
+
+  /* -------------------------------------------------------------------- */
+  /*      Add to the results cache.                                       */
+  /* -------------------------------------------------------------------- */
+  if (!nodata) {
+    addResult(layer->resultcache, p_class, rlinfo->query_results, 0);
+    rlinfo->query_results++;
+  }
+}
+
+/************************************************************************/
+/*                       msRasterQueryByRectLow()                       */
+/************************************************************************/
+
+static int msRasterQueryByRectLow(mapObj *map, layerObj *layer,
+                                  GDALDatasetH hDS, rectObj queryRect)
+
+{
+  double adfGeoTransform[6], adfInvGeoTransform[6];
+  double dfXMin, dfYMin, dfXMax, dfYMax, dfX, dfY, dfAdjustedRange;
+  int nWinXOff, nWinYOff, nWinXSize, nWinYSize;
+  int nRXSize, nRYSize;
+  float *pafRaster;
+  int nBandCount, *panBandMap, iPixel, iLine;
+  CPLErr eErr;
+  rasterLayerInfo *rlinfo;
+  rectObj searchrect;
+
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  /* -------------------------------------------------------------------- */
+  /*      Reproject the search rect into the projection of this           */
+  /*      layer/file if needed.                                           */
+  /* -------------------------------------------------------------------- */
+  searchrect = queryRect;
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
+  if (layer->project)
+    msProjectRect(&(map->projection), &(layer->projection), &searchrect);
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform the rectangle in target ground coordinates to         */
+  /*      pixel/line extents on the file.  Process all 4 corners, to      */
+  /*      build extents.                                                  */
+  /* -------------------------------------------------------------------- */
+  nRXSize = GDALGetRasterXSize(hDS);
+  nRYSize = GDALGetRasterYSize(hDS);
+
+  msGetGDALGeoTransform(hDS, map, layer, adfGeoTransform);
+  InvGeoTransform(adfGeoTransform, adfInvGeoTransform);
+
+  /* top left */
+  dfXMin = dfXMax =
+      GEO_TRANS(adfInvGeoTransform, searchrect.minx, searchrect.maxy);
+  dfYMin = dfYMax =
+      GEO_TRANS(adfInvGeoTransform + 3, searchrect.minx, searchrect.maxy);
+
+  /* top right */
+  dfX = GEO_TRANS(adfInvGeoTransform, searchrect.maxx, searchrect.maxy);
+  dfY = GEO_TRANS(adfInvGeoTransform + 3, searchrect.maxx, searchrect.maxy);
+  dfXMin = MS_MIN(dfXMin, dfX);
+  dfXMax = MS_MAX(dfXMax, dfX);
+  dfYMin = MS_MIN(dfYMin, dfY);
+  dfYMax = MS_MAX(dfYMax, dfY);
+
+  /* bottom left */
+  dfX = GEO_TRANS(adfInvGeoTransform, searchrect.minx, searchrect.miny);
+  dfY = GEO_TRANS(adfInvGeoTransform + 3, searchrect.minx, searchrect.miny);
+  dfXMin = MS_MIN(dfXMin, dfX);
+  dfXMax = MS_MAX(dfXMax, dfX);
+  dfYMin = MS_MIN(dfYMin, dfY);
+  dfYMax = MS_MAX(dfYMax, dfY);
+
+  /* bottom right */
+  dfX = GEO_TRANS(adfInvGeoTransform, searchrect.maxx, searchrect.miny);
+  dfY = GEO_TRANS(adfInvGeoTransform + 3, searchrect.maxx, searchrect.miny);
+  dfXMin = MS_MIN(dfXMin, dfX);
+  dfXMax = MS_MAX(dfXMax, dfX);
+  dfYMin = MS_MIN(dfYMin, dfY);
+  dfYMax = MS_MAX(dfYMax, dfY);
+
+  /* -------------------------------------------------------------------- */
+  /*      Trim the rectangle to the area of the file itself, but out      */
+  /*      to the edges of the touched edge pixels.                        */
+  /* -------------------------------------------------------------------- */
+  dfXMin = MS_MAX(0.0, MS_MIN(nRXSize, floor(dfXMin)));
+  dfYMin = MS_MAX(0.0, MS_MIN(nRYSize, floor(dfYMin)));
+  dfXMax = MS_MAX(0.0, MS_MIN(nRXSize, ceil(dfXMax)));
+  dfYMax = MS_MAX(0.0, MS_MIN(nRYSize, ceil(dfYMax)));
+
+  /* -------------------------------------------------------------------- */
+  /*      Convert to integer offset/size values.                          */
+  /* -------------------------------------------------------------------- */
+  nWinXOff = (int)dfXMin;
+  nWinYOff = (int)dfYMin;
+  nWinXSize = (int)(dfXMax - dfXMin);
+  nWinYSize = (int)(dfYMax - dfYMin);
+
+  /* -------------------------------------------------------------------- */
+  /*      What bands are we operating on?                                 */
+  /* -------------------------------------------------------------------- */
+  panBandMap = msGetGDALBandList(layer, hDS, 0, &nBandCount);
+
+  if (rlinfo->band_count == -1)
+    rlinfo->band_count = nBandCount;
+
+  if (nBandCount != rlinfo->band_count) {
+    msSetError(MS_IMGERR, "Got %d bands, but expected %d bands.",
+               "msRasterQueryByRectLow()", nBandCount, rlinfo->band_count);
+
+    return -1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Try to load the raster data.  For now we just load the first    */
+  /*      band in the file.  Later we will deal with the various band     */
+  /*      selection criteria.                                             */
+  /* -------------------------------------------------------------------- */
+  pafRaster = (float *)calloc(sizeof(float),
+                              ((size_t)nWinXSize) * nWinYSize * nBandCount);
+  MS_CHECK_ALLOC(pafRaster, sizeof(float) * nWinXSize * nWinYSize * nBandCount,
+                 -1);
+
+  eErr = GDALDatasetRasterIO(hDS, GF_Read, nWinXOff, nWinYOff, nWinXSize,
+                             nWinYSize, pafRaster, nWinXSize, nWinYSize,
+                             GDT_Float32, nBandCount, panBandMap,
+                             4 * nBandCount, 4 * nBandCount * nWinXSize, 4);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALDatasetRasterIO() failed: %s",
+               "msRasterQueryByRectLow()", CPLGetLastErrorMsg());
+
+    free(pafRaster);
+    return -1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch color table for intepreting colors if needed.             */
+  /* -------------------------------------------------------------------- */
+  rlinfo->hCT = GDALGetRasterColorTable(GDALGetRasterBand(hDS, panBandMap[0]));
+
+  free(panBandMap);
+
+  /* -------------------------------------------------------------------- */
+  /*      When computing whether pixels are within range we do it         */
+  /*      based on the center of the pixel to the target point but        */
+  /*      really it ought to be the nearest point on the pixel.  It       */
+  /*      would be too much trouble to do this rigerously, so we just     */
+  /*      add a fudge factor so that a range of zero will find the        */
+  /*      pixel the target falls in at least.                             */
+  /* -------------------------------------------------------------------- */
+  dfAdjustedRange = sqrt(adfGeoTransform[1] * adfGeoTransform[1] +
+                         adfGeoTransform[2] * adfGeoTransform[2] +
+                         adfGeoTransform[4] * adfGeoTransform[4] +
+                         adfGeoTransform[5] * adfGeoTransform[5]) *
+                        0.5 * 1.41421356237 +
+                    sqrt(rlinfo->range_dist);
+  dfAdjustedRange = dfAdjustedRange * dfAdjustedRange;
+
+  reprojectionObj *reprojector = NULL;
+  if (layer->project) {
+    reprojector =
+        msProjectCreateReprojector(&(layer->projection), &(map->projection));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Loop over all pixels determining which are "in".                */
+  /* -------------------------------------------------------------------- */
+  for (iLine = 0; iLine < nWinYSize; iLine++) {
+    for (iPixel = 0; iPixel < nWinXSize; iPixel++) {
+      pointObj sPixelLocation = {0};
+
+      if (rlinfo->query_results == rlinfo->query_result_hard_max)
+        break;
+
+      /* transform pixel/line to georeferenced */
+      sPixelLocation.x = GEO_TRANS(adfGeoTransform, iPixel + nWinXOff + 0.5,
+                                   iLine + nWinYOff + 0.5);
+      sPixelLocation.y = GEO_TRANS(adfGeoTransform + 3, iPixel + nWinXOff + 0.5,
+                                   iLine + nWinYOff + 0.5);
+
+      /* If projections differ, convert this back into the map  */
+      /* projection for distance testing, and comprison to the  */
+      /* search shape.  Save the original pixel location coordinates */
+      /* in sPixelLocationInLayerSRS, so that we can return those */
+      /* coordinates if we have a hit */
+      pointObj sReprojectedPixelLocation = sPixelLocation;
+      if (reprojector) {
+        msProjectPointEx(reprojector, &sReprojectedPixelLocation);
+      }
+
+      /* If we are doing QueryByShape, check against the shape now */
+      if (rlinfo->searchshape != NULL) {
+        if (rlinfo->shape_tolerance == 0.0 &&
+            rlinfo->searchshape->type == MS_SHAPE_POLYGON) {
+          if (msIntersectPointPolygon(&sReprojectedPixelLocation,
+                                      rlinfo->searchshape) == MS_FALSE)
+            continue;
+        } else {
+          shapeObj tempShape;
+          lineObj tempLine;
+
+          memset(&tempShape, 0, sizeof(shapeObj));
+          tempShape.type = MS_SHAPE_POINT;
+          tempShape.numlines = 1;
+          tempShape.line = &tempLine;
+          tempLine.numpoints = 1;
+          tempLine.point = &sReprojectedPixelLocation;
+
+          if (msDistanceShapeToShape(rlinfo->searchshape, &tempShape) >
+              rlinfo->shape_tolerance)
+            continue;
+        }
+      }
+
+      if (rlinfo->range_mode >= 0) {
+        double dist;
+
+        dist = (rlinfo->target_point.x - sReprojectedPixelLocation.x) *
+                   (rlinfo->target_point.x - sReprojectedPixelLocation.x) +
+               (rlinfo->target_point.y - sReprojectedPixelLocation.y) *
+                   (rlinfo->target_point.y - sReprojectedPixelLocation.y);
+
+        if (dist >= dfAdjustedRange)
+          continue;
+
+        /* If we can only have one feature, trim range and clear */
+        /* previous result.  */
+        if (rlinfo->range_mode == MS_QUERY_SINGLE) {
+          rlinfo->range_dist = dist;
+          rlinfo->query_results = 0;
+        }
+      }
+
+      msRasterQueryAddPixel(layer,
+                            &sPixelLocation, // return coords in layer SRS
+                            &sReprojectedPixelLocation,
+                            pafRaster +
+                                (iLine * nWinXSize + iPixel) * nBandCount);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Cleanup.                                                        */
+  /* -------------------------------------------------------------------- */
+  free(pafRaster);
+  msProjectDestroyReprojector(reprojector);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                        msRasterQueryByRect()                         */
+/************************************************************************/
+
+int msRasterQueryByRect(mapObj *map, layerObj *layer, rectObj queryRect)
+
+{
+  int status = MS_SUCCESS;
+  char *filename = NULL;
+
+  layerObj *tlp = NULL; /* pointer to the tile layer either real or temporary */
+  int tileitemindex = -1, tilelayerindex = -1, tilesrsindex = -1;
+  shapeObj tshp;
+  char tilename[MS_PATH_LENGTH], tilesrsname[1024];
+  int done, destroy_on_failure;
+
+  char szPath[MS_MAXPATHLEN];
+  rectObj searchrect;
+  rasterLayerInfo *rlinfo = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Get the layer info.                                             */
+  /* -------------------------------------------------------------------- */
+  if (!layer->layerinfo) {
+    msRasterLayerInfoInitialize(layer);
+    destroy_on_failure = 1;
+  } else {
+    destroy_on_failure = 0;
+  }
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  /* -------------------------------------------------------------------- */
+  /*      Clear old results cache.                                        */
+  /* -------------------------------------------------------------------- */
+  if (layer->resultcache) {
+    if (layer->resultcache->results)
+      free(layer->resultcache->results);
+    free(layer->resultcache);
+    layer->resultcache = NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize the results cache.                                   */
+  /* -------------------------------------------------------------------- */
+  layer->resultcache = (resultCacheObj *)msSmallMalloc(sizeof(resultCacheObj));
+  layer->resultcache->results = NULL;
+  layer->resultcache->numresults = layer->resultcache->cachesize = 0;
+  layer->resultcache->bounds.minx = layer->resultcache->bounds.miny =
+      layer->resultcache->bounds.maxx = layer->resultcache->bounds.maxy = -1;
+
+  /* -------------------------------------------------------------------- */
+  /*      Check if we should really be acting on this layer and           */
+  /*      provide debug info in various cases.                            */
+  /* -------------------------------------------------------------------- */
+  if (layer->debug > 0 || map->debug > 1)
+    msDebug("msRasterQueryByRect(%s): entering.\n", layer->name);
+
+  if (!layer->data && !layer->tileindex) {
+    if (layer->debug > 0 || map->debug > 0)
+      msDebug("msRasterQueryByRect(%s): layer data and tileindex NULL ... "
+              "doing nothing.",
+              layer->name);
+    return MS_SUCCESS;
+  }
+
+  if ((layer->status != MS_ON) && layer->status != MS_DEFAULT) {
+    if (layer->debug > 0)
+      msDebug(
+          "msRasterQueryByRect(%s): not status ON or DEFAULT, doing nothing.",
+          layer->name);
+    return MS_SUCCESS;
+  }
+
+  /* ==================================================================== */
+  /*      Handle setting up tileindex layer.                              */
+  /* ==================================================================== */
+  if (layer->tileindex) { /* we have an index file */
+    msInitShape(&tshp);
+    searchrect = queryRect;
+
+    status = msDrawRasterSetupTileLayer(map, layer, &searchrect, MS_TRUE,
+                                        &tilelayerindex, &tileitemindex,
+                                        &tilesrsindex, &tlp);
+    if (status != MS_SUCCESS) {
+      goto cleanup;
+    }
+  } else {
+    /* we have to manually apply to scaletoken logic as we're not going through
+     * msLayerOpen() */
+    status = msLayerApplyScaletokens(layer, map->scaledenom);
+    if (status != MS_SUCCESS) {
+      goto cleanup;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Iterate over all tiles (just one in untiled case).              */
+  /* -------------------------------------------------------------------- */
+  done = MS_FALSE;
+  while (done == MS_FALSE && status == MS_SUCCESS) {
+
+    GDALDatasetH hDS;
+    char *decrypted_path = NULL;
+
+    /* -------------------------------------------------------------------- */
+    /*      Get filename.                                                   */
+    /* -------------------------------------------------------------------- */
+    if (layer->tileindex) {
+      status = msDrawRasterIterateTileIndex(
+          layer, tlp, &tshp, tileitemindex, tilesrsindex, tilename,
+          sizeof(tilename), tilesrsname, sizeof(tilesrsname));
+      if (status == MS_FAILURE) {
+        break;
+      }
+
+      if (status == MS_DONE)
+        break; /* no more tiles/images */
+      filename = tilename;
+    } else {
+      filename = layer->data;
+      done = MS_TRUE; /* only one image so we're done after this */
+    }
+
+    if (strlen(filename) == 0)
+      continue;
+
+    /* -------------------------------------------------------------------- */
+    /*      Open the file.                                                  */
+    /* -------------------------------------------------------------------- */
+    msGDALInitialize();
+
+    msDrawRasterBuildRasterPath(map, layer, filename, szPath);
+
+    decrypted_path = msDecryptStringTokens(map, szPath);
+    if (!decrypted_path) {
+      status = MS_FAILURE;
+      goto cleanup;
+    }
+
+    msAcquireLock(TLOCK_GDAL);
+    if (!layer->tileindex) {
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                       (const char *const *)connectionoptions, NULL);
+      CSLDestroy(connectionoptions);
+    } else {
+      hDS = GDALOpen(decrypted_path, GA_ReadOnly);
+    }
+
+    if (hDS == NULL) {
+      int ignore_missing = msMapIgnoreMissingData(map);
+      const char *cpl_error_msg =
+          msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
+
+      msFree(decrypted_path);
+      decrypted_path = NULL;
+
+      msReleaseLock(TLOCK_GDAL);
+
+      if (ignore_missing == MS_MISSING_DATA_FAIL) {
+        if (layer->debug || map->debug)
+          msSetError(MS_IMGERR,
+                     "Unable to open file %s for layer %s ... fatal error.\n%s",
+                     "msRasterQueryByRect()", szPath, layer->name,
+                     cpl_error_msg);
+        status = MS_FAILURE;
+        goto cleanup;
+      }
+      if (ignore_missing == MS_MISSING_DATA_LOG) {
+        if (layer->debug || map->debug)
+          msDebug("Unable to open file %s for layer %s ... ignoring this "
+                  "missing data.\n%s",
+                  filename, layer->name, cpl_error_msg);
+      }
+      continue;
+    }
+
+    msFree(decrypted_path);
+    decrypted_path = NULL;
+
+    if (msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex,
+                                   tilesrsname) != MS_SUCCESS) {
+      msReleaseLock(TLOCK_GDAL);
+      status = MS_FAILURE;
+      goto cleanup;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Perform actual query on this file.                              */
+    /* -------------------------------------------------------------------- */
+    if (status == MS_SUCCESS)
+      status = msRasterQueryByRectLow(map, layer, hDS, queryRect);
+
+    GDALClose(hDS);
+    msReleaseLock(TLOCK_GDAL);
+
+  } /* next tile */
+
+  /* -------------------------------------------------------------------- */
+  /*      Cleanup tileindex if it is open.                                */
+  /* -------------------------------------------------------------------- */
+cleanup:
+  if (layer->tileindex) { /* tiling clean-up */
+    msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
+  } else {
+    msLayerRestoreFromScaletokens(layer);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      On failure, or empty result set, cleanup the rlinfo since we    */
+  /*      likely won't ever have it accessed or cleaned up later.         */
+  /* -------------------------------------------------------------------- */
+  if (status == MS_FAILURE || rlinfo->query_results == 0) {
+    if (destroy_on_failure) {
+      msRasterLayerInfoFree(layer);
+    }
+  } else {
+    /* populate the items/numitems layer-level values */
+    msRASTERLayerGetItems(layer);
+  }
+
+  return status;
+}
+
+/************************************************************************/
+/*                        msRasterQueryByShape()                        */
+/************************************************************************/
+
+int msRasterQueryByShape(mapObj *map, layerObj *layer, shapeObj *selectshape)
+
+{
+  rasterLayerInfo *rlinfo = NULL;
+  int status;
+  double tolerance;
+  rectObj searchrect;
+
+  msRasterLayerInfoInitialize(layer);
+
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  /* If the selection shape is point or line we use the default tolerance of
+     3, but for polygons we require an exact hit. */
+  if (layer->tolerance == -1) {
+    if (selectshape->type == MS_SHAPE_POINT ||
+        selectshape->type == MS_SHAPE_LINE)
+      tolerance = 3;
+    else
+      tolerance = 0;
+  } else
+    tolerance = layer->tolerance;
+
+  if (layer->toleranceunits == MS_PIXELS)
+    tolerance =
+        tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
+  else
+    tolerance = tolerance * (msInchesPerUnit(layer->toleranceunits, 0) /
+                             msInchesPerUnit(map->units, 0));
+
+  rlinfo->searchshape = selectshape;
+  rlinfo->shape_tolerance = tolerance;
+
+  msComputeBounds(selectshape);
+  searchrect = selectshape->bounds;
+
+  searchrect.minx -= tolerance; /* expand the search box to account for layer
+                                   tolerances (e.g. buffered searches) */
+  searchrect.maxx += tolerance;
+  searchrect.miny -= tolerance;
+  searchrect.maxy += tolerance;
+
+  status = msRasterQueryByRect(map, layer, searchrect);
+
+  rlinfo->searchshape = NULL;
+
+  return status;
+}
+
+/************************************************************************/
+/*                        msRasterQueryByPoint()                        */
+/************************************************************************/
+
+int msRasterQueryByPoint(mapObj *map, layerObj *layer, int mode, pointObj p,
+                         double buffer, int maxresults) {
+  int result;
+  double layer_tolerance;
+  rectObj bufferRect;
+  rasterLayerInfo *rlinfo = NULL;
+
+  msRasterLayerInfoInitialize(layer);
+
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  /* -------------------------------------------------------------------- */
+  /*      If the buffer is not set, then use layer tolerances             */
+  /*      instead.   The "buffer" distince is now in georeferenced        */
+  /*      units.  Note that tolerances in pixels are basically map        */
+  /*      display pixels, not underlying raster pixels.  It isn't         */
+  /*      clear that there is any way of requesting a buffer size in      */
+  /*      underlying pixels.                                              */
+  /* -------------------------------------------------------------------- */
+  if (buffer <= 0) { /* use layer tolerance */
+    if (layer->tolerance == -1)
+      layer_tolerance = 3;
+    else
+      layer_tolerance = layer->tolerance;
+
+    if (layer->toleranceunits == MS_PIXELS)
+      buffer = layer_tolerance *
+               msAdjustExtent(&(map->extent), map->width, map->height);
+    else
+      buffer = layer_tolerance * (msInchesPerUnit(layer->toleranceunits, 0) /
+                                  msInchesPerUnit(map->units, 0));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup target point information, at this point they are in       */
+  /*      map coordinates.                                                */
+  /* -------------------------------------------------------------------- */
+  rlinfo->range_dist = buffer * buffer;
+  rlinfo->target_point = p;
+
+  /* -------------------------------------------------------------------- */
+  /*      if we are in the MS_QUERY_SINGLE mode, first try a query with   */
+  /*      zero tolerance.  If this gets a raster pixel then we can be     */
+  /*      reasonably assured that it is the closest to the query          */
+  /*      point.  This will potentially be must more efficient than       */
+  /*      processing all pixels within the tolerance.                     */
+  /* -------------------------------------------------------------------- */
+  if (mode == MS_QUERY_SINGLE) {
+    rectObj pointRect;
+
+    pointRect.minx = p.x;
+    pointRect.maxx = p.x;
+    pointRect.miny = p.y;
+    pointRect.maxy = p.y;
+
+    rlinfo->range_mode = MS_QUERY_SINGLE;
+    result = msRasterQueryByRect(map, layer, pointRect);
+    if (rlinfo->query_results > 0)
+      return result;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup a rectangle that is everything within the designated      */
+  /*      range and do a search against that.                             */
+  /* -------------------------------------------------------------------- */
+  bufferRect.minx = p.x - buffer;
+  bufferRect.maxx = p.x + buffer;
+  bufferRect.miny = p.y - buffer;
+  bufferRect.maxy = p.y + buffer;
+
+  rlinfo->range_mode = mode;
+
+  if (maxresults != 0) {
+    const int previous_maxresults = rlinfo->query_result_hard_max;
+    rlinfo->query_result_hard_max = maxresults;
+    result = msRasterQueryByRect(map, layer, bufferRect);
+    rlinfo->query_result_hard_max = previous_maxresults;
+  } else {
+    result = msRasterQueryByRect(map, layer, bufferRect);
+  }
+
+  return result;
+}
+
+/************************************************************************/
+/* ==================================================================== */
+/*                          RASTER Query Layer                          */
+/*                                                                      */
+/*      The results of a raster query are treated as a set of shapes    */
+/*      that can be accessed using the normal layer semantics.          */
+/* ==================================================================== */
+/************************************************************************/
+
+/************************************************************************/
+/*                         msRASTERLayerOpen()                          */
+/************************************************************************/
+
+int msRASTERLayerOpen(layerObj *layer) {
+  rasterLayerInfo *rlinfo;
+
+  /* If we don't have info, initialize an empty one now */
+  if (layer->layerinfo == NULL)
+    msRasterLayerInfoInitialize(layer);
+  if (layer->layerinfo == NULL)
+    return MS_FAILURE;
+
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  rlinfo->refcount = rlinfo->refcount + 1;
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                         msRASTERIsLayerOpen()                        */
+/************************************************************************/
+
+int msRASTERLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return MS_TRUE;
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                     msRASTERLayerFreeItemInfo()                      */
+/************************************************************************/
+void msRASTERLayerFreeItemInfo(layerObj *layer) { (void)layer; }
+
+/************************************************************************/
+/*                     msRASTERLayerInitItemInfo()                      */
+/*                                                                      */
+/*      Perhaps we should be validating the requested items here?       */
+/************************************************************************/
+
+int msRASTERLayerInitItemInfo(layerObj *layer) {
+  (void)layer;
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                      msRASTERLayerWhichShapes()                      */
+/************************************************************************/
+int msRASTERLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
+
+{
+  (void)isQuery;
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  rlinfo->which_rect = rect;
+  rlinfo->next_shape = 0;
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                         msRASTERLayerClose()                         */
+/************************************************************************/
+
+int msRASTERLayerClose(layerObj *layer) {
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  if (rlinfo != NULL) {
+    rlinfo->refcount--;
+
+    if (rlinfo->refcount < 0)
+      msRasterLayerInfoFree(layer);
+  }
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msRASTERLayerNextShape()                       */
+/************************************************************************/
+
+int msRASTERLayerNextShape(layerObj *layer, shapeObj *shape) {
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  if (rlinfo->next_shape < 0 || rlinfo->next_shape >= rlinfo->query_results) {
+    msFreeShape(shape);
+    shape->type = MS_SHAPE_NULL;
+    return MS_DONE;
+  } else {
+    resultObj record;
+
+    record.shapeindex = rlinfo->next_shape++;
+    record.tileindex = 0;
+    record.classindex = record.resultindex = -1;
+
+    return msRASTERLayerGetShape(layer, shape, &record);
+  }
+}
+
+/************************************************************************/
+/*                       msRASTERLayerGetShape()                        */
+/************************************************************************/
+
+int msRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+  int i;
+
+  long shapeindex = record->shapeindex;
+
+  msFreeShape(shape);
+  shape->type = MS_SHAPE_NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Validate requested record id.                                   */
+  /* -------------------------------------------------------------------- */
+  if (shapeindex < 0 || shapeindex >= rlinfo->query_results) {
+    msSetError(MS_MISCERR,
+               "Out of range shape index requested.  Requested %ld\n"
+               "but only %d shapes available.",
+               "msRASTERLayerGetShape()", shapeindex, rlinfo->query_results);
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Apply the geometry.                                             */
+  /* -------------------------------------------------------------------- */
+  if (rlinfo->qc_x != NULL) {
+    lineObj line;
+    pointObj point;
+
+    shape->type = MS_SHAPE_POINT;
+
+    line.numpoints = 1;
+    line.point = &point;
+
+    point.x = rlinfo->qc_x[shapeindex];
+    point.y = rlinfo->qc_y[shapeindex];
+    point.m = 0.0;
+
+    msAddLine(shape, &line);
+    msComputeBounds(shape);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Apply the requested items.                                      */
+  /* -------------------------------------------------------------------- */
+  if (layer->numitems > 0) {
+    shape->values = (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
+    shape->numvalues = layer->numitems;
+
+    for (i = 0; i < layer->numitems; i++) {
+      const size_t bufferSize = 1000;
+      char szWork[1000];
+
+      szWork[0] = '\0';
+      if (EQUAL(layer->items[i], "x") && rlinfo->qc_x_reproj)
+        snprintf(szWork, bufferSize, "%.8g", rlinfo->qc_x_reproj[shapeindex]);
+      else if (EQUAL(layer->items[i], "y") && rlinfo->qc_y_reproj)
+        snprintf(szWork, bufferSize, "%.8g", rlinfo->qc_y_reproj[shapeindex]);
+
+      else if (EQUAL(layer->items[i], "value_list") && rlinfo->qc_values) {
+        int iValue;
+
+        for (iValue = 0; iValue < rlinfo->band_count; iValue++) {
+          if (iValue != 0)
+            strlcat(szWork, ",", bufferSize);
+
+          snprintf(szWork + strlen(szWork), bufferSize - strlen(szWork), "%.8g",
+                   rlinfo->qc_values[shapeindex * rlinfo->band_count + iValue]);
+        }
+      } else if (EQUALN(layer->items[i], "value_", 6) && rlinfo->qc_values) {
+        int iValue = atoi(layer->items[i] + 6);
+        snprintf(szWork, bufferSize, "%.8g",
+                 rlinfo->qc_values[shapeindex * rlinfo->band_count + iValue]);
+      } else if (EQUAL(layer->items[i], "class") && rlinfo->qc_class) {
+        int p_class = rlinfo->qc_class[shapeindex];
+        if (layer->class[p_class] -> name != NULL)
+          snprintf(szWork, bufferSize, "%.999s", layer->class[p_class] -> name);
+        else
+          snprintf(szWork, bufferSize, "%d", p_class);
+      } else if (EQUAL(layer->items[i], "red") && rlinfo->qc_red)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_red[shapeindex]);
+      else if (EQUAL(layer->items[i], "green") && rlinfo->qc_green)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_green[shapeindex]);
+      else if (EQUAL(layer->items[i], "blue") && rlinfo->qc_blue)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_blue[shapeindex]);
+      else if (EQUAL(layer->items[i], "count") && rlinfo->qc_count)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_count[shapeindex]);
+
+      shape->values[i] = msStrdup(szWork);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Eventually we should likey apply the geometry properly but      */
+  /*      we don't really care about the geometry for query purposes.     */
+  /* -------------------------------------------------------------------- */
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msRASTERLayerGetItems()                        */
+/************************************************************************/
+
+int msRASTERLayerGetItems(layerObj *layer) {
+  int maxnumitems = 0;
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
+
+  if (rlinfo == NULL)
+    return MS_FAILURE;
+
+  maxnumitems = 8 + (rlinfo->qc_values ? rlinfo->band_count : 0);
+  layer->items = (char **)msSmallCalloc(sizeof(char *), maxnumitems);
+
+  layer->numitems = 0;
+  if (rlinfo->qc_x_reproj)
+    layer->items[layer->numitems++] = msStrdup("x");
+  if (rlinfo->qc_y_reproj)
+    layer->items[layer->numitems++] = msStrdup("y");
+  if (rlinfo->qc_values) {
+    int i;
+    for (i = 0; i < rlinfo->band_count; i++) {
+      char szName[100];
+      snprintf(szName, sizeof(szName), "value_%d", i);
+      layer->items[layer->numitems++] = msStrdup(szName);
+    }
+    layer->items[layer->numitems++] = msStrdup("value_list");
+  }
+  if (rlinfo->qc_class)
+    layer->items[layer->numitems++] = msStrdup("class");
+  if (rlinfo->qc_red)
+    layer->items[layer->numitems++] = msStrdup("red");
+  if (rlinfo->qc_green)
+    layer->items[layer->numitems++] = msStrdup("green");
+  if (rlinfo->qc_blue)
+    layer->items[layer->numitems++] = msStrdup("blue");
+  if (rlinfo->qc_count)
+    layer->items[layer->numitems++] = msStrdup("count");
+
+  assert(layer->numitems <= maxnumitems);
+
+  return msRASTERLayerInitItemInfo(layer);
+}
+
+/************************************************************************/
+/*                       msRASTERLayerGetExtent()                       */
+/************************************************************************/
+
+int msRASTERLayerGetExtent(layerObj *layer, rectObj *extent)
+
+{
+  char szPath[MS_MAXPATHLEN];
+  mapObj *map = layer->map;
+  shapefileObj *tileshpfile;
+
+  if ((!layer->data || strlen(layer->data) == 0) && layer->tileindex == NULL) {
+    /* should we be issuing a specific error about not supporting
+       extents for tileindexed raster layers? */
+    return MS_FAILURE;
+  }
+
+  if (map == NULL)
+    return MS_FAILURE;
+
+  /* If the layer use a tileindex, return the extent of the tileindex
+   * shapefile/referenced layer */
+  if (layer->tileindex) {
+    const int tilelayerindex = msGetLayerIndex(map, layer->tileindex);
+    if (tilelayerindex != -1) /* does the tileindex reference another layer */
+      return msLayerGetExtent(GET_LAYER(map, tilelayerindex), extent);
+    else {
+      tileshpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
+      MS_CHECK_ALLOC(tileshpfile, sizeof(shapefileObj), MS_FAILURE);
+
+      if (msShapefileOpen(tileshpfile, "rb",
+                          msBuildPath3(szPath, map->mappath, map->shapepath,
+                                       layer->tileindex),
+                          MS_TRUE) == -1)
+        if (msShapefileOpen(tileshpfile, "rb",
+                            msBuildPath(szPath, map->mappath, layer->tileindex),
+                            MS_TRUE) == -1)
+          return MS_FAILURE;
+
+      *extent = tileshpfile->bounds;
+      msShapefileClose(tileshpfile);
+      free(tileshpfile);
+      return MS_SUCCESS;
+    }
+  }
+
+  msTryBuildPath3(szPath, map->mappath, map->shapepath, layer->data);
+  char *decrypted_path = msDecryptStringTokens(map, szPath);
+  if (!decrypted_path)
+    return MS_FAILURE;
+
+  char **connectionoptions =
+      msGetStringListFromHashTable(&(layer->connectionoptions));
+  GDALDatasetH hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                                (const char *const *)connectionoptions, NULL);
+  CSLDestroy(connectionoptions);
+  msFree(decrypted_path);
+  if (hDS == NULL) {
+    return MS_FAILURE;
+  }
+
+  const int nXSize = GDALGetRasterXSize(hDS);
+  const int nYSize = GDALGetRasterYSize(hDS);
+  double adfGeoTransform[6] = {0};
+  const CPLErr eErr = GDALGetGeoTransform(hDS, adfGeoTransform);
+  if (eErr != CE_None) {
+    GDALClose(hDS);
+    return MS_FAILURE;
+  }
+
+  /* If this appears to be an ungeoreferenced raster than flip it for
+     mapservers purposes. */
+  if (adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0) {
+    adfGeoTransform[5] = -1.0;
+    adfGeoTransform[3] = nYSize;
+  }
+
+  extent->minx = adfGeoTransform[0];
+  extent->maxy = adfGeoTransform[3];
+
+  extent->maxx = adfGeoTransform[0] + nXSize * adfGeoTransform[1];
+  extent->miny = adfGeoTransform[3] + nYSize * adfGeoTransform[5];
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                     msRASTERLayerSetTimeFilter()                     */
+/*                                                                      */
+/*      This function is actually just used in the context of           */
+/*      setting a filter on the tileindex for time based queries.       */
+/*      For instance via WMS requests.  So it isn't really related      */
+/*      to the "raster query" support at all.                           */
+/*                                                                      */
+/*      If a local shapefile tileindex is in use, we will set a         */
+/*      backtics filter (shapefile compatible).  If another layer is    */
+/*      being used as the tileindex then we will forward the            */
+/*      SetTimeFilter call to it.  If there is no tileindex in          */
+/*      place, we do nothing.                                           */
+/************************************************************************/
+
+int msRASTERLayerSetTimeFilter(layerObj *layer, const char *timestring,
+                               const char *timefield) {
+  int tilelayerindex;
+
+  /* -------------------------------------------------------------------- */
+  /*      If we don't have a tileindex the time filter has no effect.     */
+  /* -------------------------------------------------------------------- */
+  if (layer->tileindex == NULL)
+    return MS_SUCCESS;
+
+  /* -------------------------------------------------------------------- */
+  /*      Find the tileindex layer.                                       */
+  /* -------------------------------------------------------------------- */
+  tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
+
+  /* -------------------------------------------------------------------- */
+  /*      If we are using a local shapefile as our tileindex (that is     */
+  /*      to say, the tileindex name is not of another layer), then we    */
+  /*      just install a backtics style filter on the raster layer.       */
+  /*      This is propogated to the "working layer" created for the       */
+  /*      tileindex by code in mapraster.c.                               */
+  /* -------------------------------------------------------------------- */
+  if (tilelayerindex == -1)
+    return msLayerMakeBackticsTimeFilter(layer, timestring, timefield);
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
+  /*      method.                                                         */
+  /* -------------------------------------------------------------------- */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+  return msLayerSetTimeFilter(layer->GET_LAYER(map, tilelayerindex), timestring,
+                              timefield);
+}
+
+/************************************************************************/
+/*                msRASTERLayerInitializeVirtualTable()                 */
+/************************************************************************/
+
+int msRASTERLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerInitItemInfo = msRASTERLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msRASTERLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msRASTERLayerOpen;
+  layer->vtable->LayerIsOpen = msRASTERLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msRASTERLayerWhichShapes;
+  layer->vtable->LayerNextShape = msRASTERLayerNextShape;
+  layer->vtable->LayerGetShape = msRASTERLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msRASTERLayerClose;
+  layer->vtable->LayerGetItems = msRASTERLayerGetItems;
+  layer->vtable->LayerGetExtent = msRASTERLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /* layer->vtable->LayerCloseConnection = msRASTERLayerClose; */
+  /* we use backtics for proper tileindex shapefile functioning */
+  layer->vtable->LayerSetTimeFilter = msRASTERLayerSetTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapregex.c 8.2.0~beta1-1~exp1/src/mapregex.c
--- 8.0.1-5/src/mapregex.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapregex.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,87 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Regex wrapper
+ * Author:   Bill Binko
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/* we can't include mapserver.h, so we need our own basics */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <direct.h>
+#include <memory.h>
+#include <malloc.h>
+#else
+#include <unistd.h>
+#endif
+
+/*Need to specify this so that mapregex.h doesn't defined constants and
+  doesn't #define away our ms_*/
+
+#if defined(_WIN32) && !defined(__CYGWIN__) && _MSC_VER < 1900
+#define off_t long
+#endif
+
+#include "mapserver.h"
+#include "mapregex.h"
+#include <regex.h>
+
+MS_API_EXPORT(int) ms_regcomp(ms_regex_t *regex, const char *expr, int cflags) {
+  /* Must free in regfree() */
+  regex_t *sys_regex = (regex_t *)msSmallMalloc(sizeof(regex_t));
+  regex->sys_regex = (void *)sys_regex;
+  int ret = regcomp(sys_regex, expr, cflags);
+  if (ret != 0) {
+    free(regex->sys_regex);
+    regex->sys_regex = NULL;
+  }
+  return ret;
+}
+
+MS_API_EXPORT(size_t)
+ms_regerror(int errcode, const ms_regex_t *regex, char *errbuf,
+            size_t errbuf_size) {
+  return regerror(errcode, (regex_t *)(regex->sys_regex), errbuf, errbuf_size);
+}
+
+MS_API_EXPORT(int)
+ms_regexec(const ms_regex_t *regex, const char *string, size_t nmatch,
+           ms_regmatch_t pmatch[], int eflags) {
+  /*This next line only works because we know that regmatch_t
+    and ms_regmatch_t are exactly alike (POSIX STANDARD)*/
+  return regexec((const regex_t *)(regex->sys_regex), string, nmatch,
+                 (regmatch_t *)pmatch, eflags);
+}
+
+MS_API_EXPORT(void) ms_regfree(ms_regex_t *regex) {
+  regfree((regex_t *)(regex->sys_regex));
+  free(regex->sys_regex);
+  return;
+}
diff -pruN 8.0.1-5/src/mapregex.h 8.2.0~beta1-1~exp1/src/mapregex.h
--- 8.0.1-5/src/mapregex.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapregex.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,110 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Regex wrapper
+ * Author:   Bill Binko
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAP_REGEX_H
+#define MAP_REGEX_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/* We want these to match the POSIX standard, so we need these*/
+/* === regex2.h === */
+#ifdef _WIN32
+#define MS_API_EXPORT(type) __declspec(dllexport) type __stdcall
+#elif defined(__GNUC__) && __GNUC__ >= 4
+#define MS_API_EXPORT(type) __attribute__((visibility("default"))) type
+#else
+#define MS_API_EXPORT(type) type
+#endif
+
+typedef struct {
+  void *sys_regex;
+} ms_regex_t;
+
+typedef int ms_regoff_t;
+typedef struct {
+  ms_regoff_t rm_so; /* Byte offset from string's start to substring's start. */
+  ms_regoff_t rm_eo; /* Byte offset from string's start to substring's end.  */
+} ms_regmatch_t;
+
+MS_API_EXPORT(int) ms_regcomp(ms_regex_t *, const char *, int);
+MS_API_EXPORT(size_t) ms_regerror(int, const ms_regex_t *, char *, size_t);
+MS_API_EXPORT(int)
+ms_regexec(const ms_regex_t *, const char *, size_t, ms_regmatch_t[], int);
+MS_API_EXPORT(void) ms_regfree(ms_regex_t *);
+
+#ifndef BUILDING_REGEX_PROXY
+
+/* === regcomp.c === */
+#define MS_REG_BASIC 0000
+#define MS_REG_EXTENDED 0001
+#define MS_REG_ICASE 0002
+#define MS_REG_NOSUB 0004
+#define MS_REG_NEWLINE 0010
+#define MS_REG_NOSPEC 0020
+#define MS_REG_PEND 0040
+#define MS_REG_DUMP 0200
+
+/* === regerror.c === */
+#define MS_REG_OKAY 0
+#define MS_REG_NOMATCH 1
+#define MS_REG_BADPAT 2
+#define MS_REG_ECOLLATE 3
+#define MS_REG_ECTYPE 4
+#define MS_REG_EESCAPE 5
+#define MS_REG_ESUBREG 6
+#define MS_REG_EBRACK 7
+#define MS_REG_EPAREN 8
+#define MS_REG_EBRACE 9
+#define MS_REG_BADBR 10
+#define MS_REG_ERANGE 11
+#define MS_REG_ESPACE 12
+#define MS_REG_BADRPT 13
+#define MS_REG_EMPTY 14
+#define MS_REG_ASSERT 15
+#define MS_REG_INVARG 16
+#define MS_REG_ATOI 255  /* convert name to number (!) */
+#define MS_REG_ITOA 0400 /* convert number to name (!) */
+
+/* === regexec.c === */
+#define MS_REG_NOTBOL 00001
+#define MS_REG_NOTEOL 00002
+#define MS_REG_STARTEND 00004
+#define MS_REG_TRACE 00400 /* tracing of execution */
+#define MS_REG_LARGE 01000 /* force large representation */
+#define MS_REG_BACKR 02000 /* force use of backref code */
+
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/maprendering.c 8.2.0~beta1-1~exp1/src/maprendering.c
--- 8.0.1-5/src/maprendering.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maprendering.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1253 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Rendering utility functions
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2011 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <assert.h>
+
+#include "mapserver.h"
+#include "mapcopy.h"
+#include "fontcache.h"
+
+void computeSymbolStyle(symbolStyleObj *s, styleObj *src, symbolObj *symbol,
+                        double scalefactor, double resolutionfactor) {
+  double default_size;
+  double target_size;
+  double style_size;
+
+  default_size = msSymbolGetDefaultSize(symbol);
+  style_size = (src->size == -1) ? default_size : src->size;
+
+  INIT_SYMBOL_STYLE(*s);
+  if (symbol->type == MS_SYMBOL_PIXMAP) {
+    s->color = s->outlinecolor = NULL;
+  } else if (symbol->filled || symbol->type == MS_SYMBOL_TRUETYPE) {
+    if (MS_VALID_COLOR(src->color))
+      s->color = &src->color;
+    if (MS_VALID_COLOR(src->outlinecolor))
+      s->outlinecolor = &src->outlinecolor;
+  } else {
+    if (MS_VALID_COLOR(src->color))
+      s->outlinecolor = &(src->color);
+    else if (MS_VALID_COLOR(src->outlinecolor))
+      s->outlinecolor = &(src->outlinecolor);
+    s->color = NULL;
+  }
+
+  target_size = style_size * scalefactor;
+  target_size = MS_MAX(target_size, src->minsize * resolutionfactor);
+  target_size = MS_MIN(target_size, src->maxsize * resolutionfactor);
+  s->scale = target_size / default_size;
+  s->gap = src->gap * target_size / style_size;
+
+  if (s->outlinecolor) {
+    s->outlinewidth = src->width * scalefactor;
+    s->outlinewidth = MS_MAX(s->outlinewidth, src->minwidth * resolutionfactor);
+    s->outlinewidth = MS_MIN(s->outlinewidth, src->maxwidth * resolutionfactor);
+  } else {
+    s->outlinewidth = 0;
+  }
+
+  s->rotation = src->angle * MS_DEG_TO_RAD;
+}
+
+#define COMPARE_COLORS(a, b)                                                   \
+  (((a).red == (b).red) && ((a).green == (b).green) &&                         \
+   ((a).blue == (b).blue) && ((a).alpha == (b).alpha))
+
+tileCacheObj *searchTileCache(imageObj *img, symbolObj *symbol,
+                              symbolStyleObj *s, int width, int height) {
+  tileCacheObj *cur = img->tilecache;
+  while (cur != NULL) {
+    if (cur->width == width && cur->height == height && cur->symbol == symbol &&
+        cur->outlinewidth == s->outlinewidth && cur->rotation == s->rotation &&
+        cur->scale == s->scale &&
+        (!s->color || COMPARE_COLORS(cur->color, *s->color)) &&
+        (!s->backgroundcolor ||
+         COMPARE_COLORS(cur->backgroundcolor, *s->backgroundcolor)) &&
+        (!s->outlinecolor ||
+         COMPARE_COLORS(cur->outlinecolor, *s->outlinecolor)))
+      return cur;
+    cur = cur->next;
+  }
+  return NULL;
+}
+
+int preloadSymbol(symbolSetObj *symbolset, symbolObj *symbol,
+                  rendererVTableObj *renderer) {
+  (void)symbolset;
+  switch (symbol->type) {
+  case MS_SYMBOL_VECTOR:
+  case MS_SYMBOL_ELLIPSE:
+  case MS_SYMBOL_SIMPLE:
+  case (MS_SYMBOL_TRUETYPE):
+    break;
+  case (MS_SYMBOL_SVG):
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+    return msPreloadSVGSymbol(symbol);
+#else
+    msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+               "preloadSymbol()");
+    return MS_FAILURE;
+#endif
+    break;
+  case (MS_SYMBOL_PIXMAP): {
+    if (!symbol->pixmap_buffer) {
+      if (MS_SUCCESS != msPreloadImageSymbol(renderer, symbol))
+        return MS_FAILURE;
+    }
+  } break;
+  default:
+    msSetError(MS_MISCERR, "unsupported symbol type %d", "preloadSymbol()",
+               symbol->type);
+    return MS_FAILURE;
+  }
+  return MS_SUCCESS;
+}
+
+/* add a cached tile to the current image's cache */
+tileCacheObj *addTileCache(imageObj *img, imageObj *tile, symbolObj *symbol,
+                           symbolStyleObj *style, int width, int height) {
+  tileCacheObj *cachep;
+
+  if (img->ntiles >=
+      MS_IMAGECACHESIZE) { /* remove last element, size stays the same */
+    cachep = img->tilecache;
+
+    /*go to the before last cache object*/
+    while (cachep->next && cachep->next->next)
+      cachep = cachep->next;
+    assert(cachep->next);
+
+    /*free the last tile's data*/
+    msFreeImage(cachep->next->image);
+
+    /*reuse the last tile object*/
+    /* make the cache point to the start of the list*/
+    cachep->next->next = img->tilecache;
+    /* point the global cache to the new first */
+    img->tilecache = cachep->next;
+    /* the before last cache is now last, so it has no successor*/
+    cachep->next = NULL;
+
+  } else {
+    img->ntiles += 1;
+    cachep = (tileCacheObj *)malloc(sizeof(tileCacheObj));
+    MS_CHECK_ALLOC(cachep, sizeof(tileCacheObj), NULL);
+    cachep->next = img->tilecache;
+    img->tilecache = cachep;
+  }
+
+  cachep = img->tilecache;
+
+  cachep->image = tile;
+  cachep->outlinewidth = style->outlinewidth;
+  cachep->scale = style->scale;
+  cachep->rotation = style->rotation;
+  if (style->color)
+    MS_COPYCOLOR(&cachep->color, style->color);
+  if (style->outlinecolor)
+    MS_COPYCOLOR(&cachep->outlinecolor, style->outlinecolor);
+  cachep->width = width;
+  cachep->height = height;
+  cachep->symbol = symbol;
+  return (cachep);
+}
+
+/* helper function to center glyph on the desired point */
+static int drawGlyphMarker(imageObj *img, face_element *face,
+                           glyph_element *glyphc, double px, double py,
+                           int size, double rotation, colorObj *clr,
+                           colorObj *oclr, int olwidth) {
+  double ox, oy;
+  textPathObj path;
+  glyphObj glyph;
+  rendererVTableObj *renderer = img->format->vtable;
+  if (!renderer->renderGlyphs)
+    return MS_FAILURE;
+  path.numglyphs = 1;
+  glyph.glyph = glyphc;
+  glyph.face = face;
+  path.glyphs = &glyph;
+  path.glyph_size = size;
+  glyph.rot = rotation;
+  ox = (glyphc->metrics.maxx + glyphc->metrics.minx) / 2.0;
+  oy = (glyphc->metrics.maxy + glyphc->metrics.miny) / 2.0;
+  if (rotation != 0) {
+    double sina, cosa;
+    double rox, roy;
+    sina = sin(rotation);
+    cosa = cos(rotation);
+    rox = ox * cosa - oy * sina;
+    roy = ox * sina + oy * cosa;
+    px -= rox;
+    py += roy;
+    glyph.pnt.x = px;
+    glyph.pnt.y = py;
+  } else {
+    glyph.pnt.x = px - ox;
+    glyph.pnt.y = py + oy;
+  }
+  textSymbolObj ts;
+  memset(&ts, 0, sizeof(ts));
+  ts.textpath = &path;
+  return renderer->renderGlyphs(img, &ts, clr, oclr, olwidth, MS_TRUE);
+}
+
+imageObj *getTile(imageObj *img, symbolObj *symbol, symbolStyleObj *s,
+                  int width, int height, int seamlessmode) {
+  tileCacheObj *tile;
+  int status = MS_SUCCESS;
+  rendererVTableObj *renderer = img->format->vtable;
+  if (width == -1 || height == -1) {
+    width = height = MS_MAX(symbol->sizex, symbol->sizey);
+  }
+  tile = searchTileCache(img, symbol, s, width, height);
+
+  if (tile == NULL) {
+    imageObj *tileimg;
+    double p_x, p_y;
+    tileimg = msImageCreate(width, height, img->format, NULL, NULL,
+                            img->resolution, img->resolution, NULL);
+    if (MS_UNLIKELY(!tileimg)) {
+      return NULL;
+    }
+    if (!seamlessmode) {
+      p_x = width / 2.0;
+      p_y = height / 2.0;
+      switch (symbol->type) {
+      case (MS_SYMBOL_TRUETYPE): {
+        unsigned int unicode;
+        glyph_element *glyphc;
+        face_element *face = msGetFontFace(symbol->font, &img->map->fontset);
+        if (MS_UNLIKELY(!face)) {
+          status = MS_FAILURE;
+          break;
+        }
+        msUTF8ToUniChar(symbol->character, &unicode);
+        unicode = msGetGlyphIndex(face, unicode);
+        glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale), 1), unicode);
+        if (MS_UNLIKELY(!glyphc)) {
+          status = MS_FAILURE;
+          break;
+        }
+        status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale,
+                                 s->rotation, s->color, s->outlinecolor,
+                                 s->outlinewidth);
+      } break;
+      case (MS_SYMBOL_PIXMAP):
+        status = msPreloadImageSymbol(renderer, symbol);
+        if (MS_UNLIKELY(status == MS_FAILURE)) {
+          break;
+        }
+        status = renderer->renderPixmapSymbol(tileimg, p_x, p_y, symbol, s);
+        break;
+      case (MS_SYMBOL_ELLIPSE):
+        status = renderer->renderEllipseSymbol(tileimg, p_x, p_y, symbol, s);
+        break;
+      case (MS_SYMBOL_VECTOR):
+        status = renderer->renderVectorSymbol(tileimg, p_x, p_y, symbol, s);
+        break;
+
+      case (MS_SYMBOL_SVG):
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+        status = msPreloadSVGSymbol(symbol);
+        if (MS_LIKELY(status == MS_SUCCESS)) {
+          if (renderer->supports_svg) {
+            status = renderer->renderSVGSymbol(tileimg, p_x, p_y, symbol, s);
+          } else {
+            status = msRenderRasterizedSVGSymbol(tileimg, p_x, p_y, symbol, s);
+          }
+        }
+#else
+        msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                   "getTile()");
+        status = MS_FAILURE;
+#endif
+        break;
+      default:
+        msSetError(MS_SYMERR, "Unknown symbol type %d", "getTile()",
+                   symbol->type);
+        status = MS_FAILURE;
+        break;
+      }
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        msFreeImage(tileimg);
+        return NULL;
+      }
+    } else {
+      /*
+       * in seamless mode, we render the the symbol 9 times on a 3x3 grid to
+       * account for antialiasing blending from one tile to the next. We finally
+       * keep the center tile
+       */
+      imageObj *tile3img =
+          msImageCreate(width * 3, height * 3, img->format, NULL, NULL,
+                        img->resolution, img->resolution, NULL);
+      int i, j;
+      rasterBufferObj tmpraster;
+      for (i = 1; i <= 3; i++) {
+        p_x = (i + 0.5) * width;
+        for (j = 1; j <= 3; j++) {
+          p_y = (j + 0.5) * height;
+          switch (symbol->type) {
+          case (MS_SYMBOL_TRUETYPE): {
+            unsigned int unicode;
+            glyph_element *glyphc;
+            face_element *face =
+                msGetFontFace(symbol->font, &img->map->fontset);
+            if (MS_UNLIKELY(!face)) {
+              status = MS_FAILURE;
+              break;
+            }
+            msUTF8ToUniChar(symbol->character, &unicode);
+            unicode = msGetGlyphIndex(face, unicode);
+            glyphc =
+                msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale), 1), unicode);
+            if (MS_UNLIKELY(!glyphc)) {
+              status = MS_FAILURE;
+              break;
+            }
+            status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale,
+                                     s->rotation, s->color, s->outlinecolor,
+                                     s->outlinewidth);
+          } break;
+          case (MS_SYMBOL_PIXMAP):
+            status = msPreloadImageSymbol(renderer, symbol);
+            if (MS_UNLIKELY(status == MS_FAILURE)) {
+              break;
+            }
+            status =
+                renderer->renderPixmapSymbol(tile3img, p_x, p_y, symbol, s);
+            break;
+          case (MS_SYMBOL_ELLIPSE):
+            status =
+                renderer->renderEllipseSymbol(tile3img, p_x, p_y, symbol, s);
+            break;
+          case (MS_SYMBOL_VECTOR):
+            status =
+                renderer->renderVectorSymbol(tile3img, p_x, p_y, symbol, s);
+            break;
+          default:
+            msSetError(MS_SYMERR,
+                       "BUG: Seamless mode is only for vector symbols",
+                       "getTile()");
+            return NULL;
+          }
+          if (MS_UNLIKELY(status == MS_FAILURE)) {
+            msFreeImage(tile3img);
+            return NULL;
+          }
+        }
+      }
+
+      status = MS_IMAGE_RENDERER(tile3img)->getRasterBufferHandle(tile3img,
+                                                                  &tmpraster);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        msFreeImage(tile3img);
+        return NULL;
+      }
+      status = renderer->mergeRasterBuffer(tileimg, &tmpraster, 1.0, width,
+                                           height, 0, 0, width, height);
+      msFreeImage(tile3img);
+    }
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      msFreeImage(tileimg);
+      return NULL;
+    }
+    tile = addTileCache(img, tileimg, symbol, s, width, height);
+  }
+  return tile->image;
+}
+
+int msImagePolylineMarkers(imageObj *image, shapeObj *p, symbolObj *symbol,
+                           symbolStyleObj *style, double spacing,
+                           double initialgap, int auto_angle) {
+  rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
+  int i, j;
+  pointObj point;
+  double original_rotation = style->rotation;
+  double symbol_width, symbol_height;
+  glyph_element *glyphc = NULL;
+  face_element *face = NULL;
+  int ret = MS_SUCCESS;
+  if (symbol->type != MS_SYMBOL_TRUETYPE) {
+    symbol_width = MS_MAX(1, symbol->sizex * style->scale);
+    symbol_height = MS_MAX(1, symbol->sizey * style->scale);
+  } else {
+    unsigned int unicode;
+    msUTF8ToUniChar(symbol->character, &unicode);
+    face = msGetFontFace(symbol->font, &image->map->fontset);
+    if (MS_UNLIKELY(!face))
+      return MS_FAILURE;
+    unicode = msGetGlyphIndex(face, unicode);
+    glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(style->scale), 1), unicode);
+    if (MS_UNLIKELY(!glyphc))
+      return MS_FAILURE;
+    symbol_width = glyphc->metrics.maxx - glyphc->metrics.minx;
+    symbol_height = glyphc->metrics.maxy - glyphc->metrics.miny;
+  }
+  for (i = 0; i < p->numlines; i++) {
+    int line_in = 0;
+    double line_length = 0;
+    double current_length;
+    if (initialgap < 0) {
+      current_length = spacing / 2.0; /* initial padding for each line */
+    } else {
+      current_length = initialgap; /* initial padding for each line */
+    }
+    for (j = 1; j < p->line[i].numpoints; j++) {
+      double rx, ry, theta, length;
+      length =
+          sqrt((pow((p->line[i].point[j].x - p->line[i].point[j - 1].x), 2) +
+                pow((p->line[i].point[j].y - p->line[i].point[j - 1].y), 2)));
+      line_length += length;
+      if (length == 0)
+        continue;
+      rx = (p->line[i].point[j].x - p->line[i].point[j - 1].x) / length;
+      ry = (p->line[i].point[j].y - p->line[i].point[j - 1].y) / length;
+
+      if (auto_angle) {
+        theta = asin(ry);
+        if (rx < 0) {
+          theta += MS_PI;
+        } else
+          theta = -theta;
+        style->rotation = original_rotation + theta;
+      }
+      while (current_length <= length) {
+
+        point.x = p->line[i].point[j - 1].x + current_length * rx;
+        point.y = p->line[i].point[j - 1].y + current_length * ry;
+        if (symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
+          double ox, oy;
+          ox = (0.5 - symbol->anchorpoint_x) * symbol_width;
+          oy = (0.5 - symbol->anchorpoint_y) * symbol_height;
+          if (style->rotation != 0) {
+            double sina, cosa;
+            double rox, roy;
+            sina = sin(-style->rotation);
+            cosa = cos(-style->rotation);
+            rox = ox * cosa - oy * sina;
+            roy = ox * sina + oy * cosa;
+            point.x += rox;
+            point.y += roy;
+          } else {
+            point.x += ox;
+            point.y += oy;
+          }
+        }
+
+        /* if the point is not in the map extent, skip it. (POLYLINE_NO_CLIP) */
+        if ((point.x < -(symbol_width) ||
+             point.x > (image->width + symbol_width)) ||
+            (point.y < -(symbol_height) ||
+             point.y > (image->height + symbol_height))) {
+          current_length += spacing;
+          line_in = 1;
+          continue;
+        }
+
+        switch (symbol->type) {
+        case MS_SYMBOL_PIXMAP:
+          ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol,
+                                             style);
+          break;
+        case MS_SYMBOL_ELLIPSE:
+          ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol,
+                                              style);
+          break;
+        case MS_SYMBOL_VECTOR:
+          ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol,
+                                             style);
+          break;
+        case MS_SYMBOL_TRUETYPE:
+          ret = drawGlyphMarker(image, face, glyphc, point.x, point.y,
+                                style->scale, style->rotation, style->color,
+                                style->outlinecolor, style->outlinewidth);
+          break;
+        case (MS_SYMBOL_SVG):
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+          if (renderer->supports_svg) {
+            ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol,
+                                            style);
+          } else {
+            ret = msRenderRasterizedSVGSymbol(image, point.x, point.y, symbol,
+                                              style);
+          }
+#else
+          msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                     "msImagePolylineMarkers()()");
+          ret = MS_FAILURE;
+#endif
+          break;
+        }
+        if (ret != MS_SUCCESS)
+          return ret;
+        current_length += spacing;
+        line_in = 1;
+      }
+
+      current_length -= length;
+    }
+
+    /*
+     * if we couldn't place a symbol on the line and no initialgap was
+     * specified,  add one now we don't add the symbol if the line is shorter
+     * than the length of the symbol itself
+     */
+    if (initialgap < 0 && !line_in && line_length > symbol_width) {
+
+      /* total lengths of beginnning and end of current segment */
+      double before_length = 0, after_length = 0;
+
+      /*optimize*/
+      line_length /= 2.0;
+
+      for (j = 1; j < p->line[i].numpoints; j++) {
+        double length;
+        length =
+            sqrt((pow((p->line[i].point[j].x - p->line[i].point[j - 1].x), 2) +
+                  pow((p->line[i].point[j].y - p->line[i].point[j - 1].y), 2)));
+        after_length += length;
+        if (after_length > line_length) {
+          double rx, ry, theta;
+          /* offset where the symbol should be drawn on the current
+           * segment */
+          double offset = line_length - before_length;
+
+          rx = (p->line[i].point[j].x - p->line[i].point[j - 1].x) / length;
+          ry = (p->line[i].point[j].y - p->line[i].point[j - 1].y) / length;
+          if (auto_angle) {
+            theta = asin(ry);
+            if (rx < 0) {
+              theta += MS_PI;
+            } else
+              theta = -theta;
+            style->rotation = original_rotation + theta;
+          }
+
+          point.x = p->line[i].point[j - 1].x + offset * rx;
+          point.y = p->line[i].point[j - 1].y + offset * ry;
+          switch (symbol->type) {
+          case MS_SYMBOL_PIXMAP:
+            ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol,
+                                               style);
+            break;
+          case MS_SYMBOL_ELLIPSE:
+            ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol,
+                                                style);
+            break;
+          case MS_SYMBOL_VECTOR:
+            ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol,
+                                               style);
+            break;
+          case MS_SYMBOL_TRUETYPE:
+            ret = drawGlyphMarker(image, face, glyphc, point.x, point.y,
+                                  style->scale, style->rotation, style->color,
+                                  style->outlinecolor, style->outlinewidth);
+            break;
+          case (MS_SYMBOL_SVG):
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+            if (renderer->supports_svg) {
+              ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol,
+                                              style);
+            } else {
+              ret = msRenderRasterizedSVGSymbol(image, point.x, point.y, symbol,
+                                                style);
+            }
+#else
+            msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                       "msImagePolylineMarkers()()");
+            ret = MS_FAILURE;
+#endif
+            break;
+          }
+          break; /* we have rendered the single marker for this line */
+        }
+        before_length += length;
+      }
+    }
+  }
+  return ret;
+}
+
+int msDrawLineSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style,
+                     double scalefactor) {
+  int status = MS_SUCCESS;
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      rendererVTableObj *renderer = image->format->vtable;
+      symbolObj *symbol;
+      shapeObj *offsetLine = p;
+      int i;
+      double width;
+      double finalscalefactor;
+
+      if (p->numlines == 0)
+        return MS_SUCCESS;
+
+      if (style->symbol >= map->symbolset.numsymbols || style->symbol < 0)
+        return MS_SUCCESS; /* no such symbol, 0 is OK   */
+
+      symbol = map->symbolset.symbol[style->symbol];
+      /* store a reference to the renderer to be used for freeing */
+      symbol->renderer = renderer;
+
+      width = style->width * scalefactor;
+      width = MS_MIN(width, style->maxwidth * image->resolutionfactor);
+      width = MS_MAX(width, style->minwidth * image->resolutionfactor);
+      if (style->width != 0) {
+        finalscalefactor = width / style->width;
+      } else {
+        finalscalefactor = 1.0;
+      }
+
+      if (style->offsety == MS_STYLE_SINGLE_SIDED_OFFSET) {
+        offsetLine = msOffsetPolyline(p, style->offsetx * finalscalefactor,
+                                      MS_STYLE_SINGLE_SIDED_OFFSET);
+      } else if (style->offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
+        offsetLine = msOffsetPolyline(p, style->offsetx * finalscalefactor,
+                                      MS_STYLE_DOUBLE_SIDED_OFFSET);
+      } else if (style->offsetx != 0 || style->offsety != 0) {
+        offsetLine = msOffsetPolyline(p, style->offsetx * finalscalefactor,
+                                      style->offsety * finalscalefactor);
+      }
+      if (style->symbol == 0 || (symbol->type == MS_SYMBOL_SIMPLE)) {
+        strokeStyleObj s;
+        s.linecap = style->linecap;
+        s.linejoin = style->linejoin;
+        s.linejoinmaxsize = style->linejoinmaxsize;
+        s.antialiased = style->antialiased;
+        s.width = width;
+        s.patternlength = style->patternlength;
+        for (i = 0; i < s.patternlength; i++)
+          s.pattern[i] = style->pattern[i] * finalscalefactor;
+        s.patternoffset = (style->initialgap <= 0)
+                              ? 0
+                              : (style->initialgap * finalscalefactor);
+
+        if (MS_VALID_COLOR(style->color))
+          s.color = &style->color;
+        else if (MS_VALID_COLOR(style->outlinecolor))
+          s.color = &style->outlinecolor;
+        else {
+          /* msSetError(MS_MISCERR,"no color defined for line
+           * styling","msDrawLineSymbol()"); not really an error */
+          status = MS_SUCCESS;
+          goto line_cleanup;
+        }
+        status = renderer->renderLine(image, offsetLine, &s);
+      } else {
+        symbolStyleObj s;
+        if (preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
+          status = MS_FAILURE;
+          goto line_cleanup;
+        }
+
+        INIT_SYMBOL_STYLE(s);
+        computeSymbolStyle(&s, style, symbol, scalefactor,
+                           image->resolutionfactor);
+        s.style = style;
+
+        /* compute a markerStyle and use it on the line */
+        if (style->gap < 0) {
+          /* special function that treats any other symbol used as a marker, not
+           * a brush */
+          status =
+              msImagePolylineMarkers(image, offsetLine, symbol, &s, -s.gap,
+                                     style->initialgap * finalscalefactor, 1);
+        } else if (style->gap > 0) {
+          status =
+              msImagePolylineMarkers(image, offsetLine, symbol, &s, s.gap,
+                                     style->initialgap * finalscalefactor, 0);
+        } else {
+          if (renderer->renderLineTiled != NULL) {
+            int pw, ph;
+            imageObj *tile = NULL;
+            if (s.scale != 1) {
+              pw = MS_NINT(symbol->sizex * s.scale);
+              ph = MS_NINT(symbol->sizey * s.scale);
+            } else {
+              pw = symbol->sizex;
+              ph = symbol->sizey;
+            }
+            if (pw < 1)
+              pw = 1;
+            if (ph < 1)
+              ph = 1;
+            tile = getTile(image, symbol, &s, pw, ph, 0);
+            status = renderer->renderLineTiled(image, offsetLine, tile);
+          } else {
+            msSetError(MS_RENDERERERR,
+                       "renderer does not support brushed lines",
+                       "msDrawLineSymbol()");
+            status = MS_FAILURE;
+          }
+        }
+      }
+
+    line_cleanup:
+      if (offsetLine != p) {
+        msFreeShape(offsetLine);
+        msFree(offsetLine);
+      }
+      return status;
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
+      msDrawLineSymbolIM(map, image, p, style, scalefactor);
+    else {
+      msSetError(MS_RENDERERERR, "unsupported renderer", "msDrawLineSymbol()");
+      status = MS_FAILURE;
+    }
+  } else {
+    status = MS_FAILURE;
+  }
+  return status;
+}
+
+int msDrawShadeSymbol(mapObj *map, imageObj *image, shapeObj *p,
+                      styleObj *style, double scalefactor) {
+  int ret = MS_SUCCESS;
+  symbolObj *symbol;
+  if (!p)
+    return MS_SUCCESS;
+  if (p->numlines <= 0)
+    return MS_SUCCESS;
+
+  if (style->symbol >= map->symbolset.numsymbols || style->symbol < 0)
+    return MS_SUCCESS; /* no such symbol, 0 is OK */
+  symbol = map->symbolset.symbol[style->symbol];
+
+  /*
+   * if only an outlinecolor was defined, and not a color,
+   * switch to the line drawing function
+   *
+   * this behavior is kind of a mapfile hack, and must be
+   * kept for backwards compatibility
+   */
+  if (symbol->type != MS_SYMBOL_PIXMAP && symbol->type != MS_SYMBOL_SVG) {
+    if (!MS_VALID_COLOR(style->color)) {
+      if (MS_VALID_COLOR(style->outlinecolor))
+        return msDrawLineSymbol(map, image, p, style, scalefactor);
+      else {
+        /* just do nothing if no color has been set */
+        return MS_SUCCESS;
+      }
+    }
+  }
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      rendererVTableObj *renderer = image->format->vtable;
+      shapeObj *offsetPolygon = NULL;
+      /* store a reference to the renderer to be used for freeing */
+      if (style->symbol)
+        symbol->renderer = renderer;
+
+      if (style->offsetx != 0 || style->offsety != 0) {
+        if (style->offsety == MS_STYLE_SINGLE_SIDED_OFFSET) {
+          offsetPolygon = msOffsetPolyline(p, style->offsetx * scalefactor,
+                                           MS_STYLE_SINGLE_SIDED_OFFSET);
+        } else if (style->offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
+          offsetPolygon = msOffsetPolyline(p, style->offsetx * scalefactor,
+                                           MS_STYLE_DOUBLE_SIDED_OFFSET);
+        } else {
+          offsetPolygon = msOffsetPolyline(p, style->offsetx * scalefactor,
+                                           style->offsety * scalefactor);
+        }
+      } else {
+        offsetPolygon = p;
+      }
+      /* simple polygon drawing, without any specific symbol.
+       * also draws an optional outline */
+      if (style->symbol == 0 || symbol->type == MS_SYMBOL_SIMPLE) {
+        ret = renderer->renderPolygon(image, offsetPolygon, &style->color);
+        if (ret != MS_SUCCESS)
+          goto cleanup;
+        if (MS_VALID_COLOR(style->outlinecolor)) {
+          strokeStyleObj s;
+          INIT_STROKE_STYLE(s);
+          s.color = &style->outlinecolor;
+          s.color->alpha = style->color.alpha;
+          s.width =
+              (style->width == 0) ? scalefactor : style->width * scalefactor;
+          s.width = MS_MIN(s.width, style->maxwidth);
+          s.width = MS_MAX(s.width, style->minwidth);
+          ret = renderer->renderLine(image, offsetPolygon, &s);
+        }
+        goto cleanup; /*finished plain polygon*/
+      } else if (symbol->type == MS_SYMBOL_HATCH) {
+        double width, spacing;
+        double pattern[MS_MAXPATTERNLENGTH];
+        int i;
+
+        width = (style->width <= 0) ? scalefactor : style->width * scalefactor;
+        width = MS_MIN(width, style->maxwidth * image->resolutionfactor);
+        width = MS_MAX(width, style->minwidth * image->resolutionfactor);
+        spacing = (style->size <= 0) ? scalefactor : style->size * scalefactor;
+        spacing = MS_MIN(spacing, style->maxsize * image->resolutionfactor);
+        spacing = MS_MAX(spacing, style->minsize * image->resolutionfactor);
+
+        /* scale the pattern by the factor applied to the width */
+        for (i = 0; i < style->patternlength; i++) {
+          pattern[i] = style->pattern[i] * width / style->width;
+        }
+
+        ret = msHatchPolygon(image, offsetPolygon, spacing, width, pattern,
+                             style->patternlength, style->angle, &style->color);
+        goto cleanup;
+      } else {
+        symbolStyleObj s;
+        int pw, ph;
+        imageObj *tile;
+        int seamless = 0;
+
+        if (preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
+          ret = MS_FAILURE;
+          goto cleanup;
+        }
+
+        INIT_SYMBOL_STYLE(s);
+        computeSymbolStyle(&s, style, symbol, scalefactor,
+                           image->resolutionfactor);
+        s.style = style;
+
+        if (!s.color && !s.outlinecolor && symbol->type != MS_SYMBOL_PIXMAP &&
+            symbol->type != MS_SYMBOL_SVG) {
+          ret = MS_SUCCESS; /* nothing to do (colors are required except for
+                               PIXMAP symbols */
+          goto cleanup;
+        }
+
+        if (s.backgroundcolor) {
+          ret =
+              renderer->renderPolygon(image, offsetPolygon, s.backgroundcolor);
+          if (ret != MS_SUCCESS)
+            goto cleanup;
+        }
+
+        if (s.scale != 1) {
+          if (s.gap > 0) {
+            pw = MS_MAX(MS_NINT(s.gap), symbol->sizex * s.scale);
+            ph = MS_MAX(MS_NINT(s.gap), symbol->sizey * s.scale);
+          } else {
+            pw = MS_NINT(symbol->sizex * s.scale);
+            ph = MS_NINT(symbol->sizey * s.scale);
+          }
+        } else {
+          if (s.gap > 0) {
+            pw = MS_MAX(s.gap, symbol->sizex);
+            ph = MS_MAX(s.gap, symbol->sizey);
+          } else {
+            pw = symbol->sizex;
+            ph = symbol->sizey;
+          }
+        }
+        if (pw < 1)
+          pw = 1;
+        if (ph < 1)
+          ph = 1;
+
+        /* if we're doing vector symbols with an antialiased pixel rendererer,
+         * we want to enable seamless mode, i.e. comute a tile that accounts for
+         * the blending of neighbouring tiles at the tile border
+         */
+        if (symbol->type == MS_SYMBOL_VECTOR && style->gap == 0 &&
+            (image->format->renderer == MS_RENDER_WITH_AGG ||
+             image->format->renderer == MS_RENDER_WITH_CAIRO_RASTER)) {
+          seamless = 1;
+        }
+        tile = getTile(image, symbol, &s, pw, ph, seamless);
+        ret = renderer->renderPolygonTiled(image, offsetPolygon, tile);
+      }
+
+    cleanup:
+      if (offsetPolygon != p) {
+        msFreeShape(offsetPolygon);
+        msFree(offsetPolygon);
+      }
+      return ret;
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
+      msDrawShadeSymbolIM(map, image, p, style, scalefactor);
+  }
+  return ret;
+}
+
+int msDrawMarkerSymbol(mapObj *map, imageObj *image, pointObj *p,
+                       styleObj *style, double scalefactor) {
+  int ret = MS_SUCCESS;
+  if (!p)
+    return MS_SUCCESS;
+  if (style->symbol >= map->symbolset.numsymbols || style->symbol <= 0)
+    return MS_SUCCESS; /* no such symbol, 0 is OK   */
+
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      rendererVTableObj *renderer = image->format->vtable;
+      symbolStyleObj s;
+      double p_x, p_y;
+      symbolObj *symbol = map->symbolset.symbol[style->symbol];
+      /* store a reference to the renderer to be used for freeing */
+      symbol->renderer = renderer;
+      if (preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
+        return MS_FAILURE;
+      }
+
+      computeSymbolStyle(&s, style, symbol, scalefactor,
+                         image->resolutionfactor);
+      s.style = style;
+      if (!s.color && !s.outlinecolor && symbol->type != MS_SYMBOL_PIXMAP &&
+          symbol->type != MS_SYMBOL_SVG) {
+        return MS_SUCCESS; // nothing to do if no color, except for pixmap
+                           // symbols
+      }
+      if (s.scale == 0) {
+        return MS_SUCCESS;
+      }
+
+      /* TODO: skip the drawing of the symbol if it's smaller than a pixel ?
+      if (s.size < 1)
+       return; // size too small
+       */
+
+      p_x = p->x;
+      p_y = p->y;
+
+      if (style->polaroffsetpixel != 0 || style->polaroffsetangle != 0) {
+        double angle = style->polaroffsetangle * MS_DEG_TO_RAD;
+        p_x += (style->polaroffsetpixel * cos(-angle)) * scalefactor;
+        p_y += (style->polaroffsetpixel * sin(-angle)) * scalefactor;
+      }
+
+      p_x += style->offsetx * scalefactor;
+      p_y += style->offsety * scalefactor;
+
+      if (symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
+        double sx, sy;
+        double ox, oy;
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msGetMarkerSize(map, style, &sx, &sy, scalefactor))) {
+          return MS_FAILURE;
+        }
+        ox = (0.5 - symbol->anchorpoint_x) * sx;
+        oy = (0.5 - symbol->anchorpoint_y) * sy;
+        if (s.rotation != 0) {
+          double sina, cosa;
+          double rox, roy;
+          sina = sin(-s.rotation);
+          cosa = cos(-s.rotation);
+          rox = ox * cosa - oy * sina;
+          roy = ox * sina + oy * cosa;
+          p_x += rox;
+          p_y += roy;
+        } else {
+          p_x += ox;
+          p_y += oy;
+        }
+      }
+
+      if (renderer->use_imagecache) {
+        imageObj *tile = getTile(image, symbol, &s, -1, -1, 0);
+        if (tile != NULL)
+          return renderer->renderTile(image, tile, p_x, p_y);
+        else {
+          msSetError(MS_RENDERERERR, "problem creating cached tile",
+                     "msDrawMarkerSymbol()");
+          return MS_FAILURE;
+        }
+      }
+      switch (symbol->type) {
+      case (MS_SYMBOL_TRUETYPE): {
+        unsigned int unicode;
+        glyph_element *glyphc;
+        face_element *face = msGetFontFace(symbol->font, &map->fontset);
+        if (MS_UNLIKELY(!face))
+          return MS_FAILURE;
+        msUTF8ToUniChar(symbol->character, &unicode);
+        unicode = msGetGlyphIndex(face, unicode);
+        glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s.scale), 1), unicode);
+        if (MS_UNLIKELY(!glyphc))
+          return MS_FAILURE;
+        ret =
+            drawGlyphMarker(image, face, glyphc, p_x, p_y, s.scale, s.rotation,
+                            s.color, s.outlinecolor, s.outlinewidth);
+      } break;
+      case (MS_SYMBOL_PIXMAP): {
+        assert(symbol->pixmap_buffer);
+        ret = renderer->renderPixmapSymbol(image, p_x, p_y, symbol, &s);
+      } break;
+      case (MS_SYMBOL_ELLIPSE): {
+        ret = renderer->renderEllipseSymbol(image, p_x, p_y, symbol, &s);
+      } break;
+      case (MS_SYMBOL_VECTOR): {
+        ret = renderer->renderVectorSymbol(image, p_x, p_y, symbol, &s);
+      } break;
+      case (MS_SYMBOL_SVG): {
+        if (renderer->supports_svg) {
+          ret = renderer->renderSVGSymbol(image, p_x, p_y, symbol, &s);
+        } else {
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+          ret = msRenderRasterizedSVGSymbol(image, p_x, p_y, symbol, &s);
+#else
+          msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                     "msDrawMarkerSymbol()");
+          return MS_FAILURE;
+#endif
+        }
+      } break;
+      default:
+        break;
+      }
+      return ret;
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
+      msDrawMarkerSymbolIM(map, image, p, style, scalefactor);
+  }
+  return ret;
+}
+
+int msDrawLabelBounds(mapObj *map, imageObj *image, label_bounds *bnds,
+                      styleObj *style, double scalefactor) {
+  /*
+   * helper function to draw label bounds, where we might have only a rectObj
+   * and not a lineObj/shapeObj
+   */
+  shapeObj shape;
+  shape.numlines = 1;
+  if (bnds->poly) {
+    shape.line = bnds->poly;
+    return msDrawShadeSymbol(map, image, &shape, style, scalefactor);
+  } else {
+    pointObj pnts1[5];
+    lineObj l;
+    l.point = pnts1;
+    l.numpoints = 5;
+    pnts1[0].x = pnts1[1].x = pnts1[4].x = bnds->bbox.minx;
+    pnts1[2].x = pnts1[3].x = bnds->bbox.maxx;
+    pnts1[0].y = pnts1[3].y = pnts1[4].y = bnds->bbox.miny;
+    pnts1[1].y = pnts1[2].y = bnds->bbox.maxy;
+    (void)pnts1[0].x;
+    (void)pnts1[0].y;
+    (void)pnts1[1].x;
+    (void)pnts1[1].y;
+    (void)pnts1[2].x;
+    (void)pnts1[2].y;
+    (void)pnts1[3].x;
+    (void)pnts1[3].y;
+    (void)pnts1[4].x;
+    (void)pnts1[4].y;
+    shape.line = &l; // must return from this block
+    return msDrawShadeSymbol(map, image, &shape, style, scalefactor);
+  }
+}
+
+int msDrawTextSymbol(mapObj *map, imageObj *image, pointObj labelPnt,
+                     textSymbolObj *ts) {
+  (void)map;
+  rendererVTableObj *renderer = image->format->vtable;
+  colorObj *c = NULL, *oc = NULL;
+  int ow;
+  assert(ts->textpath);
+  if (!renderer->renderGlyphs)
+    return MS_FAILURE;
+
+  if (!ts->textpath->absolute) {
+    int g;
+    double cosa, sina;
+    double x = labelPnt.x;
+    double y = labelPnt.y;
+    if (ts->rotation != 0) {
+      cosa = cos(ts->rotation);
+      sina = sin(ts->rotation);
+      for (g = 0; g < ts->textpath->numglyphs; g++) {
+        double ox = ts->textpath->glyphs[g].pnt.x;
+        double oy = ts->textpath->glyphs[g].pnt.y;
+        ts->textpath->glyphs[g].pnt.x = ox * cosa + oy * sina + x;
+        ts->textpath->glyphs[g].pnt.y = -ox * sina + oy * cosa + y;
+        ts->textpath->glyphs[g].rot = ts->rotation;
+      }
+    } else {
+      for (g = 0; g < ts->textpath->numglyphs; g++) {
+        ts->textpath->glyphs[g].pnt.x += x;
+        ts->textpath->glyphs[g].pnt.y += y;
+      }
+    }
+  }
+
+  if (MS_VALID_COLOR(ts->label->shadowcolor)) {
+    textSymbolObj *ts_shadow;
+    int g;
+    double ox, oy;
+    double cosa, sina;
+    int ret;
+    if (ts->rotation != 0) {
+      cosa = cos(ts->rotation);
+      sina = sin(ts->rotation);
+      ox = ts->scalefactor *
+           (cosa * ts->label->shadowsizex + sina * ts->label->shadowsizey);
+      oy = ts->scalefactor *
+           (-sina * ts->label->shadowsizex + cosa * ts->label->shadowsizey);
+    } else {
+      ox = ts->scalefactor * ts->label->shadowsizex;
+      oy = ts->scalefactor * ts->label->shadowsizey;
+    }
+
+    ts_shadow = msSmallMalloc(sizeof(textSymbolObj));
+    initTextSymbol(ts_shadow);
+    msCopyTextSymbol(ts_shadow, ts);
+
+    for (g = 0; g < ts_shadow->textpath->numglyphs; g++) {
+      ts_shadow->textpath->glyphs[g].pnt.x += ox;
+      ts_shadow->textpath->glyphs[g].pnt.y += oy;
+    }
+
+    ret = renderer->renderGlyphs(image, ts_shadow, &ts->label->shadowcolor,
+                                 NULL, 0, MS_FALSE);
+    freeTextSymbol(ts_shadow);
+    msFree(ts_shadow);
+    if (ret != MS_SUCCESS)
+      return ret;
+  }
+
+  if (MS_VALID_COLOR(ts->label->color))
+    c = &ts->label->color;
+  if (MS_VALID_COLOR(ts->label->outlinecolor))
+    oc = &ts->label->outlinecolor;
+  ow = MS_NINT((double)ts->label->outlinewidth *
+               ((double)ts->textpath->glyph_size / (double)ts->label->size));
+  return renderer->renderGlyphs(image, ts, c, oc, ow, MS_FALSE);
+}
+
+/************************************************************************/
+/*                          msCircleDrawLineSymbol                      */
+/*                                                                      */
+/************************************************************************/
+int msCircleDrawLineSymbol(mapObj *map, imageObj *image, pointObj *p, double r,
+                           styleObj *style, double scalefactor) {
+  shapeObj *circle;
+  int status;
+  if (!image)
+    return MS_FAILURE;
+  circle = msRasterizeArc(p->x, p->y, r, 0, 360, 0);
+  if (!circle)
+    return MS_FAILURE;
+  status = msDrawLineSymbol(map, image, circle, style, scalefactor);
+  msFreeShape(circle);
+  msFree(circle);
+  return status;
+}
+
+int msCircleDrawShadeSymbol(mapObj *map, imageObj *image, pointObj *p, double r,
+                            styleObj *style, double scalefactor) {
+  shapeObj *circle;
+  int status;
+  if (!image)
+    return MS_FAILURE;
+  circle = msRasterizeArc(p->x, p->y, r, 0, 360, 0);
+  if (!circle)
+    return MS_FAILURE;
+  status = msDrawShadeSymbol(map, image, circle, style, scalefactor);
+  msFreeShape(circle);
+  msFree(circle);
+  return status;
+}
+
+int msDrawPieSlice(mapObj *map, imageObj *image, pointObj *p, styleObj *style,
+                   double radius, double start, double end) {
+  int status;
+  shapeObj *circle;
+  double center_x = p->x;
+  double center_y = p->y;
+  if (!image)
+    return MS_FAILURE;
+  if (style->offsetx > 0) {
+    center_x += style->offsetx * cos(((-start - end) * MS_PI / 360.));
+    center_y -= style->offsetx * sin(((-start - end) * MS_PI / 360.));
+  }
+  circle = msRasterizeArc(center_x, center_y, radius, start, end, 1);
+  if (!circle)
+    return MS_FAILURE;
+  status = msDrawShadeSymbol(map, image, circle, style, 1.0);
+  msFreeShape(circle);
+  msFree(circle);
+  return status;
+}
+
+/*
+ * RFC 49 implementation
+ * if an outlinewidth is used:
+ *  - augment the style's width to account for the outline width
+ *  - swap the style color and outlinecolor
+ *  - draw the shape (the outline) in the first pass of the
+ *    caching mechanism
+ */
+
+void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map,
+                                    layerObj *layer, imageObj *image) {
+  colorObj tmp;
+
+  if (pStyle->outlinewidth > 0) {
+    /* adapt width (must take scalefactor into account) */
+    pStyle->width += (pStyle->outlinewidth /
+                      (layer->scalefactor / image->resolutionfactor)) *
+                     2;
+    pStyle->minwidth += pStyle->outlinewidth * 2;
+    pStyle->maxwidth += pStyle->outlinewidth * 2;
+    pStyle->size += (pStyle->outlinewidth / layer->scalefactor *
+                     (map->resolution / map->defresolution));
+
+    /*swap color and outlinecolor*/
+    tmp = pStyle->color;
+    pStyle->color = pStyle->outlinecolor;
+    pStyle->outlinecolor = tmp;
+  }
+}
+
+/*
+ * RFC 49 implementation: switch back the styleobj to its
+ * original state, so the line fill will be drawn in the
+ * second pass of the caching mechanism
+ */
+
+void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map,
+                                    layerObj *layer, imageObj *image) {
+  colorObj tmp;
+
+  if (pStyle->outlinewidth > 0) {
+    /* reset widths to original state */
+    pStyle->width -= (pStyle->outlinewidth /
+                      (layer->scalefactor / image->resolutionfactor)) *
+                     2;
+    pStyle->minwidth -= pStyle->outlinewidth * 2;
+    pStyle->maxwidth -= pStyle->outlinewidth * 2;
+    pStyle->size -= (pStyle->outlinewidth / layer->scalefactor *
+                     (map->resolution / map->defresolution));
+
+    /*reswap colors to original state*/
+    tmp = pStyle->color;
+    pStyle->color = pStyle->outlinecolor;
+    pStyle->outlinecolor = tmp;
+  }
+}
diff -pruN 8.0.1-5/src/mapresample.c 8.2.0~beta1-1~exp1/src/mapresample.c
--- 8.0.1-5/src/mapresample.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapresample.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1639 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Assorted code related to resampling rasters.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <assert.h>
+#include "mapresample.h"
+#include "mapthread.h"
+
+#define SKIP_MASK(x, y)                                                        \
+  (mask_rb && !*(mask_rb->data.rgba.a + (y)*mask_rb->data.rgba.row_step +      \
+                 (x)*mask_rb->data.rgba.pixel_step))
+
+/************************************************************************/
+/*                          InvGeoTransform()                           */
+/*                                                                      */
+/*      Invert a standard 3x2 "GeoTransform" style matrix with an       */
+/*      implicit [1 0 0] final row.                                     */
+/************************************************************************/
+
+int InvGeoTransform(double *gt_in, double *gt_out)
+
+{
+  double det, inv_det;
+
+  /* we assume a 3rd row that is [1 0 0] */
+
+  /* Compute determinate */
+
+  det = gt_in[1] * gt_in[5] - gt_in[2] * gt_in[4];
+
+  if (fabs(det) < 0.000000000000001)
+    return 0;
+
+  inv_det = 1.0 / det;
+
+  /* compute adjoint, and devide by determinate */
+
+  gt_out[1] = gt_in[5] * inv_det;
+  gt_out[4] = -gt_in[4] * inv_det;
+
+  gt_out[2] = -gt_in[2] * inv_det;
+  gt_out[5] = gt_in[1] * inv_det;
+
+  gt_out[0] = (gt_in[2] * gt_in[3] - gt_in[0] * gt_in[5]) * inv_det;
+  gt_out[3] = (-gt_in[1] * gt_in[3] + gt_in[0] * gt_in[4]) * inv_det;
+
+  return 1;
+}
+
+/************************************************************************/
+/*                      msNearestRasterResample()                       */
+/************************************************************************/
+
+static int msNearestRasterResampler(
+    imageObj *psSrcImage, rasterBufferObj *src_rb, imageObj *psDstImage,
+    rasterBufferObj *dst_rb, SimpleTransformer pfnTransform, void *pCBData,
+    int debug, rasterBufferObj *mask_rb, int bWrapAtLeftRight)
+
+{
+  double *x, *y;
+  int nDstX, nDstY;
+  int *panSuccess;
+  int nDstXSize = psDstImage->width;
+  int nDstYSize = psDstImage->height;
+  int nSrcXSize = psSrcImage->width;
+  int nSrcYSize = psSrcImage->height;
+  int nFailedPoints = 0, nSetPoints = 0;
+  assert(!MS_RENDERER_PLUGIN(psSrcImage->format) ||
+         src_rb->type == MS_BUFFER_BYTE_RGBA);
+
+  x = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  y = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  panSuccess = (int *)msSmallMalloc(sizeof(int) * nDstXSize);
+
+  for (nDstY = 0; nDstY < nDstYSize; nDstY++) {
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      x[nDstX] = nDstX + 0.5;
+      y[nDstX] = nDstY + 0.5;
+    }
+
+    pfnTransform(pCBData, nDstXSize, x, y, panSuccess);
+
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      int nSrcX, nSrcY;
+      if (SKIP_MASK(nDstX, nDstY))
+        continue;
+
+      if (!panSuccess[nDstX]) {
+        nFailedPoints++;
+        continue;
+      }
+
+      nSrcX = (int)x[nDstX];
+      nSrcY = (int)y[nDstX];
+
+      if (bWrapAtLeftRight && nSrcX >= nSrcXSize && nSrcX < 2 * nSrcXSize)
+        nSrcX -= nSrcXSize;
+
+      /*
+       * We test the original floating point values to
+       * avoid errors related to asymmetric rounding around zero.
+       * (Also note bug #3120 regarding nearly redundent x/y < 0 checks).
+       */
+      if (x[nDstX] < 0.0 || y[nDstX] < 0.0 || nSrcX < 0 || nSrcY < 0 ||
+          nSrcX >= nSrcXSize || nSrcY >= nSrcYSize) {
+        continue;
+      }
+
+      if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
+        int src_rb_off;
+        rgbaArrayObj *src, *dst;
+        assert(src_rb && dst_rb);
+        assert(src_rb->type == MS_BUFFER_BYTE_RGBA);
+        src = &src_rb->data.rgba;
+        dst = &dst_rb->data.rgba;
+        src_rb_off = nSrcX * src->pixel_step + nSrcY * src->row_step;
+
+        if (src->a == NULL || src->a[src_rb_off] == 255) {
+          int dst_rb_off;
+
+          dst_rb_off = nDstX * dst->pixel_step + nDstY * dst->row_step;
+
+          nSetPoints++;
+
+          dst->r[dst_rb_off] = src->r[src_rb_off];
+          dst->g[dst_rb_off] = src->g[src_rb_off];
+          dst->b[dst_rb_off] = src->b[src_rb_off];
+          if (dst->a)
+            dst->a[dst_rb_off] = 255;
+        } else if (src->a[src_rb_off] != 0) {
+          int dst_rb_off;
+
+          dst_rb_off = nDstX * dst->pixel_step + nDstY * dst->row_step;
+
+          nSetPoints++;
+
+          /* actual alpha blending is required */
+          msAlphaBlendPM(
+              src->r[src_rb_off], src->g[src_rb_off], src->b[src_rb_off],
+              src->a[src_rb_off], dst->r + dst_rb_off, dst->g + dst_rb_off,
+              dst->b + dst_rb_off, dst->a ? dst->a + dst_rb_off : NULL);
+        }
+      } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
+        int band, src_off, dst_off;
+
+        src_off = nSrcX + nSrcY * psSrcImage->width;
+
+        if (!MS_GET_BIT(psSrcImage->img_mask, src_off))
+          continue;
+
+        nSetPoints++;
+
+        dst_off = nDstX + nDstY * psDstImage->width;
+
+        MS_SET_BIT(psDstImage->img_mask, dst_off);
+
+        for (band = 0; band < psSrcImage->format->bands; band++) {
+          if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
+            psDstImage->img.raw_16bit[dst_off] =
+                psSrcImage->img.raw_16bit[src_off];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+            psDstImage->img.raw_float[dst_off] =
+                psSrcImage->img.raw_float[src_off];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+            psDstImage->img.raw_byte[dst_off] =
+                psSrcImage->img.raw_byte[src_off];
+          } else {
+            assert(0);
+          }
+          src_off += psSrcImage->width * psSrcImage->height;
+          dst_off += psDstImage->width * psDstImage->height;
+        }
+      }
+    }
+  }
+
+  free(panSuccess);
+  free(x);
+  free(y);
+
+  /* -------------------------------------------------------------------- */
+  /*      Some debugging output.                                          */
+  /* -------------------------------------------------------------------- */
+  if (nFailedPoints > 0 && debug) {
+    msDebug("msNearestRasterResampler: "
+            "%d failed to transform, %d actually set.\n",
+            nFailedPoints, nSetPoints);
+  }
+
+  return 0;
+}
+
+/************************************************************************/
+/*                            msSourceSample()                          */
+/************************************************************************/
+
+static void msSourceSample(imageObj *psSrcImage, rasterBufferObj *rb, int iSrcX,
+                           int iSrcY, double *padfPixelSum, double dfWeight,
+                           double *pdfWeightSum)
+
+{
+  if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
+    rgbaArrayObj *rgba;
+    int rb_off;
+    assert(rb && rb->type == MS_BUFFER_BYTE_RGBA);
+    rgba = &(rb->data.rgba);
+    rb_off = iSrcX * rgba->pixel_step + iSrcY * rgba->row_step;
+
+    if (rgba->a == NULL || rgba->a[rb_off] > 1) {
+      padfPixelSum[0] += rgba->r[rb_off] * dfWeight;
+      padfPixelSum[1] += rgba->g[rb_off] * dfWeight;
+      padfPixelSum[2] += rgba->b[rb_off] * dfWeight;
+
+      if (rgba->a == NULL)
+        *pdfWeightSum += dfWeight;
+      else
+        *pdfWeightSum += dfWeight * (rgba->a[rb_off] / 255.0);
+    }
+  } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
+    int band;
+    int src_off;
+
+    src_off = iSrcX + iSrcY * psSrcImage->width;
+
+    if (!MS_GET_BIT(psSrcImage->img_mask, src_off))
+      return;
+
+    for (band = 0; band < psSrcImage->format->bands; band++) {
+      if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
+        int nValue;
+
+        nValue = psSrcImage->img.raw_16bit[src_off];
+
+        padfPixelSum[band] += dfWeight * nValue;
+      } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+        float fValue;
+
+        fValue = psSrcImage->img.raw_float[src_off];
+
+        padfPixelSum[band] += fValue * dfWeight;
+      } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+        int nValue;
+
+        nValue = psSrcImage->img.raw_byte[src_off];
+
+        padfPixelSum[band] += nValue * dfWeight;
+      } else {
+        assert(0);
+        return;
+      }
+
+      src_off += psSrcImage->width * psSrcImage->height;
+    }
+    *pdfWeightSum += dfWeight;
+  }
+}
+
+/************************************************************************/
+/*                      msBilinearRasterResample()                      */
+/************************************************************************/
+
+static int msBilinearRasterResampler(
+    imageObj *psSrcImage, rasterBufferObj *src_rb, imageObj *psDstImage,
+    rasterBufferObj *dst_rb, SimpleTransformer pfnTransform, void *pCBData,
+    int debug, rasterBufferObj *mask_rb, int bWrapAtLeftRight)
+
+{
+  double *x, *y;
+  int nDstX, nDstY, i;
+  int *panSuccess;
+  int nDstXSize = psDstImage->width;
+  int nDstYSize = psDstImage->height;
+  int nSrcXSize = psSrcImage->width;
+  int nSrcYSize = psSrcImage->height;
+  int nFailedPoints = 0, nSetPoints = 0;
+  double *padfPixelSum;
+  int bandCount = MS_MAX(4, psSrcImage->format->bands);
+
+  padfPixelSum = (double *)msSmallMalloc(sizeof(double) * bandCount);
+
+  x = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  y = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  panSuccess = (int *)msSmallMalloc(sizeof(int) * nDstXSize);
+
+  for (nDstY = 0; nDstY < nDstYSize; nDstY++) {
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      x[nDstX] = nDstX + 0.5;
+      y[nDstX] = nDstY + 0.5;
+    }
+
+    pfnTransform(pCBData, nDstXSize, x, y, panSuccess);
+
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      int nSrcX, nSrcY, nSrcX2, nSrcY2;
+      double dfRatioX2, dfRatioY2, dfWeightSum = 0.0;
+      if (SKIP_MASK(nDstX, nDstY))
+        continue;
+
+      if (!panSuccess[nDstX]) {
+        nFailedPoints++;
+        continue;
+      }
+
+      /* If we are right off the source, skip this pixel */
+      nSrcX = (int)floor(x[nDstX]);
+      nSrcY = (int)floor(y[nDstX]);
+      if (nSrcX < 0 || (!bWrapAtLeftRight && nSrcX >= nSrcXSize) || nSrcY < 0 ||
+          nSrcY >= nSrcYSize)
+        continue;
+
+      /*
+      ** Offset to treat TL pixel corners as pixel location instead
+      ** of the center.
+      */
+      x[nDstX] -= 0.5;
+      y[nDstX] -= 0.5;
+
+      nSrcX = (int)floor(x[nDstX]);
+      nSrcY = (int)floor(y[nDstX]);
+
+      nSrcX2 = nSrcX + 1;
+      nSrcY2 = nSrcY + 1;
+
+      dfRatioX2 = x[nDstX] - nSrcX;
+      dfRatioY2 = y[nDstX] - nSrcY;
+
+      /* Trim in stuff one pixel off the edge */
+      nSrcX = MS_MAX(nSrcX, 0);
+      nSrcY = MS_MAX(nSrcY, 0);
+      if (!bWrapAtLeftRight)
+        nSrcX2 = MS_MIN(nSrcX2, nSrcXSize - 1);
+      nSrcY2 = MS_MIN(nSrcY2, nSrcYSize - 1);
+
+      memset(padfPixelSum, 0, sizeof(double) * bandCount);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY, padfPixelSum,
+                     (1.0 - dfRatioX2) * (1.0 - dfRatioY2), &dfWeightSum);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY,
+                     padfPixelSum, (dfRatioX2) * (1.0 - dfRatioY2),
+                     &dfWeightSum);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY2,
+                     padfPixelSum, (1.0 - dfRatioX2) * (dfRatioY2),
+                     &dfWeightSum);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY2,
+                     padfPixelSum, (dfRatioX2) * (dfRatioY2), &dfWeightSum);
+
+      if (dfWeightSum == 0.0)
+        continue;
+
+      if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
+        assert(src_rb && dst_rb);
+        assert(src_rb->type == MS_BUFFER_BYTE_RGBA);
+        assert(src_rb->type == dst_rb->type);
+
+        nSetPoints++;
+
+        if (dfWeightSum > 0.001) {
+          int dst_rb_off = nDstX * dst_rb->data.rgba.pixel_step +
+                           nDstY * dst_rb->data.rgba.row_step;
+          unsigned char red, green, blue, alpha;
+
+          red = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[0]));
+          green = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[1]));
+          blue = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[2]));
+          alpha = (unsigned char)MS_MAX(0, MS_MIN(255, 255.5 * dfWeightSum));
+
+          msAlphaBlendPM(
+              red, green, blue, alpha, dst_rb->data.rgba.r + dst_rb_off,
+              dst_rb->data.rgba.g + dst_rb_off,
+              dst_rb->data.rgba.b + dst_rb_off,
+              (dst_rb->data.rgba.a == NULL) ? NULL
+                                            : dst_rb->data.rgba.a + dst_rb_off);
+        }
+      } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
+        int band;
+        int dst_off = nDstX + nDstY * psDstImage->width;
+
+        for (i = 0; i < bandCount; i++)
+          padfPixelSum[i] /= dfWeightSum;
+
+        MS_SET_BIT(psDstImage->img_mask, dst_off);
+
+        for (band = 0; band < psSrcImage->format->bands; band++) {
+          if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
+            psDstImage->img.raw_16bit[dst_off] = (short)padfPixelSum[band];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+            psDstImage->img.raw_float[dst_off] = (float)padfPixelSum[band];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+            psDstImage->img.raw_byte[dst_off] =
+                (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[band]));
+          }
+
+          dst_off += psDstImage->width * psDstImage->height;
+        }
+      }
+    }
+  }
+
+  free(padfPixelSum);
+  free(panSuccess);
+  free(x);
+  free(y);
+
+  /* -------------------------------------------------------------------- */
+  /*      Some debugging output.                                          */
+  /* -------------------------------------------------------------------- */
+  if (nFailedPoints > 0 && debug) {
+    msDebug("msBilinearRasterResampler: "
+            "%d failed to transform, %d actually set.\n",
+            nFailedPoints, nSetPoints);
+  }
+
+  return 0;
+}
+
+/************************************************************************/
+/*                          msAverageSample()                           */
+/************************************************************************/
+
+static int msAverageSample(imageObj *psSrcImage, rasterBufferObj *src_rb,
+                           double dfXMin, double dfYMin, double dfXMax,
+                           double dfYMax, double *padfPixelSum,
+                           double *pdfAlpha01)
+
+{
+  int nXMin, nXMax, nYMin, nYMax, iX, iY;
+  double dfWeightSum = 0.0;
+  double dfMaxWeight = 0.0;
+
+  nXMin = (int)dfXMin;
+  nYMin = (int)dfYMin;
+  nXMax = (int)ceil(dfXMax);
+  nYMax = (int)ceil(dfYMax);
+
+  *pdfAlpha01 = 0.0;
+
+  for (iY = nYMin; iY < nYMax; iY++) {
+    double dfYCellMin, dfYCellMax;
+
+    dfYCellMin = MS_MAX(iY, dfYMin);
+    dfYCellMax = MS_MIN(iY + 1, dfYMax);
+
+    for (iX = nXMin; iX < nXMax; iX++) {
+      double dfXCellMin, dfXCellMax, dfWeight;
+
+      dfXCellMin = MS_MAX(iX, dfXMin);
+      dfXCellMax = MS_MIN(iX + 1, dfXMax);
+
+      dfWeight = (dfXCellMax - dfXCellMin) * (dfYCellMax - dfYCellMin);
+
+      msSourceSample(psSrcImage, src_rb, iX, iY, padfPixelSum, dfWeight,
+                     &dfWeightSum);
+      dfMaxWeight += dfWeight;
+    }
+  }
+
+  if (dfWeightSum == 0.0)
+    return MS_FALSE;
+
+  for (iX = 0; iX < 4; iX++)
+    padfPixelSum[iX] /= dfWeightSum;
+
+  *pdfAlpha01 = dfWeightSum / dfMaxWeight;
+
+  return MS_TRUE;
+}
+
+/************************************************************************/
+/*                      msAverageRasterResample()                       */
+/************************************************************************/
+
+static int
+msAverageRasterResampler(imageObj *psSrcImage, rasterBufferObj *src_rb,
+                         imageObj *psDstImage, rasterBufferObj *dst_rb,
+                         SimpleTransformer pfnTransform, void *pCBData,
+                         int debug, rasterBufferObj *mask_rb)
+
+{
+  double *x1, *y1, *x2, *y2;
+  int nDstX, nDstY;
+  int *panSuccess1, *panSuccess2;
+  int nDstXSize = psDstImage->width;
+  int nDstYSize = psDstImage->height;
+  int nFailedPoints = 0, nSetPoints = 0;
+  double *padfPixelSum;
+
+  int bandCount = MS_MAX(4, psSrcImage->format->bands);
+
+  padfPixelSum = (double *)msSmallMalloc(sizeof(double) * bandCount);
+
+  x1 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  y1 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  x2 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  y2 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  panSuccess1 = (int *)msSmallMalloc(sizeof(int) * (nDstXSize + 1));
+  panSuccess2 = (int *)msSmallMalloc(sizeof(int) * (nDstXSize + 1));
+
+  for (nDstY = 0; nDstY < nDstYSize; nDstY++) {
+    for (nDstX = 0; nDstX <= nDstXSize; nDstX++) {
+      x1[nDstX] = nDstX;
+      y1[nDstX] = nDstY;
+      x2[nDstX] = nDstX;
+      y2[nDstX] = nDstY + 1;
+    }
+
+    pfnTransform(pCBData, nDstXSize + 1, x1, y1, panSuccess1);
+    pfnTransform(pCBData, nDstXSize + 1, x2, y2, panSuccess2);
+
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      double dfXMin, dfYMin, dfXMax, dfYMax;
+      double dfAlpha01;
+      if (SKIP_MASK(nDstX, nDstY))
+        continue;
+
+      /* Do not generate a pixel unless all four corners transformed */
+      if (!panSuccess1[nDstX] || !panSuccess1[nDstX + 1] ||
+          !panSuccess2[nDstX] || !panSuccess2[nDstX + 1]) {
+        nFailedPoints++;
+        continue;
+      }
+
+      dfXMin = MS_MIN(MS_MIN(x1[nDstX], x1[nDstX + 1]),
+                      MS_MIN(x2[nDstX], x2[nDstX + 1]));
+      dfYMin = MS_MIN(MS_MIN(y1[nDstX], y1[nDstX + 1]),
+                      MS_MIN(y2[nDstX], y2[nDstX + 1]));
+      dfXMax = MS_MAX(MS_MAX(x1[nDstX], x1[nDstX + 1]),
+                      MS_MAX(x2[nDstX], x2[nDstX + 1]));
+      dfYMax = MS_MAX(MS_MAX(y1[nDstX], y1[nDstX + 1]),
+                      MS_MAX(y2[nDstX], y2[nDstX + 1]));
+
+      dfXMin = MS_MIN(MS_MAX(dfXMin, 0), psSrcImage->width + 1);
+      dfYMin = MS_MIN(MS_MAX(dfYMin, 0), psSrcImage->height + 1);
+      dfXMax = MS_MIN(MS_MAX(-1, dfXMax), psSrcImage->width);
+      dfYMax = MS_MIN(MS_MAX(-1, dfYMax), psSrcImage->height);
+
+      memset(padfPixelSum, 0, sizeof(double) * bandCount);
+
+      if (!msAverageSample(psSrcImage, src_rb, dfXMin, dfYMin, dfXMax, dfYMax,
+                           padfPixelSum, &dfAlpha01))
+        continue;
+
+      if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
+        assert(dst_rb && src_rb);
+        assert(dst_rb->type == MS_BUFFER_BYTE_RGBA);
+        assert(src_rb->type == dst_rb->type);
+
+        nSetPoints++;
+
+        if (dfAlpha01 > 0) {
+          unsigned char red, green, blue, alpha;
+
+          red = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[0] + 0.5));
+          green = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[1] + 0.5));
+          blue = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[2] + 0.5));
+          alpha = (unsigned char)MS_MAX(0, MS_MIN(255, 255 * dfAlpha01 + 0.5));
+
+          RB_MIX_PIXEL(dst_rb, nDstX, nDstY, red, green, blue, alpha);
+        }
+      } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
+        int band;
+        int dst_off = nDstX + nDstY * psDstImage->width;
+
+        MS_SET_BIT(psDstImage->img_mask, dst_off);
+
+        for (band = 0; band < psSrcImage->format->bands; band++) {
+          if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
+            psDstImage->img.raw_16bit[dst_off] =
+                (short)(padfPixelSum[band] + 0.5);
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+            psDstImage->img.raw_float[dst_off] = (float)padfPixelSum[band];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+            psDstImage->img.raw_byte[dst_off] =
+                (unsigned char)padfPixelSum[band];
+          }
+
+          dst_off += psDstImage->width * psDstImage->height;
+        }
+      }
+    }
+  }
+
+  free(padfPixelSum);
+  free(panSuccess1);
+  free(x1);
+  free(y1);
+  free(panSuccess2);
+  free(x2);
+  free(y2);
+
+  /* -------------------------------------------------------------------- */
+  /*      Some debugging output.                                          */
+  /* -------------------------------------------------------------------- */
+  if (nFailedPoints > 0 && debug) {
+    msDebug("msAverageRasterResampler: "
+            "%d failed to transform, %d actually set.\n",
+            nFailedPoints, nSetPoints);
+  }
+
+  return 0;
+}
+
+/************************************************************************/
+/* ==================================================================== */
+/*      PROJ based transformer.         */
+/* ==================================================================== */
+/************************************************************************/
+
+typedef struct {
+  projectionObj *psSrcProjObj;
+  int bSrcIsGeographic;
+  double adfInvSrcGeoTransform[6];
+
+  projectionObj *psDstProjObj;
+  int bDstIsGeographic;
+  double adfDstGeoTransform[6];
+
+  int bUseProj;
+  reprojectionObj *pReprojectionDstToSrc;
+} msProjTransformInfo;
+
+/************************************************************************/
+/*                       msInitProjTransformer()                        */
+/************************************************************************/
+
+void *msInitProjTransformer(projectionObj *psSrc, double *padfSrcGeoTransform,
+                            projectionObj *psDst, double *padfDstGeoTransform)
+
+{
+  int backup_src_need_gt;
+  int backup_dst_need_gt;
+  msProjTransformInfo *psPTInfo;
+
+  psPTInfo =
+      (msProjTransformInfo *)msSmallCalloc(1, sizeof(msProjTransformInfo));
+
+  /* -------------------------------------------------------------------- */
+  /*      We won't even use PROJ.4 if either coordinate system is         */
+  /*      NULL.                                                           */
+  /* -------------------------------------------------------------------- */
+  backup_src_need_gt = psSrc->gt.need_geotransform;
+  psSrc->gt.need_geotransform = 0;
+  backup_dst_need_gt = psDst->gt.need_geotransform;
+  psDst->gt.need_geotransform = 0;
+  psPTInfo->bUseProj = (psSrc->proj != NULL && psDst->proj != NULL &&
+                        msProjectionsDiffer(psSrc, psDst));
+  psSrc->gt.need_geotransform = backup_src_need_gt;
+  psDst->gt.need_geotransform = backup_dst_need_gt;
+
+  /* -------------------------------------------------------------------- */
+  /*      Record source image information.  We invert the source          */
+  /*      transformation for more convenient inverse application in       */
+  /*      the transformer.                                                */
+  /* -------------------------------------------------------------------- */
+  psPTInfo->psSrcProjObj = psSrc;
+  if (psPTInfo->bUseProj)
+    psPTInfo->bSrcIsGeographic = msProjIsGeographicCRS(psSrc);
+  else
+    psPTInfo->bSrcIsGeographic = MS_FALSE;
+
+  if (!InvGeoTransform(padfSrcGeoTransform, psPTInfo->adfInvSrcGeoTransform)) {
+    free(psPTInfo);
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Record destination image information.                           */
+  /* -------------------------------------------------------------------- */
+  psPTInfo->psDstProjObj = psDst;
+  if (psPTInfo->bUseProj)
+    psPTInfo->bDstIsGeographic = msProjIsGeographicCRS(psDst);
+  else
+    psPTInfo->bDstIsGeographic = MS_FALSE;
+  memcpy(psPTInfo->adfDstGeoTransform, padfDstGeoTransform, sizeof(double) * 6);
+
+  if (psPTInfo->bUseProj) {
+    psPTInfo->pReprojectionDstToSrc = msProjectCreateReprojector(
+        psPTInfo->psDstProjObj, psPTInfo->psSrcProjObj);
+    if (!psPTInfo->pReprojectionDstToSrc) {
+      free(psPTInfo);
+      return NULL;
+    }
+  }
+
+  return psPTInfo;
+}
+
+/************************************************************************/
+/*                       msFreeProjTransformer()                        */
+/************************************************************************/
+
+void msFreeProjTransformer(void *pCBData)
+
+{
+  if (pCBData) {
+    msProjTransformInfo *psPTInfo = (msProjTransformInfo *)pCBData;
+    msProjectDestroyReprojector(psPTInfo->pReprojectionDstToSrc);
+  }
+  free(pCBData);
+}
+
+/************************************************************************/
+/*                          msProjTransformer                           */
+/************************************************************************/
+
+int msProjTransformer(void *pCBData, int nPoints, double *x, double *y,
+                      int *panSuccess)
+
+{
+  int i;
+  msProjTransformInfo *psPTInfo = (msProjTransformInfo *)pCBData;
+  double x_out;
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform into destination georeferenced space.                 */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < nPoints; i++) {
+    x_out = psPTInfo->adfDstGeoTransform[0] +
+            psPTInfo->adfDstGeoTransform[1] * x[i] +
+            psPTInfo->adfDstGeoTransform[2] * y[i];
+    y[i] = psPTInfo->adfDstGeoTransform[3] +
+           psPTInfo->adfDstGeoTransform[4] * x[i] +
+           psPTInfo->adfDstGeoTransform[5] * y[i];
+    x[i] = x_out;
+
+    panSuccess[i] = 1;
+  }
+
+  if (psPTInfo->bUseProj) {
+    if (msProjectTransformPoints(psPTInfo->pReprojectionDstToSrc, nPoints, x,
+                                 y) != MS_SUCCESS) {
+      for (i = 0; i < nPoints; i++)
+        panSuccess[i] = 0;
+
+      return MS_FALSE;
+    }
+    for (i = 0; i < nPoints; i++) {
+      if (x[i] == HUGE_VAL || y[i] == HUGE_VAL)
+        panSuccess[i] = 0;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform to source raster space.                               */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < nPoints; i++) {
+    if (panSuccess[i]) {
+      x_out = psPTInfo->adfInvSrcGeoTransform[0] +
+              psPTInfo->adfInvSrcGeoTransform[1] * x[i] +
+              psPTInfo->adfInvSrcGeoTransform[2] * y[i];
+      y[i] = psPTInfo->adfInvSrcGeoTransform[3] +
+             psPTInfo->adfInvSrcGeoTransform[4] * x[i] +
+             psPTInfo->adfInvSrcGeoTransform[5] * y[i];
+      x[i] = x_out;
+    } else {
+      x[i] = -1;
+      y[i] = -1;
+    }
+  }
+
+  return 1;
+}
+
+/************************************************************************/
+/* ==================================================================== */
+/*      Approximate transformer.                                        */
+/* ==================================================================== */
+/************************************************************************/
+
+typedef struct {
+  SimpleTransformer pfnBaseTransformer;
+  void *pBaseCBData;
+
+  double dfMaxError;
+} msApproxTransformInfo;
+
+/************************************************************************/
+/*                      msInitApproxTransformer()                       */
+/************************************************************************/
+
+static void *msInitApproxTransformer(SimpleTransformer pfnBaseTransformer,
+                                     void *pBaseCBData, double dfMaxError)
+
+{
+  msApproxTransformInfo *psATInfo;
+
+  psATInfo =
+      (msApproxTransformInfo *)msSmallMalloc(sizeof(msApproxTransformInfo));
+  psATInfo->pfnBaseTransformer = pfnBaseTransformer;
+  psATInfo->pBaseCBData = pBaseCBData;
+  psATInfo->dfMaxError = dfMaxError;
+
+  return psATInfo;
+}
+
+/************************************************************************/
+/*                      msFreeApproxTransformer()                       */
+/************************************************************************/
+
+static void msFreeApproxTransformer(void *pCBData)
+
+{
+  free(pCBData);
+}
+
+/************************************************************************/
+/*                         msApproxTransformer                          */
+/************************************************************************/
+
+static int msApproxTransformer(void *pCBData, int nPoints, double *x, double *y,
+                               int *panSuccess)
+
+{
+  msApproxTransformInfo *psATInfo = (msApproxTransformInfo *)pCBData;
+  double x2[3], y2[3], dfDeltaX, dfDeltaY, dfError, dfDist;
+  int nMiddle, anSuccess2[3], i, bSuccess;
+
+  nMiddle = (nPoints - 1) / 2;
+
+  /* -------------------------------------------------------------------- */
+  /*      Bail if our preconditions are not met, or if error is not       */
+  /*      acceptable.                                                     */
+  /* -------------------------------------------------------------------- */
+  if (y[0] != y[nPoints - 1] || y[0] != y[nMiddle] || x[0] == x[nPoints - 1] ||
+      x[0] == x[nMiddle] || psATInfo->dfMaxError == 0.0 || nPoints <= 5) {
+    return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                        panSuccess);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform first, last and middle point.                         */
+  /* -------------------------------------------------------------------- */
+  x2[0] = x[0];
+  y2[0] = y[0];
+  x2[1] = x[nMiddle];
+  y2[1] = y[nMiddle];
+  x2[2] = x[nPoints - 1];
+  y2[2] = y[nPoints - 1];
+
+  bSuccess = psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, 3, x2, y2,
+                                          anSuccess2);
+  if (!bSuccess || !anSuccess2[0] || !anSuccess2[1] || !anSuccess2[2])
+    return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                        panSuccess);
+
+  /* -------------------------------------------------------------------- */
+  /*      Is the error at the middle acceptable relative to an            */
+  /*      interpolation of the middle position?                           */
+  /* -------------------------------------------------------------------- */
+  dfDeltaX = (x2[2] - x2[0]) / (x[nPoints - 1] - x[0]);
+  dfDeltaY = (y2[2] - y2[0]) / (x[nPoints - 1] - x[0]);
+
+  dfError = fabs((x2[0] + dfDeltaX * (x[nMiddle] - x[0])) - x2[1]) +
+            fabs((y2[0] + dfDeltaY * (x[nMiddle] - x[0])) - y2[1]);
+
+  if (dfError > psATInfo->dfMaxError) {
+    bSuccess = msApproxTransformer(psATInfo, nMiddle, x, y, panSuccess);
+
+    if (!bSuccess) {
+      return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                          panSuccess);
+    }
+
+    bSuccess = msApproxTransformer(psATInfo, nPoints - nMiddle, x + nMiddle,
+                                   y + nMiddle, panSuccess + nMiddle);
+
+    if (!bSuccess) {
+      return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                          panSuccess);
+    }
+
+    return 1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Error is OK, linearly interpolate all points along line.        */
+  /* -------------------------------------------------------------------- */
+  for (i = nPoints - 1; i >= 0; i--) {
+    dfDist = (x[i] - x[0]);
+    y[i] = y2[0] + dfDeltaY * dfDist;
+    x[i] = x2[0] + dfDeltaX * dfDist;
+    panSuccess[i] = 1;
+  }
+
+  return 1;
+}
+
+/************************************************************************/
+/*                       msTransformMapToSource()                       */
+/*                                                                      */
+/*      Compute the extents of the current map view if transformed      */
+/*      onto the source raster.                                         */
+/************************************************************************/
+
+static int
+msTransformMapToSource(int nDstXSize, int nDstYSize, double *adfDstGeoTransform,
+                       projectionObj *psDstProj, int nSrcXSize, int nSrcYSize,
+                       double *adfInvSrcGeoTransform, projectionObj *psSrcProj,
+                       rectObj *psSrcExtent, int bUseGrid)
+
+{
+  int nFailures = 0;
+
+#define EDGE_STEPS 10
+#define MAX_SIZE ((EDGE_STEPS + 1) * (EDGE_STEPS + 1))
+
+  int i, nSamples = 0, bOutInit = 0;
+  double dfRatio;
+  double x[MAX_SIZE], y[MAX_SIZE];
+
+  /* -------------------------------------------------------------------- */
+  /*      Collect edges in map image pixel/line coordinates               */
+  /* -------------------------------------------------------------------- */
+  if (!bUseGrid) {
+    for (dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0 / EDGE_STEPS)) {
+      assert(nSamples < MAX_SIZE);
+      x[nSamples] = dfRatio * nDstXSize;
+      y[nSamples++] = 0.0;
+      x[nSamples] = dfRatio * nDstXSize;
+      y[nSamples++] = nDstYSize;
+      x[nSamples] = 0.0;
+      y[nSamples++] = dfRatio * nDstYSize;
+      x[nSamples] = nDstXSize;
+      y[nSamples++] = dfRatio * nDstYSize;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Collect a grid in the hopes of a more accurate region.          */
+  /* -------------------------------------------------------------------- */
+  else {
+    double dfRatio2;
+
+    for (dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0 / EDGE_STEPS)) {
+      for (dfRatio2 = 0.0; dfRatio2 <= 1.001; dfRatio2 += (1.0 / EDGE_STEPS)) {
+        assert(nSamples < MAX_SIZE);
+        x[nSamples] = dfRatio2 * nDstXSize;
+        y[nSamples++] = dfRatio * nDstYSize;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      transform to map georeferenced units                            */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < nSamples; i++) {
+    double x_out, y_out;
+
+    x_out = adfDstGeoTransform[0] + x[i] * adfDstGeoTransform[1] +
+            y[i] * adfDstGeoTransform[2];
+
+    y_out = adfDstGeoTransform[3] + x[i] * adfDstGeoTransform[4] +
+            y[i] * adfDstGeoTransform[5];
+
+    x[i] = x_out;
+    y[i] = y_out;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Transform to layer georeferenced coordinates.                   */
+  /* -------------------------------------------------------------------- */
+  if (psDstProj->proj && psSrcProj->proj) {
+    reprojectionObj *reprojector =
+        msProjectCreateReprojector(psDstProj, psSrcProj);
+    if (!reprojector)
+      return MS_FALSE;
+    if (msProjectTransformPoints(reprojector, nSamples, x, y) != MS_SUCCESS) {
+      msProjectDestroyReprojector(reprojector);
+      return MS_FALSE;
+    }
+    msProjectDestroyReprojector(reprojector);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If we just using the edges (not a grid) and we go some          */
+  /*      errors, then we need to restart using a grid pattern.           */
+  /* -------------------------------------------------------------------- */
+  if (!bUseGrid) {
+    for (i = 0; i < nSamples; i++) {
+      if (x[i] == HUGE_VAL || y[i] == HUGE_VAL) {
+        return msTransformMapToSource(
+            nDstXSize, nDstYSize, adfDstGeoTransform, psDstProj, nSrcXSize,
+            nSrcYSize, adfInvSrcGeoTransform, psSrcProj, psSrcExtent, 1);
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      transform to layer raster coordinates, and collect bounds.      */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < nSamples; i++) {
+    double x_out, y_out;
+
+    if (x[i] == HUGE_VAL || y[i] == HUGE_VAL) {
+      nFailures++;
+      continue;
+    }
+
+    x_out = adfInvSrcGeoTransform[0] + x[i] * adfInvSrcGeoTransform[1] +
+            y[i] * adfInvSrcGeoTransform[2];
+    y_out = adfInvSrcGeoTransform[3] + x[i] * adfInvSrcGeoTransform[4] +
+            y[i] * adfInvSrcGeoTransform[5];
+
+    if (!bOutInit) {
+      psSrcExtent->minx = psSrcExtent->maxx = x_out;
+      psSrcExtent->miny = psSrcExtent->maxy = y_out;
+      bOutInit = 1;
+    } else {
+      psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
+      psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
+      psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
+      psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Deal with discontinuities related to lon_wrap=XXX in source     */
+  /*      projection. In that case we must check if the points at         */
+  /*      lon_wrap +/- 180deg are in the output raster.                   */
+  /* -------------------------------------------------------------------- */
+  if (bOutInit && msProjIsGeographicCRS(psSrcProj)) {
+    double dfLonWrap = 0;
+    int bHasLonWrap = msProjectHasLonWrap(psSrcProj, &dfLonWrap);
+
+    if (bHasLonWrap) {
+      double x2[2], y2[2];
+      int nCountY = 0;
+      double dfY = 0.0;
+      double dfXMinOut = 0.0;
+      double dfYMinOut = 0.0;
+      double dfXMaxOut = 0.0;
+      double dfYMaxOut = 0.0;
+      const double dfHalfRes = adfDstGeoTransform[1] / 2;
+
+      /* Find out average y coordinate in src projection */
+      for (i = 0; i < nSamples; i++) {
+        if (y[i] != HUGE_VAL) {
+          dfY += y[i];
+          nCountY++;
+        }
+      }
+      dfY /= nCountY;
+
+      /* Compute bounds of output raster */
+      for (i = 0; i < 4; i++) {
+        double dfX =
+            adfDstGeoTransform[0] +
+            ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[1] +
+            ((i == 1 || i == 3) ? nDstYSize : 0) * adfDstGeoTransform[2];
+        double dfY =
+            adfDstGeoTransform[3] +
+            ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[4] +
+            ((i == 1 || i == 3) ? nDstYSize : 0) * adfDstGeoTransform[5];
+        if (i == 0 || dfX < dfXMinOut)
+          dfXMinOut = dfX;
+        if (i == 0 || dfY < dfYMinOut)
+          dfYMinOut = dfY;
+        if (i == 0 || dfX > dfXMaxOut)
+          dfXMaxOut = dfX;
+        if (i == 0 || dfY > dfYMaxOut)
+          dfYMaxOut = dfY;
+      }
+
+      x2[0] = dfLonWrap - 180 + 1e-7;
+      y2[0] = dfY;
+
+      x2[1] = dfLonWrap + 180 - 1e-7;
+      y2[1] = dfY;
+
+      {
+        reprojectionObj *reprojector =
+            msProjectCreateReprojector(psSrcProj, psDstProj);
+        if (reprojector) {
+          msProjectTransformPoints(reprojector, 2, x2, y2);
+          msProjectDestroyReprojector(reprojector);
+        }
+      }
+
+      if (x2[0] >= dfXMinOut - dfHalfRes && x2[0] <= dfXMaxOut + dfHalfRes &&
+          y2[0] >= dfYMinOut && y2[0] <= dfYMaxOut) {
+        double x_out = adfInvSrcGeoTransform[0] +
+                       (dfLonWrap - 180) * adfInvSrcGeoTransform[1] +
+                       dfY * adfInvSrcGeoTransform[2];
+        double y_out = adfInvSrcGeoTransform[3] +
+                       (dfLonWrap - 180) * adfInvSrcGeoTransform[4] +
+                       dfY * adfInvSrcGeoTransform[5];
+
+        /* Does the raster cover, at least, a whole 360 deg range ? */
+        if (nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360)) {
+          psSrcExtent->minx = 0;
+          psSrcExtent->maxx = nSrcXSize;
+        } else {
+          psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
+          psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
+        }
+        psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
+        psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
+      }
+
+      if (x2[1] >= dfXMinOut - dfHalfRes && x2[1] <= dfXMaxOut + dfHalfRes &&
+          y2[1] >= dfYMinOut && y2[1] <= dfYMaxOut) {
+        double x_out = adfInvSrcGeoTransform[0] +
+                       (dfLonWrap + 180) * adfInvSrcGeoTransform[1] +
+                       dfY * adfInvSrcGeoTransform[2];
+        double y_out = adfInvSrcGeoTransform[3] +
+                       (dfLonWrap + 180) * adfInvSrcGeoTransform[4] +
+                       dfY * adfInvSrcGeoTransform[5];
+
+        /* Does the raster cover, at least, a whole 360 deg range ? */
+        if (nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360)) {
+          psSrcExtent->minx = 0;
+          psSrcExtent->maxx = nSrcXSize;
+        } else {
+          psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
+          psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
+        }
+        psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
+        psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
+      }
+    }
+  }
+
+  if (!bOutInit)
+    return MS_FALSE;
+
+  /* -------------------------------------------------------------------- */
+  /*      If we had some failures, we need to expand the region to        */
+  /*      represent our very coarse sampling grid.                        */
+  /* -------------------------------------------------------------------- */
+  if (nFailures > 0) {
+    int nGrowAmountX =
+        (int)(psSrcExtent->maxx - psSrcExtent->minx) / EDGE_STEPS + 1;
+    int nGrowAmountY =
+        (int)(psSrcExtent->maxy - psSrcExtent->miny) / EDGE_STEPS + 1;
+
+    psSrcExtent->minx = MS_MAX(psSrcExtent->minx - nGrowAmountX, 0);
+    psSrcExtent->miny = MS_MAX(psSrcExtent->miny - nGrowAmountY, 0);
+    psSrcExtent->maxx = MS_MIN(psSrcExtent->maxx + nGrowAmountX, nSrcXSize);
+    psSrcExtent->maxy = MS_MIN(psSrcExtent->maxy + nGrowAmountY, nSrcYSize);
+  }
+
+  return MS_TRUE;
+}
+
+/************************************************************************/
+/*                        msResampleGDALToMap()                         */
+/************************************************************************/
+
+int msResampleGDALToMap(mapObj *map, layerObj *layer, imageObj *image,
+                        rasterBufferObj *rb, GDALDatasetH hDS)
+
+{
+  int nSrcXSize, nSrcYSize, nDstXSize, nDstYSize;
+  int result, bSuccess;
+  double adfSrcGeoTransform[6], adfDstGeoTransform[6];
+  double adfInvSrcGeoTransform[6], dfNominalCellSize;
+  rectObj sSrcExtent = {0}, sOrigSrcExtent;
+  mapObj sDummyMap;
+  imageObj *srcImage;
+  void *pTCBData;
+  void *pACBData;
+  char **papszAlteredProcessing = NULL;
+  int nLoadImgXSize, nLoadImgYSize;
+  double dfOversampleRatio;
+  rasterBufferObj src_rb, *psrc_rb = NULL, *mask_rb = NULL;
+  int bAddPixelMargin = MS_TRUE;
+  int bWrapAtLeftRight = MS_FALSE;
+
+  const char *resampleMode = CSLFetchNameValue(layer->processing, "RESAMPLE");
+
+  if (resampleMode == NULL)
+    resampleMode = "NEAREST";
+
+  if (layer->mask) {
+    int ret, maskLayerIdx;
+    layerObj *maskLayer;
+    maskLayerIdx = msGetLayerIndex(map, layer->mask);
+    if (maskLayerIdx == -1) {
+      msSetError(MS_MISCERR, "Invalid mask layer specified",
+                 "msResampleGDALToMap()");
+      return -1;
+    }
+    maskLayer = GET_LAYER(map, maskLayerIdx);
+    mask_rb = msSmallCalloc(1, sizeof(rasterBufferObj));
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS) {
+      free(mask_rb);
+      return -1;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      We will require source and destination to have a valid          */
+  /*      projection object.                                              */
+  /* -------------------------------------------------------------------- */
+  if (map->projection.proj == NULL || layer->projection.proj == NULL) {
+    if (layer->debug)
+      msDebug("msResampleGDALToMap(): "
+              "Either map or layer projection is NULL, assuming compatible.\n");
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize some information.                                    */
+  /* -------------------------------------------------------------------- */
+  nDstXSize = image->width;
+  nDstYSize = image->height;
+
+  memcpy(adfDstGeoTransform, map->gt.geotransform, sizeof(double) * 6);
+
+  msGetGDALGeoTransform(hDS, map, layer, adfSrcGeoTransform);
+
+  nSrcXSize = GDALGetRasterXSize(hDS);
+  nSrcYSize = GDALGetRasterYSize(hDS);
+
+  InvGeoTransform(adfSrcGeoTransform, adfInvSrcGeoTransform);
+
+  /* -------------------------------------------------------------------- */
+  /*      We need to find the extents in the source layer projection      */
+  /*      of the output requested region.  We will accomplish this by     */
+  /*      collecting the extents of a region around the edge of the       */
+  /*      destination chunk.                                              */
+  /* -------------------------------------------------------------------- */
+  if (CSLFetchBoolean(layer->processing, "LOAD_WHOLE_IMAGE", FALSE))
+    bSuccess = FALSE;
+  else {
+    bSuccess = msTransformMapToSource(nDstXSize, nDstYSize, adfDstGeoTransform,
+                                      &(map->projection), nSrcXSize, nSrcYSize,
+                                      adfInvSrcGeoTransform,
+                                      &(layer->projection), &sSrcExtent, FALSE);
+    if (bSuccess) {
+      /* -------------------------------------------------------------------- */
+      /*      Repeat transformation for a rectangle interior to the output    */
+      /*      requested region.  If the latter results in a more extreme y    */
+      /*      extent, then extend extents in source layer projection to       */
+      /*      southern/northing bounds and entire x extent.                   */
+      /* -------------------------------------------------------------------- */
+      memcpy(&sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent));
+      adfDstGeoTransform[0] = adfDstGeoTransform[0] + adfDstGeoTransform[1];
+      adfDstGeoTransform[3] = adfDstGeoTransform[3] + adfDstGeoTransform[5];
+      bSuccess = msTransformMapToSource(
+          nDstXSize - 2, nDstYSize - 2, adfDstGeoTransform, &(map->projection),
+          nSrcXSize, nSrcYSize, adfInvSrcGeoTransform, &(layer->projection),
+          &sSrcExtent, FALSE);
+      /* Reset this array to its original value! */
+      memcpy(adfDstGeoTransform, map->gt.geotransform, sizeof(double) * 6);
+
+      if (bSuccess) {
+        if (sSrcExtent.maxy > sOrigSrcExtent.maxy ||
+            sSrcExtent.miny < sOrigSrcExtent.miny) {
+          msDebug("msTransformMapToSource(): extending bounds.\n");
+          sOrigSrcExtent.minx = 0;
+          sOrigSrcExtent.maxx = nSrcXSize;
+          if (sSrcExtent.maxy > sOrigSrcExtent.maxy)
+            sOrigSrcExtent.maxy = nSrcYSize;
+          if (sSrcExtent.miny < sOrigSrcExtent.miny)
+            sOrigSrcExtent.miny = 0;
+        }
+      }
+      memcpy(&sSrcExtent, &sOrigSrcExtent, sizeof(sOrigSrcExtent));
+      bSuccess = TRUE;
+    }
+  }
+  /* -------------------------------------------------------------------- */
+  /*      If the transformation failed, it is likely that we have such    */
+  /*      broad extents that the projection transformation failed at      */
+  /*      points around the extents.  If so, we will assume we need       */
+  /*      the whole raster.  This and later assumptions are likely to     */
+  /*      result in the raster being loaded at a higher resolution        */
+  /*      than really needed but should give decent results.              */
+  /* -------------------------------------------------------------------- */
+  if (!bSuccess) {
+    if (layer->debug) {
+      if (CSLFetchBoolean(layer->processing, "LOAD_WHOLE_IMAGE", FALSE))
+        msDebug("msResampleGDALToMap(): "
+                "LOAD_WHOLE_IMAGE set, loading whole image.\n");
+      else
+        msDebug(
+            "msTransformMapToSource(): "
+            "pj_transform() failed.  Out of bounds?  Loading whole image.\n");
+    }
+
+    sSrcExtent.minx = 0;
+    sSrcExtent.maxx = nSrcXSize;
+    sSrcExtent.miny = 0;
+    sSrcExtent.maxy = nSrcYSize;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If requesting at the raster resolution, on pixel boundaries,    */
+  /*      and no reprojection is  involved, we don't need any resampling. */
+  /*      And if they match an integral subsampling factor, no need to    */
+  /*      add pixel margin.                                               */
+  /*      This optimization helps a lot when operating with mode=tile     */
+  /*      and that the underlying raster is tiled and share the same      */
+  /*      tiling scheme as the queried tile mode.                         */
+  /* -------------------------------------------------------------------- */
+#define IS_ALMOST_INTEGER(x, eps) (fabs((x) - (int)((x) + 0.5)) < (eps))
+
+  if (adfSrcGeoTransform[1] > 0.0 && adfSrcGeoTransform[2] == 0.0 &&
+      adfSrcGeoTransform[4] == 0.0 && adfSrcGeoTransform[5] < 0.0 &&
+      IS_ALMOST_INTEGER(sSrcExtent.minx, 0.1) &&
+      IS_ALMOST_INTEGER(sSrcExtent.miny, 0.1) &&
+      IS_ALMOST_INTEGER(sSrcExtent.maxx, 0.1) &&
+      IS_ALMOST_INTEGER(sSrcExtent.maxy, 0.1) &&
+      !msProjectionsDiffer(&(map->projection), &(layer->projection))) {
+    double dfXFactor, dfYFactor;
+
+    sSrcExtent.minx = (int)(sSrcExtent.minx + 0.5);
+    sSrcExtent.miny = (int)(sSrcExtent.miny + 0.5);
+    sSrcExtent.maxx = (int)(sSrcExtent.maxx + 0.5);
+    sSrcExtent.maxy = (int)(sSrcExtent.maxy + 0.5);
+
+    if ((int)(sSrcExtent.maxx - sSrcExtent.minx + 0.5) == nDstXSize &&
+        (int)(sSrcExtent.maxy - sSrcExtent.miny + 0.5) == nDstYSize) {
+      if (layer->debug)
+        msDebug("msResampleGDALToMap(): Request matching raster resolution and "
+                "pixel boundaries. "
+                "No need to do resampling/reprojection.\n");
+      msFree(mask_rb);
+      return msDrawRasterLayerGDAL(map, layer, image, rb, hDS);
+    }
+
+    dfXFactor = (sSrcExtent.maxx - sSrcExtent.minx) / nDstXSize;
+    dfYFactor = (sSrcExtent.maxy - sSrcExtent.miny) / nDstYSize;
+    if (IS_ALMOST_INTEGER(dfXFactor, 1e-5) &&
+        IS_ALMOST_INTEGER(dfYFactor, 1e-5) &&
+        IS_ALMOST_INTEGER(sSrcExtent.minx / dfXFactor, 0.1) &&
+        IS_ALMOST_INTEGER(sSrcExtent.miny / dfXFactor, 0.1) &&
+        IS_ALMOST_INTEGER(sSrcExtent.maxx / dfYFactor, 0.1) &&
+        IS_ALMOST_INTEGER(sSrcExtent.maxy / dfYFactor, 0.1)) {
+      bAddPixelMargin = MS_FALSE;
+      if (layer->debug)
+        msDebug(
+            "msResampleGDALToMap(): Request matching raster resolution "
+            "and pixel boundaries matching an integral subsampling factor\n");
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Project desired extents out by 2 pixels, and then strip to      */
+  /*      available data.                                                 */
+  /* -------------------------------------------------------------------- */
+  memcpy(&sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent));
+
+  if (bAddPixelMargin) {
+    sSrcExtent.minx = floor(sSrcExtent.minx - 1.0);
+    sSrcExtent.maxx = ceil(sSrcExtent.maxx + 1.0);
+    sSrcExtent.miny = floor(sSrcExtent.miny - 1.0);
+    sSrcExtent.maxy = ceil(sSrcExtent.maxy + 1.0);
+  }
+
+  sSrcExtent.minx = MS_MAX(0, sSrcExtent.minx);
+  sSrcExtent.maxx = MS_MIN(sSrcExtent.maxx, nSrcXSize);
+  sSrcExtent.miny = MS_MAX(sSrcExtent.miny, 0);
+  sSrcExtent.maxy = MS_MIN(sSrcExtent.maxy, nSrcYSize);
+
+  if (sSrcExtent.maxx <= sSrcExtent.minx ||
+      sSrcExtent.maxy <= sSrcExtent.miny) {
+    if (layer->debug)
+      msDebug("msResampleGDALToMap(): no overlap ... no result.\n");
+    msFree(mask_rb);
+    return 0;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Determine desired oversampling ratio.  Default to 2.0 if not    */
+  /*      otherwise set.                                                  */
+  /* -------------------------------------------------------------------- */
+  dfOversampleRatio = 2.0;
+
+  if (CSLFetchNameValue(layer->processing, "OVERSAMPLE_RATIO") != NULL) {
+    dfOversampleRatio =
+        atof(CSLFetchNameValue(layer->processing, "OVERSAMPLE_RATIO"));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Decide on a resolution to read from the source image at.  We    */
+  /*      will operate from full resolution data, if we are requesting    */
+  /*      at near to full resolution.  Otherwise we will read the data    */
+  /*      at twice the resolution of the eventual map.                    */
+  /* -------------------------------------------------------------------- */
+  dfNominalCellSize = sqrt(adfSrcGeoTransform[1] * adfSrcGeoTransform[1] +
+                           adfSrcGeoTransform[2] * adfSrcGeoTransform[2]);
+
+  /* Check first that the requested extent is not well beyond than the source */
+  /* raster. This might be the case for example if asking to visualize */
+  /* -180,-89,180,90 in EPSG:4326 from a raster in Arctic Polar Stereographic */
+  /* But restrict that to rasters of modest size, otherwise we may end up */
+  /* requesting very large dimensions in other legit reprojection cases */
+  /* See https://github.com/mapserver/mapserver/issues/5402 */
+  if (!(sOrigSrcExtent.minx <= -4 * nSrcXSize &&
+        sOrigSrcExtent.miny <= -4 * nSrcYSize &&
+        sOrigSrcExtent.maxx >= 5 * nSrcXSize &&
+        sOrigSrcExtent.maxy >= 5 * nSrcYSize && nSrcXSize < 4000 &&
+        nSrcYSize < 4000) &&
+      (sOrigSrcExtent.maxx - sOrigSrcExtent.minx) >
+          dfOversampleRatio * nDstXSize &&
+      !CSLFetchBoolean(layer->processing, "LOAD_FULL_RES_IMAGE", FALSE))
+    sDummyMap.cellsize =
+        (dfNominalCellSize * (sOrigSrcExtent.maxx - sOrigSrcExtent.minx)) /
+        (dfOversampleRatio * nDstXSize);
+  else
+    sDummyMap.cellsize = dfNominalCellSize;
+
+  nLoadImgXSize = MS_MAX(1, (int)(sSrcExtent.maxx - sSrcExtent.minx) *
+                                (dfNominalCellSize / sDummyMap.cellsize));
+  nLoadImgYSize = MS_MAX(1, (int)(sSrcExtent.maxy - sSrcExtent.miny) *
+                                (dfNominalCellSize / sDummyMap.cellsize));
+
+  /*
+  ** Because the previous calculation involved some round off, we need
+  ** to fixup the cellsize to ensure the map region represents the whole
+  ** RAW_WINDOW (at least in X).  Re: bug 1715.
+  */
+  sDummyMap.cellsize =
+      ((sSrcExtent.maxx - sSrcExtent.minx) * dfNominalCellSize) / nLoadImgXSize;
+
+  if (layer->debug)
+    msDebug("msResampleGDALToMap in effect: cellsize = %f\n",
+            sDummyMap.cellsize);
+
+  adfSrcGeoTransform[0] += +adfSrcGeoTransform[1] * sSrcExtent.minx +
+                           adfSrcGeoTransform[2] * sSrcExtent.miny;
+  adfSrcGeoTransform[1] *= (sDummyMap.cellsize / dfNominalCellSize);
+  adfSrcGeoTransform[2] *= (sDummyMap.cellsize / dfNominalCellSize);
+
+  adfSrcGeoTransform[3] += +adfSrcGeoTransform[4] * sSrcExtent.minx +
+                           adfSrcGeoTransform[5] * sSrcExtent.miny;
+  adfSrcGeoTransform[4] *= (sDummyMap.cellsize / dfNominalCellSize);
+  adfSrcGeoTransform[5] *= (sDummyMap.cellsize / dfNominalCellSize);
+
+  /* In the non-rotated case, make sure that the geotransform exactly */
+  /* matches the sSrcExtent, even if that generates non-square pixels (#1715) */
+  /* The rotated case should ideally be dealt with, but not for now... */
+  if (adfSrcGeoTransform[2] == 0 && adfSrcGeoTransform[4] == 0 &&
+      adfSrcGeoTransform[5] < 0 &&
+      /* But do that only if the pixels were square before, otherwise */
+      /* this is going to mess with source rasters whose pixels aren't at */
+      /* all square (#5445) */
+      fabs(fabs(adfSrcGeoTransform[1]) - fabs(adfSrcGeoTransform[5])) <
+          0.01 * fabs(adfSrcGeoTransform[1])) {
+    adfSrcGeoTransform[1] =
+        (sSrcExtent.maxx - sSrcExtent.minx) * dfNominalCellSize / nLoadImgXSize;
+    adfSrcGeoTransform[5] = -(sSrcExtent.maxy - sSrcExtent.miny) *
+                            dfNominalCellSize / nLoadImgYSize;
+  }
+
+  papszAlteredProcessing = CSLDuplicate(layer->processing);
+  papszAlteredProcessing = CSLSetNameValue(
+      papszAlteredProcessing, "RAW_WINDOW",
+      CPLSPrintf("%d %d %d %d", (int)sSrcExtent.minx, (int)sSrcExtent.miny,
+                 (int)(sSrcExtent.maxx - sSrcExtent.minx),
+                 (int)(sSrcExtent.maxy - sSrcExtent.miny)));
+
+  /* -------------------------------------------------------------------- */
+  /*      We clone this without referencing it knowing that the           */
+  /*      srcImage will take a reference on it.  The sDummyMap is         */
+  /*      destroyed off the stack, so the missing map reference is        */
+  /*      never a problem.  The image's dereference of the                */
+  /*      outputformat during the msFreeImage() calls will result in      */
+  /*      the output format being cleaned up.                             */
+  /*                                                                      */
+  /*      We make a copy so we can easily modify the outputformat used    */
+  /*      for the temporary image to include transparentency support.     */
+  /* -------------------------------------------------------------------- */
+  sDummyMap.outputformat = msCloneOutputFormat(image->format);
+  sDummyMap.width = nLoadImgXSize;
+  sDummyMap.height = nLoadImgYSize;
+  sDummyMap.mappath = map->mappath;
+  sDummyMap.shapepath = map->shapepath;
+
+  /* -------------------------------------------------------------------- */
+  /*      If we are working in 256 color GD mode, allocate 0 as the       */
+  /*      transparent color on the temporary image so it will be          */
+  /*      initialized to see-through.  We pick an arbitrary rgb tuple     */
+  /*      as our transparent color, but ensure it is initalized in the    */
+  /*      map so that normal transparent avoidance will apply.            */
+  /* -------------------------------------------------------------------- */
+  if (MS_RENDERER_PLUGIN(sDummyMap.outputformat)) {
+    assert(rb);
+    msInitializeRendererVTable(sDummyMap.outputformat);
+    assert(sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGB ||
+           sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGBA);
+
+    sDummyMap.outputformat->transparent = MS_TRUE;
+    sDummyMap.outputformat->imagemode = MS_IMAGEMODE_RGBA;
+    MS_INIT_COLOR(sDummyMap.imagecolor, -1, -1, -1, 255);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup a dummy map object we can use to read from the source     */
+  /*      raster, with the newly established extents, and resolution.     */
+  /* -------------------------------------------------------------------- */
+  srcImage = msImageCreate(nLoadImgXSize, nLoadImgYSize, sDummyMap.outputformat,
+                           NULL, NULL, map->resolution, map->defresolution,
+                           &(sDummyMap.imagecolor));
+
+  if (srcImage == NULL) {
+    msFree(mask_rb);
+    return -1; /* msSetError() should have been called already */
+  }
+
+  if (MS_RENDERER_PLUGIN(srcImage->format)) {
+    psrc_rb = &src_rb;
+    memset(psrc_rb, 0, sizeof(rasterBufferObj));
+    if (srcImage->format->vtable->supports_pixel_buffer) {
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      srcImage->format->vtable->getRasterBufferHandle(
+                          srcImage, psrc_rb))) {
+        msFree(mask_rb);
+        return -1;
+      }
+    } else {
+      if (MS_UNLIKELY(
+              MS_FAILURE ==
+              srcImage->format->vtable->initializeRasterBuffer(
+                  psrc_rb, nLoadImgXSize, nLoadImgYSize, MS_IMAGEMODE_RGBA))) {
+        msFree(mask_rb);
+        return -1;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Draw into the temporary image.  Temporarily replace the         */
+  /*      layer processing directive so that we use our RAW_WINDOW.       */
+  /* -------------------------------------------------------------------- */
+  {
+    char **papszSavedProcessing = layer->processing;
+    char *origMask = layer->mask;
+    layer->mask = NULL;
+    layer->processing = papszAlteredProcessing;
+
+    result = msDrawRasterLayerGDAL(&sDummyMap, layer, srcImage, psrc_rb, hDS);
+
+    layer->processing = papszSavedProcessing;
+    layer->mask = origMask;
+    CSLDestroy(papszAlteredProcessing);
+
+    if (result) {
+      if (MS_RENDERER_PLUGIN(srcImage->format) &&
+          !srcImage->format->vtable->supports_pixel_buffer)
+        msFreeRasterBuffer(psrc_rb);
+
+      msFreeImage(srcImage);
+      msFree(mask_rb);
+
+      return result;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup transformations between our source image, and the         */
+  /*      target map image.                                               */
+  /* -------------------------------------------------------------------- */
+  pTCBData = msInitProjTransformer(&(layer->projection), adfSrcGeoTransform,
+                                   &(map->projection), adfDstGeoTransform);
+
+  if (pTCBData == NULL) {
+    if (layer->debug)
+      msDebug("msInitProjTransformer() returned NULL.\n");
+    if (MS_RENDERER_PLUGIN(srcImage->format) &&
+        !srcImage->format->vtable->supports_pixel_buffer)
+      msFreeRasterBuffer(psrc_rb);
+    msFreeImage(srcImage);
+    msFree(mask_rb);
+    return MS_PROJERR;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      It is cheaper to use linear approximations as long as our       */
+  /*      error is modest (less than 0.333 pixels).                       */
+  /* -------------------------------------------------------------------- */
+  pACBData = msInitApproxTransformer(msProjTransformer, pTCBData, 0.333);
+
+  if (msProjIsGeographicCRS(&(layer->projection))) {
+    /* Does the raster cover a whole 360 deg range ? */
+    if (nSrcXSize == (int)(adfInvSrcGeoTransform[1] * 360 + 0.5))
+      bWrapAtLeftRight = MS_TRUE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Perform the resampling.                                         */
+  /* -------------------------------------------------------------------- */
+  if (EQUAL(resampleMode, "AVERAGE"))
+    result = msAverageRasterResampler(srcImage, psrc_rb, image, rb,
+                                      msApproxTransformer, pACBData,
+                                      layer->debug, mask_rb);
+  else if (EQUAL(resampleMode, "BILINEAR"))
+    result = msBilinearRasterResampler(srcImage, psrc_rb, image, rb,
+                                       msApproxTransformer, pACBData,
+                                       layer->debug, mask_rb, bWrapAtLeftRight);
+  else
+    result = msNearestRasterResampler(srcImage, psrc_rb, image, rb,
+                                      msApproxTransformer, pACBData,
+                                      layer->debug, mask_rb, bWrapAtLeftRight);
+
+  /* -------------------------------------------------------------------- */
+  /*      cleanup                                                         */
+  /* -------------------------------------------------------------------- */
+  msFree(mask_rb);
+  if (MS_RENDERER_PLUGIN(srcImage->format) &&
+      !srcImage->format->vtable->supports_pixel_buffer)
+    msFreeRasterBuffer(psrc_rb);
+  msFreeImage(srcImage);
+
+  msFreeProjTransformer(pTCBData);
+  msFreeApproxTransformer(pACBData);
+
+  return result;
+}
diff -pruN 8.0.1-5/src/mapresample.h 8.2.0~beta1-1~exp1/src/mapresample.h
--- 8.0.1-5/src/mapresample.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapresample.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,51 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  CFS OGC MapServer
+ * Purpose:  Definitions related to raster resampling support.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 2001, Frank Warmerdam, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef RESAMPLE_H
+#define RESAMPLE_H
+
+#include "mapserver.h"
+#include "mapproject.h"
+
+#include <gdal.h>
+#include <cpl_string.h>
+
+typedef int (*SimpleTransformer)(void *pCBData, int nPoints, double *x,
+                                 double *y, int *panSuccess);
+
+void *msInitProjTransformer(projectionObj *psSrc, double *padfSrcGeoTransform,
+                            projectionObj *psDst, double *padfDstGeoTransform);
+void msFreeProjTransformer(void *);
+int msProjTransformer(void *pCBData, int nPoints, double *x, double *y,
+                      int *panSuccess);
+
+int msResampleGDALToMap(mapObj *map, layerObj *layer, imageObj *image,
+                        rasterBufferObj *rb, GDALDatasetH hDS);
+
+#endif /* ndef RESAMPLE_H */
diff -pruN 8.0.1-5/src/mapscale.c 8.2.0~beta1-1~exp1/src/mapscale.c
--- 8.0.1-5/src/mapscale.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscale.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,657 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Scale object rendering.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#define VMARGIN 3 /* buffer around the scalebar */
+#define HMARGIN 3
+#define VSPACING .8 /* spacing (% of font height) between scalebar and text */
+#define VSLOP 5     /* makes things fit a bit better vertically */
+
+/*
+** Match this with with unit enumerations is mapserver.h
+*/
+static char *unitText[9] = {
+    "in", "ft", "mi", "m", "km",
+    "dd", "??", "??", "NM"}; /* MS_PIXEL and MS_PERCENTAGE not used */
+double inchesPerUnit[9] = {1,       12, 63360.0, 39.3701,   39370.1,
+                           4374754, 1,  1,       72913.3858};
+
+static double roundInterval(double d) {
+  if (d < .001)
+    return (MS_NINT(d * 10000) / 10000.0);
+  if (d < .01)
+    return (MS_NINT(d * 1000) / 1000.0);
+  if (d < .1)
+    return (MS_NINT(d * 100) / 100.0);
+  if (d < 1)
+    return (MS_NINT(d * 10) / 10.0);
+  if (d < 100)
+    return (MS_NINT(d));
+  if (d < 1000)
+    return (MS_NINT(d / 10) * 10);
+  if (d < 10000)
+    return (MS_NINT(d / 100) * 100);
+  if (d < 100000)
+    return (MS_NINT(d / 1000) * 1000);
+  if (d < 1000000)
+    return (MS_NINT(d / 10000) * 10000);
+  if (d < 10000000)
+    return (MS_NINT(d / 100000) * 100000);
+  if (d < 100000000)
+    return (MS_NINT(d / 1000000) * 1000000);
+
+  return (-1);
+}
+
+/*
+** Calculate the approximate scale based on a few parameters. Note that this
+*assumes the scale is
+** the same in the x direction as in the y direction, so run msAdjustExtent(...)
+*first.
+*/
+int msCalculateScale(rectObj extent, int units, int width, int height,
+                     double resolution, double *scale) {
+  double md, gd, center_y;
+
+  /* if((extent.maxx == extent.minx) || (extent.maxy == extent.miny))   */
+  if (!MS_VALID_EXTENT(extent)) {
+    msSetError(MS_MISCERR,
+               "Invalid image extent, minx=%lf, miny=%lf, maxx=%lf, maxy=%lf.",
+               "msCalculateScale()", extent.minx, extent.miny, extent.maxx,
+               extent.maxy);
+    return (MS_FAILURE);
+  }
+
+  if ((width <= 0) || (height <= 0)) {
+    msSetError(MS_MISCERR, "Invalid image width or height.",
+               "msCalculateScale()");
+    return (MS_FAILURE);
+  }
+
+  switch (units) {
+  case (MS_DD):
+  case (MS_METERS):
+  case (MS_KILOMETERS):
+  case (MS_MILES):
+  case (MS_NAUTICALMILES):
+  case (MS_INCHES):
+  case (MS_FEET):
+    center_y = (extent.miny + extent.maxy) / 2.0;
+    md = (width - 1) /
+         (resolution *
+          msInchesPerUnit(
+              units, center_y)); /* remember, we use a pixel-center to
+                                    pixel-center extent, hence the width-1 */
+    gd = extent.maxx - extent.minx;
+    *scale = gd / md;
+    break;
+  default:
+    *scale = -1; /* this is not an error */
+    break;
+  }
+
+  return (MS_SUCCESS);
+}
+
+double msInchesPerUnit(int units, double center_lat) {
+  (void)center_lat;
+  double lat_adj = 1.0, ipu = 1.0;
+
+  switch (units) {
+  case (MS_METERS):
+  case (MS_KILOMETERS):
+  case (MS_MILES):
+  case (MS_NAUTICALMILES):
+  case (MS_INCHES):
+  case (MS_FEET):
+    ipu = inchesPerUnit[units];
+    break;
+  case (MS_DD):
+    /* With geographical (DD) coordinates, we adjust the inchesPerUnit
+     * based on the latitude of the center of the view. For this we assume
+     * we have a perfect sphere and just use cos(lat) in our calculation.
+     */
+#ifdef ENABLE_VARIABLE_INCHES_PER_DEGREE
+    if (center_lat != 0.0) {
+      double cos_lat;
+      cos_lat = cos(MS_PI * center_lat / 180.0);
+      lat_adj = sqrt(1 + cos_lat * cos_lat) / sqrt(2.0);
+    }
+#endif
+    ipu = inchesPerUnit[units] * lat_adj;
+    break;
+  default:
+    break;
+  }
+
+  return ipu;
+}
+
+#define X_STEP_SIZE 5
+
+imageObj *msDrawScalebar(mapObj *map) {
+  int status;
+  char label[32];
+  double i, msx;
+  int j;
+  int isx, sx, sy, ox, oy, state, dsx;
+  pointObj p;
+  rectObj r;
+  imageObj *image = NULL;
+  double fontWidth, fontHeight;
+  outputFormatObj *format = NULL;
+  strokeStyleObj strokeStyle = {0};
+  shapeObj shape;
+  lineObj line;
+  pointObj points[5];
+  textSymbolObj ts;
+  rendererVTableObj *renderer;
+
+  strokeStyle.patternlength = 0;
+  initTextSymbol(&ts);
+
+  if ((int)map->units == -1) {
+    msSetError(MS_MISCERR, "Map units not set.", "msDrawScalebar()");
+    return (NULL);
+  }
+
+  renderer = MS_MAP_RENDERER(map);
+  if (!renderer || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
+    msSetError(MS_MISCERR, "Outputformat not supported for scalebar",
+               "msDrawScalebar()");
+    return (NULL);
+  }
+
+  msPopulateTextSymbolForLabelAndString(
+      &ts, &map->scalebar.label, msStrdup("0123456789"), 1.0,
+      map->resolution / map->defresolution, 0);
+
+  /*
+   *  A string containing the ten decimal digits is rendered to compute an
+   * average cell size for each number, which is used later to place labels on
+   * the scalebar.
+   */
+
+  if (msGetTextSymbolSize(map, &ts, &r) != MS_SUCCESS) {
+    return NULL;
+  }
+  fontWidth = (r.maxx - r.minx) / 10.0;
+  fontHeight = r.maxy - r.miny;
+
+  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+  status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                            map->resolution, &map->scaledenom);
+  if (status != MS_SUCCESS) {
+    return (NULL);
+  }
+  dsx = map->scalebar.width - 2 * HMARGIN;
+  do {
+    msx = (map->cellsize * dsx) / (msInchesPerUnit(map->scalebar.units, 0) /
+                                   msInchesPerUnit(map->units, 0));
+    i = roundInterval(msx / map->scalebar.intervals);
+    snprintf(label, sizeof(label), "%g",
+             map->scalebar.intervals * i); /* last label */
+    isx = MS_NINT((i / (msInchesPerUnit(map->units, 0) /
+                        msInchesPerUnit(map->scalebar.units, 0))) /
+                  map->cellsize);
+    sx = (map->scalebar.intervals * isx) +
+         MS_NINT((1.5 + strlen(label) / 2.0 +
+                  strlen(unitText[map->scalebar.units])) *
+                 fontWidth);
+
+    if (sx <= (map->scalebar.width - 2 * HMARGIN))
+      break; /* it will fit */
+
+    dsx -= X_STEP_SIZE; /* change the desired size in hopes that it will fit in
+                           user supplied width */
+  } while (1);
+
+  sy = (2 * VMARGIN) + MS_NINT(VSPACING * fontHeight) + fontHeight +
+       map->scalebar.height - VSLOP;
+
+  /*Ensure we have an image format representing the options for the scalebar.*/
+  msApplyOutputFormat(&format, map->outputformat, map->scalebar.transparent);
+
+  if (map->scalebar.transparent == MS_OFF) {
+    if (!MS_VALID_COLOR(map->scalebar.imagecolor))
+      MS_INIT_COLOR(map->scalebar.imagecolor, 255, 255, 255, 255);
+  }
+  image = msImageCreate(map->scalebar.width, sy, format, map->web.imagepath,
+                        map->web.imageurl, map->resolution, map->defresolution,
+                        &map->scalebar.imagecolor);
+
+  /* did we succeed in creating the image? */
+  if (!image) {
+    msSetError(MS_MISCERR, "Unable to initialize image.", "msDrawScalebar()");
+    return NULL;
+  }
+  image->map = map;
+
+  /* drop this reference to output format */
+  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
+
+  switch (map->scalebar.align) {
+  case (MS_ALIGN_LEFT):
+    ox = HMARGIN;
+    break;
+  case (MS_ALIGN_RIGHT):
+    ox = MS_NINT((map->scalebar.width - sx) + fontWidth);
+    break;
+  default:
+    ox = MS_NINT((map->scalebar.width - sx) / 2.0 +
+                 fontWidth / 2.0); /* center the computed scalebar */
+  }
+  oy = VMARGIN;
+
+  switch (map->scalebar.style) {
+  case (0): {
+
+    line.numpoints = 5;
+    line.point = points;
+    shape.line = &line;
+    shape.numlines = 1;
+    if (MS_VALID_COLOR(map->scalebar.color)) {
+      INIT_STROKE_STYLE(strokeStyle);
+      strokeStyle.color = &map->scalebar.outlinecolor;
+      strokeStyle.color->alpha = 255;
+      strokeStyle.width = 1;
+    }
+    map->scalebar.backgroundcolor.alpha = 255;
+    map->scalebar.color.alpha = 255;
+    state = 1; /* 1 means filled */
+    for (j = 0; j < map->scalebar.intervals; j++) {
+      points[0].x = points[4].x = points[3].x = ox + j * isx + 0.5;
+      points[0].y = points[4].y = points[1].y = oy + 0.5;
+      points[1].x = points[2].x = ox + (j + 1) * isx + 0.5;
+      points[2].y = points[3].y = oy + map->scalebar.height + 0.5;
+      if (state == 1 && MS_VALID_COLOR(map->scalebar.color))
+        status = renderer->renderPolygon(image, &shape, &map->scalebar.color);
+      else if (MS_VALID_COLOR(map->scalebar.backgroundcolor))
+        status = renderer->renderPolygon(image, &shape,
+                                         &map->scalebar.backgroundcolor);
+
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        goto scale_cleanup;
+      }
+
+      if (strokeStyle.color) {
+        status = renderer->renderLine(image, &shape, &strokeStyle);
+
+        if (MS_UNLIKELY(status == MS_FAILURE)) {
+          goto scale_cleanup;
+        }
+      }
+
+      sprintf(label, "%g", j * i);
+      map->scalebar.label.position = MS_CC;
+      p.x = ox + j * isx; /* + MS_NINT(fontPtr->w/2); */
+      p.y = oy + map->scalebar.height + MS_NINT(VSPACING * fontHeight);
+      status = msDrawLabel(map, image, p, msStrdup(label), &map->scalebar.label,
+                           1.0);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        goto scale_cleanup;
+      }
+      state = -state;
+    }
+    sprintf(label, "%g", j * i);
+    ox = ox + j * isx - MS_NINT((strlen(label) * fontWidth) / 2.0);
+    sprintf(label, "%g %s", j * i, unitText[map->scalebar.units]);
+    map->scalebar.label.position = MS_CR;
+    p.x = ox; /* + MS_NINT(fontPtr->w/2); */
+    p.y = oy + map->scalebar.height + MS_NINT(VSPACING * fontHeight);
+    status =
+        msDrawLabel(map, image, p, msStrdup(label), &map->scalebar.label, 1.0);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      goto scale_cleanup;
+    }
+    break;
+  }
+  case (1): {
+    line.numpoints = 2;
+    line.point = points;
+    shape.line = &line;
+    shape.numlines = 1;
+    if (MS_VALID_COLOR(map->scalebar.color)) {
+      strokeStyle.width = 1;
+      strokeStyle.color = &map->scalebar.color;
+    }
+
+    points[0].y = points[1].y = oy;
+    points[0].x = ox;
+    points[1].x = ox + isx * map->scalebar.intervals;
+    status = renderer->renderLine(image, &shape, &strokeStyle);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      goto scale_cleanup;
+    }
+
+    points[0].y = oy;
+    points[1].y = oy + map->scalebar.height;
+    p.y = oy + map->scalebar.height + MS_NINT(VSPACING * fontHeight);
+    for (j = 0; j <= map->scalebar.intervals; j++) {
+      points[0].x = points[1].x = ox + j * isx;
+      status = renderer->renderLine(image, &shape, &strokeStyle);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        goto scale_cleanup;
+      }
+
+      sprintf(label, "%g", j * i);
+      if (j != map->scalebar.intervals) {
+        map->scalebar.label.position = MS_CC;
+        p.x = ox + j * isx; /* + MS_NINT(fontPtr->w/2); */
+      } else {
+        sprintf(label, "%g %s", j * i, unitText[map->scalebar.units]);
+        map->scalebar.label.position = MS_CR;
+        p.x = ox + j * isx - MS_NINT((strlen(label) * fontWidth) / 2.0);
+      }
+      status = msDrawLabel(map, image, p, msStrdup(label), &map->scalebar.label,
+                           1.0);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        goto scale_cleanup;
+      }
+    }
+    break;
+  }
+  default:
+    msSetError(MS_MISCERR, "Unsupported scalebar style.", "msDrawScalebar()");
+    return (NULL);
+  }
+
+scale_cleanup:
+  freeTextSymbol(&ts);
+  if (MS_UNLIKELY(status == MS_FAILURE)) {
+    msFreeImage(image);
+    return NULL;
+  }
+  return (image);
+}
+
+int msEmbedScalebar(mapObj *map, imageObj *img) {
+  int l, index, s, status = MS_SUCCESS;
+  pointObj point;
+  imageObj *image = NULL;
+  rendererVTableObj *renderer;
+  symbolObj *embededSymbol;
+  char *imageType = NULL;
+
+  index = msGetSymbolIndex(&(map->symbolset), "scalebar", MS_FALSE);
+  if (index != -1)
+    msRemoveSymbol(&(map->symbolset),
+                   index); /* remove cached symbol in case the function is
+   called multiple times with different zoom levels */
+
+  if ((embededSymbol = msGrowSymbolSet(&map->symbolset)) == NULL)
+    return MS_FAILURE;
+
+  s = map->symbolset.numsymbols;
+  map->symbolset.numsymbols++;
+
+  if (!MS_RENDERER_PLUGIN(map->outputformat) ||
+      !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
+    imageType = msStrdup(map->imagetype); /* save format */
+    if MS_DRIVER_CAIRO (map->outputformat)
+      map->outputformat = msSelectOutputFormat(map, "cairopng");
+    else
+      map->outputformat = msSelectOutputFormat(map, "png");
+
+    msInitializeRendererVTable(map->outputformat);
+  }
+  renderer = MS_MAP_RENDERER(map);
+
+  image = msDrawScalebar(map);
+
+  if (imageType) {
+    map->outputformat =
+        msSelectOutputFormat(map, imageType); /* restore format */
+    msFree(imageType);
+  }
+
+  if (!image) {
+    return MS_FAILURE;
+  }
+  embededSymbol->pixmap_buffer = calloc(1, sizeof(rasterBufferObj));
+  MS_CHECK_ALLOC(embededSymbol->pixmap_buffer, sizeof(rasterBufferObj),
+                 MS_FAILURE);
+
+  if (MS_SUCCESS !=
+      renderer->getRasterBufferCopy(image, embededSymbol->pixmap_buffer)) {
+    return MS_FAILURE;
+  }
+
+  embededSymbol->type = MS_SYMBOL_PIXMAP; /* intialize a few things */
+  embededSymbol->name = msStrdup("scalebar");
+  embededSymbol->sizex = embededSymbol->pixmap_buffer->width;
+  embededSymbol->sizey = embededSymbol->pixmap_buffer->height;
+  if (map->scalebar.transparent) {
+    embededSymbol->transparent = MS_TRUE;
+    embededSymbol->transparentcolor = 0;
+  }
+
+  switch (map->scalebar.position) {
+  case (MS_LL):
+    point.x = MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) +
+              map->scalebar.offsetx;
+    point.y = map->height -
+              MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) -
+              map->scalebar.offsety;
+    break;
+  case (MS_LR):
+    point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) -
+              map->scalebar.offsetx;
+    point.y = map->height -
+              MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) -
+              map->scalebar.offsety;
+    break;
+  case (MS_LC):
+    point.x = MS_NINT(map->width / 2.0) + map->scalebar.offsetx;
+    point.y = map->height -
+              MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) -
+              map->scalebar.offsety;
+    break;
+  case (MS_UR):
+    point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) -
+              map->scalebar.offsetx;
+    point.y = MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) +
+              map->scalebar.offsety;
+    break;
+  case (MS_UL):
+    point.x = MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) +
+              map->scalebar.offsetx;
+    point.y = MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) +
+              map->scalebar.offsety;
+    break;
+  case (MS_UC):
+    point.x = MS_NINT(map->width / 2.0) + map->scalebar.offsetx;
+    point.y = MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) +
+              map->scalebar.offsety;
+    break;
+  }
+
+  l = msGetLayerIndex(map, "__embed__scalebar");
+  if (l == -1) {
+    if (msGrowMapLayers(map) == NULL)
+      return (-1);
+    l = map->numlayers;
+    map->numlayers++;
+    if (initLayer((GET_LAYER(map, l)), map) == -1)
+      return (-1);
+    GET_LAYER(map, l)->name = msStrdup("__embed__scalebar");
+    GET_LAYER(map, l)->type = MS_LAYER_POINT;
+
+    if (msGrowLayerClasses(GET_LAYER(map, l)) == NULL)
+      return (-1);
+
+    if (initClass(GET_LAYER(map, l)->class[0]) == -1)
+      return (-1);
+    GET_LAYER(map, l)->numclasses = 1; /* so we make sure to free it */
+
+    /* update the layer order list with the layer's index. */
+    map->layerorder[l] = l;
+  }
+
+  GET_LAYER(map, l)->status = MS_ON;
+  if (map->scalebar.postlabelcache) { /* add it directly to the image */
+    if (msMaybeAllocateClassStyle(GET_LAYER(map, l)->class[0], 0) == MS_FAILURE)
+      return MS_FAILURE;
+    GET_LAYER(map, l)->class[0]->styles[0]->symbol = s;
+    status = msDrawMarkerSymbol(map, img, &point,
+                                GET_LAYER(map, l)->class[0] -> styles[0], 1.0);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      goto embed_cleanup;
+    }
+  } else {
+    if (!GET_LAYER(map, l)->class[0] -> labels) {
+      if (msGrowClassLabels(GET_LAYER(map, l)->class[0]) == NULL)
+        return MS_FAILURE;
+      initLabel(GET_LAYER(map, l)->class[0] -> labels[0]);
+      GET_LAYER(map, l)->class[0]->numlabels = 1;
+      GET_LAYER(map, l)->class[0]->labels[0]->force = MS_TRUE;
+      GET_LAYER(map, l)->class[0]->labels[0]->size =
+          MS_MEDIUM; /* must set a size to have a valid label definition */
+      GET_LAYER(map, l)->class[0]->labels[0]->priority = MS_MAX_LABEL_PRIORITY;
+    }
+    if (GET_LAYER(map, l)->class[0] -> labels[0] -> numstyles == 0) {
+      if (msGrowLabelStyles(GET_LAYER(map, l)->class[0] -> labels[0]) == NULL)
+        return (MS_FAILURE);
+      GET_LAYER(map, l)->class[0]->labels[0]->numstyles = 1;
+      initStyle(GET_LAYER(map, l)->class[0] -> labels[0] -> styles[0]);
+      GET_LAYER(map, l)->class[0]->labels[0]->styles[0]->_geomtransform.type =
+          MS_GEOMTRANSFORM_LABELPOINT;
+    }
+    GET_LAYER(map, l)->class[0]->labels[0]->styles[0]->symbol = s;
+    status = msAddLabel(map, img, GET_LAYER(map, l)->class[0] -> labels[0], l,
+                        0, NULL, &point, -1, NULL);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      goto embed_cleanup;
+    }
+  }
+
+embed_cleanup:
+  /* Mark layer as deleted so that it doesn't interfere with html legends or
+   * with saving maps */
+  GET_LAYER(map, l)->status = MS_DELETE;
+
+  msFreeImage(image);
+  return status;
+}
+
+/************************************************************************/
+/* These two functions are used in PHP/Mapscript and Swig/Mapscript     */
+/************************************************************************/
+
+/************************************************************************/
+/*  double GetDeltaExtentsUsingScale(double scale, int units,           */
+/*                                   double centerLat, int width,       */
+/*                                   double resolution)                 */
+/*                                                                      */
+/*      Utility function to return the maximum extent using the         */
+/*      scale and the width of the image.                               */
+/*                                                                      */
+/*      Base on the function msCalculateScale (mapscale.c)              */
+/************************************************************************/
+double GetDeltaExtentsUsingScale(double scale, int units, double centerLat,
+                                 int width, double resolution) {
+  double md = 0.0;
+  double dfDelta = -1.0;
+
+  if (scale <= 0 || width <= 0)
+    return -1;
+
+  switch (units) {
+  case (MS_DD):
+  case (MS_METERS):
+  case (MS_KILOMETERS):
+  case (MS_MILES):
+  case (MS_NAUTICALMILES):
+  case (MS_INCHES):
+  case (MS_FEET):
+    /* remember, we use a pixel-center to pixel-center extent, hence the width-1
+     */
+    md = (width - 1) / (resolution * msInchesPerUnit(units, centerLat));
+    dfDelta = md * scale;
+    break;
+
+  default:
+    break;
+  }
+
+  return dfDelta;
+}
+
+/************************************************************************/
+/*    static double Pix2Georef(int nPixPos, int nPixMin, double nPixMax,*/
+/*                              double dfGeoMin, double dfGeoMax,       */
+/*                              bool bULisYOrig)                        */
+/*                                                                      */
+/*      Utility function to convert a pixel pos to georef pos. If       */
+/*      bULisYOrig parameter is set to true then the upper left is      */
+/*      considered to be the Y origin.                                  */
+/*                                                                      */
+/************************************************************************/
+double Pix2Georef(int nPixPos, int nPixMin, int nPixMax, double dfGeoMin,
+                  double dfGeoMax, int bULisYOrig) {
+  double dfPosGeo = 0.0;
+
+  const double dfWidthGeo = dfGeoMax - dfGeoMin;
+  const int nWidthPix = nPixMax - nPixMin;
+
+  if (dfWidthGeo > 0.0 && nWidthPix > 0) {
+    const double dfPixToGeo = dfWidthGeo / (double)nWidthPix;
+
+    int nDeltaPix;
+    if (!bULisYOrig)
+      nDeltaPix = nPixPos - nPixMin;
+    else
+      nDeltaPix = nPixMax - nPixPos;
+
+    const double dfDeltaGeo = nDeltaPix * dfPixToGeo;
+
+    dfPosGeo = dfGeoMin + dfDeltaGeo;
+  }
+  return (dfPosGeo);
+}
+
+/* This function converts a pixel value in geo ref. The return value is in
+ * layer units. This function has been added for the purpose of the ticket #1340
+ */
+
+double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value) {
+  double cellsize =
+      MS_MAX(MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
+             MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
+
+  double resolutionFactor = map->resolution / map->defresolution;
+  double unitsFactor = 1;
+
+  if (layer->sizeunits != MS_PIXELS)
+    unitsFactor =
+        msInchesPerUnit(map->units, 0) / msInchesPerUnit(layer->sizeunits, 0);
+
+  return value * cellsize * resolutionFactor * unitsFactor;
+}
diff -pruN 8.0.1-5/src/mapscript/README.md 8.2.0~beta1-1~exp1/src/mapscript/README.md
--- 8.0.1-5/src/mapscript/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/README.md	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,57 @@
+MapServer MapScript Modules
+===========================
+
+Much of MapServer's functionality is accessible from Java, Perl, PHP, Python,
+Ruby, C#, and Tcl.  MapScript is not a language like JavaScript or Python, it
+is a loadable module that brings MapServer capabilities to your favorite 
+high-level programming language.
+
+MapScript Family
+----------------------------------
+
+The MapScript family tree looks like this:
+
+```
+
+               MapServer
+                   | 
+                   |    
+                   | 
+              SWIGMapScript
+                   |
+   +----+-----+----+----+--+--+-----------+
+   |    |     |    |    |  |  |           |
+ Perl Python Ruby Java C# Tcl PHPNG ...
+```                 
+
+
+The SWIGMapScript modules are generated by [SWIG](http://www.swig.org). 
+
+SWIG MapScript
+--------------
+
+Installation instructions are located in the individual languages
+directories such as ``mapscript/perl``, ``mapscript/python``. 
+
+The main MapScript SWIG interface file is ``mapscript/mapscript.i``.  This
+file includes specific class interface files from ``mapscript/swiginc`` and
+language specific code from the language directories.
+
+Note the **v8** folder contains files for [V8 MapScript Support](https://mapserver.org/installation/v8.html). 
+This is not a JavaScript version of MapScript, but provides support for the use of JavaScript
+in [STYLEITEM](https://mapserver.org/mapfile/styleitem.html#styleitemjs) and 
+[GEOTRANSFORM](https://mapserver.org/mapfile/geomtransform.html#geomtransformjs). 
+
+API Documentation can be found at the [Shared SWIG MapScript Documentation](https://mapserver.org/mapscript/index.html) 
+page. 
+
+PHPNG (SWIG) MapScript
+----------------------
+
+PHP support ("PHPNG") is included in the [SWIG API](https://mapserver.org/mapscript/index.html) 
+since the MapServer 7.4.0 release.  You can specify `WITH_PHPNG=ON` at your 
+CMake commandline, to compile PHPNG support for MapServer.
+
+The old native PHPMapScript module developed using the PHP C API was removed in 
+the MapServer 8.0.0 release. 
+
diff -pruN 8.0.1-5/src/mapscript/csharp/CMakeLists.txt 8.2.0~beta1-1~exp1/src/mapscript/csharp/CMakeLists.txt
--- 8.0.1-5/src/mapscript/csharp/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,106 @@
+FIND_PACKAGE(SWIG REQUIRED)
+INCLUDE(${SWIG_USE_FILE})
+
+FIND_PROGRAM (CSHARP_COMPILER NAMES csc mcs gmcs gmcs2)
+
+IF (CSHARP_COMPILER)
+	MESSAGE(STATUS "Found CSharp compiler: ${CSHARP_COMPILER}")
+ELSE (CSHARP_COMPILER)
+	MESSAGE(FATAL_ERROR "Could not find csharp compiler")
+ENDIF (CSHARP_COMPILER)
+
+if (WIN32)
+  if (NOT MSVC71)
+    if (CMAKE_CL_64)
+      set(PLATFORM_TARGET /platform:anycpu)
+    else(CMAKE_CL_64)
+      set(PLATFORM_TARGET /platform:x86)
+    endif(CMAKE_CL_64)
+	set (KEYFILE_SPEC /keyfile:${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\mapscript.snk)
+  endif (NOT MSVC71)
+  if (MSVC_VERSION GREATER 1500)
+      set(PLATFORM_TARGET ${PLATFORM_TARGET} /define:CLR4)
+  endif (MSVC_VERSION GREATER 1500)
+  MESSAGE(STATUS "Cmake build type: ${CMAKE_BUILD_TYPE}")
+  if (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo") 
+      set(PLATFORM_TARGET ${PLATFORM_TARGET} /debug:full)
+  endif (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
+else()
+	set (KEYFILE_SPEC -keyfile:${PROJECT_SOURCE_DIR}/src/mapscript/csharp/mapscript.snk)
+endif(WIN32)
+
+MARK_AS_ADVANCED(CSHARP_COMPILER)
+
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/csharp)
+SET (CMAKE_SWIG_OUTDIR "${CMAKE_CURRENT_BINARY_DIR}")
+if (WIN32)
+	SET( CMAKE_SWIG_FLAGS -namespace OSGeo.MapServer -DWIN32 ${MAPSERVER_COMPILE_DEFINITIONS})
+else()
+	SET( CMAKE_SWIG_FLAGS -namespace OSGeo.MapServer ${MAPSERVER_COMPILE_DEFINITIONS})
+endif()
+if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
+	SWIG_ADD_MODULE(mapscript csharp ../mapscript.i)
+else()
+	SWIG_ADD_LIBRARY(mapscript LANGUAGE csharp SOURCES ../mapscript.i)
+endif()
+
+# CMake 3.29.0 corrects an issue with earlier CMake versions regarding the
+# shared library name (cf https://gitlab.kitware.com/cmake/cmake/-/issues/25405
+# / https://gitlab.kitware.com/cmake/cmake/-/merge_requests/8973)
+if (WIN32 OR (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.29.0"))
+	set_target_properties(mapscript PROPERTIES OUTPUT_NAME "mapscript")
+else()
+	set_target_properties(mapscript PROPERTIES OUTPUT_NAME "libmapscript")
+endif()
+
+SWIG_LINK_LIBRARIES(mapscript ${MAPSERVER_LIBMAPSERVER})
+
+
+
+
+if (WIN32)
+
+	ADD_CUSTOM_COMMAND(TARGET mapscript
+						  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+						  POST_BUILD
+						  COMMAND set MAPSCRIPT_SNK=${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\mapscript.snk
+						  COMMAND set MAPSCRIPT_SNK=%MAPSCRIPT_SNK:/=\\%
+						  COMMAND copy /Y \"%MAPSCRIPT_SNK%\"
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /t:library /out:mapscript_csharp.dll ${KEYFILE_SPEC} *.cs ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\config\\AssemblyInfo.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shpdump.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\shpdump.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawmap.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmap.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shapeinfo.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\shapeinfo.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawquery.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawquery.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\getbytes.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:HTMLtemplate.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\HTMLtemplate.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:RFC24.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\RFC24.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirect.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapDirect.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirectPrint.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapDirectPrint.cs
+						  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapGDIPlus.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapGDIPlus.cs
+						  #COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /lib:C:\Windows\Microsoft.NET\Framework\v4.0.30319\WPF /r:mapscript_csharp.dll /r:System.Xaml.dll /r:WindowsBase.dll /r:PresentationCore.dll /out:drawmapWPF.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapWPF.cs
+						  COMMENT "Compiling c# source files"
+						  )
+else()
+	ADD_CUSTOM_COMMAND(TARGET mapscript
+						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+						POST_BUILD
+						COMMAND cp -f ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/mapscript.snk ./
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -target:library -out:mapscript_csharp.dll ${KEYFILE_SPEC} *.cs ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/config/AssemblyInfo.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:shpdump.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/shpdump.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:drawmap.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmap.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:shapeinfo.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/shapeinfo.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:drawquery.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawquery.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:getbytes.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/getbytes.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:HTMLtemplate.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/HTMLtemplate.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -out:RFC24.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/RFC24.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapDirect.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmapDirect.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapDirectPrint.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmapDirectPrint.cs
+						COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} -reference:mapscript_csharp.dll -reference:System.Drawing.dll -out:drawmapGDIPlus.exe ${PROJECT_SOURCE_DIR}/src/mapscript/csharp/examples/drawmapGDIPlus.cs
+						#COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /lib:C:\Windows\Microsoft.NET\Framework\v4.0.30319\WPF /r:mapscript_csharp.dll /r:System.Xaml.dll /r:WindowsBase.dll /r:PresentationCore.dll /out:drawmapWPF.exe ${PROJECT_SOURCE_DIR}\\src\\mapscript\\csharp\\examples\\drawmapWPF.cs
+						COMMENT "Compiling c# source files"
+						)
+endif()
+
+
diff -pruN 8.0.1-5/src/mapscript/csharp/Makefile.in 8.2.0~beta1-1~exp1/src/mapscript/csharp/Makefile.in
--- 8.0.1-5/src/mapscript/csharp/Makefile.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/Makefile.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,98 @@
+# $Id$
+#
+# Run ./configure in the main MapServer directory to turn this Makefile.in
+# into a proper Makefile
+
+#
+# If you want to ignore missing datafile errors uncomment the following
+# line. This is especially useful with large tiled datasets that may not
+# have complete data for each tile.
+#
+#IGNORE_MISSING_DATA=-DIGNORE_MISSING_DATA
+IGNORE_MISSING_DATA = @IGNORE_MISSING_DATA@
+
+#
+# Apparently these aren't as commonplace as I'd hoped. Edit the
+# following line to reflect the missing functions on your platform.
+#
+# STRINGS=-DNEED_STRCASECMP -DNEED_STRNCASECMP -DNEED_STRDUP -DNEED_STRLCAT
+STRINGS= @STRINGS@
+
+#
+# Flags.
+#
+
+XTRALIBS= @XTRALIBS@
+RUNPATHS= @RPATHS@
+
+FLAGS = @DEBUG_FLAGS@ @ALL_ENABLED@ @ALL_INC@ $(STRINGS) $(IGNORE_MISSING_DATA)
+
+CCFLAGS   = @CFLAGS@ $(FLAGS)
+
+# Link flags and shared libs only
+SUP_LIBS =  @ALL_LIB@
+
+# STATIC_LIBS is full filename with path of libs that will be statically linked
+STATIC_LIBS= $(GD_STATIC)
+
+LDFLAGS= $(RUNPATHS) -L../.. -lmapserver $(SUP_LIBS) $(STATIC_LIBS)
+
+LIBMAPSCRIPT_SHARED= libmapscript.@SO_EXT@
+LD_SHARED= @LD_SHARED@
+
+# END OF CONFIGURE----
+
+#
+# SWIG Stuff
+#
+SWIG= swig
+
+#
+# CSHARP Stuff
+#
+CSC= mcs
+
+CC= @CC@
+
+#
+# --- You shouldn't have to edit anything else. ---
+#
+all: interface mapscript_so mapscript_csharp
+
+sign:
+	sn -k mapscript.snk
+
+interface: ../mapscript.i
+	$(SWIG) -csharp -namespace OSGeo.MapServer $(FLAGS) -o mapscript_wrap.c ../mapscript.i
+
+mapscript_so: mapscript_wrap.c
+	$(CC) -fpic -c $(CCFLAGS) mapscript_wrap.c
+	$(LD_SHARED) mapscript_wrap.o -o $(LIBMAPSCRIPT_SHARED) $(LDFLAGS)
+
+mapscript_csharp::
+	$(CSC) /t:library /out:mapscript_csharp.dll *.cs config/AssemblyInfo.cs
+	$(CSC) /r:mapscript_csharp.dll /out:shpdump.exe examples/shpdump.cs
+	$(CSC) /r:mapscript_csharp.dll /out:shapeinfo.exe examples/shapeinfo.cs
+	$(CSC) /r:mapscript_csharp.dll /out:drawmap.exe examples/drawmap.cs
+	$(CSC) /r:mapscript_csharp.dll /out:inline.exe examples/inline.cs
+	$(CSC) /r:mapscript_csharp.dll /out:drawquery.exe examples/drawquery.cs
+	$(CSC) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe examples/getbytes.cs
+	$(CSC) /r:mapscript_csharp.dll /out:HTMLtemplate.exe examples/HTMLtemplate.cs
+	$(CSC) /r:mapscript_csharp.dll /out:RFC24.exe examples/RFC24.cs
+
+dll_config: Makefile
+	rm -rf mapscript_csharp.dll.config
+	echo "<configuration>" >> mapscript_csharp.dll.config
+	echo "<dllmap dll=\"mapscript\" target=\""mapscript"\">" >> mapscript_csharp.dll.config
+	echo "</configuration>" >> mapscript_csharp.dll.config
+
+clean:
+	rm -rf edu *.o *.c *.cs *.@SO_EXT@ *.dll *.dll.config
+
+test:
+	LC_ALL=C mono ./shpdump.exe ../../tests/point.shp
+	LC_ALL=C mono ./shapeinfo.exe ../../tests/point.shp
+	LC_ALL=C mono ./inline.exe png24 inline_test.png
+	LC_ALL=C mono ./getbytes.exe ../../tests/test.map test_csharp2.png
+	LC_ALL=C mono ./RFC24.exe ../../tests/test.map
+
diff -pruN 8.0.1-5/src/mapscript/csharp/Makefile.vc 8.2.0~beta1-1~exp1/src/mapscript/csharp/Makefile.vc
--- 8.0.1-5/src/mapscript/csharp/Makefile.vc	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/Makefile.vc	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,127 @@
+#
+# makefile.vc - MSVC++ makefile for the C#/MapScript extension
+#
+# This VC++ makefile will build the PHP module CSHARP_MAPSCRIPT.DLL
+#
+# To use the makefile:
+#  - Open a DOS prompt window
+#  - Run the VCVARS32.BAT script to initialize the VC++ environment variables
+#  - Start the build with:  nmake /f makefile.vc
+#
+# $Id$
+#
+
+
+# Flag indicating to the option files that this is the build of C#/MapScript
+#!INCLUDE ../../nmake.opt
+
+# Be aware when setting different options for libmap.dll and mapscript.dll (Bug 1476)
+# To change the options for mapscript.dll uncomment the following line
+# otherwise the options of nmake.opt will be used
+#OPTFLAGS =	/nologo /Zi /MD $(WARNING_LEVEL) $(DEBUG)
+BASE_CFLAGS = 	$(OPTFLAGS) -DWIN32 -D_WIN32
+#LDFLAGS =	/NODEFAULTLIB:msvcrt /NODEFAULTLIB:libcd /dll $(LDEBUG)
+LDFLAGS =	/dll $(LDEBUG)
+CFLAGS = 	$(BASE_CFLAGS) $(MS_CFLAGS) -I../.. 
+
+CC=     cl
+LINK=   link
+
+!IFDEF MS_DEBUG
+CSDEBUG = /debug:full
+!ELSE
+CSDEBUG =
+!ENDIF
+
+!IFDEF MONO
+CSC = mcs
+!ELSE
+!IF $(MSVC_VER) >= 1400
+!IFDEF WIN64
+CSC = csc /platform:anycpu $(CSDEBUG)
+!ELSE
+CSC = csc /platform:x86 $(CSDEBUG)
+!ENDIF
+!ELSE
+CSC = csc $(CSDEBUG)
+!ENDIF
+!ENDIF
+
+!IF $(MSVC_VER) >= 1600
+CSC = $(CSC) /define:CLR4
+!ENDIF
+
+#SWIG = swig
+
+!IFDEF DLLBUILD
+MS_LIBS = ../../mapserver_i.lib $(EXTERNAL_LIBS)
+!ELSE
+MS_LIBS = $(EXTERNAL_LIBS) ../../mapserver.lib
+!ENDIF
+
+#
+# The rest of the file should not have to be edited...
+#
+
+MAPSCRIPT_OBJS =  mapscript_wrap.obj  
+MAPSCRIPT_DLL =   mapscript.dll
+CSHARP_DLL = mapscript_csharp.dll
+
+default: 	all
+
+all:		interface $(MAPSCRIPT_DLL) $(CSHARP_DLL)
+
+sign:
+	sn -k mapscript.snk
+
+interface: ../mapscript.i
+	$(SWIG) -csharp -namespace OSGeo.MapServer $(MS_DEFS) -DWIN32 -o mapscript_wrap.c ../mapscript.i
+
+.c.obj:
+	$(CC) $(CFLAGS) /DCOMPILE_DL=1 /c $*.c /Fo$*.obj	
+		
+$(MAPSCRIPT_DLL): $(MAPSCRIPT_OBJS)
+	$(LINK) $(LDFLAGS) /out:$(MAPSCRIPT_DLL) $(MAPSCRIPT_OBJS) $(MS_LIBS)
+	if exist $(MAPSCRIPT_DLL).manifest mt -manifest $(MAPSCRIPT_DLL).manifest -outputresource:$(MAPSCRIPT_DLL);2
+
+$(CSHARP_DLL)::
+	$(CSC) $(CSFLAGS) /t:library /out:mapscript_csharp.dll *.cs config\AssemblyInfo.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:shpdump.exe examples\shpdump.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:drawmap.exe examples\drawmap.cs
+#	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:inline.exe examples\inline.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:shapeinfo.exe examples\shapeinfo.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:drawquery.exe examples\drawquery.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe examples\getbytes.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:HTMLtemplate.exe examples\HTMLtemplate.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /out:RFC24.exe examples\RFC24.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirect.exe examples\drawmapDirect.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirectPrint.exe examples\drawmapDirectPrint.cs
+	$(CSC) $(CSFLAGS) /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapGDIPlus.exe examples\drawmapGDIPlus.cs
+
+test:
+!IFDEF MONO
+	mono shpdump.exe ../../tests/point.shp
+	mono shapeinfo.exe ../../tests/point.shp
+#	mono inline.exe aggpng24 inline_test.png
+	mono getbytes.exe ../../tests/test.map test_csharp2.png
+	mono RFC24.exe ../../tests/test.map
+!ELSE
+	shpdump ../../tests/point.shp
+	shapeinfo ../../tests/point.shp
+#	inline png24 inline_test.png
+	getbytes ../../tests/test.map test_csharp2.png
+	RFC24.exe ../../tests/test.map
+!ENDIF
+	
+clean:
+	del *.obj
+	del *.dll
+	del *.lib
+	del *.pdb
+	del *.exp
+	del *.ilk
+	del *.cs
+	del *.c
+	del *.exe
+	del *.manifest
+
diff -pruN 8.0.1-5/src/mapscript/csharp/README 8.2.0~beta1-1~exp1/src/mapscript/csharp/README
--- 8.0.1-5/src/mapscript/csharp/README	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/README	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,285 @@
+-- $Id$
+
+The most recent version of this document can be found on
+http://mapserver.gis.umn.edu/docs/howto/mapscriptcscompile
+
+
+1. Compilation
+==============
+Before compiling C# mapscript you should compile mapserver with the options for your requirements.
+For more information about the compilation of mapserver please see `Win32 Compilation and Installation <http://mapserver.gis.umn.edu/docs/howto/win32_compiling>`__ .
+It is highly recommended to minimize the library dependency of your application, so
+when compiling mapserver enable only the features really needed.
+To compile the C# binding SWIG 1.3.27 or later is required.
+
+
+1.1 Win32 compilation targeting the MS.NET framework 1.1
+--------------------------------------------------------
+You should compile mapserver, mapscript and all of the subsequent libraries using Visual Studio 2003.
+Download and uncompress the latest SWIGWIN package that contains the precompiled swig.exe
+Open the Visual Studio .NET 2003 Command Prompt and step into the /mapscript/csharp directory
+Edit makefile.vc and set the SWIG variable to the location of your swig.exe
+Use
+
+::
+
+       nmake -f makefile.vc 
+
+to compile mapscript.dll and mapscript_csharp.dll.
+
+
+1.2 Win32 compilation targeting the MS.NET framework 2.0
+--------------------------------------------------------
+You should compile mapserver, mapscript and all of the subsequent libraries using Visual Studio 2005.
+Download and uncompress the latest SWIGWIN package that contains the precompiled swig.exe
+Open the Visual Studio 2005 Command Prompt and step into the /mapscript/csharp directory
+Edit makefile.vc and set the SWIG variable to the location of your swig.exe
+Use
+
+::
+ 
+       nmake -f makefile.vc 
+
+to compile mapscript.dll and mapscript_csharp.dll.
+
+1.3 Win32 compilation targeting the MONO framework
+--------------------------------------------------
+Before the compilation you should download and install the recent mono Win32 setup package (eg. mono-1.1.13.2-gtksharp-2.8.1-win32-1.exe)
+Edit makefile.vc and set the CSC variable to the location of your mcs.exe. Alternatively you can define
+
+::
+
+        MONO = YES
+
+In your nmake.opt file.
+
+You should use the same compiler for compiling mapscript as the compiler has been used for
+the mapserver compilation. To compile mapscript open the Command Prompt supplied with your compiler
+and use
+
+::
+
+        nmake -f makefile.vc 
+
+to compile mapscript.dll and mapscript_csharp.dll.
+
+1.4 Alternative compilation methods on Windows
+----------------------------------------------
+Beginning from mapserver 4.8.3 you can invoke the C# compilation from the mapserver directory by uncommenting DOT_NET in nmake.opt 
+
+::
+
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# .NET/C# MapScript
+# ----------------------------------------------------------------------
+# .NET will of course only work with MSVC 7.0 and 7.1.  Also note that
+# you will definitely want USE_THREAD defined.
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#DOT_NET = YES
+
+and invoking the compilation by
+
+::
+
+        nmake -f makefile.vc csharp
+
+You can also use
+
+::
+
+        nmake -f makefile.vc install
+
+for making the compilation an copying the targets into a common output directory.
+
+1.5 Testing the compilation
+---------------------------
+
+For testing the compilation and the runtime environment you can use
+
+::
+
+      nmake -f makefile.vc test
+
+within the csharp directory for starting the sample applications compiled previously. Before making the test the location of the corresponding libraries should be incuded in the system PATH. 
+
+1.6 Linux compilation targeting the MONO framework
+--------------------------------------------------
+Before the compilation you should download and install the recent mono Linux package.
+Some distributions have precompiled binaries to install, but for using the latest
+version you might want to compile and install it from the source.
+Download and uncompress the latest SWIG release. You should probably compile it
+from the source if precompiled binaries are not available for your platform.
+
+Before compiling mapscript mapserver should be configured and compiled. Beginning from mapserver 4.8.2 during configuration the mapscript/csharp/Makefile will be created according to the configuration options. Edit this file and set the SWIG and CSC for the corresponding executable pathes if the files could not be accessed by default. To compile at a console step into the /mapscript/csharp directory
+use
+
+::
+
+      make
+      
+to compile libmapscript.so and mapscript_csharp.dll.
+
+For testing the compilation and the runtime environment you can use
+
+::
+
+      make test
+
+for starting the sample applications compiled previously.
+
+1.7 OSX compilation targeting the MONO framework
+------------------------------------------------
+Beginning from 4.10.0 the csharp/Makefile supports the OSX builds. Before making the build the recent MONO package should be installed on the system.
+
+Before compiling mapscript mapserver should be configured and compiled. Beginning from mapserver 4.8.2 during configuration the mapscript/csharp/Makefile will be created according to the configuration options. Edit this file and set the SWIG and CSC for the corresponding executable pathes if the files could not be accessed by default. To compile at a console step into the /mapscript/csharp directory
+use
+
+::
+
+      make
+      
+to compile libmapscript.dylib and mapscript_csharp.dll.
+
+For testing the compilation and the runtime environment you can use
+
+::
+
+      make test
+
+for starting the sample applications compiled previously.
+
+To run the applications mapscript_csharp.dll.config is needed along with the mapscript_csharp.dll file. This file is created during the make process
+
+2. Installation
+===============
+The files required for your application should be manually installed. It is highly recommended to copy the files into the same folder as the executable resides.
+
+3. Known issues
+===============
+
+3.1 Visual Studio 2005 requires a manifest file to load the CRT native assembly wrapper
+---------------------------------------------------------------------------------------
+
+If you have compiled mapserver for using the CRT libraries and you are using the MS.NET framework 2.0 as the execution runtime you should supply a proper manifest file along with your executable, like:
+
+::
+
+<?xml version="1.0" encoding="utf-8"?>
+<assembly xsi:schemaLocation="urn:schemas-microsoft-com:asm.v1 assembly.adaptive.xsd" manifestVersion="1.0" xmlns:asmv1="urn:schemas-microsoft-com:asm.v1" xmlns:asmv2="urn:schemas-microsoft-com:asm.v2" xmlns:dsig="http://www.w3.org/2000/09/xmldsig#" xmlns="urn:schemas-microsoft-com:asm.v1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+<assemblyIdentity name="drawmap.exe" version="1.0.0.0" type="win32" />
+<dependency>
+<dependentAssembly asmv2:dependencyType="install" asmv2:codebase="Microsoft.VC80.CRT.manifest" asmv2:size="522">
+<assemblyIdentity name="Microsoft.VC80.CRT" version="8.0.50608.0" publicKeyToken="1fc8b3b9a1e18e3b" processorArchitecture="x86" type="win32" />
+<hash xmlns="urn:schemas-microsoft-com:asm.v2">
+<dsig:Transforms>
+<dsig:Transform Algorithm="urn:schemas-microsoft-com:HashTransforms.Identity" />
+</dsig:Transforms>
+<dsig:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1" />
+<dsig:DigestValue>UMOlhUBGeKRrrg9DaaPNgyhRjyM=</dsig:DigestValue>
+</hash>
+</dependentAssembly>
+</dependency>
+</assembly>
+
+This will inform the CLR that your exe depends on the CRT and the proper assembly wrapper is to be used.
+If you are using the IDE the manifest file could be pregenerated by adding a reference to
+Microsoft.VC80.CRT.manifest within the /Microsoft Visual Studio 8/VC/redist/x86/Microsoft.VC80.CRT
+directory.
+
+3.2 Manifests for the dll-s must be embedded as a resource
+----------------------------------------------------------
+
+According to the windows makefile the mapscript compilation target (mapscript.dll) is linked with the /MD option. In this case the VS2005 linker will generate a manifest file containing the unmanaged assembly dependency. The sample contents of the manifest file are:
+
+::
+
+<?xml version='1.0' encoding='UTF-8' standalone='yes'?>
+<assembly xmlns='urn:schemas-microsoft-com:asm.v1' manifestVersion='1.0'>
+<dependency>
+<dependentAssembly>
+<assemblyIdentity type='win32' name='Microsoft.VC80.CRT' version='8.0.50608.0' processorArchitecture='x86' publicKeyToken='1fc8b3b9a1e18e3b' />
+</dependentAssembly>
+</dependency>
+</assembly>
+
+Like previously mentioned if you are creating a windows application the common language runtime will search for a manifest file for the application. The name of the manifest file should be the same as the executable appendend with the .manifest extension.
+However if the host process is not controlled by you (like web mapping applications using aspnet_wp.exe as the host process) you will not be certain if the host process (.exe) will have a manifest containing a reference to the CRT wrapper. In this case you may have to embed the manifest into the dll as a resource using the mt tool like:
+
+::
+
+ mt /manifest mapscript.dll.manifest /outputresource:mapscript.dll;#2
+
+the common language runtime will search for the embedded resource and load the CRT assembly properly.
+
+Normally it is enough to load the CRT with the root dll (mapscript.dll), but it is not harmful embedding the manifest into the dependent libraries as well.
+
+
+3.3 Issue with regex and Visual Studio 2005
+-------------------------------------------
+
+When compiling with Microsoft Visual Studio 2005 variable name collision may occur between regex.c
+and crtdefs.h. For more details see:
+
+http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1651
+
+3.4 C# mapscript library name mapping with MONO
+-----------------------------------------------
+
+Using the mapscript interface created by the SWIG interface generator the communication between the C# wrapper classes (mapscript_csharp.dll) and the C code (mapscript.dll) takes place using platform invoke like:
+
+::
+
+ [DllImport("mapscript", EntryPoint="CSharp_new_mapObj")]
+ public static extern IntPtr new_mapObj(string jarg1); 
+
+The DllImport declaration contains the library name, however to transform the library name into a file name is platform dependent.
+On Windows the library name is simply appended with the .dll extension (mapscript.dll). On the Unix systems the library file name normally starts with the lib prefix and appended with the .so extension (libmapscript.so).
+
+Mapping of the library name may be manually controlled using a dll.config file. This simply
+maps the library file the DllImport is looking for to its unix equivalent. The file normally contains the following information (mapscript_csharp.dll.config):
+
+::
+
+<configuration>
+<dllmap dll="mapscript" target="libmapscript.so" />
+</configuration>
+
+and with the OSX builds:
+
+::
+
+<configuration>
+<dllmap dll="mapscript" target="libmapscript.dylib" />
+</configuration>
+ 
+The file should be placed along with the corresponding mapscript_csharp.dll file, and created by default during the make process.
+For more information see:
+
+http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1596
+http://www.mono-project.com/Interop_with_Native_Libraries
+
+3.5 Localization issues with MONO/Linux
+---------------------------------------
+
+According to http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1762 mapserver may not operate equally well on different locale settings. Especially when the decimal separator is other than "." inside the locale of the process may cause parse errors when the mapfile contains float numbers.
+Since the MONO process takes over the locale settings of the environment it is worth considering to set the default locale to "C" of the host process, like:
+
+::
+
+ LC_ALL=C mono ./drawmap.exe ../../tests/test.map test_csharp.png
+
+4. Most frequent errors
+=======================
+
+This chapter will summarize the most frequent problems the user can run into. The issues were collected mainly from the -users list and the IRC.
+
+4.1 Unable to load dll (mapscript)
+----------------------------------
+
+You can get this problem on Windows and in most cases it can be dedicated to a missing or an unloadable shared library. The error message talks about mapscript.dll but surely one or more of the dll-s are missing that libmap.dll depends on. So firstly you might want to check for the dependencies of your libmap.dll in your application directory. You can use the Visual Studio Dependency Walker to accomplish this task. You can also use a file monitoring tool (like SysInternal's filemon) to detect the dll-s that could not be loaded. I propose to store all of the dll-s required by your application in the application folder. If you can run the drawmap C# sample application with your mapfile your compilation might be correct and all of the dlls are available.
+
+You may find that the mapscript C# interface behaves differently for the desktop and the ASP.NET applications. Although you can run the drawmap sample correctly you may encounter the dll loading problem with the ASP.NET applications. When creating an ASP.NET project your application folder will be '\Inetpub\wwwroot\[YourApp]\bin' by default. The host process of the application will aspnet_wp.exe or w3wp.exe depending on your system. The application will run under a different security context than the interactive user (under the context of the ASPNET user by default). When placing the dll-s outside of your application directory you should consider that the PATH environment variable may differ between the interactive and the ASPNET user and/or you may not have enough permission to access a dll outside of your application folder.
+
+5. Bug reports
+==============
+If you find a problem dedicated to the mapscript C# interface feel free to file a bug report to BugZilla.
diff -pruN 8.0.1-5/src/mapscript/csharp/config/AssemblyInfo.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/config/AssemblyInfo.cs
--- 8.0.1-5/src/mapscript/csharp/config/AssemblyInfo.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/config/AssemblyInfo.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,98 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  MapScript CSharp Assembly Information
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Security;
+
+//
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+//
+[assembly: AssemblyTitle("mapscript")]
+[assembly: AssemblyDescription("MapScript C# Library")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("")]
+[assembly: AssemblyCopyright("")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]		
+
+//
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+
+[assembly: AssemblyVersion("1.0.*")]
+
+//
+// In order to sign your assembly you must specify a key to use. Refer to the 
+// Microsoft .NET Framework documentation for more information on assembly signing.
+//
+// Use the attributes below to control which key is used for signing. 
+//
+// Notes: 
+//   (*) If no key is specified, the assembly is not signed.
+//   (*) KeyName refers to a key that has been installed in the Crypto Service
+//       Provider (CSP) on your machine. KeyFile refers to a file which contains
+//       a key.
+//   (*) If the KeyFile and the KeyName values are both specified, the 
+//       following processing occurs:
+//       (1) If the KeyName can be found in the CSP, that key is used.
+//       (2) If the KeyName does not exist and the KeyFile does exist, the key 
+//           in the KeyFile is installed into the CSP and used.
+//   (*) In order to create a KeyFile, you can use the sn.exe (Strong Name) utility.
+//       When specifying the KeyFile, the location of the KeyFile should be
+//       relative to the project output directory which is
+//       %Project Directory%\obj\<configuration>. For example, if your KeyFile is
+//       located in the project directory, you would specify the AssemblyKeyFile 
+//       attribute as [assembly: AssemblyKeyFile("..\\..\\mykey.snk")]
+//   (*) Delay Signing is an advanced option - see the Microsoft .NET Framework
+//       documentation for more information on this.
+//
+[assembly: AssemblyDelaySign(false)]
+[assembly: AssemblyKeyFile("mapscript.snk")]
+[assembly: AssemblyKeyName("")]
+
+// The AllowPartiallyTrustedCallersAttribute requires the assembly to be signed with a strong name key.
+// This attribute is necessary since the control is called by either an intranet or Internet
+// Web page that should be running under restricted permissions.
+[assembly: AllowPartiallyTrustedCallers]
+
+// Use the .NET Framework 2.0 transparency rules (level 1 transparency) as default
+#if (CLR4)
+[assembly: SecurityRules(SecurityRuleSet.Level1)]
+#endif
\ No newline at end of file
diff -pruN 8.0.1-5/src/mapscript/csharp/config/mapscript_csharp.dll.config 8.2.0~beta1-1~exp1/src/mapscript/csharp/config/mapscript_csharp.dll.config
--- 8.0.1-5/src/mapscript/csharp/config/mapscript_csharp.dll.config	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/config/mapscript_csharp.dll.config	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3 @@
+<configuration>
+    <dllmap dll="mapscript" target="libmapscript.so" />
+</configuration>
diff -pruN 8.0.1-5/src/mapscript/csharp/csmodule.i 8.2.0~beta1-1~exp1/src/mapscript/csharp/csmodule.i
--- 8.0.1-5/src/mapscript/csharp/csmodule.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/csmodule.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,480 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  C#-specific enhancements to MapScript
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+/*Uncomment the following lines if you want to receive subsequent exceptions as
+inner exceptions. Otherwise the exception message will be concatenated*/
+//#if SWIG_VERSION >= 0x010329
+//#define ALLOW_INNER_EXCEPTIONS
+//#endif
+
+%ignore fp;
+
+/******************************************************************************
+ * Implement Equals and GetHashCode properly
+ *****************************************************************************/
+
+%typemap(cscode) SWIGTYPE %{
+  public override bool Equals(object obj) {
+    if (obj == null)
+        return false;
+    if (this.GetType() != obj.GetType())
+        return false;
+    return swigCPtr.Handle.Equals($csclassname.getCPtr(($csclassname)obj).Handle);
+  }
+
+  public override int GetHashCode() {
+    return swigCPtr.Handle.GetHashCode();
+  }
+%}
+
+/******************************************************************************
+ * Module initialization helper (bug 1665)
+ *****************************************************************************/
+
+%pragma(csharp) imclasscode=%{
+  protected class $moduleHelper 
+	{
+		static $moduleHelper() 
+		{
+			$module.msSetup();
+		}
+		 ~$moduleHelper() 
+		{
+			//$module.msCleanup();
+		}
+	}
+	protected static $moduleHelper the$moduleHelper = new $moduleHelper();
+%}
+
+/******************************************************************************
+ * C# exception redefinition
+ *****************************************************************************/
+#ifdef ALLOW_INNER_EXCEPTIONS
+%exception
+{
+	errorObj *ms_error;
+	$action
+    ms_error = msGetErrorObj();
+    if (ms_error != NULL && ms_error->code != MS_NOERR) {
+	    if (ms_error->code != MS_NOTFOUND && ms_error->code != -1) {
+            int ms_errorcode = ms_error->code;
+            while (ms_error!=NULL && ms_error->code != MS_NOERR) {
+                char* msg =  msAddErrorDisplayString(NULL, ms_error);
+                if (msg) {
+			        SWIG_CSharpException(SWIG_SystemError, msg);
+			        free(msg);
+		        }
+                else SWIG_CSharpException(SWIG_SystemError, "MapScript unknown error");
+                ms_error = ms_error->next;	  
+            }
+            msResetErrorList();
+            return $null;
+        }
+        msResetErrorList();
+    }
+}
+#else
+%exception
+{
+	errorObj *ms_error;
+	$action
+    ms_error = msGetErrorObj();
+    if (ms_error != NULL && ms_error->code != MS_NOERR) {
+	    if (ms_error->code != MS_NOTFOUND && ms_error->code != -1) {
+            char* msg = msGetErrorString(";"); 
+		    if (msg) {
+			    SWIG_CSharpException(SWIG_SystemError, msg);
+			    free(msg);
+		    }
+            else SWIG_CSharpException(SWIG_SystemError, "MapScript unknown error");
+            msResetErrorList();
+		    return $null;
+        }
+        msResetErrorList();
+    }
+}
+#endif
+
+/******************************************************************************
+ * typemaps for string arrays (for supporting map templates)
+ *****************************************************************************/
+ 
+%pragma(csharp) imclasscode=%{
+public class StringArrayMarshal : global::System.IDisposable {
+    public readonly System.IntPtr[] _ar;
+    public StringArrayMarshal(string[] ar) {
+      _ar = new System.IntPtr[ar.Length];
+      for (int cx = 0; cx < _ar.Length; cx++) {
+	      _ar[cx] = System.Runtime.InteropServices.Marshal.StringToHGlobalAnsi(ar[cx]);
+      }
+    }
+    public virtual void Dispose() {
+	  for (int cx = 0; cx < _ar.Length; cx++) {
+          System.Runtime.InteropServices.Marshal.FreeHGlobal(_ar[cx]);
+      }
+      System.GC.SuppressFinalize(this);
+    }
+  }
+%}
+
+%typemap(imtype, out="System.IntPtr") char** "System.IntPtr[]"
+%typemap(cstype) char** %{string[]%}
+%typemap(in) char** %{ $1 = ($1_ltype)$input; %}
+%typemap(out) char** %{ $result = $1; %}
+%typemap(csin) char** "new $modulePINVOKE.StringArrayMarshal($csinput)._ar"
+%typemap(csout, excode=SWIGEXCODE) char** {
+    $excode
+    throw new System.NotSupportedException("Returning string arrays is not implemented yet.");
+}
+%typemap(csvarin, excode=SWIGEXCODE2) char** %{
+    set {
+      $excode
+	  throw new System.NotSupportedException("Setting string arrays is not supported now.");
+    } 
+%}
+/* specializations */
+%typemap(csvarout, excode=SWIGEXCODE2) char** formatoptions %{
+    get {
+        System.IntPtr cPtr = $imcall;
+        System.IntPtr objPtr;
+	    string[] ret = new string[this.numformatoptions];
+        for(int cx = 0; cx < this.numformatoptions; cx++) {
+            objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
+            ret[cx]= (objPtr == System.IntPtr.Zero) ? null : System.Runtime.InteropServices.Marshal.PtrToStringAnsi(objPtr);
+        }
+        $excode
+        return ret;
+    }
+%}
+%typemap(csvarout, excode=SWIGEXCODE2) char** values %{
+    get {
+        System.IntPtr cPtr = $imcall;
+        System.IntPtr objPtr;
+	    string[] ret = new string[this.numvalues];
+        for(int cx = 0; cx < this.numvalues; cx++) {
+            objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
+            ret[cx]= (objPtr == System.IntPtr.Zero) ? null : System.Runtime.InteropServices.Marshal.PtrToStringAnsi(objPtr);
+        }
+        $excode
+        return ret;
+    }
+%}
+
+/******************************************************************************
+ * typemaps for outputFormatObj arrays
+ *****************************************************************************/
+
+%typemap(ctype) outputFormatObj** "void*"
+%typemap(imtype) outputFormatObj** "System.IntPtr"
+%typemap(cstype) outputFormatObj** "outputFormatObj[]"
+%typemap(out) outputFormatObj** %{ $result = $1; %}
+%typemap(csout, excode=SWIGEXCODE) outputFormatObj** {
+      System.IntPtr cPtr = $imcall;
+      System.IntPtr objPtr;
+      outputFormatObj[] ret = new outputFormatObj[this.numoutputformats];
+      for(int cx = 0; cx < this.numoutputformats; cx++) {
+          objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
+          ret[cx] = (objPtr == System.IntPtr.Zero) ? null : new outputFormatObj(objPtr, false, ThisOwn_false());
+      }
+      $excode
+      return ret;
+}
+
+%typemap(csvarout, excode=SWIGEXCODE2) outputFormatObj** %{
+    get {
+      System.IntPtr cPtr = $imcall;
+      System.IntPtr objPtr;
+      outputFormatObj[] ret = new outputFormatObj[this.numoutputformats];
+      for(int cx = 0; cx < this.numoutputformats; cx++) {
+          objPtr = System.Runtime.InteropServices.Marshal.ReadIntPtr(cPtr, cx * System.Runtime.InteropServices.Marshal.SizeOf(typeof(System.IntPtr)));
+          ret[cx] = (objPtr == System.IntPtr.Zero) ? null : new outputFormatObj(objPtr, false, ThisOwn_false());
+      }
+      $excode
+      return ret;
+    }
+%}
+
+/******************************************************************************
+ * gdBuffer Typemaps and helpers
+ *****************************************************************************/
+
+%pragma(csharp) imclasscode=%{
+  public delegate void SWIGByteArrayDelegate(System.IntPtr data, int size);
+%}
+
+%insert(runtime) %{
+/* Callback for returning byte arrays to C# */
+typedef void (SWIGSTDCALL* SWIG_CSharpByteArrayHelperCallback)(const unsigned char *, const int);
+/* Default callback interface */
+static SWIG_CSharpByteArrayHelperCallback SWIG_csharp_bytearray_callback = NULL;
+%}
+
+%typemap(ctype) SWIG_CSharpByteArrayHelperCallback    %{SWIG_CSharpByteArrayHelperCallback%}
+%typemap(imtype) SWIG_CSharpByteArrayHelperCallback  %{SWIGByteArrayDelegate%}
+%typemap(cstype) SWIG_CSharpByteArrayHelperCallback %{$modulePINVOKE.SWIGByteArrayDelegate%}
+%typemap(in) SWIG_CSharpByteArrayHelperCallback %{ $1 = ($1_ltype)$input; %}
+%typemap(csin) SWIG_CSharpByteArrayHelperCallback "$csinput"
+
+%typemap(imtype) (unsigned char* pixels) "System.IntPtr"
+%typemap(cstype) (unsigned char* pixels) "System.IntPtr"
+%typemap(in) (unsigned char* pixels) %{ $1 = ($1_ltype)$input; %}
+%typemap(csin) (unsigned char* pixels) "$csinput"
+
+%csmethodmodifiers getBytes "private";
+%ignore imageObj::getBytes();
+%extend imageObj 
+{
+	void getBytes(SWIG_CSharpByteArrayHelperCallback callback) {
+        gdBuffer buffer;
+        
+        buffer.owns_data = MS_TRUE;
+        
+        buffer.data = msSaveImageBuffer(self, &buffer.size, self->format);
+            
+        if( buffer.data == NULL || buffer.size == 0 )
+        {
+            msSetError(MS_MISCERR, "Failed to get image buffer", "getBytes");
+            return;
+        }
+        callback(buffer.data, buffer.size);
+        msFree(buffer.data);
+    }
+
+    int getRawPixels(unsigned char* pixels) {
+      if (MS_RENDERER_PLUGIN(self->format)) {
+        rendererVTableObj *renderer = self->format->vtable;
+        if(renderer->supports_pixel_buffer) {
+          rasterBufferObj rb;
+          int status = MS_SUCCESS;
+          int size = self->width * self->height * 4 * sizeof(unsigned char);
+          
+          status = renderer->getRasterBufferHandle(self,&rb);
+          if(MS_UNLIKELY(status == MS_FAILURE)) {
+            return MS_FAILURE;
+          }
+          memcpy(pixels, rb.data.rgba.pixels, size);
+          return status;
+        }
+      }
+      return MS_FAILURE;
+    }
+}
+
+%ignore imageObj::write;
+%typemap(cscode) imageObj, struct imageObj %{
+  private byte[] gdbuffer;
+  private void CreateByteArray(System.IntPtr data, int size)
+  {
+      gdbuffer = new byte[size];
+      System.Runtime.InteropServices.Marshal.Copy(data, gdbuffer, 0, size);
+  }
+  
+  public byte[] getBytes()
+  {
+	getBytes(new $modulePINVOKE.SWIGByteArrayDelegate(this.CreateByteArray));
+	return gdbuffer;
+  }
+  
+  public void write(System.IO.Stream stream)
+  {
+	getBytes(new $modulePINVOKE.SWIGByteArrayDelegate(this.CreateByteArray));
+	stream.Write(gdbuffer, 0, gdbuffer.Length);
+  }
+%}
+
+
+%csmethodmodifiers processTemplate "private";
+%csmethodmodifiers processLegendTemplate "private";
+%csmethodmodifiers processQueryTemplate "private";
+
+%typemap(csinterfaces) mapObj "System.IDisposable, System.Runtime.Serialization.ISerializable";
+%typemap(csattributes) mapObj  "[Serializable]"
+%typemap(cscode) mapObj, struct mapObj %{  
+  public string processTemplate(int bGenerateImages, string[] names, string[] values)
+  {
+	if (names.Length != values.Length)
+	    throw new System.ArgumentException("Invalid array length specified!");
+	return processTemplate(bGenerateImages, names, values, values.Length);
+  }
+  
+  public string processLegendTemplate(string[] names, string[] values)
+  {
+	if (names.Length != values.Length)
+	    throw new System.ArgumentException("Invalid array length specified!");
+	return processLegendTemplate(names, values, values.Length);
+  }
+  
+  public string processQueryTemplate(string[] names, string[] values)
+  {
+	if (names.Length != values.Length)
+	    throw new System.ArgumentException("Invalid array length specified!");
+	return processQueryTemplate(names, values, values.Length);
+  }
+ 
+  public mapObj(
+      System.Runtime.Serialization.SerializationInfo info
+      , System.Runtime.Serialization.StreamingContext context) : this(info.GetString("mapText"), 1)
+  {       
+        //this constructor is needed for ISerializable interface
+  }
+  
+  public void GetObjectData(System.Runtime.Serialization.SerializationInfo info, System.Runtime.Serialization.StreamingContext context) 
+    {    
+        info.AddValue( "mapText", this.convertToString() );        
+    }
+%}
+
+
+%typemap(ctype) gdBuffer    %{void%}
+%typemap(imtype) gdBuffer  %{void%}
+%typemap(cstype) gdBuffer %{byte[]%}
+
+%typemap(out, null="") gdBuffer
+%{ SWIG_csharp_bytearray_callback($1.data, $1.size);
+	if( $1.owns_data ) msFree($1.data); %}
+
+// SWIGEXCODE is a macro used by many other csout typemaps
+#ifdef SWIGEXCODE
+%typemap(csout, excode=SWIGEXCODE) gdBuffer {
+    $imcall;$excode
+    return $modulePINVOKE.GetBytes();
+}
+#else
+%typemap(csout) gdBuffer {
+    $imcall;
+    return $modulePINVOKE.GetBytes();
+}
+#endif
+
+%pragma(csharp) imclasscode=%{
+  protected class SWIGByteArrayHelper 
+	{
+		public delegate void SWIGByteArrayDelegate(System.IntPtr data, int size);
+		static SWIGByteArrayDelegate bytearrayDelegate = new SWIGByteArrayDelegate(CreateByteArray);
+
+		[System.Runtime.InteropServices.DllImport("$dllimport", EntryPoint="SWIGRegisterByteArrayCallback_$module")]
+		public static extern void SWIGRegisterByteArrayCallback_mapscript(SWIGByteArrayDelegate bytearrayDelegate);
+
+		static void CreateByteArray(System.IntPtr data, int size)
+		{
+			arraybuffer = new byte[size];
+			System.Runtime.InteropServices.Marshal.Copy(data, arraybuffer, 0, size);
+		}
+
+		static SWIGByteArrayHelper() 
+		{
+			SWIGRegisterByteArrayCallback_$module(bytearrayDelegate);
+		}
+	}
+	protected static SWIGByteArrayHelper bytearrayHelper = new SWIGByteArrayHelper();
+	[System.ThreadStatic]
+	private static byte[] arraybuffer;
+
+	internal static byte[] GetBytes()
+	{
+		return arraybuffer;
+	}
+%}
+
+%insert(runtime) %{
+#ifdef __cplusplus
+extern "C" 
+#endif
+#ifdef SWIGEXPORT
+SWIGEXPORT void SWIGSTDCALL SWIGRegisterByteArrayCallback_$module(SWIG_CSharpByteArrayHelperCallback callback) {
+  SWIG_csharp_bytearray_callback = callback;
+}
+#else
+DllExport void SWIGSTDCALL SWIGRegisterByteArrayCallback_$module(SWIG_CSharpByteArrayHelperCallback callback) {
+  SWIG_csharp_bytearray_callback = callback;
+}
+#endif
+%}
+
+/* Typemaps for pattern array */
+%typemap(imtype) (double pattern[ANY]) "System.IntPtr"
+%typemap(cstype) (double pattern[ANY]) "double[]"
+%typemap(in) (double pattern[ANY]) %{ $1 = ($1_ltype)$input; %}
+%typemap(csin) (double pattern[ANY]) "$csinput"
+%typemap(csvarout, excode=SWIGEXCODE2) (double pattern[ANY]) %{
+    get {
+      System.IntPtr cPtr = $imcall;
+      double[] ret = new double[patternlength];
+      if (patternlength > 0) {       
+	        System.Runtime.InteropServices.Marshal.Copy(cPtr, ret, 0, patternlength);
+      }
+      $excode
+      return ret;
+    } 
+    set {
+      System.IntPtr cPtr = $imcall;
+      if (value.Length > 0) {       
+	        System.Runtime.InteropServices.Marshal.Copy(value, 0, cPtr, value.Length);
+      }
+      patternlength = value.Length;
+      $excode
+    }
+    %}
+%typemap(csvarin, excode="") (double pattern[ANY]) %{$excode%}
+
+/* Typemaps for int array */
+%typemap(imtype, out="System.IntPtr") int *panIndexes "int[]"
+%typemap(cstype) int *panIndexes %{int[]%}
+%typemap(in) int *panIndexes %{ $1 = ($1_ltype)$input; %}
+%typemap(csin) (int *panIndexes)  "$csinput"
+
+/* Typemaps for device handle */
+%typemap(imtype) (void* device)  %{System.IntPtr%}
+%typemap(cstype) (void* device) %{System.IntPtr%}
+%typemap(in) (void* device) %{ $1 = ($1_ltype)$input; %}
+%typemap(csin) (void* device)  "$csinput"
+
+/******************************************************************************
+ * Preventing to take ownership of the memory when constructing objects 
+ * with parent objects (causing nullreference exception, Bug 1743)
+ *****************************************************************************/
+
+%typemap(csconstruct, excode=SWIGEXCODE) layerObj(mapObj map) %{: this($imcall, true, map) {
+  $excode
+}
+%}
+%typemap(csconstruct, excode=SWIGEXCODE) classObj(layerObj layer) %{: this($imcall, true, layer) {
+  $excode
+}
+%}
+%typemap(csconstruct, excode=SWIGEXCODE) styleObj(classObj parent_class) %{: this($imcall, true, parent_class) {
+  $excode
+}
+%}
+
+%typemap(csout, excode=SWIGEXCODE) classObj* getClass, layerObj* getLayer, layerObj *getLayerByName, styleObj* getStyle {
+    System.IntPtr cPtr = $imcall;
+    $csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $csclassname(cPtr, $owner, ThisOwn_false());$excode
+    return ret;
+  }
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/HTMLtemplate.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/HTMLtemplate.cs
--- 8.0.1-5/src/mapscript/csharp/examples/HTMLtemplate.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/HTMLtemplate.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,60 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to show the usage of HTML templates.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using OSGeo.MapServer;
+
+/// <summary>
+/// A C# based mapscript example to show the usage of HTML templates.
+/// </summary>
+class HTMLTemplate
+{
+    public static void usage() 
+    { 
+	    Console.WriteLine("usage: HTMLTemplate {mapfile} {templatefile} {outdir}");
+	    System.Environment.Exit(-1);
+    }
+    		  
+    public static void Main(string[] args)
+    {
+        if (args.Length < 3) usage();
+        
+        mapObj map = new mapObj(args[0]);
+		map.legend.template = args[1];
+		map.web.imagepath = args[2];
+		map.web.imageurl = "";
+		string str = null;
+		string[] names = null, values = null;
+		names = new string[] {"map"};
+		values = new string[] { args[0] };
+		str = map.processLegendTemplate(names, values);
+		Console.Write(str);
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/RFC24.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/RFC24.cs
--- 8.0.1-5/src/mapscript/csharp/examples/RFC24.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/RFC24.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,503 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Tests for RFC24 implementation. 
+ *           (http://mapserver.gis.umn.edu/development/rfc/ms-rfc-24/).
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *           Umberto Nicoletti, umberto.nicoletti@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using OSGeo.MapServer;
+
+/**
+ * <p>Title: Mapscript RFC24 tests.</p>
+ * <p>Description: Tests for RFC24 implementation. (http://mapserver.gis.umn.edu/development/rfc/ms-rfc-24/)</p>
+ * @author Umberto Nicoletti (umberto.nicoletti@gmail.com)
+ */
+
+class RFC24 {
+	string mapfile;
+	int fails = 0;
+
+	public static void Main(string[] args) {
+		new RFC24(args[0]).run();
+	}
+	
+	public RFC24(string mapfile) {
+		this.mapfile=mapfile;
+	}
+	
+	public void run() {
+		Console.WriteLine("Running RFC24");
+		testLayerObj();
+		testLayerObjDestroy();
+		testClassObj();
+		testClassObjDestroy();
+		testInsertLayerObj();
+		testInsertLayerObjDestroy();
+		testRemoveLayerObj();
+		testInsertClassObj();
+		testInsertClassObjDestroy();
+		testRemoveClassObj();
+		testGetLayerObj();
+		testGetLayerObjDestroy();
+		testGetLayerObjByName();
+		testGetLayerObjByNameDestroy();
+		testGetClassObj();
+		testGetClassObjDestroy();
+		try { testStyleObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testStyleObj exception:" + e.Message); }
+		testStyleObjDestroy();
+		try { testInsertStyleObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testInsertStyleObj exception:" + e.Message); }
+		testInsertStyleObjDestroy();
+		testRemoveStyleObj();
+		try { testGetStyleObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testGetStyleObj exception:" + e.Message); }
+		testGetStyleObjDestroy();
+
+		try { testlegendObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testlegendObj exception:" + e.Message); }
+		try { testreferenceMapObj(); } 
+		catch (Exception e) { Console.WriteLine("\t- testreferenceMapObj exception:" + e.Message); }
+		try { testwebObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testwebObj exception:" + e.Message); }
+		try { testqueryMapObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testqueryMapObj exception:" + e.Message); }
+		try { testmapObjHashTable(); }
+		catch (Exception e) { Console.WriteLine("\t- testmapObjHashTable exception:" + e.Message); }
+		try { testsymbolSetObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testsymbolSetObj exception:" + e.Message); }
+		try { testimageObj(); }
+		catch (Exception e) { Console.WriteLine("\t- testimageObj exception:" + e.Message); }
+
+		if (fails > 0)
+			Console.WriteLine("\n     " + fails + " tests were FAILED!!!\n");
+
+		Console.WriteLine("Finished RFC24");
+	}
+
+	public void testlegendObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		legendObj legend = map.legend;
+		legend.template = "This is a sample!";
+
+		map=null;
+		gc();	
+		assert(legend.template == "This is a sample!", "testlegendObj");
+	}
+
+	public void testmapObjHashTable() 
+	{
+		mapObj map=new mapObj(mapfile);
+		hashTableObj configoptions = map.configoptions;
+		configoptions.set("key", "test value");
+
+		map=null;
+		gc();
+	
+		assert(configoptions.get("key", "") == "test value", "testmapObjHashTable");
+	}
+
+	public void testsymbolSetObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		symbolSetObj symbolset = map.symbolset;
+		symbolset.filename = "filename";
+
+		map=null;
+		gc();
+	
+		assert(symbolset.filename == "filename", "testsymbolSetObj");
+	}
+
+	public void testreferenceMapObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		referenceMapObj refmap = map.reference;
+		refmap.markername = "This is a sample!";
+
+		map=null;
+		gc();
+	    assert(refmap.markername == "This is a sample!", "testreferenceMapObj");
+	}
+
+	public void testwebObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		webObj web = map.web;
+		web.template = "This is a sample!";
+
+		map=null;
+		gc();
+		assert(web.template == "This is a sample!", "testwebObj");
+	}
+
+	public void testqueryMapObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		queryMapObj querymap = map.querymap;
+		querymap.color.setHex( "#13ba88" );
+
+		map=null;
+		gc();
+		assert(querymap.color.toHex() == "#13ba88", "testqueryMapObj");
+	}
+
+	public void testimageObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		imageObj image = map.draw();
+		outputFormatObj format = image.format;
+		format.setOption( "INTERLACE", "OFF");
+
+		map=null;
+		gc();
+		assert(format.getOption("INTERLACE", "") == "OFF", "testimageObj");
+	}
+	
+	public void testLayerObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=new layerObj(map);
+
+		map=null;
+		gc();
+		assertNotNull(newLayer.map, "testLayerObj");
+		assert(newLayer.refcount == 2, "testLayerObj refcount");
+	}
+
+	public void testLayerObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=new layerObj(map);
+		layerObj reference = map.getLayer(map.numlayers-1);
+
+		assert(newLayer.refcount == 3, "testLayerObjDestroy precondition");
+		newLayer.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
+		newLayer = null;
+		gc();
+		assert(reference.refcount == 2, "testLayerObjDestroy");
+	}
+	
+	public void testInsertLayerObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=new layerObj(null);
+		map.insertLayer(newLayer,-1);
+		
+		map=null;
+		gc();
+		assertNotNull(newLayer.map, "testInsertLayerObj");
+		assert(newLayer.refcount == 2, "testInsertLayerObj refcount");
+	}
+
+	public void testInsertLayerObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=new layerObj(null);
+		map.insertLayer(newLayer,0);
+		layerObj reference = map.getLayer(0);
+
+		assert(newLayer.refcount == 3, "testInsertLayerObjDestroy precondition");
+		newLayer.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
+		newLayer=null;
+		gc();
+		assert(reference.refcount == 2, "testInsertLayerObjDestroy");
+	}
+
+	public void testRemoveLayerObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=new layerObj(null);
+		map.insertLayer(newLayer,0);
+		map.removeLayer(0);
+
+		map=null;
+		gc();
+		assert(newLayer.refcount == 1, "testRemoveLayerObj");
+	}
+	
+	public void testGetLayerObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=map.getLayer(1);
+		
+		map=null;
+		gc();
+		assertNotNull(newLayer.map, "testGetLayerObj");
+		assert(newLayer.refcount == 2, "testGetLayerObj refcount");
+	}
+
+	public void testGetLayerObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=map.getLayer(1);
+		layerObj reference = map.getLayer(1);
+		
+		assert(newLayer.refcount == 3, "testGetLayerObjDestroy precondition");
+		//newLayer.Dispose(); // force the destruction needed for Mono on Windows
+		newLayer=null;
+		gc();
+		assert(reference.refcount == 2, "testGetLayerObjDestroy");
+	}
+
+	public void testGetLayerObjByName() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=map.getLayerByName("POLYGON");
+		
+		map=null;
+		gc();
+		assertNotNull(newLayer.map, "testGetLayerObjByName");
+		assert(newLayer.refcount == 2, "testGetLayerObjByName refcount");
+	}
+
+	public void testGetLayerObjByNameDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=map.getLayerByName("POLYGON");
+		layerObj reference=map.getLayerByName("POLYGON");
+		
+		assert(newLayer.refcount == 3, "testGetLayerObjByNameDestroy precondition");
+		//newLayer.Dispose(); // force the destruction needed for Mono on Windows
+		newLayer=null;
+		gc();
+		assert(reference.refcount == 2, "testGetLayerObjByNameDestroy");
+	}
+
+	public void testClassObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=new classObj(layer);
+		
+		map=null; layer=null;
+		gc();
+		assertNotNull(newClass.layer, "testClassObj");
+		assert(newClass.refcount == 2, "testClassObj refcount");
+	}
+
+	public void testClassObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=new classObj(layer);
+		classObj reference=layer.getClass(layer.numclasses-1);
+		
+		assert(newClass.refcount == 3, "testClassObjDestroy precondition");
+		newClass.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
+		map=null; layer=null; newClass=null;
+		gc();
+		assert(reference.refcount == 2, "testClassObjDestroy");
+	}
+
+	public void testStyleObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj classobj=layer.getClass(0);
+		styleObj newStyle=new styleObj(classobj);
+		
+		map=null; layer=null; classobj=null;
+		gc();
+		assert(newStyle.refcount == 2, "testStyleObj");
+	}
+
+	public void testStyleObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj classobj=layer.getClass(0);
+		styleObj newStyle=new styleObj(classobj);
+		styleObj reference=classobj.getStyle(classobj.numstyles-1);
+		
+		assert(newStyle.refcount == 3, "testStyleObjDestroy");
+		newStyle.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
+		map=null; layer=null; classobj=null; newStyle=null;
+		gc();
+		assert(reference.refcount == 2, "testStyleObjDestroy");
+	}
+
+	public void testInsertClassObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=new classObj(null);
+		layer.insertClass(newClass,-1);
+		
+		assertNotNull(newClass.layer, "testInsertClassObj precondition");
+		map=null; layer=null;
+		gc();
+		assertNotNull(newClass.layer, "testInsertClassObj");
+		assert(newClass.refcount == 2, "testInsertClassObj refcount");
+	}
+
+	public void testRemoveClassObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=new classObj(null);
+		layer.insertClass(newClass,0);
+		layer.removeClass(0);
+		
+		map=null; layer=null;
+		gc();
+		assert(newClass.refcount == 1, "testRemoveClassObj");
+	}
+
+	public void testInsertClassObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=new classObj(null);
+		layer.insertClass(newClass,0);
+		classObj reference = layer.getClass(0);
+
+		assert(newClass.refcount == 3, "testInsertClassObjDestroy precondition");
+		newClass.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
+		map=null; layer=null; newClass=null;
+		gc();
+		assert(reference.refcount == 2, "testInsertClassObjDestroy");
+	}
+
+	public void testInsertStyleObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj classobj=layer.getClass(0);
+		styleObj newStyle = new styleObj(null);
+		classobj.insertStyle(newStyle,-1);
+		
+		assert(newStyle.refcount == 2, "testInsertStyleObj precondition");
+		map=null; layer=null; classobj=null;
+		gc();
+		assert(newStyle.refcount == 2, "testInsertStyleObj");
+	}
+
+	public void testRemoveStyleObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj classobj=layer.getClass(0);
+		styleObj newStyle = new styleObj(null);
+		classobj.insertStyle(newStyle,0);
+		classobj.removeStyle(0);
+		
+		map=null; layer=null; classobj=null;
+		gc();
+		assert(newStyle.refcount == 1, "testRemoveStyleObj");
+	}
+
+	public void testInsertStyleObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj classobj=layer.getClass(0);
+		styleObj newStyle = new styleObj(null);
+		classobj.insertStyle(newStyle,0);
+		styleObj reference = classobj.getStyle(0);
+		
+		assert(newStyle.refcount == 3, "testInsertStyleObjDestroy precondition");
+		newStyle.Dispose(); // force the destruction for Mono on Windows because of the constructor overload
+		map=null; layer=null; classobj=null; newStyle=null;
+		gc();
+		assert(reference.refcount == 2, "testInsertStyleObjDestroy");
+	}
+
+	public void testGetClassObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=layer.getClass(0);
+		
+		map=null; layer=null;
+		gc();
+		assertNotNull(newClass.layer, "testGetClassObj");
+		assert(newClass.refcount == 2, "testGetClassObj refcount");
+	}
+
+	public void testGetClassObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=layer.getClass(0);
+		classObj reference = layer.getClass(0);
+		
+		assert(newClass.refcount == 3, "testGetClassObjDestroy precondition");
+		map=null; layer=null; newClass=null;
+		gc();
+		assert(reference.refcount == 2, "testGetClassObjDestroy");
+	}
+
+	public void testGetStyleObj() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj classobj=layer.getClass(0);
+		styleObj style=classobj.getStyle(0);
+		
+		map=null; layer=null; classobj=null;
+		gc();
+		assert(style.refcount == 2, "testGetStyleObj");
+	}
+
+	public void testGetStyleObjDestroy() 
+	{
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj classobj=layer.getClass(0);
+		styleObj style=classobj.getStyle(0);
+		styleObj reference=classobj.getStyle(0);
+		
+		assert(style.refcount == 3, "testGetStyleObjDestroy precondition");
+		map=null; layer=null; classobj=null; style=null;
+		gc();
+		assert(reference.refcount == 2, "testGetStyleObjDestroy");
+	}
+
+	public void gc() {
+		for (int i=0; i<100; i++) {
+			GC.Collect();
+			GC.WaitForPendingFinalizers();
+		}
+	}
+	
+	public void assertNotNull(object o, string test) {
+		if ( o != null )
+			Console.WriteLine("\t- "+test+" PASSED");
+		else
+		{
+			Console.WriteLine("\t- "+test+" FAILED");
+			++fails;
+		}
+	}
+
+	public void assert(bool val, string test) 
+	{
+		if ( val )
+			Console.WriteLine("\t- "+test+" PASSED");
+		else
+		{
+			Console.WriteLine("\t- "+test+" FAILED");
+			++fails;
+		}
+	}
+}
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/drawmap.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmap.cs
--- 8.0.1-5/src/mapscript/csharp/examples/drawmap.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmap.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,83 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to create an image given a mapfile.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *           Yew K Choo, ykchoo@geozervice.com 
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using OSGeo.MapServer;	
+
+/// <summary>
+/// A C# based mapscript mapscript example to create an image given a mapfile.
+/// </summary>
+class DrawMap
+{
+  public static void usage() 
+  { 
+	Console.WriteLine("usage: DrawMap {mapfile} {outfile} {imagetype optional}");
+	System.Environment.Exit(-1);
+  }
+		  
+  public static void Main(string[] args)
+  {
+    Console.WriteLine("");
+	if (args.Length < 2) usage();
+    
+	mapObj m_obj = new mapObj(args[0]);
+
+	if (args.Length >= 3) 
+	{
+      Console.WriteLine("Setting the imagetype to " + args[2]);
+	  m_obj.setImageType(args[2]);
+	}
+
+	Console.WriteLine ("# Map layers " + m_obj.numlayers + "; Map name = " + m_obj.name);	
+	for (int i=0; i<m_obj.numlayers; i++) 
+	{
+	  Console.WriteLine("Layer [" + i + "] name: " + m_obj.getLayer(i).name);
+	}
+	
+    imageObj i_obj = m_obj.draw();
+	Console.WriteLine("Image URL = " + i_obj.imageurl + "; Image path = " + i_obj.imagepath);    
+	Console.WriteLine("Image height = " + i_obj.height + "; width = " + i_obj.width); 
+	try 
+	{
+	  i_obj.save(args[1],m_obj);
+    } 
+	catch (Exception ex) 
+	{
+                Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
+                Console.WriteLine( 
+                    "\nHelpLink ---\n{0}", ex.HelpLink );
+                Console.WriteLine( "\nSource ---\n{0}", ex.Source );
+                Console.WriteLine( 
+                    "\nStackTrace ---\n{0}", ex.StackTrace );
+                Console.WriteLine( 
+                    "\nTargetSite ---\n{0}", ex.TargetSite );	}	
+  }
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/drawmapDirect.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapDirect.cs
--- 8.0.1-5/src/mapscript/csharp/examples/drawmapDirect.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapDirect.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,100 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to draw the map directly onto a GDI
+ *           device context.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using System.Drawing;
+using System.Drawing.Imaging;
+using OSGeo.MapServer;	
+
+/// <summary>
+/// A C# based mapscript example to draw the map directly onto a GDI device context.
+/// </summary>
+class DrawMap
+{
+  public static void usage() 
+  { 
+	Console.WriteLine("usage: DrawMapDirect {mapfile} {outfile}");
+	System.Environment.Exit(-1);
+  }
+		  
+  public static void Main(string[] args)
+  {
+    Console.WriteLine("");
+	if (args.Length < 2) usage();
+    
+	mapObj map = new mapObj(args[0]);
+
+    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
+    for (int i = 0; i < map.numlayers; i++) 
+	{
+        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
+	}
+
+    try
+    {
+        // Create the output format
+        outputFormatObj of = new outputFormatObj("CAIRO/WINGDI", "cairowinGDI");
+        map.appendOutputFormat(of);
+        map.selectOutputFormat("cairowinGDI");
+
+        Bitmap mapImage = new Bitmap(map.width, map.height, PixelFormat.Format32bppRgb);
+
+        using (Graphics g = Graphics.FromImage(mapImage))
+        {
+            IntPtr hdc = g.GetHdc();
+            try
+            {
+                // Attach the device to the outputformat for drawing
+                of.attachDevice(hdc);
+                // Drawing directly to the GDI context
+                using (imageObj image = map.draw()) { };
+            }
+            finally
+            {
+                of.attachDevice(IntPtr.Zero);
+                g.ReleaseHdc(hdc);
+            }
+        }
+
+        mapImage.Save(args[1]);
+    } 
+	catch (Exception ex) 
+	{
+                Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
+                Console.WriteLine( 
+                    "\nHelpLink ---\n{0}", ex.HelpLink );
+                Console.WriteLine( "\nSource ---\n{0}", ex.Source );
+                Console.WriteLine( 
+                    "\nStackTrace ---\n{0}", ex.StackTrace );
+                Console.WriteLine( 
+                    "\nTargetSite ---\n{0}", ex.TargetSite );	}	
+  }
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/drawmapDirectPrint.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapDirectPrint.cs
--- 8.0.1-5/src/mapscript/csharp/examples/drawmapDirectPrint.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapDirectPrint.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,116 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to draw the map directly onto a GDI
+ *           printing device context.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using System.Drawing;
+using System.Drawing.Printing;
+using OSGeo.MapServer;	
+
+/// <summary>
+/// A C# based mapscript example to draw the map directly onto a GDI printing device context.
+/// </summary>
+class DrawMap
+{
+  public static void usage() 
+  { 
+	Console.WriteLine("usage: DrawMapDirectPrint {mapfile} {printername}");
+	System.Environment.Exit(-1);
+  }
+
+  static mapObj map;
+		  
+  public static void Main(string[] args)
+  {
+    Console.WriteLine("");
+	if (args.Length < 2) usage();
+    
+	map = new mapObj(args[0]);
+
+    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
+    for (int i = 0; i < map.numlayers; i++) 
+    {
+        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
+    }
+
+    try
+    {
+        PrintDocument doc = new PrintDocument();
+
+        doc.PrintPage += new PrintPageEventHandler(doc_PrintPage);
+
+        // Specify the printer to use.
+        doc.PrinterSettings.PrinterName = args[1];
+
+        doc.Print();
+    } 
+    catch (Exception ex) 
+    {
+                Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
+                Console.WriteLine( 
+                    "\nHelpLink ---\n{0}", ex.HelpLink );
+                Console.WriteLine( "\nSource ---\n{0}", ex.Source );
+                Console.WriteLine( 
+                    "\nStackTrace ---\n{0}", ex.StackTrace );
+                Console.WriteLine( 
+                    "\nTargetSite ---\n{0}", ex.TargetSite );	}	
+    }
+
+    static void doc_PrintPage(object sender, PrintPageEventArgs e)
+    {
+        // Create the output format
+        outputFormatObj of = new outputFormatObj("CAIRO/WINGDIPRINT", "cairowinGDIPrint");
+        map.appendOutputFormat(of);
+        map.selectOutputFormat("cairowinGDIPrint");
+        map.resolution = e.Graphics.DpiX;
+        Console.WriteLine("map resolution = " + map.resolution.ToString() + "DPI  defresolution = " + map.defresolution.ToString() + " DPI");
+        // Calculating the desired image size to cover the entire area; 
+        map.width = Convert.ToInt32(e.PageBounds.Width * e.Graphics.DpiX / 100);
+        map.height = Convert.ToInt32(e.PageBounds.Height * e.Graphics.DpiY / 100);
+
+        Console.WriteLine("map size = " + map.width.ToString() + " * " + map.height.ToString() + " pixels");
+
+        IntPtr hdc = e.Graphics.GetHdc();
+        try
+        {
+            // Attach the device to the outputformat for drawing
+            of.attachDevice(hdc);
+            // Drawing directly to the GDI context
+            using (imageObj image = map.draw()) { };
+        }
+        finally
+        {
+            of.attachDevice(IntPtr.Zero);
+            e.Graphics.ReleaseHdc(hdc);
+        }
+
+        e.HasMorePages = false;
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/drawmapGDIPlus.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapGDIPlus.cs
--- 8.0.1-5/src/mapscript/csharp/examples/drawmapGDIPlus.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapGDIPlus.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,97 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to draw the map directly onto a GDI+ bitmap.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using System.Diagnostics;
+using System.Drawing;
+using System.Drawing.Imaging;
+using OSGeo.MapServer;	
+
+/// <summary>
+/// A C# based mapscript example to draw the map directly onto a GDI+ bitmap.
+/// </summary>
+class DrawMap
+{
+  public static void usage() 
+  { 
+	Console.WriteLine("usage: DrawMapGDIPlus {mapfile} {outfile}");
+	System.Environment.Exit(-1);
+  }
+		  
+  public static void Main(string[] args)
+  {
+    Console.WriteLine("");
+	if (args.Length < 2) usage();
+    
+	mapObj map = new mapObj(args[0]);
+
+    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
+    for (int i = 0; i < map.numlayers; i++) 
+	{
+        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
+	}
+
+    try
+    {
+        Bitmap mapImage = new Bitmap(map.width, map.height, PixelFormat.Format32bppRgb);
+        Stopwatch stopwatch = new Stopwatch();
+        stopwatch.Start();
+        using (imageObj image = map.draw())
+        {
+            BitmapData bitmapData = mapImage.LockBits(new Rectangle(0, 0, image.width, image.height), ImageLockMode.ReadWrite, PixelFormat.Format32bppRgb);
+            try
+            {
+                if (image.getRawPixels(bitmapData.Scan0) == (int)MS_RETURN_VALUE.MS_FAILURE)
+                {
+                    Console.WriteLine("Unable to get image contents");
+                }
+            }
+            finally
+            {
+                mapImage.UnlockBits(bitmapData);
+            }
+
+            Console.WriteLine("Rendering time: " + stopwatch.ElapsedMilliseconds + "ms");
+
+            mapImage.Save(args[1]);
+        }    
+    } 
+	catch (Exception ex) 
+	{
+        Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
+        Console.WriteLine( 
+            "\nHelpLink ---\n{0}", ex.HelpLink );
+        Console.WriteLine( "\nSource ---\n{0}", ex.Source );
+        Console.WriteLine( 
+            "\nStackTrace ---\n{0}", ex.StackTrace );
+        Console.WriteLine( 
+            "\nTargetSite ---\n{0}", ex.TargetSite );	}	
+  }
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/drawmapWPF.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapWPF.cs
--- 8.0.1-5/src/mapscript/csharp/examples/drawmapWPF.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawmapWPF.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,109 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to draw the map directly onto a WPF image.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using System.IO;
+using System.Diagnostics;
+using System.Windows;
+using System.Windows.Media;
+using System.Windows.Media.Imaging;
+using OSGeo.MapServer;	
+
+/// <summary>
+/// A C# based mapscript example to draw the map directly onto a WPF image.
+/// </summary>
+class DrawMap
+{
+  public static void usage() 
+  { 
+	Console.WriteLine("usage: DrawMapWPF {mapfile} {outfile}");
+	System.Environment.Exit(-1);
+  }
+		  
+  public static void Main(string[] args)
+  {
+    Console.WriteLine("");
+	if (args.Length < 2) usage();
+    
+	mapObj map = new mapObj(args[0]);
+
+    Console.WriteLine("# Map layers " + map.numlayers + "; Map name = " + map.name);
+    for (int i = 0; i < map.numlayers; i++) 
+	{
+        Console.WriteLine("Layer [" + i + "] name: " + map.getLayer(i).name);
+	}
+
+    try
+    {
+        WriteableBitmap mapImage = new WriteableBitmap(map.width, map.height, 96, 96, PixelFormats.Bgr32, null);
+        Stopwatch stopwatch = new Stopwatch();
+        stopwatch.Start();
+        using (imageObj image = map.draw())
+        {
+            // Reserve the back buffer for updates.
+            mapImage.Lock();
+            try
+            {
+                if (image.getRawPixels(mapImage.BackBuffer) == (int)MS_RETURN_VALUE.MS_FAILURE)
+                {
+                    Console.WriteLine("Unable to get image contents");
+                }
+                // Specify the area of the bitmap that changed.
+                mapImage.AddDirtyRect(new Int32Rect(0, 0, map.width, map.height));
+            }
+            finally
+            {
+                // Release the back buffer and make it available for display.
+                mapImage.Unlock();
+            }
+
+            Console.WriteLine("Rendering time: " + stopwatch.ElapsedMilliseconds + "ms");
+
+            // Save the bitmap into a file.
+            using (FileStream stream = new FileStream(args[1], FileMode.Create))
+            {
+                PngBitmapEncoder encoder = new PngBitmapEncoder();
+                encoder.Frames.Add(BitmapFrame.Create(mapImage));
+                encoder.Save(stream);
+            }
+        }    
+    } 
+	catch (Exception ex) 
+	{
+        Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
+        Console.WriteLine( 
+            "\nHelpLink ---\n{0}", ex.HelpLink );
+        Console.WriteLine( "\nSource ---\n{0}", ex.Source );
+        Console.WriteLine( 
+            "\nStackTrace ---\n{0}", ex.StackTrace );
+        Console.WriteLine( 
+            "\nTargetSite ---\n{0}", ex.TargetSite );	}	
+  }
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/drawquery.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawquery.cs
--- 8.0.1-5/src/mapscript/csharp/examples/drawquery.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/drawquery.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,178 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to use the atribute query and 
+ *           highlight the results.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using OSGeo.MapServer;
+
+/// <summary>
+/// A C# based mapscript example to use the arribute query an highlight the results.
+/// </summary>
+class DrawQuery
+{
+    public static void usage() 
+    { 
+	    Console.WriteLine("usage: QueryMap {mapfile} {query string} {outfile} {-zoom}");
+	    System.Environment.Exit(-1);
+    }
+    		  
+    public static void Main(string[] args)
+    {
+        Console.WriteLine("");
+		if (args.Length < 3 || args.Length > 4) usage();
+        
+        bool ZoomToResults = (args.Length == 4 && args[3] == "-zoom");
+
+	    mapObj map = new mapObj(args[0]);	
+	    Console.WriteLine ("# Map layers " + map.numlayers + "; Map name = " + map.name);
+        
+        QueryByAttribute(args[1], map, ZoomToResults);
+
+        map.querymap.status = mapscript.MS_ON;
+        map.querymap.color.setRGB(0,0,255,255);
+        map.querymap.style = (int)MS_QUERYMAP_STYLES.MS_HILITE;
+
+        try 
+        {
+            imageObj image = map.drawQuery();
+            image.save(args[2],map);
+        } 
+        catch (Exception ex) 
+        {
+            Console.WriteLine( "QueryMap: ", ex.Message );
+        }
+    }
+
+    private static bool IsLayerQueryable(layerObj layer)
+    {
+        if ( layer.type == MS_LAYER_TYPE.MS_LAYER_TILEINDEX )
+            return false;
+
+        if(layer.template != null && layer.template.Length > 0) return true;
+
+        for(int i=0; i<layer.numclasses; i++) 
+        {
+            if(layer.getClass(i).template != null && layer.getClass(i).template.Length > 0)
+                                                        return true;
+        }
+        return false;
+    }
+
+    public static void QueryByAttribute(string qstring, mapObj map, bool zoomToResults)
+    {
+        Console.WriteLine("\nPerforming QueryByAttribute:");
+        try
+        {
+        	layerObj layer;
+            rectObj query_bounds = null;
+            for (int i = 0; i < map.numlayers; i++)
+            {
+                layer = map.getLayer(i);
+                if (layer.connection != null && IsLayerQueryable(layer))
+                {
+                    Console.WriteLine("Layer [" + i + "] name: " + layer.name);
+                    BuildQuery(layer, qstring);
+                    // zoom to the query results
+                    using (resultCacheObj results = layer.getResults())
+                    {
+                        if (results != null && results.numresults > 0)
+                        {
+                            // calculating the extent of the results
+                            if (query_bounds == null)
+                                query_bounds = new rectObj(results.bounds.minx, results.bounds.miny,
+                                    results.bounds.maxx, results.bounds.maxy,0);
+                            else
+                            {
+                                if (results.bounds.minx < query_bounds.minx) query_bounds.minx = results.bounds.minx;
+                                if (results.bounds.miny < query_bounds.miny) query_bounds.miny = results.bounds.miny;
+                                if (results.bounds.maxx > query_bounds.maxx) query_bounds.maxx = results.bounds.maxx;
+                                if (results.bounds.maxy > query_bounds.maxy) query_bounds.maxy = results.bounds.maxy;
+                            }
+                        }
+                    }
+                }
+            }
+            // setting the map extent to the result bounds
+			if (query_bounds != null) 
+			{
+				if (zoomToResults) 
+				{
+					map.setExtent(query_bounds.minx, query_bounds.miny, query_bounds.maxx, query_bounds.maxy);
+					map.scaleExtent(1.2, 0, 0); // increasing the visible area
+					Console.WriteLine("Current map scale: 1:" + (int)map.scaledenom);
+				}
+			}
+			else
+				Console.WriteLine("The query returned 0 results ...");
+        }
+        catch (Exception e)
+        {
+        	Console.WriteLine("QueryByAttribute: " + e.Message);
+        }
+    }
+
+    private static void BuildQuery(layerObj layer, string qstring)
+    {
+        if (layer != null && layer.map != null)
+        {
+            /*layer.open();
+            string qs = "";
+            string att = "";
+            for (int i=0; i < layer.numitems; i++)
+            {
+                if (qs == "")
+                {
+                    qs = "(";
+                    att = layer.getItem(i);
+                }
+                else
+                {
+                    qs += " OR ";
+                }
+                qs += "'[" + layer.getItem(i) + "]'='" + qstring + "'";
+            }
+            qs += ")";
+            layer.close();*/
+            string qs = qstring;
+            string att = null;
+
+            Console.WriteLine("Query string: " + qs);
+            
+            try
+            {
+                layer.queryByAttributes(layer.map, att, qs, 1);
+            }
+            catch (Exception e)
+            {
+                Console.WriteLine("BuildQuery: " + e.Message);
+            }
+        }
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/getbytes.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/getbytes.cs
--- 8.0.1-5/src/mapscript/csharp/examples/getbytes.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/getbytes.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,83 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based mapscript example to show the usage of 
+ *           imageObj.getBytes.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using System.Drawing;
+using System.IO;
+using OSGeo.MapServer;
+
+/// <summary>
+/// A C# based mapscript example to show the usage of imageObj.getBytes.
+/// </summary>
+class GetBytes
+{
+    public static void usage() 
+    { 
+	    Console.WriteLine("usage: getbytes {mapfile} {outfile}");
+	    System.Environment.Exit(-1);
+    }
+    		  
+    public static void Main(string[] args)
+    {
+        if (args.Length < 2) usage();
+        
+        try 
+        {
+			mapObj map = new mapObj(args[0]);
+
+			using(imageObj image = map.draw())
+			{
+				// solution 1
+				Console.WriteLine ("Drawing map: '" + map.name + "' using imageObj.getBytes");
+				
+				byte[] img = image.getBytes();
+				using (MemoryStream ms = new MemoryStream(img))
+				{
+					Image mapimage = Image.FromStream(ms);
+					mapimage.Save(args[1]);
+				}
+				
+				// solution 2
+				Console.WriteLine ("Drawing map: '" + map.name + "' using imageObj.write");
+
+				using (FileStream fs = File.Open("_" + args[1], FileMode.OpenOrCreate, FileAccess.ReadWrite))
+				{
+					image.write(fs);
+				}
+			}
+        } 
+        catch (Exception ex) 
+        {
+            Console.WriteLine( "GetBytes: ", ex.Message );
+        }
+    }
+
+}
+
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/inline.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/inline.cs
--- 8.0.1-5/src/mapscript/csharp/examples/inline.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/inline.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,136 @@
+/******************************************************************************
+ * $Id: shapeinfo.cs 7418 2008-02-29 00:02:49Z nsavard $
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based based mapscript example to dump information from 
+ *           a shapefile.
+ * Author:   Tamas Szekeres, szekerest@gmail.com 
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using System.Collections;
+using OSGeo.MapServer;
+
+/// <summary>
+/// A MapScript application for creating inline layers with annotations.
+/// </summary> 
+class Inline {
+
+  public static void usage()
+  {
+      Console.WriteLine("usage: inline [outformat] [outfile]");
+      System.Environment.Exit(-1);
+  }
+  	
+  public static void Main(string[] args) 
+  {
+
+      if (args.Length < 2) usage();
+
+      // creating a new map from scratch
+      mapObj map = new mapObj(null);
+      // adding a layer
+      layerObj layer = new layerObj(map);
+      layer.type = MS_LAYER_TYPE.MS_LAYER_POINT;
+      layer.status = mapscript.MS_ON;
+      layer.connectiontype = MS_CONNECTION_TYPE.MS_INLINE;
+      // define the attribute names from the inline layer
+      layer.addProcessing("ITEMS=attribute1,attribute2,attribute3");
+      // define the class
+      classObj classobj = new classObj(layer);
+      classobj.template = "query";   // making the layer queryable
+      // setting up the text based on multiple attributes
+      classobj.setText("('Shape:' + '[attribute1]' + ' Color:' + '[attribute2]' + ' Size:' + '[attribute3]')");
+      // define the label
+      classobj.label.outlinecolor = new colorObj(255, 255, 255, 0);
+      classobj.label.force = mapscript.MS_TRUE;
+      classobj.label.size = (double)MS_BITMAP_FONT_SIZES.MS_MEDIUM;
+      classobj.label.position = (int)MS_POSITIONS_ENUM.MS_LC;
+      classobj.label.wrap = ' ';
+      // set up attribute binding
+      classobj.label.setBinding((int)MS_LABEL_BINDING_ENUM.MS_LABEL_BINDING_COLOR, "attribute2");
+      // define the style
+      styleObj style = new styleObj(classobj);
+      style.color = new colorObj(0, 255, 255, 0);
+      style.setBinding((int)MS_STYLE_BINDING_ENUM.MS_STYLE_BINDING_COLOR, "attribute2");
+      style.setBinding((int)MS_STYLE_BINDING_ENUM.MS_STYLE_BINDING_SIZE, "attribute3");
+
+      Random rand = new Random((int)DateTime.Now.ToFileTime()); ;
+
+      // creating the shapes
+      for (int i = 0; i < 10; i++)
+      {
+          shapeObj shape = new shapeObj((int)MS_SHAPE_TYPE.MS_SHAPE_POINT);
+
+          // setting the shape attributes
+          shape.initValues(4);
+          shape.setValue(0, Convert.ToString(i));
+          shape.setValue(1, new colorObj(rand.Next(255), rand.Next(255), rand.Next(255), 0).toHex());
+          shape.setValue(2, Convert.ToString(rand.Next(25) + 5));
+
+          lineObj line = new lineObj();
+          line.add(new pointObj(rand.Next(400) + 25, rand.Next(400) + 25, 0, 0));
+          shape.add(line);
+          layer.addFeature(shape);
+      }
+
+      map.width = 500;
+      map.height = 500;
+      map.setExtent(0,0,450,450);
+      map.selectOutputFormat(args[0]);
+      imageObj image = map.draw();
+      image.save(args[1], map);
+
+      //perform a query
+      layer.queryByRect(map, new rectObj(0, 0, 450, 450, 0));
+
+      resultObj res;
+      shapeObj feature;
+      using (resultCacheObj results = layer.getResults())
+      {
+          if (results != null && results.numresults > 0)
+          {
+              // extracting the features found
+              layer.open();
+              for (int j = 0; j < results.numresults; j++)
+              {
+                  res = results.getResult(j);
+                  feature = layer.getShape(res);
+                  if (feature != null)
+                  {
+                      Console.WriteLine("  Feature: shapeindex=" + res.shapeindex + " tileindex=" + res.tileindex);
+                      for (int k = 0; k < layer.numitems; k++)
+                      {
+                          Console.Write("     " + layer.getItem(k));
+                          Console.Write(" = ");
+                          Console.Write(feature.getValue(k));
+                          Console.WriteLine();
+                      }
+                  }
+              }
+              layer.close();
+          }
+      }
+  }
+}
\ No newline at end of file
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/shapeinfo.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/shapeinfo.cs
--- 8.0.1-5/src/mapscript/csharp/examples/shapeinfo.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/shapeinfo.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,63 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based based mapscript example to dump information from 
+ *           a shapefile.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *           Yew K Choo, ykchoo@geozervice.com 
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using System.Collections;
+using OSGeo.MapServer;
+
+/// <summary>
+/// A C# based mapscript mapscript to dump information from a shapefile.
+/// </summary> 
+class ShapeInfo {
+	
+  public static void usage() 
+  { 
+	Console.WriteLine("usage: shapeinfo {shapefile}");
+	System.Environment.Exit(-1);
+  }
+  
+  	
+  public static void Main(string[] args) {
+	 
+	if (args.Length != 1) usage();
+
+	Hashtable ht = new Hashtable();
+	ht.Add(1,"point");	
+	ht.Add(3,"arc");	
+	ht.Add(5,"polygon");
+	ht.Add(8,"multipoint");
+		
+    shapefileObj shpObj = new shapefileObj(args[0],-1); 
+    Console.WriteLine ("ShapeType = " + ht[shpObj.type]);
+    Console.WriteLine ("Num shapes = " + shpObj.numshapes);
+    Console.WriteLine ("(xmin, ymin) = (" + shpObj.bounds.minx + "," + shpObj.bounds.miny + ") (xmax, ymax) = (" + shpObj.bounds.maxx + "," + shpObj.bounds.maxy + ")");
+  }
+}
\ No newline at end of file
diff -pruN 8.0.1-5/src/mapscript/csharp/examples/shpdump.cs 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/shpdump.cs
--- 8.0.1-5/src/mapscript/csharp/examples/shpdump.cs	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/examples/shpdump.cs	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,68 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  A C# based based mapscript example to dump information from 
+ *           a shapefile.
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *           Yew K Choo, ykchoo@geozervice.com 
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+using System;
+using OSGeo.MapServer;
+
+/// <summary>
+/// A C# based mapscript mapscript to dump information from a shapefile.
+/// </summary>  
+class ShapeDump {
+  public static void usage() 
+  { 
+	Console.WriteLine("usage: shpdump {shapefile}");
+	System.Environment.Exit(-1);
+  }
+  	
+  public static void Main(string[] args) {
+
+	if (args.Length != 1) usage();
+		  
+ 	shapefileObj sf_obj = new shapefileObj(args[0],-1); 
+	shapeObj s_obj = new shapeObj(-1);
+	for (int i=0; i<sf_obj.numshapes; i++) 
+	{
+	  sf_obj.get(i, s_obj);
+	  Console.WriteLine("Shape " + i + " has " + s_obj.numlines + " part(s)");
+	  Console.WriteLine("bounds (" + s_obj.bounds.minx + ", " +  s_obj.bounds.miny + ") (" + s_obj.bounds.maxx + ", " + s_obj.bounds.maxy + ")" );
+	  for(int j=0; j<s_obj.numlines; j++) 
+	  {
+		lineObj l_obj = s_obj.get(j);
+		Console.WriteLine("Part " + j + " has " + l_obj.numpoints + " points.");
+                    
+		for(int k=0; k < l_obj.numpoints; k++) {
+		  pointObj p_obj = l_obj.get(k);                     
+          Console.WriteLine(k +": " + p_obj.x + ", " + p_obj.y);							
+		}
+	  }	  
+    }
+  }
+}
\ No newline at end of file
Binary files 8.0.1-5/src/mapscript/csharp/mapscript.snk and 8.2.0~beta1-1~exp1/src/mapscript/csharp/mapscript.snk differ
diff -pruN 8.0.1-5/src/mapscript/csharp/run_test.sh 8.2.0~beta1-1~exp1/src/mapscript/csharp/run_test.sh
--- 8.0.1-5/src/mapscript/csharp/run_test.sh	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/run_test.sh	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,12 @@
+#!/bin/sh -ex
+cd ${CSHARP_MAPSCRIPT_SO}
+echo .: Testing shpdump.exe :.
+LC_ALL=C mono shpdump.exe ../../../../tests/point.shp
+echo .: Testing drawmap.exe :.
+LC_ALL=C mono drawmap.exe ../../../../tests/test.map ./map.png
+echo .: Testing shapeinfo.exe :.
+LC_ALL=C mono shapeinfo.exe ../../../../tests/point.shp
+echo .: Testing getbytes.exe :.
+LC_ALL=C mono getbytes.exe ../../../../tests/test.map test_csharp2.png
+echo .: Testing RFC24.exe :.
+LC_ALL=C mono RFC24.exe ../../../../tests/test.map
diff -pruN 8.0.1-5/src/mapscript/csharp/swig_csharp_extensions.i 8.2.0~beta1-1~exp1/src/mapscript/csharp/swig_csharp_extensions.i
--- 8.0.1-5/src/mapscript/csharp/swig_csharp_extensions.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/csharp/swig_csharp_extensions.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,305 @@
+
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Fix for the SWIG Interface problems (early GC)
+ *           and implementing SWIGTYPE *DISOWN
+ * Author:   Tamas Szekeres, szekerest@gmail.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+// Ensure the class is not marked BeforeFieldInit causing memory corruption with CLR4 
+%pragma(csharp) imclasscode=%{
+
+  public class UTF8Marshaler : System.Runtime.InteropServices.ICustomMarshaler {
+    static UTF8Marshaler static_instance;
+
+    public System.IntPtr MarshalManagedToNative(object managedObj) {
+        if (managedObj == null)
+            return System.IntPtr.Zero;
+        if (!(managedObj is string))
+            throw new System.Runtime.InteropServices.MarshalDirectiveException(
+                   "UTF8Marshaler must be used on a string.");
+
+        // not null terminated
+        byte[] strbuf = System.Text.Encoding.UTF8.GetBytes((string)managedObj);
+        System.IntPtr buffer = System.Runtime.InteropServices.Marshal.AllocHGlobal(strbuf.Length + 1);
+        System.Runtime.InteropServices.Marshal.Copy(strbuf, 0, buffer, strbuf.Length);
+
+        // write the terminating null
+        System.Runtime.InteropServices.Marshal.WriteByte(buffer, strbuf.Length, 0);
+        return buffer;
+    }
+
+    public object MarshalNativeToManaged(System.IntPtr pNativeData) {
+	    int len = System.Runtime.InteropServices.Marshal.PtrToStringAnsi(pNativeData).Length;
+        byte[] utf8data = new byte[len];
+        System.Runtime.InteropServices.Marshal.Copy(pNativeData, utf8data, 0, len);
+        return System.Text.Encoding.UTF8.GetString(utf8data);
+    }
+
+    public void CleanUpNativeData(System.IntPtr pNativeData) {
+        System.Runtime.InteropServices.Marshal.FreeHGlobal(pNativeData);
+    }
+
+    public void CleanUpManagedData(object managedObj) {
+    }
+
+    public int GetNativeDataSize() {
+        return -1;
+    }
+
+    public static System.Runtime.InteropServices.ICustomMarshaler GetInstance(string cookie) {
+        if (static_instance == null) {
+            return static_instance = new UTF8Marshaler();
+        }
+        return static_instance;
+    }
+  }
+%}
+
+%typemap(imtype, inattributes="[System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(UTF8Marshaler))]",
+  outattributes="[return: System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(UTF8Marshaler))]")
+  char *, char *&, char[ANY], char[]   "string"
+
+%typemap(csout, excode=SWIGEXCODE) SWIGTYPE {
+    /* %typemap(csout, excode=SWIGEXCODE) SWIGTYPE */
+    $&csclassname ret = new $&csclassname($imcall, true, null);$excode
+    return ret;
+  }
+
+%typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE & {
+    /* typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE & */
+    $csclassname ret = new $csclassname($imcall, $owner, ThisOwn_$owner());$excode
+    return ret;
+  }
+%typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) {
+    /* %typemap(csout, excode=SWIGEXCODE, new="1") SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) */
+    System.IntPtr cPtr = $imcall;
+    $csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $csclassname(cPtr, $owner, ThisOwn_$owner());$excode
+    return ret;
+  }
+%typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE %{
+    /* %typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE */
+    get {
+      $&csclassname ret = new $&csclassname($imcall, $owner, ThisOwn_$owner());$excode
+      return ret;
+    } %}
+%typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE & %{
+    /* %typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE & */
+    get {
+      $csclassname ret = new $csclassname($imcall, $owner, ThisOwn_$owner());$excode
+      return ret;
+    } %}
+%typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE *, struct SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) %{
+    /* %typemap(csvarout, excode=SWIGEXCODE2) SWIGTYPE *, SWIGTYPE [], SWIGTYPE (CLASS::*) */
+    get {
+      System.IntPtr cPtr = $imcall;
+      $csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $csclassname(cPtr, $owner, ThisOwn_$owner());$excode
+      return ret;
+    } %}
+%typemap(csout, excode=SWIGEXCODE) SWIGTYPE *& {
+    /* %typemap(csout, excode=SWIGEXCODE) SWIGTYPE *& */
+    System.IntPtr cPtr = $imcall;
+    $*csclassname ret = (cPtr == System.IntPtr.Zero) ? null : new $*csclassname(cPtr, $owner, ThisOwn_$owner());$excode
+    return ret;
+  }
+// Proxy classes (base classes, ie, not derived classes)
+%typemap(csbody) SWIGTYPE %{
+  /* %typemap(csbody) SWIGTYPE */
+  private System.Runtime.InteropServices.HandleRef swigCPtr;
+  protected bool swigCMemOwn;
+  protected object swigParentRef;
+  
+  protected static object ThisOwn_true() { return null; }
+  protected object ThisOwn_false() { return this; }
+
+  internal $csclassname(System.IntPtr cPtr, bool cMemoryOwn, object parent) {
+    swigCMemOwn = cMemoryOwn;
+    swigParentRef = parent;
+    swigCPtr = new System.Runtime.InteropServices.HandleRef(this, cPtr);
+  }
+
+  internal static System.Runtime.InteropServices.HandleRef getCPtr($csclassname obj) {
+    return (obj == null) ? new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero) : obj.swigCPtr;
+  }
+  internal static System.Runtime.InteropServices.HandleRef getCPtrAndDisown($csclassname obj, object parent) {
+    if (obj != null)
+    {
+      obj.swigCMemOwn = false;
+      obj.swigParentRef = parent;
+      return obj.swigCPtr;
+    }
+    else
+    {
+      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
+    }
+  }
+  internal static System.Runtime.InteropServices.HandleRef getCPtrAndSetReference($csclassname obj, object parent) {
+    if (obj != null)
+    {
+      obj.swigParentRef = parent;
+      return obj.swigCPtr;
+    }
+    else
+    {
+      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
+    }
+  }
+%}
+
+// Derived proxy classes
+%typemap(csbody_derived) SWIGTYPE %{
+  /* %typemap(csbody_derived) SWIGTYPE */
+  private System.Runtime.InteropServices.HandleRef swigCPtr;
+
+  internal $csclassname(System.IntPtr cPtr, bool cMemoryOwn, object parent) : base($modulePINVOKE.$csclassnameUpcast(cPtr), cMemoryOwn, parent) {
+    swigCPtr = new System.Runtime.InteropServices.HandleRef(this, cPtr);
+  }
+
+  internal static System.Runtime.InteropServices.HandleRef getCPtr($csclassname obj) {
+    return (obj == null) ? new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero) : obj.swigCPtr;
+  }
+  internal static System.Runtime.InteropServices.HandleRef getCPtrAndDisown($csclassname obj, object parent) {
+    if (obj != null)
+    {
+      obj.swigCMemOwn = false;
+      obj.swigParentRef = parent;
+      return obj.swigCPtr;
+    }
+    else
+    {
+      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
+    }
+  }
+  internal static System.Runtime.InteropServices.HandleRef getCPtrAndSetReference($csclassname obj, object parent) {
+    if (obj != null)
+    {
+      obj.swigParentRef = parent;
+      return obj.swigCPtr;
+    }
+    else
+    {
+      return new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
+    }
+  }
+%}
+
+// Typewrapper classes
+%typemap(csbody) SWIGTYPE *, SWIGTYPE &, SWIGTYPE [], SWIGTYPE (CLASS::*) %{
+  /* %typemap(csbody) SWIGTYPE *, SWIGTYPE &, SWIGTYPE [], SWIGTYPE (CLASS::*) */
+  private System.Runtime.InteropServices.HandleRef swigCPtr;
+
+  internal $csclassname(System.IntPtr cPtr, bool futureUse, object parent) {
+    swigCPtr = new System.Runtime.InteropServices.HandleRef(this, cPtr);
+  }
+
+  protected $csclassname() {
+    swigCPtr = new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
+  }
+
+  internal static System.Runtime.InteropServices.HandleRef getCPtr($csclassname obj) {
+    return (obj == null) ? new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero) : obj.swigCPtr;
+  }
+%}
+
+#if SWIG_VERSION < 0x040000
+%typemap(csfinalize) SWIGTYPE %{
+  /* %typemap(csfinalize) SWIGTYPE */
+  ~$csclassname() {
+    Dispose();
+  }
+%}
+#endif
+
+%typemap(csconstruct, excode=SWIGEXCODE) SWIGTYPE %{: this($imcall, true, null) {$excode
+  }
+%}
+
+#if SWIG_VERSION < 0x040000
+%typemap(csdestruct, methodname="Dispose", methodmodifiers="public") SWIGTYPE {
+  lock(this) {
+      if(swigCPtr.Handle != System.IntPtr.Zero && swigCMemOwn) {
+        swigCMemOwn = false;
+        $imcall;
+      }
+      swigCPtr = new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
+      swigParentRef = null;
+      System.GC.SuppressFinalize(this);
+    }
+  }
+#endif
+
+%typemap(csdestruct_derived, methodname="Dispose", methodmodifiers="public") TYPE {
+  lock(this) {
+      if(swigCPtr.Handle != System.IntPtr.Zero && swigCMemOwn) {
+        swigCMemOwn = false;
+        $imcall;
+      }
+      swigCPtr = new System.Runtime.InteropServices.HandleRef(null, System.IntPtr.Zero);
+      swigParentRef = null;
+      System.GC.SuppressFinalize(this);
+      base.Dispose();
+    }
+  }
+
+%typemap(csin) SWIGTYPE *DISOWN "$csclassname.getCPtrAndDisown($csinput, ThisOwn_false())"
+%typemap(csin) SWIGTYPE *SETREFERENCE "$csclassname.getCPtrAndSetReference($csinput, ThisOwn_false())"
+
+%pragma(csharp) modulecode=%{
+  /* %pragma(csharp) modulecode */
+  internal class $moduleObject : global::System.IDisposable {
+	public virtual void Dispose() {
+      
+    }
+  }
+  internal static $moduleObject the$moduleObject = new $moduleObject();
+  protected static object ThisOwn_true() { return null; }
+  protected static object ThisOwn_false() { return the$moduleObject; }
+  
+  [System.Runtime.InteropServices.DllImport("$dllimport", EntryPoint="SetEnvironmentVariable")]
+  public static extern int SetEnvironmentVariable(string envstring);
+%}
+
+
+%insert(runtime) %{
+#ifdef __cplusplus
+extern "C" 
+#endif
+#ifdef SWIGEXPORT
+SWIGEXPORT int SWIGSTDCALL SetEnvironmentVariable(const char *envstring) {
+  /* putenv may not make a copy, so do it ourselves despite the memory leak */
+  char* envstringDup = (char*)malloc(strlen(envstring)+1);
+  memcpy(envstringDup, envstring, strlen(envstring)+1);
+  return putenv(envstringDup);
+}
+#else
+DllExport int SWIGSTDCALL SetEnvironmentVariable(const char *envstring) {
+  /* putenv may not make a copy, so do it ourselves despite the memory leak */
+  char* envstringDup = (char*)malloc(strlen(envstring)+1);
+  memcpy(envstringDup, envstring, strlen(envstring)+1);
+  return putenv(envstringDup);
+}
+#endif
+%}
diff -pruN 8.0.1-5/src/mapscript/java/CMakeLists.txt 8.2.0~beta1-1~exp1/src/mapscript/java/CMakeLists.txt
--- 8.0.1-5/src/mapscript/java/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,40 @@
+find_package(SWIG REQUIRED)
+include(${SWIG_USE_FILE})
+
+find_package(JNI)
+find_package(Java)
+if(NOT JNI_INCLUDE_DIRS OR NOT Java_JAVAC_EXECUTABLE OR NOT Java_JAR_EXECUTABLE)
+   message(SEND_ERROR "Could not find required Java components. Try setting the JAVA_HOME environment variable (required on e.g. Ubuntu)")
+endif(NOT JNI_INCLUDE_DIRS OR NOT Java_JAVAC_EXECUTABLE OR NOT Java_JAR_EXECUTABLE)
+
+include_directories(${JNI_INCLUDE_DIRS})
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/java)
+set (CMAKE_SWIG_OUTDIR "${CMAKE_CURRENT_BINARY_DIR}/edu/umn/gis/mapscript")
+set(CMAKE_SWIG_FLAGS -package edu.umn.gis.mapscript)
+
+# hide warnings
+if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
+endif ()
+
+
+if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
+    swig_add_library(javamapscript TYPE MODULE LANGUAGE java SOURCES ../mapscript.i)
+else ()
+    swig_add_module(javamapscript java ../mapscript.i)
+endif ()
+
+swig_link_libraries(javamapscript ${MAPSERVER_LIBMAPSERVER})
+
+add_custom_command(TARGET javamapscript
+                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+                      POST_BUILD
+                      COMMAND ${Java_JAVAC_EXECUTABLE} edu/umn/gis/mapscript/*.java
+                      COMMAND ${Java_JAR_EXECUTABLE} cf mapscript.jar edu/umn/gis/mapscript/*.class
+                      COMMENT "Compiling java source files, creating mapscript.jar"
+                      )
+
+set(mapscript_files $<TARGET_FILE:${SWIG_MODULE_javamapscript_REAL_NAME}>)
+install(FILES ${mapscript_files} DESTINATION ${CMAKE_INSTALL_LIBDIR})
diff -pruN 8.0.1-5/src/mapscript/java/README 8.2.0~beta1-1~exp1/src/mapscript/java/README
--- 8.0.1-5/src/mapscript/java/README	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/README	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,84 @@
+Java mapscript
+==============
+
+WARNING: Starting with version 6.1 Mapserver (and Mapscript) uses libtool to build
+the shared libraries. Some files have changed names and the javamapscript.so shared
+library now depends on libmapserver.so.
+The easiest way way to handle the dependency is to simply use the 'make install'
+target.
+
+To generate the SWIG wrappers you need swig > 1.3.24.
+
+MAPSCRIPT Reference
+-------------------
+
+The complete reference documentation is available on-line:
+
+http://mapserver.gis.umn.edu/docs/reference/mapscript
+
+or in the file:
+
+../doc/mapscript.txt
+
+SWIG wrappers
+-------------
+
+MapServer releases, beginning with 4.2.4, contain pre-generated wrapper code
+(mapscript/java/mapscript_wrap.c) and class files (mapscript/java/edu).
+Nevertheless it is recommended that you generate your own using the "interface"
+target in the Java Makefile.
+
+Requires swig > 1.3.24. Version above 1.3.28 or 1.3.29 are recommended.
+
+Installation
+------------
+
+After MapServer is configured and compiled, change directory to the Java
+mapscript location and execute:
+
+    $ cd mapscript/java
+    $ make
+    $ make test (recommended)
+    $ make threadtests (optional)
+    $ make install (required as of 6.1)
+
+Remember to set the appropriate variable (LD_LIBRARY_PATH, java.library.path
+or edit /etc/ld.so.conf) to make sure Java can locate and load the libraries.
+
+Windows
+-------
+
+Edit makefile.vc to match your environment.  You will need to set JAVA_HOME 
+and SWIG_HOME to the appropriate variables.  You will likely need to copy 
+all of the DLLs needed to run MapServer into the mapscript/java directory 
+(including libmap.dll) so the mapscript.dll can see them to run.
+
+cd mapscript/java
+nmake /f makefile.vc
+nmake /f makefile.vc test
+
+International language support
+------------------------------
+
+Since May 2006 Java mapscript has complete support for international languages
+usage in queries and mapscript internals. To document this improvement
+we have created the examples/QueryByAttributeUnicode.java
+test program which uses the ISO-8859-15 encoding.
+
+http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1753
+http://thread.gmane.org/gmane.comp.gis.mapserver.user/19298/focus=19298
+http://thread.gmane.org/gmane.comp.gis.mapserver.user/19213/focus=19213
+
+Onlice resources
+----------------
+
+Java mapscript related:
+
+http://mapserver.gis.umn.edu/docs/howto/javamapscript
+http://mapserver.gis.umn.edu/docs/howto/java_mapscript_Tomcat_55
+http://mapserver.gis.umn.edu/docs/faq/thread_safety
+
+General:
+
+http://mapserver.gis.umn.edu/docs
+
diff -pruN 8.0.1-5/src/mapscript/java/data/emptymap.map 8.2.0~beta1-1~exp1/src/mapscript/java/data/emptymap.map
--- 8.0.1-5/src/mapscript/java/data/emptymap.map	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/data/emptymap.map	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,7 @@
+MAP
+   NAME   "Niedersachsen"
+   EXTENT 3400000 5700000 3700000 6000000 
+   SIZE   500 500
+
+END
+
Binary files 8.0.1-5/src/mapscript/java/data/iso-subset.dbf and 8.2.0~beta1-1~exp1/src/mapscript/java/data/iso-subset.dbf differ
Binary files 8.0.1-5/src/mapscript/java/data/iso-subset.shp and 8.2.0~beta1-1~exp1/src/mapscript/java/data/iso-subset.shp differ
Binary files 8.0.1-5/src/mapscript/java/data/iso-subset.shx and 8.2.0~beta1-1~exp1/src/mapscript/java/data/iso-subset.shx differ
diff -pruN 8.0.1-5/src/mapscript/java/data/subset-umlauts.map 8.2.0~beta1-1~exp1/src/mapscript/java/data/subset-umlauts.map
--- 8.0.1-5/src/mapscript/java/data/subset-umlauts.map	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/data/subset-umlauts.map	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,39 @@
+#
+# See http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1753
+#
+# Donated by: Nicol Hermann <nicol@nicol.info>
+# Modified by Umberto Nicoletti
+#
+MAP
+  NAME test 
+  EXTENT 3404414.882766 5429530.647216  3456884.187265 5550332.450907 
+  SIZE 600 600
+  UNITS METERS 
+  
+  LAYER
+    NAME test-iso 
+    STATUS DEFAULT
+    TYPE polygon
+    DATA "iso-subset"
+    TEMPLATE "dummy.html"
+    CLASS
+      NAME test
+      COLOR 128 128 0
+      OUTLINECOLOR 0 0 0
+    END
+  END
+  
+  LAYER
+    NAME test-utf 
+    STATUS DEFAULT
+    TYPE polygon
+    DATA "utf-subset"
+    TEMPLATE "dummy.html"
+    CLASS
+      NAME test
+      COLOR 128 128 0
+      OUTLINECOLOR 0 0 0
+    END
+  END
+END
+
Binary files 8.0.1-5/src/mapscript/java/data/utf-subset.dbf and 8.2.0~beta1-1~exp1/src/mapscript/java/data/utf-subset.dbf differ
Binary files 8.0.1-5/src/mapscript/java/data/utf-subset.shp and 8.2.0~beta1-1~exp1/src/mapscript/java/data/utf-subset.shp differ
Binary files 8.0.1-5/src/mapscript/java/data/utf-subset.shx and 8.2.0~beta1-1~exp1/src/mapscript/java/data/utf-subset.shx differ
diff -pruN 8.0.1-5/src/mapscript/java/examples/ConnPool.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/ConnPool.java
--- 8.0.1-5/src/mapscript/java/examples/ConnPool.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/ConnPool.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,19 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+ * <p>Title: Mapscript conn pool</p>
+ * <p>Description: n.a. </p>
+ * @author Umberto Nicoletti (umberto.nicoletti@gmail.com)
+ * @version 1.0
+ */
+
+public class ConnPool {
+
+  public static void main(String[] args) {
+    // at least it shouldn't crash
+    System.out.println("Running mapscript.msConnPoolCloseUnreferenced");
+    mapscript.msConnPoolCloseUnreferenced();
+    System.out.println("Finished.");
+  }
+
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/DrawMap.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/DrawMap.java
--- 8.0.1-5/src/mapscript/java/examples/DrawMap.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/DrawMap.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,39 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+ * <p>Title: Mapscript shape dump example.</p>
+ * <p>Description: A Java based mapscript example to create an image given a mapfile.</p>
+ * @author Yew K Choo 	ykchoo@geozervice.com
+ * @version 1.0
+ */
+
+public class DrawMap {
+
+  public static void usage() {
+    System.err.println("Usage: DrawMap {mapfile} {outfile}");
+    System.exit(-1);
+  }
+
+  public static void main(String[] args) {
+    if (args.length != 2) usage();
+   
+    mapObj map = new mapObj(args[0]);
+    //map.getImagecolor().setRGB(153, 153, 204);
+    //styleObj st = map.getLayer(1).getClass(0).getStyle(0);
+    //st.getColor().setHex("#000000");
+    if( map.getLayer(1).getMetadata().get("hidden") != null ) {
+    	System.out.println("Layer 1 is hidden? "+map.getLayer(1).getMetadata().get("hidden"));
+    }
+    int i=0;
+    //for (i=0; i<100; i++) {
+    	imageObj img = map.draw();
+    	System.out.println("Image size is: "+img.getSize());
+    	System.out.println("Image size from getBytes is: "+img.getBytes().length);
+    	System.out.println(i+") the map will be drawn to:"+args[1]);
+    	img.save(args[1], map);
+    //}
+    img.delete();
+    map.delete();
+    //mapscript.msCleanup();
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/DumpShp.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/DumpShp.java
--- 8.0.1-5/src/mapscript/java/examples/DumpShp.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/DumpShp.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,60 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+ * <p>Title: Mapscript shape dump example.</p>
+ * <p>Description: A Java based mapscript to dump information from a shapefile.</p>
+ * @author Yew K Choo  (ykchoo@geozervice.com)
+ * @version 1.0
+ */
+
+public class DumpShp {
+  public  static String getShapeType(int type)
+  {
+    switch (type)
+    {
+      case 1: return "point";
+      case 3: return "arc";
+      case 5: return "polygon";
+      case 8: return "multipoint";
+      default: return "unknown";
+    }
+  }
+
+  public static void usage() {
+    System.err.println("Usage: DumpShp {shapefile.shp}");
+    System.exit(-1);
+  }
+
+  public static void main(String[] args) {
+    if (args.length != 1) usage();
+
+    shapefileObj shapefile = new shapefileObj (args[0],-1);
+    System.out.println ("Shapefile opened (type = "  + getShapeType(shapefile.getType()) +
+                        " with " + shapefile.getNumshapes() + " shapes).");
+
+
+    shapeObj shape = new shapeObj(-1);
+
+    for(int i=0; i<shapefile.getNumshapes(); i++) {
+        shapefile.get(i, shape);
+
+        System.out.println("Shape[" + i + "] has " + shape.getNumlines() + " part(s)");
+        System.out.println("bounds (" + shape.getBounds().getMinx() + "," + shape.getBounds().getMiny() + ")" +
+                           "(" + shape.getBounds().getMaxx() + "," + shape.getBounds().getMaxy() + ")");
+
+        for(int j=0; j<shape.getNumlines(); j++) {
+            lineObj part = shape.get(j);
+            System.out.println("Part[" +j + "] has " + part.getNumpoints() + " point(s)");
+
+            for(int k=0; k<part.getNumpoints(); k++) {
+                pointObj point = part.get(k);
+                System.out.println("Point[" + k + "] = " + point.getX() + ", "  + point.getY());
+            }
+        }
+    }
+    // shape.delete();
+    // shapefile.delete();
+    // mapscript.msCleanup();
+  }
+
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/MakePoint.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/MakePoint.java
--- 8.0.1-5/src/mapscript/java/examples/MakePoint.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/MakePoint.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,15 @@
+/*
+ Created by unicoletti@prometeo.it to test backwards-compatible
+ pointObj constructor. See bug #1106.
+
+ 2/1/2005: Created
+*/
+
+import edu.umn.gis.mapscript.*;
+
+public class MakePoint {
+	public static void main(String[] args) {
+	pointObj result = new pointObj(0,0,0);
+	System.out.println("Point made!");
+	}
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/Metadata.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/Metadata.java
--- 8.0.1-5/src/mapscript/java/examples/Metadata.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/Metadata.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,37 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+ * <p>Title: Mapscript shape dump example.</p>
+ * <p>Description: A Java based mapscript example to create an image given a mapfile.</p>
+ * @author Yew K Choo 	ykchoo@geozervice.com
+ * @version 1.0
+ */
+
+public class Metadata {
+
+  public static void usage() {
+    System.err.println("Usage: Metadata {mapfile}");
+    System.exit(-1);
+  }
+
+  public static void main(String[] args) {
+    if (args.length != 1) usage();
+   
+    mapObj map = new mapObj(args[0]);
+    
+    for (int i=0; i<100; i++) {
+	    System.out.println("Web->key1 ? "+map.getWeb().getMetadata().get("key1",null));
+	    System.out.println("Web->key2 ? "+map.getWeb().getMetadata().get("key2",null));
+	    System.out.println("Web->key3 ? "+map.getWeb().getMetadata().get("key3",null));
+	    System.out.println("Web->key4 ? "+map.getWeb().getMetadata().get("key4",null));
+	    System.out.println("Web->key5 ? "+map.getWeb().getMetadata().get("key5",null));
+	    
+	    System.gc();
+	    System.gc();
+	    System.gc();
+	    
+	    System.out.println("Web->key1 ? "+map.getWeb().getMetadata().get("key1",null));
+    }
+    map.delete();
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/OutputFormatList.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/OutputFormatList.java
--- 8.0.1-5/src/mapscript/java/examples/OutputFormatList.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/OutputFormatList.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,29 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+ * <p>Title: Mapscript outputformat dump example.</p>
+ * @author Umberto Nicoletti 	umberto.nicoletti@gmail.com
+ * @version 1.0
+ */
+
+public class OutputFormatList {
+
+  public static void usage() {
+    System.err.println("Usage: OutputFormatList {mapfile}");
+    System.exit(-1);
+  }
+
+  public static void main(String[] args) {
+    if (args.length != 1) usage();
+   
+    mapObj map = new mapObj(args[0]);
+    for (int i=0; i<map.getNumoutputformats(); i++) {
+	outputFormatObj format = map.getOutputFormat(i);
+	System.out.println("["+i+"] Format name: "+format.getName());
+	System.out.println("\toption count: "+format.getNumformatoptions());
+	for(int j=0;j<format.getNumformatoptions();j++) {
+	    System.out.println("\t["+j+"] option: "+format.getOptionAt(j));
+	}
+    }
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/QueryByAttribute.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/QueryByAttribute.java
--- 8.0.1-5/src/mapscript/java/examples/QueryByAttribute.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/QueryByAttribute.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,37 @@
+import edu.umn.gis.mapscript.imageObj;
+import edu.umn.gis.mapscript.mapObj;
+import edu.umn.gis.mapscript.layerObj;
+import edu.umn.gis.mapscript.shapeObj;
+import edu.umn.gis.mapscript.mapscriptConstants;
+
+
+
+public class QueryByAttribute {
+	public static void main(String[] args)  {
+	  
+	String filter="A Point";
+	mapObj map = new mapObj(args[0]);
+	if (args.length == 2) {
+		filter=args[1];
+	} else {
+		filter="A Point";
+	}
+
+	layerObj layer = map.getLayerByName("POINT");
+	layer.setTemplate("template.html");
+
+	layer.queryByAttributes(map,"FNAME", filter, mapscriptConstants.MS_MULTIPLE);
+	layer.open();
+	System.out.println( "Searched for: " +filter );        
+	int results=layer.getNumResults();
+	System.out.println( "Results number (should be always 1): " +results );
+	for(int i=0;i<results;i++) {
+		shapeObj shape=layer.getShape(layer.getResult(i));
+		System.out.println( "shape["+i+"]=" +shape );
+	}
+	layer.close();
+
+
+	}
+}
+
diff -pruN 8.0.1-5/src/mapscript/java/examples/QueryByAttributeUnicode.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/QueryByAttributeUnicode.java
--- 8.0.1-5/src/mapscript/java/examples/QueryByAttributeUnicode.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/QueryByAttributeUnicode.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,52 @@
+import edu.umn.gis.mapscript.*;
+
+public class QueryByAttributeUnicode {
+	public static void main(String[] args)  {
+
+		String filter="/Südliche Weinstraße/";
+		if (args.length == 2) {
+			filter=args[1];
+		}
+		// Unsupported
+		//String langSettings=System.getenv("LANG");
+		// Only since jdk 1.5
+		//String charsetSetting=Charset.defaultCharset().displayName();
+		String charsetSetting = new java.io.OutputStreamWriter(System.out).getEncoding();
+		System.out.println( "("+charsetSetting+") Searching for: " +filter );        
+
+		if ( charsetSetting.indexOf("UTF") == -1 ) {
+			mapObj map = new mapObj(args[0]);
+			layerObj layer = map.getLayerByName("test-iso");
+			layer.queryByAttributes(map,"KREIS_NAME", filter, mapscriptConstants.MS_MULTIPLE);
+			layer.open();
+
+			resultObj result = layer.getResult(0);
+			if (result==null) {
+				System.out.println("Error: no results found, resultObj is null!");
+			} else {
+				shapeObj shp = layer.getShape(result);
+				for (int z = 0; z < shp.getNumvalues(); z++) {
+					System.out.println("shp.value[" + z + "]=" + shp.getValue(z));
+				}
+
+				System.out.println( "Results number (should be always 1): " +layer.getNumResults() );
+			}
+			layer.close();
+		} else {
+			mapObj map = new mapObj(args[0]);
+			layerObj layer = map.getLayerByName("test-utf");
+			layer.queryByAttributes(map,"KREIS_NAME", filter, mapscriptConstants.MS_MULTIPLE);
+			layer.open();
+
+        		int results=layer.getNumResults();
+		        System.out.println( "Results number (should be always 1): " +results );
+        		for(int i=0;i<results;i++) {
+                		shapeObj shape=layer.getShape(layer.getResult(i));
+		                System.out.println( "shape["+i+"]=" +shape );
+        		}
+
+			layer.close();     
+		}
+	}
+}
+
diff -pruN 8.0.1-5/src/mapscript/java/examples/RFC24.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/RFC24.java
--- 8.0.1-5/src/mapscript/java/examples/RFC24.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/RFC24.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,147 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+ * <p>Title: Mapscript RFC24 tests.</p>
+ * <p>Description: Tests for RFC24 implementation. (http://mapserver.gis.umn.edu/development/rfc/ms-rfc-24/)</p>
+ * @author Umberto Nicoletti (umberto.nicoletti@gmail.com)
+ */
+
+public class RFC24 {
+	String mapfile;
+
+	public static void main(String[] args) {
+		new RFC24(args[0]).run();
+	}
+	
+	public RFC24(String mapfile) {
+		this.mapfile=mapfile;
+	}
+	
+	public void run() {
+		System.out.println("Running "+getClass().getName());
+		testLayerObj();
+		testClassObj();
+		testInsertLayerObj();
+		testInsertClassObj();
+		testGetLayerObj();
+		testGetLayerObjByName();
+		testGetClassObj();
+		testGetOutputformatObj();
+		testInsertOutputformatObj();
+
+		System.out.println("Finished "+getClass().getName());
+	}
+	
+	public void testLayerObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=new layerObj(map);
+		
+		map=null;
+		gc();
+		assertNotNull(newLayer.getMap(), "testLayerObj");
+	}
+	
+	public void testInsertLayerObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=new layerObj(null);
+		map.insertLayer(newLayer,-1);
+		
+		map=null;
+		gc();
+		assertNotNull(newLayer.getMap(), "testInsertLayerObj");
+	}
+	
+	public void testGetLayerObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=map.getLayer(1);
+		
+		map=null;
+		gc();
+		assertNotNull(newLayer.getMap(), "testGetLayerObj");
+	}
+
+	public void testGetLayerObjByName() {
+		mapObj map=new mapObj(mapfile);
+		layerObj newLayer=map.getLayerByName("POLYGON");
+		
+		map=null;
+		gc();
+		assertNotNull(newLayer.getMap(), "testGetLayerObjByName");
+	}
+
+	public void testClassObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=new classObj(layer);
+		
+		map=null; layer=null;
+		gc();
+		assertNotNull(newClass.getLayer(), "testClassObj");
+	}
+
+	public void testInsertClassObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=new classObj(null);
+		layer.insertClass(newClass,-1);
+		
+		map=null; layer=null;
+		gc();
+		assertNotNull(newClass.getLayer(), "testInsertClassObj");
+	}
+
+	public void testGetClassObj() {
+		mapObj map=new mapObj(mapfile);
+		layerObj layer=map.getLayer(1);
+		classObj newClass=layer.getClass(0);
+		
+		map=null; layer=null;
+		gc();
+		assertNotNull(newClass.getLayer(), "testGetClassObj");
+	}
+
+        public void testGetOutputformatObj() {
+                mapObj map=new mapObj(mapfile);
+                outputFormatObj format=null;
+                for (int i=0; i<map.getNumoutputformats(); i++) {
+                    format = map.getOutputFormat(i);
+                    //System.out.println("["+i+"] Format name: "+format.getName());
+                } 
+                map=null;
+                gc();
+                assertNotNull(format.getDriver(), "testGetOutputformatObj");
+        }
+
+        public void testInsertOutputformatObj() {
+                mapObj map=new mapObj(mapfile);
+                outputFormatObj format=null;
+                for (int i=0; i<map.getNumoutputformats(); i++) {
+                    format = map.getOutputFormat(i);
+		    // uncomment to see output
+                    //System.out.println("["+i+"] Format name: "+format.getName() + " driver="+format.getDriver());
+                } 
+                outputFormatObj newFormat=new outputFormatObj("AGG/PNG","test/rfc24");
+		map.appendOutputFormat(newFormat);
+                for (int i=0; i<map.getNumoutputformats(); i++) {
+                    format = map.getOutputFormat(i);
+		    // uncomment to see output
+                    //System.out.println("["+i+"] Format name: "+format.getName());
+                } 
+		map.draw();
+                map=null; format=null;
+                gc();
+                assertNotNull(newFormat.getDriver(), "testInsertOutputformatObj");
+        }
+
+	public void gc() {
+		for (int i=0; i<10; i++)
+			System.gc();
+	}
+	
+	public void assertNotNull(Object object, String test) {
+		if ( object != null )
+			System.out.println("\t- "+test+" PASSED");
+		else
+			System.out.println("\t- "+test+" FAILED");
+	}
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/RunTimeBuiltWMSClient.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/RunTimeBuiltWMSClient.java
--- 8.0.1-5/src/mapscript/java/examples/RunTimeBuiltWMSClient.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/RunTimeBuiltWMSClient.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,74 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+	This example demoes a wms client almost entirely configured
+	at run time and without the use of a map file.
+	TODO: remove the need for even a basic map file and do everything at run time
+
+	@author: Nicole Herman, Umberto Nicoletti
+*/
+public class RunTimeBuiltWMSClient {
+	public static void main(String[] args)  {
+	   System.out.println(mapscript.msGetVersion());
+	   mapObj  map;
+	   webObj web;
+	   imageObj bild;
+	   	   
+	   map = new mapObj("data/emptymap.map");
+	   /*
+	   map.setWidth(400);
+	   map.setHeight(400);
+	   map.setDebug(1);
+           // map.setExtent(3280364,5237512,3921499,6103271);
+           map.setExtent(3400000,5700000,3700000,6000000);
+	   // map.setExtent(3300000,5600000,3800000,6100000);
+	   */
+	   map.setProjection("init=epsg:31467");
+	   map.setImageType("png");
+	   
+	   outputFormatObj output = new outputFormatObj("gd/png", "");
+	   output.setName("png");
+	   output.setDriver("gd/png");
+	   output.setMimetype("image/png");
+	   output.setExtension("png");
+	   output.setImagemode(MS_IMAGEMODE.MS_IMAGEMODE_RGB.swigValue());
+	   
+	   /* This fixes bug #1870 and #1803 */
+	   // Instanz des WebObjekts 
+	   // web = new webObj();
+	   web=map.getWeb();
+	   web.setImagepath("/tmp/");
+	   web.setImageurl("http://katrin/~nicol/mapserver/tmp/");
+	   web.setLog("/tmp/wms.log");
+	   web.setHeader("nh_header.html");
+	   web.setTemplate("../html/form.html");
+	   web.setEmpty("../themen/noFeature.html");
+	   
+	   // no longer necessary
+	   //web.setMap(map);
+	   //map.setWeb(web);
+	   System.out.println("ImagePath="+web.getImagepath());
+
+
+	   // Layer Objekt wird erzeugt
+	   layerObj layer;
+	   layer = new layerObj(map);
+	   layer.setName("DUEKN5000");
+           layer.setDebug(mapscriptConstants.MS_ON);
+	   layer.setType(MS_LAYER_TYPE.MS_LAYER_RASTER);
+	   layer.setConnectiontype(MS_CONNECTION_TYPE.MS_WMS);
+	   // TODO: replace with a permanent url
+	   layer.setConnection("http://www.mapserver.niedersachsen.de/freezoneogc/mapserverogc?");
+	   layer.setMetaData("wms_srs", "EPSG:31467");
+	   layer.setMetaData("wms_name", "DUEKN5000");
+	   layer.setMetaData("wms_server_version", "1.1.1");
+	   layer.setMetaData("wms_format","image/png");
+	   layer.setProjection("init=epsg:31467");
+	   layer.setStatus(mapscriptConstants.MS_ON);
+
+	   bild = map.draw();
+	   bild.save("test.png", map);
+	   bild.delete();
+	}
+}
+
diff -pruN 8.0.1-5/src/mapscript/java/examples/ShapeInfo.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/ShapeInfo.java
--- 8.0.1-5/src/mapscript/java/examples/ShapeInfo.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/ShapeInfo.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,45 @@
+import edu.umn.gis.mapscript.*;
+
+/**
+ * <p>Title: Mapscript shapeinfo example.</p>
+ * <p>Description: A Java based mapscript example to dump information from a shapefile.</p>
+ * <p>Copyright: Copyright (c) 2004</p>
+ * <p>Company: GeoZervice</p>
+ * @author Yew K Choo (ykchoo@geozervice.com)
+ * @version 1.0
+ */
+
+public class ShapeInfo {
+  public  static String getShapeType(int type)
+  {
+    switch (type)
+    {
+      case 1: return "point";
+      case 3: return "arc";
+      case 5: return "polygon";
+      case 8: return "multipoint";
+      default: return "unknown";
+    }
+  }
+
+  public static void usage() {
+    System.err.println("Usage: ShapeInfo {shapefile.shp} {shapefile.dbf}");
+    System.exit(-1);
+  }
+
+  public static void main(String[] args) {
+
+    if (args.length != 2) usage();
+
+    shapefileObj shapefile = new shapefileObj (args[0],-1);
+
+    System.out.println ("Shapefile name = " + args[0]);
+    System.out.println ("Type = "  + getShapeType(shapefile.getType()));
+    System.out.println ("Number of features " + shapefile.getNumshapes());
+    System.out.println("bounds (" + shapefile.getBounds().getMinx() + "," + shapefile.getBounds().getMiny() + ")" +
+                        "(" + shapefile.getBounds().getMaxx() + "," + shapefile.getBounds().getMaxy() + ")");
+    shapefile.delete();
+    //mapscript.msCleanup();
+  }
+
+}
diff -pruN 8.0.1-5/src/mapscript/java/examples/WxSTest.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/WxSTest.java
--- 8.0.1-5/src/mapscript/java/examples/WxSTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/WxSTest.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,83 @@
+import edu.umn.gis.mapscript.mapObj;
+import edu.umn.gis.mapscript.OWSRequest;
+import edu.umn.gis.mapscript.mapscript;
+import java.io.*;
+
+class WxSTest_thread extends Thread {
+
+    public String	mapName;
+    public byte[]       resultBytes;
+
+    public void run() {
+	mapObj map = new mapObj(mapName);
+
+        map.setMetaData( "ows_onlineresource", "http://dummy.org/" );
+
+        OWSRequest req = new OWSRequest();
+
+        req.setParameter( "SERVICE", "WMS" );
+        req.setParameter( "VERSION", "1.1.0" );
+        req.setParameter( "REQUEST", "GetCapabilities" );
+
+        mapscript.msIO_installStdoutToBuffer();
+
+        int owsResult = map.OWSDispatch( req );
+
+        if( owsResult != 0 )
+            System.out.println( "OWSDispatch Result (expect 0): " + owsResult );
+
+//        System.out.println( "Document:" );
+//        System.out.println( mapscript.msIO_getStdoutBufferString() );
+
+        resultBytes = mapscript.msIO_getStdoutBufferBytes();
+        mapscript.msIO_resetHandlers();
+    }
+}
+
+public class WxSTest {
+    public static void main(String[] args)  {
+        try {
+            WxSTest_thread tt[] = new WxSTest_thread[100];
+            int i;
+            int expectedLength=0, success = 0, failure=0;
+
+            for( i = 0; i < tt.length; i++ )
+            {
+                tt[i] = new WxSTest_thread();
+                tt[i].mapName = args[0];
+            }
+            
+            for( i = 0; i < tt.length; i++ )
+                tt[i].start();
+
+            for( i = 0; i < tt.length; i++ )
+            {
+                tt[i].join();
+                if( i == 0 )
+                {
+                    expectedLength = tt[i].resultBytes.length;
+                    System.out.println( "["+i+"] Document Length: " + expectedLength + ", expecting somewhere around 10000 or more." );
+                }
+                else if( expectedLength != tt[i].resultBytes.length )
+                {
+                    System.out.println( "["+i+"] Document Length:" + tt[i].resultBytes.length + " Expected:" + expectedLength );
+                    failure++;
+                }
+                else
+                    success++;
+		
+		// dump test results to fs for post-mortem inspection
+		FileOutputStream fos = new FileOutputStream("/tmp/wxs_test_"+i);
+		fos.write(tt[i].resultBytes);
+		fos.close();
+            }
+
+            System.out.println( "Successes: " + success );
+            System.out.println( "Failures: " + failure );
+
+        } catch( Exception e ) {
+            e.printStackTrace();
+        }
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/java/examples/WxSTestNoThread.java 8.2.0~beta1-1~exp1/src/mapscript/java/examples/WxSTestNoThread.java
--- 8.0.1-5/src/mapscript/java/examples/WxSTestNoThread.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/examples/WxSTestNoThread.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,82 @@
+import edu.umn.gis.mapscript.mapObj;
+import edu.umn.gis.mapscript.OWSRequest;
+import edu.umn.gis.mapscript.mapscript;
+import java.io.*;
+
+class WxSTest_nothread {
+
+    public String	mapName;
+    public byte[]       resultBytes;
+
+    public void run() {
+	mapObj map = new mapObj(mapName);
+
+        map.setMetaData( "ows_onlineresource", "http://dummy.org/" );
+
+        OWSRequest req = new OWSRequest();
+
+        req.setParameter( "SERVICE", "WMS" );
+        req.setParameter( "VERSION", "1.1.0" );
+        req.setParameter( "REQUEST", "GetCapabilities" );
+
+        mapscript.msIO_installStdoutToBuffer();
+
+        int owsResult = map.OWSDispatch( req );
+
+        if( owsResult != 0 )
+            System.out.println( "OWSDispatch Result (expect 0): " + owsResult );
+
+//        System.out.println( "Document:" );
+//        System.out.println( mapscript.msIO_getStdoutBufferString() );
+
+        resultBytes = mapscript.msIO_getStdoutBufferBytes();
+        mapscript.msIO_resetHandlers();
+    }
+}
+
+public class WxSTestNoThread {
+    public static void main(String[] args)  {
+        try {
+            WxSTest_nothread tt[] = new WxSTest_nothread[1];
+            int i;
+            int expectedLength=0, success = 0, failure=0;
+
+            for( i = 0; i < tt.length; i++ )
+            {
+                tt[i] = new WxSTest_nothread();
+                tt[i].mapName = args[0];
+            }
+            
+            for( i = 0; i < tt.length; i++ )
+                tt[i].run();
+
+            for( i = 0; i < tt.length; i++ )
+            {
+                if( i == 0 )
+                {
+                    expectedLength = tt[i].resultBytes.length;
+                    System.out.println( "["+i+"] Document Length: " + expectedLength + ", expecting somewhere around 10000 or more." );
+                }
+                else if( expectedLength != tt[i].resultBytes.length )
+                {
+                    System.out.println( "["+i+"] Document Length:" + tt[i].resultBytes.length + " Expected:" + expectedLength );
+                    failure++;
+                }
+                else
+                    success++;
+		
+		// dump test results to fs for post-mortem inspection
+		FileOutputStream fos = new FileOutputStream("/tmp/wxs_test_"+i);
+		fos.write(tt[i].resultBytes);
+		fos.close();
+            }
+
+            System.out.println( "Successes: " + success );
+            System.out.println( "Failures: " + failure );
+
+        } catch( Exception e ) {
+            e.printStackTrace();
+        }
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/java/javaextend.i 8.2.0~beta1-1~exp1/src/mapscript/java/javaextend.i
--- 8.0.1-5/src/mapscript/java/javaextend.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/javaextend.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,53 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Java-specific extensions to MapScript objects
+ * Author:   Sean Gillies, sgillies@frii.com
+ *           Jerry Pisk, jerry.pisk@gmail.com
+ *
+ *****************************************************************************/
+
+/*
+===============================================================================
+imageObj
+===============================================================================
+*/
+
+/* getBytes moved to mapscript/swiginc/image.i */
+
+/*
+==============================================================================
+ pointObj
+==============================================================================
+*/
+
+%extend pointObj 
+{
+  
+    pointObj(double x, double y, double z, double m) 
+    {
+        pointObj *p;
+        p = (pointObj *)calloc(1,sizeof(pointObj));
+        if (!p) return NULL;
+        p->x = x;
+        p->y = y;
+        p->z = z;
+        p->m = m;
+        return p;
+    }
+
+    pointObj(double x, double y, double z)
+    {
+        pointObj *p;
+        p = (pointObj *)calloc(1,sizeof(pointObj));
+        if (!p) return NULL;
+        p->x = x;
+        p->y = y;
+        p->z = z;
+        p->m = -2e38;
+        return p;
+    }
+
+}
+
diff -pruN 8.0.1-5/src/mapscript/java/javamodule.i 8.2.0~beta1-1~exp1/src/mapscript/java/javamodule.i
--- 8.0.1-5/src/mapscript/java/javamodule.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/javamodule.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,224 @@
+
+%include arrays_java.i
+
+/*
+  Uncomment this if you wish to hace enums wrapped in an interface compatible
+  with that generated by swig 1.3.21 (tests wont compile, though)
+  %include enumsimple.swg
+*/
+
+/* Mapscript library loader */
+
+%pragma(java) jniclasscode=%{
+    static {
+        String  library = System.getProperty("mapserver.library.name", "javamapscript");
+
+        System.loadLibrary(library);
+        /* TODO Throw when return value not MS_SUCCESS? */
+        edu.umn.gis.mapscript.mapscript.msSetup();
+    }
+%}
+
+%typemap(jni) gdBuffer    %{jbyteArray%}
+%typemap(jtype) gdBuffer  %{byte[]%}
+%typemap(jstype) gdBuffer %{byte[]%}
+
+%typemap(out) gdBuffer
+%{ $result = SWIG_JavaArrayOutSchar(jenv, $1.data, $1.size); 
+   if( $1.owns_data ) msFree($1.data); %}
+
+%typemap(javain) gdBuffer "$javainput"
+%typemap(javaout) gdBuffer {
+    return $jnicall;
+}
+
+/* String conversion utility function */
+
+%{
+/*
+	These functions taken from: http://java.sun.com/docs/books/jni/html/other.html#26018
+	Umberto Nicoletti, umberto.nicoletti@gmail.com
+
+	Fix bug: http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1753
+*/	
+
+
+void JNU_ThrowByName(JNIEnv *env, const char *name, const char *msg)
+{
+	jclass cls = (*env)->FindClass(env, name);
+	/* if cls is NULL, an exception has already been thrown */
+	if (cls != NULL) {
+		(*env)->ThrowNew(env, cls, msg);
+	}
+	/* free the local ref */
+	(*env)->DeleteLocalRef(env, cls);
+}
+
+char *JNU_GetStringNativeChars(JNIEnv *env, jstring jstr) {
+	jbyteArray bytes = 0;
+	jthrowable exc;
+	char *result = 0;
+	jclass jcls_str;
+	jmethodID MID_String_getBytes;
+
+	if (jstr == NULL) {
+		return NULL;
+	}
+
+	if ((*env)->EnsureLocalCapacity(env, 2) < 0) {
+		return 0; /* out of memory error */
+	}
+
+  	jcls_str = (*env)->FindClass(env, "java/lang/String"); 
+    	MID_String_getBytes = (*env)->GetMethodID(env, jcls_str, "getBytes", "()[B"); 
+     
+	bytes = (*env)->CallObjectMethod(env, jstr,
+                                      MID_String_getBytes);
+	exc = (*env)->ExceptionOccurred(env);
+	if (!exc) {
+    		jint len = (*env)->GetArrayLength(env, bytes);
+    		result = (char *)malloc(len + 1);
+    		if (result == 0) {
+        		JNU_ThrowByName(env, "java/lang/OutOfMemoryError",0);
+        		(*env)->DeleteLocalRef(env, bytes);
+        		return 0;
+    		}
+    		(*env)->GetByteArrayRegion(env, bytes, 0, len,
+                               (jbyte *)result);
+	    	result[len] = 0; /* NULL-terminate */
+	} else {
+    		(*env)->DeleteLocalRef(env, exc);
+	}
+	(*env)->DeleteLocalRef(env, bytes);
+	return result;
+}
+
+jstring JNU_NewStringNative(JNIEnv *env, const char *str) {
+	jstring result;
+	jbyteArray bytes = 0;
+	int len;
+	jclass jcls_str;
+	jmethodID MID_String_init;
+
+	if (str == NULL) {
+		return NULL;
+	}
+
+	if ((*env)->EnsureLocalCapacity(env, 2) < 0) {
+	    return NULL; /* out of memory error */
+	}
+	jcls_str = (*env)->FindClass(env, "java/lang/String"); 
+	MID_String_init = (*env)->GetMethodID(env, jcls_str, "<init>", "([B)V"); 
+
+	len = strlen(str);
+	bytes = (*env)->NewByteArray(env, len);
+	if (bytes != NULL) {
+	    (*env)->SetByteArrayRegion(env, bytes, 0, len,
+	                            (jbyte *)str);
+	    result = (*env)->NewObject(env, jcls_str,
+	                            MID_String_init, bytes);
+	    (*env)->DeleteLocalRef(env, bytes);
+	    return result;
+	} /* else fall through */
+	return NULL;
+}
+ 
+%}
+
+%typemap(in) char * {
+	$1 = JNU_GetStringNativeChars(jenv, $input);
+}
+
+/* The default mapping would use ReleaseStringUTFChars to release the
+memory allocated with JNU_GetStringNativeChars which causes a
+memory corruption. (#3491) */
+%typemap(freearg, noblock=1) char * { if ($1) free($1); }
+
+%typemap(out) char * {
+	$result = JNU_NewStringNative(jenv, $1);
+}
+
+/*
+===============================================================================
+RFC-24 implementation follows
+===============================================================================
+   Modified constructor according to:
+   - cache population and sync, item 3.2
+*/
+%typemap(javaconstruct) layerObj(mapObj map) %{ {
+        this($imcall, true);
+        if (map != null) {
+                this.map=map;
+        }
+}
+%}
+
+%typemap(javaconstruct) classObj(layerObj layer) %{ {
+        this($imcall, true);
+        if (layer != null) {
+                this.layer=layer;
+        }
+}
+%}
+
+%typemap(javaout) int insertLayer {
+        // call the C API
+        int actualIndex=$jnicall;
+        /* Store parent reference, item 3.2 */
+        layer.map=this;
+        return actualIndex;
+}
+
+%typemap(javaout) layerObj* getLayer {
+        // call the C API
+        long cPtr=$jnicall;
+        layerObj layer = null;
+        if (cPtr != 0) {
+        	layer=new layerObj(cPtr, true);
+	        /* Store parent reference, item 3.2 */
+	        layer.map=this;
+        }
+        return layer;
+}
+
+%typemap(javaout) layerObj* getLayerByName {
+        // call the C API
+        long cPtr=$jnicall;
+        layerObj layer = null;
+        if (cPtr != 0) {
+        	layer=new layerObj(cPtr, true);
+	        /* Store parent reference, item 3.2 */
+	        layer.map=this;
+        }
+        return layer;
+}
+
+%typemap(javaout) int insertClass {
+        // call the C API
+        int actualIndex=$jnicall;
+        /* Store parent reference, item 3.2 */
+        classobj.layer=this;
+        return actualIndex;
+}
+
+%typemap(javaout) classObj* getClass {
+        // call the C API
+        long cPtr=$jnicall;
+        classObj clazz = null;
+        if (cPtr != 0) {
+        	clazz=new classObj(cPtr, true);
+	        /* Store parent reference, item 3.2 */
+	        clazz.layer=this;
+        }
+        return clazz;
+}
+                
+%typemap(javacode) struct layerObj %{
+        /* parent reference, RFC-24 item 3.2 */
+        mapObj map=null;
+%}
+
+%typemap(javacode) struct classObj %{
+        /* parent reference, RFC-24 item 3.2 */
+        layerObj layer=null;
+%}
diff -pruN 8.0.1-5/src/mapscript/java/makefile.vc 8.2.0~beta1-1~exp1/src/mapscript/java/makefile.vc
--- 8.0.1-5/src/mapscript/java/makefile.vc	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/makefile.vc	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,83 @@
+
+#
+# SWIG Stuff
+#
+#SWIG_HOME="D:\swig\SWIG-1.3.23\"  <- should get this from ..\..\nmake.opt
+#SWIG=$(SWIG_HOME)\swig
+
+!INCLUDE ..\..\nmake.opt
+
+MS_LIB = 	mapscript.lib
+MS_LIB_DLL  =	mapscript_i.lib
+
+#
+# Java Stuff
+#JAVA_HOME = "C:\Progra~1\Java\jdk1.5.0" <- should get this from ..\..\nmake.opt
+JAVADOC=$(JAVA_HOME)\bin\javadoc
+JAVAC=$(JAVA_HOME)\bin\javac
+JAVA=$(JAVA_HOME)\bin\java
+JAR=$(JAVA_HOME)\bin\jar
+JAVA_INCLUDE=-I$(JAVA_HOME)\include -I$(JAVA_HOME)\include\win32
+
+CC=     cl /MD
+LINK=   link
+
+MS_DLL = javamapscript.dll
+
+BASE_CFLAGS = 	$(OPTFLAGS) -DWIN32 -D_WIN32
+LDFLAGS =	/NODEFAULTLIB:"MSVCRTD" /NODEFAULTLIB:libcd /NODEFAULTLIB:libcmtd /NODEFAULTLIB:msvcrtd /NODEFAULTLIB:LIBC /DEBUG
+
+
+all: interface_release mapscript_java mapscript_lib mapscript_jar
+
+interface_release: 
+        -md edu\umn\gis\mapscript
+        $(SWIG) -java -package edu.umn.gis.mapscript -outdir edu/umn/gis/mapscript -o mapscript_wrap.c ../mapscript.i
+
+
+mapscript_java:
+	$(JAVAC) edu\umn\gis\mapscript\*.java
+
+mapscript_wrap:
+        $(CC) $(BASE_CFLAGS) $(MS_CFLAGS) $(JAVA_INCLUDE) /c mapscript_wrap.c  /Fomapscript_wrap.obj
+
+.c.obj:	
+	$(CC) $(BASE_CFLAGS) $(MS_CFLAGS) $(JAVA_INCLUDE) /c $*.c /Fo$*.obj
+
+mapscript_lib: mapscript_wrap.obj
+        link /dll /debug \
+		mapscript_wrap.obj $(EXTERNAL_LIBS) ..\..\mapserver_i.lib $(LDFLAGS) /def:..\..\mapserver.def \
+                /out:$(MS_DLL) /implib:$(MS_LIB_DLL)
+	if exist $(MS_DLL).manifest mt -manifest $(MS_DLL).manifest -outputresource:$(MS_DLL);2
+
+mapscript_javadoc:
+	$(JAVADOC) -d doc -sourcepath edu/umn/gis/mapscript/*.java
+		
+mapscript_jar:
+	$(JAR) cf mapscript.jar edu
+test:
+	$(JAVAC) -classpath ./mapscript.jar -d examples\ examples\*.java
+	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. DumpShp ../../tests/point.shp
+	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. ShapeInfo ..\..\tests\point.shp ..\..\tests\point.dbf
+	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. DrawMap ..\..\tests\test.map .\map.png
+	$(JAVA)  -cp ./;examples/;./mapscript.jar -Djava.library.path=. RFC24 ..\..\tests\test.map
+
+threadtests:
+	$(JAVAC) -cp ./mapscript.jar -d tests/threadtest/ tests/threadtest/*.java
+	@echo "-------------------------------------------------------------------------"
+	@echo "   You can use your own map! Copy the following command in your shell"
+	@echo "        and change the file to the map file (the last argument)"
+	@echo "-------------------------------------------------------------------------"
+	$(JAVA) -cp tests/threadtest/;./mapscript.jar -Djava.library.path=. MapTest -t 10 -i 5 ../../tests/test.map
+
+clean:
+	-del *.obj
+	-del *.lib
+	-rmdir /s /q edu
+	del $(MS_DLL)
+	del $(MS_DLL).manifest
+	del mapscript_wrap.c
+	del mapscript.jar
+	del *.ilk
+	del *.pdb
+	del *.exp
diff -pruN 8.0.1-5/src/mapscript/java/run_test.sh 8.2.0~beta1-1~exp1/src/mapscript/java/run_test.sh
--- 8.0.1-5/src/mapscript/java/run_test.sh	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/run_test.sh	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,23 @@
+#!/bin/sh -ex
+
+JAVA=${JAVA_HOME}/bin/java
+JAVAC=${JAVA_HOME}/bin/javac
+
+${JAVAC} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -d examples/ examples/RFC24.java examples/ConnPool.java examples/DrawMap.java examples/DumpShp.java examples/MakePoint.java examples/QueryByAttribute.java examples/ShapeInfo.java examples/WxSTest.java examples/Metadata.java examples/RunTimeBuiltWMSClient.java examples/WxSTestNoThread.java
+${JAVAC} -encoding utf8 -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -d examples/ examples/QueryByAttributeUnicode.java 
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} DumpShp ../../tests/point.shp
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} ShapeInfo ../../tests/point.shp ../../tests/point.dbf
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} DrawMap ../../tests/test.map ./map.png
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} ConnPool
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} QueryByAttribute ../../tests/test.map
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} WxSTest ../../tests/test.map
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} WxSTestNoThread ../../tests/test.map
+${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} RFC24 ../../tests/test.map
+LC_ALL=en_US.UTF-8 ${JAVA} -classpath ./:examples/:${JAVA_MAPSCRIPT_SO}/mapscript.jar -Djava.library.path=${JAVA_MAPSCRIPT_SO} QueryByAttributeUnicode data/subset-umlauts.map
+
+${JAVAC} -cp ${JAVA_MAPSCRIPT_SO}/mapscript.jar -d tests/threadtest/ tests/threadtest/*.java
+#-------------------------------------------------------------------------
+#  You can use your own map! Copy the following command in your shell
+#      and change the file to the map file (the last argument)
+#-------------------------------------------------------------------------
+${JAVA} -Djava.library.path=${JAVA_MAPSCRIPT_SO} -classpath tests/threadtest/:${JAVA_MAPSCRIPT_SO}/mapscript.jar MapTest -t 50 -i 5 ../../tests/test.map
diff -pruN 8.0.1-5/src/mapscript/java/tests/threadtest/MapTest.java 8.2.0~beta1-1~exp1/src/mapscript/java/tests/threadtest/MapTest.java
--- 8.0.1-5/src/mapscript/java/tests/threadtest/MapTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/tests/threadtest/MapTest.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,35 @@
+// $Id$
+//
+// See README_THREADTEST.TXT for usage details.
+//
+
+public class MapTest {
+    public static void main(String args[]) {
+        String      mapfile = null;
+        Integer     threads = null;
+        Integer     iterations = null;
+
+        for( int i = 0; i < args.length; i++ ) {
+            if( "-t".equals(args[i]) ) {
+                i++;
+                threads = new Integer(args[i]);
+                continue;
+            }
+            if( "-i".equals(args[i]) ) {
+                i++;
+                iterations = new Integer(args[i]);
+                continue;
+            }
+
+            mapfile = args[i];
+        }
+
+        Thread[]    tpool = new Thread[threads.intValue()];
+        for( int i = 0; i < tpool.length; i++ ) {
+            tpool[i] = new MapThread(mapfile, iterations.intValue(), i);
+        }
+        for( int i = 0; i < tpool.length; i++ ) {
+            tpool[i].start();
+        }
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/java/tests/threadtest/MapThread.java 8.2.0~beta1-1~exp1/src/mapscript/java/tests/threadtest/MapThread.java
--- 8.0.1-5/src/mapscript/java/tests/threadtest/MapThread.java	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/tests/threadtest/MapThread.java	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,105 @@
+// $Id$
+//
+// See README_THREADTEST.TXT for usage details.
+//
+
+
+import edu.umn.gis.mapscript.*;
+
+public class MapThread extends Thread {
+    MapThread(String mapfile, int iterations, int id) {
+        this.mapfile = mapfile;
+        this.iterations = iterations;
+	this.id=id;
+    }
+
+    public void run() {
+	System.out.println("Thread "+id+" running...");
+
+	/*
+		Uncomment this if you need to reschedule threads
+	if (id>=5) {
+		try {
+			sleep(10000);
+		} catch(InterruptedException ie) {
+			ie.printStackTrace();
+		}
+	}
+	*/
+
+        for( int i = 0; i < iterations; i++ ) {
+            mapObj  map = new mapObj(mapfile);
+	    long path=Math.round(Math.random()*10);
+
+	    if ( path > 5  ) {
+	       System.out.println("Thread "+id+"-"+i+" querying...");
+	       query(map);
+	    } else {
+	       System.out.println("Thread "+id+"-"+i+" using geos to create a buffer...");
+	       try {
+               	  createBuffer(map);
+	       } catch(Exception e) {
+		   System.out.println("have you enabled GEOS support? "+e.getMessage());
+	       }
+	    }
+   	    // We use this to test swig's memory management code
+	    //System.gc();
+            //map.draw().save("/tmp/mapthread"+id+"-"+i+".png", map);
+            map.draw();
+	    
+        }
+	mapscript.msConnPoolCloseUnreferenced();
+	System.out.println("Thread "+id+" done.");
+    }
+
+    public void createBuffer(mapObj map) {
+
+	layerObj layer = map.getLayer(3);
+	if (layer!=null) {
+		layer.open();
+		layer.queryByIndex(map,0,-1,mapscriptConstants.MS_FALSE);
+		shapeObj shape=layer.getShape(layer.getResults().getResult(0));
+		if (shape!=null) {
+			shapeObj buffer=shape.buffer(0.1);
+			if (buffer != null) {
+				layerObj bufferLayer=new layerObj(map);
+				bufferLayer.setStatus(mapscriptConstants.MS_DEFAULT);
+				bufferLayer.setDebug(mapscriptConstants.MS_ON);
+				bufferLayer.setName("BUFFER");
+				//bufferLayer.setType(mapscriptConstants.MS_LAYER_POLYGON);
+				bufferLayer.setProjection("init=epsg:4326");
+				bufferLayer.setType(MS_LAYER_TYPE.MS_LAYER_POINT);
+				bufferLayer.setOpacity(50);
+				classObj clazz=new classObj(bufferLayer);
+				clazz.setName("Buffer class");
+				styleObj style=new styleObj(clazz);
+				colorObj green=new colorObj(0,254,0,255);
+				//green.setRGB(0,254,0);
+				style.setColor(green);
+				bufferLayer.addFeature(buffer);
+
+			} else {
+				System.out.println("Buffer shape is NULL!");
+			}
+		}
+	}	
+    }
+
+    public void query(mapObj map) {
+
+	layerObj layer = map.getLayer(3);
+	if (layer!=null) {
+	   layer.setTemplate("template.html");
+	   String filter="A Point";
+
+	   layer.queryByAttributes(map,"FNAME", filter, mapscriptConstants.MS_MULTIPLE);
+	   layer.open();
+	   System.out.println( " numresults: " +layer.getNumResults() );
+	   layer.close();
+	}
+    }
+
+    String      mapfile;
+    int         iterations;
+    int 	id;
+}
diff -pruN 8.0.1-5/src/mapscript/java/tests/threadtest/README_THREADTEST.TXT 8.2.0~beta1-1~exp1/src/mapscript/java/tests/threadtest/README_THREADTEST.TXT
--- 8.0.1-5/src/mapscript/java/tests/threadtest/README_THREADTEST.TXT	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/java/tests/threadtest/README_THREADTEST.TXT	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,132 @@
+-----------------------------------
+June, 28th 2006
+Umberto Nicoletti (umberto.nicoletti@gmail.com)
+
+I have added more functionality to the thread test by integrating it
+in the Makefile so that it can be ran more easily and by adding a
+query by attribute and a buffer functions. The latter requires GEOS
+support in mapserver.
+
+It is best to run the tests with MALLOC_CHECK_ variable set to 2 so
+that memory errors are detected and reported (the jvm will crash
+on the first error so it should be quite noticeable ;-) ).
+
+-------- Original Message --------
+Subject: [UMN_MAPSERVER-DEV] Multithreaded Mapscript
+Date: Mon, 6 Jun 2005 19:22:41 -0700
+From: Jerry Pisk <jerry.pisk@GMAIL.COM>
+Reply-To: Jerry Pisk <jerry.pisk@GMAIL.COM>
+To: MAPSERVER-DEV@LISTS.UMN.EDU
+
+Hi everybody,
+
+as I mentioned in my previous e-mail I was able to get mapserver to
+work in a multithreaded program. But the code I covered was just a
+fraction of mapserver's code, I only tested mapfile load and map
+drawing from a PostGIS backend. Since I do not have the resources to
+do extensive testing I decided to share what I've done with the
+community. I wrote a simple Java program that creates a number of
+threads and executes map operations on them. It uses Java mapscript to
+call mapserver. The following assumes a JDK (I used 1.5 but older
+versions should work as well) is installed and JAVA_HOME points to it.
+
+There are two source files:
+================  MapTest.java  ================
+
+public class MapTest {
+    public static void main(String args[]) {
+        String      mapfile = null;
+        Integer     threads = null;
+        Integer     iterations = null;
+
+        for( int i = 0; i < args.length; i++ ) {
+            if( "-t".equals(args[i]) ) {
+                i++;
+                threads = new Integer(args[i]);
+                continue;
+            }
+            if( "-i".equals(args[i]) ) {
+                i++;
+                iterations = new Integer(args[i]);
+                continue;
+            }
+
+            mapfile = args[i];
+        }
+
+        Thread[]    tpool = new Thread[threads.intValue()];
+        for( int i = 0; i < tpool.length; i++ ) {
+            tpool[i] = new MapThread(mapfile, iterations.intValue());
+        }
+        for( int i = 0; i < tpool.length; i++ ) {
+            tpool[i].start();
+        }
+    }
+}
+================================================
+
+================  MapThread.java  ================
+
+import edu.umn.gis.mapscript.mapObj;
+
+public class MapThread extends Thread {
+    MapThread(String mapfile, int iterations) {
+        this.mapfile = mapfile;
+        this.iterations = iterations;
+    }
+
+    public void run() {
+        mapObj  map = new mapObj(mapfile);
+
+        for( int i = 0; i < iterations; i++ ) {
+            map.draw();
+            // Add additional test code here
+        }
+    }
+
+    String      mapfile;
+    int         iterations;
+}
+================================================
+
+To use these simply compile mapserver and mapscript (for java you may
+need to run 'make interface' in mapscript/java). Save the two Java
+files into a directory of your choice. Compile them (point to your
+mapscript.jar, in mapscript/java/):
+
+$JAVA_HOME/bin/javac -cp ./mapscript.jar *.java
+
+and execute:
+
+$JAVA_HOME/bin/java -Djava.library.path=./ -cp ./:./mapscript.jar
+MapTest -t <t> -i <i> <map file>
+
+where <t> is the number of threads to create, <i> is the number of
+iterations to execute on each thread and <map file> is a full path to
+your map file. Again, make sure you point to your mapscript.jar and
+point to where libmapscript.so is in that java.library.path definition
+(I copied those two files into the same directory as the Java code but
+your setup may differ).
+
+There were occasional libgd related errors (Unable to initialize
+image) but those simply resulted in an exception being thrown, which
+is in my humble opinion acceptable, as long as the code does not
+crash.
+
+The code does no error checking, feel free to add it but this is
+really meant to be a developer's troubleshooting tool, not an end user
+utility. Also if a map drawing fails that thread will simply exit
+without finishing its number of iterations.
+
+The point of all this is to help make mapserver thread safe. The code
+above is meant as a simple starting point that should help mapserver
+developers test the code in a multithreaded application. Any comments
+and thoughts or even module tests (I do not have the resources to test
+a lot of mapserver's code, especially all the various data back ends)
+will be appreciated.
+
+Jerry Pisk
+
+
+----------
+$Id$
diff -pruN 8.0.1-5/src/mapscript/mapscript.i 8.2.0~beta1-1~exp1/src/mapscript/mapscript.i
--- 8.0.1-5/src/mapscript/mapscript.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/mapscript.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,330 @@
+/* 
+===========================================================================
+ $Id$
+ 
+ Project:  MapServer
+ Purpose:  SWIG interface file for the MapServer mapscript module
+ Author:   Steve Lime 
+           Sean Gillies, sgillies@frii.com
+             
+ ===========================================================================
+ Copyright (c) 1996-2005 Regents of the University of Minnesota.
+  
+ Permission is hereby granted, free of charge, to any person obtaining a
+ copy of this software and associated documentation files (the "Software"),
+ to deal in the Software without restriction, including without limitation
+ the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ and/or sell copies of the Software, and to permit persons to whom the
+ Software is furnished to do so, subject to the following conditions:
+ 
+ The above copyright notice and this permission notice shall be included
+ in all copies or substantial portions of the Software.
+ 
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ DEALINGS IN THE SOFTWARE.
+============================================================================
+*/
+
+%begin %{
+#ifdef _MSC_VER
+#define SWIG_PYTHON_INTERPRETER_NO_DEBUG
+#else
+#define _GNU_SOURCE 1
+#endif
+%}
+
+#ifndef SWIGPHPNG
+%module mapscript
+#else
+%module mapscriptng
+#endif
+
+#ifdef SWIGCSHARP
+%ignore frompointer;
+%include swig_csharp_extensions.i
+#endif
+
+#ifdef SWIGJAVA
+%ignore layerObj::extent;
+#endif
+
+%newobject msLoadMapFromString;
+
+%{
+#include "../../mapserver.h"
+#include "../../maptemplate.h"
+#include "../../mapogcsld.h"
+#include "../../mapows.h"
+#include "../../cgiutil.h"
+#include "../../mapcopy.h"
+#include "../../maperror.h"
+#include "../../mapprimitive.h"
+#include "../../mapshape.h"
+
+#if defined(_WIN32) && defined(SWIGCSHARP)
+/* <windows.h> is needed for GetExceptionCode() for unhandled exception */
+#include <windows.h>
+#endif
+
+%}
+
+/* Problem with SWIG CSHARP typemap for pointers */
+#ifndef SWIGCSHARP
+%include typemaps.i
+#endif
+
+%include constraints.i
+
+%include carrays.i
+%array_class(int, intarray)
+
+/* 
+===========================================================================
+ Supporting 'None' as an argument to attribute accessor functions
+
+ Typemaps to support NULL in attribute accessor functions
+ provided to Steve Lime by David Beazley and tested for Python
+ only by Sean Gillies.
+   
+ With the use of these typemaps we can execute statements like
+
+   layer.group = None
+
+============================================================================
+*/
+
+#ifdef __cplusplus
+%typemap(memberin) char * {
+  if ($1) delete [] $1;
+  if ($input) {
+     $1 = ($1_type) (new char[strlen($input)+1]);
+     strcpy((char *) $1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+%typemap(memberin,warning="451:Setting const char * member may leak
+memory.") const char * {
+  if ($input) {
+     $1 = ($1_type) (new char[strlen($input)+1]);
+     strcpy((char *) $1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+%typemap(globalin) char * {
+  if ($1) delete [] $1;
+  if ($input) {
+     $1 = ($1_type) (new char[strlen($input)+1]);
+     strcpy((char *) $1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+%typemap(globalin,warning="451:Setting const char * variable may leak
+memory.") const char * {
+  if ($input) {
+     $1 = ($1_type) (new char[strlen($input)+1]);
+     strcpy((char *) $1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+#else
+%typemap(memberin) char * {
+  if ($1) free((char*)$1);
+  if ($input) {
+     $1 = ($1_type) malloc(strlen($input)+1);
+     strcpy((char*)$1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+%typemap(memberin,warning="451:Setting const char * member may leak
+memory.") const char * {
+  if ($input) {
+     $1 = ($1_type) malloc(strlen($input)+1);
+     strcpy((char*)$1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+%typemap(globalin) char * {
+  if ($1) free((char*)$1);
+  if ($input) {
+     $1 = ($1_type) malloc(strlen($input)+1);
+     strcpy((char*)$1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+%typemap(globalin,warning="451:Setting const char * variable may leak
+memory.") const char * {
+  if ($input) {
+     $1 = ($1_type) malloc(strlen($input)+1);
+     strcpy((char*)$1,$input);
+  } else {
+     $1 = 0;
+  }
+}
+#endif /* __cplusplus */
+
+/* GD Buffer Mapping for use with imageObj::getBytes */
+%{
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct {
+    unsigned char *data;
+    int size;
+    int owns_data;
+} gdBuffer;
+
+#ifdef __cplusplus
+}
+#endif
+%}
+
+/* 
+============================================================================
+ Exceptions
+
+ Note: Python exceptions are in pymodule.i
+============================================================================
+*/
+
+#if defined(SWIGCSHARP) || defined(SWIGJAVA) || defined(SWIGRUBY) || defined(SWIGPHP7)
+%include "../mserror.i"
+#endif
+
+/* 
+============================================================================
+ Language-specific module code
+============================================================================
+*/
+
+/* C# */
+#ifdef SWIGCSHARP
+%include "csmodule.i"
+#endif
+
+/* Java */
+#ifdef SWIGJAVA
+%include "javamodule.i"
+#endif
+
+/* Python */
+#ifdef SWIGPYTHON
+%include "pymodule.i"
+#endif /* SWIGPYTHON */
+
+/* Ruby */
+#ifdef SWIGRUBY
+%include "rbmodule.i"
+#endif
+
+/* Perl */
+#ifdef SWIGPERL5
+%include "plmodule.i"
+#endif
+
+/* Tcl */
+#ifdef SWIGTCL8
+%include "tclmodule.i"
+#endif /* SWIGTCL8 */
+
+/* PHP7 */
+#ifdef SWIGPHP7
+%include "php7module.i"
+#endif /* SWIGPHP7 */
+
+
+/* 
+=============================================================================
+ Wrap MapServer structs into mapscript classes
+=============================================================================
+*/
+
+%include "../../mapserver.h"
+%include "../../mapserver-version.h"
+%include "../../mapprimitive.h"
+%include "../../maperror.h"
+%include "../../mapshape.h"
+%include "../../mapproject.h"
+%include "../../mapsymbol.h"
+%include "../../maphash.h"
+%include "../../maperror.h"
+%include "../../mapserv-config.h"
+
+%apply Pointer NONNULL { mapObj *map };
+%apply Pointer NONNULL { layerObj *layer };
+%apply Pointer NONNULL { configObj *config };
+
+/* 
+=============================================================================
+ Class extension methods are now included from separate interface files  
+=============================================================================
+*/
+
+%include "../swiginc/error.i"
+%include "../swiginc/map.i"
+%include "../swiginc/mapzoom.i"
+%include "../swiginc/symbol.i"
+%include "../swiginc/symbolset.i"
+%include "../swiginc/layer.i"
+%include "../swiginc/class.i"
+%include "../swiginc/cluster.i"
+%include "../swiginc/style.i"
+%include "../swiginc/rect.i"
+%include "../swiginc/image.i"
+%include "../swiginc/shape.i"
+%include "../swiginc/point.i"
+%include "../swiginc/line.i"
+%include "../swiginc/shapefile.i"
+%include "../swiginc/outputformat.i"
+%include "../swiginc/projection.i"
+%include "../swiginc/dbfinfo.i"
+%include "../swiginc/labelcache.i"
+%include "../swiginc/color.i"
+%include "../swiginc/hashtable.i"
+%include "../swiginc/resultcache.i"
+%include "../swiginc/result.i"
+%include "../swiginc/owsrequest.i"
+%include "../swiginc/connpool.i"
+%include "../swiginc/msio.i"
+%include "../swiginc/web.i"
+%include "../swiginc/label.i"
+%include "../swiginc/scalebar.i"
+%include "../swiginc/legend.i"
+%include "../swiginc/referencemap.i"
+%include "../swiginc/querymap.i"
+%include "../swiginc/config.i"
+%include "../swiginc/reprojection.i"
+
+/* 
+=============================================================================
+ Language-specific extensions to mapserver classes are included here 
+=============================================================================
+*/
+
+/* Java */
+#ifdef SWIGJAVA
+%include "javaextend.i"
+#endif
+
+/* Python */
+#ifdef SWIGPYTHON
+%include "pyextend.i"
+#endif /* SWIGPYTHON */
+
+/* Ruby */
+#ifdef SWIGRUBY
+%include "rbextend.i"
+#endif
+
diff -pruN 8.0.1-5/src/mapscript/mserror.i 8.2.0~beta1-1~exp1/src/mapscript/mserror.i
--- 8.0.1-5/src/mapscript/mserror.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/mserror.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,67 @@
+/* 
+===========================================================================
+ $Id$
+ 
+ Project:  MapServer
+ Purpose:  MapScript exceptions
+ Author:   Umberto Unicoletti, unicoletti@prometeo.it
+           Jerry Pisk, jerry.pisk@gmail.com
+           Sean Gillies, sgillies@frii.com
+           Tamas Szekeres, szekerest@gmail.com
+
+ Note: Python exceptions are in mapscript/python
+       C# exceptions are redefinied in mapscript/csharp
+       
+       This implementation truncates the error message length
+       to MAX_ERROR_LEN since SWIG_exception does not allow
+       to free memory allocated on the heap easily (szekerest)
+============================================================================
+*/
+#define MAX_ERROR_LEN 8192
+%include exception.i
+
+%exception {
+    errorObj *ms_error;
+    $action
+    ms_error = msGetErrorObj();
+    if (ms_error!=NULL && ms_error->code != MS_NOERR) {
+        char ms_message[MAX_ERROR_LEN];
+        char* msg = msGetErrorString(";");
+        int ms_errorcode = ms_error->code;
+        if (msg) {
+			snprintf(ms_message, MAX_ERROR_LEN, "%s", msg);
+			free(msg);
+		}
+        else sprintf(ms_message, "Unknown message");
+
+        msResetErrorList();
+       
+        switch(ms_errorcode) {
+            case MS_NOTFOUND:
+                break;
+            case -1:
+                break;
+            case MS_IOERR:
+                SWIG_exception(SWIG_IOError ,ms_message);
+                break;
+            case MS_MEMERR:
+                SWIG_exception(SWIG_MemoryError,ms_message);
+                break;
+            case MS_TYPEERR:
+                SWIG_exception(SWIG_TypeError,ms_message);
+                break;
+            case MS_EOFERR:
+                SWIG_exception(SWIG_SyntaxError,ms_message);
+                break;
+            case MS_CHILDERR:
+                SWIG_exception(SWIG_SystemError,ms_message);
+                break;
+            case MS_NULLPARENTERR:
+                SWIG_exception(SWIG_SystemError,ms_message);
+                break;
+            default:
+                SWIG_exception(SWIG_UnknownError,ms_message);
+                break;
+        }       
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/perl/CMakeLists.txt 8.2.0~beta1-1~exp1/src/mapscript/perl/CMakeLists.txt
--- 8.0.1-5/src/mapscript/perl/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,30 @@
+find_package(SWIG REQUIRED)
+include(${SWIG_USE_FILE})
+find_package(Perl REQUIRED)
+find_package(PerlLibs REQUIRED)
+set(CUSTOM_PERL_SITE_ARCH_DIR ${PERL_SITEARCH} CACHE STRING "Custom installation directory for perl binary extension")
+include_directories(${PERL_INCLUDE_PATH})
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
+add_definitions(${PERL_EXTRA_C_FLAGS})
+set(CMAKE_SWIG_FLAGS -shadow -w314)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/perl)
+
+if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
+    swig_add_library(perlmapscript TYPE MODULE LANGUAGE perl5 SOURCES ../mapscript.i)
+else ()
+    swig_add_module(perlmapscript perl5 ../mapscript.i)
+endif ()
+
+SWIG_LINK_LIBRARIES(perlmapscript ${PERL_LIBRARIES} ${MAPSERVER_LIBMAPSERVER})
+set_target_properties(perlmapscript PROPERTIES OUTPUT_NAME mapscript)
+set_target_properties(perlmapscript PROPERTIES PREFIX "")
+if(APPLE)
+  set_target_properties(perlmapscript PROPERTIES SUFFIX ".bundle")
+endif(APPLE)
+
+install(FILES $<TARGET_FILE:${SWIG_MODULE_perlmapscript_REAL_NAME}> DESTINATION ${CUSTOM_PERL_SITE_ARCH_DIR}/auto/mapscript)
+install(FILES $<TARGET_FILE_DIR:${SWIG_MODULE_perlmapscript_REAL_NAME}>/mapscript.pm DESTINATION ${CUSTOM_PERL_SITE_ARCH_DIR})
+
+file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tests DESTINATION  ${CMAKE_CURRENT_BINARY_DIR})
+file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/examples DESTINATION  ${CMAKE_CURRENT_BINARY_DIR})
diff -pruN 8.0.1-5/src/mapscript/perl/README 8.2.0~beta1-1~exp1/src/mapscript/perl/README
--- 8.0.1-5/src/mapscript/perl/README	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/README	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,20 @@
+To build type:
+
+  perl Makefile.PL
+  make
+  make install
+
+MapScript requires Swig version 1.3+. If you must re-SWIG things use a command like:
+
+  swig -perl5 -shadow -outdir . -o mapscript_wrap.c ../mapscript.i
+
+and then follow the sequence of steps to install mapscript. 
+
+If you need to change the name of the mapscript module (default=mapscript) you need to:
+
+  1) edit ../mapscript.i and change the name of the swig module
+  2) edit Makefile.PL and edit the name 'mapscript' in the WriteMakefile subroutine call
+  3) edit plmodule.i and change the name 'mapscript' to whatever the new name
+     will be throughout the file
+
+and now build as normal.
diff -pruN 8.0.1-5/src/mapscript/perl/examples/RFC24.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/RFC24.pl
--- 8.0.1-5/src/mapscript/perl/examples/RFC24.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/RFC24.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,104 @@
+#!/usr/bin/perl
+use strict;
+use warnings;
+use mapscript;
+use Data::Dumper;
+
+my $file=$ARGV[0];
+
+# utility
+sub assertNotNull {
+	my ($o, $test) = @_;
+	if ($o) {
+		print $test . "  PASSED\n";
+	} else {
+		print $test . "  FAILED\n";
+	}
+}
+
+
+# layerObj
+sub testGetLayerObj {
+	my $map = new mapscript::mapObj($file);
+	my $layer = $map->getLayer(1);
+	$map = undef;
+	assertNotNull( $layer->{map} , "testGetLayerObj");
+	#$layer->{map}->draw()->save("/tmp/map.png");
+}
+
+sub testGetLayerObjByName {
+	my $map = new mapscript::mapObj($file);
+	my $layer = $map->getLayerByName("POLYGON");
+	$map = undef;
+	assertNotNull( $layer->{map} , "testGetLayerObjByName");
+}
+
+sub testLayerObj {
+	my $map = new mapscript::mapObj($file);
+	my $layer = new mapscript::layerObj($map);
+	$map = undef;
+	assertNotNull( $layer->{map} , "testLayerObj");
+}
+
+sub testInsertLayerObj {
+	my $map = new mapscript::mapObj($file);
+	my $layer = new mapscript::layerObj(undef);
+	my $position = $map->insertLayer($layer);
+	$map = undef;
+	assertNotNull( $position == 7 , "testInsertLayerObj position");
+	assertNotNull( $layer->{map} , "testInsertLayerObj notnull");
+}
+
+# classObj
+sub testGetClassObj {
+	#dumpHash(mapscript::getPARENT_PTRS());
+	my $map = new mapscript::mapObj($file);
+	my $layer = $map->getLayer(1);
+	my $clazz = $layer->getClass(0);
+	#dumpHash(mapscript::getPARENT_PTRS());
+	#$clazz->{layer}->{map}->draw()->save("/tmp/map1.png");
+	#print "parent layer=".$clazz->{layer}."\n";
+	$map = undef; $layer=undef;
+	#print "parent layer=".$clazz->{layer}."\n";
+	assertNotNull( $clazz->{layer} , "testGetClassObj");
+	#$clazz->{layer}->{map}->draw()->save("/tmp/map2.png");
+	#dumpHash(mapscript::getPARENT_PTRS());
+}
+
+sub testClassObj {
+	my $map = new mapscript::mapObj($file);
+	my $layer = $map->getLayer(1);
+	my $clazz = new mapscript::classObj($layer);
+	$map = undef; $layer=undef;
+	assertNotNull( $clazz->{layer} , "testClassObj");
+}
+
+sub testInsertClassObj {
+	my $map = new mapscript::mapObj($file);
+	my $layer = $map->getLayer(1);
+	my $clazz = new mapscript::classObj(undef);
+	my $position = $layer->insertClass($clazz);
+	$map = undef; $layer=undef;
+	assertNotNull( $position == 2 , "testInsertClassObj position");
+	assertNotNull( $clazz->{layer} , "testInsertClassObj notnull");
+}
+
+if ( ! $file ) {
+	print "Usage: RFC24.pl file.map\n";
+	exit 1;
+}
+
+testGetLayerObj;
+testGetLayerObjByName;
+testLayerObj;
+testInsertLayerObj;
+testGetClassObj;
+testClassObj;
+testInsertClassObj;
+
+my $hashmap = mapscript::getPARENT_PTRS();
+assertNotNull( keys( %$hashmap )==0 , "checking that hashmap of parent ptrs is empty");
+print "No of keys:".keys( %$hashmap )."\n";
+#dumpHash($hashmap);
+print Dumper( $hashmap );
+
diff -pruN 8.0.1-5/src/mapscript/perl/examples/buffer.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/buffer.pl
--- 8.0.1-5/src/mapscript/perl/examples/buffer.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/buffer.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+#!/usr/bin/perl
+#
+# Script : buffer.pl
+#
+# Purpose: Applies buffer to shapefile dataset using geos support
+#          buffer units as are per units of data
+#
+# $Id$
+#
+
+use strict;
+use warnings;
+use POSIX;
+use XBase;
+use mapscript;
+use Getopt::Long;
+use File::Copy;
+
+my ($infile, $outfile, $buffer);
+
+GetOptions("input=s", \$infile, "output=s", \$outfile, "buffer=n", \$buffer);
+
+if(!$infile or !$outfile or !$buffer) {
+  print "Usage: $0 --input=[filename] --output=[filename] --buffer=[native units]\n";
+  exit 0;
+}
+
+die "Tolerance must be greater than zero." unless $buffer > 0;
+
+# initialize counters for reporting
+my $incount  = 0;
+my $outcount = 0;
+
+# open the input shapefile
+my $inSHP = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile.";
+
+# create the output shapefile
+
+unlink "$outfile.shp";
+unlink "$outfile.shx";
+unlink "$outfile.dbf";
+
+my $outSHP = new mapscript::shapefileObj($outfile, $inSHP->{type}) or die "Unable to create shapefile '$outfile'. $!\n";
+
+copy("$infile.dbf", "$outfile.dbf") or die "Can't copy file $infile.dbf to $outfile.dbf: $!\n";
+
+my $inshape = new mapscript::shapeObj(-1); # something to hold shapes
+
+for(my $i=0; $i<$inSHP->{numshapes}; $i++) {
+  $inSHP->get($i, $inshape);
+  my $outshape = new mapscript::shapeObj(-1);
+
+  print "buffering feature: $i\n";
+
+  $outshape = $inshape->buffer($buffer) or die "Unable to buffer feature #$i: $!\n"; # in native map units
+
+  $outSHP->add($outshape);
+  undef($outshape); # free memory associated with shape
+
+} # for each shape
+
+$outSHP = ''; # write the file
+
+undef $inSHP;
+undef $outSHP;
+
diff -pruN 8.0.1-5/src/mapscript/perl/examples/distanceToPoint.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/distanceToPoint.pl
--- 8.0.1-5/src/mapscript/perl/examples/distanceToPoint.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/distanceToPoint.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,39 @@
+#!/usr/bin/perl
+#
+# Script : distanceToPoint.pl
+#
+# Purpose: Returns distance between a shape and a point
+#
+# $Id$
+#
+
+use strict;
+use warnings;
+use POSIX;
+use XBase;
+use mapscript;
+use Getopt::Long;
+use File::Copy;
+
+my ($infile, $infile_shpid, $x, $y, $distance);
+
+GetOptions("infile=s", \$infile, "infile_shpid=s", \$infile_shpid, "x=s", \$x, "y=s", \$y);
+
+if(!$infile or !$infile_shpid or !$x or !$y) {
+  print "Usage: $0 --infile=[filename] --infile_shpid=[shpid] --x=[x] --y=[y]\n";
+  exit 0;
+}
+
+# open the first input shapefile
+my $inshpf = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile.";
+
+my $inshape = $inshpf->getShape($infile_shpid);
+
+my $inpt = new mapscript::pointObj($x, $y);
+
+$distance = $inshape->distanceToPoint($inpt);
+
+undef $inshpf;
+
+print "Distance between shape $infile/$infile_shpid and point $x $y is $distance\n";
+
diff -pruN 8.0.1-5/src/mapscript/perl/examples/distanceToShape.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/distanceToShape.pl
--- 8.0.1-5/src/mapscript/perl/examples/distanceToShape.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/distanceToShape.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,40 @@
+#!/usr/bin/perl
+#
+# Script : distanceToShape.pl
+#
+# Purpose: Returns distance between two shapes
+#
+# $Id$
+#
+
+use strict;
+use warnings;
+use POSIX;
+use XBase;
+use mapscript;
+use Getopt::Long;
+use File::Copy;
+
+my ($infile1, $infile1_shpid, $infile2, $infile2_shpid, $distance);
+
+GetOptions("infile1=s", \$infile1, "infile1_shpid=s", \$infile1_shpid, "infile2=s", \$infile2, "infile2_shpid=s", \$infile2_shpid);
+
+if(!$infile1 or !$infile1_shpid or !$infile2 or !$infile2_shpid) {
+  print "Usage: $0 --infile1=[filename] --infile1_shpid=[shpid] --infile2=[filename] --infile2_shpid=[shpid]\n";
+  exit 0;
+}
+
+# open the first input shapefile
+my $inshpf1 = new mapscript::shapefileObj($infile1, -1) or die "Unable to open shapefile $infile1.";
+my $inshpf2 = new mapscript::shapefileObj($infile2, -1) or die "Unable to open shapefile $infile2.";
+
+my $inshape1 = $inshpf1->getShape($infile1_shpid);
+my $inshape2 = $inshpf2->getShape($infile2_shpid);
+
+$distance = $inshape1->distanceToShape($inshape2);
+
+undef $inshpf1;
+undef $inshpf2;
+
+print "Distance between shape $infile1/$infile1_shpid and shape $infile2/$infile2_shpid is $distance units\n";
+
diff -pruN 8.0.1-5/src/mapscript/perl/examples/dump.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/dump.pl
--- 8.0.1-5/src/mapscript/perl/examples/dump.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/dump.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,45 @@
+#!/usr/bin/perl
+
+use strict;
+use warnings;
+use mapscript;
+use Getopt::Long;
+
+my $file;
+my %types = ( '1' => 'point',
+	      '3' => 'arc',
+	      '5' => 'polygon',
+	      '8' => 'multipoint'
+	    );
+
+GetOptions("file=s", \$file);
+
+if(!$file) {
+  print "Syntax: dump.pl --file=[filename]\n";
+  exit 0;
+}
+
+my $shapefile = new mapscript::shapefileObj($file, -1) or die "Unable to open shapefile $file";
+
+print "Shapefile opened (type=". $types{$shapefile->{type}} .") with ".
+$shapefile->{numshapes} ." shape(s)\n";
+
+my $shape = new mapscript::shapeObj(-1);
+
+for(my $i=0; $i<$shapefile->{numshapes}; $i++) {
+    
+    $shapefile->get($i, $shape);
+
+    print "Shape $i has ". $shape->{numlines} ." part(s) - ";
+    printf "bounds (%f,%f) (%f,%f)\n", $shape->{bounds}->{minx}, $shape->{bounds}->{miny}, $shape->{bounds}->{maxx}, $shape->{bounds}->{maxy};
+
+    for(my $j=0; $j<$shape->{numlines}; $j++) {
+        my $part = $shape->get($j);
+        print "Part $j has ". $part->{numpoints} ." point(s)\n";
+
+        for(my $k=0; $k<$part->{numpoints}; $k++) {
+            my $point = $part->get($k);
+            print "$k: ". $point->{x} .", ". $point->{y} ."\n";
+        }
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/perl/examples/shapeprops.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shapeprops.pl
--- 8.0.1-5/src/mapscript/perl/examples/shapeprops.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shapeprops.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,46 @@
+#!/usr/bin/perl
+#
+# Script : shapeprops.pl
+#
+# Purpose: Applies area, perimeter and centroid calculations to a shapes
+#          in a shapefile (requires mapserver/mapscript to be built with GEOS)
+#
+# $Id$
+#
+
+use strict;
+use warnings;
+use mapscript;
+
+@ARGV == 1 or die "Usage: $0 <shapefile>\n";
+
+# open the shapefile
+my $sf = new mapscript::shapefileObj($ARGV[0], -1) or die "Unable to open shapefile $ARGV[0]: $!\n";
+
+# loop over every shape
+for(my $i = 0; $i < $sf->{numshapes}; $i++) {
+  # fetch the shape
+  my $s = $sf->getShape($i);
+
+  # calculate area
+  my $a = $s->getArea();
+
+  # calculate length / perimeter
+  my $l = $s->getLength();
+
+  # calculate centroid
+  my $c = $s->getCentroid();
+
+  print <<END;
+
+Area of shape $i: $a
+Length / Perimeter of shape $i: $l
+Centroid of shape $i: $c->{x}, $c->{y}
+END
+
+  # free shape
+  undef $s;
+}
+
+# free shapefile
+undef $sf;
diff -pruN 8.0.1-5/src/mapscript/perl/examples/shpPoint2GPX.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shpPoint2GPX.pl
--- 8.0.1-5/src/mapscript/perl/examples/shpPoint2GPX.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shpPoint2GPX.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,109 @@
+#!/usr/bin/perl
+#
+# Script : shpPoint2GPX.pl
+#
+# Purpose: Converts a Point shapefile to a GPX document
+#          as per http://www.topografix.com/gpx.asp
+#
+# $Id$
+#
+
+use strict;
+use warnings;
+use POSIX;
+use XBase;
+use mapscript;
+use Getopt::Long;
+
+my ($infile, $outfile, $namecol);
+
+GetOptions("input=s", \$infile, "output=s", \$outfile, "namecol=s", \$namecol);
+
+if(!$infile or !$outfile or !$namecol) {
+  print "Usage: $0 --input=[filename] --output=[filename] --namecol=[namecol]\n"; 
+  exit 0;
+}
+
+# open the input shapefile and dbf
+my $shapefile = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile: $!\n";
+my $table     = new XBase "$infile" or die XBase->errstr;
+
+if ($shapefile->{type} != 1) {
+  print "input shapefile must be of type point\n";
+  exit 0;
+}
+
+# unlink and create the output GPX document
+unlink "$outfile.gpx";
+
+open(GPX, ">$outfile.gpx") or die "Unable to open GPX document $outfile.gpx: $!\n";
+
+# print the GPX header info
+print <<END;
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<gpx creator="shpPoint2GPX.pl" version="1.1" xsi:schemaLocation="http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd" xmlns="http://www.topografix.com/GPX/1/1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ms="http://mapserver.gis.umn.edu/mapserver">
+	<metadata>
+		<name>$outfile.gpx</name>
+		<desc>Description</desc>
+		<author>
+			<name>Name</name>
+			<email id="foouser" domain="mapserver.gis.umn.edu"/>
+			<link href="http://mapserver.gis.unm.edu/">
+				<text>Welcome to MapServer</text>
+				<type>text/html</type>
+			</link>
+		</author>
+		<copyright author="Regents of the University of Minnesota">
+			<year>2007</year>
+			<license>http://mapserver.gis.umn.edu/License</license>
+		</copyright>
+		<link href="http://mapserver.gis.unm.edu/">
+			<text>Welcome to MapServer</text>
+			<type>text/html</type>
+		</link>
+		<time>2001-12-17T09:30:47.0Z</time>
+		<keywords>MapServer, mapscript, perl, GPX, GPS</keywords>
+		<bounds maxlat="$shapefile->{bounds}->{maxx}" maxlon="$shapefile->{bounds}->{maxy}" minlat="$shapefile->{bounds}->{miny}" minlon="$shapefile->{bounds}->{minx}"/>
+		<extensions/>
+	</metadata>
+END
+
+my $shape = new mapscript::shapeObj(-1); # something to hold shapes
+
+# print each shape as a waypoint
+for(my $i=0; $i<$shapefile->{numshapes}; $i++) {
+  $shapefile->get($i, $shape);
+
+  for(my $j=0; $j<$shape->{numlines}; $j++) {
+    my $part = $shape->get($j);
+    for(my $k=0; $k<$part->{numpoints}; $k++) {
+      my $point = $part->get($k);
+      my %row = $table->get_record_as_hash($j) or die $table->errstr;
+      delete $row{"_DELETED"};
+      print "\t<wpt lat=\"$point->{y}\" lon=\"$point->{x}\">\n";
+
+      if ($row{uc($namecol)}) {
+        print "\t\t<name>$row{$namecol}</name>\n";
+      }
+
+      # print out the dbf values as GPX extensions
+      print "\t\t<extensions>\n";
+
+      foreach my $k (keys %row) {
+        print "\t\t\t<ms:$k><![CDATA[$row{$k}]]></ms:$k>\n";
+      }
+      print "\t\t</extensions>\n\t</wpt>\n";
+    }
+  }
+} # for each shape
+
+print <<END;
+	<extensions>
+		<ms:numshapes>$shapefile->{numshapes}</ms:numshapes>
+		<ms:source>$shapefile->{source}</ms:source>
+	</extensions>
+</gpx>
+END
+
+undef $shapefile;
+close(GPX);
diff -pruN 8.0.1-5/src/mapscript/perl/examples/shp_in_shp.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shp_in_shp.pl
--- 8.0.1-5/src/mapscript/perl/examples/shp_in_shp.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shp_in_shp.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,46 @@
+#!/usr/bin/perl
+#
+# Script : shp_in_shp.pl
+#
+# Purpose: Tests whether a shape is within another shape
+#
+# $Id$
+#
+
+use strict;
+use warnings;
+use mapscript;
+use Getopt::Long;
+use File::Copy;
+
+my ($infile1, $infile1_shpid, $infile2, $infile2_shpid, $within);
+
+GetOptions("infile1=s", \$infile1, "infile1_shpid=s", \$infile1_shpid, "infile2=s", \$infile2, "infile2_shpid=s", \$infile2_shpid);
+
+# shpid can be zero, which looks false, so use defined()
+if(!$infile1 or !defined($infile1_shpid) or !$infile2 or !defined($infile2_shpid)) {
+  print "Usage: $0 --infile1=[filename] --infile1_shpid=[shpid] --infile2=[filename] --infile2_shpid=[shpid]\n";
+  exit 0;
+}
+
+# open the first input shapefile
+my $inshpf1 = new mapscript::shapefileObj($infile1, -1) or die "Unable to open shapefile $infile1.";
+my $inshpf2 = new mapscript::shapefileObj($infile2, -1) or die "Unable to open shapefile $infile2.";
+
+my $inshape1 = $inshpf1->getShape($infile1_shpid);
+my $inshape2 = $inshpf2->getShape($infile2_shpid);
+
+$within = $inshape1->within($inshape2);
+
+if ($within == 1) {
+  $within = "WITHIN";
+}
+elsif ($within == 0) {
+  $within = "NOT WITHIN";
+}
+
+undef $inshpf1;
+undef $inshpf2;
+
+print "Shape $infile1/$infile1_shpid is $within shape $infile2/$infile2_shpid\n";
+
diff -pruN 8.0.1-5/src/mapscript/perl/examples/shpinfo.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shpinfo.pl
--- 8.0.1-5/src/mapscript/perl/examples/shpinfo.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/shpinfo.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,41 @@
+#!/usr/bin/perl
+
+use strict;
+use warnings;
+use XBase;
+use mapscript;
+use Getopt::Long;
+
+my $file;
+
+my %types = ( '1' => 'point',
+              '3' => 'arc',
+              '5' => 'polygon',
+              '8' => 'multipoint'
+            );
+
+GetOptions("file=s", \$file);
+if(!$file) {
+  print "Syntax: shpinfo.pl --file=[filename]\n";
+  exit 0;
+}
+
+my $shapefile = new mapscript::shapefileObj($file, -1) or die "Unable to open shapefile $file.";
+
+print "Shapefile $file:\n\n";
+print "\ttype: ". $types{$shapefile->{type}} ."\n"; 
+print "\tnumber of features: ". $shapefile->{numshapes} ."\n";
+printf "\tbounds: (%f,%f) (%f,%f)\n", $shapefile->{bounds}->{minx}, $shapefile->{bounds}->{miny}, $shapefile->{bounds}->{maxx}, $shapefile->{bounds}->{maxy};
+
+my $table = new XBase $file.'.dbf' or die XBase->errstr;
+
+print "\nXbase table $file.dbf:\n\n";
+
+print "\tnumber of records: ". ($table->last_record+1) ."\n";
+print "\tnumber of fields: ". ($table->last_field+1) ."\n\n";
+
+print "\tName             Type Length Decimals\n";
+print "\t---------------- ---- ------ --------\n";
+foreach ($table->field_names) {
+  printf "\t%-16s %4s %6d %8d\n", $_, $table->field_type($_), $table->field_length($_), $table->field_decimal($_)
+}
diff -pruN 8.0.1-5/src/mapscript/perl/examples/thin.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/thin.pl
--- 8.0.1-5/src/mapscript/perl/examples/thin.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/thin.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,132 @@
+#!/usr/bin/perl
+# Script : thin.pl
+#
+# Purpose: An adaption of the ArcView Avenue example script genfeat.ave. It's
+#          basically the Douglas-Peucker generalization algorithm.
+#          (http://mapserver.gis.umn.edu/community/scripts/thin.pl)
+#
+# $Id$
+#
+
+use strict;
+use warnings;
+use mapscript;
+use Getopt::Long;
+use File::Copy;
+
+my ($infile, $outfile, $tolerance);
+
+GetOptions("input=s", \$infile, "output=s", \$outfile, "tolerance=n", \$tolerance);
+
+if(!$infile or !$outfile or !$tolerance) {
+  print "Usage: $0 --input=[filename] --output=[filename] --tolerance=[maximum distance between vertices]\n";
+  exit 0;
+}
+
+die "Tolerance must be greater than zero." unless $tolerance > 0;
+
+# initialize counters for reporting
+my $incount  = 0;
+my $outcount = 0;
+
+# open the input shapefile
+my $inSHP = new mapscript::shapefileObj($infile, -1) or die "Unable to open shapefile $infile.";
+
+die "Cannot thin point/multipoint shapefiles." unless ($inSHP->{type} == 5 or $inSHP->{type} == 3);
+
+# create the output shapefile
+
+unlink "$outfile.shp";
+unlink "$outfile.shx";
+unlink "$outfile.dbf";
+
+my $outSHP = new mapscript::shapefileObj($outfile, $inSHP->{type}) or die "Unable to create shapefile '$outfile'. $!\n";
+
+copy("$infile.dbf", "$outfile.dbf") or die "Can't copy file $infile.dbf to $outfile.dbf: $!\n";
+
+my $inshape = new mapscript::shapeObj(-1); # something to hold shapes
+
+for(my $i=0; $i<$inSHP->{numshapes}; $i++) {
+
+  $inSHP->get($i, $inshape);
+  my $outshape = new mapscript::shapeObj(-1);
+
+  for(my $j=0; $j<$inshape->{numlines}; $j++) {
+
+    my $inpart  = $inshape->get($j);
+    my $outpart = new mapscript::lineObj();
+
+    my @stack = ();
+
+    $incount += $inpart->{numpoints};
+
+    my $anchor = $inpart->get(0); # save first point
+    $outpart->add($anchor);
+    my $aIndex = 0;
+
+    my $fIndex = $inpart->{numpoints} - 1;
+    push @stack, $fIndex;
+
+    # Douglas - Peucker algorithm
+    while(@stack) {
+
+      $fIndex = $stack[$#stack];
+      my $fPoint = $inpart->get($fIndex);
+
+      my $max = $tolerance; # comparison values
+      my $maxIndex = 0;
+
+      # process middle points
+      for (($aIndex+1) .. ($fIndex-1)) {
+
+        my $point = $inpart->get($_);
+        #my $dist = $point->distanceToLine($anchor, $fPoint);
+        my $dist = $point->distanceToSegment($anchor, $fPoint);
+
+        if($dist >= $max) {
+          $max = $dist;
+          $maxIndex = $_;
+        }
+      }
+
+      if($maxIndex > 0) {
+        push @stack, $maxIndex;
+      } else {
+        $outpart->add($fPoint);
+        $anchor = $inpart->get(pop @stack);
+        $aIndex = $fIndex;
+      }
+    }
+
+    # check for collapsed polygons, use original data in that case
+    if(($outpart->{numpoints} < 4) and ($inSHP->{type} == 5)) {
+      $outpart = $inpart;
+    }
+
+    $outcount += $outpart->{numpoints};
+    $outshape->add($outpart);
+
+  } # for each part
+
+  $outSHP->add($outshape);
+  undef($outshape); # free memory associated with shape
+
+} # for each shape
+
+$outSHP = ''; # write the file
+
+undef $inSHP;
+undef $outSHP;
+
+my $reduction = ((($outcount / $incount) * 100) - 100) * -1;
+
+print <<END;
+
+$0 Summary:
+
+Input File  : $infile  ($incount vertices)
+Output File : $outfile ($outcount vertices)
+Tolerance   : $tolerance
+Reduction   : $reduction%
+
+END
diff -pruN 8.0.1-5/src/mapscript/perl/examples/wxs.pl 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/wxs.pl
--- 8.0.1-5/src/mapscript/perl/examples/wxs.pl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/examples/wxs.pl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,115 @@
+#!/usr/bin/perl
+############################################################################
+# $Id: $
+#
+# Project:  MapServer
+# Purpose:  MapScript WxS example
+# Author:   Tom Kralidis (tomkralidis@gmail.com)
+#
+##############################################################################
+# Copyright (c) 2007, Tom Kralidis
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in
+# all copies of this Software or works derived from this Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+############################################################################/
+
+use CGI::Carp qw(fatalsToBrowser);
+use mapscript;
+use strict;
+use warnings;
+use XML::LibXSLT;
+use XML::LibXML;
+
+my $dispatch;
+
+# uber-trivial XSLT document, as a file
+my $xsltfile = "/tmp/foo.xslt";
+
+# here's the actual document inline for
+# testing save and alter $xsltFile above
+
+=comment
+my $xsltstring = <<END;
+<?xml version="1.0" encoding="UTF-8"?> 
+<xsl:stylesheet version="1.0"
+ xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+ xmlns:wfs="http://www.opengis.net/wfs">
+ <xsl:output method="xml" indent="yes"/> 
+ <xsl:template match="/"> 
+<WFSLayers> 
+<xsl:for-each select="//wfs:FeatureType"> 
+<wfs_layer>
+<name><xsl:value-of select="wfs:Name"/></name> 
+<title><xsl:value-of select="wfs:Title"/></title> 
+</wfs_layer>
+</xsl:for-each> 
+</WFSLayers> 
+</xsl:template> 
+</xsl:stylesheet>
+=cut
+
+my $mapfile  = "/tmp/config.map";
+
+# init OWSRequest object
+my $req = new mapscript::OWSRequest();
+
+# pick up CGI paramters passed
+$req->loadParams();
+
+# init mapfile 
+my $map = new mapscript::mapObj($mapfile);
+
+# if this is a WFS GetCapabilities request, then intercept
+# what is normally returned, process with an XSLT document
+# and then return that to the client
+if ($req->getValueByName('REQUEST') eq "GetCapabilities" && $req->getValueByName('SERVICE') eq "WFS") {
+
+  # push STDOUT to a buffer and run the incoming request
+  my $io = mapscript::msIO_installStdoutToBuffer();
+  $dispatch = $map->OWSDispatch($req);
+
+  # at this point, the client's request is sent
+
+  # pull out the HTTP headers
+  my $ct = mapscript::msIO_stripStdoutBufferContentType();
+
+  # and then pick up the actual content of the response
+  my $content = mapscript::msIO_getStdoutBufferString();
+
+  my $xml  = XML::LibXML->new();
+  my $xslt = XML::LibXSLT->new();
+
+  # load XML content
+  my $source = $xml->parse_string($content);
+
+  # load XSLT document
+  my $style_doc = $xml->parse_file($xsltfile);
+  my $stylesheet = $xslt->parse_stylesheet($style_doc);
+
+  # invoke the XSLT transformation
+  my $results = $stylesheet->transform($source);
+
+  # print out the result (header + content)
+  print "Content-type: $ct\n\n";
+  print $stylesheet->output_string($results);
+}
+
+# else process as normal
+else {
+  $dispatch = $map->OWSDispatch($req);
+}
diff -pruN 8.0.1-5/src/mapscript/perl/plextend.i 8.2.0~beta1-1~exp1/src/mapscript/perl/plextend.i
--- 8.0.1-5/src/mapscript/perl/plextend.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/plextend.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,15 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Perl-specific extensions to MapScript objects
+ * Author: SDL based on Sean's Python conventions
+ *
+ ******************************************************************************
+ *
+ * Perl-specific mapscript code has been moved into this 
+ * SWIG interface file to improve the readibility of the main
+ * interface file.  The main mapscript.i file includes this
+ * file when SWIGPERL is defined (via 'swig -perl5 ...').
+ *
+ *****************************************************************************/
+
diff -pruN 8.0.1-5/src/mapscript/perl/plmodule.i 8.2.0~beta1-1~exp1/src/mapscript/perl/plmodule.i
--- 8.0.1-5/src/mapscript/perl/plmodule.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/plmodule.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,200 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Perl-specific enhancements to MapScript
+ * Author:   SDL based on Sean's Python conventions
+ *
+ ******************************************************************************
+ *
+ * Perl-specific mapscript code has been moved into this 
+ * SWIG interface file to improve the readibility of the main
+ * interface file.  The main mapscript.i file includes this
+ * file when SWIGPERL is defined (via 'swig -perl5 ...').
+ *
+ *****************************************************************************/
+
+/******************************************************************************
+ * Simple Typemaps
+ *****************************************************************************/
+
+%init %{
+  if(msSetup() != MS_SUCCESS) {
+    msSetError(MS_MISCERR, "Error initializing MapServer/Mapscript.", "msSetup()");
+  }
+%}
+
+/* Translate Perl's built-in file object to FILE * */
+%typemap(in) FILE * {
+  $1 = PerlIO_exportFILE (IoIFP (sv_2io ($input)), NULL);
+}
+
+/* To support imageObj::getBytes */
+%typemap(out) gdBuffer {
+        SV *mysv;
+        mysv = sv_newmortal();
+        if ($1.data == NULL)
+            sv_setpv(mysv,"");
+        else
+            sv_setpvn(mysv,(const char*)$1.data,$1.size);
+        $result = newRV(mysv);
+        sv_2mortal($result);
+        argvi++;
+        if( $1.owns_data )
+            msFree($1.data);
+}
+
+%typemap(out) char[ANY] {
+        $result = newSVpvn($1, strlen($1));
+        argvi++;
+}
+
+/*
+===============================================================================
+RFC-24 implementation follows
+===============================================================================
+   Modified constructor according to:
+   - cache population and sync, item 3.2
+   - reference counter since Perl does not obey %newobject
+*/
+%allowexception;
+
+%exception layer {
+	/* Accessing layer */
+	$action;
+	MS_REFCNT_INCR(result);
+}
+%exception map {
+	/* Accessing map */
+	$action;
+	MS_REFCNT_INCR(result);
+}
+
+%feature("shadow") layerObj(mapObj *map)
+%{
+sub new {
+        my $pkg = shift;
+        my $self = mapscriptc::new_layerObj(@_);
+        bless $self, $pkg if defined($self);
+        if (defined($_[0])) {
+                # parent reference
+                mapscript::RFC24_ADD_PARENT_REF( tied(%$self), $_[0]);
+        }
+        return $self;
+}
+%}
+
+%feature("shadow") getLayer(int i)
+%{
+sub getLayer {
+        my $layer = mapscriptc::mapObj_getLayer(@_);
+        if (defined($layer)) {
+                # parent reference
+                #print "l=$layer,m=$_[0]\n";
+                mapscript::RFC24_ADD_PARENT_REF( tied(%$layer) , $_[0]);
+        }
+        return $layer;
+}
+%}
+
+%feature("shadow") getLayerByName(char* name)
+%{
+sub getLayerByName {
+        my $layer = mapscriptc::mapObj_getLayerByName(@_);
+        if (defined($layer)) {
+                # parent reference
+                #print "l=$layer,m=$_[0]\n";
+                mapscript::RFC24_ADD_PARENT_REF( tied(%$layer) , $_[0]);
+        }
+        return $layer;
+}
+%}
+
+%feature("shadow") insertLayer
+%{
+sub insertLayer {
+        my $idx = mapscriptc::mapObj_insertLayer(@_);
+        my $layer=$_[1];
+        # parent reference
+        mapscript::RFC24_ADD_PARENT_REF(tied(%$layer), $_[0]);
+        return $idx;
+}
+%}
+
+%feature("shadow") ~layerObj()
+%{
+sub DESTROY {
+        return unless $_[0]->isa('HASH');
+        my $self = tied(%{$_[0]});
+        return unless defined $self;
+        delete $ITERATORS{$self};
+        mapscriptc::delete_layerObj($self);
+        # remove parent reference
+        mapscript::RFC24_DEL_PARENT_REF($self);
+}
+%}
+
+%feature("shadow") classObj(layerObj *layer)
+%{
+sub new {
+        my $pkg = shift;
+        my $self = mapscriptc::new_classObj(@_);
+        bless $self, $pkg if defined($self);
+        if (defined($_[0])) {
+                # parent reference
+                mapscript::RFC24_ADD_PARENT_REF( tied(%$self), $_[0]);
+        }
+        return $self;
+}
+%}
+
+%feature("shadow") getClass(int i)
+%{
+sub getClass {
+        my $clazz = mapscriptc::layerObj_getClass(@_);
+        if (defined($clazz)) {
+                # parent reference
+                mapscript::RFC24_ADD_PARENT_REF( tied(%$clazz) , $_[0]);
+        }
+        return $clazz;
+}
+%}
+%feature("shadow") insertClass
+%{
+sub insertClass {
+        my $idx = mapscriptc::layerObj_insertClass(@_);
+        my $clazz=$_[1];
+        # parent reference
+        mapscript::RFC24_ADD_PARENT_REF(tied(%$clazz), $_[0]);
+        return $idx;
+}
+%}
+
+%feature("shadow") ~classObj()
+%{
+sub DESTROY {
+        return unless $_[0]->isa('HASH');
+        my $self = tied(%{$_[0]});
+        return unless defined $self;
+        delete $ITERATORS{$self};
+        mapscriptc::delete_classObj($self);
+        # remove parent reference
+        mapscript::RFC24_DEL_PARENT_REF($self);
+}
+%}
+%perlcode %{
+        %PARENT_PTRS=();
+        sub RFC24_ADD_PARENT_REF {
+                my ($child, $parent)=@_;
+                $PARENT_PTRS{ $$child }=$parent;
+        }
+        sub RFC24_DEL_PARENT_REF {
+                my ($child)=@_;
+                delete $PARENT_PTRS{ $$child };
+        }
+
+        # USE THIS function only for debugging!
+        sub getPARENT_PTRS {
+                return \%PARENT_PTRS;
+        }
+%}
diff -pruN 8.0.1-5/src/mapscript/perl/tests/0-load.t 8.2.0~beta1-1~exp1/src/mapscript/perl/tests/0-load.t
--- 8.0.1-5/src/mapscript/perl/tests/0-load.t	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/tests/0-load.t	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,40 @@
+#!/usr/bin/perl
+use strict;
+use warnings;
+use Test::More tests => 11;
+
+# check the mapserver version for keywords
+sub msHas
+{
+	my ($mod) = @_;
+	my $ver = mapscript::msGetVersion();
+	if (index($ver, $mod) > -1) {
+		return 1;
+	} else {
+		return 0;
+	}
+}
+
+require_ok( 'mapscript' );
+diag("Testing: " . $INC{'mapscript.pm'});
+diag( mapscript::msGetVersion() );
+
+SKIP: {
+	skip "no geos support", 10 unless msHas('SUPPORTS=GEOS');
+    my @wkt_list = (
+		'POINT (5.0000000000000000 7.0000000000000000)',
+		'LINESTRING (5.0000000000000000 7.0000000000000000, 7.0000000000000000 9.0000000000000000, 9.0000000000000000 -1.0000000000000000)',
+		'POLYGON ((500.0000000000000000 500.0000000000000000, 3500.0000000000000000 500.0000000000000000, 3500.0000000000000000 2500.0000000000000000, 500.0000000000000000 2500.0000000000000000, 500.0000000000000000 500.0000000000000000), (1000.0000000000000000 1000.0000000000000000, 1000.0000000000000000 1500.0000000000000000, 1500.0000000000000000 1500.0000000000000000, 1500.0000000000000000 1000.0000000000000000, 1000.0000000000000000 1000.0000000000000000))',
+		'MULTIPOINT (2000.0000000000000000 2000.0000000000000000, 2000.0000000000000000 1900.0000000000000000)',
+		'MULTILINESTRING ((600.0000000000000000 1500.0000000000000000, 1600.0000000000000000 2500.0000000000000000), (700.0000000000000000 1500.0000000000000000, 1700.0000000000000000 2500.0000000000000000))'
+	);
+
+	for my $orig (@wkt_list)
+	{
+		my $shp = mapscript::shapeObj::fromWKT( $orig );
+		ok( $shp, 'create shapeObj');
+		my $new_wkt = $shp->toWKT();
+		ok( $orig eq $new_wkt, 'from WKT <> toWKT' );
+	}
+};
+
diff -pruN 8.0.1-5/src/mapscript/perl/tests/maps.t 8.2.0~beta1-1~exp1/src/mapscript/perl/tests/maps.t
--- 8.0.1-5/src/mapscript/perl/tests/maps.t	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/perl/tests/maps.t	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,61 @@
+#!/usr/bin/perl
+use strict;
+use warnings;
+use Test::More tests => 10;
+use mapscript;
+
+sub msHas
+{
+	my ($mod) = @_;
+	my $ver = mapscript::msGetVersion();
+	if (index($ver, $mod) > -1) {
+		return 1;
+	} else {
+		return 0;
+	}
+}
+
+# we need to search up directories for the test folder
+my $mapfile = '../../../msautotest/mspython/test_mapio.map';
+if (! -e $mapfile)
+{
+	$mapfile = '../../../../msautotest/mspython/test_mapio.map';
+}
+ok(-e $mapfile, 'mapfile exists');
+
+my $map = new mapscript::mapObj($mapfile);
+ok($map, 'create mapObj');
+
+mapscript::msIO_installStdoutToBuffer();
+my $owreq = new mapscript::OWSRequest();
+ok($owreq, 'create OWSRequest');
+$owreq->loadParamsFromURL('service=WMS&version=1.1.1&request=GetMap&layers=grey&srs=EPSG:4326&bbox=-180,-90,180,90&format=image/png&width=80&height=40&STYLES=');
+ok($owreq->getName(0) eq 'service');
+ok($owreq->getValue(0) eq 'WMS');
+ok($owreq->getValueByName('request') eq 'GetMap');
+
+my $err = $map->OWSDispatch( $owreq );
+ok($err == 0, 'OWSDispatch');
+
+#	warn(mapscript::msGetErrorString("\n"));
+
+my $h  = mapscript::msIO_getAndStripStdoutBufferMimeHeaders();
+#my $k = $h->nextKey();
+#while ($k)
+#{
+#	diag("$k == " . $h->get($k));
+#	$k = $h->nextKey($k);
+#}
+
+ok($h->get('Cache-Control') eq 'max-age=86400');
+ok($h->get('Content-Type') eq 'image/png');
+
+
+my $x = mapscript::msIO_getStdoutBufferBytes();
+#open(F, '>', 'x.png');
+#print F $$x;
+#close(F);
+
+ok(substr($$x, 1, 3) eq 'PNG');
+
+
diff -pruN 8.0.1-5/src/mapscript/php/README.md 8.2.0~beta1-1~exp1/src/mapscript/php/README.md
--- 8.0.1-5/src/mapscript/php/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/php/README.md	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4 @@
+Old native (and unmaintained) PHP MapScript was removed for the 
+MapServer 8.0 release.  Please see the /mapscript/phpng/ folder 
+for the maintained PHP MapScript support through SWIG, or the 
+documentation at https://mapserver.org/mapscript/mapscript.html .
diff -pruN 8.0.1-5/src/mapscript/phpng/CMakeLists.txt 8.2.0~beta1-1~exp1/src/mapscript/phpng/CMakeLists.txt
--- 8.0.1-5/src/mapscript/phpng/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/phpng/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,91 @@
+find_package(SWIG REQUIRED)
+include(${SWIG_USE_FILE})
+if(WIN32 AND ((${CMAKE_VERSION} EQUAL "3.12.0") OR (${CMAKE_VERSION} EQUAL "3.12.1") OR (${CMAKE_VERSION} EQUAL "3.12.2") OR (${CMAKE_VERSION} EQUAL "3.12.3")))
+    message(FATAL_ERROR "Building with CMAKE ${CMAKE_VERSION} will not work. Please downgrade to 3.11.x or update to a higher version than 3.12.3")
+endif()
+
+if(WIN32)
+  FIND_PACKAGE(SWIG 3.0.11 REQUIRED)
+  if(WITH_THREAD_SAFETY)
+    FIND_PACKAGE(SWIG 4.0.0 REQUIRED)
+  endif(WITH_THREAD_SAFETY)
+endif(WIN32)
+
+FIND_PACKAGE(PHP REQUIRED)
+INCLUDE(UseSWIG)
+
+if(WIN32)
+  add_definitions(/DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
+  if(NOT CMAKE_CL_64)
+    add_definitions(-D_USE_32BIT_TIME_T)
+  endif(NOT CMAKE_CL_64)
+  if(WITH_THREAD_SAFETY)
+    add_definitions(-DZTS=1)
+  endif(WITH_THREAD_SAFETY)
+endif(WIN32)
+
+include_directories(${PHP_INCLUDE_PATH})
+message(STATUS "PHP Include Path: ${PHP_INCLUDE_PATH}")
+
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/phpng)
+include_directories(${CMAKE_CURRENT_BINARY_DIR}) # make sure mapscriptPHP7_wrap.c is found
+
+if(WIN32)
+  include_directories(${PHP_INCLUDE_PATH}/win32)
+endif(WIN32)
+
+IF(PHP_VERSION LESS 5)
+  MESSAGE(FATAL_ERROR "PHP version is not 5 or later")
+ENDIF(PHP_VERSION LESS 5)
+
+IF(PHP_VERSION LESS 7)
+  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
+      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php SOURCES ../mapscript.i)
+  else ()
+      swig_add_module(php_mapscriptng php ../mapscript.i)
+  endif ()
+ELSE()
+  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
+      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php7 SOURCES ../mapscript.i)
+  else ()
+      swig_add_module(php_mapscriptng php7 ../mapscript.i)
+  endif ()
+ENDIF(PHP_VERSION LESS 7)
+
+if(WIN32)
+  target_compile_options(php_mapscriptng PRIVATE /DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
+  if(WITH_THREAD_SAFETY)
+    target_compile_options(php_mapscriptng PRIVATE /DZTS=1)
+  endif(WITH_THREAD_SAFETY)
+  SWIG_LINK_LIBRARIES(php_mapscriptng ${PHP_LIBRARY})
+endif(WIN32)
+
+IF(APPLE)
+  if(XCODE)
+     SET(CMAKE_C_LINK_FLAGS 
+        "${CMAKE_C_LINK_FLAGS} -undefined dynamic_lookup")
+     SET(CMAKE_CXX_LINK_FLAGS 
+        "${CMAKE_CXX_LINK_FLAGS} -undefined dynamic_lookup")
+  else(XCODE)
+     SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS 
+        "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -undefined dynamic_lookup")
+     SET(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS 
+        "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
+  endif(XCODE)
+ENDIF(APPLE)
+
+# hide "defined but not used" warnings
+target_compile_options(php_mapscriptng PRIVATE -Wno-unused-label)
+
+target_link_libraries(php_mapscriptng mapserver)
+set_target_properties(${SWIG_MODULE_mapscript_REAL_NAME} PROPERTIES PREFIX "")
+
+if(NOT WIN32)
+  install(TARGETS php_mapscriptng DESTINATION ${PHP_EXTENSION_DIR})
+  # check if we must install the required file containing MapServer constants and functions
+  if(${SWIG_VERSION} LESS_EQUAL 4.0.2)
+     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mapscript.php DESTINATION ${PHP_EXTENSION_DIR} COMPONENT dev)
+  endif()
+endif()
diff -pruN 8.0.1-5/src/mapscript/phpng/README.WIN32 8.2.0~beta1-1~exp1/src/mapscript/phpng/README.WIN32
--- 8.0.1-5/src/mapscript/phpng/README.WIN32	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/phpng/README.WIN32	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,71 @@
+This readme covers building Mapserver from scatch on Windows.
+We will download current development state of php.
+If you need MapscriptNG for a different version of php, you have to fit the commands below.
+For the first time, it is a good idea to build as shown below and after you have a working state, you can change whatever you want, knowing there is a working state you can return to.
+
+All you need is Visual Studio 2017 Express (latest Version, check for updates) and GIT installed.
+
+To begin, start x64 or x86 Native Tools Command Prompt for VS 2017 and just execute all Commands listed below.
+Please always stay inside PHP-SDK-Shell to have wget and unzip available.
+
+rem --------------------------------------------------------------------
+rem Step 1: Create Directories
+rem --------------------------------------------------------------------
+mkdir C:\projects
+mkdir C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
+
+rem --------------------------------------------------------------------
+rem Step 2: Build PHP
+rem --------------------------------------------------------------------
+cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
+git clone https://github.com/Microsoft/php-sdk-binary-tools.git php-sdk
+cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\php-sdk
+set VS_VERSION=%VSCMD_VER:~0,2%
+phpsdk-vc%VS_VERSION%-%VSCMD_ARG_TGT_ARCH%.bat
+phpsdk_buildtree phpmaster
+git clone https://github.com/php/php-src.git
+cd php-src
+phpsdk_deps --update --branch master
+buildconf
+configure --enable-snapshot-build
+nmake snap
+
+rem --------------------------------------------------------------------
+rem Step 3: Get GISInternals SDK
+rem --------------------------------------------------------------------
+cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
+mkdir packages
+mkdir packages\gisinternals%VSCMD_ARG_TGT_ARCH%\
+mkdir gisinternals%VSCMD_ARG_TGT_ARCH%
+set GISInternalsArchitecture=-
+if %VSCMD_ARG_TGT_ARCH% == x64 set GISInternalsArchitecture=-%VSCMD_ARG_TGT_ARCH%-
+wget -O packages\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911%GISInternalsArchitecture%dev.zip http://download.gisinternals.com/sdk/downloads/release-1911%GISInternalsArchitecture%dev.zip
+unzip -q -o packages\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911%GISInternalsArchitecture%dev.zip -d gisinternals%VSCMD_ARG_TGT_ARCH%
+
+rem --------------------------------------------------------------------
+rem Step 4: Other Dependencies
+rem --------------------------------------------------------------------
+rem ### SWIG ###
+cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
+git clone https://github.com/AlexanderGabriel/swig
+mkdir swig\build
+cd swig\build
+cmake .. -G "NMake Makefiles"  -DCMAKE_BUILD_TYPE=Release
+cmake --build .
+move swig.exe ..
+rem ### gnulib ###
+cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
+git clone git://git.savannah.gnu.org/gnulib.git
+
+--------------------------------------------------------------------
+Step 5: Build Mapserver with php_mapscriptng
+--------------------------------------------------------------------
+cd C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%
+git clone https://github.com/mapserver/mapserver
+cd mapserver
+mkdir build
+cd build
+cmake .. -G "NMake Makefiles" -DCMAKE_BUILD_TYPE=Release -Wno-dev -DCMAKE_PREFIX_PATH=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911-%VSCMD_ARG_TGT_ARCH%;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gnulib\lib;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gnulib\include;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911-%VSCMD_ARG_TGT_ARCH%\lib;C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\release-1911-%VSCMD_ARG_TGT_ARCH%\include -DREGEX_DIR=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\gisinternals%VSCMD_ARG_TGT_ARCH%\regex-0.12 -DWITH_POSTGIS=0 -DWITH_PROTOBUFC=0 -DWITH_THREAD_SAFETY=1 -DWITH_PHPNG=1 -DSWIG_EXECUTABLE=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\swig\swig.exe -DSWIG_DIR=C:\projects\mapserver%VSCMD_ARG_TGT_ARCH%\swig
+cmake --build .
+
+
diff -pruN 8.0.1-5/src/mapscript/phpng/php7module.i 8.2.0~beta1-1~exp1/src/mapscript/phpng/php7module.i
--- 8.0.1-5/src/mapscript/phpng/php7module.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/phpng/php7module.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,32 @@
+%module mapscriptng;
+
+%pragma(php) phpinfo="
+  php_info_print_table_start();
+  php_info_print_table_row(2, \"MapServer Version\", msGetVersion());
+  php_info_print_table_end();
+"
+
+
+/* To support imageObj::getBytes */
+%typemap(out) gdBuffer {
+    RETVAL_STRINGL((const char*)$1.data, $1.size);
+    if( $1.owns_data )
+       msFree($1.data);
+}
+
+
+/* Module initialization: call msSetup() and register msCleanup() */
+%init %{
+    if (msSetup() != MS_SUCCESS)
+    {
+        msSetError(MS_MISCERR, "Failed to set up threads and font cache",
+                   "msSetup()");
+    }
+
+%}
+
+%mshutdown {
+    msCleanup();
+}
+
+
diff -pruN 8.0.1-5/src/mapscript/python/CMakeLists.txt 8.2.0~beta1-1~exp1/src/mapscript/python/CMakeLists.txt
--- 8.0.1-5/src/mapscript/python/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,136 @@
+find_package(SWIG REQUIRED)
+include(${SWIG_USE_FILE})
+
+find_package (Python REQUIRED COMPONENTS Interpreter Development)
+
+include_directories(${Python_INCLUDE_DIRS})
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/python)
+
+set(SwigFile ${PROJECT_SOURCE_DIR}/src/mapscript/mapscript.i)
+
+# add and comments annotations to py file output - requires >= SWIG 4.1
+if (WITH_PYMAPSCRIPT_ANNOTATIONS AND ${Python_VERSION_MAJOR} GREATER_EQUAL 3)
+  set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -doxygen)
+  if (${Python_VERSION_MINOR} GREATER_EQUAL 6)
+     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c)
+  else ()
+     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c,python:annotations:novar)
+  endif ()
+endif ()
+
+if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
+    swig_add_library(pythonmapscript TYPE MODULE LANGUAGE python SOURCES ${SwigFile})
+else ()
+    swig_add_module(pythonmapscript python ${SwigFile})
+endif ()
+
+swig_link_libraries(pythonmapscript ${Python_LIBRARIES} ${MAPSERVER_LIBMAPSERVER})
+
+set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES PREFIX "")
+set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES OUTPUT_NAME _mapscript)
+
+set(SETUP_PY_IN "${PROJECT_SOURCE_DIR}/src/mapscript/python/setup.py.in")
+set(SETUP_PY_TEMP "${CMAKE_CURRENT_BINARY_DIR}/setup.py.temp")
+
+configure_file(${SETUP_PY_IN} ${SETUP_PY_TEMP} @ONLY)
+file(READ ${SETUP_PY_TEMP} SETUP_CONTENT)
+
+# each target (e.g. Debug, Release etc.) will have a copy of setup.py
+
+file(GENERATE OUTPUT $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/setup.py INPUT ${SETUP_PY_TEMP})
+
+if(MSVC)
+    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE})
+else()
+    # for non-Windows builds there are no build type subfolders (e.g. Release, Debug etc.)
+    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR})
+endif()
+
+if(WIN32)
+    # Windows venv binaries are in a different location than Linux
+    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/Scripts)
+else()
+    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/bin)
+endif()
+
+add_custom_target(
+    pythonmapscript-wheel
+    DEPENDS mapscripttests.stamp
+)
+
+add_custom_command(
+    DEPENDS ${SWIG_MODULE_pythonmapscript_REAL_NAME}
+    OUTPUT mapscriptvenv.stamp
+    WORKING_DIRECTORY ${OUTPUT_FOLDER}
+    COMMAND ${Python_EXECUTABLE} -m pip install pip --upgrade
+    COMMAND ${Python_EXECUTABLE} -m pip install virtualenv
+    COMMAND ${Python_EXECUTABLE} -m virtualenv mapscriptvenv
+    COMMAND ${Python_VENV_SCRIPTS}/pip install -r ${PROJECT_SOURCE_DIR}/src/mapscript/python/requirements-dev.txt > requires.log
+    COMMENT "Creating a Python virtual environment and installing the required packages"
+)
+
+add_custom_command(
+    DEPENDS mapscriptvenv.stamp
+    OUTPUT mapscriptwheel.stamp
+    WORKING_DIRECTORY ${OUTPUT_FOLDER}
+    COMMAND ${Python_VENV_SCRIPTS}/python -m build --wheel > wheel_build.log
+    COMMENT "Building the mapscript Python wheel"
+)
+
+add_custom_command(
+    WORKING_DIRECTORY ${Python_VENV_SCRIPTS} # make sure scripts aren't run when from the same folder as mapscript.py
+    DEPENDS mapscriptwheel.stamp
+    OUTPUT mapscripttests.stamp
+    COMMAND ${Python_VENV_SCRIPTS}/pip install --no-index --find-links=${OUTPUT_FOLDER}/dist mapscript
+    # ERROR: file or package not found: mapscript.tests (missing __init__.py?) is caused by
+    # ImportError: DLL load failed while importing _mapscript: The specified module could not be found.
+    COMMAND ${Python_VENV_SCRIPTS}/python -m pytest --pyargs mapscript.tests
+    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.project_csv ${PROJECT_SOURCE_DIR}/tests/cities.csv 2 1 EPSG:4326 EPSG:3857 > test.csv
+    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpdump ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpdump.txt
+    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpinfo ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpinfo.txt
+    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.wxs ${PROJECT_SOURCE_DIR}/tests/test.map > response.xml
+    COMMENT "Installing the Python wheel and testing it in the virtual environment, then running tests and examples"
+)
+
+add_custom_command(
+    TARGET ${SWIG_MODULE_pythonmapscript_REAL_NAME}
+    WORKING_DIRECTORY ${OUTPUT_FOLDER}
+    POST_BUILD
+    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/src/mapscript/python/mapscript/__init__.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/__init__.py
+    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/mapscript.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/mapscript.py
+    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:${SWIG_MODULE_pythonmapscript_REAL_NAME}>" "$<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/$<TARGET_FILE_NAME:${SWIG_MODULE_pythonmapscript_REAL_NAME}>"
+    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/src/mapscript/python/README.rst" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/README.rst
+    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/src/mapscript/python/tests/cases" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests
+    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/tests" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests/data
+    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/src/mapscript/python/examples" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/examples
+    COMMENT "Copying files required to build Mapscript"
+)
+
+install(
+  CODE "
+  
+    SET(ENV{PYTHONPATH} \${Python_SITELIB}:\$ENV{PYTHONPATH})
+
+    if(DEFINED ENV{DESTDIR})
+      SET(PYTHON_ROOT \"--root=\$ENV{DESTDIR}\")
+    endif()
+
+    if(DEFINED CMAKE_INSTALL_PREFIX)
+      SET(PYTHON_PREFIX \"--prefix=\${CMAKE_INSTALL_PREFIX}\")
+    endif()
+
+    execute_process(
+      COMMAND ${Python_EXECUTABLE} -m pip install \${PYTHON_ROOT} \${PYTHON_PREFIX}
+      WORKING_DIRECTORY ${OUTPUT_FOLDER}
+    )
+  "
+)
+
+message(STATUS "CMake Version: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")
+message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
+message(STATUS "Python MapScript output directory: ${OUTPUT_FOLDER}")
+message(STATUS "Python Executable: ${Python_EXECUTABLE}")
+message(STATUS "Python Version: ${Python_VERSION}")
+message(STATUS "Python site packages: ${Python_SITELIB}")
diff -pruN 8.0.1-5/src/mapscript/python/README.rst 8.2.0~beta1-1~exp1/src/mapscript/python/README.rst
--- 8.0.1-5/src/mapscript/python/README.rst	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/README.rst	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,324 @@
+Python MapScript for MapServer README
+=====================================
+
+:Author: MapServer Team
+:Last Updated: 2024-03-29
+
+Introduction
+------------
+
+The Python mapscript module provides users an interface to `MapServer <http://mapserver.org>`_
+classes on any platform, and has been tested on Python 3.8+. 
+
+The Python mapscript module is created using `SWIG <http://www.swig.org.>`_ the
+the Simplified Wrapper and Interface Generator. This is used to create MapServer bindings in
+many different programming languages. 
+
++ Language agnostic documentation is available at http://mapserver.org/mapscript/introduction.html
++ Python specific documentation is available at http://mapserver.org/mapscript/python.html
+
+When working with Mapfiles in Python the `mappyfile <https://mappyfile.readthedocs.io/en/latest/>`_ project can
+also be used, this allows creating, parsing, formatting, and validating Mapfiles without any dependencies on MapServer. 
+
+Wheels and PyPI
+---------------
+
+Python `wheels <https://wheel.readthedocs.io/en/stable/>`_ for Windows are automatically and uploaded to 
+`PyPI <https://pypi.org/>`_ - the Python Package Index on each MapServer release. 
+Note - MapServer binaries still need to be installed on the system, and are not included in the wheel itself, 
+see the *Installation* section below.
+
+Advantages of ready-made wheels on PyPI include:
+
++ easy installation using `pip <https://pypi.org/project/pip/>`_
++ mapscript can be added as a dependency to `Requirements Files <https://pip.pypa.io/en/stable/user_guide/#id1>`_
++ mapscript can be easily added to a Python `Virtual Environment <https://docs.python-guide.org/dev/virtualenvs/>`_
++ Python2 or Python3 versions of mapscript can be installed and work with a single installation of MapServer
+
+Wheels are built based on the `Appveyor build environments <https://github.com/MapServer/MapServer/blob/main/appveyor.yml>`_. 
+These are as follows at the time of writing:
+
++ Python 3.8 x64
++ Python 3.9 x64
++ Python 3.10 x64
++ Python 3.11 x64
++ Python 3.12 x64
+
+The mapscript wheels have been compiled using Visual Studio 2022 version 17 (``MSVC++ 17.9 _MSC_VER == 1939``). 
+Linux Wheels may also be available in the future using the `manylinux <https://github.com/pypa/manylinux>`_ project. 
+
+No source distributions will be provided on PyPI - to build from source requires the full MapServer source code,
+in which case it is easiest to take a copy of the full MapServer project and run the CMake process detailed below. 
+
+The Wheels contain a full test suite and sample data that can be run to check that the installed MapServer is
+running correctly. 
+
+..
+    py3 SWIG flag adds type annotations
+
+Installation on Windows
+-----------------------
+
+To use mapscript you will need to add the MapServer binaries to your system path. 
+
+For Python 3.8+
++++++++++++++++
+
+As of `Python 3.8 <https://docs.python.org/3/whatsnew/3.8.html#changes-in-the-python-api>`_ ``PATH`` 
+and the current working directory are no longer used when searching for the MapServer DLLs.
+A new environment variable ``MAPSERVER_DLL_PATH`` has been introduced to set the location of the MapServer DLLs.
+On Windows you can use the following, replacing ``C:\MapServer\bin`` with the location of your MapServer binaries.
+
+.. code-block:: bat
+
+    SET MAPSERVER_DLL_PATH=C:\MapServer\bin
+
+If several folders are required (e.g. GDAL DLLs) multiple paths can be provided separated by semi-colons:
+
+.. code-block:: bat
+
+    SET MAPSERVER_DLL_PATH=C:\MapServer\bin;C:\GDAL\bin
+
+In PowerShell you can set this as follows:
+
+.. code-block:: ps1
+
+    $env:MAPSERVER_DLL_PATH="C:\MapServer\bin"
+
+For Earlier Python Versions
++++++++++++++++++++++++++++
+
+For Python 3.7 and earlier (including Python 2.7) you can use either the ``MAPSERVER_DLL_PATH`` variable documented above,
+or the system ``PATH`` variable as below, replacing ``C:\MapServer\bin`` with the location of your MapServer binaries. 
+
+.. code-block:: bat
+
+    SET PATH=C:\MapServer\bin;%PATH%
+
+Windows Binaries
+++++++++++++++++
+
+Windows binary packages can be downloaded from `GIS Internals <https://www.gisinternals.com/stable.php>`_. 
+To ensure compatibility with the wheels, please use identical release packages, e.g. ``release-1930-x64-gdal-3-8-4-mapserver-8-0-1``
+for mapscript 8.0.1. 
+
+.. NOTE::
+   `MS4W <https://www.ms4w.com>`_ (MapServer for Windows) is a full installer that contains Python & Python
+   MapScript already configured out-of-the-box, as well as default OGC web services and over 60 working mapfiles.
+
+When using these packages the MapServer path will be similar to ``C:\release-1930-x64-gdal-3-8-4-mapserver-8-0-1\bin``. 
+
+Prior to installing mapscript it is recommended to update pip to the latest version with the following command:
+
+.. code-block:: bat
+
+    python -m pip install --upgrade pip
+
+If there are binary wheels available for your system, mapscript can be installed using:
+
+.. code-block:: bat
+
+    pip install mapscript
+
+If you already have mapscript installed and wish to upgrade it to a newer version you can use:
+
+.. code-block:: bat
+
+    pip install mapscript --upgrade
+
+Now you should be able to import mapscript:
+
+.. code-block:: python
+
+    python -c "import mapscript;print(mapscript.msGetVersion())"
+    MapServer version 8.0.1 PROJ version 9.3 GDAL version 3.9 OUTPUT=PNG OUTPUT=JPEG SUPPORTS=PROJ SUPPORTS=AGG SUPPORTS=FREETYPE SUPPORTS=CAIRO SUPPORTS=SVG_SYMBOLS SUPPORTS=SVGCAIRO SUPPORTS=ICONV SUPPORTS=FRIBIDI SUPPORTS=WMS_SERVER SUPPORTS=WMS_CLIENT SUPPORTS=WFS_SERVER SUPPORTS=WFS_CLIENT SUPPORTS=WCS_SERVER SUPPORTS=OGCAPI_SERVER SUPPORTS=FASTCGI SUPPORTS=THREADS SUPPORTS=GEOS SUPPORTS=PBF INPUT=JPEG INPUT=POSTGIS INPUT=OGR INPUT=GDAL INPUT=SHAPEFILE INPUT=FLATGEOBUF
+
+Installation on Unix
+--------------------
+
+For Unix users there are two approaches to installing mapscript. The first is to install the ``python3-mapscript`` package using a package manager. For example on
+Ubuntu the following command can be used:
+
+.. code-block:: bat
+
+    sudo apt-get install python3-mapscript
+
+The second approach is to build and install the Python mapscript module from source. Full details on compiling MapServer from source are detailed on the
+`Compiling on Unix <https://www.mapserver.org/installation/unix.html>`_ page. To make sure Python mapscript is built alongside MapServer the following flag needs to be set:
+
+.. code-block:: bat
+
+    -DWITH_PYTHON=ON
+
+To configure the path of the mapscript installation location ``-DCMAKE_INSTALL_PREFIX`` can be set, e.g. 
+
+.. code-block:: bat
+
+    sudo cmake .. -DCMAKE_INSTALL_PREFIX=/usr
+
+When installing the `DESTDIR <https://cmake.org/cmake/help/latest/envvar/DESTDIR.html>`_ variable can be set (note ``DESTDIR`` is not used on Windows)
+to install mapscript to a non-default location. E.g.
+
+.. code-block:: bat
+
+    make install DESTDIR=/tmp
+
+In summary the ``install`` target runs the ``setup.py install`` command using custom paths (when set) similar to below:
+
+    python setup.py install --root=${DESTDIR} --prefix={CMAKE_INSTALL_PREFIX}
+
+Installation Troubleshooting
+----------------------------
+
+If the ``_mapscript.pyd`` (or ``_mapscript.so`` on Unix) is missing from the `Lib/site-packages/mapscript` 
+folder (which can happen if the source installation is installed rather than a pre-compiled version) the following error will occur:
+
+.. code-block:: python
+
+    ImportError: cannot import name '_mapscript' from partially initialized module 'mapscript' (most likely due to a circular import)
+
+If the mapscript library is not on your ``PYTHONPATH`` you may see one of the following errors:
+
+.. code-block:: python
+
+    ModuleNotFoundError: No module named '_mapscript' # Python 3.x
+
+If the ``MapServer.dll`` cannot be found in your system paths (or ``MAPSERVER_DLL_PATH`` environment variable when using Python 3.8 
+or higher on Windows) you will see the following message:
+
+.. code-block:: python
+
+    ImportError: DLL load failed: The specified module could not be found.
+
+If MapServer has been built with a dependency also used by Python, and the versions don't match you may see the error below. 
+
+.. code-block:: python
+
+    ImportError: DLL load failed: The specified procedure could not be found.
+
+This is a particular problem on Windows with ``sqlite3.dll`` as it is used by both Python and MapServer. Copying the ``sqlite3.dll``
+from the MapServer binaries folder alongside ``_mapscript.pyd`` in `Lib/site-packages/mapscript` can resolve this.
+
+Another common cause is if the Python environment contains multiple versions of the GEOS binary. For example ``geos_c.dll`` is included
+as part of the Shapely Python library, as well as a MapServer installation.
+
+If you are using 32 bit Python on Windows and attempt to use a 64 bit version of MapScript the following import error will occur:
+
+.. code-block:: python
+
+    ImportError: DLL load failed while importing _mapscript: %1 is not a valid Win32 application.
+
+Quickstart
+----------
+
+Some basic examples of what can be done with mapscript are shown below. Note - before running any scripts using mapscript, 
+you will need to add the MapServer binaries to your system path, see the *Installation* section above. 
+
+To open an existing Mapfile:
+
+.. code-block:: python
+
+    >>> import mapscript
+    >>> test_map = mapscript.mapObj(r"C:\Maps\mymap.map")
+    >>> extent = test_map.extent
+
+Create a layer from a string:
+
+.. code-block:: python
+
+    >>> import mapscript
+    >>> layer = mapscript.fromstring("""LAYER NAME "test" TYPE POINT END""")
+    >>> layer
+    <mapscript.layerObj; proxy of C layerObj instance at ...>
+    >>> layer.name
+    'test'
+    >>> layer.type == mapscript.MS_LAYER_POINT
+    True
+
+Building the Mapscript Module
+-----------------------------
+
+The mapscript module is built as part of the MapServer CMake build process. This is configured using the ``mapserver/mapscript/CMakeLists.txt`` file. 
+
+Before the switch to CMake MapServer mapscript was built using distutils and ``setup.py``. Now the ``setup.py.in`` file is used as a template that
+is filled with the MapServer version number and used to created wheel files for distribution, or install mapscript directly on the build machine.  
+
+The build process works as follows. 
+
++ CMake runs SWIG. This uses the SWIG interface files to create a ``mapscriptPYTHON_wrap.c`` file, 
+  and a ``mapscript.py`` file containing the Python wrapper to the mapscript binary module. 
++ CMake then uses the appropriate compiler on the system to compile the ``mapscriptPYTHON_wrap.c`` file into a Python binary module -
+  ``_mapscript.pyd`` file on Windows, and a ``_mapscript.so`` file on Unix. 
+
+``CMakeLists.txt`` is configured with a ``pythonmapscript-wheel`` target that copies all the required files to the output build folder where they are then packaged
+into a Python wheel. The wheel can be built using the following command:
+
+.. code-block:: bat
+
+    cmake --build . --target pythonmapscript-wheel
+
+The ``pythonmapscript-wheel`` target creates a virtual environment, creates the Python wheel, installs it to the virtual environment and finally runs the test
+suite. This process runs commands similar to the following:
+ 
+.. code-block:: bat
+
+    python -m venv mapscriptvenv
+    python -m pip install --upgrade pip
+    pip install -r requirements-dev.txt
+    python setup.py bdist_wheel
+    pip install --no-index --find-links=dist mapscript
+    python -m pytest --pyargs mapscript.tests
+
+SWIG can also be run manually, without using CMake. This may allow further optimizations and control on the output. 
+
+.. code-block:: bat
+
+    cd C:\Projects\mapserver\build
+    SET PATH=C:\MapServerBuild\swigwin-4.0.1;%PATH%
+    swig -python -shadow -o mapscript_wrap.c ../mapscript.i
+
+SWIG has several command line options to control the output, examples of which are shown below:
+
+.. code-block:: bat
+    
+    swig -python -shadow -modern -templatereduce -fastdispatch -fvirtual -fastproxy 
+    -modernargs -castmode -dirvtable -fastinit -fastquery -noproxydel -nobuildnone 
+    -o mapscript_wrap.c ../mapscript.i
+
+Testing
+-------
+
+The mapscript module includes a test suite and a small sample dataset to check the output and MapServer installation. It is recommended
+`pytest <https://docs.pytest.org/en/latest/>`_ is used to run the tests. This can be installed using:
+
+.. code-block:: bat
+
+    pip install pytest
+
+Make sure the MapServer binaries are on the system path, and that the PROJ_DATA variable has been set as this is required for many of the tests. 
+
+.. code-block:: bat
+
+    SET PATH=C:\release-1930-x64-gdal-3-8-4-mapserver-8-0-1\bin;%PATH%
+    SET PROJ_DATA=C:\release-1930-x64-gdal-3-8-4-mapserver-8-0-1\bin\proj\SHARE
+
+Finally run the command below to run the test suite: 
+
+.. code-block:: bat
+
+    pytest --pyargs mapscript.tests
+
+Credits
+-------
+
++ Steve Lime (developer)
++ Sean Gillies (developer)
++ Frank Warmerdam (developer)
++ Howard Butler (developer)
++ Norman Vine (cygwin and distutils guru)
++ Tim Cera (install)
++ Michael Schultz (documentation)
++ Thomas Bonfort (developer)
++ Even Rouault (developer)
++ Seth Girvin (Python3 migration, documentation and builds)
++ Claude Paroz (Python3 migration)
diff -pruN 8.0.1-5/src/mapscript/python/examples/project_csv.py 8.2.0~beta1-1~exp1/src/mapscript/python/examples/project_csv.py
--- 8.0.1-5/src/mapscript/python/examples/project_csv.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/examples/project_csv.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,76 @@
+#!/usr/bin/env python
+
+"""
+Simple example to read a csv file and reproject point x/y data
+
+Usage:
+
+project_csv.py cities.csv 2 1 EPSG:4326 EPSG:3857
+
+"""
+
+import csv
+import sys
+from io import open
+
+import mapscript
+
+
+def main(input_file, x_field_idx, y_field_idx, input_proj, output_proj):
+
+    # set input and output projections
+    proj_in = mapscript.projectionObj(input_proj)
+    proj_out = mapscript.projectionObj(output_proj)
+
+    # open file
+    with open(input_file, encoding="utf-8") as f:
+        # read csv
+        csv_in = csv.reader(f)
+        headers = next(csv_in)
+
+        # setup output
+        csv_out = csv.writer(sys.stdout)
+        csv_out.writerow(headers)
+
+        for row in csv_in:
+            # set pointObj
+            point = mapscript.pointObj(float(row[x_field_idx]), float(row[y_field_idx]))
+            # project
+            point.project(proj_in, proj_out)
+
+            # update with reprojected coordinates
+            row[x_field_idx] = point.x
+            row[y_field_idx] = point.y
+
+            csv_out.writerow(row)
+
+
+def usage():
+    """
+    Display usage if program is used incorrectly
+    """
+    print(
+        "Syntax: %s <csvfile> <x_col> <y_col> <epsg_code_in> <epsg_code_out>"
+        % sys.argv[0]
+    )
+    sys.exit(2)
+
+
+# check input parameters
+
+if len(sys.argv) != 6:
+    usage()
+
+
+input_file = sys.argv[1]
+
+# set x and y indices
+
+x_field_idx = int(sys.argv[2])
+y_field_idx = int(sys.argv[3])
+
+# get projection codes
+
+input_proj = "init=" + sys.argv[4].lower()
+output_proj = "init=" + sys.argv[5].lower()
+main(input_file, x_field_idx, y_field_idx, input_proj, output_proj)
diff -pruN 8.0.1-5/src/mapscript/python/examples/shpdump.py 8.2.0~beta1-1~exp1/src/mapscript/python/examples/shpdump.py
--- 8.0.1-5/src/mapscript/python/examples/shpdump.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/examples/shpdump.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,105 @@
+#!/usr/bin/env python
+
+"""
+Dump the contents of the passed in Shapefile
+
+Usage:
+
+python shpdump.py polygon.shp
+
+"""
+
+import os
+import sys
+
+import mapscript
+
+
+def plural(x):
+    """
+    Returns an 's' if plural
+
+    Useful in print statements to avoid something like 'point(s)'
+    """
+    if x > 1:
+        return "s"
+    return ""
+
+
+def get_shapefile_object(sf_path):
+
+    # make sure can access .shp file, create shapefileObj
+
+    if os.access(sf_path, os.F_OK):
+        sf_obj = mapscript.shapefileObj(sf_path, -1)
+    else:
+        print("Can't access {}".format(sf_path))
+        sys.exit(2)
+
+    return sf_obj
+
+
+def main(sf_path):
+
+    if not sf_path.lower().endswith(".shp"):
+        sf_path += ".shp"
+
+    sf_obj = get_shapefile_object(sf_path)
+
+    # create an empty Shapefile object
+
+    s_obj = mapscript.shapeObj()
+
+    # loop through each shape in the original Shapefile
+
+    for i in range(sf_obj.numshapes):
+
+        # get the object at index i
+        sf_obj.get(i, s_obj)
+        print("Shape %i has %i part%s" % (i, s_obj.numlines, plural(s_obj.numlines)))
+        print(
+            "Bounds (%f, %f) (%f, %f)"
+            % (
+                s_obj.bounds.minx,
+                s_obj.bounds.miny,
+                s_obj.bounds.maxx,
+                s_obj.bounds.maxy,
+            )
+        )
+
+        # loop through parts of each shape
+
+        for j in range(s_obj.numlines):
+
+            # get the jth part of the ith object
+
+            part = s_obj.get(j)
+            print(
+                "Part %i has %i point%s" % (j, part.numpoints, plural(part.numpoints))
+            )
+
+            # loop through points in each part
+
+            for k in range(part.numpoints):
+
+                # get the kth point of the jth part of the ith shape
+
+                point = part.get(k)
+                print("%i: %f, %f" % (k, point.x, point.y))
+
+
+def usage():
+    """
+    Display usage if program is used incorrectly
+    """
+    print("Syntax: %s <shapefile_path>" % sys.argv[0])
+    sys.exit(2)
+
+
+# make sure passing in filename argument
+if len(sys.argv) != 2:
+    usage()
+
+
+sf_path = sys.argv[1]
+main(sf_path)
diff -pruN 8.0.1-5/src/mapscript/python/examples/shpinfo.py 8.2.0~beta1-1~exp1/src/mapscript/python/examples/shpinfo.py
--- 8.0.1-5/src/mapscript/python/examples/shpinfo.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/examples/shpinfo.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,120 @@
+#!/usr/bin/env python
+
+"""
+Extracts basic descriptive information from a Shapefile
+
+Usage:
+
+python shpinfo.py point.shp
+
+"""
+import os
+import sys
+
+import mapscript
+
+
+def get_shapefile_object(sf_path):
+
+    # make sure can access .shp file, create shapefileObj
+
+    if os.access(sf_path, os.F_OK):
+        sf_obj = mapscript.shapefileObj(sf_path)
+    else:
+        print("Can't access {}".format(sf_path))
+        sys.exit(2)
+
+    return sf_obj
+
+
+def get_shapefile_details(sf_obj):
+
+    # dictionary of shapefile types
+
+    types = {
+        mapscript.MS_SHAPEFILE_POINT: "Point",
+        mapscript.MS_SHAPEFILE_ARC: "Line",
+        mapscript.MS_SHAPEFILE_POLYGON: "Polygon",
+        mapscript.MS_SHAPEFILE_MULTIPOINT: "Multipoint",
+        mapscript.MS_SHP_POINTZ: "PointZ",
+        mapscript.MS_SHP_ARCZ: "LineZ",
+        mapscript.MS_SHP_POLYGONZ: "PolygonZ",
+        mapscript.MS_SHP_MULTIPOINTZ: "MultipointZ",
+        mapscript.MS_SHP_POINTM: "Multipoint",
+        mapscript.MS_SHP_ARCM: "LineM",
+        mapscript.MS_SHP_POLYGONM: "PolygonM",
+        mapscript.MS_SHP_MULTIPOINTM: "MultipointM",
+    }
+
+    # print out basic information that is part of the shapefile object
+
+    print("\tType: %s" % types[sf_obj.type])
+
+    print(
+        "\tBounds: (%f, %f) (%f, %f)"
+        % (
+            sf_obj.bounds.minx,
+            sf_obj.bounds.miny,
+            sf_obj.bounds.maxx,
+            sf_obj.bounds.maxy,
+        )
+    )
+
+    print("\tNumber of features: %i" % sf_obj.numshapes)
+
+
+def get_dbf_details(sf_obj):
+
+    # get DBF object
+
+    dbf_obj = sf_obj.getDBF()
+
+    # print out table characteristics
+
+    print("\tNumber of records in DBF: %i" % dbf_obj.nRecords)
+    print("\tNumber of fields: %i" % dbf_obj.nFields)
+    print("")
+    print("\t%-20s %12s %8s %10s" % ("Name", "Type", "Length", "Decimals"))
+    print("\t-----------------------------------------------------")
+
+    # print out field characteristics
+
+    for idx in range(0, dbf_obj.nFields):
+        print(
+            "\t%-20s %12s %8d %10d"
+            % (
+                dbf_obj.getFieldName(idx),
+                dbf_obj.getFieldType(idx),
+                dbf_obj.getFieldWidth(idx),
+                dbf_obj.getFieldDecimals(idx),
+            )
+        )
+
+
+def main(sf_path):
+
+    if not sf_path.lower().endswith(".shp"):
+        sf_path += ".shp"
+
+    sf_obj = get_shapefile_object(sf_path)
+
+    print("Shapefile %s:" % sf_path)
+    print("")
+
+    get_shapefile_details(sf_obj)
+    get_dbf_details(sf_obj)
+
+
+def usage():
+    """
+    Display usage if program is used incorrectly
+    """
+    print("Syntax: %s <shapefile_path>" % sys.argv[0])
+    sys.exit(2)
+
+
+# make sure a filename argument is provided
+if len(sys.argv) != 2:
+    usage()
+
+main(sys.argv[1])
diff -pruN 8.0.1-5/src/mapscript/python/examples/wxs.py 8.2.0~beta1-1~exp1/src/mapscript/python/examples/wxs.py
--- 8.0.1-5/src/mapscript/python/examples/wxs.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/examples/wxs.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,64 @@
+#!/usr/bin/env python
+
+"""
+Output WMS GetCapabilities response for a Mapfile
+
+Usage:
+
+python wxs.py test.map
+
+"""
+import sys
+import xml.dom.minidom
+
+import mapscript
+
+
+def main(map_file):
+
+    map = mapscript.mapObj(map_file)
+    map.web.metadata.set("ows_onlineresource", "http://dummy.org/")
+    ows_req = mapscript.OWSRequest()
+
+    ows_req.type = mapscript.MS_GET_REQUEST
+
+    ows_req.setParameter("SERVICE", "WMS")
+    ows_req.setParameter("VERSION", "1.1.0")
+    ows_req.setParameter("REQUEST", "GetCapabilities")
+
+    mapscript.msIO_installStdoutToBuffer()
+    dispatch_status = map.OWSDispatch(ows_req)
+
+    if dispatch_status != mapscript.MS_SUCCESS:
+        print("An error occurred")
+
+    content_type = mapscript.msIO_stripStdoutBufferContentType()
+    mapscript.msIO_stripStdoutBufferContentHeaders()
+    result = mapscript.msIO_getStdoutBufferBytes()
+
+    # [('Content-Type', 'application/vnd.ogc.wms_xml; charset=UTF-8'), ('Content-Length', '11385')]
+    response_headers = [
+        ("Content-Type", content_type),
+        ("Content-Length", str(len(result))),
+    ]
+
+    assert int(response_headers[1][1]) > 0
+
+    dom = xml.dom.minidom.parseString(result)
+    print(dom.toprettyxml(indent="", newl=""))
+
+
+def usage():
+    """
+    Display usage if program is used incorrectly
+    """
+    print("Syntax: %s <mapfile_path>" % sys.argv[0])
+    sys.exit(2)
+
+
+# make sure a filename argument is provided
+if len(sys.argv) != 2:
+    usage()
+
+map_file = sys.argv[1]
+main(map_file)
diff -pruN 8.0.1-5/src/mapscript/python/mapscript/__init__.py 8.2.0~beta1-1~exp1/src/mapscript/python/mapscript/__init__.py
--- 8.0.1-5/src/mapscript/python/mapscript/__init__.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/mapscript/__init__.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,42 @@
+import inspect
+import os
+import platform
+import sys
+
+# As of Python 3.8 PATH can no longer be used to resolve the MapServer
+# DLLs on Windows. Instead users will be required to set a new MAPSERVER_DLL_PATH
+# environment variable.
+# See https://docs.python.org/3/whatsnew/3.8.html#changes-in-the-python-api
+
+
+def add_dll_path(pth):
+    """
+    Allow Python to access the directory containing the MapServer DLL (for Python on Windows only)
+    """
+    if (3, 8) <= sys.version_info:
+        os.add_dll_directory(pth)
+    else:
+        # add the directory to the Windows path for earlier Python version
+        os.environ["PATH"] = pth + ";" + os.environ["PATH"]
+
+
+if platform.system() == "Windows":
+    mapserver_dll_path = os.getenv("MAPSERVER_DLL_PATH", "")
+    dll_paths = list(filter(os.path.exists, mapserver_dll_path.split(";")))
+    # add paths in the order listed in the string
+    dll_paths.reverse()
+    for pth in dll_paths:
+        add_dll_path(pth)
+
+
+from .mapscript import *  # NOQA
+
+# change all the class module names from mapscript.mapscript to mapscript
+
+for key, value in globals().copy().items():
+    if inspect.isclass(value) and value.__module__.startswith("mapscript."):
+        value.__module__ = "mapscript"
+
+# remove the submodule name
+
+del mapscript  # NOQA
diff -pruN 8.0.1-5/src/mapscript/python/pyextend.i 8.2.0~beta1-1~exp1/src/mapscript/python/pyextend.i
--- 8.0.1-5/src/mapscript/python/pyextend.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/pyextend.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,490 @@
+/******************************************************************************
+ * Project:  MapServer
+ * Purpose:  Python-specific extensions to MapScript objects
+ * Author:   Sean Gillies, sgillies@frii.com
+ * Author:   Seth Girvin, sethg@geographika.co.uk
+ *
+ ******************************************************************************
+ *
+ * Python-specific mapscript code has been moved into this 
+ * SWIG interface file to improve the readability of the main
+ * interface file.  The main mapscript.i file includes this
+ * file when SWIGPYTHON is defined (via 'swig -python ...').
+ *
+ *****************************************************************************/
+
+// required for Python 3.10+ - see https://bugs.python.org/issue40943
+%begin %{
+#define PY_SSIZE_T_CLEAN
+%}
+
+/* fromstring: Factory for mapfile objects */
+
+%pythoncode %{
+def fromstring(data, mappath=None, configpath=None):
+    """Creates map objects from mapfile strings.
+
+    Parameters
+    ==========
+    data : string
+        Mapfile in a string.
+    mappath : string
+        Optional root map path, enabling relative paths in mapfile.
+
+    Example
+    =======
+    >>> mo = fromstring("MAP\nNAME 'test'\nEND")
+    >>> mo.name
+    'test'
+    """
+    import re
+    if re.search(r"^\s*MAP", data, re.I):
+        # create a config object if a path is supplied
+        if configpath:
+             config = configObj(configpath)
+        else:
+             config = None
+        return msLoadMapFromString(data, mappath, config)
+    elif re.search(r"^\s*LAYER", data, re.I):
+        ob = layerObj()
+        ob.updateFromString(data)
+        return ob
+    elif re.search(r"^\s*CLASS", data, re.I):
+        ob = classObj()
+        ob.updateFromString(data)
+        return ob
+    elif re.search(r"^\s*STYLE", data, re.I):
+        ob = styleObj()
+        ob.updateFromString(data)
+        return ob
+    else:
+        raise ValueError("No map, layer, class, or style found. Can not load from provided string")
+%}
+
+
+/* ===========================================================================
+   Python rectObj extensions
+   ======================================================================== */
+   
+%extend rectObj {
+
+%pythoncode %{
+
+    def __str__(self):
+        return self.toString()
+
+    def __contains__(self, item):
+        item_type = item.__class__.__name__
+        if item_type == "pointObj":
+            if item.x >= self.minx and item.x <= self.maxx \
+            and item.y >= self.miny and item.y <= self.maxy:
+                return True
+            else:
+                return False
+        else:
+            raise TypeError('__contains__ does not yet handle %s' % (item_type))
+
+%}
+}
+
+/* ===========================================================================
+   Python pointObj extensions
+   ======================================================================== */
+
+%extend pointObj {
+
+%pythoncode %{
+
+    def __str__(self):
+        return self.toString()
+
+    @property
+    def __geo_interface__(self):
+
+        if hasattr(self, "z"):
+            coords = (self.x, self.y, self.z)
+        else:
+            coords = (self.x, self.y)
+
+        return {"type": "Point", "coordinates": coords}
+
+%}
+}
+
+
+/* ===========================================================================
+   Python lineObj extensions
+   ======================================================================== */
+   
+%extend lineObj {
+
+%pythoncode %{
+
+    @property
+    def __geo_interface__(self):
+
+        coords = []
+
+        for idx in range(0, self.numpoints):
+            pt = self.get(idx)
+            geom = pt.__geo_interface__
+            coords.append(geom["coordinates"])
+
+        return {"type": "LineString", "coordinates": coords}
+
+%}
+}
+
+
+/* ===========================================================================
+   Python shapeObj extensions
+   ======================================================================== */
+
+%extend shapeObj {
+
+%pythoncode %{
+
+        def _convert_item_values(self, property_values, property_types):
+            """
+            **Python MapScript only**
+
+            Convert an item value, which is always stored as a string, into a
+            Python type, based on an attributes GML metadata type. These can be one
+            of the following:
+
+            ``Integer|Long|Real|Character|Date|Boolean``
+            """
+
+            typed_values = []
+
+            for value, type_ in zip(property_values, property_types):
+                try:
+                    if type_.lower() == "integer":
+                        value = int(value)
+                    elif type_.lower() == "long":
+                        value = long(value)
+                    elif type_.lower() == "real":
+                        value = float(value)
+                    else:
+                        pass
+                except ValueError:
+                    pass
+
+                typed_values.append(value)
+
+            return typed_values
+
+        @property
+        def __geo_interface__(self):
+
+            bounds = self.bounds
+            ms_geom_type = self.type
+
+            # see https://tools.ietf.org/html/rfc7946 for GeoJSON types
+
+            if ms_geom_type == MS_SHAPE_POINT or ms_geom_type == MS_SHP_POINTZ or ms_geom_type == MS_SHP_POINTM:
+                geom_type = "Point"
+            elif ms_geom_type == MS_SHP_MULTIPOINTZ or ms_geom_type == MS_SHP_MULTIPOINTM:
+                geom_type = "MultiPoint"
+            elif ms_geom_type == MS_SHAPE_LINE or ms_geom_type == MS_SHP_ARCZ or ms_geom_type == MS_SHP_ARCM:
+                if self.numlines == 1:
+                    geom_type = "LineString"
+                else:
+                    geom_type = "MultiLineString"
+            elif ms_geom_type == MS_SHAPE_POLYGON or ms_geom_type == MS_SHP_POLYGONZ or ms_geom_type == MS_SHP_POLYGONM:
+                if self.numlines == 1:
+                    geom_type = "Polygon"
+                else:
+                    geom_type = "MultiPolygon"
+            elif ms_geom_type == MS_SHAPE_NULL:
+                return None
+            else:
+                raise TypeError("Shape type {} not supported".format(geom_type))
+
+            properties = {}
+            coords = []
+
+            # property names are stored at the layer level
+            # https://github.com/mapserver/mapserver/issues/130
+
+            property_values = [self.getValue(idx) for idx in range(0, self.numvalues)]
+
+            if hasattr(self, "_item_definitions"):
+                property_names, property_types = zip(*self._item_definitions)
+                property_values = self._convert_item_values(property_values, property_types)
+            else:
+                property_names = [str(idx) for idx in range(0, self.numvalues)]
+
+            properties = dict(zip(property_names, property_values))
+
+            for idx in range(0, self.numlines):
+                line = self.get(idx)
+                geom = line.__geo_interface__
+                coords.append(geom["coordinates"])
+
+            return {
+                    "type": "Feature",
+                    "bbox": (bounds.minx, bounds.miny, bounds.maxx, bounds.maxy),
+                    "properties": properties,
+                    "geometry": {
+                        "type": geom_type,
+                        "coordinates": coords
+                        }
+                    }
+
+        @property
+        def itemdefinitions(self):
+            return self._item_definitions
+
+        @itemdefinitions.setter
+        def itemdefinitions(self, item_definitions):
+            self._item_definitions = item_definitions
+
+%}
+}
+
+/******************************************************************************
+ * Extensions to mapObj
+ *****************************************************************************/
+
+%extend mapObj {
+  
+    /**
+    \**Python MapScript only**  - returns the map layer order as a native sequence
+    */
+    PyObject *getLayerOrder() {
+        int i;
+        PyObject *order;
+        order = PyTuple_New(self->numlayers);
+        for (i = 0; i < self->numlayers; i++) {
+            PyTuple_SetItem(order,i,PyInt_FromLong((long)self->layerorder[i]));
+        }
+        return order;
+    } 
+
+    /**
+    \**Python MapScript only** - sets the map layer order using a native sequence
+    */
+    int setLayerOrder(PyObject *order) {
+        int i;
+        Py_ssize_t size = PyTuple_Size(order);
+        for (i = 0; i < size; i++) {
+            self->layerorder[i] = (int)PyInt_AsLong(PyTuple_GetItem(order, i));
+        }
+        return MS_SUCCESS;
+    }
+    
+    /**
+    \**Python MapScript only** - gets the map size as a tuple
+    */
+    PyObject* getSize()
+    {
+        PyObject* output ;
+        output = PyTuple_New(2);
+        PyTuple_SetItem(output,0,PyInt_FromLong((long)self->width));
+        PyTuple_SetItem(output,1,PyInt_FromLong((long)self->height));
+        return output;
+    }
+
+%pythoncode %{
+
+    def get_height(self):
+        """
+        **Python MapScript only**
+        Return the map height from the map size
+        """
+        return self.getSize()[1] # <-- second member is the height
+
+    def get_width(self):
+        """
+        **Python MapScript only**
+        Return the map width from the map size
+        """
+        return self.getSize()[0] # <-- first member is the width
+
+    def set_height(self, value):
+        """
+        **Python MapScript only**
+        Set the map height value of the map size
+        """
+        return self.setSize(self.getSize()[0], value)
+
+    def set_width(self, value):
+        """
+        **Python MapScript only**
+        Set the map width value of the map size
+        """
+        return self.setSize(value, self.getSize()[1])
+
+    width = property(get_width, set_width, doc="See :ref:`SIZE <mapfile-map-size>`")
+    height = property(get_height, set_height, doc = "See :ref:`SIZE <mapfile-map-size>`")
+
+%}
+}
+
+/******************************************************************************
+ * Extensions to layerObj
+ *****************************************************************************/
+
+%extend layerObj {
+  
+%pythoncode %{
+
+    def getItemDefinitions(self):
+        """
+        **Python MapScript only**
+        
+        Return item (field) names and their types if available.
+        Field types are specified using GML metadata and can be one of the following:
+
+        ``Integer|Long|Real|Character|Date|Boolean``
+
+        """
+        item_names = [self.getItem(idx) for idx in range(0, self.numitems)]
+        item_types = [self.getItemType(idx) for idx in range(0, self.numitems)]
+        return zip(item_names, item_types)
+
+%}
+}
+
+/******************************************************************************
+ * Extensions to imageObj
+ *****************************************************************************/
+    
+%extend imageObj {
+
+    /**
+    Write image data to an open file handle. Replaces
+    the removed saveToString function.  See ``python/pyextend.i`` for the Python specific
+    version of this method.
+    */
+    int write( PyObject *file=Py_None )
+    {
+        unsigned char *imgbuffer=NULL;
+        int imgsize;
+        PyObject *noerr;
+        int retval=MS_FAILURE;
+
+        /* Return immediately if image driver is not GD */
+        if ( !MS_RENDERER_PLUGIN(self->format) )
+        {
+            msSetError(MS_IMGERR, "Writing of %s format not implemented",
+                       "imageObj::write", self->format->driver);
+            return MS_FAILURE;
+        }
+
+        if (file == Py_None) /* write to stdout */
+            retval = msSaveImage(NULL, self, NULL);
+        else /* presume a Python file-like object */
+        {
+            imgbuffer = msSaveImageBuffer(self, &imgsize,
+                                          self->format);
+            if (imgsize == 0)
+            {
+                msSetError(MS_IMGERR, "failed to get image buffer", "write()");
+                return MS_FAILURE;
+            }
+
+%#if PY_MAJOR_VERSION >= 3
+            // https://docs.python.org/3/c-api/arg.html
+            noerr = PyObject_CallMethod(file, "write", "y#", imgbuffer, (Py_ssize_t)imgsize);
+%#else
+            // https://docs.python.org/2/c-api/arg.html
+            noerr = PyObject_CallMethod(file, "write", "s#", imgbuffer, imgsize);
+%#endif
+
+            free(imgbuffer);
+            if (noerr == NULL)
+                return MS_FAILURE;
+            else
+                Py_DECREF(noerr);
+            retval = MS_SUCCESS;
+        }
+
+        return retval;
+    }
+}
+
+
+/******************************************************************************
+ * Extensions to styleObj
+ *****************************************************************************/
+
+%extend styleObj {
+
+    /// **Python Only** Set the pattern for the style.
+    void pattern_set(int nListSize, double* pListValues)
+    {
+        if( nListSize < 2 )
+        {
+            msSetError(MS_SYMERR, "Not enough pattern elements. A minimum of 2 are required", "pattern_set()");
+            return;
+        }
+        if( nListSize > MS_MAXPATTERNLENGTH )
+        {
+            msSetError(MS_MISCERR, "Too many elements", "pattern_set()");
+            return;
+        }
+        memcpy( self->pattern, pListValues, sizeof(double) * nListSize);
+        self->patternlength = nListSize;
+    }
+
+    /// **Python Only** Get the pattern for the style.
+    void pattern_get(double** argout, int* pnListSize)
+    {
+        *pnListSize = self->patternlength;
+        *argout = (double*) malloc(sizeof(double) * *pnListSize);
+        memcpy( *argout, self->pattern, sizeof(double) * *pnListSize);
+    }
+
+
+%pythoncode %{
+
+pattern = property(pattern_get, pattern_set, doc=r"""pattern : list **Python Only**""")
+
+%}
+}
+
+/******************************************************************************
+ * Extensions to hashTableObj - add dict methods
+ *****************************************************************************/
+
+%extend hashTableObj{
+
+    %pythoncode %{
+
+    def __getitem__(self, key):
+        return self.get(key)
+
+    def __setitem__(self, key, value):
+        return self.set(key, value)
+
+    def __delitem__(self, key) :
+        return self.remove(key)
+
+    def __contains__(self, key):
+        return key.lower() in [k.lower() for k in self.keys()]
+
+    def __len__(self):
+        return self.numitems
+
+    def keys(self):
+        """
+        **Python-only**. In Python MapScript the ``hashTableObj`` can be used and accessed
+        as a dictionary. The ``keys`` method returns a view of all the keys in the ``hashTableObj``.
+        """
+
+        keys = []
+        k = None
+
+        while True :
+            k = self.nextKey(k)
+            if k :
+                keys.append(k)
+            else :
+                break
+
+        return keys
+            
+%}
+}
diff -pruN 8.0.1-5/src/mapscript/python/pymodule.i 8.2.0~beta1-1~exp1/src/mapscript/python/pymodule.i
--- 8.0.1-5/src/mapscript/python/pymodule.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/pymodule.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,332 @@
+/******************************************************************************
+ * Project:  MapServer
+ * Purpose:  Python-specific enhancements to MapScript
+ * Author:   Sean Gillies, sgillies@frii.com
+ *
+ ******************************************************************************
+ *
+ * Python-specific mapscript code has been moved into this 
+ * SWIG interface file to improve the readability of the main
+ * interface file.  The main mapscript.i file includes this
+ * file when SWIGPYTHON is defined (via 'swig -python ...').
+ *
+ *****************************************************************************/
+
+/******************************************************************************
+ * Simple Typemaps
+ *****************************************************************************/
+
+/* Translates Python None to C NULL for strings */
+//%typemap(in,parse="z") char * "";
+
+/* To support imageObj::getBytes */
+%typemap(out) gdBuffer {
+    $result = PyBytes_FromStringAndSize((const char*)$1.data, $1.size);
+    if( $1.owns_data )
+       msFree($1.data);
+}
+
+
+/*
+ *  Typemap for counted arrays of doubles <- PySequence
+ */
+%typemap(in,numinputs=1) (int nListSize, double* pListValues)
+{
+  int i;
+  /* %typemap(in,numinputs=1) (int nListSize, double* pListValues)*/
+  /* check if is List */
+  if ( !PySequence_Check($input) ) {
+    PyErr_SetString(PyExc_TypeError, "not a sequence");
+    SWIG_fail;
+  }
+  $1 = (int) PySequence_Size($input);
+  $2 = (double*) malloc($1*sizeof(double));
+  for( i = 0; i<$1; i++ ) {
+    PyObject *o = PySequence_GetItem($input,i);
+    if ( !PyArg_Parse(o,"d",&$2[i]) ) {
+      PyErr_SetString(PyExc_TypeError, "not a number");
+      Py_DECREF(o);
+      SWIG_fail;
+    }
+    Py_DECREF(o);
+  }
+}
+
+
+%fragment("CreateTupleFromDoubleArray","header") %{
+static PyObject *
+CreateTupleFromDoubleArray( double *first, unsigned int size ) {
+  unsigned int i;
+  PyObject *out = PyTuple_New( size );
+  for( i=0; i<size; i++ ) {
+    PyObject *val = PyFloat_FromDouble( *first );
+    ++first;
+    PyTuple_SetItem( out, i, val );
+  }
+  return out;
+}
+%}
+
+%typemap(freearg) (int nListSize, double* pListValues)
+{
+  /* %typemap(freearg) (int nListSize, double* pListValues) */
+  if ($2) {
+    free((void*) $2);
+  }
+}
+
+
+%typemap(in,numinputs=0) (double** argout, int* pnListSize) ( double* argout, int nListSize ) {
+  /* %typemap(python,in,numinputs=0) (double *val, int*hasval) */
+  $1 = &argout;
+  $2 = &nListSize;
+}
+
+%typemap(argout,fragment="t_output_helper,CreateTupleFromDoubleArray") (double** argout, int* pnListSize) 
+{
+   /* %typemap(argout) (double* argout, int* pnListSize)  */
+  PyObject *r;
+  r = CreateTupleFromDoubleArray(*$1, *$2);
+  free(*$1);
+  $result = t_output_helper($result,r);
+}
+
+/*
+ *  Typemap to turn a Python dict into two sequences and
+ *  an item count. Used for msApplySubstitutions
+ */
+%typemap(in) (char **names, char **values, int npairs) {
+  /* Check if is a dict */
+  if (PyDict_Check($input)) {
+
+    int i = 0;
+    int size = (int) PyDict_Size($input);
+
+    PyObject* keys = PyDict_Keys($input);
+    PyObject* values = PyDict_Values($input);
+
+    $3 = size;
+    $1 = (char **) malloc((size+1)*sizeof(char *));
+    $2 = (char **) malloc((size+1)*sizeof(char *));
+
+    for (i = 0; i < size; i++) {
+        PyObject* key = PyList_GetItem(keys, i);
+        PyObject* val = PyList_GetItem(values, i);
+
+        %#if PY_MAJOR_VERSION >= 3
+            // Changed in version 3.7: The return type is now const char * rather than char *
+            // avoid warning C4090: '=': different 'const' qualifiers
+            $1[i] = (char *)PyUnicode_AsUTF8(key);
+            $2[i] = (char *)PyUnicode_AsUTF8(val);
+        %#else
+            $1[i] = PyString_AsString(key);
+            $2[i] = PyString_AsString(val);
+        %#endif
+    }
+
+    $1[i] = 0;
+    $2[i] = 0;
+
+  } else {
+    PyErr_SetString(PyExc_TypeError, "Input not a dictionary");
+    SWIG_fail;
+  }
+}
+
+%typemap(freearg) (char **names, char **values, int npairs) {
+  free((char *) $1);
+  free((char *) $2);
+}
+
+/**************************************************************************
+ * MapServer Errors and Python Exceptions
+ **************************************************************************
+ *
+ * Translation of errors reported via the ms_error structure into
+ * Python exceptions. Original code by Chris Chamberlin <cdc@aracnet.com>
+ * has been updated by Sean Gillies <sgillies@frii.com> to use 
+ * PyErr_SetString, %exception and $action for SWIG 1.3, do the most
+ * obvious mapping of MapServer errors to Python exceptions and map all 
+ * others to a new 'MapServerError' exception which can be caught like this:
+ * 
+ *   from mapscript import *
+ *   empty_map = mapObj('')
+ *   try:
+ *       img = empty_map.draw()
+ *   except MapServerError, msg:
+ *       print "Caught MapServerError:", msg
+ *
+ *************************************************************************/
+
+%{
+PyObject *MSExc_MapServerError;
+PyObject *MSExc_MapServerChildError;
+%}
+
+/* Module initialization: call msSetup() and register msCleanup() */
+%init %{
+
+/* See bug 1203 for discussion of race condition with GD font cache */
+    if (msSetup() != MS_SUCCESS)
+    {
+        msSetError(MS_MISCERR, "Failed to set up threads and font cache",
+                   "msSetup()");
+    }
+
+    Py_AtExit(msCleanup);
+
+/* Define Generic MapServer error */
+MSExc_MapServerError=PyErr_NewException("_mapscript.MapServerError",NULL,NULL);
+if (MSExc_MapServerError != NULL)
+    PyDict_SetItemString(d, "MapServerError", MSExc_MapServerError);
+
+/* Define MapServer MS_CHILD error */
+MSExc_MapServerChildError = PyErr_NewException("_mapscript.MapServerChildError", NULL, NULL);
+if (MSExc_MapServerChildError != NULL)
+    PyDict_SetItemString(d, "MapServerChildError", MSExc_MapServerChildError);
+
+%}
+
+%{
+
+static void _raise_ms_exception( void );
+
+static void _raise_ms_exception() {
+    int errcode;
+    errorObj *ms_error;
+    char *errmsg;
+    ms_error = msGetErrorObj();
+    errcode = ms_error->code;
+    errmsg = msGetErrorString("\n");
+    
+    switch (errcode) {
+        case MS_IOERR:
+            PyErr_SetString(PyExc_IOError, errmsg);
+            break;
+        case MS_MEMERR:
+            PyErr_SetString(PyExc_MemoryError, errmsg);
+            break;
+        case MS_TYPEERR:
+            PyErr_SetString(PyExc_TypeError, errmsg);
+            break;
+        case MS_EOFERR:
+            PyErr_SetString(PyExc_EOFError, errmsg);
+            break;
+        case MS_CHILDERR:
+            PyErr_SetString(MSExc_MapServerChildError, errmsg);
+            break;
+        default:
+            PyErr_SetString(MSExc_MapServerError, errmsg);
+            break;
+    }
+
+    free(errmsg);
+}
+  
+%}
+
+%exception {
+    $action {
+        errorObj *ms_error = msGetErrorObj();
+       
+        switch(ms_error->code) {
+            case MS_NOERR:
+                break;
+            case MS_NOTFOUND:
+                msResetErrorList();
+                break;
+            case -1:
+                break;
+            case MS_IOERR:
+                /*
+                if (strcmp(ms_error->routine, "msSearchDiskTree()") != 0) {
+                    _raise_ms_exception();
+                    msResetErrorList();
+                    return NULL;
+                }
+                */
+            default:
+                _raise_ms_exception();
+                msResetErrorList();
+                return NULL;
+        }
+                
+    }
+}
+         
+%pythoncode %{
+MapServerError = _mapscript.MapServerError
+MapServerChildError = _mapscript.MapServerChildError
+%}
+
+%feature("pythonappend") layerObj %{
+    self.p_map = None
+    if map: 
+        self.p_map = map%}
+
+%feature("pythonappend") classObj %{
+    self.p_layer = None
+    if layer: 
+        self.p_layer = layer%}
+
+%feature("shadow") insertClass %{
+    def insertClass(*args):
+        """
+        Insert a **copy** of the class into the layer at the requested *index*. 
+        Default index of -1 means insertion at the end of the array of classes. Returns the index at which the class was inserted.
+        """
+        actualIndex=$action(*args)
+        args[1].p_layer=args[0]
+        return actualIndex%}
+
+
+%feature("shadow") getClass %{
+    def getClass(*args):
+        """
+        Fetch the requested class object at *i*. Returns NULL if the class index is out of the legal range. 
+        The numclasses field contains the number of classes available, and the first class is index 0.
+        """
+        clazz = $action(*args)
+        if clazz:
+            if args and len(args)!=0:
+                clazz.p_layer=args[0]
+            else:
+                clazz.p_layer=None
+        return clazz%}
+
+%feature("shadow") insertLayer %{
+    def insertLayer(*args):
+        """
+        Insert a copy of *layer* into the map at *index*.
+        The default value of *index* is -1, which means the last possible index. 
+        Returns the index of the new layer, or -1 in the case of a failure.
+        """
+        actualIndex=$action(*args)
+        args[1].p_map=args[0]
+        return actualIndex%}
+
+%feature("shadow") getLayer %{
+    def getLayer(*args):
+        """
+        Returns a reference to the layer at index *i*.
+        """
+        layer = $action(*args)
+        if layer:
+            if args and len(args)!=0:
+                layer.p_map=args[0]
+            else:
+                layer.p_map=None
+        return layer%}
+
+%feature("shadow") getLayerByName %{
+    def getLayerByName(*args):
+        """
+        Returns a reference to the named layer.
+        """
+        layer = $action(*args)
+        if layer:
+            if args and len(args)!=0:
+                layer.p_map=args[0]
+            else:
+                layer.p_map=None
+        return layer%}
diff -pruN 8.0.1-5/src/mapscript/python/requirements-dev.txt 8.2.0~beta1-1~exp1/src/mapscript/python/requirements-dev.txt
--- 8.0.1-5/src/mapscript/python/requirements-dev.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/requirements-dev.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5 @@
+pytest
+pillow
+wheel>=0.38.0
+setuptools>=45.0.0
+build[virtualenv]
\ No newline at end of file
diff -pruN 8.0.1-5/src/mapscript/python/setup.py.in 8.2.0~beta1-1~exp1/src/mapscript/python/setup.py.in
--- 8.0.1-5/src/mapscript/python/setup.py.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/setup.py.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,47 @@
+from io import open
+from setuptools import setup, find_packages, Distribution
+
+
+class BinaryDistribution(Distribution):
+    """
+    Distribution which always forces a binary package with platform name
+    See http://lucumr.pocoo.org/2014/1/27/python-on-wheels/
+    and https://stackoverflow.com/questions/24071491/how-can-i-make-a-python-wheel-from-an-existing-native-library
+    """
+    def has_ext_modules(foo):
+        return True
+    def is_pure(self):
+        return False
+
+
+def readme():
+    with open('README.rst', "r", encoding="utf-8") as f:
+        return f.read()
+
+setup(
+    name="mapscript",
+    description = "MapServer Python MapScript bindings",
+    long_description=readme(),
+    classifiers = [
+        'Development Status :: 4 - Beta',
+        'Intended Audience :: Developers',
+        'Intended Audience :: Science/Research',
+        'License :: OSI Approved :: MIT License',
+        'Operating System :: OS Independent',
+        'Programming Language :: Python :: 3',
+        'Programming Language :: C',
+        'Programming Language :: C++',
+        'Topic :: Scientific/Engineering :: GIS',
+        'Topic :: Scientific/Engineering :: Information Analysis',
+    ],
+    author = "Steve Lime",
+    license = "MIT",
+    url="http://www.mapserver.org",
+    version="@MapServer_VERSION_MAJOR@.@MapServer_VERSION_MINOR@.@MapServer_VERSION_REVISION@",
+    packages=find_packages(),
+    package_data={
+        # list the files to include starting with the most deeply nested folder or they are overwritten
+        'mapscript': ['tests/data/vera/*.*', 'tests/data/*.*', '$<TARGET_FILE_NAME:@SWIG_MODULE_pythonmapscript_REAL_NAME@>']
+        },
+    distclass=BinaryDistribution
+)
\ No newline at end of file
diff -pruN 8.0.1-5/src/mapscript/python/tests/TESTING.txt 8.2.0~beta1-1~exp1/src/mapscript/python/tests/TESTING.txt
--- 8.0.1-5/src/mapscript/python/tests/TESTING.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/TESTING.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,34 @@
+.. $Id$
+
+Python MapScript Unit Tests
+========================================
+
+Authors: Sean Gillies, sgillies@frii.com
+         Howard Butler, hobu@iastate.edu
+
+
+Running the tests
+-----------------
+
+To run all of the tests, change directory to cases and execute
+::
+
+    $ cd cases
+    $ python runalltests.py -v
+    
+This runs all tests found in every TestCase derived class defined in any
+module named "cases/*test.py".  The tests cannot be run properly from
+another path.  The unit test script will insert the local build directory
+produced by Python distutils into the head of the Python PATH.  This allows
+us to run the unit tests before installing the mapscript module.  The unit
+tests use a map config file, symbolset file, fontset file, and data located
+in the 'tests' directory of the mapserver distribution.
+
+If you encounter any errors, please create a new issue in the MapServer
+bug tracker
+
+    http://mapserver.gis.umn.edu/bugs/enter_bug.cgi
+
+under the SWIG-MapScript component.  Copy the relevant error messages
+and we'll get to the bug ASAP.  Thanks!
+
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/class_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/class_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/class_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/class_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,144 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of classObj
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapTestCase
+
+
+class ClassObjTestCase(unittest.TestCase):
+    def testConstructorNoArg(self):
+        c = mapscript.classObj()
+        assert c.thisown == 1
+        assert c.layer is None
+        assert c.numstyles == 0
+
+    def testConstructorWithArg(self):
+        lyr = mapscript.layerObj()
+        lyr.name = "foo"
+        c = mapscript.classObj(lyr)
+        assert c.thisown == 1
+        assert c.layer.name == lyr.name
+        assert c.numstyles == 0
+
+    def testGetSetAttributes(self):
+        c = mapscript.classObj()
+
+        val = "/tmp/legend.png"
+        c.keyimage = val
+        assert c.keyimage == val
+
+        c.debug = mapscript.MS_TRUE
+        assert c.debug == mapscript.MS_TRUE
+
+        val = "Group1"
+        c.group = val
+        assert c.group == val
+
+        val = 10000
+        c.maxscaledenom = val
+        assert c.maxscaledenom == val
+
+        val = 3
+        c.minfeaturesize = val
+        assert c.minfeaturesize == val
+
+        val = 1000
+        c.minscaledenom = val
+        assert c.minscaledenom == val
+
+        val = "Class1"
+        c.name = val
+        assert c.name == val
+
+        c.status = mapscript.MS_OFF
+        assert c.status == mapscript.MS_OFF
+
+        val = "template.html"
+        c.template = val
+        assert c.template == val
+
+        val = "Title1"
+        c.title = val
+        assert c.title == val
+
+
+class ClassCloningTestCase(unittest.TestCase):
+    def testCloneClass(self):
+        """check attributes of a cloned class"""
+        c = mapscript.classObj()
+        c.minscaledenom = 5.0
+        clone = c.clone()
+        assert clone.thisown == 1
+        assert clone.minscaledenom == 5.0
+
+
+class ClassIconTestCase(MapTestCase):
+
+    """testing for bug 1250"""
+
+    def testAlphaTransparentPixmap(self):
+        lo = self.map.getLayerByName("INLINE-PIXMAP-RGBA")
+        co = lo.getClass(0)
+        self.map.selectOutputFormat("PNG")
+        im = co.createLegendIcon(self.map, lo, 48, 48)
+        im.save("testAlphaTransparentPixmapIcon.png")
+
+    def testAlphaTransparentPixmapPNG24(self):
+        lo = self.map.getLayerByName("INLINE-PIXMAP-RGBA")
+        co = lo.getClass(0)
+        self.map.selectOutputFormat("PNG24")
+        im = co.createLegendIcon(self.map, lo, 48, 48)
+        im.save("testAlphaTransparentPixmapIcon24.png")
+
+    def testAlphaTransparentPixmapJPG(self):
+        lo = self.map.getLayerByName("INLINE-PIXMAP-RGBA")
+        co = lo.getClass(0)
+        self.map.selectOutputFormat("JPEG")
+        im = co.createLegendIcon(self.map, lo, 48, 48)
+        im.save("testAlphaTransparentPixmapIcon.jpg")
+
+    def testIndexedTransparentPixmap(self):
+        lo = self.map.getLayerByName("INLINE-PIXMAP-PCT")
+        lo.type = mapscript.MS_LAYER_POINT
+        co = lo.getClass(0)
+        self.map.selectOutputFormat("PNG")
+        im = co.createLegendIcon(self.map, lo, 32, 32)
+        im.save("testIndexedTransparentPixmapIcon.png")
+
+    def testIndexedTransparentPixmapJPG(self):
+        lo = self.map.getLayerByName("INLINE-PIXMAP-PCT")
+        lo.type = mapscript.MS_LAYER_POINT
+        co = lo.getClass(0)
+        self.map.selectOutputFormat("JPEG")
+        im = co.createLegendIcon(self.map, lo, 32, 32)
+        im.save("testIndexedTransparentPixmapIcon.jpg")
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/clone_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/clone_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/clone_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/clone_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,98 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of map cloning
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import TESTMAPFILE
+
+
+class MapCloneTestCase(unittest.TestCase):
+    """Base class for testing with a map fixture"""
+
+    def setUp(self):
+        self.mapobj_orig = mapscript.mapObj(TESTMAPFILE)
+        self.mapobj_clone = self.mapobj_orig.clone()
+
+    def tearDown(self):
+        self.mapobj_orig = None
+        self.mapobj_clone = None
+
+
+class MapCloningTestCase(MapCloneTestCase):
+    def testClonedName(self):
+        """MapCloningTestCase.testClonedName: the name of a cloned map equals the original"""
+        assert self.mapobj_clone.name == self.mapobj_orig.name
+
+    def testClonedLayers(self):
+        """MapCloningTestCase.testClonedLayers: the layers of a cloned map equal the original"""
+        assert self.mapobj_clone.numlayers == self.mapobj_orig.numlayers
+        assert self.mapobj_clone.getLayer(0).data == self.mapobj_orig.getLayer(0).data
+
+    def testSetFontSet(self):
+        """MapCloningTestCase.testSetFontSet: the number of fonts in a cloned map equal original"""
+        assert self.mapobj_clone.fontset.numfonts == 2
+
+    def testSetSymbolSet(self):
+        """MapCloningTestCase.testSetSymbolSet: the number of symbols in a cloned map equal original"""
+        num = self.mapobj_clone.symbolset.numsymbols
+        assert num == 5, num
+
+    def testDrawClone(self):
+        """drawing a cloned map works properly"""
+        msimg = self.mapobj_clone.draw()
+        assert msimg.thisown == 1
+        filename = "testClone.png"
+        fh = open(filename, "wb")
+        msimg.write(fh)
+        fh.close()
+
+    def testDrawCloneJPEG(self):
+        """drawing a cloned map works properly"""
+        self.mapobj_clone.selectOutputFormat("JPEG")
+        self.mapobj_clone.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
+        msimg = self.mapobj_clone.draw()
+        assert msimg.thisown == 1
+        filename = "testClone.jpg"
+        fh = open(filename, "wb")
+        msimg.write(fh)
+        fh.close()
+
+    def testDrawClonePNG24(self):
+        """drawing a cloned map works properly"""
+        self.mapobj_clone.selectOutputFormat("PNG24")
+        self.mapobj_clone.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
+        msimg = self.mapobj_clone.draw()
+        assert msimg.thisown == 1
+        filename = "testClonePNG24.png"
+        fh = open(filename, "wb")
+        msimg.write(fh)
+        fh.close()
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/cluster_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/cluster_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/cluster_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/cluster_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,60 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of clusterObj
+# Author:   Seth Girvin
+#
+# ===========================================================================
+# Copyright (c) 2019, Seth Girvin
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+
+class ClusterObjTestCase(unittest.TestCase):
+    def testClusterObjUpdateFromString(self):
+        """a cluster can be updated from a string"""
+        c = mapscript.clusterObj()
+        c.updateFromString("CLUSTER \n MAXDISTANCE 5 \n REGION \n 'rectangle' END")
+
+        assert c.maxdistance == 5
+        assert c.region == "rectangle"
+
+        s = c.convertToString()
+        assert s == 'CLUSTER\n  MAXDISTANCE 5\n  REGION "rectangle"\nEND # CLUSTER\n'
+
+    def testClusterObjGetSetFilter(self):
+        """a cluster filter can be set and read"""
+        c = mapscript.clusterObj()
+        filter = "[attr1] > 5"
+        c.setFilter(filter)
+        assert '"{}"'.format(filter) == c.getFilterString()
+
+    def testClusterObjGetSetGroup(self):
+        """a cluster filter can be set and read"""
+        c = mapscript.clusterObj()
+        exp = "100"  # TODO not sure what would be a relevant expression here
+        c.setGroup(exp)
+        assert '"{}"'.format(exp) == c.getGroupString()
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/color_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/color_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/color_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/color_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,78 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of colorObj
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+
+class ColorObjTestCase(unittest.TestCase):
+    def testColorObjConstructorNoArgs(self):
+        """a color can be initialized with no arguments"""
+        c = mapscript.colorObj()
+        assert (c.red, c.green, c.blue, c.alpha) == (0, 0, 0, 255)
+
+    def testColorObjConstructorArgs(self):
+        """a color can be initialized with arguments"""
+        c = mapscript.colorObj(1, 2, 3, 4)
+        assert (c.red, c.green, c.blue, c.alpha) == (1, 2, 3, 4)
+
+    def testColorObjToHex(self):
+        """a color can be outputted as hex"""
+        c = mapscript.colorObj(255, 255, 255)
+        assert c.toHex() == "#ffffff"
+
+    def testColorObjToHexBadly(self):
+        """raise an error in the case of an undefined color"""
+        c = mapscript.colorObj(-1, -1, -1)
+        self.assertRaises(mapscript.MapServerError, c.toHex)
+
+    def testColorObjSetRGB(self):
+        """a color can be set using setRGB method"""
+        c = mapscript.colorObj()
+        c.setRGB(255, 255, 255, 100)
+        assert (c.red, c.green, c.blue, c.alpha) == (255, 255, 255, 100)
+
+    def testColorObjSetHexLower(self):
+        """a color can be set using lower case hex"""
+        c = mapscript.colorObj()
+        c.setHex("#ffffff64")
+        assert (c.red, c.green, c.blue, c.alpha) == (255, 255, 255, 100)
+
+    def testColorObjSetHexUpper(self):
+        """a color can be set using upper case hex"""
+        c = mapscript.colorObj()
+        c.setHex("#FFFFFF")
+        assert (c.red, c.green, c.blue) == (255, 255, 255)
+
+    def testColorObjSetHexBadly(self):
+        """invalid hex color string raises proper error"""
+        c = mapscript.colorObj()
+        self.assertRaises(mapscript.MapServerError, c.setHex, "#fffffg")
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/config_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/config_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/config_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/config_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,63 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map
+# Author:   Seth Girvin, sgirvin@geographika.co.uk
+#
+# ===========================================================================
+# Copyright (c) 2021, MapServer team
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import TESTCONFIGFILE
+
+
+class ConfigConstructorTestCase(unittest.TestCase):
+    def testConfigConstructorFilenameArg(self):
+        """ConfigConstructorTestCase.testConfigConstructorFilenameArg: map constructor with filename argument"""
+        test_config = mapscript.configObj(TESTCONFIGFILE)
+        assert test_config.__class__.__name__ == "configObj"
+        assert test_config.thisown == 1
+
+
+class ConfigHashTableTests(unittest.TestCase):
+    def testGetEnv(self):
+
+        test_config = mapscript.configObj(TESTCONFIGFILE)
+        assert test_config.env.__class__.__name__ == "hashTableObj"
+        assert test_config.env.numitems == 1
+
+    def testGetMaps(self):
+
+        test_config = mapscript.configObj(TESTCONFIGFILE)
+        assert test_config.maps.__class__.__name__ == "hashTableObj"
+        assert test_config.maps.numitems == 0
+
+    def testGetPlugins(self):
+
+        test_config = mapscript.configObj(TESTCONFIGFILE)
+        assert test_config.plugins.__class__.__name__ == "hashTableObj"
+        assert test_config.plugins.numitems == 0
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/font_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/font_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/font_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/font_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,85 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of hashTableObj
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import os
+import unittest
+
+import mapscript
+
+from .testing import TESTS_PATH
+
+
+class FontTestCase(unittest.TestCase):
+    def testSettingFonts(self):
+        mo = mapscript.mapObj()
+        assert mo.fontset.numfonts == 0
+        mo.fontset.fonts.set("Vera", os.path.join(TESTS_PATH, "vera", "Vera.ttf"))
+        # NB: this does *not* increment the fonset.numfonts -- new bug
+
+        mo.setSize(300, 300)
+        mo.setExtent(-1.0, -1.0, 1.0, 1.0)
+
+        lo = mapscript.layerObj()
+        lo.type = mapscript.MS_LAYER_POINT
+        lo.connectiontype = mapscript.MS_INLINE
+        lo.status = mapscript.MS_DEFAULT
+
+        co = mapscript.classObj()
+        lbl = mapscript.labelObj()
+        lbl.type = mapscript.MS_TRUETYPE
+        lbl.font = "Vera"
+        lbl.size = 10
+        lbl.color.setHex("#000000")
+        co.addLabel(lbl)
+
+        so = mapscript.styleObj()
+        so.symbol = 0
+        so.color.setHex("#000000")
+
+        co.insertStyle(so)
+        lo.insertClass(co)
+        li = mo.insertLayer(lo)
+        lo = mo.getLayer(li)
+
+        point = mapscript.pointObj(0, 0)
+        line = mapscript.lineObj()
+        line.add(point)
+        shape = mapscript.shapeObj(lo.type)
+        shape.add(line)
+        shape.setBounds()
+        shape.text = "Foo"
+        shape.classindex = 0
+
+        lo.addFeature(shape)
+        im = mo.draw()
+
+        # im = mo.prepareImage()
+        # shape.draw(mo, lo, im)
+        im.save("testSettingFonts.png")
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/hash_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/hash_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/hash_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/hash_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,159 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of hashTableObj
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapTestCase
+
+# ===========================================================================
+# Base class for hashtable tests.  Derived classes use these tests, but
+# defined different values for self.table.
+
+
+class HashTableBaseTestCase(object):
+
+    keys = ["key1", "key2", "key3", "key4"]
+    values = ["value1", "value2", "value3", "value4"]
+
+    def testUseNonExistentKey(self):
+        assert self.table.get("bogus") is None
+
+    def testUseNonExistentKeyWithDefault(self):
+        assert self.table.get("bogus", "default") == "default"
+
+    def testGetValue(self):
+        for key, value in zip(self.keys, self.values):
+            assert self.table.get(key) == value
+            assert self.table.get(key.upper()) == value
+            assert self.table.get(key.capitalize()) == value
+
+    def testGetValueWithDefault(self):
+        for key, value in zip(self.keys, self.values):
+            assert self.table.get(key, "foo") == value
+            assert self.table.get(key.upper(), "foo") == value
+            assert self.table.get(key.capitalize(), "foo") == value
+
+    def testClear(self):
+        self.table.clear()
+        for key in self.keys:
+            assert self.table.get(key) is None
+
+    def testRemoveItem(self):
+        key = self.keys[0]
+        self.table.remove(key)
+        assert self.table.get(key) is None
+
+    def testNextKey(self):
+        key = self.table.nextKey()
+        assert key == self.keys[0], key
+        for i in range(1, len(self.keys)):
+            key = self.table.nextKey(key)
+            assert key == self.keys[i], key
+        # We're at the end, next should be None
+        key = self.table.nextKey(key)
+        assert key is None, key
+
+    # tests using the Python dictionary access methods
+
+    def testDictKeys(self):
+        assert sorted(self.keys) == sorted(self.table.keys())
+
+    def testDictItems(self):
+        assert len(self.keys) == len(self.table)
+
+    def testCheckDictContains(self):
+        for key in self.keys:
+            assert key in self.table.keys()
+
+    def testGetDictValue(self):
+        for key, value in zip(self.keys, self.values):
+            assert self.table[key] == value
+            assert self.table[key.upper()] == value
+            assert self.table[key.capitalize()] == value
+
+    def testRemoveDictItem(self):
+        key = self.keys[0]
+        del self.table[key]
+        assert self.table[key] is None
+
+
+# ===========================================================================
+# Test begins now
+
+# ===========================================================================
+# HashTable test case
+#
+
+
+class HashTableTestCase(unittest.TestCase, HashTableBaseTestCase):
+    """Tests of the MapServer HashTable object"""
+
+    def setUp(self):
+        "our fixture is a HashTable with two items"
+        self.table = mapscript.hashTableObj()
+        for key, value in zip(self.keys, self.values):
+            self.table.set(key, value)
+
+    def tearDown(self):
+        self.table = None
+
+    def testConstructor(self):
+        table = mapscript.hashTableObj()
+        assert table.__class__.__name__ == "hashTableObj", table
+
+
+# ==============================================================================
+# following tests use the tests/test.map fixture
+
+
+class WebMetadataTestCase(MapTestCase, HashTableBaseTestCase):
+    def setUp(self):
+        MapTestCase.setUp(self)
+        self.table = self.map.web.metadata
+        self.keys = ["key1", "key2", "key3", "key4", "ows_enable_request"]
+        self.values = ["value1", "value2", "value3", "value4", "*"]
+
+    def tearDown(self):
+        MapTestCase.tearDown(self)
+        self.table = None
+
+
+class LayerMetadataTestCase(WebMetadataTestCase):
+    def setUp(self):
+        MapTestCase.setUp(self)
+        self.table = self.map.getLayer(1).metadata
+
+
+class ClassMetadataTestCase(WebMetadataTestCase):
+    def setUp(self):
+        MapTestCase.setUp(self)
+        self.table = self.map.getLayer(1).getClass(0).metadata
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/image_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/image_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/image_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/image_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,190 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of map cloning
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+import urllib
+from io import BytesIO
+
+import mapscript
+
+from .testing import TEST_IMAGE as test_image
+from .testing import MapTestCase
+
+have_image = False
+
+try:
+    from PIL import Image
+
+    have_image = True
+except ImportError:
+    pass
+
+
+class ImageObjTestCase(unittest.TestCase):
+    def testConstructor(self):
+        """imageObj constructor works"""
+        imgobj = mapscript.imageObj(10, 10)
+        assert imgobj.thisown == 1
+        assert imgobj.height == 10
+        assert imgobj.width == 10
+
+    def testConstructorWithFormat(self):
+        """imageObj with an optional driver works"""
+        driver = "AGG/PNG"
+        format = mapscript.outputFormatObj(driver)
+        imgobj = mapscript.imageObj(10, 10, format)
+        assert imgobj.thisown == 1
+        assert imgobj.format.driver == driver
+        assert imgobj.height == 10
+        assert imgobj.width == 10
+
+    def xtestConstructorFilename(self):
+        """imageObj with a filename works"""
+        imgobj = mapscript.imageObj(test_image)
+        assert imgobj.thisown == 1
+        assert imgobj.height == 200
+        assert imgobj.width == 200
+        imgobj.save("testConstructorFilename.png")
+
+    def xtestConstructorFilenameDriver(self):
+        """imageObj with a filename and a driver works"""
+        imgobj = mapscript.imageObj(test_image)
+        assert imgobj.thisown == 1
+        assert imgobj.height == 200
+        assert imgobj.width == 200
+        imgobj.save("testConstructorFilenameDriver.png")
+
+    def xtestConstructorStream(self):
+        """imageObj with a file stream works"""
+        f = open(test_image, "rb")
+        imgobj = mapscript.imageObj(f)
+        f.close()
+        assert imgobj.thisown == 1
+        assert imgobj.height == 200
+        assert imgobj.width == 200
+
+    def xtestConstructorBytesIO(self):
+        """imageObj with a BytesIO works"""
+        with open(test_image, "rb") as f:
+            data = f.read()
+        s = BytesIO(data)
+        imgobj = mapscript.imageObj(s)
+        assert imgobj.thisown == 1
+        assert imgobj.height == 200
+        assert imgobj.width == 200
+
+    def xtestConstructorUrlStream(self):
+        """imageObj with a URL stream works"""
+        url = urllib.urlopen("http://mapserver.org/_static/banner.png")
+        imgobj = mapscript.imageObj(url, "AGG/JPEG")
+        assert imgobj.thisown == 1
+        assert imgobj.height == 68
+        assert imgobj.width == 439
+        imgobj.save("testConstructorUrlStream.jpg")
+
+
+class ImageWriteTestCase(MapTestCase):
+    def testImageWrite(self):
+        """image writes data to an open filehandle"""
+        image = self.map.draw()
+        assert image.thisown == 1
+        filename = "testImageWrite.png"
+        fh = open(filename, "wb")
+        image.write(fh)
+        fh.close()
+        if have_image:
+            pyimg = Image.open(filename)
+            assert pyimg.format == "PNG"
+            assert pyimg.size == (200, 200)
+            assert pyimg.mode == "RGB"
+
+    def testImageWriteBytesIO(self):
+        """image writes data to a BytesIO instance"""
+        image = self.map.draw()
+        assert image.thisown == 1
+
+        s = BytesIO()
+        image.write(s)
+
+        filename = "testImageWriteBytesIO.png"
+        with open(filename, "wb") as fh:
+            fh.write(s.getvalue())
+        if have_image:
+            pyimg = Image.open(filename)
+            assert pyimg.format == "PNG"
+            assert pyimg.size == (200, 200)
+            assert pyimg.mode == "RGB"
+
+    def testImageGetBytes(self):
+        """image returns bytes"""
+        image = self.map.draw()
+        assert image.thisown == 1
+
+        s = BytesIO(image.getBytes())
+
+        filename = "testImageGetBytes.png"
+        with open(filename, "wb") as fh:
+            fh.write(s.getvalue())
+        if have_image:
+            pyimg = Image.open(filename)
+            assert pyimg.format == "PNG"
+            assert pyimg.size == (200, 200)
+            assert pyimg.mode == "RGB"
+
+    def testSaveWebImage(self):
+        """save an image to the imagepath folder and return its URL"""
+
+        # set the imagepath and imageurl on the MAP WEB object
+        self.map.web.imagepath = ""
+        self.map.web.imageurl = "/output/"
+
+        image = self.map.draw()
+        url = image.saveWebImage()
+        assert url.startswith("/output/")
+        assert url.endswith(".png")
+
+    def testPasteImage(self):
+        """save an image to the imagepath folder and return its URL"""
+
+        image1 = self.map.draw()
+        image2 = self.map.draw()
+
+        ret = image1.pasteImage(image2, opacity=0.5, dstx=10, dsty=10)
+        assert ret == mapscript.MS_SUCCESS
+
+        filename = "testImagePaste.png"
+        fh = open(filename, "wb")
+        image1.write(fh)
+        fh.close()
+        if have_image:
+            pyimg = Image.open(filename)
+            assert pyimg.format == "PNG"
+            assert pyimg.size == (200, 200)
+            assert pyimg.mode == "RGB"
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/label_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/label_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/label_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/label_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,76 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapTestCase
+
+
+class NewLabelsTestCase(MapTestCase):
+    def testLabelBinding(self):
+        """attribute binding can be set and get"""
+        new_label = mapscript.labelObj()
+        assert not new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR)
+        new_label.setBinding(mapscript.MS_LABEL_BINDING_COLOR, "NEW_BINDING")
+        assert new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR) == "NEW_BINDING"
+
+    def testLabelExpressionBinding(self):
+        """expression binding can be set and get"""
+        new_label = mapscript.labelObj()
+        assert not new_label.getExpressionBinding(mapscript.MS_LABEL_BINDING_PRIORITY)
+        new_label.setExpressionBinding(
+            mapscript.MS_LABEL_BINDING_PRIORITY, "[MY_ATTRIBUTE] * 2"
+        )
+        assert (
+            new_label.getExpressionBinding(mapscript.MS_LABEL_BINDING_PRIORITY)
+            == "([MY_ATTRIBUTE] * 2)"
+        )
+
+        exp = (
+            "LABEL\n  SIZE 10\n  OFFSET 0 0\n  POSITION CC\n  "
+            "PRIORITY ([MY_ATTRIBUTE] * 2)\n  SHADOWSIZE 1 1\nEND # LABEL\n"
+        )
+        assert new_label.convertToString() == exp
+
+
+class LabelCacheMemberTestCase(MapTestCase):
+    def testCacheMemberText(self):
+        """string attribute has been renamed to 'text' (bug 852)"""
+        lo = self.map.getLayerByName("POINT")
+        lo.status = mapscript.MS_ON
+        img = self.map.draw()
+        assert img is not None
+        assert (
+            self.map.labelcache.num_rendered_members == 1
+        ), self.map.labelcache.num_rendered_members
+        # label = self.map.nextLabel()
+        # assert label.text == 'A Point', label.text
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/layer_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/layer_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/layer_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/layer_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,470 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Layer
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+from random import random
+
+import mapscript
+
+from .testing import MapTestCase
+
+
+class MapLayerTestCase(MapTestCase):
+    def setUp(self):
+        MapTestCase.setUp(self)
+        self.layer = self.map.getLayer(1)
+
+
+class LayerConstructorTestCase(MapLayerTestCase):
+    def testLayerConstructorNoArg(self):
+        """test layer constructor with no argument"""
+        layer = mapscript.layerObj()
+        assert layer.__class__.__name__ == "layerObj"
+        assert layer.thisown == 1
+        assert layer.index == -1
+        assert layer.map is None, layer.map
+
+    def testLayerConstructorMapArg(self):
+        """test layer constructor with map argument"""
+        layer = mapscript.layerObj(self.map)
+        assert layer.__class__.__name__ == "layerObj"
+        assert layer.thisown == 1
+        lyr = self.map.getLayer(self.map.numlayers - 1)
+        assert lyr is not None
+        # assert str(layer) == str(lyr) # TODO - check why these are not equal
+        assert layer.map is not None, layer.map
+
+
+class LayerItemDefinitionTestCase(MapLayerTestCase):
+    def setUp(self):
+        MapTestCase.setUp(self)
+        self.layer = self.map.getLayerByName("POINT")
+        self.layer.open()
+
+    def tearDown(self):
+        self.layer.close()
+
+    def testLayerGetItemType(self):
+        """test getting layer item information for the first item"""
+
+        item_type = self.layer.getItemType(0)
+        assert item_type == "Integer"
+
+    def testLayerGetItemDefinition2(self):
+        """test getting layer item information for the second item"""
+
+        item_type = self.layer.getItemType(1)
+        assert item_type == "Character"
+
+    def testLayerGetMissingItemType(self):
+        """test getting item information for a non-existent index"""
+        item_type = self.layer.getItemType(100)
+        assert item_type is None
+
+    def testLayerGetItemTypeClosedLayer(self):
+        """item definition will be None for a closed layer"""
+        self.layer.close()
+        item_type = self.layer.getItemType(0)
+        assert item_type is None
+
+    def testLayerGetNonDefinedItemType(self):
+        """test getting layer item information for a layer with gml_types auto"""
+
+        layer = self.map.getLayerByName("POLYGON")
+        layer.open()
+        item_type = layer.getItemType(0)
+        assert item_type == ""
+        layer.close()
+
+
+class LayerCloningTestCase(MapLayerTestCase):
+    def testLayerCloning(self):
+        """check attributes of a cloned layer"""
+        clone = self.layer.clone()
+        assert clone.thisown == 1
+        assert str(clone) != str(self.layer)
+        assert clone.name == self.layer.name
+        assert clone.numclasses == self.layer.numclasses
+        assert clone.map is None, clone.map
+        assert clone.data == self.layer.data
+
+
+class LayerExtentTestCase(MapTestCase):
+    def setUp(self):
+        MapTestCase.setUp(self)
+        self.layer = self.map.getLayerByName("POLYGON")
+
+    def testPolygonExtent(self):
+        """retrieve the extent of a polygon layer"""
+        e = mapscript.rectObj()
+        self.assertRectsEqual(e, self.layer.extent)
+
+    def testPolygonGetExtent(self):
+        """retrieve the extent of a polygon layer"""
+        e = mapscript.rectObj(-0.25, 51.227222, 0.25, 51.727222)
+        self.assertRectsEqual(e, self.layer.getExtent())
+
+    def testGetPresetExtent(self):
+        """test layer.setExtent() and layer.getExtent() to return preset instead of calculating extents"""
+        r = mapscript.rectObj(1.0, 1.0, 3.0, 3.0)
+        self.layer.setExtent(r.minx, r.miny, r.maxx, r.maxy)
+        rect = self.layer.extent
+        assert r.minx == rect.minx, rect
+        assert r.miny == rect.miny, rect.miny
+        assert r.maxx == rect.maxx, rect.maxx
+        assert r.maxy == rect.maxy, rect.maxy
+
+    def testResetLayerExtent(self):
+        """test resetting a layer's extent"""
+        layer = self.map.getLayerByName("POLYGON")
+        layer.setExtent()
+        self.assertRectsEqual(layer.extent, mapscript.rectObj())
+
+    def testDirectExtentAccess(self):
+        """direct access to a layer's extent works properly"""
+        pt_layer = self.map.getLayerByName("POINT")
+        rect = pt_layer.extent
+        assert str(pt_layer.extent) == str(rect), (pt_layer.extent, rect)
+        e = mapscript.rectObj(-0.5, 51.0, 0.5, 52.0)
+        self.assertRectsEqual(e, rect)
+
+
+class LayerRasterProcessingTestCase(MapLayerTestCase):
+    def testAddProcessing(self):
+        """adding a layer's processing directive works"""
+        self.layer.addProcessing("directive0=foo")
+        assert self.layer.numprocessing == 1, self.layer.numprocessing
+        self.layer.addProcessing("directive1=bar")
+        assert self.layer.numprocessing == 2, self.layer.numprocessing
+        directives = [
+            self.layer.getProcessing(i) for i in range(self.layer.numprocessing)
+        ]
+        assert directives == ["directive0=foo", "directive1=bar"]
+
+    def testClearProcessing(self):
+        """clearing a self.layer's processing directive works"""
+        self.layer.addProcessing("directive0=foo")
+        assert self.layer.numprocessing == 1, self.layer.numprocessing
+        self.layer.addProcessing("directive1=bar")
+        assert self.layer.numprocessing == 2, self.layer.numprocessing
+        assert self.layer.clearProcessing() == mapscript.MS_SUCCESS
+
+
+class RemoveClassTestCase(MapLayerTestCase):
+    def testRemoveClass1NumClasses(self):
+        """RemoveClassTestCase.testRemoveClass1NumClasses: removing the layer's first class
+        by index leaves one class left"""
+        c = self.layer.removeClass(0)
+        assert c.thisown == 1
+        assert self.layer.numclasses == 1
+
+    def testRemoveClass1ClassName(self):
+        """RemoveClassTestCase.testRemoveClass1ClassName:
+        confirm removing the layer's first class reverts the name of the second class"""
+        c2name = self.layer.getClass(1).name
+        c = self.layer.removeClass(0)
+        assert c is not None
+        assert self.layer.getClass(0).name == c2name
+
+    def testRemoveClass2NumClasses(self):
+        """RemoveClassTestCase.testRemoveClass2NumClasses:
+        removing the layer's second class by index leaves one class left"""
+        c = self.layer.removeClass(1)
+        assert c is not None
+        assert self.layer.numclasses == 1
+
+    def testRemoveClass2ClassName(self):
+        """RemoveClassTestCase.testRemoveClass2ClassName: confirm removing the layer's second class reverts
+        the name of the first class"""
+        c1name = self.layer.getClass(0).name
+        c = self.layer.removeClass(1)
+        assert c is not None
+        assert self.layer.getClass(0).name == c1name
+
+
+class InsertClassTestCase(MapLayerTestCase):
+    def testLayerInsertClass(self):
+        """insert class at default index"""
+        n = self.layer.numclasses
+        new_class = mapscript.classObj()
+        new_class.name = "foo"
+        new_index = self.layer.insertClass(new_class)
+        assert new_index == n
+        assert self.layer.numclasses == n + 1
+        c = self.layer.getClass(new_index)
+        assert c.thisown == 1
+        assert c.name == new_class.name
+
+    def testLayerInsertClassAtZero(self):
+        """insert class at index 0"""
+        n = self.layer.numclasses
+        new_class = mapscript.classObj()
+        new_class.name = "foo"
+        new_index = self.layer.insertClass(new_class, 0)
+        assert new_index == 0
+        assert self.layer.numclasses == n + 1
+        c = self.layer.getClass(new_index)
+        assert c.thisown == 1
+        assert c.name == new_class.name
+
+    def testInsertNULLClass(self):
+        """inserting NULL class should raise an error"""
+        self.assertRaises(mapscript.MapServerChildError, self.layer.insertClass, None)
+
+
+class LayerTestCase(MapTestCase):
+    def testLayerConstructorOwnership(self):
+        """LayerTestCase.testLayerConstructorOwnership: newly constructed layer has proper ownership"""
+        layer = mapscript.layerObj(self.map)
+        assert layer.thisown == 1
+
+    def testGetLayerOrder(self):
+        """LayerTestCase.testGetLayerOrder: get layer drawing order"""
+        order = self.map.getLayerOrder()
+        assert order == tuple(range(7)), order
+
+    def testSetLayerOrder(self):
+        """LayerTestCase.testSetLayerOrder: set layer drawing order"""
+        ord = (1, 0, 2, 3, 4, 5, 6)
+        self.map.setLayerOrder(ord)
+        order = self.map.getLayerOrder()
+        assert order == ord, order
+
+
+# Layer removal tests
+
+
+class RemoveLayerTestCase(MapTestCase):
+    def testRemoveLayer1NumLayers(self):
+        """removing the first layer by index from the mapfile leaves three"""
+        self.map.removeLayer(0)
+        assert self.map.numlayers == 6
+
+    def testRemoveLayer1LayerName(self):
+        """removing first layer reverts it to the second layer's name"""
+        l2name = self.map.getLayer(1).name
+        self.map.removeLayer(0)
+        assert self.map.getLayer(0).name == l2name
+
+    def testRemoveLayer2NumLayers(self):
+        """removing second layer by index from mapfile leaves three layers"""
+        self.map.removeLayer(1)
+        assert self.map.numlayers == 6
+
+    def testRemoveLayer2LayerName(self):
+        """removing of the second layer reverts it to the first layer's name"""
+        l1name = self.map.getLayer(0).name
+        self.map.removeLayer(1)
+        assert self.map.getLayer(0).name == l1name
+
+
+class ExpressionTestCase(MapLayerTestCase):
+    def testClearExpression(self):
+        """layer expression can be properly cleared"""
+        self.layer.setFilter("")
+        fs = self.layer.getFilterString()
+        assert fs is None, fs
+
+    def testSetStringExpression(self):
+        """layer expression can be set to string"""
+        self.layer.setFilter("foo")
+        fs = self.layer.getFilterString()
+        self.layer.filteritem = "fid"
+        assert fs == '"foo"', fs
+        self.map.draw()
+
+    def testSetQuotedStringExpression(self):
+        """layer expression string can be quoted"""
+        self.layer.setFilter('"foo"')
+        fs = self.layer.getFilterString()
+        self.layer.filteritem = "fid"
+        assert fs == '"foo"', fs
+        self.map.draw()
+
+    def testSetRegularExpression(self):
+        """layer expression can be regular expression"""
+        self.layer.setFilter("/foo/")
+        self.layer.filteritem = "fid"
+        fs = self.layer.getFilterString()
+        assert fs == "/foo/", fs
+        self.map.draw()
+
+    def testSetLogicalExpression(self):
+        """layer expression can be logical expression"""
+        self.layer.setFilter("([fid] >= 2)")
+        fs = self.layer.getFilterString()
+        assert fs == "([fid] >= 2)", fs
+        self.map.draw()
+
+    def testSetCompoundLogicalExpression(self):
+        """layer expression can be a compound logical expression"""
+        # filter = '( ([fid] >= 2) AND (\'[fname]\' == \'A Polygon\' ))'
+        flt = """( ([fid] >= 2) AND ("[fname]" == 'A Polygon' ))"""
+        excode = self.layer.setFilter(flt)
+        assert excode == mapscript.MS_SUCCESS, excode
+        fs = self.layer.getFilterString()
+        assert fs == flt, fs
+        self.map.draw()
+
+
+class LayerQueryTestCase(MapLayerTestCase):
+    def setUp(self):
+        MapLayerTestCase.setUp(self)
+        self.layer = self.map.getLayerByName("POINT")
+        self.layer.template = "foo"
+
+
+class SpatialLayerQueryTestCase(LayerQueryTestCase):
+    def testRectQuery(self):
+        qrect = mapscript.rectObj(-10.0, 45.0, 10.0, 55.0)
+        self.layer.queryByRect(self.map, qrect)
+        assert self.layer.getNumResults() == 1
+
+    def testShapeQuery(self):
+        qrect = mapscript.rectObj(-10.0, 45.0, 10.0, 55.0)
+        qshape = qrect.toPolygon()
+        self.layer.queryByShape(self.map, qshape)
+        assert self.layer.getNumResults() == 1
+
+    def testPointQuery(self):
+        qpoint = mapscript.pointObj(0.0, 51.5)
+        self.layer.queryByPoint(self.map, qpoint, mapscript.MS_MULTIPLE, 2.0)
+        assert self.layer.getNumResults() == 1
+
+    def testRectQueryNoResults(self):
+        qrect = mapscript.rectObj(-101.0, 0.0, -100.0, 1.0)
+        self.layer.queryByRect(self.map, qrect)
+        assert self.layer.getNumResults() == 0
+
+    def testShapeQueryNoResults(self):
+        qrect = mapscript.rectObj(-101.0, 0.0, -100.0, 1.0)
+        qshape = qrect.toPolygon()
+        self.layer.queryByShape(self.map, qshape)
+        assert self.layer.getNumResults() == 0
+
+    def testPointQueryNoResults(self):
+        qpoint = mapscript.pointObj(-100.0, 51.5)
+        self.layer.queryByPoint(self.map, qpoint, mapscript.MS_MULTIPLE, 2.0)
+        assert self.layer.getNumResults() == 0
+
+
+class AttributeLayerQueryTestCase(LayerQueryTestCase):
+    def testAttributeQuery(self):
+        self.layer.queryByAttributes(
+            self.map, "FNAME", '"A Point"', mapscript.MS_MULTIPLE
+        )
+        assert self.layer.getNumResults() == 1
+
+    def testLogicalAttributeQuery(self):
+        self.layer.queryByAttributes(
+            self.map, None, '("[FNAME]" == "A Point")', mapscript.MS_MULTIPLE
+        )
+        assert self.layer.getNumResults() == 1
+
+    def testAttributeQueryNoResults(self):
+        self.layer.queryByAttributes(
+            self.map, "FNAME", '"Bogus Point"', mapscript.MS_MULTIPLE
+        )
+        assert self.layer.getNumResults() == 0
+
+
+class LayerVisibilityTestCase(MapLayerTestCase):
+    def setUp(self):
+        MapLayerTestCase.setUp(self)
+        self.layer.minscaledenom = 1000
+        self.layer.maxscaledenom = 2000
+        self.layer.status = mapscript.MS_ON
+        self.map.zoomScale(
+            1500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None
+        )
+
+    def testInitialVisibility(self):
+        """expect visibility"""
+        assert self.layer.isVisible() == mapscript.MS_TRUE
+
+    def testStatusOffVisibility(self):
+        """expect false visibility after switching status off"""
+        self.layer.status = mapscript.MS_OFF
+        assert self.layer.isVisible() == mapscript.MS_FALSE
+
+    def testZoomOutVisibility(self):
+        """expect false visibility after zooming out beyond maximum"""
+        self.map.zoomScale(
+            2500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None
+        )
+        assert self.layer.isVisible() == mapscript.MS_FALSE
+
+
+class InlineLayerTestCase(unittest.TestCase):
+    def setUp(self):
+        # Inline feature layer
+        self.ilayer = mapscript.layerObj()
+        self.ilayer.type = mapscript.MS_LAYER_POLYGON
+        self.ilayer.status = mapscript.MS_DEFAULT
+        self.ilayer.connectiontype = mapscript.MS_INLINE
+
+        cs = "f7fcfd, e5f5f9, ccece6, 99d8c9, 66c2a4, 41ae76, 238b45, 006d2c, 00441b"
+        colors = ["#" + h for h in cs.split(", ")]
+
+        for i in range(9):
+            # Make a class for feature
+            ci = self.ilayer.insertClass(mapscript.classObj())
+            co = self.ilayer.getClass(ci)
+            si = co.insertStyle(mapscript.styleObj())
+            so = co.getStyle(si)
+            so.color.setHex(colors[i])
+            li = co.addLabel(mapscript.labelObj())
+            lbl = co.getLabel(li)
+            lbl.color.setHex("#000000")
+            lbl.outlinecolor.setHex("#FFFFFF")
+            lbl.type = mapscript.MS_BITMAP
+            lbl.size = mapscript.MS_SMALL
+
+            # The shape to add is randomly generated
+            xc = 4.0 * (random() - 0.5)
+            yc = 4.0 * (random() - 0.5)
+            r = mapscript.rectObj(xc - 0.25, yc - 0.25, xc + 0.25, yc + 0.25)
+            s = r.toPolygon()
+
+            # Classify
+            s.classindex = i
+            s.text = "F%d" % (i)
+
+            # Add to inline feature layer
+            self.ilayer.addFeature(s)
+
+    def testExternalClassification(self):
+        mo = mapscript.mapObj()
+        mo.setSize(400, 400)
+        mo.setExtent(-2.5, -2.5, 2.5, 2.5)
+        mo.selectOutputFormat("image/png")
+        mo.insertLayer(self.ilayer)
+        im = mo.draw()
+        im.save("testExternalClassification.png")
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/line_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/line_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/line_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/line_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,87 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map "zooming"
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+
+import unittest
+
+import mapscript
+
+from .testing import MapPrimitivesTestCase
+
+
+class LineObjTestCase(MapPrimitivesTestCase):
+    """Testing the lineObj class in stand-alone mode"""
+
+    def setUp(self):
+        """The test fixture is a line with two points"""
+        self.points = (mapscript.pointObj(0.0, 1.0), mapscript.pointObj(2.0, 3.0))
+        self.line = mapscript.lineObj()
+        self.addPointToLine(self.line, self.points[0])
+        self.addPointToLine(self.line, self.points[1])
+
+    def testCreateLine(self):
+        """created line has the correct number of points"""
+        assert self.line.numpoints == 2
+
+    def testGetPointsFromLine(self):
+        """points in the line share are the same that were input"""
+        for i in range(len(self.points)):
+            got_point = self.getPointFromLine(self.line, i)
+            self.assertPointsEqual(got_point, self.points[i])
+
+    def testAddPointToLine(self):
+        """adding a point to a line behaves correctly"""
+        new_point = mapscript.pointObj(4.0, 5.0)
+        self.addPointToLine(self.line, new_point)
+        assert self.line.numpoints == 3
+
+    def xtestAlterNumPoints(self):
+        """
+        numpoints is immutable, this should raise error
+        """
+        # The following works locally but fails on Appveyor (error is not raised)
+        # with self.assertRaises(AttributeError):
+        #    self.line.numpoints = 3
+
+        # the following approach also fails on appveyor
+        error_thrown = False
+        try:
+            self.line.numpoints = 3
+        except AttributeError:
+            error_thrown = True
+
+        assert error_thrown is True
+
+    def testLineGeoInterface(self):
+        """return line using the  __geo_interface__ protocol"""
+        assert self.line.__geo_interface__ == {
+            "type": "LineString",
+            "coordinates": [(0.0, 1.0, 0.0), (2.0, 3.0, 0.0)],
+        }
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/map_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/map_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/map_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/map_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,356 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import TESTMAPFILE, MapTestCase
+
+
+class MapConstructorTestCase(unittest.TestCase):
+    def testMapConstructorNoArg(self):
+        """MapConstructorTestCase.testMapConstructorNoArg: test map constructor with no argument"""
+        test_map = mapscript.mapObj()
+        assert test_map.__class__.__name__ == "mapObj"
+        assert test_map.thisown == 1
+
+    def testMapConstructorEmptyStringArg(self):
+        """MapConstructorTestCase.testMapConstructorEmptyStringArg:
+        test map constructor with old-style empty string argument"""
+        test_map = mapscript.mapObj("")
+        assert test_map.__class__.__name__ == "mapObj"
+        assert test_map.thisown == 1
+
+    def testMapConstructorFilenameArg(self):
+        """MapConstructorTestCasetest.testMapConstructorEmptyStringArg: map constructor with filename argument"""
+        test_map = mapscript.mapObj(TESTMAPFILE)
+        assert test_map.__class__.__name__ == "mapObj"
+        assert test_map.thisown == 1
+
+
+class MapExtentTestCase(MapTestCase):
+    def testSetExtent(self):
+        """MapExtentTestCase.testSetExtent: test the setting of a mapObj's extent"""
+        test_map = mapscript.mapObj(TESTMAPFILE)
+        e = test_map.extent
+        result = test_map.setExtent(e.minx, e.miny, e.maxx, e.maxy)
+        self.assertAlmostEqual(test_map.scaledenom, 14.24445829)
+        assert result == mapscript.MS_SUCCESS, result
+
+    def testSetExtentBadly(self):
+        """MapExtentTestCase.testSetExtentBadly: test that mapscript raises an error for an invalid mapObj extent"""
+        test_map = mapscript.mapObj(TESTMAPFILE)
+        self.assertRaises(
+            mapscript.MapServerError, test_map.setExtent, 1.0, -2.0, -3.0, 4.0
+        )
+
+    def testReBindingExtent(self):
+        """test the rebinding of a map's extent"""
+        test_map = mapscript.mapObj(TESTMAPFILE)
+        rect1 = mapscript.rectObj(-10.0, -10.0, 10.0, 10.0)
+        rect2 = mapscript.rectObj(-10.0, -10.0, 10.0, 10.0)
+        test_map.extent = rect1
+        assert repr(test_map.extent) != repr(rect1), (test_map.extent, rect1)
+        del rect1
+        self.assertRectsEqual(test_map.extent, rect2)
+
+
+class MapLayersTestCase(MapTestCase):
+    def testMapInsertLayer(self):
+        """MapLayersTestCase.testMapInsertLayer: test insertion of a new layer at default (last) index"""
+        n = self.map.numlayers
+        layer = mapscript.layerObj()
+        layer.name = "new"
+        assert layer.map is None, layer.map
+        index = self.map.insertLayer(layer)
+        assert layer.map is not None, layer.map
+        assert index == n, index
+        assert self.map.numlayers == n + 1
+        names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
+        assert names == [
+            "RASTER",
+            "POLYGON",
+            "LINE",
+            "POINT",
+            "INLINE",
+            "INLINE-PIXMAP-RGBA",
+            "INLINE-PIXMAP-PCT",
+            "new",
+        ]
+        order = self.map.getLayerOrder()
+        assert order == (0, 1, 2, 3, 4, 5, 6, 7), order
+
+    def testMapInsertLayerAtZero(self):
+        """MapLayersTestCase.testMapInsertLayerAtZero: test insertion of a new layer at first index"""
+        n = self.map.numlayers
+        layer = mapscript.layerObj()
+        layer.name = "new"
+        assert layer.map is None, layer.map
+        index = self.map.insertLayer(layer, 0)
+        assert layer.map is not None, layer.map
+        assert index == 0, index
+        assert self.map.numlayers == n + 1
+        names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
+        assert names == [
+            "new",
+            "RASTER",
+            "POLYGON",
+            "LINE",
+            "POINT",
+            "INLINE",
+            "INLINE-PIXMAP-RGBA",
+            "INLINE-PIXMAP-PCT",
+        ], names
+        order = self.map.getLayerOrder()
+        assert order == (0, 1, 2, 3, 4, 5, 6, 7), order
+
+    def testMapInsertLayerDrawingOrder(self):
+        """MapLayersTestCase.testMapInsertLayerDrawingOrder: test affect of
+        insertion of a new layer at index 1 on drawing order"""
+        n = self.map.numlayers
+        assert n == 7
+        # reverse layer drawing order
+        o_start = (6, 5, 4, 3, 2, 1, 0)
+        self.map.setLayerOrder(o_start)
+        # insert Layer
+        layer = mapscript.layerObj()
+        layer.name = "new"
+        index = self.map.insertLayer(layer, 1)
+        assert index == 1, index
+        # We expect our new layer to be at index 1 in drawing order as well
+        order = self.map.getLayerOrder()
+        assert order == (7, 1, 6, 5, 4, 3, 2, 0), order
+
+    def testMapInsertLayerBadIndex(self):
+        """MapLayersTestCase.testMapInsertLayerBadIndex: expect an exception when index is too large"""
+        layer = mapscript.layerObj()
+        self.assertRaises(
+            mapscript.MapServerChildError, self.map.insertLayer, layer, 1000
+        )
+
+    def testMapInsertNULLLayer(self):
+        """expect an exception on attempt to insert a NULL Layer"""
+        self.assertRaises(mapscript.MapServerChildError, self.map.insertLayer, None)
+
+    def testMapRemoveLayerAtTail(self):
+        """removal of highest index (tail) layer"""
+        n = self.map.numlayers
+        layer = self.map.removeLayer(n - 1)
+        assert self.map.numlayers == n - 1
+        assert layer.name == "INLINE-PIXMAP-PCT"
+        assert layer.thisown == 1
+        del layer
+        order = self.map.getLayerOrder()
+        assert order == (0, 1, 2, 3, 4, 5), order
+
+    def testMapRemoveLayerAtZero(self):
+        """removal of lowest index (0) layer"""
+        n = self.map.numlayers
+        layer = self.map.removeLayer(0)
+        assert self.map.numlayers == n - 1
+        assert layer.name == "RASTER"
+        order = self.map.getLayerOrder()
+        assert order == (0, 1, 2, 3, 4, 5), order
+
+    def testMapRemoveLayerDrawingOrder(self):
+        """test affect of layer removal on drawing order"""
+        n = self.map.numlayers
+        # reverse layer drawing order
+        o_start = (6, 5, 4, 3, 2, 1, 0)
+        self.map.setLayerOrder(o_start)
+        layer = self.map.removeLayer(1)
+        assert self.map.numlayers == n - 1
+        assert layer.name == "POLYGON"
+        order = self.map.getLayerOrder()
+        assert order == (5, 4, 3, 2, 1, 0), order
+        names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
+        assert names == [
+            "RASTER",
+            "LINE",
+            "POINT",
+            "INLINE",
+            "INLINE-PIXMAP-RGBA",
+            "INLINE-PIXMAP-PCT",
+        ], names
+
+
+class MapExceptionTestCase(MapTestCase):
+    def testDrawBadData(self):
+        """MapExceptionTestCase.testDrawBadData: a bad data descriptor in a layer returns proper error"""
+        self.map.getLayerByName("POLYGON").data = "foo"
+        self.assertRaises(mapscript.MapServerError, self.map.draw)
+
+
+class EmptyMapExceptionTestCase(unittest.TestCase):
+    def setUp(self):
+        self.map = mapscript.mapObj("")
+
+    def tearDown(self):
+        self.map = None
+
+    def testDrawEmptyMap(self):
+        """EmptyMapExceptionTestCase.testDrawEmptyMap: drawing an empty map returns proper error"""
+        self.assertRaises(mapscript.MapServerError, self.map.draw)
+
+
+class NoFontSetTestCase(unittest.TestCase):
+    def testNoGetFontSetFile(self):
+        """an empty map should have fontset filename == None"""
+        self.map = mapscript.mapObj()
+        assert self.map.fontset.filename is None
+
+
+class MapFontSetTestCase(MapTestCase):
+    def testGetFontSetFile(self):
+        """expect fontset file to be 'fonts.txt'"""
+        file = self.map.fontset.filename
+        assert file == "fonts.txt", file
+
+
+class MapSizeTestCase(MapTestCase):
+    def testDefaultSize(self):
+        assert self.map.width == 200
+        assert self.map.height == 200
+
+    def testSetSize(self):
+        retval = self.map.setSize(480, 480)
+        assert retval == mapscript.MS_SUCCESS, retval
+        assert self.map.width == 480
+        assert self.map.height == 480
+
+
+class MapSetWKTTestCase(MapTestCase):
+    def testOGCWKT(self):
+        self.map.setWKTProjection(
+            """PROJCS["unnamed",GEOGCS["WGS 84",DATUM["WGS_1984",
+                                     SPHEROID["WGS 84",6378137,298.257223563]],
+                                     PRIMEM["Greenwich",0],
+                                     UNIT["Degree",0.0174532925199433]],
+                                     PROJECTION["Albers_Conic_Equal_Area"],
+                                     PARAMETER["standard_parallel_1", 65], PARAMETER["standard_parallel_2", 55],
+                                     PARAMETER["latitude_of_center", 0], PARAMETER["longitude_of_center", -153],
+                                     PARAMETER["false_easting", -4943910.68], PARAMETER["false_northing", 0],
+                                     UNIT["metre",1.0]
+                                     ]"""
+        )
+        proj4 = self.map.getProjection()
+
+        assert proj4.find("+proj=aea") != -1
+        assert proj4.find("+datum=WGS84") != -1
+        assert mapscript.projectionObj(proj4).getUnits() != mapscript.MS_DD
+
+    def testESRIWKT(self):
+        self.map.setWKTProjection(
+            'ESRI::PROJCS["Pulkovo_1995_GK_Zone_2", GEOGCS["GCS_Pulkovo_1995", '
+            'DATUM["D_Pulkovo_1995", SPHEROID["Krasovsky_1940", 6378245, 298.3]], '
+            'PRIMEM["Greenwich", 0], '
+            'UNIT["Degree", 0.017453292519943295]], PROJECTION["Gauss_Kruger"], '
+            'PARAMETER["False_Easting", 2500000], '
+            'PARAMETER["False_Northing", 0], PARAMETER["Central_Meridian", 9], '
+            'PARAMETER["Scale_Factor", 1], '
+            'PARAMETER["Latitude_Of_Origin", 0], UNIT["Meter", 1]]'
+        )
+        proj4 = self.map.getProjection()
+
+        assert proj4.find("+proj=tmerc") != -1
+        assert proj4.find("+ellps=krass") != -1
+        assert (mapscript.projectionObj(proj4)).getUnits() != mapscript.MS_DD
+
+    def testWellKnownGEOGCS(self):
+        self.map.setWKTProjection("WGS84")
+        proj4 = self.map.getProjection()
+        assert (
+            "+proj=longlat" in proj4 and "+datum=WGS84" in proj4
+        ) or proj4 == "+init=epsg:4326", proj4
+        assert (mapscript.projectionObj(proj4)).getUnits() != mapscript.MS_METERS
+
+
+class MapRunSubTestCase(MapTestCase):
+    def testDefaultSubstitutions(self):
+        s = """
+MAP
+    WEB
+        VALIDATION
+            'key1' '.*'
+            'default_key1' 'Test Title'
+        END
+        METADATA
+            "wms_title" "%key1%"
+        END
+    END
+END
+        """
+        map = mapscript.fromstring(s)
+        map.applyDefaultSubstitutions()
+        assert map.web.metadata["wms_title"] == "Test Title"
+
+    def testRuntimeSubstitutions(self):
+        """
+        For supported parameters see https://mapserver.org/cgi/runsub.html#parameters-supported
+        """
+        s = """
+MAP
+    WEB
+        VALIDATION
+            'key1' '.*'
+            'default_key1' 'Test Title'
+        END
+        METADATA
+            "wms_title" "%key1%"
+        END
+    END
+    LAYER
+        TYPE POINT
+        FILTER ([size]<%my_filter%)
+        VALIDATION
+            'my_filter' '^[0-9]$'
+        END
+    END
+END
+        """
+        map = mapscript.fromstring(s)
+
+        d = {"key1": "New Title", "my_filter": "3"}
+        map.applySubstitutions(d)
+
+        assert map.web.metadata["wms_title"] == "New Title"
+        assert map.getLayer(0).getFilterString() == "([size]<3)"
+
+
+class MapSLDTestCase(MapTestCase):
+    def test(self):
+
+        test_map = mapscript.mapObj(TESTMAPFILE)
+        result = test_map.generateSLD()
+        assert result.startswith('<StyledLayerDescriptor version="1.0.0"'), result
+
+        result = test_map.generateSLD("1.1.0")
+        assert result.startswith('<StyledLayerDescriptor version="1.1.0"'), result
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/outputformat_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/outputformat_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/outputformat_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/outputformat_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,111 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of outputFormatObj
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapTestCase
+
+
+class OutputFormatTestCase(unittest.TestCase):
+    """http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511"""
+
+    def testOutputFormatConstructor(self):
+        new_format = mapscript.outputFormatObj("GDAL/GTiff", "gtiff")
+        # assert new_format.refcount == 1, new_format.refcount
+        assert new_format.name == "gtiff"
+        assert new_format.mimetype == "image/tiff"
+
+
+class MapOutputFormatTestCase(MapTestCase):
+    def testAppendNewOutputFormat(self):
+        """test that a new output format can be created on-the-fly"""
+        num = self.map.numoutputformats
+        new_format = mapscript.outputFormatObj("GDAL/GTiff", "gtiffx")
+        # assert new_format.refcount == 1, new_format.refcount
+        self.map.appendOutputFormat(new_format)
+        assert self.map.numoutputformats == num + 1
+        # assert new_format.refcount == 2, new_format.refcount
+        self.map.selectOutputFormat("gtiffx")
+        self.map.save("testAppendNewOutputFormat.map")
+        self.map.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
+        imgobj = self.map.draw()
+        filename = "testAppendNewOutputFormat.tif"
+        imgobj.save(filename)
+
+    def testRemoveOutputFormat(self):
+        """testRemoveOutputFormat may fail depending on GD options"""
+        num = self.map.numoutputformats
+        new_format = mapscript.outputFormatObj("GDAL/GTiff", "gtiffx")
+        self.map.appendOutputFormat(new_format)
+        assert self.map.numoutputformats == num + 1
+        # assert new_format.refcount == 2, new_format.refcount
+        assert self.map.removeOutputFormat("gtiffx") == mapscript.MS_SUCCESS
+        # assert new_format.refcount == 1, new_format.refcount
+        assert self.map.numoutputformats == num
+        self.assertRaises(
+            mapscript.MapServerError, self.map.selectOutputFormat, "gtiffx"
+        )
+        self.map.selectOutputFormat("GTiff")
+        assert self.map.outputformat.mimetype == "image/tiff"
+
+    def testBuiltInPNG24Format(self):
+        """test built in PNG RGB format"""
+        self.map.selectOutputFormat("PNG24")
+        assert self.map.outputformat.mimetype == "image/png"
+        self.map.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
+        img = self.map.draw()
+        assert img.format.mimetype == "image/png"
+        filename = "testBuiltInPNG24Format.png"
+        img.save(filename)
+
+    def testBuiltInJPEGFormat(self):
+        """test built in JPEG format"""
+        self.map.selectOutputFormat("JPEG")
+        assert self.map.outputformat.mimetype == "image/jpeg"
+        self.map.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
+        img = self.map.draw()
+        assert img.format.mimetype == "image/jpeg"
+        filename = "testBuiltInJPEGFormat.jpg"
+        img.save(filename)
+
+    def testSelectBuiltInJPEGFormat(self):
+        """test selection of built-in JPEG format"""
+        self.map.selectOutputFormat("JPEG")
+        assert self.map.outputformat.mimetype == "image/jpeg"
+
+
+class UnsupportedFormatTestCase(unittest.TestCase):
+    """I (Sean) don't ever configure for PDF, so this is the unsupported
+    format."""
+
+    def testCreateUnsupported(self):
+        self.assertRaises(mapscript.MapServerError, mapscript.outputFormatObj, "PDF")
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/ows_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/ows_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/ows_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/ows_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,125 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of OWS Requests
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+import xml.dom.minidom
+
+import mapscript
+
+from .testing import MapTestCase
+
+
+class OWSRequestTestCase(MapTestCase):
+    def testInit(self):
+        """OWSRequestTestCase.testInit: OWS initializer works right"""
+        request = mapscript.OWSRequest()
+        request.setParameter("BBOX", "-0.3, 51.2, 0.3, 51.8")
+        assert request.NumParams == 1
+        assert request.getName(0) == "BBOX"
+        assert request.getValue(0) == "-0.3, 51.2, 0.3, 51.8"
+
+    def testGetParameter(self):
+        """OWSRequestTestCase.testGetParameter: OWS can get request parameters by index"""
+        request = mapscript.OWSRequest()
+        request.setParameter("foo", "bar")
+        assert request.getValue(0) == "bar"
+
+    def testGetParameterByName(self):
+        """OWSRequestTestCase.testGetParameterByName: OWS can get request parameters by name"""
+        request = mapscript.OWSRequest()
+        request.setParameter("foo", "bar")
+        assert request.getValueByName("Foo") == "bar"
+
+    def testResetParam(self):
+        """OWSRequestTestCase.testResetParam: OWS can reset parameters by name"""
+        request = mapscript.OWSRequest()
+        request.setParameter("foo", "bar")
+        assert request.NumParams == 1
+        request.setParameter("Foo", "bra")
+        assert request.NumParams == 1
+        assert request.getValue(0) == "bra"
+
+    def testLoadWMSRequest(self):
+        """OWSRequestTestCase.testLoadWMSRequest: OWS can load a WMS request"""
+        request = mapscript.OWSRequest()
+        request.setParameter("REQUEST", "GetMap")
+        request.setParameter("VERSION", "1.1.0")
+        request.setParameter("FORMAT", "image/png")
+        request.setParameter("LAYERS", "POINT")
+        request.setParameter("BBOX", "-0.30, 51.20, 0.30, 51.80")
+        request.setParameter("SRS", "EPSG:4326")
+        request.setParameter("HEIGHT", "60")
+        request.setParameter("WIDTH", "60")
+        request.setParameter("STYLES", "")
+        for i in range(self.map.numlayers):
+            self.map.getLayer(i).status = mapscript.MS_ON
+        status = self.map.loadOWSParameters(request)
+        assert status == mapscript.MS_SUCCESS, status
+        self.assertEqual(self.map.height, 60)
+        self.assertEqual(self.map.width, 60)
+        self.assertEqual(self.map.getProjection(), "+init=epsg:4326")
+        # MapServer extents are from middle of the pixel
+        self.assertAlmostEqual(self.map.extent.minx, -0.295)
+        self.assertAlmostEqual(self.map.extent.miny, 51.205)
+        self.assertAlmostEqual(self.map.extent.maxx, 0.295)
+        self.assertAlmostEqual(self.map.extent.maxy, 51.795)
+        img = self.map.draw()
+        img.save("test_load_ows_request.png")
+
+    def testWFSPostRequest(self):
+        """OWSRequestTestCase.testLoadWMSRequest: OWS can POST a WFS request"""
+
+        self.map.web.metadata.set("ows_onlineresource", "http://dummy.org/")
+        request = mapscript.OWSRequest()
+        request.contenttype = "application/xml"
+
+        post_data = """<wfs:GetFeature xmlns:wfs="http://www.opengis.net/wfs" xmlns:ogc="http://www.opengis.net/ogc" service="WFS"
+        version="1.1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+        <wfs:Query typeName="*:POINT" xmlns:feature="http://www.openplans.org/topp">
+            <ogc:Filter>
+                <ogc:PropertyIsEqualTo>
+                    <ogc:PropertyName>FID</ogc:PropertyName>
+                    <ogc:Literal>1</ogc:Literal>
+                </ogc:PropertyIsEqualTo>
+            </ogc:Filter>
+        </wfs:Query>
+        </wfs:GetFeature>
+        """
+
+        qs = ""  # additional parameters can be passed via the querystring
+        request.loadParamsFromPost(post_data, qs)
+        mapscript.msIO_installStdoutToBuffer()
+        status = self.map.OWSDispatch(request)
+        assert status == mapscript.MS_SUCCESS, status
+
+        mapscript.msIO_stripStdoutBufferContentHeaders()
+        result = mapscript.msIO_getStdoutBufferBytes()
+        dom = xml.dom.minidom.parseString(result)
+        assert len(dom.getElementsByTagName("ms:POINT")) == 1
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/parentreference_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/parentreference_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/parentreference_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/parentreference_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,118 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map
+# Author:   Umberto Nicoletti, unicoletti@prometeo.it
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import gc
+import unittest
+
+import mapscript
+
+from .testing import TESTMAPFILE
+
+
+class ParentReferenceTestCase(unittest.TestCase):
+    def initMap(self):
+        self.map = mapscript.mapObj(TESTMAPFILE)
+
+    def testGetLayerObj(self):
+        self.initMap()
+        layer = self.map.getLayer(1)
+        self.map = None
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
+        gc.collect()
+        assert layer.map is not None, layer.map
+
+    def testGetLayerObjByName(self):
+        self.initMap()
+        layer = self.map.getLayerByName("POLYGON")
+        self.map = None
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
+        gc.collect()
+        assert layer.map is not None, layer.map
+
+    def testLayerObj(self):
+        self.initMap()
+        layer = mapscript.layerObj(self.map)
+        self.map = None
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
+        gc.collect()
+        assert layer.map is not None, layer.map
+
+    def testInsertLayerObj(self):
+        self.initMap()
+        layer = mapscript.layerObj()
+        self.map.insertLayer(layer)
+        self.map = None
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
+        gc.collect()
+        assert layer.map is not None, layer.map
+
+    def testGetClassObj(self):
+        self.initMap()
+        layer = self.map.getLayer(1)
+        clazz = layer.getClass(0)
+        self.map = None
+        layer = None
+        assert str(clazz.p_layer).find("mapscript.layerObj") != -1
+        gc.collect()
+        assert clazz.layer is not None, clazz.layer
+
+    def testClassObj(self):
+        self.initMap()
+        layer = mapscript.layerObj(self.map)
+        clazz = mapscript.classObj(layer)
+        self.map = None
+        layer = None
+        assert str(clazz.p_layer).find("mapscript.layerObj") != -1
+        gc.collect()
+        assert clazz.layer is not None, clazz.layer
+
+    def testInsertClassObj(self):
+        self.initMap()
+        layer = mapscript.layerObj()
+        clazz = mapscript.classObj()
+        layer.insertClass(clazz)
+        self.map = None
+        layer = None
+        assert str(clazz.p_layer).find("mapscript.layerObj") != -1
+        gc.collect()
+        assert clazz.layer is not None, clazz.layer
+
+    def testRemoveClassObj(self):
+        self.initMap()
+        layer = self.map.getLayer(1)
+        clazz = layer.removeClass(0)
+        if hasattr(clazz, "p_layer"):
+            assert clazz.p_layer is None, clazz.p_layer
+        assert clazz.layer is None, clazz.layer
+        self.initMap()
+        position = self.map.getLayer(0).insertClass(clazz)
+        assert position == 0, position
+        assert clazz.p_layer is not None, clazz.p_layer
+        assert clazz.layer is not None, clazz.layer
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/pgtest.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/pgtest.py
--- 8.0.1-5/src/mapscript/python/tests/cases/pgtest.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/pgtest.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,131 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of PostGIS Layer
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+#
+# Execute this module as a script from mapserver/mapscript/python
+#
+#     python tests/cases/pgtest.py -v
+#
+# NOTE: these tests use a fixture included in mapserver/tests. To produce
+# the testing database, follow these steps:
+#
+# $ cd mapserver/tests
+# $ shp2pgsql -s 4326 -I polygon.shp postgis.polygon > polygon.sql
+# $ su postgres
+# $ make -f makefile_postgis
+#
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+PG_CONNECTION_STRING = "dbname=mapserver_test user=postgres"
+
+
+class TableTest(unittest.TestCase):
+    def setUp(self):
+        self.mo = mapscript.mapObj()
+        lo = mapscript.layerObj()
+        lo.name = "pg_layer"
+        lo.type = mapscript.MS_LAYER_POLYGON
+        lo.connectiontype = mapscript.MS_POSTGIS
+        lo.connection = PG_CONNECTION_STRING
+        lo.data = "the_geom from polygon"
+        li = self.mo.insertLayer(lo)
+        self.lo = self.mo.getLayer(li)
+
+    def test_getfeature(self):
+        self.lo.open()
+        f = self.lo.getFeature(1, -1)
+        atts = [f.getValue(i) for i in range(self.lo.numitems)]
+        self.lo.close()
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
+
+
+class ViewTest(unittest.TestCase):
+    def setUp(self):
+        self.mo = mapscript.mapObj()
+        lo = mapscript.layerObj()
+        lo.name = "pg_sub_layer"
+        lo.type = mapscript.MS_LAYER_POLYGON
+        lo.connectiontype = mapscript.MS_POSTGIS
+        lo.connection = PG_CONNECTION_STRING
+        lo.data = "the_geom from polygon_v using unique gid using srid=4326"
+        li = self.mo.insertLayer(lo)
+        self.lo = self.mo.getLayer(li)
+
+    def test_getfeature(self):
+        self.lo.open()
+        f = self.lo.getFeature(1, -1)
+        atts = [f.getValue(i) for i in range(self.lo.numitems)]
+        self.lo.close()
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
+
+
+class SubSelectTest(unittest.TestCase):
+    def setUp(self):
+        self.mo = mapscript.mapObj()
+        lo = mapscript.layerObj()
+        lo.name = "pg_sub_layer"
+        lo.type = mapscript.MS_LAYER_POLYGON
+        lo.connectiontype = mapscript.MS_POSTGIS
+        lo.connection = PG_CONNECTION_STRING
+        lo.data = "the_geom from (select * from polygon) as foo using unique gid using srid=4326"
+        li = self.mo.insertLayer(lo)
+        self.lo = self.mo.getLayer(li)
+
+    def test_getfeature(self):
+        self.lo.open()
+        f = self.lo.getFeature(1, -1)
+        atts = [f.getValue(i) for i in range(self.lo.numitems)]
+        self.lo.close()
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
+
+
+class SubSelectNoSRIDTest(unittest.TestCase):
+    """SRID should be diagnosed from the selection"""
+
+    def setUp(self):
+        self.mo = mapscript.mapObj()
+        lo = mapscript.layerObj()
+        lo.name = "pg_sub_layer"
+        lo.type = mapscript.MS_LAYER_POLYGON
+        lo.connectiontype = mapscript.MS_POSTGIS
+        lo.connection = PG_CONNECTION_STRING
+        lo.data = "the_geom from (select * from polygon) as foo using unique gid"
+        li = self.mo.insertLayer(lo)
+        self.lo = self.mo.getLayer(li)
+
+    def test_getfeature(self):
+        self.lo.open()
+        f = self.lo.getFeature(1, -1)
+        atts = [f.getValue(i) for i in range(self.lo.numitems)]
+        self.lo.close()
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/point_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/point_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/point_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/point_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,165 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Point
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+have_image = False
+
+try:
+    from PIL import Image
+
+    have_image = True
+except ImportError:
+    pass
+
+
+class PointObjTestCase(unittest.TestCase):
+    def testPointObjConstructorNoArgs(self):
+        """point can be created with no arguments"""
+        p = mapscript.pointObj()
+        self.assertAlmostEqual(p.x, 0.0)
+        self.assertAlmostEqual(p.y, 0.0)
+
+    def testPointObjConstructorArgs(self):
+        """point can be created with arguments"""
+        p = mapscript.pointObj(1.0, 1.0)
+        self.assertAlmostEqual(p.x, 1.0)
+        self.assertAlmostEqual(p.y, 1.0)
+
+    def testSetXY(self):
+        """point can have its x and y reset"""
+        p = mapscript.pointObj()
+        p.setXY(1.0, 1.0)
+        self.assertAlmostEqual(p.x, 1.0)
+        self.assertAlmostEqual(p.y, 1.0)
+        if hasattr(p, "m"):
+            self.assertAlmostEqual(p.m, -2e38)
+
+    def testSetXYM(self):
+        """point can have its x and y reset (with m value)"""
+        p = mapscript.pointObj()
+        p.setXY(1.0, 1.0, 1.0)
+        self.assertAlmostEqual(p.x, 1.0)
+        self.assertAlmostEqual(p.y, 1.0)
+        if hasattr(p, "m"):
+            self.assertAlmostEqual(p.m, 1.0)
+
+    def testSetXYZ(self):
+        """point can have its x, y, z reset (with m value)"""
+        p = mapscript.pointObj()
+        p.setXYZ(1.0, 2.0, 3.0, 4.0)
+        self.assertAlmostEqual(p.x, 1.0)
+        self.assertAlmostEqual(p.y, 2.0)
+        if hasattr(p, "z") and hasattr(p, "m"):
+            self.assertAlmostEqual(p.z, 3.0)
+            self.assertAlmostEqual(p.m, 4.0)
+
+    def testPointDraw(self):
+        """Can create a point, add to a layer, and draw it directly"""
+
+        map_string = """
+        MAP
+            EXTENT 0 0 90 90
+            SIZE 500 500
+
+            SYMBOL
+            NAME "circle"
+            TYPE ELLIPSE
+            POINTS 1 1 END
+            FILLED true
+            END
+
+            LAYER
+            NAME "punkt"
+            STATUS ON
+            TYPE POINT
+            END
+
+        END"""
+
+        test_map = mapscript.fromstring(map_string)
+        layer = test_map.getLayerByName("punkt")
+        cls = mapscript.classObj()
+        style = mapscript.styleObj()
+        style.outlinecolor.setHex("#00aa00ff")
+        style.size = 10
+        style.setSymbolByName(test_map, "circle")
+
+        cls.insertStyle(style)
+        class_idx = layer.insertClass(cls)
+        point = mapscript.pointObj(45, 45)
+
+        img = test_map.prepareImage()
+        point.draw(test_map, layer, img, class_idx, "test")
+
+        filename = "testDrawPoint.png"
+        with open(filename, "wb") as fh:
+            img.write(fh)
+
+        if have_image:
+            pyimg = Image.open(filename)
+            assert pyimg.size == (500, 500)
+
+    def testPoint__str__(self):
+        """return properly formatted string"""
+        p = mapscript.pointObj(1.0, 1.0)
+        if hasattr(p, "z"):
+            p_str = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g }" % (p.x, p.y, p.z)
+        else:
+            p_str = "{ 'x': %.16g, 'y': %.16g }" % (p.x, p.y)
+        assert str(p) == p_str, str(p)
+
+    def testPointToString(self):
+        """return properly formatted string in toString()"""
+        p = mapscript.pointObj(1.0, 1.0, 0.002, 15.0)
+        if hasattr(p, "z") and hasattr(p, "m"):
+            p_str = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g, 'm': %.16g }" % (
+                p.x,
+                p.y,
+                p.z,
+                p.m,
+            )
+        else:
+            p_str = "{ 'x': %.16g, 'y': %.16g }" % (p.x, p.y)
+
+        assert p.toString() == p_str, p.toString()
+
+    def testPointGeoInterface(self):
+        """return point using the  __geo_interface__ protocol"""
+        p = mapscript.pointObj(1.0, 1.0, 0.002, 15.0)
+        if hasattr(p, "z"):
+            assert p.__geo_interface__ == {
+                "type": "Point",
+                "coordinates": (1.0, 1.0, 0.002),
+            }
+        else:
+            assert p.__geo_interface__ == {"type": "Point", "coordinates": (1.0, 1.0)}
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/rect_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/rect_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/rect_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/rect_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,142 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of rectObj
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapPrimitivesTestCase
+
+
+class RectObjTestCase(MapPrimitivesTestCase):
+    def testRectObjConstructorNoArgs(self):
+        """a rect can be initialized with no args"""
+        r = mapscript.rectObj()
+        self.assertAlmostEqual(r.minx, -1.0)
+        self.assertAlmostEqual(r.miny, -1.0)
+        self.assertAlmostEqual(r.maxx, -1.0)
+        self.assertAlmostEqual(r.maxy, -1.0)
+
+    def testRectObjConstructorArgs(self):
+        """a rect can be initialized with arguments"""
+        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
+        self.assertAlmostEqual(r.minx, -1.0)
+        self.assertAlmostEqual(r.miny, -2.0)
+        self.assertAlmostEqual(r.maxx, 3.0)
+        self.assertAlmostEqual(r.maxy, 4.0)
+
+    def testRectObjConstructorBadXCoords(self):
+        """an invalid extent raises proper error (x direction)"""
+        self.assertRaises(
+            mapscript.MapServerError, mapscript.rectObj, 1.0, -2.0, -3.0, 4.0
+        )
+
+    def testRectObjConstructorBadYCoords(self):
+        """an invalid extent raises proper error (y direction)"""
+        self.assertRaises(
+            mapscript.MapServerError, mapscript.rectObj, -1.0, 2.0, 3.0, -2.0
+        )
+
+    def testRectObjToPolygon(self):
+        """a rect can be converted into a MS_POLYGON shape"""
+        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
+        s = r.toPolygon()
+        assert s.numlines == 1, s.numlines
+        line = self.getLineFromShape(s, 0)
+        assert line.numpoints == 5, line.numpoints
+        point = self.getPointFromLine(line, 0)
+        self.assertAlmostEqual(point.x, -1.0)
+        self.assertAlmostEqual(point.y, -2.0)
+
+    def testExceptionMessage(self):
+        """test formatted error message"""
+        try:
+            r = mapscript.rectObj(1.0, -2.0, -3.0, 4.0)
+            print(r)
+        except mapscript.MapServerError as msg:
+            assert (
+                str(msg) == "rectObj(): Invalid rectangle. { 'minx': 1.000000 , "
+                "'miny': -2.000000 , 'maxx': -3.000000 , 'maxy': 4.000000 }"
+            ), msg
+
+    def testRect__str__(self):
+        """__str__ returns properly formatted string"""
+        r = mapscript.rectObj(-1.0, -2.0, 3.0001, 4.0)
+        r_str = str(r)
+        assert (
+            r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }"
+        ), r_str
+        r2 = eval(r_str)
+        self.assertAlmostEqual(r2["minx"], r.minx)
+        self.assertAlmostEqual(r2["miny"], r.miny)
+        self.assertAlmostEqual(r2["maxx"], r.maxx)
+        self.assertAlmostEqual(r2["maxy"], r.maxy)
+
+    def testRectToString(self):
+        """return properly formatted string"""
+        r = mapscript.rectObj(-1.0, -2.0, 3.0001, 4.0)
+        r_str = r.toString()
+        assert (
+            r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }"
+        ), r_str
+
+    def testRectContainsPoint(self):
+        """point is contained (spatially) in rectangle"""
+        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
+        p = mapscript.pointObj(0.0, 0.0)
+        assert p in r, (p.x, p.y, r)
+
+    def testRectContainsPointNot(self):
+        """point is not contained (spatially) in rectangle"""
+        r = mapscript.rectObj(-1.0, -2.0, 3.0, 4.0)
+        p = mapscript.pointObj(3.00001, 0.0)
+        assert p not in r, (p.x, p.y, r)
+
+
+class ImageRectObjTestCase(MapPrimitivesTestCase):
+    def testRectObjConstructorArgs(self):
+        """create a rect in image units"""
+        r = mapscript.rectObj(-1.0, 2.0, 3.0, 0.0, mapscript.MS_TRUE)
+        self.assertAlmostEqual(r.minx, -1.0)
+        self.assertAlmostEqual(r.miny, 2.0)
+        self.assertAlmostEqual(r.maxx, 3.0)
+        self.assertAlmostEqual(r.maxy, 0.0)
+
+    def testRectObjConstructorBadYCoords(self):
+        """in image units miny should be greater than maxy"""
+        self.assertRaises(
+            mapscript.MapServerError,
+            mapscript.rectObj,
+            -1.0,
+            0.0,
+            3.0,
+            2.0,
+            mapscript.MS_TRUE,
+        )
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/refcount_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/refcount_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/refcount_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/refcount_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,320 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map
+# Author:   Umberto Nicoletti, unicoletti@prometeo.it
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import TESTMAPFILE
+
+
+class ReferenceCountingTestCase(unittest.TestCase):
+    def initMap(self):
+        self.map = mapscript.mapObj(TESTMAPFILE)
+
+    def testMap(self):
+        """ReferenceCountingTestCase.testMap: test map constructor with no argument"""
+        test_map = mapscript.mapObj()
+        assert test_map.__class__.__name__ == "mapObj"
+        assert test_map.thisown == 1
+        assert test_map.refcount == 1
+
+    def testMapWithDefaultMap(self):
+        """ReferenceCountingTestCase.testTestMap: test map constructor with default map file"""
+        test_map = mapscript.mapObj(TESTMAPFILE)
+        assert test_map.__class__.__name__ == "mapObj"
+        assert test_map.thisown == 1
+        assert test_map.refcount == 1
+        assert test_map.getLayer(0).refcount == 2
+
+    def testMapLayersCounting(self):
+        """ReferenceCountingTestCase.testTestMap: test map constructor with default map file"""
+        self.initMap()
+        layerRef1 = self.map.getLayer(0)
+        assert layerRef1.refcount == 2
+        layerRef2 = self.map.getLayer(0)
+        assert layerRef2.refcount == 3
+
+    def testMapInsertedLayer(self):
+        """MapLayersTestCase.testMapInsertedLayer: test insertion of a new layer at default (last) index"""
+        self.initMap()
+        n = self.map.numlayers
+        layer = mapscript.layerObj()
+        layer.name = "new"
+        assert layer.refcount == 1
+        assert layer.thisown == 1
+        index = self.map.insertLayer(layer)
+        assert index == n, index
+        assert self.map.numlayers == n + 1
+        assert layer.refcount == 2
+        assert layer.thisown == 1
+        assert self.map.getLayer(index).refcount == 3
+        assert self.map.getLayer(index).thisown == 1
+        assert layer.refcount == 2
+        assert layer.thisown == 1
+
+    def testMapInsertedLayerWithIndex(self):
+        """MapLayersTestCase.testMapInsertedLayerWithIndex: test insertion of a new layer at index 0"""
+        self.initMap()
+        n = self.map.numlayers
+        layer = mapscript.layerObj()
+        layer.name = "new"
+        assert layer.refcount == 1
+        assert layer.thisown == 1
+        index = self.map.insertLayer(layer, 0)
+        assert index == 0, index
+        assert self.map.numlayers == n + 1
+        assert layer.refcount == 2
+        assert layer.thisown == 1
+        assert self.map.getLayer(index).refcount == 3
+        assert self.map.getLayer(index).thisown == 1
+        assert layer.refcount == 2
+        assert layer.thisown == 1
+
+    def testMapRemovedLayerAtTail(self):
+        """removal of highest index (tail) layer"""
+        self.initMap()
+        n = self.map.numlayers
+        layer = self.map.removeLayer(n - 1)
+        assert self.map.numlayers == n - 1
+        assert layer.name == "INLINE-PIXMAP-PCT"
+        assert layer.thisown == 1
+        assert layer.refcount == 1, layer.refcount
+        self.map.draw()
+
+    def testMapRemovedLayerAtZero(self):
+        """removal of lowest index (0) layer"""
+        self.initMap()
+        n = self.map.numlayers
+        layer = self.map.removeLayer(0)
+        assert self.map.numlayers == n - 1
+        assert layer.name == "RASTER"
+        assert layer.thisown == 1
+        assert layer.refcount == 1, layer.refcount
+        self.map.draw()
+
+    def testBehaveWhenParentIsNull(self):
+        """behave when parent (map) is null"""
+        self.initMap()
+        layer = mapscript.layerObj()
+        layer.name = "new"
+        index = self.map.insertLayer(layer, 0)
+        assert index == 0, index
+        self.map = None
+        assert layer.map is not None, layer.map
+        exception = None
+        try:
+            layer.open()
+        except Exception:
+            # must fail because the new layer is missing information
+            exception = True
+        assert exception is True
+
+    def testLayerClone(self):
+        """Clone a layer"""
+        layer = mapscript.layerObj()
+        layer.name = "sample"
+        copy = layer.clone()
+
+        assert layer.refcount == 1, layer.refcount
+        assert copy.refcount == 1, copy.refcount
+        assert layer.name == copy.name
+        assert copy.map is None
+
+    def testMapGetLayerByName(self):
+        """behave when parent (map) is null"""
+        self.initMap()
+        layer = self.map.getLayerByName("RASTER")
+
+        assert layer.refcount == 2, layer.refcount
+        assert layer.thisown == 1, layer.thisown
+
+    def testBehaveWhenParentIsNotNull(self):
+        """behave when parent (map) is not null"""
+        self.initMap()
+        layer = mapscript.layerObj(self.map)
+        layer.name = "new"
+        assert layer.refcount == 2, layer.refcount
+
+    def testDummyClass(self):
+        """basic refcounting for classObj"""
+        clazz = mapscript.classObj()
+        assert clazz.refcount == 1, clazz.refcount
+
+    def testClassWithArgument(self):
+        """classObj constructor with not null layer"""
+        self.initMap()
+        clazz = mapscript.classObj(self.map.getLayer(0))
+        assert clazz.refcount == 2, clazz.refcount
+
+    def testClassGetter(self):
+        """classObj getter"""
+        self.initMap()
+        clazz = self.map.getLayer(1).getClass(0)
+        assert clazz.refcount == 2, clazz.refcount
+
+    def testClassClone(self):
+        """classObj clone"""
+        self.initMap()
+        clazz = self.map.getLayer(1).getClass(0)
+        assert clazz.refcount == 2, clazz.refcount
+        clone = clazz.clone()
+        assert clone.refcount == 1, clone.refcount
+
+    def testClassInsert(self):
+        """classObj insert at end"""
+        self.initMap()
+        clazz = mapscript.classObj()
+        clazz.minscaledenom = 666
+        assert clazz.refcount == 1, clazz.refcount
+        idx = self.map.getLayer(1).insertClass(clazz)
+        assert clazz.refcount == 2, clazz.refcount
+        assert self.map.getLayer(1).getClass(idx).refcount == 3, (
+            self.map.getLayer(1).getClass(idx).refcount
+        )
+        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, (
+            self.map.getLayer(1).getClass(idx).minscaledenom
+        )
+
+    def testClassInsertAtMiddle(self):
+        """classObj insert at pos. 1"""
+        self.initMap()
+        clazz = mapscript.classObj()
+        clazz.minscaledenom = 666
+        assert clazz.refcount == 1, clazz.refcount
+        idx = self.map.getLayer(1).insertClass(clazz, 1)
+        assert idx == 1, idx
+        assert clazz.refcount == 2, clazz.refcount
+        assert self.map.getLayer(1).getClass(idx).refcount == 3, (
+            self.map.getLayer(1).getClass(idx).refcount
+        )
+        assert self.map.getLayer(1).getClass(idx).thisown, (
+            self.map.getLayer(1).getClass(idx).thisown
+        )
+        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, (
+            self.map.getLayer(1).getClass(idx).minscaledenom
+        )
+
+    def testRemoveFirstClass(self):
+        """removal of first class"""
+        self.initMap()
+        clazz = self.map.getLayerByName("POLYGON").removeClass(0)
+        assert clazz is not None
+        assert clazz.thisown == 1
+        assert clazz.refcount == 1, clazz.refcount
+        self.map.draw()
+
+    def testMapClone(self):
+        """cloning a mapObj"""
+        self.initMap()
+        clone = self.map.clone()
+        assert clone.refcount == 1, clone.refcount
+
+    def testStyleGetter(self):
+        """styleObj getter"""
+        self.initMap()
+        style = self.map.getLayer(1).getClass(0).getStyle(0)
+        assert style.refcount == 2, style.refcount
+        assert style.thisown == 1, style.thisown
+
+    def testStyleConstructor(self):
+        """styleObj Constructor"""
+        self.initMap()
+        style = mapscript.styleObj(self.map.getLayer(1).getClass(0))
+        assert style.refcount == 2, style.refcount
+        assert style.thisown == 1, style.thisown
+        style = mapscript.styleObj()
+        assert style.refcount == 1, style.refcount
+        assert style.thisown == 1, style.thisown
+
+    def testRemoveStyleAtBeginning(self):
+        """styleObj remove first one"""
+        self.initMap()
+        style = mapscript.styleObj()
+        assert style.refcount == 1, style.refcount
+        assert style.thisown == 1, style.thisown
+        self.map.getLayer(1).getClass(0).insertStyle(style)
+        assert style.refcount == 2, style.refcount
+        assert style.thisown == 1, style.thisown
+        style = self.map.getLayer(1).getClass(0).removeStyle(0)
+        assert style.refcount == 1, style.refcount
+        assert style.thisown == 1, style.thisown
+
+    def testInsertStyle(self):
+        """styleObj Insert"""
+        self.initMap()
+        style = mapscript.styleObj()
+        assert style.refcount == 1, style.refcount
+        assert style.thisown == 1, style.thisown
+        self.map.getLayer(1).getClass(0).insertStyle(style)
+        assert style.refcount == 2, style.refcount
+        assert style.thisown == 1, style.thisown
+
+    def testCloneStyle(self):
+        """styleObj Clone"""
+        self.initMap()
+        style = mapscript.styleObj()
+        assert style.refcount == 1, style.refcount
+        assert style.thisown == 1, style.thisown
+        clone = style.clone()
+        assert clone.refcount == 1, clone.refcount
+        assert clone.thisown == 1, clone.thisown
+        assert style.refcount == 1, style.refcount
+        assert style.thisown == 1, style.thisown
+        style = self.map.getLayer(1).getClass(0).getStyle(0)
+        clone = style.clone()
+        assert clone.refcount == 1, clone.refcount
+        assert clone.thisown == 1, clone.thisown
+
+    def testBasicSymbolRefcounting(self):
+        """symbolObj refcounting"""
+        self.initMap()
+        symb = self.map.symbolset.getSymbol(0)
+        assert symb.refcount == 2, symb.refcount
+        assert symb.thisown == 1, symb.thisown
+        symb = self.map.symbolset.getSymbolByName("home-png")
+        assert symb.refcount == 2, symb.refcount
+        assert symb.thisown == 1, symb.thisown
+        symb2 = self.map.symbolset.getSymbolByName("home-png")
+        assert symb2.refcount == 3, symb2.refcount
+        assert symb2.thisown == 1, symb2.thisown
+
+    def testSymbolAppendRemove(self):
+        """appendSymbolObj refcounting"""
+        self.initMap()
+        symb = mapscript.symbolObj("ANEWSYMBOL")
+        assert symb.refcount == 1, symb.refcount
+        assert symb.thisown == 1, symb.thisown
+        idx = self.map.symbolset.appendSymbol(symb)
+        assert symb.refcount == 2, symb.refcount
+        assert symb.thisown == 1, symb.thisown
+        symb = self.map.symbolset.removeSymbol(idx)
+        assert symb.refcount == 1, symb.refcount
+        assert symb.thisown == 1, symb.thisown
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/resultcache_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/resultcache_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/resultcache_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/resultcache_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,143 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of ResultCache
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapTestCase
+
+
+class LayerQueryTestCase(MapTestCase):
+    def setUp(self):
+        MapTestCase.setUp(self)
+        self.layer = self.map.getLayer(1)
+        self.layer.template = "some day i will fix this!"
+
+    def pointquery(self):
+        p = mapscript.pointObj(0.0, 51.5)
+        self.layer.queryByPoint(self.map, p, mapscript.MS_MULTIPLE, -1)
+        return self.layer.getResults()
+
+    def indexquery(self):
+        self.layer.queryByIndex(self.map, -1, 0, mapscript.MS_TRUE)
+        return self.layer.getResults()
+
+
+class ResultCacheTestCase(LayerQueryTestCase):
+    def testNoDirectAccess(self):
+        """denying direct access to layer's resultcache"""
+        self.assertRaises(AttributeError, getattr, self.layer, "resultcache")
+
+    def testNullResultCache(self):
+        """before a query layer's resultcache should be NULL"""
+        results = self.layer.getResults()
+        assert results is None
+
+
+class PointQueryResultsTestCase(LayerQueryTestCase):
+    def testCacheAfterQuery(self):
+        """simple point query returns one result"""
+        results = self.pointquery()
+        assert results.numresults == 1
+
+    def testCacheAfterFailedQuery(self):
+        """point query with no results returns NULL"""
+        p = mapscript.pointObj(0.0, 0.0)
+        self.layer.queryByPoint(self.map, p, mapscript.MS_MULTIPLE, -1)
+        results = self.layer.getResults()
+        assert results is None
+
+    def testDeletionOfResults(self):
+        """deleting results should not harm the layer"""
+        results = self.pointquery()
+        assert results.thisown == 0
+        del results
+        results = self.layer.getResults()
+        assert results.numresults == 1
+
+    def testQueryResultBounds(self):
+        """result bounds should equal layer bounds"""
+        results = self.pointquery()
+        e = self.layer.getExtent()
+        self.assertRectsEqual(results.bounds, e)
+
+    def testQueryResultMembers(self):
+        """get the single result member"""
+        results = self.pointquery()
+        self.layer.open()
+        res = results.getResult(0)
+        feature = self.layer.getShape(res)
+        self.layer.close()
+        self.assertRectsEqual(results.bounds, feature.bounds)
+        assert feature.getValue(1) == "A Polygon"
+
+    def testQueryResultsListComp(self):
+        """get all results using list comprehension"""
+        results = self.pointquery()
+        result_list = [results.getResult(i) for i in range(results.numresults)]
+        assert len(result_list) == 1
+        assert result_list[0].shapeindex == 0
+
+    def testQueryByIndex(self):
+        """pop a result into the result set"""
+        self.layer.queryByIndex(self.map, -1, 0, mapscript.MS_FALSE)
+        results = self.layer.getResults()
+        assert results.numresults == 1
+        self.layer.queryByIndex(self.map, -1, 0, mapscript.MS_TRUE)
+        results = self.layer.getResults()
+        assert results.numresults == 2
+
+
+class DumpAndLoadTestCase(LayerQueryTestCase):
+    def testSaveAndLoadQuery(self):
+        """test saving query to a file"""
+        results = self.pointquery()
+        self.map.saveQuery("test.qy")
+        self.map.freeQuery()
+        results = self.layer.getResults()
+        assert results is None
+        self.map.loadQuery("test.qy")
+        results = self.layer.getResults()
+        assert results is not None
+
+
+class LayerOffQueryTestCase(LayerQueryTestCase):
+    def testPointQueryOffLayer(self):
+        """simple point query returns one result, even if layer is off"""
+        self.layer.status = mapscript.MS_OFF
+        results = self.pointquery()
+        assert results.numresults == 1
+
+    def testIndexQueryOffLayer(self):
+        """simple index query returns one result, even if layer is off"""
+        self.layer.status = mapscript.MS_OFF
+        results = self.indexquery()
+        assert results.numresults == 1
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/shape_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/shape_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/shape_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/shape_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,187 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Shape
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapTestCase, ShapeObjTestCase
+
+
+class ShapePointTestCase(ShapeObjTestCase):
+    """Test point type shapeObj in stand-alone mode"""
+
+    def setUp(self):
+        """The test fixture is a shape of one point"""
+        self.points = (mapscript.pointObj(0.0, 1.0),)
+        self.lines = (mapscript.lineObj(),)
+        self.addPointToLine(self.lines[0], self.points[0])
+        self.shape = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
+        self.addLineToShape(self.shape, self.lines[0])
+
+    def testCreateShape(self):
+        """the number of lines is correct"""
+        assert self.shape.numlines == 1
+
+    def testShapeClone(self):
+        """test shape can be copied"""
+        s = self.shape.clone()
+        self.assertShapesEqual(self.shape, s)
+
+
+class InlineFeatureTestCase(MapTestCase):
+    """tests for issue http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=562"""
+
+    def testAddPointFeature(self):
+        """adding a point to an inline feature works correctly"""
+        inline_layer = self.map.getLayerByName("INLINE")
+        assert inline_layer.connectiontype == mapscript.MS_INLINE
+        p = mapscript.pointObj(0.2, 51.5)
+        lyr = mapscript.lineObj()
+        self.addPointToLine(lyr, p)
+        shape = mapscript.shapeObj(inline_layer.type)
+        shape.classindex = 0
+        self.addLineToShape(shape, lyr)
+        inline_layer.addFeature(shape)
+        msimg = self.map.draw()
+        filename = "testAddPointFeature.png"
+        msimg.save(filename)
+
+    def testGetShape(self):
+        """returning the shape from an inline feature works"""
+        inline_layer = self.map.getLayerByName("INLINE")
+        inline_layer.open()
+        inline_layer.template = "FAKE"
+        inline_layer.queryByIndex(self.map, -1, 0)
+        res = inline_layer.getResult(0)
+        s = inline_layer.getShape(res)
+        lyr = self.getLineFromShape(s, 0)
+        p = self.getPointFromLine(lyr, 0)
+        self.assertAlmostEqual(p.x, -0.2)
+        self.assertAlmostEqual(p.y, 51.5)
+
+    def testGetNumFeatures(self):
+        """the number of features in the inline layer is correct"""
+        inline_layer = self.map.getLayerByName("INLINE")
+        assert inline_layer.getNumFeatures() == 1
+
+    def testShapeGeoInterface(self):
+        """return the shape using the  __geo_interface__ protocol with no attribute names"""
+        layer = self.map.getLayerByName("POLYGON")
+        layer.open()
+        layer.template = "FAKE"
+        layer.queryByIndex(self.map, -1, 0)
+        res = layer.getResult(0)
+        s = layer.getShape(res)
+        assert s.__geo_interface__ == {
+            "geometry": {
+                "type": "Polygon",
+                "coordinates": [
+                    [
+                        (-0.25, 51.227222, 0.0),
+                        (-0.25, 51.727222, 0.0),
+                        (0.25, 51.727222, 0.0),
+                        (0.25, 51.227222, 0.0),
+                        (-0.25, 51.227222, 0.0),
+                    ]
+                ],
+            },
+            "type": "Feature",
+            "bbox": (-0.25, 51.227222, 0.25, 51.727222),
+            "properties": {"1": "A Polygon", "0": "1"},
+        }
+
+        layer.close()
+
+    def testShapeGeoInterfaceWithFields(self):
+        """return the shape using the  __geo_interface__ protocol with attribute names"""
+        layer = self.map.getLayerByName("POINT")
+        layer.open()
+        layer.template = "FAKE"
+        layer.queryByIndex(self.map, -1, 0)
+        res = layer.getResult(0)
+        s = layer.getShape(res)
+        s.itemdefinitions = layer.getItemDefinitions()
+        assert s.__geo_interface__ == {
+            "geometry": {"type": "Point", "coordinates": [[(0.0, 51.477222, 0.0)]]},
+            "type": "Feature",
+            "bbox": (0.0, 51.477222, 0.0, 51.477222),
+            "properties": {"FNAME": "A Point", "FID": 1},
+        }
+
+        layer.close()
+
+
+class ShapeValuesTestCase(unittest.TestCase):
+    def testNullValue(self):
+        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
+        assert so.numvalues == 0
+        assert so.getValue(0) is None
+
+    def testSetValue(self):
+        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
+        so.initValues(4)
+        so.setValue(0, "Foo")
+        assert so.numvalues == 4
+        assert so.getValue(0) == "Foo"
+        assert so.getValue(1) == ""
+
+
+# New class for testing the WKT stuff of RFC-2
+class ShapeWKTTestCase(unittest.TestCase):
+
+    # define a pair of coords, and WKT as class data
+    point_xy = (-105.5000000000000000, 40.0000000000000000)
+    point_wkt = "POINT (-105.5000000000000000 40.0000000000000000)"
+
+    def testSetPointWKT(self):
+        # Create new instance and set/init from WKT
+        so = mapscript.shapeObj.fromWKT(self.point_wkt)
+
+        # expect one line with one point
+        self.assertTrue(so.numlines == 1, so.numlines)
+        self.assertTrue(so.get(0).numpoints == 1, so.get(0).numpoints)
+
+        # expect shape's x and y values to be correct
+        po = so.get(0).get(0)
+        self.assertAlmostEqual(po.x, self.point_xy[0])
+        self.assertAlmostEqual(po.y, self.point_xy[1])
+
+    def testGetPointWKT(self):
+        # Create new instance from class data
+        po = mapscript.pointObj(self.point_xy[0], self.point_xy[1])
+        lo = mapscript.lineObj()
+        lo.add(po)
+        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
+        so.add(lo)
+
+        # test output WKT
+        wkt = so.toWKT()
+        self.assertTrue(wkt == self.point_wkt, wkt)
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/shapefile_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/shapefile_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/shapefile_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/shapefile_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,54 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of shapefileObj
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import os
+import unittest
+
+import mapscript
+
+from .testing import TESTS_PATH
+
+
+class AddShapeTestCase(unittest.TestCase):
+    def testAddEmpty(self):
+        """expect an error rather than segfault when adding an empty shape"""
+        # See bug 1201
+        sf = mapscript.shapefileObj("testAddDud.shp", 1)
+        so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
+        self.assertRaises(mapscript.MapServerError, sf.add, so)
+
+    def testGetDBFInfo(self):
+        """Fetch dbf information from shapefile"""
+        pth = os.path.join(TESTS_PATH, "polygon.shp")
+        sf = mapscript.shapefileObj(pth)
+        assert sf.getDBF() is not None, sf.getDBF()
+        assert sf.getDBF().nFields == 2, sf.getDBF().nFields
+        assert sf.getDBF().getFieldName(0) == "FID", sf.getDBF().getFieldName(0)
+        assert sf.getDBF().getFieldName(1) == "FNAME", sf.getDBF().getFieldName(1)
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/style_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/style_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/style_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/style_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,294 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map Styles
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapTestCase
+
+
+class DrawProgrammedStylesTestCase(MapTestCase):
+    def testDrawPoints(self):
+        """DrawProgrammedStylesTestCase.testDrawPoints: point drawing with styles works as advertised"""
+        points = [
+            mapscript.pointObj(-0.2, 51.6),
+            mapscript.pointObj(0.0, 51.2),
+            mapscript.pointObj(0.2, 51.6),
+        ]
+        colors = [
+            mapscript.colorObj(255, 0, 0),
+            mapscript.colorObj(0, 255, 0),
+            mapscript.colorObj(0, 0, 255),
+        ]
+        img = self.map.prepareImage()
+        layer = self.map.getLayerByName("POINT")
+        # layer.draw(self.map, img)
+        class0 = layer.getClass(0)
+        for i in range(len(points)):
+            style0 = class0.getStyle(0)
+            style0.color = colors[i]
+            # style0.color.pen = -4
+            assert style0.color.toHex() == colors[i].toHex()
+            points[i].draw(self.map, layer, img, 0, "foo")
+        img.save("test_draw_points.png")
+
+
+class NewStylesTestCase(MapTestCase):
+    def testStyleConstructor(self):
+        """a new style is properly initialized"""
+        new_style = mapscript.styleObj()
+        assert new_style.color.red == -1
+        assert new_style.color.green == -1
+        assert new_style.color.blue == -1
+
+    def testCloneStyle(self):
+        """check attributes of a cloned style"""
+        new_style = mapscript.styleObj()
+        new_style.color.setHex("#808080")
+        clone = new_style.clone()
+        assert clone.thisown == 1
+        assert clone.color.toHex() == "#808080"
+
+    def testStyleColorSettable(self):
+        """a style can be set with a color tuple"""
+        new_style = mapscript.styleObj()
+        new_style.color.setRGB(1, 2, 3)
+        assert new_style.color.red == 1
+        assert new_style.color.green == 2
+        assert new_style.color.blue == 3
+
+    def testStyleBinding(self):
+        """attribute binding can be set and get"""
+        new_style = mapscript.styleObj()
+        assert not new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR)
+        new_style.setBinding(mapscript.MS_STYLE_BINDING_COLOR, "NEW_BINDING")
+        assert new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR) == "NEW_BINDING"
+
+    def testAppendNewStyle(self):
+        """a new style can be appended properly"""
+        p_layer = self.map.getLayerByName("POINT")
+        class0 = p_layer.getClass(0)
+        assert class0.numstyles == 2, class0.numstyles
+        new_style = mapscript.styleObj()
+        new_style.color.setRGB(0, 0, 0)
+        new_style.setSymbolByName(self.map, "circle")
+        new_style.size = 3
+        index = class0.insertStyle(new_style)
+        assert index == 2, index
+        assert class0.numstyles == 3, class0.numstyles
+        msimg = self.map.draw()
+        assert msimg.thisown == 1
+        filename = "testAppendNewStyle.png"
+        fh = open(filename, "wb")
+        msimg.write(fh)
+        fh.close()
+
+    def testAppendNewStyleOldWay(self):
+        """NewStylesTestCase.testAppendNewStyleOldWay: a new style can be appended properly using old method"""
+        p_layer = self.map.getLayerByName("POINT")
+        class0 = p_layer.getClass(0)
+        assert class0.numstyles == 2, class0.numstyles
+        new_style = mapscript.styleObj(class0)
+        assert new_style.thisown == 1, new_style.thisown
+        new_style.color.setRGB(0, 0, 0)
+        new_style.symbol = 1
+        new_style.size = 3
+        msimg = self.map.draw()
+        filename = "testAppendNewStyleOldWay.png"
+        fh = open(filename, "wb")
+        msimg.write(fh)
+        fh.close()
+
+    def testInsertNewStyleAtIndex0(self):
+        """NewStylesTestCase.testInsertNewStyleAtIndex0: a new style can be inserted ahead of all others"""
+        l_layer = self.map.getLayerByName("LINE")
+        class0 = l_layer.getClass(0)
+        new_style = mapscript.styleObj()
+        new_style.color.setRGB(255, 255, 0)
+        new_style.symbol = 1
+        new_style.size = 7
+        index = class0.insertStyle(new_style, 0)
+        assert index == 0, index
+        assert class0.numstyles == 2, class0.numstyles
+        msimg = self.map.draw()
+        assert msimg.thisown == 1
+        filename = "testInsertNewStyleAtIndex0.png"
+        fh = open(filename, "wb")
+        msimg.write(fh)
+        fh.close()
+
+    def testRemovePointStyle(self):
+        """NewStylesTestCase.testRemovePointStyle: a point style can be properly removed"""
+        p_layer = self.map.getLayerByName("POINT")
+        class0 = p_layer.getClass(0)
+        rem_style = class0.removeStyle(1)
+        assert rem_style is not None
+        assert class0.numstyles == 1, class0.numstyles
+        msimg = self.map.draw()
+        filename = "testRemovePointStyle.png"
+        msimg.save(filename)
+
+    def testModifyMultipleStyle(self):
+        """NewStylesTestCase.testModifyMultipleStyle: multiple styles can be modified"""
+        p_layer = self.map.getLayerByName("POINT")
+        class0 = p_layer.getClass(0)
+        style1 = class0.getStyle(1)
+        style1.color.setRGB(255, 255, 0)
+        msimg = self.map.draw()
+        filename = "testModifyMutiplePointStyle.png"
+        msimg.save(filename)
+
+    def testInsertStylePastEnd(self):
+        """NewStylesTestCase.testInsertStylePastEnd: inserting a style past the end of
+        the list raises the proper error"""
+        p_layer = self.map.getLayerByName("POINT")
+        class0 = p_layer.getClass(0)
+        new_style = mapscript.styleObj()
+        self.assertRaises(
+            mapscript.MapServerChildError, class0.insertStyle, new_style, 6
+        )
+
+    def testInsertNULLStyle(self):
+        """attempt to insert a NULL style should raise error"""
+        p_layer = self.map.getLayerByName("POINT")
+        class0 = p_layer.getClass(0)
+        self.assertRaises(mapscript.MapServerChildError, class0.insertStyle, None)
+
+    def testConvertToString(self):
+        """ensure styles can be created and output to strings
+        in a round trip"""
+        input_string = """
+            STYLE
+                SIZE 7.25
+                COLOR 255 0 0
+                OFFSET 10.5 20.75
+            END
+        """
+
+        new_style = mapscript.fromstring(input_string)
+        assert new_style.size == 7.25
+        assert new_style.color.red == 255
+        assert new_style.color.green == 0
+        assert new_style.color.blue == 0
+
+        assert new_style.offsetx == 10.5
+        assert new_style.offsety == 20.75
+
+        output_string = new_style.convertToString()
+        new_style2 = mapscript.fromstring(output_string)
+
+        # ensure attributes are output as doubles
+        assert new_style.size == 7.25
+        assert new_style2.offsetx == 10.5
+        assert new_style2.offsety == 20.75
+
+    def testPattern(self):
+        """See https://github.com/mapserver/mapserver/issues/4943"""
+
+        si = mapscript.styleObj()
+        assert si.pattern == ()
+        assert si.patternlength == 0
+
+    def testPattern2(self):
+
+        si = mapscript.styleObj()
+        si.pattern = [2.0, 3, 4]
+        assert si.pattern == (2.0, 3.0, 4.0)
+        assert si.patternlength == 3
+
+    def testPattern3(self):
+        """a pattern must have at least 2 elements"""
+
+        si = mapscript.styleObj()
+        exception = None
+        try:
+            si.pattern = [1.0]
+        except Exception:
+            exception = True
+        assert exception is True
+
+    def testPattern4(self):
+        """a pattern can have a max of 10 elements
+        This is set in mapsymbol.h with #define MS_MAXPATTERNLENGTH 10"""
+
+        si = mapscript.styleObj()
+        exception = None
+        try:
+            si.pattern = [i for i in range(11)]
+        except Exception:
+            exception = True
+        assert exception is True
+
+    def testPattern5(self):
+        """pattern length is read-only"""
+        si = mapscript.styleObj()
+        exception = None
+        try:
+            si.patternlength = 0
+        except Exception:
+            exception = True
+        assert exception is True
+
+
+class BrushCachingTestCase(MapTestCase):
+    def testDrawMapWithSecondPolygon(self):
+        """draw a blue polygon and a red polygon"""
+        p = self.map.getLayerByName("POLYGON")
+        ip = mapscript.layerObj(self.map)
+        ip.type = mapscript.MS_LAYER_POLYGON
+        ip.status = mapscript.MS_DEFAULT
+        c0 = mapscript.classObj(ip)
+
+        # turn off first polygon layer's color
+        p.getClass(0).getStyle(0).color.setRGB(-1, -1, -1)
+
+        # copy this style to inline polygon layer, then change outlinecolor
+        c0.insertStyle(p.getClass(0).getStyle(0))
+        st0 = c0.getStyle(0)
+        st0.outlinecolor.setRGB(255, 0, 0)
+
+        # pull out the first feature from polygon layer, shift it
+        # and use this as an inline feature in new layer
+        p.open()
+        p.template = "FAKE"  # set a template so the layer can be queried
+        p.queryByIndex(self.map, -1, 0, mapscript.MS_TRUE)
+        res = p.getResult(0)
+        s0 = p.getShape(res)
+        p.close()
+        r0 = s0.bounds
+        r1 = mapscript.rectObj(
+            r0.minx - 0.1, r0.miny - 0.1, r0.maxx - 0.1, r0.maxy - 0.1
+        )
+        s1 = r1.toPolygon()
+
+        ip.addFeature(s1)
+        img = self.map.draw()
+        img.save("test_drawmapw2ndpolygon.png")
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/symbol_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/symbol_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/symbol_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/symbol_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,160 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Symbol
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+from io import BytesIO
+
+import mapscript
+
+from .testing import HOME_IMAGE, XMARKS_IMAGE, MapTestCase
+
+
+class SymbolTestCase(unittest.TestCase):
+    def testConstructor(self):
+        """create new instance of symbolObj"""
+        symbol = mapscript.symbolObj("test")
+        assert symbol.name == "test"
+        assert symbol.thisown == 1
+
+    def testConstructorImage(self):
+        """create new instance of symbolObj from an image"""
+        symbol = mapscript.symbolObj("xmarks", XMARKS_IMAGE)
+        assert symbol.name == "xmarks"
+        assert symbol.type == mapscript.MS_SYMBOL_VECTOR  # was MS_SYMBOL_PIXMAP!
+        format = mapscript.outputFormatObj("AGG/PNG")
+        img = symbol.getImage(format)
+        img.save("sym-%s.%s" % (symbol.name, img.format.extension))
+
+
+class DynamicGraphicSymbolTestCase:
+    def setUp(self):
+        MapTestCase.setUp(self)
+        with open(HOME_IMAGE, "rb") as fh:
+            s = BytesIO(fh.read())
+        symb_img = mapscript.imageObj(s)
+        self.h_symbol = mapscript.symbolObj("house")
+        self.h_symbol.type = mapscript.MS_SYMBOL_PIXMAP
+        self.h_symbol.setImage(symb_img)
+        with open(XMARKS_IMAGE, "rb") as fh:
+            s = BytesIO(fh.read())
+        symb_img = mapscript.imageObj(s)
+        self.x_symbol = mapscript.symbolObj("xmarks")
+        self.x_symbol.type = mapscript.MS_SYMBOL_PIXMAP
+        self.x_symbol.setImage(symb_img)
+
+    def testSetPCTImage(self):
+        """set image of new symbolObj"""
+        assert self.h_symbol.name == "house"
+        assert self.h_symbol.type == mapscript.MS_SYMBOL_PIXMAP
+        format = mapscript.outputFormatObj("AGG/PNG")
+        format.transparent = mapscript.MS_ON
+        img = self.h_symbol.getImage(format)
+        img.save("set-%s.%s" % (self.h_symbol.name, img.format.extension))
+
+    def testDrawSetPCTImage(self):
+        """draw a map using the set image symbol"""
+        symbol_index = self.map.symbolset.appendSymbol(self.h_symbol)
+        assert symbol_index == 4, symbol_index
+        num = self.map.symbolset.numsymbols
+        assert num == 5, num
+        inline_layer = self.map.getLayerByName("INLINE")
+        s = inline_layer.getClass(0).getStyle(0)
+        s.symbol = symbol_index
+        s.size = -1  # pixmap's own size
+        img = self.map.draw()
+        img.save("testDrawSetPCTImage.%s" % (img.format.extension))
+
+    def testSetRGBAImage(self):
+        """set image of new symbolObj"""
+        assert self.x_symbol.name == "xmarks"
+        assert self.x_symbol.type == mapscript.MS_SYMBOL_PIXMAP
+        format = mapscript.outputFormatObj("AGG/PNG")
+        img = self.x_symbol.getImage(format)
+        img.save("set-%s.%s" % (self.x_symbol.name, img.format.extension))
+
+    def testDrawSetRGBAImage(self):
+        """draw a map using the set image symbol"""
+        symbol_index = self.map.symbolset.appendSymbol(self.x_symbol)
+        inline_layer = self.map.getLayerByName("INLINE")
+        s = inline_layer.getClass(0).getStyle(0)
+        s.symbol = symbol_index
+        s.size = -1  # pixmap's own size
+        self.map.selectOutputFormat("PNG24")
+        img = self.map.draw()
+        img.save("testDrawSetRGBAImage.%s" % (img.format.extension))
+
+
+class MapSymbolTestCase(MapTestCase):
+    def testGetPoints(self):
+        """get symbol points as line and test coords"""
+        symbol = self.map.symbolset.getSymbol(1)
+        assert symbol.name == "circle"
+        line = symbol.getPoints()
+        assert line.numpoints == 1, line.numpoints
+        pt = self.getPointFromLine(line, 0)
+        self.assertPointsEqual(pt, mapscript.pointObj(1.0, 1.0))
+
+    def testSetPoints(self):
+        """add lines of points to an existing symbol"""
+        symbol = self.map.symbolset.getSymbol(1)
+        assert symbol.name == "circle"
+        line = mapscript.lineObj()
+        self.addPointToLine(line, mapscript.pointObj(2.0, 2.0))
+        self.addPointToLine(line, mapscript.pointObj(3.0, 3.0))
+        assert symbol.setPoints(line) == 2
+        assert symbol.numpoints == 2
+        line = symbol.getPoints()
+        assert line.numpoints == 2, line.numpoints
+        pt = self.getPointFromLine(line, 1)
+        self.assertPointsEqual(pt, mapscript.pointObj(3.0, 3.0))
+
+    def testSetStyle(self):
+        """expect success after setting an existing symbol's style"""
+        symbol = self.map.symbolset.getSymbol(1)
+        # default MapScript API setPattern has been extended to allow lists
+        # assert symbol.setPattern(0, 1) == mapscript.MS_SUCCESS
+        symbol.pattern = [0, 1]
+        assert symbol.pattern == [0, 1]
+
+    def testRGBASymbolInPNG24(self):
+        """draw a RGBA PNG pixmap on PNG canvas"""
+        self.map.setImageType("PNG24")
+        # self.map.getLayerByName('INLINE-PIXMAP-RGBA').status \
+        #    == mapscript.MS_DEFAULT
+        img = self.map.draw()
+        img.save("pixmap-rgba-24.png")
+
+    def testRGBASymbolInJPEG(self):
+        """draw a RGBA PNG pixmap on JPEG canvas"""
+        self.map.setImageType("JPEG")
+        # self.map.getLayerByName('INLINE-PIXMAP-RGBA').status \
+        #    == mapscript.MS_DEFAULT
+        img = self.map.draw()
+        img.save("pixmap-rgba.jpg")
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/symbolset_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/symbolset_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/symbolset_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/symbolset_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,154 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of SymbolSet
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import os
+import unittest
+
+import mapscript
+
+from .testing import TESTS_PATH, XMARKS_IMAGE, MapTestCase
+
+SYMBOLSET = os.path.join(TESTS_PATH, "symbols.txt")
+
+
+class SymbolSetTestCase(unittest.TestCase):
+    def testConstructorNoArgs(self):
+        """new instance of symbolSetObj should have one symbol"""
+        symbolset = mapscript.symbolSetObj()
+        num = symbolset.numsymbols
+        assert num == 1, num
+
+    def testConstructorFile(self):
+        """new instance of symbolSetObj from symbols.txt"""
+        symbolset = mapscript.symbolSetObj(SYMBOLSET)
+        num = symbolset.numsymbols
+        assert num == 4, num
+
+    def testAddSymbolToNewSymbolSet(self):
+        """add two new symbols to a SymbolSet"""
+        symbolset = mapscript.symbolSetObj(SYMBOLSET)
+        symbola = mapscript.symbolObj("testa")
+        symbolb = mapscript.symbolObj("testb")
+        symbolset.appendSymbol(symbola)
+        symbolset.appendSymbol(symbolb)
+        num = symbolset.numsymbols
+        assert num == 6, num
+        names = [None, "circle", "xmarks-png", "home-png", "testa", "testb"]
+        for i in range(symbolset.numsymbols):
+            symbol = symbolset.getSymbol(i)
+            assert symbol.name == names[i], symbol.name
+
+    def testRemoveSymbolFromNewSymbolSet(self):
+        """after removing a symbol, expect numsymbols -= 1"""
+        symbolset = mapscript.symbolSetObj(SYMBOLSET)
+        symbolset.removeSymbol(1)
+        num = symbolset.numsymbols
+        assert num == 3, num
+
+    def testSaveNewSymbolSet(self):
+        """save a new SymbolSet to disk"""
+        symbolset = mapscript.symbolSetObj(SYMBOLSET)
+        symbola = mapscript.symbolObj("testa")
+        symbolb = mapscript.symbolObj("testb")
+        symbolset.appendSymbol(symbola)
+        symbolset.appendSymbol(symbolb)
+        assert symbolset.save("new_symbols.txt") == mapscript.MS_SUCCESS
+
+    def testError(self):
+        symbolset = mapscript.symbolSetObj(SYMBOLSET)
+        symbola = mapscript.symbolObj("testa")
+        symbolb = mapscript.symbolObj("testb")
+        symbolset.appendSymbol(symbola)
+        symbolset.appendSymbol(symbolb)
+        self.assertRaises(
+            mapscript.MapServerError, symbolset.save, "/bogus/new_symbols.txt"
+        )
+
+
+class MapSymbolSetTestCase(MapTestCase):
+    def testGetNumSymbols(self):
+        """expect getNumSymbols == 2 from test fixture test.map"""
+        num = self.map.getNumSymbols()
+        assert num == 4, num
+
+    def testSymbolSetNumsymbols(self):
+        """expect numsymbols == 2 from test fixture test.map"""
+        num = self.map.symbolset.numsymbols
+        assert num == 4, num
+
+    def testSymbolSetSymbolNames(self):
+        """test names of symbols in test fixture's symbolset"""
+        set = self.map.symbolset
+        names = [None, "circle", "xmarks-png", "home-png"]
+        for i in range(set.numsymbols):
+            symbol = set.getSymbol(i)
+            assert symbol.name == names[i], symbol.name
+
+    def testSymbolIndex(self):
+        """expect index of 'circle' symbol to be 1 in test fixture symbolset"""
+        i = self.map.symbolset.index("circle")
+        assert i == 1, i
+
+    def testBug1962(self):
+        """resetting imagepath doesn't cause segfault"""
+        layer = self.map.getLayerByName("POINT")
+        style0 = layer.getClass(0).getStyle(0)
+        sym0 = style0.symbol
+        sym1 = self.map.symbolset.getSymbol(sym0)
+        sym2 = mapscript.symbolObj("xxx")
+        assert sym2 is not None
+        sym1.setImagepath(XMARKS_IMAGE)
+        # self.assertRaises(IOError, sym1.setImagepath, '/bogus/new_symbols.txt')
+
+        msimg = self.map.draw()
+        assert msimg.thisown == 1
+        data = msimg.getBytes()
+        filename = "testBug1962.png"
+        fh = open(filename, "wb")
+        fh.write(data)
+        fh.close()
+
+    def testDrawNewSymbol(self):
+        """draw using a new symbol added to the fixture"""
+        symbol = mapscript.symbolObj("xmarks", XMARKS_IMAGE)
+        symbol_index = self.map.symbolset.appendSymbol(symbol)
+        assert symbol_index == 4, symbol_index
+        num = self.map.symbolset.numsymbols
+        assert num == 5, num
+        inline_layer = self.map.getLayerByName("INLINE")
+        s = inline_layer.getClass(0).getStyle(0)
+        s.symbol = symbol_index
+        # s.size = 24
+        msimg = self.map.draw()
+        assert msimg.thisown == 1
+        filename = "testDrawNewSymbol.png"
+        fh = open(filename, "wb")
+        msimg.write(fh)
+        fh.close()
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/testing.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/testing.py
--- 8.0.1-5/src/mapscript/python/tests/cases/testing.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/testing.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,155 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript testing utilities
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+#
+# Purpose of this module is to export the locally built mapscript module
+# prior to installation, do some name normalization that allows testing of
+# the so-called next generation class names, and define some classes
+# useful to many test cases.
+#
+# ===========================================================================
+
+import os
+import tempfile
+import unittest
+
+import mapscript
+
+# define the path to mapserver test data
+TESTS_PATH = os.path.abspath(os.path.join(os.path.dirname(__file__), "data"))
+TESTMAPFILE = os.path.join(TESTS_PATH, "test.map")
+TESTCONFIGFILE = os.path.join(TESTS_PATH, "mapserver-sample.conf")
+XMARKS_IMAGE = os.path.join(TESTS_PATH, "xmarks.png")
+HOME_IMAGE = os.path.join(TESTS_PATH, "home.png")
+TEST_IMAGE = os.path.join(TESTS_PATH, "test.png")
+
+INCOMING = tempfile.mkdtemp(prefix="mapscript")
+
+
+# ==========================================================================
+# Base testing classes
+
+
+class MapPrimitivesTestCase(unittest.TestCase):
+    """Base class for testing primitives (points, lines, shapes)
+    in stand-alone mode"""
+
+    def addPointToLine(self, line, point):
+        """Using either the standard or next_generation_api"""
+        try:
+            line.add(point)
+        except AttributeError:  # next_generation_api
+            line.addPoint(point)
+        except Exception:
+            raise
+
+    def getPointFromLine(self, line, index):
+        """Using either the standard or next_generation_api"""
+        try:
+            point = line.get(index)
+            return point
+        except AttributeError:  # next_generation_api
+            point = line.getPoint(index)
+            return point
+        except Exception:
+            raise
+
+    def addLineToShape(self, shape, line):
+        """Using either the standard or next_generation_api"""
+        try:
+            shape.add(line)
+        except AttributeError:  # next_generation_api
+            shape.addLine(line)
+        except Exception:
+            raise
+
+    def getLineFromShape(self, shape, index):
+        """Using either the standard or next_generation_api"""
+        try:
+            line = shape.get(index)
+            return line
+        except AttributeError:  # next_generation_api
+            line = shape.getLine(index)
+            return line
+        except Exception:
+            raise
+
+    def assertPointsEqual(self, first, second):
+        self.assertAlmostEqual(first.x, second.x)
+        self.assertAlmostEqual(first.y, second.y)
+
+    def assertLinesEqual(self, first, second):
+        assert first.numpoints == second.numpoints
+        for i in range(first.numpoints):
+            point_first = self.getPointFromLine(first, i)
+            point_second = self.getPointFromLine(second, i)
+            self.assertPointsEqual(point_first, point_second)
+
+    def assertShapesEqual(self, first, second):
+        assert first.numlines == second.numlines
+        for i in range(first.numlines):
+            line_first = self.getLineFromShape(first, i)
+            line_second = self.getLineFromShape(second, i)
+            self.assertLinesEqual(line_first, line_second)
+
+    def assertRectsEqual(self, first, second):
+        self.assertAlmostEqual(first.minx, second.minx)
+        self.assertAlmostEqual(first.miny, second.miny)
+        self.assertAlmostEqual(first.maxx, second.maxx)
+        self.assertAlmostEqual(first.maxy, second.maxy)
+
+
+class MapTestCase(MapPrimitivesTestCase):
+    """Base class for testing with a map fixture"""
+
+    def setUp(self):
+        self.map = mapscript.mapObj(TESTMAPFILE)
+        # self.xmarks_image = xmarks_image
+        # self.test_image = test_image
+
+    def tearDown(self):
+        self.map = None
+
+
+class MapZoomTestCase(MapPrimitivesTestCase):
+    "Testing new zoom* methods that we are adapting from the PHP MapScript"
+
+    def setUp(self):
+        self.mapobj1 = mapscript.mapObj(TESTMAPFILE)
+        # Change the extent for purposes of zoom testing
+        rect = mapscript.rectObj()
+        rect.minx, rect.miny, rect.maxx, rect.maxy = (-50.0, -50.0, 50.0, 50.0)
+        self.mapobj1.extent = rect
+        # Change height/width as well
+        self.mapobj1.width, self.mapobj1.height = (100, 100)
+
+    def tearDown(self):
+        self.mapobj1 = None
+
+
+class ShapeObjTestCase(MapPrimitivesTestCase):
+    """Base class for shapeObj tests"""
+
+    pass
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/thread_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/thread_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/thread_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/thread_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,196 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript test of multi-threading
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import os
+import threading
+import unittest
+
+import mapscript
+
+from .testing import INCOMING, TESTMAPFILE
+
+
+def draw_map(name, save=0):
+
+    # print("making map in thread %s" % (name))
+    mo = mapscript.mapObj(TESTMAPFILE)
+    im = mo.draw()
+    if save:
+        im.save("threadtest_%s.png" % (name))
+
+
+def trigger_exception(name):
+
+    # print("triggering exception in thread %s" % (name))
+    mo = mapscript.mapObj(TESTMAPFILE)
+    try:
+        mo.setExtent(1, 50, -1, 51)
+        raise Exception("We expected a MapServer exception")
+    except mapscript.MapServerError:
+        pass
+
+
+class MultipleThreadsTestCase(unittest.TestCase):
+    def testDrawMultiThreads(self):
+        """map drawing with multiple threads"""
+
+        workers = []
+        for i in range(10):
+            name = "d%d" % (i)
+            thread = threading.Thread(target=draw_map, name=name, args=(name, 1))
+            workers.append(thread)
+            thread.start()
+
+    def testExceptionsMultiThreads(self):
+        """mapserver exceptions behave with multiple threads"""
+
+        workers = []
+        for i in range(10):
+            name = "e%d" % (i)
+            thread = threading.Thread(target=trigger_exception, name=name, args=(name,))
+            workers.append(thread)
+            thread.start()
+
+    def testExceptionContainmentMultiThreads(self):
+        """mapserver exceptions should be contained to a thread"""
+        num = 100
+        workers = []
+
+        # Trigger an exception in the first started thread
+        for i in range(0, 1):
+            name = "c%d" % (i)
+            thread = threading.Thread(target=trigger_exception, name=name, args=(name,))
+            workers.append(thread)
+
+        # Draw normally
+        for i in range(1, num):
+            name = "c%d" % (i)
+            thread = threading.Thread(target=draw_map, name=name, args=(name,))
+            workers.append(thread)
+
+        # Start all threads
+        for i in range(num):
+            workers[i].start()
+
+
+def draw_map_wfs(name, save=0):
+
+    # print("making map in thread %s" % (name))
+    mo = mapscript.mapObj(TESTMAPFILE)
+
+    # WFS layer
+    lo = mapscript.layerObj()
+    lo.name = "cheapo_wfs"
+    lo.setProjection("+init=epsg:4326")
+    lo.connectiontype = mapscript.MS_WFS
+    lo.connection = "http://zcologia.com:9001/mapserver/members/features.rpy?"
+    lo.metadata.set("wfs_service", "WFS")
+    lo.metadata.set("wfs_typename", "users")
+    lo.metadata.set("wfs_version", "1.0.0")
+    lo.type = mapscript.MS_LAYER_POINT
+    lo.status = mapscript.MS_DEFAULT
+    lo.labelitem = "zco:mid"
+
+    so1 = mapscript.styleObj()
+    so1.color.setHex("#FFFFFF")
+    so1.size = 9
+    so1.symbol = 1  # mo.symbolset.index('circle')
+
+    so2 = mapscript.styleObj()
+    so2.color.setHex("#333333")
+    so2.size = 7
+    so2.symbol = 1  # mo.symbolset.index('circle')
+
+    co = mapscript.classObj()
+    co.label.type = mapscript.MS_BITMAP
+    co.label.size = mapscript.MS_SMALL
+    co.label.color.setHex("#000000")
+    co.label.outlinecolor.setHex("#FFFFFF")
+    co.label.position = mapscript.MS_AUTO
+
+    co.insertStyle(so1)
+    co.insertStyle(so2)
+    lo.insertClass(co)
+    mo.insertLayer(lo)
+
+    if not mo.web.imagepath:
+        mo.web.imagepath = os.environ.get("TEMP", None) or INCOMING
+    mo.debug = mapscript.MS_ON
+    im = mo.draw()
+    if save:
+        im.save("threadtest_wfs_%s.png" % (name))
+
+
+def draw_map_wms(name, save=0):
+
+    # print("making map in thread %s" % (name))
+    mo = mapscript.mapObj(TESTMAPFILE)
+    # WFS layer
+    lo = mapscript.layerObj()
+    lo.name = "jpl_wms"
+    lo.setProjection("+init=epsg:4326")
+    lo.connectiontype = mapscript.MS_WMS
+    lo.connection = "http://vmap0.tiles.osgeo.org/wms/vmap0?"
+    lo.metadata.set("wms_service", "WMS")
+    lo.metadata.set("wms_server_version", "1.1.1")
+    lo.metadata.set("wms_name", "basic")
+    lo.metadata.set("wms_style", "visual")
+    lo.metadata.set("wms_format", "image/jpeg")
+    lo.type = mapscript.MS_LAYER_RASTER
+    lo.status = mapscript.MS_DEFAULT
+    lo.debug = mapscript.MS_ON
+    mo.insertLayer(lo)
+
+    if not mo.web.imagepath:
+        mo.web.imagepath = os.environ.get("TEMP", None) or INCOMING
+    mo.debug = mapscript.MS_ON
+    mo.selectOutputFormat("image/jpeg")
+    im = mo.draw()
+    if save:
+        im.save("threadtest_wms_%s.jpg" % (name))
+
+
+class OWSRequestTestCase(unittest.TestCase):
+
+    # def testDrawWFS(self):
+    #    workers = []
+    #    for i in range(10):
+    #        name = 'd%d' % (i)
+    #        thread = threading.Thread(target=draw_map_wfs, name=name, args=(name, 1))
+    #        workers.append(thread)
+    #        thread.start()
+
+    def testDrawWMS(self):
+        workers = []
+        for i in range(10):
+            name = "d%d" % (i)
+            thread = threading.Thread(target=draw_map_wms, name=name, args=(name, 1))
+            workers.append(thread)
+            thread.start()
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/cases/zoom_test.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/zoom_test.py
--- 8.0.1-5/src/mapscript/python/tests/cases/zoom_test.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/cases/zoom_test.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,184 @@
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript tests of Map "zooming"
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+
+import unittest
+
+import mapscript
+
+from .testing import MapZoomTestCase
+
+
+class ZoomPointTestCase(MapZoomTestCase):
+    def testRecenter(self):
+        """ZoomPointTestCase.testRecenter: recentering the map with a point returns the same extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        p = mapscript.pointObj(50.0, 50.0)
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomPoint(1, p, w, h, extent, None)
+        new_extent = self.mapobj1.extent
+        self.assertRectsEqual(new_extent, mapscript.rectObj(-50, -50, 50, 50))
+
+    def testZoomInPoint(self):
+        """ZoomPointTestCase.testZoomInPoint: zooming in by a power of 2 returns the proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        p = mapscript.pointObj(50.0, 50.0)
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomPoint(2, p, w, h, extent, None)
+        new_extent = self.mapobj1.extent
+        self.assertRectsEqual(new_extent, mapscript.rectObj(-25, -25, 25, 25))
+
+    def testZoomOutPoint(self):
+        """ZoomPointTestCase.testZoomOutPoint: zooming out by a power of 2 returns the proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomPoint(-2, p, w, h, extent, None)
+        new_extent = self.mapobj1.extent
+        self.assertRectsEqual(new_extent, mapscript.rectObj(-100, -100, 100, 100))
+
+    def testZoomOutPointConstrained(self):
+        """ZoomPointTestCase.testZoomOutPointConstrained: zooming out to a constrained extent returns proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        max = mapscript.rectObj()
+        max.minx, max.miny, max.maxx, max.maxy = (-100.0, -100.0, 100.0, 100.0)
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomPoint(-4, p, w, h, extent, max)
+        new_extent = self.mapobj1.extent
+        self.assertRectsEqual(new_extent, max)
+
+    def testZoomBadSize(self):
+        """ZoomPointTestCase.testZoomBadSize: zooming to a bad size raises proper error"""
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        extent = self.mapobj1.extent
+        w = 0
+        h = -1
+        self.assertRaises(
+            mapscript.MapServerError, self.mapobj1.zoomPoint, -2, p, w, h, extent, None
+        )
+
+    def testZoomBadExtent(self):
+        """ZoomPointTestCase.testZoomBadExtent: zooming to a bad extent raises proper error"""
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        extent = self.mapobj1.extent
+        extent.maxx = extent.maxx - 1000000
+        w = 100
+        h = 100
+        self.assertRaises(
+            mapscript.MapServerError, self.mapobj1.zoomPoint, -2, p, w, h, extent, None
+        )
+
+
+class ZoomRectangleTestCase(MapZoomTestCase):
+    def testZoomRectangle(self):
+        """ZoomRectangleTestCase.testZoomRectangle: zooming to an extent returns proper map extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        r = mapscript.rectObj(1, 26, 26, 1, 1)
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomRectangle(r, w, h, extent, None)
+        new_extent = self.mapobj1.extent
+        self.assertRectsEqual(new_extent, mapscript.rectObj(-49, 24, -24, 49))
+
+    def testZoomRectangleConstrained(self):
+        """ZoomRectangleTestCase.testZoomRectangleConstrained: zooming to a constrained extent returns proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        max = mapscript.rectObj(-100.0, -100.0, 100.0, 100.0)
+        r = mapscript.rectObj(0, 200, 200, 0, 1)
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomRectangle(r, w, h, extent, max)
+        new_extent = self.mapobj1.extent
+        self.assertRectsEqual(new_extent, max)
+
+    def testZoomRectangleBadly(self):
+        """zooming into an invalid extent raises proper error"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        r = mapscript.rectObj(0, 0, 200, 200)
+        extent = self.mapobj1.extent
+        self.assertRaises(
+            mapscript.MapServerError, self.mapobj1.zoomRectangle, r, w, h, extent, None
+        )
+
+
+class ZoomScaleTestCase(MapZoomTestCase):
+    def testRecenter(self):
+        """ZoomScaleTestCase.testRecenter: recentering map returns proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)  # 100 by 100
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        scale = 2834.6472
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomScale(scale, p, w, h, extent, None)
+        assert self.mapobj1.scaledenom == scale
+        new_extent = self.mapobj1.extent
+        # self.assertRectsEqual(new_extent, mapscript.rectObj(-50, -50, 50, 50))  # old values
+        self.assertRectsEqual(new_extent, mapscript.rectObj(-49.5, -49.5, 49.5, 49.5))
+
+    def testZoomInScale(self):
+        """ZoomScaleTestCase.testZoomInScale: zooming in to a specified scale returns proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        scale = 1417.3236
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomScale(scale, p, w, h, extent, None)
+        new_extent = self.mapobj1.extent
+        # self.assertRectsEqual(new_extent, mapscript.rectObj(-25, -25, 25, 25))  # old values
+        self.assertRectsEqual(
+            new_extent, mapscript.rectObj(-24.75, -24.75, 24.75, 24.75)
+        )
+
+    def testZoomOutScale(self):
+        """ZoomScaleTestCase.testZoomOutScale: zooming out to a specified scale returns proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        scale = 5669.2944
+        extent = self.mapobj1.extent
+        self.mapobj1.zoomScale(scale, p, w, h, extent, None)
+        new_extent = self.mapobj1.extent
+        # self.assertRectsEqual(new_extent, mapscript.rectObj(-100, -100, 100, 100))  # old values
+        self.assertRectsEqual(new_extent, mapscript.rectObj(-99, -99, 99, 99))
+
+    def testZoomOutPointConstrained(self):
+        """ZoomScaleTestCase.testZoomOutPointConstrained: zooming out to a constrained extent returns proper extent"""
+        w, h = (self.mapobj1.width, self.mapobj1.height)
+        max = mapscript.rectObj()
+        max.minx, max.miny, max.maxx, max.maxy = (-100.0, -100.0, 100.0, 100.0)
+        p = mapscript.pointObj()
+        p.x, p.y = (50, 50)
+        extent = self.mapobj1.extent
+        scale = 10000
+        self.mapobj1.zoomScale(scale, p, w, h, extent, max)
+        new_extent = self.mapobj1.extent
+        self.assertRectsEqual(new_extent, max)
+
+
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/fragments.txt 8.2.0~beta1-1~exp1/src/mapscript/python/tests/fragments.txt
--- 8.0.1-5/src/mapscript/python/tests/fragments.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/fragments.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,95 @@
+Functional tests of mapfile fragment loading
+============================================
+
+Setup
+-----
+
+Use pkg_resources to maintain sanity with setuptools develop builds
+
+  >>> try:
+  ...     import pkg_resources
+  ...     msg = pkg_resources.require('mapscript')
+  ... except:
+  ...     pass
+
+Loading a MAP string
+--------------------
+
+Empty map
+
+  >>> import mapscript
+  >>> mo = mapscript.fromstring("""MAP\nNAME "test"\nEND""")
+  >>> mo # doctest: +ELLIPSIS
+  <mapscript.mapObj; proxy of C mapObj instance at ...>
+  >>> mo.name
+  'test'
+
+  >>> del mo
+
+With map path
+
+  Read in the standard mapserver fixture, and verify quickly
+  
+  >>> import os
+  >>> mapfile = os.path.abspath('../../../tests/test.map')
+  >>> maproot = os.path.abspath("%s/.." % mapfile)
+  >>> f = file(mapfile, 'rb')
+  >>> mapstring = f.read()
+  >>> f.close()
+  >>> mapstring.startswith('MAP')
+  True
+
+  >>> mo = mapscript.fromstring(mapstring, maproot)
+  >>> mo # doctest: +ELLIPSIS
+  <mapscript.mapObj; proxy of C mapObj instance at ...>
+  >>> mo.name
+  'Testing'
+  >>> mo.numlayers
+  7
+
+  # Delete so next tests get a clean slate
+  >>> del mo
+
+Without map map
+
+  Massage the mapfile to use absolute paths to resources
+
+  >>> absmapstr = mapstring.replace('FONTSET "', 'FONTSET "%s/' % maproot)
+  >>> absmapstr = absmapstr.replace('SYMBOLSET "', 'SYMBOLSET "%s/' % maproot)
+  >>> absmapstr = absmapstr.replace('DATA "', 'DATA "%s/' % maproot)
+
+  >>> mo = mapscript.fromstring(absmapstr)
+  >>> mo # doctest: +ELLIPSIS
+  <mapscript.mapObj; proxy of C mapObj instance at ...>
+  >>> mo.name
+  'Testing'
+  >>> mo.numlayers
+  7
+
+Layers
+------
+
+  >>> lo = mapscript.fromstring("""LAYER NAME "test" TYPE POINT END""")
+  >>> lo #doctest: +ELLIPSIS
+  <mapscript.layerObj; proxy of C layerObj instance at ...>
+  >>> lo.name
+  'test'
+  >>> lo.type == mapscript.MS_LAYER_POINT
+  True
+
+Classes
+-------
+
+  >>> co = mapscript.fromstring("""CLASS TITLE "test" END""")
+  >>> co #doctest: +ELLIPSIS
+  <mapscript.classObj; proxy of C classObj instance at ...>
+  >>> co.title
+  'test'
+
+Styles
+------
+
+  >>> so = mapscript.fromstring("""STYLE END""")
+  >>> so #doctest: +ELLIPSIS
+  <mapscript.styleObj; proxy of C styleObj instance at ...>
+
diff -pruN 8.0.1-5/src/mapscript/python/tests/runalldoctests.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/runalldoctests.py
--- 8.0.1-5/src/mapscript/python/tests/runalldoctests.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/runalldoctests.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,33 @@
+import doctest
+import getopt
+import glob
+import sys
+
+try:
+    import pkg_resources
+
+    pkg_resources.require("mapscript")
+except (ImportError, pkg_resources.DistributionNotFound):
+    pass
+
+
+def run(pattern):
+    if pattern is None:
+        testfiles = glob.glob("*.txt")
+    else:
+        testfiles = glob.glob(pattern)
+    for file in testfiles:
+        doctest.testfile(file)
+
+
+if __name__ == "__main__":
+    try:
+        opts, args = getopt.getopt(sys.argv[1:], "t:v")
+    except getopt.GetoptError:
+        print("Usage: python runalldoctests.py [-t GLOB_PATTERN]")
+        sys.exit(2)
+    pattern = None
+    for o, a in opts:
+        if o == "-t":
+            pattern = a
+    run(pattern)
diff -pruN 8.0.1-5/src/mapscript/python/tests/rundoctests.dist 8.2.0~beta1-1~exp1/src/mapscript/python/tests/rundoctests.dist
--- 8.0.1-5/src/mapscript/python/tests/rundoctests.dist	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/rundoctests.dist	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4 @@
+#!/bin/sh
+#export PYTHONPATH="YOUR_DEV_PYTHON_PATH"
+python runalldoctests.py
+
diff -pruN 8.0.1-5/src/mapscript/python/tests/runtests.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/runtests.py
--- 8.0.1-5/src/mapscript/python/tests/runtests.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/runtests.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,156 @@
+# $Id$
+#
+# Project:  MapServer
+# Purpose:  Comprehensive xUnit style Python mapscript test suite
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+#
+# Execute this module as a script from mapserver/mapscript/python
+#
+#     python tests/runtests.py -v
+#
+# ===========================================================================
+
+import unittest
+
+# Import test cases
+from cases.clonetest import MapCloningTestCase
+from cases.colortest import ColorObjTestCase
+from cases.hashtest import (
+    ClassMetadataTestCase,
+    HashTableTestCase,
+    LayerMetadataTestCase,
+    WebMetadataTestCase,
+)
+from cases.imagetest import ImageObjTestCase, ImageWriteTestCase
+from cases.labeltest import LabelCacheMemberTestCase
+from cases.layertest import (
+    LayerConstructorTestCase,
+    LayerExtentTestCase,
+    LayerRasterProcessingTestCase,
+    RemoveLayerTestCase,
+)
+from cases.linetest import LineObjTestCase
+from cases.maptest import (
+    EmptyMapExceptionTestCase,
+    MapConstructorTestCase,
+    MapExceptionTestCase,
+    MapExtentTestCase,
+    MapLayersTestCase,
+)
+from cases.outputformattest import MapOutputFormatTestCase, OutputFormatTestCase
+from cases.owstest import OWSRequestTestCase
+from cases.pointtest import PointObjTestCase
+from cases.recttest import RectObjTestCase
+from cases.resultcachetest import (
+    DumpAndLoadTestCase,
+    PointQueryResultsTestCase,
+    ResultCacheTestCase,
+)
+from cases.shapetest import InlineFeatureTestCase, ShapePointTestCase
+from cases.styletest import (
+    BrushCachingTestCase,
+    DrawProgrammedStylesTestCase,
+    NewStylesTestCase,
+)
+from cases.symbolsettest import MapSymbolSetTestCase, SymbolSetTestCase
+from cases.symboltest import MapSymbolTestCase, SymbolTestCase
+from cases.zoomtest import ZoomPointTestCase, ZoomRectangleTestCase, ZoomScaleTestCase
+
+# Create a test suite
+suite = unittest.TestSuite()
+
+# Add tests to the suite
+suite.addTests([RectObjTestCase()])
+
+suite.addTests(
+    [
+        HashTableTestCase(),
+        WebMetadataTestCase(),
+        LayerMetadataTestCase(),
+        ClassMetadataTestCase(),
+    ]
+)
+
+suite.addTests([MapCloningTestCase()])
+suite.addTests([OWSRequestTestCase()])
+
+suite.addTests([ImageObjTestCase(), ImageWriteTestCase()])
+
+suite.addTests(
+    [
+        MapConstructorTestCase(),
+        MapLayersTestCase(),
+        MapExtentTestCase(),
+        MapExceptionTestCase(),
+        EmptyMapExceptionTestCase(),
+    ]
+)
+
+suite.addTests(
+    [
+        LayerConstructorTestCase(),
+        LayerExtentTestCase(),
+        LayerRasterProcessingTestCase(),
+        RemoveLayerTestCase(),
+    ]
+)
+
+suite.addTests(
+    [
+        LineObjTestCase(),
+        ShapePointTestCase(),
+        PointObjTestCase(),
+        InlineFeatureTestCase(),
+    ]
+)
+
+
+suite.addTests(
+    [
+        DrawProgrammedStylesTestCase(),
+        NewStylesTestCase(),
+        BrushCachingTestCase(),
+        ColorObjTestCase(),
+    ]
+)
+
+suite.addTests([SymbolTestCase(), MapSymbolTestCase()])
+
+suite.addTests([SymbolSetTestCase(), MapSymbolSetTestCase()])
+
+suite.addTests([ZoomPointTestCase(), ZoomRectangleTestCase(), ZoomScaleTestCase()])
+
+suite.addTests([OutputFormatTestCase(), MapOutputFormatTestCase()])
+
+suite.addTest(LabelCacheMemberTestCase())
+
+suite.addTests(
+    [ResultCacheTestCase(), PointQueryResultsTestCase(), DumpAndLoadTestCase()]
+)
+
+# ============================================================================
+# If module is run as a script, execute every test case in the suite
+if __name__ == "__main__":
+    unittest.main()
diff -pruN 8.0.1-5/src/mapscript/python/tests/timing/clonemaps.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/clonemaps.py
--- 8.0.1-5/src/mapscript/python/tests/timing/clonemaps.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/clonemaps.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+# $Id$
+#
+# Timing tests of mapfile parsing vs map cloning
+
+import os
+import timeit
+from shutil import copyfile
+
+from .testing import TESTMAPFILE, mapscript
+
+# ===========================================================================
+# Test 1A: New maps from mapfile
+#
+# reloading the mapfile each time
+
+print("Test 1A: reloading maps from mapfile")
+s = """\
+m = mapscript.mapObj(TESTMAPFILE)
+"""
+t = timeit.Timer(stmt=s, setup="from __main__ import mapscript, TESTMAPFILE")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
+
+# ===========================================================================
+# Test 1B: Cloning
+#
+# Cloning instead of reloading
+
+print("Test 1B: cloning maps instead of reloading")
+m = mapscript.mapObj(TESTMAPFILE)
+s = """\
+c = m.clone()
+"""
+t = timeit.Timer(stmt=s, setup="from __main__ import m")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
+
+# ===========================================================================
+# Test 2: Add 20 dups of the POLYGON layer to see how results scale
+
+timing_map = mapscript.mapObj(TESTMAPFILE)
+polygon_layer = timing_map.getLayerByName("POLYGON")
+
+# duplicate POLYGON layer 20 times
+for i in range(20):
+    timing_map.insertLayer(polygon_layer)
+assert timing_map.numlayers == 24
+
+TIMINGMAPFILE = os.path.join(os.getcwd(), "timing.map")
+timing_map.save(TIMINGMAPFILE)
+copyfile("../../tests/fonts.txt", os.path.join(os.getcwd(), "fonts.txt"))
+copyfile("../../tests/symbols.txt", os.path.join(os.getcwd(), "symbols.txt"))
+
+# Test 2A: reloading mapfile
+print("Test 2A: reloading inflated mapfile")
+s = """\
+m = mapscript.mapObj(TIMINGMAPFILE)
+"""
+t = timeit.Timer(stmt=s, setup="from __main__ import mapscript, TIMINGMAPFILE")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
+
+print("Test 2B: cloning inflated mapfile")
+m = mapscript.mapObj(TIMINGMAPFILE)
+s = """\
+c = m.clone()
+"""
+t = timeit.Timer(stmt=s, setup="from __main__ import m")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
diff -pruN 8.0.1-5/src/mapscript/python/tests/timing/drawshapes.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/drawshapes.py
--- 8.0.1-5/src/mapscript/python/tests/timing/drawshapes.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/drawshapes.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,113 @@
+# $Id$
+#
+# Timing tests of feature drawing -- map.draw vs drawing features
+# shape by shape.
+
+import getopt
+import os
+import sys
+import timeit
+from random import random
+
+from .testing import mapscript
+
+# Get Number of shapes from the command line
+try:
+    opts, args = getopt.getopt(sys.argv[1:], "n:")
+except getopt.GetoptError:
+    sys.exit(2)
+
+numshapes = 100  # default to 100
+for o, a in opts:
+    if o == "-n":
+        numshapes = int(a)
+
+# The shapefileObj
+shpfile = mapscript.shapefileObj("timing.shp", mapscript.MS_SHAPEFILE_POLYGON)
+
+# Inline feature layer
+ilayer = mapscript.layerObj()
+ilayer.type = mapscript.MS_LAYER_POLYGON
+ilayer.setProjection("init=epsg:4326")
+ilayer.status = mapscript.MS_DEFAULT
+ilayer.connectiontype = mapscript.MS_INLINE
+
+print(numshapes, "shapes")
+
+i = 0
+while i < numshapes:
+    # The shape to add is randomly generated
+    xc = 4.0 * (random() - 0.5)
+    yc = 4.0 * (random() - 0.5)
+    r = mapscript.rectObj(xc - 0.25, yc - 0.25, xc + 0.25, yc + 0.25)
+    s = r.toPolygon()
+
+    # Add to shapefile
+    shpfile.add(s)
+
+    # Add to inline feature layer
+    ilayer.addFeature(s)
+
+    i = i + 1
+
+del shpfile  # closes up the file
+
+# Prepare the testing fixture
+m = mapscript.mapObj("timing.map")
+l = m.getLayerByName("POLYGON")
+l.data = os.path.join(os.getcwd(), "timing")
+
+# Save three map images to check afterwards
+img = m.draw()
+img.save("timing.png")
+
+shpfile = mapscript.shapefileObj("timing.shp")
+img = m.prepareImage()
+for i in range(shpfile.numshapes):
+    s = shpfile.getShape(i)
+    s.classindex = 0
+    s.draw(m, l, img)
+img.save("timing-shapes.png")
+
+class0 = mapscript.classObj(ilayer)
+class0.insertStyle(l.getClass(0).getStyle(0))
+img = m.prepareImage()
+ilayer.draw(m, img)
+img.save("timing-inline.png")
+
+# =========================================================================
+# Test 1A: Draw all shapes at once using map.draw()
+
+print("Test 1A: draw map, all shapes at once")
+s = """\
+img = m.draw()
+"""
+t = timeit.Timer(stmt=s, setup="from __main__ import m")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
+
+
+# =========================================================================
+# Test 1B: Draw shape by shape from the shapefileObj
+
+print("Test 1B: draw shapes one at a time")
+s = """\
+img = m.prepareImage()
+for i in range(shpfile.numshapes):
+    s = shpfile.getShape(i)
+    s.classindex = 0
+    s.draw(m, l, img)
+"""
+t = timeit.Timer(stmt=s, setup="from __main__ import m, l, shpfile")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
+
+
+# =========================================================================
+# Test 1C: Draw shapes after pushing them into an inline layer
+
+print("Test 1C: draw inline layer shapes")
+s = """\
+img = m.prepareImage()
+ilayer.draw(m, img)
+"""
+t = timeit.Timer(stmt=s, setup="from __main__ import m, ilayer")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
diff -pruN 8.0.1-5/src/mapscript/python/tests/timing/testing.py 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/testing.py
--- 8.0.1-5/src/mapscript/python/tests/timing/testing.py	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/testing.py	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,89 @@
+# $Id$
+#
+# Project:  MapServer
+# Purpose:  xUnit style Python mapscript testing utilities
+# Author:   Sean Gillies, sgillies@frii.com
+#
+# ===========================================================================
+# Copyright (c) 2004, Sean Gillies
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included
+# in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+# ===========================================================================
+#
+# Purpose of this module is to export the locally built mapscript module
+# prior to installation, do some name normalization that allows testing of
+# the so-called next generation class names, and define some classes
+# useful to many test cases.
+#
+# All test case modules should import mapscript from testing
+#
+#     from .testing import mapscript
+#
+# ===========================================================================
+
+import os
+import sys
+import sysconfig
+
+# define the path to mapserver test data
+TESTS_PATH = "../../tests"
+
+TESTMAPFILE = os.path.join(TESTS_PATH, "test.map")
+XMARKS_IMAGE = os.path.join(TESTS_PATH, "xmarks.png")
+TEST_IMAGE = os.path.join(TESTS_PATH, "test.png")
+
+# Put local build directory on head of python path
+platformdir = "-".join(
+    (sysconfig.get_platform(), ".".join(map(str, sys.version_info[0:2])))
+)
+sys.path.insert(0, os.path.join("build", "lib." + platformdir))
+
+# import mapscript from the local build directory
+import mapscript
+
+# normalize names, allows testing of module that uses the experimental
+# next generation names
+classnames = [
+    "mapObj",
+    "layerObj",
+    "classObj",
+    "styleObj",
+    "shapeObj",
+    "lineObj",
+    "pointObj",
+    "rectObj",
+    "outputFormatObj",
+    "symbolObj",
+    "symbolSetObj",
+    "colorObj",
+    "imageObj",
+    "shapefileObj",
+    "projectionObj",
+    "fontSetObj",
+    "hashTableObj",
+]
+
+for name in classnames:
+    try:
+        new_name = name.replace("Obj", "")
+        new_name = new_name.capitalize()
+        new_object = getattr(mapscript, new_name)
+        setattr(mapscript, name, new_object)
+    except AttributeError:
+        pass
diff -pruN 8.0.1-5/src/mapscript/python/tests/timing/timing.map 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/timing.map
--- 8.0.1-5/src/mapscript/python/tests/timing/timing.map	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/python/tests/timing/timing.map	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,55 @@
+MAP
+  NAME "Testing"
+  EXTENT -2 -2 2 2
+  IMAGETYPE PNG
+  IMAGECOLOR 254 254 254
+  STATUS ON
+  SIZE 800 800
+
+  PROJECTION
+    "init=epsg:4326"
+  END
+  
+  SYMBOL
+    TYPE PIXMAP
+    NAME 'home-png'
+    IMAGE '../../../../tests/home.png'
+  END
+
+  SYMBOL
+    TYPE PIXMAP
+    NAME 'xmarks-png'
+    IMAGE '../../../../tests/xmarks.png'
+  END
+  
+  LAYER
+    NAME "POLYGON"
+    TYPE POLYGON
+    PROJECTION
+      "init=epsg:4326"
+    END
+    STATUS DEFAULT
+    DATA "timing.shp"
+    CLASS
+      STYLE
+        COLOR 0 0 204
+        #OUTLINECOLOR 0 0 204
+      END
+    END
+  END
+
+  LAYER
+    NAME "POINT"
+    TYPE POINT
+    PROJECTION
+      "init=epsg:4326"
+    END
+    STATUS OFF
+    CLASS
+      STYLE
+        SYMBOL 2
+      END
+    END
+  END
+
+END
diff -pruN 8.0.1-5/src/mapscript/ruby/CMakeLists.txt 8.2.0~beta1-1~exp1/src/mapscript/ruby/CMakeLists.txt
--- 8.0.1-5/src/mapscript/ruby/CMakeLists.txt	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/ruby/CMakeLists.txt	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,26 @@
+find_package(SWIG REQUIRED)
+include(${SWIG_USE_FILE})
+find_package(Ruby REQUIRED)
+include_directories(${RUBY_INCLUDE_DIRS})
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
+include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/ruby)
+
+if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
+    swig_add_library(rubymapscript TYPE MODULE LANGUAGE ruby SOURCES ../mapscript.i)
+else ()
+    swig_add_module(rubymapscript ruby ../mapscript.i)
+endif ()
+
+swig_link_libraries(rubymapscript ${RUBY_LIBRARY} ${MAPSERVER_LIBMAPSERVER})
+
+set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES PREFIX "")
+set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES OUTPUT_NAME mapscript)
+
+if(APPLE)
+    set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES SUFFIX ".bundle")
+endif(APPLE)
+
+set(mapscript_files $<TARGET_FILE:${SWIG_MODULE_rubymapscript_REAL_NAME}>)
+execute_process(COMMAND ${RUBY_EXECUTABLE} -r rbconfig -e "puts RbConfig::CONFIG['sitearchdir']" OUTPUT_VARIABLE RUBY_SITEARCHDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+install(FILES ${mapscript_files} DESTINATION ${RUBY_SITEARCHDIR})
diff -pruN 8.0.1-5/src/mapscript/ruby/README 8.2.0~beta1-1~exp1/src/mapscript/ruby/README
--- 8.0.1-5/src/mapscript/ruby/README	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/ruby/README	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,62 @@
+Ruby MapScript Interface
+------------------------
+
+BUILD
+-----
+
+The files that are required to create the library 'mapscript.so' : 
+ mapscript.i 
+ extconf.rb
+
+Be sure that you have installed SWIG version 1.3a5 or greater.
+The installation is tested with ruby version 1.6 and 1.8.
+
+To build type :
+
+# ruby extconf.rb
+# make
+
+
+INSTALL
+-------
+
+If you don't want to install the library, you have to add the library
+path as argument to the command (ruby -I[path/to/the/library] ...).
+
+To install type as 'root' user : 
+
+# make install
+
+
+EXAMPLES
+--------
+
+To run the examples:
+Go to the directory of the examples
+
+# cd examples
+
+
+Run the example to receive information about a shape file
+
+# ruby shpinfo.rb [path/shapefile.shp]
+or if you don't have executed 'make install'
+# ruby -I[path/to/mapscript.so] shpinfo.rb [path/shapefile.shp]
+
+e.g.: # ruby -I.. shpinfo.rb lake2spy.shp
+
+Run the example to create a PNG file from a shape file. The output
+will be in the file [shapefile].png.
+
+# ruby shp2img.rb [path/shapefile.shp]
+or
+# ruby -I[path/to/mapscript.so] shp2img.rb [path/shapefile.shp]
+e.g.: # ruby -I.. shp2img.rb lake2spy.shp
+
+
+AUTHOR
+------
+
+Markus Schnider
+msr@sourcepole.ch
+http://www.sourcepole.com
diff -pruN 8.0.1-5/src/mapscript/ruby/examples/shp2img.rb 8.2.0~beta1-1~exp1/src/mapscript/ruby/examples/shp2img.rb
--- 8.0.1-5/src/mapscript/ruby/examples/shp2img.rb	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/ruby/examples/shp2img.rb	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,44 @@
+#!/usr/bin/env ruby 
+
+require "mapscript"
+include Mapscript
+
+filename = ARGV[0]
+
+shapefile = ShapefileObj.new(filename, -1)
+
+shapepath = File.dirname(filename)
+shapename = File.basename(filename, "....")
+
+map = MapObj.new('')
+map.shapepath = shapepath
+map.height = 200
+map.width = 200
+map.extent = shapefile.bounds
+
+$shapetypes =
+{
+   MS_SHAPEFILE_POINT      => MS_LAYER_POINT,
+   MS_SHAPEFILE_ARC        => MS_LAYER_LINE,
+   MS_SHAPEFILE_POLYGON    => MS_LAYER_POLYGON,
+   MS_SHAPEFILE_MULTIPOINT => MS_LAYER_LINE
+}
+
+layer = LayerObj.new(map)
+layer.name = shapename
+layer.type = $shapetypes[shapefile.type]
+layer.status = MS_ON
+layer.data = shapename
+
+cls = ClassObj.new(layer)
+style = StyleObj.new()
+color = ColorObj.new()
+color.red = 107
+color.green = 158
+color.blue = 160
+style.color = color
+cls.insertStyle(style)
+
+#map.save(shapename+'.map')
+img = map.draw
+img.save(shapename+'.png')
diff -pruN 8.0.1-5/src/mapscript/ruby/extconf.rb 8.2.0~beta1-1~exp1/src/mapscript/ruby/extconf.rb
--- 8.0.1-5/src/mapscript/ruby/extconf.rb	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/ruby/extconf.rb	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,36 @@
+#!/usr/bin/env ruby 
+require 'mkmf'
+require 'pathname'
+
+mapscriptvars = File.open("../../mapscriptvars")
+make_home = mapscriptvars.gets.chomp
+make_define = mapscriptvars.gets.chomp
+make_inc = mapscriptvars.gets.chomp
+make_libs = mapscriptvars.gets.chomp
+make_static_libs = mapscriptvars.gets.chomp
+mapscriptvars.close
+
+MAPSERVER_LOCAL_LIBS=Pathname.new(File.dirname(__FILE__) + '/../../.libs').realpath
+
+# $CFLAGS works only with 1.8 ??? -> the -Wall argument is not needed !!!
+$CFLAGS = ""
+$CPPFLAGS = make_inc + " -idirafter $(rubylibdir)/$(arch) " + make_define
+$LDFLAGS += " -fPIC -Wl,-rpath,#{MAPSERVER_LOCAL_LIBS}"
+#$LOCAL_LIBS += " -L../../.libs/ " + " -lmapserver " + make_static_libs
+$LOCAL_LIBS += " -L#{MAPSERVER_LOCAL_LIBS} " + " -lmapserver "
+
+# if the source file 'mapscript_wrap.c' is missing nothing works
+# this is a workaround !!
+if !FileTest.exist?("mapscript_wrap.c")
+	$objs = []
+	$objs.push("mapscript_wrap.o")
+end
+
+#CONFIG['LDSHARED'] = "LD_RUN_PATH=#{MAPSERVER_LOCAL_LIBS} " + CONFIG['LDSHARED']
+
+create_makefile("mapscript")
+
+make_file = File.open("Makefile", "a")
+make_file << "\nmapscript_wrap.c: ../mapscript.i\n\tswig -ruby -o mapscript_wrap.c ../mapscript.i"
+make_file.close
+
diff -pruN 8.0.1-5/src/mapscript/ruby/rbextend.i 8.2.0~beta1-1~exp1/src/mapscript/ruby/rbextend.i
--- 8.0.1-5/src/mapscript/ruby/rbextend.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/ruby/rbextend.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,16 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Ruby-specific extensions to MapScript objects
+ * Author:
+ *
+ ******************************************************************************
+ *
+ * Ruby-specific mapscript code has been moved into this 
+ * SWIG interface file to improve the readibility of the main
+ * interface file.  The main mapscript.i file includes this
+ * file when SWIGRUBY is defined (via 'swig -ruby ...').
+ *
+ *****************************************************************************/
+
diff -pruN 8.0.1-5/src/mapscript/ruby/rbmodule.i 8.2.0~beta1-1~exp1/src/mapscript/ruby/rbmodule.i
--- 8.0.1-5/src/mapscript/ruby/rbmodule.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/ruby/rbmodule.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,137 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Ruby-specific enhancements to MapScript
+ * Author:   
+ *
+ ******************************************************************************
+ *
+ * Ruby-specific mapscript code has been moved into this 
+ * SWIG interface file to improve the readibility of the main
+ * interface file.  The main mapscript.i file includes this
+ * file when SWIGRUBY is defined (via 'swig -ruby ...').
+ *
+ *****************************************************************************/
+
+/******************************************************************************
+ * Simple Typemaps
+ *****************************************************************************/
+/* To support imageObj::getBytes */
+%typemap(out) gdBuffer {
+    $result = rb_str_new($1.data, $1.size);
+    msFree($1.data);
+}
+
+/**************************************************************************
+ * MapServer Errors and Ruby Exceptions
+ **************************************************************************
+ *
+ * Translation of errors reported via the ms_error structure into
+ * Ruby exceptions. Generally copied from Python MapScript by Jim Klassen.
+ * Follows original code by Chris Chamberlin <cdc@aracnet.com> as updated
+ * updated by Sean Gillies <sgillies@frii.com>. 
+ * Uses rb_raise, %exception and $action for SWIG 1.3, do the most
+ * obvious mapping of MapServer errors to Ruby exceptions and map all 
+ * others to a new 'MapServerError' exception which can be caught like 
+ * this:
+ * 
+ *   require 'mapscript'
+ *   empty_map = Mapscript.MapObj.new('')
+ *   begin:
+ *       img = empty_map.draw()
+ *   rescue Mapscript::MapServerError => msg
+ *       print "Caught MapServerError:", msg.to_s
+ *   end
+ *
+ *************************************************************************/
+
+%{
+    VALUE MSExc_MapServerError;
+    VALUE MSExc_MapServerChildError;
+%}
+
+/* Module initialization: call msSetup() and register msCleanup() */
+%init %{
+
+/* Copied from pymodule.i to fix #3619 */
+    if (msSetup() != MS_SUCCESS)
+    {
+        msSetError(MS_MISCERR, "Failed to set up threads and font cache",
+                   "msSetup()");
+    }
+
+    /* Is there a place to hook to call msCleanup()? */
+    VALUE exceptionClass = rb_eval_string("Exception");
+    VALUE mapscriptModule = rb_eval_string("Mapscript");
+    MSExc_MapServerError = rb_define_class_under(mapscriptModule, "MapserverError", exceptionClass);
+    MSExc_MapServerChildError = rb_define_class_under(mapscriptModule, "MapserverChildErrorError", exceptionClass);
+%}
+
+%{
+static void _raise_ms_exception( void );
+
+static void _raise_ms_exception() {
+    int errcode;
+    errorObj *ms_error;
+    char *errmsg;
+    ms_error = msGetErrorObj();
+    errcode = ms_error->code;
+    errmsg = msGetErrorString("\n");
+    
+    switch (errcode) {
+        case MS_IOERR:
+            rb_raise(rb_eIOError, errmsg, "%s");
+            break;
+        case MS_MEMERR:
+            rb_raise(rb_eNoMemError, errmsg, "%s");
+            break;
+        case MS_TYPEERR:
+            rb_raise(rb_eTypeError, errmsg, "%s");
+            break;
+        case MS_EOFERR:
+            rb_raise(rb_eEOFError, errmsg, "%s");
+            break;
+        case MS_CHILDERR:
+            rb_raise(MSExc_MapServerChildError, errmsg, "%s");
+            break;
+        default:
+            rb_raise(MSExc_MapServerError, errmsg, "%s");
+            break;
+    }
+
+    free(errmsg);
+}
+%}
+
+%exception {
+    msResetErrorList();
+    $action 
+    {
+        errorObj *ms_error = msGetErrorObj();
+
+        switch(ms_error->code) {
+            case MS_NOERR:
+                break;
+            case MS_NOTFOUND:
+                msResetErrorList();
+                break;
+            case -1:
+                break;
+            case MS_IOERR:
+                /*
+                if (strncmp(ms_error->routine, "msSearchDiskTree()", 20) != 0) {
+                    _raise_ms_exception();
+                    msResetErrorList();
+                    return NULL;
+                }
+                */
+            default:
+                _raise_ms_exception();
+                msResetErrorList();
+                return 0;
+        }
+
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/class.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/class.i
--- 8.0.1-5/src/mapscript/swiginc/class.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/class.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,273 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript classObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             Seth Girvin
+
+   ===========================================================================
+   Copyright (c) 1996-2019 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+
+%extend classObj {
+
+    /// Create a new child classObj instance at the tail (highest index) of the 
+    /// class array of the parent_layer. A class can be created outside the 
+    /// context of a parent layer by omitting the layerObj constructor argument
+    classObj(layerObj *layer=NULL) 
+    {
+        classObj *new_class=NULL;
+        
+        if (!layer)
+        {
+            new_class = (classObj *) malloc(sizeof(classObj));
+            if (!new_class)
+            {
+                msSetError(MS_MEMERR,
+                    "Could not allocate memory for new classObj instance",
+                    "classObj()");
+                return NULL;
+            }
+            if (initClass(new_class) == -1) return NULL;
+            new_class->layer = NULL;
+            return new_class;
+        }
+        else
+        {
+            if(msGrowLayerClasses(layer) == NULL)
+                return NULL;
+            if (initClass(layer->class[layer->numclasses]) == -1)
+                return NULL;
+            layer->class[layer->numclasses]->layer = layer;
+            MS_REFCNT_INCR(layer->class[layer->numclasses]);
+            layer->numclasses++;
+            return (layer->class[layer->numclasses-1]);
+        }
+
+        return NULL;
+    }
+
+    ~classObj() 
+    {
+        if (self)
+        {
+            if (freeClass(self)==MS_SUCCESS) {
+                free(self);
+                self=NULL;
+            }
+        }
+    }
+
+    /// Update a class from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int updateFromString(char *snippet)
+    {
+        return msUpdateClassFromString(self, snippet);
+    }
+
+    %newobject convertToString;
+    /// Output the CLASS as a Mapfile string
+    char* convertToString()
+    {
+        return msWriteClassToString(self);
+    }
+
+#if defined (SWIGJAVA) || defined (SWIGPHP)
+    %newobject cloneClass;
+    classObj *cloneClass() 
+#else
+    %newobject clone;
+    /**
+    Return an independent copy of the class without a parent layer
+
+    .. note::
+
+        In the Java & PHP modules this method is named ``cloneClass``.    
+    */ 
+    classObj *clone() 
+#endif
+    {
+        classObj *new_class;
+
+        new_class = (classObj *) malloc(sizeof(classObj));
+        if (!new_class)
+        {
+            msSetError(MS_MEMERR,
+                "Could not allocate memory for new classObj instance",
+                "clone()");
+            return NULL;
+        }
+        if (initClass(new_class) == -1)
+        {
+            msSetError(MS_MEMERR, "Failed to initialize Class",
+                                  "clone()");
+            return NULL;
+        }
+        new_class->layer = NULL;
+
+        if (msCopyClass(new_class, self, self->layer) != MS_SUCCESS) {
+            freeClass(new_class);
+            free(new_class);
+            new_class = NULL;
+        }
+        
+        return new_class;
+    }
+
+  /// Set :ref:`EXPRESSION <mapfile-class-expression>` string where `expression` is a MapServer regular, 
+  /// logical or string expression. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int setExpression(char *expression) 
+  {
+    if (!expression || strlen(expression) == 0) {
+       msFreeExpression(&self->expression);
+       return MS_SUCCESS;
+    }
+    else return msLoadExpressionString(&self->expression, expression);
+  }
+
+  %newobject getExpressionString;
+  /// Return a string representation of the :ref:`EXPRESSION <mapfile-class-expression>` enclosed in 
+  /// the quote characters appropriate to the expression type
+  char *getExpressionString() {
+    return msGetExpressionString(&(self->expression));
+  }
+
+  /// Set :ref:`TEXT <mapfile-class-text>` string where `text` is a MapServer text expression.
+  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int setText(char *text) {
+    if (!text || strlen(text) == 0) {
+      msFreeExpression(&self->text);
+      return MS_SUCCESS;
+    }    
+    else return msLoadExpressionString(&self->text, text);
+  }
+
+  %newobject getTextString;
+  /// Return a string representation of :ref:`TEXT <mapfile-class-text>`
+  char *getTextString() {
+    return msGetExpressionString(&(self->text));
+  }
+
+  /// Draw the legend icon onto *image* at *dstx*, *dsty*.  Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int drawLegendIcon(mapObj *map, layerObj *layer, int width, int height, imageObj *dstImage, int dstX, int dstY) {    
+    if(layer->sizeunits != MS_PIXELS) {
+      map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+      layer->scalefactor = (msInchesPerUnit(layer->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
+    }
+    else
+      layer->scalefactor = map->resolution/map->defresolution;
+
+  #if defined(WIN32) && defined(SWIGCSHARP)
+    __try {
+        return msDrawLegendIcon(map, layer, self, width, height, dstImage, dstX, dstY, MS_TRUE, NULL);
+    }    
+    __except(1 /*EXCEPTION_EXECUTE_HANDLER, catch every exception so it doesn't crash IIS*/) {  
+        msSetError(MS_IMGERR, "Unhandled exception in drawing legend image 0x%08x", "msDrawMap()", GetExceptionCode());
+    }
+  #else    
+    return msDrawLegendIcon(map, layer, self, width, height, dstImage, dstX, dstY, MS_TRUE, NULL);
+  #endif
+  }
+
+  %newobject createLegendIcon;
+  /// Draw and return a new legend icon
+  imageObj *createLegendIcon(mapObj *map, layerObj *layer, int width, int height) {
+    return msCreateLegendIcon(map, layer, self, width, height, MS_TRUE);
+  } 
+
+  %newobject getLabel;
+  /// Return a reference to the :class:`labelObj` at *index* in the labels array
+  labelObj *getLabel(int i) {
+    if (i >= 0 && i < self->numlabels) {
+      MS_REFCNT_INCR(self->labels[i]);
+      return self->labels[i];
+    } else {
+      msSetError(MS_CHILDERR, "Invalid index: %d.", "getLabel()", i);
+      return NULL;
+    }
+  }
+
+#ifdef SWIGCSHARP
+%apply SWIGTYPE *SETREFERENCE {labelObj *label};
+#endif
+  /// Add a :class:`labelObj` to the :class:`classObj` and return its index in the labels array
+  int addLabel(labelObj *label) {
+    return msAddLabelToClass(self, label);
+  }
+#ifdef SWIGCSHARP 
+%clear labelObj *label;
+#endif
+
+  %newobject removeLabel;
+  /// Remove the :class:`labelObj` at *index* from the labels array and return a
+  /// reference to the :class:`labelObj`. numlabels is decremented, and the array is updated
+  labelObj *removeLabel(int index) {
+    labelObj* label = (labelObj *) msRemoveLabelFromClass(self, index);
+    if (label) MS_REFCNT_INCR(label);
+    return label;
+  }
+  
+  // See https://github.com/mapserver/mapserver/issues/548 for more details about the Style methods
+
+  %newobject getStyle;
+  /// Return a reference to the :class:`styleObj` at *index* in the styles array
+  styleObj *getStyle(int i) {
+    if (i >= 0 && i < self->numstyles) {
+      MS_REFCNT_INCR(self->styles[i]);
+      return self->styles[i];
+    } else {
+      msSetError(MS_CHILDERR, "Invalid index: %d", "getStyle()", i);
+      return NULL;
+    }
+  }
+
+#ifdef SWIGCSHARP
+%apply SWIGTYPE *SETREFERENCE {styleObj *style};
+#endif
+  /// Insert a **copy** of *style* into the styles array at index *index*
+  /// Default is -1, or the end of the array.  Returns the index at which the style was inserted.
+  int insertStyle(styleObj *style, int index=-1) {
+    return msInsertStyle(self, style, index);
+  }
+#ifdef SWIGCSHARP 
+%clear styleObj *style;
+#endif
+
+  %newobject removeStyle;
+  /// Remove the :class:`styleObj` at *index* from the styles array and return a copy.
+  styleObj *removeStyle(int index) {
+    styleObj* style = (styleObj *) msRemoveStyle(self, index);
+    if (style) MS_REFCNT_INCR(style);
+    return style;
+  }
+
+  /// Swap the :class:`styleObj` at *index* with the styleObj at *index* - 1
+  int moveStyleUp(int index) {
+    return msMoveStyleUp(self, index);
+  }
+
+  /// Swap the :class:`styleObj` at *index* with the :class:`styleObj` at *index* + 1
+  int moveStyleDown(int index) {
+    return msMoveStyleDown(self, index);
+  }
+
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/cluster.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/cluster.i
--- 8.0.1-5/src/mapscript/swiginc/cluster.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/cluster.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,78 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript clusterObj extensions
+   Author:   Tamas Szekeres
+             Seth Girvin
+   ===========================================================================
+   Copyright (c) 1996-2019 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend clusterObj
+{
+
+
+  /// Update a cluster from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int updateFromString(char *snippet)
+  {
+    return msUpdateClusterFromString(self, snippet);
+  }
+
+  %newobject convertToString;
+  /// Output the :ref:`cluster` as a Mapfile string
+  char* convertToString()
+  {
+    return msWriteClusterToString(self);
+  }
+
+  /// Set :ref:`GROUP <mapfile-cluster-group>` string where `group` is a MapServer text expression.
+  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int setGroup(char *group) 
+  {
+    if (!group || strlen(group) == 0) {
+       msFreeExpression(&self->group);
+       return MS_SUCCESS;
+    }
+    else return msLoadExpressionString(&self->group, group);
+  }
+
+  %newobject getGroupString;
+  /// Return a string representation of :ref:`GROUP <mapfile-cluster-group>`
+  char *getGroupString() {
+    return msGetExpressionString(&(self->group));
+  }
+
+  /// Set :ref:`FILTER <mapfile-cluster-filter>` string where `filter` is a MapServer text expression.
+  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int setFilter(char *filter) {
+    if (!filter || strlen(filter) == 0) {
+      msFreeExpression(&self->filter);
+      return MS_SUCCESS;
+    }
+    else return msLoadExpressionString(&self->filter, filter);
+  }
+
+  /// Return a string representation of :ref:`FILTER <mapfile-cluster-filter>`
+  %newobject getFilterString;
+  char *getFilterString() {
+    return msGetExpressionString(&(self->filter));
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/color.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/color.i
--- 8.0.1-5/src/mapscript/swiginc/color.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/color.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,142 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript colorObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             Seth Girvin
+
+   ===========================================================================
+   Copyright (c) 1996-2019 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend colorObj 
+{
+
+    /// Create a new instance. The color arguments are optional. 
+    colorObj(int red=0, int green=0, int blue=0, int alpha=255) 
+    {
+        colorObj *color;
+        
+        /* Check colors */
+        if (red > 255 || green > 255 || blue > 255 || alpha>255 ||
+            red<-1 || green<-1 || blue<-1 || alpha<0 ) {
+            msSetError(MS_MISCERR, "Invalid color", "colorObj()");
+            return NULL;
+        }
+    
+        color = (colorObj *)calloc(1, sizeof(colorObj));
+        if (!color)
+            return(NULL);
+    
+        MS_INIT_COLOR(*color, red, green, blue, alpha);
+
+        return(color);
+    }
+
+    ~colorObj() 
+    {
+        free(self);
+    }
+
+    /// Set all four RGBA components. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setRGB(int red, int green, int blue, int alpha = 255) 
+    {
+        /* Check colors */
+        if (red > 255 || green > 255 || blue > 255 || alpha > 255) {
+            msSetError(MS_MISCERR, "Invalid color index.", "setRGB()");
+            return MS_FAILURE;
+        }
+    
+        MS_INIT_COLOR(*self, red, green, blue, alpha);
+        return MS_SUCCESS;
+    }
+
+    /**
+    Set the color to values specified in case-independent hexadecimal notation. 
+    hex must start with a '#' followed by three or four hex bytes, e.g. '#ffffff' 
+    or '#ffffffff'. If only three hex bytes are supplied, the alpha will be set 
+    to 255. Calling setHex('#ffffff') therefore assigns values of 255 to each 
+    color component, including the alpha. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int setHex(char *psHexColor) 
+    {
+        int red, green, blue, alpha = 255;
+        if (psHexColor && (strlen(psHexColor) == 7 || strlen(psHexColor) == 9) && psHexColor[0] == '#') {
+            red = msHexToInt(psHexColor+1);
+            green = msHexToInt(psHexColor+3);
+            blue= msHexToInt(psHexColor+5);
+            if (strlen(psHexColor) == 9) {
+                alpha = msHexToInt(psHexColor+7);
+            }
+            if (red > 255 || green > 255 || blue > 255 || alpha > 255) {
+                msSetError(MS_MISCERR, "Invalid color index.", "setHex()");
+                return MS_FAILURE;
+            }
+
+            MS_INIT_COLOR(*self, red, green, blue, alpha);
+            return MS_SUCCESS;
+        }
+        else {
+            msSetError(MS_MISCERR, "Invalid hex color.", "setHex()");
+            return MS_FAILURE;
+        }
+    }   
+
+    %newobject toHex;
+    /**
+    Complement to setHex, returning a hexadecimal representation of the color 
+    components. If alpha is 255 then this is three hex bytes '#rrggbb', 
+    otherwise four hex bytes '#rrggbbaa'
+    */
+    char *toHex() 
+    {
+        char *hexcolor;
+
+        if (!self) 
+        {
+            msSetError(MS_MISCERR, "Can't express NULL color as hex",
+                       "toHex()");
+            return NULL;
+        }
+        if (self->red < 0 || self->green < 0 || self->blue < 0) 
+        {
+            msSetError(MS_MISCERR, "Can't express invalid color as hex",
+                       "toHex()");
+            return NULL;
+        }
+        if (self->alpha == 255) {
+          hexcolor = msSmallMalloc(8);
+          snprintf(hexcolor, 8, "#%02x%02x%02x",
+                   self->red, self->green, self->blue);
+        } else if (self->alpha >= 0) {
+          hexcolor = msSmallMalloc(10);
+          snprintf(hexcolor, 10, "#%02x%02x%02x%02x",
+                   self->red, self->green, self->blue, self->alpha);
+        } else {
+           msSetError(MS_MISCERR, "Can't express color with invalid alpha as hex",
+                      "toHex()");
+           return NULL;
+        }
+        return hexcolor;
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/config.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/config.i
--- 8.0.1-5/src/mapscript/swiginc/config.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/config.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,43 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript configObj extensions
+   Author:   Steve Lime 
+             Seth Girvin, sgirvin@geographika.co.uk
+             
+   ===========================================================================
+   Copyright (c) 1996-2021 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend configObj 
+{
+
+    /// Create a new instance of :class:`configObj`
+    configObj(char *filename=NULL)
+    {
+        return msLoadConfig(filename);
+    }
+
+    ~configObj()
+    {
+        msFreeConfig(self);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/connpool.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/connpool.i
--- 8.0.1-5/src/mapscript/swiginc/connpool.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/connpool.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,31 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for connection pool management
+   Author:   Umberto Nicoletti, unicoletti@prometeo.it
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+/// Some memory leaks can be avoided by closing any unreferenced 
+/// connections from time to time. See https://github.com/mapserver/mapserver/issues/1661
+void msConnPoolCloseUnreferenced();
diff -pruN 8.0.1-5/src/mapscript/swiginc/dbfinfo.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/dbfinfo.i
--- 8.0.1-5/src/mapscript/swiginc/dbfinfo.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/dbfinfo.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,74 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript DBFInfo extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend DBFInfo 
+{
+    /// Get the field name of a DBF using the field index ``iField``
+    char *getFieldName(int iField) 
+    {
+        static char pszFieldName[1000];
+        int pnWidth;
+        int pnDecimals;
+        msDBFGetFieldInfo(self, iField, &pszFieldName[0], &pnWidth, 
+                          &pnDecimals);
+        return pszFieldName;
+    }
+
+    /// Get the field width of a DBF using the field index ``iField``
+    int getFieldWidth(int iField) 
+    {
+        char pszFieldName[1000];
+        int pnWidth;
+        int pnDecimals;
+        msDBFGetFieldInfo(self, iField, &pszFieldName[0], &pnWidth,
+                          &pnDecimals);
+        return pnWidth;
+    }
+
+    /// Get the field decimals of a DBF using the field index ``iField``
+    int getFieldDecimals(int iField) 
+    {
+        char pszFieldName[1000];
+        int pnWidth;
+        int pnDecimals;
+        msDBFGetFieldInfo(self, iField, &pszFieldName[0], &pnWidth,
+                          &pnDecimals);
+        return pnDecimals;
+    }
+
+    /// Get the field type of a DBF using the field index ``iField``.
+    /// Field types are one of FTString, FTInteger, FTDouble, FTInvalid
+    int getFieldType(int iField) 
+    {
+        return msDBFGetFieldInfo(self, iField, NULL, NULL, NULL);
+    }   
+
+}
+
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/error.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/error.i
--- 8.0.1-5/src/mapscript/swiginc/error.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/error.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,62 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript errorObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+
+/* A few things necessary for automatically wrapped functions */
+%newobject msGetErrorString;
+
+%extend errorObj
+{
+    /// Create a new instance
+    errorObj() 
+    {    
+        return msGetErrorObj();
+    }
+
+    ~errorObj() {}
+
+    /// Returns the next error in the stack or NULL if the end has been reached
+    errorObj *next() 
+    {
+        errorObj *ep;
+
+        if (self == NULL || self->next == NULL) return NULL;
+
+        ep = msGetErrorObj();
+        while (ep != self) {
+            /* We reached end of list of active errorObj and 
+               didn't find the errorObj... this is bad! */
+            if (ep->next == NULL) return NULL;
+            ep = ep->next;
+        }
+    
+        return ep->next;
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/hashtable.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/hashtable.i
--- 8.0.1-5/src/mapscript/swiginc/hashtable.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/hashtable.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,86 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript hashTableObj extensions
+   Author:   Sean Gillies, sgillies@frii.com
+
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend hashTableObj {
+    
+    /// Create a new instance
+#if defined(SWIGJAVA) || defined(SWIGCSHARP)
+    hashTableObj() {
+#else
+    hashTableObj(void) {
+#endif
+        return msCreateHashTable();
+    }
+
+    /* Destroy instance */
+    ~hashTableObj() {
+        msFreeHashTable(self);
+    }
+
+    /// Set a hash item given key and value. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int set(char *key, char *value) {
+        if (msInsertHashTable(self, key, value) == NULL) {
+            return MS_FAILURE;
+        }
+        return MS_SUCCESS;
+    }
+
+    /// Returns the value of the item by its key, or default if the key does not exist
+    char *get(char *key, char *default_value=NULL) {
+        char *value = NULL;
+        if (!key) {
+            msSetError(MS_HASHERR, "NULL key", "get");
+        }
+     
+        value = (char *) msLookupHashTable(self, key);
+        if (!value) {
+            return default_value;
+        }
+        return value;
+    }
+
+    /// Removes the hash item by its key. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int remove(char *key) {
+        return msRemoveHashTable(self, key);
+    }
+
+    /// Empties the table of all items
+    void clear(void) {
+        msFreeHashItems(self);
+        initHashTable(self);
+    }
+
+    /// Returns the name of the next key or NULL if there is no valid next key.
+    /// If the input key is NULL, returns the first key
+    const char *nextKey(char *prevkey=NULL) {
+        return msNextKeyFromHashTable(self, (const char *) prevkey);
+    }
+    
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/image.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/image.i
--- 8.0.1-5/src/mapscript/swiginc/image.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/image.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,261 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript imageObj extensions
+   Author:   Steve Lime
+             Sean Gillies, sgillies@frii.com
+
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   =========================================================================*/
+
+%extend imageObj {
+
+  /**
+  Create a new :class:`imageObj` instance. If *filename* is specified, an imageObj
+  is created from the file and any specified *width*, *height*, and *format* parameters 
+  will be overridden by values of the image in *filename*.  Otherwise, if *format* is specified (as an :class:`outputFormatObj`) an imageObj is created
+  using that format. If *filename* is not specified, then *width* and *height* should be specified. 
+  The default resolution is currently 72 and defined by :data:`MS_DEFAULT_RESOLUTION` - this setting is 
+  not available in MapScript. 
+  */
+  imageObj(int width, int height, outputFormatObj *input_format=NULL,
+             const char *file=NULL,
+             double resolution=MS_DEFAULT_RESOLUTION, double defresolution=MS_DEFAULT_RESOLUTION)
+    {
+        imageObj *image=NULL;
+        outputFormatObj *format;
+        rendererVTableObj *renderer = NULL;
+        rasterBufferObj *rb = NULL;
+
+        if (input_format) {
+            format = input_format;
+        }
+        else {
+            format = msCreateDefaultOutputFormat(NULL, "AGG/PNG", "aggpng", NULL);
+            if (format)
+                msInitializeRendererVTable(format);
+        }
+        if (format == NULL) {
+            msSetError(MS_IMGERR, "Could not create output format",
+                       "imageObj()");
+            return NULL;
+        }
+
+        if (file) {
+
+            renderer = format->vtable;
+            rb = (rasterBufferObj*) malloc(sizeof(rasterBufferObj));
+            if (!rb) {
+                msSetError(MS_MEMERR, NULL, "imageObj()");
+                return NULL;
+            }
+            if ( (renderer->loadImageFromFile((char *)file, rb)) == MS_FAILURE) {
+                msFreeRasterBuffer(rb);
+                free(rb);
+                return NULL;
+            }
+            image = msImageCreate(rb->width, rb->height, format, NULL, NULL,
+                                  resolution, defresolution, NULL);
+            if (! image) {
+                msFreeRasterBuffer(rb);
+                free(rb);
+                return NULL;
+            }
+
+            if(renderer->mergeRasterBuffer(image, rb, 1.0, 0, 0, 0, 0, rb->width, rb->height) != MS_SUCCESS) {
+                msFreeImage(image);
+                image = NULL;
+            }
+
+            msFreeRasterBuffer(rb);
+            free(rb);
+
+            return image;
+        }
+
+        image = msImageCreate(width, height, format, NULL, NULL, resolution, defresolution, NULL);
+        return image;
+    }
+
+    ~imageObj()
+    {
+        msFreeImage(self);
+    }
+
+    /// Save image to filename. The optional map parameter must be specified if 
+    /// saving GeoTIFF images.
+    void save(char *filename, mapObj *map=NULL)
+    {
+        msSaveImage(map, self, filename );
+    }
+
+#ifndef SWIGPYTHON
+    /**
+    Write image data to an open file handle. Intended to replace
+    saveToString.  See ``python/pyextend.i`` for the Python specific
+    version of this method.
+    */
+    int write( FILE *file=NULL )
+    {
+        int retval=MS_FAILURE;
+        rendererVTableObj *renderer = NULL;
+
+        if (MS_RENDERER_PLUGIN(self->format))
+        {
+            if (file)
+            {
+                renderer = self->format->vtable;
+                /* FIXME? as an improvement, pass a map argument instead of the NULL (see #4216) */
+                retval = renderer->saveImage(self, NULL, file, self->format);
+            }
+            else
+            {
+                retval = msSaveImage(NULL, self, NULL);
+            }
+        }
+        else
+        {
+            msSetError(MS_IMGERR, "Writing of %s format not implemented",
+                       "imageObj::write",
+                       self->format->name);
+        }
+
+        return retval;
+    }
+#endif
+
+    /*
+    -------------------------------------------------------------------------
+    getBytes returns a gdBuffer structure (defined in mapscript.i) which must
+    be typemapped to an object appropriate to the target language.  This
+    typemap must also msFree the data member of the gdBuffer.  See the type-
+    maps in java/javamodule.i and python/pymodule.i for examples.
+
+    contributed by Jerry Pisk, jerry.pisk@gmail.com
+    -------------------------------------------------------------------------
+    */
+
+    /// Returns the image contents as a binary buffer. The exact form of this buffer will 
+    /// vary by MapScript language (e.g. a string in Python, byte[] array in Java and C#, unhandled in Perl)
+    gdBuffer getBytes()
+    {
+        gdBuffer buffer;
+
+        buffer.owns_data = MS_TRUE;
+
+        buffer.data = msSaveImageBuffer(self, &buffer.size, self->format);
+
+        if( buffer.data == NULL || buffer.size == 0 )
+        {
+            buffer.data = NULL;
+            msSetError(MS_MISCERR, "Failed to get image buffer", "getBytes");
+            return buffer;
+        }
+
+        return buffer;
+    }
+
+    /**
+    Returns the size of the binary buffer representing the image buffer
+
+    .. note:: 
+
+        The getSize method is inefficient as it does a call to getBytes and 
+        then computes the size of the byte array. The byte array is then immediately discarded. 
+        In most cases it is more efficient to call getBytes directly.
+    */
+    int getSize() {
+        gdBuffer buffer;
+        int size=0;
+
+        buffer.data = msSaveImageBuffer(self, &buffer.size, self->format);
+        size = buffer.size;
+
+        if( buffer.data == NULL || buffer.size == 0 ) {
+            buffer.data = NULL;
+            msSetError(MS_MISCERR, "Failed to get image buffer size", "getSize");
+        }
+        free(buffer.data);
+        return size;
+    }
+
+    /**
+    Pastes another imageObj on top of this imageObj.
+    If optional dstx,dsty are provided then they define the position where the
+    image should be copied (dstx,dsty = top-left corner position).
+    */
+    int pasteImage(imageObj *imageSrc, double opacity=1.0, int dstx=0, int dsty=0)
+    {
+        rendererVTableObj *renderer = NULL;
+        rasterBufferObj rb;
+
+        if (!MS_RENDERER_PLUGIN(self->format)) {
+            msSetError(MS_IMGERR, "PasteImage function should only be used with renderer plugin drivers.",
+                       "imageObj::pasteImage");
+            return MS_FAILURE;
+        }
+
+        memset(&rb,0,sizeof(rasterBufferObj));
+
+        renderer = self->format->vtable;
+        if(MS_SUCCESS != renderer->getRasterBufferHandle(imageSrc, &rb)) {
+            msSetError(MS_IMGERR, "PasteImage failed to extract rasterbuffer handle",
+                       "imageObj::pasteImage");
+            return MS_FAILURE;
+        }
+
+        if(MS_SUCCESS != renderer->mergeRasterBuffer(self, &rb, opacity, 0, 0, dstx, dsty, rb.width, rb.height)) {
+            msSetError(MS_IMGERR, "PasteImage failed to merge raster buffer",
+                       "imageObj::pasteImage");
+            return MS_FAILURE;
+        }
+
+        return MS_SUCCESS;
+
+    }
+
+    /**
+    Writes the image to temp directory.
+    Returns the image URL.
+    */
+    char *saveWebImage()
+    {
+        char *imageFile = NULL;
+        char *imageFilename = NULL;
+        char path[MS_MAXPATHLEN];
+        char *imageUrlFull = NULL;
+
+        imageFilename = msTmpFilename(self->format->extension);
+        imageFile = msBuildPath(path, self->imagepath, imageFilename);
+
+        if (msSaveImage(NULL, self, imageFile) != MS_SUCCESS) {
+            msSetError(MS_IMGERR, "Failed writing image to %s",
+                       "imageObj::saveWebImage",
+                       imageFile);
+            msFree(imageFilename);
+            return NULL;
+        }
+
+        imageUrlFull = msStrdup(msBuildPath(path, self->imageurl, imageFilename));
+        msFree(imageFilename);
+        return imageUrlFull;
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/label.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/label.i
--- 8.0.1-5/src/mapscript/swiginc/label.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/label.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,235 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript labelObj extensions
+   Author:   Steve Lime
+
+   ===========================================================================
+   Copyright (c) 1996-2007 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend labelObj
+{
+
+  /**
+  Create a new :class:`labelObj`. A :class:`labelObj` is associated with a 
+  :class:`classObj` a :class:`scalebarObj` or a :class:`legendObj`. 
+  An instance of :class:`labelObj` can exist outside of a :class:`classObj` container and be 
+  explicitly inserted into the :class:`classObj`:
+  
+  >>> new_label = new labelObj()
+  >>> the_class.addLabel(new_label)
+  */
+  labelObj() 
+    {
+      labelObj *label;
+        
+      label = (labelObj *)calloc(1, sizeof(labelObj));
+      if (!label)
+        return(NULL);
+    
+      initLabel(label);
+      
+      return(label);    	
+    }
+
+  ~labelObj() 
+    {
+      freeLabel(self);
+    }
+
+  /// Update a :class:`labelObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int updateFromString(char *snippet)
+  {
+    return msUpdateLabelFromString(self, snippet);
+  }
+
+  %newobject convertToString;
+  /// Output the :class:`labelObj` object as a Mapfile string. Provides the inverse option for :func:`labelObj.updateFromString`.
+  char* convertToString()
+  {
+    return msWriteLabelToString(self);
+  }
+
+  /// Remove the attribute binding for a specified label property.
+  int removeBinding(int binding) 
+  {
+    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return MS_FAILURE;
+
+    if(self->bindings[binding].item) {
+      free(self->bindings[binding].item);
+      self->bindings[binding].item = NULL;
+      self->bindings[binding].index = -1; 
+      self->numbindings--;
+    }
+
+    return MS_SUCCESS;
+  }
+
+  /// Get the attribute binding for a specified label property. Returns NULL if there is no binding for this property.
+  const char *getBinding(int binding) 
+  {
+    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return NULL;
+
+    return self->bindings[binding].item;
+  }
+
+  /// Set the attribute binding for a specified label property. Binding constants look like this: ``MS_LABEL_BINDING_[attribute name]``:
+  /// >>> new_label.setBinding(MS_LABEL_BINDING_COLOR, "FIELD_NAME_COLOR")
+  int setBinding(int binding, const char *item) 
+  {
+    if(!item) return MS_FAILURE;
+    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return MS_FAILURE;
+
+    if(self->bindings[binding].item) {
+      free(self->bindings[binding].item);
+      self->bindings[binding].item = NULL; 
+      self->bindings[binding].index = -1;
+      self->numbindings--;
+    }
+
+    self->bindings[binding].item = msStrdup(item); 
+    self->numbindings++;
+
+    return MS_SUCCESS;
+  }
+
+  /// Remove an expression binding for a specified label property.
+  int removeExpressionBinding(int binding) 
+  {
+    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return MS_FAILURE;
+
+    if(self->exprBindings[binding].string) {
+      msFreeExpression(&self->exprBindings[binding]);
+      self->nexprbindings--;
+    }
+
+    return MS_SUCCESS;
+  }
+
+  /// Get the expression binding for a specified label property. Returns NULL if there is no binding for this property.
+  %newobject getExpressionBinding;
+  const char *getExpressionBinding(int binding) 
+  {
+    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return NULL;
+
+    return msGetExpressionString(&(self->exprBindings[binding]));
+  }
+
+  /// Set the expression binding for a specified label property. Binding constants look like this: ``MS_LABEL_BINDING_[attribute name]``
+  /// Expressions are automatically wrapped in brackets, so do not need to be added to the input string
+  /// >>> new_label.setExpressionBinding(MS_LABEL_BINDING_PRIORITY, "[priority] * 2")
+  int setExpressionBinding(int binding, const char *text) 
+  {
+    if (!text || strlen(text) == 0) {
+      return MS_FAILURE;
+    }
+
+    if(binding < 0 || binding >= MS_LABEL_BINDING_LENGTH) return MS_FAILURE;
+
+    if(self->exprBindings[binding].string) {
+      msFreeExpression(&self->exprBindings[binding]);
+      self->nexprbindings--;
+    }
+
+    self->exprBindings[binding].string = msStrdup(text);
+    self->exprBindings[binding].type = MS_EXPRESSION;
+    self->nexprbindings++;
+
+    return MS_SUCCESS;
+  }
+
+  /// Set the label expression property
+  int setExpression(char *expression) 
+  {
+    if (!expression || strlen(expression) == 0) {
+       msFreeExpression(&self->expression);
+       return MS_SUCCESS;
+    }
+    else return msLoadExpressionString(&self->expression, expression);
+  }
+
+  /// Returns the label expression string.
+  %newobject getExpressionString;
+  char *getExpressionString() {
+    return msGetExpressionString(&(self->expression));
+  }
+
+  /// Set the label text.
+  int setText(char *text) {
+    if (!text || strlen(text) == 0) {
+      msFreeExpression(&self->text);
+      return MS_SUCCESS;
+    }	
+    else return msLoadExpressionString(&self->text, text);
+  }
+
+  /// Returns the label text string.
+  %newobject getTextString;
+  char *getTextString() {
+    return msGetExpressionString(&(self->text));
+  }
+
+  %newobject getStyle;
+  /// Return a reference to the :class:`styleObj` at index *i* in the styles array.
+  styleObj *getStyle(int i) {
+      if (i >= 0 && i < self->numstyles) {
+          MS_REFCNT_INCR(self->styles[i]);
+          return self->styles[i];
+      } else {
+          msSetError(MS_CHILDERR, "Invalid index: %d", "getStyle()", i);
+          return NULL;
+      }
+  }
+
+#ifdef SWIGCSHARP
+%apply SWIGTYPE *SETREFERENCE {styleObj *style};
+#endif
+
+    /// Insert a copy of style into the styles array at index *index*. 
+    /// Default is -1, or the end of the array. Returns the index at which the style was inserted.
+    int insertStyle(styleObj *style, int index=-1) {
+        return msInsertLabelStyle(self, style, index);
+    }
+#ifdef SWIGCSHARP 
+%clear styleObj *style;
+#endif
+
+    %newobject removeStyle;
+    /// Remove the styleObj at *index* from the styles array and return a copy.
+    styleObj *removeStyle(int index) {
+        styleObj* style = (styleObj *) msRemoveLabelStyle(self, index);
+        if (style) {
+            MS_REFCNT_INCR(style);
+        }
+        return style;
+    }
+
+    /// Swap the styleObj at *index* with the styleObj index - 1.
+    int moveStyleUp(int index) {
+        return msMoveLabelStyleUp(self, index);
+    }
+
+    /// Swap the styleObj at *index* with the styleObj index + 1.
+    int moveStyleDown(int index) {
+       return msMoveLabelStyleDown(self, index);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/labelcache.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/labelcache.i
--- 8.0.1-5/src/mapscript/swiginc/labelcache.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/labelcache.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,40 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript labelCacheObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend labelCacheObj 
+{
+
+    /// Free the labelCache
+    void freeCache() 
+    {
+        msFreeLabelCache(self);
+    }
+}
+
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/layer.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/layer.i
--- 8.0.1-5/src/mapscript/swiginc/layer.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/layer.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,836 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript layerObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend layerObj 
+{
+
+    /**
+    A :class:`layerObj` is associated with :class:`mapObj`. An instance of 
+    :class:`layerObj` can exist outside of a :class:`mapObj`
+    */
+    layerObj(mapObj *map=NULL) 
+    {
+        layerObj *layer;
+        int result;
+        
+        if (!map) {
+            layer = (layerObj *) malloc(sizeof(layerObj));
+            if (!layer) {
+                msSetError(MS_MEMERR, "Failed to initialize Layer",
+                                       "layerObj()");
+                return NULL;
+            } 
+            result = initLayer(layer, NULL);
+            if (result == MS_SUCCESS) {
+                layer->index = -1;
+                return layer;
+            }
+            else {
+                msSetError(MS_MEMERR, "Failed to initialize Layer",
+                                       "layerObj()");
+                return NULL;
+            }
+        }
+        else {
+            if(msGrowMapLayers(map) == NULL)
+                return(NULL);
+
+            if (initLayer((map->layers[map->numlayers]), map) == -1)
+                return(NULL);
+
+            map->layers[map->numlayers]->index = map->numlayers;
+            map->layerorder[map->numlayers] = map->numlayers;
+            map->numlayers++;
+        MS_REFCNT_INCR(map->layers[map->numlayers-1]);
+
+            return (map->layers[map->numlayers-1]);
+        }
+    }
+ 
+    /// Sets an opacity for the layer, where the value is an integer in range [0, 100]. 
+    /// A new :ref:`composite` block is generated, containing this ``OPACITY`` value.
+    void setOpacity(int opacity)
+    {
+      msSetLayerOpacity(self, opacity);
+    }
+
+    /// Returns the opacity value for the layer.
+    int getOpacity() {
+      if(self->compositer) return (self->compositer->opacity);
+      return (100);
+    }
+
+    ~layerObj() 
+    {
+        /*if (!self->map) {*/
+        if (self) {
+            if(freeLayer(self)==MS_SUCCESS) {
+                free(self);
+        }
+        }
+    }
+
+#if defined (SWIGJAVA) || defined(SWIGPHP)
+    %newobject cloneLayer;
+    layerObj *cloneLayer() 
+#else
+    %newobject clone;
+    /**
+    Return an independent copy of the layer with no parent map.
+
+    .. note::
+
+        In the Java & PHP modules this method is named ``cloneLayer``.    
+    */
+    layerObj *clone() 
+#endif
+    {
+        layerObj *layer;
+        int result;
+
+        layer = (layerObj *) malloc(sizeof(layerObj));
+        if (!layer) {
+            msSetError(MS_MEMERR, "Failed to initialize Layer",
+                                  "layerObj()");
+            return NULL;
+        } 
+        result = initLayer(layer, NULL);
+        if (result != MS_SUCCESS) {
+            msSetError(MS_MEMERR, "Failed to initialize Layer",
+                                  "layerObj()");
+            return NULL;
+        }
+
+        if (msCopyLayer(layer, self) != MS_SUCCESS) {
+            freeLayer(layer);
+            free(layer);
+            layer = NULL;
+        }
+        layer->map = NULL;
+        layer->index = -1;
+        
+        return layer;
+    }
+
+    /// Update a :class:`layerObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int updateFromString(char *snippet)
+    {
+        return msUpdateLayerFromString(self, snippet);
+    }
+    
+    %newobject convertToString;
+    /// Output the :class:`layerObj` object as a Mapfile string. Provides the inverse option for :func:`layerObj.updateFromString`.
+    char* convertToString()
+    {
+        return msWriteLayerToString(self);
+    }
+
+#ifdef SWIGCSHARP
+%apply SWIGTYPE *SETREFERENCE {classObj *classobj};
+#endif
+    /// Insert a **copy** of the class into the layer at the requested *index*. 
+    /// Default index of -1 means insertion at the end of the array of classes. Returns the index at which the class was inserted.
+    int insertClass(classObj *classobj, int index=-1)
+    {
+        return msInsertClass(self, classobj, index);
+    }
+#ifdef SWIGCSHARP
+%clear classObj *classobj;
+#endif
+
+
+    %newobject removeClass;
+    /// Removes the class at *index* and returns a copy, or NULL in the case of a failure. 
+    /// Note that subsequent classes will be renumbered by this operation. 
+    /// The numclasses field contains the number of classes available.
+    classObj *removeClass(int index) 
+    {
+        classObj* c = msRemoveClass(self, index);
+    if (c != NULL) {
+        MS_REFCNT_INCR(c);
+    }
+    return c;
+    }
+
+    /// Opens the underlying layer. This is required before operations like :func:`layerObj.getResult`
+    /// will work, but is not required before a draw or query call.
+    int open() 
+    {
+        int status;
+        status =  msLayerOpen(self);
+        if (status == MS_SUCCESS) {
+            return msLayerGetItems(self);
+        }
+        return status;
+    }
+
+    /**
+    Performs a spatial, and optionally an attribute based feature search. 
+    The function basically prepares things so that candidate features can be accessed by 
+    query or drawing functions (e.g using :func:`layerObj.nextShape` function). 
+    Returns :data:`MS_SUCCESS`, :data:`MS_FAILURE` or :data:`MS_DONE`.
+    MS_DONE is returned if the layer extent does not overlap *rect*.
+    */
+    int whichShapes(rectObj rect)
+    {
+        int oldconnectiontype = self->connectiontype;
+        self->connectiontype = MS_INLINE;
+
+        if(msLayerWhichItems(self, MS_TRUE, NULL) != MS_SUCCESS) {
+            self->connectiontype = oldconnectiontype;
+            return MS_FAILURE;
+        }
+        self->connectiontype = oldconnectiontype;
+
+        return msLayerWhichShapes(self, rect, MS_FALSE);
+    }    
+
+    %newobject nextShape;
+    /**
+    Called after :func:`layerObj.whichShapes` has been called to actually 
+    retrieve shapes within a given area returns a shape object or :data:`MS_FALSE`
+    Example of usage:
+
+    .. code-block::
+
+        mapObj map = new mapObj("d:/msapps/gmap-ms40/htdocs/gmap75.map");
+        layerObj layer = map.getLayerByName('road');
+        int status = layer.open();
+        status = layer.whichShapes(map.extent);
+        shapeObj shape;
+        while ((shape = layer.nextShape()) != null)
+        {
+          ...
+        }
+        layer.close();
+
+    */
+    shapeObj *nextShape() 
+    {
+       int status;
+       shapeObj *shape;
+
+       shape = (shapeObj *)malloc(sizeof(shapeObj));
+       if (!shape) return NULL;
+       msInitShape(shape);
+
+       status = msLayerNextShape(self, shape);
+       if(status != MS_SUCCESS) {
+         msFreeShape(shape);
+     free(shape);
+     return NULL;
+       } else
+         return shape;
+    }
+
+    /// Close the underlying layer.
+    void close() 
+    {
+        msLayerClose(self);
+    }
+
+    %newobject getShape;
+    /// Get a shape from layer data. Argument is a result cache member from :func:`layerObj.getResult`
+    shapeObj *getShape(resultObj *record) 
+    {
+        int retval;
+        shapeObj *shape;
+
+        if (!record) return NULL;
+    
+        shape = (shapeObj *)malloc(sizeof(shapeObj));
+        if (!shape) return NULL;
+
+        msInitShape(shape);
+        shape->type = self->type; /* is this right? */
+
+        retval = msLayerGetShape(self, shape, record);
+        if(retval != MS_SUCCESS) {
+          msFreeShape(shape);
+          free(shape);
+          return NULL;
+        } else
+        return shape;
+    }
+
+    /// Returns the number of entries in the query result cache for this layer.
+    int getNumResults() 
+    {
+        if (!self->resultcache) return 0;
+        return self->resultcache->numresults;
+    }
+
+    %newobject getResultsBounds;
+    /// Returns the bounds of the features in the result cache.
+    rectObj *getResultsBounds() 
+    {
+        rectObj *bounds;
+        if (!self->resultcache) return NULL;
+        bounds = (rectObj *) malloc(sizeof(rectObj));
+        MS_COPYRECT(bounds, &self->resultcache->bounds);
+        return bounds;
+    }
+
+    /// Fetches the requested query result cache entry, or NULL if the index is outside 
+    /// the range of available results. This method would normally only be used after 
+    /// issuing a query operation.
+    resultObj *getResult(int i) 
+    {
+        if (!self->resultcache) return NULL;
+        if (i >= 0 && i < self->resultcache->numresults)
+            return &self->resultcache->results[i]; 
+        else
+            return NULL;
+    }
+
+    %newobject getClass;
+    /// Fetch the requested class object at *i*. Returns NULL if the class index is out of the legal range. 
+    /// The numclasses field contains the number of classes available, and the first class is index 0.
+    classObj *getClass(int i) 
+    {
+        classObj *result=NULL;
+        if (i >= 0 && i < self->numclasses) {
+            result=self->class[i];
+            MS_REFCNT_INCR(result);
+        }
+        return result;
+    }
+
+    /// Returns the requested item. Items are attribute fields, and this method returns the 
+    /// item name (field name). The numitems field contains the number of items available, and the first item is index zero.
+    char *getItem(int i) 
+    {
+  
+        if (i >= 0 && i < self->numitems)
+            return (char *) (self->items[i]);
+        else
+            return NULL;
+    }
+
+    /// Set the items to be retrieved with a particular shape.
+    int setItems(char **items, int numitems) {
+        return msLayerSetItems(self, items, numitems);
+    }
+
+    /// Renders this layer into the target image, adding labels to the cache if required. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. 
+    // TODO: Does the map need to be the map on which the layer is defined? I suspect so.
+    int draw(mapObj *map, imageObj *image) 
+    {
+        return msDrawLayer(map, self, image);    
+    }
+
+    /// Draw query map for a single layer into the target image. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. 
+    int drawQuery(mapObj *map, imageObj *image) 
+    {
+        return msDrawQueryLayer(map, self, image);    
+    }
+
+    /**
+    Query by the filter *string*. 
+    For querying, we switch layer status ON and then back to original
+    value before returning. 
+    */
+    int queryByFilter(mapObj *map, char *string)
+    {
+        int status;
+        int retval;
+
+        msInitQuery(&(map->query));
+
+        map->query.type = MS_QUERY_BY_FILTER;
+        map->query.mode = MS_QUERY_MULTIPLE;
+
+        map->query.filter.string = msStrdup(string);
+        map->query.filter.type = MS_EXPRESSION;
+        
+        map->query.layer = self->index;
+        map->query.rect = map->extent;
+
+        status = self->status;
+        self->status = MS_ON;
+        retval = msQueryByFilter(map);
+        self->status = status;
+        return retval;
+    }
+
+    /**
+    Query layer for shapes that intersect current map extents. *qitem* is the item (attribute) 
+    on which the query is performed, and *qstring* is the expression to match. 
+    The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
+    Note that the layer's FILTER/FILTERITEM are ignored by this function. *mode* is :data:`MS_SINGLE` or :data:`MS_MULTIPLE` depending on number of results you want. 
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
+    */
+    int queryByAttributes(mapObj *map, char *qitem, char *qstring, int mode) 
+    {
+        int status;
+        int retval;
+
+        msInitQuery(&(map->query));
+        
+        map->query.type = MS_QUERY_BY_FILTER;
+        map->query.mode = mode;
+
+        if(qitem) map->query.filteritem = msStrdup(qitem);
+        if(qstring) {
+          msInitExpression(&map->query.filter);
+          msLoadExpressionString(&map->query.filter, qstring);
+        }
+
+        map->query.layer = self->index;
+        map->query.rect = map->extent;
+
+        status = self->status;
+        self->status = MS_ON;
+        retval = msQueryByFilter(map);
+        self->status = status;
+
+        return retval;
+    }
+
+    /**
+    Query layer at point location specified in georeferenced map coordinates (i.e. not pixels). 
+    The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
+    Note that the layer's FILTER/FILTERITEM are ignored by this function. *mode* is :data:`MS_SINGLE` or :data:`MS_MULTIPLE` depending on number of results you want. 
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
+    */
+    int queryByPoint(mapObj *map, pointObj *point, int mode, double buffer) 
+    {
+        int status;
+        int retval;
+
+        msInitQuery(&(map->query));
+
+        map->query.type = MS_QUERY_BY_POINT;
+        map->query.mode = mode;
+        map->query.point = *point;
+        map->query.buffer = buffer;
+        map->query.layer = self->index;
+        
+        status = self->status;
+        self->status = MS_ON;
+        retval = msQueryByPoint(map);
+        self->status = status;
+
+        return retval;
+    }
+
+    /**
+    Query layer using a rectangle specified in georeferenced map coordinates (i.e. not pixels).
+    The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
+    Note that the layer's FILTER/FILTERITEM are ignored by this function. The :data:`MS_MULTIPLE` mode is set by default.
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
+    */
+    int queryByRect(mapObj *map, rectObj rect) 
+    {
+        int status;
+        int retval;
+
+        msInitQuery(&(map->query));
+
+        map->query.type = MS_QUERY_BY_RECT;
+        map->query.mode = MS_QUERY_MULTIPLE;
+        map->query.rect = rect; 
+        map->query.layer = self->index;
+
+        status = self->status;
+        self->status = MS_ON;
+        retval = msQueryByRect(map);
+        self->status = status;
+
+        return retval;
+    }
+
+    /**
+    Perform a query set based on a previous set of results from another layer. 
+    At present the results MUST be based on a polygon layer. 
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
+    */
+    int queryByFeatures(mapObj *map, int slayer) 
+    {
+        int status;
+        int retval;
+
+        map->query.slayer = slayer;
+        map->query.layer = self->index;
+
+        status = self->status;
+        self->status = MS_ON;
+        retval = msQueryByFeatures(map);
+        self->status = status;
+        return retval;
+    }
+
+    /**
+    Query layer based on a single shape, the shape has to be a polygon at this point. 
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
+    */
+    int queryByShape(mapObj *map, shapeObj *shape) 
+    {
+        int status;
+        int retval;
+        
+        msInitQuery(&(map->query));
+
+        map->query.type = MS_QUERY_BY_SHAPE;
+        map->query.mode = MS_QUERY_MULTIPLE;
+        map->query.shape = (shapeObj *) malloc(sizeof(shapeObj));
+        msInitShape(map->query.shape);
+        msCopyShape(shape, map->query.shape);
+        map->query.layer = self->index;
+
+        status = self->status;
+        self->status = MS_ON;
+        retval = msQueryByShape(map);
+        self->status = status;
+        return retval;
+    }
+
+    /// Pop a query result member into the layer's result cache. By default clobbers existing cache.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int queryByIndex(mapObj *map, int tileindex, int shapeindex, int bAddToQuery=MS_FALSE)
+    {
+        int status;
+        int retval;
+        
+        msInitQuery(&(map->query));
+
+        map->query.type = MS_QUERY_BY_INDEX;
+        map->query.mode = MS_QUERY_SINGLE;
+        map->query.tileindex = tileindex;
+        map->query.shapeindex = shapeindex;
+        map->query.clear_resultcache = !bAddToQuery;
+        map->query.layer = self->index;
+
+        status = self->status;
+        self->status = MS_ON;
+        retval = msQueryByIndex(map);
+        self->status = status;
+        return retval;
+    }
+    
+    /// Returns a reference to layer's result cache. Should be NULL prior to any query, or after a failed query or query with no results.
+    resultCacheObj *getResults(void)
+    {
+        return self->resultcache;
+    }
+
+    /// Sets a filter expression similarly to the FILTER expression in a map file. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE` if the expression fails to parse.
+    int setFilter(char *filter) 
+    {
+        if (!filter || strlen(filter) == 0) {
+            msFreeExpression(&self->filter);
+            return MS_SUCCESS;
+        }
+        else return msLoadExpressionString(&self->filter, filter);
+    }
+
+    %newobject getFilterString;
+    /// Returns the current filter expression.
+    char *getFilterString() 
+    {
+        return msGetExpressionString(&(self->filter));
+    }
+
+    /// Set the layer projection using OpenGIS Well Known Text format. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setWKTProjection(char *wkt) 
+    {
+        self->project = MS_TRUE;
+        return msOGCWKT2ProjectionObj(wkt, &(self->projection), self->debug);
+    }
+
+    %newobject getProjection;
+    /// Returns the PROJ definition of the layer's projection.
+    char *getProjection() 
+    {    
+        return (char *) msGetProjectionString(&(self->projection));
+    }
+
+    /**
+    Set the layer projection using a PROJ format projection definition 
+    (i.e. "+proj=utm +zone=11 +datum=WGS84" or "init=EPSG:26911"). 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int setProjection(char *proj4) 
+    {
+        self->project = MS_TRUE;
+        return msLoadProjectionString(&(self->projection), proj4);
+    }
+
+    /// Add a new inline feature on a layer. Returns -1 on error. 
+    /// TODO: Is this similar to inline features in a mapfile? Does it work for any kind of layer or connection type?
+    int addFeature(shapeObj *shape) 
+    {    
+        self->connectiontype = MS_INLINE;
+        if(self->features != NULL && self->features->tailifhead != NULL) 
+            shape->index = self->features->tailifhead->shape.index + 1;
+        else 
+            shape->index = 0;
+        if (insertFeatureList(&(self->features), shape) == NULL) 
+        return MS_FAILURE;
+        return MS_SUCCESS;
+    }
+
+    /// Returns the number of inline features in a layer. 
+    /// TODO: is this really only online features or will it return the number of non-inline features on a regular layer?
+    int getNumFeatures() 
+    {
+        return msLayerGetNumFeatures(self);
+    }
+
+    %newobject getExtent;
+    /// Fetches the extents of the data in the layer. This normally requires a full read pass through the features of the layer and does not work for raster layers.
+    rectObj *getExtent() 
+    {
+        rectObj *extent;
+        extent = (rectObj *) malloc(sizeof(rectObj));
+        msLayerGetExtent(self, extent);
+        return extent;
+    }
+
+    /// Sets the extent of a layer. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setExtent(double minx=-1.0, double miny=-1.0,
+                  double maxx=-1.0, double maxy=-1.0)
+    {
+        if (minx > maxx || miny > maxy) {
+            msSetError(MS_RECTERR,
+                "{ 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }",
+                "layerObj::setExtent()", minx, miny, maxx, maxy);
+            return MS_FAILURE;
+        }
+
+        return msLayerSetExtent(self, minx, miny, maxx, maxy);
+    }
+
+    %newobject getWMSFeatureInfoURL;
+    /**
+    Return a WMS GetFeatureInfo URL (works only for WMS layers) *clickX*, *clickY*
+    is the location of to query in pixel coordinates with (0,0) at the top 
+    left of the image. *featureCount* is the number of results to return. *infoFormat* 
+    is the format the format in which the result should be requested. 
+    Depends on remote server's capabilities. MapServer WMS servers support only "MIME" 
+    (and should support "GML.1" soon). Returns "" and outputs a warning if layer is not a 
+    WMS layer or if it is not queryable.
+    */
+    char *getWMSFeatureInfoURL(mapObj *map, int click_x, int click_y,
+                               int feature_count, char *info_format)
+    {
+        return (char *) msWMSGetFeatureInfoURL(map, self, click_x, click_y,
+               feature_count, info_format);
+    }
+ 
+    %newobject executeWFSGetFeature;
+    /// Executes a GetFeature request on a WFS layer and returns the name of the temporary GML file created. Returns an empty string on error.
+    char *executeWFSGetFeature(layerObj *layer) 
+    {
+        return (char *) msWFSExecuteGetFeature(layer);
+    }
+
+    /**
+    Apply the SLD document to the layer object. The matching between the SLD document and the 
+    layer will be done using the layer's name. If a *stylelayer* argument is passed (argument is optional), 
+    the NamedLayer in the SLD that matches it will be used to style the layer. 
+    See SLD HOWTO for more information on the SLD support.
+    */
+    int applySLD(char *sld, char *stylelayer) 
+    {
+      return msSLDApplySLD(self->map, sld, self->index, stylelayer, NULL);
+    }
+
+    /**
+    Apply the SLD document pointed by the URL to the layer object. The matching between the SLD document and the 
+    layer will be done using the layer's name. If a *stylelayer* argument is passed (argument is optional), 
+    the NamedLayer in the SLD that matches it will be used to style the layer. 
+    See SLD HOWTO for more information on the SLD support.
+    */
+    int applySLDURL(char *sld, char *stylelayer) 
+    {
+      return msSLDApplySLDURL(self->map, sld, self->index, stylelayer, NULL);
+    }
+
+    %newobject generateSLD; 
+    /// Returns an SLD XML string based on all the classes found in the layer (the layer must have ``STATUS ON```).
+    char *generateSLD() 
+    {
+        return (char *) msSLDGenerateSLD(self->map, self->index, NULL);
+    }
+
+    /// Returns :data:`MS_TRUE` or :data:`MS_FALSE` after considering the layer status, 
+    /// minscaledenom, and maxscaledenom within the context of the parent map.
+    int isVisible()
+    {
+        if (!self->map)
+        {
+            msSetError(MS_MISCERR,
+                "visibility has no meaning outside of a map context",
+                "isVisible()");
+            return MS_FAILURE;
+        }
+        return msLayerIsVisible(self->map, self);
+    }
+
+    /**
+    The class specified by the class index will be moved up in the array of classes. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. For example ``moveClassUp(1)`` will have the effect 
+    of moving class 1 up to position 0, and the class at position 0 will be moved to position 1.
+    */
+    int moveClassUp(int index) 
+    {
+        return msMoveClassUp(self, index);
+    }
+
+    /**
+    The class specified by the class index will be moved up into the array of classes. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. For example ``moveClassDown(1)`` will have the effect 
+    of moving class 1 down to position 2, and the class at position 2 will be moved to position 1.
+    */
+    int moveClassDown(int index) 
+    {
+        return msMoveClassDown(self, index);
+    }
+
+    /**
+    Adds or replaces a processing directive of the form "key=value". 
+    Unlike the :func:`layerObj.addProcessing` function, this will replace an existing processing directive 
+    for the given key value. Processing directives supported are specific to the layer type 
+    and underlying renderer.
+    */
+    void setProcessingKey(const char *key, const char *value) 
+    {
+       msLayerSetProcessingKey( self, key, value );
+    }
+ 
+    /// Adds a new processing directive line to a layer, similar to the PROCESSING directive 
+    /// in a map file. Processing directives supported are specific to the layer type and 
+    /// underlying renderer.
+    void addProcessing(const char *directive ) 
+    {
+        msLayerAddProcessing( self, directive );
+    }
+
+    /// Return the raster processing directive at *index*.
+    char *getProcessing(int index) 
+    {
+        return (char *) msLayerGetProcessing(self, index);
+    }
+
+    /// Return the processing directive specified by *key*.
+    char *getProcessingKey(const char *key)
+    {
+      return (char *) msLayerGetProcessingKey(self, key);
+    }    
+
+    /**
+    Clears the layer's raster processing directives. 
+    Returns the subsequent number of directives, which will equal :data:`MS_SUCCESS` if the 
+    directives have been cleared.
+    */
+    int clearProcessing() 
+    {
+        return msLayerClearProcessing(self);
+    }
+
+    /**
+    Changes the connectiontype of the layer and recreates the vtable according to the new 
+    connection type. This method should be used instead of setting the *connectiontype*
+    parameter directly. In case when the layer.connectiontype = :data:`MS_PLUGIN` the *library_str* 
+    parameter should also be specified so as to select the library to load by MapServer. 
+    For the other connection types this parameter should be set to an empty string "". 
+    */
+    int setConnectionType(int connectiontype, const char *library_str) 
+    {    
+        /* Caller is responsible to close previous layer correctly before
+         * calling msConnectLayer() 
+         */
+        if (msLayerIsOpen(self))
+          msLayerClose(self);
+        return msConnectLayer(self, connectiontype, library_str);
+    }
+
+    /**
+    Get the class index for a shape in the layer.
+    */
+    int getClassIndex(mapObj *map, shapeObj *shape, int *classgroup=NULL, int numclasses=0) {
+        return msShapeGetClass(self, map, shape, classgroup, numclasses);
+    }
+
+    /**
+    Return the geomtransform string for the layer. 
+    */
+    char *getGeomTransform() 
+    {
+      return self->_geomtransform.string;
+    }
+
+    /**
+    Set the geomtransform string for the layer. 
+    */
+    void setGeomTransform(char *transform) 
+    {
+      msFree(self->_geomtransform.string);
+      if (!transform || strlen(transform) > 0) {
+        self->_geomtransform.string = msStrdup(transform);
+        self->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
+      }
+      else {
+        self->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
+        self->_geomtransform.string = NULL;
+      }
+    }
+
+    /**
+    Returns the requested item's field type.
+    A layer must be open to retrieve the item definition. 
+
+    Pass in the attribute index to retrieve the type. The 
+    layer's numitems property contains the number of items 
+    available, and the first item is index zero.
+    */
+    char *getItemType(int i)
+    {
+
+        char *itemType = NULL;
+
+        if (i >= 0 && i < self->numitems) {
+            gmlItemListObj *item_list;
+            item_list = msGMLGetItems(self, "G");
+            if (item_list != NULL) {
+                gmlItemObj *item = item_list->items + i;
+                itemType = msStrdup(item->type);
+                msGMLFreeItems(item_list); // destroy the original list
+            }
+        }
+
+        return itemType;
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/legend.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/legend.i
--- 8.0.1-5/src/mapscript/swiginc/legend.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/legend.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,43 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript legendObj extensions
+   Author:   Steve Lime
+
+   ===========================================================================
+   Copyright (c) 1996-2007 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend legendObj
+{
+  /// Update a :class:`legendObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int updateFromString(char *snippet)
+  {
+    return msUpdateLegendFromString(self, snippet);
+  }
+  
+  %newobject convertToString;
+  /// Output the :class:`legendObj` object as a Mapfile string. Provides the inverse option for :func:`legendObj.updateFromString`.
+  char* convertToString()
+  {
+    return msWriteLegendToString(self);
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/line.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/line.i
--- 8.0.1-5/src/mapscript/swiginc/line.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/line.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,115 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript lineObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend lineObj 
+{
+
+    /// A :class:`lineObj` is composed of one or more :class:`pointObj` instances
+    lineObj() 
+    {
+        lineObj *line;
+
+        line = (lineObj *)malloc(sizeof(lineObj));
+        if (!line)
+            return(NULL);
+
+        line->numpoints=0;
+        line->point=NULL;
+
+        return line;
+    }
+
+    ~lineObj() 
+    {
+        free(self->point);
+        free(self);		
+    }
+
+    /// Transform line in place from proj_in to proj_out.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(projectionObj *projin, projectionObj *projout) 
+    {
+        return msProjectLine(projin, projout, self);
+    }
+
+    /// Reproject line given a reprojection object. Transformation is done in place.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(reprojectionObj *reprojector)
+    {
+        return msProjectLineEx(reprojector, self);
+    }
+
+    /// Return reference to point at index *i*.
+    pointObj *get(int i) 
+    {
+        if (i<0 || i>=self->numpoints)
+            return NULL;
+        else
+            return &(self->point[i]);
+    }
+
+    /// Add point *p* to the line.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int add(pointObj *p)
+    {
+        if (self->numpoints == 0) { /* new */	
+        self->point = (pointObj *)malloc(sizeof(pointObj));
+        if (!self->point)
+            return MS_FAILURE;
+        } else { /* extend array */
+            self->point = (pointObj *)realloc(self->point, 
+                                      sizeof(pointObj)*(self->numpoints+1));
+        if (!self->point)
+            return MS_FAILURE;
+        }
+
+        self->point[self->numpoints].x = p->x;
+        self->point[self->numpoints].y = p->y;
+        self->point[self->numpoints].z = p->z;
+        self->point[self->numpoints].m = p->m;
+        self->numpoints++;
+
+        return MS_SUCCESS;
+    }
+
+    /// Set the point at index *i* to point *p*. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int set(int i, pointObj *p)
+    {
+        if (i<0 || i>=self->numpoints)
+            return MS_FAILURE;
+
+        self->point[i].x = p->x;
+        self->point[i].y = p->y;
+        self->point[i].z = p->z;
+        self->point[i].m = p->m;
+        return MS_SUCCESS;
+    }
+
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/map.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/map.i
--- 8.0.1-5/src/mapscript/swiginc/map.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/map.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,718 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript mapObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend mapObj 
+{
+
+    /// Create a new instance of :class:`mapObj`. Note that the *filename* is optional.
+    mapObj(const char *filename="", configObj *config=NULL) 
+    {
+        if (filename && strlen(filename))
+            return msLoadMap(filename, NULL, config);
+        else { /* create an empty map, no layers etc... */
+            return msNewMapObj();
+        }      
+    }
+
+#ifdef SWIGCSHARP
+
+  mapObj(const char *filename) 
+  {
+        if (filename && strlen(filename))
+            return msLoadMap(filename, NULL, NULL);
+        else { /* create an empty map, no layers etc... */
+            return msNewMapObj();
+        } 
+  }
+
+  mapObj(char *mapText, int isMapText /*used as signature only to differentiate this constructor from default constructor*/ ) 
+  {
+      return msLoadMapFromString(mapText, NULL, NULL);
+  }
+
+  mapObj(char *mapText, int isMapText, configObj *config) 
+  {
+      return msLoadMapFromString(mapText, NULL, config);
+  }
+
+#endif 
+    
+    ~mapObj() 
+    {
+        msFreeMap(self);
+    }
+
+#if defined (SWIGJAVA) || defined (SWIGPHP)
+    %newobject cloneMap;
+    mapObj *cloneMap() 
+#else
+    %newobject clone;
+    /**
+    Return an independent copy of the map, less any caches.
+
+    .. note::
+
+        In the Java & PHP modules this method is named ``cloneMap``.
+    */
+    mapObj *clone() 
+#endif
+    {
+        mapObj *dstMap;
+        dstMap = msNewMapObj();
+        if (msCopyMap(dstMap, self) != MS_SUCCESS) {
+            msFreeMap(dstMap);
+            dstMap = NULL;
+        }
+        return dstMap;
+    }
+    
+#ifdef SWIGCSHARP
+%apply SWIGTYPE *SETREFERENCE {layerObj *layer};
+#endif
+    /**
+    Insert a copy of *layer* into the map at *index*.
+    The default value of *index* is -1, which means the last possible index. 
+    Returns the index of the new layer, or -1 in the case of a failure.
+    */
+    int insertLayer(layerObj *layer, int index=-1) 
+    {
+        return msInsertLayer(self, layer, index);  
+    }
+#ifdef SWIGCSHARP
+%clear layerObj *layer;
+#endif
+
+    %newobject removeLayer;
+    /// Remove the layer at *index*. Returns the :class:`layerObj`. 
+    layerObj *removeLayer(int index) 
+    {
+        layerObj *layer=msRemoveLayer(self, index);
+        MS_REFCNT_INCR(layer);
+        return layer;
+    }
+
+    /**
+    Set the map extent, returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`. 
+    This method will correct the extents (width/height ratio) before setting the 
+    minx, miny, maxx, maxy values. See extent properties to set up a custom extent from :class:`rectObj`.
+    */
+    int setExtent(double minx, double miny, double maxx, double maxy) {
+        return msMapSetExtent( self, minx, miny, maxx, maxy );
+    }
+
+    /// Offset the map extent based on the given distances in map coordinates. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    int offsetExtent(double x, double y) {
+        return msMapOffsetExtent( self, x, y );
+    }
+
+    /**
+    Scale the map extent using the *zoomfactor* and ensure the extent within 
+    the *minscaledenom* and *maxscaledenom* domain. If *minscaledenom* and/or *maxscaledenom*
+    is 0 then the parameter is not taken into account. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int scaleExtent(double zoomfactor, double minscaledenom, double maxscaledenom) {
+        return msMapScaleExtent( self, zoomfactor, minscaledenom, maxscaledenom );
+    }
+
+    /// Set the map center to the given map point. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    int setCenter(pointObj *center) {
+        return msMapSetCenter( self, center );
+    }
+
+    /*
+    Set map's image *width* and *height* together and carry out the necessary subsequent 
+    geotransform computation. 
+
+    Recent rotation work makes setSize the only reliable 
+    method for changing the image size - direct access is deprecated. 
+
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int setSize(int width, int height) 
+    {
+        return msMapSetSize(self, width, height);
+    }
+
+    /// TODO
+    void pixelToGeoref(double pixPosX, double pixPosY, pointObj *geoPos)
+    {
+       geoPos->x = self->gt.geotransform[0] + self->gt.geotransform[1] * pixPosX + self->gt.geotransform[2] * pixPosY;
+       geoPos->y = self->gt.geotransform[3] + self->gt.geotransform[4] * pixPosX + self->gt.geotransform[5] * pixPosY;
+    }
+
+    /// Returns the map rotation angle.
+    double getRotation() 
+    {
+        return self->gt.rotation_angle;
+    }
+
+    /**
+    Set map rotation angle. The map view rectangle (specified in EXTENTS) will be rotated by 
+    the indicated angle in the counter- clockwise direction. Note that this implies the 
+    rendered map will be rotated by the angle in the clockwise direction. 
+
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int setRotation( double rotation_angle ) 
+    {
+        return msMapSetRotation( self, rotation_angle );
+    }
+
+    %newobject getLayer;
+    /// Returns a reference to the layer at index *i*.
+    layerObj *getLayer(int i) {
+      if(i >= 0 && i < self->numlayers) {
+          MS_REFCNT_INCR(self->layers[i]);
+          return (self->layers[i]); /* returns an EXISTING layer */
+      } else {
+        return NULL;
+      }
+    }
+
+    %newobject getLayerByName;
+    /// Returns a reference to the named layer.
+    layerObj *getLayerByName(char *name) {
+      int i;
+
+      i = msGetLayerIndex(self, name);
+
+      if(i != -1) {
+        MS_REFCNT_INCR(self->layers[i]);
+        return (self->layers[i]); /* returns an EXISTING layer */
+      }
+      else
+        return NULL;
+    }
+
+    /**
+    Return the index of the named symbol in the map's symbolset.
+
+    .. note::
+
+        This method is poorly named and too indirect. It is preferable to use the 
+        getSymbolByName method of :class:`symbolSetObj`, which really does return a :class:`symbolObj` 
+        reference, or use the index method of symbolSetObj to get a symbol's index number.
+    */
+    int getSymbolByName(char *name) {
+      return msGetSymbolIndex(&self->symbolset, name, MS_TRUE);
+    }
+
+    /// \**TODO** this function only calculates the scale or am I missing something?
+    void prepareQuery() {
+      int status;
+
+      status = msCalculateScale(self->extent, self->units, self->width, self->height, self->resolution, &self->scaledenom);
+      if(status != MS_SUCCESS) self->scaledenom = -1;
+    }
+
+    %newobject prepareImage;
+    /// Returns an :class:`imageObj` initialized to map extents and outputformat.
+    imageObj *prepareImage() 
+    {
+      return msPrepareImage(self, MS_FALSE);
+    }
+
+    /**
+    Sets map outputformat to the named format.
+
+    .. note::
+
+        :func:`mapObj.setImageType` remains in the module but its use 
+        is deprecated in favor of :func:`mapObj.selectOutputFormat`.
+    */
+    void setImageType( const char * imagetype ) {
+        outputFormatObj *format;
+
+        format = msSelectOutputFormat( self, imagetype );
+        if( format == NULL )
+            msSetError(MS_MISCERR, "Unable to find IMAGETYPE '%s'.", 
+               "setImageType()", imagetype );
+        else
+        {  
+            msFree( self->imagetype );
+            self->imagetype = msStrdup(imagetype);
+            msApplyOutputFormat( &(self->outputformat), format, MS_NOOVERRIDE);
+        }
+    }
+
+    /**
+    Set the map's active output format to the internal format named imagetype. 
+    Built-in formats are "PNG", "PNG24", "JPEG", "GIF", "GTIFF".
+    */
+    void selectOutputFormat( const char *imagetype )
+    {
+        outputFormatObj *format;
+
+        format = msSelectOutputFormat( self, imagetype );
+        if ( format == NULL )
+            msSetError(MS_MISCERR, "Unable to find IMAGETYPE '%s'.", 
+                       "setImageType()", imagetype );
+        else
+        {   
+            msFree( self->imagetype );
+            self->imagetype = msStrdup(imagetype);
+            msApplyOutputFormat( &(self->outputformat), format, MS_NOOVERRIDE);
+        }
+    }
+
+ 
+    %newobject getOutputFormat;
+    /**
+    Returns the output format at the specified *i* index from the output formats array or 
+    null if *i* is beyond the array bounds. The number of outpuFormats can be 
+    retrieved by calling :func:`mapObj.getNumoutputformats`.
+    */
+    outputFormatObj *getOutputFormat(int i) {
+      if(i >= 0 && i < self->numoutputformats) {
+          MS_REFCNT_INCR(self->outputformatlist[i]);
+          return (self->outputformatlist[i]); 
+      } else {
+        return NULL;
+      }
+    }
+
+    /// Sets map outputformat.
+    void setOutputFormat( outputFormatObj *format ) {
+        msApplyOutputFormat( &(self->outputformat), format, MS_NOOVERRIDE);
+    }
+
+    %newobject draw;
+    /**
+    Draw the map, processing layers according to their defined order and status. 
+    Return an :class:`imageObj`.
+    */
+    imageObj *draw() {
+  #if defined(WIN32) && defined(SWIGCSHARP)
+      __try {
+          return msDrawMap(self, MS_FALSE);
+      }    
+      __except(1 /*EXCEPTION_EXECUTE_HANDLER, catch every exception so it doesn't crash IIS*/) {  
+          msSetError(MS_IMGERR, "Unhandled exception in drawing map image 0x%08x", "msDrawMap()", GetExceptionCode());
+      }
+  #else    
+      return msDrawMap(self, MS_FALSE);
+  #endif    
+    }
+
+    %newobject drawQuery;
+    /// Draw query map, returning an :class:`imageObj`.
+    imageObj *drawQuery() {
+      return msDrawMap(self, MS_TRUE);
+    }
+
+    %newobject drawLegend;
+    /// Draw map legend, returning an :class:`imageObj`.
+    imageObj *drawLegend(int scale_independent=MS_FALSE) {
+      return msDrawLegend(self, scale_independent, NULL);
+    }
+
+    %newobject drawScalebar;
+    /// Draw scale bar, returning an :class:`imageObj`.
+    imageObj *drawScalebar() {
+      return msDrawScalebar(self);
+    }
+
+    %newobject drawReferenceMap;
+    /// Draw reference map, returning an :class:`imageObj`.
+    imageObj *drawReferenceMap() {
+      return msDrawReferenceMap(self);
+    }
+
+    /**
+    Embed map's legend in *image*. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    */
+    int embedScalebar(imageObj *image) {	
+      return msEmbedScalebar(self, image);
+    }
+
+    /**
+    Embed map's legend in *image*. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    */
+    int embedLegend(imageObj *image) {	
+      return msEmbedLegend(self, image);
+    }
+
+    /**
+    Draw map's label cache on *image*.
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    */
+    int drawLabelCache(imageObj *image) {
+      return msDrawLabelCache(self,image);
+    }
+
+    /**
+    Query map layers using the filter *string*. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    */
+    int queryByFilter(char *string) {
+      msInitQuery(&(self->query));
+
+      self->query.type = MS_QUERY_BY_FILTER;
+      self->query.mode = MS_QUERY_MULTIPLE;
+
+      self->query.filter.string = msStrdup(string);
+      self->query.filter.type = MS_EXPRESSION;
+
+      self->query.rect = self->extent;
+
+      return msQueryByFilter(self);
+    }
+
+    /**
+    Query map layers, result sets contain one or more features, depending on mode, 
+    that intersect *point* within a tolerance *buffer*. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    */
+    int queryByPoint(pointObj *point, int mode, double buffer) {
+      msInitQuery(&(self->query));
+
+      self->query.type = MS_QUERY_BY_POINT;
+      self->query.mode = mode;
+      self->query.point = *point;
+      self->query.buffer = buffer;
+
+      return msQueryByPoint(self);
+    }
+
+    /**
+    Query map layers, result sets contain features that intersect or are contained within 
+    the features in the result set of the :data:`MS_LAYER_POLYGON` type layer at layer index *slayer*. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    */
+    int queryByRect(rectObj rect) {
+      msInitQuery(&(self->query));
+
+      self->query.type = MS_QUERY_BY_RECT;
+      self->query.mode = MS_QUERY_MULTIPLE;
+      self->query.rect = rect;
+
+      return msQueryByRect(self);
+    }
+
+
+    /**
+    Query map layers, result sets contain features that intersect or are contained within 
+    the features in the result set of the :data:`MS_LAYER_POLYGON` type layer at layer index *slayer*. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`.
+    */
+    int queryByFeatures(int slayer) {
+      self->query.slayer = slayer;
+      return msQueryByFeatures(self);
+    }
+
+    /**
+    Query layer based on a single shape, the shape has to be a polygon at this point. 
+    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found 
+    or if some other error happened
+    */
+    int queryByShape(shapeObj *shape) {
+      msInitQuery(&(self->query));
+      
+      self->query.type = MS_QUERY_BY_SHAPE;
+      self->query.mode = MS_QUERY_MULTIPLE;
+      self->query.shape = (shapeObj *) malloc(sizeof(shapeObj));
+      msInitShape(self->query.shape);
+      msCopyShape(shape, self->query.shape);
+
+      return msQueryByShape(self);
+    }
+
+
+    /// Sets map projection from OGC definition *wkt*.
+    int setWKTProjection(char *wkt) {
+      return msOGCWKT2ProjectionObj(wkt, &(self->projection), self->debug);
+    }
+
+    %newobject getProjection;
+    /// Returns the PROJ definition of the map's projection.
+    char *getProjection() {
+      return msGetProjectionString(&(self->projection));
+    }
+
+    /// Set map projection from PROJ definition string proj4.
+    int setProjection(char *proj4) {
+      return msLoadProjectionString(&(self->projection), proj4);
+    }
+
+    /// Save map to disk as a new map file. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int save(char *filename) {
+      return msSaveMap(self, filename);
+    }
+
+    /// Save query to disk. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int saveQuery(char *filename, int results=MS_FALSE) {
+      return msSaveQuery(self, filename, results);
+    }
+
+    /// Load a saved query. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int loadQuery(char *filename)  {
+      return msLoadQuery(self, filename);
+    }
+
+    /// Clear layer query result caches. Default is -1, or all layers.
+    void freeQuery(int qlayer=-1) {
+      msQueryFree(self, qlayer);
+    }
+
+    /// Save query to disk. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int saveQueryAsGML(char *filename, const char *ns="GOMF") {
+      return msGMLWriteQuery(self, filename, ns);
+    }
+
+    /// Load symbols defined in filename into map symbolset. The existing symbolset is cleared. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setSymbolSet(char *szFileName) {
+      msFreeSymbolSet(&self->symbolset);
+      msInitSymbolSet(&self->symbolset);
+
+      self->symbolset.filename = msStrdup(szFileName);
+
+      /* Symbolset shares same fontset as main mapfile */
+      self->symbolset.fontset = &(self->fontset);
+
+      return msLoadSymbolSet(&self->symbolset, self);
+    }
+
+    /// Return the number of symbols in map
+    int getNumSymbols() {
+      return self->symbolset.numsymbols;
+    }
+
+    ///. Load fonts defined in filename into map fontset. The existing fontset is cleared. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setFontSet(char *filename) {
+      msFreeFontSet(&(self->fontset));
+      msInitFontSet(&(self->fontset));
+
+      self->fontset.filename = msStrdup(filename);
+
+      return msLoadFontSet(&(self->fontset), self);
+    }
+
+    /* I removed a method to get the fonset filename. Instead I updated mapserver.h
+     to allow SWIG access to the fonset, although the numfonts and filename
+     members are read-only. Use the setFontSet method to actually change the
+     fontset. To get the filename do $map->{fontset}->{filename}; -- SG */
+
+    /// Save map definition to disk as OGC-compliant XML. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int saveMapContext(char *szFileName) {
+      return msSaveMapContext(self, szFileName);
+    }
+
+    /// Load an OGC map context file to define extents and layers of a map
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int loadMapContext(char *szFileName, int useUniqueNames=MS_FALSE) {
+      return msLoadMapContext(self, szFileName, useUniqueNames);
+    }
+   
+    /// Move the layer at layerindex up in the drawing order array, meaning 
+    /// that it is drawn earlier.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int  moveLayerUp(int layerindex) {
+      return msMoveLayerUp(self, layerindex);
+    }
+
+    /// Move the layer at layerindex down in the drawing order array, meaning 
+    /// that it is drawn later. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int  moveLayerDown(int layerindex) {
+      return msMoveLayerDown(self, layerindex);
+    }
+
+    %newobject getLayersDrawingOrder;
+    /// Returns an array of layer indexes in drawing order.
+    /// Note Unless the proper typemap is implemented for the module's language 
+    /// a user is more likely to get back an unusable SWIG pointer to the integer array.
+    intarray *getLayersDrawingOrder() {
+      int i;
+      intarray *order;
+      order = new_intarray(self->numlayers);
+      for (i=0; i<self->numlayers; i++) {
+          // see http://www.swig.org/Doc4.0/SWIGDocumentation.html#Library_carrays for %array_class interface
+          order[i] = self->layerorder[i];
+      }
+      return order;
+    }
+
+    /// Set map layer drawing order.
+    /// Note Unless the proper typemap is implemented for the module's language 
+    /// users will not be able to pass arrays or lists to this method and it will be unusable.
+    int setLayersDrawingOrder(int *panIndexes) {
+      return msSetLayersdrawingOrder(self, panIndexes); 
+    }
+
+    /// Set the indicated key configuration option to the indicated value. 
+    /// Equivalent to including a CONFIG keyword in a map file.
+    void setConfigOption(char *key, char *value) {
+      msSetConfigOption(self,key,value);
+    }
+
+    /// Fetches the value of the requested configuration key if set. 
+    /// Returns NULL if the key is not set.
+    char *getConfigOption(char *key) {
+      return (char *) msGetConfigOption(self,key);
+    }
+
+    /// Apply the defined configuration options set by setConfigOption()
+    void applyConfigOptions() {
+      msApplyMapConfigOptions( self );
+    } 
+
+    /* SLD */
+
+    /// Parse the SLD XML string sldxml and apply to map layers. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int applySLD(char *sld) {
+      return msSLDApplySLD(self, sld, -1, NULL, NULL);
+    }
+
+    /// Fetch SLD XML from the URL sldurl and apply to map layers.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int applySLDURL(char *sld) {
+      return msSLDApplySLDURL(self, sld, -1, NULL, NULL);
+    }
+
+    %newobject generateSLD;
+    /// Return SLD XML as a string for map layers that have STATUS on.
+    char *generateSLD(char *sldVersion=NULL) {
+        return (char *) msSLDGenerateSLD(self, -1, sldVersion);
+    }
+
+    %newobject processTemplate;
+    /**
+    Process MapServer template and return HTML.
+    Note none of the three template processing methods will be usable unless the proper 
+    typemaps are implemented in the module for the target language.Currently the typemaps 
+    are not implemented.
+    */
+    char *processTemplate(int bGenerateImages, char **names, char **values,
+                          int numentries)
+    {
+        return msProcessTemplate(self, bGenerateImages, names, values,
+                                 numentries);
+    }
+
+    %newobject processLegendTemplate;
+    /**
+    Process MapServer legend template and return HTML.
+    Note none of the three template processing methods will be usable unless the proper 
+    typemaps are implemented in the module for the target language.Currently the typemaps 
+    are not implemented.
+    */
+    char *processLegendTemplate(char **names, char **values, int numentries) {
+        return msProcessLegendTemplate(self, names, values, numentries);
+    }
+
+    %newobject processQueryTemplate;
+    /**
+    Process MapServer query template and return HTML. 
+    Note none of the three template processing methods will be usable unless the proper 
+    typemaps are implemented in the module for the target language.Currently the typemaps 
+    are not implemented.
+    */
+    char *processQueryTemplate(char **names, char **values, int numentries) {
+        return msProcessQueryTemplate(self, 1, names, values, numentries);
+    }
+
+    /**
+    Return the output format corresponding to driver name imagetype or to format name 
+    imagetype. This works exactly the same as the IMAGETYPE directive in a mapfile, is 
+    case insensitive and allows an output format to be found either by driver 
+    (like 'AGG/PNG') or name (like 'png').
+    */
+    outputFormatObj *getOutputFormatByName(const char *name) {
+        return msSelectOutputFormat(self, name); 
+    }
+
+    /// Attach format to the map's output format list. 
+    /// Returns the updated number of output formats.
+    int appendOutputFormat(outputFormatObj *format) {
+        return msAppendOutputFormat(self, format);
+    }
+
+    /// Removes the format named name from the map's output format list. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int removeOutputFormat(const char *name) {
+        return msRemoveOutputFormat(self, name);
+    }
+
+    /// Load OWS request parameters (BBOX, LAYERS, &c.) into map. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int loadOWSParameters(cgiRequestObj *request, char *wmtver_string="1.1.1") 
+    {
+        return msMapLoadOWSParameters(self, request, wmtver_string);
+    }
+
+    /**
+    Processes and executes the passed OpenGIS Web Services request on the map. 
+    Returns :data:`MS_DONE` (2) if there is no valid OWS request in the req object, 
+    :data:`MS_SUCCESS` (0) if an OWS request was successfully processed and :data:`MS_FAILURE` (1) 
+    if an OWS request was not successfully processed. OWS requests include WMS, WFS, WCS 
+    and SOS requests supported by MapServer. Results of a dispatched request are written to 
+    stdout and can be captured using the msIO services (i.e. :func:`mapscript.msIO_installStdoutToBuffer` 
+    and :func:`mapscript.msIO_getStdoutBufferString()`
+    */
+    int OWSDispatch( cgiRequestObj *req )
+    {
+        return msOWSDispatch( self, req, MS_TRUE );
+    }
+
+    %newobject convertToString;
+    /// Saves the object to a string. Provides the inverse option for updateFromString.
+    char* convertToString()
+    {
+        return msWriteMapToString(self);
+    }
+
+    /// Apply any default values defined in a VALIDATION block used for runtime substitutions
+    void applyDefaultSubstitutions()
+    {
+        msApplyDefaultSubstitutions(self);
+    }
+
+    /**
+    Pass in runtime substitution keys and values and apply them to the map. 
+    Note - this method is currently enabled for Python only. 
+    Typemaps are needed for other MapScript languages.
+    */
+    void applySubstitutions(char **names, char **values, int npairs)
+    {
+        msApplySubstitutions(self, names, values, npairs);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/mapzoom.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/mapzoom.i
--- 8.0.1-5/src/mapscript/swiginc/mapzoom.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/mapzoom.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,571 @@
+/******************************************************************************
+ * Project:  MapServer
+ * Purpose:  Map zooming convenience methods for MapScript
+ * Author:   Sean Gillies, sgillies@frii.com
+ *
+ ******************************************************************************
+ *
+ * These functions are adapted from the code in php_mapscript.c.
+ *
+ *****************************************************************************/
+
+%extend mapObj {
+
+    /**
+    Zoom by the given factor to a pixel position within the width
+    and height bounds. If max_extent is not NULL, the zoom is 
+    constrained to the max_extents
+
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+
+    */
+    int zoomPoint(int zoomfactor, pointObj *poPixPos, int width, int height, rectObj *poGeorefExt, rectObj *poMaxGeorefExt)
+    {
+        double      dfGeoPosX, dfGeoPosY;
+        double      dfDeltaX, dfDeltaY;
+        rectObj     oNewGeorefExt;    
+        double      dfNewScale;
+        int         bMaxExtSet;
+        double      dfDeltaExt;
+        double dX, dY;
+        
+        dfNewScale = 0.0;
+        bMaxExtSet = 0;
+        dfDeltaExt = -1.0;
+
+        if (poMaxGeorefExt != NULL) { bMaxExtSet = 1; }
+
+        /* ----------------------------------------------------------- */
+        /*      check the validity of the parameters.                  */
+        /* ----------------------------------------------------------- */
+        if (zoomfactor == 0 || width <= 0 || height <= 0 || poGeorefExt == NULL || poPixPos == NULL) {
+            msSetError(MS_MISCERR, "Incorrect arguments", "mapscript::mapObj::zoomPoint()");
+            return MS_FAILURE;
+        }
+
+        /* ----------------------------------------------------------- */
+        /*      check if the values passed are consistent min > max.   */
+        /* ----------------------------------------------------------- */
+        if (poGeorefExt->minx >= poGeorefExt->maxx)  {
+            msSetError(MS_MISCERR, "Georeferenced coordinates minx >= maxx",  "mapscript::mapObj::zoomPoint()");
+            return MS_FAILURE;
+        }
+        if (poGeorefExt->miny >= poGeorefExt->maxy)  {
+            msSetError(MS_MISCERR, "Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomPoint()");
+            return MS_FAILURE;
+        }
+
+        if (bMaxExtSet == 1) {
+            if (poMaxGeorefExt->minx >= poMaxGeorefExt->maxx) {
+                msSetError(MS_MISCERR, "Max Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomPoint()");
+                return MS_FAILURE;
+            }
+            if (poMaxGeorefExt->miny >= poMaxGeorefExt->maxy) {
+                msSetError(MS_MISCERR, "Max Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomPoint()");
+            }
+        }
+   
+        dfDeltaX = poGeorefExt->maxx - poGeorefExt->minx;
+        dfDeltaY = poGeorefExt->maxy - poGeorefExt->miny;
+        dX = dfDeltaX/((double)width);
+        dY = dfDeltaY/((double)height);
+        dfGeoPosX = poGeorefExt->minx + dX * (double)poPixPos->x;
+        dfGeoPosY = poGeorefExt->maxy - dY * (double)poPixPos->y;
+
+        if (self->gt.rotation_angle != 0) {
+            dfGeoPosX = self->gt.geotransform[0] + self->gt.geotransform[1] * (double)poPixPos->x + self->gt.geotransform[2] * (double)poPixPos->y;
+            dfGeoPosY = self->gt.geotransform[3] + self->gt.geotransform[4] * (double)poPixPos->x + self->gt.geotransform[5] * (double)poPixPos->y;
+        }
+        
+        /* --- -------------------------------------------------------- */
+        /*      zoom in                                                 */
+        /* ------------------------------------------------------------ */
+        if (zoomfactor > 1) {
+            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaX/(2*zoomfactor));        
+            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaY/(2*zoomfactor));        
+            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaX/(2*zoomfactor));        
+            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaY/(2*zoomfactor));
+        }
+
+        if (zoomfactor < 0) {
+            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaX/2)*(abs(zoomfactor));    
+            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaY/2)*(abs(zoomfactor));    
+            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaX/2)*(abs(zoomfactor));    
+            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaY/2)*(abs(zoomfactor));
+        }
+
+        if (zoomfactor == 1) {
+            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaX/2);
+            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaY/2);
+            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaX/2);
+            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaY/2);
+        }
+
+        /* ------------------------------------------------------------ */
+        /*   if the min and max scale are set in the map file, we will  */
+        /*   use them to test before zooming.                           */
+        /* ------------------------------------------------------------ */
+        msAdjustExtent(&oNewGeorefExt, self->width, self->height);
+        msCalculateScale(oNewGeorefExt, self->units, self->width, self->height, self->resolution, &dfNewScale);
+    
+        if (self->web.maxscaledenom > 0) {
+            if (zoomfactor < 0 && dfNewScale > self->web.maxscaledenom) {
+                return MS_FAILURE;
+            }
+        }
+
+        /* ============================================================ */
+        /*  we do a special case for zoom in : we try to zoom as much as */
+        /*  possible using the mincale set in the .map.                 */
+        /* ============================================================ */
+        if (self->web.minscaledenom > 0 && dfNewScale < self->web.minscaledenom && zoomfactor > 1) {
+            /* To be consistent in swig mapscript and PHP mapscript, 
+               use the same function to calculate the delta extents. */
+            dfDeltaExt = GetDeltaExtentsUsingScale(self->web.minscaledenom, self->units, dfGeoPosY, 
+                                                   self->width, self->resolution);
+
+            if (dfDeltaExt > 0.0) {
+                oNewGeorefExt.minx = dfGeoPosX - (dfDeltaExt/2);
+                oNewGeorefExt.miny = dfGeoPosY - (dfDeltaExt/2);
+                oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaExt/2);
+                oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaExt/2);
+            } else
+                return MS_FAILURE;
+        }
+
+        /* ------------------------------------------------------------ */
+        /*  If the buffer is set, make sure that the extents do not go  */
+        /*  beyond the buffer.                                          */
+        /* ------------------------------------------------------------ */
+        if (bMaxExtSet) {
+            dfDeltaX = oNewGeorefExt.maxx - oNewGeorefExt.minx;
+            dfDeltaY = oNewGeorefExt.maxy - oNewGeorefExt.miny;
+        
+            /* Make sure Current georef extents is not bigger than 
+             * max extents */
+            if (dfDeltaX > (poMaxGeorefExt->maxx-poMaxGeorefExt->minx))
+                dfDeltaX = poMaxGeorefExt->maxx-poMaxGeorefExt->minx;
+            if (dfDeltaY > (poMaxGeorefExt->maxy-poMaxGeorefExt->miny))
+                dfDeltaY = poMaxGeorefExt->maxy-poMaxGeorefExt->miny;
+
+            if (oNewGeorefExt.minx < poMaxGeorefExt->minx) {
+                oNewGeorefExt.minx = poMaxGeorefExt->minx;
+                oNewGeorefExt.maxx =  oNewGeorefExt.minx + dfDeltaX;
+            }
+            if (oNewGeorefExt.maxx > poMaxGeorefExt->maxx) {
+                oNewGeorefExt.maxx = poMaxGeorefExt->maxx;
+                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
+            }
+            if (oNewGeorefExt.miny < poMaxGeorefExt->miny) {
+                oNewGeorefExt.miny = poMaxGeorefExt->miny;
+                oNewGeorefExt.maxy =  oNewGeorefExt.miny + dfDeltaY;
+            }
+            if (oNewGeorefExt.maxy > poMaxGeorefExt->maxy) {
+                oNewGeorefExt.maxy = poMaxGeorefExt->maxy;
+                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
+            }
+        }
+    
+        /* ------------------------------------------------------------ */
+        /*      set the map extents with new values.                    */
+        /* ------------------------------------------------------------ */
+        self->extent.minx = oNewGeorefExt.minx;
+        self->extent.miny = oNewGeorefExt.miny;
+        self->extent.maxx = oNewGeorefExt.maxx;
+        self->extent.maxy = oNewGeorefExt.maxy;
+    
+        self->cellsize = msAdjustExtent(&(self->extent), self->width, self->height);      
+        dfDeltaX = self->extent.maxx - self->extent.minx;
+        dfDeltaY = self->extent.maxy - self->extent.miny; 
+
+        if (bMaxExtSet) {
+            if (self->extent.minx < poMaxGeorefExt->minx) {
+                self->extent.minx = poMaxGeorefExt->minx;
+                self->extent.maxx = self->extent.minx + dfDeltaX;
+            }
+            if (self->extent.maxx > poMaxGeorefExt->maxx) {
+                self->extent.maxx = poMaxGeorefExt->maxx;
+                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
+            }
+            if (self->extent.miny < poMaxGeorefExt->miny) {
+                self->extent.miny = poMaxGeorefExt->miny;
+                self->extent.maxy =  self->extent.miny + dfDeltaY;
+            }
+            if (self->extent.maxy > poMaxGeorefExt->maxy) {
+                self->extent.maxy = poMaxGeorefExt->maxy;
+                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
+            }
+        }
+    
+        msCalculateScale(self->extent, self->units, self->width, self->height, self->resolution, &(self->scaledenom));
+
+        return MS_SUCCESS;
+    }
+
+    /**
+    Set the map extents to a given extents. 
+    Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE` on error
+    */
+    int zoomRectangle(rectObj *poPixRect, int width, int height, rectObj *poGeorefExt, rectObj *poMaxGeorefExt)
+    {
+        double      dfDeltaX, dfDeltaY;
+        rectObj     oNewGeorefExt;    
+        double      dfNewScale;
+        double      dfDeltaExt;
+        double dfMiddleX, dfMiddleY;
+        int bMaxExtSet;
+        
+        bMaxExtSet = 0;
+        dfNewScale = 0.0;
+        dfDeltaExt = -1.0;
+
+        if (poMaxGeorefExt != NULL) bMaxExtSet = 1;
+
+        /* ----------------------------------------------------------- */
+        /*      check the validity of the parameters.                  */
+        /* ----------------------------------------------------------- */
+        if (poPixRect == 0 || width <= 0 || height <= 0 || poGeorefExt == NULL) {
+            msSetError(MS_MISCERR, "Incorrect arguments", "mapscript::mapObj::zoomRectangle");
+            return MS_FAILURE;
+        }
+
+        /* ----------------------------------------------------------- */
+        /*      check if the values passed are consistent min <= max.   */
+        /* ----------------------------------------------------------- */
+        if (poPixRect->minx >= poPixRect->maxx) {
+            msSetError(MS_MISCERR, "image rectangle minx >= maxx", "mapscript::mapObj::zoomRectangle()");
+            return MS_FAILURE;
+        }
+        /* This is not a typo: "maxx >= minx". For historical reason, we
+         * keep this as it is. See documentation for more info about this check. */
+        if (poPixRect->maxy >= poPixRect->miny) {
+            msSetError(MS_MISCERR, "image rectangle maxy >= miny", "mapscript::mapObj::zoomRectangle()");
+            return MS_FAILURE;
+        }
+
+        if (poGeorefExt->minx >= poGeorefExt->maxx) {
+            msSetError(MS_MISCERR, "Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomRectangle()");
+            return MS_FAILURE;
+        }
+        if (poGeorefExt->miny >= poGeorefExt->maxy) {
+            msSetError(MS_MISCERR, "Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomRectangle()");
+            return MS_FAILURE;
+        }
+
+        if (bMaxExtSet == 1) {
+            if (poMaxGeorefExt->minx >= poMaxGeorefExt->maxx) {
+                msSetError(MS_MISCERR,  "Max Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomRectangle()");
+                return MS_FAILURE;
+            }
+            if (poMaxGeorefExt->miny >= poMaxGeorefExt->maxy) {
+                msSetError(MS_MISCERR, "Max Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomRectangle()");
+                return MS_FAILURE;
+            }
+        }
+
+  
+        /* ----------------------------------------------------------- */
+        /*   Convert pixel rectangle to georeferenced rectangle        */
+        /* ----------------------------------------------------------- */
+        
+        dfDeltaX = poGeorefExt->maxx - poGeorefExt->minx;
+        dfDeltaY = poGeorefExt->maxy - poGeorefExt->miny;
+
+        oNewGeorefExt.minx = Pix2Georef((int)poPixRect->minx, 0, width, poGeorefExt->minx, poGeorefExt->maxx, 0); 
+        oNewGeorefExt.maxx = Pix2Georef((int)poPixRect->maxx, 0, width, poGeorefExt->minx, poGeorefExt->maxx, 0); 
+        oNewGeorefExt.miny = Pix2Georef((int)poPixRect->miny, 0, height, poGeorefExt->miny, poGeorefExt->maxy, 1); 
+        oNewGeorefExt.maxy = Pix2Georef((int)poPixRect->maxy, 0, height, poGeorefExt->miny, poGeorefExt->maxy, 1); 
+
+        msAdjustExtent(&oNewGeorefExt, self->width, self->height);
+
+        /* ------------------------------------------------------------ */
+        /*   if the min and max scale are set in the map file, we will  */
+        /*   use them to test before setting extents.                   */
+        /* ------------------------------------------------------------ */
+        msCalculateScale(oNewGeorefExt, self->units, self->width, self->height, self->resolution, &dfNewScale);
+
+        if (self->web.maxscaledenom > 0 &&  dfNewScale > self->web.maxscaledenom)
+            return MS_FAILURE;
+
+        if (self->web.minscaledenom > 0 && dfNewScale <  self->web.minscaledenom) {
+            dfMiddleX = oNewGeorefExt.minx + ((oNewGeorefExt.maxx - oNewGeorefExt.minx)/2);
+            dfMiddleY = oNewGeorefExt.miny + ((oNewGeorefExt.maxy - oNewGeorefExt.miny)/2);
+
+            /* To be consistent in swig mapscript and PHP mapscript, 
+               use the same function to calculate the delta extents. */
+            dfDeltaExt = GetDeltaExtentsUsingScale(self->web.minscaledenom, self->units, dfMiddleY, self->width, self->resolution);
+
+            if (dfDeltaExt > 0.0) {
+                oNewGeorefExt.minx = dfMiddleX - (dfDeltaExt/2);
+                oNewGeorefExt.miny = dfMiddleY - (dfDeltaExt/2);
+                oNewGeorefExt.maxx = dfMiddleX + (dfDeltaExt/2);
+                oNewGeorefExt.maxy = dfMiddleY + (dfDeltaExt/2);
+            } else
+                return MS_FAILURE;
+        }
+
+        /* ------------------------------------------------------------ */
+        /*  If the buffer is set, make sure that the extents do not go  */
+        /*  beyond the buffer.                                          */
+        /* ------------------------------------------------------------ */
+        if (bMaxExtSet) {
+            dfDeltaX = oNewGeorefExt.maxx - oNewGeorefExt.minx;
+            dfDeltaY = oNewGeorefExt.maxy - oNewGeorefExt.miny;
+        
+            /* Make sure Current georef extents is not bigger 
+             * than max extents */
+            if (dfDeltaX > (poMaxGeorefExt->maxx-poMaxGeorefExt->minx))
+                dfDeltaX = poMaxGeorefExt->maxx-poMaxGeorefExt->minx;
+            if (dfDeltaY > (poMaxGeorefExt->maxy-poMaxGeorefExt->miny))
+                dfDeltaY = poMaxGeorefExt->maxy-poMaxGeorefExt->miny;
+
+            if (oNewGeorefExt.minx < poMaxGeorefExt->minx) {
+                oNewGeorefExt.minx = poMaxGeorefExt->minx;
+                oNewGeorefExt.maxx =  oNewGeorefExt.minx + dfDeltaX;
+            }
+            if (oNewGeorefExt.maxx > poMaxGeorefExt->maxx) {
+                oNewGeorefExt.maxx = poMaxGeorefExt->maxx;
+                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
+            }
+            if (oNewGeorefExt.miny < poMaxGeorefExt->miny) {
+                oNewGeorefExt.miny = poMaxGeorefExt->miny;
+                oNewGeorefExt.maxy =  oNewGeorefExt.miny + dfDeltaY;
+            }
+            if (oNewGeorefExt.maxy > poMaxGeorefExt->maxy) {
+                oNewGeorefExt.maxy = poMaxGeorefExt->maxy;
+                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
+            }
+        }
+
+        self->extent.minx = oNewGeorefExt.minx;
+        self->extent.miny = oNewGeorefExt.miny;
+        self->extent.maxx = oNewGeorefExt.maxx;
+        self->extent.maxy = oNewGeorefExt.maxy;
+
+        self->cellsize = msAdjustExtent(&(self->extent), self->width, self->height);    
+        dfDeltaX = self->extent.maxx - self->extent.minx;
+        dfDeltaY = self->extent.maxy - self->extent.miny; 
+
+        if (bMaxExtSet) {
+            if (self->extent.minx < poMaxGeorefExt->minx) {
+                self->extent.minx = poMaxGeorefExt->minx;
+                self->extent.maxx = self->extent.minx + dfDeltaX;
+            }
+            if (self->extent.maxx > poMaxGeorefExt->maxx) {
+                self->extent.maxx = poMaxGeorefExt->maxx;
+                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
+            }
+            if (self->extent.miny < poMaxGeorefExt->miny) {
+                self->extent.miny = poMaxGeorefExt->miny;
+                self->extent.maxy =  self->extent.miny + dfDeltaY;
+            }
+            if (self->extent.maxy > poMaxGeorefExt->maxy) {
+                self->extent.maxy = poMaxGeorefExt->maxy;
+                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
+            }
+        }
+
+        msCalculateScale(self->extent, self->units, self->width,  self->height, self->resolution, &(self->scaledenom));
+
+        return MS_SUCCESS;
+    }
+
+    /**
+     Zoom by the given factor to a pixel position within the width
+     and height bounds.  If max_extent is not NULL, the zoom is 
+     constrained to the max_extents
+    */
+    int zoomScale(double scale, pointObj *poPixPos, int width, int height,
+                  rectObj *poGeorefExt, rectObj *poMaxGeorefExt)
+    {
+        double      dfGeoPosX, dfGeoPosY;
+        double      dfDeltaX, dfDeltaY;
+        rectObj     oNewGeorefExt;    
+        double      dfNewScale, dfCurrentScale;
+        int         bMaxExtSet;
+        int nTmp;
+        double      dfDeltaExt;
+        double dX, dY;
+        
+        dfNewScale = 0.0;
+        dfCurrentScale = 0.0;
+        nTmp = 0;
+        bMaxExtSet = 0;
+        dfDeltaExt = -1.0;
+
+        if (poMaxGeorefExt != NULL) { bMaxExtSet = 1; }
+
+        /* ----------------------------------------------------------- */
+        /*      check the validity of the parameters.                  */
+        /* ----------------------------------------------------------- */
+        if (scale <= 0.0 || width <= 0 || height <= 0 || poGeorefExt == NULL || poPixPos == NULL ) {
+            msSetError(MS_MISCERR, "Incorrect arguments", "mapscript::mapObj::zoomScale");
+            return MS_FAILURE;
+        }
+
+        /* ----------------------------------------------------------- */
+        /*      check if the values passed are consistent min > max.   */
+        /* ----------------------------------------------------------- */
+        if (poGeorefExt->minx >= poGeorefExt->maxx) {
+            msSetError(MS_MISCERR, "Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomScale()");
+            return MS_FAILURE;
+        }
+        if (poGeorefExt->miny >= poGeorefExt->maxy) {
+            msSetError(MS_MISCERR, "Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomScale()");
+            return MS_FAILURE;
+        }
+
+        if (bMaxExtSet == 1) {
+            if (poMaxGeorefExt->minx >= poMaxGeorefExt->maxx) {
+                msSetError(MS_MISCERR, "Max Georeferenced coordinates minx >= maxx", "mapscript::mapObj::zoomScale()");
+                return MS_FAILURE;
+            }
+            if (poMaxGeorefExt->miny >= poMaxGeorefExt->maxy) {
+                msSetError(MS_MISCERR,  "Max Georeferenced coordinates miny >= maxy", "mapscript::mapObj::zoomScale()");
+            }
+        }
+   
+        dfDeltaX = poGeorefExt->maxx - poGeorefExt->minx;
+        dfDeltaY = poGeorefExt->maxy - poGeorefExt->miny;
+        dX = dfDeltaX/((double)width);
+        dY = dfDeltaY/((double)height);
+        dfGeoPosX = poGeorefExt->minx + dX * (double)poPixPos->x;
+        dfGeoPosY = poGeorefExt->maxy - dY * (double)poPixPos->y;
+
+        if (self->gt.rotation_angle != 0) {
+            dfGeoPosX = self->gt.geotransform[0] + self->gt.geotransform[1] * (double)poPixPos->x + self->gt.geotransform[2] * (double)poPixPos->y;
+            dfGeoPosY = self->gt.geotransform[3] + self->gt.geotransform[4] * (double)poPixPos->x + self->gt.geotransform[5] * (double)poPixPos->y;
+        }
+        
+        /* ------------------------------------------------------------ */
+        /*  Calculate new extents based on the scale.                   */
+        /* ------------------------------------------------------------ */
+
+        /* ============================================================ */
+        /*  make sure to take the smallest size because this is the one */
+        /*  that will be used to ajust the scale.                       */
+        /* ============================================================ */
+
+        if (self->width <  self->height)
+            nTmp = self->width;
+        else
+            nTmp = self->height;
+
+        /* To be consistent in swig mapscript and PHP mapscript, 
+           use the same function to calculate the delta extents. */
+        dfDeltaExt = GetDeltaExtentsUsingScale(scale, self->units, dfGeoPosY, nTmp, self->resolution);
+
+        if (dfDeltaExt > 0.0) {
+            oNewGeorefExt.minx = dfGeoPosX - (dfDeltaExt/2);
+            oNewGeorefExt.miny = dfGeoPosY - (dfDeltaExt/2);
+            oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaExt/2);
+            oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaExt/2);
+        } else
+            return MS_FAILURE;
+
+        /* ------------------------------------------------------------ */
+        /*   get current scale.                                         */
+        /* ------------------------------------------------------------ */
+        msCalculateScale(*poGeorefExt, self->units, self->width, self->height, self->resolution, &dfCurrentScale);
+
+        /* ------------------------------------------------------------ *
+         *   if the min and max scale are set in the map file, we will  *
+         *   use them to test before zooming.                           *
+         *                                                              *
+         *   This function has the same effect as zoomin or zoom out.
+         *   If the current scale is > newscale we zoom in; else it is
+         *   a zoom out.
+         * ------------------------------------------------------------ */
+        msAdjustExtent(&oNewGeorefExt, self->width, self->height);
+        msCalculateScale(oNewGeorefExt, self->units, self->width, self->height, self->resolution, &dfNewScale);
+
+        if (self->web.maxscaledenom > 0) {
+            if (dfCurrentScale < dfNewScale && dfNewScale >  self->web.maxscaledenom) {
+                return MS_FAILURE;
+            }
+        }
+
+        /* ============================================================ */
+        /* we do a special case for zoom in : we try to zoom as much as */
+        /* possible using the mincale set in the .map.                  */
+        /* ============================================================ */
+        if (self->web.minscaledenom > 0 && dfNewScale <  self->web.minscaledenom && dfCurrentScale > dfNewScale) {
+            /* To be consistent in swig mapscript and PHP mapscript, 
+               use the same function to calculate the delta extents. */
+            dfDeltaExt = GetDeltaExtentsUsingScale(scale, self->units, dfGeoPosY, nTmp, self->resolution);
+            if (dfDeltaExt > 0.0) {
+                oNewGeorefExt.minx = dfGeoPosX - (dfDeltaExt/2);
+                oNewGeorefExt.miny = dfGeoPosY - (dfDeltaExt/2);
+                oNewGeorefExt.maxx = dfGeoPosX + (dfDeltaExt/2);
+                oNewGeorefExt.maxy = dfGeoPosY + (dfDeltaExt/2);
+            } else
+                return MS_FAILURE;
+        }
+
+        /* ------------------------------------------------------------ */
+        /*  If the buffer is set, make sure that the extents do not go  */
+        /*  beyond the buffer.                                          */
+        /* ------------------------------------------------------------ */
+        if (bMaxExtSet) {
+            dfDeltaX = oNewGeorefExt.maxx - oNewGeorefExt.minx;
+            dfDeltaY = oNewGeorefExt.maxy - oNewGeorefExt.miny;
+        
+            /* Make sure Current georef extents is not bigger 
+             * than max extents */
+            if (dfDeltaX > (poMaxGeorefExt->maxx-poMaxGeorefExt->minx))
+                dfDeltaX = poMaxGeorefExt->maxx-poMaxGeorefExt->minx;
+            if (dfDeltaY > (poMaxGeorefExt->maxy-poMaxGeorefExt->miny))
+                dfDeltaY = poMaxGeorefExt->maxy-poMaxGeorefExt->miny;
+
+            if (oNewGeorefExt.minx < poMaxGeorefExt->minx) {
+                oNewGeorefExt.minx = poMaxGeorefExt->minx;
+                oNewGeorefExt.maxx =  oNewGeorefExt.minx + dfDeltaX;
+            }
+            if (oNewGeorefExt.maxx > poMaxGeorefExt->maxx) {
+                oNewGeorefExt.maxx = poMaxGeorefExt->maxx;
+                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
+            }
+            if (oNewGeorefExt.miny < poMaxGeorefExt->miny) {
+                oNewGeorefExt.miny = poMaxGeorefExt->miny;
+                oNewGeorefExt.maxy =  oNewGeorefExt.miny + dfDeltaY;
+            }
+            if (oNewGeorefExt.maxy > poMaxGeorefExt->maxy) {
+                oNewGeorefExt.maxy = poMaxGeorefExt->maxy;
+                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
+            }
+        }
+
+        self->extent.minx = oNewGeorefExt.minx;
+        self->extent.miny = oNewGeorefExt.miny;
+        self->extent.maxx = oNewGeorefExt.maxx;
+        self->extent.maxy = oNewGeorefExt.maxy;
+    
+        self->cellsize = msAdjustExtent(&(self->extent), self->width, self->height);    
+        dfDeltaX = self->extent.maxx - self->extent.minx;
+        dfDeltaY = self->extent.maxy - self->extent.miny; 
+
+        if (bMaxExtSet) {
+            if (self->extent.minx < poMaxGeorefExt->minx) {
+                self->extent.minx = poMaxGeorefExt->minx;
+                self->extent.maxx = self->extent.minx + dfDeltaX;
+            }
+            if (self->extent.maxx > poMaxGeorefExt->maxx) {
+                self->extent.maxx = poMaxGeorefExt->maxx;
+                oNewGeorefExt.minx = oNewGeorefExt.maxx - dfDeltaX;
+            }
+            if (self->extent.miny < poMaxGeorefExt->miny) {
+                self->extent.miny = poMaxGeorefExt->miny;
+                self->extent.maxy =  self->extent.miny + dfDeltaY;
+            }
+            if (self->extent.maxy > poMaxGeorefExt->maxy) {
+                self->extent.maxy = poMaxGeorefExt->maxy;
+                oNewGeorefExt.miny = oNewGeorefExt.maxy - dfDeltaY;
+            }
+        }
+
+        msCalculateScale(self->extent, self->units, self->width, self->height, self->resolution, &(self->scaledenom));
+
+        return MS_SUCCESS;
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/msio.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/msio.i
--- 8.0.1-5/src/mapscript/swiginc/msio.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/msio.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,118 @@
+/******************************************************************************
+ * Project:  MapServer
+ * Purpose:  Definitions for MapServer IO redirection capability.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ * Note:
+ * copied from mapio.h to avoid to much #ifdef swigging
+ *
+ ******************************************************************************
+ * Copyright (c) 2004, Frank Warmerdam <warmerdam@pobox.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in 
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/// Resets the default stdin and stdout handlers in place of buffer based handlers.
+void msIO_resetHandlers(void);
+
+/// Installs a mapserver IO handler directing future stdout output to a memory buffer.
+void msIO_installStdoutToBuffer(void);
+
+/// Installs a mapserver IO handler directing future stdin reading 
+/// (i.e. post request capture) to come from a buffer.
+void msIO_installStdinFromBuffer(void);
+
+%newobject msIO_stripStdoutBufferContentType;
+/// Strip the Content-type header off the stdout buffer if it has one, and if a content type 
+/// is found it is returned (otherwise NULL/None/etc).
+const char *msIO_stripStdoutBufferContentType();
+
+/// Strip all Content-* headers off the stdout buffer if it has any.
+void msIO_stripStdoutBufferContentHeaders(void);
+
+/* mapscript only extensions */
+
+/// Fetch the current stdout buffer contents as a string. 
+/// This method does not clear the buffer.
+const char *msIO_getStdoutBufferString(void);
+
+/// Fetch the current stdout buffer contents as a binary buffer. The exact form of this buffer will vary by 
+/// MapScript language (e/g. string in Python, byte[] array in Java and C#, unhandled in Perl).
+gdBuffer msIO_getStdoutBufferBytes(void);
+
+%newobject msIO_getAndStripStdoutBufferMimeHeaders;
+/// Strip off all MIME headers and return them in a hashTableObj
+hashTableObj* msIO_getAndStripStdoutBufferMimeHeaders(void);
+
+%{
+
+const char *msIO_getStdoutBufferString() {
+    msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
+    msIOBuffer  *buf;
+
+    if( ctx == NULL || ctx->write_channel == MS_FALSE 
+        || strcmp(ctx->label,"buffer") != 0 )
+    {
+        msSetError( MS_MISCERR, "Can't identify msIO buffer.",
+                    "msIO_getStdoutBufferString" );
+        return "";
+    }
+
+    buf = (msIOBuffer *) ctx->cbData;
+
+    /* write one zero byte and backtrack if it isn't already there */
+    if( buf->data_len == 0 || buf->data[buf->data_offset] != '\0' ) {
+        msIO_bufferWrite( buf, "", 1 );
+        buf->data_offset--;
+    }
+
+    return (const char *) (buf->data);
+}
+
+gdBuffer msIO_getStdoutBufferBytes() {
+    msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
+    msIOBuffer  *buf;
+    gdBuffer     gdBuf;
+
+    if( ctx == NULL || ctx->write_channel == MS_FALSE 
+        || strcmp(ctx->label,"buffer") != 0 )
+    {
+        msSetError( MS_MISCERR, "Can't identify msIO buffer.",
+                        "msIO_getStdoutBufferString" );
+        gdBuf.data = (unsigned char*)"";
+        gdBuf.size = 0;
+        gdBuf.owns_data = MS_FALSE;
+        return gdBuf;
+    }
+
+    buf = (msIOBuffer *) ctx->cbData;
+
+    gdBuf.data = buf->data;
+    gdBuf.size = buf->data_offset;
+    gdBuf.owns_data = MS_TRUE;
+
+    /* we are seizing ownership of the buffer contents */
+    buf->data_offset = 0;
+    buf->data_len = 0;
+    buf->data = NULL;
+
+    return gdBuf;
+}
+
+%}
diff -pruN 8.0.1-5/src/mapscript/swiginc/outputformat.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/outputformat.i
--- 8.0.1-5/src/mapscript/swiginc/outputformat.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/outputformat.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,126 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript outputFormatObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend outputFormatObj 
+{
+    /// Create new instance. If name is not provided, the value of driver is used as a name.
+    outputFormatObj(const char *driver, char *name=NULL) 
+    {
+        outputFormatObj *format;
+
+        format = msCreateDefaultOutputFormat(NULL, driver, name, NULL);
+
+        /* in the case of unsupported formats, msCreateDefaultOutputFormat
+           should return NULL */
+        if (!format)
+        {
+            msSetError(MS_MISCERR, "Unsupported format driver: %s",
+                       "outputFormatObj()", driver);
+            return NULL;
+        }
+        
+        msInitializeRendererVTable(format);
+
+        MS_REFCNT_INIT(format);
+        format->inmapfile = MS_TRUE;
+
+        return format;
+    }
+
+    ~outputFormatObj() 
+    {
+        msFreeOutputFormat( self );
+    }
+
+    /**
+    * Set file extension for output format such as  'png' or 'jpg'. 
+    * Method could probably be deprecated since the extension attribute is mutable.
+    * Not in Java extension.
+    */
+#ifndef SWIGJAVA
+    void setExtension( const char *extension ) 
+    {
+        msFree( self->extension );
+        self->extension = msStrdup(extension);
+    }
+
+    /**
+    * Set mimetype for output format such as ``image/png`` or ``image/jpeg``.
+    * Method could probably be deprecated since the mimetype attribute is mutable.
+    * Not in Java extension
+    */
+    void setMimetype( const char *mimetype ) 
+    {
+        msFree( self->mimetype );
+        self->mimetype = msStrdup(mimetype);
+    }
+#endif
+
+    /// Set the format option at ``key`` to ``value``. Format options are mostly driver specific.
+    void setOption( const char *key, const char *value ) 
+    {
+        msSetOutputFormatOption( self, key, value );
+    }
+
+    /// Checks some internal consistency issues, and returns :data:`MS_TRUE` 
+    /// if things are OK and :data:`MS_FALSE` if there are problems. 
+    /// Some problems are fixed up internally. May produce debug output if issues encountered.
+    int validate() 
+    {
+        return msOutputFormatValidate(self, MS_FALSE );
+    }
+
+    %newobject getOption;
+    /// Return the format option at ``key`` or ``defaultvalue`` 
+    /// if key is not a valid hash index.
+    char *getOption(const char *key, const char *value="") 
+    {
+        return msStrdup(msGetOutputFormatOption(self, key, value));
+    }
+
+    %newobject getOptionAt;
+    /**
+    * Returns the option at ``idx`` or NULL if the index is beyond the array bounds. 
+    * The option is returned as the original KEY=VALUE string. 
+    * The number of available options can be obtained via :attr:`outputFormatObj.numformatoptions`
+    */
+    char* getOptionAt(int i) {
+       if( i >= 0 && i < self->numformatoptions ) {
+          return msStrdup(self->formatoptions[i]);
+       }
+       return NULL;
+    }
+
+    /// Set the device property of the output format
+    void attachDevice( void *device ) 
+    {
+        self->device = device;
+    }
+    
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/owsrequest.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/owsrequest.i
--- 8.0.1-5/src/mapscript/swiginc/owsrequest.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/owsrequest.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,207 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for manipulating OGC request stuff via
+             mapscript.
+   Author:   Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 2004 Sean Gillies
+   Copyright (c) 2006 Frank Warmerdam
+   Copyright (c) 1996-2007 Regents of the University of Minnesota.
+       
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+
+%{
+/**
+The following functions are used to simulate the CGI environment for a request
+and return default values when a environment key is passed in
+*/
+static char *msGetEnvURL( const char *key, void *thread_context )
+{
+    if( strcmp(key,"REQUEST_METHOD") == 0 )
+        return "GET";
+
+    if( strcmp(key,"QUERY_STRING") == 0 )
+        return (char *) thread_context;
+
+    return NULL;
+}
+
+static char *msPostEnvURL(const char *key, void *thread_context)
+{
+    if (strcmp(key, "REQUEST_METHOD") == 0)
+        return "POST";
+
+    if (strcmp(key, "QUERY_STRING") == 0)
+        return (char *)thread_context;
+
+    return NULL;
+}
+%}
+
+%rename(OWSRequest) cgiRequestObj;
+
+// include has to be placed here
+%include "../../cgiutil.h"
+
+/* Class for programming OWS services - SG */
+
+%extend cgiRequestObj {
+
+    /**
+    Not associated with other mapscript classes. Serves as a message intermediary 
+    between an application and MapServer's OWS capabilities. Using it permits creation 
+    of lightweight WMS services.
+    */
+    cgiRequestObj()
+    {
+        cgiRequestObj *request;
+
+        request = msAllocCgiObj();
+        if (!request) {
+            msSetError(MS_CGIERR, "Failed to initialize object","OWSRequest()");
+            return NULL;
+        }
+        
+        return request;
+    }
+
+    ~cgiRequestObj()
+    {
+        msFreeCgiObj(self);
+    }
+
+    /**
+    Initializes the OWSRequest object from the cgi environment variables 
+    ``REQUEST_METHOD``, ``QUERY_STRING`` and ``HTTP_COOKIE``. 
+    Returns the number of name/value pairs collected. 
+    Warning: most errors will result in a process exit!
+    */
+    int loadParams()
+    {
+        self->NumParams = loadParams( self, NULL, NULL, 0, NULL);
+        return self->NumParams;
+    }
+
+    /**
+    Initializes the OWSRequest object from the provided URL which is 
+    treated like a ``QUERY_STRING``. 
+    Note that ``REQUEST_METHOD=GET`` and no post data is assumed in this case. 
+    */
+    int loadParamsFromURL( const char *url )
+    {
+        self->NumParams = loadParams( self, msGetEnvURL, NULL, 0, (void*)url );
+        return self->NumParams;
+    }
+
+    /**
+    Initializes the OWSRequest object with POST data, along with a the provided URL which is
+    treated like a ``QUERY_STRING``.
+    Note that ``REQUEST_METHOD=POST`` and the caller is responsible for setting the correct
+    content type e.g. ``req.contenttype = "application/xml"``
+    */
+    int loadParamsFromPost( char *postData, const char *url)
+    {
+        self->NumParams = loadParams( self, msPostEnvURL, msStrdup(postData), (ms_uint32) strlen(postData), (void*)url);
+        return self->NumParams;
+    }
+
+    /**
+    Set a request parameter. For example:
+    
+    request.setParameter('REQUEST', 'GetMap')
+    request.setParameter('BBOX', '-107.0,40.0,-106.0,41.0')
+    */
+    void setParameter(char *name, char *value) 
+    {
+        int i;
+        
+        if (self->NumParams == MS_DEFAULT_CGI_PARAMS) {
+            msSetError(MS_CHILDERR, "Maximum number of items, %d, has been reached", "setItem()", MS_DEFAULT_CGI_PARAMS);
+        }
+        
+        for (i=0; i<self->NumParams; i++) {
+            if (strcasecmp(self->ParamNames[i], name) == 0) {
+                free(self->ParamValues[i]);
+                self->ParamValues[i] = msStrdup(value);
+                break;
+            }
+        }
+        if (i == self->NumParams) {
+            self->ParamNames[self->NumParams] = msStrdup(name);
+            self->ParamValues[self->NumParams] = msStrdup(value);
+            self->NumParams++;
+        }
+    }
+
+    /**
+    Add a request parameter, even if the parameter key was previously set. 
+    This is useful when multiple parameters with the same key are required. 
+    For example: 
+    request.addParameter('SIZE', 'x(100)')
+    request.addParameter('SIZE', 'y(100)')
+    */
+    void addParameter(char *name, char *value)
+    {
+        if (self->NumParams == MS_DEFAULT_CGI_PARAMS) {
+            msSetError(MS_CHILDERR, "Maximum number of items, %d, has been reached", "addParameter()", MS_DEFAULT_CGI_PARAMS);
+        }
+        self->ParamNames[self->NumParams] = msStrdup(name);
+        self->ParamValues[self->NumParams] = msStrdup(value);
+        self->NumParams++;
+    }
+
+    /// Return the name of the parameter at ``index`` in the request's 
+    /// array of parameter names.
+    char *getName(int index) 
+    {
+        if (index < 0 || index >= self->NumParams) {
+            msSetError(MS_CHILDERR, "Invalid index, valid range is [0, %d]", "getName()", self->NumParams-1);
+            return NULL;
+        }
+        return self->ParamNames[index];
+    }
+
+    /// Return the value of the parameter at ``index`` in the request's 
+    /// array of parameter values.
+    char *getValue(int index) 
+    {
+        if (index < 0 || index >= self->NumParams) {
+            msSetError(MS_CHILDERR, "Invalid index, valid range is [0, %d]", "getValue()", self->NumParams-1);
+            return NULL;
+        }
+        return self->ParamValues[index];
+    }
+
+    /// Return the value associated with the parameter ``name``
+    char *getValueByName(const char *name) 
+    {
+        int i;
+        for (i=0; i<self->NumParams; i++) {
+            if (strcasecmp(self->ParamNames[i], name) == 0) {
+                return self->ParamValues[i];
+            }
+        }
+        return NULL;
+    }
+
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/point.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/point.i
--- 8.0.1-5/src/mapscript/swiginc/point.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/point.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,191 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript pointObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend pointObj 
+{
+    /** 
+    * Create new instance. Easting, northing, and measure arguments are optional.
+    * Java pointObj constructors are in java/javaextend.i
+    * See https://github.com/mapserver/mapserver/issues/1106
+    */
+#ifndef SWIGJAVA
+    pointObj(double x=0.0, double y=0.0, double z=0.0, double m=-2e38) 
+    {
+        pointObj *p;
+        p = (pointObj *)calloc(1,sizeof(pointObj));
+        if (!p) return NULL;
+        p->x = x;
+        p->y = y;
+        p->z = z;
+        p->m = m;
+        return p;
+    }
+#endif
+
+    ~pointObj() 
+    {
+        free(self);
+    }
+
+    /// Reproject point from proj_in to proj_out. Transformation is done in place.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(projectionObj *projin, projectionObj *projout) 
+    {
+        return msProjectPoint(projin, projout, self);
+    }
+
+    /// Reproject point given a reprojection object. Transformation is done in place.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(reprojectionObj *reprojector)
+    {
+        return msProjectPointEx(reprojector, self);
+    }
+
+    /// Draw the point using the styles defined by the classindex class of layer and 
+    /// labelled with string text. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int draw(mapObj *map, layerObj *layer, imageObj *image, int classindex, 
+             char *text) 
+    {
+        return msDrawPoint(map, layer, self, image, classindex, text);
+    }
+
+    /// Returns the distance to point.
+    double distanceToPoint(pointObj *point) 
+    {
+        return msDistancePointToPoint(self, point);
+    }
+
+    /// Returns the minimum distance to a hypothetical line segment connecting point1 
+    /// and point2.
+    double distanceToSegment(pointObj *a, pointObj *b) 
+    {
+        return msDistancePointToSegment(self, a, b);
+    }
+
+    /// Returns the minimum distance to shape.
+    double distanceToShape(shapeObj *shape) 
+    {
+        return msDistancePointToShape(self, shape);
+    }
+
+    /**
+    * Set spatial coordinate and, optionally, measure values simultaneously. 
+    * The measure will be set only if the value of m is greater than the ESRI measure 
+    * no-data value of -1e38. 
+    * Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int setXY(double x, double y, double m=-2e38) 
+    {
+        self->x = x;
+        self->y = y;
+        self->z = 0.0;
+        self->m = m;
+        return MS_SUCCESS;
+    }
+
+    /**
+    * Set spatial coordinate and, optionally, measure values simultaneously. 
+    * The measure will be set only if the value of m is greater than the ESRI measure 
+    * no-data value of -1e38. 
+    * Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int setXYZ(double x, double y, double z, double m=-2e38) 
+    {
+        self->x = x;
+        self->y = y;
+        self->z = z;
+        self->m = m;
+        return MS_SUCCESS;
+    }
+
+    /**
+    * Set spatial coordinate and, optionally, measure values simultaneously.
+    * The measure will be set only if the value of m is greater than the ESRI measure
+    * no-data value of -1e38.
+    * Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    */
+    int setXYZM(double x, double y, double z, double m) 
+    {
+        self->x = x;
+        self->y = y;
+        self->z = z;
+        self->m = m;
+        return MS_SUCCESS;
+    }
+
+    %newobject toString;
+    /**
+    Return a string formatted like: ``{ 'x': %f , 'y': %f, 'z': %f }``
+    with the coordinate values substituted appropriately. Python users can get the same effect 
+    via the pointObj  __str__ method:
+    
+    >>> p = mapscript.pointObj(1, 1)
+    >>> str(p)
+    { 'x': 1.000000 , 'y': 1.000000, 'z': 1.000000 }
+    */
+    char *toString() 
+    {
+        char buffer[256];
+        const char *fmt;
+
+        if( self->m < -1e38 ){
+            fmt = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g }";
+        }
+        else {
+            fmt = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g, 'm': %.16g }";
+        }
+
+msPointToFormattedString(self, fmt, (char *) &buffer, 256);
+    return msStrdup(buffer);
+    }
+
+    %newobject toShape;
+    /// Convert to a new :class:`shapeObj`
+    shapeObj *toShape() 
+    {
+      shapeObj *shape;
+
+      shape = (shapeObj *) malloc(sizeof(shapeObj));
+      msInitShape(shape);
+    
+      shape->type = MS_SHAPE_POINT;
+      shape->line = (lineObj *) malloc(sizeof(lineObj));
+      shape->numlines = 1;
+      shape->line[0].point = (pointObj *) malloc(sizeof(pointObj));
+      shape->line[0].numpoints = 1;
+
+      shape->line[0].point[0].x = self->x;
+      shape->line[0].point[0].y = self->y;
+      shape->line[0].point[0].z = self->z;
+      shape->line[0].point[0].m = self->m;
+
+      return shape;
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/projection.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/projection.i
--- 8.0.1-5/src/mapscript/swiginc/projection.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/projection.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,71 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript projectionObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend projectionObj 
+{
+
+    /// Create new instance of projectionObj. Input parameter proj4 is a 
+    /// PROJ definition string such as 'init=EPSG:4269'
+    projectionObj(char *proj4) 
+    {
+        int status;
+        projectionObj *proj=NULL;
+
+        proj = (projectionObj *)malloc(sizeof(projectionObj));
+        if (!proj) return NULL;
+        msInitProjection(proj);
+
+        status = msLoadProjectionString(proj, proj4);
+        if (status == -1) {
+            msFreeProjection(proj);
+            free(proj);
+            return NULL;
+        }
+
+        return proj;
+    }
+
+    ~projectionObj() 
+    {
+        msFreeProjection(self);
+        free(self);
+    }
+
+    /// Update the projectionObj using an OGC WKT definition
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setWKTProjection(char* wkt) {
+        /* no debug output here */
+        return msOGCWKT2ProjectionObj(wkt, self, MS_FALSE);
+    }
+
+    /// Returns the units of a projection object. Returns -1 on error.
+    int getUnits() {
+      return GetMapserverUnitUsingProj(self);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/querymap.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/querymap.i
--- 8.0.1-5/src/mapscript/swiginc/querymap.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/querymap.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,45 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript queryMapObj extensions
+   Author:   Steve Lime
+
+   ===========================================================================
+   Copyright (c) 1996-2007 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend queryMapObj
+{
+
+  /// Update a querymap from a string snippet. 
+  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int updateFromString(char *snippet)
+  {
+    return msUpdateQueryMapFromString(self, snippet);
+  }
+
+  %newobject convertToString;
+  /// Saves the object to a string. Provides the inverse option for :func:`queryMapObj.updateFromString`.
+  char* convertToString()
+  {
+    return msWriteQueryMapToString(self);
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/rect.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/rect.i
--- 8.0.1-5/src/mapscript/swiginc/rect.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/rect.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,188 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript rectObj extensions
+   Author:   Steve Lime
+             Sean Gillies, sgillies@frii.com
+
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend rectObj {
+
+    /**
+    * Create new instance. The four easting and northing arguments are optional and 
+    * default to -1.0. Note the new optional fifth argument which allows creation 
+    * of rectangles in image (pixel/line) units which are also tested for validity.
+    */
+    rectObj(double minx=-1.0, double miny=-1.0, 
+            double maxx=-1.0, double maxy=-1.0,
+            int imageunits=MS_FALSE) 
+    {
+        rectObj *rect;
+    
+        if (imageunits == MS_FALSE)
+        { 
+            if (minx > maxx || miny > maxy)
+            {
+                msSetError(MS_RECTERR,
+                    "{ 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }",
+                    "rectObj()", minx, miny, maxx, maxy);
+                return NULL;
+            }
+        }
+        else 
+        {
+            if (minx > maxx || maxy > miny) 
+            {
+                msSetError(MS_RECTERR,
+                    "image (pixel/line) units { 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }",
+                    "rectObj()", minx, miny, maxx, maxy);
+                return NULL;
+            }
+        }
+    
+        rect = (rectObj *)calloc(1, sizeof(rectObj));
+        if (!rect)
+            return(NULL);
+    
+        rect->minx = minx;
+        rect->miny = miny;
+        rect->maxx = maxx;
+        rect->maxy = maxy;
+
+        return(rect);
+    }
+
+    ~rectObj() {
+        free(self);
+    }
+
+    /// Reproject rectangle from proj_in to proj_out. Transformation is done in place. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(projectionObj *projin, projectionObj *projout) {
+        return msProjectRect(projin, projout, self);
+    }
+
+    /// Reproject rectangle given a reprojection object. Transformation is done in place.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(reprojectionObj *reprojector)
+    {
+        return msProjectRectAsPolygon(reprojector, self);
+    }
+
+    /// Adjust the rect to fit the width and height. Returns cellsize of rect.
+    double fit(int width, int height) {
+        return  msAdjustExtent(self, width, height);
+    } 
+
+    /// Draw rectangle into img using style defined by the classindex class of layer. 
+    /// The rectangle is labeled with the string text. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int draw(mapObj *map, layerObj *layer, imageObj *image, 
+             int classindex, char *text) 
+    {
+        shapeObj shape;
+        int ret;
+
+        msInitShape(&shape);
+        msRectToPolygon(*self, &shape);
+        shape.classindex = classindex;
+        if(text && layer->class[classindex]->numlabels > 0) {
+          shape.text = msStrdup(text);
+        }
+        
+        ret = msDrawShape(map, layer, &shape, image, -1, MS_DRAWMODE_FEATURES|MS_DRAWMODE_LABELS);
+
+        msFreeShape(&shape);
+    
+        return ret;
+    }
+    
+    %newobject getCenter;
+    /// Return the center point of the rectangle.
+    pointObj *getCenter() 
+    {
+        pointObj *center;
+        center = (pointObj *)calloc(1, sizeof(pointObj));
+        if (!center) {
+            msSetError(2, "Failed to allocate memory for point", "getCenter()");
+            return NULL;
+        }
+        center->x = (self->minx + self->maxx)/2;
+        center->y = (self->miny + self->maxy)/2;
+        
+        return center;
+    }
+
+    %newobject toPolygon;
+    /// Convert to a polygon of five vertices.
+    shapeObj *toPolygon() 
+    {
+        lineObj line = {0,NULL};
+        shapeObj *shape;
+        shape = (shapeObj *)malloc(sizeof(shapeObj));
+        if (!shape)
+            return NULL;
+        msInitShape(shape);
+        shape->type = MS_SHAPE_POLYGON;
+  
+        line.point = (pointObj *)malloc(sizeof(pointObj)*5);
+        line.point[0].x = self->minx;
+        line.point[0].y = self->miny;
+        line.point[1].x = self->minx;
+        line.point[1].y = self->maxy;
+        line.point[2].x = self->maxx;
+        line.point[2].y = self->maxy;
+        line.point[3].x = self->maxx;
+        line.point[3].y = self->miny;
+        line.point[4].x = line.point[0].x;
+        line.point[4].y = line.point[0].y;
+  
+        line.numpoints = 5;
+  
+        msAddLine(shape, &line);
+        msComputeBounds(shape);
+        
+        free(line.point);
+
+        return shape;
+    }
+
+    %newobject toString;
+    /**
+    Return a string formatted like: ``{ 'minx': %f , 'miny': %f , 'maxx': %f , 'maxy': %f }``
+    with the bounding values substituted appropriately. Python users can get the same effect 
+    via the rectObj __str__ method:
+    
+    >>> r = mapscript.rectObj(0, 0, 1, 1)
+    >>> str(r)
+    { 'minx': 0 , 'miny': 0 , 'maxx': 1 , 'maxy': 1 }
+    */
+    char *toString()
+    {
+        char buffer[256];
+        char fmt[]="{ 'minx': %.16g , 'miny': %.16g , 'maxx': %.16g , 'maxy': %.16g }";
+        msRectToFormattedString(self, (char *) &fmt, (char *) &buffer, 256);
+        return msStrdup(buffer);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/referencemap.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/referencemap.i
--- 8.0.1-5/src/mapscript/swiginc/referencemap.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/referencemap.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,44 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript referenceMapObj extensions
+   Author:   Steve Lime
+
+   ===========================================================================
+   Copyright (c) 1996-2007 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend referenceMapObj
+{
+  /// Update a reference map from a string snippet. 
+  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int updateFromString(char *snippet)
+  {
+    return msUpdateReferenceMapFromString(self, snippet);
+  }
+
+  %newobject convertToString;
+  /// Saves the object to a string. Provides the inverse option for :func:`referenceMapObj.updateFromString`.
+  char* convertToString()
+  {
+    return msWriteReferenceMapToString(self);
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/reprojection.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/reprojection.i
--- 8.0.1-5/src/mapscript/swiginc/reprojection.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/reprojection.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,44 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript reprojectionObj extensions
+   Author:   Steve Lime 
+             Even Rouault
+             
+   ===========================================================================
+   Copyright (c) 1996-2022 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+
+%extend reprojectionObj
+{
+    /// Create new instance of reprojectionObj. Input parameters are two projectionsObj's - in and out.
+    reprojectionObj(projectionObj *in, projectionObj *out) 
+    {
+        if(!in && !out) return NULL;
+        return msProjectCreateReprojector(in, out);
+    }
+
+    ~reprojectionObj() 
+    {
+        msProjectDestroyReprojector(self);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/result.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/result.i
--- 8.0.1-5/src/mapscript/swiginc/result.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/result.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,52 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript shapeObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend resultObj 
+{
+    /**
+    * The result object is a handle, of sorts, for a feature of the layer, having 
+    * ``shapeindex`` and ``tileindex`` attributes that can be used as arguments to 
+    * ``getFeature``
+    */
+    resultObj(long shapeindex) 
+    {
+        resultObj *result = (resultObj *) msSmallMalloc(sizeof(resultObj));
+
+        result->tileindex = -1;
+        result->resultindex = -1; 
+        result->shapeindex = shapeindex;
+        
+        return result;
+    }
+
+    ~resultObj() 
+    {
+        free(self);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/resultcache.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/resultcache.i
--- 8.0.1-5/src/mapscript/swiginc/resultcache.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/resultcache.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,43 @@
+/* ===========================================================================   
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript resultCacheObj extensions
+   Author:   Steve Lime
+             Sean Gillies, sgillies@frii.com
+
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend resultCacheObj
+{
+    /// Returns the result at index i, like :meth:`layerObj.getResult`,
+    /// or ``NULL`` if index is outside the range of results.
+    resultObj *getResult(int i)
+    {
+        if (i >= 0 && i < self->numresults) {
+            return &self->results[i];
+        }
+        return NULL;
+    }
+
+}
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/scalebar.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/scalebar.i
--- 8.0.1-5/src/mapscript/swiginc/scalebar.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/scalebar.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,44 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript scalebarObj extensions
+   Author:   Steve Lime
+
+   ===========================================================================
+   Copyright (c) 1996-2007 Regents of the University of Minnesota.
+
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend scalebarObj
+{
+  /// Update a scalebar from a string snippet. 
+  /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+  int updateFromString(char *snippet)
+  {
+    return msUpdateScalebarFromString(self, snippet);
+  }
+  
+  %newobject convertToString;
+  /// Saves the object to a string. Provides the inverse option for updateFromString.
+  char* convertToString()
+  {
+    return msWriteScalebarToString(self);
+  }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/shape.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/shape.i
--- 8.0.1-5/src/mapscript/swiginc/shape.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/shape.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,340 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript shapeObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend shapeObj 
+{
+    /**
+    * Return a new shapeObj of the specified type. See the type attribute. 
+    * No attribute values created by default. 
+    * initValues should be explicitly called to create the required number of values. 
+    * Each feature of a layer's data is a shapeObj. Each part of the shape is a 
+    * closed :class:`lineObj`
+    */
+    shapeObj(int type=MS_SHAPE_NULL) 
+    {
+        shapeObj *shape;
+
+    shape = (shapeObj *)malloc(sizeof(shapeObj));
+        if (!shape)
+            return NULL;
+
+        msInitShape(shape);
+        if(type >= 0) shape->type = type;
+        
+        return shape;
+    }
+
+    ~shapeObj() 
+    {
+        msFreeShape(self);
+        free(self);		
+    }
+
+    %newobject fromWKT;
+    /// Returns a new shapeObj based on a well-known text representation of a geometry. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    static shapeObj *fromWKT(char *wkt)
+    {
+    shapeObj *shape;
+        
+        if(!wkt) return NULL;
+
+        shape = msShapeFromWKT(wkt);
+    if(!shape) return NULL;
+
+    return shape;
+    }
+
+    /// Reproject shape from proj_in to proj_out. Transformation is done in place. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(projectionObj *projin, projectionObj *projout) 
+    {
+        return msProjectShape(projin, projout, self);
+    }
+
+    /// Reproject shape given a reprojection object. Transformation is done in place.
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int project(reprojectionObj *reprojector)
+    {
+        return msProjectShapeEx(reprojector, self);
+    }
+
+    /// Returns a reference to part at index. Reference is valid only during 
+    /// the life of the shapeObj.
+    lineObj *get(int i) {
+        if (i<0 || i>=self->numlines)
+            return NULL;
+        else
+            return &(self->line[i]);
+    }
+
+    /// Add line (i.e. a part) to the shape. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int add(lineObj *line) {
+        return msAddLine(self, line);
+    }
+
+    /// Draws the individual shape using layer. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int draw(mapObj *map, layerObj *layer, imageObj *image) {
+        return msDrawShape(map, layer, self, image, -1, MS_DRAWMODE_FEATURES|MS_DRAWMODE_LABELS);
+    }
+
+    /// Must be called to calculate new bounding box after new parts have been added.
+    /// TODO: should return int and set msSetError.
+    void setBounds() 
+    {    
+        msComputeBounds(self);
+        return;
+    }
+
+#if defined (SWIGJAVA) || defined (SWIGPHP)
+    %newobject cloneShape;
+    shapeObj *cloneShape()
+#else
+    %newobject clone;
+    /**
+    Return an independent copy of the shape.
+
+    .. note::
+
+        In the Java & PHP modules this method is named ``cloneShape``.    
+    */    
+    shapeObj *clone()
+#endif
+    {
+        shapeObj *shape;
+        shape = (shapeObj *)malloc(sizeof(shapeObj));
+        if (!shape)
+            return NULL;
+        msInitShape(shape);
+        shape->type = self->type;
+        msCopyShape(self, shape);
+        return shape;
+    }
+
+    /// Copy the shape to shape_copy. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int copy(shapeObj *dest) 
+    {
+        return(msCopyShape(self, dest));
+    }
+
+    %newobject toWKT;
+    /// Returns the well - known text representation of a shapeObj.
+    /// Requires GEOS support.Returns NULL / undefined on failure.
+    char *toWKT()
+    {
+        return msShapeToWKT(self);
+    }
+
+    %newobject buffer;
+    /// Returns a new buffered shapeObj based on the supplied distance 
+    /// (given in the coordinates of the existing shapeObj). 
+    /// Requires GEOS support. Returns NULL/undefined on failure.
+    shapeObj *buffer(double width) { return msGEOSBuffer(self, width); }
+
+    %newobject simplify;
+    /// Given a tolerance, returns a simplified shape object or NULL on error. 
+    /// Requires GEOS support (>=3.0).
+    shapeObj *simplify(double tolerance) { return msGEOSSimplify(self, tolerance); }
+
+    %newobject topologyPreservingSimplify;
+    /// Given a tolerance, returns a simplified shape object or NULL on error. 
+    /// Requires GEOS support (>=3.0).
+    shapeObj *topologyPreservingSimplify(double tolerance) { return msGEOSTopologyPreservingSimplify(self, tolerance); }
+
+    %newobject convexHull;
+    /// Returns the convex hull of the existing shape. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    shapeObj *convexHull() { return msGEOSConvexHull(self); }
+
+    %newobject boundary;
+    /// Returns the boundary of the existing shape. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    shapeObj *boundary() { return msGEOSBoundary(self); }
+
+    %newobject getCentroid;
+    /// Returns the centroid for the existing shape. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    pointObj *getCentroid() { return msGEOSGetCentroid(self); }
+
+    %newobject Union;
+    /// Returns the union of the existing and supplied shape. 
+    /// Shapes must be of the same type. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    shapeObj *Union(shapeObj *shape) { return msGEOSUnion(self, shape); }
+
+    %newobject intersection;
+    /// Returns the computed intersection of the supplied and existing shape. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    shapeObj *intersection(shapeObj *shape) { return msGEOSIntersection(self, shape); }
+
+    %newobject difference;
+    /// Returns the computed difference of the supplied and existing shape. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    shapeObj *difference(shapeObj *shape) { return msGEOSDifference(self, shape); }
+
+    %newobject symDifference;
+    /// Returns the computed symmetric difference of the supplied and existing shape. 
+    /// Requires GEOS support. Returns NULL/undef on failure.
+    shapeObj *symDifference(shapeObj *shape) { return msGEOSSymDifference(self, shape); }
+
+    /// Returns :data:`MS_TRUE` if shape2 is entirely inside the shape, returns -1 on error and :data:`MS_FALSE` otherwise.
+    /// Requires GEOS support.
+    int contains(shapeObj *shape) { return msGEOSContains(self, shape); }
+
+    /// Returns :data:`MS_TRUE` if shape2 overlaps shape, returns -1 on error and :data:`MS_FALSE` otherwise.
+    /// Requires GEOS support.
+    int overlaps(shapeObj *shape) { return msGEOSOverlaps(self, shape); }
+
+    /// Returns :data:`MS_TRUE` if shape is entirely within shape2, returns -1 on error and :data:`MS_FALSE` otherwise.
+    /// Requires GEOS support.
+    int within(shapeObj *shape) { return msGEOSWithin(self, shape); }
+
+    /// Returns :data:`MS_TRUE` if shape2 crosses the shape, returns -1 on error and :data:`MS_FALSE` otherwise.
+    /// Requires GEOS support.
+    int crosses(shapeObj *shape) { return msGEOSCrosses(self, shape); }
+
+    /// Returns :data:`MS_TRUE` if shape and shape2 intersect, and :data:`MS_FALSE` otherwise.
+    /// Does not require GEOS support but will use GEOS functions if available.
+    int intersects(shapeObj *shape) { return msGEOSIntersects(self, shape); } /* if GEOS is not present an alternative computation is provided, see mapgeos.c */
+
+    /// Returns :data:`MS_TRUE` if shape and shape2 touch, returns -1 on error and :data:`MS_FALSE` otherwise.
+    /// Requires GEOS support.
+    int touches(shapeObj *shape) { return msGEOSTouches(self, shape); }
+
+    /// Returns :data:`MS_TRUE` if shape and shape2 are equal (geometry only), returns -1 on error and :data:`MS_FALSE` otherwise.
+    /// Requires GEOS support.
+    int equals(shapeObj *shape) { return msGEOSEquals(self, shape); }
+
+    /// Returns :data:`MS_TRUE` if shape and shape2 are disjoint, returns -1 on error and :data:`MS_FALSE` otherwise.
+    /// Requires GEOS support.
+    int disjoint(shapeObj *shape) { return msGEOSDisjoint(self, shape); }
+
+    /// Returns the area of the shape (if applicable). Requires GEOS support. 
+    double getArea() { return msGEOSArea(self); }
+
+    /// Returns the length (or perimeter) of the shape. Requires GEOS support. 
+    double getLength() { return msGEOSLength(self); }
+
+    /// Return the shape attribute at index i.
+    char *getValue(int i) 
+    {
+        if (i >= 0 && i < self->numvalues && self->values)
+            return (self->values[i]);
+        else
+            return NULL;
+    }
+
+    /// Returns :data:`MS_TRUE` if the point is inside the shape, :data:`MS_FALSE` otherwise
+    int contains(pointObj *point) 
+    {
+        if (self->type == MS_SHAPE_POLYGON)
+            return msIntersectPointPolygon(point, self);
+        
+        return -1;
+    }
+
+    /// Returns the distance to point.
+    double distanceToPoint(pointObj *point) 
+    {
+        return msDistancePointToShape(point, self); /* should there be a GEOS version of this? */
+    }
+
+    /// Returns the minimum distance to shape.
+    double distanceToShape(shapeObj *shape) 
+    {
+        return msGEOSDistance(self, shape); /* note this calls msDistanceShapeToShape() if GEOS support is not present */
+    }
+
+    %newobject getLabelPoint;
+    /// Given a shape, return a point object suitable for labelling it. 
+    pointObj *getLabelPoint()
+    {
+        pointObj *point = (pointObj *)calloc(1, sizeof(pointObj));
+        if (point == NULL) {
+            msSetError(MS_MEMERR, "Failed to allocate memory for point", "labelPoint()");
+            return NULL;
+        }
+
+        if(self->type == MS_SHAPE_POLYGON && msPolygonLabelPoint(self, point, -1) == MS_SUCCESS)
+            return point;
+
+        free(point);
+        return NULL;
+    }
+
+    /// Set the shape value at index i to value.
+    int setValue(int i, char *value)
+    {
+        if (!self->values || !value)
+        {
+            msSetError(MS_SHPERR, "Can't set value", "setValue()");
+            return MS_FAILURE;
+        }
+        if (i >= 0 && i < self->numvalues)
+        {
+            msFree(self->values[i]);
+            self->values[i] = msStrdup(value);
+            if (!self->values[i])
+            {
+                return MS_FAILURE;
+            }
+            else return MS_SUCCESS;
+        }
+        else
+        {
+            msSetError(MS_SHPERR, "Invalid value index", 
+                                  "setValue()");
+            return MS_FAILURE;
+        }
+    }
+
+    /// Allocates memory for the requested number of values.
+    void initValues(int numvalues)
+    {
+        int i;
+        
+        if(self->values) msFreeCharArray(self->values, self->numvalues);
+        self->values = NULL;
+        self->numvalues = 0;
+        
+        /* Allocate memory for the values */
+        if (numvalues > 0) {
+            if ((self->values = (char **)malloc(sizeof(char *)*numvalues)) == NULL) {
+                msSetError(MS_MEMERR, "Failed to allocate memory for values", "shapeObj()");
+                return;
+            } else {
+                for (i=0; i<numvalues; i++) self->values[i] = msStrdup("");
+            }
+            self->numvalues = numvalues;
+        }
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/shapefile.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/shapefile.i
--- 8.0.1-5/src/mapscript/swiginc/shapefile.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/shapefile.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,160 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript shapefileObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2001 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend shapefileObj 
+{
+    /**
+    * Create a new instance. Omit the type argument or use a value of -1 to open 
+    * an existing shapefile.
+    *
+    * Type should be one of :data:`MS_SHAPEFILE_POINT`, :data:`MS_SHAPEFILE_ARC`,
+    * :data:`MS_SHAPEFILE_POLYGON` or :data:`MS_SHAPEFILE_MULTIPOINT`
+    */
+    shapefileObj(char *filename, int type=-1) 
+    {    
+        shapefileObj *shapefile;
+        int status;
+
+        shapefile = (shapefileObj *)malloc(sizeof(shapefileObj));
+        if (!shapefile)
+            return NULL;
+
+        if (type == -1)
+            status = msShapefileOpen(shapefile, "rb", filename, MS_TRUE);
+        else if (type == -2)
+            status = msShapefileOpen(shapefile, "rb+", filename, MS_TRUE);
+        else
+            status = msShapefileCreate(shapefile, filename, type);
+
+        if (status == -1) {
+            msShapefileClose(shapefile);
+            free(shapefile);
+            return NULL;
+        }
+ 
+        return(shapefile);
+    }
+
+    ~shapefileObj() 
+    {
+        msShapefileClose(self);
+        free(self);  
+    }
+
+    /// Get the shapefile feature from index i and store it in shape. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int get(int i, shapeObj *shape) 
+    {
+        if (i<0 || i>=self->numshapes)
+            return MS_FAILURE;
+
+        msFreeShape(shape); /* frees all lines and points before re-filling */
+        msSHPReadShape(self->hSHP, i, shape);
+
+        return MS_SUCCESS;
+    }
+
+    %newobject getShape;
+    /// Returns the shapefile feature at index i. More efficient than get.
+    shapeObj *getShape(int i)
+    {
+        shapeObj *shape;
+        shape = (shapeObj *)malloc(sizeof(shapeObj));
+        if (!shape)
+            return NULL;
+        msInitShape(shape);
+        shape->type = self->type;
+        msSHPReadShape(self->hSHP, i, shape);
+        return shape;
+
+    }
+
+    /// Returns the point feature at index i and store it in pointObj.
+    int getPoint(int i, pointObj *point) 
+    {
+        if (i<0 || i>=self->numshapes)
+            return MS_FAILURE;
+
+        msSHPReadPoint(self->hSHP, i, point);
+        return MS_SUCCESS;
+    }
+
+    /// Returns the feature at index i, simplify it, and store it in shape. Uses the
+    /// map extent and cellsize for simplification. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int getTransformed(mapObj *map, int i, shapeObj *shape) 
+    {
+        if (i<0 || i>=self->numshapes)
+            return MS_FAILURE;
+
+        msFreeShape(shape); /* frees all lines and points before re-filling */
+        msSHPReadShape(self->hSHP, i, shape);
+        msTransformShapeSimplify(shape, map->extent, map->cellsize);
+
+        return MS_SUCCESS;
+    }
+
+    /// Retrieve a shape's bounding box by index and stores it in rect.
+    void getExtent(int i, rectObj *rect) 
+    {
+        msSHPReadBounds(self->hSHP, i, rect);
+    }
+
+    /// Appends a shape to the open shapefile. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int add(shapeObj *shape) 
+    {
+        /* Trap NULL or empty shapes -- bug 1201 */
+        if (!shape) 
+        {
+            msSetError(MS_SHPERR, "Can't add NULL shape", "shapefileObj::add");
+            return MS_FAILURE;
+        }
+        else if (!shape->line)
+        {
+            msSetError(MS_SHPERR, "Can't add empty shape", "shapefileObj::add");
+            return MS_FAILURE;
+        }
+
+        return msSHPWriteShape(self->hSHP, shape);
+    }
+
+    /// Appends a point to the open shapefile. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int addPoint(pointObj *point) 
+    {    
+        return msSHPWritePoint(self->hSHP, point);
+    }
+
+    /// Returns a :class:`DBFInfo` object containing information on the associated DBF
+    DBFInfo *getDBF() {
+        return self->hDBF;
+    }
+}
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/style.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/style.i
--- 8.0.1-5/src/mapscript/swiginc/style.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/style.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,199 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript styleObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2020 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+
+   */
+
+// See https://github.com/mapserver/mapserver/issues/548
+
+%extend styleObj {
+
+    /// Returns new default :class:`styleObj` instance. The ``parent_class`` is optional. 
+    styleObj(classObj *parent_class=NULL) 
+    {
+    
+        styleObj *style = NULL;
+        
+        if (parent_class!=NULL) {
+            if ((style = msGrowClassStyles(parent_class)) == NULL)
+                return NULL;
+
+            if ( initStyle(style) == MS_FAILURE ) {
+                msSetError(MS_MISCERR, "Failed to init new styleObj instance",
+                                       "initStyle()");
+            }
+            parent_class->numstyles++;
+            MS_REFCNT_INCR(style);
+        }
+        else {
+            style = (styleObj *) malloc(sizeof(styleObj));
+            if (!style) { 
+                msSetError(MS_MEMERR, "Failed to allocate memory for new styleObj instance",
+                                       "styleObj()");
+                return NULL;
+            }
+            if ( initStyle(style) == MS_FAILURE ) {
+                msSetError(MS_MISCERR, "Failed to init new styleObj instance",
+                                       "initStyle()");
+                msFree(style);
+                return NULL;
+            }
+        }
+        return style;
+    }
+   
+    ~styleObj() 
+    {
+        if (self) { 
+            if ( freeStyle(self) == MS_SUCCESS ) {
+                        free(self);
+                self=NULL;
+            }
+        }
+    }
+
+    /// Update a style from a string snippet. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int updateFromString(char *snippet)
+    {
+        return msUpdateStyleFromString(self, snippet);
+    }
+
+    %newobject convertToString;
+    /// Saves the object to a string. Provides the inverse option for :func:`styleObj.updateFromString` 
+    char* convertToString()
+    {
+        return msWriteStyleToString(self);
+    }
+
+#if defined (SWIGJAVA) || defined (SWIGPHP)
+    %newobject cloneStyle;
+    styleObj *cloneStyle() 
+#else
+    %newobject clone;
+    /**
+    Return an independent copy of the style with no parent class.
+
+    .. note::
+
+        In the Java & PHP modules this method is named ``cloneStyle``.    
+    */ 
+    styleObj *clone() 
+#endif
+    {
+        styleObj *style;
+
+        style = (styleObj *) malloc(sizeof(styleObj));
+        if (!style)
+        {
+            msSetError(MS_MEMERR,
+                "Could not allocate memory for new styleObj instance",
+                "clone()");
+            return NULL;
+        }
+        if (initStyle(style) == -1)
+        {
+            msSetError(MS_MEMERR, "Failed to initialize Style",
+                                  "clone()");
+            return NULL;
+        }
+
+        if (msCopyStyle(style, self) != MS_SUCCESS)
+        {
+            free(style);
+            return NULL;
+        }
+        
+        return style;
+    }
+
+    /// Setting the symbol of the :class:`styleObj` given the reference of the map 
+    /// object and the symbol name. 
+    int setSymbolByName(mapObj *map, char* symbolname) 
+    {
+        self->symbol = msGetSymbolIndex(&map->symbolset, symbolname, MS_TRUE);
+        if (self->symbolname) free((char*)self->symbolname);
+        if (symbolname) self->symbolname = msStrdup(symbolname);
+        else self->symbolname = 0;
+        return self->symbol;
+    }
+
+    /// Remove the attribute binding for a specified style property. 
+    int removeBinding(int binding) 
+    {
+        if(binding < 0 || binding >= MS_STYLE_BINDING_LENGTH) return MS_FAILURE;
+
+        if(self->bindings[binding].item) {
+            free(self->bindings[binding].item);
+            self->bindings[binding].item = NULL;
+            self->bindings[binding].index = -1;
+            self->numbindings--;
+        }
+
+        return MS_SUCCESS;
+    }
+
+    /// Remove the attribute binding for a specified style property. 
+    int setBinding(int binding, const char *item) 
+    {
+        if(!item) return MS_FAILURE;
+        if(binding < 0 || binding >= MS_STYLE_BINDING_LENGTH) return MS_FAILURE;
+
+        if(self->bindings[binding].item) {
+            free(self->bindings[binding].item);
+            self->bindings[binding].item = NULL;
+            self->bindings[binding].index = -1;
+            self->numbindings--;
+        }
+
+        self->bindings[binding].item = msStrdup(item);
+        self->numbindings++;
+
+        return MS_SUCCESS;
+    }
+
+    /// Get the attribute binding for a specified style property. 
+    /// Returns NULL if there is no binding for this property. 
+    const char *getBinding(int binding) 
+    {
+        if(binding < 0 || binding >= MS_STYLE_BINDING_LENGTH) return NULL;
+
+        return self->bindings[binding].item;
+    }
+
+    /// Get the :ref:`GEOMTRANSFORM <mapfile-style-geomtransform>` for the style. 
+    char *getGeomTransform() 
+    {
+        return self->_geomtransform.string;
+    }
+
+    /// Set the :ref:`GEOMTRANSFORM <mapfile-style-geomtransform>` for the style. 
+    void setGeomTransform(char *transform) 
+    {
+        msStyleSetGeomTransform(self, transform);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/symbol.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/symbol.i
--- 8.0.1-5/src/mapscript/swiginc/symbol.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/symbol.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,165 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript symbolObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2020 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+/// See also https://github.com/mapserver/mapserver/issues/579
+
+%extend symbolObj 
+{
+
+    /// Create new default :class:`symbolObj` named ``symbolname``. If ``imagefile`` is specified, then the symbol 
+    /// will be of type :data:`MS_SYMBOL_PIXMAP`. 
+    symbolObj(char *symbolname, const char *imagefile=NULL) 
+    {
+        symbolObj *symbol;
+        symbol = (symbolObj *) malloc(sizeof(symbolObj));
+        initSymbol(symbol);
+        symbol->name = msStrdup(symbolname);
+        if (imagefile) {
+            msLoadImageSymbol(symbol, imagefile);
+        }
+        return symbol;
+    }
+
+    ~symbolObj() 
+    {
+        if (self) {
+            if (msFreeSymbol(self)==MS_SUCCESS) {
+                free(self);
+                self=NULL;
+            }
+        }
+    }
+
+    /// Sets the ``imagefile`` path for a :data:`MS_SYMBOL_PIXMAP`. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setImagepath(const char *imagefile) {
+        return msLoadImageSymbol(self, imagefile);
+    }
+
+    /// Sets the symbol points from the points of line. Returns the updated number of points. 
+    int setPoints(lineObj *line) {
+        int i;
+    self->sizex = 0;
+    self->sizey = 0;
+        for (i=0; i<line->numpoints; i++) {
+            MS_COPYPOINT(&(self->points[i]), &(line->point[i]));
+        self->sizex = MS_MAX(self->sizex, self->points[i].x);
+        self->sizey = MS_MAX(self->sizey, self->points[i].y);
+        }
+        self->numpoints = line->numpoints;
+        return self->numpoints;
+    }
+
+    %newobject getPoints;
+    /// Returns the symbol points as a :class:`lineObj`. 
+    lineObj *getPoints() 
+    {
+        int i;
+        lineObj *line;
+        line = (lineObj *) malloc(sizeof(lineObj));
+        line->point = (pointObj *) malloc(sizeof(pointObj)*(self->numpoints));
+        for (i=0; i<self->numpoints; i++) {
+            line->point[i].x = self->points[i].x;
+            line->point[i].y = self->points[i].y;
+        }
+        line->numpoints = self->numpoints;
+        return line;
+    }
+
+    %newobject getImage;
+    /// Returns a pixmap symbol's imagery as an :class:`imageObj`. 
+    imageObj *getImage(outputFormatObj *input_format)
+    {
+        imageObj *image = NULL;
+        outputFormatObj *format = NULL;
+        rendererVTableObj *renderer = NULL;
+
+        if (input_format)
+        {
+            format = input_format;
+        }
+        else 
+        {
+            format = msCreateDefaultOutputFormat(NULL, "AGG/PNG", "aggpng", NULL);
+            if (format)
+                msInitializeRendererVTable(format);
+        }
+        
+        if (format == NULL) 
+        {
+            msSetError(MS_IMGERR, "Could not create output format",
+                       "getImage()");
+            return NULL;
+        }
+
+        renderer = format->vtable;
+        msPreloadImageSymbol(renderer, self);
+        if (self->pixmap_buffer) 
+        {
+            image = msImageCreate(self->pixmap_buffer->width, self->pixmap_buffer->height, format, NULL, NULL,
+                                  MS_DEFAULT_RESOLUTION, MS_DEFAULT_RESOLUTION, NULL);
+            if(!image) {
+              msSetError(MS_IMGERR, "Could not create image",
+                       "getImage()");
+              return NULL;
+            }
+            if(MS_SUCCESS != renderer->mergeRasterBuffer(image, self->pixmap_buffer, 1.0, 0, 0, 0, 0,
+                                        self->pixmap_buffer->width, self->pixmap_buffer->height)) {
+              msSetError(MS_IMGERR, "Could not merge symbol image",
+                       "getImage()");
+              msFreeImage(image);
+              return NULL;
+            }
+        }
+
+        return image;
+    }
+
+    /// Set a pixmap symbol's imagery from image. 
+    /// Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int setImage(imageObj *image)
+    {
+        rendererVTableObj *renderer = NULL;
+        
+        renderer = image->format->vtable;
+        
+        if (self->pixmap_buffer) {
+            msFreeRasterBuffer(self->pixmap_buffer);
+            free(self->pixmap_buffer);
+        }
+        
+        self->pixmap_buffer = (rasterBufferObj*)malloc(sizeof(rasterBufferObj));
+        if (!self->pixmap_buffer) {
+            msSetError(MS_MEMERR, NULL, "setImage()");
+            return MS_FAILURE;
+        }
+        self->type = MS_SYMBOL_PIXMAP;
+        return renderer->getRasterBufferCopy(image, self->pixmap_buffer);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/swiginc/symbolset.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/symbolset.i
--- 8.0.1-5/src/mapscript/swiginc/symbolset.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/symbolset.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,118 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript symbolSetObj extensions
+   Author:   Steve Lime 
+             Sean Gillies, sgillies@frii.com
+             
+   ===========================================================================
+   Copyright (c) 1996-2020 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+%extend symbolSetObj 
+{
+
+    /// Create new :class:`symbolSetObj` instance. If symbolfile is specified, symbols will be 
+    /// loaded from the file. 
+    symbolSetObj(const char *symbolfile=NULL) 
+    {
+        symbolSetObj *symbolset;
+        mapObj *temp_map=NULL;
+        symbolset = (symbolSetObj *) malloc(sizeof(symbolSetObj));
+        msInitSymbolSet(symbolset);
+        if (symbolfile) {
+            symbolset->filename = msStrdup(symbolfile);
+            temp_map = msNewMapObj();
+            msLoadSymbolSet(symbolset, temp_map);
+            symbolset->map = NULL;
+            msFreeMap(temp_map);
+        }
+        return symbolset;
+    }
+
+    ~symbolSetObj() 
+    {
+        msFreeSymbolSet(self);
+        if (self->filename) free(self->filename);
+        free(self);
+    }
+
+    %newobject getSymbol;
+    /// Returns a reference to the symbol at index.
+    symbolObj *getSymbol(int i) 
+    {
+        if (i >= 0 && i < self->numsymbols) {
+            symbolObj *s=self->symbol[i];
+            MS_REFCNT_INCR(s);
+            return s;
+        } else
+            return NULL;
+    }
+
+    %newobject getSymbolByName;
+    /// Returns a reference to the symbol named name.
+    symbolObj *getSymbolByName(char *symbolname) 
+    {
+        int i;
+
+        if (!symbolname) return NULL;
+
+        i = msGetSymbolIndex(self, symbolname, MS_TRUE);
+        if (i == -1)
+            return NULL;
+        else {
+            MS_REFCNT_INCR(self->symbol[i]);
+            return self->symbol[i];
+        }
+    }
+
+    /// Return the index of the symbol named name or -1 in the case that no such 
+    /// symbol is found. 
+    int index(char *symbolname) 
+    {
+        return msGetSymbolIndex(self, symbolname, MS_TRUE);
+    }
+
+    /// Add a copy of symbol to the symbolset and return its index. 
+    int appendSymbol(symbolObj *symbol) 
+    {
+        return msAppendSymbol(self, symbol);
+    }
+
+    %newobject removeSymbol;
+    /// Remove the symbol at index and return a copy of the symbol.
+    symbolObj *removeSymbol(int index) 
+    {
+        symbolObj *s=msRemoveSymbol(self, index);
+        if (s!=NULL) {
+            MS_REFCNT_INCR(s);
+        }
+        return s;
+    }
+
+    /// Save symbol set to a file. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int save(const char *filename) {
+        return msSaveSymbolSet(self, filename);
+    }
+
+}
+
+
diff -pruN 8.0.1-5/src/mapscript/swiginc/web.i 8.2.0~beta1-1~exp1/src/mapscript/swiginc/web.i
--- 8.0.1-5/src/mapscript/swiginc/web.i	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/swiginc/web.i	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+/* ===========================================================================
+   Project:  MapServer
+   Purpose:  SWIG interface file for mapscript webObj extensions
+   Author:   Steve Lime 
+             Umberto Nicoletti unicoletti@prometeo.it
+             
+   ===========================================================================
+   Copyright (c) 1996-2020 Regents of the University of Minnesota.
+   
+   Permission is hereby granted, free of charge, to any person obtaining a
+   copy of this software and associated documentation files (the "Software"),
+   to deal in the Software without restriction, including without limitation
+   the rights to use, copy, modify, merge, publish, distribute, sublicense,
+   and/or sell copies of the Software, and to permit persons to whom the
+   Software is furnished to do so, subject to the following conditions:
+ 
+   The above copyright notice and this permission notice shall be included
+   in all copies or substantial portions of the Software.
+ 
+   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+   DEALINGS IN THE SOFTWARE.
+   ===========================================================================
+*/
+
+// See https://github.com/mapserver/mapserver/issues/1798 for a related issue
+
+%extend webObj 
+{
+    /**
+    * Instances of :class:`webObj` are always are always embedded inside the :class:`mapObj`. 
+    * Has no other existence than as an attribute of a :class:`mapObj`. Serves as a container for various run-time 
+    * web application definitions like temporary file paths, template paths, etc.
+    */
+    webObj() 
+    {
+        webObj *web;
+        web = (webObj *) malloc(sizeof(webObj));
+        initWeb(web);
+        return web;
+    }
+
+    ~webObj() 
+    {
+        if (!self) return;
+        freeWeb(self);
+        free(self);
+    }
+
+    /// Update a :class:`webObj` from a string snippet. Returns :data:`MS_SUCCESS` or :data:`MS_FAILURE`
+    int updateFromString(char *snippet)
+    {
+        return msUpdateWebFromString(self, snippet);
+    }
+
+    %newobject convertToString;
+    /// Output the :ref:`web` object as a Mapfile string. Provides the inverse option for :func:`webObj.updateFromString`.
+    char* convertToString()
+    {
+        return msWriteWebToString(self);
+    }
+}
diff -pruN 8.0.1-5/src/mapscript/tcl/Makefile.in 8.2.0~beta1-1~exp1/src/mapscript/tcl/Makefile.in
--- 8.0.1-5/src/mapscript/tcl/Makefile.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/Makefile.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,103 @@
+#
+# Makefile.in for mapscript Tcl interface
+# Tom Poindexter, tpoindex@nyx.net
+#
+
+DLTARGET            = libMapscript11
+PACKAGEDIR          = MapscriptTcl1.1
+
+# Note: also change 'package provide' version in pkgIndex.tcl !!
+
+SWIGINC             = -I@SWIGDIR@/include
+SWIGLIB             = -L@SWIGDIR@/lib
+SWIGLIB_SPEC        = -lswig
+
+TCL_PREFIX          = @TCL_PREFIX@
+TCL_EXEC_PREFIX     = @TCL_EXEC_PREFIX@
+TCL_CC              = @TCL_CC@
+TCL_DEFS            = @TCL_DEFS@
+TCL_SHLIB_SUFFIX    = @TCL_SHLIB_SUFFIX@
+TCL_SHLIB_CFLAGS    = @TCL_SHLIB_CFLAGS@
+TCL_LD_SEARCH_FLAGS = @TCL_LD_SEARCH_FLAGS@
+TCL_SHLIB_LD        = @TCL_SHLIB_LD@
+TCL_LIB_SPEC        = @TCL_LIB_SPEC@
+TCL_STUB_LIB_SPEC   = @TCL_STUB_LIB_SPEC@
+TCL_LIBS            = @TCL_LIBS@
+LIBS                = @TCL_LIBS@
+TCL_DBGX            = @TCL_DBGX@
+LIB_RUNTIME_DIR     = @TCL_EXEC_PREFIX@/lib:@TCL_EXEC_PREFIX@/lib/$(PACKAGEDIR):@TCL_PREFIX@/lib:@MAPSERVERHOME@
+
+MAPSERVERHOME       = @MAPSERVERHOME@
+MAPSERVERDEFS       = @MAPSERVERDEFS@
+MAPSERVERINCS       = @MAPSERVERINCS@
+MAPSERVERLIBS       = @MAPSERVERLIBS@
+
+# ugly alert!
+# see the README for this hack
+SWIG_STUB_HACK = -DUSE_TCL_STUBS -DITCL_NAMESPACES -DItcl_Namespace=int \
+		 -D"spaceId=spcid;Tcl_InitStubs(interp,\"8.1\",0)"
+
+all: stublib
+
+stublib: mapscript_wrap.c
+	$(TCL_CC) -c $(TCL_DEFS) $(TCL_SHLIB_CFLAGS) \
+		-I$(TCL_PREFIX)/include \
+		$(MAPSERVERDEFS) $(MAPSERVERINCS) \
+		$(SWIG_STUB_HACK) \
+		mapscript_wrap.c
+	$(TCL_SHLIB_LD) -o $(DLTARGET)$(TCL_SHLIB_SUFFIX) mapscript_wrap.o \
+		$(TCL_LD_SEARCH_FLAGS) \
+		$(TCL_STUB_LIB_SPEC) \
+		$(TCL_LIBS) \
+		-L$(MAPSERVERHOME) $(MAPSERVERLIBS)
+
+mapscript_wrap.c:
+	swig -tcl8 -dhtml -namespace $(MAPSERVERDEFS) $(MAPSERVERINCS) \
+		mapscript.i
+
+nostublib: mapscript_wrap.c
+	$(TCL_CC) -c $(TCL_DEFS) $(TCL_SHLIB_CFLAGS) \
+		-I$(TCL_PREFIX)/include \
+		$(MAPSERVERDEFS) $(MAPSERVERINCS) \
+		mapscript_wrap.c
+	$(TCL_SHLIB_LD) -o $(DLTARGET)$(TCL_SHLIB_SUFFIX) mapscript_wrap.o \
+		$(TCL_LD_SEARCH_FLAGS) \
+		$(TCL_LIB_SPEC) \
+		$(TCL_LIBS) \
+		-L$(MAPSERVERHOME) $(MAPSERVERLIBS)
+
+$(DLTARGET)$(TCL_SHLIB_SUFFIX): mapscript_wrap.o
+
+install: $(DLTARGET)$(TCL_SHLIB_SUFFIX)
+	-mkdir $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
+	cp $(DLTARGET)$(TCL_SHLIB_SUFFIX) $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
+	chmod +x \
+	   $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)/$(DLTARGET)$(TCL_SHLIB_SUFFIX)
+	cp pkgIndex.tcl                   $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
+	cp mapscriptsupp.tcl              $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
+	cp mapscriptsupp.html             $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
+	cp mapscript_wrap.html            $(TCL_EXEC_PREFIX)/lib/$(PACKAGEDIR)
+
+
+useprebuilt:
+	gunzip -c mapscript_wrap.c.gz >mapscript_wrap.c
+
+prebuilt:  mapscript_wrap.c
+	gzip -cf mapscript_wrap.c >mapscript_wrap.c.gz
+
+tar:
+	if test ! -f mapscript_wrap.c.gz ; then \
+		gzip -cf mapscript_wrap.c >mapscript_wrap.c.gz; fi
+	rm -f mapscript_wrap.c
+	(cd ..; tar cf mapscript-tcl.tar tcl )
+	gzip -f ../mapscript-tcl.tar
+
+clean:
+	rm -f *.o core *.so
+
+distclean: clean
+	rm -f Makefile
+
+reallyclean: distclean
+	rm -f mapscript_wrap.*
+
diff -pruN 8.0.1-5/src/mapscript/tcl/README 8.2.0~beta1-1~exp1/src/mapscript/tcl/README
--- 8.0.1-5/src/mapscript/tcl/README	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/README	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,167 @@
+Mapscript Tcl Interface
+
+WHAT
+It's a Tcl interface for Mapserver.  You can write Tcl scripts to generate
+maps, read/write shapefiles, etc.
+
+VERSION
+Mapscript 1.1 is built for Mapserver 3.5 +
+
+INSTALL
+A simple 'configure' script and Makefile is included.  The configure is hand
+built, rather than being derived from GNU autoconf.  Normally you can just 
+type:
+	configure
+	make
+	make install
+
+    to build and install the interface.  Three configure options are supported:
+
+	configure --with-tcl=[dir]  --with-swig=[dir]  --with-linker-cc
+
+	--with-tcl=[dir]    specify the directory where you installed Tcl,
+			    the default is /usr/local.  'configure' looks for
+			    $dir/lib/tclConfig.sh for Tcl configure info.
+
+	--with-swig=[dir]   specify the directory where you installed Swig,
+			    the default is /usr/local.  'configure' looks for
+			    $dir/include/swig.h and $dir/lib/libswig.a.
+
+	--with-linker-cc    use the compiler command as the front-end for
+			    linking, if not already so.  See 'COMPILE PROBLEMS'
+			    below.
+
+	** Mapserver source code is presumed to be two directory levels above
+	this directory, and uses various .h files from Mapscript, along	
+	with ../mapscript.i.
+
+	** Mapscript/Tcl normally builds as a Tcl stubbed dynamic library.
+	The makefile includes a target 'nostublib' if you want to build
+	with a Tcl version dependent library (not recommended).
+
+	** Tested with Tcl/Tk version 8.3.2, and Swig version 1.1-883
+
+
+REQUIREMENTS
+You must have Tcl (tcl.sourceforge.net) installed and optionally, Swig 
+installed also (www.swig.org).  
+
+The current mapscript.i Swig interface definition file is designed for
+Swig 1.1 versions.  Newer versions of Swig may require mapscript.i changes.
+You should have Tcl 8.3 or greater installed, as the Makefile normally builds
+with the Tcl dynamic stubs library.  Tcl 8.3.2 (or current release) is 
+recommended.  Additionally, you may want the Img Tcl extension to
+support upcoming Mapserver images (PNG, JPG, etc.)  See the NOTES section
+below for more information.
+
+
+COMPILE PROBLEMS
+Some users have reported link or runtime errors, most notably when 
+mapscript_wrap.c is compiled with gcc, but using ld to link the shared
+library.  If you experience this problem, try re-running the configure script,
+adding the '--with-linker-cc' option to the configure command line.
+
+For users without Swig installed, a pre-built mapscript_wrap.c is available.
+'make useprebuilt' will unpack the pre-built mapscript_wrap.c.
+
+If you get runtime errors reporting missing symbols, check the Mapscript/Tcl
+shared library for shared libraries it may be dependent upon.  In Linux, 
+Solaris (and possibly other unix systems) try this:
+	
+	ldd libMapscript*.*
+
+Note which libraries are unresolved.  Find the directories which contain the
+libraries that are unresolved, and add those directories to your 
+LD_LIBRARY_PATH environment variable, or whichever environment variable is
+appropriate for your system:
+
+	$ export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/other/required/dirs
+
+Add this to your .profile or .cshrc so you won't have to set this each
+time you login.  On some systems (Linux, et.al), a /etc/ld.so.conf file
+and 'ldconfig' program will set system-wide default library directory paths.
+
+
+WINDOWS
+See the ./win directory.   You should first install Tcl 8.3.2.  Then,
+run the 'setup.tcl' file to install Mapscript/Tcl.  You can double-click
+on the 'setup.tcl' file from Windows explorer, or 'start setup.tcl'
+from a DOS box.
+  
+To rebuild the DLL, see the file 'README.ms-mingw' and 'ms-mingw.tar.gz'.  
+The DLL provided was built with the Mingw compiler, as a cross compiler 
+hosted on Linux.  You should be able to rebuild the DLL on any Unix box, or 
+with a little work, using Mingw or Cygwin compiler & tools on Windows.  
+
+No Microsoft or Borland makefiles are provided.  Feel free to donate one(s). 
+
+You can use the popular 'WinZip' program to unpack tar.gz files on Windows
+(http://www.winzip.com), or use gunzip and tar from the Cygwin tools
+(http://sources.redhat.com/cygwin/).
+
+
+
+DOCS
+Swig generated documentation, plus and additional doc page for Tcl coded 
+helper functions are available as HTML.
+
+
+EXAMPLES
+See the ./examples directory.  
+
+	shpinfo.tcl    - print rudimentary info about a shape file.
+
+
+MAPSERVER WORKBENCH 
+MapServer Workbench is a set of tools written in Tcl/Tk with the Mapscript/Tcl
+extension, and is available separately.  The Workbench currently consists of:
+
+	msappwiz.tcl    -wizard to create mapserver application mapfiles
+	msedit.tcl	-tree-structured mapfile editor
+	msexplorer.tcl	-view, zoom, and query mapfiles 
+	msshapex.tcl	-view shapefile information and .dbf attributes
+
+MapServer Workbench tools run under Unix or Windows.
+
+For more information and to download MapServer Workbench:
+	http://msworkbench.sourceforge.net
+	http://sourceforge.net/projects/msworkbench/
+	http://www.nyx.net/~tpoindex/gis
+
+
+NOTES
+e.g., the "SWIG_STUB_HACK"
+Building Tcl extensions that are not dependent on a particular version of
+Tcl is the preferred method.  Prior to Tcl 8.1, an extension had to be
+linked against a version dependent Tcl libarary.  Extensions had to be
+recompiled and relinked when newer versions of Tcl were installed.
+
+Beginning with Tcl 8.1, the 'stub' library was introduced to facilitate 
+version independent extensions.  The stub library is a table of pointers
+to Tcl functions, that are initialized at run time, so extensions compiled
+for one version of Tcl don't have to be recompiled.  A call to Tcl_InitStubs()
+is required before using any Tcl function in an extension, and we link to
+libtclstub8.3.a, instead of the entire Tcl library. 
+
+Swig 1.1-883 doesn't initialize the stub table by calling Tcl_InitStubs(), so
+we must do it ourselves.  Normally, we use the Swig directive '%init' to
+include the call to Tcl_InitStubs.  However, we also prefer that the new
+Mapscript commands reside in their own namespace, by using the Swig option
+'-namespace'.  Unfortunately, Swig generates a call to Tcl_Eval() before
+the %init code is included in the wrapped .c file.
+
+We work around this problem for Mapscript by some crusty use of the
+C preprocessor.  Just before the Tcl_Eval call in the wrapped .c file, Swig
+also includes an bit of code that allows use the [incr Tcl] object system.  
+The makefile passes command line C preprocessor defines to
+subvert this bit of code for our use.  Thus, we are able to call the 
+Tcl_InitStub function before Tcl_Eval is called.  See the Makefile 
+macro "SWIG_STUB_HACK".
+
+
+WHO
+Tom Poindexter
+tpoindex@nyx.net
+http://www.nyx.net/~tpoindex/
+
+
diff -pruN 8.0.1-5/src/mapscript/tcl/configure 8.2.0~beta1-1~exp1/src/mapscript/tcl/configure
--- 8.0.1-5/src/mapscript/tcl/configure	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/configure	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,178 @@
+#!/bin/sh
+
+# not a normal autoconf configure script
+# grab the file ../../perlvars that mapserver made for the perl mapscript
+# build, and use gcc and ld flags
+
+if [ ! -f ../../perlvars ] ; then
+   echo "you must build MapServer first."
+   exit
+fi
+
+MAPSERVERHOME=`head -1 ../../mapscriptvars | tail -1`
+MAPSERVERDEFS=`head -2 ../../mapscriptvars | tail -1`
+MAPSERVERINCS=`head -3 ../../mapscriptvars | tail -1`
+MAPSERVERLIBS=`head -4 ../../mapscriptvars | tail -1`
+
+# make sure link to mapscript.i exists
+
+if [ ! -f mapscript.i ] ; then
+    ln -s ../mapscript.i mapscript.i
+fi
+
+# check for --with-tcl= and/or --with-swig=
+with_tcl=/usr/local
+with_swig=/usr/local
+with_linker_cc=no
+for arg in $*
+do
+    case $arg in
+	--help)
+		echo "mapscript tcl configure options:"
+		echo "--with-tcl=dir   where to find tcl  (lib/tclConfig.sh)"
+		echo "--with-swig=dir  where to find swig (include/swig.h)"
+		echo "--with-linker-cc use the compiler as linker front-end \
+				(see README)"
+		exit	
+		;;
+        --with-tcl=*)
+		save_if=$IFS
+		IFS==
+		set -- $arg
+		with_tcl=$2
+		IFS=$save_ifs
+		;;
+	--with-swig=*)
+		save_if=$IFS
+		IFS==
+		set -- $arg
+		with_swig=$2
+		IFS=$save_ifs
+		;;
+	--with-linker-cc)
+		with_linker_cc=yes
+		;;
+    esac
+done
+
+
+# look for Tcl configs
+
+echo "looking for Tcl in $with_tcl"
+if [ ! -f $with_tcl/lib/tclConfig.sh ] ; then
+    echo "can not find tclConfig.sh in $with_tcl"
+    exit
+fi
+echo "                  found lib/tclConfig.sh in $with_tcl"
+
+# look for swig
+
+echo "looking for Swig in $with_swig"
+if [ ! -f $with_swig/include/swig.h ] ; then
+    echo "can not find swig.h in $with_swig/include"
+    echo "using pre-built swig tcl interface"
+    # mapscript_wrap.c included in package
+else
+    echo "                  found include/swig.h in $with_swig"
+fi
+SWIGDIR=$with_swig
+
+
+# source the tcl Configs
+
+. $with_tcl/lib/tclConfig.sh
+echo "tcl version = $TCL_VERSION"
+
+
+# if --with-linker-cc option set, then change ld command to use TCL_CC
+
+if test "$with_linker_cc" = "yes" ; then
+    # get cc command, without any options that may be present
+    eval set -- $TCL_CC
+    cc="$1"
+    # get any linker command options
+    eval set -- $TCL_SHLIB_LD
+    shift
+    # build the new command using cc and linker options
+    TCL_SHLIB_LD="$cc $*"
+fi
+
+
+# ugh.  Tcl's tclConfig.sh only provides TCL_LD_SEARCH_FLAGS appropriate for
+#       use with 'cc'.  if 'ld' is the shared library loader, the flags
+#       might be wrong, try to fix.  this problem is often found on 
+#       Solaris, HP-UX, IRIX, {Free,Open,Net}BSD, OSF, Dec/Compaq Unix
+
+# first, get the shared lib loader command, should be ld or *cc
+
+eval set -- $TCL_SHLIB_LD
+ldcmd=`basename $1`
+if test "$ldcmd" = "ld" ; then
+
+    # this machine uses ld, now see if a flag begins with -Wl
+
+    newarg=""
+    eval set -- $TCL_LD_SEARCH_FLAGS
+    space=""
+    for arg in $*
+    do
+        case $TCL_LD_SEARCH_FLAGS in
+	    -Wl*)
+	        # yep, here's our problem child
+	        # strip off first arg, change "," to " " via sh set hack
+                IFSsave="$IFS"
+	        IFS=","
+	        eval set -- $arg
+	        IFS="$IFSsave"
+	        shift
+	        arg="$*"
+	        ;;
+	    *)
+		newarg="$newarg$space$arg"
+		;;
+        esac
+	space=" "
+    done
+    TCL_LD_SEARCH_FLAGS="$newarg"
+fi
+
+# also check for Solaris loader flags '-z text', which causes unresolved
+# link errors, because we're mixing -fPIC code (mapscript_wrap.o) with 
+# non -fPIC code (libmap.a, etc.)  the resulting libMapscript.so will be
+# mixed, so don't cause the link to fail.
+
+TCL_SHLIB_LD=`echo $TCL_SHLIB_LD | sed -e 's/-z text//'` 
+
+
+# fix up LIB_RUNTIME_DIR for those systems that leave it out
+
+if test -z "$LIB_RUNTIME_DIR" ; then
+    LIB_RUNTIME_DIR=$with_tcl/lib
+fi
+
+
+# create our Makefile
+
+echo "creating Makefile"
+
+sed -e "s%@MAPSERVERHOME@%$MAPSERVERHOME%g" \
+    -e "s%@MAPSERVERDEFS@%$MAPSERVERDEFS%g" \
+    -e "s%@MAPSERVERINCS@%$MAPSERVERINCS%g" \
+    -e "s%@MAPSERVERLIBS@%$MAPSERVERLIBS%g" \
+    -e "s%@TCL_PREFIX@%$TCL_PREFIX%g" \
+    -e "s%@TCL_EXEC_PREFIX@%$TCL_EXEC_PREFIX%g" \
+    -e "s%@TCL_CC@%$TCL_CC%g" \
+    -e "s%@TCL_DEFS@%$TCL_DEFS%g" \
+    -e "s%@TCL_SHLIB_SUFFIX@%$TCL_SHLIB_SUFFIX%g" \
+    -e "s%@TCL_SHLIB_CFLAGS@%$TCL_SHLIB_CFLAGS%g" \
+    -e "s%@TCL_LD_SEARCH_FLAGS@%$TCL_LD_SEARCH_FLAGS%g" \
+    -e "s%@TCL_SHLIB_LD@%$TCL_SHLIB_LD%g" \
+    -e "s%@TCL_LIB_SPEC@%$TCL_LIB_SPEC%g" \
+    -e "s%@TCL_STUB_LIB_SPEC@%$TCL_STUB_LIB_SPEC%g" \
+    -e "s%@TCL_LIBS@%$TCL_LIBS%g" \
+    -e "s%@LIB_RUNTIME_DIR@%$LIB_RUNTIME_DIR%g" \
+    -e "s%@TCL_DBGX@%$TCL_DBGX%g" \
+    -e "s%@SWIGDIR@%$SWIGDIR%g" \
+ <Makefile.in >Makefile
+
+
diff -pruN 8.0.1-5/src/mapscript/tcl/examples/shpinfo.tcl 8.2.0~beta1-1~exp1/src/mapscript/tcl/examples/shpinfo.tcl
--- 8.0.1-5/src/mapscript/tcl/examples/shpinfo.tcl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/examples/shpinfo.tcl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,33 @@
+#!/usr/local/bin/tclsh8.3
+
+# if running a test before install, include directory to find package
+
+lappend auto_path [pwd]/..
+
+package require Mapscript
+
+array set types {
+   1 point
+   3 arc
+   5 polygon
+   8 multipoint
+}
+
+
+set file $argv
+
+if {! [file isfile $file.shp]} {
+    puts "shapefile \"$file\" not found"
+    puts "usage: $argv0 <shapefile>"
+    exit
+}
+
+mapscript::shapefileObj shp1 $file -1
+
+puts "\nShapefile $file:\n"
+puts "\ttype: $types([shp1 cget -type])"
+puts "\tnumber of features: [shp1 cget -numshapes]"
+set rectPtr [shp1 cget -bounds]
+puts "\tbounds: ([mapscript::rectObjRef $rectPtr cget -minx],[mapscript::rectObjRef $rectPtr cget -miny]) ([mapscript::rectObjRef $rectPtr cget -maxx],[mapscript::rectObjRef $rectPtr cget -maxy])"
+
+
diff -pruN 8.0.1-5/src/mapscript/tcl/mapscript_wrap.html 8.2.0~beta1-1~exp1/src/mapscript/tcl/mapscript_wrap.html
--- 8.0.1-5/src/mapscript/tcl/mapscript_wrap.html	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/mapscript_wrap.html	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2144 @@
+<HTML>
+<HEAD>
+<TITLE>
+mapscript_wrap.c</TITLE>
+<BODY BGCOLOR="#ffffff">
+<H1>mapscript_wrap.c</H1>
+
+<HR><H1> Contents </H1>
+<UL><LI> <A HREF="#s1_">1. class featureListNodeObj</A>
+<LI> <A HREF="#s2_">2. class colorObj</A>
+<LI> <A HREF="#s3_">3. class queryObj</A>
+<LI> <A HREF="#s4_">4. class shapeResultObj</A>
+<LI> <A HREF="#s5_">5. class queryResultObj</A>
+<LI> <A HREF="#s6_">6. class queryMapObj</A>
+<LI> <A HREF="#s7_">7. class labelObj</A>
+<LI> <A HREF="#s8_">8. class webObj</A>
+<LI> <A HREF="#s9_">9. class classObj</A>
+<LI> <A HREF="#s10_">10. class labelCacheMemberObj</A>
+<LI> <A HREF="#s11_">11. class markerCacheMemberObj</A>
+<LI> <A HREF="#s12_">12. class labelCacheObj</A>
+<LI> <A HREF="#s13_">13. class symbolSetObj</A>
+<LI> <A HREF="#s14_">14. class referenceMapObj</A>
+<LI> <A HREF="#s15_">15. class scalebarObj</A>
+<LI> <A HREF="#s16_">16. class legendObj</A>
+<LI> <A HREF="#s17_">17. class layerObj</A>
+<LI> <A HREF="#s18_">18. class mapObj</A>
+<LI> <A HREF="#s19_">19. class errorObj</A>
+<LI> <A HREF="#s20_">20. class rectObj</A>
+<LI> <A HREF="#s21_">21. class pointObj</A>
+<LI> <A HREF="#s22_">22. class lineObj</A>
+<LI> <A HREF="#s23_">23. class shapeObj</A>
+<LI> <A HREF="#s24_">24. class DBFInfo</A>
+<LI> <A HREF="#s25_">25. class shapefileObj</A>
+</UL>
+
+<P><TT><B>mapscript::MS_VERSION = 3.4 (pre-release)</B></TT>
+<BLOCKQUOTE>[ Constant : char * ]
+<BR>   logical control variables   
+</BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_TRUE = 1</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_FALSE = 0</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_ON = 1</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_OFF = 0</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_DEFAULT = 2</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_QUERY = 3</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_EMBED = 4</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_YES = 1</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_NO = 0</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR>   modes for searching (spatial/database)   
+</BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SINGLE = 0</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_MULTIPLE = 1</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR>   General defines, not wrapable
+</BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_FILE_MAP = MS_FILE_MAP</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_FILE_SYMBOL = MS_FILE_SYMBOL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_INCHES = MS_INCHES</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_FEET = MS_FEET</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_MILES = MS_MILES</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_METERS = MS_METERS</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_NAUTICALMILES = MS_NAUTICALMILES</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_KILOMETERS = MS_KILOMETERS</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_DD = MS_DD</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_PIXELS = MS_PIXELS</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_POINT = MS_POINT</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_LINE = MS_LINE</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_POLYGON = MS_POLYGON</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_POLYLINE = MS_POLYLINE</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_RASTER = MS_RASTER</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_ANNOTATION = MS_ANNOTATION</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_NULL = MS_NULL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_TRUETYPE = MS_TRUETYPE</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_BITMAP = MS_BITMAP</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_UL = MS_UL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_LR = MS_LR</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_UR = MS_UR</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_LL = MS_LL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_CR = MS_CR</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_CL = MS_CL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_UC = MS_UC</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_LC = MS_LC</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_CC = MS_CC</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_AUTO = MS_AUTO</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_XY = MS_XY</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR>   arrangement matters for auto placement   
+</BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_TINY = MS_TINY</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SMALL = MS_SMALL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_MEDIUM = MS_MEDIUM</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_LARGE = MS_LARGE</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_GIANT = MS_GIANT</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_NORMAL = MS_NORMAL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_HILITE = MS_HILITE</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SELECTED = MS_SELECTED</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_INVERTED = MS_INVERTED</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_LOCAL = MS_LOCAL</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SDE = MS_SDE</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_OGR = MS_OGR</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_GIF = MS_GIF</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_PNG = MS_PNG</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_JPEG = MS_JPEG</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_WBMP = MS_WBMP</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_FILE_DEFAULT = (MS_FILE_MAP)</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s1_">
+<HR><H2>1. class featureListNodeObj</H2></A>
+[ created from struct featureListNodeObj ]<BR>
+<P><TT><B>-shape
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns shapeObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-next
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns struct listNode * ]
+<BR></BLOCKQUOTE>
+
+<A name="s2_">
+<HR><H2>2. class colorObj</H2></A>
+[ created from struct colorObj ]<BR>
+<P><TT><B>-red
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-green
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-blue
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s3_">
+<HR><H2>3. class queryObj</H2></A>
+[ created from struct queryObj ]<BR>
+<P><TT><B>-expression
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns expressionObj * ]
+<BR>   the expression to be matched  
+</BLOCKQUOTE>
+
+<P><TT><B>-template
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryObj name layer </B></TT>
+<BLOCKQUOTE>[ Constructor: returns queryObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>setExpression string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s4_">
+<HR><H2>4. class shapeResultObj</H2></A>
+[ created from struct shapeResultObj ]<BR>
+<P><TT><B>-layer
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-tile
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-shape
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-query
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s5_">
+<HR><H2>5. class queryResultObj</H2></A>
+[ created from struct queryResultObj ]<BR>
+<P><TT><B>-numlayers
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-numresults
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-numquerylayers
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-currentlayer
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-currenttile
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-currentshape
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   allows for cursors-like access to results
+</BLOCKQUOTE>
+
+<P><TT><B>queryResultObj name filename </B></TT>
+<BLOCKQUOTE>[ Constructor: returns queryResultObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>free </B></TT>
+<BLOCKQUOTE>[ Member : returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>save filename </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>next </B></TT>
+<BLOCKQUOTE>[ Member : returns shapeResultObj  ]
+<BR></BLOCKQUOTE>
+
+<A name="s6_">
+<HR><H2>6. class queryMapObj</H2></A>
+[ created from struct queryMapObj ]<BR>
+<P><TT><B>-height
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-width
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-status
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-style
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   HILITE, SELECTED or NORMAL   
+</BLOCKQUOTE>
+
+<P><TT><B>-color
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s7_">
+<HR><H2>7. class labelObj</H2></A>
+[ created from struct labelObj ]<BR>
+<P><TT><B>-font
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-type
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns enum MS_FONT_TYPE  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-color
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-outlinecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-shadowcolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-shadowsizex
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-shadowsizey
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-backgroundcolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-backgroundshadowcolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-backgroundshadowsizex
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-backgroundshadowsizey
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-size
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-sizescaled
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-minsize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-maxsize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-position
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-offsetx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-offsety
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-angle
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-autoangle
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   true or false 
+</BLOCKQUOTE>
+
+<P><TT><B>-buffer
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   space to reserve around a label   
+</BLOCKQUOTE>
+
+<P><TT><B>-antialias
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-wrap
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-minfeaturesize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   minimum feature size (in pixels) to label   
+</BLOCKQUOTE>
+
+<P><TT><B>-autominfeaturesize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   true or false 
+</BLOCKQUOTE>
+
+<P><TT><B>-mindistance
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-partials
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   can labels run of an image   
+</BLOCKQUOTE>
+
+<P><TT><B>-force
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   labels *must* be drawn
+</BLOCKQUOTE>
+
+<A name="s8_">
+<HR><H2>8. class webObj</H2></A>
+[ created from struct webObj ]<BR>
+<P><TT><B>-log
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-imagepath
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-imageurl
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-template
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-header
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-footer
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-empty
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-error
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   error handling   
+</BLOCKQUOTE>
+
+<P><TT><B>-extent
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns rectObj * ]
+<BR>   clipping extent   
+</BLOCKQUOTE>
+
+<P><TT><B>-minscale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-maxscale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-mintemplate
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-maxtemplate
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<A name="s9_">
+<HR><H2>9. class classObj</H2></A>
+[ created from struct classObj ]<BR>
+<P><TT><B>-color
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-backgroundcolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-outlinecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlaycolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlaybackgroundcolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlayoutlinecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-symbol
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-symbolname
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlaysymbol
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlaysymbolname
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-size
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-sizescaled
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-minsize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-maxsize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlaysize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlaysizescaled
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlayminsize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-overlaymaxsize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-label
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns labelObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-name
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   used for legend labeling   
+</BLOCKQUOTE>
+
+<P><TT><B>classObj name layer </B></TT>
+<BLOCKQUOTE>[ Constructor: returns classObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>setExpression string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>setText layer string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s10_">
+<HR><H2>10. class labelCacheMemberObj</H2></A>
+[ created from struct labelCacheMemberObj ]<BR>
+<P><TT><B>-size
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   parameters that can vary for each label/feature   
+</BLOCKQUOTE>
+
+<P><TT><B>-angle
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-string
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-featuresize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-layeridx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   indexes   
+</BLOCKQUOTE>
+
+<P><TT><B>-classidx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-tileidx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-shapeidx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-point
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns pointObj * ]
+<BR>   label point   
+</BLOCKQUOTE>
+
+<P><TT><B>-poly
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns shapeObj * ]
+<BR>   label bounding box   
+</BLOCKQUOTE>
+
+<P><TT><B>-status
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   has this label been drawn or not   
+</BLOCKQUOTE>
+
+<A name="s11_">
+<HR><H2>11. class markerCacheMemberObj</H2></A>
+[ created from struct markerCacheMemberObj ]<BR>
+<P><TT><B>-id
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   corresponding label
+</BLOCKQUOTE>
+
+<P><TT><B>-poly
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns shapeObj * ]
+<BR>   marker bounding box (POINT layers only)
+</BLOCKQUOTE>
+
+<A name="s12_">
+<HR><H2>12. class labelCacheObj</H2></A>
+[ created from struct labelCacheObj ]<BR>
+<P><TT><B>-labels
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns labelCacheMemberObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-numlabels
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-cachesize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-markers
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns markerCacheMemberObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-nummarkers
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-markercachesize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>freeCache </B></TT>
+<BLOCKQUOTE>[ Member : returns void  ]
+<BR></BLOCKQUOTE>
+
+<A name="s13_">
+<HR><H2>13. class symbolSetObj</H2></A>
+[ created from struct symbolSetObj ]<BR>
+<P><TT><B>-filename
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-fontset
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns fontSetObj * ]
+<BR>   a pointer to the main mapObj version
+</BLOCKQUOTE>
+
+<P><TT><B>-numsymbols
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-symbol
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns symbolObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-imagecache
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns struct imageCacheObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-imagecachesize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s14_">
+<HR><H2>14. class referenceMapObj</H2></A>
+[ created from struct referenceMapObj ]<BR>
+<P><TT><B>-extent
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns rectObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-height
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-width
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-color
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns colorObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-outlinecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns colorObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-image
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-status
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s15_">
+<HR><H2>15. class scalebarObj</H2></A>
+[ created from struct scalebarObj ]<BR>
+<P><TT><B>-imagecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns colorObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-height
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-width
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-style
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-intervals
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-label
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns labelObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-color
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-backgroundcolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-outlinecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-units
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-status
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   ON, OFF or EMBED
+</BLOCKQUOTE>
+
+<P><TT><B>-position
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   for embeded scalebars
+</BLOCKQUOTE>
+
+<P><TT><B>-transparent
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-interlace
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-postlabelcache
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s16_">
+<HR><H2>16. class legendObj</H2></A>
+[ created from struct legendObj ]<BR>
+<P><TT><B>-imagecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns colorObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-label
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns labelObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-keysizex
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-keysizey
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-keyspacingx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-keyspacingy
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-outlinecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   Color of outline of box, -1 for no outline   
+</BLOCKQUOTE>
+
+<P><TT><B>-status
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   ON, OFF or EMBED
+</BLOCKQUOTE>
+
+<P><TT><B>-height
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-width
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-position
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   for embeded legends
+</BLOCKQUOTE>
+
+<P><TT><B>-transparent
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-interlace
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-postlabelcache
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s17_">
+<HR><H2>17. class layerObj</H2></A>
+[ created from struct layerObj ]<BR>
+<P><TT><B>-index
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-classitem
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   .DBF item to be used for symbol lookup   
+</BLOCKQUOTE>
+
+<P><TT><B>-class
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns classObj * ]
+<BR>   always at least 1 class   
+</BLOCKQUOTE>
+
+<P><TT><B>-numclasses
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-name
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   layer name, must be unique   
+</BLOCKQUOTE>
+
+<P><TT><B>-group
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-description
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   layer title or description   
+</BLOCKQUOTE>
+
+<P><TT><B>-legend
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   legend graphic   
+</BLOCKQUOTE>
+
+<P><TT><B>-status
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   layer status, either ON or OFF   
+</BLOCKQUOTE>
+
+<P><TT><B>-data
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   layer data filename, including path   
+</BLOCKQUOTE>
+
+<P><TT><B>-type
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns enum MS_FEATURE_TYPE  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-tolerance
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   search buffer for point and line queries (in toleranceunits)   
+</BLOCKQUOTE>
+
+<P><TT><B>-toleranceunits
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-symbolscale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   scale at which symbols are default size   
+</BLOCKQUOTE>
+
+<P><TT><B>-maxscale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   layer is active only BELOW this scale value (<=)   
+</BLOCKQUOTE>
+
+<P><TT><B>-minscale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   layer is active only ABOVE this scale value (>)   
+</BLOCKQUOTE>
+
+<P><TT><B>-labelminscale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   annotation is active only BELOW this scale value (<=)   
+</BLOCKQUOTE>
+
+<P><TT><B>-labelmaxscale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   annotation is active only ABOVE this scale value (>)   
+</BLOCKQUOTE>
+
+<P><TT><B>-maxfeatures
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-offsite
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   offsite value for raster images   
+</BLOCKQUOTE>
+
+<P><TT><B>-transform
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   does this layer have to be transformed to file coordinates   
+</BLOCKQUOTE>
+
+<P><TT><B>-labelcache
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   on or off   
+</BLOCKQUOTE>
+
+<P><TT><B>-postlabelcache
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-labelitem
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   .DBF item to be used for text   
+</BLOCKQUOTE>
+
+<P><TT><B>-labelsizeitem
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-labelangleitem
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-tileitem
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-tileindex
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   layer index file for tiling support   
+</BLOCKQUOTE>
+
+<P><TT><B>-projection
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns projectionObj * ]
+<BR>   projection information for the layer   
+</BLOCKQUOTE>
+
+<P><TT><B>-features
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns featureListNodeObjPtr  ]
+<BR>   linked list so we don't need a counter   
+</BLOCKQUOTE>
+
+<P><TT><B>-connection
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-connectiontype
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns enum MS_CONNECTION_TYPE  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>layerObj name map </B></TT>
+<BLOCKQUOTE>[ Constructor: returns layerObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getClass i </B></TT>
+<BLOCKQUOTE>[ Member : returns classObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>draw map img </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingPoint map point mode buffer </B></TT>
+<BLOCKQUOTE>[ Member : returns queryResultObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingRect map rect </B></TT>
+<BLOCKQUOTE>[ Member : returns queryResultObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingFeatures map results </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingShape map shape </B></TT>
+<BLOCKQUOTE>[ Member : returns queryResultObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>setProjection string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>addFeature shape </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>classify string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s18_">
+<HR><H2>18. class mapObj</H2></A>
+[ created from struct mapObj ]<BR>
+   structure for a map   
+
+<P><TT><B>-name
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   small identifier for naming etc.   
+</BLOCKQUOTE>
+
+<P><TT><B>-status
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   is map creation on or off   
+</BLOCKQUOTE>
+
+<P><TT><B>-height
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-width
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-layers
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns layerObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-numlayers
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   number of layers in mapfile   
+</BLOCKQUOTE>
+
+<P><TT><B>-labelcache
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns labelCacheObj * ]
+<BR>   we need this here so multiple feature processors can access it   
+</BLOCKQUOTE>
+
+<P><TT><B>-transparent
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-interlace
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-extent
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns rectObj * ]
+<BR>   map extent array   
+</BLOCKQUOTE>
+
+<P><TT><B>-cellsize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   in map units   
+</BLOCKQUOTE>
+
+<P><TT><B>-units
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns enum MS_UNITS  ]
+<BR>   units of the projection   
+</BLOCKQUOTE>
+
+<P><TT><B>-scale
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR>   scale of the output image   
+</BLOCKQUOTE>
+
+<P><TT><B>-shapepath
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   where are the shape files located   
+</BLOCKQUOTE>
+
+<P><TT><B>-tile
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   an optional tile name to use as well   
+</BLOCKQUOTE>
+
+<P><TT><B>-palette
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns paletteObj * ]
+<BR>   holds a map palette   
+</BLOCKQUOTE>
+
+<P><TT><B>-imagecolor
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns colorObj * ]
+<BR>   holds the initial image color value   
+</BLOCKQUOTE>
+
+<P><TT><B>-imagetype
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-imagequality
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-projection
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns projectionObj * ]
+<BR>   projection information for output map   
+</BLOCKQUOTE>
+
+<P><TT><B>-reference
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns referenceMapObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-scalebar
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns scalebarObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-legend
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns legendObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-web
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns webObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapObj name filename </B></TT>
+<BLOCKQUOTE>[ Constructor: returns mapObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getLayer i </B></TT>
+<BLOCKQUOTE>[ Member : returns layerObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getLayerByName name </B></TT>
+<BLOCKQUOTE>[ Member : returns layerObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>addColor r g b </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getSymbolByName type name </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>prepareQuery </B></TT>
+<BLOCKQUOTE>[ Member : returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>prepareImage </B></TT>
+<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>draw </B></TT>
+<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>drawQueryMap results </B></TT>
+<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>drawLegend </B></TT>
+<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>drawScalebar </B></TT>
+<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>drawReferenceMap </B></TT>
+<BLOCKQUOTE>[ Member : returns gdImagePtr  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>embedScalebar img </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>embedLegend img </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>drawLabelCache img </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>nextLabel </B></TT>
+<BLOCKQUOTE>[ Member : returns labelCacheMemberObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingPoint point mode buffer </B></TT>
+<BLOCKQUOTE>[ Member : returns queryResultObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingRect rect </B></TT>
+<BLOCKQUOTE>[ Member : returns queryResultObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingFeatures results </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>queryUsingShape map shape </B></TT>
+<BLOCKQUOTE>[ Member : returns queryResultObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>setProjection string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>save filename </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::msSaveImage img filename transparent interlace </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::msFreeImage img </B></TT>
+<BLOCKQUOTE>[ returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_NOERR = 0</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_IOERR = 1</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_MEMERR = 2</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_TYPEERR = 3</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SYMERR = 4</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_REGEXERR = 5</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_TTFERR = 6</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_DBFERR = 7</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_GDERR = 8</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_IDENTERR = 9</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_EOFERR = 10</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_PROJERR = 11</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_MISCERR = 12</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_CGIERR = 13</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_WEBERR = 14</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_IMGERR = 15</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_HASHERR = 16</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_JOINERR = 17</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR>   empty search results   
+</BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_NOTFOUND = 18</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SHPERR = 19</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_PARSEERR = 20</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SDEERR = 21</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_OGRERR = 22</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_NUMERRORCODES = 23</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MESSAGELENGTH = 2048</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::ROUTINELENGTH = 64</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s19_">
+<HR><H2>19. class errorObj</H2></A>
+[ created from struct errorObj ]<BR>
+<P><TT><B>-code
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-routine
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-message
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::ms_error_set { errorObj * } 
+mapscript::ms_error_get </B></TT>
+<BLOCKQUOTE>[ Global : errorObj  ms_error ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::msSetError code message routine </B></TT>
+<BLOCKQUOTE>[ returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::msWriteError stream </B></TT>
+<BLOCKQUOTE>[ returns void  ]
+<BR></BLOCKQUOTE>
+
+<A name="s20_">
+<HR><H2>20. class rectObj</H2></A>
+[ created from struct rectObj ]<BR>
+<P><TT><B>-minx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-miny
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-maxx
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-maxy
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rectObj name </B></TT>
+<BLOCKQUOTE>[ Constructor: returns rectObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>fit width height </B></TT>
+<BLOCKQUOTE>[ Member : returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>draw map layer img class_string label_string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s21_">
+<HR><H2>21. class pointObj</H2></A>
+[ created from struct pointObj ]<BR>
+<P><TT><B>-x
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-y
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>pointObj name </B></TT>
+<BLOCKQUOTE>[ Constructor: returns pointObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>draw map layer img class_string label_string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>distanceToPoint point </B></TT>
+<BLOCKQUOTE>[ Member : returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>distanceToLine a b </B></TT>
+<BLOCKQUOTE>[ Member : returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>distanceToShape shape </B></TT>
+<BLOCKQUOTE>[ Member : returns double  ]
+<BR></BLOCKQUOTE>
+
+<A name="s22_">
+<HR><H2>22. class lineObj</H2></A>
+[ created from struct lineObj ]<BR>
+<P><TT><B>-numpoints
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-point
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns pointObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>lineObj name </B></TT>
+<BLOCKQUOTE>[ Constructor: returns lineObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>get i </B></TT>
+<BLOCKQUOTE>[ Member : returns pointObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>add p </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s23_">
+<HR><H2>23. class shapeObj</H2></A>
+[ created from struct shapeObj ]<BR>
+<P><TT><B>-numlines
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-line
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns lineObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-bounds
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns rectObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-type
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-classindex
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-queryindex
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-text
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>shapeObj name type </B></TT>
+<BLOCKQUOTE>[ Constructor: returns shapeObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>get i </B></TT>
+<BLOCKQUOTE>[ Member : returns lineObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>add line </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>draw map layer img class_string label_string </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>setBounds </B></TT>
+<BLOCKQUOTE>[ Member : returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>copy dest </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>contains point </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>intersects shape </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SHAPEFILE_POINT = 1</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SHAPEFILE_ARC = 3</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SHAPEFILE_POLYGON = 5</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::MS_SHAPEFILE_MULTIPOINT = 8</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s24_">
+<HR><H2>24. class DBFInfo</H2></A>
+[ created from struct DBFInfo ]<BR>
+<P><TT><B>-fp
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns FILE * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-nRecords
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-nRecordLength
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-nHeaderLength
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-nFields
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-panFieldOffset
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-panFieldSize
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-panFieldDecimals
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-pachFieldType
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-pszHeader
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-nCurrentRecord
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-bCurrentRecordModified
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-pszCurrentRecord
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-bNoHeader
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>-bUpdated
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getFieldName iField </B></TT>
+<BLOCKQUOTE>[ Member : returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getFieldWidth iField </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getFieldDecimals iField </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getFieldType iField </B></TT>
+<BLOCKQUOTE>[ Member : returns DBFFieldType  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::FTString = FTString</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::FTInteger = FTInteger</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::FTDouble = FTDouble</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::FTInvalid = FTInvalid</B></TT>
+<BLOCKQUOTE>[ Constant : int  ]
+<BR></BLOCKQUOTE>
+
+<A name="s25_">
+<HR><H2>25. class shapefileObj</H2></A>
+[ created from struct shapefileObj ]<BR>
+<P><TT><B>-source
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns char * ]
+<BR>   full path to the shapefile data   
+</BLOCKQUOTE>
+
+<P><TT><B>-hSHP
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns SHPHandle * ]
+<BR>   .SHP/.SHX file pointer   
+</BLOCKQUOTE>
+
+<P><TT><B>-type
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   shape type   
+</BLOCKQUOTE>
+
+<P><TT><B>-numshapes
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns int  ]
+<BR>   number of shapes   
+</BLOCKQUOTE>
+
+<P><TT><B>-bounds
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns rectObj * ]
+<BR>   shape extent   
+</BLOCKQUOTE>
+
+<P><TT><B>-hDBF
+</B></TT>
+<BLOCKQUOTE>[ Member data: returns DBFHandle  ]
+<BR>   .DBF file pointer   
+</BLOCKQUOTE>
+
+<P><TT><B>shapefileObj name filename type </B></TT>
+<BLOCKQUOTE>[ Constructor: returns shapefileObj * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>rename obj {}</B></TT>
+<BLOCKQUOTE>[ Destructor: returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>get i shape </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getTransformed map i shape </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>getExtent i rect </B></TT>
+<BLOCKQUOTE>[ Member : returns void  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>add shape </B></TT>
+<BLOCKQUOTE>[ Member : returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFOpen pszDBFFile pszAccess </B></TT>
+<BLOCKQUOTE>[ returns DBFHandle  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFCreate pszDBFFile </B></TT>
+<BLOCKQUOTE>[ returns DBFHandle  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFGetFieldCount psDBF </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFGetRecordCount psDBF </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFAddField hDBF pszFieldName eType nWidth nDecimals </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFGetFieldInfo psDBF iField pszFieldName pnWidth pnDecimals </B></TT>
+<BLOCKQUOTE>[ returns DBFFieldType  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFReadIntegerAttribute hDBF iShape iField </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFReadDoubleAttribute hDBF iShape iField </B></TT>
+<BLOCKQUOTE>[ returns double  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFReadStringAttribute hDBF iShape iField </B></TT>
+<BLOCKQUOTE>[ returns char * ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFWriteIntegerAttribute hDBF iShape iField nFieldValue </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFWriteDoubleAttribute hDBF iShape iField dFieldValue </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFWriteStringAttribute hDBF iShape iField pszFieldValue </B></TT>
+<BLOCKQUOTE>[ returns int  ]
+<BR></BLOCKQUOTE>
+
+<P><TT><B>mapscript::DBFClose hDBF </B></TT>
+<BLOCKQUOTE>[ returns void  ]
+<BR></BLOCKQUOTE>
+
+
+</BODY>
+</HTML>
diff -pruN 8.0.1-5/src/mapscript/tcl/mapscriptsupp.html 8.2.0~beta1-1~exp1/src/mapscript/tcl/mapscriptsupp.html
--- 8.0.1-5/src/mapscript/tcl/mapscriptsupp.html	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/mapscriptsupp.html	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,129 @@
+<HTML>
+<HEAD>
+<TITLE>
+mapscript_supp.c</TITLE>
+<BODY BGCOLOR="#ffffff">
+<H1>mapscriptsupp.tcl</H1>
+
+<HR><H1> Mapscript Supplemental Procedures </H1>
+<UL>
+<LI> 1. proc mapscript::classObjRef
+<LI> 2. proc mapscript::colorObjRef
+<LI> 3. proc mapscript::errorObjRef
+<LI> 4. proc mapscript::featureListNodeObjRef
+<LI> 5. proc mapscript::itemObjRef
+<LI> 6. proc mapscript::labelCacheMemberObjRef
+<LI> 7. proc mapscript::labelCacheObjRef
+<LI> 8. proc mapscript::labelObjRef
+<LI> 9. proc mapscript::layerObjRef
+<LI> 10. proc mapscript::legendObjRef
+<LI> 11. proc mapscript::lineObjRef
+<LI> 12. proc mapscript::mapObjRef
+<LI> 13. proc mapscript::markerCacheMemberObjRef
+<LI> 14. proc mapscript::pointObjRef
+<LI> 15. proc mapscript::projectionObjRef
+<LI> 16. proc mapscript::queryMapObjRef
+<LI> 17. proc mapscript::rectObjRef
+<LI> 18. proc mapscript::referenceMapObjRef
+<LI> 19. proc mapscript::resultCacheMemberObjRef
+<LI> 20. proc mapscript::resultCacheObjRef
+<LI> 21. proc mapscript::scalebarObjRef
+<LI> 22. proc mapscript::shapeObjRef
+<LI> 23. proc mapscript::shapefileObjRef
+<LI> 24. proc mapscript::symbolSetObjRef
+<LI> 25. proc mapscript::webObjRef
+<LI> 26. proc mapscript::DBFInfoRef
+</UL>
+
+<H2> Usage </H2>
+<P> 
+These procedures allow methods to be invoked on object references 
+(i.e., pointers), without having to convert a reference into an object.
+A valid object reference is required; procedures check for valid object types.
+<P>
+General syntax:
+<BLOCKQUOTE>
+objectRefProc  $objectPtr  args
+</BLOCKQUOTE>
+<P>
+Sample:
+<BLOCKQUOTE>
+set map [mapscript::mapObj -args $mapFile]
+<BR>
+set rectPtr [$map cget -extent]
+<BR>
+set minx [<B>mapscript::rectObjRef</B> $rectPtr cget -minx]
+<BR>
+set miny [<B>mapscript::rectObjRef</B> $rectPtr cget -miny]
+<BR>
+</BLOCKQUOTE>
+<P>
+Notes:  each of the <EM>objectRef</EM> procedures is just a shortcut to invoke a
+SWIG generated method name.   Method names of:
+<UL>
+<LI> cget
+<LI> configure
+<LI> delete
+</UL>
+invoke that object's cget, configure, and delete method respectively.
+<P> Example:
+<BLOCKQUOTE>
+mapscript::rectObjRef $rectPtr cget -minx
+</BLOCKQUOTE>
+is equivalent to:
+<BLOCKQUOTE>
+mapscript::rectObj_minx_get $rectPtr
+</BLOCKQUOTE>
+
+<HR><H1> Mapscript Convenience Procedures </H1>
+<UL>
+<LI> 1. proc mapscript::getDBFNames
+<LI> 2. proc mapscript::getDBFTypes
+<LI> 3. proc mapscript::getDBFValues
+<LI> 4. proc mapscript::getQueryInfo
+</UL>
+
+<H2> Usage </H2>
+<P><b>mapscript::getDBFNames <em> DBFInfo_handle </em></b><br>
+getDBFNames returns a list of field names from a DBF file handle.  The
+<em> DBFInfo_handle </em> must be a valid DBFInfo handle returned from
+the DBFInfo constructor.
+
+<P><b>mapscript::getDBFTypes <em> DBFInfo_handle </em></b><br>
+getDBFTypes returns a list of field types and lengths from a DBF file handle.  
+The <em> DBFInfo_handle </em> must be a valid DBFInfo handle returned from
+the DBFInfo constructor.  Each list element is itself a list of field type
+and field length.  Valid field types are returned as: <b>string</b>,
+<b>integer</b>, and <b>double</b>. 
+
+<P><b>mapscript::getDBFValues <em> DBFInfo_handle record_number </em></b><br>
+getDBFValues returns a list of field values from a DBF file handle.  The
+<em> DBFInfo_handle </em> must be a valid DBFInfo handle returned from
+the DBFInfo constructor.  <em>Record_number</em> is the record number of the
+row to fetch.
+
+<P><b>mapscript::getQueryInfo <em> mapObj_pointer  layerObj_pointer 
+</em></b><br>
+getQueryInfo returns a list of name-value
+pairs from a layer that map query has generated.  
+<em> mapObj_pointer</em> and <em>queryObj_pointer</em> must be valid 
+mapObj and layerObj pointers.
+
+
+<BR>
+<HR>
+<H1>See also</H1>
+<P>
+See <A HREF="mapscript_wrap.html">mapscript_wrap.html</A> for the full
+Mapscript Tcl interface.
+<P>
+Note also that the Mapscript objects described in mapscript_wrap.html are
+defined in the <b> mapscript </b> namespace.
+<P>
+Tom Poindexter
+<BR>
+tpoindex@nyx.net
+<BR>
+
+</BODY>
+</HTML>
diff -pruN 8.0.1-5/src/mapscript/tcl/mapscriptsupp.tcl 8.2.0~beta1-1~exp1/src/mapscript/tcl/mapscriptsupp.tcl
--- 8.0.1-5/src/mapscript/tcl/mapscriptsupp.tcl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/mapscriptsupp.tcl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,177 @@
+#  mapscriptsupp.tcl
+# 
+#  define procs to invoke object methods using an object pointer
+#  tom poindexter, nov 2000, tpoindex@nyx.net
+#  
+#  e.g.  shapeObj method arg arg ...
+#        can be invoked on a shapeObj pointer as:
+#        shapeObjRef $shapeObjPointer method arg arg ...        
+#
+#  convenience procedures:
+#   getDBFNames  $DBFHandle		       :returns list of field names
+#   getDBFTypes  $DBFHandle 		       :returns list of field types 
+#   getDBFValues $DBFHandle $rec	       :returns list of field values
+#   getQueryInfo $mapPtr $layerPtr             :return "field value" from query
+
+
+# fix SWIG error
+# some swig versions don't handle namespaces when generating shadow objects
+# mapscript just has one - ms_error
+#
+
+if {![string length [info commands ::mapscript::ms_error]]} {
+ catch {
+  ::mapscript::errorObj ::mapscript::ms_error -this [::mapscript::ms_error_get]
+ }
+}
+
+#
+# now define object helper procs
+#
+
+namespace eval ::mapscript {
+
+proc _mapscript_init_ {} {
+
+    set code {
+        proc OBJECTRef {ptr method args} {
+	    # check ptr for correct object type
+	    #if {! [regexp {_[^_]*_OBJECT_p} $ptr]} {
+	    #	error "OBJECTRef pointer \"$ptr\" has wrong object class"
+	    #}
+	    # check for configure/cget/delete commands 
+	    set member ""
+	    set delete ""
+	    switch -- $method {
+		configure {
+		    set command _set
+		    set member _[string range [lindex $args 0] 1 end]
+		    set args [lrange $args 1 end]
+		}
+		cget {
+		    set command _get
+		    set member _[string range [lindex $args 0] 1 end]
+		    set args ""
+		}
+		delete {
+		    set delete delete_
+		    set command ""
+		    set args ""
+		}
+		default {
+	    	    set command _$method
+		}
+	    }
+	    # check of existence of command
+	    if {! [string length \
+	      [info command ::mapscript::${delete}OBJECT${member}${command}]]} {
+		error "OBJECT does not have method named \"$method\", or \
+		       a member named \"$member\""
+	    }
+	    # invoke command 
+	    return [uplevel "::mapscript::${delete}OBJECT${member}${command} \
+								$ptr $args"]
+        }
+    }
+
+    foreach obj {classObj colorObj errorObj featureListNodeObj itemObj  \
+		 labelCacheMemberObj labelCacheObj labelObj layerObj  \
+		 legendObj lineObj mapObj markerCacheMemberObj pointObj \
+		 projectionObj queryMapObj rectObj referenceMapObj  \
+		 resultCacheMemberObj resultCacheObj scalebarObj shapeObj \
+		 shapefileObj symbolSetObj webObj \
+		 DBFInfo} {
+    
+        regsub -all OBJECT $code $obj proc_code
+        eval $proc_code
+    }
+}
+
+
+# run the help proc initialization, then get rid of it
+
+_mapscript_init_
+rename _mapscript_init_ {}
+
+
+#
+# now create convenience procs
+#
+
+proc getDBFNames {dbf} {
+    set n [msDBFGetFieldCount $dbf]
+    set names ""
+    for {set i 0} {$i < $n} {incr i} {
+	lappend names [DBFInfoRef $dbf getFieldName $i]
+    }
+    return $names
+}
+
+proc getDBFTypes {dbf} {
+    set n [msDBFGetFieldCount $dbf]
+    set types ""
+    for {set i 0} {$i < $n} {incr i} {
+	set t [DBFInfoRef $dbf getFieldType $i]
+	switch $t \
+	    $::mapscript::FTString  {set t string}  \
+	    $::mapscript::FTInteger {set t integer} \
+	    $::mapscript::FTDouble  {set t double}  \
+	    default      {set t invalid}
+
+	lappend t [DBFInfoRef $dbf getFieldWidth $i]
+        lappend types $t
+    }
+    return $types
+}
+
+proc getDBFValues {dbf rec} {
+    set n [msDBFGetFieldCount $dbf]
+    set r [msDBFGetRecordCount $dbf]
+    if {$rec >= $r || $rec < -1} {return ""}
+    set values ""
+    for {set i 0} {$i < $n} {incr i} {
+	switch [DBFInfoRef $dbf getFieldType $i] \
+	    $::mapscript::FTString  {
+		set t [msDBFReadStringAttribute  $dbf $rec $i]
+	    } \
+	    $::mapscript::FTInteger {
+		set t [msDBFReadIntegerAttribute $dbf $rec $i]
+	    } \
+	    $::mapscript::FTDouble  {
+		set t [msDBFReadDoubleAttribute  $dbf $rec $i]
+	    } \
+	    default      {set t ""}
+	lappend values $t
+    }
+    return $values
+}
+
+proc getQueryInfo {mapPtr layerPtr} {
+    
+    layerObjRef $layerPtr open [mapObjRef $mapPtr cget -shapepath]
+    set rescachePtr [layerObjRef $layerPtr cget -resultcache]
+    set numResults  [resultCacheObjRef $rescachePtr cget -numresults]
+
+    for {set i 0} {$i < $numResults} {incr i} {
+	set resmemPtr [layerObjRef $layerPtr getResult $i]
+        set shpIdx    [resultCacheMemberObjRef $resmemPtr cget -shapeindex]
+        set tileIdx   [resultCacheMemberObjRef $resmemPtr cget -tileindex]
+	set shpPtr    [shapeObj -args $mapscript::MS_SHAPE_NULL]
+	set rc        [layerObjRef $layerPtr getShape $shpPtr $tileIdx $shpIdx]
+	set numValues [shapeObjRef $shpPtr cget -numvalues]
+
+	set pairs ""
+	for {set j 0} {$j < $numValues} {incr j} {
+	    lappend pairs [layerObjRef $layerPtr getItem $j] \
+			  [shapeObjRef $shpPtr getValue $j]
+	}
+        # delete the temporary shpPtr
+	catch {rename $shpPtr {}}
+    }
+    layerObjRef $layerPtr close
+    return $pairs
+}
+
+
+
+} ;#end of namespace command
diff -pruN 8.0.1-5/src/mapscript/tcl/pkgIndex.tcl 8.2.0~beta1-1~exp1/src/mapscript/tcl/pkgIndex.tcl
--- 8.0.1-5/src/mapscript/tcl/pkgIndex.tcl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/pkgIndex.tcl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,12 @@
+# pkgIndex.tcl for mapscript
+#
+# load shared library, and source supplementaly ref procs
+
+package ifneeded Mapscript 1.1 " 
+    load [list [file join $dir libMapscript11[info sharedlibextension]]]
+    # source the object reference helpers and convenience procs
+    source [list [file join $dir mapscriptsupp.tcl]]
+    package provide Mapscript 1.1
+"
+
+
diff -pruN 8.0.1-5/src/mapscript/tcl/win/README.ms-mingw 8.2.0~beta1-1~exp1/src/mapscript/tcl/win/README.ms-mingw
--- 8.0.1-5/src/mapscript/tcl/win/README.ms-mingw	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/win/README.ms-mingw	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,130 @@
+Mapserver and Mapscript/Tcl for Windows
+
+These are the steps I have made to compile Mapserver and Mapscript/Tcl for
+Windows.  My build environment is the Mingw (Minimalist GNU for Windows)
+compiler and toolchain, hosted on Linux/Unix.  
+
+You probably want to use the pre-compiled DLL, if at all possible.
+Things get ugly after this......
+
+
+
+First, make a new directory to hold everthing we will need.
+
+	mkdir ms_win
+	cd ms_win
+
+Unpack the ms-mingw.tar.gz in that directory:
+
+	gunzip -c ../ms-mingw.tar.gz | tar xf -
+
+
+Next, you'll need the Mingw compiler and toolchain, compiled as a 
+cross compiler, hosted on your Linux or Unix platform.
+
+Mo DeJong has written a shell script to download, compile, and install *all*
+of the compiler, toolchain, and Mingw libraries.  The script is in
+ms-mingw/mingw-xcc.sh  I have set the script to install the tools into
+/opt/mingw.  If you want to change this, you'll need to also change the 'build'
+shell script.  The mingw-xcc.sh script uses the 'wget' program to fetch
+files via ftp (ftp://ftp.gnu.org/gnu/wget/).
+
+	cd ms-mingw
+	sh mingw-xcc.sh
+	cd ..
+
+
+Next, get *fresh* sources of all of the required MapServer packages, and 
+unpack in the ms_win directory.  Your 'ms_win' directory should look 
+like this after unpacking all of the sources:
+
+	README.ms-mingw  install     ms-mingw/    tcl8.3.2/
+	build            jpeg-6b/    proj-4.4.2/  tiff-v3.5.5/
+	freetype-1.3.1/  mapserver/  regex-0.12/  zlib-1.1.3/
+
+
+The 'ms-mingw' directory contains directories for each of the components we
+will be building.  Each directory consists of a Makefile for Mingw as a 
+cross compiler, and a 'build' script to copy the Makefile into the source
+directories (as above), and make the libraries.
+
+Software locations:
+
+mingw:	http://www.mingw.org
+	The mingw-xcc.sh script will grab things for you.
+	There's a lot of info on the Mingw compiler and its use as a 
+	cross compiler at the site.
+
+proj:	http://www.remotesensing.org/proj/
+	Get version 4.4.2
+
+zlib:   http://www.info-zip.org/pub/infozip/zlib/
+	Get version 1.1.3
+
+jpeg:   ftp://ftp.uu.net/graphics/jpeg/
+	Get version 6b.
+
+tiff:   http://www.libtiff.org/
+	Get version 3.5.5
+
+freetype: http://www.freetype.org
+	Get version 1.3.1
+	NOTE!!!  I have found the the freetype-1.3.1.tar.gz file contains
+	source files with dos style end of line characters (cr-lf).  This 
+	will likely confuse gcc.  The easy way to convert into normal
+	unix-style text files is to get the freetype-1.3.1.zip, and
+	use 'unzip -a freetype-1.3.1' to unpack it, converting the
+	files to use lf only.  Rename the 'freetype' directory to 
+	'freetype-1.3.1'.
+
+regex: ftp://ftp.gnu.org/pub/gnu/regex/regex-0.12.tar.gz
+	  
+mapserver: http://mapserver.gis.umn.edu/dload.html
+	Get the 'nightly' CVS builds for 3.4 (beta), nightly.tar.gz. 
+	We will also use the GD 1.2 and GDFT libraries that come with 
+	Mapserver.  As a side effect, we will also build an executable,
+	mapserv.exe.
+
+tcl:	http://dev.scriptics.com
+	Get version 8.3.2
+	We will only be building 'libtclstub83.a', not the entire 
+	Tcl library.  Also get 'tcl832.exe' and install it on your Windows
+	machine(s) if you don't already have it.  For best results,
+	let the installer place Tcl in 'C:\Program Files\Tcl'.
+
+
+
+
+Build everything:
+Use the build script in this directory.  (change the values of 'mingwbin' and
+'mingwxcc' if needed.)
+
+	sh build
+
+Install:
+You probably have to be root to write into /c.
+
+	sh install
+
+Or, you can ftp the files over to your windows box and use the 'setup.tcl' 
+installer.
+
+
+Notes:  
+
+Building for Windows is a royal pain in the ***!  The biggest problem is
+building the various libraries the 'right' way, i.e, as DLL files.  This
+requires a majic Windows macro to export the symbols for the DLL, but another
+majic macro for code that uses the symbols in a DLL.  For software originally
+not designed to be portable across Unix and Windows, this requires changing
+alot of source files.  
+
+    Examples of software that is written for portability: zlib, tcl
+    Examples of software that is not: proj, mapserver
+
+The alternative:  compile the source library code, and bundling it into
+a standard library file, e.g., libz.a, libjpeg.a, libttf.a, etc.
+We then take all of the libraries and create our final DLL, libMapscript.dll.
+The downside is that we're not allowing any reuse of the libaries, but the
+upside is we don't have to change much exisiting code.  I do this method.
+
Binary files 8.0.1-5/src/mapscript/tcl/win/ms-mingw.tar and 8.2.0~beta1-1~exp1/src/mapscript/tcl/win/ms-mingw.tar differ
diff -pruN 8.0.1-5/src/mapscript/tcl/win/setup.tcl 8.2.0~beta1-1~exp1/src/mapscript/tcl/win/setup.tcl
--- 8.0.1-5/src/mapscript/tcl/win/setup.tcl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/tcl/win/setup.tcl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,20 @@
+# install mapscript/tcl
+
+set tclhome [file dirname $tcl_library]
+set mslib $tclhome/MapscriptTcl1.0
+
+if {! [file isdirectory $mslib]} {
+    file mkdir $mslib
+}
+
+file copy -force libMapscript.dll      $mslib
+file copy -force ../pkgIndex.tcl       $mslib
+file copy -force ../mapscriptsupp.tcl  $mslib
+catch {file copy -force ../mapscriptsupp.html  $mslib}
+catch {file copy -force ../mapscript_wrap.html  $mslib}
+
+wm title . "Mapscript/Tcl Installer"
+label .l -text "Mapscript/Tcl Installation is complete."
+button .b -text Ok -command exit
+pack .l .b -side top -padx 30 -pady 30
+
diff -pruN 8.0.1-5/src/mapscript/v8/line.cpp 8.2.0~beta1-1~exp1/src/mapscript/v8/line.cpp
--- 8.0.1-5/src/mapscript/v8/line.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/line.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,219 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include "mapserver-config.h"
+#ifdef USE_V8_MAPSCRIPT
+
+#include "v8_mapscript.h"
+
+using namespace v8;
+
+Persistent<FunctionTemplate> Line::constructor;
+
+void Line::Initialize(Handle<Object> target) {
+  HandleScope scope;
+
+  Handle<FunctionTemplate> c = FunctionTemplate::New(Line::New);
+  c->InstanceTemplate()->SetInternalFieldCount(1);
+  c->SetClassName(String::NewSymbol("lineObj"));
+
+  SET_ATTRIBUTE_RO(c, "numpoints", getProp);
+
+  NODE_SET_PROTOTYPE_METHOD(c, "point", getPoint);
+  NODE_SET_PROTOTYPE_METHOD(c, "addXY", addXY);
+  NODE_SET_PROTOTYPE_METHOD(c, "addXYZ", addXYZ);
+  NODE_SET_PROTOTYPE_METHOD(c, "add", addPoint);
+
+  target->Set(String::NewSymbol("lineObj"), c->GetFunction());
+
+  constructor.Reset(Isolate::GetCurrent(), c);
+}
+
+void Line::Dispose() {
+  Line::constructor.Dispose();
+  Line::constructor.Clear();
+}
+
+Line::~Line() {
+  if (this->freeInternal) {
+    msFree(this->this_->point);
+    msFree(this->this_);
+  }
+}
+
+Handle<Function> Line::Constructor() {
+  return (*Line::constructor)->GetFunction();
+}
+
+void Line::New(const v8::FunctionCallbackInfo<Value> &args) {
+  HandleScope scope;
+
+  if (args[0]->IsExternal()) {
+    Local<External> ext = Local<External>::Cast(args[0]);
+    void *ptr = ext->Value();
+    Line *line = static_cast<Line *>(ptr);
+    Handle<Object> self = args.Holder();
+    line->Wrap(self);
+    if (line->parent_) {
+      self->SetHiddenValue(String::New("__parent__"), line->parent_->handle());
+      line->disableMemoryHandler();
+    }
+  } else {
+    lineObj *l = (lineObj *)msSmallMalloc(sizeof(lineObj));
+
+    l->numpoints = 0;
+    l->point = NULL;
+
+    Line *line = new Line(l);
+    line->Wrap(args.Holder());
+  }
+}
+
+Line::Line(lineObj *l, ObjectWrap *p) : ObjectWrap() {
+  this->this_ = l;
+  this->parent_ = p;
+  this->freeInternal = true;
+}
+
+void Line::getProp(Local<String> property,
+                   const PropertyCallbackInfo<Value> &info) {
+  HandleScope scope;
+  Line *l = ObjectWrap::Unwrap<Line>(info.Holder());
+  std::string name = TOSTR(property);
+  Handle<Value> value = Undefined();
+
+  if (name == "numpoints")
+    value = Integer::New(l->get()->numpoints);
+
+  info.GetReturnValue().Set(value);
+}
+
+void Line::getPoint(const v8::FunctionCallbackInfo<Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 1 || !args[0]->IsInt32()) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
+
+  int index = args[0]->Int32Value();
+
+  if (index < 0 || index >= line->numpoints) {
+    ThrowException(String::New("Invalid point index."));
+    return;
+  }
+
+  Point *point = new Point(&line->point[index], l);
+  Handle<Value> ext = External::New(point);
+  args.GetReturnValue().Set(Point::Constructor()->NewInstance(1, &ext));
+}
+
+void Line::addXY(const v8::FunctionCallbackInfo<Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 2 || !args[0]->IsNumber() || !args[1]->IsNumber()) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
+
+  if (line->numpoints == 0) /* new */
+    line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+  else /* extend array */
+    line->point = (pointObj *)msSmallRealloc(
+        line->point, sizeof(pointObj) * (line->numpoints + 1));
+
+  line->point[line->numpoints].x = args[0]->NumberValue();
+  line->point[line->numpoints].y = args[1]->NumberValue();
+  if (args.Length() > 2 && args[2]->IsNumber())
+    line->point[line->numpoints].m = args[2]->NumberValue();
+
+  line->numpoints++;
+}
+
+void Line::addXYZ(const v8::FunctionCallbackInfo<Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 3 || !args[0]->IsNumber() || !args[1]->IsNumber() ||
+      !args[2]->IsNumber()) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
+
+  if (line->numpoints == 0) /* new */
+    line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+  else /* extend array */
+    line->point = (pointObj *)msSmallRealloc(
+        line->point, sizeof(pointObj) * (line->numpoints + 1));
+
+  line->point[line->numpoints].x = args[0]->NumberValue();
+  line->point[line->numpoints].y = args[1]->NumberValue();
+  line->point[line->numpoints].z = args[2]->NumberValue();
+  if (args.Length() > 3 && args[3]->IsNumber())
+    line->point[line->numpoints].m = args[3]->NumberValue();
+  line->numpoints++;
+}
+
+void Line::addPoint(const v8::FunctionCallbackInfo<Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 1 || !args[0]->IsObject() ||
+      !args[0]->ToObject()->GetConstructorName()->Equals(
+          String::New("pointObj"))) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
+  Point *p = ObjectWrap::Unwrap<Point>(args[0]->ToObject());
+  pointObj *point = p->get();
+
+  if (line->numpoints == 0) /* new */
+    line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+  else /* extend array */
+    line->point = (pointObj *)msSmallRealloc(
+        line->point, sizeof(pointObj) * (line->numpoints + 1));
+
+  line->point[line->numpoints].x = point->x;
+  line->point[line->numpoints].y = point->y;
+  line->point[line->numpoints].z = point->z;
+  if (args.Length() > 3 && args[3]->IsNumber())
+    line->point[line->numpoints].m = point->m;
+  line->numpoints++;
+}
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/line.hpp 8.2.0~beta1-1~exp1/src/mapscript/v8/line.hpp
--- 8.0.1-5/src/mapscript/v8/line.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/line.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,65 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#ifndef LINE_H_
+#define LINE_H_
+
+#include <v8.h>
+
+using namespace v8;
+
+class Line : public ObjectWrap {
+public:
+  static void Initialize(Handle<Object> target);
+  static void New(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void Dispose();
+  static Handle<Function> Constructor();
+
+  Line(lineObj *l, ObjectWrap *p = NULL);
+  ~Line();
+  inline lineObj *get() { return this_; }
+  inline void disableMemoryHandler() { this->freeInternal = false; }
+
+  static void getProp(Local<String> property,
+                      const PropertyCallbackInfo<Value> &info);
+  static void setProp(Local<String> property, Local<Value> value,
+                      const PropertyCallbackInfo<void> &info);
+
+  static void getPoint(const v8::FunctionCallbackInfo<Value> &args);
+  static void addXY(const v8::FunctionCallbackInfo<Value> &args);
+  static void addXYZ(const v8::FunctionCallbackInfo<Value> &args);
+  static void addPoint(const v8::FunctionCallbackInfo<Value> &args);
+
+private:
+  static Persistent<FunctionTemplate> constructor;
+  lineObj *this_;
+  ObjectWrap *parent_;
+  bool freeInternal;
+};
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/point.cpp 8.2.0~beta1-1~exp1/src/mapscript/v8/point.cpp
--- 8.0.1-5/src/mapscript/v8/point.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/point.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,177 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include "mapserver-config.h"
+#ifdef USE_V8_MAPSCRIPT
+
+#include "v8_mapscript.h"
+
+using namespace v8;
+
+Persistent<FunctionTemplate> Point::constructor;
+
+void Point::Initialize(Handle<Object> target) {
+  HandleScope scope;
+
+  Handle<FunctionTemplate> c = FunctionTemplate::New(Point::New);
+  c->InstanceTemplate()->SetInternalFieldCount(1);
+  c->SetClassName(String::NewSymbol("pointObj"));
+
+  SET_ATTRIBUTE(c, "x", getProp, setProp);
+  SET_ATTRIBUTE(c, "y", getProp, setProp);
+  SET_ATTRIBUTE(c, "z", getProp, setProp);
+  SET_ATTRIBUTE(c, "m", getProp, setProp);
+
+  NODE_SET_PROTOTYPE_METHOD(c, "setXY", setXY);
+  NODE_SET_PROTOTYPE_METHOD(c, "setXYZ", setXYZ);
+
+  target->Set(String::NewSymbol("pointObj"), c->GetFunction());
+
+  constructor.Reset(Isolate::GetCurrent(), c);
+}
+
+void Point::Dispose() {
+  Point::constructor.Dispose();
+  Point::constructor.Clear();
+}
+
+Point::~Point() {
+  if (this->freeInternal) {
+    msFree(this->get());
+  }
+}
+
+Handle<Function> Point::Constructor() {
+  return (*Point::constructor)->GetFunction();
+}
+
+void Point::New(const v8::FunctionCallbackInfo<Value> &args) {
+  HandleScope scope;
+
+  if (args[0]->IsExternal()) {
+    Local<External> ext = Local<External>::Cast(args[0]);
+    void *ptr = ext->Value();
+    Point *point = static_cast<Point *>(ptr);
+    Handle<Object> self = args.Holder();
+    point->Wrap(self);
+    if (point->parent_) {
+      self->SetHiddenValue(String::New("__parent__"), point->parent_->handle());
+      point->disableMemoryHandler();
+    }
+  } else {
+    pointObj *p = (pointObj *)msSmallMalloc(sizeof(pointObj));
+
+    p->x = 0;
+    p->y = 0;
+    p->z = 0;
+    p->m = 0;
+
+    Point *point = new Point(p);
+    point->Wrap(args.Holder());
+  }
+}
+
+Point::Point(pointObj *p, ObjectWrap *pa) : ObjectWrap() {
+  this->this_ = p;
+  this->parent_ = pa;
+  this->freeInternal = true;
+}
+
+void Point::getProp(Local<String> property,
+                    const PropertyCallbackInfo<Value> &info) {
+  HandleScope scope;
+  Point *p = ObjectWrap::Unwrap<Point>(info.Holder());
+  std::string name = TOSTR(property);
+  Handle<Value> value = Undefined();
+
+  if (name == "x")
+    value = Number::New(p->get()->x);
+  else if (name == "y")
+    value = Number::New(p->get()->y);
+  else if (name == "z")
+    value = Number::New(p->get()->z);
+  else if (name == "m")
+    value = Number::New(p->get()->m);
+
+  info.GetReturnValue().Set(value);
+}
+
+void Point::setProp(Local<String> property, Local<Value> value,
+                    const PropertyCallbackInfo<void> &info) {
+  HandleScope scope;
+  Point *p = ObjectWrap::Unwrap<Point>(info.Holder());
+  std::string name = TOSTR(property);
+  if (!value->IsNumber())
+    ThrowException(
+        Exception::TypeError(String::New("point value must be a number")));
+  if (name == "x") {
+    p->get()->x = value->NumberValue();
+  } else if (name == "y") {
+    p->get()->y = value->NumberValue();
+  } else if (name == "z") {
+    p->get()->z = value->NumberValue();
+  } else if (name == "m") {
+    p->get()->m = value->NumberValue();
+  }
+}
+
+void Point::setXY(const v8::FunctionCallbackInfo<v8::Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 2 || !args[0]->IsNumber() || !args[1]->IsNumber()) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Point *p = ObjectWrap::Unwrap<Point>(args.Holder());
+
+  p->get()->x = args[0]->NumberValue();
+  p->get()->y = args[1]->NumberValue();
+}
+
+void Point::setXYZ(const v8::FunctionCallbackInfo<v8::Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 3 || !args[0]->IsNumber() || !args[1]->IsNumber() ||
+      !args[2]->IsNumber()) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Point *p = ObjectWrap::Unwrap<Point>(args.Holder());
+
+  p->get()->x = args[0]->NumberValue();
+  p->get()->y = args[1]->NumberValue();
+
+  p->get()->z = args[2]->NumberValue();
+  if (args.Length() > 3 && args[3]->IsNumber()) {
+    p->get()->m = args[3]->NumberValue();
+  }
+}
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/point.hpp 8.2.0~beta1-1~exp1/src/mapscript/v8/point.hpp
--- 8.0.1-5/src/mapscript/v8/point.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/point.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,63 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#ifndef POINT_H_
+#define POINT_H_
+
+#include <v8.h>
+
+using namespace v8;
+
+class Point : public ObjectWrap {
+public:
+  static void Initialize(Handle<Object> target);
+  static void New(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void Dispose();
+  static Handle<Function> Constructor();
+
+  Point(pointObj *p, ObjectWrap *pa = NULL);
+  ~Point();
+  inline pointObj *get() { return this_; }
+  inline void disableMemoryHandler() { this->freeInternal = false; }
+
+  static void getProp(Local<String> property,
+                      const PropertyCallbackInfo<Value> &info);
+  static void setProp(Local<String> property, Local<Value> value,
+                      const PropertyCallbackInfo<void> &info);
+
+  static void setXY(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void setXYZ(const v8::FunctionCallbackInfo<v8::Value> &args);
+
+private:
+  static Persistent<FunctionTemplate> constructor;
+  pointObj *this_;
+  ObjectWrap *parent_;
+  bool freeInternal;
+};
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/shape.cpp 8.2.0~beta1-1~exp1/src/mapscript/v8/shape.cpp
--- 8.0.1-5/src/mapscript/v8/shape.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/shape.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,341 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include "mapserver-config.h"
+#ifdef USE_V8_MAPSCRIPT
+
+#include "v8_mapscript.h"
+#include <map>
+
+using namespace v8;
+using std::map;
+using std::string;
+
+Persistent<FunctionTemplate> Shape::constructor;
+
+void Shape::Initialize(Handle<Object> target) {
+  HandleScope scope;
+
+  Handle<FunctionTemplate> c = FunctionTemplate::New(Shape::New);
+  c->InstanceTemplate()->SetInternalFieldCount(1);
+  c->SetClassName(String::NewSymbol("shapeObj"));
+
+  SET_ATTRIBUTE_RO(c, "numvalues", getProp);
+  SET_ATTRIBUTE_RO(c, "numlines", getProp);
+  SET_ATTRIBUTE_RO(c, "index", getProp);
+  SET_ATTRIBUTE_RO(c, "type", getProp);
+  SET_ATTRIBUTE_RO(c, "tileindex", getProp);
+  SET_ATTRIBUTE_RO(c, "classindex", getProp);
+  SET_ATTRIBUTE(c, "text", getProp, setProp);
+
+  NODE_SET_PROTOTYPE_METHOD(c, "clone", clone);
+  NODE_SET_PROTOTYPE_METHOD(c, "line", getLine);
+  NODE_SET_PROTOTYPE_METHOD(c, "add", addLine);
+  NODE_SET_PROTOTYPE_METHOD(c, "setGeometry", setGeometry);
+
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Point", MS_SHAPE_POINT);
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Line", MS_SHAPE_LINE);
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Polygon", MS_SHAPE_POLYGON);
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Null", MS_SHAPE_NULL);
+
+  target->Set(String::NewSymbol("shapeObj"), c->GetFunction());
+
+  constructor.Reset(Isolate::GetCurrent(), c);
+}
+
+void Shape::Dispose() {
+  Shape::constructor.Dispose();
+  Shape::constructor.Clear();
+}
+
+Shape::~Shape() {
+  /* this is set to false if the shapeObj is owned by mapserver and not v8 */
+  if (freeInternal) {
+    msFreeShape(this->get());
+    msFree(this->get());
+  }
+}
+
+Handle<Function> Shape::Constructor() {
+  return (*Shape::constructor)->GetFunction();
+}
+
+void Shape::New(const v8::FunctionCallbackInfo<Value> &args) {
+  HandleScope scope;
+  Handle<Object> self = args.Holder();
+  Shape *shape;
+
+  if (args[0]->IsExternal()) {
+    Local<External> ext = Local<External>::Cast(args[0]);
+    void *ptr = ext->Value();
+    shape = static_cast<Shape *>(ptr);
+    shape->Wrap(args.Holder());
+  } else {
+    shapeObj *s = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+
+    msInitShape(s);
+    if (args.Length() >= 1) {
+      s->type = args[0]->Int32Value();
+    } else {
+      s->type = MS_SHAPE_NULL;
+    }
+
+    shape = new Shape(s);
+    shape->Wrap(self);
+  }
+
+  /* create the attribute template. should use ObjectWrap in future */
+  Handle<ObjectTemplate> attributes_templ = ObjectTemplate::New();
+  attributes_templ->SetInternalFieldCount(2);
+  attributes_templ->SetNamedPropertyHandler(attributeGetValue,
+                                            attributeSetValue);
+  Handle<Object> attributes = attributes_templ->NewInstance();
+  map<string, int> *attributes_map = new map<string, int>();
+  attributes->SetInternalField(0, External::New(attributes_map));
+  attributes->SetInternalField(1, External::New(shape->get()->values));
+  attributes->SetHiddenValue(String::New("__parent__"), self);
+
+  if (shape->layer) {
+    for (int i = 0; i < shape->layer->numitems; ++i) {
+      (*attributes_map)[string(shape->layer->items[i])] = i;
+    }
+  }
+
+  Persistent<Object> pattributes;
+  pattributes.Reset(Isolate::GetCurrent(), attributes);
+  pattributes.MakeWeak(attributes_map, attributeWeakCallback);
+  pattributes.MarkIndependent();
+
+  self->Set(String::New("attributes"), attributes);
+}
+
+Shape::Shape(shapeObj *s) : ObjectWrap() {
+  this->this_ = s;
+  this->layer = NULL;
+  this->freeInternal = true;
+}
+
+void Shape::getProp(Local<String> property,
+                    const PropertyCallbackInfo<Value> &info) {
+  HandleScope scope;
+  Shape *s = ObjectWrap::Unwrap<Shape>(info.Holder());
+  std::string name = TOSTR(property);
+  Handle<Value> value = Undefined();
+
+  if (name == "numvalues")
+    value = Integer::New(s->get()->numvalues);
+  else if (name == "numlines")
+    value = Integer::New(s->get()->numlines);
+  else if (name == "index")
+    value = Number::New(s->get()->index);
+  else if (name == "type")
+    value = Integer::New(s->get()->type);
+  else if (name == "tileindex")
+    value = Integer::New(s->get()->tileindex);
+  else if (name == "classindex")
+    value = Integer::New(s->get()->classindex);
+  else if (name == "text")
+    value = String::New(s->get()->text);
+
+  info.GetReturnValue().Set(value);
+}
+
+void Shape::setProp(Local<String> property, Local<Value> value,
+                    const PropertyCallbackInfo<void> &info) {
+  HandleScope scope;
+  Shape *s = ObjectWrap::Unwrap<Shape>(info.Holder());
+  std::string name = TOSTR(property);
+
+  if (name == "text") {
+    if (s->get()->text)
+      msFree(s->get()->text);
+    s->get()->text = getStringValue(value);
+  }
+}
+
+void Shape::clone(const v8::FunctionCallbackInfo<v8::Value> &args) {
+  HandleScope scope;
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  shapeObj *shape = s->get();
+
+  shapeObj *new_shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+  msInitShape(new_shape);
+  msCopyShape(shape, new_shape);
+
+  Shape *ns = new Shape(new_shape);
+  Handle<Value> ext = External::New(ns);
+  Handle<Object> clone = Shape::Constructor()->NewInstance(1, &ext);
+
+  /* we need this to copy shape attributes */
+  Handle<Object> self = s->handle();
+  Handle<Object> self_attributes =
+      self->Get(String::New("attributes"))->ToObject();
+  Local<External> wrap =
+      Local<External>::Cast(self_attributes->GetInternalField(0));
+  void *ptr = wrap->Value();
+  map<string, int> *self_attributes_map = static_cast<map<string, int> *>(ptr);
+
+  Handle<Object> clone_attributes =
+      clone->Get(String::New("attributes"))->ToObject();
+  wrap = Local<External>::Cast(clone_attributes->GetInternalField(0));
+  ptr = wrap->Value();
+  map<string, int> *clone_attributes_map = static_cast<map<string, int> *>(ptr);
+
+  clone_attributes_map->insert(self_attributes_map->begin(),
+                               self_attributes_map->end());
+
+  args.GetReturnValue().Set(clone);
+}
+
+void Shape::getLine(const v8::FunctionCallbackInfo<v8::Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 1 || !args[0]->IsInt32()) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  int index = args[0]->Int32Value();
+
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  shapeObj *shape = s->get();
+
+  if (index < 0 || index >= shape->numlines) {
+    ThrowException(String::New("Invalid line index."));
+    return;
+  }
+
+  Line *line = new Line(&shape->line[index], s);
+  Handle<Value> ext = External::New(line);
+  args.GetReturnValue().Set(Line::Constructor()->NewInstance(1, &ext));
+}
+
+void Shape::addLine(const v8::FunctionCallbackInfo<v8::Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 1 || !args[0]->IsObject() ||
+      !args[0]->ToObject()->GetConstructorName()->Equals(
+          String::New("lineObj"))) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  shapeObj *shape = s->get();
+
+  Line *l = ObjectWrap::Unwrap<Line>(args[0]->ToObject());
+  lineObj *line = l->get();
+
+  msAddLine(shape, line);
+}
+
+void Shape::setGeometry(const v8::FunctionCallbackInfo<v8::Value> &args) {
+  HandleScope scope;
+
+  if (args.Length() < 1 || !args[0]->IsObject() ||
+      !args[0]->ToObject()->GetConstructorName()->Equals(
+          String::New("shapeObj"))) {
+    ThrowException(String::New("Invalid argument"));
+    return;
+  }
+
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  shapeObj *shape = s->get();
+  Shape *ns = ObjectWrap::Unwrap<Shape>(args[0]->ToObject());
+  shapeObj *new_shape = ns->get();
+
+  /* clean current shape */
+  for (int i = 0; i < shape->numlines; i++) {
+    free(shape->line[i].point);
+  }
+  if (shape->line)
+    free(shape->line);
+  shape->line = NULL;
+  shape->numlines = 0;
+
+  for (int i = 0; i < new_shape->numlines; i++) {
+    msAddLine(shape, &(new_shape->line[i]));
+  }
+
+  return;
+}
+
+void Shape::attributeWeakCallback(v8::Isolate *isolate,
+                                  v8::Persistent<v8::Object> *pobj,
+                                  map<string, int> *map) {
+  v8::HandleScope scope(isolate);
+  pobj->Dispose();
+  pobj->Clear();
+  delete map;
+}
+
+void Shape::attributeGetValue(Local<String> name,
+                              const PropertyCallbackInfo<Value> &info) {
+  Local<Object> self = info.Holder();
+  Local<External> wrap = Local<External>::Cast(self->GetInternalField(0));
+  void *ptr = wrap->Value();
+  map<string, int> *indexes = static_cast<map<string, int> *>(ptr);
+  wrap = Local<External>::Cast(self->GetInternalField(1));
+  ptr = wrap->Value();
+  char **values = static_cast<char **>(ptr);
+
+  String::Utf8Value utf8_value(name);
+  string key = string(*utf8_value);
+  map<string, int>::iterator iter = indexes->find(key);
+
+  if (iter != indexes->end()) {
+    const int &index = (*iter).second;
+    info.GetReturnValue().Set(String::New(values[index]));
+  }
+}
+
+void Shape::attributeSetValue(Local<String> name, Local<Value> value,
+                              const PropertyCallbackInfo<Value> &info) {
+  Local<Object> self = info.Holder();
+  Local<External> wrap = Local<External>::Cast(self->GetInternalField(0));
+  void *ptr = wrap->Value();
+  map<string, int> *indexes = static_cast<map<string, int> *>(ptr);
+  wrap = Local<External>::Cast(self->GetInternalField(1));
+  ptr = wrap->Value();
+  char **values = static_cast<char **>(ptr);
+
+  String::Utf8Value utf8_name(name), utf8_value(value);
+  string key = string(*utf8_name);
+
+  map<string, int>::iterator iter = indexes->find(key);
+
+  if (iter == indexes->end()) {
+    ThrowException(String::New("Invalid value name."));
+  } else {
+    const int &index = (*iter).second;
+    msFree(values[index]);
+    values[index] = msStrdup(*utf8_value);
+  }
+}
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/shape.hpp 8.2.0~beta1-1~exp1/src/mapscript/v8/shape.hpp
--- 8.0.1-5/src/mapscript/v8/shape.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/shape.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,82 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#ifndef SHAPE_H_
+#define SHAPE_H_
+
+#include <v8.h>
+#include <map>
+#include <string>
+
+using namespace v8;
+using std::map;
+using std::string;
+
+class Shape : public ObjectWrap {
+public:
+  static void Initialize(Handle<Object> target);
+  static void New(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void Dispose();
+  static Handle<Function> Constructor();
+
+  Shape(shapeObj *p);
+  ~Shape();
+  inline shapeObj *get() { return this_; }
+  inline void disableMemoryHandler() { this->freeInternal = false; }
+
+  inline void setLayer(layerObj *layer) { this->layer = layer; };
+
+  static void getProp(Local<String> property,
+                      const PropertyCallbackInfo<Value> &info);
+  static void setProp(Local<String> property, Local<Value> value,
+                      const PropertyCallbackInfo<void> &info);
+
+  static void clone(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void getLine(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void addLine(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void setGeometry(const v8::FunctionCallbackInfo<v8::Value> &args);
+
+  /* This could be generic in the future.. */
+  static void attributeWeakCallback(v8::Isolate *isolate,
+                                    v8::Persistent<v8::Object> *pobj,
+                                    map<string, int> *map);
+  static void attributeGetValue(Local<String> name,
+                                const PropertyCallbackInfo<Value> &info);
+  static void attributeSetValue(Local<String> name, Local<Value> value,
+                                const PropertyCallbackInfo<Value> &info);
+  static void attributeMapDestroy(Isolate *isolate, Persistent<Object> *object,
+                                  map<string, int> *map);
+
+private:
+  static Persistent<FunctionTemplate> constructor;
+  bool freeInternal;
+  layerObj *layer; /* for attributes names */
+  shapeObj *this_;
+};
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/v8_mapscript.cpp 8.2.0~beta1-1~exp1/src/mapscript/v8/v8_mapscript.cpp
--- 8.0.1-5/src/mapscript/v8/v8_mapscript.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/v8_mapscript.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,47 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include "mapserver-config.h"
+#ifdef USE_V8_MAPSCRIPT
+
+#include "mapserver.h"
+#include "v8_mapscript.h"
+
+char *getStringValue(Local<Value> value, const char *fallback) {
+  if (value->IsString()) {
+    String::AsciiValue string(value);
+    char *str = (char *)malloc(string.length() + 1);
+    strcpy(str, *string);
+    return str;
+  }
+  char *str = (char *)malloc(strlen(fallback) + 1);
+  strcpy(str, fallback);
+  return str;
+}
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/v8_mapscript.h 8.2.0~beta1-1~exp1/src/mapscript/v8/v8_mapscript.h
--- 8.0.1-5/src/mapscript/v8/v8_mapscript.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/v8_mapscript.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,99 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#ifndef V8_MAPSCRIPT_H
+#define V8_MAPSCRIPT_H
+
+#include "mapserver-config.h"
+#ifdef USE_V8_MAPSCRIPT
+
+/* This need should be removed in future v8 version */
+#define V8_ALLOW_ACCESS_TO_RAW_HANDLE_CONSTRUCTOR 1
+#define V8_USE_UNSAFE_HANDLES 1
+
+#include "mapserver.h"
+#include <v8.h>
+#include <string>
+#include <stack>
+#include <map>
+#include "v8_object_wrap.hpp"
+#include "point.hpp"
+#include "line.hpp"
+#include "shape.hpp"
+
+using namespace v8;
+
+using std::map;
+using std::stack;
+using std::string;
+
+class V8Context {
+public:
+  V8Context(Isolate *isolate) : isolate(isolate) {}
+  Isolate *isolate;
+  stack<string> paths; /* for relative paths and the require function */
+  map<string, Persistent<Script>> scripts;
+  Persistent<Context> context;
+  layerObj *layer; /* current layer, used in geomtransform */
+};
+
+#define V8CONTEXT(map) ((V8Context *)(map)->v8context)
+
+inline void NODE_SET_PROTOTYPE_METHOD(v8::Handle<v8::FunctionTemplate> recv,
+                                      const char *name,
+                                      v8::FunctionCallback callback) {
+  v8::Isolate *isolate = v8::Isolate::GetCurrent();
+  v8::HandleScope handle_scope(isolate);
+  v8::Local<v8::FunctionTemplate> t = v8::FunctionTemplate::New(callback);
+  recv->InstanceTemplate()->Set(v8::String::NewFromUtf8(isolate, name),
+                                t->GetFunction());
+}
+#define NODE_SET_PROTOTYPE_METHOD NODE_SET_PROTOTYPE_METHOD
+
+#define TOSTR(obj) (*String::Utf8Value((obj)->ToString()))
+
+#define SET(target, name, value)                                               \
+  (target)->PrototypeTemplate()->Set(String::NewSymbol(name), value);
+
+#define SET_ATTRIBUTE(t, name, get, set)                                       \
+  t->InstanceTemplate()->SetAccessor(String::NewSymbol(name), get, set)
+
+#define SET_ATTRIBUTE_RO(t, name, get)                                         \
+  t->InstanceTemplate()->SetAccessor(                                          \
+      String::NewSymbol(name), get, 0, Handle<Value>(), DEFAULT,               \
+      static_cast<PropertyAttribute>(ReadOnly | DontDelete))
+
+#define NODE_DEFINE_CONSTANT(target, name, constant)                           \
+  (target)->Set(String::NewSymbol(name), Integer::New(constant),               \
+                static_cast<PropertyAttribute>(ReadOnly | DontDelete));
+
+char *getStringValue(Local<Value> value, const char *fallback = "");
+
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/mapscript/v8/v8_object_wrap.hpp 8.2.0~beta1-1~exp1/src/mapscript/v8/v8_object_wrap.hpp
--- 8.0.1-5/src/mapscript/v8/v8_object_wrap.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapscript/v8/v8_object_wrap.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,116 @@
+// Copyright Joyent, Inc. and other Node contributors.
+//
+// Permission is hereby granted, free of charge, to any person obtaining a
+// copy of this software and associated documentation files (the
+// "Software"), to deal in the Software without restriction, including
+// without limitation the rights to use, copy, modify, merge, publish,
+// distribute, sublicense, and/or sell copies of the Software, and to permit
+// persons to whom the Software is furnished to do so, subject to the
+// following conditions:
+//
+// The above copyright notice and this permission notice shall be included
+// in all copies or substantial portions of the Software.
+//
+// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
+// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
+// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
+// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
+// USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+#ifndef V8_OBJECT_WRAP_H_
+#define V8_OBJECT_WRAP_H_
+
+#include "v8.h"
+#include <assert.h>
+
+class ObjectWrap {
+public:
+  ObjectWrap() { refs_ = 0; }
+
+  virtual ~ObjectWrap() {
+    if (persistent().IsEmpty())
+      return;
+    assert(persistent().IsNearDeath());
+    persistent().ClearWeak();
+    persistent().Dispose();
+  }
+
+  template <class T> static inline T *Unwrap(v8::Handle<v8::Object> handle) {
+    assert(!handle.IsEmpty());
+    assert(handle->InternalFieldCount() > 0);
+    // Cast to ObjectWrap before casting to T.  A direct cast from void
+    // to T won't work right when T has more than one base class.
+    void *ptr = handle->GetAlignedPointerFromInternalField(0);
+    ObjectWrap *wrap = static_cast<ObjectWrap *>(ptr);
+    return static_cast<T *>(wrap);
+  }
+
+  inline v8::Local<v8::Object> handle() {
+    return handle(v8::Isolate::GetCurrent());
+  }
+
+  inline v8::Local<v8::Object> handle(v8::Isolate *isolate) {
+    return v8::Local<v8::Object>::New(isolate, persistent());
+  }
+
+  inline v8::Persistent<v8::Object> &persistent() { return handle_; }
+
+protected:
+  inline void Wrap(v8::Handle<v8::Object> handle) {
+    assert(persistent().IsEmpty());
+    assert(handle->InternalFieldCount() > 0);
+    handle->SetAlignedPointerInInternalField(0, this);
+    persistent().Reset(v8::Isolate::GetCurrent(), handle);
+    MakeWeak();
+  }
+
+  inline void MakeWeak(void) {
+    persistent().MakeWeak(this, WeakCallback);
+    persistent().MarkIndependent();
+  }
+
+  /* Ref() marks the object as being attached to an event loop.
+   * Refed objects will not be garbage collected, even if
+   * all references are lost.
+   */
+  virtual void Ref() {
+    assert(!persistent().IsEmpty());
+    persistent().ClearWeak();
+    refs_++;
+  }
+
+  /* Unref() marks an object as detached from the event loop.  This is its
+   * default state.  When an object with a "weak" reference changes from
+   * attached to detached state it will be freed. Be careful not to access
+   * the object after making this call as it might be gone!
+   * (A "weak reference" means an object that only has a
+   * persistant handle.)
+   *
+   * DO NOT CALL THIS FROM DESTRUCTOR
+   */
+  virtual void Unref() {
+    assert(!persistent().IsEmpty());
+    assert(!persistent().IsWeak());
+    assert(refs_ > 0);
+    if (--refs_ == 0)
+      MakeWeak();
+  }
+
+  int refs_; // ro
+
+private:
+  static void WeakCallback(v8::Isolate *isolate,
+                           v8::Persistent<v8::Object> *pobj, ObjectWrap *wrap) {
+    v8::HandleScope scope(isolate);
+    assert(wrap->refs_ == 0);
+    assert(*pobj == wrap->persistent());
+    assert((*pobj).IsNearDeath());
+    delete wrap;
+  }
+
+  v8::Persistent<v8::Object> handle_;
+};
+
+#endif // v8_OBJECT_WRAP_H_
diff -pruN 8.0.1-5/src/mapsearch.c 8.2.0~beta1-1~exp1/src/mapsearch.c
--- 8.0.1-5/src/mapsearch.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapsearch.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,733 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Various geospatial search operations.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ * Notes: For information on point in polygon function please see:
+ *
+ *   http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html
+ *
+ * The appropriate copyright notice accompanies the funtion definition.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#define LASTVERT(v, n) ((v) == 0 ? n - 2 : v - 1)
+#define NEXTVERT(v, n) ((v) == n - 2 ? 0 : v + 1)
+
+/*
+** Returns MS_TRUE if rectangles a and b overlap
+*/
+int msRectOverlap(const rectObj *a, const rectObj *b) {
+  if (a->minx > b->maxx)
+    return (MS_FALSE);
+  if (a->maxx < b->minx)
+    return (MS_FALSE);
+  if (a->miny > b->maxy)
+    return (MS_FALSE);
+  if (a->maxy < b->miny)
+    return (MS_FALSE);
+  return (MS_TRUE);
+}
+
+/*
+** Computes the intersection of two rectangles, updating the first
+** to be only the intersection of the two.  Returns MS_FALSE if
+** the intersection is empty.
+*/
+int msRectIntersect(rectObj *a, const rectObj *b) {
+  if (a->maxx > b->maxx)
+    a->maxx = b->maxx;
+  if (a->minx < b->minx)
+    a->minx = b->minx;
+  if (a->maxy > b->maxy)
+    a->maxy = b->maxy;
+  if (a->miny < b->miny)
+    a->miny = b->miny;
+
+  if (a->maxx < a->minx || b->maxx < b->minx)
+    return MS_FALSE;
+  else
+    return MS_TRUE;
+}
+
+/*
+** Returns MS_TRUE if rectangle a is contained in rectangle b
+*/
+int msRectContained(const rectObj *a, const rectObj *b) {
+  if (a->minx >= b->minx && a->maxx <= b->maxx)
+    if (a->miny >= b->miny && a->maxy <= b->maxy)
+      return (MS_TRUE);
+  return (MS_FALSE);
+}
+
+/*
+** Merges rect b into rect a. Rect a changes, b does not.
+*/
+void msMergeRect(rectObj *a, rectObj *b) {
+  a->minx = MS_MIN(a->minx, b->minx);
+  a->maxx = MS_MAX(a->maxx, b->maxx);
+  a->miny = MS_MIN(a->miny, b->miny);
+  a->maxy = MS_MAX(a->maxy, b->maxy);
+}
+
+int msPointInRect(const pointObj *p, const rectObj *rect) {
+  if (p->x < rect->minx)
+    return (MS_FALSE);
+  if (p->x > rect->maxx)
+    return (MS_FALSE);
+  if (p->y < rect->miny)
+    return (MS_FALSE);
+  if (p->y > rect->maxy)
+    return (MS_FALSE);
+  return (MS_TRUE);
+}
+
+int msPolygonDirection(lineObj *c) {
+  double mx, my, area;
+  int i, v = 0, lv, nv;
+
+  /* first find lowest, rightmost point of polygon */
+  mx = c->point[0].x;
+  my = c->point[0].y;
+
+  for (i = 0; i < c->numpoints - 1; i++) {
+    if ((c->point[i].y < my) ||
+        ((c->point[i].y == my) && (c->point[i].x > mx))) {
+      v = i;
+      mx = c->point[i].x;
+      my = c->point[i].y;
+    }
+  }
+
+  lv = LASTVERT(v, c->numpoints);
+  nv = NEXTVERT(v, c->numpoints);
+
+  area = c->point[lv].x * c->point[v].y - c->point[lv].y * c->point[v].x +
+         c->point[lv].y * c->point[nv].x - c->point[lv].x * c->point[nv].y +
+         c->point[v].x * c->point[nv].y - c->point[nv].x * c->point[v].y;
+  if (area > 0)
+    return (1);      /* counter clockwise orientation */
+  else if (area < 0) /* clockwise orientation */
+    return (-1);
+  else
+    return (0); /* shouldn't happen unless the polygon is self intersecting */
+}
+
+/*
+** Copyright (c) 1970-2003, Wm. Randolph Franklin
+**
+** Permission is hereby granted, free of charge, to any person obtaining a copy
+*of this software and
+** associated documentation files (the "Software"), to deal in the Software
+*without restriction, including
+** without limitation the rights to use, copy, modify, merge, publish,
+*distribute, sublicense, and/or sell
+** copies of the Software, and to permit persons to whom the Software is
+*furnished to do so, subject to the
+** following conditions:
+**
+** 1. Redistributions of source code must retain the above copyright notice,
+*this list of conditions and the
+**    following disclaimers.
+** 2. Redistributions in binary form must reproduce the above copyright notice
+*in the documentation and/or
+**    other materials provided with the distribution.
+** 3. The name of W. Randolph Franklin may not be used to endorse or promote
+*products derived from this
+**    Software without specific prior written permission.
+**
+** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+*IMPLIED, INCLUDING BUT NOT
+** LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
+*PURPOSE AND NONINFRINGEMENT. IN
+** NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
+*DAMAGES OR OTHER LIABILITY,
+** WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
+*IN CONNECTION WITH THE
+** SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+*/
+int msPointInPolygon(pointObj *p, lineObj *c) {
+  int i, j, status = MS_FALSE;
+
+  for (i = 0, j = c->numpoints - 1; i < c->numpoints; j = i++) {
+    if ((((c->point[i].y <= p->y) && (p->y < c->point[j].y)) ||
+         ((c->point[j].y <= p->y) && (p->y < c->point[i].y))) &&
+        (p->x < (c->point[j].x - c->point[i].x) * (p->y - c->point[i].y) /
+                        (c->point[j].y - c->point[i].y) +
+                    c->point[i].x))
+      status = !status;
+  }
+  return status;
+}
+
+/*
+** Note: the following functions are brute force implementations. Some fancy
+** computational geometry algorithms would speed things up nicely in many
+** cases. In due time... -SDL-
+*/
+
+int msIntersectSegments(
+    const pointObj *a, const pointObj *b, const pointObj *c,
+    const pointObj *d) /* from comp.graphics.alogorithms FAQ */
+{
+
+  double r, s;
+  double denominator, numerator;
+
+  numerator = ((a->y - c->y) * (d->x - c->x) - (a->x - c->x) * (d->y - c->y));
+  denominator = ((b->x - a->x) * (d->y - c->y) - (b->y - a->y) * (d->x - c->x));
+
+  if ((denominator == 0) &&
+      (numerator == 0)) { /* lines are coincident, intersection is a line
+                             segement if it exists */
+    if (a->y == c->y) {   /* coincident horizontally, check x's */
+      if (((a->x >= MS_MIN(c->x, d->x)) && (a->x <= MS_MAX(c->x, d->x))) ||
+          ((b->x >= MS_MIN(c->x, d->x)) && (b->x <= MS_MAX(c->x, d->x))))
+        return (MS_TRUE);
+      else
+        return (MS_FALSE);
+    } else { /* test for y's will work fine for remaining cases */
+      if (((a->y >= MS_MIN(c->y, d->y)) && (a->y <= MS_MAX(c->y, d->y))) ||
+          ((b->y >= MS_MIN(c->y, d->y)) && (b->y <= MS_MAX(c->y, d->y))))
+        return (MS_TRUE);
+      else
+        return (MS_FALSE);
+    }
+  }
+
+  if (denominator == 0) /* lines are parallel, can't intersect */
+    return (MS_FALSE);
+
+  r = numerator / denominator;
+
+  if ((r < 0) || (r > 1))
+    return (MS_FALSE); /* no intersection */
+
+  numerator = ((a->y - c->y) * (b->x - a->x) - (a->x - c->x) * (b->y - a->y));
+  s = numerator / denominator;
+
+  if ((s < 0) || (s > 1))
+    return (MS_FALSE); /* no intersection */
+
+  return (MS_TRUE);
+}
+
+/*
+** Instead of using ring orientation we count the number of parts the
+** point falls in. If odd the point is in the polygon, if 0 or even
+** then the point is in a hole or completely outside.
+*/
+int msIntersectPointPolygon(pointObj *point, shapeObj *poly) {
+  int i;
+  int status = MS_FALSE;
+
+  for (i = 0; i < poly->numlines; i++) {
+    if (msPointInPolygon(point, &poly->line[i]) ==
+        MS_TRUE) /* ok, the point is in a line */
+      status = !status;
+  }
+
+  return (status);
+}
+
+int msIntersectMultipointPolygon(shapeObj *multipoint, shapeObj *poly) {
+  int i, j;
+
+  /* The change to loop through all the lines has been made for ticket
+   * #2443 but is no more needed since ticket #2762. PostGIS now put all
+   * points into a single line.  */
+  for (i = 0; i < multipoint->numlines; i++) {
+    lineObj points = multipoint->line[i];
+    for (j = 0; j < points.numpoints; j++) {
+      if (msIntersectPointPolygon(&(points.point[j]), poly) == MS_TRUE)
+        return (MS_TRUE);
+    }
+  }
+
+  return (MS_FALSE);
+}
+
+int msIntersectPolylines(shapeObj *line1, shapeObj *line2) {
+  int c1, v1, c2, v2;
+
+  for (c1 = 0; c1 < line1->numlines; c1++)
+    for (v1 = 1; v1 < line1->line[c1].numpoints; v1++)
+      for (c2 = 0; c2 < line2->numlines; c2++)
+        for (v2 = 1; v2 < line2->line[c2].numpoints; v2++)
+          if (msIntersectSegments(&(line1->line[c1].point[v1 - 1]),
+                                  &(line1->line[c1].point[v1]),
+                                  &(line2->line[c2].point[v2 - 1]),
+                                  &(line2->line[c2].point[v2])) == MS_TRUE)
+            return (MS_TRUE);
+
+  return (MS_FALSE);
+}
+
+int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly) {
+  int i;
+
+  /* STEP 1: polygon might competely contain the polyline or one of it's parts
+   * (only need to check one point from each part) */
+  for (i = 0; i < line->numlines; i++) {
+    if (msIntersectPointPolygon(&(line->line[i].point[0]), poly) ==
+        MS_TRUE) /* this considers holes and multiple parts */
+      return (MS_TRUE);
+  }
+
+  /* STEP 2: look for intersecting line segments */
+  if (msIntersectPolylines(line, poly) == MS_TRUE)
+    return (MS_TRUE);
+
+  return (MS_FALSE);
+}
+
+int msIntersectPolygons(shapeObj *p1, shapeObj *p2) {
+  int i;
+
+  /* STEP 1: polygon 1 completely contains 2 (only need to check one point from
+   * each part) */
+  for (i = 0; i < p2->numlines; i++) {
+    if (msIntersectPointPolygon(&(p2->line[i].point[0]), p1) ==
+        MS_TRUE) /* this considers holes and multiple parts */
+      return (MS_TRUE);
+  }
+
+  /* STEP 2: polygon 2 completely contains 1 (only need to check one point from
+   * each part) */
+  for (i = 0; i < p1->numlines; i++) {
+    if (msIntersectPointPolygon(&(p1->line[i].point[0]), p2) ==
+        MS_TRUE) /* this considers holes and multiple parts */
+      return (MS_TRUE);
+  }
+
+  /* STEP 3: look for intersecting line segments */
+  if (msIntersectPolylines(p1, p2) == MS_TRUE)
+    return (MS_TRUE);
+
+  /*
+  ** At this point we know there are are no intersections between edges. There
+  *may be other tests necessary
+  ** but I haven't run into any cases that require them.
+  */
+
+  return (MS_FALSE);
+}
+
+/*
+** Distance computations
+*/
+
+double msDistancePointToPoint(pointObj *a, pointObj *b) {
+  double d;
+
+  d = sqrt(msSquareDistancePointToPoint(a, b));
+
+  return (d);
+}
+
+/*
+** Quickly compute the square of the distance; avoids expensive sqrt() call on
+*each invocation
+*/
+double msSquareDistancePointToPoint(pointObj *a, pointObj *b) {
+  double dx, dy;
+
+  dx = a->x - b->x;
+  dy = a->y - b->y;
+
+  return (dx * dx + dy * dy);
+}
+
+double msDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b) {
+  return (sqrt(msSquareDistancePointToSegment(p, a, b)));
+}
+
+double msSquareDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b) {
+  double l_squared; /* squared length of line ab */
+  double r, s;
+
+  l_squared = msSquareDistancePointToPoint(a, b);
+
+  if (l_squared == 0.0) /* a = b */
+    return (msSquareDistancePointToPoint(a, p));
+
+  r = ((a->y - p->y) * (a->y - b->y) - (a->x - p->x) * (b->x - a->x)) /
+      (l_squared);
+
+  if (r >
+      1) /* perpendicular projection of P is on the forward extention of AB */
+    return (MS_MIN(msSquareDistancePointToPoint(p, b),
+                   msSquareDistancePointToPoint(p, a)));
+  if (r <
+      0) /* perpendicular projection of P is on the backward extention of AB */
+    return (MS_MIN(msSquareDistancePointToPoint(p, b),
+                   msSquareDistancePointToPoint(p, a)));
+
+  s = ((a->y - p->y) * (b->x - a->x) - (a->x - p->x) * (b->y - a->y)) /
+      l_squared;
+
+  return (fabs(s * s * l_squared));
+}
+
+#define SMALL_NUMBER 0.00000001
+#define dot(u, v) ((u).x * (v).x + (u).y * (v).y) /* vector dot product */
+#define norm(v) sqrt(dot(v, v))
+
+#define slope(a, b) (((a)->y - (b)->y) / ((a)->x - (b)->x))
+
+/* Segment to segment distance code is a modified version of that found at:  */
+/*  */
+/* http://www.geometryalgorithms.com/Archive/algorithm_0106/algorithm_0106.htm
+ */
+/*  */
+/* Copyright 2001, softSurfer (www.softsurfer.com) */
+/* This code may be freely used and modified for any purpose */
+/* providing that this copyright notice is included with it. */
+/* SoftSurfer makes no warranty for this code, and cannot be held */
+/* liable for any real or imagined damage resulting from its use. */
+/* Users of this code must verify correctness for their application. */
+
+double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb, pointObj *pc,
+                                  pointObj *pd) {
+  vectorObj u, v, w;
+
+  /* check for strictly parallel segments first */
+  /* if(((pa->x == pb->x) && (pc->x == pd->x)) || (slope(pa,pb) ==
+   * slope(pc,pd))) { // vertical (infinite slope) || otherwise parallel */
+  /* D = msDistancePointToSegment(pa, pc, pd); */
+  /* D = MS_MIN(D, msDistancePointToSegment(pb, pc, pd)); */
+  /* D = MS_MIN(D, msDistancePointToSegment(pc, pa, pb)); */
+  /* return(MS_MIN(D, msDistancePointToSegment(pd, pa, pb))); */
+  /* } */
+
+  u.x = pb->x - pa->x; /* u = pb - pa */
+  u.y = pb->y - pa->y;
+  v.x = pd->x - pc->x; /* v = pd - pc  */
+  v.y = pd->y - pc->y;
+  w.x = pa->x - pc->x; /* w = pa - pc */
+  w.y = pa->y - pc->y;
+
+  const double a = dot(u, u);
+  const double b = dot(u, v);
+  const double c = dot(v, v);
+  const double d = dot(u, w);
+  const double e = dot(v, w);
+
+  const double D = a * c - b * b;
+  /* N=numerator, D=demoninator */
+  double sN = 0;
+  double sD = D;
+  double tD = D;
+  double tN = D;
+
+  /* compute the line parameters of the two closest points */
+  if (D < SMALL_NUMBER) { /* lines are parallel or almost parallel */
+    sD = 1.0;
+    tN = e;
+    tD = c;
+  } else { /* get the closest points on the infinite lines */
+    sN = b * e - c * d;
+    tN = a * e - b * d;
+    if (sN < 0) {
+      sN = 0.0;
+      tN = e;
+      tD = c;
+    } else if (sN > sD) {
+      sN = sD;
+      tN = e + b;
+      tD = c;
+    }
+  }
+
+  if (tN < 0) {
+    tN = 0.0;
+    if (-d < 0) {
+      /* sN = 0.0 */
+    } else if (-d > a)
+      sN = sD;
+    else {
+      sN = -d;
+      sD = a;
+    }
+  } else if (tN > tD) {
+    tN = tD;
+    if ((-d + b) < 0) {
+      /* sN = 0.0 */
+    } else if ((-d + b) > a)
+      sN = sD;
+    else {
+      sN = (-d + b);
+      sD = a;
+    }
+  }
+
+  /* finally do the division to get sc and tc */
+  const double sc = sN / sD;
+  const double tc = tN / tD;
+
+  vectorObj dP;
+  dP.x = w.x + (sc * u.x) - (tc * v.x);
+  dP.y = w.y + (sc * u.y) - (tc * v.y);
+
+  return (norm(dP));
+}
+
+double msDistancePointToShape(pointObj *point, shapeObj *shape) {
+  double d;
+
+  d = msSquareDistancePointToShape(point, shape);
+
+  return (sqrt(d));
+}
+
+/*
+** As msDistancePointToShape; avoid expensive sqrt calls
+*/
+double msSquareDistancePointToShape(pointObj *point, shapeObj *shape) {
+  int i, j;
+  double dist, minDist = -1;
+
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    for (j = 0; j < shape->numlines; j++) {
+      for (i = 0; i < shape->line[j].numpoints; i++) {
+        dist = msSquareDistancePointToPoint(point, &(shape->line[j].point[i]));
+        if ((dist < minDist) || (minDist < 0))
+          minDist = dist;
+      }
+    }
+    break;
+  case (MS_SHAPE_LINE):
+    for (j = 0; j < shape->numlines; j++) {
+      for (i = 1; i < shape->line[j].numpoints; i++) {
+        dist = msSquareDistancePointToSegment(
+            point, &(shape->line[j].point[i - 1]), &(shape->line[j].point[i]));
+        if ((dist < minDist) || (minDist < 0))
+          minDist = dist;
+      }
+    }
+    break;
+  case (MS_SHAPE_POLYGON):
+    if (msIntersectPointPolygon(point, shape))
+      minDist = 0; /* point is IN the shape */
+    else {         /* treat shape just like a line */
+      for (j = 0; j < shape->numlines; j++) {
+        for (i = 1; i < shape->line[j].numpoints; i++) {
+          dist = msSquareDistancePointToSegment(point,
+                                                &(shape->line[j].point[i - 1]),
+                                                &(shape->line[j].point[i]));
+          if ((dist < minDist) || (minDist < 0))
+            minDist = dist;
+        }
+      }
+    }
+    break;
+  default:
+    break;
+  }
+
+  return (minDist);
+}
+
+double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2) {
+  int i, j, k, l;
+  double dist, minDist = -1;
+
+  switch (shape1->type) {
+  case (MS_SHAPE_POINT): /* shape1 */
+    for (i = 0; i < shape1->numlines; i++) {
+      for (j = 0; j < shape1->line[i].numpoints; j++) {
+        dist =
+            msSquareDistancePointToShape(&(shape1->line[i].point[j]), shape2);
+        if ((dist < minDist) || (minDist < 0))
+          minDist = dist;
+      }
+    }
+    minDist = sqrt(minDist);
+    break;
+  case (MS_SHAPE_LINE): /* shape1 */
+    switch (shape2->type) {
+    case (MS_SHAPE_POINT):
+      for (i = 0; i < shape2->numlines; i++) {
+        for (j = 0; j < shape2->line[i].numpoints; j++) {
+          dist =
+              msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
+          if ((dist < minDist) || (minDist < 0))
+            minDist = dist;
+        }
+      }
+      minDist = sqrt(minDist);
+      break;
+    case (MS_SHAPE_LINE):
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
+                minDist = dist;
+            }
+          }
+        }
+      }
+      break;
+    case (MS_SHAPE_POLYGON):
+      /* shape2 (the polygon) could contain shape1 or one of it's parts       */
+      for (i = 0; i < shape1->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape1->line[0].point[0]), shape2) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
+
+      /* check segment intersection and, if necessary, distance between segments
+       */
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
+                minDist = dist;
+            }
+          }
+        }
+      }
+      break;
+    }
+    break;
+  case (MS_SHAPE_POLYGON): /* shape1 */
+    switch (shape2->type) {
+    case (MS_SHAPE_POINT):
+      for (i = 0; i < shape2->numlines; i++) {
+        for (j = 0; j < shape2->line[i].numpoints; j++) {
+          dist =
+              msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
+          if ((dist < minDist) || (minDist < 0))
+            minDist = dist;
+        }
+      }
+      minDist = sqrt(minDist);
+      break;
+    case (MS_SHAPE_LINE):
+      /* shape1 (the polygon) could contain shape2 or one of it's parts       */
+      for (i = 0; i < shape2->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
+
+      /* check segment intersection and, if necessary, distance between segments
+       */
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
+                minDist = dist;
+            }
+          }
+        }
+      }
+      break;
+    case (MS_SHAPE_POLYGON):
+      /* shape1 completely contains shape2 (only need to check one point from
+       * each part) */
+      for (i = 0; i < shape2->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
+
+      /* shape2 completely contains shape1 (only need to check one point from
+       * each part) */
+      for (i = 0; i < shape1->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape1->line[i].point[0]), shape2) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
+
+      /* check segment intersection and, if necessary, distance between segments
+       */
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
+                minDist = dist;
+            }
+          }
+        }
+      }
+      break;
+    }
+    break;
+  }
+
+  return (minDist);
+}
diff -pruN 8.0.1-5/src/mapserv-config.cpp 8.2.0~beta1-1~exp1/src/mapserv-config.cpp
--- 8.0.1-5/src/mapserv-config.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserv-config.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,211 @@
+/**********************************************************************
+ * $id$
+ *
+ * Project:  MapServer
+ * Purpose:  Config File Support
+ * Author:   Steve Lime and the MapServer team.
+ *
+ **********************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+#include "mapserver.h"
+#include "mapfile.h" // format shares a couple of tokens
+
+#include "cpl_conv.h"
+
+#include <string>
+
+extern "C" int msyylex(void);
+extern "C" void msyyrestart(FILE *);
+
+extern "C" FILE *msyyin;
+extern "C" int msyystate;
+extern "C" int msyylineno;
+extern "C" char *msyystring_buffer;
+
+static int initConfig(configObj *config) {
+  if (config == NULL) {
+    msSetError(MS_MEMERR, "Config object is NULL.", "initConfig()");
+    return MS_FAILURE;
+  }
+
+  if (initHashTable(&(config->env)) != MS_SUCCESS)
+    return MS_FAILURE;
+  if (initHashTable(&(config->maps)) != MS_SUCCESS)
+    return MS_FAILURE;
+  if (initHashTable(&(config->plugins)) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+void msFreeConfig(configObj *config) {
+  if (config == NULL)
+    return;
+  msFreeHashItems(&(config->env));
+  msFreeHashItems(&(config->maps));
+  msFreeHashItems(&(config->plugins));
+
+  msFree(config);
+}
+
+static int loadConfig(configObj *config) {
+  int token;
+
+  if (config == NULL)
+    return MS_FAILURE;
+
+  token = msyylex();
+  if (token != MS_CONFIG_SECTION) {
+    msSetError(MS_IDENTERR,
+               "First token must be CONFIG, this doesn't look like a mapserver "
+               "config file.",
+               "msLoadConfig()");
+    return MS_FAILURE;
+  }
+
+  for (;;) {
+    switch (msyylex()) {
+    case (MS_CONFIG_SECTION_ENV): {
+      if (loadHashTable(&(config->env)) != MS_SUCCESS)
+        return MS_FAILURE;
+      break;
+    }
+    case (MS_CONFIG_SECTION_MAPS):
+      if (loadHashTable(&config->maps) != MS_SUCCESS)
+        return MS_FAILURE;
+      break;
+    case (MS_CONFIG_SECTION_PLUGINS):
+      if (loadHashTable(&config->plugins) != MS_SUCCESS)
+        return MS_FAILURE;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "msLoadConfig()");
+      return MS_FAILURE;
+    case (END):
+      if (msyyin) {
+        fclose(msyyin);
+        msyyin = NULL;
+      }
+      return MS_SUCCESS;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "msLoadConfig()", msyystring_buffer, msyylineno);
+      return MS_FAILURE;
+    }
+  }
+}
+
+static void msConfigSetConfigOption(const char *key, const char *value) {
+  CPLSetConfigOption(key, value);
+  if (strcasecmp(key, "PROJ_DATA") == 0 || strcasecmp(key, "PROJ_LIB") == 0) {
+    msSetPROJ_DATA(value, nullptr);
+  }
+}
+
+configObj *msLoadConfig(const char *ms_config_file) {
+  configObj *config = NULL;
+
+  if (ms_config_file == NULL) {
+    // get config filename from environment
+    ms_config_file = getenv("MAPSERVER_CONFIG_FILE");
+  }
+
+  if (ms_config_file == NULL && MAPSERVER_CONFIG_FILE[0] != '\0') {
+    // Fallback to hardcoded file name
+    ms_config_file = MAPSERVER_CONFIG_FILE;
+  }
+
+  if (ms_config_file == NULL) {
+    msSetError(MS_MISCERR, "No config file set.", "msLoadConfig()");
+    return NULL;
+  }
+
+  config = (configObj *)calloc(sizeof(configObj), 1);
+  MS_CHECK_ALLOC(config, sizeof(configObj), NULL);
+
+  if (initConfig(config) != MS_SUCCESS) {
+    msFreeConfig(config);
+    return NULL;
+  }
+
+  msAcquireLock(TLOCK_PARSER);
+
+  if ((msyyin = fopen(ms_config_file, "r")) == NULL) {
+    msDebug("Cannot open configuration file %s.\n", ms_config_file);
+    msSetError(MS_IOERR,
+               "See mapserver.org/mapfile/config.html for more information.",
+               "msLoadConfig()");
+    msReleaseLock(TLOCK_PARSER);
+    msFreeConfig(config);
+    return NULL;
+  }
+
+  msyystate = MS_TOKENIZE_CONFIG;
+  msyylex(); // sets things up, but doesn't process any tokens
+
+  msyyrestart(msyyin); // start at line 1
+  msyylineno = 1;
+
+  if (loadConfig(config) != MS_SUCCESS) {
+    msFreeConfig(config);
+    msReleaseLock(TLOCK_PARSER);
+    if (msyyin) {
+      fclose(msyyin);
+      msyyin = NULL;
+    }
+    return NULL;
+  }
+  msReleaseLock(TLOCK_PARSER);
+
+  // load all env key/values using CPLSetConfigOption() - only do this *after*
+  // we have a good config
+  const char *key = msFirstKeyFromHashTable(&config->env);
+  if (key != NULL) {
+    msConfigSetConfigOption(key, msLookupHashTable(&config->env, key));
+
+    const char *last_key = key;
+    while ((key = msNextKeyFromHashTable(&config->env, last_key)) != NULL) {
+      msConfigSetConfigOption(key, msLookupHashTable(&config->env, key));
+      last_key = key;
+    }
+  }
+
+  return config;
+}
+
+const char *msConfigGetEnv(const configObj *config, const char *key) {
+  if (config == NULL || key == NULL)
+    return NULL;
+  return msLookupHashTable(&config->env, key);
+}
+
+const char *msConfigGetMap(const configObj *config, const char *key) {
+  if (config == NULL || key == NULL)
+    return NULL;
+  return msLookupHashTable(&config->maps, key);
+}
+
+const char *msConfigGetPlugin(const configObj *config, const char *key) {
+  if (config == NULL || key == NULL)
+    return NULL;
+  return msLookupHashTable(&config->plugins, key);
+}
diff -pruN 8.0.1-5/src/mapserv-config.h 8.2.0~beta1-1~exp1/src/mapserv-config.h
--- 8.0.1-5/src/mapserv-config.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserv-config.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,39 @@
+#ifndef MAPSERV_CONFIG_H
+#define MAPSERV_CONFIG_H
+
+#include "maphash.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+enum MS_CONFIG_SECTIONS {
+  MS_CONFIG_SECTION = 3000,
+  MS_CONFIG_SECTION_ENV,
+  MS_CONFIG_SECTION_MAPS,
+  MS_CONFIG_SECTION_PLUGINS
+};
+
+/**
+The :ref:`CONFIG <config>` object
+*/
+typedef struct {
+  hashTableObj env;     ///< Key-value pairs of environment variables and values
+  hashTableObj maps;    ///< Key-value pairs of Mapfile names and paths
+  hashTableObj plugins; ///< Key-value pairs of plugin names and paths
+} configObj;
+
+MS_DLL_EXPORT configObj *msLoadConfig(const char *ms_config_file);
+MS_DLL_EXPORT void msFreeConfig(configObj *config);
+MS_DLL_EXPORT const char *msConfigGetEnv(const configObj *config,
+                                         const char *key);
+MS_DLL_EXPORT const char *msConfigGetMap(const configObj *config,
+                                         const char *key);
+MS_DLL_EXPORT const char *msConfigGetPlugin(const configObj *config,
+                                            const char *key);
+
+#ifdef __cplusplus
+} /* extern C */
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/mapserver-api.c 8.2.0~beta1-1~exp1/src/mapserver-api.c
--- 8.0.1-5/src/mapserver-api.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserver-api.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,19 @@
+#include "mapserver.h"
+
+mapObj *umnms_new_map(char *filename) {
+  mapObj *map = NULL;
+  if (filename) {
+    map = msLoadMap(filename, NULL);
+  } else {
+    map = (mapObj *)msSmallCalloc(sizeof(mapObj), 1);
+    if (initMap(map) == -1) {
+      free(map);
+      return NULL;
+    }
+  }
+  return map;
+}
+layerObj *umnms_new_layer(mapObj *map);
+classObj *umnms_new_class(layerObj *layer);
+styleObj *umnms_new_style(classObj *theclass);
+labelObj *umnms_new_label(classObj *theclass);
diff -pruN 8.0.1-5/src/mapserver-api.h 8.2.0~beta1-1~exp1/src/mapserver-api.h
--- 8.0.1-5/src/mapserver-api.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserver-api.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,35 @@
+/*
+ * File:   mapserver-api.h
+ * Author: tbonfort
+ *
+ * Created on March 14, 2013, 1:12 PM
+ */
+
+#ifndef MAPSERVER_API_H
+#define MAPSERVER_API_H
+
+#include "mapserver-version.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct mapObj mapObj;
+typedef struct layerObj layerObj;
+typedef struct classObj classObj;
+typedef struct styleObj styleObj;
+typedef struct labelObj labelObj;
+typedef struct symbolObj symbolObj;
+typedef struct imageObj imageObj;
+
+mapObj *umnms_new_map(char *filename);
+layerObj *umnms_new_layer(mapObj *map);
+classObj *umnms_new_class(layerObj *layer);
+styleObj *umnms_new_style(classObj *theclass);
+labelObj *umnms_new_label(classObj *theclass);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPSERVER_API_H */
diff -pruN 8.0.1-5/src/mapserver-config-version.cmake.in 8.2.0~beta1-1~exp1/src/mapserver-config-version.cmake.in
--- 8.0.1-5/src/mapserver-config-version.cmake.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserver-config-version.cmake.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,11 @@
+set(PACKAGE_VERSION "@MapServer_VERSION_STRING@")
+
+# Check whether the requested PACKAGE_FIND_VERSION is compatible
+if("${PACKAGE_VERSION}" VERSION_LESS "${PACKAGE_FIND_VERSION}")
+  set(PACKAGE_VERSION_COMPATIBLE FALSE)
+else()
+  set(PACKAGE_VERSION_COMPATIBLE TRUE)
+  if ("${PACKAGE_VERSION}" VERSION_EQUAL "${PACKAGE_FIND_VERSION}")
+    set(PACKAGE_VERSION_EXACT TRUE)
+  endif()
+endif()
diff -pruN 8.0.1-5/src/mapserver-config.cmake.in 8.2.0~beta1-1~exp1/src/mapserver-config.cmake.in
--- 8.0.1-5/src/mapserver-config.cmake.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserver-config.cmake.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,18 @@
+# - Config file for the mapserver package
+# It defines the following variables
+#  MAPSERVER_INCLUDE_DIRS - include directories for mapserver
+#  MAPSERVER_LIBRARIES    - libraries to link against
+#  MAPSERVER_EXECUTABLES  - executables build for mapserver
+
+# Compute paths
+get_filename_component(MAPSERVER_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)
+set(MAPSERVER_INCLUDE_DIRS "@CONF_INCLUDE_DIRS@")
+
+# Our library dependencies (contains definitions for IMPORTED targets)
+if(NOT TARGET mapserver AND NOT MapServer_BINARY_DIR)
+  include("${MAPSERVER_CMAKE_DIR}/mapserverTargets.cmake")
+endif()
+
+# These are IMPORTED targets created by mapserverTargets.cmake
+set(MAPSERVER_LIBRARIES mapserver)
+set(MAPSERVER_EXECUTABLES sortshp shptree shptreevis msencrypt legend scalebar tile4ms shptreetst map2img mapserv)
diff -pruN 8.0.1-5/src/mapserver-config.h.in 8.2.0~beta1-1~exp1/src/mapserver-config.h.in
--- 8.0.1-5/src/mapserver-config.h.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserver-config.h.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+#ifndef _MAPSERVER_CONFIG_H
+#define _MAPSERVER_CONFIG_H
+
+#cmakedefine USE_PROJ 1
+#cmakedefine USE_PBF 1
+#cmakedefine USE_POSTGIS 1
+#cmakedefine USE_GDAL 1
+#cmakedefine USE_PIXMAN 1
+#cmakedefine USE_OGR 1
+#cmakedefine USE_WMS_SVR 1
+#cmakedefine USE_WCS_SVR 1
+#cmakedefine USE_WFS_SVR 1
+#cmakedefine USE_SOS_SVR 1
+#cmakedefine USE_OGCAPI_SVR 1
+#cmakedefine USE_WFS_LYR 1
+#cmakedefine USE_WMS_LYR 1
+#cmakedefine USE_CURL 1
+#cmakedefine USE_CAIRO 1
+#cmakedefine USE_GEOS 1
+#cmakedefine USE_GIF 1
+#cmakedefine USE_JPEG 1
+#cmakedefine USE_PNG 1
+#cmakedefine USE_ICONV 1
+#cmakedefine USE_FRIBIDI 1
+#cmakedefine USE_HARFBUZZ 1
+#cmakedefine USE_LIBXML2 1
+#cmakedefine USE_FASTCGI 1
+#cmakedefine USE_MYSQL 1
+#cmakedefine USE_THREAD 1
+#cmakedefine USE_KML 1
+#cmakedefine USE_ORACLESPATIAL 1
+#cmakedefine USE_EXEMPI 1
+#cmakedefine USE_XMLMAPFILE 1
+#cmakedefine USE_GENERIC_MS_NINT 1
+#cmakedefine POSTGIS_HAS_SERVER_VERSION 1
+#cmakedefine USE_SVG_CAIRO 1
+#cmakedefine USE_RSVG 1
+#cmakedefine USE_SDE 1
+#cmakedefine SDE64 1
+#cmakedefine USE_EXTENDED_DEBUG 1
+#cmakedefine USE_V8_MAPSCRIPT 1
+
+/*windows specific hacks*/
+#if defined(_WIN32)
+#cmakedefine REGEX_MALLOC 1
+#cmakedefine USE_GENERIC_MS_NINT 1
+#endif
+
+
+#cmakedefine HAVE_STRRSTR 1
+#cmakedefine HAVE_STRCASECMP 1
+#cmakedefine HAVE_STRCASESTR 1
+#cmakedefine HAVE_STRDUP 1
+#cmakedefine HAVE_STRLCAT 1
+#cmakedefine HAVE_STRLCPY 1
+#cmakedefine HAVE_STRLEN 1
+#cmakedefine HAVE_STRNCASECMP 1
+#cmakedefine HAVE_VSNPRINTF 1
+#cmakedefine HAVE_DLFCN_H 1
+
+#cmakedefine HAVE_LRINTF 1
+#cmakedefine HAVE_LRINT 1
+#cmakedefine HAVE_SYNC_FETCH_AND_ADD 1
+     
+
+#endif
diff -pruN 8.0.1-5/src/mapserver-version.h.in 8.2.0~beta1-1~exp1/src/mapserver-version.h.in
--- 8.0.1-5/src/mapserver-version.h.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserver-version.h.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,11 @@
+#ifndef _MAPSERVER_VERSION_H
+#define _MAPSERVER_VERSION_H
+
+#define MS_VERSION_MAJOR @MapServer_VERSION_MAJOR@
+#define MS_VERSION_MINOR @MapServer_VERSION_MINOR@
+#define MS_VERSION_REV @MapServer_VERSION_REVISION@
+#define MS_VERSION "@MapServer_VERSION_STRING@"
+#define MS_VERSION_NUM  @MapServer_VERSION_NUM@ 
+
+#endif
+
diff -pruN 8.0.1-5/src/mapserver.h 8.2.0~beta1-1~exp1/src/mapserver.h
--- 8.0.1-5/src/mapserver.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapserver.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4112 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Primary MapServer include file.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#ifndef MAP_H
+#define MAP_H
+
+#include "mapserver-config.h"
+
+/*
+** Main includes. If a particular header was needed by several .c files then
+** I just put it here. What the hell, it works and it's all right here. -SDL-
+*/
+#if defined(HAVE_STRCASESTR) && !defined(_GNU_SOURCE)
+#define _GNU_SOURCE /* Required for <string.h> strcasestr() defn */
+#endif
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+#include <time.h>
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <direct.h>
+#include <memory.h>
+#include <malloc.h>
+#include <process.h>
+#include <float.h>
+#else
+#include <unistd.h>
+#endif
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#define MS_DLL_EXPORT __declspec(dllexport)
+#define USE_MSFREE
+#else
+#define MS_DLL_EXPORT
+#endif
+
+#if defined(__GNUC__)
+#define WARN_UNUSED __attribute__((warn_unused_result))
+#define MS_LIKELY(x) __builtin_expect((x), 1)
+#define MS_UNLIKELY(x) __builtin_expect((x), 0)
+#else
+#define WARN_UNUSED
+#define MS_LIKELY(x) (x)
+#define MS_UNLIKELY(x) (x)
+#endif
+
+/* definition of  ms_int32/ms_uint32 */
+#include <limits.h>
+#ifndef _WIN32
+#include <stdint.h>
+#endif
+
+#ifdef _WIN32
+#ifndef SIZE_MAX
+#ifdef _WIN64
+#define SIZE_MAX _UI64_MAX
+#else
+#define SIZE_MAX UINT_MAX
+#endif
+#endif
+#endif
+
+#if ULONG_MAX == 0xffffffff
+typedef long ms_int32;
+typedef unsigned long ms_uint32;
+#elif UINT_MAX == 0xffffffff
+typedef int ms_int32;
+typedef unsigned int ms_uint32;
+#else
+typedef int32_t ms_int32;
+typedef uint32_t ms_uint32;
+#endif
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+/* Need to use _vsnprintf() with VS2003 */
+#define vsnprintf _vsnprintf
+#endif
+
+#include "mapserver-api.h"
+
+#ifndef SWIG
+/*forward declaration of rendering object*/
+typedef struct rendererVTableObj rendererVTableObj;
+typedef struct tileCacheObj tileCacheObj;
+typedef struct textPathObj textPathObj;
+typedef struct textRunObj textRunObj;
+typedef struct glyph_element glyph_element;
+typedef struct face_element face_element;
+#endif
+
+/* ms_bitarray is used by the bit mask in mapbit.c */
+typedef ms_uint32 *ms_bitarray;
+typedef const ms_uint32 *ms_const_bitarray;
+
+#include "maperror.h"
+#include "mapprimitive.h"
+#include "mapshape.h"
+#include "mapflatgeobuf.h"
+#include "mapsymbol.h"
+#include "maptree.h" /* quadtree spatial index */
+#include "maphash.h"
+#include "mapio.h"
+#include <assert.h>
+#include "mapproject.h"
+#include "cgiutil.h"
+#include "mapserv-config.h"
+
+#include <sys/types.h> /* regular expression support */
+
+/* The regex lib from the system and the regex lib from PHP needs to
+ * be separated here. We separate here via its directory location.
+ */
+#include "mapregex.h"
+
+#define CPL_SUPRESS_CPLUSPLUS
+#include "ogr_api.h"
+
+/* EQUAL and EQUALN are defined in cpl_port.h, so add them in here if ogr was
+ * not included */
+
+#ifndef EQUAL
+#if defined(_WIN32) || defined(WIN32CE)
+#define EQUAL(a, b) (stricmp(a, b) == 0)
+#else
+#define EQUAL(a, b) (strcasecmp(a, b) == 0)
+#endif
+#endif
+
+#ifndef EQUALN
+#if defined(_WIN32) || defined(WIN32CE)
+#define EQUALN(a, b, n) (strnicmp(a, b, n) == 0)
+#else
+#define EQUALN(a, b, n) (strncasecmp(a, b, n) == 0)
+#endif
+#endif
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#if (defined(_MSC_VER) && (_MSC_VER < 1900)) || !defined(_MSC_VER)
+#define snprintf _snprintf
+#endif
+#endif
+
+#ifdef __cplusplus
+#include <string>
+#include <vector>
+extern "C" {
+#endif
+
+// hide from swig or ruby will choke on the __FUNCTION__ name
+#ifndef SWIG
+/* Memory allocation check utility */
+#ifndef __FUNCTION__
+#define __FUNCTION__ "MapServer"
+#endif
+#endif
+
+#define MS_CHECK_ALLOC(var, size, retval)                                      \
+  if (!var) {                                                                  \
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",      \
+               __FUNCTION__, __FILE__, __LINE__, (unsigned int)(size));        \
+    return retval;                                                             \
+  }
+
+#define MS_CHECK_ALLOC_NO_RET(var, size)                                       \
+  if (!var) {                                                                  \
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",      \
+               __FUNCTION__, __FILE__, __LINE__, (unsigned int)(size));        \
+    return;                                                                    \
+  }
+
+/* General defines, wrapable */
+
+#define MS_TRUE 1 /* logical control variables */
+#define MS_FALSE 0
+#define MS_UNKNOWN -1
+#define MS_ON 1
+#define MS_OFF 0
+#define MS_DEFAULT 2
+#define MS_EMBED 3
+#define MS_DELETE 4
+#define MS_YES 1
+#define MS_NO 0
+
+/* Number of layer, class and style ptrs to alloc at once in the
+   corresponding msGrow...() functions. Replaces former MS_MAXLAYERS,
+   MS_MAXCLASSES and MS_MAXSTYLES with dynamic allocation (see RFC-17). */
+#define MS_LAYER_ALLOCSIZE 64
+#define MS_CLASS_ALLOCSIZE 8
+#define MS_STYLE_ALLOCSIZE 4
+#define MS_LABEL_ALLOCSIZE 2 /* not too common */
+
+#define MS_MAX_LABEL_PRIORITY 10
+#define MS_MAX_LABEL_FONTS 5
+#define MS_DEFAULT_LABEL_PRIORITY 1
+#define MS_LABEL_FORCE_GROUP 2 /* other values are MS_ON/MS_OFF */
+
+/* General defines, not wrapable */
+#ifndef SWIG
+#ifdef USE_XMLMAPFILE
+#define MS_DEFAULT_MAPFILE_PATTERN "\\.(map|xml)$"
+#define MS_DEFAULT_XMLMAPFILE_PATTERN "\\.xml$"
+#else
+#define MS_DEFAULT_MAPFILE_PATTERN "\\.map$"
+#endif
+#define MS_DEFAULT_CONTEXTFILE_PATTERN "\\.[Xx][Mm][Ll]$"
+#define MS_TEMPLATE_MAGIC_STRING "MapServer Template"
+#define MS_TEMPLATE_EXPR "\\.(xml|wml|html|htm|svg|kml|gml|js|tmpl)$"
+
+#define MS_INDEX_EXTENSION ".qix"
+
+#define MS_QUERY_RESULTS_MAGIC_STRING "MapServer Query Results"
+#define MS_QUERY_PARAMS_MAGIC_STRING "MapServer Query Params"
+#define MS_QUERY_EXTENSION ".qy"
+
+#define MS_DEG_TO_RAD .0174532925199432958
+#define MS_RAD_TO_DEG 57.29577951
+
+#define MS_DEFAULT_RESOLUTION 72
+
+#define MS_RED 0
+#define MS_GREEN 1
+#define MS_BLUE 2
+
+#define MS_MAXCOLORS 256
+
+#define MS_MISSING_DATA_IGNORE 0
+#define MS_MISSING_DATA_FAIL 1
+#define MS_MISSING_DATA_LOG 2
+
+#define MS_BUFFER_LENGTH 2048 /* maximum input line length */
+#define MS_URL_LENGTH 1024
+#define MS_MAXPATHLEN 1024
+
+#define MS_MAXIMAGESIZE_DEFAULT 4096
+
+#define MS_MAXPROJARGS 20
+#define MS_MAXJOINS 20
+#define MS_ITEMNAMELEN 32
+#define MS_NAMELEN 20
+
+#define MS_MINSYMBOLSIZE 0 /* in pixels */
+#define MS_MAXSYMBOLSIZE 500
+
+#define MS_MINSYMBOLWIDTH 0 /* in pixels */
+#define MS_MAXSYMBOLWIDTH 32
+
+#define MS_URL 0 /* template types */
+#define MS_FILE 1
+
+#define MS_MINFONTSIZE 4
+#define MS_MAXFONTSIZE 256
+
+#define MS_LABELCACHEINITSIZE 100
+#define MS_LABELCACHEINCREMENT 10
+
+#define MS_RESULTCACHEINITSIZE 10
+#define MS_RESULTCACHEINCREMENT 10
+
+#define MS_FEATUREINITSIZE                                                     \
+  10 /* how many points initially can a feature have                           \
+      */
+#define MS_FEATUREINCREMENT 10
+
+#define MS_EXPRESSION 2000 /* todo: make this an enum */
+#define MS_REGEX 2001
+#define MS_STRING 2002
+#define MS_NUMBER 2003
+#define MS_COMMENT 2004
+#define MS_IREGEX 2005
+#define MS_ISTRING 2006
+#define MS_BINDING 2007
+#define MS_LIST 2008
+
+/* string split flags */
+#define MS_HONOURSTRINGS 0x0001
+#define MS_ALLOWEMPTYTOKENS 0x0002
+#define MS_PRESERVEQUOTES 0x0004
+#define MS_PRESERVEESCAPES 0x0008
+#define MS_STRIPLEADSPACES 0x0010
+#define MS_STRIPENDSPACES 0x0020
+
+/* boolean options for the expression object. */
+#define MS_EXP_INSENSITIVE 1
+
+/* General macro definitions */
+#define MS_MIN(a, b) (((a) < (b)) ? (a) : (b))
+#define MS_MAX(a, b) (((a) > (b)) ? (a) : (b))
+#define MS_ABS(a) (((a) < 0) ? -(a) : (a))
+#define MS_SGN(a) (((a) < 0) ? -1 : 1)
+
+#define MS_STRING_IS_NULL_OR_EMPTY(s)                                          \
+  ((!s || s[0] == '\0') ? MS_TRUE : MS_FALSE)
+
+#define MS_NINT_GENERIC(x) ((x) >= 0.0 ? ((long)((x) + .5)) : ((long)((x)-.5)))
+
+#ifdef _MSC_VER
+#define msIsNan(x) _isnan(x)
+#else
+#define msIsNan(x) isnan(x)
+#endif
+
+/* see http://mega-nerd.com/FPcast/ for some discussion of fast
+   conversion to nearest int.  We avoid lrint() for now because it
+   would be hard to include math.h "properly". */
+
+#if defined(HAVE_LRINT) && !defined(USE_GENERIC_MS_NINT)
+#define MS_NINT(x) lrint(x)
+/*#   define MS_NINT(x) lround(x) */
+/* note that lrint rounds .5 to the nearest *even* integer, i.e.
+ * lrint(0.5)=0,lrint(1.5)=2 */
+#elif defined(_MSC_VER) && defined(_WIN32) && !defined(USE_GENERIC_MS_NINT)
+static __inline long int MS_NINT(double flt) {
+  int intgr;
+
+  _asm {
+      fld flt
+      fistp intgr
+  }
+  ;
+
+  return intgr;
+}
+#elif defined(i386) && defined(__GNUC_PREREQ) && !defined(USE_GENERIC_MS_NINT)
+static __inline long int MS_NINT(double __x) {
+  long int __lrintres;
+  __asm__ __volatile__("fistpl %0" : "=m"(__lrintres) : "t"(__x) : "st");
+  return __lrintres;
+}
+#else
+#define MS_NINT(x) MS_NINT_GENERIC(x)
+#endif
+
+/* #define MS_VALID_EXTENT(minx, miny, maxx, maxy)  (((minx<maxx) &&
+ * (miny<maxy))?MS_TRUE:MS_FALSE) */
+#define MS_VALID_EXTENT(rect)                                                  \
+  ((((rect).minx < (rect).maxx && (rect).miny < (rect).maxy)) ? MS_TRUE        \
+                                                              : MS_FALSE)
+#define MS_VALID_SEARCH_EXTENT(rect)                                           \
+  ((((rect).minx <= (rect).maxx && (rect).miny <= (rect).maxy)) ? MS_TRUE      \
+                                                                : MS_FALSE)
+
+#define MS_INIT_COLOR(color, r, g, b, a)                                       \
+  {                                                                            \
+    (color).red = r;                                                           \
+    (color).green = g;                                                         \
+    (color).blue = b;                                                          \
+    (color).alpha = a;                                                         \
+  }
+#define MS_VALID_COLOR(color)                                                  \
+  (((color).red == -1 || (color).green == -1 || (color).blue == -1) ? MS_FALSE \
+                                                                    : MS_TRUE)
+#define MS_COMPARE_COLOR(color1, color2)                                       \
+  (((color2).red == (color1).red && (color2).green == (color1).green &&        \
+    (color2).blue == (color1).blue)                                            \
+       ? MS_TRUE                                                               \
+       : MS_FALSE)
+#define MS_TRANSPARENT_COLOR(color)                                            \
+  (((color).alpha == 0 || (color).red == -255 || (color).green == -255 ||      \
+    (color).blue == -255)                                                      \
+       ? MS_TRUE                                                               \
+       : MS_FALSE)
+#define MS_COMPARE_COLORS(a, b)                                                \
+  (((a).red != (b).red || (a).green != (b).green || (a).blue != (b).blue)      \
+       ? MS_FALSE                                                              \
+       : MS_TRUE)
+#define MS_COLOR_GETRGB(color)                                                 \
+  (MS_VALID_COLOR(color)                                                       \
+       ? ((color).red * 0x10000 + (color).green * 0x100 + (color).blue)        \
+       : -1)
+
+#define MS_IMAGE_MIME_TYPE(format)                                             \
+  (format->mimetype ? format->mimetype : "unknown")
+#define MS_IMAGE_EXTENSION(format)                                             \
+  (format->extension ? format->extension : "unknown")
+#define MS_DRIVER_SWF(format) (strncasecmp((format)->driver, "swf", 3) == 0)
+#define MS_DRIVER_GDAL(format) (strncasecmp((format)->driver, "gdal/", 5) == 0)
+#define MS_DRIVER_IMAGEMAP(format)                                             \
+  (strncasecmp((format)->driver, "imagemap", 8) == 0)
+#define MS_DRIVER_AGG(format) (strncasecmp((format)->driver, "agg/", 4) == 0)
+#define MS_DRIVER_MVT(format) (strncasecmp((format)->driver, "mvt", 3) == 0)
+#define MS_DRIVER_CAIRO(format)                                                \
+  (strncasecmp((format)->driver, "cairo/", 6) == 0)
+#define MS_DRIVER_OGL(format) (strncasecmp((format)->driver, "ogl/", 4) == 0)
+#define MS_DRIVER_TEMPLATE(format)                                             \
+  (strncasecmp((format)->driver, "template", 8) == 0)
+
+#endif /*SWIG*/
+
+#define MS_RENDER_WITH_SWF 2
+#define MS_RENDER_WITH_RAWDATA 3
+#define MS_RENDER_WITH_IMAGEMAP 5
+#define MS_RENDER_WITH_TEMPLATE 8 /* query results only */
+#define MS_RENDER_WITH_OGR 16
+
+#define MS_RENDER_WITH_PLUGIN 100
+#define MS_RENDER_WITH_CAIRO_RASTER 101
+#define MS_RENDER_WITH_CAIRO_PDF 102
+#define MS_RENDER_WITH_CAIRO_SVG 103
+#define MS_RENDER_WITH_OGL 104
+#define MS_RENDER_WITH_AGG 105
+#define MS_RENDER_WITH_KML 106
+#define MS_RENDER_WITH_UTFGRID 107
+#define MS_RENDER_WITH_MVT 108
+
+#ifndef SWIG
+
+#define MS_RENDERER_SWF(format) ((format)->renderer == MS_RENDER_WITH_SWF)
+#define MS_RENDERER_RAWDATA(format)                                            \
+  ((format)->renderer == MS_RENDER_WITH_RAWDATA)
+#define MS_RENDERER_IMAGEMAP(format)                                           \
+  ((format)->renderer == MS_RENDER_WITH_IMAGEMAP)
+#define MS_RENDERER_TEMPLATE(format)                                           \
+  ((format)->renderer == MS_RENDER_WITH_TEMPLATE)
+#define MS_RENDERER_KML(format) ((format)->renderer == MS_RENDER_WITH_KML)
+#define MS_RENDERER_OGR(format) ((format)->renderer == MS_RENDER_WITH_OGR)
+#define MS_RENDERER_MVT(format) ((format)->renderer == MS_RENDER_WITH_MVT)
+
+#define MS_RENDERER_PLUGIN(format) ((format)->renderer > MS_RENDER_WITH_PLUGIN)
+
+#define MS_CELLSIZE(min, max, d)                                               \
+  (((max) - (min)) / ((d)-1)) /* where min/max are from an MapServer pixel     \
+                                 center-to-pixel center extent */
+#define MS_OWS_CELLSIZE(min, max, d)                                           \
+  (((max) - (min)) / (d)) /* where min/max are from an OGC pixel outside       \
+                             edge-to-pixel outside edge extent */
+#define MS_MAP2IMAGE_X(x, minx, cx) (MS_NINT(((x) - (minx)) / (cx)))
+#define MS_MAP2IMAGE_Y(y, maxy, cy) (MS_NINT(((maxy) - (y)) / (cy)))
+#define MS_IMAGE2MAP_X(x, minx, cx) ((minx) + (cx) * (x))
+#define MS_IMAGE2MAP_Y(y, maxy, cy) ((maxy) - (cy) * (y))
+
+/* these versions of MS_MAP2IMAGE takes 1/cellsize and is much faster */
+#define MS_MAP2IMAGE_X_IC(x, minx, icx) (MS_NINT(((x) - (minx)) * (icx)))
+#define MS_MAP2IMAGE_Y_IC(y, maxy, icy) (MS_NINT(((maxy) - (y)) * (icy)))
+#define MS_MAP2IMAGE_XCELL_IC(x, minx, icx) ((int)(((x) - (minx)) * (icx)))
+#define MS_MAP2IMAGE_YCELL_IC(y, maxy, icy) ((int)(((maxy) - (y)) * (icy)))
+
+#define MS_MAP2IMAGE_X_IC_DBL(x, minx, icx) (((x) - (minx)) * (icx))
+#define MS_MAP2IMAGE_Y_IC_DBL(y, maxy, icy) (((maxy) - (y)) * (icy))
+
+#define MS_MAP2IMAGE_X_IC_SNAP(x, minx, icx, res)                              \
+  ((MS_NINT(((x) - (minx)) * (icx) * (res))) / (res))
+#define MS_MAP2IMAGE_Y_IC_SNAP(y, maxy, icy, res)                              \
+  ((MS_NINT(((maxy) - (y)) * (icy) * (res))) / (res))
+
+/* For CARTO symbols */
+#define MS_PI 3.14159265358979323846
+#define MS_PI2 1.57079632679489661923  /* (MS_PI / 2) */
+#define MS_3PI2 4.71238898038468985769 /* (3 * MS_PI2) */
+#define MS_2PI 6.28318530717958647693  /* (2 * MS_PI) */
+
+#define MS_ENCRYPTION_KEY_SIZE 16 /* Key size: 128 bits = 16 bytes */
+
+#define GET_LAYER(map, pos) map->layers[pos]
+#define GET_CLASS(map, lid, cid) map->layers[lid]->class[cid]
+
+#ifdef USE_THREAD
+#if defined(HAVE_SYNC_FETCH_AND_ADD)
+#define MS_REFCNT_INCR(obj) __sync_fetch_and_add(&obj->refcount, +1)
+#define MS_REFCNT_DECR(obj) __sync_sub_and_fetch(&obj->refcount, +1)
+#define MS_REFCNT_INIT(obj) obj->refcount = 1, __sync_synchronize()
+#elif defined(_MSC_VER) && (defined(_M_IX86) || defined(_M_X64))
+#include <intrin.h>
+#pragma intrinsic(_InterlockedExchangeAdd)
+#if defined(_MSC_VER) && (_MSC_VER <= 1200)
+#define MS_REFCNT_INCR(obj)                                                    \
+  (_InterlockedExchangeAdd((long *)(&obj->refcount), (long)(+1)) + 1)
+#define MS_REFCNT_DECR(obj)                                                    \
+  (_InterlockedExchangeAdd((long *)(&obj->refcount), (long)(-1)) - 1)
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
+#else
+#define MS_REFCNT_INCR(obj)                                                    \
+  (_InterlockedExchangeAdd((volatile long *)(&obj->refcount), (long)(+1)) + 1)
+#define MS_REFCNT_DECR(obj)                                                    \
+  (_InterlockedExchangeAdd((volatile long *)(&obj->refcount), (long)(-1)) - 1)
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
+#endif
+#elif defined(__MINGW32__) && defined(__i386__)
+#define MS_REFCNT_INCR(obj)                                                    \
+  (InterlockedExchangeAdd((long *)(&obj->refcount), (long)(+1)) + 1)
+#define MS_REFCNT_DECR(obj)                                                    \
+  (InterlockedExchangeAdd((long *)(&obj->refcount), (long)(-1)) - 1)
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
+#else
+// unsafe fallback
+#define MS_REFCNT_INCR(obj) obj->refcount++
+#define MS_REFCNT_DECR(obj) (--(obj->refcount))
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
+#endif // close if defined(_MSC..
+#else  /*USE_THREAD*/
+#define MS_REFCNT_INCR(obj) obj->refcount++
+#define MS_REFCNT_DECR(obj) (--(obj->refcount))
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
+#endif /*USE_THREAD*/
+
+#define MS_REFCNT_DECR_IS_NOT_ZERO(obj) (MS_REFCNT_DECR(obj)) > 0
+#define MS_REFCNT_DECR_IS_ZERO(obj) (MS_REFCNT_DECR(obj)) <= 0
+
+#define MS_IS_VALID_ARRAY_INDEX(index, size)                                   \
+  ((index < 0 || index >= size) ? MS_FALSE : MS_TRUE)
+
+#define MS_CONVERT_UNIT(src_unit, dst_unit, value)                             \
+  (value * msInchesPerUnit(src_unit, 0) / msInchesPerUnit(dst_unit, 0))
+
+#define MS_INIT_INVALID_RECT                                                   \
+  { -1e300, -1e300, 1e300, 1e300 }
+
+#endif
+
+enum MS_NUM_CHECK_TYPES {
+  MS_NUM_CHECK_NONE = 0,
+  MS_NUM_CHECK_RANGE,
+  MS_NUM_CHECK_GT,
+  MS_NUM_CHECK_GTE
+};
+
+/* General enumerated types - needed by scripts */
+enum MS_FILE_TYPE { MS_FILE_MAP, MS_FILE_SYMBOL };
+enum MS_UNITS {
+  MS_INCHES,
+  MS_FEET,
+  MS_MILES,
+  MS_METERS,
+  MS_KILOMETERS,
+  MS_DD,
+  MS_PIXELS,
+  MS_PERCENTAGES,
+  MS_NAUTICALMILES,
+  MS_INHERIT = -1
+};
+enum MS_SHAPE_TYPE {
+  MS_SHAPE_POINT,
+  MS_SHAPE_LINE,
+  MS_SHAPE_POLYGON,
+  MS_SHAPE_NULL
+};
+enum MS_LAYER_TYPE {
+  MS_LAYER_POINT,
+  MS_LAYER_LINE,
+  MS_LAYER_POLYGON,
+  MS_LAYER_RASTER,
+  MS_LAYER_ANNOTATION /* only used for parser backwards compatibility */,
+  MS_LAYER_QUERY,
+  MS_LAYER_CIRCLE,
+  MS_LAYER_TILEINDEX,
+  MS_LAYER_CHART
+};
+enum MS_FONT_TYPE { MS_TRUETYPE, MS_BITMAP };
+enum MS_RENDER_MODE { MS_FIRST_MATCHING_CLASS, MS_ALL_MATCHING_CLASSES };
+
+#define MS_POSITIONS_LENGTH 14
+enum MS_POSITIONS_ENUM {
+  MS_UL = 101,
+  MS_LR,
+  MS_UR,
+  MS_LL,
+  MS_CR,
+  MS_CL,
+  MS_UC,
+  MS_LC,
+  MS_CC,
+  MS_AUTO,
+  MS_XY,
+  MS_NONE,
+  MS_AUTO2,
+  MS_FOLLOW
+};
+#define MS_TINY 5
+#define MS_SMALL 7
+#define MS_MEDIUM 10
+#define MS_LARGE 13
+#define MS_GIANT 16
+enum MS_QUERYMAP_STYLES { MS_NORMAL, MS_HILITE, MS_SELECTED };
+enum MS_CONNECTION_TYPE {
+  MS_INLINE,
+  MS_SHAPEFILE,
+  MS_TILED_SHAPEFILE,
+  MS_UNUSED_2,
+  MS_OGR,
+  MS_UNUSED_1,
+  MS_POSTGIS,
+  MS_WMS,
+  MS_ORACLESPATIAL,
+  MS_WFS,
+  MS_GRATICULE,
+  MS_MYSQL,
+  MS_RASTER,
+  MS_PLUGIN,
+  MS_UNION,
+  MS_UVRASTER,
+  MS_CONTOUR,
+  MS_KERNELDENSITY,
+  MS_IDW,
+  MS_FLATGEOBUF
+};
+#define IS_THIRDPARTY_LAYER_CONNECTIONTYPE(type)                               \
+  ((type) == MS_UNION || (type) == MS_KERNELDENSITY || (type) == MS_IDW)
+enum MS_JOIN_CONNECTION_TYPE {
+  MS_DB_XBASE,
+  MS_DB_CSV,
+  MS_DB_MYSQL,
+  MS_DB_ORACLE,
+  MS_DB_POSTGRES
+};
+enum MS_JOIN_TYPE { MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY };
+
+#define MS_SINGLE 0 /* modes for searching (spatial/database) */
+#define MS_MULTIPLE 1
+
+enum MS_QUERY_MODE { MS_QUERY_SINGLE, MS_QUERY_MULTIPLE };
+enum MS_QUERY_TYPE {
+  MS_QUERY_IS_NULL,
+  MS_QUERY_BY_POINT,
+  MS_QUERY_BY_RECT,
+  MS_QUERY_BY_SHAPE,
+  MS_QUERY_BY_ATTRIBUTE,
+  MS_QUERY_BY_INDEX,
+  MS_QUERY_BY_FILTER
+};
+
+enum MS_ALIGN_VALUE {
+  MS_ALIGN_DEFAULT,
+  MS_ALIGN_LEFT,
+  MS_ALIGN_CENTER,
+  MS_ALIGN_RIGHT
+};
+
+enum MS_CAPS_JOINS_AND_CORNERS {
+  MS_CJC_NONE,
+  MS_CJC_BEVEL,
+  MS_CJC_BUTT,
+  MS_CJC_MITER,
+  MS_CJC_ROUND,
+  MS_CJC_SQUARE,
+  MS_CJC_TRIANGLE
+};
+
+#define MS_CJC_DEFAULT_CAPS MS_CJC_ROUND
+#define MS_CJC_DEFAULT_JOINS MS_CJC_NONE
+#define MS_CJC_DEFAULT_JOIN_MAXSIZE 3
+
+enum MS_RETURN_VALUE { MS_SUCCESS, MS_FAILURE, MS_DONE };
+enum MS_IMAGEMODE {
+  MS_IMAGEMODE_PC256,
+  MS_IMAGEMODE_RGB,
+  MS_IMAGEMODE_RGBA,
+  MS_IMAGEMODE_INT16,
+  MS_IMAGEMODE_FLOAT32,
+  MS_IMAGEMODE_BYTE,
+  MS_IMAGEMODE_FEATURE,
+  MS_IMAGEMODE_NULL
+};
+
+enum MS_GEOS_OPERATOR {
+  MS_GEOS_EQUALS,
+  MS_GEOS_DISJOINT,
+  MS_GEOS_TOUCHES,
+  MS_GEOS_OVERLAPS,
+  MS_GEOS_CROSSES,
+  MS_GEOS_INTERSECTS,
+  MS_GEOS_WITHIN,
+  MS_GEOS_CONTAINS,
+  MS_GEOS_BEYOND,
+  MS_GEOS_DWITHIN
+};
+#define MS_FILE_DEFAULT MS_FILE_MAP
+
+#if defined(_MSC_VER) && (_MSC_VER <= 1310)
+#define MS_DEBUG msDebug2
+#else
+#ifdef USE_EXTENDED_DEBUG
+#define MS_DEBUG(level, elt, fmt, ...)                                         \
+  if ((elt)->debug >= (level))                                                 \
+  msDebug(fmt, ##__VA_ARGS__)
+#else
+#define MS_DEBUG(level, elt, fmt, ...) /* no-op */
+#endif
+#endif
+
+/* coordinate to pixel simplification modes, used in msTransformShape */
+enum MS_TRANSFORM_MODE {
+  MS_TRANSFORM_NONE,  /* no geographic to pixel transformation */
+  MS_TRANSFORM_ROUND, /* round to integer, might create degenerate geometries
+                         (used for GD)*/
+  MS_TRANSFORM_SNAPTOGRID, /* snap to a grid, should be user configurable in the
+                              future*/
+  MS_TRANSFORM_FULLRESOLUTION, /* keep full resolution */
+  MS_TRANSFORM_SIMPLIFY        /* keep full resolution */
+};
+
+typedef enum {
+  MS_COMPOP_CLEAR,
+  MS_COMPOP_SRC,
+  MS_COMPOP_DST,
+  MS_COMPOP_SRC_OVER,
+  MS_COMPOP_DST_OVER,
+  MS_COMPOP_SRC_IN,
+  MS_COMPOP_DST_IN,
+  MS_COMPOP_SRC_OUT,
+  MS_COMPOP_DST_OUT,
+  MS_COMPOP_SRC_ATOP,
+  MS_COMPOP_DST_ATOP,
+  MS_COMPOP_XOR,
+  MS_COMPOP_PLUS,
+  MS_COMPOP_MINUS,
+  MS_COMPOP_MULTIPLY,
+  MS_COMPOP_SCREEN,
+  MS_COMPOP_OVERLAY,
+  MS_COMPOP_DARKEN,
+  MS_COMPOP_LIGHTEN,
+  MS_COMPOP_COLOR_DODGE,
+  MS_COMPOP_COLOR_BURN,
+  MS_COMPOP_HARD_LIGHT,
+  MS_COMPOP_SOFT_LIGHT,
+  MS_COMPOP_DIFFERENCE,
+  MS_COMPOP_EXCLUSION,
+  MS_COMPOP_CONTRAST,
+  MS_COMPOP_INVERT,
+  MS_COMPOP_INVERT_RGB
+} CompositingOperation;
+
+typedef struct _CompositingFilter {
+  char *filter;
+  struct _CompositingFilter *next;
+} CompositingFilter;
+
+typedef struct _LayerCompositer {
+  CompositingOperation comp_op;
+  int opacity;
+  CompositingFilter *filter;
+  struct _LayerCompositer *next;
+} LayerCompositer;
+
+#ifndef SWIG
+/* Filter object */
+typedef enum {
+  FILTER_NODE_TYPE_UNDEFINED = -1,
+  FILTER_NODE_TYPE_LOGICAL = 0,
+  FILTER_NODE_TYPE_SPATIAL = 1,
+  FILTER_NODE_TYPE_COMPARISON = 2,
+  FILTER_NODE_TYPE_PROPERTYNAME = 3,
+  FILTER_NODE_TYPE_BBOX = 4,
+  FILTER_NODE_TYPE_LITERAL = 5,
+  FILTER_NODE_TYPE_BOUNDARY = 6,
+  FILTER_NODE_TYPE_GEOMETRY_POINT = 7,
+  FILTER_NODE_TYPE_GEOMETRY_LINE = 8,
+  FILTER_NODE_TYPE_GEOMETRY_POLYGON = 9,
+  FILTER_NODE_TYPE_FEATUREID = 10,
+  FILTER_NODE_TYPE_TEMPORAL = 11,
+  FILTER_NODE_TYPE_TIME_PERIOD = 12
+} FilterNodeType;
+
+/************************************************************************/
+/*                          FilterEncodingNode                          */
+/************************************************************************/
+
+typedef struct _FilterNode {
+  FilterNodeType eType;
+  char *pszValue;
+  void *pOther;
+  char *pszSRS;
+  struct _FilterNode *psLeftNode;
+  struct _FilterNode *psRightNode;
+} FilterEncodingNode;
+#endif /*SWIG*/
+
+/* Define supported bindings here (only covers existing bindings at first). Not
+ * accessible directly using MapScript. */
+#define MS_STYLE_BINDING_LENGTH 12
+enum MS_STYLE_BINDING_ENUM {
+  MS_STYLE_BINDING_SIZE,
+  MS_STYLE_BINDING_WIDTH,
+  MS_STYLE_BINDING_ANGLE,
+  MS_STYLE_BINDING_COLOR,
+  MS_STYLE_BINDING_OUTLINECOLOR,
+  MS_STYLE_BINDING_SYMBOL,
+  MS_STYLE_BINDING_OUTLINEWIDTH,
+  MS_STYLE_BINDING_OPACITY,
+  MS_STYLE_BINDING_OFFSET_X,
+  MS_STYLE_BINDING_OFFSET_Y,
+  MS_STYLE_BINDING_POLAROFFSET_PIXEL,
+  MS_STYLE_BINDING_POLAROFFSET_ANGLE
+};
+#define MS_LABEL_BINDING_LENGTH 12
+enum MS_LABEL_BINDING_ENUM {
+  MS_LABEL_BINDING_SIZE,
+  MS_LABEL_BINDING_ANGLE,
+  MS_LABEL_BINDING_COLOR,
+  MS_LABEL_BINDING_OUTLINECOLOR,
+  MS_LABEL_BINDING_FONT,
+  MS_LABEL_BINDING_PRIORITY,
+  MS_LABEL_BINDING_POSITION,
+  MS_LABEL_BINDING_SHADOWSIZEX,
+  MS_LABEL_BINDING_SHADOWSIZEY,
+  MS_LABEL_BINDING_OFFSET_X,
+  MS_LABEL_BINDING_OFFSET_Y,
+  MS_LABEL_BINDING_ALIGN
+};
+
+/************************************************************************/
+/*                         attributeBindingObj                          */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  char *item;
+  int index;
+} attributeBindingObj;
+#endif /*SWIG*/
+
+/************************************************************************/
+/*                             labelPathObj                             */
+/*                                                                      */
+/*      Label path object - used to hold path and bounds of curved      */
+/*      labels - Bug #1620 implementation.                              */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  multipointObj path;
+  shapeObj bounds;
+  double *angles;
+} labelPathObj;
+#endif /*SWIG*/
+
+/************************************************************************/
+/*                              fontSetObj                              */
+/*                                                                      */
+/*      used to hold aliases for TRUETYPE fonts                         */
+/************************************************************************/
+
+/**
+The :ref:`FONTSET <fontset>` object
+*/
+typedef struct {
+#ifdef SWIG
+    %immutable;
+#endif
+  char *filename;     ///< The filename of the fonset
+  int numfonts;       ///< The number of fonts in the fontset
+  hashTableObj fonts; ///< Key, value pairs of font name and font file
+#ifdef SWIG
+    %mutable;
+#endif
+
+#ifndef SWIG
+  struct mapObj *map;
+#endif
+} fontSetObj;
+
+/************************************************************************/
+/*                         featureListNodeObj                           */
+/*                                                                      */
+/*      for inline features, shape caches and queries                   */
+/************************************************************************/
+#ifndef SWIG
+typedef struct listNode {
+  shapeObj shape;
+  struct listNode *next;
+  struct listNode *tailifhead; /* this is the tail node in the list, if this is
+                                  the head element, otherwise NULL */
+} featureListNodeObj;
+
+typedef featureListNodeObj *featureListNodeObjPtr;
+#endif
+
+/************************************************************************/
+/*                              paletteObj                              */
+/*                                                                      */
+/*      used to hold colors while a map file is read                    */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  colorObj colors[MS_MAXCOLORS - 1];
+  int colorvalue[MS_MAXCOLORS - 1];
+  int numcolors;
+} paletteObj;
+#endif
+
+/************************************************************************/
+/*                     expressionObj & tokenObj                         */
+/************************************************************************/
+
+enum MS_TOKEN_LOGICAL_ENUM {
+  MS_TOKEN_LOGICAL_AND = 300,
+  MS_TOKEN_LOGICAL_OR,
+  MS_TOKEN_LOGICAL_NOT
+};
+enum MS_TOKEN_LITERAL_ENUM {
+  MS_TOKEN_LITERAL_NUMBER = 310,
+  MS_TOKEN_LITERAL_STRING,
+  MS_TOKEN_LITERAL_TIME,
+  MS_TOKEN_LITERAL_SHAPE,
+  MS_TOKEN_LITERAL_BOOLEAN
+};
+enum MS_TOKEN_COMPARISON_ENUM {
+  MS_TOKEN_COMPARISON_EQ = 320,
+  MS_TOKEN_COMPARISON_NE,
+  MS_TOKEN_COMPARISON_GT,
+  MS_TOKEN_COMPARISON_LT,
+  MS_TOKEN_COMPARISON_LE,
+  MS_TOKEN_COMPARISON_GE,
+  MS_TOKEN_COMPARISON_IEQ,
+  MS_TOKEN_COMPARISON_RE,
+  MS_TOKEN_COMPARISON_IRE,
+  MS_TOKEN_COMPARISON_IN,
+#ifdef MAPSERVER_BUILD
+  MS_TOKEN_COMPARISON_LIKE_is_unused,
+#else
+  MS_TOKEN_COMPARISON_LIKE,
+#endif
+  MS_TOKEN_COMPARISON_INTERSECTS,
+  MS_TOKEN_COMPARISON_DISJOINT,
+  MS_TOKEN_COMPARISON_TOUCHES,
+  MS_TOKEN_COMPARISON_OVERLAPS,
+  MS_TOKEN_COMPARISON_CROSSES,
+  MS_TOKEN_COMPARISON_WITHIN,
+  MS_TOKEN_COMPARISON_CONTAINS,
+  MS_TOKEN_COMPARISON_EQUALS,
+  MS_TOKEN_COMPARISON_BEYOND,
+  MS_TOKEN_COMPARISON_DWITHIN
+};
+enum MS_TOKEN_FUNCTION_ENUM {
+  MS_TOKEN_FUNCTION_LENGTH = 350,
+  MS_TOKEN_FUNCTION_TOSTRING,
+  MS_TOKEN_FUNCTION_COMMIFY,
+  MS_TOKEN_FUNCTION_AREA,
+  MS_TOKEN_FUNCTION_ROUND,
+  MS_TOKEN_FUNCTION_FROMTEXT,
+  MS_TOKEN_FUNCTION_BUFFER,
+  MS_TOKEN_FUNCTION_DIFFERENCE,
+  MS_TOKEN_FUNCTION_SIMPLIFY,
+  MS_TOKEN_FUNCTION_SIMPLIFYPT,
+  MS_TOKEN_FUNCTION_GENERALIZE,
+  MS_TOKEN_FUNCTION_SMOOTHSIA,
+  MS_TOKEN_FUNCTION_CENTERLINE,
+  MS_TOKEN_FUNCTION_DENSIFY,
+  MS_TOKEN_FUNCTION_OUTER,
+  MS_TOKEN_FUNCTION_INNER,
+  MS_TOKEN_FUNCTION_JAVASCRIPT,
+  MS_TOKEN_FUNCTION_UPPER,
+  MS_TOKEN_FUNCTION_LOWER,
+  MS_TOKEN_FUNCTION_INITCAP,
+  MS_TOKEN_FUNCTION_FIRSTCAP
+};
+enum MS_TOKEN_BINDING_ENUM {
+  MS_TOKEN_BINDING_DOUBLE = 380,
+  MS_TOKEN_BINDING_INTEGER,
+  MS_TOKEN_BINDING_STRING,
+  MS_TOKEN_BINDING_TIME,
+  MS_TOKEN_BINDING_SHAPE,
+  MS_TOKEN_BINDING_MAP_CELLSIZE,
+  MS_TOKEN_BINDING_DATA_CELLSIZE
+};
+enum MS_PARSE_TYPE_ENUM {
+  MS_PARSE_TYPE_BOOLEAN,
+  MS_PARSE_TYPE_STRING,
+  MS_PARSE_TYPE_SHAPE,
+  MS_PARSE_TYPE_SLD
+};
+
+#ifndef SWIG
+typedef union {
+  int intval;
+  char *strval;
+  shapeObj *shpval;
+} parseResultObj;
+
+typedef union {
+  double dblval;
+  int intval;
+  char *strval;
+  struct tm tmval;
+  shapeObj *shpval;
+  attributeBindingObj bindval;
+} tokenValueObj;
+
+typedef struct tokenListNode {
+  int token;
+  tokenValueObj tokenval;
+  char *tokensrc; /* on occassion we may want to access to the original source
+                     string (e.g. date/time) */
+  struct tokenListNode *next;
+  struct tokenListNode *tailifhead; /* this is the tail node in the list if this
+                                       is the head element, otherwise NULL */
+} tokenListNodeObj;
+
+typedef tokenListNodeObj *tokenListNodeObjPtr;
+
+typedef struct {
+  char *string;
+  int type;
+  /* container for expression options such as case-insensitiveness */
+  /* This is a boolean container. */
+  int flags;
+
+  /* logical expression options */
+  tokenListNodeObjPtr tokens;
+  tokenListNodeObjPtr curtoken;
+
+  /* regular expression options */
+  ms_regex_t regex; /* compiled regular expression to be matched */
+  int compiled;
+
+  char *native_string; /* RFC 91 */
+} expressionObj;
+
+typedef struct {
+  colorObj *pixel;     /* for raster layers */
+  shapeObj *shape;     /* for vector layers */
+  double dblval;       /* for map cellsize used by simplify */
+  double dblval2;      /* for data cellsize */
+  expressionObj *expr; /* expression to be evaluated (contains tokens) */
+  int type; /* type of parse: boolean, string/text or shape/geometry */
+  parseResultObj result; /* parse result */
+} parseObj;
+#endif
+
+/************************************************************************/
+/*                          clusterObj                                  */
+/************************************************************************/
+
+/**
+The :ref:`CLUSTER <cluster>` object. See :ref:`RFC 69 <rfc69>`.
+*/
+typedef struct {
+  double maxdistance; ///< Maximum distance between clusters - see
+                      ///< :ref:`MAXDISTANCE <mapfile-cluster-maxdistance>`
+  double buffer;      ///< The buffer size around the selection area - see
+                      ///< :ref:`BUFFER <mapfile-cluster-buffer>`
+  char *region; ///< The type of the cluster region (rectangle or ellipse) - see
+                ///< :ref:`REGION <mapfile-cluster-region>`
+#ifndef SWIG
+  expressionObj group;  /* expression to identify the groups */
+  expressionObj filter; /* expression for filtering the shapes */
+#endif
+} clusterObj;
+
+/************************************************************************/
+/*                          processingParams                            */
+/************************************************************************/
+
+#ifndef SWIG
+/* Used by idw.c and kerneldensity.c */
+typedef struct {
+  float normalization_scale;
+  int expand_searchrect;
+  int radius;
+  float power;
+} interpolationProcessingParams;
+#endif
+
+/************************************************************************/
+/*                               joinObj                                */
+/*                                                                      */
+/*      simple way to access other XBase files, one-to-one or           */
+/*      one-to-many supported                                           */
+/************************************************************************/
+
+#ifndef SWIG
+typedef struct {
+  char *name;
+  char **items, **values; /* items/values (process 1 record at a time) */
+  int numitems;
+
+  char *table;
+  char *from, *to; /* item names */
+
+  void *joininfo; /* vendor specific (i.e. XBase, MySQL, etc.) stuff to allow
+                     for persistent access */
+
+  char *header, *footer;
+#ifndef __cplusplus
+  char *template;
+#else
+  char *_template;
+#endif
+
+  enum MS_JOIN_TYPE type;
+  char *connection;
+  enum MS_JOIN_CONNECTION_TYPE connectiontype;
+} joinObj;
+#endif
+
+/************************************************************************/
+/*                           outputFormatObj                            */
+/*                                                                      */
+/*      see mapoutput.c for most related code.                          */
+/************************************************************************/
+
+/**
+The :ref:`OUTPUTFORMAT <outputformat>` object
+*/
+typedef struct {
+#ifndef SWIG
+  int refcount;
+  char **formatoptions;
+  rendererVTableObj *vtable;
+  void *device; /* for supporting direct rendering onto a device context */
+#endif          /* SWIG */
+#ifdef SWIG
+    %immutable;
+#endif /* SWIG */
+
+  /**
+  The number of option values set on this format - can be used to
+  iterate over the options array in conjunction with
+  :func:`outputFormatObj.getOptionAt`
+  */
+  int numformatoptions;
+
+#ifdef SWIG
+    %mutable;
+#endif             /* SWIG */
+  char *name;      ///< See :ref:`NAME <mapfile-outputformat-name>`
+  char *mimetype;  ///< See :ref:`MIMETYPE <mapfile-outputformat-mimetype>`
+  char *driver;    ///< See :ref:`DRIVER <mapfile-outputformat-driver>`
+  char *extension; ///< See :ref:`EXTENSION <mapfile-outputformat-extension>`
+  int renderer;  ///< A :ref:`render mode constant<mapfile-constants-render>` -
+                 ///< normally set internally based on the driver and some other
+                 ///< setting in the constructor.
+  int imagemode; ///< An :ref:`Image mode constant<mapfile-constants-imagemode>`
+                 ///< - see :ref:`IMAGEMODE <mapfile-outputformat-imagemode>`
+  int transparent; ///< See :ref:`TRANSPARENT
+                   ///< <mapfile-outputformat-transparent>`
+  int bands;       ///< The number of bands in the raster, normally set via the
+             ///< BAND_COUNT formatoption - this field should be considered
+             ///< read-only Only used for the "raw" modes, MS_IMAGEMODE_BYTE,
+             ///< MS_IMAGEMODE_INT16, and MS_IMAGEMODE_FLOAT32
+  int inmapfile; ///< Boolean value indicating if the format is in the Mapfile
+} outputFormatObj;
+
+/* The following is used for "don't care" values in transparent, interlace and
+   imagequality values. */
+#define MS_NOOVERRIDE -1111
+
+/************************************************************************/
+/*                             queryObj                                 */
+/*                                                                      */
+/*      encapsulates the information necessary to perform a query       */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  int type; /* MS_QUERY_TYPE */
+  int mode; /* MS_QUERY_MODE */
+
+  int layer;
+
+  pointObj point; /* by point */
+  double buffer;
+  int maxresults;
+
+  rectObj rect;    /* by rect */
+  shapeObj *shape; /* by shape & operator (OGC filter) */
+
+  long shapeindex; /* by index */
+  long tileindex;
+  int clear_resultcache;
+
+  int maxfeatures; /* global maxfeatures */
+  int startindex;
+  int only_cache_result_count; /* set to 1 sometimes by WFS 2.0 GetFeature
+                                  request */
+
+  expressionObj filter; /* by filter */
+  char *filteritem;
+
+  int slayer; /* selection layer, used for msQueryByFeatures() (note this is not
+                 a query mode per se) */
+
+  int cache_shapes;           /* whether to cache shapes in resultCacheObj */
+  int max_cached_shape_count; /* maximum number of shapes cached in the total
+                                 number of resultCacheObj */
+  int max_cached_shape_ram_amount; /* maximum number of bytes taken by shapes
+                                      cached in the total number of
+                                      resultCacheObj */
+} queryObj;
+#endif
+
+/************************************************************************/
+/*                             queryMapObj                              */
+/*                                                                      */
+/*      used to visualize query results                                 */
+/************************************************************************/
+
+/**
+The :ref:`QUERYMAP <querymap>` object.
+Instances of querymapObj are always are always embedded inside the
+:class:`mapObj`.
+*/
+typedef struct {
+#ifdef SWIG
+    %immutable;
+#endif                /* SWIG */
+  struct mapObj *map; ///< Reference to parent :class:`mapObj`
+#ifdef SWIG
+    %mutable;
+#endif            /* SWIG */
+  int height;     ///< See :ref:`SIZE <mapfile-querymap-size>`
+  int width;      ///< See :ref:`SIZE <mapfile-querymap-size>`
+  int status;     ///< See :ref:`STATUS <mapfile-querymap-status>`
+  int style;      ///< ``HILITE``, ``SELECTED`` or ``NORMAL`` - see :ref:`STYLE
+                  ///< <mapfile-querymap-style>`
+  colorObj color; ///< See :ref:`COLOR <mapfile-querymap-color>`
+} queryMapObj;
+
+/************************************************************************/
+/*                                webObj                                */
+/*                                                                      */
+/*      holds parameters for a mapserver/mapscript interface            */
+/************************************************************************/
+
+/**
+The :ref:`WEB <web>` object.
+Has no other existence than as an attribute of a :class:`mapObj`.
+Serves as a container for various run-time web application definitions like
+temporary file paths, template paths, etc.
+*/
+typedef struct {
+
+#ifdef SWIG
+      %immutable;
+#endif                     /* SWIG */
+  hashTableObj metadata;   ///< Metadata hash table - see :ref:`METADATA
+                           ///< <mapfile-web-metadata>`
+  hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-web-validation>`
+  struct mapObj *map;      ///< Reference to parent :class:`mapObj`
+
+#ifdef SWIG
+      %mutable;
+#endif /* SWIG */
+
+  char *imagepath; ///< Filesystem path to temporary image location - see
+                   ///< :ref:`IMAGEPATH <mapfile-web-imagepath>`
+  char *imageurl;  ///< URL to temporary image location - see :ref:`IMAGEURL
+                   ///< <mapfile-web-imageurl>`
+  char *temppath;  ///< See :ref:`TEMPPATH <mapfile-web-temppath>`
+  char *header;    ///< Path to header document - see :ref:`HEADER
+                   ///< <mapfile-web-header>`
+  char *footer;    ///< Path to footer document - see :ref:`FOOTER
+                   ///< <mapfile-web-footer>`
+  char *empty;     ///< See :ref:`EMPTY <mapfile-web-empty>`
+  char *error;     ///< Error handling - see :ref:`ERROR <mapfile-web-error>`
+
+  double minscaledenom; ///< Maximum map scale - see :ref:`MINSCALEDENOM
+                        ///< <mapfile-web-minscaledenom>`
+  double maxscaledenom; ///< Minimum map scale - see :ref:`MAXSCALEDENOM
+                        ///< <mapfile-web-maxscaledenom>`
+  char *mintemplate;    ///< See :ref:`MINTEMPLATE <mapfile-web-mintemplate>`
+  char *maxtemplate;    ///< See :ref:`MAXTEMPLATE <mapfile-web-maxtemplate>`
+
+  char *queryformat;  ///< See :ref:`QUERYFORMAT <mapfile-web-queryformat>` /*
+                      ///< what format is the query to be returned, given as a
+                      ///< MIME type */
+  char *legendformat; ///< See :ref:`LEGENDFORMAT <mapfile-web-legendformat>`
+  char *browseformat; ///< See :ref:`BROWSEFORMAT <mapfile-web-browseformat>`
+
+#ifndef __cplusplus
+  char *template; ///< Path to template document - see :ref:`TEMPLATE
+                  ///< <mapfile-web-template>`
+#else
+  char *_template;
+#endif
+
+} webObj;
+
+/************************************************************************/
+/*                               styleObj                               */
+/*                                                                      */
+/*      holds parameters for symbolization, multiple styles may be      */
+/*      applied within a classObj                                       */
+/************************************************************************/
+
+/**
+The :ref:`STYLE <style>` object. An instance of styleObj is associated with one
+instance of :class:`classObj`.
+*/
+struct styleObj {
+
+#ifndef SWIG
+  /* private vars for rfc 48 & 64 */
+  expressionObj _geomtransform;
+  double scalefactor; // computed, not set
+  attributeBindingObj bindings[MS_STYLE_BINDING_LENGTH];
+  int numbindings;
+  expressionObj exprBindings[MS_STYLE_BINDING_LENGTH];
+  int nexprbindings;
+#endif
+
+#ifdef SWIG
+    %immutable;
+#endif /* SWIG */
+
+  int refcount;     ///< number of references to this object
+  char *symbolname; ///< Name of the style's symbol - see :ref:`symbolname
+                    ///< <mapfile-style-symbol>`
+
+#ifdef SWIG
+    %mutable;
+#endif /* SWIG */
+
+#if defined(SWIG) && defined(SWIGPYTHON)
+  /* would probably make sense to mark it immutable for other binding languages
+   * than Python */
+  // clang-format off
+  %immutable;
+// clang-format on
+#endif
+  int patternlength; ///< Number of elements in the pattern attribute
+#if defined(SWIG) && defined(SWIGPYTHON)
+  // clang-format off
+  %mutable;
+// clang-format on
+#endif
+
+#if !(defined(SWIG) &&                                                         \
+      defined(SWIGPYTHON)) /* in Python we use a special typemap for this */
+  double pattern[MS_MAXPATTERNLENGTH]; ///< List of on, off values to define a
+                                       ///< dash pattern for line work (lines,
+                                       ///< polygon outlines, hatch lines)
+#endif
+
+  double angle; ///< Angle, given in degrees, to draw the line work, default is
+                ///< 0, for symbols of Type HATCH, this is the angle of the
+                ///< hatched lines - see :ref:`ANGLE <mapfile-style-angle>`
+  /*should an angle be automatically computed*/
+  int autoangle; ///< If the angle is set to ``AUTO`` - see :ref:`ANGLE
+                 ///< <mapfile-style-angle>`
+
+  /* should lines be drawn with antialiasing (default)? */
+  int antialiased; ///< See :ref:`ANTIALIAS <mapfile-style-antialias>`
+
+  colorObj color;        ///< Foreground or fill pen color - see :ref:`COLOR
+                         ///< <mapfile-style-color>`
+  colorObj outlinecolor; ///< Outline pen color - see :ref:`OUTLINECOLOR
+                         ///< <mapfile-style-outlinecolor>`
+
+  int opacity; ///< See :ref:`OPACITY <mapfile-style-opacity>`
+
+  /* Stuff to handle Color Range Styles */
+  colorObj mincolor; ///< Minimum color in the :ref:`COLORRANGE
+                     ///< <mapfile-style-colorrange>`
+  colorObj maxcolor; ///< Maximum color in the :ref:`COLORRANGE
+                     ///< <mapfile-style-colorrange>`
+  double minvalue;   ///< related to color ranges
+  double maxvalue;   ///< related to color ranges
+  char *
+      rangeitem; ///< Attribute/field that stores the values for the Color Range
+                 ///< Mapping  - see :ref:`RANGEITEM <mapfile-style-rangeitem>`
+  int rangeitemindex; ///< The index of the range item - see :ref:`RANGEITEM
+                      ///< <mapfile-style-rangeitem>`
+
+  int symbol;  ///< The index within the map symbolset of the style's symbol -
+               ///< see :ref:`SYMBOL <mapfile-style-symbol>`
+  double size; ///< Pixel width of the style's pen or symbol - see :ref:`SIZE
+               ///< <mapfile-style-size>`
+  double minsize; ///< Minimum pen or symbol width for scaling styles - see
+                  ///< :ref:`MINSIZE <mapfile-style-minsize>`
+  double maxsize; ///< Maximum pen or symbol width for scaling - see
+                  ///< :ref:`MAXSIZE <mapfile-style-maxsize>`
+
+  double gap; ///< See :ref:`GAP <mapfile-style-gap>` - moved from symbolObj in
+              ///< version 6.0
+  double initialgap; ///< See :ref:`INITIALGAP <mapfile-style-initialgap>`
+
+  int linecap;  ///< See :ref:`LINECAP <mapfile-style-linecap>`
+  int linejoin; ///< See :ref:`LINEJOIN <mapfile-style-linejoin>` - moved from
+                ///< symbolObj in version 6.0
+  double linejoinmaxsize; ///< See :ref:`LINEJOINMAXSIZE
+                          ///< <mapfile-style-linejoinmaxsize>` - moved from
+                          ///< symbolObj in version 6.0
+
+  double width; ///< Width refers to the thickness of line work drawn, in pixels
+                ///< - default is 1, for symbols of type ``HATCH``, the with is
+                ///< how thick the hatched lines are - see :ref:`WIDTH
+                ///< <mapfile-style-width>`
+  double outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-style-outlinewidth>`
+  double minwidth;     ///< Minimum width of the symbol - see :ref:`MINWIDTH
+                       ///< <mapfile-style-minwidth>`
+  double maxwidth;     ///< Maximum width of the symbol - see :ref:`MAXWIDTH
+                       ///< <mapfile-style-maxwidth>`
+
+  double offsetx; ///< Draw with pen or symbol offset from map data, for
+                  ///< shadows, hollow symbols, etc - see :ref:`OFFSET
+                  ///< <mapfile-style-offset>`
+  double offsety; ///< Draw with pen or symbol offset from map data, for
+                  ///< shadows, hollow symbols, etc - see :ref:`OFFSET
+                  ///< <mapfile-style-offset>`
+  double polaroffsetpixel; ///< Specifies the radius/distance - see
+                           ///< :ref:`POLAROFFSET <mapfile-style-polaroffset>`
+  double polaroffsetangle; ///< Specified the angle - see :ref:`POLAROFFSET
+                           ///< <mapfile-style-polaroffset>`
+
+  double
+      minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-style-minscaledenom>`
+  double
+      maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-style-maxscaledenom>`
+  int sizeunits;     ///< Supersedes class's :ref:`SIZEUNITS
+                 ///< <mapfile-layer-sizeunits>` to allow fine-grained sizing
+                 ///< for improved SLD (RFC 124)
+};
+
+#define MS_STYLE_SINGLE_SIDED_OFFSET -99
+#define MS_STYLE_DOUBLE_SIDED_OFFSET -999
+#define IS_PARALLEL_OFFSET(offsety)                                            \
+  ((offsety) == MS_STYLE_SINGLE_SIDED_OFFSET ||                                \
+   (offsety) == MS_STYLE_DOUBLE_SIDED_OFFSET)
+
+/********************************************************************/
+/*                          labelLeaderObj                          */
+/*                                                                  */
+/*  parameters defining how a label or a group of labels may be     */
+/*  offsetted from its original position                            */
+/********************************************************************/
+
+/**
+The :ref:`LEADER <leader>` object
+*/
+typedef struct {
+#ifndef SWIG
+  styleObj **styles;
+  int maxstyles;
+#endif
+#ifdef SWIG
+    %immutable;
+#endif
+  int numstyles; ///< Number of styles used
+#ifdef SWIG
+    %mutable;
+#endif
+  int maxdistance; ///< See :ref:`MAXDISTANCE <mapfile-leader-maxdistance>`
+  int gridstep;    ///< See :ref:`GRIDSTEP <mapfile-leader-gridstep>`
+} labelLeaderObj;
+
+/************************************************************************/
+/*                               labelObj                               */
+/*                                                                      */
+/*      parameters needed to annotate a layer, legend or scalebar       */
+/************************************************************************/
+
+/**
+The :ref:`LABEL <label>` object
+*/
+struct labelObj {
+#ifdef SWIG
+    %immutable;
+#endif /* SWIG */
+  int refcount;
+#ifdef SWIG
+    %mutable;
+#endif /* SWIG */
+
+  char *font; ///< Name of TrueType font  see :ref:`FONT <mapfile-label-font>`
+  colorObj color; ///< Foreground color - see :ref:`COLOR <mapfile-label-color>`
+  colorObj outlinecolor; ///< Color of one point outline - see
+                         ///< :ref:`OUTLINECOLOR <mapfile-label-outlinecolor>`
+  int outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-label-outlinewidth>`
+
+  colorObj shadowcolor; ///< See :ref:`SHADOWCOLOR <mapfile-label-shadowcolor>`
+  int shadowsizex;      ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
+  int shadowsizey;      ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
+
+  int size;    ///< Annotation height in pixels - see :ref:`SIZE
+               ///< <mapfile-label-size>`
+  int minsize; ///< Minimum height in pixels - see :ref:`MINSIZE
+               ///< <mapfile-label-minsize>`
+  int maxsize; ///< Maximum height in pixels for scaled labels. See
+               ///< :ref:`MAXSIZE <mapfile-label-maxsize>`
+
+  int position; ///< See :ref:`POSTION <mapfile-label-position>`
+  int offsetx;  ///< Horizontal offset of label - see :ref:`OFFSET
+                ///< <mapfile-label-offset>`
+  int offsety;  ///< Vertical offset of label - see :ref:`OFFSET
+                ///< <mapfile-label-offset>`
+
+  double angle; ///< See :ref:`ANGLE <mapfile-label-angle>`
+  enum MS_POSITIONS_ENUM
+      anglemode; ///< One of :data:`AUTO` :data:`AUTO2`, or :data:`FOLLOW` - see
+                 ///< :ref:`ANGLE <mapfile-label-angle>`
+
+  int buffer; ///< Space to reserve around a label (padding) - see :ref:`BUFFER
+              ///< <mapfile-label-buffer>`
+
+  int align; ///< See :ref:`ALIGN <mapfile-label-align>`
+
+  char wrap;            ///< See :ref:`WRAP <mapfile-label-wrap>`
+  int maxlength;        ///< See :ref:`MAXLENGTH <mapfile-label-maxlength>`
+  double space_size_10; ///< Cached size of a single space character used for
+                        ///< label text alignment of rfc40
+
+  /**
+  Minimum feature size (in pixels) to label, features of this size or greater
+  will be labeled - see :ref:`MINFEATURESIZE  <mapfile-label-minfeaturesize>`
+  */
+  int minfeaturesize;
+  int autominfeaturesize; ///< :data:`MS_TRUE` or :data:`MS_FALSE`
+
+  double
+      minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-label-minscaledenom>`
+  double
+      maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-label-maxscaledenom>`
+
+  int mindistance;    ///< Minimum distance in pixels between duplicate labels -
+                      ///< see :ref:`MINDISTANCE <mapfile-label-mindistance>`
+  int repeatdistance; ///< See :ref:`REPEATDISTANCE
+                      ///< <mapfile-label-repeatdistance>`
+  double maxoverlapangle; ///< See :ref:`MAXOVERLAPANGLE
+                          ///< <mapfile-label-maxoverlapangle>`
+
+  /**
+  Indicates if labels can run off the edge of an image, either :data:`MS_TRUE`
+  or :data:`MS_FALSE` (default) - see :ref:`PARTIALS <mapfile-label-partials>`
+  */
+  int partials;
+
+  int force; ///< Indicates if labels **must** be drawn - see :ref:`FORCE
+             ///< <mapfile-label-force>`
+
+  char *encoding; ///< Supported encoding format to be used for labels - see
+                  ///< :ref:`ENCODING <mapfile-label-encoding>`
+
+  int priority;  ///< Priority level 1 to :data:`MS_MAX_LABEL_PRIORITY`,
+                 ///< default=1 - see :ref:`PRIORITY <mapfile-label-priority>`
+  int numstyles; ///< The number of styles associated with the label
+
+  int sizeunits; ///< Supersedes class's sizeunits, defaults to
+                 ///< :data:`MS_INHERIT`.
+
+#ifndef SWIG
+  styleObj **styles;
+  int maxstyles;
+
+  expressionObj expression;
+  expressionObj text;
+
+  labelLeaderObj *leader;
+
+  attributeBindingObj bindings[MS_LABEL_BINDING_LENGTH];
+  int numbindings;
+  expressionObj exprBindings[MS_LABEL_BINDING_LENGTH];
+  int nexprbindings;
+
+  double scalefactor; // computed, not set
+#endif                /* not SWIG */
+};
+
+#ifdef SWIG
+#ifdef __cplusplus
+extern "C" {
+#endif
+typedef struct labelObj labelObj;
+#ifdef __cplusplus
+}
+#endif
+#endif
+
+#ifndef SWIG
+/* lightweight structure containing information to render a labelObj */
+typedef struct {
+  lineObj *poly;
+  rectObj bbox;
+} label_bounds;
+
+typedef struct {
+  labelObj *label;
+  char *annotext;
+  double scalefactor, resolutionfactor;
+  pointObj annopoint;
+  double rotation;
+  textPathObj *textpath;
+  // rectObj bbox;
+  label_bounds **style_bounds;
+} textSymbolObj;
+#endif
+
+#define MS_LABEL_PERPENDICULAR_OFFSET -99
+#define MS_LABEL_PERPENDICULAR_TOP_OFFSET 99
+#define IS_PERPENDICULAR_OFFSET(offsety)                                       \
+  ((offsety) == MS_LABEL_PERPENDICULAR_OFFSET ||                               \
+   (offsety) == MS_LABEL_PERPENDICULAR_TOP_OFFSET)
+
+/************************************************************************/
+/*                          classObj                                    */
+/************************************************************************/
+
+/**
+ * The :ref:`CLASS <class>` object. Used for symbolization and classification
+ * information.
+ *
+ */
+struct classObj {
+
+#ifdef SWIG
+    %immutable;
+#endif /* SWIG */
+
+  hashTableObj metadata;   ///< see :ref:`METADATA <mapfile-class-metadata>`
+  hashTableObj validation; ///< see :ref:`VALIDATION <mapfile-class-validation>`
+  int numstyles;           ///< number of styles for class
+  int numlabels;           ///< number of labels for class
+  int refcount;            ///< number of references to this object
+  struct layerObj *layer;  ///< reference to the parent layer
+  labelLeaderObj *leader;  ///< see :ref:`LEADER <mapfile-class-leader>`
+
+#ifdef SWIG
+    %mutable;
+#endif
+
+  int status; ///< :data:`MS_ON` or :data:`MS_OFF` - draw features of this class
+              ///< or do not - see :ref:`STATUS <mapfile-class-status>`
+  int isfallback; ///< :data:`MS_TRUE` or :data:`MS_FALSE` use :data:`MS_TRUE`
+                  ///< if this class should be applied if and only if no other
+                  ///< class is applicable
+  char *name;  ///< See :ref:`NAME <mapfile-class-name>` should be unique within
+               ///< a layer
+  char *title; ///< See :ref:`TITLE <mapfile-class-title>`
+  double
+      minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-class-minscaledenom>`
+  double
+      maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-CLASS-maxscaledenom>`
+  int minfeaturesize; ///< See :ref:`MINFEATURESIZE
+                      ///< <mapfile-class-minfeaturesize>` minimum feature size
+                      ///< in pixels
+  int debug;          ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`DEBUG
+                      ///< <mapfile-class-debug>`
+  char *keyimage;     ///< See :ref:`KEYIMAGE <mapfile-class-keyimage>`
+  char *group;        ///< See :ref:`GROUP <mapfile-class-group>`
+  int sizeunits; ///< Supersedes layer's sizeunits and applies to all styles and
+                 ///< labels - see :ref:`LAYER SIZEUNITS
+                 ///< <mapfile-layer-sizeunits>`
+
+#ifndef __cplusplus
+  char *template; ///< See :ref:`TEMPLATE <mapfile-class-template>`
+#else             /* __cplusplus */
+  char *_template; // keyword in cplusplus
+#endif            /* __cplusplus */
+
+#ifndef SWIG
+  expressionObj text;
+  expressionObj expression; /* the expression to be matched */
+  labelObj **labels;
+  int maxlabels;
+  int maxstyles;
+  styleObj **styles;
+  double scalefactor; // computed, not set
+#endif                /* not SWIG */
+};
+
+/************************************************************************/
+/*                         labelCacheMemberObj                          */
+/*                                                                      */
+/*      structures to implement label caching and collision             */
+/*      avoidance etc                                                   */
+/*                                                                      */
+/*        Note: These are scriptable, but are read only.                */
+/************************************************************************/
+
+#ifdef SWIG
+  %immutable;
+#endif /* SWIG */
+/**
+An individual feature label. The labelCacheMemberObj class is associated with
+labelCacheObj.
+*/
+typedef struct {
+  int numtextsymbols; ///< Number of text symbols found in textsymbols
+  int layerindex;     ///< The index of the layer of the labelled feature
+  int classindex;     ///< Index of the class of the labelled feature
+  int status;         ///< Has this label been drawn or not?
+  int markerid;       ///< Corresponding marker (POINT layers only)
+
+  pointObj point; ///< Label point
+  rectObj bbox;   ///< Bounds of the whole cachePtr. Individual text and symbol
+                  ///< sub bounds are found in textsymbols
+
+  lineObj *leaderline; ///< Leader lineObj
+  rectObj *leaderbbox; ///< Leader rectObj
+
+#ifndef SWIG
+  textSymbolObj **textsymbols;
+#endif
+
+} labelCacheMemberObj;
+
+/************************************************************************/
+/*                         markerCacheMemberObj                         */
+/************************************************************************/
+/**
+An individual marker. The markerCacheMemberObj class is associated with
+labelCacheObj.
+*/
+typedef struct {
+  int id;         ///< Corresponding label
+  rectObj bounds; ///< Bounds of the markerCacheMemberObj
+} markerCacheMemberObj;
+
+/************************************************************************/
+/*                          labelCacheSlotObj                           */
+/************************************************************************/
+/**
+A cache slot to hold labels grouped by priority
+*/
+typedef struct {
+  int numlabels;       ///< Number of label members
+  int cachesize;       ///< TODO
+  int nummarkers;      ///< Number of marker members
+  int markercachesize; ///< TODO
+  labelCacheMemberObj *labels;
+  markerCacheMemberObj *markers;
+} labelCacheSlotObj;
+
+/************************************************************************/
+/*                            labelCacheObj                             */
+/************************************************************************/
+/**
+Set of a map's cached labels. Has no other existence other than as a labelcache
+attribute of a mapObj. Associated with labelCacheMemberObj and
+markerCacheMemberObj.
+*/
+typedef struct {
+  int num_rendered_members; ///< Number of rendered labels
+#ifndef SWIG
+  /* One labelCacheSlotObj for each priority level */
+  labelCacheSlotObj slots[MS_MAX_LABEL_PRIORITY];
+  int gutter; /* space in pixels around the image where labels cannot be placed
+               */
+  labelCacheMemberObj **rendered_text_symbols;
+  int num_allocated_rendered_members;
+#endif
+} labelCacheObj;
+
+/************************************************************************/
+/*                         resultObj                                    */
+/************************************************************************/
+/**
+The result object is a handle, of sorts, for a feature of the layer
+*/
+typedef struct {
+#ifndef SWIG
+  shapeObj *shape;
+#endif
+  long shapeindex; ///< The shape index of the result
+  int tileindex;   ///< The tile index of the result
+  int resultindex; ///< The index of the result
+  int classindex;  ///< The class index of the result
+} resultObj;
+
+/************************************************************************/
+/*                            resultCacheObj                            */
+/************************************************************************/
+/**
+A cached result object
+*/
+typedef struct {
+
+#ifndef SWIG
+  resultObj *results;
+  int cachesize;
+  rectObj previousBounds; /* bounds at previous iteration */
+#endif                    /* not SWIG */
+
+#ifdef SWIG
+    %immutable;
+#endif            /* SWIG */
+  int numresults; ///< Length of result set
+  rectObj bounds; ///< Bounding box of query results
+
+#ifdef SWIG
+    %mutable;
+#endif /* SWIG */
+} resultCacheObj;
+
+/************************************************************************/
+/*                             symbolSetObj                             */
+/************************************************************************/
+/**
+A :class:`symbolSetObj` is an attribute of a :class:`mapObj` and is associated
+with instances of :class:`symbolObj`.
+*/
+typedef struct {
+#ifndef SWIG
+  int refcount;
+  symbolObj **symbol;
+  struct mapObj *map;
+  fontSetObj *fontset; /* a pointer to the main mapObj version */
+  struct imageCacheObj *imagecache;
+#endif /* not SWIG */
+
+#ifdef SWIG
+    %immutable;
+#endif            /* SWIG */
+  int numsymbols; ///< Number of symbols in the set
+  int maxsymbols; ///< Maximum number of allowed symbols
+#ifdef SWIG
+    %mutable;
+#endif /* SWIG */
+
+  char *filename;     ///< Symbolset filename
+  int imagecachesize; ///< Symbols in the cache
+
+} symbolSetObj;
+
+/************************************************************************/
+/*                           referenceMapObj                            */
+/************************************************************************/
+
+/**
+The :ref:`REFERENCE <reference>` object
+*/
+typedef struct {
+#ifdef SWIG
+      %immutable;
+#endif                /* SWIG */
+  struct mapObj *map; ///< Reference to parent :class:`mapObj`
+#ifdef SWIG
+      %mutable;
+#endif            /* SWIG */
+  rectObj extent; ///< Spatial extent of reference in units of parent map - see
+                  ///< :ref:`EXTENT <mapfile-reference-extent>`
+  int height;     ///< Height of reference map in pixels - see :ref:`SIZE
+                  ///< <mapfile-reference-size>`
+  int width;      ///< Width of reference map in pixels - see :ref:`SIZE
+                  ///< <mapfile-reference-size>`
+  colorObj color; ///< Color of reference box - see :ref:`COLOR
+                  ///< <mapfile-reference-color>`
+  colorObj
+      outlinecolor; ///< Outline color of reference box - see :ref:`OUTLINECOLOR
+                    ///< <mapfile-reference-outlinecolor>`
+  char *image;      ///< Filename of reference map image - see :ref:`IMAGE
+                    ///< <mapfile-reference-image>`
+  int status;       ///< :data:`MS_ON` or :data:`MS_OFF` - see :ref:`STATUS
+                    ///< <mapfile-reference-status>`
+  int marker; ///< Index of a symbol in the map symbol set to use for marker -
+              ///< see :ref:`MARKER <mapfile-reference-marker>`
+  char *markername; ///< Name of a symbol - see :ref:`MARKER
+                    ///< <mapfile-reference-marker>`
+  int markersize;   ///< Size of marker - see :ref:`MARKERSIZE
+                    ///< <mapfile-reference-markersize>`
+  int minboxsize;   ///< In pixels - see :ref:`MINBOXSIZE
+                    ///< <mapfile-reference-minboxsize>`
+  int maxboxsize;   ///< In pixels - see :ref:`MAXBOXSIZE
+                    ///< <mapfile-reference-maxboxsize>`
+} referenceMapObj;
+
+/************************************************************************/
+/*                             scalebarObj                              */
+/************************************************************************/
+
+#define MS_SCALEBAR_INTERVALS_MIN 1
+#define MS_SCALEBAR_INTERVALS_MAX 100
+
+#define MS_SCALEBAR_WIDTH_MIN 5
+#define MS_SCALEBAR_WIDTH_MAX 1000
+#define MS_SCALEBAR_HEIGHT_MIN 2
+#define MS_SCALEBAR_HEIGHT_MAX 100
+
+#define MS_SCALEBAR_OFFSET_MIN -50
+#define MS_SCALEBAR_OFFSET_MAX 50
+
+/**
+The :ref:`SCALEBAR <scalebar>` object
+*/
+typedef struct {
+
+  int transparent;     ///< Allows transparency for an embedded scalebar - see
+                       ///< :ref:`TRANSPARENT <mapfile-scalebar-transparent>`
+  colorObj imagecolor; ///< Background color of scalebar - see :ref:`IMAGECOLOR
+                       ///< <mapfile-scalebar-imagecolor>`
+  int height;    ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
+  int width;     ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
+  int style;     ///< 0 or 1 - see :ref:`STYLE <mapfile-scalebar-style>`
+  int intervals; ///< Number of intervals - see :ref:`INTERVALS
+                 ///< <mapfile-scalebar-intervals>`
+  labelObj
+      label; ///< Scalebar label - see :ref:`LABEL <mapfile-scalebar-label>`
+  colorObj color;           ///< Scalebar foreground color - see :ref:`COLOR
+                            ///< <mapfile-scalebar-color>`
+  colorObj backgroundcolor; ///< Scalebar background color - see
+                            ///< :ref:`BACKGROUNDCOLOR
+                            ///< <mapfile-scalebar-backgroundcolor>`
+  colorObj outlinecolor; ///< Foreground outline color - see :ref:`OUTLINECOLOR
+                         ///< <mapfile-scalebar-outlinecolor>`
+  int units;             ///< See :ref:`UNITS <mapfile-scalebar-units>`
+  int status;            ///< ON, OFF or EMBED - see :ref:`STATUS
+              ///< <mapfile-scalebar-status>` - :data:`MS_ON`, :data:`MS_OFF`,
+              ///< or :data:`MS_EMBED`.
+  int position; ///< For embeded scalebars - see :ref:`POSITION
+                ///< <mapfile-scalebar-position>` - :data:`MS_UL`,
+                ///< :data:`MS_UC`, :data:`MS_UR`, :data:`MS_LL`, :data:`MS_LC`,
+                ///< or :data:`MS_LR`
+
+  int postlabelcache; ///< See :ref:`POSTLABELCACHE
+                      ///< <mapfile-scalebar-postlabelcache>` - :data:`MS_TRUE`
+                      ///< or :data:`MS_FALSE`
+  int align;          ///< See :ref:`ALIGN <mapfile-scalebar-align>`
+  int offsetx;        ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
+  int offsety;        ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
+} scalebarObj;
+
+/************************************************************************/
+/*                              legendObj                               */
+/************************************************************************/
+
+#define MS_LEGEND_KEYSIZE_MIN 5
+#define MS_LEGEND_KEYSIZE_MAX 200
+#define MS_LEGEND_KEYSPACING_MIN 0
+#define MS_LEGEND_KEYSPACING_MAX 50
+
+/**
+The :ref:`LEGEND <legend>` object
+*/
+typedef struct {
+
+#ifdef SWIG
+    %immutable;
+#endif
+  labelObj label;     ///< See :ref:`LABEL <mapfile-legend-label>`
+  struct mapObj *map; ///< Instances of legendObj are always are always embedded
+                      ///< inside the mapObj
+#ifdef SWIG
+    %mutable;
+#endif
+  int transparent;     ///< Allows transparency for an embedded legend - see
+                       ///< :ref:`TRANSPARENT <mapfile-legend-transparent>`
+  colorObj imagecolor; ///< Legend background color - see :ref:`IMAGECOLOR
+                       ///< <mapfile-legend-imagecolor>`
+  int keysizex;        ///< Width in pixels of legend keys - see :ref:`KEYSIZE
+                       ///< <mapfile-legend-keysize>`
+  int keysizey;        ///< Height in pixels of legend keys - see :ref:`KEYSIZE
+                       ///< <mapfile-legend-keysize>`
+  int keyspacingx;     ///< Horizontal padding around keys in pixels - see
+                       ///< :ref:`KEYSPACING <mapfile-legend-keyspacing>`
+  int keyspacingy;     ///< Vertical padding around keys in pixels - see
+                       ///< :ref:`KEYSPACING <mapfile-legend-keyspacing>`
+  colorObj outlinecolor; ///< Key outline color, -1 for no outline - see
+                         ///< :ref:`OUTLINECOLOR <mapfile-legend-outlinecolor>`
+  int status;   ///< :data:`MS_ON`, :data:`MS_OFF` or :data:`MS_EMBED`- see
+                ///< :ref:`STATUS <mapfile-legend-status>`
+  int height;   ///< Legend height
+  int width;    ///< Legend width
+  int position; ///< Used for embedded legends, see :ref:`POSITION
+                ///< <mapfile-legend-position>`
+  int postlabelcache; ///< :data:`MS_TRUE`, :data:`MS_FALSE` - see
+                      ///< :ref:`POSTLABELCACHE <mapfile-legend-postlabelcache>`
+#ifndef __cplusplus
+  char *template; ///< See :ref:`TEMPLATE <mapfile-legend-template>`
+#else             /* __cplusplus */
+  char *_template;
+#endif            /* __cplusplus */
+} legendObj;
+
+/************************************************************************/
+/*                             graticuleObj                             */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  double dwhichlatitude;
+  double dwhichlongitude;
+  double dstartlatitude;
+  double dstartlongitude;
+  double dendlatitude;
+  double dendlongitude;
+  double dincrementlatitude;
+  double dincrementlongitude;
+  double minarcs;
+  double maxarcs;
+  double minincrement;
+  double maxincrement;
+  double minsubdivides;
+  double maxsubdivides;
+  int bvertical;
+  int blabelaxes;
+  int ilabelstate;
+  int ilabeltype;
+  rectObj extent;
+  lineObj *pboundinglines;
+  pointObj *pboundingpoints;
+  char *labelformat;
+} graticuleObj;
+
+typedef struct {
+  int nTop;
+  pointObj *pasTop;
+  char **papszTopLabels;
+  int nBottom;
+  pointObj *pasBottom;
+  char **papszBottomLabels;
+  int nLeft;
+  pointObj *pasLeft;
+  char **papszLeftLabels;
+  int nRight;
+  pointObj *pasRight;
+  char **papszRightLabels;
+
+} graticuleIntersectionObj;
+
+struct layerVTable;
+typedef struct layerVTable layerVTableObj;
+
+#endif /*SWIG*/
+
+/************************************************************************/
+/*                               imageObj                               */
+/************************************************************************/
+
+/**
+ * An image object is a wrapper for images generated by MapServer.
+ *
+ */
+struct imageObj {
+#ifdef SWIG
+    %immutable;
+#endif
+  int width;               ///< image width in pixels
+  int height;              ///< image height in pixels
+  double resolution;       ///< image resolution in pixels per inch
+  double resolutionfactor; ///< resolution factor
+
+  char *imagepath;         ///< if image is drawn by :func:`mapObj.draw` this is
+                           ///< :ref:`IMAGEPATH <mapfile-web-imagepath>`
+  char *imageurl;          ///< if image is drawn by :func:`mapObj.draw` this is
+                           ///< :ref:`IMAGEURL <mapfile-web-imageurl>`
+  outputFormatObj *format; ///< an :class:`outputFormatObj` representing the
+                           ///< output format of the image
+
+#ifndef SWIG
+  tileCacheObj *tilecache;
+  int ntiles;
+  int size;
+#endif
+#ifdef SWIG
+    %mutable;
+#endif
+
+#ifndef SWIG
+  union {
+    void *plugin;
+
+    char *imagemap;
+    short *raw_16bit;
+    float *raw_float;
+    unsigned char *raw_byte;
+  } img;
+  ms_bitarray img_mask;
+  pointObj refpt;
+  mapObj *map;
+#endif
+};
+
+/************************************************************************/
+/*                               layerObj                               */
+/*                                                                      */
+/*      base unit of a map.                                             */
+/************************************************************************/
+
+/**
+An individual value within the :ref:`SCALETOKEN <mapfile-layer-scaletoken>`
+object
+*/
+typedef struct {
+  double minscale; ///< The minimum scale for the replacement
+  double maxscale; ///< The maximum scale for the replacement
+  char *value;     ///< The token replacement value
+} scaleTokenEntryObj;
+
+/**
+The :ref:`SCALETOKEN <mapfile-layer-scaletoken>` object
+*/
+typedef struct {
+  char *name;    ///< The name of the token to replace in the :ref:`DATA
+                 ///< <mapfile-layer-data>` statement
+  int n_entries; ///< The number of values within the scaletoken
+  scaleTokenEntryObj *tokens; ///< A reference to the values
+} scaleTokenObj;
+
+#ifndef SWIG
+typedef enum { SORT_ASC, SORT_DESC } sortOrderEnum;
+
+typedef struct {
+  char *item;
+  sortOrderEnum sortOrder;
+} sortByProperties;
+
+typedef struct {
+  int nProperties;
+  sortByProperties *properties;
+} sortByClause;
+
+typedef struct {
+  /* The following store original members if they have been modified at runtime
+   * by a rfc86 scaletoken */
+  char *data;
+  char *tileitem;
+  char *tileindex;
+  char *filteritem;
+  char *filter;
+  char **processing;
+  int *processing_idx;
+  int n_processing;
+} originalScaleTokenStrings;
+#endif
+
+/**
+The :ref:`LAYER <layer>` object
+*/
+struct layerObj {
+
+#ifndef SWIG
+  /* RFC86 Scale-dependent token replacements */
+  scaleTokenObj *scaletokens;
+  int numscaletokens;
+  originalScaleTokenStrings *orig_st;
+  int labelitemindex;
+
+  int tileitemindex;
+  projectionObj projection; /* projection information for the layer */
+  int project; /* boolean variable, do we need to project this layer or not */
+  reprojectionObj *reprojectorLayerToMap;
+  reprojectionObj *reprojectorMapToLayer;
+
+  featureListNodeObjPtr features; /* linked list so we don't need a counter */
+  featureListNodeObjPtr currentfeature; /* pointer to the current feature */
+
+  layerVTableObj *vtable;
+
+  /* SDL has converted OracleSpatial, SDE, Graticules */
+  void *layerinfo; /* all connection types should use this generic pointer to a
+                      vendor specific structure */
+  void *wfslayerinfo; /* For WFS layers, will contain a msWFSLayerInfo struct */
+
+  char **items;
+  void *iteminfo;       /* connection specific information necessary to retrieve
+                           values */
+  expressionObj filter; /* connection specific attribute filter */
+  int bandsitemindex;
+  int filteritemindex;
+  int styleitemindex;
+
+  char **processing;
+  joinObj *joins;
+
+  imageObj *maskimage;
+  graticuleObj *grid;
+  expressionObj _geomtransform;
+  sortByClause sortBy;
+
+#endif
+
+#ifndef SWIG
+  int classitemindex;
+  resultCacheObj
+      *resultcache;   /* holds the results of a query against this layer */
+  double scalefactor; /* computed, not set */
+#ifndef __cplusplus
+  classObj **class; /* always at least 1 class */
+#else               /* __cplusplus */
+  classObj **_class;
+#endif              /* __cplusplus */
+#endif              /* not SWIG */
+
+#ifdef SWIG
+    %immutable;
+#endif                /* SWIG */
+  int refcount;       ///< reference counting, RFC24
+  int numclasses;     ///< Number of layer classes
+  int maxclasses;     ///< Used to track of the maximum number of classes - see
+                      ///< RFC-17
+  int index;          ///< Index of layer within parent map's layers array
+  struct mapObj *map; ///< Reference to parent map
+  int numitems;       ///< Number of layer feature attributes (items)
+  hashTableObj metadata;   ///< See :ref:`METADATA <mapfile-layer-metadata>`
+  hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-layer-validation>`
+  hashTableObj bindvals;   ///< Relates to RFC59
+  hashTableObj connectionoptions; ///< See :ref:`CONNECTIONOPTIONS
+                                  ///< <mapfile-layer-connectionoptions>`
+
+  clusterObj cluster; ///< See :ref:`CLUSTER <mapfile-layer-cluster>`
+  rectObj extent;     ///< optional limiting extent for layer features - see
+                      ///< :ref:`EXTENT <mapfile-layer-extent>`
+  int numprocessing;  ///< Number of raster processing directives
+  int numjoins;       ///< Number of layer joins
+
+  expressionObj utfdata; ///< See :ref:`UTFDATA <mapfile-layer-utfdata>`
+  LayerCompositer
+      *compositer; ///< See :ref:`COMPOSITE <mapfile-layer-composite>`
+
+#ifdef SWIG
+    %mutable;
+#endif /* SWIG */
+
+  char *classitem; ///< the attribute used to classify layer data - see
+                   ///< :ref:`CLASSITEM <mapfile-layer-classitem>`
+  char *header;    ///< filename to a template for result's header - see
+                   ///< :ref:`HEADER <mapfile-layer-header>`
+  char *footer;    ///< filename to a template for result's footer - see
+                   ///< :ref:`FOOTER <mapfile-layer-footer>`
+
+#ifndef __cplusplus
+  char *template; ///< See :ref:`TEMPLATE <mapfile-layer-template>` - global
+                  ///< template, used across all classes
+#else             /* __cplusplus */
+  char *_template;
+#endif            /* __cplusplus */
+
+  char *name;  ///< See :ref:`NAME <mapfile-layer-name>` - should be unique
+  char *group; ///< Name of a group of layers - see :ref:`GROUP
+               ///< <mapfile-layer-group>`
+  int status;  ///< See :ref:`STATUS <mapfile-layer-status>`:data:`MS_ON`,
+               ///< :data:`MS_OFF` or :data:`MS_DEFAULT`
+  enum MS_RENDER_MODE
+      rendermode; ///< :data:`MS_FIRST_MATCHING_CLASS` - default and historic
+                  ///< MapServer behavior, :data:`MS_ALL_MATCHING_CLASSES` - SLD
+                  ///< behavior
+  char *data; ///< Layer data definition, values depend upon connectiontype -
+              ///< see :ref:`DATA <mapfile-layer-data>`
+  enum MS_LAYER_TYPE
+      type; ///< the layer type - see :ref:`TYPE <mapfile-layer-type>`
+  enum MS_CONNECTION_TYPE
+      connectiontype; ///< the layer connection type - see :ref:`CONNECTIONTYPE
+                      ///< <mapfile-layer-connectiontype>`
+
+  double tolerance;   ///< search buffer for point and line queries (in
+                      ///< toleranceunits) - see :ref:`TOLERANCE
+                      ///< <mapfile-layer-tolerance>`
+  int toleranceunits; ///< See :ref:`TOLERANCEUNITS
+                      ///< <mapfile-layer-toleranceunits>`
+
+  double symbolscaledenom; ///< scale at which symbols are default size - see
+                           ///< :ref:`SYMBOLSCALEDENOM
+                           ///< <mapfile-layer-symbolscaledenom>`
+  double minscaledenom;    ///< Maximum scale at which layer will be drawn - see
+                        ///< :ref:`MINSCALEDENOM <mapfile-layer-minscaledenom>`
+  double maxscaledenom; ///< Minimum scale at which layer will be drawn - see
+                        ///< :ref:`MAXSCALEDENOM <mapfile-layer-maxscaledenom>`
+  int minfeaturesize;   ///< minimum feature size (in pixels) for shape
+  double labelminscaledenom; ///< See :ref:`LABELMINSCALEDENOM
+                             ///< <mapfile-layer-labelminscaledenom>`
+  double labelmaxscaledenom; ///< See :ref:`LABELMAXSCALEDENOM
+                             ///< <mapfile-layer-labelmaxscaledenom>`
+  double mingeowidth; ///< min map width (in map units) at which the layer
+                      ///< should be drawn - see :ref:`MAXGEOWIDTH
+                      ///< <mapfile-layer-maxgeowidth>`
+  double maxgeowidth; ///< max map width (in map units) at which the layer
+                      ///< should be drawn - see :ref:`MAXGEOWIDTH
+                      ///< <mapfile-layer-maxgeowidth>`
+
+  int sizeunits; ///< applies to all classes - see :ref:`SIZEUNITS
+                 ///< <mapfile-layer-sizeunits>`
+
+  int maxfeatures; ///< Maximum number of layer features that will be drawn -
+                   ///< see :ref:`MAXFEATURES <mapfile-layer-maxfeatures>`
+  int startindex;  ///< Feature start index - used for paging
+
+  colorObj offsite; ///< transparent pixel value for raster images - see
+                    ///< :ref:`OFFSITE <mapfile-layer-offsite>`
+
+  /**
+  :data:`MS_TRUE` (default) or :data:`MS_FALSE` whether or not layer data is to
+  be transformed to image units - see :ref:`TRANSFORM <mapfile-layer-transform>`
+  */
+  int transform;
+
+  int labelcache;     ///< :data:`MS_ON` (default) or :data:`MS_OFF` - see
+                      ///< :ref:`LABELCACHE <mapfile-layer-labelcache>`
+  int postlabelcache; ///< :data:`MS_ON` or :data:`MS_OFF` (default) - see
+                      ///< :ref:`POSTLABELCACHE <mapfile-layer-postlabelcache>`
+
+  char *labelitem; ///< attribute defining feature label text - see
+                   ///< :ref:`LABELITEM <mapfile-layer-labelitem>`
+  char *tileitem;  ///< attribute defining tile paths - see :ref:`TILEITEM
+                   ///< <mapfile-layer-tileitem>`
+  char *tileindex; ///< layer index file for tiling support - see
+                   ///< :ref:`TILEINDEX <mapfile-layer-tileindex>`
+  char *
+      tilesrs; ///< name of the attribute that contains the SRS of an individual
+               ///< tile - see :ref:`TILESRS <mapfile-layer-tilesrs>`
+  int units;   ///< units of the layer - see :ref:`UNITS <mapfile-layer-units>`
+
+  char *connection;     ///< layer connection or data source name - see
+                        ///< :ref:`CONNECTION <mapfile-layer-connection>`
+  char *plugin_library; ///< Used to select the library to load by MapServer
+  char *plugin_library_original; ///< this is needed for Mapfile writing
+
+  /**
+  The attribute from the index file used to select the source raster band(s) to
+  be used - normally NULL for default bands processing
+  */
+  char *bandsitem;
+
+  char *filteritem; ///< Attribute defining filter - see :ref:`FILTERITEM
+                    ///< <mapfile-layer-filteritem>`
+  char *styleitem;  ///< item to be used for style lookup - can also be 'AUTO' -
+                    ///< see :ref:`STYLEITEM <mapfile-layer-styleitem>`
+
+#ifndef __cplusplus
+  char *
+    requires; ///< Context expressions, simple enough to not use expressionObj -
+              ///< see :ref:`REQUIRES <mapfile-layer-requires>`
+#else
+  char *_requires;
+#endif
+  char *labelrequires; ///< Simple logical expression - see :ref:`LABELREQUIRES
+                       ///< <mapfile-layer-labelrequires>`
+
+  int debug; ///< Enable debugging of layer-  :data:`MS_ON` or :data:`MS_OFF`
+             ///< (default) - see :ref:`DEBUG <mapfile-layer-debug>`
+  char *classgroup; ///< See :ref:`CLASSGROUP <mapfile-layer-classgroup>`
+  char *mask;       ///< See :ref:`MASK <mapfile-layer-mask>`
+  char *encoding; ///< For iconving shape attributes, ignored if NULL or "utf-8"
+                  ///< - see :ref:`ENCODING <mapfile-layer-encoding>`
+
+  /* RFC93 UTFGrid support */
+  char *utfitem;    ///< See :ref:`UTFITEM <mapfile-layer-utfitem>`
+  int utfitemindex; ///< See :ref:`CLASSITEM <mapfile-layer-classitem>`
+};
+
+#ifndef SWIG
+void msFontCacheSetup();
+void msFontCacheCleanup();
+
+typedef struct {
+  double minx, miny, maxx, maxy, advance;
+} glyph_metrics;
+
+typedef struct {
+  glyph_element *glyph;
+  face_element *face;
+  pointObj pnt;
+  double rot;
+} glyphObj;
+
+struct textPathObj {
+  int numglyphs;
+  int numlines;
+  int line_height;
+  int glyph_size;
+  int absolute; /* are the glyph positions absolutely placed, or relative to the
+                   origin */
+  glyphObj *glyphs;
+  label_bounds bounds;
+};
+
+typedef enum {
+  duplicate_never,
+  duplicate_always,
+  duplicate_if_needed
+} label_cache_mode;
+
+void initTextPath(textPathObj *tp);
+int WARN_UNUSED msComputeTextPath(mapObj *map, textSymbolObj *ts);
+void msCopyTextPath(textPathObj *dst, textPathObj *src);
+void freeTextPath(textPathObj *tp);
+void initTextSymbol(textSymbolObj *ts);
+void freeTextSymbol(textSymbolObj *ts);
+void freeTextSymbolEx(textSymbolObj *ts, int doFreeLabel);
+void copyLabelBounds(label_bounds *dst, label_bounds *src);
+void msCopyTextSymbol(textSymbolObj *dst, textSymbolObj *src);
+void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l,
+                                           char *string, double scalefactor,
+                                           double resolutionfactor,
+                                           label_cache_mode cache);
+#endif /* SWIG */
+
+/************************************************************************/
+/*                                mapObj                                */
+/*                                                                      */
+/*      encompasses everything used in an Internet mapping              */
+/*      application.                                                    */
+/************************************************************************/
+
+#define MS_RESOLUTION_MAX 1000 /* applies to resolution and defresolution */
+#define MS_RESOLUTION_MIN 10
+
+/**
+The :ref:`MAP <map>` object
+*/
+struct mapObj { /* structure for a map */
+
+#ifndef SWIG
+  layerObj **layers;
+  geotransformObj gt; /* rotation / geotransform */
+  rectObj saved_extent;
+  paletteObj palette; /* holds a map palette */
+  outputFormatObj **outputformatlist;
+  projectionObj projection; /* projection information for output map */
+  projectionObj latlon;     /* geographic projection definition */
+
+  /* Private encryption key information - see mapcrypto.c */
+  int encryption_key_loaded; /* MS_TRUE once key has been loaded */
+  unsigned char
+      encryption_key[MS_ENCRYPTION_KEY_SIZE]; /* 128bits encryption key */
+  queryObj query;
+  projectionContext *projContext;
+
+#endif /* SWIG */
+
+#ifdef SWIG
+      %immutable;
+#endif           /* SWIG */
+  int refcount;  ///< Used for reference counting see RFC24
+  int numlayers; ///< Number of layers in mapfile
+  int maxlayers; ///< Allocated size of layers[] array
+
+  /**
+  A hash table of configuration options from CONFIG keywords
+  in the map - see :ref:`CONFIG <mapfile-map-config>`
+  */
+  hashTableObj configoptions;
+
+  symbolSetObj symbolset; ///< See :ref:`SYMBOLSET <mapfile-map-symbolset>`
+  fontSetObj fontset;     ///< See :ref:`FONTSET <mapfile-map-fontset>`
+
+  labelCacheObj labelcache; ///< We need this here so multiple feature
+                            ///< processors can access it
+  int numoutputformats;     ///< Number of output formats available in the map
+  outputFormatObj
+      *outputformat; ///< See :ref:`OUTPUTFORMAT <mapfile-map-outputformat>`
+  char *imagetype;   ///< Name of current outputformat
+
+  referenceMapObj reference; ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
+  scalebarObj scalebar;      ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
+  legendObj legend;          ///< See :ref:`LEGEND <mapfile-map-legend>`
+  queryMapObj querymap;      ///< See :ref:`QUERYMAP <mapfile-map-querymap>`
+  webObj web;                ///< See :ref:`WEB <mapfile-map-web>`
+
+  const configObj *config;
+#ifdef SWIG
+    %mutable;
+#endif /* SWIG */
+
+  char *datapattern; ///< TODO - Deprecated use VALIDATION ... END block instead
+  char *templatepattern; ///< TODO - Deprecated use VALIDATION ... END block
+                         ///< instead
+
+  char *name;  ///< Small identifier for naming etc - see :ref:`NAME
+               ///< <mapfile-map-name>`
+  int status;  ///< Is map creation on or off - see :ref:`STATUS
+               ///< <mapfile-map-status>`
+  int height;  ///< See :ref:`SIZE <mapfile-map-size>`
+  int width;   ///< See :ref:`SIZE <mapfile-map-size>`
+  int maxsize; ///< See :ref:`MAXSIZE  <mapfile-map-maxsize>`
+
+  rectObj extent; ///< Map extent array - see :ref:`EXTENT <mapfile-map-extent>`
+  double cellsize; ///< Pixel size in map units
+
+  enum MS_UNITS
+      units; ///< Units of the projection - see :ref:`UNITS <mapfile-map-units>`
+  double scaledenom; ///< The nominal map scale, a value of 25000 means 1:25000
+                     ///< scale - see :ref:`SCALEDENOM <mapfile-map-scaledenom>`
+  double resolution; ///< See :ref:`RESOLUTION <mapfile-map-resolution>`
+  double defresolution; ///< Default resolution - used to calculate the
+                        ///< scalefactor, see :ref:`DEFRESOLUTION
+                        ///< <mapfile-map-defresolution>`
+
+  char *shapepath; ///< Where are the shape files located - see :ref:`SHAPEPATH
+                   ///< <mapfile-map-shapepath>`
+  char *mappath;   ///< Path of the mapfile, all paths are relative to this path
+
+  /**
+  URL of SLD document as specified with "&SLD=..." WMS parameter d- currently
+  this reference is used only in mapogcsld.c and has a NULL value outside that
+  context
+  */
+  char *sldurl;
+
+  colorObj imagecolor; ///< Holds the initial image color value - see
+                       ///< :ref:`IMAGECOLOR <mapfile-map-imagecolor>`
+
+  int *layerorder; ///< Used to modify the order in which the layers are drawn -
+                   ///< TODO should be immutable?
+  int debug;       ///< See :ref:`DEBUG <mapfile-map-debug>`
+
+#ifdef USE_V8_MAPSCRIPT
+  void *v8context;
+#endif
+};
+
+/************************************************************************/
+/*                             layerVTable                              */
+/*                                                                      */
+/*      contains function pointers to the layer operations.  If you     */
+/*      add new functions to here, remember to update                   */
+/*      populateVirtualTable in maplayer.c                              */
+/************************************************************************/
+#ifndef SWIG
+struct layerVTable {
+  int (*LayerTranslateFilter)(layerObj *layer, expressionObj *filter,
+                              char *filteritem);
+  int (*LayerSupportsCommonFilters)(layerObj *layer);
+  int (*LayerInitItemInfo)(layerObj *layer);
+  void (*LayerFreeItemInfo)(layerObj *layer);
+  int (*LayerOpen)(layerObj *layer);
+  int (*LayerIsOpen)(layerObj *layer);
+  int (*LayerWhichShapes)(layerObj *layer, rectObj rect, int isQuery);
+  int (*LayerNextShape)(layerObj *layer, shapeObj *shape);
+  int (*LayerGetShape)(layerObj *layer, shapeObj *shape, resultObj *record);
+  int (*LayerGetShapeCount)(layerObj *layer, rectObj rect,
+                            projectionObj *rectProjection);
+  int (*LayerClose)(layerObj *layer);
+  int (*LayerGetItems)(layerObj *layer);
+  int (*LayerGetExtent)(layerObj *layer, rectObj *extent);
+  int (*LayerGetAutoStyle)(mapObj *map, layerObj *layer, classObj *c,
+                           shapeObj *shape);
+  int (*LayerCloseConnection)(layerObj *layer);
+  int (*LayerSetTimeFilter)(layerObj *layer, const char *timestring,
+                            const char *timefield);
+  int (*LayerApplyFilterToLayer)(FilterEncodingNode *psNode, mapObj *map,
+                                 int iLayerIndex);
+  int (*LayerCreateItems)(layerObj *layer, int nt);
+  int (*LayerGetNumFeatures)(layerObj *layer);
+  int (*LayerGetAutoProjection)(layerObj *layer, projectionObj *projection);
+  char *(*LayerEscapeSQLParam)(layerObj *layer, const char *pszString);
+  char *(*LayerEscapePropertyName)(layerObj *layer, const char *pszString);
+  void (*LayerEnablePaging)(layerObj *layer, int value);
+  int (*LayerGetPaging)(layerObj *layer);
+};
+#endif /*SWIG*/
+
+/* Function prototypes, wrapable */
+
+/**
+Saves a map image to a file
+*/
+MS_DLL_EXPORT int msSaveImage(mapObj *map, imageObj *img, const char *filename);
+
+/**
+Generic function to free a imageObj
+*/
+MS_DLL_EXPORT void msFreeImage(imageObj *img);
+
+/**
+Sets up threads and font cache - called when MapScript is initialised
+*/
+MS_DLL_EXPORT int msSetup(void);
+
+/**
+Attempts to recover all dynamically allocated resources allocated by MapServer
+code and dependent libraries. It is used primarily for final clean-up in scripts
+that need to do memory leak testing to get rid of "noise" one-time allocations.
+It should not normally be used by production code.
+*/
+MS_DLL_EXPORT void msCleanup(void);
+
+/**
+Sets up string-based mapfile loading and calls loadMapInternal to do the work
+*/
+MS_DLL_EXPORT mapObj *msLoadMapFromString(char *buffer, char *new_mappath,
+                                          const configObj *config);
+
+/* Function prototypes, not wrapable */
+
+#ifndef SWIG
+
+/*
+** helper functions not part of the general API but needed in
+** a few other places (like mapscript)... found in mapfile.c
+*/
+int getString(char **s);
+int getDouble(double *d, int num_check_type, double value1,
+              double value2); // getDouble(double *d);
+int getInteger(int *i, int num_check_type, int value1,
+               int value2); // getInteger(int *i);
+int getSymbol(int n, ...);
+int getCharacter(char *c);
+
+int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map);
+
+MS_DLL_EXPORT int hex2int(char *hex);
+
+MS_DLL_EXPORT void initJoin(joinObj *join);
+MS_DLL_EXPORT void initSymbol(symbolObj *s);
+MS_DLL_EXPORT int initMap(mapObj *map);
+MS_DLL_EXPORT layerObj *msGrowMapLayers(mapObj *map);
+MS_DLL_EXPORT int initLayer(layerObj *layer, mapObj *map);
+MS_DLL_EXPORT int freeLayer(layerObj *);
+MS_DLL_EXPORT classObj *msGrowLayerClasses(layerObj *layer);
+MS_DLL_EXPORT scaleTokenObj *msGrowLayerScaletokens(layerObj *layer);
+MS_DLL_EXPORT int initScaleToken(scaleTokenObj *scaleToken);
+MS_DLL_EXPORT int initClass(classObj *_class);
+MS_DLL_EXPORT int freeClass(classObj *);
+MS_DLL_EXPORT styleObj *msGrowClassStyles(classObj *_class);
+MS_DLL_EXPORT labelObj *msGrowClassLabels(classObj *_class);
+MS_DLL_EXPORT styleObj *msGrowLabelStyles(labelObj *label);
+MS_DLL_EXPORT styleObj *msGrowLeaderStyles(labelLeaderObj *leader);
+MS_DLL_EXPORT int msMaybeAllocateClassStyle(classObj *c, int idx);
+MS_DLL_EXPORT void initLabel(labelObj *label);
+MS_DLL_EXPORT int freeLabel(labelObj *label);
+MS_DLL_EXPORT int freeLabelLeader(labelLeaderObj *leader);
+MS_DLL_EXPORT void resetClassStyle(classObj *_class);
+MS_DLL_EXPORT int initStyle(styleObj *style);
+MS_DLL_EXPORT int freeStyle(styleObj *style);
+MS_DLL_EXPORT void initReferenceMap(referenceMapObj *ref);
+MS_DLL_EXPORT void initScalebar(scalebarObj *scalebar);
+MS_DLL_EXPORT void initGrid(graticuleObj *pGraticule);
+MS_DLL_EXPORT void initWeb(webObj *web);
+MS_DLL_EXPORT void freeWeb(webObj *web);
+MS_DLL_EXPORT void initResultCache(resultCacheObj *resultcache);
+void cleanupResultCache(resultCacheObj *resultcache);
+MS_DLL_EXPORT int initLayerCompositer(LayerCompositer *compositer);
+MS_DLL_EXPORT void initLeader(labelLeaderObj *leader);
+MS_DLL_EXPORT void freeGrid(graticuleObj *pGraticule);
+int loadHashTable(hashTableObj *ptable); // used by other file loading code
+
+MS_DLL_EXPORT featureListNodeObjPtr
+insertFeatureList(featureListNodeObjPtr *list, shapeObj *shape);
+MS_DLL_EXPORT void freeFeatureList(featureListNodeObjPtr list);
+
+/* To be used *only* within the mapfile loading phase */
+MS_DLL_EXPORT int loadExpressionString(expressionObj *exp, const char *value);
+/* Use this next, thread safe wrapper, function everywhere else */
+MS_DLL_EXPORT int msLoadExpressionString(expressionObj *exp, const char *value);
+MS_DLL_EXPORT char *msGetExpressionString(expressionObj *exp);
+MS_DLL_EXPORT void msInitExpression(expressionObj *exp);
+MS_DLL_EXPORT void msFreeExpressionTokens(expressionObj *exp);
+MS_DLL_EXPORT void msFreeExpression(expressionObj *exp);
+
+MS_DLL_EXPORT void msApplySubstitutions(mapObj *map, char **names,
+                                        char **values, int npairs);
+MS_DLL_EXPORT void msApplyDefaultSubstitutions(mapObj *map);
+
+MS_DLL_EXPORT int getClassIndex(layerObj *layer, char *str);
+
+/* For maplabel */
+int intersectLabelPolygons(lineObj *p1, rectObj *r1, lineObj *p2, rectObj *r2);
+int intersectTextSymbol(textSymbolObj *ts, label_bounds *lb);
+pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy,
+                     double rotation, int buffer, label_bounds *metrics);
+double dist(pointObj a, pointObj b);
+void fastComputeBounds(lineObj *line, rectObj *bounds);
+
+/*
+** Main API Functions
+*/
+
+/* mapobject.c */
+
+MS_DLL_EXPORT void msFreeMap(mapObj *map);
+MS_DLL_EXPORT mapObj *msNewMapObj(void);
+MS_DLL_EXPORT const char *msGetConfigOption(mapObj *map, const char *key);
+MS_DLL_EXPORT int msSetConfigOption(mapObj *map, const char *key,
+                                    const char *value);
+MS_DLL_EXPORT int msTestConfigOption(mapObj *map, const char *key,
+                                     int default_result);
+MS_DLL_EXPORT void msApplyMapConfigOptions(mapObj *map);
+MS_DLL_EXPORT int msMapComputeGeotransform(mapObj *map);
+int msMapComputeGeotransformEx(mapObj *map, double resolutionX,
+                               double resolutionY);
+
+MS_DLL_EXPORT void msMapPixelToGeoref(mapObj *map, double *x, double *y);
+MS_DLL_EXPORT void msMapGeorefToPixel(mapObj *map, double *x, double *y);
+
+MS_DLL_EXPORT int msMapSetExtent(mapObj *map, double minx, double miny,
+                                 double maxx, double maxy);
+MS_DLL_EXPORT int msMapOffsetExtent(mapObj *map, double x, double y);
+MS_DLL_EXPORT int msMapScaleExtent(mapObj *map, double zoomfactor,
+                                   double minscaledenom, double maxscaledenom);
+MS_DLL_EXPORT int msMapSetCenter(mapObj *map, pointObj *center);
+MS_DLL_EXPORT int msMapSetRotation(mapObj *map, double rotation_angle);
+MS_DLL_EXPORT int msMapSetSize(mapObj *map, int width, int height);
+MS_DLL_EXPORT int msMapSetSize(mapObj *map, int width, int height);
+MS_DLL_EXPORT int msMapSetFakedExtent(mapObj *map);
+MS_DLL_EXPORT int msMapRestoreRealExtent(mapObj *map);
+MS_DLL_EXPORT int msMapLoadOWSParameters(mapObj *map, cgiRequestObj *request,
+                                         const char *wmtver_string);
+MS_DLL_EXPORT int msMapIgnoreMissingData(mapObj *map);
+
+/* mapfile.c */
+
+MS_DLL_EXPORT int msValidateParameter(const char *value, const char *pattern1,
+                                      const char *pattern2,
+                                      const char *pattern3,
+                                      const char *pattern4);
+MS_DLL_EXPORT int msGetLayerIndex(mapObj *map, const char *name);
+MS_DLL_EXPORT int msGetSymbolIndex(symbolSetObj *set, const char *name,
+                                   int try_addimage_if_notfound);
+MS_DLL_EXPORT mapObj *msLoadMap(const char *filename, const char *new_mappath,
+                                const configObj *config);
+MS_DLL_EXPORT int msTransformXmlMapfile(const char *stylesheet,
+                                        const char *xmlMapfile, FILE *tmpfile);
+MS_DLL_EXPORT int msSaveMap(mapObj *map, char *filename);
+MS_DLL_EXPORT int msSaveConfig(configObj *map, const char *filename);
+MS_DLL_EXPORT void msFreeCharArray(char **array, int num_items);
+MS_DLL_EXPORT int msUpdateScalebarFromString(scalebarObj *scalebar,
+                                             char *string);
+MS_DLL_EXPORT int msUpdateQueryMapFromString(queryMapObj *querymap,
+                                             char *string);
+MS_DLL_EXPORT int msUpdateLabelFromString(labelObj *label, char *string);
+MS_DLL_EXPORT int msUpdateClusterFromString(clusterObj *cluster, char *string);
+MS_DLL_EXPORT int msUpdateReferenceMapFromString(referenceMapObj *ref,
+                                                 char *string);
+MS_DLL_EXPORT int msUpdateLegendFromString(legendObj *legend, char *string);
+MS_DLL_EXPORT int msUpdateWebFromString(webObj *web, char *string);
+MS_DLL_EXPORT int msUpdateStyleFromString(styleObj *style, char *string);
+MS_DLL_EXPORT int msUpdateClassFromString(classObj *_class, char *string);
+MS_DLL_EXPORT int msUpdateLayerFromString(layerObj *layer, char *string);
+MS_DLL_EXPORT char *msWriteLayerToString(layerObj *layer);
+MS_DLL_EXPORT char *msWriteMapToString(mapObj *map);
+MS_DLL_EXPORT char *msWriteClassToString(classObj *_class);
+MS_DLL_EXPORT char *msWriteStyleToString(styleObj *style);
+MS_DLL_EXPORT char *msWriteLabelToString(labelObj *label);
+MS_DLL_EXPORT char *msWriteWebToString(webObj *web);
+MS_DLL_EXPORT char *msWriteScalebarToString(scalebarObj *scalebar);
+MS_DLL_EXPORT char *msWriteQueryMapToString(queryMapObj *querymap);
+MS_DLL_EXPORT char *msWriteReferenceMapToString(referenceMapObj *ref);
+MS_DLL_EXPORT char *msWriteLegendToString(legendObj *legend);
+MS_DLL_EXPORT char *msWriteClusterToString(clusterObj *cluster);
+MS_DLL_EXPORT int msIsValidRegex(const char *e);
+MS_DLL_EXPORT int msEvalRegex(const char *e, const char *s);
+MS_DLL_EXPORT int msCaseEvalRegex(const char *e, const char *s);
+#ifdef USE_MSFREE
+MS_DLL_EXPORT void msFree(void *p);
+#else
+#define msFree free
+#endif
+MS_DLL_EXPORT char **msTokenizeMap(char *filename, int *numtokens);
+MS_DLL_EXPORT int msInitLabelCache(labelCacheObj *cache);
+MS_DLL_EXPORT int msFreeLabelCache(labelCacheObj *cache);
+MS_DLL_EXPORT int msCheckConnection(
+    layerObj *layer); /* connection pooling functions (mapfile.c) */
+MS_DLL_EXPORT void msCloseConnections(mapObj *map);
+
+MS_DLL_EXPORT void msOGRInitialize(void);
+MS_DLL_EXPORT void msOGRCleanup(void);
+MS_DLL_EXPORT void msGDALCleanup(void);
+MS_DLL_EXPORT void msGDALInitialize(void);
+
+MS_DLL_EXPORT imageObj *msDrawScalebar(mapObj *map); /* in mapscale.c */
+MS_DLL_EXPORT int msCalculateScale(rectObj extent, int units, int width,
+                                   int height, double resolution,
+                                   double *scaledenom);
+MS_DLL_EXPORT double GetDeltaExtentsUsingScale(double scale, int units,
+                                               double centerLat, int width,
+                                               double resolution);
+MS_DLL_EXPORT double Pix2Georef(int nPixPos, int nPixMin, int nPixMax,
+                                double dfGeoMin, double dfGeoMax,
+                                int bULisYOrig);
+MS_DLL_EXPORT double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value);
+MS_DLL_EXPORT double msInchesPerUnit(int units, double center_lat);
+MS_DLL_EXPORT int msEmbedScalebar(mapObj *map, imageObj *img);
+
+MS_DLL_EXPORT int msPointInRect(const pointObj *p,
+                                const rectObj *rect); /* in mapsearch.c */
+MS_DLL_EXPORT int msRectOverlap(const rectObj *a, const rectObj *b);
+MS_DLL_EXPORT int msRectContained(const rectObj *a, const rectObj *b);
+MS_DLL_EXPORT int msRectIntersect(rectObj *a, const rectObj *b);
+
+MS_DLL_EXPORT void msRectToFormattedString(rectObj *rect, char *format,
+                                           char *buffer, int buffer_length);
+MS_DLL_EXPORT void msPointToFormattedString(pointObj *point, const char *format,
+                                            char *buffer, int buffer_length);
+MS_DLL_EXPORT int msIsDegenerateShape(shapeObj *shape);
+
+MS_DLL_EXPORT void msMergeRect(rectObj *a, rectObj *b);
+MS_DLL_EXPORT double msDistancePointToPoint(pointObj *a, pointObj *b);
+MS_DLL_EXPORT double msSquareDistancePointToPoint(pointObj *a, pointObj *b);
+MS_DLL_EXPORT double msDistancePointToSegment(pointObj *p, pointObj *a,
+                                              pointObj *b);
+MS_DLL_EXPORT double msSquareDistancePointToSegment(pointObj *p, pointObj *a,
+                                                    pointObj *b);
+MS_DLL_EXPORT double msDistancePointToShape(pointObj *p, shapeObj *shape);
+MS_DLL_EXPORT double msSquareDistancePointToShape(pointObj *p, shapeObj *shape);
+MS_DLL_EXPORT double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb,
+                                                pointObj *pc, pointObj *pd);
+MS_DLL_EXPORT double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msIntersectSegments(const pointObj *a, const pointObj *b,
+                                      const pointObj *c, const pointObj *d);
+MS_DLL_EXPORT int msPointInPolygon(pointObj *p, lineObj *c);
+MS_DLL_EXPORT int msIntersectMultipointPolygon(shapeObj *multipoint,
+                                               shapeObj *polygon);
+MS_DLL_EXPORT int msIntersectPointPolygon(pointObj *p, shapeObj *polygon);
+MS_DLL_EXPORT int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly);
+MS_DLL_EXPORT int msIntersectPolygons(shapeObj *p1, shapeObj *p2);
+MS_DLL_EXPORT int msIntersectPolylines(shapeObj *line1, shapeObj *line2);
+
+MS_DLL_EXPORT int msInitQuery(queryObj *query); /* in mapquery.c */
+MS_DLL_EXPORT void msFreeQuery(queryObj *query);
+MS_DLL_EXPORT int msSaveQuery(mapObj *map, char *filename, int results);
+MS_DLL_EXPORT int msLoadQuery(mapObj *map, char *filename);
+MS_DLL_EXPORT int msExecuteQuery(mapObj *map);
+
+MS_DLL_EXPORT int
+msQueryByIndex(mapObj *map); /* various query methods, all rely on the queryObj
+                                hung off the mapObj */
+MS_DLL_EXPORT int msQueryByAttributes(mapObj *map);
+MS_DLL_EXPORT int msQueryByPoint(mapObj *map);
+MS_DLL_EXPORT int msQueryByRect(mapObj *map);
+MS_DLL_EXPORT int msQueryByFeatures(mapObj *map);
+MS_DLL_EXPORT int msQueryByShape(mapObj *map);
+MS_DLL_EXPORT int msQueryByFilter(mapObj *map);
+
+MS_DLL_EXPORT int msGetQueryResultBounds(mapObj *map, rectObj *bounds);
+MS_DLL_EXPORT int msIsLayerQueryable(layerObj *lp);
+MS_DLL_EXPORT void msQueryFree(mapObj *map, int qlayer); /* todo: rename */
+MS_DLL_EXPORT int msRasterQueryByShape(mapObj *map, layerObj *layer,
+                                       shapeObj *selectshape);
+MS_DLL_EXPORT int msRasterQueryByRect(mapObj *map, layerObj *layer,
+                                      rectObj queryRect);
+MS_DLL_EXPORT int msRasterQueryByPoint(mapObj *map, layerObj *layer, int mode,
+                                       pointObj p, double buffer,
+                                       int maxresults);
+
+/* in mapstring.c */
+MS_DLL_EXPORT void msStringTrim(char *str);
+MS_DLL_EXPORT void msStringTrimBlanks(char *string);
+MS_DLL_EXPORT char *msStringTrimLeft(char *string);
+MS_DLL_EXPORT char *msStringChop(char *string);
+MS_DLL_EXPORT void msStringTrimEOL(char *string);
+MS_DLL_EXPORT char *msReplaceSubstring(char *str, const char *old,
+                                       const char *sznew);
+MS_DLL_EXPORT void msReplaceChar(char *str, char old, char sznew);
+MS_DLL_EXPORT char *msCaseReplaceSubstring(char *str, const char *old,
+                                           const char *sznew);
+MS_DLL_EXPORT char *msStripPath(char *fn);
+MS_DLL_EXPORT char *msGetPath(const char *fn);
+MS_DLL_EXPORT char *msBuildPath(char *pszReturnPath, const char *abs_path,
+                                const char *path);
+MS_DLL_EXPORT char *msBuildPath3(char *pszReturnPath, const char *abs_path,
+                                 const char *path1, const char *path2);
+MS_DLL_EXPORT char *msTryBuildPath(char *szReturnPath, const char *abs_path,
+                                   const char *path);
+MS_DLL_EXPORT char *msTryBuildPath3(char *szReturnPath, const char *abs_path,
+                                    const char *path1, const char *path2);
+MS_DLL_EXPORT char **msStringSplit(const char *string, char cd,
+                                   int *num_tokens);
+MS_DLL_EXPORT char **msStringSplitComplex(const char *pszString,
+                                          const char *pszDelimiters,
+                                          int *num_tokens, int nFlags);
+MS_DLL_EXPORT int msStringArrayContains(char **array, const char *element,
+                                        int numElements);
+MS_DLL_EXPORT char **msStringTokenize(const char *pszLine, const char *pszDelim,
+                                      int *num_tokens, int preserve_quote);
+MS_DLL_EXPORT int msCountChars(char *str, char ch);
+MS_DLL_EXPORT char *msLongToString(long value);
+MS_DLL_EXPORT char *msDoubleToString(double value, int force_f);
+MS_DLL_EXPORT char *msIntToString(int value);
+MS_DLL_EXPORT void msStringToUpper(char *string);
+MS_DLL_EXPORT void msStringToLower(char *string);
+MS_DLL_EXPORT void msStringInitCap(char *string);
+MS_DLL_EXPORT void msStringFirstCap(char *string);
+MS_DLL_EXPORT int msEncodeChar(const char);
+MS_DLL_EXPORT char *msEncodeUrlExcept(const char *, const char);
+MS_DLL_EXPORT char *msEncodeUrl(const char *);
+MS_DLL_EXPORT char *msEscapeJSonString(const char *pszJSonString);
+MS_DLL_EXPORT char *msEncodeHTMLEntities(const char *string);
+MS_DLL_EXPORT void msDecodeHTMLEntities(const char *string);
+MS_DLL_EXPORT int msIsXMLTagValid(const char *string);
+MS_DLL_EXPORT char *msStringConcatenate(char *pszDest, const char *pszSrc);
+MS_DLL_EXPORT char *msJoinStrings(char **array, int arrayLength,
+                                  const char *delimeter);
+MS_DLL_EXPORT char *msHashString(const char *pszStr);
+MS_DLL_EXPORT char *msCommifyString(char *str);
+MS_DLL_EXPORT int msHexToInt(char *hex);
+MS_DLL_EXPORT char *msGetEncodedString(const char *string,
+                                       const char *encoding);
+MS_DLL_EXPORT char *msConvertWideStringToUTF8(const wchar_t *string,
+                                              const char *encoding);
+MS_DLL_EXPORT wchar_t *msConvertWideStringFromUTF8(const char *string,
+                                                   const char *encoding);
+MS_DLL_EXPORT int msGetNextGlyph(const char **in_ptr, char *out_string);
+MS_DLL_EXPORT int msGetNumGlyphs(const char *in_ptr);
+MS_DLL_EXPORT int msGetUnicodeEntity(const char *inptr, unsigned int *unicode);
+MS_DLL_EXPORT int msStringIsInteger(const char *string);
+MS_DLL_EXPORT int msUTF8ToUniChar(const char *str,
+                                  unsigned int *chPtr); /* maptclutf.c */
+MS_DLL_EXPORT char *msStringEscape(const char *pszString);
+MS_DLL_EXPORT int msStringInArray(const char *pszString, char **array,
+                                  int numelements);
+
+typedef struct msStringBuffer msStringBuffer;
+MS_DLL_EXPORT msStringBuffer *msStringBufferAlloc(void);
+MS_DLL_EXPORT void msStringBufferFree(msStringBuffer *sb);
+MS_DLL_EXPORT const char *msStringBufferGetString(msStringBuffer *sb);
+MS_DLL_EXPORT char *msStringBufferReleaseStringAndFree(msStringBuffer *sb);
+MS_DLL_EXPORT int msStringBufferAppend(msStringBuffer *sb,
+                                       const char *pszAppendedString);
+
+MS_DLL_EXPORT int msStringToInt(const char *str, int *value, int base);
+MS_DLL_EXPORT int msStringToDouble(const char *str, double *value);
+
+#ifdef __cplusplus
+}
+std::string msStdStringEscape(const char *pszString);
+void msStringTrim(std::string &string);
+void msStringTrimBlanks(std::string &string);
+void msStringTrimLeft(std::string &string);
+std::vector<std::string> msStringSplit(const char *string, char cd);
+std::string msStringToLower(const std::string &s);
+bool msStringInArray(const char *pszString,
+                     const std::vector<std::string> &array);
+extern "C" {
+#endif
+
+#ifndef HAVE_STRRSTR
+MS_DLL_EXPORT char *strrstr(const char *string, const char *find);
+#endif /* NEED_STRRSTR */
+
+#ifndef HAVE_STRCASESTR
+MS_DLL_EXPORT char *strcasestr(const char *s, const char *find);
+#endif /* NEED_STRCASESTR */
+
+#ifndef HAVE_STRNCASECMP
+MS_DLL_EXPORT int strncasecmp(const char *s1, const char *s2, size_t len);
+#endif /* NEED_STRNCASECMP */
+
+#ifndef HAVE_STRCASECMP
+MS_DLL_EXPORT int strcasecmp(const char *s1, const char *s2);
+#endif /* NEED_STRCASECMP */
+
+#ifndef HAVE_STRLCAT
+MS_DLL_EXPORT size_t strlcat(char *dst, const char *src, size_t siz);
+#endif /* NEED_STRLCAT */
+
+#ifndef HAVE_STRLCPY
+MS_DLL_EXPORT size_t strlcpy(char *dst, const char *src, size_t siz);
+#endif /* NEED_STRLCAT */
+
+MS_DLL_EXPORT char *msStrdup(const char *pszString);
+
+#include "hittest.h"
+
+/* in mapsymbol.c */
+/* Use this function *only* with mapfile loading phase */
+MS_DLL_EXPORT int loadSymbolSet(symbolSetObj *symbolset, mapObj *map);
+/* Use this threadsafe wrapper everywhere else */
+MS_DLL_EXPORT int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map);
+MS_DLL_EXPORT int msCopySymbol(symbolObj *dst, const symbolObj *src,
+                               mapObj *map);
+MS_DLL_EXPORT int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src,
+                                  mapObj *map);
+MS_DLL_EXPORT int msCopyHashTable(hashTableObj *dst, const hashTableObj *src);
+MS_DLL_EXPORT void msInitSymbolSet(symbolSetObj *symbolset);
+MS_DLL_EXPORT symbolObj *msGrowSymbolSet(symbolSetObj *symbolset);
+MS_DLL_EXPORT int msAddImageSymbol(symbolSetObj *symbolset,
+                                   const char *filename);
+MS_DLL_EXPORT int msFreeSymbolSet(symbolSetObj *symbolset);
+MS_DLL_EXPORT int msFreeSymbol(symbolObj *symbol);
+MS_DLL_EXPORT int msAddNewSymbol(mapObj *map, const char *name);
+MS_DLL_EXPORT int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol);
+MS_DLL_EXPORT symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int index);
+MS_DLL_EXPORT int msSaveSymbolSet(symbolSetObj *symbolset,
+                                  const char *filename);
+MS_DLL_EXPORT int msLoadImageSymbol(symbolObj *symbol, const char *filename);
+MS_DLL_EXPORT int msPreloadImageSymbol(rendererVTableObj *renderer,
+                                       symbolObj *symbol);
+MS_DLL_EXPORT int msPreloadSVGSymbol(symbolObj *symbol);
+MS_DLL_EXPORT symbolObj *msRotateSymbol(symbolObj *symbol, double angle);
+
+MS_DLL_EXPORT int WARN_UNUSED msGetCharacterSize(mapObj *map, const char *font,
+                                                 int size,
+                                                 const char *character,
+                                                 rectObj *r);
+MS_DLL_EXPORT int WARN_UNUSED msGetMarkerSize(mapObj *map, styleObj *style,
+                                              double *width, double *height,
+                                              double scalefactor);
+/* MS_DLL_EXPORT int msGetCharacterSize(char *character, int size, char *font,
+ * rectObj *rect); */
+MS_DLL_EXPORT double msSymbolGetDefaultSize(symbolObj *s);
+MS_DLL_EXPORT void freeImageCache(struct imageCacheObj *ic);
+
+MS_DLL_EXPORT imageObj WARN_UNUSED *
+msDrawLegend(mapObj *map, int scale_independent,
+             map_hittest *hittest); /* in maplegend.c */
+MS_DLL_EXPORT int WARN_UNUSED msLegendCalcSize(
+    mapObj *map, int scale_independent, int *size_x, int *size_y, int *alayers,
+    int numl_ayer, map_hittest *hittest, double resolutionfactor);
+MS_DLL_EXPORT int WARN_UNUSED msEmbedLegend(mapObj *map, imageObj *img);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLegendIcon(mapObj *map, layerObj *lp,
+                                               classObj *myClass, int width,
+                                               int height, imageObj *img,
+                                               int dstX, int dstY,
+                                               int scale_independant,
+                                               class_hittest *hittest);
+MS_DLL_EXPORT imageObj WARN_UNUSED *
+msCreateLegendIcon(mapObj *map, layerObj *lp, classObj *myClass, int width,
+                   int height, int scale_independant);
+
+MS_DLL_EXPORT int msLoadFontSet(fontSetObj *fontSet,
+                                mapObj *map); /* in maplabel.c */
+MS_DLL_EXPORT int msInitFontSet(fontSetObj *fontset);
+MS_DLL_EXPORT int msFreeFontSet(fontSetObj *fontset);
+
+MS_DLL_EXPORT int WARN_UNUSED msGetTextSymbolSize(mapObj *map,
+                                                  textSymbolObj *ts,
+                                                  rectObj *r);
+MS_DLL_EXPORT int WARN_UNUSED msGetStringSize(mapObj *map, labelObj *label,
+                                              int size, char *string,
+                                              rectObj *r);
+
+MS_DLL_EXPORT int WARN_UNUSED msAddLabel(mapObj *map, imageObj *image,
+                                         labelObj *label, int layerindex,
+                                         int classindex, shapeObj *shape,
+                                         pointObj *point, double featuresize,
+                                         textSymbolObj *ts);
+MS_DLL_EXPORT int WARN_UNUSED msAddLabelGroup(mapObj *map, imageObj *image,
+                                              layerObj *layer, int classindex,
+                                              shapeObj *shape, pointObj *point,
+                                              double featuresize);
+MS_DLL_EXPORT void insertRenderedLabelMember(mapObj *map,
+                                             labelCacheMemberObj *cachePtr);
+MS_DLL_EXPORT int msTestLabelCacheCollisions(mapObj *map,
+                                             labelCacheMemberObj *cachePtr,
+                                             label_bounds *lb,
+                                             int current_priority,
+                                             int current_label);
+MS_DLL_EXPORT int msTestLabelCacheLeaderCollision(mapObj *map, pointObj *lp1,
+                                                  pointObj *lp2);
+MS_DLL_EXPORT labelCacheMemberObj *
+msGetLabelCacheMember(labelCacheObj *labelcache, int i);
+
+MS_DLL_EXPORT void msFreeShape(shapeObj *shape); /* in mapprimitive.c */
+int msGetShapeRAMSize(shapeObj *shape);          /* in mapprimitive.c */
+MS_DLL_EXPORT void msFreeLabelPathObj(labelPathObj *path);
+MS_DLL_EXPORT shapeObj *msShapeFromWKT(const char *string);
+MS_DLL_EXPORT char *msShapeToWKT(shapeObj *shape);
+MS_DLL_EXPORT void msInitShape(shapeObj *shape);
+MS_DLL_EXPORT void msShapeDeleteLine(shapeObj *shape, int line);
+MS_DLL_EXPORT int msCopyShape(const shapeObj *from, shapeObj *to);
+MS_DLL_EXPORT int msIsOuterRing(shapeObj *shape, int r);
+MS_DLL_EXPORT int *msGetOuterList(shapeObj *shape);
+MS_DLL_EXPORT int *msGetInnerList(shapeObj *shape, int r, int *outerlist);
+MS_DLL_EXPORT void msComputeBounds(shapeObj *shape);
+MS_DLL_EXPORT void msRectToPolygon(rectObj rect, shapeObj *poly);
+MS_DLL_EXPORT void msClipPolylineRect(shapeObj *shape, rectObj rect);
+MS_DLL_EXPORT void msClipPolygonRect(shapeObj *shape, rectObj rect);
+MS_DLL_EXPORT void msTransformShape(shapeObj *shape, rectObj extent,
+                                    double cellsize, imageObj *image);
+MS_DLL_EXPORT void msTransformPoint(pointObj *point, rectObj *extent,
+                                    double cellsize, imageObj *image);
+
+MS_DLL_EXPORT void msOffsetPointRelativeTo(pointObj *point, layerObj *layer);
+MS_DLL_EXPORT void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer);
+MS_DLL_EXPORT void msTransformShapeSimplify(shapeObj *shape, rectObj extent,
+                                            double cellsize);
+MS_DLL_EXPORT void msTransformShapeToPixelSnapToGrid(shapeObj *shape,
+                                                     rectObj extent,
+                                                     double cellsize,
+                                                     double grid_resolution);
+MS_DLL_EXPORT void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent,
+                                                double cellsize);
+MS_DLL_EXPORT void msTransformShapeToPixelDoublePrecision(shapeObj *shape,
+                                                          rectObj extent,
+                                                          double cellsize);
+
+MS_DLL_EXPORT shapeObj *msDensify(shapeObj *shape, double tolerance);
+MS_DLL_EXPORT shapeObj *msRings2Shape(shapeObj *shape, int outer);
+
+#ifndef SWIG
+
+struct line_lengths {
+  double *segment_lengths;
+  double total_length;
+  int longest_segment_index;
+};
+
+struct polyline_lengths {
+  struct line_lengths *ll;
+  double total_length;
+  int longest_line_index;
+  int longest_segment_line_index, longest_segment_point_index;
+};
+
+struct label_auto_result {
+  pointObj *label_points;
+  double *angles;
+  int num_label_points;
+};
+
+struct label_follow_result {
+  textSymbolObj **follow_labels;
+  int num_follow_labels;
+  struct label_auto_result lar;
+};
+
+#endif
+
+MS_DLL_EXPORT void msTransformPixelToShape(shapeObj *shape, rectObj extent,
+                                           double cellsize);
+MS_DLL_EXPORT void msPolylineComputeLineSegments(shapeObj *shape,
+                                                 struct polyline_lengths *pll);
+MS_DLL_EXPORT int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p,
+                                      textSymbolObj *ts, labelObj *label,
+                                      struct label_follow_result *lfr);
+MS_DLL_EXPORT int WARN_UNUSED msPolylineLabelPoint(
+    mapObj *map, shapeObj *p, textSymbolObj *ts, labelObj *label,
+    struct label_auto_result *lar, double resolutionfactor);
+MS_DLL_EXPORT int WARN_UNUSED msLineLabelPath(mapObj *map, imageObj *img,
+                                              lineObj *p, textSymbolObj *ts,
+                                              struct line_lengths *ll,
+                                              struct label_follow_result *lfr,
+                                              labelObj *lbl);
+MS_DLL_EXPORT int WARN_UNUSED msLineLabelPoint(
+    mapObj *map, lineObj *p, textSymbolObj *ts, struct line_lengths *ll,
+    struct label_auto_result *lar, labelObj *lbl, double resolutionfactor);
+MS_DLL_EXPORT int msPolygonLabelPoint(shapeObj *p, pointObj *lp,
+                                      double min_dimension);
+MS_DLL_EXPORT int msAddLine(shapeObj *p, const lineObj *new_line);
+MS_DLL_EXPORT int msAddLineDirectly(shapeObj *p, lineObj *new_line);
+MS_DLL_EXPORT int msAddPointToLine(lineObj *line, pointObj *point);
+MS_DLL_EXPORT double msGetPolygonArea(shapeObj *p);
+MS_DLL_EXPORT int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny,
+                                       double *maxy);
+
+MS_DLL_EXPORT int msDrawRasterLayer(mapObj *map, layerObj *layer,
+                                    imageObj *image); /* in mapraster.c */
+MS_DLL_EXPORT imageObj *msDrawReferenceMap(mapObj *map);
+
+/* mapbits.c - bit array handling functions and macros */
+
+#define MS_ARRAY_BIT 32
+
+#define MS_GET_BIT(array, i) (array[i >> 5] & (1 << (i & 0x3f)))
+#define MS_SET_BIT(array, i)                                                   \
+  { array[i >> 5] |= (1 << (i & 0x3f)); }
+#define MS_CLR_BIT(array, i)                                                   \
+  { array[i >> 5] &= (~(1 << (i & 0x3f))); }
+
+MS_DLL_EXPORT size_t msGetBitArraySize(int numbits); /* in mapbits.c */
+MS_DLL_EXPORT ms_bitarray msAllocBitArray(int numbits);
+MS_DLL_EXPORT int msGetBit(ms_const_bitarray array, int index);
+MS_DLL_EXPORT void msSetBit(ms_bitarray array, int index, int value);
+MS_DLL_EXPORT void msSetAllBits(ms_bitarray array, int index, int value);
+MS_DLL_EXPORT void msFlipBit(ms_bitarray array, int index);
+MS_DLL_EXPORT int msGetNextBit(ms_const_bitarray array, int index, int size);
+
+/* maplayer.c - layerObj  api */
+
+MS_DLL_EXPORT int msLayerInitItemInfo(layerObj *layer);
+MS_DLL_EXPORT void msLayerFreeItemInfo(layerObj *layer);
+
+MS_DLL_EXPORT int msLayerOpen(layerObj *layer); /* in maplayer.c */
+MS_DLL_EXPORT int msLayerApplyScaletokens(layerObj *layer, double scale);
+MS_DLL_EXPORT int msLayerRestoreFromScaletokens(layerObj *layer);
+MS_DLL_EXPORT int msClusterLayerOpen(layerObj *layer); /* in mapcluster.c */
+MS_DLL_EXPORT int msLayerIsOpen(layerObj *layer);
+MS_DLL_EXPORT void msLayerClose(layerObj *layer);
+MS_DLL_EXPORT void msLayerFreeExpressions(layerObj *layer);
+MS_DLL_EXPORT int msLayerWhichShapes(layerObj *layer, rectObj rect,
+                                     int isQuery);
+MS_DLL_EXPORT int msLayerGetItemIndex(layerObj *layer, char *item);
+MS_DLL_EXPORT int msLayerWhichItems(layerObj *layer, int get_all,
+                                    const char *metadata);
+MS_DLL_EXPORT int msLayerNextShape(layerObj *layer, shapeObj *shape);
+MS_DLL_EXPORT int msLayerGetItems(layerObj *layer);
+MS_DLL_EXPORT int msLayerSetItems(layerObj *layer, char **items, int numitems);
+MS_DLL_EXPORT int msLayerGetShape(layerObj *layer, shapeObj *shape,
+                                  resultObj *record);
+MS_DLL_EXPORT int msLayerGetShapeCount(layerObj *layer, rectObj rect,
+                                       projectionObj *rectProjection);
+MS_DLL_EXPORT int msLayerGetExtent(layerObj *layer, rectObj *extent);
+MS_DLL_EXPORT int msLayerSetExtent(layerObj *layer, double minx, double miny,
+                                   double maxx, double maxy);
+MS_DLL_EXPORT int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                      shapeObj *shape);
+MS_DLL_EXPORT int msLayerGetFeatureStyle(mapObj *map, layerObj *layer,
+                                         classObj *c, shapeObj *shape);
+MS_DLL_EXPORT void msLayerAddProcessing(layerObj *layer, const char *directive);
+MS_DLL_EXPORT void msLayerSetProcessingKey(layerObj *layer, const char *key,
+                                           const char *value);
+MS_DLL_EXPORT const char *msLayerGetProcessing(const layerObj *layer,
+                                               int proc_index);
+MS_DLL_EXPORT const char *msLayerGetProcessingKey(const layerObj *layer,
+                                                  const char *);
+MS_DLL_EXPORT int msLayerClearProcessing(layerObj *layer);
+MS_DLL_EXPORT void
+msLayerSubstituteProcessing(layerObj *layer, const char *from, const char *to);
+MS_DLL_EXPORT char *msLayerGetFilterString(layerObj *layer);
+MS_DLL_EXPORT int msLayerEncodeShapeAttributes(layerObj *layer,
+                                               shapeObj *shape);
+
+MS_DLL_EXPORT int msLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                         char *filteritem);
+MS_DLL_EXPORT int msLayerSupportsCommonFilters(layerObj *layer);
+MS_DLL_EXPORT const char *msExpressionTokenToString(int token);
+MS_DLL_EXPORT int msTokenizeExpression(expressionObj *expression, char **list,
+                                       int *listsize);
+
+MS_DLL_EXPORT int msLayerSetTimeFilter(layerObj *lp, const char *timestring,
+                                       const char *timefield);
+MS_DLL_EXPORT int msLayerMakeBackticsTimeFilter(layerObj *lp,
+                                                const char *timestring,
+                                                const char *timefield);
+MS_DLL_EXPORT int msLayerMakePlainTimeFilter(layerObj *lp,
+                                             const char *timestring,
+                                             const char *timefield);
+
+MS_DLL_EXPORT int msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode,
+                                                   mapObj *map,
+                                                   int iLayerIndex);
+MS_DLL_EXPORT int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode,
+                                                 mapObj *map, int iLayerIndex);
+
+/* maplayer.c */
+MS_DLL_EXPORT int msLayerGetNumFeatures(layerObj *layer);
+
+MS_DLL_EXPORT int msLayerSupportsPaging(layerObj *layer);
+
+MS_DLL_EXPORT void msLayerEnablePaging(layerObj *layer, int value);
+MS_DLL_EXPORT int msLayerGetPaging(layerObj *layer);
+
+MS_DLL_EXPORT int msLayerGetMaxFeaturesToDraw(layerObj *layer,
+                                              outputFormatObj *format);
+
+MS_DLL_EXPORT char *msLayerEscapeSQLParam(layerObj *layer,
+                                          const char *pszString);
+MS_DLL_EXPORT char *msLayerEscapePropertyName(layerObj *layer,
+                                              const char *pszString);
+
+int msLayerSupportsSorting(layerObj *layer);
+void msLayerSetSort(layerObj *layer, const sortByClause *sortBy);
+MS_DLL_EXPORT char *msLayerBuildSQLOrderBy(layerObj *layer);
+
+/* These are special because SWF is using these */
+int msOGRLayerNextShape(layerObj *layer, shapeObj *shape);
+int msOGRLayerGetItems(layerObj *layer);
+void msOGRLayerFreeItemInfo(layerObj *layer);
+int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
+int msOGRLayerGetExtent(layerObj *layer, rectObj *extent);
+
+reprojectionObj MS_DLL_EXPORT *msLayerGetReprojectorToMap(layerObj *layer,
+                                                          mapObj *map);
+
+MS_DLL_EXPORT int msOGRGeometryToShape(OGRGeometryH hGeometry, shapeObj *shape,
+                                       OGRwkbGeometryType type);
+
+MS_DLL_EXPORT int msInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msConnectLayer(layerObj *layer, const int connectiontype,
+                                 const char *library_str);
+
+MS_DLL_EXPORT int msINLINELayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msSHPLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msTiledSHPLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msOGRLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msPostGISLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msWFSLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msGraticuleLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msRASTERLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msUVRASTERLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msContourLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msPluginLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msUnionLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT void msPluginFreeVirtualTableFactory(void);
+
+MS_DLL_EXPORT int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect,
+                                            projectionObj *rectProjection);
+void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj *layer,
+                                                                mapObj *map);
+rectObj msUVRASTERGetSearchRect(layerObj *layer, mapObj *map);
+
+/* ==================================================================== */
+/*      Prototypes for functions in mapdraw.c                           */
+/* ==================================================================== */
+
+MS_DLL_EXPORT imageObj *msPrepareImage(mapObj *map, int allow_nonsquare);
+MS_DLL_EXPORT imageObj *msDrawMap(mapObj *map, int querymap);
+MS_DLL_EXPORT int msLayerIsVisible(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image);
+MS_DLL_EXPORT int msDrawVectorLayer(mapObj *map, layerObj *layer,
+                                    imageObj *image);
+MS_DLL_EXPORT int msDrawQueryLayer(mapObj *map, layerObj *layer,
+                                   imageObj *image);
+MS_DLL_EXPORT int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image);
+MS_DLL_EXPORT int msDrawWFSLayer(mapObj *map, layerObj *layer, imageObj *image);
+
+#define MS_DRAWMODE_FEATURES 0x00001
+#define MS_DRAW_FEATURES(mode) (MS_DRAWMODE_FEATURES & (mode))
+#define MS_DRAWMODE_LABELS 0x00002
+#define MS_DRAW_LABELS(mode) (MS_DRAWMODE_LABELS & (mode))
+#define MS_DRAWMODE_SINGLESTYLE 0x00004
+#define MS_DRAW_SINGLESTYLE(mode) (MS_DRAWMODE_SINGLESTYLE & (mode))
+#define MS_DRAWMODE_QUERY 0x00008
+#define MS_DRAW_QUERY(mode) (MS_DRAWMODE_QUERY & (mode))
+#define MS_DRAWMODE_UNCLIPPEDLABELS 0x00010
+#define MS_DRAW_UNCLIPPED_LABELS(mode) (MS_DRAWMODE_UNCLIPPEDLABELS & (mode))
+#define MS_DRAWMODE_UNCLIPPEDLINES 0x00020
+#define MS_DRAW_UNCLIPPED_LINES(mode) (MS_DRAWMODE_UNCLIPPEDLINES & (mode))
+
+MS_DLL_EXPORT int WARN_UNUSED msDrawShape(mapObj *map, layerObj *layer,
+                                          shapeObj *shape, imageObj *image,
+                                          int style, int mode);
+MS_DLL_EXPORT int WARN_UNUSED msDrawPoint(mapObj *map, layerObj *layer,
+                                          pointObj *point, imageObj *image,
+                                          int classindex, char *labeltext);
+
+/*Range Support*/
+typedef enum { MS_COLORSPACE_RGB, MS_COLORSPACE_HSL } colorspace;
+MS_DLL_EXPORT int msShapeToRange(styleObj *style, shapeObj *shape);
+MS_DLL_EXPORT int msValueToRange(styleObj *style, double fieldVal,
+                                 colorspace cs);
+
+MS_DLL_EXPORT int WARN_UNUSED msDrawMarkerSymbol(mapObj *map, imageObj *image,
+                                                 pointObj *p, styleObj *style,
+                                                 double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLineSymbol(mapObj *map, imageObj *image,
+                                               shapeObj *p, styleObj *style,
+                                               double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawShadeSymbol(mapObj *map, imageObj *image,
+                                                shapeObj *p, styleObj *style,
+                                                double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msCircleDrawLineSymbol(mapObj *map,
+                                                     imageObj *image,
+                                                     pointObj *p, double r,
+                                                     styleObj *style,
+                                                     double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msCircleDrawShadeSymbol(mapObj *map,
+                                                      imageObj *image,
+                                                      pointObj *p, double r,
+                                                      styleObj *style,
+                                                      double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawPieSlice(mapObj *map, imageObj *image,
+                                             pointObj *p, styleObj *style,
+                                             double radius, double start,
+                                             double end);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLabelBounds(mapObj *map, imageObj *image,
+                                                label_bounds *bnds,
+                                                styleObj *style,
+                                                double scalefactor);
+
+MS_DLL_EXPORT void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map,
+                                                  layerObj *layer,
+                                                  imageObj *image);
+MS_DLL_EXPORT void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map,
+                                                  layerObj *layer,
+                                                  imageObj *image);
+
+MS_DLL_EXPORT int WARN_UNUSED msDrawLabel(mapObj *map, imageObj *image,
+                                          pointObj labelPnt, char *string,
+                                          labelObj *label, double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawTextSymbol(mapObj *map, imageObj *image,
+                                               pointObj labelPnt,
+                                               textSymbolObj *ts);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLabelCache(mapObj *map, imageObj *image);
+
+MS_DLL_EXPORT void msImageStartLayer(mapObj *map, layerObj *layer,
+                                     imageObj *image);
+MS_DLL_EXPORT void msImageEndLayer(mapObj *map, layerObj *layer,
+                                   imageObj *image);
+
+MS_DLL_EXPORT void msDrawStartShape(mapObj *map, layerObj *layer,
+                                    imageObj *image, shapeObj *shape);
+MS_DLL_EXPORT void msDrawEndShape(mapObj *map, layerObj *layer, imageObj *image,
+                                  shapeObj *shape);
+/* ==================================================================== */
+/*      End of Prototypes for functions in mapdraw.c                    */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      Prototypes for functions in mapgeomutil.cpp                       */
+/* ==================================================================== */
+MS_DLL_EXPORT shapeObj *msRasterizeArc(double x0, double y0, double radius,
+                                       double startAngle, double endAngle,
+                                       int isSlice);
+MS_DLL_EXPORT int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing,
+                                 double width, double *pattern,
+                                 int patternlength, double angle,
+                                 colorObj *color);
+
+/* ==================================================================== */
+/*      Prototypes for functions in mapimagemap.c                       */
+/* ==================================================================== */
+MS_DLL_EXPORT imageObj *
+msImageCreateIM(int width, int height, outputFormatObj *format, char *imagepath,
+                char *imageurl, double resolution, double defresolution);
+MS_DLL_EXPORT void msImageStartLayerIM(mapObj *map, layerObj *layer,
+                                       imageObj *image);
+MS_DLL_EXPORT int msSaveImageIM(imageObj *img, const char *filename,
+                                outputFormatObj *format);
+MS_DLL_EXPORT void msFreeImageIM(imageObj *img);
+MS_DLL_EXPORT void msDrawMarkerSymbolIM(mapObj *map, imageObj *img, pointObj *p,
+                                        styleObj *style, double scalefactor);
+MS_DLL_EXPORT void msDrawLineSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                                      styleObj *style, double scalefactor);
+MS_DLL_EXPORT void msDrawShadeSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                                       styleObj *style, double scalefactor);
+MS_DLL_EXPORT int msDrawTextIM(mapObj *map, imageObj *img, pointObj labelPnt,
+                               char *string, labelObj *label,
+                               double scalefactor);
+/* ==================================================================== */
+/*      End of Prototypes for functions in mapimagemap.c                */
+/* ==================================================================== */
+
+/* various JOIN functions (in mapjoin.c) */
+MS_DLL_EXPORT int msJoinConnect(layerObj *layer, joinObj *join);
+MS_DLL_EXPORT int msJoinPrepare(joinObj *join, shapeObj *shape);
+MS_DLL_EXPORT int msJoinNext(joinObj *join);
+MS_DLL_EXPORT int msJoinClose(joinObj *join);
+
+/*in mapraster.c */
+int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer);
+void *msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
+                                      const char *filename,
+                                      char szPath[MS_MAXPATHLEN],
+                                      char **p_decrypted_path);
+void msDrawRasterLayerLowCloseDataset(layerObj *layer, void *hDataset);
+int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer,
+                                    imageObj *image, rasterBufferObj *rb,
+                                    void *hDatasetIn);
+
+MS_DLL_EXPORT int msDrawRasterLayerLow(mapObj *map, layerObj *layer,
+                                       imageObj *image, rasterBufferObj *rb);
+MS_DLL_EXPORT int msGetClass(layerObj *layer, colorObj *color,
+                             int colormap_index);
+MS_DLL_EXPORT int msGetClass_FloatRGB(layerObj *layer, float fValue, int red,
+                                      int green, int blue);
+int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue,
+                                            int red, int green, int blue,
+                                            int firstClassToTry);
+
+/* in mapdrawgdal.c */
+MS_DLL_EXPORT int msDrawRasterLayerGDAL(mapObj *map, layerObj *layer,
+                                        imageObj *image, rasterBufferObj *rb,
+                                        void *hDSVoid);
+MS_DLL_EXPORT int msGetGDALGeoTransform(void *hDS, mapObj *map, layerObj *layer,
+                                        double *padfGeoTransform);
+MS_DLL_EXPORT int *msGetGDALBandList(layerObj *layer, void *hDS, int max_bands,
+                                     int *band_count);
+MS_DLL_EXPORT double msGetGDALNoDataValue(layerObj *layer, void *hBand,
+                                          int *pbGotNoData);
+
+/* in interpolation.c */
+MS_DLL_EXPORT int msInterpolationDataset(mapObj *map, imageObj *image,
+                                         layerObj *layer, void **hDSvoid,
+                                         void **cleanup_ptr);
+MS_DLL_EXPORT int msCleanupInterpolationDataset(mapObj *map, imageObj *image,
+                                                layerObj *layer,
+                                                void *cleanup_ptr);
+
+/* in mapchart.c */
+MS_DLL_EXPORT int msDrawChartLayer(mapObj *map, layerObj *layer,
+                                   imageObj *image);
+
+/* ==================================================================== */
+/*      End of prototypes for functions in mapgd.c                      */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      Prototypes for functions in maputil.c                           */
+/* ==================================================================== */
+
+MS_DLL_EXPORT int msScaleInBounds(double scale, double minscale,
+                                  double maxscale);
+MS_DLL_EXPORT void *msSmallMalloc(size_t nSize);
+MS_DLL_EXPORT void *msSmallRealloc(void *pData, size_t nNewSize);
+MS_DLL_EXPORT void *msSmallCalloc(size_t nCount, size_t nSize);
+MS_DLL_EXPORT int msIntegerInArray(const int value, int *array,
+                                   int numelements);
+
+MS_DLL_EXPORT int msExtentsOverlap(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req);
+
+/* For mapswf */
+MS_DLL_EXPORT int getRgbColor(mapObj *map, int i, int *r, int *g,
+                              int *b); /* maputil.c */
+
+MS_DLL_EXPORT int msBindLayerToShape(layerObj *layer, shapeObj *shape,
+                                     int querymapMode);
+MS_DLL_EXPORT int msValidateContexts(mapObj *map);
+MS_DLL_EXPORT int msEvalContext(mapObj *map, layerObj *layer, char *context);
+MS_DLL_EXPORT int msEvalExpression(layerObj *layer, shapeObj *shape,
+                                   expressionObj *expression, int itemindex);
+MS_DLL_EXPORT int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape,
+                                  int *classgroup, int numclasses);
+MS_DLL_EXPORT int msShapeGetNextClass(int currentclass, layerObj *layer,
+                                      mapObj *map, shapeObj *shape,
+                                      int *classgroup, int numclasses);
+MS_DLL_EXPORT int msShapeCheckSize(shapeObj *shape, double minfeaturesize);
+MS_DLL_EXPORT char *msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape,
+                                              labelObj *lbl);
+MS_DLL_EXPORT int msGetLabelStatus(mapObj *map, layerObj *layer,
+                                   shapeObj *shape, labelObj *lbl);
+MS_DLL_EXPORT int msAdjustImage(rectObj rect, int *width, int *height);
+MS_DLL_EXPORT char *msEvalTextExpression(expressionObj *expr, shapeObj *shape);
+MS_DLL_EXPORT char *msEvalTextExpressionJSonEscape(expressionObj *expr,
+                                                   shapeObj *shape);
+MS_DLL_EXPORT double msEvalDoubleExpression(expressionObj *expr,
+                                            shapeObj *shape);
+MS_DLL_EXPORT double msAdjustExtent(rectObj *rect, int width, int height);
+MS_DLL_EXPORT int msConstrainExtent(rectObj *bounds, rectObj *rect,
+                                    double overlay);
+MS_DLL_EXPORT int *msGetLayersIndexByGroup(mapObj *map, char *groupname,
+                                           int *nCount);
+MS_DLL_EXPORT unsigned char *msSaveImageBuffer(imageObj *image, int *size_ptr,
+                                               outputFormatObj *format);
+MS_DLL_EXPORT shapeObj *msOffsetPolyline(shapeObj *shape, double offsetx,
+                                         double offsety);
+MS_DLL_EXPORT int msMapSetLayerProjections(mapObj *map);
+
+/* Functions to chnage the drawing order of the layers. */
+/* Defined in mapobject.c */
+MS_DLL_EXPORT int msMoveLayerUp(mapObj *map, int nLayerIndex);
+MS_DLL_EXPORT int msMoveLayerDown(mapObj *map, int nLayerIndex);
+MS_DLL_EXPORT int msSetLayersdrawingOrder(mapObj *self, int *panIndexes);
+MS_DLL_EXPORT int msInsertLayer(mapObj *map, layerObj *layer, int nIndex);
+MS_DLL_EXPORT layerObj *msRemoveLayer(mapObj *map, int nIndex);
+
+/* Defined in layerobject.c */
+MS_DLL_EXPORT int msInsertClass(layerObj *layer, classObj *classobj,
+                                int nIndex);
+MS_DLL_EXPORT classObj *msRemoveClass(layerObj *layer, int nIndex);
+MS_DLL_EXPORT int msMoveClassUp(layerObj *layer, int nClassIndex);
+MS_DLL_EXPORT int msMoveClassDown(layerObj *layer, int nClassIndex);
+
+/* classobject.c */
+MS_DLL_EXPORT int msAddLabelToClass(classObj *classo, labelObj *label);
+MS_DLL_EXPORT labelObj *msRemoveLabelFromClass(classObj *classo,
+                                               int nLabelIndex);
+MS_DLL_EXPORT int msMoveStyleUp(classObj *classo, int nStyleIndex);
+MS_DLL_EXPORT int msMoveStyleDown(classObj *classo, int nStyleIndex);
+MS_DLL_EXPORT int msDeleteStyle(classObj *classo, int nStyleIndex);
+MS_DLL_EXPORT int msInsertStyle(classObj *classo, styleObj *style,
+                                int nStyleIndex);
+MS_DLL_EXPORT styleObj *msRemoveStyle(classObj *classo, int index);
+
+/* maplabel.c */
+MS_DLL_EXPORT int msInsertLabelStyle(labelObj *label, styleObj *style,
+                                     int nStyleIndex);
+MS_DLL_EXPORT int msMoveLabelStyleUp(labelObj *label, int nStyleIndex);
+MS_DLL_EXPORT int msMoveLabelStyleDown(labelObj *label, int nStyleIndex);
+MS_DLL_EXPORT int msDeleteLabelStyle(labelObj *label, int nStyleIndex);
+MS_DLL_EXPORT styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex);
+
+/* Measured shape utility functions. */
+MS_DLL_EXPORT pointObj *msGetPointUsingMeasure(shapeObj *shape, double m);
+MS_DLL_EXPORT pointObj *msGetMeasureUsingPoint(shapeObj *shape,
+                                               pointObj *point);
+
+MS_DLL_EXPORT char **msGetAllGroupNames(mapObj *map, int *numTok);
+MS_DLL_EXPORT char *msTmpFile(mapObj *map, const char *mappath,
+                              const char *tmppath, const char *ext);
+MS_DLL_EXPORT char *msTmpPath(mapObj *map, const char *mappath,
+                              const char *tmppath);
+MS_DLL_EXPORT char *msTmpFilename(const char *ext);
+MS_DLL_EXPORT void msForceTmpFileBase(const char *new_base);
+
+MS_DLL_EXPORT imageObj *msImageCreate(int width, int height,
+                                      outputFormatObj *format, char *imagepath,
+                                      char *imageurl, double resolution,
+                                      double defresolution, colorObj *bg);
+
+MS_DLL_EXPORT void msAlphaBlend(unsigned char red_src, unsigned char green_src,
+                                unsigned char blue_src, unsigned char alpha_src,
+                                unsigned char *red_dst,
+                                unsigned char *green_dst,
+                                unsigned char *blue_dst,
+                                unsigned char *alpha_dst);
+MS_DLL_EXPORT void
+msAlphaBlendPM(unsigned char red_src, unsigned char green_src,
+               unsigned char blue_src, unsigned char alpha_src,
+               unsigned char *red_dst, unsigned char *green_dst,
+               unsigned char *blue_dst, unsigned char *alpha_dst);
+
+MS_DLL_EXPORT void msRGBtoHSL(colorObj *rgb, double *h, double *s, double *l);
+
+MS_DLL_EXPORT void msHSLtoRGB(double h, double s, double l, colorObj *rgb);
+
+MS_DLL_EXPORT int msCheckParentPointer(void *p, const char *objname);
+
+MS_DLL_EXPORT int *msAllocateValidClassGroups(layerObj *lp, int *nclasses);
+
+MS_DLL_EXPORT void msFreeRasterBuffer(rasterBufferObj *b);
+MS_DLL_EXPORT void msSetLayerOpacity(layerObj *layer, int opacity);
+
+void msMapSetLanguageSpecificConnection(mapObj *map,
+                                        const char *validated_language);
+MS_DLL_EXPORT shapeObj *msGeneralize(shapeObj *shape, double tolerance);
+/* ==================================================================== */
+/*      End of prototypes for functions in maputil.c                    */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapoutput.c                         */
+/* ==================================================================== */
+
+MS_DLL_EXPORT void msApplyDefaultOutputFormats(mapObj *);
+MS_DLL_EXPORT void msFreeOutputFormat(outputFormatObj *);
+MS_DLL_EXPORT int msGetOutputFormatIndex(mapObj *map, const char *imagetype);
+MS_DLL_EXPORT int msRemoveOutputFormat(mapObj *map, const char *imagetype);
+MS_DLL_EXPORT int msAppendOutputFormat(mapObj *map, outputFormatObj *format);
+MS_DLL_EXPORT outputFormatObj *msSelectOutputFormat(mapObj *map,
+                                                    const char *imagetype);
+MS_DLL_EXPORT void msApplyOutputFormat(outputFormatObj **target,
+                                       outputFormatObj *format,
+                                       int transparent);
+MS_DLL_EXPORT const char *msGetOutputFormatOption(outputFormatObj *format,
+                                                  const char *optionkey,
+                                                  const char *defaultresult);
+MS_DLL_EXPORT outputFormatObj *
+msCreateDefaultOutputFormat(mapObj *map, const char *driver, const char *name,
+                            const char *mimetype);
+MS_DLL_EXPORT int msPostMapParseOutputFormatSetup(mapObj *map);
+MS_DLL_EXPORT void msSetOutputFormatOption(outputFormatObj *format,
+                                           const char *key, const char *value);
+MS_DLL_EXPORT void msGetOutputFormatMimeList(mapObj *map, char **mime_list,
+                                             int max_mime);
+MS_DLL_EXPORT void
+msGetOutputFormatMimeListImg(mapObj *map, const char **mime_list, int max_mime);
+MS_DLL_EXPORT void
+msGetOutputFormatMimeListWMS(mapObj *map, const char **mime_list, int max_mime);
+MS_DLL_EXPORT outputFormatObj *msCloneOutputFormat(outputFormatObj *format);
+MS_DLL_EXPORT int msOutputFormatValidate(outputFormatObj *format,
+                                         int issue_error);
+void msOutputFormatResolveFromImage(mapObj *map, imageObj *img);
+
+/* ==================================================================== */
+/*      End of prototypes for functions in mapoutput.c                  */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgdal.c                           */
+/* ==================================================================== */
+MS_DLL_EXPORT int msSaveImageGDAL(mapObj *map, imageObj *image,
+                                  const char *filename);
+MS_DLL_EXPORT int msInitDefaultGDALOutputFormat(outputFormatObj *format);
+void msCleanVSIDir(const char *pszDir);
+char **msGetStringListFromHashTable(hashTableObj *table);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapogroutput.c                      */
+/* ==================================================================== */
+MS_DLL_EXPORT int msInitDefaultOGROutputFormat(outputFormatObj *format);
+MS_DLL_EXPORT int msOGRWriteFromQuery(mapObj *map, outputFormatObj *format,
+                                      int sendheaders);
+
+/* ==================================================================== */
+/*      Public prototype for mapogr.cpp functions.                      */
+/* ==================================================================== */
+int MS_DLL_EXPORT msOGRLayerWhichShapes(layerObj *layer, rectObj rect,
+                                        int isQuery);
+int MS_DLL_EXPORT msOGRLayerOpen(
+    layerObj *layer, const char *pszOverrideConnection); /* in mapogr.cpp */
+int MS_DLL_EXPORT msOGRLayerClose(layerObj *layer);
+
+char MS_DLL_EXPORT *msOGRShapeToWKT(shapeObj *shape);
+shapeObj MS_DLL_EXPORT *msOGRShapeFromWKT(const char *string);
+int msOGRUpdateStyleFromString(mapObj *map, layerObj *layer, classObj *c,
+                               const char *stylestring);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapcopy                             */
+/* ==================================================================== */
+MS_DLL_EXPORT int msCopyMap(mapObj *dst, const mapObj *src);
+MS_DLL_EXPORT int msCopyLayer(layerObj *dst, const layerObj *src);
+MS_DLL_EXPORT int msCopyScaleToken(const scaleTokenObj *src,
+                                   scaleTokenObj *dst);
+MS_DLL_EXPORT int msCopyPoint(pointObj *dst, const pointObj *src);
+MS_DLL_EXPORT int msCopyFontSet(fontSetObj *dst, const fontSetObj *src,
+                                mapObj *map);
+MS_DLL_EXPORT void copyProperty(void *dst, const void *src, int size);
+MS_DLL_EXPORT char *copyStringProperty(char **dst, const char *src);
+MS_DLL_EXPORT int msCopyClass(classObj *dst, const classObj *src,
+                              layerObj *layer);
+MS_DLL_EXPORT int msCopyStyle(styleObj *dst, const styleObj *src);
+MS_DLL_EXPORT int msCopyLabel(labelObj *dst, const labelObj *src);
+MS_DLL_EXPORT int msCopyLabelLeader(labelLeaderObj *dst,
+                                    const labelLeaderObj *src);
+MS_DLL_EXPORT int msCopyLine(lineObj *dst, const lineObj *src);
+MS_DLL_EXPORT int msCopyProjection(projectionObj *dst,
+                                   const projectionObj *src);
+MS_DLL_EXPORT int msCopyProjectionExtended(projectionObj *dst,
+                                           const projectionObj *src,
+                                           char **args, int num_args);
+int msCopyExpression(expressionObj *dst, const expressionObj *src);
+int msCopyProjection(projectionObj *dst, const projectionObj *src);
+MS_DLL_EXPORT int msCopyRasterBuffer(rasterBufferObj *dst,
+                                     const rasterBufferObj *src);
+
+/* ==================================================================== */
+/*      end prototypes for functions in mapcopy                         */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      mappool.c: connection pooling API.                              */
+/* ==================================================================== */
+MS_DLL_EXPORT void *msConnPoolRequest(layerObj *layer);
+MS_DLL_EXPORT void msConnPoolRelease(layerObj *layer, void *);
+MS_DLL_EXPORT void msConnPoolRegister(layerObj *layer, void *conn_handle,
+                                      void (*close)(void *));
+MS_DLL_EXPORT void msConnPoolCloseUnreferenced(void);
+MS_DLL_EXPORT void msConnPoolFinalCleanup(void);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapcpl.c                            */
+/* ==================================================================== */
+MS_DLL_EXPORT const char *msGetBasename(const char *pszFullFilename);
+MS_DLL_EXPORT void *msGetSymbol(const char *pszLibrary,
+                                const char *pszEntryPoint);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgeos.c                         */
+/* ==================================================================== */
+MS_DLL_EXPORT void msGEOSSetup(void);
+MS_DLL_EXPORT void msGEOSCleanup(void);
+MS_DLL_EXPORT void msGEOSFreeGeometry(shapeObj *shape);
+
+MS_DLL_EXPORT shapeObj *msGEOSShapeFromWKT(const char *string);
+MS_DLL_EXPORT char *msGEOSShapeToWKT(shapeObj *shape);
+MS_DLL_EXPORT void msGEOSFreeWKT(char *pszGEOSWKT);
+
+MS_DLL_EXPORT shapeObj *msGEOSBuffer(shapeObj *shape, double width);
+MS_DLL_EXPORT shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance);
+MS_DLL_EXPORT shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape,
+                                                         double tolerance);
+MS_DLL_EXPORT shapeObj *msGEOSConvexHull(shapeObj *shape);
+MS_DLL_EXPORT shapeObj *msGEOSBoundary(shapeObj *shape);
+MS_DLL_EXPORT pointObj *msGEOSGetCentroid(shapeObj *shape);
+MS_DLL_EXPORT shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset);
+MS_DLL_EXPORT shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance,
+                                             int onlyEdges);
+MS_DLL_EXPORT shapeObj *msGEOSCenterline(shapeObj *shape);
+
+MS_DLL_EXPORT int msGEOSContains(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSWithin(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSTouches(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSEquals(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2);
+
+MS_DLL_EXPORT double msGEOSArea(shapeObj *shape);
+MS_DLL_EXPORT double msGEOSLength(shapeObj *shape);
+MS_DLL_EXPORT double msGEOSDistance(shapeObj *shape1, shapeObj *shape2);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapcrypto.c                         */
+/* ==================================================================== */
+MS_DLL_EXPORT int msGenerateEncryptionKey(unsigned char *k);
+MS_DLL_EXPORT int msReadEncryptionKeyFromFile(const char *keyfile,
+                                              unsigned char *k);
+MS_DLL_EXPORT void msEncryptStringWithKey(const unsigned char *key,
+                                          const char *in, char *out);
+MS_DLL_EXPORT void msDecryptStringWithKey(const unsigned char *key,
+                                          const char *in, char *out);
+MS_DLL_EXPORT char *msDecryptStringTokens(mapObj *map, const char *in);
+MS_DLL_EXPORT void msHexEncode(const unsigned char *in, char *out,
+                               int numbytes);
+MS_DLL_EXPORT int msHexDecode(const char *in, unsigned char *out, int numchars);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapxmp.c                            */
+/* ==================================================================== */
+MS_DLL_EXPORT int msXmpPresent(mapObj *map);
+MS_DLL_EXPORT int msXmpWrite(mapObj *map, const char *filename);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgeomtransform.c                  */
+/* ==================================================================== */
+enum MS_GEOMTRANSFORM_TYPE {
+  MS_GEOMTRANSFORM_NONE,
+  MS_GEOMTRANSFORM_EXPRESSION,
+  MS_GEOMTRANSFORM_START,
+  MS_GEOMTRANSFORM_END,
+  MS_GEOMTRANSFORM_VERTICES,
+  MS_GEOMTRANSFORM_BBOX,
+  MS_GEOMTRANSFORM_CENTROID,
+  MS_GEOMTRANSFORM_BUFFER,
+  MS_GEOMTRANSFORM_CONVEXHULL,
+  MS_GEOMTRANSFORM_LABELPOINT,
+  MS_GEOMTRANSFORM_LABELPOLY,
+  MS_GEOMTRANSFORM_LABELCENTER
+};
+
+MS_DLL_EXPORT int msDrawTransformedShape(mapObj *map, imageObj *image,
+                                         shapeObj *shape, styleObj *style,
+                                         double scalefactor);
+MS_DLL_EXPORT void msStyleSetGeomTransform(styleObj *s, const char *transform);
+MS_DLL_EXPORT char *msStyleGetGeomTransform(styleObj *style);
+
+MS_DLL_EXPORT int msGeomTransformShape(mapObj *map, layerObj *layer,
+                                       shapeObj *shape);
+
+/* ==================================================================== */
+/*      end of prototypes for functions in mapgeomtransform.c                 */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgraticule.c                      */
+/* ==================================================================== */
+MS_DLL_EXPORT graticuleIntersectionObj *
+msGraticuleLayerGetIntersectionPoints(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT void
+msGraticuleLayerFreeIntersectionPoints(graticuleIntersectionObj *psValue);
+
+/* ==================================================================== */
+/*      end of prototypes for functions in mapgraticule.c               */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapsmoothing.c                      */
+/* ==================================================================== */
+MS_DLL_EXPORT shapeObj *msSmoothShapeSIA(shapeObj *shape, int ss, int si,
+                                         char *preprocessing);
+
+/* ==================================================================== */
+/*      end of prototypes for functions in mapsmoothing.c               */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapv8.cpp                           */
+/* ==================================================================== */
+#ifdef USE_V8_MAPSCRIPT
+MS_DLL_EXPORT void msV8CreateContext(mapObj *map);
+MS_DLL_EXPORT void msV8ContextSetLayer(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT void msV8FreeContext(mapObj *map);
+MS_DLL_EXPORT char *msV8GetFeatureStyle(mapObj *map, const char *filename,
+                                        layerObj *layer, shapeObj *shape);
+MS_DLL_EXPORT shapeObj *msV8TransformShape(shapeObj *shape,
+                                           const char *filename);
+#endif
+/* ==================================================================== */
+/*      end of prototypes for functions in mapv8.cpp                    */
+/* ==================================================================== */
+
+#endif
+
+#ifndef SWIG
+/*
+ * strokeStyleObj
+ */
+typedef struct {
+  double width; /* line width in pixels */
+
+  /* line pattern, e.g. dots, dashes, etc.. */
+  int patternlength;
+  double pattern[MS_MAXPATTERNLENGTH];
+  double patternoffset;
+
+  /* must be a valid color if not NULL */
+  /* color.alpha must be used if supported by the renderer */
+  colorObj *color;
+
+  int linecap;  /* MS_CJC_TRIANGLE, MS_CJC_SQUARE, MS_CJC_ROUND, MS_CJC_BUTT */
+  int linejoin; /* MS_CJC_BEVEL MS_CJC_ROUND MS_CJC_MITER */
+  double linejoinmaxsize;
+  int antialiased;
+} strokeStyleObj;
+
+#define INIT_STROKE_STYLE(s)                                                   \
+  {                                                                            \
+    (s).width = 0;                                                             \
+    (s).patternlength = 0;                                                     \
+    (s).color = NULL;                                                          \
+    (s).linecap = MS_CJC_ROUND;                                                \
+    (s).linejoin = MS_CJC_ROUND;                                               \
+    (s).linejoinmaxsize = 0;                                                   \
+    (s).antialiased = MS_TRUE;                                                 \
+  }
+
+/*
+ * symbolStyleObj
+ */
+typedef struct {
+  /* must be valid colors if not NULL */
+  /* color.alpha must be used if supported by the renderer */
+  colorObj *color;
+  colorObj *backgroundcolor;
+
+  double outlinewidth;
+  colorObj *outlinecolor;
+
+  /* scalefactor to be applied on the tile or symbol*/
+  double scale;
+
+  /* rotation to apply on the symbol (and the tile?)
+   * in radians */
+  double rotation;
+
+  /* the gap to space symbols appart when used as a polygon tile
+   */
+  double gap;
+
+  /* style object, necessary for vector type renderers to be able
+   * to render symbols through other renders such as cairo/agg */
+  styleObj *style;
+} symbolStyleObj;
+
+#define INIT_SYMBOL_STYLE(s)                                                   \
+  {                                                                            \
+    (s).color = NULL;                                                          \
+    (s).backgroundcolor = NULL;                                                \
+    (s).outlinewidth = 0;                                                      \
+    (s).outlinecolor = NULL;                                                   \
+    (s).scale = 1.0;                                                           \
+    (s).rotation = 0;                                                          \
+    (s).style = NULL;                                                          \
+  }
+
+struct tileCacheObj {
+  symbolObj *symbol;
+  int width;
+  int height;
+  colorObj color, outlinecolor, backgroundcolor;
+  double outlinewidth, rotation, scale;
+  imageObj *image;
+  tileCacheObj *next;
+};
+
+/*
+ * labelStyleObj
+ */
+typedef struct {
+  /* full paths to truetype font file */
+  char *fonts[MS_MAX_LABEL_FONTS];
+  int numfonts;
+  double size;
+  double rotation;
+  colorObj *color;
+  double outlinewidth;
+  colorObj *outlinecolor;
+} labelStyleObj;
+
+#define INIT_LABEL_STYLE(s)                                                    \
+  { memset(&(s), '\0', sizeof(labelStyleObj)); }
+
+#endif
+
+#ifndef SWIG
+MS_DLL_EXPORT int msInitializeDummyRenderer(rendererVTableObj *vtable);
+MS_DLL_EXPORT int msInitializeRendererVTable(outputFormatObj *outputformat);
+MS_DLL_EXPORT int
+msPopulateRendererVTableCairoRaster(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableCairoSVG(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableCairoPDF(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableOGL(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableAGG(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableUTFGrid(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableKML(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableOGR(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableMVT(rendererVTableObj *renderer);
+
+MS_DLL_EXPORT int msMVTWriteTile(mapObj *map, int sendheaders);
+
+#ifdef USE_CAIRO
+MS_DLL_EXPORT void msCairoCleanup(void);
+#endif
+
+/* allocate 50k for starters */
+#define MS_DEFAULT_BUFFER_ALLOC 50000
+
+typedef struct _autobuffer {
+  unsigned char *data;
+  size_t size;
+  size_t available;
+  size_t _next_allocation_size;
+} bufferObj;
+
+/* in mapimageio.c */
+int msQuantizeRasterBuffer(rasterBufferObj *rb, unsigned int *reqcolors,
+                           rgbaPixel *palette, rgbaPixel *forced_palette,
+                           int num_forced_palette_entries,
+                           unsigned int *palette_scaling_maxval);
+int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb);
+int msSaveRasterBuffer(mapObj *map, rasterBufferObj *data, FILE *stream,
+                       outputFormatObj *format);
+int msSaveRasterBufferToBuffer(rasterBufferObj *data, bufferObj *buffer,
+                               outputFormatObj *format);
+int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb);
+
+/* in mapagg.cpp */
+void msApplyBlurringCompositingFilter(rasterBufferObj *rb, unsigned int radius);
+
+int WARN_UNUSED msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb,
+                                         CompositingFilter *filter);
+
+void msBufferInit(bufferObj *buffer);
+void msBufferResize(bufferObj *buffer, size_t target_size);
+MS_DLL_EXPORT void msBufferFree(bufferObj *buffer);
+MS_DLL_EXPORT void msBufferAppend(bufferObj *buffer, void *data, size_t length);
+
+typedef struct {
+  int charWidth, charHeight;
+} fontMetrics;
+
+struct rendererVTableObj {
+  int supports_pixel_buffer;
+  int supports_clipping;
+  int supports_svg;
+  int use_imagecache;
+  enum MS_TRANSFORM_MODE default_transform_mode;
+  enum MS_TRANSFORM_MODE transform_mode;
+  double default_approximation_scale;
+  double approximation_scale;
+
+  void *renderer_data;
+
+  int WARN_UNUSED (*renderLine)(imageObj *img, shapeObj *p,
+                                strokeStyleObj *style);
+  int WARN_UNUSED (*renderPolygon)(imageObj *img, shapeObj *p, colorObj *color);
+  int WARN_UNUSED (*renderPolygonTiled)(imageObj *img, shapeObj *p,
+                                        imageObj *tile);
+  int WARN_UNUSED (*renderLineTiled)(imageObj *img, shapeObj *p,
+                                     imageObj *tile);
+
+  /* only ts->textpath is guaranteed to be populated. Other fields might be
+   * 0/NULL */
+  int WARN_UNUSED (*renderGlyphs)(imageObj *img, const textSymbolObj *ts,
+                                  colorObj *clr, colorObj *olcolor, int olwidth,
+                                  int isMarker);
+
+  int WARN_UNUSED (*renderVectorSymbol)(imageObj *img, double x, double y,
+                                        symbolObj *symbol,
+                                        symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderPixmapSymbol)(imageObj *img, double x, double y,
+                                        symbolObj *symbol,
+                                        symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderEllipseSymbol)(imageObj *image, double x, double y,
+                                         symbolObj *symbol,
+                                         symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderSVGSymbol)(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderTile)(imageObj *img, imageObj *tile, double x,
+                                double y);
+
+  int WARN_UNUSED (*loadImageFromFile)(char *path, rasterBufferObj *rb);
+
+  int WARN_UNUSED (*getRasterBufferHandle)(imageObj *img, rasterBufferObj *rb);
+  int WARN_UNUSED (*getRasterBufferCopy)(imageObj *img, rasterBufferObj *rb);
+  int WARN_UNUSED (*initializeRasterBuffer)(rasterBufferObj *rb, int width,
+                                            int height, int mode);
+
+  int WARN_UNUSED (*mergeRasterBuffer)(imageObj *dest, rasterBufferObj *overlay,
+                                       double opacity, int srcX, int srcY,
+                                       int dstX, int dstY, int width,
+                                       int height);
+  int WARN_UNUSED (*compositeRasterBuffer)(imageObj *dest,
+                                           rasterBufferObj *overlay,
+                                           CompositingOperation comp_op,
+                                           int opacity);
+
+  /* image i/o */
+  imageObj *WARN_UNUSED (*createImage)(int width, int height,
+                                       outputFormatObj *format, colorObj *bg);
+  int WARN_UNUSED (*saveImage)(imageObj *img, mapObj *map, FILE *fp,
+                               outputFormatObj *format);
+  unsigned char *WARN_UNUSED (*saveImageBuffer)(imageObj *img, int *size_ptr,
+                                                outputFormatObj *format);
+  /*...*/
+
+  int (*startLayer)(imageObj *img, mapObj *map, layerObj *layer);
+  int (*endLayer)(imageObj *img, mapObj *map, layerObj *layer);
+
+  int (*startShape)(imageObj *img, shapeObj *shape);
+  int (*endShape)(imageObj *img, shapeObj *shape);
+  int (*setClip)(imageObj *img, rectObj clipRect);
+  int (*resetClip)(imageObj *img);
+
+  int (*freeImage)(imageObj *image);
+  int (*freeSymbol)(symbolObj *symbol);
+  int (*cleanup)(void *renderer_data);
+};
+MS_DLL_EXPORT int msRenderRasterizedSVGSymbol(imageObj *img, double x, double y,
+                                              symbolObj *symbol,
+                                              symbolStyleObj *style);
+
+#define MS_IMAGE_RENDERER(im) ((im)->format->vtable)
+#define MS_RENDERER_CACHE(renderer) ((renderer)->renderer_data)
+#define MS_IMAGE_RENDERER_CACHE(im) MS_RENDERER_CACHE(MS_IMAGE_RENDERER((im)))
+#define MS_MAP_RENDERER(map) ((map)->outputformat->vtable)
+
+shapeObj *msOffsetCurve(shapeObj *p, double offset);
+#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 ||                             \
+                         (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
+shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset);
+#endif
+
+int msOGRSupportsIsNull(layerObj *layer);
+
+#ifdef NEED_IGNORE_RET_VAL
+static inline void IGNORE_RET_VAL(int x) { (void)x; }
+#endif
+
+#endif /* SWIG */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAP_H */
diff -pruN 8.0.1-5/src/mapservutil.c 8.2.0~beta1-1~exp1/src/mapservutil.c
--- 8.0.1-5/src/mapservutil.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapservutil.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2519 @@
+/******************************************************************************
+ * $id$
+ *
+ * Project:  MapServer
+ * Purpose:  MapServer CGI utility functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "apps/mapserv.h"
+#include "maptime.h"
+#include "mapows.h"
+#include "mapogcapi.h"
+
+#include "cpl_conv.h"
+
+#include "mapserver-config.h"
+
+#include "cpl_conv.h"
+
+/*
+** Enumerated types, keep the query modes in sequence and at the end of the
+*enumeration (mode enumeration is in maptemplate.h).
+*/
+static const int numModes = 23;
+static char *const modeStrings[23] = {"BROWSE",
+                                      "ZOOMIN",
+                                      "ZOOMOUT",
+                                      "MAP",
+                                      "LEGEND",
+                                      "LEGENDICON",
+                                      "REFERENCE",
+                                      "SCALEBAR",
+                                      "COORDINATE",
+                                      "QUERY",
+                                      "NQUERY",
+                                      "ITEMQUERY",
+                                      "ITEMNQUERY",
+                                      "FEATUREQUERY",
+                                      "FEATURENQUERY",
+                                      "ITEMFEATUREQUERY",
+                                      "ITEMFEATURENQUERY",
+                                      "INDEXQUERY",
+                                      "TILE",
+                                      "OWS",
+                                      "WFS",
+                                      "MAPLEGEND",
+                                      "MAPLEGENDICON"};
+
+static int commonLoadForm(mapservObj *mapserv, mapObj *map);
+
+void msCGIWriteError(mapservObj *mapserv) {
+  errorObj *ms_error = msGetErrorObj();
+
+  if (!ms_error || ms_error->code == MS_NOERR || ms_error->isreported) {
+    /* either we have no error, or it was already reported by other means */
+    return;
+  }
+
+  if (!mapserv || !mapserv->map) {
+    if (CPLGetConfigOption("MS_ERROR_URL", NULL) != NULL) {
+      msRedirect(CPLGetConfigOption("MS_ERROR_URL", NULL));
+    } else {
+      msIO_setHeader("Content-Type", "text/html");
+      msIO_sendHeaders();
+      msIO_printf("<HTML>\n");
+      msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
+      msIO_printf("<BODY BGCOLOR=\"#FFFFFF\">\n");
+      msWriteErrorXML(stdout);
+      msIO_printf("</BODY></HTML>");
+    }
+    return;
+  }
+
+  if ((ms_error->code == MS_NOTFOUND) &&
+      (mapserv->map->web.empty != NULL ||
+       CPLGetConfigOption("MS_EMPTY_URL", NULL) != NULL)) {
+    const char *url = mapserv->map->web.empty; // takes precedence
+    if (url == NULL)
+      url = CPLGetConfigOption("MS_EMPTY_URL", NULL);
+    msRedirect(url);
+  } else if (mapserv->map->web.error != NULL ||
+             CPLGetConfigOption("MS_ERROR_URL", NULL) != NULL) {
+    const char *url = mapserv->map->web.error; // takes precedence
+    if (url == NULL)
+      url = CPLGetConfigOption("MS_ERROR_URL", NULL);
+    msRedirect(url);
+  } else {
+    msIO_setHeader("Content-Type", "text/html");
+    msIO_sendHeaders();
+    msIO_printf("<HTML>\n");
+    msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
+    msIO_printf("<BODY BGCOLOR=\"#FFFFFF\">\n");
+    msWriteErrorXML(stdout);
+    msIO_printf("</BODY></HTML>");
+  }
+
+  return;
+}
+
+/*
+** Converts a string (e.g. form parameter) to a double, first checking the
+*format against
+** a regular expression. returns an error if the format test fails.
+*/
+
+#define GET_NUMERIC(string, dbl)                                               \
+  do {                                                                         \
+    dbl = strtod((string), &strtoderr);                                        \
+    if (*strtoderr) {                                                          \
+      msSetError(MS_TYPEERR, NULL, "GET_NUMERIC()");                           \
+      return MS_FAILURE;                                                       \
+    }                                                                          \
+  } while (0)
+
+#define GET_NUMERIC_NO_ERROR(string, dbl) dbl = strtod((string), &strtoderr);
+
+#define FREE_TOKENS_ON_ERROR(ntok)                                             \
+  if (!strtoderr) {                                                            \
+    msSetError(MS_TYPEERR, "invalid number", "msCGILoadForm()");               \
+    msFreeCharArray(tokens, (ntok));                                           \
+    return MS_FAILURE;                                                         \
+  }
+
+static void setClassGroup(layerObj *layer, char *classgroup) {
+  int i;
+
+  if (!layer || !classgroup)
+    return;
+
+  for (i = 0; i < layer->numclasses; i++) {
+    if (layer->class[i] -> group && strcmp(layer->class[i] -> group,
+                                           classgroup) == 0) {
+      msFree(layer->classgroup);
+      layer->classgroup = msStrdup(classgroup);
+      return; /* bail */
+    }
+  }
+}
+
+/*
+** Extract Map File name from params and load it.
+** Returns map object or NULL on error.
+*/
+mapObj *msCGILoadMap(mapservObj *mapserv, configObj *config) {
+  int i;
+  mapObj *map = NULL;
+
+  const char *ms_map_bad_pattern_default = "[/\\]{2}|[/\\]?\\.+[/\\]|,";
+
+  int ms_mapfile_tainted = MS_TRUE;
+  const char *ms_mapfile = CPLGetConfigOption("MS_MAPFILE", NULL);
+
+  const char *ms_map_no_path = CPLGetConfigOption("MS_MAP_NO_PATH", NULL);
+  const char *ms_map_pattern = CPLGetConfigOption("MS_MAP_PATTERN", NULL);
+
+  const char *ms_map_bad_pattern =
+      CPLGetConfigOption("MS_MAP_BAD_PATTERN", NULL);
+  if (ms_map_bad_pattern == NULL)
+    ms_map_bad_pattern = ms_map_bad_pattern_default;
+
+  const char *map_value = NULL;
+
+  if (mapserv->request->api_path != NULL) {
+    map_value = mapserv->request
+                    ->api_path[0]; /* mapfile is *always* in the first position
+                                      (/{mapfile}/{signature}) of an API call */
+  } else {
+    for (i = 0; i < mapserv->request->NumParams;
+         i++) { /* find the map parameter */
+      if (strcasecmp(mapserv->request->ParamNames[i], "map") == 0) {
+        map_value = mapserv->request->ParamValues[i];
+        break;
+      }
+    }
+  }
+
+  if (map_value == NULL) {
+    if (ms_mapfile == NULL) {
+      msSetError(MS_WEBERR, "CGI variable \"map\" is not set.",
+                 "msCGILoadMap()"); /* no default, outta here */
+      return NULL;
+    }
+    ms_mapfile_tainted = MS_FALSE;
+  } else {
+    ms_mapfile = msConfigGetMap(
+        config,
+        map_value); /* does NOT check the environment, only the config */
+    if (ms_mapfile) {
+      ms_mapfile_tainted = MS_FALSE;
+    } else {
+      /* by now we know the map parameter isn't referencing something in the
+       * configuration */
+      if (ms_map_no_path != NULL) {
+        msSetError(MS_WEBERR,
+                   "CGI variable \"map\" not found in configuration and this "
+                   "server is not configured for full paths.",
+                   "msCGILoadMap()");
+        return NULL;
+      }
+      ms_mapfile = map_value;
+    }
+  }
+
+  /* validate ms_mapfile if tainted */
+  if (ms_mapfile_tainted == MS_TRUE) {
+    if (ms_map_pattern == NULL) { // can't go any further, bail
+      msSetError(MS_WEBERR,
+                 "Required configuration value MS_MAP_PATTERN not set.",
+                 "msCGILoadMap()");
+      return NULL;
+    }
+    if (msIsValidRegex(ms_map_bad_pattern) == MS_FALSE ||
+        msEvalRegex(ms_map_bad_pattern, ms_mapfile) == MS_TRUE) {
+      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.",
+                 "msCGILoadMap()");
+      return NULL;
+    }
+    if (msEvalRegex(ms_map_pattern, ms_mapfile) != MS_TRUE) {
+      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.",
+                 "msCGILoadMap()");
+      return NULL;
+    }
+  }
+
+  /* ok to try to load now */
+  map = msLoadMap(ms_mapfile, NULL, config);
+  if (!map)
+    return NULL;
+
+  /* handle common parameters */
+  if (commonLoadForm(mapserv, map) != MS_SUCCESS) {
+    msFreeMap(map);
+    return NULL;
+  }
+
+  if (!msLookupHashTable(&(map->web.validation), "immutable")) {
+    /* check for any %variable% substitutions, we do this here so WMS/WFS  */
+    /* services can take advantage of these "vendor specific" extensions */
+
+    msApplySubstitutions(map, mapserv->request->ParamNames,
+                         mapserv->request->ParamValues,
+                         mapserv->request->NumParams);
+    msApplyDefaultSubstitutions(map);
+
+    /* check to see if a ogc map context is passed as argument. if there */
+    /* is one load it */
+
+    for (i = 0; i < mapserv->request->NumParams; i++) {
+      if (strcasecmp(mapserv->request->ParamNames[i], "context") == 0) {
+        if (mapserv->request->ParamValues[i] &&
+            strlen(mapserv->request->ParamValues[i]) > 0) {
+          if (strncasecmp(mapserv->request->ParamValues[i], "http", 4) == 0) {
+            if (msGetConfigOption(map, "CGI_CONTEXT_URL"))
+              msLoadMapContextURL(map, mapserv->request->ParamValues[i],
+                                  MS_FALSE);
+          } else {
+            const char *map_context_filename = mapserv->request->ParamValues[i];
+            const char *ms_context_pattern =
+                CPLGetConfigOption("MS_CONTEXT_PATTERN", NULL);
+            const char *ms_context_bad_pattern =
+                CPLGetConfigOption("MS_CONTEXT_BAD_PATTERN", NULL);
+            if (ms_context_bad_pattern == NULL)
+              ms_context_bad_pattern = ms_map_bad_pattern_default;
+
+            if (ms_context_pattern == NULL) { // can't go any further, bail
+              msSetError(
+                  MS_WEBERR,
+                  "Required configuration value MS_CONTEXT_PATTERN not set.",
+                  "msCGILoadMap()");
+              msFreeMap(map);
+              return NULL;
+            }
+            if (msIsValidRegex(ms_context_bad_pattern) == MS_FALSE ||
+                msEvalRegex(ms_context_bad_pattern, map_context_filename) ==
+                    MS_TRUE) {
+              msSetError(MS_WEBERR,
+                         "CGI variable \"context\" fails to validate.",
+                         "msCGILoadMap()");
+              msFreeMap(map);
+              return NULL;
+            }
+            if (msEvalRegex(ms_context_pattern, map_context_filename) !=
+                MS_TRUE) {
+              msSetError(MS_WEBERR,
+                         "CGI variable \"context\" fails to validate.",
+                         "msCGILoadMap()");
+              msFreeMap(map);
+              return NULL;
+            }
+            msLoadMapContext(map, map_context_filename, MS_FALSE);
+          }
+        }
+      }
+    }
+  }
+
+  /*
+   * RFC-42 HTTP Cookie Forwarding
+   * Here we set the http_cookie_data metadata to handle the
+   * HTTP Cookie Forwarding. The content of this metadata is the cookie
+   * content. In the future, this metadata will probably be replaced
+   * by an object that is part of the mapObject that would contain
+   * information on the application status (such as cookie).
+   */
+  if (mapserv->request->httpcookiedata != NULL) {
+    msInsertHashTable(&(map->web.metadata), "http_cookie_data",
+                      mapserv->request->httpcookiedata);
+  }
+
+  return map;
+}
+
+/*
+** Set operation mode. First look in MS_MODE env. var. as a
+** default value that can be overridden by the mode=... CGI param.
+** Returns silently, leaving mapserv->Mode unchanged if mode param not set.
+*/
+int msCGISetMode(mapservObj *mapserv) {
+  const char *mode = NULL;
+  int i, j;
+
+  mode = CPLGetConfigOption("MS_MODE", NULL);
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "mode") == 0) {
+      mode = mapserv->request->ParamValues[i];
+      break;
+    }
+  }
+
+  if (mode) {
+    for (j = 0; j < numModes; j++) {
+      if (strcasecmp(mode, modeStrings[j]) == 0) {
+        mapserv->Mode = j;
+        break;
+      }
+    }
+
+    if (j == numModes) {
+      msSetError(MS_WEBERR, "Invalid mode.", "msCGISetMode()");
+      return MS_FAILURE;
+    }
+  }
+
+  if (mapserv->Mode >= 0) {
+    int disabled = MS_FALSE;
+    const char *enable_modes =
+        msLookupHashTable(&mapserv->map->web.metadata, "ms_enable_modes");
+
+    if (!msOWSParseRequestMetadata(enable_modes, mode, &disabled) && disabled) {
+      /* the current mode is disabled */
+      msSetError(MS_WEBERR,
+                 "The specified mode '%s' is not supported by the current map "
+                 "configuration",
+                 "msCGISetMode()", mode);
+      return MS_FAILURE;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** API-related funtions.
+*/
+int msCGIIsAPIRequest(mapservObj *mapserv) {
+  char **tmp_api_path = NULL;
+  int i, n, tmp_api_path_length = 0;
+
+  mapserv->request->path_info = getenv("PATH_INFO");
+  if (mapserv->request->path_info != NULL &&
+      strlen(mapserv->request->path_info) > 0) {
+    tmp_api_path =
+        msStringSplit(mapserv->request->path_info, '/',
+                      &tmp_api_path_length); // ignores consecutive delimiters
+    if (tmp_api_path_length >=
+        2) { // we can access a mapfile by key using /{mapfile-key} so 2
+             // components at a minimum (1st component is a zero-length string)
+
+      // capture only non-zero length components
+      n = 0;
+      for (i = 0; i < tmp_api_path_length; i++) {
+        if (strlen(tmp_api_path[i]) > 0)
+          n++;
+      }
+
+      if (n < 1) { // we need at least a mapfile key for a legitimate request
+        msFreeCharArray(tmp_api_path, tmp_api_path_length);
+        return MS_FALSE;
+      }
+
+      mapserv->request->api_path = (char **)msSmallMalloc(sizeof(char *) * n);
+      if (mapserv->request->api_path == NULL) {
+        msFreeCharArray(tmp_api_path, tmp_api_path_length);
+        return MS_FALSE;
+      }
+
+      mapserv->request->api_path_length = 0;
+      for (i = 0; i < tmp_api_path_length; i++) {
+        if (strlen(tmp_api_path[i]) > 0) {
+          mapserv->request->api_path[mapserv->request->api_path_length] =
+              msStrdup(tmp_api_path[i]);
+          mapserv->request->api_path_length++;
+        }
+      }
+
+      msFreeCharArray(tmp_api_path, tmp_api_path_length);
+      return MS_TRUE;
+    } else {
+      msFreeCharArray(tmp_api_path, tmp_api_path_length);
+    }
+  }
+
+  return MS_FALSE;
+}
+
+int msCGIDispatchAPIRequest(mapservObj *mapserv) {
+  // should be a more elegant way to do this (perhaps similar to how drivers are
+  // handled)
+  if (strcmp("ogcapi", mapserv->request->api_path[1]) == 0) {
+#ifdef USE_OGCAPI_SVR
+    return msOGCAPIDispatchRequest(mapserv->map, mapserv->request);
+#else
+    msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.",
+               "msCGIDispatchAPIRequest()");
+#endif
+  } else {
+    msSetError(MS_WEBERR, "Invalid API signature.",
+               "msCGIDispatchAPIRequest()");
+  }
+
+  return MS_FAILURE;
+}
+
+/*
+** Process common parameters that can apply to CGI and WxS calls - there are
+*just a few and affect the mapObj directly.
+*/
+static int commonLoadForm(mapservObj *mapserv, mapObj *map) {
+  double tmpval;
+  char *strtoderr;
+
+  if (!mapserv || !map)
+    return MS_FAILURE;
+
+  for (int i = 0; i < mapserv->request->NumParams; i++) {
+    if (strlen(mapserv->request->ParamValues[i]) == 0)
+      continue;
+
+    if (strncasecmp(mapserv->request->ParamNames[i], "classgroup", 10) ==
+        0) { /* #4207 */
+      for (int j = 0; j < map->numlayers; j++) {
+        setClassGroup(GET_LAYER(map, j), mapserv->request->ParamValues[i]);
+      }
+      continue;
+    }
+
+    /*
+    ** For backwards compatibility. Might want to consider a vendor parameter
+    *for WFS specifically and then deprecate this.
+    */
+    if (strcasecmp(mapserv->request->ParamNames[i], "map.extent") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_extent") == 0) {
+      int n = 0;
+      char **tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "commonLoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 4) {
+        msSetError(MS_WEBERR, "Not enough arguments for mapext.",
+                   "commonLoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], map->extent.minx);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[1], map->extent.miny);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[2], map->extent.maxx);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[3], map->extent.maxy);
+      FREE_TOKENS_ON_ERROR(4);
+
+      msFreeCharArray(tokens, 4);
+
+      if (!MS_VALID_EXTENT(map->extent)) {
+        msSetError(MS_WEBERR,
+                   "Supplied extent is invalid. Check that it is in the form: "
+                   "minx, miny, maxx, maxy",
+                   "commonLoadForm()");
+        return (MS_FAILURE);
+      }
+    }
+
+    /*
+    ** For backwards compatibility - we don't use plain RESOLUTION here because
+    *of a potential conflict WCS. Might want
+    ** to consider a vendor parameter for WMS specifically and then deprecate
+    *these.
+    */
+    if (strcasecmp(mapserv->request->ParamNames[i], "map.resolution") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_resolution") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
+      if (tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
+        msSetError(MS_WEBERR, "Resolution value out of range.",
+                   "commonLoadForm()");
+        return MS_FAILURE;
+      }
+      map->resolution = (int)tmpval;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "keysize") ==
+        0) { // legend keysize, used with legend-related outputs
+      int n = 0;
+      char **tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "commonLoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for keysize.",
+                   "commonLoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      map->legend.keysizex = (int)tmpval;
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      map->legend.keysizey = (int)tmpval;
+
+      msFreeCharArray(tokens, 2);
+
+      if (map->legend.keysizex < MS_LEGEND_KEYSIZE_MIN ||
+          map->legend.keysizex > MS_LEGEND_KEYSIZE_MAX ||
+          map->legend.keysizey < MS_LEGEND_KEYSIZE_MIN ||
+          map->legend.keysizey > MS_LEGEND_KEYSIZE_MAX) {
+        msSetError(MS_WEBERR, "Legend keysize out of range.",
+                   "commonLoadForm()");
+        return MS_FAILURE;
+      }
+
+      continue;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Process CGI parameters.
+*/
+int msCGILoadForm(mapservObj *mapserv) {
+  int i, n;
+  char **tokens = NULL;
+  int rosa_type = 0;
+  double tmpval;
+  char *strtoderr;
+
+  for (i = 0; i < mapserv->request->NumParams;
+       i++) { /* now process the rest of the form variables */
+    if (strlen(mapserv->request->ParamValues[i]) == 0)
+      continue;
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "icon") == 0) {
+      mapserv->icon = msStrdup(mapserv->request->ParamValues[i]);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "queryfile") == 0) {
+      mapserv->QueryFile = msStrdup(mapserv->request->ParamValues[i]);
+      if (msValidateParameter(
+              mapserv->QueryFile,
+              msLookupHashTable(&(mapserv->map->web.validation), "queryfile"),
+              NULL, NULL, NULL) != MS_SUCCESS) {
+        msSetError(MS_WEBERR, "Parameter 'queryfile' value fails to validate.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "savequery") == 0) {
+      mapserv->savequery = MS_TRUE;
+      continue;
+    }
+
+    /* Insecure as implemented, need to save someplace non accessible by
+       everyone in the universe
+        if(strcasecmp(mapserv->request->ParamNames[i],"savemap") == 0) {
+         mapserv->savemap = MS_TRUE;
+         continue;
+        }
+    */
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "zoom") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->Zoom);
+      if ((mapserv->Zoom > MAXZOOM) || (mapserv->Zoom < MINZOOM)) {
+        msSetError(MS_WEBERR, "Zoom value out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "zoomdir") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
+      mapserv->ZoomDirection = (int)tmpval;
+      if ((mapserv->ZoomDirection != -1) && (mapserv->ZoomDirection != 1) &&
+          (mapserv->ZoomDirection != 0)) {
+        msSetError(MS_WEBERR, "Zoom direction must be 1, 0 or -1.",
+                   "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "zoomsize") ==
+        0) { /* absolute zoom magnitude */
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
+      mapserv->ZoomSize = (int)tmpval;
+      if ((mapserv->ZoomSize > MAXZOOM) || (mapserv->ZoomSize < 1)) {
+        msSetError(MS_WEBERR, "Invalid zoom size.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgext") ==
+        0) { /* extent of an existing image in a web application */
+      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 4) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgext.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->ImgExt.minx);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->ImgExt.miny);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[2], mapserv->ImgExt.maxx);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[3], mapserv->ImgExt.maxy);
+      FREE_TOKENS_ON_ERROR(4);
+
+      msFreeCharArray(tokens, 4);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "searchmap") == 0) {
+      mapserv->SearchMap = MS_TRUE;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "id") == 0) {
+      if (msEvalRegex(IDPATTERN, mapserv->request->ParamValues[i]) ==
+          MS_FALSE) {
+        msSetError(MS_WEBERR, "Parameter 'id' value fails to validate.",
+                   "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      strlcpy(mapserv->Id, mapserv->request->ParamValues[i], IDSIZE);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapext") ==
+        0) { /* extent of the new map or query */
+
+      if (strncasecmp(mapserv->request->ParamValues[i], "shape", 5) == 0)
+        mapserv->UseShapes = MS_TRUE;
+      else {
+        tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+        if (!tokens) {
+          msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+          return MS_FAILURE;
+        }
+
+        if (n != 4) {
+          msSetError(MS_WEBERR, "Not enough arguments for mapext.",
+                     "msCGILoadForm()");
+          msFreeCharArray(tokens, n);
+          return MS_FAILURE;
+        }
+
+        GET_NUMERIC_NO_ERROR(tokens[0], mapserv->map->extent.minx);
+        FREE_TOKENS_ON_ERROR(4);
+        GET_NUMERIC_NO_ERROR(tokens[1], mapserv->map->extent.miny);
+        FREE_TOKENS_ON_ERROR(4);
+        GET_NUMERIC_NO_ERROR(tokens[2], mapserv->map->extent.maxx);
+        FREE_TOKENS_ON_ERROR(4);
+        GET_NUMERIC_NO_ERROR(tokens[3], mapserv->map->extent.maxy);
+        FREE_TOKENS_ON_ERROR(4);
+
+        msFreeCharArray(tokens, 4);
+
+        /*
+         * If there is a projection in the map file, and it is not lon/lat, and
+         * the extents "look like" they *are* lon/lat, based on their size, then
+         * convert the extents to the map file projection.
+         *
+         * DANGER: If the extents are legitimately in the mapfile projection
+         *         and coincidentally fall in the lon/lat range, bad things
+         *         will ensue.
+         */
+        if (mapserv->map->projection.proj &&
+            !msProjIsGeographicCRS(&(mapserv->map->projection)) &&
+            (mapserv->map->extent.minx >= -180.0 &&
+             mapserv->map->extent.minx <= 180.0) &&
+            (mapserv->map->extent.miny >= -90.0 &&
+             mapserv->map->extent.miny <= 90.0) &&
+            (mapserv->map->extent.maxx >= -180.0 &&
+             mapserv->map->extent.maxx <= 180.0) &&
+            (mapserv->map->extent.maxy >= -90.0 &&
+             mapserv->map->extent.maxy <= 90.0)) {
+          msProjectRect(&(mapserv->map->latlon), &(mapserv->map->projection),
+                        &(mapserv->map->extent)); /* extent is a in lat/lon */
+        }
+
+        if ((mapserv->map->extent.minx != mapserv->map->extent.maxx) &&
+            (mapserv->map->extent.miny !=
+             mapserv->map->extent.maxy)) { /* extent seems ok */
+          mapserv->CoordSource = FROMUSERBOX;
+          mapserv->QueryCoordSource = FROMUSERBOX;
+        }
+      }
+
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "minx") ==
+        0) { /* extent of the new map, in pieces */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.minx);
+      continue;
+    }
+    if (strcasecmp(mapserv->request->ParamNames[i], "maxx") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.maxx);
+      continue;
+    }
+    if (strcasecmp(mapserv->request->ParamNames[i], "miny") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.miny);
+      continue;
+    }
+    if (strcasecmp(mapserv->request->ParamNames[i], "maxy") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.maxy);
+      mapserv->CoordSource = FROMUSERBOX;
+      mapserv->QueryCoordSource = FROMUSERBOX;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapxy") ==
+        0) { /* user map coordinate */
+
+      if (strncasecmp(mapserv->request->ParamValues[i], "shape", 5) == 0) {
+        mapserv->UseShapes = MS_TRUE;
+      } else {
+        tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+        if (!tokens) {
+          msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+          return MS_FAILURE;
+        }
+
+        if (n != 2) {
+          msSetError(MS_WEBERR, "Not enough arguments for mapxy.",
+                     "msCGILoadForm()");
+          msFreeCharArray(tokens, n);
+          return MS_FAILURE;
+        }
+
+        GET_NUMERIC_NO_ERROR(tokens[0], mapserv->mappnt.x);
+        FREE_TOKENS_ON_ERROR(2);
+        GET_NUMERIC_NO_ERROR(tokens[1], mapserv->mappnt.y);
+        FREE_TOKENS_ON_ERROR(2);
+
+        msFreeCharArray(tokens, 2);
+
+        if (mapserv->map->projection.proj &&
+            !msProjIsGeographicCRS(&(mapserv->map->projection)) &&
+            (mapserv->mappnt.x >= -180.0 && mapserv->mappnt.x <= 180.0) &&
+            (mapserv->mappnt.y >= -90.0 && mapserv->mappnt.y <= 90.0)) {
+          msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection),
+                         &mapserv->mappnt); /* point is a in lat/lon */
+        }
+
+        if (mapserv->CoordSource == NONE) { /* don't override previous settings
+                                               (i.e. buffer or scale ) */
+          mapserv->CoordSource = FROMUSERPNT;
+          mapserv->QueryCoordSource = FROMUSERPNT;
+        }
+      }
+      continue;
+    }
+
+    /*
+    ** Query shape consisting of map or image coordinates. It's almost identical
+    *processing so we'll do either in this block...
+    */
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapshape") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "imgshape") == 0) {
+      if (strcasecmp(mapserv->request->ParamNames[i], "mapshape") == 0)
+        mapserv->QueryCoordSource = FROMUSERSHAPE;
+      else
+        mapserv->QueryCoordSource = FROMIMGSHAPE;
+
+      if (strchr(mapserv->request->ParamValues[i], '(') != NULL) { /* try WKT */
+        if ((mapserv->map->query.shape =
+                 msShapeFromWKT(mapserv->request->ParamValues[i])) == NULL) {
+          msSetError(MS_WEBERR, "WKT parse failed for mapshape/imgshape.",
+                     "msCGILoadForm()");
+          return MS_FAILURE;
+        }
+      } else {
+        lineObj line = {0, NULL};
+        char **tmp = NULL;
+        int n, j;
+
+        tmp = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+        if (n % 2 != 0 || n < 8) { /* n must be even and be at least 8 */
+          msSetError(MS_WEBERR,
+                     "Malformed polygon geometry for mapshape/imgshape.",
+                     "msCGILoadForm()");
+          msFreeCharArray(tmp, n);
+          return MS_FAILURE;
+        }
+
+        line.numpoints = n / 2;
+        line.point =
+            (pointObj *)msSmallMalloc(sizeof(pointObj) * line.numpoints);
+
+        mapserv->map->query.shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+        msInitShape(mapserv->map->query.shape);
+        mapserv->map->query.shape->type = MS_SHAPE_POLYGON;
+
+        for (j = 0; j < line.numpoints; j++) {
+          line.point[j].x = atof(tmp[2 * j]);
+          line.point[j].y = atof(tmp[2 * j + 1]);
+
+          if (mapserv->QueryCoordSource == FROMUSERSHAPE &&
+              mapserv->map->projection.proj &&
+              !msProjIsGeographicCRS(&(mapserv->map->projection)) &&
+              (line.point[j].x >= -180.0 && line.point[j].x <= 180.0) &&
+              (line.point[j].y >= -90.0 && line.point[j].y <= 90.0)) {
+            msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection),
+                           &line.point[j]); /* point is a in lat/lon */
+          }
+        }
+
+        if (msAddLine(mapserv->map->query.shape, &line) == -1) {
+          msFree(line.point);
+          msFreeCharArray(tmp, n);
+          return MS_FAILURE;
+        }
+
+        msFree(line.point);
+        msFreeCharArray(tmp, n);
+      }
+
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "img.x") ==
+        0) { /* mouse click, in pieces */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->ImgPnt.x);
+      if ((mapserv->ImgPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.x < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      mapserv->CoordSource = FROMIMGPNT;
+      mapserv->QueryCoordSource = FROMIMGPNT;
+      continue;
+    }
+    if (strcasecmp(mapserv->request->ParamNames[i], "img.y") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->ImgPnt.y);
+      if ((mapserv->ImgPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.y < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      mapserv->CoordSource = FROMIMGPNT;
+      mapserv->QueryCoordSource = FROMIMGPNT;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgxy") ==
+        0) { /* mouse click, single variable */
+      if (mapserv->CoordSource == FROMIMGPNT)
+        continue;
+
+      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgxy.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->ImgPnt.x);
+      FREE_TOKENS_ON_ERROR(2);
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->ImgPnt.y);
+      FREE_TOKENS_ON_ERROR(2);
+
+      msFreeCharArray(tokens, 2);
+
+      if ((mapserv->ImgPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.x < (-2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.y < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Reference map coordinate out of range.",
+                   "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (mapserv->CoordSource ==
+          NONE) { /* override nothing since this parameter is usually used to
+                     hold a default value */
+        mapserv->CoordSource = FROMIMGPNT;
+        mapserv->QueryCoordSource = FROMIMGPNT;
+      }
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgbox") ==
+        0) { /* selection box (eg. mouse drag) */
+      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 4) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgbox.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->ImgBox.minx);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->ImgBox.miny);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[2], mapserv->ImgBox.maxx);
+      FREE_TOKENS_ON_ERROR(4);
+      GET_NUMERIC_NO_ERROR(tokens[3], mapserv->ImgBox.maxy);
+      FREE_TOKENS_ON_ERROR(4);
+
+      msFreeCharArray(tokens, 4);
+
+      if ((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) &&
+          (mapserv->ImgBox.miny !=
+           mapserv->ImgBox.maxy)) { /* must not degenerate into a point */
+        mapserv->CoordSource = FROMIMGBOX;
+        mapserv->QueryCoordSource = FROMIMGBOX;
+      }
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "ref.x") ==
+        0) { /* mouse click in reference image, in pieces */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->RefPnt.x);
+      if ((mapserv->RefPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.x < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      mapserv->CoordSource = FROMREFPNT;
+      continue;
+    }
+    if (strcasecmp(mapserv->request->ParamNames[i], "ref.y") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->RefPnt.y);
+      if ((mapserv->RefPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.y < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      mapserv->CoordSource = FROMREFPNT;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "refxy") ==
+        0) { /* mouse click in reference image, single variable */
+      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgxy.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->RefPnt.x);
+      FREE_TOKENS_ON_ERROR(2);
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->RefPnt.y);
+      FREE_TOKENS_ON_ERROR(2);
+
+      msFreeCharArray(tokens, 2);
+
+      if ((mapserv->RefPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.x < (-2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.y < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Reference map coordinate out of range.",
+                   "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      mapserv->CoordSource = FROMREFPNT;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "buffer") ==
+        0) { /* radius (map units), actually 1/2 square side */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->Buffer);
+      mapserv->CoordSource = FROMBUF;
+      mapserv->QueryCoordSource = FROMUSERPNT;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "scale") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "scaledenom") ==
+            0) { /* scale for new map */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->ScaleDenom);
+      if (mapserv->ScaleDenom <= 0) {
+        msSetError(MS_WEBERR, "Scale out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      mapserv->CoordSource = FROMSCALE;
+      mapserv->QueryCoordSource = FROMUSERPNT;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgsize") ==
+        0) { /* size of existing image (pixels) */
+      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgsize.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      mapserv->ImgCols = (int)tmpval;
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      mapserv->ImgRows = (int)tmpval;
+
+      msFreeCharArray(tokens, 2);
+
+      if (mapserv->ImgCols > mapserv->map->maxsize ||
+          mapserv->ImgRows > mapserv->map->maxsize || mapserv->ImgCols <= 0 ||
+          mapserv->ImgRows <= 0) {
+        msSetError(MS_WEBERR, "Image size out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "resolution") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
+      if (tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
+        msSetError(MS_WEBERR, "Resolution value out of range.",
+                   "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      mapserv->map->resolution = (int)tmpval;
+      continue;
+    }
+
+    // map.imagetype and map_imagetype are for backwards compatibility and may
+    // be removed in the future
+    if (strcasecmp(mapserv->request->ParamNames[i], "imagetype") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map.imagetype") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_imagetype") == 0) {
+
+      const char *imagetype_validation_pattern =
+          msLookupHashTable(&(mapserv->map->web.validation), "imagetype");
+      if (imagetype_validation_pattern != NULL &&
+          msEvalRegex(imagetype_validation_pattern,
+                      mapserv->request->ParamValues[i]) !=
+              MS_TRUE) { /* optional check */
+        msSetError(MS_WEBERR, "Imagetype value fails to validate.",
+                   "msCGILoadMap()");
+        return MS_FAILURE;
+      }
+
+      outputFormatObj *format =
+          msSelectOutputFormat(mapserv->map, mapserv->request->ParamValues[i]);
+      if (format == NULL) {
+        msSetError(MS_WEBERR, "Invalid imagetype value.\n", "msCGILoadForm()");
+        return MS_FAILURE;
+      } else {
+        msFree((char *)mapserv->map->imagetype);
+        mapserv->map->imagetype = msStrdup(mapserv->request->ParamValues[i]);
+        msApplyOutputFormat(&(mapserv->map->outputformat), format,
+                            MS_NOOVERRIDE);
+      }
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "tilesize") ==
+        0) { /* size of existing image (pixels) */
+      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for tilesize.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      mapserv->TileWidth = (int)tmpval;
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      mapserv->TileHeight = (int)tmpval;
+
+      msFreeCharArray(tokens, 2);
+
+      if (mapserv->TileWidth > mapserv->map->maxsize ||
+          mapserv->TileHeight > mapserv->map->maxsize ||
+          mapserv->TileWidth <= 0 || mapserv->TileHeight <= 0) {
+        msSetError(MS_WEBERR, "Tile size out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      continue;
+    }
+
+    /* size of new map (pixels), map.size/map_size are included for backwards
+     * compatibility and may be removed in future release */
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapsize") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map.size") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_size") == 0) {
+      tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
+
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for mapsize.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      mapserv->map->width = (int)tmpval;
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
+      FREE_TOKENS_ON_ERROR(2);
+      mapserv->map->height = (int)tmpval;
+
+      msFreeCharArray(tokens, 2);
+
+      if (mapserv->map->width > mapserv->map->maxsize ||
+          mapserv->map->height > mapserv->map->maxsize ||
+          mapserv->map->width <= 0 || mapserv->map->height <= 0) {
+        msSetError(MS_WEBERR, "Image size out of range.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      continue;
+    }
+
+    if (strncasecmp(mapserv->request->ParamNames[i], "layers", 6) ==
+        0) { /* turn a set of layers, delimited by spaces, on */
+
+      /* If layers=all then turn on all layers */
+      if (strcasecmp(mapserv->request->ParamValues[i], "all") == 0) {
+        int l;
+
+        /* Reset NumLayers=0. If individual layers were already selected then
+         * free the previous values.  */
+        for (l = 0; l < mapserv->NumLayers; l++)
+          msFree(mapserv->Layers[l]);
+        mapserv->NumLayers = 0;
+
+        for (mapserv->NumLayers = 0;
+             mapserv->NumLayers < mapserv->map->numlayers;
+             mapserv->NumLayers++) {
+          if (msGrowMapservLayers(mapserv) == MS_FAILURE)
+            return MS_FAILURE;
+
+          if (GET_LAYER(mapserv->map, mapserv->NumLayers)->name) {
+            mapserv->Layers[mapserv->NumLayers] =
+                msStrdup(GET_LAYER(mapserv->map, mapserv->NumLayers)->name);
+          } else {
+            mapserv->Layers[mapserv->NumLayers] = msStrdup("");
+          }
+        }
+      } else {
+        int num_layers = 0, l;
+        char **layers = NULL;
+
+        layers =
+            msStringSplit(mapserv->request->ParamValues[i], ' ', &(num_layers));
+        for (l = 0; l < num_layers; l++) {
+          if (msGrowMapservLayers(mapserv) == MS_FAILURE) {
+            msFreeCharArray(layers, num_layers);
+            return MS_FAILURE;
+          }
+          mapserv->Layers[mapserv->NumLayers++] = msStrdup(layers[l]);
+        }
+
+        msFreeCharArray(layers, num_layers);
+        num_layers = 0;
+      }
+
+      continue;
+    }
+
+    if (strncasecmp(mapserv->request->ParamNames[i], "layer", 5) ==
+        0) { /* turn a single layer/group on */
+      if (msGrowMapservLayers(mapserv) == MS_FAILURE)
+        return MS_FAILURE;
+      mapserv->Layers[mapserv->NumLayers] =
+          msStrdup(mapserv->request->ParamValues[i]);
+      mapserv->NumLayers++;
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "qlayer") ==
+        0) { /* layer to query (i.e search) */
+      mapserv->QueryLayer = msStrdup(mapserv->request->ParamValues[i]);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "qitem") ==
+        0) { /* attribute to query on (optional) */
+      mapserv->QueryItem = msStrdup(mapserv->request->ParamValues[i]);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "qstring") ==
+        0) { /* attribute query string */
+      mapserv->QueryString = msStrdup(mapserv->request->ParamValues[i]);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "qformat") ==
+        0) { /* format to apply to query results (shortcut instead of having to
+                use "map.web=QUERYFORMAT+foo") */
+      if (mapserv->map->web.queryformat)
+        free(mapserv->map->web.queryformat); /* avoid leak */
+      mapserv->map->web.queryformat =
+          msStrdup(mapserv->request->ParamValues[i]);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "slayer") ==
+        0) { /* layer to select (for feature based search) */
+      mapserv->SelectLayer = msStrdup(mapserv->request->ParamValues[i]);
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "shapeindex") ==
+        0) { /* used for index queries */
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
+      mapserv->ShapeIndex = (int)tmpval;
+      continue;
+    }
+    if (strcasecmp(mapserv->request->ParamNames[i], "tileindex") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
+      mapserv->TileIndex = (int)tmpval;
+      continue;
+    }
+
+    /* --------------------------------------------------------------------
+     *   The following code is used to support mode=tile
+     * -------------------------------------------------------------------- */
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "tilemode") == 0) {
+      /* currently, only valid tilemode is "spheremerc" */
+      if (strcasecmp(mapserv->request->ParamValues[i], "gmap") == 0) {
+        mapserv->TileMode = TILE_GMAP;
+      } else if (strcasecmp(mapserv->request->ParamValues[i], "ve") == 0) {
+        mapserv->TileMode = TILE_VE;
+      } else {
+        msSetError(MS_WEBERR, "Invalid tilemode. Use one of: gmap, ve",
+                   "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      continue;
+    }
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "tile") == 0) {
+
+      if (strlen(mapserv->request->ParamValues[i]) < 1) {
+        msSetError(MS_WEBERR, "Empty tile parameter.", "msCGILoadForm()");
+        return MS_FAILURE;
+      }
+      mapserv->CoordSource = FROMTILE;
+      mapserv->TileCoords = msStrdup(mapserv->request->ParamValues[i]);
+
+      continue;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      The following code is used to support the rosa applet (for      */
+    /*      more information on Rosa, please consult :                      */
+    /*      http://www.maptools.org/rosa/) .                                */
+    /*      This code was provided by Tim.Mackey@agso.gov.au.               */
+    /*                                                                      */
+    /*      For Application using it can be seen at :                       */
+    /*        http://www.agso.gov.au/map/pilbara/                           */
+    /*                                                                      */
+    /* -------------------------------------------------------------------- */
+
+    if (strcasecmp(mapserv->request->ParamNames[i], "INPUT_TYPE") == 0) {
+      /* Rosa input type */
+      if (strcasecmp(mapserv->request->ParamValues[i], "auto_rect") == 0) {
+        rosa_type = 1; /* rectangle */
+        continue;
+      }
+
+      if (strcasecmp(mapserv->request->ParamValues[i], "auto_point") == 0) {
+        rosa_type = 2; /* point */
+        continue;
+      }
+    }
+    if (strcasecmp(mapserv->request->ParamNames[i], "INPUT_COORD") == 0) {
+      /* Rosa coordinates */
+
+      switch (rosa_type) {
+      case 1:
+        sscanf(mapserv->request->ParamValues[i], "%lf,%lf;%lf,%lf",
+               &mapserv->ImgBox.minx, &mapserv->ImgBox.miny,
+               &mapserv->ImgBox.maxx, &mapserv->ImgBox.maxy);
+        if ((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) &&
+            (mapserv->ImgBox.miny != mapserv->ImgBox.maxy)) {
+          mapserv->CoordSource = FROMIMGBOX;
+          mapserv->QueryCoordSource = FROMIMGBOX;
+        } else {
+          mapserv->CoordSource = FROMIMGPNT;
+          mapserv->QueryCoordSource = FROMIMGPNT;
+          mapserv->ImgPnt.x = mapserv->ImgBox.minx;
+          mapserv->ImgPnt.y = mapserv->ImgBox.miny;
+        }
+        break;
+      case 2:
+        sscanf(mapserv->request->ParamValues[i], "%lf,%lf", &mapserv->ImgPnt.x,
+               &mapserv->ImgPnt.y);
+        mapserv->CoordSource = FROMIMGPNT;
+        mapserv->QueryCoordSource = FROMIMGPNT;
+        break;
+      }
+      continue;
+    }
+    /* -------------------------------------------------------------------- */
+    /*      end of code for Rosa support.                                   */
+    /* -------------------------------------------------------------------- */
+
+  } /* next parameter */
+
+  if (mapserv->Mode == ZOOMIN) {
+    mapserv->ZoomDirection = 1;
+    mapserv->Mode = BROWSE;
+  }
+  if (mapserv->Mode == ZOOMOUT) {
+    mapserv->ZoomDirection = -1;
+    mapserv->Mode = BROWSE;
+  }
+
+  if (mapserv->ZoomSize !=
+      0) { /* use direction and magnitude to calculate zoom */
+    if (mapserv->ZoomDirection == 0) {
+      mapserv->fZoom = 1;
+    } else {
+      mapserv->fZoom = mapserv->ZoomSize * mapserv->ZoomDirection;
+      if (mapserv->fZoom < 0)
+        mapserv->fZoom = 1.0 / MS_ABS(mapserv->fZoom);
+    }
+  } else { /* use single value for zoom */
+    if ((mapserv->Zoom >= -1) && (mapserv->Zoom <= 1)) {
+      mapserv->fZoom = 1; /* pan */
+    } else {
+      if (mapserv->Zoom < 0)
+        mapserv->fZoom = 1.0 / MS_ABS(mapserv->Zoom);
+      else
+        mapserv->fZoom = mapserv->Zoom;
+    }
+  }
+
+  if (mapserv->ImgRows == -1)
+    mapserv->ImgRows = mapserv->map->height;
+  if (mapserv->ImgCols == -1)
+    mapserv->ImgCols = mapserv->map->width;
+  if (mapserv->map->height == -1)
+    mapserv->map->height = mapserv->ImgRows;
+  if (mapserv->map->width == -1)
+    mapserv->map->width = mapserv->ImgCols;
+  return MS_SUCCESS;
+}
+
+int setExtentFromShapes(mapservObj *mapserv) {
+  double dx, dy, cellsize;
+
+  rectObj tmpext = {-1.0, -1.0, -1.0, -1.0};
+  pointObj tmppnt = {-1.0, -1.0, -1.0, -1.0};
+
+  msGetQueryResultBounds(mapserv->map, &(tmpext));
+
+  dx = tmpext.maxx - tmpext.minx;
+  dy = tmpext.maxy - tmpext.miny;
+
+  tmppnt.x = (tmpext.maxx + tmpext.minx) / 2;
+  tmppnt.y = (tmpext.maxy + tmpext.miny) / 2;
+  tmpext.minx -= dx * EXTENT_PADDING / 2.0;
+  tmpext.maxx += dx * EXTENT_PADDING / 2.0;
+  tmpext.miny -= dy * EXTENT_PADDING / 2.0;
+  tmpext.maxy += dy * EXTENT_PADDING / 2.0;
+
+  if (mapserv->ScaleDenom !=
+      0) { /* apply the scale around the center point (tmppnt) */
+    cellsize = (mapserv->ScaleDenom / mapserv->map->resolution) /
+               msInchesPerUnit(mapserv->map->units,
+                               0); /* user supplied a point and a scale */
+    tmpext.minx = tmppnt.x - cellsize * mapserv->map->width / 2.0;
+    tmpext.miny = tmppnt.y - cellsize * mapserv->map->height / 2.0;
+    tmpext.maxx = tmppnt.x + cellsize * mapserv->map->width / 2.0;
+    tmpext.maxy = tmppnt.y + cellsize * mapserv->map->height / 2.0;
+  } else if (mapserv->Buffer !=
+             0) { /* apply the buffer around the center point (tmppnt) */
+    tmpext.minx = tmppnt.x - mapserv->Buffer;
+    tmpext.miny = tmppnt.y - mapserv->Buffer;
+    tmpext.maxx = tmppnt.x + mapserv->Buffer;
+    tmpext.maxy = tmppnt.y + mapserv->Buffer;
+  }
+
+  /* in case we don't get  usable extent at this point (i.e. single point
+   * result) */
+  if (!MS_VALID_EXTENT(tmpext)) {
+    if (mapserv->map->web.minscaledenom >
+        0) { /* try web object minscale first */
+      cellsize = (mapserv->map->web.minscaledenom / mapserv->map->resolution) /
+                 msInchesPerUnit(mapserv->map->units,
+                                 0); /* user supplied a point and a scale */
+      tmpext.minx = tmppnt.x - cellsize * mapserv->map->width / 2.0;
+      tmpext.miny = tmppnt.y - cellsize * mapserv->map->height / 2.0;
+      tmpext.maxx = tmppnt.x + cellsize * mapserv->map->width / 2.0;
+      tmpext.maxy = tmppnt.y + cellsize * mapserv->map->height / 2.0;
+    } else {
+      msSetError(MS_WEBERR,
+                 "No way to generate a valid map extent from selected shapes.",
+                 "mapserv()");
+      return MS_FAILURE;
+    }
+  }
+
+  mapserv->mappnt = tmppnt;
+  mapserv->map->extent = mapserv->RawExt = tmpext; /* save unadjusted extent */
+
+  return MS_SUCCESS;
+}
+
+/* FIX: NEED ERROR CHECKING HERE FOR IMGPNT or MAPPNT */
+void setCoordinate(mapservObj *mapserv) {
+  double cellx, celly;
+
+  cellx =
+      MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
+  celly =
+      MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
+
+  mapserv->mappnt.x =
+      MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
+  mapserv->mappnt.y =
+      MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
+
+  return;
+}
+
+int msCGIDispatchBrowseRequest(mapservObj *mapserv) {
+  char *template = NULL;
+  int i, status;
+  for (i = 0; i < mapserv->request->NumParams;
+       i++) /* find the template param value */
+    if (strcasecmp(mapserv->request->ParamNames[i], "template") == 0)
+      template = mapserv->request->ParamValues[i];
+
+  if ((!mapserv->map->web.template) &&
+      (template == NULL || (strcasecmp(template, "openlayers") != 0))) {
+    msSetError(MS_WEBERR,
+               "Traditional BROWSE mode requires a TEMPLATE in the WEB "
+               "section, but none was provided.",
+               "mapserv()");
+    return MS_FAILURE;
+  }
+
+  if (mapserv->QueryFile) {
+    status = msLoadQuery(mapserv->map, mapserv->QueryFile);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  status = setExtent(mapserv);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+  status = checkWebScale(mapserv);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /* -------------------------------------------------------------------- */
+  /*      generate map, legend, scalebar and refernce images.             */
+  /* -------------------------------------------------------------------- */
+  if (msGenerateImages(mapserv, MS_FALSE, MS_TRUE) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  if ((template != NULL) && (strcasecmp(template, "openlayers") == 0)) {
+    msIO_setHeader("Content-Type", "text/html");
+    msIO_sendHeaders();
+    if (msReturnOpenLayersPage(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
+  } else if (mapserv->QueryFile) {
+    if (msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) !=
+        MS_SUCCESS)
+      return MS_FAILURE;
+  } else {
+    if (TEMPLATE_TYPE(mapserv->map->web.template) ==
+        MS_FILE) { /* if thers's an html template, then use it */
+      if (mapserv->sendheaders) {
+        msIO_setHeader("Content-Type", "%s",
+                       mapserv->map->web.browseformat); /* write MIME header */
+        msIO_sendHeaders();
+      }
+      if (msReturnPage(mapserv, mapserv->map->web.template, BROWSE, NULL) !=
+          MS_SUCCESS)
+        return MS_FAILURE;
+    } else {
+      if (msReturnURL(mapserv, mapserv->map->web.template, BROWSE) !=
+          MS_SUCCESS)
+        return MS_FAILURE;
+    }
+  }
+  return MS_SUCCESS;
+}
+
+int msCGIDispatchCoordinateRequest(mapservObj *mapserv) {
+  setCoordinate(mapserv); /* mouse click => map coord */
+  msIO_printf("Your \"<i>click</i>\" corresponds to (approximately): (%g, %g).",
+              mapserv->mappnt.x, mapserv->mappnt.y);
+
+  if (mapserv->map->projection.proj != NULL &&
+      !msProjIsGeographicCRS(&(mapserv->map->projection))) {
+    pointObj p = mapserv->mappnt;
+    msProjectPoint(&(mapserv->map->projection), &(mapserv->map->latlon), &p);
+    msIO_printf("Computed lat/lon value is (%g, %g).\n", p.x, p.y);
+  }
+  return MS_SUCCESS;
+}
+
+int msCGIDispatchQueryRequest(mapservObj *mapserv) {
+  int status, i, j;
+  char buffer[1024];
+  if (mapserv->QueryFile) { /* already got a completed query */
+    status = msLoadQuery(mapserv->map, mapserv->QueryFile);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+  } else {
+
+    if ((mapserv->QueryLayerIndex =
+             msGetLayerIndex(mapserv->map, mapserv->QueryLayer)) !=
+        -1) /* force the query layer on */
+      GET_LAYER(mapserv->map, mapserv->QueryLayerIndex)->status = MS_ON;
+
+    switch (mapserv->Mode) {
+    case ITEMFEATUREQUERY:
+    case ITEMFEATURENQUERY:
+      if ((mapserv->SelectLayerIndex =
+               msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) ==
+          -1) { /* force the selection layer on */
+        msSetError(MS_WEBERR,
+                   "Selection layer not set or references an invalid layer.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+      GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
+
+      /* validate the qstring parameter */
+      if (msValidateParameter(
+              mapserv->QueryString,
+              msLookupHashTable(
+                  &(GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)
+                        ->validation),
+                  "qstring"),
+              msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
+              NULL, NULL) != MS_SUCCESS) {
+        msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+
+      if (mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
+        if (MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
+          return MS_FAILURE;
+
+      mapserv->map->query.type = MS_QUERY_BY_FILTER;
+      if (mapserv->QueryItem)
+        mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
+      if (mapserv->QueryString) {
+        msInitExpression(&mapserv->map->query.filter);
+        msLoadExpressionString(&mapserv->map->query.filter,
+                               mapserv->QueryString);
+      }
+
+      mapserv->map->query.rect = mapserv->map->extent;
+
+      mapserv->map->query.mode = MS_QUERY_MULTIPLE;
+      if (mapserv->Mode == ITEMFEATUREQUERY)
+        mapserv->map->query.mode = MS_QUERY_SINGLE;
+
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.slayer =
+          mapserv->SelectLayerIndex; /* this will trigger the feature query
+                                        eventually */
+      break;
+    case FEATUREQUERY:
+    case FEATURENQUERY:
+      if ((mapserv->SelectLayerIndex =
+               msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) ==
+          -1) { /* force the selection layer on */
+        msSetError(MS_WEBERR,
+                   "Selection layer not set or references an invalid layer.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+      GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
+
+      if (mapserv->Mode == FEATUREQUERY) {
+        switch (mapserv->QueryCoordSource) {
+        case FROMIMGPNT:
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing map extent */
+          setCoordinate(mapserv);
+          break;
+        case FROMUSERPNT:
+          break;
+        default:
+          msSetError(
+              MS_WEBERR,
+              "No way to perform the initial search, not enough information.",
+              "mapserv()");
+          return MS_FAILURE;
+          break;
+        }
+
+        mapserv->map->query.type = MS_QUERY_BY_POINT;
+      } else { /* FEATURENQUERY */
+        switch (mapserv->QueryCoordSource) {
+        case FROMIMGPNT:
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing map extent */
+          setCoordinate(mapserv);
+          mapserv->map->query.type = MS_QUERY_BY_POINT;
+          break;
+        case FROMIMGBOX:
+          /* TODO: this option was present but with no code to leverage the
+           * image box... */
+          break;
+        case FROMUSERPNT:
+          mapserv->map->query.type = MS_QUERY_BY_POINT;
+          break;
+        default:
+          if (MS_SUCCESS != setExtent(mapserv)) {
+            return MS_FAILURE;
+          }
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+          break;
+        }
+      }
+
+      mapserv->map->query.mode = MS_QUERY_MULTIPLE;
+
+      mapserv->map->query.rect = mapserv->map->extent;
+      mapserv->map->query.point = mapserv->mappnt;
+      mapserv->map->query.buffer = mapserv->Buffer;
+
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.slayer = mapserv->SelectLayerIndex;
+      break;
+    case ITEMQUERY:
+    case ITEMNQUERY:
+      if (mapserv->QueryLayerIndex < 0 ||
+          mapserv->QueryLayerIndex >= mapserv->map->numlayers) {
+        msSetError(MS_WEBERR,
+                   "Query layer not set or references an invalid layer.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+
+      /* validate the qstring parameter */
+      if (msValidateParameter(
+              mapserv->QueryString,
+              msLookupHashTable(
+                  &(GET_LAYER(mapserv->map, mapserv->QueryLayerIndex)
+                        ->validation),
+                  "qstring"),
+              msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
+              NULL, NULL) != MS_SUCCESS) {
+        msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+
+      if (mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
+        if (MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
+          return MS_FAILURE;
+
+      mapserv->map->query.type = MS_QUERY_BY_FILTER;
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      if (mapserv->QueryItem)
+        mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
+      if (mapserv->QueryString) {
+        msInitExpression(&mapserv->map->query.filter);
+        msLoadExpressionString(&mapserv->map->query.filter,
+                               mapserv->QueryString);
+      }
+
+      mapserv->map->query.rect = mapserv->map->extent;
+
+      mapserv->map->query.mode = MS_QUERY_MULTIPLE;
+      if (mapserv->Mode == ITEMQUERY)
+        mapserv->map->query.mode = MS_QUERY_SINGLE;
+      break;
+    case NQUERY:
+      mapserv->map->query.mode =
+          MS_QUERY_MULTIPLE; /* all of these cases return multiple results */
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+
+      switch (mapserv->QueryCoordSource) {
+      case FROMIMGPNT:
+        setCoordinate(mapserv);
+
+        if (mapserv->SearchMap) { /* compute new extent, pan etc then search
+                                     that extent */
+          if (MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
+            return MS_FAILURE;
+          mapserv->map->cellsize =
+              msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                             mapserv->map->height);
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          mapserv->map->query.rect = mapserv->map->extent;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+        } else {
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing image parameters */
+          mapserv->map->width = mapserv->ImgCols;
+          mapserv->map->height = mapserv->ImgRows;
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          mapserv->map->query.point = mapserv->mappnt;
+          mapserv->map->query.type = MS_QUERY_BY_POINT;
+        }
+
+        break;
+      case FROMIMGBOX:
+        if (mapserv->SearchMap) { /* compute new extent, pan etc then search
+                                     that extent */
+          setExtent(mapserv);
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          mapserv->map->cellsize =
+              msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                             mapserv->map->height);
+          mapserv->map->query.rect = mapserv->map->extent;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+        } else {
+          double cellx, celly;
+
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing image parameters */
+          mapserv->map->width = mapserv->ImgCols;
+          mapserv->map->height = mapserv->ImgRows;
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          cellx = MS_CELLSIZE(
+              mapserv->ImgExt.minx, mapserv->ImgExt.maxx,
+              mapserv->ImgCols); /* calculate the new search extent */
+          celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy,
+                              mapserv->ImgRows);
+          mapserv->RawExt.minx =
+              MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
+          mapserv->RawExt.maxx =
+              MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
+          mapserv->RawExt.maxy =
+              MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy,
+                             celly); /* y's are flip flopped because img/map
+                                        coordinate systems are */
+          mapserv->RawExt.miny =
+              MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
+
+          mapserv->map->query.rect = mapserv->RawExt;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+        }
+        break;
+      case FROMIMGSHAPE:
+        mapserv->map->extent =
+            mapserv->ImgExt; /* use the existing image parameters */
+        mapserv->map->width = mapserv->ImgCols;
+        mapserv->map->height = mapserv->ImgRows;
+        mapserv->map->cellsize = msAdjustExtent(
+            &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+        if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                             mapserv->map->width, mapserv->map->height,
+                             mapserv->map->resolution,
+                             &mapserv->map->scaledenom) != MS_SUCCESS)
+          return MS_FAILURE;
+
+        /* convert from image to map coordinates here (see setCoordinate) */
+        for (i = 0; i < mapserv->map->query.shape->numlines; i++) {
+          for (j = 0; j < mapserv->map->query.shape->line[i].numpoints; j++) {
+            mapserv->map->query.shape->line[i].point[j].x = MS_IMAGE2MAP_X(
+                mapserv->map->query.shape->line[i].point[j].x,
+                mapserv->map->extent.minx, mapserv->map->cellsize);
+            mapserv->map->query.shape->line[i].point[j].y = MS_IMAGE2MAP_Y(
+                mapserv->map->query.shape->line[i].point[j].y,
+                mapserv->map->extent.maxy, mapserv->map->cellsize);
+          }
+        }
+
+        mapserv->map->query.type = MS_QUERY_BY_SHAPE;
+        break;
+      case FROMUSERPNT:
+        if (mapserv->Buffer == 0) { /* do a *pure* point query */
+          mapserv->map->query.point = mapserv->mappnt;
+          mapserv->map->query.type = MS_QUERY_BY_POINT;
+          setExtent(mapserv);
+        } else {
+          setExtent(mapserv);
+          if (mapserv->SearchMap) { /* the extent should be tied to a map, so we
+                                       need to "adjust" it */
+            if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                                 mapserv->map->width, mapserv->map->height,
+                                 mapserv->map->resolution,
+                                 &mapserv->map->scaledenom) != MS_SUCCESS)
+              return MS_FAILURE;
+            mapserv->map->cellsize =
+                msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                               mapserv->map->height);
+          }
+          mapserv->map->query.rect = mapserv->map->extent;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+        }
+        break;
+      case FROMUSERSHAPE:
+        setExtent(mapserv);
+        mapserv->map->query.type = MS_QUERY_BY_SHAPE;
+        break;
+      default: /* from an extent of some sort */
+        setExtent(mapserv);
+        if (mapserv->SearchMap) { /* the extent should be tied to a map, so we
+                                     need to "adjust" it */
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          mapserv->map->cellsize =
+              msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                             mapserv->map->height);
+        }
+
+        mapserv->map->query.rect = mapserv->map->extent;
+        mapserv->map->query.type = MS_QUERY_BY_RECT;
+        break;
+      }
+      break;
+    case QUERY:
+      switch (mapserv->QueryCoordSource) {
+      case FROMIMGPNT:
+        setCoordinate(mapserv);
+        mapserv->map->extent =
+            mapserv->ImgExt; /* use the existing image parameters */
+        mapserv->map->width = mapserv->ImgCols;
+        mapserv->map->height = mapserv->ImgRows;
+        if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                             mapserv->map->width, mapserv->map->height,
+                             mapserv->map->resolution,
+                             &mapserv->map->scaledenom) != MS_SUCCESS)
+          return MS_FAILURE;
+        break;
+      case FROMUSERPNT: /* only a buffer makes sense, DOES IT? */
+        if (setExtent(mapserv) != MS_SUCCESS)
+          return MS_FAILURE;
+        break;
+      default:
+        msSetError(MS_WEBERR,
+                   "Query mode needs a point, imgxy and mapxy are not set.",
+                   "mapserv()");
+        return MS_FAILURE;
+        break;
+      }
+
+      mapserv->map->query.type = MS_QUERY_BY_POINT;
+      mapserv->map->query.mode = MS_QUERY_SINGLE;
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.point = mapserv->mappnt;
+      mapserv->map->query.buffer = mapserv->Buffer;
+      break;
+    case INDEXQUERY:
+      mapserv->map->query.type = MS_QUERY_BY_INDEX;
+      mapserv->map->query.mode = MS_QUERY_SINGLE;
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.shapeindex = mapserv->ShapeIndex;
+      mapserv->map->query.tileindex = mapserv->TileIndex;
+      break;
+    } /* end mode switch */
+
+    /* finally execute the query */
+    if (msExecuteQuery(mapserv->map) != MS_SUCCESS)
+      return MS_FAILURE;
+
+    /* catch empty result set when web->empty is set (#6907) */
+    if (mapserv->map->web.empty != NULL ||
+        CPLGetConfigOption("MS_EMPTY_URL", NULL) != NULL) {
+      int empty = MS_TRUE;
+      for (int i = 0; i < mapserv->map->numlayers; i++) { // count results
+        if (mapserv->map->layers[i]->resultcache &&
+            mapserv->map->layers[i]->resultcache->numresults > 0) {
+          empty = MS_FALSE;
+          break;
+        }
+      }
+      if (empty == MS_TRUE) {
+        /* note: this error message will not be displayed */
+        msSetError(MS_NOTFOUND, "No matching record(s) found.",
+                   "msCGIDispatchQueryRequest()");
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  if (mapserv->map->querymap.width > 0 &&
+      mapserv->map->querymap.width <= mapserv->map->maxsize)
+    mapserv->map->width =
+        mapserv->map->querymap.width; /* make sure we use the right size */
+  if (mapserv->map->querymap.height > 0 &&
+      mapserv->map->querymap.height <= mapserv->map->maxsize)
+    mapserv->map->height = mapserv->map->querymap.height;
+
+  if (mapserv->UseShapes)
+    if (MS_SUCCESS != setExtentFromShapes(mapserv))
+      return MS_FAILURE;
+
+  if (msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) !=
+      MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (mapserv->savequery) {
+    snprintf(buffer, sizeof(buffer), "%s%s%s%s", mapserv->map->web.imagepath,
+             mapserv->map->name, mapserv->Id, MS_QUERY_EXTENSION);
+    if ((status = msSaveQuery(mapserv->map, buffer, MS_FALSE)) != MS_SUCCESS)
+      return status;
+  }
+  return MS_SUCCESS;
+}
+
+int msCGIDispatchImageRequest(mapservObj *mapserv) {
+  int status;
+  imageObj *img = NULL;
+  switch (mapserv->Mode) {
+  case MAP:
+    if (mapserv->QueryFile) {
+      status = msLoadQuery(mapserv->map, mapserv->QueryFile);
+      if (status != MS_SUCCESS)
+        return MS_FAILURE;
+      img = msDrawMap(mapserv->map, MS_TRUE);
+    } else
+      img = msDrawMap(mapserv->map, MS_FALSE);
+    break;
+  case REFERENCE:
+    mapserv->map->cellsize = msAdjustExtent(
+        &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+    img = msDrawReferenceMap(mapserv->map);
+    break;
+  case SCALEBAR:
+    img = msDrawScalebar(mapserv->map);
+    break;
+  case TILE:
+    msTileSetExtent(mapserv);
+
+    if (!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat),
+                "application/vnd.mapbox-vector-tile") ||
+        !strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat),
+                "application/x-protobuf")) {
+      if (msMVTWriteTile(mapserv->map, mapserv->sendheaders) != MS_SUCCESS)
+        return MS_FAILURE;
+      return MS_SUCCESS;
+    }
+
+    img = msTileDraw(mapserv);
+    break;
+  case LEGEND:
+  case MAPLEGEND:
+    img = msDrawLegend(mapserv->map, MS_FALSE, mapserv->hittest);
+    break;
+  default:
+    msSetError(MS_CGIERR, "Invalid CGI mode", "msCGIDispatchImageRequest()");
+    break;
+  }
+
+  if (!img)
+    return MS_FAILURE;
+
+  /*
+   ** Set the Cache control headers if the option is set.
+   */
+  if (mapserv->sendheaders &&
+      msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age")) {
+    msIO_setHeader(
+        "Cache-Control", "max-age=%s",
+        msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"));
+  }
+
+  if (mapserv->sendheaders) {
+    const char *attachment =
+        msGetOutputFormatOption(mapserv->map->outputformat, "ATTACHMENT", NULL);
+    if (attachment)
+      msIO_setHeader("Content-disposition", "attachment; filename=%s",
+                     attachment);
+
+    if (!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat),
+                "application/json")) {
+      msIO_setHeader("Content-Type", "application/json; charset=utf-8");
+    } else {
+      msIO_setHeader("Content-Type", "%s",
+                     MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
+    }
+    msIO_sendHeaders();
+  }
+
+  if (mapserv->Mode == MAP || mapserv->Mode == TILE)
+    status = msSaveImage(mapserv->map, img, NULL);
+  else
+    status = msSaveImage(NULL, img, NULL);
+
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  msFreeImage(img);
+  return MS_SUCCESS;
+}
+
+int msCGIDispatchLegendRequest(mapservObj *mapserv) {
+  int status;
+  if (mapserv->Mode == MAPLEGEND) {
+    if (setExtent(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
+    if (checkWebScale(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
+    mapserv->hittest = msSmallMalloc(sizeof(map_hittest));
+    initMapHitTests(mapserv->map, mapserv->hittest);
+    status = msHitTestMap(mapserv->map, mapserv->hittest);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+  if (mapserv->map->legend.template) {
+    char *legendTemplate;
+    legendTemplate = generateLegendTemplate(mapserv);
+    if (legendTemplate) {
+      if (mapserv->sendheaders) {
+        msIO_setHeader("Content-Type", "%s", mapserv->map->web.legendformat);
+        msIO_sendHeaders();
+      }
+      msIO_fwrite(legendTemplate, strlen(legendTemplate), 1, stdout);
+
+      free(legendTemplate);
+      return MS_SUCCESS;
+    } else { /* error already generated by (generateLegendTemplate()) */
+      return MS_FAILURE;
+    }
+  } else {
+    return msCGIDispatchImageRequest(mapserv);
+  }
+}
+
+int msCGIDispatchLegendIconRequest(mapservObj *mapserv) {
+  char **tokens = NULL;
+  int numtokens = 0;
+  int layerindex = -1, classindex = 0, status;
+  outputFormatObj *format = NULL;
+  imageObj *img = NULL;
+
+  /* TODO: do we want to set scale here? */
+
+  /* do we have enough information */
+  if (!mapserv->icon) {
+    msSetError(MS_WEBERR, "Mode=LEGENDICON requires an icon parameter.",
+               "mapserv()");
+    return MS_FAILURE;
+  }
+
+  /* process the icon definition */
+  tokens = msStringSplit(mapserv->icon, ',', &numtokens);
+
+  if (numtokens != 1 && numtokens != 2) {
+    msSetError(MS_WEBERR,
+               "%d Malformed icon parameter, should be 'layer,class' or just "
+               "'layer' if the layer has only 1 class defined.",
+               "mapserv()", numtokens);
+    status = MS_FAILURE;
+    goto li_cleanup;
+  }
+
+  if ((layerindex = msGetLayerIndex(mapserv->map, tokens[0])) == -1) {
+    msSetError(MS_WEBERR, "Icon layer=%s not found in mapfile.", "mapserv()",
+               tokens[0]);
+    status = MS_FAILURE;
+    goto li_cleanup;
+  }
+
+  if (numtokens == 2) { /* check the class index */
+    classindex = atoi(tokens[1]);
+    if (classindex < 0 ||
+        classindex >= GET_LAYER(mapserv->map, layerindex)->numclasses) {
+      msSetError(MS_WEBERR, "Icon class=%d not found in layer=%s.", "mapserv()",
+                 classindex, GET_LAYER(mapserv->map, layerindex)->name);
+      status = MS_FAILURE;
+      goto li_cleanup;
+    }
+  }
+
+  if (mapserv->Mode == MAPLEGENDICON) {
+    if (setExtent(mapserv) != MS_SUCCESS) {
+      status = MS_FAILURE;
+      goto li_cleanup;
+    }
+    if (checkWebScale(mapserv) != MS_SUCCESS) {
+      status = MS_FAILURE;
+      goto li_cleanup;
+    }
+    mapserv->hittest = msSmallMalloc(sizeof(map_hittest));
+    initMapHitTests(mapserv->map, mapserv->hittest);
+    status = msHitTestLayer(mapserv->map, GET_LAYER(mapserv->map, layerindex),
+                            &mapserv->hittest->layerhits[layerindex]);
+    if (status != MS_SUCCESS)
+      goto li_cleanup;
+  }
+
+  /* ensure we have an image format representing the options for the legend. */
+  msApplyOutputFormat(&format, mapserv->map->outputformat,
+                      mapserv->map->legend.transparent);
+
+  /* initialize the legend image */
+  if (!MS_RENDERER_PLUGIN(format)) {
+    msSetError(MS_RENDERERERR, "unsupported renderer for legend icon",
+               "mapserv main()");
+    status = MS_FAILURE;
+    goto li_cleanup;
+  }
+  img = msImageCreate(mapserv->map->legend.keysizex,
+                      mapserv->map->legend.keysizey, format,
+                      mapserv->map->web.imagepath, mapserv->map->web.imageurl,
+                      mapserv->map->resolution, mapserv->map->defresolution,
+                      &(mapserv->map->legend.imagecolor));
+  if (!img) {
+    status = MS_FAILURE;
+    goto li_cleanup;
+  }
+  img->map = mapserv->map;
+
+  /* drop this reference to output format */
+  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
+
+  if (msDrawLegendIcon(mapserv->map, GET_LAYER(mapserv->map, layerindex),
+                       GET_LAYER(mapserv->map, layerindex)->class[classindex],
+                       mapserv -> map -> legend.keysizex,
+                       mapserv->map->legend.keysizey, img, 0, 0, MS_TRUE,
+                       ((mapserv->hittest)
+                            ? (&mapserv->hittest->layerhits[layerindex]
+                                    .classhits[classindex])
+                            : (NULL))) != MS_SUCCESS) {
+    status = MS_FAILURE;
+    goto li_cleanup;
+  }
+
+  if (mapserv->sendheaders) {
+    msIO_setHeader("Content-Type", "%s",
+                   MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
+    msIO_sendHeaders();
+  }
+  /*
+   ** Set the Cache control headers if the option is set.
+   */
+  if (mapserv->sendheaders &&
+      msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age")) {
+    msIO_printf(
+        "Cache-Control: max-age=%s%c",
+        msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"), 10);
+  }
+
+  status = msSaveImage(NULL, img, NULL);
+
+li_cleanup:
+  msFreeCharArray(tokens, numtokens);
+  msFreeImage(img);
+  return status;
+}
+
+int msCGIDispatchRequest(mapservObj *mapserv) {
+  int i;
+  int status;
+
+  /*
+   ** Determine 'mode': Check for MS_MODE env. var. and mode=... CGI param
+   */
+  mapserv->Mode = -1; /* Not set */
+  if (msCGISetMode(mapserv) != MS_SUCCESS) {
+    return MS_FAILURE;
+  }
+
+  /*
+   ** Start by calling the WMS/WFS/WCS Dispatchers.  If they fail then we'll
+   ** process this as a regular MapServer request.
+   */
+  if ((mapserv->Mode == -1 || mapserv->Mode == OWS || mapserv->Mode == WFS) &&
+      (status = msOWSDispatch(mapserv->map, mapserv->request, mapserv->Mode)) !=
+          MS_DONE) {
+    /*
+     ** OWSDispatch returned either MS_SUCCESS or MS_FAILURE
+     */
+    if (status == MS_FAILURE) {
+      return MS_FAILURE;
+    }
+
+    if (status == MS_SUCCESS &&
+        strcasecmp(mapserv->map->imagetype, "application/openlayers") == 0) {
+      char *service = NULL;
+      for (i = 0; i < mapserv->request->NumParams; i++) {
+        if (strcasecmp(mapserv->request->ParamNames[i], "SERVICE") == 0) {
+          service = mapserv->request->ParamValues[i];
+          break;
+        }
+      }
+      if (service && strcasecmp(service, "WMS") == 0) {
+        if (mapserv->sendheaders) {
+          msIO_setHeader("Content-Type", "text/html");
+          msIO_sendHeaders();
+        }
+
+        if (msReturnOpenLayersPage(mapserv) != MS_SUCCESS)
+          return MS_FAILURE;
+      }
+    }
+    return MS_SUCCESS;
+  } /* done OGC/OWS case */
+
+  /*
+  ** Do "traditional" mode processing.
+  */
+  if (mapserv->Mode == -1)
+    mapserv->Mode = BROWSE;
+
+  if (MS_SUCCESS != msCGILoadForm(mapserv)) {
+    return MS_FAILURE;
+  }
+
+  /* Insecure as implemented, need to save someplace non accessible by everyone
+     in the universe if(mapserv->savemap) { snprintf(buffer, sizeof(buffer),
+     "%s%s%s.map", mapserv->map->web.imagepath, mapserv->map->name,
+     mapserv->Id); if(msSaveMap(mapserv->map, buffer) == -1) return MS_FAILURE;
+      }
+  */
+
+  if ((mapserv->CoordSource == FROMIMGPNT) ||
+      (mapserv->CoordSource == FROMIMGBOX)) /* make sure extent of existing
+                                               image matches shape of image */
+    mapserv->map->cellsize =
+        msAdjustExtent(&mapserv->ImgExt, mapserv->ImgCols, mapserv->ImgRows);
+
+  /*
+  ** For each layer let's set layer status
+  */
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    if ((GET_LAYER(mapserv->map, i)->status != MS_DEFAULT)) {
+      if (isOn(mapserv, GET_LAYER(mapserv->map, i)->name,
+               GET_LAYER(mapserv->map, i)->group) ==
+          MS_TRUE) /* Set layer status */
+        GET_LAYER(mapserv->map, i)->status = MS_ON;
+      else
+        GET_LAYER(mapserv->map, i)->status = MS_OFF;
+    }
+  }
+
+  if (mapserv->CoordSource ==
+      FROMREFPNT) /* force browse mode if the reference coords are set */
+    mapserv->Mode = BROWSE;
+
+  if (mapserv->Mode == TILE) {
+    /*
+     ** Tile mode:
+     ** Set the projection up and test the parameters for legality.
+     */
+    if (msTileSetup(mapserv) != MS_SUCCESS) {
+      return MS_FAILURE;
+    }
+  }
+  if (mapserv->Mode == BROWSE) {
+    return msCGIDispatchBrowseRequest(mapserv);
+  } else if (mapserv->Mode == MAP || mapserv->Mode == SCALEBAR ||
+             mapserv->Mode == REFERENCE ||
+             mapserv->Mode == TILE) { /* "image" only modes */
+    /* tile, map, scalebar and reference all need the extent to be set up
+     * correctly */
+    if (setExtent(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
+    if (checkWebScale(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
+    return msCGIDispatchImageRequest(mapserv);
+  } else if (mapserv->Mode == LEGEND || mapserv->Mode == MAPLEGEND) {
+    return msCGIDispatchLegendRequest(mapserv);
+  } else if (mapserv->Mode == LEGENDICON || mapserv->Mode == MAPLEGENDICON) {
+    return msCGIDispatchLegendIconRequest(mapserv);
+  } else if (mapserv->Mode >= QUERY) {
+    return msCGIDispatchQueryRequest(mapserv);
+  } else if (mapserv->Mode == COORDINATE) {
+    return msCGIDispatchCoordinateRequest(mapserv);
+  } else {
+    msSetError(MS_WEBERR, "Bug: unsupported mode", "msDispatchRequest");
+    return MS_FAILURE;
+  }
+}
+
+int msCGIHandler(const char *query_string, void **out_buffer,
+                 size_t *buffer_length) {
+  int x, m = 0;
+  struct mstimeval execstarttime = {0}, execendtime = {0};
+  struct mstimeval requeststarttime = {0}, requestendtime = {0};
+  mapservObj *mapserv = NULL;
+  char *queryString = NULL;
+  int maxParams = MS_DEFAULT_CGI_PARAMS;
+  msIOContext *ctx;
+  msIOBuffer *buf;
+
+  configObj *config = NULL;
+
+  msIO_installStdoutToBuffer();
+
+  /* Use PROJ_DATA/PROJ_LIB env vars if set */
+  msProjDataInitFromEnv();
+
+  /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
+  if (msDebugInitFromEnv() != MS_SUCCESS) {
+    msCGIWriteError(mapserv);
+    goto end_request;
+  }
+
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&execstarttime, NULL);
+
+  if (!query_string || !*query_string) {
+    msIO_setHeader("Content-Type", "text/html");
+    msIO_sendHeaders();
+    msIO_printf("No query information to decode. QUERY_STRING not set.\n");
+    goto end_request;
+  }
+
+  config = msLoadConfig(NULL);
+  if (config == NULL) {
+    msCGIWriteError(mapserv);
+    goto end_request;
+  }
+
+  mapserv = msAllocMapServObj();
+  mapserv->request->type = MS_GET_REQUEST;
+
+  /* don't modify the string */
+  queryString = msStrdup(query_string);
+  for (x = 0; queryString[0] != '\0'; x++) {
+    if (m >= maxParams) {
+      maxParams *= 2;
+      mapserv->request->ParamNames = (char **)realloc(
+          mapserv->request->ParamNames, sizeof(char *) * maxParams);
+      if (mapserv->request->ParamNames == NULL) {
+        msIO_printf("Out of memory trying to allocate name/value pairs.\n");
+        goto end_request;
+      }
+      mapserv->request->ParamValues = (char **)realloc(
+          mapserv->request->ParamValues, sizeof(char *) * maxParams);
+      if (mapserv->request->ParamValues == NULL) {
+        msIO_printf("Out of memory trying to allocate name/value pairs.\n");
+        goto end_request;
+      }
+    }
+    mapserv->request->ParamValues[m] = makeword(queryString, '&');
+    plustospace(mapserv->request->ParamValues[m]);
+    unescape_url(mapserv->request->ParamValues[m]);
+    mapserv->request->ParamNames[m] =
+        makeword(mapserv->request->ParamValues[m], '=');
+    m++;
+  }
+  mapserv->request->NumParams = m;
+
+  if (mapserv->request->NumParams == 0) {
+    msCGIWriteError(mapserv);
+    goto end_request;
+  }
+
+  mapserv->map = msCGILoadMap(mapserv, config);
+  if (!mapserv->map) {
+    msCGIWriteError(mapserv);
+    goto end_request;
+  }
+
+  if (mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&requeststarttime, NULL);
+
+  if (msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
+    msCGIWriteError(mapserv);
+    goto end_request;
+  }
+
+end_request:
+  if (mapserv) {
+    if (mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
+      msGettimeofday(&requestendtime, NULL);
+      msDebug("mapserv request processing time (msLoadMap not incl.): %.3fs\n",
+              (requestendtime.tv_sec + requestendtime.tv_usec / 1.0e6) -
+                  (requeststarttime.tv_sec + requeststarttime.tv_usec / 1.0e6));
+    }
+    msFreeMapServObj(mapserv);
+    msFreeConfig(config);
+  }
+
+  /* normal case, processing is complete */
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&execendtime, NULL);
+    msDebug("mapserv total execution time: %.3fs\n",
+            (execendtime.tv_sec + execendtime.tv_usec / 1.0e6) -
+                (execstarttime.tv_sec + execstarttime.tv_usec / 1.0e6));
+  }
+  ctx = msIO_getHandler((FILE *)"stdout");
+  buf = (msIOBuffer *)ctx->cbData;
+  *out_buffer = buf->data;
+  *buffer_length = buf->data_offset;
+
+  free(queryString);
+
+  return 0;
+}
diff -pruN 8.0.1-5/src/mapshape.c 8.2.0~beta1-1~exp1/src/mapshape.c
--- 8.0.1-5/src/mapshape.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapshape.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3158 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implements support for shapefile access.
+ * Authors:  Steve Lime and Frank Warmerdam
+ *
+ * Note:
+ * This code is entirely based on the previous work of Frank Warmerdam. It is
+ * essentially shapelib 1.1.5. However, there were enough changes that it was
+ * incorporated into the MapServer source to avoid confusion. Relicensed with
+ * permission of Frank Warmerdam (shapelib author). See the README
+ * for licence details.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#define NEED_IGNORE_RET_VAL
+
+#include <limits.h>
+#include <assert.h>
+#include <stdbool.h>
+#include "mapserver.h"
+#include "mapows.h"
+
+#include <cpl_conv.h>
+#include <ogr_srs_api.h>
+
+/* Only use this macro on 32-bit integers! */
+#define SWAP_FOUR_BYTES(data) CPL_SWAP32(data)
+
+#define ByteCopy(a, b, c) memcpy(b, a, c)
+
+#ifdef __BYTE_ORDER__
+/* GCC/clang predefined macro */
+#define bBigEndian (__BYTE_ORDER__ == __ORDER_BIG_ENDIAN__)
+#elif defined(_MSC_VER)
+/* MSVC doesn't support the C99 trick below, but all Microsoft
+   platforms are little-endian */
+#define bBigEndian false
+#else
+/* generic check */
+#define bBigEndian                                                             \
+  (((union {                                                                   \
+     int in;                                                                   \
+     char out;                                                                 \
+   }){1})                                                                      \
+       .out)
+#endif
+
+/* SHX reading */
+static int msSHXLoadAll(SHPHandle psSHP);
+static int msSHXReadOffset(SHPHandle psSHP, int hEntity);
+static int msSHXReadSize(SHPHandle psSHP, int hEntity);
+
+/************************************************************************/
+/*                              SwapWord()                              */
+/*                                                                      */
+/*      Swap a 2, 4 or 8 byte word.                                     */
+/************************************************************************/
+static void SwapWord(int length, void *wordP) {
+  int i;
+  uchar temp;
+
+  for (i = 0; i < length / 2; i++) {
+    temp = ((uchar *)wordP)[i];
+    ((uchar *)wordP)[i] = ((uchar *)wordP)[length - i - 1];
+    ((uchar *)wordP)[length - i - 1] = temp;
+  }
+}
+
+/************************************************************************/
+/*                             SfRealloc()                              */
+/*                                                                      */
+/*      A realloc cover function that will access a NULL pointer as     */
+/*      a valid input.                                                  */
+/************************************************************************/
+static void *SfRealloc(void *pMem, int nNewSize) {
+  return realloc(pMem, nNewSize);
+}
+
+/************************************************************************/
+/*                          writeHeader()                               */
+/*                                                                      */
+/*      Write out a header for the .shp and .shx files as well as the */
+/*  contents of the index (.shx) file.        */
+/************************************************************************/
+static void writeHeader(SHPHandle psSHP) {
+  uchar abyHeader[100];
+  int i;
+  ms_int32 i32;
+  double dValue;
+  ms_int32 *panSHX;
+
+  /* -------------------------------------------------------------------- */
+  /*      Prepare header block for .shp file.                             */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < 100; i++)
+    abyHeader[i] = 0;
+
+  abyHeader[2] = 0x27; /* magic cookie */
+  abyHeader[3] = 0x0a;
+
+  i32 = psSHP->nFileSize / 2; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
+
+  i32 = 1000; /* version */
+  ByteCopy(&i32, abyHeader + 28, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 28);
+
+  i32 = psSHP->nShapeType; /* shape type */
+  ByteCopy(&i32, abyHeader + 32, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 32);
+
+  dValue = psSHP->adBoundsMin[0]; /* set bounds */
+  ByteCopy(&dValue, abyHeader + 36, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 36);
+
+  dValue = psSHP->adBoundsMin[1];
+  ByteCopy(&dValue, abyHeader + 44, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 44);
+
+  dValue = psSHP->adBoundsMax[0];
+  ByteCopy(&dValue, abyHeader + 52, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 52);
+
+  dValue = psSHP->adBoundsMax[1];
+  ByteCopy(&dValue, abyHeader + 60, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 60);
+
+  dValue = psSHP->adBoundsMin[2]; /* z */
+  ByteCopy(&dValue, abyHeader + 68, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 68);
+
+  dValue = psSHP->adBoundsMax[2];
+  ByteCopy(&dValue, abyHeader + 76, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 76);
+
+  dValue = psSHP->adBoundsMin[3]; /* m */
+  ByteCopy(&dValue, abyHeader + 84, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 84);
+
+  dValue = psSHP->adBoundsMax[3];
+  ByteCopy(&dValue, abyHeader + 92, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 92);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write .shp file header.                                         */
+  /* -------------------------------------------------------------------- */
+  VSIFSeekL(psSHP->fpSHP, 0, 0);
+  VSIFWriteL(abyHeader, 100, 1, psSHP->fpSHP);
+
+  /* -------------------------------------------------------------------- */
+  /*      Prepare, and write .shx file header.                            */
+  /* -------------------------------------------------------------------- */
+  i32 = (psSHP->nRecords * 2 * sizeof(ms_int32) + 100) / 2; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
+
+  VSIFSeekL(psSHP->fpSHX, 0, 0);
+  VSIFWriteL(abyHeader, 100, 1, psSHP->fpSHX);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out the .shx contents.                                    */
+  /* -------------------------------------------------------------------- */
+  panSHX = (ms_int32 *)msSmallMalloc(sizeof(ms_int32) * 2 * psSHP->nRecords);
+
+  for (i = 0; i < psSHP->nRecords; i++) {
+    panSHX[i * 2] = psSHP->panRecOffset[i] / 2;
+    panSHX[i * 2 + 1] = psSHP->panRecSize[i] / 2;
+    if (!bBigEndian) {
+      *(panSHX + i * 2) = SWAP_FOUR_BYTES(*(panSHX + i * 2));
+      *(panSHX + i * 2 + 1) = SWAP_FOUR_BYTES(*(panSHX + i * 2 + 1));
+    }
+  }
+
+  VSIFWriteL(panSHX, sizeof(ms_int32) * 2, psSHP->nRecords, psSHP->fpSHX);
+
+  free(panSHX);
+}
+
+SHPHandle msSHPOpenVirtualFile(VSILFILE *fpSHP, VSILFILE *fpSHX) {
+  /* -------------------------------------------------------------------- */
+  /*  Initialize the info structure.              */
+  /* -------------------------------------------------------------------- */
+  SHPHandle psSHP = (SHPHandle)msSmallMalloc(sizeof(SHPInfo));
+
+  psSHP->bUpdated = MS_FALSE;
+
+  psSHP->pabyRec = NULL;
+  psSHP->panParts = NULL;
+  psSHP->nBufSize = psSHP->nPartMax = 0;
+
+  psSHP->fpSHP = fpSHP;
+  psSHP->fpSHX = fpSHX;
+
+  /* -------------------------------------------------------------------- */
+  /*   Read the file size from the SHP file.            */
+  /* -------------------------------------------------------------------- */
+  uchar *pabyBuf = (uchar *)msSmallMalloc(100);
+  if (1 != VSIFReadL(pabyBuf, 100, 1, psSHP->fpSHP)) {
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
+    free(pabyBuf);
+    return (NULL);
+  }
+
+  if (!bBigEndian)
+    SwapWord(4, pabyBuf + 24);
+  memcpy(&psSHP->nFileSize, pabyBuf + 24, 4);
+  if (psSHP->nFileSize < 0 || psSHP->nFileSize > INT_MAX / 2) {
+    msDebug("Invalid / unsupported nFileSize = %d value. Got it from actual "
+            "file length",
+            psSHP->nFileSize);
+    VSIFSeekL(psSHP->fpSHP, 0, SEEK_END);
+    vsi_l_offset nSize = VSIFTellL(psSHP->fpSHP);
+    if (nSize > (vsi_l_offset)INT_MAX) {
+      msDebug("Actual .shp size is larger than 2 GB. Not supported. "
+              "Invalidating nFileSize");
+      psSHP->nFileSize = 0;
+    } else
+      psSHP->nFileSize = (int)nSize;
+  } else {
+    psSHP->nFileSize *= 2;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Read SHX file Header info                                           */
+  /* -------------------------------------------------------------------- */
+  if (1 != VSIFReadL(pabyBuf, 100, 1, psSHP->fpSHX)) {
+    msSetError(MS_SHPERR, "Corrupted .shx file", "msSHPOpen()");
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
+    free(pabyBuf);
+    return (NULL);
+  }
+
+  if (pabyBuf[0] != 0 || pabyBuf[1] != 0 || pabyBuf[2] != 0x27 ||
+      (pabyBuf[3] != 0x0a && pabyBuf[3] != 0x0d)) {
+    msSetError(MS_SHPERR, "Corrupted .shx file", "msSHPOpen()");
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
+    free(pabyBuf);
+
+    return (NULL);
+  }
+
+  int nSHXHalfFileSize;
+  if (!bBigEndian)
+    SwapWord(4, pabyBuf + 24);
+  memcpy(&nSHXHalfFileSize, pabyBuf + 24, 4);
+  if (nSHXHalfFileSize >= 50)
+    psSHP->nRecords = (nSHXHalfFileSize - 50) / 4; // (nSHXFileSize - 100) / 8
+  else
+    psSHP->nRecords = -1;
+
+  if (psSHP->nRecords < 0 || psSHP->nRecords > 256000000) {
+    msSetError(MS_SHPERR, "Corrupted .shx file : nRecords = %d.", "msSHPOpen()",
+               psSHP->nRecords);
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
+    free(pabyBuf);
+    return (NULL);
+  }
+
+  psSHP->nShapeType = pabyBuf[32];
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 36);
+  double dValue;
+  memcpy(&dValue, pabyBuf + 36, 8);
+  psSHP->adBoundsMin[0] = dValue;
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 44);
+  memcpy(&dValue, pabyBuf + 44, 8);
+  psSHP->adBoundsMin[1] = dValue;
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 52);
+  memcpy(&dValue, pabyBuf + 52, 8);
+  psSHP->adBoundsMax[0] = dValue;
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 60);
+  memcpy(&dValue, pabyBuf + 60, 8);
+  psSHP->adBoundsMax[1] = dValue;
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 68); /* z */
+  memcpy(&dValue, pabyBuf + 68, 8);
+  psSHP->adBoundsMin[2] = dValue;
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 76);
+  memcpy(&dValue, pabyBuf + 76, 8);
+  psSHP->adBoundsMax[2] = dValue;
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 84); /* m */
+  memcpy(&dValue, pabyBuf + 84, 8);
+  psSHP->adBoundsMin[3] = dValue;
+
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 92);
+  memcpy(&dValue, pabyBuf + 92, 8);
+  psSHP->adBoundsMax[3] = dValue;
+  free(pabyBuf);
+
+  /* -------------------------------------------------------------------- */
+  /*  Read the .shx file to get the offsets to each record in       */
+  /*  the .shp file.                  */
+  /* -------------------------------------------------------------------- */
+  psSHP->nMaxRecords = psSHP->nRecords;
+
+  /* Our in-memory cache of offset information */
+  psSHP->panRecOffset = (int *)malloc(sizeof(int) * psSHP->nMaxRecords);
+  /* Our in-memory cache of size information */
+  psSHP->panRecSize = (int *)malloc(sizeof(int) * psSHP->nMaxRecords);
+  /* The completeness information for our in-memory cache */
+  psSHP->panRecLoaded =
+      msAllocBitArray(1 + (psSHP->nMaxRecords / SHX_BUFFER_PAGE));
+  /* Is our in-memory cache completely populated? */
+  psSHP->panRecAllLoaded = 0;
+
+  /* malloc failed? clean up and shut down */
+  if (psSHP->panRecOffset == NULL || psSHP->panRecSize == NULL ||
+      psSHP->panRecLoaded == NULL) {
+    free(psSHP->panRecOffset);
+    free(psSHP->panRecSize);
+    free(psSHP->panRecLoaded);
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
+    msSetError(MS_MEMERR, "Out of memory", "msSHPOpen()");
+    return (NULL);
+  }
+
+  return (psSHP);
+}
+
+/************************************************************************/
+/*                              msSHPOpen()                             */
+/*                                                                      */
+/*      Open the .shp and .shx files based on the basename of the       */
+/*      files or either file name.                                      */
+/************************************************************************/
+SHPHandle msSHPOpen(const char *pszLayer, const char *pszAccess) {
+  char *pszFullname, *pszBasename;
+
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*      Ensure the access string is one of the legal ones.  We          */
+  /*      ensure the result string indicates binary to avoid common       */
+  /*      problems on Windows.                                            */
+  /* -------------------------------------------------------------------- */
+  if (strcmp(pszAccess, "rb+") == 0 || strcmp(pszAccess, "r+b") == 0 ||
+      strcmp(pszAccess, "r+") == 0)
+    pszAccess = "r+b";
+  else
+    pszAccess = "rb";
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension     */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(pszLayer) + 5);
+  strcpy(pszBasename, pszLayer);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*  Open the .shp and .shx files.  Note that files pulled from      */
+  /*  a PC to Unix with upper case filenames won't work!        */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s.shp", pszBasename);
+  VSILFILE *fpSHP = VSIFOpenL(pszFullname, pszAccess);
+  if (fpSHP == NULL) {
+    sprintf(pszFullname, "%s.SHP", pszBasename);
+    fpSHP = VSIFOpenL(pszFullname, pszAccess);
+  }
+  if (fpSHP == NULL) {
+    msFree(pszBasename);
+    msFree(pszFullname);
+    return (NULL);
+  }
+
+  sprintf(pszFullname, "%s.shx", pszBasename);
+  VSILFILE *fpSHX = VSIFOpenL(pszFullname, pszAccess);
+  if (fpSHX == NULL) {
+    sprintf(pszFullname, "%s.SHX", pszBasename);
+    fpSHX = VSIFOpenL(pszFullname, pszAccess);
+  }
+  if (fpSHX == NULL) {
+    VSIFCloseL(fpSHP);
+    msFree(pszBasename);
+    msFree(pszFullname);
+    return (NULL);
+  }
+
+  free(pszFullname);
+  free(pszBasename);
+
+  return msSHPOpenVirtualFile(fpSHP, fpSHX);
+}
+
+/************************************************************************/
+/*                              msSHPClose()                            */
+/*                        */
+/*  Close the .shp and .shx files.          */
+/************************************************************************/
+void msSHPClose(SHPHandle psSHP) {
+  /* -------------------------------------------------------------------- */
+  /*  Update the header if we have modified anything.           */
+  /* -------------------------------------------------------------------- */
+  if (psSHP->bUpdated)
+    writeHeader(psSHP);
+
+  /* -------------------------------------------------------------------- */
+  /*      Free all resources, and close files.                            */
+  /* -------------------------------------------------------------------- */
+  free(psSHP->panRecOffset);
+  free(psSHP->panRecSize);
+  free(psSHP->panRecLoaded);
+
+  free(psSHP->pabyRec);
+  free(psSHP->panParts);
+
+  VSIFCloseL(psSHP->fpSHX);
+  VSIFCloseL(psSHP->fpSHP);
+
+  free(psSHP);
+}
+
+/************************************************************************/
+/*                             msSHPGetInfo()                           */
+/*                                                                      */
+/*      Fetch general information about the shape file.                 */
+/************************************************************************/
+void msSHPGetInfo(SHPHandle psSHP, int *pnEntities, int *pnShapeType) {
+  if (pnEntities)
+    *pnEntities = psSHP->nRecords;
+
+  if (pnShapeType)
+    *pnShapeType = psSHP->nShapeType;
+}
+
+/************************************************************************/
+/*                             msSHPCreate()                            */
+/*                                                                      */
+/*      Create a new shape file and return a handle to the open         */
+/*      shape file with read/write access.                              */
+/************************************************************************/
+SHPHandle msSHPCreate(const char *pszLayer, int nShapeType) {
+  char *pszBasename, *pszFullname;
+  int i;
+  VSILFILE *fpSHP, *fpSHX;
+  uchar abyHeader[100];
+  ms_int32 i32;
+  double dValue;
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension       */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(pszLayer) + 5);
+  strcpy(pszBasename, pszLayer);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*      Open the two files so we can write their headers.               */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s.shp", pszBasename);
+  fpSHP = VSIFOpenL(pszFullname, "wb");
+  if (fpSHP == NULL) {
+    free(pszFullname);
+    free(pszBasename);
+    return (NULL);
+  }
+
+  sprintf(pszFullname, "%s.shx", pszBasename);
+  fpSHX = VSIFOpenL(pszFullname, "wb");
+  if (fpSHX == NULL) {
+    VSIFCloseL(fpSHP);
+    free(pszFullname);
+    free(pszBasename);
+    return (NULL);
+  }
+
+  free(pszFullname);
+  free(pszBasename);
+
+  /* -------------------------------------------------------------------- */
+  /*      Prepare header block for .shp file.                             */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < 100; i++)
+    abyHeader[i] = 0;
+
+  abyHeader[2] = 0x27; /* magic cookie */
+  abyHeader[3] = 0x0a;
+
+  i32 = 50; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
+
+  i32 = 1000; /* version */
+  ByteCopy(&i32, abyHeader + 28, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 28);
+
+  i32 = nShapeType; /* shape type */
+  ByteCopy(&i32, abyHeader + 32, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 32);
+
+  dValue = 0.0; /* set bounds */
+  ByteCopy(&dValue, abyHeader + 36, 8);
+  ByteCopy(&dValue, abyHeader + 44, 8);
+  ByteCopy(&dValue, abyHeader + 52, 8);
+  ByteCopy(&dValue, abyHeader + 60, 8);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write .shp file header.                                         */
+  /* -------------------------------------------------------------------- */
+  VSIFWriteL(abyHeader, 100, 1, fpSHP);
+
+  /* -------------------------------------------------------------------- */
+  /*      Prepare, and write .shx file header.                            */
+  /* -------------------------------------------------------------------- */
+  i32 = 50; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
+
+  VSIFWriteL(abyHeader, 100, 1, fpSHX);
+
+  /* -------------------------------------------------------------------- */
+  /*      Close the files, and then open them as regular existing files.  */
+  /* -------------------------------------------------------------------- */
+  VSIFCloseL(fpSHP);
+  VSIFCloseL(fpSHX);
+
+  return (msSHPOpen(pszLayer, "rb+"));
+}
+
+/************************************************************************/
+/*                           writeBounds()                              */
+/*                                                                      */
+/*      Compute a bounds rectangle for a shape, and set it into the     */
+/*      indicated location in the record.                               */
+/************************************************************************/
+static void writeBounds(uchar *pabyRec, shapeObj *shape, int nVCount) {
+  double dXMin, dXMax, dYMin, dYMax;
+  int i, j;
+
+  if (nVCount == 0) {
+    dXMin = dYMin = dXMax = dYMax = 0.0;
+  } else {
+    dXMin = dXMax = shape->line[0].point[0].x;
+    dYMin = dYMax = shape->line[0].point[0].y;
+
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        dXMin = MS_MIN(dXMin, shape->line[i].point[j].x);
+        dXMax = MS_MAX(dXMax, shape->line[i].point[j].x);
+        dYMin = MS_MIN(dYMin, shape->line[i].point[j].y);
+        dYMax = MS_MAX(dYMax, shape->line[i].point[j].y);
+      }
+    }
+  }
+
+  if (bBigEndian) {
+    SwapWord(8, &dXMin);
+    SwapWord(8, &dYMin);
+    SwapWord(8, &dXMax);
+    SwapWord(8, &dYMax);
+  }
+
+  ByteCopy(&dXMin, pabyRec + 0, 8);
+  ByteCopy(&dYMin, pabyRec + 8, 8);
+  ByteCopy(&dXMax, pabyRec + 16, 8);
+  ByteCopy(&dYMax, pabyRec + 24, 8);
+}
+
+int msSHPWritePoint(SHPHandle psSHP, pointObj *point) {
+  int nRecordOffset, nRecordSize = 0;
+  uchar *pabyRec;
+  ms_int32 i32, nPoints, nParts;
+
+  if (psSHP->nShapeType != SHP_POINT)
+    return (-1);
+  if (psSHP->nFileSize == 0)
+    return -1;
+
+  psSHP->bUpdated = MS_TRUE;
+
+  /* Fill the SHX buffer if it is not already full. */
+  if (!psSHP->panRecAllLoaded)
+    msSHXLoadAll(psSHP);
+
+  /* -------------------------------------------------------------------- */
+  /*      Add the new entity to the in memory index.                      */
+  /* -------------------------------------------------------------------- */
+  psSHP->nRecords++;
+  if (psSHP->nRecords > psSHP->nMaxRecords) {
+    psSHP->nMaxRecords = (int)(psSHP->nMaxRecords * 1.3 + 100);
+
+    psSHP->panRecOffset =
+        (int *)SfRealloc(psSHP->panRecOffset, sizeof(int) * psSHP->nMaxRecords);
+    psSHP->panRecSize =
+        (int *)SfRealloc(psSHP->panRecSize, sizeof(int) * psSHP->nMaxRecords);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Compute a few things.                                           */
+  /* -------------------------------------------------------------------- */
+  nPoints = 1;
+  nParts = 1;
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize record.                                              */
+  /* -------------------------------------------------------------------- */
+  psSHP->panRecOffset[psSHP->nRecords - 1] = nRecordOffset = psSHP->nFileSize;
+
+  pabyRec =
+      (uchar *)msSmallMalloc(nPoints * 2 * sizeof(double) + nParts * 4 + 128);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write vertices for a point.                                     */
+  /* -------------------------------------------------------------------- */
+  ByteCopy(&(point->x), pabyRec + 12, 8);
+  ByteCopy(&(point->y), pabyRec + 20, 8);
+
+  if (bBigEndian) {
+    SwapWord(8, pabyRec + 12);
+    SwapWord(8, pabyRec + 20);
+  }
+
+  nRecordSize = 20;
+
+  /* -------------------------------------------------------------------- */
+  /*      Set the shape type, record number, and record size.             */
+  /* -------------------------------------------------------------------- */
+  i32 = psSHP->nRecords - 1 + 1; /* record # */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec, 4);
+
+  i32 = nRecordSize / 2; /* record size */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 4, 4);
+
+  i32 = psSHP->nShapeType; /* shape type */
+  if (bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 8, 4);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out record.                                               */
+  /* -------------------------------------------------------------------- */
+  if (VSIFSeekL(psSHP->fpSHP, nRecordOffset, 0) == 0) {
+    VSIFWriteL(pabyRec, nRecordSize + 8, 1, psSHP->fpSHP);
+
+    psSHP->panRecSize[psSHP->nRecords - 1] = nRecordSize;
+    psSHP->nFileSize += nRecordSize + 8;
+
+    /* -------------------------------------------------------------------- */
+    /*  Expand file wide bounds based on this shape.        */
+    /* -------------------------------------------------------------------- */
+    if (psSHP->nRecords == 1) {
+      psSHP->adBoundsMin[0] = psSHP->adBoundsMax[0] = point->x;
+      psSHP->adBoundsMin[1] = psSHP->adBoundsMax[1] = point->y;
+    } else {
+      psSHP->adBoundsMin[0] = MS_MIN(psSHP->adBoundsMin[0], point->x);
+      psSHP->adBoundsMin[1] = MS_MIN(psSHP->adBoundsMin[1], point->y);
+      psSHP->adBoundsMax[0] = MS_MAX(psSHP->adBoundsMax[0], point->x);
+      psSHP->adBoundsMax[1] = MS_MAX(psSHP->adBoundsMax[1], point->y);
+    }
+  } else {
+    psSHP->nRecords--;
+  }
+  free(pabyRec);
+  return (psSHP->nRecords - 1);
+}
+
+int msSHPWriteShape(SHPHandle psSHP, shapeObj *shape) {
+  int nRecordOffset, i, j, k, nRecordSize = 0;
+  uchar *pabyRec;
+  int nShapeType;
+
+  ms_int32 i32, nPoints, nParts;
+
+  if (psSHP->nFileSize == 0)
+    return -1;
+
+  psSHP->bUpdated = MS_TRUE;
+
+  /* Fill the SHX buffer if it is not already full. */
+  if (!psSHP->panRecAllLoaded)
+    msSHXLoadAll(psSHP);
+
+  /* -------------------------------------------------------------------- */
+  /*      Add the new entity to the in memory index.                      */
+  /* -------------------------------------------------------------------- */
+  psSHP->nRecords++;
+  if (psSHP->nRecords > psSHP->nMaxRecords) {
+    psSHP->nMaxRecords = (int)(psSHP->nMaxRecords * 1.3 + 100);
+
+    psSHP->panRecOffset =
+        (int *)SfRealloc(psSHP->panRecOffset, sizeof(int) * psSHP->nMaxRecords);
+    psSHP->panRecSize =
+        (int *)SfRealloc(psSHP->panRecSize, sizeof(int) * psSHP->nMaxRecords);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Compute a few things.                                           */
+  /* -------------------------------------------------------------------- */
+  nPoints = 0;
+  for (i = 0; i < shape->numlines; i++)
+    nPoints += shape->line[i].numpoints;
+
+  nParts = shape->numlines;
+
+  /* -------------------------------------------------------------------- */
+  /*      Initialize record.                                              */
+  /* -------------------------------------------------------------------- */
+  psSHP->panRecOffset[psSHP->nRecords - 1] = nRecordOffset = psSHP->nFileSize;
+
+  pabyRec =
+      (uchar *)msSmallMalloc(nPoints * 4 * sizeof(double) + nParts * 8 + 128);
+  nShapeType = psSHP->nShapeType;
+
+  if (shape->type == MS_SHAPE_NULL) {
+    nShapeType = 0;
+    nRecordSize = 12;
+  }
+  /* -------------------------------------------------------------------- */
+  /*  Write vertices for a Polygon or Arc.            */
+  /* -------------------------------------------------------------------- */
+  else if (psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
+           psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM ||
+           psSHP->nShapeType == SHP_ARCZ || psSHP->nShapeType == SHP_POLYGONZ) {
+    ms_int32 t_nParts, t_nPoints, partSize;
+
+    t_nParts = nParts;
+    t_nPoints = nPoints;
+
+    writeBounds(pabyRec + 12, shape, t_nPoints);
+
+    if (bBigEndian) {
+      nPoints = SWAP_FOUR_BYTES(nPoints);
+      nParts = SWAP_FOUR_BYTES(nParts);
+    }
+
+    ByteCopy(&nPoints, pabyRec + 40 + 8, 4);
+    ByteCopy(&nParts, pabyRec + 36 + 8, 4);
+
+    partSize = 0; /* first part always starts at 0 */
+    ByteCopy(&partSize, pabyRec + 44 + 8 + 4 * 0, 4);
+    if (bBigEndian)
+      SwapWord(4, pabyRec + 44 + 8 + 4 * 0);
+
+    for (i = 1; i < t_nParts; i++) {
+      partSize += shape->line[i - 1].numpoints;
+      ByteCopy(&partSize, pabyRec + 44 + 8 + 4 * i, 4);
+      if (bBigEndian)
+        SwapWord(4, pabyRec + 44 + 8 + 4 * i);
+    }
+
+    k = 0; /* overall point counter */
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        ByteCopy(&(shape->line[i].point[j].x),
+                 pabyRec + 44 + 4 * t_nParts + 8 + k * 16, 8);
+        ByteCopy(&(shape->line[i].point[j].y),
+                 pabyRec + 44 + 4 * t_nParts + 8 + k * 16 + 8, 8);
+
+        if (bBigEndian) {
+          SwapWord(8, pabyRec + 44 + 4 * t_nParts + 8 + k * 16);
+          SwapWord(8, pabyRec + 44 + 4 * t_nParts + 8 + k * 16 + 8);
+        }
+
+        k++;
+      }
+    }
+
+    nRecordSize = 44 + 4 * t_nParts + 16 * t_nPoints;
+
+    /* -------------------------------------------------------------------- */
+    /*      measured shape : polygon and arc.                               */
+    /* -------------------------------------------------------------------- */
+    if (psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
+      const double dfMMin = shape->line[0].point[0].m;
+      const double dfMMax =
+          shape->line[shape->numlines - 1]
+              .point[shape->line[shape->numlines - 1].numpoints - 1]
+              .m;
+
+      nRecordSize = 44 + 4 * t_nParts + 8 + (t_nPoints * 16);
+
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          ByteCopy(&(shape->line[i].point[j].m), pabyRec + nRecordSize, 8);
+          if (bBigEndian)
+            SwapWord(8, pabyRec + nRecordSize);
+          nRecordSize += 8;
+        }
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Polygon. Arc with Z                                             */
+    /* -------------------------------------------------------------------- */
+    if (psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ ||
+        psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
+      const double dfMMin = shape->line[0].point[0].z;
+      const double dfMMax =
+          shape->line[shape->numlines - 1]
+              .point[shape->line[shape->numlines - 1].numpoints - 1]
+              .z;
+
+      nRecordSize = 44 + 4 * t_nParts + 8 + (t_nPoints * 16);
+
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          ByteCopy(&(shape->line[i].point[j].z), pabyRec + nRecordSize, 8);
+          if (bBigEndian)
+            SwapWord(8, pabyRec + nRecordSize);
+          nRecordSize += 8;
+        }
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Write vertices for a MultiPoint.                                    */
+  /* -------------------------------------------------------------------- */
+  else if (psSHP->nShapeType == SHP_MULTIPOINT ||
+           psSHP->nShapeType == SHP_MULTIPOINTM ||
+           psSHP->nShapeType == SHP_MULTIPOINTZ) {
+    ms_int32 t_nPoints;
+
+    t_nPoints = nPoints;
+
+    writeBounds(pabyRec + 12, shape, nPoints);
+
+    if (bBigEndian)
+      nPoints = SWAP_FOUR_BYTES(nPoints);
+    ByteCopy(&nPoints, pabyRec + 44, 4);
+
+    for (i = 0; i < shape->line[0].numpoints; i++) {
+      ByteCopy(&(shape->line[0].point[i].x), pabyRec + 48 + i * 16, 8);
+      ByteCopy(&(shape->line[0].point[i].y), pabyRec + 48 + i * 16 + 8, 8);
+
+      if (bBigEndian) {
+        SwapWord(8, pabyRec + 48 + i * 16);
+        SwapWord(8, pabyRec + 48 + i * 16 + 8);
+      }
+    }
+
+    nRecordSize = 40 + 16 * t_nPoints;
+
+    if (psSHP->nShapeType == SHP_MULTIPOINTM) {
+      const double dfMMin = shape->line[0].point[0].m;
+      const double dfMMax =
+          shape->line[0].point[shape->line[0].numpoints - 1].m;
+
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      for (i = 0; i < shape->line[0].numpoints; i++) {
+        ByteCopy(&(shape->line[0].point[i].m), pabyRec + nRecordSize, 8);
+        if (bBigEndian)
+          SwapWord(8, pabyRec + nRecordSize);
+        nRecordSize += 8;
+      }
+    }
+
+    if (psSHP->nShapeType == SHP_MULTIPOINTZ) {
+      const double dfMMin = shape->line[0].point[0].z;
+      const double dfMMax =
+          shape->line[0].point[shape->line[0].numpoints - 1].z;
+
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+
+      for (i = 0; i < shape->line[0].numpoints; i++) {
+        ByteCopy(&(shape->line[0].point[i].z), pabyRec + nRecordSize, 8);
+        if (bBigEndian)
+          SwapWord(8, pabyRec + nRecordSize);
+        nRecordSize += 8;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Write vertices for a point.                                     */
+  /* -------------------------------------------------------------------- */
+  else if (psSHP->nShapeType == SHP_POINT || psSHP->nShapeType == SHP_POINTM ||
+           psSHP->nShapeType == SHP_POINTZ) {
+    ByteCopy(&(shape->line[0].point[0].x), pabyRec + 12, 8);
+    ByteCopy(&(shape->line[0].point[0].y), pabyRec + 20, 8);
+
+    if (bBigEndian) {
+      SwapWord(8, pabyRec + 12);
+      SwapWord(8, pabyRec + 20);
+    }
+
+    nRecordSize = 20;
+
+    if (psSHP->nShapeType == SHP_POINTM) {
+      ByteCopy(&(shape->line[0].point[0].m), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+    }
+
+    if (psSHP->nShapeType == SHP_POINTZ) {
+      ByteCopy(&(shape->line[0].point[0].z), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
+      nRecordSize += 8;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Set the shape type, record number, and record size.             */
+  /* -------------------------------------------------------------------- */
+  i32 = psSHP->nRecords - 1 + 1; /* record # */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec, 4);
+
+  i32 = nRecordSize / 2; /* record size */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 4, 4);
+
+  i32 = nShapeType; /* shape type */
+  if (bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 8, 4);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out record.                                               */
+  /* -------------------------------------------------------------------- */
+  if (VSIFSeekL(psSHP->fpSHP, nRecordOffset, 0) == 0) {
+    VSIFWriteL(pabyRec, nRecordSize + 8, 1, psSHP->fpSHP);
+
+    psSHP->panRecSize[psSHP->nRecords - 1] = nRecordSize;
+    psSHP->nFileSize += nRecordSize + 8;
+
+    /* -------------------------------------------------------------------- */
+    /*  Expand file wide bounds based on this shape.        */
+    /* -------------------------------------------------------------------- */
+    if (psSHP->nRecords == 1) {
+      psSHP->adBoundsMin[0] = psSHP->adBoundsMax[0] = shape->line[0].point[0].x;
+      psSHP->adBoundsMin[1] = psSHP->adBoundsMax[1] = shape->line[0].point[0].y;
+      psSHP->adBoundsMin[2] = psSHP->adBoundsMax[2] = shape->line[0].point[0].z;
+      psSHP->adBoundsMin[3] = psSHP->adBoundsMax[3] = shape->line[0].point[0].m;
+    }
+
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        psSHP->adBoundsMin[0] =
+            MS_MIN(psSHP->adBoundsMin[0], shape->line[i].point[j].x);
+        psSHP->adBoundsMin[1] =
+            MS_MIN(psSHP->adBoundsMin[1], shape->line[i].point[j].y);
+        psSHP->adBoundsMin[2] =
+            MS_MIN(psSHP->adBoundsMin[2], shape->line[i].point[j].z);
+        psSHP->adBoundsMin[3] =
+            MS_MIN(psSHP->adBoundsMin[3], shape->line[i].point[j].m);
+        psSHP->adBoundsMax[0] =
+            MS_MAX(psSHP->adBoundsMax[0], shape->line[i].point[j].x);
+        psSHP->adBoundsMax[1] =
+            MS_MAX(psSHP->adBoundsMax[1], shape->line[i].point[j].y);
+        psSHP->adBoundsMax[2] =
+            MS_MAX(psSHP->adBoundsMax[2], shape->line[i].point[j].z);
+        psSHP->adBoundsMax[3] =
+            MS_MAX(psSHP->adBoundsMax[3], shape->line[i].point[j].m);
+      }
+    }
+
+  } else {
+    psSHP->nRecords--;
+    /* there was an error writing the record */
+  }
+  free(pabyRec);
+  return (psSHP->nRecords - 1);
+}
+
+/*
+ ** msSHPReadAllocateBuffer() - Ensure our record buffer is large enough.
+ */
+static uchar *msSHPReadAllocateBuffer(SHPHandle psSHP, int hEntity,
+                                      const char *pszCallingFunction) {
+
+  int nEntitySize = msSHXReadSize(psSHP, hEntity);
+  if (nEntitySize <= 0 || nEntitySize > INT_MAX - 8) {
+    msSetError(MS_MEMERR,
+               "Out of memory. Cannot allocate %d bytes. Probably broken "
+               "shapefile at feature %d",
+               pszCallingFunction, nEntitySize, hEntity);
+    return NULL;
+  }
+  nEntitySize += 8;
+  /* -------------------------------------------------------------------- */
+  /*      Ensure our record buffer is large enough.                       */
+  /* -------------------------------------------------------------------- */
+
+#ifdef FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION
+  /* when running with libFuzzer, allocate a new buffer for every
+     call, to allow AddressSanitizer to detect memory errors */
+  free(psSHP->pabyRec);
+  psSHP->pabyRec = NULL;
+  psSHP->nBufSize = 0;
+#endif
+
+  if (nEntitySize > psSHP->nBufSize) {
+    uchar *pabyRec = (uchar *)SfRealloc(psSHP->pabyRec, nEntitySize);
+    if (pabyRec == NULL) {
+      msSetError(MS_MEMERR,
+                 "Out of memory. Cannot allocate %d bytes. Probably broken "
+                 "shapefile at feature %d",
+                 pszCallingFunction, nEntitySize, hEntity);
+      return NULL;
+    }
+    psSHP->pabyRec = pabyRec;
+    psSHP->nBufSize = nEntitySize;
+  }
+  return psSHP->pabyRec;
+}
+
+/*
+** msSHPReadPoint() - Reads a single point from a POINT shape file.
+*/
+int msSHPReadPoint(SHPHandle psSHP, int hEntity, pointObj *point) {
+  int nEntitySize;
+
+  /* -------------------------------------------------------------------- */
+  /*      Only valid for point shapefiles                                 */
+  /* -------------------------------------------------------------------- */
+  if (psSHP->nShapeType != SHP_POINT) {
+    msSetError(MS_SHPERR, "msSHPReadPoint only operates on point shapefiles.",
+               "msSHPReadPoint()");
+    return (MS_FAILURE);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Validate the record/entity number.                              */
+  /* -------------------------------------------------------------------- */
+  if (hEntity < 0 || hEntity >= psSHP->nRecords) {
+    msSetError(MS_SHPERR, "Record index out of bounds.", "msSHPReadPoint()");
+    return (MS_FAILURE);
+  }
+
+  nEntitySize = msSHXReadSize(psSHP, hEntity) + 8;
+
+  if (nEntitySize == 12) {
+    msSetError(MS_SHPERR, "NULL feature encountered.", "msSHPReadPoint()");
+    return (MS_FAILURE);
+  } else if (nEntitySize < 28) {
+    msSetError(MS_SHPERR,
+               "Corrupted feature encountered.  hEntity=%d, nEntitySize=%d",
+               "msSHPReadPoint()", hEntity, nEntitySize);
+    return (MS_FAILURE);
+  }
+
+  uchar *pabyRec = msSHPReadAllocateBuffer(psSHP, hEntity, "msSHPReadPoint()");
+  if (pabyRec == NULL) {
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Read the record.                                                */
+  /* -------------------------------------------------------------------- */
+  const int offset = msSHXReadOffset(psSHP, hEntity);
+  if (offset <= 0 || 0 != VSIFSeekL(psSHP->fpSHP, offset, 0)) {
+    msSetError(MS_IOERR, "failed to seek offset", "msSHPReadPoint()");
+    return (MS_FAILURE);
+  }
+  if (1 != VSIFReadL(pabyRec, nEntitySize, 1, psSHP->fpSHP)) {
+    msSetError(MS_IOERR, "failed to fread record", "msSHPReadPoint()");
+    return (MS_FAILURE);
+  }
+
+  memcpy(&(point->x), pabyRec + 12, 8);
+  memcpy(&(point->y), pabyRec + 20, 8);
+
+  if (bBigEndian) {
+    SwapWord(8, &(point->x));
+    SwapWord(8, &(point->y));
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*
+** msSHXLoadPage()
+**
+** The SHX tells us what the byte offsets of the shapes in the SHP file are.
+** We read the SHX file in ~8K pages and store those pages in memory for
+** successive accesses during the reading cycle (first bounds are read,
+** then entire shapes). Each time we read a page, we mark it as read.
+*/
+static bool msSHXLoadPage(SHPHandle psSHP, int shxBufferPage) {
+  int i;
+
+  /* Each SHX record is 8 bytes long (two ints), hence our buffer size. */
+  char buffer[SHX_BUFFER_PAGE * 8];
+
+  /*  Validate the page number. */
+  if (shxBufferPage < 0)
+    return (MS_FAILURE);
+
+  const int nShapesToCache =
+      shxBufferPage < psSHP->nRecords / SHX_BUFFER_PAGE
+          ? SHX_BUFFER_PAGE
+          : psSHP->nRecords - shxBufferPage * SHX_BUFFER_PAGE;
+
+  if (0 !=
+      VSIFSeekL(psSHP->fpSHX, 100 + shxBufferPage * SHX_BUFFER_PAGE * 8, 0)) {
+    memset(psSHP->panRecOffset + shxBufferPage * SHX_BUFFER_PAGE, 0,
+           nShapesToCache * sizeof(psSHP->panRecOffset[0]));
+    memset(psSHP->panRecSize + shxBufferPage * SHX_BUFFER_PAGE, 0,
+           nShapesToCache * sizeof(psSHP->panRecSize[0]));
+    msSetBit(psSHP->panRecLoaded, shxBufferPage, 1);
+    msSetError(MS_IOERR, "failed to seek offset", "msSHXLoadPage()");
+    return false;
+  }
+
+  if ((size_t)nShapesToCache !=
+      VSIFReadL(buffer, 8, nShapesToCache, psSHP->fpSHX)) {
+    memset(psSHP->panRecOffset + shxBufferPage * SHX_BUFFER_PAGE, 0,
+           nShapesToCache * sizeof(psSHP->panRecOffset[0]));
+    memset(psSHP->panRecSize + shxBufferPage * SHX_BUFFER_PAGE, 0,
+           nShapesToCache * sizeof(psSHP->panRecSize[0]));
+    msSetBit(psSHP->panRecLoaded, shxBufferPage, 1);
+    msSetError(MS_IOERR, "failed to fread SHX record", "msSHXLoadPage()");
+    return false;
+  }
+
+  /* Copy the buffer contents out into the working arrays. */
+  for (i = 0; i < nShapesToCache; i++) {
+    int tmpOffset, tmpSize;
+
+    memcpy(&tmpOffset, (buffer + (8 * i)), 4);
+    memcpy(&tmpSize, (buffer + (8 * i) + 4), 4);
+
+    /* SHX uses big endian numbers for the offsets, so we have to flip them */
+    /* if we are a little endian machine. */
+    if (!bBigEndian) {
+      tmpOffset = SWAP_FOUR_BYTES(tmpOffset);
+      tmpSize = SWAP_FOUR_BYTES(tmpSize);
+    }
+
+    /* SHX stores the offsets in 2 byte units, so we double them to get */
+    /* an offset in bytes. */
+    if (tmpOffset > 0 && tmpOffset < INT_MAX / 2)
+      tmpOffset = tmpOffset * 2;
+    else
+      tmpOffset = 0;
+
+    if (tmpSize > 0 && tmpSize < INT_MAX / 2)
+      tmpSize = tmpSize * 2;
+    else
+      tmpSize = 0;
+
+    /* Write the answer into the working arrays on the SHPHandle */
+    psSHP->panRecOffset[shxBufferPage * SHX_BUFFER_PAGE + i] = tmpOffset;
+    psSHP->panRecSize[shxBufferPage * SHX_BUFFER_PAGE + i] = tmpSize;
+  }
+
+  msSetBit(psSHP->panRecLoaded, shxBufferPage, 1);
+
+  return (MS_SUCCESS);
+}
+
+static int msSHXLoadAll(SHPHandle psSHP) {
+
+  int i;
+  uchar *pabyBuf;
+
+  pabyBuf = (uchar *)malloc(8 * psSHP->nRecords);
+  if (pabyBuf == NULL) {
+    msSetError(MS_IOERR, "failed to allocate memory for SHX buffer",
+               "msSHXLoadAll()");
+    return MS_FAILURE;
+  }
+  if ((size_t)psSHP->nRecords !=
+      VSIFReadL(pabyBuf, 8, psSHP->nRecords, psSHP->fpSHX)) {
+    msSetError(MS_IOERR, "failed to read shx records", "msSHXLoadAll()");
+    free(pabyBuf);
+    return MS_FAILURE;
+  }
+  for (i = 0; i < psSHP->nRecords; i++) {
+    ms_int32 nOffset, nLength;
+
+    memcpy(&nOffset, pabyBuf + i * 8, 4);
+    memcpy(&nLength, pabyBuf + i * 8 + 4, 4);
+
+    if (!bBigEndian) {
+      nOffset = SWAP_FOUR_BYTES(nOffset);
+      nLength = SWAP_FOUR_BYTES(nLength);
+    }
+
+    /* SHX stores the offsets in 2 byte units, so we double them to get */
+    /* an offset in bytes. */
+    if (nOffset > 0 && nOffset < INT_MAX / 2)
+      nOffset = nOffset * 2;
+    else
+      nOffset = 0;
+
+    if (nLength > 0 && nLength < INT_MAX / 2)
+      nLength = nLength * 2;
+    else
+      nLength = 0;
+
+    psSHP->panRecOffset[i] = nOffset;
+    psSHP->panRecSize[i] = nLength;
+  }
+  free(pabyBuf);
+  psSHP->panRecAllLoaded = 1;
+
+  return (MS_SUCCESS);
+}
+
+static int msSHXReadOffset(SHPHandle psSHP, int hEntity) {
+
+  int shxBufferPage = hEntity / SHX_BUFFER_PAGE;
+
+  /*  Validate the record/entity number. */
+  if (hEntity < 0 || hEntity >= psSHP->nRecords)
+    return 0;
+
+  if (!(psSHP->panRecAllLoaded ||
+        msGetBit(psSHP->panRecLoaded, shxBufferPage))) {
+    msSHXLoadPage(psSHP, shxBufferPage);
+  }
+
+  return psSHP->panRecOffset[hEntity];
+}
+
+static int msSHXReadSize(SHPHandle psSHP, int hEntity) {
+
+  int shxBufferPage = hEntity / SHX_BUFFER_PAGE;
+
+  /*  Validate the record/entity number. */
+  if (hEntity < 0 || hEntity >= psSHP->nRecords)
+    return 0;
+
+  if (!(psSHP->panRecAllLoaded ||
+        msGetBit(psSHP->panRecLoaded, shxBufferPage))) {
+    msSHXLoadPage(psSHP, shxBufferPage);
+  }
+
+  return psSHP->panRecSize[hEntity];
+}
+
+static void ReadRect(rectObj *r, const uchar *src) {
+  memcpy(&r->minx, src, 8);
+  memcpy(&r->miny, src + 8, 8);
+  memcpy(&r->maxx, src + 16, 8);
+  memcpy(&r->maxy, src + 24, 8);
+
+  if (bBigEndian) {
+    SwapWord(8, &r->minx);
+    SwapWord(8, &r->miny);
+    SwapWord(8, &r->maxx);
+    SwapWord(8, &r->maxy);
+  }
+}
+
+/*
+** msSHPReadShape() - Reads the vertices for one shape from a shape file.
+*/
+void msSHPReadShape(SHPHandle psSHP, int hEntity, shapeObj *shape) {
+  int i, j, k;
+  int nEntitySize, nRequiredSize;
+
+  msInitShape(shape); /* initialize the shape */
+
+  /* -------------------------------------------------------------------- */
+  /*      Validate the record/entity number.                              */
+  /* -------------------------------------------------------------------- */
+  if (hEntity < 0 || hEntity >= psSHP->nRecords)
+    return;
+
+  nEntitySize = msSHXReadSize(psSHP, hEntity);
+  if (nEntitySize < 4 || nEntitySize > INT_MAX - 8) {
+    shape->type = MS_SHAPE_NULL;
+    msSetError(MS_SHPERR,
+               "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d",
+               "msSHPReadShape()", hEntity, nEntitySize);
+    return;
+  }
+
+  nEntitySize += 8;
+  if (nEntitySize == 12) {
+    shape->type = MS_SHAPE_NULL;
+    return;
+  }
+
+  uchar *pabyRec = msSHPReadAllocateBuffer(psSHP, hEntity, "msSHPReadShape()");
+  if (pabyRec == NULL) {
+    shape->type = MS_SHAPE_NULL;
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Read the record.                                                */
+  /* -------------------------------------------------------------------- */
+  const int offset = msSHXReadOffset(psSHP, hEntity);
+  if (offset <= 0 || 0 != VSIFSeekL(psSHP->fpSHP, offset, 0)) {
+    msSetError(MS_IOERR, "failed to seek offset", "msSHPReadShape()");
+    shape->type = MS_SHAPE_NULL;
+    return;
+  }
+  if (1 != VSIFReadL(pabyRec, nEntitySize, 1, psSHP->fpSHP)) {
+    msSetError(MS_IOERR, "failed to fread record", "msSHPReadPoint()");
+    shape->type = MS_SHAPE_NULL;
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Extract vertices for a Polygon or Arc.            */
+  /* -------------------------------------------------------------------- */
+  if (psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
+      psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM ||
+      psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ) {
+    ms_int32 nPoints, nParts;
+
+    if (nEntitySize < 40 + 8 + 4) {
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d",
+                 "msSHPReadShape()", hEntity, nEntitySize);
+      return;
+    }
+
+    /* copy the bounding box */
+    ReadRect(&shape->bounds, pabyRec + 8 + 4);
+
+    memcpy(&nPoints, pabyRec + 40 + 8, 4);
+    memcpy(&nParts, pabyRec + 36 + 8, 4);
+
+    if (bBigEndian) {
+      nPoints = SWAP_FOUR_BYTES(nPoints);
+      nParts = SWAP_FOUR_BYTES(nParts);
+    }
+
+    if (nPoints < 0 || nParts < 0 || nPoints > 50 * 1000 * 1000 ||
+        nParts > 10 * 1000 * 1000) {
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  hEntity = %d, nPoints =%d, "
+                 "nParts = %d",
+                 "msSHPReadShape()", hEntity, nPoints, nParts);
+      return;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Copy out the part array from the record.                        */
+    /* -------------------------------------------------------------------- */
+
+#ifdef FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION
+    /* when running with libFuzzer, allocate a new buffer for every
+       call, to allow AddressSanitizer to detect memory errors */
+    free(psSHP->panParts);
+    psSHP->panParts = NULL;
+    psSHP->nPartMax = 0;
+#endif
+
+    if (psSHP->nPartMax < nParts) {
+      psSHP->panParts = (int *)SfRealloc(psSHP->panParts, nParts * sizeof(int));
+      if (psSHP->panParts == NULL) {
+        /* Reallocate previous successfull size for following features */
+        psSHP->panParts = (int *)msSmallMalloc(psSHP->nPartMax * sizeof(int));
+
+        shape->type = MS_SHAPE_NULL;
+        msSetError(MS_MEMERR,
+                   "Out of memory. Cannot allocate %d bytes. Probably broken "
+                   "shapefile at feature %d",
+                   "msSHPReadShape()", (int)(nParts * sizeof(int)), hEntity);
+        return;
+      }
+      psSHP->nPartMax = nParts;
+    }
+    if (psSHP->panParts == NULL) {
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
+      return;
+    }
+
+    /* With the previous checks on nPoints and nParts, */
+    /* we should not overflow here and after */
+    /* since 50 M * (16 + 8 + 8) = 1 600 MB */
+    if (44 + 8 + 4 * nParts + 16 * nPoints > nEntitySize) {
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_SHPERR,
+                 "Corrupted .shp file : shape %d, nPoints=%d, nParts=%d.",
+                 "msSHPReadShape()", hEntity, nPoints, nParts);
+      return;
+    }
+
+    memcpy(psSHP->panParts, pabyRec + 44 + 8, 4 * nParts);
+    if (bBigEndian) {
+      for (i = 0; i < nParts; i++) {
+        *(psSHP->panParts + i) = SWAP_FOUR_BYTES(*(psSHP->panParts + i));
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Fill the shape structure.                                       */
+    /* -------------------------------------------------------------------- */
+    shape->line = (lineObj *)malloc(sizeof(lineObj) * nParts);
+    MS_CHECK_ALLOC_NO_RET(shape->line, sizeof(lineObj) * nParts);
+
+    shape->numlines = nParts;
+
+    k = 0; /* overall point counter */
+    for (i = 0; i < nParts; i++) {
+      const ms_int32 end = i == nParts - 1 ? nPoints : psSHP->panParts[i + 1];
+      if (psSHP->panParts[i] < 0 || end < 0 || end > nPoints ||
+          psSHP->panParts[i] >= end) {
+        msSetError(MS_SHPERR,
+                   "Corrupted .shp file : shape %d, shape->line[%d].start=%d, "
+                   "shape->line[%d].end=%d",
+                   "msSHPReadShape()", hEntity, i, psSHP->panParts[i], i, end);
+        while (--i >= 0)
+          free(shape->line[i].point);
+        free(shape->line);
+        shape->line = NULL;
+        shape->numlines = 0;
+        shape->type = MS_SHAPE_NULL;
+        return;
+      }
+
+      shape->line[i].numpoints = end - psSHP->panParts[i];
+      if ((shape->line[i].point = (pointObj *)malloc(
+               sizeof(pointObj) * shape->line[i].numpoints)) == NULL) {
+        while (--i >= 0)
+          free(shape->line[i].point);
+        free(shape->line);
+        shape->line = NULL;
+        shape->numlines = 0;
+        shape->type = MS_SHAPE_NULL;
+        msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
+        return;
+      }
+
+      /* nOffset = 44 + 8 + 4*nParts; */
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        memcpy(&(shape->line[i].point[j].x),
+               pabyRec + 44 + 4 * nParts + 8 + k * 16, 8);
+        memcpy(&(shape->line[i].point[j].y),
+               pabyRec + 44 + 4 * nParts + 8 + k * 16 + 8, 8);
+
+        if (bBigEndian) {
+          SwapWord(8, &(shape->line[i].point[j].x));
+          SwapWord(8, &(shape->line[i].point[j].y));
+        }
+
+        /* --------------------------------------------------------------------
+         */
+        /*      Polygon, Arc with Z values. */
+        /* --------------------------------------------------------------------
+         */
+        shape->line[i].point[j].z = 0.0; /* initialize */
+        if (psSHP->nShapeType == SHP_POLYGONZ ||
+            psSHP->nShapeType == SHP_ARCZ) {
+          const int nOffset = 44 + 8 + (4 * nParts) + (16 * nPoints);
+          if (nEntitySize >= nOffset + 16 + 8 * nPoints) {
+            memcpy(&(shape->line[i].point[j].z), pabyRec + nOffset + 16 + k * 8,
+                   8);
+            if (bBigEndian)
+              SwapWord(8, &(shape->line[i].point[j].z));
+          }
+        }
+
+        /* --------------------------------------------------------------------
+         */
+        /*      Measured arc and polygon support. */
+        /* --------------------------------------------------------------------
+         */
+        shape->line[i].point[j].m = 0; /* initialize */
+        if (psSHP->nShapeType == SHP_POLYGONM ||
+            psSHP->nShapeType == SHP_ARCM) {
+          const int nOffset = 44 + 8 + (4 * nParts) + (16 * nPoints);
+          if (nEntitySize >= nOffset + 16 + 8 * nPoints) {
+            memcpy(&(shape->line[i].point[j].m), pabyRec + nOffset + 16 + k * 8,
+                   8);
+            if (bBigEndian)
+              SwapWord(8, &(shape->line[i].point[j].m));
+          }
+        }
+        k++;
+      }
+    }
+
+    if (psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_POLYGONZ ||
+        psSHP->nShapeType == SHP_POLYGONM)
+      shape->type = MS_SHAPE_POLYGON;
+    else
+      shape->type = MS_SHAPE_LINE;
+
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Extract a MultiPoint.                                               */
+  /* -------------------------------------------------------------------- */
+  else if (psSHP->nShapeType == SHP_MULTIPOINT ||
+           psSHP->nShapeType == SHP_MULTIPOINTM ||
+           psSHP->nShapeType == SHP_MULTIPOINTZ) {
+    ms_int32 nPoints;
+
+    if (nEntitySize < 44 + 4) {
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  recSize of feature %d=%d",
+                 "msSHPReadShape()", hEntity, msSHXReadSize(psSHP, hEntity));
+      return;
+    }
+
+    /* copy the bounding box */
+    ReadRect(&shape->bounds, pabyRec + 8 + 4);
+
+    memcpy(&nPoints, pabyRec + 44, 4);
+    if (bBigEndian)
+      nPoints = SWAP_FOUR_BYTES(nPoints);
+
+    /* -------------------------------------------------------------------- */
+    /*      Fill the shape structure.                                       */
+    /* -------------------------------------------------------------------- */
+    if ((shape->line = (lineObj *)malloc(sizeof(lineObj))) == NULL) {
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
+      return;
+    }
+
+    if (nPoints < 0 || nPoints > 50 * 1000 * 1000) {
+      free(shape->line);
+      shape->line = NULL;
+      shape->numlines = 0;
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_SHPERR, "Corrupted .shp file : shape %d, nPoints=%d.",
+                 "msSHPReadShape()", hEntity, nPoints);
+      return;
+    }
+
+    nRequiredSize = 48 + nPoints * 16;
+    if (psSHP->nShapeType == SHP_MULTIPOINTZ ||
+        psSHP->nShapeType == SHP_MULTIPOINTM)
+      nRequiredSize += 16 + nPoints * 8;
+    if (nRequiredSize > nEntitySize) {
+      free(shape->line);
+      shape->line = NULL;
+      shape->numlines = 0;
+      shape->type = MS_SHAPE_NULL;
+      msSetError(
+          MS_SHPERR,
+          "Corrupted .shp file : shape %d : nPoints = %d, nEntitySize = %d",
+          "msSHPReadShape()", hEntity, nPoints, nEntitySize);
+      return;
+    }
+
+    shape->numlines = 1;
+    shape->line[0].numpoints = nPoints;
+    shape->line[0].point = (pointObj *)malloc(nPoints * sizeof(pointObj));
+    if (shape->line[0].point == NULL) {
+      free(shape->line);
+      shape->line = NULL;
+      shape->numlines = 0;
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
+      return;
+    }
+
+    for (i = 0; i < nPoints; i++) {
+      memcpy(&(shape->line[0].point[i].x), pabyRec + 48 + 16 * i, 8);
+      memcpy(&(shape->line[0].point[i].y), pabyRec + 48 + 16 * i + 8, 8);
+
+      if (bBigEndian) {
+        SwapWord(8, &(shape->line[0].point[i].x));
+        SwapWord(8, &(shape->line[0].point[i].y));
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      MulipointZ                                                      */
+      /* -------------------------------------------------------------------- */
+      shape->line[0].point[i].z = 0; /* initialize */
+      if (psSHP->nShapeType == SHP_MULTIPOINTZ) {
+        const int nOffset = 48 + 16 * nPoints;
+        memcpy(&(shape->line[0].point[i].z), pabyRec + nOffset + 16 + i * 8, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[i].z));
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      Measured shape : multipont.                                     */
+      /* -------------------------------------------------------------------- */
+      shape->line[0].point[i].m = 0; /* initialize */
+      if (psSHP->nShapeType == SHP_MULTIPOINTM) {
+        const int nOffset = 48 + 16 * nPoints;
+        memcpy(&(shape->line[0].point[i].m), pabyRec + nOffset + 16 + i * 8, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[i].m));
+      }
+    }
+
+    shape->type = MS_SHAPE_POINT;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Extract a Point.                            */
+  /* -------------------------------------------------------------------- */
+  else if (psSHP->nShapeType == SHP_POINT || psSHP->nShapeType == SHP_POINTM ||
+           psSHP->nShapeType == SHP_POINTZ) {
+
+    if (nEntitySize < 20 + 8) {
+      shape->type = MS_SHAPE_NULL;
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  recSize of feature %d=%d",
+                 "msSHPReadShape()", hEntity, msSHXReadSize(psSHP, hEntity));
+      return;
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Fill the shape structure.                                       */
+    /* -------------------------------------------------------------------- */
+    shape->line = (lineObj *)malloc(sizeof(lineObj));
+    MS_CHECK_ALLOC_NO_RET(shape->line, sizeof(lineObj));
+
+    shape->numlines = 1;
+    shape->line[0].numpoints = 1;
+    shape->line[0].point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+
+    memcpy(&(shape->line[0].point[0].x), pabyRec + 12, 8);
+    memcpy(&(shape->line[0].point[0].y), pabyRec + 20, 8);
+
+    if (bBigEndian) {
+      SwapWord(8, &(shape->line[0].point[0].x));
+      SwapWord(8, &(shape->line[0].point[0].y));
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      PointZ                                                          */
+    /* -------------------------------------------------------------------- */
+    shape->line[0].point[0].z = 0; /* initialize */
+    if (psSHP->nShapeType == SHP_POINTZ) {
+      const int nOffset = 20 + 8;
+      if (nEntitySize >= nOffset + 8) {
+        memcpy(&(shape->line[0].point[0].z), pabyRec + nOffset, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[0].z));
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Measured support : point.                                       */
+    /* -------------------------------------------------------------------- */
+    shape->line[0].point[0].m = 0; /* initialize */
+    if (psSHP->nShapeType == SHP_POINTM) {
+      const int nOffset = 20 + 8;
+      if (nEntitySize >= nOffset + 8) {
+        memcpy(&(shape->line[0].point[0].m), pabyRec + nOffset, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[0].m));
+      }
+    }
+
+    /* set the bounding box to the point */
+    shape->bounds.minx = shape->bounds.maxx = shape->line[0].point[0].x;
+    shape->bounds.miny = shape->bounds.maxy = shape->line[0].point[0].y;
+
+    shape->type = MS_SHAPE_POINT;
+  }
+
+  shape->index = hEntity;
+
+  return;
+}
+
+int msSHPReadBounds(SHPHandle psSHP, int hEntity, rectObj *padBounds) {
+  /* -------------------------------------------------------------------- */
+  /*      Validate the record/entity number.                              */
+  /* -------------------------------------------------------------------- */
+  if (psSHP->nRecords <= 0 || hEntity < -1 || hEntity >= psSHP->nRecords) {
+    padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy = 0.0;
+    return MS_FAILURE;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  If the entity is -1 we fetch the bounds for the whole file.   */
+  /* -------------------------------------------------------------------- */
+  if (hEntity == -1) {
+    padBounds->minx = psSHP->adBoundsMin[0];
+    padBounds->miny = psSHP->adBoundsMin[1];
+    padBounds->maxx = psSHP->adBoundsMax[0];
+    padBounds->maxy = psSHP->adBoundsMax[1];
+  } else {
+
+    if (msSHXReadSize(psSHP, hEntity) <= 4) { /* NULL shape */
+      padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy =
+          0.0;
+      return MS_FAILURE;
+    }
+
+    const int offset = msSHXReadOffset(psSHP, hEntity);
+    if (offset <= 0 || offset >= INT_MAX - 12 ||
+        0 != VSIFSeekL(psSHP->fpSHP, offset + 12, 0)) {
+      msSetError(MS_IOERR, "failed to seek offset", "msSHPReadBounds()");
+      return (MS_FAILURE);
+    }
+
+    if (psSHP->nShapeType != SHP_POINT && psSHP->nShapeType != SHP_POINTZ &&
+        psSHP->nShapeType != SHP_POINTM) {
+      if (1 != VSIFReadL(padBounds, sizeof(double) * 4, 1, psSHP->fpSHP)) {
+        msSetError(MS_IOERR, "failed to fread record", "msSHPReadBounds()");
+        return (MS_FAILURE);
+      }
+
+      if (bBigEndian) {
+        SwapWord(8, &(padBounds->minx));
+        SwapWord(8, &(padBounds->miny));
+        SwapWord(8, &(padBounds->maxx));
+        SwapWord(8, &(padBounds->maxy));
+      }
+
+      if (msIsNan(padBounds->minx)) { /* empty shape */
+        padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy =
+            0.0;
+        return MS_FAILURE;
+      }
+    } else {
+      /* -------------------------------------------------------------------- */
+      /*      For points we fetch the point, and duplicate it as the          */
+      /*      minimum and maximum bound.                                      */
+      /* -------------------------------------------------------------------- */
+      if (1 != VSIFReadL(padBounds, sizeof(double) * 2, 1, psSHP->fpSHP)) {
+        msSetError(MS_IOERR, "failed to fread record", "msSHPReadBounds()");
+        return (MS_FAILURE);
+      }
+
+      if (bBigEndian) {
+        SwapWord(8, &(padBounds->minx));
+        SwapWord(8, &(padBounds->miny));
+      }
+
+      padBounds->maxx = padBounds->minx;
+      padBounds->maxy = padBounds->miny;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+int msShapefileOpenHandle(shapefileObj *shpfile, const char *filename,
+                          SHPHandle hSHP, DBFHandle hDBF) {
+  assert(filename != NULL);
+  assert(hSHP != NULL);
+  assert(hDBF != NULL);
+
+  /* initialize a few things */
+  shpfile->status = NULL;
+  shpfile->lastshape = -1;
+  shpfile->isopen = MS_FALSE;
+
+  shpfile->hSHP = hSHP;
+
+  strlcpy(shpfile->source, filename, sizeof(shpfile->source));
+
+  /* load some information about this shapefile */
+  msSHPGetInfo(shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
+
+  if (shpfile->numshapes < 0 || shpfile->numshapes > 256000000) {
+    msSetError(MS_SHPERR, "Corrupted .shp file : numshapes = %d.",
+               "msShapefileOpen()", shpfile->numshapes);
+    msDBFClose(hDBF);
+    msSHPClose(hSHP);
+    return -1;
+  }
+
+  msSHPReadBounds(shpfile->hSHP, -1, &(shpfile->bounds));
+
+  shpfile->hDBF = hDBF;
+
+  shpfile->isopen = MS_TRUE;
+  return (0); /* all o.k. */
+}
+
+int msShapefileOpenVirtualFile(shapefileObj *shpfile, const char *filename,
+                               VSILFILE *fpSHP, VSILFILE *fpSHX,
+                               VSILFILE *fpDBF, int log_failures) {
+  assert(filename != NULL);
+  assert(fpSHP != NULL);
+  assert(fpSHX != NULL);
+  assert(fpDBF != NULL);
+
+  /* open the shapefile file (appending ok) and get basic info */
+  SHPHandle hSHP = msSHPOpenVirtualFile(fpSHP, fpSHX);
+  if (!hSHP) {
+    if (log_failures)
+      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
+    VSIFCloseL(fpDBF);
+    return (-1);
+  }
+
+  DBFHandle hDBF = msDBFOpenVirtualFile(fpDBF);
+
+  if (!hDBF) {
+    if (log_failures)
+      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
+    msSHPClose(hSHP);
+    return (-1);
+  }
+
+  return msShapefileOpenHandle(shpfile, filename, hSHP, hDBF);
+}
+
+int msShapefileOpen(shapefileObj *shpfile, const char *mode,
+                    const char *filename, int log_failures) {
+  int i;
+  char *dbfFilename;
+  size_t bufferSize = 0;
+
+  if (!filename) {
+    if (log_failures)
+      msSetError(MS_IOERR, "No (NULL) filename provided.", "msShapefileOpen()");
+    return (-1);
+  }
+
+  /* open the shapefile file (appending ok) and get basic info */
+  SHPHandle hSHP;
+  if (!mode)
+    hSHP = msSHPOpen(filename, "rb");
+  else
+    hSHP = msSHPOpen(filename, mode);
+
+  if (!hSHP) {
+    if (log_failures)
+      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
+    return (-1);
+  }
+
+  bufferSize = strlen(filename) + 5;
+  dbfFilename = (char *)msSmallMalloc(bufferSize);
+  strcpy(dbfFilename, filename);
+
+  /* clean off any extention the filename might have */
+  for (i = strlen(dbfFilename) - 1;
+       i > 0 && dbfFilename[i] != '.' && dbfFilename[i] != '/' &&
+       dbfFilename[i] != '\\';
+       i--) {
+  }
+
+  if (dbfFilename[i] == '.')
+    dbfFilename[i] = '\0';
+
+  strlcat(dbfFilename, ".dbf", bufferSize);
+
+  DBFHandle hDBF = msDBFOpen(dbfFilename, "rb");
+
+  if (!hDBF) {
+    if (log_failures)
+      msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", dbfFilename);
+    free(dbfFilename);
+    msSHPClose(hSHP);
+    return (-1);
+  }
+  free(dbfFilename);
+
+  return msShapefileOpenHandle(shpfile, filename, hSHP, hDBF);
+}
+
+/* Creates a new shapefile */
+int msShapefileCreate(shapefileObj *shpfile, char *filename, int type) {
+  if (type != SHP_POINT && type != SHP_MULTIPOINT && type != SHP_ARC &&
+      type != SHP_POLYGON && type != SHP_POINTM && type != SHP_MULTIPOINTM &&
+      type != SHP_ARCM && type != SHP_POLYGONM && type != SHP_POINTZ &&
+      type != SHP_MULTIPOINTZ && type != SHP_ARCZ && type != SHP_POLYGONZ) {
+    msSetError(MS_SHPERR, "Invalid shape type.", "msNewSHPFile()");
+    return (-1);
+  }
+
+  /* create the spatial portion */
+  shpfile->hSHP = msSHPCreate(filename, type);
+  if (!shpfile->hSHP) {
+    msSetError(MS_IOERR, "(%s)", "msNewSHPFile()", filename);
+    return (-1);
+  }
+
+  /* retrieve a few things about this shapefile */
+  msSHPGetInfo(shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
+  msSHPReadBounds(shpfile->hSHP, -1, &(shpfile->bounds));
+
+  /* initialize a few other things */
+  shpfile->status = NULL;
+  shpfile->lastshape = -1;
+  shpfile->isopen = MS_TRUE;
+
+  shpfile->hDBF = NULL; /* XBase file is NOT created here... */
+  return (0);
+}
+
+void msShapefileClose(shapefileObj *shpfile) {
+  if (shpfile && shpfile->isopen == MS_TRUE) { /* Silently return if called with
+                                                  NULL shpfile by freeLayer() */
+    if (shpfile->hSHP)
+      msSHPClose(shpfile->hSHP);
+    if (shpfile->hDBF)
+      msDBFClose(shpfile->hDBF);
+    free(shpfile->status);
+    shpfile->isopen = MS_FALSE;
+  }
+}
+
+/* status array lives in the shpfile, can return MS_SUCCESS/MS_FAILURE/MS_DONE
+ */
+int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect, int debug) {
+  int i;
+  rectObj shaperect;
+  char *filename;
+
+  free(shpfile->status);
+  shpfile->status = NULL;
+
+  /* rect and shapefile DON'T overlap... */
+  if (msRectOverlap(&shpfile->bounds, &rect) != MS_TRUE)
+    return (MS_DONE);
+
+  if (msRectContained(&shpfile->bounds, &rect) == MS_TRUE) {
+    shpfile->status = msAllocBitArray(shpfile->numshapes);
+    if (!shpfile->status) {
+      msSetError(MS_MEMERR, NULL, "msShapefileWhichShapes()");
+      return (MS_FAILURE);
+    }
+    msSetAllBits(shpfile->status, shpfile->numshapes, 1);
+  } else {
+
+    /* deal with case where sourcename is of the form 'file.shp' */
+    char *sourcename =
+        msStrdup(shpfile->source); /* shape file source string from map file */
+    char *s = strstr(sourcename, ".shp");
+    if (s)
+      *s = '\0';
+    else {
+      s = strstr(sourcename, ".SHP");
+      if (s)
+        *s = '\0';
+    }
+
+    filename =
+        (char *)malloc(strlen(sourcename) + strlen(MS_INDEX_EXTENSION) + 1);
+    MS_CHECK_ALLOC(filename,
+                   strlen(sourcename) + strlen(MS_INDEX_EXTENSION) + 1,
+                   MS_FAILURE);
+
+    sprintf(filename, "%s%s", sourcename, MS_INDEX_EXTENSION);
+
+    shpfile->status =
+        msSearchDiskTree(filename, rect, debug, shpfile->numshapes);
+    free(filename);
+    free(sourcename);
+
+    if (shpfile->status) { /* index  */
+      msFilterTreeSearch(shpfile, shpfile->status, rect);
+    } else { /* no index  */
+      shpfile->status = msAllocBitArray(shpfile->numshapes);
+      if (!shpfile->status) {
+        msSetError(MS_MEMERR, NULL, "msShapefileWhichShapes()");
+        return (MS_FAILURE);
+      }
+
+      for (i = 0; i < shpfile->numshapes; i++) {
+        if (msSHPReadBounds(shpfile->hSHP, i, &shaperect) != MS_SUCCESS) {
+          if (msSHXReadSize(shpfile->hSHP, i) == 4) { /* handle NULL shape */
+            continue;
+          }
+          return (MS_FAILURE);
+        }
+
+        if (msRectOverlap(&shaperect, &rect) == MS_TRUE)
+          msSetBit(shpfile->status, i, 1);
+      }
+    }
+  }
+
+  shpfile->lastshape = -1;
+
+  return (MS_SUCCESS); /* success */
+}
+
+/* Return the absolute path to the given layer's tileindex file's directory */
+void msTileIndexAbsoluteDir(char *tiFileAbsDir, layerObj *layer) {
+  char tiFileAbsPath[MS_MAXPATHLEN];
+  char *tiFileAbsDirTmp = NULL;
+
+  msBuildPath(tiFileAbsPath, layer->map->mappath,
+              layer->tileindex); /* absolute path to tileindex file */
+  tiFileAbsDirTmp = msGetPath(tiFileAbsPath); /* tileindex file's directory */
+  strlcpy(tiFileAbsDir, tiFileAbsDirTmp, MS_MAXPATHLEN);
+  free(tiFileAbsDirTmp);
+}
+
+/*
+** Build possible paths we might find the tile file at:
+**   map dir + shape path + filename?
+**   tile dir + shape path + filename?
+**   map dir + filename?
+**
+** Returns
+** MS_SUCCESS - found a file
+** MS_FAILURE - no file, and map is configured to fail on missing
+** MS_DONE - no file, and map is configured to continue on missing
+*/
+static int msTiledSHPTryOpen(shapefileObj *shpfile, layerObj *layer,
+                             char *tiFileAbsDir, const char *filename) {
+  char szPath[MS_MAXPATHLEN];
+  int ignore_missing = msMapIgnoreMissingData(layer->map);
+  int log_failures = MS_TRUE;
+
+  if (ignore_missing == MS_MISSING_DATA_IGNORE)
+    log_failures = MS_FALSE;
+
+  if (msShapefileOpen(shpfile, "rb",
+                      msBuildPath3(szPath, layer->map->mappath,
+                                   layer->map->shapepath, filename),
+                      log_failures) == -1) {
+    if (msShapefileOpen(
+            shpfile, "rb",
+            msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename),
+            log_failures) == -1) {
+      if (msShapefileOpen(shpfile, "rb",
+                          msBuildPath(szPath, layer->map->mappath, filename),
+                          log_failures) == -1) {
+        if (ignore_missing == MS_MISSING_DATA_FAIL) {
+          msSetError(
+              MS_IOERR,
+              "Unable to open shapefile '%s' for layer '%s' ... fatal error.",
+              "msTiledSHPTryOpen()", filename, layer->name);
+          return (MS_FAILURE);
+        } else if (ignore_missing == MS_MISSING_DATA_LOG) {
+          if (layer->debug || layer->map->debug) {
+            msDebug("Unable to open shapefile '%s' for layer '%s' ... ignoring "
+                    "this missing data.\n",
+                    szPath, layer->name);
+          }
+          return (MS_DONE);
+        } else if (ignore_missing == MS_MISSING_DATA_IGNORE) {
+          return (MS_DONE);
+        } else {
+          /* never get here */
+          msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.",
+                     "msTiledSHPTryOpen()");
+          return (MS_FAILURE);
+        }
+      }
+    }
+  }
+  return (MS_SUCCESS);
+}
+
+static const char *msTiledSHPLoadEntry(layerObj *layer, int i, char *tilename,
+                                       size_t tilenamesize) {
+  const char *filename;
+  msTiledSHPLayerInfo *tSHP = layer->layerinfo;
+
+  msProjectDestroyReprojector(tSHP->reprojectorFromTileProjToLayerProj);
+  tSHP->reprojectorFromTileProjToLayerProj = NULL;
+
+  msFreeProjection(&(tSHP->sTileProj));
+  if (layer->tilesrs != NULL) {
+    int idx = msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs);
+    const char *pszWKT =
+        msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, idx);
+    IGNORE_RET_VAL(
+        msOGCWKT2ProjectionObj(pszWKT, &(tSHP->sTileProj), layer->debug));
+  }
+
+  if (!layer->data) /* assume whole filename is in attribute field */
+    filename = msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i,
+                                        layer->tileitemindex);
+  else {
+    snprintf(tilename, tilenamesize, "%s/%s",
+             msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i,
+                                      layer->tileitemindex),
+             layer->data);
+    filename = tilename;
+  }
+
+  return filename;
+}
+
+static int msTiledSHPOpenFile(layerObj *layer) {
+  int i;
+  const char *filename;
+  char tilename[MS_MAXPATHLEN], szPath[MS_MAXPATHLEN];
+  char tiFileAbsDir[MS_MAXPATHLEN];
+
+  msTiledSHPLayerInfo *tSHP = NULL;
+
+  if (layer->layerinfo != NULL) {
+    return MS_SUCCESS; // Nothing to do... layer is already opened
+  }
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  /* allocate space for a shapefileObj using layer->layerinfo  */
+  tSHP = (msTiledSHPLayerInfo *)calloc(1, sizeof(msTiledSHPLayerInfo));
+  MS_CHECK_ALLOC(tSHP, sizeof(msTiledSHPLayerInfo), MS_FAILURE);
+  msInitProjection(&(tSHP->sTileProj));
+  msProjectionInheritContextFrom(&(tSHP->sTileProj), &layer->projection);
+
+  tSHP->shpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
+  if (tSHP->shpfile == NULL) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msTiledSHPOpenFile()", __FILE__, __LINE__,
+               (unsigned int)sizeof(shapefileObj));
+    msFreeProjection(&(tSHP->sTileProj));
+    free(tSHP);
+    return MS_FAILURE;
+  }
+
+  tSHP->shpfile->isopen =
+      MS_FALSE; /* in case of error: do not try to close the shpfile */
+  tSHP->tileshpfile =
+      NULL; /* may need this if not using a tile layer, look for malloc later */
+  layer->layerinfo = tSHP;
+
+  tSHP->tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
+  if (tSHP->tilelayerindex !=
+      -1) { /* does the tileindex reference another layer */
+    int status;
+    layerObj *tlp;
+
+    tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
+
+    if (tlp->connectiontype != MS_SHAPEFILE) {
+      msSetError(MS_SHPERR, "Tileindex layer must be a shapefile.",
+                 "msTiledSHPOpenFile()");
+      return (MS_FAILURE);
+    }
+
+    status = msLayerOpen(tlp);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    /* build item list */
+    status = msLayerWhichItems(tlp, MS_FALSE, NULL);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    tSHP->tileshpfile =
+        (shapefileObj *)tlp->layerinfo; /* shapefiles use layerinfo to point to
+                                           a shapefileObj */
+
+  } else { /* or reference a shapefile directly */
+
+    /* we need tSHP->tileshpfile if we're not working with a layer */
+    tSHP->tileshpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
+    if (tSHP->tileshpfile == NULL) {
+      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                 "msTiledSHPOpenFile()", __FILE__, __LINE__,
+                 (unsigned int)sizeof(shapefileObj));
+      free(tSHP->shpfile);
+      msFreeProjection(&(tSHP->sTileProj));
+      free(tSHP);
+      layer->layerinfo = NULL;
+      return MS_FAILURE;
+    }
+
+    if (msShapefileOpen(tSHP->tileshpfile, "rb",
+                        msBuildPath3(szPath, layer->map->mappath,
+                                     layer->map->shapepath, layer->tileindex),
+                        MS_TRUE) == -1)
+      if (msShapefileOpen(
+              tSHP->tileshpfile, "rb",
+              msBuildPath(szPath, layer->map->mappath, layer->tileindex),
+              MS_TRUE) == -1)
+        return (MS_FAILURE);
+  }
+
+  if ((layer->tileitemindex =
+           msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tileitem)) == -1)
+    return (MS_FAILURE);
+
+  if (layer->tilesrs != NULL &&
+      msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs) < 0) {
+    msSetError(MS_SHPERR, "Cannot identify TILESRS field.",
+               "msTiledSHPOpenFile()");
+    return MS_FAILURE;
+  }
+  if (layer->tilesrs != NULL && layer->projection.numargs == 0) {
+    msSetError(MS_SHPERR,
+               "A layer with TILESRS set in TILEINDEX `%s' must have a "
+               "projection set on itself.",
+               "msOGRLayerOpen()", layer->tileindex);
+    return MS_FAILURE;
+  }
+
+  msTileIndexAbsoluteDir(tiFileAbsDir, layer);
+
+  /* position the source at the FIRST tile to use as a template, this is so the
+   * functions that fill the iteminfo array have something to work from */
+  for (i = 0; i < tSHP->tileshpfile->numshapes; i++) {
+    int try_open;
+
+    filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
+    if (strlen(filename) == 0)
+      continue; /* check again */
+
+    try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+    if (try_open == MS_DONE)
+      continue;
+    else if (try_open == MS_FAILURE)
+      return (MS_FAILURE);
+
+    return (MS_SUCCESS); /* found a template, ok to proceed */
+  }
+
+  msSetError(MS_SHPERR,
+             "Unable to open a single tile to use as a template in layer %s.",
+             "msTiledSHPOpenFile()", layer->name ? layer->name : "(null)");
+  return (MS_FAILURE);
+}
+
+static int msTiledSHPWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  int i, status;
+  const char *filename;
+  char tilename[MS_MAXPATHLEN];
+  char tiFileAbsDir[MS_MAXPATHLEN];
+
+  msTiledSHPLayerInfo *tSHP = NULL;
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  tSHP = layer->layerinfo;
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPWhichShapes()");
+    return (MS_FAILURE);
+  }
+
+  msShapefileClose(tSHP->shpfile); /* close previously opened files */
+
+  tSHP->searchrect = rect; /* save the search extent */
+
+  if (tSHP->tilelayerindex !=
+      -1) { /* does the tileindex reference another layer */
+    layerObj *tlp;
+    shapeObj tshape;
+
+    tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
+    status = msLayerWhichShapes(tlp, rect, isQuery);
+    if (status != MS_SUCCESS)
+      return (status); /* could be MS_DONE or MS_FAILURE */
+
+    msTileIndexAbsoluteDir(tiFileAbsDir, layer);
+
+    msInitShape(&tshape);
+    while ((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
+      int try_open;
+      rectObj rectTile = rect;
+
+      filename =
+          msTiledSHPLoadEntry(layer, tshape.index, tilename, sizeof(tilename));
+      if (strlen(filename) == 0)
+        continue; /* check again */
+
+      try_open =
+          msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+      if (try_open == MS_DONE)
+        continue;
+      else if (try_open == MS_FAILURE)
+        return (MS_FAILURE);
+
+      if (tSHP->sTileProj.numargs > 0) {
+        msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
+      }
+
+      status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
+      if (status == MS_DONE) {
+        /* Close and continue to next tile */
+        msShapefileClose(tSHP->shpfile);
+        continue;
+      } else if (status != MS_SUCCESS) {
+        msShapefileClose(tSHP->shpfile);
+        return (MS_FAILURE);
+      }
+
+      /* the layer functions keeps track of this */
+      /* tSHP->tileshpfile->lastshape = tshape.index; */
+      break;
+    }
+    return (status); /* if we reach here we either 1) ran out of tiles or 2) had
+                        an error reading a tile */
+
+  } else { /* or reference a shapefile directly */
+    int try_open;
+
+    status = msShapefileWhichShapes(tSHP->tileshpfile, rect, layer->debug);
+    if (status != MS_SUCCESS)
+      return (status); /* could be MS_DONE or MS_FAILURE */
+
+    msTileIndexAbsoluteDir(tiFileAbsDir, layer);
+
+    /* position the source at the FIRST shapefile */
+    for (i = 0; i < tSHP->tileshpfile->numshapes; i++) {
+      rectObj rectTile = rect;
+      if (msGetBit(tSHP->tileshpfile->status, i)) {
+
+        filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
+        if (strlen(filename) == 0)
+          continue; /* check again */
+
+        try_open =
+            msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+        if (try_open == MS_DONE)
+          continue;
+        else if (try_open == MS_FAILURE)
+          return (MS_FAILURE);
+
+        if (tSHP->sTileProj.numargs > 0) {
+          msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
+        }
+
+        status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
+        if (status == MS_DONE) {
+          /* Close and continue to next tile */
+          msShapefileClose(tSHP->shpfile);
+          continue;
+        } else if (status != MS_SUCCESS) {
+          msShapefileClose(tSHP->shpfile);
+          return (MS_FAILURE);
+        }
+
+        tSHP->tileshpfile->lastshape = i;
+        break;
+      }
+    }
+
+    if (i == tSHP->tileshpfile->numshapes)
+      return (MS_DONE); /* no more tiles */
+    else
+      return (MS_SUCCESS);
+  }
+
+  return (MS_FAILURE); /* should *never* get here */
+}
+
+static int msTiledSHPNextShape(layerObj *layer, shapeObj *shape) {
+  int i, status, filter_passed = MS_FALSE;
+  const char *filename;
+  char tilename[MS_MAXPATHLEN];
+  char tiFileAbsDir[MS_MAXPATHLEN];
+
+  msTiledSHPLayerInfo *tSHP = NULL;
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  tSHP = layer->layerinfo;
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPNextShape()");
+    return (MS_FAILURE);
+  }
+
+  msTileIndexAbsoluteDir(tiFileAbsDir, layer);
+
+  do {
+    i = tSHP->shpfile->lastshape + 1;
+    while (i < tSHP->shpfile->numshapes && !msGetBit(tSHP->shpfile->status, i))
+      i++; /* next "in" shape */
+
+    if (i ==
+        tSHP->shpfile->numshapes) {    /* done with this tile, need a new one */
+      msShapefileClose(tSHP->shpfile); /* clean up */
+
+      /* position the source to the NEXT shapefile based on the tileindex */
+      if (tSHP->tilelayerindex !=
+          -1) { /* does the tileindex reference another layer */
+        layerObj *tlp;
+        shapeObj tshape;
+        int try_open;
+
+        tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
+
+        msInitShape(&tshape);
+        while ((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
+          rectObj rectTile = tSHP->searchrect;
+
+          filename = msTiledSHPLoadEntry(layer, tshape.index, tilename,
+                                         sizeof(tilename));
+          if (strlen(filename) == 0)
+            continue; /* check again */
+
+          try_open =
+              msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+          if (try_open == MS_DONE)
+            continue;
+          else if (try_open == MS_FAILURE)
+            return (MS_FAILURE);
+
+          if (tSHP->sTileProj.numargs > 0) {
+            msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
+          }
+
+          status =
+              msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
+          if (status == MS_DONE) {
+            /* Close and continue to next tile */
+            msShapefileClose(tSHP->shpfile);
+            continue;
+          } else if (status != MS_SUCCESS) {
+            msShapefileClose(tSHP->shpfile);
+            tSHP->tileshpfile->lastshape = -1;
+            return (MS_FAILURE);
+          }
+
+          /* the layer functions keeps track of this */
+          /* tSHP->tileshpfile->lastshape = tshape.index; */
+          break;
+        }
+
+        if (status == MS_DONE) {
+          tSHP->tileshpfile->lastshape = -1;
+          return (MS_DONE); /* no more tiles */
+        } else {
+          msFreeShape(&tshape);
+          continue; /* we've got shapes */
+        }
+
+      } else { /* or reference a shapefile directly   */
+
+        for (i = (tSHP->tileshpfile->lastshape + 1);
+             i < tSHP->tileshpfile->numshapes; i++) {
+          if (msGetBit(tSHP->tileshpfile->status, i)) {
+            rectObj rectTile = tSHP->searchrect;
+            int try_open;
+
+            filename =
+                msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
+            if (strlen(filename) == 0)
+              continue; /* check again */
+
+            try_open =
+                msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+            if (try_open == MS_DONE)
+              continue;
+            else if (try_open == MS_FAILURE)
+              return (MS_FAILURE);
+
+            if (tSHP->sTileProj.numargs > 0) {
+              msProjectRect(&(layer->projection), &(tSHP->sTileProj),
+                            &rectTile);
+            }
+
+            status =
+                msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
+            if (status == MS_DONE) {
+              /* Close and continue to next tile */
+              msShapefileClose(tSHP->shpfile);
+              continue;
+            } else if (status != MS_SUCCESS) {
+              msShapefileClose(tSHP->shpfile);
+              tSHP->tileshpfile->lastshape = -1;
+              return (MS_FAILURE);
+            }
+
+            tSHP->tileshpfile->lastshape = i;
+            break;
+          }
+        } /* end for loop */
+
+        if (i == tSHP->tileshpfile->numshapes) {
+          tSHP->tileshpfile->lastshape = -1;
+          return (MS_DONE); /* no more tiles */
+        } else
+          continue; /* we've got shapes */
+      }
+    }
+
+    tSHP->shpfile->lastshape = i;
+
+    msSHPReadShape(tSHP->shpfile->hSHP, i, shape);
+    if (shape->type == MS_SHAPE_NULL) {
+      msFreeShape(shape);
+      continue; /* skip NULL shapes */
+    }
+
+    if (tSHP->sTileProj.numargs > 0) {
+      if (tSHP->reprojectorFromTileProjToLayerProj == NULL) {
+        tSHP->reprojectorFromTileProjToLayerProj = msProjectCreateReprojector(
+            &(tSHP->sTileProj), &(layer->projection));
+      }
+      if (tSHP->reprojectorFromTileProjToLayerProj) {
+        msProjectShapeEx(tSHP->reprojectorFromTileProjToLayerProj, shape);
+      }
+    }
+
+    shape->tileindex = tSHP->tileshpfile->lastshape;
+    shape->numvalues = layer->numitems;
+    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, i, layer->iteminfo,
+                                      layer->numitems);
+    if (!shape->values)
+      shape->numvalues = 0;
+
+    filter_passed = MS_TRUE; /* By default accept ANY shape */
+    if (layer->numitems > 0 && layer->iteminfo) {
+      filter_passed = msEvalExpression(layer, shape, &(layer->filter),
+                                       layer->filteritemindex);
+    }
+
+    if (!filter_passed)
+      msFreeShape(shape); /* free's values as well */
+
+  } while (
+      !filter_passed); /* Loop until both spatial and attribute filters match */
+
+  return (MS_SUCCESS);
+}
+
+static int msTiledSHPGetShape(layerObj *layer, shapeObj *shape,
+                              resultObj *record) {
+  const char *filename;
+  char tilename[MS_MAXPATHLEN], szPath[MS_MAXPATHLEN];
+
+  msTiledSHPLayerInfo *tSHP = NULL;
+  char tiFileAbsDir[MS_MAXPATHLEN];
+
+  long shapeindex = record->shapeindex;
+  int tileindex = record->tileindex;
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  tSHP = layer->layerinfo;
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPGetShape()");
+    return (MS_FAILURE);
+  }
+
+  msTileIndexAbsoluteDir(tiFileAbsDir, layer);
+
+  if ((tileindex < 0) || (tileindex >= tSHP->tileshpfile->numshapes))
+    return (MS_FAILURE); /* invalid tile id */
+
+  if (tileindex !=
+      tSHP->tileshpfile->lastshape) { /* correct tile is not currenly open so
+                                         open the correct tile */
+    msShapefileClose(tSHP->shpfile);  /* close current tile */
+
+    filename =
+        msTiledSHPLoadEntry(layer, tileindex, tilename, sizeof(tilename));
+
+    /* open the shapefile, since a specific tile was request an error should be
+     * generated if that tile does not exist */
+    if (strlen(filename) == 0)
+      return (MS_FAILURE);
+    if (msShapefileOpen(
+            tSHP->shpfile, "rb",
+            msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename),
+            MS_TRUE) == -1) {
+      if (msShapefileOpen(tSHP->shpfile, "rb",
+                          msBuildPath3(szPath, layer->map->mappath,
+                                       layer->map->shapepath, filename),
+                          MS_TRUE) == -1) {
+        if (msShapefileOpen(tSHP->shpfile, "rb",
+                            msBuildPath(szPath, layer->map->mappath, filename),
+                            MS_TRUE) == -1) {
+          return (MS_FAILURE);
+        }
+      }
+    }
+  }
+
+  if ((shapeindex < 0) || (shapeindex >= tSHP->shpfile->numshapes))
+    return (MS_FAILURE);
+
+  msSHPReadShape(tSHP->shpfile->hSHP, shapeindex, shape);
+  tSHP->shpfile->lastshape = shapeindex;
+  tSHP->tileshpfile->lastshape = tileindex;
+
+  if (tSHP->sTileProj.numargs > 0) {
+    if (tSHP->reprojectorFromTileProjToLayerProj == NULL) {
+      tSHP->reprojectorFromTileProjToLayerProj =
+          msProjectCreateReprojector(&(tSHP->sTileProj), &(layer->projection));
+    }
+    if (tSHP->reprojectorFromTileProjToLayerProj) {
+      msProjectShapeEx(tSHP->reprojectorFromTileProjToLayerProj, shape);
+    }
+  }
+
+  if (layer->numitems > 0 && layer->iteminfo) {
+    shape->numvalues = layer->numitems;
+    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, shapeindex,
+                                      layer->iteminfo, layer->numitems);
+    if (!shape->values)
+      return (MS_FAILURE);
+  }
+
+  shape->tileindex = tileindex;
+
+  return (MS_SUCCESS);
+}
+
+static void msTiledSHPClose(layerObj *layer) {
+  msTiledSHPLayerInfo *tSHP = NULL;
+
+  tSHP = layer->layerinfo;
+  if (tSHP) {
+    msShapefileClose(tSHP->shpfile);
+    free(tSHP->shpfile);
+
+    if (tSHP->tilelayerindex != -1) {
+      layerObj *tlp;
+      if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+        return;
+      tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
+      msLayerClose(tlp);
+    } else {
+      msShapefileClose(tSHP->tileshpfile);
+      free(tSHP->tileshpfile);
+    }
+
+    msProjectDestroyReprojector(tSHP->reprojectorFromTileProjToLayerProj);
+
+    msFreeProjection(&(tSHP->sTileProj));
+
+    free(tSHP);
+  }
+  layer->layerinfo = NULL;
+}
+/************************************************************************/
+/*                              msTiledSHPClose()                       */
+/* Overloaded version of msTiledSHPClose for virtual table architecture */
+/************************************************************************/
+int msTiledSHPCloseVT(layerObj *layer) {
+  msTiledSHPClose(layer);
+  return MS_SUCCESS;
+}
+
+void msTiledSHPLayerFreeItemInfo(layerObj *layer) {
+  if (layer->iteminfo) {
+    free(layer->iteminfo);
+    layer->iteminfo = NULL;
+  }
+}
+
+int msTiledSHPLayerInitItemInfo(layerObj *layer) {
+  msTiledSHPLayerInfo *tSHP = NULL;
+
+  tSHP = layer->layerinfo;
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPLayerInitItemInfo()");
+    return MS_FAILURE;
+  }
+
+  msTiledSHPLayerFreeItemInfo(layer);
+  layer->iteminfo = (int *)msDBFGetItemIndexes(tSHP->shpfile->hDBF,
+                                               layer->items, layer->numitems);
+  if (!layer->iteminfo)
+    return (MS_FAILURE);
+
+  return MS_SUCCESS;
+}
+
+static void msSHPPassThroughFieldDefinitions(layerObj *layer, DBFHandle hDBF) {
+  int numitems, i;
+
+  numitems = msDBFGetFieldCount(hDBF);
+
+  for (i = 0; i < numitems; i++) {
+    char item[16];
+    int nWidth = 0, nPrecision = 0;
+    char gml_width[32], gml_precision[32];
+    DBFFieldType eType;
+    const char *gml_type = NULL;
+
+    eType = msDBFGetFieldInfo(hDBF, i, item, &nWidth, &nPrecision);
+
+    gml_width[0] = '\0';
+    gml_precision[0] = '\0';
+
+    switch (eType) {
+    case FTInteger:
+      gml_type = "Integer";
+      sprintf(gml_width, "%d", nWidth);
+      break;
+
+    case FTDouble:
+      gml_type = "Real";
+      sprintf(gml_width, "%d", nWidth);
+      sprintf(gml_precision, "%d", nPrecision);
+      break;
+
+    case FTString:
+    default:
+      gml_type = "Character";
+      sprintf(gml_width, "%d", nWidth);
+      break;
+    }
+
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision,
+                             0);
+  }
+}
+
+int msTiledSHPLayerGetItems(layerObj *layer) {
+  msTiledSHPLayerInfo *tSHP = NULL;
+  const char *value;
+
+  tSHP = layer->layerinfo;
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPLayerGetItems()");
+    return MS_FAILURE;
+  }
+
+  layer->numitems = msDBFGetFieldCount(tSHP->shpfile->hDBF);
+  layer->items = msDBFGetItems(tSHP->shpfile->hDBF);
+  if (!layer->items)
+    return MS_FAILURE;
+
+  /* -------------------------------------------------------------------- */
+  /*      consider populating the field definitions in metadata.          */
+  /* -------------------------------------------------------------------- */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    msSHPPassThroughFieldDefinitions(layer, tSHP->shpfile->hDBF);
+
+  return msTiledSHPLayerInitItemInfo(layer);
+}
+
+int msTiledSHPLayerGetExtent(layerObj *layer, rectObj *extent) {
+  msTiledSHPLayerInfo *tSHP = NULL;
+
+  tSHP = layer->layerinfo;
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPLayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  *extent = tSHP->tileshpfile->bounds;
+  return MS_SUCCESS;
+}
+
+int msTiledSHPLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return MS_TRUE;
+  else
+    return MS_FALSE;
+}
+
+int msTiledSHPLayerSupportsCommonFilters(layerObj *layer) {
+  (void)layer;
+  return MS_TRUE;
+}
+
+int msTiledSHPLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerSupportsCommonFilters =
+      msTiledSHPLayerSupportsCommonFilters;
+  layer->vtable->LayerInitItemInfo = msTiledSHPLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msTiledSHPLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msTiledSHPOpenFile;
+  layer->vtable->LayerIsOpen = msTiledSHPLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msTiledSHPWhichShapes;
+  layer->vtable->LayerNextShape = msTiledSHPNextShape;
+  /* no special version, use ...GetShape() */
+  /* layer->vtable->LayerResultsGetShape = msTiledSHPGetShape; */
+  layer->vtable->LayerGetShape = msTiledSHPGetShape;
+  layer->vtable->LayerClose = msTiledSHPCloseVT;
+  layer->vtable->LayerGetItems = msTiledSHPLayerGetItems;
+  layer->vtable->LayerGetExtent = msTiledSHPLayerGetExtent;
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerCloseConnection, use default */;
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+  /* layer->vtable->LayerGetAutoProjection, use defaut*/
+
+  return MS_SUCCESS;
+}
+
+/* SHAPEFILE Layer virtual table functions */
+
+void msSHPLayerFreeItemInfo(layerObj *layer) {
+  if (layer->iteminfo) {
+    free(layer->iteminfo);
+    layer->iteminfo = NULL;
+  }
+}
+
+int msSHPLayerInitItemInfo(layerObj *layer) {
+  shapefileObj *shpfile = layer->layerinfo;
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerInitItemInfo()");
+    return MS_FAILURE;
+  }
+
+  /* iteminfo needs to be a bit more complex, a list of indexes plus the length
+   * of the list */
+  msSHPLayerFreeItemInfo(layer);
+  layer->iteminfo =
+      (int *)msDBFGetItemIndexes(shpfile->hDBF, layer->items, layer->numitems);
+  if (!layer->iteminfo) {
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+int msSHPLayerOpen(layerObj *layer) {
+  char szPath[MS_MAXPATHLEN];
+  shapefileObj *shpfile;
+
+  if (layer->layerinfo)
+    return MS_SUCCESS; /* layer already open */
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  /* allocate space for a shapefileObj using layer->layerinfo  */
+  shpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
+  MS_CHECK_ALLOC(shpfile, sizeof(shapefileObj), MS_FAILURE);
+
+  layer->layerinfo = shpfile;
+
+  if (msShapefileOpen(shpfile, "rb",
+                      msBuildPath3(szPath, layer->map->mappath,
+                                   layer->map->shapepath, layer->data),
+                      MS_TRUE) == -1) {
+    if (msShapefileOpen(shpfile, "rb",
+                        msBuildPath(szPath, layer->map->mappath, layer->data),
+                        MS_TRUE) == -1) {
+      layer->layerinfo = NULL;
+      free(shpfile);
+      return MS_FAILURE;
+    }
+  }
+
+  if (layer->projection.numargs > 0 &&
+      EQUAL(layer->projection.args[0], "auto")) {
+    const char *pszPRJFilename = CPLResetExtension(szPath, "prj");
+    int bOK = MS_FALSE;
+    VSILFILE *fp = VSIFOpenL(pszPRJFilename, "rb");
+    if (fp != NULL) {
+      char szPRJ[2048];
+      OGRSpatialReferenceH hSRS;
+      int nRead;
+
+      nRead = (int)VSIFReadL(szPRJ, 1, sizeof(szPRJ) - 1, fp);
+      szPRJ[nRead] = '\0';
+      hSRS = OSRNewSpatialReference(szPRJ);
+      if (hSRS != NULL) {
+        if (OSRMorphFromESRI(hSRS) == OGRERR_NONE) {
+          char *pszWKT = NULL;
+          if (OSRExportToWkt(hSRS, &pszWKT) == OGRERR_NONE) {
+            if (msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
+                                       layer->debug) == MS_SUCCESS) {
+              bOK = MS_TRUE;
+            }
+          }
+          CPLFree(pszWKT);
+        }
+        OSRDestroySpatialReference(hSRS);
+      }
+      VSIFCloseL(fp);
+    }
+
+    if (bOK != MS_TRUE) {
+      if (layer->debug || layer->map->debug) {
+        msDebug("Unable to get SRS from shapefile '%s' for layer '%s'.\n",
+                szPath, layer->name);
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+int msSHPLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return MS_TRUE;
+  else
+    return MS_FALSE;
+}
+
+int msSHPLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  (void)isQuery;
+  int status;
+  shapefileObj *shpfile;
+
+  shpfile = layer->layerinfo;
+
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerWhichShapes()");
+    return MS_FAILURE;
+  }
+
+  status = msShapefileWhichShapes(shpfile, rect, layer->debug);
+  if (status != MS_SUCCESS) {
+    return status;
+  }
+
+  return MS_SUCCESS;
+}
+
+int msSHPLayerNextShape(layerObj *layer, shapeObj *shape) {
+  int i;
+  shapefileObj *shpfile;
+
+  shpfile = layer->layerinfo;
+
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerNextShape()");
+    return MS_FAILURE;
+  }
+
+  if (!shpfile->status) {
+    /* probably whichShapes didn't overlap */
+    return MS_DONE;
+  }
+
+  i = msGetNextBit(shpfile->status, shpfile->lastshape + 1, shpfile->numshapes);
+  shpfile->lastshape = i;
+  if (i == -1)
+    return (MS_DONE); /* nothing else to read */
+
+  msSHPReadShape(shpfile->hSHP, i, shape);
+  if (shape->type == MS_SHAPE_NULL) {
+    msFreeShape(shape);
+    return msSHPLayerNextShape(layer, shape); /* skip NULL shapes */
+  }
+  shape->numvalues = layer->numitems;
+  shape->values =
+      msDBFGetValueList(shpfile->hDBF, i, layer->iteminfo, layer->numitems);
+  if (!shape->values)
+    shape->numvalues = 0;
+
+  return MS_SUCCESS;
+}
+
+int msSHPLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  shapefileObj *shpfile;
+  long shapeindex;
+
+  shpfile = layer->layerinfo;
+
+  shapeindex = record->shapeindex;
+
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  /* msSHPReadShape *should* return success or failure so we don't have to test
+   * here */
+  if (shapeindex < 0 || shapeindex >= shpfile->numshapes) {
+    msSetError(MS_MISCERR, "Invalid feature id.", "msSHPLayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  msSHPReadShape(shpfile->hSHP, shapeindex, shape);
+  if (layer->numitems > 0 && layer->iteminfo) {
+    shape->numvalues = layer->numitems;
+    shape->values = msDBFGetValueList(shpfile->hDBF, shapeindex,
+                                      layer->iteminfo, layer->numitems);
+    if (!shape->values)
+      return MS_FAILURE;
+  }
+
+  shpfile->lastshape = shapeindex;
+
+  return MS_SUCCESS;
+}
+
+int msSHPLayerClose(layerObj *layer) {
+  shapefileObj *shpfile;
+  shpfile = layer->layerinfo;
+  if (!shpfile)
+    return MS_SUCCESS; /* nothing to do */
+
+  msShapefileClose(shpfile);
+  free(layer->layerinfo);
+  layer->layerinfo = NULL;
+
+  return MS_SUCCESS;
+}
+
+int msSHPLayerGetItems(layerObj *layer) {
+  shapefileObj *shpfile;
+  const char *value;
+
+  shpfile = layer->layerinfo;
+
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerGetItems()");
+    return MS_FAILURE;
+  }
+
+  layer->numitems = msDBFGetFieldCount(shpfile->hDBF);
+  layer->items = msDBFGetItems(shpfile->hDBF);
+  if (layer->numitems == 0)
+    return MS_SUCCESS; /* No items is a valid case (#3147) */
+  if (!layer->items)
+    return MS_FAILURE;
+
+  /* -------------------------------------------------------------------- */
+  /*      consider populating the field definitions in metadata.          */
+  /* -------------------------------------------------------------------- */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    msSHPPassThroughFieldDefinitions(layer, shpfile->hDBF);
+
+  return msLayerInitItemInfo(layer);
+}
+
+int msSHPLayerGetExtent(layerObj *layer, rectObj *extent) {
+  *extent = ((shapefileObj *)layer->layerinfo)->bounds;
+  return MS_SUCCESS;
+}
+
+int msSHPLayerSupportsCommonFilters(layerObj *layer) {
+  (void)layer;
+  return MS_TRUE;
+}
+
+int msSHPLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerSupportsCommonFilters = msSHPLayerSupportsCommonFilters;
+  layer->vtable->LayerInitItemInfo = msSHPLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msSHPLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msSHPLayerOpen;
+  layer->vtable->LayerIsOpen = msSHPLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msSHPLayerWhichShapes;
+  layer->vtable->LayerNextShape = msSHPLayerNextShape;
+  layer->vtable->LayerGetShape = msSHPLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msSHPLayerClose;
+  layer->vtable->LayerGetItems = msSHPLayerGetItems;
+  layer->vtable->LayerGetExtent = msSHPLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerCloseConnection, use default */
+  layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
+  /* layer->vtable->LayerTranslateFilter, use default */
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapshape.h 8.2.0~beta1-1~exp1/src/mapshape.h
--- 8.0.1-5/src/mapshape.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapshape.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,275 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Shapefile access API
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPSHAPE_H
+#define MAPSHAPE_H
+
+#include <stdio.h>
+#include "mapprimitive.h"
+#include "mapproject.h"
+
+#include "cpl_vsi.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define SHX_BUFFER_PAGE 1024
+
+#ifndef SWIG
+#define MS_PATH_LENGTH 1024
+
+/* Shapefile types */
+#define SHP_POINT 1
+#define SHP_ARC 3
+#define SHP_POLYGON 5
+#define SHP_MULTIPOINT 8
+
+#define SHP_POINTZ 11
+#define SHP_ARCZ 13
+#define SHP_POLYGONZ 15
+#define SHP_MULTIPOINTZ 18
+
+#define SHP_POINTM 21
+#define SHP_ARCM 23
+#define SHP_POLYGONM 25
+#define SHP_MULTIPOINTM 28
+#endif
+
+#define MS_SHAPEFILE_POINT 1
+#define MS_SHAPEFILE_ARC 3
+#define MS_SHAPEFILE_POLYGON 5
+#define MS_SHAPEFILE_MULTIPOINT 8
+
+#define MS_SHP_POINTZ 11
+#define MS_SHP_ARCZ 13
+#define MS_SHP_POLYGONZ 15
+#define MS_SHP_MULTIPOINTZ 18
+
+#define MS_SHP_POINTM 21
+#define MS_SHP_ARCM 23
+#define MS_SHP_POLYGONM 25
+#define MS_SHP_MULTIPOINTM 28
+
+#ifndef SWIG
+typedef unsigned char uchar;
+
+typedef struct {
+  VSILFILE *fpSHP;
+  VSILFILE *fpSHX;
+
+  int nShapeType; /* SHPT_* */
+  int nFileSize;  /* SHP file */
+
+  int nRecords;
+  int nMaxRecords;
+
+  int *panRecOffset;
+  int *panRecSize;
+  ms_bitarray panRecLoaded;
+  int panRecAllLoaded;
+
+  double adBoundsMin[4];
+  double adBoundsMax[4];
+
+  int bUpdated;
+
+  int nBufSize; /* these used static vars in shape readers, moved to be
+                   thread-safe */
+  uchar *pabyRec;
+  int nPartMax;
+  int *panParts;
+
+} SHPInfo;
+typedef SHPInfo *SHPHandle;
+#endif
+
+/************************************************************************/
+/*                          DBFInfo                                     */
+/************************************************************************/
+
+/**
+ * An object containing information about a DBF file
+ *
+ */
+typedef struct {
+#ifdef SWIG
+    %immutable;
+#endif
+
+  int nRecords; ///< Number of records in the DBF
+  int nFields;  ///< Number of fields in the DBF
+
+#ifndef SWIG
+  VSILFILE *fp;
+  unsigned int nRecordLength;
+  int nHeaderLength;
+
+  int *panFieldOffset;
+  int *panFieldSize;
+  int *panFieldDecimals;
+  char *pachFieldType;
+
+  char *pszHeader;
+
+  int nCurrentRecord;
+  int bCurrentRecordModified;
+  char *pszCurrentRecord;
+
+  int bNoHeader;
+  int bUpdated;
+
+  char *pszStringField;
+  int nStringFieldLen;
+#endif /* not SWIG */
+} DBFInfo;
+
+typedef DBFInfo *DBFHandle;
+
+typedef enum { FTString, FTInteger, FTDouble, FTInvalid } DBFFieldType;
+
+/************************************************************************/
+/*                          shapefileObj                                */
+/************************************************************************/
+
+/**
+ * An object representing a Shapefile. There is no write access to this object
+ * using MapScript.
+ */
+typedef struct {
+#ifdef SWIG
+    %immutable;
+#endif
+
+  int type;       ///< Shapefile type - see mapshape.h for values of type
+  int numshapes;  ///< Number of shapes
+  rectObj bounds; ///< Extent of shapes
+
+#ifndef SWIG
+  char source[MS_PATH_LENGTH]; /* full path to this file data */
+  int lastshape;
+  ms_bitarray status;
+  int isopen;
+  SHPHandle hSHP; /* SHP/SHX file pointer */
+  DBFHandle hDBF; /* DBF file pointer */
+#endif
+
+} shapefileObj;
+
+#ifndef SWIG
+/* layerInfo structure for tiled shapefiles */
+typedef struct {
+  shapefileObj *shpfile;
+  shapefileObj *tileshpfile;
+  int tilelayerindex;
+  projectionObj sTileProj;
+  rectObj searchrect;
+  reprojectionObj *reprojectorFromTileProjToLayerProj;
+} msTiledSHPLayerInfo;
+
+/* shapefileObj function prototypes  */
+MS_DLL_EXPORT int msShapefileOpenHandle(shapefileObj *shpfile,
+                                        const char *filename, SHPHandle hSHP,
+                                        DBFHandle hDBF);
+MS_DLL_EXPORT int msShapefileOpenVirtualFile(shapefileObj *shpfile,
+                                             const char *filename,
+                                             VSILFILE *fpSHP, VSILFILE *fpSHX,
+                                             VSILFILE *fpDBF, int log_failures);
+MS_DLL_EXPORT int msShapefileOpen(shapefileObj *shpfile, const char *mode,
+                                  const char *filename, int log_failures);
+MS_DLL_EXPORT int msShapefileCreate(shapefileObj *shpfile, char *filename,
+                                    int type);
+MS_DLL_EXPORT void msShapefileClose(shapefileObj *shpfile);
+MS_DLL_EXPORT int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect,
+                                         int debug);
+
+/* SHP/SHX function prototypes */
+MS_DLL_EXPORT SHPHandle msSHPOpenVirtualFile(VSILFILE *fpSHP, VSILFILE *fpSHX);
+MS_DLL_EXPORT SHPHandle msSHPOpen(const char *pszShapeFile,
+                                  const char *pszAccess);
+MS_DLL_EXPORT SHPHandle msSHPCreate(const char *pszShapeFile, int nShapeType);
+MS_DLL_EXPORT void msSHPClose(SHPHandle hSHP);
+MS_DLL_EXPORT void msSHPGetInfo(SHPHandle hSHP, int *pnEntities,
+                                int *pnShapeType);
+MS_DLL_EXPORT int msSHPReadBounds(SHPHandle psSHP, int hEntity,
+                                  rectObj *padBounds);
+MS_DLL_EXPORT void msSHPReadShape(SHPHandle psSHP, int hEntity,
+                                  shapeObj *shape);
+MS_DLL_EXPORT int msSHPReadPoint(SHPHandle psSHP, int hEntity, pointObj *point);
+MS_DLL_EXPORT int msSHPWriteShape(SHPHandle psSHP, shapeObj *shape);
+MS_DLL_EXPORT int msSHPWritePoint(SHPHandle psSHP, pointObj *point);
+
+/* tiledShapefileObj function prototypes are in mapserver.h */
+
+/* XBase function prototypes */
+MS_DLL_EXPORT DBFHandle msDBFOpenVirtualFile(VSILFILE *fp);
+MS_DLL_EXPORT DBFHandle msDBFOpen(const char *pszDBFFile,
+                                  const char *pszAccess);
+MS_DLL_EXPORT void msDBFClose(DBFHandle hDBF);
+MS_DLL_EXPORT DBFHandle msDBFCreate(const char *pszDBFFile);
+
+MS_DLL_EXPORT int msDBFGetFieldCount(DBFHandle psDBF);
+MS_DLL_EXPORT int msDBFGetRecordCount(DBFHandle psDBF);
+MS_DLL_EXPORT int msDBFAddField(DBFHandle hDBF, const char *pszFieldName,
+                                DBFFieldType eType, int nWidth, int nDecimals);
+
+MS_DLL_EXPORT DBFFieldType msDBFGetFieldInfo(DBFHandle psDBF, int iField,
+                                             char *pszFieldName, int *pnWidth,
+                                             int *pnDecimals);
+
+MS_DLL_EXPORT int msDBFReadIntegerAttribute(DBFHandle hDBF, int iShape,
+                                            int iField);
+MS_DLL_EXPORT double msDBFReadDoubleAttribute(DBFHandle hDBF, int iShape,
+                                              int iField);
+MS_DLL_EXPORT const char *msDBFReadStringAttribute(DBFHandle hDBF, int iShape,
+                                                   int iField);
+
+MS_DLL_EXPORT int msDBFWriteIntegerAttribute(DBFHandle hDBF, int iShape,
+                                             int iField, int nFieldValue);
+MS_DLL_EXPORT int msDBFWriteDoubleAttribute(DBFHandle hDBF, int iShape,
+                                            int iField, double dFieldValue);
+MS_DLL_EXPORT int msDBFWriteStringAttribute(DBFHandle hDBF, int iShape,
+                                            int iField,
+                                            const char *pszFieldValue);
+
+MS_DLL_EXPORT char **msDBFGetItems(DBFHandle dbffile);
+MS_DLL_EXPORT char **msDBFGetValues(DBFHandle dbffile, int record);
+MS_DLL_EXPORT char **msDBFGetValueList(DBFHandle dbffile, int record,
+                                       int *itemindexes, int numitems);
+MS_DLL_EXPORT int *msDBFGetItemIndexes(DBFHandle dbffile, char **items,
+                                       int numitems);
+MS_DLL_EXPORT int msDBFGetItemIndex(DBFHandle dbffile, char *name);
+
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPSHAPE_H */
diff -pruN 8.0.1-5/src/mapsmoothing.c 8.2.0~beta1-1~exp1/src/mapsmoothing.c
--- 8.0.1-5/src/mapsmoothing.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapsmoothing.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,293 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  RFC94 Shape smoothing
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ * Author:   Daniel Morissette (dmorissette@mapgears.com)
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+
+#define FP_EPSILON 1e-12
+#define FP_EQ(a, b) (fabs((a) - (b)) < FP_EPSILON)
+
+/* Internal Use, represent a line window (points) */
+typedef struct {
+  int pos; /* current point position in line */
+  int size;
+  int index; /* index of the current point in points array */
+  lineObj *line;
+  int lineIsRing; /* closed ring? */
+  pointObj **points;
+} lineWindow;
+
+static void initLineWindow(lineWindow *lw, lineObj *line, int size) {
+  lw->pos = -1;
+  lw->lineIsRing = MS_FALSE;
+  lw->size = size;
+  lw->line = line;
+  lw->index =
+      floor(lw->size / 2); /* index of current position in points array */
+  lw->points = (pointObj **)msSmallMalloc(sizeof(pointObj *) * size);
+
+  if ((line->numpoints >= 2) &&
+      ((FP_EQ(line->point[0].x, line->point[line->numpoints - 1].x)) &&
+       (FP_EQ(line->point[0].y, line->point[line->numpoints - 1].y)))) {
+    lw->lineIsRing = 1;
+  }
+}
+
+static void freeLineWindow(lineWindow *lw) { free(lw->points); }
+
+static int nextLineWindow(lineWindow *lw) {
+  int i;
+
+  if (++lw->pos >= lw->line->numpoints)
+    return MS_DONE;
+
+  lw->points[lw->index] = &lw->line->point[lw->pos];
+
+  for (i = 0; i < lw->index; ++i) {
+    int r, l;
+    r = lw->pos - (i + 1);
+    l = lw->pos + (i + 1);
+
+    /* adjust values */
+    if ((r < 0) && lw->lineIsRing)
+      r = lw->line->numpoints - (i + 2);
+    if ((l >= lw->line->numpoints) && lw->lineIsRing)
+      l = 1 + (l - lw->line->numpoints);
+
+    /* return if the window in not valid.. */
+    if (r < 0 || l >= lw->line->numpoints)
+      return MS_FALSE;
+
+    lw->points[lw->index - (i + 1)] = &lw->line->point[r];
+    lw->points[lw->index + (i + 1)] = &lw->line->point[l];
+  }
+
+  return MS_TRUE;
+}
+
+/* Calculates the distance ratio between the total distance of a path and the
+   distance between the first and last point (to detect a loop). */
+static double computePathDistanceRatio(pointObj **points, int len) {
+  double sum;
+  int i;
+
+  for (sum = 0, i = 1; i < len; ++i) {
+    sum += msDistancePointToPoint(points[i - 1], points[i]);
+  }
+
+  return sum / msDistancePointToPoint(points[0], points[len - 1]);
+}
+
+/* Pre-Processing of a shape. It modifies the shape by adding intermediate
+   points where a loop is detected to improve the smoothing result. */
+static int processShapePathDistance(shapeObj *shape, int force) {
+  shapeObj initialShape, *newShape;
+  int i;
+
+  /* initial shape to process */
+  msInitShape(&initialShape);
+  msCopyShape(shape, &initialShape);
+
+  newShape = shape; /* we modify the shape object directly */
+  shape = &initialShape;
+
+  /* Clean our shape object */
+  for (i = 0; i < newShape->numlines; i++)
+    free(newShape->line[i].point);
+  newShape->numlines = 0;
+  if (newShape->line)
+    free(newShape->line);
+
+  for (i = 0; i < shape->numlines; ++i) {
+    const int windowSize = 5;
+    int res;
+    lineWindow lw;
+    lineObj line = {0, NULL};
+
+    initLineWindow(&lw, &shape->line[i], windowSize);
+    msAddLine(newShape, &line);
+
+    while ((res = nextLineWindow(&lw)) != MS_DONE) {
+      double ratio = 0;
+      pointObj point = {0}; // initialize
+
+      if (lw.lineIsRing && lw.pos == lw.line->numpoints - 1) {
+        point = newShape->line[i].point[0];
+        msAddPointToLine(&newShape->line[i], &point);
+        continue;
+      }
+
+      if (res == MS_FALSE) { /* invalid window */
+        msAddPointToLine(&newShape->line[i], lw.points[lw.index]);
+        continue;
+      }
+
+      if (!force)
+        ratio = computePathDistanceRatio(lw.points, windowSize);
+
+      if (force || (ratio > 1.3)) {
+        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index - 1]->x) / 2;
+        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index - 1]->y) / 2;
+        msAddPointToLine(&newShape->line[i], &point);
+      }
+
+      point = lw.line->point[lw.pos];
+      msAddPointToLine(&newShape->line[i], &point);
+
+      if (force || (ratio > 1.3)) {
+        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index + 1]->x) / 2;
+        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index + 1]->y) / 2;
+        msAddPointToLine(&newShape->line[i], &point);
+      }
+    }
+
+    freeLineWindow(&lw);
+  }
+
+  msFreeShape(shape);
+
+  return MS_SUCCESS;
+}
+
+shapeObj *msSmoothShapeSIA(shapeObj *shape, int ss, int si,
+                           char *preprocessing) {
+  int i, j;
+  pointObj *p;
+  double *coeff;
+  shapeObj *newShape;
+
+  newShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+  msInitShape(newShape);
+  newShape->type = shape->type; // preserve the type
+
+  if (ss < 3)
+    ss = 3;
+
+  if (si < 1)
+    si = 1;
+
+  /* Apply preprocessing */
+  if (preprocessing) {
+    if (strcasecmp(preprocessing, "all") == 0)
+      processShapePathDistance(shape, MS_TRUE);
+    else if (strcasecmp(preprocessing, "angle") == 0)
+      processShapePathDistance(shape, MS_FALSE);
+  }
+
+  p = (pointObj *)msSmallMalloc(ss * sizeof(pointObj));
+  coeff = (double *)msSmallMalloc(ss * sizeof(double));
+
+  for (i = 0; i < si; ++i) {
+    shapeObj initialShape;
+
+    if (si > 1 && i > 0) {
+      msInitShape(&initialShape);
+      msCopyShape(shape, &initialShape);
+
+      /* Clean our shape object */
+      for (j = 0; j < newShape->numlines; ++j)
+        free(newShape->line[j].point);
+      newShape->numlines = 0;
+      if (newShape->line) {
+        free(newShape->line);
+        newShape->line = NULL;
+      }
+
+      shape = &initialShape;
+    }
+
+    for (j = 0; j < shape->numlines; ++j) {
+      int k, ws, res;
+      lineObj newLine = {0, NULL};
+      lineWindow lw;
+
+      /* determine if we can use the ss for this line */
+      ws = ss;
+      if (ws >= shape->line[j].numpoints) {
+        ws = shape->line[j].numpoints - 1;
+      }
+
+      if (ws % 2 == 0)
+        ws -= 1;
+
+      initLineWindow(&lw, &shape->line[j], ws);
+      msAddLine(newShape, &newLine);
+
+      coeff[lw.index] = 1;
+      for (k = 0; k < lw.index; ++k) {
+        coeff[lw.index + (k + 1)] = coeff[lw.index - k] / 2;
+        coeff[lw.index - (k + 1)] = coeff[lw.index + k] / 2;
+      }
+
+      while ((res = nextLineWindow(&lw)) != MS_DONE) {
+        double sum_x = 0, sum_y = 0, sum = 0;
+        pointObj point = {0}; // initialize
+        int k = 0;
+
+        if (res == MS_FALSE) { /* invalid window */
+          msAddPointToLine(&newShape->line[j], lw.points[lw.index]);
+          continue;
+        }
+
+        /* Apply Coefficient */
+        p[lw.index] = *lw.points[lw.index];
+        for (k = 0; k < lw.index; ++k) {
+          p[lw.index - (k + 1)] = *lw.points[lw.index - (k + 1)];
+          p[lw.index - (k + 1)].x *= coeff[lw.index - (k + 1)];
+          p[lw.index - (k + 1)].y *= coeff[lw.index - (k + 1)];
+          p[lw.index + (k + 1)] = *lw.points[lw.index + (k + 1)];
+          p[lw.index + (k + 1)].x *= coeff[lw.index + (k + 1)];
+          p[lw.index + (k + 1)].y *= coeff[lw.index + (k + 1)];
+        }
+
+        for (k = 0; k < lw.size; ++k) {
+          sum += coeff[k];
+          sum_x += p[k].x;
+          sum_y += p[k].y;
+        }
+
+        point.x = sum_x / sum;
+        point.y = sum_y / sum;
+        msAddPointToLine(&newShape->line[j], &point);
+      }
+
+      freeLineWindow(&lw);
+    }
+
+    if (i > 0) {
+      msFreeShape(shape);
+      shape = newShape;
+    }
+  }
+
+  free(p);
+  free(coeff);
+
+  return newShape;
+}
diff -pruN 8.0.1-5/src/mapstring.cpp 8.2.0~beta1-1~exp1/src/mapstring.cpp
--- 8.0.1-5/src/mapstring.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapstring.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2467 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Various string handling functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ * Notes: A couple of string handling functions (strrstr, strlcat) were taken
+ *from other sources. Copyright notices accompany those functions below.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ * Copyright (c) 1998 Todd C. Miller <Todd.Miller@courtesan.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapthread.h"
+
+#include "cpl_vsi.h"
+
+#include <ctype.h>
+#include <string.h>
+#include <errno.h>
+
+#include <algorithm>
+#include <cctype>
+
+/*
+ * Find the first occurrence of find in s, ignore case.
+ */
+
+#ifdef USE_FRIBIDI
+#if (defined(_WIN32) && !defined(__CYGWIN__)) || defined(HAVE_FRIBIDI2)
+#include "fribidi.h"
+#else
+#include <fribidi/fribidi.h>
+#endif
+#define MAX_STR_LEN 65000
+#endif
+
+#ifdef USE_ICONV
+#include "mapiconv.h"
+#include <iconv.h>
+#include <wchar.h>
+#endif
+
+#include "mapentities.h"
+
+#ifndef HAVE_STRRSTR
+/*
+** Copyright (c) 2000-2004  University of Illinois Board of Trustees
+** Copyright (c) 2000-2005  Mark D. Roth
+** All rights reserved.
+**
+** Developed by: Campus Information Technologies and Educational Services,
+** University of Illinois at Urbana-Champaign
+**
+** Permission is hereby granted, free of charge, to any person obtaining
+** a copy of this software and associated documentation files (the
+** ``Software''), to deal with the Software without restriction, including
+** without limitation the rights to use, copy, modify, merge, publish,
+** distribute, sublicense, and/or sell copies of the Software, and to
+** permit persons to whom the Software is furnished to do so, subject to
+** the following conditions:
+**
+** * Redistributions of source code must retain the above copyright
+**   notice, this list of conditions and the following disclaimers.
+**
+** * Redistributions in binary form must reproduce the above copyright
+**   notice, this list of conditions and the following disclaimers in the
+**   documentation and/or other materials provided with the distribution.
+**
+** * Neither the names of Campus Information Technologies and Educational
+**   Services, University of Illinois at Urbana-Champaign, nor the names
+**   of its contributors may be used to endorse or promote products derived
+**   from this Software without specific prior written permission.
+**
+** THE SOFTWARE IS PROVIDED ``AS IS'', WITHOUT WARRANTY OF ANY KIND,
+** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+** MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+** IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
+** ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+** TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
+** OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
+*/
+char *strrstr(const char *string, const char *find) {
+  size_t stringlen, findlen;
+  const char *cp;
+
+  findlen = strlen(find);
+  stringlen = strlen(string);
+  if (findlen > stringlen)
+    return NULL;
+
+  for (cp = string + stringlen - findlen; cp >= string; cp--)
+    if (strncmp(cp, find, findlen) == 0)
+      return (char *)cp;
+
+  return NULL;
+}
+#endif
+
+#ifndef HAVE_STRLCAT
+/*
+ * Copyright (c) 1998 Todd C. Miller <Todd.Miller@courtesan.com>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+/*
+ * Appends src to string dst of size siz (unlike strncat, siz is the
+ * full size of dst, not space left).  At most siz-1 characters
+ * will be copied.  Always NUL terminates (unless siz <= strlen(dst)).
+ * Returns strlen(src) + MS_MIN(siz, strlen(initial dst)).
+ * If retval >= siz, truncation occurred.
+ */
+size_t strlcat(char *dst, const char *src, size_t siz) {
+  char *d = dst;
+  const char *s = src;
+  size_t n = siz;
+  size_t dlen;
+
+  /* Find the end of dst and adjust bytes left but don't go past end */
+  while (n-- != 0 && *d != '\0')
+    d++;
+  dlen = d - dst;
+  n = siz - dlen;
+
+  if (n == 0)
+    return (dlen + strlen(s));
+  while (*s != '\0') {
+    if (n != 1) {
+      *d++ = *s;
+      n--;
+    }
+    s++;
+  }
+  *d = '\0';
+
+  return (dlen + (s - src)); /* count does not include NUL */
+}
+#endif
+
+#ifndef HAVE_STRLCPY
+/*
+ * Copyright (c) 1998 Todd C. Miller <Todd.Miller@courtesan.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
+ * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
+ * THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+ * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+ * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+ * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+ * Copy src to string dst of size siz.  At most siz-1 characters
+ * will be copied.  Always NUL terminates (unless siz == 0).
+ * Returns strlen(src); if retval >= siz, truncation occurred.
+ */
+size_t strlcpy(char *dst, const char *src, size_t siz) {
+  char *d = dst;
+  const char *s = src;
+  size_t n = siz;
+
+  /* Copy as many bytes as will fit */
+  if (n != 0 && --n != 0) {
+    do {
+      if ((*d++ = *s++) == 0)
+        break;
+    } while (--n != 0);
+  }
+
+  /* Not enough room in dst, add NUL and traverse rest of src */
+  if (n == 0) {
+    if (siz != 0)
+      *d = '\0'; /* NUL-terminate dst */
+    while (*s++)
+      ;
+  }
+
+  return (s - src - 1); /* count does not include NUL */
+}
+#endif
+
+#ifndef HAVE_STRCASESTR
+/*-
+ * Copyright (c) 1990, 1993
+ *  The Regents of the University of California.  All rights reserved.
+ *
+ * This code is derived from software contributed to Berkeley by
+ * Chris Torek.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+char *strcasestr(const char *s, const char *find) {
+  char c, sc;
+  size_t len;
+
+  if ((c = *find++) != 0) {
+    c = tolower((unsigned char)c);
+    len = strlen(find);
+    do {
+      do {
+        if ((sc = *s++) == 0)
+          return (NULL);
+      } while ((char)tolower((unsigned char)sc) != c);
+    } while (strncasecmp(s, find, len) != 0);
+    s--;
+  }
+  return ((char *)s);
+}
+#endif
+
+#ifndef HAVE_STRNCASECMP
+int strncasecmp(const char *s1, const char *s2, size_t len) {
+  const char *cp1, *cp2;
+
+  cp1 = s1;
+  cp2 = s2;
+
+  if (len == 0)
+    return (0);
+
+  if (!*cp1)
+    return -1;
+  else if (!*cp2)
+    return 1;
+
+  while (*cp1 && *cp2 && len) {
+    int cmp;
+    if ((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
+      return (cmp);
+    cp1++;
+    cp2++;
+    len--;
+  }
+
+  if (len == 0) {
+    return (0);
+  }
+  if (*cp1 || *cp2) {
+    if (*cp1)
+      return (1);
+    else
+      return (-1);
+  }
+  return (0);
+}
+#endif
+
+#ifndef HAVE_STRCASECMP
+int strcasecmp(const char *s1, const char *s2) {
+  const char *cp1, *cp2;
+
+  cp1 = s1;
+  cp2 = s2;
+  if ((!cp1) || (!cp2)) {
+    return (0);
+  }
+  while (*cp1 && *cp2) {
+    int cmp;
+    if ((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
+      return (cmp);
+    cp1++;
+    cp2++;
+  }
+  if (*cp1 || *cp2) {
+    if (*cp1)
+      return (1);
+    else
+      return (-1);
+  }
+
+  return (0);
+}
+#endif
+
+/*
+** msStringToInt() and msStringToDouble() are helper functions to convert
+*strings to numbers. They
+** return MS_FAILURE if the input string is NULL or if the entire string did not
+*convert successfully.
+*/
+int msStringToInt(const char *str, int *value, int base) {
+  char *parse_check = NULL;
+
+  if (!str)
+    return MS_FAILURE;
+
+  *value = (int)strtol(str, &parse_check, base);
+  if (*parse_check != '\0')
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+int msStringToDouble(const char *str, double *value) {
+  char *parse_check = NULL;
+
+  if (!str)
+    return MS_FAILURE;
+
+  *value = strtod(str, &parse_check);
+  if (*parse_check != '\0')
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+char *msLongToString(long value) {
+  size_t bufferSize = 256;
+  char *buffer = (char *)msSmallMalloc(bufferSize);
+
+  snprintf(buffer, bufferSize, "%ld", value);
+  return (buffer);
+}
+
+char *msDoubleToString(double value, int force_f) {
+  size_t bufferSize = 256;
+  char *buffer = (char *)msSmallMalloc(bufferSize);
+
+  if (force_f == MS_TRUE)
+    snprintf(buffer, bufferSize, "%f", value);
+  else
+    snprintf(buffer, bufferSize, "%g", value);
+  return (buffer);
+}
+
+char *msIntToString(int value) {
+  size_t bufferSize = 256;
+  char *buffer = (char *)msSmallMalloc(bufferSize);
+
+  snprintf(buffer, bufferSize, "%i", value);
+  return (buffer);
+}
+
+void msStringToUpper(char *string) {
+  int i;
+
+  if (string != NULL) {
+    for (i = 0; string[i]; i++) {
+      string[i] = toupper(string[i]);
+    }
+    return;
+  }
+}
+
+void msStringToLower(char *string) {
+  int i;
+
+  if (string != NULL) {
+    for (i = 0; string[i]; i++) {
+      string[i] = tolower(string[i]);
+    }
+    return;
+  }
+}
+
+std::string msStringToLower(const std::string &s) {
+  std::string ret(s);
+  std::transform(ret.begin(), ret.end(), ret.begin(),
+                 [](unsigned char c) { return std::tolower(c); });
+  return ret;
+}
+
+/**
+ * Force the first character to uppercase and the rest of the characters to
+ * lower case for EACH word in the string.
+ */
+void msStringInitCap(char *string) {
+  int i;
+  int start = 1;
+  if (string != NULL) {
+    for (i = 0; i < (int)strlen(string); i++) {
+      if (string[i] == ' ')
+        start = 1;
+      else if (start) {
+        string[i] = toupper(string[i]);
+        start = 0;
+      } else {
+        string[i] = tolower(string[i]);
+      }
+    }
+  }
+}
+
+/**
+ * Force the first character to uppercase for the FIRST word in the string
+ * and the rest of the characters to lower case.
+ */
+void msStringFirstCap(char *string) {
+  int i;
+  int start = 1;
+  if (string != NULL) {
+    for (i = 0; i < (int)strlen(string); i++) {
+      if (string[i] != ' ') {
+        if (start) {
+          string[i] = toupper(string[i]);
+          start = 0;
+        } else
+          string[i] = tolower(string[i]);
+      }
+    }
+  }
+}
+
+char *msStringChop(char *string) {
+  int n;
+
+  n = strlen(string);
+  if (n > 0)
+    string[n - 1] = '\0';
+
+  return (string);
+}
+
+/*
+** Trim leading and trailing white space.
+*/
+void msStringTrim(char *str) {
+  int i;
+
+  /* Send nulls home without supper. */
+  if (!str)
+    return;
+
+  /* Move non-white string to the front. */
+  i = strspn(str, " ");
+  if (i) {
+    memmove(str, str + i, strlen(str) - i + 1);
+  }
+  /* Nothing left? Exit. */
+  if (strlen(str) == 0) {
+    return;
+  }
+  /* Null-terminate end of non-white string. */
+  for (i = strlen(str) - 1; i >= 0; i--) { /* step backwards from end */
+    if (str[i] != ' ') {
+      str[i + 1] = '\0';
+      return;
+    }
+  }
+  return;
+}
+
+void msStringTrim(std::string &string) {
+  const size_t npos = string.find_first_not_of(' ');
+  if (npos != std::string::npos)
+    string.erase(0, npos);
+  msStringTrimBlanks(string);
+}
+
+/*
+** Remove leading white spaces and shift everything to the left.
+*/
+char *msStringTrimLeft(char *string) {
+  char *read, *write;
+  int i, length;
+
+  if (string && strlen(string) > 0) {
+    length = strlen(string);
+    read = string;
+    write = string;
+
+    for (i = 0; i < length; i++) {
+      if (isspace(string[i]))
+        read++;
+      else
+        break;
+    }
+
+    if (read > write) {
+      while (*read) {
+        *write = *read;
+        read++;
+        write++;
+      }
+      *write = '\0';
+    }
+  }
+  return string;
+}
+
+void msStringTrimLeft(std::string &string) {
+  const size_t length = string.length();
+  for (size_t i = 0; i < length; i++) {
+    if (!isspace(string[i])) {
+      if (i > 0) {
+        string.erase(0, i - 1);
+      }
+      return;
+    }
+  }
+  string.clear();
+}
+
+/* -------------------------------------------------------------------------------
+ */
+/*       Trims trailing blanks from a string */
+/* -------------------------------------------------------------------------------
+ */
+void msStringTrimBlanks(char *string) {
+  int i, n;
+
+  n = strlen(string);
+  for (i = n - 1; i >= 0; i--) { /* step backwards through the string */
+    if (string[i] != ' ') {
+      string[i + 1] = '\0';
+      return;
+    }
+  }
+}
+
+void msStringTrimBlanks(std::string &string) {
+  const size_t npos = string.find_last_not_of(' ');
+  if (npos != std::string::npos)
+    string.resize(npos + 1);
+}
+
+/* -------------------------------------------------------------------------------
+ */
+/*       Trims end-of-line marker from a string */
+/*       Usefull in conjunction with fgets() calls */
+/* -------------------------------------------------------------------------------
+ */
+void msStringTrimEOL(char *string) {
+  int i;
+
+  for (i = 0; string[i] != '\0'; i++) {
+    if (string[i] == '\n') {
+      string[i] = '\0'; /* Terminate the string at the newline */
+      return;
+    }
+  }
+}
+
+/* -------------------------------------------------------------------------------
+ */
+/*       Replace all occurances of old with new in str. */
+/*       It is assumed that str was dynamically created using malloc. */
+/* -------------------------------------------------------------------------------
+ */
+char *msReplaceSubstring(char *str, const char *old, const char *newstr) {
+  size_t str_len, old_len, new_len, tmp_offset;
+  char *tmp_ptr;
+
+  if (newstr == NULL)
+    newstr = "";
+
+  /*
+  ** If old is not found then leave str alone
+  */
+  if ((tmp_ptr = strstr(str, old)) == NULL)
+    return (str);
+
+  /*
+  ** Grab some info about incoming strings
+  */
+  str_len = strlen(str);
+  old_len = strlen(old);
+  new_len = strlen(newstr);
+
+  /*
+  ** Now loop until old is NOT found in new
+  */
+  while (tmp_ptr != NULL) {
+
+    /*
+    ** re-allocate memory for buf assuming 1 replacement of old with new
+    ** don't bother reallocating if old is larger than new)
+    */
+    if (old_len < new_len) {
+      tmp_offset = tmp_ptr - str;
+      str_len = str_len - old_len + new_len;
+      str = (char *)msSmallRealloc(
+          str, (str_len + 1)); /* make new space for a copy */
+      tmp_ptr = str + tmp_offset;
+    }
+
+    /*
+    ** Move the trailing part of str to make some room unless old_len == new_len
+    */
+    if (old_len != new_len) {
+      memmove(tmp_ptr + new_len, tmp_ptr + old_len,
+              strlen(tmp_ptr) - old_len + 1);
+    }
+
+    /*
+    ** Now copy new over old
+    */
+    memcpy(tmp_ptr, newstr, new_len);
+
+    /*
+    ** And look for more matches in the rest of the string
+    */
+    tmp_ptr = strstr(tmp_ptr + new_len, old);
+  }
+
+  return (str);
+}
+
+/*
+ * same goal as msReplaceSubstring, but for the known case
+ * when we won't have to do reallocs etc
+ * used to replace the wrap characetr by a newline for labels
+ */
+void msReplaceChar(char *str, char old, char newstr) {
+  while (*(str++))
+    if (*str == old)
+      *str = newstr;
+}
+
+/*
+** how many times does ch occur in str
+*/
+int msCountChars(char *str, char ch) {
+  int i, l, n = 0;
+
+  l = strlen(str);
+  for (i = 0; i < l; i++)
+    if (str[i] == ch)
+      n++;
+
+  return (n);
+}
+
+/* -------------------------------------------------------------------------------
+ */
+/*       Strip filename from a full path */
+/* -------------------------------------------------------------------------------
+ */
+char *msStripPath(char *fn) {
+  char *pSlash;
+  char *pBackslash;
+
+  /* try to locate both, the last slash or backslash */
+  pSlash = strrchr(fn, '/');
+  pBackslash = strrchr(fn, '\\');
+
+  if (pSlash != NULL && pBackslash != NULL) {
+    if (pSlash < pBackslash)
+      return ++pBackslash;
+    else
+      return ++pSlash;
+  } else if (pSlash != NULL)
+    return ++pSlash; /* skip past the "slash" */
+  else if (pBackslash != NULL)
+    return ++pBackslash; /* skip past the "backslash" */
+  else
+    return (fn);
+}
+
+/*
+** Returns the *path* portion of the filename fn. Memory is allocated using
+*malloc.
+*/
+char *msGetPath(const char *fn) {
+  char *str;
+  int i, length;
+
+  length = strlen(fn);
+  if ((str = msStrdup(fn)) == NULL)
+    return (NULL);
+
+  for (i = length - 1; i >= 0; i--) { /* step backwards through the string */
+    if ((str[i] == '/') || (str[i] == '\\')) {
+      str[i + 1] = '\0';
+      break;
+    }
+  }
+
+  if (strcmp(str, fn) == 0) {
+    msFree(str);
+#if defined(_WIN32) && !defined(__CYGWIN__)
+    str = msStrdup(".\\");
+#else
+    str = msStrdup("./");
+#endif
+  }
+
+  return (str);
+}
+
+/*
+** Returns a *path* built from abs_path and path.
+** The pszReturnPath must be declared by the caller function as an array
+** of MS_MAXPATHLEN char
+*/
+char *msBuildPath(char *pszReturnPath, const char *abs_path, const char *path) {
+  int abslen = 0;
+  int pathlen = 0;
+
+  if (path == NULL) {
+    msSetError(MS_IOERR, NULL, "msBuildPath");
+    return NULL;
+  }
+
+  pathlen = strlen(path);
+  if (abs_path)
+    abslen = strlen(abs_path);
+
+  if ((pathlen + abslen + 2) > MS_MAXPATHLEN) {
+    msSetError(MS_IOERR, "Path is too long.  Check server logs.",
+               "msBuildPath()");
+    msDebug("msBuildPath(): (%s%s): path is too long.\n", abs_path, path);
+    return NULL;
+  }
+
+  /* Check if path is absolute */
+  if ((abs_path == NULL) || (abslen == 0) || (path[0] == '\\') ||
+      (path[0] == '/') || (pathlen > 1 && (path[1] == ':'))) {
+    strlcpy(pszReturnPath, path, MS_MAXPATHLEN);
+    return (pszReturnPath);
+  }
+
+  /* else return abs_path/path */
+  if ((abs_path[abslen - 1] == '/') || (abs_path[abslen - 1] == '\\')) {
+    snprintf(pszReturnPath, MS_MAXPATHLEN, "%s%s", abs_path, path);
+  } else {
+    snprintf(pszReturnPath, MS_MAXPATHLEN, "%s/%s", abs_path, path);
+  }
+
+  return (pszReturnPath);
+}
+
+/*
+** Returns a *path* built from abs_path, path1 and path2.
+** abs_path/path1/path2
+** The pszReturnPath must be declared by the caller function as an array
+** of MS_MAXPATHLEN char
+*/
+char *msBuildPath3(char *pszReturnPath, const char *abs_path, const char *path1,
+                   const char *path2) {
+  char szPath[MS_MAXPATHLEN];
+
+  return msBuildPath(pszReturnPath, abs_path,
+                     msBuildPath(szPath, path1, path2));
+}
+
+/*
+** Similar to msBuildPath(), but the input path is only qualified by the
+** absolute path if this will result in it pointing to a readable file.
+**
+** Returns NULL if the resulting path doesn't point to a readable file.
+*/
+
+char *msTryBuildPath(char *szReturnPath, const char *abs_path, const char *path)
+
+{
+  VSILFILE *fp;
+
+  if (msBuildPath(szReturnPath, abs_path, path) == NULL)
+    return NULL;
+
+  fp = VSIFOpenL(szReturnPath, "r");
+  if (fp == NULL) {
+    strlcpy(szReturnPath, path, MS_MAXPATHLEN);
+    return NULL;
+  } else
+    VSIFCloseL(fp);
+
+  return szReturnPath;
+}
+
+/*
+** Similar to msBuildPath3(), but the input path is only qualified by the
+** absolute path if this will result in it pointing to a readable file.
+**
+** Returns NULL if the resulting path doesn't point to a readable file.
+*/
+
+char *msTryBuildPath3(char *szReturnPath, const char *abs_path,
+                      const char *path1, const char *path2)
+
+{
+  VSILFILE *fp;
+
+  if (msBuildPath3(szReturnPath, abs_path, path1, path2) == NULL)
+    return NULL;
+
+  fp = VSIFOpenL(szReturnPath, "r");
+  if (fp == NULL) {
+    strlcpy(szReturnPath, path2, MS_MAXPATHLEN);
+    return NULL;
+  } else
+    VSIFCloseL(fp);
+
+  return szReturnPath;
+}
+
+/*
+** Splits a string into multiple strings based on ch. Consecutive ch's are
+*ignored.
+*/
+char **msStringSplit(const char *string, char ch, int *num_tokens) {
+  int i, j, k;
+  int length, n;
+  char **token;
+  char last_ch = '\0';
+
+  n = 1; /* always at least 1 token, the string itself */
+  length = strlen(string);
+  for (i = 0; i < length; i++) {
+    if (string[i] == ch && last_ch != ch)
+      n++;
+    last_ch = string[i];
+  }
+
+  token = (char **)msSmallMalloc(sizeof(char *) * n);
+
+  k = 0;
+  token[k] = (char *)msSmallMalloc(sizeof(char) * (length + 1));
+
+  j = 0;
+  last_ch = '\0';
+  for (i = 0; i < length; i++) {
+    if (string[i] == ch) {
+
+      if (last_ch == ch)
+        continue;
+
+      token[k][j] = '\0'; /* terminate current token */
+
+      k++;
+      token[k] = (char *)msSmallMalloc(sizeof(char) * (length + 1));
+
+      j = 0;
+    } else {
+      token[k][j] = string[i];
+      j++;
+    }
+
+    last_ch = string[i];
+  }
+
+  token[k][j] = '\0'; /* terminate last token */
+
+  *num_tokens = n;
+
+  return (token);
+}
+
+std::vector<std::string> msStringSplit(const char *string, char ch) {
+  int num_tokens = 0;
+  char **tmp = msStringSplit(string, ch, &num_tokens);
+  std::vector<std::string> res;
+  res.reserve(num_tokens);
+  for (int i = 0; i < num_tokens; i++)
+    res.push_back(tmp[i]);
+  msFreeCharArray(tmp, num_tokens);
+  return res;
+}
+
+/*
+ This function is a copy of CSLTokenizeString2() function of the CPL component.
+ See the port/cpl_string.cpp file in gdal source for the complete documentation.
+ Available Flags:
+ * - MS_ALLOWEMPTYTOKENS: allow the return of empty tokens when two
+ * delimiters in a row occur with no other text between them.  If not set,
+ * empty tokens will be discarded;
+ * - MS_STRIPLEADSPACES: strip leading space characters from the token (as
+ * reported by isspace());
+ * - MS_STRIPENDSPACES: strip ending space characters from the token (as
+ * reported by isspace());
+ * - MS_HONOURSTRINGS: double quotes can be used to hold values that should
+ * not be broken into multiple tokens;
+ * - MS_PRESERVEQUOTES: string quotes are carried into the tokens when this
+ * is set, otherwise they are removed;
+ * - MS_PRESERVEESCAPES: if set backslash escapes (for backslash itself,
+ * and for literal double quotes) will be preserved in the tokens, otherwise
+ * the backslashes will be removed in processing.
+ */
+char **msStringSplitComplex(const char *pszString, const char *pszDelimiters,
+                            int *num_tokens, int nFlags)
+
+{
+  char **papszRetList = NULL;
+  int nRetMax = 0, nRetLen = 0;
+  char *pszToken;
+  int nTokenMax, nTokenLen;
+  int bHonourStrings = (nFlags & MS_HONOURSTRINGS);
+  int bAllowEmptyTokens = (nFlags & MS_ALLOWEMPTYTOKENS);
+  int bStripLeadSpaces = (nFlags & MS_STRIPLEADSPACES);
+  int bStripEndSpaces = (nFlags & MS_STRIPENDSPACES);
+
+  pszToken = (char *)msSmallMalloc(sizeof(char) * 10);
+  ;
+  nTokenMax = 10;
+
+  while (pszString != NULL && *pszString != '\0') {
+    int bInString = MS_FALSE;
+    int bStartString = MS_TRUE;
+
+    nTokenLen = 0;
+
+    /* Try to find the next delimeter, marking end of token */
+    for (; *pszString != '\0'; pszString++) {
+
+      /* End if this is a delimeter skip it and break. */
+      if (!bInString && strchr(pszDelimiters, *pszString) != NULL) {
+        pszString++;
+        break;
+      }
+
+      /* If this is a quote, and we are honouring constant
+         strings, then process the constant strings, with out delim
+         but don't copy over the quotes */
+      if (bHonourStrings && *pszString == '"') {
+        if (nFlags & MS_PRESERVEQUOTES) {
+          pszToken[nTokenLen] = *pszString;
+          nTokenLen++;
+        }
+
+        if (bInString) {
+          bInString = MS_FALSE;
+          continue;
+        } else {
+          bInString = MS_TRUE;
+          continue;
+        }
+      }
+
+      /*
+       * Within string constants we allow for escaped quotes, but in
+       * processing them we will unescape the quotes and \\ sequence
+       * reduces to \
+       */
+      if (bInString && pszString[0] == '\\') {
+        if (pszString[1] == '"' || pszString[1] == '\\') {
+          if (nFlags & MS_PRESERVEESCAPES) {
+            pszToken[nTokenLen] = *pszString;
+            nTokenLen++;
+          }
+
+          pszString++;
+        }
+      }
+
+      /*
+       * Strip spaces at the token start if requested.
+       */
+      if (!bInString && bStripLeadSpaces && bStartString &&
+          isspace((unsigned char)*pszString))
+        continue;
+
+      bStartString = MS_FALSE;
+
+      /*
+       * Extend token buffer if we are running close to its end.
+       */
+      if (nTokenLen >= nTokenMax - 3) {
+        nTokenMax = nTokenMax * 2 + 10;
+        pszToken = (char *)msSmallRealloc(pszToken, sizeof(char) * nTokenMax);
+      }
+
+      pszToken[nTokenLen] = *pszString;
+      nTokenLen++;
+    }
+
+    /*
+     * Strip spaces at the token end if requested.
+     */
+    if (!bInString && bStripEndSpaces) {
+      while (nTokenLen && isspace((unsigned char)pszToken[nTokenLen - 1]))
+        nTokenLen--;
+    }
+
+    pszToken[nTokenLen] = '\0';
+
+    /*
+     * Add the token.
+     */
+    if (pszToken[0] != '\0' || bAllowEmptyTokens) {
+      if (nRetLen >= nRetMax - 1) {
+        nRetMax = nRetMax * 2 + 10;
+        papszRetList =
+            (char **)msSmallRealloc(papszRetList, sizeof(char *) * nRetMax);
+      }
+
+      papszRetList[nRetLen++] = msStrdup(pszToken);
+      papszRetList[nRetLen] = NULL;
+    }
+  }
+
+  /*
+   * If the last token was empty, then we need to capture
+   * it now, as the loop would skip it.
+   */
+  if (pszString != NULL && *pszString == '\0' && bAllowEmptyTokens &&
+      nRetLen > 0 && strchr(pszDelimiters, *(pszString - 1)) != NULL) {
+    if (nRetLen >= nRetMax - 1) {
+      nRetMax = nRetMax * 2 + 10;
+      papszRetList =
+          (char **)msSmallRealloc(papszRetList, sizeof(char *) * nRetMax);
+    }
+
+    papszRetList[nRetLen++] = msStrdup("");
+    papszRetList[nRetLen] = NULL;
+  }
+
+  if (papszRetList == NULL)
+    papszRetList = (char **)msSmallMalloc(sizeof(char *) * 1);
+
+  *num_tokens = nRetLen;
+  free(pszToken);
+
+  return papszRetList;
+}
+
+/* This method is similar to msStringSplit but support quoted strings.
+   It also support multi-characters delimiter and allows to preserve quotes */
+char **msStringTokenize(const char *pszLine, const char *pszDelim,
+                        int *num_tokens, int preserve_quote) {
+  char **papszResult = NULL;
+  int n = 1, iChar, nLength = strlen(pszLine), iTokenChar = 0,
+      bInQuotes = MS_FALSE;
+  char *pszToken = (char *)msSmallMalloc(sizeof(char) * (nLength + 1));
+  int nDelimLen = strlen(pszDelim);
+
+  /* Compute the number of tokens */
+  for (iChar = 0; pszLine[iChar] != '\0'; iChar++) {
+    if (bInQuotes && pszLine[iChar] == '"' && pszLine[iChar + 1] == '"') {
+      iChar++;
+    } else if (pszLine[iChar] == '"') {
+      bInQuotes = !bInQuotes;
+    } else if (!bInQuotes &&
+               strncmp(pszLine + iChar, pszDelim, nDelimLen) == 0) {
+      iChar += nDelimLen - 1;
+      n++;
+    }
+  }
+
+  papszResult = (char **)msSmallMalloc(sizeof(char *) * n);
+  n = iTokenChar = bInQuotes = 0;
+  for (iChar = 0; pszLine[iChar] != '\0'; iChar++) {
+    if (bInQuotes && pszLine[iChar] == '"' && pszLine[iChar + 1] == '"') {
+      if (preserve_quote == MS_TRUE)
+        pszToken[iTokenChar++] = '"';
+      pszToken[iTokenChar++] = '"';
+      iChar++;
+    } else if (pszLine[iChar] == '"') {
+      if (preserve_quote == MS_TRUE)
+        pszToken[iTokenChar++] = '"';
+      bInQuotes = !bInQuotes;
+    } else if (!bInQuotes &&
+               strncmp(pszLine + iChar, pszDelim, nDelimLen) == 0) {
+      pszToken[iTokenChar++] = '\0';
+      papszResult[n] = pszToken;
+      pszToken = (char *)msSmallMalloc(sizeof(char) * (nLength + 1));
+      iChar += nDelimLen - 1;
+      iTokenChar = 0;
+      n++;
+    } else {
+      pszToken[iTokenChar++] = pszLine[iChar];
+    }
+  }
+
+  pszToken[iTokenChar++] = '\0';
+  papszResult[n] = pszToken;
+
+  *num_tokens = n + 1;
+
+  return papszResult;
+}
+
+/**********************************************************************
+ *                       msEncodeChar()
+ *
+ * Return 1 if the character argument should be encoded for safety
+ * in URL use and 0 otherwise. Specific character map taken from
+ * http://www.ietf.org/rfc/rfc2396.txt
+ *
+ **********************************************************************/
+
+int msEncodeChar(const char c) {
+  if ((c >= 0x61 && c <= 0x7A) || /* Letters a-z */
+      (c >= 0x41 && c <= 0x5A) || /* Letters A-Z */
+      (c >= 0x30 && c <= 0x39) || /* Numbers 0-9 */
+      (c >= 0x27 && c <= 0x2A) || /* * ' ( )     */
+      (c >= 0x2D && c <= 0x2E) || /* - .         */
+      (c == 0x5F) ||              /* _           */
+      (c == 0x21) ||              /* !           */
+      (c == 0x7E)) {              /* ~           */
+    return (0);
+  } else {
+    return (1);
+  }
+}
+
+char *msEncodeUrl(const char *data) {
+  /*
+   * Delegate to msEncodeUrlExcept, with a null second argument
+   * to render the except handling moot.
+   */
+  return (msEncodeUrlExcept(data, '\0'));
+}
+
+/**********************************************************************
+ *                       msEncodeCharExcept()
+ *
+ * URL encoding, applies RFP2396 encoding to all characters
+ * except the one exception character. An exception character
+ * of '\0' implies no exception handling.
+ *
+ **********************************************************************/
+
+char *msEncodeUrlExcept(const char *data, const char except) {
+  static const char *hex = "0123456789ABCDEF";
+  const char *i;
+  char *j, *code;
+  int inc;
+  unsigned char ch;
+
+  for (inc = 0, i = data; *i != '\0'; i++)
+    if (msEncodeChar(*i))
+      inc += 2;
+
+  code = (char *)msSmallMalloc(strlen(data) + inc + 1);
+
+  for (j = code, i = data; *i != '\0'; i++, j++) {
+    if (except != '\0' && *i == except) {
+      *j = except;
+    } else if (msEncodeChar(*i)) {
+      ch = *i;
+      *j++ = '%';
+      *j++ = hex[ch / 16];
+      *j = hex[ch % 16];
+    } else
+      *j = *i;
+  }
+  *j = '\0';
+
+  return code;
+}
+
+/************************************************************************/
+/*                            msEscapeJSonString()                      */
+/************************************************************************/
+
+/* The input (and output) string are not supposed to start/end with double */
+/* quote characters. It is the responsibility of the caller to do that. */
+char *msEscapeJSonString(const char *pszJSonString) {
+  /* Worst case is one character to become \uABCD so 6 characters */
+  char *pszRet;
+  int i = 0, j = 0;
+  static const char *pszHex = "0123456789ABCDEF";
+
+  pszRet = (char *)msSmallMalloc(strlen(pszJSonString) * 6 + 1);
+  /* From http://www.json.org/ */
+  for (i = 0; pszJSonString[i] != '\0'; i++) {
+    unsigned char ch = pszJSonString[i];
+    if (ch == '\b') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'b';
+    } else if (ch == '\f') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'f';
+    } else if (ch == '\n') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'n';
+    } else if (ch == '\r') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'r';
+    } else if (ch == '\t') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 't';
+    } else if (ch < 32) {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'u';
+      pszRet[j++] = '0';
+      pszRet[j++] = '0';
+      pszRet[j++] = pszHex[ch / 16];
+      pszRet[j++] = pszHex[ch % 16];
+    } else if (ch == '"') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = '"';
+    } else if (ch == '\\') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = '\\';
+    } else {
+      pszRet[j++] = ch;
+    }
+  }
+  pszRet[j] = '\0';
+  return pszRet;
+}
+
+/* msEncodeHTMLEntities()
+**
+** Return a copy of string after replacing some problematic chars with their
+** HTML entity equivalents.
+**
+** The replacements performed are:
+**  '&' -> "&amp;", '"' -> "&quot;", '<' -> "&lt;" and '>' -> "&gt;"
+**/
+char *msEncodeHTMLEntities(const char *string) {
+  int buflen, i;
+  char *newstring;
+  const char *c;
+
+  if (string == NULL)
+    return NULL;
+
+  /* Start with 100 extra chars for replacements...  */
+  /* should be good enough for most cases */
+  buflen = strlen(string) + 100;
+  newstring = (char *)malloc(buflen + 1);
+  MS_CHECK_ALLOC(newstring, buflen + 1, NULL);
+
+  for (i = 0, c = string; *c != '\0'; c++) {
+    /* Need to realloc buffer? */
+    if (i + 6 > buflen) {
+      /* If we had to realloc then this string must contain several */
+      /* entities... so let's go with twice the previous buffer size */
+      buflen *= 2;
+      /* cppcheck-suppress memleakOnRealloc */
+      newstring = (char *)realloc(newstring, buflen + 1);
+      MS_CHECK_ALLOC(newstring, buflen + 1, NULL);
+    }
+
+    switch (*c) {
+    case '&':
+      strcpy(newstring + i, "&amp;");
+      i += 5;
+      break;
+    case '<':
+      strcpy(newstring + i, "&lt;");
+      i += 4;
+      break;
+    case '>':
+      strcpy(newstring + i, "&gt;");
+      i += 4;
+      break;
+    case '"':
+      strcpy(newstring + i, "&quot;");
+      i += 6;
+      break;
+    case '\'':
+      strcpy(newstring + i,
+             "&#39;"); /* changed from &apos; and i += 6 (bug 1040) */
+      i += 5;
+      break;
+    default:
+      newstring[i++] = *c;
+    }
+  }
+
+  newstring[i++] = '\0';
+
+  return newstring;
+}
+
+/* msDecodeHTMLEntities()
+**
+** Modify the string to replace encoded characters by their true value
+**
+** The replacements performed are:
+**  "&amp;" -> '&', "&quot;" -> '"', "&lt;" -> '<' and "&gt;" -> '>'
+**/
+void msDecodeHTMLEntities(const char *string) {
+  char *pszAmp = NULL, *pszSemiColon = NULL, *pszReplace = NULL, *pszEnd = NULL;
+  char *pszBuffer = NULL;
+  size_t bufferSize = 0;
+
+  if (string == NULL)
+    return;
+  else
+    pszBuffer = (char *)string;
+
+  bufferSize = strlen(pszBuffer);
+  pszReplace = (char *)msSmallMalloc(bufferSize + 1);
+  pszEnd = (char *)msSmallMalloc(bufferSize + 1);
+
+  while ((pszAmp = strchr(pszBuffer, '&')) != NULL) {
+    /* Get the &...; */
+    strlcpy(pszReplace, pszAmp, bufferSize);
+    pszSemiColon = strchr(pszReplace, ';');
+    if (pszSemiColon == NULL)
+      break;
+    else
+      pszSemiColon++;
+
+    /* Get everything after the &...; */
+    strlcpy(pszEnd, pszSemiColon, bufferSize);
+
+    pszReplace[pszSemiColon - pszReplace] = '\0';
+
+    /* Replace the &...; */
+    if (strcasecmp(pszReplace, "&amp;") == 0) {
+      pszBuffer[pszAmp - pszBuffer] = '&';
+      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
+      strcat(pszBuffer, pszEnd);
+    } else if (strcasecmp(pszReplace, "&lt;") == 0) {
+      pszBuffer[pszAmp - pszBuffer] = '<';
+      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
+      strcat(pszBuffer, pszEnd);
+    } else if (strcasecmp(pszReplace, "&gt;") == 0) {
+      pszBuffer[pszAmp - pszBuffer] = '>';
+      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
+      strcat(pszBuffer, pszEnd);
+    } else if (strcasecmp(pszReplace, "&quot;") == 0) {
+      pszBuffer[pszAmp - pszBuffer] = '"';
+      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
+      strcat(pszBuffer, pszEnd);
+    } else if (strcasecmp(pszReplace, "&apos;") == 0) {
+      pszBuffer[pszAmp - pszBuffer] = '\'';
+      pszBuffer[pszAmp - pszBuffer + 1] = '\0';
+      strcat(pszBuffer, pszEnd);
+    }
+
+    pszBuffer = pszAmp + 1;
+  }
+
+  free(pszReplace);
+  free(pszEnd);
+
+  return;
+}
+
+/*
+** msIsXMLValid
+**
+** Check if the string is an XML valid string. It should contains only
+** A-Z, a-z, 0-9, '_', '-', '.', and ':'
+** Return MS_TRUE or MS_FALSE
+*/
+int msIsXMLTagValid(const char *string) {
+  int i, nLen;
+
+  nLen = strlen(string);
+
+  for (i = 0; i < nLen; i++) {
+    if (!(string[i] >= 'A' && string[i] <= 'Z') &&
+        !(string[i] >= 'a' && string[i] <= 'z') &&
+        !(string[i] >= '0' && string[i] <= '9') && string[i] != '-' &&
+        string[i] != '.' && string[i] != ':' && string[i] != '_')
+      return MS_FALSE;
+  }
+
+  return MS_TRUE;
+}
+
+/*
+ * Concatenate pszSrc to pszDest and reallocate memory if necessary.
+ */
+char *msStringConcatenate(char *pszDest, const char *pszSrc) {
+  int nLen;
+
+  if (pszSrc == NULL)
+    return pszDest;
+
+  /* if destination is null, allocate memory */
+  if (pszDest == NULL) {
+    pszDest = msStrdup(pszSrc);
+  } else { /* if dest is not null, reallocate memory */
+    char *pszTemp;
+
+    nLen = strlen(pszDest) + strlen(pszSrc);
+
+    pszTemp = (char *)realloc(pszDest, nLen + 1);
+    if (pszTemp) {
+      pszDest = pszTemp;
+      strcat(pszDest, pszSrc);
+      pszDest[nLen] = '\0';
+    } else {
+      msSetError(MS_MEMERR, "Error while reallocating memory.",
+                 "msStringConcatenate()");
+      return NULL;
+    }
+  }
+
+  return pszDest;
+}
+
+char *msJoinStrings(char **array, int arrayLength, const char *delimeter) {
+  char *string;
+  int stringLength = 0;
+  int delimeterLength;
+  int i;
+
+  if (!array || arrayLength <= 0 || !delimeter)
+    return NULL;
+
+  delimeterLength = strlen(delimeter);
+
+  for (i = 0; i < arrayLength; i++)
+    stringLength += strlen(array[i]) + delimeterLength;
+
+  string = (char *)calloc(stringLength + 1, sizeof(char));
+  MS_CHECK_ALLOC(string, (stringLength + 1) * sizeof(char), NULL);
+  string[0] = '\0';
+
+  for (i = 0; i < arrayLength - 1; i++) {
+    strlcat(string, array[i], stringLength);
+    strlcat(string, delimeter, stringLength);
+  }
+  strlcat(string, array[i], stringLength); /* add last element, no delimiter */
+
+  return string;
+}
+
+#define HASH_SIZE 16
+/*
+ * Return a hashed string for a given input string.
+ * The caller should free the return value.
+ */
+char *msHashString(const char *pszStr) {
+  unsigned char sums[HASH_SIZE] = {0, 0, 0, 0, 0, 0, 0, 0,
+                                   0, 0, 0, 0, 0, 0, 0, 0};
+  char *pszOutBuf = NULL;
+  size_t bufferSize = 0;
+  int i = 0;
+
+  bufferSize = HASH_SIZE * 2 + 1;
+  pszOutBuf = (char *)msSmallMalloc(bufferSize);
+
+  for (i = 0; pszStr && pszStr[i]; i++) {
+    sums[i % HASH_SIZE] += (unsigned char)(pszStr[i]);
+  }
+
+  for (i = 0; i < HASH_SIZE; i++) {
+    snprintf(pszOutBuf + i * 2, bufferSize - (i * 2), "%02x", sums[i]);
+  }
+
+  return pszOutBuf;
+}
+
+char *msCommifyString(char *str) {
+  int i, j, old_length, new_length;
+  int num_commas = 0, num_decimal_points = 0;
+  int add_commas;
+
+  char comma = ',', decimal_point = '.';
+
+  if (!str)
+    return NULL;
+
+  num_decimal_points = msCountChars(str, decimal_point);
+  if (num_decimal_points > 1)
+    return str;
+
+  old_length = strlen(str);
+  if (num_decimal_points == 0) {
+    num_commas = floor((old_length - 1) / 3);
+    add_commas = 1; /* add commas right away */
+  } else {
+    num_commas =
+        floor(((old_length - strlen(strchr(str, decimal_point))) - 1) / 3);
+    add_commas = 0; /* wait until after the decimal point */
+  }
+
+  if (num_commas < 1)
+    return str; /* nothing to add */
+
+  new_length = old_length + num_commas;
+  str = (char *)msSmallRealloc(str, new_length + 1);
+  str[new_length] = '\0';
+
+  j = 0;
+  for (i = new_length - 1; i >= 0;
+       i--) { /* step backwards through the string */
+
+    if (num_decimal_points == 1 &&
+        add_commas == 0) { /* to the right of the decimal point, no commas */
+      str[i] = str[i - num_commas];
+      if (str[i] == decimal_point)
+        add_commas = 1;
+    } else if (add_commas == 1 && j > 2) { /* need a comma */
+      str[i] = comma;
+      num_commas--; /* need one fewer now */
+      j = 0;        /* reset */
+    } else {
+      str[i] = str[i - num_commas]; /* shift to the right */
+      j++;
+    }
+
+    if (num_commas == 0)
+      break; /* done, rest of string is ok "as is" */
+  }
+
+  return str;
+}
+
+/* -------------------------------------------------------------------------------
+ */
+/*       Replace all occurrences of old with new in str. */
+/*       It is assumed that str was dynamically created using malloc. */
+/*       Same function as msReplaceSubstring but this is case insensitive */
+/* -------------------------------------------------------------------------------
+ */
+char *msCaseReplaceSubstring(char *str, const char *old, const char *newstr) {
+  size_t str_len, old_len, new_len, tmp_offset;
+  char *tmp_ptr;
+
+  /*
+  ** If old is not found then leave str alone
+  */
+  if ((tmp_ptr = (char *)strcasestr(str, old)) == NULL)
+    return (str);
+
+  if (newstr == NULL)
+    newstr = "";
+
+  /*
+  ** Grab some info about incoming strings
+  */
+  str_len = strlen(str);
+  old_len = strlen(old);
+  new_len = strlen(newstr);
+
+  /*
+  ** Now loop until old is NOT found in new
+  */
+  while (tmp_ptr != NULL) {
+
+    /*
+    ** re-allocate memory for buf assuming 1 replacement of old with new
+    ** don't bother reallocating if old is larger than new)
+    */
+    if (old_len < new_len) {
+      tmp_offset = tmp_ptr - str;
+      str_len = str_len - old_len + new_len;
+      str = (char *)msSmallRealloc(
+          str, (str_len + 1)); /* make new space for a copy */
+      tmp_ptr = str + tmp_offset;
+    }
+
+    /*
+    ** Move the trailing part of str to make some room unless old_len == new_len
+    */
+    if (old_len != new_len) {
+      memmove(tmp_ptr + new_len, tmp_ptr + old_len,
+              strlen(tmp_ptr) - old_len + 1);
+    }
+
+    /*
+    ** Now copy new over old
+    */
+    memcpy(tmp_ptr, newstr, new_len);
+
+    /*
+    ** And look for more matches in the rest of the string
+    */
+    tmp_ptr = (char *)strcasestr(tmp_ptr + new_len, old);
+  }
+
+  return (str);
+}
+
+/*
+** Converts a 2 character hexidecimal string to an integer.
+*/
+int msHexToInt(char *hex) {
+  int number;
+
+  number = (hex[0] >= 'A' ? ((hex[0] & 0xdf) - 'A') + 10 : (hex[0] - '0'));
+  number *= 16;
+  number += (hex[1] >= 'A' ? ((hex[1] & 0xdf) - 'A') + 10 : (hex[1] - '0'));
+
+  return (number);
+}
+
+/*
+** Use FRIBIDI to encode the string.
+** The return value must be freed by the caller.
+*/
+#ifdef USE_FRIBIDI
+char *msGetFriBidiEncodedString(const char *string, const char *encoding) {
+  FriBidiChar logical[MAX_STR_LEN];
+  FriBidiParType base;
+  size_t len;
+
+#ifdef FRIBIDI_NO_CHARSETS
+  iconv_t to_ucs4, from_ucs4;
+#else
+  FriBidiCharSet to_char_set_num;
+  FriBidiCharSet from_char_set_num;
+#endif
+
+  len = strlen(string);
+
+#ifdef FRIBIDI_NO_CHARSETS
+  to_ucs4 = iconv_open("WCHAR_T", encoding);
+  from_ucs4 = iconv_open("UTF-8", "WCHAR_T");
+#else
+  to_char_set_num = fribidi_parse_charset((char *)encoding);
+  from_char_set_num = fribidi_parse_charset("UTF-8");
+#endif
+
+#ifdef FRIBIDI_NO_CHARSETS
+  if (to_ucs4 == (iconv_t)(-1) || from_ucs4 == (iconv_t)(-1))
+#else
+  if (!to_char_set_num || !from_char_set_num)
+#endif
+  {
+    msSetError(MS_IDENTERR, "Encoding not supported (%s).",
+               "msGetFriBidiEncodedString()", encoding);
+    return NULL;
+  }
+
+#ifdef FRIBIDI_NO_CHARSETS
+  {
+    char *st = string, *ust = (char *)logical;
+    int in_len = (int)len;
+    len = sizeof logical;
+    iconv(to_ucs4, &st, &in_len, &ust, (int *)&len);
+    len = (FriBidiChar *)ust - logical;
+  }
+#else
+  len =
+      fribidi_charset_to_unicode(to_char_set_num, (char *)string, len, logical);
+#endif
+
+  {
+    FriBidiChar *visual;
+    char outstring[MAX_STR_LEN];
+    FriBidiStrIndex *ltov, *vtol;
+    FriBidiLevel *levels;
+    FriBidiStrIndex new_len;
+    fribidi_boolean log2vis;
+
+    visual = (FriBidiChar *)msSmallMalloc(sizeof(FriBidiChar) * (len + 1));
+    ltov = NULL;
+    vtol = NULL;
+    levels = NULL;
+
+    // fribidi_log2vis() doesn't support multi-line paragraphs.
+    // See:
+    // https://lists.freedesktop.org/archives/fribidi/2008-January/000515.html
+    for (size_t i = 0; i < len; i++) {
+      if (logical[i] == '\n') {
+        msSetError(
+            MS_IDENTERR,
+            "Input string is a multi-line paragraph, which is not supported.",
+            "msGetFriBidiEncodedString()");
+        msFree(visual);
+        return NULL;
+      }
+    }
+
+    /* Create a bidi string. */
+    log2vis = fribidi_log2vis(logical, len, &base,
+                              /* output */
+                              visual, ltov, vtol, levels);
+
+    if (!log2vis) {
+      msSetError(MS_IDENTERR, "Failed to create bidi string.",
+                 "msGetFriBidiEncodedString()");
+      msFree(visual);
+      return NULL;
+    }
+
+    /* Convert it to utf-8 for display. */
+#ifdef FRIBIDI_NO_CHARSETS
+    {
+      char *str = outstring, *ust = (char *)visual;
+      int in_len = len * sizeof visual[0];
+      new_len = sizeof outstring;
+      iconv(from_ucs4, &ust, &in_len, &str, (int *)&new_len);
+      *str = '\0';
+      new_len = str - outstring;
+    }
+#else
+    new_len =
+        fribidi_unicode_to_charset(from_char_set_num, visual, len, outstring);
+
+    /* scan str and compress out FRIBIDI_CHAR_FILL UTF8 characters */
+
+    int j = 0;
+    for (int i = 0; i < new_len; i++, j++) {
+      if (outstring[i] == '\xef' && outstring[i + 1] == '\xbb' &&
+          outstring[i + 2] == '\xbf') {
+        i += 3;
+      }
+      if (i != j) {
+        outstring[j] = outstring[i];
+      }
+    }
+    outstring[j] = '\0';
+
+#endif
+
+    msFree(visual);
+    return msStrdup(outstring);
+  }
+}
+#endif
+
+/*
+** Simple charset converter. Converts string from specified encoding to UTF-8.
+** The return value must be freed by the caller.
+*/
+char *msGetEncodedString(const char *string, const char *encoding) {
+#ifdef USE_ICONV
+  iconv_t cd = NULL;
+  const char *inp;
+  char *outp, *out = NULL;
+  size_t len, bufsize, bufleft;
+  assert(encoding);
+
+#ifdef USE_FRIBIDI
+  msAcquireLock(TLOCK_FRIBIDI);
+  if (fribidi_parse_charset((char *)encoding)) {
+    char *ret = msGetFriBidiEncodedString(string, encoding);
+    msReleaseLock(TLOCK_FRIBIDI);
+    return ret;
+  }
+  msReleaseLock(TLOCK_FRIBIDI);
+#endif
+  len = strlen(string);
+
+  if (len == 0 || strcasecmp(encoding, "UTF-8") == 0)
+    return msStrdup(string); /* Nothing to do: string already in UTF-8 */
+
+  cd = iconv_open("UTF-8", encoding);
+  if (cd == (iconv_t)-1) {
+    msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
+               "msGetEncodedString()", encoding);
+    return NULL;
+  }
+
+  bufsize = len * 6 + 1; /* Each UTF-8 char can be up to 6 bytes */
+  inp = string;
+  out = (char *)malloc(bufsize);
+  if (out == NULL) {
+    msSetError(MS_MEMERR, NULL, "msGetEncodedString()");
+    iconv_close(cd);
+    return NULL;
+  }
+  strlcpy(out, string, bufsize);
+  outp = out;
+
+  bufleft = bufsize;
+
+  while (len > 0) {
+    const size_t iconv_status =
+        msIconv(cd, (char **)&inp, &len, &outp, &bufleft);
+    if (iconv_status == static_cast<size_t>(-1)) {
+      msFree(out);
+      iconv_close(cd);
+      return msStrdup(string);
+    }
+  }
+  out[bufsize - bufleft] = '\0';
+
+  iconv_close(cd);
+
+  return out;
+#else
+  if (*string == '\0' || (encoding && strcasecmp(encoding, "UTF-8") == 0))
+    return msStrdup(string); /* Nothing to do: string already in UTF-8 */
+
+  msSetError(MS_MISCERR, "Not implemeted since Iconv is not enabled.",
+             "msGetEncodedString()");
+  return NULL;
+#endif
+}
+
+char *msConvertWideStringToUTF8(const wchar_t *string, const char *encoding) {
+#ifdef USE_ICONV
+
+  char *output = NULL;
+  const char *errormessage = NULL;
+  iconv_t cd = NULL;
+  size_t nStr;
+  size_t nInSize;
+  size_t nOutSize;
+  size_t nBufferSize;
+
+  char *pszUTF8 = NULL;
+  const wchar_t *pwszWide = NULL;
+
+  if (string != NULL) {
+    nStr = wcslen(string);
+    nBufferSize = ((nStr * 6) + 1);
+    output = (char *)msSmallMalloc(nBufferSize);
+
+    if (nStr == 0) {
+      /* return an empty 8 byte string */
+      output[0] = '\0';
+      return output;
+    }
+
+    cd = iconv_open("UTF-8", encoding);
+
+    nOutSize = nBufferSize;
+    if ((iconv_t)-1 != cd) {
+      nInSize = sizeof(wchar_t) * nStr;
+      pszUTF8 = output;
+      pwszWide = string;
+      size_t iconv_status =
+          msIconv(cd, (char **)&pwszWide, &nInSize, &pszUTF8, &nOutSize);
+      if ((size_t)-1 == iconv_status) {
+        switch (errno) {
+        case E2BIG:
+          errormessage = "There is not sufficient room in buffer";
+          break;
+        case EILSEQ:
+          errormessage =
+              "An invalid multibyte sequence has been encountered in the input";
+          break;
+        case EINVAL:
+          errormessage = "An incomplete multibyte sequence has been "
+                         "encountered in the input";
+          break;
+        default:
+          errormessage = "Unknown";
+          break;
+        }
+        msSetError(MS_MISCERR,
+                   "Unable to convert string in encoding '%s' to UTF8 %s",
+                   "msConvertWideStringToUTF8()", encoding, errormessage);
+        iconv_close(cd);
+        msFree(output);
+        return NULL;
+      }
+      iconv_close(cd);
+    } else {
+      msSetError(MS_MISCERR, "Encoding not supported by libiconv (%s).",
+                 "msConvertWideStringToUTF8()", encoding);
+      msFree(output);
+      return NULL;
+    }
+
+  } else {
+    /* we were given a NULL wide string, nothing we can do here */
+    return NULL;
+  }
+
+  /* NULL-terminate the output string */
+  output[nBufferSize - nOutSize] = '\0';
+  return output;
+#else
+  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.",
+             "msConvertWideStringToUTF8()");
+  return NULL;
+#endif
+}
+
+wchar_t *msConvertWideStringFromUTF8(const char *string, const char *encoding) {
+#ifdef USE_ICONV
+  wchar_t *output = NULL;
+  const char *errormessage = NULL;
+  iconv_t cd = NULL;
+  size_t nStr;
+  size_t nInSize;
+  size_t nOutSize;
+  size_t nBufferSize;
+
+  const char *pszUTF8 = NULL;
+  wchar_t *pwszWide = NULL;
+
+  if (string != NULL) {
+    nStr = strlen(string);
+    nBufferSize = ((nStr * 6) + 1);
+    output = (wchar_t *)msSmallMalloc(nBufferSize);
+
+    if (nStr == 0) {
+      /* return an empty 8 byte string */
+      output[0] = '\0';
+      return output;
+    }
+
+    cd = iconv_open(encoding, "UTF-8");
+
+    nOutSize = nBufferSize;
+    if ((iconv_t)-1 != cd) {
+      nInSize = sizeof(char) * nStr;
+      pszUTF8 = string;
+      pwszWide = output;
+      size_t iconv_status = msIconv(cd, (char **)&pszUTF8, &nInSize,
+                                    (char **)&pwszWide, &nOutSize);
+      if ((size_t)-1 == iconv_status) {
+        switch (errno) {
+        case E2BIG:
+          errormessage = "There is not sufficient room in buffer";
+          break;
+        case EILSEQ:
+          errormessage =
+              "An invalid multibyte sequence has been encountered in the input";
+          break;
+        case EINVAL:
+          errormessage = "An incomplete multibyte sequence has been "
+                         "encountered in the input";
+          break;
+        default:
+          errormessage = "Unknown";
+          break;
+        }
+        msSetError(MS_MISCERR,
+                   "Unable to convert string in UTF8 to encoding '%s' %s",
+                   "msConvertWideStringFromUTF8()", encoding, errormessage);
+        iconv_close(cd);
+        msFree(output);
+        return NULL;
+      }
+      iconv_close(cd);
+    } else {
+      msSetError(MS_MISCERR, "Encoding not supported by libiconv (%s).",
+                 "msConvertWideStringFromUTF8()", encoding);
+      msFree(output);
+      return NULL;
+    }
+  } else {
+    /* we were given a NULL wide string, nothing we can do here */
+    return NULL;
+  }
+
+  /* NULL-terminate the output string */
+  if (nOutSize >= sizeof(wchar_t))
+    *((wchar_t *)pwszWide) = L'\0';
+
+  return output;
+#else
+  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.",
+             "msConvertWideStringFromUTF8()");
+  return NULL;
+#endif
+}
+
+/*
+** Returns the next glyph in string and advances *in_ptr to the next
+** character.
+**
+** If out_string is not NULL then the character (bytes) is copied to this
+** buffer and null-terminated. out_string must be a pre-allocated buffer of
+** at least 11 bytes.
+**
+** The function returns the number of bytes in this glyph.
+**
+** This function treats 3 types of glyph encodings:
+*   - as an html entity, for example &#123; , &#x1af; , or &eacute;
+*   - as an utf8 encoded character
+*   - if utf8 decoding fails, as a raw character
+*
+** This function mimics the character decoding function used in gdft.c of
+* libGD. It is necessary to have the same behaviour, as input strings must be
+* split into the same glyphs as what gd does.
+**
+** In UTF-8, the number of leading 1 bits in the first byte specifies the
+** number of bytes in the entire sequence.
+** Source: http://www.cl.cam.ac.uk/~mgk25/unicode.html#utf-8
+**
+** U-00000000 U-0000007F: 0xxxxxxx
+** U-00000080 U-000007FF: 110xxxxx 10xxxxxx
+** U-00000800 U-0000FFFF: 1110xxxx 10xxxxxx 10xxxxxx
+** U-00010000 U-001FFFFF: 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
+** U-00200000 U-03FFFFFF: 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
+** U-04000000 U-7FFFFFFF: 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
+*/
+int msGetNextGlyph(const char **in_ptr, char *out_string) {
+  unsigned char in;
+  int numbytes = 0;
+  unsigned int unicode;
+  int i;
+
+  in = (unsigned char)**in_ptr;
+
+  if (in == 0)
+    return -1; /* Empty string */
+  if ((numbytes = msGetUnicodeEntity(*in_ptr, &unicode)) > 0) {
+    if (out_string) {
+      for (i = 0; i < numbytes; i++) {
+        out_string[i] = (*in_ptr)[i];
+      }
+      out_string[numbytes] = '\0';
+    }
+    *in_ptr += numbytes;
+    return numbytes;
+  }
+  if (in < 0xC0) {
+    /*
+     * Handles properly formed UTF-8 characters between
+     * 0x01 and 0x7F.  Also treats \0 and naked trail
+     * bytes 0x80 to 0xBF as valid characters representing
+     * themselves.
+     */
+    /*goto end of loop to return just the char*/
+  } else if (in < 0xE0) {
+    if (((*in_ptr)[1] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = '\0';
+      }
+      *in_ptr += 2;
+      return 2; /*110xxxxx 10xxxxxx*/
+    }
+  } else if (in < 0xF0) {
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        *in_ptr += numbytes;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = '\0';
+      }
+      *in_ptr += 3;
+      return 3; /* 1110xxxx 10xxxxxx 10xxxxxx */
+    }
+  } else if (in < 0xF8) {
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80 &&
+        ((*in_ptr)[3] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = (*in_ptr)[3];
+        out_string[4] = '\0';
+      }
+      *in_ptr += 4;
+      return 4; /* 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx */
+    }
+  } else if (in < 0xFC) {
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80 &&
+        ((*in_ptr)[3] & 0xC0) == 0x80 && ((*in_ptr)[4] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = (*in_ptr)[3];
+        out_string[4] = (*in_ptr)[4];
+        out_string[5] = '\0';
+      }
+      *in_ptr += 5;
+      return 5; /* 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
+    }
+  } else if (in < 0xFE) {
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80 &&
+        ((*in_ptr)[3] & 0xC0) == 0x80 && ((*in_ptr)[4] & 0xC0) == 0x80 &&
+        ((*in_ptr)[5] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = (*in_ptr)[3];
+        out_string[4] = (*in_ptr)[4];
+        out_string[5] = (*in_ptr)[5];
+        out_string[6] = '\0';
+      }
+      *in_ptr += 6;
+      return 6; /* 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
+    }
+  }
+
+  if (out_string) {
+    out_string[0] = in;
+    out_string[1] = '\0'; /* 0xxxxxxx */
+  }
+  (*in_ptr)++;
+  return 1;
+}
+
+/*
+** Returns the number of glyphs in string
+*/
+int msGetNumGlyphs(const char *in_ptr) {
+  int numchars = 0;
+
+  while (msGetNextGlyph(&in_ptr, NULL) != -1)
+    numchars++;
+
+  return numchars;
+}
+
+static int cmp_entities(const void *e1, const void *e2) {
+  struct mapentities_s *en1 = (struct mapentities_s *)e1;
+  struct mapentities_s *en2 = (struct mapentities_s *)e2;
+  return strcmp(en1->name, en2->name);
+}
+/*
+ * this function tests if the string pointed by inptr represents
+ * an HTML entity, in decimal form ( e.g. &#197;), in hexadecimal
+ * form ( e.g. &#x6C34; ), or from html 4.0 spec ( e.g. &eacute; )
+ * - returns returns 0 if the string doesn't represent such an entity.
+ * - if the string does start with such entity,it returns the number of
+ * bytes occupied by said entity, and stores the unicode value in *unicode
+ */
+int msGetUnicodeEntity(const char *inptr, unsigned int *unicode) {
+  unsigned char *in = (unsigned char *)inptr;
+  int l, val = 0;
+  if (*in == '&') {
+    in++;
+    if (*in == '#') {
+      in++;
+      if (*in == 'x' || *in == 'X') {
+        in++;
+        for (l = 3; l < 8; l++) {
+          char byte;
+          if (*in >= '0' && *in <= '9')
+            byte = *in - '0';
+          else if (*in >= 'a' && *in <= 'f')
+            byte = *in - 'a' + 10;
+          else if (*in >= 'A' && *in <= 'F')
+            byte = *in - 'A' + 10;
+          else
+            break;
+          in++;
+          val = (val * 16) + byte;
+        }
+        if (*in == ';' && l > 3) {
+          *unicode = val;
+          return ++l;
+        }
+      } else {
+        for (l = 2; l < 8; l++) {
+          if (*in >= '0' && *in <= '9') {
+            val = val * 10 + *in - '0';
+            in++;
+          } else
+            break;
+        }
+        if (*in == ';' && l > 2) {
+          *unicode = val;
+          return ++l;
+        }
+      }
+    } else {
+      char entity_name_buf[MAP_ENTITY_NAME_LENGTH_MAX + 1];
+      char *p;
+      struct mapentities_s key;
+      key.name = p = entity_name_buf;
+      key.value = 0; // unused, but makes cppcheck happy
+      for (l = 1; l <= MAP_ENTITY_NAME_LENGTH_MAX + 1; l++) {
+        if (*in == '\0') /*end of string before possible entity: return*/
+          break;
+        if (*in == ';') { /*possible end of entity: do a lookup*/
+          *p++ = '\0';
+          const struct mapentities_s *res =
+              static_cast<const struct mapentities_s *>(
+                  bsearch(&key, mapentities, MAP_NR_OF_ENTITIES,
+                          sizeof(mapentities[0]), cmp_entities));
+          if (res) {
+            *unicode = res->value;
+            return ++l;
+          }
+          break; /*the string was of the form of an entity but didn't correspond
+                    to an existing one: return*/
+        }
+        *p++ = *in;
+        in++;
+      }
+    }
+  }
+  return 0;
+}
+
+/**
+ * msStringIsInteger()
+ *
+ * determines whether a given string is an integer
+ *
+ * @param string the string to be tested
+ *
+ * @return MS_SUCCESS or MS_FAILURE
+ */
+
+int msStringIsInteger(const char *string) {
+  int length, i;
+
+  length = strlen(string);
+
+  if (length == 0)
+    return MS_FAILURE;
+
+  for (i = 0; i < length; i++) {
+    if (!isdigit(string[i]))
+      return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                             msStrdup()                               */
+/************************************************************************/
+
+/* Safe version of msStrdup(). This function is taken from gdal/cpl. */
+
+char *msStrdup(const char *pszString) {
+  size_t nStringLength;
+  char *pszReturn;
+
+  if (pszString == NULL)
+    pszString = "";
+
+  nStringLength = strlen(pszString) + 1; /* null terminated byte */
+  pszReturn = static_cast<char *>(malloc(nStringLength));
+
+  if (pszReturn == NULL) {
+    fprintf(stderr, "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
+            (long)strlen(pszString));
+    exit(1);
+  }
+
+  memcpy(pszReturn, pszString, nStringLength);
+
+  return pszReturn;
+}
+
+/************************************************************************/
+/*                             msStringEscape()                         */
+/************************************************************************/
+
+/* Checks if a string contains single or double quotes and escape them.
+   NOTE: the user must free the returned char* if it is different than the
+   one passed in */
+
+char *msStringEscape(const char *pszString) {
+  char *string_tmp, *string_ptr;
+  int i, ncharstoescape = 0;
+
+  if (pszString == NULL || strlen(pszString) == 0)
+    return msStrdup("");
+
+  for (i = 0; pszString[i]; i++)
+    ncharstoescape += ((pszString[i] == '\"') || (pszString[i] == '\''));
+
+  if (!ncharstoescape) {
+    return (char *)pszString;
+  }
+
+  string_tmp = (char *)msSmallMalloc(strlen(pszString) + ncharstoescape + 1);
+  for (string_ptr = (char *)pszString, i = 0; *string_ptr != '\0';
+       ++string_ptr, ++i) {
+    if ((*string_ptr == '\"') || (*string_ptr == '\'')) {
+      string_tmp[i] = '\\';
+      ++i;
+    }
+    string_tmp[i] = *string_ptr;
+  }
+
+  string_tmp[i] = '\0';
+  return string_tmp;
+}
+
+std::string msStdStringEscape(const char *pszString) {
+  char *tmp = msStringEscape(pszString);
+  std::string ret(tmp);
+  if (tmp != pszString)
+    msFree(tmp);
+  return ret;
+}
+
+/************************************************************************/
+/*                             msStringInArray()                        */
+/************************************************************************/
+
+/* Check if a string is in a array */
+int msStringInArray(const char *pszString, char **array, int numelements) {
+  int i;
+  for (i = 0; i < numelements; ++i) {
+    if (strcasecmp(pszString, array[i]) == 0)
+      return MS_TRUE;
+  }
+  return MS_FALSE;
+}
+
+bool msStringInArray(const char *pszString,
+                     const std::vector<std::string> &array) {
+  for (const auto &str : array) {
+    if (strcasecmp(pszString, str.c_str()) == 0)
+      return true;
+  }
+  return false;
+}
+
+int msLayerEncodeShapeAttributes(layerObj *layer, shapeObj *shape) {
+
+#ifdef USE_ICONV
+  iconv_t cd = NULL;
+  const char *inp;
+  char *outp, *out = NULL;
+  size_t len, bufsize, bufleft;
+  int i;
+
+  if (!layer->encoding || !*layer->encoding ||
+      !strcasecmp(layer->encoding, "UTF-8"))
+    return MS_SUCCESS;
+
+  cd = iconv_open("UTF-8", layer->encoding);
+  if (cd == (iconv_t)-1) {
+    msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
+               "msGetEncodedString()", layer->encoding);
+    return MS_FAILURE;
+  }
+
+  for (i = 0; i < shape->numvalues; i++) {
+    if (!shape->values[i] || (len = strlen(shape->values[i])) == 0) {
+      continue; /* Nothing to do */
+    }
+
+    bufsize = len * 6 + 1; /* Each UTF-8 char can be up to 6 bytes */
+    inp = shape->values[i];
+    out = (char *)msSmallMalloc(bufsize);
+
+    strlcpy(out, shape->values[i], bufsize);
+    outp = out;
+
+    bufleft = bufsize;
+
+    bool failedIconv = false;
+    while (len > 0) {
+      const size_t iconv_status =
+          msIconv(cd, (char **)&inp, &len, &outp, &bufleft);
+      if (iconv_status == static_cast<size_t>(-1)) {
+        failedIconv = true;
+        break;
+      }
+    }
+    if (failedIconv) {
+      msFree(out);
+      continue; /* silently ignore failed conversions */
+    }
+    out[bufsize - bufleft] = '\0';
+    msFree(shape->values[i]);
+    shape->values[i] = out;
+  }
+  iconv_close(cd);
+
+  return MS_SUCCESS;
+#else
+  if (!layer->encoding || !*layer->encoding ||
+      !strcasecmp(layer->encoding, "UTF-8"))
+    return MS_SUCCESS;
+  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.",
+             "msGetEncodedString()");
+  return MS_FAILURE;
+#endif
+}
+
+/************************************************************************/
+/*                             msStringBuffer                           */
+/************************************************************************/
+
+struct msStringBuffer {
+  size_t alloc_size;
+  size_t length;
+  char *str;
+};
+
+/************************************************************************/
+/*                         msStringBufferAlloc()                        */
+/************************************************************************/
+
+msStringBuffer *msStringBufferAlloc(void) {
+  return (msStringBuffer *)msSmallCalloc(sizeof(msStringBuffer), 1);
+}
+
+/************************************************************************/
+/*                         msStringBufferFree()                         */
+/************************************************************************/
+
+void msStringBufferFree(msStringBuffer *sb) {
+  if (sb)
+    msFree(sb->str);
+  msFree(sb);
+}
+
+/************************************************************************/
+/*                       msStringBufferGetString()                      */
+/************************************************************************/
+
+const char *msStringBufferGetString(msStringBuffer *sb) { return sb->str; }
+
+/************************************************************************/
+/*                   msStringBufferReleaseStringAndFree()               */
+/************************************************************************/
+
+char *msStringBufferReleaseStringAndFree(msStringBuffer *sb) {
+  char *str = sb->str;
+  sb->str = NULL;
+  sb->alloc_size = 0;
+  sb->length = 0;
+  msStringBufferFree(sb);
+  return str;
+}
+
+/************************************************************************/
+/*                        msStringBufferAppend()                        */
+/************************************************************************/
+
+int msStringBufferAppend(msStringBuffer *sb, const char *pszAppendedString) {
+  size_t nAppendLen = strlen(pszAppendedString);
+  if (sb->length + nAppendLen >= sb->alloc_size) {
+    size_t newAllocSize1 = sb->alloc_size + sb->alloc_size / 3;
+    size_t newAllocSize2 = sb->length + nAppendLen + 1;
+    size_t newAllocSize = MAX(newAllocSize1, newAllocSize2);
+    void *newStr = realloc(sb->str, newAllocSize);
+    if (newStr == NULL) {
+      msSetError(MS_MEMERR, "Not enough memory", "msStringBufferAppend()");
+      return MS_FAILURE;
+    }
+    sb->alloc_size = newAllocSize;
+    sb->str = (char *)newStr;
+  }
+  memcpy(sb->str + sb->length, pszAppendedString, nAppendLen + 1);
+  sb->length += nAppendLen;
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapsymbol.c 8.2.0~beta1-1~exp1/src/mapsymbol.c
--- 8.0.1-5/src/mapsymbol.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapsymbol.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1140 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  symbolObj related functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <stdarg.h> /* variable number of function arguments support */
+#include <time.h>   /* since the parser handles time/date we need this */
+
+#include "mapserver.h"
+#include "mapfile.h"
+#include "mapcopy.h"
+#include "mapthread.h"
+#include "fontcache.h"
+#include "mapows.h"
+
+extern int msyylex(void); /* lexer globals */
+extern void msyyrestart(FILE *);
+extern double msyynumber;
+extern char *msyystring_buffer;
+extern int msyylineno;
+extern FILE *msyyin;
+
+extern int msyystate;
+
+void freeImageCache(struct imageCacheObj *ic) {
+  if (ic) {
+    freeImageCache(ic->next); /* free any children */
+    msFreeRasterBuffer(&(ic->img));
+    free(ic);
+  }
+  return;
+}
+
+/*
+** msSymbolGetDefaultSize()
+**
+** Return the default size of a symbol.
+** Note: The size of a symbol is the height. Everywhere in the code, the width
+** is adjusted to the size that becomes the height.
+** See mapgd.c // size ~ height in pixels
+*/
+double msSymbolGetDefaultSize(symbolObj *s) {
+  double size = 1;
+  if (s == NULL)
+    return 1;
+
+  switch (s->type) {
+  case (MS_SYMBOL_TRUETYPE):
+    break;
+  case (MS_SYMBOL_PIXMAP):
+    assert(s->pixmap_buffer != NULL);
+    if (s->pixmap_buffer == NULL)
+      return 1; /* FIXME */
+    size = (double)s->pixmap_buffer->height;
+    break;
+  case (MS_SYMBOL_SVG):
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+    assert(s->renderer_cache != NULL);
+    size = s->sizey;
+#endif
+    break;
+  default: /* vector and ellipses, scalable */
+    size = (s->sizey <= 0) ? s->sizex : s->sizey;
+    break;
+  }
+
+  if (size <= 0)
+    return 1;
+
+  return size;
+}
+
+void initSymbol(symbolObj *s) {
+  MS_REFCNT_INIT(s);
+  s->type = MS_SYMBOL_VECTOR;
+  s->transparent = MS_FALSE;
+  s->transparentcolor = 0;
+  s->sizex = 1;
+  s->sizey = 1;
+  s->filled = MS_FALSE;
+  s->numpoints = 0;
+  s->renderer = NULL;
+  s->renderer_free_func = NULL;
+  s->renderer_cache = NULL;
+  s->pixmap_buffer = NULL;
+  s->imagepath = NULL;
+  s->name = NULL;
+  s->inmapfile = MS_FALSE;
+  s->font = NULL;
+  s->full_pixmap_path = NULL;
+  s->character = NULL;
+  s->anchorpoint_x = s->anchorpoint_y = 0.5;
+}
+
+int msFreeSymbol(symbolObj *s) {
+  if (!s)
+    return MS_FAILURE;
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(s)) {
+    return MS_FAILURE;
+  }
+
+  if (s->name)
+    free(s->name);
+  if (s->renderer_free_func) {
+    s->renderer_free_func(s);
+  } else {
+    if (s->renderer != NULL) {
+      s->renderer->freeSymbol(s);
+    }
+  }
+  if (s->pixmap_buffer) {
+    msFreeRasterBuffer(s->pixmap_buffer);
+    free(s->pixmap_buffer);
+  }
+
+  if (s->font)
+    free(s->font);
+  msFree(s->full_pixmap_path);
+  if (s->imagepath)
+    free(s->imagepath);
+  if (s->character)
+    free(s->character);
+
+  return MS_SUCCESS;
+}
+
+int loadSymbol(symbolObj *s, char *symbolpath) {
+  int done = MS_FALSE;
+  char szPath[MS_MAXPATHLEN];
+
+  initSymbol(s);
+
+  for (;;) {
+    switch (msyylex()) {
+    case (ANCHORPOINT):
+      if (getDouble(&(s->anchorpoint_x), MS_NUM_CHECK_RANGE, 0, 1) == -1) {
+        msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1",
+                   "loadSymbol()");
+        return -1;
+      }
+      if (getDouble(&(s->anchorpoint_y), MS_NUM_CHECK_RANGE, 0, 1) == -1) {
+        msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1",
+                   "loadSymbol()");
+        return (-1);
+      }
+      break;
+
+    case (ANTIALIAS): /*ignore*/
+      msyylex();
+      break;
+    case (CHARACTER):
+      if (getString(&s->character) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END): /* do some error checking */
+      if ((s->type == MS_SYMBOL_SVG) && (s->imagepath == NULL)) {
+        msSetError(MS_SYMERR, "Symbol of type SVG has no file path specified.",
+                   "loadSymbol()");
+        return (-1);
+      }
+      if ((s->type == MS_SYMBOL_PIXMAP) && (s->full_pixmap_path == NULL)) {
+        msSetError(MS_SYMERR, "Symbol of type PIXMAP has no image data.",
+                   "loadSymbol()");
+        return (-1);
+      }
+      if (((s->type == MS_SYMBOL_ELLIPSE) || (s->type == MS_SYMBOL_VECTOR)) &&
+          (s->numpoints == 0)) {
+        msSetError(MS_SYMERR,
+                   "Symbol of type VECTOR or ELLIPSE has no point data.",
+                   "loadSymbol()");
+        return (-1);
+      }
+      if (s->type == MS_SYMBOL_VECTOR) {
+        double minx = s->points[0].x;
+        double miny = s->points[0].y;
+        /* should only negative points be shifted? (#4116)*/
+        int shiftpositive =
+            ((s->anchorpoint_x != 0.5) || (s->anchorpoint_y != 0.5));
+        int i;
+        for (i = 1; i < s->numpoints; i++) {
+          if (s->points[i].x != -99 && s->points[i].y != -99) {
+            if (s->points[i].x < minx)
+              minx = s->points[i].x;
+            if (s->points[i].y < miny)
+              miny = s->points[i].y;
+          }
+        }
+        if (minx < 0 || miny < 0 ||
+            (shiftpositive && (minx != 0 || miny != 0))) {
+          for (i = 0; i < s->numpoints; i++) {
+            if (s->points[i].x != -99 && s->points[i].y != -99) {
+              s->points[i].x -= minx;
+              s->points[i].y -= miny;
+            }
+          }
+          s->sizex -= minx;
+          s->sizey -= miny;
+        }
+      }
+
+      return (0);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadSymbol()");
+      return (-1);
+      break;
+    case (FILLED):
+      if ((s->filled = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (FONT):
+      if (getString(&s->font) == MS_FAILURE)
+        return (-1);
+      break;
+    case (IMAGE):
+      if (msyylex() != MS_STRING) { /* get image location from next token */
+        msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)",
+                   "loadSymbol()", msyystring_buffer, msyylineno);
+        return (-1);
+      }
+      msFree(s->full_pixmap_path);
+      s->full_pixmap_path =
+          msStrdup(msBuildPath(szPath, symbolpath, msyystring_buffer));
+      /* Set imagepath */
+      msFree(s->imagepath);
+      s->imagepath = msStrdup(msyystring_buffer);
+      break;
+    case (NAME):
+      if (getString(&s->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (POINTS):
+      done = MS_FALSE;
+      s->sizex = 0;
+      s->sizey = 0;
+      for (;;) {
+        switch (msyylex()) {
+        case (END):
+          done = MS_TRUE;
+          break;
+        case (MS_NUMBER):
+          if (s->numpoints == MS_MAXVECTORPOINTS) {
+            msSetError(MS_SYMERR, "POINT block contains too many points.",
+                       "loadSymbol()");
+            return (-1);
+          }
+          s->points[s->numpoints].x = atof(msyystring_buffer); /* grab the x */
+          if (getDouble(&(s->points[s->numpoints].y), MS_NUM_CHECK_NONE, -1,
+                        -1) == -1)
+            return (-1); /* grab the y */
+          if (s->points[s->numpoints].x != -99) {
+            s->sizex = MS_MAX(s->sizex, s->points[s->numpoints].x);
+            s->sizey = MS_MAX(s->sizey, s->points[s->numpoints].y);
+          }
+          s->numpoints++;
+          break;
+        default:
+          msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)",
+                     "loadSymbol()", msyystring_buffer, msyylineno);
+          return (-1);
+        }
+
+        if (done == MS_TRUE)
+          break;
+      }
+      break;
+    case (TRANSPARENT):
+      s->transparent = MS_TRUE;
+      if (getInteger(&(s->transparentcolor), MS_NUM_CHECK_RANGE, 0, 255) == -1)
+        return (-1);
+      break;
+    case (TYPE):
+      if ((s->type = getSymbol(8, MS_SYMBOL_VECTOR, MS_SYMBOL_ELLIPSE,
+                               MS_SYMBOL_PIXMAP, MS_SYMBOL_SIMPLE, MS_TRUETYPE,
+                               MS_SYMBOL_HATCH, MS_SYMBOL_SVG)) == -1)
+        return (-1);
+      if (s->type ==
+          MS_TRUETYPE) /* TrueType keyword is valid several place in map files
+                          and symbol files, this simplifies the lexer */
+        s->type = MS_SYMBOL_TRUETYPE;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadSymbol()", msyystring_buffer, msyylineno);
+      return (-1);
+    } /* end switch */
+  }   /* end for */
+  return done;
+}
+
+void writeSymbol(symbolObj *s, FILE *stream) {
+  int i;
+
+  msIO_fprintf(stream, "  SYMBOL\n");
+  if (s->name != NULL)
+    msIO_fprintf(stream, "    NAME \"%s\"\n", s->name);
+
+  switch (s->type) {
+  case (MS_SYMBOL_HATCH):
+    msIO_fprintf(stream, "    TYPE HATCH\n");
+    break;
+  case (MS_SYMBOL_PIXMAP):
+    msIO_fprintf(stream, "    TYPE PIXMAP\n");
+    if (s->imagepath != NULL)
+      msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
+    if (s->anchorpoint_y != 0.5 || s->anchorpoint_x != 0.5) {
+      msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x,
+                   s->anchorpoint_y);
+    }
+    msIO_fprintf(stream, "    TRANSPARENT %d\n", s->transparentcolor);
+    break;
+  case (MS_SYMBOL_TRUETYPE):
+    msIO_fprintf(stream, "    TYPE TRUETYPE\n");
+    if (s->character != NULL)
+      msIO_fprintf(stream, "    CHARACTER \"%s\"\n", s->character);
+    if (s->font != NULL)
+      msIO_fprintf(stream, "    FONT \"%s\"\n", s->font);
+    if (s->anchorpoint_y != 0.5 || s->anchorpoint_x != 0.5) {
+      msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x,
+                   s->anchorpoint_y);
+    }
+    break;
+  default:
+    if (s->type == MS_SYMBOL_ELLIPSE)
+      msIO_fprintf(stream, "    TYPE ELLIPSE\n");
+    else if (s->type == MS_SYMBOL_VECTOR)
+      msIO_fprintf(stream, "    TYPE VECTOR\n");
+    else if (s->type == MS_SYMBOL_SVG)
+      msIO_fprintf(stream, "    TYPE SVG\n");
+    else
+      msIO_fprintf(stream, "    TYPE SIMPLE\n");
+
+    if (s->filled == MS_TRUE)
+      msIO_fprintf(stream, "    FILLED TRUE\n");
+    if (s->imagepath != NULL)
+      msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
+    if (s->anchorpoint_y != 0.5 || s->anchorpoint_x != 0.5) {
+      msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x,
+                   s->anchorpoint_y);
+    }
+
+    /* POINTS */
+    if (s->numpoints != 0) {
+      msIO_fprintf(stream, "    POINTS\n");
+      for (i = 0; i < s->numpoints; i++) {
+        msIO_fprintf(stream, "      %g %g\n", s->points[i].x, s->points[i].y);
+      }
+      msIO_fprintf(stream, "    END\n");
+    }
+    break;
+  }
+
+  msIO_fprintf(stream, "  END\n\n");
+}
+
+/*
+** Little helper function to allow us to build symbol files on-the-fly
+** from just a file name.
+**
+** Returns the symbol index or -1 if it could not be added.
+*/
+int msAddImageSymbol(symbolSetObj *symbolset, const char *filename) {
+  char szPath[MS_MAXPATHLEN];
+  symbolObj *symbol = NULL;
+  char *extension = NULL;
+  int symbolidx;
+
+  if (!symbolset) {
+    msSetError(MS_SYMERR, "Symbol structure unallocated.",
+               "msAddImageSymbol()");
+    return (-1);
+  }
+
+  if (!filename || strlen(filename) == 0)
+    return (-1);
+
+  /* Allocate/init memory for new symbol if needed */
+  if (msGrowSymbolSet(symbolset) == NULL)
+    return -1;
+  symbolidx = symbolset->numsymbols;
+  symbolset->numsymbols++;
+  symbol = symbolset->symbol[symbolidx];
+
+  /* check if svg checking extension otherwise assume it's a pixmap */
+  extension = strrchr(filename, '.');
+  if (extension == NULL)
+    extension = "";
+  if (strncasecmp(extension, ".svg", 4) == 0) {
+    symbol->type = MS_SYMBOL_SVG;
+  } else {
+    symbol->type = MS_SYMBOL_PIXMAP;
+  }
+
+#ifdef USE_CURL
+  if (strncasecmp(filename, "http", 4) == 0) {
+    char *tmpfullfilename = NULL;
+    char *tmpfilename = NULL;
+    char *tmppath = NULL;
+    int status = 0;
+    char szPath[MS_MAXPATHLEN];
+    int bCheckLocalCache = MS_TRUE;
+
+    tmppath = msTmpPath(NULL, NULL, NULL);
+    if (tmppath) {
+      tmpfilename = msEncodeUrl(filename);
+      tmpfullfilename = msBuildPath(szPath, tmppath, tmpfilename);
+      if (tmpfullfilename) {
+        /*use the url for now as a caching mechanism*/
+        if (msHTTPGetFile(filename, tmpfullfilename, &status, -1,
+                          bCheckLocalCache, 0,
+                          1024 * 1024 /* 1 MegaByte */) == MS_SUCCESS) {
+          symbol->imagepath = msStrdup(tmpfullfilename);
+          symbol->full_pixmap_path = msStrdup(tmpfullfilename);
+        } else {
+          unlink(tmpfullfilename);
+          msFree(tmpfilename);
+          msFree(tmppath);
+          return -1;
+        }
+      }
+      msFree(tmpfilename);
+      msFree(tmppath);
+    }
+  }
+#endif
+  /*if the http did not work, allow it to be treated as a file*/
+  if (!symbol->full_pixmap_path) {
+    if (symbolset->map) {
+      symbol->full_pixmap_path =
+          msStrdup(msBuildPath(szPath, symbolset->map->mappath, filename));
+    } else {
+      symbol->full_pixmap_path = msStrdup(msBuildPath(szPath, NULL, filename));
+    }
+    symbol->imagepath = msStrdup(filename);
+  }
+  symbol->name = msStrdup(filename);
+  return symbolidx;
+}
+
+int msFreeSymbolSet(symbolSetObj *symbolset) {
+  int i;
+
+  freeImageCache(symbolset->imagecache);
+  for (i = 0; i < symbolset->numsymbols; i++) {
+    if (symbolset->symbol[i] != NULL) {
+      if (msFreeSymbol((symbolset->symbol[i])) == MS_SUCCESS) {
+        msFree(symbolset->symbol[i]);
+        symbolset->symbol[i] = NULL;
+      }
+    }
+  }
+  msFree(symbolset->symbol);
+
+  /* no need to deal with fontset, it's a pointer */
+  return MS_SUCCESS;
+}
+
+void msInitSymbolSet(symbolSetObj *symbolset) {
+  symbolset->filename = NULL;
+
+  symbolset->imagecache = NULL;
+  symbolset->imagecachesize = 0; /* 0 symbols in the cache */
+
+  symbolset->fontset = NULL;
+  symbolset->map = NULL;
+
+  symbolset->numsymbols = 0;
+  symbolset->maxsymbols = 0;
+  symbolset->symbol = NULL;
+
+  /* Alloc symbol[] array and ensure there is at least 1 symbol:
+   * symbol 0 which is the default symbol with all default params.
+   */
+  symbolObj *symbol = msGrowSymbolSet(symbolset);
+  if (symbol == NULL)
+    return; /* alloc failed */
+  symbol->type = MS_SYMBOL_ELLIPSE;
+  symbol->filled = MS_TRUE;
+  symbol->numpoints = 1;
+  symbol->points[0].x = 1;
+  symbol->points[0].y = 1;
+
+  /* Just increment numsymbols to reserve symbol 0.
+   * initSymbol() has already been called
+   */
+  symbolset->numsymbols = 1;
+}
+
+/*
+** Ensure there is at least one free entry in the symbol array of this
+** symbolSetObj. Grow the allocated symbol[] array if necessary and
+** allocate a new symbol for symbol[numsymbols] if there is not already one
+** and call initSymbol() on it.
+**
+** This function is safe to use for the initial allocation of the symbol[]
+** array as well (i.e. when maxsymbols==0 and symbol==NULL)
+**
+** Returns a reference to the new symbolObj on success, NULL on error.
+*/
+symbolObj *msGrowSymbolSet(symbolSetObj *symbolset) {
+  /* Do we need to increase the size of symbol[] by MS_SYMBOL_ALLOCSIZE? */
+  if (symbolset->numsymbols == symbolset->maxsymbols) {
+    int i;
+    if (symbolset->maxsymbols == 0) {
+      /* Initial allocation of array */
+      symbolset->maxsymbols += MS_SYMBOL_ALLOCSIZE;
+      symbolset->numsymbols = 0;
+      symbolset->symbol =
+          (symbolObj **)malloc(symbolset->maxsymbols * sizeof(symbolObj *));
+    } else {
+      /* realloc existing array */
+      symbolset->maxsymbols += MS_SYMBOL_ALLOCSIZE;
+      symbolset->symbol = (symbolObj **)realloc(
+          symbolset->symbol, symbolset->maxsymbols * sizeof(symbolObj *));
+    }
+
+    if (symbolset->symbol == NULL) {
+      msSetError(MS_MEMERR, "Failed to allocate memory for symbol array.",
+                 "msGrowSymbolSet()");
+      return NULL;
+    }
+
+    for (i = symbolset->numsymbols; i < symbolset->maxsymbols; i++)
+      symbolset->symbol[i] = NULL;
+  }
+
+  if (symbolset->symbol[symbolset->numsymbols] == NULL) {
+    symbolset->symbol[symbolset->numsymbols] =
+        (symbolObj *)malloc(sizeof(symbolObj));
+    if (symbolset->symbol[symbolset->numsymbols] == NULL) {
+      msSetError(MS_MEMERR, "Failed to allocate memory for a symbolObj",
+                 "msGrowSymbolSet()");
+      return NULL;
+    }
+  }
+
+  /* Always call initSymbol() even if we didn't allocate a new symbolObj
+   * Since it's possible to dynamically remove/reuse symbols */
+  initSymbol(symbolset->symbol[symbolset->numsymbols]);
+
+  return symbolset->symbol[symbolset->numsymbols];
+}
+
+/* ---------------------------------------------------------------------------
+   msLoadSymbolSet and loadSymbolSet
+
+   msLoadSymbolSet wraps calls to loadSymbolSet with mutex acquisition and
+   release.  It should be used everywhere outside the mapfile loading
+   phase of an application.  loadSymbolSet should only be used when a mutex
+   exists.  It does not check for existence of a mutex!
+
+   See bug 339 for more details -- SG.
+   ------------------------------------------------------------------------ */
+
+int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map) {
+  int retval = MS_FAILURE;
+
+  msAcquireLock(TLOCK_PARSER);
+  retval = loadSymbolSet(symbolset, map);
+  msReleaseLock(TLOCK_PARSER);
+
+  return retval;
+}
+
+int loadSymbolSet(symbolSetObj *symbolset, mapObj *map) {
+  int status = 1;
+  char szPath[MS_MAXPATHLEN], *pszSymbolPath = NULL;
+
+  int foundSymbolSetToken = MS_FALSE;
+  int symbolSetLevel = 0;
+  int token;
+
+  if (!symbolset) {
+    msSetError(MS_SYMERR, "Symbol structure unallocated.", "loadSymbolSet()");
+    return (-1);
+  }
+
+  symbolset->map = (mapObj *)map;
+
+  if (!symbolset->filename)
+    return (0);
+
+  /*
+  ** Open the file
+  */
+  if ((msyyin = fopen(
+           msBuildPath(szPath, symbolset->map->mappath, symbolset->filename),
+           "r")) == NULL) {
+    msSetError(MS_IOERR, "(%s)", "loadSymbolSet()", symbolset->filename);
+    return (-1);
+  }
+
+  pszSymbolPath = msGetPath(szPath);
+
+  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return
+                                   comments */
+  msyylex(); /* sets things up, but doesn't process any tokens */
+
+  msyylineno = 0;      /* reset line counter */
+  msyyrestart(msyyin); /* flush the scanner - there's a better way but this
+                          works for now */
+
+  /*
+  ** Read the symbol file
+  */
+  for (;;) {
+    token = msyylex();
+
+    if (!foundSymbolSetToken && token != SYMBOLSET) {
+      msSetError(MS_IDENTERR,
+                 "First token must be SYMBOLSET, this doesn't look like a "
+                 "symbol file.",
+                 "msLoadSymbolSet()");
+      status = -1;
+      break;
+    }
+
+    switch (token) {
+    case (END):
+      if (--symbolSetLevel < 0) {
+        msSetError(
+            MS_IDENTERR,
+            "END token found outside SYMBOLSET context. When nesting multiple "
+            "SYMBOLSETs, make sure the SYMBOLSET/END pairs match.",
+            "msLoadSymbolSet()");
+        status = -1;
+      }
+      break;
+    case (EOF):
+      status = 0;
+      break;
+    case (SYMBOL):
+      /* Allocate/init memory for new symbol if needed */
+      if (symbolSetLevel == 0) {
+        msSetError(
+            MS_IDENTERR,
+            "SYMBOL token found outside SYMBOLSET context. When nesting "
+            "multiple SYMBOLSETs, make sure the SYMBOLSET/END pairs match.",
+            "msLoadSymbolSet()");
+        status = -1;
+      } else if (msGrowSymbolSet(symbolset) == NULL) {
+        status = -1;
+      } else if ((loadSymbol((symbolset->symbol[symbolset->numsymbols]),
+                             pszSymbolPath) == -1))
+        status = -1;
+      else
+        symbolset->numsymbols++;
+      break;
+    case (SYMBOLSET):
+      foundSymbolSetToken = MS_TRUE;
+      symbolSetLevel++;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadSymbolSet()", msyystring_buffer, msyylineno);
+      status = -1;
+    } /* end switch */
+
+    if (status != 1)
+      break;
+  } /* end for */
+
+  fclose(msyyin);
+  msyyin = NULL;
+  free(pszSymbolPath);
+  return (status);
+}
+
+int msGetCharacterSize(mapObj *map, const char *font, int size,
+                       const char *character, rectObj *r) {
+  unsigned int unicode, codepoint;
+  glyph_element *glyph;
+  face_element *face = msGetFontFace(font, &map->fontset);
+  if (MS_UNLIKELY(!face))
+    return MS_FAILURE;
+  msUTF8ToUniChar(character, &unicode);
+  codepoint = msGetGlyphIndex(face, unicode);
+  glyph = msGetGlyphByIndex(face, size, codepoint);
+  if (MS_UNLIKELY(!glyph))
+    return MS_FAILURE;
+  r->minx = glyph->metrics.minx;
+  r->maxx = glyph->metrics.maxx;
+  r->miny = -glyph->metrics.maxy;
+  r->maxy = -glyph->metrics.miny;
+  return MS_SUCCESS;
+}
+
+/*
+** Returns the size, in pixels, of a marker symbol defined by a specific style
+*and scalefactor. Used for annotation
+** layer collision avoidance. A marker is made up of a number of styles so the
+*calling code must either do the looping
+** itself or call this function for the bottom style which should be the
+*largest.
+*/
+int msGetMarkerSize(mapObj *map, styleObj *style, double *width, double *height,
+                    double scalefactor) {
+  int size;
+  symbolObj *symbol;
+  *width = *height = 0; /* set a starting value */
+
+  if (style->symbol > map->symbolset.numsymbols || style->symbol < 0)
+    return (MS_FAILURE); /* no such symbol, 0 is OK */
+
+  if (style->symbol == 0) { /* single point */
+    *width = 1;
+    *height = 1;
+    return (MS_SUCCESS);
+  }
+
+  symbol = map->symbolset.symbol[style->symbol];
+  if (symbol->type == MS_SYMBOL_PIXMAP && !symbol->pixmap_buffer) {
+    if (MS_SUCCESS != msPreloadImageSymbol(MS_MAP_RENDERER(map), symbol))
+      return MS_FAILURE;
+  }
+  if (symbol->type == MS_SYMBOL_SVG && !symbol->renderer_cache) {
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+    if (MS_SUCCESS != msPreloadSVGSymbol(symbol))
+      return MS_FAILURE;
+#else
+    msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+               "msGetMarkerSize()");
+    return MS_FAILURE;
+#endif
+  }
+  if (style->size == -1) {
+    size = (msSymbolGetDefaultSize(symbol) * scalefactor);
+  } else
+    size = (style->size * scalefactor);
+  size = MS_MAX(size, style->minsize);
+  size = MS_MIN(size, style->maxsize);
+
+  switch (symbol->type) {
+
+  case (MS_SYMBOL_TRUETYPE): {
+    rectObj gbounds;
+    if (MS_UNLIKELY(MS_FAILURE == msGetCharacterSize(map, symbol->font, size,
+                                                     symbol->character,
+                                                     &gbounds)))
+      return MS_FAILURE;
+
+    *width = MS_MAX(*width, (gbounds.maxx - gbounds.minx));
+    *height = MS_MAX(*height, (gbounds.maxy - gbounds.miny));
+  }
+
+  break;
+
+  case (MS_SYMBOL_PIXMAP):
+    if (size == 1) {
+      *width = MS_MAX(*width, symbol->pixmap_buffer->width);
+      *height = MS_MAX(*height, symbol->pixmap_buffer->height);
+    } else {
+      *width = MS_MAX(*width,
+                      (((double)size / (double)symbol->pixmap_buffer->height) *
+                       symbol->pixmap_buffer->width));
+      *height = MS_MAX(*height, size);
+    }
+    break;
+  default: /* vector and ellipses, scalable */
+    if (style->size > 0) {
+      *width = MS_MAX(*width, ((size / symbol->sizey) * symbol->sizex));
+      *height = MS_MAX(*height, size);
+    } else { /* use symbol defaults */
+      *width = MS_MAX(*width, symbol->sizex);
+      *height = MS_MAX(*height, symbol->sizey);
+    }
+    break;
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*
+ * Add a default new symbol. If the symbol name exists
+ * return the id of the symbol.
+ */
+int msAddNewSymbol(mapObj *map, const char *name) {
+  int i = 0;
+
+  if (!map || !name)
+    return -1;
+
+  i = msGetSymbolIndex(&map->symbolset, name, MS_TRUE);
+  if (i >= 0)
+    return i;
+
+  /* Allocate memory for new symbol if needed */
+  if (msGrowSymbolSet(&(map->symbolset)) == NULL)
+    return -1;
+
+  i = map->symbolset.numsymbols;
+  map->symbolset.symbol[i]->name = msStrdup(name);
+
+  map->symbolset.numsymbols++;
+
+  return i;
+}
+
+/* msAppendSymbol and msRemoveSymbol are part of the work to resolve
+ * MapServer bug 579.
+ * http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=579 */
+
+int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol) {
+  /* Allocate memory for new symbol if needed */
+  if (msGrowSymbolSet(symbolset) == NULL)
+    return -1;
+
+  /* we need to free the symbolObj that was already allocated as we are
+   going to replace it with the provided symbolObj*. Not the most efficient
+   technique, but this function should be rarely called, and in any case only
+   by mapscript. Another option could be to use msCopySymbol(), in which case
+   the call to MS_REFCNT_INCR(symbol) should be removed.*/
+  if (symbolset->symbol[symbolset->numsymbols]) {
+    msFreeSymbol(symbolset->symbol[symbolset->numsymbols]);
+    msFree(symbolset->symbol[symbolset->numsymbols]);
+  }
+  symbolset->symbol[symbolset->numsymbols] = symbol;
+  MS_REFCNT_INCR(symbol);
+  return symbolset->numsymbols++;
+}
+
+symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int nSymbolIndex) {
+  int i;
+  symbolObj *symbol;
+  if (symbolset->numsymbols == 1) {
+    msSetError(MS_CHILDERR, "Cannot remove a symbolset's sole symbol",
+               "removeSymbol()");
+    return NULL;
+  } else if (nSymbolIndex < 0 || nSymbolIndex >= symbolset->numsymbols) {
+    msSetError(MS_CHILDERR, "Cannot remove symbol, invalid nSymbolIndex %d",
+               "removeSymbol()", nSymbolIndex);
+    return NULL;
+  } else {
+    symbol = symbolset->symbol[nSymbolIndex];
+    for (i = nSymbolIndex + 1; i < symbolset->numsymbols; i++) {
+      symbolset->symbol[i - 1] = symbolset->symbol[i];
+    }
+    symbolset->symbol[i - 1] = NULL;
+    symbolset->numsymbols--;
+    MS_REFCNT_DECR(symbol);
+    /* update symbol references in the map */
+    if (symbolset->map) {
+      int l, c, s, lb;
+      layerObj *layer;
+      classObj *cl;
+      styleObj *style;
+      labelObj *label;
+      for (l = 0; l < symbolset->map->numlayers; l++) {
+        layer = GET_LAYER(symbolset->map, l);
+        for (c = 0; c < layer->numclasses; c++) {
+          cl = layer->class[c];
+          for (s = 0; s < cl->numstyles; s++) {
+            style = cl->styles[s];
+            if (style->symbol >= nSymbolIndex)
+              --style->symbol;
+          }
+          for (lb = 0; lb < cl->numlabels; lb++) {
+            label = cl->labels[lb];
+            for (s = 0; s < label->numstyles; s++) {
+              style = label->styles[s];
+              if (style->symbol >= nSymbolIndex)
+                --style->symbol;
+            }
+          }
+        }
+      }
+      /* Update symbol references in labelcache */
+      for (c = 0; c < MS_MAX_LABEL_PRIORITY; c++) {
+        labelCacheSlotObj *cacheslot = &(symbolset->map->labelcache.slots[c]);
+        for (l = 0; l < cacheslot->numlabels; l++) {
+          labelCacheMemberObj *cachePtr = &(cacheslot->labels[l]);
+          for (lb = 0; lb < cachePtr->numtextsymbols; lb++) {
+            label = cachePtr->textsymbols[lb]->label;
+            for (s = 0; s < label->numstyles; s++) {
+              style = label->styles[s];
+              if (style->symbol >= nSymbolIndex)
+                --style->symbol;
+            }
+          }
+        }
+      }
+    }
+    return symbol;
+  }
+}
+
+int msSaveSymbolSetStream(symbolSetObj *symbolset, FILE *stream) {
+  int i;
+  if (!symbolset || !stream) {
+    msSetError(MS_SYMERR, "Cannot save symbolset.", "msSaveSymbolSetStream()");
+    return MS_FAILURE;
+  }
+  /* Don't ever write out the default symbol at index 0 */
+  for (i = 1; i < symbolset->numsymbols; i++) {
+    if (!symbolset->symbol[i]->inmapfile)
+      writeSymbol((symbolset->symbol[i]), stream);
+  }
+  return MS_SUCCESS;
+}
+
+int msSaveSymbolSet(symbolSetObj *symbolset, const char *filename) {
+  FILE *stream;
+  int retval;
+  if (!filename || strlen(filename) == 0) {
+    msSetError(MS_SYMERR, "Invalid filename.", "msSaveSymbolSet()");
+    return MS_FAILURE;
+  }
+  stream = fopen(filename, "w");
+  if (stream) {
+    fprintf(stream, "SYMBOLSET\n");
+    retval = msSaveSymbolSetStream(symbolset, stream);
+    fprintf(stream, "END\n");
+    fclose(stream);
+  } else {
+    msSetError(MS_SYMERR, "Could not write to %s", "msSaveSymbolSet()",
+               filename);
+    retval = MS_FAILURE;
+  }
+  return retval;
+}
+
+int msLoadImageSymbol(symbolObj *symbol, const char *filename) {
+  msFree(symbol->full_pixmap_path);
+  symbol->full_pixmap_path = msStrdup(filename);
+  return MS_SUCCESS;
+}
+
+int msPreloadImageSymbol(rendererVTableObj *renderer, symbolObj *symbol) {
+  if (symbol->pixmap_buffer && symbol->renderer == renderer)
+    return MS_SUCCESS;
+  if (symbol->pixmap_buffer) { /* other renderer was used, start again */
+    msFreeRasterBuffer(symbol->pixmap_buffer);
+  } else {
+    symbol->pixmap_buffer =
+        (rasterBufferObj *)calloc(1, sizeof(rasterBufferObj));
+  }
+  if (MS_SUCCESS != renderer->loadImageFromFile(symbol->full_pixmap_path,
+                                                symbol->pixmap_buffer)) {
+    /* Free pixmap_buffer already allocated */
+    free(symbol->pixmap_buffer);
+    symbol->pixmap_buffer = NULL;
+    return MS_FAILURE;
+  }
+  symbol->renderer = renderer;
+  symbol->sizex = symbol->pixmap_buffer->width;
+  symbol->sizey = symbol->pixmap_buffer->height;
+  return MS_SUCCESS;
+}
+
+/***********************************************************************
+ * msCopySymbol()                                                      *
+ *                                                                     *
+ * Copy a symbolObj, using mapfile.c:initSymbol(), msCopyPoint()       *
+ * gdImageCreate(), gdImageCopy()                                      *
+ **********************************************************************/
+
+int msCopySymbol(symbolObj *dst, const symbolObj *src, mapObj *map) {
+  int i;
+
+  initSymbol(dst);
+
+  MS_COPYSTRING(dst->name, src->name);
+  MS_COPYSTELEM(type);
+  MS_COPYSTELEM(inmapfile);
+
+  /* map is a special case */
+  dst->map = map;
+
+  MS_COPYSTELEM(sizex);
+  MS_COPYSTELEM(sizey);
+  MS_COPYSTELEM(anchorpoint_x);
+  MS_COPYSTELEM(anchorpoint_y);
+
+  for (i = 0; i < src->numpoints; i++) {
+    MS_COPYPOINT(&(dst->points[i]), &(src->points[i]));
+  }
+
+  MS_COPYSTELEM(numpoints);
+  MS_COPYSTELEM(filled);
+
+  MS_COPYSTRING(dst->imagepath, src->imagepath);
+  MS_COPYSTELEM(transparent);
+  MS_COPYSTELEM(transparentcolor);
+  MS_COPYSTRING(dst->character, src->character);
+  MS_COPYSTRING(dst->font, src->font);
+  MS_COPYSTRING(dst->full_pixmap_path, src->full_pixmap_path);
+
+  return (MS_SUCCESS);
+}
+
+/***********************************************************************
+ * msCopySymbolSet()                                                   *
+ *                                                                     *
+ * Copy a symbolSetObj using msCopyFontSet(), msCopySymbol()           *
+ **********************************************************************/
+
+int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src, mapObj *map) {
+  int i, return_value;
+
+  MS_COPYSTRING(dst->filename, src->filename);
+
+  dst->map = map;
+  dst->fontset = &(map->fontset);
+
+  /* Copy child symbols */
+  for (i = 0; i < src->numsymbols; i++) {
+    if (msGrowSymbolSet(dst) == NULL)
+      return MS_FAILURE;
+    return_value = msCopySymbol(dst->symbol[i], src->symbol[i], map);
+    if (return_value != MS_SUCCESS) {
+      msSetError(MS_MEMERR, "Failed to copy symbol.", "msCopySymbolSet()");
+      return (MS_FAILURE);
+    }
+    dst->numsymbols++;
+  }
+
+  /* MS_COPYSTELEM(imagecachesize); */
+
+  /* I have a feeling that the code below is not quite right - Sean */
+  /*copyProperty(&(dst->imagecache), &(src->imagecache),
+               sizeof(struct imageCacheObj));
+   */
+
+  dst->imagecachesize = 0; /* since we are not copying the cache set the cache
+                              to NUNLL and the size to 0 (bug 1521) */
+  dst->imagecache = NULL;
+
+  return (MS_SUCCESS);
+}
+
+static void get_bbox(pointObj *poiList, int numpoints, double *minx,
+                     double *miny, double *maxx, double *maxy) {
+  int j;
+
+  *minx = *maxx = poiList[0].x;
+  *miny = *maxy = poiList[0].y;
+  for (j = 1; j < numpoints; j++) {
+    if ((poiList[j].x == -99.0) || (poiList[j].y == -99.0))
+      continue;
+    *minx = MS_MIN(*minx, poiList[j].x);
+    *maxx = MS_MAX(*maxx, poiList[j].x);
+    *miny = MS_MIN(*miny, poiList[j].y);
+    *maxy = MS_MAX(*maxy, poiList[j].y);
+  }
+
+  return;
+}
+
+/*
+ ** msRotateSymbol - Clockwise rotation of a symbol definition. Contributed
+ ** by MapMedia, with clean up by SDL. Currently only type VECTOR and PIXMAP
+ ** symbols are handled.
+ */
+symbolObj *msRotateVectorSymbol(symbolObj *symbol, double angle) {
+  double angle_rad = 0.0;
+  double cos_a, sin_a;
+  double minx = 0.0, miny = 0.0, maxx = 0.0, maxy = 0.0;
+  symbolObj *newSymbol = NULL;
+  double dp_x, dp_y, xcor, ycor;
+  double TOL = 0.00000000001;
+  int i;
+
+  /* assert(symbol->type == MS_SYMBOL_VECTOR); */
+
+  newSymbol = (symbolObj *)malloc(sizeof(symbolObj));
+  msCopySymbol(
+      newSymbol, symbol,
+      NULL); /* TODO: do we really want to do this for all symbol types? */
+
+  angle_rad = (MS_DEG_TO_RAD * angle);
+
+  sin_a = sin(angle_rad);
+  cos_a = cos(angle_rad);
+
+  dp_x = symbol->sizex * .5; /* get the shift vector at 0,0 */
+  dp_y = symbol->sizey * .5;
+
+  /* center at 0,0 and rotate; then move back */
+  for (i = 0; i < symbol->numpoints; i++) {
+    /* don't rotate PENUP commands (TODO: should use a constant here) */
+    if ((symbol->points[i].x == -99.0) && (symbol->points[i].y == -99.0)) {
+      newSymbol->points[i].x = -99.0;
+      newSymbol->points[i].y = -99.0;
+      continue;
+    }
+
+    newSymbol->points[i].x = dp_x + ((symbol->points[i].x - dp_x) * cos_a -
+                                     (symbol->points[i].y - dp_y) * sin_a);
+    newSymbol->points[i].y = dp_y + ((symbol->points[i].x - dp_x) * sin_a +
+                                     (symbol->points[i].y - dp_y) * cos_a);
+  }
+
+  /* get the new bbox of the symbol, because we need it to get the new
+   * dimensions of the new symbol */
+  get_bbox(newSymbol->points, newSymbol->numpoints, &minx, &miny, &maxx, &maxy);
+  if ((fabs(minx) > TOL) || (fabs(miny) > TOL)) {
+    xcor =
+        minx * -1.0; /* symbols always start at 0,0 so get the shift vector */
+    ycor = miny * -1.0;
+    for (i = 0; i < newSymbol->numpoints; i++) {
+      if ((newSymbol->points[i].x == -99.0) &&
+          (newSymbol->points[i].y == -99.0))
+        continue;
+      newSymbol->points[i].x = newSymbol->points[i].x + xcor;
+      newSymbol->points[i].y = newSymbol->points[i].y + ycor;
+    }
+
+    /* update the bbox to get the final dimension values for the symbol */
+    get_bbox(newSymbol->points, newSymbol->numpoints, &minx, &miny, &maxx,
+             &maxy);
+  }
+
+  newSymbol->sizex = maxx;
+  newSymbol->sizey = maxy;
+  return newSymbol;
+}
diff -pruN 8.0.1-5/src/mapsymbol.h 8.2.0~beta1-1~exp1/src/mapsymbol.h
--- 8.0.1-5/src/mapsymbol.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapsymbol.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,240 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  symbolObj related declarations.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPSYMBOL_H
+#define MAPSYMBOL_H
+
+#include "mapserver-api.h"
+#include <assert.h>
+
+enum MS_SYMBOL_TYPE {
+  MS_SYMBOL_SIMPLE = 1000,
+  MS_SYMBOL_VECTOR,
+  MS_SYMBOL_ELLIPSE,
+  MS_SYMBOL_PIXMAP,
+  MS_SYMBOL_TRUETYPE,
+  MS_SYMBOL_HATCH,
+  MS_SYMBOL_SVG
+};
+
+#define MS_SYMBOL_ALLOCSIZE                                                    \
+  64 /* number of symbolObj ptrs to allocate for a symbolset at once */
+#define MS_MAXVECTORPOINTS 100 /* shade, marker and line symbol parameters */
+#define MS_MAXPATTERNLENGTH 10
+
+#define MS_IMAGECACHESIZE 6
+
+/* COLOR OBJECT */
+typedef struct {
+#ifdef SWIG
+  %feature("docstring", "An object representing a color.") colorObj;
+  %feature("docstring", "Red component of color in range [0-255]") red;
+  %feature("docstring", "Green component of color in range [0-255]") green;
+  %feature("docstring", "Blue component of color in range [0-255]") blue;
+  %feature("docstring", "Alpha (opacity) component of color in range [0-255]") alpha;
+#endif /* SWIG */
+  int red;
+  int green;
+  int blue;
+  int alpha;
+} colorObj;
+
+#ifndef SWIG
+enum MS_RASTER_BUFFER_TYPE {
+  MS_BUFFER_NONE = 2000,
+  MS_BUFFER_BYTE_RGBA,
+  MS_BUFFER_BYTE_PALETTE
+};
+
+typedef struct {
+  unsigned char *pixels;
+  unsigned int pixel_step, row_step;
+  unsigned char *a, *r, *g, *b;
+} rgbaArrayObj;
+
+typedef struct {
+  unsigned char b, g, r, a;
+} rgbaPixel;
+
+typedef struct {
+  unsigned char r, g, b;
+} rgbPixel;
+
+typedef struct {
+  unsigned char *pixels;    /*stores the actual pixel indexes*/
+  rgbaPixel *palette;       /*rgba palette entries*/
+  unsigned int num_entries; /*number of palette entries*/
+  unsigned int scaling_maxval;
+} paletteArrayObj;
+
+typedef struct {
+  int type;
+  unsigned int width, height;
+  union {
+    rgbaArrayObj rgba;
+    paletteArrayObj palette;
+  } data;
+} rasterBufferObj;
+
+/* NOTE: RB_SET_PIXEL() will premultiply by alpha, inputs should not be
+         premultiplied */
+
+#define RB_SET_PIXEL(rb, x, y, red, green, blue, alpha)                        \
+  {                                                                            \
+    int _rb_off =                                                              \
+        (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;     \
+    if (!(rb)->data.rgba.a) {                                                  \
+      (rb)->data.rgba.r[_rb_off] = red;                                        \
+      (rb)->data.rgba.g[_rb_off] = green;                                      \
+      (rb)->data.rgba.b[_rb_off] = blue;                                       \
+    } else {                                                                   \
+      double a = alpha / 255.0;                                                \
+      (rb)->data.rgba.r[_rb_off] = red * a;                                    \
+      (rb)->data.rgba.g[_rb_off] = green * a;                                  \
+      (rb)->data.rgba.b[_rb_off] = blue * a;                                   \
+      (rb)->data.rgba.a[_rb_off] = alpha;                                      \
+    }                                                                          \
+  }
+
+/* This versions receives an input red/green/blue that is already
+   premultiplied with alpha */
+#define RB_SET_PIXEL_PM(rb, x, y, red, green, blue, alpha)                     \
+  {                                                                            \
+    int _rb_off =                                                              \
+        (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;     \
+    (rb)->data.rgba.r[_rb_off] = red;                                          \
+    (rb)->data.rgba.g[_rb_off] = green;                                        \
+    (rb)->data.rgba.b[_rb_off] = blue;                                         \
+    if (rb->data.rgba.a) {                                                     \
+      (rb)->data.rgba.a[_rb_off] = alpha;                                      \
+    }                                                                          \
+  }
+
+/* NOTE: RB_MIX_PIXEL() will premultiply by alpha, inputs should not be
+         premultiplied */
+
+#define RB_MIX_PIXEL(rb, x, y, red, green, blue, alpha)                        \
+  {                                                                            \
+    int _rb_off =                                                              \
+        (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;     \
+                                                                               \
+    msAlphaBlend(red, green, blue, alpha, (rb)->data.rgba.r + _rb_off,         \
+                 (rb)->data.rgba.g + _rb_off, (rb)->data.rgba.b + _rb_off,     \
+                 ((rb)->data.rgba.a == NULL) ? NULL                            \
+                                             : (rb)->data.rgba.a + _rb_off);   \
+  }
+
+struct imageCacheObj {
+  int symbol;
+  int size;
+  colorObj color;
+  colorObj outlinecolor;
+  colorObj backgroundcolor;
+  rasterBufferObj img;
+  struct imageCacheObj *next;
+};
+
+#endif /* SWIG */
+
+/**
+The :ref:`SYMBOL <symbol>` object
+*/
+struct symbolObj {
+
+  /*
+  ** MS_SYMBOL_PIXMAP options
+  */
+#ifndef SWIG
+  rendererVTableObj *renderer;
+  void (*renderer_free_func)(symbolObj *self);
+  rasterBufferObj *pixmap_buffer;
+  void *renderer_cache;
+  char *full_pixmap_path;
+
+  /*
+  ** Pointer to his map
+  */
+  struct mapObj *map;
+
+  pointObj points[MS_MAXVECTORPOINTS];
+
+#endif /* SWIG */
+
+#ifdef SWIG
+    %immutable;
+#endif             /* SWIG */
+  int refcount;    ///< Reference counter
+  int numpoints;   ///< Number of points of a vector symbol
+  char *imagepath; ///< Path to pixmap file - see :ref:`IMAGE
+                   ///< <mapfile-symbol-image>`
+
+#ifdef SWIG
+    %mutable;
+#endif /* SWIG */
+
+  char *name;    ///< Symbol name - see :ref:`NAME <mapfile-symbol-name>`
+  int type;      ///< See :ref:`TYPE <mapfile-symbol-type>`
+  int inmapfile; ///< Boolean value for writing - if set to :data:`TRUE`, the
+                 ///< symbol will be saved inside the Mapfile. Added in
+                 ///< MapServer 5.6.1
+
+  /*
+  ** MS_SYMBOL_VECTOR and MS_SYMBOL_ELLIPSE options
+  */
+  double
+      sizex; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      sizey; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+
+  double
+      minx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      miny; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      maxx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      maxy; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+
+  int filled; ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`FILLED
+              ///< <mapfile-symbol-filled>`
+  double anchorpoint_x; ///< See :ref:`ANCHORPOINT <mapfile-symbol-anchorpoint>`
+  double anchorpoint_y; ///< See :ref:`ANCHORPOINT <mapfile-symbol-anchorpoint>`
+
+  int transparent;      ///< \**TODO** Remove
+  int transparentcolor; ///< \**TODO** Remove
+
+  /*
+  ** MS_SYMBOL_TRUETYPE options
+  */
+  char *character; ///< For TrueType symbols - see :ref:`CHARACTER
+                   ///< <mapfile-symbol-character>`
+  char *font; ///< For TrueType symbols - see :ref:`FONT <mapfile-symbol-font>`
+};
+
+#endif /* MAPSYMBOL_H */
diff -pruN 8.0.1-5/src/maptclutf.c 8.2.0~beta1-1~exp1/src/maptclutf.c
--- 8.0.1-5/src/maptclutf.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptclutf.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,324 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of msUTF8ToUniChar()
+ * Author:   Daniel Morissette, Thomas Bonfort
+ *
+ * Note:
+ * The source code of Tcl_UtfToUniChar() was borrowed from tclUtf.c
+ * from the Tcl/Tk project.
+ *
+ * Website: http://www.tcl.tk/software/tcltk/
+ * Source download: http://prdownloads.sourceforge.net/tcl/tcl8.4.15-src.tar.gz
+ *
+ * See copyright and license terms below the standard MapServer license.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ * Copyright (c) 1997-1998 Sun Microsystems, Inc.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/*
+ * tclUtf.c --
+ *
+ * Routines for manipulating UTF-8 strings.
+ *
+ * Copyright (c) 1997-1998 Sun Microsystems, Inc.
+ *
+ * This software is copyrighted by the Regents of the University of
+ * California, Sun Microsystems, Inc., Scriptics Corporation, ActiveState
+ * Corporation and other parties.  The following terms apply to all files
+ * associated with the software unless explicitly disclaimed in
+ * individual files.
+ *
+ * The authors hereby grant permission to use, copy, modify, distribute,
+ * and license this software and its documentation for any purpose, provided
+ * that existing copyright notices are retained in all copies and that this
+ * notice is included verbatim in any distributions. No written agreement,
+ * license, or royalty fee is required for any of the authorized uses.
+ * Modifications to this software may be copyrighted by their authors
+ * and need not follow the licensing terms described here, provided that
+ * the new terms are clearly indicated on the first page of each file where
+ * they apply.
+ *
+ * IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
+ * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
+ * ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
+ * DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ *
+ * THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
+ * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
+ * IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
+ * NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
+ * MODIFICATIONS.
+ *
+ * GOVERNMENT USE: If you are acquiring this software on behalf of the
+ * U.S. government, the Government shall have only "Restricted Rights"
+ * in the software and related documentation as defined in the Federal
+ * Acquisition Regulations (FARs) in Clause 52.227.19 (c) (2).  If you
+ * are acquiring the software on behalf of the Department of Defense, the
+ * software shall be classified as "Commercial Computer Software" and the
+ * Government shall have only "Restricted Rights" as defined in Clause
+ * 252.227-7013 (c) (1) of DFARs.  Notwithstanding the foregoing, the
+ * authors grant the U.S. Government and others acting in its behalf
+ * permission to use and distribute the software in accordance with the
+ * terms specified in this license.
+ */
+
+#include "mapserver.h"
+
+/* The source code of Tcl_UtfToUniChar() was borrowed from tclUtf.c
+ * from the Tcl/Tk project:
+ * Website:
+ *   http://www.tcl.tk/software/tcltk/
+ * Source download:
+ *   http://prdownloads.sourceforge.net/tcl/tcl8.4.15-src.tar.gz
+ * Original License info follows below.
+ */
+
+/*
+ * tclUtf.c --
+ *
+ *  Routines for manipulating UTF-8 strings.
+ *
+ * Copyright (c) 1997-1998 Sun Microsystems, Inc.
+ *
+ * See the file "license.terms" for information on usage and redistribution of
+ * this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ *
+ * Id: tclUtf.c,v 1.30.2.3 2005/09/07 14:35:56 dgp Exp
+ */
+
+/******************* Tcl license.terms *********************
+
+This software is copyrighted by the Regents of the University of
+California, Sun Microsystems, Inc., Scriptics Corporation, ActiveState
+Corporation and other parties.  The following terms apply to all files
+associated with the software unless explicitly disclaimed in
+individual files.
+
+The authors hereby grant permission to use, copy, modify, distribute,
+and license this software and its documentation for any purpose, provided
+that existing copyright notices are retained in all copies and that this
+notice is included verbatim in any distributions. No written agreement,
+license, or royalty fee is required for any of the authorized uses.
+Modifications to this software may be copyrighted by their authors
+and need not follow the licensing terms described here, provided that
+the new terms are clearly indicated on the first page of each file where
+they apply.
+
+IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
+FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
+ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
+DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGE.
+
+THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
+INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
+IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
+NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
+MODIFICATIONS.
+
+GOVERNMENT USE: If you are acquiring this software on behalf of the
+U.S. government, the Government shall have only "Restricted Rights"
+in the software and related documentation as defined in the Federal
+Acquisition Regulations (FARs) in Clause 52.227.19 (c) (2).  If you
+are acquiring the software on behalf of the Department of Defense, the
+software shall be classified as "Commercial Computer Software" and the
+Government shall have only "Restricted Rights" as defined in Clause
+252.227-7013 (c) (1) of DFARs.  Notwithstanding the foregoing, the
+authors grant the U.S. Government and others acting in its behalf
+permission to use and distribute the software in accordance with the
+terms specified in this license.
+
+***********************************************************/
+
+#define TCL_UTF_MAX 6
+
+/*
+ * The following structures are used when mapping between Unicode (UCS-2)
+ * and UTF-8.
+ */
+
+static const unsigned char totalBytes[256] = {
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
+    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
+#if TCL_UTF_MAX > 3
+    4, 4, 4, 4, 4, 4, 4, 4,
+#else
+    1, 1, 1, 1, 1, 1, 1, 1,
+#endif
+#if TCL_UTF_MAX > 4
+    5, 5, 5, 5,
+#else
+    1, 1, 1, 1,
+#endif
+#if TCL_UTF_MAX > 5
+    6, 6, 6, 6
+#else
+    1, 1, 1, 1
+#endif
+};
+
+/*
+ *---------------------------------------------------------------------------
+ *
+ * Tcl_UtfToUniChar --
+ *
+ *  Extract the Tcl_UniChar represented by the UTF-8 string.  Bad
+ *  UTF-8 sequences are converted to valid Tcl_UniChars and processing
+ *  continues.  Equivalent to Plan 9 chartorune().
+ *
+ *  The caller must ensure that the source buffer is long enough that
+ *  this routine does not run off the end and dereference non-existent
+ *  memory looking for trail bytes.  If the source buffer is known to
+ *  be '\0' terminated, this cannot happen.  Otherwise, the caller
+ *  should call Tcl_UtfCharComplete() before calling this routine to
+ *  ensure that enough bytes remain in the string.
+ *
+ * Results:
+ *  *chPtr is filled with the Tcl_UniChar, and the return value is the
+ *  number of bytes from the UTF-8 string that were consumed.
+ *
+ * Side effects:
+ *  None.
+ *
+ *---------------------------------------------------------------------------
+ */
+
+int ms_Tcl_UtfToUniChar(register const char *str,
+                        register unsigned int *chPtr) {
+  register int byte;
+
+  /*
+   * Unroll 1 to 3 byte UTF-8 sequences, use loop to handle longer ones.
+   */
+
+  byte = *((unsigned char *)str);
+  if (byte < 0xC0) {
+    /*
+     * Handles properly formed UTF-8 characters between 0x01 and 0x7F.
+     * Also treats \0 and naked trail bytes 0x80 to 0xBF as valid
+     * characters representing themselves.
+     */
+
+    *chPtr = byte;
+    return 1;
+  } else if (byte < 0xE0) {
+    if ((str[1] & 0xC0) == 0x80) {
+      /*
+       * Two-byte-character lead-byte followed by a trail-byte.
+       */
+
+      *chPtr = (((byte & 0x1F) << 6) | (str[1] & 0x3F));
+      return 2;
+    }
+    /*
+     * A two-byte-character lead-byte not followed by trail-byte
+     * represents itself.
+     */
+
+    *chPtr = byte;
+    return 1;
+  } else if (byte < 0xF0) {
+    if (((str[1] & 0xC0) == 0x80) && ((str[2] & 0xC0) == 0x80)) {
+      /*
+       * Three-byte-character lead byte followed by two trail bytes.
+       */
+
+      *chPtr =
+          (((byte & 0x0F) << 12) | ((str[1] & 0x3F) << 6) | (str[2] & 0x3F));
+      return 3;
+    }
+    /*
+     * A three-byte-character lead-byte not followed by two trail-bytes
+     * represents itself.
+     */
+
+    *chPtr = byte;
+    return 1;
+  }
+#if TCL_UTF_MAX > 3
+  else {
+    int ch, total, trail;
+
+    total = totalBytes[byte];
+    trail = total - 1;
+    if (trail > 0) {
+      ch = byte & (0x3F >> trail);
+      do {
+        str++;
+        if ((*str & 0xC0) != 0x80) {
+          *chPtr = byte;
+          return 1;
+        }
+        ch <<= 6;
+        ch |= (*str & 0x3F);
+        trail--;
+      } while (trail > 0);
+      *chPtr = ch;
+      return total;
+    }
+  }
+#endif
+
+  *chPtr = byte;
+  return 1;
+}
+
+/* msUTF8ToUniChar()
+ *
+ *  Extract the Unicode Char represented by the UTF-8 string.  Bad
+ *  UTF-8 sequences are converted to valid Unicode Chars and processing
+ *  continues.
+ *
+ *  The caller must ensure that the source buffer is long enough that
+ *  this routine does not run off the end and dereference non-existent
+ *  memory looking for trail bytes.  If the source buffer is known to
+ *  be '\0' terminated, this cannot happen.
+ *
+ * Results:
+ *  *chPtr is filled with the Unicode Char value, and the return value
+ *  is the number of bytes from the UTF-8 string that were consumed.
+ **
+ **/
+int msUTF8ToUniChar(const char *str,     /* The UTF-8 string. */
+                    unsigned int *chPtr) /* Filled with the Unicode Char
+                                          * represented by the UTF-8 string. */
+{
+  /*check if the string is an html entity (eg &#123; or &#x12a;)*/
+  int entitylgth;
+  if (*str == '&' && (entitylgth = msGetUnicodeEntity(str, chPtr)) > 0)
+    return entitylgth;
+  return ms_Tcl_UtfToUniChar(str, chPtr);
+}
diff -pruN 8.0.1-5/src/maptemplate.c 8.2.0~beta1-1~exp1/src/maptemplate.c
--- 8.0.1-5/src/maptemplate.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptemplate.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5430 @@
+/******************************************************************************
+ * $id: maptemplate.c 7725 2008-06-21 15:56:58Z sdlime $
+ *
+ * Project:  MapServer
+ * Purpose:  Various template processing functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2008 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#define NEED_IGNORE_RET_VAL
+
+#include "maptemplate.h"
+#include "maphash.h"
+#include "mapserver.h"
+#include "maptile.h"
+#include "mapows.h"
+
+#include "cpl_conv.h"
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <time.h>
+
+#include <assert.h>
+#include <ctype.h>
+
+static inline void IGUR_sizet(size_t ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
+static inline void IGUR_voidp(void *ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
+
+static const char *const olUrl = "//www.mapserver.org/lib/OpenLayers-ms60.js";
+static const char *const olTemplate =
+    "<html>\n"
+    "<head>\n"
+    "<meta content=\"text/html;charset=utf-8\" http-equiv=\"Content-Type\">\n"
+    "  <title>MapServer Simple Viewer</title>\n"
+    "    <script type=\"text/javascript\" "
+    "src=\"[openlayers_js_url]\"></script>\n"
+    "    <link rel=\"shortcut icon\" type=\"image/x-icon\" "
+    "href=\"//www.mapserver.org/_static/mapserver.ico\"/>\n"
+    "    </head>\n"
+    "    <body>\n"
+    "      <div style=\"width:[mapwidth]; height:[mapheight]\" "
+    "id=\"map\"></div>\n"
+    "      <script defer=\"defer\" type=\"text/javascript\">\n"
+    "        var map = new OpenLayers.Map('map',\n"
+    "                                     {maxExtent: new "
+    "OpenLayers.Bounds([minx],[miny],[maxx],[maxy]),\n"
+    "                                      maxResolution: [cellsize]});\n"
+    "        [openlayers_layer];\n"
+    "        map.addLayer(mslayer);\n"
+    "        map.zoomToMaxExtent();\n"
+    "      </script>\n"
+    "</body>\n"
+    "</html>";
+
+static const char *const olLayerMapServerTag =
+    "var mslayer = new OpenLayers.Layer.MapServer( \"MapServer Layer\",\n"
+    "                                              "
+    "\"[mapserv_onlineresource]\",\n"
+    "                                              {layers: '[layers]'},\n"
+    "                                              {singleTile: \"true\", "
+    "ratio:1} )";
+
+static const char *const olLayerWMSTag =
+    "var mslayer = new OpenLayers.Layer.WMS('MapServer Simple Viewer\',\n"
+    "                                   '[mapserv_onlineresource]',\n"
+    "                                   {layers: '[LAYERS]',\n"
+    "                                   bbox: '[minx],[miny],[maxx],[maxy]',\n"
+    "                                   width: [mapwidth], height: "
+    "[mapheight], version: '[VERSION]', format:'[openlayers_format]'},"
+    "                                   {singleTile: \"true\", ratio:1, "
+    "projection: '[openlayers_projection]'});\n";
+
+static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream,
+                         int mode);
+
+static int isValidTemplate(FILE *stream, const char *filename) {
+  char buffer[MS_BUFFER_LENGTH];
+
+  if (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+    if (!strcasestr(buffer, MS_TEMPLATE_MAGIC_STRING)) {
+      msSetError(
+          MS_WEBERR,
+          "Missing magic string, %s doesn't look like a MapServer template.",
+          "isValidTemplate()", filename);
+      return MS_FALSE;
+    }
+  }
+
+  return MS_TRUE;
+}
+
+/*
+ * Redirect to (only use in CGI)
+ *
+ */
+int msRedirect(const char *url) {
+  msIO_setHeader("Status", "302 Found");
+  msIO_setHeader("Uri", "%s", url);
+  msIO_setHeader("Location", "%s", url);
+  msIO_setHeader("Content-Type", "text/html");
+  msIO_sendHeaders();
+  return MS_SUCCESS;
+}
+
+/*
+** Sets the map extent under a variety of scenarios.
+*/
+int setExtent(mapservObj *mapserv) {
+  double cellx, celly, cellsize;
+
+  if (mapserv->Mode == TILE) {
+    if (MS_SUCCESS != msTileSetExtent(mapserv)) {
+      return MS_FAILURE;
+    }
+  }
+  switch (mapserv->CoordSource) {
+  case FROMUSERBOX: /* user passed in a map extent */
+    break;
+  case FROMIMGBOX: /* fully interactive web, most likely with java front end */
+    cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx,
+                        mapserv->ImgCols);
+    celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy,
+                        mapserv->ImgRows);
+    mapserv->map->extent.minx =
+        MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
+    mapserv->map->extent.maxx =
+        MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
+    mapserv->map->extent.maxy =
+        MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy,
+                       celly); /* y's are flip flopped because img/map
+                                  coordinate systems are */
+    mapserv->map->extent.miny =
+        MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
+    break;
+  case FROMIMGPNT:
+    cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx,
+                        mapserv->ImgCols);
+    celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy,
+                        mapserv->ImgRows);
+    mapserv->mappnt.x =
+        MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
+    mapserv->mappnt.y =
+        MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
+
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x -
+        .5 * ((mapserv->ImgExt.maxx - mapserv->ImgExt.minx) /
+              mapserv->fZoom); /* create an extent around that point */
+    mapserv->map->extent.miny =
+        mapserv->mappnt.y -
+        .5 * ((mapserv->ImgExt.maxy - mapserv->ImgExt.miny) / mapserv->fZoom);
+    mapserv->map->extent.maxx =
+        mapserv->mappnt.x +
+        .5 * ((mapserv->ImgExt.maxx - mapserv->ImgExt.minx) / mapserv->fZoom);
+    mapserv->map->extent.maxy =
+        mapserv->mappnt.y +
+        .5 * ((mapserv->ImgExt.maxy - mapserv->ImgExt.miny) / mapserv->fZoom);
+    break;
+  case FROMREFPNT:
+    cellx = MS_CELLSIZE(mapserv->map->reference.extent.minx,
+                        mapserv->map->reference.extent.maxx,
+                        mapserv->map->reference.width);
+    celly = MS_CELLSIZE(mapserv->map->reference.extent.miny,
+                        mapserv->map->reference.extent.maxy,
+                        mapserv->map->reference.height);
+    mapserv->mappnt.x = MS_IMAGE2MAP_X(
+        mapserv->RefPnt.x, mapserv->map->reference.extent.minx, cellx);
+    mapserv->mappnt.y = MS_IMAGE2MAP_Y(
+        mapserv->RefPnt.y, mapserv->map->reference.extent.maxy, celly);
+
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x -
+        .5 * (mapserv->ImgExt.maxx -
+              mapserv->ImgExt.minx); /* create an extent around that point */
+    mapserv->map->extent.miny =
+        mapserv->mappnt.y - .5 * (mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
+    mapserv->map->extent.maxx =
+        mapserv->mappnt.x + .5 * (mapserv->ImgExt.maxx - mapserv->ImgExt.minx);
+    mapserv->map->extent.maxy =
+        mapserv->mappnt.y + .5 * (mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
+    break;
+  case FROMBUF:
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x -
+        mapserv
+            ->Buffer; /* create an extent around that point, using the buffer */
+    mapserv->map->extent.miny = mapserv->mappnt.y - mapserv->Buffer;
+    mapserv->map->extent.maxx = mapserv->mappnt.x + mapserv->Buffer;
+    mapserv->map->extent.maxy = mapserv->mappnt.y + mapserv->Buffer;
+    break;
+  case FROMSCALE:
+    cellsize =
+        (mapserv->ScaleDenom / mapserv->map->resolution) /
+        msInchesPerUnit(mapserv->map->units,
+                        0); /* user supplied a point and a scale denominator */
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x - cellsize * (mapserv->map->width - 1) / 2.0;
+    mapserv->map->extent.miny =
+        mapserv->mappnt.y - cellsize * (mapserv->map->height - 1) / 2.0;
+    mapserv->map->extent.maxx =
+        mapserv->mappnt.x + cellsize * (mapserv->map->width - 1) / 2.0;
+    mapserv->map->extent.maxy =
+        mapserv->mappnt.y + cellsize * (mapserv->map->height - 1) / 2.0;
+    break;
+  default: /* use the default in the mapfile if it exists */
+    if ((mapserv->map->extent.minx == mapserv->map->extent.maxx) &&
+        (mapserv->map->extent.miny == mapserv->map->extent.maxy)) {
+      msSetError(MS_WEBERR, "No way to generate map extent.", "mapserv()");
+      return MS_FAILURE;
+    }
+  }
+
+  mapserv->RawExt = mapserv->map->extent; /* save unaltered extent */
+
+  return MS_SUCCESS;
+}
+
+int checkWebScale(mapservObj *mapserv) {
+  int status;
+  rectObj work_extent = mapserv->map->extent;
+
+  mapserv->map->cellsize = msAdjustExtent(
+      &(work_extent), mapserv->map->width,
+      mapserv->map->height); /* we do this cause we need a scale */
+  if ((status = msCalculateScale(work_extent, mapserv->map->units,
+                                 mapserv->map->width, mapserv->map->height,
+                                 mapserv->map->resolution,
+                                 &mapserv->map->scaledenom)) != MS_SUCCESS)
+    return status;
+
+  if ((mapserv->map->scaledenom < mapserv->map->web.minscaledenom) &&
+      (mapserv->map->web.minscaledenom > 0)) {
+    if (mapserv->map->web.mintemplate) { /* use the template provided */
+      if (TEMPLATE_TYPE(mapserv->map->web.mintemplate) == MS_FILE) {
+        if ((status = msReturnPage(mapserv, mapserv->map->web.mintemplate,
+                                   BROWSE, NULL)) != MS_SUCCESS)
+          return status;
+      } else {
+        if ((status = msReturnURL(mapserv, mapserv->map->web.mintemplate,
+                                  BROWSE)) != MS_SUCCESS)
+          return status;
+      }
+    } else { /* force zoom = 1 (i.e. pan) */
+      mapserv->fZoom = mapserv->Zoom = 1;
+      mapserv->ZoomDirection = 0;
+      mapserv->CoordSource = FROMSCALE;
+      mapserv->ScaleDenom = mapserv->map->web.minscaledenom;
+      mapserv->mappnt.x =
+          (mapserv->map->extent.maxx + mapserv->map->extent.minx) /
+          2; /* use center of bad extent */
+      mapserv->mappnt.y =
+          (mapserv->map->extent.maxy + mapserv->map->extent.miny) / 2;
+      setExtent(mapserv);
+      mapserv->map->cellsize = msAdjustExtent(
+          &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+      if ((status = msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                                     mapserv->map->width, mapserv->map->height,
+                                     mapserv->map->resolution,
+                                     &mapserv->map->scaledenom)) != MS_SUCCESS)
+        return status;
+    }
+  } else {
+    if ((mapserv->map->scaledenom > mapserv->map->web.maxscaledenom) &&
+        (mapserv->map->web.maxscaledenom > 0)) {
+      if (mapserv->map->web.maxtemplate) { /* use the template provided */
+        if (TEMPLATE_TYPE(mapserv->map->web.maxtemplate) == MS_FILE) {
+          if ((status = msReturnPage(mapserv, mapserv->map->web.maxtemplate,
+                                     BROWSE, NULL)) != MS_SUCCESS)
+            return status;
+        } else {
+          if ((status = msReturnURL(mapserv, mapserv->map->web.maxtemplate,
+                                    BROWSE)) != MS_SUCCESS)
+            return status;
+        }
+      } else { /* force zoom = 1 (i.e. pan) */
+        mapserv->fZoom = mapserv->Zoom = 1;
+        mapserv->ZoomDirection = 0;
+        mapserv->CoordSource = FROMSCALE;
+        mapserv->ScaleDenom = mapserv->map->web.maxscaledenom;
+        mapserv->mappnt.x =
+            (mapserv->map->extent.maxx + mapserv->map->extent.minx) /
+            2; /* use center of bad extent */
+        mapserv->mappnt.y =
+            (mapserv->map->extent.maxy + mapserv->map->extent.miny) / 2;
+        setExtent(mapserv);
+        mapserv->map->cellsize = msAdjustExtent(
+            &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+        if ((status = msCalculateScale(
+                 mapserv->map->extent, mapserv->map->units, mapserv->map->width,
+                 mapserv->map->height, mapserv->map->resolution,
+                 &mapserv->map->scaledenom)) != MS_SUCCESS)
+          return status;
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+int msReturnTemplateQuery(mapservObj *mapserv, char *queryFormat,
+                          char **papszBuffer) {
+  imageObj *img = NULL;
+  int i, status;
+
+  outputFormatObj *outputFormat = NULL;
+  mapObj *map = mapserv->map;
+
+  if (!queryFormat) {
+    msSetError(MS_WEBERR, "Return format/mime-type not specified.",
+               "msReturnTemplateQuery()");
+    return MS_FAILURE;
+  }
+
+  msApplyDefaultOutputFormats(map);
+
+  i = msGetOutputFormatIndex(
+      map, queryFormat); /* queryFormat can be a mime-type or name */
+  if (i >= 0)
+    outputFormat = map->outputformatlist[i];
+
+  if (outputFormat) {
+    if (MS_RENDERER_PLUGIN(outputFormat)) {
+      msInitializeRendererVTable(outputFormat);
+    }
+    if (MS_RENDERER_OGR(outputFormat)) {
+      checkWebScale(mapserv);
+
+      status = msOGRWriteFromQuery(map, outputFormat, mapserv->sendheaders);
+
+      return status;
+    }
+
+    if (!MS_RENDERER_TEMPLATE(outputFormat)) { /* got an image format, return
+                                                  the query results that way */
+      outputFormatObj *tempOutputFormat = map->outputformat; /* save format */
+
+      checkWebScale(mapserv);
+
+      map->outputformat =
+          outputFormat; /* override what was given for IMAGETYPE */
+      img = msDrawMap(map, MS_TRUE);
+      if (!img)
+        return MS_FAILURE;
+      map->outputformat = tempOutputFormat; /* restore format */
+
+      if (mapserv->sendheaders) {
+        msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(outputFormat));
+        msIO_sendHeaders();
+      }
+      status = msSaveImage(map, img, NULL);
+      msFreeImage(img);
+
+      return status;
+    }
+  }
+
+  /*
+  ** At this point we know we have a template of some sort, either the new style
+  *that references a or the old
+  ** style made up of external files slammed together. Either way we may have to
+  *compute a query map and other
+  ** images. We only create support images IF the querymap has status=MS_ON.
+  */
+  if (map->querymap.status) {
+    checkWebScale(mapserv);
+    if (msGenerateImages(mapserv, MS_TRUE, MS_TRUE) != MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  if (outputFormat) {
+    const char *file = msGetOutputFormatOption(outputFormat, "FILE", NULL);
+    if (!file) {
+      msSetError(MS_WEBERR,
+                 "Template driver requires \"FILE\" format option be set.",
+                 "msReturnTemplateQuery()");
+      return MS_FAILURE;
+    }
+
+    if (mapserv->sendheaders) {
+      const char *attachment =
+          msGetOutputFormatOption(outputFormat, "ATTACHMENT", NULL);
+      if (attachment)
+        msIO_setHeader("Content-disposition", "attachment; filename=%s",
+                       attachment);
+      msIO_setHeader("Content-Type", "%s", outputFormat->mimetype);
+      msIO_sendHeaders();
+    }
+    if ((status = msReturnPage(mapserv, (char *)file, BROWSE, papszBuffer)) !=
+        MS_SUCCESS)
+      return status;
+  } else {
+    if ((status = msReturnNestedTemplateQuery(mapserv, queryFormat,
+                                              papszBuffer)) != MS_SUCCESS)
+      return status;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Is a particular layer or group on, that is was it requested explicitly by the
+*user.
+*/
+int isOn(mapservObj *mapserv, char *name, char *group) {
+  int i;
+
+  for (i = 0; i < mapserv->NumLayers; i++) {
+    if (name && strcmp(mapserv->Layers[i], name) == 0)
+      return (MS_TRUE);
+    if (group && strcmp(mapserv->Layers[i], group) == 0)
+      return (MS_TRUE);
+  }
+
+  return (MS_FALSE);
+}
+
+/************************************************************************/
+/*            int sortLayerByOrder(mapObj *map, char* pszOrder)         */
+/*                                                                      */
+/*      sorth the displaying in ascending or descending order.          */
+/************************************************************************/
+int sortLayerByOrder(mapObj *map, const char *pszOrder) {
+  int *panCurrentOrder = NULL;
+
+  if (!map) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "sortLayerByOrder()");
+    return MS_FAILURE;
+  }
+  /* ==================================================================== */
+  /*      The flag "ascending" is in fact not useful since the            */
+  /*      default ordering is ascending.                                  */
+  /* ==================================================================== */
+
+  /* -------------------------------------------------------------------- */
+  /*      the map->layerorder should be set at this point in the          */
+  /*      sortLayerByMetadata.                                            */
+  /* -------------------------------------------------------------------- */
+  if (map->layerorder) {
+    panCurrentOrder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
+    for (int i = 0; i < map->numlayers; i++)
+      panCurrentOrder[i] = map->layerorder[i];
+
+    if (strcasecmp(pszOrder, "DESCENDING") == 0) {
+      for (int i = 0; i < map->numlayers; i++)
+        map->layerorder[i] = panCurrentOrder[map->numlayers - 1 - i];
+    }
+
+    free(panCurrentOrder);
+  }
+
+  return MS_SUCCESS;
+}
+
+/*!
+ * This function set the map->layerorder
+ * index order by the metadata column name
+ */
+static int sortLayerByMetadata(mapObj *map, const char *pszMetadata) {
+  int nLegendOrder1;
+  int nLegendOrder2;
+  int i, j;
+  int tmp;
+
+  if (!map) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "sortLayerByMetadata()");
+    return MS_FAILURE;
+  }
+
+  /*
+   * Initiate to default order (Reverse mapfile order)
+   */
+  if (map->layerorder) {
+    int *pnLayerOrder;
+
+    /* Backup the original layer order to be able to reverse it */
+    pnLayerOrder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
+    for (i = 0; i < map->numlayers; i++)
+      pnLayerOrder[i] = map->layerorder[i];
+
+    /* Get a new layerorder array */
+    free(map->layerorder);
+    map->layerorder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
+
+    /* Reverse the layerorder array */
+    for (i = 0; i < map->numlayers; i++)
+      map->layerorder[i] = pnLayerOrder[map->numlayers - i - 1];
+
+    free(pnLayerOrder);
+  } else {
+    map->layerorder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
+
+    for (i = 0; i < map->numlayers; i++)
+      map->layerorder[i] = map->numlayers - i - 1;
+  }
+
+  if (!pszMetadata)
+    return MS_SUCCESS;
+
+  /*
+   * Bubble sort algo (not very efficient)
+   * should implement a kind of quick sort
+   * algo instead
+   */
+  for (i = 0; i < map->numlayers - 1; i++) {
+    for (j = 0; j < map->numlayers - 1 - i; j++) {
+      const char *pszLegendOrder1 = msLookupHashTable(
+          &(GET_LAYER(map, map->layerorder[j + 1])->metadata), pszMetadata);
+      const char *pszLegendOrder2 = msLookupHashTable(
+          &(GET_LAYER(map, map->layerorder[j])->metadata), pszMetadata);
+
+      if (!pszLegendOrder1 || !pszLegendOrder2)
+        continue;
+
+      nLegendOrder1 = atoi(pszLegendOrder1);
+      nLegendOrder2 = atoi(pszLegendOrder2);
+
+      if (nLegendOrder1 < nLegendOrder2) { /* compare the two neighbors */
+        tmp = map->layerorder[j];          /* swap a[j] and a[j+1]      */
+        map->layerorder[j] = map->layerorder[j + 1];
+        map->layerorder[j + 1] = tmp;
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** This function return a pointer
+** at the beginning of the first occurrence
+** of pszTag in pszInstr.
+**
+** Tag can be [TAG] or [TAG something]
+*/
+static const char *findTag(const char *pszInstr, const char *pszTag) {
+  const char *pszStart = NULL;
+  int done = MS_FALSE;
+
+  if (!pszInstr || !pszTag) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "findTag()");
+    return NULL;
+  }
+
+  const int length =
+      strlen(pszTag) + 1; /* adding [ character to the beginning */
+  char *pszTag1 = (char *)msSmallMalloc(length + 1);
+
+  strcpy(pszTag1, "[");
+  strcat(pszTag1, pszTag);
+
+  const char *pszTemp = pszInstr;
+  do {
+    pszStart = strstr(pszTemp, pszTag1);
+
+    if (pszStart == NULL)
+      done = MS_TRUE; /* tag not found */
+    else if ((*(pszStart + length) == ']' || *(pszStart + length) == ' '))
+      done = MS_TRUE; /* valid tag */
+    else
+      pszTemp += length; /* skip ahead and start over */
+  } while (!done);
+
+  free(pszTag1);
+
+  return pszStart;
+}
+
+/*
+** This function return a pointer
+** to the end of the tag in pszTag
+**
+** The end of a tag is the next
+** non-quoted ']' character.
+** Return NULL if not found.
+*/
+
+char *findTagEnd(const char *pszTag) {
+  char *pszEnd = NULL, *pszTmp = (char *)pszTag;
+
+  while (pszTmp != NULL) {
+    if (*pszTmp == '"')
+      pszTmp = strchr(pszTmp + 1, '"');
+    if ((pszTmp == NULL) || (*pszTmp == ']')) {
+      pszEnd = pszTmp;
+      pszTmp = NULL;
+    } else
+      pszTmp++;
+  }
+
+  return pszEnd;
+}
+
+/*
+** Return a hashtableobj from instr of all
+** arguments. hashtable must be freed by caller.
+*/
+static int getTagArgs(const char *pszTag, const char *pszInstr,
+                      hashTableObj **ppoHashTable) {
+  const char *pszStart, *pszEnd;
+  int nLength;
+  char **papszArgs, **papszVarVal;
+  int nArgs, nDummy;
+  int i;
+
+  if (!pszTag || !pszInstr) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "getTagArgs()");
+    return MS_FAILURE;
+  }
+
+  /* set position to the beginning of tag */
+  pszStart = findTag(pszInstr, pszTag);
+
+  if (pszStart) {
+    /* find ending position */
+    pszEnd = findTagEnd(pszStart);
+
+    if (pszEnd) {
+      /* skip the tag name */
+      pszStart = pszStart + strlen(pszTag) + 1;
+
+      /* get length of all args */
+      nLength = pszEnd - pszStart;
+
+      if (nLength > 0) { /* is there arguments ? */
+        char *pszArgs = (char *)msSmallMalloc(nLength + 1);
+        strlcpy(pszArgs, pszStart, nLength + 1);
+
+        if (!(*ppoHashTable))
+          *ppoHashTable = msCreateHashTable();
+
+        /* put all arguments separate by space in a hash table */
+        papszArgs = msStringTokenize(pszArgs, " ", &nArgs, MS_TRUE);
+
+        /* msReturnTemplateQuerycheck all argument if they have values */
+        for (i = 0; i < nArgs; i++) {
+          if (strlen(papszArgs[i]) == 0) {
+            free(papszArgs[i]);
+            continue;
+          }
+
+          if (strchr(papszArgs[i], '=')) {
+            papszVarVal =
+                msStringTokenize(papszArgs[i], "=", &nDummy, MS_FALSE);
+            msInsertHashTable(*ppoHashTable, papszVarVal[0], papszVarVal[1]);
+            free(papszVarVal[0]);
+            free(papszVarVal[1]);
+            free(papszVarVal);
+          } else /* no value specified. set it to 1 */
+            msInsertHashTable(*ppoHashTable, papszArgs[i], "1");
+
+          free(papszArgs[i]);
+        }
+        free(papszArgs);
+        free(pszArgs);
+      }
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Return a substring from instr between [tag] and [/tag]
+** char * returned must be freed by caller.
+** pszNextInstr will be a pointer at the end of the
+** first occurrence found.
+*/
+static int getInlineTag(const char *pszTag, const char *pszInstr,
+                        char **pszResult) {
+  const char *pszEnd = NULL;
+  int nInst = 0;
+  int nLength;
+
+  *pszResult = NULL;
+
+  if (!pszInstr || !pszTag) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "getInlineTag()");
+    return MS_FAILURE;
+  }
+
+  char *pszEndTag = (char *)msSmallMalloc(strlen(pszTag) + 3);
+  strcpy(pszEndTag, "[/");
+  strcat(pszEndTag, pszTag);
+
+  /* find start tag */
+  const char *pszPatIn = findTag(pszInstr, pszTag);
+  const char *pszPatOut = strstr(pszInstr, pszEndTag);
+
+  const char *pszStart = pszPatIn;
+
+  const char *pszTmp = pszInstr;
+
+  if (pszPatIn) {
+    do {
+      if (pszPatIn && pszPatIn < pszPatOut) {
+        nInst++;
+
+        pszTmp = pszPatIn;
+      }
+
+      if (pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
+        pszEnd = pszPatOut;
+        nInst--;
+
+        pszTmp = pszPatOut;
+      }
+
+      pszPatIn = findTag(pszTmp + 1, pszTag);
+      pszPatOut = strstr(pszTmp + 1, pszEndTag);
+
+    } while (pszTmp != NULL && nInst > 0);
+  }
+
+  if (pszStart && pszEnd) {
+    /* find end of start tag */
+    pszStart = strchr(pszStart, ']');
+
+    if (pszStart) {
+      pszStart++;
+
+      nLength = pszEnd - pszStart;
+
+      if (nLength > 0) {
+        *pszResult = (char *)msSmallMalloc(nLength + 1);
+
+        /* copy string beetween start and end tag */
+        strlcpy(*pszResult, pszStart, nLength + 1);
+
+        (*pszResult)[nLength] = '\0';
+      }
+    } else {
+      msSetError(MS_WEBERR, "Malformed [%s] tag.", "getInlineTag()", pszTag);
+      return MS_FAILURE;
+    }
+  }
+
+  msFree(pszEndTag);
+
+  return MS_SUCCESS;
+}
+
+/*!
+ * this function process all if tag in pszInstr.
+ * this function return a modified pszInstr.
+ * ht mus contain all variables needed by the function
+ * to interpret if expression.
+ *
+ * If bLastPass is true then all tests for 'null' values will be
+ * considered true if the corresponding value is not set.
+ */
+int processIfTag(char **pszInstr, hashTableObj *ht, int bLastPass) {
+  /*   char *pszNextInstr = pszInstr; */
+  const char *pszEnd = NULL;
+
+  if (!*pszInstr) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "processIfTag()");
+    return MS_FAILURE;
+  }
+
+  /* find the if start tag */
+
+  const char *pszStart = findTag(*pszInstr, "if");
+
+  while (pszStart) {
+    const char *pszPatIn = findTag(pszStart, "if");
+    const char *pszPatOut = strstr(pszStart, "[/if]");
+    const char *pszTmp = pszPatIn;
+
+    int nInst = 0;
+    do {
+      if (pszPatIn && pszPatIn < pszPatOut) {
+        nInst++;
+        pszTmp = pszPatIn;
+      }
+
+      if (pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
+        pszEnd = pszPatOut;
+        nInst--;
+        pszTmp = pszPatOut;
+      }
+
+      pszPatIn = findTag(pszTmp + 1, "if");
+      pszPatOut = strstr(pszTmp + 1, "[/if]");
+
+    } while (nInst > 0);
+
+    /* get the then string (if expression is true) */
+    char *pszThen = NULL;
+    if (getInlineTag("if", pszStart, &pszThen) != MS_SUCCESS) {
+      msSetError(MS_WEBERR, "Malformed then if tag.", "processIfTag()");
+      return MS_FAILURE;
+    }
+
+    /* retrieve if tag args */
+    hashTableObj *ifArgs = NULL;
+    if (getTagArgs("if", pszStart, &ifArgs) != MS_SUCCESS) {
+      msSetError(MS_WEBERR, "Malformed args if tag.", "processIfTag()");
+      return MS_FAILURE;
+    }
+
+    const char *pszName = msLookupHashTable(ifArgs, "name");
+    const char *pszValue = msLookupHashTable(ifArgs, "value");
+    const char *pszOperator = msLookupHashTable(ifArgs, "oper");
+    if (pszOperator == NULL) /* Default operator if not set is "eq" */
+      pszOperator = "eq";
+
+    int bEmpty = 0;
+
+    if (pszName) {
+      /* build the complete if tag ([if all_args]then string[/if]) */
+      /* to replace if by then string if expression is true */
+      /* or by a white space if not. */
+      const int nLength = pszEnd - pszStart;
+      char *pszIfTag = (char *)msSmallMalloc(nLength + 6);
+      strlcpy(pszIfTag, pszStart, nLength + 1);
+      pszIfTag[nLength] = '\0';
+      strcat(pszIfTag, "[/if]");
+
+      const char *pszHTValue = msLookupHashTable(ht, pszName);
+
+      if (strcmp(pszOperator, "neq") == 0) {
+        if (pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) != 0) {
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
+        } else if (pszHTValue) {
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
+          bEmpty = 1;
+        }
+      } else if (strcmp(pszOperator, "eq") == 0) {
+        if (pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) == 0) {
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
+        } else if (pszHTValue) {
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
+          bEmpty = 1;
+        }
+      } else if (strcmp(pszOperator, "isnull") == 0) {
+        if (pszHTValue != NULL) {
+          /* We met a non-null value... condition is false */
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
+          bEmpty = 1;
+        } else if (bLastPass) {
+          /* On last pass, if value is still null then condition is true */
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
+        }
+      } else if (strcmp(pszOperator, "isset") == 0) {
+        if (pszHTValue != NULL) {
+          /* Found a non-null value... condition is true */
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
+        } else if (bLastPass) {
+          /* On last pass, if value still not set then condition is false */
+          *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
+          bEmpty = 1;
+        }
+      } else {
+        msSetError(MS_WEBERR, "Unsupported operator (%s) in if tag.",
+                   "processIfTag()", pszOperator);
+        free(pszIfTag);
+        free(pszThen);
+        msFreeHashTable(ifArgs);
+        return MS_FAILURE;
+      }
+
+      free(pszIfTag);
+    }
+
+    free(pszThen);
+
+    msFreeHashTable(ifArgs);
+
+    /* find the if start tag */
+    if (bEmpty)
+      pszStart = findTag(pszStart, "if");
+    else
+      pszStart = findTag(pszStart + 1, "if");
+  }
+
+  return MS_SUCCESS;
+}
+
+/* Helper function to return the text before the supplied string2 in string1. */
+static char *getPreTagText(const char *string1, const char *string2) {
+  int n;
+  char *result, *tmpstr;
+
+  if ((tmpstr = strstr(string1, string2)) == NULL)
+    return msStrdup(""); /* return an empty string */
+
+  n = strlen(string1) - strlen(tmpstr);
+  result = (char *)msSmallMalloc(n + 1);
+  strlcpy(result, string1, n + 1);
+
+  return result;
+}
+
+/* Helper function to return the text after the supplied string2 in string1. */
+static char *getPostTagText(const char *string1, const char *string2) {
+  char *tmpstr;
+
+  if ((tmpstr = strstr(string1, string2)) == NULL)
+    return msStrdup(""); /* return an empty string */
+
+  tmpstr += strlen(string2); /* skip string2 */
+  return msStrdup(tmpstr);
+}
+
+/*
+** Function to process a [feature ...] tag. This tag can *only* be found within
+** a [resultset ...][/resultset] block.
+*/
+static int processFeatureTag(mapservObj *mapserv, char **line,
+                             layerObj *layer) {
+  char *preTag, *postTag; /* text before and after the tag */
+
+  const char *argValue;
+  char *tag, *tagInstance;
+  hashTableObj *tagArgs = NULL;
+
+  int limit = -1;
+  const char *trimLast = NULL;
+
+  int i, j, status;
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processFeatureTag()");
+    return (MS_FAILURE);
+  }
+
+  const char *tagStart = findTag(*line, "feature");
+  if (!tagStart)
+    return (MS_SUCCESS); /* OK, just return; */
+
+  /* check for any tag arguments */
+  if (getTagArgs("feature", tagStart, &tagArgs) != MS_SUCCESS)
+    return (MS_FAILURE);
+  if (tagArgs) {
+    argValue = msLookupHashTable(tagArgs, "limit");
+    if (argValue)
+      limit = atoi(argValue);
+
+    argValue = msLookupHashTable(tagArgs, "trimlast");
+    if (argValue)
+      trimLast = argValue;
+  }
+
+  if (strstr(*line, "[/feature]") ==
+      NULL) { /* we know the closing tag must be here, if not throw an error */
+    msSetError(MS_WEBERR, "[feature] tag found without closing [/feature].",
+               "processFeatureTag()");
+    msFreeHashTable(tagArgs);
+    return (MS_FAILURE);
+  }
+
+  if (getInlineTag("feature", *line, &tag) != MS_SUCCESS) {
+    msSetError(MS_WEBERR, "Malformed feature tag.", "processFeatureTag()");
+    msFreeHashTable(tagArgs);
+    return MS_FAILURE;
+  }
+
+  preTag = getPreTagText(*line, "[feature");
+  postTag = getPostTagText(*line, "[/feature]");
+
+  /* start rebuilding **line */
+  free(*line);
+  *line = preTag;
+
+  /* we know the layer has query results or we wouldn't be in this code */
+
+#if 0
+  status = msLayerOpen(layer); /* open the layer */
+  if(status != MS_SUCCESS) return status;
+  status = msLayerGetItems(layer); /* retrieve all the item names */
+  if(status != MS_SUCCESS) return status;
+#endif
+
+  if (layer->numjoins > 0) { /* initialize necessary JOINs here */
+    for (j = 0; j < layer->numjoins; j++) {
+      status = msJoinConnect(layer, &(layer->joins[j]));
+      if (status != MS_SUCCESS) {
+        msFreeHashTable(tagArgs);
+        msFree(postTag);
+        msFree(tag);
+        return status;
+      }
+    }
+  }
+
+  mapserv->LRN = 1; /* layer result counter */
+  mapserv->resultlayer = layer;
+  msInitShape(&(mapserv->resultshape));
+
+  if (limit == -1) /* return all */
+    limit = layer->resultcache->numresults;
+  else
+    limit = MS_MIN(limit, layer->resultcache->numresults);
+
+  for (i = 0; i < limit; i++) {
+    status = msLayerGetShape(layer, &(mapserv->resultshape),
+                             &(layer->resultcache->results[i]));
+    if (status != MS_SUCCESS) {
+      msFreeHashTable(tagArgs);
+      msFree(postTag);
+      msFree(tag);
+      return status;
+    }
+
+    mapserv->resultshape.classindex =
+        msShapeGetClass(layer, layer->map, &mapserv->resultshape, NULL, -1);
+
+    /* prepare any necessary JOINs here (one-to-one only) */
+    if (layer->numjoins > 0) {
+      for (j = 0; j < layer->numjoins; j++) {
+        if (layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
+          msJoinPrepare(&(layer->joins[j]), &(mapserv->resultshape));
+          msJoinNext(&(layer->joins[j])); /* fetch the first row */
+        }
+      }
+    }
+
+    /*
+    ** if necessary trim a few characters off the end of the tag
+    */
+    if (trimLast && (i == limit - 1)) {
+      char *ptr;
+      if ((ptr = strrstr(tag, trimLast)) != NULL)
+        *ptr = '\0';
+    }
+
+    /* process the tag */
+    tagInstance = processLine(mapserv, tag, NULL, QUERY); /* do substitutions */
+    *line = msStringConcatenate(*line, tagInstance);      /* grow the line */
+
+    free(tagInstance);
+    msFreeShape(&(mapserv->resultshape)); /* init too */
+
+    mapserv->RN++; /* increment counters */
+    mapserv->LRN++;
+  }
+
+  /* msLayerClose(layer); */
+  mapserv->resultlayer = NULL; /* necessary? */
+
+  *line = msStringConcatenate(*line, postTag);
+
+  /*
+  ** clean up
+  */
+  free(postTag);
+  free(tag);
+  msFreeHashTable(tagArgs);
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Function process a [include src="..."] tag.
+**
+** TODO's:
+**   - allow URLs
+*/
+static int processIncludeTag(mapservObj *mapserv, char **line, FILE *stream,
+                             int mode) {
+  char *tag, *tagEnd;
+  hashTableObj *tagArgs = NULL;
+  int tagOffset, tagLength;
+
+  char *content = NULL, *processedContent = NULL;
+  const char *src = NULL;
+
+  FILE *includeStream;
+  char buffer[MS_BUFFER_LENGTH], path[MS_MAXPATHLEN];
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processIncludeTag()");
+    return (MS_FAILURE);
+  }
+
+  const char *tagStart = findTag(*line, "include");
+
+  /* It is OK to have no include tags, just return. */
+  if (!tagStart)
+    return MS_SUCCESS;
+
+  while (tagStart) {
+    tagOffset = tagStart - *line;
+
+    /* check for any tag arguments */
+    if (getTagArgs("include", tagStart, &tagArgs) != MS_SUCCESS) {
+      return (MS_FAILURE);
+    }
+    if (tagArgs) {
+      src = msLookupHashTable(tagArgs, "src");
+    }
+
+    if (!src)
+      return (MS_SUCCESS); /* don't process the tag, could be something else so
+                              return MS_SUCCESS */
+
+    if ((includeStream = fopen(msBuildPath(path, mapserv->map->mappath, src),
+                               "r")) == NULL) {
+      msSetError(MS_IOERR, "%s", "processIncludeTag()", src);
+      msFreeHashTable(tagArgs);
+      return MS_FAILURE;
+    }
+
+    if (isValidTemplate(includeStream, src) != MS_TRUE) {
+      msFreeHashTable(tagArgs);
+      fclose(includeStream);
+      return MS_FAILURE;
+    }
+
+    while (fgets(buffer, MS_BUFFER_LENGTH, includeStream) != NULL)
+      content = msStringConcatenate(content, buffer);
+
+    /* done with included file handle */
+    fclose(includeStream);
+
+    /* find the end of the tag */
+    tagEnd = findTagEnd(tagStart);
+    tagEnd++;
+
+    /* build the complete tag so we can do substitution */
+    tagLength = tagEnd - tagStart;
+    tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
+
+    /* process any other tags in the content */
+    processedContent = processLine(mapserv, content, stream, mode);
+
+    /* do the replacement */
+    *line = msReplaceSubstring(*line, tag, processedContent);
+
+    /* clean up */
+    free(tag);
+    tag = NULL;
+    msFreeHashTable(tagArgs);
+    tagArgs = NULL;
+    free(content);
+    free(processedContent);
+
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "include");
+    else
+      tagStart = NULL;
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Function to process a [resultset ...] tag.
+*/
+static int processResultSetTag(mapservObj *mapserv, char **line, FILE *stream) {
+  char lineBuffer[MS_BUFFER_LENGTH];
+  int foundTagEnd;
+
+  char *preTag, *postTag; /* text before and after the tag */
+
+  char *tag;
+  hashTableObj *tagArgs = NULL;
+
+  const char *layerName = NULL;
+  const char *nodata = NULL;
+
+  layerObj *lp;
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processResultSetTag()");
+    return (MS_FAILURE);
+  }
+
+  const char *tagStart = findTag(*line, "resultset");
+  if (!tagStart)
+    return (MS_SUCCESS); /* OK, just return; */
+
+  while (tagStart) {
+    /* initialize the tag arguments */
+    layerName = NULL;
+
+    /* check for any tag arguments */
+    if (getTagArgs("resultset", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
+      layerName = msLookupHashTable(tagArgs, "layer");
+      nodata = msLookupHashTable(tagArgs, "nodata");
+    }
+
+    if (!layerName) {
+      msSetError(MS_WEBERR,
+                 "[resultset] tag missing required 'layer' argument.",
+                 "processResultSetTag()");
+      msFreeHashTable(tagArgs);
+      return (MS_FAILURE);
+    }
+
+    const int layerIndex = msGetLayerIndex(mapserv->map, layerName);
+    if (layerIndex >= mapserv->map->numlayers || layerIndex < 0) {
+      msSetError(MS_MISCERR, "Layer named '%s' does not exist.",
+                 "processResultSetTag()", layerName);
+      msFreeHashTable(tagArgs);
+      return MS_FAILURE;
+    }
+    lp = GET_LAYER(mapserv->map, layerIndex);
+
+    if (strstr(*line, "[/resultset]") == NULL) { /* read ahead */
+      if (!stream) {
+        msSetError(MS_WEBERR, "Invalid file pointer.", "processResultSetTag()");
+        msFreeHashTable(tagArgs);
+        return (MS_FAILURE);
+      }
+
+      foundTagEnd = MS_FALSE;
+      while (!foundTagEnd) {
+        if (fgets(lineBuffer, MS_BUFFER_LENGTH, stream) != NULL) {
+          *line = msStringConcatenate(*line, lineBuffer);
+          if (strstr(*line, "[/resultset]") != NULL)
+            foundTagEnd = MS_TRUE;
+        } else
+          break; /* ran out of file */
+      }
+      if (foundTagEnd == MS_FALSE) {
+        msSetError(MS_WEBERR,
+                   "[resultset] tag found without closing [/resultset].",
+                   "processResultSetTag()");
+        msFreeHashTable(tagArgs);
+        return (MS_FAILURE);
+      }
+    }
+
+    if (getInlineTag("resultset", *line, &tag) != MS_SUCCESS) {
+      msSetError(MS_WEBERR, "Malformed resultset tag.",
+                 "processResultSetTag()");
+      msFreeHashTable(tagArgs);
+      return MS_FAILURE;
+    }
+
+    preTag = getPreTagText(
+        *line, "[resultset"); /* TODO: need to handle tags in these */
+    postTag = getPostTagText(*line, "[/resultset]");
+
+    /* start rebuilding **line */
+    free(*line);
+    *line = preTag;
+
+    /* process any includes within the resultset tag */
+    if (processIncludeTag(mapserv, &tag, stream, 0) != MS_SUCCESS) {
+      msFreeHashTable(tagArgs);
+      return (MS_FAILURE);
+    }
+
+    if (lp->resultcache && lp->resultcache->numresults > 0) {
+      /* probably will need a while-loop here to handle multiple instances of
+       * [feature ...] tags */
+      if (processFeatureTag(mapserv, &tag, lp) != MS_SUCCESS) {
+        msFreeHashTable(tagArgs);
+        return (MS_FAILURE); /* TODO: how to handle */
+      }
+      *line = msStringConcatenate(*line, tag);
+    } else if (nodata) {
+      *line = msStringConcatenate(*line, nodata);
+    }
+
+    *line = msStringConcatenate(*line, postTag);
+
+    /* clean up */
+    free(postTag);
+    free(tag);
+
+    tagStart = findTag(*line, "resultset");
+  }
+  msFreeHashTable(tagArgs);
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Function to process an [item ...] tag: line contains the tag, shape holds the
+*attributes.
+*/
+enum ITEM_ESCAPING { ESCAPE_HTML, ESCAPE_URL, ESCAPE_JSON, ESCAPE_NONE };
+
+static int processItemTag(layerObj *layer, char **line, shapeObj *shape) {
+  int i;
+
+  char *tagEnd;
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processItemTag()");
+    return (MS_FAILURE);
+  }
+
+  const char *tagStart = findTag(*line, "item");
+
+  if (!tagStart)
+    return (MS_SUCCESS); /* OK, just return; */
+
+  while (tagStart) {
+    const char *format = "$value"; /* initialize the tag arguments */
+    const char *nullFormat = "";
+    int precision = -1;
+    int padding = -1;
+    const char *name = NULL;
+    const char *pattern = NULL;
+    int uc = MS_FALSE;
+    int lc = MS_FALSE;
+    int commify = MS_FALSE;
+    int ignoremissing = MS_FALSE;
+    int escape = ESCAPE_HTML;
+    int skip = MS_FALSE;
+
+    /* check for any tag arguments */
+    hashTableObj *tagArgs = NULL;
+    if (getTagArgs("item", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
+      const char *argValue = msLookupHashTable(tagArgs, "name");
+      if (argValue)
+        name = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "pattern");
+      if (argValue)
+        pattern = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "precision");
+      if (argValue)
+        precision = atoi(argValue);
+
+      argValue = msLookupHashTable(tagArgs, "padding");
+      if (argValue)
+        padding = atoi(argValue);
+
+      argValue = msLookupHashTable(tagArgs, "format");
+      if (argValue)
+        format = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "nullformat");
+      if (argValue)
+        nullFormat = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "uc");
+      if (argValue && strcasecmp(argValue, "true") == 0)
+        uc = MS_TRUE;
+
+      argValue = msLookupHashTable(tagArgs, "lc");
+      if (argValue && strcasecmp(argValue, "true") == 0)
+        lc = MS_TRUE;
+
+      argValue = msLookupHashTable(tagArgs, "commify");
+      if (argValue && strcasecmp(argValue, "true") == 0)
+        commify = MS_TRUE;
+
+      argValue = msLookupHashTable(tagArgs, "ignoremissing");
+      if (argValue && strcasecmp(argValue, "true") == 0)
+        ignoremissing = MS_TRUE;
+
+      argValue = msLookupHashTable(tagArgs, "escape");
+      if (argValue && strcasecmp(argValue, "url") == 0)
+        escape = ESCAPE_URL;
+      else if (argValue && strcasecmp(argValue, "none") == 0)
+        escape = ESCAPE_NONE;
+      else if (argValue && strcasecmp(argValue, "json") == 0)
+        escape = ESCAPE_JSON;
+
+      /* TODO: deal with sub strings */
+    }
+
+    if (!name) {
+      msSetError(MS_WEBERR, "Item tag contains no name attribute.",
+                 "processItemTag()");
+      return (MS_FAILURE);
+    }
+
+    for (i = 0; i < layer->numitems; i++)
+      if (strcasecmp(name, layer->items[i]) == 0)
+        break;
+
+    if (i == layer->numitems) {
+      if (ignoremissing == MS_TRUE) {
+        skip = MS_TRUE;
+      } else {
+        msSetError(MS_WEBERR, "Item name (%s) not found in layer item list.",
+                   "processItemTag()", name);
+        return (MS_FAILURE);
+      }
+    }
+
+    /*
+    ** now we know which item so build the tagValue
+    */
+
+    char *tagValue = NULL;
+    if (!skip && (shape->values[i] && strlen(shape->values[i]) > 0)) {
+      char *itemValue = NULL;
+
+      /* set tag text depending on pattern (if necessary), nullFormat can
+       * contain $value (#3637) */
+      if (pattern && msEvalRegex(pattern, shape->values[i]) != MS_TRUE)
+        tagValue = msStrdup(nullFormat);
+      else
+        tagValue = msStrdup(format);
+
+      if (precision != -1) {
+        char numberFormat[16];
+
+        itemValue = (char *)msSmallMalloc(64); /* plenty big */
+        snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
+        snprintf(itemValue, 64, numberFormat, atof(shape->values[i]));
+      } else
+        itemValue = msStrdup(shape->values[i]);
+
+      if (commify == MS_TRUE)
+        itemValue = msCommifyString(itemValue);
+
+      /* apply other effects */
+      if (uc == MS_TRUE)
+        for (unsigned j = 0; j < strlen(itemValue); j++)
+          itemValue[j] = toupper(itemValue[j]);
+      if (lc == MS_TRUE)
+        for (unsigned j = 0; j < strlen(itemValue); j++)
+          itemValue[j] = tolower(itemValue[j]);
+
+      tagValue = msReplaceSubstring(tagValue, "$value", itemValue);
+      msFree(itemValue);
+
+      if (padding > 0 && padding < 1000) {
+        int paddedSize = strlen(tagValue) + padding + 1;
+        char *paddedValue = NULL;
+        paddedValue = (char *)msSmallMalloc(paddedSize);
+        snprintf(paddedValue, paddedSize, "%-*s", padding, tagValue);
+        msFree(tagValue);
+        tagValue = paddedValue;
+      }
+
+      if (!tagValue) {
+        msSetError(MS_WEBERR, "Error applying item format.",
+                   "processItemTag()");
+        return (MS_FAILURE); /* todo leaking... */
+      }
+    } else {
+      tagValue = msStrdup(nullFormat); /* attribute value is NULL or empty */
+    }
+
+    /* find the end of the tag */
+    tagEnd = findTagEnd(tagStart);
+    tagEnd++;
+
+    /* build the complete tag so we can do substitution */
+    const int tagLength = tagEnd - tagStart;
+    char *tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
+
+    /* do the replacement */
+    switch (escape) {
+    case ESCAPE_HTML: {
+      char *encodedTagValue = msEncodeHTMLEntities(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      msFree(encodedTagValue);
+      break;
+    }
+    case ESCAPE_JSON: {
+      char *encodedTagValue = msEscapeJSonString(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      msFree(encodedTagValue);
+      break;
+    }
+    case ESCAPE_URL: {
+      char *encodedTagValue = msEncodeUrl(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      msFree(encodedTagValue);
+      break;
+    }
+    case ESCAPE_NONE:
+      *line = msReplaceSubstring(*line, tag, tagValue);
+      break;
+    default:
+      break;
+    }
+
+    /* clean up */
+    free(tag);
+    msFreeHashTable(tagArgs);
+    msFree(tagValue);
+
+    tagStart = findTag(*line, "item");
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Function process any number of MapServer extent tags (e.g. shpext, mapext,
+*etc...).
+*/
+static int processExtentTag(mapservObj *mapserv, char **line, char *name,
+                            rectObj *extent, projectionObj *rectProj) {
+  rectObj tempExtent;
+
+  char number[64]; /* holds a single number in the extent */
+  char numberFormat[16];
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processExtentTag()");
+    return (MS_FAILURE);
+  }
+
+  const char *tagStart = findTag(*line, name); /* this supports any extent */
+
+  /* It is OK to have no include tags, just return. */
+  if (!tagStart)
+    return MS_SUCCESS;
+
+  while (tagStart) {
+    double xExpand = 0, yExpand = 0; /* set tag argument defaults */
+    int precision = -1;
+    const char *format = "$minx $miny $maxx $maxy";
+    const char *projectionString = NULL;
+
+    /* hack to handle tags like 'mapext_esc' easily */
+    int escape;
+    if (strstr(name, "_esc"))
+      escape = ESCAPE_URL;
+    else
+      escape = ESCAPE_HTML;
+
+    const int tagOffset = tagStart - *line;
+
+    /* check for any tag arguments */
+    hashTableObj *tagArgs = NULL;
+    if (getTagArgs(name, tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
+      const char *argValue = msLookupHashTable(tagArgs, "expand");
+      if (argValue) {
+        if (strchr(argValue, '%') != NULL) {
+          float f;
+          sscanf(argValue, "%f%%", &f);
+          xExpand = ((f / 100.0) * (extent->maxx - extent->minx)) / 2;
+          yExpand = ((f / 100.0) * (extent->maxy - extent->miny)) / 2;
+        } else {
+          xExpand = atof(argValue);
+          yExpand = xExpand;
+        }
+      }
+
+      argValue = msLookupHashTable(tagArgs, "escape");
+      if (argValue && strcasecmp(argValue, "url") == 0)
+        escape = ESCAPE_URL;
+      else if (argValue && strcasecmp(argValue, "none") == 0)
+        escape = ESCAPE_NONE;
+
+      argValue = msLookupHashTable(tagArgs, "format");
+      if (argValue)
+        format = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "precision");
+      if (argValue)
+        precision = atoi(argValue);
+
+      argValue = msLookupHashTable(tagArgs, "proj");
+      if (argValue)
+        projectionString = argValue;
+    }
+
+    tempExtent.minx = extent->minx - xExpand;
+    tempExtent.miny = extent->miny - yExpand;
+    tempExtent.maxx = extent->maxx + xExpand;
+    tempExtent.maxy = extent->maxy + yExpand;
+
+    /* no big deal to convert from file to image coordinates, but what are the
+     * image parameters */
+    if (rectProj && projectionString &&
+        strcasecmp(projectionString, "image") == 0) {
+      precision = 0;
+
+      /* if necessary, project the shape to match the map */
+      if (msProjectionsDiffer(rectProj, &(mapserv->map->projection)))
+        msProjectRect(rectProj, &mapserv->map->projection, &tempExtent);
+
+      /* convert tempExtent to image coordinates based on the map extent and
+       * cellsize */
+      tempExtent.minx = MS_MAP2IMAGE_X(
+          tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
+      tempExtent.miny = MS_MAP2IMAGE_Y(
+          tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
+      tempExtent.maxx = MS_MAP2IMAGE_X(
+          tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
+      tempExtent.maxy = MS_MAP2IMAGE_Y(
+          tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
+    } else if (rectProj && projectionString) {
+      projectionObj projection;
+      msInitProjection(&projection);
+      msProjectionInheritContextFrom(&projection, &mapserv->map->projection);
+
+      if (MS_SUCCESS != msLoadProjectionString(&projection, projectionString))
+        return MS_FAILURE;
+
+      if (msProjectionsDiffer(rectProj, &projection))
+        msProjectRect(rectProj, &projection, &tempExtent);
+    }
+
+    char *tagValue = msStrdup(format);
+
+    if (precision != -1)
+      snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
+    else
+      snprintf(numberFormat, sizeof(numberFormat), "%%f");
+
+    snprintf(number, sizeof(number), numberFormat, tempExtent.minx);
+    tagValue = msReplaceSubstring(tagValue, "$minx", number);
+    snprintf(number, sizeof(number), numberFormat, tempExtent.miny);
+    tagValue = msReplaceSubstring(tagValue, "$miny", number);
+    snprintf(number, sizeof(number), numberFormat, tempExtent.maxx);
+    tagValue = msReplaceSubstring(tagValue, "$maxx", number);
+    snprintf(number, sizeof(number), numberFormat, tempExtent.maxy);
+    tagValue = msReplaceSubstring(tagValue, "$maxy", number);
+
+    /* find the end of the tag */
+    char *tagEnd = findTagEnd(tagStart);
+    tagEnd++;
+
+    /* build the complete tag so we can do substitution */
+    const int tagLength = tagEnd - tagStart;
+    char *tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
+
+    /* do the replacement */
+    switch (escape) {
+    case ESCAPE_HTML: {
+      char *encodedTagValue = msEncodeHTMLEntities(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      msFree(encodedTagValue);
+      break;
+    }
+    case ESCAPE_URL: {
+      char *encodedTagValue = msEncodeUrl(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      msFree(encodedTagValue);
+      break;
+    }
+    case ESCAPE_NONE:
+      *line = msReplaceSubstring(*line, tag, tagValue);
+      break;
+    default:
+      break;
+    }
+
+    /* clean up */
+    free(tag);
+    msFreeHashTable(tagArgs);
+    msFree(tagValue);
+
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, name);
+    else
+      tagStart = NULL;
+  }
+
+  return (MS_SUCCESS);
+}
+
+// RFC 77 TODO: Need to validate these changes with Assefa...
+static int processShplabelTag(layerObj *layer, char **line,
+                              shapeObj *origshape) {
+  char *tagEnd;
+  shapeObj tShape;
+  int precision = 0;
+  int clip_to_map = MS_TRUE;
+  int use_label_settings = MS_FALSE;
+  int labelposvalid = MS_FALSE;
+  pointObj labelPos;
+  int status;
+  char number[64]; /* holds a single number in the extent */
+  char numberFormat[16];
+  shapeObj *shape = NULL;
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processShplabelTag()");
+    return (MS_FAILURE);
+  }
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  const char *tagStart = findTag(*line, "shplabel");
+
+  /* It is OK to have no shplabel tags, just return. */
+  if (!tagStart)
+    return MS_SUCCESS;
+
+  if (!origshape ||
+      origshape->numlines <= 0) { /* I suppose we need to make sure the part has
+                                     vertices (need shape checker?) */
+    msSetError(MS_WEBERR, "Null or empty shape.", "processShplabelTag()");
+    return (MS_FAILURE);
+  }
+
+  while (tagStart) {
+    if (shape)
+      msFreeShape(shape);
+    shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+    msInitShape(shape);
+    msCopyShape(origshape, shape);
+
+    const char *projectionString = NULL;
+    const char *format = "$x,$y";
+    const int tagOffset = tagStart - *line;
+
+    hashTableObj *tagArgs = NULL;
+    if (getTagArgs("shplabel", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
+      const char *argValue = msLookupHashTable(tagArgs, "format");
+      if (argValue)
+        format = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "precision");
+      if (argValue)
+        precision = atoi(argValue);
+
+      argValue = msLookupHashTable(tagArgs, "proj");
+      if (argValue)
+        projectionString = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "clip_to_map");
+      if (argValue) {
+        if (strcasecmp(argValue, "false") == 0)
+          clip_to_map = MS_FALSE;
+      }
+
+      argValue = msLookupHashTable(tagArgs, "use_label_settings");
+      if (argValue) {
+        if (strcasecmp(argValue, "true") == 0)
+          use_label_settings = MS_TRUE;
+      }
+    }
+
+    labelPos.x = -1;
+    labelPos.y = -1;
+    msInitShape(&tShape);
+
+    tShape.type = MS_SHAPE_LINE;
+    tShape.line = (lineObj *)msSmallMalloc(sizeof(lineObj));
+    tShape.numlines = 1;
+    tShape.line[0].point = NULL; /* initialize the line */
+    tShape.line[0].numpoints = 0;
+
+    double cellsize;
+    if (layer->map->cellsize <= 0)
+      cellsize =
+          MS_MAX(MS_CELLSIZE(layer->map->extent.minx, layer->map->extent.maxx,
+                             layer->map->width),
+                 MS_CELLSIZE(layer->map->extent.miny, layer->map->extent.maxy,
+                             layer->map->height));
+    else
+      cellsize = layer->map->cellsize;
+
+    if (shape->type == MS_SHAPE_POINT) {
+      labelposvalid = MS_FALSE;
+      if (shape->numlines > 0 && shape->line[0].numpoints > 0) {
+        labelposvalid = MS_TRUE;
+        labelPos = shape->line[0].point[0];
+        if (layer->transform == MS_TRUE) {
+          if (layer->project &&
+              msProjectionsDiffer(&(layer->projection),
+                                  &(layer->map->projection))) {
+            reprojectionObj *reprojector =
+                msLayerGetReprojectorToMap(layer, layer->map);
+            if (reprojector) {
+              msProjectShapeEx(reprojector, shape);
+            }
+          }
+
+          labelPos = shape->line[0].point[0];
+          labelPos.x =
+              MS_MAP2IMAGE_X(labelPos.x, layer->map->extent.minx, cellsize);
+          labelPos.y =
+              MS_MAP2IMAGE_Y(labelPos.y, layer->map->extent.maxy, cellsize);
+        }
+      }
+    } else if (shape->type == MS_SHAPE_LINE) {
+      labelposvalid = MS_FALSE;
+      if (layer->transform == MS_TRUE) {
+        if (layer->project && msProjectionsDiffer(&(layer->projection),
+                                                  &(layer->map->projection))) {
+          reprojectionObj *reprojector =
+              msLayerGetReprojectorToMap(layer, layer->map);
+          if (reprojector) {
+            msProjectShapeEx(reprojector, shape);
+          }
+        }
+
+        if (clip_to_map)
+          msClipPolylineRect(shape, layer->map->extent);
+
+        msTransformShapeToPixelRound(shape, layer->map->extent, cellsize);
+      } else
+        msOffsetShapeRelativeTo(shape, layer);
+
+      if (shape->numlines > 0) {
+        struct label_auto_result lar;
+        memset(&lar, 0, sizeof(struct label_auto_result));
+        if (MS_UNLIKELY(MS_FAILURE == msPolylineLabelPoint(layer->map, shape,
+                                                           NULL, NULL, &lar,
+                                                           0))) {
+          free(lar.angles);
+          free(lar.label_points);
+          return MS_FAILURE;
+        }
+        if (lar.num_label_points > 0) {
+          /* convert to geo */
+          labelPos.x = lar.label_points[0].x;
+          labelPos.y = lar.label_points[0].y;
+          labelposvalid = MS_TRUE;
+        }
+        free(lar.angles);
+        free(lar.label_points);
+      }
+    } else if (shape->type == MS_SHAPE_POLYGON) {
+      labelposvalid = MS_FALSE;
+      if (layer->transform == MS_TRUE) {
+        if (layer->project && msProjectionsDiffer(&(layer->projection),
+                                                  &(layer->map->projection))) {
+          reprojectionObj *reprojector =
+              msLayerGetReprojectorToMap(layer, layer->map);
+          if (reprojector) {
+            msProjectShapeEx(reprojector, shape);
+          }
+        }
+
+        if (clip_to_map)
+          msClipPolygonRect(shape, layer->map->extent);
+
+        msTransformShapeToPixelRound(shape, layer->map->extent, cellsize);
+      } else
+        msOffsetShapeRelativeTo(shape, layer);
+
+      if (shape->numlines > 0) {
+        if (msPolygonLabelPoint(shape, &labelPos, -1) == MS_SUCCESS) {
+          if (labelPos.x == -1 && labelPos.y == -1)
+            labelposvalid = MS_FALSE;
+          else
+            labelposvalid = MS_TRUE;
+        }
+      }
+    }
+
+    if (labelposvalid == MS_TRUE) {
+      pointObj p1 = {0}; // initialize
+      pointObj p2 = {0};
+      int label_offset_x, label_offset_y;
+      labelObj *label = NULL;
+      label_bounds lbounds;
+      lineObj lbounds_line;
+      pointObj lbounds_point[5];
+      double tmp;
+
+      p1.x = labelPos.x;
+      p1.y = labelPos.y;
+
+      p2.x = labelPos.x;
+      p2.y = labelPos.y;
+      if (use_label_settings == MS_TRUE) {
+
+        /* RFC 77: classes (and shapes) can have more than 1 piece of
+         * annotation, here we only use the first (index=0) */
+        if (shape->classindex >= 0 &&
+                layer->class[shape->classindex] -> numlabels > 0) {
+          label = layer->class[shape->classindex]->labels[0];
+          if (msGetLabelStatus(layer->map, layer, shape, label) == MS_ON) {
+            char *annotext = msShapeGetLabelAnnotation(layer, shape, label);
+            if (annotext) {
+              textSymbolObj ts;
+              initTextSymbol(&ts);
+              msPopulateTextSymbolForLabelAndString(&ts, label, annotext,
+                                                    layer->scalefactor, 1.0, 0);
+
+              label_offset_x = (int)(label->offsetx * layer->scalefactor);
+              label_offset_y = (int)(label->offsety * layer->scalefactor);
+              lbounds.poly = &lbounds_line;
+              lbounds_line.numpoints = 5;
+              lbounds_line.point = lbounds_point;
+
+              p1 = get_metrics(&labelPos, label->position, ts.textpath,
+                               label_offset_x, label_offset_y,
+                               label->angle * MS_DEG_TO_RAD, 0, &lbounds);
+
+              /* should we use the point returned from  get_metrics?. From few
+                test done, It seems to return the UL corner of the text. For now
+                use the bounds.minx/miny */
+              p1.x = lbounds.bbox.minx;
+              p1.y = lbounds.bbox.miny;
+              p2.x = lbounds.bbox.maxx;
+              p2.y = lbounds.bbox.maxy;
+              freeTextSymbol(&ts);
+            }
+          }
+        }
+      }
+
+      /* y's are flipped because it is in image coordinate systems */
+      p1.x = MS_IMAGE2MAP_X(p1.x, layer->map->extent.minx, cellsize);
+      tmp = p1.y;
+      p1.y = MS_IMAGE2MAP_Y(p2.y, layer->map->extent.maxy, cellsize);
+      p2.x = MS_IMAGE2MAP_X(p2.x, layer->map->extent.minx, cellsize);
+      p2.y = MS_IMAGE2MAP_Y(tmp, layer->map->extent.maxy, cellsize);
+      if (layer->transform == MS_TRUE) {
+        if (layer->project && msProjectionsDiffer(&(layer->projection),
+                                                  &(layer->map->projection))) {
+          msProjectPoint(&layer->map->projection, &layer->projection, &p1);
+          msProjectPoint(&layer->map->projection, &layer->projection, &p2);
+        }
+      }
+      msAddPointToLine(&(tShape.line[0]), &p1);
+      msAddPointToLine(&(tShape.line[0]), &p2);
+    } else
+      tShape.numlines = 0;
+
+    if (projectionString && strcasecmp(projectionString, "image") == 0) {
+      precision = 0;
+
+      /* if necessary, project the shape to match the map */
+      if (msProjectionsDiffer(&(layer->projection),
+                              &(layer->map->projection))) {
+        reprojectionObj *reprojector =
+            msLayerGetReprojectorToMap(layer, layer->map);
+        if (reprojector) {
+          msProjectShapeEx(reprojector, &tShape);
+        }
+      }
+
+      msClipPolylineRect(&tShape, layer->map->extent);
+
+      msTransformShapeToPixelRound(&tShape, layer->map->extent,
+                                   layer->map->cellsize);
+    } else if (projectionString) {
+      projectionObj projection;
+      msInitProjection(&projection);
+      msProjectionInheritContextFrom(&projection, &layer->map->projection);
+
+      status = msLoadProjectionString(&projection, projectionString);
+      if (status != MS_SUCCESS)
+        return MS_FAILURE;
+
+      if (msProjectionsDiffer(&(layer->projection), &projection))
+        msProjectShape(&layer->projection, &projection, &tShape);
+    }
+
+    /* do the replacement */
+    char *tagValue = msStrdup(format);
+    if (precision > 0)
+      snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
+    else
+      snprintf(numberFormat, sizeof(numberFormat), "%%f");
+
+    if (tShape.numlines > 0) {
+      if (strcasestr(tagValue, "$x") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].x);
+        tagValue = msReplaceSubstring(tagValue, "$x", number);
+      }
+      if (strcasestr(tagValue, "$y") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].y);
+        tagValue = msReplaceSubstring(tagValue, "$y", number);
+      }
+
+      if (strcasestr(tagValue, "$minx") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].x);
+        tagValue = msReplaceSubstring(tagValue, "$minx", number);
+      }
+      if (strcasestr(tagValue, "$miny") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].y);
+        tagValue = msReplaceSubstring(tagValue, "$miny", number);
+      }
+      if (strcasestr(tagValue, "$maxx") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[1].x);
+        tagValue = msReplaceSubstring(tagValue, "$maxx", number);
+      }
+      if (strcasestr(tagValue, "$maxy") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[1].y);
+        tagValue = msReplaceSubstring(tagValue, "$maxy", number);
+      }
+    }
+
+    /* find the end of the tag */
+    tagEnd = findTagEnd(tagStart);
+    tagEnd++;
+
+    /* build the complete tag so we can do substitution */
+    const int tagLength = tagEnd - tagStart;
+    char *tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
+
+    *line = msReplaceSubstring(*line, tag, tagValue);
+
+    /* clean up */
+    msFreeShape(&tShape);
+    free(tag);
+    msFreeHashTable(tagArgs);
+    msFree(tagValue);
+
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "shplabel");
+    else
+      tagStart = NULL;
+  }
+  if (shape)
+    msFreeShape(shape);
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Function to process a [date ...] tag
+*/
+static int processDateTag(char **line) {
+  struct tm *datetime;
+  time_t t;
+  int result;
+  char *tag = NULL, *tagEnd;
+  hashTableObj *tagArgs = NULL;
+  int tagOffset, tagLength;
+#define DATE_BUFLEN 1024
+  char datestr[DATE_BUFLEN];
+  const char *argValue = NULL;
+  const char *format, *tz; /* tag parameters */
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processDateTag()");
+    return (MS_FAILURE);
+  }
+
+  const char *tagStart = findTag(*line, "date");
+
+  /* It is OK to have no date tags, just return. */
+  if (!tagStart)
+    return MS_SUCCESS;
+
+  while (tagStart) {
+    /* set tag params to defaults */
+    format = DEFAULT_DATE_FORMAT;
+    tz = "";
+
+    tagOffset = tagStart - *line;
+
+    /* check for any tag arguments */
+    if (getTagArgs("date", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+
+    if (tagArgs) {
+      argValue = msLookupHashTable(tagArgs, "format");
+      if (argValue)
+        format = argValue;
+      argValue = msLookupHashTable(tagArgs, "tz");
+      if (argValue)
+        tz = argValue;
+    }
+
+    t = time(NULL);
+    if (strncasecmp(tz, "gmt", 4) == 0) {
+      datetime = gmtime(&t);
+    } else {
+      datetime = localtime(&t);
+    }
+    result = strftime(datestr, DATE_BUFLEN, format, datetime);
+
+    /* Only do the replacement if the date was successfully written */
+    if (result > 0) {
+      /* find the end of the tag */
+      tagEnd = findTagEnd(tagStart);
+      tagEnd++;
+
+      /* build the complete tag so we can do substitution */
+      tagLength = tagEnd - tagStart;
+      tag = (char *)msSmallMalloc(tagLength + 1);
+      strlcpy(tag, tagStart, tagLength + 1);
+
+      /* do the replacement */
+      *line = msReplaceSubstring(*line, tag, datestr);
+    }
+
+    /* clean up */
+    msFree(tag);
+    tag = NULL;
+    msFreeHashTable(tagArgs);
+    tagArgs = NULL;
+
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "date");
+    else
+      tagStart = NULL;
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Function to process a [shpxy ...] tag: line contains the tag, shape holds the
+*coordinates.
+**
+** TODO's:
+**   - May need to change attribute names.
+**   - Need generalization routines (not here, but in mapprimative.c).
+**   - Try to avoid all the realloc calls.
+*/
+static int processShpxyTag(layerObj *layer, char **line, shapeObj *shape) {
+  int i, j, p;
+  int status;
+
+  char *tagEnd;
+
+  shapeObj tShape;
+  char point[128];
+
+  if (!*line) {
+    msSetError(MS_WEBERR, "Invalid line pointer.", "processShpxyTag()");
+    return (MS_FAILURE);
+  }
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  const char *tagStart = findTag(*line, "shpxy");
+
+  /* It is OK to have no shpxy tags, just return. */
+  if (!tagStart)
+    return MS_SUCCESS;
+
+  if (!shape ||
+      shape->numlines <= 0) { /* I suppose we need to make sure the part has
+                                 vertices (need shape checker?) */
+    msSetError(MS_WEBERR, "Null or empty shape.", "processShpxyTag()");
+    return (MS_FAILURE);
+  }
+
+  while (tagStart) {
+#ifdef USE_GEOS
+    double buffer = 0;
+    int bufferUnits = -1;
+#endif
+
+    /*
+    ** Pointers to static strings, naming convention is:
+    **   char 1/2 - x=x, y=y, c=coordinate, p=part, s=shape, ir=inner ring,
+    *or=outer ring
+    **   last char - h=header, f=footer, s=separator
+    */
+    const char *xh = "", *yh = "";
+    const char *xf = ",";
+    const char *yf = "";
+    const char *cs = " ";
+    const char *ph = "", *pf = "";
+    const char *ps = " ";
+    const char *sh = "", *sf = "";
+    const char *irh = "",
+               *irf = ""; /* inner ring: necessary for complex polygons */
+    const char *orh = "", *orf = ""; /* outer ring */
+
+    int centroid = MS_FALSE;
+    int precision = 0;
+    double scale_x = 1.0;
+    double scale_y = 1.0;
+
+    const char *projectionString = NULL;
+
+    const int tagOffset = tagStart - *line;
+
+    /* check for any tag arguments */
+    hashTableObj *tagArgs = NULL;
+    if (getTagArgs("shpxy", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
+      const char *argValue = msLookupHashTable(tagArgs, "xh");
+      if (argValue)
+        xh = argValue;
+      argValue = msLookupHashTable(tagArgs, "xf");
+      if (argValue)
+        xf = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "yh");
+      if (argValue)
+        yh = argValue;
+      argValue = msLookupHashTable(tagArgs, "yf");
+      if (argValue)
+        yf = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "cs");
+      if (argValue)
+        cs = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "irh");
+      if (argValue)
+        irh = argValue;
+      argValue = msLookupHashTable(tagArgs, "irf");
+      if (argValue)
+        irf = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "orh");
+      if (argValue)
+        orh = argValue;
+      argValue = msLookupHashTable(tagArgs, "orf");
+      if (argValue)
+        orf = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "ph");
+      if (argValue)
+        ph = argValue;
+      argValue = msLookupHashTable(tagArgs, "pf");
+      if (argValue)
+        pf = argValue;
+      argValue = msLookupHashTable(tagArgs, "ps");
+      if (argValue)
+        ps = argValue;
+
+      argValue = msLookupHashTable(tagArgs, "sh");
+      if (argValue)
+        sh = argValue;
+      argValue = msLookupHashTable(tagArgs, "sf");
+      if (argValue)
+        sf = argValue;
+
+#ifdef USE_GEOS
+      argValue = msLookupHashTable(tagArgs, "buffer");
+      if (argValue) {
+        buffer = atof(argValue);
+        if (strstr(argValue, "px"))
+          bufferUnits = MS_PIXELS; /* may support others at some point */
+      }
+#endif
+
+      argValue = msLookupHashTable(tagArgs, "precision");
+      if (argValue)
+        precision = atoi(argValue);
+
+      argValue = msLookupHashTable(tagArgs, "scale");
+      if (argValue) {
+        scale_x = atof(argValue);
+        scale_y = scale_x;
+      }
+
+      argValue = msLookupHashTable(tagArgs, "scale_x");
+      if (argValue)
+        scale_x = atof(argValue);
+
+      argValue = msLookupHashTable(tagArgs, "scale_y");
+      if (argValue)
+        scale_y = atof(argValue);
+
+      argValue = msLookupHashTable(tagArgs, "centroid");
+      if (argValue)
+        if (strcasecmp(argValue, "true") == 0)
+          centroid = MS_TRUE;
+
+      argValue = msLookupHashTable(tagArgs, "proj");
+      if (argValue)
+        projectionString = argValue;
+    }
+
+    /* build the per point format strings (version 1 contains the coordinate
+     * separator, version 2 doesn't) */
+    const int pointFormatLength =
+        strlen(xh) + strlen(xf) + strlen(yh) + strlen(yf) + strlen(cs) + 12 + 1;
+    char *pointFormat1 = (char *)msSmallMalloc(pointFormatLength);
+    snprintf(pointFormat1, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s%s", xh,
+             precision, xf, yh, precision, yf, cs);
+    char *pointFormat2 = (char *)msSmallMalloc(pointFormatLength);
+    snprintf(pointFormat2, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s", xh,
+             precision, xf, yh, precision, yf);
+
+    /* make a copy of the original shape or compute a centroid if necessary */
+    msInitShape(&tShape);
+    if (centroid == MS_TRUE) {
+      pointObj p;
+
+      p.x = (shape->bounds.minx + shape->bounds.maxx) / 2;
+      p.y = (shape->bounds.miny + shape->bounds.maxy) / 2;
+
+      tShape.type = MS_SHAPE_POINT;
+      tShape.line = (lineObj *)msSmallMalloc(sizeof(lineObj));
+      tShape.numlines = 1;
+      tShape.line[0].point = NULL; /* initialize the line */
+      tShape.line[0].numpoints = 0;
+
+      msAddPointToLine(&(tShape.line[0]), &p);
+    }
+
+#ifdef USE_GEOS
+    else if (buffer != 0 && bufferUnits != MS_PIXELS) {
+      shapeObj *bufferShape = NULL;
+
+      bufferShape = msGEOSBuffer(shape, buffer);
+      if (!bufferShape) {
+        free(pointFormat1);
+        free(pointFormat2);
+        return (MS_FAILURE); /* buffer failed */
+      }
+      msCopyShape(bufferShape, &tShape);
+      msFreeShape(bufferShape);
+    }
+#endif
+    else {
+      status = msCopyShape(shape, &tShape);
+      if (status != 0) {
+        free(pointFormat1);
+        free(pointFormat2);
+        return (MS_FAILURE); /* copy failed */
+      }
+    }
+
+    /* no big deal to convert from file to image coordinates, but what are the
+     * image parameters */
+    if (projectionString && strcasecmp(projectionString, "image") == 0) {
+      precision = 0;
+
+      /* if necessary, project the shape to match the map */
+      if (msProjectionsDiffer(&(layer->projection),
+                              &(layer->map->projection))) {
+        reprojectionObj *reprojector =
+            msLayerGetReprojectorToMap(layer, layer->map);
+        if (reprojector) {
+          msProjectShapeEx(reprojector, &tShape);
+        }
+      }
+
+      switch (tShape.type) {
+      case (MS_SHAPE_POINT):
+        /* no clipping necessary */
+        break;
+      case (MS_SHAPE_LINE):
+        msClipPolylineRect(&tShape, layer->map->extent);
+        break;
+      case (MS_SHAPE_POLYGON):
+        msClipPolygonRect(&tShape, layer->map->extent);
+        break;
+      default:
+        /* TO DO: need an error message here */
+        return (MS_FAILURE);
+        break;
+      }
+      msTransformShapeToPixelRound(&tShape, layer->map->extent,
+                                   layer->map->cellsize);
+
+#ifdef USE_GEOS
+      if (buffer != 0 && bufferUnits == MS_PIXELS) {
+        shapeObj *bufferShape = NULL;
+
+        bufferShape = msGEOSBuffer(&tShape, buffer);
+        if (!bufferShape) {
+          if (!msIsDegenerateShape(
+                  &tShape))      /* If shape is degenerate this is expected. */
+            return (MS_FAILURE); /* buffer failed */
+        } else {
+          msFreeShape(&tShape); /* avoid memory leak */
+          msCopyShape(bufferShape, &tShape);
+          msFreeShape(bufferShape);
+        }
+      }
+#endif
+
+    } else if (projectionString) {
+      projectionObj projection;
+      msInitProjection(&projection);
+      msProjectionInheritContextFrom(&projection, &(layer->projection));
+
+      status = msLoadProjectionString(&projection, projectionString);
+      if (status != MS_SUCCESS)
+        return MS_FAILURE;
+
+      if (msProjectionsDiffer(&(layer->projection), &projection))
+        msProjectShape(&layer->projection, &projection, &tShape);
+    }
+
+    /* TODO: add thinning support here */
+
+    /*
+    ** build the coordinate string
+    */
+
+    char *coords = NULL;
+    if (strlen(sh) > 0)
+      coords = msStringConcatenate(coords, sh);
+
+    /* do we need to handle inner/outer rings */
+    if (tShape.type == MS_SHAPE_POLYGON && strlen(orh) > 0 && strlen(irh) > 0) {
+      int *outers;
+      int firstPart; /* to keep track of inserting part separators before each
+                        part after the first */
+      outers = msGetOuterList(&tShape);
+      firstPart = 1;
+      /* loop over rings looking for outers*/
+      for (i = 0; i < tShape.numlines; i++) {
+        int *inners;
+        if (outers[i]) {
+          /* this is an outer ring */
+          if ((!firstPart) && (strlen(ps) > 0))
+            coords = msStringConcatenate(coords, ps);
+          firstPart = 0;
+          if (strlen(ph) > 0)
+            coords = msStringConcatenate(coords, ph);
+          coords = msStringConcatenate(coords, orh);
+          for (p = 0; p < tShape.line[i].numpoints - 1; p++) {
+            snprintf(point, sizeof(point), pointFormat1,
+                     scale_x * tShape.line[i].point[p].x,
+                     scale_y * tShape.line[i].point[p].y);
+            coords = msStringConcatenate(coords, point);
+          }
+          snprintf(point, sizeof(point), pointFormat2,
+                   scale_x * tShape.line[i].point[p].x,
+                   scale_y * tShape.line[i].point[p].y);
+          coords = msStringConcatenate(coords, point);
+          coords = msStringConcatenate(coords, orf);
+
+          inners = msGetInnerList(&tShape, i, outers);
+          /* loop over rings looking for inners to this outer */
+          for (j = 0; j < tShape.numlines; j++) {
+            if (inners[j]) {
+              /* j is an inner ring of i */
+              coords = msStringConcatenate(coords, irh);
+              for (p = 0; p < tShape.line[j].numpoints - 1; p++) {
+                snprintf(point, sizeof(point), pointFormat1,
+                         scale_x * tShape.line[j].point[p].x,
+                         scale_y * tShape.line[j].point[p].y);
+                coords = msStringConcatenate(coords, point);
+              }
+              snprintf(point, sizeof(point), pointFormat2,
+                       scale_x * tShape.line[j].point[p].x,
+                       scale_y * tShape.line[j].point[p].y);
+              coords = msStringConcatenate(coords, irf);
+            }
+          }
+          free(inners);
+          if (strlen(pf) > 0)
+            coords = msStringConcatenate(coords, pf);
+        }
+      } /* end of loop over outer rings */
+      free(outers);
+    } else { /* output without ring formatting */
+
+      for (i = 0; i < tShape.numlines; i++) { /* e.g. part */
+
+        /* skip degenerate parts, really should only happen with pixel output */
+        if ((tShape.type == MS_SHAPE_LINE && tShape.line[i].numpoints < 2) ||
+            (tShape.type == MS_SHAPE_POLYGON && tShape.line[i].numpoints < 3))
+          continue;
+
+        if (strlen(ph) > 0)
+          coords = msStringConcatenate(coords, ph);
+
+        for (p = 0; p < tShape.line[i].numpoints - 1; p++) {
+          snprintf(point, sizeof(point), pointFormat1,
+                   scale_x * tShape.line[i].point[p].x,
+                   scale_y * tShape.line[i].point[p].y);
+          coords = msStringConcatenate(coords, point);
+        }
+        snprintf(point, sizeof(point), pointFormat2,
+                 scale_x * tShape.line[i].point[p].x,
+                 scale_y * tShape.line[i].point[p].y);
+        coords = msStringConcatenate(coords, point);
+
+        if (strlen(pf) > 0)
+          coords = msStringConcatenate(coords, pf);
+
+        if ((i < tShape.numlines - 1) && (strlen(ps) > 0))
+          coords = msStringConcatenate(coords, ps);
+      }
+    }
+    if (strlen(sf) > 0)
+      coords = msStringConcatenate(coords, sf);
+
+    msFreeShape(&tShape);
+
+    /* find the end of the tag */
+    tagEnd = findTagEnd(tagStart);
+    tagEnd++;
+
+    /* build the complete tag so we can do substitution */
+    const int tagLength = tagEnd - tagStart;
+    char *tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
+
+    /* do the replacement */
+    *line = msReplaceSubstring(*line, tag, coords);
+
+    /* clean up */
+    free(tag);
+    msFreeHashTable(tagArgs);
+    free(pointFormat1);
+    free(pointFormat2);
+    free(coords);
+
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "shpxy");
+    else
+      tagStart = NULL;
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*!
+ * this function process all metadata
+ * in pszInstr. ht mus contain all corresponding
+ * metadata value.
+ *
+ * this function return a modified pszInstr
+ */
+int processMetadata(char **pszInstr, hashTableObj *ht) {
+  /* char *pszNextInstr = pszInstr; */
+  char *pszEnd;
+  char *pszMetadataTag;
+  const char *pszHashName;
+  const char *pszHashValue;
+  int nLength, nOffset;
+
+  hashTableObj *metadataArgs = NULL;
+
+  if (!*pszInstr) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "processMetadata()");
+    return MS_FAILURE;
+  }
+
+  /* set position to the beginning of metadata tag */
+  const char *pszStart = findTag(*pszInstr, "metadata");
+
+  while (pszStart) {
+    /* get metadata args */
+    if (getTagArgs("metadata", pszStart, &metadataArgs) != MS_SUCCESS)
+      return MS_FAILURE;
+
+    pszHashName = msLookupHashTable(metadataArgs, "name");
+    pszHashValue = msLookupHashTable(ht, pszHashName);
+
+    nOffset = pszStart - *pszInstr;
+
+    if (pszHashName && pszHashValue) {
+      /* set position to the end of metadata start tag */
+      pszEnd = strchr(pszStart, ']');
+      pszEnd++;
+
+      /* build the complete metadata tag ([metadata all_args]) */
+      /* to replace it by the corresponding value from ht */
+      nLength = pszEnd - pszStart;
+      pszMetadataTag = (char *)msSmallMalloc(nLength + 1);
+      strlcpy(pszMetadataTag, pszStart, nLength + 1);
+
+      *pszInstr = msReplaceSubstring(*pszInstr, pszMetadataTag, pszHashValue);
+
+      free(pszMetadataTag);
+      pszMetadataTag = NULL;
+    }
+
+    msFreeHashTable(metadataArgs);
+    metadataArgs = NULL;
+
+    /* set position to the beginning of the next metadata tag */
+    if ((*pszInstr)[nOffset] != '\0')
+      pszStart = findTag(*pszInstr + nOffset + 1, "metadata");
+    else
+      pszStart = NULL;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*!
+ * this function process all icon tag
+ * from pszInstr.
+ *
+ * This func return a modified pszInstr.
+ */
+int processIcon(mapObj *map, int nIdxLayer, int nIdxClass, char **pszInstr,
+                char *pszPrefix) {
+  int nWidth, nHeight, nLen;
+  char szImgFname[1024], *pszImgTag;
+  char szPath[MS_MAXPATHLEN];
+  hashTableObj *myHashTable = NULL;
+  FILE *fIcon;
+
+  if (!map || nIdxLayer > map->numlayers || nIdxLayer < 0) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "processIcon()");
+    return MS_FAILURE;
+  }
+
+  /* find the beginning of tag */
+  pszImgTag = strstr(*pszInstr, "[leg_icon");
+
+  while (pszImgTag) {
+    int i;
+    char szStyleCode[512] = "";
+    classObj *thisClass = NULL;
+
+    /* It's okay to have no classes... we'll generate an empty icon in this case
+     */
+    if (nIdxClass >= 0 && nIdxClass < GET_LAYER(map, nIdxLayer)->numclasses)
+      thisClass = GET_LAYER(map, nIdxLayer)->class[nIdxClass];
+
+    if (getTagArgs("leg_icon", pszImgTag, &myHashTable) != MS_SUCCESS)
+      return MS_FAILURE;
+
+    /* if no specified width or height, set them to map default */
+    if (!msLookupHashTable(myHashTable, "width") ||
+        !msLookupHashTable(myHashTable, "height")) {
+      nWidth = map->legend.keysizex;
+      nHeight = map->legend.keysizey;
+    } else {
+      nWidth = atoi(msLookupHashTable(myHashTable, "width"));
+      nHeight = atoi(msLookupHashTable(myHashTable, "height"));
+    }
+
+    /* Create a unique and predictable filename to cache the legend icons.
+     * Include some key parameters from the first 2 styles
+     */
+    for (i = 0; i < 2 && thisClass && i < thisClass->numstyles; i++) {
+      styleObj *style;
+      char *pszSymbolNameHash = NULL;
+      style = thisClass->styles[i];
+      if (style->symbolname)
+        pszSymbolNameHash = msHashString(style->symbolname);
+
+      snprintf(szStyleCode + strlen(szStyleCode), 255, "s%d_%x_%x_%d_%s_%g", i,
+               MS_COLOR_GETRGB(style->color),
+               MS_COLOR_GETRGB(style->outlinecolor), style->symbol,
+               pszSymbolNameHash ? pszSymbolNameHash : "", style->angle);
+      msFree(pszSymbolNameHash);
+    }
+
+    snprintf(szImgFname, sizeof(szImgFname), "%s_%d_%d_%d_%d_%s.%s%c",
+             pszPrefix, nIdxLayer, nIdxClass, nWidth, nHeight, szStyleCode,
+             MS_IMAGE_EXTENSION(map->outputformat), '\0');
+
+    char *pszFullImgFname = msStrdup(
+        msBuildPath3(szPath, map->mappath, map->web.imagepath, szImgFname));
+
+    /* check if icon already exist in cache */
+    if ((fIcon = fopen(pszFullImgFname, "r")) != NULL) {
+      /* File already exists. No need to generate it again */
+      fclose(fIcon);
+    } else {
+      /* Create an image corresponding to the current class */
+      imageObj *img = NULL;
+
+      if (thisClass == NULL) {
+        /* Nonexistent class.  Create an empty image */
+        img = msCreateLegendIcon(map, NULL, NULL, nWidth, nHeight, MS_TRUE);
+      } else {
+        img = msCreateLegendIcon(map, GET_LAYER(map, nIdxLayer), thisClass,
+                                 nWidth, nHeight, MS_TRUE);
+      }
+
+      if (!img) {
+        if (myHashTable)
+          msFreeHashTable(myHashTable);
+
+        msSetError(MS_IMGERR, "Error while creating image.", "processIcon()");
+        msFree(pszFullImgFname);
+        return MS_FAILURE;
+      }
+
+      /* save it with a unique file name */
+      if (msSaveImage(map, img, pszFullImgFname) != MS_SUCCESS) {
+        if (myHashTable)
+          msFreeHashTable(myHashTable);
+
+        msFreeImage(img);
+
+        msSetError(MS_IOERR, "Error saving GD image to disk (%s).",
+                   "processIcon()", pszFullImgFname);
+        msFree(pszFullImgFname);
+        return MS_FAILURE;
+      }
+
+      msFreeImage(img);
+    }
+
+    msFree(pszFullImgFname);
+
+    nLen = (strchr(pszImgTag, ']') + 1) - pszImgTag;
+
+    if (nLen > 0) {
+      char *pszTag;
+
+      /* rebuild image tag ([leg_class_img all_args]) */
+      /* to replace it by the image url */
+      pszTag = (char *)msSmallMalloc(nLen + 1);
+      strlcpy(pszTag, pszImgTag, nLen + 1);
+
+      char *pszFullImgUrlFname = (char *)msSmallMalloc(
+          strlen(map->web.imageurl) + strlen(szImgFname) + 1);
+      strcpy(pszFullImgUrlFname, map->web.imageurl);
+      strcat(pszFullImgUrlFname, szImgFname);
+
+      *pszInstr = msReplaceSubstring(*pszInstr, pszTag, pszFullImgUrlFname);
+
+      msFree(pszFullImgUrlFname);
+      msFree(pszTag);
+
+      /* find the beginning of tag */
+      pszImgTag = strstr(*pszInstr, "[leg_icon");
+    } else {
+      pszImgTag = NULL;
+    }
+
+    if (myHashTable) {
+      msFreeHashTable(myHashTable);
+      myHashTable = NULL;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*!
+ * Replace all tags from group template
+ * with correct value.
+ *
+ * this function return a buffer containing
+ * the template with correct values.
+ *
+ * buffer must be freed by caller.
+ */
+int generateGroupTemplate(char *pszGroupTemplate, mapObj *map,
+                          char *pszGroupName, hashTableObj *oGroupArgs,
+                          char **pszTemp, char *pszPrefix) {
+  hashTableObj *myHashTable;
+  char pszStatus[3];
+  char *pszClassImg;
+  const char *pszOptFlag = NULL;
+  int i, j;
+  int nOptFlag = 15;
+  int bShowGroup;
+
+  *pszTemp = NULL;
+
+  if (!pszGroupName || !pszGroupTemplate) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "generateGroupTemplate()");
+    return MS_FAILURE;
+  }
+
+  /*
+   * Get the opt_flag is any.
+   */
+  if (oGroupArgs)
+    pszOptFlag = msLookupHashTable(oGroupArgs, "opt_flag");
+
+  if (pszOptFlag)
+    nOptFlag = atoi(pszOptFlag);
+
+  /*
+   * Check all layers, if one in the group
+   * should be visible, print the group.
+   * (Check for opt_flag)
+   */
+  bShowGroup = 0;
+  for (j = 0; j < map->numlayers; j++) {
+    if (GET_LAYER(map, map->layerorder[j])->group &&
+        strcmp(GET_LAYER(map, map->layerorder[j])->group, pszGroupName) == 0) {
+      /* don't display layer is off. */
+      if ((nOptFlag & 2) == 0 &&
+          GET_LAYER(map, map->layerorder[j])->status == MS_OFF)
+        bShowGroup = 0;
+      else
+        bShowGroup = 1;
+
+      /* don't display layer is query. */
+      if ((nOptFlag & 4) == 0 &&
+          GET_LAYER(map, map->layerorder[j])->type == MS_LAYER_QUERY)
+        bShowGroup = 0;
+
+      /* don't display layer if out of scale. */
+      if ((nOptFlag & 1) == 0) {
+        if (map->scaledenom > 0) {
+          if ((GET_LAYER(map, map->layerorder[j])->maxscaledenom > 0) &&
+              (map->scaledenom >
+               GET_LAYER(map, map->layerorder[j])->maxscaledenom))
+            bShowGroup = 0;
+          if ((GET_LAYER(map, map->layerorder[j])->minscaledenom > 0) &&
+              (map->scaledenom <=
+               GET_LAYER(map, map->layerorder[j])->minscaledenom))
+            bShowGroup = 0;
+        }
+      }
+
+      /* The group contains one visible layer */
+      /* Draw the group */
+      if (bShowGroup)
+        break;
+    }
+  }
+
+  if (!bShowGroup)
+    return MS_SUCCESS;
+
+  /*
+   * Work from a copy
+   */
+  *pszTemp = (char *)msSmallMalloc(strlen(pszGroupTemplate) + 1);
+  strcpy(*pszTemp, pszGroupTemplate);
+
+  /*
+   * Change group tags
+   */
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_group_name]", pszGroupName);
+
+  /*
+   * Create a hash table that contain info
+   * on current layer
+   */
+  myHashTable = msCreateHashTable();
+
+  /*
+   * Check for the first layer
+   * that belong to this group.
+   * Get his status and check for if.
+   */
+  for (j = 0; j < map->numlayers; j++) {
+    if (GET_LAYER(map, map->layerorder[j])->group &&
+        strcmp(GET_LAYER(map, map->layerorder[j])->group, pszGroupName) == 0) {
+      snprintf(pszStatus, sizeof(pszStatus), "%d",
+               GET_LAYER(map, map->layerorder[j])->status);
+      msInsertHashTable(myHashTable, "layer_status", pszStatus);
+      msInsertHashTable(
+          myHashTable, "layer_visible",
+          msLayerIsVisible(map, GET_LAYER(map, map->layerorder[j])) ? "1"
+                                                                    : "0");
+      msInsertHashTable(
+          myHashTable, "layer_queryable",
+          msIsLayerQueryable(GET_LAYER(map, map->layerorder[j])) ? "1" : "0");
+      msInsertHashTable(myHashTable, "group_name", pszGroupName);
+
+      if (processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
+        return MS_FAILURE;
+
+      if (processIfTag(pszTemp, &(GET_LAYER(map, map->layerorder[j])->metadata),
+                       MS_FALSE) != MS_SUCCESS)
+        return MS_FAILURE;
+
+      if (processMetadata(pszTemp,
+                          &GET_LAYER(map, map->layerorder[j])->metadata) !=
+          MS_SUCCESS)
+        return MS_FAILURE;
+
+      break;
+    }
+  }
+
+  msFreeHashTable(myHashTable);
+
+  /*
+   * Process all metadata tags
+   * only web object is accessible
+   */
+  if (processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /*
+   * check for if tag
+   */
+  if (processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /*
+   * Check if leg_icon tag exist
+   * if so display the first layer first class icon
+   */
+  pszClassImg = strstr(*pszTemp, "[leg_icon");
+  if (pszClassImg) {
+    /* find first layer of this group */
+    for (i = 0; i < map->numlayers; i++)
+      if (GET_LAYER(map, map->layerorder[i])->group &&
+          strcmp(GET_LAYER(map, map->layerorder[i])->group, pszGroupName) == 0)
+        processIcon(map, map->layerorder[i], 0, pszTemp, pszPrefix);
+  }
+
+  return MS_SUCCESS;
+}
+
+/*!
+ * Replace all tags from layer template
+ * with correct value.
+ *
+ * this function return a buffer containing
+ * the template with correct values.
+ *
+ * buffer must be freed by caller.
+ */
+int generateLayerTemplate(char *pszLayerTemplate, mapObj *map, int nIdxLayer,
+                          hashTableObj *oLayerArgs, char **pszTemp,
+                          char *pszPrefix) {
+  hashTableObj *myHashTable;
+  char szStatus[10];
+  char szType[10];
+
+  int nOptFlag = 0;
+  const char *pszOptFlag = NULL;
+  char *pszClassImg;
+
+  char
+      szTmpstr[128]; /* easily big enough for the couple of instances we need */
+
+  *pszTemp = NULL;
+
+  if (!pszLayerTemplate || !map || nIdxLayer > map->numlayers ||
+      nIdxLayer < 0) {
+    msSetError(MS_WEBERR, "Invalid pointer.", "generateLayerTemplate()");
+    return MS_FAILURE;
+  }
+
+  if (oLayerArgs)
+    pszOptFlag = msLookupHashTable(oLayerArgs, "opt_flag");
+
+  if (pszOptFlag)
+    nOptFlag = atoi(pszOptFlag);
+
+  /* don't display deleted layers */
+  if (GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
+    return MS_SUCCESS;
+
+  /* don't display layer is off. */
+  /* check this if Opt flag is not set */
+  if ((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
+    return MS_SUCCESS;
+
+  /* don't display layer is query. */
+  /* check this if Opt flag is not set */
+  if ((nOptFlag & 4) == 0 && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
+    return MS_SUCCESS;
+
+  /* don't display layer if out of scale. */
+  /* check this if Opt flag is not set             */
+  if ((nOptFlag & 1) == 0) {
+    if (map->scaledenom > 0) {
+      if ((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) &&
+          (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
+        return MS_SUCCESS;
+      if ((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) &&
+          (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
+        return MS_SUCCESS;
+    }
+  }
+
+  /*
+   * Work from a copy
+   */
+  *pszTemp = msStrdup(pszLayerTemplate);
+
+  /*
+   * Change layer tags
+   */
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]",
+                                GET_LAYER(map, nIdxLayer)->name);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_group]",
+                                GET_LAYER(map, nIdxLayer)->group);
+
+  snprintf(szTmpstr, sizeof(szTmpstr), "%d", nIdxLayer);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_index]", szTmpstr);
+
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->minscaledenom);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_minscale]", szTmpstr);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_layer_minscaledenom]", szTmpstr);
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->maxscaledenom);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_maxscale]", szTmpstr);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_layer_maxscaledenom]", szTmpstr);
+
+  /*
+   * Create a hash table that contain info
+   * on current layer
+   */
+  myHashTable = msCreateHashTable();
+
+  /*
+   * for now, only status and type is required by template
+   */
+  snprintf(szStatus, sizeof(szStatus), "%d", GET_LAYER(map, nIdxLayer)->status);
+  msInsertHashTable(myHashTable, "layer_status", szStatus);
+
+  snprintf(szType, sizeof(szType), "%d", GET_LAYER(map, nIdxLayer)->type);
+  msInsertHashTable(myHashTable, "layer_type", szType);
+
+  msInsertHashTable(
+      myHashTable, "layer_name",
+      (GET_LAYER(map, nIdxLayer)->name) ? GET_LAYER(map, nIdxLayer)->name : "");
+  msInsertHashTable(myHashTable, "layer_group",
+                    (GET_LAYER(map, nIdxLayer)->group)
+                        ? GET_LAYER(map, nIdxLayer)->group
+                        : "");
+  msInsertHashTable(myHashTable, "layer_visible",
+                    msLayerIsVisible(map, GET_LAYER(map, nIdxLayer)) ? "1"
+                                                                     : "0");
+  msInsertHashTable(myHashTable, "layer_queryable",
+                    msIsLayerQueryable(GET_LAYER(map, nIdxLayer)) ? "1" : "0");
+
+  if (processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) !=
+      MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  msFreeHashTable(myHashTable);
+
+  /*
+   * Check if leg_icon tag exist
+   * if so display the first class icon
+   */
+  pszClassImg = strstr(*pszTemp, "[leg_icon");
+  if (pszClassImg) {
+    processIcon(map, nIdxLayer, 0, pszTemp, pszPrefix);
+  }
+
+  /* process all metadata tags
+   * only current layer and web object
+   * metadata are accessible
+   */
+  if (processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) !=
+      MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+/*!
+ * Replace all tags from class template
+ * with correct value.
+ *
+ * this function return a buffer containing
+ * the template with correct values.
+ *
+ * buffer must be freed by caller.
+ */
+int generateClassTemplate(char *pszClassTemplate, mapObj *map, int nIdxLayer,
+                          int nIdxClass, hashTableObj *oClassArgs,
+                          char **pszTemp, char *pszPrefix) {
+  hashTableObj *myHashTable;
+  char szStatus[10];
+  char szType[10];
+
+  char *pszClassImg;
+  int nOptFlag = 0;
+  const char *pszOptFlag = NULL;
+
+  char
+      szTmpstr[128]; /* easily big enough for the couple of instances we need */
+
+  *pszTemp = NULL;
+
+  if (!pszClassTemplate || !map || nIdxLayer > map->numlayers ||
+      nIdxLayer < 0 || nIdxClass > GET_LAYER(map, nIdxLayer)->numclasses ||
+      nIdxClass < 0) {
+
+    msSetError(MS_WEBERR, "Invalid pointer.", "generateClassTemplate()");
+    return MS_FAILURE;
+  }
+
+  if (oClassArgs)
+    pszOptFlag = msLookupHashTable(oClassArgs, "Opt_flag");
+
+  if (pszOptFlag)
+    nOptFlag = atoi(pszOptFlag);
+
+  /* don't display deleted layers */
+  if (GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
+    return MS_SUCCESS;
+
+  /* don't display class if layer is off. */
+  /* check this if Opt flag is not set */
+  if ((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
+    return MS_SUCCESS;
+
+  /* don't display class if layer is query. */
+  /* check this if Opt flag is not set       */
+  if ((nOptFlag & 4) == 0 && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
+    return MS_SUCCESS;
+
+  /* don't display layer if out of scale. */
+  /* check this if Opt flag is not set */
+  if ((nOptFlag & 1) == 0) {
+    if (map->scaledenom > 0) {
+      if ((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) &&
+          (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
+        return MS_SUCCESS;
+      if ((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) &&
+          (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
+        return MS_SUCCESS;
+    }
+  }
+
+  /*
+   * Work from a copy
+   */
+  *pszTemp = (char *)msSmallMalloc(strlen(pszClassTemplate) + 1);
+  strcpy(*pszTemp, pszClassTemplate);
+
+  /*
+   * Change class tags
+   */
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_name]",
+                         GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> name);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_title]",
+                         GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> title);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]",
+                                GET_LAYER(map, nIdxLayer)->name);
+
+  snprintf(szTmpstr, sizeof(szTmpstr), "%d", nIdxClass);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_index]", szTmpstr);
+
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> minscaledenom);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_minscale]", szTmpstr);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_minscaledenom]", szTmpstr);
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> maxscaledenom);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_maxscale]", szTmpstr);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_maxscaledenom]", szTmpstr);
+
+  /*
+   * Create a hash table that contain info
+   * on current layer
+   */
+  myHashTable = msCreateHashTable();
+
+  /*
+   * for now, only status, type, name and group are  required by template
+   */
+  snprintf(szStatus, sizeof(szStatus), "%d", GET_LAYER(map, nIdxLayer)->status);
+  msInsertHashTable(myHashTable, "layer_status", szStatus);
+
+  snprintf(szType, sizeof(szType), "%d", GET_LAYER(map, nIdxLayer)->type);
+  msInsertHashTable(myHashTable, "layer_type", szType);
+
+  msInsertHashTable(
+      myHashTable, "layer_name",
+      (GET_LAYER(map, nIdxLayer)->name) ? GET_LAYER(map, nIdxLayer)->name : "");
+  msInsertHashTable(myHashTable, "layer_group",
+                    (GET_LAYER(map, nIdxLayer)->group)
+                        ? GET_LAYER(map, nIdxLayer)->group
+                        : "");
+  msInsertHashTable(myHashTable, "layer_visible",
+                    msLayerIsVisible(map, GET_LAYER(map, nIdxLayer)) ? "1"
+                                                                     : "0");
+  msInsertHashTable(myHashTable, "layer_queryable",
+                    msIsLayerQueryable(GET_LAYER(map, nIdxLayer)) ? "1" : "0");
+  msInsertHashTable(myHashTable, "class_name",
+                    (GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> name)
+                    ? GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> name
+                    : "");
+
+  if (processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) !=
+      MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  msFreeHashTable(myHashTable);
+
+  /*
+   * Check if leg_icon tag exist
+   */
+  pszClassImg = strstr(*pszTemp, "[leg_icon");
+  if (pszClassImg) {
+    processIcon(map, nIdxLayer, nIdxClass, pszTemp, pszPrefix);
+  }
+
+  /* process all metadata tags
+   * only current layer and web object
+   * metadata are accessible
+   */
+  if (processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) !=
+      MS_SUCCESS)
+    return MS_FAILURE;
+
+  if (processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
+    return MS_FAILURE;
+
+  return MS_SUCCESS;
+}
+
+char *generateLegendTemplate(mapservObj *mapserv) {
+  FILE *stream;
+  char *file = NULL;
+  int length;
+  char *pszResult = NULL;
+  char *legGroupHtml = NULL;
+  char *legLayerHtml = NULL;
+  char *legClassHtml = NULL;
+  char *legLayerHtmlCopy = NULL;
+  char *legClassHtmlCopy = NULL;
+  char *legGroupHtmlCopy = NULL;
+
+  char *legHeaderHtml = NULL;
+  char *legFooterHtml = NULL;
+
+  char *pszPrefix = NULL;
+  char *pszMapFname = NULL;
+
+  struct stat tmpStat;
+
+  const char *pszOrderMetadata = NULL;
+  const char *pszOrder = NULL;
+
+  int i, j, k;
+  char **papszGroups = NULL;
+  int nGroupNames = 0;
+
+  const char *pszOrderValue;
+
+  hashTableObj *groupArgs = NULL;
+  hashTableObj *layerArgs = NULL;
+  hashTableObj *classArgs = NULL;
+
+  ms_regex_t re; /* compiled regular expression to be matched */
+
+  int *panCurrentDrawingOrder = NULL;
+  char szPath[MS_MAXPATHLEN];
+
+  if (ms_regcomp(&re, MS_TEMPLATE_EXPR,
+                 MS_REG_EXTENDED | MS_REG_NOSUB | MS_REG_ICASE) != 0) {
+    msSetError(MS_IOERR, "Error regcomp.", "generateLegendTemplate()");
+    return NULL;
+  }
+
+  if (ms_regexec(&re, mapserv->map->legend.template, 0, NULL, 0) !=
+      0) { /* no match */
+    msSetError(MS_IOERR, "Invalid template file name.",
+               "generateLegendTemplate()");
+    ms_regfree(&re);
+    return NULL;
+  }
+  ms_regfree(&re);
+
+  /* -------------------------------------------------------------------- */
+  /*      Save the current drawing order. The drawing order is reset      */
+  /*      at the end of the function.                                     */
+  /* -------------------------------------------------------------------- */
+  if (mapserv->map->numlayers > 0) {
+    panCurrentDrawingOrder =
+        (int *)msSmallMalloc(sizeof(int) * mapserv->map->numlayers);
+
+    for (i = 0; i < mapserv->map->numlayers; i++) {
+      if (mapserv->map->layerorder)
+        panCurrentDrawingOrder[i] = mapserv->map->layerorder[i];
+      else
+        panCurrentDrawingOrder[i] = i;
+    }
+  }
+
+  /*
+   * build prefix filename
+   * for legend icon creation
+   */
+  for (i = 0; i < mapserv->request->NumParams;
+       i++) /* find the mapfile parameter first */
+    if (strcasecmp(mapserv->request->ParamNames[i], "map") == 0)
+      break;
+
+  if (i == mapserv->request->NumParams) {
+    const char *ms_mapfile = CPLGetConfigOption("MS_MAPFILE", NULL);
+    if (ms_mapfile)
+      pszMapFname = msStringConcatenate(pszMapFname, ms_mapfile);
+  } else {
+    if (getenv(mapserv->request->ParamValues[i])) /* an environment references
+                                                     the actual file to use */
+      pszMapFname = msStringConcatenate(
+          pszMapFname, getenv(mapserv->request->ParamValues[i]));
+    else
+      pszMapFname =
+          msStringConcatenate(pszMapFname, mapserv->request->ParamValues[i]);
+  }
+
+  if (pszMapFname) {
+    if (stat(pszMapFname, &tmpStat) != -1) {
+      int nLen;
+
+      nLen = (mapserv->map->name ? strlen(mapserv->map->name) : 0) + 50;
+      pszPrefix = (char *)msSmallMalloc((nLen + 1) * sizeof(char));
+      snprintf(pszPrefix, nLen, "%s_%ld_%ld", mapserv->map->name,
+               (long)tmpStat.st_size, (long)tmpStat.st_mtime);
+      pszPrefix[nLen] = '\0';
+    }
+
+    free(pszMapFname);
+    pszMapFname = NULL;
+  } else {
+    /* -------------------------------------------------------------------- */
+    /*      map file name may not be available when the template functions    */
+    /*      are called from mapscript. Use the time stamp as prefix.        */
+    /* -------------------------------------------------------------------- */
+    char pszTime[20];
+
+    snprintf(pszTime, sizeof(pszTime), "%ld", (long)time(NULL));
+    pszPrefix = msStringConcatenate(pszPrefix, pszTime);
+  }
+
+  /* open template */
+  if ((stream = fopen(msBuildPath(szPath, mapserv->map->mappath,
+                                  mapserv->map->legend.template),
+                      "r")) == NULL) {
+    msSetError(MS_IOERR, "Error while opening template file.",
+               "generateLegendTemplate()");
+    free(pszResult);
+    pszResult = NULL;
+    goto error;
+  }
+
+  fseek(stream, 0, SEEK_END);
+  long lengthLong = ftell(stream);
+  rewind(stream);
+  if (lengthLong < 0 || lengthLong > INT_MAX - 1) {
+    msSetError(MS_IOERR, "Too large template file.",
+               "generateLegendTemplate()");
+    free(pszResult);
+    pszResult = NULL;
+    goto error;
+  }
+  length = (int)lengthLong;
+
+  file = (char *)malloc(length + 1);
+  if (file == NULL) {
+    msSetError(MS_IOERR, "Cannot allocate memory for template file.",
+               "generateLegendTemplate()");
+    free(pszResult);
+    pszResult = NULL;
+    goto error;
+  }
+
+  /*
+   * Read all the template file
+   */
+  IGUR_sizet(fread(file, length, 1, stream));
+  /* E. Rouault: the below issue is due to opening in "r" mode, which is a
+   * synonymous of "rt" on Windows. In that mode \r\n are turned into \n,
+   * consequently less bytes are written in the output buffer than requested.
+   * A potential fix might be to open in "rb" mode, but is the code ready
+   * to deal with Windows \r\n end of lines ? */
+  /* Disabled for now due to Windows issue, see ticket #3814
+     if( 1 != fread(file, length, 1, stream)) {
+       msSetError(MS_IOERR, "Error while reading template file.",
+     "generateLegendTemplate()"); free(file); fclose(stream); return NULL;
+     }
+  */
+  file[length] = '\0';
+
+  if (msValidateContexts(mapserv->map) !=
+      MS_SUCCESS) { /* make sure there are no recursive REQUIRES or
+                       LABELREQUIRES expressions */
+    if (pszResult)
+      free(pszResult);
+    pszResult = NULL;
+    goto error;
+  }
+
+  /*
+   * Separate header/footer, groups, layers and class
+   */
+  getInlineTag("leg_header_html", file, &legHeaderHtml);
+  getInlineTag("leg_footer_html", file, &legFooterHtml);
+  getInlineTag("leg_group_html", file, &legGroupHtml);
+  getInlineTag("leg_layer_html", file, &legLayerHtml);
+  getInlineTag("leg_class_html", file, &legClassHtml);
+
+  /*
+   * Retrieve arguments of all three parts
+   */
+  if (legGroupHtml)
+    if (getTagArgs("leg_group_html", file, &groupArgs) != MS_SUCCESS) {
+      if (pszResult)
+        free(pszResult);
+      pszResult = NULL;
+      goto error;
+    }
+
+  if (legLayerHtml)
+    if (getTagArgs("leg_layer_html", file, &layerArgs) != MS_SUCCESS) {
+      if (pszResult)
+        free(pszResult);
+      pszResult = NULL;
+      goto error;
+    }
+
+  if (legClassHtml)
+    if (getTagArgs("leg_class_html", file, &classArgs) != MS_SUCCESS) {
+      if (pszResult)
+        free(pszResult);
+      pszResult = NULL;
+      goto error;
+    }
+
+  mapserv->map->cellsize = msAdjustExtent(
+      &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+  if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                       mapserv->map->width, mapserv->map->height,
+                       mapserv->map->resolution,
+                       &mapserv->map->scaledenom) != MS_SUCCESS) {
+    if (pszResult)
+      free(pszResult);
+    pszResult = NULL;
+    goto error;
+  }
+
+  /* start with the header if present */
+  if (legHeaderHtml)
+    pszResult = msStringConcatenate(pszResult, legHeaderHtml);
+
+  /********************************************************************/
+
+  /*
+   * order layers if order_metadata args is set
+   * If not, keep default order
+   */
+  pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
+
+  if (sortLayerByMetadata(mapserv->map, pszOrderMetadata) != MS_SUCCESS) {
+    if (pszResult)
+      free(pszResult);
+    pszResult = NULL;
+    goto error;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      if the order tag is set to ascending or descending, the         */
+  /*      current order will be changed to correspond to that.            */
+  /* -------------------------------------------------------------------- */
+  pszOrder = msLookupHashTable(layerArgs, "order");
+  if (pszOrder && ((strcasecmp(pszOrder, "ASCENDING") == 0) ||
+                   (strcasecmp(pszOrder, "DESCENDING") == 0))) {
+    if (sortLayerByOrder(mapserv->map, pszOrder) != MS_SUCCESS) {
+      if (pszResult)
+        free(pszResult);
+      pszResult = NULL;
+      goto error;
+    }
+  }
+
+  if (legGroupHtml) {
+    /* retrieve group names */
+    papszGroups = msGetAllGroupNames(mapserv->map, &nGroupNames);
+
+    for (i = 0; i < nGroupNames; i++) {
+      /* process group tags */
+      if (generateGroupTemplate(legGroupHtml, mapserv->map, papszGroups[i],
+                                groupArgs, &legGroupHtmlCopy,
+                                pszPrefix) != MS_SUCCESS) {
+        if (pszResult)
+          free(pszResult);
+        pszResult = NULL;
+        goto error;
+      }
+
+      /* concatenate it to final result */
+      pszResult = msStringConcatenate(pszResult, legGroupHtmlCopy);
+
+      /*
+               if(!pszResult)
+               {
+                  if(pszResult)
+                    free(pszResult);
+                  pszResult=NULL;
+                  goto error;
+               }
+      */
+
+      if (legGroupHtmlCopy) {
+        free(legGroupHtmlCopy);
+        legGroupHtmlCopy = NULL;
+      }
+
+      /* for all layers in group */
+      if (legLayerHtml) {
+        for (j = 0; j < mapserv->map->numlayers; j++) {
+          /*
+           * if order_metadata is set and the order
+           * value is less than 0, don't display it
+           */
+          pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
+          if (pszOrderMetadata) {
+            pszOrderValue = msLookupHashTable(
+                &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                      ->metadata),
+                pszOrderMetadata);
+            if (pszOrderValue) {
+              const int nLegendOrder = atoi(pszOrderValue);
+              if (nLegendOrder < 0)
+                continue;
+            }
+          }
+          if (mapserv->hittest &&
+              mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                  0) {
+            continue;
+          }
+
+          if (GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group &&
+              strcmp(
+                  GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group,
+                  papszGroups[i]) == 0) {
+            /* process all layer tags */
+            if (generateLayerTemplate(
+                    legLayerHtml, mapserv->map, mapserv->map->layerorder[j],
+                    layerArgs, &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
+              if (pszResult)
+                free(pszResult);
+              pszResult = NULL;
+              goto error;
+            }
+
+            /* concatenate to final result */
+            pszResult = msStringConcatenate(pszResult, legLayerHtmlCopy);
+
+            if (legLayerHtmlCopy) {
+              free(legLayerHtmlCopy);
+              legLayerHtmlCopy = NULL;
+            }
+
+            /* for all classes in layer */
+            if (legClassHtml) {
+              for (k = 0;
+                   k < GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                           ->numclasses;
+                   k++) {
+                /* process all class tags */
+                if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                         ->class[k] -> name)
+                  continue;
+                if (mapserv->hittest &&
+                    mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                            .classhits[k]
+                            .status == 0) {
+                  continue;
+                }
+
+                if (generateClassTemplate(legClassHtml, mapserv->map,
+                                          mapserv->map->layerorder[j], k,
+                                          classArgs, &legClassHtmlCopy,
+                                          pszPrefix) != MS_SUCCESS) {
+                  if (pszResult)
+                    free(pszResult);
+                  pszResult = NULL;
+                  goto error;
+                }
+
+                /* concatenate to final result */
+                pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
+
+                if (legClassHtmlCopy) {
+                  free(legClassHtmlCopy);
+                  legClassHtmlCopy = NULL;
+                }
+              }
+            }
+          }
+        }
+      } else if (legClassHtml) { /* no layer template specified but class and
+                                    group template */
+        for (j = 0; j < mapserv->map->numlayers; j++) {
+          /*
+           * if order_metadata is set and the order
+           * value is less than 0, don't display it
+           */
+          pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
+          if (pszOrderMetadata) {
+            pszOrderValue = msLookupHashTable(
+                &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                      ->metadata),
+                pszOrderMetadata);
+            if (pszOrderValue) {
+              const int nLegendOrder = atoi(pszOrderValue);
+              if (nLegendOrder < 0)
+                continue;
+            }
+          }
+          if (mapserv->hittest &&
+              mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                  0) {
+            continue;
+          }
+
+          if (GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group &&
+              strcmp(
+                  GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group,
+                  papszGroups[i]) == 0) {
+            /* for all classes in layer */
+
+            for (k = 0; k < GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                                ->numclasses;
+                 k++) {
+              /* process all class tags */
+              if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                       ->class[k] -> name)
+                continue;
+              if (mapserv->hittest &&
+                  mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                          .classhits[k]
+                          .status == 0) {
+                continue;
+              }
+
+              if (generateClassTemplate(legClassHtml, mapserv->map,
+                                        mapserv->map->layerorder[j], k,
+                                        classArgs, &legClassHtmlCopy,
+                                        pszPrefix) != MS_SUCCESS) {
+                if (pszResult)
+                  free(pszResult);
+                pszResult = NULL;
+                goto error;
+              }
+
+              /* concatenate to final result */
+              pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
+
+              if (legClassHtmlCopy) {
+                free(legClassHtmlCopy);
+                legClassHtmlCopy = NULL;
+              }
+            }
+          }
+        }
+      }
+    }
+  } else {
+    /* if no group template specified */
+    if (legLayerHtml) {
+      for (j = 0; j < mapserv->map->numlayers; j++) {
+        /*
+         * if order_metadata is set and the order
+         * value is less than 0, don't display it
+         */
+        pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
+        if (pszOrderMetadata) {
+          pszOrderValue = msLookupHashTable(
+              &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata),
+              pszOrderMetadata);
+          if (pszOrderValue) {
+            const int nLegendOrder = atoi(pszOrderValue);
+            if (nLegendOrder < 0)
+              continue;
+          }
+        }
+        if (mapserv->hittest &&
+            mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                0) {
+          continue;
+        }
+
+        /* process a layer tags */
+        if (generateLayerTemplate(legLayerHtml, mapserv->map,
+                                  mapserv->map->layerorder[j], layerArgs,
+                                  &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
+          if (pszResult)
+            free(pszResult);
+          pszResult = NULL;
+          goto error;
+        }
+
+        /* concatenate to final result */
+        pszResult = msStringConcatenate(pszResult, legLayerHtmlCopy);
+
+        if (legLayerHtmlCopy) {
+          free(legLayerHtmlCopy);
+          legLayerHtmlCopy = NULL;
+        }
+
+        /* for all classes in layer */
+        if (legClassHtml) {
+          for (k = 0;
+               k <
+               GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses;
+               k++) {
+            /* process all class tags */
+            if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]
+                -> name)
+              continue;
+            if (mapserv->hittest &&
+                mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                        .classhits[k]
+                        .status == 0) {
+              continue;
+            }
+
+            if (generateClassTemplate(
+                    legClassHtml, mapserv->map, mapserv->map->layerorder[j], k,
+                    classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
+              if (pszResult)
+                free(pszResult);
+              pszResult = NULL;
+              goto error;
+            }
+
+            /* concatenate to final result */
+            pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
+
+            if (legClassHtmlCopy) {
+              free(legClassHtmlCopy);
+              legClassHtmlCopy = NULL;
+            }
+          }
+        }
+      }
+    } else { /* if no group and layer template specified */
+      if (legClassHtml) {
+        for (j = 0; j < mapserv->map->numlayers; j++) {
+          /*
+           * if order_metadata is set and the order
+           * value is less than 0, don't display it
+           */
+          pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
+          if (pszOrderMetadata) {
+            pszOrderValue = msLookupHashTable(
+                &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                      ->metadata),
+                pszOrderMetadata);
+            if (pszOrderValue) {
+              const int nLegendOrder = atoi(pszOrderValue);
+              if (nLegendOrder < 0)
+                continue;
+            }
+          }
+          if (mapserv->hittest &&
+              mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                  0) {
+            continue;
+          }
+
+          for (k = 0;
+               k <
+               GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses;
+               k++) {
+            if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]
+                -> name)
+              continue;
+            if (mapserv->hittest &&
+                mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                        .classhits[k]
+                        .status == 0) {
+              continue;
+            }
+
+            if (generateClassTemplate(
+                    legClassHtml, mapserv->map, mapserv->map->layerorder[j], k,
+                    classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
+              if (pszResult)
+                free(pszResult);
+              pszResult = NULL;
+              goto error;
+            }
+
+            pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
+
+            if (legClassHtmlCopy) {
+              free(legClassHtmlCopy);
+              legClassHtmlCopy = NULL;
+            }
+          }
+        }
+      }
+    }
+  }
+
+  /* finish with the footer if present */
+  if (legFooterHtml)
+    pszResult = msStringConcatenate(pszResult, legFooterHtml);
+
+  /*
+   * if we reach this point, that mean no error was generated.
+   * So check if template is null and initialize it to <space>.
+   */
+  if (pszResult == NULL) {
+    pszResult = msStringConcatenate(pszResult, " ");
+  }
+
+  /********************************************************************/
+
+error:
+
+  if (papszGroups) {
+    for (i = 0; i < nGroupNames; i++)
+      msFree(papszGroups[i]);
+
+    msFree(papszGroups);
+  }
+
+  msFreeHashTable(groupArgs);
+  msFreeHashTable(layerArgs);
+  msFreeHashTable(classArgs);
+
+  msFree(file);
+
+  msFree(legGroupHtmlCopy);
+  msFree(legLayerHtmlCopy);
+  msFree(legClassHtmlCopy);
+
+  msFree(legHeaderHtml);
+  msFree(legFooterHtml);
+
+  msFree(legGroupHtml);
+  msFree(legLayerHtml);
+  msFree(legClassHtml);
+  msFree(pszPrefix);
+
+  if (stream)
+    fclose(stream);
+
+  /* -------------------------------------------------------------------- */
+  /*      Reset the layerdrawing order.                                   */
+  /* -------------------------------------------------------------------- */
+  if (panCurrentDrawingOrder && mapserv->map->layerorder) {
+    for (i = 0; i < mapserv->map->numlayers; i++)
+      mapserv->map->layerorder[i] = panCurrentDrawingOrder[i];
+
+    free(panCurrentDrawingOrder);
+  }
+
+  return pszResult;
+}
+
+char *processOneToManyJoin(mapservObj *mapserv, joinObj *join) {
+  int records = MS_FALSE;
+  FILE *stream = NULL;
+  char *outbuf;
+  char line[MS_BUFFER_LENGTH], *tmpline;
+  char szPath[MS_MAXPATHLEN];
+
+  if ((outbuf = msStrdup("")) == NULL)
+    return (NULL); /* empty at first */
+
+  msJoinPrepare(join, &(mapserv->resultshape)); /* execute the join */
+  while (msJoinNext(join) == MS_SUCCESS) {
+    /* First time through, deal with the header (if necessary) and open the main
+     * template. We only */
+    /* want to do this if there are joined records. */
+    if (records == MS_FALSE) {
+      if (join->header != NULL) {
+        /* coverity[dead_error_line] */
+        if (stream)
+          fclose(stream);
+        if ((stream =
+                 fopen(msBuildPath(szPath, mapserv->map->mappath, join->header),
+                       "r")) == NULL) {
+          msSetError(MS_IOERR, "Error while opening join header file %s.",
+                     "processOneToManyJoin()", join->header);
+          msFree(outbuf);
+          return (NULL);
+        }
+
+        if (isValidTemplate(stream, join->header) != MS_TRUE) {
+          fclose(stream);
+          msFree(outbuf);
+          return NULL;
+        }
+
+        /* echo file to the output buffer, no substitutions */
+        while (fgets(line, MS_BUFFER_LENGTH, stream) != NULL)
+          outbuf = msStringConcatenate(outbuf, line);
+
+        fclose(stream);
+        stream = NULL;
+      }
+
+      if ((stream =
+               fopen(msBuildPath(szPath, mapserv->map->mappath, join->template),
+                     "r")) == NULL) {
+        msSetError(MS_IOERR, "Error while opening join template file %s.",
+                   "processOneToManyJoin()", join->template);
+        msFree(outbuf);
+        return (NULL);
+      }
+
+      if (isValidTemplate(stream, join->template) != MS_TRUE) {
+        fclose(stream);
+        msFree(outbuf);
+        return NULL;
+      }
+
+      records = MS_TRUE;
+    }
+
+    while (fgets(line, MS_BUFFER_LENGTH, stream) !=
+           NULL) { /* now on to the end of the template */
+      if (strchr(line, '[') != NULL) {
+        tmpline =
+            processLine(mapserv, line, NULL,
+                        QUERY); /* no multiline tags are allowed in a join */
+        if (!tmpline) {
+          msFree(outbuf);
+          fclose(stream);
+          return NULL;
+        }
+        outbuf = msStringConcatenate(outbuf, tmpline);
+        free(tmpline);
+      } else /* no subs, just echo */
+        outbuf = msStringConcatenate(outbuf, line);
+    }
+
+    rewind(stream);
+    IGUR_voidp(
+        fgets(line, MS_BUFFER_LENGTH,
+              stream)); /* skip the first line since it's the magic string */
+  }                     /* next record */
+
+  if (records == MS_TRUE && join->footer) {
+    if (stream)
+      fclose(stream);
+    if ((stream =
+             fopen(msBuildPath(szPath, mapserv->map->mappath, join->footer),
+                   "r")) == NULL) {
+      msSetError(MS_IOERR, "Error while opening join footer file %s.",
+                 "processOneToManyJoin()", join->footer);
+      msFree(outbuf);
+      return (NULL);
+    }
+
+    if (isValidTemplate(stream, join->footer) != MS_TRUE) {
+      msFree(outbuf);
+      fclose(stream);
+      return NULL;
+    }
+
+    /* echo file to the output buffer, no substitutions */
+    while (fgets(line, MS_BUFFER_LENGTH, stream) != NULL)
+      outbuf = msStringConcatenate(outbuf, line);
+
+    fclose(stream);
+    stream = NULL;
+  }
+
+  /* clear any data associated with the join */
+  msFreeCharArray(join->values, join->numitems);
+  join->values = NULL;
+
+  if (stream)
+    fclose(stream);
+
+  return (outbuf);
+}
+
+/*
+** Process a single line in the template. A few tags (e.g.
+*[resultset]...[/resultset]) can be multi-line so
+** we pass the filehandle to look ahead if necessary.
+*/
+static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream,
+                         int mode) {
+  int i, j;
+#define PROCESSLINE_BUFLEN 5120
+  char repstr[PROCESSLINE_BUFLEN], substr[PROCESSLINE_BUFLEN],
+      *outstr; /* repstr = replace string, substr = sub string */
+  struct hashObj *tp = NULL;
+  char *encodedstr;
+
+  rectObj llextent;
+  pointObj llpoint;
+
+  outstr = msStrdup(instr); /* work from a copy */
+
+  if (strstr(outstr, "[version]"))
+    outstr = msReplaceSubstring(outstr, "[version]", msGetVersion());
+
+  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.%s", mapserv->map->web.imageurl,
+           mapserv->map->name, mapserv->Id,
+           MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+  outstr = msReplaceSubstring(outstr, "[img]", repstr);
+  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sref%s.%s",
+           mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id,
+           MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+  outstr = msReplaceSubstring(outstr, "[ref]", repstr);
+
+  if (strstr(outstr, "[errmsg")) {
+    char *errmsg = msGetErrorString(";");
+    if (!errmsg)
+      errmsg =
+          msStrdup("Error message buffer is empty."); /* should never happen,
+                                                         but just in case... */
+    outstr = msReplaceSubstring(outstr, "[errmsg]", errmsg);
+    encodedstr = msEncodeUrl(errmsg);
+    outstr = msReplaceSubstring(outstr, "[errmsg_esc]", encodedstr);
+    free(errmsg);
+    free(encodedstr);
+  }
+
+  if (strstr(outstr, "[legend]")) {
+    /* if there's a template legend specified, use it */
+    if (mapserv->map->legend.template) {
+      char *legendTemplate;
+
+      legendTemplate = generateLegendTemplate(mapserv);
+      if (legendTemplate) {
+        outstr = msReplaceSubstring(outstr, "[legend]", legendTemplate);
+
+        free(legendTemplate);
+      } else /* error already generated by (generateLegendTemplate()) */
+        return NULL;
+    } else { /* if not display gif image with all legend icon */
+      snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sleg%s.%s",
+               mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id,
+               MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+      outstr = msReplaceSubstring(outstr, "[legend]", repstr);
+    }
+  }
+
+  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%ssb%s.%s",
+           mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id,
+           MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+  outstr = msReplaceSubstring(outstr, "[scalebar]", repstr);
+
+  if (mapserv->savequery) {
+    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s%s",
+             mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+             MS_QUERY_EXTENSION);
+    outstr = msReplaceSubstring(outstr, "[queryfile]", repstr);
+  }
+
+  if (mapserv->savemap) {
+    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.map",
+             mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id);
+    outstr = msReplaceSubstring(outstr, "[map]", repstr);
+  }
+
+  if (strstr(outstr, "[mapserv_onlineresource]")) {
+    char *ol;
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+    ol = msOWSGetOnlineResource(mapserv->map, "O", "onlineresource",
+                                mapserv->request);
+#else
+    ol = msBuildOnlineResource(mapserv->map, mapserv->request);
+#endif
+    outstr = msReplaceSubstring(outstr, "[mapserv_onlineresource]", ol);
+    msFree(ol);
+  }
+
+  if (getenv("HTTP_HOST")) {
+    snprintf(repstr, PROCESSLINE_BUFLEN, "%s", getenv("HTTP_HOST"));
+    outstr = msReplaceSubstring(outstr, "[host]", repstr);
+  }
+  if (getenv("SERVER_PORT")) {
+    snprintf(repstr, PROCESSLINE_BUFLEN, "%s", getenv("SERVER_PORT"));
+    outstr = msReplaceSubstring(outstr, "[port]", repstr);
+  }
+
+  snprintf(repstr, PROCESSLINE_BUFLEN, "%s", mapserv->Id);
+  outstr = msReplaceSubstring(outstr, "[id]", repstr);
+
+  repstr[0] = '\0'; /* Layer list for a "POST" request */
+  for (i = 0; i < mapserv->NumLayers; i++) {
+    strlcat(repstr, mapserv->Layers[i], sizeof(repstr));
+    strlcat(repstr, " ", sizeof(repstr));
+  }
+  msStringTrimBlanks(repstr);
+  encodedstr = msEncodeHTMLEntities(repstr);
+  outstr = msReplaceSubstring(outstr, "[layers]", encodedstr);
+  free(encodedstr);
+
+  encodedstr = msEncodeUrl(repstr);
+  outstr = msReplaceSubstring(outstr, "[layers_esc]", encodedstr);
+  free(encodedstr);
+
+  strcpy(repstr, ""); /* list of ALL layers that can be toggled */
+  repstr[0] = '\0';
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    if (GET_LAYER(mapserv->map, i)->status != MS_DEFAULT &&
+        GET_LAYER(mapserv->map, i)->name != NULL) {
+      strlcat(repstr, GET_LAYER(mapserv->map, i)->name, sizeof(repstr));
+      strlcat(repstr, " ", sizeof(repstr));
+    }
+  }
+  msStringTrimBlanks(repstr);
+  outstr = msReplaceSubstring(outstr, "[toggle_layers]", repstr);
+
+  encodedstr = msEncodeUrl(repstr);
+  outstr = msReplaceSubstring(outstr, "[toggle_layers_esc]", encodedstr);
+  free(encodedstr);
+
+  for (i = 0; i < mapserv->map->numlayers;
+       i++) { /* Set form widgets (i.e. checkboxes, radio and select lists),
+                 note that default layers don't show up here */
+    if (isOn(mapserv, GET_LAYER(mapserv->map, i)->name,
+             GET_LAYER(mapserv->map, i)->group) == MS_TRUE) {
+      if (GET_LAYER(mapserv->map, i)->group) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->group);
+        outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->group);
+        outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
+      }
+      if (GET_LAYER(mapserv->map, i)->name) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->name);
+        outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->name);
+        outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
+      }
+    } else {
+      if (GET_LAYER(mapserv->map, i)->group) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->group);
+        outstr = msReplaceSubstring(outstr, substr, "");
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->group);
+        outstr = msReplaceSubstring(outstr, substr, "");
+      }
+      if (GET_LAYER(mapserv->map, i)->name) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->name);
+        outstr = msReplaceSubstring(outstr, substr, "");
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->name);
+        outstr = msReplaceSubstring(outstr, substr, "");
+      }
+    }
+  }
+
+  for (i = -1; i <= 1; i++) { /* make zoom direction persistent */
+    if (mapserv->ZoomDirection == i) {
+      snprintf(substr, sizeof(substr), "[zoomdir_%d_select]", i);
+      outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
+      snprintf(substr, sizeof(substr), "[zoomdir_%d_check]", i);
+      outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
+    } else {
+      snprintf(substr, sizeof(substr), "[zoomdir_%d_select]", i);
+      outstr = msReplaceSubstring(outstr, substr, "");
+      snprintf(substr, sizeof(substr), "[zoomdir_%d_check]", i);
+      outstr = msReplaceSubstring(outstr, substr, "");
+    }
+  }
+
+  for (i = MINZOOM; i <= MAXZOOM; i++) { /* make zoom persistent */
+    if (mapserv->Zoom == i) {
+      snprintf(substr, sizeof(substr), "[zoom_%d_select]", i);
+      outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
+      snprintf(substr, sizeof(substr), "[zoom_%d_check]", i);
+      outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
+    } else {
+      snprintf(substr, sizeof(substr), "[zoom_%d_select]", i);
+      outstr = msReplaceSubstring(outstr, substr, "");
+      snprintf(substr, sizeof(substr), "[zoom_%d_check]", i);
+      outstr = msReplaceSubstring(outstr, substr, "");
+    }
+  }
+
+  /* allow web object metadata access in template */
+
+  /*
+   * reworked by SG to use HashTable methods
+   */
+
+  if (strstr(outstr, "web_")) {
+    for (j = 0; j < MS_HASHSIZE; j++) {
+      if (mapserv->map->web.metadata.items[j] != NULL) {
+        for (tp = mapserv->map->web.metadata.items[j]; tp != NULL;
+             tp = tp->next) {
+          snprintf(substr, PROCESSLINE_BUFLEN, "[web_%s]", tp->key);
+          outstr = msReplaceSubstring(outstr, substr, tp->data);
+          snprintf(substr, PROCESSLINE_BUFLEN, "[web_%s_esc]", tp->key);
+
+          encodedstr = msEncodeUrl(tp->data);
+          outstr = msReplaceSubstring(outstr, substr, encodedstr);
+          free(encodedstr);
+        }
+      }
+    }
+  }
+
+  /* allow layer metadata access in template */
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    if (GET_LAYER(mapserv->map, i)->name &&
+        strstr(outstr, GET_LAYER(mapserv->map, i)->name)) {
+      for (j = 0; j < MS_HASHSIZE; j++) {
+        if (GET_LAYER(mapserv->map, i)->metadata.items[j] != NULL) {
+          for (tp = GET_LAYER(mapserv->map, i)->metadata.items[j]; tp != NULL;
+               tp = tp->next) {
+            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]",
+                     GET_LAYER(mapserv->map, i)->name, tp->key);
+            if (GET_LAYER(mapserv->map, i)->status == MS_ON)
+              outstr = msReplaceSubstring(outstr, substr, tp->data);
+            else
+              outstr = msReplaceSubstring(outstr, substr, "");
+            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]",
+                     GET_LAYER(mapserv->map, i)->name, tp->key);
+            if (GET_LAYER(mapserv->map, i)->status == MS_ON) {
+              encodedstr = msEncodeUrl(tp->data);
+              outstr = msReplaceSubstring(outstr, substr, encodedstr);
+              free(encodedstr);
+            } else
+              outstr = msReplaceSubstring(outstr, substr, "");
+          }
+        }
+      }
+    }
+  }
+
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->mappnt.x);
+  outstr = msReplaceSubstring(outstr, "[mapx]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->mappnt.y);
+  outstr = msReplaceSubstring(outstr, "[mapy]", repstr);
+
+  snprintf(repstr, sizeof(repstr), "%f",
+           mapserv->map->extent.minx); /* Individual mapextent elements for
+                                          spatial query building, deprecated. */
+  outstr = msReplaceSubstring(outstr, "[minx]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.maxx);
+  outstr = msReplaceSubstring(outstr, "[maxx]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.miny);
+  outstr = msReplaceSubstring(outstr, "[miny]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.maxy);
+  outstr = msReplaceSubstring(outstr, "[maxy]", repstr);
+
+  if (processDateTag(&outstr) != MS_SUCCESS)
+    return (NULL);
+
+  if (processExtentTag(mapserv, &outstr, "mapext", &(mapserv->map->extent),
+                       &(mapserv->map->projection)) != MS_SUCCESS)
+    return (NULL);
+  if (processExtentTag(mapserv, &outstr, "mapext_esc", &(mapserv->map->extent),
+                       &(mapserv->map->projection)) !=
+      MS_SUCCESS) /* deprecated */
+    return (NULL);
+
+  snprintf(repstr, sizeof(repstr), "%f",
+           (mapserv->map->extent.maxx -
+            mapserv->map->extent
+                .minx)); /* useful for creating cachable extents (i.e. 0 0 dx
+                            dy) with legends and scalebars */
+  outstr = msReplaceSubstring(outstr, "[dx]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f",
+           (mapserv->map->extent.maxy - mapserv->map->extent.miny));
+  outstr = msReplaceSubstring(outstr, "[dy]", repstr);
+
+  snprintf(repstr, sizeof(repstr), "%f",
+           mapserv->RawExt.minx); /* Individual raw extent elements for spatial
+                                     query building, deprecated. */
+  outstr = msReplaceSubstring(outstr, "[rawminx]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.maxx);
+  outstr = msReplaceSubstring(outstr, "[rawmaxx]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.miny);
+  outstr = msReplaceSubstring(outstr, "[rawminy]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.maxy);
+  outstr = msReplaceSubstring(outstr, "[rawmaxy]", repstr);
+
+  if (processExtentTag(mapserv, &outstr, "rawext", &(mapserv->RawExt),
+                       &(mapserv->map->projection)) != MS_SUCCESS)
+    return (NULL);
+  if (processExtentTag(mapserv, &outstr, "rawext_esc", &(mapserv->RawExt),
+                       &(mapserv->map->projection)) !=
+      MS_SUCCESS) /* deprecated */
+    return (NULL);
+
+  if ((strstr(outstr, "lat]") || strstr(outstr, "lon]") ||
+       strstr(outstr, "lon_esc]")) &&
+      mapserv->map->projection.proj != NULL) {
+    llextent = mapserv->map->extent;
+    llpoint = mapserv->mappnt;
+    if (!msProjIsGeographicCRS(&(mapserv->map->projection))) {
+      msProjectRect(&(mapserv->map->projection), &(mapserv->map->latlon),
+                    &llextent);
+      msProjectPoint(&(mapserv->map->projection), &(mapserv->map->latlon),
+                     &llpoint);
+    }
+    snprintf(repstr, sizeof(repstr), "%f", llpoint.x);
+    outstr = msReplaceSubstring(outstr, "[maplon]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", llpoint.y);
+    outstr = msReplaceSubstring(outstr, "[maplat]", repstr);
+
+    snprintf(repstr, sizeof(repstr), "%f",
+             llextent.minx); /* map extent as lat/lon */
+    outstr = msReplaceSubstring(outstr, "[minlon]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", llextent.maxx);
+    outstr = msReplaceSubstring(outstr, "[maxlon]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", llextent.miny);
+    outstr = msReplaceSubstring(outstr, "[minlat]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", llextent.maxy);
+    outstr = msReplaceSubstring(outstr, "[maxlat]", repstr);
+
+    if (processExtentTag(mapserv, &outstr, "mapext_latlon", &(llextent),
+                         NULL) != MS_SUCCESS)
+      return (NULL);
+    if (processExtentTag(mapserv, &outstr, "mapext_latlon_esc", &(llextent),
+                         NULL) != MS_SUCCESS) /* deprecated */
+      return (NULL);
+  }
+
+  /* submitted by J.F (bug 1102) */
+  if (mapserv->map->reference.status == MS_ON) {
+    snprintf(repstr, sizeof(repstr), "%f",
+             mapserv->map->reference.extent
+                 .minx); /* Individual reference map extent elements for spatial
+                            query building, deprecated. */
+    outstr = msReplaceSubstring(outstr, "[refminx]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.maxx);
+    outstr = msReplaceSubstring(outstr, "[refmaxx]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.miny);
+    outstr = msReplaceSubstring(outstr, "[refminy]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.maxy);
+    outstr = msReplaceSubstring(outstr, "[refmaxy]", repstr);
+
+    if (processExtentTag(mapserv, &outstr, "refext",
+                         &(mapserv->map->reference.extent),
+                         &(mapserv->map->projection)) != MS_SUCCESS)
+      return (NULL);
+    if (processExtentTag(
+            mapserv, &outstr, "refext_esc", &(mapserv->map->reference.extent),
+            &(mapserv->map->projection)) != MS_SUCCESS) /* deprecated */
+      return (NULL);
+  }
+
+  snprintf(repstr, sizeof(repstr), "%d %d", mapserv->map->width,
+           mapserv->map->height);
+  outstr = msReplaceSubstring(outstr, "[mapsize]", repstr);
+
+  encodedstr = msEncodeUrl(repstr);
+  outstr = msReplaceSubstring(outstr, "[mapsize_esc]", encodedstr);
+  free(encodedstr);
+
+  snprintf(repstr, sizeof(repstr), "%d", mapserv->map->width);
+  outstr = msReplaceSubstring(outstr, "[mapwidth]", repstr);
+  snprintf(repstr, sizeof(repstr), "%d", mapserv->map->height);
+  outstr = msReplaceSubstring(outstr, "[mapheight]", repstr);
+
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->scaledenom);
+  outstr = msReplaceSubstring(outstr, "[scale]", repstr);
+  outstr = msReplaceSubstring(outstr, "[scaledenom]", repstr);
+  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->cellsize);
+  outstr = msReplaceSubstring(outstr, "[cellsize]", repstr);
+
+  snprintf(repstr, sizeof(repstr), "%.1f %.1f", (mapserv->map->width) / 2.0,
+           (mapserv->map->height) /
+               2.0); /* not subtracting 1 from image dimensions (see bug 633) */
+  outstr = msReplaceSubstring(outstr, "[center]", repstr);
+  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->width) / 2.0);
+  outstr = msReplaceSubstring(outstr, "[center_x]", repstr);
+  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->height) / 2.0);
+  outstr = msReplaceSubstring(outstr, "[center_y]", repstr);
+
+  /* These are really for situations with multiple result sets only, but often
+   * used in header/footer   */
+  snprintf(repstr, sizeof(repstr), "%d",
+           mapserv->NR); /* total number of results */
+  outstr = msReplaceSubstring(outstr, "[nr]", repstr);
+  snprintf(repstr, sizeof(repstr), "%d",
+           mapserv->NL); /* total number of layers with results */
+  outstr = msReplaceSubstring(outstr, "[nl]", repstr);
+
+  if (mapserv->resultlayer) {
+    if (strstr(outstr, "[items]") != NULL) {
+      char *itemstr = NULL;
+
+      itemstr = msJoinStrings(mapserv->resultlayer->items,
+                              mapserv->resultlayer->numitems, ",");
+      outstr = msReplaceSubstring(outstr, "[items]", itemstr);
+      free(itemstr);
+    }
+
+    snprintf(repstr, sizeof(repstr), "%d",
+             mapserv->NLR); /* total number of results within this layer */
+    outstr = msReplaceSubstring(outstr, "[nlr]", repstr);
+    snprintf(
+        repstr, sizeof(repstr), "%d",
+        mapserv
+            ->RN); /* sequential (eg. 1..n) result number within all layers */
+    outstr = msReplaceSubstring(outstr, "[rn]", repstr);
+    snprintf(
+        repstr, sizeof(repstr), "%d",
+        mapserv
+            ->LRN); /* sequential (eg. 1..n) result number within this layer */
+    outstr = msReplaceSubstring(outstr, "[lrn]", repstr);
+    outstr = msReplaceSubstring(
+        outstr, "[cl]", mapserv->resultlayer->name); /* current layer name */
+    /* if(resultlayer->description) outstr = msReplaceSubstring(outstr, "[cd]",
+     * resultlayer->description); */ /* current layer description */
+
+    /* allow layer metadata access when there is a current result layer
+     * (implicitly a query template) */
+    if (strstr(outstr, "[metadata_")) {
+      for (i = 0; i < MS_HASHSIZE; i++) {
+        if (mapserv->resultlayer->metadata.items[i] != NULL) {
+          for (tp = mapserv->resultlayer->metadata.items[i]; tp != NULL;
+               tp = tp->next) {
+            snprintf(substr, PROCESSLINE_BUFLEN, "[metadata_%s]", tp->key);
+            outstr = msReplaceSubstring(outstr, substr, tp->data);
+
+            snprintf(substr, PROCESSLINE_BUFLEN, "[metadata_%s_esc]", tp->key);
+            encodedstr = msEncodeUrl(tp->data);
+            outstr = msReplaceSubstring(outstr, substr, encodedstr);
+            free(encodedstr);
+          }
+        }
+      }
+    }
+  }
+
+  if (mode != QUERY) {
+    if (processResultSetTag(mapserv, &outstr, stream) != MS_SUCCESS) {
+      msFree(outstr);
+      return (NULL);
+    }
+  } else { /* return shape and/or values */
+
+    assert(mapserv->resultlayer);
+
+    snprintf(
+        repstr, sizeof(repstr), "%f %f",
+        (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx) /
+            2,
+        (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny) /
+            2);
+    outstr = msReplaceSubstring(outstr, "[shpmid]", repstr);
+    snprintf(
+        repstr, sizeof(repstr), "%f",
+        (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx) /
+            2);
+    outstr = msReplaceSubstring(outstr, "[shpmidx]", repstr);
+    snprintf(
+        repstr, sizeof(repstr), "%f",
+        (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny) /
+            2);
+    outstr = msReplaceSubstring(outstr, "[shpmidy]", repstr);
+
+    if (processExtentTag(mapserv, &outstr, "shpext",
+                         &(mapserv->resultshape.bounds),
+                         &(mapserv->resultlayer->projection)) != MS_SUCCESS)
+      return (NULL);
+    if (processExtentTag(
+            mapserv, &outstr, "shpext_esc", &(mapserv->resultshape.bounds),
+            &(mapserv->resultlayer->projection)) != MS_SUCCESS) /* depricated */
+      return (NULL);
+
+    snprintf(repstr, sizeof(repstr), "%d", mapserv->resultshape.classindex);
+    outstr = msReplaceSubstring(outstr, "[shpclass]", repstr);
+
+    if (processShpxyTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) !=
+        MS_SUCCESS)
+      return (NULL);
+
+    if (processShplabelTag(mapserv->resultlayer, &outstr,
+                           &mapserv->resultshape) != MS_SUCCESS)
+      return (NULL);
+
+    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.minx);
+    outstr = msReplaceSubstring(outstr, "[shpminx]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.miny);
+    outstr = msReplaceSubstring(outstr, "[shpminy]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.maxx);
+    outstr = msReplaceSubstring(outstr, "[shpmaxx]", repstr);
+    snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.maxy);
+    outstr = msReplaceSubstring(outstr, "[shpmaxy]", repstr);
+
+    snprintf(repstr, sizeof(repstr), "%ld", mapserv->resultshape.index);
+    outstr = msReplaceSubstring(outstr, "[shpidx]", repstr);
+    snprintf(repstr, sizeof(repstr), "%d", mapserv->resultshape.tileindex);
+    outstr = msReplaceSubstring(outstr, "[tileidx]", repstr);
+
+    /* return ALL attributes in one delimited list */
+    if (strstr(outstr, "[values]") != NULL) {
+      char *valuestr = NULL;
+
+      valuestr = msJoinStrings(mapserv->resultshape.values,
+                               mapserv->resultlayer->numitems, ",");
+      outstr = msReplaceSubstring(outstr, "[values]", valuestr);
+      free(valuestr);
+    }
+
+    for (i = 0; i < mapserv->resultlayer->numitems; i++) {
+      /* by default let's encode attributes for HTML presentation */
+      snprintf(substr, PROCESSLINE_BUFLEN, "[%s]",
+               mapserv->resultlayer->items[i]);
+      if (strstr(outstr, substr) != NULL) {
+        encodedstr = msEncodeHTMLEntities(mapserv->resultshape.values[i]);
+        outstr = msReplaceSubstring(outstr, substr, encodedstr);
+        free(encodedstr);
+      }
+
+      /* of course you might want to embed that data in URLs */
+      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]",
+               mapserv->resultlayer->items[i]);
+      if (strstr(outstr, substr) != NULL) {
+        encodedstr = msEncodeUrl(mapserv->resultshape.values[i]);
+        outstr = msReplaceSubstring(outstr, substr, encodedstr);
+        free(encodedstr);
+      }
+
+      /* or you might want to access the attributes unaltered */
+      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_raw]",
+               mapserv->resultlayer->items[i]);
+      if (strstr(outstr, substr) != NULL)
+        outstr =
+            msReplaceSubstring(outstr, substr, mapserv->resultshape.values[i]);
+    }
+
+    if (processItemTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) !=
+        MS_SUCCESS)
+      return (NULL);
+
+    /* handle joins in this next section */
+    for (i = 0; i < mapserv->resultlayer->numjoins; i++) {
+      if (mapserv->resultlayer->joins[i].values) { /* join has data */
+        for (j = 0; j < mapserv->resultlayer->joins[i].numitems; j++) {
+          /* by default let's encode attributes for HTML presentation */
+          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]",
+                   mapserv->resultlayer->joins[i].name,
+                   mapserv->resultlayer->joins[i].items[j]);
+          if (strstr(outstr, substr) != NULL) {
+            encodedstr =
+                msEncodeHTMLEntities(mapserv->resultlayer->joins[i].values[j]);
+            outstr = msReplaceSubstring(outstr, substr, encodedstr);
+            free(encodedstr);
+          }
+
+          /* of course you might want to embed that data in URLs */
+          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]",
+                   mapserv->resultlayer->joins[i].name,
+                   mapserv->resultlayer->joins[i].items[j]);
+          if (strstr(outstr, substr) != NULL) {
+            encodedstr = msEncodeUrl(mapserv->resultlayer->joins[i].values[j]);
+            outstr = msReplaceSubstring(outstr, substr, encodedstr);
+            free(encodedstr);
+          }
+
+          /* or you might want to access the attributes unaltered */
+          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_raw]",
+                   mapserv->resultlayer->joins[i].name,
+                   mapserv->resultlayer->joins[i].items[j]);
+          if (strstr(outstr, substr) != NULL)
+            outstr = msReplaceSubstring(
+                outstr, substr, mapserv->resultlayer->joins[i].values[j]);
+        }
+      } else if (mapserv->resultlayer->joins[i].type ==
+                 MS_JOIN_ONE_TO_MANY) { /* one-to-many join */
+        char *joinTemplate = NULL;
+
+        snprintf(substr, PROCESSLINE_BUFLEN, "[join_%s]",
+                 mapserv->resultlayer->joins[i].name);
+        if (strstr(outstr, substr) != NULL) {
+          joinTemplate =
+              processOneToManyJoin(mapserv, &(mapserv->resultlayer->joins[i]));
+          if (joinTemplate) {
+            outstr = msReplaceSubstring(outstr, substr, joinTemplate);
+            free(joinTemplate);
+          } else
+            return NULL;
+        }
+      }
+    } /* next join */
+
+  } /* end query mode specific substitutions */
+
+  if (processIncludeTag(mapserv, &outstr, stream, mode) != MS_SUCCESS) {
+    msFree(outstr);
+    return (NULL);
+  }
+
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    /* Replace [variable] tags using values from URL. We cannot offer a
+     * [variable_raw] option here due to the risk of XSS.
+     *
+     * Replacement is case-insensitive. (#4511)
+     */
+    snprintf(substr, PROCESSLINE_BUFLEN, "[%s]",
+             mapserv->request->ParamNames[i]);
+    encodedstr = msEncodeHTMLEntities(mapserv->request->ParamValues[i]);
+    outstr = msCaseReplaceSubstring(outstr, substr, encodedstr);
+    free(encodedstr);
+
+    snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]",
+             mapserv->request->ParamNames[i]);
+    encodedstr = msEncodeUrl(mapserv->request->ParamValues[i]);
+    outstr = msCaseReplaceSubstring(outstr, substr, encodedstr);
+    free(encodedstr);
+  }
+
+  return (outstr);
+}
+
+#define MS_TEMPLATE_BUFFER 1024 /* 1k */
+
+int msReturnPage(mapservObj *mapserv, char *html, int mode,
+                 char **papszBuffer) {
+  FILE *stream;
+  char line[MS_BUFFER_LENGTH], *tmpline;
+  int nBufferSize = 0;
+  int nCurrentSize = 0;
+
+  ms_regex_t re; /* compiled regular expression to be matched */
+  char szPath[MS_MAXPATHLEN];
+
+  if (!html) {
+    msSetError(MS_WEBERR, "No template specified", "msReturnPage()");
+    return MS_FAILURE;
+  }
+
+  if (ms_regcomp(&re, MS_TEMPLATE_EXPR,
+                 MS_REG_EXTENDED | MS_REG_NOSUB | MS_REG_ICASE) != 0) {
+    msSetError(MS_REGEXERR, NULL, "msReturnPage()");
+    return MS_FAILURE;
+  }
+
+  if (ms_regexec(&re, html, 0, NULL, 0) != 0) { /* no match */
+    ms_regfree(&re);
+    msSetError(MS_WEBERR, "Malformed template name (%s).", "msReturnPage()",
+               html);
+    return MS_FAILURE;
+  }
+  ms_regfree(&re);
+
+  if ((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, html), "r")) ==
+      NULL) {
+    msSetError(MS_IOERR, "%s", "msReturnPage()", html);
+    return MS_FAILURE;
+  }
+
+  if (isValidTemplate(stream, html) != MS_TRUE) {
+    fclose(stream);
+    return MS_FAILURE;
+  }
+
+  if (papszBuffer) {
+    if ((*papszBuffer) == NULL) {
+      (*papszBuffer) = (char *)msSmallMalloc(MS_TEMPLATE_BUFFER);
+      (*papszBuffer)[0] = '\0';
+      nBufferSize = MS_TEMPLATE_BUFFER;
+      nCurrentSize = 0;
+    } else {
+      nCurrentSize = strlen((*papszBuffer));
+      nBufferSize = nCurrentSize;
+    }
+  }
+
+  while (fgets(line, MS_BUFFER_LENGTH, stream) !=
+         NULL) { /* now on to the end of the file */
+
+    if (strchr(line, '[') != NULL) {
+      tmpline = processLine(mapserv, line, stream, mode);
+      if (!tmpline) {
+        fclose(stream);
+        return MS_FAILURE;
+      }
+
+      if (papszBuffer) {
+        if (nBufferSize <= (int)(nCurrentSize + strlen(tmpline) + 1)) {
+          const int nExpandBuffer = (strlen(tmpline) / MS_TEMPLATE_BUFFER) + 1;
+          nBufferSize =
+              MS_TEMPLATE_BUFFER * nExpandBuffer + strlen((*papszBuffer));
+          (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer),
+                                                  sizeof(char) * nBufferSize);
+        }
+        strcat((*papszBuffer), tmpline);
+        nCurrentSize += strlen(tmpline);
+      } else
+        msIO_fwrite(tmpline, strlen(tmpline), 1, stdout);
+
+      free(tmpline);
+    } else {
+      if (papszBuffer) {
+        if (nBufferSize <= (int)(nCurrentSize + strlen(line))) {
+          const int nExpandBuffer = (strlen(line) / MS_TEMPLATE_BUFFER) + 1;
+          nBufferSize =
+              MS_TEMPLATE_BUFFER * nExpandBuffer + strlen((*papszBuffer));
+          (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer),
+                                                  sizeof(char) * nBufferSize);
+        }
+        strcat((*papszBuffer), line);
+        nCurrentSize += strlen(line);
+      } else
+        msIO_fwrite(line, strlen(line), 1, stdout);
+    }
+    if (!papszBuffer)
+      fflush(stdout);
+  } /* next line */
+
+  fclose(stream);
+
+  return MS_SUCCESS;
+}
+
+int msReturnURL(mapservObj *ms, const char *url, int mode) {
+  char *tmpurl;
+
+  if (url == NULL) {
+    msSetError(MS_WEBERR, "Empty URL.", "msReturnURL()");
+    return MS_FAILURE;
+  }
+
+  tmpurl =
+      processLine(ms, url, NULL, mode); /* URL templates can't handle multi-line
+                                           tags, hence the NULL file pointer */
+
+  if (!tmpurl)
+    return MS_FAILURE;
+
+  msRedirect(tmpurl);
+  free(tmpurl);
+
+  return MS_SUCCESS;
+}
+
+/*
+** Legacy query template parsing where you use headers, footers and such...
+*/
+int msReturnNestedTemplateQuery(mapservObj *mapserv, char *pszMimeType,
+                                char **papszBuffer) {
+  int status;
+  int i, j, k;
+  char buffer[1024];
+  int nBufferSize = 0;
+  int nCurrentSize = 0;
+  int nExpandBuffer = 0;
+
+  char *template;
+
+  layerObj *lp = NULL;
+
+  if (papszBuffer) {
+    (*papszBuffer) = (char *)msSmallMalloc(MS_TEMPLATE_BUFFER);
+    (*papszBuffer)[0] = '\0';
+    nBufferSize = MS_TEMPLATE_BUFFER;
+    nCurrentSize = 0;
+    nExpandBuffer = 1;
+  }
+
+  msInitShape(&(mapserv->resultshape));
+
+  if ((mapserv->Mode == ITEMQUERY) ||
+      (mapserv->Mode == QUERY)) { /* may need to handle a URL result set since
+                                     these modes return exactly 1 result */
+
+    for (i = (mapserv->map->numlayers - 1); i >= 0; i--) {
+      lp = (GET_LAYER(mapserv->map, i));
+
+      if (!lp->resultcache)
+        continue;
+      if (lp->resultcache->numresults > 0)
+        break;
+    }
+
+    if (i >= 0) { /* at least if no result found, mapserver will display an
+                     empty template. */
+
+      if (lp->resultcache->results[0].classindex >= 0 &&
+              lp->class[(int)(lp->resultcache->results[0].classindex)]
+          -> template)
+        template =
+            lp->class[(int)(lp->resultcache->results[0].classindex)]->template;
+      else
+        template = lp->template;
+
+      if (template == NULL) {
+        msSetError(MS_WEBERR, "No template for layer %s or it's classes.",
+                   "msReturnNestedTemplateQuery()", lp->name);
+        return MS_FAILURE;
+      }
+
+      if (TEMPLATE_TYPE(template) == MS_URL) {
+        mapserv->resultlayer = lp;
+
+#if 0
+        status = msLayerOpen(lp);
+        if(status != MS_SUCCESS) return status;
+
+        status = msLayerGetItems(lp); /* retrieve all the item names */
+        if(status != MS_SUCCESS) return status;
+#endif
+
+        status = msLayerGetShape(lp, &(mapserv->resultshape),
+                                 &(lp->resultcache->results[0]));
+        if (status != MS_SUCCESS)
+          return status;
+
+        if (lp->numjoins > 0) {
+          for (k = 0; k < lp->numjoins; k++) {
+            status = msJoinConnect(lp, &(lp->joins[k]));
+            if (status != MS_SUCCESS)
+              return status;
+
+            msJoinPrepare(&(lp->joins[k]), &(mapserv->resultshape));
+            msJoinNext(&(lp->joins[k])); /* fetch the first row */
+          }
+        }
+
+        if (papszBuffer == NULL) {
+          if (msReturnURL(mapserv, template, QUERY) != MS_SUCCESS)
+            return MS_FAILURE;
+        }
+
+        msFreeShape(&(mapserv->resultshape));
+        /* msLayerClose(lp); */
+        mapserv->resultlayer = NULL;
+
+        return MS_SUCCESS;
+      }
+    }
+  }
+
+  /*
+  ** Now we know we're making a template sandwich
+  */
+  mapserv->NR = mapserv->NL = 0;
+  for (i = 0; i < mapserv->map->numlayers; i++) { /* compute some totals */
+    lp = (GET_LAYER(mapserv->map, i));
+
+    if (!lp->resultcache)
+      continue;
+
+    if (lp->resultcache->numresults > 0) {
+      mapserv->NL++;
+      mapserv->NR += lp->resultcache->numresults;
+    }
+  }
+
+  /*
+  ** Is this step really necessary for buffered output? Legend and browse
+  *templates don't deal with mime-types
+  ** so why should this. Note that new-style templates don't buffer the
+  *mime-type either.
+  */
+  if (papszBuffer && mapserv->sendheaders) {
+    snprintf(buffer, sizeof(buffer), "Content-Type: %s%c%c", pszMimeType, 10,
+             10);
+    if (nBufferSize <= (int)(nCurrentSize + strlen(buffer) + 1)) {
+      nExpandBuffer++;
+      (*papszBuffer) = (char *)msSmallRealloc(
+          (*papszBuffer), MS_TEMPLATE_BUFFER * nExpandBuffer);
+      nBufferSize = MS_TEMPLATE_BUFFER * nExpandBuffer;
+    }
+    strcat((*papszBuffer), buffer);
+    nCurrentSize += strlen(buffer);
+  } else if (mapserv->sendheaders) {
+    msIO_setHeader("Content-Type", "%s", pszMimeType);
+    msIO_sendHeaders();
+  }
+
+  if (mapserv->map->web.header) {
+    if (msReturnPage(mapserv, mapserv->map->web.header, BROWSE, papszBuffer) !=
+        MS_SUCCESS)
+      return MS_FAILURE;
+  }
+
+  mapserv->RN = 1; /* overall result number */
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    mapserv->resultlayer = lp =
+        (GET_LAYER(mapserv->map, mapserv->map->layerorder[i]));
+
+    if (!lp->resultcache)
+      continue;
+    if (lp->resultcache->numresults <= 0)
+      continue;
+
+    mapserv->NLR = lp->resultcache->numresults;
+
+#if 0
+    status = msLayerOpen(lp); /* open this layer */
+    if(status != MS_SUCCESS) return status;
+
+    status = msLayerGetItems(lp); /* retrieve all the item names */
+    if(status != MS_SUCCESS) return status;
+#endif
+
+    if (lp->numjoins > 0) { /* open any necessary JOINs here */
+      for (k = 0; k < lp->numjoins; k++) {
+        status = msJoinConnect(lp, &(lp->joins[k]));
+        if (status != MS_SUCCESS)
+          return status;
+      }
+    }
+
+    if (lp->header) {
+      if (msReturnPage(mapserv, lp->header, BROWSE, papszBuffer) != MS_SUCCESS)
+        return MS_FAILURE;
+    }
+
+    mapserv->LRN = 1; /* layer result number */
+    for (j = 0; j < lp->resultcache->numresults; j++) {
+      status = msLayerGetShape(lp, &(mapserv->resultshape),
+                               &(lp->resultcache->results[j]));
+      if (status != MS_SUCCESS)
+        return status;
+
+      /* prepare any necessary JOINs here (one-to-one only) */
+      if (lp->numjoins > 0) {
+        for (k = 0; k < lp->numjoins; k++) {
+          if (lp->joins[k].type == MS_JOIN_ONE_TO_ONE) {
+            msJoinPrepare(&(lp->joins[k]), &(mapserv->resultshape));
+            msJoinNext(&(lp->joins[k])); /* fetch the first row */
+          }
+        }
+      }
+
+      if (lp->resultcache->results[j].classindex >= 0 &&
+              lp->class[(int)(lp->resultcache->results[j].classindex)]
+          -> template)
+        template =
+            lp->class[(int)(lp->resultcache->results[j].classindex)]->template;
+      else
+        template = lp->template;
+
+      if (msReturnPage(mapserv, template, QUERY, papszBuffer) != MS_SUCCESS) {
+        msFreeShape(&(mapserv->resultshape));
+        return MS_FAILURE;
+      }
+
+      msFreeShape(&(mapserv->resultshape)); /* init too */
+
+      mapserv->RN++; /* increment counters */
+      mapserv->LRN++;
+    }
+
+    if (lp->footer) {
+      if (msReturnPage(mapserv, lp->footer, BROWSE, papszBuffer) != MS_SUCCESS)
+        return MS_FAILURE;
+    }
+
+    /* msLayerClose(lp); */
+    mapserv->resultlayer = NULL;
+  }
+
+  if (mapserv->map->web.footer)
+    return msReturnPage(mapserv, mapserv->map->web.footer, BROWSE, papszBuffer);
+
+  return MS_SUCCESS;
+}
+
+int msReturnOpenLayersPage(mapservObj *mapserv) {
+  int i;
+  char *buffer = NULL, *layer = NULL;
+  const char *tmpUrl = NULL;
+  const char *openlayersUrl = olUrl;
+  char *projection = NULL;
+  char *format = NULL;
+
+  /* 2 CGI parameters are used in the template. we need to transform them
+   * to be sure the case match during the template processing. We also
+   * need to search the SRS/CRS parameter to get the projection info. OGC
+   * services version >= 1.3.0 uses CRS rather than SRS */
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    if ((strcasecmp(mapserv->request->ParamNames[i], "SRS") == 0) ||
+        (strcasecmp(mapserv->request->ParamNames[i], "CRS") == 0)) {
+      projection = mapserv->request->ParamValues[i];
+    } else if (strcasecmp(mapserv->request->ParamNames[i], "LAYERS") == 0) {
+      free(mapserv->request->ParamNames[i]);
+      mapserv->request->ParamNames[i] = msStrdup("LAYERS");
+    } else if (strcasecmp(mapserv->request->ParamNames[i], "VERSION") == 0) {
+      free(mapserv->request->ParamNames[i]);
+      mapserv->request->ParamNames[i] = msStrdup("VERSION");
+    }
+  }
+  if (mapserv->map->outputformat->mimetype &&
+      *mapserv->map->outputformat->mimetype) {
+    format = mapserv->map->outputformat->mimetype;
+  }
+
+  /* check if the environment variable or config MS_OPENLAYERS_JS_URL is set */
+  tmpUrl = msGetConfigOption(mapserv->map, "MS_OPENLAYERS_JS_URL");
+  if (tmpUrl == NULL)
+    tmpUrl = CPLGetConfigOption("MS_OPENLAYERS_JS_URL", NULL);
+
+  if (tmpUrl)
+    openlayersUrl = (char *)tmpUrl;
+
+  if (mapserv->Mode == BROWSE) {
+    msSetError(MS_WMSERR, "At least one layer name required in LAYERS.",
+               "msWMSLoadGetMapParams()");
+    layer = processLine(mapserv, olLayerMapServerTag, NULL, BROWSE);
+  } else
+    layer = processLine(mapserv, olLayerWMSTag, NULL, BROWSE);
+
+  buffer = processLine(mapserv, olTemplate, NULL, BROWSE);
+  buffer = msReplaceSubstring(buffer, "[openlayers_js_url]", openlayersUrl);
+  buffer = msReplaceSubstring(buffer, "[openlayers_layer]", layer);
+  if (projection)
+    buffer = msReplaceSubstring(buffer, "[openlayers_projection]", projection);
+  if (format)
+    buffer = msReplaceSubstring(buffer, "[openlayers_format]", format);
+  else
+    buffer = msReplaceSubstring(buffer, "[openlayers_format]", "image/jpeg");
+  msIO_fwrite(buffer, strlen(buffer), 1, stdout);
+  free(layer);
+  free(buffer);
+
+  return MS_SUCCESS;
+}
+
+mapservObj *msAllocMapServObj() {
+  mapservObj *mapserv = msSmallMalloc(sizeof(mapservObj));
+
+  mapserv->savemap = MS_FALSE;
+  mapserv->savequery = MS_FALSE; /* should the query and/or map be saved  */
+
+  mapserv->sendheaders = MS_TRUE;
+
+  mapserv->request = msAllocCgiObj();
+
+  mapserv->map = NULL;
+
+  mapserv->NumLayers = 0; /* number of layers specified by a user */
+  mapserv->MaxLayers = 0; /* allocated size of Layers[] array */
+  mapserv->Layers = NULL;
+
+  mapserv->icon = NULL;
+
+  mapserv->RawExt.minx = -1;
+  mapserv->RawExt.miny = -1;
+  mapserv->RawExt.maxx = -1;
+  mapserv->RawExt.maxy = -1;
+
+  mapserv->fZoom = 1;
+  mapserv->Zoom = 1; /* default for browsing */
+
+  mapserv->resultlayer = NULL;
+
+  mapserv->UseShapes = MS_FALSE;
+
+  mapserv->mappnt.x = -1;
+  mapserv->mappnt.y = -1;
+
+  mapserv->ZoomDirection =
+      0; /* whether zooming in or out, default is pan or 0 */
+
+  mapserv->Mode = BROWSE; /* can be BROWSE, QUERY, etc. */
+
+  sprintf(mapserv->Id, "%ld%d", (long)time(NULL), (int)getpid());
+
+  mapserv->CoordSource = NONE;
+  mapserv->ScaleDenom = 0;
+
+  mapserv->ImgRows = -1;
+  mapserv->ImgCols = -1;
+
+  mapserv->ImgExt.minx = -1;
+  mapserv->ImgExt.miny = -1;
+  mapserv->ImgExt.maxx = -1;
+  mapserv->ImgExt.maxy = -1;
+
+  mapserv->ImgBox.minx = -1;
+  mapserv->ImgBox.miny = -1;
+  mapserv->ImgBox.maxx = -1;
+  mapserv->ImgBox.maxy = -1;
+
+  mapserv->RefPnt.x = -1;
+  mapserv->RefPnt.y = -1;
+  mapserv->ImgPnt.x = -1;
+  mapserv->ImgPnt.y = -1;
+
+  mapserv->Buffer = 0;
+
+  /*
+  ** variables for multiple query results processing
+  */
+  mapserv->RN = 0;  /* overall result number */
+  mapserv->LRN = 0; /* result number within a layer */
+  mapserv->NL = 0;  /* total number of layers with results */
+  mapserv->NR = 0;  /* total number or results */
+  mapserv->NLR = 0; /* number of results in a layer */
+
+  mapserv->SearchMap =
+      MS_FALSE; /* apply pan/zoom BEFORE doing the query (e.g. query the output
+                   image rather than the input image) */
+
+  mapserv->QueryFile = NULL;
+  mapserv->QueryLayer = NULL;
+  mapserv->SelectLayer = NULL;
+  mapserv->QueryLayerIndex = -1;
+  mapserv->SelectLayerIndex = -1;
+  mapserv->QueryItem = NULL;
+  mapserv->QueryString = NULL;
+  mapserv->ShapeIndex = -1;
+  mapserv->TileIndex = -1;
+  mapserv->TileMode = TILE_GMAP;
+  mapserv->TileCoords = NULL;
+  mapserv->TileWidth = -1;
+  mapserv->TileHeight = -1;
+  mapserv->QueryCoordSource = NONE;
+  mapserv->ZoomSize = 0; /* zoom absolute magnitude (i.e. > 0) */
+
+  mapserv->hittest = NULL;
+
+  return mapserv;
+}
+
+void msFreeMapServObj(mapservObj *mapserv) {
+  int i;
+
+  if (mapserv) {
+    if (mapserv->map) {
+      if (mapserv->hittest) {
+        freeMapHitTests(mapserv->map, mapserv->hittest);
+        free(mapserv->hittest);
+      }
+      msFreeMap(mapserv->map);
+      mapserv->map = NULL;
+    }
+
+    if (mapserv->request) {
+      msFreeCgiObj(mapserv->request);
+      mapserv->request = NULL;
+    }
+
+    for (i = 0; i < mapserv->NumLayers; i++)
+      msFree(mapserv->Layers[i]);
+    msFree(mapserv->Layers);
+
+    msFree(mapserv->icon);
+
+    msFree(mapserv->QueryItem);
+    msFree(mapserv->QueryString);
+    msFree(mapserv->QueryLayer);
+    msFree(mapserv->SelectLayer);
+    msFree(mapserv->QueryFile);
+
+    msFree(mapserv->TileCoords);
+
+    msFree(mapserv);
+  }
+}
+
+/*
+** Ensure there is at least one free entry in the Layers array.
+**
+** This function is safe to use for the initial allocation of the Layers[]
+** array as well (i.e. when MaxLayers==0 and Layers==NULL)
+**
+** Returns MS_SUCCESS/MS_FAILURE
+*/
+int msGrowMapservLayers(mapservObj *mapserv) {
+  /* Do we need to increase the size of Layers[] by MS_LAYER_ALLOCSIZE? */
+  if (mapserv->NumLayers == mapserv->MaxLayers) {
+    int i;
+
+    if (mapserv->MaxLayers == 0) {
+      /* initial allocation of array */
+      mapserv->MaxLayers += MS_LAYER_ALLOCSIZE;
+      mapserv->NumLayers = 0;
+      mapserv->Layers =
+          (char **)msSmallMalloc(mapserv->MaxLayers * sizeof(char *));
+    } else {
+      /* realloc existing array */
+      mapserv->MaxLayers += MS_LAYER_ALLOCSIZE;
+      mapserv->Layers = (char **)msSmallRealloc(
+          mapserv->Layers, mapserv->MaxLayers * sizeof(char *));
+    }
+
+    if (mapserv->Layers == NULL) {
+      msSetError(MS_MEMERR, "Failed to allocate memory for Layers array.",
+                 "msGrowMappservLayers()");
+      return MS_FAILURE;
+    }
+
+    for (i = mapserv->NumLayers; i < mapserv->MaxLayers; i++) {
+      mapserv->Layers[i] = NULL;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Utility function to generate map, legend, scalebar and reference images.
+**
+** Parameters:
+**   - mapserv: mapserv object (used to extract the map object).
+**   - bQueryMap: if set to TRUE a query map will be created instead of a
+*regular map.
+**   - bReturnOnError: if set to TRUE, the function will return on the first
+*error, else it will try to generate all the images.
+*/
+int msGenerateImages(mapservObj *mapserv, int bQueryMap, int bReturnOnError) {
+  char buffer[1024];
+
+  if (mapserv) {
+
+    /* render the map OR query map */
+    if ((!bQueryMap && mapserv->map->status == MS_ON) ||
+        (bQueryMap && mapserv->map->querymap.status == MS_ON)) {
+      imageObj *image = NULL;
+
+      image = msDrawMap(mapserv->map, bQueryMap);
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%s%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
+          msFreeImage(image);
+          return MS_FAILURE;
+        }
+        msFreeImage(image);
+      } else if (bReturnOnError)
+        return MS_FAILURE;
+    }
+
+    /* render the legend */
+    if (mapserv->map->legend.status == MS_ON) {
+      imageObj *image = NULL;
+      image = msDrawLegend(mapserv->map, MS_FALSE, NULL);
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%sleg%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
+          msFreeImage(image);
+          return MS_FAILURE;
+        }
+        msFreeImage(image);
+      } else if (bReturnOnError)
+        return MS_FAILURE;
+    }
+
+    /* render the scalebar */
+    if (mapserv->map->scalebar.status == MS_ON) {
+      imageObj *image = NULL;
+      image = msDrawScalebar(mapserv->map);
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%ssb%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
+          msFreeImage(image);
+          return MS_FAILURE;
+        }
+        msFreeImage(image);
+      } else if (bReturnOnError)
+        return MS_FAILURE;
+    }
+
+    /* render the reference map */
+    if (mapserv->map->reference.status == MS_ON) {
+      imageObj *image;
+      image = msDrawReferenceMap(mapserv->map);
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%sref%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
+          msFreeImage(image);
+          return MS_FAILURE;
+        }
+        msFreeImage(image);
+      } else if (bReturnOnError)
+        return MS_FAILURE;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Utility function to open a template file, process it and
+** and return into a buffer the processed template. Uses the
+** template file from the web object. Returns NULL if there is
+** an error.
+*/
+char *msProcessTemplate(mapObj *map, int bGenerateImages, char **names,
+                        char **values, int numentries) {
+  char *pszBuffer = NULL;
+
+  if (map) {
+
+    /* Initialize object and set appropriate defaults. */
+    mapservObj *mapserv = NULL;
+    mapserv = msAllocMapServObj();
+
+    mapserv->map = map;
+    mapserv->Mode = BROWSE;
+
+    if (names && values && numentries > 0) {
+      msFreeCharArray(mapserv->request->ParamNames,
+                      mapserv->request->NumParams);
+      msFreeCharArray(mapserv->request->ParamValues,
+                      mapserv->request->NumParams);
+      mapserv->request->ParamNames = names;
+      mapserv->request->ParamValues = values;
+      mapserv->request->NumParams = numentries;
+    }
+
+    /*
+    ** ISSUE/TODO : some of the name/values should be extracted and
+    ** processed (ex imgext, layers, ...) as it is done in function
+    ** loadform.
+    */
+
+    if (bGenerateImages)
+      msGenerateImages(mapserv, MS_FALSE, MS_FALSE);
+
+    /*
+    ** Process the template.
+    **
+    ** TODO : use web minscaledenom/maxscaledenom depending on the scale.
+    */
+    if (msReturnPage(mapserv, mapserv->map->web.template, BROWSE, &pszBuffer) !=
+        MS_SUCCESS) {
+      msFree(pszBuffer);
+      pszBuffer = NULL;
+    }
+
+    /* Don't free the map and names and values arrays since they were passed by
+     * reference. */
+    mapserv->map = NULL;
+    mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
+    mapserv->request->NumParams = 0;
+    msFreeMapServObj(mapserv);
+  }
+
+  return pszBuffer;
+}
+
+/*
+** Utility method to process the legend template.
+*/
+char *msProcessLegendTemplate(mapObj *map, char **names, char **values,
+                              int numentries) {
+  char *pszOutBuf = NULL;
+
+  if (map && map->legend.template) {
+
+    /* Initialize object and set appropriate defaults. */
+    mapservObj *mapserv = NULL;
+    mapserv = msAllocMapServObj();
+
+    mapserv->map = map;
+    mapserv->Mode = BROWSE;
+
+    if (names && values && numentries > 0) {
+      msFreeCharArray(mapserv->request->ParamNames,
+                      mapserv->request->NumParams);
+      msFreeCharArray(mapserv->request->ParamValues,
+                      mapserv->request->NumParams);
+      mapserv->request->ParamNames = names;
+      mapserv->request->ParamValues = values;
+      mapserv->request->NumParams = numentries;
+    }
+
+    pszOutBuf = generateLegendTemplate(mapserv);
+
+    /* Don't free the map and names and values arrays since they were passed by
+     * reference. */
+    mapserv->map = NULL;
+    mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
+    mapserv->request->NumParams = 0;
+    msFreeMapServObj(mapserv);
+  }
+
+  return pszOutBuf;
+}
+
+/*
+** Utility function that process a template file(s) used in the
+** query and return the processed template(s) in a buffer.
+*/
+char *msProcessQueryTemplate(mapObj *map, int bGenerateImages, char **names,
+                             char **values, int numentries) {
+  char *pszBuffer = NULL;
+
+  if (map) {
+
+    /* Initialize object and set appropriate defaults. */
+    mapservObj *mapserv = NULL;
+    mapserv = msAllocMapServObj();
+
+    mapserv->map = map;
+    mapserv->Mode = QUERY;
+
+    if (names && values && numentries > 0) {
+      msFreeCharArray(mapserv->request->ParamNames,
+                      mapserv->request->NumParams);
+      msFreeCharArray(mapserv->request->ParamValues,
+                      mapserv->request->NumParams);
+      mapserv->request->ParamNames = names;
+      mapserv->request->ParamValues = values;
+      mapserv->request->NumParams = numentries;
+    }
+
+    if (bGenerateImages)
+      msGenerateImages(mapserv, MS_TRUE, MS_FALSE);
+
+    mapserv->sendheaders = MS_FALSE;
+    IGNORE_RET_VAL(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat,
+                                         &pszBuffer));
+
+    mapserv->map = NULL;
+    mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
+    mapserv->request->NumParams = 0;
+    msFreeMapServObj(mapserv);
+  }
+
+  return pszBuffer;
+}
diff -pruN 8.0.1-5/src/maptemplate.h 8.2.0~beta1-1~exp1/src/maptemplate.h
--- 8.0.1-5/src/maptemplate.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptemplate.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,233 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Template processing related declarations.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPTEMPLATE_H
+#define MAPTEMPLATE_H
+
+#include "mapserver.h"
+#include "maphash.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define IDPATTERN "^[0-9A-Za-z]{1,63}$"
+#define IDSIZE 64
+#define TEMPLATE_TYPE(s)                                                       \
+  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) ||     \
+    (strncmp("ftp://", s, 6)) == 0)                                            \
+       ? MS_URL                                                                \
+       : MS_FILE)
+#define MAXZOOM 25
+#define MINZOOM -25
+#define DEFAULT_DATE_FORMAT "%d/%b/%Y:%H:%M:%S %z"
+
+enum coordSources {
+  NONE,
+  FROMIMGPNT,
+  FROMIMGBOX,
+  FROMIMGSHAPE,
+  FROMREFPNT,
+  FROMUSERPNT,
+  FROMUSERBOX,
+  FROMUSERSHAPE,
+  FROMBUF,
+  FROMSCALE,
+  FROMTILE
+};
+
+enum modes {
+  BROWSE,
+  ZOOMIN,
+  ZOOMOUT,
+  MAP,
+  LEGEND,
+  LEGENDICON,
+  REFERENCE,
+  SCALEBAR,
+  COORDINATE,
+  QUERY,
+  NQUERY,
+  ITEMQUERY,
+  ITEMNQUERY,
+  FEATUREQUERY,
+  FEATURENQUERY,
+  ITEMFEATUREQUERY,
+  ITEMFEATURENQUERY,
+  INDEXQUERY,
+  TILE,
+  OWS,
+  WFS,
+  MAPLEGEND,
+  MAPLEGENDICON
+};
+
+/* struct mapservObj
+ * Global structure used by templates and mapserver CGI interface.
+ *
+ * This structur was created to seperate template functionality
+ * from the main mapserv file. Instead of moving all template
+ * related functions in a new file (maptemplate.c) and change
+ * their signatures to pass all global variables, we created this
+ * structure with all global variables needed by template.
+ */
+typedef struct {
+  /* should the query and/or map be saved */
+  int savemap, savequery;
+
+  cgiRequestObj *request;
+
+  int sendheaders; /* should mime-type header be output, default will be MS_TRUE
+                    */
+
+  mapObj *map;
+
+  char **Layers;
+  char *icon; /* layer:class combination that defines a legend icon */
+
+  int NumLayers; /* number of layers specfied by a use */
+  int MaxLayers; /* Allocated size of Layers[] array */
+
+  layerObj *resultlayer;
+
+  int UseShapes; /* are results of a query to be used in calculating an extent
+                    of some sort */
+
+  shapeObj resultshape;
+
+  rectObj RawExt;
+
+  pointObj mappnt;
+
+  double fZoom, Zoom;
+  int ZoomDirection; /* whether zooming in or out, default is pan or 0 */
+
+  int Mode; /* can be BROWSE, QUERY, etc. */
+
+  int TileMode;     /* can be GMAP, VE */
+  char *TileCoords; /* for GMAP: 0 0 1; for VE: 013021023 */
+  int TileWidth;
+  int TileHeight;
+
+  char Id[IDSIZE]; /* big enough for time + pid */
+
+  int CoordSource;
+  double ScaleDenom; /* used to create a map extent around a point */
+
+  int ImgRows, ImgCols;
+  rectObj ImgExt; /* Existing image's mapextent */
+  rectObj ImgBox;
+
+  pointObj RefPnt;
+  pointObj ImgPnt;
+
+  double Buffer;
+
+  int SearchMap; /* apply pan/zoom BEFORE doing the query (e.g. query the output
+                    image rather than the input image) */
+
+  char *QueryFile;
+  char *QueryLayer;
+  char *SelectLayer;
+  int QueryLayerIndex;
+  int SelectLayerIndex;
+
+  char *QueryItem;
+  char *QueryString;
+
+  int ShapeIndex;
+  int TileIndex;
+
+  int QueryCoordSource;
+
+  int ZoomSize; /* zoom absolute magnitude (i.e. > 0) */
+
+  /*
+  ** variables for multiple query results processing
+  */
+  int RN;  /* overall result number */
+  int LRN; /* result number within a layer */
+  int NL;  /* total number of layers with results */
+  int NR;  /* total number or results */
+  int NLR; /* number of results in a layer */
+
+  map_hittest *hittest;
+
+} mapservObj;
+
+/*! \fn msAllocMapServObj
+ * Allocate memory for all variables in strusture
+ * and initiate default values
+ */
+MS_DLL_EXPORT mapservObj *msAllocMapServObj(void);
+
+/*! \fn msFreeMapServObj
+ * free all variables in structure
+ */
+MS_DLL_EXPORT void msFreeMapServObj(mapservObj *msObj);
+
+/* For Mapserv.c */
+MS_DLL_EXPORT int isOn(mapservObj *msObj, char *name, char *group);
+MS_DLL_EXPORT int checkWebScale(mapservObj *msObj);
+MS_DLL_EXPORT int setExtent(mapservObj *msObj);
+
+MS_DLL_EXPORT int msReturnPage(mapservObj *msObj, char *, int, char **);
+MS_DLL_EXPORT int msReturnURL(mapservObj *msObj, const char *, int);
+MS_DLL_EXPORT int msReturnNestedTemplateQuery(mapservObj *msObj,
+                                              char *pszMimeType,
+                                              char **papszBuffer);
+MS_DLL_EXPORT int msReturnTemplateQuery(mapservObj *msObj, char *pszMimeType,
+                                        char **papszBuffer);
+MS_DLL_EXPORT int msReturnOpenLayersPage(mapservObj *mapserv);
+
+MS_DLL_EXPORT int msRedirect(const char *url);
+
+MS_DLL_EXPORT char *generateLegendTemplate(mapservObj *msObj);
+
+MS_DLL_EXPORT int msGenerateImages(mapservObj *msObj, int bQueryMap,
+                                   int bReturnOnError);
+
+MS_DLL_EXPORT char *msProcessTemplate(mapObj *map, int bGenerateImages,
+                                      char **names, char **values,
+                                      int numentries);
+
+MS_DLL_EXPORT char *msProcessLegendTemplate(mapObj *map, char **names,
+                                            char **values, int numentries);
+
+MS_DLL_EXPORT char *msProcessQueryTemplate(mapObj *map, int bGenerateImages,
+                                           char **names, char **values,
+                                           int numentries);
+
+MS_DLL_EXPORT int msGrowMapservLayers(mapservObj *msObj);
+
+#ifdef __cplusplus
+} /* extern C */
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/mapthread.c 8.2.0~beta1-1~exp1/src/mapthread.c
--- 8.0.1-5/src/mapthread.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapthread.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,316 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  UMN MapServer
+ * Purpose:  Support code for abstracting thread issues.
+ * Author:   Frank Warmerdam, warmerdam@pobox.com
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+/******************************************************************************
+
+            THREAD-SAFE SUPPORT IN MAPSERVER
+            ================================
+
+If thread safety is enabled the USE_THREAD macro will be defined.
+
+Thread API (mapthread.h/c)
+--------------------------
+
+This API is made available to avoid having dependencies on different
+thread libraries in lots of places in MapServer.  It is intended to provide
+minimal services required by mapserver and isn't intended to be broadly useful.
+It should be available for Win32 and pthreads environments.  It should be
+possible to implement for other thread libraries if needed.
+
+  int msGetThreadId():
+    Returns the current threads integer id.  This can be used for making
+        some information thread specific, as has been done for the global
+        error context in maperror.c.
+
+  void msAcquireLock(int):
+        Acquires the indicated Mutex.  If it is already held by another thread
+        then this thread will block till the other thread releases it.  If
+        this thread already holds the mutex then behaviour is undefined.  If
+        the mutex id is not valid (not in the range 0 to TLOCK_STATIC_MAX)
+        then results are undefined.
+
+  void msReleaseLock(int):
+        Releases the indicated mutex.  If the lock id is invalid, or if the
+        mutex is not currently held by this thread then results are undefined.
+
+It is incredibly important to ensure that any mutex that is acquired is
+released as soon as possible.  Any flow of control that could result in a
+mutex not being release is going to be a disaster.
+
+The mutex numbers are defined in mapthread.h with the TLOCK_* codes.  If you
+need a new mutex, add a #define in mapthread.h for it.  Currently there is
+no "dynamic" mutex allocation, but this could be added.
+
+
+Making Things Thread-safe
+-------------------------
+
+Generally, to make MapServer thread-safe it is necessary to ensure that
+different threads aren't read and updating common datastructures at the same
+time and that all appropriate state be kept thread specific.
+
+Generally this will mean:
+  o The previously global error status (errorObj ms_error) is now thread
+    specific.  Use msGetErrorObj() to get the current threads error state.
+
+  o Use of subcomponents that are not thread safe need to be protected by
+    a Mutex (lock).
+
+Currently a mutex is used for the entire map file parsing operation
+(msLoadMap() in mapfile.c) since the yacc parser uses a number of global
+variables.
+
+It is also done with pj_init() from PROJ.4 since this does not appear to be
+thread safe.  It isn't yet clear if pj_transform() is thread safe.
+
+It is expected that mutexes will need to be employed in a variety of other
+places to ensure serialized access to risky functionality.  This may apply
+to sublibraries like GDAL for instance.
+
+If a new section that is not thread-safe is identified (and assuming it
+can't be internally modified to make it thread-safe easily), it is necessary
+to define a new mutex (#define a TLOCK code in mapthread.h), and then
+surround the resource with acquire and release lock calls.
+
+eg.
+    msAcquireLock( TLOCK_PROJ );
+    if( !(p->proj = pj_init(p->numargs, p->args)) ) {
+        msReleaseLock( TLOCK_PROJ );
+        msSetError(MS_PROJERR, pj_strerrno(pj_errno),
+                   "msProcessProjection()");
+        return(-1);
+    }
+
+    msReleaseLock( TLOCK_PROJ );
+
+It is imperative that any acquired locks be released on all possible
+control paths or else the MapServer will lock up as other thread try to
+acquire the lock and block forever.
+
+
+Other Thread-safe Issues
+------------------------
+
+Some issues are not easily corrected with Mutexes or other similar
+mechanisms.  The following restrictions currently apply to MapServer when
+trying to use it in thread-safe mode.  Note that failure to adhere to these
+constraints will not usually generate nice error messages, instead operation
+will just fail sometimes.
+
+1) It is currently assumed that a mapObj belongs only to one thread at a time.
+That is, there is no effort to syncronize access to a mapObj itself.
+
+2) Stuff that results in a chdir() call are problematic.  In particular, the
+.map file SHAPEPATH directive should not be used.  Use full paths to data
+files instead.
+
+******************************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "mapthread.h"
+
+#if defined(USE_THREAD)
+static int thread_debug = 0;
+
+static char *const lock_names[] = {
+    NULL,           "PARSER",    "GDAL",    "ERROROBJ", "PROJ",
+    "TTF",          "POOL",      "SDE",     "ORACLE",   "OWS",
+    "LAYER_VTABLE", "IOCONTEXT", "TMPFILE", "DEBUGOBJ", "OGR",
+    "TIME",         "FRIBIDI",   "WXS",     "GEOS",     NULL};
+#endif
+
+/************************************************************************/
+/* ==================================================================== */
+/*                               PTHREADS                               */
+/* ==================================================================== */
+/************************************************************************/
+
+#if defined(USE_THREAD) && !defined(_WIN32)
+
+#include "pthread.h"
+
+static int mutexes_initialized = 0;
+static pthread_mutex_t mutex_locks[TLOCK_MAX];
+
+/************************************************************************/
+/*                            msThreadInit()                            */
+/************************************************************************/
+
+void msThreadInit()
+
+{
+  static pthread_mutex_t core_lock = PTHREAD_MUTEX_INITIALIZER;
+
+  if (thread_debug)
+    fprintf(stderr, "msThreadInit() (posix)\n");
+
+  pthread_mutex_lock(&core_lock);
+
+  for (; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++)
+    pthread_mutex_init(mutex_locks + mutexes_initialized, NULL);
+
+  pthread_mutex_unlock(&core_lock);
+}
+
+/************************************************************************/
+/*                           msGetThreadId()                            */
+/************************************************************************/
+
+void *msGetThreadId()
+
+{
+  return (void *)pthread_self();
+}
+
+/************************************************************************/
+/*                           msAcquireLock()                            */
+/************************************************************************/
+
+void msAcquireLock(int nLockId)
+
+{
+  if (mutexes_initialized == 0)
+    msThreadInit();
+
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
+
+  if (thread_debug)
+    fprintf(stderr, "msAcquireLock(%d/%s) (posix)\n", nLockId,
+            lock_names[nLockId]);
+
+  pthread_mutex_lock(mutex_locks + nLockId);
+}
+
+/************************************************************************/
+/*                           msReleaseLock()                            */
+/************************************************************************/
+
+void msReleaseLock(int nLockId)
+
+{
+  assert(mutexes_initialized > 0);
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
+
+  if (thread_debug)
+    fprintf(stderr, "msReleaseLock(%d/%s) (posix)\n", nLockId,
+            lock_names[nLockId]);
+
+  pthread_mutex_unlock(mutex_locks + nLockId);
+}
+
+#endif /* defined(USE_THREAD) && !defined(_WIN32) */
+
+/************************************************************************/
+/* ==================================================================== */
+/*                          WIN32 THREADS                               */
+/* ==================================================================== */
+/************************************************************************/
+
+#if defined(USE_THREAD) && defined(_WIN32)
+
+#include <windows.h>
+
+static int mutexes_initialized = 0;
+static HANDLE mutex_locks[TLOCK_MAX];
+
+/************************************************************************/
+/*                            msThreadInit()                            */
+/************************************************************************/
+
+void msThreadInit()
+
+{
+  /* static pthread_mutex_t core_lock = PTHREAD_MUTEX_INITIALIZER; */
+  static HANDLE core_lock = NULL;
+
+  if (mutexes_initialized >= TLOCK_STATIC_MAX)
+    return;
+
+  if (thread_debug)
+    fprintf(stderr, "msThreadInit() (win32)\n");
+
+  if (core_lock == NULL)
+    core_lock = CreateMutex(NULL, TRUE, NULL);
+  else
+    WaitForSingleObject(core_lock, INFINITE);
+
+  for (; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++)
+    mutex_locks[mutexes_initialized] = CreateMutex(NULL, FALSE, NULL);
+
+  ReleaseMutex(core_lock);
+}
+
+/************************************************************************/
+/*                           msGetThreadId()                            */
+/************************************************************************/
+
+void *msGetThreadId()
+
+{
+  return (void *)(size_t)GetCurrentThreadId();
+}
+
+/************************************************************************/
+/*                           msAcquireLock()                            */
+/************************************************************************/
+
+void msAcquireLock(int nLockId)
+
+{
+  if (mutexes_initialized == 0)
+    msThreadInit();
+
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
+
+  if (thread_debug)
+    fprintf(stderr, "msAcquireLock(%d/%s) (win32)\n", nLockId,
+            lock_names[nLockId]);
+
+  WaitForSingleObject(mutex_locks[nLockId], INFINITE);
+}
+
+/************************************************************************/
+/*                           msReleaseLock()                            */
+/************************************************************************/
+
+void msReleaseLock(int nLockId)
+
+{
+  assert(mutexes_initialized > 0);
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
+
+  if (thread_debug)
+    fprintf(stderr, "msReleaseLock(%d/%s) (win32)\n", nLockId,
+            lock_names[nLockId]);
+
+  ReleaseMutex(mutex_locks[nLockId]);
+}
+
+#endif /* defined(USE_THREAD) && defined(_WIN32) */
diff -pruN 8.0.1-5/src/mapthread.h 8.2.0~beta1-1~exp1/src/mapthread.h
--- 8.0.1-5/src/mapthread.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapthread.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,80 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Multithreading / locking related declarations.
+ * Author:   Frank Warmerdam <warmerdam@pobox.com>
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPTHREAD_H
+#define MAPTHREAD_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef USE_THREAD
+void msThreadInit(void);
+void *msGetThreadId(void);
+void msAcquireLock(int);
+void msReleaseLock(int);
+#else
+#define msThreadInit()
+#define msGetThreadId() (0)
+#define msAcquireLock(x)
+#define msReleaseLock(x)
+#endif
+
+/*
+** lock ids - note there is a corresponding lock_names[] array in
+** mapthread.c that needs to be extended when new ids are added.
+*/
+
+#define TLOCK_PARSER 1
+#define TLOCK_GDAL 2
+#define TLOCK_ERROROBJ 3
+#define TLOCK_PROJ 4
+#define TLOCK_TTF 5
+#define TLOCK_POOL 6
+#define TLOCK_SDE 7
+#define TLOCK_ORACLE 8
+#define TLOCK_OWS 9
+#define TLOCK_LAYER_VTABLE 10
+#define TLOCK_IOCONTEXT 11
+#define TLOCK_TMPFILE 12
+#define TLOCK_DEBUGOBJ 13
+#define TLOCK_OGR 14
+#define TLOCK_TIME 15
+#define TLOCK_FRIBIDI 16
+#define TLOCK_WxS 17
+#define TLOCK_GEOS 18
+
+#define TLOCK_STATIC_MAX 20
+#define TLOCK_MAX 100
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPTHREAD_H */
diff -pruN 8.0.1-5/src/maptile.c 8.2.0~beta1-1~exp1/src/maptile.c
--- 8.0.1-5/src/maptile.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptile.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,548 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  MapServer Tile Access API
+ * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
+ *
+ ******************************************************************************
+ * Copyright (c) 2008, Paul Ramsey
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "maptile.h"
+#include "mapproject.h"
+
+#ifdef USE_TILE_API
+static void msTileResetMetatileLevel(mapObj *map) {
+  hashTableObj *meta = &(map->web.metadata);
+  const char *zero = "0";
+
+  /*  Is the tile_metatile_levetl set... */
+  if (msLookupHashTable(meta, "tile_metatile_level") != NULL) {
+    msRemoveHashTable(meta, "tile_metatile_level");
+  }
+  msInsertHashTable(meta, "tile_metatile_level", zero);
+}
+#endif
+
+/************************************************************************
+ *                            msTileGetGMapCoords                       *
+ ************************************************************************/
+static int msTileGetGMapCoords(const char *coordstring, int *x, int *y,
+                               int *zoom) {
+
+  int num_coords = 0;
+  char **coords = NULL;
+
+  if (coordstring) {
+    coords = msStringSplit(coordstring, ' ', &(num_coords));
+    if (num_coords != 3) {
+      msFreeCharArray(coords, num_coords);
+      msSetError(MS_WEBERR,
+                 "Invalid number of tile coordinates (should be three).",
+                 "msTileSetup()");
+      return MS_FAILURE;
+    }
+  } else {
+    msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
+    return MS_FAILURE;
+  }
+
+  if (x)
+    *x = strtol(coords[0], NULL, 10);
+  if (y)
+    *y = strtol(coords[1], NULL, 10);
+  if (zoom)
+    *zoom = strtol(coords[2], NULL, 10);
+
+  msFreeCharArray(coords, 3);
+  return MS_SUCCESS;
+}
+
+/************************************************************************
+ *                            msTileSetParams                           *
+ ************************************************************************/
+static void msTileGetParams(const mapservObj *msObj, tileParams *params) {
+
+  const char *value = NULL;
+  const mapObj *map = msObj->map;
+  const hashTableObj *meta = &(map->web.metadata);
+
+  if (msObj->TileWidth < 0)
+    params->tile_width = SPHEREMERC_IMAGE_SIZE;
+  else
+    params->tile_width = msObj->TileWidth;
+  if (msObj->TileHeight < 0)
+    params->tile_height = SPHEREMERC_IMAGE_SIZE;
+  else
+    params->tile_height = msObj->TileHeight;
+
+  /* Check for tile buffer, set to buffer==0 as default */
+  if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
+    params->map_edge_buffer = atoi(value);
+    if (map->debug)
+      msDebug("msTileSetParams(): tile_map_edge_buffer = %d\n",
+              params->map_edge_buffer);
+  } else
+    params->map_edge_buffer = 0;
+
+  /* Check for metatile size, set to tile==metatile as default */
+  if ((value = msLookupHashTable(meta, "tile_metatile_level")) != NULL) {
+    params->metatile_level = atoi(value);
+    /* Quietly force metatile_level to be sane */
+    if (params->metatile_level < 0)
+      params->metatile_level = 0;
+    if (params->metatile_level > 2)
+      params->metatile_level = 2;
+    if (map->debug)
+      msDebug("msTileSetParams(): tile_metatile_level = %d\n",
+              params->metatile_level);
+  } else
+    params->metatile_level = 0;
+}
+
+/************************************************************************
+ *                            msTileExtractSubTile                      *
+ *                                                                      *
+ ************************************************************************/
+static imageObj *msTileExtractSubTile(const mapservObj *msObj,
+                                      const imageObj *img) {
+
+  int width, mini, minj;
+  int zoom = 2;
+  imageObj *imgOut = NULL;
+  tileParams params;
+  rendererVTableObj *renderer;
+  rasterBufferObj imgBuffer;
+
+  if (!MS_RENDERER_PLUGIN(msObj->map->outputformat) ||
+      msObj->map->outputformat->renderer != img->format->renderer ||
+      !MS_MAP_RENDERER(msObj->map)->supports_pixel_buffer) {
+    msSetError(MS_MISCERR, "unsupported or mixed renderers",
+               "msTileExtractSubTile()");
+    return NULL;
+  }
+  renderer = MS_MAP_RENDERER(msObj->map);
+
+  if (renderer->getRasterBufferHandle((imageObj *)img, &imgBuffer) !=
+      MS_SUCCESS) {
+    return NULL;
+  }
+
+  /*
+  ** Load the metatiling information from the map file.
+  */
+  msTileGetParams(msObj, &params);
+
+  /*
+  ** Initialize values for the metatile clip area.
+  */
+  width = img->width - 2 * params.map_edge_buffer;
+  mini = params.map_edge_buffer;
+  minj = params.map_edge_buffer;
+
+  if (msObj->TileMode == TILE_GMAP) {
+    int x, y, zoom;
+
+    if (msObj->TileCoords) {
+      if (msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE)
+        return NULL;
+    } else {
+      msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
+      return NULL;
+    }
+
+    if (msObj->map->debug)
+      msDebug("msTileExtractSubTile(): gmaps coords (x: %d, y: %d)\n", x, y);
+
+    /*
+    ** The bottom N bits of the coordinates give us the subtile
+    ** location relative to the metatile.
+    */
+    x = (0xffff ^ (0xffff << params.metatile_level)) & x;
+    y = (0xffff ^ (0xffff << params.metatile_level)) & y;
+
+    if (msObj->map->debug)
+      msDebug("msTileExtractSubTile(): gmaps image coords (x: %d, y: %d)\n", x,
+              y);
+
+    mini = mini + x * params.tile_width;
+    minj = minj + y * params.tile_height;
+
+  } else if (msObj->TileMode == TILE_VE) {
+    int tsize;
+
+    const int lenTileCoords = (int)strlen(msObj->TileCoords);
+    if (lenTileCoords - params.metatile_level < 0) {
+      return (NULL);
+    }
+
+    /*
+    ** Process the last elements of the VE coordinate string to place the
+    ** requested tile in the context of the metatile
+    */
+    for (int i = lenTileCoords - params.metatile_level; i < lenTileCoords;
+         i++) {
+      char j = msObj->TileCoords[i];
+      tsize = width / zoom;
+      if (j == '1' || j == '3')
+        mini += tsize;
+      if (j == '2' || j == '3')
+        minj += tsize;
+      zoom *= 2;
+    }
+  } else {
+    return (NULL); /* Huh? Should have a mode. */
+  }
+
+  imgOut = msImageCreate(
+      params.tile_width, params.tile_height, msObj->map->outputformat, NULL,
+      NULL, msObj->map->resolution, msObj->map->defresolution, NULL);
+
+  if (imgOut == NULL) {
+    return NULL;
+  }
+
+  if (msObj->map->debug)
+    msDebug("msTileExtractSubTile(): extracting (%d x %d) tile, top corner "
+            "(%d, %d)\n",
+            params.tile_width, params.tile_height, mini, minj);
+
+  if (MS_UNLIKELY(MS_FAILURE == renderer->mergeRasterBuffer(
+                                    imgOut, &imgBuffer, 1.0, mini, minj, 0, 0,
+                                    params.tile_width, params.tile_height))) {
+    msFreeImage(imgOut);
+    return NULL;
+  }
+
+  return imgOut;
+}
+
+/************************************************************************
+ *                            msTileSetup                               *
+ *                                                                      *
+ *  Called from mapserv.c, this is where the fun begins                 *
+ *  Set up projections and test the parameters for legality.            *
+ ************************************************************************/
+int msTileSetup(mapservObj *msObj) {
+#ifdef USE_TILE_API
+
+  char *outProjStr = NULL;
+  tileParams params;
+
+  /*
+  ** Load the metatiling information from the map file.
+  */
+  msTileGetParams(msObj, &params);
+
+  /*
+  ** Ensure all the LAYERs have a projection.
+  */
+  if (msMapSetLayerProjections(msObj->map) != 0) {
+    return (MS_FAILURE);
+  }
+
+  /*
+  ** Set the projection string for this mode.
+  */
+  if (msObj->TileMode == TILE_GMAP || msObj->TileMode == TILE_VE) {
+    outProjStr = SPHEREMERC_PROJ4;
+  } else {
+    return MS_FAILURE; /* Huh? No mode? */
+  }
+  if (msLoadProjectionString(&(msObj->map->projection), outProjStr) != 0) {
+    msSetError(MS_CGIERR, "Unable to load projection string.", "msTileSetup()");
+    return MS_FAILURE;
+  }
+
+  /*
+  ** Set up the output extents for this tilemode and tile coordinates
+  */
+  if (msObj->TileMode == TILE_GMAP) {
+
+    int x, y, zoom;
+    double zoomfactor;
+
+    if (msObj->TileCoords) {
+      if (msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE)
+        return MS_FAILURE;
+    } else {
+      msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
+      return MS_FAILURE;
+    }
+
+    if (params.metatile_level >= zoom) {
+      msTileResetMetatileLevel(msObj->map);
+    }
+
+    zoomfactor = pow(2.0, (double)zoom);
+
+    /*
+    ** Check the input request for sanity.
+    */
+    if (x >= zoomfactor || y >= zoomfactor) {
+      msSetError(MS_CGIERR,
+                 "GMap tile coordinates are too large for supplied zoom.",
+                 "msTileSetup()");
+      return (MS_FAILURE);
+    }
+    if (x < 0 || y < 0) {
+      msSetError(MS_CGIERR,
+                 "GMap tile coordinates should not be less than zero.",
+                 "msTileSetup()");
+      return (MS_FAILURE);
+    }
+
+  } else if (msObj->TileMode == TILE_VE) {
+
+    if (strspn(msObj->TileCoords, "0123") < strlen(msObj->TileCoords)) {
+      msSetError(MS_CGIERR,
+                 "VE tile name should only include characters 0, 1, 2 and 3.",
+                 "msTileSetup()");
+      return (MS_FAILURE);
+    }
+
+    if (params.metatile_level >= (int)strlen(msObj->TileCoords)) {
+      msTileResetMetatileLevel(msObj->map);
+    }
+
+  } else {
+    return (MS_FAILURE); /* Huh? Should have a mode. */
+  }
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_CGIERR, "Tile API is not available.", "msTileSetup()");
+  return (MS_FAILURE);
+#endif
+}
+
+/************************************************************************
+ *                            msTileSetExtent                           *
+ *                                                                      *
+ *  Based on the input parameters, set the output extent for this       *
+ *  tile.                                                               *
+ ************************************************************************/
+int msTileSetExtent(mapservObj *msObj) {
+#ifdef USE_TILE_API
+
+  mapObj *map = msObj->map;
+  double dx, dy, buffer;
+  tileParams params;
+
+  /* Read the tile-mode map file parameters */
+  msTileGetParams(msObj, &params);
+
+  if (msObj->TileMode == TILE_GMAP) {
+    int x, y, zoom;
+    double zoomfactor, tilesize, xmin, xmax, ymin, ymax;
+
+    if (msObj->TileCoords) {
+      if (msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE)
+        return MS_FAILURE;
+    } else {
+      msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
+      return MS_FAILURE;
+    }
+
+    if (map->debug)
+      msDebug("msTileSetExtent(): gmaps coords (x: %d, y: %d, z: %d)\n", x, y,
+              zoom);
+
+    /*
+    ** If we are metatiling, adjust the zoom level appropriately,
+    ** then scale back the x/y coordinates to match the new level.
+    */
+    if (params.metatile_level > 0) {
+      zoom = zoom - params.metatile_level;
+      x = x >> params.metatile_level;
+      y = y >> params.metatile_level;
+    }
+
+    if (map->debug)
+      msDebug("msTileSetExtent(): gmaps metacoords (x: %d, y: %d, z: %d)\n", x,
+              y, zoom);
+
+    zoomfactor = pow(2.0, (double)zoom);
+
+    /*
+    ** Calculate the ground extents of the tile request.
+    */
+    /* printf("X: %i  Y: %i  Z: %i\n",x,y,zoom); */
+    tilesize = SPHEREMERC_GROUND_SIZE / zoomfactor;
+    xmin = (x * tilesize) - (SPHEREMERC_GROUND_SIZE / 2.0);
+    xmax = ((x + 1) * tilesize) - (SPHEREMERC_GROUND_SIZE / 2.0);
+    ymin = (SPHEREMERC_GROUND_SIZE / 2.0) - ((y + 1) * tilesize);
+    ymax = (SPHEREMERC_GROUND_SIZE / 2.0) - (y * tilesize);
+
+    map->extent.minx = xmin;
+    map->extent.maxx = xmax;
+    map->extent.miny = ymin;
+    map->extent.maxy = ymax;
+
+  } else if (msObj->TileMode == TILE_VE) {
+
+    double minx = SPHEREMERC_GROUND_SIZE / -2.0;
+    double miny = SPHEREMERC_GROUND_SIZE / -2.0;
+    double maxx = SPHEREMERC_GROUND_SIZE / 2.0;
+    double maxy = SPHEREMERC_GROUND_SIZE / 2.0;
+    double zoom = 2.0;
+    double tsize;
+
+    /*
+    ** Walk down the VE URL string, adjusting the extent each time.
+    ** For meta-tiling cases, we stop early, to draw a larger image.
+    */
+    for (int i = 0; i < (int)strlen(msObj->TileCoords) - params.metatile_level;
+         i++) {
+      char j = msObj->TileCoords[i];
+      tsize = SPHEREMERC_GROUND_SIZE / zoom;
+      if (j == '1' || j == '3')
+        minx += tsize;
+      if (j == '0' || j == '2')
+        maxx -= tsize;
+      if (j == '2' || j == '3')
+        maxy -= tsize;
+      if (j == '0' || j == '1')
+        miny += tsize;
+      zoom *= 2.0;
+    }
+
+    map->extent.minx = minx;
+    map->extent.maxx = maxx;
+    map->extent.miny = miny;
+    map->extent.maxy = maxy;
+
+  } else {
+    return (MS_FAILURE); /* Huh? Should have a mode. */
+  }
+
+  /*
+  ** Set the output tile size.
+  */
+  map->width = params.tile_width << params.metatile_level;
+  map->height = params.tile_height << params.metatile_level;
+
+  if (map->debug)
+    msDebug("msTileSetExtent(): base image size (%d x %d)\n", map->width,
+            map->height);
+
+  /*
+  ** Add the gutters
+  ** First calculate ground units in the buffer at current extent
+  */
+  buffer = params.map_edge_buffer * (map->extent.maxx - map->extent.minx) /
+           (double)map->width;
+  /*
+  ** Then adjust the map extents out by that amount
+  */
+  map->extent.minx -= buffer;
+  map->extent.maxx += buffer;
+  map->extent.miny -= buffer;
+  map->extent.maxy += buffer;
+  /*
+  ** Finally adjust the map image size by the pixel buffer
+  */
+  map->width += 2 * params.map_edge_buffer;
+  map->height += 2 * params.map_edge_buffer;
+
+  if (map->debug)
+    msDebug("msTileSetExtent(): buffered image size (%d x %d)\n", map->width,
+            map->height);
+
+  /*
+  ** Adjust the extents inwards by 1/2 pixel so they are from
+  ** center-of-pixel to center-of-pixel, instead of edge-to-edge.
+  ** This is the way mapserver does it.
+  */
+  dx = (map->extent.maxx - map->extent.minx) / map->width;
+  map->extent.minx += dx * 0.5;
+  map->extent.maxx -= dx * 0.5;
+  dy = (map->extent.maxy - map->extent.miny) / map->height;
+  map->extent.miny += dy * 0.5;
+  map->extent.maxy -= dy * 0.5;
+
+  /*
+  ** Ensure the labelcache buffer is greater than the tile buffer.
+  */
+  if (params.map_edge_buffer > 0) {
+    const char *value;
+    hashTableObj *meta = &(map->web.metadata);
+    char tilebufferstr[64];
+
+    /* Write the tile buffer to a string */
+    snprintf(tilebufferstr, sizeof(tilebufferstr), "-%d",
+             params.map_edge_buffer);
+
+    /* Hm, the labelcache buffer is set... */
+    if ((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) !=
+        NULL) {
+      /* If it's too small, replace with a bigger one */
+      if (params.map_edge_buffer > abs(atoi(value))) {
+        msRemoveHashTable(meta, "labelcache_map_edge_buffer");
+        msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
+      }
+    }
+    /* No labelcache buffer value? Then we use the tile buffer. */
+    else {
+      msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
+    }
+  }
+
+  if (map->debug) {
+    msDebug("msTileSetExtent (%f, %f) (%f, %f)\n", map->extent.minx,
+            map->extent.miny, map->extent.maxx, map->extent.maxy);
+  }
+
+  map->units = MS_METERS; // now the units are meters
+
+  return MS_SUCCESS;
+#else
+  msSetError(MS_CGIERR, "Tile API is not available.", "msTileSetExtent()");
+  return (MS_FAILURE);
+#endif
+}
+
+/************************************************************************
+ *                            msDrawTile                                *
+ *                                                                      *
+ *   Draw the tile once with gutters, metatiling and buffers, then      *
+ *   clip out the final tile.                                           *
+ *   WARNING: Call msTileSetExtent() first or this will be a pointless  *
+ *   fucnction call.                                                    *
+ ************************************************************************/
+
+imageObj *msTileDraw(mapservObj *msObj) {
+  imageObj *img;
+  tileParams params;
+  msTileGetParams(msObj, &params);
+  img = msDrawMap(msObj->map, MS_FALSE);
+  if (img == NULL)
+    return NULL;
+  if (params.metatile_level > 0 || params.map_edge_buffer > 0) {
+    imageObj *tmp = msTileExtractSubTile(msObj, img);
+    msFreeImage(img);
+    if (tmp == NULL)
+      return NULL;
+    img = tmp;
+  }
+  return img;
+}
diff -pruN 8.0.1-5/src/maptile.h 8.2.0~beta1-1~exp1/src/maptile.h
--- 8.0.1-5/src/maptile.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptile.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,54 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  MapServer Tile Access API
+ * Author:   Paul Ramsey <pramsey@cleverelephant.ca>
+ *
+ ******************************************************************************
+ * Copyright (c) 2008, Paul Ramsey
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maptemplate.h"
+
+#define USE_TILE_API 1
+
+#define SPHEREMERC_PROJ4                                                       \
+  "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 "   \
+  "+units=m +k=1.0 +nadgrids=@null"
+#define SPHEREMERC_GROUND_SIZE (20037508.34 * 2)
+#define SPHEREMERC_IMAGE_SIZE 0x0100
+
+enum tileModes { TILE_GMAP, TILE_VE };
+
+MS_DLL_EXPORT int msTileSetup(mapservObj *msObj);
+MS_DLL_EXPORT int msTileSetExtent(mapservObj *msObj);
+MS_DLL_EXPORT int msTileSetProjections(mapObj *map);
+MS_DLL_EXPORT imageObj *msTileDraw(mapservObj *msObj);
+
+typedef struct {
+  int metatile_level;  /* In zoom levels above tile request: best bet is 0, 1 or
+                          2 */
+  int tile_width;      /* In pixels */
+  int tile_height;     /* In pixels */
+  int map_edge_buffer; /* In pixels */
+} tileParams;
diff -pruN 8.0.1-5/src/maptime.c 8.2.0~beta1-1~exp1/src/maptime.c
--- 8.0.1-5/src/maptime.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptime.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,477 @@
+/******************************************************************************
+ * $id$
+ *
+ * Project:  MapServer
+ * Purpose:  Date/Time utility functions.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#define _GNU_SOURCE /* glibc2 needs this for strptime() */
+#include <stdlib.h>
+#include <stdio.h>
+#include <time.h>
+
+#include "mapserver.h"
+#include "maptime.h"
+#include "maperror.h"
+#include "mapthread.h"
+
+typedef struct {
+  char pattern[64];
+  ms_regex_t *regex;
+  char format[32];
+  char userformat[32];
+  MS_TIME_RESOLUTION resolution;
+} timeFormatObj;
+
+static timeFormatObj ms_timeFormats[] = {
+    {"^[0-9]{8}", NULL, "%Y%m%d", "YYYYMMDD", TIME_RESOLUTION_DAY},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL,
+     "%Y-%m-%dT%H:%M:%SZ", "YYYY-MM-DDTHH:MM:SSZ", TIME_RESOLUTION_SECOND},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL,
+     "%Y-%m-%dT%H:%M:%S", "YYYY-MM-DDTHH:MM:SS", TIME_RESOLUTION_SECOND},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}", NULL,
+     "%Y-%m-%d %H:%M:%S", "YYYY-MM-DD HH:MM:SS", TIME_RESOLUTION_SECOND},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%dT%H:%M",
+     "YYYY-MM-DDTHH:MM", TIME_RESOLUTION_MINUTE},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%d %H:%M",
+     "YYYY-MM-DD HH:MM", TIME_RESOLUTION_MINUTE},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}", NULL, "%Y-%m-%dT%H",
+     "YYYY-MM-DDTHH", TIME_RESOLUTION_HOUR},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}", NULL, "%Y-%m-%d %H",
+     "YYYY-MM-DD HH", TIME_RESOLUTION_HOUR},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}", NULL, "%Y-%m-%d", "YYYY-MM-DD",
+     TIME_RESOLUTION_DAY},
+    {"^[0-9]{4}-[0-9]{2}", NULL, "%Y-%m", "YYYY-MM", TIME_RESOLUTION_MONTH},
+    {"^[0-9]{4}", NULL, "%Y", "YYYY", TIME_RESOLUTION_YEAR},
+    {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "T%H:%M:%SZ", "THH:MM:SSZ",
+     TIME_RESOLUTION_SECOND},
+    {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "T%H:%M:%S", "THH:MM:SS",
+     TIME_RESOLUTION_SECOND},
+    {"^[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "%H:%M:%SZ", "HH:MM:SSZ",
+     TIME_RESOLUTION_SECOND},
+    {"^[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%H:%M:%S", "HH:MM:SS",
+     TIME_RESOLUTION_SECOND}};
+
+#define MS_NUMTIMEFORMATS                                                      \
+  (int)(sizeof(ms_timeFormats) / sizeof(ms_timeFormats[0]))
+
+int *ms_limited_pattern = NULL;
+int ms_num_limited_pattern;
+
+int ms_time_inited = 0;
+int msTimeSetup() {
+  if (!ms_time_inited) {
+    msAcquireLock(TLOCK_TIME);
+    if (!ms_time_inited) {
+      int i;
+      for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
+        ms_timeFormats[i].regex = msSmallMalloc(sizeof(ms_regex_t));
+        if (0 != ms_regcomp(ms_timeFormats[i].regex, ms_timeFormats[i].pattern,
+                            MS_REG_EXTENDED | MS_REG_NOSUB)) {
+          msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+                     "msTimeSetup()", ms_timeFormats[i].pattern);
+          return MS_FAILURE;
+          /* TODO: free already init'd regexes */
+        }
+      }
+      ms_limited_pattern =
+          (int *)msSmallMalloc(sizeof(int) * MS_NUMTIMEFORMATS);
+      ms_num_limited_pattern = 0;
+      ms_time_inited = 1;
+    }
+    msReleaseLock(TLOCK_TIME);
+  }
+  return MS_SUCCESS;
+}
+
+void msTimeCleanup() {
+  if (ms_time_inited) {
+    int i;
+    for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
+      if (ms_timeFormats[i].regex) {
+        ms_regfree(ms_timeFormats[i].regex);
+        msFree(ms_timeFormats[i].regex);
+        ms_timeFormats[i].regex = NULL;
+      }
+    }
+    msFree(ms_limited_pattern);
+    ms_time_inited = 0;
+  }
+}
+
+void msTimeInit(struct tm *time) {
+  time->tm_sec = 0; /* set all members to zero */
+  time->tm_min = 0;
+  time->tm_hour = 0;
+  time->tm_mday = 0;
+  time->tm_mon = 0;
+  time->tm_year = 0;
+  time->tm_wday = 0;
+  time->tm_yday = 0;
+  time->tm_isdst = 0;
+
+  return;
+}
+
+static int compareIntVals(int a, int b) {
+  if (a < b)
+    return -1;
+  else if (a > b)
+    return 1;
+  else
+    return 0;
+}
+
+int msDateCompare(struct tm *time1, struct tm *time2) {
+  int result;
+
+  if ((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
+    return result; /* not equal based on year */
+  else if ((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
+    return result; /* not equal based on month */
+  else if ((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
+    return result; /* not equal based on day of month */
+
+  return (0); /* must be equal */
+}
+
+int msTimeCompare(struct tm *time1, struct tm *time2) {
+  int result;
+
+  // fprintf(stderr, "in msTimeCompare()...\n");
+  // fprintf(stderr, "time1: %d %d %d %d %d %d\n", time1->tm_year,
+  // time1->tm_mon, time1->tm_mday, time1->tm_hour, time1->tm_min,
+  // time1->tm_sec); fprintf(stderr, "time2: %d %d %d %d %d %d\n",
+  // time2->tm_year, time2->tm_mon, time2->tm_mday, time2->tm_hour,
+  // time2->tm_min, time2->tm_sec);
+
+  if ((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
+    return result; /* not equal based on year */
+  else if ((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
+    return result; /* not equal based on month */
+  else if ((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
+    return result; /* not equal based on day of month */
+  else if ((result = compareIntVals(time1->tm_hour, time2->tm_hour)) != 0)
+    return result; /* not equal based on hour */
+  else if ((result = compareIntVals(time1->tm_min, time2->tm_min)) != 0)
+    return result; /* not equal based on minute */
+  else if ((result = compareIntVals(time1->tm_sec, time2->tm_sec)) != 0)
+    return result; /* not equal based on second */
+
+  return (0); /* must be equal */
+}
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <sys/timeb.h>
+void msGettimeofday(struct mstimeval *tp, void *tzp) {
+  struct _timeb theTime;
+
+  _ftime(&theTime);
+  tp->tv_sec = theTime.time;
+  tp->tv_usec = theTime.millitm * 1000;
+}
+#endif
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+/* we need to provide our own prototype on windows. */
+char *strptime(const char *buf, const char *format, struct tm *timeptr);
+#endif
+
+char *msStrptime(const char *s, const char *format, struct tm *tm) {
+  memset(tm, 0, sizeof(struct tm));
+  return strptime(s, format, tm);
+}
+
+/**
+   return MS_TRUE if the time string matchs the timeformat.
+   else return MS_FALSE.
+ */
+int msTimeMatchPattern(const char *timestring, const char *timeformat) {
+  int i = -1;
+  if (msTimeSetup() != MS_SUCCESS) {
+    return MS_FALSE;
+  }
+
+  /* match the pattern format first and then check if the time string  */
+  /* matchs the pattern. If it is the case retrurn the MS_TRUE */
+  for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
+    if (strcasecmp(ms_timeFormats[i].userformat, timeformat) == 0)
+      break;
+  }
+
+  if (i >= 0 && i < MS_NUMTIMEFORMATS) {
+    int match = ms_regexec(ms_timeFormats[i].regex, timestring, 0, NULL, 0);
+    if (match == 0)
+      return MS_TRUE;
+  }
+  return MS_FALSE;
+}
+
+void msUnsetLimitedPatternToUse() {
+  msTimeSetup();
+  ms_num_limited_pattern = 0;
+}
+
+void msSetLimitedPatternsToUse(const char *patternstring) {
+  int *limitedpatternindice = NULL;
+  int numpatterns = 0, ntmp = 0;
+  char **patterns = NULL;
+  msTimeSetup();
+
+  limitedpatternindice = (int *)msSmallMalloc(sizeof(int) * MS_NUMTIMEFORMATS);
+
+  /* free previous setting */
+  msUnsetLimitedPatternToUse();
+
+  if (patternstring) {
+    patterns = msStringSplit(patternstring, ',', &ntmp);
+    if (patterns && ntmp >= 1) {
+
+      for (int i = 0; i < ntmp; i++) {
+        for (int j = 0; j < MS_NUMTIMEFORMATS; j++) {
+          if (strcasecmp(ms_timeFormats[j].userformat, patterns[i]) == 0) {
+            limitedpatternindice[numpatterns] = j;
+            numpatterns++;
+            break;
+          }
+        }
+      }
+    }
+    msFreeCharArray(patterns, ntmp);
+  }
+
+  if (numpatterns > 0) {
+    for (int i = 0; i < numpatterns; i++)
+      ms_limited_pattern[i] = limitedpatternindice[i];
+
+    ms_num_limited_pattern = numpatterns;
+  }
+  free(limitedpatternindice);
+}
+
+int msParseTime(const char *string, struct tm *tm) {
+  int num_patterns = 0;
+
+  if (MS_STRING_IS_NULL_OR_EMPTY(string))
+    return MS_FALSE; /* nothing to parse so bail */
+
+  if (msTimeSetup() != MS_SUCCESS) {
+    return MS_FALSE;
+  }
+
+  /* if limited patterns are set, use them, else use all the patterns defined */
+  if (ms_num_limited_pattern > 0)
+    num_patterns = ms_num_limited_pattern;
+  else
+    num_patterns = MS_NUMTIMEFORMATS;
+
+  for (int i = 0; i < num_patterns; i++) {
+    int match;
+    int indice;
+    if (ms_num_limited_pattern > 0)
+      indice = ms_limited_pattern[i];
+    else
+      indice = i;
+
+    match = ms_regexec(ms_timeFormats[indice].regex, string, 0, NULL, 0);
+    /* test the expression against the string */
+    if (match == 0) {
+      /* match    */
+      msStrptime(string, ms_timeFormats[indice].format, tm);
+      return (MS_TRUE);
+    }
+  }
+
+  msSetError(MS_REGEXERR, "Unrecognized date or time format (%s).",
+             "msParseTime()", string);
+  return (MS_FALSE);
+}
+
+/**
+ * Parse the time string and return the reslution
+ */
+int msTimeGetResolution(const char *timestring) {
+  int i = 0;
+
+  if (!timestring)
+    return -1;
+
+  for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
+    ms_regex_t *regex = (ms_regex_t *)msSmallMalloc(sizeof(ms_regex_t));
+    if (ms_regcomp(regex, ms_timeFormats[i].pattern,
+                   MS_REG_EXTENDED | MS_REG_NOSUB) != 0) {
+      msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+                 "msParseTime()", ms_timeFormats[i].pattern);
+      msFree(regex);
+      return -1;
+    }
+    /* test the expression against the string */
+    if (ms_regexec(regex, timestring, 0, NULL, 0) == 0) {
+      /* match    */
+      ms_regfree(regex);
+      msFree(regex);
+      return ms_timeFormats[i].resolution;
+    }
+    ms_regfree(regex);
+    msFree(regex);
+  }
+
+  return -1;
+}
+
+int _msValidateTime(const char *timestring, const char *timeextent) {
+  int numelements, numextents, i, numranges;
+  struct tm tmtimestart, tmtimeend, tmstart, tmend;
+  char **atimerange = NULL, **atimeelements = NULL, **atimeextents = NULL;
+
+  if (!timestring || !timeextent)
+    return MS_FALSE;
+
+  if (strlen(timestring) == 0 || strlen(timeextent) == 0)
+    return MS_FALSE;
+
+  /* we first need to parse the timesting that is passed
+     so that we can determine if it is a descrete time
+     or a range */
+
+  numelements = 0;
+  atimeelements = msStringSplit(timestring, '/', &numelements);
+  msTimeInit(&tmtimestart);
+  msTimeInit(&tmtimeend);
+
+  if (numelements == 1) { /*descrete time*/
+    /*start end end times are the same*/
+    if (msParseTime(timestring, &tmtimestart) != MS_TRUE) {
+      msFreeCharArray(atimeelements, numelements);
+      return MS_FALSE;
+    }
+    if (msParseTime(timestring, &tmtimeend) != MS_TRUE) {
+      msFreeCharArray(atimeelements, numelements);
+      return MS_FALSE;
+    }
+  } else if (numelements >= 2) { /*range */
+    if (msParseTime(atimeelements[0], &tmtimestart) != MS_TRUE) {
+      msFreeCharArray(atimeelements, numelements);
+      return MS_FALSE;
+    }
+    if (msParseTime(atimeelements[1], &tmtimeend) != MS_TRUE) {
+      msFreeCharArray(atimeelements, numelements);
+      return MS_FALSE;
+    }
+  }
+
+  msFreeCharArray(atimeelements, numelements);
+
+  /* Now parse the time extent. Extents can be
+    -  one range (2004-09-21/2004-09-25/resolution)
+    -  multiple rages 2004-09-21/2004-09-25/res1,2004-09-21/2004-09-25/res2
+    - one value 2004-09-21
+    - mutiple values 2004-09-21,2004-09-22,2004-09-23
+  */
+
+  numextents = 0;
+  atimeextents = msStringSplit(timeextent, ',', &numextents);
+  if (numextents <= 0) {
+    msFreeCharArray(atimeextents, numextents);
+    return MS_FALSE;
+  }
+
+  /*the time timestring should at be valid in one of the extents
+    defined */
+
+  for (i = 0; i < numextents; i++) {
+    /* build time structure for the extents */
+    msTimeInit(&tmstart);
+    msTimeInit(&tmend);
+
+    numranges = 0;
+    atimerange = msStringSplit(atimeextents[i], '/', &numranges);
+    /* - one value 2004-09-21 */
+    if (numranges == 1) {
+      /*time tested can either be descrete or a range */
+
+      if (msParseTime(atimerange[0], &tmstart) == MS_TRUE &&
+          msParseTime(atimerange[0], &tmend) == MS_TRUE &&
+          msTimeCompare(&tmstart, &tmtimestart) <= 0 &&
+          msTimeCompare(&tmend, &tmtimeend) >= 0) {
+        msFreeCharArray(atimerange, numranges);
+        msFreeCharArray(atimeextents, numextents);
+        return MS_TRUE;
+      }
+    }
+    /*2004-09-21/2004-09-25/res1*/
+    else if (numranges >= 2) {
+      if (msParseTime(atimerange[0], &tmstart) == MS_TRUE &&
+          msParseTime(atimerange[1], &tmend) == MS_TRUE &&
+          msTimeCompare(&tmstart, &tmtimestart) <= 0 &&
+          msTimeCompare(&tmend, &tmtimeend) >= 0) {
+        msFreeCharArray(atimerange, numranges);
+        msFreeCharArray(atimeextents, numextents);
+        return MS_TRUE;
+      }
+    }
+    msFreeCharArray(atimerange, numranges);
+  }
+  msFreeCharArray(atimeextents, numextents);
+  return MS_FALSE;
+}
+
+int msValidateTimeValue(const char *timestring, const char *timeextent) {
+  char **atimes = NULL;
+  int i, numtimes = 0;
+
+  /* we need to validate the time passsed in the request */
+  /* against the time extent defined */
+
+  if (!timestring || !timeextent)
+    return MS_FALSE;
+
+  /* To avoid SQL injections */
+  if (strchr(timestring, '\''))
+    return MS_FALSE;
+
+  /* parse the time string. We support descrete times (eg 2004-09-21), */
+  /* multiple times (2004-09-21, 2004-09-22, ...) */
+  /* and range(s) (2004-09-21/2004-09-25, 2004-09-27/2004-09-29) */
+  if (strstr(timestring, ",") == NULL &&
+      strstr(timestring, "/") == NULL) { /* discrete time */
+    return _msValidateTime(timestring, timeextent);
+  } else {
+    atimes = msStringSplit(timestring, ',', &numtimes);
+    if (numtimes >= 1) { /* multiple times */
+      for (i = 0; i < numtimes; i++) {
+        if (_msValidateTime(atimes[i], timeextent) == MS_FALSE) {
+          msFreeCharArray(atimes, numtimes);
+          return MS_FALSE;
+        }
+      }
+      msFreeCharArray(atimes, numtimes);
+      return MS_TRUE;
+    } else {
+      msFreeCharArray(atimes, numtimes);
+    }
+  }
+  return MS_FALSE;
+}
diff -pruN 8.0.1-5/src/maptime.h 8.2.0~beta1-1~exp1/src/maptime.h
--- 8.0.1-5/src/maptime.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptime.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,83 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Time processing related declarations.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPTIME_H
+#define MAPTIME_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/* (bug 602) gettimeofday() and struct timeval aren't available on Windows,
+ * so we provide a replacement with msGettimeofday() and struct mstimeval on
+ * Windows.  On Unix/Linux they are just #defines to the real things.
+ */
+#if defined(_WIN32) && !defined(__CYGWIN__)
+struct mstimeval {
+  long tv_sec;  /* seconds */
+  long tv_usec; /* and microseconds */
+};
+MS_DLL_EXPORT void msGettimeofday(struct mstimeval *t, void *__not_used_here__);
+#else
+#include <sys/time.h> /* for gettimeofday() */
+#define mstimeval timeval
+#define msGettimeofday(t, u) gettimeofday(t, u)
+#endif
+
+typedef enum {
+  TIME_RESOLUTION_UNDEFINED = -1,
+  TIME_RESOLUTION_MICROSECOND = 0,
+  TIME_RESOLUTION_MILLISECOND = 1,
+  TIME_RESOLUTION_SECOND = 2,
+  TIME_RESOLUTION_MINUTE = 3,
+  TIME_RESOLUTION_HOUR = 4,
+  TIME_RESOLUTION_DAY = 5,
+  TIME_RESOLUTION_MONTH = 6,
+  TIME_RESOLUTION_YEAR = 7
+} MS_TIME_RESOLUTION;
+
+/* function prototypes */
+void msTimeInit(struct tm *time);
+int msDateCompare(struct tm *time1, struct tm *time2);
+int msTimeCompare(struct tm *time1, struct tm *time2);
+char *msStrptime(const char *s, const char *format, struct tm *tm);
+int msParseTime(const char *string, struct tm *tm);
+int msTimeMatchPattern(const char *timestring, const char *pattern);
+void msSetLimitedPatternsToUse(const char *patternstring);
+void msUnsetLimitedPatternToUse(void);
+MS_DLL_EXPORT int msTimeGetResolution(const char *timestring);
+void msTimeCleanup();
+
+int msValidateTimeValue(const char *timestring, const char *timeextent);
+
+#ifdef __cplusplus
+} /* extern C */
+#endif
+
+#endif /* MAPTIME_H */
diff -pruN 8.0.1-5/src/maptree.c 8.2.0~beta1-1~exp1/src/maptree.c
--- 8.0.1-5/src/maptree.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptree.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,854 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  .qix spatial index implementation.  Derived from shapelib, and
+ *           relicensed with permission of Frank Warmerdam (shapelib author).
+ * Author:   Steve Lime
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maptree.h"
+
+#include <limits.h>
+
+#ifdef __BYTE_ORDER__
+/* GCC/clang predefined macro */
+#define bBigEndian (__BYTE_ORDER__ == __ORDER_BIG_ENDIAN__)
+#elif defined(_MSC_VER)
+/* MSVC doesn't support the C99 trick below, but all Microsoft
+   platforms are little-endian */
+#define bBigEndian false
+#else
+/* generic check */
+#define bBigEndian                                                             \
+  (((union {                                                                   \
+     int in;                                                                   \
+     char out;                                                                 \
+   }){1})                                                                      \
+       .out)
+#endif
+
+/* -------------------------------------------------------------------- */
+/*      If the following is 0.5, nodes will be split in half.  If it    */
+/*      is 0.6 then each subnode will contain 60% of the parent         */
+/*      node, with 20% representing overlap.  This can be help to       */
+/*      prevent small objects on a boundary from shifting too high      */
+/*      up the tree.                                                    */
+/* -------------------------------------------------------------------- */
+#define SPLITRATIO 0.55
+
+static int treeAddShapeId(treeObj *tree, int id, rectObj rect);
+
+static void SwapWord(int length, void *wordP) {
+  int i;
+  uchar temp;
+
+  for (i = 0; i < length / 2; i++) {
+    temp = ((uchar *)wordP)[i];
+    ((uchar *)wordP)[i] = ((uchar *)wordP)[length - i - 1];
+    ((uchar *)wordP)[length - i - 1] = temp;
+  }
+}
+
+static void *SfRealloc(void *pMem, int nNewSize)
+
+{
+  if (pMem == NULL)
+    return ((void *)malloc(nNewSize));
+  else
+    return ((void *)realloc(pMem, nNewSize));
+}
+
+static treeNodeObj *treeNodeCreate(rectObj rect) {
+  treeNodeObj *node;
+
+  node = (treeNodeObj *)msSmallMalloc(sizeof(treeNodeObj));
+
+  node->numshapes = 0;
+  node->ids = NULL;
+
+  node->numsubnodes = 0;
+
+  memcpy(&(node->rect), &(rect), sizeof(rectObj));
+
+  return node;
+}
+
+SHPTreeHandle msSHPDiskTreeOpen(const char *pszTree, int debug) {
+  char *pszFullname, *pszBasename;
+  SHPTreeHandle psTree;
+
+  char pabyBuf[16];
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*  Initialize the info structure.              */
+  /* -------------------------------------------------------------------- */
+  psTree = (SHPTreeHandle)msSmallMalloc(sizeof(SHPTreeInfo));
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension     */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(pszTree) + 5);
+  strcpy(pszBasename, pszTree);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*  Open the .shp and .shx files.  Note that files pulled from      */
+  /*  a PC to Unix with upper case filenames won't work!        */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
+  psTree->fp = fopen(pszFullname, "rb");
+  if (psTree->fp == NULL) {
+    sprintf(pszFullname, "%s.QIX", pszBasename);
+    psTree->fp = fopen(pszFullname, "rb");
+  }
+
+  msFree(pszBasename); /* don't need these any more */
+  msFree(pszFullname);
+
+  if (psTree->fp == NULL) {
+    msFree(psTree);
+    return (NULL);
+  }
+
+  if (fread(pabyBuf, 8, 1, psTree->fp) != 1) {
+    msFree(psTree);
+    return (NULL);
+  }
+
+  memcpy(&psTree->signature, pabyBuf, 3);
+  if (strncmp(psTree->signature, "SQT", 3)) {
+    /* ---------------------------------------------------------------------- */
+    /*     must check if the 2 first bytes equal 0 of max depth that cannot   */
+    /*     be more than 65535. If yes, we must swap all value. The problem    */
+    /*     here is if there's no Depth (bytea 5,6,7,8 in the file) all bytes  */
+    /*     will be set to 0. So,we will test with the number of shapes (bytes */
+    /*     1,2,3,4) that cannot be more than 65535 too.                       */
+    /* ---------------------------------------------------------------------- */
+    if (debug) {
+      msDebug("WARNING in msSHPDiskTreeOpen(): %s is in old index format "
+              "which has been deprecated.  It is strongly recommended to "
+              "regenerate it in new format.\n",
+              pszTree);
+    }
+    if ((pabyBuf[4] == 0 && pabyBuf[5] == 0 && pabyBuf[6] == 0 &&
+         pabyBuf[7] == 0)) {
+      psTree->LSB_order = !(pabyBuf[0] == 0 && pabyBuf[1] == 0);
+    } else {
+      psTree->LSB_order = !(pabyBuf[4] == 0 && pabyBuf[5] == 0);
+    }
+    psTree->needswap = ((psTree->LSB_order) != (!bBigEndian));
+
+    /* ---------------------------------------------------------------------- */
+    /*     poor hack to see if this quadtree was created by a computer with a */
+    /*     different Endian                                                   */
+    /* ---------------------------------------------------------------------- */
+    psTree->version = 0;
+  } else {
+    psTree->needswap = ((pabyBuf[3] == MS_NEW_MSB_ORDER) ^ (bBigEndian));
+
+    psTree->LSB_order = (pabyBuf[3] == MS_NEW_LSB_ORDER);
+    memcpy(&psTree->version, pabyBuf + 4, 1);
+    memcpy(&psTree->flags, pabyBuf + 5, 3);
+
+    if (fread(pabyBuf, 8, 1, psTree->fp) != 1) {
+      msFree(psTree);
+      return (NULL);
+    }
+  }
+
+  if (psTree->needswap)
+    SwapWord(4, pabyBuf);
+  memcpy(&psTree->nShapes, pabyBuf, 4);
+
+  if (psTree->needswap)
+    SwapWord(4, pabyBuf + 4);
+  memcpy(&psTree->nDepth, pabyBuf + 4, 4);
+
+  return (psTree);
+}
+
+void msSHPDiskTreeClose(SHPTreeHandle disktree) {
+  fclose(disktree->fp);
+  free(disktree);
+}
+
+treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth) {
+  int i;
+  treeObj *tree;
+  rectObj bounds;
+
+  if (!shapefile)
+    return NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Allocate the tree object                                        */
+  /* -------------------------------------------------------------------- */
+  tree = (treeObj *)msSmallMalloc(sizeof(treeObj));
+
+  tree->numshapes = shapefile->numshapes;
+  tree->maxdepth = maxdepth;
+
+  /* -------------------------------------------------------------------- */
+  /*      If no max depth was defined, try to select a reasonable one     */
+  /*      that implies approximately 8 shapes per node.                   */
+  /* -------------------------------------------------------------------- */
+  if (tree->maxdepth == 0) {
+    int numnodes = 1;
+
+    while (numnodes * 4 < shapefile->numshapes) {
+      tree->maxdepth += 1;
+      numnodes = numnodes * 2;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Allocate the root node.                                         */
+  /* -------------------------------------------------------------------- */
+  tree->root = treeNodeCreate(shapefile->bounds);
+
+  for (i = 0; i < shapefile->numshapes; i++) {
+    if (msSHPReadBounds(shapefile->hSHP, i, &bounds) == MS_SUCCESS)
+      treeAddShapeId(tree, i, bounds);
+  }
+
+  return tree;
+}
+
+static void destroyTreeNode(treeNodeObj *node) {
+  int i;
+
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i])
+      destroyTreeNode(node->subnode[i]);
+  }
+
+  if (node->ids)
+    free(node->ids);
+
+  free(node);
+}
+
+void msDestroyTree(treeObj *tree) {
+  destroyTreeNode(tree->root);
+  free(tree);
+}
+
+static void treeSplitBounds(rectObj *in, rectObj *out1, rectObj *out2) {
+  double range;
+
+  /* -------------------------------------------------------------------- */
+  /*      The output bounds will be very similar to the input bounds,     */
+  /*      so just copy over to start.                                     */
+  /* -------------------------------------------------------------------- */
+  memcpy(out1, in, sizeof(rectObj));
+  memcpy(out2, in, sizeof(rectObj));
+
+  /* -------------------------------------------------------------------- */
+  /*      Split in X direction.                                           */
+  /* -------------------------------------------------------------------- */
+  if ((in->maxx - in->minx) > (in->maxy - in->miny)) {
+    range = in->maxx - in->minx;
+
+    out1->maxx = in->minx + range * SPLITRATIO;
+    out2->minx = in->maxx - range * SPLITRATIO;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise split in Y direction.                                 */
+  /* -------------------------------------------------------------------- */
+  else {
+    range = in->maxy - in->miny;
+
+    out1->maxy = in->miny + range * SPLITRATIO;
+    out2->miny = in->maxy - range * SPLITRATIO;
+  }
+}
+
+static int treeNodeAddShapeId(treeNodeObj *node, int id, rectObj rect,
+                              int maxdepth) {
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*      If there are subnodes, then consider whether this object        */
+  /*      will fit in them.                                               */
+  /* -------------------------------------------------------------------- */
+  if (maxdepth > 1 && node->numsubnodes > 0) {
+    for (i = 0; i < node->numsubnodes; i++) {
+      if (msRectContained(&rect, &node->subnode[i]->rect)) {
+        return treeNodeAddShapeId(node->subnode[i], id, rect, maxdepth - 1);
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise, consider creating four subnodes if could fit into    */
+  /*      them, and adding to the appropriate subnode.                    */
+  /* -------------------------------------------------------------------- */
+#if MAX_SUBNODES == 4
+  else if (maxdepth > 1 && node->numsubnodes == 0) {
+    rectObj half1, half2, quad1, quad2, quad3, quad4;
+
+    treeSplitBounds(&node->rect, &half1, &half2);
+    treeSplitBounds(&half1, &quad1, &quad2);
+    treeSplitBounds(&half2, &quad3, &quad4);
+
+    if (msRectContained(&rect, &quad1) || msRectContained(&rect, &quad2) ||
+        msRectContained(&rect, &quad3) || msRectContained(&rect, &quad4)) {
+      node->numsubnodes = 4;
+      node->subnode[0] = treeNodeCreate(quad1);
+      node->subnode[1] = treeNodeCreate(quad2);
+      node->subnode[2] = treeNodeCreate(quad3);
+      node->subnode[3] = treeNodeCreate(quad4);
+
+      /* recurse back on this node now that it has subnodes */
+      return (treeNodeAddShapeId(node, id, rect, maxdepth));
+    }
+  }
+#endif
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise, consider creating two subnodes if could fit into     */
+  /*      them, and adding to the appropriate subnode.                    */
+  /* -------------------------------------------------------------------- */
+#if MAX_SUBNODE == 2
+  else if (maxdepth > 1 && node->numsubnodes == 0) {
+    rectObj half1, half2;
+
+    treeSplitBounds(&node->rect, &half1, &half2);
+
+    if (msRectContained(&rect, &half1)) {
+      node->numsubnodes = 2;
+      node->subnode[0] = treeNodeCreate(half1);
+      node->subnode[1] = treeNodeCreate(half2);
+
+      return (treeNodeAddShapeId(node->subnode[0], id, rect, maxdepth - 1));
+    } else if (msRectContained(&rect, &half2)) {
+      node->numsubnodes = 2;
+      node->subnode[0] = treeNodeCreate(&half1);
+      node->subnode[1] = treeNodeCreate(&half2);
+
+      return (treeNodeAddShapeId(node->subnode[1], id, rect, maxdepth - 1));
+    }
+  }
+#endif /* MAX_SUBNODE == 2 */
+
+  /* -------------------------------------------------------------------- */
+  /*      If none of that worked, just add it to this nodes list.         */
+  /* -------------------------------------------------------------------- */
+  node->numshapes++;
+
+  node->ids = SfRealloc(node->ids, sizeof(ms_int32) * node->numshapes);
+  node->ids[node->numshapes - 1] = id;
+
+  return MS_TRUE;
+}
+
+static int treeAddShapeId(treeObj *tree, int id, rectObj rect) {
+  return (treeNodeAddShapeId(tree->root, id, rect, tree->maxdepth));
+}
+
+static void treeCollectShapeIds(treeNodeObj *node, rectObj aoi,
+                                ms_bitarray status) {
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*      Does this node overlap the area of interest at all?  If not,    */
+  /*      return without adding to the list at all.                       */
+  /* -------------------------------------------------------------------- */
+  if (!msRectOverlap(&node->rect, &aoi))
+    return;
+
+  /* -------------------------------------------------------------------- */
+  /*      Add the local nodes shapeids to the list.                       */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < node->numshapes; i++)
+    msSetBit(status, node->ids[i], 1);
+
+  /* -------------------------------------------------------------------- */
+  /*      Recurse to subnodes if they exist.                              */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i])
+      treeCollectShapeIds(node->subnode[i], aoi, status);
+  }
+}
+
+ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi) {
+  ms_bitarray status = NULL;
+
+  status = msAllocBitArray(tree->numshapes);
+  if (!status) {
+    msSetError(MS_MEMERR, NULL, "msSearchTree()");
+    return (NULL);
+  }
+
+  treeCollectShapeIds(tree->root, aoi, status);
+
+  return (status);
+}
+
+static int treeNodeTrim(treeNodeObj *node) {
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*      Trim subtrees, and free subnodes that come back empty.          */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (treeNodeTrim(node->subnode[i])) {
+      destroyTreeNode(node->subnode[i]);
+      node->subnode[i] = node->subnode[node->numsubnodes - 1];
+      node->numsubnodes--;
+      i--; /* process the new occupant of this subnode entry */
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If the current node has 1 subnode and no shapes, promote that   */
+  /*      subnode to the current node position.                           */
+  /* -------------------------------------------------------------------- */
+  if (node->numsubnodes == 1 && node->numshapes == 0) {
+    treeNodeObj *psSubNode = node->subnode[0];
+
+    memcpy(&node->rect, &psSubNode->rect, sizeof(psSubNode->rect));
+    node->numshapes = psSubNode->numshapes;
+    assert(node->ids == NULL);
+    node->ids = psSubNode->ids;
+    node->numsubnodes = psSubNode->numsubnodes;
+    for (i = 0; i < psSubNode->numsubnodes; i++)
+      node->subnode[i] = psSubNode->subnode[i];
+    free(psSubNode);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      We should be trimmed if we have no subnodes, and no shapes.     */
+  /* -------------------------------------------------------------------- */
+
+  return (node->numsubnodes == 0 && node->numshapes == 0);
+}
+
+void msTreeTrim(treeObj *tree) { treeNodeTrim(tree->root); }
+
+static void searchDiskTreeNode(SHPTreeHandle disktree, rectObj aoi,
+                               ms_bitarray status) {
+  int i;
+  ms_int32 offset;
+  ms_int32 numshapes, numsubnodes;
+  rectObj rect;
+
+  int *ids = NULL;
+
+  if (fread(&offset, 4, 1, disktree->fp) != 1)
+    goto error;
+  if (disktree->needswap)
+    SwapWord(4, &offset);
+
+  if (fread(&rect, sizeof(rectObj), 1, disktree->fp) != 1)
+    goto error;
+  if (disktree->needswap)
+    SwapWord(8, &rect.minx);
+  if (disktree->needswap)
+    SwapWord(8, &rect.miny);
+  if (disktree->needswap)
+    SwapWord(8, &rect.maxx);
+  if (disktree->needswap)
+    SwapWord(8, &rect.maxy);
+
+  if (fread(&numshapes, 4, 1, disktree->fp) != 1)
+    goto error;
+  if (disktree->needswap)
+    SwapWord(4, &numshapes);
+  if (numshapes < 0 || numshapes > INT_MAX / 4)
+    goto error;
+
+  if (!msRectOverlap(&rect, &aoi)) { /* skip rest of this node and sub-nodes */
+    offset += numshapes * sizeof(ms_int32) + sizeof(ms_int32);
+    if (fseek(disktree->fp, offset, SEEK_CUR) < 0)
+      goto error;
+    return;
+  }
+  if (numshapes > 0) {
+    ids = (int *)msSmallMalloc(numshapes * sizeof(ms_int32));
+
+    if (fread(ids, numshapes * sizeof(ms_int32), 1, disktree->fp) != 1)
+      goto error;
+    if (disktree->needswap) {
+      for (i = 0; i < numshapes; i++) {
+        SwapWord(4, &ids[i]);
+        msSetBit(status, ids[i], 1);
+      }
+    } else {
+      for (i = 0; i < numshapes; i++)
+        msSetBit(status, ids[i], 1);
+    }
+    free(ids);
+    ids = NULL;
+  }
+
+  if (fread(&numsubnodes, 4, 1, disktree->fp) != 1)
+    goto error;
+  if (disktree->needswap)
+    SwapWord(4, &numsubnodes);
+  if (numsubnodes < 0 || numsubnodes > INT_MAX / 4)
+    goto error;
+
+  for (i = 0; i < numsubnodes; i++)
+    searchDiskTreeNode(disktree, aoi, status);
+
+  return;
+
+error:
+  msSetError(MS_IOERR, NULL, "searchDiskTreeNode()");
+  free(ids);
+  return;
+}
+
+ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi, int debug,
+                             int numshapes) {
+  SHPTreeHandle disktree;
+  ms_bitarray status = NULL;
+
+  disktree = msSHPDiskTreeOpen(filename, debug);
+  if (!disktree) {
+
+    /* only set this error IF debugging is turned on, gets annoying otherwise */
+    if (debug)
+      msSetError(
+          MS_NOTFOUND,
+          "Unable to open spatial index for %s. In most cases you can safely "
+          "ignore this message, otherwise check file names and permissions.",
+          "msSearchDiskTree()", filename);
+
+    return (NULL);
+  }
+
+  if (disktree->nShapes != numshapes) {
+    msSetError(MS_SHPERR, "The spatial index file %s is corrupt.",
+               "msSearchDiskTree()", filename);
+    msSHPDiskTreeClose(disktree);
+    return (NULL);
+  }
+
+  status = msAllocBitArray(disktree->nShapes);
+  if (!status) {
+    msSetError(MS_MEMERR, NULL, "msSearchDiskTree()");
+    msSHPDiskTreeClose(disktree);
+    return (NULL);
+  }
+
+  searchDiskTreeNode(disktree, aoi, status);
+
+  msSHPDiskTreeClose(disktree);
+  return (status);
+}
+
+treeNodeObj *readTreeNode(SHPTreeHandle disktree) {
+  int i, res;
+  ms_int32 offset;
+  treeNodeObj *node;
+
+  node = (treeNodeObj *)msSmallMalloc(sizeof(treeNodeObj));
+  node->ids = NULL;
+
+  res = fread(&offset, 4, 1, disktree->fp);
+  if (!res) {
+    free(node);
+    return NULL;
+  }
+
+  if (disktree->needswap)
+    SwapWord(4, &offset);
+
+  res = fread(&node->rect, sizeof(rectObj), 1, disktree->fp);
+  if (!res) {
+    free(node);
+    return NULL;
+  }
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.minx);
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.miny);
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.maxx);
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.maxy);
+
+  res = fread(&node->numshapes, 4, 1, disktree->fp);
+  if (!res) {
+    free(node);
+    return NULL;
+  }
+  if (disktree->needswap)
+    SwapWord(4, &node->numshapes);
+  if (node->numshapes < 0 || node->numshapes > INT_MAX / 4) {
+    free(node);
+    return NULL;
+  }
+  if (node->numshapes > 0) {
+    node->ids = (ms_int32 *)msSmallMalloc(sizeof(ms_int32) * node->numshapes);
+    res = fread(node->ids, node->numshapes * 4, 1, disktree->fp);
+    if (!res) {
+      free(node->ids);
+      free(node);
+      return NULL;
+    }
+  }
+  for (i = 0; i < node->numshapes; i++) {
+    if (disktree->needswap)
+      SwapWord(4, &node->ids[i]);
+  }
+
+  res = fread(&node->numsubnodes, 4, 1, disktree->fp);
+  if (!res) {
+    free(node->ids);
+    free(node);
+    return NULL;
+  }
+  if (disktree->needswap)
+    SwapWord(4, &node->numsubnodes);
+
+  return node;
+}
+
+treeObj *msReadTree(char *filename, int debug) {
+  treeObj *tree = NULL;
+  SHPTreeHandle disktree;
+
+  disktree = msSHPDiskTreeOpen(filename, debug);
+  if (!disktree) {
+    msSetError(MS_IOERR, NULL, "msReadTree()");
+    return (NULL);
+  }
+
+  tree = (treeObj *)malloc(sizeof(treeObj));
+  MS_CHECK_ALLOC(tree, sizeof(treeObj), NULL);
+
+  tree->numshapes = disktree->nShapes;
+  tree->maxdepth = disktree->nDepth;
+
+  tree->root = readTreeNode(disktree);
+
+  msSHPDiskTreeClose(disktree);
+
+  return (tree);
+}
+
+static ms_int32 getSubNodeOffset(treeNodeObj *node) {
+  int i;
+  ms_int32 offset = 0;
+
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i]) {
+      offset +=
+          sizeof(rectObj) + (node->subnode[i]->numshapes + 3) * sizeof(int);
+      offset += getSubNodeOffset(node->subnode[i]);
+    }
+  }
+
+  /* offset is the disk offset in the index file on disk       */
+  /*   that format is (per node)                               */
+  /*      int       offset      4 bytes           */
+  /*      rectObj   rect      4 * 8 bytes         */
+  /*    int   numShapes   4 bytes           */
+  /*    int   ids[numShapes]  4 * numShapes bytes     */
+  /*    int   numSubNodes   4 bytes           */
+  /*                                               */
+
+  return (offset);
+}
+
+static void writeTreeNode(SHPTreeHandle disktree, treeNodeObj *node) {
+  int i, j;
+  ms_int32 offset;
+  char *pabyRec = NULL;
+
+  offset = getSubNodeOffset(node);
+
+  pabyRec = msSmallMalloc(sizeof(rectObj) + (3 * sizeof(ms_int32)) +
+                          (node->numshapes * sizeof(ms_int32)));
+
+  memcpy(pabyRec, &offset, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyRec);
+
+  memcpy(pabyRec + 4, &node->rect, sizeof(rectObj));
+  for (i = 0; i < 4; i++)
+    if (disktree->needswap)
+      SwapWord(8, pabyRec + 4 + (8 * i));
+
+  memcpy(pabyRec + 36, &node->numshapes, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyRec + 36);
+
+  j = node->numshapes * sizeof(ms_int32);
+  memcpy(pabyRec + 40, node->ids, j);
+  for (i = 0; i < node->numshapes; i++)
+    if (disktree->needswap)
+      SwapWord(4, pabyRec + 40 + (4 * i));
+
+  memcpy(pabyRec + j + 40, &node->numsubnodes, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyRec + 40 + j);
+
+  fwrite(pabyRec, 44 + j, 1, disktree->fp);
+  free(pabyRec);
+
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i])
+      writeTreeNode(disktree, node->subnode[i]);
+  }
+
+  return;
+}
+
+int msWriteTree(treeObj *tree, char *filename, int B_order) {
+  char signature[3] = "SQT";
+  char version = 1;
+  char reserved[3] = {0, 0, 0};
+  SHPTreeHandle disktree;
+  int i;
+  char mtBigEndian;
+  char pabyBuf[32];
+  char *pszBasename, *pszFullname;
+
+  disktree = (SHPTreeHandle)malloc(sizeof(SHPTreeInfo));
+  MS_CHECK_ALLOC(disktree, sizeof(SHPTreeInfo), MS_FALSE);
+
+  /* -------------------------------------------------------------------- */
+  /*  Compute the base (layer) name.  If there is any extension     */
+  /*  on the passed in filename we will strip it off.         */
+  /* -------------------------------------------------------------------- */
+  pszBasename = (char *)msSmallMalloc(strlen(filename) + 5);
+  strcpy(pszBasename, filename);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
+
+  if (pszBasename[i] == '.')
+    pszBasename[i] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*  Open the .shp and .shx files.  Note that files pulled from      */
+  /*  a PC to Unix with upper case filenames won't work!        */
+  /* -------------------------------------------------------------------- */
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
+  disktree->fp = fopen(pszFullname, "wb");
+
+  msFree(pszBasename); /* not needed */
+  msFree(pszFullname);
+
+  if (!disktree->fp) {
+    msFree(disktree);
+    msSetError(MS_IOERR, NULL, "msWriteTree()");
+    return (MS_FALSE);
+  }
+
+  /* for efficiency, trim the tree */
+  msTreeTrim(tree);
+
+  /* -------------------------------------------------------------------- */
+  /*  Establish the byte order on this machine.         */
+  /* -------------------------------------------------------------------- */
+  i = 1;
+  /* cppcheck-suppress knownConditionTrueFalse */
+  if (*((uchar *)&i) == 1)
+    mtBigEndian = MS_FALSE;
+  else
+    mtBigEndian = MS_TRUE;
+
+  if (!(mtBigEndian ^ (B_order == MS_LSB_ORDER || B_order == MS_NEW_LSB_ORDER)))
+    disktree->needswap = 1;
+  else
+    disktree->needswap = 0;
+
+  if (B_order == MS_NATIVE_ORDER)
+    disktree->needswap = 0;
+
+  /* write the header */
+  if (B_order > 0) {
+    memcpy(pabyBuf, &signature, 3);
+    memcpy(&disktree->signature, &signature, 3);
+    pabyBuf[3] = B_order;
+
+    memcpy(pabyBuf + 4, &version, 1);
+    memcpy(pabyBuf + 5, &reserved, 3);
+
+    memcpy(&disktree->version, &version, 1);
+    memcpy(&disktree->flags, &reserved, 3);
+
+    fwrite(pabyBuf, 8, 1, disktree->fp);
+  }
+
+  memcpy(pabyBuf, &tree->numshapes, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyBuf);
+
+  memcpy(pabyBuf + 4, &tree->maxdepth, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyBuf + 4);
+
+  i = fwrite(pabyBuf, 8, 1, disktree->fp);
+  if (!i) {
+    fprintf(stderr, "unable to write to index file ... exiting \n");
+    msSHPDiskTreeClose(disktree);
+    return (MS_FALSE);
+  }
+
+  writeTreeNode(disktree, tree->root);
+
+  msSHPDiskTreeClose(disktree);
+
+  return (MS_TRUE);
+}
+
+/* Function to filter search results further against feature bboxes */
+void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status,
+                        rectObj search_rect) {
+  int i;
+  rectObj shape_rect;
+
+  i = msGetNextBit(status, 0, shp->numshapes);
+  while (i >= 0) {
+    if (msSHPReadBounds(shp->hSHP, i, &shape_rect) == MS_SUCCESS) {
+      if (msRectOverlap(&shape_rect, &search_rect) != MS_TRUE) {
+        msSetBit(status, i, 0);
+      }
+    }
+    i = msGetNextBit(status, i + 1, shp->numshapes);
+  }
+}
diff -pruN 8.0.1-5/src/maptree.h 8.2.0~beta1-1~exp1/src/maptree.h
--- 8.0.1-5/src/maptree.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maptree.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,99 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  .qix spatial index declarations.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPTREE_H
+#define MAPTREE_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/* this can be 2 or 4 for binary or quad tree */
+#define MAX_SUBNODES 4
+
+typedef struct shape_tree_node {
+  /* area covered by this node */
+  rectObj rect;
+
+  /* list of shapes stored at this node. */
+  ms_int32 numshapes;
+  ms_int32 *ids;
+
+  int numsubnodes;
+  struct shape_tree_node *subnode[MAX_SUBNODES];
+} treeNodeObj;
+
+typedef struct {
+  ms_int32 numshapes;
+  ms_int32 maxdepth;
+  treeNodeObj *root;
+} treeObj;
+
+typedef struct {
+  FILE *fp;
+  char signature[3];
+  char LSB_order;
+  char needswap;
+  char version;
+  char flags[3];
+
+  ms_int32 nShapes;
+  ms_int32 nDepth;
+} SHPTreeInfo;
+typedef SHPTreeInfo *SHPTreeHandle;
+
+#define MS_LSB_ORDER -1
+#define MS_MSB_ORDER -2
+#define MS_NATIVE_ORDER 0
+#define MS_NEW_LSB_ORDER 1
+#define MS_NEW_MSB_ORDER 2
+
+MS_DLL_EXPORT SHPTreeHandle msSHPDiskTreeOpen(const char *pszTree, int debug);
+MS_DLL_EXPORT void msSHPDiskTreeClose(SHPTreeHandle disktree);
+MS_DLL_EXPORT treeNodeObj *readTreeNode(SHPTreeHandle disktree);
+
+MS_DLL_EXPORT treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth);
+MS_DLL_EXPORT void msTreeTrim(treeObj *tree);
+MS_DLL_EXPORT void msDestroyTree(treeObj *tree);
+
+MS_DLL_EXPORT ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi);
+MS_DLL_EXPORT ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi,
+                                           int debug, int numshapes);
+
+MS_DLL_EXPORT treeObj *msReadTree(char *filename, int debug);
+MS_DLL_EXPORT int msWriteTree(treeObj *tree, char *filename, int LSB_order);
+
+MS_DLL_EXPORT void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status,
+                                      rectObj search_rect);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAPTREE_H */
diff -pruN 8.0.1-5/src/mapunion.cpp 8.2.0~beta1-1~exp1/src/mapunion.cpp
--- 8.0.1-5/src/mapunion.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapunion.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,746 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of the union layer data provider (RFC-68).
+ * Author:   Tamas Szekeres (szekerest@gmail.com).
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#define _CRT_SECURE_NO_WARNINGS 1
+
+/* $Id$ */
+#include <assert.h>
+#include "mapserver.h"
+
+#define MSUNION_NUMITEMS 3
+#define MSUNION_SOURCELAYERNAME "Union_SourceLayerName"
+#define MSUNION_SOURCELAYERNAMEINDEX -100
+#define MSUNION_SOURCELAYERGROUP "Union_SourceLayerGroup"
+#define MSUNION_SOURCELAYERGROUPINDEX -101
+#define MSUNION_SOURCELAYERVISIBLE "Union_SourceLayerVisible"
+#define MSUNION_SOURCELAYERVISIBLEINDEX -102
+
+typedef struct {
+  int layerIndex;   /* current source layer index */
+  int classIndex;   /* current class index */
+  char *classText;  /* current class text (autostyle) */
+  int layerCount;   /* number of the source layers */
+  layerObj *layers; /* structure to the source layers */
+  int *status;      /* the layer status */
+  int *classgroup;  /* current array of the valid classes */
+  int nclasses;     /* number of the valid classes */
+  reprojectionObj *reprojectorSrcLayerToLayer;
+  int reprojectorCurSrcLayer;
+} msUnionLayerInfo;
+
+/* Close the the combined layer */
+int msUnionLayerClose(layerObj *const layer) {
+  int i;
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo)
+    return MS_SUCCESS;
+
+  if (!layer->map)
+    return MS_FAILURE;
+
+  msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
+  for (i = 0; i < layerinfo->layerCount; i++) {
+    layerObj *const srclayer = &layerinfo->layers[i];
+    msLayerClose(srclayer);
+    freeLayer(srclayer);
+  }
+  msFree(layerinfo->layers);
+  msFree(layerinfo->status);
+  msFree(layerinfo->classgroup);
+  msFree(layerinfo->classText);
+  msFree(layerinfo);
+  layer->layerinfo = NULL;
+
+  return MS_SUCCESS;
+}
+
+int isScaleInRange(mapObj *map, layerObj *const layer) {
+  if (map->scaledenom > 0) {
+    int i;
+    /* layer scale boundaries should be checked first */
+    if ((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom))
+      return MS_FALSE;
+
+    if ((layer->minscaledenom > 0) && (map->scaledenom <= layer->minscaledenom))
+      return MS_FALSE;
+
+    /* now check class scale boundaries (all layers *must* pass these tests) */
+    if (layer->numclasses > 0) {
+      for (i = 0; i < layer->numclasses; i++) {
+        if ((layer->_class[i]->maxscaledenom > 0) &&
+            (map->scaledenom > layer->_class[i]->maxscaledenom))
+          continue; /* can skip this one, next class */
+        if ((layer->_class[i]->minscaledenom > 0) &&
+            (map->scaledenom <= layer->_class[i]->minscaledenom))
+          continue; /* can skip this one, next class */
+
+        break; /* can't skip this class (or layer for that matter) */
+      }
+      if (i == layer->numclasses)
+        return MS_FALSE;
+    }
+
+    if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
+      if ((layer->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth))
+        return MS_FALSE;
+
+      if ((layer->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < layer->mingeowidth))
+        return MS_FALSE;
+    }
+  }
+  return MS_TRUE;
+}
+
+int msUnionLayerOpen(layerObj *const layer) {
+  if (layer->layerinfo != NULL) {
+    return MS_SUCCESS; /* Nothing to do... layer is already opened */
+  }
+
+  if (!layer->connection) {
+    msSetError(MS_MISCERR,
+               "The CONNECTION option is not specified for layer: %s",
+               "msUnionLayerOpen()", layer->name);
+    return MS_FAILURE;
+  }
+
+  if (!layer->map) {
+    msSetError(MS_MISCERR, "No map assigned to this layer: %s",
+               "msUnionLayerOpen()", layer->name);
+    return MS_FAILURE;
+  }
+
+  mapObj *map = layer->map;
+
+  msUnionLayerInfo *layerinfo =
+      (msUnionLayerInfo *)calloc(1, sizeof(msUnionLayerInfo));
+  MS_CHECK_ALLOC(layerinfo, sizeof(msUnionLayerInfo), MS_FAILURE);
+
+  layer->layerinfo = layerinfo;
+  layerinfo->layerIndex = 0;
+
+  layerinfo->classgroup = NULL;
+  layerinfo->nclasses = 0;
+
+  layerinfo->layerCount = 0;
+
+  layerinfo->classText = NULL;
+  layerinfo->reprojectorCurSrcLayer = -1;
+
+  const char *pkey = msLayerGetProcessingKey(layer, "UNION_STATUS_CHECK");
+  const bool status_check = (pkey && strcasecmp(pkey, "true") == 0);
+
+  pkey = msLayerGetProcessingKey(layer, "UNION_SCALE_CHECK");
+  const bool scale_check = !(pkey && strcasecmp(pkey, "false") == 0);
+
+  pkey = msLayerGetProcessingKey(layer, "UNION_SRCLAYER_CLOSE_CONNECTION");
+
+  const auto layerNames = msStringSplit(layer->connection, ',');
+
+  if (layerNames.empty()) {
+    msSetError(MS_MISCERR, "No source layers specified in layer: %s",
+               "msUnionLayerOpen()", layer->name);
+    msUnionLayerClose(layer);
+    return MS_FAILURE;
+  }
+
+  const int layerCount = static_cast<int>(layerNames.size());
+  layerinfo->layers = (layerObj *)malloc(layerCount * sizeof(layerObj));
+  MS_CHECK_ALLOC(layerinfo->layers, layerCount * sizeof(layerObj), MS_FAILURE);
+
+  layerinfo->status = (int *)malloc(layerCount * sizeof(int));
+  MS_CHECK_ALLOC(layerinfo->status, layerCount * sizeof(int), MS_FAILURE);
+
+  for (int i = 0; i < layerCount; i++) {
+    const char *layerName = layerNames[i].c_str();
+    const int layerindex = msGetLayerIndex(map, layerName);
+    if (layerindex >= 0 && layerindex < map->numlayers) {
+      const layerObj *const srclayer = map->layers[layerindex];
+
+      if (srclayer->type != layer->type) {
+        msSetError(MS_MISCERR,
+                   "The type of the source layer doesn't match with the union "
+                   "layer: %s",
+                   "msUnionLayerOpen()", srclayer->name);
+        msUnionLayerClose(layer);
+        return MS_FAILURE;
+      }
+
+      /* we need to create a new layer in order make the single pass query to
+       * work */
+      layerObj *dstlayer = &layerinfo->layers[i];
+      if (initLayer(dstlayer, map) == -1) {
+        msSetError(MS_MISCERR, "Cannot initialize source layer: %s",
+                   "msUnionLayerOpen()", srclayer->name);
+        msUnionLayerClose(layer);
+        return MS_FAILURE;
+      }
+
+      ++layerinfo->layerCount;
+
+      if (msCopyLayer(dstlayer, srclayer) != MS_SUCCESS) {
+        msSetError(MS_MISCERR, "Cannot copy source layer: %s",
+                   "msUnionLayerOpen()", srclayer->name);
+        msUnionLayerClose(layer);
+        return MS_FAILURE;
+      }
+
+      if (pkey) {
+        /* override connection flag */
+        msLayerSetProcessingKey(dstlayer, "CLOSE_CONNECTION", pkey);
+      }
+
+      /* check is we should skip this source (status check) */
+      if (status_check && dstlayer->status == MS_OFF) {
+        layerinfo->status[i] = MS_DONE;
+        continue;
+      }
+
+      /* check is we should skip this source (scale check) */
+      if (scale_check && isScaleInRange(map, dstlayer) == MS_FALSE) {
+        layerinfo->status[i] = MS_DONE;
+        continue;
+      }
+
+      layerinfo->status[i] = msLayerOpen(dstlayer);
+      if (layerinfo->status[i] != MS_SUCCESS) {
+        msUnionLayerClose(layer);
+        return MS_FAILURE;
+      }
+    } else {
+      msSetError(MS_MISCERR, "Invalid layer: %s", "msUnionLayerOpen()",
+                 layerName);
+      msUnionLayerClose(layer);
+      return MS_FAILURE;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
+int msUnionLayerIsOpen(layerObj *const layer) {
+  if (layer->layerinfo)
+    return (MS_TRUE);
+  else
+    return (MS_FALSE);
+}
+
+/* Free the itemindexes array in a layer. */
+void msUnionLayerFreeItemInfo(layerObj *const layer) {
+  int i;
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo || !layer->map)
+    return;
+
+  msFree(layer->iteminfo);
+
+  layer->iteminfo = NULL;
+
+  for (i = 0; i < layerinfo->layerCount; i++) {
+    msLayerFreeItemInfo(&(layerinfo->layers[i]));
+    if (layerinfo->layers[i].items) {
+      /* need to remove the source layer items */
+      msFreeCharArray(layerinfo->layers[i].items,
+                      layerinfo->layers[i].numitems);
+      layerinfo->layers[i].items = NULL;
+      layerinfo->layers[i].numitems = 0;
+    }
+  }
+}
+
+/* clean up expression tokens */
+void msUnionLayerFreeExpressionTokens(layerObj *const layer) {
+  int i, j;
+  msFreeExpressionTokens(&(layer->filter));
+  msFreeExpressionTokens(&(layer->cluster.group));
+  msFreeExpressionTokens(&(layer->cluster.filter));
+  for (i = 0; i < layer->numclasses; i++) {
+    msFreeExpressionTokens(&(layer->_class[i]->expression));
+    msFreeExpressionTokens(&(layer->_class[i]->text));
+    for (j = 0; j < layer->_class[i]->numstyles; j++)
+      msFreeExpressionTokens(&(layer->_class[i]->styles[j]->_geomtransform));
+  }
+}
+
+/* allocate the iteminfo index array - same order as the item list */
+int msUnionLayerInitItemInfo(layerObj *const layer) {
+  int i, numitems;
+  int *itemindexes;
+  char *itemlist = NULL;
+
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (layer->numitems == 0) {
+    return MS_SUCCESS;
+  }
+
+  if (!layerinfo || !layer->map)
+    return MS_FAILURE;
+
+  /* Cleanup any previous item selection */
+  msUnionLayerFreeItemInfo(layer);
+
+  layer->iteminfo = (int *)malloc(sizeof(int) * layer->numitems);
+  MS_CHECK_ALLOC(layer->iteminfo, sizeof(int) * layer->numitems, MS_FAILURE);
+
+  itemindexes = (int *)layer->iteminfo;
+
+  /* check whether we require attributes from the source layers also */
+  numitems = 0;
+  for (i = 0; i < layer->numitems; i++) {
+    if (EQUAL(layer->items[i], MSUNION_SOURCELAYERNAME))
+      itemindexes[i] = MSUNION_SOURCELAYERNAMEINDEX;
+    else if (EQUAL(layer->items[i], MSUNION_SOURCELAYERGROUP))
+      itemindexes[i] = MSUNION_SOURCELAYERGROUPINDEX;
+    else if (EQUAL(layer->items[i], MSUNION_SOURCELAYERVISIBLE))
+      itemindexes[i] = MSUNION_SOURCELAYERVISIBLEINDEX;
+    else {
+      itemindexes[i] = numitems++;
+      if (itemlist) {
+        itemlist = msStringConcatenate(itemlist, ",");
+        itemlist = msStringConcatenate(itemlist, layer->items[i]);
+      } else {
+        itemlist = msStrdup(layer->items[i]);
+      }
+    }
+  }
+
+  for (i = 0; i < layerinfo->layerCount; i++) {
+    layerObj *const srclayer = &(layerinfo->layers[i]);
+
+    if (layerinfo->status[i] != MS_SUCCESS)
+      continue; /* skip empty layers */
+
+    msUnionLayerFreeExpressionTokens(srclayer);
+
+    if (itemlist) {
+      /* get items requested by the union layer plus the required items */
+      msLayerSetProcessingKey(srclayer, "ITEMS", itemlist);
+      if (msLayerWhichItems(srclayer, MS_TRUE, NULL) != MS_SUCCESS) {
+        msFree(itemlist);
+        return MS_FAILURE;
+      }
+    } else {
+      /* get only the required items */
+      if (msLayerWhichItems(srclayer, MS_FALSE, NULL) != MS_SUCCESS)
+        return MS_FAILURE;
+    }
+  }
+
+  msFree(itemlist);
+  return MS_SUCCESS;
+}
+
+// cppcheck-suppress passedByValue
+int msUnionLayerWhichShapes(layerObj *const layer, rectObj rect, int isQuery) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo || !layer->map)
+    return MS_FAILURE;
+
+  for (int i = 0; i < layerinfo->layerCount; i++) {
+    layerObj *const srclayer = &layerinfo->layers[i];
+
+    if (layerinfo->status[i] != MS_SUCCESS)
+      continue; /* skip empty layers */
+
+    if (layer->styleitem && layer->numitems == 0) {
+      /* need to initialize items */
+      msUnionLayerFreeExpressionTokens(srclayer);
+
+      /* get only the required items */
+      if (msLayerWhichItems(srclayer, MS_FALSE, NULL) != MS_SUCCESS)
+        return MS_FAILURE;
+    }
+
+    rectObj srcRect = rect;
+
+    if (srclayer->transform == MS_TRUE && srclayer->project &&
+        layer->transform == MS_TRUE && layer->project &&
+        msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
+      msProjectRect(&layer->projection, &srclayer->projection,
+                    &srcRect); /* project the searchrect to source coords */
+
+    layerinfo->status[i] = msLayerWhichShapes(srclayer, srcRect, isQuery);
+    if (layerinfo->status[i] == MS_FAILURE)
+      return MS_FAILURE;
+  }
+
+  layerinfo->layerIndex = 0;
+  layerObj *const srclayer = &layerinfo->layers[0];
+
+  msFree(layerinfo->classgroup);
+
+  layerinfo->classgroup = NULL;
+  layerinfo->nclasses = 0;
+
+  if (srclayer->classgroup && srclayer->numclasses > 0)
+    layerinfo->classgroup =
+        msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
+
+  return MS_SUCCESS;
+}
+
+static int BuildFeatureAttributes(layerObj *const layer,
+                                  const layerObj *srclayer, shapeObj *shape) {
+  const int *const itemindexes = static_cast<const int *>(layer->iteminfo);
+
+  char **values =
+      static_cast<char **>(msSmallMalloc(sizeof(char *) * (layer->numitems)));
+  MS_CHECK_ALLOC(values, layer->numitems * sizeof(char *), MS_FAILURE);
+  ;
+
+  for (int i = 0; i < layer->numitems; i++) {
+    if (itemindexes[i] == MSUNION_SOURCELAYERNAMEINDEX)
+      values[i] = msStrdup(srclayer->name);
+    else if (itemindexes[i] == MSUNION_SOURCELAYERGROUPINDEX)
+      values[i] = msStrdup(srclayer->group);
+    else if (itemindexes[i] == MSUNION_SOURCELAYERVISIBLEINDEX) {
+      if (srclayer->status == MS_OFF)
+        values[i] = msStrdup("0");
+      else
+        values[i] = msStrdup("1");
+    } else if (shape->values[itemindexes[i]])
+      values[i] = msStrdup(shape->values[itemindexes[i]]);
+    else
+      values[i] = msStrdup("");
+  }
+
+  if (shape->values)
+    msFreeCharArray(shape->values, shape->numvalues);
+
+  shape->values = values;
+  shape->numvalues = layer->numitems;
+
+  return MS_SUCCESS;
+}
+
+/* find the next shape with the appropriate shape type */
+/* also, load in the attribute data */
+/* MS_DONE => no more data */
+int msUnionLayerNextShape(layerObj *const layer, shapeObj *shape) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo || !layer->map)
+    return MS_FAILURE;
+
+  if (layerinfo->layerIndex < 0 ||
+      layerinfo->layerIndex >= layerinfo->layerCount)
+    return MS_FAILURE;
+
+  int rv = MS_DONE;
+
+  while (layerinfo->layerIndex < layerinfo->layerCount) {
+    layerObj *srclayer = &layerinfo->layers[layerinfo->layerIndex];
+    if (layerinfo->status[layerinfo->layerIndex] == MS_SUCCESS) {
+      while ((rv = srclayer->vtable->LayerNextShape(srclayer, shape)) ==
+             MS_SUCCESS) {
+        if (layer->styleitem) {
+          /* need to retrieve the source layer classindex if styleitem AUTO is
+           * set */
+          layerinfo->classIndex =
+              msShapeGetClass(srclayer, layer->map, shape,
+                              layerinfo->classgroup, layerinfo->nclasses);
+          if (layerinfo->classIndex < 0 ||
+              layerinfo->classIndex >= srclayer->numclasses) {
+            /*  this shape is not visible, skip it */
+            msFreeShape(shape);
+            continue;
+          }
+          if (srclayer->styleitem &&
+              strcasecmp(srclayer->styleitem, "AUTO") != 0) {
+            /* Generic feature style handling as per RFC-61 */
+            msLayerGetFeatureStyle(layer->map, srclayer,
+                                   srclayer->_class[layerinfo->classIndex],
+                                   shape);
+          }
+          /* set up annotation */
+          msFree(layerinfo->classText);
+          layerinfo->classText = NULL;
+          if (srclayer->_class[layerinfo->classIndex]->numlabels > 0) {
+            /* pull text from the first label only */
+            if (msGetLabelStatus(
+                    layer->map, layer, shape,
+                    srclayer->_class[layerinfo->classIndex]->labels[0]) ==
+                MS_ON) {
+              layerinfo->classText = msShapeGetLabelAnnotation(
+                  layer, shape,
+                  srclayer->_class[layerinfo->classIndex]->labels[0]);
+            }
+          }
+        }
+
+        /* reproject to the target layer */
+        if (layerinfo->reprojectorCurSrcLayer != layerinfo->layerIndex) {
+          msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
+          layerinfo->reprojectorSrcLayerToLayer = NULL;
+          layerinfo->reprojectorCurSrcLayer = layerinfo->layerIndex;
+          if (srclayer->project && msProjectionsDiffer(&(srclayer->projection),
+                                                       &(layer->projection)))
+            layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(
+                &(srclayer->projection), &(layer->projection));
+          else
+            srclayer->project = MS_FALSE;
+        }
+        if (layerinfo->reprojectorSrcLayerToLayer)
+          msProjectShapeEx(layerinfo->reprojectorSrcLayerToLayer, shape);
+
+        /* update the layer styles with the bound values */
+        if (msBindLayerToShape(srclayer, shape, MS_FALSE) != MS_SUCCESS)
+          return MS_FAILURE;
+
+        shape->tileindex = layerinfo->layerIndex;
+
+        /* construct the item array */
+        if (layer->iteminfo)
+          rv = BuildFeatureAttributes(layer, srclayer, shape);
+
+        /* check the layer filter condition */
+        if (layer->filter.string != NULL && layer->numitems > 0 &&
+            layer->iteminfo) {
+          if (layer->filter.type == MS_EXPRESSION &&
+              layer->filter.tokens == NULL)
+            msTokenizeExpression(&(layer->filter), layer->items,
+                                 &(layer->numitems));
+
+          if (!msEvalExpression(layer, shape, &(layer->filter),
+                                layer->filteritemindex)) {
+            /* this shape is filtered */
+            msFreeShape(shape);
+            continue;
+          }
+        }
+
+        return rv;
+      }
+    }
+
+    ++layerinfo->layerIndex;
+    if (layerinfo->layerIndex == layerinfo->layerCount) {
+      layerinfo->layerIndex = 0;
+      return MS_DONE;
+    }
+
+    /* allocate the classgroups for the next layer */
+    msFree(layerinfo->classgroup);
+
+    layerinfo->classgroup = NULL;
+    layerinfo->nclasses = 0;
+
+    if (srclayer->classgroup && srclayer->numclasses > 0)
+      layerinfo->classgroup =
+          msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
+  }
+
+  return rv;
+}
+
+/* Random access of the feature. */
+int msUnionLayerGetShape(layerObj *const layer, shapeObj *shape,
+                         resultObj *record) {
+  const long tile = record->tileindex;
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo || !layer->map)
+    return MS_FAILURE;
+
+  if (tile < 0 || tile >= layerinfo->layerCount) {
+    msSetError(MS_MISCERR, "Invalid tile index: %s", "msUnionLayerGetShape()",
+               layer->name);
+    return MS_FAILURE;
+  }
+
+  layerObj *const srclayer = &layerinfo->layers[tile];
+  record->tileindex = 0;
+  int rv = srclayer->vtable->LayerGetShape(srclayer, shape, record);
+  record->tileindex = tile;
+
+  if (rv == MS_SUCCESS) {
+    /* reproject to the target layer */
+    if (layerinfo->reprojectorCurSrcLayer != tile) {
+      msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
+      layerinfo->reprojectorSrcLayerToLayer = NULL;
+      layerinfo->reprojectorCurSrcLayer = tile;
+      if (srclayer->project &&
+          msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
+        layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(
+            &(srclayer->projection), &(layer->projection));
+      else
+        srclayer->project = MS_FALSE;
+    }
+    if (layerinfo->reprojectorSrcLayerToLayer)
+      msProjectShapeEx(layerinfo->reprojectorSrcLayerToLayer, shape);
+
+    shape->tileindex = tile;
+
+    /* construct the item array */
+    if (layer->iteminfo)
+      rv = BuildFeatureAttributes(layer, srclayer, shape);
+  }
+
+  return rv;
+}
+
+/* Query for the items collection */
+int msUnionLayerGetItems(layerObj *const layer) {
+  /* we support certain built in attributes */
+  layer->numitems = 2;
+  layer->items =
+      static_cast<char **>(msSmallMalloc(sizeof(char *) * (layer->numitems)));
+  MS_CHECK_ALLOC(layer->items, layer->numitems * sizeof(char *), MS_FAILURE);
+  layer->items[0] = msStrdup(MSUNION_SOURCELAYERNAME);
+  layer->items[1] = msStrdup(MSUNION_SOURCELAYERGROUP);
+
+  return msUnionLayerInitItemInfo(layer);
+}
+
+int msUnionLayerGetNumFeatures(layerObj *const layer) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo || !layer->map)
+    return 0;
+
+  int numFeatures = 0;
+
+  for (int i = 0; i < layerinfo->layerCount; i++) {
+    if (layerinfo->status[i] != MS_SUCCESS)
+      continue; /* skip empty layers */
+
+    int c = msLayerGetNumFeatures(&(layerinfo->layers[i]));
+    if (c > 0)
+      numFeatures += c;
+  }
+
+  return numFeatures;
+}
+
+static int msUnionLayerGetAutoStyle(mapObj *map, layerObj *const layer,
+                                    classObj *c, shapeObj *shape) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
+
+  if (!layerinfo || !layer->map)
+    return MS_FAILURE;
+
+  if (shape->tileindex < 0 || shape->tileindex >= layerinfo->layerCount) {
+    msSetError(MS_MISCERR, "Invalid tile index: %s",
+               "msUnionLayerGetAutoStyle()", layer->name);
+    return MS_FAILURE;
+  }
+
+  layerObj *const srclayer = &layerinfo->layers[shape->tileindex];
+
+  if (srclayer->styleitem && strcasecmp(srclayer->styleitem, "AUTO") == 0) {
+    const int tileindex = shape->tileindex;
+    shape->tileindex = 0;
+    int rv = msLayerGetAutoStyle(map, srclayer, c, shape);
+    shape->tileindex = tileindex;
+    return rv;
+  } else {
+    const classObj *src = srclayer->_class[layerinfo->classIndex];
+    /* copy the style from the current class index */
+    /* free any previous styles on the dst layer */
+
+    resetClassStyle(c);
+
+    for (int i = 0; i < src->numstyles; i++) {
+      if (msMaybeAllocateClassStyle(c, i))
+        return MS_FAILURE;
+
+      if (msCopyStyle(c->styles[i], src->styles[i]) != MS_SUCCESS) {
+        msSetError(MS_MEMERR, "Failed to copy style.",
+                   "msUnionLayerGetAutoStyle()");
+        return MS_FAILURE;
+      }
+      /* remove the bindings on the style */
+      for (int j = 0; j < MS_STYLE_BINDING_LENGTH; j++) {
+        msFree(c->styles[i]->bindings[j].item);
+        c->styles[i]->bindings[j].item = NULL;
+      }
+      c->styles[i]->numbindings = 0;
+    }
+
+    for (int i = 0; i < src->numlabels; i++) {
+      // RFC77 TODO: allocation need to be done, but is the right way (from
+      // mapcopy.c)?
+      if (msGrowClassLabels(c) == NULL)
+        return MS_FAILURE;
+      initLabel(c->labels[i]);
+
+      if (msCopyLabel(c->labels[i], src->labels[i]) != MS_SUCCESS) {
+        msSetError(MS_MEMERR, "Failed to copy label.",
+                   "msUnionLayerGetAutoStyle()");
+        return MS_FAILURE;
+      }
+
+      /* remove the bindings on the label */
+      for (int j = 0; j < MS_LABEL_BINDING_LENGTH; j++) {
+        msFree(c->labels[i]->bindings[j].item);
+        c->labels[i]->bindings[j].item = NULL;
+      }
+      c->labels[i]->numbindings = 0;
+    }
+    c->numlabels = src->numlabels;
+
+    c->layer = layer;
+    c->text.string = layerinfo->classText;
+    layerinfo->classText = NULL;
+  }
+  return MS_SUCCESS;
+}
+
+int msUnionLayerCopyVirtualTable(layerVTableObj *vtable) {
+  vtable->LayerInitItemInfo = msUnionLayerInitItemInfo;
+  vtable->LayerFreeItemInfo = msUnionLayerFreeItemInfo;
+  vtable->LayerOpen = msUnionLayerOpen;
+  vtable->LayerIsOpen = msUnionLayerIsOpen;
+  vtable->LayerWhichShapes = msUnionLayerWhichShapes;
+  vtable->LayerNextShape = msUnionLayerNextShape;
+  vtable->LayerGetShape = msUnionLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  vtable->LayerClose = msUnionLayerClose;
+
+  vtable->LayerGetItems = msUnionLayerGetItems;
+  vtable->LayerCloseConnection = msUnionLayerClose;
+  vtable->LayerGetAutoStyle = msUnionLayerGetAutoStyle;
+
+  vtable->LayerGetNumFeatures = msUnionLayerGetNumFeatures;
+
+  return MS_SUCCESS;
+}
+
+int msUnionLayerInitializeVirtualTable(layerObj *const layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  return msUnionLayerCopyVirtualTable(layer->vtable);
+}
diff -pruN 8.0.1-5/src/maputfgrid.cpp 8.2.0~beta1-1~exp1/src/maputfgrid.cpp
--- 8.0.1-5/src/maputfgrid.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maputfgrid.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,745 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  UTFGrid rendering functions (using AGG)
+ * Author:   Francois Desjarlais
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "maputfgrid.h"
+#include "mapagg.h"
+#include "renderers/agg/include/agg_rasterizer_scanline_aa.h"
+#include "renderers/agg/include/agg_basics.h"
+#include "renderers/agg/include/agg_renderer_scanline.h"
+#include "renderers/agg/include/agg_scanline_bin.h"
+#include "renderers/agg/include/agg_gamma_functions.h"
+#include "renderers/agg/include/agg_conv_stroke.h"
+#include "renderers/agg/include/agg_ellipse.h"
+
+#include <memory>
+#include <vector>
+
+typedef mapserver::int32u band_type;
+typedef mapserver::row_ptr_cache<band_type> rendering_buffer;
+typedef pixfmt_utf<utfpix32, rendering_buffer> pixfmt_utf32;
+typedef mapserver::renderer_base<pixfmt_utf32> renderer_base;
+typedef mapserver::rasterizer_scanline_aa<> rasterizer_scanline;
+typedef mapserver::renderer_scanline_bin_solid<renderer_base> renderer_scanline;
+
+static const utfpix32 UTF_WATER = utfpix32(32);
+
+#define utfitem(c) utfpix32(c)
+
+namespace {
+
+struct shapeData {
+  std::string datavalues{};
+  std::string itemvalue{};
+  band_type utfvalue = 0;
+  int serialid = 0;
+};
+
+/*
+ * UTFGrid specific polygon adaptor.
+ */
+class polygon_adaptor_utf final : public polygon_adaptor {
+public:
+  polygon_adaptor_utf(shapeObj *shape, int utfres_in)
+      : polygon_adaptor(shape), utfresolution(utfres_in) {}
+
+  unsigned vertex(double *x, double *y) override {
+    if (m_point < m_pend) {
+      bool first = m_point == m_line->point;
+      *x = m_point->x / utfresolution;
+      *y = m_point->y / utfresolution;
+      m_point++;
+      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
+    }
+    *x = *y = 0.0;
+    if (!m_stop) {
+
+      m_line++;
+      if (m_line >= m_lend) {
+        m_stop = true;
+        return mapserver::path_cmd_end_poly;
+      }
+
+      m_point = m_line->point;
+      m_pend = &(m_line->point[m_line->numpoints]);
+      return mapserver::path_cmd_end_poly;
+    }
+    return mapserver::path_cmd_stop;
+  }
+
+private:
+  int utfresolution;
+};
+
+/*
+ * UTFGrid specific line adaptor.
+ */
+class line_adaptor_utf final : public line_adaptor {
+public:
+  line_adaptor_utf(shapeObj *shape, int utfres_in)
+      : line_adaptor(shape), utfresolution(utfres_in) {}
+
+  unsigned vertex(double *x, double *y) override {
+    if (m_point < m_pend) {
+      bool first = m_point == m_line->point;
+      *x = m_point->x / utfresolution;
+      *y = m_point->y / utfresolution;
+      m_point++;
+      return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
+    }
+    m_line++;
+    *x = *y = 0.0;
+    if (m_line >= m_lend)
+      return mapserver::path_cmd_stop;
+
+    m_point = m_line->point;
+    m_pend = &(m_line->point[m_line->numpoints]);
+
+    return vertex(x, y);
+  }
+
+private:
+  int utfresolution;
+};
+
+class UTFGridRenderer {
+public:
+  std::vector<shapeData> table{};
+  int utfresolution = 0;
+  int layerwatch = 0;
+  bool renderlayer = false;
+  bool useutfitem = false;
+  bool useutfdata = false;
+  bool duplicates = false;
+  band_type utfvalue = 0;
+  layerObj *utflayer = nullptr;
+  int width = 0;
+  int height = 0;
+  std::vector<band_type> buffer{};
+  rendering_buffer m_rendering_buffer{};
+  pixfmt_utf32 m_pixel_format{};
+  renderer_base m_renderer_base{};
+  rasterizer_scanline m_rasterizer{};
+  renderer_scanline m_renderer_scanline{};
+  mapserver::scanline_bin sl_utf{};
+  std::unique_ptr<mapserver::conv_stroke<line_adaptor_utf>> stroke{};
+};
+
+} // namespace
+
+#define UTFGRID_RENDERER(image)                                                \
+  (static_cast<UTFGridRenderer *>((image)->img.plugin))
+
+/*
+ * Encode to avoid unavailable char in the JSON
+ */
+static unsigned int encodeForRendering(unsigned int toencode) {
+  unsigned int encoded;
+  encoded = toencode + 32;
+  /* 34 => " */
+  if (encoded >= 34) {
+    encoded = encoded + 1;
+  }
+  /* 92 => \ */
+  if (encoded >= 92) {
+    encoded = encoded + 1;
+  }
+  return encoded;
+}
+
+/*
+ * Decode value to have the initial one
+ */
+static unsigned int decodeRendered(unsigned int todecode) {
+  unsigned int decoded;
+
+  if (todecode >= 92)
+    todecode--;
+
+  if (todecode >= 34)
+    todecode--;
+
+  decoded = todecode - 32;
+
+  return decoded;
+}
+
+/*
+ * Add the shapeObj UTFDATA and UTFITEM to the lookup table.
+ */
+static band_type addToTable(UTFGridRenderer *r, shapeObj *p) {
+  /* Looks for duplicates. */
+  if (r->duplicates == false && r->useutfitem) {
+    const auto itemvalue = p->values[r->utflayer->utfitemindex];
+    for (const auto &tableItem : r->table) {
+      if (tableItem.itemvalue == itemvalue) {
+        /* Found a copy of the values in the table. */
+        return tableItem.utfvalue;
+      }
+    }
+  }
+
+  /* Data added to the table */
+  shapeData table;
+  char *escaped = msEvalTextExpressionJSonEscape(&r->utflayer->utfdata, p);
+  table.datavalues = escaped ? escaped : "";
+  msFree(escaped);
+
+  /* If UTFITEM is set in the mapfile we add its value to the table */
+  if (r->useutfitem)
+    table.itemvalue = p->values[r->utflayer->utfitemindex];
+
+  table.serialid = static_cast<int>(r->table.size() + 1);
+
+  /* Simple operation so we don't have unavailable char in the JSON */
+  const auto utfvalue = encodeForRendering(table.serialid);
+  table.utfvalue = utfvalue;
+
+  r->table.emplace_back(std::move(table));
+
+  return utfvalue;
+}
+
+/*
+ * Use AGG to render any path.
+ */
+template <class vertex_source>
+static int utfgridRenderPath(imageObj *img, vertex_source &path) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+  r->m_rasterizer.reset();
+  r->m_rasterizer.filling_rule(mapserver::fill_even_odd);
+  r->m_rasterizer.add_path(path);
+  r->m_renderer_scanline.color(utfitem(r->utfvalue));
+  mapserver::render_scanlines(r->m_rasterizer, r->sl_utf,
+                              r->m_renderer_scanline);
+  return MS_SUCCESS;
+}
+
+/*
+ * Initialize the renderer, create buffer, allocate memory.
+ */
+static imageObj *utfgridCreateImage(int width, int height,
+                                    outputFormatObj *format,
+                                    colorObj * /*bg*/) {
+  auto r = std::unique_ptr<UTFGridRenderer>(new UTFGridRenderer);
+
+  r->utfresolution =
+      atof(msGetOutputFormatOption(format, "UTFRESOLUTION", "4"));
+  if (r->utfresolution < 1) {
+    msSetError(MS_MISCERR, "UTFRESOLUTION smaller that 1 in the mapfile.",
+               "utfgridCreateImage()");
+    return nullptr;
+  }
+  r->duplicates =
+      EQUAL("true", msGetOutputFormatOption(format, "DUPLICATES", "true"));
+
+  r->width = width / r->utfresolution;
+  r->height = height / r->utfresolution;
+
+  r->buffer.resize(static_cast<size_t>(r->width) * r->height);
+
+  /* AGG specific operations */
+  r->m_rendering_buffer.attach(&r->buffer[0], r->width, r->height, r->width);
+  r->m_pixel_format.attach(r->m_rendering_buffer);
+  r->m_renderer_base.attach(r->m_pixel_format);
+  r->m_renderer_scanline.attach(r->m_renderer_base);
+  r->m_renderer_base.clear(UTF_WATER);
+  r->m_rasterizer.gamma(mapserver::gamma_none());
+
+  imageObj *image = (imageObj *)msSmallCalloc(1, sizeof(imageObj));
+  image->img.plugin = r.release();
+
+  return image;
+}
+
+/*
+ * Free all the memory used by the renderer.
+ */
+static int utfgridFreeImage(imageObj *img) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+  delete r;
+
+  img->img.plugin = NULL;
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Update a character in the utfgrid.
+ */
+static int utfgridUpdateChar(imageObj *img, band_type oldChar,
+                             band_type newChar) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  for (auto &ch : r->buffer) {
+    if (ch == oldChar) {
+      ch = newChar;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Remove unnecessary data that didn't made it to the final grid.
+ */
+static int utfgridCleanData(imageObj *img) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  std::vector<bool> usedChar;
+  usedChar.resize(r->table.size());
+
+  int itemFound = 0;
+
+  for (const auto ch : r->buffer) {
+    const auto rendered = decodeRendered(ch);
+    if (rendered != 0 && !usedChar[rendered - 1]) {
+      itemFound++;
+      usedChar[rendered - 1] = true;
+    }
+  }
+
+  std::vector<shapeData> updatedData;
+  updatedData.reserve(itemFound);
+
+  for (const auto &tableItem : r->table) {
+    if (usedChar[decodeRendered(tableItem.utfvalue) - 1]) {
+      updatedData.emplace_back(tableItem);
+      auto &newData = updatedData.back();
+
+      newData.serialid = static_cast<int>(updatedData.size());
+
+      const band_type utfvalue = encodeForRendering(newData.serialid);
+
+      utfgridUpdateChar(img, newData.utfvalue, utfvalue);
+      newData.utfvalue = utfvalue;
+    }
+  }
+
+  r->table = std::move(updatedData);
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Print the renderer data as JSON.
+ */
+static int utfgridSaveImage(imageObj *img, mapObj * /*map*/, FILE *fp,
+                            outputFormatObj * /*format*/) {
+  utfgridCleanData(img);
+
+  const UTFGridRenderer *renderer = UTFGRID_RENDERER(img);
+
+  if (renderer->layerwatch > 1)
+    return MS_FAILURE;
+
+  const int imgheight = renderer->height;
+  const int imgwidth = renderer->width;
+
+  msIO_fprintf(fp, "{\"grid\":[");
+
+  /* Print the buffer */
+  std::vector<wchar_t> string;
+  string.resize(imgwidth + 1);
+  for (int row = 0; row < imgheight; row++) {
+
+    /* Need a comma between each line but JSON must not start with a comma. */
+    if (row != 0)
+      msIO_fprintf(fp, ",");
+    msIO_fprintf(fp, "\"");
+    for (int col = 0; col < imgwidth; col++) {
+      /* Get the data from buffer. */
+      band_type pixelid = renderer->buffer[(row * imgwidth) + col];
+      string[col] = pixelid;
+    }
+
+    /* Conversion to UTF-8 encoding */
+#if defined(_WIN32) && !defined(__CYGWIN__)
+    const char *encoding = "UCS-2LE";
+#else
+    const char *encoding = "UCS-4LE";
+#endif
+
+    char *utf8 = msConvertWideStringToUTF8(string.data(), encoding);
+    msIO_fprintf(fp, "%s", utf8);
+    msFree(utf8);
+    msIO_fprintf(fp, "\"");
+  }
+
+  msIO_fprintf(fp, "],\"keys\":[\"\"");
+
+  /* Print the specified key */
+  for (const auto &table : renderer->table) {
+    msIO_fprintf(fp, ",");
+
+    if (renderer->useutfitem) {
+      char *pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
+      msIO_fprintf(fp, "\"%s\"", pszEscaped);
+      msFree(pszEscaped);
+    }
+    /* If no UTFITEM specified use the serial ID as the key */
+    else
+      msIO_fprintf(fp, "\"%i\"", table.serialid);
+  }
+
+  msIO_fprintf(fp, "],\"data\":{");
+
+  /* Print the data */
+  if (renderer->useutfdata) {
+    bool first = true;
+    for (const auto &table : renderer->table) {
+      if (!first)
+        msIO_fprintf(fp, ",");
+      first = false;
+
+      if (renderer->useutfitem) {
+        char *pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
+        msIO_fprintf(fp, "\"%s\":", pszEscaped);
+        msFree(pszEscaped);
+      }
+      /* If no UTFITEM specified use the serial ID as the key */
+      else
+        msIO_fprintf(fp, "\"%i\":", table.serialid);
+
+      msIO_fprintf(fp, "%s", table.datavalues.c_str());
+    }
+  }
+  msIO_fprintf(fp, "}}");
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Starts a layer for UTFGrid renderer.
+ */
+static int utfgridStartLayer(imageObj *img, mapObj * /*map*/, layerObj *layer) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  /* Look if the layer uses the UTFGrid output format */
+  if (layer->utfdata.string != 0) {
+    r->useutfdata = true;
+  }
+
+  /* layerwatch is set to 1 on first layer treated. Doesn't allow multiple
+   * layers. */
+  if (!r->layerwatch) {
+    r->layerwatch++;
+
+    r->renderlayer = true;
+    r->utflayer = layer;
+    layer->refcount++;
+
+    /* Verify if renderer needs to use UTFITEM */
+    if (r->utflayer->utfitem)
+      r->useutfitem = true;
+  }
+  /* If multiple layers, send error */
+  else {
+    r->layerwatch++;
+    msSetError(MS_MISCERR,
+               "MapServer does not support multiple UTFGrid layers rendering "
+               "simultaneously.",
+               "utfgridStartLayer()");
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Tell renderer the layer is done.
+ */
+static int utfgridEndLayer(imageObj *img, mapObj * /*map*/, layerObj *layer) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  /* Look if the layer was rendered, if it was then turn off rendering. */
+  if (r->renderlayer) {
+    r->utflayer = NULL;
+    layer->refcount--;
+    r->renderlayer = false;
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Do the table operations on the shapes. Allow multiple types of data to be
+ * rendered.
+ */
+static int utfgridStartShape(imageObj *img, shapeObj *shape) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  if (!r->renderlayer)
+    return MS_FAILURE;
+
+  /* Table operations */
+  r->utfvalue = addToTable(r, shape);
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Tells the renderer that the shape's rendering is done.
+ */
+static int utfgridEndShape(imageObj *img, shapeObj *) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  r->utfvalue = 0;
+  return MS_SUCCESS;
+}
+
+/*
+ * Function that renders polygons into UTFGrid.
+ */
+static int utfgridRenderPolygon(imageObj *img, shapeObj *polygonshape,
+                                colorObj *) {
+  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  /* utfvalue is set to 0 if the shape isn't in the table. */
+  if (r->utfvalue == 0) {
+    return MS_FAILURE;
+  }
+
+  /* Render the polygon */
+  polygon_adaptor_utf polygons(polygonshape, r->utfresolution);
+  utfgridRenderPath(img, polygons);
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Function that renders lines into UTFGrid. Starts by looking if the line is a
+ * polygon outline, draw it if it's not.
+ */
+static int utfgridRenderLine(imageObj *img, shapeObj *lineshape,
+                             strokeStyleObj *linestyle) {
+  UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  /* utfvalue is set to 0 if the shape isn't in the table. */
+  if (r->utfvalue == 0) {
+    return MS_SUCCESS;
+    /* If we dont get a caracter to draw we just skip execution
+     * instead of failing
+     */
+  }
+
+  /* Render the line */
+  line_adaptor_utf lines(lineshape, r->utfresolution);
+
+  if (!r->stroke) {
+    r->stroke.reset(new mapserver::conv_stroke<line_adaptor_utf>(lines));
+  } else {
+    r->stroke->attach(lines);
+  }
+  r->stroke->width(linestyle->width / r->utfresolution);
+  utfgridRenderPath(img, *r->stroke);
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Function that render vector type symbols into UTFGrid.
+ */
+static int utfgridRenderVectorSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
+  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
+  double ox = symbol->sizex * 0.5;
+  double oy = symbol->sizey * 0.5;
+
+  /* utfvalue is set to 0 if the shape isn't in the table. */
+  if (r->utfvalue == 0) {
+    return MS_FAILURE;
+  }
+
+  /* Pathing the symbol */
+  mapserver::path_storage path = imageVectorSymbol(symbol);
+
+  /* Transformation to the right size/scale. */
+  mapserver::trans_affine mtx;
+  mtx *= mapserver::trans_affine_translation(-ox, -oy);
+  mtx *= mapserver::trans_affine_scaling(style->scale / r->utfresolution);
+  mtx *= mapserver::trans_affine_rotation(-style->rotation);
+  mtx *= mapserver::trans_affine_translation(x / r->utfresolution,
+                                             y / r->utfresolution);
+  path.transform(mtx);
+
+  /* Rendering the symbol. */
+  utfgridRenderPath(img, path);
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Function that renders Pixmap type symbols into UTFGrid.
+ */
+static int utfgridRenderPixmapSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
+  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
+  rasterBufferObj *pixmap = symbol->pixmap_buffer;
+
+  /* utfvalue is set to 0 if the shape isn't in the table. */
+  if (r->utfvalue == 0) {
+    return MS_FAILURE;
+  }
+
+  /* Pathing the symbol BBox */
+  mapserver::path_storage pixmap_bbox;
+  double w, h;
+  w = pixmap->width * style->scale / (2.0);
+  h = pixmap->height * style->scale / (2.0);
+  pixmap_bbox.move_to((x - w) / r->utfresolution, (y - h) / r->utfresolution);
+  pixmap_bbox.line_to((x + w) / r->utfresolution, (y - h) / r->utfresolution);
+  pixmap_bbox.line_to((x + w) / r->utfresolution, (y + h) / r->utfresolution);
+  pixmap_bbox.line_to((x - w) / r->utfresolution, (y + h) / r->utfresolution);
+
+  /* Rendering the symbol */
+  utfgridRenderPath(img, pixmap_bbox);
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Function that render ellipse type symbols into UTFGrid.
+ */
+static int utfgridRenderEllipseSymbol(imageObj *img, double x, double y,
+                                      symbolObj *symbol,
+                                      symbolStyleObj *style) {
+  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  /* utfvalue is set to 0 if the shape isn't in the table. */
+  if (r->utfvalue == 0) {
+    return MS_FAILURE;
+  }
+
+  /* Pathing the symbol. */
+  mapserver::path_storage path;
+  mapserver::ellipse ellipse(
+      x / r->utfresolution, y / r->utfresolution,
+      symbol->sizex * style->scale / 2 / r->utfresolution,
+      symbol->sizey * style->scale / 2 / r->utfresolution);
+  path.concat_path(ellipse);
+
+  /* Rotation if necessary. */
+  if (style->rotation != 0) {
+    mapserver::trans_affine mtx;
+    mtx *= mapserver::trans_affine_translation(-x / r->utfresolution,
+                                               -y / r->utfresolution);
+    mtx *= mapserver::trans_affine_rotation(-style->rotation);
+    mtx *= mapserver::trans_affine_translation(x / r->utfresolution,
+                                               y / r->utfresolution);
+    path.transform(mtx);
+  }
+
+  /* Rendering the symbol. */
+  utfgridRenderPath(img, path);
+
+  return MS_SUCCESS;
+}
+
+static int utfgridRenderGlyphs(imageObj *img, const textSymbolObj *ts,
+                               colorObj * /*c*/, colorObj * /*oc*/, int /*ow*/,
+                               int isMarker) {
+
+  const textPathObj *tp = ts->textpath;
+  const UTFGridRenderer *r = UTFGRID_RENDERER(img);
+
+  /* If it's not a marker then it's a label or other thing and we dont
+   *  want to draw it on the map
+   */
+  if (!isMarker) {
+    return MS_SUCCESS; // Stop the rendering with no errors
+  }
+
+  /* utfvalue is set to 0 if the shape isn't in the table. */
+  if (r->utfvalue == 0) {
+    return MS_SUCCESS; // Stop the rendering with no errors
+  }
+
+  /* Pathing the symbol BBox */
+  mapserver::path_storage box;
+  double size, x, y;
+
+  size = tp->glyph_size;
+  ;
+  x = tp->glyphs->pnt.x;
+  y = tp->glyphs->pnt.y;
+
+  box.move_to((x) / r->utfresolution, (y) / r->utfresolution);
+  box.line_to((x + size) / r->utfresolution, (y) / r->utfresolution);
+  box.line_to((x + size) / r->utfresolution, (y - size) / r->utfresolution);
+  box.line_to((x) / r->utfresolution, (y - size) / r->utfresolution);
+
+  /* Rotation if necessary. */
+  if (tp->glyphs->rot != 0) {
+    mapserver::trans_affine mtx;
+    mtx *= mapserver::trans_affine_translation(-x / r->utfresolution,
+                                               -y / r->utfresolution);
+    mtx *= mapserver::trans_affine_rotation(-tp->glyphs->rot);
+    mtx *= mapserver::trans_affine_translation(x / r->utfresolution,
+                                               y / r->utfresolution);
+    box.transform(mtx);
+  }
+
+  /* Rendering the symbol */
+  utfgridRenderPath(img, box);
+
+  return MS_SUCCESS;
+}
+
+static int utfgridFreeSymbol(symbolObj *) { return MS_SUCCESS; }
+
+/*
+ * Add the necessary functions for UTFGrid to the renderer VTable.
+ */
+int msPopulateRendererVTableUTFGrid(rendererVTableObj *renderer) {
+  renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
+
+  renderer->createImage = &utfgridCreateImage;
+  renderer->freeImage = &utfgridFreeImage;
+  renderer->saveImage = &utfgridSaveImage;
+
+  renderer->startLayer = &utfgridStartLayer;
+  renderer->endLayer = &utfgridEndLayer;
+
+  renderer->startShape = &utfgridStartShape;
+  renderer->endShape = &utfgridEndShape;
+
+  renderer->renderPolygon = &utfgridRenderPolygon;
+  renderer->renderGlyphs = &utfgridRenderGlyphs;
+  renderer->renderLine = &utfgridRenderLine;
+  renderer->renderVectorSymbol = &utfgridRenderVectorSymbol;
+  renderer->renderPixmapSymbol = &utfgridRenderPixmapSymbol;
+  renderer->renderEllipseSymbol = &utfgridRenderEllipseSymbol;
+
+  renderer->freeSymbol = &utfgridFreeSymbol;
+
+  renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/maputfgrid.h 8.2.0~beta1-1~exp1/src/maputfgrid.h
--- 8.0.1-5/src/maputfgrid.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maputfgrid.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,198 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  UTFGrid rendering functions (using AGG)
+ * Author:   Francois Desjarlais
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "renderers/agg/include/agg_renderer_base.h"
+#include "renderers/agg/include/agg_rendering_buffer.h"
+
+/*
+ * Using AGG templates to create UTFGrid pixel.
+ */
+
+//==================================================================utfpix32
+struct utfpix32 {
+  typedef mapserver::int32u value_type;
+  typedef mapserver::int64u calc_type;
+  typedef mapserver::int64 long_type;
+
+  typedef utfpix32 self_type;
+
+  value_type v;
+
+  //--------------------------------------------------------------------
+  utfpix32() : v(0) {}
+
+  //--------------------------------------------------------------------
+  explicit utfpix32(unsigned v_) : v(mapserver::int32u(v_)) {}
+
+  //--------------------------------------------------------------------
+  utfpix32(const self_type &c) : v(c.v) {}
+
+  //--------------------------------------------------------------------
+  utfpix32 &operator=(const self_type &) = default;
+
+  //--------------------------------------------------------------------
+  void clear() { v = 0; }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE void add(const self_type &c, unsigned /*cover*/) { *this = c; }
+};
+
+//=================================================pixfmt_utf
+template <class ColorT, class RenBuf, unsigned Step = 1, unsigned Offset = 0>
+class pixfmt_utf {
+public:
+  typedef RenBuf rbuf_type;
+  typedef typename rbuf_type::row_data row_data;
+  typedef ColorT color_type;
+  typedef typename color_type::value_type value_type;
+  typedef typename color_type::calc_type calc_type;
+  enum base_scale_e {
+    pix_width = sizeof(value_type),
+    pix_step = Step,
+    pix_offset = Offset
+  };
+
+private:
+  //--------------------------------------------------------------------
+  static AGG_INLINE void copy_or_blend_pix(value_type *p, const color_type &c,
+                                           unsigned cover) {
+    *p = c.v;
+  }
+
+  static AGG_INLINE void copy_or_blend_pix(value_type *p, const color_type &c) {
+    *p = c.v;
+  }
+
+public:
+  pixfmt_utf() : m_rbuf(0) {}
+  //--------------------------------------------------------------------
+  explicit pixfmt_utf(rbuf_type &rb) : m_rbuf(&rb) {}
+  void attach(rbuf_type &rb) { m_rbuf = &rb; }
+  //--------------------------------------------------------------------
+
+  template <class PixFmt>
+  bool attach(PixFmt &pixf, int x1, int y1, int x2, int y2) {
+    mapserver::rect_i r(x1, y1, x2, y2);
+    if (r.clip(mapserver::rect_i(0, 0, pixf.width() - 1, pixf.height() - 1))) {
+      int stride = pixf.stride();
+      m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1),
+                     (r.x2 - r.x1) + 1, (r.y2 - r.y1) + 1, stride);
+      return true;
+    }
+    return false;
+  }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE unsigned width() const { return m_rbuf->width(); }
+  AGG_INLINE unsigned height() const { return m_rbuf->height(); }
+  AGG_INLINE int stride() const { return m_rbuf->stride(); }
+
+  //--------------------------------------------------------------------
+  mapserver::int8u *row_ptr(int y) { return m_rbuf->row_ptr(y); }
+  const mapserver::int8u *row_ptr(int y) const { return m_rbuf->row_ptr(y); }
+  row_data row(int y) const { return m_rbuf->row(y); }
+
+  const mapserver::int8u *pix_ptr(int x, int y) const {
+    return m_rbuf->row_ptr(y) + x * Step + Offset + 1213;
+  }
+
+  mapserver::int8u *pix_ptr(int x, int y) {
+    return m_rbuf->row_ptr(y) + x * Step + Offset + 1213;
+  }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE static void make_pix(mapserver::int8u *p, const color_type &c) {
+    *(value_type *)p = c.v;
+  }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE color_type pixel(int x, int y) const {
+    value_type *p = (value_type *)m_rbuf->row_ptr(y) + x * Step + Offset;
+    return color_type(*p);
+  }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE void copy_pixel(int x, int y, const color_type &c) {
+    *((value_type *)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset) = c.v;
+  }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE void blend_pixel(int x, int y, const color_type &c,
+                              mapserver::int8u cover) {
+    copy_or_blend_pix(
+        (value_type *)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset, c);
+  }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE void copy_hline(int x, int y, unsigned len, const color_type &c) {
+    value_type *p =
+        (value_type *)m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+
+    do {
+      *p = c.v;
+      p += Step;
+    } while (--len);
+  }
+
+  //--------------------------------------------------------------------
+  AGG_INLINE void copy_vline(int x, int y, unsigned len, const color_type &c) {
+    do {
+      value_type *p =
+          (value_type *)m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+      *p = c.v;
+    } while (--len);
+  }
+
+  //--------------------------------------------------------------------
+  void blend_hline(int x, int y, unsigned len, const color_type &c,
+                   mapserver::int8u /*cover*/) {
+    value_type *p =
+        (value_type *)m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+
+    do {
+      *p = c.v;
+      p += Step;
+    } while (--len);
+  }
+
+  //--------------------------------------------------------------------
+  void blend_vline(int x, int y, unsigned len, const color_type &c,
+                   mapserver::int8u cover) {
+    do {
+      value_type *p =
+          (value_type *)m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+      *p = c.v;
+    } while (--len);
+  }
+
+private:
+  rbuf_type *m_rbuf;
+};
diff -pruN 8.0.1-5/src/maputil.c 8.2.0~beta1-1~exp1/src/maputil.c
--- 8.0.1-5/src/maputil.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/maputil.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2841 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Various utility functions ... a real hodgepodge.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ * Notes: Some code (notably msAlphaBlend()) are directly derived from GD. See
+ * the mapserver/GD-COPYING file for the GD license.  Use of this code in this
+ * manner is compatible with the MapServer license.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <math.h>
+#include <time.h>
+
+#include "mapserver.h"
+#include "maptime.h"
+#include "mapthread.h"
+#include "mapcopy.h"
+#include "mapows.h"
+
+#include "gdal.h"
+#include "cpl_conv.h"
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <windows.h>
+#include <tchar.h>
+#include <fcntl.h>
+#include <io.h>
+#include <process.h>
+#endif
+
+#ifdef USE_RSVG
+#include <glib-object.h>
+#endif
+#ifdef USE_GEOS
+#include <geos_c.h>
+#endif
+
+extern char *msyystring_buffer;
+extern int msyylex_destroy(void);
+extern int yyparse(parseObj *);
+
+int msScaleInBounds(double scale, double minscale, double maxscale) {
+  if (scale > 0) {
+    if (maxscale != -1 && scale >= maxscale)
+      return MS_FALSE;
+    if (minscale != -1 && scale < minscale)
+      return MS_FALSE;
+  }
+  return MS_TRUE;
+}
+
+/*
+** Helper functions to convert from strings to other types or objects.
+*/
+static int bindIntegerAttribute(int *attribute, const char *value) {
+  if (!value || strlen(value) == 0)
+    return MS_FAILURE;
+  *attribute =
+      MS_NINT(atof(value)); /*use atof instead of atoi as a fix for bug 2394*/
+  return MS_SUCCESS;
+}
+
+static int bindDoubleAttribute(double *attribute, const char *value) {
+  if (!value || strlen(value) == 0)
+    return MS_FAILURE;
+  *attribute = atof(value);
+  return MS_SUCCESS;
+}
+
+static int bindColorAttribute(colorObj *attribute, const char *value) {
+  int len;
+
+  if (!value || ((len = strlen(value)) == 0))
+    return MS_FAILURE;
+
+  if (value[0] == '#' && (len == 7 || len == 9)) { /* got a hex color */
+    char hex[2];
+
+    hex[0] = value[1];
+    hex[1] = value[2];
+    attribute->red = msHexToInt(hex);
+    hex[0] = value[3];
+    hex[1] = value[4];
+    attribute->green = msHexToInt(hex);
+    hex[0] = value[5];
+    hex[1] = value[6];
+    attribute->blue = msHexToInt(hex);
+    if (len == 9) {
+      hex[0] = value[7];
+      hex[1] = value[8];
+      attribute->alpha = msHexToInt(hex);
+    }
+    return MS_SUCCESS;
+  } else { /* try a space delimited string */
+    char **tokens = NULL;
+    int numtokens = 0;
+
+    tokens = msStringSplit(value, ' ', &numtokens);
+    if (tokens == NULL || numtokens != 3) {
+      msFreeCharArray(tokens, numtokens);
+      return MS_FAILURE; /* punt */
+    }
+
+    attribute->red = atoi(tokens[0]);
+    attribute->green = atoi(tokens[1]);
+    attribute->blue = atoi(tokens[2]);
+    msFreeCharArray(tokens, numtokens);
+
+    return MS_SUCCESS;
+  }
+
+  return MS_FAILURE; /* shouldn't get here */
+}
+
+static void bindStyle(layerObj *layer, shapeObj *shape, styleObj *style,
+                      int drawmode) {
+  int applyOpacity = MS_FALSE;
+  assert(MS_DRAW_FEATURES(drawmode));
+  if (style->numbindings > 0) {
+    applyOpacity = MS_TRUE;
+    if (style->bindings[MS_STYLE_BINDING_SYMBOL].index != -1) {
+      style->symbol = msGetSymbolIndex(
+          &(layer->map->symbolset),
+          shape->values[style->bindings[MS_STYLE_BINDING_SYMBOL].index],
+          MS_TRUE);
+      if (style->symbol == -1)
+        style->symbol =
+            0; /* a reasonable default (perhaps should throw an error?) */
+    }
+    if (style->bindings[MS_STYLE_BINDING_ANGLE].index != -1) {
+      style->angle = 360.0;
+      bindDoubleAttribute(
+          &style->angle,
+          shape->values[style->bindings[MS_STYLE_BINDING_ANGLE].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_SIZE].index != -1) {
+      style->size = 1;
+      bindDoubleAttribute(
+          &style->size,
+          shape->values[style->bindings[MS_STYLE_BINDING_SIZE].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_WIDTH].index != -1) {
+      style->width = 1;
+      bindDoubleAttribute(
+          &style->width,
+          shape->values[style->bindings[MS_STYLE_BINDING_WIDTH].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_COLOR].index != -1 &&
+        !MS_DRAW_QUERY(drawmode)) {
+      MS_INIT_COLOR(style->color, -1, -1, -1, 255);
+      bindColorAttribute(
+          &style->color,
+          shape->values[style->bindings[MS_STYLE_BINDING_COLOR].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index != -1 &&
+        !MS_DRAW_QUERY(drawmode)) {
+      MS_INIT_COLOR(style->outlinecolor, -1, -1, -1, 255);
+      bindColorAttribute(
+          &style->outlinecolor,
+          shape->values[style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index != -1) {
+      style->outlinewidth = 1;
+      bindDoubleAttribute(
+          &style->outlinewidth,
+          shape->values[style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_OPACITY].index != -1) {
+      style->opacity = 100;
+      bindIntegerAttribute(
+          &style->opacity,
+          shape->values[style->bindings[MS_STYLE_BINDING_OPACITY].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_OFFSET_X].index != -1) {
+      style->offsetx = 0;
+      bindDoubleAttribute(
+          &style->offsetx,
+          shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_X].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_OFFSET_Y].index != -1) {
+      style->offsety = 0;
+      bindDoubleAttribute(
+          &style->offsety,
+          shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_Y].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].index != -1) {
+      style->polaroffsetpixel = 0;
+      bindDoubleAttribute(
+          &style->polaroffsetpixel,
+          shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL]
+                            .index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].index != -1) {
+      style->polaroffsetangle = 0;
+      bindDoubleAttribute(
+          &style->polaroffsetangle,
+          shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE]
+                            .index]);
+    }
+  }
+  if (style->nexprbindings > 0) {
+    applyOpacity = MS_TRUE;
+    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_X].type == MS_EXPRESSION) {
+      style->offsetx = msEvalDoubleExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_X]), shape);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_Y].type == MS_EXPRESSION) {
+      style->offsety = msEvalDoubleExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_Y]), shape);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_ANGLE].type == MS_EXPRESSION) {
+      style->angle = msEvalDoubleExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_ANGLE]), shape);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_SIZE].type == MS_EXPRESSION) {
+      style->size = msEvalDoubleExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_SIZE]), shape);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_WIDTH].type == MS_EXPRESSION) {
+      style->width = msEvalDoubleExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_WIDTH]), shape);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_OPACITY].type == MS_EXPRESSION) {
+      style->opacity =
+          100 * msEvalDoubleExpression(
+                    &(style->exprBindings[MS_STYLE_BINDING_OPACITY]), shape);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].type ==
+        MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR]), shape);
+      bindColorAttribute(&style->outlinecolor, txt);
+      msFree(txt);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_COLOR].type == MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_COLOR]), shape);
+      bindColorAttribute(&style->color, txt);
+      msFree(txt);
+    }
+  }
+
+  if (applyOpacity == MS_TRUE &&
+      (style->opacity < 100 || style->color.alpha != 255)) {
+    int alpha;
+    alpha = MS_NINT(style->opacity * 2.55);
+    style->color.alpha = alpha;
+    style->outlinecolor.alpha = alpha;
+    style->mincolor.alpha = alpha;
+    style->maxcolor.alpha = alpha;
+  }
+}
+
+static void bindLabel(layerObj *layer, shapeObj *shape, labelObj *label,
+                      int drawmode) {
+  int i;
+  assert(MS_DRAW_LABELS(drawmode));
+
+  /* check the label styleObj's (TODO: do we need to use querymapMode here? */
+  for (i = 0; i < label->numstyles; i++) {
+    /* force MS_DRAWMODE_FEATURES for label styles */
+    bindStyle(layer, shape, label->styles[i], drawmode | MS_DRAWMODE_FEATURES);
+  }
+
+  if (label->numbindings > 0) {
+    if (label->bindings[MS_LABEL_BINDING_ANGLE].index != -1) {
+      label->angle = 0.0;
+      bindDoubleAttribute(
+          &label->angle,
+          shape->values[label->bindings[MS_LABEL_BINDING_ANGLE].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_SIZE].index != -1) {
+      label->size = 1;
+      bindIntegerAttribute(
+          &label->size,
+          shape->values[label->bindings[MS_LABEL_BINDING_SIZE].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_COLOR].index != -1) {
+      MS_INIT_COLOR(label->color, -1, -1, -1, 255);
+      bindColorAttribute(
+          &label->color,
+          shape->values[label->bindings[MS_LABEL_BINDING_COLOR].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index != -1) {
+      MS_INIT_COLOR(label->outlinecolor, -1, -1, -1, 255);
+      bindColorAttribute(
+          &label->outlinecolor,
+          shape->values[label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_FONT].index != -1) {
+      msFree(label->font);
+      label->font =
+          msStrdup(shape->values[label->bindings[MS_LABEL_BINDING_FONT].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_PRIORITY].index != -1) {
+      label->priority = MS_DEFAULT_LABEL_PRIORITY;
+      bindIntegerAttribute(
+          &label->priority,
+          shape->values[label->bindings[MS_LABEL_BINDING_PRIORITY].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index != -1) {
+      label->shadowsizex = 1;
+      bindIntegerAttribute(
+          &label->shadowsizex,
+          shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index]);
+    }
+    if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index != -1) {
+      label->shadowsizey = 1;
+      bindIntegerAttribute(
+          &label->shadowsizey,
+          shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_OFFSET_X].index != -1) {
+      label->offsetx = 0;
+      bindIntegerAttribute(
+          &label->offsetx,
+          shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_X].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_OFFSET_Y].index != -1) {
+      label->offsety = 0;
+      bindIntegerAttribute(
+          &label->offsety,
+          shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_Y].index]);
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_ALIGN].index != -1) {
+      int tmpAlign = 0;
+      bindIntegerAttribute(
+          &tmpAlign,
+          shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]);
+      if (tmpAlign != 0) { /* is this test sufficient? */
+        label->align = tmpAlign;
+      } else { /* Integer binding failed, look for strings like cc, ul, lr,
+                  etc... */
+        if (strlen(
+                shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]) >=
+            4) {
+          char *va =
+              shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index];
+          if (!strncasecmp(va, "center", 5))
+            label->align = MS_ALIGN_CENTER;
+          else if (!strncasecmp(va, "left", 4))
+            label->align = MS_ALIGN_LEFT;
+          else if (!strncasecmp(va, "right", 5))
+            label->align = MS_ALIGN_RIGHT;
+        }
+      }
+    }
+
+    if (label->bindings[MS_LABEL_BINDING_POSITION].index != -1) {
+      int tmpPosition = 0;
+      bindIntegerAttribute(
+          &tmpPosition,
+          shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index]);
+      if (tmpPosition != 0) { /* is this test sufficient? */
+        label->position = tmpPosition;
+      } else { /* Integer binding failed, look for strings like cc, ul, lr,
+                  etc... */
+        if (strlen(shape->values[label->bindings[MS_LABEL_BINDING_POSITION]
+                                     .index]) == 2) {
+          char *vp =
+              shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index];
+          if (!strncasecmp(vp, "ul", 2))
+            label->position = MS_UL;
+          else if (!strncasecmp(vp, "lr", 2))
+            label->position = MS_LR;
+          else if (!strncasecmp(vp, "ur", 2))
+            label->position = MS_UR;
+          else if (!strncasecmp(vp, "ll", 2))
+            label->position = MS_LL;
+          else if (!strncasecmp(vp, "cr", 2))
+            label->position = MS_CR;
+          else if (!strncasecmp(vp, "cl", 2))
+            label->position = MS_CL;
+          else if (!strncasecmp(vp, "uc", 2))
+            label->position = MS_UC;
+          else if (!strncasecmp(vp, "lc", 2))
+            label->position = MS_LC;
+          else if (!strncasecmp(vp, "cc", 2))
+            label->position = MS_CC;
+        }
+      }
+    }
+  }
+  if (label->nexprbindings > 0) {
+    if (label->exprBindings[MS_LABEL_BINDING_ANGLE].type == MS_EXPRESSION) {
+      label->angle = msEvalDoubleExpression(
+          &(label->exprBindings[MS_LABEL_BINDING_ANGLE]), shape);
+    }
+    if (label->exprBindings[MS_LABEL_BINDING_SIZE].type == MS_EXPRESSION) {
+      label->size = msEvalDoubleExpression(
+          &(label->exprBindings[MS_LABEL_BINDING_SIZE]), shape);
+    }
+    if (label->exprBindings[MS_LABEL_BINDING_COLOR].type == MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(label->exprBindings[MS_LABEL_BINDING_COLOR]), shape);
+      bindColorAttribute(&label->color, txt);
+      msFree(txt);
+    }
+    if (label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR].type ==
+        MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR]), shape);
+      bindColorAttribute(&label->outlinecolor, txt);
+      msFree(txt);
+    }
+    if (label->exprBindings[MS_LABEL_BINDING_PRIORITY].type == MS_EXPRESSION) {
+      label->priority = msEvalDoubleExpression(
+          &(label->exprBindings[MS_LABEL_BINDING_PRIORITY]), shape);
+    }
+  }
+}
+
+/*
+** Function to bind various layer properties to shape attributes.
+*/
+int msBindLayerToShape(layerObj *layer, shapeObj *shape, int drawmode) {
+  int i, j;
+
+  if (!layer || !shape)
+    return MS_FAILURE;
+
+  for (i = 0; i < layer->numclasses; i++) {
+    /* check the styleObj's */
+    if (MS_DRAW_FEATURES(drawmode)) {
+      for (j = 0; j < layer->class[i] -> numstyles; j++) {
+        bindStyle(layer, shape, layer->class[i] -> styles[j], drawmode);
+      }
+    }
+
+    /* check the labelObj's */
+    if (MS_DRAW_LABELS(drawmode)) {
+      for (j = 0; j < layer->class[i] -> numlabels; j++) {
+        bindLabel(layer, shape, layer->class[i] -> labels[j], drawmode);
+      }
+    }
+  } /* next classObj */
+
+  return MS_SUCCESS;
+}
+
+/*
+ * Used to get red, green, blue integers separately based upon the color index
+ */
+int getRgbColor(mapObj *map, int i, int *r, int *g, int *b) {
+  /* check index range */
+  int status = 1;
+  *r = *g = *b = -1;
+  if ((i > 0) && (i <= map->palette.numcolors)) {
+    *r = map->palette.colors[i - 1].red;
+    *g = map->palette.colors[i - 1].green;
+    *b = map->palette.colors[i - 1].blue;
+    status = 0;
+  }
+  return status;
+}
+
+static int searchContextForTag(mapObj *map, char **ltags, char *tag,
+                               char *context, int requires) {
+  int i;
+
+  if (!context)
+    return MS_FAILURE;
+
+  /*  printf("\tin searchContextForTag, searching %s for %s\n", context, tag);
+   */
+
+  if (strstr(context, tag) != NULL)
+    return MS_SUCCESS; /* found the tag */
+
+  /* check referenced layers for the tag too */
+  for (i = 0; i < map->numlayers; i++) {
+    if (strstr(context, ltags[i]) != NULL) { /* need to check this layer */
+      if (requires == MS_TRUE) {
+        if (searchContextForTag(map, ltags, tag, GET_LAYER(map, i)->requires,
+                                MS_TRUE) == MS_SUCCESS)
+          return MS_SUCCESS;
+      } else {
+        if (searchContextForTag(map, ltags, tag,
+                                GET_LAYER(map, i)->labelrequires,
+                                MS_FALSE) == MS_SUCCESS)
+          return MS_SUCCESS;
+      }
+    }
+  }
+
+  return MS_FAILURE;
+}
+
+/*
+** Function to take a look at all layers with REQUIRES/LABELREQUIRES set to make
+*sure there are no
+** recursive context requirements set (e.g. layer1 requires layer2 and layer2
+*requires layer1). This
+** is bug 1059.
+*/
+int msValidateContexts(mapObj *map) {
+  int i;
+  char **ltags;
+  int status = MS_SUCCESS;
+
+  ltags = (char **)msSmallMalloc(map->numlayers * sizeof(char *));
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->name == NULL) {
+      ltags[i] = msStrdup("[NULL]");
+    } else {
+      ltags[i] = (char *)msSmallMalloc(
+          sizeof(char) * strlen(GET_LAYER(map, i)->name) + 3);
+      sprintf(ltags[i], "[%s]", GET_LAYER(map, i)->name);
+    }
+  }
+
+  /* check each layer's REQUIRES and LABELREQUIRES parameters */
+  for (i = 0; i < map->numlayers; i++) {
+    /* printf("working on layer %s, looking for references to %s\n",
+     * GET_LAYER(map, i)->name, ltags[i]); */
+    if (searchContextForTag(map, ltags, ltags[i], GET_LAYER(map, i)->requires,
+                            MS_TRUE) == MS_SUCCESS) {
+      msSetError(MS_PARSEERR,
+                 "Recursion error found for REQUIRES parameter for layer %s.",
+                 "msValidateContexts", GET_LAYER(map, i)->name);
+      status = MS_FAILURE;
+      break;
+    }
+    if (searchContextForTag(map, ltags, ltags[i],
+                            GET_LAYER(map, i)->labelrequires,
+                            MS_FALSE) == MS_SUCCESS) {
+      msSetError(
+          MS_PARSEERR,
+          "Recursion error found for LABELREQUIRES parameter for layer %s.",
+          "msValidateContexts", GET_LAYER(map, i)->name);
+      status = MS_FAILURE;
+      break;
+    }
+    /* printf("done layer %s\n", GET_LAYER(map, i)->name); */
+  }
+
+  /* clean up */
+  msFreeCharArray(ltags, map->numlayers);
+
+  return status;
+}
+
+int msEvalContext(mapObj *map, layerObj *layer, char *context) {
+  int i, status;
+  char *tag = NULL;
+
+  expressionObj e;
+  parseObj p;
+
+  if (!context)
+    return (MS_TRUE);
+
+  /* initialize a temporary expression (e) */
+  msInitExpression(&e);
+
+  e.string = msStrdup(context);
+  e.type = MS_EXPRESSION; /* todo */
+
+  for (i = 0; i < map->numlayers; i++) { /* step through all the layers */
+    if (layer->index == i)
+      continue; /* skip the layer in question */
+    if (GET_LAYER(map, i)->name == NULL)
+      continue; /* Layer without name cannot be used in contexts */
+
+    tag = (char *)msSmallMalloc(sizeof(char) * strlen(GET_LAYER(map, i)->name) +
+                                3);
+    sprintf(tag, "[%s]", GET_LAYER(map, i)->name);
+
+    if (strstr(e.string, tag)) {
+      if (msLayerIsVisible(map, (GET_LAYER(map, i))))
+        e.string = msReplaceSubstring(e.string, tag, "1");
+      else
+        e.string = msReplaceSubstring(e.string, tag, "0");
+    }
+
+    free(tag);
+  }
+
+  msTokenizeExpression(&e, NULL, NULL);
+
+  p.shape = NULL;
+  p.expr = &e;
+  p.expr->curtoken = p.expr->tokens; /* reset */
+  p.type = MS_PARSE_TYPE_BOOLEAN;
+
+  status = yyparse(&p);
+
+  msFreeExpression(&e);
+
+  if (status != 0) {
+    msSetError(MS_PARSEERR, "Failed to parse context", "msEvalContext");
+    return MS_FALSE; /* error in parse */
+  }
+
+  return p.result.intval;
+}
+
+/* msEvalExpression()
+ *
+ * Evaluates a mapserver expression for a given set of attribute values and
+ * returns the result of the expression (MS_TRUE or MS_FALSE)
+ * May also return MS_FALSE in case of parsing errors or invalid expressions
+ * (check the error stack if you care)
+ *
+ */
+int msEvalExpression(layerObj *layer, shapeObj *shape,
+                     expressionObj *expression, int itemindex) {
+  if (MS_STRING_IS_NULL_OR_EMPTY(expression->string))
+    return MS_TRUE; /* NULL or empty expressions are ALWAYS true */
+  if (expression->native_string != NULL)
+    return MS_TRUE; /* expressions that are evaluated natively are ALWAYS true
+                     */
+
+  switch (expression->type) {
+  case (MS_STRING):
+    if (itemindex == -1) {
+      msSetError(MS_MISCERR,
+                 "Cannot evaluate expression, no item index defined.",
+                 "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (itemindex >= layer->numitems || itemindex >= shape->numvalues) {
+      msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (expression->flags & MS_EXP_INSENSITIVE) {
+      if (strcasecmp(expression->string, shape->values[itemindex]) == 0)
+        return MS_TRUE; /* got a match */
+    } else {
+      if (strcmp(expression->string, shape->values[itemindex]) == 0)
+        return MS_TRUE; /* got a match */
+    }
+    break;
+  case (MS_LIST):
+    if (itemindex == -1) {
+      msSetError(MS_MISCERR,
+                 "Cannot evaluate expression, no item index defined.",
+                 "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (itemindex >= layer->numitems || itemindex >= shape->numvalues) {
+      msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
+      return MS_FALSE;
+    }
+    {
+      char *start, *end;
+      int value_len = strlen(shape->values[itemindex]);
+      start = expression->string;
+      while ((end = strchr(start, ',')) != NULL) {
+        if (value_len == end - start &&
+            !strncmp(start, shape->values[itemindex], end - start))
+          return MS_TRUE;
+        start = end + 1;
+      }
+      if (!strcmp(start, shape->values[itemindex]))
+        return MS_TRUE;
+    }
+    break;
+  case (MS_EXPRESSION): {
+    int status;
+    parseObj p;
+
+    p.shape = shape;
+    p.expr = expression;
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_BOOLEAN;
+
+    status = yyparse(&p);
+
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to parse expression: %s",
+                 "msEvalExpression", expression->string);
+      return MS_FALSE;
+    }
+
+    return p.result.intval;
+  }
+  case (MS_REGEX):
+    if (itemindex == -1) {
+      msSetError(MS_MISCERR,
+                 "Cannot evaluate expression, no item index defined.",
+                 "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (itemindex >= layer->numitems || itemindex >= shape->numvalues) {
+      msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
+      return MS_FALSE;
+    }
+
+    if (MS_STRING_IS_NULL_OR_EMPTY(shape->values[itemindex]) == MS_TRUE)
+      return MS_FALSE;
+
+    if (!expression->compiled) {
+      if (expression->flags & MS_EXP_INSENSITIVE) {
+        if (ms_regcomp(&(expression->regex), expression->string,
+                       MS_REG_EXTENDED | MS_REG_NOSUB | MS_REG_ICASE) !=
+            0) { /* compile the expression */
+          msSetError(MS_REGEXERR, "Invalid regular expression.",
+                     "msEvalExpression()");
+          return MS_FALSE;
+        }
+      } else {
+        if (ms_regcomp(&(expression->regex), expression->string,
+                       MS_REG_EXTENDED | MS_REG_NOSUB) !=
+            0) { /* compile the expression */
+          msSetError(MS_REGEXERR, "Invalid regular expression.",
+                     "msEvalExpression()");
+          return MS_FALSE;
+        }
+      }
+      expression->compiled = MS_TRUE;
+    }
+
+    if (ms_regexec(&(expression->regex), shape->values[itemindex], 0, NULL,
+                   0) == 0)
+      return MS_TRUE; /* got a match */
+    break;
+  }
+
+  return MS_FALSE;
+}
+
+int *msAllocateValidClassGroups(layerObj *lp, int *nclasses) {
+  int *classgroup = NULL;
+  int nvalidclass = 0, i = 0;
+
+  if (!lp || !lp->classgroup || lp->numclasses <= 0 || !nclasses)
+    return NULL;
+
+  classgroup = (int *)msSmallMalloc(sizeof(int) * lp->numclasses);
+  nvalidclass = 0;
+  for (i = 0; i < lp->numclasses; i++) {
+    if (lp->class[i] -> group && strcasecmp(lp->class[i] -> group,
+                                            lp -> classgroup) == 0) {
+      classgroup[nvalidclass] = i;
+      nvalidclass++;
+    }
+  }
+  if (nvalidclass > 0) {
+    classgroup = (int *)msSmallRealloc(classgroup, sizeof(int) * nvalidclass);
+    *nclasses = nvalidclass;
+    return classgroup;
+  }
+
+  if (classgroup)
+    msFree(classgroup);
+
+  return NULL;
+}
+
+int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape,
+                    int *classgroup, int numclasses) {
+  return msShapeGetNextClass(-1, layer, map, shape, classgroup, numclasses);
+}
+
+int msShapeGetNextClass(int currentclass, layerObj *layer, mapObj *map,
+                        shapeObj *shape, int *classgroup, int numclasses) {
+  int i, iclass;
+
+  if (currentclass < 0)
+    currentclass = -1;
+
+  if (layer->numclasses > 0) {
+    if (classgroup == NULL || numclasses <= 0)
+      numclasses = layer->numclasses;
+
+    for (i = currentclass + 1; i < numclasses; i++) {
+      if (classgroup)
+        iclass = classgroup[i];
+      else
+        iclass = i;
+
+      if (iclass < 0 || iclass >= layer->numclasses)
+        continue; /* this should never happen but just in case */
+
+      if (map->scaledenom > 0) { /* verify scaledenom here  */
+        if ((layer->class[iclass] -> maxscaledenom > 0) &&
+            (map->scaledenom > layer->class[iclass] -> maxscaledenom))
+          continue; /* can skip this one, next class */
+        if ((layer->class[iclass] -> minscaledenom > 0) &&
+            (map->scaledenom <= layer->class[iclass] -> minscaledenom))
+          continue; /* can skip this one, next class */
+      }
+
+      /* verify the minfeaturesize */
+      if ((shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) &&
+          (layer->class[iclass] -> minfeaturesize > 0)) {
+        double minfeaturesize =
+            Pix2LayerGeoref(map, layer, layer->class[iclass] -> minfeaturesize);
+        if (msShapeCheckSize(shape, minfeaturesize) == MS_FALSE)
+          continue; /* skip this one, next class */
+      }
+
+      if (layer->class[iclass] -> status != MS_DELETE &&
+                                      msEvalExpression(
+                                          layer, shape,
+                                          &(layer->class[iclass] -> expression),
+                                          layer->classitemindex) == MS_TRUE) {
+        if (layer->class[iclass] -> isfallback && currentclass != -1) {
+          // Class is not applicable if it is flagged as fallback (<ElseFilter/>
+          // tag in SLD) but other classes have been applied before.
+          return -1;
+        } else {
+          return (iclass);
+        }
+      }
+    }
+  }
+
+  return (-1); /* no match */
+}
+
+static char *msEvalTextExpressionInternal(expressionObj *expr, shapeObj *shape,
+                                          int bJSonEscape) {
+  char *result = NULL;
+
+  if (!expr->string)
+    return result; /* nothing to do */
+
+  switch (expr->type) {
+  case (MS_STRING): {
+    char *target = NULL;
+    char *pszEscaped;
+    tokenListNodeObjPtr node = NULL;
+    tokenListNodeObjPtr nextNode = NULL;
+
+    result = msStrdup(expr->string);
+
+    node = expr->tokens;
+    if (node) {
+      while (node != NULL) {
+        nextNode = node->next;
+        if (node->token == MS_TOKEN_BINDING_DOUBLE ||
+            node->token == MS_TOKEN_BINDING_INTEGER ||
+            node->token == MS_TOKEN_BINDING_STRING ||
+            node->token == MS_TOKEN_BINDING_TIME) {
+          target =
+              (char *)msSmallMalloc(strlen(node->tokenval.bindval.item) + 3);
+          sprintf(target, "[%s]", node->tokenval.bindval.item);
+          if (bJSonEscape)
+            pszEscaped =
+                msEscapeJSonString(shape->values[node->tokenval.bindval.index]);
+          else
+            pszEscaped = msStrdup(shape->values[node->tokenval.bindval.index]);
+          result = msReplaceSubstring(result, target, pszEscaped);
+          msFree(pszEscaped);
+          msFree(target);
+        }
+        node = nextNode;
+      }
+    }
+    if (!strlen(result)) {
+      msFree(result);
+      result = NULL;
+    }
+  } break;
+  case (MS_EXPRESSION): {
+    int status;
+    parseObj p;
+
+    p.shape = shape;
+    p.expr = expr;
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_STRING;
+
+    status = yyparse(&p);
+
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to process text expression: %s",
+                 "msEvalTextExpression", expr->string);
+      return NULL;
+    }
+
+    result = p.result.strval;
+    break;
+  }
+  default:
+    break;
+  }
+  if (result && !strlen(result)) {
+    msFree(result);
+    result = NULL;
+  }
+  return result;
+}
+
+char *msEvalTextExpressionJSonEscape(expressionObj *expr, shapeObj *shape) {
+  return msEvalTextExpressionInternal(expr, shape, MS_TRUE);
+}
+
+char *msEvalTextExpression(expressionObj *expr, shapeObj *shape) {
+  return msEvalTextExpressionInternal(expr, shape, MS_FALSE);
+}
+
+double msEvalDoubleExpression(expressionObj *expression, shapeObj *shape) {
+  double value;
+  int status;
+  parseObj p;
+  p.shape = shape;
+  p.expr = expression;
+  p.expr->curtoken = p.expr->tokens; /* reset */
+  p.type = MS_PARSE_TYPE_STRING;
+  status = yyparse(&p);
+  if (status != 0) {
+    msSetError(MS_PARSEERR, "Failed to parse expression: %s", "bindStyle",
+               expression->string);
+    value = 0.0;
+  } else {
+    value = atof(p.result.strval);
+    msFree(p.result.strval);
+  }
+  return value;
+}
+
+char *msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape,
+                                labelObj *lbl) {
+  assert(shape && lbl);
+  if (lbl->text.string) {
+    return msEvalTextExpression(&(lbl->text), shape);
+  } else if (layer->class[shape->classindex] -> text.string) {
+    return msEvalTextExpression(&(layer->class[shape->classindex] -> text),
+                                shape);
+  } else {
+    if (shape->values && layer->labelitemindex >= 0 &&
+        shape->values[layer->labelitemindex] &&
+        strlen(shape->values[layer->labelitemindex]))
+      return msStrdup(shape->values[layer->labelitemindex]);
+    else if (shape->text)
+      return msStrdup(
+          shape->text); /* last resort but common with iniline features */
+  }
+  return NULL;
+}
+
+int msGetLabelStatus(mapObj *map, layerObj *layer, shapeObj *shape,
+                     labelObj *lbl) {
+  assert(layer && lbl);
+  if (!msScaleInBounds(map->scaledenom, lbl->minscaledenom, lbl->maxscaledenom))
+    return MS_OFF;
+  if (msEvalExpression(layer, shape, &(lbl->expression),
+                       layer->labelitemindex) != MS_TRUE)
+    return MS_OFF;
+  /* TODO: check for minfeaturesize here ? */
+  return MS_ON;
+}
+
+/* Check if the shape is enough big to be drawn with the
+   layer::minfeaturesize setting. The minfeaturesize parameter should be
+   the value in geo ref (not in pixel) and should have been multiplied by
+   the resolution factor.
+ */
+int msShapeCheckSize(shapeObj *shape, double minfeaturesize) {
+  double dx = (shape->bounds.maxx - shape->bounds.minx);
+  double dy = (shape->bounds.maxy - shape->bounds.miny);
+
+  if (pow(minfeaturesize, 2.0) > (pow(dx, 2.0) + pow(dy, 2.0)))
+    return MS_FALSE;
+
+  return MS_TRUE;
+}
+
+/*
+** Adjusts an image size in one direction to fit an extent.
+*/
+int msAdjustImage(rectObj rect, int *width, int *height) {
+  if (*width == -1 && *height == -1) {
+    msSetError(MS_MISCERR, "Cannot calculate both image height and width.",
+               "msAdjustImage()");
+    return (-1);
+  }
+
+  if (*width > 0)
+    *height =
+        MS_NINT((rect.maxy - rect.miny) / ((rect.maxx - rect.minx) / (*width)));
+  else
+    *width = MS_NINT((rect.maxx - rect.minx) /
+                     ((rect.maxy - rect.miny) / (*height)));
+
+  return (0);
+}
+
+/*
+** Make sure extent fits image window to be created. Returns cellsize of output
+*image.
+*/
+double msAdjustExtent(rectObj *rect, int width, int height) {
+  double cellsize, ox, oy;
+
+  if (width == 1 || height == 1)
+    return 0;
+
+  cellsize = MS_MAX(MS_CELLSIZE(rect->minx, rect->maxx, width),
+                    MS_CELLSIZE(rect->miny, rect->maxy, height));
+
+  if (cellsize <= 0) /* avoid division by zero errors */
+    return (0);
+
+  ox = MS_MAX(((width - 1) - (rect->maxx - rect->minx) / cellsize) / 2,
+              0); /* these were width-1 and height-1 */
+  oy = MS_MAX(((height - 1) - (rect->maxy - rect->miny) / cellsize) / 2, 0);
+
+  rect->minx = rect->minx - ox * cellsize;
+  rect->miny = rect->miny - oy * cellsize;
+  rect->maxx = rect->maxx + ox * cellsize;
+  rect->maxy = rect->maxy + oy * cellsize;
+
+  return (cellsize);
+}
+
+/*
+** Rect must always contain a portion of bounds. If not, rect is
+** shifted to overlap by overlay percent. The dimensions of rect do
+** not change but placement relative to bounds can.
+*/
+int msConstrainExtent(rectObj *bounds, rectObj *rect, double overlay) {
+  /* check left edge, and if necessary the right edge of bounds */
+  if (rect->maxx <= bounds->minx) {
+    const double offset = overlay * (rect->maxx - rect->minx);
+    rect->minx += offset; /* shift right */
+    rect->maxx += offset;
+  } else if (rect->minx >= bounds->maxx) {
+    const double offset = overlay * (rect->maxx - rect->minx);
+    rect->minx -= offset; /* shift left */
+    rect->maxx -= offset;
+  }
+
+  /* check top edge, and if necessary the bottom edge of bounds */
+  if (rect->maxy <= bounds->miny) {
+    const double offset = overlay * (rect->maxy - rect->miny);
+    rect->miny -= offset; /* shift down */
+    rect->maxy -= offset;
+  } else if (rect->miny >= bounds->maxy) {
+    const double offset = overlay * (rect->maxy - rect->miny);
+    rect->miny += offset; /* shift up */
+    rect->maxy += offset;
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*
+** Generic function to save an image to a file.
+**
+** Note that map may be NULL. If it is set, then it is used for two things:
+** - Deal with relative imagepaths (compute absolute path relative to map path)
+** - Extract the georeferenced extents and coordinate system
+**   of the map for writing out with the image when appropriate
+**   (primarily this means via msSaveImageGDAL() to something like GeoTIFF).
+**
+** The filename is NULL when the image is supposed to be written to stdout.
+*/
+
+int msSaveImage(mapObj *map, imageObj *img, const char *filename) {
+  int nReturnVal = MS_FAILURE;
+  char szPath[MS_MAXPATHLEN];
+  struct mstimeval starttime = {0}, endtime = {0};
+
+  if (map && map->debug >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&starttime, NULL);
+  }
+
+  if (img) {
+    if (MS_DRIVER_GDAL(img->format)) {
+      if (map != NULL && filename != NULL)
+        nReturnVal = msSaveImageGDAL(
+            map, img, msBuildPath(szPath, map->mappath, filename));
+      else
+        nReturnVal = msSaveImageGDAL(map, img, filename);
+    } else
+
+        if (MS_RENDERER_PLUGIN(img->format)) {
+      rendererVTableObj *renderer = img->format->vtable;
+      FILE *stream = NULL;
+      if (filename) {
+        if (map)
+          stream = fopen(msBuildPath(szPath, map->mappath, filename), "wb");
+        else
+          stream = fopen(filename, "wb");
+
+        if (!stream) {
+          msSetError(MS_IOERR, "Failed to create output file (%s).",
+                     "msSaveImage()", (map ? szPath : filename));
+          return MS_FAILURE;
+        }
+
+      } else {
+        if (msIO_needBinaryStdout() == MS_FAILURE)
+          return MS_FAILURE;
+        stream = stdout;
+      }
+
+      if (renderer->supports_pixel_buffer) {
+        rasterBufferObj data;
+        if (renderer->getRasterBufferHandle(img, &data) != MS_SUCCESS) {
+          if (stream != stdout)
+            fclose(stream);
+          return MS_FAILURE;
+        }
+
+        nReturnVal = msSaveRasterBuffer(map, &data, stream, img->format);
+      } else {
+        nReturnVal = renderer->saveImage(img, map, stream, img->format);
+      }
+      if (stream != stdout)
+        fclose(stream);
+
+    } else if (MS_DRIVER_IMAGEMAP(img->format))
+      nReturnVal = msSaveImageIM(img, filename, img->format);
+    else
+      msSetError(MS_MISCERR, "Unknown image type", "msSaveImage()");
+  }
+
+  if (map && map->debug >= MS_DEBUGLEVEL_TUNING) {
+    msGettimeofday(&endtime, NULL);
+    msDebug("msSaveImage(%s) total time: %.3fs\n",
+            (filename ? filename : "stdout"),
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
+  }
+
+  return nReturnVal;
+}
+
+/*
+** Generic function to save an image to a byte array.
+** - the return value is the pointer to the byte array
+** - size_ptr contains the number of bytes returned
+** - format: the desired output format
+**
+** The caller is responsible to free the returned array
+** The function returns NULL if the output format is not supported.
+*/
+
+unsigned char *msSaveImageBuffer(imageObj *image, int *size_ptr,
+                                 outputFormatObj *format) {
+  *size_ptr = 0;
+  if (MS_RENDERER_PLUGIN(image->format)) {
+    rasterBufferObj data;
+    rendererVTableObj *renderer = image->format->vtable;
+    if (renderer->supports_pixel_buffer) {
+      bufferObj buffer;
+      msBufferInit(&buffer);
+      const int status = renderer->getRasterBufferHandle(image, &data);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        return NULL;
+      }
+      msSaveRasterBufferToBuffer(&data, &buffer, format);
+      *size_ptr = buffer.size;
+      return buffer.data;
+      /* don't free the bufferObj as we don't own the bytes anymore */
+    } else {
+      /* check if the renderer supports native buffer output */
+      if (renderer->saveImageBuffer)
+        return renderer->saveImageBuffer(image, size_ptr, format);
+
+      msSetError(MS_MISCERR, "Unsupported image type", "msSaveImageBuffer()");
+      return NULL;
+    }
+  }
+  msSetError(MS_MISCERR, "Unsupported image type", "msSaveImage()");
+  return NULL;
+}
+
+/**
+ * Generic function to free the imageObj
+ */
+void msFreeImage(imageObj *image) {
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      rendererVTableObj *renderer = image->format->vtable;
+      tileCacheObj *next, *cur = image->tilecache;
+      while (cur) {
+        msFreeImage(cur->image);
+        next = cur->next;
+        free(cur);
+        cur = next;
+      }
+      image->ntiles = 0;
+      renderer->freeImage(image);
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
+      msFreeImageIM(image);
+    else if (MS_RENDERER_RAWDATA(image->format))
+      msFree(image->img.raw_16bit);
+    else
+      msSetError(MS_MISCERR, "Unknown image type", "msFreeImage()");
+
+    if (image->imagepath)
+      free(image->imagepath);
+    if (image->imageurl)
+      free(image->imageurl);
+
+    if (--image->format->refcount < 1)
+      msFreeOutputFormat(image->format);
+
+    image->imagepath = NULL;
+    image->imageurl = NULL;
+
+    msFree(image->img_mask);
+    image->img_mask = NULL;
+
+    msFree(image);
+  }
+}
+
+/*
+** Return an array containing all the layer's index given a group name.
+** If nothing is found, NULL is returned. The nCount is initalized
+** to the number of elements in the returned array.
+** Note : the caller of the function should free the array.
+*/
+int *msGetLayersIndexByGroup(mapObj *map, char *groupname, int *pnCount) {
+  int i;
+  int iLayer = 0;
+  int *aiIndex;
+
+  if (!groupname || !map || !pnCount) {
+    return NULL;
+  }
+
+  aiIndex = (int *)msSmallMalloc(sizeof(int) * map->numlayers);
+
+  for (i = 0; i < map->numlayers; i++) {
+    if (!GET_LAYER(map, i)->group) /* skip it */
+      continue;
+    if (strcmp(groupname, GET_LAYER(map, i)->group) == 0) {
+      aiIndex[iLayer] = i;
+      iLayer++;
+    }
+  }
+
+  if (iLayer == 0) {
+    free(aiIndex);
+    aiIndex = NULL;
+    *pnCount = 0;
+  } else {
+    aiIndex = (int *)msSmallRealloc(aiIndex, sizeof(int) * iLayer);
+    *pnCount = iLayer;
+  }
+
+  return aiIndex;
+}
+
+/* ==================================================================== */
+/*      Measured shape utility functions.                               */
+/* ==================================================================== */
+
+/************************************************************************/
+/*        pointObj *msGetPointUsingMeasure(shapeObj *shape, double m)   */
+/*                                                                      */
+/*      Using a measured value get the XY location it corresonds        */
+/*      to.                                                             */
+/*                                                                      */
+/************************************************************************/
+pointObj *msGetPointUsingMeasure(shapeObj *shape, double m) {
+  pointObj *point = NULL;
+  int bFound = 0;
+  double dfFirstPointX = 0;
+  double dfFirstPointY = 0;
+  double dfFirstPointM = 0;
+  double dfSecondPointX = 0;
+  double dfSecondPointY = 0;
+  double dfSecondPointM = 0;
+
+  if (shape && shape->numlines > 0) {
+    /* -------------------------------------------------------------------- */
+    /*      check fir the first value (min) and the last value(max) to      */
+    /*      see if the m is contained between these min and max.            */
+    /* -------------------------------------------------------------------- */
+    const lineObj *lineFirst = &(shape->line[0]);
+    const double dfMin = lineFirst->point[0].m;
+    const lineObj *lineLast = &(shape->line[shape->numlines - 1]);
+    const double dfMax = lineLast->point[lineLast->numpoints - 1].m;
+
+    if (m >= dfMin && m <= dfMax) {
+      for (int i = 0; i < shape->numlines; i++) {
+        const lineObj *line = &(shape->line[i]);
+
+        for (int j = 0; j < line->numpoints; j++) {
+          const double dfCurrentM = line->point[j].m;
+          if (dfCurrentM > m) {
+            bFound = 1;
+
+            dfSecondPointX = line->point[j].x;
+            dfSecondPointY = line->point[j].y;
+            dfSecondPointM = line->point[j].m;
+
+            /* --------------------------------------------------------------------
+             */
+            /*      get the previous node xy values. */
+            /* --------------------------------------------------------------------
+             */
+            if (j > 0) { /* not the first point of the line */
+              dfFirstPointX = line->point[j - 1].x;
+              dfFirstPointY = line->point[j - 1].y;
+              dfFirstPointM = line->point[j - 1].m;
+            } else { /* get last point of previous line */
+              dfFirstPointX = shape->line[i - 1].point[0].x;
+              dfFirstPointY = shape->line[i - 1].point[0].y;
+              dfFirstPointM = shape->line[i - 1].point[0].m;
+            }
+            break;
+          }
+        }
+      }
+    }
+
+    if (!bFound)
+      return NULL;
+
+    /* -------------------------------------------------------------------- */
+    /*      extrapolate the m value to get t he xy coordinate.              */
+    /* -------------------------------------------------------------------- */
+
+    double dfFactor = 0;
+    if (dfFirstPointM != dfSecondPointM)
+      dfFactor = (m - dfFirstPointM) / (dfSecondPointM - dfFirstPointM);
+
+    point = (pointObj *)msSmallMalloc(sizeof(pointObj));
+
+    point->x = dfFirstPointX + (dfFactor * (dfSecondPointX - dfFirstPointX));
+    point->y = dfFirstPointY + (dfFactor * (dfSecondPointY - dfFirstPointY));
+    point->m = dfFirstPointM + (dfFactor * (dfSecondPointM - dfFirstPointM));
+
+    return point;
+  }
+
+  return NULL;
+}
+
+/************************************************************************/
+/*       IntersectionPointLinepointObj *p, pointObj *a, pointObj *b)    */
+/*                                                                      */
+/*      Retunrs a point object corresponding to the intersection of     */
+/*      point p and a line formed of 2 points : a and b.                */
+/*                                                                      */
+/*      Alorith base on :                                               */
+/*      http://www.faqs.org/faqs/graphics/algorithms-faq/               */
+/*                                                                      */
+/*      Subject 1.02:How do I find the distance from a point to a line? */
+/*                                                                      */
+/*          Let the point be C (Cx,Cy) and the line be AB (Ax,Ay) to (Bx,By).*/
+/*          Let P be the point of perpendicular projection of C on AB.  The
+ * parameter*/
+/*          r, which indicates P's position along AB, is computed by the dot
+ * product */
+/*          of AC and AB divided by the square of the length of AB:     */
+/*                                                                      */
+/*          (1)     AC dot AB                                           */
+/*              r = ---------                                           */
+/*                  ||AB||^2                                            */
+/*                                                                      */
+/*          r has the following meaning:                                */
+/*                                                                      */
+/*              r=0      P = A                                          */
+/*              r=1      P = B                                          */
+/*              r<0      P is on the backward extension of AB           */
+/*              r>1      P is on the forward extension of AB            */
+/*              0<r<1    P is interior to AB                            */
+/*                                                                      */
+/*          The length of a line segment in d dimensions, AB is computed by:*/
+/*                                                                      */
+/*              L = sqrt( (Bx-Ax)^2 + (By-Ay)^2 + ... + (Bd-Ad)^2)      */
+/*                                                                      */
+/*          so in 2D:                                                   */
+/*                                                                      */
+/*              L = sqrt( (Bx-Ax)^2 + (By-Ay)^2 )                       */
+/*                                                                      */
+/*          and the dot product of two vectors in d dimensions, U dot V is
+ * computed:*/
+/*                                                                      */
+/*              D = (Ux * Vx) + (Uy * Vy) + ... + (Ud * Vd)             */
+/*                                                                      */
+/*          so in 2D:                                                   */
+/*                                                                      */
+/*              D = (Ux * Vx) + (Uy * Vy)                               */
+/*                                                                      */
+/*          So (1) expands to:                                          */
+/*                                                                      */
+/*                  (Cx-Ax)(Bx-Ax) + (Cy-Ay)(By-Ay)                     */
+/*              r = -------------------------------                     */
+/*                                L^2                                   */
+/*                                                                      */
+/*          The point P can then be found:                              */
+/*                                                                      */
+/*              Px = Ax + r(Bx-Ax)                                      */
+/*              Py = Ay + r(By-Ay)                                      */
+/*                                                                      */
+/*          And the distance from A to P = r*L.                         */
+/*                                                                      */
+/*          Use another parameter s to indicate the location along PC, with the
+ */
+/*          following meaning:                                          */
+/*                 s<0      C is left of AB                             */
+/*                 s>0      C is right of AB                            */
+/*                 s=0      C is on AB                                  */
+/*                                                                      */
+/*          Compute s as follows:                                       */
+/*                                                                      */
+/*                  (Ay-Cy)(Bx-Ax)-(Ax-Cx)(By-Ay)                       */
+/*              s = -----------------------------                       */
+/*                              L^2                                     */
+/*                                                                      */
+/*                                                                      */
+/*          Then the distance from C to P = |s|*L.                      */
+/*                                                                      */
+/************************************************************************/
+pointObj *msIntersectionPointLine(pointObj *p, pointObj *a, pointObj *b) {
+  pointObj *result = NULL;
+
+  if (p && a && b) {
+    const double L =
+        sqrt(((b->x - a->x) * (b->x - a->x)) + ((b->y - a->y) * (b->y - a->y)));
+
+    double r = 0;
+    if (L != 0)
+      r = ((p->x - a->x) * (b->x - a->x) + (p->y - a->y) * (b->y - a->y)) /
+          (L * L);
+
+    result = (pointObj *)msSmallMalloc(sizeof(pointObj));
+    /* -------------------------------------------------------------------- */
+    /*      We want to make sure that the point returned is on the line     */
+    /*                                                                      */
+    /*              r=0      P = A                                          */
+    /*              r=1      P = B                                          */
+    /*              r<0      P is on the backward extension of AB           */
+    /*              r>1      P is on the forward extension of AB            */
+    /*                    0<r<1    P is interior to AB                      */
+    /* -------------------------------------------------------------------- */
+    if (r < 0) {
+      result->x = a->x;
+      result->y = a->y;
+    } else if (r > 1) {
+      result->x = b->x;
+      result->y = b->y;
+    } else {
+      result->x = a->x + r * (b->x - a->x);
+      result->y = a->y + r * (b->y - a->y);
+    }
+    result->m = 0;
+  }
+
+  return result;
+}
+
+/************************************************************************/
+/*         pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj   */
+/*      *point)                                                         */
+/*                                                                      */
+/*      Calculate the intersection point betwwen the point and the      */
+/*      shape and return the Measured value at the intersection.        */
+/************************************************************************/
+pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj *point) {
+  pointObj oFirst = {0, 0, 0, 0};
+  pointObj oSecond = {0, 0, 0, 0};
+
+  if (shape && point) {
+    double dfMinDist = HUGE_VAL;
+    for (int i = 0; i < shape->numlines; i++) {
+      lineObj line = shape->line[i];
+      /* -------------------------------------------------------------------- */
+      /*      for each line (2 consecutive lines) get the distance between    */
+      /*      the line and the point and determine which line segment is      */
+      /*      the closeset to the point.                                      */
+      /* -------------------------------------------------------------------- */
+      for (int j = 0; j < line.numpoints - 1; j++) {
+        const double dfDist =
+            msDistancePointToSegment(point, &line.point[j], &line.point[j + 1]);
+        if (dfDist < dfMinDist) {
+          oFirst.x = line.point[j].x;
+          oFirst.y = line.point[j].y;
+          oFirst.m = line.point[j].m;
+
+          oSecond.x = line.point[j + 1].x;
+          oSecond.y = line.point[j + 1].y;
+          oSecond.m = line.point[j + 1].m;
+
+          dfMinDist = dfDist;
+        }
+      }
+    }
+    /* -------------------------------------------------------------------- */
+    /*      once we have the nearest segment, look for the x,y location     */
+    /*      which is the nearest intersection between the line and the      */
+    /*      point.                                                          */
+    /* -------------------------------------------------------------------- */
+    pointObj *poIntersectionPt =
+        msIntersectionPointLine(point, &oFirst, &oSecond);
+    if (poIntersectionPt) {
+      const double dfDistTotal =
+          sqrt(((oSecond.x - oFirst.x) * (oSecond.x - oFirst.x)) +
+               ((oSecond.y - oFirst.y) * (oSecond.y - oFirst.y)));
+
+      const double dfDistToIntersection =
+          sqrt(((poIntersectionPt->x - oFirst.x) *
+                (poIntersectionPt->x - oFirst.x)) +
+               ((poIntersectionPt->y - oFirst.y) *
+                (poIntersectionPt->y - oFirst.y)));
+
+      const double dfFactor = dfDistToIntersection / dfDistTotal;
+
+      poIntersectionPt->m = oFirst.m + (oSecond.m - oFirst.m) * dfFactor;
+      return poIntersectionPt;
+    }
+  }
+  return NULL;
+}
+
+/* ==================================================================== */
+/*   End   Measured shape utility functions.                            */
+/* ==================================================================== */
+
+char **msGetAllGroupNames(mapObj *map, int *numTok) {
+  char **papszGroups = NULL;
+
+  assert(map);
+  *numTok = 0;
+
+  if (!map->layerorder) {
+    map->layerorder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
+
+    /*
+     * Initiate to default order
+     */
+    for (int i = 0; i < map->numlayers; i++)
+      map->layerorder[i] = i;
+  }
+
+  if (map->numlayers > 0) {
+    const int nCount = map->numlayers;
+    papszGroups = (char **)msSmallMalloc(sizeof(char *) * nCount);
+
+    for (int i = 0; i < nCount; i++)
+      papszGroups[i] = NULL;
+
+    for (int i = 0; i < nCount; i++) {
+      layerObj *lp;
+      lp = (GET_LAYER(map, map->layerorder[i]));
+
+      int bFound = 0;
+      if (lp->group && lp->status != MS_DELETE) {
+        for (int j = 0; j < *numTok; j++) {
+          if (papszGroups[j] && strcmp(lp->group, papszGroups[j]) == 0) {
+            bFound = 1;
+            break;
+          }
+        }
+        if (!bFound) {
+          /* New group... add to the list of groups found */
+          papszGroups[(*numTok)] = msStrdup(lp->group);
+          (*numTok)++;
+        }
+      }
+    }
+  }
+
+  return papszGroups;
+}
+
+/************************************************************************/
+/*                         msForceTmpFileBase()                         */
+/************************************************************************/
+
+static int tmpCount = 0;
+static char *ForcedTmpBase = NULL;
+
+void msForceTmpFileBase(const char *new_base) {
+  /* -------------------------------------------------------------------- */
+  /*      Clear previous setting, if any.                                 */
+  /* -------------------------------------------------------------------- */
+  if (ForcedTmpBase != NULL) {
+    free(ForcedTmpBase);
+    ForcedTmpBase = NULL;
+  }
+
+  tmpCount = -1;
+
+  if (new_base == NULL)
+    return;
+
+  /* -------------------------------------------------------------------- */
+  /*      Record new base.                                                */
+  /* -------------------------------------------------------------------- */
+  ForcedTmpBase = msStrdup(new_base);
+  tmpCount = 0;
+}
+
+/**********************************************************************
+ *                          msTmpFile()
+ *
+ * Generate a Unique temporary file.
+ *
+ * Returns char* which must be freed by caller.
+ **********************************************************************/
+char *msTmpFile(mapObj *map, const char *mappath, const char *tmppath,
+                const char *ext) {
+  char szPath[MS_MAXPATHLEN];
+  const char *fullFname;
+  char *tmpFileName; /* big enough for time + pid + ext */
+  char *tmpBase = NULL;
+
+  tmpBase = msTmpPath(map, mappath, tmppath);
+  tmpFileName = msTmpFilename(ext);
+
+  fullFname = msBuildPath(szPath, tmpBase, tmpFileName);
+
+  free(tmpFileName);
+  free(tmpBase);
+
+  if (fullFname)
+    return msStrdup(fullFname);
+
+  return NULL;
+}
+
+/**********************************************************************
+ *                          msTmpPath()
+ *
+ * Return the temporary path based on the platform.
+ *
+ * Returns char* which must be freed by caller.
+ **********************************************************************/
+char *msTmpPath(mapObj *map, const char *mappath, const char *tmppath) {
+  char szPath[MS_MAXPATHLEN];
+  const char *fullPath;
+  const char *tmpBase;
+  const char *ms_temppath;
+#ifdef _WIN32
+  DWORD dwRetVal = 0;
+  TCHAR lpTempPathBuffer[MAX_PATH];
+#endif
+
+  if (ForcedTmpBase != NULL)
+    tmpBase = ForcedTmpBase;
+  else if (tmppath != NULL)
+    tmpBase = tmppath;
+  else if ((ms_temppath = CPLGetConfigOption("MS_TEMPPATH", NULL)) != NULL)
+    tmpBase = ms_temppath;
+  else if (map && map->web.temppath)
+    tmpBase = map->web.temppath;
+  else { /* default paths */
+#ifndef _WIN32
+    tmpBase = "/tmp/";
+#else
+    dwRetVal = GetTempPath(MAX_PATH,          /* length of the buffer */
+                           lpTempPathBuffer); /* buffer for path */
+    if (dwRetVal > MAX_PATH || (dwRetVal == 0)) {
+      tmpBase = "C:\\";
+    } else {
+      tmpBase = (char *)lpTempPathBuffer;
+    }
+#endif
+  }
+
+  fullPath = msBuildPath(szPath, mappath, tmpBase);
+  return msStrdup(fullPath);
+}
+
+/**********************************************************************
+ *                          msTmpFilename()
+ *
+ * Generate a Unique temporary filename.
+ *
+ * Returns char* which must be freed by caller.
+ **********************************************************************/
+char *msTmpFilename(const char *ext) {
+  char *tmpFname;
+  int tmpFnameBufsize;
+  char *fullFname;
+  char tmpId[128]; /* big enough for time + pid + ext */
+
+  snprintf(tmpId, sizeof(tmpId), "%lx_%x", (long)time(NULL), (int)getpid());
+
+  if (ext == NULL)
+    ext = "";
+  tmpFnameBufsize = strlen(tmpId) + 10 + strlen(ext) + 1;
+  tmpFname = (char *)msSmallMalloc(tmpFnameBufsize);
+
+  msAcquireLock(TLOCK_TMPFILE);
+  snprintf(tmpFname, tmpFnameBufsize, "%s_%x.%s", tmpId, tmpCount++, ext);
+  msReleaseLock(TLOCK_TMPFILE);
+
+  fullFname = msStrdup(tmpFname);
+  free(tmpFname);
+
+  return fullFname;
+}
+
+/**
+ *  Generic function to Initalize an image object.
+ */
+imageObj *msImageCreate(int width, int height, outputFormatObj *format,
+                        char *imagepath, char *imageurl, double resolution,
+                        double defresolution, colorObj *bg) {
+  imageObj *image = NULL;
+  if (MS_RENDERER_PLUGIN(format)) {
+
+    image = format->vtable->createImage(width, height, format, bg);
+    if (image == NULL) {
+      msSetError(MS_MEMERR, "Unable to create new image object.",
+                 "msImageCreate()");
+      return NULL;
+    }
+
+    image->format = format;
+    format->refcount++;
+
+    image->width = width;
+    image->height = height;
+    image->imagepath = NULL;
+    image->imageurl = NULL;
+    image->tilecache = NULL;
+    image->ntiles = 0;
+    image->resolution = resolution;
+    image->resolutionfactor = resolution / defresolution;
+
+    if (imagepath)
+      image->imagepath = msStrdup(imagepath);
+    if (imageurl)
+      image->imageurl = msStrdup(imageurl);
+  } else if (MS_RENDERER_RAWDATA(format)) {
+    if (format->imagemode != MS_IMAGEMODE_INT16 &&
+        format->imagemode != MS_IMAGEMODE_FLOAT32 &&
+        format->imagemode != MS_IMAGEMODE_BYTE) {
+      msSetError(MS_IMGERR,
+                 "Attempt to use illegal imagemode with rawdata renderer.",
+                 "msImageCreate()");
+      return NULL;
+    }
+
+    image = (imageObj *)calloc(1, sizeof(imageObj));
+    if (image == NULL) {
+      msSetError(MS_MEMERR, "Unable to create new image object.",
+                 "msImageCreate()");
+      return NULL;
+    }
+
+    if (format->imagemode == MS_IMAGEMODE_INT16)
+      image->img.raw_16bit = (short *)msSmallCalloc(
+          sizeof(short), ((size_t)width) * height * format->bands);
+    else if (format->imagemode == MS_IMAGEMODE_FLOAT32)
+      image->img.raw_float = (float *)msSmallCalloc(
+          sizeof(float), ((size_t)width) * height * format->bands);
+    else if (format->imagemode == MS_IMAGEMODE_BYTE)
+      image->img.raw_byte = (unsigned char *)msSmallCalloc(
+          sizeof(unsigned char), ((size_t)width) * height * format->bands);
+
+    if (image->img.raw_16bit == NULL) {
+      msFree(image);
+      msSetError(MS_IMGERR,
+                 "Attempt to allocate raw image failed, out of memory.",
+                 "msImageCreate()");
+      return NULL;
+    }
+
+    image->img_mask = msAllocBitArray(width * height);
+
+    image->format = format;
+    format->refcount++;
+
+    image->width = width;
+    image->height = height;
+    image->imagepath = NULL;
+    image->imageurl = NULL;
+    image->resolution = resolution;
+    image->resolutionfactor = resolution / defresolution;
+
+    if (imagepath)
+      image->imagepath = msStrdup(imagepath);
+    if (imageurl)
+      image->imageurl = msStrdup(imageurl);
+
+    /* initialize to requested nullvalue if there is one */
+    const char *nullvalue =
+        msGetOutputFormatOption(image->format, "NULLVALUE", NULL);
+    if (nullvalue != NULL) {
+      int i = image->width * image->height * format->bands;
+      if (atof(nullvalue) == 0.0)
+        /* nothing to do */;
+      else if (format->imagemode == MS_IMAGEMODE_INT16) {
+        short nv = atoi(nullvalue);
+        for (; i > 0;)
+          image->img.raw_16bit[--i] = nv;
+      } else if (format->imagemode == MS_IMAGEMODE_FLOAT32) {
+        float nv = atof(nullvalue);
+        for (; i > 0;)
+          image->img.raw_float[--i] = nv;
+      } else if (format->imagemode == MS_IMAGEMODE_BYTE) {
+        unsigned char nv = (unsigned char)atoi(nullvalue);
+
+        memset(image->img.raw_byte, nv, i);
+      }
+    }
+  } else if (MS_RENDERER_IMAGEMAP(format)) {
+    image = msImageCreateIM(width, height, format, imagepath, imageurl,
+                            resolution, defresolution);
+  } else {
+    msSetError(MS_MISCERR,
+               "Unsupported renderer requested, unable to initialize image.",
+               "msImageCreate()");
+    return NULL;
+  }
+
+  if (!image) {
+    msSetError(MS_IMGERR, "Unable to initialize image.", "msImageCreate()");
+    return NULL;
+  }
+  image->refpt.x = image->refpt.y = 0;
+  return image;
+}
+
+/**
+ * Generic function to transorm a point.
+ *
+ */
+void msTransformPoint(pointObj *point, rectObj *extent, double cellsize,
+                      imageObj *image) {
+  double invcellsize;
+  /*We should probabaly have a function defined at all the renders*/
+  if (image != NULL && MS_RENDERER_PLUGIN(image->format)) {
+    if (image->format->renderer == MS_RENDER_WITH_KML) {
+      return;
+    }
+  }
+  invcellsize = 1.0 / cellsize;
+  point->x = MS_MAP2IMAGE_X_IC_DBL(point->x, extent->minx, invcellsize);
+  point->y = MS_MAP2IMAGE_Y_IC_DBL(point->y, extent->maxy, invcellsize);
+}
+
+/*
+** Helper functions supplied as part of bug #2868 solution. Consider moving
+*these to
+** mapprimitive.c for more general use.
+*/
+
+/* vector difference */
+static pointObj point_diff(const pointObj a, const pointObj b) {
+  pointObj retv;
+  retv.x = a.x - b.x;
+  retv.y = a.y - b.y;
+  retv.z = a.z - b.z;
+  retv.m = a.m - b.m;
+  return retv;
+}
+
+/* vector sum */
+static pointObj point_sum(const pointObj a, const pointObj b) {
+  pointObj retv;
+  retv.x = a.x + b.x;
+  retv.y = a.y + b.y;
+  retv.z = a.z + b.z;
+  retv.m = a.m + b.m;
+  return retv;
+}
+
+/* vector multiply */
+static pointObj point_mul(const pointObj a, double b) {
+  pointObj retv;
+  retv.x = a.x * b;
+  retv.y = a.y * b;
+  retv.z = a.z * b;
+  retv.m = a.m * b;
+  return retv;
+}
+
+/* vector ??? */
+static double point_abs2(const pointObj a) {
+  return a.x * a.x + a.y * a.y + a.z * a.z + a.m * a.m;
+}
+
+/* vector normal */
+static pointObj point_norm(const pointObj a) {
+  double lenmul;
+  pointObj retv;
+  int norm_vector;
+
+  norm_vector = a.x == 0 && a.y == 0;
+  norm_vector = norm_vector && a.z == 0 && a.m == 0;
+
+  if (norm_vector)
+    return a;
+
+  lenmul =
+      1.0 / sqrt(point_abs2(a)); /* this seems to be the costly operation */
+
+  retv.x = a.x * lenmul;
+  retv.y = a.y * lenmul;
+  retv.z = a.z * lenmul;
+  retv.m = a.m * lenmul;
+
+  return retv;
+}
+
+/* rotate a vector 90 degrees */
+static pointObj point_rotz90(const pointObj a) {
+  double nx = -1.0 * a.y, ny = a.x;
+  pointObj retv = a;
+  retv.x = nx;
+  retv.y = ny;
+  return retv;
+}
+
+/* vector cross product (warning: z and m dimensions are ignored!) */
+static double point_cross(const pointObj a, const pointObj b) {
+  return a.x * b.y - a.y * b.x;
+}
+
+shapeObj *msOffsetCurve(shapeObj *p, double offset) {
+  shapeObj *ret;
+  int i, j, first, idx, ok = 0;
+#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 ||                             \
+                         (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
+  ret = msGEOSOffsetCurve(p, offset);
+  /* GEOS curve offsetting can fail sometimes, we continue with our own
+   implementation if that is the case.*/
+  if (ret)
+    return ret;
+  /* clear error raised by geos in this case */
+  msResetErrorList();
+#endif
+  /*
+  ** For offset corner point calculation 1/sin() is used
+  ** to avoid 1/0 division (and long spikes) we define a
+  ** limit for sin().
+  */
+#define CURVE_SIN_LIMIT 0.3
+  ret = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+  msInitShape(ret);
+  ret->numlines = p->numlines;
+  ret->line = (lineObj *)msSmallMalloc(sizeof(lineObj) * ret->numlines);
+  for (i = 0; i < ret->numlines; i++) {
+    ret->line[i].numpoints = p->line[i].numpoints;
+    ret->line[i].point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * ret->line[i].numpoints);
+  }
+  for (i = 0; i < p->numlines; i++) {
+    pointObj old_diffdir, old_offdir;
+    if (p->line[i].numpoints < 2) {
+      ret->line[i].numpoints = 0;
+      continue; /* skip degenerate points */
+    }
+    ok = 1;
+    /* initialize old_offdir and old_diffdir, as gcc isn't smart enough to see
+     * that it is not an error to do so, and prints a warning */
+    old_offdir.x = old_offdir.y = old_diffdir.x = old_diffdir.y = 0;
+
+    idx = 0;
+    first = 1;
+
+    /* saved metrics of the last processed point */
+    pointObj old_pt = p->line[i].point[0];
+    for (j = 1; j < p->line[i].numpoints; j++) {
+      const pointObj pt = p->line[i].point[j]; /* place of the point */
+      const pointObj diffdir =
+          point_norm(point_diff(pt, old_pt)); /* direction of the line */
+      const pointObj offdir =
+          point_rotz90(diffdir); /* direction where the distance between the
+                                    line and the offset is measured */
+      pointObj offpt; /* this will be the corner point of the offset line */
+
+      /* offset line points computation */
+      if (first == 1) { /* first point */
+        first = 0;
+        offpt = point_sum(old_pt, point_mul(offdir, offset));
+      } else { /* middle points */
+        /* curve is the angle of the last and the current line's direction
+         * (supplementary angle of the shape's inner angle) */
+        double sin_curve = point_cross(diffdir, old_diffdir);
+        double cos_curve = point_cross(old_offdir, diffdir);
+        if ((-1.0) * CURVE_SIN_LIMIT < sin_curve &&
+            sin_curve < CURVE_SIN_LIMIT) {
+          /* do not calculate 1/sin, instead use a corner point approximation:
+           * average of the last and current offset direction and length */
+
+          /*
+          ** TODO: fair for obtuse inner angles, however, positive and negative
+          ** acute inner angles would need special handling - similar to LINECAP
+          ** to avoid drawing of long spikes
+          */
+          offpt = point_sum(
+              old_pt, point_mul(point_sum(offdir, old_offdir), 0.5 * offset));
+        } else {
+          double base_shift = -1.0 * (1.0 + cos_curve) / sin_curve;
+          offpt = point_sum(
+              old_pt,
+              point_mul(point_sum(point_mul(diffdir, base_shift), offdir),
+                        offset));
+        }
+      }
+      ret->line[i].point[idx] = offpt;
+      idx++;
+      old_pt = pt;
+      old_diffdir = diffdir;
+      old_offdir = offdir;
+    }
+
+    /* last point */
+    if (first == 0) {
+      pointObj offpt = point_sum(old_pt, point_mul(old_offdir, offset));
+      ret->line[i].point[idx] = offpt;
+      idx++;
+    }
+
+    if (idx != p->line[i].numpoints) {
+      /* printf("shouldn't happen :(\n"); */
+      ret->line[i].numpoints = idx;
+      ret->line =
+          msSmallRealloc(ret->line, ret->line[i].numpoints * sizeof(pointObj));
+    }
+  }
+  if (!ok)
+    ret->numlines = 0; /* all lines where degenerate */
+  return ret;
+}
+
+shapeObj *msOffsetPolyline(shapeObj *p, double offsetx, double offsety) {
+  int i, j;
+  shapeObj *ret;
+  if (offsety == MS_STYLE_SINGLE_SIDED_OFFSET) { /* complex calculations */
+    return msOffsetCurve(p, offsetx);
+  } else if (offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
+    shapeObj *tmp1;
+    ret = msOffsetCurve(p, offsetx / 2.0);
+    tmp1 = msOffsetCurve(p, -offsetx / 2.0);
+    for (i = 0; i < tmp1->numlines; i++) {
+      msAddLineDirectly(ret, tmp1->line + i);
+    }
+    msFreeShape(tmp1);
+    free(tmp1);
+    return ret;
+  }
+
+  ret = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+  msInitShape(ret);
+  ret->numlines = p->numlines;
+  ret->line = (lineObj *)msSmallMalloc(sizeof(lineObj) * ret->numlines);
+  for (i = 0; i < ret->numlines; i++) {
+    ret->line[i].numpoints = p->line[i].numpoints;
+    ret->line[i].point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * ret->line[i].numpoints);
+  }
+
+  for (i = 0; i < p->numlines; i++) {
+    for (j = 0; j < p->line[i].numpoints; j++) {
+      ret->line[i].point[j].x = p->line[i].point[j].x + offsetx;
+      ret->line[i].point[j].y = p->line[i].point[j].y + offsety;
+    }
+  }
+
+  return ret;
+}
+
+/*
+-------------------------------------------------------------------------------
+ msSetup()
+
+ Contributed by Jerry Pisk in bug 1203.  Heads off potential race condition
+ in initializing GD font cache with multiple threads.  Should be called from
+ mapscript module initialization code.
+-------------------------------------------------------------------------------
+*/
+
+int msSetup() {
+#ifdef _WIN32
+  const char *maxfiles = CPLGetConfigOption("MS_MAX_OPEN_FILES", NULL);
+  if (maxfiles) {
+    int res = _getmaxstdio();
+    if (res < 2048) {
+      res = _setmaxstdio(atoi(maxfiles));
+      assert(res != -1);
+    }
+  }
+#endif
+
+#ifdef USE_THREAD
+  msThreadInit();
+#endif
+
+  /* Use PROJ_DATA/PROJ_LIB env vars if set */
+  msProjDataInitFromEnv();
+
+  /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
+  if (msDebugInitFromEnv() != MS_SUCCESS)
+    return MS_FAILURE;
+
+#ifdef USE_GEOS
+  msGEOSSetup();
+#endif
+
+#ifdef USE_RSVG
+#if !GLIB_CHECK_VERSION(2, 35, 0)
+  g_type_init();
+#endif
+#endif
+
+  msFontCacheSetup();
+
+  return MS_SUCCESS;
+}
+
+/* This is intended to be a function to cleanup anything that "hangs around"
+   when all maps are destroyed, like Registered GDAL drivers, and so forth. */
+#ifndef NDEBUG
+#if defined(USE_LIBXML2)
+#include "maplibxml2.h"
+#endif
+#endif
+void msCleanup() {
+  msForceTmpFileBase(NULL);
+  msConnPoolFinalCleanup();
+  /* Lexer string parsing variable */
+  if (msyystring_buffer != NULL) {
+    msFree(msyystring_buffer);
+    msyystring_buffer = NULL;
+  }
+  msyylex_destroy();
+
+  msOGRCleanup();
+  msGDALCleanup();
+
+  /* Release both GDAL and OGR resources */
+  msAcquireLock(TLOCK_GDAL);
+  /* Cleanup some GDAL global resources in particular */
+  GDALDestroy();
+  msReleaseLock(TLOCK_GDAL);
+
+  msSetPROJ_DATA(NULL, NULL);
+  msProjectionContextPoolCleanup();
+
+#if defined(USE_CURL)
+  msHTTPCleanup();
+#endif
+
+#ifdef USE_GEOS
+  msGEOSCleanup();
+#endif
+
+/* make valgrind happy on debug code */
+#ifndef NDEBUG
+#ifdef USE_CAIRO
+  msCairoCleanup();
+#endif
+#if defined(USE_LIBXML2)
+  xmlCleanupParser();
+#endif
+#endif
+
+  msFontCacheCleanup();
+
+  msTimeCleanup();
+
+  msIO_Cleanup();
+
+  msResetErrorList();
+
+  /* Close/cleanup log/debug output. Keep this at the very end. */
+  msDebugCleanup();
+
+  /* Clean up the vtable factory */
+  msPluginFreeVirtualTableFactory();
+}
+
+/************************************************************************/
+/*                            msAlphaBlend()                            */
+/*                                                                      */
+/*      Function to overlay/blend an RGBA value into an existing        */
+/*      RGBA value using the Porter-Duff "over" operator.               */
+/*      Primarily intended for use with rasterBufferObj                 */
+/*      raster rendering.  The "src" is the overlay value, and "dst"    */
+/*      is the existing value being overlaid. dst is expected to be     */
+/*      premultiplied, but the source should not be.                    */
+/*                                                                      */
+/*      NOTE: alpha_dst may be NULL.                                    */
+/************************************************************************/
+
+void msAlphaBlend(unsigned char red_src, unsigned char green_src,
+                  unsigned char blue_src, unsigned char alpha_src,
+                  unsigned char *red_dst, unsigned char *green_dst,
+                  unsigned char *blue_dst, unsigned char *alpha_dst) {
+  /* -------------------------------------------------------------------- */
+  /*      Simple cases we want to handle fast.                            */
+  /* -------------------------------------------------------------------- */
+  if (alpha_src == 0)
+    return;
+
+  if (alpha_src == 255) {
+    *red_dst = red_src;
+    *green_dst = green_src;
+    *blue_dst = blue_src;
+    if (alpha_dst)
+      *alpha_dst = 255;
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Premultiple alpha for source values now.                        */
+  /* -------------------------------------------------------------------- */
+  red_src = red_src * alpha_src / 255;
+  green_src = green_src * alpha_src / 255;
+  blue_src = blue_src * alpha_src / 255;
+
+  /* -------------------------------------------------------------------- */
+  /*      Another pretty fast case if there is nothing in the             */
+  /*      destination to mix with.                                        */
+  /* -------------------------------------------------------------------- */
+  if (alpha_dst && *alpha_dst == 0) {
+    *red_dst = red_src;
+    *green_dst = green_src;
+    *blue_dst = blue_src;
+    *alpha_dst = alpha_src;
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Cases with actual blending.                                     */
+  /* -------------------------------------------------------------------- */
+  if (!alpha_dst || *alpha_dst == 255) {
+    int weight_dst = 256 - alpha_src;
+
+    *red_dst = (256 * red_src + *red_dst * weight_dst) >> 8;
+    *green_dst = (256 * green_src + *green_dst * weight_dst) >> 8;
+    *blue_dst = (256 * blue_src + *blue_dst * weight_dst) >> 8;
+  } else {
+    int weight_dst = (256 - alpha_src);
+
+    *red_dst = (256 * red_src + *red_dst * weight_dst) >> 8;
+    *green_dst = (256 * green_src + *green_dst * weight_dst) >> 8;
+    *blue_dst = (256 * blue_src + *blue_dst * weight_dst) >> 8;
+
+    *alpha_dst = (256 * alpha_src + *alpha_dst * weight_dst) >> 8;
+  }
+}
+
+/************************************************************************/
+/*                           msAlphaBlendPM()                           */
+/*                                                                      */
+/*      Same as msAlphaBlend() except that the source RGBA is           */
+/*      assumed to already be premultiplied.                            */
+/************************************************************************/
+
+void msAlphaBlendPM(unsigned char red_src, unsigned char green_src,
+                    unsigned char blue_src, unsigned char alpha_src,
+                    unsigned char *red_dst, unsigned char *green_dst,
+                    unsigned char *blue_dst, unsigned char *alpha_dst) {
+  /* -------------------------------------------------------------------- */
+  /*      Simple cases we want to handle fast.                            */
+  /* -------------------------------------------------------------------- */
+  if (alpha_src == 0)
+    return;
+
+  if (alpha_src == 255) {
+    *red_dst = red_src;
+    *green_dst = green_src;
+    *blue_dst = blue_src;
+    if (alpha_dst)
+      *alpha_dst = 255;
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Another pretty fast case if there is nothing in the             */
+  /*      destination to mix with.                                        */
+  /* -------------------------------------------------------------------- */
+  if (alpha_dst && *alpha_dst == 0) {
+    *red_dst = red_src;
+    *green_dst = green_src;
+    *blue_dst = blue_src;
+    *alpha_dst = alpha_src;
+    return;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Cases with actual blending.                                     */
+  /* -------------------------------------------------------------------- */
+  if (!alpha_dst || *alpha_dst == 255) {
+    int weight_dst = 255 - alpha_src;
+
+    *red_dst = (alpha_src * red_src + *red_dst * weight_dst) >> 8;
+    *green_dst = (alpha_src * green_src + *green_dst * weight_dst) >> 8;
+    *blue_dst = (alpha_src * blue_src + *blue_dst * weight_dst) >> 8;
+  } else {
+    int weight_dst = (255 - alpha_src);
+
+    *red_dst = (alpha_src * red_src + *red_dst * weight_dst) >> 8;
+    *green_dst = (alpha_src * green_src + *green_dst * weight_dst) >> 8;
+    *blue_dst = (alpha_src * blue_src + *blue_dst * weight_dst) >> 8;
+
+    *alpha_dst = (255 * alpha_src + *alpha_dst * weight_dst) >> 8;
+  }
+}
+
+void msRGBtoHSL(colorObj *rgb, double *h, double *s, double *l) {
+  double r = rgb->red / 255.0, g = rgb->green / 255.0, b = rgb->blue / 255.0;
+  double maxv = MS_MAX(MS_MAX(r, g), b), minv = MS_MIN(MS_MIN(r, g), b);
+  double d = maxv - minv;
+
+  *h = 0, *s = 0;
+  *l = (maxv + minv) / 2;
+
+  if (maxv != minv) {
+    *s = *l > 0.5 ? d / (2 - maxv - minv) : d / (maxv + minv);
+    if (maxv == r) {
+      *h = (g - b) / d + (g < b ? 6 : 0);
+    } else if (maxv == g) {
+      *h = (b - r) / d + 2;
+    } else if (maxv == b) {
+      *h = (r - g) / d + 4;
+    }
+    *h /= 6;
+  }
+}
+
+static double hue_to_rgb(double p, double q, double t) {
+  if (t < 0)
+    t += 1;
+  if (t > 1)
+    t -= 1;
+  if (t < 0.1666666666666666)
+    return p + (q - p) * 6 * t;
+  if (t < 0.5)
+    return q;
+  if (t < 0.6666666666666666)
+    return p + (q - p) * (0.666666666666 - t) * 6;
+  return p;
+}
+
+void msHSLtoRGB(double h, double s, double l, colorObj *rgb) {
+  double r, g, b;
+
+  if (s == 0) {
+    r = g = b = l;
+  } else {
+
+    double q = l < 0.5 ? l * (1 + s) : l + s - l * s;
+    double p = 2 * l - q;
+    r = hue_to_rgb(p, q, h + 0.33333333333333333);
+    g = hue_to_rgb(p, q, h);
+    b = hue_to_rgb(p, q, h - 0.33333333333333333);
+  }
+  rgb->red = r * 255;
+  rgb->green = g * 255;
+  rgb->blue = b * 255;
+}
+
+/*
+ RFC 24: check if the parent pointer is NULL and raise an error otherwise
+*/
+int msCheckParentPointer(void *p, const char *objname) {
+  if (p == NULL) {
+    if (objname != NULL) {
+      msSetError(MS_NULLPARENTERR, "The %s parent object is null",
+                 "msCheckParentPointer()", objname);
+    } else {
+      msSetError(MS_NULLPARENTERR, "The parent object is null",
+                 "msCheckParentPointer()");
+    }
+    return MS_FAILURE;
+  }
+  return MS_SUCCESS;
+}
+
+void msBufferInit(bufferObj *buffer) {
+  buffer->data = NULL;
+  buffer->size = 0;
+  buffer->available = 0;
+  buffer->_next_allocation_size = MS_DEFAULT_BUFFER_ALLOC;
+}
+
+void msBufferResize(bufferObj *buffer, size_t target_size) {
+  while (buffer->available <= target_size) {
+    buffer->data = msSmallRealloc(
+        buffer->data, buffer->available + buffer->_next_allocation_size);
+    buffer->available += buffer->_next_allocation_size;
+    buffer->_next_allocation_size *= 2;
+  }
+}
+
+void msBufferAppend(bufferObj *buffer, void *data, size_t length) {
+  if (buffer->available < buffer->size + length) {
+    msBufferResize(buffer, buffer->size + length);
+  }
+  memcpy(&(buffer->data[buffer->size]), data, length);
+  buffer->size += length;
+}
+
+void msBufferFree(bufferObj *buffer) {
+  if (buffer->available > 0)
+    free(buffer->data);
+}
+
+void msFreeRasterBuffer(rasterBufferObj *b) {
+  switch (b->type) {
+  case MS_BUFFER_BYTE_RGBA:
+    msFree(b->data.rgba.pixels);
+    b->data.rgba.pixels = NULL;
+    break;
+  case MS_BUFFER_BYTE_PALETTE:
+    msFree(b->data.palette.pixels);
+    msFree(b->data.palette.palette);
+    b->data.palette.pixels = NULL;
+    b->data.palette.palette = NULL;
+    break;
+  }
+}
+
+/*
+** Issue #3043: Layer extent comparison short circuit.
+**
+** msExtentsOverlap()
+**
+** Returns MS_TRUE if map extent and layer extent overlap,
+** MS_FALSE if they are disjoint, and MS_UNKNOWN if there is
+** not enough info to calculate a deterministic answer.
+**
+*/
+int msExtentsOverlap(mapObj *map, layerObj *layer) {
+  rectObj map_extent;
+  rectObj layer_extent;
+
+  /* No extent info? Nothing we can do, return MS_UNKNOWN. */
+  if ((map->extent.minx == -1) && (map->extent.miny == -1) &&
+      (map->extent.maxx == -1) && (map->extent.maxy == -1))
+    return MS_UNKNOWN;
+  if ((layer->extent.minx == -1) && (layer->extent.miny == -1) &&
+      (layer->extent.maxx == -1) && (layer->extent.maxy == -1))
+    return MS_UNKNOWN;
+
+  /* No map projection? Let someone else sort this out. */
+  if (!(map->projection.numargs > 0))
+    return MS_UNKNOWN;
+
+  /* No layer projection? Perform naive comparison, because they are
+  ** in the same projection. */
+  if (!(layer->projection.numargs > 0))
+    return msRectOverlap(&(map->extent), &(layer->extent));
+
+  /* In the case where map and layer projections are identical, and the */
+  /* bounding boxes don't cross the dateline, do simple rectangle comparison */
+  if (map->extent.minx < map->extent.maxx &&
+      layer->extent.minx < layer->extent.maxx &&
+      !msProjectionsDiffer(&(map->projection), &(layer->projection))) {
+    return msRectOverlap(&(map->extent), &(layer->extent));
+  }
+
+  /* We need to transform our rectangles for comparison,
+  ** so we will work with copies and leave the originals intact. */
+  MS_COPYRECT(&map_extent, &(map->extent));
+  MS_COPYRECT(&layer_extent, &(layer->extent));
+
+  /* Transform map extents into geographics for comparison. */
+  if (msProjectRect(&(map->projection), &(map->latlon), &map_extent))
+    return MS_UNKNOWN;
+
+  /* Transform layer extents into geographics for comparison. */
+  if (msProjectRect(&(layer->projection), &(map->latlon), &layer_extent))
+    return MS_UNKNOWN;
+
+  /* Simple case? Return simple answer. */
+  if (map_extent.minx < map_extent.maxx &&
+      layer_extent.minx < layer_extent.maxx)
+    return msRectOverlap(&(map_extent), &(layer_extent));
+
+  /* Uh oh, one of the rects crosses the dateline!
+  ** Let someone else handle it. */
+  return MS_UNKNOWN;
+}
+
+/************************************************************************/
+/*                             msSmallMalloc()                          */
+/************************************************************************/
+
+/* Safe version of malloc(). This function is taken from gdal/cpl. */
+
+void *msSmallMalloc(size_t nSize) {
+  void *pReturn;
+
+  if (MS_UNLIKELY(nSize == 0))
+    return NULL;
+
+  pReturn = malloc(nSize);
+  if (MS_UNLIKELY(pReturn == NULL)) {
+    msIO_fprintf(stderr,
+                 "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
+                 (long)nSize);
+    exit(1);
+  }
+
+  return pReturn;
+}
+
+/************************************************************************/
+/*                             msSmallRealloc()                         */
+/************************************************************************/
+
+/* Safe version of realloc(). This function is taken from gdal/cpl. */
+
+void *msSmallRealloc(void *pData, size_t nNewSize) {
+  void *pReturn;
+
+  if (MS_UNLIKELY(nNewSize == 0))
+    return NULL;
+
+  pReturn = realloc(pData, nNewSize);
+
+  if (MS_UNLIKELY(pReturn == NULL)) {
+    msIO_fprintf(stderr,
+                 "msSmallRealloc(): Out of memory allocating %ld bytes.\n",
+                 (long)nNewSize);
+    exit(1);
+  }
+
+  return pReturn;
+}
+
+/************************************************************************/
+/*                             msSmallCalloc()                         */
+/************************************************************************/
+
+/* Safe version of calloc(). This function is taken from gdal/cpl. */
+
+void *msSmallCalloc(size_t nCount, size_t nSize) {
+  void *pReturn;
+
+  if (MS_UNLIKELY(nSize * nCount == 0))
+    return NULL;
+
+  pReturn = calloc(nCount, nSize);
+  if (MS_UNLIKELY(pReturn == NULL)) {
+    msIO_fprintf(stderr,
+                 "msSmallCalloc(): Out of memory allocating %ld bytes.\n",
+                 (long)(nCount * nSize));
+    exit(1);
+  }
+
+  return pReturn;
+}
+
+/*
+** msBuildOnlineResource()
+**
+** Try to build the online resource (mapserv URL) for this service.
+** "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?"
+** (+append the map=... param if it was explicitly passed in QUERY_STRING)
+**
+** Returns a newly allocated string that should be freed by the caller or
+** NULL in case of error.
+*/
+char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req) {
+  (void)map;
+  char *online_resource = NULL;
+  const char *value, *hostname, *port, *script, *protocol = "http",
+                                                *mapparam = NULL;
+  char **hostname_array = NULL;
+  int mapparam_len = 0, hostname_array_len = 0;
+
+  hostname = getenv("HTTP_X_FORWARDED_HOST");
+  if (!hostname)
+    hostname = getenv("SERVER_NAME");
+  else {
+    if (strchr(hostname, ',')) {
+      hostname_array = msStringSplit(hostname, ',', &hostname_array_len);
+      hostname = hostname_array[0];
+    }
+  }
+
+  port = getenv("HTTP_X_FORWARDED_PORT");
+  if (!port)
+    port = getenv("SERVER_PORT");
+
+  script = getenv("SCRIPT_NAME");
+
+  /* HTTPS is set by Apache to "on" in an HTTPS server ... if not set */
+  /* then check SERVER_PORT: 443 is the default https port. */
+  if (((value = getenv("HTTPS")) && strcasecmp(value, "on") == 0) ||
+      ((value = getenv("SERVER_PORT")) && atoi(value) == 443)) {
+    protocol = "https";
+  }
+  if ((value = getenv("HTTP_X_FORWARDED_PROTO"))) {
+    protocol = value;
+  }
+
+  /* If map=.. was explicitly set then we'll include it in onlineresource
+   */
+  if (req->type == MS_GET_REQUEST) {
+    int i;
+    for (i = 0; i < req->NumParams; i++) {
+      if (strcasecmp(req->ParamNames[i], "map") == 0) {
+        mapparam = req->ParamValues[i];
+        mapparam_len = strlen(mapparam) + 5; /* +5 for "map="+"&" */
+        break;
+      }
+    }
+  }
+
+  if (hostname && port && script) {
+    size_t buffer_size;
+    buffer_size =
+        strlen(hostname) + strlen(port) + strlen(script) + mapparam_len +
+        11; /* 11 comes from https://[host]:[port][scriptname]?[map]\0, i.e.
+               "https://:?\0" */
+    online_resource = (char *)msSmallMalloc(buffer_size);
+    if ((atoi(port) == 80 && strcmp(protocol, "http") == 0) ||
+        (atoi(port) == 443 && strcmp(protocol, "https") == 0))
+      snprintf(online_resource, buffer_size, "%s://%s%s?", protocol, hostname,
+               script);
+    else
+      snprintf(online_resource, buffer_size, "%s://%s:%s%s?", protocol,
+               hostname, port, script);
+
+    if (mapparam) {
+      int baselen;
+      baselen = strlen(online_resource);
+      snprintf(online_resource + baselen, buffer_size - baselen, "map=%s&",
+               mapparam);
+    }
+  } else {
+    msSetError(MS_CGIERR, "Impossible to establish server URL.",
+               "msBuildOnlineResource()");
+    return NULL;
+  }
+  if (hostname_array) {
+    msFreeCharArray(hostname_array, hostname_array_len);
+  }
+
+  return online_resource;
+}
+
+/************************************************************************/
+/*                             msIntegerInArray()                        */
+/************************************************************************/
+
+/* Check if a integer is in a array */
+int msIntegerInArray(const int value, int *array, int numelements) {
+  int i;
+  for (i = 0; i < numelements; ++i) {
+    if (value == array[i])
+      return MS_TRUE;
+  }
+  return MS_FALSE;
+}
+
+/************************************************************************
+ *                            msMapSetProjections                       *
+ *                                                                      *
+ *   Ensure that all the layers in the map file have a projection       *
+ *   by copying the map-level projection to all layers than have no     *
+ *   projection.                                                        *
+ ************************************************************************/
+
+int msMapSetLayerProjections(mapObj *map) {
+
+  char *mapProjStr = NULL;
+  int i;
+
+  if (map->projection.numargs <= 0) {
+    msSetError(MS_WMSERR,
+               "Cannot set new SRS on a map that doesn't "
+               "have any projection set. Please make sure your mapfile "
+               "has a PROJECTION defined at the top level.",
+               "msTileSetProjectionst()");
+    return (MS_FAILURE);
+  }
+
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp = GET_LAYER(map, i);
+    /* This layer is turned on and needs a projection? */
+    if (lp->projection.numargs <= 0 && lp->status != MS_OFF &&
+        lp->transform == MS_TRUE) {
+
+      /* Fetch main map projection string only now that we need it */
+      if (mapProjStr == NULL)
+        mapProjStr = msGetProjectionString(&(map->projection));
+
+      /* Set the projection to the map file projection */
+      if (msLoadProjectionString(&(lp->projection), mapProjStr) != 0) {
+        msSetError(MS_CGIERR, "Unable to set projection on layer.",
+                   "msMapSetLayerProjections()");
+        return (MS_FAILURE);
+      }
+      lp->project = MS_TRUE;
+      if (lp->connection &&
+          IS_THIRDPARTY_LAYER_CONNECTIONTYPE(lp->connectiontype)) {
+        char **reflayers;
+        int numreflayers, j;
+        reflayers = msStringSplit(lp->connection, ',', &numreflayers);
+        for (j = 0; j < numreflayers; j++) {
+          int *lidx, nlidx;
+          /* first check layers referenced by group name */
+          lidx = msGetLayersIndexByGroup(map, reflayers[i], &nlidx);
+          if (lidx) {
+            int k;
+            for (k = 0; k < nlidx; k++) {
+              layerObj *glp = GET_LAYER(map, lidx[k]);
+              if (glp->projection.numargs <= 0 && glp->transform == MS_TRUE) {
+
+                /* Set the projection to the map file projection */
+                if (msLoadProjectionString(&(glp->projection), mapProjStr) !=
+                    0) {
+                  msSetError(MS_CGIERR, "Unable to set projection on layer.",
+                             "msMapSetLayerProjections()");
+                  return (MS_FAILURE);
+                }
+                glp->project = MS_TRUE;
+              }
+            }
+            free(lidx);
+          } else {
+            /* group name did not match, check by layer name */
+            int layer_idx = msGetLayerIndex(map, lp->connection);
+            layerObj *glp = GET_LAYER(map, layer_idx);
+            if (glp->projection.numargs <= 0 && glp->transform == MS_TRUE) {
+
+              /* Set the projection to the map file projection */
+              if (msLoadProjectionString(&(glp->projection), mapProjStr) != 0) {
+                msSetError(MS_CGIERR, "Unable to set projection on layer.",
+                           "msMapSetLayerProjections()");
+                return (MS_FAILURE);
+              }
+              glp->project = MS_TRUE;
+            }
+          }
+        }
+        msFreeCharArray(reflayers, numreflayers);
+      }
+    }
+  }
+  msFree(mapProjStr);
+  return (MS_SUCCESS);
+}
+
+/************************************************************************
+ *                    msMapSetLanguageSpecificConnection                *
+ *                                                                      *
+ *   Override DATA and CONNECTION of each layer with their specific     *
+ *  variant for the specified language.                                 *
+ ************************************************************************/
+
+void msMapSetLanguageSpecificConnection(mapObj *map,
+                                        const char *validated_language) {
+  int i;
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *layer = GET_LAYER(map, i);
+    if (layer->data)
+      layer->data =
+          msCaseReplaceSubstring(layer->data, "%language%", validated_language);
+    if (layer->connection)
+      layer->connection = msCaseReplaceSubstring(
+          layer->connection, "%language%", validated_language);
+  }
+}
+
+/* Generalize a shape based of the tolerance.
+   Ref: http://trac.osgeo.org/gdal/ticket/966 */
+shapeObj *msGeneralize(shapeObj *shape, double tolerance) {
+  lineObj newLine = {0, NULL};
+  const double sqTolerance = tolerance * tolerance;
+
+  shapeObj *newShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+  msInitShape(newShape);
+  msCopyShape(shape, newShape);
+
+  if (shape->numlines < 1)
+    return newShape;
+
+  /* Clean shape */
+  for (int i = 0; i < newShape->numlines; i++)
+    free(newShape->line[i].point);
+  newShape->numlines = 0;
+  if (newShape->line)
+    free(newShape->line);
+
+  msAddLine(newShape, &newLine);
+
+  if (shape->line[0].numpoints == 0) {
+    return newShape;
+  }
+
+  msAddPointToLine(&newShape->line[0], &shape->line[0].point[0]);
+  double dX0 = shape->line[0].point[0].x;
+  double dY0 = shape->line[0].point[0].y;
+
+  for (int i = 1; i < shape->line[0].numpoints; i++) {
+    double dX1 = shape->line[0].point[i].x;
+    double dY1 = shape->line[0].point[i].y;
+
+    const double dX = dX1 - dX0;
+    const double dY = dY1 - dY0;
+    const double dSqDist = dX * dX + dY * dY;
+    if (i == shape->line[0].numpoints - 1 || dSqDist >= sqTolerance) {
+      pointObj p;
+      p.x = dX1;
+      p.y = dY1;
+
+      /* Keep this point (always keep the last point) */
+      msAddPointToLine(&newShape->line[0], &p);
+      dX0 = dX1;
+      dY0 = dY1;
+    }
+  }
+
+  return newShape;
+}
+
+void msSetLayerOpacity(layerObj *layer, int opacity) {
+  if (!layer->compositer) {
+    layer->compositer = msSmallMalloc(sizeof(LayerCompositer));
+    initLayerCompositer(layer->compositer);
+  }
+  layer->compositer->opacity = opacity;
+}
diff -pruN 8.0.1-5/src/mapuvraster.c 8.2.0~beta1-1~exp1/src/mapuvraster.c
--- 8.0.1-5/src/mapuvraster.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapuvraster.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1109 @@
+/**********************************************************************
+ * $Id: mapuv.c 12629 2011-10-06 18:06:34Z aboudreault $
+ *
+ * Project:  MapServer
+ * Purpose:  UV Layer
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2011, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include "mapserver.h"
+
+#include <assert.h>
+#include <math.h>
+#include <stdbool.h>
+#include "mapows.h"
+#include "mapresample.h"
+#include "mapthread.h"
+
+#define MSUVRASTER_NUMITEMS 6
+#define MSUVRASTER_ANGLE "uv_angle"
+#define MSUVRASTER_ANGLEINDEX -100
+#define MSUVRASTER_MINUS_ANGLE "uv_minus_angle"
+#define MSUVRASTER_MINUSANGLEINDEX -101
+#define MSUVRASTER_LENGTH "uv_length"
+#define MSUVRASTER_LENGTHINDEX -102
+#define MSUVRASTER_LENGTH_2 "uv_length_2"
+#define MSUVRASTER_LENGTH2INDEX -103
+#define MSUVRASTER_U "u"
+#define MSUVRASTER_UINDEX -104
+#define MSUVRASTER_V "v"
+#define MSUVRASTER_VINDEX -105
+#define MSUVRASTER_LON "lon"
+#define MSUVRASTER_LONINDEX -106
+#define MSUVRASTER_LAT "lat"
+#define MSUVRASTER_LATINDEX -107
+
+#define RQM_UNKNOWN 0
+#define RQM_ENTRY_PER_PIXEL 1
+#define RQM_HIST_ON_CLASS 2
+#define RQM_HIST_ON_VALUE 3
+
+typedef struct {
+
+  /* query cache results */
+  int query_results;
+  /* int query_alloc_max;
+  int query_request_max;
+  int query_result_hard_max;
+  int raster_query_mode; */
+  int band_count;
+
+  int refcount;
+
+  /* query bound in force
+     shapeObj *searchshape;*/
+
+  /* Only nearest result to this point.
+  int      range_mode; MS_QUERY_SINGLE, MS_QUERY_MULTIPLE or -1 (skip test)
+  double   range_dist;
+  pointObj target_point;*/
+
+  /* double   shape_tolerance; */
+
+  float **u; /* u values */
+  float **v; /* v values */
+  int width;
+  int height;
+  rectObj extent;
+  int next_shape;
+  int x, y; /* used internally in msUVRasterLayerNextShape() */
+
+  bool needsLonLat;
+  reprojectionObj *reprojectorToLonLat;
+
+  mapObj
+      *mapToUseForWhichShapes; /* set if the map->extent and map->projection are
+                                  valid in msUVRASTERLayerWhichShapes() */
+
+} uvRasterLayerInfo;
+
+void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj *layer,
+                                                                mapObj *map) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  uvlinfo->mapToUseForWhichShapes = map;
+}
+
+static int msUVRASTERLayerInitItemInfo(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  int i;
+  int *itemindexes;
+  int failed = 0;
+
+  if (layer->numitems == 0)
+    return MS_SUCCESS;
+
+  if (uvlinfo == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: GDAL layer not opened!!!",
+               "msUVRASTERLayerInitItemInfo()");
+    return (MS_FAILURE);
+  }
+
+  if (layer->iteminfo)
+    free(layer->iteminfo);
+
+  if ((layer->iteminfo = (int *)malloc(sizeof(int) * layer->numitems)) ==
+      NULL) {
+    msSetError(MS_MEMERR, NULL, "msUVRASTERLayerInitItemInfo()");
+    return (MS_FAILURE);
+  }
+
+  itemindexes = (int *)layer->iteminfo;
+  for (i = 0; i < layer->numitems; i++) {
+    /* Special attribute names. */
+    if (EQUAL(layer->items[i], MSUVRASTER_ANGLE))
+      itemindexes[i] = MSUVRASTER_ANGLEINDEX;
+    else if (EQUAL(layer->items[i], MSUVRASTER_MINUS_ANGLE))
+      itemindexes[i] = MSUVRASTER_MINUSANGLEINDEX;
+    else if (EQUAL(layer->items[i], MSUVRASTER_LENGTH))
+      itemindexes[i] = MSUVRASTER_LENGTHINDEX;
+    else if (EQUAL(layer->items[i], MSUVRASTER_LENGTH_2))
+      itemindexes[i] = MSUVRASTER_LENGTH2INDEX;
+    else if (EQUAL(layer->items[i], MSUVRASTER_U))
+      itemindexes[i] = MSUVRASTER_UINDEX;
+    else if (EQUAL(layer->items[i], MSUVRASTER_V))
+      itemindexes[i] = MSUVRASTER_VINDEX;
+    else if (EQUAL(layer->items[i], MSUVRASTER_LON)) {
+      uvlinfo->needsLonLat = true;
+      itemindexes[i] = MSUVRASTER_LONINDEX;
+    } else if (EQUAL(layer->items[i], MSUVRASTER_LAT)) {
+      uvlinfo->needsLonLat = true;
+      itemindexes[i] = MSUVRASTER_LATINDEX;
+    } else {
+      itemindexes[i] = -1;
+      msSetError(MS_MISCERR, "Invalid Field name: %s",
+                 "msUVRASTERLayerInitItemInfo()", layer->items[i]);
+      failed = 1;
+    }
+  }
+
+  return failed ? (MS_FAILURE) : (MS_SUCCESS);
+}
+
+void msUVRASTERLayerFreeItemInfo(layerObj *layer) {
+  if (layer->iteminfo)
+    free(layer->iteminfo);
+  layer->iteminfo = NULL;
+}
+
+static void msUVRasterLayerInfoInitialize(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+
+  if (uvlinfo != NULL)
+    return;
+
+  uvlinfo = (uvRasterLayerInfo *)msSmallCalloc(1, sizeof(uvRasterLayerInfo));
+  layer->layerinfo = uvlinfo;
+
+  uvlinfo->band_count = -1;
+  /* uvlinfo->raster_query_mode = RQM_ENTRY_PER_PIXEL; */
+  /* uvlinfo->range_mode = -1; /\* inactive *\/ */
+  /* uvlinfo->refcount = 0; */
+  /* uvlinfo->shape_tolerance = 0.0; */
+  uvlinfo->u = NULL;
+  uvlinfo->v = NULL;
+  uvlinfo->width = 0;
+  uvlinfo->height = 0;
+
+  /* Set attribute type to Real, unless the user has explicitly set */
+  /* something else. */
+  {
+    const char *const items[] = {
+        MSUVRASTER_ANGLE,    MSUVRASTER_MINUS_ANGLE, MSUVRASTER_LENGTH,
+        MSUVRASTER_LENGTH_2, MSUVRASTER_U,           MSUVRASTER_V,
+    };
+    size_t i;
+    for (i = 0; i < sizeof(items) / sizeof(items[0]); ++i) {
+      char szTmp[100];
+      snprintf(szTmp, sizeof(szTmp), "%s_type", items[i]);
+      if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
+        snprintf(szTmp, sizeof(szTmp), "gml_%s_type", items[i]);
+        msInsertHashTable(&(layer->metadata), szTmp, "Real");
+      }
+    }
+  }
+
+  /* uvlinfo->query_result_hard_max = 1000000; */
+
+  /* if( CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" )  */
+  /*     != NULL ) */
+  /* { */
+  /*     uvlinfo->query_result_hard_max =  */
+  /*         atoi(CSLFetchNameValue( layer->processing,
+   * "RASTER_QUERY_MAX_RESULT" )); */
+  /* } */
+}
+
+static void msUVRasterLayerInfoFree(layerObj *layer)
+
+{
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  int i;
+
+  if (uvlinfo == NULL)
+    return;
+
+  if (uvlinfo->u) {
+    for (i = 0; i < uvlinfo->width; ++i) {
+      free(uvlinfo->u[i]);
+    }
+    free(uvlinfo->u);
+  }
+
+  if (uvlinfo->v) {
+    for (i = 0; i < uvlinfo->width; ++i) {
+      free(uvlinfo->v[i]);
+    }
+    free(uvlinfo->v);
+  }
+
+  if (uvlinfo->reprojectorToLonLat) {
+    msProjectDestroyReprojector(uvlinfo->reprojectorToLonLat);
+  }
+
+  free(uvlinfo);
+
+  layer->layerinfo = NULL;
+}
+
+int msUVRASTERLayerOpen(layerObj *layer) {
+  /* If we don't have info, initialize an empty one now */
+  if (layer->layerinfo == NULL)
+    msUVRasterLayerInfoInitialize(layer);
+  if (layer->layerinfo == NULL)
+    return MS_FAILURE;
+
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+
+  uvlinfo->refcount = uvlinfo->refcount + 1;
+
+  return MS_SUCCESS;
+}
+
+int msUVRASTERLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
+    return MS_TRUE;
+  return MS_FALSE;
+}
+
+int msUVRASTERLayerClose(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+
+  if (uvlinfo != NULL) {
+    uvlinfo->refcount--;
+
+    if (uvlinfo->refcount < 1)
+      msUVRasterLayerInfoFree(layer);
+  }
+  return MS_SUCCESS;
+}
+
+int msUVRASTERLayerGetItems(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+
+  if (uvlinfo == NULL)
+    return MS_FAILURE;
+
+  layer->numitems = 0;
+  layer->items = (char **)msSmallCalloc(sizeof(char *), 10);
+
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_ANGLE);
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_MINUS_ANGLE);
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_LENGTH);
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_LENGTH_2);
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_U);
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_V);
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_LON);
+  layer->items[layer->numitems++] = msStrdup(MSUVRASTER_LAT);
+  layer->items[layer->numitems] = NULL;
+
+  return msUVRASTERLayerInitItemInfo(layer);
+}
+
+/**********************************************************************
+ *                     msUVRASTERGetValues()
+ *
+ * Special attribute names are used to return some UV params: uv_angle,
+ * uv_length, u and v.
+ **********************************************************************/
+static char **msUVRASTERGetValues(layerObj *layer, float u, float v,
+                                  const pointObj *point) {
+  char **values;
+  int i = 0;
+  char tmp[100];
+  float size_scale;
+  int *itemindexes = (int *)layer->iteminfo;
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  double lon = HUGE_VAL;
+  double lat = HUGE_VAL;
+
+  if (layer->numitems == 0)
+    return (NULL);
+
+  if (!layer->iteminfo) { /* Should not happen... but just in case! */
+    if (msUVRASTERLayerInitItemInfo(layer) != MS_SUCCESS)
+      return NULL;
+    itemindexes = (int *)layer->iteminfo; /* reassign after malloc */
+  }
+
+  if ((values = (char **)malloc(sizeof(char *) * layer->numitems)) == NULL) {
+    msSetError(MS_MEMERR, NULL, "msUVRASTERGetValues()");
+    return (NULL);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*    Determine desired size_scale.  Default to 1 if not otherwise set  */
+  /* -------------------------------------------------------------------- */
+  size_scale = 1;
+  if (CSLFetchNameValue(layer->processing, "UV_SIZE_SCALE") != NULL) {
+    size_scale = atof(CSLFetchNameValue(layer->processing, "UV_SIZE_SCALE"));
+  }
+
+  if (uvlinfo->needsLonLat) {
+    if (uvlinfo->reprojectorToLonLat == NULL)
+      uvlinfo->reprojectorToLonLat =
+          msProjectCreateReprojector(&layer->projection, NULL);
+    if (uvlinfo->reprojectorToLonLat) {
+      pointObj pointWrk = *point;
+      if (msProjectPointEx(uvlinfo->reprojectorToLonLat, &pointWrk) ==
+          MS_SUCCESS) {
+        lon = pointWrk.x;
+        lat = pointWrk.y;
+      }
+    }
+  }
+
+  for (i = 0; i < layer->numitems; i++) {
+    if (itemindexes[i] == MSUVRASTER_ANGLEINDEX) {
+      snprintf(tmp, 100, "%f", (atan2((double)v, (double)u) * 180 / MS_PI));
+      values[i] = msStrdup(tmp);
+    } else if (itemindexes[i] == MSUVRASTER_MINUSANGLEINDEX) {
+      double minus_angle;
+      minus_angle = (atan2((double)v, (double)u) * 180 / MS_PI) + 180;
+      if (minus_angle >= 360)
+        minus_angle -= 360;
+      snprintf(tmp, 100, "%f", minus_angle);
+      values[i] = msStrdup(tmp);
+    } else if ((itemindexes[i] == MSUVRASTER_LENGTHINDEX) ||
+               (itemindexes[i] == MSUVRASTER_LENGTH2INDEX)) {
+      float length = sqrt((u * u) + (v * v)) * size_scale;
+
+      if (itemindexes[i] == MSUVRASTER_LENGTHINDEX)
+        snprintf(tmp, 100, "%f", length);
+      else
+        snprintf(tmp, 100, "%f", length / 2);
+
+      values[i] = msStrdup(tmp);
+    } else if (itemindexes[i] == MSUVRASTER_UINDEX) {
+      snprintf(tmp, 100, "%f", u);
+      values[i] = msStrdup(tmp);
+    } else if (itemindexes[i] == MSUVRASTER_VINDEX) {
+      snprintf(tmp, 100, "%f", v);
+      values[i] = msStrdup(tmp);
+    } else if (itemindexes[i] == MSUVRASTER_LONINDEX) {
+      snprintf(tmp, sizeof(tmp), "%.18g", lon);
+      values[i] = msStrdup(tmp);
+    } else if (itemindexes[i] == MSUVRASTER_LATINDEX) {
+      snprintf(tmp, sizeof(tmp), "%.18g", lat);
+      values[i] = msStrdup(tmp);
+    } else {
+      values[i] = NULL;
+    }
+  }
+
+  return values;
+}
+
+rectObj msUVRASTERGetSearchRect(layerObj *layer, mapObj *map) {
+  rectObj searchrect = map->extent;
+  int bDone = MS_FALSE;
+
+  /* For UVRaster, it is important that the searchrect is not too large */
+  /* to avoid insufficient intermediate raster resolution, which could */
+  /* happen if we use the default code path, given potential reprojection */
+  /* issues when using a map extent that is not in the validity area of */
+  /* the layer projection. */
+  if (!layer->projection.gt.need_geotransform &&
+      !(msProjIsGeographicCRS(&(map->projection)) &&
+        msProjIsGeographicCRS(&(layer->projection)))) {
+    rectObj layer_ori_extent;
+
+    if (msLayerGetExtent(layer, &layer_ori_extent) == MS_SUCCESS) {
+      projectionObj map_proj;
+
+      double map_extent_minx = map->extent.minx;
+      double map_extent_miny = map->extent.miny;
+      double map_extent_maxx = map->extent.maxx;
+      double map_extent_maxy = map->extent.maxy;
+      rectObj layer_extent = layer_ori_extent;
+
+      /* Create a variant of map->projection without geotransform for */
+      /* conveniency */
+      msInitProjection(&map_proj);
+      msCopyProjection(&map_proj, &map->projection);
+      map_proj.gt.need_geotransform = MS_FALSE;
+      if (map->projection.gt.need_geotransform) {
+        map_extent_minx =
+            map->projection.gt.geotransform[0] +
+            map->projection.gt.geotransform[1] * map->extent.minx +
+            map->projection.gt.geotransform[2] * map->extent.miny;
+        map_extent_miny =
+            map->projection.gt.geotransform[3] +
+            map->projection.gt.geotransform[4] * map->extent.minx +
+            map->projection.gt.geotransform[5] * map->extent.miny;
+        map_extent_maxx =
+            map->projection.gt.geotransform[0] +
+            map->projection.gt.geotransform[1] * map->extent.maxx +
+            map->projection.gt.geotransform[2] * map->extent.maxy;
+        map_extent_maxy =
+            map->projection.gt.geotransform[3] +
+            map->projection.gt.geotransform[4] * map->extent.maxx +
+            map->projection.gt.geotransform[5] * map->extent.maxy;
+      }
+
+      /* Reproject layer extent to map projection */
+      msProjectRect(&layer->projection, &map_proj, &layer_extent);
+
+      if (layer_extent.minx <= map_extent_minx &&
+          layer_extent.miny <= map_extent_miny &&
+          layer_extent.maxx >= map_extent_maxx &&
+          layer_extent.maxy >= map_extent_maxy) {
+        /* do nothing special if area to map is inside layer extent */
+      } else {
+        if (layer_extent.minx >= map_extent_minx &&
+            layer_extent.maxx <= map_extent_maxx &&
+            layer_extent.miny >= map_extent_miny &&
+            layer_extent.maxy <= map_extent_maxy) {
+          /* if the area to map is larger than the layer extent, then */
+          /* use full layer extent and add some margin to reflect the */
+          /* proportion of the useful area over the requested bbox */
+          double extra_x = (map_extent_maxx - map_extent_minx) /
+                           (layer_extent.maxx - layer_extent.minx) *
+                           (layer_ori_extent.maxx - layer_ori_extent.minx);
+          double extra_y = (map_extent_maxy - map_extent_miny) /
+                           (layer_extent.maxy - layer_extent.miny) *
+                           (layer_ori_extent.maxy - layer_ori_extent.miny);
+          searchrect.minx = layer_ori_extent.minx - extra_x / 2;
+          searchrect.maxx = layer_ori_extent.maxx + extra_x / 2;
+          searchrect.miny = layer_ori_extent.miny - extra_y / 2;
+          searchrect.maxy = layer_ori_extent.maxy + extra_y / 2;
+        } else {
+          /* otherwise clip the map extent with the reprojected layer */
+          /* extent */
+          searchrect.minx = MS_MAX(map_extent_minx, layer_extent.minx);
+          searchrect.maxx = MS_MIN(map_extent_maxx, layer_extent.maxx);
+          searchrect.miny = MS_MAX(map_extent_miny, layer_extent.miny);
+          searchrect.maxy = MS_MIN(map_extent_maxy, layer_extent.maxy);
+          /* and reproject into the layer projection */
+          msProjectRect(&map_proj, &layer->projection, &searchrect);
+        }
+        bDone = MS_TRUE;
+      }
+
+      msFreeProjection(&map_proj);
+    }
+  }
+
+  if (!bDone)
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
+
+  return searchrect;
+}
+
+int msUVRASTERLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  imageObj *image_tmp;
+  outputFormatObj *outputformat = NULL;
+  mapObj *map_tmp;
+  double map_cellsize;
+  unsigned int spacing;
+  int width, height, u_src_off, v_src_off, i, x, y;
+  char **alteredProcessing = NULL, *saved_layer_mask;
+  char **savedProcessing = NULL;
+  int bHasLonWrap = MS_FALSE;
+  double dfLonWrap = 0.0;
+  rectObj oldLayerExtent = {0};
+  char *oldLayerData = NULL;
+  projectionObj oldLayerProjection = {0};
+  int ret;
+
+  if (layer->debug)
+    msDebug("Entering msUVRASTERLayerWhichShapes().\n");
+
+  if (uvlinfo == NULL)
+    return MS_FAILURE;
+
+  if (CSLFetchNameValue(layer->processing, "BANDS") == NULL) {
+    msSetError(MS_MISCERR,
+               "BANDS processing option is required for UV layer. You have to "
+               "specified 2 bands.",
+               "msUVRASTERLayerWhichShapes()");
+    return MS_FAILURE;
+  }
+
+  /*
+  ** Allocate mapObj structure
+  */
+  map_tmp = (mapObj *)msSmallCalloc(sizeof(mapObj), 1);
+  if (initMap(map_tmp) == -1) { /* initialize this map */
+    msFree(map_tmp);
+    return (MS_FAILURE);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Determine desired spacing.  Default to 32 if not otherwise set  */
+  /* -------------------------------------------------------------------- */
+  spacing = 32;
+  if (CSLFetchNameValue(layer->processing, "UV_SPACING") != NULL) {
+    spacing = atoi(CSLFetchNameValue(layer->processing, "UV_SPACING"));
+    if (spacing == 0)
+      spacing = 32;
+  }
+
+  width = (int)(layer->map->width / spacing);
+  height = (int)(layer->map->height / spacing);
+
+  /* Initialize our dummy map */
+  MS_INIT_COLOR(map_tmp->imagecolor, 255, 255, 255, 255);
+  map_tmp->resolution = layer->map->resolution;
+  map_tmp->defresolution = layer->map->defresolution;
+
+  outputformat = (outputFormatObj *)msSmallCalloc(1, sizeof(outputFormatObj));
+  outputformat->bands = uvlinfo->band_count = 2;
+  outputformat->name = NULL;
+  outputformat->driver = NULL;
+  outputformat->refcount = 0;
+  outputformat->vtable = NULL;
+  outputformat->device = NULL;
+  outputformat->renderer = MS_RENDER_WITH_RAWDATA;
+  outputformat->imagemode = MS_IMAGEMODE_FLOAT32;
+  msAppendOutputFormat(map_tmp, outputformat);
+
+  msCopyHashTable(&map_tmp->configoptions, &layer->map->configoptions);
+  map_tmp->mappath = msStrdup(layer->map->mappath);
+  map_tmp->shapepath = msStrdup(layer->map->shapepath);
+  map_tmp->gt.rotation_angle = 0.0;
+
+  /* Custom msCopyProjection() that removes lon_wrap parameter */
+  {
+    int i;
+
+    map_tmp->projection.numargs = 0;
+    map_tmp->projection.gt = layer->projection.gt;
+
+    for (i = 0; i < layer->projection.numargs; i++) {
+      if (strncmp(layer->projection.args[i],
+                  "lon_wrap=", strlen("lon_wrap=")) == 0) {
+        bHasLonWrap = MS_TRUE;
+        dfLonWrap = atof(layer->projection.args[i] + strlen("lon_wrap="));
+      } else {
+        map_tmp->projection.args[map_tmp->projection.numargs++] =
+            msStrdup(layer->projection.args[i]);
+      }
+    }
+    if (map_tmp->projection.numargs != 0) {
+      msProcessProjection(&(map_tmp->projection));
+    }
+
+    map_tmp->projection.wellknownprojection =
+        layer->projection.wellknownprojection;
+  }
+
+  /* Very special case to improve quality for rasters referenced from lon=0 to
+   * 360 */
+  /* We create a temporary VRT that swiches the 2 hemispheres, and then we */
+  /* modify the georeferncing to be in the more standard [-180, 180] range */
+  /* and we adjust the layer->data, extent and projection accordingly */
+  if (layer->tileindex == NULL && uvlinfo->mapToUseForWhichShapes &&
+      bHasLonWrap && dfLonWrap == 180.0) {
+    rectObj layerExtent;
+    msLayerGetExtent(layer, &layerExtent);
+    if (layerExtent.minx == 0 && layerExtent.maxx == 360) {
+      GDALDatasetH hDS = NULL;
+      char *decrypted_path;
+
+      if (strncmp(layer->data, "<VRTDataset", strlen("<VRTDataset")) == 0) {
+        decrypted_path = msStrdup(layer->data);
+      } else {
+        char szPath[MS_MAXPATHLEN];
+        msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                        layer->data);
+        decrypted_path = msDecryptStringTokens(layer->map, szPath);
+      }
+
+      if (decrypted_path) {
+        char **connectionoptions;
+        GDALAllRegister();
+        connectionoptions =
+            msGetStringListFromHashTable(&(layer->connectionoptions));
+        hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                         (const char *const *)connectionoptions, NULL);
+        CSLDestroy(connectionoptions);
+      }
+      if (hDS != NULL) {
+        int iBand;
+        int nXSize = GDALGetRasterXSize(hDS);
+        int nYSize = GDALGetRasterYSize(hDS);
+        int nBands = GDALGetRasterCount(hDS);
+        int nMaxLen = 100 + nBands * (800 + 2 * strlen(decrypted_path));
+        int nOffset = 0;
+        char *pszInlineVRT = msSmallMalloc(nMaxLen);
+
+        snprintf(pszInlineVRT, nMaxLen,
+                 "<VRTDataset rasterXSize=\"%d\" rasterYSize=\"%d\">", nXSize,
+                 nYSize);
+        nOffset = strlen(pszInlineVRT);
+        for (iBand = 1; iBand <= nBands; iBand++) {
+          const char *pszDataType = "Byte";
+          switch (GDALGetRasterDataType(GDALGetRasterBand(hDS, iBand))) {
+          case GDT_Byte:
+            pszDataType = "Byte";
+            break;
+          case GDT_Int16:
+            pszDataType = "Int16";
+            break;
+          case GDT_UInt16:
+            pszDataType = "UInt16";
+            break;
+          case GDT_Int32:
+            pszDataType = "Int32";
+            break;
+          case GDT_UInt32:
+            pszDataType = "UInt32";
+            break;
+          case GDT_Float32:
+            pszDataType = "Float32";
+            break;
+          case GDT_Float64:
+            pszDataType = "Float64";
+            break;
+          default:
+            break;
+          }
+
+          snprintf(pszInlineVRT + nOffset, nMaxLen - nOffset,
+                   "    <VRTRasterBand dataType=\"%s\" band=\"%d\">"
+                   "        <SimpleSource>"
+                   "            <SourceFilename "
+                   "relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
+                   "            <SourceBand>%d</SourceBand>"
+                   "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "        </SimpleSource>"
+                   "        <SimpleSource>"
+                   "            <SourceFilename "
+                   "relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
+                   "            <SourceBand>%d</SourceBand>"
+                   "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "        </SimpleSource>"
+                   "    </VRTRasterBand>",
+                   pszDataType, iBand, decrypted_path, iBand, nXSize / 2, 0,
+                   nXSize - nXSize / 2, nYSize, 0, 0, nXSize - nXSize / 2,
+                   nYSize, decrypted_path, iBand, 0, 0, nXSize / 2, nYSize,
+                   nXSize - nXSize / 2, 0, nXSize / 2, nYSize);
+
+          nOffset += strlen(pszInlineVRT + nOffset);
+        }
+        snprintf(pszInlineVRT + nOffset, nMaxLen - nOffset, "</VRTDataset>");
+
+        oldLayerExtent = layer->extent;
+        oldLayerData = layer->data;
+        oldLayerProjection = layer->projection;
+        layer->extent.minx = -180;
+        layer->extent.maxx = 180;
+        layer->data = pszInlineVRT;
+        layer->projection = map_tmp->projection;
+
+        /* map_tmp->projection is actually layer->projection without lon_wrap */
+        rect = uvlinfo->mapToUseForWhichShapes->extent;
+        msProjectRect(&uvlinfo->mapToUseForWhichShapes->projection,
+                      &map_tmp->projection, &rect);
+        bHasLonWrap = MS_FALSE;
+
+        GDALClose(hDS);
+      }
+      msFree(decrypted_path);
+    }
+  }
+
+  if (isQuery) {
+    /* For query mode, use layer->map->extent reprojected rather than */
+    /* the provided rect. Generic query code will filter returned features. */
+    rect = msUVRASTERGetSearchRect(layer, layer->map);
+  }
+
+  map_cellsize = MS_MAX(MS_CELLSIZE(rect.minx, rect.maxx, layer->map->width),
+                        MS_CELLSIZE(rect.miny, rect.maxy, layer->map->height));
+  map_tmp->cellsize = map_cellsize * spacing;
+  map_tmp->extent.minx =
+      rect.minx - (0.5 * map_cellsize) + (0.5 * map_tmp->cellsize);
+  map_tmp->extent.miny =
+      rect.miny - (0.5 * map_cellsize) + (0.5 * map_tmp->cellsize);
+  map_tmp->extent.maxx =
+      map_tmp->extent.minx + ((width - 1) * map_tmp->cellsize);
+  map_tmp->extent.maxy =
+      map_tmp->extent.miny + ((height - 1) * map_tmp->cellsize);
+
+  if (bHasLonWrap && dfLonWrap == 180.0) {
+    if (map_tmp->extent.minx >= 180) {
+      /* Request on the right half of the shifted raster (= western hemisphere)
+       */
+      map_tmp->extent.minx -= 360;
+      map_tmp->extent.maxx -= 360;
+    } else if (map_tmp->extent.maxx >= 180.0) {
+      /* Request spanning on the 2 hemispheres => drawing whole planet */
+      /* Take only into account vertical resolution, as horizontal one */
+      /* will be unreliable (assuming square pixels...) */
+      map_cellsize = MS_CELLSIZE(rect.miny, rect.maxy, layer->map->height);
+      map_tmp->cellsize = map_cellsize * spacing;
+
+      width = 360.0 / map_tmp->cellsize;
+      map_tmp->extent.minx = -180.0 + (0.5 * map_tmp->cellsize);
+      map_tmp->extent.maxx = 180.0 - (0.5 * map_tmp->cellsize);
+    }
+  }
+
+  if (layer->debug)
+    msDebug(
+        "msUVRASTERLayerWhichShapes(): width: %d, height: %d, cellsize: %g\n",
+        width, height, map_tmp->cellsize);
+
+  if (layer->debug == MS_DEBUGLEVEL_VVV)
+    msDebug("msUVRASTERLayerWhichShapes(): extent: %g %g %g %g\n",
+            map_tmp->extent.minx, map_tmp->extent.miny, map_tmp->extent.maxx,
+            map_tmp->extent.maxy);
+
+  /* important to use that function, to compute map
+     geotransform, used by the resampling*/
+  msMapSetSize(map_tmp, width, height);
+
+  if (layer->debug == MS_DEBUGLEVEL_VVV)
+    msDebug("msUVRASTERLayerWhichShapes(): geotransform: %g %g %g %g %g %g\n",
+            map_tmp->gt.geotransform[0], map_tmp->gt.geotransform[1],
+            map_tmp->gt.geotransform[2], map_tmp->gt.geotransform[3],
+            map_tmp->gt.geotransform[4], map_tmp->gt.geotransform[5]);
+
+  uvlinfo->extent = map_tmp->extent;
+
+  image_tmp = msImageCreate(width, height, map_tmp->outputformatlist[0], NULL,
+                            NULL, map_tmp->resolution, map_tmp->defresolution,
+                            &(map_tmp->imagecolor));
+
+  /* Default set to AVERAGE resampling */
+  if (CSLFetchNameValue(layer->processing, "RESAMPLE") == NULL) {
+    alteredProcessing = CSLDuplicate(layer->processing);
+    alteredProcessing =
+        CSLSetNameValue(alteredProcessing, "RESAMPLE", "AVERAGE");
+    savedProcessing = layer->processing;
+    layer->processing = alteredProcessing;
+  }
+
+  /* disable masking at this level: we don't want to apply the mask at the
+   * raster level, it will be applied with the correct cellsize and image size
+   * in the vector rendering phase.
+   */
+  saved_layer_mask = layer->mask;
+  layer->mask = NULL;
+  ret = msDrawRasterLayerLow(map_tmp, layer, image_tmp, NULL);
+
+  /* restore layer attributes if we went through the above on-the-fly VRT */
+  if (oldLayerData) {
+    msFree(layer->data);
+    layer->data = oldLayerData;
+    layer->extent = oldLayerExtent;
+    layer->projection = oldLayerProjection;
+  }
+
+  /* restore layer mask */
+  layer->mask = saved_layer_mask;
+
+  /* restore the saved processing */
+  if (alteredProcessing != NULL) {
+    layer->processing = savedProcessing;
+    CSLDestroy(alteredProcessing);
+  }
+
+  if (ret == MS_FAILURE) {
+    msSetError(MS_MISCERR, "Unable to draw raster data.",
+               "msUVRASTERLayerWhichShapes()");
+
+    msFreeMap(map_tmp);
+    msFreeImage(image_tmp);
+
+    return MS_FAILURE;
+  }
+
+  /* free old query arrays */
+  if (uvlinfo->u) {
+    for (i = 0; i < uvlinfo->width; ++i) {
+      free(uvlinfo->u[i]);
+    }
+    free(uvlinfo->u);
+  }
+
+  if (uvlinfo->v) {
+    for (i = 0; i < uvlinfo->width; ++i) {
+      free(uvlinfo->v[i]);
+    }
+    free(uvlinfo->v);
+  }
+
+  /* Update our uv layer structure */
+  uvlinfo->width = width;
+  uvlinfo->height = height;
+  uvlinfo->query_results = width * height;
+
+  uvlinfo->u = (float **)msSmallMalloc(sizeof(float *) * width);
+  uvlinfo->v = (float **)msSmallMalloc(sizeof(float *) * width);
+
+  for (x = 0; x < width; ++x) {
+    uvlinfo->u[x] = (float *)msSmallMalloc(height * sizeof(float));
+    uvlinfo->v[x] = (float *)msSmallMalloc(height * sizeof(float));
+
+    for (y = 0; y < height; ++y) {
+      u_src_off = v_src_off = x + y * width;
+      v_src_off += width * height;
+
+      uvlinfo->u[x][y] = image_tmp->img.raw_float[u_src_off];
+      uvlinfo->v[x][y] = image_tmp->img.raw_float[v_src_off];
+
+      /* null vector? update the number of results  */
+      if (uvlinfo->u[x][y] == 0 && uvlinfo->v[x][y] == 0)
+        --uvlinfo->query_results;
+    }
+  }
+
+  msFreeImage(image_tmp); /* we do not need the imageObj anymore */
+  msFreeMap(map_tmp);
+
+  uvlinfo->next_shape = 0;
+
+  return MS_SUCCESS;
+}
+
+int msUVRASTERLayerGetShape(layerObj *layer, shapeObj *shape,
+                            resultObj *record) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  lineObj line;
+  pointObj point;
+  int i, j, k, x = 0, y = 0;
+  long shapeindex = record->shapeindex;
+
+  msFreeShape(shape);
+  shape->type = MS_SHAPE_NULL;
+
+  if (shapeindex < 0 || shapeindex >= uvlinfo->query_results) {
+    msSetError(MS_MISCERR,
+               "Out of range shape index requested.  Requested %ld\n"
+               "but only %d shapes available.",
+               "msUVRASTERLayerGetShape()", shapeindex, uvlinfo->query_results);
+    return MS_FAILURE;
+  }
+
+  /* loop to the next non null vector */
+  k = 0;
+  for (i = 0, x = -1; i < uvlinfo->width && k <= shapeindex; ++i, ++x) {
+    for (j = 0, y = -1; j < uvlinfo->height && k <= shapeindex; ++j, ++k, ++y) {
+      if (uvlinfo->u[i][j] == 0 && uvlinfo->v[i][j] == 0)
+        --k;
+    }
+  }
+
+  point.x = Pix2Georef(x, 0, uvlinfo->width - 1, uvlinfo->extent.minx,
+                       uvlinfo->extent.maxx, MS_FALSE);
+  point.y = Pix2Georef(y, 0, uvlinfo->height - 1, uvlinfo->extent.miny,
+                       uvlinfo->extent.maxy, MS_TRUE);
+  if (layer->debug == MS_DEBUGLEVEL_VVV)
+    msDebug("msUVRASTERLayerWhichShapes(): shapeindex: %ld, x: %g, y: %g\n",
+            shapeindex, point.x, point.y);
+
+  point.m = 0.0;
+
+  shape->type = MS_SHAPE_POINT;
+  line.numpoints = 1;
+  line.point = &point;
+  msAddLine(shape, &line);
+  msComputeBounds(shape);
+
+  shape->numvalues = layer->numitems;
+  shape->values =
+      msUVRASTERGetValues(layer, uvlinfo->u[x][y], uvlinfo->v[x][y], &point);
+  shape->index = shapeindex;
+  shape->resultindex = shapeindex;
+
+  return MS_SUCCESS;
+}
+
+int msUVRASTERLayerNextShape(layerObj *layer, shapeObj *shape) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+
+  if (uvlinfo->next_shape < 0 ||
+      uvlinfo->next_shape >= uvlinfo->query_results) {
+    msFreeShape(shape);
+    shape->type = MS_SHAPE_NULL;
+    return MS_DONE;
+  } else {
+    resultObj record;
+
+    record.shapeindex = uvlinfo->next_shape++;
+    record.tileindex = 0;
+    record.classindex = record.resultindex = -1;
+
+    return msUVRASTERLayerGetShape(layer, shape, &record);
+  }
+}
+
+/************************************************************************/
+/*                       msUVRASTERLayerGetExtent()                     */
+/* Simple copy of the maprasterquery.c file. might change in the future */
+/************************************************************************/
+
+int msUVRASTERLayerGetExtent(layerObj *layer, rectObj *extent)
+
+{
+  char szPath[MS_MAXPATHLEN];
+  mapObj *map = layer->map;
+  shapefileObj *tileshpfile;
+
+  if ((!layer->data || strlen(layer->data) == 0) && layer->tileindex == NULL) {
+    /* should we be issuing a specific error about not supporting
+       extents for tileindexed raster layers? */
+    return MS_FAILURE;
+  }
+
+  if (map == NULL)
+    return MS_FAILURE;
+
+  /* If the layer use a tileindex, return the extent of the tileindex
+   * shapefile/referenced layer */
+  if (layer->tileindex) {
+    const int tilelayerindex = msGetLayerIndex(map, layer->tileindex);
+    if (tilelayerindex != -1) /* does the tileindex reference another layer */
+      return msLayerGetExtent(GET_LAYER(map, tilelayerindex), extent);
+    else {
+      tileshpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
+      MS_CHECK_ALLOC(tileshpfile, sizeof(shapefileObj), MS_FAILURE);
+
+      if (msShapefileOpen(tileshpfile, "rb",
+                          msBuildPath3(szPath, map->mappath, map->shapepath,
+                                       layer->tileindex),
+                          MS_TRUE) == -1)
+        if (msShapefileOpen(tileshpfile, "rb",
+                            msBuildPath(szPath, map->mappath, layer->tileindex),
+                            MS_TRUE) == -1)
+          return MS_FAILURE;
+
+      *extent = tileshpfile->bounds;
+      msShapefileClose(tileshpfile);
+      free(tileshpfile);
+      return MS_SUCCESS;
+    }
+  }
+
+  msTryBuildPath3(szPath, map->mappath, map->shapepath, layer->data);
+  char *decrypted_path = msDecryptStringTokens(map, szPath);
+  if (!decrypted_path)
+    return MS_FAILURE;
+
+  GDALAllRegister();
+
+  char **connectionoptions =
+      msGetStringListFromHashTable(&(layer->connectionoptions));
+  GDALDatasetH hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                                (const char *const *)connectionoptions, NULL);
+  CSLDestroy(connectionoptions);
+  msFree(decrypted_path);
+  if (hDS == NULL) {
+    return MS_FAILURE;
+  }
+
+  const int nXSize = GDALGetRasterXSize(hDS);
+  const int nYSize = GDALGetRasterYSize(hDS);
+  double adfGeoTransform[6] = {0};
+  const CPLErr eErr = GDALGetGeoTransform(hDS, adfGeoTransform);
+  if (eErr != CE_None) {
+    GDALClose(hDS);
+    return MS_FAILURE;
+  }
+
+  /* If this appears to be an ungeoreferenced raster than flip it for
+     mapservers purposes. */
+  if (adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0) {
+    adfGeoTransform[5] = -1.0;
+    adfGeoTransform[3] = nYSize;
+  }
+
+  extent->minx = adfGeoTransform[0];
+  extent->maxy = adfGeoTransform[3];
+
+  extent->maxx = adfGeoTransform[0] + nXSize * adfGeoTransform[1];
+  extent->miny = adfGeoTransform[3] + nYSize * adfGeoTransform[5];
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                     msUVRASTERLayerSetTimeFilter()                   */
+/*                                                                      */
+/*      This function is actually just used in the context of           */
+/*      setting a filter on the tileindex for time based queries.       */
+/*      For instance via WMS requests.  So it isn't really related      */
+/*      to the "raster query" support at all.                           */
+/*                                                                      */
+/*      If a local shapefile tileindex is in use, we will set a         */
+/*      backtics filter (shapefile compatible).  If another layer is    */
+/*      being used as the tileindex then we will forward the            */
+/*      SetTimeFilter call to it.  If there is no tileindex in          */
+/*      place, we do nothing.                                           */
+/************************************************************************/
+
+int msUVRASTERLayerSetTimeFilter(layerObj *layer, const char *timestring,
+                                 const char *timefield) {
+  int tilelayerindex;
+
+  /* -------------------------------------------------------------------- */
+  /*      If we don't have a tileindex the time filter has no effect.     */
+  /* -------------------------------------------------------------------- */
+  if (layer->tileindex == NULL)
+    return MS_SUCCESS;
+
+  /* -------------------------------------------------------------------- */
+  /*      Find the tileindex layer.                                       */
+  /* -------------------------------------------------------------------- */
+  tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
+
+  /* -------------------------------------------------------------------- */
+  /*      If we are using a local shapefile as our tileindex (that is     */
+  /*      to say, the tileindex name is not of another layer), then we    */
+  /*      just install a backtics style filter on the raster layer.       */
+  /*      This is propogated to the "working layer" created for the       */
+  /*      tileindex by code in mapraster.c.                               */
+  /* -------------------------------------------------------------------- */
+  if (tilelayerindex == -1)
+    return msLayerMakeBackticsTimeFilter(layer, timestring, timefield);
+
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
+  /*      method.                                                         */
+  /* -------------------------------------------------------------------- */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+  return msLayerSetTimeFilter(layer->GET_LAYER(map, tilelayerindex), timestring,
+                              timefield);
+}
+
+/************************************************************************/
+/*                msRASTERLayerInitializeVirtualTable()                 */
+/************************************************************************/
+
+int msUVRASTERLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerInitItemInfo = msUVRASTERLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msUVRASTERLayerFreeItemInfo;
+  layer->vtable->LayerOpen = msUVRASTERLayerOpen;
+  layer->vtable->LayerIsOpen = msUVRASTERLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msUVRASTERLayerWhichShapes;
+  layer->vtable->LayerNextShape = msUVRASTERLayerNextShape;
+  layer->vtable->LayerGetShape = msUVRASTERLayerGetShape;
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerClose = msUVRASTERLayerClose;
+  layer->vtable->LayerGetItems = msUVRASTERLayerGetItems;
+  layer->vtable->LayerGetExtent = msUVRASTERLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /* layer->vtable->LayerCloseConnection = msUVRASTERLayerClose; */
+  /* we use backtics for proper tileindex shapefile functioning */
+  layer->vtable->LayerSetTimeFilter = msUVRASTERLayerSetTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapv8.cpp 8.2.0~beta1-1~exp1/src/mapv8.cpp
--- 8.0.1-5/src/mapv8.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapv8.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,382 @@
+/**********************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  V8 JavaScript Engine Support
+ * Author:   Alan Boudreault (aboudreault@mapgears.com)
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Alan Boudreault, MapGears
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ **********************************************************************/
+
+#include "mapserver-config.h"
+#ifdef USE_V8_MAPSCRIPT
+
+#include "mapserver.h"
+#include "v8_mapscript.h"
+
+/* This file could be refactored in the future to encapsulate the global
+   functions and internal use functions in a class. */
+
+/* Handler for Javascript Exceptions. Not exposed to JavaScript, used
+   internally. Most of the code from v8 shell example.
+*/
+void msV8ReportException(TryCatch *try_catch, const char *msg = "") {
+  HandleScope handle_scope;
+
+  if (!try_catch || !try_catch->HasCaught()) {
+    msSetError(MS_V8ERR, "%s.", "msV8ReportException()", msg);
+    return;
+  }
+
+  String::Utf8Value exception(try_catch->Exception());
+  const char *exception_string = *exception;
+  Handle<Message> message = try_catch->Message();
+  if (message.IsEmpty()) {
+    msSetError(MS_V8ERR, "Javascript Exception: %s.", "msV8ReportException()",
+               exception_string);
+  } else {
+    String::Utf8Value filename(message->GetScriptResourceName());
+    const char *filename_string = *filename;
+    int linenum = message->GetLineNumber();
+    msSetError(MS_V8ERR, "Javascript Exception: %s:%i: %s",
+               "msV8ReportException()", filename_string, linenum,
+               exception_string);
+    String::Utf8Value sourceline(message->GetSourceLine());
+    const char *sourceline_string = *sourceline;
+    msSetError(MS_V8ERR, "Exception source line: %s", "msV8ReportException()",
+               sourceline_string);
+    String::Utf8Value stack_trace(try_catch->StackTrace());
+    if (stack_trace.length() > 0) {
+      const char *stack_trace_string = *stack_trace;
+      msSetError(MS_V8ERR, "Exception StackTrace: %s", "msV8ReportException()",
+                 stack_trace_string);
+    }
+  }
+}
+
+/* This function load a javascript file in memory. */
+static Handle<Value> msV8ReadFile(V8Context *v8context, const char *path) {
+  FILE *file = fopen(path, "rb");
+  if (file == NULL) {
+    char err[MS_MAXPATHLEN + 21];
+    sprintf(err, "Error opening file: %s", path);
+    msV8ReportException(NULL, err);
+    return Handle<String>(String::New(""));
+  }
+
+  fseek(file, 0, SEEK_END);
+  int size = ftell(file);
+  rewind(file);
+
+  char *chars = new char[size + 1];
+  chars[size] = '\0';
+  for (int i = 0; i < size;) {
+    int read = static_cast<int>(fread(&chars[i], 1, size - i, file));
+    if (read == 0) {
+      delete[] chars;
+      fclose(file);
+      msDebug("msV8ReadFile: error while reading file '%s'\n", path);
+      return Undefined();
+    }
+    i += read;
+  }
+
+  fclose(file);
+  Handle<String> result = String::New(chars, size);
+  delete[] chars;
+  return result;
+}
+
+/* Returns a compiled javascript script. */
+static Handle<Script> msV8CompileScript(Handle<String> source,
+                                        Handle<String> script_name) {
+  TryCatch try_catch;
+
+  if (source.IsEmpty() || source->Length() == 0) {
+    msV8ReportException(NULL, "No source to compile");
+    return Handle<Script>();
+  }
+
+  Handle<Script> script = Script::Compile(source, script_name);
+  if (script.IsEmpty() && try_catch.HasCaught()) {
+    msV8ReportException(&try_catch);
+  }
+
+  return script;
+}
+
+/* Runs a compiled script */
+static Handle<Value> msV8RunScript(Handle<Script> script) {
+  if (script.IsEmpty()) {
+    ThrowException(String::New("No script to run"));
+    return Handle<Value>();
+  }
+
+  TryCatch try_catch;
+  Handle<Value> result = script->Run();
+
+  if (result.IsEmpty() && try_catch.HasCaught()) {
+    msV8ReportException(&try_catch);
+  }
+
+  return result;
+}
+
+/* Execute a javascript file */
+static Handle<Value> msV8ExecuteScript(const char *path,
+                                       int throw_exception = MS_FALSE) {
+  char fullpath[MS_MAXPATHLEN];
+  map<string, Persistent<Script>>::iterator it;
+  Isolate *isolate = Isolate::GetCurrent();
+  V8Context *v8context = (V8Context *)isolate->GetData();
+
+  /* construct the path */
+  msBuildPath(fullpath, v8context->paths.top().c_str(), path);
+  char *filepath = msGetPath((char *)fullpath);
+  v8context->paths.push(filepath);
+  free(filepath);
+
+  Handle<Script> script;
+  it = v8context->scripts.find(fullpath);
+  if (it == v8context->scripts.end()) {
+    Handle<Value> source = msV8ReadFile(v8context, fullpath);
+    Handle<String> script_name = String::New(msStripPath((char *)path));
+    script = msV8CompileScript(source->ToString(), script_name);
+    if (script.IsEmpty()) {
+      v8context->paths.pop();
+      if (throw_exception) {
+        return ThrowException(String::New("Error compiling script"));
+      }
+    }
+    /* cache the compiled script */
+    Persistent<Script> pscript;
+    pscript.Reset(isolate, script);
+    v8context->scripts[fullpath] = pscript;
+  } else {
+    script = v8context->scripts[fullpath];
+  }
+
+  Handle<Value> result = msV8RunScript(script);
+  v8context->paths.pop();
+  if (result.IsEmpty() && throw_exception) {
+    return ThrowException(String::New("Error running script"));
+  }
+
+  return result;
+}
+
+/* END OF INTERNAL JAVASCRIPT FUNCTIONS */
+
+/* JAVASCRIPT EXPOSED FUNCTIONS */
+
+/* JavaScript Function to load javascript dependencies.
+   Exposed to JavaScript as 'require()'. */
+static Handle<Value> msV8Require(const Arguments &args) {
+  TryCatch try_catch;
+
+  for (int i = 0; i < args.Length(); i++) {
+    String::Utf8Value filename(args[i]);
+    msV8ExecuteScript(*filename, MS_TRUE);
+    if (try_catch.HasCaught()) {
+      return try_catch.ReThrow();
+    }
+  }
+
+  return Undefined();
+}
+
+/* Javascript Function print: print to debug file.
+   Exposed to JavaScript as 'print()'. */
+static Handle<Value> msV8Print(const Arguments &args) {
+  for (int i = 0; i < args.Length(); i++) {
+    String::Utf8Value str(args[i]);
+    msDebug("msV8Print: %s\n", *str);
+  }
+
+  return Undefined();
+}
+
+/* END OF JAVASCRIPT EXPOSED FUNCTIONS */
+
+/* Create and return a v8 context. Thread safe. */
+void msV8CreateContext(mapObj *map) {
+
+  Isolate *isolate = Isolate::GetCurrent();
+  Isolate::Scope isolate_scope(isolate);
+  HandleScope handle_scope(isolate);
+
+  V8Context *v8context = new V8Context(isolate);
+
+  Handle<ObjectTemplate> global_templ = ObjectTemplate::New();
+  global_templ->Set(String::New("require"), FunctionTemplate::New(msV8Require));
+  global_templ->Set(String::New("print"), FunctionTemplate::New(msV8Print));
+  global_templ->Set(String::New("alert"), FunctionTemplate::New(msV8Print));
+
+  Handle<Context> context_ =
+      Context::New(v8context->isolate, NULL, global_templ);
+  v8context->context.Reset(v8context->isolate, context_);
+
+  /* we have to enter the context before getting global instance */
+  Context::Scope context_scope(context_);
+  Handle<Object> global = context_->Global();
+  Shape::Initialize(global);
+  Point::Initialize(global);
+  Line::Initialize(global);
+
+  v8context->paths.push(map->mappath);
+  v8context->isolate->SetData(v8context);
+  v8context->layer = NULL;
+
+  map->v8context = (void *)v8context;
+}
+
+void msV8ContextSetLayer(mapObj *map, layerObj *layer) {
+  V8Context *v8context = V8CONTEXT(map);
+
+  if (!v8context) {
+    msSetError(MS_V8ERR, "V8 Persistent Context is not created.",
+               "msV8ContextSetLayer()");
+    return;
+  }
+
+  v8context->layer = layer;
+}
+
+static void msV8FreeContextScripts(V8Context *v8context) {
+  map<string, Persistent<Script>>::iterator it;
+  for (it = v8context->scripts.begin(); it != v8context->scripts.end(); ++it) {
+    ((*it).second).Dispose();
+  }
+}
+
+void msV8FreeContext(mapObj *map) {
+  V8Context *v8context = V8CONTEXT(map);
+  Shape::Dispose();
+  Point::Dispose();
+  Line::Dispose();
+  msV8FreeContextScripts(v8context);
+  v8context->context.Dispose();
+  delete v8context;
+}
+
+/* Create a V8 execution context, execute a script and return the feature
+ * style. */
+char *msV8GetFeatureStyle(mapObj *map, const char *filename, layerObj *layer,
+                          shapeObj *shape) {
+  TryCatch try_catch;
+  V8Context *v8context = V8CONTEXT(map);
+  char *ret = NULL;
+
+  if (!v8context) {
+    msSetError(MS_V8ERR, "V8 Persistent Context is not created.",
+               "msV8ReportException()");
+    return NULL;
+  }
+
+  Isolate::Scope isolate_scope(v8context->isolate);
+  HandleScope handle_scope(v8context->isolate);
+
+  /* execution context */
+  Local<Context> context =
+      Local<Context>::New(v8context->isolate, v8context->context);
+  Context::Scope context_scope(context);
+  Handle<Object> global = context->Global();
+
+  Shape *shape_ = new Shape(shape);
+  shape_->setLayer(
+      layer); // hack to set the attribute names, should change in future.
+  shape_->disableMemoryHandler(); /* the internal object should not be freed by
+                                     the v8 GC */
+  Handle<Value> ext = External::New(shape_);
+  global->Set(String::New("shape"), Shape::Constructor()->NewInstance(1, &ext));
+
+  msV8ExecuteScript(filename);
+  Handle<Value> value = global->Get(String::New("styleitem"));
+  if (value->IsUndefined()) {
+    msDebug("msV8GetFeatureStyle: Function 'styleitem' is missing.\n");
+    return ret;
+  }
+  Handle<Function> func = Handle<Function>::Cast(value);
+  Handle<Value> result = func->Call(global, 0, 0);
+  if (result.IsEmpty() && try_catch.HasCaught()) {
+    msV8ReportException(&try_catch);
+  }
+
+  if (!result.IsEmpty() && !result->IsUndefined()) {
+    String::AsciiValue ascii(result);
+    ret = msStrdup(*ascii);
+  }
+
+  return ret;
+}
+
+/* for geomtransform, we don't have the mapObj */
+shapeObj *msV8TransformShape(shapeObj *shape, const char *filename) {
+  TryCatch try_catch;
+  Isolate *isolate = Isolate::GetCurrent();
+  V8Context *v8context = (V8Context *)isolate->GetData();
+
+  HandleScope handle_scope(v8context->isolate);
+
+  /* execution context */
+  Local<Context> context =
+      Local<Context>::New(v8context->isolate, v8context->context);
+  Context::Scope context_scope(context);
+  Handle<Object> global = context->Global();
+
+  Shape *shape_ = new Shape(shape);
+  shape_->setLayer(v8context->layer);
+  shape_->disableMemoryHandler();
+  Handle<Value> ext = External::New(shape_);
+  global->Set(String::New("shape"), Shape::Constructor()->NewInstance(1, &ext));
+
+  msV8ExecuteScript(filename);
+  Handle<Value> value = global->Get(String::New("geomtransform"));
+  if (value->IsUndefined()) {
+    msDebug("msV8TransformShape: Function 'geomtransform' is missing.\n");
+    return NULL;
+  }
+  Handle<Function> func = Handle<Function>::Cast(value);
+  Handle<Value> result = func->Call(global, 0, 0);
+  if (result.IsEmpty() && try_catch.HasCaught()) {
+    msV8ReportException(&try_catch);
+  }
+
+  if (!result.IsEmpty() && result->IsObject()) {
+    Handle<Object> obj = result->ToObject();
+    if (obj->GetConstructorName()->Equals(String::New("shapeObj"))) {
+      Shape *new_shape = ObjectWrap::Unwrap<Shape>(result->ToObject());
+      if (shape == new_shape->get()) {
+        shapeObj *new_shape_ = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+        msInitShape(new_shape_);
+        msCopyShape(shape, new_shape_);
+        return new_shape_;
+      } else {
+        new_shape->disableMemoryHandler();
+        return new_shape->get();
+      }
+    }
+  }
+
+  return NULL;
+}
+
+#endif /* USE_V8_MAPSCRIPT */
diff -pruN 8.0.1-5/src/mapwcs.cpp 8.2.0~beta1-1~exp1/src/mapwcs.cpp
--- 8.0.1-5/src/mapwcs.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwcs.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3576 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OpenGIS Web Coverage Server (WCS) Implementation.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapthread.h"
+#include "mapows.h"
+#include <assert.h>
+
+#include <map>
+#include <string>
+
+#if defined(USE_WCS_SVR)
+
+#include "mapwcs.h"
+
+#include "maptime.h"
+#include <time.h>
+
+#include "gdal.h"
+#include "cpl_string.h" /* GDAL string handling */
+
+/************************************************************************/
+/*                    msWCSValidateRangeSetParam()                      */
+/************************************************************************/
+static int msWCSValidateRangeSetParam(layerObj *lp, char *name,
+                                      const char *value) {
+  char **allowed_ri_values;
+  char **client_ri_values;
+  int allowed_count, client_count;
+  int i_client, i, all_match = 1;
+  char *tmpname = NULL;
+  const char *ri_values_list;
+
+  if (name == NULL)
+    return MS_FAILURE;
+
+  /* Fetch the available values list for the rangeset item and tokenize */
+  tmpname = (char *)msSmallMalloc(sizeof(char) * strlen(name) + 10);
+  sprintf(tmpname, "%s_values", name);
+  ri_values_list = msOWSLookupMetadata(&(lp->metadata), "CO", tmpname);
+  msFree(tmpname);
+
+  if (ri_values_list == NULL)
+    return MS_FAILURE;
+
+  allowed_ri_values = msStringSplit(ri_values_list, ',', &allowed_count);
+
+  /* Parse the client value list into tokens. */
+  client_ri_values = msStringSplit(value, ',', &client_count);
+
+  /* test each client value against the allowed list. */
+
+  for (i_client = 0; all_match && i_client < client_count; i_client++) {
+    for (i = 0; i < allowed_count && strcasecmp(client_ri_values[i_client],
+                                                allowed_ri_values[i]) != 0;
+         i++) {
+    }
+
+    if (i == allowed_count)
+      all_match = 0;
+  }
+
+  msFreeCharArray(allowed_ri_values, allowed_count);
+  msFreeCharArray(client_ri_values, client_count);
+
+  if (all_match == 0)
+    return MS_FAILURE;
+  else
+    return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                    msWCSConvertRangeSetToString()                    */
+/************************************************************************/
+static char *msWCSConvertRangeSetToString(const char *value) {
+  char **tokens;
+  int numtokens;
+  double min, max, res;
+  double val;
+  char buf1[128], *buf2 = NULL;
+
+  if (strchr(value, '/')) { /* value is min/max/res */
+    tokens = msStringSplit(value, '/', &numtokens);
+    if (tokens == NULL || numtokens != 3) {
+      msFreeCharArray(tokens, numtokens);
+      return NULL; /* not a set of equally spaced intervals */
+    }
+
+    min = atof(tokens[0]);
+    max = atof(tokens[1]);
+    res = atof(tokens[2]);
+    msFreeCharArray(tokens, numtokens);
+
+    for (val = min; val <= max; val += res) {
+      if (val == min)
+        snprintf(buf1, sizeof(buf1), "%g", val);
+      else
+        snprintf(buf1, sizeof(buf1), ",%g", val);
+      buf2 = msStringConcatenate(buf2, buf1);
+    }
+
+    return buf2;
+  } else
+    return msStrdup(value);
+}
+
+/************************************************************************/
+/*                           msWCSException()                           */
+/************************************************************************/
+int msWCSException(mapObj *map, const char *code, const char *locator,
+                   const char *version) {
+  char *pszEncodedVal = NULL;
+  char version_string[OWS_VERSION_MAXLEN];
+
+  if (version == NULL)
+    version = "1.0.0";
+
+#if defined(USE_LIBXML2)
+  if (msOWSParseVersionString(version) >= OWS_2_0_0)
+    return msWCSException20(
+        map, code, locator,
+        msOWSGetVersionString(msOWSParseVersionString(version),
+                              version_string));
+#endif
+
+  if (msOWSParseVersionString(version) >= OWS_1_1_0)
+    return msWCSException11(
+        map, code, locator,
+        msOWSGetVersionString(msOWSParseVersionString(version),
+                              version_string));
+
+  msIO_setHeader("Content-Type", "application/vnd.ogc.se_xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  /* msIO_printf("Content-Type: text/xml%c%c",10,10); */
+
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+
+  msIO_printf("<ServiceExceptionReport version=\"1.2.0\"\n");
+  msIO_printf("xmlns=\"http://www.opengis.net/ogc\" ");
+  msIO_printf("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ");
+  pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc "
+              "%s/wcs/1.0.0/OGC-exception.xsd\">\n",
+              pszEncodedVal);
+  msFree(pszEncodedVal);
+  msIO_printf("  <ServiceException");
+  if (code) {
+    msIO_printf(" code=\"%s\"", code);
+  }
+  if (locator) {
+    msIO_printf(" locator=\"%s\"", locator);
+  }
+  msIO_printf(">");
+  msWriteErrorXML(stdout);
+  msIO_printf("  </ServiceException>\n");
+  msIO_printf("</ServiceExceptionReport>\n");
+
+  msResetErrorList();
+
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                    msWCSPrintRequestCapability()                     */
+/************************************************************************/
+
+static void msWCSPrintRequestCapability(const char *request_tag,
+                                        const char *script_url) {
+  msIO_printf("    <%s>\n", request_tag);
+
+  msIO_printf("      <DCPType>\n");
+  msIO_printf("        <HTTP>\n");
+  msIO_printf("          <Get><OnlineResource xlink:type=\"simple\" "
+              "xlink:href=\"%s\" /></Get>\n",
+              script_url);
+  msIO_printf("        </HTTP>\n");
+  msIO_printf("      </DCPType>\n");
+  msIO_printf("      <DCPType>\n");
+  msIO_printf("        <HTTP>\n");
+  msIO_printf("          <Post><OnlineResource xlink:type=\"simple\" "
+              "xlink:href=\"%s\" /></Post>\n",
+              script_url);
+  msIO_printf("        </HTTP>\n");
+  msIO_printf("      </DCPType>\n");
+
+  msIO_printf("    </%s>\n", request_tag);
+}
+
+/************************************************************************/
+/*                         msWCSCreateParams()                          */
+/************************************************************************/
+static wcsParamsObj *msWCSCreateParams() {
+  wcsParamsObj *params;
+
+  params = (wcsParamsObj *)calloc(1, sizeof(wcsParamsObj));
+  MS_CHECK_ALLOC(params, sizeof(wcsParamsObj), NULL);
+
+  return params;
+}
+
+/************************************************************************/
+/*                          msWCSFreeParams()                           */
+/************************************************************************/
+void msWCSFreeParams(wcsParamsObj *params) {
+  if (params) {
+    /* TODO */
+    if (params->version)
+      free(params->version);
+    if (params->updatesequence)
+      free(params->updatesequence);
+    if (params->request)
+      free(params->request);
+    if (params->service)
+      free(params->service);
+    if (params->section)
+      free(params->section);
+    if (params->crs)
+      free(params->crs);
+    if (params->response_crs)
+      free(params->response_crs);
+    if (params->format)
+      free(params->format);
+    if (params->exceptions)
+      free(params->exceptions);
+    if (params->time)
+      free(params->time);
+    if (params->interpolation)
+      free(params->interpolation);
+    CSLDestroy(params->coverages);
+  }
+}
+
+/************************************************************************/
+/*                       msWCSIsLayerSupported()                        */
+/************************************************************************/
+
+int msWCSIsLayerSupported(layerObj *layer) {
+  /* only raster layers, are elligible to be served via WCS, WMS rasters are not
+   * ok */
+  if ((layer->type == MS_LAYER_RASTER) && layer->connectiontype != MS_WMS &&
+      layer->name != NULL)
+    return MS_TRUE;
+
+  return MS_FALSE;
+}
+
+/************************************************************************/
+/*                      msWCSGetRequestParameter()                      */
+/*                                                                      */
+/************************************************************************/
+
+const char *msWCSGetRequestParameter(cgiRequestObj *request, const char *name) {
+  int i;
+
+  if (!request || !name) /* nothing to do */
+    return NULL;
+
+  if (request->NumParams > 0) {
+    for (i = 0; i < request->NumParams; i++) {
+      if (strcasecmp(request->ParamNames[i], name) == 0)
+        return request->ParamValues[i];
+    }
+  }
+
+  return NULL;
+}
+
+/************************************************************************/
+/*                  msWCSSetDefaultBandsRangeSetInfo()                  */
+/************************************************************************/
+
+void msWCSSetDefaultBandsRangeSetInfo(wcsParamsObj *params,
+                                      coverageMetadataObj *cm, layerObj *lp) {
+  (void)params;
+
+  /* This function will provide default rangeset information for the "special"
+   */
+  /* "bands" rangeset if it appears in the axes list but has no specifics
+   * provided */
+  /* in the metadata.   */
+
+  const char *value;
+  char *bandlist;
+  size_t bufferSize = 0;
+  int i;
+
+  /* Does this item exist in the axes list?  */
+
+  value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_axes");
+  if (value == NULL)
+    return;
+
+  value = strstr(value, "bands");
+  if (value == NULL || (value[5] != '\0' && value[5] != ' '))
+    return;
+
+  /* Are there any w*s_bands_ metadata already? If so, skip out. */
+  if (msOWSLookupMetadata(&(lp->metadata), "CO", "bands_description") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_name") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_label") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_semantic") !=
+          NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_type") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_rangeitem") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_semantic") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsys") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsyslabel") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_interval") != NULL)
+    return;
+
+  /* OK, we have decided to fill in the information. */
+
+  msInsertHashTable(&(lp->metadata), "wcs_bands_name", "bands");
+  msInsertHashTable(&(lp->metadata), "wcs_bands_label",
+                    "Bands/Channels/Samples");
+  msInsertHashTable(&(lp->metadata), "wcs_bands_rangeitem", "_bands"); /* ? */
+
+  bufferSize = cm->bandcount * 30 + 30;
+  bandlist = (char *)msSmallMalloc(bufferSize);
+  strcpy(bandlist, "1");
+  for (i = 1; i < cm->bandcount; i++)
+    snprintf(bandlist + strlen(bandlist), bufferSize - strlen(bandlist), ",%d",
+             i + 1);
+
+  msInsertHashTable(&(lp->metadata), "wcs_bands_values", bandlist);
+  free(bandlist);
+}
+
+/************************************************************************/
+/*                         msWCSParseRequest()                          */
+/************************************************************************/
+
+static int msWCSParseRequest(cgiRequestObj *request, wcsParamsObj *params,
+                             mapObj *map) {
+  int i, n;
+  char **tokens;
+
+  if (!request || !params) /* nothing to do */
+    return MS_SUCCESS;
+
+  /* -------------------------------------------------------------------- */
+  /*      Check if this appears to be an XML POST WCS request.            */
+  /* -------------------------------------------------------------------- */
+
+  msDebug("msWCSParseRequest(): request is %s.\n",
+          (request->type == MS_POST_REQUEST) ? "POST" : "KVP");
+
+  if (request->type == MS_POST_REQUEST && request->postrequest) {
+#if defined(USE_LIBXML2)
+    xmlDocPtr doc = NULL;
+    xmlNodePtr root = NULL, child = NULL;
+    char *tmp = NULL;
+
+    /* parse to DOM-Structure and get root element */
+    if ((doc = xmlParseMemory(request->postrequest,
+                              strlen(request->postrequest))) == NULL) {
+      const xmlError *error = xmlGetLastError();
+      msSetError(MS_WCSERR, "XML parsing error: %s", "msWCSParseRequest()",
+                 error->message);
+      return MS_FAILURE;
+    }
+    root = xmlDocGetRootElement(doc);
+
+    /* Get service, version and request from root */
+    params->request = msStrdup((char *)root->name);
+    if ((tmp = (char *)xmlGetProp(root, BAD_CAST "service")) != NULL)
+      params->service = tmp;
+    if ((tmp = (char *)xmlGetProp(root, BAD_CAST "version")) != NULL)
+      params->version = tmp;
+
+    /* search first level children, either CoverageID,  */
+    for (child = root->children; child != NULL; child = child->next) {
+      if (EQUAL((char *)child->name, "AcceptVersions")) {
+        /* will be overridden to 1.1.1 anyway */
+      } else if (EQUAL((char *)child->name, "UpdateSequence")) {
+        params->updatesequence = (char *)xmlNodeGetContent(child);
+      } else if (EQUAL((char *)child->name, "Sections")) {
+        xmlNodePtr sectionNode = NULL;
+        /* concatenate all sections by ',' */
+        for (sectionNode = child->children; sectionNode != NULL;
+             sectionNode = sectionNode->next) {
+          char *content;
+          if (!EQUAL((char *)sectionNode->name, "Section"))
+            continue;
+          content = (char *)xmlNodeGetContent(sectionNode);
+          if (!params->section) {
+            params->section = content;
+          } else {
+            params->section = msStringConcatenate(params->section, ",");
+            params->section = msStringConcatenate(params->section, content);
+            xmlFree(content);
+          }
+        }
+      } else if (EQUAL((char *)child->name, "AcceptFormats")) {
+        /* TODO: implement */
+      } else if (EQUAL((char *)child->name, "Identifier")) {
+        char *content = (char *)xmlNodeGetContent(child);
+        params->coverages = CSLAddString(params->coverages, content);
+        xmlFree(content);
+      } else if (EQUAL((char *)child->name, "DomainSubset")) {
+        xmlNodePtr tmpNode = NULL;
+        for (tmpNode = child->children; tmpNode != NULL;
+             tmpNode = tmpNode->next) {
+          if (EQUAL((char *)tmpNode->name, "BoundingBox")) {
+            xmlNodePtr cornerNode = NULL;
+            params->crs = (char *)xmlGetProp(tmpNode, BAD_CAST "crs");
+            if (strncasecmp(params->crs, "urn:ogc:def:crs:", 16) == 0 &&
+                strncasecmp(params->crs + strlen(params->crs) - 8, "imageCRS",
+                            8) == 0)
+              strcpy(params->crs, "imageCRS");
+            for (cornerNode = tmpNode->children; cornerNode != NULL;
+                 cornerNode = cornerNode->next) {
+              if (EQUAL((char *)cornerNode->name, "LowerCorner")) {
+                char *value = (char *)xmlNodeGetContent(cornerNode);
+                tokens = msStringSplit(value, ' ', &n);
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for LowerCorner",
+                             "msWCSParseRequest()");
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "LowerCorner", params->version);
+                }
+                params->bbox.minx = atof(tokens[0]);
+                params->bbox.miny = atof(tokens[1]);
+                msFreeCharArray(tokens, n);
+                xmlFree(value);
+              }
+              if (EQUAL((char *)cornerNode->name, "UpperCorner")) {
+                char *value = (char *)xmlNodeGetContent(cornerNode);
+                tokens = msStringSplit(value, ' ', &n);
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for UpperCorner",
+                             "msWCSParseRequest()");
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "UpperCorner", params->version);
+                }
+                params->bbox.maxx = atof(tokens[0]);
+                params->bbox.maxy = atof(tokens[1]);
+                msFreeCharArray(tokens, n);
+                xmlFree(value);
+              }
+            }
+          }
+        }
+      } else if (EQUAL((char *)child->name, "RangeSubset")) {
+        /* TODO: not implemented in mapserver WCS 1.1? */
+      } else if (EQUAL((char *)child->name, "Output")) {
+        xmlNodePtr tmpNode = NULL;
+        params->format = (char *)xmlGetProp(child, BAD_CAST "format");
+        for (tmpNode = child->children; tmpNode != NULL;
+             tmpNode = tmpNode->next) {
+          if (EQUAL((char *)tmpNode->name, "GridCRS")) {
+            xmlNodePtr crsNode = NULL;
+            for (crsNode = tmpNode->children; crsNode != NULL;
+                 crsNode = crsNode->next) {
+              if (EQUAL((char *)crsNode->name, "GridBaseCRS")) {
+                params->response_crs = (char *)xmlNodeGetContent(crsNode);
+              } else if (EQUAL((char *)crsNode->name, "GridOrigin")) {
+                char *value = (char *)xmlNodeGetContent(crsNode);
+                tokens = msStringSplit(value, ' ', &n);
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for GridOrigin",
+                             "msWCSParseRequest()");
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "GridOffsets", params->version);
+                }
+                params->originx = atof(tokens[0]);
+                params->originy = atof(tokens[1]);
+                msFreeCharArray(tokens, n);
+                xmlFree(value);
+              } else if (EQUAL((char *)crsNode->name, "GridOffsets")) {
+                char *value = (char *)xmlNodeGetContent(crsNode);
+                tokens = msStringSplit(value, ' ', &n);
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for GridOffsets",
+                             "msWCSParseRequest()");
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "GridOffsets", params->version);
+                }
+                /* take absolute values to convert to positive RESX/RESY style
+                WCS 1.0 behavior.  *but* this does break some possibilities! */
+                params->resx = fabs(atof(tokens[0]));
+                params->resy = fabs(atof(tokens[1]));
+                msFreeCharArray(tokens, n);
+                xmlFree(value);
+              }
+            }
+          }
+        }
+      }
+    }
+    xmlFreeDoc(doc);
+    xmlCleanupParser();
+    return MS_SUCCESS;
+#else  /* defined(USE_LIBXML2) */
+    msSetError(MS_WCSERR,
+               "To enable POST requests, MapServer has to "
+               "be compiled with libxml2.",
+               "msWCSParseRequest()");
+    return MS_FAILURE;
+#endif /* defined(USE_LIBXML2) */
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Extract WCS KVP Parameters.                                     */
+  /* -------------------------------------------------------------------- */
+  if (request->NumParams > 0) {
+    for (i = 0; i < request->NumParams; i++) {
+
+      if (strcasecmp(request->ParamNames[i], "VERSION") == 0)
+        params->version = msStrdup(request->ParamValues[i]);
+      if (strcasecmp(request->ParamNames[i], "UPDATESEQUENCE") == 0)
+        params->updatesequence = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "REQUEST") == 0)
+        params->request = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "INTERPOLATION") == 0)
+        params->interpolation = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "SERVICE") == 0)
+        params->service = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "SECTION") == 0) /* 1.0 */
+        params->section =
+            msStrdup(request->ParamValues[i]); /* TODO: validate value here */
+      else if (strcasecmp(request->ParamNames[i], "SECTIONS") == 0) /* 1.1 */
+        params->section =
+            msStrdup(request->ParamValues[i]); /* TODO: validate value here */
+
+      /* GetCoverage parameters. */
+      else if (strcasecmp(request->ParamNames[i], "BBOX") == 0) {
+        tokens = msStringSplit(request->ParamValues[i], ',', &n);
+        if (tokens == NULL || n != 4) {
+          msSetError(MS_WCSERR, "Wrong number of arguments for BBOX.",
+                     "msWCSParseRequest()");
+          return msWCSException(map, "InvalidParameterValue", "bbox",
+                                params->version);
+        }
+        params->bbox.minx = atof(tokens[0]);
+        params->bbox.miny = atof(tokens[1]);
+        params->bbox.maxx = atof(tokens[2]);
+        params->bbox.maxy = atof(tokens[3]);
+
+        msFreeCharArray(tokens, n);
+      } else if (strcasecmp(request->ParamNames[i], "RESX") == 0)
+        params->resx = atof(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "RESY") == 0)
+        params->resy = atof(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "WIDTH") == 0)
+        params->width = atoi(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "HEIGHT") == 0)
+        params->height = atoi(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "COVERAGE") == 0)
+        params->coverages =
+            CSLAddString(params->coverages, request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "TIME") == 0)
+        params->time = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "FORMAT") == 0)
+        params->format = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "CRS") == 0)
+        params->crs = msStrdup(request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "RESPONSE_CRS") == 0)
+        params->response_crs = msStrdup(request->ParamValues[i]);
+
+      /* WCS 1.1 DescribeCoverage and GetCoverage ... */
+      else if (strcasecmp(request->ParamNames[i], "IDENTIFIER") == 0 ||
+               strcasecmp(request->ParamNames[i], "IDENTIFIERS") == 0) {
+        msDebug("msWCSParseRequest(): Whole String: %s\n",
+                request->ParamValues[i]);
+        params->coverages =
+            CSLAddString(params->coverages, request->ParamValues[i]);
+      }
+      /* WCS 1.1 style BOUNDINGBOX */
+      else if (strcasecmp(request->ParamNames[i], "BOUNDINGBOX") == 0) {
+        tokens = msStringSplit(request->ParamValues[i], ',', &n);
+        if (tokens == NULL || n < 5) {
+          msSetError(MS_WCSERR, "Wrong number of arguments for BOUNDINGBOX.",
+                     "msWCSParseRequest()");
+          return msWCSException(map, "InvalidParameterValue", "boundingbox",
+                                params->version);
+        }
+
+        /* NOTE: WCS 1.1 boundingbox is center of pixel oriented, not edge
+           like in WCS 1.0.  So bbox semantics are wonky till this is fixed
+           later in the GetCoverage processing. */
+        params->bbox.minx = atof(tokens[0]);
+        params->bbox.miny = atof(tokens[1]);
+        params->bbox.maxx = atof(tokens[2]);
+        params->bbox.maxy = atof(tokens[3]);
+
+        params->crs = msStrdup(tokens[4]);
+        msFreeCharArray(tokens, n);
+        /* normalize imageCRS urns to simply "imageCRS" */
+        if (strncasecmp(params->crs, "urn:ogc:def:crs:", 16) == 0 &&
+            strncasecmp(params->crs + strlen(params->crs) - 8, "imageCRS", 8) ==
+                0)
+          strcpy(params->crs, "imageCRS");
+      } else if (strcasecmp(request->ParamNames[i], "GridOffsets") == 0) {
+        tokens = msStringSplit(request->ParamValues[i], ',', &n);
+        if (tokens == NULL || n < 2) {
+          msSetError(MS_WCSERR, "Wrong number of arguments for GridOffsets",
+                     "msWCSParseRequest()");
+          return msWCSException(map, "InvalidParameterValue", "GridOffsets",
+                                params->version);
+        }
+        /* take absolute values to convert to positive RESX/RESY style
+           WCS 1.0 behavior.  *but* this does break some possibilities! */
+        params->resx = fabs(atof(tokens[0]));
+        params->resy = fabs(atof(tokens[1]));
+        msFreeCharArray(tokens, n);
+      } else if (strcasecmp(request->ParamNames[i], "GridOrigin") == 0) {
+        tokens = msStringSplit(request->ParamValues[i], ',', &n);
+        if (tokens == NULL || n < 2) {
+          msSetError(MS_WCSERR, "Wrong number of arguments for GridOrigin",
+                     "msWCSParseRequest()");
+          return msWCSException(map, "InvalidParameterValue", "GridOffsets",
+                                params->version);
+        }
+        params->originx = atof(tokens[0]);
+        params->originy = atof(tokens[1]);
+        msFreeCharArray(tokens, n);
+      }
+
+      /* and so on... */
+    }
+  }
+  /* we are not dealing with an XML encoded request at this point */
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*           msWCSGetCapabilities_Service_ResponsibleParty()            */
+/************************************************************************/
+
+static void msWCSGetCapabilities_Service_ResponsibleParty(mapObj *map) {
+  int bEnableTelephone = MS_FALSE, bEnableAddress = MS_FALSE,
+      bEnableOnlineResource = MS_FALSE;
+
+  /* the WCS-specific way */
+  if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                          "responsibleparty_individualname") ||
+      msOWSLookupMetadata(&(map->web.metadata), "CO",
+                          "responsibleparty_organizationname")) {
+
+    msIO_printf("<responsibleParty>\n");
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "responsibleparty_individualname", OWS_NOERR,
+                             "    <individualName>%s</individualName>\n", NULL);
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "CO", "responsibleparty_organizationname",
+        OWS_NOERR, "    <organisationName>%s</organisationName>\n", NULL);
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "responsibleparty_positionname", OWS_NOERR,
+                             "    <positionName>%s</positionName>\n", NULL);
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_phone_voice") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_phone_facsimile"))
+      bEnableTelephone = MS_TRUE;
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_deliverypoint") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_city") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_administrativearea") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_postalcode") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_country") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_electronicmailaddress"))
+      bEnableAddress = MS_TRUE;
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_onlineresource"))
+      bEnableOnlineResource = MS_TRUE;
+
+    if (bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
+      msIO_printf("  <contactInfo>\n");
+      if (bEnableTelephone) {
+        msIO_printf("    <phone>\n");
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_phone_voice", OWS_NOERR,
+                                 "    <voice>%s</voice>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_phone_facsimile", OWS_NOERR,
+                                 "    <facsimile>%s</facsimile>\n", NULL);
+        msIO_printf("    </phone>\n");
+      }
+      if (bEnableAddress) {
+        msIO_printf("    <address>\n");
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO",
+            "responsibleparty_address_deliverypoint", OWS_NOERR,
+            "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_address_city", OWS_NOERR,
+                                 "    <city>%s</city>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO",
+            "responsibleparty_address_administrativearea", OWS_NOERR,
+            "    <administrativeArea>%s</administrativeArea>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_address_postalcode",
+                                 OWS_NOERR, "    <postalCode>%s</postalCode>\n",
+                                 NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_address_country", OWS_NOERR,
+                                 "    <country>%s</country>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO",
+            "responsibleparty_address_electronicmailaddress", OWS_NOERR,
+            "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
+        msIO_printf("    </address>\n");
+      }
+      msOWSPrintEncodeMetadata(
+          stdout, &(map->web.metadata), "CO", "responsibleparty_onlineresource",
+          OWS_NOERR,
+          "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+          NULL);
+      msIO_printf("  </contactInfo>\n");
+    }
+
+    msIO_printf("</responsibleParty>\n");
+
+  } else if (msOWSLookupMetadata(&(map->web.metadata), "CO", "contactperson") ||
+             msOWSLookupMetadata(
+                 &(map->web.metadata), "CO",
+                 "contactorganization")) { /* leverage WMS contact information
+                                            */
+
+    msIO_printf("<responsibleParty>\n");
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "contactperson", OWS_NOERR,
+                             "    <individualName>%s</individualName>\n", NULL);
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "CO", "contactorganization", OWS_NOERR,
+        "    <organisationName>%s</organisationName>\n", NULL);
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "contactposition", OWS_NOERR,
+                             "    <positionName>%s</positionName>\n", NULL);
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "contactvoicetelephone") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "contactfacsimiletelephone"))
+      bEnableTelephone = MS_TRUE;
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO", "address") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO", "city") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO", "stateorprovince") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO", "postcode") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO", "country") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "contactelectronicmailaddress"))
+      bEnableAddress = MS_TRUE;
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "service_onlineresource"))
+      bEnableOnlineResource = MS_TRUE;
+
+    if (bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
+      msIO_printf("  <contactInfo>\n");
+      if (bEnableTelephone) {
+        msIO_printf("    <phone>\n");
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "contactvoicetelephone", OWS_NOERR,
+                                 "    <voice>%s</voice>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "contactfacsimiletelephone", OWS_NOERR,
+                                 "    <facsimile>%s</facsimile>\n", NULL);
+        msIO_printf("    </phone>\n");
+      }
+      if (bEnableAddress) {
+        msIO_printf("    <address>\n");
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO", "address", OWS_NOERR,
+            "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "city",
+                                 OWS_NOERR, "    <city>%s</city>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO", "stateorprovince", OWS_NOERR,
+            "    <administrativeArea>%s</administrativeArea>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "postcode",
+                                 OWS_NOERR, "    <postalCode>%s</postalCode>\n",
+                                 NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "country",
+                                 OWS_NOERR, "    <country>%s</country>\n",
+                                 NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO", "contactelectronicmailaddress",
+            OWS_NOERR,
+            "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
+        msIO_printf("    </address>\n");
+      }
+      msOWSPrintEncodeMetadata(
+          stdout, &(map->web.metadata), "CO", "service_onlineresource",
+          OWS_NOERR,
+          "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+          NULL);
+      msIO_printf("  </contactInfo>\n");
+    }
+    msIO_printf("</responsibleParty>\n");
+  }
+
+  return;
+}
+
+/************************************************************************/
+/*                    msWCSGetCapabilities_Service()                    */
+/************************************************************************/
+
+static int msWCSGetCapabilities_Service(mapObj *map, wcsParamsObj *params) {
+  /* start the Service section, only need the full start tag if this is the only
+   * section requested */
+  if (!params->section ||
+      (params->section && strcasecmp(params->section, "/") == 0))
+    msIO_printf("<Service>\n");
+  else
+    msIO_printf("<Service\n"
+                "   version=\"%s\" \n"
+                "   updateSequence=\"%s\" \n"
+                "   xmlns=\"http://www.opengis.net/wcs\" \n"
+                "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
+                "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
+                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+                "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                params->version, params->updatesequence,
+                msOWSGetSchemasLocation(map), params->version);
+
+  /* optional metadataLink */
+  msOWSPrintURLType(stdout, &(map->web.metadata), "CO", "metadatalink",
+                    OWS_NOERR,
+                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>", NULL,
+                    " metadataType=\"%s\"", NULL, NULL, NULL,
+                    " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
+                    MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
+
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "description",
+                           OWS_NOERR, "  <description>%s</description>\n",
+                           NULL);
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "name",
+                           OWS_NOERR, "  <name>%s</name>\n", "MapServer WCS");
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "label",
+                           OWS_WARN, "  <label>%s</label>\n", NULL);
+
+  /* we are not supporting the optional keyword type, at least not yet */
+  msOWSPrintEncodeMetadataList(
+      stdout, &(map->web.metadata), "CO", "keywordlist", "  <keywords>\n",
+      "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
+
+  msWCSGetCapabilities_Service_ResponsibleParty(map);
+
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "fees",
+                           OWS_NOERR, "  <fees>%s</fees>\n", "NONE");
+  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "CO",
+                               "accessconstraints", "  <accessConstraints>\n",
+                               "  </accessConstraints>\n", "    %s\n", "NONE");
+
+  /* done */
+  msIO_printf("</Service>\n");
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                  msWCSGetCapabilities_Capability()                   */
+/************************************************************************/
+
+static int msWCSGetCapabilities_Capability(mapObj *map, wcsParamsObj *params,
+                                           cgiRequestObj *req) {
+  char *script_url = NULL, *script_url_encoded = NULL;
+
+  /* we need this server's onlineresource for the request section */
+  if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource", req)) ==
+          NULL ||
+      (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+    free(script_url);
+    free(script_url_encoded);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+
+  /* start the Capabilty section, only need the full start tag if this is the
+   * only section requested */
+  if (!params->section ||
+      (params->section && strcasecmp(params->section, "/") == 0))
+    msIO_printf("<Capability>\n");
+  else
+    msIO_printf("<Capability\n"
+                "   version=\"%s\" \n"
+                "   updateSequence=\"%s\" \n"
+                "   xmlns=\"http://www.opengis.net/wcs\" \n"
+                "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
+                "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
+                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+                "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                params->version, params->updatesequence,
+                msOWSGetSchemasLocation(map), params->version);
+
+  /* describe the types of requests the server can handle */
+  msIO_printf("  <Request>\n");
+
+  msWCSPrintRequestCapability("GetCapabilities", script_url_encoded);
+  if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE))
+    msWCSPrintRequestCapability("DescribeCoverage", script_url_encoded);
+  if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE))
+    msWCSPrintRequestCapability("GetCoverage", script_url_encoded);
+
+  msIO_printf("  </Request>\n");
+
+  /* describe the exception formats the server can produce */
+  msIO_printf("  <Exception>\n");
+  msIO_printf("    <Format>application/vnd.ogc.se_xml</Format>\n");
+  msIO_printf("  </Exception>\n");
+
+  /* describe any vendor specific capabilities */
+  /* msIO_printf("  <VendorSpecificCapabilities />\n"); */ /* none yet */
+
+  /* done */
+  msIO_printf("</Capability>\n");
+
+  free(script_url);
+  free(script_url_encoded);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                    msWCSPrintMetadataLink()                          */
+/************************************************************************/
+
+static void msWCSPrintMetadataLink(layerObj *layer,
+                                   const char *script_url_encoded) {
+  const char *list =
+      msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
+  if (list) {
+    int ntokens = 0;
+    char **tokens = msStringSplit(list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
+      std::string key("metadatalink_");
+      key += tokens[i];
+      msOWSPrintURLType(
+          stdout, &(layer->metadata), "CO", key.c_str(), OWS_NOERR,
+          "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>", NULL,
+          " metadataType=\"%s\"", NULL, NULL, NULL, " xlink:href=\"%s\"",
+          MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, "other", NULL, NULL,
+          NULL, NULL, NULL);
+    }
+    msFreeCharArray(tokens, ntokens);
+    return;
+  }
+
+  /* optional metadataLink */
+  if (!msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_href"))
+    msMetadataSetGetMetadataURL(layer, script_url_encoded);
+
+  msOWSPrintURLType(stdout, &(layer->metadata), "CO", "metadatalink", OWS_NOERR,
+                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>", NULL,
+                    " metadataType=\"%s\"", NULL, NULL, NULL,
+                    " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
+                    MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
+}
+
+/************************************************************************/
+/*             msWCSGetCapabilities_CoverageOfferingBrief()             */
+/************************************************************************/
+
+static int
+msWCSGetCapabilities_CoverageOfferingBrief(layerObj *layer,
+                                           const char *script_url_encoded) {
+  coverageMetadataObj cm;
+  int status;
+
+  if ((layer->status == MS_DELETE) || !msWCSIsLayerSupported(layer))
+    return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
+
+  status = msWCSGetCoverageMetadata(layer, &cm);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /* start the CoverageOfferingBrief section */
+  msIO_printf(
+      "  <CoverageOfferingBrief>\n"); /* is this tag right? (I hate schemas
+                                         without ANY examples) */
+
+  msWCSPrintMetadataLink(layer, script_url_encoded);
+
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description",
+                           OWS_NOERR, "    <description>%s</description>\n",
+                           NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR,
+                           "    <name>%s</name>\n", layer->name);
+
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN,
+                           "    <label>%s</label>\n", NULL);
+
+  /* TODO: add elevation ranges to lonLatEnvelope (optional) */
+  msIO_printf(
+      "    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx,
+              cm.llextent.miny); /* TODO: don't know if this is right */
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx,
+              cm.llextent.maxy);
+
+  msOWSPrintEncodeMetadataList(
+      stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+      "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
+
+  msIO_printf("    </lonLatEnvelope>\n");
+
+  /* we are not supporting the optional keyword type, at least not yet */
+  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist",
+                               "  <keywords>\n", "  </keywords>\n",
+                               "    <keyword>%s</keyword>\n", NULL);
+
+  /* done */
+  msIO_printf("  </CoverageOfferingBrief>\n");
+
+  msWCSFreeCoverageMetadata(&cm);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                msWCSGetCapabilities_ContentMetadata()                */
+/************************************************************************/
+
+static int msWCSGetCapabilities_ContentMetadata(mapObj *map,
+                                                wcsParamsObj *params,
+                                                owsRequestObj *ows_request,
+                                                cgiRequestObj *req) {
+  int i;
+  char *script_url_encoded = NULL;
+
+  {
+    char *pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
+    script_url_encoded = msEncodeHTMLEntities(pszTmp);
+    msFree(pszTmp);
+  }
+
+  /* start the ContentMetadata section, only need the full start tag if this is
+   * the only section requested */
+  /* TODO: add Xlink attributes for other sources of this information  */
+  if (!params->section ||
+      (params->section && strcasecmp(params->section, "/") == 0))
+    msIO_printf("<ContentMetadata>\n");
+  else
+    msIO_printf("<ContentMetadata\n"
+                "   version=\"%s\" \n"
+                "   updateSequence=\"%s\" \n"
+                "   xmlns=\"http://www.opengis.net/wcs\" \n"
+                "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
+                "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
+                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+                "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                params->version, params->updatesequence,
+                msOWSGetSchemasLocation(map), params->version);
+
+  if (ows_request->numlayers == 0) {
+    msIO_printf("  <!-- WARNING: No WCS layers are enabled. Check "
+                "wcs/ows_enable_request settings. -->\n");
+  } else {
+    for (i = 0; i < map->numlayers; i++) {
+      if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                            ows_request->enabled_layers,
+                            ows_request->numlayers))
+        continue;
+
+      if (msWCSGetCapabilities_CoverageOfferingBrief(
+              (GET_LAYER(map, i)), script_url_encoded) != MS_SUCCESS) {
+        msIO_printf("  <!-- WARNING: There was a problem with one of layers. "
+                    "See server log for details. -->\n");
+      }
+    }
+  }
+
+  msFree(script_url_encoded);
+
+  /* done */
+  msIO_printf("</ContentMetadata>\n");
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                        msWCSGetCapabilities()                        */
+/************************************************************************/
+
+static int msWCSGetCapabilities(mapObj *map, wcsParamsObj *params,
+                                cgiRequestObj *req,
+                                owsRequestObj *ows_request) {
+  char tmpString[OWS_VERSION_MAXLEN];
+  int i, tmpInt = 0;
+  int wcsSupportedVersions[] = {OWS_1_1_2, OWS_1_1_1, OWS_1_1_0, OWS_1_0_0};
+  int wcsNumSupportedVersions = 4;
+  const char *updatesequence = NULL;
+
+  /* check version is valid */
+  tmpInt = msOWSParseVersionString(params->version);
+  if (tmpInt == OWS_VERSION_BADFORMAT) {
+    return msWCSException(map, "InvalidParameterValue", "version", "1.0.0 ");
+  }
+
+  /* negotiate version */
+  tmpInt = msOWSNegotiateVersion(tmpInt, wcsSupportedVersions,
+                                 wcsNumSupportedVersions);
+
+  /* set result as string and carry on */
+  free(params->version);
+  params->version = msStrdup(msOWSGetVersionString(tmpInt, tmpString));
+
+  /* -------------------------------------------------------------------- */
+  /*      1.1.x is sufficiently different we have a whole case for        */
+  /*      it.  The remainder of this function is for 1.0.0.               */
+  /* -------------------------------------------------------------------- */
+  if (strncmp(params->version, "1.1", 3) == 0)
+    return msWCSGetCapabilities11(map, params, req, ows_request);
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+
+  if (params->updatesequence != NULL) {
+    i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
+    if (i == 0) { /* current */
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWCSGetCapabilities()", params->updatesequence, updatesequence);
+      return msWCSException(map, "CurrentUpdateSequence", "updatesequence",
+                            params->version);
+    }
+    if (i > 0) { /* invalid */
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWCSGetCapabilities()", params->updatesequence, updatesequence);
+      return msWCSException(map, "InvalidUpdateSequence", "updatesequence",
+                            params->version);
+    }
+  }
+
+  else { /* set default updatesequence */
+    if (!updatesequence)
+      updatesequence = "0";
+    params->updatesequence = msStrdup(updatesequence);
+  }
+
+  /* if a bum section param is passed, throw exception */
+  if (params->section &&
+      strcasecmp(params->section, "/WCS_Capabilities/Service") != 0 &&
+      strcasecmp(params->section, "/WCS_Capabilities/Capability") != 0 &&
+      strcasecmp(params->section, "/WCS_Capabilities/ContentMetadata") != 0 &&
+      strcasecmp(params->section, "/") != 0) {
+    msIO_setHeader("Content-Type", "application/vnd.ogc.se_xml; charset=UTF-8");
+    msIO_sendHeaders();
+    msSetError(MS_WCSERR, "Invalid SECTION parameter \"%s\"",
+               "msWCSGetCapabilities()", params->section);
+    return msWCSException(map, "InvalidParameterValue", "section",
+                          params->version);
+  }
+
+  else {
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+    msIO_sendHeaders();
+
+    /* print common capability elements  */
+    /* TODO: DocType? */
+
+    if (!updatesequence)
+      updatesequence = "0";
+
+    msIO_printf(
+        "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+
+    if (!params->section ||
+        (params->section && strcasecmp(params->section, "/") == 0))
+      msIO_printf("<WCS_Capabilities\n"
+                  "   version=\"%s\" \n"
+                  "   updateSequence=\"%s\" \n"
+                  "   xmlns=\"http://www.opengis.net/wcs\" \n"
+                  "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
+                  "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
+                  "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+                  "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                  "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                  params->version, updatesequence, msOWSGetSchemasLocation(map),
+                  params->version);
+
+    /* print the various capability sections */
+    if (!params->section ||
+        strcasecmp(params->section, "/WCS_Capabilities/Service") == 0)
+      msWCSGetCapabilities_Service(map, params);
+
+    if (!params->section ||
+        strcasecmp(params->section, "/WCS_Capabilities/Capability") == 0)
+      msWCSGetCapabilities_Capability(map, params, req);
+
+    if (!params->section ||
+        strcasecmp(params->section, "/WCS_Capabilities/ContentMetadata") == 0)
+      msWCSGetCapabilities_ContentMetadata(map, params, ows_request, req);
+
+    if (params->section && strcasecmp(params->section, "/") == 0) {
+      msWCSGetCapabilities_Service(map, params);
+      msWCSGetCapabilities_Capability(map, params, req);
+      msWCSGetCapabilities_ContentMetadata(map, params, ows_request, req);
+    }
+
+    /* done */
+    if (!params->section ||
+        (params->section && strcasecmp(params->section, "/") == 0))
+      msIO_printf("</WCS_Capabilities>\n");
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*               msWCSDescribeCoverage_AxisDescription()                */
+/************************************************************************/
+
+static int msWCSDescribeCoverage_AxisDescription(layerObj *layer, char *name) {
+  const char *value;
+  char tag[100]; /* should be plenty of space */
+
+  msIO_printf("        <axisDescription>\n");
+  msIO_printf("          <AxisDescription");
+  snprintf(tag, sizeof(tag), "%s_semantic",
+           name); /* optional attributes follow (should escape?) */
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " semantic=\"%s\"", NULL);
+  snprintf(tag, sizeof(tag), "%s_refsys", name);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " refSys=\"%s\"", NULL);
+  snprintf(tag, sizeof(tag), "%s_refsyslabel", name);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " refSysLabel=\"%s\"", NULL);
+  msIO_printf(">\n");
+
+  /* TODO: add metadataLink (optional) */
+
+  snprintf(tag, sizeof(tag), "%s_description", name);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           "            <description>%s</description>\n", NULL);
+  /* snprintf(tag, sizeof(tag), "%s_name", name); */
+  /* msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN, "
+   * <name>%s</name>\n", NULL); */
+  msIO_printf("            <name>%s</name>\n", name);
+
+  snprintf(tag, sizeof(tag), "%s_label", name);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN,
+                           "            <label>%s</label>\n", NULL);
+
+  /* Values */
+  msIO_printf("            <values");
+  snprintf(tag, sizeof(tag), "%s_values_semantic",
+           name); /* optional attributes follow (should escape?) */
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " semantic=\"%s\"", NULL);
+  snprintf(tag, sizeof(tag), "%s_values_type", name);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " type=\"%s\"", NULL);
+  msIO_printf(">\n");
+
+  /* single values, we do not support optional type and semantic attributes */
+  snprintf(tag, sizeof(tag), "%s_values", name);
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", tag))
+    msOWSPrintEncodeMetadataList(
+        stdout, &(layer->metadata), "CO", tag, NULL, NULL,
+        "              <singleValue>%s</singleValue>\n", NULL);
+
+  /* intervals, only one per axis for now, we do not support optional type,
+   * atomic and semantic attributes */
+  snprintf(tag, sizeof(tag), "%s_interval", name);
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", tag)) != NULL) {
+    int numtokens = 0;
+    char **tokens = msStringSplit(value, '/', &numtokens);
+    if (tokens && numtokens > 0) {
+      msIO_printf("            <interval>\n");
+      if (numtokens >= 1)
+        msIO_printf("            <min>%s</min>\n",
+                    tokens[0]); /* TODO: handle closure */
+      if (numtokens >= 2)
+        msIO_printf("            <max>%s</max>\n", tokens[1]);
+      if (numtokens >= 3)
+        msIO_printf("            <res>%s</res>\n", tokens[2]);
+      msIO_printf("            </interval>\n");
+    }
+    msFreeCharArray(tokens, numtokens);
+  }
+
+  /* TODO: add default (optional) */
+
+  msIO_printf("            </values>\n");
+
+  msIO_printf("          </AxisDescription>\n");
+  msIO_printf("        </axisDescription>\n");
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*               msWCSDescribeCoverage_CoverageOffering()               */
+/************************************************************************/
+
+static int msWCSDescribeCoverage_CoverageOffering(layerObj *layer,
+                                                  wcsParamsObj *params,
+                                                  char *script_url_encoded) {
+  const char *value;
+  char *epsg_buf, *encoded_format;
+  coverageMetadataObj cm;
+  int i, status;
+
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  if (!msWCSIsLayerSupported(layer))
+    return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
+
+  status = msWCSGetCoverageMetadata(layer, &cm);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /* fill in bands rangeset info, if required.  */
+  msWCSSetDefaultBandsRangeSetInfo(params, &cm, layer);
+
+  /* start the Coverage section */
+  msIO_printf("  <CoverageOffering>\n");
+
+  msWCSPrintMetadataLink(layer, script_url_encoded);
+
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description",
+                           OWS_NOERR, "  <description>%s</description>\n",
+                           NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR,
+                           "  <name>%s</name>\n", layer->name);
+
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN,
+                           "  <label>%s</label>\n", NULL);
+
+  /* TODO: add elevation ranges to lonLatEnvelope (optional) */
+  msIO_printf(
+      "    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx,
+              cm.llextent.miny);
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx,
+              cm.llextent.maxy);
+
+  msOWSPrintEncodeMetadataList(
+      stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+      "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
+
+  msIO_printf("    </lonLatEnvelope>\n");
+
+  /* we are not supporting the optional keyword type, at least not yet */
+  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist",
+                               "  <keywords>\n", "  </keywords>\n",
+                               "    <keyword>%s</keyword>\n", NULL);
+
+  /* DomainSet: starting simple, just a spatial domain (gml:envelope) and
+   * optionally a temporal domain */
+  msIO_printf("    <domainSet>\n");
+
+  /* SpatialDomain */
+  msIO_printf("      <spatialDomain>\n");
+
+  /* envelope in lat/lon */
+  msIO_printf("        <gml:Envelope srsName=\"EPSG:4326\">\n");
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx,
+              cm.llextent.miny);
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx,
+              cm.llextent.maxy);
+  msIO_printf("        </gml:Envelope>\n");
+
+  /* envelope in the native srs */
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &epsg_buf);
+  if (!epsg_buf) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &epsg_buf);
+  }
+  if (epsg_buf) {
+    msIO_printf("        <gml:Envelope srsName=\"%s\">\n", epsg_buf);
+    msFree(epsg_buf);
+  } else {
+    msIO_printf("        <!-- NativeCRSs ERROR: missing required information, "
+                "no SRSs defined -->\n");
+  }
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.minx,
+              cm.extent.miny);
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.maxx,
+              cm.extent.maxy);
+  msIO_printf("        </gml:Envelope>\n");
+
+  /* gml:rectifiedGrid */
+  msIO_printf("        <gml:RectifiedGrid dimension=\"2\">\n");
+  msIO_printf("          <gml:limits>\n");
+  msIO_printf("            <gml:GridEnvelope>\n");
+  msIO_printf("              <gml:low>0 0</gml:low>\n");
+  msIO_printf("              <gml:high>%d %d</gml:high>\n", cm.xsize - 1,
+              cm.ysize - 1);
+  msIO_printf("            </gml:GridEnvelope>\n");
+  msIO_printf("          </gml:limits>\n");
+  msIO_printf("          <gml:axisName>x</gml:axisName>\n");
+  msIO_printf("          <gml:axisName>y</gml:axisName>\n");
+  msIO_printf("          <gml:origin>\n");
+  msIO_printf("            <gml:pos>%.15g %.15g</gml:pos>\n",
+              cm.geotransform[0], cm.geotransform[3]);
+  msIO_printf("          </gml:origin>\n");
+  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n",
+              cm.geotransform[1],
+              cm.geotransform[2]); /* offset vector in X direction */
+  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n",
+              cm.geotransform[4],
+              cm.geotransform[5]); /* offset vector in Y direction */
+  msIO_printf("        </gml:RectifiedGrid>\n");
+
+  msIO_printf("      </spatialDomain>\n");
+
+  msWCSFreeCoverageMetadata(&cm);
+
+  /* TemporalDomain */
+
+  /* TODO: figure out when a temporal domain is valid, for example only tiled
+   * rasters support time as a domain, plus we need a timeitem */
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") ||
+      msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
+    msIO_printf("      <temporalDomain>\n");
+
+    /* TimePosition (should support a value AUTO, then we could mine positions
+     * from the timeitem) */
+    msOWSPrintEncodeMetadataList(
+        stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+        "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
+
+    /* TODO:  add TimePeriod (only one per layer)  */
+
+    msIO_printf("      </temporalDomain>\n");
+  }
+
+  msIO_printf("    </domainSet>\n");
+
+  /* rangeSet */
+  msIO_printf("    <rangeSet>\n");
+  msIO_printf(
+      "      <RangeSet>\n"); /* TODO: there are some optional attributes */
+
+  /* TODO: add metadataLink (optional) */
+
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO",
+                           "rangeset_description", OWS_NOERR,
+                           "        <description>%s</description>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_name",
+                           OWS_WARN, "        <name>%s</name>\n", NULL);
+
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_label",
+                           OWS_WARN, "        <label>%s</label>\n", NULL);
+
+  /* compound range sets */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                   "rangeset_axes")) != NULL) {
+    int numtokens = 0;
+    char **tokens = msStringSplit(value, ',', &numtokens);
+    if (tokens && numtokens > 0) {
+      for (i = 0; i < numtokens; i++)
+        msWCSDescribeCoverage_AxisDescription(layer, tokens[i]);
+    }
+    msFreeCharArray(tokens, numtokens);
+  }
+
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                   "rangeset_nullvalue")) != NULL) {
+    msIO_printf("        <nullValues>\n");
+    msIO_printf("          <singleValue>%s</singleValue>\n", value);
+    msIO_printf("        </nullValues>\n");
+  }
+
+  msIO_printf("      </RangeSet>\n");
+  msIO_printf("    </rangeSet>\n");
+
+  /* supportedCRSs */
+  msIO_printf("    <supportedCRSs>\n");
+
+  /* requestResposeCRSs: check the layer metadata/projection, and then the map
+   * metadata/projection if necessary (should never get to the error message) */
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_FALSE,
+                   &epsg_buf);
+  if (!epsg_buf) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_FALSE, &epsg_buf);
+  }
+  if (epsg_buf) {
+    int numtokens = 0;
+    char **tokens = msStringSplit(epsg_buf, ' ', &numtokens);
+    if (tokens && numtokens > 0) {
+      for (i = 0; i < numtokens; i++)
+        msIO_printf("      <requestResponseCRSs>%s</requestResponseCRSs>\n",
+                    tokens[i]);
+    }
+    msFreeCharArray(tokens, numtokens);
+    msFree(epsg_buf);
+  } else {
+    msIO_printf("      <!-- requestResponseCRSs ERROR: missing required "
+                "information, no SRSs defined -->\n");
+  }
+
+  /* nativeCRSs (only one in our case) */
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &epsg_buf);
+  if (!epsg_buf) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &epsg_buf);
+  }
+  if (epsg_buf) {
+    msIO_printf("      <nativeCRSs>%s</nativeCRSs>\n", epsg_buf);
+    msFree(epsg_buf);
+  } else {
+    msIO_printf("      <!-- nativeCRSs ERROR: missing required information, no "
+                "SRSs defined -->\n");
+  }
+
+  msIO_printf("    </supportedCRSs>\n");
+
+  /* supportedFormats */
+  msIO_printf("    <supportedFormats");
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "nativeformat",
+                           OWS_NOERR, " nativeFormat=\"%s\"", NULL);
+  msIO_printf(">\n");
+
+  if ((encoded_format = msOWSGetEncodeMetadata(&(layer->metadata), "CO",
+                                               "formats", "GTiff")) != NULL) {
+    int numtokens = 0;
+    char **tokens = msStringSplit(encoded_format, ' ', &numtokens);
+    if (tokens && numtokens > 0) {
+      for (i = 0; i < numtokens; i++)
+        msIO_printf("      <formats>%s</formats>\n", tokens[i]);
+    }
+    msFreeCharArray(tokens, numtokens);
+    msFree(encoded_format);
+  }
+  msIO_printf("    </supportedFormats>\n");
+
+  msIO_printf("    <supportedInterpolations default=\"nearest neighbor\">\n");
+  msIO_printf(
+      "      <interpolationMethod>nearest neighbor</interpolationMethod>\n");
+  msIO_printf("      <interpolationMethod>bilinear</interpolationMethod>\n");
+  /*  msIO_printf("      <interpolationMethod>bicubic</interpolationMethod>\n"
+   * ); */
+  msIO_printf("    </supportedInterpolations>\n");
+
+  /* done */
+  msIO_printf("  </CoverageOffering>\n");
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msWCSDescribeCoverage()                        */
+/************************************************************************/
+
+static int msWCSDescribeCoverage(mapObj *map, wcsParamsObj *params,
+                                 owsRequestObj *ows_request,
+                                 cgiRequestObj *req) {
+  int i = 0, j = 0, k = 0;
+  const char *updatesequence = NULL;
+  char **coverages = NULL;
+  int numcoverages = 0;
+
+  char *coverageName = NULL;
+  char *script_url_encoded = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      1.1.x is sufficiently different we have a whole case for        */
+  /*      it.  The remainder of this function is for 1.0.0.               */
+  /* -------------------------------------------------------------------- */
+  if (strncmp(params->version, "1.1", 3) == 0)
+    return msWCSDescribeCoverage11(map, params, ows_request);
+
+  /* -------------------------------------------------------------------- */
+  /*      Process 1.0.0...                                                */
+  /* -------------------------------------------------------------------- */
+
+  if (params->coverages) { /* use the list, but validate it first */
+    for (j = 0; params->coverages[j]; j++) {
+      coverages = msStringSplit(params->coverages[j], ',', &numcoverages);
+      for (k = 0; k < numcoverages; k++) {
+
+        for (i = 0; i < map->numlayers; i++) {
+          coverageName =
+              msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                     "name", GET_LAYER(map, i)->name);
+          if (coverageName != NULL && EQUAL(coverageName, coverages[k]) &&
+              (msIntegerInArray(GET_LAYER(map, i)->index,
+                                ows_request->enabled_layers,
+                                ows_request->numlayers))) {
+            msFree(coverageName);
+            break;
+          }
+          msFree(coverageName);
+        }
+
+        /* i = msGetLayerIndex(map, coverages[k]); */
+        if (i == map->numlayers) { /* coverage not found */
+          msSetError(
+              MS_WCSERR,
+              "COVERAGE %s cannot be opened / does not exist. A layer might be disabled for \
+this request. Check wcs/ows_enable_request settings.",
+              "msWCSDescribeCoverage()", coverages[k]);
+          return msWCSException(map, "CoverageNotDefined", "coverage",
+                                params->version);
+        }
+      } /* next coverage */
+      msFreeCharArray(coverages, numcoverages);
+    }
+  }
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+  if (!updatesequence)
+    updatesequence = "0";
+
+  /* printf("Content-Type: application/vnd.ogc.se_xml%c%c",10,10); */
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  /* print common capability elements  */
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+
+  /* start the DescribeCoverage section */
+  msIO_printf("<CoverageDescription\n"
+              "   version=\"%s\" \n"
+              "   updateSequence=\"%s\" \n"
+              "   xmlns=\"http://www.opengis.net/wcs\" \n"
+              "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
+              "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
+              "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+              "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+              "%s/wcs/%s/describeCoverage.xsd\">\n",
+              params->version, updatesequence, msOWSGetSchemasLocation(map),
+              params->version);
+
+  {
+    char *pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
+    script_url_encoded = msEncodeHTMLEntities(pszTmp);
+    msFree(pszTmp);
+  }
+
+  if (params->coverages) { /* use the list */
+    for (j = 0; params->coverages[j]; j++) {
+      coverages = msStringSplit(params->coverages[j], ',', &numcoverages);
+      for (k = 0; k < numcoverages; k++) {
+        for (i = 0; i < map->numlayers; i++) {
+          coverageName =
+              msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                     "name", GET_LAYER(map, i)->name);
+          if (coverageName != NULL && EQUAL(coverageName, coverages[k])) {
+            msFree(coverageName);
+            break;
+          }
+          msFree(coverageName);
+        }
+        msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params,
+                                               script_url_encoded);
+      }
+      msFreeCharArray(coverages, numcoverages);
+    }
+  } else { /* return all layers */
+    for (i = 0; i < map->numlayers; i++) {
+      if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                            ows_request->enabled_layers,
+                            ows_request->numlayers))
+        continue;
+
+      msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params,
+                                             script_url_encoded);
+    }
+  }
+
+  msFree(script_url_encoded);
+
+  /* done */
+  msIO_printf("</CoverageDescription>\n");
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msWCSGetCoverageBands10()                      */
+/************************************************************************/
+
+static int msWCSGetCoverageBands10(mapObj *map, cgiRequestObj *request,
+                                   wcsParamsObj *params, layerObj *lp,
+                                   char **p_bandlist)
+
+{
+  const char *value = NULL;
+  int i;
+
+  /* Are there any non-spatio/temporal ranges to do subsetting on (e.g. bands)
+   */
+  value = msOWSLookupMetadata(
+      &(lp->metadata), "CO",
+      "rangeset_axes"); /* this will get all the compound range sets */
+  if (value) {
+    char **tokens;
+    int numtokens;
+    char tag[100];
+    const char *rangeitem;
+
+    tokens = msStringSplit(value, ',', &numtokens);
+
+    for (i = 0; i < numtokens; i++) {
+      if ((value = msWCSGetRequestParameter(request, tokens[i])) == NULL)
+        continue; /* next rangeset parameter */
+
+      /* ok, a parameter has been passed which matches a token in
+       * wcs_rangeset_axes */
+      if (msWCSValidateRangeSetParam(lp, tokens[i], value) != MS_SUCCESS) {
+        int ret;
+        msSetError(MS_WCSERR, "Error specifying \"%s\" parameter value(s).",
+                   "msWCSGetCoverage()", tokens[i]);
+        ret = msWCSException(map, "InvalidParameterValue", tokens[i],
+                             params->version);
+        msFreeCharArray(tokens, numtokens);
+        return ret;
+      }
+
+      /* xxxxx_rangeitem tells us how to subset */
+      snprintf(tag, sizeof(tag), "%s_rangeitem", tokens[i]);
+      if ((rangeitem = msOWSLookupMetadata(&(lp->metadata), "CO", tag)) ==
+          NULL) {
+        msSetError(MS_WCSERR,
+                   "Missing required metadata element \"%s\", unable to "
+                   "process %s=%s.",
+                   "msWCSGetCoverage()", tag, tokens[i], value);
+        msFreeCharArray(tokens, numtokens);
+        return msWCSException(map, NULL, NULL, params->version);
+      }
+
+      if (strcasecmp(rangeitem, "_bands") ==
+          0) { /* special case, subset bands */
+        *p_bandlist = msWCSConvertRangeSetToString(value);
+
+        if (!*p_bandlist) {
+          msSetError(MS_WCSERR, "Error specifying \"%s\" parameter value(s).",
+                     "msWCSGetCoverage()", tokens[i]);
+          msFreeCharArray(tokens, numtokens);
+          return msWCSException(map, NULL, NULL, params->version);
+        }
+      } else if (strcasecmp(rangeitem, "_pixels") ==
+                 0) { /* special case, subset pixels */
+        msFreeCharArray(tokens, numtokens);
+        msSetError(
+            MS_WCSERR,
+            "Arbitrary range sets based on pixel values are not yet supported.",
+            "msWCSGetCoverage()");
+        return msWCSException(map, NULL, NULL, params->version);
+      } else {
+        msFreeCharArray(tokens, numtokens);
+        msSetError(MS_WCSERR,
+                   "Arbitrary range sets based on tile (i.e. image) attributes "
+                   "are not yet supported.",
+                   "msWCSGetCoverage()");
+        return msWCSException(map, NULL, NULL, params->version);
+      }
+    }
+    /* clean-up */
+    msFreeCharArray(tokens, numtokens);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSGetCoverage_ImageCRSSetup()                   */
+/*                                                                      */
+/*      The request was in imageCRS - update the map projection to      */
+/*      map the native projection of the layer, and reset the           */
+/*      bounding box to match the projected bounds corresponding to     */
+/*      the imageCRS request.                                           */
+/************************************************************************/
+
+static int msWCSGetCoverage_ImageCRSSetup(mapObj *map, wcsParamsObj *params,
+                                          coverageMetadataObj *cm,
+                                          layerObj *layer)
+
+{
+  /* -------------------------------------------------------------------- */
+  /*      Load map with the layer (coverage) coordinate system.  We       */
+  /*      really need a set projectionObj from projectionObj function!    */
+  /* -------------------------------------------------------------------- */
+  char *layer_proj = msGetProjectionString(&(layer->projection));
+
+  if (msLoadProjectionString(&(map->projection), layer_proj) != 0) {
+    msFree(layer_proj);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+
+  free(layer_proj);
+  layer_proj = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Reset bounding box.                                             */
+  /* -------------------------------------------------------------------- */
+  if (params->bbox.maxx != params->bbox.minx) {
+    rectObj orig_bbox = params->bbox;
+
+    params->bbox.minx = cm->geotransform[0] +
+                        orig_bbox.minx * cm->geotransform[1] +
+                        orig_bbox.miny * cm->geotransform[2];
+    params->bbox.maxy = cm->geotransform[3] +
+                        orig_bbox.minx * cm->geotransform[4] +
+                        orig_bbox.miny * cm->geotransform[5];
+    params->bbox.maxx = cm->geotransform[0] +
+                        (orig_bbox.maxx + 1) * cm->geotransform[1] +
+                        (orig_bbox.maxy + 1) * cm->geotransform[2];
+    params->bbox.miny = cm->geotransform[3] +
+                        (orig_bbox.maxx + 1) * cm->geotransform[4] +
+                        (orig_bbox.maxy + 1) * cm->geotransform[5];
+
+    /* WCS 1.1 boundbox is center of pixel oriented. */
+    if (strncasecmp(params->version, "1.1", 3) == 0) {
+      params->bbox.minx += cm->geotransform[1] / 2 + cm->geotransform[2] / 2;
+      params->bbox.maxx -= cm->geotransform[1] / 2 + cm->geotransform[2] / 2;
+      params->bbox.maxy += cm->geotransform[4] / 2 + cm->geotransform[5] / 2;
+      params->bbox.miny -= cm->geotransform[4] / 2 + cm->geotransform[5] / 2;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Reset resolution.                                               */
+  /* -------------------------------------------------------------------- */
+  if (params->resx != 0.0) {
+    params->resx = cm->geotransform[1] * params->resx;
+    params->resy = fabs(cm->geotransform[5] * params->resy);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                    msWCSApplyLayerCreationOptions()                  */
+/************************************************************************/
+
+void msWCSApplyLayerCreationOptions(layerObj *lp, outputFormatObj *format,
+                                    const char *bandlist)
+
+{
+  const char *pszKey;
+  char szKeyBeginning[256];
+  size_t nKeyBeginningLength;
+  int nBands = 0;
+  char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+
+  snprintf(szKeyBeginning, sizeof(szKeyBeginning),
+           "wcs_outputformat_%s_creationoption_", format->name);
+  nKeyBeginningLength = strlen(szKeyBeginning);
+
+  pszKey = msFirstKeyFromHashTable(&(lp->metadata));
+  for (; pszKey != NULL;
+       pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+    if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+      const char *pszValue = msLookupHashTable(&(lp->metadata), pszKey);
+      const char *pszGDALKey = pszKey + nKeyBeginningLength;
+      if (EQUALN(pszGDALKey, "BAND_", strlen("BAND_"))) {
+        /* Remap BAND specific creation option to the real output
+         * band number, given the band subset of the request */
+        int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
+        int nTargetBandNumber = -1;
+        int i;
+        for (i = 0; i < nBands; i++) {
+          if (nKeyOriBandNumber == atoi(papszBandNumbers[i])) {
+            nTargetBandNumber = i + 1;
+            break;
+          }
+        }
+        if (nTargetBandNumber > 0) {
+          char szModKey[256];
+          const char *pszAfterBand = strchr(pszGDALKey + strlen("BAND_"), '_');
+          if (pszAfterBand != NULL) {
+            snprintf(szModKey, sizeof(szModKey), "BAND_%d%s", nTargetBandNumber,
+                     pszAfterBand);
+            if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+              msDebug("Setting GDAL %s=%s creation option\n", szModKey,
+                      pszValue);
+            }
+            msSetOutputFormatOption(format, szModKey, pszValue);
+          }
+        }
+      } else {
+        if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("Setting GDAL %s=%s creation option\n", pszGDALKey, pszValue);
+        }
+        msSetOutputFormatOption(format, pszGDALKey, pszValue);
+      }
+    }
+  }
+
+  msFreeCharArray(papszBandNumbers, nBands);
+}
+
+/************************************************************************/
+/*               msWCSApplyDatasetMetadataAsCreationOptions()           */
+/************************************************************************/
+
+void msWCSApplyDatasetMetadataAsCreationOptions(layerObj *lp,
+                                                outputFormatObj *format,
+                                                const char *bandlist,
+                                                void *hDSIn) {
+  /* Requires GDAL 2.3 in practice. */
+  /* Automatic forwarding of input dataset metadata if it is GRIB and the */
+  /* output is GRIB as well, and wcs_outputformat_GRIB_creationoption* are */
+  /* not defined. */
+  GDALDatasetH hDS = (GDALDatasetH)hDSIn;
+  if (hDS && GDALGetDatasetDriver(hDS) &&
+      EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "GRIB") &&
+      EQUAL(format->driver, "GDAL/GRIB")) {
+    const char *pszKey;
+    char szKeyBeginning[256];
+    size_t nKeyBeginningLength;
+    int bWCSMetadataFound = MS_FALSE;
+
+    snprintf(szKeyBeginning, sizeof(szKeyBeginning),
+             "wcs_outputformat_%s_creationoption_", format->name);
+    nKeyBeginningLength = strlen(szKeyBeginning);
+
+    for (pszKey = msFirstKeyFromHashTable(&(lp->metadata)); pszKey != NULL;
+         pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+      if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+        bWCSMetadataFound = MS_TRUE;
+        break;
+      }
+    }
+    if (!bWCSMetadataFound) {
+      int nBands = 0;
+      char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+      int i;
+      for (i = 0; i < nBands; i++) {
+        int nSrcBand = atoi(papszBandNumbers[i]);
+        int nDstBand = i + 1;
+        GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
+        if (hBand) {
+          char **papszMD = GDALGetMetadata(hBand, NULL);
+          const char *pszMDI = CSLFetchNameValue(papszMD, "GRIB_IDS");
+          // Make sure it is a GRIB2 band
+          if (pszMDI) {
+            char szKey[256];
+            sprintf(szKey, "BAND_%d_IDS", nDstBand);
+            msSetOutputFormatOption(format, szKey, pszMDI);
+
+            sprintf(szKey, "BAND_%d_DISCIPLINE", nDstBand);
+            msSetOutputFormatOption(format, szKey,
+                                    CSLFetchNameValue(papszMD, "DISCIPLINE"));
+
+            sprintf(szKey, "BAND_%d_PDS_PDTN", nDstBand);
+            msSetOutputFormatOption(
+                format, szKey, CSLFetchNameValue(papszMD, "GRIB_PDS_PDTN"));
+
+            sprintf(szKey, "BAND_%d_PDS_TEMPLATE_NUMBERS", nDstBand);
+            msSetOutputFormatOption(
+                format, szKey,
+                CSLFetchNameValue(papszMD, "GRIB_PDS_TEMPLATE_NUMBERS"));
+          }
+        }
+      }
+      msFreeCharArray(papszBandNumbers, nBands);
+    }
+  }
+}
+
+/************************************************************************/
+/*                  msWCSApplyLayerMetadataItemOptions()                */
+/************************************************************************/
+
+void msWCSApplyLayerMetadataItemOptions(layerObj *lp, outputFormatObj *format,
+                                        const char *bandlist)
+
+{
+  if (!STARTS_WITH(format->driver, "GDAL/"))
+    return;
+
+  const bool bIsNetCDFOutput = EQUAL(format->driver, "GDAL/netCDF");
+  const char *pszKey;
+  char szKeyBeginning[256];
+  size_t nKeyBeginningLength;
+  int nBands = 0;
+  char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+
+  snprintf(szKeyBeginning, sizeof(szKeyBeginning), "wcs_outputformat_%s_mdi_",
+           format->name);
+  nKeyBeginningLength = strlen(szKeyBeginning);
+
+  // Transform wcs_outputformat_{formatname}_mdi_{key} to mdi_{key}
+  // and Transform wcs_outputformat_{formatname}_mdi_BAND_X_{key} to
+  // mdi_BAND_Y_{key} MDI stands for MetaDataItem
+
+  // For netCDF 3D output
+  std::map<int, std::string> oMapExtraDimValues;
+  std::string osExtraDimName;
+  bool bExtraDimValid = false;
+
+  pszKey = msFirstKeyFromHashTable(&(lp->metadata));
+  for (; pszKey != NULL;
+       pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+    if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+      const char *pszValue = msLookupHashTable(&(lp->metadata), pszKey);
+      const char *pszGDALKey = pszKey + nKeyBeginningLength;
+
+      if (EQUALN(pszGDALKey, "BAND_", strlen("BAND_"))) {
+        /* Remap BAND specific creation option to the real output
+         * band number, given the band subset of the request */
+        int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
+        int nTargetBandNumber = -1;
+        int i;
+        for (i = 0; i < nBands; i++) {
+          if (nKeyOriBandNumber == atoi(papszBandNumbers[i])) {
+            nTargetBandNumber = i + 1;
+            break;
+          }
+        }
+        if (nTargetBandNumber > 0) {
+          char szModKey[256];
+          const char *pszAfterBand = strchr(pszGDALKey + strlen("BAND_"), '_');
+          if (pszAfterBand != NULL) {
+            // Special case to generate 3D netCDF files
+            if (bIsNetCDFOutput &&
+                strncmp(pszAfterBand, "_default_NETCDF_DIM_",
+                        strlen("_default_NETCDF_DIM_")) == 0) {
+              const char *pszDimName =
+                  pszAfterBand + strlen("_default_NETCDF_DIM_");
+              if (osExtraDimName.empty()) {
+                bExtraDimValid = true;
+                osExtraDimName = pszDimName;
+                oMapExtraDimValues[nTargetBandNumber] = pszValue;
+              } else if (bExtraDimValid) {
+                if (osExtraDimName != pszDimName) {
+                  msDebug("One band has several %sdefault_NETCDF_DIM_ metadata "
+                          "items, "
+                          "or different bands have a different value. "
+                          "Only a single extra dimension is supported.",
+                          szKeyBeginning);
+                  bExtraDimValid = false;
+                } else {
+                  oMapExtraDimValues[nTargetBandNumber] = pszValue;
+                }
+              }
+            } else {
+              snprintf(szModKey, sizeof(szModKey), "mdi_BAND_%d%s",
+                       nTargetBandNumber, pszAfterBand);
+              if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+                msDebug("Setting GDAL %s=%s metadata item option\n", szModKey,
+                        pszValue);
+              }
+              msSetOutputFormatOption(format, szModKey, pszValue);
+            }
+          }
+        }
+      } else {
+        char szModKey[256];
+        snprintf(szModKey, sizeof(szModKey), "mdi_%s", pszGDALKey);
+        if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("Setting GDAL %s=%s metadata item option\n", szModKey,
+                  pszValue);
+        }
+        msSetOutputFormatOption(format, szModKey, pszValue);
+      }
+    }
+  }
+
+  // netCDF 3D output
+  // Tested in msautotest/wxs/wcs_netcdf_3d_output.map
+  std::string osExtraDimDataType;
+  if (bExtraDimValid && static_cast<int>(oMapExtraDimValues.size()) != nBands) {
+    msDebug("One of the band lack a NETCDF_DIM_%s metadata item.",
+            osExtraDimName.c_str());
+    bExtraDimValid = false;
+  }
+  if (bExtraDimValid) {
+    for (const auto &keyValue : oMapExtraDimValues) {
+      const auto &osVal = keyValue.second;
+      const CPLValueType eType = CPLGetValueType(osVal.c_str());
+      if (eType == CPL_VALUE_STRING) {
+        osExtraDimDataType = "string";
+        break;
+      } else if (eType == CPL_VALUE_INTEGER) {
+        if (osExtraDimDataType.empty() || osExtraDimDataType == "integer") {
+          osExtraDimDataType = "integer";
+          const GIntBig nVal = CPLAtoGIntBig(osVal.c_str());
+          if (nVal > INT_MAX || nVal < INT_MIN) {
+            osExtraDimDataType = "integer64";
+          }
+        }
+      } else {
+        osExtraDimDataType = "double";
+      }
+    }
+    if (osExtraDimDataType == "string") {
+      msDebug("One of the value for the NETCDF_DIM_%s metadata is a string. "
+              "This is not supported",
+              osExtraDimName.c_str());
+      bExtraDimValid = false;
+    }
+  }
+  if (bExtraDimValid) {
+    // Cf
+    // https://gdal.org/drivers/raster/netcdf.html#creation-of-multidimensional-files-with-createcopy-2d-raster-api
+
+    // Define the name of the extra dimensions
+    {
+      std::string osValue;
+      osValue = '{';
+      osValue += osExtraDimName;
+      osValue += '}';
+
+      msSetOutputFormatOption(format, "mdi_default_NETCDF_DIM_EXTRA",
+                              osValue.c_str());
+    }
+
+    // Define the size (in number of samples) and type of the extra dimension
+    {
+      std::string osKey;
+      osKey = "mdi_default_NETCDF_DIM_";
+      osKey += osExtraDimName;
+      osKey += "_DEF";
+
+      std::string osValue;
+      osValue = '{';
+      osValue += CPLSPrintf("%d", nBands);
+      osValue += ',';
+      if (osExtraDimDataType == "integer")
+        osValue += '4';
+      else if (osExtraDimDataType == "integer64")
+        osValue += "10";
+      else /* if ( osExtraDimDataType == "double" ) */
+        osValue += '6';
+      osValue += '}';
+
+      msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
+    }
+
+    // Define the values along the extra dimension
+    {
+      std::string osKey;
+      osKey = "mdi_default_NETCDF_DIM_";
+      osKey += osExtraDimName;
+      osKey += "_VALUES";
+      std::string osValue;
+      osValue = '{';
+      bool bFirstVal = true;
+      for (const auto &keyValue : oMapExtraDimValues) {
+        const auto &osVal = keyValue.second;
+        if (!bFirstVal)
+          osValue += ',';
+        else
+          bFirstVal = false;
+        osValue += osVal;
+      }
+      osValue += '}';
+
+      msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
+    }
+  }
+
+  msFreeCharArray(papszBandNumbers, nBands);
+}
+
+/************************************************************************/
+/*               msWCSApplySourceDatasetMetadata()                      */
+/************************************************************************/
+
+void msWCSApplySourceDatasetMetadata(layerObj *lp, outputFormatObj *format,
+                                     const char *bandlist, void *hDSIn) {
+  /* Automatic forwarding of input dataset metadata if it is netCDF and the */
+  /* output is netCDF as well, and wcs_outputformat_netCDF_mdi* are */
+  /* not defined. */
+  GDALDatasetH hDS = (GDALDatasetH)hDSIn;
+  if (hDS && GDALGetDatasetDriver(hDS) &&
+      EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "netCDF") &&
+      EQUAL(format->driver, "GDAL/netCDF")) {
+    const char *pszKey;
+    char szKeyBeginning[256];
+    size_t nKeyBeginningLength;
+    int bWCSMetadataFound = MS_FALSE;
+
+    snprintf(szKeyBeginning, sizeof(szKeyBeginning), "wcs_outputformat_%s_mdi_",
+             format->name);
+    nKeyBeginningLength = strlen(szKeyBeginning);
+
+    for (pszKey = msFirstKeyFromHashTable(&(lp->metadata)); pszKey != NULL;
+         pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+      if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+        bWCSMetadataFound = MS_TRUE;
+        break;
+      }
+    }
+    if (!bWCSMetadataFound) {
+      int nBands = 0;
+      char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+
+      std::string osExtraDimName;
+      // Special processing if the input dataset is a 3D one
+      {
+        // Check if extra dimensions are declared on the source dataset,
+        // and if so, if there's just a single one.
+        const char *pszDimExtraWithCurl =
+            GDALGetMetadataItem(hDS, "NETCDF_DIM_EXTRA", nullptr);
+        if (pszDimExtraWithCurl &&
+            strchr(pszDimExtraWithCurl, ',') == nullptr &&
+            pszDimExtraWithCurl[0] == '{' &&
+            pszDimExtraWithCurl[strlen(pszDimExtraWithCurl) - 1] == '}') {
+          osExtraDimName.append(pszDimExtraWithCurl + 1,
+                                strlen(pszDimExtraWithCurl) - 2);
+
+          // Declare the extra dimension name
+          msSetOutputFormatOption(format, "mdi_default_NETCDF_DIM_EXTRA",
+                                  pszDimExtraWithCurl);
+
+          // Declare the extra dimension definition: size + data type
+          const char *pszDimExtraDef = GDALGetMetadataItem(
+              hDS, ("NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(), nullptr);
+          if (pszDimExtraDef && pszDimExtraDef[0] == '{' &&
+              pszDimExtraDef[strlen(pszDimExtraDef) - 1] == '}') {
+            const auto tokens = msStringSplit(
+                std::string(pszDimExtraDef + 1, strlen(pszDimExtraDef) - 2)
+                    .c_str(),
+                ',');
+            if (tokens.size() == 2) {
+              const auto &varType = tokens[1];
+              msSetOutputFormatOption(
+                  format,
+                  ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(),
+                  (std::string("{") + CPLSPrintf("%d", nBands) + ',' + varType +
+                   '}')
+                      .c_str());
+            }
+          }
+
+          // Declare the extra dimension values
+          const char *pszDimExtraValues = GDALGetMetadataItem(
+              hDS, ("NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(),
+              nullptr);
+          if (pszDimExtraValues && pszDimExtraValues[0] == '{' &&
+              pszDimExtraValues[strlen(pszDimExtraValues) - 1] == '}') {
+            const auto tokens =
+                msStringSplit(std::string(pszDimExtraValues + 1,
+                                          strlen(pszDimExtraValues) - 2)
+                                  .c_str(),
+                              ',');
+            if (static_cast<int>(tokens.size()) == GDALGetRasterCount(hDS)) {
+              std::string osValue = "{";
+              for (int i = 0; i < nBands; i++) {
+                int nSrcBand = atoi(papszBandNumbers[i]);
+                assert(nSrcBand >= 1 &&
+                       nSrcBand <= static_cast<int>(tokens.size()));
+                if (i > 0)
+                  osValue += ',';
+                osValue += tokens[nSrcBand - 1];
+              }
+              osValue += '}';
+
+              msSetOutputFormatOption(
+                  format,
+                  ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES")
+                      .c_str(),
+                  osValue.c_str());
+            }
+          } else if (pszDimExtraValues) {
+            // If there's a single value
+            msSetOutputFormatOption(
+                format,
+                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES")
+                    .c_str(),
+                pszDimExtraValues);
+          }
+        }
+      }
+
+      {
+        char **papszMD = GDALGetMetadata(hDS, NULL);
+        if (papszMD) {
+          for (char **papszIter = papszMD; *papszIter; ++papszIter) {
+            // Copy netCDF global attributes, as well as the ones
+            // of the extra dimension for 3D netCDF files
+            if (STARTS_WITH(*papszIter, "NC_GLOBAL#") ||
+                (!osExtraDimName.empty() &&
+                 STARTS_WITH(*papszIter, osExtraDimName.c_str()) &&
+                 (*papszIter)[osExtraDimName.size()] == '#')) {
+              char *pszKey = nullptr;
+              const char *pszValue = CPLParseNameValue(*papszIter, &pszKey);
+              if (pszKey && pszValue) {
+                char szKey[256];
+                snprintf(szKey, sizeof(szKey), "mdi_default_%s", pszKey);
+                msSetOutputFormatOption(format, szKey, pszValue);
+              }
+              CPLFree(pszKey);
+            }
+          }
+        }
+      }
+
+      for (int i = 0; i < nBands; i++) {
+        int nSrcBand = atoi(papszBandNumbers[i]);
+        int nDstBand = i + 1;
+        GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
+        if (hBand) {
+          char **papszMD = GDALGetMetadata(hBand, NULL);
+          if (papszMD) {
+            for (char **papszIter = papszMD; *papszIter; ++papszIter) {
+              char *pszKey = nullptr;
+              const char *pszValue = CPLParseNameValue(*papszIter, &pszKey);
+              if (pszKey && pszValue && !EQUAL(pszKey, "grid_name") &&
+                  !EQUAL(pszKey, "grid_mapping")) {
+                char szKey[256];
+                snprintf(szKey, sizeof(szKey), "mdi_BAND_%d_default_%s",
+                         nDstBand, pszKey);
+                msSetOutputFormatOption(format, szKey, pszValue);
+              }
+              CPLFree(pszKey);
+            }
+          }
+        }
+      }
+      msFreeCharArray(papszBandNumbers, nBands);
+    }
+  }
+}
+
+/************************************************************************/
+/*                          msWCSGetCoverage()                          */
+/************************************************************************/
+
+static int msWCSGetCoverage(mapObj *map, cgiRequestObj *request,
+                            wcsParamsObj *params, owsRequestObj *ows_request) {
+  imageObj *image;
+  layerObj *lp;
+  int status, i;
+  const char *value;
+  outputFormatObj *format;
+  char *bandlist = NULL;
+  size_t bufferSize = 0;
+  char numbands[12]; /* should be large enough to hold the number of bands in
+                        the bandlist */
+  coverageMetadataObj cm;
+  rectObj reqextent;
+  rectObj covextent;
+  rasterBufferObj rb;
+  int doDrawRasterLayerDraw = MS_TRUE;
+  GDALDatasetH hDS = NULL;
+
+  char *coverageName;
+
+  /* make sure all required parameters are available (at least the easy ones) */
+  if (!params->crs) {
+    msSetError(MS_WCSERR, "Required parameter CRS was not supplied.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue", "crs", params->version);
+  }
+
+  if (!params->time && !params->bbox.minx && !params->bbox.miny &&
+      !params->bbox.maxx && !params->bbox.maxy) {
+    msSetError(MS_WCSERR, "One of BBOX or TIME is required",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue", "bbox/time",
+                          params->version);
+  }
+
+  if (params->coverages == NULL || params->coverages[0] == NULL) {
+    msSetError(MS_WCSERR, "Required parameter COVERAGE was not supplied.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue", "coverage",
+                          params->version);
+  }
+
+  /* For WCS 1.1, we need to normalize the axis order of the BBOX and
+     resolution values some coordinate systems (eg. EPSG geographic) */
+  if (strncasecmp(params->version, "1.0", 3) != 0 && params->crs != NULL &&
+      strncasecmp(params->crs, "urn:", 4) == 0) {
+    projectionObj proj;
+
+    msInitProjection(&proj);
+    msProjectionInheritContextFrom(&proj, &(map->projection));
+    if (msLoadProjectionString(&proj, (char *)params->crs) == 0) {
+      msAxisNormalizePoints(&proj, 1, &(params->bbox.minx),
+                            &(params->bbox.miny));
+      msAxisNormalizePoints(&proj, 1, &(params->bbox.maxx),
+                            &(params->bbox.maxy));
+      msAxisNormalizePoints(&proj, 1, &(params->resx), &(params->resy));
+      msAxisNormalizePoints(&proj, 1, &(params->originx), &(params->originy));
+    } else
+      msResetErrorList();
+    msFreeProjection(&proj);
+  }
+
+  /* find the layer we are working with */
+  lp = NULL;
+  for (i = 0; i < map->numlayers; i++) {
+    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                          "name", GET_LAYER(map, i)->name);
+    if (coverageName != NULL && EQUAL(coverageName, params->coverages[0]) &&
+        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))) {
+      lp = GET_LAYER(map, i);
+      free(coverageName);
+      break;
+    }
+    free(coverageName);
+  }
+
+  if (lp == NULL) {
+    msSetError(
+        MS_WCSERR,
+        "COVERAGE=%s not found, not in supported layer list. A layer might be disabled for \
+this request. Check wcs/ows_enable_request settings.",
+        "msWCSGetCoverage()", params->coverages[0]);
+    return msWCSException(map, "InvalidParameterValue", "coverage",
+                          params->version);
+  }
+
+  /* make sure the layer is on */
+  lp->status = MS_ON;
+
+  /* If the layer has no projection set, set it to the map's projection (#4079)
+   */
+  if (lp->projection.numargs <= 0) {
+    char *map_original_srs = msGetProjectionString(&(map->projection));
+    if (msLoadProjectionString(&(lp->projection), map_original_srs) != 0) {
+      msSetError(
+          MS_WCSERR,
+          "Error when setting map projection to a layer with no projection",
+          "msWCSGetCoverage()");
+      free(map_original_srs);
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+    free(map_original_srs);
+  }
+
+  /* we need the coverage metadata, since things like numbands may not be
+   * available otherwise */
+  status = msWCSGetCoverageMetadata(lp, &cm);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  /* fill in bands rangeset info, if required.  */
+  msWCSSetDefaultBandsRangeSetInfo(params, &cm, lp);
+
+  /* handle the response CRS, that is, set the map object projection */
+  if (params->response_crs || params->crs) {
+    int iUnits;
+    const char *crs_to_use = params->response_crs;
+
+    if (crs_to_use == NULL)
+      crs_to_use = params->crs;
+
+    if (strncasecmp(crs_to_use, "EPSG:", 5) == 0 ||
+        strncasecmp(crs_to_use, "urn:ogc:def:crs:", 16) == 0) {
+      if (msLoadProjectionString(&(map->projection), (char *)crs_to_use) != 0)
+        return msWCSException(map, NULL, NULL, params->version);
+    } else if (strcasecmp(crs_to_use, "imageCRS") == 0) {
+      /* use layer native CRS, and rework bounding box accordingly */
+      if (msWCSGetCoverage_ImageCRSSetup(map, params, &cm, lp) != MS_SUCCESS) {
+        msWCSFreeCoverageMetadata(&cm);
+        return MS_FAILURE;
+      }
+    } else { /* should we support WMS style AUTO: projections? (not for now) */
+      msSetError(MS_WCSERR,
+                 "Unsupported SRS namespace (only EPSG currently supported).",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "srs",
+                            params->version);
+    }
+
+    iUnits = GetMapserverUnitUsingProj(&(map->projection));
+    if (iUnits != -1)
+      map->units = static_cast<MS_UNITS>(iUnits);
+  }
+
+  /* did we get a TIME value (support only a single value for now) */
+  if (params->time) {
+    int tli;
+    layerObj *tlp = NULL;
+
+    /* need to handle NOW case */
+
+    /* check format of TIME parameter */
+    if (strchr(params->time, ',')) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(MS_WCSERR,
+                 "Temporal lists are not supported, only individual values.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
+    }
+    if (strchr(params->time, '/')) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(MS_WCSERR,
+                 "Temporal ranges are not supported, only individual values.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
+    }
+
+    /* TODO: will need to expand this check if a time period is supported */
+    value = msOWSLookupMetadata(&(lp->metadata), "CO", "timeposition");
+    if (!value) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(MS_WCSERR,
+                 "The coverage does not support temporal subsetting.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
+    }
+
+    /* check if timestamp is covered by the wcs_timeposition definition */
+    if (msValidateTimeValue(params->time, value) == MS_FALSE) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(MS_WCSERR, "The coverage does not have a time position of %s.",
+                 "msWCSGetCoverage()", params->time);
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
+    }
+
+    /* make sure layer is tiled appropriately */
+    if (!lp->tileindex) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(
+          MS_WCSERR,
+          "Underlying layer is not tiled, unable to do temporal subsetting.",
+          "msWCSGetCoverage()");
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+    tli = msGetLayerIndex(map, lp->tileindex);
+    if (tli == -1) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(MS_WCSERR,
+                 "Underlying layer does not use appropriate tiling mechanism.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+
+    tlp = (GET_LAYER(map, tli));
+
+    /* make sure there is enough information to filter */
+    value = msOWSLookupMetadata(&(lp->metadata), "CO", "timeitem");
+    if (!tlp->filteritem && !value) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(MS_WCSERR, "Not enough information available to filter.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+
+    /* override filteritem if specified in metadata */
+    if (value) {
+      if (tlp->filteritem)
+        free(tlp->filteritem);
+      tlp->filteritem = msStrdup(value);
+    }
+
+    /* finally set the filter */
+    msLayerSetTimeFilter(tlp, params->time, value);
+  }
+
+  if (strncasecmp(params->version, "1.0", 3) == 0)
+    status = msWCSGetCoverageBands10(map, request, params, lp, &bandlist);
+  else
+    status = msWCSGetCoverageBands11(map, request, params, lp, &bandlist);
+  if (status != MS_SUCCESS) {
+    msWCSFreeCoverageMetadata(&cm);
+    return status;
+  }
+
+  /* did we get BBOX values? if not use the exent stored in the
+   * coverageMetadataObj */
+  if (fabs((params->bbox.maxx - params->bbox.minx)) < 0.000000000001 ||
+      fabs(params->bbox.maxy - params->bbox.miny) < 0.000000000001) {
+    params->bbox = cm.extent;
+
+    /* WCS 1.1 boundbox is center of pixel oriented. */
+    if (strncasecmp(params->version, "1.1", 3) == 0) {
+      params->bbox.minx += cm.geotransform[1] / 2 + cm.geotransform[2] / 2;
+      params->bbox.maxx -= cm.geotransform[1] / 2 + cm.geotransform[2] / 2;
+      params->bbox.maxy += cm.geotransform[4] / 2 + cm.geotransform[5] / 2;
+      params->bbox.miny -= cm.geotransform[4] / 2 + cm.geotransform[5] / 2;
+    }
+  }
+
+  /* WCS 1.1+ GridOrigin is effectively resetting the minx/maxy
+     BOUNDINGBOX values, so apply that here */
+  if (params->originx != 0.0 || params->originy != 0.0) {
+    assert(strncasecmp(params->version, "1.0", 3) !=
+           0); /* should always be 1.0 in this logic. */
+    params->bbox.minx = params->originx;
+    params->bbox.maxy = params->originy;
+  }
+
+  /* if necessary, project the BBOX to the map->projection */
+  if (params->response_crs && params->crs) {
+    projectionObj tmp_proj;
+
+    msInitProjection(&tmp_proj);
+    msProjectionInheritContextFrom(&tmp_proj, &(map->projection));
+    if (msLoadProjectionString(&tmp_proj, (char *)params->crs) != 0) {
+      msWCSFreeCoverageMetadata(&cm);
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+    msProjectRect(&tmp_proj, &map->projection, &(params->bbox));
+    msFreeProjection(&tmp_proj);
+  }
+
+  /* in WCS 1.1 the default is full resolution */
+  if (strncasecmp(params->version, "1.1", 3) == 0 && params->resx == 0.0 &&
+      params->resy == 0.0) {
+    params->resx = cm.geotransform[1];
+    params->resy = fabs(cm.geotransform[5]);
+  }
+
+  /* compute width/height from BBOX and cellsize.  */
+  if ((params->resx == 0.0 || params->resy == 0.0) && params->width != 0 &&
+      params->height != 0) {
+    assert(strncasecmp(params->version, "1.0", 3) ==
+           0); /* should always be 1.0 in this logic. */
+    params->resx = (params->bbox.maxx - params->bbox.minx) / params->width;
+    params->resy = (params->bbox.maxy - params->bbox.miny) / params->height;
+  }
+
+  /* compute cellsize/res from bbox and raster size. */
+  if ((params->width == 0 || params->height == 0) && params->resx != 0 &&
+      params->resy != 0) {
+
+    /* WCS 1.0 boundbox is edge of pixel oriented. */
+    if (strncasecmp(params->version, "1.0", 3) == 0) {
+      params->width =
+          (int)((params->bbox.maxx - params->bbox.minx) / params->resx + 0.5);
+      params->height =
+          (int)((params->bbox.maxy - params->bbox.miny) / params->resy + 0.5);
+    } else {
+      params->width =
+          (int)((params->bbox.maxx - params->bbox.minx) / params->resx +
+                1.000001);
+      params->height =
+          (int)((params->bbox.maxy - params->bbox.miny) / params->resy +
+                1.000001);
+
+      /* recompute bounding box so we get exactly the origin and
+         resolution requested. */
+      params->bbox.maxx =
+          params->bbox.minx + (params->width - 1) * params->resx;
+      params->bbox.miny =
+          params->bbox.maxy - (params->height - 1) * params->resy;
+    }
+  }
+
+  /* are we still underspecified?  */
+  if ((params->width == 0 || params->height == 0) &&
+      (params->resx == 0.0 || params->resy == 0.0)) {
+    msWCSFreeCoverageMetadata(&cm);
+    msSetError(MS_WCSERR,
+               "A non-zero RESX/RESY or WIDTH/HEIGHT is required but neither "
+               "was provided.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue",
+                          "width/height/resx/resy", params->version);
+  }
+
+  map->cellsize = params->resx;
+
+  /* Do we need to force special handling?  */
+  if (fabs(params->resx / params->resy - 1.0) > 0.001) {
+    map->gt.need_geotransform = MS_TRUE;
+    if (map->debug)
+      msDebug("RESX and RESY don't match.  Using geotransform/resample.\n");
+  }
+
+  /* Do we have a specified interpolation method */
+  if (params->interpolation != NULL) {
+    if (strncasecmp(params->interpolation, "NEAREST", 7) == 0)
+      msLayerSetProcessingKey(lp, "RESAMPLE", "NEAREST");
+    else if (strcasecmp(params->interpolation, "BILINEAR") == 0)
+      msLayerSetProcessingKey(lp, "RESAMPLE", "BILINEAR");
+    else if (strcasecmp(params->interpolation, "AVERAGE") == 0)
+      msLayerSetProcessingKey(lp, "RESAMPLE", "AVERAGE");
+    else {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(
+          MS_WCSERR,
+          "INTERPOLATION=%s specifies an unsupported interpolation method.",
+          "msWCSGetCoverage()", params->interpolation);
+      return msWCSException(map, "InvalidParameterValue", "interpolation",
+                            params->version);
+    }
+  }
+
+  /* apply region and size to map object.  */
+  map->width = params->width;
+  map->height = params->height;
+
+  /* Are we exceeding the MAXSIZE limit on result size? */
+  if (map->width > map->maxsize || map->height > map->maxsize) {
+    msWCSFreeCoverageMetadata(&cm);
+    msSetError(MS_WCSERR,
+               "Raster size out of range, width and height of resulting "
+               "coverage must be no more than MAXSIZE=%d.",
+               "msWCSGetCoverage()", map->maxsize);
+
+    return msWCSException(map, "InvalidParameterValue", "width/height",
+                          params->version);
+  }
+
+  /* adjust OWS BBOX to MapServer's pixel model */
+  if (strncasecmp(params->version, "1.0", 3) == 0) {
+    params->bbox.minx += params->resx * 0.5;
+    params->bbox.miny += params->resy * 0.5;
+    params->bbox.maxx -= params->resx * 0.5;
+    params->bbox.maxy -= params->resy * 0.5;
+  }
+
+  map->extent = params->bbox;
+
+  map->cellsize = params->resx; /* pick one, MapServer only supports square
+                                   cells (what about msAdjustExtent here!) */
+
+  if (params->width == 1 || params->height == 1)
+    msMapComputeGeotransformEx(map, params->resx, params->resy);
+  else
+    msMapComputeGeotransform(map);
+
+  /* Do we need to fake out stuff for rotated support? */
+  if (map->gt.need_geotransform)
+    msMapSetFakedExtent(map);
+
+  map->projection.gt = map->gt;
+
+  /* check for overlap */
+
+  /* get extent of bbox passed, and reproject */
+  reqextent.minx = map->extent.minx;
+  reqextent.miny = map->extent.miny;
+  reqextent.maxx = map->extent.maxx;
+  reqextent.maxy = map->extent.maxy;
+
+  /* reproject incoming bbox */
+  msProjectRect(&map->projection, &lp->projection, &(reqextent));
+
+  /* get extent of layer */
+  covextent.minx = cm.extent.minx;
+  covextent.miny = cm.extent.miny;
+  covextent.maxx = cm.extent.maxx;
+  covextent.maxy = cm.extent.maxy;
+
+  if (msRectOverlap(&reqextent, &covextent) == MS_FALSE) {
+    msWCSFreeCoverageMetadata(&cm);
+    msSetError(MS_WCSERR,
+               "Requested BBOX (%.15g,%.15g,%.15g,%.15g) is outside requested "
+               "coverage BBOX (%.15g,%.15g,%.15g,%.15g)",
+               "msWCSGetCoverage()", reqextent.minx, reqextent.miny,
+               reqextent.maxx, reqextent.maxy, covextent.minx, covextent.miny,
+               covextent.maxx, covextent.maxy);
+    return msWCSException(map, "NoApplicableCode", "bbox", params->version);
+  }
+
+  /* check and make sure there is a format, and that it's valid (TODO: make sure
+   * in the layer metadata) */
+  if (!params->format) {
+    msWCSFreeCoverageMetadata(&cm);
+    msSetError(MS_WCSERR, "Missing required FORMAT parameter.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue", "format",
+                          params->version);
+  }
+  msApplyDefaultOutputFormats(map);
+  if (msGetOutputFormatIndex(map, params->format) == -1) {
+    msWCSFreeCoverageMetadata(&cm);
+    msSetError(MS_WCSERR, "Unrecognized value for the FORMAT parameter.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "InvalidParameterValue", "format",
+                          params->version);
+  }
+
+  /* create a temporary outputformat (we likely will need to tweak parts) */
+  format = msCloneOutputFormat(msSelectOutputFormat(map, params->format));
+  msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
+
+  if (!bandlist) { /* build a bandlist (default is ALL bands) */
+    bufferSize = cm.bandcount * 30 + 30;
+    bandlist = (char *)msSmallMalloc(bufferSize);
+    strcpy(bandlist, "1");
+    for (i = 1; i < cm.bandcount; i++)
+      snprintf(bandlist + strlen(bandlist), bufferSize - strlen(bandlist),
+               ",%d", i + 1);
+  }
+
+  /* apply nullvalue to the output format object if we have it */
+  if ((value = msOWSLookupMetadata(&(lp->metadata), "CO",
+                                   "rangeset_nullvalue")) != NULL) {
+    msSetOutputFormatOption(map->outputformat, "NULLVALUE", value);
+  }
+
+  msLayerSetProcessingKey(lp, "BANDS", bandlist);
+  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',') + 1);
+  msSetOutputFormatOption(map->outputformat, "BAND_COUNT", numbands);
+
+  msWCSApplyLayerCreationOptions(lp, map->outputformat, bandlist);
+  msWCSApplyLayerMetadataItemOptions(lp, map->outputformat, bandlist);
+
+  if (lp->tileindex == NULL && lp->data != NULL && strlen(lp->data) > 0 &&
+      lp->connectiontype != MS_KERNELDENSITY) {
+    if (msDrawRasterLayerLowCheckIfMustDraw(map, lp)) {
+      char *decrypted_path = NULL;
+      char szPath[MS_MAXPATHLEN];
+      hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
+          map, lp, lp->data, szPath, &decrypted_path);
+      msFree(decrypted_path);
+      if (hDS) {
+        msWCSApplyDatasetMetadataAsCreationOptions(lp, map->outputformat,
+                                                   bandlist, hDS);
+        msWCSApplySourceDatasetMetadata(lp, map->outputformat, bandlist, hDS);
+      }
+    } else {
+      doDrawRasterLayerDraw = MS_FALSE;
+    }
+  }
+
+  free(bandlist);
+
+  if (lp->mask) {
+    int maskLayerIdx = msGetLayerIndex(map, lp->mask);
+    layerObj *maskLayer;
+    outputFormatObj *altFormat;
+    if (maskLayerIdx == -1) {
+      msWCSFreeCoverageMetadata(&cm);
+      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)",
+                 "msDrawLayer()", lp->name, lp->mask);
+      msDrawRasterLayerLowCloseDataset(lp, hDS);
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+    maskLayer = GET_LAYER(map, maskLayerIdx);
+    if (!maskLayer->maskimage) {
+      int i, retcode;
+      int origstatus, origlabelcache;
+      char *origImageType = msStrdup(map->imagetype);
+      altFormat = msSelectOutputFormat(map, "png24");
+      msInitializeRendererVTable(altFormat);
+      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg
+       */
+      maskLayer->maskimage = msImageCreate(
+          map->width, map->height, altFormat, map->web.imagepath,
+          map->web.imageurl, map->resolution, map->defresolution, NULL);
+      if (!maskLayer->maskimage) {
+        msWCSFreeCoverageMetadata(&cm);
+        msSetError(MS_MISCERR, "Unable to initialize mask image.",
+                   "msDrawLayer()");
+        msFree(origImageType);
+        msDrawRasterLayerLowCloseDataset(lp, hDS);
+        return msWCSException(map, NULL, NULL, params->version);
+      }
+
+      /*
+       * force the masked layer to status on, and turn off the labelcache so
+       * that eventual labels are added to the temporary image instead of being
+       * added to the labelcache
+       */
+      origstatus = maskLayer->status;
+      origlabelcache = maskLayer->labelcache;
+      maskLayer->status = MS_ON;
+      maskLayer->labelcache = MS_OFF;
+
+      /* draw the mask layer in the temporary image */
+      retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
+      maskLayer->status = origstatus;
+      maskLayer->labelcache = origlabelcache;
+      if (retcode != MS_SUCCESS) {
+        msWCSFreeCoverageMetadata(&cm);
+        /* set the imagetype from the original outputformat back (it was removed
+         * by msSelectOutputFormat() */
+        msFree(map->imagetype);
+        map->imagetype = origImageType;
+        msDrawRasterLayerLowCloseDataset(lp, hDS);
+        return msWCSException(map, NULL, NULL, params->version);
+      }
+      /*
+       * hack to work around bug #3834: if we have use an alternate renderer,
+       * the symbolset may contain symbols that reference it. We want to remove
+       * those references before the altFormat is destroyed to avoid a segfault
+       * and/or a leak, and so the the main renderer doesn't pick the cache up
+       * thinking it's for him.
+       */
+      for (i = 0; i < map->symbolset.numsymbols; i++) {
+        if (map->symbolset.symbol[i] != NULL) {
+          symbolObj *s = map->symbolset.symbol[i];
+          if (s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
+            MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
+            s->renderer = NULL;
+          }
+        }
+      }
+      /* set the imagetype from the original outputformat back (it was removed
+       * by msSelectOutputFormat() */
+      msFree(map->imagetype);
+      map->imagetype = origImageType;
+    }
+  }
+
+  /* create the image object  */
+  if (!map->outputformat) {
+    msWCSFreeCoverageMetadata(&cm);
+    msSetError(MS_WCSERR, "The map outputformat is missing!",
+               "msWCSGetCoverage()");
+    msDrawRasterLayerLowCloseDataset(lp, hDS);
+    return msWCSException(map, NULL, NULL, params->version);
+  } else if (MS_RENDERER_RAWDATA(map->outputformat) ||
+             MS_RENDERER_PLUGIN(map->outputformat)) {
+    image = msImageCreate(map->width, map->height, map->outputformat,
+                          map->web.imagepath, map->web.imageurl,
+                          map->resolution, map->defresolution, NULL);
+  } else {
+    msWCSFreeCoverageMetadata(&cm);
+    msSetError(MS_WCSERR, "Map outputformat not supported for WCS!",
+               "msWCSGetCoverage()");
+    msDrawRasterLayerLowCloseDataset(lp, hDS);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+
+  if (image == NULL) {
+    msWCSFreeCoverageMetadata(&cm);
+    msDrawRasterLayerLowCloseDataset(lp, hDS);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+  if (MS_RENDERER_RAWDATA(map->outputformat)) {
+    if (doDrawRasterLayerDraw) {
+      status = msDrawRasterLayerLowWithDataset(map, lp, image, NULL, hDS);
+    } else {
+      status = MS_SUCCESS;
+    }
+  } else {
+    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image, &rb);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      msWCSFreeCoverageMetadata(&cm);
+      msDrawRasterLayerLowCloseDataset(lp, hDS);
+      return MS_FAILURE;
+    }
+
+    /* Actually produce the "grid". */
+    if (doDrawRasterLayerDraw) {
+      status = msDrawRasterLayerLowWithDataset(map, lp, image, &rb, hDS);
+    } else {
+      status = MS_SUCCESS;
+    }
+  }
+  msDrawRasterLayerLowCloseDataset(lp, hDS);
+
+  if (status != MS_SUCCESS) {
+    msWCSFreeCoverageMetadata(&cm);
+    msFreeImage(image);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+
+  if (strncmp(params->version, "1.1", 3) == 0) {
+    msWCSReturnCoverage11(params, map, image);
+  } else { /* WCS 1.0.0 - just return the binary data with a content type */
+    const char *fo_filename;
+
+    /* Do we have a predefined filename? */
+    fo_filename = msGetOutputFormatOption(format, "FILENAME", NULL);
+    if (fo_filename)
+      msIO_setHeader("Content-Disposition", "attachment; filename=%s",
+                     fo_filename);
+
+    /* Emit back to client. */
+    msOutputFormatResolveFromImage(map, image);
+    msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(map->outputformat));
+    msIO_sendHeaders();
+    status = msSaveImage(map, image, NULL);
+
+    if (status != MS_SUCCESS) {
+      /* unfortunately, the image content type will have already been sent
+         but that is hard for us to avoid.  The main error that could happen
+         here is a misconfigured tmp directory or running out of space. */
+      msWCSFreeCoverageMetadata(&cm);
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+  }
+
+  /* Cleanup */
+  msFreeImage(image);
+  msApplyOutputFormat(&(map->outputformat), NULL, MS_NOOVERRIDE);
+  /* msFreeOutputFormat(format); */
+
+  msWCSFreeCoverageMetadata(&cm);
+  return status;
+}
+#endif /* def USE_WCS_SVR */
+
+/************************************************************************/
+/*                           msWCSDispatch()                            */
+/*                                                                      */
+/*      Entry point for WCS requests                                    */
+/************************************************************************/
+
+int msWCSDispatch(mapObj *map, cgiRequestObj *request,
+                  owsRequestObj *ows_request) {
+#if defined(USE_WCS_SVR)
+  wcs20ParamsObj *params20 = NULL;
+  int status, retVal, operation;
+
+  /* If SERVICE is not set or not WCS exit gracefully. */
+  if (ows_request->service == NULL || !EQUAL(ows_request->service, "WCS")) {
+    return MS_DONE;
+  }
+
+  /* If no REQUEST is set, exit with an error */
+  if (ows_request->request == NULL) {
+    /* The request has to be set. */
+    msSetError(MS_WCSERR, "Missing REQUEST parameter", "msWCSDispatch()");
+    return msWCSException(map, "MissingParameterValue", "request",
+                          ows_request->version);
+  }
+
+  if (EQUAL(ows_request->request, "GetCapabilities")) {
+    operation = MS_WCS_GET_CAPABILITIES;
+  } else if (EQUAL(ows_request->request, "DescribeCoverage")) {
+    operation = MS_WCS_DESCRIBE_COVERAGE;
+  } else if (EQUAL(ows_request->request, "GetCoverage")) {
+    operation = MS_WCS_GET_COVERAGE;
+  } else {
+    msSetError(MS_WCSERR, "Invalid REQUEST parameter \"%s\"", "msWCSDispatch()",
+               ows_request->request);
+    return msWCSException(map, "InvalidParameterValue", "request",
+                          ows_request->version);
+  }
+
+  /* Check the number of enabled layers for the REQUEST */
+  msOWSRequestLayersEnabled(map, "C", ows_request->request, ows_request);
+  if (ows_request->numlayers == 0) {
+    int caps_globally_enabled = MS_FALSE, disabled = MS_FALSE;
+    const char *enable_request;
+    if (operation == MS_WCS_GET_CAPABILITIES) {
+      enable_request =
+          msOWSLookupMetadata(&map->web.metadata, "OC", "enable_request");
+      caps_globally_enabled = msOWSParseRequestMetadata(
+          enable_request, "GetCapabilities", &disabled);
+    }
+
+    if (caps_globally_enabled == MS_FALSE) {
+      msSetError(MS_WCSERR,
+                 "WCS request not enabled. Check "
+                 "wcs/ows_enable_request settings.",
+                 "msWCSDispatch()");
+      return msWCSException(map, "InvalidParameterValue", "request",
+                            ows_request->version);
+    }
+  }
+
+  /* Check the VERSION parameter */
+  if (ows_request->version == NULL) {
+    /* If the VERSION parameter is not set, it is either */
+    /* an error (Describe and GetCoverage), or it has to */
+    /* be determined (GetCapabilities). To determine the */
+    /* version, the request has to be fully parsed to    */
+    /* obtain the ACCEPTVERSIONS parameter. If this is   */
+    /* present also, set version to "2.0.1".             */
+
+    if (operation == MS_WCS_GET_CAPABILITIES) {
+      /* Parse it as if it was a WCS 2.0 request */
+      wcs20ParamsObjPtr params_tmp = msWCSCreateParamsObj20();
+      status = msWCSParseRequest20(map, request, ows_request, params_tmp);
+      if (status == MS_FAILURE) {
+        msWCSFreeParamsObj20(params_tmp);
+        return msWCSException(map, "InvalidParameterValue", "request", "2.0.1");
+      }
+
+      /* VERSION negotiation */
+      if (params_tmp->accept_versions != NULL) {
+        /* choose highest acceptable */
+        int i, highest_version = 0;
+        char version_string[OWS_VERSION_MAXLEN];
+        for (i = 0; params_tmp->accept_versions[i] != NULL; ++i) {
+          int version = msOWSParseVersionString(params_tmp->accept_versions[i]);
+          if (version == OWS_VERSION_BADFORMAT) {
+            msWCSFreeParamsObj20(params_tmp);
+            return msWCSException(map, "InvalidParameterValue", "version",
+                                  NULL);
+          }
+          if (version > highest_version) {
+            highest_version = version;
+          }
+        }
+        msOWSGetVersionString(highest_version, version_string);
+        params_tmp->version = msStrdup(version_string);
+        ows_request->version = msStrdup(version_string);
+      } else {
+        /* set to highest acceptable */
+        params_tmp->version = msStrdup("2.0.1");
+        ows_request->version = msStrdup("2.0.1");
+      }
+
+      /* check if we can keep the params object */
+      if (EQUAL(params_tmp->version, "2.0.1")) {
+        params20 = params_tmp;
+      } else {
+        msWCSFreeParamsObj20(params_tmp);
+      }
+    } else { /* operation != GetCapabilities */
+      /* VERSION is mandatory in other requests */
+      msSetError(MS_WCSERR, "VERSION parameter not set.", "msWCSDispatch()");
+      return msWCSException(map, "InvalidParameterValue", "version", NULL);
+    }
+  } else {
+    /* Parse the VERSION parameter */
+    int requested_version = msOWSParseVersionString(ows_request->version);
+    if (requested_version == OWS_VERSION_BADFORMAT) {
+      /* Return an error if the VERSION is */
+      /* in an unsupported format.         */
+      return msWCSException(map, "InvalidParameterValue", "version", NULL);
+    }
+
+    if (operation == MS_WCS_GET_CAPABILITIES) {
+      /* In case of GetCapabilities, make  */
+      char version_string[OWS_VERSION_MAXLEN];
+      int version, supported_versions[] = {OWS_2_0_1, OWS_2_0_0, OWS_1_1_2,
+                                           OWS_1_1_1, OWS_1_1_0, OWS_1_0_0};
+      version = msOWSNegotiateVersion(requested_version, supported_versions,
+                                      sizeof(supported_versions) / sizeof(int));
+      msOWSGetVersionString(version, version_string);
+      msFree(ows_request->version);
+      ows_request->version = msStrdup(version_string);
+    }
+  }
+
+  /* VERSION specific request handler */
+  if (strcmp(ows_request->version, "1.0.0") == 0 ||
+      strcmp(ows_request->version, "1.1.0") == 0 ||
+      strcmp(ows_request->version, "1.1.1") == 0 ||
+      strcmp(ows_request->version, "1.1.2") == 0) {
+    auto paramsTmp = msWCSCreateParams();
+    status = msWCSParseRequest(request, paramsTmp, map);
+    if (status == MS_FAILURE) {
+      msWCSFreeParams(paramsTmp);
+      free(paramsTmp);
+      return msWCSException(map, "InvalidParameterValue", "request", "2.0");
+    }
+
+    retVal = MS_FAILURE;
+    if (operation == MS_WCS_GET_CAPABILITIES) {
+      retVal = msWCSGetCapabilities(map, paramsTmp, request, ows_request);
+    } else if (operation == MS_WCS_DESCRIBE_COVERAGE) {
+      retVal = msWCSDescribeCoverage(map, paramsTmp, ows_request, request);
+    } else if (operation == MS_WCS_GET_COVERAGE) {
+      retVal = msWCSGetCoverage(map, request, paramsTmp, ows_request);
+    }
+    msWCSFreeParams(paramsTmp);
+    free(paramsTmp);
+    return retVal;
+  } else if (strcmp(ows_request->version, "2.0.0") == 0 ||
+             strcmp(ows_request->version, "2.0.1") == 0) {
+#if defined(USE_LIBXML2)
+    int i;
+
+    if (params20 == NULL) {
+      params20 = msWCSCreateParamsObj20();
+      status = msWCSParseRequest20(map, request, ows_request, params20);
+      if (status == MS_FAILURE) {
+        msWCSFreeParamsObj20(params20);
+        return msWCSException(map, "InvalidParameterValue", "request", "2.0.1");
+      } else if (status == MS_DONE) {
+        /* MS_DONE means, that the exception has already been written to the IO
+          buffer.
+        */
+        msWCSFreeParamsObj20(params20);
+        return MS_FAILURE;
+      }
+    }
+
+    /* check if all layer names are valid NCNames */
+    for (i = 0; i < map->numlayers; ++i) {
+      if (!msWCSIsLayerSupported(map->layers[i]))
+        continue;
+
+      /* Check if each layers name is a valid NCName. */
+      if (msEvalRegex("^[a-zA-z_][a-zA-Z0-9_.-]*$", map->layers[i]->name) ==
+          MS_FALSE) {
+        msSetError(MS_WCSERR, "Layer name '%s' is not a valid NCName.",
+                   "msWCSDispatch()", map->layers[i]->name);
+        msWCSFreeParamsObj20(params20);
+        return msWCSException(map, "mapserv", "Internal", "2.0.1");
+      }
+    }
+
+    /* Call operation specific functions */
+    if (operation == MS_WCS_GET_CAPABILITIES) {
+      retVal = msWCSGetCapabilities20(map, request, params20, ows_request);
+    } else if (operation == MS_WCS_DESCRIBE_COVERAGE) {
+      retVal = msWCSDescribeCoverage20(map, params20, ows_request);
+    } else if (operation == MS_WCS_GET_COVERAGE) {
+      retVal = msWCSGetCoverage20(map, request, params20, ows_request);
+    } else {
+      msSetError(MS_WCSERR, "Invalid request '%s'.", "msWCSDispatch20()",
+                 ows_request->request);
+      retVal =
+          msWCSException20(map, "InvalidParameterValue", "request", "2.0.1");
+    }
+    /* clean up */
+    msWCSFreeParamsObj20(params20);
+    return retVal;
+#else      /* def USE_LIBXML2 */
+    msSetError(MS_WCSERR,
+               "WCS 2.0 needs mapserver to be compiled with libxml2.",
+               "msWCSDispatch()");
+    return msWCSException(map, "mapserv", "NoApplicableCode", "2.0.1");
+#endif     /* def USE_LIBXML2 */
+  } else { /* unsupported version */
+    msSetError(MS_WCSERR, "WCS Server does not support VERSION %s.",
+               "msWCSDispatch()", ows_request->version);
+    return msWCSException(map, "InvalidParameterValue", "version",
+                          ows_request->version);
+  }
+
+#else
+  msSetError(MS_WCSERR, "WCS server support is not available.",
+             "msWCSDispatch()");
+  return MS_FAILURE;
+#endif
+}
+
+/************************************************************************/
+/*                      msWCSGetCoverageMetadata()                      */
+/************************************************************************/
+
+#ifdef USE_WCS_SVR
+
+void msWCSFreeCoverageMetadata(coverageMetadataObj *cm) {
+  msFree(cm->srs_epsg);
+}
+
+int msWCSGetCoverageMetadata(layerObj *layer, coverageMetadataObj *cm) {
+  char *srs_urn = NULL;
+  int i = 0;
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  /* -------------------------------------------------------------------- */
+  /*      Get the SRS in WCS 1.0 format (eg. EPSG:n)                      */
+  /* -------------------------------------------------------------------- */
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &(cm->srs_epsg));
+  if (!cm->srs_epsg) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &(cm->srs_epsg));
+    if (!cm->srs_epsg) {
+      msSetError(MS_WCSERR,
+                 "Unable to determine the SRS for this layer, no projection "
+                 "defined and no metadata available.",
+                 "msWCSGetCoverageMetadata()");
+      return MS_FAILURE;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Get the SRS in urn format.                                      */
+  /* -------------------------------------------------------------------- */
+  if ((srs_urn = msOWSGetProjURN(&(layer->projection), &(layer->metadata), "CO",
+                                 MS_TRUE)) == NULL) {
+    srs_urn = msOWSGetProjURN(&(layer->map->projection),
+                              &(layer->map->web.metadata), "CO", MS_TRUE);
+  }
+
+  if (srs_urn != NULL) {
+    if (strlen(srs_urn) > sizeof(cm->srs_urn) - 1) {
+      msSetError(MS_WCSERR, "SRS URN too long!", "msWCSGetCoverageMetadata()");
+      return MS_FAILURE;
+    }
+
+    strcpy(cm->srs_urn, srs_urn);
+    msFree(srs_urn);
+  } else
+    cm->srs_urn[0] = '\0';
+
+  /* -------------------------------------------------------------------- */
+  /*      If we have "virtual dataset" metadata on the layer, then use    */
+  /*      that in preference to inspecting the file(s).                   */
+  /*      We require extent and either size or resolution.                */
+  /* -------------------------------------------------------------------- */
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL &&
+      (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL ||
+       msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL)) {
+    const char *value;
+
+    /* get extent */
+    cm->extent.minx = 0.0;
+    cm->extent.maxx = 0.0;
+    cm->extent.miny = 0.0;
+    cm->extent.maxy = 0.0;
+    if (msOWSGetLayerExtent(layer->map, layer, "CO", &cm->extent) == MS_FAILURE)
+      return MS_FAILURE;
+
+    /* get resolution */
+    cm->xresolution = 0.0;
+    cm->yresolution = 0.0;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) !=
+        NULL) {
+      char **tokens;
+      int n;
+
+      tokens = msStringSplit(value, ' ', &n);
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_resolution metadata.",
+                   "msWCSGetCoverageMetadata()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+      cm->xresolution = atof(tokens[0]);
+      cm->yresolution = atof(tokens[1]);
+      msFreeCharArray(tokens, n);
+    }
+
+    /* get Size (in pixels and lines) */
+    cm->xsize = 0;
+    cm->ysize = 0;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "size")) !=
+        NULL) {
+      char **tokens;
+      int n;
+
+      tokens = msStringSplit(value, ' ', &n);
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_size metadata.",
+                   "msWCSGetCoverageDomain()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+      cm->xsize = atoi(tokens[0]);
+      cm->ysize = atoi(tokens[1]);
+      msFreeCharArray(tokens, n);
+    }
+
+    /* try to compute raster size */
+    if (cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 &&
+        cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx &&
+        cm->extent.miny != cm->extent.maxy) {
+      cm->xsize =
+          (int)((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
+      cm->ysize = (int)fabs(
+          (cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
+    }
+
+    /* try to compute raster resolution */
+    if ((cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 &&
+        cm->ysize != 0) {
+      cm->xresolution = (cm->extent.maxx - cm->extent.minx) / cm->xsize;
+      cm->yresolution = (cm->extent.maxy - cm->extent.miny) / cm->ysize;
+    }
+
+    /* do we have information to do anything */
+    if (cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 ||
+        cm->ysize == 0) {
+      msSetError(MS_WCSERR,
+                 "Failed to collect extent and resolution for WCS coverage "
+                 "from metadata for layer '%s'.  Need value wcs|ows_resolution "
+                 "or wcs|ows_size values.",
+                 "msWCSGetCoverageMetadata()", layer->name);
+      return MS_FAILURE;
+    }
+
+    /* compute geotransform */
+    cm->geotransform[0] = cm->extent.minx;
+    cm->geotransform[1] = cm->xresolution;
+    cm->geotransform[2] = 0.0;
+    cm->geotransform[3] = cm->extent.maxy;
+    cm->geotransform[4] = 0.0;
+    cm->geotransform[5] = -fabs(cm->yresolution);
+
+    /* get bands count, or assume 1 if not found */
+    cm->bandcount = 1;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) !=
+        NULL) {
+      cm->bandcount = atoi(value);
+    }
+
+    /* get bands type, or assume float if not found */
+    cm->imagemode = MS_IMAGEMODE_FLOAT32;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) !=
+        NULL) {
+      if (EQUAL(value, "INT16"))
+        cm->imagemode = MS_IMAGEMODE_INT16;
+      else if (EQUAL(value, "FLOAT32"))
+        cm->imagemode = MS_IMAGEMODE_FLOAT32;
+      else if (EQUAL(value, "BYTE"))
+        cm->imagemode = MS_IMAGEMODE_BYTE;
+      else {
+        msSetError(MS_WCSERR,
+                   "Content of wcs|ows_imagemode (%s) not recognised.  Should "
+                   "be one of BYTE, INT16 or FLOAT32.",
+                   "msWCSGetCoverageMetadata()", value);
+        return MS_FAILURE;
+      }
+    }
+    /* set color interpretation to undefined */
+    /* TODO: find better solution */
+    for (i = 0; i < 10; ++i) {
+      cm->bandinterpretation[i] = GDALGetColorInterpretationName(GCI_Undefined);
+    }
+  } else if (layer->data ==
+             NULL) { /* no virtual metadata, not ok unless we're talking 1
+                        image, hopefully we can fix that */
+    msSetError(
+        MS_WCSERR,
+        "RASTER Layer with no DATA statement and no WCS virtual dataset "
+        "metadata.  Tileindexed raster layers not supported for WCS without "
+        "virtual dataset metadata (cm->extent, wcs_res, wcs_size).",
+        "msWCSGetCoverageDomain()");
+    return MS_FAILURE;
+  } else { /* work from the file (e.g. DATA) */
+    GDALDatasetH hDS;
+    GDALRasterBandH hBand;
+    char szPath[MS_MAXPATHLEN];
+    char *decrypted_path;
+
+    msGDALInitialize();
+
+    msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                    layer->data);
+    decrypted_path = msDecryptStringTokens(layer->map, szPath);
+    if (!decrypted_path)
+      return MS_FAILURE;
+
+    msAcquireLock(TLOCK_GDAL);
+    {
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                       (const char *const *)connectionoptions, NULL);
+      CSLDestroy(connectionoptions);
+    }
+    if (hDS == NULL) {
+      const char *cpl_error_msg = CPLGetLastErrorMsg();
+
+      /* we wish to avoid reporting decrypted paths */
+      if (cpl_error_msg != NULL &&
+          strstr(cpl_error_msg, decrypted_path) != NULL &&
+          strcmp(decrypted_path, szPath) != 0)
+        cpl_error_msg = NULL;
+
+      if (cpl_error_msg == NULL)
+        cpl_error_msg = "";
+
+      msReleaseLock(TLOCK_GDAL);
+
+      msSetError(MS_IOERR, "%s", "msWCSGetCoverageMetadata()", cpl_error_msg);
+
+      msFree(decrypted_path);
+      return MS_FAILURE;
+    }
+    msFree(decrypted_path);
+
+    msGetGDALGeoTransform(hDS, layer->map, layer, cm->geotransform);
+
+    cm->xsize = GDALGetRasterXSize(hDS);
+    cm->ysize = GDALGetRasterYSize(hDS);
+
+    cm->extent.minx = cm->geotransform[0];
+    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize +
+                      cm->geotransform[2] * cm->ysize;
+    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize +
+                      cm->geotransform[5] * cm->ysize;
+    cm->extent.maxy = cm->geotransform[3];
+
+    cm->xresolution = cm->geotransform[1];
+    cm->yresolution = cm->geotransform[5];
+
+    /* TODO: need to set resolution */
+
+    cm->bandcount = GDALGetRasterCount(hDS);
+
+    if (cm->bandcount == 0) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_WCSERR,
+                 "Raster file %s has no raster bands.  This cannot be used in "
+                 "a layer.",
+                 "msWCSGetCoverageMetadata()", layer->data);
+      return MS_FAILURE;
+    }
+
+    hBand = GDALGetRasterBand(hDS, 1);
+    switch (GDALGetRasterDataType(hBand)) {
+    case GDT_Byte:
+      cm->imagemode = MS_IMAGEMODE_BYTE;
+      break;
+    case GDT_Int16:
+      cm->imagemode = MS_IMAGEMODE_INT16;
+      break;
+    default:
+      cm->imagemode = MS_IMAGEMODE_FLOAT32;
+      break;
+    }
+
+    /* color interpretation */
+    for (i = 1; i <= 10 && i <= cm->bandcount; ++i) {
+      GDALColorInterp colorInterp;
+      hBand = GDALGetRasterBand(hDS, i);
+      colorInterp = GDALGetRasterColorInterpretation(hBand);
+      cm->bandinterpretation[i - 1] =
+          GDALGetColorInterpretationName(colorInterp);
+    }
+
+    GDALClose(hDS);
+    msReleaseLock(TLOCK_GDAL);
+  }
+
+  /* we must have the bounding box in lat/lon [WGS84(DD)/EPSG:4326] */
+  cm->llextent = cm->extent;
+
+  /* Already in latlong .. use directly. */
+  if (layer->projection.proj != NULL &&
+      msProjIsGeographicCRS(&(layer->projection))) {
+    /* no change */
+  }
+
+  else if (layer->projection.numargs > 0 &&
+           !msProjIsGeographicCRS(
+               &(layer->projection))) /* check the layer projection */
+    msProjectRect(&(layer->projection), NULL, &(cm->llextent));
+
+  else if (layer->map->projection.numargs > 0 &&
+           !msProjIsGeographicCRS(
+               &(layer->map->projection))) /* check the map projection */
+    msProjectRect(&(layer->map->projection), NULL, &(cm->llextent));
+
+  else { /* projection was specified in the metadata only (EPSG:... only at the
+            moment)  */
+    projectionObj proj;
+    char projstring[32];
+
+    msInitProjection(&proj); /* or bad things happen */
+    msProjectionInheritContextFrom(&proj, &(layer->map->projection));
+
+    snprintf(projstring, sizeof(projstring), "init=epsg:%.20s",
+             cm->srs_epsg + 5);
+    if (msLoadProjectionString(&proj, projstring) != 0)
+      return MS_FAILURE;
+    msProjectRect(&proj, NULL, &(cm->llextent));
+  }
+
+  return MS_SUCCESS;
+}
+#endif /* def USE_WCS_SVR */
diff -pruN 8.0.1-5/src/mapwcs.h 8.2.0~beta1-1~exp1/src/mapwcs.h
--- 8.0.1-5/src/mapwcs.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwcs.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,330 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OpenGIS Web Coverage Server (WCS) Declarations.
+ * Author:   Steve Lime, Frank Warmerdam and the MapServer Team
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#ifndef MAPWCS_H
+#define MAPWCS_H
+
+#include "mapserver.h"
+#include "mapowscommon.h"
+#include <limits.h>
+#include <time.h>
+#include <float.h>
+
+#ifndef _WIN32
+#include <sys/time.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+ * Definitions
+ */
+
+#define MS_WCS_GML_COVERAGETYPE_RECTIFIED_GRID_COVERAGE "RectifiedGridCoverage"
+
+enum { MS_WCS_GET_CAPABILITIES, MS_WCS_DESCRIBE_COVERAGE, MS_WCS_GET_COVERAGE };
+
+/*
+** Structure to hold metadata taken from the image or image tile index
+*/
+typedef struct {
+  char *srs_epsg;
+  char srs_urn[500];
+  rectObj extent, llextent;
+  double geotransform[6];
+  int xsize, ysize;
+  double xresolution, yresolution;
+  int bandcount;
+  int imagemode;
+  const char *bandinterpretation[10];
+} coverageMetadataObj;
+
+typedef struct {
+  char *version;        /* 1.0.0 for now */
+  char *updatesequence; /* string, int or timestampe */
+  char *request;        /* GetCapabilities|DescribeCoverage|GetCoverage */
+  char *service;        /* MUST be WCS */
+  char *
+      section;        /* of capabilities document:
+                         /WCS_Capabilities/Service|/WCS_Capabilities/Capability|/WCS_Capabilities/ContentMetadata
+                       */
+  char **coverages;   /* NULL terminated list of coverages (in the case of a
+                         GetCoverage there will only be 1) */
+  char *crs;          /* request coordinate reference system */
+  char *response_crs; /* response coordinate reference system */
+  rectObj bbox;       /* subset bounding box (3D), although we'll only use 2D */
+  char *time;
+  long width, height, depth; /* image dimensions */
+  double originx, originy;   /* WCS 1.1 GridOrigin */
+  double resx, resy, resz;   /* resolution */
+  char *interpolation;       /* interpolationMethod */
+  char *format;
+  char *exceptions; /* exception MIME type, (default application=vnd.ogc.se_xml)
+                     */
+} wcsParamsObj;
+
+/* -------------------------------------------------------------------- */
+/*      Prototypes from mapwcs.c used in mapwcs11.c.                    */
+/*                                                                      */
+/*      Note, all prototypes are deliberately not exported from DLL     */
+/*      since they are for internal use within the core.                */
+/* -------------------------------------------------------------------- */
+void msWCSFreeParams(wcsParamsObj *params);
+int msWCSException(mapObj *map, const char *code, const char *locator,
+                   const char *version);
+int msWCSIsLayerSupported(layerObj *layer);
+int msWCSGetCoverageMetadata(layerObj *layer, coverageMetadataObj *cm);
+void msWCSFreeCoverageMetadata(coverageMetadataObj *cm);
+void msWCSSetDefaultBandsRangeSetInfo(wcsParamsObj *params,
+                                      coverageMetadataObj *cm, layerObj *lp);
+const char *msWCSGetRequestParameter(cgiRequestObj *request, const char *name);
+void msWCSApplyLayerCreationOptions(layerObj *lp, outputFormatObj *format,
+                                    const char *bandlist);
+void msWCSApplyDatasetMetadataAsCreationOptions(layerObj *lp,
+                                                outputFormatObj *format,
+                                                const char *bandlist,
+                                                void *hDSIn);
+void msWCSApplyLayerMetadataItemOptions(layerObj *lp, outputFormatObj *format,
+                                        const char *bandlist);
+void msWCSApplySourceDatasetMetadata(layerObj *lp, outputFormatObj *format,
+                                     const char *bandlist, void *hDSIn);
+/* -------------------------------------------------------------------- */
+/*      Some WCS 1.1 specific functions from mapwcs11.c                 */
+/* -------------------------------------------------------------------- */
+int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request);
+int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params,
+                            owsRequestObj *ows_request);
+int msWCSReturnCoverage11(wcsParamsObj *params, mapObj *map, imageObj *image);
+int msWCSGetCoverageBands11(mapObj *map, cgiRequestObj *request,
+                            wcsParamsObj *params, layerObj *lp,
+                            char **p_bandlist);
+int msWCSException11(mapObj *map, const char *locator,
+                     const char *exceptionCode, const char *version);
+
+/* -------------------------------------------------------------------- */
+/*      Some WCS 2.0 specific functions and structs from mapwcs20.c     */
+/* -------------------------------------------------------------------- */
+
+enum { MS_WCS20_TRIM = 0, MS_WCS20_SLICE = 1 };
+
+enum {
+  MS_WCS20_ERROR_VALUE = -1,
+  MS_WCS20_SCALAR_VALUE = 0,
+  MS_WCS20_TIME_VALUE = 1,
+  MS_WCS20_UNDEFINED_VALUE = 2
+};
+
+#define MS_WCS20_UNBOUNDED DBL_MAX
+#define MS_WCS20_UNBOUNDED_TIME 0xFFFFFFFF
+
+typedef struct {
+  union {
+    double scalar;
+    time_t time;
+  };
+  int unbounded; /* 0 if bounded, 1 if unbounded */
+} timeScalarUnion;
+
+typedef struct {
+  char *axis;          /* the name of the subsetted axis */
+  int operation;       /* Either TRIM or SLICE */
+  char *crs;           /* optional CRS to use */
+  int timeOrScalar;    /* 0 if scalar value, 1 if time value */
+  timeScalarUnion min; /* Minimum and Maximum of the subsetted axis;*/
+  timeScalarUnion max;
+} wcs20SubsetObj;
+typedef wcs20SubsetObj *wcs20SubsetObjPtr;
+
+typedef struct {
+  char *name;          /* name of the axis */
+  int size;            /* pixelsize of the axis */
+  double resolution;   /* resolution of the axis */
+  double scale;        /* scale of the axis */
+  char *resolutionUOM; /* resolution units of measure */
+  wcs20SubsetObjPtr subset;
+} wcs20AxisObj;
+typedef wcs20AxisObj *wcs20AxisObjPtr;
+
+typedef struct {
+  char *version;           /* 2.0.0 v 2.0.1 */
+  char *request;           /* GetCapabilities|DescribeCoverage|GetCoverage */
+  char *service;           /* MUST be WCS */
+  char **accept_versions;  /* NULL terminated list of Accepted versions */
+  char **accept_languages; /* NULL terminated list of Accepted versions */
+  char **sections;      /* NULL terminated list of GetCapabilities sections */
+  char *updatesequence; /* GetCapabilities updatesequence */
+  char **ids; /* NULL terminated list of coverages (in the case of a GetCoverage
+                 there will only be 1) */
+  long width, height;    /* image dimensions */
+  double resolutionX;    /* image resolution in X axis */
+  double resolutionY;    /* image resolution in Y axis */
+  double scale;          /* Overall scale */
+  double scaleX;         /* X-Axis specific scale */
+  double scaleY;         /* Y-Axis specific scale */
+  char *resolutionUnits; /* Units of Measure for resolution */
+  char *format;          /* requested output format */
+  int multipart;         /* flag for multipart GML+image */
+  char *interpolation;   /* requested interpolation method */
+  char *outputcrs;       /* requested CRS for output */
+  char *subsetcrs;       /* determined CRS of the subsets */
+  rectObj bbox;          /* determined Bounding Box */
+  int numaxes;           /* number of axes */
+  wcs20AxisObjPtr *axes; /* list of axes, NULL if none*/
+  char **range_subset;   /* list of bands selected */
+  char **format_options; /* list of format specific options, NULL terminated */
+} wcs20ParamsObj;
+typedef wcs20ParamsObj *wcs20ParamsObjPtr;
+
+typedef struct {
+  union {
+    struct {
+      char *name;
+      char *interpretation;
+      char *uom;
+      char *definition;
+      char *description;
+    };
+    char *values[5];
+  };
+  double interval_min;
+  double interval_max;
+  int significant_figures;
+} wcs20rasterbandMetadataObj;
+typedef wcs20rasterbandMetadataObj *wcs20rasterbandMetadataObjPtr;
+
+typedef struct {
+  char *native_format; /* mime type of the native format */
+  char *srs_epsg;
+  char srs_uri[200];
+  rectObj extent;
+  double geotransform[6];
+  double xresolution;
+  double yresolution;
+  int xsize;
+  int ysize;
+  int imagemode;
+  size_t numnilvalues;
+  char **nilvalues;
+  char **nilvalues_reasons;
+  size_t numbands;
+  wcs20rasterbandMetadataObjPtr bands;
+} wcs20coverageMetadataObj;
+typedef wcs20coverageMetadataObj *wcs20coverageMetadataObjPtr;
+
+#define MS_WCS_20_PROFILE_CORE "http://www.opengis.net/spec/WCS/2.0/conf/core"
+#define MS_WCS_20_PROFILE_KVP                                                  \
+  "http://www.opengis.net/spec/WCS_protocol-binding_get-kvp/1.0/conf/get-kvp"
+#define MS_WCS_20_PROFILE_POST                                                 \
+  "http://www.opengis.net/spec/WCS_protocol-binding_post-xml/1.0/conf/"        \
+  "post-xml"
+#define MS_WCS_20_PROFILE_GML                                                  \
+  "http://www.opengis.net/spec/GMLCOV/1.0/conf/gml-coverage"
+#define MS_WCS_20_PROFILE_GML_MULTIPART                                        \
+  "http://www.opengis.net/spec/GMLCOV/1.0/conf/multipart"
+#define MS_WCS_20_PROFILE_GML_SPECIAL                                          \
+  "http://www.opengis.net/spec/GMLCOV/1.0/conf/special-format"
+#define MS_WCS_20_PROFILE_GML_GEOTIFF                                          \
+  "http://www.opengis.net/spec/GMLCOV_geotiff-coverages/1.0/conf/"             \
+  "geotiff-coverage"
+#define MS_WCS_20_PROFILE_CRS                                                  \
+  "http://www.opengis.net/spec/WCS_service-extension_crs/1.0/conf/crs"
+#define MS_WCS_20_PROFILE_SCALING                                              \
+  "http://www.opengis.net/spec/WCS_service-extension_scaling/1.0/conf/scaling"
+#define MS_WCS_20_PROFILE_RANGESUBSET                                          \
+  "http://www.opengis.net/spec/WCS_service-extension_range-subsetting/1.0/"    \
+  "conf/record-subsetting"
+#define MS_WCS_20_PROFILE_INTERPOLATION                                        \
+  "http://www.opengis.net/spec/WCS_service-extension_interpolation/1.0/conf/"  \
+  "interpolation"
+
+/* -------------------------------------------------------------------- */
+/*      WCS 2.0 function prototypes.                                    */
+/* -------------------------------------------------------------------- */
+
+wcs20ParamsObjPtr msWCSCreateParamsObj20();
+void msWCSFreeParamsObj20(wcs20ParamsObjPtr params);
+int msWCSParseRequest20(mapObj *map, cgiRequestObj *request,
+                        owsRequestObj *ows_request, wcs20ParamsObjPtr params);
+
+int msWCSException20(mapObj *map, const char *locator,
+                     const char *exceptionCode, const char *version);
+
+int msWCSGetCapabilities20(mapObj *map, cgiRequestObj *req,
+                           wcs20ParamsObjPtr params,
+                           owsRequestObj *ows_request);
+int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params,
+                            owsRequestObj *ows_request);
+int msWCSGetCoverage20(mapObj *map, cgiRequestObj *request,
+                       wcs20ParamsObjPtr params, owsRequestObj *ows_request);
+
+/* -------------------------------------------------------------------- */
+/*      XML parsing helper macros.                                      */
+/* -------------------------------------------------------------------- */
+
+#define XML_FOREACH_CHILD(parent_node, child_node)                             \
+  for (child_node = parent_node->children; child_node != NULL;                 \
+       child_node = child_node->next)
+
+/* Makro to continue the iteration over an xml structure    */
+/* when the current node has the type 'text' or 'comment'   */
+#define XML_LOOP_IGNORE_COMMENT_OR_TEXT(node)                                  \
+  if (xmlNodeIsText(node) || node->type == XML_COMMENT_NODE) {                 \
+    continue;                                                                  \
+  }
+
+/* Makro to set an XML error that an unknown node type      */
+/* occurred.                                                */
+#define XML_UNKNOWN_NODE_ERROR(node)                                           \
+  msSetError(MS_WCSERR, "Unknown XML element '%s'.", __FUNCTION__,             \
+             (char *)node->name);                                              \
+  return MS_FAILURE;
+
+#define XML_ASSERT_NODE_NAME(node, nodename)                                   \
+  if (EQUAL((char *)node->name, nodename) == MS_FALSE) {                       \
+    XML_UNKNOWN_NODE_ERROR(node);                                              \
+  }
+
+#define MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, section)                \
+  (params->sections == NULL || CSLFindString(params->sections, "All") != -1 || \
+   CSLFindString(params->sections, section) != -1)
+
+#if defined(USE_LIBXML2)
+#include "maplibxml2.h"
+void msWCS_11_20_PrintMetadataLinks(layerObj *layer, xmlDocPtr doc,
+                                    xmlNodePtr psCSummary);
+#endif
+
+#ifdef __cplusplus
+} /* extern C */
+#endif
+
+#endif /* nef MAPWCS_H */
diff -pruN 8.0.1-5/src/mapwcs11.cpp 8.2.0~beta1-1~exp1/src/mapwcs11.cpp
--- 8.0.1-5/src/mapwcs11.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwcs11.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1457 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OpenGIS Web Coverage Server (WCS) 1.1.0 Implementation.  This
+ *           file holds some WCS 1.1.0 specific functions but other parts
+ *           are still implemented in mapwcs.c.
+ * Author:   Frank Warmerdam and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 2007, Frank Warmerdam
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <assert.h>
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapthread.h"
+#include "mapows.h"
+#include "mapwcs.h"
+#include "mapgdal.h"
+
+#if defined(USE_WCS_SVR)
+#include "mapwcs.h"
+#include "gdal.h"
+#include "cpl_string.h" /* GDAL string handling */
+#endif
+
+#if defined(USE_LIBXML2)
+#include "maplibxml2.h"
+#endif
+
+#include <string>
+
+#if defined(USE_WCS_SVR) && defined(USE_LIBXML2)
+/*
+** msWCSException11()
+**
+** Report current MapServer error in XML exception format.
+** Wrapper function around msOWSCommonExceptionReport. Merely
+** passes WCS specific info.
+**
+*/
+
+int msWCSException11(mapObj *map, const char *exceptionCode,
+                     const char *locator, const char *version) {
+  int size = 0;
+  char *errorString = NULL;
+  char *schemasLocation = NULL;
+
+  xmlDocPtr psDoc = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
+
+  psNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+
+  errorString = msGetErrorString("\n");
+  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_1_0, schemasLocation, version,
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+           BAD_CAST "ows");
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
+
+  msIO_printf("%s", buffer);
+
+  /*free buffer and the document */
+  free(errorString);
+  free(schemasLocation);
+  xmlFree(buffer);
+  xmlFreeDoc(psDoc);
+  xmlFreeNs(psNsOws);
+
+  /* clear error since we have already reported it */
+  msResetErrorList();
+
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                       msWCSGetFormatsList11()                        */
+/*                                                                      */
+/*      Fetch back a comma delimited formats list for the past layer    */
+/*      if one is supplied, otherwise for all formats supported by      */
+/*      the server.  Formats should be identified by mime type.         */
+/************************************************************************/
+
+static char *msWCSGetFormatsList11(mapObj *map, layerObj *layer)
+
+{
+  char *format_list = msStrdup("");
+  char **tokens = NULL, **formats = NULL;
+  int i, numtokens = 0, numformats;
+  char *value;
+
+  msApplyDefaultOutputFormats(map);
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse from layer metadata.                                      */
+  /* -------------------------------------------------------------------- */
+  if (layer != NULL &&
+      (value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "formats",
+                                      "GTiff")) != NULL) {
+    tokens = msStringSplit(value, ' ', &numtokens);
+    msFree(value);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse from map.web metadata.                                    */
+  /* -------------------------------------------------------------------- */
+  else if ((value = msOWSGetEncodeMetadata(&(map->web.metadata), "CO",
+                                           "formats", NULL)) != NULL) {
+    tokens = msStringSplit(value, ' ', &numtokens);
+    msFree(value);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Or generate from all configured raster output formats that      */
+  /*      look plausible.                                                 */
+  /* -------------------------------------------------------------------- */
+  else {
+    tokens = (char **)calloc(map->numoutputformats, sizeof(char *));
+    for (i = 0; i < map->numoutputformats; i++) {
+      switch (map->outputformatlist[i]->renderer) {
+        /* seeminly normal raster format */
+      case MS_RENDER_WITH_AGG:
+      case MS_RENDER_WITH_RAWDATA:
+        tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
+        break;
+
+        /* rest of formats aren't really WCS compatible */
+      default:
+        break;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Convert outputFormatObj names into mime types and remove        */
+  /*      duplicates.                                                     */
+  /* -------------------------------------------------------------------- */
+  numformats = 0;
+  formats = (char **)calloc(sizeof(char *), numtokens);
+
+  for (i = 0; i < numtokens; i++) {
+    int format_i, j;
+    const char *mimetype;
+
+    for (format_i = 0; format_i < map->numoutputformats; format_i++) {
+      if (strcasecmp(map->outputformatlist[format_i]->name, tokens[i]) == 0)
+        break;
+    }
+
+    if (format_i == map->numoutputformats) {
+      msDebug("Failed to find outputformat info on format '%s', ignore.\n",
+              tokens[i]);
+      continue;
+    }
+
+    mimetype = map->outputformatlist[format_i]->mimetype;
+    if (mimetype == NULL || strlen(mimetype) == 0) {
+      msDebug("No mimetime for format '%s', ignoring.\n", tokens[i]);
+      continue;
+    }
+
+    for (j = 0; j < numformats; j++) {
+      if (strcasecmp(mimetype, formats[j]) == 0)
+        break;
+    }
+
+    if (j < numformats) {
+      msDebug("Format '%s' ignored since mimetype '%s' duplicates another "
+              "outputFormatObj.\n",
+              tokens[i], mimetype);
+      continue;
+    }
+
+    formats[numformats++] = msStrdup(mimetype);
+  }
+
+  msFreeCharArray(tokens, numtokens);
+
+  /* -------------------------------------------------------------------- */
+  /*      Turn mimetype list into comma delimited form for easy use       */
+  /*      with xml functions.                                             */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < numformats; i++) {
+    if (i > 0) {
+      format_list = msStringConcatenate(format_list, (char *)",");
+    }
+    format_list = msStringConcatenate(format_list, formats[i]);
+  }
+  msFreeCharArray(formats, numformats);
+
+  return format_list;
+}
+
+/************************************************************************/
+/*                   msWCS_11_20_PrintMetadataLink()                    */
+/************************************************************************/
+
+static void msWCS_11_20_PrintMetadataLink(layerObj *layer,
+                                          const std::string &radix,
+                                          xmlDocPtr doc,
+                                          xmlNodePtr psCSummary) {
+  const char *value =
+      msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_href").c_str());
+  if (value) {
+    xmlNsPtr psOwsNs =
+        xmlSearchNs(doc, xmlDocGetRootElement(doc), BAD_CAST "ows");
+    xmlNodePtr psMetadata =
+        xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Metadata", NULL);
+    xmlNsPtr psXlinkNs =
+        xmlSearchNs(doc, xmlDocGetRootElement(doc), BAD_CAST "xlink");
+    const char *metadatalink_type = msOWSLookupMetadata(
+        &(layer->metadata), "CO", (radix + "_type").c_str());
+    const char *metadatalink_format = msOWSLookupMetadata(
+        &(layer->metadata), "CO", (radix + "_format").c_str());
+
+    xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "type", BAD_CAST "simple");
+    xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "href", BAD_CAST value);
+    if (metadatalink_type != NULL) {
+      xmlNewProp(psMetadata, BAD_CAST "about", BAD_CAST metadatalink_type);
+    }
+    if (metadatalink_format != NULL) {
+      xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "role",
+                   BAD_CAST metadatalink_format);
+    }
+  }
+}
+
+/************************************************************************/
+/*                   msWCS_11_20_PrintMetadataLinks()                   */
+/************************************************************************/
+
+void msWCS_11_20_PrintMetadataLinks(layerObj *layer, xmlDocPtr doc,
+                                    xmlNodePtr psCSummary) {
+  const char *list =
+      msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
+  if (list) {
+    int ntokens = 0;
+    char **tokens = msStringSplit(list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
+      std::string key("metadatalink_");
+      key += tokens[i];
+      msWCS_11_20_PrintMetadataLink(layer, key, doc, psCSummary);
+    }
+    msFreeCharArray(tokens, ntokens);
+    return;
+  }
+
+  msWCS_11_20_PrintMetadataLink(layer, "metadatalink", doc, psCSummary);
+}
+
+/************************************************************************/
+/*                msWCSGetCapabilities11_CoverageSummary()              */
+/*                                                                      */
+/*      Generate a WCS 1.1 CoverageSummary.                             */
+/************************************************************************/
+
+static int msWCSGetCapabilities11_CoverageSummary(mapObj *map, xmlDocPtr doc,
+                                                  xmlNodePtr psContents,
+                                                  layerObj *layer)
+
+{
+  coverageMetadataObj cm;
+  int status;
+  const char *value;
+  char *owned_value;
+  char *format_list;
+  xmlNodePtr psCSummary;
+  xmlNsPtr psOwsNs = xmlSearchNs(doc, psContents, BAD_CAST "ows");
+  int i = 0;
+
+  status = msWCSGetCoverageMetadata(layer, &cm);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  psCSummary = xmlNewChild(psContents, NULL, BAD_CAST "CoverageSummary", NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*      Title (from description)                                        */
+  /* -------------------------------------------------------------------- */
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "description");
+  if (value == NULL)
+    value = msOWSLookupMetadata(&(layer->metadata), "CO", "title");
+  if (value == NULL)
+    value = layer->name;
+  xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Title", BAD_CAST value);
+
+  /* -------------------------------------------------------------------- */
+  /*      Abstract                                                        */
+  /* -------------------------------------------------------------------- */
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "abstract");
+  xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Abstract", BAD_CAST value);
+
+  /* -------------------------------------------------------------------- */
+  /*      Keywords                                                        */
+  /* -------------------------------------------------------------------- */
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "keywordlist");
+
+  if (value) {
+    xmlNodePtr psNode;
+
+    psNode = xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Keywords", NULL);
+
+    int n = 0;
+    char **tokens = msStringSplit(value, ',', &n);
+    if (tokens && n > 0) {
+      for (i = 0; i < n; i++) {
+        xmlNewChild(psNode, NULL, BAD_CAST "Keyword", BAD_CAST tokens[i]);
+      }
+    }
+    msFreeCharArray(tokens, n);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Metadata Link                                                   */
+  /* -------------------------------------------------------------------- */
+  msWCS_11_20_PrintMetadataLinks(layer, doc, psCSummary);
+
+  /* -------------------------------------------------------------------- */
+  /*      WGS84 bounding box.                                             */
+  /* -------------------------------------------------------------------- */
+  xmlAddChild(psCSummary, msOWSCommonWGS84BoundingBox(
+                              psOwsNs, 2, cm.llextent.minx, cm.llextent.miny,
+                              cm.llextent.maxx, cm.llextent.maxy));
+
+  /* -------------------------------------------------------------------- */
+  /*      Supported CRSes.                                                */
+  /* -------------------------------------------------------------------- */
+  if ((owned_value = msOWSGetProjURN(&(layer->projection), &(layer->metadata),
+                                     "CO", MS_FALSE)) != NULL) {
+    /* ok */
+  } else if ((owned_value = msOWSGetProjURN(&(layer->map->projection),
+                                            &(layer->map->web.metadata), "CO",
+                                            MS_FALSE)) != NULL) {
+    /* ok */
+  } else
+    msDebug("mapwcs.c: missing required information, no SRSs defined.\n");
+
+  if (owned_value != NULL && strlen(owned_value) > 0)
+    msLibXml2GenerateList(psCSummary, NULL, "SupportedCRS", owned_value, ' ');
+
+  msFree(owned_value);
+
+  /* -------------------------------------------------------------------- */
+  /*      SupportedFormats                                                */
+  /* -------------------------------------------------------------------- */
+  format_list = msWCSGetFormatsList11(map, layer);
+
+  if (strlen(format_list) > 0)
+    msLibXml2GenerateList(psCSummary, NULL, "SupportedFormat", format_list,
+                          ',');
+
+  msFree(format_list);
+  msWCSFreeCoverageMetadata(&cm);
+
+  /* -------------------------------------------------------------------- */
+  /*      Identifier (layer name)                                         */
+  /* -------------------------------------------------------------------- */
+  xmlNewChild(psCSummary, NULL, BAD_CAST "Identifier", BAD_CAST layer->name);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                       msWCSGetCapabilities11()                       */
+/************************************************************************/
+int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode, psMainNode, psNode;
+  char *identifier_list = NULL, *format_list = NULL;
+  const char *updatesequence = NULL;
+  xmlNsPtr psOwsNs, psXLinkNs;
+  char *schemaLocation = NULL;
+  char *xsi_schemaLocation = NULL;
+  char *script_url = NULL, *script_url_encoded = NULL;
+
+  xmlChar *buffer = NULL;
+  int size = 0, i;
+  msIOContext *context = NULL;
+
+  int ows_version = OWS_1_1_0;
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle updatesequence                                           */
+  /* -------------------------------------------------------------------- */
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+
+  if (params->updatesequence != NULL) {
+    i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
+    if (i == 0) { /* current */
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
+      return msWCSException11(map, "CurrentUpdateSequence", "updatesequence",
+                              params->version);
+    }
+    if (i > 0) { /* invalid */
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
+      return msWCSException11(map, "InvalidUpdateSequence", "updatesequence",
+                              params->version);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Build list of layer identifiers available.                      */
+  /* -------------------------------------------------------------------- */
+  identifier_list = msStrdup("");
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *layer = map->layers[i];
+    int new_length;
+
+    if (!msWCSIsLayerSupported(layer))
+      continue;
+
+    new_length = strlen(identifier_list) + strlen(layer->name) + 2;
+    identifier_list = (char *)realloc(identifier_list, new_length);
+
+    if (strlen(identifier_list) > 0)
+      strcat(identifier_list, ",");
+    strcat(identifier_list, layer->name);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create document.                                                */
+  /* -------------------------------------------------------------------- */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "Capabilities");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* -------------------------------------------------------------------- */
+  /*      Name spaces                                                     */
+  /* -------------------------------------------------------------------- */
+  xmlSetNs(
+      psRootNode,
+      xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
+  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psXLinkNs =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+
+  /*xmlNewProp(psRootNode, BAD_CAST " */
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version);
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+
+  if (updatesequence)
+    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
+
+  schemaLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStrdup("http://www.opengis.net/wcs/1.1");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           "/wcs/1.1/wcsGetCapabilities.xsd ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+  msFree(schemaLocation);
+  msFree(xsi_schemaLocation);
+
+  /* -------------------------------------------------------------------- */
+  /*      Service metadata.                                               */
+  /* -------------------------------------------------------------------- */
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "ServiceIdentification") != NULL) {
+    xmlAddChild(psRootNode,
+                msOWSCommonServiceIdentification(
+                    psOwsNs, map, "OGC WCS", "2.0.1,1.1.1,1.0.0", "CO", NULL));
+  }
+
+  /*service provider*/
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "ServiceProvider") != NULL) {
+    xmlAddChild(psRootNode, msOWSCommonServiceProvider(psOwsNs, psXLinkNs, map,
+                                                       "CO", NULL));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Operations metadata.                                            */
+  /* -------------------------------------------------------------------- */
+  /*operation metadata */
+  if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource", req)) ==
+          NULL ||
+      (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+    msSetError(MS_WCSERR, "Server URL not found", "msWCSGetCapabilities11()");
+    return msWCSException11(map, "NoApplicableCode", "mapserv",
+                            params->version);
+  }
+  free(script_url);
+
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "OperationsMetadata") != NULL) {
+    psMainNode =
+        xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psOwsNs));
+
+    /* -------------------------------------------------------------------- */
+    /*      GetCapabilities - add Sections and AcceptVersions?              */
+    /* -------------------------------------------------------------------- */
+    psNode = msOWSCommonOperationsMetadataOperation(
+        psOwsNs, psXLinkNs, "GetCapabilities", OWS_METHOD_GETPOST,
+        script_url_encoded);
+
+    xmlAddChild(psMainNode, psNode);
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psOwsNs, "Parameter", "service", "WCS"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psOwsNs, "Parameter", "version",
+                            (char *)params->version));
+
+    /* -------------------------------------------------------------------- */
+    /*      DescribeCoverage                                                */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE)) {
+      psNode = msOWSCommonOperationsMetadataOperation(
+          psOwsNs, psXLinkNs, "DescribeCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
+
+      xmlAddChild(psMainNode, psNode);
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "service", "WCS"));
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psOwsNs, "Parameter", "version",
+                              (char *)params->version));
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psOwsNs, "Parameter", "identifiers",
+                              identifier_list));
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      GetCoverage                                                     */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE)) {
+
+      psNode = msOWSCommonOperationsMetadataOperation(
+          psOwsNs, psXLinkNs, "GetCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
+
+      format_list = msWCSGetFormatsList11(map, NULL);
+
+      xmlAddChild(psMainNode, psNode);
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "service", "WCS"));
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psOwsNs, "Parameter", "version",
+                              (char *)params->version));
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psOwsNs, "Parameter", "Identifier",
+                              identifier_list));
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "InterpolationType",
+                      "NEAREST_NEIGHBOUR,BILINEAR"));
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psOwsNs, "Parameter", "format",
+                              format_list));
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "store", "false"));
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psOwsNs, "Parameter", "GridBaseCRS",
+                              "urn:ogc:def:crs:epsg::4326"));
+
+      msFree(format_list);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Contents section.                                               */
+  /* -------------------------------------------------------------------- */
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "Contents") != NULL) {
+    psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Contents", NULL);
+
+    if (ows_request->numlayers == 0) {
+      xmlAddChild(psMainNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: No WCS layers are enabled. "
+                                "Check wcs/ows_enable_request settings."));
+    } else {
+      for (i = 0; i < map->numlayers; i++) {
+        layerObj *layer = map->layers[i];
+        int status;
+
+        if (!msWCSIsLayerSupported(layer))
+          continue;
+
+        if (!msIntegerInArray(layer->index, ows_request->enabled_layers,
+                              ows_request->numlayers))
+          continue;
+
+        status = msWCSGetCapabilities11_CoverageSummary(map, psDoc, psMainNode,
+                                                        layer);
+        if (status != MS_SUCCESS) {
+          msFree(identifier_list);
+          return MS_FAILURE;
+        }
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document.                                         */
+  /* -------------------------------------------------------------------- */
+
+  if (msIO_needBinaryStdout() == MS_FAILURE)
+    return MS_FAILURE;
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  context = msIO_getHandler(stdout);
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
+  msIO_contextWrite(context, buffer, size);
+  xmlFree(buffer);
+
+  /*free buffer and the document */
+  /*xmlFree(buffer);*/
+  xmlFreeDoc(psDoc);
+
+  xmlCleanupParser();
+
+  /* clean up */
+  free(script_url_encoded);
+  free(identifier_list);
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*            msWCSDescribeCoverage_CoverageDescription11()             */
+/************************************************************************/
+
+static int msWCSDescribeCoverage_CoverageDescription11(layerObj *layer,
+                                                       wcsParamsObj *params,
+                                                       xmlNodePtr psRootNode,
+                                                       xmlNsPtr psOwsNs)
+
+{
+  int status;
+  coverageMetadataObj cm;
+  xmlNodePtr psCD, psDomain, psSD, psGridCRS;
+  const char *value;
+
+  /* -------------------------------------------------------------------- */
+  /*      Verify layer is processable.                                    */
+  /* -------------------------------------------------------------------- */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  if (!msWCSIsLayerSupported(layer))
+    return MS_SUCCESS;
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup coverage metadata.                                        */
+  /* -------------------------------------------------------------------- */
+  status = msWCSGetCoverageMetadata(layer, &cm);
+  if (status != MS_SUCCESS)
+    return status;
+
+  /* fill in bands rangeset info, if required.  */
+  msWCSSetDefaultBandsRangeSetInfo(params, &cm, layer);
+
+  /* -------------------------------------------------------------------- */
+  /*      Create CoverageDescription node.                                */
+  /* -------------------------------------------------------------------- */
+  psCD = xmlNewChild(psRootNode, NULL, BAD_CAST "CoverageDescription", NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*      Title (from description)                                        */
+  /* -------------------------------------------------------------------- */
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "description");
+  if (value == NULL)
+    value = layer->name;
+  xmlNewChild(psCD, psOwsNs, BAD_CAST "Title", BAD_CAST value);
+
+  /* -------------------------------------------------------------------- */
+  /*      Abstract                                                        */
+  /* -------------------------------------------------------------------- */
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "abstract");
+  xmlNewChild(psCD, psOwsNs, BAD_CAST "Abstract", BAD_CAST value);
+
+  /* -------------------------------------------------------------------- */
+  /*      Keywords                                                        */
+  /* -------------------------------------------------------------------- */
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "keywordlist");
+
+  if (value)
+    msLibXml2GenerateList(xmlNewChild(psCD, psOwsNs, BAD_CAST "Keywords", NULL),
+                          NULL, "Keyword", value, ',');
+
+  /* -------------------------------------------------------------------- */
+  /*      Identifier (layer name)                                         */
+  /* -------------------------------------------------------------------- */
+  xmlNewChild(psCD, NULL, BAD_CAST "Identifier", BAD_CAST layer->name);
+
+  /* -------------------------------------------------------------------- */
+  /*      Domain                                                          */
+  /* -------------------------------------------------------------------- */
+  psDomain = xmlNewChild(psCD, NULL, BAD_CAST "Domain", NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*      SpatialDomain                                                   */
+  /* -------------------------------------------------------------------- */
+  psSD = xmlNewChild(psDomain, NULL, BAD_CAST "SpatialDomain", NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*      imageCRS bounding box.                                          */
+  /* -------------------------------------------------------------------- */
+  xmlAddChild(psSD,
+              msOWSCommonBoundingBox(psOwsNs, "urn:ogc:def:crs:OGC::imageCRS",
+                                     2, 0, 0, cm.xsize - 1, cm.ysize - 1));
+
+  /* -------------------------------------------------------------------- */
+  /*      native CRS bounding box.                                        */
+  /* -------------------------------------------------------------------- */
+  xmlAddChild(psSD, msOWSCommonBoundingBox(psOwsNs, cm.srs_urn, 2,
+                                           cm.extent.minx, cm.extent.miny,
+                                           cm.extent.maxx, cm.extent.maxy));
+
+  /* -------------------------------------------------------------------- */
+  /*      WGS84 bounding box.                                             */
+  /* -------------------------------------------------------------------- */
+  xmlAddChild(psSD, msOWSCommonWGS84BoundingBox(
+                        psOwsNs, 2, cm.llextent.minx, cm.llextent.miny,
+                        cm.llextent.maxx, cm.llextent.maxy));
+
+  /* -------------------------------------------------------------------- */
+  /*      GridCRS                                                         */
+  /* -------------------------------------------------------------------- */
+  {
+    char format_buf[500];
+    projectionObj proj;
+    double x0 =
+        cm.geotransform[0] + cm.geotransform[1] / 2 + cm.geotransform[2] / 2;
+    double y0 =
+        cm.geotransform[3] + cm.geotransform[4] / 2 + cm.geotransform[5] / 2;
+    double resx = cm.geotransform[1];
+    double resy = cm.geotransform[5];
+
+    msInitProjection(&proj);
+    msProjectionInheritContextFrom(&proj, &(layer->projection));
+    if (msLoadProjectionString(&proj, cm.srs_urn) == 0) {
+      msAxisNormalizePoints(&proj, 1, &x0, &y0);
+      msAxisNormalizePoints(&proj, 1, &resx, &resy);
+    }
+    msFreeProjection(&proj);
+
+    psGridCRS = xmlNewChild(psSD, NULL, BAD_CAST "GridCRS", NULL);
+
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridBaseCRS", BAD_CAST cm.srs_urn);
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridType",
+                BAD_CAST "urn:ogc:def:method:WCS:1.1:2dSimpleGrid");
+
+    sprintf(format_buf, "%.15g %.15g", x0, y0);
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridOrigin", BAD_CAST format_buf);
+
+    sprintf(format_buf, "%.15g %.15g", resx, resy);
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridOffsets", BAD_CAST format_buf);
+
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridCS",
+                BAD_CAST "urn:ogc:def:cs:OGC:0.0:Grid2dSquareCS");
+  }
+
+#ifdef notdef
+  /* TemporalDomain */
+
+  /* TODO: figure out when a temporal domain is valid, for example only tiled
+   * rasters support time as a domain, plus we need a timeitem */
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") ||
+      msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
+    msIO_printf("      <temporalDomain>\n");
+
+    /* TimePosition (should support a value AUTO, then we could mine positions
+     * from the timeitem) */
+    msOWSPrintEncodeMetadataList(
+        stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+        "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
+
+    /* TODO:  add TimePeriod (only one per layer)  */
+
+    msIO_printf("      </temporalDomain>\n");
+  }
+
+  msIO_printf("    </domainSet>\n");
+#endif
+
+  /* -------------------------------------------------------------------- */
+  /*      Range                                                           */
+  /* -------------------------------------------------------------------- */
+  {
+    xmlNodePtr psField, psInterpMethods, psAxis;
+    char *value;
+
+    psField = xmlNewChild(xmlNewChild(psCD, NULL, BAD_CAST "Range", NULL), NULL,
+                          BAD_CAST "Field", NULL);
+
+    value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "rangeset_label",
+                                   NULL);
+    if (value)
+      xmlNewChild(psField, psOwsNs, BAD_CAST "Title", BAD_CAST value);
+    msFree(value);
+
+    /* ows:Abstract? TODO */
+
+    value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "rangeset_name",
+                                   "raster");
+    xmlNewChild(psField, NULL, BAD_CAST "Identifier", BAD_CAST value);
+    msFree(value);
+
+    xmlNewChild(xmlNewChild(psField, NULL, BAD_CAST "Definition", NULL),
+                psOwsNs, BAD_CAST "AnyValue", NULL);
+
+    /* NullValue */
+    value = msOWSGetEncodeMetadata(&(layer->metadata), "CO",
+                                   "rangeset_nullvalue", NULL);
+    if (value)
+      xmlNewChild(psField, NULL, BAD_CAST "NullValue", BAD_CAST value);
+    msFree(value);
+
+    /* InterpolationMethods */
+    psInterpMethods =
+        xmlNewChild(psField, NULL, BAD_CAST "InterpolationMethods", NULL);
+
+    xmlNewChild(psInterpMethods, NULL, BAD_CAST "InterpolationMethod",
+                BAD_CAST "bilinear");
+    xmlNewChild(psInterpMethods, NULL, BAD_CAST "Default",
+                BAD_CAST "nearest neighbor");
+
+    /* -------------------------------------------------------------------- */
+    /*      Bands axis.                                                     */
+    /* -------------------------------------------------------------------- */
+    {
+      xmlNodePtr psKeys;
+      int iBand;
+
+      value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "bands_name",
+                                     "bands");
+      psAxis = xmlNewChild(psField, NULL, BAD_CAST "Axis", NULL);
+      xmlNewProp(psAxis, BAD_CAST "identifier", BAD_CAST value);
+      msFree(value);
+
+      psKeys = xmlNewChild(psAxis, NULL, BAD_CAST "AvailableKeys", NULL);
+
+      for (iBand = 0; iBand < cm.bandcount; iBand++) {
+        char szBandName[32];
+
+        snprintf(szBandName, sizeof(szBandName), "%d", iBand + 1);
+        xmlNewChild(psKeys, NULL, BAD_CAST "Key", BAD_CAST szBandName);
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      SupportedCRS                                                    */
+  /* -------------------------------------------------------------------- */
+  {
+    char *owned_value;
+
+    if ((owned_value = msOWSGetProjURN(&(layer->projection), &(layer->metadata),
+                                       "CO", MS_FALSE)) != NULL) {
+      /* ok */
+    } else if ((owned_value = msOWSGetProjURN(&(layer->map->projection),
+                                              &(layer->map->web.metadata), "CO",
+                                              MS_FALSE)) != NULL) {
+      /* ok */
+    } else
+      msDebug("mapwcs.c: missing required information, no SRSs defined.\n");
+
+    if (owned_value != NULL && strlen(owned_value) > 0)
+      msLibXml2GenerateList(psCD, NULL, "SupportedCRS", owned_value, ' ');
+
+    msFree(owned_value);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      SupportedFormats                                                */
+  /* -------------------------------------------------------------------- */
+  {
+    char *format_list;
+
+    format_list = msWCSGetFormatsList11(layer->map, layer);
+
+    if (strlen(format_list) > 0)
+      msLibXml2GenerateList(psCD, NULL, "SupportedFormat", format_list, ',');
+
+    msFree(format_list);
+  }
+  msWCSFreeCoverageMetadata(&cm);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                      msWCSDescribeCoverage11()                       */
+/************************************************************************/
+
+int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params,
+                            owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode;
+  xmlNsPtr psOwsNs;
+  char *schemaLocation = NULL;
+  char *xsi_schemaLocation = NULL;
+
+  int i, j;
+
+  /* -------------------------------------------------------------------- */
+  /*      We will actually get the coverages list as a single item in     */
+  /*      a string list with that item having the comma delimited         */
+  /*      coverage names.  Split it up now, and assign back in place      */
+  /*      of the old coverages list.                                      */
+  /* -------------------------------------------------------------------- */
+  if (CSLCount(params->coverages) == 1) {
+    char **old_coverages = params->coverages;
+    params->coverages =
+        CSLTokenizeStringComplex(old_coverages[0], ",", FALSE, FALSE);
+    CSLDestroy(old_coverages);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Validate that the requested coverages exist as named layers.    */
+  /* -------------------------------------------------------------------- */
+  if (params->coverages) { /* use the list */
+    for (j = 0; params->coverages[j]; j++) {
+      i = msGetLayerIndex(map, params->coverages[j]);
+      if ((i == -1) || (!msIntegerInArray(GET_LAYER(map, i)->index,
+                                          ows_request->enabled_layers,
+                                          ows_request->numlayers))) {
+        msSetError(MS_WCSERR, "COVERAGE %s cannot be opened / does not exist",
+                   "msWCSDescribeCoverage()", params->coverages[j]);
+        return msWCSException11(map, "CoverageNotDefined", "coverage",
+                                params->version);
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create document.                                                */
+  /* -------------------------------------------------------------------- */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "CoverageDescriptions");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* -------------------------------------------------------------------- */
+  /*      Name spaces                                                     */
+  /* -------------------------------------------------------------------- */
+  xmlSetNs(
+      psRootNode,
+      xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
+  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+
+  schemaLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStrdup("http://www.opengis.net/wcs/1.1");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           "/wcs/1.1/wcsDescribeCoverage.xsd ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+  msFree(schemaLocation);
+  msFree(xsi_schemaLocation);
+
+  /* -------------------------------------------------------------------- */
+  /*      Generate a CoverageDescription for each requested coverage.     */
+  /* -------------------------------------------------------------------- */
+
+  if (params->coverages) { /* use the list */
+    for (j = 0; params->coverages[j]; j++) {
+      i = msGetLayerIndex(map, params->coverages[j]);
+      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)), params,
+                                                  psRootNode, psOwsNs);
+    }
+  } else { /* return all layers */
+    for (i = 0; i < map->numlayers; i++) {
+
+      if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                            ows_request->enabled_layers,
+                            ows_request->numlayers))
+        continue;
+
+      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)), params,
+                                                  psRootNode, psOwsNs);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document.                                         */
+  /* -------------------------------------------------------------------- */
+  {
+    xmlChar *buffer = NULL;
+    int size = 0;
+    msIOContext *context = NULL;
+
+    if (msIO_needBinaryStdout() == MS_FAILURE)
+      return MS_FAILURE;
+
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+    msIO_sendHeaders();
+
+    context = msIO_getHandler(stdout);
+
+    xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
+    msIO_contextWrite(context, buffer, size);
+    xmlFree(buffer);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Cleanup                                                         */
+  /* -------------------------------------------------------------------- */
+  xmlFreeDoc(psDoc);
+  xmlCleanupParser();
+
+  return MS_SUCCESS;
+}
+
+#endif /* defined(USE_WCS_SVR) && defined(USE_LIBXML2) */
+
+/************************************************************************/
+/*                      msWCSGetCoverageBands11()                       */
+/*                                                                      */
+/*      We expect input to be of the form:                              */
+/*      RangeSubset=raster:interpolation[bands[1]].                     */
+/*                                                                      */
+/*      RangeSet=raster:[bands[1,2]]                                    */
+/*       or                                                             */
+/*      RangeSet=raster:bilinear                                        */
+/*                                                                      */
+/*      This function tries to return a bandlist if found, and will     */
+/*      also push an INTERPOLATION keyword into the parameters list     */
+/*      if found in the RangeSubset.                                    */
+/************************************************************************/
+
+#if defined(USE_WCS_SVR)
+int msWCSGetCoverageBands11(mapObj *map, cgiRequestObj *request,
+                            wcsParamsObj *params, layerObj *lp,
+                            char **p_bandlist)
+
+{
+  char *rangesubset, *field_id;
+  const char *axis_id;
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch the RangeSubset from the parameters, skip building a      */
+  /*      bands list if not found.                                        */
+  /* -------------------------------------------------------------------- */
+  const char *value = msWCSGetRequestParameter(request, "RangeSubset");
+  if (value == NULL)
+    return MS_SUCCESS;
+
+  rangesubset = msStrdup(value);
+
+  /* -------------------------------------------------------------------- */
+  /*      What is the <Field identifier=...> (rangeset_name)?             */
+  /* -------------------------------------------------------------------- */
+  value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_name");
+  if (value == NULL)
+    value = "raster";
+  field_id = msStrdup(value);
+
+  /* -------------------------------------------------------------------- */
+  /*      What is the <Axis identifier=...> (bands_name)?                 */
+  /* -------------------------------------------------------------------- */
+  axis_id = msOWSLookupMetadata(&(lp->metadata), "CO", "bands_name");
+  if (axis_id == NULL)
+    axis_id = "bands";
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse out the field identifier from the request and verify.     */
+  /* -------------------------------------------------------------------- */
+  value = rangesubset + strlen(field_id);
+
+  if (strcasecmp(rangesubset, field_id) == 0) {
+    free(rangesubset);
+    free(field_id);
+    return MS_SUCCESS; /* we only got field ... default options */
+  }
+
+  if (strlen(rangesubset) <= strlen(field_id) + 1 ||
+      strncasecmp(rangesubset, field_id, strlen(field_id)) != 0 ||
+      (*value != '[' && *value != ':')) {
+    msSetError(
+        MS_WCSERR,
+        "RangeSubset field name malformed, expected '%s', got RangeSubset=%s",
+        "msWCSGetCoverageBands11()", field_id, rangesubset);
+    free(rangesubset);
+    free(field_id);
+    return msWCSException11(map, "NoApplicableCode", "mapserv",
+                            params->version);
+  }
+
+  free(field_id);
+  field_id = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse out the interpolation, if found.                          */
+  /* -------------------------------------------------------------------- */
+  if (*value == ':') {
+    assert(params->interpolation == NULL);
+    params->interpolation = msStrdup(value + 1);
+    for (i = 0; params->interpolation[i] != '\0'; i++) {
+      if (params->interpolation[i] == '[') {
+        params->interpolation[i] = '\0';
+        break;
+      }
+    }
+
+    value += strlen(params->interpolation) + 1;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse out the axis name, and verify.                            */
+  /* -------------------------------------------------------------------- */
+  if (*value != '[') {
+    free(rangesubset);
+    return MS_SUCCESS;
+  }
+
+  value++;
+
+  if (strlen(value) <= strlen(axis_id) + 1 ||
+      strncasecmp(value, axis_id, strlen(axis_id)) != 0 ||
+      value[strlen(axis_id)] != '[') {
+    msSetError(
+        MS_WCSERR,
+        "RangeSubset axis name malformed, expected '%s', got RangeSubset=%s",
+        "msWCSGetCoverageBands11()", axis_id, rangesubset);
+    free(rangesubset);
+    return msWCSException11(map, "NoApplicableCode", "mapserv",
+                            params->version);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse the band list.  Basically assuming the band list is       */
+  /*      everything from here to a close ';'.                            */
+  /* -------------------------------------------------------------------- */
+  value += strlen(axis_id) + 1;
+
+  *p_bandlist = msStrdup(value);
+
+  for (i = 0; (*p_bandlist)[i] != '\0'; i++) {
+    if ((*p_bandlist)[i] == '[') {
+      (*p_bandlist)[i] = '\0';
+      break;
+    }
+  }
+  free(rangesubset);
+  return MS_SUCCESS;
+}
+#endif
+
+/************************************************************************/
+/*                       msWCSReturnCoverage11()                        */
+/*                                                                      */
+/*      Return a render image as a coverage to the caller with WCS      */
+/*      1.1 "mime" wrapping.                                            */
+/************************************************************************/
+
+#if defined(USE_WCS_SVR)
+int msWCSReturnCoverage11(wcsParamsObj *params, mapObj *map, imageObj *image) {
+  int status, i;
+  char *filename = NULL;
+  char *base_dir = NULL;
+  const char *fo_filename;
+
+  fo_filename = msGetOutputFormatOption(image->format, "FILENAME", NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch the driver we will be using and check if it supports      */
+  /*      VSIL IO.                                                        */
+  /* -------------------------------------------------------------------- */
+  if (EQUALN(image->format->driver, "GDAL/", 5)) {
+    GDALDriverH hDriver;
+    const char *pszExtension = image->format->extension;
+
+    msAcquireLock(TLOCK_GDAL);
+    hDriver = GDALGetDriverByName(image->format->driver + 5);
+    if (hDriver == NULL) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_MISCERR, "Failed to find %s driver.",
+                 "msWCSReturnCoverage11()", image->format->driver + 5);
+      return msWCSException11(map, "NoApplicableCode", "mapserv",
+                              params->version);
+    }
+
+    if (pszExtension == NULL)
+      pszExtension = "img.tmp";
+
+    if (msGDALDriverSupportsVirtualIOOutput(hDriver)) {
+      base_dir = msTmpFile(map, map->mappath, "/vsimem/wcsout", NULL);
+      if (fo_filename)
+        filename = msStrdup(CPLFormFilename(base_dir, fo_filename, NULL));
+      else
+        filename = msStrdup(CPLFormFilename(base_dir, "out", pszExtension));
+
+      /*            CleanVSIDir( "/vsimem/wcsout" ); */
+
+      msReleaseLock(TLOCK_GDAL);
+      status = msSaveImage(map, image, filename);
+      if (status != MS_SUCCESS) {
+        msFree(filename);
+        msSetError(MS_MISCERR, "msSaveImage() failed",
+                   "msWCSReturnCoverage11()");
+        return msWCSException11(map, "NoApplicableCode", "mapserv",
+                                params->version);
+      }
+    }
+    msReleaseLock(TLOCK_GDAL);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Output stock header.                                            */
+  /* -------------------------------------------------------------------- */
+  msIO_setHeader("Content-Type", "multipart/mixed; boundary=wcs");
+  msIO_sendHeaders();
+  msIO_printf("\r\n--wcs\r\n"
+              "Content-Type: text/xml; charset=UTF-8\r\n"
+              "Content-ID: wcs.xml\r\n\r\n"
+              "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
+              "<Coverages\n"
+              "     xmlns=\"http://www.opengis.net/wcs/1.1\"\n"
+              "     xmlns:ows=\"http://www.opengis.net/ows/1.1\"\n"
+              "     xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n"
+              "     xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+              "     xsi:schemaLocation=\"http://www.opengis.net/ows/1.1 "
+              "../owsCoverages.xsd\">\n"
+              "  <Coverage>\n");
+
+  /* -------------------------------------------------------------------- */
+  /*      If we weren't able to write data under /vsimem, then we just    */
+  /*      output a single "stock" filename.                               */
+  /* -------------------------------------------------------------------- */
+  if (filename == NULL) {
+    msOutputFormatResolveFromImage(map, image);
+    msIO_fprintf(stdout,
+                 "    <ows:Reference xlink:href=\"cid:coverage/wcs.%s\"/>\n"
+                 "  </Coverage>\n"
+                 "</Coverages>\n"
+                 "\r\n--wcs\r\n"
+                 "Content-Type: %s\r\n"
+                 "Content-Description: coverage data\r\n"
+                 "Content-Transfer-Encoding: binary\r\n"
+                 "Content-ID: coverage/wcs.%s\r\n"
+                 "Content-Disposition: INLINE\r\n\r\n",
+                 MS_IMAGE_EXTENSION(map->outputformat),
+                 MS_IMAGE_MIME_TYPE(map->outputformat),
+                 MS_IMAGE_EXTENSION(map->outputformat));
+
+    status = msSaveImage(map, image, NULL);
+    if (status != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "msSaveImage() failed", "msWCSReturnCoverage11()");
+      return msWCSException11(map, "NoApplicableCode", "mapserv",
+                              params->version);
+    }
+
+    msIO_fprintf(stdout, "\r\n--wcs--\r\n");
+    return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      When potentially listing multiple files, we take great care     */
+  /*      to identify the "primary" file and list it first.  In fact      */
+  /*      it is the only file listed in the coverages document.           */
+  /* -------------------------------------------------------------------- */
+  {
+    char **all_files = CPLReadDir(base_dir);
+    int count = CSLCount(all_files);
+
+    if (msIO_needBinaryStdout() == MS_FAILURE)
+      return MS_FAILURE;
+
+    msAcquireLock(TLOCK_GDAL);
+    for (i = count - 1; i >= 0; i--) {
+      const char *this_file = all_files[i];
+
+      if (EQUAL(this_file, ".") || EQUAL(this_file, "..")) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
+        continue;
+      }
+
+      if (i > 0 && EQUAL(this_file, CPLGetFilename(filename))) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
+        all_files = CSLInsertString(all_files, 0, CPLGetFilename(filename));
+        i++;
+      }
+    }
+
+    msIO_fprintf(stdout,
+                 "    <ows:Reference xlink:href=\"cid:coverage/%s\"/>\n"
+                 "  </Coverage>\n"
+                 "</Coverages>\n",
+                 CPLGetFilename(filename));
+
+    /* -------------------------------------------------------------------- */
+    /*      Dump all the files in the memory directory as mime sections.    */
+    /* -------------------------------------------------------------------- */
+    count = CSLCount(all_files);
+
+    for (i = 0; i < count; i++) {
+      const char *mimetype = NULL;
+      VSILFILE *fp;
+      unsigned char block[4000];
+      int bytes_read;
+
+      if (i == 0)
+        mimetype = MS_IMAGE_MIME_TYPE(map->outputformat);
+
+      if (mimetype == NULL)
+        mimetype = "application/octet-stream";
+
+      msIO_fprintf(stdout,
+                   "\r\n--wcs\r\n"
+                   "Content-Type: %s\r\n"
+                   "Content-Description: coverage data\r\n"
+                   "Content-Transfer-Encoding: binary\r\n"
+                   "Content-ID: coverage/%s\r\n"
+                   "Content-Disposition: INLINE\r\n\r\n",
+                   mimetype, all_files[i]);
+
+      fp = VSIFOpenL(CPLFormFilename(base_dir, all_files[i], NULL), "rb");
+      if (fp == NULL) {
+        msReleaseLock(TLOCK_GDAL);
+        msSetError(MS_MISCERR, "Failed to open %s for streaming to stdout.",
+                   "msWCSReturnCoverage11()", all_files[i]);
+        return MS_FAILURE;
+      }
+
+      while ((bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0)
+        msIO_fwrite(block, 1, bytes_read, stdout);
+
+      VSIFCloseL(fp);
+
+      VSIUnlink(CPLFormFilename(base_dir, all_files[i], NULL));
+    }
+
+    msFree(base_dir);
+    msFree(filename);
+    CSLDestroy(all_files);
+    msReleaseLock(TLOCK_GDAL);
+
+    msIO_fprintf(stdout, "\r\n--wcs--\r\n");
+    return MS_SUCCESS;
+  }
+}
+#endif /* defined(USE_WCS_SVR) && defined(USE_LIBXML2) */
+
+/************************************************************************/
+/* ==================================================================== */
+/*  If we don't have libxml2 but WCS SVR was selected, then         */
+/*      report WCS 1.1 requests as unsupported.                         */
+/* ==================================================================== */
+/************************************************************************/
+
+#if defined(USE_WCS_SVR) && !defined(USE_LIBXML2)
+
+#include "mapwcs.h"
+
+/* ==================================================================== */
+
+int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params,
+                            owsRequestObj *ows_request) {
+  msSetError(MS_WCSERR,
+             "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 "
+             "services and this is not configured.",
+             "msWCSDescribeCoverage11()");
+  return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
+}
+
+/* ==================================================================== */
+
+int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  msSetError(MS_WCSERR,
+             "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 "
+             "services and this is not configured.",
+             "msWCSGetCapabilities11()");
+
+  return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
+}
+
+int msWCSException11(mapObj *map, const char *exceptionCode,
+                     const char *locator, const char *version) {
+  /* fallback to reporting using 1.0 style exceptions. */
+  return msWCSException(map, exceptionCode, locator, "1.0.0");
+}
+
+#endif /* defined(USE_WCS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/src/mapwcs20.cpp 8.2.0~beta1-1~exp1/src/mapwcs20.cpp
--- 8.0.1-5/src/mapwcs20.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwcs20.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5221 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OpenGIS Web Coverage Server (WCS) 2.0 implementation.
+ * Author:   Stephan Meissl <stephan.meissl@eox.at>
+ *           Fabian Schindler <fabian.schindler@eox.at>
+ *           and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 2010, 2011 EOX IT Services GmbH, Austria
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver-config.h"
+#if defined(USE_WCS_SVR)
+
+#include <assert.h>
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapthread.h"
+#include "mapows.h"
+#include "mapwcs.h"
+#include "mapgdal.h"
+#include <float.h>
+#include "gdal.h"
+#include "cpl_port.h"
+#include "maptime.h"
+#include "mapprimitive.h"
+#include "cpl_string.h"
+#include <string.h>
+
+#if defined(USE_LIBXML2)
+
+#include <libxml/tree.h>
+#include "maplibxml2.h"
+#include <libxml/parser.h>
+
+#endif /* defined(USE_LIBXML2) */
+
+#include <string>
+
+/************************************************************************/
+/*                          msXMLStripIndentation                       */
+/************************************************************************/
+
+static void msXMLStripIndentation(char *ptr) {
+  /* Remove spaces between > and < to get properly indented result */
+  char *afterLastClosingBracket = NULL;
+  if (*ptr == ' ')
+    afterLastClosingBracket = ptr;
+  while (*ptr != '\0') {
+    if (*ptr == '<' && afterLastClosingBracket != NULL) {
+      memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
+      ptr = afterLastClosingBracket;
+    } else if (*ptr == '>') {
+      afterLastClosingBracket = ptr + 1;
+    } else if (*ptr != ' ' && *ptr != '\n')
+      afterLastClosingBracket = NULL;
+    ptr++;
+  }
+}
+
+/************************************************************************/
+/*                   msStringParseInteger()                             */
+/*                                                                      */
+/*      Tries to parse a string as a integer value. If not possible     */
+/*      the value MS_WCS20_UNBOUNDED is stored as value.                */
+/*      If no characters could be parsed, MS_FAILURE is returned. If at */
+/*      least some characters could be parsed, MS_DONE is returned and  */
+/*      only if all characters could be parsed, MS_SUCCESS is returned. */
+/************************************************************************/
+
+static int msStringParseInteger(const char *string, int *dest) {
+  char *parse_check;
+  *dest = (int)strtol(string, &parse_check, 0);
+  if (parse_check == string) {
+    return MS_FAILURE;
+  } else if (parse_check - strlen(string) != string) {
+    return MS_DONE;
+  }
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msStringParseDouble()                              */
+/*                                                                      */
+/*      Tries to parse a string as a double value. If not possible      */
+/*      the value 0 is stored as value.                                 */
+/*      If no characters could be parsed, MS_FAILURE is returned. If at */
+/*      least some characters could be parsed, MS_DONE is returned and  */
+/*      only if all characters could be parsed, MS_SUCCESS is returned. */
+/************************************************************************/
+
+static int msStringParseDouble(const char *string, double *dest) {
+  char *parse_check = NULL;
+  *dest = strtod(string, &parse_check);
+  if (parse_check == string) {
+    return MS_FAILURE;
+  } else if (parse_check - strlen(string) != string) {
+    return MS_DONE;
+  }
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSParseTimeOrScalar20()                         */
+/*                                                                      */
+/*      Parses a string, either as a time or a scalar value and         */
+/*      writes the output into the timeScalarUnion.                     */
+/************************************************************************/
+
+static int msWCSParseTimeOrScalar20(timeScalarUnion *u, const char *string) {
+  struct tm time;
+  if (string) {
+    while (*string == ' ')
+      string++;
+  }
+
+  if (!string || strlen(string) == 0 || !u) {
+    msSetError(MS_WCSERR, "Invalid string", "msWCSParseTimeOrScalar20()");
+    return MS_WCS20_ERROR_VALUE;
+  }
+  /* if the string is equal to "*" it means the value
+   *  of the interval is unbounded                    */
+  if (EQUAL(string, "*")) {
+    u->scalar = MS_WCS20_UNBOUNDED;
+    u->unbounded = 1;
+    return MS_WCS20_UNDEFINED_VALUE;
+  }
+
+  /* if returned a valid value, use it */
+  if (msStringParseDouble(string, &(u->scalar)) == MS_SUCCESS) {
+    return MS_WCS20_SCALAR_VALUE;
+  }
+  /* otherwise it might be a time value */
+  msTimeInit(&time);
+  if (msParseTime(string, &time) == MS_TRUE) {
+    u->time = mktime(&time);
+    return MS_WCS20_TIME_VALUE;
+  }
+  /* the value could neither be parsed as a double nor as a time value */
+  else {
+    msSetError(MS_WCSERR,
+               "String %s could not be parsed to a time or scalar value",
+               "msWCSParseTimeOrScalar20()", string);
+    return MS_WCS20_ERROR_VALUE;
+  }
+}
+
+/************************************************************************/
+/*                   msWCSCreateSubsetObj20()                           */
+/*                                                                      */
+/*      Creates a new wcs20SubsetObj and initializes it to standard     */
+/*      values.                                                         */
+/************************************************************************/
+
+static wcs20SubsetObjPtr msWCSCreateSubsetObj20() {
+  wcs20SubsetObjPtr subset = (wcs20SubsetObjPtr)malloc(sizeof(wcs20SubsetObj));
+  MS_CHECK_ALLOC(subset, sizeof(wcs20SubsetObj), NULL);
+
+  subset->axis = NULL;
+  subset->crs = NULL;
+  subset->min.scalar = subset->max.scalar = MS_WCS20_UNBOUNDED;
+  subset->min.unbounded = subset->max.unbounded = 0;
+  subset->operation = MS_WCS20_SLICE;
+
+  return subset;
+}
+
+/************************************************************************/
+/*                   msWCSFreeSubsetObj20()                             */
+/*                                                                      */
+/*      Frees a wcs20SubsetObj and releases all linked resources.       */
+/************************************************************************/
+
+static void msWCSFreeSubsetObj20(wcs20SubsetObjPtr subset) {
+  if (NULL == subset) {
+    return;
+  }
+  msFree(subset->axis);
+  msFree(subset->crs);
+  msFree(subset);
+}
+
+/************************************************************************/
+/*                   msWCSCreateAxisObj20()                             */
+/*                                                                      */
+/*      Creates a new wcs20AxisObj and initializes it to standard       */
+/*      values.                                                         */
+/************************************************************************/
+
+static wcs20AxisObjPtr msWCSCreateAxisObj20() {
+  wcs20AxisObj *axis = (wcs20AxisObjPtr)malloc(sizeof(wcs20AxisObj));
+  MS_CHECK_ALLOC(axis, sizeof(wcs20AxisObj), NULL);
+
+  axis->name = NULL;
+  axis->size = 0;
+  axis->resolution = MS_WCS20_UNBOUNDED;
+  axis->scale = MS_WCS20_UNBOUNDED;
+  axis->resolutionUOM = NULL;
+  axis->subset = NULL;
+
+  return axis;
+}
+
+/************************************************************************/
+/*                   msWCSFreeAxisObj20()                               */
+/*                                                                      */
+/*      Frees a wcs20AxisObj and releases all linked resources.         */
+/************************************************************************/
+
+static void msWCSFreeAxisObj20(wcs20AxisObjPtr axis) {
+  if (NULL == axis) {
+    return;
+  }
+
+  msFree(axis->name);
+  msFree(axis->resolutionUOM);
+  msWCSFreeSubsetObj20(axis->subset);
+  msFree(axis);
+}
+
+/************************************************************************/
+/*                   msWCSFindAxis20()                                  */
+/*                                                                      */
+/*      Helper function to retrieve an axis by the name from a params   */
+/*      object.                                                         */
+/************************************************************************/
+
+static wcs20AxisObjPtr msWCSFindAxis20(wcs20ParamsObjPtr params,
+                                       const char *name) {
+  int i = 0;
+  for (i = 0; i < params->numaxes; ++i) {
+    if (EQUAL(params->axes[i]->name, name)) {
+      return params->axes[i];
+    }
+  }
+  return NULL;
+}
+
+/************************************************************************/
+/*                   msWCSInsertAxisObj20()                             */
+/*                                                                      */
+/*      Helper function to insert an axis object into the axes list of  */
+/*      a params object.                                                */
+/************************************************************************/
+
+static void msWCSInsertAxisObj20(wcs20ParamsObjPtr params,
+                                 wcs20AxisObjPtr axis) {
+  params->numaxes++;
+  params->axes = (wcs20AxisObjPtr *)msSmallRealloc(
+      params->axes, sizeof(wcs20AxisObjPtr) * (params->numaxes));
+  params->axes[params->numaxes - 1] = axis;
+}
+
+/************************************************************************/
+/*                   msWCSCreateParamsObj20()                           */
+/*                                                                      */
+/*      Creates a new wcs20ParamsObj and initializes it to standard     */
+/*      values.                                                         */
+/************************************************************************/
+
+wcs20ParamsObjPtr msWCSCreateParamsObj20() {
+  wcs20ParamsObjPtr params = (wcs20ParamsObjPtr)malloc(sizeof(wcs20ParamsObj));
+  MS_CHECK_ALLOC(params, sizeof(wcs20ParamsObj), NULL);
+
+  params->version = NULL;
+  params->request = NULL;
+  params->service = NULL;
+  params->accept_versions = NULL;
+  params->accept_languages = NULL;
+  params->sections = NULL;
+  params->updatesequence = NULL;
+  params->ids = NULL;
+  params->width = 0;
+  params->height = 0;
+  params->resolutionX = MS_WCS20_UNBOUNDED;
+  params->resolutionY = MS_WCS20_UNBOUNDED;
+  params->scale = MS_WCS20_UNBOUNDED;
+  params->scaleX = MS_WCS20_UNBOUNDED;
+  params->scaleY = MS_WCS20_UNBOUNDED;
+  params->resolutionUnits = NULL;
+  params->numaxes = 0;
+  params->axes = NULL;
+  params->format = NULL;
+  params->multipart = 0;
+  params->interpolation = NULL;
+  params->outputcrs = NULL;
+  params->subsetcrs = NULL;
+  params->bbox.minx = params->bbox.miny = -DBL_MAX;
+  params->bbox.maxx = params->bbox.maxy = DBL_MAX;
+  params->range_subset = NULL;
+  params->format_options = NULL;
+
+  return params;
+}
+
+/************************************************************************/
+/*                   msWCSFreeParamsObj20()                             */
+/*                                                                      */
+/*      Frees a wcs20ParamsObj and releases all linked resources.       */
+/************************************************************************/
+
+void msWCSFreeParamsObj20(wcs20ParamsObjPtr params) {
+  if (NULL == params) {
+    return;
+  }
+
+  msFree(params->version);
+  msFree(params->request);
+  msFree(params->service);
+  CSLDestroy(params->accept_versions);
+  CSLDestroy(params->accept_languages);
+  CSLDestroy(params->sections);
+  msFree(params->updatesequence);
+  CSLDestroy(params->ids);
+  msFree(params->resolutionUnits);
+  msFree(params->format);
+  msFree(params->interpolation);
+  msFree(params->outputcrs);
+  msFree(params->subsetcrs);
+  while (params->numaxes > 0) {
+    params->numaxes -= 1;
+    msWCSFreeAxisObj20(params->axes[params->numaxes]);
+  }
+  msFree(params->axes);
+  CSLDestroy(params->range_subset);
+  CSLDestroy(params->format_options);
+  msFree(params);
+}
+
+/************************************************************************/
+/*                   msWCSParseSubset20()                               */
+/*                                                                      */
+/*      Parses several string parameters and fills them into the        */
+/*      subset object.                                                  */
+/************************************************************************/
+
+static int msWCSParseSubset20(wcs20SubsetObjPtr subset, const char *axis,
+                              const char *crs, const char *min,
+                              const char *max) {
+  int ts1, ts2;
+  ts1 = ts2 = MS_WCS20_UNDEFINED_VALUE;
+
+  if (subset == NULL) {
+    return MS_FAILURE;
+  }
+
+  if (axis == NULL || strlen(axis) == 0) {
+    msSetError(MS_WCSERR, "Subset axis is not given.", "msWCSParseSubset20()");
+    return MS_FAILURE;
+  }
+
+  subset->axis = msStrdup(axis);
+  if (crs != NULL) {
+    subset->crs = msStrdup(crs);
+  }
+
+  /* Parse first (probably only) part of interval/point;
+   * check whether its a time value or a scalar value     */
+  ts1 = msWCSParseTimeOrScalar20(&(subset->min), min);
+  if (ts1 == MS_WCS20_ERROR_VALUE) {
+    return MS_FAILURE;
+  }
+
+  /* check if its an interval */
+  /* if there is a comma, then it is */
+  if (max != NULL && strlen(max) > 0) {
+    subset->operation = MS_WCS20_TRIM;
+
+    /* Parse the second value of the interval */
+    ts2 = msWCSParseTimeOrScalar20(&(subset->max), max);
+    if (ts2 == MS_WCS20_ERROR_VALUE) {
+      return MS_FAILURE;
+    }
+
+    /* if at least one boundary is defined, use that value */
+    if ((ts1 == MS_WCS20_UNDEFINED_VALUE) ^ (ts2 == MS_WCS20_UNDEFINED_VALUE)) {
+      if (ts1 == MS_WCS20_UNDEFINED_VALUE) {
+        ts1 = ts2;
+      }
+    }
+    /* if time and scalar values do not fit, throw an error */
+    else if (ts1 != MS_WCS20_UNDEFINED_VALUE &&
+             ts2 != MS_WCS20_UNDEFINED_VALUE && ts1 != ts2) {
+      msSetError(MS_WCSERR,
+                 "Interval error: minimum is a %s value, maximum is a %s value",
+                 "msWCSParseSubset20()", ts1 ? "time" : "scalar",
+                 ts2 ? "time" : "scalar");
+      return MS_FAILURE;
+    }
+    /* if both min and max are unbounded -> throw an error */
+    if (subset->min.unbounded && subset->max.unbounded) {
+      msSetError(MS_WCSERR, "Invalid values: no bounds could be parsed",
+                 "msWCSParseSubset20()");
+      return MS_FAILURE;
+    }
+  }
+  /* there is no second value, therefore it is a point.
+   * consequently set the operation to slice */
+  else {
+    subset->operation = MS_WCS20_SLICE;
+    if (ts1 == MS_WCS20_UNDEFINED_VALUE) {
+      msSetError(MS_WCSERR, "Invalid point value given",
+                 "msWCSParseSubset20()");
+      return MS_FAILURE;
+    }
+  }
+
+  subset->timeOrScalar = ts1;
+
+  /* check whether the min is smaller than the max */
+  if (subset->operation == MS_WCS20_TRIM) {
+    if (subset->timeOrScalar == MS_WCS20_SCALAR_VALUE &&
+        subset->min.scalar == MS_WCS20_UNBOUNDED) {
+      subset->min.scalar = -MS_WCS20_UNBOUNDED;
+    }
+
+    if (subset->timeOrScalar == MS_WCS20_TIME_VALUE &&
+        subset->min.time > subset->max.time) {
+      msSetError(MS_WCSERR,
+                 "Minimum value of subset axis %s is larger than maximum value",
+                 "msWCSParseSubset20()", subset->axis);
+      return MS_FAILURE;
+    }
+    if (subset->timeOrScalar == MS_WCS20_SCALAR_VALUE &&
+        subset->min.scalar > subset->max.scalar) {
+      msSetError(MS_WCSERR,
+                 "Minimum value (%f) of subset axis '%s' is larger than "
+                 "maximum value (%f).",
+                 "msWCSParseSubset20()", subset->min.scalar, subset->axis,
+                 subset->max.scalar);
+      return MS_FAILURE;
+    }
+  }
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSParseSubsetKVPString20()                      */
+/*                                                                      */
+/*      Creates a new wcs20SubsetObj, parses a string and fills         */
+/*      the parsed values into the object. Returns NULL on failure.     */
+/*      Subset string: axis [ , crs ] ( intervalOrPoint )               */
+/************************************************************************/
+
+static int msWCSParseSubsetKVPString20(wcs20SubsetObjPtr subset, char *string) {
+  char *axis, *crs, *min, *max;
+
+  axis = string;
+  crs = NULL;
+  min = NULL;
+  max = NULL;
+
+  /* find first '(' */
+  min = strchr(string, '(');
+
+  /* if min could not be found, the string is invalid */
+  if (min == NULL) {
+    msSetError(MS_WCSERR, "Invalid axis subset string: '%s'",
+               "msWCSParseSubsetKVPString20()", string);
+    return MS_FAILURE;
+  }
+  /* set min to first letter */
+  *min = '\0';
+  ++min;
+
+  /* cut the trailing ')' */
+  if (min[strlen(min) - 1] == ')') {
+    min[strlen(min) - 1] = '\0';
+  }
+  /* look if also a max is defined */
+  max = strchr(min, ',');
+  if (max != NULL) {
+    *max = '\0';
+    ++max;
+  }
+
+  /* look if also a crs is defined */
+  crs = strchr(axis, ',');
+  if (crs != NULL) {
+    *crs = '\0';
+    ++crs;
+  }
+
+  return msWCSParseSubset20(subset, axis, crs, min, max);
+}
+
+/************************************************************************/
+/*                   msWCSParseSizeString20()                           */
+/*                                                                      */
+/*      Parses a string containing the axis and the size as an integer. */
+/*      Size string: axis ( size )                                      */
+/************************************************************************/
+
+static int msWCSParseSizeString20(char *string, char *outAxis,
+                                  size_t axisStringLen, int *outSize) {
+  char *number = NULL;
+  char *check = NULL;
+
+  /* find first '(', the character before the number */
+  number = strchr(string, '(');
+
+  if (NULL == number) {
+    msSetError(MS_WCSERR, "Invalid size parameter value.",
+               "msWCSParseSize20()");
+    return MS_FAILURE;
+  }
+
+  /* cut trailing ')' */
+  check = strchr(string, ')');
+  if (NULL == check) {
+    msSetError(MS_WCSERR, "Invalid size parameter value.",
+               "msWCSParseSize20()");
+    return MS_FAILURE;
+  }
+  *number = '\0';
+  ++number;
+  *check = '\0';
+
+  strlcpy(outAxis, string, axisStringLen);
+
+  /* parse size value */
+  if (msStringParseInteger(number, outSize) != MS_SUCCESS) {
+    msSetError(MS_WCSERR, "Parameter value '%s' is not a valid integer.",
+               "msWCSParseSize20()", number);
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSParseResolutionString20()                     */
+/*                                                                      */
+/*      Parses a resolution string and returns the axis, the units of   */
+/*      measure and the resolution value.                               */
+/*      Subset string: axis ( value )                                   */
+/************************************************************************/
+
+static int msWCSParseResolutionString20(char *string, char *outAxis,
+                                        size_t axisStringLen,
+                                        double *outResolution) {
+  char *number = NULL;
+  char *check = NULL;
+
+  /* find brackets */
+  number = strchr(string, '(');
+
+  if (NULL == number) {
+    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
+               "msWCSParseSize20()", string);
+    return MS_FAILURE;
+  }
+
+  /* cut trailing ')' */
+  check = strchr(string, ')');
+  if (NULL == check) {
+    msSetError(MS_WCSERR, "Invalid size parameter value.",
+               "msWCSParseSize20()");
+    return MS_FAILURE;
+  }
+
+  *number = '\0';
+  ++number;
+  *check = '\0';
+
+  strlcpy(outAxis, string, axisStringLen);
+
+  if (msStringParseDouble(number, outResolution) != MS_SUCCESS) {
+    *outResolution = MS_WCS20_UNBOUNDED;
+    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
+               "msWCSParseSize20()", number);
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSParseScaleString20()                          */
+/*                                                                      */
+/*      Parses a scale string and returns the axis, the and the value.  */
+/*      Subset string: axis ( value )                                   */
+/************************************************************************/
+
+static int msWCSParseScaleString20(char *string, char *outAxis,
+                                   size_t axisStringLen, double *outScale) {
+  char *number = NULL;
+  char *check = NULL;
+
+  /* find brackets */
+  number = strchr(string, '(');
+
+  if (NULL == number) {
+    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
+               "msWCSParseScaleString20()", string);
+    return MS_FAILURE;
+  }
+
+  /* cut trailing ')' */
+  check = strchr(string, ')');
+  if (NULL == check || check < number) {
+    msSetError(MS_WCSERR, "Invalid scale parameter value.",
+               "msWCSParseScaleString20()");
+    return MS_FAILURE;
+  }
+
+  *number = '\0';
+  ++number;
+  *check = '\0';
+
+  strlcpy(outAxis, string, axisStringLen);
+
+  if (msStringParseDouble(number, outScale) != MS_SUCCESS || *outScale <= 0.0) {
+    *outScale = MS_WCS20_UNBOUNDED;
+    msSetError(MS_WCSERR, "Invalid scale parameter value : %s.",
+               "msWCSParseScaleString20()", number);
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSParseResolutionString20()                     */
+/*                                                                      */
+/*      Parses a resolution string and returns the axis, the units of   */
+/*      measure and the resolution value.                               */
+/*      Subset string: axis ( value )                                   */
+/************************************************************************/
+
+static int msWCSParseScaleExtentString20(char *string, char *outAxis,
+                                         size_t axisStringLen, int *outMin,
+                                         int *outMax) {
+  char *number = NULL;
+  char *check = NULL;
+  char *colon = NULL;
+
+  /* find brackets */
+  number = strchr(string, '(');
+
+  if (NULL == number) {
+    msSetError(MS_WCSERR, "Invalid extent parameter value : %s.",
+               "msWCSParseScaleExtentString20()", string);
+    return MS_FAILURE;
+  }
+
+  /* find colon */
+  colon = strchr(string, ':');
+
+  if (NULL == colon || colon < number) {
+    msSetError(MS_WCSERR, "Invalid extent parameter value : %s.",
+               "msWCSParseScaleExtentString20()", string);
+    return MS_FAILURE;
+  }
+
+  /* cut trailing ')' */
+  check = strchr(string, ')');
+
+  if (NULL == check || check < colon) {
+    msSetError(MS_WCSERR, "Invalid extent parameter value.",
+               "msWCSParseScaleExtentString20()");
+    return MS_FAILURE;
+  }
+
+  *number = '\0';
+  ++number;
+  *colon = '\0';
+  ++colon;
+  *check = '\0';
+
+  strlcpy(outAxis, string, axisStringLen);
+
+  if (msStringParseInteger(number, outMin) != MS_SUCCESS) {
+    *outMin = 0;
+    msSetError(MS_WCSERR, "Invalid min parameter value : %s.",
+               "msWCSParseScaleExtentString20()", number);
+    return MS_FAILURE;
+  } else if (msStringParseInteger(colon, outMax) != MS_SUCCESS) {
+    *outMax = 0;
+    msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
+               "msWCSParseScaleExtentString20()", colon);
+    return MS_FAILURE;
+  }
+
+  if (*outMin > *outMax) {
+    msSetError(MS_WCSERR,
+               "Invalid extent: lower part is higher than upper part.",
+               "msWCSParseScaleExtentString20()");
+    return MS_FAILURE;
+  }
+
+  return MS_SUCCESS;
+}
+
+#if defined(USE_LIBXML2)
+/*
+  Utility function to get the first child of a node with a given node name
+  */
+
+xmlNodePtr msLibXml2GetFirstChild(xmlNodePtr parent, const char *name) {
+  xmlNodePtr node;
+  if (!parent || !name) {
+    return NULL;
+  }
+
+  XML_FOREACH_CHILD(parent, node) {
+    XML_LOOP_IGNORE_COMMENT_OR_TEXT(node);
+    if (EQUAL((char *)node->name, name)) {
+      return node;
+    }
+  }
+  return NULL;
+}
+
+/*
+  Utility function to get the first child of a node with a given node name and
+  namespace.
+  */
+
+xmlNodePtr msLibXml2GetFirstChildNs(xmlNodePtr parent, const char *name,
+                                    xmlNsPtr ns) {
+  xmlNodePtr node;
+  if (!parent || !name || !ns) {
+    return NULL;
+  }
+
+  XML_FOREACH_CHILD(parent, node) {
+    XML_LOOP_IGNORE_COMMENT_OR_TEXT(node);
+    if (EQUAL((char *)node->name, name) && ns == node->ns) {
+      return node;
+    }
+  }
+  return NULL;
+}
+
+/*
+  Utility function to get the first child of a node with a given node name
+  */
+
+xmlNodePtr msLibXml2GetFirstChildElement(xmlNodePtr parent) {
+  xmlNodePtr node;
+  if (!parent) {
+    return NULL;
+  }
+
+  XML_FOREACH_CHILD(parent, node) {
+    if (node->type == XML_ELEMENT_NODE) {
+      return node;
+    }
+  }
+  return NULL;
+}
+#endif /* defined(USE_LIBXML2) */
+
+/************************************************************************/
+/*                   msWCSParseRequest20_XMLGetCapabilities()           */
+/*                                                                      */
+/*      Parses a DOM element, representing a GetCapabilities-request    */
+/*      to a params object.                                             */
+/************************************************************************/
+#if defined(USE_LIBXML2)
+static int msWCSParseRequest20_XMLGetCapabilities(xmlNodePtr root,
+                                                  wcs20ParamsObjPtr params) {
+  xmlNodePtr child;
+  char *content = NULL;
+  XML_FOREACH_CHILD(root, child) {
+    XML_LOOP_IGNORE_COMMENT_OR_TEXT(child)
+    else if (EQUAL((char *)child->name, "AcceptVersions")) {
+      xmlNodePtr versionNode = NULL;
+      XML_FOREACH_CHILD(child, versionNode) {
+        XML_LOOP_IGNORE_COMMENT_OR_TEXT(versionNode);
+        XML_ASSERT_NODE_NAME(versionNode, "Version");
+
+        content = (char *)xmlNodeGetContent(versionNode);
+        params->accept_versions =
+            CSLAddString(params->accept_versions, content);
+        xmlFree(content);
+      }
+    }
+    else if (EQUAL((char *)child->name, "Sections")) {
+      xmlNodePtr sectionNode = NULL;
+      XML_FOREACH_CHILD(child, sectionNode) {
+        XML_LOOP_IGNORE_COMMENT_OR_TEXT(sectionNode)
+        XML_ASSERT_NODE_NAME(sectionNode, "Section");
+
+        content = (char *)xmlNodeGetContent(sectionNode);
+        params->sections = CSLAddString(params->sections, content);
+        xmlFree(content);
+      }
+    }
+    else if (EQUAL((char *)child->name, "UpdateSequence")) {
+      params->updatesequence = (char *)xmlNodeGetContent(child);
+    }
+    else if (EQUAL((char *)child->name, "AcceptFormats")) {
+      /* Maybe not necessary, since only format is xml.   */
+      /* At least ignore it, to not generate an error.    */
+    }
+    else if (EQUAL((char *)child->name, "AcceptLanguages")) {
+      xmlNodePtr languageNode;
+      XML_FOREACH_CHILD(child, languageNode) {
+        XML_LOOP_IGNORE_COMMENT_OR_TEXT(languageNode)
+        XML_ASSERT_NODE_NAME(languageNode, "Language");
+
+        content = (char *)xmlNodeGetContent(languageNode);
+        params->accept_languages =
+            CSLAddString(params->accept_languages, content);
+        xmlFree(content);
+      }
+    }
+    else {
+      XML_UNKNOWN_NODE_ERROR(child);
+    }
+  }
+  return MS_SUCCESS;
+}
+#endif
+
+/************************************************************************/
+/*                   msWCSParseRequest20_XMLDescribeCoverage()          */
+/*                                                                      */
+/*      Parses a DOM element, representing a DescribeCoverage-request   */
+/*      to a params object.                                             */
+/************************************************************************/
+#if defined(USE_LIBXML2)
+static int msWCSParseRequest20_XMLDescribeCoverage(xmlNodePtr root,
+                                                   wcs20ParamsObjPtr params) {
+  xmlNodePtr child;
+  int numIds = 0;
+  char *id;
+
+  XML_FOREACH_CHILD(root, child) {
+    XML_LOOP_IGNORE_COMMENT_OR_TEXT(child)
+    XML_ASSERT_NODE_NAME(child, "CoverageID");
+
+    /* Node content is the coverage ID */
+    id = (char *)xmlNodeGetContent(child);
+    if (id == NULL || strlen(id) == 0) {
+      msSetError(MS_WCSERR, "CoverageID could not be parsed.",
+                 "msWCSParseRequest20_XMLDescribeCoverage()");
+      return MS_FAILURE;
+    }
+    /* insert coverage ID into the list */
+    ++numIds;
+    params->ids = CSLAddString(params->ids, (char *)id);
+    xmlFree(id);
+  }
+  return MS_SUCCESS;
+}
+#endif
+
+/************************************************************************/
+/*                   msWCSParseRequest20_XMLGetCoverage()               */
+/*                                                                      */
+/*      Parses a DOM element, representing a GetCoverage-request to a   */
+/*      params object.                                                  */
+/************************************************************************/
+#if defined(USE_LIBXML2)
+static int msWCSParseRequest20_XMLGetCoverage(mapObj *map, xmlNodePtr root,
+                                              wcs20ParamsObjPtr params) {
+  xmlNodePtr child;
+  int numIds = 0;
+  char *id;
+
+  XML_FOREACH_CHILD(root, child) {
+    XML_LOOP_IGNORE_COMMENT_OR_TEXT(child)
+    else if (EQUAL((char *)child->name, "CoverageID")) {
+      /* Node content is the coverage ID */
+      id = (char *)xmlNodeGetContent(child);
+      if (id == NULL || strlen(id) == 0) {
+        msSetError(MS_WCSERR, "CoverageID could not be parsed.",
+                   "msWCSParseRequest20_XMLGetCoverage()");
+        return MS_FAILURE;
+      }
+
+      /* insert coverage ID into the list */
+      ++numIds;
+      params->ids = CSLAddString(params->ids, (char *)id);
+      xmlFree(id);
+    }
+    else if (EQUAL((char *)child->name, "Format")) {
+      msFree(params->format);
+      params->format = (char *)xmlNodeGetContent(child);
+    }
+    else if (EQUAL((char *)child->name, "Mediatype")) {
+      char *content = (char *)xmlNodeGetContent(child);
+      if (content != NULL && (EQUAL(content, "multipart/mixed") ||
+                              EQUAL(content, "multipart/related"))) {
+        params->multipart = MS_TRUE;
+      } else {
+        msSetError(MS_WCSERR, "Invalid value '%s' for parameter 'Mediatype'.",
+                   "msWCSParseRequest20()", content);
+        xmlFree(content);
+        return MS_FAILURE;
+      }
+      xmlFree(content);
+    }
+    else if (EQUAL((char *)child->name, "DimensionTrim")) {
+      wcs20AxisObjPtr axis = NULL;
+      wcs20SubsetObjPtr subset = NULL;
+      xmlNodePtr node = NULL;
+      char *axisName = NULL, *min = NULL, *max = NULL, *crs = NULL;
+
+      /* get strings for axis, min and max */
+      XML_FOREACH_CHILD(child, node) {
+        XML_LOOP_IGNORE_COMMENT_OR_TEXT(node)
+        else if (EQUAL((char *)node->name, "Dimension")) {
+          if (axisName != NULL) {
+            msSetError(MS_WCSERR, "Parameter 'Dimension' is already set.",
+                       "msWCSParseRequest20_XMLGetCoverage()");
+            return MS_FAILURE;
+          }
+          axisName = (char *)xmlNodeGetContent(node);
+          crs = (char *)xmlGetProp(node, BAD_CAST "crs");
+        }
+        else if (EQUAL((char *)node->name, "trimLow")) {
+          min = (char *)xmlNodeGetContent(node);
+        }
+        else if (EQUAL((char *)node->name, "trimHigh")) {
+          max = (char *)xmlNodeGetContent(node);
+        }
+        else {
+          msFree(axisName);
+          msFree(min);
+          msFree(max);
+          msFree(crs);
+          XML_UNKNOWN_NODE_ERROR(node);
+        }
+      }
+      if (NULL == (subset = msWCSCreateSubsetObj20())) {
+        msFree(axisName);
+        msFree(min);
+        msFree(max);
+        msFree(crs);
+        return MS_FAILURE;
+      }
+
+      /* min and max have to have a value */
+      if (min == NULL) {
+        min = msStrdup("*");
+      }
+      if (max == NULL) {
+        max = msStrdup("*");
+      }
+      if (msWCSParseSubset20(subset, axisName, crs, min, max) == MS_FAILURE) {
+        msWCSFreeSubsetObj20(subset);
+        msWCSException(map, "InvalidSubsetting", "subset", "2.0.1");
+        return MS_DONE;
+      }
+
+      if (NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
+          msFree(axisName);
+          msFree(min);
+          msFree(max);
+          msFree(crs);
+          return MS_FAILURE;
+        }
+        axis->name = msStrdup(subset->axis);
+        msWCSInsertAxisObj20(params, axis);
+      }
+
+      axis->subset = subset;
+
+      /* cleanup */
+      msFree(axisName);
+      msFree(min);
+      msFree(max);
+      msFree(crs);
+    }
+    else if (EQUAL((char *)child->name, "DimensionSlice")) {
+      msSetError(MS_WCSERR, "Operation '%s' is not supported by MapServer.",
+                 "msWCSParseRequest20_XMLGetCoverage()", (char *)child->name);
+      return MS_FAILURE;
+    }
+    else if (EQUAL((char *)child->name, "Size")) {
+      wcs20AxisObjPtr axis;
+      char *axisName;
+      char *content;
+
+      if (NULL ==
+          (axisName = (char *)xmlGetProp(child, BAD_CAST "dimension"))) {
+        msSetError(MS_WCSERR,
+                   "Attribute 'dimension' is missing in element 'Size'.",
+                   "msWCSParseRequest20_XMLGetCoverage()");
+        return MS_FAILURE;
+      }
+
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
+          xmlFree(axisName);
+          return MS_FAILURE;
+        }
+        axis->name = msStrdup(axisName);
+        msWCSInsertAxisObj20(params, axis);
+      }
+      xmlFree(axisName);
+
+      content = (char *)xmlNodeGetContent(child);
+      if (msStringParseInteger(content, &(axis->size)) != MS_SUCCESS) {
+        xmlFree(content);
+        msSetError(MS_WCSERR,
+                   "Value of element 'Size' could not "
+                   "be parsed to a valid integer.",
+                   "msWCSParseRequest20_XMLGetCoverage()");
+        return MS_FAILURE;
+      }
+      xmlFree(content);
+    }
+    else if (EQUAL((char *)child->name, "Resolution")) {
+      wcs20AxisObjPtr axis;
+      char *axisName;
+      char *content;
+
+      if (NULL ==
+          (axisName = (char *)xmlGetProp(child, BAD_CAST "dimension"))) {
+        msSetError(MS_WCSERR,
+                   "Attribute 'dimension' is missing "
+                   "in element 'Resolution'.",
+                   "msWCSParseRequest20_XMLGetCoverage()");
+        return MS_FAILURE;
+      }
+
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
+          xmlFree(axisName);
+          return MS_FAILURE;
+        }
+        axis->name = msStrdup(axisName);
+        msWCSInsertAxisObj20(params, axis);
+      }
+      xmlFree(axisName);
+
+      axis->resolutionUOM = (char *)xmlGetProp(child, BAD_CAST "uom");
+
+      content = (char *)xmlNodeGetContent(child);
+      if (msStringParseDouble(content, &(axis->resolution)) != MS_SUCCESS) {
+        msSetError(MS_WCSERR,
+                   "Value of element 'Resolution' could not "
+                   "be parsed to a valid value.",
+                   "msWCSParseRequest20_XMLGetCoverage()");
+        xmlFree(content);
+        return MS_FAILURE;
+      }
+      xmlFree(content);
+    }
+    else if (EQUAL((char *)child->name, "Interpolation")) {
+      /* Deprecated, use wcs:Extension/int:Interpolation/int:globalInterpolation
+       */
+      msFree(params->interpolation);
+      params->interpolation = (char *)xmlNodeGetContent(child);
+    }
+    else if (EQUAL((char *)child->name, "OutputCRS")) {
+      params->outputcrs = (char *)xmlNodeGetContent(child);
+    }
+    else if (EQUAL((char *)child->name, "rangeSubset")) {
+      /* Deprecated, use wcs:Extension/rsub:RangeSubset */
+      xmlNodePtr bandNode = NULL;
+      XML_FOREACH_CHILD(child, bandNode) {
+        char *content = NULL;
+        XML_LOOP_IGNORE_COMMENT_OR_TEXT(bandNode);
+        XML_ASSERT_NODE_NAME(bandNode, "band");
+
+        content = (char *)xmlNodeGetContent(bandNode);
+        params->range_subset = CSLAddString(params->range_subset, content);
+        xmlFree(content);
+      }
+    }
+    else if (EQUAL((char *)child->name, "Extension")) {
+      xmlNodePtr extensionNode = NULL;
+      XML_FOREACH_CHILD(child, extensionNode) {
+        XML_LOOP_IGNORE_COMMENT_OR_TEXT(extensionNode);
+
+        if (EQUAL((char *)extensionNode->name, "Scaling")) {
+          xmlNodePtr scaleMethodNode =
+              msLibXml2GetFirstChildElement(extensionNode);
+
+          if (EQUAL((char *)scaleMethodNode->name, "ScaleByFactor")) {
+            xmlNodePtr scaleFactorNode =
+                msLibXml2GetFirstChildElement(scaleMethodNode);
+            char *content;
+            if (!scaleFactorNode ||
+                !EQUAL((char *)scaleFactorNode->name, "scaleFactor")) {
+              msSetError(MS_WCSERR, "Missing 'scaleFactor' node.",
+                         "msWCSParseRequest20_XMLGetCoverage()");
+              return MS_FAILURE;
+            }
+            content = (char *)xmlNodeGetContent(scaleFactorNode);
+            if (msStringParseDouble(content, &(params->scale)) != MS_SUCCESS ||
+                params->scale < 0.0) {
+              msSetError(MS_WCSERR, "Invalid scaleFactor '%s'.",
+                         "msWCSParseRequest20_XMLGetCoverage()", content);
+              xmlFree(content);
+              return MS_FAILURE;
+            }
+            xmlFree(content);
+          }
+
+          else if (EQUAL((char *)scaleMethodNode->name, "ScaleAxesByFactor")) {
+            xmlNodePtr scaleAxisNode, axisNode, scaleFactorNode;
+            char *axisName, *content;
+            wcs20AxisObjPtr axis;
+
+            XML_FOREACH_CHILD(scaleMethodNode, scaleAxisNode) {
+              XML_LOOP_IGNORE_COMMENT_OR_TEXT(scaleAxisNode);
+
+              if (!EQUAL((char *)scaleAxisNode->name, "ScaleAxis")) {
+                msSetError(MS_WCSERR, "Invalid ScaleAxesByFactor.",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              /* axis */
+              if (NULL ==
+                  (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
+                msSetError(MS_WCSERR, "Missing axis node",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+              axisName = (char *)xmlNodeGetContent(axisNode);
+              if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+                if (NULL == (axis = msWCSCreateAxisObj20())) {
+                  xmlFree(axisName);
+                  return MS_FAILURE;
+                }
+                axis->name = msStrdup(axisName);
+                msWCSInsertAxisObj20(params, axis);
+              }
+              xmlFree(axisName);
+
+              if (axis->scale != MS_WCS20_UNBOUNDED) {
+                msSetError(MS_WCSERR,
+                           "scaleFactor was already set for axis '%s'.",
+                           "msWCSParseRequest20_XMLGetCoverage()", axis->name);
+                return MS_FAILURE;
+              }
+
+              /* scaleFactor */
+              if (NULL == (scaleFactorNode = msLibXml2GetFirstChild(
+                               scaleAxisNode, "scaleFactor"))) {
+                msSetError(MS_WCSERR, "Missing scaleFactor node",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              content = (char *)xmlNodeGetContent(scaleFactorNode);
+              if (msStringParseDouble(content, &(axis->scale)) != MS_SUCCESS ||
+                  axis->scale < 0.0) {
+                msSetError(MS_WCSERR, "Invalid scaleFactor '%s'.",
+                           "msWCSParseRequest20_XMLGetCoverage()", content);
+                xmlFree(content);
+                return MS_FAILURE;
+              }
+              xmlFree(content);
+            }
+          }
+
+          else if (EQUAL((char *)scaleMethodNode->name, "ScaleToSize")) {
+            xmlNodePtr scaleAxisNode, axisNode, targetSizeNode;
+            char *axisName, *content;
+            wcs20AxisObjPtr axis;
+
+            XML_FOREACH_CHILD(scaleMethodNode, scaleAxisNode) {
+              XML_LOOP_IGNORE_COMMENT_OR_TEXT(scaleAxisNode);
+
+              if (!EQUAL((char *)scaleAxisNode->name, "TargetAxisSize")) {
+                msSetError(MS_WCSERR, "Invalid ScaleToSize.",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              /* axis */
+              if (NULL ==
+                  (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
+                msSetError(MS_WCSERR, "Missing axis node",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+              axisName = (char *)xmlNodeGetContent(axisNode);
+              if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+                if (NULL == (axis = msWCSCreateAxisObj20())) {
+                  xmlFree(axisName);
+                  return MS_FAILURE;
+                }
+                axis->name = msStrdup(axisName);
+                msWCSInsertAxisObj20(params, axis);
+              }
+              xmlFree(axisName);
+
+              if (axis->size != 0) {
+                msSetError(MS_WCSERR,
+                           "targetSize was already set for axis '%s'.",
+                           "msWCSParseRequest20_XMLGetCoverage()", axis->name);
+                return MS_FAILURE;
+              }
+
+              /* targetSize */
+              if (NULL == (targetSizeNode = msLibXml2GetFirstChild(
+                               scaleAxisNode, "targetSize"))) {
+                msSetError(MS_WCSERR, "Missing targetSize node",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              content = (char *)xmlNodeGetContent(targetSizeNode);
+              if (msStringParseInteger(content, &(axis->size)) != MS_SUCCESS ||
+                  axis->size <= 0) {
+                msSetError(MS_WCSERR, "Invalid targetSize '%s'.",
+                           "msWCSParseRequest20_XMLGetCoverage()", content);
+                xmlFree(content);
+                return MS_FAILURE;
+              }
+              xmlFree(content);
+            }
+          }
+
+          else if (EQUAL((char *)scaleMethodNode->name, "ScaleToExtent")) {
+            xmlNodePtr scaleAxisNode, axisNode, lowNode, highNode;
+            char *axisName, *content;
+            wcs20AxisObjPtr axis;
+            int low, high;
+
+            XML_FOREACH_CHILD(scaleMethodNode, scaleAxisNode) {
+              XML_LOOP_IGNORE_COMMENT_OR_TEXT(scaleAxisNode);
+
+              if (!EQUAL((char *)scaleAxisNode->name, "TargetAxisExtent")) {
+                msSetError(MS_WCSERR, "Invalid ScaleToExtent.",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              /* axis */
+              if (NULL ==
+                  (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
+                msSetError(MS_WCSERR, "Missing axis node",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+              axisName = (char *)xmlNodeGetContent(axisNode);
+              if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+                if (NULL == (axis = msWCSCreateAxisObj20())) {
+                  xmlFree(axisName);
+                  return MS_FAILURE;
+                }
+                axis->name = msStrdup(axisName);
+                msWCSInsertAxisObj20(params, axis);
+              }
+              xmlFree(axisName);
+
+              if (axis->size != 0) {
+                msSetError(MS_WCSERR,
+                           "targetSize was already set for axis '%s'.",
+                           "msWCSParseRequest20_XMLGetCoverage()", axis->name);
+                return MS_FAILURE;
+              }
+
+              /* targetSize */
+              if (NULL ==
+                  (lowNode = msLibXml2GetFirstChild(scaleAxisNode, "low"))) {
+                msSetError(MS_WCSERR, "Missing low node",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              if (NULL ==
+                  (highNode = msLibXml2GetFirstChild(scaleAxisNode, "high"))) {
+                msSetError(MS_WCSERR, "Missing high node",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              content = (char *)xmlNodeGetContent(lowNode);
+              if (msStringParseInteger(content, &low) != MS_SUCCESS) {
+                msSetError(MS_WCSERR, "Invalid low value '%s'.",
+                           "msWCSParseRequest20_XMLGetCoverage()", content);
+                xmlFree(content);
+                return MS_FAILURE;
+              }
+              xmlFree(content);
+
+              content = (char *)xmlNodeGetContent(highNode);
+              if (msStringParseInteger(content, &high) != MS_SUCCESS) {
+                msSetError(MS_WCSERR, "Invalid high value '%s'.",
+                           "msWCSParseRequest20_XMLGetCoverage()", content);
+                xmlFree(content);
+                return MS_FAILURE;
+              }
+              xmlFree(content);
+
+              if (high <= low) {
+                msSetError(MS_WCSERR, "Invalid extent, high is lower than low.",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              axis->size = high - low;
+            }
+          }
+        }
+
+        /* Range Subset */
+        else if (EQUAL((char *)extensionNode->name, "RangeSubset")) {
+          xmlNodePtr rangeItemNode = NULL;
+
+          XML_FOREACH_CHILD(extensionNode, rangeItemNode) {
+            xmlNodePtr rangeItemNodeChild =
+                msLibXml2GetFirstChildElement(rangeItemNode);
+            XML_LOOP_IGNORE_COMMENT_OR_TEXT(rangeItemNode);
+
+            XML_ASSERT_NODE_NAME(rangeItemNode, "RangeItem");
+
+            if (!rangeItemNodeChild) {
+              msSetError(MS_WCSERR, "Missing RangeComponent or RangeInterval.",
+                         "msWCSParseRequest20_XMLGetCoverage()");
+              return MS_FAILURE;
+            } else if (EQUAL((char *)rangeItemNodeChild->name,
+                             "RangeComponent")) {
+              char *content = (char *)xmlNodeGetContent(rangeItemNodeChild);
+              params->range_subset =
+                  CSLAddString(params->range_subset, content);
+              xmlFree(content);
+            } else if (EQUAL((char *)rangeItemNodeChild->name,
+                             "RangeInterval")) {
+              xmlNodePtr intervalNode = rangeItemNodeChild;
+              xmlNodePtr startComponentNode =
+                  msLibXml2GetFirstChild(intervalNode, "startComponent");
+              xmlNodePtr endComponentNode =
+                  msLibXml2GetFirstChild(intervalNode, "endComponent");
+              char *start;
+              char *stop;
+
+              if (!startComponentNode || !endComponentNode) {
+                msSetError(MS_WCSERR, "Wrong RangeInterval.",
+                           "msWCSParseRequest20_XMLGetCoverage()");
+                return MS_FAILURE;
+              }
+
+              start = (char *)xmlNodeGetContent(startComponentNode);
+              stop = (char *)xmlNodeGetContent(endComponentNode);
+
+              std::string value(start);
+              value += ':';
+              value += stop;
+
+              xmlFree(start);
+              xmlFree(stop);
+
+              params->range_subset =
+                  CSLAddString(params->range_subset, value.c_str());
+            }
+          }
+        }
+
+        else if (EQUAL((char *)extensionNode->name, "subsettingCrs")) {
+          msFree(params->subsetcrs);
+          params->subsetcrs = (char *)xmlNodeGetContent(extensionNode);
+        }
+
+        else if (EQUAL((char *)extensionNode->name, "outputCrs")) {
+          msFree(params->outputcrs);
+          params->outputcrs = (char *)xmlNodeGetContent(extensionNode);
+        }
+
+        else if (EQUAL((char *)extensionNode->name, "Interpolation")) {
+          xmlNodePtr globalInterpolation =
+              msLibXml2GetFirstChild(extensionNode, "globalInterpolation");
+          char *content;
+          if (globalInterpolation == NULL) {
+            msSetError(MS_WCSERR, "Missing 'globalInterpolation' node.",
+                       "msWCSParseRequest20_XMLGetCoverage()");
+            return MS_FAILURE;
+          }
+          content = (char *)xmlNodeGetContent(globalInterpolation);
+          msFree(params->interpolation);
+          /* TODO: use URIs/URLs once they are specified */
+          params->interpolation = msStrdup(content);
+          xmlFree(content);
+        }
+
+        /* GeoTIFF parameters */
+        else if (EQUAL((char *)extensionNode->name, "parameters") &&
+                 extensionNode->ns &&
+                 EQUAL((char *)extensionNode->ns->href,
+                       "http://www.opengis.net/gmlcov/geotiff/1.0")) {
+
+          xmlNodePtr parameter;
+
+          XML_FOREACH_CHILD(extensionNode, parameter) {
+            char *content;
+            XML_LOOP_IGNORE_COMMENT_OR_TEXT(parameter);
+
+            content = (char *)xmlNodeGetContent(parameter);
+
+            params->format_options = CSLAddNameValue(
+                params->format_options, (char *)parameter->name, content);
+            xmlFree(content);
+          }
+        }
+      }
+    }
+    else {
+      XML_UNKNOWN_NODE_ERROR(child);
+    }
+  }
+  return MS_SUCCESS;
+}
+#endif
+
+/************************************************************************/
+/*                   msWCSParseRequest20()                              */
+/*                                                                      */
+/*      Parses a CGI-request to a WCS 20 params object. It is           */
+/*      either a POST or a GET request. In case of a POST request       */
+/*      the xml content has to be parsed to a DOM structure             */
+/*      before the parameters can be extracted.                         */
+/************************************************************************/
+
+int msWCSParseRequest20(mapObj *map, cgiRequestObj *request,
+                        owsRequestObj *ows_request, wcs20ParamsObjPtr params) {
+  int i;
+  if (params == NULL || request == NULL || ows_request == NULL) {
+    msSetError(MS_WCSERR, "Internal error.", "msWCSParseRequest20()");
+    return MS_FAILURE;
+  }
+
+  /* Copy arbitrary service, version and request. */
+  params->service = msStrdup(ows_request->service);
+  if (ows_request->version != NULL) {
+    params->version = msStrdup(ows_request->version);
+  }
+  params->request = msStrdup(ows_request->request);
+
+  /* Parse the POST request */
+  if (request->type == MS_POST_REQUEST) {
+#if defined(USE_LIBXML2)
+    xmlDocPtr doc = static_cast<xmlDocPtr>(ows_request->document);
+    xmlNodePtr root = NULL;
+    const char *validate;
+    int ret = MS_SUCCESS;
+
+    /* parse to DOM-Structure and get root element */
+    if (doc == NULL) {
+      const xmlError *error = xmlGetLastError();
+      msSetError(MS_WCSERR, "XML parsing error: %s", "msWCSParseRequest20()",
+                 error->message);
+      return MS_FAILURE;
+    }
+
+    root = xmlDocGetRootElement(doc);
+
+    validate = msOWSLookupMetadata(&(map->web.metadata), "CO", "validate_xml");
+    if (validate != NULL && EQUAL(validate, "TRUE")) {
+      char *schema_dir = msStrdup(
+          msOWSLookupMetadata(&(map->web.metadata), "CO", "schemas_dir"));
+      if (schema_dir != NULL &&
+          (params->version == NULL || EQUALN(params->version, "2.0", 3))) {
+        schema_dir = msStringConcatenate(schema_dir, "wcs/2.0.0/wcsAll.xsd");
+        if (msOWSSchemaValidation(schema_dir, request->postrequest) != 0) {
+          msSetError(MS_WCSERR,
+                     "Invalid POST request. "
+                     "XML is not valid",
+                     "msWCSParseRequest20()");
+          return MS_FAILURE;
+        }
+      }
+      msFree(schema_dir);
+    }
+
+    if (EQUAL(params->request, "GetCapabilities")) {
+      ret = msWCSParseRequest20_XMLGetCapabilities(root, params);
+    } else if (params->version != NULL && EQUALN(params->version, "2.0", 3)) {
+      if (EQUAL(params->request, "DescribeCoverage")) {
+        ret = msWCSParseRequest20_XMLDescribeCoverage(root, params);
+      } else if (EQUAL(params->request, "GetCoverage")) {
+        ret = msWCSParseRequest20_XMLGetCoverage(map, root, params);
+      }
+    }
+    return ret;
+
+#else  /* defined(USE_LIBXML2) */
+    /* TODO: maybe with CPLXML? */
+    return MS_FAILURE;
+#endif /* defined(USE_LIBXML2) */
+  }
+
+  /* Parse the KVP GET request */
+  for (i = 0; i < request->NumParams; ++i) {
+    char *key = NULL, *value = NULL;
+    char **tokens;
+    int num, j;
+    key = request->ParamNames[i];
+    value = request->ParamValues[i];
+
+    if (EQUAL(key, "VERSION")) {
+      continue;
+    } else if (EQUAL(key, "REQUEST")) {
+      continue;
+    } else if (EQUAL(key, "SERVICE")) {
+      continue;
+    } else if (EQUAL(key, "ACCEPTVERSIONS")) {
+      tokens = msStringSplit(value, ',', &num);
+      for (j = 0; j < num; ++j) {
+        params->accept_versions =
+            CSLAddString(params->accept_versions, tokens[j]);
+      }
+      msFreeCharArray(tokens, num);
+    } else if (EQUAL(key, "SECTIONS")) {
+      tokens = msStringSplit(value, ',', &num);
+      for (j = 0; j < num; ++j) {
+        params->sections = CSLAddString(params->sections, tokens[j]);
+      }
+      msFreeCharArray(tokens, num);
+    } else if (EQUAL(key, "UPDATESEQUENCE")) {
+      msFree(params->updatesequence);
+      params->updatesequence = msStrdup(value);
+    } else if (EQUAL(key, "ACCEPTFORMATS")) {
+      /* ignore */
+    } else if (EQUAL(key, "ACCEPTLANGUAGES")) {
+      if (params->accept_languages != NULL) {
+        CSLDestroy(params->accept_languages);
+      }
+      params->accept_languages = CSLTokenizeString2(value, ",", 0);
+    } else if (EQUAL(key, "COVERAGEID")) {
+      if (params->ids != NULL) {
+        msSetError(MS_WCSERR,
+                   "Parameter 'CoverageID' is already set. "
+                   "For multiple IDs use a comma separated list.",
+                   "msWCSParseRequest20()");
+        return MS_FAILURE;
+      }
+      params->ids = CSLTokenizeString2(value, ",", 0);
+    } else if (EQUAL(key, "FORMAT")) {
+      msFree(params->format);
+      params->format = msStrdup(value);
+    } else if (EQUAL(key, "MEDIATYPE")) {
+      if (EQUAL(value, "multipart/mixed") ||
+          EQUAL(value, "multipart/related")) {
+        params->multipart = MS_TRUE;
+      } else {
+        msSetError(MS_WCSERR, "Invalid value '%s' for parameter 'Mediatype'.",
+                   "msWCSParseRequest20()", value);
+        return MS_FAILURE;
+      }
+    } else if (EQUAL(key, "INTERPOLATION")) {
+      msFree(params->interpolation);
+      params->interpolation = msStrdup(value);
+    } else if (EQUAL(key, "OUTPUTCRS")) {
+      msFree(params->outputcrs);
+      params->outputcrs = msStrdup(value);
+    } else if (EQUAL(key, "SUBSETTINGCRS")) {
+      msFree(params->subsetcrs);
+      params->subsetcrs = msStrdup(value);
+    } else if (EQUAL(key, "SCALEFACTOR")) {
+      double scale = MS_WCS20_UNBOUNDED;
+      if (params->scale != MS_WCS20_UNBOUNDED) {
+        msSetError(MS_WCSERR, "Parameter 'SCALEFACTOR' already set.",
+                   "msWCSParseRequest20()");
+        return MS_FAILURE;
+      } else if (msStringParseDouble(value, &scale) != MS_SUCCESS) {
+        msSetError(MS_WCSERR, "Could not parse parameter 'SCALEFACTOR'.",
+                   "msWCSParseRequest20()");
+        return MS_FAILURE;
+      } else if (scale <= 0.0) {
+        msSetError(MS_WCSERR, "Invalid value for 'SCALEFACTOR'.",
+                   "msWCSParseRequest20()");
+        return MS_FAILURE;
+      }
+      params->scale = scale;
+    } else if (EQUAL(key, "SCALEAXES")) {
+      wcs20AxisObjPtr axis = NULL;
+      tokens = msStringSplit(value, ',', &num);
+      for (j = 0; j < num; ++j) {
+        char axisName[500];
+        double scale;
+
+        if (msWCSParseScaleString20(tokens[j], axisName, sizeof(axisName),
+                                    &scale) != MS_SUCCESS) {
+          msFreeCharArray(tokens, num);
+          return MS_FAILURE;
+        }
+
+        if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+          if (NULL == (axis = msWCSCreateAxisObj20())) {
+            msFreeCharArray(tokens, num);
+            return MS_FAILURE;
+          }
+          axis->name = msStrdup(axisName);
+          msWCSInsertAxisObj20(params, axis);
+        }
+
+        /* check if the size of the axis is already set */
+        if (axis->scale != MS_WCS20_UNBOUNDED) {
+          msFreeCharArray(tokens, num);
+          msSetError(MS_WCSERR, "The scale of the axis is already set.",
+                     "msWCSParseRequest20()");
+          return MS_FAILURE;
+        }
+        axis->scale = scale;
+      }
+      msFreeCharArray(tokens, num);
+    } else if (EQUAL(key, "SCALESIZE")) {
+      wcs20AxisObjPtr axis = NULL;
+      tokens = msStringSplit(value, ',', &num);
+      for (j = 0; j < num; ++j) {
+        char axisName[500];
+        int size;
+
+        if (msWCSParseSizeString20(tokens[j], axisName, sizeof(axisName),
+                                   &size) != MS_SUCCESS) {
+          msFreeCharArray(tokens, num);
+          return MS_FAILURE;
+        }
+
+        if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+          if (NULL == (axis = msWCSCreateAxisObj20())) {
+            msFreeCharArray(tokens, num);
+            return MS_FAILURE;
+          }
+          axis->name = msStrdup(axisName);
+          msWCSInsertAxisObj20(params, axis);
+        }
+
+        /* check if the size of the axis is already set */
+        if (axis->size != 0) {
+          msFreeCharArray(tokens, num);
+          msSetError(MS_WCSERR, "The size of the axis is already set.",
+                     "msWCSParseRequest20()");
+          return MS_FAILURE;
+        }
+        axis->size = size;
+      }
+      msFreeCharArray(tokens, num);
+    } else if (EQUAL(key, "SCALEEXTENT")) {
+      wcs20AxisObjPtr axis = NULL;
+      /* No real support for scaleextent, we just interprete it as SCALESIZE */
+      tokens = msStringSplit(value, ',', &num);
+      for (j = 0; j < num; ++j) {
+        char axisName[500];
+        int min, max;
+
+        if (msWCSParseScaleExtentString20(tokens[j], axisName, sizeof(axisName),
+                                          &min, &max) != MS_SUCCESS) {
+          msFreeCharArray(tokens, num);
+          return MS_FAILURE;
+        }
+
+        if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+          if (NULL == (axis = msWCSCreateAxisObj20())) {
+            msFreeCharArray(tokens, num);
+            return MS_FAILURE;
+          }
+          axis->name = msStrdup(axisName);
+          msWCSInsertAxisObj20(params, axis);
+        }
+
+        /* check if the size of the axis is already set */
+        if (axis->size != 0) {
+          msFreeCharArray(tokens, num);
+          msSetError(MS_WCSERR, "The size of the axis is already set.",
+                     "msWCSParseRequest20()");
+          return MS_FAILURE;
+        }
+        axis->size = max - min;
+      }
+      msFreeCharArray(tokens, num);
+      /* We explicitly don't test for strict equality as the parameter name is
+       * supposed to be unique */
+    } else if (EQUALN(key, "SIZE", 4)) {
+      /* Deprecated scaling */
+      wcs20AxisObjPtr axis = NULL;
+      char axisName[500];
+      int size = 0;
+
+      if (msWCSParseSizeString20(value, axisName, sizeof(axisName), &size) ==
+          MS_FAILURE) {
+        return MS_FAILURE;
+      }
+
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
+          return MS_FAILURE;
+        }
+        axis->name = msStrdup(axisName);
+        msWCSInsertAxisObj20(params, axis);
+      }
+
+      /* check if the size of the axis is already set */
+      if (axis->size != 0) {
+        msSetError(MS_WCSERR, "The size of the axis is already set.",
+                   "msWCSParseRequest20()");
+        return MS_FAILURE;
+      }
+      axis->size = size;
+      /* We explicitly don't test for strict equality as the parameter name is
+       * supposed to be unique */
+    } else if (EQUALN(key, "RESOLUTION", 10)) {
+      wcs20AxisObjPtr axis = NULL;
+      char axisName[500];
+      double resolution = 0;
+
+      if (msWCSParseResolutionString20(value, axisName, sizeof(axisName),
+                                       &resolution) == MS_FAILURE) {
+        return MS_FAILURE;
+      }
+
+      /* check if axis object already exists, otherwise create a new one */
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
+          return MS_FAILURE;
+        }
+        axis->name = msStrdup(axisName);
+        msWCSInsertAxisObj20(params, axis);
+      }
+
+      /* check if the resolution of the axis is already set */
+      if (axis->resolution != MS_WCS20_UNBOUNDED) {
+        msSetError(MS_WCSERR, "The resolution of the axis is already set.",
+                   "msWCSParseRequest20()");
+        return MS_FAILURE;
+      }
+      axis->resolution = resolution;
+      /* We explicitly don't test for strict equality as the parameter name is
+       * supposed to be unique */
+    } else if (EQUALN(key, "SUBSET", 6)) {
+      wcs20AxisObjPtr axis = NULL;
+      wcs20SubsetObjPtr subset = msWCSCreateSubsetObj20();
+      if (NULL == subset) {
+        return MS_FAILURE;
+      }
+      if (msWCSParseSubsetKVPString20(subset, value) == MS_FAILURE) {
+        msWCSFreeSubsetObj20(subset);
+        msWCSException(map, "InvalidSubsetting", "subset",
+                       ows_request->version);
+        return MS_DONE;
+      }
+
+      if (NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
+          return MS_FAILURE;
+        }
+        axis->name = msStrdup(subset->axis);
+        msWCSInsertAxisObj20(params, axis);
+      }
+
+      if (NULL != axis->subset) {
+        msSetError(MS_WCSERR, "The axis '%s' is already subsetted.",
+                   "msWCSParseRequest20()", axis->name);
+        msWCSFreeSubsetObj20(subset);
+        msWCSException(map, "InvalidAxisLabel", "subset", ows_request->version);
+        return MS_DONE;
+      }
+      axis->subset = subset;
+    } else if (EQUAL(key, "RANGESUBSET")) {
+      tokens = msStringSplit(value, ',', &num);
+      for (j = 0; j < num; ++j) {
+        params->range_subset = CSLAddString(params->range_subset, tokens[j]);
+      }
+      msFreeCharArray(tokens, num);
+    } else if (EQUALN(key, "GEOTIFF:", 8)) {
+      params->format_options =
+          CSLAddNameValue(params->format_options, key, value);
+    }
+    /* Ignore all other parameters here */
+  }
+
+  return MS_SUCCESS;
+}
+
+#if defined(USE_LIBXML2)
+
+/************************************************************************/
+/*                   msWCSValidateAndFindSubsets20()                    */
+/*                                                                      */
+/*      Iterates over every axis in the parameters and checks if the    */
+/*      axis name is in any string list. If found, but there already is */
+/*      a sample found for this axis, an Error is returned. Also if no  */
+/*      axis is found for a given axis, an error is returned.           */
+/************************************************************************/
+static int msWCSValidateAndFindAxes20(wcs20ParamsObjPtr params,
+                                      wcs20AxisObjPtr outAxes[]) {
+  static const int numAxis = 2;
+  const char *const validXAxisNames[] = {
+      "x",         "xaxis", "x-axis",   "x_axis",   "long", "long_axis",
+      "long-axis", "lon",   "lon_axis", "lon-axis", NULL};
+  const char *const validYAxisNames[] = {
+      "y", "yaxis", "y-axis", "y_axis", "lat", "lat_axis", "lat-axis", NULL};
+  const char *const *const validAxisNames[2] = {validXAxisNames,
+                                                validYAxisNames};
+  int iParamAxis, iAcceptedAxis, iName, i;
+
+  for (i = 0; i < numAxis; ++i) {
+    outAxes[i] = NULL;
+  }
+
+  /* iterate over all subsets */
+  for (iParamAxis = 0; iParamAxis < params->numaxes; ++iParamAxis) {
+    int found = 0;
+
+    /* iterate over all given axes */
+    for (iAcceptedAxis = 0; iAcceptedAxis < numAxis; ++iAcceptedAxis) {
+      /* iterate over all possible names for the current axis */
+      for (iName = 0; validAxisNames[iAcceptedAxis][iName] != NULL; ++iName) {
+        /* compare axis name with current possible name */
+        if (EQUAL(params->axes[iParamAxis]->name,
+                  validAxisNames[iAcceptedAxis][iName])) {
+          /* if there is already a sample for the axis, throw error */
+          if (outAxes[iAcceptedAxis] != NULL) {
+            msSetError(MS_WCSERR,
+                       "The axis with the name '%s' corresponds "
+                       "to the same axis as the subset with the name '%s'.",
+                       "msWCSValidateAndFindAxes20()",
+                       outAxes[iAcceptedAxis]->name,
+                       params->axes[iParamAxis]->name);
+            return MS_FAILURE;
+          }
+
+          /* if match is found, save it */
+          outAxes[iAcceptedAxis] = params->axes[iParamAxis];
+          found = 1;
+          break;
+        }
+      }
+      if (found) {
+        break;
+      }
+    }
+
+    /* no valid representation for current subset found */
+    /* exit and throw error                             */
+    if (found == 0) {
+      msSetError(MS_WCSERR, "Invalid subset axis '%s'.",
+                 "msWCSValidateAndFindAxes20()",
+                 params->axes[iParamAxis]->name);
+      return MS_FAILURE;
+    }
+  }
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSPrepareNamespaces20()                         */
+/*                                                                      */
+/*      Inserts namespace definitions into the root node of a DOM       */
+/*      structure.                                                      */
+/************************************************************************/
+
+static void msWCSPrepareNamespaces20(xmlDocPtr pDoc, xmlNodePtr psRootNode,
+                                     mapObj *map, int addInspire) {
+  xmlNsPtr psXsiNs;
+  char *schemaLocation = NULL;
+  char *xsi_schemaLocation = NULL;
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX));
+
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_SWE_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
+
+  if (addInspire) {
+    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI,
+             BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
+    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI,
+             BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
+  }
+
+  psXsiNs = xmlSearchNs(pDoc, psRootNode,
+                        BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+
+  schemaLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WCS_20_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
+  xsi_schemaLocation = msStringConcatenate(
+      xsi_schemaLocation, MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+
+  if (addInspire) {
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                             MS_INSPIRE_DLS_NAMESPACE_URI " ");
+    xsi_schemaLocation = msStringConcatenate(
+        xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
+    xsi_schemaLocation =
+        msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
+  }
+
+  xmlNewNsProp(psRootNode, psXsiNs, BAD_CAST "schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+
+  msFree(schemaLocation);
+  msFree(xsi_schemaLocation);
+}
+
+/************************************************************************/
+/*                   msWCSGetFormatList20()                             */
+/*                                                                      */
+/*      Copied from mapwcs.c.                                           */
+/************************************************************************/
+
+static char *msWCSGetFormatsList20(mapObj *map, layerObj *layer) {
+  char *format_list = msStrdup("");
+  char **tokens = NULL, **formats = NULL;
+  int i, numtokens = 0, numformats;
+  char *value;
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse from layer metadata.                                      */
+  /* -------------------------------------------------------------------- */
+  if (layer != NULL &&
+      (value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "formats",
+                                      NULL)) != NULL) {
+    tokens = msStringSplit(value, ' ', &numtokens);
+    msFree(value);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse from map.web metadata.                                    */
+  /* -------------------------------------------------------------------- */
+  else if ((value = msOWSGetEncodeMetadata(&(map->web.metadata), "CO",
+                                           "formats", NULL)) != NULL) {
+    tokens = msStringSplit(value, ' ', &numtokens);
+    msFree(value);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Or generate from all configured raster output formats that      */
+  /*      look plausible.                                                 */
+  /* -------------------------------------------------------------------- */
+  else {
+    tokens = (char **)msSmallCalloc(map->numoutputformats, sizeof(char *));
+    for (i = 0; i < map->numoutputformats; i++) {
+      switch (map->outputformatlist[i]->renderer) {
+        /* seemingly normal raster format */
+      case MS_RENDER_WITH_AGG:
+      case MS_RENDER_WITH_RAWDATA:
+        tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
+        break;
+        /* rest of formats aren't really WCS compatible */
+      default:
+        break;
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Convert outputFormatObj names into mime types and remove        */
+  /*      duplicates.                                                     */
+  /* -------------------------------------------------------------------- */
+  numformats = 0;
+  formats = (char **)msSmallCalloc(sizeof(char *), numtokens);
+
+  for (i = 0; i < numtokens; i++) {
+    int format_i, j;
+    const char *mimetype;
+
+    for (format_i = 0; format_i < map->numoutputformats; format_i++) {
+      if (EQUAL(map->outputformatlist[format_i]->name, tokens[i]))
+        break;
+    }
+
+    if (format_i == map->numoutputformats) {
+      msDebug("Failed to find outputformat info on format '%s', ignore.\n",
+              tokens[i]);
+      continue;
+    }
+
+    mimetype = map->outputformatlist[format_i]->mimetype;
+    if (mimetype == NULL || strlen(mimetype) == 0) {
+      msDebug("No mimetime for format '%s', ignoring.\n", tokens[i]);
+      continue;
+    }
+
+    for (j = 0; j < numformats; j++) {
+      if (EQUAL(mimetype, formats[j]))
+        break;
+    }
+
+    if (j < numformats) {
+      msDebug("Format '%s' ignored since mimetype '%s' duplicates another "
+              "outputFormatObj.\n",
+              tokens[i], mimetype);
+      continue;
+    }
+
+    formats[numformats++] = msStrdup(mimetype);
+  }
+
+  msFreeCharArray(tokens, numtokens);
+
+  /* -------------------------------------------------------------------- */
+  /*      Turn mimetype list into comma delimited form for easy use       */
+  /*      with xml functions.                                             */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < numformats; i++) {
+    if (i > 0) {
+      format_list = msStringConcatenate(format_list, (char *)",");
+    }
+    format_list = msStringConcatenate(format_list, formats[i]);
+  }
+  msFreeCharArray(formats, numformats);
+
+  return format_list;
+}
+
+/************************************************************************/
+/*                   msWCSSwapAxes20                                    */
+/*                                                                      */
+/*      Helper function to determine if a SRS mandates swapped axes.    */
+/************************************************************************/
+
+static int msWCSSwapAxes20(char *srs_uri) {
+  int srid = 0;
+
+  /* get SRID from the srs uri */
+  if (srs_uri != NULL && strlen(srs_uri) > 0) {
+    if (sscanf(srs_uri, "http://www.opengis.net/def/crs/EPSG/0/%d", &srid) !=
+        EOF)
+      ;
+    else if (sscanf(srs_uri, "http://www.opengis.net/def/crs/%d", &srid) != EOF)
+      ;
+    else
+      srid = 0;
+  }
+  if (srid == 0)
+    return MS_FALSE;
+
+  return msIsAxisInverted(srid);
+}
+
+/************************************************************************/
+/*                   msWCSCommon20_CreateBoundedBy()                    */
+/*                                                                      */
+/*      Inserts the BoundedBy section into an existing DOM structure.   */
+/************************************************************************/
+
+static void msWCSCommon20_CreateBoundedBy(wcs20coverageMetadataObjPtr cm,
+                                          xmlNsPtr psGmlNs, xmlNodePtr psRoot,
+                                          projectionObj *projection,
+                                          int swapAxes) {
+  xmlNodePtr psBoundedBy, psEnvelope;
+  char lowerCorner[100], upperCorner[100], axisLabels[100], uomLabels[100];
+
+  psBoundedBy = xmlNewChild(psRoot, psGmlNs, BAD_CAST "boundedBy", NULL);
+  {
+    psEnvelope = xmlNewChild(psBoundedBy, psGmlNs, BAD_CAST "Envelope", NULL);
+    {
+      xmlNewProp(psEnvelope, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
+
+      if (projection->proj != NULL && msProjIsGeographicCRS(projection)) {
+        if (swapAxes == MS_FALSE) {
+          strlcpy(axisLabels, "long lat", sizeof(axisLabels));
+        } else {
+          strlcpy(axisLabels, "lat long", sizeof(axisLabels));
+        }
+        strlcpy(uomLabels, "deg deg", sizeof(uomLabels));
+      } else {
+        if (swapAxes == MS_FALSE) {
+          strlcpy(axisLabels, "x y", sizeof(axisLabels));
+        } else {
+          strlcpy(axisLabels, "y x", sizeof(axisLabels));
+        }
+        strlcpy(uomLabels, "m m", sizeof(uomLabels));
+      }
+      xmlNewProp(psEnvelope, BAD_CAST "axisLabels", BAD_CAST axisLabels);
+      xmlNewProp(psEnvelope, BAD_CAST "uomLabels", BAD_CAST uomLabels);
+      xmlNewProp(psEnvelope, BAD_CAST "srsDimension", BAD_CAST "2");
+
+      if (swapAxes == MS_FALSE) {
+        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g",
+                 cm->extent.minx, cm->extent.miny);
+        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g",
+                 cm->extent.maxx, cm->extent.maxy);
+      } else {
+        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g",
+                 cm->extent.miny, cm->extent.minx);
+        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g",
+                 cm->extent.maxy, cm->extent.maxx);
+      }
+
+      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "lowerCorner",
+                  BAD_CAST lowerCorner);
+      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "upperCorner",
+                  BAD_CAST upperCorner);
+    }
+  }
+}
+
+/************************************************************************/
+/*                   msWCSCommon20_CreateDomainSet()                    */
+/*                                                                      */
+/*      Inserts the DomainSet section into an existing DOM structure.   */
+/************************************************************************/
+
+static void msWCSCommon20_CreateDomainSet(layerObj *layer,
+                                          wcs20coverageMetadataObjPtr cm,
+                                          xmlNsPtr psGmlNs, xmlNodePtr psRoot,
+                                          projectionObj *projection,
+                                          int swapAxes) {
+  xmlNodePtr psDomainSet, psGrid, psLimits, psGridEnvelope, psOrigin, psOffsetX,
+      psOffsetY;
+  char low[100], high[100], id[100], point[100];
+  char offsetVector1[100], offsetVector2[100], axisLabels[100];
+
+  psDomainSet = xmlNewChild(psRoot, psGmlNs, BAD_CAST "domainSet", NULL);
+  {
+    psGrid = xmlNewChild(psDomainSet, psGmlNs, BAD_CAST "RectifiedGrid", NULL);
+    {
+      double x0 = cm->geotransform[0] + cm->geotransform[1] / 2 +
+                  cm->geotransform[2] / 2;
+      double y0 = cm->geotransform[3] + cm->geotransform[4] / 2 +
+                  cm->geotransform[5] / 2;
+      double resx = cm->geotransform[1];
+      double resy = cm->geotransform[5];
+
+      xmlNewProp(psGrid, BAD_CAST "dimension", BAD_CAST "2");
+      snprintf(id, sizeof(id), "grid_%s", layer->name);
+      xmlNewNsProp(psGrid, psGmlNs, BAD_CAST "id", BAD_CAST id);
+
+      psLimits = xmlNewChild(psGrid, psGmlNs, BAD_CAST "limits", NULL);
+      {
+        psGridEnvelope =
+            xmlNewChild(psLimits, psGmlNs, BAD_CAST "GridEnvelope", NULL);
+        {
+          strlcpy(low, "0 0", sizeof(low));
+          snprintf(high, sizeof(high), "%d %d", cm->xsize - 1, cm->ysize - 1);
+
+          xmlNewChild(psGridEnvelope, psGmlNs, BAD_CAST "low", BAD_CAST low);
+          xmlNewChild(psGridEnvelope, psGmlNs, BAD_CAST "high", BAD_CAST high);
+        }
+      }
+
+      if (projection->proj != NULL && msProjIsGeographicCRS(projection)) {
+        strlcpy(axisLabels, "long lat", sizeof(axisLabels));
+      } else {
+        strlcpy(axisLabels, "x y", sizeof(axisLabels));
+      }
+
+      xmlNewChild(psGrid, psGmlNs, BAD_CAST "axisLabels", BAD_CAST axisLabels);
+
+      psOrigin = xmlNewChild(psGrid, psGmlNs, BAD_CAST "origin", NULL);
+      {
+        if (swapAxes == MS_FALSE) {
+          snprintf(point, sizeof(point), "%f %f", x0, y0);
+        } else {
+          snprintf(point, sizeof(point), "%f %f", y0, x0);
+        }
+        psOrigin = xmlNewChild(psOrigin, psGmlNs, BAD_CAST "Point", NULL);
+        snprintf(id, sizeof(id), "grid_origin_%s", layer->name);
+        xmlNewNsProp(psOrigin, psGmlNs, BAD_CAST "id", BAD_CAST id);
+        xmlNewProp(psOrigin, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
+
+        xmlNewChild(psOrigin, psGmlNs, BAD_CAST "pos", BAD_CAST point);
+      }
+
+      if (swapAxes == MS_FALSE) {
+        snprintf(offsetVector1, sizeof(offsetVector1), "%f 0", resx);
+        snprintf(offsetVector2, sizeof(offsetVector2), "0 %f", resy);
+      } else {
+        snprintf(offsetVector1, sizeof(offsetVector1), "0 %f", resx);
+        snprintf(offsetVector2, sizeof(offsetVector2), "%f 0", resy);
+      }
+      psOffsetX = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector",
+                              BAD_CAST offsetVector1);
+      psOffsetY = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector",
+                              BAD_CAST offsetVector2);
+
+      xmlNewProp(psOffsetX, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
+      xmlNewProp(psOffsetY, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
+    }
+  }
+}
+
+/************************************************************************/
+/*                   msWCSCommon20_CreateRangeType()                    */
+/*                                                                      */
+/*      Inserts the RangeType section into an existing DOM structure.   */
+/************************************************************************/
+
+static void msWCSCommon20_CreateRangeType(wcs20coverageMetadataObjPtr cm,
+                                          char *bands, xmlNsPtr psGmlcovNs,
+                                          xmlNsPtr psSweNs, xmlNodePtr psRoot) {
+  xmlNodePtr psRangeType, psDataRecord, psField, psQuantity, psUom,
+      psConstraint, psAllowedValues = NULL, psNilValues = NULL;
+  char **arr = NULL;
+  int num = 0;
+
+  if (NULL != bands) {
+    arr = msStringSplit(bands, ',', &num);
+  }
+
+  psRangeType = xmlNewChild(psRoot, psGmlcovNs, BAD_CAST "rangeType", NULL);
+  psDataRecord = xmlNewChild(psRangeType, psSweNs, BAD_CAST "DataRecord", NULL);
+
+  /* iterate over every band */
+  for (unsigned i = 0; i < cm->numbands; ++i) {
+    /* only add bands that are in the range subset */
+    if (NULL != arr && num > 0) {
+      int found = MS_FALSE, j;
+      for (j = 0; j < num; ++j) {
+        int repr = 0;
+        if (msStringParseInteger(arr[j], &repr) == MS_SUCCESS &&
+            static_cast<unsigned>(repr) == i + 1) {
+          found = MS_TRUE;
+          break;
+        }
+      }
+      if (found == MS_FALSE) {
+        /* ignore this band since it is not in the range subset */
+        continue;
+      }
+    }
+
+    /* add field tag */
+    psField = xmlNewChild(psDataRecord, psSweNs, BAD_CAST "field", NULL);
+
+    if (cm->bands[i].name != NULL) {
+      xmlNewProp(psField, BAD_CAST "name", BAD_CAST cm->bands[i].name);
+    } else {
+      xmlNewProp(psField, BAD_CAST "name", BAD_CAST "band");
+    }
+    /* add Quantity tag */
+    psQuantity = xmlNewChild(psField, psSweNs, BAD_CAST "Quantity", NULL);
+    if (cm->bands[i].definition != NULL) {
+      xmlNewProp(psQuantity, BAD_CAST "definition",
+                 BAD_CAST cm->bands[i].definition);
+    }
+    if (cm->bands[i].description != NULL) {
+      xmlNewChild(psQuantity, psSweNs, BAD_CAST "description",
+                  BAD_CAST cm->bands[i].description);
+    }
+
+    /* if there are given nilvalues -> add them to the first field */
+    /* all other fields get a reference to these */
+    if (cm->numnilvalues > 0) {
+      psNilValues = xmlNewChild(
+          xmlNewChild(psQuantity, psSweNs, BAD_CAST "nilValues", NULL), psSweNs,
+          BAD_CAST "NilValues", NULL);
+      for (unsigned j = 0; j < cm->numnilvalues; ++j) {
+        xmlNodePtr psTemp =
+            xmlNewChild(psNilValues, psSweNs, BAD_CAST "nilValue",
+                        BAD_CAST cm->nilvalues[j]);
+        if (j < cm->numnilvalues)
+          xmlNewProp(psTemp, BAD_CAST "reason",
+                     BAD_CAST cm->nilvalues_reasons[j]);
+      }
+    } else { /* create an empty nilValues tag */
+      xmlNewChild(psQuantity, psSweNs, BAD_CAST "nilValues", NULL);
+    }
+
+    psUom = xmlNewChild(psQuantity, psSweNs, BAD_CAST "uom", NULL);
+    if (cm->bands[i].uom != NULL) {
+      xmlNewProp(psUom, BAD_CAST "code", BAD_CAST cm->bands[i].uom);
+    } else {
+      xmlNewProp(psUom, BAD_CAST "code", BAD_CAST "W.m-2.Sr-1");
+    }
+
+    /* add constraint */
+    psConstraint =
+        xmlNewChild(psQuantity, psSweNs, BAD_CAST "constraint", NULL);
+
+    {
+      char interval[100], significant_figures[100];
+      psAllowedValues =
+          xmlNewChild(psConstraint, psSweNs, BAD_CAST "AllowedValues", NULL);
+
+      /* Interval */
+      snprintf(interval, sizeof(interval), "%.5g %.5g",
+               cm->bands[i].interval_min, cm->bands[i].interval_max);
+      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "interval",
+                  BAD_CAST interval);
+
+      /* Significant figures */
+      snprintf(significant_figures, sizeof(significant_figures), "%d",
+               cm->bands[i].significant_figures);
+      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "significantFigures",
+                  BAD_CAST significant_figures);
+    }
+  }
+  msFreeCharArray(arr, num);
+}
+
+/************************************************************************/
+/*                   msWCSWriteDocument20()                             */
+/*                                                                      */
+/*      Writes out an xml structure to the stream.                      */
+/************************************************************************/
+
+static int msWCSWriteDocument20(xmlDocPtr psDoc) {
+  xmlChar *buffer = NULL;
+  int size = 0;
+  msIOContext *context = NULL;
+  char *contenttype = NULL;
+
+  if (msIO_needBinaryStdout() == MS_FAILURE) {
+    return MS_FAILURE;
+  }
+
+  if (EQUAL((char *)xmlDocGetRootElement(psDoc)->name, "RectifiedGridCoverage"))
+    contenttype = msStrdup("application/gml+xml");
+  else
+    contenttype = msStrdup("text/xml");
+
+  msIO_setHeader("Content-Type", "%s; charset=UTF-8", contenttype);
+  msIO_sendHeaders();
+  msFree(contenttype);
+
+  context = msIO_getHandler(stdout);
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
+  msIO_contextWrite(context, buffer, size);
+  xmlFree(buffer);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSWriteFile20()                                 */
+/*                                                                      */
+/*      Writes an image object to the stream. If multipart is set,      */
+/*      then content sections are inserted.                             */
+/************************************************************************/
+
+static int msWCSWriteFile20(mapObj *map, imageObj *image,
+                            wcs20ParamsObjPtr params, int multipart) {
+  int status;
+  char *filename = NULL;
+  char *base_dir = NULL;
+  const char *fo_filename;
+  int i;
+
+  fo_filename = msGetOutputFormatOption(image->format, "FILENAME", NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*      Fetch the driver we will be using and check if it supports      */
+  /*      VSIL IO.                                                        */
+  /* -------------------------------------------------------------------- */
+  if (EQUALN(image->format->driver, "GDAL/", 5)) {
+    GDALDriverH hDriver;
+    const char *pszExtension = image->format->extension;
+
+    msAcquireLock(TLOCK_GDAL);
+    hDriver = GDALGetDriverByName(image->format->driver + 5);
+    if (hDriver == NULL) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_MISCERR, "Failed to find %s driver.", "msWCSWriteFile20()",
+                 image->format->driver + 5);
+      return msWCSException(map, "NoApplicableCode", "mapserv",
+                            params->version);
+    }
+
+    if (pszExtension == NULL)
+      pszExtension = "img.tmp";
+
+    if (msGDALDriverSupportsVirtualIOOutput(hDriver)) {
+      base_dir = msTmpFile(map, map->mappath, "/vsimem/wcsout", NULL);
+      if (fo_filename)
+        filename = msStrdup(CPLFormFilename(base_dir, fo_filename, NULL));
+      else
+        filename = msStrdup(CPLFormFilename(base_dir, "out", pszExtension));
+
+      /*            CleanVSIDir( "/vsimem/wcsout" ); */
+
+      msReleaseLock(TLOCK_GDAL);
+      status = msSaveImage(map, image, filename);
+      if (status != MS_SUCCESS) {
+        msSetError(MS_MISCERR, "msSaveImage() failed", "msWCSWriteFile20()");
+        return msWCSException20(map, "NoApplicableCode", "mapserv",
+                                params->version);
+      }
+    }
+    msReleaseLock(TLOCK_GDAL);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If we weren't able to write data under /vsimem, then we just    */
+  /*      output a single "stock" filename.                               */
+  /* -------------------------------------------------------------------- */
+  if (filename == NULL) {
+    msOutputFormatResolveFromImage(map, image);
+    if (multipart) {
+      msIO_fprintf(stdout, "\r\n--wcs\r\n");
+      msIO_fprintf(stdout,
+                   "Content-Type: %s\r\n"
+                   "Content-Description: coverage data\r\n"
+                   "Content-Transfer-Encoding: binary\r\n",
+                   MS_IMAGE_MIME_TYPE(map->outputformat));
+
+      if (fo_filename != NULL)
+        msIO_fprintf(stdout,
+                     "Content-ID: coverage/%s\r\n"
+                     "Content-Disposition: INLINE; filename=%s\r\n\r\n",
+                     fo_filename, fo_filename);
+      else
+        msIO_fprintf(stdout,
+                     "Content-ID: coverage/wcs.%s\r\n"
+                     "Content-Disposition: INLINE\r\n\r\n",
+                     MS_IMAGE_EXTENSION(map->outputformat));
+    } else {
+      msIO_setHeader("Content-Type", "%s",
+                     MS_IMAGE_MIME_TYPE(map->outputformat));
+      msIO_setHeader("Content-Description", "coverage data");
+      msIO_setHeader("Content-Transfer-Encoding", "binary");
+
+      if (fo_filename != NULL) {
+        msIO_setHeader("Content-ID", "coverage/%s", fo_filename);
+        msIO_setHeader("Content-Disposition", "INLINE; filename=%s",
+                       fo_filename);
+      } else {
+        msIO_setHeader("Content-ID", "coverage/wcs.%s",
+                       MS_IMAGE_EXTENSION(map->outputformat));
+        msIO_setHeader("Content-Disposition", "INLINE");
+      }
+      msIO_sendHeaders();
+    }
+
+    status = msSaveImage(map, image, NULL);
+    if (status != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "msSaveImage() failed", "msWCSWriteFile20()");
+      return msWCSException(map, "NoApplicableCode", "mapserv",
+                            params->version);
+    }
+    if (multipart)
+      msIO_fprintf(stdout, "\r\n--wcs--\r\n");
+    return MS_SUCCESS;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      When potentially listing multiple files, we take great care     */
+  /*      to identify the "primary" file and list it first.  In fact      */
+  /*      it is the only file listed in the coverages document.           */
+  /* -------------------------------------------------------------------- */
+  {
+    char **all_files = CPLReadDir(base_dir);
+    int count = CSLCount(all_files);
+
+    if (msIO_needBinaryStdout() == MS_FAILURE)
+      return MS_FAILURE;
+
+    msAcquireLock(TLOCK_GDAL);
+    for (i = count - 1; i >= 0; i--) {
+      const char *this_file = all_files[i];
+
+      if (EQUAL(this_file, ".") || EQUAL(this_file, "..")) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
+        continue;
+      }
+
+      if (i > 0 && EQUAL(this_file, CPLGetFilename(filename))) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
+        all_files = CSLInsertString(all_files, 0, CPLGetFilename(filename));
+        i++;
+      }
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Dump all the files in the memory directory as mime sections.    */
+    /* -------------------------------------------------------------------- */
+    count = CSLCount(all_files);
+
+    if (count > 1 && multipart == MS_FALSE) {
+      msDebug("msWCSWriteFile20(): force multipart output without gml summary "
+              "because we have multiple files in the result.\n");
+
+      multipart = MS_TRUE;
+      msIO_setHeader("Content-Type", "multipart/related; boundary=wcs");
+      msIO_sendHeaders();
+    }
+
+    for (i = 0; i < count; i++) {
+      const char *mimetype = NULL;
+      VSILFILE *fp;
+      unsigned char block[4000];
+      int bytes_read;
+
+      if (i == 0 && !EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "unknown"))
+        mimetype = MS_IMAGE_MIME_TYPE(map->outputformat);
+
+      if (mimetype == NULL)
+        mimetype = "application/octet-stream";
+      if (multipart) {
+        msIO_fprintf(stdout, "\r\n--wcs\r\n");
+        msIO_fprintf(stdout,
+                     "Content-Type: %s\r\n"
+                     "Content-Description: coverage data\r\n"
+                     "Content-Transfer-Encoding: binary\r\n"
+                     "Content-ID: coverage/%s\r\n"
+                     "Content-Disposition: INLINE; filename=%s\r\n\r\n",
+                     mimetype, all_files[i], all_files[i]);
+      } else {
+        msIO_setHeader("Content-Type", "%s", mimetype);
+        msIO_setHeader("Content-Description", "coverage data");
+        msIO_setHeader("Content-Transfer-Encoding", "binary");
+        msIO_setHeader("Content-ID", "coverage/%s", all_files[i]);
+        msIO_setHeader("Content-Disposition", "INLINE; filename=%s",
+                       all_files[i]);
+        msIO_sendHeaders();
+      }
+
+      fp = VSIFOpenL(CPLFormFilename(base_dir, all_files[i], NULL), "rb");
+      if (fp == NULL) {
+        msReleaseLock(TLOCK_GDAL);
+        msSetError(MS_MISCERR, "Failed to open %s for streaming to stdout.",
+                   "msWCSWriteFile20()", all_files[i]);
+        return MS_FAILURE;
+      }
+
+      while ((bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0)
+        msIO_fwrite(block, 1, bytes_read, stdout);
+
+      VSIFCloseL(fp);
+
+      VSIUnlink(CPLFormFilename(base_dir, all_files[i], NULL));
+    }
+
+    msFree(base_dir);
+    msFree(filename);
+    CSLDestroy(all_files);
+    msReleaseLock(TLOCK_GDAL);
+    if (multipart)
+      msIO_fprintf(stdout, "\r\n--wcs--\r\n");
+    return MS_SUCCESS;
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSGetRangesetAxisMetadata20()                   */
+/*                                                                      */
+/*      Looks up a layers metadata for a specific axis information.     */
+/************************************************************************/
+
+static const char *msWCSLookupRangesetAxisMetadata20(hashTableObj *table,
+                                                     const char *axis,
+                                                     const char *item) {
+  char buf[500];
+  const char *value;
+
+  if (table == NULL || axis == NULL || item == NULL) {
+    return NULL;
+  }
+
+  strlcpy(buf, axis, sizeof(buf));
+  strlcat(buf, "_", sizeof(buf));
+  strlcat(buf, item, sizeof(buf));
+  if ((value = msLookupHashTable(table, buf)) != NULL) {
+    return value;
+  }
+  return msOWSLookupMetadata(table, "CO", buf);
+}
+
+/************************************************************************/
+/*                   msWCSGetCoverageMetadata20()                       */
+/*                                                                      */
+/*      Inits a coverageMetadataObj. Uses msWCSGetCoverageMetadata()    */
+/*      but exchanges the SRS URN by an URI for compliancy with 2.0.    */
+/************************************************************************/
+
+static int msWCSGetCoverageMetadata20(layerObj *layer,
+                                      wcs20coverageMetadataObj *cm) {
+  char *srs_uri = NULL;
+  memset(cm, 0, sizeof(wcs20coverageMetadataObj));
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &(cm->srs_epsg));
+  if (!cm->srs_epsg) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &cm->srs_epsg);
+    if (!cm->srs_epsg) {
+      msSetError(MS_WCSERR,
+                 "Unable to determine the SRS for this layer, "
+                 "no projection defined and no metadata available.",
+                 "msWCSGetCoverageMetadata20()");
+      return MS_FAILURE;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Get the SRS in uri format.                                      */
+  /* -------------------------------------------------------------------- */
+  if ((srs_uri = msOWSGetProjURI(&(layer->projection), &(layer->metadata), "CO",
+                                 MS_TRUE)) == NULL) {
+    srs_uri = msOWSGetProjURI(&(layer->map->projection),
+                              &(layer->map->web.metadata), "CO", MS_TRUE);
+  }
+
+  if (srs_uri != NULL) {
+    if (strlen(srs_uri) > sizeof(cm->srs_uri) - 1) {
+      msSetError(MS_WCSERR, "SRS URI too long!", "msWCSGetCoverageMetadata()");
+      return MS_FAILURE;
+    }
+
+    strlcpy(cm->srs_uri, srs_uri, sizeof(cm->srs_uri));
+    msFree(srs_uri);
+  } else {
+    cm->srs_uri[0] = '\0';
+  }
+
+  /* setup nilvalues */
+  cm->numnilvalues = 0;
+  cm->nilvalues = NULL;
+  cm->nilvalues_reasons = NULL;
+  cm->native_format = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*      If we have "virtual dataset" metadata on the layer, then use    */
+  /*      that in preference to inspecting the file(s).                   */
+  /*      We require extent and either size or resolution.                */
+  /* -------------------------------------------------------------------- */
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL &&
+      (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL ||
+       msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL)) {
+    const char *value;
+
+    /* get extent */
+    cm->extent.minx = 0.0;
+    cm->extent.maxx = 0.0;
+    cm->extent.miny = 0.0;
+    cm->extent.maxy = 0.0;
+    if (msOWSGetLayerExtent(layer->map, layer, "CO", &cm->extent) == MS_FAILURE)
+      return MS_FAILURE;
+
+    /* get resolution */
+    cm->xresolution = 0.0;
+    cm->yresolution = 0.0;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) !=
+        NULL) {
+      char **tokens;
+      int n;
+
+      tokens = msStringSplit(value, ' ', &n);
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_resolution metadata.",
+                   "msWCSGetCoverageMetadata20()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+      cm->xresolution = atof(tokens[0]);
+      cm->yresolution = atof(tokens[1]);
+      msFreeCharArray(tokens, n);
+    }
+
+    /* get Size (in pixels and lines) */
+    cm->xsize = 0;
+    cm->ysize = 0;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "size")) !=
+        NULL) {
+      char **tokens;
+      int n;
+
+      tokens = msStringSplit(value, ' ', &n);
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_size metadata.",
+                   "msWCSGetCoverageMetadata20()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
+      }
+      cm->xsize = atoi(tokens[0]);
+      cm->ysize = atoi(tokens[1]);
+      msFreeCharArray(tokens, n);
+    }
+
+    /* try to compute raster size */
+    if (cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 &&
+        cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx &&
+        cm->extent.miny != cm->extent.maxy) {
+      cm->xsize =
+          (int)((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
+      cm->ysize = (int)fabs(
+          (cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
+    }
+
+    /* try to compute raster resolution */
+    if ((cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 &&
+        cm->ysize != 0) {
+      cm->xresolution = (cm->extent.maxx - cm->extent.minx) / cm->xsize;
+      cm->yresolution = (cm->extent.maxy - cm->extent.miny) / cm->ysize;
+    }
+
+    /* do we have information to do anything */
+    if (cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 ||
+        cm->ysize == 0) {
+      msSetError(MS_WCSERR,
+                 "Failed to collect extent and resolution for WCS coverage "
+                 "from metadata for layer '%s'.  Need value wcs|ows_resolution "
+                 "or wcs|ows_size values.",
+                 "msWCSGetCoverageMetadata20()", layer->name);
+      return MS_FAILURE;
+    }
+
+    /* compute geotransform */
+    cm->geotransform[0] = cm->extent.minx;
+    cm->geotransform[1] = cm->xresolution;
+    cm->geotransform[2] = 0.0;
+    cm->geotransform[3] = cm->extent.maxy;
+    cm->geotransform[4] = 0.0;
+    cm->geotransform[5] = -fabs(cm->yresolution);
+
+    /* get bands count, or assume 1 if not found */
+    cm->numbands = 1;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) !=
+        NULL) {
+      int numbands = 0;
+      if (msStringParseInteger(value, &numbands) != MS_SUCCESS) {
+        return MS_FAILURE;
+      }
+      cm->numbands = (size_t)numbands;
+    }
+
+    cm->bands = static_cast<wcs20rasterbandMetadataObj *>(
+        msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
+
+    /* get bands type, or assume float if not found */
+    cm->imagemode = MS_IMAGEMODE_FLOAT32;
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) !=
+        NULL) {
+      if (EQUAL(value, "INT16"))
+        cm->imagemode = MS_IMAGEMODE_INT16;
+      else if (EQUAL(value, "FLOAT32"))
+        cm->imagemode = MS_IMAGEMODE_FLOAT32;
+      else if (EQUAL(value, "BYTE"))
+        cm->imagemode = MS_IMAGEMODE_BYTE;
+      else {
+        msSetError(MS_WCSERR,
+                   "Content of wcs|ows_imagemode (%s) not recognised.  Should "
+                   "be one of BYTE, INT16 or FLOAT32.",
+                   "msWCSGetCoverageMetadata20()", value);
+        return MS_FAILURE;
+      }
+    }
+
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                     "native_format")) != NULL) {
+      cm->native_format = msStrdup(value);
+    }
+
+    /* determine nilvalues and reasons */
+    {
+      int n_nilvalues = 0, n_nilvalues_reasons = 0;
+      char **t_nilvalues = NULL, **t_nilvalues_reasons = NULL;
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       "nilvalues")) != NULL) {
+        t_nilvalues = msStringSplit(value, ' ', &n_nilvalues);
+      } else if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                              "rangeset_nullvalue")) != NULL) {
+        t_nilvalues = msStringSplit(value, ' ', &n_nilvalues);
+      }
+
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       "nilvalues_reasons")) != NULL) {
+        t_nilvalues_reasons = msStringSplit(value, ' ', &n_nilvalues_reasons);
+      }
+
+      if (n_nilvalues > 0) {
+        int i;
+        cm->numnilvalues = n_nilvalues;
+        cm->nilvalues =
+            static_cast<char **>(msSmallCalloc(sizeof(char *), n_nilvalues));
+        cm->nilvalues_reasons =
+            static_cast<char **>(msSmallCalloc(sizeof(char *), n_nilvalues));
+        for (i = 0; i < n_nilvalues; ++i) {
+          cm->nilvalues[i] = msStrdup(t_nilvalues[i]);
+          if (i < n_nilvalues_reasons) {
+            cm->nilvalues_reasons[i] = msStrdup(t_nilvalues_reasons[i]);
+          } else {
+            cm->nilvalues_reasons[i] = msStrdup("");
+          }
+        }
+      }
+      msFreeCharArray(t_nilvalues, n_nilvalues);
+      msFreeCharArray(t_nilvalues_reasons, n_nilvalues_reasons);
+    }
+
+    {
+      int num_band_names = 0, j;
+      char **band_names = NULL;
+
+      const char *wcs11_band_names_key = "rangeset_axes";
+      const char *wcs20_band_names_key = "band_names";
+
+      const char *wcs11_interval_key = "interval";
+      const char *wcs20_interval_key = "interval";
+      const char *interval_key = NULL;
+
+      const char *significant_figures_key = "significant_figures";
+
+      const char *wcs11_keys[] = {"label", "semantic", "values_type",
+                                  "values_semantic", "description"};
+      const char *wcs20_keys[] = {"band_name", "band_interpretation",
+                                  "band_uom", "band_definition",
+                                  "band_description"};
+      const char **keys = NULL;
+
+      char **interval_array;
+      int num_interval;
+
+      wcs20rasterbandMetadataObj default_values;
+
+      /* Decide whether WCS1.1 or WCS2.0 keys should be used */
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       wcs20_band_names_key)) != NULL) {
+        keys = wcs20_keys;
+        interval_key = wcs20_interval_key;
+        band_names = msStringSplit(value, ' ', &num_band_names);
+      } else if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                              wcs11_band_names_key)) != NULL) {
+        keys = wcs11_keys;
+        interval_key = wcs11_interval_key;
+        /* "bands" has a special processing in WCS 1.0. See */
+        /* msWCSSetDefaultBandsRangeSetInfo */
+        if (EQUAL(value, "bands")) {
+          num_band_names = cm->numbands;
+          band_names = (char **)msSmallMalloc(sizeof(char *) * num_band_names);
+          for (int i = 0; i < num_band_names; i++) {
+            char szName[30];
+            snprintf(szName, sizeof(szName), "Band%d", i + 1);
+            band_names[i] = msStrdup(szName);
+          }
+        } else {
+          /* WARNING: in WCS 1.x,, "rangeset_axes" has never been intended */
+          /* to contain the list of band names... This code should probably */
+          /* be removed */
+          band_names = msStringSplit(value, ' ', &num_band_names);
+        }
+      }
+
+      /* return with error when number of bands does not match    */
+      /* the number of names                                      */
+      if (static_cast<size_t>(num_band_names) != cm->numbands &&
+          num_band_names != 0) {
+        msFreeCharArray(band_names, num_band_names);
+        msSetError(MS_WCSERR,
+                   "Wrong number of band names given in layer '%s'. "
+                   "Expected %d, got %d.",
+                   "msWCSGetCoverageMetadata20()", layer->name,
+                   (int)cm->numbands, num_band_names);
+        return MS_FAILURE;
+      }
+
+      /* look up default metadata values */
+      for (j = 1; j < 5; ++j) {
+        if (keys != NULL) {
+          default_values.values[j] =
+              (char *)msOWSLookupMetadata(&(layer->metadata), "CO", keys[j]);
+        }
+      }
+
+      /* set default values for interval and significant figures */
+      switch (cm->imagemode) {
+      case MS_IMAGEMODE_BYTE:
+        default_values.interval_min = 0.;
+        default_values.interval_max = 255.;
+        default_values.significant_figures = 3;
+        break;
+      case MS_IMAGEMODE_INT16:
+        default_values.interval_min = 0.;
+        default_values.interval_max = (double)USHRT_MAX;
+        default_values.significant_figures = 5;
+        break;
+      case MS_IMAGEMODE_FLOAT32:
+        default_values.interval_min = -FLT_MAX;
+        default_values.interval_max = FLT_MAX;
+        default_values.significant_figures = 12;
+        break;
+      default:
+        // other imagemodes are invalid (see above), just keep the compiler
+        // happy
+        msFreeCharArray(band_names, num_band_names);
+        return MS_FAILURE;
+        break;
+      }
+
+      /* lookup default interval values */
+      if (interval_key != NULL &&
+          (value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       interval_key)) != NULL) {
+        interval_array = msStringSplit(value, ' ', &num_interval);
+
+        if (num_interval != 2 ||
+            msStringParseDouble(interval_array[0],
+                                &(default_values.interval_min)) != MS_SUCCESS ||
+            msStringParseDouble(interval_array[1],
+                                &(default_values.interval_max)) != MS_SUCCESS) {
+          msFreeCharArray(band_names, num_band_names);
+          msFreeCharArray(interval_array, num_interval);
+          msSetError(MS_WCSERR, "Wrong interval format for default axis.",
+                     "msWCSGetCoverageMetadata20()");
+          return MS_FAILURE;
+        }
+        msFreeCharArray(interval_array, num_interval);
+      }
+
+      /* lookup default value for significant figures */
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       significant_figures_key)) != NULL) {
+        if (msStringParseInteger(
+                value, &(default_values.significant_figures)) != MS_SUCCESS) {
+          msFreeCharArray(band_names, num_band_names);
+          msSetError(MS_WCSERR,
+                     "Wrong significant figures format "
+                     "for default axis.",
+                     "msWCSGetCoverageMetadata20()");
+          return MS_FAILURE;
+        }
+      }
+
+      /* iterate over every band */
+      for (unsigned i = 0; i < cm->numbands; ++i) {
+        cm->bands[i].name = NULL;
+
+        /* look up band metadata or copy defaults */
+        if (num_band_names != 0) {
+          cm->bands[i].name = msStrdup(band_names[i]);
+          for (j = 1; j < 5; ++j) {
+            value = (char *)msWCSLookupRangesetAxisMetadata20(
+                &(layer->metadata), cm->bands[i].name, keys[j]);
+            if (value != NULL) {
+              cm->bands[i].values[j] = msStrdup(value);
+            } else if (default_values.values[j] != NULL) {
+              cm->bands[i].values[j] = msStrdup(default_values.values[j]);
+            }
+          }
+        }
+
+        /* set up interval */
+        value = (char *)msWCSLookupRangesetAxisMetadata20(
+            &(layer->metadata), cm->bands[i].name, interval_key);
+        if (value != NULL) {
+          num_interval = 0;
+          interval_array = msStringSplit(value, ' ', &num_interval);
+
+          if (num_interval != 2 ||
+              msStringParseDouble(interval_array[0],
+                                  &(cm->bands[i].interval_min)) != MS_SUCCESS ||
+              msStringParseDouble(interval_array[1],
+                                  &(cm->bands[i].interval_max)) != MS_SUCCESS) {
+            msFreeCharArray(band_names, num_band_names);
+            msFreeCharArray(interval_array, num_interval);
+            msSetError(MS_WCSERR, "Wrong interval format for axis %s.",
+                       "msWCSGetCoverageMetadata20()", cm->bands[i].name);
+            return MS_FAILURE;
+          }
+
+          msFreeCharArray(interval_array, num_interval);
+        } else {
+          cm->bands[i].interval_min = default_values.interval_min;
+          cm->bands[i].interval_max = default_values.interval_max;
+        }
+
+        /* set up significant figures */
+        value = (char *)msWCSLookupRangesetAxisMetadata20(
+            &(layer->metadata), cm->bands[i].name, significant_figures_key);
+        if (value != NULL) {
+          if (msStringParseInteger(
+                  value, &(cm->bands[i].significant_figures)) != MS_SUCCESS) {
+            msFreeCharArray(band_names, num_band_names);
+            msSetError(MS_WCSERR,
+                       "Wrong significant figures format "
+                       "for axis %s.",
+                       "msWCSGetCoverageMetadata20()", cm->bands[i].name);
+            return MS_FAILURE;
+          }
+        } else {
+          cm->bands[i].significant_figures = default_values.significant_figures;
+        }
+      }
+
+      msFreeCharArray(band_names, num_band_names);
+    }
+  } else if (layer->data == NULL) {
+    /* no virtual metadata, not ok unless we're talking 1 image, hopefully we
+     * can fix that */
+    msSetError(
+        MS_WCSERR,
+        "RASTER Layer with no DATA statement and no WCS virtual dataset "
+        "metadata.  Tileindexed raster layers not supported for WCS without "
+        "virtual dataset metadata (cm->extent, wcs_res, wcs_size).",
+        "msWCSGetCoverageMetadata20()");
+    return MS_FAILURE;
+  } else {
+    /* work from the file (e.g. DATA) */
+    GDALDatasetH hDS;
+    GDALDriverH hDriver;
+    GDALRasterBandH hBand;
+    char szPath[MS_MAXPATHLEN];
+    const char *driver_short_name, *driver_long_name;
+
+    msGDALInitialize();
+
+    msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                    layer->data);
+    msAcquireLock(TLOCK_GDAL);
+    {
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      hDS = GDALOpenEx(szPath, GDAL_OF_RASTER, NULL,
+                       (const char *const *)connectionoptions, NULL);
+      CSLDestroy(connectionoptions);
+    }
+    if (hDS == NULL) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_IOERR, "%s", "msWCSGetCoverageMetadata20()",
+                 CPLGetLastErrorMsg());
+      return MS_FAILURE;
+    }
+
+    msGetGDALGeoTransform(hDS, layer->map, layer, cm->geotransform);
+
+    cm->xsize = GDALGetRasterXSize(hDS);
+    cm->ysize = GDALGetRasterYSize(hDS);
+
+    cm->extent.minx = cm->geotransform[0];
+    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize +
+                      cm->geotransform[2] * cm->ysize;
+    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize +
+                      cm->geotransform[5] * cm->ysize;
+    cm->extent.maxy = cm->geotransform[3];
+
+    cm->xresolution = cm->geotransform[1];
+    cm->yresolution = cm->geotransform[5];
+
+    cm->numbands = GDALGetRasterCount(hDS);
+
+    /* TODO nilvalues? */
+
+    if (cm->numbands == 0) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_WCSERR,
+                 "Raster file %s has no raster bands.  This cannot be used in "
+                 "a layer.",
+                 "msWCSGetCoverageMetadata20()", layer->data);
+      return MS_FAILURE;
+    }
+
+    hBand = GDALGetRasterBand(hDS, 1);
+    switch (GDALGetRasterDataType(hBand)) {
+    case GDT_Byte:
+      cm->imagemode = MS_IMAGEMODE_BYTE;
+      break;
+    case GDT_Int16:
+      cm->imagemode = MS_IMAGEMODE_INT16;
+      break;
+    default:
+      cm->imagemode = MS_IMAGEMODE_FLOAT32;
+      break;
+    }
+
+    cm->bands = static_cast<wcs20rasterbandMetadataObj *>(
+        msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
+
+    /* get as much band metadata as possible */
+    for (unsigned i = 0; i < cm->numbands; ++i) {
+      char bandname[32];
+      GDALColorInterp colorInterp;
+      hBand = GDALGetRasterBand(hDS, i + 1);
+      snprintf(bandname, sizeof(bandname), "band%d", i + 1);
+      cm->bands[i].name = msStrdup(bandname);
+      colorInterp = GDALGetRasterColorInterpretation(hBand);
+      cm->bands[i].interpretation =
+          msStrdup(GDALGetColorInterpretationName(colorInterp));
+      cm->bands[i].uom = msStrdup(GDALGetRasterUnitType(hBand));
+      if (strlen(cm->bands[i].uom) == 0) {
+        msFree(cm->bands[i].uom);
+        cm->bands[i].uom = NULL;
+      }
+
+      /* set up interval and significant figures */
+      switch (cm->imagemode) {
+      case MS_IMAGEMODE_BYTE:
+      case MS_IMAGEMODE_PC256:
+        cm->bands[i].interval_min = 0.;
+        cm->bands[i].interval_max = 255.;
+        cm->bands[i].significant_figures = 3;
+        break;
+      case MS_IMAGEMODE_INT16:
+        cm->bands[i].interval_min = 0.;
+        cm->bands[i].interval_max = (double)USHRT_MAX;
+        cm->bands[i].significant_figures = 5;
+        break;
+      case MS_IMAGEMODE_FLOAT32:
+        cm->bands[i].interval_min = -FLT_MAX;
+        cm->bands[i].interval_max = FLT_MAX;
+        cm->bands[i].significant_figures = 12;
+        break;
+      }
+    }
+
+    hDriver = GDALGetDatasetDriver(hDS);
+    driver_short_name = GDALGetDriverShortName(hDriver);
+    driver_long_name = GDALGetDriverLongName(hDriver);
+    /* TODO: improve this, exchange strstr() */
+    for (int i = 0; i < layer->map->numoutputformats; ++i) {
+      if (strstr(layer->map->outputformatlist[i]->driver, driver_short_name) !=
+              NULL ||
+          strstr(layer->map->outputformatlist[i]->driver, driver_long_name) !=
+              NULL) {
+        cm->native_format = msStrdup(layer->map->outputformatlist[i]->mimetype);
+        break;
+      }
+    }
+
+    GDALClose(hDS);
+    msReleaseLock(TLOCK_GDAL);
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSClearCoverageMetadata20()                     */
+/*                                                                      */
+/*      Returns all dynamically allocated memory from a coverage meta-  */
+/*      data object.                                                    */
+/************************************************************************/
+
+static int msWCSClearCoverageMetadata20(wcs20coverageMetadataObj *cm) {
+  msFree(cm->native_format);
+  for (unsigned i = 0; i < cm->numnilvalues; ++i) {
+    msFree(cm->nilvalues[i]);
+    msFree(cm->nilvalues_reasons[i]);
+  }
+  msFree(cm->nilvalues);
+  msFree(cm->nilvalues_reasons);
+
+  for (unsigned i = 0; i < cm->numbands; ++i) {
+    for (int j = 0; j < 5; ++j) {
+      msFree(cm->bands[i].values[j]);
+    }
+  }
+  msFree(cm->bands);
+  msFree(cm->srs_epsg);
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSException20()                                 */
+/*                                                                      */
+/*      Writes out an OWS compliant exception.                          */
+/************************************************************************/
+
+int msWCSException20(mapObj *map, const char *exceptionCode,
+                     const char *locator, const char *version) {
+  int size = 0;
+  const char *status = "400 Bad Request";
+  char *errorString = NULL;
+  char *schemasLocation = NULL;
+  char *xsi_schemaLocation = NULL;
+  char version_string[OWS_VERSION_MAXLEN];
+
+  xmlDocPtr psDoc = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psMainNode = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlNsPtr psNsXsi = NULL;
+  xmlChar *buffer = NULL;
+
+  errorString = msGetErrorString("\n");
+  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "ExceptionReport");
+  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_20_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  xmlSetNs(psRootNode, psNsOws);
+
+  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+
+  /* add attributes to root element */
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST version);
+  xmlNewProp(psRootNode, BAD_CAST "xml:lang",
+             BAD_CAST msOWSGetLanguage(map, "exception"));
+
+  /* get 2 digits version string: '2.0' */
+  msOWSGetVersionString(OWS_2_0_0, version_string);
+  version_string[3] = '\0';
+
+  xsi_schemaLocation = msStrdup((char *)psNsOws->href);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)schemasLocation);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, version_string);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
+
+  /* add namespace'd attributes to root element */
+  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+
+  /* add child element */
+  psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Exception", NULL);
+
+  /* add attributes to child */
+  xmlNewProp(psMainNode, BAD_CAST "exceptionCode", BAD_CAST exceptionCode);
+
+  if (locator != NULL) {
+    xmlNewProp(psMainNode, BAD_CAST "locator", BAD_CAST locator);
+  }
+
+  if (errorString != NULL) {
+    char *errorMessage = msEncodeHTMLEntities(errorString);
+    xmlNewChild(psMainNode, NULL, BAD_CAST "ExceptionText",
+                BAD_CAST errorMessage);
+    msFree(errorMessage);
+  }
+
+  /*psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_2_0_0,
+          schemasLocation, version, msOWSGetLanguage(map, "exception"),
+          exceptionCode, locator, errorMessage);*/
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  if (exceptionCode == NULL) {
+    /* Do nothing */
+  } else if (EQUAL(exceptionCode, "OperationNotSupported") ||
+             EQUAL(exceptionCode, "OptionNotSupported")) {
+    status = "501 Not Implemented";
+  } else if (EQUAL(exceptionCode, "NoSuchCoverage") ||
+             EQUAL(exceptionCode, "emptyCoverageIdList") ||
+             EQUAL(exceptionCode, "InvalidAxisLabel") ||
+             EQUAL(exceptionCode, "InvalidSubsetting")) {
+    status = "404 Not Found";
+  }
+
+  msIO_setHeader("Status", "%s", status);
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
+
+  msIO_printf("%s", buffer);
+
+  /* free buffer and the document */
+  free(errorString);
+  free(schemasLocation);
+  free(xsi_schemaLocation);
+  xmlFree(buffer);
+  xmlFreeDoc(psDoc);
+
+  /* clear error since we have already reported it */
+  msResetErrorList();
+  return MS_FAILURE;
+}
+
+#define MAX_MIMES 20
+
+static int msWCSGetCapabilities20_CreateProfiles(
+    mapObj *map, xmlNodePtr psServiceIdentification, xmlNsPtr psOwsNs) {
+  xmlNodePtr psProfile, psTmpNode;
+  char *available_mime_types[MAX_MIMES];
+  int i = 0;
+
+  /* even indices are urls, uneven are mime-types, or null*/
+  const char *const urls_and_mime_types[] = {
+      MS_WCS_20_PROFILE_CORE,
+      NULL,
+      MS_WCS_20_PROFILE_KVP,
+      NULL,
+      MS_WCS_20_PROFILE_POST,
+      NULL,
+      MS_WCS_20_PROFILE_GML,
+      NULL,
+      MS_WCS_20_PROFILE_GML_MULTIPART,
+      NULL,
+      MS_WCS_20_PROFILE_GML_SPECIAL,
+      NULL,
+      MS_WCS_20_PROFILE_GML_GEOTIFF,
+      "image/tiff",
+      MS_WCS_20_PROFILE_CRS,
+      NULL,
+      MS_WCS_20_PROFILE_SCALING,
+      NULL,
+      MS_WCS_20_PROFILE_RANGESUBSET,
+      NULL,
+      MS_WCS_20_PROFILE_INTERPOLATION,
+      NULL,
+      NULL,
+      NULL /* guardian */
+  };
+
+  /* navigate to node where profiles shall be inserted */
+  for (psTmpNode = psServiceIdentification->children; psTmpNode->next != NULL;
+       psTmpNode = psTmpNode->next) {
+    if (EQUAL((char *)psTmpNode->name, "ServiceTypeVersion") &&
+        !EQUAL((char *)psTmpNode->next->name, "ServiceTypeVersion"))
+      break;
+  }
+
+  /* get list of all available mime types */
+  msGetOutputFormatMimeList(map, available_mime_types, MAX_MIMES);
+
+  while (urls_and_mime_types[i] != NULL) {
+    const char *mime_type = urls_and_mime_types[i + 1];
+
+    /* check if there is a mime type */
+    if (mime_type != NULL) {
+      /* check if the mime_type is in the list of outputformats */
+      if (CSLPartialFindString(available_mime_types, mime_type) == -1)
+        continue;
+    }
+
+    /* create a new node and attach it in the tree */
+    psProfile = xmlNewNode(psOwsNs, BAD_CAST "Profile");
+    xmlNodeSetContent(psProfile, BAD_CAST urls_and_mime_types[i]);
+    xmlAddNextSibling(psTmpNode, psProfile);
+
+    psTmpNode = psProfile;
+    i += 2;
+  }
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSGetCapabilities20_CoverageSummary()           */
+/*                                                                      */
+/*      Helper function to create a short summary for a specific        */
+/*      coverage.                                                       */
+/************************************************************************/
+
+static int msWCSGetCapabilities20_CoverageSummary(xmlDocPtr doc,
+                                                  xmlNodePtr psContents,
+                                                  layerObj *layer) {
+  wcs20coverageMetadataObj cm;
+  int status;
+  xmlNodePtr psCSummary;
+
+  xmlNsPtr psWcsNs =
+      xmlSearchNs(doc, xmlDocGetRootElement(doc), BAD_CAST "wcs");
+
+  status = msWCSGetCoverageMetadata20(layer, &cm);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  psCSummary =
+      xmlNewChild(psContents, psWcsNs, BAD_CAST "CoverageSummary", NULL);
+  xmlNewChild(psCSummary, psWcsNs, BAD_CAST "CoverageId", BAD_CAST layer->name);
+  xmlNewChild(psCSummary, psWcsNs, BAD_CAST "CoverageSubtype",
+              BAD_CAST "RectifiedGridCoverage");
+
+  msWCS_11_20_PrintMetadataLinks(layer, doc, psCSummary);
+
+  msWCSClearCoverageMetadata20(&cm);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                          msWCSAddInspireDSID20                       */
+/************************************************************************/
+
+static void msWCSAddInspireDSID20(mapObj *map, xmlNsPtr psNsInspireDls,
+                                  xmlNsPtr psNsInspireCommon,
+                                  xmlNodePtr pDlsExtendedCapabilities) {
+  const char *dsid_code =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_code");
+  const char *dsid_ns =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_ns");
+  if (dsid_code == NULL) {
+    xmlAddChild(
+        pDlsExtendedCapabilities,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Required metadata \"inspire_dsid_code\" missing"));
+  } else {
+    int ntokensCode = 0, ntokensNS = 0;
+    char **tokensCode;
+    char **tokensNS = NULL;
+    int i;
+
+    tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
+    if (dsid_ns != NULL)
+      tokensNS =
+          msStringSplitComplex(dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
+    if (ntokensNS > 0 && ntokensNS != ntokensCode) {
+      xmlAddChild(
+          pDlsExtendedCapabilities,
+          xmlNewComment(
+              BAD_CAST
+              "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not "
+              "the same number of elements. Ignoring inspire_dsid_ns"));
+      msFreeCharArray(tokensNS, ntokensNS);
+      tokensNS = NULL;
+      ntokensNS = 0;
+    }
+    for (i = 0; i < ntokensCode; i++) {
+      xmlNodePtr pSDSI =
+          xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
+      xmlAddChild(pDlsExtendedCapabilities, pSDSI);
+      xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code",
+                      BAD_CAST tokensCode[i]);
+      if (ntokensNS > 0 && tokensNS[i][0] != '\0')
+        xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace",
+                        BAD_CAST tokensNS[i]);
+    }
+    msFreeCharArray(tokensCode, ntokensCode);
+    msFreeCharArray(tokensNS, ntokensNS);
+  }
+}
+
+/************************************************************************/
+/*                   msWCSGetCapabilities20()                           */
+/*                                                                      */
+/*      Performs the GetCapabilities operation. Writes out a xml        */
+/*      structure with server specific information and a summary        */
+/*      of all available coverages.                                     */
+/************************************************************************/
+
+int msWCSGetCapabilities20(mapObj *map, cgiRequestObj *req,
+                           wcs20ParamsObjPtr params,
+                           owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode, psOperationsNode, psNode;
+  const char *updatesequence = NULL;
+  xmlNsPtr psOwsNs = NULL, psXLinkNs = NULL, psWcsNs = NULL, psCrsNs = NULL,
+           psIntNs = NULL;
+  char *script_url = NULL, *script_url_encoded = NULL, *format_list = NULL;
+  int i;
+  xmlDocPtr pInspireTmpDoc = NULL;
+
+  const char *inspire_capabilities =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_capabilities");
+
+  char *validated_language = msOWSLanguageNegotiation(
+      map, "CO", params->accept_languages, CSLCount(params->accept_languages));
+
+  /* -------------------------------------------------------------------- */
+  /*      Create document.                                                */
+  /* -------------------------------------------------------------------- */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "Capabilities");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* -------------------------------------------------------------------- */
+  /*      Name spaces                                                     */
+  /* -------------------------------------------------------------------- */
+
+  msWCSPrepareNamespaces20(psDoc, psRootNode, map,
+                           inspire_capabilities != NULL);
+
+  /* lookup namespaces */
+  psOwsNs = xmlSearchNs(psDoc, psRootNode,
+                        BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psWcsNs = xmlSearchNs(psDoc, psRootNode,
+                        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+  xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+  psXLinkNs = xmlSearchNs(psDoc, psRootNode, BAD_CAST "xlink");
+  psCrsNs = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/crs/1.0",
+                     BAD_CAST "crs");
+  psIntNs = xmlNewNs(psRootNode,
+                     BAD_CAST "http://www.opengis.net/wcs/interpolation/1.0",
+                     BAD_CAST "int");
+
+  xmlSetNs(psRootNode, psWcsNs);
+
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version);
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+  if (params->updatesequence != NULL) {
+    i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
+    if (i == 0) { /* current */
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
+      xmlFreeDoc(psDoc);
+      return msWCSException(map, "CurrentUpdateSequence", "updatesequence",
+                            params->version);
+    }
+    if (i > 0) { /* invalid */
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
+      xmlFreeDoc(psDoc);
+      return msWCSException(map, "InvalidUpdateSequence", "updatesequence",
+                            params->version);
+    }
+  }
+  if (updatesequence != NULL) {
+    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Service identification.                                         */
+  /* -------------------------------------------------------------------- */
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceIdentification")) {
+    psNode = xmlAddChild(
+        psRootNode, msOWSCommonServiceIdentification(psOwsNs, map, "OGC WCS",
+                                                     "2.0.1,1.1.1,1.0.0", "CO",
+                                                     validated_language));
+    msWCSGetCapabilities20_CreateProfiles(map, psNode, psOwsNs);
+  }
+
+  /* Service Provider */
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceProvider")) {
+    xmlAddChild(psRootNode,
+                msOWSCommonServiceProvider(psOwsNs, psXLinkNs, map, "CO",
+                                           validated_language));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Operations metadata.                                            */
+  /* -------------------------------------------------------------------- */
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "OperationsMetadata")) {
+    if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource",
+                                             req)) == NULL ||
+        (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+      xmlFreeDoc(psDoc);
+      msSetError(MS_WCSERR, "Server URL not found", "msWCSGetCapabilities20()");
+      return msWCSException(map, "NoApplicableCode", "mapserv",
+                            params->version);
+    }
+    free(script_url);
+
+    psOperationsNode =
+        xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psOwsNs));
+
+    /* -------------------------------------------------------------------- */
+    /*      GetCapabilities - add Sections and AcceptVersions?              */
+    /* -------------------------------------------------------------------- */
+    psNode = msOWSCommonOperationsMetadataOperation(
+        psOwsNs, psXLinkNs, "GetCapabilities", OWS_METHOD_GETPOST,
+        script_url_encoded);
+
+    xmlAddChild(psNode->last->last->last,
+                msOWSCommonOperationsMetadataDomainType(
+                    OWS_2_0_0, psOwsNs, "Constraint", "PostEncoding", "XML"));
+    xmlAddChild(psOperationsNode, psNode);
+
+    /* -------------------------------------------------------------------- */
+    /*      DescribeCoverage                                                */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE)) {
+      psNode = msOWSCommonOperationsMetadataOperation(
+          psOwsNs, psXLinkNs, "DescribeCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
+      xmlAddChild(psNode->last->last->last,
+                  msOWSCommonOperationsMetadataDomainType(
+                      OWS_2_0_0, psOwsNs, "Constraint", "PostEncoding", "XML"));
+      xmlAddChild(psOperationsNode, psNode);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      GetCoverage                                                     */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE)) {
+      psNode = msOWSCommonOperationsMetadataOperation(
+          psOwsNs, psXLinkNs, "GetCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
+
+      xmlAddChild(psNode->last->last->last,
+                  msOWSCommonOperationsMetadataDomainType(
+                      OWS_2_0_0, psOwsNs, "Constraint", "PostEncoding", "XML"));
+      xmlAddChild(psOperationsNode, psNode);
+    }
+    msFree(script_url_encoded);
+
+    /* -------------------------------------------------------------------- */
+    /*      Extended Capabilities for inspire                               */
+    /* -------------------------------------------------------------------- */
+
+    if (inspire_capabilities) {
+      msIOContext *old_context;
+      msIOContext *new_context;
+      msIOBuffer *buffer;
+
+      xmlNodePtr pRoot;
+      xmlNodePtr pOWSExtendedCapabilities;
+      xmlNodePtr pDlsExtendedCapabilities;
+      xmlNodePtr pChild;
+
+      xmlNsPtr psInspireCommonNs = xmlSearchNs(
+          psDoc, psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
+      xmlNsPtr psInspireDlsNs = xmlSearchNs(
+          psDoc, psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
+
+      old_context = msIO_pushStdoutToBufferAndGetOldContext();
+      msOWSPrintInspireCommonExtendedCapabilities(
+          stdout, map, "CO", OWS_WARN, "foo",
+          "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
+          "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
+          "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"",
+          validated_language, OWS_WCS);
+
+      new_context = msIO_getHandler(stdout);
+      buffer = (msIOBuffer *)new_context->cbData;
+
+      /* Remove spaces between > and < to get properly indented result */
+      msXMLStripIndentation((char *)buffer->data);
+
+      pInspireTmpDoc = xmlParseDoc((const xmlChar *)buffer->data);
+      pRoot = xmlDocGetRootElement(pInspireTmpDoc);
+      xmlReconciliateNs(psDoc, pRoot);
+
+      pOWSExtendedCapabilities =
+          xmlNewNode(psOwsNs, BAD_CAST "ExtendedCapabilities");
+      xmlAddChild(psOperationsNode, pOWSExtendedCapabilities);
+
+      pDlsExtendedCapabilities =
+          xmlNewNode(psInspireDlsNs, BAD_CAST "ExtendedCapabilities");
+      xmlAddChild(pOWSExtendedCapabilities, pDlsExtendedCapabilities);
+
+      pChild = pRoot->children;
+      while (pChild != NULL) {
+        xmlNodePtr pNext = pChild->next;
+        xmlUnlinkNode(pChild);
+        xmlAddChild(pDlsExtendedCapabilities, pChild);
+        pChild = pNext;
+      }
+
+      msWCSAddInspireDSID20(map, psInspireDlsNs, psInspireCommonNs,
+                            pDlsExtendedCapabilities);
+
+      msIO_restoreOldStdoutContext(old_context);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Service metadata.                                               */
+  /* -------------------------------------------------------------------- */
+
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceMetadata")) {
+    xmlNodePtr psExtensionNode = NULL;
+    psNode = xmlNewChild(psRootNode, psWcsNs, BAD_CAST "ServiceMetadata", NULL);
+
+    /* Apply default formats */
+    msApplyDefaultOutputFormats(map);
+
+    /* Add formats list */
+    format_list = msWCSGetFormatsList20(map, NULL);
+    msLibXml2GenerateList(psNode, psWcsNs, "formatSupported", format_list, ',');
+    msFree(format_list);
+
+    psExtensionNode = xmlNewChild(psNode, psWcsNs, BAD_CAST "Extension", NULL);
+    /* interpolations supported */
+    {
+      /* TODO: use URIs/URLs once they are specified */
+      const char *const interpolation_methods[] = {"NEAREST", "AVERAGE",
+                                                   "BILINEAR"};
+      int i;
+      xmlNodePtr imNode = xmlNewChild(psExtensionNode, psIntNs,
+                                      BAD_CAST "InterpolationMetadata", NULL);
+
+      for (i = 0; i < 3; ++i) {
+        xmlNewChild(imNode, psIntNs, BAD_CAST "InterpolationSupported",
+                    BAD_CAST interpolation_methods[i]);
+      }
+    }
+
+    /* Report the supported CRSs */
+    {
+      char *crs_list = NULL;
+      xmlNodePtr crsMetadataNode =
+          xmlNewChild(psExtensionNode, psCrsNs, BAD_CAST "CrsMetadata", NULL);
+
+      if ((crs_list = msOWSGetProjURI(&(map->projection), &(map->web.metadata),
+                                      "CO", MS_FALSE)) != NULL) {
+        msLibXml2GenerateList(crsMetadataNode, psCrsNs, "crsSupported",
+                              crs_list, ' ');
+        msFree(crs_list);
+      } else {
+        /* could not determine list of CRSs */
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Contents section.                                               */
+  /* -------------------------------------------------------------------- */
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "Contents")) {
+    psNode = xmlNewChild(psRootNode, psWcsNs, BAD_CAST "Contents", NULL);
+
+    if (ows_request->numlayers == 0) {
+      xmlAddChild(psNode, xmlNewComment(BAD_CAST(
+                              "WARNING: No WCS layers are enabled. "
+                              "Check wcs/ows_enable_request settings.")));
+    } else {
+      for (i = 0; i < map->numlayers; ++i) {
+        layerObj *layer = map->layers[i];
+        int status;
+
+        if (!msWCSIsLayerSupported(layer))
+          continue;
+
+        if (!msIntegerInArray(layer->index, ows_request->enabled_layers,
+                              ows_request->numlayers))
+          continue;
+
+        status = msWCSGetCapabilities20_CoverageSummary(psDoc, psNode, layer);
+        if (status != MS_SUCCESS) {
+          msFree(validated_language);
+          xmlFreeDoc(psDoc);
+          xmlCleanupParser();
+          return msWCSException(map, "Internal", "mapserv", params->version);
+        }
+      }
+    }
+  }
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document and clean up.                            */
+  /* -------------------------------------------------------------------- */
+  msWCSWriteDocument20(psDoc);
+  msFree(validated_language);
+  xmlFreeDoc(psDoc);
+  if (pInspireTmpDoc)
+    xmlFreeDoc(pInspireTmpDoc);
+  xmlCleanupParser();
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSDescribeCoverage20_CoverageDescription()      */
+/*                                                                      */
+/*      Creates a description of a specific coverage with the three     */
+/*      major sections: BoundedBy, DomainSet and RangeType.             */
+/************************************************************************/
+
+static int msWCSDescribeCoverage20_CoverageDescription(layerObj *layer,
+                                                       xmlDocPtr psDoc,
+                                                       xmlNodePtr psRootNode) {
+  int status, swapAxes;
+  wcs20coverageMetadataObj cm;
+  xmlNodePtr psCD;
+  xmlNsPtr psWcsNs, psGmlNs, psGmlcovNs, psSweNs, psXLinkNs;
+  psWcsNs = psGmlNs = psGmlcovNs = psSweNs = psXLinkNs = NULL;
+
+  psWcsNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+  psGmlNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                        BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+  psGmlcovNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                           BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
+  psSweNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                        BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
+  psXLinkNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                          BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+
+  /* -------------------------------------------------------------------- */
+  /*      Verify layer is processable.                                    */
+  /* -------------------------------------------------------------------- */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  if (!msWCSIsLayerSupported(layer))
+    return MS_SUCCESS;
+
+  /* -------------------------------------------------------------------- */
+  /*      Setup coverage metadata.                                        */
+  /* -------------------------------------------------------------------- */
+  status = msWCSGetCoverageMetadata20(layer, &cm);
+  if (status != MS_SUCCESS)
+    return status;
+
+  swapAxes = msWCSSwapAxes20(cm.srs_uri);
+
+  /* fill in bands rangeset info, if required. */
+  /* msWCSSetDefaultBandsRangeSetInfo( NULL, &cm, layer ); */
+
+  /* -------------------------------------------------------------------- */
+  /*      Create CoverageDescription node.                                */
+  /* -------------------------------------------------------------------- */
+  psCD = xmlNewChild(psRootNode, psWcsNs, BAD_CAST "CoverageDescription", NULL);
+  xmlNewNsProp(psCD, psGmlNs, BAD_CAST "id", BAD_CAST layer->name);
+
+  /* -------------------------------------------------------------------- */
+  /*      gml:boundedBy                                                   */
+  /* -------------------------------------------------------------------- */
+  msWCSCommon20_CreateBoundedBy(&cm, psGmlNs, psCD, &(layer->projection),
+                                swapAxes);
+
+  xmlNewChild(psCD, psWcsNs, BAD_CAST "CoverageId", BAD_CAST layer->name);
+
+  /* -------------------------------------------------------------------- */
+  /*      gml:domainSet                                                   */
+  /* -------------------------------------------------------------------- */
+  msWCSCommon20_CreateDomainSet(layer, &cm, psGmlNs, psCD, &(layer->projection),
+                                swapAxes);
+
+  /* -------------------------------------------------------------------- */
+  /*      gmlcov:rangeType                                                */
+  /* -------------------------------------------------------------------- */
+  msWCSCommon20_CreateRangeType(&cm, NULL, psGmlcovNs, psSweNs, psCD);
+
+  /* -------------------------------------------------------------------- */
+  /*      wcs:ServiceParameters                                           */
+  /* -------------------------------------------------------------------- */
+  {
+    xmlNodePtr psSP;
+
+    psSP = xmlNewChild(psCD, psWcsNs, BAD_CAST "ServiceParameters", NULL);
+    xmlNewChild(psSP, psWcsNs, BAD_CAST "CoverageSubtype",
+                BAD_CAST "RectifiedGridCoverage");
+
+    /* -------------------------------------------------------------------- */
+    /*      SupportedCRS                                                    */
+    /* -------------------------------------------------------------------- */
+    /* for now, WCS 2.0 does not allow per coverage CRS definitions */
+    /*{
+      xmlNodePtr psSupportedCrss;
+      char *owned_value;
+
+      psSupportedCrss = xmlNewChild(psSP, psWcsNs,
+                                    BAD_CAST "SupportedCRSs", NULL);
+
+      if ((owned_value = msOWSGetProjURI(&(layer->projection),
+                                         &(layer->metadata), "CO", MS_FALSE)) !=
+    NULL) { } else if ((owned_value = msOWSGetProjURI(&(layer->map->projection),
+                                              &(layer->map->web.metadata), "CO",
+    MS_FALSE)) != NULL) { } else { msDebug("missing required information, no
+    SRSs defined.\n");
+      }
+
+      if (owned_value != NULL && strlen(owned_value) > 0) {
+        msLibXml2GenerateList(psSupportedCrss, psWcsNs,
+                              "SupportedCRS", owned_value, ' ');
+      }
+
+      xmlNewChild(psSupportedCrss, psWcsNs,
+                  BAD_CAST "NativeCRS", BAD_CAST cm.srs_uri);
+
+      msFree(owned_value);
+    }*/
+
+    /* -------------------------------------------------------------------- */
+    /*      SupportedFormats                                                */
+    /* -------------------------------------------------------------------- */
+    /* for now, WCS 2.0 does not allow per coverage format definitions */
+    /*{
+      xmlNodePtr psSupportedFormats;
+      char *format_list;
+
+      psSupportedFormats =
+      xmlNewChild(psSP, psWcsNs, BAD_CAST "SupportedFormats", NULL);
+
+      format_list = msWCSGetFormatsList20(layer->map, layer);
+
+      if (strlen(format_list) > 0) {
+        msLibXml2GenerateList(psSupportedFormats, psWcsNs,
+                              "SupportedFormat", format_list, ',');
+
+      msFree(format_list);
+    }*/
+
+    /* -------------------------------------------------------------------- */
+    /*      nativeFormat                                                    */
+    /* -------------------------------------------------------------------- */
+    xmlNewChild(psSP, psWcsNs, BAD_CAST "nativeFormat",
+                BAD_CAST(cm.native_format ? cm.native_format : ""));
+
+    if (!cm.native_format) {
+      msDebug("msWCSDescribeCoverage20_CoverageDescription(): "
+              "No native format specified.\n");
+    }
+  }
+
+  msWCSClearCoverageMetadata20(&cm);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSDescribeCoverage20()                          */
+/*                                                                      */
+/*      Implementation of the DescibeCoverage Operation. The result     */
+/*      of this operation is a xml document, containing specific        */
+/*      information about a coverage identified by an ID. The result    */
+/*      is written on the stream.                                       */
+/************************************************************************/
+
+int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params,
+                            owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode;
+  xmlNsPtr psWcsNs = NULL;
+  int i, j;
+
+  /* create DOM document and root node */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+  psRootNode = xmlNewNode(NULL, BAD_CAST "CoverageDescriptions");
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* prepare initial namespace definitions */
+  msWCSPrepareNamespaces20(psDoc, psRootNode, map, MS_FALSE);
+
+  psWcsNs = xmlSearchNs(psDoc, psRootNode,
+                        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+  xmlSetNs(psRootNode, psWcsNs);
+
+  /* check if IDs are given */
+  if (params->ids) {
+    /* for each given ID in the ID-list */
+    for (j = 0; params->ids[j]; j++) {
+      i = msGetLayerIndex(map, params->ids[j]);
+      if (i == -1 || (!msIntegerInArray(GET_LAYER(map, i)->index,
+                                        ows_request->enabled_layers,
+                                        ows_request->numlayers))) {
+        msSetError(MS_WCSERR, "Unknown coverage: (%s)",
+                   "msWCSDescribeCoverage20()", params->ids[j]);
+        return msWCSException(map, "NoSuchCoverage", "coverage",
+                              params->version);
+      }
+      /* create coverage description for the specified layer */
+      if (msWCSDescribeCoverage20_CoverageDescription(
+              (GET_LAYER(map, i)), psDoc, psRootNode) == MS_FAILURE) {
+        msSetError(MS_WCSERR, "Error retrieving coverage description.",
+                   "msWCSDescribeCoverage20()");
+        return msWCSException(map, "MissingParameterValue", "coverage",
+                              params->version);
+      }
+    }
+  } else {
+    /* Throw error, since IDs are mandatory */
+    msSetError(MS_WCSERR, "Missing COVERAGEID parameter.",
+               "msWCSDescribeCoverage20()");
+    return msWCSException(map, "MissingParameterValue", "coverage",
+                          params->version);
+  }
+
+  /* write out the DOM document to the stream */
+  msWCSWriteDocument20(psDoc);
+
+  /* cleanup */
+  xmlFreeDoc(psDoc);
+  xmlCleanupParser();
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSGetCoverage_FinalizeParamsObj20()             */
+/*                                                                      */
+/*      Finalizes a wcs20ParamsObj for a GetCoverage operation. In the  */
+/*      process, the params boundig box is adjusted to the subsets,     */
+/*      width, height and resolution are determined and the subset crs  */
+/*      is found out.                                                   */
+/************************************************************************/
+
+static int msWCSGetCoverage20_FinalizeParamsObj(wcs20ParamsObjPtr params,
+                                                wcs20AxisObjPtr *axes) {
+  char *crs = NULL;
+  int have_scale, have_size, have_resolution;
+  int have_global_scale = (params->scale != MS_WCS20_UNBOUNDED) ? 1 : 0;
+
+  if (axes[0] != NULL) {
+    if (axes[0]->subset != NULL) {
+      msDebug("Subset for X-axis found: %s\n", axes[0]->subset->axis);
+      if (!axes[0]->subset->min.unbounded)
+        params->bbox.minx = axes[0]->subset->min.scalar;
+      if (!axes[0]->subset->max.unbounded)
+        params->bbox.maxx = axes[0]->subset->max.scalar;
+      crs = axes[0]->subset->crs;
+    }
+    params->width = axes[0]->size;
+    params->resolutionX = axes[0]->resolution;
+    params->scaleX = axes[0]->scale;
+
+    if (axes[0]->resolutionUOM != NULL) {
+      params->resolutionUnits = msStrdup(axes[0]->resolutionUOM);
+    }
+
+    have_scale = (params->scaleX != MS_WCS20_UNBOUNDED) ? 1 : 0;
+    have_size = (params->width != 0) ? 1 : 0;
+    have_resolution = (params->resolutionX != MS_WCS20_UNBOUNDED) ? 1 : 0;
+
+    if ((have_global_scale + have_scale + have_size + have_resolution) > 1) {
+      msSetError(
+          MS_WCSERR,
+          "Axis '%s' defines scale, size and/or resolution multiple times.",
+          "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name);
+      return MS_FAILURE;
+    }
+  }
+
+  if (axes[1] != NULL) {
+    if (axes[1]->subset != NULL) {
+      msDebug("Subset for Y-axis found: %s\n", axes[1]->subset->axis);
+      if (!axes[1]->subset->min.unbounded)
+        params->bbox.miny = axes[1]->subset->min.scalar;
+      if (!axes[1]->subset->max.unbounded)
+        params->bbox.maxy = axes[1]->subset->max.scalar;
+      if (crs != NULL && axes[0] != NULL && axes[0]->subset != NULL) {
+        if (!EQUAL(crs, axes[1]->subset->crs)) {
+          msSetError(MS_WCSERR, "CRS for axis %s and axis %s are not the same.",
+                     "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name,
+                     axes[1]->name);
+          return MS_FAILURE;
+        }
+      } else {
+        crs = axes[1]->subset->crs;
+      }
+    }
+    params->height = axes[1]->size;
+    params->resolutionY = axes[1]->resolution;
+    params->scaleY = axes[1]->scale;
+
+    if (params->resolutionUnits == NULL && axes[1]->resolutionUOM != NULL) {
+      params->resolutionUnits = msStrdup(axes[1]->resolutionUOM);
+    } else if (params->resolutionUnits != NULL &&
+               axes[1]->resolutionUOM != NULL &&
+               !EQUAL(params->resolutionUnits, axes[1]->resolutionUOM)) {
+      msSetError(MS_WCSERR,
+                 "The units of measure of the resolution for"
+                 "axis %s and axis %s are not the same.",
+                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name,
+                 axes[1]->name);
+      return MS_FAILURE;
+    }
+
+    have_scale = (params->scaleY != MS_WCS20_UNBOUNDED) ? 1 : 0;
+    have_size = (params->height != 0) ? 1 : 0;
+    have_resolution = (params->resolutionY != MS_WCS20_UNBOUNDED) ? 1 : 0;
+
+    if ((have_global_scale + have_scale + have_size + have_resolution) > 1) {
+      msSetError(
+          MS_WCSERR,
+          "Axis '%s' defines scale, size and/or resolution multiple times.",
+          "msWCSGetCoverage20_FinalizeParamsObj()", axes[1]->name);
+      return MS_FAILURE;
+    }
+  }
+
+  /* if scale is globally set, use this value instead */
+  if (params->scale != MS_WCS20_UNBOUNDED) {
+    params->scaleX = params->scaleY = params->scale;
+  }
+
+  /* check if projections are equal */
+  if (crs != NULL) {
+    if (params->subsetcrs && !EQUAL(crs, params->subsetcrs)) {
+      /* already set and not equal -> raise exception */
+      msSetError(MS_WCSERR,
+                 "SubsetCRS does not match the CRS of the axes: "
+                 "'%s' != '%s'",
+                 "msWCSCreateBoundingBox20()", params->subsetcrs, crs);
+      return MS_FAILURE;
+    } else if (params->subsetcrs) {
+      /* equal, and already set -> do nothing */
+    } else {
+      /* not yet globally set -> set it */
+      params->subsetcrs = msStrdup(crs);
+    }
+  } else if (!params->subsetcrs) {
+    /* default to CRS of image */
+    /* leave params->subsetcrs to null */
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSGetCoverage20_GetBands()                      */
+/*                                                                      */
+/*      Returns a string, containing a comma-separated list of band     */
+/*      indices.                                                        */
+/************************************************************************/
+
+static int msWCSGetCoverage20_GetBands(layerObj *layer,
+                                       wcs20ParamsObjPtr params,
+                                       wcs20coverageMetadataObjPtr cm,
+                                       char **bandlist) {
+  int maxlen, index;
+  char *interval_stop;
+  char **band_ids = NULL;
+
+  /* if rangesubset parameter is not given, default to all bands */
+  if (NULL == params->range_subset) {
+    *bandlist = msStrdup("1");
+    for (unsigned i = 1; i < cm->numbands; ++i) {
+      char strnumber[12];
+      snprintf(strnumber, sizeof(strnumber), ",%d", i + 1);
+      *bandlist = msStringConcatenate(*bandlist, strnumber);
+    }
+    return MS_SUCCESS;
+  }
+
+  maxlen = cm->numbands * 4 * sizeof(char);
+  *bandlist = static_cast<char *>(msSmallCalloc(sizeof(char), maxlen));
+
+  /* Use WCS 2.0 metadata items in priority */
+  {
+    char *tmp =
+        msOWSGetEncodeMetadata(&layer->metadata, "CO", "band_names", NULL);
+
+    if (NULL == tmp) {
+      /* Otherwise default to WCS 1.x*/
+      tmp =
+          msOWSGetEncodeMetadata(&layer->metadata, "CO", "rangeset_axes", NULL);
+      /* "bands" has a special processing in WCS 1.0. See */
+      /* msWCSSetDefaultBandsRangeSetInfo */
+      if (tmp != NULL && EQUAL(tmp, "bands")) {
+        int num_band_names = cm->numbands;
+        band_ids = (char **)msSmallCalloc(sizeof(char *), (num_band_names + 1));
+        for (int i = 0; i < num_band_names; i++) {
+          char szName[30];
+          snprintf(szName, sizeof(szName), "Band%d", i + 1);
+          band_ids[i] = msStrdup(szName);
+        }
+      }
+    }
+
+    if (NULL != tmp && band_ids == NULL) {
+      band_ids = CSLTokenizeString2(tmp, " ", 0);
+    }
+    msFree(tmp);
+  }
+
+  /* If we still don't have band names, use the band names from the coverage
+   * metadata */
+  if (band_ids == NULL) {
+    band_ids = (char **)CPLCalloc(sizeof(char *), (cm->numbands + 1));
+    for (unsigned i = 0; i < cm->numbands; ++i) {
+      band_ids[i] = CPLStrdup(cm->bands[i].name);
+    }
+  }
+
+  /* Iterate over all supplied range */
+  const int count = CSLCount(params->range_subset);
+  for (int i = 0; i < count; ++i) {
+    /* RangeInterval case: defined as "<start>:<stop>" */
+    if ((interval_stop = strchr(params->range_subset[i], ':')) != NULL) {
+      int start, stop;
+      *interval_stop = '\0';
+      ++interval_stop;
+
+      /* check if the string represents an integer */
+      if (msStringParseInteger(params->range_subset[i], &start) == MS_SUCCESS) {
+      }
+      /* get index of start clause, or raise an error if none was found */
+      else if ((start = CSLFindString(band_ids, params->range_subset[i])) !=
+               -1) {
+        start += 1; /* adjust index, since GDAL bands start with index 1 */
+      } else {
+        msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
+                   "msWCSGetCoverage20_GetBands()", params->range_subset[i]);
+        return MS_FAILURE;
+      }
+
+      /* check if the string represents an integer */
+      if (msStringParseInteger(interval_stop, &stop) == MS_SUCCESS) {
+      }
+      /* get index of stop clause, or raise an error if none was found */
+      else if ((stop = CSLFindString(band_ids, interval_stop)) != -1) {
+        stop += 1; /* adjust index, since GDAL bands start with index 1 */
+      } else {
+        msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
+                   "msWCSGetCoverage20_GetBands()", interval_stop);
+        return MS_FAILURE;
+      }
+
+      /* Check whether or not start and stop are different and stop is higher
+       * than start */
+      if (stop <= start) {
+        msSetError(MS_WCSERR, "Invalid range interval given.",
+                   "msWCSGetCoverage20_GetBands()");
+        return MS_FAILURE;
+      } else if (start < 1 || static_cast<unsigned>(stop) > cm->numbands) {
+        msSetError(MS_WCSERR, "Band interval is out of the valid range: 1-%d",
+                   "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
+        return MS_FAILURE;
+      }
+
+      /* expand the interval to a list of indices and push them on the list */
+      for (int j = start; j <= stop; ++j) {
+        char *tmp;
+        if (i != 0 || j != start) {
+          strlcat(*bandlist, ",", maxlen);
+        }
+        tmp = msIntToString(j);
+        strlcat(*bandlist, tmp, maxlen);
+        msFree(tmp);
+      }
+    }
+    /* RangeComponent case */
+    else {
+      if (i != 0) {
+        strlcat(*bandlist, ",", maxlen);
+      }
+
+      /* check if the string represents an integer */
+      if (msStringParseInteger(params->range_subset[i], &index) == MS_SUCCESS) {
+        char *tmp;
+        if (index < 1 || static_cast<unsigned>(index) > cm->numbands) {
+          msSetError(MS_WCSERR, "Band index is out of the valid range: 1-%d",
+                     "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
+          return MS_FAILURE;
+        }
+
+        tmp = msIntToString((int)index);
+        strlcat(*bandlist, tmp, maxlen);
+        msFree(tmp);
+        continue;
+      }
+
+      /* check if the string is equal to a band identifier    */
+      /* if so, what is the index of the band                 */
+      if ((index = CSLFindString(band_ids, params->range_subset[i])) != -1) {
+        char *tmp = msIntToString((int)index + 1);
+        strlcat(*bandlist, tmp, maxlen);
+        msFree(tmp);
+      } else {
+        msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
+                   "msWCSGetCoverage20_GetBands()", params->range_subset[i]);
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  CSLDestroy(band_ids);
+  return MS_SUCCESS;
+}
+
+/* Fixes CPLParseNameValue to allow ':' characters for namespaced keys */
+
+static const char *fixedCPLParseNameValue(const char *string, char **key) {
+  const char *value;
+  size_t size;
+  value = strchr(string, '=');
+
+  if (value == NULL) {
+    *key = NULL;
+    return NULL;
+  }
+
+  size = value - string;
+  *key = static_cast<char *>(msSmallMalloc(size + 1));
+  strncpy(*key, string, size + 1);
+  (*key)[size] = '\0';
+  return value + 1;
+}
+
+/************************************************************************/
+/*                   msWCSSetFormatParams20()                           */
+/*                                                                      */
+/*      Parses the given format options and sets the appropriate        */
+/*      output format values.                                           */
+/************************************************************************/
+
+static int msWCSSetFormatParams20(outputFormatObj *format,
+                                  char **format_options) {
+  /* currently geotiff only */
+  char *format_option;
+  int i = 0;
+  int is_geotiff = (format->mimetype && EQUAL(format->mimetype, "image/tiff"));
+
+  if (!is_geotiff || !format_options) {
+    /* Currently only geotiff available */
+    return MS_SUCCESS;
+  }
+
+  format_option = format_options[0];
+  while (format_option) {
+    /* key, value */
+    char *key;
+    const char *value = fixedCPLParseNameValue(format_option, &key);
+
+    if (!key) {
+      msSetError(MS_WCSERR, "Could not deduct the option key.",
+                 "msWCSSetFormatParams20()");
+      return MS_FAILURE;
+    } else if (!value) {
+      msSetError(MS_WCSERR, "Missing value for parameter '%s'.",
+                 "msWCSSetFormatParams20()", key);
+      return MS_FAILURE;
+    }
+
+    if (EQUAL(key, "geotiff:compression") && is_geotiff) {
+      /*COMPRESS=[JPEG/LZW/PACKBITS/DEFLATE/CCITTRLE/CCITTFAX3/CCITTFAX4/NONE]*/
+      if (EQUAL(value, "None")) {
+        msSetOutputFormatOption(format, "COMPRESS", "NONE");
+      } else if (EQUAL(value, "PackBits")) {
+        msSetOutputFormatOption(format, "COMPRESS", "PACKBITS");
+      } else if (EQUAL(value, "Deflate")) {
+        msSetOutputFormatOption(format, "COMPRESS", "DEFLATE");
+      } else if (EQUAL(value, "Huffman")) {
+        msSetOutputFormatOption(format, "COMPRESS", "CCITTRLE");
+      } else if (EQUAL(value, "LZW")) {
+        msSetOutputFormatOption(format, "COMPRESS", "LZW");
+      } else if (EQUAL(value, "JPEG")) {
+        msSetOutputFormatOption(format, "COMPRESS", "JPEG");
+      }
+      /* unsupported compression methods: CCITTFAX3/CCITTFAX4 */
+      else {
+        msSetError(MS_WCSERR, "Compression method '%s' not supported.",
+                   "msWCSSetFormatParams20()", value);
+        return MS_FAILURE;
+      }
+    }
+
+    else if (EQUAL(key, "geotiff:jpeg_quality") && is_geotiff) {
+      int quality;
+      /* JPEG_QUALITY=[1-100] */
+      if (msStringParseInteger(value, &quality) != MS_SUCCESS) {
+        msSetError(MS_WCSERR, "Could not parse jpeg_quality value.",
+                   "msWCSSetFormatParams20()");
+        return MS_FAILURE;
+      } else if (quality < 1 || quality > 100) {
+        msSetError(MS_WCSERR, "Invalid jpeg_quality value '%d'.",
+                   "msWCSSetFormatParams20()", quality);
+        return MS_FAILURE;
+      }
+      msSetOutputFormatOption(format, "JPEG_QUALITY", value);
+    } else if (EQUAL(key, "geotiff:predictor") && is_geotiff) {
+      /* PREDICTOR=[None/Horizontal/FloatingPoint] */
+      const char *predictor;
+      if (EQUAL(value, "None") || EQUAL(value, "1")) {
+        predictor = "1";
+      } else if (EQUAL(value, "Horizontal") || EQUAL(value, "2")) {
+        predictor = "2";
+      } else if (EQUAL(value, "FloatingPoint") || EQUAL(value, "3")) {
+        predictor = "3";
+      } else {
+        msSetError(MS_WCSERR, "Invalid predictor value '%s'.",
+                   "msWCSSetFormatParams20()", value);
+        return MS_FAILURE;
+      }
+      msSetOutputFormatOption(format, "PREDICTOR", predictor);
+    } else if (EQUAL(key, "geotiff:interleave") && is_geotiff) {
+      /* INTERLEAVE=[BAND,PIXEL] */
+      if (EQUAL(value, "Band")) {
+        msSetOutputFormatOption(format, "INTERLEAVE", "BAND");
+      } else if (EQUAL(value, "Pixel")) {
+        msSetOutputFormatOption(format, "INTERLEAVE", "PIXEL");
+      } else {
+        msSetError(MS_WCSERR, "Interleave method '%s' not supported.",
+                   "msWCSSetFormatParams20()", value);
+        return MS_FAILURE;
+      }
+    } else if (EQUAL(key, "geotiff:tiling") && is_geotiff) {
+      /* TILED=YES */
+      if (EQUAL(value, "true")) {
+        msSetOutputFormatOption(format, "TILED", "YES");
+      } else if (EQUAL(value, "false")) {
+        msSetOutputFormatOption(format, "TILED", "NO");
+      } else {
+        msSetError(MS_WCSERR, "Invalid boolean value '%s'.",
+                   "msWCSSetFormatParams20()", value);
+        return MS_FAILURE;
+      }
+    } else if (EQUAL(key, "geotiff:tileheight") && is_geotiff) {
+      /* BLOCKXSIZE=n */
+      int tileheight;
+
+      if (msStringParseInteger(value, &tileheight) != MS_SUCCESS) {
+        msSetError(MS_WCSERR, "Could not parse tileheight value.",
+                   "msWCSSetFormatParams20()");
+        return MS_FAILURE;
+      } else if (tileheight < 1 || tileheight % 16) {
+        msSetError(MS_WCSERR,
+                   "Invalid tileheight value '%d'. "
+                   "Must be greater than 0 and dividable by 16.",
+                   "msWCSSetFormatParams20()", tileheight);
+        return MS_FAILURE;
+      }
+      msSetOutputFormatOption(format, "BLOCKXSIZE", value);
+    } else if (EQUAL(key, "geotiff:tilewidth") && is_geotiff) {
+      /* BLOCKYSIZE=n */
+      int tilewidth;
+
+      if (msStringParseInteger(value, &tilewidth) != MS_SUCCESS) {
+        msSetError(MS_WCSERR, "Could not parse tilewidth value.",
+                   "msWCSSetFormatParams20()");
+        return MS_FAILURE;
+      } else if (tilewidth < 1 || tilewidth % 16) {
+        msSetError(MS_WCSERR,
+                   "Invalid tilewidth value '%d'. "
+                   "Must be greater than 0 and dividable by 16.",
+                   "msWCSSetFormatParams20()", tilewidth);
+        return MS_FAILURE;
+      }
+      msSetOutputFormatOption(format, "BLOCKYSIZE", value);
+    } else if (EQUALN(key, "geotiff:", 8)) {
+      msSetError(MS_WCSERR, "Unrecognized GeoTIFF parameter '%s'.",
+                 "msWCSSetFormatParams20()", key);
+      return MS_FAILURE;
+    }
+
+    msFree(key);
+
+    /* fetch next option */
+    format_option = format_options[++i];
+  }
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                   msWCSGetCoverage20()                               */
+/*                                                                      */
+/*      Implementation of the GetCoverage Operation. The coverage       */
+/*      is either returned as an image or as a multipart xml/image.     */
+/*      The result is written on the stream.                            */
+/************************************************************************/
+
+int msWCSGetCoverage20(mapObj *map, cgiRequestObj *request,
+                       wcs20ParamsObjPtr params, owsRequestObj *ows_request) {
+  (void)request;
+  layerObj *layer = NULL;
+  wcs20coverageMetadataObj cm;
+  imageObj *image = NULL;
+  outputFormatObj *format = NULL;
+
+  rectObj subsets, bbox;
+  projectionObj imageProj;
+
+  int status, i;
+  double x_1, x_2, y_1, y_2;
+  char *coverageName, *bandlist = NULL, numbands[12];
+
+  int doDrawRasterLayerDraw = MS_TRUE;
+  GDALDatasetH hDS = NULL;
+
+  int widthFromComputationInImageCRS = 0;
+  int heightFromComputationInImageCRS = 0;
+
+  /* number of coverage ids should be 1 */
+  if (params->ids == NULL || params->ids[0] == NULL) {
+    msSetError(MS_WCSERR, "Required parameter CoverageID was not supplied.",
+               "msWCSGetCoverage20()");
+    return msWCSException(map, "MissingParameterValue", "coverage",
+                          params->version);
+  }
+  if (params->ids[1] != NULL) {
+    msSetError(MS_WCSERR, "GetCoverage operation supports only one coverage.",
+               "msWCSGetCoverage20()");
+    return msWCSException(map, "TooManyParameterValues", "coverage",
+                          params->version);
+  }
+
+  /* find the right layer */
+  layer = NULL;
+  for (i = 0; i < map->numlayers; i++) {
+    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                          "name", GET_LAYER(map, i)->name);
+    if (EQUAL(coverageName, params->ids[0]) &&
+        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))) {
+      layer = GET_LAYER(map, i);
+      i = map->numlayers; /* to exit loop don't use break, we want to free
+                             resources first */
+    }
+    msFree(coverageName);
+  }
+
+  /* throw exception if no Layer was found */
+  if (layer == NULL) {
+    msSetError(
+        MS_WCSERR,
+        "COVERAGEID=%s not found, not in supported layer list. A layer might be disabled for \
+this request. Check wcs/ows_enable_request settings.",
+        "msWCSGetCoverage20()", params->ids[0]);
+    return msWCSException(map, "NoSuchCoverage", "coverageid", params->version);
+  }
+  /* retrieve coverage metadata  */
+  status = msWCSGetCoverageMetadata20(layer, &cm);
+  if (status != MS_SUCCESS) {
+    msWCSClearCoverageMetadata20(&cm);
+    return MS_FAILURE;
+  }
+
+  /* fill in bands rangeset info, if required.  */
+  /* msWCSSetDefaultBandsRangeSetInfo(NULL, &cm, layer ); */
+
+  /* set  resolution, size and maximum extent */
+  layer->extent = map->extent = cm.extent;
+  map->cellsize = cm.xresolution;
+  map->width = cm.xsize;
+  map->height = cm.ysize;
+
+  /************************************************************************/
+  /*      finalize the params object. determine subset crs and subset     */
+  /*      bbox. Also project the image to the subset crs.                 */
+  /************************************************************************/
+
+  msInitProjection(&imageProj);
+  msProjectionInheritContextFrom(&imageProj, &(layer->projection));
+  if (msLoadProjectionString(&imageProj, cm.srs_epsg) == -1) {
+    msFreeProjection(&imageProj);
+    msWCSClearCoverageMetadata20(&cm);
+    msSetError(MS_WCSERR, "Error loading CRS %s.", "msWCSGetCoverage20()",
+               cm.srs_epsg);
+    return msWCSException(map, "InvalidParameterValue", "projection",
+                          params->version);
+  }
+
+  /* iterate over all subsets and check if they are valid*/
+  for (i = 0; i < params->numaxes; ++i) {
+    if (params->axes[i]->subset != NULL) {
+      if (params->axes[i]->subset->timeOrScalar == MS_WCS20_TIME_VALUE) {
+        msFreeProjection(&imageProj);
+        msWCSClearCoverageMetadata20(&cm);
+        msSetError(MS_WCSERR, "Time values for subsets are not supported. ",
+                   "msWCSGetCoverage20()");
+        return msWCSException(map, "InvalidSubsetting", "subset",
+                              params->version);
+      }
+      if (params->axes[i]->subset->operation == MS_WCS20_SLICE) {
+        msFreeProjection(&imageProj);
+        msWCSClearCoverageMetadata20(&cm);
+        msSetError(MS_WCSERR, "Subset operation 'slice' is not supported.",
+                   "msWCSGetCoverage20()");
+        return msWCSException(map, "InvalidSubsetting", "subset",
+                              params->version);
+      }
+    }
+  }
+
+  {
+    wcs20AxisObjPtr axes[2];
+    if (msWCSValidateAndFindAxes20(params, axes) == MS_FAILURE) {
+      msFreeProjection(&imageProj);
+      msWCSClearCoverageMetadata20(&cm);
+      return msWCSException(map, "InvalidAxisLabel", "subset", params->version);
+    }
+    if (msWCSGetCoverage20_FinalizeParamsObj(params, axes) == MS_FAILURE) {
+      msFreeProjection(&imageProj);
+      msWCSClearCoverageMetadata20(&cm);
+      return msWCSException(map, "InvalidParameterValue", "extent",
+                            params->version);
+    }
+  }
+
+  subsets = params->bbox;
+
+  /* if no subsetCRS was specified use the coverages CRS
+     (Requirement 27 of the WCS 2.0 specification) */
+  if (!params->subsetcrs) {
+    params->subsetcrs = msStrdup(cm.srs_epsg);
+  }
+
+  if (EQUAL(params->subsetcrs, "imageCRS")) {
+    /* subsets are in imageCRS; reproject them to real coordinates */
+    rectObj orig_bbox = subsets;
+
+    msFreeProjection(&(map->projection));
+    map->projection = imageProj;
+
+    if (subsets.minx != -DBL_MAX || subsets.maxx != DBL_MAX) {
+      x_1 = cm.geotransform[0] + orig_bbox.minx * cm.geotransform[1] +
+            orig_bbox.miny * cm.geotransform[2];
+      // below +1 look suspicious to me (E. Rouault) and probably mean that
+      // there are still issues with pixel-center vs pixel-corner convention
+      // The resolution computed on wcs_20_post_getcov_trim_x_y_both_1px
+      // with that is 11, whereas it should be 10
+      x_2 = cm.geotransform[0] + (orig_bbox.maxx + 1) * cm.geotransform[1] +
+            (orig_bbox.maxy + 1) * cm.geotransform[2];
+
+      subsets.minx = MS_MIN(x_1, x_2);
+      subsets.maxx = MS_MAX(x_1, x_2);
+    }
+    if (subsets.miny != -DBL_MAX || subsets.maxy != DBL_MAX) {
+      // below +1 are suspicious. See bove comment in the minx/maxx cases
+      y_1 = cm.geotransform[3] + (orig_bbox.maxx + 1) * cm.geotransform[4] +
+            (orig_bbox.maxy + 1) * cm.geotransform[5];
+      /*subsets.miny -= cm.geotransform[4]/2 + cm.geotransform[5]/2;*/
+      y_2 = cm.geotransform[3] + orig_bbox.minx * cm.geotransform[4] +
+            orig_bbox.miny * cm.geotransform[5];
+
+      subsets.miny = MS_MIN(y_1, y_2);
+      subsets.maxy = MS_MAX(y_1, y_2);
+    }
+  } else { /* if crs is not the 'imageCRS' */
+    projectionObj subsetProj;
+
+    /* if the subsets have a crs given, project the image extent to it */
+    msInitProjection(&subsetProj);
+    msProjectionInheritContextFrom(&subsetProj, &(layer->projection));
+    if (msLoadProjectionString(&subsetProj, params->subsetcrs) != MS_SUCCESS) {
+      msFreeProjection(&subsetProj);
+      msFreeProjection(&imageProj);
+      msWCSClearCoverageMetadata20(&cm);
+      msSetError(MS_WCSERR, "Error loading CRS %s.", "msWCSGetCoverage20()",
+                 params->subsetcrs);
+      return msWCSException(map, "InvalidParameterValue", "projection",
+                            params->version);
+    }
+
+    if (msProjectionsDiffer(&imageProj, &subsetProj)) {
+
+      /* Reprojection of source raster extent of (-180,-90,180,90) to any */
+      /* projected CRS is going to exhibit strong anomalies. So instead */
+      /* do the reverse, project the subset extent to the layer CRS, and */
+      /* see how much the subset extent takes with respect to the source */
+      /* raster extent. This is only used if output width and resolutionX (or */
+      /* (height and resolutionY) are unknown. */
+      if (((params->width == 0 && params->resolutionX == MS_WCS20_UNBOUNDED) ||
+           (params->height == 0 &&
+            params->resolutionY == MS_WCS20_UNBOUNDED)) &&
+          (msProjIsGeographicCRS(&imageProj) &&
+           !msProjIsGeographicCRS(&subsetProj) &&
+           fabs(layer->extent.minx - -180.0) < 1e-5 &&
+           fabs(layer->extent.miny - -90.0) < 1e-5 &&
+           fabs(layer->extent.maxx - 180.0) < 1e-5 &&
+           fabs(layer->extent.maxy - 90.0) < 1e-5)) {
+        rectObj subsetInImageProj = subsets;
+        if (msProjectRect(&subsetProj, &imageProj, &(subsetInImageProj)) ==
+            MS_SUCCESS) {
+          subsetInImageProj.minx =
+              MS_MAX(subsetInImageProj.minx, layer->extent.minx);
+          subsetInImageProj.miny =
+              MS_MAX(subsetInImageProj.miny, layer->extent.miny);
+          subsetInImageProj.maxx =
+              MS_MIN(subsetInImageProj.maxx, layer->extent.maxx);
+          subsetInImageProj.maxy =
+              MS_MIN(subsetInImageProj.maxy, layer->extent.maxy);
+          {
+            double total = ABS(layer->extent.maxx - layer->extent.minx);
+            double part = ABS(subsetInImageProj.maxx - subsetInImageProj.minx);
+            widthFromComputationInImageCRS =
+                MS_NINT((part * map->width) / total);
+          }
+          {
+            double total = ABS(layer->extent.maxy - layer->extent.miny);
+            double part = ABS(subsetInImageProj.maxy - subsetInImageProj.miny);
+            heightFromComputationInImageCRS =
+                MS_NINT((part * map->height) / total);
+          }
+        }
+      }
+
+      msProjectRect(&imageProj, &subsetProj, &(layer->extent));
+      map->extent = layer->extent;
+      msFreeProjection(&(map->projection));
+      map->projection = subsetProj;
+      msFreeProjection(&imageProj);
+    } else {
+      msFreeProjection(&(map->projection));
+      map->projection = imageProj;
+      msFreeProjection(&subsetProj);
+    }
+  }
+
+  /* create boundings of params subsets and image extent */
+  if (msRectOverlap(&subsets, &(layer->extent)) == MS_FALSE) {
+    /* extent and bbox do not overlap -> exit */
+    msWCSClearCoverageMetadata20(&cm);
+    msSetError(MS_WCSERR,
+               "Image extent does not intersect with desired region.",
+               "msWCSGetCoverage20()");
+    return msWCSException(map, "ExtentError", "extent", params->version);
+  }
+
+  /* write combined bounding box */
+  bbox.minx = MS_MAX(subsets.minx, map->extent.minx);
+  bbox.miny = MS_MAX(subsets.miny, map->extent.miny);
+  bbox.maxx = MS_MIN(subsets.maxx, map->extent.maxx);
+  bbox.maxy = MS_MIN(subsets.maxy, map->extent.maxy);
+
+  /* check if we are overspecified  */
+  if ((params->width != 0 && params->resolutionX != MS_WCS20_UNBOUNDED) ||
+      (params->height != 0 && params->resolutionY != MS_WCS20_UNBOUNDED)) {
+    msWCSClearCoverageMetadata20(&cm);
+    msSetError(MS_WCSERR,
+               "GetCoverage operation supports only one of SIZE or RESOLUTION "
+               "per axis.",
+               "msWCSGetCoverage20()");
+    return msWCSException(map, "TooManyParameterValues", "coverage",
+                          params->version);
+  }
+
+  /************************************************************************/
+  /* check both axes: see if either size or resolution are given (and     */
+  /* calculate the other value). If both are not given, calculate them    */
+  /* from the bounding box.                                               */
+  /************************************************************************/
+
+  /* check x axis */
+  if (params->width != 0) {
+    /* TODO Unit Of Measure? */
+    params->resolutionX = (bbox.maxx - bbox.minx) / params->width;
+  } else if (params->resolutionX != MS_WCS20_UNBOUNDED) {
+    params->width = MS_NINT((bbox.maxx - bbox.minx) / params->resolutionX);
+  } else {
+    if (widthFromComputationInImageCRS != 0) {
+      params->width = widthFromComputationInImageCRS;
+    } else if (ABS(bbox.maxx - bbox.minx) !=
+               ABS(map->extent.maxx - map->extent.minx)) {
+      double total = ABS(map->extent.maxx - map->extent.minx),
+             part = ABS(bbox.maxx - bbox.minx);
+      params->width = MS_NINT((part * map->width) / total);
+    } else {
+      params->width = map->width;
+    }
+
+    params->resolutionX = (bbox.maxx - bbox.minx) / params->width;
+
+    if (params->scaleX != MS_WCS20_UNBOUNDED) {
+      params->resolutionX /= params->scaleX;
+      params->width = (long)(((double)params->width) * params->scaleX);
+    }
+  }
+
+  /* check y axis */
+  if (params->height != 0) {
+    params->resolutionY = (bbox.maxy - bbox.miny) / params->height;
+  } else if (params->resolutionY != MS_WCS20_UNBOUNDED) {
+    params->height = MS_NINT((bbox.maxy - bbox.miny) / params->resolutionY);
+  } else {
+    if (heightFromComputationInImageCRS != 0) {
+      params->height = heightFromComputationInImageCRS;
+    } else if (ABS(bbox.maxy - bbox.miny) !=
+               ABS(map->extent.maxy - map->extent.miny)) {
+      double total = ABS(map->extent.maxy - map->extent.miny),
+             part = ABS(bbox.maxy - bbox.miny);
+      params->height = MS_NINT((part * map->height) / total);
+    } else {
+      params->height = map->height;
+    }
+
+    params->resolutionY = (bbox.maxy - bbox.miny) / params->height;
+
+    if (params->scaleY != MS_WCS20_UNBOUNDED) {
+      params->resolutionY /= params->scaleY;
+      params->height = (long)(((double)params->height) * params->scaleY);
+    }
+  }
+
+  /* WCS 2.0 is center of pixel oriented */
+  rectObj bboxOriginIsCorner = bbox;
+  bbox.minx += params->resolutionX * 0.5;
+  bbox.maxx -= params->resolutionX * 0.5;
+  bbox.miny += params->resolutionY * 0.5;
+  bbox.maxy -= params->resolutionY * 0.5;
+
+  /* if parameter 'outputcrs' is given, project the image to this crs */
+  if (params->outputcrs != NULL) {
+    projectionObj outputProj;
+
+    msInitProjection(&outputProj);
+    msProjectionInheritContextFrom(&outputProj, &(layer->projection));
+    if (msLoadProjectionString(&outputProj, params->outputcrs) == -1) {
+      msFreeProjection(&outputProj);
+      msWCSClearCoverageMetadata20(&cm);
+      return msWCSException(map, "InvalidParameterValue", "coverage",
+                            params->version);
+    }
+    if (msProjectionsDiffer(&(map->projection), &outputProj)) {
+
+      msDebug("msWCSGetCoverage20(): projecting to outputcrs %s\n",
+              params->outputcrs);
+
+      msProjectRect(&(map->projection), &outputProj, &bbox);
+
+      /* recalculate resolutions, needed if UOM changes (e.g: deg -> m) */
+      if (params->width == 1 || params->height == 1) {
+        // if one of the dimension is 1, we cannot use the center-of-pixel bbox,
+        // but must use the origin-is-corner one.
+        msProjectRect(&(map->projection), &outputProj, &bboxOriginIsCorner);
+        params->resolutionX =
+            (bboxOriginIsCorner.maxx - bboxOriginIsCorner.minx) / params->width;
+        params->resolutionY =
+            (bboxOriginIsCorner.maxy - bboxOriginIsCorner.miny) /
+            params->height;
+      } else {
+        params->resolutionX = (bbox.maxx - bbox.minx) / (params->width - 1);
+        params->resolutionY = (bbox.maxy - bbox.miny) / (params->height - 1);
+      }
+
+      msFreeProjection(&(map->projection));
+      map->projection = outputProj;
+    } else {
+      msFreeProjection(&outputProj);
+    }
+  }
+
+  /* set the bounding box as new map extent */
+  map->extent = bbox;
+  map->width = params->width;
+  map->height = params->height;
+
+  /* Are we exceeding the MAXSIZE limit on result size? */
+  if (map->width > map->maxsize || map->height > map->maxsize) {
+    msWCSClearCoverageMetadata20(&cm);
+    msSetError(MS_WCSERR,
+               "Raster size out of range, width and height of "
+               "resulting coverage must be no more than MAXSIZE=%d.",
+               "msWCSGetCoverage20()", map->maxsize);
+
+    return msWCSException(map, "InvalidParameterValue", "size",
+                          params->version);
+  }
+
+  /* Mapserver only supports square cells */
+  if (params->resolutionX <= params->resolutionY)
+    map->cellsize = params->resolutionX;
+  else
+    map->cellsize = params->resolutionY;
+
+  msDebug("msWCSGetCoverage20(): Set parameters from original"
+          "data. Width: %d, height: %d, cellsize: %f, extent: %f,%f,%f,%f\n",
+          map->width, map->height, map->cellsize, map->extent.minx,
+          map->extent.miny, map->extent.maxx, map->extent.maxy);
+
+  /**
+   * Which format to use?
+   *
+   * 1) format parameter
+   * 2) native format (from metadata) or GDAL format of the input dataset
+   * 3) exception
+   **/
+
+  if (!params->format) {
+    if (cm.native_format) {
+      params->format = msStrdup(cm.native_format);
+    }
+  }
+
+  if (!params->format) {
+    msSetError(MS_WCSERR,
+               "Output format could not be automatically determined. "
+               "Use the FORMAT parameter to specify a format.",
+               "msWCSGetCoverage20()");
+    msWCSClearCoverageMetadata20(&cm);
+    return msWCSException(map, "MissingParameterValue", "format",
+                          params->version);
+  }
+
+  /*    make sure layer is on   */
+  layer->status = MS_ON;
+
+  if (params->width == 1 || params->height == 1)
+    msMapComputeGeotransformEx(map, params->resolutionX, params->resolutionY);
+  else
+    msMapComputeGeotransform(map);
+
+  /*    fill in bands rangeset info, if required.  */
+  /* msWCSSetDefaultBandsRangeSetInfo(params, &cm, layer); */
+  /* msDebug("Bandcount: %d\n", cm.bandcount); */
+
+  msApplyDefaultOutputFormats(map);
+
+  if (msGetOutputFormatIndex(map, params->format) == -1) {
+    msSetError(MS_WCSERR, "Unrecognized value '%s' for the FORMAT parameter.",
+               "msWCSGetCoverage20()", params->format);
+    msWCSClearCoverageMetadata20(&cm);
+    return msWCSException(map, "InvalidParameterValue", "format",
+                          params->version);
+  }
+
+  /* create a temporary outputformat (we likely will need to tweak parts) */
+  format = msCloneOutputFormat(msSelectOutputFormat(map, params->format));
+  msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
+
+  /* set format specific parameters */
+  if (msWCSSetFormatParams20(format, params->format_options) != MS_SUCCESS) {
+    msFree(bandlist);
+    msWCSClearCoverageMetadata20(&cm);
+    return msWCSException(map, "InvalidParameterValue", "format",
+                          params->version);
+  }
+
+  if (msWCSGetCoverage20_GetBands(layer, params, &cm, &bandlist) !=
+      MS_SUCCESS) {
+    msFree(bandlist);
+    msWCSClearCoverageMetadata20(&cm);
+    return msWCSException(map, "InvalidParameterValue", "rangesubset",
+                          params->version);
+  }
+  msLayerSetProcessingKey(layer, "BANDS", bandlist);
+  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',') + 1);
+  msSetOutputFormatOption(map->outputformat, "BAND_COUNT", numbands);
+
+  msWCSApplyLayerCreationOptions(layer, map->outputformat, bandlist);
+  msWCSApplyLayerMetadataItemOptions(layer, map->outputformat, bandlist);
+
+  /* check for the interpolation */
+  /* Defaults to NEAREST */
+  if (params->interpolation != NULL) {
+    if (EQUALN(params->interpolation, "NEAREST", 7)) {
+      msLayerSetProcessingKey(layer, "RESAMPLE", "NEAREST");
+    } else if (EQUAL(params->interpolation, "BILINEAR")) {
+      msLayerSetProcessingKey(layer, "RESAMPLE", "BILINEAR");
+    } else if (EQUAL(params->interpolation, "AVERAGE")) {
+      msLayerSetProcessingKey(layer, "RESAMPLE", "AVERAGE");
+    } else {
+      msFree(bandlist);
+      msSetError(MS_WCSERR,
+                 "'%s' specifies an unsupported interpolation method.",
+                 "msWCSGetCoverage20()", params->interpolation);
+      msWCSClearCoverageMetadata20(&cm);
+      return msWCSException(map, "InvalidParameterValue", "interpolation",
+                            params->version);
+    }
+  } else {
+    msLayerSetProcessingKey(layer, "RESAMPLE", "NEAREST");
+  }
+
+  /* since the dataset is only used in one layer, set it to be    */
+  /* closed after drawing the layer. This normally defaults to    */
+  /* DEFER and will produce a memory leak, because the dataset    */
+  /* will not be closed.                                          */
+  if (msLayerGetProcessingKey(layer, "CLOSE_CONNECTION") == NULL) {
+    msLayerSetProcessingKey(layer, "CLOSE_CONNECTION", "NORMAL");
+  }
+
+  if (layer->tileindex == NULL && layer->data != NULL &&
+      strlen(layer->data) > 0 && layer->connectiontype != MS_KERNELDENSITY) {
+    if (msDrawRasterLayerLowCheckIfMustDraw(map, layer)) {
+      char *decrypted_path = NULL;
+      char szPath[MS_MAXPATHLEN];
+      hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
+          map, layer, layer->data, szPath, &decrypted_path);
+      msFree(decrypted_path);
+      if (hDS) {
+        msWCSApplyDatasetMetadataAsCreationOptions(layer, map->outputformat,
+                                                   bandlist, hDS);
+        msWCSApplySourceDatasetMetadata(layer, map->outputformat, bandlist,
+                                        hDS);
+      }
+    } else {
+      doDrawRasterLayerDraw = MS_FALSE;
+    }
+  }
+
+  /* create the image object  */
+  if (MS_RENDERER_PLUGIN(map->outputformat)) {
+    image =
+        msImageCreate(map->width, map->height, map->outputformat,
+                      map->web.imagepath, map->web.imageurl, map->resolution,
+                      map->defresolution, &map->imagecolor);
+  } else if (MS_RENDERER_RAWDATA(map->outputformat)) {
+    image =
+        msImageCreate(map->width, map->height, map->outputformat,
+                      map->web.imagepath, map->web.imageurl, map->resolution,
+                      map->defresolution, &map->imagecolor);
+  } else {
+    msFree(bandlist);
+    msWCSClearCoverageMetadata20(&cm);
+    msSetError(MS_WCSERR, "Map outputformat not supported for WCS!",
+               "msWCSGetCoverage20()");
+    msDrawRasterLayerLowCloseDataset(layer, hDS);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+
+  if (image == NULL) {
+    msFree(bandlist);
+    msWCSClearCoverageMetadata20(&cm);
+    msDrawRasterLayerLowCloseDataset(layer, hDS);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+
+  if (layer->mask) {
+    int maskLayerIdx = msGetLayerIndex(map, layer->mask);
+    layerObj *maskLayer;
+    outputFormatObj *altFormat;
+    if (maskLayerIdx == -1) {
+      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)",
+                 "msDrawLayer()", layer->name, layer->mask);
+      msFreeImage(image);
+      msFree(bandlist);
+      msWCSClearCoverageMetadata20(&cm);
+      msDrawRasterLayerLowCloseDataset(layer, hDS);
+      return msWCSException(map, NULL, NULL, params->version);
+    }
+    maskLayer = GET_LAYER(map, maskLayerIdx);
+    if (!maskLayer->maskimage) {
+      int i, retcode;
+      int origstatus, origlabelcache;
+      char *origImageType = msStrdup(map->imagetype);
+      altFormat = msSelectOutputFormat(map, "png24");
+      msInitializeRendererVTable(altFormat);
+      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg
+       */
+      maskLayer->maskimage = msImageCreate(
+          image->width, image->height, altFormat, image->imagepath,
+          image->imageurl, map->resolution, map->defresolution, NULL);
+      if (!maskLayer->maskimage) {
+        msSetError(MS_MISCERR, "Unable to initialize mask image.",
+                   "msDrawLayer()");
+        msFreeImage(image);
+        msFree(bandlist);
+        msWCSClearCoverageMetadata20(&cm);
+        msDrawRasterLayerLowCloseDataset(layer, hDS);
+        return msWCSException(map, NULL, NULL, params->version);
+      }
+
+      /*
+       * force the masked layer to status on, and turn off the labelcache so
+       * that eventual labels are added to the temporary image instead of being
+       * added to the labelcache
+       */
+      origstatus = maskLayer->status;
+      origlabelcache = maskLayer->labelcache;
+      maskLayer->status = MS_ON;
+      maskLayer->labelcache = MS_OFF;
+
+      /* draw the mask layer in the temporary image */
+      retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
+      maskLayer->status = origstatus;
+      maskLayer->labelcache = origlabelcache;
+      if (retcode != MS_SUCCESS) {
+        free(origImageType);
+        msFreeImage(image);
+        msFree(bandlist);
+        msWCSClearCoverageMetadata20(&cm);
+        msDrawRasterLayerLowCloseDataset(layer, hDS);
+        return msWCSException(map, NULL, NULL, params->version);
+      }
+      /*
+       * hack to work around bug #3834: if we have use an alternate renderer,
+       * the symbolset may contain symbols that reference it. We want to remove
+       * those references before the altFormat is destroyed to avoid a segfault
+       * and/or a leak, and so the the main renderer doesn't pick the cache up
+       * thinking it's for him.
+       */
+      for (i = 0; i < map->symbolset.numsymbols; i++) {
+        if (map->symbolset.symbol[i] != NULL) {
+          symbolObj *s = map->symbolset.symbol[i];
+          if (s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
+            MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
+            s->renderer = NULL;
+          }
+        }
+      }
+      /* set the imagetype from the original outputformat back (it was removed
+       * by msSelectOutputFormat() */
+      msFree(map->imagetype);
+      map->imagetype = origImageType;
+    }
+  }
+
+  /* Actually produce the "grid". */
+  if (MS_RENDERER_RAWDATA(map->outputformat)) {
+    if (doDrawRasterLayerDraw) {
+      status = msDrawRasterLayerLowWithDataset(map, layer, image, NULL, hDS);
+    } else {
+      status = MS_SUCCESS;
+    }
+  } else {
+    rasterBufferObj rb;
+    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image, &rb);
+    if (MS_LIKELY(status == MS_SUCCESS)) {
+      if (doDrawRasterLayerDraw) {
+        status = msDrawRasterLayerLowWithDataset(map, layer, image, &rb, hDS);
+      } else {
+        status = MS_SUCCESS;
+      }
+    }
+  }
+
+  msDrawRasterLayerLowCloseDataset(layer, hDS);
+
+  if (status != MS_SUCCESS) {
+    msFree(bandlist);
+    msFreeImage(image);
+    msWCSClearCoverageMetadata20(&cm);
+    return msWCSException(map, NULL, NULL, params->version);
+  }
+
+  /* GML+Image */
+  /* Embed the image into multipart message */
+  if (params->multipart == MS_TRUE) {
+    xmlDocPtr psDoc = NULL; /* document pointer */
+    xmlNodePtr psRootNode, psRangeSet, psFile, psRangeParameters;
+    xmlNsPtr psGmlNs = NULL, psGmlcovNs = NULL, psSweNs = NULL,
+             psXLinkNs = NULL;
+    wcs20coverageMetadataObj tmpCm;
+    char *srs_uri, *default_filename;
+    const char *filename;
+    int swapAxes;
+
+    /* Create Document  */
+    psDoc = xmlNewDoc(BAD_CAST "1.0");
+    psRootNode = xmlNewNode(
+        NULL, BAD_CAST MS_WCS_GML_COVERAGETYPE_RECTIFIED_GRID_COVERAGE);
+    xmlDocSetRootElement(psDoc, psRootNode);
+
+    msWCSPrepareNamespaces20(psDoc, psRootNode, map, MS_FALSE);
+
+    psGmlNs = xmlSearchNs(psDoc, psRootNode,
+                          BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+    psGmlcovNs = xmlSearchNs(psDoc, psRootNode,
+                             BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
+    psSweNs = xmlSearchNs(psDoc, psRootNode,
+                          BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
+    xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+    psXLinkNs = xmlSearchNs(psDoc, psRootNode,
+                            BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+
+    xmlNewNsProp(psRootNode, psGmlNs, BAD_CAST "id", BAD_CAST layer->name);
+
+    xmlSetNs(psRootNode, psGmlcovNs);
+
+    srs_uri = msOWSGetProjURI(&map->projection, NULL, "CO", 1);
+
+    tmpCm = cm;
+    tmpCm.extent = map->extent;
+    tmpCm.xsize = map->width;
+    tmpCm.ysize = map->height;
+    strlcpy(tmpCm.srs_uri, srs_uri, sizeof(tmpCm.srs_uri));
+
+    tmpCm.xresolution = map->gt.geotransform[1];
+    tmpCm.yresolution = map->gt.geotransform[5];
+
+    tmpCm.extent.minx =
+        MS_MIN(map->gt.geotransform[0],
+               map->gt.geotransform[0] + map->width * tmpCm.xresolution);
+    tmpCm.extent.miny =
+        MS_MIN(map->gt.geotransform[3],
+               map->gt.geotransform[3] + map->height * tmpCm.yresolution);
+    tmpCm.extent.maxx =
+        MS_MAX(map->gt.geotransform[0],
+               map->gt.geotransform[0] + map->width * tmpCm.xresolution);
+    tmpCm.extent.maxy =
+        MS_MAX(map->gt.geotransform[3],
+               map->gt.geotransform[3] + map->height * tmpCm.yresolution);
+
+    swapAxes = msWCSSwapAxes20(srs_uri);
+    msFree(srs_uri);
+
+    /* Setup layer information  */
+    msWCSCommon20_CreateBoundedBy(&tmpCm, psGmlNs, psRootNode,
+                                  &(map->projection), swapAxes);
+    msWCSCommon20_CreateDomainSet(layer, &tmpCm, psGmlNs, psRootNode,
+                                  &(map->projection), swapAxes);
+
+    psRangeSet = xmlNewChild(psRootNode, psGmlNs, BAD_CAST "rangeSet", NULL);
+    psFile = xmlNewChild(psRangeSet, psGmlNs, BAD_CAST "File", NULL);
+
+    /* TODO: wait for updated specifications */
+    psRangeParameters =
+        xmlNewChild(psFile, psGmlNs, BAD_CAST "rangeParameters", NULL);
+
+    default_filename = msStrdup("out.");
+    default_filename = msStringConcatenate(default_filename,
+                                           MS_IMAGE_EXTENSION(image->format));
+
+    filename =
+        msGetOutputFormatOption(image->format, "FILENAME", default_filename);
+    std::string file_ref("cid:coverage/");
+    file_ref += filename;
+
+    msFree(default_filename);
+
+    std::string role;
+    if (EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "image/tiff")) {
+      role = MS_WCS_20_PROFILE_GML_GEOTIFF;
+    } else {
+      role = MS_IMAGE_MIME_TYPE(map->outputformat);
+    }
+
+    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "href",
+                 BAD_CAST file_ref.c_str());
+    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "role",
+                 BAD_CAST role.c_str());
+    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "arcrole",
+                 BAD_CAST "fileReference");
+
+    xmlNewChild(psFile, psGmlNs, BAD_CAST "fileReference",
+                BAD_CAST file_ref.c_str());
+    xmlNewChild(psFile, psGmlNs, BAD_CAST "fileStructure", NULL);
+    xmlNewChild(psFile, psGmlNs, BAD_CAST "mimeType",
+                BAD_CAST MS_IMAGE_MIME_TYPE(map->outputformat));
+
+    msWCSCommon20_CreateRangeType(&cm, bandlist, psGmlcovNs, psSweNs,
+                                  psRootNode);
+
+    msIO_setHeader("Content-Type", "multipart/related; boundary=wcs");
+    msIO_sendHeaders();
+    msIO_printf("\r\n--wcs\r\n");
+
+    msWCSWriteDocument20(psDoc);
+    msWCSWriteFile20(map, image, params, 1);
+
+    xmlFreeDoc(psDoc);
+    xmlCleanupParser();
+    /* just print out the file without gml */
+  } else {
+    msWCSWriteFile20(map, image, params, 0);
+  }
+
+  msFree(bandlist);
+  msWCSClearCoverageMetadata20(&cm);
+  msFreeImage(image);
+  return MS_SUCCESS;
+}
+
+#endif /* defined(USE_LIBXML2) */
+
+#endif /* defined(USE_WCS_SVR) */
diff -pruN 8.0.1-5/src/mapwfs.cpp 8.2.0~beta1-1~exp1/src/mapwfs.cpp
--- 8.0.1-5/src/mapwfs.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwfs.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5596 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  WFS server implementation
+ * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2002, Daniel Morissette, DM Solutions Group Inc
+ * Copyright (c) 2013, Even Rouault
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#include <string>
+
+#if defined(USE_WFS_SVR)
+
+/* There is a dependency to GDAL/OGR for the GML driver and MiniXML parser */
+#include "cpl_minixml.h"
+#include "cpl_conv.h"
+#include "cpl_string.h"
+
+#include "mapogcfilter.h"
+#include "mapowscommon.h"
+#include "maptemplate.h"
+
+#if defined(USE_LIBXML2)
+#include "maplibxml2.h"
+#endif
+
+#include <string>
+
+static int msWFSAnalyzeStoredQuery(mapObj *map, wfsParamsObj *wfsparams,
+                                   const char *id,
+                                   const char *pszResolvedQuery);
+static void msWFSSimplifyPropertyNameAndFilter(wfsParamsObj *wfsparams);
+static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map,
+                                                  const wfsParamsObj *paramsObj,
+                                                  int bIsHits,
+                                                  int *pmaxfeatures,
+                                                  int *pstartindex);
+static int msWFSRunBasicGetFeature(mapObj *map, layerObj *lp,
+                                   const wfsParamsObj *paramsObj,
+                                   int nWFSVersion);
+
+static int msWFSParseRequest(mapObj *map, cgiRequestObj *request,
+                             wfsParamsObj *wfsparams, int force_wfs_mode);
+
+/* Must be sorted from more recent to older one */
+static const int wfsSupportedVersions[] = {OWS_2_0_0, OWS_1_1_0, OWS_1_0_0};
+static const char *const wfsSupportedVersionsStr[] = {"2.0.0", "1.1.0",
+                                                      "1.0.0"};
+static const int wfsNumSupportedVersions =
+    (int)(sizeof(wfsSupportedVersions) / sizeof(wfsSupportedVersions[0]));
+static const char *const wfsUnsupportedOperations[] = {
+    "GetFeatureWithLock", "LockFeature", "Transaction", "CreateStoredQuery",
+    "DropStoredQuery"};
+static const int wfsNumUnsupportedOperations =
+    (int)(sizeof(wfsUnsupportedOperations) /
+          sizeof(wfsUnsupportedOperations[0]));
+
+#define WFS_LATEST_VERSION wfsSupportedVersionsStr[0]
+
+/* Supported DescribeFeature formats */
+typedef enum {
+  OWS_DEFAULT_SCHEMA,  /* basically a GML 2.1 schema */
+  OWS_SFE_SCHEMA,      /* GML for simple feature exchange (formerly GML3L0) */
+  OWS_GML32_SFE_SCHEMA /* GML 3.2 Simple Features Level 0 */
+} WFSSchemaVersion;
+
+/*
+** msWFSGetIndexUnsupportedOperation()
+**
+** Return index of pszOp in wfsUnsupportedOperations, or -1 otherwise
+*/
+
+static int msWFSGetIndexUnsupportedOperation(const char *pszOp) {
+  int i;
+  for (i = 0; i < wfsNumUnsupportedOperations; i++) {
+    if (strcasecmp(wfsUnsupportedOperations[i], pszOp) == 0)
+      return i;
+  }
+  return -1;
+}
+
+static const char *msWFSGetDefaultVersion(mapObj *map);
+
+/*
+** msWFSException()
+**
+** Report current MapServer error in XML exception format.
+*/
+
+static int msWFSExceptionInternal(mapObj *map, const char *locator,
+                                  const char *code, const char *version,
+                                  int locatorShouldBeNull) {
+  char *schemalocation = NULL;
+  /* In WFS, exceptions are always XML.
+   */
+
+  if (version == NULL)
+    version = msWFSGetDefaultVersion(map);
+
+  if (msOWSParseVersionString(version) >= OWS_2_0_0)
+    return msWFSException20(map, (locatorShouldBeNull) ? NULL : locator, code);
+  if (msOWSParseVersionString(version) >= OWS_1_1_0)
+    return msWFSException11(map, (locatorShouldBeNull) ? NULL : locator, code,
+                            version);
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+
+  msIO_printf("<ServiceExceptionReport ");
+  msIO_printf("version=\"1.2.0\" ");
+  msIO_printf("xmlns=\"http://www.opengis.net/ogc\" ");
+  msIO_printf("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ");
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc "
+              "%s/wfs/1.0.0/OGC-exception.xsd\">\n",
+              schemalocation);
+  free(schemalocation);
+  msIO_printf("  <ServiceException code=\"%s\" locator=\"%s\">\n", code,
+              locator);
+  /* Optional <Locator> element currently unused. */
+  /* msIO_printf("    <Message>\n"); */
+  msWriteErrorXML(stdout);
+  /* msIO_printf("    </Message>\n"); */
+  msIO_printf("  </ServiceException>\n");
+  msIO_printf("</ServiceExceptionReport>\n");
+
+  return MS_FAILURE; /* so we can call 'return msWFSException();' anywhere */
+}
+
+int msWFSException(mapObj *map, const char *locator, const char *code,
+                   const char *version) {
+  return msWFSExceptionInternal(map, locator, code, version, FALSE);
+}
+
+/*
+** msWFSExceptionNoLocator()
+**
+** Report current MapServer error in XML exception format.
+** For WFS >= 1.1.0, the locator will be ignored. It will be just used
+** for legacy WFS 1.0 exceptions.
+*/
+
+static int msWFSExceptionNoLocator(mapObj *map, const char *locator,
+                                   const char *code, const char *version) {
+  return msWFSExceptionInternal(map, locator, code, version, TRUE);
+}
+
+/*
+** Helper function to build a list of output formats.
+**
+** Given a layer it will return all formats valid for that layer, otherwise
+** all formats permitted on layers in the map are returned.  The string
+** returned should be freed by the caller.
+*/
+
+char *msWFSGetOutputFormatList(mapObj *map, layerObj *layer, int nWFSVersion) {
+  int i, got_map_list = 0;
+  static const int out_list_size = 20000;
+  char *out_list = (char *)msSmallCalloc(1, out_list_size);
+
+  if (nWFSVersion == OWS_1_0_0)
+    strcpy(out_list, "GML2");
+  else if (nWFSVersion == OWS_1_1_0)
+    strcpy(out_list, "text/xml; subtype=gml/3.1.1");
+  else
+    strcpy(out_list, "application/gml+xml; version=3.2,"
+                     "text/xml; subtype=gml/3.2.1,"
+                     "text/xml; subtype=gml/3.1.1,"
+                     "text/xml; subtype=gml/2.1.2");
+
+  for (i = 0; i < map->numlayers; i++) {
+    const char *format_list;
+    layerObj *lp;
+    int j, n;
+    char **tokens;
+
+    lp = GET_LAYER(map, i);
+    if (layer != NULL && layer != lp)
+      continue;
+
+    format_list =
+        msOWSLookupMetadata(&(lp->metadata), "F", "getfeature_formatlist");
+
+    if (format_list == NULL && !got_map_list) {
+      format_list = msOWSLookupMetadata(&(map->web.metadata), "F",
+                                        "getfeature_formatlist");
+      got_map_list = 1;
+    }
+
+    if (format_list == NULL)
+      continue;
+
+    n = 0;
+    tokens = msStringSplit(format_list, ',', &n);
+
+    for (j = 0; j < n; j++) {
+      int iformat;
+      const char *fname, *hit;
+      outputFormatObj *format_obj;
+
+      msStringTrim(tokens[j]);
+      iformat = msGetOutputFormatIndex(map, tokens[j]);
+      if (iformat < 0)
+        continue;
+
+      format_obj = map->outputformatlist[iformat];
+
+      fname = format_obj->name;
+      if (nWFSVersion >= OWS_1_1_0 && format_obj->mimetype != NULL)
+        fname = format_obj->mimetype;
+
+      hit = strstr(out_list, fname);
+      if (hit != NULL &&
+          (hit[strlen(fname)] == '\0' || hit[strlen(fname)] == ','))
+        continue;
+
+      if (strlen(out_list) + strlen(fname) + 3 < out_list_size) {
+        strcat(out_list, ",");
+        strcat(out_list, fname);
+      } else
+        break;
+    }
+
+    msFreeCharArray(tokens, n);
+  }
+
+  return out_list;
+}
+
+/*
+**
+*/
+static void msWFSPrintRequestCap(const char *request, const char *script_url,
+                                 const char *format_tag,
+                                 const char *formats_list) {
+  msIO_printf("    <%s>\n", request);
+
+  /* We expect to receive a NULL-terminated args list of formats */
+  if (format_tag != NULL) {
+    int i, n;
+    char **tokens;
+
+    n = 0;
+    tokens = msStringSplit(formats_list, ',', &n);
+
+    msIO_printf("      <%s>\n", format_tag);
+
+    for (i = 0; i < n; i++) {
+      msIO_printf("        <%s/>\n", tokens[i]);
+    }
+
+    msFreeCharArray(tokens, n);
+
+    msIO_printf("      </%s>\n", format_tag);
+  }
+
+  msIO_printf("      <DCPType>\n");
+  msIO_printf("        <HTTP>\n");
+  msIO_printf("          <Get onlineResource=\"%s\" />\n", script_url);
+  msIO_printf("        </HTTP>\n");
+  msIO_printf("      </DCPType>\n");
+  msIO_printf("      <DCPType>\n");
+  msIO_printf("        <HTTP>\n");
+  msIO_printf("          <Post onlineResource=\"%s\" />\n", script_url);
+  msIO_printf("        </HTTP>\n");
+  msIO_printf("      </DCPType>\n");
+
+  msIO_printf("    </%s>\n", request);
+}
+
+/* msWFSLocateSRSInList()
+**
+** Utility function to check if a space separated list contains  the one passed
+*in argument.
+**  The list comes normaly from ows_srs metadata, and is expected to use the
+*simple EPSG notation
+** (EPSG:4326 ESPG:42304 ...). The srs comes from the query string and can
+*either
+** be of simple EPSG format or using gc:def:crs:EPSG:xxx format
+*/
+int msWFSLocateSRSInList(const char *pszList, const char *srs) {
+  int nTokens, i;
+  char **tokens = NULL;
+  int bFound = MS_FALSE;
+  char epsg_string[100];
+  const char *code;
+
+  if (!pszList || !srs)
+    return MS_FALSE;
+
+  if (strncasecmp(srs, "EPSG:", 5) == 0)
+    code = srs + 5;
+  else if (strncasecmp(srs, "urn:ogc:def:crs:EPSG:", 21) == 0) {
+    if (srs[21] == ':')
+      code = srs + 21;
+    else
+      code = srs + 20;
+
+    while (*code != ':' && *code != '\0')
+      code++;
+    if (*code == ':')
+      code++;
+  } else if (strncasecmp(srs, "urn:EPSG:geographicCRS:", 23) == 0)
+    code = srs + 23;
+  else
+    return MS_FALSE;
+
+  snprintf(epsg_string, sizeof(epsg_string), "EPSG:%s", code);
+
+  tokens = msStringSplit(pszList, ' ', &nTokens);
+  if (tokens && nTokens > 0) {
+    for (i = 0; i < nTokens; i++) {
+      if (strcasecmp(tokens[i], epsg_string) == 0) {
+        bFound = MS_TRUE;
+        break;
+      }
+    }
+  }
+  msFreeCharArray(tokens, nTokens);
+
+  return bFound;
+}
+
+/* msWFSGetFeatureApplySRS()
+**
+** Utility function called from msWFSGetFeature. It is assumed that at this
+*point
+** all queried layers are turned ON
+*/
+static int msWFSGetFeatureApplySRS(mapObj *map, const char *srs,
+                                   int nWFSVersion) {
+  char *pszMapSRS = NULL;
+  char *pszOutputSRS = NULL;
+  layerObj *lp;
+  int i;
+
+  /*validation of SRS
+    - wfs 1.0 does not have an srsname parameter so all queried layers should be
+    advertized using the same srs. For wfs 1.1.0 an srsName can be passed, we
+    should validate that It is valid for all queries layers
+  */
+
+  /* Start by applying the default service SRS to the mapObj,
+   * make sure we reproject the map extent if a projection was
+   * already set
+   */
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                   &pszMapSRS);
+  if (pszMapSRS && nWFSVersion > OWS_1_0_0) {
+    projectionObj proj;
+    msInitProjection(&proj);
+    msProjectionInheritContextFrom(&proj, &(map->projection));
+    if (map->projection.numargs > 0 &&
+        msLoadProjectionStringEPSG(&proj, pszMapSRS) == 0) {
+      msProjectRect(&(map->projection), &proj, &map->extent);
+    }
+    msLoadProjectionStringEPSG(&(map->projection), pszMapSRS);
+    msFreeProjection(&proj);
+  }
+
+  if (srs == NULL || nWFSVersion == OWS_1_0_0) {
+    for (i = 0; i < map->numlayers; i++) {
+      char *pszLayerSRS;
+      lp = GET_LAYER(map, i);
+      if (lp->status != MS_ON)
+        continue;
+
+      if (pszMapSRS)
+        pszLayerSRS = pszMapSRS;
+      else
+        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE,
+                         &pszLayerSRS);
+
+      if (pszLayerSRS == NULL) {
+        msSetError(MS_WFSERR,
+                   "Server config error: SRS must be set at least at the map "
+                   "or at the layer level.",
+                   "msWFSGetFeature()");
+        if (pszOutputSRS)
+          msFree(pszOutputSRS);
+        /*pszMapSrs would also be NULL, no use freeing*/
+        return MS_FAILURE;
+      }
+      if (pszOutputSRS == NULL)
+        pszOutputSRS = msStrdup(pszLayerSRS);
+      else if (strcasecmp(pszLayerSRS, pszOutputSRS) != 0) {
+        msSetError(
+            MS_WFSERR,
+            "Invalid GetFeature Request: All TYPENAMES in a single GetFeature "
+            "request must have been advertized in the same SRS.  Please check "
+            "the capabilities and reformulate your request.",
+            "msWFSGetFeature()");
+        if (pszOutputSRS)
+          msFree(pszOutputSRS);
+        if (pszLayerSRS != pszMapSRS)
+          msFree(pszLayerSRS);
+        msFree(pszMapSRS);
+        return MS_FAILURE;
+      }
+      if (pszLayerSRS != pszMapSRS)
+        msFree(pszLayerSRS);
+    }
+  } else { /*srs is given so it should be valid for all layers*/
+    /*get all the srs defined at the map level and check them aginst the srsName
+      passed as argument*/
+    msFree(pszMapSRS);
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_FALSE,
+                     &pszMapSRS);
+    if (pszMapSRS) {
+      if (!msWFSLocateSRSInList(pszMapSRS, srs)) {
+        msSetError(MS_WFSERR,
+                   "Invalid GetFeature Request:Invalid SRS.  Please check the "
+                   "capabilities and reformulate your request.",
+                   "msWFSGetFeature()");
+        msFree(pszMapSRS);
+        return MS_FAILURE;
+      }
+      pszOutputSRS = msStrdup(srs);
+    } else {
+      for (i = 0; i < map->numlayers; i++) {
+        char *pszLayerSRS = NULL;
+        lp = GET_LAYER(map, i);
+        if (lp->status != MS_ON)
+          continue;
+
+        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_FALSE,
+                         &pszLayerSRS);
+        if (!pszLayerSRS) {
+          msSetError(MS_WFSERR,
+                     "Server config error: SRS must be set at least at the map "
+                     "or at the layer level.",
+                     "msWFSGetFeature()");
+          msFree(pszMapSRS);
+          return MS_FAILURE;
+        }
+        if (!msWFSLocateSRSInList(pszLayerSRS, srs)) {
+          msSetError(MS_WFSERR,
+                     "Invalid GetFeature Request:Invalid SRS.  Please check "
+                     "the capabilities and reformulate your request.",
+                     "msWFSGetFeature()");
+          msFree(pszMapSRS);
+          msFree(pszLayerSRS);
+          return MS_FAILURE;
+        }
+        msFree(pszLayerSRS);
+      }
+      pszOutputSRS = msStrdup(srs);
+    }
+  }
+
+  if (pszOutputSRS) {
+    projectionObj sProjTmp;
+    int nTmp = 0;
+
+    msInitProjection(&sProjTmp);
+    msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
+    if (nWFSVersion >= OWS_1_1_0) {
+      nTmp = msLoadProjectionStringEPSG(&(sProjTmp), pszOutputSRS);
+    } else {
+      nTmp = msLoadProjectionString(&(sProjTmp), pszOutputSRS);
+    }
+    if (nTmp == 0) {
+      msProjectRect(&(map->projection), &(sProjTmp), &map->extent);
+    }
+    msFreeProjection(&(sProjTmp));
+
+    if (nTmp != 0) {
+      msSetError(MS_WFSERR, "msLoadProjectionString() failed",
+                 "msWFSGetFeature()");
+      return MS_FAILURE;
+    }
+
+    /*we load the projection sting in the map and possibly
+    set the axis order*/
+    if (nWFSVersion >= OWS_1_1_0) {
+      msLoadProjectionStringEPSG(&(map->projection), pszOutputSRS);
+    } else {
+      msLoadProjectionString(&(map->projection), pszOutputSRS);
+    }
+
+    nTmp = GetMapserverUnitUsingProj(&(map->projection));
+    if (nTmp != -1) {
+      map->units = static_cast<MS_UNITS>(nTmp);
+    }
+  }
+
+  msFree(pszOutputSRS);
+  msFree(pszMapSRS);
+  return MS_SUCCESS;
+}
+
+/* msWFSIsLayerSupported()
+**
+** Returns true (1) is this layer meets the requirements to be served as
+** a WFS feature type.
+*/
+int msWFSIsLayerSupported(layerObj *lp) {
+  /* In order to be supported, lp->type must be specified, even for
+  ** layers that are OGR, SDE, SDO, etc connections.
+  */
+  if ((lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE ||
+       lp->type == MS_LAYER_POLYGON) &&
+      lp->connectiontype != MS_WMS && lp->connectiontype != MS_GRATICULE) {
+    return 1; /* true */
+  }
+
+  return 0; /* false */
+}
+
+static int msWFSIsLayerAllowed(layerObj *lp, owsRequestObj *ows_request) {
+  return msWFSIsLayerSupported(lp) &&
+         (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                           ows_request->numlayers));
+}
+
+static layerObj *msWFSGetLayerByName(mapObj *map, owsRequestObj *ows_request,
+                                     const char *name) {
+  int j;
+  for (j = 0; j < map->numlayers; j++) {
+    layerObj *lp;
+
+    lp = GET_LAYER(map, j);
+
+    if (msWFSIsLayerAllowed(lp, ows_request) && lp->name &&
+        (strcasecmp(lp->name, name) == 0)) {
+      return lp;
+    }
+  }
+  return NULL;
+}
+
+/*
+** msWFSDumpLayer()
+*/
+int msWFSDumpLayer(mapObj *map, layerObj *lp, const char *script_url_encoded) {
+  rectObj ext;
+  char *pszWfsSrs = NULL;
+  projectionObj poWfs;
+
+  msIO_printf("    <FeatureType>\n");
+
+  if (lp->name && strlen(lp->name) > 0 &&
+      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
+    msIO_fprintf(stdout,
+                 "<!-- WARNING: The layer name '%s' might contain spaces or "
+                 "invalid characters or may start with a number. This could "
+                 "lead to potential problems. -->\n",
+                 lp->name);
+
+  msOWSPrintEncodeParam(stdout, "LAYER.NAME", lp->name, OWS_WARN,
+                        "        <Name>%s</Name>\n", NULL);
+
+  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "title", OWS_WARN,
+                           "        <Title>%s</Title>\n", lp->name);
+
+  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "abstract", OWS_NOERR,
+                           "        <Abstract>%s</Abstract>\n", NULL);
+
+  msOWSPrintEncodeMetadataList(stdout, &(lp->metadata), "FO", "keywordlist",
+                               "        <Keywords>\n", "        </Keywords>\n",
+                               "          %s\n", NULL);
+
+  /* In WFS, every layer must have exactly one SRS and there is none at */
+  /* the top level contrary to WMS */
+  /*  */
+  /* So here is the way we'll deal with SRS: */
+  /* 1- If a top-level map projection (or wfs_srs metadata) is set then */
+  /* all layers are advertized in the map's projection and they will */
+  /* be reprojected on the fly in the GetFeature request. */
+  /* 2- If there is no top-level map projection (or wfs_srs metadata) then */
+  /* each layer is advertized in its own projection as defined in the */
+  /* layer's projection object or wfs_srs metadata. */
+  /*  */
+
+  /* if Map has a SRS,  Use it for all layers. */
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                   &pszWfsSrs);
+  if (!pszWfsSrs) {
+    /* Map has no SRS.  Use layer SRS or produce a warning. */
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE,
+                     &pszWfsSrs);
+  }
+
+  msOWSPrintEncodeParam(
+      stdout,
+      "(at least one of) MAP.PROJECTION, LAYER.PROJECTION or wfs_srs metadata",
+      pszWfsSrs, OWS_WARN, "        <SRS>%s</SRS>\n", NULL);
+
+  /* If layer has no proj set then use map->proj for bounding box. */
+  if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
+    msInitProjection(&poWfs);
+    msProjectionInheritContextFrom(&poWfs, &(map->projection));
+    if (pszWfsSrs != NULL)
+      msLoadProjectionString(&(poWfs), pszWfsSrs);
+
+    if (lp->projection.numargs > 0) {
+      msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext), &(lp->projection),
+                                  &(poWfs), OWS_WFS);
+    } else {
+      msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
+                                  &(map->projection), &(poWfs), OWS_WFS);
+    }
+    msFreeProjection(&poWfs);
+  } else {
+    msIO_printf("<!-- WARNING: Optional LatLongBoundingBox could not be "
+                "established for this layer.  Consider setting the EXTENT in "
+                "the LAYER object, or wfs_extent metadata. Also check that "
+                "your data exists in the DATA statement -->\n");
+  }
+
+  const char *metadataurl_list =
+      msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
+  if (metadataurl_list) {
+    int ntokens = 0;
+    char **tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
+      std::string key("metadataurl_");
+      key += tokens[i];
+      msOWSPrintURLType(stdout, &(lp->metadata), "FO", key.c_str(), OWS_WARN,
+                        NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                        " format=\"%s\"", "%s", MS_TRUE, MS_FALSE, MS_FALSE,
+                        MS_TRUE, MS_TRUE, NULL, NULL, NULL, NULL, NULL,
+                        "        ");
+    }
+    msFreeCharArray(tokens, ntokens);
+  } else {
+    if (!msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
+      msMetadataSetGetMetadataURL(lp, script_url_encoded);
+
+    msOWSPrintURLType(stdout, &(lp->metadata), "FO", "metadataurl", OWS_WARN,
+                      NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                      " format=\"%s\"", "%s", MS_TRUE, MS_FALSE, MS_FALSE,
+                      MS_TRUE, MS_TRUE, NULL, NULL, NULL, NULL, NULL,
+                      "        ");
+  }
+
+  if (msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid") == NULL) {
+    msIO_fprintf(
+        stdout,
+        "<!-- WARNING: Required Feature Id attribute (fid) not specified for "
+        "this feature type. Make sure you set one of wfs_featureid, "
+        "ows_featureid or gml_featureid metadata. -->\n");
+  }
+
+  msIO_printf("    </FeatureType>\n");
+
+  msFree(pszWfsSrs);
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSHandleUpdateSequence()
+*/
+int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *params,
+                              const char *pszFunction) {
+  /* -------------------------------------------------------------------- */
+  /*      Handle updatesequence                                           */
+  /* -------------------------------------------------------------------- */
+
+  const char *updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+
+  if (params->pszUpdateSequence != NULL) {
+    int i =
+        msOWSNegotiateUpdateSequence(params->pszUpdateSequence, updatesequence);
+    if (i == 0) { /* current */
+      msSetError(MS_WFSERR,
+                 "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+                 pszFunction, params->pszUpdateSequence, updatesequence);
+      /* FIXME? : according to table 7 of OWS 1.1, we should return a service */
+      /* metadata document with only “version” and “updateSequence” parameters
+       */
+      return msWFSException(map, "updatesequence", "CurrentUpdateSequence",
+                            params->pszVersion);
+    }
+    if (i > 0) { /* invalid */
+      msSetError(MS_WFSERR,
+                 "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+                 pszFunction, params->pszUpdateSequence, updatesequence);
+      /* locator must be NULL. See Table 25 of OWS 1.1 */
+      return msWFSExceptionNoLocator(map, "updatesequence",
+                                     MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE,
+                                     params->pszVersion);
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSGetCapabilitiesNegotiateVersion()
+*/
+static int msWFSGetCapabilitiesNegotiateVersion(mapObj *map,
+                                                wfsParamsObj *wfsparams) {
+  int iVersion = -1;
+  char tmpString[OWS_VERSION_MAXLEN];
+
+  /* acceptversions: do OWS Common style of version negotiation */
+  if (wfsparams->pszAcceptVersions &&
+      strlen(wfsparams->pszAcceptVersions) > 0) {
+    char **tokens;
+    int i, j;
+
+    tokens = msStringSplit(wfsparams->pszAcceptVersions, ',', &j);
+    for (i = 0; i < j; i++) {
+      iVersion = msOWSParseVersionString(tokens[i]);
+
+      if (iVersion < 0) {
+        msSetError(MS_WFSERR, "Invalid version format : %s.",
+                   "msWFSGetCapabilities()", tokens[i]);
+        msFreeCharArray(tokens, j);
+        return msWFSException(map, "acceptversions",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE, NULL);
+      }
+
+      /* negotiate version */
+      iVersion = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions,
+                                             wfsNumSupportedVersions);
+      if (iVersion != -1)
+        break;
+    }
+    msFreeCharArray(tokens, j);
+    if (iVersion == -1) {
+      msSetError(MS_WFSERR,
+                 "ACCEPTVERSIONS list (%s) does not match supported versions",
+                 "msWFSGetCapabilities()", wfsparams->pszAcceptVersions);
+      /* locator must be NULL. See Table 25 of OWS 1.1 */
+      return msWFSExceptionNoLocator(
+          map, "acceptversions", MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED, NULL);
+    }
+  } else {
+    /* negotiate version */
+    int tmpInt;
+    iVersion = msOWSParseVersionString(wfsparams->pszVersion);
+    if (iVersion < 0) {
+      return msWFSException(map, "version",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE, NULL);
+    }
+    tmpInt = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions,
+                                         wfsNumSupportedVersions);
+    /* Old style negociation : paragraph D.11 of OWS 1.1.0 spec */
+    if (tmpInt < 0) {
+      int i;
+      for (i = 0; i < wfsNumSupportedVersions; i++) {
+        if (iVersion >= wfsSupportedVersions[i]) {
+          iVersion = wfsSupportedVersions[i];
+          break;
+        }
+      }
+      if (i == wfsNumSupportedVersions)
+        iVersion = wfsSupportedVersions[wfsNumSupportedVersions - 1];
+    }
+  }
+
+  /* set result as string and carry on */
+  if (wfsparams->pszVersion)
+    msFree(wfsparams->pszVersion);
+  wfsparams->pszVersion = msStrdup(msOWSGetVersionString(iVersion, tmpString));
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSGetCapabilities()
+*/
+int msWFSGetCapabilities(mapObj *map, wfsParamsObj *wfsparams,
+                         cgiRequestObj *req, owsRequestObj *ows_request) {
+  char *script_url = NULL, *script_url_encoded;
+  const char *updatesequence = NULL;
+  const char *wmtver = NULL;
+  char *formats_list;
+  int ret;
+  int iVersion;
+  int i = 0;
+
+  ret = msWFSGetCapabilitiesNegotiateVersion(map, wfsparams);
+  if (ret != MS_SUCCESS)
+    return ret;
+
+  iVersion = msOWSParseVersionString(wfsparams->pszVersion);
+  if (iVersion == OWS_2_0_0)
+    return msWFSGetCapabilities20(map, wfsparams, req, ows_request);
+  if (iVersion == OWS_1_1_0)
+    return msWFSGetCapabilities11(map, wfsparams, req, ows_request);
+
+  /* Decide which version we're going to return... only 1.0.0 for now */
+  wmtver = "1.0.0";
+
+  /* We need this server's onlineresource. */
+  if ((script_url = msOWSGetOnlineResource(map, "FO", "onlineresource", req)) ==
+          NULL ||
+      (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+    msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities()");
+    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          wmtver);
+  }
+  free(script_url);
+  script_url = NULL;
+
+  ret = msWFSHandleUpdateSequence(map, wfsparams, "msWFSGetCapabilities()");
+  if (ret != MS_SUCCESS) {
+    free(script_url_encoded);
+    return ret;
+  }
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+  msIO_printf("<WFS_Capabilities \n"
+              "   version=\"%s\" \n"
+              "   updateSequence=\"%s\" \n"
+              "   xmlns=\"http://www.opengis.net/wfs\" \n"
+              "   xmlns:ogc=\"http://www.opengis.net/ogc\" \n"
+              "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+              "   xsi:schemaLocation=\"http://www.opengis.net/wfs "
+              "%s/wfs/%s/WFS-capabilities.xsd\">\n",
+              wmtver, updatesequence ? updatesequence : "0",
+              msOWSGetSchemasLocation(map), wmtver);
+
+  /*
+  ** SERVICE definition
+  */
+  msIO_printf("<Service>\n");
+  msIO_printf("  <Name>MapServer WFS</Name>\n");
+
+  /* the majority of this section is dependent on appropriately named metadata
+   * in the WEB object */
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "title",
+                           OWS_WARN, "  <Title>%s</Title>\n", map->name);
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "abstract",
+                           OWS_NOERR, "  <Abstract>%s</Abstract>\n", NULL);
+
+  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "FO",
+                               "keywordlist", "  <Keywords>\n",
+                               "  </Keywords>\n", "    %s\n", NULL);
+
+  /* Service/onlineresource */
+  /* Defaults to same as request onlineresource if wfs_service_onlineresource */
+  /* is not set. */
+  msOWSPrintEncodeMetadata(
+      stdout, &(map->web.metadata), "FO", "service_onlineresource", OWS_NOERR,
+      "  <OnlineResource>%s</OnlineResource>\n", script_url_encoded);
+
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "fees",
+                           OWS_NOERR, "  <Fees>%s</Fees>\n", NULL);
+
+  msOWSPrintEncodeMetadata(
+      stdout, &(map->web.metadata), "FO", "accessconstraints", OWS_NOERR,
+      "  <AccessConstraints>%s</AccessConstraints>\n", NULL);
+
+  msIO_printf("</Service>\n\n");
+
+  /*
+  ** CAPABILITY definitions: list of supported requests
+  */
+
+  msIO_printf("<Capability>\n");
+
+  msIO_printf("  <Request>\n");
+  msWFSPrintRequestCap("GetCapabilities", script_url_encoded, NULL, NULL);
+  /* msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded,
+   * "SchemaDescriptionLanguage", "XMLSCHEMA", "SFE_XMLSCHEMA", NULL); */
+  /* msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat",
+   * "GML2", "GML3", NULL); */
+
+  /* don't advertise the GML3 or GML for SFE support */
+  if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE))
+    msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded,
+                         "SchemaDescriptionLanguage", "XMLSCHEMA");
+
+  if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
+    formats_list = msWFSGetOutputFormatList(map, NULL, OWS_1_0_0);
+    msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat",
+                         formats_list);
+    msFree(formats_list);
+  }
+
+  msIO_printf("  </Request>\n");
+  msIO_printf("</Capability>\n\n");
+
+  /*
+  ** FeatureTypeList: layers
+  */
+
+  msIO_printf("<FeatureTypeList>\n");
+
+  /* Operations supported... set default at top-level, and more operations */
+  /* can be added inside each layer... for MapServer only query is supported */
+  msIO_printf("  <Operations>\n");
+  msIO_printf("    <Query/>\n");
+  msIO_printf("  </Operations>\n");
+
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp;
+    lp = GET_LAYER(map, i);
+
+    if (lp->status == MS_DELETE)
+      continue;
+
+    if (msWFSIsLayerAllowed(lp, ows_request)) {
+      msWFSDumpLayer(map, lp, script_url_encoded);
+    }
+  }
+
+  msIO_printf("</FeatureTypeList>\n\n");
+
+  /*
+  ** OGC Filter Capabilities ... for now we support only BBOX
+  */
+
+  msIO_printf("<ogc:Filter_Capabilities>\n");
+  msIO_printf("  <ogc:Spatial_Capabilities>\n");
+  msIO_printf("    <ogc:Spatial_Operators>\n");
+#ifdef USE_GEOS
+  msIO_printf("      <ogc:Equals/>\n");
+  msIO_printf("      <ogc:Disjoint/>\n");
+  msIO_printf("      <ogc:Touches/>\n");
+  msIO_printf("      <ogc:Within/>\n");
+  msIO_printf("      <ogc:Overlaps/>\n");
+  msIO_printf("      <ogc:Crosses/>\n");
+  msIO_printf("      <ogc:Intersect/>\n");
+  msIO_printf("      <ogc:Contains/>\n");
+  msIO_printf("      <ogc:DWithin/>\n");
+#endif
+  msIO_printf("      <ogc:BBOX/>\n");
+  msIO_printf("    </ogc:Spatial_Operators>\n");
+  msIO_printf("  </ogc:Spatial_Capabilities>\n");
+
+  msIO_printf("  <ogc:Scalar_Capabilities>\n");
+  msIO_printf("    <ogc:Logical_Operators />\n");
+  msIO_printf("    <ogc:Comparison_Operators>\n");
+  msIO_printf("      <ogc:Simple_Comparisons />\n");
+  msIO_printf("      <ogc:Like />\n");
+  msIO_printf("      <ogc:Between />\n");
+  msIO_printf("    </ogc:Comparison_Operators>\n");
+  msIO_printf("  </ogc:Scalar_Capabilities>\n");
+
+  msIO_printf("</ogc:Filter_Capabilities>\n\n");
+
+  /*
+  ** Done!
+  */
+  msIO_printf("</WFS_Capabilities>\n");
+
+  free(script_url_encoded);
+
+  return MS_SUCCESS;
+}
+
+/*
+** Helper functions for producing XML schema.
+*/
+
+static const char *msWFSGetGeometryType(const char *type,
+                                        OWSGMLVersion outputformat) {
+  if (!type)
+    return "GeometryPropertyType";
+
+  if (strcasecmp(type, "point") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+    case OWS_GML3:
+    case OWS_GML32:
+      return "PointPropertyType";
+    }
+  } else if (strcasecmp(type, "multipoint") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+    case OWS_GML3:
+    case OWS_GML32:
+      return "MultiPointPropertyType";
+    }
+  } else if (strcasecmp(type, "line") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "LineStringPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "CurvePropertyType";
+    }
+  } else if (strcasecmp(type, "multiline") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "MultiLineStringPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "MultiCurvePropertyType";
+    }
+  } else if (strcasecmp(type, "polygon") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "PolygonPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "SurfacePropertyType";
+    }
+  } else if (strcasecmp(type, "multipolygon") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "MultiPolygonPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "MultiSurfacePropertyType";
+    }
+  }
+
+  return "???unknown???";
+}
+
+static void msWFSWriteGeometryElement(FILE *stream,
+                                      gmlGeometryListObj *geometryList,
+                                      OWSGMLVersion outputformat,
+                                      const char *tab) {
+  int i;
+  gmlGeometryObj *geometry = NULL;
+
+  if (!stream || !tab)
+    return;
+  if (geometryList->numgeometries == 1 &&
+      strcasecmp(geometryList->geometries[0].name, "none") == 0)
+    return;
+
+  if (geometryList->numgeometries == 1) {
+    geometry = &(geometryList->geometries[0]);
+    msIO_fprintf(
+        stream, "%s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"", tab,
+        geometry->name, msWFSGetGeometryType(geometry->type, outputformat),
+        geometry->occurmin);
+    if (geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
+      msIO_fprintf(stream, " maxOccurs=\"unbounded\"/>\n");
+    else
+      msIO_fprintf(stream, " maxOccurs=\"%d\"/>\n", geometry->occurmax);
+  } else {
+    msIO_fprintf(stream, "%s<choice>\n", tab);
+    for (i = 0; i < geometryList->numgeometries; i++) {
+      geometry = &(geometryList->geometries[i]);
+
+      msIO_fprintf(stream,
+                   "  %s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"",
+                   tab, geometry->name,
+                   msWFSGetGeometryType(geometry->type, outputformat),
+                   geometry->occurmin);
+      if (geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
+        msIO_fprintf(stream, " maxOccurs=\"unbounded\"/>\n");
+      else
+        msIO_fprintf(stream, " maxOccurs=\"%d\"/>\n", geometry->occurmax);
+    }
+    msIO_fprintf(stream, "%s</choice>\n", tab);
+  }
+
+  return;
+}
+
+static OWSGMLVersion
+msWFSGetGMLVersionFromSchemaVersion(WFSSchemaVersion outputformat) {
+  switch (outputformat) {
+  case OWS_DEFAULT_SCHEMA:
+    return OWS_GML2;
+  case OWS_SFE_SCHEMA:
+    return OWS_GML3;
+  case OWS_GML32_SFE_SCHEMA:
+    return OWS_GML32;
+  }
+  return OWS_GML2;
+}
+
+static void msWFSSchemaWriteGeometryElement(FILE *stream,
+                                            gmlGeometryListObj *geometryList,
+                                            WFSSchemaVersion outputformat,
+                                            const char *tab) {
+  OWSGMLVersion gmlversion = msWFSGetGMLVersionFromSchemaVersion(outputformat);
+  msWFSWriteGeometryElement(stream, geometryList, gmlversion, tab);
+}
+
+static const char *msWFSMapServTypeToXMLType(const char *type) {
+  const char *element_type = "string";
+  /* Map from MapServer types to XSD types */
+  if (strcasecmp(type, "Integer") == 0)
+    element_type = "integer";
+  /* Note : xs:int and xs:integer differ */
+  else if (EQUAL(type, "int"))
+    element_type = "int";
+  if (strcasecmp(type, "Long") == 0) /* 64bit integer */
+    element_type = "long";
+  else if (
+      EQUAL(type, "Real") ||
+      EQUAL(type,
+            "double") /* just in case someone provided the xsd type directly */)
+    element_type = "double";
+  else if (EQUAL(type, "Character"))
+    element_type = "string";
+  else if (EQUAL(type, "Date"))
+    element_type = "date";
+  else if (EQUAL(type, "Time"))
+    element_type = "time";
+  else if (EQUAL(type, "DateTime"))
+    element_type = "dateTime";
+  else if (EQUAL(type, "Boolean"))
+    element_type = "boolean";
+  return element_type;
+}
+
+static void msWFSWriteItemElement(FILE *stream, gmlItemObj *item,
+                                  const char *tab,
+                                  WFSSchemaVersion outputformat,
+                                  int is_nillable) {
+  const char *element_name;
+  const char *element_type = "string";
+  const char *pszMinOccurs = "";
+  const char *pszNillable = "";
+
+  if (!stream || !item || !tab)
+    return;
+  if (!item->visible)
+    return; /* not exposing this attribute */
+  if (item->_template)
+    return; /* can't adequately deal with templated items yet */
+
+  if (item->alias) /* TODO: what about name spaces embedded in the alias? */
+    element_name = item->alias;
+  else
+    element_name = item->name;
+
+  if (item->type) {
+    if (outputformat == OWS_GML32_SFE_SCHEMA &&
+        (EQUAL(item->type, "Date") || EQUAL(item->type, "Time") ||
+         EQUAL(item->type, "DateTime")))
+      element_type = "gml:TimeInstantType";
+    else
+      element_type = msWFSMapServTypeToXMLType(item->type);
+  }
+
+  if (item->minOccurs == 0)
+    pszMinOccurs = " minOccurs=\"0\"";
+
+  if (is_nillable)
+    pszNillable = " nillable=\"true\"";
+
+  msIO_fprintf(stream, "%s<element name=\"%s\"%s%s type=\"%s\"/>\n", tab,
+               element_name, pszMinOccurs, pszNillable, element_type);
+
+  return;
+}
+
+static void msWFSWriteConstantElement(FILE *stream, gmlConstantObj *constant,
+                                      const char *tab) {
+  const char *element_type = "string";
+
+  if (!stream || !constant || !tab)
+    return;
+
+  if (constant->type)
+    element_type = msWFSMapServTypeToXMLType(constant->type);
+
+  msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s\"/>\n", tab,
+               constant->name, element_type);
+
+  return;
+}
+
+static void msWFSWriteGroupElement(FILE *stream, gmlGroupObj *group,
+                                   const char *tab, const char *_namespace) {
+  if (group->type)
+    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%s\"/>\n", tab,
+                 group->name, _namespace, group->type);
+  else
+    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%sType\"/>\n", tab,
+                 group->name, _namespace, group->name);
+
+  return;
+}
+
+static void msWFSWriteGroupElementType(FILE *stream, gmlGroupObj *group,
+                                       gmlItemListObj *itemList,
+                                       gmlConstantListObj *constantList,
+                                       const char *tab,
+                                       WFSSchemaVersion outputformat) {
+  int i, j;
+  char *element_tab;
+
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
+
+  /* setup the element tab */
+  element_tab = (char *)msSmallMalloc(sizeof(char) * strlen(tab) + 5);
+  sprintf(element_tab, "%s    ", tab);
+
+  if (group->type)
+    msIO_fprintf(stream, "%s<complexType name=\"%s\">\n", tab, group->type);
+  else
+    msIO_fprintf(stream, "%s<complexType name=\"%sType\">\n", tab, group->name);
+
+  msIO_fprintf(stream, "%s  <sequence>\n", tab);
+
+  /* now the items/constants (e.g. elements) in the group */
+  for (i = 0; i < group->numitems; i++) {
+    for (j = 0; j < constantList->numconstants;
+         j++) { /* find the right gmlConstantObj */
+      constant = &(constantList->constants[j]);
+      if (strcasecmp(constant->name, group->items[i]) == 0) {
+        msWFSWriteConstantElement(stream, constant, element_tab);
+        break;
+      }
+    }
+    if (j != constantList->numconstants)
+      continue;                                /* found this item */
+    for (j = 0; j < itemList->numitems; j++) { /* find the right gmlItemObj */
+      item = &(itemList->items[j]);
+      if (strcasecmp(item->name, group->items[i]) == 0) {
+        msWFSWriteItemElement(stream, item, element_tab, outputformat,
+                              MS_FALSE);
+        break;
+      }
+    }
+  }
+
+  msIO_fprintf(stream, "%s  </sequence>\n", tab);
+  msIO_fprintf(stream, "%s</complexType>\n", tab);
+  free(element_tab);
+
+  return;
+}
+
+static const char *msWFSGetGMLSchemaLocation(OWSGMLVersion outputformat) {
+  switch (outputformat) {
+  case OWS_GML2:
+    return MS_OWSCOMMON_GML_212_SCHEMA_LOCATION;
+  case OWS_GML3:
+    return MS_OWSCOMMON_GML_311_SCHEMA_LOCATION;
+  case OWS_GML32:
+    return MS_OWSCOMMON_GML_321_SCHEMA_LOCATION;
+  }
+  return "/unknown.xsd";
+}
+
+static const char *msWFSGetGMLNamespaceURI(WFSSchemaVersion outputformat) {
+  switch (outputformat) {
+  case OWS_DEFAULT_SCHEMA:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_SFE_SCHEMA:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_GML32_SFE_SCHEMA:
+    return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
+  }
+  return "http://unknown";
+}
+
+static const char *
+msWFSGetGMLNamespaceURIFromGMLVersion(OWSGMLVersion outputformat) {
+  switch (outputformat) {
+  case OWS_GML2:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_GML3:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_GML32:
+    return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
+  }
+  return "http://unknown";
+}
+
+static void msWFS_NS_printf(const char *prefix, const char *uri) {
+  if (prefix == NULL)
+    msIO_printf("   xmlns=\"%s\"\n", uri);
+  else
+    msIO_printf("   xmlns:%s=\"%s\"\n", prefix, uri);
+}
+
+static void
+msWFSPrintAdditionalNamespaces(const gmlNamespaceListObj *namespaceList) {
+  int i;
+  /* any additional namespaces */
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri) {
+      char *uri_encoded = NULL;
+
+      uri_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].uri);
+      msWFS_NS_printf(namespaceList->namespaces[i].prefix, uri_encoded);
+      msFree(uri_encoded);
+    }
+  }
+}
+
+static const char *msWFSStripNS(const char *name) {
+  const char *pszColon = strchr(name, ':');
+  const char *pszSlash = strchr(name, '/');
+  if (pszColon && (pszSlash == NULL || pszColon < pszSlash))
+    return pszColon + 1;
+  return name;
+}
+
+/*
+** msWFSDescribeFeatureType()
+*/
+static int msWFSDescribeFeatureType(mapObj *map, wfsParamsObj *paramsObj,
+                                    owsRequestObj *ows_request,
+                                    int nWFSVersion) {
+  int i, numlayers = 0;
+  char **layers = NULL;
+
+  const char *value;
+  const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+  const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+  char *user_namespace_uri_encoded = NULL;
+  const char *collection_name = OWS_WFS_FEATURE_COLLECTION_NAME;
+  char *encoded;
+
+  WFSSchemaVersion outputformat =
+      OWS_DEFAULT_SCHEMA; /* default output is GML 2.1 compliant schema*/
+
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
+  char *mimetype = NULL;
+
+  if (paramsObj->pszTypeName && numlayers == 0) {
+    /* Parse comma-delimited list of type names (layers) */
+    layers = msStringSplit(paramsObj->pszTypeName, ',', &numlayers);
+    if (numlayers > 0) {
+      /* strip namespace if there is one :ex TYPENAME=cdf:Other */
+      for (i = 0; i < numlayers; i++) {
+        char *pszTmp = msStrdup(msWFSStripNS(layers[i]));
+        free(layers[i]);
+        layers[i] = pszTmp;
+      }
+    }
+  }
+
+  if (paramsObj->pszOutputFormat) {
+    if (strcasecmp(paramsObj->pszOutputFormat, "XMLSCHEMA") == 0 ||
+        strstr(paramsObj->pszOutputFormat, "gml/2") != NULL) {
+      mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/2.1.2");
+      outputformat = OWS_DEFAULT_SCHEMA;
+    } else if (strcasecmp(paramsObj->pszOutputFormat, "SFE_XMLSCHEMA") == 0 ||
+               strstr(paramsObj->pszOutputFormat, "gml/3.1") != NULL) {
+      mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/3.1.1");
+      outputformat = OWS_SFE_SCHEMA;
+    } else if (strstr(paramsObj->pszOutputFormat, "gml/3.2") != NULL ||
+               strstr(paramsObj->pszOutputFormat,
+                      "application/gml+xml; version=3.2") != NULL) {
+      mimetype = msEncodeHTMLEntities("application/gml+xml; version=3.2");
+      outputformat = OWS_GML32_SFE_SCHEMA;
+    } else {
+      msSetError(MS_WFSERR,
+                 "Unsupported DescribeFeatureType outputFormat (%s).",
+                 "msWFSDescribeFeatureType()", paramsObj->pszOutputFormat);
+      if (layers)
+        msFreeCharArray(layers, numlayers);
+      msFree(mimetype);
+      return msWFSException(map, "outputformat",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+  }
+  /* If no outputFormat explicitely asked, use a sensible default for the WFS
+     version */
+  else {
+    switch (nWFSVersion) {
+    case OWS_1_0_0:
+    default:
+      mimetype = msEncodeHTMLEntities(
+          "text/xml"); /* ERO: why not "text/xml; subtype=gml/2.1.2" ? */
+      break;
+
+    case OWS_1_1_0:
+      mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/3.1.1");
+      outputformat = OWS_SFE_SCHEMA;
+      break;
+
+    case OWS_2_0_0:
+      mimetype = msEncodeHTMLEntities("application/gml+xml; version=3.2");
+      outputformat = OWS_GML32_SFE_SCHEMA;
+      break;
+    }
+  }
+
+  /* Validate layers */
+  if (numlayers > 0) {
+    for (i = 0; i < numlayers; i++) {
+      layerObj *lp = msWFSGetLayerByName(map, ows_request, layers[i]);
+      if (lp == NULL) {
+        msSetError(MS_WFSERR,
+                   "Invalid typename (%s). A layer might be disabled for \
+this request. Check wfs/ows_enable_request settings.",
+                   "msWFSDescribeFeatureType()",
+                   layers[i]); /* paramsObj->pszTypeName); */
+        msFreeCharArray(layers, numlayers);
+        msFree(mimetype);
+        return msWFSException(map, "typename",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
+      }
+    }
+  }
+
+  /*
+  ** retrieve any necessary external namespace/schema configuration information
+  */
+  namespaceList = msGMLGetNamespaces(&(map->web), "G");
+  if (namespaceList == NULL) {
+    msSetError(MS_MISCERR, "Unable to populate namespace list",
+               "msWFSDescribeFeatureType()");
+    return MS_FAILURE;
+  }
+
+  /*
+  ** DescribeFeatureType response
+  */
+
+  msIO_setHeader("Content-Type", "%s; charset=UTF-8", mimetype);
+  msIO_sendHeaders();
+
+  if (mimetype)
+    msFree(mimetype);
+
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
+  if (value)
+    user_namespace_uri = value;
+  user_namespace_uri_encoded = msEncodeHTMLEntities(user_namespace_uri);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
+  if (value)
+    user_namespace_prefix = value;
+  if (user_namespace_prefix != NULL &&
+      msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        user_namespace_prefix);
+
+  msIO_printf("<schema\n"
+              "   targetNamespace=\"%s\" \n"
+              "   xmlns:%s=\"%s\" \n",
+              user_namespace_uri_encoded, user_namespace_prefix,
+              user_namespace_uri_encoded);
+  if (nWFSVersion < OWS_2_0_0)
+    msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_OGC_NAMESPACE_URI);
+  msWFS_NS_printf("xsd", MS_OWSCOMMON_W3C_XS_NAMESPACE_URI);
+  msWFS_NS_printf(NULL, MS_OWSCOMMON_W3C_XS_NAMESPACE_URI);
+  msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
+                  msWFSGetGMLNamespaceURI(outputformat));
+
+  msWFSPrintAdditionalNamespaces(namespaceList);
+
+  msIO_printf("   elementFormDefault=\"qualified\" version=\"0.1\" >\n");
+
+  encoded = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  msIO_printf("\n  <import namespace=\"%s\"\n"
+              "          schemaLocation=\"%s%s\" />\n",
+              msWFSGetGMLNamespaceURI(outputformat), encoded,
+              msWFSGetGMLSchemaLocation(
+                  msWFSGetGMLVersionFromSchemaVersion(outputformat)));
+
+  msFree(encoded);
+
+  /* any additional namespace includes */
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri &&
+        namespaceList->namespaces[i].schemalocation) {
+      char *schema_location_encoded = NULL, *uri_encoded = NULL;
+
+      uri_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].uri);
+      schema_location_encoded =
+          msEncodeHTMLEntities(namespaceList->namespaces[i].schemalocation);
+      msIO_printf("\n  <import namespace=\"%s\"\n schemaLocation=\"%s\" />\n",
+                  uri_encoded, schema_location_encoded);
+      msFree(uri_encoded);
+      msFree(schema_location_encoded);
+    }
+  }
+
+  /* output definition for the default feature container, can't use
+     wfs:FeatureCollection with GML3: kept here so that the behaviour with
+     wfs1.0 and gml3 output is preserved. We can use the wfs:FeatureCollection
+     for wfs1.1*/
+  if (outputformat == OWS_SFE_SCHEMA && nWFSVersion == OWS_1_0_0) {
+    value =
+        msOWSLookupMetadata(&(map->web.metadata), "FO", "feature_collection");
+    if (value)
+      collection_name = value;
+
+    msIO_printf("  <element name=\"%s\" type=\"%s:%sType\" "
+                "substitutionGroup=\"gml:_FeatureCollection\"/>\n",
+                collection_name, user_namespace_prefix, collection_name);
+    msIO_printf("  <complexType name=\"%sType\">\n", collection_name);
+    msIO_printf("    <complexContent>\n");
+    msIO_printf(
+        "      <extension base=\"gml:AbstractFeatureCollectionType\">\n");
+    msIO_printf("        <attribute name=\"version\" type=\"string\" "
+                "use=\"required\" fixed=\"1.0.0\"/>\n");
+    msIO_printf("      </extension>\n");
+    msIO_printf("    </complexContent>\n");
+    msIO_printf("  </complexType>\n");
+  }
+
+  /*
+  ** loop through layers
+  */
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp;
+    int j, bFound = 0;
+
+    lp = GET_LAYER(map, i);
+
+    for (j = 0; j < numlayers && !bFound; j++) {
+      if (lp->name && strcasecmp(lp->name, layers[j]) == 0)
+        bFound = 1;
+    }
+
+    if ((numlayers == 0 || bFound) && msWFSIsLayerAllowed(lp, ows_request)) {
+
+      /*
+      ** OK, describe this layer IF you can open it and retrieve items
+      */
+      if (msLayerOpen(lp) == MS_SUCCESS) {
+        if (msLayerGetItems(lp) == MS_SUCCESS) {
+          int k;
+          gmlGroupListObj *groupList = NULL;
+          gmlItemListObj *itemList = NULL;
+          gmlConstantListObj *constantList = NULL;
+          gmlGeometryListObj *geometryList = NULL;
+          gmlItemObj *item = NULL;
+          gmlConstantObj *constant = NULL;
+          char *encoded_name = NULL;
+
+          const char *layer_namespace_prefix;
+          const char *substitution_group;
+          char *encoded_type = NULL;
+
+          itemList = msGMLGetItems(lp, "G"); /* GML-related metadata */
+          constantList = msGMLGetConstants(lp, "G");
+          groupList = msGMLGetGroups(lp, "G");
+          geometryList = msGMLGetGeometries(lp, "GFO", MS_TRUE);
+          if (itemList == NULL || constantList == NULL || groupList == NULL ||
+              geometryList == NULL) {
+            msSetError(MS_MISCERR,
+                       "Unable to populate item and group metadata structures",
+                       "msWFSDescribeFeatureType()");
+            return MS_FAILURE;
+          }
+
+          value =
+              msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
+          if (value)
+            layer_namespace_prefix = value;
+          else
+            layer_namespace_prefix = user_namespace_prefix;
+
+          encoded_name = msEncodeHTMLEntities(lp->name);
+          value = msOWSLookupMetadata(&(lp->metadata), "F", "layer_type");
+          if (value) {
+            encoded_type = msEncodeHTMLEntities(value);
+          } else {
+            size_t sz = strlen(encoded_name) + strlen("Type") + 1;
+            encoded_type = (char *)msSmallMalloc(sz);
+            strlcpy(encoded_type, encoded_name, sz);
+            strlcat(encoded_type, "Type", sz);
+          }
+
+          switch (outputformat) {
+          case OWS_DEFAULT_SCHEMA: /* default GML 2.1.x schema */
+          case OWS_SFE_SCHEMA:     /* reference GML 3.1.1 schema */
+          default:
+            substitution_group = "gml:_Feature";
+            break;
+
+          case OWS_GML32_SFE_SCHEMA: /* reference GML 3.2.1 schema */
+            substitution_group = "gml:AbstractFeature";
+            break;
+          }
+
+          msIO_printf("\n"
+                      "  <element name=\"%s\" \n"
+                      "           type=\"%s:%s\" \n"
+                      "           substitutionGroup=\"%s\" />\n\n",
+                      encoded_name, layer_namespace_prefix, encoded_type,
+                      substitution_group);
+          msFree(encoded_type);
+
+          if (strcmp(layer_namespace_prefix, user_namespace_prefix) != 0) {
+            msFree(encoded_name);
+            msGMLFreeItems(itemList);
+            msGMLFreeConstants(constantList);
+            msGMLFreeGroups(groupList);
+            msGMLFreeGeometries(geometryList);
+            continue; /* the rest is defined in an external schema */
+          }
+
+          msIO_printf("  <complexType name=\"%sType\">\n", encoded_name);
+          msIO_printf("    <complexContent>\n");
+          msIO_printf("      <extension base=\"gml:AbstractFeatureType\">\n");
+          msIO_printf("        <sequence>\n");
+
+          /* write the geometry schema element(s) */
+          msWFSSchemaWriteGeometryElement(stdout, geometryList, outputformat,
+                                          "          ");
+
+          /* write the constant-based schema elements */
+          for (k = 0; k < constantList->numconstants; k++) {
+            constant = &(constantList->constants[k]);
+            if (msItemInGroups(constant->name, groupList) == MS_FALSE)
+              msWFSWriteConstantElement(stdout, constant, "          ");
+          }
+
+          /* write the item-based schema elements */
+          for (k = 0; k < itemList->numitems; k++) {
+            item = &(itemList->items[k]);
+            if (msItemInGroups(item->name, groupList) == MS_FALSE) {
+              int nillable = MS_FALSE;
+              char mdname[256];
+              const char *pszNillable;
+              snprintf(mdname, sizeof(mdname), "%s_nillable", item->name);
+              pszNillable = msOWSLookupMetadata(&(lp->metadata), "G", mdname);
+              if (pszNillable && strcasecmp(pszNillable, "true") == 0)
+                nillable = MS_TRUE;
+              msWFSWriteItemElement(stdout, item, "          ", outputformat,
+                                    nillable);
+            }
+          }
+
+          for (k = 0; k < groupList->numgroups; k++)
+            msWFSWriteGroupElement(stdout, &(groupList->groups[k]),
+                                   "          ", user_namespace_prefix);
+
+          msIO_printf("        </sequence>\n");
+          msIO_printf("      </extension>\n");
+          msIO_printf("    </complexContent>\n");
+          msIO_printf("  </complexType>\n");
+
+          /* any group types */
+          for (k = 0; k < groupList->numgroups; k++)
+            msWFSWriteGroupElementType(stdout, &(groupList->groups[k]),
+                                       itemList, constantList, "  ",
+                                       outputformat);
+
+          msGMLFreeItems(itemList);
+          msGMLFreeConstants(constantList);
+          msGMLFreeGroups(groupList);
+          msGMLFreeGeometries(geometryList);
+
+          msFree(encoded_name);
+        }
+
+        msLayerClose(lp);
+      } else {
+        msIO_printf("\n\n<!-- ERROR: Failed opening layer %s -->\n\n",
+                    lp->name);
+      }
+    }
+  }
+
+  /*
+  ** Done!
+  */
+  msIO_printf("\n</schema>\n");
+
+  msFree(user_namespace_uri_encoded);
+
+  if (layers)
+    msFreeCharArray(layers, numlayers);
+
+  msGMLFreeNamespaces(namespaceList);
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSGetFeature_GMLPreamble()
+**
+** Generate the GML preamble up to the first feature for the builtin
+** WFS GML support.
+*/
+
+typedef struct {
+  const char *user_namespace_prefix;
+  const char *user_namespace_uri;
+  char *user_namespace_uri_encoded;
+  const char *collection_name;
+  const char *_typename;
+  char *script_url, *script_url_encoded;
+  const char *output_mime_type;
+  const char *output_schema_format;
+} WFSGMLInfo;
+
+static void msWFSPrintURLAndXMLEncoded(const char *str) {
+  char *url_encoded = msEncodeUrl(str);
+  char *xml_encoded = msEncodeHTMLEntities(url_encoded);
+  msIO_printf("%s", xml_encoded);
+  msFree(xml_encoded);
+  msFree(url_encoded);
+}
+
+static void msWFSGetFeature_PrintBasePrevNextURI(
+    cgiRequestObj *req, WFSGMLInfo *gmlinfo, wfsParamsObj *paramsObj,
+    const char *encoded_version, const char *encoded_typename,
+    const char *encoded_mime_type) {
+  int i;
+  int bFirstArg = MS_TRUE;
+  msIO_printf("%s", gmlinfo->script_url_encoded);
+
+  if (req->postrequest != NULL) {
+    msIO_printf("SERVICE=WFS&amp;VERSION=");
+    msIO_printf("%s", encoded_version);
+    msIO_printf("&amp;REQUEST=");
+    msIO_printf("%s", paramsObj->pszRequest);
+    msIO_printf("&amp;TYPENAMES=");
+    msIO_printf("%s", encoded_typename);
+    msIO_printf("&amp;OUTPUTFORMAT=");
+    msIO_printf("%s", encoded_mime_type);
+    if (paramsObj->pszBbox != NULL) {
+      msIO_printf("&amp;BBOX=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszBbox);
+    }
+    if (paramsObj->pszSrs != NULL) {
+      msIO_printf("&amp;SRSNAME=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszSrs);
+    }
+    if (paramsObj->pszFilter != NULL) {
+      msIO_printf("&amp;FILTER=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszFilter);
+    }
+    if (paramsObj->pszPropertyName != NULL) {
+      msIO_printf("&amp;PROPERTYNAME=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszPropertyName);
+    }
+    if (paramsObj->pszValueReference != NULL) {
+      msIO_printf("&amp;VALUEREFERENCE=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszValueReference);
+    }
+    if (paramsObj->pszSortBy != NULL) {
+      msIO_printf("&amp;SORTBY=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszSortBy);
+    }
+    if (paramsObj->nMaxFeatures >= 0)
+      msIO_printf("&amp;COUNT=%d", paramsObj->nMaxFeatures);
+  } else {
+    for (i = 0; i < req->NumParams; i++) {
+      if (req->ParamNames[i] && req->ParamValues[i] &&
+          strcasecmp(req->ParamNames[i], "MAP") != 0 &&
+          strcasecmp(req->ParamNames[i], "STARTINDEX") != 0 &&
+          strcasecmp(req->ParamNames[i], "RESULTTYPE") != 0) {
+        if (!bFirstArg)
+          msIO_printf("&amp;");
+        bFirstArg = MS_FALSE;
+        msIO_printf("%s=", req->ParamNames[i]);
+        msWFSPrintURLAndXMLEncoded(req->ParamValues[i]);
+      }
+    }
+  }
+}
+
+static void msWFSGetFeature_GetTimeStamp(char *timestring,
+                                         size_t timestringlen) {
+  struct tm *now;
+  time_t tim = time(NULL);
+
+  now = localtime(&tim);
+
+  snprintf(timestring, timestringlen, "%d-%02d-%02dT%02d:%02d:%02d",
+           now->tm_year + 1900, now->tm_mon + 1, now->tm_mday, now->tm_hour,
+           now->tm_min, now->tm_sec);
+}
+
+static int msWFSGetFeature_GMLPreamble(
+    mapObj *map, cgiRequestObj *req, WFSGMLInfo *gmlinfo,
+    wfsParamsObj *paramsObj, OWSGMLVersion outputformat, int iResultTypeHits,
+    int iNumberOfFeatures, int nMatchingFeatures, int maxfeatures,
+    int bHasNextFeatures, int nWFSVersion)
+
+{
+  const char *value;
+  char *encoded_version, *encoded_typename, *encoded_schema;
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
+  char timestring[100];
+  timestring[0] = '\0';
+
+  namespaceList = msGMLGetNamespaces(&(map->web), "G");
+  if (namespaceList == NULL) {
+    msSetError(MS_MISCERR, "Unable to populate namespace list",
+               "msWFSGetFeature_GMLPreamble()");
+    return MS_FAILURE;
+  }
+
+  /*
+  ** Establish script_url.
+  */
+
+  if ((gmlinfo->script_url =
+           msOWSGetOnlineResource(map, "FO", "onlineresource", req)) == NULL ||
+      (gmlinfo->script_url_encoded =
+           msEncodeHTMLEntities(gmlinfo->script_url)) == NULL) {
+    msSetError(MS_WFSERR, "Server URL not found", "msWFSGetFeature()");
+    msGMLFreeNamespaces(namespaceList);
+    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          paramsObj->pszVersion);
+  }
+
+  /*
+  ** Write encoding.
+  */
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
+  if (value)
+    gmlinfo->user_namespace_uri = value;
+  gmlinfo->user_namespace_uri_encoded =
+      msEncodeHTMLEntities(gmlinfo->user_namespace_uri);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
+  if (value)
+    gmlinfo->user_namespace_prefix = value;
+
+  if (gmlinfo->user_namespace_prefix != NULL &&
+      msIsXMLTagValid(gmlinfo->user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        gmlinfo->user_namespace_prefix);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "feature_collection");
+  if (value)
+    gmlinfo->collection_name = value;
+
+  encoded_version = msEncodeHTMLEntities(paramsObj->pszVersion);
+  encoded_typename = msEncodeHTMLEntities(gmlinfo->_typename);
+  encoded_schema = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  if (nWFSVersion >= OWS_2_0_0) {
+    int nNextStartIndex;
+    char *tmp;
+    char *encoded_mime_type;
+    int bAbleToPrintPreviousOrNext = MS_TRUE;
+
+    tmp = msEncodeUrl(gmlinfo->output_mime_type);
+    encoded_mime_type = msEncodeHTMLEntities(tmp);
+    msFree(tmp);
+
+    msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
+
+    if (strcasecmp(paramsObj->pszRequest, "GetFeature") == 0)
+      msIO_printf("<wfs:FeatureCollection\n");
+    else
+      msIO_printf("<wfs:ValueCollection\n");
+
+    msWFS_NS_printf(gmlinfo->user_namespace_prefix,
+                    gmlinfo->user_namespace_uri_encoded);
+    msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
+                    msWFSGetGMLNamespaceURIFromGMLVersion(outputformat));
+    msWFS_NS_printf(MS_OWSCOMMON_WFS_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+    msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
+    msWFSPrintAdditionalNamespaces(namespaceList);
+
+    msIO_printf("   xsi:schemaLocation=\"%s "
+                "%sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&"
+                "amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s "
+                "%s %s%s "
+                "%s %s%s\"\n",
+                gmlinfo->user_namespace_uri_encoded,
+                gmlinfo->script_url_encoded, encoded_version, encoded_typename,
+                gmlinfo->output_schema_format,
+
+                MS_OWSCOMMON_WFS_20_NAMESPACE_URI, encoded_schema,
+                MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION,
+
+                msWFSGetGMLNamespaceURIFromGMLVersion(outputformat),
+                encoded_schema, msWFSGetGMLSchemaLocation(outputformat));
+
+    msIO_printf("   timeStamp=\"%s\" numberMatched=\"", timestring);
+    if (nMatchingFeatures < 0) {
+      /* If we don't know the exact number, at least return something */
+      /* equivalent to what we would return with WFS 1.1, otherwise */
+      /* resultType=hits would not return anything usefull to the client. */
+      if (iResultTypeHits == MS_TRUE)
+        msIO_printf("%d", iNumberOfFeatures);
+      else
+        msIO_printf("unknown");
+    } else
+      msIO_printf("%d", nMatchingFeatures);
+    msIO_printf("\" numberReturned=\"%d\"",
+                (iResultTypeHits == 1) ? 0 : iNumberOfFeatures);
+
+    /* TODO: in case of a multi-layer GetFeature POST, it is difficult to build
+     * a */
+    /* valid GET KVP GetFeature/GetPropertyValue when some options are
+     * specified. So for now just */
+    /* avoid those problematic cases */
+    if (req->postrequest != NULL &&
+        (paramsObj->bHasPostStoredQuery ||
+         (strchr(encoded_typename, ',') != NULL &&
+          (paramsObj->pszFilter != NULL || paramsObj->pszPropertyName != NULL ||
+           paramsObj->pszSortBy != NULL)))) {
+      bAbleToPrintPreviousOrNext = MS_FALSE;
+    }
+
+    if (bAbleToPrintPreviousOrNext) {
+      if (maxfeatures > 0 && iResultTypeHits != 1 &&
+          paramsObj->nStartIndex > 0 &&
+          ((nMatchingFeatures < 0 && iNumberOfFeatures > 0) ||
+           (nMatchingFeatures >= 0 &&
+            paramsObj->nStartIndex < nMatchingFeatures))) {
+        int nPrevStartIndex;
+
+        msIO_printf("\n");
+        msIO_printf("   previous=\"");
+        msWFSGetFeature_PrintBasePrevNextURI(req, gmlinfo, paramsObj,
+                                             encoded_version, encoded_typename,
+                                             encoded_mime_type);
+
+        nPrevStartIndex = paramsObj->nStartIndex - maxfeatures;
+        if (nPrevStartIndex > 0)
+          msIO_printf("&amp;STARTINDEX=%d", nPrevStartIndex);
+        msIO_printf("\"");
+      }
+
+      if (iResultTypeHits != 1 && paramsObj->nStartIndex >= 0)
+        nNextStartIndex = paramsObj->nStartIndex;
+      else
+        nNextStartIndex = 0;
+      if (maxfeatures > 0 &&
+          (bHasNextFeatures ||
+           (nMatchingFeatures > 0 &&
+            (iResultTypeHits == 1 ||
+             iNumberOfFeatures + nNextStartIndex < nMatchingFeatures)))) {
+        msIO_printf("\n");
+        msIO_printf("   next=\"");
+        msWFSGetFeature_PrintBasePrevNextURI(req, gmlinfo, paramsObj,
+                                             encoded_version, encoded_typename,
+                                             encoded_mime_type);
+
+        if (iResultTypeHits != 1)
+          nNextStartIndex += iNumberOfFeatures;
+
+        if (nNextStartIndex > 0)
+          msIO_printf("&amp;STARTINDEX=%d", nNextStartIndex);
+        msIO_printf("\"");
+      }
+    }
+
+    msIO_printf(">\n");
+
+    msFree(encoded_mime_type);
+  }
+  /*
+  ** GML 2.x
+  */
+  else if (outputformat == OWS_GML2) { /* use a wfs:FeatureCollection */
+    msIO_printf("<wfs:FeatureCollection\n");
+    msWFS_NS_printf(gmlinfo->user_namespace_prefix,
+                    gmlinfo->user_namespace_uri_encoded);
+    msWFS_NS_printf(MS_OWSCOMMON_WFS_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_WFS_NAMESPACE_URI);
+    msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_GML_NAMESPACE_URI);
+    msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_OGC_NAMESPACE_URI);
+    msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
+    msWFSPrintAdditionalNamespaces(namespaceList);
+
+    /* FIXME ? : the schemaLocation will be only valid for WFS 1.0.0 */
+    msIO_printf("   xsi:schemaLocation=\"http://www.opengis.net/wfs "
+                "%s/wfs/%s/WFS-basic.xsd \n"
+                "                       %s "
+                "%sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&"
+                "amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s\">\n",
+                encoded_schema, encoded_version,
+                gmlinfo->user_namespace_uri_encoded,
+                gmlinfo->script_url_encoded, encoded_version, encoded_typename,
+                gmlinfo->output_schema_format);
+  }
+
+  /*
+  ** GML 3
+  */
+  else if (outputformat == OWS_GML3) {
+    if (nWFSVersion == OWS_1_1_0) {
+      msIO_printf("<wfs:FeatureCollection\n");
+      msWFS_NS_printf(gmlinfo->user_namespace_prefix,
+                      gmlinfo->user_namespace_uri_encoded);
+      msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
+                      MS_OWSCOMMON_GML_NAMESPACE_URI);
+      msWFS_NS_printf(MS_OWSCOMMON_WFS_NAMESPACE_PREFIX,
+                      MS_OWSCOMMON_WFS_NAMESPACE_URI);
+      msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
+                      MS_OWSCOMMON_OGC_NAMESPACE_URI);
+      msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
+                      MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
+    } else {
+      msIO_printf("<%s:%s\n"
+                  "   version=\"1.0.0\"\n",
+                  gmlinfo->user_namespace_prefix, gmlinfo->collection_name);
+      msWFS_NS_printf(gmlinfo->user_namespace_prefix,
+                      gmlinfo->user_namespace_uri_encoded);
+      msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
+                      MS_OWSCOMMON_GML_NAMESPACE_URI);
+      msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
+                      MS_OWSCOMMON_OGC_NAMESPACE_URI);
+      msWFS_NS_printf(MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX,
+                      MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
+    }
+
+    msWFSPrintAdditionalNamespaces(namespaceList);
+
+    msIO_printf("   xsi:schemaLocation=\"%s "
+                "%sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&"
+                "amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s",
+                gmlinfo->user_namespace_uri_encoded,
+                gmlinfo->script_url_encoded, encoded_version, encoded_typename,
+                gmlinfo->output_schema_format);
+
+    if (nWFSVersion == OWS_1_1_0) {
+
+      msIO_printf("  %s %s%s", MS_OWSCOMMON_WFS_NAMESPACE_URI, encoded_schema,
+                  MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION);
+
+      if (iResultTypeHits == 1) {
+        msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
+
+        msIO_printf("\" timeStamp=\"%s\" numberOfFeatures=\"%d", timestring,
+                    iNumberOfFeatures);
+      }
+    }
+    msIO_printf("\">\n");
+  }
+
+  msFree(encoded_version);
+  msFree(encoded_schema);
+  msFree(encoded_typename);
+
+  msGMLFreeNamespaces(namespaceList);
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSGetFeature_GMLPostfix()
+**
+** Generate the GML file tail closing the collection and cleanup a bit.
+*/
+
+static int msWFSGetFeature_GMLPostfix(WFSGMLInfo *gmlinfo,
+                                      OWSGMLVersion outputformat,
+                                      int maxfeatures, int iResultTypeHits,
+                                      int iNumberOfFeatures, int nWFSVersion)
+
+{
+  if (((iNumberOfFeatures == 0) || (maxfeatures == 0)) &&
+      iResultTypeHits == 0) {
+
+    if (nWFSVersion < OWS_2_0_0) {
+      msIO_printf("   <gml:boundedBy>\n");
+      if (outputformat == OWS_GML3 || outputformat == OWS_GML32)
+        msIO_printf("      <gml:Null>missing</gml:Null>\n");
+      else
+        msIO_printf("      <gml:null>missing</gml:null>\n");
+      msIO_printf("   </gml:boundedBy>\n");
+    }
+  }
+
+  if (outputformat == OWS_GML2)
+    msIO_printf("</wfs:FeatureCollection>\n\n");
+  else {
+    if (nWFSVersion >= OWS_1_1_0)
+      msIO_printf("</wfs:FeatureCollection>\n\n");
+    else
+      msIO_printf("</%s:%s>\n\n", gmlinfo->user_namespace_prefix,
+                  gmlinfo->collection_name);
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSBuildParamList()
+*/
+static void msWFSBuildParamList(char **ppszStrList, const char *pszValue,
+                                const char *pszSep) {
+  if (*ppszStrList == NULL)
+    *ppszStrList = msStrdup(pszValue);
+  else {
+    char *pszTmp = msStrdup(*ppszStrList);
+    *ppszStrList = (char *)msSmallRealloc(
+        *ppszStrList, sizeof(char) * (strlen(pszTmp) + strlen(pszSep) +
+                                      strlen(pszValue) + 1));
+
+    sprintf(*ppszStrList, "%s%s%s", pszTmp, pszSep, pszValue);
+    free(pszTmp);
+  }
+}
+
+/*
+** msWFSTurnOffAllLayer()
+*/
+static void msWFSTurnOffAllLayer(mapObj *map) {
+  int j;
+  for (j = 0; j < map->numlayers; j++) {
+    layerObj *lp;
+    lp = GET_LAYER(map, j);
+    lp->status = MS_OFF;
+  }
+}
+
+/*
+** msWFSRunFilter()
+*/
+static int msWFSRunFilter(mapObj *map, layerObj *lp,
+                          const wfsParamsObj *paramsObj, const char *pszFilter,
+                          int nWFSVersion) {
+  int layerWasOpened;
+  FilterEncodingNode *psNode = NULL;
+
+  psNode = FLTParseFilterEncoding(pszFilter);
+
+  if (!psNode) {
+    msSetError(MS_WFSERR, "Invalid or Unsupported FILTER in GetFeature : %s",
+               "msWFSGetFeature()", pszFilter);
+    return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
+
+  /* Starting with WFS 1.1, we need to swap coordinates of BBOX or geometry */
+  /* parameters in some circumstances */
+  if (nWFSVersion >= OWS_1_1_0) {
+    int bDefaultSRSNeedsAxisSwapping = MS_FALSE;
+    char *srs;
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                     &srs);
+    if (!srs) {
+      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &srs);
+    }
+    if (srs && strncasecmp(srs, "EPSG:", 5) == 0) {
+      bDefaultSRSNeedsAxisSwapping = msIsAxisInverted(atoi(srs + 5));
+    }
+    msFree(srs);
+    FLTDoAxisSwappingIfNecessary(map, psNode, bDefaultSRSNeedsAxisSwapping);
+  }
+
+  layerWasOpened = msLayerIsOpen(lp);
+  if (!layerWasOpened && msLayerOpen(lp) != MS_SUCCESS) {
+    FLTFreeFilterEncodingNode(psNode);
+    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          paramsObj->pszVersion);
+  }
+
+  FLTProcessPropertyIsNull(psNode, map, lp->index);
+
+  /*preparse the filter for gml aliases*/
+  FLTPreParseFilterForAliasAndGroup(psNode, map, lp->index, "G");
+
+  /* Check that FeatureId filters are consistent with the active layer */
+  if (FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE) {
+    FLTFreeFilterEncodingNode(psNode);
+    return msWFSException(map, "resourceid",
+                          MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
+
+  /* FIXME?: could probably apply to WFS 1.1 too */
+  if (nWFSVersion >= OWS_2_0_0) {
+    int nEvaluation;
+
+    if (FLTCheckInvalidOperand(psNode) == MS_FAILURE) {
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "filter",
+                            MS_WFS_ERROR_OPERATION_PROCESSING_FAILED,
+                            paramsObj->pszVersion);
+    }
+
+    if (FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE) {
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+
+    psNode = FLTSimplify(psNode, &nEvaluation);
+    if (psNode == NULL) {
+      FLTFreeFilterEncodingNode(psNode);
+      if (nEvaluation == 1) {
+        /* return full layer */
+        return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
+      } else {
+        /* return empty result set */
+        return MS_SUCCESS;
+      }
+    }
+  }
+
+  // ignore any classes used by the WFS layer to avoid selecting fields we don't
+  // need
+  int numclasses = lp->numclasses;
+  lp->numclasses = 0;
+
+  /* run filter.  If no results are found, do not throw exception */
+  /* this is a null result */
+  int status = FLTApplyFilterToLayer(psNode, map, lp->index);
+
+  // set the class count to the original value
+  lp->numclasses = numclasses;
+
+  if (status != MS_SUCCESS) {
+    errorObj *ms_error = msGetErrorObj();
+
+    if (ms_error->code != MS_NOTFOUND) {
+      msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed",
+                 "msWFSGetFeature()");
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "mapserv",
+                            (nWFSVersion >= OWS_2_0_0)
+                                ? MS_WFS_ERROR_OPERATION_PROCESSING_FAILED
+                                : MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
+    }
+  }
+
+  FLTFreeFilterEncodingNode(psNode);
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSRunBasicGetFeature()
+*/
+static int msWFSRunBasicGetFeature(mapObj *map, layerObj *lp,
+                                   const wfsParamsObj *paramsObj,
+                                   int nWFSVersion) {
+  rectObj ext;
+  int status;
+
+  map->query.type = MS_QUERY_BY_RECT; /* setup the query */
+  map->query.mode = MS_QUERY_MULTIPLE;
+  map->query.rect = map->extent;
+  map->query.layer = lp->index;
+
+  if (FLTLayerSetInvalidRectIfSupported(lp, &(map->query.rect))) {
+    /* do nothing */
+  } else if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
+    char *pszMapSRS = NULL;
+
+    /*if srsName was given for wfs 1.1.0, It is at this point loaded into the
+    map object and should be used*/
+    if (!paramsObj->pszSrs)
+      msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                       &pszMapSRS);
+
+    /* For a single point layer, to avoid numerical precision issues */
+    /* when reprojection is involved */
+    ext.minx -= 1e-5;
+    ext.miny -= 1e-5;
+    ext.maxx += 1e-5;
+    ext.maxy += 1e-5;
+
+    if (pszMapSRS != NULL && strncmp(pszMapSRS, "EPSG:", 5) == 0) {
+
+      if (nWFSVersion >= OWS_1_1_0)
+        status = msLoadProjectionStringEPSG(&(map->projection), pszMapSRS);
+      else
+        status = msLoadProjectionString(&(map->projection), pszMapSRS);
+
+      if (status != 0) {
+        msSetError(MS_WFSERR, "msLoadProjectionString() failed: %s",
+                   "msWFSGetFeature()", pszMapSRS);
+        msFree(pszMapSRS);
+        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                              paramsObj->pszVersion);
+      }
+    }
+    msFree(pszMapSRS);
+
+    /*make sure that the layer projection is loaded.
+        It could come from a ows/wfs_srs metadata*/
+    if (lp->projection.numargs == 0) {
+      char *pszLayerSRS;
+      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE,
+                       &pszLayerSRS);
+      if (pszLayerSRS) {
+        if (strncmp(pszLayerSRS, "EPSG:", 5) == 0) {
+          if (nWFSVersion >= OWS_1_1_0)
+            msLoadProjectionStringEPSG(&(lp->projection), pszLayerSRS);
+          else
+            msLoadProjectionString(&(lp->projection), pszLayerSRS);
+        }
+      }
+      msFree(pszLayerSRS);
+    }
+
+    if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
+      msProjectRect(&lp->projection, &map->projection, &(ext));
+    }
+    map->query.rect = ext;
+  }
+
+  if (msQueryByRect(map) != MS_SUCCESS) {
+    errorObj *ms_error;
+    ms_error = msGetErrorObj();
+
+    if (ms_error->code != MS_NOTFOUND) {
+      msSetError(MS_WFSERR, "ms_error->code not found", "msWFSGetFeature()");
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSRetrieveFeatures()
+*/
+static int msWFSRetrieveFeatures(
+    mapObj *map, owsRequestObj *ows_request, const wfsParamsObj *paramsObj,
+    const WFSGMLInfo *gmlinfo, const char *pszFilter, int bBBOXSet,
+    const char *pszBBOXSRS, rectObj bbox, const char *pszFeatureId,
+    char **layers, int numlayers, int maxfeatures, int nWFSVersion,
+    int *pnOutTotalFeatures, int *pnHasNext) {
+  int i, j;
+  int iNumberOfFeatures = 0;
+
+  if (pszFilter && strlen(pszFilter) > 0) {
+    int nFilters;
+    char **paszFilter = NULL;
+
+    /* -------------------------------------------------------------------- */
+    /*      Validate the parameters. When a FILTER parameter is given,      */
+    /*      It needs the TYPENAME parameter for the layers. Also Filter     */
+    /*      is Mutually exclusive with FEATUREID and BBOX (see wfs specs    */
+    /*      1.0 section 13.7.3 on GetFeature)                               */
+    /*                                                                      */
+    /* -------------------------------------------------------------------- */
+
+    /* WFS 2.0 */
+    if (nWFSVersion >= OWS_2_0_0 && paramsObj->pszFilterLanguage != NULL &&
+        strcasecmp(paramsObj->pszFilterLanguage,
+                   "urn:ogc:def:query Language:OGC-FES:Filter") != 0) {
+      msSetError(MS_WFSERR,
+                 "Unhandled value for FILTER_LANGUAGE parameter. Only "
+                 "\"urn:ogc:def:query Language:OGC-FES:Filter\" accepted.",
+                 "msWFSGetFeature()");
+      return msWFSException(map, "filter_language",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+
+    if (gmlinfo->_typename == NULL || strlen(gmlinfo->_typename) <= 0 ||
+        layers == NULL || numlayers <= 0) {
+      msSetError(MS_WFSERR,
+                 "Required %s parameter missing for GetFeature with a FILTER "
+                 "parameter.",
+                 "msWFSGetFeature()",
+                 (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
+      return msWFSException(
+          map, (nWFSVersion >= OWS_2_0_0) ? "typenames" : "typename",
+          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+    }
+
+    if (bBBOXSet) {
+      msSetError(MS_WFSERR,
+                 "BBOX parameter and FILTER parameter are mutually exclusive "
+                 "in GetFeature.",
+                 "msWFSGetFeature()");
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
+    }
+
+    if (pszFeatureId != NULL) {
+      msSetError(MS_WFSERR,
+                 "%s parameter and FILTER parameter are mutually exclusive in "
+                 "GetFeature.",
+                 "msWFSGetFeature()",
+                 (nWFSVersion < OWS_2_0_0) ? "FEATUREID" : "RESOURCEID");
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
+    }
+
+    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) ==
+        MS_FAILURE)
+      return msWFSException(map, "srsname",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+
+    /* -------------------------------------------------------------------- */
+    /*      Parse the Filter parameter. If there are several Filter         */
+    /*      parameters, each Filter is inside a parantheses. Eg :           */
+    /*      FILTER=(<Filter><Within><PropertyName>                          */
+    /*      INWATERA_1M/WKB_GEOM|INWATERA_1M/WKB_GEOM                       */
+    /*      <PropertyName><gml:Box><gml:coordinates>10,10
+     * 20,20</gml:coordinates>*/
+    /*      </gml:Box></Within></Filter>)(<Filter><Within><PropertyName>    */
+    /*      INWATERA_1M/WKB_GEOM<PropertyName><gml:Box><gml:coordinates>10,10*/
+    /*      20,20</gml:coordinates></gml:Box></Within></Filter>)            */
+    /* -------------------------------------------------------------------- */
+    nFilters = 0;
+    if (strlen(pszFilter) > 0 && pszFilter[0] == '(') {
+      paszFilter = FLTSplitFilters(pszFilter, &nFilters);
+    } else if (numlayers == 1) {
+      nFilters = 1;
+      paszFilter = (char **)msSmallMalloc(sizeof(char *) * nFilters);
+      paszFilter[0] = msStrdup(pszFilter);
+    }
+
+    if (numlayers != nFilters) {
+      msSetError(MS_WFSERR,
+                 "Wrong number of filter elements, one filter must be "
+                 "specified for each feature type listed in the %s parameter.",
+                 "msWFSGetFeature()",
+                 (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
+      msFreeCharArray(paszFilter, nFilters);
+      return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      run through the filters and build the class expressions.        */
+    /* -------------------------------------------------------------------- */
+    for (i = 0; i < nFilters; i++) {
+      int status;
+      layerObj *lp;
+
+      lp = msWFSGetLayerByName(map, ows_request, layers[i]);
+
+      /* Special value set when parsing XML Post when there is a mix of */
+      /* Query with and without Filter */
+      if (strcmp(paszFilter[i], "!") == 0)
+        status = msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
+      else
+        status = msWFSRunFilter(map, lp, paramsObj, paszFilter[i], nWFSVersion);
+
+      if (status != MS_SUCCESS) {
+        msFreeCharArray(paszFilter, nFilters);
+        return status;
+      }
+
+      /* Decrement the total maxfeatures */
+      if (map->query.maxfeatures >= 0) {
+        if (lp->resultcache && lp->resultcache->numresults > 0) {
+          map->query.maxfeatures -= lp->resultcache->numresults;
+          if (map->query.maxfeatures <= 0)
+            break;
+        }
+      }
+    }
+
+    msFreeCharArray(paszFilter, nFilters);
+  } /* end if filter set */
+
+  if (pszFeatureId != NULL) {
+    char **tokens = NULL;
+    int nTokens = 0, j = 0, k = 0;
+    char **aFIDLayers = NULL;
+    char **aFIDValues = NULL;
+    int iFIDLayers = 0;
+
+    /* Keep only selected layers, set to OFF by default. */
+    msWFSTurnOffAllLayer(map);
+
+    /*featureid can be a list INWATERA_1M.1234, INWATERA_1M.1235
+    We will keep all the feature id from the same layer together
+    so that an OR would be applied if several of them are present
+    */
+    tokens = msStringSplit(pszFeatureId, ',', &nTokens);
+    iFIDLayers = 0;
+    if (tokens && nTokens >= 1) {
+      aFIDLayers = (char **)msSmallMalloc(sizeof(char *) * nTokens);
+      aFIDValues = (char **)msSmallMalloc(sizeof(char *) * nTokens);
+      for (j = 0; j < nTokens; j++) {
+        aFIDLayers[j] = NULL;
+        aFIDValues[j] = NULL;
+      }
+      for (j = 0; j < nTokens; j++) {
+        const char *pszLastDot = strrchr(tokens[j], '.');
+        if (pszLastDot != NULL) {
+          char *pszLayerInFID = msStrdup(tokens[j]);
+          pszLayerInFID[pszLastDot - tokens[j]] = '\0';
+          /* Find if the layer is already requested */
+          for (k = 0; k < iFIDLayers; k++) {
+            if (strcasecmp(aFIDLayers[k], pszLayerInFID) == 0)
+              break;
+          }
+          /* If not, add it to the list of requested layers */
+          if (k == iFIDLayers) {
+            aFIDLayers[iFIDLayers] = msStrdup(pszLayerInFID);
+            iFIDLayers++;
+          }
+          /* Add the id to the list of search identifiers of the layer */
+          if (aFIDValues[k] != NULL)
+            aFIDValues[k] = msStringConcatenate(aFIDValues[k], ",");
+          aFIDValues[k] = msStringConcatenate(aFIDValues[k], pszLastDot + 1);
+          msFree(pszLayerInFID);
+        } else {
+          /* In WFS 20, an unknown/invalid feature id shouldn't trigger an */
+          /* exception. Tested by CITE */
+          if (nWFSVersion < OWS_2_0_0) {
+            msSetError(MS_WFSERR,
+                       "Invalid FeatureId in GetFeature. Expecting "
+                       "layername.value : %s",
+                       "msWFSGetFeature()", tokens[j]);
+            if (tokens)
+              msFreeCharArray(tokens, nTokens);
+            msFreeCharArray(aFIDLayers, iFIDLayers);
+            msFreeCharArray(aFIDValues, iFIDLayers);
+            return msWFSException(map, "featureid",
+                                  MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                                  paramsObj->pszVersion);
+          }
+        }
+      }
+    }
+    if (tokens)
+      msFreeCharArray(tokens, nTokens);
+
+    /*turn on the layers and make sure projections are set properly*/
+    for (j = 0; j < iFIDLayers; j++) {
+      layerObj *lp;
+      lp = msWFSGetLayerByName(map, ows_request, aFIDLayers[j]);
+      if (lp == NULL) {
+        msSetError(
+            MS_WFSERR,
+            "Invalid typename given with FeatureId in GetFeature : %s. A layer might be disabled for \
+this request. Check wfs/ows_enable_request settings.",
+            "msWFSGetFeature()", aFIDLayers[j]);
+
+        msFreeCharArray(aFIDLayers, iFIDLayers);
+        msFreeCharArray(aFIDValues, iFIDLayers);
+        return msWFSException(map, "featureid",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
+      }
+
+      lp->status = MS_ON;
+    }
+
+    if (map->query.only_cache_result_count == MS_FALSE)
+      msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, FALSE, NULL, NULL);
+
+    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) ==
+        MS_FAILURE)
+      return msWFSException(map, "srsname",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+
+    for (j = 0; j < iFIDLayers; j++) {
+      layerObj *lp;
+      lp = msWFSGetLayerByName(map, ows_request, aFIDLayers[j]);
+      if (lp->_template == NULL) {
+        /* Force setting a template to enable query. */
+        lp->_template = msStrdup("ttt.html");
+      }
+      FilterEncodingNode *psNode =
+          FLTCreateFeatureIdFilterEncoding(aFIDValues[j]);
+
+      if (FLTApplyFilterToLayer(psNode, map, lp->index) != MS_SUCCESS) {
+        msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed",
+                   "msWFSGetFeature");
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(aFIDLayers, iFIDLayers);
+        msFreeCharArray(aFIDValues, iFIDLayers);
+        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                              paramsObj->pszVersion);
+      }
+
+      FLTFreeFilterEncodingNode(psNode);
+
+      /* Decrement the total maxfeatures */
+      if (map->query.maxfeatures >= 0) {
+        if (lp->resultcache && lp->resultcache->numresults > 0) {
+          map->query.maxfeatures -= lp->resultcache->numresults;
+          if (map->query.maxfeatures <= 0)
+            break;
+        }
+      }
+    }
+
+    msFreeCharArray(aFIDLayers, iFIDLayers);
+    msFreeCharArray(aFIDValues, iFIDLayers);
+  }
+
+  /*
+  ** Perform Query (only BBOX for now)
+  */
+  /* __TODO__ Using a rectangle query may not be the most efficient way */
+  /* to do things here. */
+  if (pszFilter == NULL && pszFeatureId == NULL) {
+
+    /* Apply the requested SRS */
+    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) ==
+        MS_FAILURE)
+      return msWFSException(map, "srsname",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+
+    if (!bBBOXSet) {
+      for (j = 0; j < map->numlayers; j++) {
+        layerObj *lp;
+        lp = GET_LAYER(map, j);
+        if (lp->status == MS_ON) {
+          // classes don't affect retrieval of features, so set the count to 0
+          // when the query is executed this avoids selecting any fields
+          // referenced in a CLASS from the data source
+          int numclasses = lp->numclasses;
+          lp->numclasses = 0;
+          int status = msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
+          // set the class count back to its original value once the query is
+          // run
+          lp->numclasses = numclasses;
+          if (status != MS_SUCCESS)
+            return status;
+        }
+      }
+    } else {
+
+      char *sBBoxSrs = NULL;
+
+      if (pszBBOXSRS != NULL)
+        sBBoxSrs = msStrdup(pszBBOXSRS);
+
+      /* On WFS 2.0.0, if the BBOX has no explicit SRS, use the map SRS */
+      /* Should likely be used for WFS 1.1.0 too, but don't want to cause */
+      /* issue at that point, since it can influence axis ordering */
+      if (nWFSVersion >= OWS_2_0_0 && sBBoxSrs == NULL) {
+        projectionObj sProjTmp;
+
+        msInitProjection(&sProjTmp);
+        msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
+        msOWSGetEPSGProj(&sProjTmp, &(map->web.metadata), "FO", MS_TRUE,
+                         &sBBoxSrs);
+        msFreeProjection(&sProjTmp);
+      }
+
+      if (sBBoxSrs) {
+        int status;
+        projectionObj sProjTmp;
+
+        msInitProjection(&sProjTmp);
+        msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
+        /*do the axis order for now. It is unclear if the bbox are expected
+          ro respect the axis oder defined in the projectsion #3296*/
+
+        if (nWFSVersion >= OWS_1_1_0) {
+          if ((status = msLoadProjectionStringEPSG(&sProjTmp, sBBoxSrs)) == 0) {
+            msAxisNormalizePoints(&sProjTmp, 1, &bbox.minx, &bbox.miny);
+            msAxisNormalizePoints(&sProjTmp, 1, &bbox.maxx, &bbox.maxy);
+          }
+        } else
+          status = msLoadProjectionString(&sProjTmp, sBBoxSrs);
+
+        if (status == 0 && map->projection.numargs > 0)
+          msProjectRect(&sProjTmp, &map->projection, &bbox);
+        msFreeProjection(&sProjTmp);
+
+        msFree(sBBoxSrs);
+        sBBoxSrs = NULL;
+      }
+      map->query.type = MS_QUERY_BY_RECT; /* setup the query */
+      map->query.mode = MS_QUERY_MULTIPLE;
+      map->query.rect = bbox;
+
+      /*
+        Retaining this block of code in case we want to setup a rendering path
+        through the query code at some point.
+      */
+      /* if(map->outputformat && MS_DRIVER_MVT(map->outputformat)) {
+        const char *mvt_buffer = msGetOutputFormatOption(map->outputformat,
+      "EDGE_BUFFER", "10"); int buffer = MS_ABS(atoi(mvt_buffer)); double res =
+      (bbox.maxx - bbox.minx)/(double)map->width; bbox.minx -= buffer * res;
+        bbox.maxx += buffer * res;
+        res = (bbox.maxy - bbox.miny)/(double)map->height;
+        bbox.miny -= buffer * res;
+        bbox.maxy += buffer * res;
+        map->width += buffer*2;
+        map->height += buffer*2;
+        msCalculateScale(bbox,map->units,map->width,map->height,
+      map->resolution, &map->scaledenom); map->query.rect = bbox;
+      } */
+
+      if (msQueryByRect(map) != MS_SUCCESS) {
+        errorObj *ms_error;
+        ms_error = msGetErrorObj();
+
+        if (ms_error->code != MS_NOTFOUND) {
+          msSetError(MS_WFSERR, "ms_error->code not found",
+                     "msWFSGetFeature()");
+          return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                                paramsObj->pszVersion);
+        }
+      }
+    }
+  }
+
+  /* Count total number of features retrieved */
+  for (j = 0; j < map->numlayers; j++) {
+    if (GET_LAYER(map, j)->resultcache &&
+        GET_LAYER(map, j)->resultcache->numresults > 0) {
+      iNumberOfFeatures += GET_LAYER(map, j)->resultcache->numresults;
+    }
+  }
+
+  /* If maxfeatures is set, we have actually asked for 1 more feature than asked
+   */
+  /* to be able to know if there are next features. So it is now time to */
+  /* remove this extra unasked feature from the result cache */
+  if (maxfeatures >= 0 && iNumberOfFeatures == maxfeatures + 1) {
+    int lastJ = -1;
+    for (j = 0; j < map->numlayers; j++) {
+      if (GET_LAYER(map, j)->resultcache &&
+          GET_LAYER(map, j)->resultcache->numresults > 0) {
+        lastJ = j;
+      }
+    }
+    GET_LAYER(map, lastJ)->resultcache->numresults--;
+    GET_LAYER(map, lastJ)->resultcache->bounds =
+        GET_LAYER(map, lastJ)->resultcache->previousBounds;
+    iNumberOfFeatures--;
+    if (pnHasNext)
+      *pnHasNext = MS_TRUE;
+  } else if (pnHasNext)
+    *pnHasNext = MS_FALSE;
+
+  *pnOutTotalFeatures = iNumberOfFeatures;
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSParsePropertyNameOrSortBy()
+*/
+static char **msWFSParsePropertyNameOrSortBy(const char *pszPropertyName,
+                                             int numlayers) {
+  char **tokens = NULL;
+  int nPropertyNames = 0;
+  char **papszPropertyName = NULL;
+  int i;
+
+  if (pszPropertyName == NULL) {
+    papszPropertyName = (char **)msSmallMalloc(sizeof(char *) * numlayers);
+    for (i = 0; i < numlayers; i++) {
+      papszPropertyName[i] = msStrdup("!");
+    }
+    return papszPropertyName;
+  }
+
+  if (!(pszPropertyName[0] == '(' || numlayers == 1)) {
+    return NULL;
+  }
+
+  if (numlayers == 1 && pszPropertyName[0] != '(') {
+    /* Accept PROPERTYNAME without () when there is a single TYPENAME */
+    std::string osTmpPropertyName;
+    osTmpPropertyName = '(';
+    osTmpPropertyName += pszPropertyName;
+    osTmpPropertyName += ')';
+    tokens = msStringSplit(osTmpPropertyName.c_str() + 1, '(', &nPropertyNames);
+  } else
+    tokens = msStringSplit(pszPropertyName + 1, '(', &nPropertyNames);
+
+  /*expecting to always have a list of property names equal to
+      the number of layers(typename)*/
+  if (nPropertyNames != numlayers) {
+    msFreeCharArray(tokens, nPropertyNames);
+    return NULL;
+  }
+
+  papszPropertyName = (char **)msSmallMalloc(sizeof(char *) * nPropertyNames);
+  for (i = 0; i < nPropertyNames; i++) {
+    if (strlen(tokens[i]) > 0) {
+      papszPropertyName[i] = msStrdup(tokens[i]);
+      /* remove trailing ) */
+      papszPropertyName[i][strlen(papszPropertyName[i]) - 1] = '\0';
+    } else {
+      for (i--; i >= 0; i--)
+        msFree(papszPropertyName[i]);
+      msFree(papszPropertyName);
+      msFreeCharArray(tokens, nPropertyNames);
+      return NULL;
+    }
+  }
+
+  msFreeCharArray(tokens, nPropertyNames);
+
+  return papszPropertyName;
+}
+
+static void msWFSInitGMLInfo(WFSGMLInfo *pgmlinfo) {
+  memset(pgmlinfo, 0, sizeof(WFSGMLInfo));
+  pgmlinfo->user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+  pgmlinfo->user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+  pgmlinfo->collection_name = OWS_WFS_FEATURE_COLLECTION_NAME;
+  pgmlinfo->_typename = "";
+  pgmlinfo->output_mime_type = "text/xml";
+  pgmlinfo->output_schema_format = "XMLSCHEMA";
+}
+
+static void msWFSCleanupGMLInfo(WFSGMLInfo *pgmlinfo) {
+  free(pgmlinfo->script_url);
+  free(pgmlinfo->script_url_encoded);
+  msFree(pgmlinfo->user_namespace_uri_encoded);
+}
+
+static int msWFSGetGMLOutputFormat(wfsParamsObj *paramsObj,
+                                   WFSGMLInfo *pgmlinfo, int nWFSVersion) {
+  OWSGMLVersion outputformat = OWS_GML2;
+
+  /* Validate outputformat */
+  if (paramsObj->pszOutputFormat) {
+    /* We support GML2, GML3, GML3.2 for now. */
+    if (strcasecmp(paramsObj->pszOutputFormat, "GML2") == 0 ||
+        strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/2.1.2") ==
+            0) {
+      outputformat = OWS_GML2;
+      pgmlinfo->output_schema_format = "XMLSCHEMA";
+      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE
+       * WFS 2.0 */
+      pgmlinfo->output_mime_type = "text/xml; subtype=gml/2.1.2";
+    } else if (strcasecmp(paramsObj->pszOutputFormat, "GML3") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "text/xml; subtype=gml/3.1.1") == 0) {
+      outputformat = OWS_GML3;
+      pgmlinfo->output_schema_format = "SFE_XMLSCHEMA";
+      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE
+       * WFS 2.0 */
+      pgmlinfo->output_mime_type = "text/xml; subtype=gml/3.1.1";
+    } else if (strcasecmp(paramsObj->pszOutputFormat, "GML32") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "text/xml; subtype=gml/3.2.1") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "text/xml; subtype=\"gml/3.2.1\"") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "application/gml+xml; version=3.2") == 0) {
+      outputformat = OWS_GML32;
+      pgmlinfo->output_schema_format =
+          "application%2Fgml%2Bxml%3B%20version%3D3.2";
+      pgmlinfo->output_mime_type = "text/xml; subtype=\"gml/3.2.1\"";
+    } else {
+      return -1;
+    }
+
+    /* If OUTPUTFORMAT not set, default to gml */
+  } else {
+    /*set the output format using the version if available*/
+    if (nWFSVersion == OWS_1_1_0) {
+      outputformat = OWS_GML3;
+      pgmlinfo->output_schema_format = "text/xml;%20subtype=gml/3.1.1";
+      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE
+       * WFS 2.0 */
+      pgmlinfo->output_mime_type = "text/xml; subtype=gml/3.1.1";
+    } else if (nWFSVersion >= OWS_2_0_0) {
+      outputformat = OWS_GML32;
+      pgmlinfo->output_schema_format =
+          "application%2Fgml%2Bxml%3B%20version%3D3.2";
+      pgmlinfo->output_mime_type = "text/xml; subtype=\"gml/3.2.1\"";
+    }
+  }
+
+  if (nWFSVersion == OWS_1_0_0) {
+    pgmlinfo->output_mime_type = "text/xml";
+  }
+
+  return outputformat;
+}
+
+static outputFormatObj *msWFSGetOtherOutputFormat(mapObj *map,
+                                                  wfsParamsObj *paramsObj) {
+  const char *format_list;
+  hashTableObj *md;
+  outputFormatObj *psFormat = NULL;
+  int j;
+
+  /* validate selected format against all selected layers. */
+  for (j = 0; j < map->numlayers; j++) {
+    layerObj *lp;
+
+    lp = GET_LAYER(map, j);
+
+    if (lp->status != MS_ON)
+      continue;
+
+    md = &(lp->metadata);
+    format_list = msOWSLookupMetadata(md, "F", "getfeature_formatlist");
+    if (format_list == NULL) {
+      md = &(map->web.metadata);
+      format_list = msOWSLookupMetadata(md, "F", "getfeature_formatlist");
+    }
+    if (format_list) {
+      psFormat = msOwsIsOutputFormatValid(map, paramsObj->pszOutputFormat, md,
+                                          "F", "getfeature_formatlist");
+    }
+    if (psFormat == NULL) {
+      msSetError(MS_WFSERR,
+                 "'%s' is not a permitted output format for layer '%s', review "
+                 "wfs_getfeature_formatlist setting.",
+                 "msWFSGetFeature()", paramsObj->pszOutputFormat, lp->name);
+      return NULL;
+    }
+
+    if (psFormat->imagemode != MS_IMAGEMODE_FEATURE) {
+      msSetError(MS_WFSERR,
+                 "OUTPUTFORMAT '%s' does not have IMAGEMODE FEATURE, and is "
+                 "not permitted for WFS output.",
+                 "msWFSGetFeature()", paramsObj->pszOutputFormat);
+      return NULL;
+    }
+  }
+
+  return psFormat;
+}
+
+static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map,
+                                                  const wfsParamsObj *paramsObj,
+                                                  int bIsHits,
+                                                  int *pmaxfeatures,
+                                                  int *pstartindex) {
+  const char *tmpmaxfeatures = NULL;
+  int maxfeatures = -1, startindex = -1;
+  int j;
+
+  int nQueriedLayers = 0;
+  layerObj *lpQueried = NULL;
+
+  tmpmaxfeatures =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
+  if (tmpmaxfeatures)
+    maxfeatures = atoi(tmpmaxfeatures);
+
+  if (bIsHits) {
+    const char *ignoreMaxFeaturesForHits = msOWSLookupMetadata(
+        &(map->web.metadata), "FO", "maxfeatures_ignore_for_resulttype_hits");
+
+    /* For PostGIS where we have an efficient implementation of hits, default to
+     * true */
+    if (ignoreMaxFeaturesForHits == NULL) {
+      int bHasEfficientHits = MS_TRUE;
+      for (j = 0; j < map->numlayers; j++) {
+        layerObj *lp;
+        lp = GET_LAYER(map, j);
+        if (lp->status == MS_ON) {
+          if (lp->connectiontype != MS_POSTGIS) {
+            bHasEfficientHits = MS_FALSE;
+            break;
+          }
+        }
+      }
+
+      if (bHasEfficientHits)
+        ignoreMaxFeaturesForHits = "true";
+    }
+
+    if (ignoreMaxFeaturesForHits != NULL &&
+        strcasecmp(ignoreMaxFeaturesForHits, "true") == 0)
+      maxfeatures = -1;
+  }
+
+  if (paramsObj->nMaxFeatures >= 0) {
+    if (maxfeatures < 0 ||
+        (maxfeatures > 0 && paramsObj->nMaxFeatures < maxfeatures))
+      maxfeatures = paramsObj->nMaxFeatures;
+  }
+
+  nQueriedLayers = 0;
+  for (j = 0; j < map->numlayers; j++) {
+    layerObj *lp;
+    lp = GET_LAYER(map, j);
+    if (lp->status == MS_ON) {
+      /* No reason to handle tolerances for WFS GetFeature */
+      lp->tolerance = 0;
+      lpQueried = GET_LAYER(map, j);
+      nQueriedLayers++;
+    }
+  }
+
+  /* WFS convention is that STARTINDEX=0 means the first feature, whereas */
+  /* in MapServer internals we used another interpretation with STARTINDEX=1 */
+  /* being the first index. This was before that the SWG WFS clarified things */
+  /* hence the mess. Ultimately we should likely fix our internals to avoid */
+  /* possible confusion */
+  if (paramsObj->nStartIndex >= 0) {
+    startindex = 1 + paramsObj->nStartIndex;
+    map->query.startindex = startindex;
+  }
+
+  /* maxfeatures set */
+  if (maxfeatures >= 0) {
+    int extrafeature = 1;
+    for (j = 0; j < map->numlayers; j++) {
+      layerObj *lp;
+      lp = GET_LAYER(map, j);
+      if (lp->status == MS_ON) {
+        /*over-ride the value only if it is unset or wfs maxfeatures is
+          lower that what is currently set*/
+        if (lp->maxfeatures <= 0 ||
+            (lp->maxfeatures > 0 && maxfeatures < lp->maxfeatures)) {
+          /* TODO: We don't handle DESC sorting, as it would mean to be */
+          /* able to evict the first property, which mapquery cannot handle */
+          /* This would have impact on the resultcache.bounds */
+          if (lp->sortBy.nProperties > 0) {
+            int k;
+            int countDesc = 1;
+            for (k = 0; k < lp->sortBy.nProperties; k++) {
+              if (lp->sortBy.properties[k].sortOrder == SORT_DESC)
+                countDesc++;
+            }
+            if (countDesc > 0)
+              extrafeature = 0;
+          }
+
+          /* + 1 to be able to detect if there are more features for a next
+           * request */
+          lp->maxfeatures = maxfeatures + extrafeature;
+        }
+      }
+    }
+    /* + 1 to be able to detect if there are more features for a next request */
+    map->query.maxfeatures = maxfeatures + extrafeature;
+  }
+
+  /* startindex set */
+  if (startindex > 0 && nQueriedLayers > 1) {
+    for (j = 0; j < map->numlayers; j++) {
+      layerObj *lp;
+      lp = GET_LAYER(map, j);
+      if (lp->status == MS_ON) {
+        msLayerEnablePaging(lp, MS_FALSE);
+      }
+    }
+  } else if (startindex > 0 && lpQueried) {
+    lpQueried->startindex = startindex;
+  }
+
+  if (pmaxfeatures)
+    *pmaxfeatures = maxfeatures;
+  if (pstartindex)
+    *pstartindex = startindex;
+}
+
+static int msWFSAnalyzeBBOX(mapObj *map, wfsParamsObj *paramsObj,
+                            rectObj *pbbox, char **pszBBoxSRS) {
+  /* Default filter is map extents */
+  *pbbox = map->extent;
+
+  if (paramsObj->pszBbox) {
+    char **tokens;
+    int n;
+
+    tokens = msStringSplit(paramsObj->pszBbox, ',', &n);
+    if (tokens == NULL || (n != 4 && n != 5)) {
+      msSetError(MS_WFSERR, "Wrong number of arguments for BBOX.",
+                 "msWFSGetFeature()");
+      msFreeCharArray(tokens, n);
+      return msWFSException(map, "bbox", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+    pbbox->minx = atof(tokens[0]);
+    pbbox->miny = atof(tokens[1]);
+    pbbox->maxx = atof(tokens[2]);
+    pbbox->maxy = atof(tokens[3]);
+    /*5th aregument is assumed to be projection*/
+    if (n == 5)
+      *pszBBoxSRS = msStrdup(tokens[4]);
+
+    msFreeCharArray(tokens, n);
+  }
+  return 0;
+}
+
+static int msWFSComputeMatchingFeatures(mapObj *map, owsRequestObj *ows_request,
+                                        wfsParamsObj *paramsObj,
+                                        int iNumberOfFeatures, int maxfeatures,
+                                        WFSGMLInfo *pgmlinfo, rectObj bbox,
+                                        const char *sBBoxSrs, char **layers,
+                                        int numlayers, int nWFSVersion) {
+  int nMatchingFeatures = -1;
+
+  if (nWFSVersion >= OWS_2_0_0) {
+    /* If no features have been retrived and there was no feature count limit,
+     * then */
+    /* it is obvious. We must test maxfeatures because if startindex is defined,
+     */
+    /* and above the number of matched features, iNumberOfFeatures can be 0. */
+    if (iNumberOfFeatures == 0 && maxfeatures < 0) {
+      nMatchingFeatures = 0;
+    }
+
+    /* In the case we had limited the query by a maximum number of features, and
+     */
+    /* that the query has returned less features than the limit, or if there was
+     */
+    /* no limit in fature count, we are able to determine the number of matching
+     */
+    /* features */
+    else if (iNumberOfFeatures > 0 &&
+             (maxfeatures < 0 || iNumberOfFeatures < maxfeatures)) {
+      if (paramsObj->nStartIndex >= 0)
+        nMatchingFeatures = iNumberOfFeatures + paramsObj->nStartIndex;
+      else
+        nMatchingFeatures = iNumberOfFeatures;
+    }
+
+    /* Otherwise big hammer ! */
+    else {
+      /* The WFS 2.0 spec is not really clear on numberMatched behaviour */
+      /* and there are interesting logic in server implementations. */
+      /* */
+      /* Deegree
+       * (http://deegree3-demo.deegree.org:80/inspire-workspace/services/wfs?)
+       */
+      /* will return numberMatched="19005" on the cp:CadastralParcel layer for a
+       */
+      /* resultType=hits request, whereas the server limitation is set to 15000
+       */
+      /* But on a regular GetFeature (without count specified), it will return
+       */
+      /* numberMatched="15000" (and numberReturned="15000")) */
+      /* */
+      /* GeoServer 2.4.1 will also ignore its server limitation for a
+       * resultType=hits */
+      /* but when using a regular GetFeature (without count specified), il will
+       * return */
+      /* numberMatched=numberReturned=total_number_of_features_without_taking_into_account_server_limit
+       */
+      /* but the number of actually returned features will be truncated to the
+       * server */
+      /* limit, likely a bug */
+      /* */
+      /* If wfs_compute_number_matched is set to TRUE, we will issue a full */
+      /* count of potentially matching features, ignoring any client or server
+       */
+      /* side limits. */
+
+      const char *pszComputeNumberMatched = msOWSLookupMetadata(
+          &(map->web.metadata), "F", "compute_number_matched");
+      if (pszComputeNumberMatched != NULL &&
+          strcasecmp(pszComputeNumberMatched, "true") == 0) {
+        int j;
+        mapObj *mapTmp = (mapObj *)msSmallCalloc(1, sizeof(mapObj));
+        if (initMap(mapTmp) == -1) {
+          free(mapTmp);
+          return 0;
+        }
+        msCopyMap(mapTmp, map);
+
+        /* Re-run the query but with no limit */
+        mapTmp->query.maxfeatures = -1;
+        mapTmp->query.startindex = -1;
+        mapTmp->query.only_cache_result_count = MS_TRUE;
+        for (j = 0; j < mapTmp->numlayers; j++) {
+          layerObj *lp = GET_LAYER(mapTmp, j);
+          /* Reset layer paging */
+          lp->maxfeatures = -1;
+          lp->startindex = -1;
+        }
+
+        nMatchingFeatures = 0;
+        msWFSRetrieveFeatures(
+            mapTmp, ows_request, paramsObj, pgmlinfo, paramsObj->pszFilter,
+            paramsObj->pszBbox != NULL, sBBoxSrs, bbox, paramsObj->pszFeatureId,
+            layers, numlayers, -1, nWFSVersion, &nMatchingFeatures, NULL);
+
+        msFreeMap(mapTmp);
+      }
+    }
+  }
+
+  return nMatchingFeatures;
+}
+
+static int msWFSResolveStoredQuery(mapObj *map, wfsParamsObj *paramsObj,
+                                   cgiRequestObj *req) {
+  if (paramsObj->pszStoredQueryId != NULL) {
+    int i;
+    int status;
+    hashTableObj *hashTable = msCreateHashTable();
+    char *pszResolvedQuery;
+
+    if (req->NumParams > 0 && req->postrequest == NULL) {
+      for (i = 0; i < req->NumParams; i++) {
+        if (req->ParamNames[i] && req->ParamValues[i]) {
+          char *pszXMLValue = CPLEscapeString(
+              req->ParamValues[i], strlen(req->ParamValues[i]), CPLES_XML);
+          msInsertHashTable(hashTable, req->ParamNames[i], pszXMLValue);
+          CPLFree(pszXMLValue);
+        }
+      }
+    }
+
+    pszResolvedQuery = msWFSGetResolvedStoredQuery20(
+        map, paramsObj, paramsObj->pszStoredQueryId, hashTable);
+    msFreeHashTable(hashTable);
+
+    if (pszResolvedQuery == NULL)
+      return MS_FAILURE;
+
+    status = msWFSAnalyzeStoredQuery(
+        map, paramsObj, paramsObj->pszStoredQueryId, pszResolvedQuery);
+    msFree(pszResolvedQuery);
+
+    if (status != MS_SUCCESS)
+      return status;
+
+    msWFSSimplifyPropertyNameAndFilter(paramsObj);
+  }
+  return MS_SUCCESS;
+}
+
+/*
+** msWFSUnaliasItem()
+*/
+static const char *msWFSUnaliasItem(layerObj *lp, const char *name) {
+  const char *pszFullName;
+  char szTmp[256];
+  int z;
+  for (z = 0; z < lp->numitems; z++) {
+    if (!lp->items[z] || strlen(lp->items[z]) <= 0)
+      continue;
+    snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[z]);
+    pszFullName = msOWSLookupMetadata(&(lp->metadata), "G", szTmp);
+    if (pszFullName && strcmp(name, pszFullName) == 0)
+      return lp->items[z];
+  }
+  return name;
+}
+
+/*
+** msWFSIsAllowedItem()
+*/
+static int msWFSIsAllowedItem(gmlItemListObj *itemList, const char *name) {
+  int z;
+  for (z = 0; z < itemList->numitems; z++) {
+    if (itemList->items[z].visible &&
+        strcasecmp(name, itemList->items[z].name) == 0) {
+      return MS_TRUE;
+    }
+  }
+  return MS_FALSE;
+}
+
+/*
+** msWFSUngroupItem()
+*/
+static const char *msWFSUngroupItem(layerObj *lp, gmlGroupListObj *groupList,
+                                    const char *name, int *pnGroupIndex) {
+  int z;
+
+  *pnGroupIndex = -1;
+  for (z = 0; z < groupList->numgroups; z++) {
+    const char *pszGroupName = groupList->groups[z].name;
+    size_t nGroupNameLen = strlen(pszGroupName);
+
+    /* Is it a group name ? */
+    if (strcasecmp(name, pszGroupName) == 0) {
+      *pnGroupIndex = z;
+      return NULL;
+    }
+
+    /* Is it an item of a group ? */
+    if (strncasecmp(name, pszGroupName, nGroupNameLen) == 0 &&
+        name[nGroupNameLen] == '/') {
+
+      int w;
+      const char *pszSubName = msWFSStripNS(name + nGroupNameLen + 1);
+      pszSubName = msWFSUnaliasItem(lp, pszSubName);
+      for (w = 0; w < groupList->groups[z].numitems; w++) {
+        if (strcasecmp(pszSubName, groupList->groups[z].items[w]) == 0) {
+          return pszSubName;
+        }
+      }
+    }
+  }
+
+  return name;
+}
+
+/*
+** msWFSApplySortBy()
+*/
+static int msWFSApplySortBy(mapObj *map, wfsParamsObj *paramsObj, layerObj *lp,
+                            const char *pszSortBy, gmlItemListObj *itemList,
+                            gmlGroupListObj *groupList) {
+  int y, n;
+  char **tokens;
+  int invalidSortBy = MS_FALSE;
+  sortByClause sortBy;
+
+  if (!msLayerSupportsSorting(lp)) {
+    msSetError(MS_WFSERR, "Layer %s does not support sorting",
+               "msWFSGetFeature()", lp->name);
+    return msWFSException(map, "mapserv",
+                          MS_WFS_ERROR_OPERATION_PROCESSING_FAILED,
+                          paramsObj->pszVersion);
+  }
+
+  tokens = msStringSplit(pszSortBy, ',', &n);
+  sortBy.nProperties = n;
+  sortBy.properties =
+      (sortByProperties *)msSmallMalloc(n * sizeof(sortByProperties));
+  for (y = 0; y < n; y++) {
+    char *pszSpace;
+    int nGroupIndex = -1;
+    const char *pszSortProperty;
+    char *pszTmp;
+
+    sortBy.properties[y].item = msStrdup(tokens[y]);
+    sortBy.properties[y].sortOrder = SORT_ASC;
+    pszSpace = strchr(sortBy.properties[y].item, ' ');
+    if (pszSpace) {
+      *pszSpace = '\0';
+      if (strcasecmp(pszSpace + 1, "A") == 0 ||
+          strcasecmp(pszSpace + 1, "ASC") == 0)
+        ;
+      else if (strcasecmp(pszSpace + 1, "D") == 0 ||
+               strcasecmp(pszSpace + 1, "DESC") == 0)
+        sortBy.properties[y].sortOrder = SORT_DESC;
+      else
+        invalidSortBy = MS_TRUE;
+    }
+
+    pszSortProperty = msWFSStripNS(sortBy.properties[y].item);
+    pszSortProperty = msWFSUnaliasItem(lp, pszSortProperty);
+    pszSortProperty =
+        msWFSUngroupItem(lp, groupList, pszSortProperty, &nGroupIndex);
+    if (nGroupIndex >= 0)
+      invalidSortBy = MS_TRUE;
+
+    if (!msWFSIsAllowedItem(itemList, pszSortProperty))
+      invalidSortBy = MS_TRUE;
+
+    pszTmp = msStrdup(pszSortProperty);
+    msFree(sortBy.properties[y].item);
+    sortBy.properties[y].item = pszTmp;
+  }
+  msFreeCharArray(tokens, n);
+
+  if (!invalidSortBy)
+    msLayerSetSort(lp, &sortBy);
+
+  for (y = 0; y < n; y++) {
+    msFree(sortBy.properties[y].item);
+  }
+  msFree(sortBy.properties);
+
+  if (invalidSortBy) {
+    msSetError(MS_WFSERR, "Invalid SORTBY clause", "msWFSGetFeature()");
+    return msWFSException(map, "sortby", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
+
+  return MS_SUCCESS;
+}
+
+static void msWFSSetShapeCache(mapObj *map) {
+  const char *pszFeaturesCacheCount =
+      msOWSLookupMetadata(&(map->web.metadata), "F", "features_cache_count");
+  const char *pszFeaturesCacheSize =
+      msOWSLookupMetadata(&(map->web.metadata), "F", "features_cache_size");
+  if (pszFeaturesCacheCount) {
+    map->query.cache_shapes = MS_TRUE;
+    map->query.max_cached_shape_count = atoi(pszFeaturesCacheCount);
+    if (map->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("Caching up to %d shapes\n", map->query.max_cached_shape_count);
+    }
+  }
+
+  if (pszFeaturesCacheSize) {
+    map->query.cache_shapes = MS_TRUE;
+    map->query.max_cached_shape_ram_amount = atoi(pszFeaturesCacheSize);
+    if (strstr(pszFeaturesCacheSize, "mb") ||
+        strstr(pszFeaturesCacheSize, "MB"))
+      map->query.max_cached_shape_ram_amount *= 1024 * 1024;
+    if (map->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("Caching up to %d bytes of shapes\n",
+              map->query.max_cached_shape_ram_amount);
+    }
+  }
+}
+
+/*
+** msWFSGetFeature()
+*/
+static int msWFSGetFeature(mapObj *map, wfsParamsObj *paramsObj,
+                           cgiRequestObj *req, owsRequestObj *ows_request,
+                           int nWFSVersion) {
+  int status;
+  int maxfeatures = -1, startindex = -1;
+  rectObj bbox;
+
+  char **layers = NULL;
+  int numlayers = 0;
+
+  char *sBBoxSrs = NULL;
+
+  WFSGMLInfo gmlinfo;
+
+  OWSGMLVersion outputformat = OWS_GML2; /* default output is GML 2.1 */
+  outputFormatObj *psFormat = NULL;
+
+  int iNumberOfFeatures = 0;
+  int iResultTypeHits = 0;
+  int nMatchingFeatures = -1;
+  int bHasNextFeatures = MS_FALSE;
+
+  char **papszGMLGroups = NULL;
+  char **papszGMLIncludeItems = NULL;
+  char **papszGMLGeometries = NULL;
+
+  msIOContext *old_context = NULL;
+
+  /* Initialize gml options */
+  msWFSInitGMLInfo(&gmlinfo);
+
+  if (paramsObj->pszResultType != NULL) {
+    if (strcasecmp(paramsObj->pszResultType, "hits") == 0)
+      iResultTypeHits = 1;
+  }
+
+  status = msWFSResolveStoredQuery(map, paramsObj, req);
+  if (status != MS_SUCCESS)
+    return status;
+
+  /* typename is mandatory unless featureid is specfied. We do not
+     support featureid */
+  if (paramsObj->pszTypeName == NULL && paramsObj->pszFeatureId == NULL) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: %s parameter missing",
+               "msWFSGetFeature()",
+               (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
+    return msWFSException(
+        map, (nWFSVersion >= OWS_2_0_0) ? "typenames" : "typename",
+        MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+  }
+
+  /* Is it a WFS 2.0 GetFeatureById stored query with an unknown id ? */
+  /* If so, CITE interprets the spec as requesting to issue a
+   * OperationProcessingFailed */
+  /* exception. But it only checks that the HTTP error code is 403 or 404. So
+   * emit 404. */
+  /* A bit strange when a similar request but with RESOURCEID= should */
+  /* produce an empty FeatureCollection */
+  if (nWFSVersion >= OWS_2_0_0 && paramsObj->pszTypeName != NULL &&
+      strcmp(paramsObj->pszTypeName, "?") == 0 &&
+      paramsObj->pszFilter != NULL && paramsObj->pszFeatureId == NULL) {
+    CPLXMLNode *psDoc;
+
+    psDoc = CPLParseXMLString(paramsObj->pszFilter);
+    if (psDoc != NULL) {
+      const char *rid;
+
+      CPLStripXMLNamespace(psDoc, NULL, 1);
+      rid = CPLGetXMLValue(psDoc, "=Filter.ResourceId.rid", NULL);
+      if (rid != NULL) {
+        msSetError(MS_WFSERR, "Invalid rid '%s'", "msWFSGetFeature()", rid);
+        CPLDestroyXMLNode(psDoc);
+        return msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
+                              paramsObj->pszVersion);
+      }
+      CPLDestroyXMLNode(psDoc);
+    }
+  }
+
+  papszGMLGroups = (char **)calloc(sizeof(char *), map->numlayers);
+  papszGMLIncludeItems = (char **)calloc(sizeof(char *), map->numlayers);
+  papszGMLGeometries = (char **)calloc(sizeof(char *), map->numlayers);
+
+  if (paramsObj->pszTypeName) {
+    int k, y, z;
+
+    char **tokens;
+    int n = 0, i = 0;
+    char **papszPropertyName = NULL;
+    char **papszSortBy = NULL;
+
+    /* keep a ref for layer use. */
+    gmlinfo._typename = paramsObj->pszTypeName;
+
+    /* Parse comma-delimited list of type names (layers) */
+    /*  */
+    /* __TODO__ Need to handle type grouping, e.g. "(l1,l2),l3,l4" */
+    /*  */
+    layers = msStringSplit(gmlinfo._typename, ',', &numlayers);
+
+    /* ==================================================================== */
+    /*      TODO: check if the typename contains namespaces (ex cdf:Other), */
+    /*      If that is the case extract only the layer name.                */
+    /* ==================================================================== */
+
+    if (layers == NULL || numlayers < 1) {
+      msSetError(MS_WFSERR, "At least one type name required in %s parameter.",
+                 "msWFSGetFeature()",
+                 (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
+      return msWFSException(
+          map, (nWFSVersion >= OWS_2_0_0) ? "typenames" : "typename",
+          MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+    }
+
+    /* strip namespace if there is one :ex TYPENAME=cdf:Other */
+    for (i = 0; i < numlayers; i++) {
+      char *pszTmp = msStrdup(msWFSStripNS(layers[i]));
+      free(layers[i]);
+      layers[i] = pszTmp;
+    }
+
+    /* Keep only selected layers, set to OFF by default. */
+    msWFSTurnOffAllLayer(map);
+
+    papszPropertyName =
+        msWFSParsePropertyNameOrSortBy(paramsObj->pszPropertyName, numlayers);
+    if (papszPropertyName == NULL) {
+      msFreeCharArray(layers, numlayers);
+      msFreeCharArray(papszGMLGroups, map->numlayers);
+      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+      msFreeCharArray(papszGMLGeometries, map->numlayers);
+      msSetError(MS_WFSERR,
+                 "Optional PROPERTYNAME parameter. A list of properties may be "
+                 "specified for each type name. Example "
+                 "TYPENAME=name1,name2&PROPERTYNAME=(prop1,prop2)(prop1)",
+                 "msWFSGetFeature()");
+      return msWFSException(map, "PROPERTYNAME",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+
+    papszSortBy =
+        msWFSParsePropertyNameOrSortBy(paramsObj->pszSortBy, numlayers);
+    if (papszSortBy == NULL) {
+      msFreeCharArray(layers, numlayers);
+      msFreeCharArray(papszPropertyName, numlayers);
+      msFreeCharArray(papszGMLGroups, map->numlayers);
+      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+      msFreeCharArray(papszGMLGeometries, map->numlayers);
+      msSetError(
+          MS_WFSERR,
+          "Optional SORTBY parameter. A list may be specified for each type "
+          "name. Example TYPENAME=name1,name2&SORTBY=(prop1,prop2)(prop1)",
+          "msWFSGetFeature()");
+      return msWFSException(map, "SORTBY", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+
+    for (k = 0; k < numlayers; k++) {
+      layerObj *lp;
+      lp = msWFSGetLayerByName(map, ows_request, layers[k]);
+      if (lp != NULL) {
+        gmlItemListObj *itemList = NULL;
+        gmlGeometryListObj *geometryList = NULL;
+        gmlGroupListObj *groupList = NULL;
+
+        lp->status = MS_ON;
+        if (lp->_template == NULL) {
+          /* Force setting a template to enable query. */
+          lp->_template = msStrdup("ttt.html");
+        }
+
+        /*do an alias replace for the current layer*/
+        if (msLayerOpen(lp) == MS_SUCCESS &&
+            msLayerGetItems(lp) == MS_SUCCESS) {
+
+          itemList = msGMLGetItems(lp, "G");
+          groupList = msGMLGetGroups(lp, "G");
+
+          if (strcmp(papszSortBy[k], "!") != 0) {
+            status = msWFSApplySortBy(map, paramsObj, lp, papszSortBy[k],
+                                      itemList, groupList);
+            if (status != MS_SUCCESS) {
+              msFreeCharArray(papszPropertyName, numlayers);
+              msFreeCharArray(papszSortBy, numlayers);
+              msFreeCharArray(layers, numlayers);
+              msFreeCharArray(papszGMLGroups, map->numlayers);
+              msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+              msFreeCharArray(papszGMLGeometries, map->numlayers);
+              msGMLFreeItems(itemList);
+              msGMLFreeGroups(groupList);
+              return status;
+            }
+          }
+
+          geometryList = msGMLGetGeometries(lp, "GFO", MS_TRUE);
+
+          /* unalias, ungroup and validate that the property names passed are
+           * part of the items list*/
+          tokens = msStringSplit(papszPropertyName[k], ',', &n);
+          for (y = 0; y < n; y++) {
+            const char *pszPropertyNameItem = tokens[y];
+            int nGroupIndex = -1;
+
+            if (strcasecmp(pszPropertyNameItem, "*") == 0 ||
+                strcasecmp(pszPropertyNameItem, "!") == 0)
+              continue;
+
+            pszPropertyNameItem = msWFSStripNS(pszPropertyNameItem);
+            pszPropertyNameItem = msWFSUnaliasItem(lp, pszPropertyNameItem);
+            pszPropertyNameItem = msWFSUngroupItem(
+                lp, groupList, pszPropertyNameItem, &nGroupIndex);
+            if (nGroupIndex >= 0)
+              continue;
+
+            /* Check that the property name is allowed (#3563) */
+            /*we need to check of the property name is the geometry name; In
+              that case it is a valid property name*/
+            if (!msWFSIsAllowedItem(itemList, pszPropertyNameItem)) {
+              for (z = 0; z < geometryList->numgeometries; z++) {
+                if (strcasecmp(pszPropertyNameItem,
+                               geometryList->geometries[z].name) == 0)
+                  break;
+              }
+
+              if (z == geometryList->numgeometries) {
+                msSetError(MS_WFSERR, "Invalid PROPERTYNAME %s",
+                           "msWFSGetFeature()", tokens[y]);
+                msFreeCharArray(tokens, n);
+                msGMLFreeItems(itemList);
+                msGMLFreeGroups(groupList);
+                msGMLFreeGeometries(geometryList);
+                msFreeCharArray(papszPropertyName, numlayers);
+                msFreeCharArray(papszSortBy, numlayers);
+                msFreeCharArray(layers, numlayers);
+                msFreeCharArray(papszGMLGroups, map->numlayers);
+                msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+                msFreeCharArray(papszGMLGeometries, map->numlayers);
+                return msWFSException(map, "PROPERTYNAME",
+                                      MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                                      paramsObj->pszVersion);
+              }
+            } else {
+              char *pszTmp = msStrdup(pszPropertyNameItem);
+              msFree(tokens[y]);
+              tokens[y] = pszTmp;
+            }
+          }
+
+          /* Add mandatory items that are not explicitely listed. */
+          /* When the user specifies PROPERTYNAME, we might have to augment */
+          /* the list of returned parameters so as to validate against the
+           * schema. */
+          /* This is made clear in the WFS 1.0.0, 1.1.0 and 2.0.0 specs (#3319)
+           */
+          for (z = 0; z < itemList->numitems; z++) {
+            if (itemList->items[z].visible &&
+                itemList->items[z].minOccurs == 1) {
+              int bFound = MS_FALSE;
+              for (y = 0; y < n; y++) {
+                if (strcasecmp(tokens[y], "*") == 0 ||
+                    strcasecmp(tokens[y], "!") == 0 ||
+                    strcasecmp(tokens[y], itemList->items[z].name) == 0) {
+                  bFound = MS_TRUE;
+                  break;
+                }
+              }
+              if (!bFound) {
+                tokens = (char **)realloc(tokens, sizeof(char *) * (n + 1));
+                tokens[n] = msStrdup(itemList->items[z].name);
+                n++;
+              }
+            }
+          }
+
+          /* Rebuild papszPropertyName[k] */
+          msFree(papszPropertyName[k]);
+          papszPropertyName[k] = NULL;
+          for (y = 0; y < n; y++) {
+            if (y == 0)
+              papszPropertyName[k] = msStrdup(tokens[y]);
+            else {
+              papszPropertyName[k] =
+                  msStringConcatenate(papszPropertyName[k], ",");
+              papszPropertyName[k] =
+                  msStringConcatenate(papszPropertyName[k], tokens[y]);
+            }
+          }
+
+          msFreeCharArray(tokens, n);
+          msLayerClose(lp);
+
+          if (strlen(papszPropertyName[k]) > 0) {
+
+            if (strcasecmp(papszPropertyName[k], "*") == 0) {
+              /* Add all non-excluded items, including optional ones */
+              msFree(papszPropertyName[k]);
+              papszPropertyName[k] = NULL;
+              for (z = 0; z < itemList->numitems; z++) {
+                if (itemList->items[z].visible) {
+                  if (papszPropertyName[k] != NULL)
+                    papszPropertyName[k] =
+                        msStringConcatenate(papszPropertyName[k], ",");
+                  papszPropertyName[k] = msStringConcatenate(
+                      papszPropertyName[k], itemList->items[z].name);
+                }
+              }
+              if (papszPropertyName[k])
+                papszGMLIncludeItems[lp->index] =
+                    msStrdup(papszPropertyName[k]);
+              else
+                papszGMLIncludeItems[lp->index] = msStrdup("");
+
+              /* The user didn't specify explicity PROPERTYNAME for this layer
+               */
+            } else if (strcasecmp(papszPropertyName[k], "!") == 0) {
+              /* Add all non-excluded items, but only default and mandatory ones
+               * (and geometry) */
+              msFree(papszPropertyName[k]);
+              papszPropertyName[k] = NULL;
+              for (z = 0; z < itemList->numitems; z++) {
+                if (itemList->items[z].visible &&
+                    (itemList->items[z].outputByDefault == 1 ||
+                     itemList->items[z].minOccurs == 1)) {
+                  if (papszPropertyName[k] != NULL)
+                    papszPropertyName[k] =
+                        msStringConcatenate(papszPropertyName[k], ",");
+                  papszPropertyName[k] = msStringConcatenate(
+                      papszPropertyName[k], itemList->items[z].name);
+                }
+              }
+              if (papszPropertyName[k])
+                papszGMLIncludeItems[lp->index] =
+                    msStrdup(papszPropertyName[k]);
+              else
+                papszGMLIncludeItems[lp->index] = msStrdup("");
+
+            } else {
+              char *pszGeometryList = NULL;
+
+              for (z = 0; z < groupList->numgroups; z++) {
+                const char *pszNeedle =
+                    strstr(papszPropertyName[k], groupList->groups[z].name);
+                char chAfterNeedle = 0;
+                if (pszNeedle != NULL)
+                  chAfterNeedle =
+                      papszPropertyName[k][strlen(groupList->groups[z].name)];
+                if (pszNeedle != NULL &&
+                    (chAfterNeedle == '\0' || chAfterNeedle == ',')) {
+                  int w;
+                  for (w = 0; w < groupList->groups[z].numitems; w++) {
+                    if (strstr(papszPropertyName[k],
+                               groupList->groups[z].items[w]) == NULL) {
+                      papszPropertyName[k] =
+                          msStringConcatenate(papszPropertyName[k], ",");
+                      papszPropertyName[k] = msStringConcatenate(
+                          papszPropertyName[k], groupList->groups[z].items[w]);
+                    }
+                  }
+                }
+              }
+
+              // Set the "gml_select_items" metadata items that is used by
+              // msQueryByRect() to restrict the number of properties to
+              // select for faster results.
+              if (msOWSLookupMetadata(&(lp->metadata), "OFG", "groups") ==
+                  NULL) {
+                auto properties = msStringSplit(papszPropertyName[k], ',');
+                std::string selectItems;
+                const char *featureid =
+                    msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
+                bool foundFeatureId = false;
+                for (const auto &prop : properties) {
+                  bool isGeom = false;
+                  const char *propNoNS = prop.c_str();
+                  const char *pszColon = strchr(propNoNS, ':');
+                  if (pszColon)
+                    propNoNS = pszColon + 1;
+                  for (z = 0; z < geometryList->numgeometries; z++) {
+                    if (strcasecmp(propNoNS,
+                                   geometryList->geometries[z].name) == 0) {
+                      isGeom = true;
+                      break;
+                    }
+                  }
+                  if (!isGeom) {
+                    if (!selectItems.empty())
+                      selectItems += ',';
+                    selectItems += prop;
+                  }
+                  if (featureid && featureid == prop) {
+                    foundFeatureId = true;
+                  }
+                }
+                if (featureid && !foundFeatureId) {
+                  if (!selectItems.empty())
+                    selectItems += ',';
+                  selectItems += featureid;
+                }
+                if (!selectItems.empty()) {
+                  msInsertHashTable(&(lp->metadata), "gml_select_items",
+                                    selectItems.c_str());
+                }
+              }
+
+              papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
+
+              for (z = 0; z < geometryList->numgeometries; z++) {
+                if (strstr(papszPropertyName[k],
+                           geometryList->geometries[z].name) != NULL) {
+                  if (pszGeometryList != NULL)
+                    pszGeometryList = msStringConcatenate(pszGeometryList, ",");
+                  pszGeometryList = msStringConcatenate(
+                      pszGeometryList, geometryList->geometries[z].name);
+                }
+              }
+
+              if (pszGeometryList != NULL) {
+                papszGMLGeometries[lp->index] = msStrdup(pszGeometryList);
+                msFree(pszGeometryList);
+              } else {
+                papszGMLGeometries[lp->index] = msStrdup("none");
+              }
+            }
+          } else { /*empty string*/
+            papszGMLGeometries[lp->index] = msStrdup("none");
+          }
+        } else {
+          msFreeCharArray(papszPropertyName, numlayers);
+          msFreeCharArray(papszSortBy, numlayers);
+          msFreeCharArray(layers, numlayers);
+          msFreeCharArray(papszGMLGroups, map->numlayers);
+          msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+          msFreeCharArray(papszGMLGeometries, map->numlayers);
+          msGMLFreeItems(itemList);
+          msGMLFreeGroups(groupList);
+          msGMLFreeGeometries(geometryList);
+          return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                                paramsObj->pszVersion);
+        }
+
+        msGMLFreeItems(itemList);
+        msGMLFreeGroups(groupList);
+        msGMLFreeGeometries(geometryList);
+      } else {
+        /* Requested layer name was not in capabilities:
+         * either it just doesn't exist
+         */
+        msSetError(MS_WFSERR,
+                   "TYPENAME '%s' doesn't exist in this server.  Please check "
+                   "the capabilities and reformulate your request.",
+                   "msWFSGetFeature()", layers[k]);
+        msFreeCharArray(papszPropertyName, numlayers);
+        msFreeCharArray(papszSortBy, numlayers);
+        msFreeCharArray(layers, numlayers);
+        msFreeCharArray(papszGMLGroups, map->numlayers);
+        msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+        msFreeCharArray(papszGMLGeometries, map->numlayers);
+        return msWFSException(map, "typename",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
+      }
+    }
+
+    msFreeCharArray(papszPropertyName, numlayers);
+    msFreeCharArray(papszSortBy, numlayers);
+  }
+
+  /* Validate outputformat */
+  status = msWFSGetGMLOutputFormat(paramsObj, &gmlinfo, nWFSVersion);
+  if (status < 0) {
+    psFormat = msWFSGetOtherOutputFormat(map, paramsObj);
+    if (psFormat == NULL) {
+      msFreeCharArray(layers, numlayers);
+      msFreeCharArray(papszGMLGroups, map->numlayers);
+      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+      msFreeCharArray(papszGMLGeometries, map->numlayers);
+      return msWFSException(map, "outputformat",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+    // only GML is supported for resultType=hits, so ignore any other
+    // outputformat
+    if (iResultTypeHits == 1) {
+      psFormat = NULL;
+    }
+  } else {
+    outputformat = (OWSGMLVersion)status;
+  }
+
+  msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, iResultTypeHits,
+                                        &maxfeatures, &startindex);
+
+  status = msWFSAnalyzeBBOX(map, paramsObj, &bbox, &sBBoxSrs);
+  if (status != 0) {
+    msFreeCharArray(layers, numlayers);
+    msFreeCharArray(papszGMLGroups, map->numlayers);
+    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+    msFreeCharArray(papszGMLGeometries, map->numlayers);
+    return status;
+  }
+
+  if (iResultTypeHits == 1) {
+    map->query.only_cache_result_count = MS_TRUE;
+  } else {
+    msWFSSetShapeCache(map);
+  }
+
+  status = msWFSRetrieveFeatures(
+      map, ows_request, paramsObj, &gmlinfo, paramsObj->pszFilter,
+      paramsObj->pszBbox != NULL, sBBoxSrs, bbox, paramsObj->pszFeatureId,
+      layers, numlayers, maxfeatures, nWFSVersion, &iNumberOfFeatures,
+      &bHasNextFeatures);
+  if (status != MS_SUCCESS) {
+    msFreeCharArray(layers, numlayers);
+    msFree(sBBoxSrs);
+    msFreeCharArray(papszGMLGroups, map->numlayers);
+    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+    msFreeCharArray(papszGMLGeometries, map->numlayers);
+    return status;
+  }
+
+  /* ----------------------------------------- */
+  /* Now compute nMatchingFeatures for WFS 2.0 */
+  /* ----------------------------------------- */
+
+  nMatchingFeatures = msWFSComputeMatchingFeatures(
+      map, ows_request, paramsObj, iNumberOfFeatures, maxfeatures, &gmlinfo,
+      bbox, sBBoxSrs, layers, numlayers, nWFSVersion);
+
+  msFreeCharArray(layers, numlayers);
+
+  msFree(sBBoxSrs);
+  sBBoxSrs = NULL;
+
+  /*
+  ** GML Header generation.
+  */
+
+  status = MS_SUCCESS;
+
+  if (psFormat == NULL) {
+    if (paramsObj->countGetFeatureById == 1 && maxfeatures != 0 &&
+        iResultTypeHits == 0) {
+      /* When there's a single  urn:ogc:def:query:OGC-WFS::GetFeatureById
+       * GetFeature request */
+      /* we must not output a FeatureCollection but the object itself */
+      /* We do that as a post-processing step, so let print into a buffer and
+       * modify the */
+      /* XML afterwards */
+      old_context = msIO_pushStdoutToBufferAndGetOldContext();
+    } else {
+      msIO_setHeader("Content-Type", "%s; charset=UTF-8",
+                     gmlinfo.output_mime_type);
+      msIO_sendHeaders();
+    }
+
+    status = msWFSGetFeature_GMLPreamble(
+        map, req, &gmlinfo, paramsObj, outputformat, iResultTypeHits,
+        iNumberOfFeatures, nMatchingFeatures, maxfeatures, bHasNextFeatures,
+        nWFSVersion);
+    if (status != MS_SUCCESS) {
+      if (old_context != NULL)
+        msIO_restoreOldStdoutContext(old_context);
+      msWFSCleanupGMLInfo(&gmlinfo);
+      msFreeCharArray(papszGMLGroups, map->numlayers);
+      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+      msFreeCharArray(papszGMLGeometries, map->numlayers);
+      return MS_FAILURE;
+    }
+  }
+
+  {
+    int i;
+    for (i = 0; i < map->numlayers; i++) {
+      layerObj *lp = GET_LAYER(map, i);
+      if (papszGMLGroups[i])
+        msInsertHashTable(&(lp->metadata), "GML_GROUPS", papszGMLGroups[i]);
+      if (papszGMLIncludeItems[i])
+        msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS",
+                          papszGMLIncludeItems[i]);
+      if (papszGMLGeometries[i])
+        msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES",
+                          papszGMLGeometries[i]);
+    }
+  }
+
+  /* handle case of maxfeatures = 0 */
+  /*internally use a start index that start with 0 as the first index*/
+  if (psFormat == NULL) {
+    if (maxfeatures != 0 && iResultTypeHits == 0) {
+      int bWFS2MultipleFeatureCollection = MS_FALSE;
+
+      /* Would make sense for WFS 1.1.0 too ! See #3576 */
+      int bUseURN = (nWFSVersion == OWS_2_0_0);
+      const char *useurn =
+          msOWSLookupMetadata(&(map->web.metadata), "F", "return_srs_as_urn");
+      if (useurn && strcasecmp(useurn, "true") == 0)
+        bUseURN = 1;
+      else if (useurn && strcasecmp(useurn, "false") == 0)
+        bUseURN = 0;
+
+      /* For WFS 2.0, when we request several types, we must present each type
+       */
+      /* in its own FeatureCollection (§ 11.3.3.5 ) */
+      if (nWFSVersion >= OWS_2_0_0 && iResultTypeHits != 1) {
+        int i;
+        int nLayersWithFeatures = 0;
+        for (i = 0; i < map->numlayers; i++) {
+          layerObj *lp = GET_LAYER(map, i);
+          if (lp->resultcache && lp->resultcache->numresults > 0)
+            nLayersWithFeatures++;
+        }
+        if (nLayersWithFeatures > 1) {
+          char timestring[100];
+          resultCacheObj **saveResultCache = (resultCacheObj **)msSmallMalloc(
+              map->numlayers * sizeof(resultCacheObj *));
+          int iLastNonEmptyLayer = -1;
+
+          msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
+
+          /* Emit global bounds */
+          msGMLWriteWFSBounds(map, stdout, "  ", outputformat, nWFSVersion,
+                              bUseURN);
+
+          /* Save the result cache that contains the features that we want to */
+          /* emit in the response */
+          for (i = 0; i < map->numlayers; i++) {
+            layerObj *lp = GET_LAYER(map, i);
+            saveResultCache[i] = lp->resultcache;
+            if (lp->resultcache && lp->resultcache->numresults > 0) {
+              iLastNonEmptyLayer = i;
+            }
+            lp->resultcache = NULL;
+          }
+
+          /* Just dump one layer at a time */
+          for (i = 0; i < map->numlayers; i++) {
+            layerObj *lp = GET_LAYER(map, i);
+            lp->resultcache = saveResultCache[i];
+            if (lp->resultcache && lp->resultcache->numresults > 0) {
+              msIO_fprintf(stdout, "  <wfs:member>\n");
+              msIO_fprintf(
+                  stdout,
+                  "   <wfs:FeatureCollection timeStamp=\"%s\" numberMatched=\"",
+                  timestring);
+              if (i < iLastNonEmptyLayer || nMatchingFeatures >= 0)
+                msIO_fprintf(stdout, "%d", lp->resultcache->numresults);
+              else
+                msIO_fprintf(stdout, "unknown");
+              msIO_fprintf(stdout, "\" numberReturned=\"%d\">\n",
+                           lp->resultcache->numresults);
+
+              msGMLWriteWFSQuery(map, stdout, gmlinfo.user_namespace_prefix,
+                                 outputformat, nWFSVersion, bUseURN, MS_FALSE);
+              msIO_fprintf(stdout, "   </wfs:FeatureCollection>\n");
+              msIO_fprintf(stdout, "  </wfs:member>\n");
+            }
+            lp->resultcache = NULL;
+          }
+
+          /* Restore for later cleanup */
+          for (i = 0; i < map->numlayers; i++) {
+            layerObj *lp = GET_LAYER(map, i);
+            lp->resultcache = saveResultCache[i];
+          }
+          msFree(saveResultCache);
+
+          bWFS2MultipleFeatureCollection = MS_TRUE;
+        }
+      }
+
+      if (!bWFS2MultipleFeatureCollection) {
+        msGMLWriteWFSQuery(map, stdout, gmlinfo.user_namespace_prefix,
+                           outputformat, nWFSVersion, bUseURN, MS_FALSE);
+      }
+
+      status = MS_SUCCESS;
+    }
+  } else {
+    mapservObj *mapserv = msAllocMapServObj();
+
+    /* Setup dummy mapserv object */
+    mapserv->sendheaders = MS_TRUE;
+    mapserv->map = map;
+    msFreeCgiObj(mapserv->request);
+    mapserv->request = req;
+    map->querymap.status = MS_FALSE;
+
+    if (nMatchingFeatures >= 0) {
+      char szMatchingFeatures[12];
+      sprintf(szMatchingFeatures, "%d", nMatchingFeatures);
+      msSetOutputFormatOption(psFormat, "_matching_features_",
+                              szMatchingFeatures);
+    } else {
+      msSetOutputFormatOption(psFormat, "_matching_features_", "");
+    }
+    status = msReturnTemplateQuery(mapserv, psFormat->name, NULL);
+
+    mapserv->request = NULL;
+    mapserv->map = NULL;
+
+    msFreeMapServObj(mapserv);
+
+    if (status != MS_SUCCESS) {
+      msFreeCharArray(papszGMLGroups, map->numlayers);
+      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+      msFreeCharArray(papszGMLGeometries, map->numlayers);
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
+    }
+  }
+
+  msFreeCharArray(papszGMLGroups, map->numlayers);
+  msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+  msFreeCharArray(papszGMLGeometries, map->numlayers);
+
+  if (psFormat == NULL && status == MS_SUCCESS) {
+    msWFSGetFeature_GMLPostfix(&gmlinfo, outputformat, maxfeatures,
+                               iResultTypeHits, iNumberOfFeatures, nWFSVersion);
+  }
+
+  /*Special case for a single urn:ogc:def:query:OGC-WFS::GetFeatureById
+   * GetFeature request */
+  if (old_context != NULL) {
+    msIOContext *new_context;
+    msIOBuffer *buffer;
+    CPLXMLNode *psRoot;
+
+    new_context = msIO_getHandler(stdout);
+    buffer = (msIOBuffer *)new_context->cbData;
+    psRoot = CPLParseXMLString((const char *)buffer->data);
+    msIO_restoreOldStdoutContext(old_context);
+    if (psRoot != NULL) {
+      CPLXMLNode *psFeatureCollection =
+          CPLGetXMLNode(psRoot, "=wfs:FeatureCollection");
+      if (psFeatureCollection != NULL) {
+        CPLXMLNode *psMember = CPLGetXMLNode(psFeatureCollection, "wfs:member");
+        if (psMember != NULL && psMember->psChild != NULL) {
+          CPLXMLNode *psIter;
+          CPLXMLNode *psFeatureNode;
+          char *pszTmpXML;
+
+          /* Transfer all namespaces of FeatureCollection to the Feature */
+          psFeatureNode = psMember->psChild;
+          psIter = psFeatureCollection->psChild;
+          while (psIter != NULL) {
+            if (psIter->eType == CXT_Attribute &&
+                (strncmp(psIter->pszValue, "xmlns:", strlen("xmlns:")) == 0 ||
+                 strncmp(psIter->pszValue, "xsi:", strlen("xsi:")) == 0)) {
+              CPLXMLNode *psIterNext = psIter->psNext;
+              psIter->psNext = NULL;
+              CPLAddXMLChild(psFeatureNode, CPLCloneXMLTree(psIter));
+              psIter->psNext = psIterNext;
+            }
+            psIter = psIter->psNext;
+          }
+
+          pszTmpXML = CPLSerializeXMLTree(psFeatureNode);
+          msIO_setHeader("Content-Type", "%s; charset=UTF-8",
+                         gmlinfo.output_mime_type);
+          msIO_sendHeaders();
+          msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+          msIO_printf("%s", pszTmpXML);
+          CPLFree(pszTmpXML);
+        } else {
+          status = msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
+                                  paramsObj->pszVersion);
+        }
+      }
+      CPLDestroyXMLNode(psRoot);
+    }
+  }
+
+  msWFSCleanupGMLInfo(&gmlinfo);
+
+  return status;
+}
+
+/*
+** msWFSGetPropertyValue()
+*/
+static int msWFSGetPropertyValue(mapObj *map, wfsParamsObj *paramsObj,
+                                 cgiRequestObj *req, owsRequestObj *ows_request,
+                                 int nWFSVersion) {
+  int status;
+  int maxfeatures = -1, startindex = -1;
+  rectObj bbox;
+
+  char *sBBoxSrs = NULL;
+
+  WFSGMLInfo gmlinfo;
+
+  OWSGMLVersion outputformat = OWS_GML2; /* default output is GML 2.1 */
+
+  int iNumberOfFeatures = 0;
+  int iResultTypeHits = 0;
+  int nMatchingFeatures = -1;
+  int bHasNextFeatures = MS_FALSE;
+
+  const char *pszTypeName;
+  layerObj *lp;
+
+  char *pszGMLGroups = NULL;
+  char *pszGMLIncludeItems = NULL;
+  char *pszGMLGeometries = NULL;
+
+  status = msWFSResolveStoredQuery(map, paramsObj, req);
+  if (status != MS_SUCCESS)
+    return status;
+
+  if (paramsObj->pszTypeName == NULL) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: TYPENAMES parameter missing",
+               "msWFSGetPropertyValue()");
+    return msWFSException(map, "typenames",
+                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
+
+  if (paramsObj->pszValueReference == NULL) {
+    msSetError(MS_WFSERR,
+               "Incomplete WFS request: VALUEREFERENCE parameter missing",
+               "msWFSGetPropertyValue()");
+    return msWFSException(map, "valuereference",
+                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
+
+  /* Keep only selected layers, set to OFF by default. */
+  msWFSTurnOffAllLayer(map);
+
+  /* Remove namespace prefix */
+  pszTypeName = msWFSStripNS(paramsObj->pszTypeName);
+
+  lp = msWFSGetLayerByName(map, ows_request, pszTypeName);
+  if (lp != NULL) {
+    gmlItemListObj *itemList = NULL;
+    gmlGeometryListObj *geometryList = NULL;
+    gmlGroupListObj *groupList = NULL;
+
+    lp->status = MS_ON;
+    if (lp->_template == NULL) {
+      /* Force setting a template to enable query. */
+      lp->_template = msStrdup("ttt.html");
+    }
+
+    /*do an alias replace for the current layer*/
+    if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
+      const char *pszValueReference;
+      int z;
+      int nGroupIndex = -1;
+
+      itemList = msGMLGetItems(lp, "G");
+      groupList = msGMLGetGroups(lp, "G");
+
+      if (paramsObj->pszSortBy != NULL &&
+          strcmp(paramsObj->pszSortBy, "!") != 0) {
+        status = msWFSApplySortBy(map, paramsObj, lp, paramsObj->pszSortBy,
+                                  itemList, groupList);
+        if (status != MS_SUCCESS) {
+          msGMLFreeItems(itemList);
+          msGMLFreeGroups(groupList);
+          return status;
+        }
+      }
+
+      geometryList = msGMLGetGeometries(lp, "GFO", MS_TRUE);
+
+      pszValueReference = msWFSStripNS(paramsObj->pszValueReference);
+      pszValueReference = msWFSUnaliasItem(lp, pszValueReference);
+      pszValueReference =
+          msWFSUngroupItem(lp, groupList, pszValueReference, &nGroupIndex);
+
+      if (strcmp(paramsObj->pszValueReference, "@gml:id") == 0) {
+        pszGMLGroups = msStrdup("");
+        pszGMLIncludeItems = msStrdup(paramsObj->pszValueReference);
+        pszGMLGeometries = msStrdup("none");
+      } else if (nGroupIndex >= 0) {
+        int w;
+        char *pszItems = NULL;
+        for (w = 0; w < groupList->groups[nGroupIndex].numitems; w++) {
+          if (w > 0)
+            pszItems = msStringConcatenate(pszItems, ",");
+          pszItems = msStringConcatenate(
+              pszItems, groupList->groups[nGroupIndex].items[w]);
+        }
+        pszGMLGroups = msStrdup(groupList->groups[nGroupIndex].name);
+        pszGMLIncludeItems = msStrdup(pszItems);
+        pszGMLGeometries = msStrdup("none");
+        msFree(pszItems);
+      } else {
+        pszGMLGroups = msStrdup("");
+
+        /* Check that the property name is allowed (#3563) */
+        /*we need to check of the property name is the geometry name; In that
+           case it is a valid property name*/
+        if (!msWFSIsAllowedItem(itemList, pszValueReference)) {
+          for (z = 0; z < geometryList->numgeometries; z++) {
+            if (strcasecmp(pszValueReference,
+                           geometryList->geometries[z].name) == 0)
+              break;
+          }
+
+          if (z == geometryList->numgeometries) {
+            msSetError(MS_WFSERR, "Invalid VALUEREFERENCE %s",
+                       "msWFSGetPropertyValue()", paramsObj->pszValueReference);
+            msFree(pszGMLGroups);
+            msGMLFreeItems(itemList);
+            msGMLFreeGroups(groupList);
+            msGMLFreeGeometries(geometryList);
+            return msWFSException(map, "valuereference",
+                                  MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                                  paramsObj->pszVersion);
+          } else {
+            pszGMLIncludeItems = msStrdup("");
+            pszGMLGeometries = msStrdup(pszValueReference);
+          }
+        } else {
+          pszGMLIncludeItems = msStrdup(pszValueReference);
+          pszGMLGeometries = msStrdup("none");
+        }
+      }
+
+      msLayerClose(lp);
+
+      msGMLFreeItems(itemList);
+      msGMLFreeGroups(groupList);
+      msGMLFreeGeometries(geometryList);
+    }
+  } else {
+    /* Requested layer name was not in capabilities:
+     * either it just doesn't exist
+     */
+    msSetError(MS_WFSERR,
+               "TYPENAME '%s' doesn't exist in this server.  Please check the "
+               "capabilities and reformulate your request.",
+               "msWFSGetFeature()", paramsObj->pszTypeName);
+    msFree(pszGMLGroups);
+    msFree(pszGMLIncludeItems);
+    msFree(pszGMLGeometries);
+    return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
+
+  /* Initialize gml options */
+  msWFSInitGMLInfo(&gmlinfo);
+
+  if (paramsObj->pszResultType != NULL) {
+    if (strcasecmp(paramsObj->pszResultType, "hits") == 0)
+      iResultTypeHits = 1;
+  }
+
+  gmlinfo._typename = paramsObj->pszTypeName;
+
+  /* Validate outputformat */
+  status = msWFSGetGMLOutputFormat(paramsObj, &gmlinfo, nWFSVersion);
+  if (status < 0) {
+    msSetError(
+        MS_WFSERR,
+        "'%s' is not a permitted output format for GetPropertyValue request.",
+        "msWFSGetPropertyValue()", paramsObj->pszOutputFormat);
+    msFree(pszGMLGroups);
+    msFree(pszGMLIncludeItems);
+    msFree(pszGMLGeometries);
+    return msWFSException(map, "outputformat",
+                          MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  } else {
+    outputformat = (OWSGMLVersion)status;
+  }
+
+  msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, iResultTypeHits,
+                                        &maxfeatures, &startindex);
+
+  status = msWFSAnalyzeBBOX(map, paramsObj, &bbox, &sBBoxSrs);
+  if (status != 0) {
+    msFree(pszGMLGroups);
+    msFree(pszGMLIncludeItems);
+    msFree(pszGMLGeometries);
+    return status;
+  }
+
+  if (iResultTypeHits == 1) {
+    map->query.only_cache_result_count = MS_TRUE;
+  } else {
+    msWFSSetShapeCache(map);
+  }
+
+  status = msWFSRetrieveFeatures(
+      map, ows_request, paramsObj, &gmlinfo, paramsObj->pszFilter,
+      paramsObj->pszBbox != NULL, sBBoxSrs, bbox, paramsObj->pszFeatureId,
+      (char **)&pszTypeName, 1, maxfeatures, nWFSVersion, &iNumberOfFeatures,
+      &bHasNextFeatures);
+  if (status != MS_SUCCESS) {
+    msFree(sBBoxSrs);
+    msFree(pszGMLGroups);
+    msFree(pszGMLIncludeItems);
+    msFree(pszGMLGeometries);
+    return status;
+  }
+
+  /* ----------------------------------------- */
+  /* Now compute nMatchingFeatures for WFS 2.0 */
+  /* ----------------------------------------- */
+
+  nMatchingFeatures = msWFSComputeMatchingFeatures(
+      map, ows_request, paramsObj, iNumberOfFeatures, maxfeatures, &gmlinfo,
+      bbox, sBBoxSrs, (char **)&pszTypeName, 1, nWFSVersion);
+
+  msFree(sBBoxSrs);
+  sBBoxSrs = NULL;
+
+  /*
+  ** GML Header generation.
+  */
+  msIO_setHeader("Content-Type", "%s; charset=UTF-8", gmlinfo.output_mime_type);
+  msIO_sendHeaders();
+
+  status = msWFSGetFeature_GMLPreamble(
+      map, req, &gmlinfo, paramsObj, outputformat, iResultTypeHits,
+      iNumberOfFeatures, nMatchingFeatures, maxfeatures, bHasNextFeatures,
+      nWFSVersion);
+
+  if (status == MS_SUCCESS && maxfeatures != 0 && iResultTypeHits == 0) {
+    if (pszGMLGroups)
+      msInsertHashTable(&(lp->metadata), "GML_GROUPS", pszGMLGroups);
+    if (pszGMLIncludeItems)
+      msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS",
+                        pszGMLIncludeItems);
+    if (pszGMLGeometries)
+      msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES", pszGMLGeometries);
+
+    status = msGMLWriteWFSQuery(map, stdout, gmlinfo.user_namespace_prefix,
+                                outputformat, nWFSVersion, MS_TRUE, MS_TRUE);
+  }
+
+  msIO_printf("</wfs:ValueCollection>\n");
+
+  msFree(pszGMLGroups);
+  msFree(pszGMLIncludeItems);
+  msFree(pszGMLGeometries);
+
+  free(gmlinfo.script_url);
+  free(gmlinfo.script_url_encoded);
+  msFree(gmlinfo.user_namespace_uri_encoded);
+
+  return status;
+}
+
+#endif /* USE_WFS_SVR */
+
+/*
+** msWFSDispatch() is the entry point for WFS requests.
+** - If this is a valid request then it is processed and MS_SUCCESS is returned
+**   on success, or MS_FAILURE on failure.
+** - If this does not appear to be a valid WFS request then MS_DONE
+**   is returned and MapServer is expected to process this as a regular
+**   MapServer request.
+*/
+int msWFSDispatch(mapObj *map, cgiRequestObj *requestobj,
+                  owsRequestObj *ows_request, int force_wfs_mode) {
+#ifdef USE_WFS_SVR
+  int status;
+  int returnvalue = MS_DONE;
+  int nWFSVersion;
+  char *validated_language;
+
+  /* static char *wmtver = NULL, *request=NULL, *service=NULL; */
+  wfsParamsObj *paramsObj;
+  /*
+  ** Populate the Params object based on the request
+  */
+  paramsObj = msWFSCreateParamsObj();
+  /* TODO : store also parameters that are inside the map object */
+  /* into the paramsObj.  */
+  status = msWFSParseRequest(map, requestobj, paramsObj, force_wfs_mode);
+  if (status != MS_SUCCESS) {
+    msWFSFreeParamsObj(paramsObj);
+    return status;
+  }
+
+  validated_language =
+      msOWSGetLanguageFromList(map, "FO", paramsObj->pszLanguage);
+  if (validated_language != NULL) {
+    msMapSetLanguageSpecificConnection(map, validated_language);
+  }
+  msFree(validated_language);
+
+  if (force_wfs_mode) {
+    /*request is always required*/
+    if (paramsObj->pszRequest == NULL || strlen(paramsObj->pszRequest) <= 0) {
+      msSetError(MS_WFSERR, "Incomplete WFS request: REQUEST parameter missing",
+                 "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
+      msWFSFreeParamsObj(paramsObj);
+      return returnvalue;
+    }
+
+    /*version:
+      wfs 1.0 and 1.1.0 POST request: optional
+      wfs 1.0 and 1.1.0 GET request: optional for getcapabilities and required
+      for describefeature and getfeature
+     */
+    if (paramsObj->pszVersion == NULL && requestobj &&
+        requestobj->postrequest == NULL &&
+        strcasecmp(paramsObj->pszRequest, "GetCapabilities") != 0) {
+      msSetError(MS_WFSERR, "Invalid WFS request: VERSION parameter missing",
+                 "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
+      msWFSFreeParamsObj(paramsObj);
+      return returnvalue;
+    }
+
+    if (paramsObj->pszVersion == NULL || strlen(paramsObj->pszVersion) <= 0)
+      paramsObj->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
+
+    /*service
+      wfs 1.0 and 1.1.0 GET: required and should be set to WFS
+      wfs 1.0 POST: required
+      wfs 1.1.1 POST: optional
+    */
+    if ((paramsObj->pszService == NULL || strlen(paramsObj->pszService) == 0) &&
+        ((requestobj && requestobj->postrequest == NULL) ||
+         strcasecmp(paramsObj->pszVersion, "1.0") == 0)) {
+      msSetError(MS_WFSERR, "Invalid WFS request: Missing SERVICE parameter",
+                 "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
+      msWFSFreeParamsObj(paramsObj);
+      return returnvalue;
+    }
+
+    if (paramsObj->pszService == NULL || strlen(paramsObj->pszService) == 0)
+      paramsObj->pszService = msStrdup("WFS");
+
+    if (paramsObj->pszService != NULL &&
+        strcasecmp(paramsObj->pszService, "WFS") != 0) {
+      msSetError(MS_WFSERR,
+                 "Invalid WFS request: SERVICE parameter must be set to WFS",
+                 "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "service", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
+      msWFSFreeParamsObj(paramsObj);
+      return returnvalue;
+    }
+  }
+  /* If SERVICE is specified then it MUST be "WFS" */
+  if (paramsObj->pszService != NULL &&
+      strcasecmp(paramsObj->pszService, "WFS") != 0) {
+    msWFSFreeParamsObj(paramsObj);
+    return MS_DONE; /* Not a WFS request */
+  }
+
+  /* If SERVICE, VERSION and REQUEST not included than this isn't a WFS req*/
+  if (paramsObj->pszService == NULL && paramsObj->pszVersion == NULL &&
+      paramsObj->pszRequest == NULL) {
+    msWFSFreeParamsObj(paramsObj);
+    return MS_DONE; /* Not a WFS request */
+  }
+
+  /* VERSION *and* REQUEST *and* SERVICE required by all WFS requests including
+   * GetCapabilities.
+   */
+  if (paramsObj->pszVersion == NULL || strlen(paramsObj->pszVersion) <= 0) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: VERSION parameter missing",
+               "msWFSDispatch()");
+
+    returnvalue =
+        msWFSException11(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         msWFSGetDefaultVersion(map));
+    msWFSFreeParamsObj(paramsObj);
+    return returnvalue;
+  }
+
+  if (paramsObj->pszRequest == NULL || strlen(paramsObj->pszRequest) <= 0) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: REQUEST parameter missing",
+               "msWFSDispatch()");
+    returnvalue =
+        msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                       paramsObj->pszVersion);
+    msWFSFreeParamsObj(paramsObj);
+    return returnvalue;
+  }
+
+  if (paramsObj->pszService == NULL || strlen(paramsObj->pszService) <= 0) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: SERVICE parameter missing",
+               "msWFSDispatch()");
+
+    returnvalue =
+        msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                       paramsObj->pszVersion);
+    msWFSFreeParamsObj(paramsObj);
+    return returnvalue;
+  }
+
+  if ((status = msOWSMakeAllLayersUnique(map)) != MS_SUCCESS) {
+    msSetError(MS_WFSERR, "msOWSMakeAllLayersUnique() failed",
+               "msWFSDispatch()");
+    returnvalue = msWFSException(
+        map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+    msWFSFreeParamsObj(paramsObj);
+    return returnvalue;
+  }
+  /*
+  ** Start dispatching requests
+  */
+  if (strcasecmp(paramsObj->pszRequest, "GetCapabilities") == 0) {
+    msOWSRequestLayersEnabled(map, "F", paramsObj->pszRequest, ows_request);
+    if (ows_request->numlayers == 0) {
+      msSetError(
+          MS_WFSERR,
+          "WFS request not enabled. Check wfs/ows_enable_request settings.",
+          "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
+      msWFSFreeParamsObj(paramsObj);
+      return returnvalue;
+    }
+
+    returnvalue = msWFSGetCapabilities(map, paramsObj, requestobj, ows_request);
+    msWFSFreeParamsObj(paramsObj);
+    return returnvalue;
+  }
+
+  /*
+  ** Validate VERSION against the versions that we support... we don't do this
+  ** for GetCapabilities in order to allow version negociation.
+  */
+  if (strcmp(paramsObj->pszVersion, "1.0.0") != 0 &&
+      strcmp(paramsObj->pszVersion, "1.1.0") != 0 &&
+      strcmp(paramsObj->pszVersion, "2.0.0") != 0) {
+    msSetError(MS_WFSERR, "WFS Server does not support VERSION %s.",
+               "msWFSDispatch()", paramsObj->pszVersion);
+    returnvalue =
+        msWFSException(map, "version", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                       msWFSGetDefaultVersion(map));
+    msWFSFreeParamsObj(paramsObj);
+    return returnvalue;
+  }
+
+  nWFSVersion = msOWSParseVersionString(paramsObj->pszVersion);
+
+  /* Since the function can still return MS_DONE, we add an extra service check
+     to not call msOWSRequestLayersEnabled twice */
+  if (strcasecmp(paramsObj->pszService, "WFS") == 0) {
+    msOWSRequestLayersEnabled(map, "F", paramsObj->pszRequest, ows_request);
+    if (ows_request->numlayers == 0) {
+      msSetError(
+          MS_WFSERR,
+          "WFS request not enabled. Check wfs/ows_enable_request settings.",
+          "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
+      msWFSFreeParamsObj(paramsObj);
+      return returnvalue;
+    }
+  }
+
+  returnvalue = MS_DONE;
+  /* Continue dispatching...
+   */
+  if (strcasecmp(paramsObj->pszRequest, "DescribeFeatureType") == 0)
+    returnvalue =
+        msWFSDescribeFeatureType(map, paramsObj, ows_request, nWFSVersion);
+
+  else if (strcasecmp(paramsObj->pszRequest, "GetFeature") == 0)
+    returnvalue =
+        msWFSGetFeature(map, paramsObj, requestobj, ows_request, nWFSVersion);
+
+  else if (nWFSVersion >= OWS_2_0_0 &&
+           strcasecmp(paramsObj->pszRequest, "GetPropertyValue") == 0)
+    returnvalue = msWFSGetPropertyValue(map, paramsObj, requestobj, ows_request,
+                                        nWFSVersion);
+
+  else if (nWFSVersion >= OWS_2_0_0 &&
+           strcasecmp(paramsObj->pszRequest, "ListStoredQueries") == 0)
+    returnvalue = msWFSListStoredQueries20(map, ows_request);
+
+  else if (nWFSVersion >= OWS_2_0_0 &&
+           strcasecmp(paramsObj->pszRequest, "DescribeStoredQueries") == 0)
+    returnvalue = msWFSDescribeStoredQueries20(map, paramsObj, ows_request);
+
+  else if (msWFSGetIndexUnsupportedOperation(paramsObj->pszRequest) >= 0) {
+    /* Unsupported WFS request */
+    msSetError(MS_WFSERR, "Unsupported WFS request: %s", "msWFSDispatch()",
+               paramsObj->pszRequest);
+    returnvalue = msWFSException(map, paramsObj->pszRequest,
+                                 MS_OWS_ERROR_OPERATION_NOT_SUPPORTED,
+                                 paramsObj->pszVersion);
+  } else if (strcasecmp(paramsObj->pszService, "WFS") == 0) {
+    /* Invalid WFS request */
+    msSetError(MS_WFSERR, "Invalid WFS request: %s", "msWFSDispatch()",
+               paramsObj->pszRequest);
+    returnvalue =
+        msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                       paramsObj->pszVersion);
+  }
+
+  /* This was not detected as a WFS request... let MapServer handle it */
+  msWFSFreeParamsObj(paramsObj);
+  return returnvalue;
+
+#else
+  msSetError(MS_WFSERR, "WFS server support is not available.",
+             "msWFSDispatch()");
+  return (MS_FAILURE);
+#endif
+}
+
+/************************************************************************/
+/*                           msWFSCreateParamsObj                       */
+/*                                                                      */
+/*      Create a parameter object, initialize it.                       */
+/*      The caller should free the object using msWFSFreeParamsObj.     */
+/************************************************************************/
+wfsParamsObj *msWFSCreateParamsObj() {
+  wfsParamsObj *paramsObj = (wfsParamsObj *)calloc(1, sizeof(wfsParamsObj));
+  MS_CHECK_ALLOC(paramsObj, sizeof(wfsParamsObj), NULL);
+
+  paramsObj->nMaxFeatures = -1;
+  paramsObj->nStartIndex = -1;
+
+  return paramsObj;
+}
+
+/************************************************************************/
+/*                            msWFSFreeParmsObj                         */
+/*                                                                      */
+/*      Free params object.                                             */
+/************************************************************************/
+void msWFSFreeParamsObj(wfsParamsObj *wfsparams) {
+  if (wfsparams) {
+    free(wfsparams->pszVersion);
+    free(wfsparams->pszUpdateSequence);
+    free(wfsparams->pszRequest);
+    free(wfsparams->pszService);
+    free(wfsparams->pszTypeName);
+    free(wfsparams->pszFilter);
+    free(wfsparams->pszFilterLanguage);
+    free(wfsparams->pszBbox);
+    free(wfsparams->pszGeometryName);
+    free(wfsparams->pszOutputFormat);
+    free(wfsparams->pszFeatureId);
+    free(wfsparams->pszSrs);
+    free(wfsparams->pszResultType);
+    free(wfsparams->pszPropertyName);
+    free(wfsparams->pszAcceptVersions);
+    free(wfsparams->pszSections);
+    free(wfsparams->pszSortBy);
+    free(wfsparams->pszLanguage);
+    free(wfsparams->pszValueReference);
+    free(wfsparams->pszStoredQueryId);
+
+    free(wfsparams);
+  }
+}
+
+#ifdef USE_WFS_SVR
+/************************************************************************/
+/*                       msWFSGetDefaultVersion                         */
+/************************************************************************/
+static const char *msWFSGetDefaultVersion(mapObj *map) {
+  const char *pszVersion =
+      msOWSLookupMetadata(&(map->web.metadata), "F", "getcapabilities_version");
+  if (pszVersion != NULL) {
+    /* Check that the metadata value is one of the recognized versions */
+    int iVersion = msOWSParseVersionString(pszVersion);
+    int i;
+    for (i = 0; i < wfsNumSupportedVersions; i++) {
+      if (iVersion == wfsSupportedVersions[i])
+        return wfsSupportedVersionsStr[i];
+    }
+    /* If not, use the default (= latest) version */
+    msDebug("msWFSGetDefaultVersion(): invalid value for "
+            "wfs_getcapabilities_version: %s\n",
+            pszVersion);
+  }
+  return WFS_LATEST_VERSION;
+}
+
+/************************************************************************/
+/*                             msWFSSetParam                            */
+/************************************************************************/
+static int msWFSSetParam(char **ppszOut, cgiRequestObj *request, int i,
+                         const char *pszExpectedParamName) {
+  if (strcasecmp(request->ParamNames[i], pszExpectedParamName) == 0) {
+    if (*ppszOut == NULL)
+      *ppszOut = msStrdup(request->ParamValues[i]);
+    return 1;
+  }
+  return 0;
+}
+
+/************************************************************************/
+/*                         msWFSParseXMLQueryNode                       */
+/************************************************************************/
+
+static void msWFSParseXMLQueryNode(CPLXMLNode *psQuery,
+                                   wfsParamsObj *wfsparams) {
+  const char *pszTypename;
+  const char *pszValue;
+  char *pszSerializedFilter, *pszTmp, *pszTmp2;
+  CPLXMLNode *psPropertyName;
+  CPLXMLNode *psFilter;
+  CPLXMLNode *psSortBy;
+  char *pszSortBy = NULL;
+
+  pszValue = CPLGetXMLValue(psQuery, "srsName", NULL);
+  if (pszValue) {
+    msFree(wfsparams->pszSrs);
+    wfsparams->pszSrs = msStrdup(pszValue);
+  }
+
+  /* parse typenames */
+  pszTypename = CPLGetXMLValue(psQuery, "typename", NULL);
+  if (pszTypename == NULL) /* WFS 2.0 */
+    pszTypename = CPLGetXMLValue(psQuery, "typeNames", NULL);
+
+  /*parse property name*/
+  psPropertyName = CPLGetXMLNode(psQuery, "PropertyName");
+  pszTmp2 = NULL;
+
+  /*when there is no PropertyName, we output (!) so that it is parsed properly
+   * in GetFeature*/
+  if (psPropertyName == NULL)
+    pszTmp2 = msStrdup("!");
+
+  while (psPropertyName) {
+    if (!psPropertyName->pszValue ||
+        strcasecmp(psPropertyName->pszValue, "PropertyName") != 0) {
+      psPropertyName = psPropertyName->psNext;
+      continue;
+    }
+    pszValue = CPLGetXMLValue(psPropertyName, NULL, NULL);
+    if (pszTmp2 == NULL) {
+      pszTmp2 = msStrdup(pszValue);
+    } else {
+      pszTmp = msStrdup(pszTmp2);
+      pszTmp2 = (char *)msSmallRealloc(
+          pszTmp2, sizeof(char) * (strlen(pszTmp) + strlen(pszValue) + 2));
+      sprintf(pszTmp2, "%s,%s", pszTmp, pszValue);
+      msFree(pszTmp);
+    }
+    psPropertyName = psPropertyName->psNext;
+  }
+  if (pszTmp2) {
+    pszTmp = msStrdup(pszTmp2);
+    pszTmp2 =
+        (char *)msSmallRealloc(pszTmp2, sizeof(char) * (strlen(pszTmp) + 3));
+    sprintf(pszTmp2, "(%s)", pszTmp);
+    msFree(pszTmp);
+
+    msWFSBuildParamList(&(wfsparams->pszPropertyName), pszTmp2, "");
+    msFree(pszTmp2);
+    pszTmp2 = NULL;
+  }
+
+  /* parse filter */
+  psFilter = CPLGetXMLNode(psQuery, "Filter");
+
+  if (psFilter == NULL) {
+    /*when there is no Filter, we output (!) so that it is parsed properly in
+     * GetFeature*/
+    pszSerializedFilter = msStrdup("(!)");
+  } else {
+    char *pszCPLTmp = CPLSerializeXMLTree(psFilter);
+    pszSerializedFilter =
+        (char *)msSmallMalloc(sizeof(char) * (strlen(pszCPLTmp) + 3));
+    sprintf(pszSerializedFilter, "(%s)", pszCPLTmp);
+    CPLFree(pszCPLTmp);
+  }
+
+  msWFSBuildParamList(&(wfsparams->pszFilter), pszSerializedFilter, "");
+  free(pszSerializedFilter);
+
+  /* parse SortBy */
+  psSortBy = CPLGetXMLNode(psQuery, "SortBy");
+  if (psSortBy != NULL) {
+    int bFirstProperty = MS_TRUE;
+    CPLXMLNode *psIter = psSortBy->psChild;
+
+    pszSortBy = msStringConcatenate(pszSortBy, "(");
+
+    while (psIter != NULL) {
+      if (psIter->eType == CXT_Element &&
+          strcmp(psIter->pszValue, "SortProperty") == 0) {
+        const char *pszPropertyName =
+            CPLGetXMLValue(psIter, "PropertyName", NULL);
+        if (pszPropertyName == NULL)
+          pszPropertyName = CPLGetXMLValue(psIter, "ValueReference", NULL);
+        if (pszPropertyName != NULL) {
+          const char *pszSortOrder = CPLGetXMLValue(psIter, "SortOrder", NULL);
+          if (!bFirstProperty)
+            pszSortBy = msStringConcatenate(pszSortBy, ",");
+          bFirstProperty = MS_FALSE;
+
+          pszSortBy = msStringConcatenate(pszSortBy, pszPropertyName);
+          if (pszSortOrder != NULL) {
+            pszSortBy = msStringConcatenate(pszSortBy, " ");
+            pszSortBy = msStringConcatenate(pszSortBy, pszSortOrder);
+          }
+        }
+      }
+      psIter = psIter->psNext;
+    }
+
+    pszSortBy = msStringConcatenate(pszSortBy, ")");
+  } else {
+    pszSortBy = msStrdup("(!)");
+  }
+
+  msWFSBuildParamList(&(wfsparams->pszSortBy), pszSortBy, "");
+  free(pszSortBy);
+
+  /* Special case for "urn:ogc:def:query:OGC-WFS::GetFeatureById" */
+  /* Resolve the property typename */
+  if (pszTypename != NULL && strcmp(pszTypename, "?") == 0 &&
+      psFilter != NULL) {
+    const char *rid;
+    rid = CPLGetXMLValue(psFilter, "ResourceId.rid", NULL);
+    if (rid != NULL) {
+      char *pszTmpTypename = msStrdup(rid);
+      char *pszDot = strchr(pszTmpTypename, '.');
+      if (pszDot) {
+        *pszDot = '\0';
+        msWFSBuildParamList(&(wfsparams->pszTypeName), pszTmpTypename, ",");
+        pszTypename = NULL;
+
+        if (wfsparams->countGetFeatureById >= 0)
+          wfsparams->countGetFeatureById++;
+      } else
+        wfsparams->countGetFeatureById = -1;
+      msFree(pszTmpTypename);
+    } else
+      wfsparams->countGetFeatureById = -1;
+  } else
+    wfsparams->countGetFeatureById = -1;
+
+  if (pszTypename) {
+    msWFSBuildParamList(&(wfsparams->pszTypeName), pszTypename, ",");
+  }
+}
+
+/************************************************************************/
+/*                     msWFSAnalyzeStoredQuery                          */
+/************************************************************************/
+
+static int msWFSAnalyzeStoredQuery(mapObj *map, wfsParamsObj *wfsparams,
+                                   const char *id,
+                                   const char *pszResolvedQuery) {
+  CPLXMLNode *psRoot;
+  CPLXMLNode *psQuery;
+  CPLXMLNode *psIter;
+
+  psRoot = CPLParseXMLString(pszResolvedQuery);
+
+  if (psRoot == NULL) {
+    msSetError(MS_WFSERR,
+               "Resolved definition for stored query '%s' is invalid",
+               "msWFSParseRequest()", id);
+    msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   wfsparams->pszVersion);
+    return MS_FAILURE;
+  }
+
+  CPLStripXMLNamespace(psRoot, NULL, 1);
+  psQuery = CPLGetXMLNode(psRoot,
+                          "=StoredQueryDescription.QueryExpressionText.Query");
+  if (psQuery == NULL) {
+    msSetError(MS_WFSERR,
+               "Resolved definition for stored query '%s' is invalid",
+               "msWFSParseRequest()", id);
+    msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   wfsparams->pszVersion);
+    CPLDestroyXMLNode(psRoot);
+    return MS_FAILURE;
+  }
+
+  psIter = psQuery;
+  while (psIter != NULL) {
+    if (psIter->eType == CXT_Element &&
+        strcmp(psIter->pszValue, "Query") == 0) {
+      msWFSParseXMLQueryNode(psIter, wfsparams);
+    }
+    psIter = psIter->psNext;
+  }
+
+  CPLDestroyXMLNode(psRoot);
+
+  return MS_SUCCESS;
+}
+
+/************************************************************************/
+/*                     msWFSParseXMLStoredQueryNode                     */
+/************************************************************************/
+
+static int msWFSParseXMLStoredQueryNode(mapObj *map, wfsParamsObj *wfsparams,
+                                        CPLXMLNode *psQuery) {
+  const char *id;
+  CPLXMLNode *psIter;
+  hashTableObj *hashTable;
+  char *pszResolvedQuery;
+  int status;
+
+  id = CPLGetXMLValue(psQuery, "id", NULL);
+  if (id == NULL) {
+    msSetError(MS_WFSERR, "Missing 'id' attribute in StoredQuery",
+               "msWFSParseRequest()");
+    return msWFSException(map, "id", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                          wfsparams->pszVersion);
+  }
+
+  hashTable = msCreateHashTable();
+  psIter = psQuery->psChild;
+  while (psIter != NULL) {
+    if (psIter->eType == CXT_Element &&
+        strcmp(psIter->pszValue, "Parameter") == 0) {
+      const char *name;
+      CPLXMLNode *psIter2;
+      char *pszValue;
+
+      name = CPLGetXMLValue(psIter, "name", NULL);
+      if (name == NULL) {
+        msSetError(MS_WFSERR,
+                   "Missing 'name' attribute in Parameter of StoredQuery",
+                   "msWFSParseRequest()");
+        msFreeHashTable(hashTable);
+        return msWFSException(map, NULL, MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              wfsparams->pszVersion);
+      }
+
+      psIter2 = psIter->psChild;
+      while (psIter2 != NULL) {
+        if (psIter2->eType != CXT_Attribute)
+          break;
+        psIter2 = psIter2->psNext;
+      }
+
+      pszValue = CPLSerializeXMLTree(psIter2);
+      msInsertHashTable(hashTable, name, pszValue);
+      CPLFree(pszValue);
+    }
+    psIter = psIter->psNext;
+  }
+
+  pszResolvedQuery =
+      msWFSGetResolvedStoredQuery20(map, wfsparams, id, hashTable);
+  msFreeHashTable(hashTable);
+  if (pszResolvedQuery == NULL)
+    return MS_FAILURE;
+
+  status = msWFSAnalyzeStoredQuery(map, wfsparams, id, pszResolvedQuery);
+
+  msFree(pszResolvedQuery);
+
+  return status;
+}
+
+/************************************************************************/
+/*                    msWFSSimplifyPropertyNameAndFilter                */
+/************************************************************************/
+
+static void msWFSSimplifyPropertyNameAndFilter(wfsParamsObj *wfsparams) {
+  int i;
+
+  /* If no PropertyName at all was specified, then clear the field */
+  /* that will be easier to generate valid 'next' and 'previous' uri */
+  /* for WFS 2.0 GetFeature */
+  if (wfsparams->pszPropertyName != NULL) {
+    i = 0;
+    while (strncmp(wfsparams->pszPropertyName + i, "(!)", 3) == 0)
+      i += 3;
+    if (wfsparams->pszPropertyName[i] == '\0') {
+      msFree(wfsparams->pszPropertyName);
+      wfsparams->pszPropertyName = NULL;
+    }
+  }
+
+  /* Same with filter */
+  if (wfsparams->pszFilter != NULL) {
+    i = 0;
+    while (strncmp(wfsparams->pszFilter + i, "(!)", 3) == 0)
+      i += 3;
+    if (wfsparams->pszFilter[i] == '\0') {
+      msFree(wfsparams->pszFilter);
+      wfsparams->pszFilter = NULL;
+    }
+  }
+
+  /* Same with SortBy */
+  if (wfsparams->pszSortBy != NULL) {
+    i = 0;
+    while (strncmp(wfsparams->pszSortBy + i, "(!)", 3) == 0)
+      i += 3;
+    if (wfsparams->pszSortBy[i] == '\0') {
+      msFree(wfsparams->pszSortBy);
+      wfsparams->pszSortBy = NULL;
+    }
+  }
+}
+
+#endif /* USE_WFS_SVR */
+
+/************************************************************************/
+/*                            msWFSParseRequest                         */
+/*                                                                      */
+/*      Parse request into the params object.                           */
+/************************************************************************/
+int msWFSParseRequest(mapObj *map, cgiRequestObj *request,
+                      wfsParamsObj *wfsparams, int force_wfs_mode) {
+#ifdef USE_WFS_SVR
+  int i = 0;
+
+  if (!request || !wfsparams)
+    return msWFSException(map, "request", "InvalidRequest", NULL);
+
+  if (request->NumParams > 0 && request->postrequest == NULL) {
+    for (i = 0; i < request->NumParams; i++) {
+      if (request->ParamNames[i] && request->ParamValues[i]) {
+        if (msWFSSetParam(&(wfsparams->pszVersion), request, i, "VERSION")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszUpdateSequence), request, i,
+                               "UPDATESEQUENCE")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszRequest), request, i,
+                               "REQUEST")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszService), request, i,
+                               "SERVICE")) {
+        }
+
+        else if (strcasecmp(request->ParamNames[i], "MAXFEATURES") == 0)
+          wfsparams->nMaxFeatures = atoi(request->ParamValues[i]);
+
+        /* WFS 2.0 */
+        else if (strcasecmp(request->ParamNames[i], "COUNT") == 0)
+          wfsparams->nMaxFeatures = atoi(request->ParamValues[i]);
+
+        else if (strcasecmp(request->ParamNames[i], "STARTINDEX") == 0)
+          wfsparams->nStartIndex = atoi(request->ParamValues[i]);
+
+        else if (msWFSSetParam(&(wfsparams->pszBbox), request, i, "BBOX")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszSrs), request, i, "SRSNAME")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszResultType), request, i,
+                               "RESULTTYPE")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszTypeName), request, i,
+                               "TYPENAME")) {
+        }
+
+        /* WFS 2.0 */
+        else if (msWFSSetParam(&(wfsparams->pszTypeName), request, i,
+                               "TYPENAMES")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszFilter), request, i, "FILTER")) {
+        }
+
+        /* WFS 2.0 */
+        else if (msWFSSetParam(&(wfsparams->pszFilterLanguage), request, i,
+                               "FILTER_LANGUAGE")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszOutputFormat), request, i,
+                               "OUTPUTFORMAT")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszFeatureId), request, i,
+                               "FEATUREID")) {
+        }
+
+        /* WFS 2.0 */
+        else if (msWFSSetParam(&(wfsparams->pszFeatureId), request, i,
+                               "RESOURCEID")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszPropertyName), request, i,
+                               "PROPERTYNAME")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszAcceptVersions), request, i,
+                               "ACCEPTVERSIONS")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszSections), request, i,
+                               "SECTIONS")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszSortBy), request, i, "SORTBY")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszLanguage), request, i,
+                               "LANGUAGE")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszValueReference), request, i,
+                               "VALUEREFERENCE")) {
+        }
+
+        else if (msWFSSetParam(&(wfsparams->pszStoredQueryId), request, i,
+                               "STOREDQUERY_ID")) {
+        }
+      }
+    }
+    /* version is optional is the GetCapabilities. If not */
+    /* provided, set it. Default it to latest implemented version */
+    /* or to the specified one in wfs_getcapabilities_version */
+    if (wfsparams->pszVersion == NULL && wfsparams->pszRequest &&
+        strcasecmp(wfsparams->pszRequest, "GetCapabilities") == 0) {
+      wfsparams->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse the post request. It is assumed to be an XML document.    */
+  /* -------------------------------------------------------------------- */
+  if (request->postrequest != NULL) {
+
+    CPLXMLNode *psRoot;
+    CPLXMLNode *psGetFeature = NULL;
+    CPLXMLNode *psGetCapabilities = NULL;
+    CPLXMLNode *psDescribeFeature = NULL;
+    CPLXMLNode *psGetPropertyValue = NULL;
+    CPLXMLNode *psListStoredQueries = NULL;
+    CPLXMLNode *psDescribeStoredQueries = NULL;
+    CPLXMLNode *psOperation = NULL;
+    const char *pszValue;
+    char *pszSchemaLocation = NULL;
+
+    psRoot = CPLParseXMLString(request->postrequest);
+    if (map->debug == MS_DEBUGLEVEL_VVV) {
+      msDebug("msWFSParseRequest(): WFS post request: %s\n",
+              request->postrequest);
+    }
+    if (psRoot) {
+      /* need to strip namespaces */
+      CPLStripXMLNamespace(psRoot, NULL, 1);
+
+      for (psOperation = psRoot; psOperation != NULL;
+           psOperation = psOperation->psNext) {
+        if (psOperation->eType == CXT_Element) {
+
+          /* keep schemaLocation so as to be able to validate against
+           * appropriate */
+          /* wfs.xsd schema afterwards */
+          if (pszSchemaLocation == NULL &&
+              CPLGetXMLValue(psOperation, "schemaLocation", NULL) != NULL)
+            pszSchemaLocation =
+                msStrdup(CPLGetXMLValue(psOperation, "schemaLocation", NULL));
+
+          if (strcasecmp(psOperation->pszValue, "GetFeature") == 0) {
+            psGetFeature = psOperation;
+            break;
+          } else if (strcasecmp(psOperation->pszValue, "GetCapabilities") ==
+                     0) {
+            psGetCapabilities = psOperation;
+            break;
+          } else if (strcasecmp(psOperation->pszValue, "DescribeFeatureType") ==
+                     0) {
+            psDescribeFeature = psOperation;
+            break;
+          } else if (strcasecmp(psOperation->pszValue, "GetPropertyValue") ==
+                     0) {
+            psGetPropertyValue = psOperation;
+            break;
+          } else if (strcasecmp(psOperation->pszValue, "ListStoredQueries") ==
+                     0) {
+            psListStoredQueries = psOperation;
+            break;
+          } else if (strcasecmp(psOperation->pszValue,
+                                "DescribeStoredQueries") == 0) {
+            psDescribeStoredQueries = psOperation;
+            break;
+          }
+          /* these are unsupported requests. Just set the  */
+          /* request value and return; */
+          else {
+            int idx = msWFSGetIndexUnsupportedOperation(psOperation->pszValue);
+            if (idx >= 0) {
+              wfsparams->pszRequest = msStrdup(wfsUnsupportedOperations[idx]);
+              break;
+            }
+          }
+        }
+      }
+
+      if (psOperation != NULL) {
+        pszValue = CPLGetXMLValue(psOperation, "version", NULL);
+        if (pszValue)
+          wfsparams->pszVersion = msStrdup(pszValue);
+
+        pszValue = CPLGetXMLValue(psOperation, "service", NULL);
+        if (pszValue)
+          wfsparams->pszService = msStrdup(pszValue);
+      }
+
+      /* -------------------------------------------------------------------- */
+      /*      Parse the GetFeature                                            */
+      /* -------------------------------------------------------------------- */
+      if (psGetFeature) {
+        CPLXMLNode *psIter;
+
+        wfsparams->pszRequest = msStrdup("GetFeature");
+
+        pszValue = CPLGetXMLValue(psGetFeature, "resultType", NULL);
+        if (pszValue)
+          wfsparams->pszResultType = msStrdup(pszValue);
+
+        pszValue = CPLGetXMLValue(psGetFeature, "maxFeatures", NULL);
+        if (pszValue)
+          wfsparams->nMaxFeatures = atoi(pszValue);
+        else {
+          /* WFS 2.0 */
+          pszValue = CPLGetXMLValue(psGetFeature, "count", NULL);
+          if (pszValue)
+            wfsparams->nMaxFeatures = atoi(pszValue);
+        }
+
+        pszValue = CPLGetXMLValue(psGetFeature, "startIndex", NULL);
+        if (pszValue)
+          wfsparams->nStartIndex = atoi(pszValue);
+
+        pszValue = CPLGetXMLValue(psGetFeature, "outputFormat", NULL);
+        if (pszValue)
+          wfsparams->pszOutputFormat = msStrdup(pszValue);
+
+        /* --------------------------------------------------------------------
+         */
+        /*      Parse typenames and filters. If there are multiple queries, */
+        /*      typenames will be build with comma between thme */
+        /*      (typename1,typename2,...) and filters will be build with */
+        /*      bracets enclosinf the filters :(filter1)(filter2)... */
+        /*      propertynames are stored like (property1,property2)(property1)
+         */
+        /* --------------------------------------------------------------------
+         */
+        psIter = psGetFeature->psChild;
+        while (psIter != NULL) {
+          if (psIter->eType == CXT_Element &&
+              strcmp(psIter->pszValue, "Query") == 0) {
+            msWFSParseXMLQueryNode(psIter, wfsparams);
+          } else if (psIter->eType == CXT_Element &&
+                     strcmp(psIter->pszValue, "StoredQuery") == 0) {
+            int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
+            if (status != MS_SUCCESS) {
+              CPLDestroyXMLNode(psRoot);
+              msFree(pszSchemaLocation);
+              return status;
+            }
+            wfsparams->bHasPostStoredQuery = MS_TRUE;
+          }
+          psIter = psIter->psNext;
+        }
+
+        msWFSSimplifyPropertyNameAndFilter(wfsparams);
+      } /* end of GetFeature */
+
+      /* -------------------------------------------------------------------- */
+      /*      Parse the GetPropertyValue                                      */
+      /* -------------------------------------------------------------------- */
+      if (psGetPropertyValue) {
+        CPLXMLNode *psIter;
+
+        wfsparams->pszRequest = msStrdup("GetPropertyValue");
+
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "valueReference", NULL);
+        if (pszValue)
+          wfsparams->pszValueReference = msStrdup(pszValue);
+
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "resultType", NULL);
+        if (pszValue)
+          wfsparams->pszResultType = msStrdup(pszValue);
+
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "count", NULL);
+        if (pszValue)
+          wfsparams->nMaxFeatures = atoi(pszValue);
+
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "startIndex", NULL);
+        if (pszValue)
+          wfsparams->nStartIndex = atoi(pszValue);
+
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "outputFormat", NULL);
+        if (pszValue)
+          wfsparams->pszOutputFormat = msStrdup(pszValue);
+
+        psIter = psGetPropertyValue->psChild;
+        while (psIter != NULL) {
+          if (psIter->eType == CXT_Element &&
+              strcmp(psIter->pszValue, "Query") == 0) {
+            msWFSParseXMLQueryNode(psIter, wfsparams);
+            /* Just one is allowed for GetPropertyValue */
+            break;
+          } else if (psIter->eType == CXT_Element &&
+                     strcmp(psIter->pszValue, "StoredQuery") == 0) {
+            int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
+            if (status != MS_SUCCESS) {
+              CPLDestroyXMLNode(psRoot);
+              msFree(pszSchemaLocation);
+              return status;
+            }
+            wfsparams->bHasPostStoredQuery = MS_TRUE;
+            /* Just one is allowed for GetPropertyValue */
+            break;
+          }
+          psIter = psIter->psNext;
+        }
+
+        msWFSSimplifyPropertyNameAndFilter(wfsparams);
+      } /* end of GetPropertyValue */
+
+      /* -------------------------------------------------------------------- */
+      /*      Parse GetCapabilities.                                          */
+      /* -------------------------------------------------------------------- */
+      if (psGetCapabilities) {
+        CPLXMLNode *psAcceptVersions;
+        CPLXMLNode *psSections;
+
+        wfsparams->pszRequest = msStrdup("GetCapabilities");
+
+        pszValue = CPLGetXMLValue(psGetCapabilities, "updateSequence", NULL);
+        if (pszValue)
+          wfsparams->pszUpdateSequence = msStrdup(pszValue);
+
+        /* version is optional for the GetCapabilities. If not */
+        /* provided, set it. */
+        if (wfsparams->pszVersion == NULL)
+          wfsparams->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
+
+        psAcceptVersions = CPLGetXMLNode(psGetCapabilities, "AcceptVersions");
+        if (psAcceptVersions != NULL) {
+          CPLXMLNode *psIter = psAcceptVersions->psChild;
+          while (psIter != NULL) {
+            if (psIter->eType == CXT_Element &&
+                strcmp(psIter->pszValue, "Version") == 0) {
+              pszValue = CPLGetXMLValue(psIter, NULL, NULL);
+              if (pszValue) {
+                msWFSBuildParamList(&(wfsparams->pszAcceptVersions), pszValue,
+                                    ",");
+              }
+            }
+            psIter = psIter->psNext;
+          }
+        }
+
+        psSections = CPLGetXMLNode(psGetCapabilities, "Sections");
+        if (psSections != NULL) {
+          CPLXMLNode *psIter = psSections->psChild;
+          while (psIter != NULL) {
+            if (psIter->eType == CXT_Element &&
+                strcmp(psIter->pszValue, "Section") == 0) {
+              pszValue = CPLGetXMLValue(psIter, NULL, NULL);
+              if (pszValue) {
+                msWFSBuildParamList(&(wfsparams->pszSections), pszValue, ",");
+              }
+            }
+            psIter = psIter->psNext;
+          }
+        }
+      } /* end of GetCapabilites */
+      /* -------------------------------------------------------------------- */
+      /*      Parse DescribeFeatureType                                       */
+      /* -------------------------------------------------------------------- */
+      if (psDescribeFeature) {
+        CPLXMLNode *psIter;
+        wfsparams->pszRequest = msStrdup("DescribeFeatureType");
+
+        pszValue = CPLGetXMLValue(psDescribeFeature, "outputFormat", NULL);
+        if (pszValue)
+          wfsparams->pszOutputFormat = msStrdup(pszValue);
+
+        psIter = CPLGetXMLNode(psDescribeFeature, "TypeName");
+        if (psIter) {
+          /* free typname and filter. There may have been */
+          /* values if they were passed in the URL */
+          if (wfsparams->pszTypeName)
+            free(wfsparams->pszTypeName);
+          wfsparams->pszTypeName = NULL;
+
+          while (psIter) {
+            if (psIter->eType == CXT_Element &&
+                strcasecmp(psIter->pszValue, "TypeName") == 0) {
+              pszValue = CPLGetXMLValue(psIter, NULL, NULL);
+              if (pszValue) {
+                msWFSBuildParamList(&(wfsparams->pszTypeName), pszValue, ",");
+              }
+            }
+            psIter = psIter->psNext;
+          }
+        }
+
+      } /* end of DescibeFeatureType */
+
+      /* -------------------------------------------------------------------- */
+      /*      Parse the ListStoredQueries                                     */
+      /* -------------------------------------------------------------------- */
+      if (psListStoredQueries) {
+        wfsparams->pszRequest = msStrdup("ListStoredQueries");
+      } /* end of ListStoredQueries */
+
+      /* -------------------------------------------------------------------- */
+      /*      Parse the DescribeStoredQueries                                 */
+      /* -------------------------------------------------------------------- */
+      if (psDescribeStoredQueries) {
+        CPLXMLNode *psIter;
+
+        wfsparams->pszRequest = msStrdup("DescribeStoredQueries");
+
+        psIter = CPLGetXMLNode(psDescribeStoredQueries, "StoredQueryId");
+        while (psIter) {
+          if (psIter->eType == CXT_Element &&
+              strcasecmp(psIter->pszValue, "StoredQueryId") == 0) {
+            pszValue = CPLGetXMLValue(psIter, NULL, NULL);
+            if (pszValue) {
+              msWFSBuildParamList(&(wfsparams->pszStoredQueryId), pszValue,
+                                  ",");
+            }
+          }
+          psIter = psIter->psNext;
+        }
+      } /* end of DescribeStoredQueries */
+
+      CPLDestroyXMLNode(psRoot);
+    }
+
+#if defined(USE_LIBXML2)
+    {
+      const char *schema_location = NULL, *validate = NULL;
+
+      /*do we validate the xml ?*/
+      validate =
+          msOWSLookupMetadata(&(map->web.metadata), "FO", "validate_xml");
+      if (validate && strcasecmp(validate, "true") == 0 &&
+          (schema_location = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                                 "schemas_dir"))) {
+        if ((wfsparams->pszService &&
+             strcmp(wfsparams->pszService, "WFS") == 0) ||
+            force_wfs_mode) {
+          char *schema_file = NULL;
+          if (pszSchemaLocation != NULL &&
+              strstr(pszSchemaLocation, "wfs/1.0") != NULL) {
+            schema_file = msStringConcatenate(schema_file, schema_location);
+            schema_file = msStringConcatenate(
+                schema_file, MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION);
+          } else if (pszSchemaLocation != NULL &&
+                     strstr(pszSchemaLocation, "wfs/1.1") != NULL) {
+            schema_file = msStringConcatenate(schema_file, schema_location);
+            schema_file = msStringConcatenate(
+                schema_file, MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION);
+          } else if (pszSchemaLocation != NULL &&
+                     strstr(pszSchemaLocation, "wfs/2.0") != NULL) {
+            schema_file = msStringConcatenate(schema_file, schema_location);
+            schema_file = msStringConcatenate(
+                schema_file, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+          }
+          if (schema_file != NULL) {
+            if (msOWSSchemaValidation(schema_file, request->postrequest) != 0) {
+              msSetError(MS_WFSERR, "Invalid POST request.  XML is not valid",
+                         "msWFSParseRequest()");
+              msFree(schema_file);
+              return msWFSException(map, "request", "InvalidRequest", NULL);
+            }
+            msFree(schema_file);
+          }
+        }
+      }
+    }
+#endif
+
+    msFree(pszSchemaLocation);
+  }
+
+#endif
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapwfs11.cpp 8.2.0~beta1-1~exp1/src/mapwfs11.cpp
--- 8.0.1-5/src/mapwfs11.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwfs11.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,588 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC WFS 1.1.0 implementation. This file holds some WFS 1.1.0
+ *           specific functions but other parts are still implemented in
+ *mapwfs.c. Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2008, Y. Assefa, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#if defined(USE_WFS_SVR) && defined(USE_LIBXML2)
+#include "maplibxml2.h"
+#include "mapowscommon.h"
+#include "mapogcfilter.h"
+
+#include <string>
+
+template <class T> inline void IGNORE_RET_VAL(T) {}
+
+/************************************************************************/
+/*                          msWFSException11()                          */
+/************************************************************************/
+
+int msWFSException11(mapObj *map, const char *locator,
+                     const char *exceptionCode, const char *version) {
+  int size = 0;
+  char *errorString = NULL;
+  char *schemasLocation = NULL;
+
+  xmlDocPtr psDoc = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
+
+  if (version == NULL)
+    version = "1.1.0";
+
+  psNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows", BAD_CAST "ows");
+
+  errorString = msGetErrorString("\n");
+  schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_0_0, schemasLocation, version,
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows", BAD_CAST "ows");
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+
+  msIO_printf("%s", buffer);
+
+  /*free buffer and the document */
+  free(errorString);
+  free(schemasLocation);
+  xmlFree(buffer);
+  xmlFreeDoc(psDoc);
+  xmlFreeNs(psNsOws);
+
+  /* clear error since we have already reported it */
+  msResetErrorList();
+
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                       msWFSAddMetadataURL                            */
+/************************************************************************/
+
+static void msWFSAddMetadataURL(layerObj *lp, int nWFSVersion,
+                                const std::string &radix,
+                                xmlNodePtr psRootNode) {
+  const char *value =
+      msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_href").c_str());
+
+  if (value) {
+    if (nWFSVersion >= OWS_2_0_0) {
+      xmlNodePtr psNode =
+          xmlNewChild(psRootNode, NULL, BAD_CAST "MetadataURL", NULL);
+      xmlNewProp(psNode, BAD_CAST "xlink:href", BAD_CAST value);
+
+      value = msOWSLookupMetadata(&(lp->metadata), "FO",
+                                  (radix + "_about").c_str());
+      if (value != NULL)
+        xmlNewProp(psNode, BAD_CAST "about", BAD_CAST value);
+    } else {
+      xmlNodePtr psNode = xmlNewTextChild(
+          psRootNode, NULL, BAD_CAST "MetadataURL", BAD_CAST value);
+
+      value = msOWSLookupMetadata(&(lp->metadata), "FO",
+                                  (radix + "_format").c_str());
+
+      if (!value)
+        value = "text/html"; /* default */
+
+      xmlNewProp(psNode, BAD_CAST "format", BAD_CAST value);
+
+      value =
+          msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_type").c_str());
+
+      if (!value)
+        value = "FGDC"; /* default */
+
+      xmlNewProp(psNode, BAD_CAST "type", BAD_CAST value);
+    }
+  }
+}
+
+/************************************************************************/
+/*                            msWFSDumpLayer11                          */
+/************************************************************************/
+xmlNodePtr msWFSDumpLayer11(mapObj *map, layerObj *lp, xmlNsPtr psNsOws,
+                            int nWFSVersion, const char *validate_language,
+                            char *script_url) {
+  rectObj ext;
+
+  xmlNodePtr psRootNode, psNode;
+  const char *value = NULL;
+  char *valueToFree;
+  int i = 0;
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "FeatureType");
+
+  /* add namespace to layer name */
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
+
+  /* FIXME? Should probably be applied to WFS 1.1 as well, but the addition */
+  /* of the prefix can be disruptive for clients */
+  if (value == NULL && nWFSVersion >= OWS_2_0_0)
+    value = MS_DEFAULT_NAMESPACE_PREFIX;
+
+  if (value) {
+    int n = strlen(value) + strlen(lp->name) + 1 + 1;
+    valueToFree = (char *)msSmallMalloc(n);
+    snprintf(valueToFree, n, "%s:%s", value, lp->name);
+
+    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name",
+                             BAD_CAST valueToFree);
+    msFree(valueToFree);
+  } else {
+    psNode =
+        xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name", BAD_CAST lp->name);
+  }
+
+  if (lp->name && strlen(lp->name) > 0 &&
+      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0]))) {
+    char szTmp[512];
+    snprintf(szTmp, sizeof(szTmp),
+             "WARNING: The layer name '%s' might contain spaces or "
+             "invalid characters or may start with a number. This could lead "
+             "to potential problems",
+             lp->name);
+    xmlAddSibling(psNode, xmlNewComment(BAD_CAST szTmp));
+  }
+
+  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "title",
+                                          validate_language);
+  if (!value)
+    value = (const char *)lp->name;
+
+  psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Title", BAD_CAST value);
+
+  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "abstract",
+                                          validate_language);
+  if (value)
+    psNode =
+        xmlNewTextChild(psRootNode, NULL, BAD_CAST "Abstract", BAD_CAST value);
+
+  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "keywordlist",
+                                          validate_language);
+
+  if (value)
+    msLibXml2GenerateList(
+        xmlNewChild(psRootNode, psNsOws, BAD_CAST "Keywords", NULL), NULL,
+        "Keyword", value, ',');
+
+  /*support DefaultSRS and OtherSRS*/
+  valueToFree =
+      msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FO", MS_FALSE);
+  if (!valueToFree)
+    valueToFree =
+        msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", MS_FALSE);
+
+  if (valueToFree) {
+    int n = 0;
+    char **tokens = msStringSplit(valueToFree, ' ', &n);
+    if (tokens && n > 0) {
+      if (nWFSVersion == OWS_1_1_0)
+        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultSRS",
+                                       BAD_CAST tokens[0]));
+      else
+        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultCRS",
+                                       BAD_CAST tokens[0]));
+      for (i = 1; i < n; i++) {
+        if (nWFSVersion == OWS_1_1_0)
+          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherSRS",
+                                         BAD_CAST tokens[i]));
+        else
+          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherCRS",
+                                         BAD_CAST tokens[i]));
+      }
+    }
+    msFreeCharArray(tokens, n);
+  } else
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Mandatory mapfile parameter: (at least one of) "
+                      "MAP.PROJECTION, LAYER.PROJECTION or wfs/ows_srs "
+                      "metadata was missing in this context."));
+
+  free(valueToFree);
+  valueToFree = NULL;
+
+  /*TODO: adevertize only gml3?*/
+  psNode = xmlNewNode(NULL, BAD_CAST "OutputFormats");
+  xmlAddChild(psRootNode, psNode);
+
+  {
+    char *formats_list = msWFSGetOutputFormatList(map, lp, nWFSVersion);
+    int iformat;
+    int n = 0;
+    char **tokens = msStringSplit(formats_list, ',', &n);
+
+    for (iformat = 0; iformat < n; iformat++)
+      xmlNewTextChild(psNode, NULL, BAD_CAST "Format",
+                      BAD_CAST tokens[iformat]);
+    msFree(formats_list);
+    msFreeCharArray(tokens, n);
+  }
+
+  /*bbox*/
+  if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
+    /*convert to latlong*/
+    if (lp->projection.numargs > 0)
+      msOWSProjectToWGS84(&lp->projection, &ext);
+    else
+      msOWSProjectToWGS84(&map->projection, &ext);
+
+    xmlAddChild(psRootNode,
+                msOWSCommonWGS84BoundingBox(psNsOws, 2, ext.minx, ext.miny,
+                                            ext.maxx, ext.maxy));
+  } else {
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(
+            BAD_CAST "WARNING: Optional WGS84BoundingBox could not be "
+                     "established for this layer.  Consider setting the EXTENT "
+                     "in the LAYER object, or wfs_extent metadata. Also check "
+                     "that your data exists in the DATA statement"));
+  }
+
+  const char *metadataurl_list =
+      msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
+  if (metadataurl_list) {
+    int ntokens = 0;
+    char **tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
+      std::string key("metadataurl_");
+      key += tokens[i];
+      msWFSAddMetadataURL(lp, nWFSVersion, key, psRootNode);
+    }
+    msFreeCharArray(tokens, ntokens);
+  } else {
+    if (!msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
+      msMetadataSetGetMetadataURL(lp, script_url);
+
+    msWFSAddMetadataURL(lp, nWFSVersion, "metadataurl", psRootNode);
+  }
+
+  return psRootNode;
+}
+
+/************************************************************************/
+/*                          msWFSGetCapabilities11                      */
+/*                                                                      */
+/*      Return the capabilities document for wfs 1.1.0                  */
+/************************************************************************/
+int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode, psMainNode, psNode, psFtNode;
+  const char *updatesequence = NULL;
+  xmlNsPtr psNsOws, psNsXLink, psNsOgc;
+  char *schemalocation = NULL;
+  char *xsi_schemaLocation = NULL;
+  const char *user_namespace_prefix = NULL;
+  const char *user_namespace_uri = NULL;
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
+
+  char *script_url = NULL, *formats_list;
+  const char *value = NULL;
+
+  xmlChar *buffer = NULL;
+  int size = 0, i;
+  msIOContext *context = NULL;
+
+  int ows_version = OWS_1_0_0;
+  int ret;
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle updatesequence                                           */
+  /* -------------------------------------------------------------------- */
+  ret = msWFSHandleUpdateSequence(map, params, "msWFSGetCapabilities11()");
+  if (ret != MS_SUCCESS)
+    return ret;
+
+  /* -------------------------------------------------------------------- */
+  /*      Create document.                                                */
+  /* -------------------------------------------------------------------- */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "WFS_Capabilities");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* -------------------------------------------------------------------- */
+  /*      Name spaces                                                     */
+  /* -------------------------------------------------------------------- */
+  /*default name space*/
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST "http://www.opengis.net/wfs");
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml",
+                    BAD_CAST "gml"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wfs",
+                    BAD_CAST "wfs"));
+
+  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psNsXLink =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
+  if (value)
+    user_namespace_uri = value;
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
+  if (value)
+    user_namespace_prefix = value;
+  if (user_namespace_prefix != NULL &&
+      msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        user_namespace_prefix);
+  else
+    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri,
+             BAD_CAST user_namespace_prefix);
+
+  /* any additional namespaces */
+  namespaceList = msGMLGetNamespaces(&(map->web), "G");
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri) {
+      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri,
+               BAD_CAST namespaceList->namespaces[i].prefix);
+    }
+  }
+  msGMLFreeNamespaces(namespaceList);
+
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion);
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+
+  if (updatesequence)
+    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
+
+  /*schema*/
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStrdup("http://www.opengis.net/wfs");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/wfs/1.1.0/wfs.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+
+  /* -------------------------------------------------------------------- */
+  /*      Service metadata.                                               */
+  /* -------------------------------------------------------------------- */
+
+  xmlAddChild(psRootNode,
+              msOWSCommonServiceIdentification(psNsOws, map, "OGC WFS",
+                                               params->pszVersion, "FO", NULL));
+
+  /*service provider*/
+  xmlAddChild(psRootNode,
+              msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "FO", NULL));
+
+  /*operation metadata */
+  if ((script_url = msOWSGetOnlineResource(map, "FO", "onlineresource", req)) ==
+      NULL) {
+    msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities11()");
+    return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            params->pszVersion);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Operations metadata.                                            */
+  /* -------------------------------------------------------------------- */
+  psMainNode = xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psNsOws));
+
+  /* -------------------------------------------------------------------- */
+  /*      GetCapabilities                                                 */
+  /* -------------------------------------------------------------------- */
+  psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                       psNsOws, psNsXLink, "GetCapabilities",
+                                       OWS_METHOD_GETPOST, script_url));
+
+  xmlAddChild(psMainNode, psNode);
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "service", "WFS"));
+  /*accept version*/
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "AcceptVersions",
+                          "1.0.0,1.1.0"));
+  /*format*/
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "AcceptFormats",
+                          "text/xml"));
+
+  /* -------------------------------------------------------------------- */
+  /*      DescribeFeatureType                                             */
+  /* -------------------------------------------------------------------- */
+  if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE)) {
+    psNode =
+        xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                    psNsOws, psNsXLink, "DescribeFeatureType",
+                                    OWS_METHOD_GETPOST, script_url));
+    xmlAddChild(psMainNode, psNode);
+
+    /*output format*/
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "outputFormat",
+                            "XMLSCHEMA,text/xml; subtype=gml/2.1.2,text/xml; "
+                            "subtype=gml/3.1.1"));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      GetFeature                                                      */
+  /* -------------------------------------------------------------------- */
+  if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
+
+    psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                         psNsOws, psNsXLink, "GetFeature",
+                                         OWS_METHOD_GETPOST, script_url));
+    xmlAddChild(psMainNode, psNode);
+
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "resultType",
+                            "results,hits"));
+
+    formats_list = msWFSGetOutputFormatList(map, NULL, OWS_1_1_0);
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "outputFormat",
+                            formats_list));
+    msFree(formats_list);
+
+    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
+
+    if (value) {
+      xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(
+                                  ows_version, psNsOws, "Constraint",
+                                  "DefaultMaxFeatures", (char *)value));
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      FeatureTypeList                                                 */
+  /* -------------------------------------------------------------------- */
+
+  psFtNode = xmlNewNode(NULL, BAD_CAST "FeatureTypeList");
+  xmlAddChild(psRootNode, psFtNode);
+  psNode = xmlNewChild(psFtNode, NULL, BAD_CAST "Operations", NULL);
+  xmlNewChild(psNode, NULL, BAD_CAST "Operation", BAD_CAST "Query");
+
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp;
+    lp = GET_LAYER(map, i);
+
+    if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
+      continue;
+
+    if (msWFSIsLayerSupported(lp))
+      xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_1_1_0, NULL,
+                                             script_url));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Filter capabilities.                                            */
+  /* -------------------------------------------------------------------- */
+
+  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+  xmlAddChild(psRootNode, FLTGetCapabilities(psNsOgc, psNsOgc, MS_FALSE));
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document.                                         */
+  /* -------------------------------------------------------------------- */
+
+  if (msIO_needBinaryStdout() == MS_FAILURE)
+    return MS_FAILURE;
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  context = msIO_getHandler(stdout);
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+  msIO_contextWrite(context, buffer, size);
+  xmlFree(buffer);
+
+  /*free buffer and the document */
+  /*xmlFree(buffer);*/
+  xmlFreeDoc(psDoc);
+  xmlFreeNs(psNsOgc);
+
+  free(script_url);
+  free(xsi_schemaLocation);
+  free(schemalocation);
+
+  xmlCleanupParser();
+
+  return (MS_SUCCESS);
+}
+
+#endif /*defined(USE_WFS_SVR) && defined(USE_LIBXML2)*/
+
+#if defined(USE_WFS_SVR) && !defined(USE_LIBXML2)
+
+int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request)
+
+{
+  msSetError(MS_WFSERR,
+             "WFS 1.1 request made, but mapserver requires libxml2 for WFS 1.1 "
+             "services and this is not configured.",
+             "msWFSGetCapabilities11()");
+
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
+}
+
+int msWFSException11(mapObj *map, const char *locator,
+                     const char *exceptionCode, const char *version) {
+  /* fallback to reporting using 1.0 style exceptions. */
+  return msWFSException(map, locator, exceptionCode, "1.0.0");
+}
+
+#endif /* defined(USE_WFS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/src/mapwfs20.c 8.2.0~beta1-1~exp1/src/mapwfs20.c
--- 8.0.1-5/src/mapwfs20.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwfs20.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1531 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OGC WFS 2.0.0 implementation. This file holds some WFS 2.0.0
+ *           specific functions but other parts are still implemented in
+ *mapwfs.c. Author:   Even Rouault
+ *
+ **********************************************************************
+ * Copyright (c) 2013, Even Rouault
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "mapows.h"
+
+#if defined(USE_WFS_SVR) && defined(USE_LIBXML2)
+#include "maplibxml2.h"
+#include "mapowscommon.h"
+#include "mapogcfilter.h"
+
+#define MS_OWS_11_NAMESPACE_PREFIX MS_OWSCOMMON_OWS_NAMESPACE_PREFIX
+#define MS_OWS_11_NAMESPACE_URI MS_OWSCOMMON_OWS_110_NAMESPACE_URI
+
+#define URN_GET_FEATURE_BY_ID "urn:ogc:def:query:OGC-WFS::GetFeatureById"
+
+#define GET_FEATURE_BY_ID                                                      \
+  "<StoredQueryDescription id=\"" URN_GET_FEATURE_BY_ID "\">"                  \
+  "<Title>Get feature by identifier</Title>"                                   \
+  "<Abstract>Returns the single feature whose value is equal to the "          \
+  "specified value of the ID argument</Abstract>"                              \
+  "<Parameter name=\"ID\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" "      \
+  "type=\"xs:string\"/>"                                                       \
+  "<QueryExpressionText isPrivate=\"true\" "                                   \
+  "language=\"urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression\" "       \
+  "returnFeatureTypes=\"\">"                                                   \
+  "<Query xmlns:fes=\"http://www.opengis.net/fes/2.0\" typeNames=\"?\">"       \
+  "<fes:Filter><fes:ResourceId rid=\"${ID}\"/></fes:Filter>"                   \
+  "</Query>"                                                                   \
+  "</QueryExpressionText>"                                                     \
+  "</StoredQueryDescription>"
+
+/************************************************************************/
+/*                          msWFSException20()                          */
+/************************************************************************/
+
+int msWFSException20(mapObj *map, const char *locator,
+                     const char *exceptionCode) {
+  int size = 0;
+  char *errorString = NULL;
+
+  xmlDocPtr psDoc = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
+  const char *status = NULL;
+
+  psNsOws = xmlNewNs(NULL, BAD_CAST MS_OWS_11_NAMESPACE_URI,
+                     BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
+
+  errorString = msGetErrorString("\n");
+
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_1_0, msOWSGetSchemasLocation(map), "2.0.0",
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  xmlNewNs(psRootNode, BAD_CAST MS_OWS_11_NAMESPACE_URI,
+           BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
+
+  /* Table D.2 OGC 09-025r1 - For CITE compliance */
+  if (EQUAL(exceptionCode, MS_OWS_ERROR_OPERATION_NOT_SUPPORTED) ||
+      EQUAL(exceptionCode, MS_OWS_ERROR_OPTION_NOT_SUPPORTED)) {
+    status = "400 Not Implemented";
+  } else if (EQUAL(exceptionCode, MS_OWS_ERROR_MISSING_PARAMETER_VALUE) ||
+             EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_PARAMETER_VALUE) ||
+             EQUAL(exceptionCode, MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED) ||
+             EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE)) {
+    status = "400 Bad request";
+  } else if (EQUAL(exceptionCode, MS_WFS_ERROR_OPERATION_PROCESSING_FAILED)) {
+    status = "403 Server processing failed";
+  } else if (EQUAL(exceptionCode, MS_OWS_ERROR_NOT_FOUND)) {
+    status = "404 Not Found";
+  } else if (EQUAL(exceptionCode, MS_OWS_ERROR_NO_APPLICABLE_CODE)) {
+    status = "400 Internal Server Error";
+  }
+
+  if (status != NULL) {
+    msIO_setHeader("Status", "%s", status);
+  }
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
+
+  msIO_printf("%s", buffer);
+
+  /*free buffer and the document */
+  free(errorString);
+  xmlFree(buffer);
+  xmlFreeDoc(psDoc);
+  xmlFreeNs(psNsOws);
+
+  /* clear error since we have already reported it */
+  msResetErrorList();
+
+  return MS_FAILURE;
+}
+
+/************************************************************************/
+/*                          msWFSIncludeSection                         */
+/************************************************************************/
+static int msWFSIncludeSection(wfsParamsObj *params, const char *pszSection) {
+  int i;
+  if (params->pszSections == NULL)
+    return TRUE;
+  for (i = 0; params->pszSections[i] != '\0'; i++) {
+    if (strncasecmp(params->pszSections + i, "All", strlen("All")) == 0)
+      return TRUE;
+    if (strncasecmp(params->pszSections + i, pszSection, strlen(pszSection)) ==
+        0)
+      return TRUE;
+  }
+  return FALSE;
+}
+
+/************************************************************************/
+/*                       msWFSConstraintDefaultValue                    */
+/************************************************************************/
+
+static xmlNodePtr msWFSConstraintDefaultValue(xmlNsPtr psNs, xmlNsPtr psNsOws,
+                                              const char *name,
+                                              const char *value) {
+  xmlNodePtr psRootNode = NULL;
+
+  psRootNode = xmlNewNode(psNs, BAD_CAST "Constraint");
+
+  xmlNewProp(psRootNode, BAD_CAST "name", BAD_CAST name);
+
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "NoValues", NULL);
+  xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "DefaultValue", BAD_CAST value);
+
+  return psRootNode;
+}
+
+/************************************************************************/
+/*                              msWFSOperator                           */
+/************************************************************************/
+
+static xmlNodePtr msWFSOperator(xmlNsPtr psNsFES, const char *pszOperatorType,
+                                const char *pszOperator) {
+  xmlNodePtr psNode = xmlNewNode(psNsFES, BAD_CAST pszOperatorType);
+  xmlNewProp(psNode, BAD_CAST "name", BAD_CAST pszOperator);
+  return psNode;
+}
+
+/************************************************************************/
+/*                       msWFS20FilterCapabilities                      */
+/************************************************************************/
+
+static xmlNodePtr msWFS20FilterCapabilities(xmlNsPtr psNsFES, xmlNsPtr psNsOws,
+                                            int bImplementsSorting) {
+  xmlNodePtr psRootNode = NULL, psNode = NULL, psSubNode = NULL;
+
+  psRootNode = xmlNewNode(psNsFES, BAD_CAST "Filter_Capabilities");
+
+  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Conformance", NULL);
+
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsQuery", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsAdHocQuery", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsFunctions", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsResourceId", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsMinStandardFilter",
+                                                  "TRUE"));
+  xmlAddChild(psNode,
+              msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                          "ImplementsStandardFilter", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsMinSpatialFilter",
+                                                  "TRUE"));
+  xmlAddChild(psNode,
+              msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                          "ImplementsSpatialFilter", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsMinTemporalFilter",
+                                                  "TRUE"));
+  xmlAddChild(psNode,
+              msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                          "ImplementsTemporalFilter", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsVersionNav", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsSorting",
+                          (bImplementsSorting) ? "TRUE" : "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsExtendedOperators",
+                                                  "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsMinimumXPath", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsSchemaElementFunc",
+                                                  "FALSE"));
+
+  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Id_Capabilities", NULL);
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "ResourceIdentifier", NULL);
+  xmlNewProp(psSubNode, BAD_CAST "name", BAD_CAST "fes:ResourceId");
+
+  psNode =
+      xmlNewChild(psRootNode, psNsFES, BAD_CAST "Scalar_Capabilities", NULL);
+  xmlNewChild(psNode, psNsFES, BAD_CAST "LogicalOperators", NULL);
+  psNode = xmlNewChild(psNode, psNsFES, BAD_CAST "ComparisonOperators", NULL);
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsEqualTo"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsNotEqualTo"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsLessThan"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsGreaterThan"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsLessThanOrEqualTo"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsGreaterThanOrEqualTo"));
+  xmlAddChild(psNode,
+              msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLike"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsBetween"));
+  /* Missing: PropertyIsNull, PropertyIsNil */
+
+  psNode =
+      xmlNewChild(psRootNode, psNsFES, BAD_CAST "Spatial_Capabilities", NULL);
+
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "GeometryOperands", NULL);
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Point"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPoint"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:LineString"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiLineString"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Curve"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiCurve"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Polygon"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPolygon"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Surface"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiSurface"));
+  /* xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand",
+   * "gml:MultiGeometry")); */
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Box"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Envelope"));
+
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "SpatialOperators", NULL);
+#ifdef USE_GEOS
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Equals"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Disjoint"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Touches"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Within"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Overlaps"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Crosses"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "SpatialOperator", "Intersects"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Contains"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "DWithin"));
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Beyond"));
+#endif
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "BBOX"));
+
+  psNode =
+      xmlNewChild(psRootNode, psNsFES, BAD_CAST "Temporal_Capabilities", NULL);
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperands", NULL);
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "TemporalOperand", "gml:TimePeriod"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "TemporalOperand", "gml:TimeInstant"));
+
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperators", NULL);
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperator", "During"));
+
+  return psRootNode;
+}
+
+/************************************************************************/
+/*                          msXMLStripIndentation                       */
+/************************************************************************/
+
+static void msXMLStripIndentation(char *ptr) {
+  /* Remove spaces between > and < to get properly indented result */
+  char *afterLastClosingBracket = NULL;
+  if (*ptr == ' ')
+    afterLastClosingBracket = ptr;
+  while (*ptr != '\0') {
+    if (*ptr == '<' && afterLastClosingBracket != NULL) {
+      memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
+      ptr = afterLastClosingBracket;
+    } else if (*ptr == '>') {
+      afterLastClosingBracket = ptr + 1;
+    } else if (*ptr != ' ' && *ptr != '\n')
+      afterLastClosingBracket = NULL;
+    ptr++;
+  }
+}
+
+/************************************************************************/
+/*                          msWFSAddInspireDSID                         */
+/************************************************************************/
+
+static void msWFSAddInspireDSID(mapObj *map, xmlNsPtr psNsInspireDls,
+                                xmlNsPtr psNsInspireCommon,
+                                xmlNodePtr pDlsExtendedCapabilities) {
+  const char *dsid_code =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_code");
+  const char *dsid_ns =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_ns");
+  if (dsid_code == NULL) {
+    xmlAddChild(
+        pDlsExtendedCapabilities,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Required metadata \"inspire_dsid_code\" missing"));
+  } else {
+    int ntokensCode = 0, ntokensNS = 0;
+    char **tokensCode;
+    char **tokensNS = NULL;
+    int i;
+
+    tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
+    if (dsid_ns != NULL)
+      tokensNS =
+          msStringSplitComplex(dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
+    if (ntokensNS > 0 && ntokensNS != ntokensCode) {
+      xmlAddChild(
+          pDlsExtendedCapabilities,
+          xmlNewComment(
+              BAD_CAST
+              "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not "
+              "the same number of elements. Ignoring inspire_dsid_ns"));
+      msFreeCharArray(tokensNS, ntokensNS);
+      tokensNS = NULL;
+      ntokensNS = 0;
+    }
+    for (i = 0; i < ntokensCode; i++) {
+      xmlNodePtr pSDSI =
+          xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
+      xmlAddChild(pDlsExtendedCapabilities, pSDSI);
+      xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code",
+                      BAD_CAST tokensCode[i]);
+      if (ntokensNS > 0 && tokensNS[i][0] != '\0')
+        xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace",
+                        BAD_CAST tokensNS[i]);
+    }
+    msFreeCharArray(tokensCode, ntokensCode);
+    if (tokensNS)
+      msFreeCharArray(tokensNS, ntokensNS);
+  }
+}
+
+/************************************************************************/
+/*                          msWFSGetCapabilities20                      */
+/*                                                                      */
+/*      Return the capabilities document for WFS 2.0.0                  */
+/************************************************************************/
+int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode, psMainNode, psNode, psFtNode = NULL;
+  const char *updatesequence = NULL;
+  xmlNsPtr psNsOws, psNsXLink;
+  xmlNsPtr psNsFES = NULL;
+  xmlNsPtr psNsInspireCommon = NULL;
+  xmlNsPtr psNsInspireDls = NULL;
+  xmlDocPtr pInspireTmpDoc = NULL;
+  char *xsi_schemaLocation = NULL;
+  const char *user_namespace_prefix = NULL;
+  const char *user_namespace_uri = NULL;
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
+
+  char *script_url = NULL, *formats_list;
+  const char *value = NULL;
+
+  xmlChar *buffer = NULL;
+  int size = 0, i;
+  msIOContext *context = NULL;
+
+  int ows_version = OWS_1_1_0;
+  int ret;
+
+  char *validated_language;
+  int bImplementsSorting = MS_FALSE;
+
+  /* -------------------------------------------------------------------- */
+  /*      Handle updatesequence                                           */
+  /* -------------------------------------------------------------------- */
+  ret = msWFSHandleUpdateSequence(map, params, "msWFSGetCapabilities20()");
+  if (ret != MS_SUCCESS)
+    return ret;
+
+  validated_language = msOWSGetLanguageFromList(map, "FO", params->pszLanguage);
+
+  /* -------------------------------------------------------------------- */
+  /*      Create document.                                                */
+  /* -------------------------------------------------------------------- */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "WFS_Capabilities");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* -------------------------------------------------------------------- */
+  /*      Name spaces                                                     */
+  /* -------------------------------------------------------------------- */
+
+  /*default name space*/
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
+
+  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psNsXLink =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX);
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
+  if (value)
+    user_namespace_uri = value;
+  else
+    user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
+  if (value)
+    user_namespace_prefix = value;
+  else
+    user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+
+  if (user_namespace_prefix != NULL &&
+      msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        user_namespace_prefix);
+  else
+    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri,
+             BAD_CAST user_namespace_prefix);
+
+  /* any additional namespaces */
+  namespaceList = msGMLGetNamespaces(&(map->web), "G");
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri) {
+      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri,
+               BAD_CAST namespaceList->namespaces[i].prefix);
+    }
+  }
+  msGMLFreeNamespaces(namespaceList);
+
+  if (msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_capabilities")) {
+    psNsInspireCommon =
+        xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI,
+                 BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
+    psNsInspireDls = xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI,
+                              BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
+  }
+
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion);
+
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+
+  if (updatesequence)
+    xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
+
+  /*schema*/
+  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+
+  if (psNsInspireDls != NULL) {
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation =
+        msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_NAMESPACE_URI);
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation = msStringConcatenate(
+        xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
+    xsi_schemaLocation =
+        msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                             MS_INSPIRE_COMMON_NAMESPACE_URI);
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation = msStringConcatenate(
+        xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                             MS_INSPIRE_COMMON_SCHEMA_LOCATION);
+  }
+
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+  free(xsi_schemaLocation);
+
+  /* -------------------------------------------------------------------- */
+  /*      Service metadata.                                               */
+  /* -------------------------------------------------------------------- */
+
+  /* TODO? : also add 1.1.0 and 1.0.0 as extra <ows:ServiceTypeVersion>. The OWS
+   */
+  /* schema would suggest to do so, and also the example */
+  /* http://schemas.opengis.net/wfs/2.0/examples/GetCapabilities/GetCapabilities_Res_01.xml
+   */
+  /* and Deegree too, but GeoServer also only lists the current version. */
+  if (msWFSIncludeSection(params, "ServiceIdentification")) {
+    xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
+                                psNsOws, map, "WFS", params->pszVersion, "FO",
+                                validated_language));
+  }
+
+  /*service provider*/
+  if (msWFSIncludeSection(params, "ServiceProvider")) {
+    xmlAddChild(psRootNode,
+                msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "FO",
+                                           validated_language));
+  }
+
+  /*operation metadata */
+  if (msWFSIncludeSection(params, "OperationsMetadata")) {
+    if ((script_url = msOWSGetOnlineResource2(map, "FO", "onlineresource", req,
+                                              validated_language)) == NULL) {
+      msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities20()");
+      return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                              params->pszVersion);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      Operations metadata.                                            */
+    /* -------------------------------------------------------------------- */
+    psMainNode =
+        xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psNsOws));
+
+    /* -------------------------------------------------------------------- */
+    /*      GetCapabilities                                                 */
+    /* -------------------------------------------------------------------- */
+    psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                         psNsOws, psNsXLink, "GetCapabilities",
+                                         OWS_METHOD_GETPOST, script_url));
+
+    xmlAddChild(psMainNode, psNode);
+
+    /*accept version*/
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "AcceptVersions",
+                            "2.0.0,1.1.0,1.0.0"));
+    /*format*/
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "AcceptFormats",
+                            "text/xml"));
+    /*sections*/
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "Sections",
+                    "ServiceIdentification,ServiceProvider,OperationsMetadata,"
+                    "FeatureTypeList,Filter_Capabilities"));
+
+    /* -------------------------------------------------------------------- */
+    /*      DescribeFeatureType                                             */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE)) {
+      psNode =
+          xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                      psNsOws, psNsXLink, "DescribeFeatureType",
+                                      OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+
+      /*output format*/
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psNsOws, "Parameter", "outputFormat",
+                              "application/gml+xml; version=3.2,"
+                              "text/xml; subtype=gml/3.2.1,"
+                              "text/xml; subtype=gml/3.1.1,"
+                              "text/xml; subtype=gml/2.1.2"));
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      GetFeature                                                      */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
+
+      psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                           psNsOws, psNsXLink, "GetFeature",
+                                           OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+
+      formats_list = msWFSGetOutputFormatList(map, NULL, OWS_2_0_0);
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psNsOws, "Parameter", "outputFormat",
+                              formats_list));
+      msFree(formats_list);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      GetPropertyValue                                                */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "F", "GetPropertyValue", MS_TRUE)) {
+
+      psNode =
+          xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                      psNsOws, psNsXLink, "GetPropertyValue",
+                                      OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+
+      /* Only advertize built-in GML formats for GetPropertyValue. Not sure */
+      /* it makes sense to advertize OGR formats. */
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psNsOws, "Parameter", "outputFormat",
+                              "application/gml+xml; version=3.2,"
+                              "text/xml; subtype=gml/3.2.1,"
+                              "text/xml; subtype=gml/3.1.1,"
+                              "text/xml; subtype=gml/2.1.2"));
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      ListStoredQueries                                               */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "F", "ListStoredQueries", MS_TRUE)) {
+
+      psNode =
+          xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                      psNsOws, psNsXLink, "ListStoredQueries",
+                                      OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      DescribeStoredQueries                                           */
+    /* -------------------------------------------------------------------- */
+    if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeStoredQueries",
+                              MS_TRUE)) {
+
+      psNode = xmlAddChild(psMainNode,
+                           msOWSCommonOperationsMetadataOperation(
+                               psNsOws, psNsXLink, "DescribeStoredQueries",
+                               OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+    }
+
+    xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(
+                                ows_version, psNsOws, "Parameter", "version",
+                                "2.0.0,1.1.0,1.0.0"));
+
+    /* Conformance declaration */
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsBasicWFS", "TRUE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsTransactionalWFS", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsLockingWFS", "FALSE"));
+    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                                        "KVPEncoding", "TRUE"));
+    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                                        "XMLEncoding", "TRUE"));
+    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(
+                                psNsOws, psNsOws, "SOAPEncoding", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsInheritance", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsRemoteResolve", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsResultPaging", "TRUE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsStandardJoins", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsSpatialJoins", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsTemporalJoins", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsFeatureVersioning", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ManageStoredQueries", "FALSE"));
+
+    /* Capacity declaration */
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "PagingIsTransactionSafe", "FALSE"));
+
+    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
+    if (value) {
+      xmlAddChild(psMainNode, msWFSConstraintDefaultValue(
+                                  psNsOws, psNsOws, "CountDefault", value));
+    }
+
+    xmlAddChild(psMainNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Constraint", "QueryExpressions",
+                    "wfs:Query,wfs:StoredQuery"));
+
+    /* Add Inspire Download Services extended capabilities */
+    if (psNsInspireDls != NULL) {
+      msIOContext *old_context;
+      msIOContext *new_context;
+      msIOBuffer *buffer;
+      xmlNodePtr pRoot;
+      xmlNodePtr pOWSExtendedCapabilities;
+      xmlNodePtr pDlsExtendedCapabilities;
+      xmlNodePtr pChild;
+
+      old_context = msIO_pushStdoutToBufferAndGetOldContext();
+      msOWSPrintInspireCommonExtendedCapabilities(
+          stdout, map, "FO", OWS_WARN, "foo",
+          "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
+          "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
+          "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"",
+          validated_language, OWS_WFS);
+
+      new_context = msIO_getHandler(stdout);
+      buffer = (msIOBuffer *)new_context->cbData;
+
+      /* Remove spaces between > and < to get properly indented result */
+      msXMLStripIndentation((char *)buffer->data);
+
+      pInspireTmpDoc = xmlParseDoc((const xmlChar *)buffer->data);
+      pRoot = xmlDocGetRootElement(pInspireTmpDoc);
+      xmlReconciliateNs(psDoc, pRoot);
+
+      pOWSExtendedCapabilities =
+          xmlNewNode(psNsOws, BAD_CAST "ExtendedCapabilities");
+      xmlAddChild(psMainNode, pOWSExtendedCapabilities);
+
+      pDlsExtendedCapabilities =
+          xmlNewNode(psNsInspireDls, BAD_CAST "ExtendedCapabilities");
+      xmlAddChild(pOWSExtendedCapabilities, pDlsExtendedCapabilities);
+
+      pChild = pRoot->children;
+      while (pChild != NULL) {
+        xmlNodePtr pNext = pChild->next;
+        xmlUnlinkNode(pChild);
+        xmlAddChild(pDlsExtendedCapabilities, pChild);
+        pChild = pNext;
+      }
+
+      msWFSAddInspireDSID(map, psNsInspireDls, psNsInspireCommon,
+                          pDlsExtendedCapabilities);
+
+      msIO_restoreOldStdoutContext(old_context);
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      FeatureTypeList                                                 */
+  /* -------------------------------------------------------------------- */
+  if (msWFSIncludeSection(params, "FeatureTypeList")) {
+    psFtNode = xmlNewNode(NULL, BAD_CAST "FeatureTypeList");
+    xmlAddChild(psRootNode, psFtNode);
+  }
+
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp;
+    lp = GET_LAYER(map, i);
+
+    if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
+      continue;
+
+    if (msWFSIsLayerSupported(lp)) {
+      if (psFtNode != NULL) {
+        xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_2_0_0,
+                                               validated_language, script_url));
+      }
+
+      /* As soon as at least one layer supports sorting, advertize sorting */
+      if (msLayerSupportsSorting(lp))
+        bImplementsSorting = MS_TRUE;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Filter capabilities.                                            */
+  /* -------------------------------------------------------------------- */
+  if (msWFSIncludeSection(params, "Filter_Capabilities")) {
+    psNsFES = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX);
+    xmlAddChild(psRootNode, msWFS20FilterCapabilities(psNsFES, psNsOws,
+                                                      bImplementsSorting));
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document.                                         */
+  /* -------------------------------------------------------------------- */
+
+  if (msIO_needBinaryStdout() == MS_FAILURE)
+    return MS_FAILURE;
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  context = msIO_getHandler(stdout);
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+  msIO_contextWrite(context, buffer, size);
+  xmlFree(buffer);
+
+  /*free buffer and the document */
+  /*xmlFree(buffer);*/
+  xmlFreeDoc(psDoc);
+  if (psNsFES != NULL)
+    xmlFreeNs(psNsFES);
+  if (pInspireTmpDoc != NULL)
+    xmlFreeDoc(pInspireTmpDoc);
+
+  free(script_url);
+  msFree(validated_language);
+
+  xmlCleanupParser();
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                       msWFSGetStoredQueries                          */
+/*                                                                      */
+/* Result must be freed with msFreeCharArray()                          */
+/************************************************************************/
+
+static char **msWFSGetStoredQueries(mapObj *map, int *pn) {
+  const char *value;
+  char **tokens;
+  int i, n;
+
+  value = msOWSLookupMetadata(&(map->web.metadata), "F", "storedqueries");
+  if (value != NULL) {
+    tokens = msStringSplit(value, ',', &n);
+    for (i = 0; i < n; i++) {
+      if (strcasecmp(tokens[i], URN_GET_FEATURE_BY_ID) == 0)
+        break;
+    }
+    /* Add mandatory GetFeatureById stored query if not found */
+    if (i == n) {
+      tokens = (char **)realloc(tokens, (n + 1) * sizeof(char *));
+      memmove(tokens + 1, tokens, n * sizeof(char *));
+      tokens[0] = msStrdup(URN_GET_FEATURE_BY_ID);
+      n++;
+    }
+  } else {
+    tokens = (char **)malloc(sizeof(char *));
+    tokens[0] = msStrdup(URN_GET_FEATURE_BY_ID);
+    n = 1;
+  }
+  *pn = n;
+  return tokens;
+}
+
+/************************************************************************/
+/*                       msWFSGetStoredQuery                            */
+/*                                                                      */
+/* Result must be freed with msFree()                                   */
+/************************************************************************/
+
+static char *msWFSGetStoredQuery(mapObj *map, const char *pszURN) {
+  const char *value;
+  char szKey[256];
+
+  snprintf(szKey, sizeof(szKey), "%s_inlinedef", pszURN);
+  value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
+  if (value != NULL)
+    return msStrdup(value);
+
+  snprintf(szKey, sizeof(szKey), "%s_filedef", pszURN);
+  value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
+  if (value != NULL) {
+    FILE *f = fopen(value, "rb");
+    if (f != NULL) {
+      char *pszBuffer;
+      int nread;
+      long length;
+
+      fseek(f, 0, SEEK_END);
+      length = ftell(f);
+      if (length < 0 || length > 1000000) {
+        msSetError(MS_WFSERR, "%s: too big (%ld bytes > 1000000)",
+                   "msWFSGetStoredQuery()", value, length);
+        fclose(f);
+      } else {
+        fseek(f, 0, SEEK_SET);
+        pszBuffer = (char *)malloc((int)length + 1);
+        if (pszBuffer == NULL) {
+          msSetError(MS_WFSERR, "Cannot allocate %d bytes to read %s",
+                     "msWFSGetStoredQuery()", (int)length + 1, value);
+          fclose(f);
+        } else {
+          nread = (int)fread(pszBuffer, 1, length, f);
+          fclose(f);
+          if (nread == length) {
+            pszBuffer[nread] = '\0';
+            return pszBuffer;
+          }
+          msSetError(MS_WFSERR, "Could only read %d bytes / %d of %s",
+                     "msWFSGetStoredQuery()", nread, (int)length, value);
+          msFree(pszBuffer);
+        }
+      }
+    } else {
+      msSetError(MS_WFSERR, "Cannot open %s", "msWFSGetStoredQuery()", value);
+    }
+  }
+
+  if (strcasecmp(pszURN, URN_GET_FEATURE_BY_ID) == 0)
+    return msStrdup(GET_FEATURE_BY_ID);
+  return NULL;
+}
+
+/************************************************************************/
+/*                     msWFSGetResolvedStoredQuery20                    */
+/*                                                                      */
+/* Result must be freed with msFree()                                   */
+/************************************************************************/
+
+char *msWFSGetResolvedStoredQuery20(mapObj *map, wfsParamsObj *wfsparams,
+                                    const char *id, hashTableObj *hashTable) {
+  char *storedQuery;
+  xmlDocPtr psStoredQueryDoc;
+  xmlNodePtr psStoredQueryRoot, pChild;
+
+  storedQuery = msWFSGetStoredQuery(map, id);
+  if (storedQuery == NULL) {
+    msSetError(MS_WFSERR, "Unknown stored query id: %s",
+               "msWFSGetResolvedStoredQuery20()", id);
+    msWFSException(map, "storedqueryid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                   wfsparams->pszVersion);
+    return NULL;
+  }
+
+  psStoredQueryDoc = xmlParseDoc((const xmlChar *)storedQuery);
+  if (psStoredQueryDoc == NULL) {
+    msSetError(MS_WFSERR, "Definition for stored query '%s' is invalid",
+               "msWFSGetResolvedStoredQuery20()", id);
+    msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   wfsparams->pszVersion);
+    msFree(storedQuery);
+    return NULL;
+  }
+
+  psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
+
+  /* Check that all parameters are provided */
+  pChild = psStoredQueryRoot->children;
+  while (pChild != NULL) {
+    if (pChild->type == XML_ELEMENT_NODE &&
+        strcmp((const char *)pChild->name, "Parameter") == 0) {
+      xmlChar *parameterName = xmlGetProp(pChild, BAD_CAST "name");
+      if (parameterName != NULL) {
+        char szTmp[256];
+        const char *value =
+            msLookupHashTable(hashTable, (const char *)parameterName);
+        if (value == NULL) {
+          msSetError(MS_WFSERR, "Stored query '%s' requires parameter '%s'",
+                     "msWFSParseRequest()", id, (const char *)parameterName);
+          msWFSException(map, (const char *)parameterName,
+                         MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         wfsparams->pszVersion);
+          msFree(storedQuery);
+          xmlFree(parameterName);
+          xmlFreeDoc(psStoredQueryDoc);
+          return NULL;
+        }
+
+        snprintf(szTmp, sizeof(szTmp), "${%s}", (const char *)parameterName);
+        // value should already be a valid XML fragment
+        storedQuery = msReplaceSubstring(storedQuery, szTmp, value);
+      }
+      xmlFree(parameterName);
+    }
+    pChild = pChild->next;
+  }
+
+  xmlFreeDoc(psStoredQueryDoc);
+
+  return storedQuery;
+}
+
+/************************************************************************/
+/*                       msWFSListStoredQueries20                       */
+/************************************************************************/
+
+int msWFSListStoredQueries20(mapObj *map, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc;
+  xmlChar *buffer = NULL;
+  int size = 0;
+  msIOContext *context = NULL;
+  xmlNodePtr psRootNode;
+  char *xsi_schemaLocation = NULL;
+  int i, j;
+  int nStoredQueries = 0;
+  char **storedQueries = NULL;
+
+  xmlDocPtr psStoredQueryDoc;
+  xmlNodePtr psStoredQueryRoot;
+
+  /* -------------------------------------------------------------------- */
+  /*      Create document.                                                */
+  /* -------------------------------------------------------------------- */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "ListStoredQueriesResponse");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* -------------------------------------------------------------------- */
+  /*      Name spaces                                                     */
+  /* -------------------------------------------------------------------- */
+
+  /*default name space*/
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
+
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+
+  /*schema*/
+  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+  free(xsi_schemaLocation);
+
+  /* -------------------------------------------------------------------- */
+  /*      Add queries                                                     */
+  /* -------------------------------------------------------------------- */
+
+  storedQueries = msWFSGetStoredQueries(map, &nStoredQueries);
+  for (i = 0; i < nStoredQueries; i++) {
+    char *query = msWFSGetStoredQuery(map, storedQueries[i]);
+    if (query != NULL) {
+      xmlNodePtr pChild;
+      xmlNodePtr psStoredQuery;
+
+      psStoredQueryDoc = xmlParseDoc((const xmlChar *)query);
+      if (psStoredQueryDoc == NULL) {
+        char szMsg[256];
+        msFree(query);
+        snprintf(szMsg, sizeof(szMsg),
+                 "WARNING: Definition for stored query %s is invalid",
+                 storedQueries[i]);
+        xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
+        continue;
+      }
+
+      psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
+
+      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQuery");
+      xmlNewProp(psStoredQuery, BAD_CAST "id", BAD_CAST storedQueries[i]);
+      xmlAddChild(psRootNode, psStoredQuery);
+
+      pChild = psStoredQueryRoot->children;
+      while (pChild != NULL) {
+        xmlNodePtr pNext = pChild->next;
+        if (pChild->type == XML_ELEMENT_NODE &&
+            strcmp((const char *)pChild->name, "Title") == 0) {
+          xmlUnlinkNode(pChild);
+          xmlAddChild(psStoredQuery, pChild);
+        } else if (pChild->type == XML_ELEMENT_NODE &&
+                   strcmp((const char *)pChild->name, "QueryExpressionText") ==
+                       0) {
+          xmlNodePtr psReturnFeatureType;
+
+          if (strcasecmp(storedQueries[i], URN_GET_FEATURE_BY_ID) == 0) {
+            for (j = 0; j < map->numlayers; j++) {
+              layerObj *lp;
+              const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+              const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+              const char *value;
+              char szValue[256];
+
+              lp = GET_LAYER(map, j);
+
+              if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                    ows_request->numlayers) ||
+                  !msWFSIsLayerSupported(lp))
+                continue;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_uri");
+              if (value)
+                user_namespace_uri = value;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_prefix");
+              if (value)
+                user_namespace_prefix = value;
+
+              psReturnFeatureType =
+                  xmlNewNode(NULL, BAD_CAST "ReturnFeatureType");
+              xmlNewNs(psReturnFeatureType, BAD_CAST user_namespace_uri,
+                       BAD_CAST user_namespace_prefix);
+
+              xmlAddChild(psStoredQuery, psReturnFeatureType);
+              snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix,
+                       lp->name);
+              xmlAddChild(psReturnFeatureType, xmlNewText(BAD_CAST szValue));
+            }
+          } else {
+            xmlChar *returnFeatureTypes =
+                xmlGetProp(pChild, BAD_CAST "returnFeatureTypes");
+            if (returnFeatureTypes != NULL &&
+                strlen((const char *)returnFeatureTypes) > 0) {
+              int ntypes;
+              char **types =
+                  msStringSplit((const char *)returnFeatureTypes, ' ', &ntypes);
+              for (j = 0; j < ntypes; j++) {
+                psReturnFeatureType =
+                    xmlNewNode(NULL, BAD_CAST "ReturnFeatureType");
+                xmlAddChild(psStoredQuery, psReturnFeatureType);
+                xmlAddChild(psReturnFeatureType, xmlNewText(BAD_CAST types[j]));
+              }
+              msFreeCharArray(types, ntypes);
+            } else {
+              psReturnFeatureType =
+                  xmlNewNode(NULL, BAD_CAST "ReturnFeatureType");
+              xmlAddChild(psStoredQuery, psReturnFeatureType);
+              xmlAddChild(
+                  psReturnFeatureType,
+                  xmlNewComment(BAD_CAST "WARNING: Missing return type"));
+            }
+            xmlFree(returnFeatureTypes);
+          }
+        }
+        pChild = pNext;
+      }
+
+      xmlReconciliateNs(psDoc, psStoredQuery);
+      xmlFreeDoc(psStoredQueryDoc);
+      msFree(query);
+    } else {
+      char szMsg[256];
+      snprintf(szMsg, sizeof(szMsg),
+               "WARNING: Definition for stored query %s missing",
+               storedQueries[i]);
+      xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
+    }
+  }
+  msFreeCharArray(storedQueries, nStoredQueries);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document.                                         */
+  /* -------------------------------------------------------------------- */
+
+  if (msIO_needBinaryStdout() == MS_FAILURE)
+    return MS_FAILURE;
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  context = msIO_getHandler(stdout);
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+  msIO_contextWrite(context, buffer, size);
+  xmlFree(buffer);
+
+  /*free buffer and the document */
+  /*xmlFree(buffer);*/
+  xmlFreeDoc(psDoc);
+
+  xmlCleanupParser();
+
+  return (MS_SUCCESS);
+}
+
+/************************************************************************/
+/*                     msWFSDescribeStoredQueries20                     */
+/************************************************************************/
+
+int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
+                                 owsRequestObj *ows_request) {
+  xmlDocPtr psDoc;
+  xmlChar *buffer = NULL;
+  int size = 0;
+  msIOContext *context = NULL;
+  xmlNodePtr psRootNode;
+  char *xsi_schemaLocation = NULL;
+  int i, j;
+  int nStoredQueries = 0;
+  char **storedQueries = NULL;
+
+  xmlDocPtr psStoredQueryDoc;
+  xmlNodePtr psStoredQueryRoot;
+
+  if (params->pszStoredQueryId != NULL) {
+    storedQueries =
+        msStringSplit(params->pszStoredQueryId, ',', &nStoredQueries);
+    for (i = 0; i < nStoredQueries; i++) {
+      char *query = msWFSGetStoredQuery(map, storedQueries[i]);
+      if (query == NULL) {
+        msSetError(MS_WFSERR, "Unknown stored query id: %s",
+                   "msWFSDescribeStoredQueries20()", storedQueries[i]);
+        msFreeCharArray(storedQueries, nStoredQueries);
+        return msWFSException(map, "storedqueryid",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              params->pszVersion);
+      }
+      msFree(query);
+    }
+  } else {
+    storedQueries = msWFSGetStoredQueries(map, &nStoredQueries);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Create document.                                                */
+  /* -------------------------------------------------------------------- */
+  psDoc = xmlNewDoc(BAD_CAST "1.0");
+
+  psRootNode = xmlNewNode(NULL, BAD_CAST "DescribeStoredQueriesResponse");
+
+  xmlDocSetRootElement(psDoc, psRootNode);
+
+  /* -------------------------------------------------------------------- */
+  /*      Name spaces                                                     */
+  /* -------------------------------------------------------------------- */
+
+  /*default name space*/
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
+
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+
+  /*schema*/
+  xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
+  free(xsi_schemaLocation);
+
+  /* -------------------------------------------------------------------- */
+  /*      Add queries                                                     */
+  /* -------------------------------------------------------------------- */
+
+  for (i = 0; i < nStoredQueries; i++) {
+    char *query = msWFSGetStoredQuery(map, storedQueries[i]);
+    if (query != NULL) {
+      xmlNodePtr pChild;
+      xmlNs *ns;
+      xmlNodePtr psStoredQuery;
+
+      psStoredQueryDoc = xmlParseDoc((const xmlChar *)query);
+      if (psStoredQueryDoc == NULL) {
+        char szMsg[256];
+        msFree(query);
+        snprintf(szMsg, sizeof(szMsg),
+                 "WARNING: Definition for stored query %s is invalid",
+                 storedQueries[i]);
+        xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
+        continue;
+      }
+
+      psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
+
+      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQueryDescription");
+      xmlNewProp(psStoredQuery, BAD_CAST "id", BAD_CAST storedQueries[i]);
+      xmlAddChild(psRootNode, psStoredQuery);
+
+      ns = psStoredQueryRoot->nsDef;
+      while (ns != NULL) {
+        xmlNewNs(psStoredQuery, BAD_CAST ns->href, BAD_CAST ns->prefix);
+        ns = ns->next;
+      }
+
+      pChild = psStoredQueryRoot->children;
+      while (pChild != NULL) {
+        xmlNodePtr pNext = pChild->next;
+
+        if (pChild->type == XML_ELEMENT_NODE &&
+            strcmp((const char *)pChild->name, "QueryExpressionText") == 0) {
+          if (strcasecmp(storedQueries[i], URN_GET_FEATURE_BY_ID) == 0) {
+            char **arrayNsPrefix =
+                (char **)malloc(sizeof(char *) * map->numlayers);
+            char **arrayNsUri =
+                (char **)malloc(sizeof(char *) * map->numlayers);
+            int arraysize = 0;
+            int k;
+            char *returnFeatureTypes = NULL;
+            xmlNodePtr psQueryExpressionText;
+
+            psQueryExpressionText =
+                xmlNewNode(NULL, BAD_CAST "QueryExpressionText");
+            xmlAddChild(psStoredQuery, psQueryExpressionText);
+            xmlNewProp(psQueryExpressionText, BAD_CAST "isPrivate",
+                       BAD_CAST "true");
+            xmlNewProp(
+                psQueryExpressionText, BAD_CAST "language",
+                BAD_CAST
+                "urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression");
+
+            for (j = 0; j < map->numlayers; j++) {
+              layerObj *lp;
+              const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+              const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+              const char *value;
+              char szValue[256];
+
+              lp = GET_LAYER(map, j);
+
+              if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                    ows_request->numlayers) ||
+                  !msWFSIsLayerSupported(lp))
+                continue;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_uri");
+              if (value)
+                user_namespace_uri = value;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_prefix");
+              if (value)
+                user_namespace_prefix = value;
+
+              for (k = 0; k < arraysize; k++) {
+                if (strcmp(arrayNsPrefix[k], user_namespace_prefix) == 0)
+                  break;
+              }
+              if (k == arraysize) {
+                arrayNsPrefix[arraysize] = msStrdup(user_namespace_prefix);
+                arrayNsUri[arraysize] = msStrdup(user_namespace_uri);
+                arraysize++;
+
+                xmlNewNs(psQueryExpressionText, BAD_CAST user_namespace_uri,
+                         BAD_CAST user_namespace_prefix);
+              }
+
+              if (returnFeatureTypes != NULL)
+                returnFeatureTypes =
+                    msStringConcatenate(returnFeatureTypes, " ");
+              snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix,
+                       lp->name);
+              returnFeatureTypes =
+                  msStringConcatenate(returnFeatureTypes, szValue);
+            }
+
+            xmlNewProp(psQueryExpressionText, BAD_CAST "returnFeatureTypes",
+                       BAD_CAST returnFeatureTypes);
+
+            msFree(returnFeatureTypes);
+            msFreeCharArray(arrayNsPrefix, arraysize);
+            msFreeCharArray(arrayNsUri, arraysize);
+          } else {
+            xmlChar *isPrivate = xmlGetProp(pChild, BAD_CAST "isPrivate");
+            if (isPrivate != NULL &&
+                strcmp((const char *)isPrivate, "true") == 0) {
+              xmlNodePtr pSubChild = xmlFirstElementChild(pChild);
+              xmlUnlinkNode(pSubChild);
+              xmlFreeNode(pSubChild);
+            }
+            xmlUnlinkNode(pChild);
+            xmlAddChild(psStoredQuery, pChild);
+            msFree(isPrivate);
+          }
+        } else {
+          xmlUnlinkNode(pChild);
+          xmlAddChild(psStoredQuery, pChild);
+        }
+        pChild = pNext;
+      }
+
+      xmlReconciliateNs(psDoc, psStoredQuery);
+      xmlFreeDoc(psStoredQueryDoc);
+      msFree(query);
+    } else {
+      char szMsg[256];
+      snprintf(szMsg, sizeof(szMsg),
+               "WARNING: Definition for stored query %s missing",
+               storedQueries[i]);
+      xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
+    }
+  }
+  msFreeCharArray(storedQueries, nStoredQueries);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out the document.                                         */
+  /* -------------------------------------------------------------------- */
+
+  if (msIO_needBinaryStdout() == MS_FAILURE)
+    return MS_FAILURE;
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  context = msIO_getHandler(stdout);
+
+  xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
+  msIO_contextWrite(context, buffer, size);
+  xmlFree(buffer);
+
+  /*free buffer and the document */
+  /*xmlFree(buffer);*/
+  xmlFreeDoc(psDoc);
+
+  xmlCleanupParser();
+
+  return (MS_SUCCESS);
+}
+
+#endif /* defined(USE_WFS_SVR) && defined(USE_LIBXML2) */
+
+#if defined(USE_WFS_SVR) && !defined(USE_LIBXML2)
+
+int msWFSException20(mapObj *map, const char *locator,
+                     const char *exceptionCode) {
+  /* fallback to reporting using 1.0 style exceptions. */
+  return msWFSException(map, locator, exceptionCode, "1.0.0");
+}
+
+int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
+                           cgiRequestObj *req, owsRequestObj *ows_request)
+
+{
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSGetCapabilities20()");
+
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
+}
+
+int msWFSListStoredQueries20(mapObj *map, wfsParamsObj *params,
+                             cgiRequestObj *req, owsRequestObj *ows_request) {
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSListStoredQueries20()");
+
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
+}
+
+int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
+                                 cgiRequestObj *req,
+                                 owsRequestObj *ows_request) {
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSDescribeStoredQueries20()");
+
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
+}
+
+char *msWFSGetResolvedStoredQuery20(mapObj *map, wfsParamsObj *params,
+                                    const char *id, hashTableObj *hashTable) {
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSGetResolvedStoredQuery20()");
+
+  msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   params->pszVersion);
+  return NULL;
+}
+
+#endif /* defined(USE_WFS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/src/mapwfslayer.c 8.2.0~beta1-1~exp1/src/mapwfslayer.c
--- 8.0.1-5/src/mapwfslayer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwfslayer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1273 @@
+/**********************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of WFS CONNECTIONTYPE - client to WFS servers
+ * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
+ *
+ **********************************************************************
+ * Copyright (c) 2002, Daniel Morissette, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapows.h"
+#include "mapproject.h"
+
+#include <time.h>
+#include <assert.h>
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <process.h>
+#endif
+
+#define WFS_V_0_0_14 14
+#define WFS_V_1_0_0 100
+
+/*====================================================================
+ *  Private (static) functions
+ *====================================================================*/
+
+#ifdef USE_WFS_LYR
+
+/************************************************************************/
+/*                           msBuildRequestParms                        */
+/*                                                                      */
+/*      Build the params object based on the metadata                   */
+/*      information. This object will be used when building the Get     */
+/*      and Post requsests.                                             */
+/*      Note : Verify the connection string to extract some values      */
+/*      for backward compatiblity. (It is though depricated).           */
+/*      This will also set layer projection and compute BBOX in that    */
+/*      projection.                                                     */
+/*                                                                      */
+/************************************************************************/
+static wfsParamsObj *msBuildRequestParams(mapObj *map, layerObj *lp,
+                                          rectObj *bbox_ret) {
+  wfsParamsObj *psParams = NULL;
+  rectObj bbox;
+  const char *pszTmp;
+  char *pszVersion, *pszTypeName;
+
+  if (!map || !lp || !bbox_ret)
+    return NULL;
+
+  if (lp->connection == NULL)
+    return NULL;
+
+  psParams = msWFSCreateParamsObj();
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "version");
+  if (pszTmp)
+    psParams->pszVersion = msStrdup(pszTmp);
+  else {
+    pszTmp = strstr(lp->connection, "VERSION=");
+    if (!pszTmp)
+      pszTmp = strstr(lp->connection, "version=");
+    if (pszTmp) {
+      pszVersion = strchr(pszTmp, '=') + 1;
+      if (strncmp(pszVersion, "0.0.14", 6) == 0)
+        psParams->pszVersion = msStrdup("0.0.14");
+      else if (strncmp(pszVersion, "1.0.0", 5) == 0)
+        psParams->pszVersion = msStrdup("1.0.0");
+    }
+  }
+
+  /*the service is always set to WFS : see bug 1302 */
+  psParams->pszService = msStrdup("WFS");
+
+  /*
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "service");
+  if (pszTmp)
+    psParams->pszService = msStrdup(pszTmp);
+  else
+  {
+      pszTmp = strstr(lp->connection, "SERVICE=");
+      if (!pszTmp)
+        pszTmp = strstr(lp->connection, "service=");
+      if (pszTmp)
+      {
+          pszService = strchr(pszTmp, '=')+1;
+          if (strncmp(pszService, "WFS", 3) == 0)
+            psParams->pszService = msStrdup("WFS");
+      }
+  }
+  */
+
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "geometryname");
+  if (pszTmp)
+    psParams->pszGeometryName = msStrdup(pszTmp);
+
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "typename");
+  if (pszTmp)
+    psParams->pszTypeName = msStrdup(pszTmp);
+  else {
+    pszTmp = strstr(lp->connection, "TYPENAME=");
+    if (!pszTmp)
+      pszTmp = strstr(lp->connection, "typename=");
+    if (pszTmp) {
+      pszTypeName = strchr(pszTmp, '=') + 1;
+      if (pszTypeName) {
+        const int nLength = strlen(pszTypeName);
+        if (nLength > 0) {
+          int i = 0;
+          for (; i < nLength; i++) {
+            if (pszTypeName[i] == '&')
+              break;
+          }
+
+          if (i < nLength) {
+            char *pszTypeNameTmp = NULL;
+            pszTypeNameTmp = msStrdup(pszTypeName);
+            pszTypeNameTmp[i] = '\0';
+            psParams->pszTypeName = msStrdup(pszTypeNameTmp);
+            free(pszTypeNameTmp);
+          } else
+            psParams->pszTypeName = msStrdup(pszTypeName);
+        }
+      }
+    }
+  }
+
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "filter");
+  if (pszTmp && strlen(pszTmp) > 0) {
+    if (strstr(pszTmp, "<Filter>") != NULL ||
+        strstr(pszTmp, "<ogc:Filter") != NULL)
+      psParams->pszFilter = msStrdup(pszTmp);
+    else {
+      psParams->pszFilter = msStringConcatenate(
+          psParams->pszFilter,
+          "<ogc:Filter xmlns:ogc=\"http://www.opengis.net/ogc\">");
+      psParams->pszFilter =
+          msStringConcatenate(psParams->pszFilter, (char *)pszTmp);
+      psParams->pszFilter =
+          msStringConcatenate(psParams->pszFilter, "</ogc:Filter>");
+    }
+  }
+
+  pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "maxfeatures");
+  if (pszTmp)
+    psParams->nMaxFeatures = atoi(pszTmp);
+
+  /* Request is always GetFeature; */
+  psParams->pszRequest = msStrdup("GetFeature");
+
+  /* ------------------------------------------------------------------
+   * Figure the SRS we'll use for the request.
+   * - Fetch the map SRS (if it's EPSG)
+   * - Check if map SRS is listed in layer wfs_srs metadata
+   * - If map SRS is valid for this layer then use it
+   * - Otherwise request layer in its default SRS and we'll reproject later
+   * ------------------------------------------------------------------ */
+
+  /* __TODO__ WFS servers support only one SRS... need to decide how we'll */
+  /* handle this and document it well. */
+  /* It's likely that we'll simply reproject the BBOX to teh layer's projection.
+   */
+
+  /* ------------------------------------------------------------------
+   * Set layer SRS and reproject map extents to the layer's SRS
+   * ------------------------------------------------------------------ */
+#ifdef __TODO__
+  /* No need to set lp->proj if it's already set to the right EPSG code */
+  if ((pszTmp = msGetEPSGProj(&(lp->projection), NULL, MS_TRUE)) == NULL ||
+      strcasecmp(pszEPSG, pszTmp) != 0) {
+    char szProj[20];
+    snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG + 5);
+    if (msLoadProjectionString(&(lp->projection), szProj) != 0)
+      return NULL;
+  }
+#endif
+
+  bbox = map->extent;
+  if (msProjectionsDiffer(&(map->projection), &(lp->projection))) {
+    msProjectRect(&(map->projection), &(lp->projection), &bbox);
+  }
+
+  *bbox_ret = bbox;
+
+  return psParams;
+}
+
+/**********************************************************************
+ *                          msBuildWFSLayerPostRequest()
+ *
+ * Build a WFS GetFeature xml document for a Post Request.
+ *
+ * Returns a reference to a newly allocated string that should be freed
+ * by the caller.
+ **********************************************************************/
+static char *msBuildWFSLayerPostRequest(rectObj *bbox, wfsParamsObj *psParams) {
+  char *pszPostReq = NULL;
+  char *pszFilter = NULL;
+  char *pszGeometryName = "Geometry";
+  size_t bufferSize = 0;
+
+  if (psParams->pszVersion == NULL ||
+      (strncmp(psParams->pszVersion, "0.0.14", 6) != 0 &&
+       strncmp(psParams->pszVersion, "1.0.0", 5)) != 0) {
+    msSetError(MS_WFSCONNERR,
+               "MapServer supports only WFS 1.0.0 or 0.0.14 (please verify the "
+               "version metadata wfs_version).",
+               "msBuildWFSLayerPostRequest()");
+    return NULL;
+  }
+
+  if (psParams->pszTypeName == NULL) {
+    msSetError(MS_WFSCONNERR, "Metadata wfs_typename must be set in the layer",
+               "msBuildWFSLayerPostRequest()");
+    return NULL;
+  }
+
+  if (psParams->pszGeometryName) {
+    pszGeometryName = psParams->pszGeometryName;
+  }
+
+  if (psParams->pszFilter)
+    pszFilter = psParams->pszFilter;
+  else {
+    bufferSize = 500;
+    pszFilter = (char *)msSmallMalloc(bufferSize);
+    snprintf(pszFilter, bufferSize,
+             "<ogc:Filter>\n"
+             "<ogc:BBOX>\n"
+             "<ogc:PropertyName>%s</ogc:PropertyName>\n"
+             "<gml:Box>\n"
+             "<gml:coordinates>%f,%f %f,%f</gml:coordinates>\n"
+             "</gml:Box>\n"
+             "</ogc:BBOX>\n"
+             "</ogc:Filter>",
+             pszGeometryName, bbox->minx, bbox->miny, bbox->maxx, bbox->maxy);
+  }
+
+  bufferSize = strlen(pszFilter) + strlen(psParams->pszTypeName) + 500;
+  pszPostReq = (char *)msSmallMalloc(bufferSize);
+  if (psParams->nMaxFeatures > 0)
+    snprintf(pszPostReq, bufferSize,
+             "<?xml version=\"1.0\" ?>\n"
+             "<wfs:GetFeature\n"
+             "service=\"WFS\"\n"
+             "version=\"1.0.0\"\n"
+             "maxFeatures=\"%d\"\n"
+             "outputFormat=\"GML2\"\n"
+             "xmlns:wfs=\"http://www.opengis.net/wfs\" "
+             "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+             "xsi:schemaLocation=\"http://www.opengis.net/wfs "
+             "http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" "
+             "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+             "xmlns:gml=\"http://www.opengis.net/gml\">\n"
+             "<wfs:Query typeName=\"%s\">\n"
+             "%s"
+             "</wfs:Query>\n"
+             "</wfs:GetFeature>\n",
+             psParams->nMaxFeatures, psParams->pszTypeName, pszFilter);
+  else
+    snprintf(pszPostReq, bufferSize,
+             "<?xml version=\"1.0\" ?>\n"
+             "<wfs:GetFeature\n"
+             "service=\"WFS\"\n"
+             "version=\"1.0.0\"\n"
+             "outputFormat=\"GML2\"\n"
+             "xmlns:wfs=\"http://www.opengis.net/wfs\" "
+             "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+             "xsi:schemaLocation=\"http://www.opengis.net/wfs "
+             "http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" "
+             "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+             "xmlns:gml=\"http://www.opengis.net/gml\">\n"
+             "<wfs:Query typeName=\"%s\">\n"
+             "%s"
+             "</wfs:Query>\n"
+             "</wfs:GetFeature>\n",
+             psParams->pszTypeName, pszFilter);
+  if (psParams->pszFilter == NULL)
+    free(pszFilter);
+
+  return pszPostReq;
+}
+
+/**********************************************************************
+ *                          msBuildWFSLayerGetURL()
+ *
+ * Build a WFS GetFeature URL for a Get Request.
+ *
+ * Returns a reference to a newly allocated string that should be freed
+ * by the caller.
+ **********************************************************************/
+static char *msBuildWFSLayerGetURL(layerObj *lp, rectObj *bbox,
+                                   wfsParamsObj *psParams) {
+  char *pszURL = NULL, *pszOnlineResource = NULL;
+  const char *pszTmp;
+  char *pszVersion, *pszService, *pszTypename = NULL;
+  int bVersionInConnection = 0;
+  int bTypenameInConnection = 0;
+  size_t bufferSize = 0;
+
+  if (lp->connectiontype != MS_WFS || lp->connection == NULL) {
+    msSetError(MS_WFSCONNERR, "Call supported only for CONNECTIONTYPE WFS",
+               "msBuildWFSLayerGetURL()");
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Find out request version. Look first for the wfs_version        */
+  /*      metedata. If not available try to find out if the CONNECTION    */
+  /*      string contains the version. This last test is done for         */
+  /*      backward compatiblity but is depericated.                       */
+  /* -------------------------------------------------------------------- */
+  pszVersion = psParams->pszVersion;
+  if (!pszVersion) {
+    if ((pszTmp = strstr(lp->connection, "VERSION=")) == NULL &&
+        (pszTmp = strstr(lp->connection, "version=")) == NULL) {
+      msSetError(MS_WFSCONNERR, "Metadata wfs_version must be set in the layer",
+                 "msBuildWFSLayerGetURL()");
+      return NULL;
+    }
+    pszVersion = strchr(pszTmp, '=') + 1;
+    bVersionInConnection = 1;
+  }
+
+  if (strncmp(pszVersion, "0.0.14", 6) != 0 &&
+      strncmp(pszVersion, "1.0.0", 5) != 0 &&
+      strncmp(pszVersion, "1.1", 3) != 0) {
+    msSetError(MS_WFSCONNERR,
+               "MapServer supports only WFS 1.1.0, 1.0.0 or 0.0.14 (please "
+               "verify the version metadata wfs_version).",
+               "msBuildWFSLayerGetURL()");
+    return NULL;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Find out the service. It is always set to WFS in function       */
+  /*      msBuildRequestParms  (check Bug 1302 for details).              */
+  /* -------------------------------------------------------------------- */
+  pszService = psParams->pszService;
+
+  /* -------------------------------------------------------------------- */
+  /*      Find out the typename. Look first for the wfs_tyename           */
+  /*      metadata. If not available try to find out if the CONNECTION    */
+  /*      string contains it. This last test is done for                  */
+  /*      backward compatiblity but is depericated.                       */
+  /* -------------------------------------------------------------------- */
+  pszTypename = psParams->pszTypeName;
+  if (!pszTypename) {
+    if (strstr(lp->connection, "TYPENAME=") == NULL &&
+        strstr(lp->connection, "typename=") == NULL) {
+      msSetError(MS_WFSCONNERR,
+                 "Metadata wfs_typename must be set in the layer",
+                 "msBuildWFSLayerGetURL()");
+      return NULL;
+    }
+    bTypenameInConnection = 1;
+  }
+
+  /* --------------------------------------------------------------------
+   * Build the request URL.
+   * At this point we set only the following parameters for GetFeature:
+   *   REQUEST
+   *   BBOX
+   *   VERSION
+   *   SERVICE
+   *   TYPENAME
+   *   FILTER
+   *   MAXFEATURES
+   *
+   * For backward compatiblity the user could also have in the connection
+   * string the following parameters (but it is depricated):
+   *   VERSION
+   *   SERVICE
+   *   TYPENAME
+   * -------------------------------------------------------------------- */
+  /* Make sure we have a big enough buffer for the URL */
+  bufferSize = strlen(lp->connection) + 1024;
+  pszURL = (char *)malloc(bufferSize);
+  MS_CHECK_ALLOC(pszURL, bufferSize, NULL);
+
+  /* __TODO__ We have to urlencode each value... especially the BBOX values */
+  /* because if they end up in exponent format (123e+06) the + will be seen */
+  /* as a space by the remote server. */
+
+  /* -------------------------------------------------------------------- */
+  /*      build the URL,                                                  */
+  /* -------------------------------------------------------------------- */
+  /* make sure connection ends with "&" or "?" */
+  pszOnlineResource = msOWSTerminateOnlineResource(lp->connection);
+  snprintf(pszURL, bufferSize, "%s", pszOnlineResource);
+  msFree(pszOnlineResource);
+
+  /* REQUEST */
+  snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+           "&REQUEST=GetFeature");
+
+  /* VERSION */
+  if (!bVersionInConnection)
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+             "&VERSION=%s", pszVersion);
+
+  /* SERVICE */
+  snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL), "&SERVICE=%s",
+           pszService);
+
+  /* TYPENAME */
+  if (!bTypenameInConnection)
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+             "&TYPENAME=%s", pszTypename);
+
+  /* -------------------------------------------------------------------- */
+  /*      If the filter parameter is given in the wfs_filter metadata,    */
+  /*      we use it and do not send the BBOX paramter as they are         */
+  /*      mutually exclusive.                                             */
+  /* -------------------------------------------------------------------- */
+  if (psParams->pszFilter) {
+    char *encoded_filter = msEncodeUrl(psParams->pszFilter);
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL), "&FILTER=%s",
+             encoded_filter);
+    free(encoded_filter);
+  } else {
+    /*
+     * take care about the axis order for WFS 1.1
+     */
+    char *projUrn;
+    char *projEpsg;
+    projUrn = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", 1);
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", 1, &projEpsg);
+
+    /*
+     * WFS 1.1 supports including the SRS in the BBOX parameter, should
+     * respect axis order in the BBOX and has a separate SRSNAME parameter for
+     * the desired result SRS.
+     * WFS 1.0 is always easting, northing, doesn't include the SRS as part of
+     * the BBOX parameter and has no SRSNAME parameter: if we don't have a
+     * URN then fallback to WFS 1.0 style */
+    if ((strncmp(pszVersion, "1.1", 3) == 0) && projUrn) {
+      if (projEpsg && (strncmp(projEpsg, "EPSG:", 5) == 0) &&
+          msIsAxisInverted(atoi(projEpsg + 5))) {
+        snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+                 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s", bbox->miny,
+                 bbox->minx, bbox->maxy, bbox->maxx, projUrn, projUrn);
+      } else {
+        snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+                 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s", bbox->minx,
+                 bbox->miny, bbox->maxx, bbox->maxy, projUrn, projUrn);
+      }
+    } else {
+      snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+               "&BBOX=%.15g,%.15g,%.15g,%.15g", bbox->minx, bbox->miny,
+               bbox->maxx, bbox->maxy);
+    }
+
+    msFree(projUrn);
+    msFree(projEpsg);
+  }
+
+  if (psParams->nMaxFeatures > 0)
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+             "&MAXFEATURES=%d", psParams->nMaxFeatures);
+
+  return pszURL;
+}
+
+/**********************************************************************
+ *                          msWFSLayerInfo
+ *
+ **********************************************************************/
+typedef struct ms_wfs_layer_info_t {
+  char *pszGMLFilename;
+  rectObj rect; /* set by WhichShapes */
+  char *pszGetUrl;
+  int nStatus;           /* HTTP status */
+  int bLayerHasValidGML; /* False until msWFSLayerWhichShapes() is called and
+                            determines the result GML is valid with features*/
+} msWFSLayerInfo;
+
+/**********************************************************************
+ *                          msAllocWFSLayerInfo()
+ *
+ **********************************************************************/
+static msWFSLayerInfo *msAllocWFSLayerInfo(void) {
+  msWFSLayerInfo *psInfo;
+
+  psInfo = (msWFSLayerInfo *)calloc(1, sizeof(msWFSLayerInfo));
+  MS_CHECK_ALLOC(psInfo, sizeof(msWFSLayerInfo), NULL);
+
+  psInfo->pszGMLFilename = NULL;
+  psInfo->rect.minx = psInfo->rect.maxx = 0;
+  psInfo->rect.miny = psInfo->rect.maxy = 0;
+  psInfo->pszGetUrl = NULL;
+  psInfo->nStatus = 0;
+
+  return psInfo;
+}
+
+/**********************************************************************
+ *                          msFreeWFSLayerInfo()
+ *
+ **********************************************************************/
+static void msFreeWFSLayerInfo(msWFSLayerInfo *psInfo) {
+  if (psInfo) {
+    if (psInfo->pszGMLFilename)
+      free(psInfo->pszGMLFilename);
+    if (psInfo->pszGetUrl)
+      free(psInfo->pszGetUrl);
+
+    free(psInfo);
+  }
+}
+
+#endif /* USE_WFS_LYR */
+
+/*====================================================================
+ *  Public functions
+ *====================================================================*/
+
+/**********************************************************************
+ *                          msPrepareWFSLayerRequest()
+ *
+ **********************************************************************/
+
+int msPrepareWFSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
+                             httpRequestObj *pasReqInfo, int *numRequests) {
+#ifdef USE_WFS_LYR
+  char *pszURL = NULL;
+  const char *pszTmp;
+  rectObj bbox;
+  int nTimeout;
+  int nStatus = MS_SUCCESS;
+  msWFSLayerInfo *psInfo = NULL;
+  int bPostRequest = 0;
+  wfsParamsObj *psParams = NULL;
+  char *pszHTTPCookieData = NULL;
+
+  if (lp->connectiontype != MS_WFS || lp->connection == NULL)
+    return MS_FAILURE;
+
+  /* ------------------------------------------------------------------
+   * Build a params object that will be used by to build the request,
+    this will also set layer projection and compute BBOX in that projection.
+   * ------------------------------------------------------------------ */
+  psParams = msBuildRequestParams(map, lp, &bbox);
+  if (!psParams)
+    return MS_FAILURE;
+
+  /* -------------------------------------------------------------------- */
+  /*      Depending on the metadata wfs_request_method, build a Get or    */
+  /*      a Post URL.                                                     */
+  /*    If it is a Get request the URL would contain all the parameters in*/
+  /*      the string;                                                     */
+  /*      If it is a Post request, the URL will only contain the          */
+  /*      connection string comming from the layer.                       */
+  /* -------------------------------------------------------------------- */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "request_method")) !=
+      NULL) {
+    if (strncmp(pszTmp, "GET", 3) == 0) {
+      pszURL = msBuildWFSLayerGetURL(lp, &bbox, psParams);
+      if (!pszURL) {
+        /* an error was already reported. */
+        return MS_FAILURE;
+      }
+    }
+  }
+  /* else it is a post request and just get the connection string */
+  if (!pszURL) {
+    bPostRequest = 1;
+    pszURL = msStrdup(lp->connection);
+  }
+
+  /* ------------------------------------------------------------------
+   * check to see if a the metadata wfs_connectiontimeout is set. If it is
+   * the case we will use it, else we use the default which is 30 seconds.
+   * First check the metadata in the layer object and then in the map object.
+   * ------------------------------------------------------------------ */
+  nTimeout = 30; /* Default is 30 seconds  */
+  if ((pszTmp = msOWSLookupMetadata2(&(lp->metadata), &(map->web.metadata),
+                                     "FO", "connectiontimeout")) != NULL) {
+    nTimeout = atoi(pszTmp);
+  }
+
+  /*------------------------------------------------------------------
+   * Check to see if there's a HTTP Cookie to forward
+   * If Cookie differ between the two connection, it's NOT OK to merge
+   * the connection
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "http_cookie")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
+        pszHTTPCookieData = msStrdup(pszTmp);
+      }
+    } else {
+      pszHTTPCookieData = msStrdup(pszTmp);
+    }
+  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                           "http_cookie")) != NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
+        pszHTTPCookieData = msStrdup(pszTmp);
+      }
+    } else {
+      pszHTTPCookieData = msStrdup(pszTmp);
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * If nLayerId == -1 then we need to figure it
+   * ------------------------------------------------------------------ */
+  if (nLayerId == -1) {
+    int iLayer;
+    for (iLayer = 0; iLayer < map->numlayers; iLayer++) {
+      if (GET_LAYER(map, iLayer) == lp) {
+        nLayerId = iLayer;
+        break;
+      }
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * Add a request to the array (already preallocated)
+   * ------------------------------------------------------------------ */
+  pasReqInfo[(*numRequests)].nLayerId = nLayerId;
+  pasReqInfo[(*numRequests)].pszGetUrl = pszURL;
+
+  if (bPostRequest) {
+    pasReqInfo[(*numRequests)].pszPostRequest =
+        msBuildWFSLayerPostRequest(&bbox, psParams);
+    pasReqInfo[(*numRequests)].pszPostContentType = msStrdup("text/xml");
+  }
+
+  /* We'll store the remote server's response to a tmp file. */
+  pasReqInfo[(*numRequests)].pszOutputFile =
+      msTmpFile(map, map->mappath, NULL, "tmp.gml");
+
+  /* TODO: Implement Caching of GML responses. There was an older caching
+   * method, but it suffered from a race condition. See #3137.
+   */
+
+  pasReqInfo[(*numRequests)].pszHTTPCookieData = pszHTTPCookieData;
+  pszHTTPCookieData = NULL;
+  pasReqInfo[(*numRequests)].nStatus = 0;
+  pasReqInfo[(*numRequests)].nTimeout = nTimeout;
+  pasReqInfo[(*numRequests)].bbox = bbox;
+  pasReqInfo[(*numRequests)].debug = lp->debug;
+
+  if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata), pasReqInfo,
+                           *numRequests, map, "FO") != MS_SUCCESS) {
+    msWFSFreeParamsObj(psParams);
+    return MS_FAILURE;
+  }
+
+  /* ------------------------------------------------------------------
+   * Pre-Open the layer now, (i.e. alloc and fill msWFSLayerInfo inside
+   * layer obj).  Layer will be ready for use when the main mapserver
+   * code calls msLayerOpen().
+   * ------------------------------------------------------------------ */
+  if (lp->wfslayerinfo != NULL) {
+    psInfo = (msWFSLayerInfo *)(lp->wfslayerinfo);
+  } else {
+    lp->wfslayerinfo = psInfo = msAllocWFSLayerInfo();
+  }
+
+  if (psInfo->pszGMLFilename)
+    free(psInfo->pszGMLFilename);
+  psInfo->pszGMLFilename = msStrdup(pasReqInfo[(*numRequests)].pszOutputFile);
+
+  psInfo->rect = pasReqInfo[(*numRequests)].bbox;
+
+  if (psInfo->pszGetUrl)
+    free(psInfo->pszGetUrl);
+  psInfo->pszGetUrl = msStrdup(pasReqInfo[(*numRequests)].pszGetUrl);
+
+  psInfo->nStatus = 0;
+
+  (*numRequests)++;
+
+  msWFSFreeParamsObj(psParams);
+
+  return nStatus;
+
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msPrepareWFSLayerRequest");
+  return (MS_FAILURE);
+
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSUpdateRequestInfo()
+ *
+ * This function is called after a WFS request has been completed so that
+ * we can copy request result information from the httpRequestObj to the
+ * msWFSLayerInfo struct.  Things to copy here are the HTTP status, exceptions
+ * information, mime type, etc.
+ **********************************************************************/
+void msWFSUpdateRequestInfo(layerObj *lp, httpRequestObj *pasReqInfo) {
+#ifdef USE_WFS_LYR
+  if (lp->wfslayerinfo) {
+    msWFSLayerInfo *psInfo = NULL;
+
+    psInfo = (msWFSLayerInfo *)(lp->wfslayerinfo);
+
+    /* Copy request results infos to msWFSLayerInfo struct */
+    /* For now there is only nStatus, but we should eventually add */
+    /* mime type and WFS exceptions information. */
+    psInfo->nStatus = pasReqInfo->nStatus;
+  }
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSUpdateRequestInfo()");
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerOpen()
+ *
+ * WFS layers are just a special case of OGR connection.  Only the open/close
+ * methods differ since they have to download and maintain GML files in cache
+ * but the rest is mapped directly to OGR function calls in maplayer.c
+ *
+ **********************************************************************/
+
+int msWFSLayerOpen(layerObj *lp, const char *pszGMLFilename,
+                   rectObj *defaultBBOX) {
+#ifdef USE_WFS_LYR
+  int status = MS_SUCCESS;
+  msWFSLayerInfo *psInfo = NULL;
+
+  if (msCheckParentPointer(lp->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  if (lp->wfslayerinfo != NULL) {
+    psInfo = (msWFSLayerInfo *)lp->wfslayerinfo;
+
+    /* Layer already opened.  If explicit filename requested then check */
+    /* that file was already opened with the same filename. */
+    /* If no explicit filename requested then we'll try to reuse the */
+    /* previously opened layer... this will happen in a msDrawMap() call. */
+    if (pszGMLFilename == NULL ||
+        (psInfo->pszGMLFilename &&
+         strcmp(psInfo->pszGMLFilename, pszGMLFilename) == 0)) {
+      if (lp->layerinfo == NULL) {
+        if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) ==
+            MS_FAILURE) /* no access to context (draw vs. query) here, although
+                           I doubt it matters... */
+          return MS_FAILURE;
+      }
+      return MS_SUCCESS; /* Nothing to do... layer is already opened */
+    } else {
+      /* Hmmm... should we produce a fatal error? */
+      /* For now we'll just close the layer and reopen it. */
+      if (lp->debug)
+        msDebug("msWFSLayerOpen(): Layer already opened (%s)\n",
+                lp->name ? lp->name : "(null)");
+      msWFSLayerClose(lp);
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * Alloc and fill msWFSLayerInfo inside layer obj
+   * ------------------------------------------------------------------ */
+  lp->wfslayerinfo = psInfo = msAllocWFSLayerInfo();
+
+  if (pszGMLFilename)
+    psInfo->pszGMLFilename = msStrdup(pszGMLFilename);
+  else {
+    psInfo->pszGMLFilename =
+        msTmpFile(lp->map, lp->map->mappath, NULL, "tmp.gml");
+  }
+
+  if (defaultBBOX) {
+    /* __TODO__ If new bbox differs from current one then we should */
+    /* invalidate current GML file in cache */
+    psInfo->rect = *defaultBBOX;
+  } else {
+    /* Use map bbox by default */
+    psInfo->rect = lp->map->extent;
+  }
+
+  /* We will call whichshapes() now and force downloading layer right */
+  /* away.  This saves from having to call DescribeFeatureType and */
+  /* parsing the response (being lazy I guess) and anyway given the */
+  /* way we work with layers right now the bbox is unlikely to change */
+  /* between now and the time whichshapes() would have been called by */
+  /* the MapServer core. */
+
+  if ((lp->map->projection.numargs > 0) && (lp->projection.numargs > 0))
+    msProjectRect(&lp->map->projection, &lp->projection,
+                  &psInfo->rect); /* project the searchrect to source coords */
+
+  if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) ==
+      MS_FAILURE) /* no access to context (draw vs. query) here, although I
+                     doubt it matters... */
+    status = MS_FAILURE;
+
+  return status;
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerOpen()");
+  return (MS_FAILURE);
+
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerOpenVT()
+ *
+ * Overloaded version of msWFSLayerOpen for virtual table architecture
+ **********************************************************************/
+int msWFSLayerOpenVT(layerObj *lp) { return msWFSLayerOpen(lp, NULL, NULL); }
+
+/**********************************************************************
+ *                          msWFSLayerIsOpen()
+ *
+ * Returns MS_TRUE if layer is already open, MS_FALSE otherwise.
+ *
+ **********************************************************************/
+
+int msWFSLayerIsOpen(layerObj *lp) {
+#ifdef USE_WFS_LYR
+  if (lp->wfslayerinfo != NULL)
+    return MS_TRUE;
+
+  return MS_FALSE;
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerIsOpen()");
+  return (MS_FALSE);
+
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerInitItemInfo()
+ *
+ **********************************************************************/
+
+int msWFSLayerInitItemInfo(layerObj *layer) {
+  (void)layer;
+  /* Nothing to do here.  OGR will do its own initialization when it */
+  /* opens the actual file. */
+  /* Note that we didn't implement our own msWFSLayerFreeItemInfo() */
+  /* so that the OGR one gets called. */
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                          msWFSLayerGetShape()
+ *
+ **********************************************************************/
+int msWFSLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+#ifdef USE_WFS_LYR
+  msWFSLayerInfo *psInfo = NULL;
+
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
+  else {
+    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetShape()");
+    return MS_FAILURE;
+  }
+
+  if (psInfo->bLayerHasValidGML)
+    return msOGRLayerGetShape(layer, shape, record);
+  else {
+    /* Layer is successful, but there is no data to process */
+    msFreeShape(shape);
+    shape->type = MS_SHAPE_NULL;
+    return MS_FAILURE;
+  }
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerGetShape()");
+  return (MS_FAILURE);
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerGetNextShape()
+ *
+ **********************************************************************/
+int msWFSLayerNextShape(layerObj *layer, shapeObj *shape) {
+#ifdef USE_WFS_LYR
+  msWFSLayerInfo *psInfo = NULL;
+
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
+  else {
+    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerNextShape()");
+    return MS_FAILURE;
+  }
+
+  if (psInfo->bLayerHasValidGML)
+    return msOGRLayerNextShape(layer, shape);
+  else {
+    /* Layer is successful, but there is no data to process */
+    msFreeShape(shape);
+    shape->type = MS_SHAPE_NULL;
+    return MS_FAILURE;
+  }
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerNextShape()");
+  return (MS_FAILURE);
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerGetExtent()
+ *
+ **********************************************************************/
+int msWFSLayerGetExtent(layerObj *layer, rectObj *extent) {
+#ifdef USE_WFS_LYR
+  msWFSLayerInfo *psInfo = NULL;
+
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
+  else {
+    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetExtent()");
+    return MS_FAILURE;
+  }
+
+  if (psInfo->bLayerHasValidGML)
+    return msOGRLayerGetExtent(layer, extent);
+  else {
+    /* Layer is successful, but there is no data to process */
+    msSetError(MS_WFSERR, "Unable to get extents for this layer.",
+               "msWFSLayerGetExtent()");
+    return MS_FAILURE;
+  }
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerGetExtent()");
+  return (MS_FAILURE);
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerGetItems()
+ *
+ **********************************************************************/
+
+int msWFSLayerGetItems(layerObj *layer) {
+#ifdef USE_WFS_LYR
+  /* For now this method simply lets OGR parse the GML and figure the  */
+  /* schema itself. */
+  /* It could also be implemented to call DescribeFeatureType for */
+  /* this layer, but we don't need to do it so why waste resources? */
+
+  msWFSLayerInfo *psInfo = NULL;
+
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
+  else {
+    msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetItems()");
+    return MS_FAILURE;
+  }
+
+  if (psInfo->bLayerHasValidGML)
+    return msOGRLayerGetItems(layer);
+  else {
+    /* Layer is successful, but there is no data to process */
+    layer->numitems = 0;
+    layer->items = NULL;
+    return MS_SUCCESS;
+  }
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerGetItems()");
+  return (MS_FAILURE);
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerWhichShapes()
+ *
+ **********************************************************************/
+
+int msWFSLayerWhichShapes(layerObj *lp, rectObj rect, int isQuery) {
+#ifdef USE_WFS_LYR
+  msWFSLayerInfo *psInfo;
+  int status = MS_SUCCESS;
+  const char *pszTmp;
+  FILE *fp;
+
+  if (msCheckParentPointer(lp->map, "map") == MS_FAILURE)
+    return MS_FAILURE;
+
+  psInfo = (msWFSLayerInfo *)lp->wfslayerinfo;
+
+  if (psInfo == NULL) {
+    msSetError(MS_WFSCONNERR, "Assertion failed: WFS layer not opened!!!",
+               "msWFSLayerWhichShapes()");
+    return (MS_FAILURE);
+  }
+
+  /* ------------------------------------------------------------------
+   * Check if layer overlaps current view window (using wfs_latlonboundingbox)
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO",
+                                    "latlonboundingbox")) != NULL) {
+    char **tokens;
+    int n;
+    rectObj ext;
+
+    tokens = msStringSplit(pszTmp, ' ', &n);
+    if (tokens == NULL || n != 4) {
+      msSetError(MS_WFSCONNERR,
+                 "Wrong number of values in 'wfs_latlonboundingbox' metadata.",
+                 "msWFSLayerWhichShapes()");
+      return MS_FAILURE;
+    }
+
+    ext.minx = atof(tokens[0]);
+    ext.miny = atof(tokens[1]);
+    ext.maxx = atof(tokens[2]);
+    ext.maxy = atof(tokens[3]);
+
+    msFreeCharArray(tokens, n);
+
+    /* Reproject latlonboundingbox to the selected SRS for the layer and */
+    /* check if it overlaps the bbox that we calculated for the request */
+
+    msProjectRect(&(lp->map->latlon), &(lp->projection), &ext);
+    if (!msRectOverlap(&rect, &ext)) {
+      /* No overlap... nothing to do. If layer was never opened, go open it.*/
+      if (lp->layerinfo)
+        return MS_DONE; /* No overlap. */
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * __TODO__ If new bbox differs from current one then we should
+   * invalidate current GML file in cache
+   * ------------------------------------------------------------------ */
+  psInfo->rect = rect;
+
+  /* ------------------------------------------------------------------
+   * If file not downloaded yet then do it now.
+   * ------------------------------------------------------------------ */
+  if (psInfo->nStatus == 0) {
+    httpRequestObj asReqInfo[2];
+    int numReq = 0;
+
+    msHTTPInitRequestObj(asReqInfo, 2);
+
+    if (msPrepareWFSLayerRequest(-1, lp->map, lp, asReqInfo, &numReq) ==
+            MS_FAILURE ||
+        msOWSExecuteRequests(asReqInfo, numReq, lp->map, MS_TRUE) ==
+            MS_FAILURE) {
+      /* Delete tmp file... we don't want it to stick around. */
+      unlink(asReqInfo[0].pszOutputFile);
+      return MS_FAILURE;
+    }
+
+    /* Cleanup */
+    msHTTPFreeRequestObj(asReqInfo, numReq);
+  }
+
+  if (!MS_HTTP_SUCCESS(psInfo->nStatus)) {
+    /* Delete tmp file... we don't want it to stick around. */
+    unlink(psInfo->pszGMLFilename);
+
+    msSetError(MS_WFSCONNERR, "Got HTTP status %d downloading WFS layer %s",
+               "msWFSLayerWhichShapes()", psInfo->nStatus,
+               lp->name ? lp->name : "(null)");
+    return (MS_FAILURE);
+  }
+
+  /* ------------------------------------------------------------------
+   * Check that file is really GML... it could be an exception, or just junk.
+   * ------------------------------------------------------------------ */
+  if ((fp = fopen(psInfo->pszGMLFilename, "r")) != NULL) {
+    char szHeader[2000];
+    int nBytes = 0;
+
+    nBytes = fread(szHeader, 1, sizeof(szHeader) - 1, fp);
+    fclose(fp);
+
+    if (nBytes < 0)
+      nBytes = 0;
+    szHeader[nBytes] = '\0';
+
+    if (nBytes == 0) {
+      msSetError(MS_WFSCONNERR, "WFS request produced no oputput for layer %s.",
+                 "msWFSLayerWhichShapes()", lp->name ? lp->name : "(null)");
+      return (MS_FAILURE);
+    }
+    if (strstr(szHeader, "<WFS_Exception>") ||
+        strstr(szHeader, "<ServiceExceptionReport>")) {
+      msOWSProcessException(lp, psInfo->pszGMLFilename, MS_WFSCONNERR,
+                            "msWFSLayerWhichShapes()");
+      return MS_FAILURE;
+    } else if (strstr(szHeader, "opengis.net/gml") &&
+               strstr(szHeader, "featureMember>") == NULL) {
+      /* This looks like valid GML, but contains 0 features. */
+      return MS_DONE;
+    } else if (strstr(szHeader, "opengis.net/gml") == NULL ||
+               strstr(szHeader, "featureMember>") == NULL) {
+      /* This is probably just junk. */
+      msSetError(MS_WFSCONNERR,
+                 "WFS request produced unexpected output (junk?) for layer %s.",
+                 "msWFSLayerWhichShapes()", lp->name ? lp->name : "(null)");
+      return (MS_FAILURE);
+    }
+
+    /* If we got this far, it must be a valid GML dataset... keep going */
+  }
+
+  /* ------------------------------------------------------------------
+   * Open GML file using OGR.
+   * ------------------------------------------------------------------ */
+  if ((status = msOGRLayerOpen(lp, psInfo->pszGMLFilename)) != MS_SUCCESS)
+    return status;
+
+  status = msOGRLayerWhichShapes(lp, rect, isQuery);
+
+  /* Mark that the OGR Layer is valid */
+  psInfo->bLayerHasValidGML = MS_TRUE;
+
+  return status;
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerWhichShapes()");
+  return (MS_FAILURE);
+
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSLayerClose()
+ *
+ **********************************************************************/
+
+int msWFSLayerClose(layerObj *lp) {
+#ifdef USE_WFS_LYR
+
+  /* ------------------------------------------------------------------
+   * Cleanup OGR connection
+   * ------------------------------------------------------------------ */
+  if (lp->layerinfo)
+    msOGRLayerClose(lp);
+
+  /* ------------------------------------------------------------------
+   * Cleanup WFS connection info.
+   * __TODO__ For now we flush everything, but we should try to cache some stuff
+   * ------------------------------------------------------------------ */
+  /* __TODO__ unlink()  .gml file and OGR's schema file if they exist */
+  /* unlink( */
+
+  msFreeWFSLayerInfo(lp->wfslayerinfo);
+  lp->wfslayerinfo = NULL;
+
+  return MS_SUCCESS;
+
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msWFSLayerClose()");
+  return (MS_FAILURE);
+
+#endif /* USE_WFS_LYR */
+}
+
+/**********************************************************************
+ *                          msWFSExecuteGetFeature()
+ * Returns the temporary gml file name. User shpuld free the return string.
+ **********************************************************************/
+char *msWFSExecuteGetFeature(layerObj *lp) {
+#ifdef USE_WFS_LYR
+  char *gmltmpfile = NULL;
+  msWFSLayerInfo *psInfo = NULL;
+
+  if (lp == NULL || lp->connectiontype != MS_WFS)
+    return NULL;
+
+  msWFSLayerOpen(lp, NULL, NULL);
+  psInfo = (msWFSLayerInfo *)lp->wfslayerinfo;
+  if (psInfo && psInfo->pszGMLFilename)
+    gmltmpfile = msStrdup(psInfo->pszGMLFilename);
+  msWFSLayerClose(lp);
+
+  return gmltmpfile;
+
+#else
+  /* ------------------------------------------------------------------
+   * WFS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
+             "msExecuteWFSGetFeature()");
+  return NULL;
+
+#endif /* USE_WFS_LYR */
+}
+
+int msWFSLayerInitializeVirtualTable(layerObj *layer) {
+  assert(layer != NULL);
+  assert(layer->vtable != NULL);
+
+  layer->vtable->LayerInitItemInfo = msWFSLayerInitItemInfo;
+  layer->vtable->LayerFreeItemInfo = msOGRLayerFreeItemInfo; /* yes, OGR */
+  layer->vtable->LayerOpen = msWFSLayerOpenVT;
+  layer->vtable->LayerIsOpen = msWFSLayerIsOpen;
+  layer->vtable->LayerWhichShapes = msWFSLayerWhichShapes;
+  layer->vtable->LayerNextShape = msWFSLayerNextShape;
+  /* layer->vtable->LayerResultsGetShape = msWFSLayerResultGetShape; */
+  /* layer->vtable->LayerGetShapeCount, use default */
+  layer->vtable->LayerGetShape = msWFSLayerGetShape;
+  layer->vtable->LayerClose = msWFSLayerClose;
+  layer->vtable->LayerGetItems = msWFSLayerGetItems;
+  layer->vtable->LayerGetExtent = msWFSLayerGetExtent;
+  /* layer->vtable->LayerGetAutoStyle, use default */
+  /* layer->vtable->LayerApplyFilterToLayer, use default */
+  /* layer->vtable->LayerCloseConnection, use default */
+  layer->vtable->LayerSetTimeFilter = msLayerMakePlainTimeFilter;
+  /* layer->vtable->LayerCreateItems, use default */
+  /* layer->vtable->LayerGetNumFeatures, use default */
+  /* layer->vtable->LayerGetAutoProjection, use defaut*/
+
+  return MS_SUCCESS;
+}
diff -pruN 8.0.1-5/src/mapwms.cpp 8.2.0~beta1-1~exp1/src/mapwms.cpp
--- 8.0.1-5/src/mapwms.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwms.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5832 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  OpenGIS Web Mapping Service support implementation.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#define NEED_IGNORE_RET_VAL
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapthread.h"
+#include "mapgml.h"
+#include <ctype.h>
+#include "maptemplate.h"
+#include "mapows.h"
+
+#include "mapogcsld.h"
+#include "mapogcfilter.h"
+#include "mapowscommon.h"
+
+#include "maptime.h"
+#include "mapproject.h"
+
+#include <cassert>
+#include <stdarg.h>
+#include <time.h>
+#include <string.h>
+
+#include <set>
+#include <string>
+#include <vector>
+
+#ifdef _WIN32
+#include <process.h>
+#endif
+
+/* ==================================================================
+ * WMS Server stuff.
+ * ================================================================== */
+#ifdef USE_WMS_SVR
+
+/*
+** msWMSException()
+**
+** Report current MapServer error in requested format.
+*/
+
+static int msWMSException(mapObj *map, int nVersion, const char *exception_code,
+                          const char *wms_exception_format) {
+  char *schemalocation = NULL;
+
+  /* Default to WMS 1.3.0 exceptions if version not set yet */
+  if (nVersion <= 0)
+    nVersion = OWS_1_3_0;
+
+  /* get scheam location */
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  /* Establish default exception format depending on VERSION */
+  if (wms_exception_format == NULL) {
+    if (nVersion <= OWS_1_0_0)
+      wms_exception_format = "INIMAGE"; /* WMS 1.0.0 */
+    else if (nVersion <= OWS_1_0_7)
+      wms_exception_format = "SE_XML"; /* WMS 1.0.1 to 1.0.7 */
+    else if (nVersion <= OWS_1_1_1)
+      wms_exception_format =
+          "application/vnd.ogc.se_xml"; /* WMS 1.1.0 and later */
+    else
+      wms_exception_format = "text/xml";
+  }
+
+  if (strcasecmp(wms_exception_format, "INIMAGE") == 0 ||
+      strcasecmp(wms_exception_format, "BLANK") == 0 ||
+      strcasecmp(wms_exception_format, "application/vnd.ogc.se_inimage") == 0 ||
+      strcasecmp(wms_exception_format, "application/vnd.ogc.se_blank") == 0) {
+    int blank = 0;
+
+    if (strcasecmp(wms_exception_format, "BLANK") == 0 ||
+        strcasecmp(wms_exception_format, "application/vnd.ogc.se_blank") == 0) {
+      blank = 1;
+    }
+
+    msWriteErrorImage(map, NULL, blank);
+
+  } else if (strcasecmp(wms_exception_format, "WMS_XML") ==
+             0) { /* Only in V1.0.0 */
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+    msIO_sendHeaders();
+
+    msIO_printf("<WMTException version=\"1.0.0\">\n");
+    msWriteErrorXML(stdout);
+    msIO_printf("</WMTException>\n");
+  } else /* XML error, the default: SE_XML (1.0.1 to 1.0.7) */
+  /* or application/vnd.ogc.se_xml (1.1.0 and later) */
+  {
+    if (nVersion <= OWS_1_0_7) {
+      /* In V1.0.1 to 1.0.7, the MIME type was text/xml */
+      msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+      msIO_sendHeaders();
+
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+      msIO_printf(
+          "<!DOCTYPE ServiceExceptionReport SYSTEM "
+          "\"http://www.digitalearth.gov/wmt/xml/exception_1_0_1.dtd\">\n");
+
+      msIO_printf("<ServiceExceptionReport version=\"1.0.1\">\n");
+    } else if (nVersion <= OWS_1_1_0) {
+      /* In V1.1.0 and later, we have OGC-specific MIME types */
+      /* we cannot return anything else than application/vnd.ogc.se_xml here. */
+      msIO_setHeader("Content-Type",
+                     "application/vnd.ogc.se_xml; charset=UTF-8");
+      msIO_sendHeaders();
+
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+
+      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM "
+                  "\"%s/wms/1.1.0/exception_1_1_0.dtd\">\n",
+                  schemalocation);
+
+      msIO_printf("<ServiceExceptionReport version=\"1.1.0\">\n");
+    } else if (nVersion <= OWS_1_1_1) { /* 1.1.1 */
+      msIO_setHeader("Content-Type",
+                     "application/vnd.ogc.se_xml; charset=UTF-8");
+      msIO_sendHeaders();
+
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM "
+                  "\"%s/wms/1.1.1/exception_1_1_1.dtd\">\n",
+                  schemalocation);
+      msIO_printf("<ServiceExceptionReport version=\"1.1.1\">\n");
+    } else { /*1.3.0*/
+      if (strcasecmp(wms_exception_format, "application/vnd.ogc.se_xml") == 0) {
+        msIO_setHeader("Content-Type",
+                       "application/vnd.ogc.se_xml; charset=UTF-8");
+      } else {
+        msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+      }
+      msIO_sendHeaders();
+
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+      msIO_printf("<ServiceExceptionReport version=\"1.3.0\" "
+                  "xmlns=\"http://www.opengis.net/ogc\" "
+                  "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+                  "xsi:schemaLocation=\"http://www.opengis.net/ogc "
+                  "%s/wms/1.3.0/exceptions_1_3_0.xsd\">\n",
+                  schemalocation);
+    }
+
+    if (exception_code)
+      msIO_printf("<ServiceException code=\"%s\">\n", exception_code);
+    else
+      msIO_printf("<ServiceException>\n");
+    msWriteErrorXML(stdout);
+    msIO_printf("</ServiceException>\n");
+    msIO_printf("</ServiceExceptionReport>\n");
+  }
+  free(schemalocation);
+
+  return MS_FAILURE; /* so that we can call 'return msWMSException();' anywhere
+                      */
+}
+
+static bool msWMSSetTimePattern(const char *timepatternstring,
+                                const char *timestring, bool checkonly) {
+  if (timepatternstring && timestring) {
+    /* parse the time parameter to extract a distinct time. */
+    /* time value can be dicrete times (eg 2004-09-21), */
+    /* multiple times (2004-09-21, 2004-09-22, ...) */
+    /* and range(s) (2004-09-21/2004-09-25, 2004-09-27/2004-09-29) */
+    const auto atimes = msStringSplit(timestring, ',');
+
+    /* get the pattern to use */
+    if (!atimes.empty()) {
+      auto patterns = msStringSplit(timepatternstring, ',');
+      for (auto &pattern : patterns) {
+        msStringTrimBlanks(pattern);
+        msStringTrimLeft(pattern);
+      }
+
+      for (const auto &atime : atimes) {
+        const auto ranges = msStringSplit(atime.c_str(), '/');
+        for (const auto &range : ranges) {
+          bool match = false;
+          for (const auto &pattern : patterns) {
+            if (!pattern.empty()) {
+              if (msTimeMatchPattern(range.c_str(), pattern.c_str()) ==
+                  MS_TRUE) {
+                if (!checkonly)
+                  msSetLimitedPatternsToUse(pattern.c_str());
+                match = true;
+                break;
+              }
+            }
+          }
+          if (!match) {
+            msSetError(
+                MS_WMSERR,
+                "Time value %s given does not match the time format pattern.",
+                "msWMSSetTimePattern", range.c_str());
+            return false;
+          }
+        }
+      }
+    }
+  }
+
+  return true;
+}
+
+/*
+** Apply the TIME parameter to layers that are time aware
+*/
+static int msWMSApplyTime(mapObj *map, int version, const char *time,
+                          const char *wms_exception_format) {
+  if (map) {
+
+    const char *timepattern =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "timeformat");
+
+    for (int i = 0; i < map->numlayers; i++) {
+      layerObj *lp = (GET_LAYER(map, i));
+      if (lp->status != MS_ON && lp->status != MS_DEFAULT)
+        continue;
+
+      /* check if the layer is time aware */
+      const char *timeextent =
+          msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
+      const char *timefield =
+          msOWSLookupMetadata(&(lp->metadata), "MO", "timeitem");
+      const char *timedefault =
+          msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault");
+
+      if (timeextent && timefield) {
+        /* check to see if the time value is given. If not */
+        /* use default time. If default time is not available */
+        /* send an exception */
+        if (time == NULL || strlen(time) <= 0) {
+          if (timedefault == NULL) {
+            msSetError(
+                MS_WMSERR,
+                "No Time value was given, and no default time value defined.",
+                "msWMSApplyTime");
+            return msWMSException(map, version, "MissingDimensionValue",
+                                  wms_exception_format);
+          } else {
+            if (msValidateTimeValue((char *)timedefault, timeextent) ==
+                MS_FALSE) {
+              msSetError(MS_WMSERR,
+                         "No Time value was given, and the default time value "
+                         "%s is invalid or outside the time extent defined %s",
+                         "msWMSApplyTime", timedefault, timeextent);
+              /* return MS_FALSE; */
+              return msWMSException(map, version, "InvalidDimensionValue",
+                                    wms_exception_format);
+            }
+            msLayerSetTimeFilter(lp, timedefault, timefield);
+          }
+        } else {
+          /*
+          ** Check to see if there is a list of possible patterns defined. If it
+          *is the case, use
+          ** it to set the time pattern to use for the request.
+          **
+          ** Last argument is set to TRUE (checkonly) to not trigger the
+          *patterns info setting, rather
+          ** to only apply the wms_timeformats on the user request values, not
+          *the mapfile values.
+          */
+          if (timepattern && time && strlen(time) > 0) {
+            if (!msWMSSetTimePattern(timepattern, time, true))
+              return msWMSException(map, version, "InvalidDimensionValue",
+                                    wms_exception_format);
+          }
+
+          /* check if given time is in the range */
+          if (msValidateTimeValue(time, timeextent) == MS_FALSE) {
+            if (timedefault == NULL) {
+              msSetError(MS_WMSERR,
+                         "Time value(s) %s given is invalid or outside the "
+                         "time extent defined (%s).",
+                         "msWMSApplyTime", time, timeextent);
+              /* return MS_FALSE; */
+              return msWMSException(map, version, "InvalidDimensionValue",
+                                    wms_exception_format);
+            } else {
+              if (msValidateTimeValue((char *)timedefault, timeextent) ==
+                  MS_FALSE) {
+                msSetError(
+                    MS_WMSERR,
+                    "Time value(s) %s given is invalid or outside the time "
+                    "extent defined (%s), and default time set is invalid (%s)",
+                    "msWMSApplyTime", time, timeextent, timedefault);
+                /* return MS_FALSE; */
+                return msWMSException(map, version, "InvalidDimensionValue",
+                                      wms_exception_format);
+              } else
+                msLayerSetTimeFilter(lp, timedefault, timefield);
+            }
+
+          } else {
+            /* build the time string */
+            msLayerSetTimeFilter(lp, time, timefield);
+            timeextent = NULL;
+          }
+        }
+      }
+    }
+
+    /* last argument is MS_FALSE to trigger a method call that set the patterns
+       info. some drivers use it */
+    if (timepattern && time && strlen(time) > 0) {
+      if (!msWMSSetTimePattern(timepattern, time, false))
+        return msWMSException(map, version, "InvalidDimensionValue",
+                              wms_exception_format);
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** Apply the FILTER parameter to layers (RFC118)
+*/
+static int msWMSApplyFilter(mapObj *map, int version, const char *filter,
+                            int def_srs_needs_axis_swap,
+                            const char *wms_exception_format,
+                            owsRequestObj *ows_request) {
+  // Empty filter should be ignored
+  if (!filter || strlen(filter) == 0)
+    return MS_SUCCESS;
+
+  if (!map)
+    return MS_FAILURE;
+
+  /* Count number of requested layers / groups / etc.
+   * Only layers with STATUS ON were in the LAYERS request param.
+   * Layers with STATUS DEFAULT were set in the mapfile and are
+   * not expected to have a corresponding filter in the request
+   */
+  int numlayers = 0;
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *lp = NULL;
+
+    if (map->layerorder[i] != -1) {
+      lp = (GET_LAYER(map, map->layerorder[i]));
+      if (lp->status == MS_ON)
+        numlayers++;
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Parse the Filter parameter. If there are several Filter         */
+  /*      parameters, each Filter is inside parentheses.                  */
+  /* -------------------------------------------------------------------- */
+  int numfilters = 0;
+  char **paszFilters = NULL;
+  if (filter[0] == '(') {
+    paszFilters = FLTSplitFilters(filter, &numfilters);
+
+  } else if (numlayers == 1) {
+    numfilters = 1;
+    paszFilters = (char **)msSmallMalloc(sizeof(char *) * numfilters);
+    paszFilters[0] = msStrdup(filter);
+  }
+
+  if (numfilters != ows_request->numwmslayerargs) {
+    msSetError(MS_WMSERR,
+               "Wrong number of filter elements, one filter must be specified "
+               "for each requested layer or groups.",
+               "msWMSApplyFilter");
+    msFreeCharArray(paszFilters, numfilters);
+    return msWMSException(map, version, "InvalidParameterValue",
+                          wms_exception_format);
+  }
+
+  /* We're good to go. Apply each filter to the corresponding layer */
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *lp = NULL;
+
+    if (map->layerorder[i] != -1)
+      lp = (GET_LAYER(map, map->layerorder[i]));
+
+    /* Only layers with STATUS ON were in the LAYERS request param.*/
+    if (lp == NULL || lp->status != MS_ON)
+      continue;
+
+    const int curfilter = ows_request->layerwmsfilterindex[lp->index];
+
+    /* Skip empty filters */
+    assert(paszFilters);
+    assert(curfilter >= 0 && curfilter < numfilters);
+    if (paszFilters[curfilter][0] == '\0') {
+      continue;
+    }
+
+    /* Force setting a template to enable query. */
+    if (lp->_template == NULL)
+      lp->_template = msStrdup("ttt.html");
+
+    /* Parse filter */
+    FilterEncodingNode *psNode = FLTParseFilterEncoding(paszFilters[curfilter]);
+    if (!psNode) {
+      msSetError(MS_WMSERR, "Invalid or Unsupported FILTER : %s",
+                 "msWMSApplyFilter()", paszFilters[curfilter]);
+      msFreeCharArray(paszFilters, numfilters);
+      return msWMSException(map, version, "InvalidParameterValue",
+                            wms_exception_format);
+    }
+
+    /* For WMS 1.3 and up, we may need to swap the axis of bbox and geometry
+     * elements inside the filter(s)
+     */
+    if (version >= OWS_1_3_0)
+      FLTDoAxisSwappingIfNecessary(map, psNode, def_srs_needs_axis_swap);
+
+#ifdef do_we_need_this
+    FLTProcessPropertyIsNull(psNode, map, lp->index);
+
+    /*preparse the filter for gml aliases*/
+    FLTPreParseFilterForAliasAndGroup(psNode, map, lp->index, "G");
+
+    /* Check that FeatureId filters are consistent with the active layer */
+    if (FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE) {
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
+    }
+
+    /* FIXME?: could probably apply to WFS 1.1 too */
+    if (nWFSVersion >= OWS_2_0_0) {
+      int nEvaluation;
+
+      if (FLTCheckInvalidOperand(psNode) == MS_FAILURE) {
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(paszFilters, numfilters);
+        return msWFSException(map, "filter",
+                              MS_WFS_ERROR_OPERATION_PROCESSING_FAILED,
+                              paramsObj->pszVersion);
+      }
+
+      if (FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE) {
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(paszFilters, numfilters);
+        return msWFSException(map, "filter",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
+      }
+
+      psNode = FLTSimplify(psNode, &nEvaluation);
+      if (psNode == NULL) {
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(paszFilters, numfilters);
+        if (nEvaluation == 1) {
+          /* return full layer */
+          return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
+        } else {
+          /* return empty result set */
+          return MS_SUCCESS;
+        }
+      }
+    }
+
+#endif
+
+    /* Apply filter to this layer */
+
+    /* But first, start by removing any wfs_use_default_extent_for_getfeature
+     * metadata item */
+    /* that could result in the BBOX to be removed */
+    std::string old_value_wfs_use_default_extent_for_getfeature;
+    {
+      const char *old_value_tmp = msLookupHashTable(
+          &(lp->metadata), "wfs_use_default_extent_for_getfeature");
+      if (old_value_tmp) {
+        old_value_wfs_use_default_extent_for_getfeature = old_value_tmp;
+        msRemoveHashTable(&(lp->metadata),
+                          "wfs_use_default_extent_for_getfeature");
+      }
+    }
+
+    msInsertHashTable(&(lp->metadata), "gml_wmsfilter_flag", "true");
+
+    int ret = FLTApplyFilterToLayer(psNode, map, lp->index);
+
+    msRemoveHashTable(&(lp->metadata), "gml_wmsfilter_flag");
+
+    if (!old_value_wfs_use_default_extent_for_getfeature.empty()) {
+      msInsertHashTable(
+          &(lp->metadata), "wfs_use_default_extent_for_getfeature",
+          old_value_wfs_use_default_extent_for_getfeature.c_str());
+    }
+
+    if (ret != MS_SUCCESS) {
+      errorObj *ms_error = msGetErrorObj();
+
+      if (ms_error->code != MS_NOTFOUND) {
+        msSetError(MS_WMSERR, "FLTApplyFilterToLayer() failed",
+                   "msWMSApplyFilter()");
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(paszFilters, numfilters);
+        return msWMSException(map, version, "InvalidParameterValue",
+                              wms_exception_format);
+      }
+    }
+
+    FLTFreeFilterEncodingNode(psNode);
+
+  } /* for */
+
+  msFreeCharArray(paszFilters, numfilters);
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWMSPrepareNestedGroups()
+**
+** purpose: Parse WMS_LAYER_GROUP settings into arrays
+**
+** params:
+** - nestedGroups: This array holds the arrays of groups that have been set
+**                 through the WMS_LAYER_GROUP metadata
+** - numNestedGroups: This array holds the number of groups set in
+**                    WMS_LAYER_GROUP for each layer
+** - isUsedInNestedGroup: This array indicates if the layer is used as group
+**                        as set through the WMS_LAYER_GROUP metadata
+*/
+static void msWMSPrepareNestedGroups(mapObj *map, int /* nVersion */,
+                                     char ***nestedGroups, int *numNestedGroups,
+                                     int *isUsedInNestedGroup) {
+  // Create set to hold unique groups
+  std::set<std::string> uniqgroups;
+
+  for (int i = 0; i < map->numlayers; i++) {
+    nestedGroups[i] = NULL;     /* default */
+    numNestedGroups[i] = 0;     /* default */
+    isUsedInNestedGroup[i] = 0; /* default */
+
+    const char *groups = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata),
+                                             "MO", "layer_group");
+    if ((groups != NULL) && (strlen(groups) != 0)) {
+      if (GET_LAYER(map, i)->group != NULL &&
+          strlen(GET_LAYER(map, i)->group) != 0) {
+        const char *errorMsg = "It is not allowed to set both the GROUP and "
+                               "WMS_LAYER_GROUP for a layer";
+        msSetError(MS_WMSERR, errorMsg, "msWMSPrepareNestedGroups()", NULL);
+        msIO_fprintf(stdout, "<!-- ERROR: %s -->\n", errorMsg);
+        /* cannot return exception at this point because we are already writing
+         * to stdout */
+      } else {
+        if (groups[0] != '/') {
+          const char *errorMsg =
+              "The WMS_LAYER_GROUP metadata does not start with a '/'";
+          msSetError(MS_WMSERR, errorMsg, "msWMSPrepareNestedGroups()", NULL);
+          msIO_fprintf(stdout, "<!-- ERROR: %s -->\n", errorMsg);
+          /* cannot return exception at this point because we are already
+           * writing to stdout */
+        } else {
+          /* split into subgroups. Start at address + 1 because the first '/'
+           * would cause an extra empty group */
+          nestedGroups[i] = msStringSplit(groups + 1, '/', &numNestedGroups[i]);
+          /* Iterate through the groups and add them to the unique groups array
+           */
+          for (int k = 0; k < numNestedGroups[i]; k++) {
+            uniqgroups.insert(msStringToLower(std::string(nestedGroups[i][k])));
+          }
+        }
+      }
+    }
+  }
+  /* Iterate through layers to find out whether they are in any of the nested
+   * groups */
+  for (int i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->name) {
+      if (uniqgroups.find(msStringToLower(
+              std::string(GET_LAYER(map, i)->name))) != uniqgroups.end()) {
+        isUsedInNestedGroup[i] = 1;
+      }
+    }
+  }
+}
+
+/*
+** Validate that a given dimension is inside the extents defined
+*/
+static bool msWMSValidateDimensionValue(const char *value,
+                                        const char *dimensionextent,
+                                        bool forcecharacter) {
+  std::vector<pointObj> aextentranges;
+
+  bool isextentavalue = false;
+  bool isextentarange = false;
+  bool ischaracter = false;
+
+  if (forcecharacter)
+    ischaracter = true;
+
+  if (!value || !dimensionextent)
+    return false;
+
+  /*for the value, we support descrete values (2005) */
+  /* multiple values (abc, def, ...) */
+  /* and range(s) (1000/2000, 3000/5000) */
+  /** we do not support resolution*/
+
+  /* -------------------------------------------------------------------- */
+  /*      parse the extent first.                                         */
+  /* -------------------------------------------------------------------- */
+  auto extents = msStringSplit(dimensionextent, ',');
+  for (auto &extent :
+       extents) // Make sure to get by reference so that it is updated in place
+    msStringTrim(extent);
+
+  std::vector<std::string> aextentvalues;
+  if (extents.size() == 1) {
+    if (strstr(dimensionextent, "/") == NULL) {
+      /*single value*/
+      isextentavalue = true;
+      aextentvalues.push_back(dimensionextent);
+      if (!forcecharacter)
+        ischaracter = FLTIsNumeric(dimensionextent) == MS_FALSE;
+
+    } else {
+      const auto ranges = msStringSplit(dimensionextent, '/');
+      if (ranges.size() == 2 || ranges.size() == 3) {
+        /*single range*/
+        isextentarange = true;
+        aextentranges.resize(1);
+        aextentranges[0].x = atof(ranges[0].c_str());
+        aextentranges[0].y = atof(ranges[1].c_str());
+        /*ranges should be numeric*/
+        ischaracter = false;
+      }
+    }
+  } else if (extents.size() >
+             1) { /*check if it is muliple values or mutliple ranges*/
+    if (strstr(dimensionextent, "/") == NULL) {
+      /*multiple values*/
+      isextentavalue = true;
+      aextentvalues = std::move(extents);
+      if (!forcecharacter)
+        ischaracter = FLTIsNumeric(aextentvalues[0].c_str()) == MS_FALSE;
+    } else { /*multiple range extent*/
+      int isvalidextent = MS_TRUE;
+      /*ranges should be numeric*/
+      ischaracter = false;
+      isextentarange = true;
+      aextentranges.resize(extents.size());
+      size_t nextentranges = 0;
+
+      for (const auto &extent : extents) {
+        const auto onerange = msStringSplit(extent.c_str(), '/');
+        if (onerange.size() != 2 && onerange.size() != 3) {
+          isvalidextent = MS_FALSE;
+          break;
+        }
+        if (isvalidextent) {
+
+          aextentranges[nextentranges].x = atof(onerange[0].c_str());
+          aextentranges[nextentranges++].y = atof(onerange[1].c_str());
+        }
+      }
+      if (!isvalidextent) {
+        nextentranges = 0;
+        isextentarange = false;
+      }
+      aextentranges.resize(nextentranges);
+    }
+  }
+
+  /* make sure that we got a valid extent*/
+  if (!isextentavalue && !isextentarange) {
+    return false;
+  }
+
+  /*for the extent of the dimesion, we support
+  single value,  or list of mulitiple values comma separated,
+  a single range or multipe ranges */
+
+  const auto uservalues = msStringSplit(value, ',');
+  bool uservaluevalid = false;
+  if (uservalues.size() == 1) {
+    /*user iput=single*/
+    /*is it descret or range*/
+    const auto ranges = msStringSplit(uservalues[0].c_str(), '/');
+    if (ranges.size() == 1) { /*discrete*/
+      if (isextentavalue) {
+        /*single user value, single/multiple values extent*/
+        for (const auto &extentvalue : aextentvalues) {
+          if (ischaracter)
+            uservaluevalid = (uservalues[0] == extentvalue);
+          else {
+            if (atof(uservalues[0].c_str()) == atof(extentvalue.c_str()))
+              uservaluevalid = true;
+          }
+          if (uservaluevalid)
+            break;
+        }
+      } else if (isextentarange) {
+        /*single user value, single/multiple range extent*/
+        const float currentval = atof(uservalues[0].c_str());
+
+        for (const auto &extentrange : aextentranges) {
+          const float minval = extentrange.x;
+          const float maxval = extentrange.y;
+          if (currentval >= minval && currentval <= maxval) {
+            uservaluevalid = true;
+            break;
+          }
+        }
+      }
+    } else if (ranges.size() == 2 || ranges.size() == 3) { /*range*/
+      /*user input=single range. In this case the extents must
+       be of a range type.*/
+      const float mincurrentval = atof(ranges[0].c_str());
+      const float maxcurrentval = atof(ranges[1].c_str());
+      if (isextentarange) {
+        for (const auto &extentrange : aextentranges) {
+          const float minval = extentrange.x;
+          const float maxval = extentrange.y;
+
+          if (minval <= mincurrentval && maxval >= maxcurrentval &&
+              minval <= maxval) {
+            uservaluevalid = true;
+            break;
+          }
+        }
+      }
+    }
+  } else if (uservalues.size() > 1) { /*user input=multiple*/
+    if (strstr(value, "/") == NULL) {
+      /*user input=multiple value*/
+      bool valueisvalid = false;
+      for (const auto &uservalue : uservalues) {
+        valueisvalid = false;
+        if (isextentavalue) {
+          /*user input is multiple values, extent is defned as one or multiple
+           * values*/
+          for (const auto &extentvalue : aextentvalues) {
+            if (ischaracter) {
+              if (uservalue == extentvalue) {
+                valueisvalid = true;
+                break;
+              }
+            } else {
+              if (atof(uservalue.c_str()) == atof(extentvalue.c_str())) {
+                valueisvalid = true;
+                break;
+              }
+            }
+          }
+          /*every value shoule be valid*/
+          if (!valueisvalid)
+            break;
+        } else if (isextentarange) {
+          /*user input is multiple values, extent is defned as one or multiple
+           * ranges*/
+          for (const auto &extentrange : aextentranges) {
+            const float minval = extentrange.x;
+            const float maxval = extentrange.y;
+            const float currentval = atof(uservalue.c_str());
+            if (minval <= currentval && maxval >= currentval &&
+                minval <= maxval) {
+              valueisvalid = true;
+              break;
+            }
+          }
+          if (!valueisvalid)
+            break;
+        }
+      }
+      uservaluevalid = valueisvalid;
+    } else { /*user input multiple ranges*/
+      bool valueisvalid = true;
+
+      for (const auto &uservalue : uservalues) {
+        /*each ranges should be valid*/
+        const auto onerange = msStringSplit(uservalue.c_str(), '/');
+        if (onerange.size() == 2 || onerange.size() == 3) {
+          const float mincurrentval = atof(onerange[0].c_str());
+          const float maxcurrentval = atof(onerange[1].c_str());
+
+          /*extent must be defined also as a rangle*/
+          if (isextentarange) {
+            bool found = false;
+            for (const auto &extentrange : aextentranges) {
+              const float mincurrentrange = extentrange.x;
+              const float maxcurrentrange = extentrange.y;
+
+              if (mincurrentval >= mincurrentrange &&
+                  maxcurrentval <= maxcurrentrange &&
+                  mincurrentval <= maxcurrentval) {
+                found = true;
+                break;
+              }
+            }
+            if (!found) {
+              valueisvalid = false;
+              break;
+            }
+          }
+        } else {
+          valueisvalid = false;
+        }
+      }
+      uservaluevalid = valueisvalid;
+    }
+  }
+
+  return uservaluevalid;
+}
+
+static bool msWMSApplyDimensionLayer(layerObj *lp, const char *item,
+                                     const char *value, bool forcecharacter) {
+  bool result = false;
+
+  if (lp && item && value) {
+    /*for the value, we support descrete values (2005) */
+    /* multiple values (abc, def, ...) */
+    /* and range(s) (1000/2000, 3000/5000) */
+    char *pszExpression = FLTGetExpressionForValuesRanges(
+        lp, item, value, forcecharacter ? MS_TRUE : MS_FALSE);
+
+    if (pszExpression) {
+      // If tileindex is set, the filter is applied to tileindex too.
+      int tlpindex = -1;
+      if (lp->tileindex &&
+          (tlpindex = msGetLayerIndex(lp->map, lp->tileindex)) != -1) {
+        result = FLTApplyExpressionToLayer((GET_LAYER(lp->map, tlpindex)),
+                                           pszExpression) != MS_FALSE;
+      } else {
+        result = true;
+      }
+      result &= FLTApplyExpressionToLayer(lp, pszExpression) != MS_FALSE;
+      msFree(pszExpression);
+    }
+  }
+  return result;
+}
+
+static bool msWMSApplyDimension(layerObj *lp, int /* version */,
+                                const char *dimensionname, const char *value,
+                                const char * /* wms_exception_format */) {
+  bool forcecharacter = false;
+  bool result = false;
+
+  if (lp && dimensionname && value) {
+    /*check if the dimension name passes starts with dim_. All dimensions should
+     * start with dim_, except elevation*/
+    std::string dimension;
+    if (strncasecmp(dimensionname, "dim_", 4) == 0)
+      dimension = dimensionname + 4;
+    else
+      dimension = dimensionname;
+
+    /*if value is empty and a default is defined, use it*/
+    std::string currentvalue;
+    if (strlen(value) > 0)
+      currentvalue = value;
+    else {
+      const char *dimensiondefault = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_default").c_str());
+      if (dimensiondefault)
+        currentvalue = dimensiondefault;
+    }
+
+    /*check if the manadatory metada related to the dimension are set*/
+    const char *dimensionitem = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_item").c_str());
+    const char *dimensionextent = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_extent").c_str());
+    const char *dimensionunit = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_units").c_str());
+
+    /*if the server want to force the type to character*/
+    const char *dimensiontype = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_type").c_str());
+    if (dimensiontype && strcasecmp(dimensiontype, "Character") == 0)
+      forcecharacter = true;
+
+    if (dimensionitem && dimensionextent && dimensionunit &&
+        !currentvalue.empty()) {
+      if (msWMSValidateDimensionValue(currentvalue.c_str(), dimensionextent,
+                                      forcecharacter)) {
+        result = msWMSApplyDimensionLayer(lp, dimensionitem,
+                                          currentvalue.c_str(), forcecharacter);
+      } else {
+        msSetError(MS_WMSERR,
+                   "Dimension %s with a value of %s is invalid or outside the "
+                   "extents defined",
+                   "msWMSApplyDimension", dimension.c_str(),
+                   currentvalue.c_str());
+        result = false;
+      }
+    } else
+      msSetError(MS_WMSERR,
+                 "Dimension %s : invalid settings. Make sure that item, units "
+                 "and extent are set.",
+                 "msWMSApplyDimension", dimension.c_str());
+  }
+  return result;
+}
+/*
+**
+*/
+int msWMSLoadGetMapParams(mapObj *map, int nVersion, char **names,
+                          char **values, int numentries,
+                          const char *wms_exception_format,
+                          const char * /*wms_request*/,
+                          owsRequestObj *ows_request) {
+  bool adjust_extent = false;
+  bool nonsquare_enabled = false;
+  int transparent = MS_NOOVERRIDE;
+  bool bbox_pixel_is_point = false;
+  outputFormatObj *format = NULL;
+  int validlayers = 0;
+  const char *styles = NULL;
+  int invalidlayers = 0;
+  std::string epsgbuf;
+  std::string srsbuffer;
+  bool epsgvalid = false;
+  bool timerequest = false;
+  const char *stime = NULL;
+  bool srsfound = false;
+  bool bboxfound = false;
+  bool formatfound = false;
+  bool widthfound = false;
+  bool heightfound = false;
+  const char *request = NULL;
+  int status = 0;
+  const char *layerlimit = NULL;
+  bool tiled = false;
+
+  const char *sldenabled = NULL;
+  const char *sld_url = NULL;
+  const char *sld_body = NULL;
+
+  const char *filter = NULL;
+
+  /* Some of the getMap parameters are actually required depending on the */
+  /* request, but for now we assume all are optional and the map file */
+  /* defaults will apply. */
+
+  msAdjustExtent(&(map->extent), map->width, map->height);
+
+  /*
+    Check for SLDs first. If SLD is available LAYERS and STYLES parameters are
+    non mandatory
+   */
+  for (int i = 0; i < numentries; i++) {
+    /* check if SLD is passed.  If yes, check for OGR support */
+    if (strcasecmp(names[i], "SLD") == 0 ||
+        strcasecmp(names[i], "SLD_BODY") == 0) {
+      sldenabled =
+          msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
+
+      if (sldenabled == NULL) {
+        sldenabled = "true";
+      }
+
+      if (strcasecmp(sldenabled, "true") == 0) {
+        if (strcasecmp(names[i], "SLD") == 0) {
+          sld_url = values[i];
+        }
+        if (strcasecmp(names[i], "SLD_BODY") == 0) {
+          sld_body = values[i];
+        }
+      }
+    }
+  }
+
+  std::vector<std::string> wmslayers;
+  for (int i = 0; i < numentries; i++) {
+    /* getMap parameters */
+
+    if (strcasecmp(names[i], "REQUEST") == 0) {
+      request = values[i];
+    }
+
+    if (strcasecmp(names[i], "LAYERS") == 0) {
+      std::vector<int> layerOrder(map->numlayers);
+
+      wmslayers = msStringSplit(values[i], ',');
+      if (wmslayers.empty()) {
+        if (sld_url == NULL && sld_body == NULL) {
+          msSetError(MS_WMSERR, "At least one layer name required in LAYERS.",
+                     "msWMSLoadGetMapParams()");
+          return msWMSException(map, nVersion, NULL, wms_exception_format);
+        }
+      }
+
+      if (nVersion >= OWS_1_3_0) {
+        layerlimit =
+            msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
+        if (layerlimit) {
+          if (static_cast<int>(wmslayers.size()) > atoi(layerlimit)) {
+            msSetError(MS_WMSERR,
+                       "Number of layers requested exceeds LayerLimit.",
+                       "msWMSLoadGetMapParams()");
+            return msWMSException(map, nVersion, NULL, wms_exception_format);
+          }
+        }
+      }
+
+      for (int iLayer = 0; iLayer < map->numlayers; iLayer++) {
+        map->layerorder[iLayer] = iLayer;
+      }
+
+      int nLayerOrder = 0;
+      for (int j = 0; j < map->numlayers; j++) {
+        /* Keep only layers with status=DEFAULT by default */
+        /* Layer with status DEFAULT is drawn first. */
+        if (GET_LAYER(map, j)->status != MS_DEFAULT)
+          GET_LAYER(map, j)->status = MS_OFF;
+        else {
+          map->layerorder[nLayerOrder++] = j;
+          layerOrder[j] = 1;
+        }
+      }
+
+      char ***nestedGroups =
+          (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+      int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      int *isUsedInNestedGroup =
+          (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                               isUsedInNestedGroup);
+
+      if (ows_request->layerwmsfilterindex != NULL)
+        msFree(ows_request->layerwmsfilterindex);
+      ows_request->layerwmsfilterindex =
+          (int *)msSmallMalloc(map->numlayers * sizeof(int));
+      for (int j = 0; j < map->numlayers; j++) {
+        ows_request->layerwmsfilterindex[j] = -1;
+      }
+      ows_request->numwmslayerargs = static_cast<int>(wmslayers.size());
+
+      for (int k = 0; k < static_cast<int>(wmslayers.size()); k++) {
+        const auto &wmslayer = wmslayers[k];
+        bool layerfound = false;
+        for (int j = 0; j < map->numlayers; j++) {
+          /* Turn on selected layers only. */
+          if (((GET_LAYER(map, j)->name &&
+                strcasecmp(GET_LAYER(map, j)->name, wmslayer.c_str()) == 0) ||
+               (map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
+               (GET_LAYER(map, j)->group &&
+                strcasecmp(GET_LAYER(map, j)->group, wmslayer.c_str()) == 0) ||
+               ((numNestedGroups[j] > 0) &&
+                msStringInArray(wmslayer.c_str(), nestedGroups[j],
+                                numNestedGroups[j]))) &&
+              ((msIntegerInArray(GET_LAYER(map, j)->index,
+                                 ows_request->enabled_layers,
+                                 ows_request->numlayers)))) {
+            if (GET_LAYER(map, j)->status != MS_DEFAULT) {
+              if (layerOrder[j] == 0) {
+                map->layerorder[nLayerOrder++] = j;
+                layerOrder[j] = 1;
+                GET_LAYER(map, j)->status = MS_ON;
+              }
+            }
+            /* if a layer name is repeated assign the first matching filter */
+            /* duplicate names will be assigned filters later when layer copies
+             * are created */
+            if (ows_request->layerwmsfilterindex[j] == -1) {
+              ows_request->layerwmsfilterindex[j] = k;
+            }
+            validlayers++;
+            layerfound = true;
+          }
+        }
+        if (layerfound == false && !wmslayers.empty())
+          invalidlayers++;
+      }
+
+      /* free the stuff used for nested layers */
+      for (int k = 0; k < map->numlayers; k++) {
+        if (numNestedGroups[k] > 0) {
+          msFreeCharArray(nestedGroups[k], numNestedGroups[k]);
+        }
+      }
+      free(nestedGroups);
+      free(numNestedGroups);
+      free(isUsedInNestedGroup);
+
+      /* set all layers with status off at end of array */
+      for (int j = 0; j < map->numlayers; j++) {
+        if (GET_LAYER(map, j)->status == MS_OFF)
+          if (layerOrder[j] == 0)
+            map->layerorder[nLayerOrder++] = j;
+      }
+    } else if (strcasecmp(names[i], "STYLES") == 0) {
+      styles = values[i];
+
+    } else if ((strcasecmp(names[i], "SRS") == 0 && nVersion < OWS_1_3_0) ||
+               (strcasecmp(names[i], "CRS") == 0 && nVersion >= OWS_1_3_0)) {
+      srsfound = true;
+      char *colon = strchr(values[i], ':');
+      bool srsOk = false;
+      /* SRS is in format "EPSG:epsg_id" or "AUTO:proj_id,unit_id,lon0,lat0" */
+      if (strncasecmp(values[i], "EPSG:", 5) == 0) {
+        srsOk = true;
+        /* SRS=EPSG:xxxx */
+
+        /* don't need to copy init=xxx since the srsbuffer is only
+           used with msLoadProjection and that does already the job */
+
+        srsbuffer = "EPSG:";
+        srsbuffer += (values[i] + 5);
+        epsgbuf = srsbuffer;
+
+        /* This test was to correct a request by the OCG cite 1.3.0 test
+         sending CRS=ESPG:4326,  Bug:*/
+        if (nVersion >= OWS_1_3_0) {
+          if (srsbuffer.back() == ',') {
+            srsbuffer.resize(srsbuffer.size() - 1);
+            epsgbuf = srsbuffer;
+          }
+        }
+
+        /* we need to wait until all params are read before */
+        /* loading the projection into the map. This will help */
+        /* insure that the passes srs is valid for all layers. */
+        /*
+        if (msLoadProjectionString(&(map->projection), buffer) != 0)
+          return msWMSException(map, nVersion, NULL);
+
+        iUnits = GetMapserverUnitUsingProj(&(map->projection));
+        if (iUnits != -1)
+          map->units = iUnits;
+        */
+      } else if (strncasecmp(values[i], "AUTO:", 5) == 0 &&
+                 nVersion < OWS_1_3_0) {
+        if (nVersion < OWS_1_3_0) {
+          srsOk = true;
+          srsbuffer = values[i];
+          /* SRS=AUTO:proj_id,unit_id,lon0,lat0 */
+          /*
+          if (msLoadProjectionString(&(map->projection), values[i]) != 0)
+            return msWMSException(map, nVersion, NULL);
+
+          iUnits = GetMapserverUnitUsingProj(&(map->projection));
+          if (iUnits != -1)
+            map->units = iUnits;
+          */
+        }
+      } else if (strncasecmp(values[i], "AUTO2:", 6) == 0 ||
+                 strncasecmp(values[i], "CRS:", 4) == 0) {
+        if (nVersion >= OWS_1_3_0) {
+          srsOk = true;
+          srsbuffer = values[i];
+        }
+      } else if (colon != NULL && strchr(colon + 1, ':') == NULL) {
+        srsOk = true;
+        srsbuffer = values[i];
+        epsgbuf = srsbuffer;
+      }
+      if (!srsOk) {
+        if (nVersion >= OWS_1_3_0) {
+          msSetError(MS_WMSERR,
+                     "Unsupported CRS namespace (CRS must be in the format "
+                     "AUTH:XXXX).",
+                     "msWMSLoadGetMapParams()");
+          return msWMSException(map, nVersion, "InvalidCRS",
+                                wms_exception_format);
+        } else {
+          msSetError(MS_WMSERR,
+                     "Unsupported SRS namespace (SRS must be in the format "
+                     "AUTH:XXXX).",
+                     "msWMSLoadGetMapParams()");
+          return msWMSException(map, nVersion, "InvalidSRS",
+                                wms_exception_format);
+        }
+      }
+    } else if (strcasecmp(names[i], "BBOX") == 0) {
+      bboxfound = true;
+      const auto tokens = msStringSplit(values[i], ',');
+      if (tokens.size() != 4) {
+        msSetError(MS_WMSERR, "Wrong number of arguments for BBOX.",
+                   "msWMSLoadGetMapParams()");
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+      }
+      map->extent.minx = atof(tokens[0].c_str());
+      map->extent.miny = atof(tokens[1].c_str());
+      map->extent.maxx = atof(tokens[2].c_str());
+      map->extent.maxy = atof(tokens[3].c_str());
+
+      /*for wms 1.3.0 we will do the validation of the bbox after all parameters
+       are read to account for the axes order*/
+      if (nVersion < OWS_1_3_0) {
+
+        /* validate bbox values */
+        if (map->extent.minx >= map->extent.maxx ||
+            map->extent.miny >= map->extent.maxy) {
+          msSetError(MS_WMSERR, "Invalid values for BBOX.",
+                     "msWMSLoadGetMapParams()");
+          return msWMSException(map, nVersion, NULL, wms_exception_format);
+        }
+        adjust_extent = true;
+      }
+    } else if (strcasecmp(names[i], "WIDTH") == 0) {
+      widthfound = true;
+      map->width = atoi(values[i]);
+    } else if (strcasecmp(names[i], "HEIGHT") == 0) {
+      heightfound = true;
+      map->height = atoi(values[i]);
+    } else if (strcasecmp(names[i], "FORMAT") == 0) {
+      formatfound = true;
+
+      if (strcasecmp(values[i], "application/openlayers") != 0) {
+        /*check to see if a predefined list is given*/
+        const char *format_list =
+            msOWSLookupMetadata(&(map->web.metadata), "M", "getmap_formatlist");
+        if (format_list) {
+          format = msOwsIsOutputFormatValid(
+              map, values[i], &(map->web.metadata), "M", "getmap_formatlist");
+          if (format == NULL) {
+            msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                       "msWMSLoadGetMapParams()", values[i]);
+            return msWMSException(map, nVersion, "InvalidFormat",
+                                  wms_exception_format);
+          }
+        } else {
+          format = msSelectOutputFormat(map, values[i]);
+          if (format == NULL ||
+              (strncasecmp(format->driver, "MVT", 3) != 0 &&
+               strncasecmp(format->driver, "GDAL/", 5) != 0 &&
+               strncasecmp(format->driver, "AGG/", 4) != 0 &&
+               strncasecmp(format->driver, "UTFGRID", 7) != 0 &&
+               strncasecmp(format->driver, "CAIRO/", 6) != 0 &&
+               strncasecmp(format->driver, "OGL/", 4) != 0 &&
+               strncasecmp(format->driver, "KML", 3) != 0 &&
+               strncasecmp(format->driver, "KMZ", 3) != 0)) {
+            msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                       "msWMSLoadGetMapParams()", values[i]);
+            return msWMSException(map, nVersion, "InvalidFormat",
+                                  wms_exception_format);
+          }
+        }
+      }
+      msFree(map->imagetype);
+      map->imagetype = msStrdup(values[i]);
+    } else if (strcasecmp(names[i], "TRANSPARENT") == 0) {
+      transparent = (strcasecmp(values[i], "TRUE") == 0);
+    } else if (strcasecmp(names[i], "BGCOLOR") == 0) {
+      long c;
+      c = strtol(values[i], NULL, 16);
+      map->imagecolor.red = (c / 0x10000) & 0xff;
+      map->imagecolor.green = (c / 0x100) & 0xff;
+      map->imagecolor.blue = c & 0xff;
+    }
+
+    /* value of time can be empty. We should look for a default value */
+    /* see function msWMSApplyTime */
+    else if (strcasecmp(names[i], "TIME") == 0) { /* &&  values[i]) */
+      stime = values[i];
+      timerequest = true;
+    }
+    /* Vendor-specific ANGLE param (for map rotation), added in ticket #3332,
+     * also supported by GeoServer
+     */
+    else if (strcasecmp(names[i], "ANGLE") == 0) {
+      msMapSetRotation(map, atof(values[i]));
+    }
+    /* Vendor-specific bbox_pixel_is_point, added in ticket #4652 */
+    else if (strcasecmp(names[i], "BBOX_PIXEL_IS_POINT") == 0) {
+      bbox_pixel_is_point = (strcasecmp(values[i], "TRUE") == 0);
+    }
+    /* Vendor specific TILED (WMS-C) */
+    else if (strcasecmp(names[i], "TILED") == 0) {
+      tiled = (strcasecmp(values[i], "TRUE") == 0);
+    }
+    /* Vendor-specific FILTER, added in RFC-118 */
+    else if (strcasecmp(names[i], "FILTER") == 0) {
+      filter = values[i];
+    }
+  }
+
+  /*validate the exception format WMS 1.3.0 section 7.3.3.11*/
+
+  if (nVersion >= OWS_1_3_0 && wms_exception_format != NULL) {
+    if (strcasecmp(wms_exception_format, "INIMAGE") != 0 &&
+        strcasecmp(wms_exception_format, "BLANK") != 0 &&
+        strcasecmp(wms_exception_format, "XML") != 0) {
+      msSetError(MS_WMSERR, "Invalid format %s for the EXCEPTIONS parameter.",
+                 "msWMSLoadGetMapParams()", wms_exception_format);
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
+    }
+  }
+
+  int need_axis_swap = MS_FALSE;
+  if (bboxfound && nVersion >= OWS_1_3_0) {
+    rectObj rect;
+    projectionObj proj;
+
+    /*we have already validated that the request format when reading
+     the request parameters*/
+    rect = map->extent;
+
+    /*try to adjust the axes if necessary*/
+    if (srsbuffer.size() > 1) {
+      msInitProjection(&proj);
+      msProjectionInheritContextFrom(&proj, &(map->projection));
+      if (msLoadProjectionStringEPSG(&proj, srsbuffer.c_str()) == 0 &&
+          (need_axis_swap = msIsAxisInvertedProj(&proj))) {
+        msAxisNormalizePoints(&proj, 1, &rect.minx, &rect.miny);
+        msAxisNormalizePoints(&proj, 1, &rect.maxx, &rect.maxy);
+      }
+      msFreeProjection(&proj);
+    }
+    /*if the CRS is AUTO2:auto_crs_id,factor,lon0,lat0,
+     we need to grab the factor parameter and use it with the bbox*/
+    if (srsbuffer.size() > 1 &&
+        strncasecmp(srsbuffer.c_str(), "AUTO2:", 6) == 0) {
+      const auto args = msStringSplit(srsbuffer.c_str(), ',');
+      if (args.size() == 4) {
+        const double factor = atof(args[1].c_str());
+        if (factor > 0 && factor != 1.0) {
+          rect.minx = rect.minx * factor;
+          rect.miny = rect.miny * factor;
+          rect.maxx = rect.maxx * factor;
+          rect.maxx = rect.maxy * factor;
+        }
+      }
+    }
+
+    map->extent = rect;
+
+    /* validate bbox values */
+    if (map->extent.minx >= map->extent.maxx ||
+        map->extent.miny >= map->extent.maxy) {
+      msSetError(MS_WMSERR, "Invalid values for BBOX.",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+    adjust_extent = true;
+  }
+
+  if (tiled) {
+    const char *value;
+    hashTableObj *meta = &(map->web.metadata);
+    int map_edge_buffer = 0;
+
+    if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
+      map_edge_buffer = atoi(value);
+    }
+    if (map_edge_buffer > 0 && map->width > 0 && map->height > 0) {
+      /* adjust bbox and width and height to the buffer */
+      const double buffer_x = map_edge_buffer *
+                              (map->extent.maxx - map->extent.minx) /
+                              (double)map->width;
+      const double buffer_y = map_edge_buffer *
+                              (map->extent.maxy - map->extent.miny) /
+                              (double)map->height;
+
+      // TODO: we should probably clamp the extent to avoid going outside of
+      // -180,-90,180,90 for geographic CRS for example
+      map->extent.minx -= buffer_x;
+      map->extent.maxx += buffer_x;
+      map->extent.miny -= buffer_y;
+      map->extent.maxy += buffer_y;
+
+      map->width += 2 * map_edge_buffer;
+      map->height += 2 * map_edge_buffer;
+
+      if (map_edge_buffer > 0) {
+        char tilebufferstr[64];
+
+        /* Write the tile buffer to a string */
+        snprintf(tilebufferstr, sizeof(tilebufferstr), "-%d", map_edge_buffer);
+
+        /* Hm, the labelcache buffer is set... */
+        if ((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) !=
+            NULL) {
+          /* If it's too small, replace with a bigger one */
+          if (map_edge_buffer > abs(atoi(value))) {
+            msRemoveHashTable(meta, "labelcache_map_edge_buffer");
+            msInsertHashTable(meta, "labelcache_map_edge_buffer",
+                              tilebufferstr);
+          }
+        }
+        /* No labelcache buffer value? Then we use the tile buffer. */
+        else {
+          msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
+        }
+      }
+    }
+  }
+
+  /*
+  ** If any select layers have a default time, we will apply the default
+  ** time value even if no TIME request was in the url.
+  */
+  if (!timerequest && map) {
+    for (int i = 0; i < map->numlayers && !timerequest; i++) {
+      layerObj *lp = NULL;
+
+      lp = (GET_LAYER(map, i));
+      if (lp->status != MS_ON && lp->status != MS_DEFAULT)
+        continue;
+
+      if (msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault"))
+        timerequest = true;
+    }
+  }
+
+  /*
+  ** Apply time filters if available in the request.
+  */
+  if (timerequest) {
+    if (msWMSApplyTime(map, nVersion, stime, wms_exception_format) ==
+        MS_FAILURE) {
+      return MS_FAILURE; /* msWMSException(map, nVersion, "InvalidTimeRequest");
+                          */
+    }
+  }
+
+  /*
+  ** Check/apply wms dimensions
+  ** all dimension requests should start with dim_xxxx, except time and
+  *elevation.
+  */
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *lp = (GET_LAYER(map, i));
+    if (lp->status != MS_ON && lp->status != MS_DEFAULT)
+      continue;
+
+    const char *dimensionlist =
+        msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
+    if (dimensionlist) {
+      auto tokens = msStringSplit(dimensionlist, ',');
+      for (auto &token : tokens) {
+        msStringTrim(token);
+        for (int k = 0; k < numentries; k++) {
+          const std::string dimensionname(names[k]);
+
+          /*the dim_ is supposed to be part of the dimension name in the
+           * request*/
+          std::string stmp;
+          if (strcasecmp(token.c_str(), "elevation") == 0)
+            stmp = token;
+          else {
+            stmp = "dim_";
+            stmp += token;
+          }
+          if (strcasecmp(dimensionname.c_str(), stmp.c_str()) == 0) {
+            if (!msWMSApplyDimension(lp, nVersion, dimensionname.c_str(),
+                                     values[k], wms_exception_format)) {
+              return msWMSException(lp->map, nVersion, "InvalidDimensionValue",
+                                    wms_exception_format);
+            }
+            break;
+          }
+        }
+      }
+    }
+  }
+
+  /*
+  ** Apply the selected output format (if one was selected), and override
+  ** the transparency if needed.
+  */
+
+  if (format != NULL)
+    msApplyOutputFormat(&(map->outputformat), format, transparent);
+
+  /* Validate all layers given.
+  ** If an invalid layer is sent, return an exception.
+  */
+  if (validlayers == 0 || invalidlayers > 0) {
+    if (invalidlayers > 0) {
+      msSetError(
+          MS_WMSERR,
+          "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
+this request. Check wms/ows_enable_request settings.",
+          "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
+    }
+    if (validlayers == 0 && sld_url == NULL && sld_body == NULL) {
+      msSetError(MS_WMSERR, "Missing required parameter LAYERS",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+  }
+
+  /* validate srs value: When the SRS parameter in a GetMap request contains a
+  ** SRS that is valid for some, but not all of the layers being requested,
+  ** then the server shall throw a Service Exception (code = "InvalidSRS").
+  ** Validate first against epsg in the map and if no matching srs is found
+  ** validate all layers requested.
+  */
+  if (epsgbuf.size() >= 2) { /*at least 2 chars*/
+    char *projstring;
+    epsgvalid = false;
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE,
+                     &projstring);
+    if (projstring) {
+      const auto tokens = msStringSplit(projstring, ' ');
+      for (const auto &token : tokens) {
+        if (strcasecmp(token.c_str(), epsgbuf.c_str()) == 0) {
+          epsgvalid = true;
+          break;
+        }
+      }
+      msFree(projstring);
+    }
+    if (!epsgvalid) {
+      for (int i = 0; i < map->numlayers; i++) {
+        epsgvalid = false;
+        if (GET_LAYER(map, i)->status == MS_ON) {
+          msOWSGetEPSGProj(&(GET_LAYER(map, i)->projection),
+                           &(GET_LAYER(map, i)->metadata), "MO", MS_FALSE,
+                           &projstring);
+          if (projstring) {
+            const auto tokens = msStringSplit(projstring, ' ');
+            for (const auto &token : tokens) {
+              if (strcasecmp(token.c_str(), epsgbuf.c_str()) == 0) {
+                epsgvalid = true;
+                break;
+              }
+            }
+            msFree(projstring);
+          }
+          if (!epsgvalid) {
+            if (nVersion >= OWS_1_3_0) {
+              msSetError(MS_WMSERR,
+                         "Invalid CRS given : CRS must be valid for all "
+                         "requested layers.",
+                         "msWMSLoadGetMapParams()");
+              return msWMSException(map, nVersion, "InvalidSRS",
+                                    wms_exception_format);
+            } else {
+              msSetError(MS_WMSERR,
+                         "Invalid SRS given : SRS must be valid for all "
+                         "requested layers.",
+                         "msWMSLoadGetMapParams()");
+              return msWMSException(map, nVersion, "InvalidSRS",
+                                    wms_exception_format);
+            }
+          }
+        }
+      }
+    }
+  }
+
+  if (request == NULL || strcasecmp(request, "DescribeLayer") != 0) {
+    /* Validate requested image size.
+     */
+    if (map->width > map->maxsize || map->height > map->maxsize ||
+        map->width < 1 || map->height < 1) {
+      msSetError(MS_WMSERR,
+                 "Image size out of range, WIDTH and HEIGHT must be between 1 "
+                 "and %d pixels.",
+                 "msWMSLoadGetMapParams()", map->maxsize);
+
+      /* Restore valid default values in case errors INIMAGE are used */
+      map->width = 400;
+      map->height = 300;
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+
+    /* Check whether requested BBOX and width/height result in non-square pixels
+     */
+    nonsquare_enabled =
+        msTestConfigOption(map, "MS_NONSQUARE", MS_FALSE) != MS_FALSE;
+    if (!nonsquare_enabled) {
+      const double dx = MS_ABS(map->extent.maxx - map->extent.minx);
+      const double dy = MS_ABS(map->extent.maxy - map->extent.miny);
+
+      const double reqy = ((double)map->width) * dy / dx;
+
+      /* Allow up to 1 pixel of error on the width/height ratios. */
+      /* If more than 1 pixel then enable non-square pixels */
+      if (MS_ABS((reqy - (double)map->height)) > 1.0) {
+        if (map->debug)
+          msDebug("msWMSLoadGetMapParams(): enabling non-square pixels.\n");
+        msSetConfigOption(map, "MS_NONSQUARE", "YES");
+        nonsquare_enabled = true;
+      }
+    }
+  }
+
+  /* If the requested SRS is different from the default mapfile projection, or
+  ** if a BBOX resulting in non-square pixels is requested then
+  ** copy the original mapfile's projection to any layer that doesn't already
+  ** have a projection. This will prevent problems when users forget to
+  ** explicitly set a projection on all layers in a WMS mapfile.
+  */
+  if (srsbuffer.size() > 1 || nonsquare_enabled) {
+    projectionObj newProj;
+
+    if (map->projection.numargs <= 0) {
+      if (nVersion >= OWS_1_3_0) {
+        msSetError(MS_WMSERR,
+                   "Cannot set new CRS on a map that doesn't "
+                   "have any projection set. Please make sure your mapfile "
+                   "has a projection defined at the top level.",
+                   "msWMSLoadGetMapParams()");
+        return msWMSException(map, nVersion, "InvalidCRS",
+                              wms_exception_format);
+      } else {
+        msSetError(MS_WMSERR,
+                   "Cannot set new SRS on a map that doesn't "
+                   "have any projection set. Please make sure your mapfile "
+                   "has a projection defined at the top level.",
+                   "msWMSLoadGetMapParams()");
+        return msWMSException(map, nVersion, "InvalidSRS",
+                              wms_exception_format);
+      }
+    }
+
+    msInitProjection(&newProj);
+    msProjectionInheritContextFrom(&newProj, &map->projection);
+    if (srsbuffer.size() > 1) {
+      int nTmp;
+
+      if (nVersion >= OWS_1_3_0)
+        nTmp = msLoadProjectionStringEPSG(&newProj, srsbuffer.c_str());
+      else
+        nTmp = msLoadProjectionString(&newProj, srsbuffer.c_str());
+      if (nTmp != 0) {
+        msFreeProjection(&newProj);
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+      }
+    }
+
+    if (nonsquare_enabled ||
+        msProjectionsDiffer(&(map->projection), &newProj)) {
+      msMapSetLayerProjections(map);
+    }
+    msFreeProjection(&newProj);
+  }
+
+  /* apply the srs to the map file. This is only done after validating */
+  /* that the srs given as parameter is valid for all layers */
+  if (srsbuffer.size() > 1) {
+    int nTmp;
+    msFreeProjectionExceptContext(&map->projection);
+    if (nVersion >= OWS_1_3_0)
+      nTmp = msLoadProjectionStringEPSG(&(map->projection), srsbuffer.c_str());
+    else
+      nTmp = msLoadProjectionString(&(map->projection), srsbuffer.c_str());
+
+    if (nTmp != 0)
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+    nTmp = GetMapserverUnitUsingProj(&(map->projection));
+    if (nTmp != -1) {
+      map->units = static_cast<MS_UNITS>(nTmp);
+    }
+  }
+
+  if (sld_url || sld_body) {
+    char *pszLayerNames = NULL;
+    const int nLayersBefore = map->numlayers;
+
+    /* -------------------------------------------------------------------- */
+    /*      if LAYERS parameter was not given, set all layers to off        */
+    /* -------------------------------------------------------------------- */
+    if (validlayers == 0) { /*no LAYERS parameter is give*/
+      for (int j = 0; j < map->numlayers; j++) {
+        if (GET_LAYER(map, j)->status != MS_DEFAULT)
+          GET_LAYER(map, j)->status = MS_OFF;
+      }
+    }
+
+    /*apply sld if defined. This is done here so that bbox and srs are already
+     * applied*/
+    if (sld_url) {
+      if ((status = msSLDApplySLDURL(map, sld_url, -1, NULL, &pszLayerNames)) !=
+          MS_SUCCESS)
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+    } else if (sld_body) {
+      if ((status = msSLDApplySLD(map, sld_body, -1, NULL, &pszLayerNames)) !=
+          MS_SUCCESS)
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+    /* -------------------------------------------------------------------- */
+    /*      SLD and styles can use the same layer multiple times. If        */
+    /*      that is the case we duplicate the layer for drawing             */
+    /*      purpose. We need to reset the ows request enable settings (#1602)*/
+    /* -------------------------------------------------------------------- */
+    const int nLayerAfter = map->numlayers;
+    if (nLayersBefore != nLayerAfter) {
+      msOWSRequestLayersEnabled(map, "M", "GetMap", ows_request);
+    }
+
+    /* -------------------------------------------------------------------- */
+    /*      We need to take into account where the LAYERS parameter was     */
+    /*      not given (the LAYERS is option when an SLD is given). In       */
+    /*      this particular case, we need to turn on the layers             */
+    /*      identified the SLD (#1166).                                     */
+    /*                                                                      */
+    /* -------------------------------------------------------------------- */
+    if (validlayers == 0) {
+      if (pszLayerNames) {
+        const auto tokens = msStringSplit(pszLayerNames, ',');
+        for (const auto &token : tokens) {
+          for (int j = 0; j < map->numlayers; j++) {
+            if (((GET_LAYER(map, j)->name &&
+                  strcasecmp(GET_LAYER(map, j)->name, token.c_str()) == 0) ||
+                 (map->name && strcasecmp(map->name, token.c_str()) == 0) ||
+                 (GET_LAYER(map, j)->group &&
+                  strcasecmp(GET_LAYER(map, j)->group, token.c_str()) == 0)) &&
+                ((msIntegerInArray(GET_LAYER(map, j)->index,
+                                   ows_request->enabled_layers,
+                                   ows_request->numlayers)))) {
+              if (GET_LAYER(map, j)->status != MS_DEFAULT)
+                GET_LAYER(map, j)->status = MS_ON;
+            }
+          }
+        }
+      }
+    }
+    msFree(pszLayerNames);
+  }
+
+  /* Validate Styles :
+  ** MapServer advertize styles through the group setting in a class object.
+  ** If no styles are set MapServer expects to have empty values
+  ** for the styles parameter (...&STYLES=&...) Or for multiple Styles/Layers,
+  ** we could have ...&STYLES=,,,. If that is not the
+  ** case, we generate an exception.
+  */
+  if (styles && strlen(styles) > 0) {
+    bool hasCheckedLayerUnicity = false;
+    int n = 0;
+    int layerCopyIndex;
+
+    char **tokens = msStringSplitComplex(styles, ",", &n, MS_ALLOWEMPTYTOKENS);
+    for (int i = 0; i < n; i++) {
+      if (tokens[i] && strlen(tokens[i]) > 0 &&
+          strcasecmp(tokens[i], "default") != 0) {
+        if (!hasCheckedLayerUnicity) {
+          hasCheckedLayerUnicity = true;
+          bool bLayerInserted = false;
+
+          /* --------------------------------------------------------------------
+           */
+          /*      If the same layer is given more that once, we need to */
+          /*      duplicate it. */
+          /* --------------------------------------------------------------------
+           */
+          for (size_t m = 0; m < wmslayers.size(); m++) {
+            for (size_t l = m + 1; l < wmslayers.size(); l++) {
+              const int nIndex = msGetLayerIndex(map, wmslayers[m].c_str());
+              if (nIndex != -1 &&
+                  strcasecmp(wmslayers[m].c_str(), wmslayers[l].c_str()) == 0) {
+                layerObj *psTmpLayer = (layerObj *)malloc(sizeof(layerObj));
+                initLayer(psTmpLayer, map);
+                msCopyLayer(psTmpLayer, GET_LAYER(map, nIndex));
+                /* open the source layer */
+                if (!psTmpLayer->vtable)
+                  msInitializeVirtualTable(psTmpLayer);
+
+                /*make the name unique*/
+                char tmpId[128];
+                snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d", (long)time(NULL),
+                         (int)getpid(), map->numlayers);
+                if (psTmpLayer->name)
+                  msFree(psTmpLayer->name);
+                psTmpLayer->name = msStrdup(tmpId);
+                wmslayers[l] = tmpId;
+
+                layerCopyIndex = msInsertLayer(map, psTmpLayer, -1);
+
+                // expand the array mapping map layer index to filter indexes
+                ows_request->layerwmsfilterindex =
+                    (int *)msSmallRealloc(ows_request->layerwmsfilterindex,
+                                          map->numlayers * sizeof(int));
+                ows_request->layerwmsfilterindex[layerCopyIndex] =
+                    l; // the filter index matches the index of the layer name
+                       // in the WMS param
+
+                bLayerInserted = true;
+                /* layer was copied, we need to decrement its refcount */
+                MS_REFCNT_DECR(psTmpLayer);
+              }
+            }
+          }
+
+          if (bLayerInserted) {
+            msOWSRequestLayersEnabled(map, "M", "GetMap", ows_request);
+          }
+        }
+
+        if (static_cast<int>(wmslayers.size()) == n) {
+          for (int j = 0; j < map->numlayers; j++) {
+            layerObj *lp = GET_LAYER(map, j);
+            if ((lp->name && strcasecmp(lp->name, wmslayers[i].c_str()) == 0) ||
+                (lp->group &&
+                 strcasecmp(lp->group, wmslayers[i].c_str()) == 0)) {
+              bool found = false;
+              for (int k = 0; k < lp->numclasses; k++) {
+                if (lp->_class[k]->group &&
+                    strcasecmp(lp->_class[k]->group, tokens[i]) == 0) {
+                  msFree(lp->classgroup);
+                  lp->classgroup = msStrdup(tokens[i]);
+                  found = true;
+                  break;
+                }
+              }
+              if (!found) {
+                msSetError(MS_WMSERR, "Style (%s) not defined on layer.",
+                           "msWMSLoadGetMapParams()", tokens[i]);
+                msFreeCharArray(tokens, n);
+
+                return msWMSException(map, nVersion, "StyleNotDefined",
+                                      wms_exception_format);
+              }
+              /* Check the style of the root layer */
+            } else if (map->name &&
+                       strcasecmp(map->name, wmslayers[i].c_str()) == 0) {
+              const char *styleName =
+                  msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
+              if (styleName == NULL)
+                styleName = "default";
+              char *pszEncodedStyleName = msEncodeHTMLEntities(styleName);
+              if (strcasecmp(pszEncodedStyleName, tokens[i]) != 0) {
+                msSetError(MS_WMSERR, "Style (%s) not defined on root layer.",
+                           "msWMSLoadGetMapParams()", tokens[i]);
+                msFreeCharArray(tokens, n);
+                msFree(pszEncodedStyleName);
+
+                return msWMSException(map, nVersion, "StyleNotDefined",
+                                      wms_exception_format);
+              }
+              msFree(pszEncodedStyleName);
+            }
+          }
+        } else {
+          msSetError(MS_WMSERR,
+                     "Invalid style (%s). Mapserver is expecting an empty "
+                     "string for the STYLES : STYLES= or STYLES=,,, or using "
+                     "keyword default  STYLES=default,default, ...",
+                     "msWMSLoadGetMapParams()", styles);
+          msFreeCharArray(tokens, n);
+          return msWMSException(map, nVersion, "StyleNotDefined",
+                                wms_exception_format);
+        }
+      }
+    }
+    msFreeCharArray(tokens, n);
+  }
+
+  /*
+  ** WMS extents are edge to edge while MapServer extents are center of
+  ** pixel to center of pixel.  Here we try to adjust the WMS extents
+  ** in by half a pixel.  We wait till here because we want to ensure we
+  ** are doing this in terms of the correct WIDTH and HEIGHT.
+  */
+  if (adjust_extent && map->width > 1 && map->height > 1 &&
+      !bbox_pixel_is_point) {
+    double dx, dy;
+
+    dx = (map->extent.maxx - map->extent.minx) / map->width;
+    map->extent.minx += dx * 0.5;
+    map->extent.maxx -= dx * 0.5;
+
+    dy = (map->extent.maxy - map->extent.miny) / map->height;
+    map->extent.miny += dy * 0.5;
+    map->extent.maxy -= dy * 0.5;
+  }
+
+  if (request && strcasecmp(request, "DescribeLayer") != 0) {
+    if (!srsfound) {
+      if (nVersion >= OWS_1_3_0)
+        msSetError(MS_WMSERR, "Missing required parameter CRS",
+                   "msWMSLoadGetMapParams()");
+      else
+        msSetError(MS_WMSERR, "Missing required parameter SRS",
+                   "msWMSLoadGetMapParams()");
+
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+
+    if (!bboxfound) {
+      msSetError(MS_WMSERR, "Missing required parameter BBOX",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+
+    if (!formatfound && (strcasecmp(request, "GetMap") == 0 ||
+                         strcasecmp(request, "map") == 0)) {
+      msSetError(MS_WMSERR, "Missing required parameter FORMAT",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+
+    if (!widthfound) {
+      msSetError(MS_WMSERR, "Missing required parameter WIDTH",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+
+    if (!heightfound) {
+      msSetError(MS_WMSERR, "Missing required parameter HEIGHT",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+
+    if (styles == nullptr && sld_url == nullptr && sld_body == nullptr &&
+        (strcasecmp(request, "GetMap") == 0 ||
+         strcasecmp(request, "GetFeatureInfo") == 0) &&
+        msOWSLookupMetadata(&(map->web.metadata), "M",
+                            "allow_getmap_without_styles") == nullptr) {
+      msSetError(
+          MS_WMSERR,
+          "Missing required parameter STYLES. Note to service administrators: "
+          "defining the \"wms_allow_getmap_without_styles\" \"true\" "
+          "MAP.WEB.METADATA "
+          "item will disable this check (backward compatibility with behaviour "
+          "of MapServer < 8.0)",
+          "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+  }
+
+  /*
+  ** Apply vendor-specific filter if specified
+  */
+  if (filter) {
+    if (sld_url || sld_body) {
+      msSetError(MS_WMSERR,
+                 "Vendor-specific FILTER parameter cannot be used with SLD or "
+                 "SLD_BODY.",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+
+    if (msWMSApplyFilter(map, nVersion, filter, need_axis_swap,
+                         wms_exception_format, ows_request) == MS_FAILURE) {
+      return MS_FAILURE; /* msWMSException(map, nVersion,
+                            "InvalidFilterRequest"); */
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+**
+*/
+static void msWMSPrintRequestCap(int nVersion, const char *request,
+                                 const char *script_url, const char *formats,
+                                 ...) {
+  va_list argp;
+
+  msIO_printf("    <%s>\n", request);
+
+  /* We expect to receive a NULL-terminated args list of formats */
+  va_start(argp, formats);
+  const char *fmt = formats;
+  while (fmt != NULL) {
+    /* Special case for early WMS with subelements in Format (bug 908) */
+    char *encoded;
+    if (nVersion <= OWS_1_0_7) {
+      encoded = msStrdup(fmt);
+    }
+
+    /* otherwise we HTML code special characters */
+    else {
+      encoded = msEncodeHTMLEntities(fmt);
+    }
+
+    msIO_printf("      <Format>%s</Format>\n", encoded);
+    msFree(encoded);
+
+    fmt = va_arg(argp, const char *);
+  }
+  va_end(argp);
+
+  msIO_printf("      <DCPType>\n");
+  msIO_printf("        <HTTP>\n");
+  /* The URL should already be HTML encoded. */
+  if (nVersion == OWS_1_0_0) {
+    msIO_printf("          <Get onlineResource=\"%s\" />\n", script_url);
+    msIO_printf("          <Post onlineResource=\"%s\" />\n", script_url);
+  } else {
+    msIO_printf("          <Get><OnlineResource "
+                "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                "xlink:href=\"%s\"/></Get>\n",
+                script_url);
+    msIO_printf("          <Post><OnlineResource "
+                "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                "xlink:href=\"%s\"/></Post>\n",
+                script_url);
+  }
+
+  msIO_printf("        </HTTP>\n");
+  msIO_printf("      </DCPType>\n");
+  msIO_printf("    </%s>\n", request);
+}
+
+void msWMSPrintAttribution(FILE *stream, const char *tabspace,
+                           hashTableObj *metadata,
+                           const char * /*namespaces*/) {
+  if (stream && metadata) {
+    const char *title =
+        msOWSLookupMetadata(metadata, "MO", "attribution_title");
+    const char *onlineres =
+        msOWSLookupMetadata(metadata, "MO", "attribution_onlineresource");
+    const char *logourl =
+        msOWSLookupMetadata(metadata, "MO", "attribution_logourl_width");
+
+    if (title || onlineres || logourl) {
+      msIO_printf("%s<Attribution>\n", tabspace);
+      if (title) {
+        char *pszEncodedValue = msEncodeHTMLEntities(title);
+        msIO_fprintf(stream, "%s%s<Title>%s</Title>\n", tabspace, tabspace,
+                     pszEncodedValue);
+        free(pszEncodedValue);
+      }
+
+      if (onlineres) {
+        char *pszEncodedValue = msEncodeHTMLEntities(onlineres);
+        msIO_fprintf(
+            stream,
+            "%s%s<OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+            "xlink:href=\"%s\"/>\n",
+            tabspace, tabspace, pszEncodedValue);
+        free(pszEncodedValue);
+      }
+
+      if (logourl) {
+        msOWSPrintURLType(stream, metadata, "MO", "attribution_logourl",
+                          OWS_NOERR, NULL, "LogoURL", NULL, " width=\"%s\"",
+                          " height=\"%s\"",
+                          ">\n             <Format>%s</Format",
+                          "\n             <OnlineResource "
+                          "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                          " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                          "          ",
+                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "        ");
+      }
+      msIO_printf("%s</Attribution>\n", tabspace);
+    }
+  }
+}
+
+/*
+** msWMSPrintScaleHint()
+**
+** Print a Min/MaxScaleDenominator tag for the layer if applicable.
+** used for WMS >=1.3.0
+*/
+void msWMSPrintScaleDenominator(const char *tabspace, double minscaledenom,
+                                double maxscaledenom) {
+  if (minscaledenom > 0)
+    msIO_printf("%s<MinScaleDenominator>%g</MinScaleDenominator>\n", tabspace,
+                minscaledenom);
+
+  if (maxscaledenom > 0)
+    msIO_printf("%s<MaxScaleDenominator>%g</MaxScaleDenominator>\n", tabspace,
+                maxscaledenom);
+}
+
+/*
+** msWMSPrintScaleHint()
+**
+** Print a ScaleHint tag for this layer if applicable.
+**
+** (see WMS 1.1.0 sect. 7.1.5.4) The WMS defines the scalehint values as
+** the ground distance in meters of the southwest to northeast diagonal of
+** the central pixel of a map.  ScaleHint values are the min and max
+** recommended values of that diagonal.
+*/
+void msWMSPrintScaleHint(const char *tabspace, double minscaledenom,
+                         double maxscaledenom, double resolution) {
+  double scalehintmin = 0.0, scalehintmax = 0.0;
+
+  const double diag = sqrt(2.0);
+
+  if (minscaledenom > 0)
+    scalehintmin =
+        diag * (minscaledenom / resolution) / msInchesPerUnit(MS_METERS, 0);
+  if (maxscaledenom > 0)
+    scalehintmax =
+        diag * (maxscaledenom / resolution) / msInchesPerUnit(MS_METERS, 0);
+
+  if (scalehintmin > 0.0 || scalehintmax > 0.0) {
+    msIO_printf("%s<ScaleHint min=\"%.15g\" max=\"%.15g\" />\n", tabspace,
+                scalehintmin, scalehintmax);
+    if (scalehintmax == 0.0)
+      msIO_printf("%s<!-- WARNING: Only MINSCALEDENOM and no MAXSCALEDENOM "
+                  "specified in "
+                  "the mapfile. A default value of 0 has been returned for the "
+                  "Max ScaleHint but this is probably not what you want. -->\n",
+                  tabspace);
+  }
+}
+
+/*
+** msWMSPrintAuthorityURL()
+**
+** Print an AuthorityURL tag if applicable.
+*/
+void msWMSPrintAuthorityURL(FILE *stream, const char *tabspace,
+                            hashTableObj *metadata, const char *namespaces) {
+  if (stream && metadata) {
+    const char *pszWmsAuthorityName =
+        msOWSLookupMetadata(metadata, namespaces, "authorityurl_name");
+    const char *pszWMSAuthorityHref =
+        msOWSLookupMetadata(metadata, namespaces, "authorityurl_href");
+
+    /* AuthorityURL only makes sense if you have *both* the name and url */
+    if (pszWmsAuthorityName && pszWMSAuthorityHref) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "authorityurl_name", OWS_NOERR,
+          (std::string(tabspace) + "<AuthorityURL name=\"%s\">\n").c_str(),
+          NULL);
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "authorityurl_href", OWS_NOERR,
+          (std::string(tabspace) +
+           "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+           "xlink:href=\"%s\"/>\n")
+              .c_str(),
+          NULL);
+      msIO_printf("%s</AuthorityURL>\n", tabspace);
+    } else if (pszWmsAuthorityName || pszWMSAuthorityHref) {
+      msIO_printf(
+          "%s<!-- WARNING: Both wms_authorityurl_name and "
+          "wms_authorityurl_href must be set to output an AuthorityURL -->\n",
+          tabspace);
+    }
+  }
+}
+
+/*
+** msWMSPrintIdentifier()
+**
+** Print an Identifier tag if applicable.
+*/
+void msWMSPrintIdentifier(FILE *stream, const char *tabspace,
+                          hashTableObj *metadata, const char *namespaces) {
+  if (stream && metadata) {
+    const char *pszWMSIdentifierAuthority =
+        msOWSLookupMetadata(metadata, namespaces, "identifier_authority");
+    const char *pszWMSIdentifierValue =
+        msOWSLookupMetadata(metadata, namespaces, "identifier_value");
+
+    /* Identifier only makes sense if you have *both* the authority and value */
+    if (pszWMSIdentifierAuthority && pszWMSIdentifierValue) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "identifier_authority", OWS_NOERR,
+          (std::string(tabspace) + "<Identifier authority=\"%s\">").c_str(),
+          NULL);
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "identifier_value",
+                               OWS_NOERR, "%s</Identifier>\n", NULL);
+    } else if (pszWMSIdentifierAuthority || pszWMSIdentifierValue) {
+      msIO_printf(
+          "%s<!-- WARNING: Both wms_identifier_authority and "
+          "wms_identifier_value must be set to output an Identifier -->\n",
+          tabspace);
+    }
+  }
+}
+
+/*
+** msWMSPrintKeywordlist()
+**
+** Print a Keywordlist tag if applicable.
+*/
+void msWMSPrintKeywordlist(FILE *stream, const char *tabspace, const char *name,
+                           hashTableObj *metadata, const char *namespaces,
+                           int nVersion) {
+  std::string newname(name); /* max. rootlayer_keywordlist_items          */
+  newname += "_items";
+
+  std::string vocname(name); /* max. rootlayer_keywordlist_vocabulary     */
+  vocname += "_vocabulary";
+
+  if (nVersion == OWS_1_0_0) {
+    /* <Keywords> in V 1.0.0 */
+    /* The 1.0.0 spec doesn't specify which delimiter to use so let's use spaces
+     */
+    msOWSPrintEncodeMetadataList(
+        stream, metadata, namespaces, name,
+        (std::string(tabspace) + "<Keywords>").c_str(),
+        (std::string(tabspace) + "</Keywords>\n").c_str(), "%s ", NULL);
+  } else if (msOWSLookupMetadata(metadata, namespaces, name) ||
+             msOWSLookupMetadata(metadata, namespaces, newname.c_str()) ||
+             msOWSLookupMetadata(metadata, namespaces, vocname.c_str())) {
+    /* <KeywordList><Keyword> ... in V1.0.6+ */
+    msIO_printf("%s<KeywordList>\n", tabspace);
+    std::string template1(tabspace);
+    template1 += "    <Keyword>%s</Keyword>\n";
+    /* print old styled ..._keywordlist */
+    msOWSPrintEncodeMetadataList(stream, metadata, namespaces, name, NULL, NULL,
+                                 template1.c_str(), NULL);
+    /* print new styled ..._keywordlist_items */
+    msOWSPrintEncodeMetadataList(stream, metadata, namespaces, newname.c_str(),
+                                 NULL, NULL, template1.c_str(), NULL);
+
+    /* find out if there's a vocabulary list set */
+    const char *vocabularylist =
+        msOWSLookupMetadata(metadata, namespaces, vocname.c_str());
+    if (vocabularylist && nVersion >= OWS_1_3_0) {
+      const auto tokens = msStringSplit(vocabularylist, ',');
+      for (const auto &token : tokens) {
+        msOWSPrintEncodeMetadataList(
+            stream, metadata, namespaces,
+            (std::string(name) + '_' + token + "_items").c_str(), NULL, NULL,
+            (std::string(tabspace) + "    <Keyword vocabulary=\"" + token +
+             "\">%s</Keyword>\n")
+                .c_str(),
+            NULL);
+      }
+    }
+    msIO_printf("%s</KeywordList>\n", tabspace);
+  }
+}
+
+/*
+** msDumpLayer()
+*/
+static int msDumpLayer(mapObj *map, layerObj *lp, int nVersion,
+                       const char *script_url_encoded, const char *indent,
+                       const char *validated_language, int grouplayer,
+                       int hasQueryableSubLayers) {
+  rectObj ext;
+  char **classgroups = NULL;
+  int iclassgroups = 0;
+  char *pszMapEPSG, *pszLayerEPSG;
+
+  /* if the layer status is set to MS_DEFAULT, output a warning */
+  if (lp->status == MS_DEFAULT)
+    msIO_fprintf(stdout,
+                 "<!-- WARNING: This layer has its status set to DEFAULT and "
+                 "will always be displayed when doing a GetMap request even if "
+                 "it is not requested by the client. This is not in line with "
+                 "the expected behavior of a WMS server. Using status ON or "
+                 "OFF is recommended. -->\n");
+
+  if (nVersion <= OWS_1_0_7) {
+    msIO_printf("%s    <Layer queryable=\"%d\">\n", indent,
+                hasQueryableSubLayers || msIsLayerQueryable(lp));
+  } else {
+    /* 1.1.0 and later: opaque and cascaded are new. */
+    int cascaded = 0, opaque = 0;
+    const char *value = msOWSLookupMetadata(&(lp->metadata), "MO", "opaque");
+    if (value != NULL)
+      opaque = atoi(value);
+    if (lp->connectiontype == MS_WMS)
+      cascaded = 1;
+
+    msIO_printf(
+        "%s    <Layer queryable=\"%d\" opaque=\"%d\" cascaded=\"%d\">\n",
+        indent, hasQueryableSubLayers || msIsLayerQueryable(lp), opaque,
+        cascaded);
+  }
+
+  if (lp->name && strlen(lp->name) > 0 &&
+      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
+    msIO_fprintf(stdout,
+                 "<!-- WARNING: The layer name '%s' might contain spaces or "
+                 "invalid characters or may start with a number. This could "
+                 "lead to potential problems. -->\n",
+                 lp->name);
+  msOWSPrintEncodeParam(stdout, "LAYER.NAME", lp->name, OWS_NOERR,
+                        "        <Name>%s</Name>\n", NULL);
+
+  /* the majority of this section is dependent on appropriately named metadata
+   * in the LAYER object */
+  msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO", "title", OWS_WARN,
+                            "        <Title>%s</Title>\n", lp->name,
+                            validated_language);
+
+  msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO", "abstract",
+                            OWS_NOERR, "        <Abstract>%s</Abstract>\n",
+                            NULL, validated_language);
+
+  msWMSPrintKeywordlist(stdout, "        ", "keywordlist", &(lp->metadata),
+                        "MO", nVersion);
+
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE,
+                   &pszMapEPSG);
+  msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE,
+                   &pszLayerEPSG);
+  if (pszMapEPSG == NULL) {
+    /* If map has no proj then every layer MUST have one or produce a warning */
+    if (nVersion > OWS_1_1_0) {
+      /* starting 1.1.1 SRS are given in individual tags */
+      if (nVersion >= OWS_1_3_0) {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
+                                  "MAP.PROJECTION, LAYER.PROJECTION "
+                                  "or wms_srs metadata",
+                                  pszLayerEPSG, OWS_WARN, ' ', NULL, NULL,
+                                  "        <CRS>%s</CRS>\n", NULL);
+      } else {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
+                                  "MAP.PROJECTION, LAYER.PROJECTION "
+                                  "or wms_srs metadata",
+                                  pszLayerEPSG, OWS_WARN, ' ', NULL, NULL,
+                                  "        <SRS>%s</SRS>\n", NULL);
+      }
+    } else {
+      msOWSPrintEncodeParam(stdout,
+                            "(at least one of) MAP.PROJECTION, "
+                            "LAYER.PROJECTION or wms_srs metadata",
+                            pszLayerEPSG, OWS_WARN, "        <SRS>%s</SRS>\n",
+                            NULL);
+    }
+  } else {
+    /* No warning required in this case since there's at least a map proj. */
+    if (nVersion > OWS_1_1_0) {
+      /* starting 1.1.1 SRS are given in individual tags */
+      if (nVersion >= OWS_1_3_0) {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
+                                  "MAP.PROJECTION, LAYER.PROJECTION "
+                                  "or wms_srs metadata",
+                                  pszLayerEPSG, OWS_NOERR, ' ', NULL, NULL,
+                                  "        <CRS>%s</CRS>\n", NULL);
+      } else {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
+                                  "MAP.PROJECTION, LAYER.PROJECTION "
+                                  "or wms_srs metadata",
+                                  pszLayerEPSG, OWS_NOERR, ' ', NULL, NULL,
+                                  "        <SRS>%s</SRS>\n", NULL);
+      }
+    } else {
+      msOWSPrintEncodeParam(stdout, " LAYER.PROJECTION (or wms_srs metadata)",
+                            pszLayerEPSG, OWS_NOERR, "        <SRS>%s</SRS>\n",
+                            NULL);
+    }
+  }
+  msFree(pszLayerEPSG);
+  msFree(pszMapEPSG);
+
+  /* If layer has no proj set then use map->proj for bounding box. */
+  if (msOWSGetLayerExtent(map, lp, "MO", &ext) == MS_SUCCESS) {
+    if (lp->projection.numargs > 0) {
+      if (nVersion >= OWS_1_3_0)
+        msOWSPrintEX_GeographicBoundingBox(stdout, "        ", &(ext),
+                                           &(lp->projection));
+      else
+        msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
+                                    &(lp->projection), NULL, OWS_WMS);
+
+      msOWSPrintBoundingBox(stdout, "        ", &(ext), &(lp->projection),
+                            &(lp->metadata), &(map->web.metadata), "MO",
+                            nVersion);
+    } else {
+      if (nVersion >= OWS_1_3_0)
+        msOWSPrintEX_GeographicBoundingBox(stdout, "        ", &(ext),
+                                           &(map->projection));
+      else
+        msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
+                                    &(map->projection), NULL, OWS_WMS);
+      msOWSPrintBoundingBox(stdout, "        ", &(ext), &(map->projection),
+                            &(lp->metadata), &(map->web.metadata), "MO",
+                            nVersion);
+    }
+  } else {
+    if (nVersion >= OWS_1_3_0)
+      msIO_printf(
+          "        <!-- WARNING: Optional Ex_GeographicBoundingBox could not "
+          "be established for this layer.  Consider setting the EXTENT in the "
+          "LAYER object, or wms_extent metadata. Also check that your data "
+          "exists in the DATA statement -->\n");
+    else
+      msIO_printf("        <!-- WARNING: Optional LatLonBoundingBox could not "
+                  "be established for this layer.  Consider setting the EXTENT "
+                  "in the LAYER object, or wms_extent metadata. Also check "
+                  "that your data exists in the DATA statement -->\n");
+  }
+
+  /* time support */
+  const char *pszWmsTimeExtent =
+      msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
+  if (pszWmsTimeExtent) {
+    const char *pszWmsTimeDefault =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault");
+
+    if (nVersion >= OWS_1_3_0) {
+      if (pszWmsTimeDefault)
+        msIO_fprintf(stdout,
+                     "        <Dimension name=\"time\" units=\"ISO8601\" "
+                     "default=\"%s\" nearestValue=\"0\">%s</Dimension>\n",
+                     pszWmsTimeDefault, pszWmsTimeExtent);
+      else
+        msIO_fprintf(stdout,
+                     "        <Dimension name=\"time\" units=\"ISO8601\" "
+                     "nearestValue=\"0\">%s</Dimension>\n",
+                     pszWmsTimeExtent);
+    }
+
+    else {
+      msIO_fprintf(stdout,
+                   "        <Dimension name=\"time\" units=\"ISO8601\"/>\n");
+      if (pszWmsTimeDefault)
+        msIO_fprintf(stdout,
+                     "        <Extent name=\"time\" default=\"%s\" "
+                     "nearestValue=\"0\">%s</Extent>\n",
+                     pszWmsTimeDefault, pszWmsTimeExtent);
+      else
+        msIO_fprintf(
+            stdout,
+            "        <Extent name=\"time\" nearestValue=\"0\">%s</Extent>\n",
+            pszWmsTimeExtent);
+    }
+  }
+
+  /*dimensions support: elevation + other user defined dimensions*/
+  const char *pszDimensionlist =
+      msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
+  if (pszDimensionlist) {
+    auto tokens = msStringSplit(pszDimensionlist, ',');
+    for (auto &dimension : tokens) {
+      /*check if manadatory unit and extent are set. Item should also be set.
+       * default value is optional*/
+      msStringTrim(dimension);
+
+      const char *pszDimensionItem = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_item").c_str());
+      const char *pszDimensionExtent = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_extent").c_str());
+      const char *pszDimensionUnit = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_units").c_str());
+      const char *pszDimensionDefault = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_default").c_str());
+
+      if (pszDimensionItem && pszDimensionExtent && pszDimensionUnit) {
+        if (nVersion >= OWS_1_3_0) {
+          if (pszDimensionDefault && strlen(pszDimensionDefault) > 0)
+            msIO_fprintf(
+                stdout,
+                "        <Dimension name=\"%s\" units=\"%s\" default=\"%s\" "
+                "multipleValues=\"1\" nearestValue=\"0\">%s</Dimension>\n",
+                dimension.c_str(), pszDimensionUnit, pszDimensionDefault,
+                pszDimensionExtent);
+          else
+            msIO_fprintf(
+                stdout,
+                "        <Dimension name=\"%s\" units=\"%s\"  "
+                "multipleValues=\"1\"  nearestValue=\"0\">%s</Dimension>\n",
+                dimension.c_str(), pszDimensionUnit, pszDimensionExtent);
+        } else {
+          msIO_fprintf(stdout,
+                       "        <Dimension name=\"%s\" units=\"%s\"/>\n",
+                       dimension.c_str(), pszDimensionUnit);
+          if (pszDimensionDefault && strlen(pszDimensionDefault) > 0)
+            msIO_fprintf(stdout,
+                         "        <Extent name=\"%s\" default=\"%s\" "
+                         "nearestValue=\"0\">%s</Extent>\n",
+                         dimension.c_str(), pszDimensionDefault,
+                         pszDimensionExtent);
+          else
+            msIO_fprintf(
+                stdout,
+                "        <Extent name=\"%s\" nearestValue=\"0\">%s</Extent>\n",
+                dimension.c_str(), pszDimensionExtent);
+        }
+      }
+    }
+  }
+
+  if (nVersion >= OWS_1_0_7) {
+    msWMSPrintAttribution(stdout, "    ", &(lp->metadata), "MO");
+  }
+
+  /* AuthorityURL support and Identifier support, only available >= WMS 1.1.0 */
+  if (nVersion >= OWS_1_1_0) {
+    msWMSPrintAuthorityURL(stdout, "        ", &(lp->metadata), "MO");
+    msWMSPrintIdentifier(stdout, "        ", &(lp->metadata), "MO");
+  }
+
+  if (nVersion >= OWS_1_1_0) {
+    const char *metadataurl_list =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_list");
+    if (metadataurl_list) {
+      const auto tokens = msStringSplit(metadataurl_list, ' ');
+      for (const auto &token : tokens) {
+        std::string key("metadataurl_");
+        key += token;
+        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(), OWS_NOERR,
+                          NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                          ">\n          <Format>%s</Format",
+                          "\n          <OnlineResource xmlns:xlink=\""
+                          "http://www.w3.org/1999/xlink\" "
+                          "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
+                          MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "        ");
+      }
+    } else {
+      if (!msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_href"))
+        msMetadataSetGetMetadataURL(lp, script_url_encoded);
+
+      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "metadataurl", OWS_NOERR,
+                        NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                        ">\n          <Format>%s</Format",
+                        "\n          <OnlineResource xmlns:xlink=\""
+                        "http://www.w3.org/1999/xlink\" "
+                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
+                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "        ");
+    }
+  }
+
+  if (nVersion < OWS_1_1_0)
+    msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO", "dataurl_href",
+                             OWS_NOERR, "        <DataURL>%s</DataURL>\n",
+                             NULL);
+  else {
+    const char *dataurl_list =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "dataurl_list");
+    if (dataurl_list) {
+      const auto tokens = msStringSplit(dataurl_list, ' ');
+      for (const auto &token : tokens) {
+        std::string key("dataurl_");
+        key += token;
+        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(), OWS_NOERR,
+                          NULL, "DataURL", NULL, NULL, NULL,
+                          ">\n          <Format>%s</Format",
+                          "\n          <OnlineResource xmlns:xlink=\""
+                          "http://www.w3.org/1999/xlink\" "
+                          "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
+                          MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "        ");
+      }
+    } else {
+      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "dataurl", OWS_NOERR,
+                        NULL, "DataURL", NULL, NULL, NULL,
+                        ">\n          <Format>%s</Format",
+                        "\n          <OnlineResource xmlns:xlink=\""
+                        "http://www.w3.org/1999/xlink\" "
+                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "        ");
+    }
+  }
+
+  /* The LegendURL reside in a style. The Web Map Context spec already  */
+  /* included the support on this in mapserver. However, it is not in the  */
+  /* wms_legendurl_... metadatas it's in the styles metadata, */
+  /* In wms_style_<style_name>_lengendurl_... metadata. So we have to detect */
+  /* the current style before reading it. Also in the Style block, we need */
+  /* a Title and a name. Title is derived from wms_style_<style>_title, */
+  /* which allows mutiple style definitions, e.g. by using classgroups. */
+  const char *pszStyle = msOWSLookupMetadata(&(lp->metadata), "MO", "style");
+  const char *pszLegendURL = NULL;
+  if (pszStyle) {
+    pszLegendURL = msOWSLookupMetadata(
+        &(lp->metadata), "MO",
+        (std::string("style_") + pszStyle + "_legendurl_href").c_str());
+  } else
+    pszStyle = "default";
+
+  if (nVersion <= OWS_1_0_0 && pszLegendURL) {
+    /* First, print the style block */
+    msIO_fprintf(stdout, "        <Style>\n");
+    msIO_fprintf(stdout, "          <Name>%s</Name>\n", pszStyle);
+    /* Print the real Title or Style name otherwise */
+    msOWSPrintEncodeMetadata2(
+        stdout, &(lp->metadata), "MO",
+        (std::string("style_") + pszStyle + "_title").c_str(), OWS_NOERR,
+        "          <Title>%s</Title>\n", pszStyle, validated_language);
+
+    /* Inside, print the legend url block */
+    msOWSPrintEncodeMetadata(
+        stdout, &(lp->metadata), "MO",
+        (std::string("style_") + pszStyle + "_legendurl_href").c_str(),
+        OWS_NOERR, "          <StyleURL>%s</StyleURL>\n", NULL);
+
+    /* close the style block */
+    msIO_fprintf(stdout, "        </Style>\n");
+
+  } else if (nVersion >= OWS_1_1_0) {
+    if (pszLegendURL) {
+      /* First, print the style block */
+      msIO_fprintf(stdout, "        <Style>\n");
+      msIO_fprintf(stdout, "          <Name>%s</Name>\n", pszStyle);
+      /* Print the real Title or Style name otherwise */
+      msOWSPrintEncodeMetadata2(
+          stdout, &(lp->metadata), "MO",
+          (std::string("style_") + pszStyle + "_title").c_str(), OWS_NOERR,
+          "          <Title>%s</Title>\n", pszStyle, validated_language);
+
+      /* Inside, print the legend url block */
+      msOWSPrintURLType(
+          stdout, &(lp->metadata), "MO",
+          (std::string("style_") + pszStyle + "_legendurl").c_str(), OWS_NOERR,
+          NULL, "LegendURL", NULL, " width=\"%s\"", " height=\"%s\"",
+          ">\n             <Format>%s</Format",
+          "\n             <OnlineResource "
+          "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+          " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+          "          ",
+          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL, NULL, NULL, NULL,
+          NULL, "          ");
+      msIO_fprintf(stdout, "        </Style>\n");
+
+    } else {
+      if (script_url_encoded) {
+        if (lp->connectiontype != MS_WMS && lp->connectiontype != MS_WFS &&
+            lp->connectiontype != MS_UNUSED_1 && lp->numclasses > 0) {
+          bool classnameset = false;
+          for (int i = 0; i < lp->numclasses; i++) {
+            if (lp->_class[i]->name && strlen(lp->_class[i]->name) > 0) {
+              classnameset = true;
+              break;
+            }
+          }
+          if (classnameset) {
+            int size_x = 0, size_y = 0;
+            std::vector<int> group_layers;
+            group_layers.reserve(map->numlayers);
+
+            char ***nestedGroups =
+                (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+            int *numNestedGroups =
+                (int *)msSmallCalloc(map->numlayers, sizeof(int));
+            int *isUsedInNestedGroup =
+                (int *)msSmallCalloc(map->numlayers, sizeof(int));
+            msWMSPrepareNestedGroups(map, nVersion, nestedGroups,
+                                     numNestedGroups, isUsedInNestedGroup);
+
+            group_layers.push_back(lp->index);
+            if (isUsedInNestedGroup[lp->index]) {
+              for (int j = 0; j < map->numlayers; j++) {
+                if (j == lp->index)
+                  continue;
+                for (int k = 0; k < numNestedGroups[j]; k++) {
+                  if (strcasecmp(lp->name, nestedGroups[j][k]) == 0) {
+                    group_layers.push_back(j);
+                    break;
+                  }
+                }
+              }
+            }
+
+            if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(),
+                                 static_cast<int>(group_layers.size()), NULL,
+                                 1) == MS_SUCCESS) {
+              const std::string width(std::to_string(size_x));
+              const std::string height(std::to_string(size_y));
+
+              char *mimetype = NULL;
+#if defined USE_PNG
+              mimetype = msEncodeHTMLEntities("image/png");
+#endif
+
+#if defined USE_JPEG
+              if (!mimetype)
+                mimetype = msEncodeHTMLEntities("image/jpeg");
+#endif
+              if (!mimetype)
+                mimetype =
+                    msEncodeHTMLEntities(MS_IMAGE_MIME_TYPE(map->outputformat));
+
+              /* --------------------------------------------------------------------
+               */
+              /*      check if the group parameters for the classes are set. We
+               */
+              /*      should then publish the different class groups as
+               * different styles.*/
+              /* --------------------------------------------------------------------
+               */
+              iclassgroups = 0;
+              classgroups = NULL;
+
+              const char *styleName =
+                  msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
+              if (styleName == NULL)
+                styleName = "default";
+              char *pszEncodedStyleName = msEncodeHTMLEntities(styleName);
+
+              for (int i = 0; i < lp->numclasses; i++) {
+                if (lp->_class[i]->name && lp->_class[i]->group) {
+                  /* Check that style is not inherited from root layer (#4442).
+                   */
+                  if (strcasecmp(pszEncodedStyleName, lp->_class[i]->group) ==
+                      0)
+                    continue;
+                  /* Check that style is not inherited from group layer(s)
+                   * (#4442). */
+                  if (numNestedGroups[lp->index] > 0) {
+                    int j = 0;
+                    layerObj *lp2 = NULL;
+                    for (; j < numNestedGroups[lp->index]; j++) {
+                      int l = 0;
+                      for (int k = 0; k < map->numlayers; k++) {
+                        if (GET_LAYER(map, k)->name &&
+                            strcasecmp(GET_LAYER(map, k)->name,
+                                       nestedGroups[lp->index][j]) == 0) {
+                          lp2 = (GET_LAYER(map, k));
+                          for (l = 0; l < lp2->numclasses; l++) {
+                            if (strcasecmp(lp2->_class[l]->group,
+                                           lp->_class[i]->group) == 0)
+                              break;
+                          }
+                          break;
+                        }
+                      }
+                      if (lp2 && l < lp2->numclasses)
+                        break;
+                    }
+                    if (j < numNestedGroups[lp->index])
+                      continue;
+                  }
+                  if (!classgroups) {
+                    classgroups = (char **)msSmallMalloc(sizeof(char *));
+                    classgroups[iclassgroups++] =
+                        msStrdup(lp->_class[i]->group);
+                  } else {
+                    /* Output style only once. */
+                    bool found = false;
+                    for (int j = 0; j < iclassgroups; j++) {
+                      if (strcasecmp(classgroups[j], lp->_class[i]->group) ==
+                          0) {
+                        found = true;
+                        break;
+                      }
+                    }
+                    if (!found) {
+                      iclassgroups++;
+                      classgroups = (char **)msSmallRealloc(
+                          classgroups, sizeof(char *) * iclassgroups);
+                      classgroups[iclassgroups - 1] =
+                          msStrdup(lp->_class[i]->group);
+                    }
+                  }
+                }
+              }
+              msFree(pszEncodedStyleName);
+              if (classgroups == NULL) {
+                classgroups = (char **)msSmallMalloc(sizeof(char *));
+                classgroups[0] = msStrdup("default");
+                iclassgroups = 1;
+              }
+
+              for (int i = 0; i < iclassgroups; i++) {
+                char *name_encoded = msEncodeHTMLEntities(lp->name);
+                char *classgroup_encoded = msEncodeHTMLEntities(classgroups[i]);
+                std::string legendurl(script_url_encoded);
+                legendurl += "version=";
+                char szVersionBuf[OWS_VERSION_MAXLEN];
+                legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
+                legendurl +=
+                    "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
+                if (nVersion >= OWS_1_3_0) {
+                  legendurl += "sld_version=1.1.0&amp;layer=";
+                } else {
+                  legendurl += "layer=";
+                }
+                legendurl += name_encoded;
+                legendurl += "&amp;format=";
+                legendurl += mimetype;
+                legendurl += "&amp;STYLE=";
+                legendurl += classgroup_encoded;
+
+                msFree(name_encoded);
+                msFree(classgroup_encoded);
+
+                msIO_fprintf(stdout, "        <Style>\n");
+                msIO_fprintf(stdout, "          <Name>%s</Name>\n",
+                             classgroups[i]);
+                msOWSPrintEncodeMetadata2(
+                    stdout, &(lp->metadata), "MO",
+                    (std::string("style_") + classgroups[i] + "_title").c_str(),
+                    OWS_NOERR, "          <Title>%s</Title>\n", classgroups[i],
+                    validated_language);
+
+                /* A legendurl from wms_style_<style>_legendurl_href will
+                 * override a self generated legend graphic */
+                pszLegendURL = msOWSLookupMetadata(
+                    &(lp->metadata), "MO",
+                    (std::string("style_") + classgroups[i] + "_legendurl_href")
+                        .c_str());
+                if (pszLegendURL) {
+                  msOWSPrintURLType(
+                      stdout, &(lp->metadata), "MO",
+                      (std::string("style_") + classgroups[i] + "_legendurl")
+                          .c_str(),
+                      OWS_NOERR, NULL, "LegendURL", NULL, " width=\"%s\"",
+                      " height=\"%s\"", ">\n             <Format>%s</Format",
+                      "\n             <OnlineResource "
+                      "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                      " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                      "          ",
+                      MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL, NULL,
+                      NULL, NULL, NULL, "          ");
+                } else {
+                  msOWSPrintURLType(
+                      stdout, NULL, "O", "ttt", OWS_NOERR, NULL, "LegendURL",
+                      NULL, " width=\"%s\"", " height=\"%s\"",
+                      ">\n             <Format>%s</Format",
+                      "\n             <OnlineResource "
+                      "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                      " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                      "          ",
+                      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, NULL,
+                      width.c_str(), height.c_str(), mimetype,
+                      legendurl.c_str(), "          ");
+                }
+                msIO_fprintf(stdout, "        </Style>\n");
+              }
+              msFreeCharArray(classgroups, iclassgroups);
+              msFree(mimetype);
+            }
+            /* free the stuff used for nested layers */
+            for (int i = 0; i < map->numlayers; i++) {
+              if (numNestedGroups[i] > 0) {
+                msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
+              }
+            }
+            free(nestedGroups);
+            free(numNestedGroups);
+            free(isUsedInNestedGroup);
+          }
+        }
+      }
+    }
+  }
+
+  /* print Min/Max ScaleDenominator */
+  if (nVersion < OWS_1_3_0)
+    msWMSPrintScaleHint("        ", lp->minscaledenom, lp->maxscaledenom,
+                        map->resolution);
+  else
+    msWMSPrintScaleDenominator("        ", lp->minscaledenom,
+                               lp->maxscaledenom);
+
+  if (grouplayer == MS_FALSE)
+    msIO_printf("%s    </Layer>\n", indent);
+
+  return MS_SUCCESS;
+}
+
+/*
+ * msWMSIsSubGroup
+ */
+static bool msWMSIsSubGroup(char **currentGroups, int currentLevel,
+                            char **otherGroups, int numOtherGroups) {
+  /* no match if otherGroups[] has less levels than currentLevel */
+  if (numOtherGroups <= currentLevel) {
+    return false;
+  }
+  /* compare all groups below the current level */
+  for (int i = 0; i <= currentLevel; i++) {
+    if (strcmp(currentGroups[i], otherGroups[i]) != 0) {
+      return false; /* if one of these is not equal it is not a sub group */
+    }
+  }
+  return true;
+}
+
+/*
+ * msWMSHasQueryableSubLayers
+ */
+static int msWMSHasQueryableSubLayers(mapObj *map, int index, int level,
+                                      char ***nestedGroups,
+                                      int *numNestedGroups) {
+  for (int j = index; j < map->numlayers; j++) {
+    if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j],
+                        numNestedGroups[j])) {
+      if (msIsLayerQueryable(GET_LAYER(map, j)))
+        return MS_TRUE;
+    }
+  }
+  return MS_FALSE;
+}
+
+/***********************************************************************************
+ * msWMSPrintNestedGroups() *
+ *                                                                                 *
+ * purpose: Writes the layers to the capabilities that have the *
+ * "WMS_LAYER_GROUP" metadata set. *
+ *                                                                                 *
+ * params: * -map: The main map object * -nVersion: OGC WMS version *
+ * -pabLayerProcessed: boolean array indicating which layers have been dealt
+ *with. * -index: the index of the current layer. * -level: the level of depth
+ *in the group tree (root = 0)                         * -nestedGroups: This
+ *array holds the arrays of groups that have                  * been set through
+ *the WMS_LAYER_GROUP metadata                                 *
+ * -numNestedGroups: This array holds the number of nested groups for each layer
+ **
+ ***********************************************************************************/
+void msWMSPrintNestedGroups(mapObj *map, int nVersion, char *pabLayerProcessed,
+                            int index, int level, char ***nestedGroups,
+                            int *numNestedGroups, int *isUsedInNestedGroup,
+                            const char *script_url_encoded,
+                            const char *validated_language) {
+  bool groupAdded = false;
+  std::string indent;
+  for (int i = 0; i < level; i++) {
+    indent += "  ";
+  }
+
+  if (numNestedGroups[index] <= level) { /* no more subgroups */
+    if ((!pabLayerProcessed[index]) && (!isUsedInNestedGroup[index])) {
+      /* we are at the deepest level of the group branchings, so add layer now.
+       */
+      msDumpLayer(map, GET_LAYER(map, index), nVersion, script_url_encoded,
+                  indent.c_str(), validated_language, MS_FALSE, MS_FALSE);
+      pabLayerProcessed[index] = 1; /* done */
+    }
+  } else { /* not yet there, we have to deal with this group and possible
+              subgroups and layers. */
+    int j;
+    for (j = 0; j < map->numlayers; j++) {
+      if (GET_LAYER(map, j)->name &&
+          strcasecmp(GET_LAYER(map, j)->name, nestedGroups[index][level]) ==
+              0) {
+        break;
+      }
+    }
+
+    /* Beginning of a new group... enclose the group in a layer block */
+    if (j < map->numlayers) {
+      if (!pabLayerProcessed[j]) {
+        msDumpLayer(map, GET_LAYER(map, j), nVersion, script_url_encoded,
+                    indent.c_str(), validated_language, MS_TRUE,
+                    msWMSHasQueryableSubLayers(map, index, level, nestedGroups,
+                                               numNestedGroups));
+        pabLayerProcessed[j] = 1; /* done */
+        groupAdded = true;
+      }
+    } else {
+      msIO_printf("%s    <Layer%s>\n", indent.c_str(),
+                  msWMSHasQueryableSubLayers(map, index, level, nestedGroups,
+                                             numNestedGroups)
+                      ? " queryable=\"1\""
+                      : "");
+      msIO_printf("%s      <Name>%s</Name>\n", indent.c_str(),
+                  nestedGroups[index][level]);
+      msIO_printf("%s      <Title>%s</Title>\n", indent.c_str(),
+                  nestedGroups[index][level]);
+      groupAdded = true;
+    }
+
+    /* Look for one group deeper in the current layer */
+    if (!pabLayerProcessed[index]) {
+      msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed, index, level + 1,
+                             nestedGroups, numNestedGroups, isUsedInNestedGroup,
+                             script_url_encoded, validated_language);
+    }
+
+    /* look for subgroups in other layers. */
+    for (j = index + 1; j < map->numlayers; j++) {
+      if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j],
+                          numNestedGroups[j])) {
+        if (!pabLayerProcessed[j]) {
+          msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed, j, level + 1,
+                                 nestedGroups, numNestedGroups,
+                                 isUsedInNestedGroup, script_url_encoded,
+                                 validated_language);
+        }
+      } else {
+        /* TODO: if we would sort all layers on "WMS_LAYER_GROUP" beforehand */
+        /* we could break out of this loop at this point, which would increase
+         */
+        /* performance.  */
+      }
+    }
+    /* Close group layer block */
+    if (groupAdded)
+      msIO_printf("%s    </Layer>\n", indent.c_str());
+  }
+} /* msWMSPrintNestedGroups */
+
+/*
+** msWMSGetCapabilities()
+*/
+static int msWMSGetCapabilities(mapObj *map, int nVersion, cgiRequestObj *req,
+                                owsRequestObj *ows_request,
+                                const char *requested_updatesequence,
+                                const char *wms_exception_format,
+                                const char *requested_language) {
+  const char *updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "updatesequence");
+
+  const char *sldenabled =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
+
+  if (sldenabled == NULL)
+    sldenabled = "true";
+
+  if (requested_updatesequence != NULL) {
+    int i =
+        msOWSNegotiateUpdateSequence(requested_updatesequence, updatesequence);
+    if (i == 0) { /* current */
+      msSetError(
+          MS_WMSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
+      return msWMSException(map, nVersion, "CurrentUpdateSequence",
+                            wms_exception_format);
+    }
+    if (i > 0) { /* invalid */
+      msSetError(
+          MS_WMSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
+      return msWMSException(map, nVersion, "InvalidUpdateSequence",
+                            wms_exception_format);
+    }
+  }
+
+  std::string schemalocation;
+  {
+    char *pszSchemalocation =
+        msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    schemalocation = pszSchemalocation;
+    msFree(pszSchemalocation);
+  }
+
+  if (nVersion < 0)
+    nVersion = OWS_1_3_0; /* Default to 1.3.0 */
+
+  /* Decide which version we're going to return. */
+  std::string dtd_url;
+  if (nVersion < OWS_1_0_7) {
+    nVersion = OWS_1_0_0;
+    dtd_url = std::move(schemalocation);
+    dtd_url += "/wms/1.0.0/capabilities_1_0_0.dtd";
+  }
+
+  else if (nVersion < OWS_1_1_0) {
+    nVersion = OWS_1_0_7;
+    dtd_url = std::move(schemalocation);
+    dtd_url += "/wms/1.0.7/capabilities_1_0_7.dtd";
+  } else if (nVersion < OWS_1_1_1) {
+    nVersion = OWS_1_1_0;
+    dtd_url = std::move(schemalocation);
+    dtd_url += "/wms/1.1.0/capabilities_1_1_0.dtd";
+  } else if (nVersion < OWS_1_3_0) {
+    nVersion = OWS_1_1_1;
+    dtd_url = std::move(schemalocation);
+    /* this exception was added to accomadote the OGC test suite (Bug 1576)*/
+    if (strcasecmp(dtd_url.c_str(), OWS_DEFAULT_SCHEMAS_LOCATION) == 0)
+      dtd_url += "/wms/1.1.1/WMS_MS_Capabilities.dtd";
+    else
+      dtd_url += "/wms/1.1.1/capabilities_1_1_1.dtd";
+  } else
+    nVersion = OWS_1_3_0;
+
+  /* This function owns validated_language, so remember to free it later*/
+  std::string validated_language;
+  {
+    char *pszValidated_language =
+        msOWSGetLanguageFromList(map, "MO", requested_language);
+    if (pszValidated_language) {
+      validated_language = pszValidated_language;
+      msMapSetLanguageSpecificConnection(map, pszValidated_language);
+    }
+    msFree(pszValidated_language);
+  }
+
+  /* We need this server's onlineresource. */
+  /* Default to use the value of the "onlineresource" metadata, and if not */
+  /* set then build it: "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?" */
+  /* the returned string should be freed once we're done with it. */
+  char *script_url_encoded = NULL;
+  {
+    char *script_url = msOWSGetOnlineResource2(map, "MO", "onlineresource", req,
+                                               validated_language.c_str());
+    if (script_url == NULL ||
+        (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+      free(script_url);
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+    free(script_url);
+  }
+
+  if (nVersion <= OWS_1_0_7 ||
+      nVersion >= OWS_1_3_0) /* 1.0.0 to 1.0.7 and >=1.3.0*/
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  else /* 1.1.0 and later */
+    msIO_setHeader("Content-Type",
+                   "application/vnd.ogc.wms_xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+
+  /*TODO review wms1.3.0*/
+  if (nVersion < OWS_1_3_0) {
+    msIO_printf("<!DOCTYPE WMT_MS_Capabilities SYSTEM \"%s\"\n",
+                dtd_url.c_str());
+    msIO_printf(" [\n");
+
+    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                                     "inspire_capabilities")) {
+      msIO_printf(
+          "<!ELEMENT VendorSpecificCapabilities "
+          "(inspire_vs:ExtendedCapabilities)><!ELEMENT "
+          "inspire_vs:ExtendedCapabilities ((inspire_common:MetadataUrl, "
+          "inspire_common:SupportedLanguages, inspire_common:ResponseLanguage) "
+          "| (inspire_common:ResourceLocator+, inspire_common:ResourceType, "
+          "inspire_common:TemporalReference+, inspire_common:Conformity+, "
+          "inspire_common:MetadataPointOfContact+, "
+          "inspire_common:MetadataDate, inspire_common:SpatialDataServiceType, "
+          "inspire_common:MandatoryKeyword+, inspire_common:Keyword*, "
+          "inspire_common:SupportedLanguages, inspire_common:ResponseLanguage, "
+          "inspire_common:MetadataUrl?))><!ATTLIST "
+          "inspire_vs:ExtendedCapabilities xmlns:inspire_vs CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/inspire_vs/1.0\" ><!ELEMENT "
+          "inspire_common:MetadataUrl (inspire_common:URL, "
+          "inspire_common:MediaType*)><!ATTLIST inspire_common:MetadataUrl "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA "
+          "#FIXED \"http://www.w3.org/2001/XMLSchema-instance\" xsi:type CDATA "
+          "#FIXED \"inspire_common:resourceLocatorType\" ><!ELEMENT "
+          "inspire_common:URL (#PCDATA)><!ATTLIST inspire_common:URL "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:MediaType (#PCDATA)><!ATTLIST "
+          "inspire_common:MediaType xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:SupportedLanguages (inspire_common:DefaultLanguage, "
+          "inspire_common:SupportedLanguage*)><!ATTLIST "
+          "inspire_common:SupportedLanguages xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:DefaultLanguage (inspire_common:Language)><!ATTLIST "
+          "inspire_common:DefaultLanguage xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:SupportedLanguage "
+          "(inspire_common:Language)><!ATTLIST "
+          "inspire_common:SupportedLanguage xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
+          "<!ELEMENT inspire_common:ResponseLanguage "
+          "(inspire_common:Language)><!ATTLIST inspire_common:ResponseLanguage "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Language (#PCDATA)><!ATTLIST inspire_common:Language "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:ResourceLocator (inspire_common:URL, "
+          "inspire_common:MediaType*)><!ATTLIST inspire_common:ResourceLocator "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:ResourceType (#PCDATA)> <!ATTLIST "
+          "inspire_common:ResourceType xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:TemporalReference (inspire_common:DateOfCreation?, "
+          "inspire_common:DateOfLastRevision?, "
+          "inspire_common:DateOfPublication*, "
+          "inspire_common:TemporalExtent*)><!ATTLIST "
+          "inspire_common:TemporalReference xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:DateOfCreation (#PCDATA)> <!ATTLIST "
+          "inspire_common:DateOfCreation xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:DateOfLastRevision (#PCDATA)><!ATTLIST "
+          "inspire_common:DateOfLastRevision xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:DateOfPublication (#PCDATA)><!ATTLIST "
+          "inspire_common:DateOfPublication xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:TemporalExtent (inspire_common:IndividualDate | "
+          "inspire_common:IntervalOfDates)><!ATTLIST "
+          "inspire_common:TemporalExtent xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:IndividualDate (#PCDATA)> <!ATTLIST "
+          "inspire_common:IndividualDate xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\">"
+          "<!ELEMENT inspire_common:IntervalOfDates "
+          "(inspire_common:StartingDate, inspire_common:EndDate)><!ATTLIST "
+          "inspire_common:IntervalOfDates xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:StartingDate (#PCDATA)><!ATTLIST "
+          "inspire_common:StartingDate xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:EndDate (#PCDATA)><!ATTLIST inspire_common:EndDate "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Conformity (inspire_common:Specification, "
+          "inspire_common:Degree)><!ATTLIST inspire_common:Conformity "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Specification (inspire_common:Title, "
+          "(inspire_common:DateOfPublication | inspire_common:DateOfCreation | "
+          "inspire_common:DateOfLastRevision), inspire_common:URI*, "
+          "inspire_common:ResourceLocator*)><!ATTLIST "
+          "inspire_common:Specification xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Title (#PCDATA)><!ATTLIST inspire_common:Title "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:URI (#PCDATA)><!ATTLIST inspire_common:URI "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Degree (#PCDATA)><!ATTLIST inspire_common:Degree "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:MetadataPointOfContact "
+          "(inspire_common:OrganisationName, "
+          "inspire_common:EmailAddress)><!ATTLIST "
+          "inspire_common:MetadataPointOfContact xmlns:inspire_common CDATA "
+          "#FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
+          "<!ELEMENT inspire_common:OrganisationName (#PCDATA)><!ATTLIST "
+          "inspire_common:OrganisationName  xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:EmailAddress (#PCDATA)><!ATTLIST "
+          "inspire_common:EmailAddress xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:MetadataDate (#PCDATA)><!ATTLIST "
+          "inspire_common:MetadataDate xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:SpatialDataServiceType (#PCDATA)><!ATTLIST "
+          "inspire_common:SpatialDataServiceType xmlns:inspire_common CDATA "
+          "#FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" "
+          "><!ELEMENT inspire_common:MandatoryKeyword "
+          "(inspire_common:KeywordValue)><!ATTLIST "
+          "inspire_common:MandatoryKeyword xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:KeywordValue (#PCDATA)><!ATTLIST "
+          "inspire_common:KeywordValue xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
+          "<!ELEMENT inspire_common:Keyword "
+          "(inspire_common:OriginatingControlledVocabulary?, "
+          "inspire_common:KeywordValue)><!ATTLIST inspire_common:Keyword "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA "
+          "#FIXED \"http://www.w3.org/2001/XMLSchemainstance\" xsi:type "
+          "(inspire_common:inspireTheme_bul | inspire_common:inspireTheme_cze "
+          "| inspire_common:inspireTheme_dan | inspire_common:inspireTheme_dut "
+          "| inspire_common:inspireTheme_eng | inspire_common:inspireTheme_est "
+          "| inspire_common:inspireTheme_fin | inspire_common:inspireTheme_fre "
+          "| inspire_common:inspireTheme_ger | inspire_common:inspireTheme_gre "
+          "| inspire_common:inspireTheme_hun | inspire_common:inspireTheme_gle "
+          "| inspire_common:inspireTheme_ita | inspire_common:inspireTheme_lav "
+          "| inspire_common:inspireTheme_lit | inspire_common:inspireTheme_mlt "
+          "| inspire_common:inspireTheme_pol | inspire_common:inspireTheme_por "
+          "| inspire_common:inspireTheme_rum | inspire_common:inspireTheme_slo "
+          "| inspire_common:inspireTheme_slv | inspire_common:inspireTheme_spa "
+          "| inspire_common:inspireTheme_swe) #IMPLIED ><!ELEMENT "
+          "inspire_common:OriginatingControlledVocabulary "
+          "(inspire_common:Title, (inspire_common:DateOfPublication | "
+          "inspire_common:DateOfCreation | inspire_common:DateOfLastRevision), "
+          "inspire_common:URI*, inspire_common:ResourceLocator*)><!ATTLIST "
+          "inspire_common:OriginatingControlledVocabulary xmlns:inspire_common "
+          "CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\">\n");
+    } else {
+      /* some mapserver specific declarations will go here */
+      msIO_printf(" <!ELEMENT VendorSpecificCapabilities EMPTY>\n");
+    }
+
+    msIO_printf(" ]>  <!-- end of DOCTYPE declaration -->\n\n");
+  }
+
+  char szVersionBuf[OWS_VERSION_MAXLEN];
+  const char *pszVersion = msOWSGetVersionString(nVersion, szVersionBuf);
+  if (nVersion >= OWS_1_3_0)
+    msIO_printf("<WMS_Capabilities version=\"%s\"", pszVersion);
+  else
+    msIO_printf("<WMT_MS_Capabilities version=\"%s\"", pszVersion);
+  if (updatesequence)
+    msIO_printf(" updateSequence=\"%s\"", updatesequence);
+
+  if (nVersion == OWS_1_3_0) {
+    msIO_printf("  xmlns=\"http://www.opengis.net/wms\""
+                "   xmlns:sld=\"http://www.opengis.net/sld\""
+                "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\""
+                "   xmlns:ms=\"http://mapserver.gis.umn.edu/mapserver\"");
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "inspire_capabilities")) {
+      msIO_printf("   xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX
+                  "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\""
+                  "   xmlns:" MS_INSPIRE_VS_NAMESPACE_PREFIX
+                  "=\"" MS_INSPIRE_VS_NAMESPACE_URI "\"");
+    }
+
+    msIO_printf(
+        "   xsi:schemaLocation=\"http://www.opengis.net/wms "
+        "%s/wms/%s/capabilities_1_3_0.xsd "
+        " http://www.opengis.net/sld %s/sld/1.1.0/sld_capabilities.xsd ",
+        msOWSGetSchemasLocation(map), pszVersion, msOWSGetSchemasLocation(map));
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "inspire_capabilities")) {
+      char *inspireschemalocation =
+          msEncodeHTMLEntities(msOWSGetInspireSchemasLocation(map));
+      msIO_printf(" " MS_INSPIRE_VS_NAMESPACE_URI " "
+                  " %s%s",
+                  inspireschemalocation, MS_INSPIRE_VS_SCHEMA_LOCATION);
+      free(inspireschemalocation);
+    }
+
+    msIO_printf(
+        " http://mapserver.gis.umn.edu/mapserver "
+        "%sservice=WMS&amp;version=1.3.0&amp;request=GetSchemaExtension\"",
+        script_url_encoded);
+  }
+
+  msIO_printf(">\n");
+
+  /* WMS definition */
+  msIO_printf("<Service>\n");
+
+  /* Service name is defined by the spec and changed at v1.0.0 */
+  if (nVersion <= OWS_1_0_7)
+    msIO_printf("  <Name>GetMap</Name>\n"); /* v 1.0.0 to 1.0.7 */
+  else if (nVersion > OWS_1_0_7 && nVersion < OWS_1_3_0)
+    msIO_printf("  <Name>OGC:WMS</Name>\n"); /* v 1.1.0 to 1.1.1*/
+  else
+    msIO_printf("  <Name>WMS</Name>\n"); /* v 1.3.0+ */
+
+  /* the majority of this section is dependent on appropriately named metadata
+   * in the WEB object */
+  msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "title",
+                            OWS_WARN, "  <Title>%s</Title>\n", map->name,
+                            validated_language.c_str());
+  msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "abstract",
+                            OWS_NOERR, "  <Abstract>%s</Abstract>\n", NULL,
+                            validated_language.c_str());
+
+  msWMSPrintKeywordlist(stdout, "  ", "keywordlist", &(map->web.metadata), "MO",
+                        nVersion);
+
+  /* Service/onlineresource */
+  /* Defaults to same as request onlineresource if wms_service_onlineresource */
+  /* is not set. */
+  if (nVersion == OWS_1_0_0)
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "MO", "service_onlineresource", OWS_NOERR,
+        "  <OnlineResource>%s</OnlineResource>\n", script_url_encoded);
+  else
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "MO", "service_onlineresource", OWS_NOERR,
+        "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+        "xlink:href=\"%s\"/>\n",
+        script_url_encoded);
+
+  /* contact information is a required element in 1.0.7 but the */
+  /* sub-elements such as ContactPersonPrimary, etc. are not! */
+  /* In 1.1.0, ContactInformation becomes optional. */
+  msOWSPrintContactInfo(stdout, "  ", nVersion, &(map->web.metadata), "MO");
+
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO", "fees",
+                           OWS_NOERR, "  <Fees>%s</Fees>\n", NULL);
+
+  msOWSPrintEncodeMetadata(
+      stdout, &(map->web.metadata), "MO", "accessconstraints", OWS_NOERR,
+      "  <AccessConstraints>%s</AccessConstraints>\n", NULL);
+
+  if (nVersion >= OWS_1_3_0) {
+    const char *layerlimit =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
+    if (layerlimit) {
+      msIO_printf("  <LayerLimit>%s</LayerLimit>\n", layerlimit);
+    }
+    msIO_printf("  <MaxWidth>%d</MaxWidth>\n", map->maxsize);
+    msIO_printf("  <MaxHeight>%d</MaxHeight>\n", map->maxsize);
+  }
+
+  msIO_printf("</Service>\n\n");
+
+  /* WMS capabilities definitions */
+  msIO_printf("<Capability>\n");
+  msIO_printf("  <Request>\n");
+
+  if (nVersion <= OWS_1_0_7) {
+    /* WMS 1.0.0 to 1.0.7 - We don't try to use outputformats list here for now
+     */
+    if (msOWSRequestIsEnabled(map, NULL, "M", "GetMap", MS_FALSE))
+      msWMSPrintRequestCap(nVersion, "Map", script_url_encoded,
+                           ""
+
+#if defined USE_PNG
+                           "<PNG />"
+#endif
+#if defined USE_JPEG
+                           "<JPEG />"
+#endif
+                           "<SVG />",
+                           NULL);
+    if (msOWSRequestIsEnabled(map, NULL, "M", "GetCapabilities", MS_TRUE))
+      msWMSPrintRequestCap(nVersion, "Capabilities", script_url_encoded,
+                           "<WMS_XML />", NULL);
+    if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE))
+      msWMSPrintRequestCap(nVersion, "FeatureInfo", script_url_encoded,
+                           "<MIME /><GML.1 />", NULL);
+  } else {
+    const char *mime_list[20];
+    int mime_count = 0;
+    int max_mime = 20;
+    /* WMS 1.1.0 and later */
+    /* Note changes to the request names, their ordering, and to the formats */
+
+    if (msOWSRequestIsEnabled(map, NULL, "M", "GetCapabilities", MS_TRUE)) {
+      if (nVersion >= OWS_1_3_0)
+        msWMSPrintRequestCap(nVersion, "GetCapabilities", script_url_encoded,
+                             "text/xml", NULL);
+      else
+        msWMSPrintRequestCap(nVersion, "GetCapabilities", script_url_encoded,
+                             "application/vnd.ogc.wms_xml", NULL);
+    }
+
+    msGetOutputFormatMimeListWMS(map, mime_list,
+                                 sizeof(mime_list) / sizeof(char *));
+    if (msOWSRequestIsEnabled(map, NULL, "M", "GetMap", MS_FALSE))
+      msWMSPrintRequestCap(
+          nVersion, "GetMap", script_url_encoded, mime_list[0], mime_list[1],
+          mime_list[2], mime_list[3], mime_list[4], mime_list[5], mime_list[6],
+          mime_list[7], mime_list[8], mime_list[9], mime_list[10],
+          mime_list[11], mime_list[12], mime_list[13], mime_list[14],
+          mime_list[15], mime_list[16], mime_list[17], mime_list[18],
+          mime_list[19], NULL);
+
+    const char *format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                                  "getfeatureinfo_formatlist");
+    /*feature_info_mime_type depricated for MapServer 6.0*/
+    if (!format_list)
+      format_list = msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                        "feature_info_mime_type");
+
+    if (format_list && strlen(format_list) > 0) {
+      auto tokens = msStringSplit(format_list, ',');
+      for (auto &token : tokens) {
+        msStringTrim(token);
+        /*text plain and gml do not need to be a format and accepted by
+         * default*/
+        /*can not really validate since the old way of using template
+          with wei->header, layer->template ... should be kept*/
+        if (!token.empty() && mime_count < max_mime)
+          mime_list[mime_count++] = token.c_str();
+      }
+      /*add text/plain and gml */
+      if (strcasestr(format_list, "GML") == 0 &&
+          strcasestr(format_list, "application/vnd.ogc.gml") == 0) {
+        if (mime_count < max_mime)
+          mime_list[mime_count++] = "application/vnd.ogc.gml";
+      }
+      if (strcasestr(format_list, "text/plain") == 0 &&
+          strcasestr(format_list, "MIME") == 0) {
+        if (mime_count < max_mime)
+          mime_list[mime_count++] = "text/plain";
+        else /*force always this format*/
+          mime_list[max_mime - 1] = "text/plain";
+      }
+
+      if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE)) {
+        if (mime_count > 0) {
+          if (mime_count < max_mime)
+            mime_list[mime_count] = NULL;
+          msWMSPrintRequestCap(
+              nVersion, "GetFeatureInfo", script_url_encoded, mime_list[0],
+              mime_list[1], mime_list[2], mime_list[3], mime_list[4],
+              mime_list[5], mime_list[6], mime_list[7], mime_list[8],
+              mime_list[9], mime_list[10], mime_list[11], mime_list[12],
+              mime_list[13], mime_list[14], mime_list[15], mime_list[16],
+              mime_list[17], mime_list[18], mime_list[19], NULL);
+        }
+        /*if all formats given are invalid go to default*/
+        else
+          msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
+                               "text/plain", "application/vnd.ogc.gml", NULL);
+      }
+    } else {
+      if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE))
+        msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
+                             "text/plain", "application/vnd.ogc.gml", NULL);
+    }
+
+    if (strcasecmp(sldenabled, "true") == 0) {
+      if (msOWSRequestIsEnabled(map, NULL, "M", "DescribeLayer", MS_FALSE)) {
+        if (nVersion == OWS_1_3_0)
+          msWMSPrintRequestCap(nVersion, "sld:DescribeLayer",
+                               script_url_encoded, "text/xml", NULL);
+        else
+          msWMSPrintRequestCap(nVersion, "DescribeLayer", script_url_encoded,
+                               "text/xml", NULL);
+      }
+
+      msGetOutputFormatMimeListImg(map, mime_list,
+                                   sizeof(mime_list) / sizeof(char *));
+
+      if (nVersion >= OWS_1_1_1) {
+        const auto isGetLegendGraphicEnabled =
+            msOWSRequestIsEnabled(map, NULL, "M", "GetLegendGraphic", MS_FALSE);
+        if (nVersion == OWS_1_3_0) {
+          if (isGetLegendGraphicEnabled)
+            msWMSPrintRequestCap(
+                nVersion, "sld:GetLegendGraphic", script_url_encoded,
+                mime_list[0], mime_list[1], mime_list[2], mime_list[3],
+                mime_list[4], mime_list[5], mime_list[6], mime_list[7],
+                mime_list[8], mime_list[9], mime_list[10], mime_list[11],
+                mime_list[12], mime_list[13], mime_list[14], mime_list[15],
+                mime_list[16], mime_list[17], mime_list[18], mime_list[19],
+                NULL);
+          if (msOWSRequestIsEnabled(map, NULL, "M", "GetStyles", MS_FALSE))
+            msWMSPrintRequestCap(nVersion, "ms:GetStyles", script_url_encoded,
+                                 "text/xml", NULL);
+        } else {
+          if (isGetLegendGraphicEnabled)
+            msWMSPrintRequestCap(
+                nVersion, "GetLegendGraphic", script_url_encoded, mime_list[0],
+                mime_list[1], mime_list[2], mime_list[3], mime_list[4],
+                mime_list[5], mime_list[6], mime_list[7], mime_list[8],
+                mime_list[9], mime_list[10], mime_list[11], mime_list[12],
+                mime_list[13], mime_list[14], mime_list[15], mime_list[16],
+                mime_list[17], mime_list[18], mime_list[19], NULL);
+          if (msOWSRequestIsEnabled(map, NULL, "M", "GetStyles", MS_FALSE))
+            msWMSPrintRequestCap(nVersion, "GetStyles", script_url_encoded,
+                                 "text/xml", NULL);
+        }
+      }
+    }
+  }
+
+  msIO_printf("  </Request>\n");
+
+  msIO_printf("  <Exception>\n");
+  if (nVersion <= OWS_1_0_7)
+    msIO_printf("    <Format><BLANK /><INIMAGE /><WMS_XML /></Format>\n");
+  else if (nVersion <= OWS_1_1_1) {
+    msIO_printf("    <Format>application/vnd.ogc.se_xml</Format>\n");
+    msIO_printf("    <Format>application/vnd.ogc.se_inimage</Format>\n");
+    msIO_printf("    <Format>application/vnd.ogc.se_blank</Format>\n");
+  } else { /*>=1.3.0*/
+    msIO_printf("    <Format>XML</Format>\n");
+    msIO_printf("    <Format>INIMAGE</Format>\n");
+    msIO_printf("    <Format>BLANK</Format>\n");
+  }
+  msIO_printf("  </Exception>\n");
+
+  if (nVersion != OWS_1_3_0) {
+    /* INSPIRE extended capabilities for WMS 1.1.1 */
+    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                                     "inspire_capabilities")) {
+      msIO_printf("  <VendorSpecificCapabilities>\n");
+      msOWSPrintInspireCommonExtendedCapabilities(
+          stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL,
+          validated_language.c_str(), OWS_WMS);
+      msIO_printf("  </VendorSpecificCapabilities>\n");
+    } else {
+      msIO_printf("  <VendorSpecificCapabilities />\n"); /* nothing yet */
+    }
+  }
+
+  /* SLD support */
+  if (strcasecmp(sldenabled, "true") == 0) {
+    if (nVersion >= OWS_1_0_7) {
+      if (nVersion >= OWS_1_3_0)
+        msIO_printf("  <sld:UserDefinedSymbolization SupportSLD=\"1\" "
+                    "UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\" "
+                    "InlineFeature=\"0\" RemoteWCS=\"0\"/>\n");
+      else
+        msIO_printf("  <UserDefinedSymbolization SupportSLD=\"1\" "
+                    "UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\"/>\n");
+    }
+  }
+
+  /* INSPIRE extended capabilities for WMS 1.3.0 */
+  if (nVersion >= OWS_1_3_0 &&
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities")) {
+    msOWSPrintInspireCommonExtendedCapabilities(
+        stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL,
+        validated_language.c_str(), OWS_WMS);
+  }
+
+  /* Top-level layer with map extents and SRS, encloses all map layers */
+  /* Output only if at least one layers is enabled. */
+  if (ows_request->numlayers == 0) {
+    msIO_fprintf(stdout, "  <!-- WARNING: No WMS layers are enabled. Check "
+                         "wms/ows_enable_request settings. -->\n");
+  } else {
+    int root_is_queryable = MS_FALSE;
+
+    const char *rootlayer_name =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
+
+    /* Root layer is queryable if it has a valid name and at list one layer */
+    /* is queryable */
+    if (!rootlayer_name || strlen(rootlayer_name) > 0) {
+      int j;
+      for (j = 0; j < map->numlayers; j++) {
+        layerObj *layer = GET_LAYER(map, j);
+        if (msIsLayerQueryable(layer) &&
+            msIntegerInArray(layer->index, ows_request->enabled_layers,
+                             ows_request->numlayers)) {
+          root_is_queryable = MS_TRUE;
+          break;
+        }
+      }
+    }
+    msIO_printf("  <Layer%s>\n", root_is_queryable ? " queryable=\"1\"" : "");
+
+    /* Layer Name is optional but title is mandatory. */
+    if (map->name && strlen(map->name) > 0 &&
+        (msIsXMLTagValid(map->name) == MS_FALSE || isdigit(map->name[0])))
+      msIO_fprintf(stdout,
+                   "<!-- WARNING: The layer name '%s' might contain spaces or "
+                   "invalid characters or may start with a number. This could "
+                   "lead to potential problems. -->\n",
+                   map->name);
+
+    if (rootlayer_name) {
+      if (strlen(rootlayer_name) > 0) {
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO",
+                                 "rootlayer_name", OWS_NOERR,
+                                 "    <Name>%s</Name>\n", NULL);
+      }
+    } else {
+      msOWSPrintEncodeParam(stdout, "MAP.NAME", map->name, OWS_NOERR,
+                            "    <Name>%s</Name>\n", NULL);
+    }
+
+    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO",
+                                        "rootlayer_title",
+                                        validated_language.c_str()))
+      msOWSPrintEncodeMetadata2(
+          stdout, &(map->web.metadata), "MO", "rootlayer_title", OWS_WARN,
+          "    <Title>%s</Title>\n", map->name, validated_language.c_str());
+
+    else
+      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "title",
+                                OWS_WARN, "    <Title>%s</Title>\n", map->name,
+                                validated_language.c_str());
+
+    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO",
+                                        "rootlayer_abstract",
+                                        validated_language.c_str()))
+      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO",
+                                "rootlayer_abstract", OWS_NOERR,
+                                "    <Abstract>%s</Abstract>\n", map->name,
+                                validated_language.c_str());
+    else
+      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "abstract",
+                                OWS_NOERR, "    <Abstract>%s</Abstract>\n",
+                                map->name, validated_language.c_str());
+
+    const char *pszTmp;
+    if (msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "rootlayer_keywordlist") ||
+        msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "rootlayer_keywordlist_vocabulary"))
+      pszTmp = "rootlayer_keywordlist";
+    else
+      pszTmp = "keywordlist";
+    msWMSPrintKeywordlist(stdout, "    ", pszTmp, &(map->web.metadata), "MO",
+                          nVersion);
+
+    /* According to normative comments in the 1.0.7 DTD, the root layer's SRS
+     * tag */
+    /* is REQUIRED.  It also suggests that we use an empty SRS element if there
+     */
+    /* is no common SRS. */
+    char *pszMapEPSG;
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE,
+                     &pszMapEPSG);
+    if (nVersion > OWS_1_1_0) {
+      /* starting 1.1.1 SRS are given in individual tags */
+      if (nVersion >= OWS_1_3_0) {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
+                                  "MAP.PROJECTION, LAYER.PROJECTION "
+                                  "or wms_srs metadata",
+                                  pszMapEPSG, OWS_WARN, ' ', NULL, NULL,
+                                  "    <CRS>%s</CRS>\n", "");
+      } else {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
+                                  "MAP.PROJECTION, LAYER.PROJECTION "
+                                  "or wms_srs metadata",
+                                  pszMapEPSG, OWS_WARN, ' ', NULL, NULL,
+                                  "    <SRS>%s</SRS>\n", "");
+      }
+    } else {
+      /* If map has no proj then every layer MUST have one or produce a warning
+       */
+      msOWSPrintEncodeParam(stdout, "MAP.PROJECTION (or wms_srs metadata)",
+                            pszMapEPSG, OWS_WARN, "    <SRS>%s</SRS>\n", "");
+    }
+    msFree(pszMapEPSG);
+
+    if (nVersion >= OWS_1_3_0)
+      msOWSPrintEX_GeographicBoundingBox(stdout, "    ", &(map->extent),
+                                         &(map->projection));
+    else
+      msOWSPrintLatLonBoundingBox(stdout, "    ", &(map->extent),
+                                  &(map->projection), NULL, OWS_WMS);
+
+    msOWSPrintBoundingBox(stdout, "    ", &(map->extent), &(map->projection),
+                          NULL, &(map->web.metadata), "MO", nVersion);
+
+    if (nVersion >= OWS_1_0_7) {
+      msWMSPrintAttribution(stdout, "    ", &(map->web.metadata), "MO");
+    }
+
+    /* AuthorityURL support and Identifier support, only available >= WMS 1.1.0
+     */
+    if (nVersion >= OWS_1_1_0) {
+      msWMSPrintAuthorityURL(stdout, "    ", &(map->web.metadata), "MO");
+      msWMSPrintIdentifier(stdout, "    ", &(map->web.metadata), "MO");
+    }
+
+    /* MetadataURL */
+    if (nVersion >= OWS_1_1_0)
+      msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "metadataurl",
+                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"", NULL,
+                        NULL, ">\n      <Format>%s</Format",
+                        "\n      <OnlineResource xmlns:xlink=\""
+                        "http://www.w3.org/1999/xlink\" "
+                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n    ",
+                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "    ");
+
+    /* DataURL */
+    if (nVersion < OWS_1_1_0)
+      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO",
+                               "dataurl_href", OWS_NOERR,
+                               "    <DataURL>%s</DataURL>\n", NULL);
+    else
+      msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "dataurl",
+                        OWS_NOERR, NULL, "DataURL", NULL, NULL, NULL,
+                        ">\n      <Format>%s</Format",
+                        "\n      <OnlineResource xmlns:xlink=\""
+                        "http://www.w3.org/1999/xlink\" "
+                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n    ",
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "    ");
+
+    if (map->name && strlen(map->name) > 0 &&
+        msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "inspire_capabilities")) {
+      char *pszEncodedName = NULL;
+      const char *styleName = NULL;
+      char *pszEncodedStyleName = NULL;
+      const char *legendURL = NULL;
+
+      pszEncodedName = msEncodeHTMLEntities(map->name);
+
+      styleName = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
+      if (styleName == NULL)
+        styleName = "default";
+
+      pszEncodedStyleName = msEncodeHTMLEntities(styleName);
+
+      msIO_fprintf(stdout, "    <Style>\n");
+      msIO_fprintf(stdout, "       <Name>%s</Name>\n", pszEncodedStyleName);
+      msOWSPrintEncodeMetadata2(
+          stdout, &(map->web.metadata), "MO", "style_title", OWS_NOERR,
+          "       <Title>%s</Title>\n", styleName, validated_language.c_str());
+
+      legendURL = msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                      "style_legendurl_href");
+      if (legendURL) {
+        msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "style_legendurl",
+                          OWS_NOERR, NULL, "LegendURL", NULL, " width=\"%s\"",
+                          " height=\"%s\"", ">\n          <Format>%s</Format",
+                          "\n          <OnlineResource "
+                          "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                          " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                          "       ",
+                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "       ");
+      } else {
+        std::vector<int> group_layers;
+        group_layers.reserve(map->numlayers);
+
+        for (int i = 0; i < map->numlayers; i++)
+          if (msIntegerInArray(GET_LAYER(map, i)->index,
+                               ows_request->enabled_layers,
+                               ows_request->numlayers))
+            group_layers.push_back(i);
+
+        if (!group_layers.empty()) {
+          int size_x = 0, size_y = 0;
+          if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(),
+                               static_cast<int>(group_layers.size()), NULL,
+                               1) == MS_SUCCESS) {
+            const std::string width(std::to_string(size_x));
+            const std::string height(std::to_string(size_y));
+
+            const char *format_list = msOWSLookupMetadata(
+                &(map->web.metadata), "M", "getlegendgraphic_formatlist");
+            char *pszMimetype = NULL;
+            if (format_list && strlen(format_list) > 0) {
+              const auto tokens = msStringSplit(format_list, ',');
+              if (!tokens.empty()) {
+                /*just grab the first mime type*/
+                pszMimetype = msEncodeHTMLEntities(tokens[0].c_str());
+              }
+            } else
+              pszMimetype = msEncodeHTMLEntities("image/png");
+
+            std::string legendurl(script_url_encoded);
+            legendurl += "version=";
+            char szVersionBuf[OWS_VERSION_MAXLEN];
+            legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
+            legendurl += "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
+            if (nVersion >= OWS_1_3_0) {
+              legendurl += "sld_version=1.1.0&amp;layer=";
+            } else {
+              legendurl += "layer=";
+            }
+            legendurl += pszEncodedName;
+            legendurl += "&amp;format=";
+            legendurl += pszMimetype;
+            legendurl += "&amp;STYLE=";
+            legendurl += pszEncodedStyleName;
+
+            msOWSPrintURLType(stdout, NULL, "O", "ttt", OWS_NOERR, NULL,
+                              "LegendURL", NULL, " width=\"%s\"",
+                              " height=\"%s\"",
+                              ">\n          <Format>%s</Format",
+                              "\n          <OnlineResource "
+                              "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                              " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                              "       ",
+                              MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
+                              NULL, width.c_str(), height.c_str(), pszMimetype,
+                              legendurl.c_str(), "       ");
+            msFree(pszMimetype);
+          }
+        }
+      }
+      msIO_fprintf(stdout, "    </Style>\n");
+      msFree(pszEncodedName);
+      msFree(pszEncodedStyleName);
+    }
+
+    if (nVersion < OWS_1_3_0)
+      msWMSPrintScaleHint("    ", map->web.minscaledenom,
+                          map->web.maxscaledenom, map->resolution);
+    else
+      msWMSPrintScaleDenominator("    ", map->web.minscaledenom,
+                                 map->web.maxscaledenom);
+
+    /*  */
+    /* Dump list of layers organized by groups.  Layers with no group are listed
+     */
+    /* individually, at the same level as the groups in the layer hierarchy */
+    /*  */
+    if (map->numlayers) {
+      char ***nestedGroups = NULL;
+      int *numNestedGroups = NULL;
+      int *isUsedInNestedGroup = NULL;
+
+      /* We'll use this array of booleans to track which layer/group have been
+       */
+      /* processed already */
+      std::vector<char> pabLayerProcessed(map->numlayers);
+
+      /* Mark disabled layers as processed to prevent from being displayed in
+       * nested groups (#4533)*/
+      for (int i = 0; i < map->numlayers; i++) {
+        if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                              ows_request->enabled_layers,
+                              ows_request->numlayers))
+          pabLayerProcessed[i] = 1;
+      }
+
+      nestedGroups = (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+      numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                               isUsedInNestedGroup);
+
+      for (int i = 0; i < map->numlayers; i++) {
+        layerObj *lp = (GET_LAYER(map, i));
+
+        if (pabLayerProcessed[i] || (lp->status == MS_DELETE))
+          continue; /* Layer is hidden or has already been handled */
+
+        if (numNestedGroups[i] > 0) {
+          /* Has nested groups.  */
+          msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed.data(), i, 0,
+                                 nestedGroups, numNestedGroups,
+                                 isUsedInNestedGroup, script_url_encoded,
+                                 validated_language.c_str());
+        } else if (lp->group == NULL || strlen(lp->group) == 0) {
+          /* Don't dump layer if it is used in wms_group_layer. */
+          if (!isUsedInNestedGroup[i]) {
+            /* This layer is not part of a group... dump it directly */
+            msDumpLayer(map, lp, nVersion, script_url_encoded, "",
+                        validated_language.c_str(), MS_FALSE, MS_FALSE);
+            pabLayerProcessed[i] = 1;
+          }
+        } else {
+          bool group_is_queryable = false;
+          /* Group is queryable as soon as its member layers is. */
+          for (int j = i; j < map->numlayers; j++) {
+            if (GET_LAYER(map, j)->group &&
+                strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
+                msIntegerInArray(GET_LAYER(map, j)->index,
+                                 ows_request->enabled_layers,
+                                 ows_request->numlayers) &&
+                msIsLayerQueryable(GET_LAYER(map, j))) {
+              group_is_queryable = true;
+              break;
+            }
+          }
+          /* Beginning of a new group... enclose the group in a layer block */
+          msIO_printf("    <Layer%s>\n",
+                      group_is_queryable ? " queryable=\"1\"" : "");
+
+          /* Layer Name is optional but title is mandatory. */
+          if (lp->group && strlen(lp->group) > 0 &&
+              (msIsXMLTagValid(lp->group) == MS_FALSE || isdigit(lp->group[0])))
+            msIO_fprintf(
+                stdout,
+                "<!-- WARNING: The layer name '%s' might contain spaces or "
+                "invalid characters or may start with a number. This could "
+                "lead to potential problems. -->\n",
+                lp->group);
+          msOWSPrintEncodeParam(stdout, "GROUP.NAME", lp->group, OWS_NOERR,
+                                "      <Name>%s</Name>\n", NULL);
+          msOWSPrintGroupMetadata2(stdout, map, lp->group, "MO", "GROUP_TITLE",
+                                   OWS_WARN, "      <Title>%s</Title>\n",
+                                   lp->group, validated_language.c_str());
+          msOWSPrintGroupMetadata2(stdout, map, lp->group, "MO",
+                                   "GROUP_ABSTRACT", OWS_NOERR,
+                                   "      <Abstract>%s</Abstract>\n", lp->group,
+                                   validated_language.c_str());
+
+          /*build a getlegendgraphicurl*/
+          if (script_url_encoded) {
+            if (lp->group && strlen(lp->group) > 0) {
+              char *pszEncodedName = NULL;
+              const char *styleName = NULL;
+              char *pszEncodedStyleName = NULL;
+              const char *legendURL = NULL;
+
+              pszEncodedName = msEncodeHTMLEntities(lp->group);
+
+              styleName = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                              "group_style_name");
+              if (styleName == NULL)
+                styleName = "default";
+
+              pszEncodedStyleName = msEncodeHTMLEntities(styleName);
+
+              msIO_fprintf(stdout, "    <Style>\n");
+              msIO_fprintf(stdout, "       <Name>%s</Name>\n",
+                           pszEncodedStyleName);
+              msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO",
+                                       "group_style_title", OWS_NOERR,
+                                       "       <Title>%s</Title>\n", styleName);
+
+              legendURL = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                              "group_style_legendurl_href");
+              if (legendURL) {
+                msOWSPrintURLType(
+                    stdout, &(lp->metadata), "MO", "group_style_legendurl",
+                    OWS_NOERR, NULL, "LegendURL", NULL, " width=\"%s\"",
+                    " height=\"%s\"", ">\n          <Format>%s</Format",
+                    "\n          <OnlineResource "
+                    "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                    " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                    "       ",
+                    MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL, NULL,
+                    NULL, NULL, NULL, "       ");
+              } else {
+                std::vector<int> group_layers;
+                group_layers.reserve(map->numlayers);
+
+                for (int j = i; j < map->numlayers; j++)
+                  if (!pabLayerProcessed[j] && GET_LAYER(map, j)->group &&
+                      strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
+                      msIntegerInArray(GET_LAYER(map, j)->index,
+                                       ows_request->enabled_layers,
+                                       ows_request->numlayers))
+                    group_layers.push_back(j);
+
+                if (!group_layers.empty()) {
+                  int size_x = 0, size_y = 0;
+                  char *pszMimetype = NULL;
+
+                  if (msLegendCalcSize(map, 1, &size_x, &size_y,
+                                       group_layers.data(),
+                                       static_cast<int>(group_layers.size()),
+                                       NULL, 1) == MS_SUCCESS) {
+                    const std::string width(std::to_string(size_x));
+                    const std::string height(std::to_string(size_y));
+
+                    const char *format_list =
+                        msOWSLookupMetadata(&(map->web.metadata), "M",
+                                            "getlegendgraphic_formatlist");
+                    if (format_list && strlen(format_list) > 0) {
+                      const auto tokens = msStringSplit(format_list, ',');
+                      if (!tokens.empty()) {
+                        /*just grab the first mime type*/
+                        pszMimetype = msEncodeHTMLEntities(tokens[0].c_str());
+                      }
+                    } else
+                      pszMimetype = msEncodeHTMLEntities("image/png");
+
+                    std::string legendurl(script_url_encoded);
+                    legendurl += "version=";
+                    char szVersionBuf[OWS_VERSION_MAXLEN];
+                    legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
+                    legendurl +=
+                        "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
+                    if (nVersion >= OWS_1_3_0) {
+                      legendurl += "sld_version=1.1.0&amp;layer=";
+                    } else {
+                      legendurl += "layer=";
+                    }
+                    legendurl += pszEncodedName;
+                    legendurl += "&amp;format=";
+                    legendurl += pszMimetype;
+                    legendurl += "&amp;STYLE=";
+                    legendurl += pszEncodedStyleName;
+
+                    msOWSPrintURLType(
+                        stdout, NULL, "O", "ttt", OWS_NOERR, NULL, "LegendURL",
+                        NULL, " width=\"%s\"", " height=\"%s\"",
+                        ">\n          <Format>%s</Format",
+                        "\n          <OnlineResource "
+                        "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                        " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                        "       ",
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, NULL,
+                        width.c_str(), height.c_str(), pszMimetype,
+                        legendurl.c_str(), "       ");
+
+                    msFree(pszMimetype);
+                  }
+                }
+              }
+              msIO_fprintf(stdout, "    </Style>\n");
+              msFree(pszEncodedName);
+              msFree(pszEncodedStyleName);
+            }
+          }
+
+          /* Dump all layers for this group */
+          for (int j = i; j < map->numlayers; j++) {
+            if (!pabLayerProcessed[j] && GET_LAYER(map, j)->group &&
+                strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
+                msIntegerInArray(GET_LAYER(map, j)->index,
+                                 ows_request->enabled_layers,
+                                 ows_request->numlayers)) {
+              msDumpLayer(map, (GET_LAYER(map, j)), nVersion,
+                          script_url_encoded, "  ", validated_language.c_str(),
+                          MS_FALSE, MS_FALSE);
+              pabLayerProcessed[j] = 1;
+            }
+          }
+          /* Close group layer block */
+          msIO_printf("    </Layer>\n");
+        }
+      }
+
+      /* free the stuff used for nested layers */
+      for (int i = 0; i < map->numlayers; i++) {
+        if (numNestedGroups[i] > 0) {
+          msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
+        }
+      }
+      free(nestedGroups);
+      free(numNestedGroups);
+      free(isUsedInNestedGroup);
+    }
+
+    msIO_printf("  </Layer>\n");
+  }
+
+  msIO_printf("</Capability>\n");
+  if (nVersion >= OWS_1_3_0)
+    msIO_printf("</WMS_Capabilities>\n");
+  else
+    msIO_printf("</WMT_MS_Capabilities>\n");
+
+  free(script_url_encoded);
+
+  return (MS_SUCCESS);
+}
+
+/*
+ * This function look for params that can be used
+ * by mapserv when generating template.
+ */
+int msTranslateWMS2Mapserv(const char **names, const char **values,
+                           int numentries, char ***translated_names,
+                           char ***translated_values,
+                           int *translated_numentries) {
+  int num_allocated = numentries;
+  *translated_names = (char **)msSmallMalloc(num_allocated * sizeof(char *));
+  *translated_values = (char **)msSmallMalloc(num_allocated * sizeof(char *));
+  *translated_numentries = 0;
+  for (int i = 0; i < numentries; i++) {
+    (*translated_values)[*translated_numentries] = msStrdup(values[i]);
+    (*translated_names)[*translated_numentries] = msStrdup(names[i]);
+    (*translated_numentries)++;
+    if (strcasecmp("X", names[i]) == 0) {
+      num_allocated++;
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
+      (*translated_values)[*translated_numentries] = msStrdup(values[i]);
+      (*translated_names)[*translated_numentries] = msStrdup("img.x");
+      (*translated_numentries)++;
+    } else if (strcasecmp("Y", names[i]) == 0) {
+      num_allocated++;
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
+      (*translated_values)[*translated_numentries] = msStrdup(values[i]);
+      (*translated_names)[*translated_numentries] = msStrdup("img.y");
+      (*translated_numentries)++;
+    } else if (strcasecmp("LAYERS", names[i]) == 0) {
+      char **layers;
+      int tok;
+      int j;
+      layers = msStringSplit(values[i], ',', &tok);
+      num_allocated += tok;
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
+      for (j = 0; j < tok; j++) {
+        (*translated_values)[*translated_numentries] = layers[j];
+        (*translated_names)[*translated_numentries] = msStrdup("layer");
+        (*translated_numentries)++;
+        layers[j] = NULL;
+      }
+      free(layers);
+    } else if (strcasecmp("QUERY_LAYERS", names[i]) == 0) {
+      char **layers;
+      int tok;
+      int j;
+      layers = msStringSplit(values[i], ',', &tok);
+      num_allocated += tok;
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
+      for (j = 0; j < tok; j++) {
+        (*translated_values)[*translated_numentries] = layers[j];
+        (*translated_names)[*translated_numentries] = msStrdup("qlayer");
+        (*translated_numentries)++;
+        layers[j] = NULL;
+      }
+      free(layers);
+    } else if (strcasecmp("BBOX", names[i]) == 0) {
+      char *imgext;
+      num_allocated++;
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
+
+      /* Note msReplaceSubstring() works on the string itself, so we need to
+       * make a copy */
+      imgext = msStrdup(values[i]);
+      imgext = msReplaceSubstring(imgext, ",", " ");
+      (*translated_values)[*translated_numentries] = imgext;
+      (*translated_names)[*translated_numentries] = msStrdup("imgext");
+      (*translated_numentries)++;
+    }
+  }
+
+  return MS_SUCCESS;
+}
+
+/*
+** msWMSGetMap()
+*/
+static int msWMSGetMap(mapObj *map, int nVersion, char **names, char **values,
+                       int numentries, const char *wms_exception_format,
+                       owsRequestObj *ows_request) {
+  imageObj *img;
+  int sldrequested = MS_FALSE, sldspatialfilter = MS_FALSE;
+  int drawquerymap = MS_FALSE;
+
+  /* __TODO__ msDrawMap() will try to adjust the extent of the map */
+  /* to match the width/height image ratio. */
+  /* The spec states that this should not happen so that we can deliver */
+  /* maps to devices with non-square pixels. */
+
+  /* If there was an SLD in the request, we need to treat it */
+  /* diffrently : some SLD may contain spatial filters requiring */
+  /* to do a query. While parsing the SLD and applying it to the */
+  /* layer, we added a temporary metadata on the layer */
+  /* (tmp_wms_sld_query) for layers with a spatial filter. */
+
+  for (int i = 0; i < numentries; i++) {
+    if ((strcasecmp(names[i], "SLD") == 0 && values[i] &&
+         strlen(values[i]) > 0) ||
+        (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] &&
+         strlen(values[i]) > 0)) {
+      sldrequested = MS_TRUE;
+      break;
+    }
+  }
+  if (sldrequested) {
+    for (int i = 0; i < map->numlayers; i++) {
+      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata),
+                            "tmp_wms_sld_query")) {
+        sldspatialfilter = MS_TRUE;
+        break;
+      }
+    }
+  }
+  /* If FILTER is passed then we'll render layers as querymap */
+  for (int i = 0; i < numentries; i++) {
+    if ((strcasecmp(names[i], "FILTER") == 0 && values[i] &&
+         strlen(values[i]) > 0)) {
+      drawquerymap = MS_TRUE;
+      map->querymap.status = MS_ON;
+      map->querymap.style = MS_SELECTED;
+      break;
+    }
+  }
+
+  /* turn off layer if WMS GetMap is not enabled */
+  for (int i = 0; i < map->numlayers; i++)
+    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
+      GET_LAYER(map, i)->status = MS_OFF;
+
+  if (sldrequested && sldspatialfilter) {
+    /* set the quermap style so that only selected features will be retruned */
+    map->querymap.status = MS_ON;
+    map->querymap.style = MS_SELECTED;
+
+    img = msPrepareImage(map, MS_TRUE);
+
+    /* compute layer scale factors now */
+    for (int i = 0; i < map->numlayers; i++) {
+      if (GET_LAYER(map, i)->sizeunits != MS_PIXELS)
+        GET_LAYER(map, i)->scalefactor =
+            (msInchesPerUnit(GET_LAYER(map, i)->sizeunits, 0) /
+             msInchesPerUnit(map->units, 0)) /
+            map->cellsize;
+      else if (GET_LAYER(map, i)->symbolscaledenom > 0 && map->scaledenom > 0)
+        GET_LAYER(map, i)->scalefactor =
+            GET_LAYER(map, i)->symbolscaledenom / map->scaledenom;
+      else
+        GET_LAYER(map, i)->scalefactor = 1;
+    }
+    for (int i = 0; i < map->numlayers; i++) {
+      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata),
+                            "tmp_wms_sld_query") &&
+          (GET_LAYER(map, i)->type == MS_LAYER_POINT ||
+           GET_LAYER(map, i)->type == MS_LAYER_LINE ||
+           GET_LAYER(map, i)->type == MS_LAYER_POLYGON ||
+           GET_LAYER(map, i)->type == MS_LAYER_TILEINDEX))
+
+      {
+        /* make sure that there is a resultcache. If not just ignore */
+        /* the layer */
+        if (GET_LAYER(map, i)->resultcache)
+          msDrawQueryLayer(map, GET_LAYER(map, i), img);
+      }
+
+      else
+        IGNORE_RET_VAL(msDrawLayer(map, GET_LAYER(map, i), img));
+    }
+
+  } else {
+
+    /* intercept requests for Mapbox vector tiles */
+    if (!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat),
+                "application/vnd.mapbox-vector-tile") ||
+        !strcmp(MS_IMAGE_MIME_TYPE(map->outputformat),
+                "application/x-protobuf")) {
+      int status = 0;
+      if ((status = msMVTWriteTile(map, MS_TRUE)) != MS_SUCCESS)
+        return MS_FAILURE;
+      return MS_SUCCESS;
+    }
+
+    img = msDrawMap(map, drawquerymap);
+  }
+
+  /* see if we have tiled = true and a buffer */
+  /* if so, clip the image */
+  for (int i = 0; i < numentries; i++) {
+    if (strcasecmp(names[i], "TILED") == 0 &&
+        strcasecmp(values[i], "TRUE") == 0) {
+      hashTableObj *meta = &(map->web.metadata);
+      const char *value;
+
+      if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
+        const int map_edge_buffer = atoi(value);
+        if (map_edge_buffer > 0) {
+          /* we have to clip the image */
+
+          // TODO: we could probably avoid the use of an intermediate image
+          // by playing with the rasterBufferObj's data->rgb.pixels and
+          // data->rgb.row_stride values.
+          rendererVTableObj *renderer = MS_MAP_RENDERER(map);
+          rasterBufferObj imgBuffer;
+          if (renderer->getRasterBufferHandle((imageObj *)img, &imgBuffer) !=
+              MS_SUCCESS) {
+            msFreeImage(img);
+            return MS_FAILURE;
+          }
+
+          int width = map->width - map_edge_buffer - map_edge_buffer;
+          int height = map->height - map_edge_buffer - map_edge_buffer;
+          imageObj *tmp =
+              msImageCreate(width, height, map->outputformat, NULL, NULL,
+                            map->resolution, map->defresolution, NULL);
+
+          if ((MS_FAILURE == renderer->mergeRasterBuffer(
+                                 tmp, &imgBuffer, 1.0, map_edge_buffer,
+                                 map_edge_buffer, 0, 0, width, height))) {
+            msFreeImage(tmp);
+            msFreeImage(img);
+            img = NULL;
+          } else {
+            msFreeImage(img);
+            img = tmp;
+          }
+        }
+      }
+      break;
+    }
+  }
+
+  if (img == NULL)
+    return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+  /* Set the HTTP Cache-control headers if they are defined
+     in the map object */
+
+  const char *http_max_age =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "http_max_age");
+  if (http_max_age) {
+    msIO_setHeader("Cache-Control", "max-age=%s", http_max_age);
+  }
+
+  if (strcasecmp(map->imagetype, "application/openlayers") != 0) {
+    if (!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/json")) {
+      msIO_setHeader("Content-Type", "application/json; charset=utf-8");
+    } else {
+      msOutputFormatResolveFromImage(map, img);
+      msIO_setHeader("Content-Type", "%s",
+                     MS_IMAGE_MIME_TYPE(map->outputformat));
+    }
+    msIO_sendHeaders();
+    if (msSaveImage(map, img, NULL) != MS_SUCCESS) {
+      msFreeImage(img);
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+  }
+  msFreeImage(img);
+
+  return (MS_SUCCESS);
+}
+
+static int msDumpResult(mapObj *map, int nVersion,
+                        const char *wms_exception_format) {
+  int numresults = 0;
+
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *lp = (GET_LAYER(map, i));
+
+    if (lp->status != MS_ON || lp->resultcache == NULL ||
+        lp->resultcache->numresults == 0)
+      continue;
+
+    /* if(msLayerOpen(lp) != MS_SUCCESS || msLayerGetItems(lp) != MS_SUCCESS)
+     return msWMSException(map, nVersion, NULL); */
+
+    /* Use metadata to control which fields to output. We use the same
+     * metadata names as for GML:
+     * wms/ows_include_items: comma delimited list or keyword 'all'
+     * wms/ows_exclude_items: comma delimited list (all items are excluded by
+     * default)
+     */
+    /* get a list of items that should be excluded in output */
+    std::vector<std::string> incitems;
+    const char *value;
+    if ((value = msOWSLookupMetadata(&(lp->metadata), "MO", "include_items")) !=
+        NULL)
+      incitems = msStringSplit(value, ',');
+
+    /* get a list of items that should be excluded in output */
+    std::vector<std::string> excitems;
+    if ((value = msOWSLookupMetadata(&(lp->metadata), "MO", "exclude_items")) !=
+        NULL)
+      excitems = msStringSplit(value, ',');
+
+    std::vector<bool> itemvisible(lp->numitems);
+    for (int k = 0; k < lp->numitems; k++) {
+      /* check visibility, included items first... */
+      if (incitems.size() == 1 && strcasecmp("all", incitems[0].c_str()) == 0) {
+        itemvisible[k] = true;
+      } else {
+        for (const auto &incitem : incitems) {
+          if (strcasecmp(lp->items[k], incitem.c_str()) == 0)
+            itemvisible[k] = true;
+        }
+      }
+
+      /* ...and now excluded items */
+      for (const auto &excitem : excitems) {
+        if (strcasecmp(lp->items[k], excitem.c_str()) == 0)
+          itemvisible[k] = false;
+      }
+    }
+
+    /* Output selected shapes for this layer */
+    msIO_printf("\nLayer '%s'\n", lp->name);
+
+    for (int j = 0; j < lp->resultcache->numresults; j++) {
+      shapeObj shape;
+
+      msInitShape(&shape);
+      if (msLayerGetShape(lp, &shape, &(lp->resultcache->results[j])) !=
+          MS_SUCCESS) {
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+      }
+
+      msIO_printf("  Feature %ld: \n", lp->resultcache->results[j].shapeindex);
+
+      for (int k = 0; k < lp->numitems; k++) {
+        if (itemvisible[k]) {
+          value = msOWSLookupMetadata(
+              &(lp->metadata), "MO",
+              (std::string(lp->items[k]) + "_alias").c_str());
+          const char *lineTemplate = "    %s = '%s'\n";
+          msIO_printf(lineTemplate, value != NULL ? value : lp->items[k],
+                      shape.values[k]);
+        }
+      }
+
+      msFreeShape(&shape);
+      numresults++;
+    }
+
+    /* msLayerClose(lp); */
+  }
+
+  return numresults;
+}
+
+/*
+** msWMSFeatureInfo()
+*/
+static int msWMSFeatureInfo(mapObj *map, int nVersion, char **names,
+                            char **values, int numentries,
+                            const char *wms_exception_format,
+                            owsRequestObj *ows_request) {
+  int feature_count = 1, numlayers_found = 0;
+  pointObj point = {-1.0, -1.0, -1.0, -1.0};
+  const char *info_format = "MIME";
+  errorObj *ms_error = msGetErrorObj();
+  int query_status = MS_NOERR;
+  int query_layer = 0;
+  const char *format_list = NULL;
+  int valid_format = MS_FALSE;
+  int format_found = MS_FALSE;
+  int use_bbox = MS_FALSE;
+  int wms_layer = MS_FALSE;
+  const char *wms_connection = NULL;
+  int numOWSLayers = 0;
+
+  char ***nestedGroups =
+      (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+  int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  int *isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                           isUsedInNestedGroup);
+
+  for (int i = 0; i < numentries; i++) {
+    if (strcasecmp(names[i], "QUERY_LAYERS") == 0) {
+      query_layer = 1; /* flag set if QUERY_LAYERS is the request */
+
+      const auto wmslayers = msStringSplit(values[i], ',');
+      if (wmslayers.empty()) {
+        msSetError(MS_WMSERR,
+                   "At least one layer name required in QUERY_LAYERS.",
+                   "msWMSFeatureInfo()");
+        return msWMSException(map, nVersion, "LayerNotDefined",
+                              wms_exception_format);
+      }
+
+      for (int j = 0; j < map->numlayers; j++) {
+        /* Force all layers OFF by default */
+        GET_LAYER(map, j)->status = MS_OFF;
+      }
+
+      /* Special case for root layer */
+      const char *rootlayer_name =
+          msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
+      if (!rootlayer_name)
+        rootlayer_name = map->name;
+      if (rootlayer_name && msStringInArray(rootlayer_name, wmslayers)) {
+        for (int j = 0; j < map->numlayers; j++) {
+          layerObj *layer = GET_LAYER(map, j);
+          if (msIsLayerQueryable(layer) &&
+              msIntegerInArray(layer->index, ows_request->enabled_layers,
+                               ows_request->numlayers)) {
+            if (layer->connectiontype == MS_WMS) {
+              wms_layer = MS_TRUE;
+              wms_connection = layer->connection;
+            }
+
+            numlayers_found++;
+            layer->status = MS_ON;
+          }
+        }
+      }
+
+      for (int j = 0; j < map->numlayers; j++) {
+        layerObj *layer = GET_LAYER(map, j);
+        if (!msIsLayerQueryable(layer))
+          continue;
+        for (const auto &wmslayer : wmslayers) {
+          if (((layer->name &&
+                strcasecmp(layer->name, wmslayer.c_str()) == 0) ||
+               (layer->group &&
+                strcasecmp(layer->group, wmslayer.c_str()) == 0) ||
+               ((numNestedGroups[j] > 0) &&
+                msStringInArray(wmslayer.c_str(), nestedGroups[j],
+                                numNestedGroups[j]))) &&
+              (msIntegerInArray(layer->index, ows_request->enabled_layers,
+                                ows_request->numlayers))) {
+
+            if (layer->connectiontype == MS_WMS) {
+              wms_layer = MS_TRUE;
+              wms_connection = layer->connection;
+            }
+
+            numlayers_found++;
+            layer->status = MS_ON;
+          }
+        }
+      }
+    } else if (strcasecmp(names[i], "INFO_FORMAT") == 0) {
+      if (values[i] && strlen(values[i]) > 0) {
+        info_format = values[i];
+        format_found = MS_TRUE;
+      }
+    } else if (strcasecmp(names[i], "FEATURE_COUNT") == 0)
+      feature_count = atoi(values[i]);
+    else if (strcasecmp(names[i], "X") == 0 || strcasecmp(names[i], "I") == 0)
+      point.x = atof(values[i]);
+    else if (strcasecmp(names[i], "Y") == 0 || strcasecmp(names[i], "J") == 0)
+      point.y = atof(values[i]);
+    else if (strcasecmp(names[i], "RADIUS") == 0) {
+      /* RADIUS in pixels. */
+      /* This is not part of the spec, but some servers such as cubeserv */
+      /* support it as a vendor-specific feature. */
+      /* It's easy for MapServer to handle this so let's do it! */
+
+      /* Special RADIUS value that changes the query into a bbox query */
+      /* based on the bbox in the request parameters. */
+      if (strcasecmp(values[i], "BBOX") == 0) {
+        use_bbox = MS_TRUE;
+      } else {
+        int j;
+        for (j = 0; j < map->numlayers; j++) {
+          GET_LAYER(map, j)->tolerance = atoi(values[i]);
+          GET_LAYER(map, j)->toleranceunits = MS_PIXELS;
+        }
+      }
+    }
+  }
+
+  /* free the stuff used for nested layers */
+  for (int i = 0; i < map->numlayers; i++) {
+    if (numNestedGroups[i] > 0) {
+      msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
+    }
+  }
+  free(nestedGroups);
+  free(numNestedGroups);
+  free(isUsedInNestedGroup);
+
+  if (numlayers_found == 0) {
+    if (query_layer) {
+      msSetError(MS_WMSERR,
+                 "Layer(s) specified in QUERY_LAYERS parameter is not offered "
+                 "by the service instance.",
+                 "msWMSFeatureInfo()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
+    } else {
+      msSetError(MS_WMSERR,
+                 "Required QUERY_LAYERS parameter missing for getFeatureInfo.",
+                 "msWMSFeatureInfo()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
+    }
+  }
+
+  /*make sure to initialize the map scale so that layers that are scale
+    dependent are resepected for the query*/
+  msCalculateScale(map->extent, map->units, map->width, map->height,
+                   map->resolution, &map->scaledenom);
+
+  /* -------------------------------------------------------------------- */
+  /*      check if all layers selected are queryable. If not send an      */
+  /*      exception.                                                      */
+  /* -------------------------------------------------------------------- */
+
+  /* If a layer of type WMS was found... all layers have to be of that type and
+   * with the same connection */
+  for (int i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->status == MS_ON) {
+      if (wms_layer == MS_TRUE) {
+        if ((GET_LAYER(map, i)->connectiontype != MS_WMS) ||
+            (strcasecmp(wms_connection, GET_LAYER(map, i)->connection) != 0)) {
+          msSetError(MS_WMSERR,
+                     "Requested WMS layer(s) are not queryable: type or "
+                     "connection differ",
+                     "msWMSFeatureInfo()");
+          return msWMSException(map, nVersion, "LayerNotQueryable",
+                                wms_exception_format);
+        }
+        ++numOWSLayers;
+      }
+    }
+  }
+
+  /* It's a valid Cascading WMS GetFeatureInfo request */
+  if (wms_layer)
+    return msWMSLayerExecuteRequest(map, numOWSLayers, point.x, point.y,
+                                    feature_count, info_format,
+                                    WMS_GETFEATUREINFO);
+
+  if (use_bbox == MS_FALSE) {
+
+    if (point.x == -1.0 || point.y == -1.0) {
+      if (nVersion >= OWS_1_3_0)
+        msSetError(MS_WMSERR,
+                   "Required I/J parameters missing for getFeatureInfo.",
+                   "msWMSFeatureInfo()");
+      else
+        msSetError(MS_WMSERR,
+                   "Required X/Y parameters missing for getFeatureInfo.",
+                   "msWMSFeatureInfo()");
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+
+    /*wms1.3.0: check if the points are valid*/
+    if (nVersion >= OWS_1_3_0) {
+      if (point.x > map->width || point.y > map->height) {
+        msSetError(MS_WMSERR, "Invalid I/J values", "msWMSFeatureInfo()");
+        return msWMSException(map, nVersion, "InvalidPoint",
+                              wms_exception_format);
+      }
+    }
+    /* Perform the actual query */
+    const double cellx =
+        MS_CELLSIZE(map->extent.minx, map->extent.maxx,
+                    map->width); /* note: don't adjust extent, WMS assumes
+                                    incoming extent is correct */
+    const double celly =
+        MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height);
+    point.x = MS_IMAGE2MAP_X(point.x, map->extent.minx, cellx);
+    point.y = MS_IMAGE2MAP_Y(point.y, map->extent.maxy, celly);
+
+    /* WMS 1.3.0 states that feature_count is *per layer*.
+     * Its value is a positive integer, if omitted then the default is 1
+     */
+    if (feature_count < 1)
+      feature_count = 1;
+
+    map->query.type = MS_QUERY_BY_POINT;
+    map->query.mode =
+        (feature_count == 1 ? MS_QUERY_SINGLE : MS_QUERY_MULTIPLE);
+    map->query.layer = -1;
+    map->query.point = point;
+    map->query.buffer = 0;
+    map->query.maxresults = feature_count;
+
+    if (msQueryByPoint(map) != MS_SUCCESS)
+      if ((query_status = ms_error->code) != MS_NOTFOUND)
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+  } else { /* use_bbox == MS_TRUE */
+    map->query.type = MS_QUERY_BY_RECT;
+    map->query.mode = MS_QUERY_MULTIPLE;
+    map->query.layer = -1;
+    map->query.rect = map->extent;
+    map->query.buffer = 0;
+    map->query.maxresults = feature_count;
+    if (msQueryByRect(map) != MS_SUCCESS)
+      if ((query_status = ms_error->code) != MS_NOTFOUND)
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+  }
+
+  /*validate the INFO_FORMAT*/
+  valid_format = MS_FALSE;
+  format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                    "getfeatureinfo_formatlist");
+  /*feature_info_mime_type depricated for MapServer 6.0*/
+  if (!format_list)
+    format_list = msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                      "feature_info_mime_type");
+  if (format_list) {
+    /*can not really validate if it is a valid output format
+      since old way of using template with web->header/footer and
+      layer templates need to still be supported.
+      We can only validate if it was part of the format list*/
+    if (strcasestr(format_list, info_format))
+      valid_format = MS_TRUE;
+  }
+  /*check to see if the format passed is text/plain or GML and if is
+    defined in the formatlist. If that is the case, It is a valid format*/
+  if (strcasecmp(info_format, "MIME") == 0 ||
+      strcasecmp(info_format, "text/plain") == 0 ||
+      strncasecmp(info_format, "GML", 3) == 0 ||
+      strcasecmp(info_format, "application/vnd.ogc.gml") == 0)
+    valid_format = MS_TRUE;
+
+  /*last case: if the info_format is not part of the request, it defaults to
+   * MIME*/
+  if (!valid_format && format_found == MS_FALSE)
+    valid_format = MS_TRUE;
+
+  if (!valid_format) {
+    msSetError(MS_WMSERR, "Unsupported INFO_FORMAT value (%s).",
+               "msWMSFeatureInfo()", info_format);
+    if (nVersion >= OWS_1_3_0)
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
+    else
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+  }
+
+  /* Generate response */
+  if (strcasecmp(info_format, "MIME") == 0 ||
+      strcasecmp(info_format, "text/plain") == 0) {
+
+    /* MIME response... we're free to use any valid MIME type */
+    int numresults = 0;
+
+    msIO_setHeader("Content-Type", "text/plain; charset=UTF-8");
+    msIO_sendHeaders();
+    msIO_printf("GetFeatureInfo results:\n");
+
+    numresults = msDumpResult(map, nVersion, wms_exception_format);
+
+    if (numresults == 0)
+      msIO_printf("\n  Search returned no results.\n");
+
+  } else if (strncasecmp(info_format, "GML", 3) ==
+                 0 || /* accept GML.1 or GML */
+             strcasecmp(info_format, "application/vnd.ogc.gml") == 0) {
+
+    if (nVersion <= OWS_1_0_7) /* 1.0.0 to 1.0.7 */
+      msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+    else /* 1.1.0 and later */
+      msIO_setHeader("Content-Type", "application/vnd.ogc.gml; charset=UTF-8");
+    msIO_sendHeaders();
+    msGMLWriteQuery(map, NULL, "MGO"); /* default is stdout */
+
+  } else {
+    mapservObj *msObj;
+
+    char **translated_names, **translated_values;
+    int translated_numentries;
+    msObj = msAllocMapServObj();
+
+    /* Translate some vars from WMS to mapserv */
+    msTranslateWMS2Mapserv((const char **)names, (const char **)values,
+                           numentries, &translated_names, &translated_values,
+                           &translated_numentries);
+
+    msObj->map = map;
+    msFreeCharArray(msObj->request->ParamNames, msObj->request->NumParams);
+    msFreeCharArray(msObj->request->ParamValues, msObj->request->NumParams);
+    msObj->request->ParamNames = translated_names;
+    msObj->request->ParamValues = translated_values;
+    msObj->Mode = QUERY;
+    msObj->request->NumParams = translated_numentries;
+    msObj->mappnt.x = point.x;
+    msObj->mappnt.y = point.y;
+
+    if (query_status == MS_NOTFOUND && msObj->map->web.empty) {
+      if (msReturnURL(msObj, msObj->map->web.empty, BROWSE) != MS_SUCCESS)
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+    } else if (msReturnTemplateQuery(msObj, (char *)info_format, NULL) !=
+               MS_SUCCESS)
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+    /* We don't want to free the map since it */
+    /* belongs to the caller, set it to NULL before freeing the mapservObj */
+    msObj->map = NULL;
+
+    msFreeMapServObj(msObj);
+  }
+
+  return (MS_SUCCESS);
+}
+
+/*
+** msWMSDescribeLayer()
+*/
+static int msWMSDescribeLayer(mapObj *map, int nVersion, char **names,
+                              char **values, int numentries,
+                              const char *wms_exception_format) {
+  std::vector<std::string> wmslayers;
+  const char *version = NULL;
+  const char *sld_version = NULL;
+
+  for (int i = 0; i < numentries; i++) {
+    if (strcasecmp(names[i], "LAYERS") == 0) {
+      wmslayers = msStringSplit(values[i], ',');
+    }
+    if (strcasecmp(names[i], "VERSION") == 0) {
+      version = values[i];
+    }
+    if (strcasecmp(names[i], "SLD_VERSION") == 0) {
+      sld_version = values[i];
+    }
+  }
+
+  if (nVersion >= OWS_1_3_0 && sld_version == NULL) {
+    msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION",
+               "DescribeLayer()");
+    return msWMSException(map, nVersion, "MissingParameterValue",
+                          wms_exception_format);
+  }
+  if (nVersion >= OWS_1_3_0 && strcasecmp(sld_version, "1.1.0") != 0) {
+    msSetError(MS_WMSERR, "SLD_VERSION must be 1.1.0", "DescribeLayer()");
+    return msWMSException(map, nVersion, "InvalidParameterValue",
+                          wms_exception_format);
+  }
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\"?>\n");
+
+  {
+    char *schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    if (nVersion < OWS_1_3_0) {
+
+      msIO_printf("<!DOCTYPE WMS_DescribeLayerResponse SYSTEM "
+                  "\"%s/wms/1.1.1/WMS_DescribeLayerResponse.dtd\">\n",
+                  schemalocation);
+
+      msIO_printf("<WMS_DescribeLayerResponse version=\"%s\" >\n", version);
+    } else {
+      msIO_printf("<DescribeLayerResponse xmlns=\"http://www.opengis.net/sld\" "
+                  "xmlns:ows=\"http://www.opengis.net/ows\" "
+                  "xmlns:se=\"http://www.opengis.net/se\" "
+                  "xmlns:wfs=\"http://www.opengis.net/wfs\" "
+                  "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+                  "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                  "xsi:schemaLocation=\"http://www.opengis.net/sld "
+                  "%s/sld/1.1.0/DescribeLayer.xsd\">\n",
+                  schemalocation);
+      msIO_printf("<Version>%s</Version>\n", sld_version);
+    }
+    free(schemalocation);
+  }
+
+  /* check if map-level metadata wfs(wcs)_onlineresource is available */
+  const char *pszOnlineResMapWFS =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "onlineresource");
+  if (pszOnlineResMapWFS && strlen(pszOnlineResMapWFS) == 0)
+    pszOnlineResMapWFS = NULL;
+
+  const char *pszOnlineResMapWCS =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "onlineresource");
+  if (pszOnlineResMapWCS && strlen(pszOnlineResMapWCS) == 0)
+    pszOnlineResMapWCS = NULL;
+
+  char ***nestedGroups =
+      (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+  int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  int *isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                           isUsedInNestedGroup);
+
+  for (const auto &wmslayer : wmslayers) {
+    for (int k = 0; k < map->numlayers; k++) {
+      layerObj *lp = GET_LAYER(map, k);
+
+      if ((map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
+          (lp->name && strcasecmp(lp->name, wmslayer.c_str()) == 0) ||
+          (lp->group && strcasecmp(lp->group, wmslayer.c_str()) == 0) ||
+          ((numNestedGroups[k] > 0) &&
+           msStringInArray(wmslayer.c_str(), nestedGroups[k],
+                           numNestedGroups[k]))) {
+        /* Look for a WFS onlineresouce at the layer level and then at
+         * the map level.
+         */
+        const char *pszOnlineResLyrWFS =
+            msOWSLookupMetadata(&(lp->metadata), "FO", "onlineresource");
+        const char *pszOnlineResLyrWCS =
+            msOWSLookupMetadata(&(lp->metadata), "CO", "onlineresource");
+        if (pszOnlineResLyrWFS == NULL || strlen(pszOnlineResLyrWFS) == 0)
+          pszOnlineResLyrWFS = pszOnlineResMapWFS;
+
+        if (pszOnlineResLyrWCS == NULL || strlen(pszOnlineResLyrWCS) == 0)
+          pszOnlineResLyrWCS = pszOnlineResMapWCS;
+
+        if (pszOnlineResLyrWFS &&
+            (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE ||
+             lp->type == MS_LAYER_POLYGON)) {
+          char *pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWFS);
+          char *pszLayerName = msEncodeHTMLEntities(lp->name);
+
+          if (nVersion < OWS_1_3_0) {
+            msIO_printf("<LayerDescription name=\"%s\" wfs=\"%s\" "
+                        "owsType=\"WFS\" owsURL=\"%s\">\n",
+                        pszLayerName, pszOnlineResEncoded, pszOnlineResEncoded);
+            msIO_printf("<Query typeName=\"%s\" />\n", pszLayerName);
+            msIO_printf("</LayerDescription>\n");
+          } else { /*wms 1.3.0*/
+            msIO_printf("  <LayerDescription>\n");
+            msIO_printf("    <owsType>wfs</owsType>\n");
+            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" "
+                        "xlink:href=\"%s\"/>\n",
+                        pszOnlineResEncoded);
+            msIO_printf("    <TypeName>\n");
+            msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",
+                        pszLayerName);
+            msIO_printf("    </TypeName>\n");
+            msIO_printf("  </LayerDescription>\n");
+          }
+
+          msFree(pszOnlineResEncoded);
+          msFree(pszLayerName);
+        } else if (pszOnlineResLyrWCS && lp->type == MS_LAYER_RASTER &&
+                   lp->connectiontype != MS_WMS) {
+          char *pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWCS);
+          char *pszLayerName = msEncodeHTMLEntities(lp->name);
+
+          if (nVersion < OWS_1_3_0) {
+            msIO_printf("<LayerDescription name=\"%s\"  owsType=\"WCS\" "
+                        "owsURL=\"%s\">\n",
+                        pszLayerName, pszOnlineResEncoded);
+            msIO_printf("<Query typeName=\"%s\" />\n", pszLayerName);
+            msIO_printf("</LayerDescription>\n");
+          } else {
+            msIO_printf("  <LayerDescription>\n");
+            msIO_printf("    <owsType>wcs</owsType>\n");
+            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" "
+                        "xlink:href=\"%s\"/>\n",
+                        pszOnlineResEncoded);
+            msIO_printf("    <TypeName>\n");
+            msIO_printf("      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",
+                        pszLayerName);
+            msIO_printf("    </TypeName>\n");
+            msIO_printf("  </LayerDescription>\n");
+          }
+          msFree(pszOnlineResEncoded);
+          msFree(pszLayerName);
+        } else {
+          char *pszLayerName = msEncodeHTMLEntities(lp->name);
+
+          if (nVersion < OWS_1_3_0)
+            msIO_printf("<LayerDescription name=\"%s\"></LayerDescription>\n",
+                        pszLayerName);
+          else { /*wms 1.3.0*/
+            msIO_printf("  <LayerDescription>\n");
+            /*need to have a owstype for the DescribeLayer to be valid*/
+            if (lp->type == MS_LAYER_RASTER && lp->connectiontype != MS_WMS)
+              msIO_printf("    <owsType>wcs</owsType>\n");
+            else
+              msIO_printf("    <owsType>wfs</owsType>\n");
+
+            msIO_printf("    <se:OnlineResource xlink:type=\"simple\"/>\n");
+            msIO_printf("    <TypeName>\n");
+            if (lp->type == MS_LAYER_RASTER && lp->connectiontype != MS_WMS)
+              msIO_printf(
+                  "      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",
+                  pszLayerName);
+            else
+              msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",
+                          pszLayerName);
+            msIO_printf("    </TypeName>\n");
+            msIO_printf("  </LayerDescription>\n");
+          }
+
+          msFree(pszLayerName);
+        }
+        /* break; */
+      }
+    }
+  }
+
+  if (nVersion < OWS_1_3_0)
+    msIO_printf("</WMS_DescribeLayerResponse>\n");
+  else
+    msIO_printf("</DescribeLayerResponse>\n");
+
+  /* free the stuff used for nested layers */
+  for (int i = 0; i < map->numlayers; i++) {
+    if (numNestedGroups[i] > 0) {
+      msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
+    }
+  }
+  free(nestedGroups);
+  free(numNestedGroups);
+  free(isUsedInNestedGroup);
+
+  return (MS_SUCCESS);
+}
+
+/*
+** msWMSGetLegendGraphic()
+*/
+static int msWMSLegendGraphic(mapObj *map, int nVersion, char **names,
+                              char **values, int numentries,
+                              const char *wms_exception_format,
+                              owsRequestObj *ows_request,
+                              map_hittest *hittest) {
+  const char *pszLayer = NULL;
+  const char *pszFormat = NULL;
+  const char *psRule = NULL;
+  const char *psScale = NULL;
+  int iLayerIndex = -1;
+  outputFormatObj *psFormat = NULL;
+  imageObj *img = NULL;
+  int nWidth = -1, nHeight = -1;
+  const char *pszStyle = NULL;
+  const char *sld_version = NULL;
+  int wms_layer = MS_FALSE;
+  const char *sldenabled = NULL;
+  const char *format_list = NULL;
+  int nLayers = 0;
+
+  if (!hittest) {
+    /* we can skip alot of testing if we already have a hittest, as it has
+     * already been done in the hittesting phase */
+
+    sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
+
+    if (sldenabled == NULL)
+      sldenabled = "true";
+
+    for (int i = 0; i < numentries; i++) {
+      if (strcasecmp(names[i], "LAYER") == 0) {
+        pszLayer = values[i];
+      } else if (strcasecmp(names[i], "WIDTH") == 0)
+        nWidth = atoi(values[i]);
+      else if (strcasecmp(names[i], "HEIGHT") == 0)
+        nHeight = atoi(values[i]);
+      else if (strcasecmp(names[i], "FORMAT") == 0)
+        pszFormat = values[i];
+      else if (strcasecmp(names[i], "SCALE") == 0)
+        psScale = values[i];
+
+      /* -------------------------------------------------------------------- */
+      /*      SLD support :                                                   */
+      /*        - check if the SLD parameter is there. it is supposed to      */
+      /*      refer a valid URL containing an SLD document.                   */
+      /*        - check the SLD_BODY parameter that should contain the SLD    */
+      /*      xml string.                                                     */
+      /* -------------------------------------------------------------------- */
+      else if (strcasecmp(names[i], "SLD") == 0 && values[i] &&
+               strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
+        msSLDApplySLDURL(map, values[i], -1, NULL, NULL);
+      else if (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] &&
+               strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
+        msSLDApplySLD(map, values[i], -1, NULL, NULL);
+      else if (strcasecmp(names[i], "RULE") == 0)
+        psRule = values[i];
+      else if (strcasecmp(names[i], "STYLE") == 0)
+        pszStyle = values[i];
+
+      /* -------------------------------------------------------------------- */
+      /*      SLD support:                                                    */
+      /*        - because the request parameter "sld_version" is required in  */
+      /*          in WMS 1.3.0, it will be set regardless of OGR support.     */
+      /* -------------------------------------------------------------------- */
+      else if (strcasecmp(names[i], "SLD_VERSION") == 0)
+        sld_version = values[i];
+    }
+
+    if (!pszLayer) {
+      msSetError(
+          MS_WMSERR,
+          "Mandatory LAYER parameter missing in GetLegendGraphic request.",
+          "msWMSGetLegendGraphic()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
+    }
+    if (!pszFormat) {
+      msSetError(
+          MS_WMSERR,
+          "Mandatory FORMAT parameter missing in GetLegendGraphic request.",
+          "msWMSGetLegendGraphic()");
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
+    }
+
+    if (nVersion >= OWS_1_3_0 && sld_version == NULL) {
+      msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION",
+                 "GetLegendGraphic()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
+    }
+    if (nVersion >= OWS_1_3_0 && strcasecmp(sld_version, "1.1.0") != 0) {
+      msSetError(MS_WMSERR, "SLD_VERSION must be 1.1.0", "GetLegendGraphic()");
+      return msWMSException(map, nVersion, "InvalidParameterValue",
+                            wms_exception_format);
+    }
+
+    char ***nestedGroups =
+        (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+    int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+    int *isUsedInNestedGroup =
+        (int *)msSmallCalloc(map->numlayers, sizeof(int));
+    msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                             isUsedInNestedGroup);
+
+    /* check if layer name is valid. we check for layer's and group's name */
+    /* as well as wms_layer_group names */
+    for (int i = 0; i < map->numlayers; i++) {
+      layerObj *lp = GET_LAYER(map, i);
+      if (((map->name && strcasecmp(map->name, pszLayer) == 0) ||
+           (lp->name && strcasecmp(lp->name, pszLayer) == 0) ||
+           (lp->group && strcasecmp(lp->group, pszLayer) == 0) ||
+           ((numNestedGroups[i] > 0) &&
+            (msStringInArray(pszLayer, nestedGroups[i],
+                             numNestedGroups[i])))) &&
+          (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                            ows_request->numlayers))) {
+        nLayers++;
+        lp->status = MS_ON;
+        iLayerIndex = i;
+        if (GET_LAYER(map, i)->connectiontype == MS_WMS) {
+          /* we do not cascade a wms layer if it contains at least
+           * one class with the property name set */
+          wms_layer = MS_TRUE;
+          for (int j = 0; j < lp->numclasses; j++) {
+            if (lp->_class[j]->name != NULL &&
+                strlen(lp->_class[j]->name) > 0) {
+              wms_layer = MS_FALSE;
+              break;
+            }
+          }
+        }
+      } else
+        lp->status = MS_OFF;
+    }
+
+    /* free the stuff used for nested layers */
+    for (int i = 0; i < map->numlayers; i++) {
+      if (numNestedGroups[i] > 0) {
+        msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
+      }
+    }
+    free(nestedGroups);
+    free(numNestedGroups);
+    free(isUsedInNestedGroup);
+
+    if (nLayers == 0) {
+      msSetError(
+          MS_WMSERR,
+          "Invalid layer given in the LAYER parameter. A layer might be disabled for \
+this request. Check wms/ows_enable_request settings.",
+          "msWMSGetLegendGraphic()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
+    }
+
+    /* if SCALE was provided in request, calculate an extent and use a default
+     * width and height */
+    if (psScale != NULL) {
+      double scale, cellsize;
+
+      scale = atof(psScale);
+      map->width = 600;
+      map->height = 600;
+
+      cellsize = (scale / map->resolution) / msInchesPerUnit(map->units, 0.0);
+
+      map->extent.maxx = cellsize * map->width / 2.0;
+      map->extent.maxy = cellsize * map->height / 2.0;
+      map->extent.minx = -map->extent.maxx;
+      map->extent.miny = -map->extent.maxy;
+    }
+
+    /* It's a valid Cascading WMS GetLegendGraphic request */
+    if (wms_layer)
+      return msWMSLayerExecuteRequest(map, 1, 0, 0, 0, NULL,
+                                      WMS_GETLEGENDGRAPHIC);
+
+    /*if STYLE is set, check if it is a valid style (valid = at least one
+    of the classes have a the group value equals to the style */
+    /*style is only validated when there is only one layer #3411*/
+    if (nLayers == 1 && pszStyle && strlen(pszStyle) > 0 &&
+        strcasecmp(pszStyle, "default") != 0) {
+      bool found = false;
+      for (int i = 0; i < GET_LAYER(map, iLayerIndex)->numclasses; i++) {
+        if (GET_LAYER(map, iLayerIndex)->_class[i]->group &&
+            strcasecmp(GET_LAYER(map, iLayerIndex)->_class[i]->group,
+                       pszStyle) == 0) {
+          found = true;
+          break;
+        }
+      }
+
+      if (!found) {
+        msSetError(
+            MS_WMSERR,
+            "style used in the STYLE parameter is not defined on the layer.",
+            "msWMSGetLegendGraphic()");
+        return msWMSException(map, nVersion, "StyleNotDefined",
+                              wms_exception_format);
+      } else {
+        msFree(GET_LAYER(map, iLayerIndex)->classgroup);
+        GET_LAYER(map, iLayerIndex)->classgroup = msStrdup(pszStyle);
+      }
+    }
+  } else {
+    /* extract the parameters we need */
+    for (int i = 0; i < numentries; i++) {
+      if (strcasecmp(names[i], "FORMAT") == 0)
+        pszFormat = values[i];
+      else if (strcasecmp(names[i], "RULE") == 0)
+        psRule = values[i];
+    }
+  }
+  /* validate format */
+
+  /*check to see if a predefined list is given*/
+  format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                    "getlegendgraphic_formatlist");
+  if (format_list) {
+    psFormat = msOwsIsOutputFormatValid(map, pszFormat, &(map->web.metadata),
+                                        "M", "getlegendgraphic_formatlist");
+    if (psFormat == NULL) {
+      msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                 "msWMSGetLegendGraphic()", pszFormat);
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
+    }
+  } else {
+    psFormat = msSelectOutputFormat(map, pszFormat);
+    if (psFormat == NULL || !MS_RENDERER_PLUGIN(psFormat))
+    /* msDrawLegend and msCreateLegendIcon both switch the alpha channel to gd
+     ** after creation, so they can be called here without going through
+     ** the msAlphaGD2AGG functions */
+    {
+      msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                 "msWMSGetLegendGraphic()", pszFormat);
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
+    }
+  }
+  msApplyOutputFormat(&(map->outputformat), psFormat, MS_NOOVERRIDE);
+
+  if (psRule == NULL || nLayers > 1) {
+    if (psScale != NULL) {
+      /* Scale-dependent legend. map->scaledenom will be calculated in
+       * msDrawLegend */
+      img = msDrawLegend(map, MS_FALSE, NULL);
+    } else {
+      /* Scale-independent legend */
+      img = msDrawLegend(map, MS_TRUE, hittest);
+    }
+  } else {
+    /* RULE was specified. Get the class corresponding to the RULE */
+    /* (RULE = class->name) */
+    /* TBT FIXME? also check the map->scaledenom if multiple scale-dependant
+     * classes with same name */
+
+    layerObj *lp = GET_LAYER(map, iLayerIndex);
+    int i;
+    for (i = 0; i < lp->numclasses; i++) {
+      if (lp->classgroup &&
+          (lp->_class[i]->group == NULL ||
+           strcasecmp(lp->_class[i]->group, lp->classgroup) != 0))
+        continue;
+
+      if (lp->_class[i]->name && strlen(lp->_class[i]->name) > 0 &&
+          strcasecmp(lp->_class[i]->name, psRule) == 0)
+        break;
+    }
+    if (i < lp->numclasses) {
+      /* set the map legend parameters */
+      if (nWidth < 0) {
+        if (map->legend.keysizex > 0)
+          nWidth = map->legend.keysizex;
+        else
+          nWidth = 20; /* default values : this in not defined in the specs */
+      }
+      if (nHeight < 0) {
+        if (map->legend.keysizey > 0)
+          nHeight = map->legend.keysizey;
+        else
+          nHeight = 20;
+      }
+
+      if (psScale != NULL) {
+        /* Scale-dependent legend. calculate map->scaledenom */
+        map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+        msCalculateScale(map->extent, map->units, map->width, map->height,
+                         map->resolution, &map->scaledenom);
+        img = msCreateLegendIcon(map, lp, lp->_class[i], nWidth, nHeight,
+                                 MS_FALSE);
+      } else {
+        /* Scale-independent legend */
+        img = msCreateLegendIcon(map, lp, lp->_class[i], nWidth, nHeight,
+                                 MS_TRUE);
+      }
+    }
+    if (img == NULL) {
+      msSetError(MS_IMGERR, "Unavailable RULE (%s).", "msWMSGetLegendGraphic()",
+                 psRule);
+      return msWMSException(map, nVersion, "InvalidRule", wms_exception_format);
+    }
+  }
+
+  if (img == NULL)
+    return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+  msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(map->outputformat));
+  msIO_sendHeaders();
+  if (msSaveImage(map, img, NULL) != MS_SUCCESS)
+    return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+  msFreeImage(img);
+
+  return (MS_SUCCESS);
+}
+
+/*
+** msWMSGetContentDependantLegend()
+*/
+static int msWMSGetContentDependantLegend(mapObj *map, int nVersion,
+                                          char **names, char **values,
+                                          int numentries,
+                                          const char *wms_exception_format,
+                                          owsRequestObj *ows_request) {
+
+  /* turn off layer if WMS GetMap is not enabled */
+  for (int i = 0; i < map->numlayers; i++)
+    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
+      GET_LAYER(map, i)->status = MS_OFF;
+
+  map_hittest hittest;
+  initMapHitTests(map, &hittest);
+  int status = msHitTestMap(map, &hittest);
+  if (status == MS_SUCCESS) {
+    status = msWMSLegendGraphic(map, nVersion, names, values, numentries,
+                                wms_exception_format, ows_request, &hittest);
+  }
+  freeMapHitTests(map, &hittest);
+  if (status != MS_SUCCESS) {
+    return msWMSException(map, nVersion, NULL, wms_exception_format);
+  } else {
+    return MS_SUCCESS;
+  }
+}
+
+/*
+** msWMSGetStyles() : return an SLD document for all layers that
+** have a status set to on or default.
+*/
+static int msWMSGetStyles(mapObj *map, int nVersion, char **names,
+                          char **values, int numentries,
+                          const char *wms_exception_format)
+
+{
+  bool validlayer = false;
+
+  char ***nestedGroups =
+      (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+  int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  int *isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                           isUsedInNestedGroup);
+
+  const char *sldenabled =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
+  if (sldenabled == NULL)
+    sldenabled = "true";
+
+  for (int i = 0; i < numentries; i++) {
+    /* getMap parameters */
+    if (strcasecmp(names[i], "LAYERS") == 0) {
+      const auto wmslayers = msStringSplit(values[i], ',');
+      if (wmslayers.empty()) {
+        msSetError(MS_WMSERR, "At least one layer name required in LAYERS.",
+                   "msWMSGetStyles()");
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
+      }
+      for (int j = 0; j < map->numlayers; j++)
+        GET_LAYER(map, j)->status = MS_OFF;
+
+      for (int k = 0; k < static_cast<int>(wmslayers.size()); k++) {
+        const auto &wmslayer = wmslayers[k];
+        for (int j = 0; j < map->numlayers; j++) {
+          if ((map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
+              (GET_LAYER(map, j)->name &&
+               strcasecmp(GET_LAYER(map, j)->name, wmslayer.c_str()) == 0) ||
+              (GET_LAYER(map, j)->group &&
+               strcasecmp(GET_LAYER(map, j)->group, wmslayer.c_str()) == 0) ||
+              ((numNestedGroups[j] > 0) &&
+               msStringInArray(wmslayer.c_str(), nestedGroups[j],
+                               numNestedGroups[j]))) {
+            GET_LAYER(map, j)->status = MS_ON;
+            validlayer = true;
+          }
+        }
+      }
+    }
+
+    else if (strcasecmp(names[i], "SLD") == 0 && values[i] &&
+             strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0) {
+      msSLDApplySLDURL(map, values[i], -1, NULL, NULL);
+    }
+
+    else if (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] &&
+             strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0) {
+      msSLDApplySLD(map, values[i], -1, NULL, NULL);
+    }
+  }
+
+  /* free the stuff used for nested layers */
+  for (int i = 0; i < map->numlayers; i++) {
+    if (numNestedGroups[i] > 0) {
+      msFreeCharArray(nestedGroups[i], numNestedGroups[i]);
+    }
+  }
+  free(nestedGroups);
+  free(numNestedGroups);
+  free(isUsedInNestedGroup);
+
+  /* validate all layers given. If an invalid layer is sent, return an
+   * exception. */
+  if (!validlayer) {
+    msSetError(
+        MS_WMSERR,
+        "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
+this request. Check wms/ows_enable_request settings.",
+        "msWMSGetStyles()");
+    return msWMSException(map, nVersion, "LayerNotDefined",
+                          wms_exception_format);
+  }
+
+  char *sld = NULL;
+  if (nVersion <= OWS_1_1_1) {
+    msIO_setHeader("Content-Type",
+                   "application/vnd.ogc.sld+xml; charset=UTF-8");
+    msIO_sendHeaders();
+    sld = msSLDGenerateSLD(map, -1, "1.0.0");
+  } else {
+    /*for wms 1.3.0 generate a 1.1 sld*/
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+    msIO_sendHeaders();
+    sld = msSLDGenerateSLD(map, -1, "1.1.0");
+  }
+  if (sld) {
+    msIO_printf("%s\n", sld);
+    free(sld);
+  }
+
+  return (MS_SUCCESS);
+}
+
+int msWMSGetSchemaExtension(mapObj *map) {
+  char *schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+  msIO_sendHeaders();
+
+  msIO_printf("<?xml version='1.0' encoding=\"UTF-8\"?>\n");
+  msIO_printf("<schema xmlns=\"http://www.w3.org/2001/XMLSchema\" "
+              "xmlns:wms=\"http://www.opengis.net/wms\" "
+              "xmlns:ms=\"http://mapserver.gis.umn.edu/mapserver\" "
+              "targetNamespace=\"http://mapserver.gis.umn.edu/mapserver\" "
+              "elementFormDefault=\"qualified\" version=\"1.0.0\">\n");
+  msIO_printf("  <import namespace=\"http://www.opengis.net/wms\" "
+              "schemaLocation=\"%s/wms/1.3.0/capabilities_1_3_0.xsd\"/>\n",
+              schemalocation);
+  msIO_printf("  <element name=\"GetStyles\" type=\"wms:OperationType\" "
+              "substitutionGroup=\"wms:_ExtendedOperation\"/>\n");
+  msIO_printf("</schema>");
+
+  free(schemalocation);
+
+  return (MS_SUCCESS);
+}
+
+#endif /* USE_WMS_SVR */
+
+/*
+** msWMSDispatch() is the entry point for WMS requests.
+** - If this is a valid request then it is processed and MS_SUCCESS is returned
+**   on success, or MS_FAILURE on failure.
+** - If this does not appear to be a valid WMS request then MS_DONE
+**   is returned and MapServer is expected to process this as a regular
+**   MapServer request.
+*/
+int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request,
+                  int force_wms_mode) {
+#ifdef USE_WMS_SVR
+  int nVersion = OWS_VERSION_NOTSET;
+  const char *version = NULL, *request = NULL, *service = NULL, *format = NULL,
+             *updatesequence = NULL, *language = NULL;
+  const char *wms_exception_format = NULL;
+
+  /*
+  ** Process Params common to all requests
+  */
+  /* VERSION (WMTVER in 1.0.0) and REQUEST must be present in a valid request */
+  for (int i = 0; i < req->NumParams; i++) {
+    if (strcasecmp(req->ParamNames[i], "VERSION") == 0)
+      version = req->ParamValues[i];
+    else if (strcasecmp(req->ParamNames[i], "WMTVER") == 0 && version == NULL)
+      version = req->ParamValues[i];
+    else if (strcasecmp(req->ParamNames[i], "UPDATESEQUENCE") == 0)
+      updatesequence = req->ParamValues[i];
+    else if (strcasecmp(req->ParamNames[i], "REQUEST") == 0)
+      request = req->ParamValues[i];
+    else if (strcasecmp(req->ParamNames[i], "EXCEPTIONS") == 0)
+      wms_exception_format = req->ParamValues[i];
+    else if (strcasecmp(req->ParamNames[i], "SERVICE") == 0)
+      service = req->ParamValues[i];
+    else if (strcasecmp(req->ParamNames[i], "FORMAT") == 0)
+      format = req->ParamValues[i];
+    else if (strcasecmp(req->ParamNames[i], "LANGUAGE") == 0 &&
+             msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                 "inspire_capabilities"))
+      language = req->ParamValues[i];
+  }
+
+  /* If SERVICE is specified then it MUST be "WMS" */
+  if (service != NULL && strcasecmp(service, "WMS") != 0)
+    return MS_DONE; /* Not a WMS request */
+
+  nVersion = msOWSParseVersionString(version);
+  if (nVersion == OWS_VERSION_BADFORMAT) {
+    /* Invalid version format. msSetError() has been called by
+     * msOWSParseVersionString() and we return the error as an exception
+     */
+    return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
+  }
+
+  /*
+  ** GetCapbilities request needs the service parametr defined as WMS:
+  see section 7.1.3.2 wms 1.1.1 specs for decsription.
+  */
+  if (request && service == NULL &&
+      (strcasecmp(request, "capabilities") == 0 ||
+       strcasecmp(request, "GetCapabilities") == 0) &&
+      (nVersion >= OWS_1_0_7 || nVersion == OWS_VERSION_NOTSET)) {
+    if (force_wms_mode) {
+      msSetError(MS_WMSERR, "Required SERVICE parameter missing.",
+                 "msWMSDispatch");
+      return msWMSException(map, nVersion, "ServiceNotDefined",
+                            wms_exception_format);
+    } else
+      return MS_DONE;
+  }
+
+  /*
+  ** Dispatch request... we should probably do some validation on VERSION here
+  ** vs the versions we actually support.
+  */
+  if (request && (strcasecmp(request, "capabilities") == 0 ||
+                  strcasecmp(request, "GetCapabilities") == 0)) {
+    const char *enable_request;
+    int globally_enabled, disabled = MS_FALSE;
+
+    if (nVersion == OWS_VERSION_NOTSET) {
+      version = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                    "getcapabilities_version");
+      if (version)
+        nVersion = msOWSParseVersionString(version);
+      else
+        nVersion =
+            OWS_1_3_0; /* VERSION is optional with getCapabilities only */
+    }
+
+    if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+    msOWSRequestLayersEnabled(map, "M", "GetCapabilities", ows_request);
+
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, "OM", "enable_request");
+    globally_enabled =
+        msOWSParseRequestMetadata(enable_request, "GetCapabilities", &disabled);
+
+    if (ows_request->numlayers == 0 && !globally_enabled) {
+      msSetError(
+          MS_WMSERR,
+          "WMS request not enabled. Check wms/ows_enable_request settings.",
+          "msWMSGetCapabilities()");
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+    msAcquireLock(TLOCK_WxS);
+    const int status =
+        msWMSGetCapabilities(map, nVersion, req, ows_request, updatesequence,
+                             wms_exception_format, language);
+    msReleaseLock(TLOCK_WxS);
+    return status;
+  } else if (request && (strcasecmp(request, "context") == 0 ||
+                         strcasecmp(request, "GetContext") == 0)) {
+    /* Return a context document with all layers in this mapfile
+     * This is not a standard WMS request.
+     * __TODO__ The real implementation should actually return only context
+     * info for selected layers in the LAYERS parameter.
+     */
+    const char *getcontext_enabled;
+    getcontext_enabled =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "getcontext_enabled");
+
+    if (nVersion != OWS_VERSION_NOTSET) {
+      /* VERSION, if specified, is Map Context version, not WMS version */
+      /* Pass it via wms_context_version metadata */
+      char szVersion[OWS_VERSION_MAXLEN];
+      msInsertHashTable(&(map->web.metadata), "wms_context_version",
+                        msOWSGetVersionString(nVersion, szVersion));
+    }
+    /* Now set version to 1.1.1 for error handling purposes */
+    nVersion = OWS_1_1_1;
+
+    if (getcontext_enabled == NULL || atoi(getcontext_enabled) == 0) {
+      msSetError(MS_WMSERR, "GetContext not enabled on this server.",
+                 "msWMSDispatch()");
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+
+    if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
+    msIO_sendHeaders();
+
+    if (msWriteMapContext(map, stdout) != MS_SUCCESS)
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    /* Request completed */
+    return MS_SUCCESS;
+  } else if (request && strcasecmp(request, "GetMap") == 0 && format &&
+             strcasecmp(format, "image/txt") == 0) {
+    /* Until someone adds full support for ASCII graphics this should do. ;) */
+    msIO_setHeader("Content-Type", "text/plain; charset=UTF-8");
+    msIO_sendHeaders();
+    msIO_printf(".\n               ,,ggddY\"\"\"Ybbgg,,\n          ,agd888b,_ "
+                "\"Y8, ___'\"\"Ybga,\n       ,gdP\"\"88888888baa,.\"\"8b    \""
+                "888g,\n     ,dP\"     ]888888888P'  \"Y     '888Yb,\n   ,dP\""
+                "      ,88888888P\"  db,       \"8P\"\"Yb,\n  ,8\"       ,8888"
+                "88888b, d8888a           \"8,\n ,8'        d88888888888,88P\""
+                "' a,          '8,\n,8'         88888888888888PP\"  \"\"      "
+                "     '8,\nd'          I88888888888P\"                   'b\n8"
+                "           '8\"88P\"\"Y8P'                      8\n8         "
+                "   Y 8[  _ \"                        8\n8              \"Y8d8"
+                "b  \"Y a                   8\n8                 '\"\"8d,   __"
+                "                 8\nY,                    '\"8bd888b,        "
+                "     ,P\n'8,                     ,d8888888baaa       ,8'\n '8"
+                ",                    888888888888'      ,8'\n  '8a           "
+                "        \"8888888888I      a8'\n   'Yba                  'Y88"
+                "88888P'    adP'\n     \"Yba                 '888888P'   adY\""
+                "\n       '\"Yba,             d8888P\" ,adP\"' \n          '\""
+                "Y8baa,      ,d888P,ad8P\"' \n               ''\"\"YYba8888P\""
+                "\"''\n");
+    return MS_SUCCESS;
+  }
+
+  /* If SERVICE, VERSION and REQUEST not included than this isn't a WMS req*/
+  if (service == NULL && nVersion == OWS_VERSION_NOTSET && request == NULL)
+    return MS_DONE; /* Not a WMS request */
+
+  /* VERSION *and* REQUEST required by both getMap and getFeatureInfo */
+  if (nVersion == OWS_VERSION_NOTSET) {
+    msSetError(MS_WMSERR, "Incomplete WMS request: VERSION parameter missing",
+               "msWMSDispatch()");
+    return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
+  }
+
+  /*check if the version is one of the supported vcersions*/
+  if (nVersion != OWS_1_0_0 && nVersion != OWS_1_0_6 && nVersion != OWS_1_0_7 &&
+      nVersion != OWS_1_1_0 && nVersion != OWS_1_1_1 && nVersion != OWS_1_3_0) {
+    msSetError(MS_WMSERR,
+               "Invalid WMS version: VERSION %s is not supported. Supported "
+               "versions are 1.0.0, 1.0.6, 1.0.7, 1.1.0, 1.1.1, 1.3.0",
+               "msWMSDispatch()", version);
+    return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
+  }
+
+  if (request == NULL) {
+    msSetError(MS_WMSERR, "Incomplete WMS request: REQUEST parameter missing",
+               "msWMSDispatch()");
+    return msWMSException(map, nVersion, NULL, wms_exception_format);
+  }
+
+  /* hack !? The function can return MS_DONE ... be sure it's a wms request
+   * before checking the enabled layers */
+  if ((strcasecmp(request, "GetStyles") == 0) ||
+      (strcasecmp(request, "GetLegendGraphic") == 0) ||
+      (strcasecmp(request, "GetSchemaExtension") == 0) ||
+      (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0) ||
+      (strcasecmp(request, "feature_info") == 0 ||
+       strcasecmp(request, "GetFeatureInfo") == 0) ||
+      (strcasecmp(request, "DescribeLayer") == 0)) {
+    const char *request_tmp;
+    if (strcasecmp(request, "map") == 0)
+      request_tmp = "GetMap";
+    else if (strcasecmp(request, "feature_info") == 0)
+      request_tmp = "GetFeatureInfo";
+    else
+      request_tmp = request;
+
+    msOWSRequestLayersEnabled(map, "M", request_tmp, ows_request);
+    if (ows_request->numlayers == 0) {
+      msSetError(
+          MS_WMSERR,
+          "WMS request not enabled. Check wms/ows_enable_request settings.",
+          "msWMSDispatch()");
+      return msWMSException(map, nVersion, NULL, wms_exception_format);
+    }
+  }
+
+  if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
+    return msWMSException(map, nVersion, NULL, wms_exception_format);
+
+  bool isContentDependantLegend = false;
+  if (strcasecmp(request, "GetLegendGraphic") == 0) {
+    /*
+     * check for a BBOX in the request, in that case we have a content-dependant
+     * legend request, and should be following the GetMap path a bit more
+     */
+    bool found = false;
+    for (int i = 0; i < req->NumParams; i++) {
+      if (strcasecmp(req->ParamNames[i], "BBOX") == 0) {
+        if (req->ParamValues[i] && *req->ParamValues[i]) {
+          found = true;
+          break;
+        }
+      }
+    }
+    if (found) {
+      isContentDependantLegend = true;
+      /* getLegendGraphic uses LAYER= , we need to create a LAYERS= value that
+       * is identical we'll suppose that the client is conformat and hasn't
+       * included a LAYERS= parameter in its request */
+      for (int i = 0; i < req->NumParams; i++) {
+        if (strcasecmp(req->ParamNames[i], "LAYER") == 0) {
+          req->ParamNames[req->NumParams] = msStrdup("LAYERS");
+          req->ParamValues[req->NumParams] = msStrdup(req->ParamValues[i]);
+          req->NumParams++;
+        }
+      }
+    } else {
+      return msWMSLegendGraphic(map, nVersion, req->ParamNames,
+                                req->ParamValues, req->NumParams,
+                                wms_exception_format, ows_request, NULL);
+    }
+  }
+
+  if (strcasecmp(request, "GetStyles") == 0)
+    return msWMSGetStyles(map, nVersion, req->ParamNames, req->ParamValues,
+                          req->NumParams, wms_exception_format);
+
+  else if (request && strcasecmp(request, "GetSchemaExtension") == 0)
+    return msWMSGetSchemaExtension(map);
+
+  /* getMap parameters are used by both getMap, getFeatureInfo, and content
+   * dependant legendgraphics */
+  if (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0 ||
+      strcasecmp(request, "feature_info") == 0 ||
+      strcasecmp(request, "GetFeatureInfo") == 0 ||
+      strcasecmp(request, "DescribeLayer") == 0 || isContentDependantLegend) {
+
+    const int status = msWMSLoadGetMapParams(
+        map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
+        wms_exception_format, request, ows_request);
+    if (status != MS_SUCCESS)
+      return status;
+  }
+
+  /* This function owns validated_language, so remember to free it later*/
+  char *validated_language = msOWSGetLanguageFromList(map, "MO", language);
+  if (validated_language != NULL) {
+    msMapSetLanguageSpecificConnection(map, validated_language);
+  }
+  msFree(validated_language);
+
+  if (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0)
+    return msWMSGetMap(map, nVersion, req->ParamNames, req->ParamValues,
+                       req->NumParams, wms_exception_format, ows_request);
+  else if (strcasecmp(request, "feature_info") == 0 ||
+           strcasecmp(request, "GetFeatureInfo") == 0)
+    return msWMSFeatureInfo(map, nVersion, req->ParamNames, req->ParamValues,
+                            req->NumParams, wms_exception_format, ows_request);
+  else if (strcasecmp(request, "DescribeLayer") == 0) {
+    return msWMSDescribeLayer(map, nVersion, req->ParamNames, req->ParamValues,
+                              req->NumParams, wms_exception_format);
+  } else if (isContentDependantLegend) {
+    return msWMSGetContentDependantLegend(map, nVersion, req->ParamNames,
+                                          req->ParamValues, req->NumParams,
+                                          wms_exception_format, ows_request);
+  }
+
+  /* Hummmm... incomplete or unsupported WMS request */
+  if (service != NULL && strcasecmp(service, "WMS") == 0) {
+    msSetError(MS_WMSERR, "Incomplete or unsupported WMS request",
+               "msWMSDispatch()");
+    return msWMSException(map, nVersion, NULL, wms_exception_format);
+  } else
+    return MS_DONE; /* Not a WMS request */
+#else
+  msSetError(MS_WMSERR, "WMS server support is not available.",
+             "msWMSDispatch()");
+  return (MS_FAILURE);
+#endif
+}
diff -pruN 8.0.1-5/src/mapwmslayer.c 8.2.0~beta1-1~exp1/src/mapwmslayer.c
--- 8.0.1-5/src/mapwmslayer.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapwmslayer.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1697 @@
+/*****************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Implementation of WMS CONNECTIONTYPE - client to WMS servers
+ * Author:   Daniel Morissette, DM Solutions Group (morissette@dmsolutions.ca)
+ *
+ *****************************************************************************
+ * Copyright (c) 2001-2004, Daniel Morissette, DM Solutions Group Inc
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include "mapserver.h"
+#include "maperror.h"
+#include "mapogcsld.h"
+#include "mapows.h"
+
+#include <time.h>
+#include <ctype.h>
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#include <process.h>
+#include <stdio.h>
+#endif
+
+#include "cpl_vsi.h"
+
+/**********************************************************************
+ *                          msInitWmsParamsObj()
+ *
+ **********************************************************************/
+int msInitWmsParamsObj(wmsParamsObj *wmsparams) {
+  wmsparams->onlineresource = NULL;
+  wmsparams->params = msCreateHashTable();
+  wmsparams->numparams = 0;
+  wmsparams->httpcookiedata = NULL;
+
+  return MS_SUCCESS;
+}
+
+/**********************************************************************
+ *                          msFreeWmsParamsObj()
+ *
+ * Frees the contents of the object, but not the object itself.
+ **********************************************************************/
+void msFreeWmsParamsObj(wmsParamsObj *wmsparams) {
+  msFree(wmsparams->onlineresource);
+  wmsparams->onlineresource = NULL;
+
+  msFreeHashTable(wmsparams->params);
+  wmsparams->params = NULL;
+
+  msFree(wmsparams->httpcookiedata);
+
+  wmsparams->numparams = 0;
+}
+
+/**********************************************************************
+ *                          msSetWMSParamString()
+ *
+ **********************************************************************/
+
+#ifdef USE_WMS_LYR
+static int msSetWMSParamString(wmsParamsObj *psWMSParams, const char *name,
+                               const char *value, int urlencode, int nVersion) {
+  if (urlencode) {
+    char *pszTmp;
+
+    /*
+     *  Special case handling for characters the WMS specification
+     *  says should not be encoded, when they occur in certain
+     *  parameters.
+     *
+     *  Note: WMS 1.3 removes SRS and FORMAT from the set of
+     *        exceptional cases, but renames SRS as CRS in any case.
+     */
+    if (strcmp(name, "LAYERS") == 0 || strcmp(name, "STYLES") == 0 ||
+        strcmp(name, "BBOX") == 0) {
+      pszTmp = msEncodeUrlExcept(value, ',');
+    } else if (strcmp(name, "SRS") == 0) {
+      pszTmp = msEncodeUrlExcept(value, ':');
+    } else if (nVersion < OWS_1_3_0 && strcmp(name, "FORMAT") == 0) {
+      pszTmp = msEncodeUrlExcept(value, '/');
+    } else {
+      pszTmp = msEncodeUrl(value);
+    }
+
+    msInsertHashTable(psWMSParams->params, name, pszTmp);
+    msFree(pszTmp);
+  } else {
+    msInsertHashTable(psWMSParams->params, name, value);
+  }
+  psWMSParams->numparams++;
+
+  return MS_SUCCESS;
+}
+#endif /* def USE_WMS_LYR */
+
+/**********************************************************************
+ *                          msSetWMSParamInt()
+ *
+ **********************************************************************/
+
+#ifdef USE_WMS_LYR
+static int msSetWMSParamInt(wmsParamsObj *wmsparams, const char *name,
+                            int value) {
+  char szBuf[100];
+
+  snprintf(szBuf, sizeof(szBuf), "%d", value);
+  msInsertHashTable(wmsparams->params, name, szBuf);
+  wmsparams->numparams++;
+
+  return MS_SUCCESS;
+}
+#endif /* def USE_WMS_LYR */
+
+/**********************************************************************
+ *                          msBuildWMSParamsUrl()
+ *
+ **********************************************************************/
+static char *msBuildURLFromWMSParams(wmsParamsObj *wmsparams) {
+  const char *key, *value;
+  size_t bufferSize = 0;
+  int nLen;
+  char *pszURL;
+
+  /* Compute size required for URL buffer
+   */
+  nLen = strlen(wmsparams->onlineresource) + 3;
+
+  key = msFirstKeyFromHashTable(wmsparams->params);
+  while (key != NULL) {
+    value = msLookupHashTable(wmsparams->params, key);
+    nLen += strlen(key) + strlen(value) + 2;
+
+    key = msNextKeyFromHashTable(wmsparams->params, key);
+  }
+
+  bufferSize = nLen + 1;
+  pszURL = (char *)msSmallMalloc(bufferSize);
+
+  /* Start with the onlineresource value and append trailing '?' or '&'
+   * if missing.
+   */
+  strcpy(pszURL, wmsparams->onlineresource);
+  if (strchr(pszURL, '?') == NULL)
+    strcat(pszURL, "?");
+  else {
+    char *c;
+    c = pszURL + strlen(pszURL) - 1;
+    if (*c != '?' && *c != '&')
+      strcpy(c + 1, "&");
+  }
+
+  /* Now add all the parameters
+   */
+  nLen = strlen(pszURL);
+  key = msFirstKeyFromHashTable(wmsparams->params);
+  while (key != NULL) {
+    value = msLookupHashTable(wmsparams->params, key);
+    snprintf(pszURL + nLen, bufferSize - nLen, "%s=%s&", key, value);
+    nLen += strlen(key) + strlen(value) + 2;
+    key = msNextKeyFromHashTable(wmsparams->params, key);
+  }
+
+  /* Get rid of trailing '&'*/
+  pszURL[nLen - 1] = '\0';
+
+  return pszURL;
+}
+
+#ifdef USE_WMS_LYR
+
+static bool IsPNGFormat(const char *pszValue) {
+  return EQUAL(pszValue, "PNG") || EQUAL(pszValue, "image/png");
+}
+
+static bool IsJPEGFormat(const char *pszValue) {
+  return EQUAL(pszValue, "JPEG") || EQUAL(pszValue, "image/jpeg");
+}
+
+/**********************************************************************
+ *                          msWMSLayerGetFormat()
+ *
+ * Returns the value of the "FORMAT" parameter (to be freed with msFree())
+ * or NULL in case of error
+ **********************************************************************/
+static char *msWMSLayerGetFormat(layerObj *lp) {
+  const char *pszFormat = msOWSLookupMetadata(&(lp->metadata), "MO", "format");
+  if (pszFormat)
+    return msStrdup(pszFormat);
+
+  const char *pszFormatList =
+      msOWSLookupMetadata(&(lp->metadata), "MO", "formatlist");
+  if (pszFormatList == NULL) {
+    msSetError(MS_WMSCONNERR,
+               "At least wms_format or wms_formatlist is required for "
+               "layer %s.  "
+               "Please either provide a valid CONNECTION URL, or provide "
+               "those values in the layer's metadata.\n",
+               "msBuildWMSLayerURLBase()", lp->name);
+    return NULL;
+  }
+
+  /* Look for the first format in list that matches */
+  int i, n;
+  char **papszTok = msStringSplit(pszFormatList, ',', &n);
+
+  for (i = 0; pszFormat == NULL && i < n; i++) {
+    if (0
+#if defined USE_PNG
+        || IsPNGFormat(papszTok[i])
+#endif
+#if defined USE_JPEG
+        || IsJPEGFormat(papszTok[i])
+#endif
+    ) {
+      pszFormat = papszTok[i];
+    }
+  }
+
+  if (pszFormat) {
+    char *pszRet = msStrdup(pszFormat);
+    msFreeCharArray(papszTok, n);
+    return pszRet;
+  } else {
+    msSetError(MS_WMSCONNERR,
+               "Could not find a format that matches supported input "
+               "formats in wms_formatlist metdata in layer %s.  "
+               "Please either provide a valid CONNECTION URL, or "
+               "provide the required layer metadata.\n",
+               "msBuildWMSLayerURLBase()", lp->name);
+    msFreeCharArray(papszTok, n);
+    return NULL;
+  }
+}
+
+/**********************************************************************
+ *                          msBuildWMSLayerURLBase()
+ *
+ * Build the base of a GetMap or GetFeatureInfo URL using metadata.
+ * The parameters to set are:
+ *   VERSION
+ *   LAYERS
+ *   FORMAT
+ *   TRANSPARENT
+ *   STYLES
+ *   QUERY_LAYERS (for queriable layers only)
+ *
+ * Returns a reference to a newly allocated string that should be freed
+ * by the caller.
+ **********************************************************************/
+static int msBuildWMSLayerURLBase(mapObj *map, layerObj *lp,
+                                  wmsParamsObj *psWMSParams, int nRequestType) {
+  const char *pszOnlineResource, *pszVersion, *pszName;
+  const char *pszStyle, /* *pszStyleList,*/ *pszTime;
+  const char *pszBgColor, *pszTransparent;
+  const char *pszSLD = NULL, *pszStyleSLDBody = NULL, *pszVersionKeyword = NULL;
+  const char *pszSLDBody = NULL, *pszSLDURL = NULL;
+  char *pszSLDGenerated = NULL;
+  int nVersion = OWS_VERSION_NOTSET;
+
+  /* If lp->connection is not set then use wms_onlineresource metadata */
+  pszOnlineResource = lp->connection;
+  if (pszOnlineResource == NULL)
+    pszOnlineResource =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "onlineresource");
+
+  pszVersion = msOWSLookupMetadata(&(lp->metadata), "MO", "server_version");
+  pszName = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
+  pszStyle = msOWSLookupMetadata(&(lp->metadata), "MO", "style");
+  /*pszStyleList =      msOWSLookupMetadata(&(lp->metadata), "MO",
+   * "stylelist");*/
+  pszTime = msOWSLookupMetadata(&(lp->metadata), "MO", "time");
+  pszSLDBody = msOWSLookupMetadata(&(lp->metadata), "MO", "sld_body");
+  pszSLDURL = msOWSLookupMetadata(&(lp->metadata), "MO", "sld_url");
+  pszBgColor = msOWSLookupMetadata(&(lp->metadata), "MO", "bgcolor");
+  pszTransparent = msOWSLookupMetadata(&(lp->metadata), "MO", "transparent");
+
+  if (pszOnlineResource == NULL || pszVersion == NULL || pszName == NULL) {
+    msSetError(MS_WMSCONNERR,
+               "One of wms_onlineresource, wms_server_version, wms_name "
+               "metadata is missing in layer %s.  "
+               "Please either provide a valid CONNECTION URL, or provide "
+               "those values in the layer's metadata.\n",
+               "msBuildWMSLayerURLBase()", lp->name);
+    return MS_FAILURE;
+  }
+
+  psWMSParams->onlineresource = msStrdup(pszOnlineResource);
+
+  if (strncmp(pszVersion, "1.0.7", 5) < 0)
+    pszVersionKeyword = "WMTVER";
+  else
+    pszVersionKeyword = "VERSION";
+
+  nVersion = msOWSParseVersionString(pszVersion);
+  /* WMS 1.0.8 is really just 1.1.0 */
+  if (nVersion == OWS_1_0_8)
+    nVersion = OWS_1_1_0;
+
+  msSetWMSParamString(psWMSParams, pszVersionKeyword, pszVersion, MS_FALSE,
+                      nVersion);
+  msSetWMSParamString(psWMSParams, "SERVICE", "WMS", MS_FALSE, nVersion);
+  msSetWMSParamString(psWMSParams, "LAYERS", pszName, MS_TRUE, nVersion);
+
+  char *pszFormat = msWMSLayerGetFormat(lp);
+  if (!pszFormat) {
+    return MS_FAILURE;
+  }
+
+  msSetWMSParamString(psWMSParams, "FORMAT", pszFormat, MS_TRUE, nVersion);
+  msFree(pszFormat);
+
+  if (pszStyle == NULL) {
+    /* When no style is selected, use "" which is a valid default. */
+    pszStyle = "";
+  } else {
+    /* Was a wms_style_..._sld URL provided? */
+    char szBuf[100];
+    snprintf(szBuf, sizeof(szBuf), "style_%.80s_sld", pszStyle);
+    pszSLD = msOWSLookupMetadata(&(lp->metadata), "MO", szBuf);
+    snprintf(szBuf, sizeof(szBuf), "style_%.80s_sld_body", pszStyle);
+    pszStyleSLDBody = msOWSLookupMetadata(&(lp->metadata), "MO", szBuf);
+
+    if (pszSLD || pszStyleSLDBody) {
+      /* SLD URL is set.  If this defn. came from a map context then */
+      /* the style name may just be an internal name: "Style{%d}" if */
+      /* that's the case then we should not pass this name via the URL */
+      if (strncmp(pszStyle, "Style{", 6) == 0)
+        pszStyle = "";
+    }
+  }
+
+  /*  set STYLE parameter no matter what, even if it's empty (i.e. "STYLES=")
+   *  GetLegendGraphic doesn't support multiple styles and is named STYLE
+   */
+  if (nRequestType == WMS_GETLEGENDGRAPHIC) {
+    msSetWMSParamString(psWMSParams, "STYLE", pszStyle, MS_TRUE, nVersion);
+  } else {
+    msSetWMSParamString(psWMSParams, "STYLES", pszStyle, MS_TRUE, nVersion);
+  }
+
+  if (pszSLD != NULL) {
+    /* Only SLD is set */
+    msSetWMSParamString(psWMSParams, "SLD", pszSLD, MS_TRUE, nVersion);
+  } else if (pszStyleSLDBody != NULL) {
+    /* SLDBODY are set */
+    msSetWMSParamString(psWMSParams, "SLD_BODY", pszStyleSLDBody, MS_TRUE,
+                        nVersion);
+  }
+
+  if (msIsLayerQueryable(lp)) {
+    msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszName, MS_TRUE,
+                        nVersion);
+  }
+  if (pszTime && strlen(pszTime) > 0) {
+    msSetWMSParamString(psWMSParams, "TIME", pszTime, MS_TRUE, nVersion);
+  }
+
+  /* if  the metadata wms_sld_body is set to AUTO, we generate
+   * the sld based on classes found in the map file and send
+   * it in the URL. If diffrent from AUTO, we are assuming that
+   * it is a valid sld.
+   */
+  if (pszSLDBody) {
+    if (strcasecmp(pszSLDBody, "AUTO") == 0) {
+      if (strncmp(pszVersion, "1.3.0", 5) == 0)
+        pszSLDGenerated = msSLDGenerateSLD(map, lp->index, "1.1.0");
+      else
+        pszSLDGenerated = msSLDGenerateSLD(map, lp->index, NULL);
+
+      if (pszSLDGenerated) {
+        msSetWMSParamString(psWMSParams, "SLD_BODY", pszSLDGenerated, MS_TRUE,
+                            nVersion);
+        free(pszSLDGenerated);
+      }
+    } else {
+      msSetWMSParamString(psWMSParams, "SLD_BODY", pszSLDBody, MS_TRUE,
+                          nVersion);
+    }
+  }
+
+  if (pszSLDURL) {
+    msSetWMSParamString(psWMSParams, "SLD", pszSLDURL, MS_TRUE, nVersion);
+  }
+
+  if (pszBgColor) {
+    msSetWMSParamString(psWMSParams, "BGCOLOR", pszBgColor, MS_TRUE, nVersion);
+  }
+
+  if (pszTransparent) {
+    msSetWMSParamString(psWMSParams, "TRANSPARENT", pszTransparent, MS_TRUE,
+                        nVersion);
+  } else {
+    msSetWMSParamString(psWMSParams, "TRANSPARENT", "TRUE", MS_TRUE, nVersion);
+  }
+
+  return MS_SUCCESS;
+}
+
+#endif /* USE_WMS_LYR */
+
+/**********************************************************************
+ *                          msBuildWMSLayerURL()
+ *
+ * Build a GetMap or GetFeatureInfo URL.
+ *
+ * Returns a reference to a newly allocated string that should be freed
+ * by the caller.
+ **********************************************************************/
+
+static int msBuildWMSLayerURL(mapObj *map, layerObj *lp, int nRequestType,
+                              int nClickX, int nClickY, int nFeatureCount,
+                              const char *pszInfoFormat, rectObj *bbox_ret,
+                              int *width_ret, int *height_ret,
+                              wmsParamsObj *psWMSParams) {
+#ifdef USE_WMS_LYR
+  char *pszEPSG = NULL;
+  const char *pszVersion, *pszRequestParam,
+      *pszSrsParamName = "SRS", *pszLayer = NULL, *pszQueryLayers = NULL,
+      *pszUseStrictAxisOrder;
+  rectObj bbox;
+  int bbox_width = map->width, bbox_height = map->height;
+  int nVersion = OWS_VERSION_NOTSET;
+  int bUseStrictAxisOrder = MS_FALSE; /* this is the assumption up to 1.1.0 */
+  int bFlipAxisOrder = MS_FALSE;
+  const char *pszTmp;
+  int bIsEssential = MS_FALSE;
+
+  if (lp->connectiontype != MS_WMS) {
+    msSetError(MS_WMSCONNERR, "Call supported only for CONNECTIONTYPE WMS",
+               "msBuildWMSLayerURL()");
+    return MS_FAILURE;
+  }
+
+  /* ------------------------------------------------------------------
+   * Find out request version
+   * ------------------------------------------------------------------ */
+  if (lp->connection == NULL ||
+      ((pszVersion = strstr(lp->connection, "VERSION=")) == NULL &&
+       (pszVersion = strstr(lp->connection, "version=")) == NULL &&
+       (pszVersion = strstr(lp->connection, "WMTVER=")) == NULL &&
+       (pszVersion = strstr(lp->connection, "wmtver=")) == NULL)) {
+    /* CONNECTION missing or seems incomplete... try to build from metadata */
+    if (msBuildWMSLayerURLBase(map, lp, psWMSParams, nRequestType) !=
+        MS_SUCCESS)
+      return MS_FAILURE; /* An error already produced. */
+
+    /* If we received MS_SUCCESS then version must have been set */
+    pszVersion = msLookupHashTable(psWMSParams->params, "VERSION");
+    if (pszVersion == NULL)
+      pszVersion = msLookupHashTable(psWMSParams->params, "WMTVER");
+
+    nVersion = msOWSParseVersionString(pszVersion);
+  } else {
+    /* CONNECTION string seems complete, start with that. */
+    char *pszDelimiter;
+    psWMSParams->onlineresource = msStrdup(lp->connection);
+
+    /* Fetch version info */
+    pszVersion = strchr(pszVersion, '=') + 1;
+    pszDelimiter = strchr(pszVersion, '&');
+    if (pszDelimiter != NULL)
+      *pszDelimiter = '\0';
+    nVersion = msOWSParseVersionString(pszVersion);
+    if (pszDelimiter != NULL)
+      *pszDelimiter = '&';
+  }
+
+  switch (nVersion) {
+  case OWS_1_0_8:
+    nVersion = OWS_1_1_0; /* 1.0.8 == 1.1.0 */
+    break;
+  case OWS_1_0_0:
+  case OWS_1_0_1:
+  case OWS_1_0_7:
+  case OWS_1_1_0:
+  case OWS_1_1_1:
+    /* All is good, this is a supported version. */
+    break;
+  case OWS_1_3_0:
+    /* 1.3.0 introduces a few changes... */
+    pszSrsParamName = "CRS";
+    bUseStrictAxisOrder = MS_TRUE; /* this is the assumption for 1.3.0 */
+    break;
+  default:
+    /* Not a supported version */
+    msSetError(MS_WMSCONNERR,
+               "MapServer supports only WMS 1.0.0 to 1.3.0 (please verify the "
+               "VERSION parameter in the connection string).",
+               "msBuildWMSLayerURL()");
+    return MS_FAILURE;
+  }
+
+  /* ------------------------------------------------------------------
+   * For GetFeatureInfo requests, make sure QUERY_LAYERS is included
+   * ------------------------------------------------------------------ */
+  if (nRequestType == WMS_GETFEATUREINFO &&
+      strstr(psWMSParams->onlineresource, "QUERY_LAYERS=") == NULL &&
+      strstr(psWMSParams->onlineresource, "query_layers=") == NULL &&
+      msLookupHashTable(psWMSParams->params, "QUERY_LAYERS") == NULL) {
+    pszQueryLayers = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
+
+    if (pszQueryLayers == NULL) {
+      msSetError(MS_WMSCONNERR,
+                 "wms_name not set or WMS Connection String must contain the "
+                 "QUERY_LAYERS parameter to support GetFeatureInfo requests "
+                 "(with name in uppercase).",
+                 "msBuildWMSLayerURL()");
+      return MS_FAILURE;
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * For GetLegendGraphic requests, make sure LAYER is included
+   * ------------------------------------------------------------------ */
+  if (nRequestType == WMS_GETLEGENDGRAPHIC &&
+      strstr(psWMSParams->onlineresource, "LAYER=") == NULL &&
+      strstr(psWMSParams->onlineresource, "layer=") == NULL &&
+      msLookupHashTable(psWMSParams->params, "LAYER") == NULL) {
+    pszLayer = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
+
+    if (pszLayer == NULL) {
+      msSetError(MS_WMSCONNERR,
+                 "wms_name not set or WMS Connection String must contain the "
+                 "LAYER parameter to support GetLegendGraphic requests (with "
+                 "name in uppercase).",
+                 "msBuildWMSLayerURL()");
+      return MS_FAILURE;
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * Figure the SRS we'll use for the request.
+   * - Fetch the map SRS (if it's EPSG)
+   * - Check if map SRS is listed in layer wms_srs metadata
+   * - If map SRS is valid for this layer then use it
+   * - Otherwise request layer in its default SRS and we'll reproject later
+   * ------------------------------------------------------------------ */
+  msOWSGetEPSGProj(&(map->projection), NULL, NULL, MS_TRUE, &pszEPSG);
+  if (pszEPSG && (strncasecmp(pszEPSG, "EPSG:", 5) == 0 ||
+                  strncasecmp(pszEPSG, "AUTO:", 5) == 0)) {
+    const char *pszFound;
+    char *pszLyrEPSG;
+    int nLen;
+    char *pszPtr = NULL;
+
+    /* If it's an AUTO projection then keep only id and strip off  */
+    /* the parameters for now (we'll restore them at the end) */
+    if (strncasecmp(pszEPSG, "AUTO:", 5) == 0) {
+      if ((pszPtr = strchr(pszEPSG, ',')))
+        *pszPtr = '\0';
+    }
+
+    nLen = strlen(pszEPSG);
+
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE,
+                     &pszLyrEPSG);
+
+    if (pszLyrEPSG == NULL ||
+        (pszFound = strstr(pszLyrEPSG, pszEPSG)) == NULL ||
+        !((*(pszFound + nLen) == '\0') || isspace(*(pszFound + nLen)))) {
+      /* Not found in Layer's list of SRS (including projection object) */
+      free(pszEPSG);
+      pszEPSG = NULL;
+    }
+    msFree(pszLyrEPSG);
+    if (pszEPSG && pszPtr)
+      *pszPtr = ','; /* Restore full AUTO:... definition */
+  }
+
+  if (pszEPSG == NULL) {
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_TRUE,
+                     &pszEPSG);
+    if (pszEPSG == NULL || (strncasecmp(pszEPSG, "EPSG:", 5) != 0 &&
+                            strncasecmp(pszEPSG, "AUTO:", 5) != 0)) {
+      msSetError(MS_WMSCONNERR,
+                 "Layer must have an EPSG or AUTO projection code (in its "
+                 "PROJECTION object or wms_srs metadata)",
+                 "msBuildWMSLayerURL()");
+      msFree(pszEPSG);
+      return MS_FAILURE;
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * For an AUTO projection, set the Units,lon0,lat0 if not already set
+   * ------------------------------------------------------------------ */
+  if (strncasecmp(pszEPSG, "AUTO:", 5) == 0 && strchr(pszEPSG, ',') == NULL) {
+    pointObj oPoint;
+    char *pszNewEPSG;
+
+    /* Use center of map view for lon0,lat0 */
+    oPoint.x = (map->extent.minx + map->extent.maxx) / 2.0;
+    oPoint.y = (map->extent.miny + map->extent.maxy) / 2.0;
+    msProjectPoint(&(map->projection), &(map->latlon), &oPoint);
+
+    pszNewEPSG = (char *)msSmallMalloc(101 * sizeof(char));
+
+    snprintf(pszNewEPSG, 100, "%s,9001,%.16g,%.16g", pszEPSG, oPoint.x,
+             oPoint.y);
+    pszNewEPSG[100] = '\0';
+    free(pszEPSG);
+    pszEPSG = pszNewEPSG;
+  }
+
+  /*
+   * Work out whether we'll be wanting to flip the axis order for the request
+   */
+  pszUseStrictAxisOrder =
+      msOWSLookupMetadata(&(lp->metadata), "MO", "strict_axis_order");
+  if (pszUseStrictAxisOrder != NULL) {
+    if (strncasecmp(pszUseStrictAxisOrder, "1", 1) == 0 ||
+        strncasecmp(pszUseStrictAxisOrder, "true", 4) == 0) {
+      bUseStrictAxisOrder = MS_TRUE;
+    } else if (strncasecmp(pszUseStrictAxisOrder, "0", 1) == 0 ||
+               strncasecmp(pszUseStrictAxisOrder, "false", 5) == 0) {
+      bUseStrictAxisOrder = MS_FALSE;
+    }
+  }
+  if (bUseStrictAxisOrder == MS_TRUE && pszEPSG &&
+      strncasecmp(pszEPSG, "EPSG:", 5) == 0 &&
+      msIsAxisInverted(atoi(pszEPSG + 5))) {
+    bFlipAxisOrder = MS_TRUE;
+  }
+
+  /* ------------------------------------------------------------------
+   * Set layer SRS.
+   * ------------------------------------------------------------------ */
+  /* No need to set lp->proj if it's already set to the right EPSG code */
+  {
+    char *pszEPSGCodeFromLayer = NULL;
+    msOWSGetEPSGProj(&(lp->projection), NULL, "MO", MS_TRUE,
+                     &pszEPSGCodeFromLayer);
+    if (pszEPSGCodeFromLayer == NULL ||
+        strcasecmp(pszEPSG, pszEPSGCodeFromLayer) != 0) {
+      char *ows_srs = NULL;
+      msOWSGetEPSGProj(NULL, &(lp->metadata), "MO", MS_FALSE, &ows_srs);
+      /* no need to set lp->proj if it is already set and there is only
+      one item in the _srs metadata for this layer - we will assume
+      the projection block matches the _srs metadata (the search for ' '
+      in ows_srs is a test to see if there are multiple EPSG: codes) */
+      if (lp->projection.numargs == 0 || ows_srs == NULL ||
+          (strchr(ows_srs, ' ') != NULL)) {
+        // Reproject layer extent if lp-projection is set since we might change
+        // layer projection
+        if (msProjectionsDiffer(&(map->projection), &(lp->projection))) {
+          msProjectRect(&(lp->projection), &(map->projection), &(lp->extent));
+        }
+
+        if (strncasecmp(pszEPSG, "EPSG:", 5) == 0) {
+          char szProj[20];
+          snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG + 5);
+          if (msLoadProjectionString(&(lp->projection), szProj) != 0) {
+            msFree(pszEPSGCodeFromLayer);
+            msFree(ows_srs);
+            free(pszEPSG);
+            return MS_FAILURE;
+          }
+        } else {
+          if (msLoadProjectionString(&(lp->projection), pszEPSG) != 0) {
+            msFree(pszEPSGCodeFromLayer);
+            msFree(ows_srs);
+            free(pszEPSG);
+            return MS_FAILURE;
+          }
+        }
+      }
+      msFree(ows_srs);
+    }
+    msFree(pszEPSGCodeFromLayer);
+  }
+
+  /* ------------------------------------------------------------------
+   * Adjust for MapServer EXTENT being center of pixel and WMS BBOX being
+   * edge of pixel (#2843).
+   * ------------------------------------------------------------------ */
+  bbox = map->extent;
+
+  bbox.minx -= map->cellsize * 0.5;
+  bbox.maxx += map->cellsize * 0.5;
+  bbox.miny -= map->cellsize * 0.5;
+  bbox.maxy += map->cellsize * 0.5;
+
+  /* -------------------------------------------------------------------- */
+  /*      Reproject if needed.                                            */
+  /* -------------------------------------------------------------------- */
+  if (msProjectionsDiffer(&(map->projection), &(lp->projection))) {
+    msProjectRect(&(map->projection), &(lp->projection), &bbox);
+
+    /* -------------------------------------------------------------------- */
+    /*      Sometimes our remote WMS only accepts square pixel              */
+    /*      requests.  If this is the case adjust adjust the number of      */
+    /*      pixels or lines in the request so that the pixels are           */
+    /*      square.                                                         */
+    /* -------------------------------------------------------------------- */
+    {
+      const char *nonsquare_ok =
+          msOWSLookupMetadata(&(lp->metadata), "MO", "nonsquare_ok");
+
+      /* assume nonsquare_ok is false */
+      if (nonsquare_ok != NULL && (strcasecmp(nonsquare_ok, "no") == 0 ||
+                                   strcasecmp(nonsquare_ok, "false") == 0)) {
+        double cellsize_x = (bbox.maxx - bbox.minx) / bbox_width;
+        double cellsize_y = (bbox.maxy - bbox.miny) / bbox_height;
+
+        if (cellsize_x < cellsize_y * 0.999999) {
+          int new_bbox_height = ceil((cellsize_y / cellsize_x) * bbox_height);
+
+          if (lp->debug)
+            msDebug("NONSQUARE_OK=%s, adjusted HEIGHT from %d to %d to "
+                    "equalize cellsize at %g.\n",
+                    nonsquare_ok, bbox_height, new_bbox_height, cellsize_x);
+          bbox_height = new_bbox_height;
+        } else if (cellsize_y < cellsize_x * 0.999999) {
+          int new_bbox_width = ceil((cellsize_x / cellsize_y) * bbox_width);
+
+          if (lp->debug)
+            msDebug("NONSQUARE_OK=%s, adjusted WIDTH from %d to %d to equalize "
+                    "cellsize at %g.\n",
+                    nonsquare_ok, bbox_width, new_bbox_width, cellsize_y);
+          bbox_width = new_bbox_width;
+        } else {
+          if (lp->debug)
+            msDebug("NONSQUARE_OK=%s, but cellsize was already square - no "
+                    "change.\n",
+                    nonsquare_ok);
+        }
+      }
+    }
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      If the layer has predefined extents, and a predefined           */
+  /*      projection that matches the request projection, then            */
+  /*      consider restricting the BBOX to match the limits.              */
+  /* -------------------------------------------------------------------- */
+  if (bbox_width != 0) {
+    char *ows_srs;
+    rectObj layer_rect;
+
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE,
+                     &ows_srs);
+
+    if (ows_srs && strchr(ows_srs, ' ') == NULL &&
+        msOWSGetLayerExtent(map, lp, "MO", &layer_rect) == MS_SUCCESS) {
+      /* fulloverlap */
+      if (msRectContained(&bbox, &layer_rect)) {
+        /* no changes */
+      }
+
+      /* no overlap */
+      else if (!msRectOverlap(&layer_rect, &bbox)) {
+        bbox_width = 0;
+        bbox_height = 0;
+      }
+
+      else {
+        double cellsize_x = (bbox.maxx - bbox.minx) / bbox_width;
+        double cellsize_y = (bbox.maxy - bbox.miny) / bbox_height;
+        double cellsize = MS_MIN(cellsize_x, cellsize_y);
+
+        msRectIntersect(&bbox, &layer_rect);
+
+        bbox_width = round((bbox.maxx - bbox.minx) / cellsize);
+        bbox_height = round((bbox.maxy - bbox.miny) / cellsize);
+
+        /* Force going through the resampler if we're going to receive a clipped
+         * BBOX (#4931) */
+        if (msLayerGetProcessingKey(lp, "RESAMPLE") == NULL) {
+          msLayerSetProcessingKey(lp, "RESAMPLE", "nearest");
+        }
+      }
+    }
+    msFree(ows_srs);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Potentially return the bbox.                                    */
+  /* -------------------------------------------------------------------- */
+  if (bbox_ret != NULL)
+    *bbox_ret = bbox;
+
+  if (width_ret != NULL)
+    *width_ret = bbox_width;
+
+  if (height_ret != NULL)
+    *height_ret = bbox_height;
+
+  /* ------------------------------------------------------------------
+   * Build the request URL.
+   * At this point we set only the following parameters for GetMap:
+   *   REQUEST
+   *   SRS (or CRS)
+   *   BBOX
+   *
+   * And for GetFeatureInfo:
+   *   X (I for 1.3.0)
+   *   Y (J for 1.3.0)
+   *   INFO_FORMAT
+   *   FEATURE_COUNT (only if nFeatureCount > 0)
+   *
+   * The connection string should contain all other required params,
+   * including:
+   *   VERSION
+   *   LAYERS
+   *   FORMAT
+   *   TRANSPARENT
+   *   STYLES
+   *   QUERY_LAYERS (for queryable layers only)
+   * ------------------------------------------------------------------ */
+
+  /* ------------------------------------------------------------------
+   * Sometimes a requested layer is essential for the map, so if the
+   * request fails or an error is delivered, the map has not to be drawn
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "essential")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "true") == 0 || strcasecmp(pszTmp, "on") == 0 ||
+        strcasecmp(pszTmp, "yes") == 0)
+      bIsEssential = MS_TRUE;
+    else
+      bIsEssential = atoi(pszTmp);
+  }
+
+  if (nRequestType == WMS_GETFEATUREINFO) {
+    char szBuf[100] = "";
+
+    if (nVersion >= OWS_1_0_7)
+      pszRequestParam = "GetFeatureInfo";
+    else
+      pszRequestParam = "feature_info";
+
+    const char *pszExceptionsParam;
+    if (nVersion >= OWS_1_3_0)
+      pszExceptionsParam = "XML";
+    else if (nVersion >= OWS_1_1_0) /* 1.1.0 to 1.1.0 */
+      pszExceptionsParam = "application/vnd.ogc.se_xml";
+    else if (nVersion > OWS_1_0_0) /* 1.0.1 to 1.0.7 */
+      pszExceptionsParam = "SE_XML";
+    else
+      pszExceptionsParam = "WMS_XML";
+
+    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamInt(psWMSParams, "WIDTH", bbox_width);
+    msSetWMSParamInt(psWMSParams, "HEIGHT", bbox_height);
+
+    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE,
+                        nVersion);
+
+    if (bFlipAxisOrder == MS_TRUE) {
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.miny,
+               bbox.minx, bbox.maxy, bbox.maxx);
+    } else {
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.minx,
+               bbox.miny, bbox.maxx, bbox.maxy);
+    }
+    msSetWMSParamString(psWMSParams, "BBOX", szBuf, MS_TRUE, nVersion);
+
+    if (nVersion >= OWS_1_3_0) {
+      msSetWMSParamInt(psWMSParams, "I", nClickX);
+      msSetWMSParamInt(psWMSParams, "J", nClickY);
+    } else {
+      msSetWMSParamInt(psWMSParams, "X", nClickX);
+      msSetWMSParamInt(psWMSParams, "Y", nClickY);
+    }
+
+    msSetWMSParamString(psWMSParams, "EXCEPTIONS", pszExceptionsParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamString(psWMSParams, "INFO_FORMAT", pszInfoFormat, MS_TRUE,
+                        nVersion);
+
+    if (pszQueryLayers) { /* not set in CONNECTION string */
+      msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszQueryLayers, MS_FALSE,
+                          nVersion);
+    }
+
+    /* If FEATURE_COUNT <= 0 then don't pass this parameter */
+    /* The spec states that FEATURE_COUNT must be greater than zero */
+    /* and if not passed then the behavior is up to the server */
+    if (nFeatureCount > 0) {
+      msSetWMSParamInt(psWMSParams, "FEATURE_COUNT", nFeatureCount);
+    }
+
+  } else if (nRequestType == WMS_GETLEGENDGRAPHIC) {
+    if (map->extent.maxx > map->extent.minx && map->width > 0 &&
+        map->height > 0) {
+      char szBuf[20] = "";
+      double scaledenom;
+      msCalculateScale(map->extent, map->units, map->width, map->height,
+                       map->resolution, &scaledenom);
+      snprintf(szBuf, 20, "%g", scaledenom);
+      msSetWMSParamString(psWMSParams, "SCALE", szBuf, MS_FALSE, nVersion);
+    }
+    pszRequestParam = "GetLegendGraphic";
+
+    /*
+    const char* pszExceptionsParam = msOWSLookupMetadata(&(lp->metadata),
+                         "MO", "exceptions_format");
+    if (pszExceptionsParam == NULL) {
+      if (nVersion >= OWS_1_1_0 && nVersion < OWS_1_3_0)
+        pszExceptionsParam = "application/vnd.ogc.se_inimage";
+      else
+        pszExceptionsParam = "INIMAGE";
+    }*/
+
+    if (pszLayer) { /* not set in CONNECTION string */
+      msSetWMSParamString(psWMSParams, "LAYER", pszLayer, MS_FALSE, nVersion);
+    }
+
+    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE,
+                        nVersion);
+
+    if (nVersion >= OWS_1_3_0) {
+      msSetWMSParamString(psWMSParams, "SLD_VERSION", "1.1.0", MS_FALSE,
+                          nVersion);
+    }
+
+  } else { /* if (nRequestType == WMS_GETMAP) */
+    char szBuf[100] = "";
+
+    if (nVersion >= OWS_1_0_7)
+      pszRequestParam = "GetMap";
+    else
+      pszRequestParam = "map";
+
+    const char *pszExceptionsParam =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "exceptions_format");
+
+    if (!bIsEssential) {
+      if (pszExceptionsParam == NULL) {
+        if (nVersion >= OWS_1_1_0 && nVersion < OWS_1_3_0)
+          pszExceptionsParam = "application/vnd.ogc.se_inimage";
+        else
+          pszExceptionsParam = "INIMAGE";
+      }
+    } else {
+      /* if layer is essential, do not emit EXCEPTIONS parameter (defaults to
+       * XML) */
+      pszExceptionsParam = NULL;
+    }
+
+    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamInt(psWMSParams, "WIDTH", bbox_width);
+    msSetWMSParamInt(psWMSParams, "HEIGHT", bbox_height);
+    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE,
+                        nVersion);
+
+    if (bFlipAxisOrder == MS_TRUE) {
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.miny,
+               bbox.minx, bbox.maxy, bbox.maxx);
+    } else {
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.minx,
+               bbox.miny, bbox.maxx, bbox.maxy);
+    }
+    msSetWMSParamString(psWMSParams, "BBOX", szBuf, MS_TRUE, nVersion);
+    if (pszExceptionsParam) {
+      msSetWMSParamString(psWMSParams, "EXCEPTIONS", pszExceptionsParam,
+                          MS_FALSE, nVersion);
+    }
+  }
+
+  free(pszEPSG);
+
+  return MS_SUCCESS;
+
+#else
+  /* ------------------------------------------------------------------
+   * WMS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
+             "msBuildWMSLayerURL()");
+  return MS_FAILURE;
+
+#endif /* USE_WMS_LYR */
+}
+
+/**********************************************************************
+ *                          msWMSGetFeatureInfoURL()
+ *
+ * Build a GetFeatureInfo URL for this layer.
+ *
+ * Returns a reference to a newly allocated string that should be freed
+ * by the caller.
+ **********************************************************************/
+char *msWMSGetFeatureInfoURL(mapObj *map, layerObj *lp, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat) {
+  wmsParamsObj sThisWMSParams;
+  char *pszURL;
+
+  msInitWmsParamsObj(&sThisWMSParams);
+
+  if (msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO, nClickX, nClickY,
+                         nFeatureCount, pszInfoFormat, NULL, NULL, NULL,
+                         &sThisWMSParams) != MS_SUCCESS) {
+    return NULL;
+  }
+
+  pszURL = msBuildURLFromWMSParams(&sThisWMSParams);
+  msFreeWmsParamsObj(&sThisWMSParams);
+
+  return pszURL;
+}
+
+/**********************************************************************
+ *                          msPrepareWMSLayerRequest()
+ *
+ **********************************************************************/
+
+int msPrepareWMSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
+                             int nRequestType,
+                             enum MS_CONNECTION_TYPE lastconnectiontype,
+                             wmsParamsObj *psLastWMSParams, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat,
+                             httpRequestObj *pasReqInfo, int *numRequests) {
+#ifdef USE_WMS_LYR
+  char *pszURL = NULL, *pszHTTPCookieData = NULL;
+  const char *pszTmp;
+  rectObj bbox = {0};
+  int bbox_width = 0, bbox_height = 0;
+  int nTimeout, bOkToMerge, bForceSeparateRequest, bCacheToDisk;
+  wmsParamsObj sThisWMSParams;
+  int ret = MS_FAILURE;
+
+  if (lp->connectiontype != MS_WMS)
+    return MS_FAILURE;
+
+  msInitWmsParamsObj(&sThisWMSParams);
+
+  /* ------------------------------------------------------------------
+   * Build the request URL, this will also set layer projection and
+   * compute BBOX in that projection.
+   * ------------------------------------------------------------------ */
+
+  switch (nRequestType) {
+  case WMS_GETMAP:
+    ret = msBuildWMSLayerURL(map, lp, WMS_GETMAP, 0, 0, 0, NULL, &bbox,
+                             &bbox_width, &bbox_height, &sThisWMSParams);
+    break;
+
+  case WMS_GETFEATUREINFO:
+    ret = msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO, nClickX, nClickY,
+                             nFeatureCount, pszInfoFormat, NULL, NULL, NULL,
+                             &sThisWMSParams);
+    break;
+
+  case WMS_GETLEGENDGRAPHIC:
+    ret = msBuildWMSLayerURL(map, lp, WMS_GETLEGENDGRAPHIC, 0, 0, 0, NULL, NULL,
+                             NULL, NULL, &sThisWMSParams);
+    break;
+
+  default:
+    assert(FALSE);
+    break;
+  }
+
+  if (ret != MS_SUCCESS) {
+    /* an error was already reported. */
+    msFreeWmsParamsObj(&sThisWMSParams);
+    return MS_FAILURE;
+  }
+
+  /* ------------------------------------------------------------------
+   * Check if the request is empty, perhaps due to reprojection problems
+   * or wms_extents restrictions.
+   * ------------------------------------------------------------------ */
+  if ((nRequestType == WMS_GETMAP) && (bbox_width == 0 || bbox_height == 0)) {
+    msFreeWmsParamsObj(&sThisWMSParams);
+    return MS_SUCCESS; /* No overlap. */
+  }
+
+  /* ------------------------------------------------------------------
+   * Check if layer overlaps current view window (using wms_latlonboundingbox)
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                    "latlonboundingbox")) != NULL) {
+    char **tokens;
+    int n;
+    rectObj ext;
+
+    tokens = msStringSplit(pszTmp, ' ', &n);
+    if (tokens == NULL || n != 4) {
+      msSetError(
+          MS_WMSCONNERR,
+          "Wrong number of arguments for 'wms_latlonboundingbox' metadata.",
+          "msDrawWMSLayer()");
+      msFreeWmsParamsObj(&sThisWMSParams);
+      return MS_FAILURE;
+    }
+
+    ext.minx = atof(tokens[0]);
+    ext.miny = atof(tokens[1]);
+    ext.maxx = atof(tokens[2]);
+    ext.maxy = atof(tokens[3]);
+
+    msFreeCharArray(tokens, n);
+
+    /* Reproject latlonboundingbox to the selected SRS for the layer and */
+    /* check if it overlaps the bbox that we calculated for the request */
+
+    msProjectRect(&(map->latlon), &(lp->projection), &ext);
+    if (!msRectOverlap(&bbox, &ext)) {
+      /* No overlap... nothing to do */
+
+      msFreeWmsParamsObj(&sThisWMSParams);
+      return MS_SUCCESS; /* No overlap. */
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * check to see if a the metadata wms_connectiontimeout is set. If it is
+   * the case we will use it, else we use the default which is 30 seconds.
+   * First check the metadata in the layer object and then in the map object.
+   * ------------------------------------------------------------------ */
+  nTimeout = 30; /* Default is 30 seconds  */
+  if ((pszTmp = msOWSLookupMetadata2(&(lp->metadata), &(map->web.metadata),
+                                     "MO", "connectiontimeout")) != NULL) {
+    nTimeout = atoi(pszTmp);
+  }
+
+  /* ------------------------------------------------------------------
+   * Check if we want to use in memory images instead of writing to disk.
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "cache_to_disk")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "true") == 0 || strcasecmp(pszTmp, "on") == 0 ||
+        strcasecmp(pszTmp, "yes") == 0)
+      bCacheToDisk = MS_TRUE;
+    else
+      bCacheToDisk = atoi(pszTmp);
+  } else
+    bCacheToDisk = MS_FALSE;
+
+  if (bCacheToDisk) {
+    /* We'll store the remote server's response to a tmp file. */
+    if (map->web.imagepath == NULL || strlen(map->web.imagepath) == 0) {
+      msSetError(MS_WMSERR,
+                 "WEB.IMAGEPATH must be set to use WMS client connections.",
+                 "msPrepareWMSLayerRequest()");
+      return MS_FAILURE;
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * Check if layer can be merged with previous WMS layer requests
+   * Metadata wms_force_separate_request can be set to 1 to prevent this
+   * this layer from being combined with any other layer.
+   * ------------------------------------------------------------------ */
+  bForceSeparateRequest = MS_FALSE;
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                    "force_separate_request")) != NULL) {
+    bForceSeparateRequest = atoi(pszTmp);
+  }
+  bOkToMerge = MS_FALSE;
+  if (!bForceSeparateRequest && lastconnectiontype == MS_WMS &&
+      psLastWMSParams != NULL &&
+      sThisWMSParams.numparams == psLastWMSParams->numparams &&
+      strcmp(sThisWMSParams.onlineresource, psLastWMSParams->onlineresource) ==
+          0) {
+    const char *key, *value1, *value2;
+    bOkToMerge = MS_TRUE;
+
+    key = msFirstKeyFromHashTable(sThisWMSParams.params);
+    while (key != NULL && bOkToMerge == MS_TRUE) {
+      /* Skip parameters whose values can be different */
+      if (!(strcmp(key, "LAYERS") == 0 || strcmp(key, "QUERY_LAYERS") == 0 ||
+            strcmp(key, "STYLES") == 0)) {
+        value1 = msLookupHashTable(psLastWMSParams->params, key);
+        value2 = msLookupHashTable(sThisWMSParams.params, key);
+
+        if (value1 == NULL || value2 == NULL || strcmp(value1, value2) != 0) {
+          bOkToMerge = MS_FALSE;
+          break;
+        }
+      }
+      key = msNextKeyFromHashTable(sThisWMSParams.params, key);
+    }
+  }
+
+  /*------------------------------------------------------------------
+   * Check to see if there's a HTTP Cookie to forward
+   * If Cookie differ between the two connection, it's NOT OK to merge
+   * the connection
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "http_cookie")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
+        pszHTTPCookieData = msStrdup(pszTmp);
+      }
+    } else {
+      pszHTTPCookieData = msStrdup(pszTmp);
+    }
+  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                           "http_cookie")) != NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
+        pszHTTPCookieData = msStrdup(pszTmp);
+      }
+    } else {
+      pszHTTPCookieData = msStrdup(pszTmp);
+    }
+  }
+
+  if (bOkToMerge && pszHTTPCookieData != sThisWMSParams.httpcookiedata) {
+    if (pszHTTPCookieData == NULL || sThisWMSParams.httpcookiedata == NULL) {
+      bOkToMerge = MS_FALSE;
+    } else if (strcmp(pszHTTPCookieData, sThisWMSParams.httpcookiedata) != 0) {
+      bOkToMerge = MS_FALSE;
+    }
+  }
+
+  if (bOkToMerge) {
+    /* Merge both requests into sThisWMSParams
+     */
+    const char *value1, *value2;
+    char *keys[] = {"LAYERS", "QUERY_LAYERS", "STYLES"};
+    int i;
+
+    for (i = 0; i < 3; i++) {
+      value1 = msLookupHashTable(psLastWMSParams->params, keys[i]);
+      value2 = msLookupHashTable(sThisWMSParams.params, keys[i]);
+      if (value1 && value2) {
+        char *pszBuf;
+        int nLen;
+
+        nLen = strlen(value1) + strlen(value2) + 2;
+        pszBuf = malloc(nLen);
+        MS_CHECK_ALLOC(pszBuf, nLen, MS_FAILURE);
+
+        snprintf(pszBuf, nLen, "%s,%s", value1, value2);
+        /* TODO should really send the server request version here */
+        msSetWMSParamString(&sThisWMSParams, keys[i], pszBuf, MS_FALSE,
+                            OWS_VERSION_NOTSET);
+
+        /* This key existed already, we don't want it counted twice */
+        sThisWMSParams.numparams--;
+
+        msFree(pszBuf);
+      }
+    }
+  }
+
+  /* ------------------------------------------------------------------
+   * Build new request URL
+   * ------------------------------------------------------------------ */
+  pszURL = msBuildURLFromWMSParams(&sThisWMSParams);
+
+  if (bOkToMerge && (*numRequests) > 0) {
+    /* ------------------------------------------------------------------
+     * Update the last request in the array:  (*numRequests)-1
+     * ------------------------------------------------------------------ */
+    msFree(pasReqInfo[(*numRequests) - 1].pszGetUrl);
+    pasReqInfo[(*numRequests) - 1].pszGetUrl = pszURL;
+    pszURL = NULL;
+    pasReqInfo[(*numRequests) - 1].debug |= lp->debug;
+    if (nTimeout > pasReqInfo[(*numRequests) - 1].nTimeout)
+      pasReqInfo[(*numRequests) - 1].nTimeout = nTimeout;
+  } else {
+    /* ------------------------------------------------------------------
+     * Add a request to the array (already preallocated)
+     * ------------------------------------------------------------------ */
+    pasReqInfo[(*numRequests)].nLayerId = nLayerId;
+    pasReqInfo[(*numRequests)].pszGetUrl = pszURL;
+
+    pszURL = NULL;
+    pasReqInfo[(*numRequests)].pszHTTPCookieData = pszHTTPCookieData;
+    pszHTTPCookieData = NULL;
+    if (bCacheToDisk) {
+      pasReqInfo[(*numRequests)].pszOutputFile =
+          msTmpFile(map, map->mappath, NULL, "wms.tmp");
+    } else
+      pasReqInfo[(*numRequests)].pszOutputFile = NULL;
+    pasReqInfo[(*numRequests)].nStatus = 0;
+    pasReqInfo[(*numRequests)].nTimeout = nTimeout;
+    pasReqInfo[(*numRequests)].bbox = bbox;
+    pasReqInfo[(*numRequests)].width = bbox_width;
+    pasReqInfo[(*numRequests)].height = bbox_height;
+    pasReqInfo[(*numRequests)].debug = lp->debug;
+
+    if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata), pasReqInfo,
+                             *numRequests, map, "MO") != MS_SUCCESS)
+      return MS_FAILURE;
+
+    (*numRequests)++;
+  }
+
+  /* ------------------------------------------------------------------
+   * Replace contents of psLastWMSParams with sThisWMSParams
+   * unless bForceSeparateRequest is set in which case we make it empty
+   * ------------------------------------------------------------------ */
+  if (psLastWMSParams) {
+    msFreeWmsParamsObj(psLastWMSParams);
+    if (!bForceSeparateRequest)
+      *psLastWMSParams = sThisWMSParams;
+    else
+      msInitWmsParamsObj(psLastWMSParams);
+  } else {
+    /* Can't copy it, so we just free it */
+    msFreeWmsParamsObj(&sThisWMSParams);
+  }
+
+  return MS_SUCCESS;
+
+#else
+  /* ------------------------------------------------------------------
+   * WMS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
+             "msDrawWMSLayer()");
+  return (MS_FAILURE);
+
+#endif /* USE_WMS_LYR */
+}
+
+/**********************************************************************
+ *                          msDrawWMSLayerLow()
+ *
+ **********************************************************************/
+
+int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo, int numRequests,
+                      mapObj *map, layerObj *lp, imageObj *img) {
+#ifdef USE_WMS_LYR
+  int status = MS_SUCCESS;
+  int iReq = -1;
+  char szPath[MS_MAXPATHLEN];
+  int currenttype;
+  int currentconnectiontype;
+  int numclasses;
+  char *mem_filename = NULL;
+  const char *pszTmp;
+  int bIsEssential = MS_FALSE;
+
+  /* ------------------------------------------------------------------
+   * Sometimes a requested layer is essential for the map, so if the
+   * request fails or an error is delivered, the map has not to be drawn
+   * ------------------------------------------------------------------ */
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "essential")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "true") == 0 || strcasecmp(pszTmp, "on") == 0 ||
+        strcasecmp(pszTmp, "yes") == 0)
+      bIsEssential = MS_TRUE;
+    else
+      bIsEssential = atoi(pszTmp);
+  }
+
+  /* ------------------------------------------------------------------
+   * Find the request info for this layer in the array, based on nLayerId
+   * ------------------------------------------------------------------ */
+  for (iReq = 0; iReq < numRequests; iReq++) {
+    if (pasReqInfo[iReq].nLayerId == nLayerId)
+      break;
+  }
+
+  if (iReq == numRequests) {
+    /* This layer was skipped or was included in a multi-layers
+     * request ... nothing to do.
+     */
+    return MS_SUCCESS;
+  }
+
+  if (!MS_HTTP_SUCCESS(pasReqInfo[iReq].nStatus)) {
+    /* ====================================================================
+          Failed downloading layer... we log an error but we still return
+          SUCCESS here so that the layer is only skipped instead of aborting
+          the whole draw map.
+          If the layer is essential the map is not to be drawn.
+     ==================================================================== */
+    msSetError(MS_WMSERR,
+               "WMS GetMap request failed for layer '%s' (Status %d: %s).",
+               "msDrawWMSLayerLow()", (lp->name ? lp->name : "(null)"),
+               pasReqInfo[iReq].nStatus, pasReqInfo[iReq].pszErrBuf);
+
+    if (!bIsEssential)
+      return MS_SUCCESS;
+    else
+      return MS_FAILURE;
+  }
+
+  /* ------------------------------------------------------------------
+   * Check the Content-Type of the response to see if we got an exception,
+   * if yes then try to parse it and pass the info to msSetError().
+   * We log an error but we still return SUCCESS here so that the layer
+   * is only skipped instead of aborting the whole draw map.
+   * If the layer is essential the map is not to be drawn.
+   * ------------------------------------------------------------------ */
+  if (pasReqInfo[iReq].pszContentType &&
+      (strcmp(pasReqInfo[iReq].pszContentType, "text/xml") == 0 ||
+       strcmp(pasReqInfo[iReq].pszContentType, "application/vnd.ogc.se_xml") ==
+           0)) {
+    FILE *fp;
+    char szBuf[MS_BUFFER_LENGTH];
+
+    if (pasReqInfo[iReq].pszOutputFile) {
+      fp = fopen(pasReqInfo[iReq].pszOutputFile, "r");
+      if (fp) {
+        /* TODO: For now we'll only read the first chunk and return it
+         * via msSetError()... we should really try to parse the XML
+         * and extract the exception code/message though
+         */
+        size_t nSize;
+
+        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH - 1, fp);
+        if (nSize < MS_BUFFER_LENGTH)
+          szBuf[nSize] = '\0';
+        else {
+          strlcpy(szBuf, "(!!!)", sizeof(szBuf)); /* This should never happen */
+        }
+
+        fclose(fp);
+
+        /* We're done with the remote server's response... delete it. */
+        if (!lp->debug)
+          unlink(pasReqInfo[iReq].pszOutputFile);
+      } else {
+        strlcpy(szBuf, "(Failed to open exception response)", sizeof(szBuf));
+      }
+    } else {
+      strlcpy(szBuf, pasReqInfo[iReq].result_data, MS_BUFFER_LENGTH);
+    }
+
+    if (lp->debug)
+      msDebug("WMS GetMap request got XML exception for layer '%s': %s.",
+              (lp->name ? lp->name : "(null)"), szBuf);
+
+    msSetError(MS_WMSERR,
+               "WMS GetMap request got XML exception for layer '%s': %s.",
+               "msDrawWMSLayerLow()", (lp->name ? lp->name : "(null)"), szBuf);
+
+    if (!bIsEssential)
+      return MS_SUCCESS;
+    else
+      return MS_FAILURE;
+  }
+
+  /* ------------------------------------------------------------------
+   * If the output was written to a memory buffer, then we will need
+   * to attach a "VSI" name to this buffer.
+   * ------------------------------------------------------------------ */
+  if (pasReqInfo[iReq].pszOutputFile == NULL) {
+    mem_filename = msTmpFile(map, NULL, "/vsimem/msout/", "img.tmp");
+
+    VSIFCloseL(VSIFileFromMemBuffer(
+        mem_filename, (GByte *)pasReqInfo[iReq].result_data,
+        (vsi_l_offset)pasReqInfo[iReq].result_size, FALSE));
+  }
+
+  /* ------------------------------------------------------------------
+   * Prepare layer for drawing, reprojecting the image received from the
+   * server if needed...
+   * ------------------------------------------------------------------ */
+  /* keep the current type that will be restored at the end of this  */
+  /* function. */
+  currenttype = lp->type;
+  currentconnectiontype = lp->connectiontype;
+  lp->type = MS_LAYER_RASTER;
+  lp->connectiontype = MS_RASTER;
+
+  /* set the classes to 0 so that It won't do client side */
+  /* classification if an sld was set. */
+  numclasses = lp->numclasses;
+
+  /* ensure the file connection is closed right away after the layer */
+  /* is rendered */
+  msLayerSetProcessingKey(lp, "CLOSE_CONNECTION", "NORMAL");
+
+  if (msOWSLookupMetadata(&(lp->metadata), "MO", "sld_body") ||
+      msOWSLookupMetadata(&(lp->metadata), "MO", "sld_url"))
+    lp->numclasses = 0;
+
+  if (lp->data)
+    free(lp->data);
+  if (mem_filename != NULL)
+    lp->data = mem_filename;
+  else
+    lp->data = msStrdup(pasReqInfo[iReq].pszOutputFile);
+
+  const char *pszAllowedDrivers =
+      msOWSLookupMetadata(&(lp->metadata), "MO", "allowed_gdal_drivers");
+  if (!pszAllowedDrivers) {
+    char *pszFormat = msWMSLayerGetFormat(lp);
+    if (IsPNGFormat(pszFormat))
+      pszAllowedDrivers = "PNG";
+    else if (IsJPEGFormat(pszFormat))
+      pszAllowedDrivers = "JPEG";
+    else
+      pszAllowedDrivers = "PNG,JPEG";
+    msFree(pszFormat);
+  }
+  // This will be used by msDrawRasterLayerLow()
+  msLayerSetProcessingKey(lp, "ALLOWED_GDAL_DRIVERS", pszAllowedDrivers);
+  if (lp->debug)
+    msDebug("Setting ALLOWED_GDAL_DRIVERS = %s\n", pszAllowedDrivers);
+
+  /* #3138 If PROCESSING "RESAMPLE=..." is set we cannot use the simple case */
+  if (!msProjectionsDiffer(&(map->projection), &(lp->projection)) &&
+      (msLayerGetProcessingKey(lp, "RESAMPLE") == NULL)) {
+    /* The simple case... no reprojection needed... render layer directly. */
+    lp->transform = MS_FALSE;
+    /* if (msDrawRasterLayerLow(map, lp, img) != 0) */
+    /* status = MS_FAILURE; */
+    if (msDrawLayer(map, lp, img) != 0)
+      status = MS_FAILURE;
+  } else {
+    VSILFILE *fp;
+    char *wldfile;
+    /* OK, we have to resample the raster to map projection... */
+    lp->transform = MS_TRUE;
+    msLayerSetProcessingKey(lp, "LOAD_WHOLE_IMAGE", "YES");
+
+    /* Create a world file with raster extents */
+    /* One line per value, in this order: cx, 0, 0, cy, ulx, uly */
+    wldfile = msBuildPath(szPath, lp->map->mappath, lp->data);
+    if (wldfile && (strlen(wldfile) >= 3))
+      strcpy(wldfile + strlen(wldfile) - 3, "wld");
+    if (wldfile && (fp = VSIFOpenL(wldfile, "wt")) != NULL) {
+      double dfCellSizeX =
+          MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.minx,
+                          pasReqInfo[iReq].bbox.maxx, pasReqInfo[iReq].width);
+      double dfCellSizeY =
+          MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.maxy,
+                          pasReqInfo[iReq].bbox.miny, pasReqInfo[iReq].height);
+      char world_text[5000];
+
+      sprintf(world_text, "%.12f\n0\n0\n%.12f\n%.12f\n%.12f\n", dfCellSizeX,
+              dfCellSizeY, pasReqInfo[iReq].bbox.minx + dfCellSizeX * 0.5,
+              pasReqInfo[iReq].bbox.maxy + dfCellSizeY * 0.5);
+
+      VSIFWriteL(world_text, 1, strlen(world_text), fp);
+      VSIFCloseL(fp);
+
+      /* GDAL should be called to reproject automatically. */
+      if (msDrawLayer(map, lp, img) != 0)
+        status = MS_FAILURE;
+
+      if (!lp->debug || mem_filename != NULL)
+        VSIUnlink(wldfile);
+    } else {
+      msSetError(MS_WMSCONNERR, "Unable to create wld file for WMS slide.",
+                 "msDrawWMSLayer()");
+      status = MS_FAILURE;
+    }
+  }
+
+  /* We're done with the remote server's response... delete it. */
+  if (!lp->debug || mem_filename != NULL)
+    VSIUnlink(lp->data);
+
+  /* restore prveious type */
+  lp->type = currenttype;
+  lp->connectiontype = currentconnectiontype;
+
+  /* restore previous numclasses */
+  lp->numclasses = numclasses;
+
+  free(lp->data);
+  lp->data = NULL;
+
+  return status;
+
+#else
+  /* ------------------------------------------------------------------
+   * WMS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
+             "msDrawWMSLayer()");
+  return (MS_FAILURE);
+
+#endif /* USE_WMS_LYR */
+}
+
+int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat, int type) {
+#ifdef USE_WMS_LYR
+
+  msIOContext *context;
+
+  httpRequestObj *pasReqInfo;
+  wmsParamsObj sLastWMSParams;
+  int i, numReq = 0;
+
+  pasReqInfo = (httpRequestObj *)msSmallMalloc((nOWSLayers + 1) *
+                                               sizeof(httpRequestObj));
+  msHTTPInitRequestObj(pasReqInfo, nOWSLayers + 1);
+  msInitWmsParamsObj(&sLastWMSParams);
+
+  /* Generate the http request */
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, map->layerorder[i])->status == MS_ON) {
+      if (type == WMS_GETFEATUREINFO) {
+        if (msPrepareWMSLayerRequest(
+                map->layerorder[i], map, GET_LAYER(map, map->layerorder[i]),
+                WMS_GETFEATUREINFO, MS_WMS, &sLastWMSParams, nClickX, nClickY,
+                nFeatureCount, pszInfoFormat, pasReqInfo,
+                &numReq) == MS_FAILURE) {
+          msFreeWmsParamsObj(&sLastWMSParams);
+          msFree(pasReqInfo);
+          return MS_FAILURE;
+        }
+      } else if (msPrepareWMSLayerRequest(map->layerorder[i], map,
+                                          GET_LAYER(map, map->layerorder[i]),
+                                          WMS_GETLEGENDGRAPHIC, MS_WMS,
+                                          &sLastWMSParams, 0, 0, 0, NULL,
+                                          pasReqInfo, &numReq) == MS_FAILURE) {
+        msFreeWmsParamsObj(&sLastWMSParams);
+        msFree(pasReqInfo);
+        return MS_FAILURE;
+      }
+    }
+  }
+
+  if (msOWSExecuteRequests(pasReqInfo, numReq, map, MS_FALSE) == MS_FAILURE) {
+    msHTTPFreeRequestObj(pasReqInfo, numReq);
+    msFree(pasReqInfo);
+    msFreeWmsParamsObj(&sLastWMSParams);
+    return MS_FAILURE;
+  }
+
+  context = msIO_getHandler(stdout);
+  if (context == NULL) {
+    msHTTPFreeRequestObj(pasReqInfo, numReq);
+    msFree(pasReqInfo);
+    msFreeWmsParamsObj(&sLastWMSParams);
+    return MS_FAILURE;
+  }
+
+  msIO_printf("Content-Type: %s%c%c", pasReqInfo[0].pszContentType, 10, 10);
+
+  if (pasReqInfo[0].pszOutputFile) {
+    FILE *fp;
+    char szBuf[MS_BUFFER_LENGTH];
+
+    fp = fopen(pasReqInfo[0].pszOutputFile, "r");
+    if (fp) {
+      while (1) {
+        size_t nSize;
+        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH - 1, fp);
+        if (nSize > 0)
+          msIO_contextWrite(context, szBuf, nSize);
+        if (nSize != MS_BUFFER_LENGTH - 1)
+          break;
+      }
+      fclose(fp);
+      if (!map->debug)
+        unlink(pasReqInfo[0].pszOutputFile);
+    } else {
+      msSetError(MS_IOERR, "'%s'.", "msWMSLayerExecuteRequest()",
+                 pasReqInfo[0].pszOutputFile);
+      return MS_FAILURE;
+    }
+  } else {
+    msIO_contextWrite(context, pasReqInfo[0].result_data,
+                      pasReqInfo[0].result_size);
+  }
+
+  msHTTPFreeRequestObj(pasReqInfo, numReq);
+  msFree(pasReqInfo);
+  msFreeWmsParamsObj(&sLastWMSParams);
+
+  return MS_SUCCESS;
+#else
+  /* ------------------------------------------------------------------
+   * WMS CONNECTION Support not included...
+   * ------------------------------------------------------------------ */
+  msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
+             "msWMSLayerExecuteRequest()");
+  return (MS_FAILURE);
+
+#endif /* USE_WMS_LYR */
+}
diff -pruN 8.0.1-5/src/mapxbase.c 8.2.0~beta1-1~exp1/src/mapxbase.c
--- 8.0.1-5/src/mapxbase.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapxbase.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,919 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  .dbf access API.  Derived from shapelib, and relicensed with
+ *           permission of Frank Warmerdam (shapelib author).
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+#include <stdlib.h> /* for atof() and atoi() */
+#include <math.h>
+
+#include "cpl_vsi.h"
+
+static inline void IGUR_sizet(size_t ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
+
+/************************************************************************/
+/*                             SfRealloc()                              */
+/*                                                                      */
+/*      A realloc cover function that will access a NULL pointer as     */
+/*      a valid input.                                                  */
+/************************************************************************/
+static void *SfRealloc(void *pMem, int nNewSize)
+
+{
+  return ((void *)realloc(pMem, nNewSize));
+}
+
+/************************************************************************/
+/*                           writeHeader()                              */
+/*                                                                      */
+/*      This is called to write out the file header, and field          */
+/*      descriptions before writing any actual data records.  This      */
+/*      also computes all the DBFDataSet field offset/size/decimals     */
+/*      and so forth values.                                            */
+/************************************************************************/
+static void writeHeader(DBFHandle psDBF)
+
+{
+  uchar abyHeader[32];
+  int i;
+
+  if (!psDBF->bNoHeader)
+    return;
+
+  psDBF->bNoHeader = MS_FALSE;
+
+  /* -------------------------------------------------------------------- */
+  /*  Initialize the file header information.               */
+  /* -------------------------------------------------------------------- */
+  for (i = 0; i < 32; i++)
+    abyHeader[i] = 0;
+
+  abyHeader[0] = 0x03; /* memo field? - just copying   */
+
+  /* date updated on close, record count preset at zero */
+
+  abyHeader[8] = psDBF->nHeaderLength % 256;
+  abyHeader[9] = psDBF->nHeaderLength / 256;
+
+  abyHeader[10] = psDBF->nRecordLength % 256;
+  abyHeader[11] = psDBF->nRecordLength / 256;
+
+  /* -------------------------------------------------------------------- */
+  /*      Write the initial 32 byte file header, and all the field        */
+  /*      descriptions.                                             */
+  /* -------------------------------------------------------------------- */
+  VSIFSeekL(psDBF->fp, 0, 0);
+  VSIFWriteL(abyHeader, 32, 1, psDBF->fp);
+  VSIFWriteL(psDBF->pszHeader, 32, psDBF->nFields, psDBF->fp);
+
+  /* -------------------------------------------------------------------- */
+  /*      Write out the newline character if there is room for it.        */
+  /* -------------------------------------------------------------------- */
+  if (psDBF->nHeaderLength > 32 * psDBF->nFields + 32) {
+    char cNewline;
+
+    cNewline = 0x0d;
+    VSIFWriteL(&cNewline, 1, 1, psDBF->fp);
+  }
+}
+
+/************************************************************************/
+/*                           flushRecord()                              */
+/*                                                                      */
+/*      Write out the current record if there is one.                   */
+/************************************************************************/
+static void flushRecord(DBFHandle psDBF)
+
+{
+  unsigned int nRecordOffset;
+
+  if (psDBF->bCurrentRecordModified && psDBF->nCurrentRecord > -1) {
+    psDBF->bCurrentRecordModified = MS_FALSE;
+
+    nRecordOffset =
+        psDBF->nRecordLength * psDBF->nCurrentRecord + psDBF->nHeaderLength;
+
+    VSIFSeekL(psDBF->fp, nRecordOffset, 0);
+    VSIFWriteL(psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp);
+  }
+}
+
+DBFHandle msDBFOpenVirtualFile(VSILFILE *fp) {
+  DBFHandle psDBF;
+  uchar *pabyBuf;
+  int nFields, nHeadLen, nRecLen, iField;
+
+  /* -------------------------------------------------------------------- */
+  /*      Open the file.                                                  */
+  /* -------------------------------------------------------------------- */
+  psDBF = (DBFHandle)calloc(1, sizeof(DBFInfo));
+  MS_CHECK_ALLOC(psDBF, sizeof(DBFInfo), NULL);
+  psDBF->fp = fp;
+
+  psDBF->bNoHeader = MS_FALSE;
+  psDBF->nCurrentRecord = -1;
+  psDBF->bCurrentRecordModified = MS_FALSE;
+
+  psDBF->pszStringField = NULL;
+  psDBF->nStringFieldLen = 0;
+
+  /* -------------------------------------------------------------------- */
+  /*  Read Table Header info                                              */
+  /* -------------------------------------------------------------------- */
+  pabyBuf = (uchar *)msSmallMalloc(500);
+  if (VSIFReadL(pabyBuf, 32, 1, psDBF->fp) != 1) {
+    VSIFCloseL(psDBF->fp);
+    msFree(psDBF);
+    msFree(pabyBuf);
+    return (NULL);
+  }
+
+  if (pabyBuf[7] < 128)
+    psDBF->nRecords = pabyBuf[4] + pabyBuf[5] * 256 + pabyBuf[6] * 256 * 256 +
+                      pabyBuf[7] * 256 * 256 * 256;
+  else
+    psDBF->nRecords = 0;
+
+  psDBF->nHeaderLength = nHeadLen = pabyBuf[8] + pabyBuf[9] * 256;
+  psDBF->nRecordLength = nRecLen = pabyBuf[10] + pabyBuf[11] * 256;
+
+  if (nHeadLen <= 32) {
+    VSIFCloseL(psDBF->fp);
+    msFree(psDBF);
+    msFree(pabyBuf);
+    return (NULL);
+  }
+
+  psDBF->nFields = nFields = (nHeadLen - 32) / 32;
+
+  psDBF->pszCurrentRecord = (char *)msSmallMalloc(nRecLen);
+
+  /* -------------------------------------------------------------------- */
+  /*  Read in Field Definitions                                           */
+  /* -------------------------------------------------------------------- */
+  pabyBuf = (uchar *)SfRealloc(pabyBuf, nHeadLen);
+  psDBF->pszHeader = (char *)pabyBuf;
+
+  VSIFSeekL(psDBF->fp, 32, 0);
+  if (VSIFReadL(pabyBuf, nHeadLen - 32, 1, psDBF->fp) != 1) {
+    msFree(psDBF->pszCurrentRecord);
+    VSIFCloseL(psDBF->fp);
+    msFree(psDBF);
+    msFree(pabyBuf);
+    return (NULL);
+  }
+
+  psDBF->panFieldOffset = (int *)msSmallMalloc(sizeof(int) * nFields);
+  psDBF->panFieldSize = (int *)msSmallMalloc(sizeof(int) * nFields);
+  psDBF->panFieldDecimals = (int *)msSmallMalloc(sizeof(int) * nFields);
+  psDBF->pachFieldType = (char *)msSmallMalloc(sizeof(char) * nFields);
+
+  for (iField = 0; iField < nFields; iField++) {
+    uchar *pabyFInfo;
+
+    pabyFInfo = pabyBuf + iField * 32;
+
+    if (pabyFInfo[11] == 'N' || pabyFInfo[11] == 'F') {
+      psDBF->panFieldSize[iField] = pabyFInfo[16];
+      psDBF->panFieldDecimals[iField] = pabyFInfo[17];
+    } else {
+      psDBF->panFieldSize[iField] = pabyFInfo[16] + pabyFInfo[17] * 256;
+      psDBF->panFieldDecimals[iField] = 0;
+    }
+
+    psDBF->pachFieldType[iField] = (char)pabyFInfo[11];
+    if (iField == 0)
+      psDBF->panFieldOffset[iField] = 1;
+    else
+      psDBF->panFieldOffset[iField] =
+          psDBF->panFieldOffset[iField - 1] + psDBF->panFieldSize[iField - 1];
+  }
+
+  return (psDBF);
+}
+
+/************************************************************************/
+/*                              msDBFOpen()                             */
+/*                                                                      */
+/*      Open a .dbf file.                                               */
+/************************************************************************/
+DBFHandle msDBFOpen(const char *pszFilename, const char *pszAccess)
+
+{
+  /* -------------------------------------------------------------------- */
+  /*      We only allow the access strings "rb" and "r+".                 */
+  /* -------------------------------------------------------------------- */
+  if (strcmp(pszAccess, "r") != 0 && strcmp(pszAccess, "r+") != 0 &&
+      strcmp(pszAccess, "rb") != 0 && strcmp(pszAccess, "r+b") != 0)
+    return (NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*  Ensure the extension is converted to dbf or DBF if it is      */
+  /*  currently .shp or .shx.               */
+  /* -------------------------------------------------------------------- */
+  char *pszDBFFilename = (char *)msSmallMalloc(strlen(pszFilename) + 1);
+  strcpy(pszDBFFilename, pszFilename);
+
+  if (strcmp(pszFilename + strlen(pszFilename) - 4, ".shp") == 0 ||
+      strcmp(pszFilename + strlen(pszFilename) - 4, ".shx") == 0) {
+    strcpy(pszDBFFilename + strlen(pszDBFFilename) - 4, ".dbf");
+  } else if (strcmp(pszFilename + strlen(pszFilename) - 4, ".SHP") == 0 ||
+             strcmp(pszFilename + strlen(pszFilename) - 4, ".SHX") == 0) {
+    strcpy(pszDBFFilename + strlen(pszDBFFilename) - 4, ".DBF");
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Open the file.                                                  */
+  /* -------------------------------------------------------------------- */
+  VSILFILE *fp = VSIFOpenL(pszDBFFilename, pszAccess);
+  if (fp == NULL) {
+    if (strcmp(pszDBFFilename + strlen(pszDBFFilename) - 4, ".dbf") == 0) {
+      strcpy(pszDBFFilename + strlen(pszDBFFilename) - 4, ".DBF");
+      fp = VSIFOpenL(pszDBFFilename, pszAccess);
+    }
+  }
+  msFree(pszDBFFilename);
+  if (fp == NULL) {
+    return (NULL);
+  }
+
+  return msDBFOpenVirtualFile(fp);
+}
+
+/************************************************************************/
+/*                              msDBFClose()                            */
+/************************************************************************/
+
+void msDBFClose(DBFHandle psDBF) {
+  /* -------------------------------------------------------------------- */
+  /*      Write out header if not already written.                        */
+  /* -------------------------------------------------------------------- */
+  if (psDBF->bNoHeader)
+    writeHeader(psDBF);
+
+  flushRecord(psDBF);
+
+  /* -------------------------------------------------------------------- */
+  /*      Update last access date, and number of records if we have       */
+  /*  write access.                             */
+  /* -------------------------------------------------------------------- */
+  if (psDBF->bUpdated) {
+    uchar abyFileHeader[32];
+
+    VSIFSeekL(psDBF->fp, 0, 0);
+    IGUR_sizet(VSIFReadL(abyFileHeader, 32, 1, psDBF->fp));
+
+    abyFileHeader[1] = 95; /* YY */
+    abyFileHeader[2] = 7;  /* MM */
+    abyFileHeader[3] = 26; /* DD */
+
+    abyFileHeader[4] = psDBF->nRecords % 256;
+    abyFileHeader[5] = (psDBF->nRecords / 256) % 256;
+    abyFileHeader[6] = (psDBF->nRecords / (256 * 256)) % 256;
+    abyFileHeader[7] = (psDBF->nRecords / (256 * 256 * 256)) % 256;
+
+    VSIFSeekL(psDBF->fp, 0, 0);
+    VSIFWriteL(abyFileHeader, 32, 1, psDBF->fp);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Close, and free resources.                                      */
+  /* -------------------------------------------------------------------- */
+  VSIFCloseL(psDBF->fp);
+
+  if (psDBF->panFieldOffset != NULL) {
+    free(psDBF->panFieldOffset);
+    free(psDBF->panFieldSize);
+    free(psDBF->panFieldDecimals);
+    free(psDBF->pachFieldType);
+  }
+
+  free(psDBF->pszHeader);
+  free(psDBF->pszCurrentRecord);
+
+  free(psDBF->pszStringField);
+
+  free(psDBF);
+}
+
+/************************************************************************/
+/*                             msDBFCreate()                            */
+/*                                                                      */
+/*      Create a new .dbf file.                                         */
+/************************************************************************/
+DBFHandle msDBFCreate(const char *pszFilename)
+
+{
+  DBFHandle psDBF;
+  VSILFILE *fp;
+
+  /* -------------------------------------------------------------------- */
+  /*      Create the file.                                                */
+  /* -------------------------------------------------------------------- */
+  fp = VSIFOpenL(pszFilename, "wb");
+  if (fp == NULL)
+    return (NULL);
+
+  {
+    char ch = 0;
+    VSIFWriteL(&ch, 1, 1, fp);
+  }
+  VSIFCloseL(fp);
+
+  fp = VSIFOpenL(pszFilename, "rb+");
+  if (fp == NULL)
+    return (NULL);
+
+  /* -------------------------------------------------------------------- */
+  /*  Create the info structure.                */
+  /* -------------------------------------------------------------------- */
+  psDBF = (DBFHandle)malloc(sizeof(DBFInfo));
+  if (psDBF == NULL) {
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDBFCreate()", __FILE__, __LINE__,
+               (unsigned int)sizeof(DBFInfo));
+    VSIFCloseL(fp);
+    return NULL;
+  }
+
+  psDBF->fp = fp;
+  psDBF->nRecords = 0;
+  psDBF->nFields = 0;
+  psDBF->nRecordLength = 1;
+  psDBF->nHeaderLength = 33;
+
+  psDBF->panFieldOffset = NULL;
+  psDBF->panFieldSize = NULL;
+  psDBF->panFieldDecimals = NULL;
+  psDBF->pachFieldType = NULL;
+  psDBF->pszHeader = NULL;
+
+  psDBF->nCurrentRecord = -1;
+  psDBF->bCurrentRecordModified = MS_FALSE;
+  psDBF->pszCurrentRecord = NULL;
+
+  psDBF->pszStringField = NULL;
+  psDBF->nStringFieldLen = 0;
+
+  psDBF->bNoHeader = MS_TRUE;
+  psDBF->bUpdated = MS_FALSE;
+
+  return (psDBF);
+}
+
+/************************************************************************/
+/*                            msDBFAddField()                           */
+/*                                                                      */
+/*      Add a field to a newly created .dbf file before any records     */
+/*      are written.                                                    */
+/************************************************************************/
+int msDBFAddField(DBFHandle psDBF, const char *pszFieldName, DBFFieldType eType,
+                  int nWidth, int nDecimals) {
+  char *pszFInfo;
+  int i;
+
+  /* -------------------------------------------------------------------- */
+  /*      Do some checking to ensure we can add records to this file.     */
+  /* -------------------------------------------------------------------- */
+  if (psDBF->nRecords > 0)
+    return (MS_FALSE);
+
+  if (!psDBF->bNoHeader)
+    return (MS_FALSE);
+
+  if (eType != FTDouble && nDecimals != 0)
+    return (MS_FALSE);
+
+  /* -------------------------------------------------------------------- */
+  /*      SfRealloc all the arrays larger to hold the additional field    */
+  /*      information.                                                    */
+  /* -------------------------------------------------------------------- */
+  psDBF->nFields++;
+
+  psDBF->panFieldOffset =
+      (int *)SfRealloc(psDBF->panFieldOffset, sizeof(int) * psDBF->nFields);
+
+  psDBF->panFieldSize =
+      (int *)SfRealloc(psDBF->panFieldSize, sizeof(int) * psDBF->nFields);
+
+  psDBF->panFieldDecimals =
+      (int *)SfRealloc(psDBF->panFieldDecimals, sizeof(int) * psDBF->nFields);
+
+  psDBF->pachFieldType =
+      (char *)SfRealloc(psDBF->pachFieldType, sizeof(char) * psDBF->nFields);
+
+  /* -------------------------------------------------------------------- */
+  /*      Assign the new field information fields.                        */
+  /* -------------------------------------------------------------------- */
+  psDBF->panFieldOffset[psDBF->nFields - 1] = psDBF->nRecordLength;
+  psDBF->nRecordLength += nWidth;
+  psDBF->panFieldSize[psDBF->nFields - 1] = nWidth;
+  psDBF->panFieldDecimals[psDBF->nFields - 1] = nDecimals;
+
+  if (eType == FTString)
+    psDBF->pachFieldType[psDBF->nFields - 1] = 'C';
+  else
+    psDBF->pachFieldType[psDBF->nFields - 1] = 'N';
+
+  /* -------------------------------------------------------------------- */
+  /*      Extend the required header information.                         */
+  /* -------------------------------------------------------------------- */
+  psDBF->nHeaderLength += 32;
+  psDBF->bUpdated = MS_FALSE;
+
+  psDBF->pszHeader = (char *)SfRealloc(psDBF->pszHeader, psDBF->nFields * 32);
+
+  pszFInfo = psDBF->pszHeader + 32 * (psDBF->nFields - 1);
+
+  for (i = 0; i < 32; i++)
+    pszFInfo[i] = '\0';
+
+  strncpy(pszFInfo, pszFieldName, 10);
+
+  pszFInfo[11] = psDBF->pachFieldType[psDBF->nFields - 1];
+
+  if (eType == FTString) {
+    pszFInfo[16] = nWidth % 256;
+    pszFInfo[17] = nWidth / 256;
+  } else {
+    pszFInfo[16] = nWidth;
+    pszFInfo[17] = nDecimals;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Make the current record buffer appropriately larger.            */
+  /* -------------------------------------------------------------------- */
+  psDBF->pszCurrentRecord =
+      (char *)SfRealloc(psDBF->pszCurrentRecord, psDBF->nRecordLength);
+
+  return (psDBF->nFields - 1);
+}
+
+/************************************************************************/
+/*                         DBFIsValueNULL()                             */
+/*                                                                      */
+/*      Return TRUE if value is NULL (in DBF terms).                    */
+/*                                                                      */
+/*      Based on DBFIsAttributeNULL of shapelib                         */
+/************************************************************************/
+
+static int DBFIsValueNULL(const char *pszValue, char type)
+
+{
+  switch (type) {
+  case 'N':
+  case 'F':
+    /* NULL numeric fields have value "****************" */
+    return pszValue[0] == '*';
+
+  case 'D':
+    /* NULL date fields have value "00000000" */
+    return strncmp(pszValue, "00000000", 8) == 0;
+
+  case 'L':
+    /* NULL boolean fields have value "?" */
+    return pszValue[0] == '?';
+
+  default:
+    /* empty string fields are considered NULL */
+    return strlen(pszValue) == 0;
+  }
+}
+
+/************************************************************************/
+/*                          msDBFReadAttribute()                        */
+/*                                                                      */
+/*      Read one of the attribute fields of a record.                   */
+/************************************************************************/
+static const char *msDBFReadAttribute(DBFHandle psDBF, int hEntity, int iField)
+
+{
+  int i;
+  unsigned int nRecordOffset;
+  const uchar *pabyRec;
+  const char *pReturnField = NULL;
+
+  /* -------------------------------------------------------------------- */
+  /*  Is the request valid?                             */
+  /* -------------------------------------------------------------------- */
+  if (iField < 0 || iField >= psDBF->nFields) {
+    msSetError(MS_DBFERR, "Invalid field index %d.", "msDBFReadAttribute()",
+               iField);
+    return (NULL);
+  }
+
+  if (hEntity < 0 || hEntity >= psDBF->nRecords) {
+    msSetError(MS_DBFERR, "Invalid record number %d.", "msDBFReadAttribute()",
+               hEntity);
+    return (NULL);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Have we read the record?              */
+  /* -------------------------------------------------------------------- */
+  if (psDBF->nCurrentRecord != hEntity) {
+    flushRecord(psDBF);
+
+    nRecordOffset = psDBF->nRecordLength * hEntity + psDBF->nHeaderLength;
+
+    VSIFSeekL(psDBF->fp, nRecordOffset, 0);
+    if (VSIFReadL(psDBF->pszCurrentRecord, psDBF->nRecordLength, 1,
+                  psDBF->fp) != 1) {
+      msSetError(MS_DBFERR, "Cannot read record %d.", "msDBFReadAttribute()",
+                 hEntity);
+      return (NULL);
+    }
+
+    psDBF->nCurrentRecord = hEntity;
+  }
+
+  pabyRec = (const uchar *)psDBF->pszCurrentRecord;
+  /* DEBUG */
+  /* printf("CurrentRecord(%c):%s\n", psDBF->pachFieldType[iField], pabyRec); */
+
+  /* -------------------------------------------------------------------- */
+  /*  Ensure our field buffer is large enough to hold this buffer.      */
+  /* -------------------------------------------------------------------- */
+  if (psDBF->panFieldSize[iField] + 1 > psDBF->nStringFieldLen) {
+    psDBF->nStringFieldLen = psDBF->panFieldSize[iField] * 2 + 10;
+    psDBF->pszStringField =
+        (char *)SfRealloc(psDBF->pszStringField, psDBF->nStringFieldLen);
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*  Extract the requested field.              */
+  /* -------------------------------------------------------------------- */
+  strncpy(psDBF->pszStringField,
+          (const char *)pabyRec + psDBF->panFieldOffset[iField],
+          psDBF->panFieldSize[iField]);
+  psDBF->pszStringField[psDBF->panFieldSize[iField]] = '\0';
+
+  /*
+  ** Trim trailing blanks (SDL Modification)
+  */
+  for (i = strlen(psDBF->pszStringField) - 1; i >= 0; i--) {
+    if (psDBF->pszStringField[i] != ' ') {
+      psDBF->pszStringField[i + 1] = '\0';
+      break;
+    }
+  }
+
+  if (i == -1)
+    psDBF->pszStringField[0] = '\0'; /* whole string is blank (SDL fix)       */
+
+  /*
+  ** Trim/skip leading blanks (SDL/DM Modification - only on numeric types)
+  */
+  if (psDBF->pachFieldType[iField] == 'N' ||
+      psDBF->pachFieldType[iField] == 'F' ||
+      psDBF->pachFieldType[iField] == 'D') {
+    for (i = 0; psDBF->pszStringField[i] != '\0'; i++) {
+      if (psDBF->pszStringField[i] != ' ')
+        break;
+    }
+    pReturnField = psDBF->pszStringField + i;
+  } else
+    pReturnField = psDBF->pszStringField;
+
+  /*  detect null values */
+  if (DBFIsValueNULL(pReturnField, psDBF->pachFieldType[iField])) {
+    if (psDBF->pachFieldType[iField] == 'N' ||
+        psDBF->pachFieldType[iField] == 'F' ||
+        psDBF->pachFieldType[iField] == 'D')
+      pReturnField = "0";
+  }
+  return (pReturnField);
+}
+
+/************************************************************************/
+/*                        msDBFReadIntAttribute()                       */
+/*                                                                      */
+/*      Read an integer attribute.                                      */
+/************************************************************************/
+int msDBFReadIntegerAttribute(DBFHandle psDBF, int iRecord, int iField)
+
+{
+  return (atoi(msDBFReadAttribute(psDBF, iRecord, iField)));
+}
+
+/************************************************************************/
+/*                        msDBFReadDoubleAttribute()                    */
+/*                                                                      */
+/*      Read a double attribute.                                        */
+/************************************************************************/
+double msDBFReadDoubleAttribute(DBFHandle psDBF, int iRecord, int iField) {
+  return (atof(msDBFReadAttribute(psDBF, iRecord, iField)));
+}
+
+/************************************************************************/
+/*                        msDBFReadStringAttribute()                      */
+/*                                                                      */
+/*      Read a string attribute.                                        */
+/************************************************************************/
+const char *msDBFReadStringAttribute(DBFHandle psDBF, int iRecord, int iField) {
+  return (msDBFReadAttribute(psDBF, iRecord, iField));
+}
+
+/************************************************************************/
+/*                          msDBFGetFieldCount()                        */
+/*                                                                      */
+/*      Return the number of fields in this table.                      */
+/************************************************************************/
+int msDBFGetFieldCount(DBFHandle psDBF) { return (psDBF->nFields); }
+
+/************************************************************************/
+/*                         msDBFGetRecordCount()                        */
+/*                                                                      */
+/*      Return the number of records in this table.                     */
+/************************************************************************/
+int msDBFGetRecordCount(DBFHandle psDBF) { return (psDBF->nRecords); }
+
+/************************************************************************/
+/*                          msDBFGetFieldInfo()                         */
+/*                                                                      */
+/*      Return any requested information about the field.               */
+/************************************************************************/
+DBFFieldType msDBFGetFieldInfo(DBFHandle psDBF, int iField, char *pszFieldName,
+                               int *pnWidth, int *pnDecimals) {
+  if (iField < 0 || iField >= psDBF->nFields)
+    return (FTInvalid);
+
+  if (pnWidth != NULL)
+    *pnWidth = psDBF->panFieldSize[iField];
+
+  if (pnDecimals != NULL)
+    *pnDecimals = psDBF->panFieldDecimals[iField];
+
+  if (pszFieldName != NULL) {
+    int i;
+
+    strncpy(pszFieldName, (char *)psDBF->pszHeader + iField * 32, 11);
+    pszFieldName[11] = '\0';
+    for (i = 10; i > 0 && pszFieldName[i] == ' '; i--)
+      pszFieldName[i] = '\0';
+  }
+
+  if (psDBF->pachFieldType[iField] == 'N' ||
+      psDBF->pachFieldType[iField] == 'F' ||
+      psDBF->pachFieldType[iField] == 'D') {
+    if (psDBF->panFieldDecimals[iField] > 0)
+      return (FTDouble);
+    else
+      return (FTInteger);
+  } else {
+    return (FTString);
+  }
+}
+
+/************************************************************************/
+/*                         msDBFWriteAttribute()                        */
+/*                  */
+/*  Write an attribute record to the file.        */
+/************************************************************************/
+static int msDBFWriteAttribute(DBFHandle psDBF, int hEntity, int iField,
+                               void *pValue) {
+  unsigned int nRecordOffset;
+  int len;
+  uchar *pabyRec;
+  char szSField[40];
+
+  /* -------------------------------------------------------------------- */
+  /*  Is this a valid record?             */
+  /* -------------------------------------------------------------------- */
+  if (hEntity < 0 || hEntity > psDBF->nRecords)
+    return (MS_FALSE);
+
+  if (psDBF->bNoHeader)
+    writeHeader(psDBF);
+
+  /* -------------------------------------------------------------------- */
+  /*      Is this a brand new record?                                     */
+  /* -------------------------------------------------------------------- */
+  if (hEntity == psDBF->nRecords) {
+    flushRecord(psDBF);
+
+    psDBF->nRecords++;
+    for (unsigned i = 0; i < psDBF->nRecordLength; i++)
+      psDBF->pszCurrentRecord[i] = ' ';
+
+    psDBF->nCurrentRecord = hEntity;
+  }
+
+  /* -------------------------------------------------------------------- */
+  /*      Is this an existing record, but different than the last one     */
+  /*      we accessed?                                                    */
+  /* -------------------------------------------------------------------- */
+  if (psDBF->nCurrentRecord != hEntity) {
+    flushRecord(psDBF);
+
+    nRecordOffset = psDBF->nRecordLength * hEntity + psDBF->nHeaderLength;
+
+    VSIFSeekL(psDBF->fp, nRecordOffset, 0);
+    if (VSIFReadL(psDBF->pszCurrentRecord, psDBF->nRecordLength, 1,
+                  psDBF->fp) != 1)
+      return MS_FALSE;
+
+    psDBF->nCurrentRecord = hEntity;
+  }
+
+  pabyRec = (uchar *)psDBF->pszCurrentRecord;
+
+  /* -------------------------------------------------------------------- */
+  /*      Assign all the record fields.                                   */
+  /* -------------------------------------------------------------------- */
+  switch (psDBF->pachFieldType[iField]) {
+  case 'D':
+  case 'N':
+  case 'F':
+    snprintf(szSField, sizeof(szSField), "%*.*f", psDBF->panFieldSize[iField],
+             psDBF->panFieldDecimals[iField], *(double *)pValue);
+    len = strlen((char *)szSField);
+    memcpy(pabyRec + psDBF->panFieldOffset[iField], szSField,
+           MS_MIN(len, psDBF->panFieldSize[iField]));
+    break;
+
+  default:
+    len = strlen((char *)pValue);
+    memcpy(pabyRec + psDBF->panFieldOffset[iField], pValue,
+           MS_MIN(len, psDBF->panFieldSize[iField]));
+    break;
+  }
+
+  psDBF->bCurrentRecordModified = MS_TRUE;
+  psDBF->bUpdated = MS_TRUE;
+
+  return (MS_TRUE);
+}
+
+/************************************************************************/
+/*                      msDBFWriteDoubleAttribute()                     */
+/*                                                                      */
+/*      Write a double attribute.                                       */
+/************************************************************************/
+int msDBFWriteDoubleAttribute(DBFHandle psDBF, int iRecord, int iField,
+                              double dValue) {
+  return (msDBFWriteAttribute(psDBF, iRecord, iField, (void *)&dValue));
+}
+
+/************************************************************************/
+/*                      msDBFWriteIntegerAttribute()                    */
+/*                                                                      */
+/*      Write a integer attribute.                                      */
+/************************************************************************/
+
+int msDBFWriteIntegerAttribute(DBFHandle psDBF, int iRecord, int iField,
+                               int nValue) {
+  double dValue = nValue;
+
+  return (msDBFWriteAttribute(psDBF, iRecord, iField, (void *)&dValue));
+}
+
+/************************************************************************/
+/*                      msDBFWriteStringAttribute()                     */
+/*                                                                      */
+/*      Write a string attribute.                                       */
+/************************************************************************/
+int msDBFWriteStringAttribute(DBFHandle psDBF, int iRecord, int iField,
+                              const char *pszValue) {
+  return (msDBFWriteAttribute(psDBF, iRecord, iField, (void *)pszValue));
+}
+
+/*
+** Which column number in the .DBF file does the item correspond to
+*/
+int msDBFGetItemIndex(DBFHandle dbffile, char *name) {
+  int i;
+  int fWidth, fnDecimals; /* field width and number of decimals */
+  char fName[32];         /* field name */
+
+  if (!name) {
+    msSetError(MS_MISCERR, "NULL item name passed.", "msGetItemIndex()");
+    return (-1);
+  }
+
+  /* does name exist as a field? */
+  for (i = 0; i < msDBFGetFieldCount(dbffile); i++) {
+    msDBFGetFieldInfo(dbffile, i, fName, &fWidth, &fnDecimals);
+    if (strcasecmp(name, fName) == 0) /* found it */
+      return (i);
+  }
+
+  msSetError(MS_DBFERR, "Item '%s' not found.", "msDBFGetItemIndex()", name);
+  return (-1); /* item not found */
+}
+
+/*
+** Load item names into a character array
+*/
+char **msDBFGetItems(DBFHandle dbffile) {
+  char **items;
+  int i, nFields;
+  char fName[32];
+
+  if ((nFields = msDBFGetFieldCount(dbffile)) == 0) {
+    msSetError(MS_DBFERR, "File contains no data.", "msGetDBFItems()");
+    return (NULL);
+  }
+
+  items = (char **)malloc(sizeof(char *) * nFields);
+  MS_CHECK_ALLOC(items, sizeof(char *) * nFields, NULL);
+
+  for (i = 0; i < nFields; i++) {
+    msDBFGetFieldInfo(dbffile, i, fName, NULL, NULL);
+    items[i] = msStrdup(fName);
+  }
+
+  return (items);
+}
+
+/*
+** Load item values into a character array
+*/
+char **msDBFGetValues(DBFHandle dbffile, int record) {
+  char **values;
+  int i, nFields;
+
+  if ((nFields = msDBFGetFieldCount(dbffile)) == 0) {
+    msSetError(MS_DBFERR, "File contains no data.", "msGetDBFValues()");
+    return (NULL);
+  }
+
+  values = (char **)malloc(sizeof(char *) * nFields);
+  MS_CHECK_ALLOC(values, sizeof(char *) * nFields, NULL);
+
+  for (i = 0; i < nFields; i++)
+    values[i] = msStrdup(msDBFReadStringAttribute(dbffile, record, i));
+
+  return (values);
+}
+
+int *msDBFGetItemIndexes(DBFHandle dbffile, char **items, int numitems) {
+  int *itemindexes = NULL, i;
+
+  if (numitems == 0)
+    return (NULL);
+
+  itemindexes = (int *)malloc(sizeof(int) * numitems);
+  MS_CHECK_ALLOC(itemindexes, sizeof(int) * numitems, NULL);
+
+  for (i = 0; i < numitems; i++) {
+    itemindexes[i] = msDBFGetItemIndex(dbffile, items[i]);
+    if (itemindexes[i] == -1) {
+      free(itemindexes);
+      return (NULL); /* item not found */
+    }
+  }
+
+  return (itemindexes);
+}
+
+char **msDBFGetValueList(DBFHandle dbffile, int record, int *itemindexes,
+                         int numitems) {
+  const char *value;
+  char **values = NULL;
+  int i;
+
+  if (numitems == 0)
+    return (NULL);
+
+  values = (char **)malloc(sizeof(char *) * numitems);
+  MS_CHECK_ALLOC(values, sizeof(char *) * numitems, NULL);
+
+  for (i = 0; i < numitems; i++) {
+    value = msDBFReadStringAttribute(dbffile, record, itemindexes[i]);
+    if (value == NULL) {
+      free(values);
+      return NULL; /* Error already reported by msDBFReadStringAttribute() */
+    }
+    values[i] = msStrdup(value);
+  }
+
+  return (values);
+}
diff -pruN 8.0.1-5/src/mapxml.c 8.2.0~beta1-1~exp1/src/mapxml.c
--- 8.0.1-5/src/mapxml.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapxml.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,89 @@
+/******************************************************************************
+ * $id: mapfile.c 7854 2008-08-14 19:22:48Z dmorissette $
+ *
+ * Project:  MapServer
+ * Purpose:  High level Map file parsing code.
+ * Author:   Steve Lime and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+#include "mapserver.h"
+
+#ifdef USE_XMLMAPFILE
+
+#include <libxslt/xslt.h>
+#include "libexslt/exslt.h"
+#include <libxslt/transform.h>
+#include <libxslt/xsltInternals.h>
+#include <libxslt/extensions.h>
+#include <libxslt/xsltutils.h>
+
+extern int xmlLoadExtDtdDefaultValue;
+
+int msTransformXmlMapfile(const char *stylesheet, const char *xmlMapfile,
+                          FILE *tmpfile) {
+  xsltStylesheetPtr cur = NULL;
+  int status = MS_FAILURE;
+  xmlDocPtr doc = NULL, res = NULL;
+
+  exsltRegisterAll();
+  xsltRegisterTestModule();
+
+  cur = xsltParseStylesheetFile((const xmlChar *)stylesheet);
+  if (cur == NULL) {
+    msSetError(MS_MISCERR, "Failed to load xslt stylesheet",
+               "msTransformXmlMapfile()");
+    goto done;
+  }
+
+  doc = xmlReadFile(xmlMapfile, NULL, XML_PARSE_NOENT | XML_PARSE_DTDLOAD);
+  if (doc == NULL) {
+    msSetError(MS_MISCERR, "Failed to load xml mapfile",
+               "msTransformXmlMapfile()");
+    goto done;
+  }
+
+  res = xsltApplyStylesheet(cur, doc, NULL);
+  if (res == NULL) {
+    msSetError(MS_MISCERR, "Failed to apply style sheet to %s",
+               "msTransformXmlMapfile()", xmlMapfile);
+    goto done;
+  }
+
+  if (xsltSaveResultToFile(tmpfile, res, cur) != -1)
+    status = MS_SUCCESS;
+
+done:
+  if (cur)
+    xsltFreeStylesheet(cur);
+  if (res)
+    xmlFreeDoc(res);
+  if (doc)
+    xmlFreeDoc(doc);
+
+  xsltCleanupGlobals();
+  xmlCleanupParser();
+
+  return status;
+}
+
+#endif
diff -pruN 8.0.1-5/src/mapxmp.c 8.2.0~beta1-1~exp1/src/mapxmp.c
--- 8.0.1-5/src/mapxmp.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/mapxmp.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,283 @@
+/******************************************************************************
+ * $Id: mapchart.c 11880 2011-07-07 19:51:37Z sdlime $
+ *
+ * Project:  MapServer
+ * Purpose:  XMP embedded image metadata (MS-RFC-7X)
+ * Author:   Paul Ramsey <pramsey@opengeo.org>
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2007 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#include "mapserver.h"
+
+#ifdef USE_EXEMPI
+
+/* To pull parts out of hash keys */
+#include <regex.h>
+
+/* To write the XMP XML into the files */
+#include <xmp.h>
+#include <xmpconsts.h>
+
+/**
+ * Get standard Exempi namespace URI for a given namespace string
+ */
+static const char *msXmpUri(char *ns_name) {
+  /* Creative Commons */
+  if (strcmp(ns_name, "cc") == 0)
+    return NS_CC;
+  /* Dublin Core */
+  else if (strcmp(ns_name, "dc") == 0)
+    return NS_DC;
+  /* XMP Meta */
+  else if (strcmp(ns_name, "meta") == 0)
+    return NS_XMP_META;
+  /* XMP Rights */
+  else if (strcmp(ns_name, "rights") == 0)
+    return NS_XAP_RIGHTS;
+  /* EXIF */
+  else if (strcmp(ns_name, "exif") == 0)
+    return NS_EXIF;
+  /* TIFF */
+  else if (strcmp(ns_name, "tiff") == 0)
+    return NS_TIFF;
+  /* Photoshop Camera Raw Schema */
+  else if (strcmp(ns_name, "crs") == 0)
+    return NS_CAMERA_RAW_SETTINGS;
+  /* Photoshop */
+  else if (strcmp(ns_name, "photoshop") == 0)
+    return NS_PHOTOSHOP;
+  else
+    return NULL;
+}
+
+#endif
+
+/**
+ * Is there any XMP metadata in the map file for us to worry about?
+ */
+int msXmpPresent(mapObj *map) {
+#ifdef USE_EXEMPI
+
+  /* Read the WEB.METADATA */
+  hashTableObj hash_metadata = map->web.metadata;
+  const char *key = NULL;
+  int rv = MS_FALSE;
+
+  /* Check all the keys for "xmp_" start pattern */
+  key = msFirstKeyFromHashTable(&hash_metadata);
+
+  /* No first key? No license info. */
+  if (!key)
+    return MS_FALSE;
+
+  do {
+    /* Found one! Break out and return true */
+    if (strcasestr(key, "xmp_") == key) {
+      rv = MS_TRUE;
+      break;
+    }
+  } while ((key = msNextKeyFromHashTable(&hash_metadata, key)));
+
+  return rv;
+
+#else
+  return MS_FALSE;
+#endif
+}
+
+/**
+ * Is there any XMP metadata in the map file for us to worry about?
+ */
+int msXmpWrite(mapObj *map, const char *filename) {
+#ifdef USE_EXEMPI
+
+  /* Should hold our keys */
+  hashTableObj hash_metadata = map->web.metadata;
+  /* Temporary place for custom name spaces */
+  hashTableObj hash_ns;
+  /* We use regex to strip out the namespace and XMP key value from the metadata
+   * key */
+  regex_t xmp_regex;
+  const char *xmp_ns_str = "^xmp_(.+)_namespace$";
+  const char *xmp_tag_str = "^xmp_(.+)_(.+)$";
+  const char *key = NULL;
+  static int regflags = REG_ICASE | REG_EXTENDED;
+
+  /* XMP object and file pointers */
+  XmpPtr xmp;
+  XmpFilePtr f;
+
+  /* Force the hash table to empty */
+  hash_ns.numitems = 0;
+
+  /* Prepare XMP library */
+  xmp_init();
+  f = xmp_files_open_new(filename, XMP_OPEN_FORUPDATE);
+  if (!f) {
+    msSetError(MS_MISCERR,
+               "Unable to open temporary file '%s' to write XMP info",
+               "msXmpWrite()", filename);
+    return MS_FAILURE;
+  }
+
+  /* Create a new XMP structure if the file doesn't already have one */
+  xmp = xmp_files_get_new_xmp(f);
+  if (xmp == NULL)
+    xmp = xmp_new_empty();
+
+  /* Check we can write to the file */
+  if (!xmp_files_can_put_xmp(f, xmp)) {
+    msSetError(MS_MISCERR, "Unable to write XMP information to '%s'",
+               "msXmpWrite()", filename);
+    return MS_FAILURE;
+  }
+
+  /* Compile our "xmp_*_namespace" regex */
+  if (regcomp(&xmp_regex, xmp_ns_str, regflags)) {
+    msSetError(MS_MISCERR, "Unable compile regex '%s'", "msXmpWrite()",
+               xmp_ns_str);
+    return MS_FAILURE;
+  }
+
+  /* Check all the keys for "xmp_*_namespace" pattern */
+  initHashTable(&hash_ns);
+  key = msFirstKeyFromHashTable(&hash_metadata);
+
+  /* No first key? No license info. We shouldn't get here. */
+  if (!key)
+    return MS_SUCCESS;
+
+  do {
+    /* Our regex has one match slot */
+    regmatch_t matches[2];
+
+    /* Found a custom namespace entry! Store it for later. */
+    if (0 == regexec(&xmp_regex, key, 2, matches, 0)) {
+      size_t ns_size = 0;
+      char *ns_name = NULL;
+      const char *ns_uri;
+
+      /* Copy in the namespace name */
+      ns_size = matches[1].rm_eo - matches[1].rm_so;
+      ns_name = msSmallMalloc(ns_size + 1);
+      memcpy(ns_name, key + matches[1].rm_so, ns_size);
+      ns_name[ns_size] = 0; /* null terminate */
+
+      /* Copy in the namespace uri */
+      ns_uri = msLookupHashTable(&hash_metadata, key);
+      msInsertHashTable(&hash_ns, ns_name, ns_uri);
+      xmp_register_namespace(ns_uri, ns_name, NULL);
+      msFree(ns_name);
+    }
+  } while ((key = msNextKeyFromHashTable(&hash_metadata, key)));
+  /* Clean up regex */
+  regfree(&xmp_regex);
+
+  /* Compile our "xmp_*_*" regex */
+  if (regcomp(&xmp_regex, xmp_tag_str, regflags)) {
+    msFreeHashItems(&hash_ns);
+    msSetError(MS_MISCERR, "Unable compile regex '%s'", "msXmpWrite()",
+               xmp_tag_str);
+    return MS_FAILURE;
+  }
+
+  /* Check all the keys for "xmp_*_*" pattern */
+  key = msFirstKeyFromHashTable(&hash_metadata);
+  for (; key != NULL; key = msNextKeyFromHashTable(&hash_metadata, key)) {
+    /* Our regex has two match slots */
+    regmatch_t matches[3];
+
+    /* Found a namespace entry! Write it into XMP. */
+    if (0 == regexec(&xmp_regex, key, 3, matches, 0)) {
+      /* Get the namespace and tag name */
+      size_t ns_name_size = matches[1].rm_eo - matches[1].rm_so;
+      size_t ns_tag_size = matches[2].rm_eo - matches[2].rm_so;
+      char *ns_name = msSmallMalloc(ns_name_size + 1);
+      char *ns_tag = msSmallMalloc(ns_tag_size + 1);
+      const char *ns_uri = NULL;
+      memcpy(ns_name, key + matches[1].rm_so, ns_name_size);
+      memcpy(ns_tag, key + matches[2].rm_so, ns_tag_size);
+      ns_name[ns_name_size] = 0; /* null terminate */
+      ns_tag[ns_tag_size] = 0;   /* null terminate */
+
+      if (strcmp(ns_tag, "namespace") == 0) {
+        msFree(ns_name);
+        msFree(ns_tag);
+        continue;
+      }
+
+      /* If this is a default name space?... */
+      if ((ns_uri = msXmpUri(ns_name))) {
+        xmp_register_namespace(ns_uri, ns_name, NULL);
+        xmp_set_property(xmp, ns_uri, ns_tag,
+                         msLookupHashTable(&hash_metadata, key), 0);
+      }
+      /* Or maybe it's a custom one?... */
+      else if ((ns_uri = msLookupHashTable(&hash_ns, ns_name))) {
+        xmp_set_property(xmp, ns_uri, ns_tag,
+                         msLookupHashTable(&hash_metadata, key), 0);
+      }
+      /* Or perhaps we're screwed. */
+      else {
+        msSetError(MS_MISCERR,
+                   "Unable to identify XMP namespace '%s' in metadata key '%s'",
+                   "msXmpWrite()", ns_name, key);
+        msFreeHashItems(&hash_ns);
+        msFree(ns_name);
+        msFree(ns_tag);
+        return MS_FAILURE;
+      }
+      msFree(ns_name);
+      msFree(ns_tag);
+    }
+  }
+
+  /* Clean up regex */
+  regfree(&xmp_regex);
+
+  /* Write out the XMP */
+  if (!xmp_files_put_xmp(f, xmp)) {
+    msFreeHashItems(&hash_ns);
+    msSetError(MS_MISCERR, "Unable to execute '%s' on pointer %p",
+               "msXmpWrite()", "xmp_files_put_xmp", f);
+    return MS_FAILURE;
+  }
+
+  /* Write out the file and flush */
+  if (!xmp_files_close(f, XMP_CLOSE_SAFEUPDATE)) {
+    msFreeHashItems(&hash_ns);
+    msSetError(MS_MISCERR, "Unable to execute '%s' on pointer %p",
+               "msXmpWrite()", "xmp_files_close", f);
+    return MS_FAILURE;
+  }
+
+  msFreeHashItems(&hash_ns);
+  xmp_free(xmp);
+  xmp_terminate();
+
+  return MS_SUCCESS;
+
+#else
+  return MS_FAILURE;
+#endif
+}
diff -pruN 8.0.1-5/src/opengl/glext.h 8.2.0~beta1-1~exp1/src/opengl/glext.h
--- 8.0.1-5/src/opengl/glext.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/opengl/glext.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,6569 @@
+#ifndef __glext_h_
+#define __glext_h_
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+  /******************************************************************************
+
+   Copyright NVIDIA Corporation 2005
+
+   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
+   *AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
+   OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
+   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL
+   NVIDIA OR ITS SUPPLIERS BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR
+   CONSEQUENTIAL DAMAGES WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR
+   LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION,
+   OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE OF OR INABILITY TO USE
+   THIS SOFTWARE, EVEN IF NVIDIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+   DAMAGES.
+
+  ******************************************************************************/
+
+  /*
+  ** License Applicability. Except to the extent portions of this file are
+  ** made subject to an alternative license as permitted in the SGI Free
+  ** Software License B, Version 1.1 (the "License"), the contents of this
+  ** file are subject only to the provisions of the License. You may not use
+  ** this file except in compliance with the License. You may obtain a copy
+  ** of the License at Silicon Graphics, Inc., attn: Legal Services, 1600
+  ** Amphitheatre Parkway, Mountain View, CA 94043-1351, or at:
+  **
+  ** http://oss.sgi.com/projects/FreeB
+  **
+  ** Note that, as provided in the License, the Software is distributed on an
+  ** "AS IS" basis, with ALL EXPRESS AND IMPLIED WARRANTIES AND CONDITIONS
+  ** DISCLAIMED, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES AND
+  ** CONDITIONS OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A
+  ** PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
+  **
+  ** Original Code. The Original Code is: OpenGL Sample Implementation,
+  ** Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
+  ** Inc. The Original Code is Copyright (c) 1991-2004 Silicon Graphics, Inc.
+  ** Copyright in any portions created by third parties is as indicated
+  ** elsewhere herein. All Rights Reserved.
+  **
+  ** Additional Notice Provisions: This software was created using the
+  ** OpenGL(R) version 1.2.1 Sample Implementation published by SGI, but has
+  ** not been independently verified as being compliant with the OpenGL(R)
+  ** version 1.2.1 Specification.
+  */
+
+#if defined(_WIN32) && !defined(APIENTRY) && !defined(__CYGWIN__) && !defined(__SCITECH_SNAP__)
+#define WIN32_LEAN_AND_MEAN 1
+#include <windows.h>
+#endif
+
+#ifndef APIENTRY
+#define APIENTRY
+#endif
+#ifndef APIENTRYP
+#define APIENTRYP APIENTRY *
+#endif
+#ifndef GLAPI
+#define GLAPI extern
+#endif
+
+  /*************************************************************/
+
+  /* Header file version number, required by OpenGL ABI for Linux */
+  /* glext.h last updated 2005/06/06 */
+  /* Current version at http://oss.sgi.com/projects/ogl-sample/registry/ */
+#define GL_GLEXT_VERSION 28
+
+#ifndef GL_VERSION_1_2
+#define GL_UNSIGNED_BYTE_3_3_2            0x8032
+#define GL_UNSIGNED_SHORT_4_4_4_4         0x8033
+#define GL_UNSIGNED_SHORT_5_5_5_1         0x8034
+#define GL_UNSIGNED_INT_8_8_8_8           0x8035
+#define GL_UNSIGNED_INT_10_10_10_2        0x8036
+#define GL_RESCALE_NORMAL                 0x803A
+#define GL_TEXTURE_BINDING_3D             0x806A
+#define GL_PACK_SKIP_IMAGES               0x806B
+#define GL_PACK_IMAGE_HEIGHT              0x806C
+#define GL_UNPACK_SKIP_IMAGES             0x806D
+#define GL_UNPACK_IMAGE_HEIGHT            0x806E
+#define GL_TEXTURE_3D                     0x806F
+#define GL_PROXY_TEXTURE_3D               0x8070
+#define GL_TEXTURE_DEPTH                  0x8071
+#define GL_TEXTURE_WRAP_R                 0x8072
+#define GL_MAX_3D_TEXTURE_SIZE            0x8073
+#define GL_UNSIGNED_BYTE_2_3_3_REV        0x8362
+#define GL_UNSIGNED_SHORT_5_6_5           0x8363
+#define GL_UNSIGNED_SHORT_5_6_5_REV       0x8364
+#define GL_UNSIGNED_SHORT_4_4_4_4_REV     0x8365
+#define GL_UNSIGNED_SHORT_1_5_5_5_REV     0x8366
+#define GL_UNSIGNED_INT_8_8_8_8_REV       0x8367
+#define GL_UNSIGNED_INT_2_10_10_10_REV    0x8368
+#define GL_BGR                            0x80E0
+#define GL_BGRA                           0x80E1
+#define GL_MAX_ELEMENTS_VERTICES          0x80E8
+#define GL_MAX_ELEMENTS_INDICES           0x80E9
+#define GL_CLAMP_TO_EDGE                  0x812F
+#define GL_TEXTURE_MIN_LOD                0x813A
+#define GL_TEXTURE_MAX_LOD                0x813B
+#define GL_TEXTURE_BASE_LEVEL             0x813C
+#define GL_TEXTURE_MAX_LEVEL              0x813D
+#define GL_LIGHT_MODEL_COLOR_CONTROL      0x81F8
+#define GL_SINGLE_COLOR                   0x81F9
+#define GL_SEPARATE_SPECULAR_COLOR        0x81FA
+#define GL_SMOOTH_POINT_SIZE_RANGE        0x0B12
+#define GL_SMOOTH_POINT_SIZE_GRANULARITY  0x0B13
+#define GL_SMOOTH_LINE_WIDTH_RANGE        0x0B22
+#define GL_SMOOTH_LINE_WIDTH_GRANULARITY  0x0B23
+#define GL_ALIASED_POINT_SIZE_RANGE       0x846D
+#define GL_ALIASED_LINE_WIDTH_RANGE       0x846E
+#endif
+
+#ifndef GL_ARB_imaging
+#define GL_CONSTANT_COLOR                 0x8001
+#define GL_ONE_MINUS_CONSTANT_COLOR       0x8002
+#define GL_CONSTANT_ALPHA                 0x8003
+#define GL_ONE_MINUS_CONSTANT_ALPHA       0x8004
+#define GL_BLEND_COLOR                    0x8005
+#define GL_FUNC_ADD                       0x8006
+#define GL_MIN                            0x8007
+#define GL_MAX                            0x8008
+#define GL_BLEND_EQUATION                 0x8009
+#define GL_FUNC_SUBTRACT                  0x800A
+#define GL_FUNC_REVERSE_SUBTRACT          0x800B
+#define GL_CONVOLUTION_1D                 0x8010
+#define GL_CONVOLUTION_2D                 0x8011
+#define GL_SEPARABLE_2D                   0x8012
+#define GL_CONVOLUTION_BORDER_MODE        0x8013
+#define GL_CONVOLUTION_FILTER_SCALE       0x8014
+#define GL_CONVOLUTION_FILTER_BIAS        0x8015
+#define GL_REDUCE                         0x8016
+#define GL_CONVOLUTION_FORMAT             0x8017
+#define GL_CONVOLUTION_WIDTH              0x8018
+#define GL_CONVOLUTION_HEIGHT             0x8019
+#define GL_MAX_CONVOLUTION_WIDTH          0x801A
+#define GL_MAX_CONVOLUTION_HEIGHT         0x801B
+#define GL_POST_CONVOLUTION_RED_SCALE     0x801C
+#define GL_POST_CONVOLUTION_GREEN_SCALE   0x801D
+#define GL_POST_CONVOLUTION_BLUE_SCALE    0x801E
+#define GL_POST_CONVOLUTION_ALPHA_SCALE   0x801F
+#define GL_POST_CONVOLUTION_RED_BIAS      0x8020
+#define GL_POST_CONVOLUTION_GREEN_BIAS    0x8021
+#define GL_POST_CONVOLUTION_BLUE_BIAS     0x8022
+#define GL_POST_CONVOLUTION_ALPHA_BIAS    0x8023
+#define GL_HISTOGRAM                      0x8024
+#define GL_PROXY_HISTOGRAM                0x8025
+#define GL_HISTOGRAM_WIDTH                0x8026
+#define GL_HISTOGRAM_FORMAT               0x8027
+#define GL_HISTOGRAM_RED_SIZE             0x8028
+#define GL_HISTOGRAM_GREEN_SIZE           0x8029
+#define GL_HISTOGRAM_BLUE_SIZE            0x802A
+#define GL_HISTOGRAM_ALPHA_SIZE           0x802B
+#define GL_HISTOGRAM_LUMINANCE_SIZE       0x802C
+#define GL_HISTOGRAM_SINK                 0x802D
+#define GL_MINMAX                         0x802E
+#define GL_MINMAX_FORMAT                  0x802F
+#define GL_MINMAX_SINK                    0x8030
+#define GL_TABLE_TOO_LARGE                0x8031
+#define GL_COLOR_MATRIX                   0x80B1
+#define GL_COLOR_MATRIX_STACK_DEPTH       0x80B2
+#define GL_MAX_COLOR_MATRIX_STACK_DEPTH   0x80B3
+#define GL_POST_COLOR_MATRIX_RED_SCALE    0x80B4
+#define GL_POST_COLOR_MATRIX_GREEN_SCALE  0x80B5
+#define GL_POST_COLOR_MATRIX_BLUE_SCALE   0x80B6
+#define GL_POST_COLOR_MATRIX_ALPHA_SCALE  0x80B7
+#define GL_POST_COLOR_MATRIX_RED_BIAS     0x80B8
+#define GL_POST_COLOR_MATRIX_GREEN_BIAS   0x80B9
+#define GL_POST_COLOR_MATRIX_BLUE_BIAS    0x80BA
+#define GL_POST_COLOR_MATRIX_ALPHA_BIAS   0x80BB
+#define GL_COLOR_TABLE                    0x80D0
+#define GL_POST_CONVOLUTION_COLOR_TABLE   0x80D1
+#define GL_POST_COLOR_MATRIX_COLOR_TABLE  0x80D2
+#define GL_PROXY_COLOR_TABLE              0x80D3
+#define GL_PROXY_POST_CONVOLUTION_COLOR_TABLE 0x80D4
+#define GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE 0x80D5
+#define GL_COLOR_TABLE_SCALE              0x80D6
+#define GL_COLOR_TABLE_BIAS               0x80D7
+#define GL_COLOR_TABLE_FORMAT             0x80D8
+#define GL_COLOR_TABLE_WIDTH              0x80D9
+#define GL_COLOR_TABLE_RED_SIZE           0x80DA
+#define GL_COLOR_TABLE_GREEN_SIZE         0x80DB
+#define GL_COLOR_TABLE_BLUE_SIZE          0x80DC
+#define GL_COLOR_TABLE_ALPHA_SIZE         0x80DD
+#define GL_COLOR_TABLE_LUMINANCE_SIZE     0x80DE
+#define GL_COLOR_TABLE_INTENSITY_SIZE     0x80DF
+#define GL_CONSTANT_BORDER                0x8151
+#define GL_REPLICATE_BORDER               0x8153
+#define GL_CONVOLUTION_BORDER_COLOR       0x8154
+#endif
+
+#ifndef GL_VERSION_1_3
+#define GL_TEXTURE0                       0x84C0
+#define GL_TEXTURE1                       0x84C1
+#define GL_TEXTURE2                       0x84C2
+#define GL_TEXTURE3                       0x84C3
+#define GL_TEXTURE4                       0x84C4
+#define GL_TEXTURE5                       0x84C5
+#define GL_TEXTURE6                       0x84C6
+#define GL_TEXTURE7                       0x84C7
+#define GL_TEXTURE8                       0x84C8
+#define GL_TEXTURE9                       0x84C9
+#define GL_TEXTURE10                      0x84CA
+#define GL_TEXTURE11                      0x84CB
+#define GL_TEXTURE12                      0x84CC
+#define GL_TEXTURE13                      0x84CD
+#define GL_TEXTURE14                      0x84CE
+#define GL_TEXTURE15                      0x84CF
+#define GL_TEXTURE16                      0x84D0
+#define GL_TEXTURE17                      0x84D1
+#define GL_TEXTURE18                      0x84D2
+#define GL_TEXTURE19                      0x84D3
+#define GL_TEXTURE20                      0x84D4
+#define GL_TEXTURE21                      0x84D5
+#define GL_TEXTURE22                      0x84D6
+#define GL_TEXTURE23                      0x84D7
+#define GL_TEXTURE24                      0x84D8
+#define GL_TEXTURE25                      0x84D9
+#define GL_TEXTURE26                      0x84DA
+#define GL_TEXTURE27                      0x84DB
+#define GL_TEXTURE28                      0x84DC
+#define GL_TEXTURE29                      0x84DD
+#define GL_TEXTURE30                      0x84DE
+#define GL_TEXTURE31                      0x84DF
+#define GL_ACTIVE_TEXTURE                 0x84E0
+#define GL_CLIENT_ACTIVE_TEXTURE          0x84E1
+#define GL_MAX_TEXTURE_UNITS              0x84E2
+#define GL_TRANSPOSE_MODELVIEW_MATRIX     0x84E3
+#define GL_TRANSPOSE_PROJECTION_MATRIX    0x84E4
+#define GL_TRANSPOSE_TEXTURE_MATRIX       0x84E5
+#define GL_TRANSPOSE_COLOR_MATRIX         0x84E6
+#define GL_MULTISAMPLE                    0x809D
+#define GL_SAMPLE_ALPHA_TO_COVERAGE       0x809E
+#define GL_SAMPLE_ALPHA_TO_ONE            0x809F
+#define GL_SAMPLE_COVERAGE                0x80A0
+#define GL_SAMPLE_BUFFERS                 0x80A8
+#define GL_SAMPLES                        0x80A9
+#define GL_SAMPLE_COVERAGE_VALUE          0x80AA
+#define GL_SAMPLE_COVERAGE_INVERT         0x80AB
+#define GL_MULTISAMPLE_BIT                0x20000000
+#define GL_NORMAL_MAP                     0x8511
+#define GL_REFLECTION_MAP                 0x8512
+#define GL_TEXTURE_CUBE_MAP               0x8513
+#define GL_TEXTURE_BINDING_CUBE_MAP       0x8514
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_X    0x8515
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X    0x8516
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y    0x8517
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y    0x8518
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z    0x8519
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z    0x851A
+#define GL_PROXY_TEXTURE_CUBE_MAP         0x851B
+#define GL_MAX_CUBE_MAP_TEXTURE_SIZE      0x851C
+#define GL_COMPRESSED_ALPHA               0x84E9
+#define GL_COMPRESSED_LUMINANCE           0x84EA
+#define GL_COMPRESSED_LUMINANCE_ALPHA     0x84EB
+#define GL_COMPRESSED_INTENSITY           0x84EC
+#define GL_COMPRESSED_RGB                 0x84ED
+#define GL_COMPRESSED_RGBA                0x84EE
+#define GL_TEXTURE_COMPRESSION_HINT       0x84EF
+#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE  0x86A0
+#define GL_TEXTURE_COMPRESSED             0x86A1
+#define GL_NUM_COMPRESSED_TEXTURE_FORMATS 0x86A2
+#define GL_COMPRESSED_TEXTURE_FORMATS     0x86A3
+#define GL_CLAMP_TO_BORDER                0x812D
+#define GL_COMBINE                        0x8570
+#define GL_COMBINE_RGB                    0x8571
+#define GL_COMBINE_ALPHA                  0x8572
+#define GL_SOURCE0_RGB                    0x8580
+#define GL_SOURCE1_RGB                    0x8581
+#define GL_SOURCE2_RGB                    0x8582
+#define GL_SOURCE0_ALPHA                  0x8588
+#define GL_SOURCE1_ALPHA                  0x8589
+#define GL_SOURCE2_ALPHA                  0x858A
+#define GL_OPERAND0_RGB                   0x8590
+#define GL_OPERAND1_RGB                   0x8591
+#define GL_OPERAND2_RGB                   0x8592
+#define GL_OPERAND0_ALPHA                 0x8598
+#define GL_OPERAND1_ALPHA                 0x8599
+#define GL_OPERAND2_ALPHA                 0x859A
+#define GL_RGB_SCALE                      0x8573
+#define GL_ADD_SIGNED                     0x8574
+#define GL_INTERPOLATE                    0x8575
+#define GL_SUBTRACT                       0x84E7
+#define GL_CONSTANT                       0x8576
+#define GL_PRIMARY_COLOR                  0x8577
+#define GL_PREVIOUS                       0x8578
+#define GL_DOT3_RGB                       0x86AE
+#define GL_DOT3_RGBA                      0x86AF
+#endif
+
+#ifndef GL_VERSION_1_4
+#define GL_BLEND_DST_RGB                  0x80C8
+#define GL_BLEND_SRC_RGB                  0x80C9
+#define GL_BLEND_DST_ALPHA                0x80CA
+#define GL_BLEND_SRC_ALPHA                0x80CB
+#define GL_POINT_SIZE_MIN                 0x8126
+#define GL_POINT_SIZE_MAX                 0x8127
+#define GL_POINT_FADE_THRESHOLD_SIZE      0x8128
+#define GL_POINT_DISTANCE_ATTENUATION     0x8129
+#define GL_GENERATE_MIPMAP                0x8191
+#define GL_GENERATE_MIPMAP_HINT           0x8192
+#define GL_DEPTH_COMPONENT16              0x81A5
+#define GL_DEPTH_COMPONENT24              0x81A6
+#define GL_DEPTH_COMPONENT32              0x81A7
+#define GL_MIRRORED_REPEAT                0x8370
+#define GL_FOG_COORDINATE_SOURCE          0x8450
+#define GL_FOG_COORDINATE                 0x8451
+#define GL_FRAGMENT_DEPTH                 0x8452
+#define GL_CURRENT_FOG_COORDINATE         0x8453
+#define GL_FOG_COORDINATE_ARRAY_TYPE      0x8454
+#define GL_FOG_COORDINATE_ARRAY_STRIDE    0x8455
+#define GL_FOG_COORDINATE_ARRAY_POINTER   0x8456
+#define GL_FOG_COORDINATE_ARRAY           0x8457
+#define GL_COLOR_SUM                      0x8458
+#define GL_CURRENT_SECONDARY_COLOR        0x8459
+#define GL_SECONDARY_COLOR_ARRAY_SIZE     0x845A
+#define GL_SECONDARY_COLOR_ARRAY_TYPE     0x845B
+#define GL_SECONDARY_COLOR_ARRAY_STRIDE   0x845C
+#define GL_SECONDARY_COLOR_ARRAY_POINTER  0x845D
+#define GL_SECONDARY_COLOR_ARRAY          0x845E
+#define GL_MAX_TEXTURE_LOD_BIAS           0x84FD
+#define GL_TEXTURE_FILTER_CONTROL         0x8500
+#define GL_TEXTURE_LOD_BIAS               0x8501
+#define GL_INCR_WRAP                      0x8507
+#define GL_DECR_WRAP                      0x8508
+#define GL_TEXTURE_DEPTH_SIZE             0x884A
+#define GL_DEPTH_TEXTURE_MODE             0x884B
+#define GL_TEXTURE_COMPARE_MODE           0x884C
+#define GL_TEXTURE_COMPARE_FUNC           0x884D
+#define GL_COMPARE_R_TO_TEXTURE           0x884E
+#endif
+
+#ifndef GL_VERSION_1_5
+#define GL_BUFFER_SIZE                    0x8764
+#define GL_BUFFER_USAGE                   0x8765
+#define GL_QUERY_COUNTER_BITS             0x8864
+#define GL_CURRENT_QUERY                  0x8865
+#define GL_QUERY_RESULT                   0x8866
+#define GL_QUERY_RESULT_AVAILABLE         0x8867
+#define GL_ARRAY_BUFFER                   0x8892
+#define GL_ELEMENT_ARRAY_BUFFER           0x8893
+#define GL_ARRAY_BUFFER_BINDING           0x8894
+#define GL_ELEMENT_ARRAY_BUFFER_BINDING   0x8895
+#define GL_VERTEX_ARRAY_BUFFER_BINDING    0x8896
+#define GL_NORMAL_ARRAY_BUFFER_BINDING    0x8897
+#define GL_COLOR_ARRAY_BUFFER_BINDING     0x8898
+#define GL_INDEX_ARRAY_BUFFER_BINDING     0x8899
+#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING 0x889A
+#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING 0x889B
+#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING 0x889C
+#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING 0x889D
+#define GL_WEIGHT_ARRAY_BUFFER_BINDING    0x889E
+#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING 0x889F
+#define GL_READ_ONLY                      0x88B8
+#define GL_WRITE_ONLY                     0x88B9
+#define GL_READ_WRITE                     0x88BA
+#define GL_BUFFER_ACCESS                  0x88BB
+#define GL_BUFFER_MAPPED                  0x88BC
+#define GL_BUFFER_MAP_POINTER             0x88BD
+#define GL_STREAM_DRAW                    0x88E0
+#define GL_STREAM_READ                    0x88E1
+#define GL_STREAM_COPY                    0x88E2
+#define GL_STATIC_DRAW                    0x88E4
+#define GL_STATIC_READ                    0x88E5
+#define GL_STATIC_COPY                    0x88E6
+#define GL_DYNAMIC_DRAW                   0x88E8
+#define GL_DYNAMIC_READ                   0x88E9
+#define GL_DYNAMIC_COPY                   0x88EA
+#define GL_SAMPLES_PASSED                 0x8914
+#define GL_FOG_COORD_SRC                  GL_FOG_COORDINATE_SOURCE
+#define GL_FOG_COORD                      GL_FOG_COORDINATE
+#define GL_CURRENT_FOG_COORD              GL_CURRENT_FOG_COORDINATE
+#define GL_FOG_COORD_ARRAY_TYPE           GL_FOG_COORDINATE_ARRAY_TYPE
+#define GL_FOG_COORD_ARRAY_STRIDE         GL_FOG_COORDINATE_ARRAY_STRIDE
+#define GL_FOG_COORD_ARRAY_POINTER        GL_FOG_COORDINATE_ARRAY_POINTER
+#define GL_FOG_COORD_ARRAY                GL_FOG_COORDINATE_ARRAY
+#define GL_FOG_COORD_ARRAY_BUFFER_BINDING GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING
+#define GL_SRC0_RGB                       GL_SOURCE0_RGB
+#define GL_SRC1_RGB                       GL_SOURCE1_RGB
+#define GL_SRC2_RGB                       GL_SOURCE2_RGB
+#define GL_SRC0_ALPHA                     GL_SOURCE0_ALPHA
+#define GL_SRC1_ALPHA                     GL_SOURCE1_ALPHA
+#define GL_SRC2_ALPHA                     GL_SOURCE2_ALPHA
+#endif
+
+#ifndef GL_VERSION_2_0
+#define GL_BLEND_EQUATION_RGB             GL_BLEND_EQUATION
+#define GL_VERTEX_ATTRIB_ARRAY_ENABLED    0x8622
+#define GL_VERTEX_ATTRIB_ARRAY_SIZE       0x8623
+#define GL_VERTEX_ATTRIB_ARRAY_STRIDE     0x8624
+#define GL_VERTEX_ATTRIB_ARRAY_TYPE       0x8625
+#define GL_CURRENT_VERTEX_ATTRIB          0x8626
+#define GL_VERTEX_PROGRAM_POINT_SIZE      0x8642
+#define GL_VERTEX_PROGRAM_TWO_SIDE        0x8643
+#define GL_VERTEX_ATTRIB_ARRAY_POINTER    0x8645
+#define GL_STENCIL_BACK_FUNC              0x8800
+#define GL_STENCIL_BACK_FAIL              0x8801
+#define GL_STENCIL_BACK_PASS_DEPTH_FAIL   0x8802
+#define GL_STENCIL_BACK_PASS_DEPTH_PASS   0x8803
+#define GL_MAX_DRAW_BUFFERS               0x8824
+#define GL_DRAW_BUFFER0                   0x8825
+#define GL_DRAW_BUFFER1                   0x8826
+#define GL_DRAW_BUFFER2                   0x8827
+#define GL_DRAW_BUFFER3                   0x8828
+#define GL_DRAW_BUFFER4                   0x8829
+#define GL_DRAW_BUFFER5                   0x882A
+#define GL_DRAW_BUFFER6                   0x882B
+#define GL_DRAW_BUFFER7                   0x882C
+#define GL_DRAW_BUFFER8                   0x882D
+#define GL_DRAW_BUFFER9                   0x882E
+#define GL_DRAW_BUFFER10                  0x882F
+#define GL_DRAW_BUFFER11                  0x8830
+#define GL_DRAW_BUFFER12                  0x8831
+#define GL_DRAW_BUFFER13                  0x8832
+#define GL_DRAW_BUFFER14                  0x8833
+#define GL_DRAW_BUFFER15                  0x8834
+#define GL_BLEND_EQUATION_ALPHA           0x883D
+#define GL_POINT_SPRITE                   0x8861
+#define GL_COORD_REPLACE                  0x8862
+#define GL_MAX_VERTEX_ATTRIBS             0x8869
+#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED 0x886A
+#define GL_MAX_TEXTURE_COORDS             0x8871
+#define GL_MAX_TEXTURE_IMAGE_UNITS        0x8872
+#define GL_FRAGMENT_SHADER                0x8B30
+#define GL_VERTEX_SHADER                  0x8B31
+#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS 0x8B49
+#define GL_MAX_VERTEX_UNIFORM_COMPONENTS  0x8B4A
+#define GL_MAX_VARYING_FLOATS             0x8B4B
+#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS 0x8B4C
+#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS 0x8B4D
+#define GL_SHADER_TYPE                    0x8B4F
+#define GL_FLOAT_VEC2                     0x8B50
+#define GL_FLOAT_VEC3                     0x8B51
+#define GL_FLOAT_VEC4                     0x8B52
+#define GL_INT_VEC2                       0x8B53
+#define GL_INT_VEC3                       0x8B54
+#define GL_INT_VEC4                       0x8B55
+#define GL_BOOL                           0x8B56
+#define GL_BOOL_VEC2                      0x8B57
+#define GL_BOOL_VEC3                      0x8B58
+#define GL_BOOL_VEC4                      0x8B59
+#define GL_FLOAT_MAT2                     0x8B5A
+#define GL_FLOAT_MAT3                     0x8B5B
+#define GL_FLOAT_MAT4                     0x8B5C
+#define GL_SAMPLER_1D                     0x8B5D
+#define GL_SAMPLER_2D                     0x8B5E
+#define GL_SAMPLER_3D                     0x8B5F
+#define GL_SAMPLER_CUBE                   0x8B60
+#define GL_SAMPLER_1D_SHADOW              0x8B61
+#define GL_SAMPLER_2D_SHADOW              0x8B62
+#define GL_DELETE_STATUS                  0x8B80
+#define GL_COMPILE_STATUS                 0x8B81
+#define GL_LINK_STATUS                    0x8B82
+#define GL_VALIDATE_STATUS                0x8B83
+#define GL_INFO_LOG_LENGTH                0x8B84
+#define GL_ATTACHED_SHADERS               0x8B85
+#define GL_ACTIVE_UNIFORMS                0x8B86
+#define GL_ACTIVE_UNIFORM_MAX_LENGTH      0x8B87
+#define GL_SHADER_SOURCE_LENGTH           0x8B88
+#define GL_ACTIVE_ATTRIBUTES              0x8B89
+#define GL_ACTIVE_ATTRIBUTE_MAX_LENGTH    0x8B8A
+#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT 0x8B8B
+#define GL_SHADING_LANGUAGE_VERSION       0x8B8C
+#define GL_CURRENT_PROGRAM                0x8B8D
+#define GL_POINT_SPRITE_COORD_ORIGIN      0x8CA0
+#define GL_LOWER_LEFT                     0x8CA1
+#define GL_UPPER_LEFT                     0x8CA2
+#define GL_STENCIL_BACK_REF               0x8CA3
+#define GL_STENCIL_BACK_VALUE_MASK        0x8CA4
+#define GL_STENCIL_BACK_WRITEMASK         0x8CA5
+#endif
+
+#ifndef GL_ARB_multitexture
+#define GL_TEXTURE0_ARB                   0x84C0
+#define GL_TEXTURE1_ARB                   0x84C1
+#define GL_TEXTURE2_ARB                   0x84C2
+#define GL_TEXTURE3_ARB                   0x84C3
+#define GL_TEXTURE4_ARB                   0x84C4
+#define GL_TEXTURE5_ARB                   0x84C5
+#define GL_TEXTURE6_ARB                   0x84C6
+#define GL_TEXTURE7_ARB                   0x84C7
+#define GL_TEXTURE8_ARB                   0x84C8
+#define GL_TEXTURE9_ARB                   0x84C9
+#define GL_TEXTURE10_ARB                  0x84CA
+#define GL_TEXTURE11_ARB                  0x84CB
+#define GL_TEXTURE12_ARB                  0x84CC
+#define GL_TEXTURE13_ARB                  0x84CD
+#define GL_TEXTURE14_ARB                  0x84CE
+#define GL_TEXTURE15_ARB                  0x84CF
+#define GL_TEXTURE16_ARB                  0x84D0
+#define GL_TEXTURE17_ARB                  0x84D1
+#define GL_TEXTURE18_ARB                  0x84D2
+#define GL_TEXTURE19_ARB                  0x84D3
+#define GL_TEXTURE20_ARB                  0x84D4
+#define GL_TEXTURE21_ARB                  0x84D5
+#define GL_TEXTURE22_ARB                  0x84D6
+#define GL_TEXTURE23_ARB                  0x84D7
+#define GL_TEXTURE24_ARB                  0x84D8
+#define GL_TEXTURE25_ARB                  0x84D9
+#define GL_TEXTURE26_ARB                  0x84DA
+#define GL_TEXTURE27_ARB                  0x84DB
+#define GL_TEXTURE28_ARB                  0x84DC
+#define GL_TEXTURE29_ARB                  0x84DD
+#define GL_TEXTURE30_ARB                  0x84DE
+#define GL_TEXTURE31_ARB                  0x84DF
+#define GL_ACTIVE_TEXTURE_ARB             0x84E0
+#define GL_CLIENT_ACTIVE_TEXTURE_ARB      0x84E1
+#define GL_MAX_TEXTURE_UNITS_ARB          0x84E2
+#endif
+
+#ifndef GL_ARB_transpose_matrix
+#define GL_TRANSPOSE_MODELVIEW_MATRIX_ARB 0x84E3
+#define GL_TRANSPOSE_PROJECTION_MATRIX_ARB 0x84E4
+#define GL_TRANSPOSE_TEXTURE_MATRIX_ARB   0x84E5
+#define GL_TRANSPOSE_COLOR_MATRIX_ARB     0x84E6
+#endif
+
+#ifndef GL_ARB_multisample
+#define GL_MULTISAMPLE_ARB                0x809D
+#define GL_SAMPLE_ALPHA_TO_COVERAGE_ARB   0x809E
+#define GL_SAMPLE_ALPHA_TO_ONE_ARB        0x809F
+#define GL_SAMPLE_COVERAGE_ARB            0x80A0
+#define GL_SAMPLE_BUFFERS_ARB             0x80A8
+#define GL_SAMPLES_ARB                    0x80A9
+#define GL_SAMPLE_COVERAGE_VALUE_ARB      0x80AA
+#define GL_SAMPLE_COVERAGE_INVERT_ARB     0x80AB
+#define GL_MULTISAMPLE_BIT_ARB            0x20000000
+#endif
+
+#ifndef GL_ARB_texture_env_add
+#endif
+
+#ifndef GL_ARB_texture_cube_map
+#define GL_NORMAL_MAP_ARB                 0x8511
+#define GL_REFLECTION_MAP_ARB             0x8512
+#define GL_TEXTURE_CUBE_MAP_ARB           0x8513
+#define GL_TEXTURE_BINDING_CUBE_MAP_ARB   0x8514
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB 0x8515
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB 0x8516
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB 0x8517
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB 0x8518
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB 0x8519
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB 0x851A
+#define GL_PROXY_TEXTURE_CUBE_MAP_ARB     0x851B
+#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB  0x851C
+#endif
+
+#ifndef GL_ARB_texture_compression
+#define GL_COMPRESSED_ALPHA_ARB           0x84E9
+#define GL_COMPRESSED_LUMINANCE_ARB       0x84EA
+#define GL_COMPRESSED_LUMINANCE_ALPHA_ARB 0x84EB
+#define GL_COMPRESSED_INTENSITY_ARB       0x84EC
+#define GL_COMPRESSED_RGB_ARB             0x84ED
+#define GL_COMPRESSED_RGBA_ARB            0x84EE
+#define GL_TEXTURE_COMPRESSION_HINT_ARB   0x84EF
+#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB 0x86A0
+#define GL_TEXTURE_COMPRESSED_ARB         0x86A1
+#define GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB 0x86A2
+#define GL_COMPRESSED_TEXTURE_FORMATS_ARB 0x86A3
+#endif
+
+#ifndef GL_ARB_texture_border_clamp
+#define GL_CLAMP_TO_BORDER_ARB            0x812D
+#endif
+
+#ifndef GL_ARB_point_parameters
+#define GL_POINT_SIZE_MIN_ARB             0x8126
+#define GL_POINT_SIZE_MAX_ARB             0x8127
+#define GL_POINT_FADE_THRESHOLD_SIZE_ARB  0x8128
+#define GL_POINT_DISTANCE_ATTENUATION_ARB 0x8129
+#endif
+
+#ifndef GL_ARB_vertex_blend
+#define GL_MAX_VERTEX_UNITS_ARB           0x86A4
+#define GL_ACTIVE_VERTEX_UNITS_ARB        0x86A5
+#define GL_WEIGHT_SUM_UNITY_ARB           0x86A6
+#define GL_VERTEX_BLEND_ARB               0x86A7
+#define GL_CURRENT_WEIGHT_ARB             0x86A8
+#define GL_WEIGHT_ARRAY_TYPE_ARB          0x86A9
+#define GL_WEIGHT_ARRAY_STRIDE_ARB        0x86AA
+#define GL_WEIGHT_ARRAY_SIZE_ARB          0x86AB
+#define GL_WEIGHT_ARRAY_POINTER_ARB       0x86AC
+#define GL_WEIGHT_ARRAY_ARB               0x86AD
+#define GL_MODELVIEW0_ARB                 0x1700
+#define GL_MODELVIEW1_ARB                 0x850A
+#define GL_MODELVIEW2_ARB                 0x8722
+#define GL_MODELVIEW3_ARB                 0x8723
+#define GL_MODELVIEW4_ARB                 0x8724
+#define GL_MODELVIEW5_ARB                 0x8725
+#define GL_MODELVIEW6_ARB                 0x8726
+#define GL_MODELVIEW7_ARB                 0x8727
+#define GL_MODELVIEW8_ARB                 0x8728
+#define GL_MODELVIEW9_ARB                 0x8729
+#define GL_MODELVIEW10_ARB                0x872A
+#define GL_MODELVIEW11_ARB                0x872B
+#define GL_MODELVIEW12_ARB                0x872C
+#define GL_MODELVIEW13_ARB                0x872D
+#define GL_MODELVIEW14_ARB                0x872E
+#define GL_MODELVIEW15_ARB                0x872F
+#define GL_MODELVIEW16_ARB                0x8730
+#define GL_MODELVIEW17_ARB                0x8731
+#define GL_MODELVIEW18_ARB                0x8732
+#define GL_MODELVIEW19_ARB                0x8733
+#define GL_MODELVIEW20_ARB                0x8734
+#define GL_MODELVIEW21_ARB                0x8735
+#define GL_MODELVIEW22_ARB                0x8736
+#define GL_MODELVIEW23_ARB                0x8737
+#define GL_MODELVIEW24_ARB                0x8738
+#define GL_MODELVIEW25_ARB                0x8739
+#define GL_MODELVIEW26_ARB                0x873A
+#define GL_MODELVIEW27_ARB                0x873B
+#define GL_MODELVIEW28_ARB                0x873C
+#define GL_MODELVIEW29_ARB                0x873D
+#define GL_MODELVIEW30_ARB                0x873E
+#define GL_MODELVIEW31_ARB                0x873F
+#endif
+
+#ifndef GL_ARB_matrix_palette
+#define GL_MATRIX_PALETTE_ARB             0x8840
+#define GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB 0x8841
+#define GL_MAX_PALETTE_MATRICES_ARB       0x8842
+#define GL_CURRENT_PALETTE_MATRIX_ARB     0x8843
+#define GL_MATRIX_INDEX_ARRAY_ARB         0x8844
+#define GL_CURRENT_MATRIX_INDEX_ARB       0x8845
+#define GL_MATRIX_INDEX_ARRAY_SIZE_ARB    0x8846
+#define GL_MATRIX_INDEX_ARRAY_TYPE_ARB    0x8847
+#define GL_MATRIX_INDEX_ARRAY_STRIDE_ARB  0x8848
+#define GL_MATRIX_INDEX_ARRAY_POINTER_ARB 0x8849
+#endif
+
+#ifndef GL_ARB_texture_env_combine
+#define GL_COMBINE_ARB                    0x8570
+#define GL_COMBINE_RGB_ARB                0x8571
+#define GL_COMBINE_ALPHA_ARB              0x8572
+#define GL_SOURCE0_RGB_ARB                0x8580
+#define GL_SOURCE1_RGB_ARB                0x8581
+#define GL_SOURCE2_RGB_ARB                0x8582
+#define GL_SOURCE0_ALPHA_ARB              0x8588
+#define GL_SOURCE1_ALPHA_ARB              0x8589
+#define GL_SOURCE2_ALPHA_ARB              0x858A
+#define GL_OPERAND0_RGB_ARB               0x8590
+#define GL_OPERAND1_RGB_ARB               0x8591
+#define GL_OPERAND2_RGB_ARB               0x8592
+#define GL_OPERAND0_ALPHA_ARB             0x8598
+#define GL_OPERAND1_ALPHA_ARB             0x8599
+#define GL_OPERAND2_ALPHA_ARB             0x859A
+#define GL_RGB_SCALE_ARB                  0x8573
+#define GL_ADD_SIGNED_ARB                 0x8574
+#define GL_INTERPOLATE_ARB                0x8575
+#define GL_SUBTRACT_ARB                   0x84E7
+#define GL_CONSTANT_ARB                   0x8576
+#define GL_PRIMARY_COLOR_ARB              0x8577
+#define GL_PREVIOUS_ARB                   0x8578
+#endif
+
+#ifndef GL_ARB_texture_env_crossbar
+#endif
+
+#ifndef GL_ARB_texture_env_dot3
+#define GL_DOT3_RGB_ARB                   0x86AE
+#define GL_DOT3_RGBA_ARB                  0x86AF
+#endif
+
+#ifndef GL_ARB_texture_mirrored_repeat
+#define GL_MIRRORED_REPEAT_ARB            0x8370
+#endif
+
+#ifndef GL_ARB_depth_texture
+#define GL_DEPTH_COMPONENT16_ARB          0x81A5
+#define GL_DEPTH_COMPONENT24_ARB          0x81A6
+#define GL_DEPTH_COMPONENT32_ARB          0x81A7
+#define GL_TEXTURE_DEPTH_SIZE_ARB         0x884A
+#define GL_DEPTH_TEXTURE_MODE_ARB         0x884B
+#endif
+
+#ifndef GL_ARB_shadow
+#define GL_TEXTURE_COMPARE_MODE_ARB       0x884C
+#define GL_TEXTURE_COMPARE_FUNC_ARB       0x884D
+#define GL_COMPARE_R_TO_TEXTURE_ARB       0x884E
+#endif
+
+#ifndef GL_ARB_shadow_ambient
+#define GL_TEXTURE_COMPARE_FAIL_VALUE_ARB 0x80BF
+#endif
+
+#ifndef GL_ARB_window_pos
+#endif
+
+#ifndef GL_ARB_vertex_program
+#define GL_COLOR_SUM_ARB                  0x8458
+#define GL_VERTEX_PROGRAM_ARB             0x8620
+#define GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB 0x8622
+#define GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB   0x8623
+#define GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB 0x8624
+#define GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB   0x8625
+#define GL_CURRENT_VERTEX_ATTRIB_ARB      0x8626
+#define GL_PROGRAM_LENGTH_ARB             0x8627
+#define GL_PROGRAM_STRING_ARB             0x8628
+#define GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB 0x862E
+#define GL_MAX_PROGRAM_MATRICES_ARB       0x862F
+#define GL_CURRENT_MATRIX_STACK_DEPTH_ARB 0x8640
+#define GL_CURRENT_MATRIX_ARB             0x8641
+#define GL_VERTEX_PROGRAM_POINT_SIZE_ARB  0x8642
+#define GL_VERTEX_PROGRAM_TWO_SIDE_ARB    0x8643
+#define GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB 0x8645
+#define GL_PROGRAM_ERROR_POSITION_ARB     0x864B
+#define GL_PROGRAM_BINDING_ARB            0x8677
+#define GL_MAX_VERTEX_ATTRIBS_ARB         0x8869
+#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB 0x886A
+#define GL_PROGRAM_ERROR_STRING_ARB       0x8874
+#define GL_PROGRAM_FORMAT_ASCII_ARB       0x8875
+#define GL_PROGRAM_FORMAT_ARB             0x8876
+#define GL_PROGRAM_INSTRUCTIONS_ARB       0x88A0
+#define GL_MAX_PROGRAM_INSTRUCTIONS_ARB   0x88A1
+#define GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB 0x88A2
+#define GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB 0x88A3
+#define GL_PROGRAM_TEMPORARIES_ARB        0x88A4
+#define GL_MAX_PROGRAM_TEMPORARIES_ARB    0x88A5
+#define GL_PROGRAM_NATIVE_TEMPORARIES_ARB 0x88A6
+#define GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB 0x88A7
+#define GL_PROGRAM_PARAMETERS_ARB         0x88A8
+#define GL_MAX_PROGRAM_PARAMETERS_ARB     0x88A9
+#define GL_PROGRAM_NATIVE_PARAMETERS_ARB  0x88AA
+#define GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB 0x88AB
+#define GL_PROGRAM_ATTRIBS_ARB            0x88AC
+#define GL_MAX_PROGRAM_ATTRIBS_ARB        0x88AD
+#define GL_PROGRAM_NATIVE_ATTRIBS_ARB     0x88AE
+#define GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB 0x88AF
+#define GL_PROGRAM_ADDRESS_REGISTERS_ARB  0x88B0
+#define GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB 0x88B1
+#define GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB 0x88B2
+#define GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB 0x88B3
+#define GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB 0x88B4
+#define GL_MAX_PROGRAM_ENV_PARAMETERS_ARB 0x88B5
+#define GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB 0x88B6
+#define GL_TRANSPOSE_CURRENT_MATRIX_ARB   0x88B7
+#define GL_MATRIX0_ARB                    0x88C0
+#define GL_MATRIX1_ARB                    0x88C1
+#define GL_MATRIX2_ARB                    0x88C2
+#define GL_MATRIX3_ARB                    0x88C3
+#define GL_MATRIX4_ARB                    0x88C4
+#define GL_MATRIX5_ARB                    0x88C5
+#define GL_MATRIX6_ARB                    0x88C6
+#define GL_MATRIX7_ARB                    0x88C7
+#define GL_MATRIX8_ARB                    0x88C8
+#define GL_MATRIX9_ARB                    0x88C9
+#define GL_MATRIX10_ARB                   0x88CA
+#define GL_MATRIX11_ARB                   0x88CB
+#define GL_MATRIX12_ARB                   0x88CC
+#define GL_MATRIX13_ARB                   0x88CD
+#define GL_MATRIX14_ARB                   0x88CE
+#define GL_MATRIX15_ARB                   0x88CF
+#define GL_MATRIX16_ARB                   0x88D0
+#define GL_MATRIX17_ARB                   0x88D1
+#define GL_MATRIX18_ARB                   0x88D2
+#define GL_MATRIX19_ARB                   0x88D3
+#define GL_MATRIX20_ARB                   0x88D4
+#define GL_MATRIX21_ARB                   0x88D5
+#define GL_MATRIX22_ARB                   0x88D6
+#define GL_MATRIX23_ARB                   0x88D7
+#define GL_MATRIX24_ARB                   0x88D8
+#define GL_MATRIX25_ARB                   0x88D9
+#define GL_MATRIX26_ARB                   0x88DA
+#define GL_MATRIX27_ARB                   0x88DB
+#define GL_MATRIX28_ARB                   0x88DC
+#define GL_MATRIX29_ARB                   0x88DD
+#define GL_MATRIX30_ARB                   0x88DE
+#define GL_MATRIX31_ARB                   0x88DF
+#endif
+
+#ifndef GL_ARB_fragment_program
+#define GL_FRAGMENT_PROGRAM_ARB           0x8804
+#define GL_PROGRAM_ALU_INSTRUCTIONS_ARB   0x8805
+#define GL_PROGRAM_TEX_INSTRUCTIONS_ARB   0x8806
+#define GL_PROGRAM_TEX_INDIRECTIONS_ARB   0x8807
+#define GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB 0x8808
+#define GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB 0x8809
+#define GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB 0x880A
+#define GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB 0x880B
+#define GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB 0x880C
+#define GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB 0x880D
+#define GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB 0x880E
+#define GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB 0x880F
+#define GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB 0x8810
+#define GL_MAX_TEXTURE_COORDS_ARB         0x8871
+#define GL_MAX_TEXTURE_IMAGE_UNITS_ARB    0x8872
+#endif
+
+#ifndef GL_ARB_vertex_buffer_object
+#define GL_BUFFER_SIZE_ARB                0x8764
+#define GL_BUFFER_USAGE_ARB               0x8765
+#define GL_ARRAY_BUFFER_ARB               0x8892
+#define GL_ELEMENT_ARRAY_BUFFER_ARB       0x8893
+#define GL_ARRAY_BUFFER_BINDING_ARB       0x8894
+#define GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB 0x8895
+#define GL_VERTEX_ARRAY_BUFFER_BINDING_ARB 0x8896
+#define GL_NORMAL_ARRAY_BUFFER_BINDING_ARB 0x8897
+#define GL_COLOR_ARRAY_BUFFER_BINDING_ARB 0x8898
+#define GL_INDEX_ARRAY_BUFFER_BINDING_ARB 0x8899
+#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB 0x889A
+#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB 0x889B
+#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB 0x889C
+#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB 0x889D
+#define GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB 0x889E
+#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB 0x889F
+#define GL_READ_ONLY_ARB                  0x88B8
+#define GL_WRITE_ONLY_ARB                 0x88B9
+#define GL_READ_WRITE_ARB                 0x88BA
+#define GL_BUFFER_ACCESS_ARB              0x88BB
+#define GL_BUFFER_MAPPED_ARB              0x88BC
+#define GL_BUFFER_MAP_POINTER_ARB         0x88BD
+#define GL_STREAM_DRAW_ARB                0x88E0
+#define GL_STREAM_READ_ARB                0x88E1
+#define GL_STREAM_COPY_ARB                0x88E2
+#define GL_STATIC_DRAW_ARB                0x88E4
+#define GL_STATIC_READ_ARB                0x88E5
+#define GL_STATIC_COPY_ARB                0x88E6
+#define GL_DYNAMIC_DRAW_ARB               0x88E8
+#define GL_DYNAMIC_READ_ARB               0x88E9
+#define GL_DYNAMIC_COPY_ARB               0x88EA
+#endif
+
+#ifndef GL_ARB_occlusion_query
+#define GL_QUERY_COUNTER_BITS_ARB         0x8864
+#define GL_CURRENT_QUERY_ARB              0x8865
+#define GL_QUERY_RESULT_ARB               0x8866
+#define GL_QUERY_RESULT_AVAILABLE_ARB     0x8867
+#define GL_SAMPLES_PASSED_ARB             0x8914
+#endif
+
+#ifndef GL_ARB_shader_objects
+#define GL_PROGRAM_OBJECT_ARB             0x8B40
+#define GL_SHADER_OBJECT_ARB              0x8B48
+#define GL_OBJECT_TYPE_ARB                0x8B4E
+#define GL_OBJECT_SUBTYPE_ARB             0x8B4F
+#define GL_FLOAT_VEC2_ARB                 0x8B50
+#define GL_FLOAT_VEC3_ARB                 0x8B51
+#define GL_FLOAT_VEC4_ARB                 0x8B52
+#define GL_INT_VEC2_ARB                   0x8B53
+#define GL_INT_VEC3_ARB                   0x8B54
+#define GL_INT_VEC4_ARB                   0x8B55
+#define GL_BOOL_ARB                       0x8B56
+#define GL_BOOL_VEC2_ARB                  0x8B57
+#define GL_BOOL_VEC3_ARB                  0x8B58
+#define GL_BOOL_VEC4_ARB                  0x8B59
+#define GL_FLOAT_MAT2_ARB                 0x8B5A
+#define GL_FLOAT_MAT3_ARB                 0x8B5B
+#define GL_FLOAT_MAT4_ARB                 0x8B5C
+#define GL_SAMPLER_1D_ARB                 0x8B5D
+#define GL_SAMPLER_2D_ARB                 0x8B5E
+#define GL_SAMPLER_3D_ARB                 0x8B5F
+#define GL_SAMPLER_CUBE_ARB               0x8B60
+#define GL_SAMPLER_1D_SHADOW_ARB          0x8B61
+#define GL_SAMPLER_2D_SHADOW_ARB          0x8B62
+#define GL_SAMPLER_2D_RECT_ARB            0x8B63
+#define GL_SAMPLER_2D_RECT_SHADOW_ARB     0x8B64
+#define GL_OBJECT_DELETE_STATUS_ARB       0x8B80
+#define GL_OBJECT_COMPILE_STATUS_ARB      0x8B81
+#define GL_OBJECT_LINK_STATUS_ARB         0x8B82
+#define GL_OBJECT_VALIDATE_STATUS_ARB     0x8B83
+#define GL_OBJECT_INFO_LOG_LENGTH_ARB     0x8B84
+#define GL_OBJECT_ATTACHED_OBJECTS_ARB    0x8B85
+#define GL_OBJECT_ACTIVE_UNIFORMS_ARB     0x8B86
+#define GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB 0x8B87
+#define GL_OBJECT_SHADER_SOURCE_LENGTH_ARB 0x8B88
+#endif
+
+#ifndef GL_ARB_vertex_shader
+#define GL_VERTEX_SHADER_ARB              0x8B31
+#define GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB 0x8B4A
+#define GL_MAX_VARYING_FLOATS_ARB         0x8B4B
+#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB 0x8B4C
+#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB 0x8B4D
+#define GL_OBJECT_ACTIVE_ATTRIBUTES_ARB   0x8B89
+#define GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB 0x8B8A
+#endif
+
+#ifndef GL_ARB_fragment_shader
+#define GL_FRAGMENT_SHADER_ARB            0x8B30
+#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB 0x8B49
+#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB 0x8B8B
+#endif
+
+#ifndef GL_ARB_shading_language_100
+#define GL_SHADING_LANGUAGE_VERSION_ARB   0x8B8C
+#endif
+
+#ifndef GL_ARB_texture_non_power_of_two
+#endif
+
+#ifndef GL_ARB_point_sprite
+#define GL_POINT_SPRITE_ARB               0x8861
+#define GL_COORD_REPLACE_ARB              0x8862
+#endif
+
+#ifndef GL_ARB_fragment_program_shadow
+#endif
+
+#ifndef GL_ARB_draw_buffers
+#define GL_MAX_DRAW_BUFFERS_ARB           0x8824
+#define GL_DRAW_BUFFER0_ARB               0x8825
+#define GL_DRAW_BUFFER1_ARB               0x8826
+#define GL_DRAW_BUFFER2_ARB               0x8827
+#define GL_DRAW_BUFFER3_ARB               0x8828
+#define GL_DRAW_BUFFER4_ARB               0x8829
+#define GL_DRAW_BUFFER5_ARB               0x882A
+#define GL_DRAW_BUFFER6_ARB               0x882B
+#define GL_DRAW_BUFFER7_ARB               0x882C
+#define GL_DRAW_BUFFER8_ARB               0x882D
+#define GL_DRAW_BUFFER9_ARB               0x882E
+#define GL_DRAW_BUFFER10_ARB              0x882F
+#define GL_DRAW_BUFFER11_ARB              0x8830
+#define GL_DRAW_BUFFER12_ARB              0x8831
+#define GL_DRAW_BUFFER13_ARB              0x8832
+#define GL_DRAW_BUFFER14_ARB              0x8833
+#define GL_DRAW_BUFFER15_ARB              0x8834
+#endif
+
+#ifndef GL_ARB_texture_rectangle
+#define GL_TEXTURE_RECTANGLE_ARB          0x84F5
+#define GL_TEXTURE_BINDING_RECTANGLE_ARB  0x84F6
+#define GL_PROXY_TEXTURE_RECTANGLE_ARB    0x84F7
+#define GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB 0x84F8
+#endif
+
+#ifndef GL_ARB_color_buffer_float
+#define GL_RGBA_FLOAT_MODE_ARB            0x8820
+#define GL_CLAMP_VERTEX_COLOR_ARB         0x891A
+#define GL_CLAMP_FRAGMENT_COLOR_ARB       0x891B
+#define GL_CLAMP_READ_COLOR_ARB           0x891C
+#define GL_FIXED_ONLY_ARB                 0x891D
+#endif
+
+#ifndef GL_ARB_half_float_pixel
+#define GL_HALF_FLOAT_ARB                 0x140B
+#endif
+
+#ifndef GL_ARB_texture_float
+#define GL_TEXTURE_RED_TYPE_ARB           0x8C10
+#define GL_TEXTURE_GREEN_TYPE_ARB         0x8C11
+#define GL_TEXTURE_BLUE_TYPE_ARB          0x8C12
+#define GL_TEXTURE_ALPHA_TYPE_ARB         0x8C13
+#define GL_TEXTURE_LUMINANCE_TYPE_ARB     0x8C14
+#define GL_TEXTURE_INTENSITY_TYPE_ARB     0x8C15
+#define GL_TEXTURE_DEPTH_TYPE_ARB         0x8C16
+#define GL_UNSIGNED_NORMALIZED_ARB        0x8C17
+#define GL_RGBA32F_ARB                    0x8814
+#define GL_RGB32F_ARB                     0x8815
+#define GL_ALPHA32F_ARB                   0x8816
+#define GL_INTENSITY32F_ARB               0x8817
+#define GL_LUMINANCE32F_ARB               0x8818
+#define GL_LUMINANCE_ALPHA32F_ARB         0x8819
+#define GL_RGBA16F_ARB                    0x881A
+#define GL_RGB16F_ARB                     0x881B
+#define GL_ALPHA16F_ARB                   0x881C
+#define GL_INTENSITY16F_ARB               0x881D
+#define GL_LUMINANCE16F_ARB               0x881E
+#define GL_LUMINANCE_ALPHA16F_ARB         0x881F
+#endif
+
+#ifndef GL_ARB_pixel_buffer_object
+#define GL_PIXEL_PACK_BUFFER_ARB          0x88EB
+#define GL_PIXEL_UNPACK_BUFFER_ARB        0x88EC
+#define GL_PIXEL_PACK_BUFFER_BINDING_ARB  0x88ED
+#define GL_PIXEL_UNPACK_BUFFER_BINDING_ARB 0x88EF
+#endif
+
+#ifndef GL_EXT_abgr
+#define GL_ABGR_EXT                       0x8000
+#endif
+
+#ifndef GL_EXT_blend_color
+#define GL_CONSTANT_COLOR_EXT             0x8001
+#define GL_ONE_MINUS_CONSTANT_COLOR_EXT   0x8002
+#define GL_CONSTANT_ALPHA_EXT             0x8003
+#define GL_ONE_MINUS_CONSTANT_ALPHA_EXT   0x8004
+#define GL_BLEND_COLOR_EXT                0x8005
+#endif
+
+#ifndef GL_EXT_polygon_offset
+#define GL_POLYGON_OFFSET_EXT             0x8037
+#define GL_POLYGON_OFFSET_FACTOR_EXT      0x8038
+#define GL_POLYGON_OFFSET_BIAS_EXT        0x8039
+#endif
+
+#ifndef GL_EXT_texture
+#define GL_ALPHA4_EXT                     0x803B
+#define GL_ALPHA8_EXT                     0x803C
+#define GL_ALPHA12_EXT                    0x803D
+#define GL_ALPHA16_EXT                    0x803E
+#define GL_LUMINANCE4_EXT                 0x803F
+#define GL_LUMINANCE8_EXT                 0x8040
+#define GL_LUMINANCE12_EXT                0x8041
+#define GL_LUMINANCE16_EXT                0x8042
+#define GL_LUMINANCE4_ALPHA4_EXT          0x8043
+#define GL_LUMINANCE6_ALPHA2_EXT          0x8044
+#define GL_LUMINANCE8_ALPHA8_EXT          0x8045
+#define GL_LUMINANCE12_ALPHA4_EXT         0x8046
+#define GL_LUMINANCE12_ALPHA12_EXT        0x8047
+#define GL_LUMINANCE16_ALPHA16_EXT        0x8048
+#define GL_INTENSITY_EXT                  0x8049
+#define GL_INTENSITY4_EXT                 0x804A
+#define GL_INTENSITY8_EXT                 0x804B
+#define GL_INTENSITY12_EXT                0x804C
+#define GL_INTENSITY16_EXT                0x804D
+#define GL_RGB2_EXT                       0x804E
+#define GL_RGB4_EXT                       0x804F
+#define GL_RGB5_EXT                       0x8050
+#define GL_RGB8_EXT                       0x8051
+#define GL_RGB10_EXT                      0x8052
+#define GL_RGB12_EXT                      0x8053
+#define GL_RGB16_EXT                      0x8054
+#define GL_RGBA2_EXT                      0x8055
+#define GL_RGBA4_EXT                      0x8056
+#define GL_RGB5_A1_EXT                    0x8057
+#define GL_RGBA8_EXT                      0x8058
+#define GL_RGB10_A2_EXT                   0x8059
+#define GL_RGBA12_EXT                     0x805A
+#define GL_RGBA16_EXT                     0x805B
+#define GL_TEXTURE_RED_SIZE_EXT           0x805C
+#define GL_TEXTURE_GREEN_SIZE_EXT         0x805D
+#define GL_TEXTURE_BLUE_SIZE_EXT          0x805E
+#define GL_TEXTURE_ALPHA_SIZE_EXT         0x805F
+#define GL_TEXTURE_LUMINANCE_SIZE_EXT     0x8060
+#define GL_TEXTURE_INTENSITY_SIZE_EXT     0x8061
+#define GL_REPLACE_EXT                    0x8062
+#define GL_PROXY_TEXTURE_1D_EXT           0x8063
+#define GL_PROXY_TEXTURE_2D_EXT           0x8064
+#define GL_TEXTURE_TOO_LARGE_EXT          0x8065
+#endif
+
+#ifndef GL_EXT_texture3D
+#define GL_PACK_SKIP_IMAGES_EXT           0x806B
+#define GL_PACK_IMAGE_HEIGHT_EXT          0x806C
+#define GL_UNPACK_SKIP_IMAGES_EXT         0x806D
+#define GL_UNPACK_IMAGE_HEIGHT_EXT        0x806E
+#define GL_TEXTURE_3D_EXT                 0x806F
+#define GL_PROXY_TEXTURE_3D_EXT           0x8070
+#define GL_TEXTURE_DEPTH_EXT              0x8071
+#define GL_TEXTURE_WRAP_R_EXT             0x8072
+#define GL_MAX_3D_TEXTURE_SIZE_EXT        0x8073
+#endif
+
+#ifndef GL_SGIS_texture_filter4
+#define GL_FILTER4_SGIS                   0x8146
+#define GL_TEXTURE_FILTER4_SIZE_SGIS      0x8147
+#endif
+
+#ifndef GL_EXT_subtexture
+#endif
+
+#ifndef GL_EXT_copy_texture
+#endif
+
+#ifndef GL_EXT_histogram
+#define GL_HISTOGRAM_EXT                  0x8024
+#define GL_PROXY_HISTOGRAM_EXT            0x8025
+#define GL_HISTOGRAM_WIDTH_EXT            0x8026
+#define GL_HISTOGRAM_FORMAT_EXT           0x8027
+#define GL_HISTOGRAM_RED_SIZE_EXT         0x8028
+#define GL_HISTOGRAM_GREEN_SIZE_EXT       0x8029
+#define GL_HISTOGRAM_BLUE_SIZE_EXT        0x802A
+#define GL_HISTOGRAM_ALPHA_SIZE_EXT       0x802B
+#define GL_HISTOGRAM_LUMINANCE_SIZE_EXT   0x802C
+#define GL_HISTOGRAM_SINK_EXT             0x802D
+#define GL_MINMAX_EXT                     0x802E
+#define GL_MINMAX_FORMAT_EXT              0x802F
+#define GL_MINMAX_SINK_EXT                0x8030
+#define GL_TABLE_TOO_LARGE_EXT            0x8031
+#endif
+
+#ifndef GL_EXT_convolution
+#define GL_CONVOLUTION_1D_EXT             0x8010
+#define GL_CONVOLUTION_2D_EXT             0x8011
+#define GL_SEPARABLE_2D_EXT               0x8012
+#define GL_CONVOLUTION_BORDER_MODE_EXT    0x8013
+#define GL_CONVOLUTION_FILTER_SCALE_EXT   0x8014
+#define GL_CONVOLUTION_FILTER_BIAS_EXT    0x8015
+#define GL_REDUCE_EXT                     0x8016
+#define GL_CONVOLUTION_FORMAT_EXT         0x8017
+#define GL_CONVOLUTION_WIDTH_EXT          0x8018
+#define GL_CONVOLUTION_HEIGHT_EXT         0x8019
+#define GL_MAX_CONVOLUTION_WIDTH_EXT      0x801A
+#define GL_MAX_CONVOLUTION_HEIGHT_EXT     0x801B
+#define GL_POST_CONVOLUTION_RED_SCALE_EXT 0x801C
+#define GL_POST_CONVOLUTION_GREEN_SCALE_EXT 0x801D
+#define GL_POST_CONVOLUTION_BLUE_SCALE_EXT 0x801E
+#define GL_POST_CONVOLUTION_ALPHA_SCALE_EXT 0x801F
+#define GL_POST_CONVOLUTION_RED_BIAS_EXT  0x8020
+#define GL_POST_CONVOLUTION_GREEN_BIAS_EXT 0x8021
+#define GL_POST_CONVOLUTION_BLUE_BIAS_EXT 0x8022
+#define GL_POST_CONVOLUTION_ALPHA_BIAS_EXT 0x8023
+#endif
+
+#ifndef GL_SGI_color_matrix
+#define GL_COLOR_MATRIX_SGI               0x80B1
+#define GL_COLOR_MATRIX_STACK_DEPTH_SGI   0x80B2
+#define GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI 0x80B3
+#define GL_POST_COLOR_MATRIX_RED_SCALE_SGI 0x80B4
+#define GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI 0x80B5
+#define GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI 0x80B6
+#define GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI 0x80B7
+#define GL_POST_COLOR_MATRIX_RED_BIAS_SGI 0x80B8
+#define GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI 0x80B9
+#define GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI 0x80BA
+#define GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI 0x80BB
+#endif
+
+#ifndef GL_SGI_color_table
+#define GL_COLOR_TABLE_SGI                0x80D0
+#define GL_POST_CONVOLUTION_COLOR_TABLE_SGI 0x80D1
+#define GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI 0x80D2
+#define GL_PROXY_COLOR_TABLE_SGI          0x80D3
+#define GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI 0x80D4
+#define GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI 0x80D5
+#define GL_COLOR_TABLE_SCALE_SGI          0x80D6
+#define GL_COLOR_TABLE_BIAS_SGI           0x80D7
+#define GL_COLOR_TABLE_FORMAT_SGI         0x80D8
+#define GL_COLOR_TABLE_WIDTH_SGI          0x80D9
+#define GL_COLOR_TABLE_RED_SIZE_SGI       0x80DA
+#define GL_COLOR_TABLE_GREEN_SIZE_SGI     0x80DB
+#define GL_COLOR_TABLE_BLUE_SIZE_SGI      0x80DC
+#define GL_COLOR_TABLE_ALPHA_SIZE_SGI     0x80DD
+#define GL_COLOR_TABLE_LUMINANCE_SIZE_SGI 0x80DE
+#define GL_COLOR_TABLE_INTENSITY_SIZE_SGI 0x80DF
+#endif
+
+#ifndef GL_SGIS_pixel_texture
+#define GL_PIXEL_TEXTURE_SGIS             0x8353
+#define GL_PIXEL_FRAGMENT_RGB_SOURCE_SGIS 0x8354
+#define GL_PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS 0x8355
+#define GL_PIXEL_GROUP_COLOR_SGIS         0x8356
+#endif
+
+#ifndef GL_SGIX_pixel_texture
+#define GL_PIXEL_TEX_GEN_SGIX             0x8139
+#define GL_PIXEL_TEX_GEN_MODE_SGIX        0x832B
+#endif
+
+#ifndef GL_SGIS_texture4D
+#define GL_PACK_SKIP_VOLUMES_SGIS         0x8130
+#define GL_PACK_IMAGE_DEPTH_SGIS          0x8131
+#define GL_UNPACK_SKIP_VOLUMES_SGIS       0x8132
+#define GL_UNPACK_IMAGE_DEPTH_SGIS        0x8133
+#define GL_TEXTURE_4D_SGIS                0x8134
+#define GL_PROXY_TEXTURE_4D_SGIS          0x8135
+#define GL_TEXTURE_4DSIZE_SGIS            0x8136
+#define GL_TEXTURE_WRAP_Q_SGIS            0x8137
+#define GL_MAX_4D_TEXTURE_SIZE_SGIS       0x8138
+#define GL_TEXTURE_4D_BINDING_SGIS        0x814F
+#endif
+
+#ifndef GL_SGI_texture_color_table
+#define GL_TEXTURE_COLOR_TABLE_SGI        0x80BC
+#define GL_PROXY_TEXTURE_COLOR_TABLE_SGI  0x80BD
+#endif
+
+#ifndef GL_EXT_cmyka
+#define GL_CMYK_EXT                       0x800C
+#define GL_CMYKA_EXT                      0x800D
+#define GL_PACK_CMYK_HINT_EXT             0x800E
+#define GL_UNPACK_CMYK_HINT_EXT           0x800F
+#endif
+
+#ifndef GL_EXT_texture_object
+#define GL_TEXTURE_PRIORITY_EXT           0x8066
+#define GL_TEXTURE_RESIDENT_EXT           0x8067
+#define GL_TEXTURE_1D_BINDING_EXT         0x8068
+#define GL_TEXTURE_2D_BINDING_EXT         0x8069
+#define GL_TEXTURE_3D_BINDING_EXT         0x806A
+#endif
+
+#ifndef GL_SGIS_detail_texture
+#define GL_DETAIL_TEXTURE_2D_SGIS         0x8095
+#define GL_DETAIL_TEXTURE_2D_BINDING_SGIS 0x8096
+#define GL_LINEAR_DETAIL_SGIS             0x8097
+#define GL_LINEAR_DETAIL_ALPHA_SGIS       0x8098
+#define GL_LINEAR_DETAIL_COLOR_SGIS       0x8099
+#define GL_DETAIL_TEXTURE_LEVEL_SGIS      0x809A
+#define GL_DETAIL_TEXTURE_MODE_SGIS       0x809B
+#define GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS 0x809C
+#endif
+
+#ifndef GL_SGIS_sharpen_texture
+#define GL_LINEAR_SHARPEN_SGIS            0x80AD
+#define GL_LINEAR_SHARPEN_ALPHA_SGIS      0x80AE
+#define GL_LINEAR_SHARPEN_COLOR_SGIS      0x80AF
+#define GL_SHARPEN_TEXTURE_FUNC_POINTS_SGIS 0x80B0
+#endif
+
+#ifndef GL_EXT_packed_pixels
+#define GL_UNSIGNED_BYTE_3_3_2_EXT        0x8032
+#define GL_UNSIGNED_SHORT_4_4_4_4_EXT     0x8033
+#define GL_UNSIGNED_SHORT_5_5_5_1_EXT     0x8034
+#define GL_UNSIGNED_INT_8_8_8_8_EXT       0x8035
+#define GL_UNSIGNED_INT_10_10_10_2_EXT    0x8036
+#endif
+
+#ifndef GL_SGIS_texture_lod
+#define GL_TEXTURE_MIN_LOD_SGIS           0x813A
+#define GL_TEXTURE_MAX_LOD_SGIS           0x813B
+#define GL_TEXTURE_BASE_LEVEL_SGIS        0x813C
+#define GL_TEXTURE_MAX_LEVEL_SGIS         0x813D
+#endif
+
+#ifndef GL_SGIS_multisample
+#define GL_MULTISAMPLE_SGIS               0x809D
+#define GL_SAMPLE_ALPHA_TO_MASK_SGIS      0x809E
+#define GL_SAMPLE_ALPHA_TO_ONE_SGIS       0x809F
+#define GL_SAMPLE_MASK_SGIS               0x80A0
+#define GL_1PASS_SGIS                     0x80A1
+#define GL_2PASS_0_SGIS                   0x80A2
+#define GL_2PASS_1_SGIS                   0x80A3
+#define GL_4PASS_0_SGIS                   0x80A4
+#define GL_4PASS_1_SGIS                   0x80A5
+#define GL_4PASS_2_SGIS                   0x80A6
+#define GL_4PASS_3_SGIS                   0x80A7
+#define GL_SAMPLE_BUFFERS_SGIS            0x80A8
+#define GL_SAMPLES_SGIS                   0x80A9
+#define GL_SAMPLE_MASK_VALUE_SGIS         0x80AA
+#define GL_SAMPLE_MASK_INVERT_SGIS        0x80AB
+#define GL_SAMPLE_PATTERN_SGIS            0x80AC
+#endif
+
+#ifndef GL_EXT_rescale_normal
+#define GL_RESCALE_NORMAL_EXT             0x803A
+#endif
+
+#ifndef GL_EXT_vertex_array
+#define GL_VERTEX_ARRAY_EXT               0x8074
+#define GL_NORMAL_ARRAY_EXT               0x8075
+#define GL_COLOR_ARRAY_EXT                0x8076
+#define GL_INDEX_ARRAY_EXT                0x8077
+#define GL_TEXTURE_COORD_ARRAY_EXT        0x8078
+#define GL_EDGE_FLAG_ARRAY_EXT            0x8079
+#define GL_VERTEX_ARRAY_SIZE_EXT          0x807A
+#define GL_VERTEX_ARRAY_TYPE_EXT          0x807B
+#define GL_VERTEX_ARRAY_STRIDE_EXT        0x807C
+#define GL_VERTEX_ARRAY_COUNT_EXT         0x807D
+#define GL_NORMAL_ARRAY_TYPE_EXT          0x807E
+#define GL_NORMAL_ARRAY_STRIDE_EXT        0x807F
+#define GL_NORMAL_ARRAY_COUNT_EXT         0x8080
+#define GL_COLOR_ARRAY_SIZE_EXT           0x8081
+#define GL_COLOR_ARRAY_TYPE_EXT           0x8082
+#define GL_COLOR_ARRAY_STRIDE_EXT         0x8083
+#define GL_COLOR_ARRAY_COUNT_EXT          0x8084
+#define GL_INDEX_ARRAY_TYPE_EXT           0x8085
+#define GL_INDEX_ARRAY_STRIDE_EXT         0x8086
+#define GL_INDEX_ARRAY_COUNT_EXT          0x8087
+#define GL_TEXTURE_COORD_ARRAY_SIZE_EXT   0x8088
+#define GL_TEXTURE_COORD_ARRAY_TYPE_EXT   0x8089
+#define GL_TEXTURE_COORD_ARRAY_STRIDE_EXT 0x808A
+#define GL_TEXTURE_COORD_ARRAY_COUNT_EXT  0x808B
+#define GL_EDGE_FLAG_ARRAY_STRIDE_EXT     0x808C
+#define GL_EDGE_FLAG_ARRAY_COUNT_EXT      0x808D
+#define GL_VERTEX_ARRAY_POINTER_EXT       0x808E
+#define GL_NORMAL_ARRAY_POINTER_EXT       0x808F
+#define GL_COLOR_ARRAY_POINTER_EXT        0x8090
+#define GL_INDEX_ARRAY_POINTER_EXT        0x8091
+#define GL_TEXTURE_COORD_ARRAY_POINTER_EXT 0x8092
+#define GL_EDGE_FLAG_ARRAY_POINTER_EXT    0x8093
+#endif
+
+#ifndef GL_EXT_misc_attribute
+#endif
+
+#ifndef GL_SGIS_generate_mipmap
+#define GL_GENERATE_MIPMAP_SGIS           0x8191
+#define GL_GENERATE_MIPMAP_HINT_SGIS      0x8192
+#endif
+
+#ifndef GL_SGIX_clipmap
+#define GL_LINEAR_CLIPMAP_LINEAR_SGIX     0x8170
+#define GL_TEXTURE_CLIPMAP_CENTER_SGIX    0x8171
+#define GL_TEXTURE_CLIPMAP_FRAME_SGIX     0x8172
+#define GL_TEXTURE_CLIPMAP_OFFSET_SGIX    0x8173
+#define GL_TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX 0x8174
+#define GL_TEXTURE_CLIPMAP_LOD_OFFSET_SGIX 0x8175
+#define GL_TEXTURE_CLIPMAP_DEPTH_SGIX     0x8176
+#define GL_MAX_CLIPMAP_DEPTH_SGIX         0x8177
+#define GL_MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX 0x8178
+#define GL_NEAREST_CLIPMAP_NEAREST_SGIX   0x844D
+#define GL_NEAREST_CLIPMAP_LINEAR_SGIX    0x844E
+#define GL_LINEAR_CLIPMAP_NEAREST_SGIX    0x844F
+#endif
+
+#ifndef GL_SGIX_shadow
+#define GL_TEXTURE_COMPARE_SGIX           0x819A
+#define GL_TEXTURE_COMPARE_OPERATOR_SGIX  0x819B
+#define GL_TEXTURE_LEQUAL_R_SGIX          0x819C
+#define GL_TEXTURE_GEQUAL_R_SGIX          0x819D
+#endif
+
+#ifndef GL_SGIS_texture_edge_clamp
+#define GL_CLAMP_TO_EDGE_SGIS             0x812F
+#endif
+
+#ifndef GL_SGIS_texture_border_clamp
+#define GL_CLAMP_TO_BORDER_SGIS           0x812D
+#endif
+
+#ifndef GL_EXT_blend_minmax
+#define GL_FUNC_ADD_EXT                   0x8006
+#define GL_MIN_EXT                        0x8007
+#define GL_MAX_EXT                        0x8008
+#define GL_BLEND_EQUATION_EXT             0x8009
+#endif
+
+#ifndef GL_EXT_blend_subtract
+#define GL_FUNC_SUBTRACT_EXT              0x800A
+#define GL_FUNC_REVERSE_SUBTRACT_EXT      0x800B
+#endif
+
+#ifndef GL_EXT_blend_logic_op
+#endif
+
+#ifndef GL_SGIX_interlace
+#define GL_INTERLACE_SGIX                 0x8094
+#endif
+
+#ifndef GL_SGIX_pixel_tiles
+#define GL_PIXEL_TILE_BEST_ALIGNMENT_SGIX 0x813E
+#define GL_PIXEL_TILE_CACHE_INCREMENT_SGIX 0x813F
+#define GL_PIXEL_TILE_WIDTH_SGIX          0x8140
+#define GL_PIXEL_TILE_HEIGHT_SGIX         0x8141
+#define GL_PIXEL_TILE_GRID_WIDTH_SGIX     0x8142
+#define GL_PIXEL_TILE_GRID_HEIGHT_SGIX    0x8143
+#define GL_PIXEL_TILE_GRID_DEPTH_SGIX     0x8144
+#define GL_PIXEL_TILE_CACHE_SIZE_SGIX     0x8145
+#endif
+
+#ifndef GL_SGIS_texture_select
+#define GL_DUAL_ALPHA4_SGIS               0x8110
+#define GL_DUAL_ALPHA8_SGIS               0x8111
+#define GL_DUAL_ALPHA12_SGIS              0x8112
+#define GL_DUAL_ALPHA16_SGIS              0x8113
+#define GL_DUAL_LUMINANCE4_SGIS           0x8114
+#define GL_DUAL_LUMINANCE8_SGIS           0x8115
+#define GL_DUAL_LUMINANCE12_SGIS          0x8116
+#define GL_DUAL_LUMINANCE16_SGIS          0x8117
+#define GL_DUAL_INTENSITY4_SGIS           0x8118
+#define GL_DUAL_INTENSITY8_SGIS           0x8119
+#define GL_DUAL_INTENSITY12_SGIS          0x811A
+#define GL_DUAL_INTENSITY16_SGIS          0x811B
+#define GL_DUAL_LUMINANCE_ALPHA4_SGIS     0x811C
+#define GL_DUAL_LUMINANCE_ALPHA8_SGIS     0x811D
+#define GL_QUAD_ALPHA4_SGIS               0x811E
+#define GL_QUAD_ALPHA8_SGIS               0x811F
+#define GL_QUAD_LUMINANCE4_SGIS           0x8120
+#define GL_QUAD_LUMINANCE8_SGIS           0x8121
+#define GL_QUAD_INTENSITY4_SGIS           0x8122
+#define GL_QUAD_INTENSITY8_SGIS           0x8123
+#define GL_DUAL_TEXTURE_SELECT_SGIS       0x8124
+#define GL_QUAD_TEXTURE_SELECT_SGIS       0x8125
+#endif
+
+#ifndef GL_SGIX_sprite
+#define GL_SPRITE_SGIX                    0x8148
+#define GL_SPRITE_MODE_SGIX               0x8149
+#define GL_SPRITE_AXIS_SGIX               0x814A
+#define GL_SPRITE_TRANSLATION_SGIX        0x814B
+#define GL_SPRITE_AXIAL_SGIX              0x814C
+#define GL_SPRITE_OBJECT_ALIGNED_SGIX     0x814D
+#define GL_SPRITE_EYE_ALIGNED_SGIX        0x814E
+#endif
+
+#ifndef GL_SGIX_texture_multi_buffer
+#define GL_TEXTURE_MULTI_BUFFER_HINT_SGIX 0x812E
+#endif
+
+#ifndef GL_EXT_point_parameters
+#define GL_POINT_SIZE_MIN_EXT             0x8126
+#define GL_POINT_SIZE_MAX_EXT             0x8127
+#define GL_POINT_FADE_THRESHOLD_SIZE_EXT  0x8128
+#define GL_DISTANCE_ATTENUATION_EXT       0x8129
+#endif
+
+#ifndef GL_SGIS_point_parameters
+#define GL_POINT_SIZE_MIN_SGIS            0x8126
+#define GL_POINT_SIZE_MAX_SGIS            0x8127
+#define GL_POINT_FADE_THRESHOLD_SIZE_SGIS 0x8128
+#define GL_DISTANCE_ATTENUATION_SGIS      0x8129
+#endif
+
+#ifndef GL_SGIX_instruments
+#define GL_INSTRUMENT_BUFFER_POINTER_SGIX 0x8180
+#define GL_INSTRUMENT_MEASUREMENTS_SGIX   0x8181
+#endif
+
+#ifndef GL_SGIX_texture_scale_bias
+#define GL_POST_TEXTURE_FILTER_BIAS_SGIX  0x8179
+#define GL_POST_TEXTURE_FILTER_SCALE_SGIX 0x817A
+#define GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX 0x817B
+#define GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX 0x817C
+#endif
+
+#ifndef GL_SGIX_framezoom
+#define GL_FRAMEZOOM_SGIX                 0x818B
+#define GL_FRAMEZOOM_FACTOR_SGIX          0x818C
+#define GL_MAX_FRAMEZOOM_FACTOR_SGIX      0x818D
+#endif
+
+#ifndef GL_SGIX_tag_sample_buffer
+#endif
+
+#ifndef GL_FfdMaskSGIX
+#define GL_TEXTURE_DEFORMATION_BIT_SGIX   0x00000001
+#define GL_GEOMETRY_DEFORMATION_BIT_SGIX  0x00000002
+#endif
+
+#ifndef GL_SGIX_polynomial_ffd
+#define GL_GEOMETRY_DEFORMATION_SGIX      0x8194
+#define GL_TEXTURE_DEFORMATION_SGIX       0x8195
+#define GL_DEFORMATIONS_MASK_SGIX         0x8196
+#define GL_MAX_DEFORMATION_ORDER_SGIX     0x8197
+#endif
+
+#ifndef GL_SGIX_reference_plane
+#define GL_REFERENCE_PLANE_SGIX           0x817D
+#define GL_REFERENCE_PLANE_EQUATION_SGIX  0x817E
+#endif
+
+#ifndef GL_SGIX_flush_raster
+#endif
+
+#ifndef GL_SGIX_depth_texture
+#define GL_DEPTH_COMPONENT16_SGIX         0x81A5
+#define GL_DEPTH_COMPONENT24_SGIX         0x81A6
+#define GL_DEPTH_COMPONENT32_SGIX         0x81A7
+#endif
+
+#ifndef GL_SGIS_fog_function
+#define GL_FOG_FUNC_SGIS                  0x812A
+#define GL_FOG_FUNC_POINTS_SGIS           0x812B
+#define GL_MAX_FOG_FUNC_POINTS_SGIS       0x812C
+#endif
+
+#ifndef GL_SGIX_fog_offset
+#define GL_FOG_OFFSET_SGIX                0x8198
+#define GL_FOG_OFFSET_VALUE_SGIX          0x8199
+#endif
+
+#ifndef GL_HP_image_transform
+#define GL_IMAGE_SCALE_X_HP               0x8155
+#define GL_IMAGE_SCALE_Y_HP               0x8156
+#define GL_IMAGE_TRANSLATE_X_HP           0x8157
+#define GL_IMAGE_TRANSLATE_Y_HP           0x8158
+#define GL_IMAGE_ROTATE_ANGLE_HP          0x8159
+#define GL_IMAGE_ROTATE_ORIGIN_X_HP       0x815A
+#define GL_IMAGE_ROTATE_ORIGIN_Y_HP       0x815B
+#define GL_IMAGE_MAG_FILTER_HP            0x815C
+#define GL_IMAGE_MIN_FILTER_HP            0x815D
+#define GL_IMAGE_CUBIC_WEIGHT_HP          0x815E
+#define GL_CUBIC_HP                       0x815F
+#define GL_AVERAGE_HP                     0x8160
+#define GL_IMAGE_TRANSFORM_2D_HP          0x8161
+#define GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP 0x8162
+#define GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP 0x8163
+#endif
+
+#ifndef GL_HP_convolution_border_modes
+#define GL_IGNORE_BORDER_HP               0x8150
+#define GL_CONSTANT_BORDER_HP             0x8151
+#define GL_REPLICATE_BORDER_HP            0x8153
+#define GL_CONVOLUTION_BORDER_COLOR_HP    0x8154
+#endif
+
+#ifndef GL_INGR_palette_buffer
+#endif
+
+#ifndef GL_SGIX_texture_add_env
+#define GL_TEXTURE_ENV_BIAS_SGIX          0x80BE
+#endif
+
+#ifndef GL_EXT_color_subtable
+#endif
+
+#ifndef GL_PGI_vertex_hints
+#define GL_VERTEX_DATA_HINT_PGI           0x1A22A
+#define GL_VERTEX_CONSISTENT_HINT_PGI     0x1A22B
+#define GL_MATERIAL_SIDE_HINT_PGI         0x1A22C
+#define GL_MAX_VERTEX_HINT_PGI            0x1A22D
+#define GL_COLOR3_BIT_PGI                 0x00010000
+#define GL_COLOR4_BIT_PGI                 0x00020000
+#define GL_EDGEFLAG_BIT_PGI               0x00040000
+#define GL_INDEX_BIT_PGI                  0x00080000
+#define GL_MAT_AMBIENT_BIT_PGI            0x00100000
+#define GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI 0x00200000
+#define GL_MAT_DIFFUSE_BIT_PGI            0x00400000
+#define GL_MAT_EMISSION_BIT_PGI           0x00800000
+#define GL_MAT_COLOR_INDEXES_BIT_PGI      0x01000000
+#define GL_MAT_SHININESS_BIT_PGI          0x02000000
+#define GL_MAT_SPECULAR_BIT_PGI           0x04000000
+#define GL_NORMAL_BIT_PGI                 0x08000000
+#define GL_TEXCOORD1_BIT_PGI              0x10000000
+#define GL_TEXCOORD2_BIT_PGI              0x20000000
+#define GL_TEXCOORD3_BIT_PGI              0x40000000
+#define GL_TEXCOORD4_BIT_PGI              0x80000000
+#define GL_VERTEX23_BIT_PGI               0x00000004
+#define GL_VERTEX4_BIT_PGI                0x00000008
+#endif
+
+#ifndef GL_PGI_misc_hints
+#define GL_PREFER_DOUBLEBUFFER_HINT_PGI   0x1A1F8
+#define GL_CONSERVE_MEMORY_HINT_PGI       0x1A1FD
+#define GL_RECLAIM_MEMORY_HINT_PGI        0x1A1FE
+#define GL_NATIVE_GRAPHICS_HANDLE_PGI     0x1A202
+#define GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI 0x1A203
+#define GL_NATIVE_GRAPHICS_END_HINT_PGI   0x1A204
+#define GL_ALWAYS_FAST_HINT_PGI           0x1A20C
+#define GL_ALWAYS_SOFT_HINT_PGI           0x1A20D
+#define GL_ALLOW_DRAW_OBJ_HINT_PGI        0x1A20E
+#define GL_ALLOW_DRAW_WIN_HINT_PGI        0x1A20F
+#define GL_ALLOW_DRAW_FRG_HINT_PGI        0x1A210
+#define GL_ALLOW_DRAW_MEM_HINT_PGI        0x1A211
+#define GL_STRICT_DEPTHFUNC_HINT_PGI      0x1A216
+#define GL_STRICT_LIGHTING_HINT_PGI       0x1A217
+#define GL_STRICT_SCISSOR_HINT_PGI        0x1A218
+#define GL_FULL_STIPPLE_HINT_PGI          0x1A219
+#define GL_CLIP_NEAR_HINT_PGI             0x1A220
+#define GL_CLIP_FAR_HINT_PGI              0x1A221
+#define GL_WIDE_LINE_HINT_PGI             0x1A222
+#define GL_BACK_NORMALS_HINT_PGI          0x1A223
+#endif
+
+#ifndef GL_EXT_paletted_texture
+#define GL_COLOR_INDEX1_EXT               0x80E2
+#define GL_COLOR_INDEX2_EXT               0x80E3
+#define GL_COLOR_INDEX4_EXT               0x80E4
+#define GL_COLOR_INDEX8_EXT               0x80E5
+#define GL_COLOR_INDEX12_EXT              0x80E6
+#define GL_COLOR_INDEX16_EXT              0x80E7
+#define GL_TEXTURE_INDEX_SIZE_EXT         0x80ED
+#endif
+
+#ifndef GL_EXT_clip_volume_hint
+#define GL_CLIP_VOLUME_CLIPPING_HINT_EXT  0x80F0
+#endif
+
+#ifndef GL_SGIX_list_priority
+#define GL_LIST_PRIORITY_SGIX             0x8182
+#endif
+
+#ifndef GL_SGIX_ir_instrument1
+#define GL_IR_INSTRUMENT1_SGIX            0x817F
+#endif
+
+#ifndef GL_SGIX_calligraphic_fragment
+#define GL_CALLIGRAPHIC_FRAGMENT_SGIX     0x8183
+#endif
+
+#ifndef GL_SGIX_texture_lod_bias
+#define GL_TEXTURE_LOD_BIAS_S_SGIX        0x818E
+#define GL_TEXTURE_LOD_BIAS_T_SGIX        0x818F
+#define GL_TEXTURE_LOD_BIAS_R_SGIX        0x8190
+#endif
+
+#ifndef GL_SGIX_shadow_ambient
+#define GL_SHADOW_AMBIENT_SGIX            0x80BF
+#endif
+
+#ifndef GL_EXT_index_texture
+#endif
+
+#ifndef GL_EXT_index_material
+#define GL_INDEX_MATERIAL_EXT             0x81B8
+#define GL_INDEX_MATERIAL_PARAMETER_EXT   0x81B9
+#define GL_INDEX_MATERIAL_FACE_EXT        0x81BA
+#endif
+
+#ifndef GL_EXT_index_func
+#define GL_INDEX_TEST_EXT                 0x81B5
+#define GL_INDEX_TEST_FUNC_EXT            0x81B6
+#define GL_INDEX_TEST_REF_EXT             0x81B7
+#endif
+
+#ifndef GL_EXT_index_array_formats
+#define GL_IUI_V2F_EXT                    0x81AD
+#define GL_IUI_V3F_EXT                    0x81AE
+#define GL_IUI_N3F_V2F_EXT                0x81AF
+#define GL_IUI_N3F_V3F_EXT                0x81B0
+#define GL_T2F_IUI_V2F_EXT                0x81B1
+#define GL_T2F_IUI_V3F_EXT                0x81B2
+#define GL_T2F_IUI_N3F_V2F_EXT            0x81B3
+#define GL_T2F_IUI_N3F_V3F_EXT            0x81B4
+#endif
+
+#ifndef GL_EXT_compiled_vertex_array
+#define GL_ARRAY_ELEMENT_LOCK_FIRST_EXT   0x81A8
+#define GL_ARRAY_ELEMENT_LOCK_COUNT_EXT   0x81A9
+#endif
+
+#ifndef GL_EXT_cull_vertex
+#define GL_CULL_VERTEX_EXT                0x81AA
+#define GL_CULL_VERTEX_EYE_POSITION_EXT   0x81AB
+#define GL_CULL_VERTEX_OBJECT_POSITION_EXT 0x81AC
+#endif
+
+#ifndef GL_SGIX_ycrcb
+#define GL_YCRCB_422_SGIX                 0x81BB
+#define GL_YCRCB_444_SGIX                 0x81BC
+#endif
+
+#ifndef GL_SGIX_fragment_lighting
+#define GL_FRAGMENT_LIGHTING_SGIX         0x8400
+#define GL_FRAGMENT_COLOR_MATERIAL_SGIX   0x8401
+#define GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX 0x8402
+#define GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX 0x8403
+#define GL_MAX_FRAGMENT_LIGHTS_SGIX       0x8404
+#define GL_MAX_ACTIVE_LIGHTS_SGIX         0x8405
+#define GL_CURRENT_RASTER_NORMAL_SGIX     0x8406
+#define GL_LIGHT_ENV_MODE_SGIX            0x8407
+#define GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX 0x8408
+#define GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX 0x8409
+#define GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX 0x840A
+#define GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX 0x840B
+#define GL_FRAGMENT_LIGHT0_SGIX           0x840C
+#define GL_FRAGMENT_LIGHT1_SGIX           0x840D
+#define GL_FRAGMENT_LIGHT2_SGIX           0x840E
+#define GL_FRAGMENT_LIGHT3_SGIX           0x840F
+#define GL_FRAGMENT_LIGHT4_SGIX           0x8410
+#define GL_FRAGMENT_LIGHT5_SGIX           0x8411
+#define GL_FRAGMENT_LIGHT6_SGIX           0x8412
+#define GL_FRAGMENT_LIGHT7_SGIX           0x8413
+#endif
+
+#ifndef GL_IBM_rasterpos_clip
+#define GL_RASTER_POSITION_UNCLIPPED_IBM  0x19262
+#endif
+
+#ifndef GL_HP_texture_lighting
+#define GL_TEXTURE_LIGHTING_MODE_HP       0x8167
+#define GL_TEXTURE_POST_SPECULAR_HP       0x8168
+#define GL_TEXTURE_PRE_SPECULAR_HP        0x8169
+#endif
+
+#ifndef GL_EXT_draw_range_elements
+#define GL_MAX_ELEMENTS_VERTICES_EXT      0x80E8
+#define GL_MAX_ELEMENTS_INDICES_EXT       0x80E9
+#endif
+
+#ifndef GL_WIN_phong_shading
+#define GL_PHONG_WIN                      0x80EA
+#define GL_PHONG_HINT_WIN                 0x80EB
+#endif
+
+#ifndef GL_WIN_specular_fog
+#define GL_FOG_SPECULAR_TEXTURE_WIN       0x80EC
+#endif
+
+#ifndef GL_EXT_light_texture
+#define GL_FRAGMENT_MATERIAL_EXT          0x8349
+#define GL_FRAGMENT_NORMAL_EXT            0x834A
+#define GL_FRAGMENT_COLOR_EXT             0x834C
+#define GL_ATTENUATION_EXT                0x834D
+#define GL_SHADOW_ATTENUATION_EXT         0x834E
+#define GL_TEXTURE_APPLICATION_MODE_EXT   0x834F
+#define GL_TEXTURE_LIGHT_EXT              0x8350
+#define GL_TEXTURE_MATERIAL_FACE_EXT      0x8351
+#define GL_TEXTURE_MATERIAL_PARAMETER_EXT 0x8352
+  /* reuse GL_FRAGMENT_DEPTH_EXT */
+#endif
+
+#ifndef GL_SGIX_blend_alpha_minmax
+#define GL_ALPHA_MIN_SGIX                 0x8320
+#define GL_ALPHA_MAX_SGIX                 0x8321
+#endif
+
+#ifndef GL_SGIX_impact_pixel_texture
+#define GL_PIXEL_TEX_GEN_Q_CEILING_SGIX   0x8184
+#define GL_PIXEL_TEX_GEN_Q_ROUND_SGIX     0x8185
+#define GL_PIXEL_TEX_GEN_Q_FLOOR_SGIX     0x8186
+#define GL_PIXEL_TEX_GEN_ALPHA_REPLACE_SGIX 0x8187
+#define GL_PIXEL_TEX_GEN_ALPHA_NO_REPLACE_SGIX 0x8188
+#define GL_PIXEL_TEX_GEN_ALPHA_LS_SGIX    0x8189
+#define GL_PIXEL_TEX_GEN_ALPHA_MS_SGIX    0x818A
+#endif
+
+#ifndef GL_EXT_bgra
+#define GL_BGR_EXT                        0x80E0
+#define GL_BGRA_EXT                       0x80E1
+#endif
+
+#ifndef GL_SGIX_async
+#define GL_ASYNC_MARKER_SGIX              0x8329
+#endif
+
+#ifndef GL_SGIX_async_pixel
+#define GL_ASYNC_TEX_IMAGE_SGIX           0x835C
+#define GL_ASYNC_DRAW_PIXELS_SGIX         0x835D
+#define GL_ASYNC_READ_PIXELS_SGIX         0x835E
+#define GL_MAX_ASYNC_TEX_IMAGE_SGIX       0x835F
+#define GL_MAX_ASYNC_DRAW_PIXELS_SGIX     0x8360
+#define GL_MAX_ASYNC_READ_PIXELS_SGIX     0x8361
+#endif
+
+#ifndef GL_SGIX_async_histogram
+#define GL_ASYNC_HISTOGRAM_SGIX           0x832C
+#define GL_MAX_ASYNC_HISTOGRAM_SGIX       0x832D
+#endif
+
+#ifndef GL_INTEL_texture_scissor
+#endif
+
+#ifndef GL_INTEL_parallel_arrays
+#define GL_PARALLEL_ARRAYS_INTEL          0x83F4
+#define GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL 0x83F5
+#define GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL 0x83F6
+#define GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL 0x83F7
+#define GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL 0x83F8
+#endif
+
+#ifndef GL_HP_occlusion_test
+#define GL_OCCLUSION_TEST_HP              0x8165
+#define GL_OCCLUSION_TEST_RESULT_HP       0x8166
+#endif
+
+#ifndef GL_EXT_pixel_transform
+#define GL_PIXEL_TRANSFORM_2D_EXT         0x8330
+#define GL_PIXEL_MAG_FILTER_EXT           0x8331
+#define GL_PIXEL_MIN_FILTER_EXT           0x8332
+#define GL_PIXEL_CUBIC_WEIGHT_EXT         0x8333
+#define GL_CUBIC_EXT                      0x8334
+#define GL_AVERAGE_EXT                    0x8335
+#define GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT 0x8336
+#define GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT 0x8337
+#define GL_PIXEL_TRANSFORM_2D_MATRIX_EXT  0x8338
+#endif
+
+#ifndef GL_EXT_pixel_transform_color_table
+#endif
+
+#ifndef GL_EXT_shared_texture_palette
+#define GL_SHARED_TEXTURE_PALETTE_EXT     0x81FB
+#endif
+
+#ifndef GL_EXT_separate_specular_color
+#define GL_LIGHT_MODEL_COLOR_CONTROL_EXT  0x81F8
+#define GL_SINGLE_COLOR_EXT               0x81F9
+#define GL_SEPARATE_SPECULAR_COLOR_EXT    0x81FA
+#endif
+
+#ifndef GL_EXT_secondary_color
+#define GL_COLOR_SUM_EXT                  0x8458
+#define GL_CURRENT_SECONDARY_COLOR_EXT    0x8459
+#define GL_SECONDARY_COLOR_ARRAY_SIZE_EXT 0x845A
+#define GL_SECONDARY_COLOR_ARRAY_TYPE_EXT 0x845B
+#define GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT 0x845C
+#define GL_SECONDARY_COLOR_ARRAY_POINTER_EXT 0x845D
+#define GL_SECONDARY_COLOR_ARRAY_EXT      0x845E
+#endif
+
+#ifndef GL_EXT_texture_perturb_normal
+#define GL_PERTURB_EXT                    0x85AE
+#define GL_TEXTURE_NORMAL_EXT             0x85AF
+#endif
+
+#ifndef GL_EXT_multi_draw_arrays
+#endif
+
+#ifndef GL_EXT_fog_coord
+#define GL_FOG_COORDINATE_SOURCE_EXT      0x8450
+#define GL_FOG_COORDINATE_EXT             0x8451
+#define GL_FRAGMENT_DEPTH_EXT             0x8452
+#define GL_CURRENT_FOG_COORDINATE_EXT     0x8453
+#define GL_FOG_COORDINATE_ARRAY_TYPE_EXT  0x8454
+#define GL_FOG_COORDINATE_ARRAY_STRIDE_EXT 0x8455
+#define GL_FOG_COORDINATE_ARRAY_POINTER_EXT 0x8456
+#define GL_FOG_COORDINATE_ARRAY_EXT       0x8457
+#endif
+
+#ifndef GL_REND_screen_coordinates
+#define GL_SCREEN_COORDINATES_REND        0x8490
+#define GL_INVERTED_SCREEN_W_REND         0x8491
+#endif
+
+#ifndef GL_EXT_coordinate_frame
+#define GL_TANGENT_ARRAY_EXT              0x8439
+#define GL_BINORMAL_ARRAY_EXT             0x843A
+#define GL_CURRENT_TANGENT_EXT            0x843B
+#define GL_CURRENT_BINORMAL_EXT           0x843C
+#define GL_TANGENT_ARRAY_TYPE_EXT         0x843E
+#define GL_TANGENT_ARRAY_STRIDE_EXT       0x843F
+#define GL_BINORMAL_ARRAY_TYPE_EXT        0x8440
+#define GL_BINORMAL_ARRAY_STRIDE_EXT      0x8441
+#define GL_TANGENT_ARRAY_POINTER_EXT      0x8442
+#define GL_BINORMAL_ARRAY_POINTER_EXT     0x8443
+#define GL_MAP1_TANGENT_EXT               0x8444
+#define GL_MAP2_TANGENT_EXT               0x8445
+#define GL_MAP1_BINORMAL_EXT              0x8446
+#define GL_MAP2_BINORMAL_EXT              0x8447
+#endif
+
+#ifndef GL_EXT_texture_env_combine
+#define GL_COMBINE_EXT                    0x8570
+#define GL_COMBINE_RGB_EXT                0x8571
+#define GL_COMBINE_ALPHA_EXT              0x8572
+#define GL_RGB_SCALE_EXT                  0x8573
+#define GL_ADD_SIGNED_EXT                 0x8574
+#define GL_INTERPOLATE_EXT                0x8575
+#define GL_CONSTANT_EXT                   0x8576
+#define GL_PRIMARY_COLOR_EXT              0x8577
+#define GL_PREVIOUS_EXT                   0x8578
+#define GL_SOURCE0_RGB_EXT                0x8580
+#define GL_SOURCE1_RGB_EXT                0x8581
+#define GL_SOURCE2_RGB_EXT                0x8582
+#define GL_SOURCE0_ALPHA_EXT              0x8588
+#define GL_SOURCE1_ALPHA_EXT              0x8589
+#define GL_SOURCE2_ALPHA_EXT              0x858A
+#define GL_OPERAND0_RGB_EXT               0x8590
+#define GL_OPERAND1_RGB_EXT               0x8591
+#define GL_OPERAND2_RGB_EXT               0x8592
+#define GL_OPERAND0_ALPHA_EXT             0x8598
+#define GL_OPERAND1_ALPHA_EXT             0x8599
+#define GL_OPERAND2_ALPHA_EXT             0x859A
+#endif
+
+#ifndef GL_APPLE_specular_vector
+#define GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE 0x85B0
+#endif
+
+#ifndef GL_APPLE_transform_hint
+#define GL_TRANSFORM_HINT_APPLE           0x85B1
+#endif
+
+#ifndef GL_SGIX_fog_scale
+#define GL_FOG_SCALE_SGIX                 0x81FC
+#define GL_FOG_SCALE_VALUE_SGIX           0x81FD
+#endif
+
+#ifndef GL_SUNX_constant_data
+#define GL_UNPACK_CONSTANT_DATA_SUNX      0x81D5
+#define GL_TEXTURE_CONSTANT_DATA_SUNX     0x81D6
+#endif
+
+#ifndef GL_SUN_global_alpha
+#define GL_GLOBAL_ALPHA_SUN               0x81D9
+#define GL_GLOBAL_ALPHA_FACTOR_SUN        0x81DA
+#endif
+
+#ifndef GL_SUN_triangle_list
+#define GL_RESTART_SUN                    0x0001
+#define GL_REPLACE_MIDDLE_SUN             0x0002
+#define GL_REPLACE_OLDEST_SUN             0x0003
+#define GL_TRIANGLE_LIST_SUN              0x81D7
+#define GL_REPLACEMENT_CODE_SUN           0x81D8
+#define GL_REPLACEMENT_CODE_ARRAY_SUN     0x85C0
+#define GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN 0x85C1
+#define GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN 0x85C2
+#define GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN 0x85C3
+#define GL_R1UI_V3F_SUN                   0x85C4
+#define GL_R1UI_C4UB_V3F_SUN              0x85C5
+#define GL_R1UI_C3F_V3F_SUN               0x85C6
+#define GL_R1UI_N3F_V3F_SUN               0x85C7
+#define GL_R1UI_C4F_N3F_V3F_SUN           0x85C8
+#define GL_R1UI_T2F_V3F_SUN               0x85C9
+#define GL_R1UI_T2F_N3F_V3F_SUN           0x85CA
+#define GL_R1UI_T2F_C4F_N3F_V3F_SUN       0x85CB
+#endif
+
+#ifndef GL_SUN_vertex
+#endif
+
+#ifndef GL_EXT_blend_func_separate
+#define GL_BLEND_DST_RGB_EXT              0x80C8
+#define GL_BLEND_SRC_RGB_EXT              0x80C9
+#define GL_BLEND_DST_ALPHA_EXT            0x80CA
+#define GL_BLEND_SRC_ALPHA_EXT            0x80CB
+#endif
+
+#ifndef GL_INGR_color_clamp
+#define GL_RED_MIN_CLAMP_INGR             0x8560
+#define GL_GREEN_MIN_CLAMP_INGR           0x8561
+#define GL_BLUE_MIN_CLAMP_INGR            0x8562
+#define GL_ALPHA_MIN_CLAMP_INGR           0x8563
+#define GL_RED_MAX_CLAMP_INGR             0x8564
+#define GL_GREEN_MAX_CLAMP_INGR           0x8565
+#define GL_BLUE_MAX_CLAMP_INGR            0x8566
+#define GL_ALPHA_MAX_CLAMP_INGR           0x8567
+#endif
+
+#ifndef GL_INGR_interlace_read
+#define GL_INTERLACE_READ_INGR            0x8568
+#endif
+
+#ifndef GL_EXT_stencil_wrap
+#define GL_INCR_WRAP_EXT                  0x8507
+#define GL_DECR_WRAP_EXT                  0x8508
+#endif
+
+#ifndef GL_EXT_422_pixels
+#define GL_422_EXT                        0x80CC
+#define GL_422_REV_EXT                    0x80CD
+#define GL_422_AVERAGE_EXT                0x80CE
+#define GL_422_REV_AVERAGE_EXT            0x80CF
+#endif
+
+#ifndef GL_NV_texgen_reflection
+#define GL_NORMAL_MAP_NV                  0x8511
+#define GL_REFLECTION_MAP_NV              0x8512
+#endif
+
+#ifndef GL_EXT_texture_cube_map
+#define GL_NORMAL_MAP_EXT                 0x8511
+#define GL_REFLECTION_MAP_EXT             0x8512
+#define GL_TEXTURE_CUBE_MAP_EXT           0x8513
+#define GL_TEXTURE_BINDING_CUBE_MAP_EXT   0x8514
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT 0x8515
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT 0x8516
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT 0x8517
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT 0x8518
+#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT 0x8519
+#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT 0x851A
+#define GL_PROXY_TEXTURE_CUBE_MAP_EXT     0x851B
+#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT  0x851C
+#endif
+
+#ifndef GL_SUN_convolution_border_modes
+#define GL_WRAP_BORDER_SUN                0x81D4
+#endif
+
+#ifndef GL_EXT_texture_env_add
+#endif
+
+#ifndef GL_EXT_texture_lod_bias
+#define GL_MAX_TEXTURE_LOD_BIAS_EXT       0x84FD
+#define GL_TEXTURE_FILTER_CONTROL_EXT     0x8500
+#define GL_TEXTURE_LOD_BIAS_EXT           0x8501
+#endif
+
+#ifndef GL_EXT_texture_filter_anisotropic
+#define GL_TEXTURE_MAX_ANISOTROPY_EXT     0x84FE
+#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT 0x84FF
+#endif
+
+#ifndef GL_EXT_vertex_weighting
+#define GL_MODELVIEW0_STACK_DEPTH_EXT     GL_MODELVIEW_STACK_DEPTH
+#define GL_MODELVIEW1_STACK_DEPTH_EXT     0x8502
+#define GL_MODELVIEW0_MATRIX_EXT          GL_MODELVIEW_MATRIX
+#define GL_MODELVIEW1_MATRIX_EXT          0x8506
+#define GL_VERTEX_WEIGHTING_EXT           0x8509
+#define GL_MODELVIEW0_EXT                 GL_MODELVIEW
+#define GL_MODELVIEW1_EXT                 0x850A
+#define GL_CURRENT_VERTEX_WEIGHT_EXT      0x850B
+#define GL_VERTEX_WEIGHT_ARRAY_EXT        0x850C
+#define GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT   0x850D
+#define GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT   0x850E
+#define GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT 0x850F
+#define GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT 0x8510
+#endif
+
+#ifndef GL_NV_light_max_exponent
+#define GL_MAX_SHININESS_NV               0x8504
+#define GL_MAX_SPOT_EXPONENT_NV           0x8505
+#endif
+
+#ifndef GL_NV_vertex_array_range
+#define GL_VERTEX_ARRAY_RANGE_NV          0x851D
+#define GL_VERTEX_ARRAY_RANGE_LENGTH_NV   0x851E
+#define GL_VERTEX_ARRAY_RANGE_VALID_NV    0x851F
+#define GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV 0x8520
+#define GL_VERTEX_ARRAY_RANGE_POINTER_NV  0x8521
+#endif
+
+#ifndef GL_NV_register_combiners
+#define GL_REGISTER_COMBINERS_NV          0x8522
+#define GL_VARIABLE_A_NV                  0x8523
+#define GL_VARIABLE_B_NV                  0x8524
+#define GL_VARIABLE_C_NV                  0x8525
+#define GL_VARIABLE_D_NV                  0x8526
+#define GL_VARIABLE_E_NV                  0x8527
+#define GL_VARIABLE_F_NV                  0x8528
+#define GL_VARIABLE_G_NV                  0x8529
+#define GL_CONSTANT_COLOR0_NV             0x852A
+#define GL_CONSTANT_COLOR1_NV             0x852B
+#define GL_PRIMARY_COLOR_NV               0x852C
+#define GL_SECONDARY_COLOR_NV             0x852D
+#define GL_SPARE0_NV                      0x852E
+#define GL_SPARE1_NV                      0x852F
+#define GL_DISCARD_NV                     0x8530
+#define GL_E_TIMES_F_NV                   0x8531
+#define GL_SPARE0_PLUS_SECONDARY_COLOR_NV 0x8532
+#define GL_UNSIGNED_IDENTITY_NV           0x8536
+#define GL_UNSIGNED_INVERT_NV             0x8537
+#define GL_EXPAND_NORMAL_NV               0x8538
+#define GL_EXPAND_NEGATE_NV               0x8539
+#define GL_HALF_BIAS_NORMAL_NV            0x853A
+#define GL_HALF_BIAS_NEGATE_NV            0x853B
+#define GL_SIGNED_IDENTITY_NV             0x853C
+#define GL_SIGNED_NEGATE_NV               0x853D
+#define GL_SCALE_BY_TWO_NV                0x853E
+#define GL_SCALE_BY_FOUR_NV               0x853F
+#define GL_SCALE_BY_ONE_HALF_NV           0x8540
+#define GL_BIAS_BY_NEGATIVE_ONE_HALF_NV   0x8541
+#define GL_COMBINER_INPUT_NV              0x8542
+#define GL_COMBINER_MAPPING_NV            0x8543
+#define GL_COMBINER_COMPONENT_USAGE_NV    0x8544
+#define GL_COMBINER_AB_DOT_PRODUCT_NV     0x8545
+#define GL_COMBINER_CD_DOT_PRODUCT_NV     0x8546
+#define GL_COMBINER_MUX_SUM_NV            0x8547
+#define GL_COMBINER_SCALE_NV              0x8548
+#define GL_COMBINER_BIAS_NV               0x8549
+#define GL_COMBINER_AB_OUTPUT_NV          0x854A
+#define GL_COMBINER_CD_OUTPUT_NV          0x854B
+#define GL_COMBINER_SUM_OUTPUT_NV         0x854C
+#define GL_MAX_GENERAL_COMBINERS_NV       0x854D
+#define GL_NUM_GENERAL_COMBINERS_NV       0x854E
+#define GL_COLOR_SUM_CLAMP_NV             0x854F
+#define GL_COMBINER0_NV                   0x8550
+#define GL_COMBINER1_NV                   0x8551
+#define GL_COMBINER2_NV                   0x8552
+#define GL_COMBINER3_NV                   0x8553
+#define GL_COMBINER4_NV                   0x8554
+#define GL_COMBINER5_NV                   0x8555
+#define GL_COMBINER6_NV                   0x8556
+#define GL_COMBINER7_NV                   0x8557
+  /* reuse GL_TEXTURE0_ARB */
+  /* reuse GL_TEXTURE1_ARB */
+  /* reuse GL_ZERO */
+  /* reuse GL_NONE */
+  /* reuse GL_FOG */
+#endif
+
+#ifndef GL_NV_fog_distance
+#define GL_FOG_DISTANCE_MODE_NV           0x855A
+#define GL_EYE_RADIAL_NV                  0x855B
+#define GL_EYE_PLANE_ABSOLUTE_NV          0x855C
+  /* reuse GL_EYE_PLANE */
+#endif
+
+#ifndef GL_NV_texgen_emboss
+#define GL_EMBOSS_LIGHT_NV                0x855D
+#define GL_EMBOSS_CONSTANT_NV             0x855E
+#define GL_EMBOSS_MAP_NV                  0x855F
+#endif
+
+#ifndef GL_NV_blend_square
+#endif
+
+#ifndef GL_NV_texture_env_combine4
+#define GL_COMBINE4_NV                    0x8503
+#define GL_SOURCE3_RGB_NV                 0x8583
+#define GL_SOURCE3_ALPHA_NV               0x858B
+#define GL_OPERAND3_RGB_NV                0x8593
+#define GL_OPERAND3_ALPHA_NV              0x859B
+#endif
+
+#ifndef GL_MESA_resize_buffers
+#endif
+
+#ifndef GL_MESA_window_pos
+#endif
+
+#ifndef GL_EXT_texture_compression_s3tc
+#define GL_COMPRESSED_RGB_S3TC_DXT1_EXT   0x83F0
+#define GL_COMPRESSED_RGBA_S3TC_DXT1_EXT  0x83F1
+#define GL_COMPRESSED_RGBA_S3TC_DXT3_EXT  0x83F2
+#define GL_COMPRESSED_RGBA_S3TC_DXT5_EXT  0x83F3
+#endif
+
+#ifndef GL_IBM_cull_vertex
+#define GL_CULL_VERTEX_IBM                103050
+#endif
+
+#ifndef GL_IBM_multimode_draw_arrays
+#endif
+
+#ifndef GL_IBM_vertex_array_lists
+#define GL_VERTEX_ARRAY_LIST_IBM          103070
+#define GL_NORMAL_ARRAY_LIST_IBM          103071
+#define GL_COLOR_ARRAY_LIST_IBM           103072
+#define GL_INDEX_ARRAY_LIST_IBM           103073
+#define GL_TEXTURE_COORD_ARRAY_LIST_IBM   103074
+#define GL_EDGE_FLAG_ARRAY_LIST_IBM       103075
+#define GL_FOG_COORDINATE_ARRAY_LIST_IBM  103076
+#define GL_SECONDARY_COLOR_ARRAY_LIST_IBM 103077
+#define GL_VERTEX_ARRAY_LIST_STRIDE_IBM   103080
+#define GL_NORMAL_ARRAY_LIST_STRIDE_IBM   103081
+#define GL_COLOR_ARRAY_LIST_STRIDE_IBM    103082
+#define GL_INDEX_ARRAY_LIST_STRIDE_IBM    103083
+#define GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM 103084
+#define GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM 103085
+#define GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM 103086
+#define GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM 103087
+#endif
+
+#ifndef GL_SGIX_subsample
+#define GL_PACK_SUBSAMPLE_RATE_SGIX       0x85A0
+#define GL_UNPACK_SUBSAMPLE_RATE_SGIX     0x85A1
+#define GL_PIXEL_SUBSAMPLE_4444_SGIX      0x85A2
+#define GL_PIXEL_SUBSAMPLE_2424_SGIX      0x85A3
+#define GL_PIXEL_SUBSAMPLE_4242_SGIX      0x85A4
+#endif
+
+#ifndef GL_SGIX_ycrcb_subsample
+#endif
+
+#ifndef GL_SGIX_ycrcba
+#define GL_YCRCB_SGIX                     0x8318
+#define GL_YCRCBA_SGIX                    0x8319
+#endif
+
+#ifndef GL_SGI_depth_pass_instrument
+#define GL_DEPTH_PASS_INSTRUMENT_SGIX     0x8310
+#define GL_DEPTH_PASS_INSTRUMENT_COUNTERS_SGIX 0x8311
+#define GL_DEPTH_PASS_INSTRUMENT_MAX_SGIX 0x8312
+#endif
+
+#ifndef GL_3DFX_texture_compression_FXT1
+#define GL_COMPRESSED_RGB_FXT1_3DFX       0x86B0
+#define GL_COMPRESSED_RGBA_FXT1_3DFX      0x86B1
+#endif
+
+#ifndef GL_3DFX_multisample
+#define GL_MULTISAMPLE_3DFX               0x86B2
+#define GL_SAMPLE_BUFFERS_3DFX            0x86B3
+#define GL_SAMPLES_3DFX                   0x86B4
+#define GL_MULTISAMPLE_BIT_3DFX           0x20000000
+#endif
+
+#ifndef GL_3DFX_tbuffer
+#endif
+
+#ifndef GL_EXT_multisample
+#define GL_MULTISAMPLE_EXT                0x809D
+#define GL_SAMPLE_ALPHA_TO_MASK_EXT       0x809E
+#define GL_SAMPLE_ALPHA_TO_ONE_EXT        0x809F
+#define GL_SAMPLE_MASK_EXT                0x80A0
+#define GL_1PASS_EXT                      0x80A1
+#define GL_2PASS_0_EXT                    0x80A2
+#define GL_2PASS_1_EXT                    0x80A3
+#define GL_4PASS_0_EXT                    0x80A4
+#define GL_4PASS_1_EXT                    0x80A5
+#define GL_4PASS_2_EXT                    0x80A6
+#define GL_4PASS_3_EXT                    0x80A7
+#define GL_SAMPLE_BUFFERS_EXT             0x80A8
+#define GL_SAMPLES_EXT                    0x80A9
+#define GL_SAMPLE_MASK_VALUE_EXT          0x80AA
+#define GL_SAMPLE_MASK_INVERT_EXT         0x80AB
+#define GL_SAMPLE_PATTERN_EXT             0x80AC
+#define GL_MULTISAMPLE_BIT_EXT            0x20000000
+#endif
+
+#ifndef GL_SGIX_vertex_preclip
+#define GL_VERTEX_PRECLIP_SGIX            0x83EE
+#define GL_VERTEX_PRECLIP_HINT_SGIX       0x83EF
+#endif
+
+#ifndef GL_SGIX_convolution_accuracy
+#define GL_CONVOLUTION_HINT_SGIX          0x8316
+#endif
+
+#ifndef GL_SGIX_resample
+#define GL_PACK_RESAMPLE_SGIX             0x842C
+#define GL_UNPACK_RESAMPLE_SGIX           0x842D
+#define GL_RESAMPLE_REPLICATE_SGIX        0x842E
+#define GL_RESAMPLE_ZERO_FILL_SGIX        0x842F
+#define GL_RESAMPLE_DECIMATE_SGIX         0x8430
+#endif
+
+#ifndef GL_SGIS_point_line_texgen
+#define GL_EYE_DISTANCE_TO_POINT_SGIS     0x81F0
+#define GL_OBJECT_DISTANCE_TO_POINT_SGIS  0x81F1
+#define GL_EYE_DISTANCE_TO_LINE_SGIS      0x81F2
+#define GL_OBJECT_DISTANCE_TO_LINE_SGIS   0x81F3
+#define GL_EYE_POINT_SGIS                 0x81F4
+#define GL_OBJECT_POINT_SGIS              0x81F5
+#define GL_EYE_LINE_SGIS                  0x81F6
+#define GL_OBJECT_LINE_SGIS               0x81F7
+#endif
+
+#ifndef GL_SGIS_texture_color_mask
+#define GL_TEXTURE_COLOR_WRITEMASK_SGIS   0x81EF
+#endif
+
+#ifndef GL_EXT_texture_env_dot3
+#define GL_DOT3_RGB_EXT                   0x8740
+#define GL_DOT3_RGBA_EXT                  0x8741
+#endif
+
+#ifndef GL_ATI_texture_mirror_once
+#define GL_MIRROR_CLAMP_ATI               0x8742
+#define GL_MIRROR_CLAMP_TO_EDGE_ATI       0x8743
+#endif
+
+#ifndef GL_NV_fence
+#define GL_ALL_COMPLETED_NV               0x84F2
+#define GL_FENCE_STATUS_NV                0x84F3
+#define GL_FENCE_CONDITION_NV             0x84F4
+#endif
+
+#ifndef GL_IBM_texture_mirrored_repeat
+#define GL_MIRRORED_REPEAT_IBM            0x8370
+#endif
+
+#ifndef GL_NV_evaluators
+#define GL_EVAL_2D_NV                     0x86C0
+#define GL_EVAL_TRIANGULAR_2D_NV          0x86C1
+#define GL_MAP_TESSELLATION_NV            0x86C2
+#define GL_MAP_ATTRIB_U_ORDER_NV          0x86C3
+#define GL_MAP_ATTRIB_V_ORDER_NV          0x86C4
+#define GL_EVAL_FRACTIONAL_TESSELLATION_NV 0x86C5
+#define GL_EVAL_VERTEX_ATTRIB0_NV         0x86C6
+#define GL_EVAL_VERTEX_ATTRIB1_NV         0x86C7
+#define GL_EVAL_VERTEX_ATTRIB2_NV         0x86C8
+#define GL_EVAL_VERTEX_ATTRIB3_NV         0x86C9
+#define GL_EVAL_VERTEX_ATTRIB4_NV         0x86CA
+#define GL_EVAL_VERTEX_ATTRIB5_NV         0x86CB
+#define GL_EVAL_VERTEX_ATTRIB6_NV         0x86CC
+#define GL_EVAL_VERTEX_ATTRIB7_NV         0x86CD
+#define GL_EVAL_VERTEX_ATTRIB8_NV         0x86CE
+#define GL_EVAL_VERTEX_ATTRIB9_NV         0x86CF
+#define GL_EVAL_VERTEX_ATTRIB10_NV        0x86D0
+#define GL_EVAL_VERTEX_ATTRIB11_NV        0x86D1
+#define GL_EVAL_VERTEX_ATTRIB12_NV        0x86D2
+#define GL_EVAL_VERTEX_ATTRIB13_NV        0x86D3
+#define GL_EVAL_VERTEX_ATTRIB14_NV        0x86D4
+#define GL_EVAL_VERTEX_ATTRIB15_NV        0x86D5
+#define GL_MAX_MAP_TESSELLATION_NV        0x86D6
+#define GL_MAX_RATIONAL_EVAL_ORDER_NV     0x86D7
+#endif
+
+#ifndef GL_NV_packed_depth_stencil
+#define GL_DEPTH_STENCIL_NV               0x84F9
+#define GL_UNSIGNED_INT_24_8_NV           0x84FA
+#endif
+
+#ifndef GL_NV_register_combiners2
+#define GL_PER_STAGE_CONSTANTS_NV         0x8535
+#endif
+
+#ifndef GL_NV_texture_compression_vtc
+#endif
+
+#ifndef GL_NV_texture_rectangle
+#define GL_TEXTURE_RECTANGLE_NV           0x84F5
+#define GL_TEXTURE_BINDING_RECTANGLE_NV   0x84F6
+#define GL_PROXY_TEXTURE_RECTANGLE_NV     0x84F7
+#define GL_MAX_RECTANGLE_TEXTURE_SIZE_NV  0x84F8
+#endif
+
+#ifndef GL_NV_texture_shader
+#define GL_OFFSET_TEXTURE_RECTANGLE_NV    0x864C
+#define GL_OFFSET_TEXTURE_RECTANGLE_SCALE_NV 0x864D
+#define GL_DOT_PRODUCT_TEXTURE_RECTANGLE_NV 0x864E
+#define GL_RGBA_UNSIGNED_DOT_PRODUCT_MAPPING_NV 0x86D9
+#define GL_UNSIGNED_INT_S8_S8_8_8_NV      0x86DA
+#define GL_UNSIGNED_INT_8_8_S8_S8_REV_NV  0x86DB
+#define GL_DSDT_MAG_INTENSITY_NV          0x86DC
+#define GL_SHADER_CONSISTENT_NV           0x86DD
+#define GL_TEXTURE_SHADER_NV              0x86DE
+#define GL_SHADER_OPERATION_NV            0x86DF
+#define GL_CULL_MODES_NV                  0x86E0
+#define GL_OFFSET_TEXTURE_MATRIX_NV       0x86E1
+#define GL_OFFSET_TEXTURE_SCALE_NV        0x86E2
+#define GL_OFFSET_TEXTURE_BIAS_NV         0x86E3
+#define GL_OFFSET_TEXTURE_2D_MATRIX_NV    GL_OFFSET_TEXTURE_MATRIX_NV
+#define GL_OFFSET_TEXTURE_2D_SCALE_NV     GL_OFFSET_TEXTURE_SCALE_NV
+#define GL_OFFSET_TEXTURE_2D_BIAS_NV      GL_OFFSET_TEXTURE_BIAS_NV
+#define GL_PREVIOUS_TEXTURE_INPUT_NV      0x86E4
+#define GL_CONST_EYE_NV                   0x86E5
+#define GL_PASS_THROUGH_NV                0x86E6
+#define GL_CULL_FRAGMENT_NV               0x86E7
+#define GL_OFFSET_TEXTURE_2D_NV           0x86E8
+#define GL_DEPENDENT_AR_TEXTURE_2D_NV     0x86E9
+#define GL_DEPENDENT_GB_TEXTURE_2D_NV     0x86EA
+#define GL_DOT_PRODUCT_NV                 0x86EC
+#define GL_DOT_PRODUCT_DEPTH_REPLACE_NV   0x86ED
+#define GL_DOT_PRODUCT_TEXTURE_2D_NV      0x86EE
+#define GL_DOT_PRODUCT_TEXTURE_CUBE_MAP_NV 0x86F0
+#define GL_DOT_PRODUCT_DIFFUSE_CUBE_MAP_NV 0x86F1
+#define GL_DOT_PRODUCT_REFLECT_CUBE_MAP_NV 0x86F2
+#define GL_DOT_PRODUCT_CONST_EYE_REFLECT_CUBE_MAP_NV 0x86F3
+#define GL_HILO_NV                        0x86F4
+#define GL_DSDT_NV                        0x86F5
+#define GL_DSDT_MAG_NV                    0x86F6
+#define GL_DSDT_MAG_VIB_NV                0x86F7
+#define GL_HILO16_NV                      0x86F8
+#define GL_SIGNED_HILO_NV                 0x86F9
+#define GL_SIGNED_HILO16_NV               0x86FA
+#define GL_SIGNED_RGBA_NV                 0x86FB
+#define GL_SIGNED_RGBA8_NV                0x86FC
+#define GL_SIGNED_RGB_NV                  0x86FE
+#define GL_SIGNED_RGB8_NV                 0x86FF
+#define GL_SIGNED_LUMINANCE_NV            0x8701
+#define GL_SIGNED_LUMINANCE8_NV           0x8702
+#define GL_SIGNED_LUMINANCE_ALPHA_NV      0x8703
+#define GL_SIGNED_LUMINANCE8_ALPHA8_NV    0x8704
+#define GL_SIGNED_ALPHA_NV                0x8705
+#define GL_SIGNED_ALPHA8_NV               0x8706
+#define GL_SIGNED_INTENSITY_NV            0x8707
+#define GL_SIGNED_INTENSITY8_NV           0x8708
+#define GL_DSDT8_NV                       0x8709
+#define GL_DSDT8_MAG8_NV                  0x870A
+#define GL_DSDT8_MAG8_INTENSITY8_NV       0x870B
+#define GL_SIGNED_RGB_UNSIGNED_ALPHA_NV   0x870C
+#define GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV 0x870D
+#define GL_HI_SCALE_NV                    0x870E
+#define GL_LO_SCALE_NV                    0x870F
+#define GL_DS_SCALE_NV                    0x8710
+#define GL_DT_SCALE_NV                    0x8711
+#define GL_MAGNITUDE_SCALE_NV             0x8712
+#define GL_VIBRANCE_SCALE_NV              0x8713
+#define GL_HI_BIAS_NV                     0x8714
+#define GL_LO_BIAS_NV                     0x8715
+#define GL_DS_BIAS_NV                     0x8716
+#define GL_DT_BIAS_NV                     0x8717
+#define GL_MAGNITUDE_BIAS_NV              0x8718
+#define GL_VIBRANCE_BIAS_NV               0x8719
+#define GL_TEXTURE_BORDER_VALUES_NV       0x871A
+#define GL_TEXTURE_HI_SIZE_NV             0x871B
+#define GL_TEXTURE_LO_SIZE_NV             0x871C
+#define GL_TEXTURE_DS_SIZE_NV             0x871D
+#define GL_TEXTURE_DT_SIZE_NV             0x871E
+#define GL_TEXTURE_MAG_SIZE_NV            0x871F
+#endif
+
+#ifndef GL_NV_texture_shader2
+#define GL_DOT_PRODUCT_TEXTURE_3D_NV      0x86EF
+#endif
+
+#ifndef GL_NV_vertex_array_range2
+#define GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV 0x8533
+#endif
+
+#ifndef GL_NV_vertex_program
+#define GL_VERTEX_PROGRAM_NV              0x8620
+#define GL_VERTEX_STATE_PROGRAM_NV        0x8621
+#define GL_ATTRIB_ARRAY_SIZE_NV           0x8623
+#define GL_ATTRIB_ARRAY_STRIDE_NV         0x8624
+#define GL_ATTRIB_ARRAY_TYPE_NV           0x8625
+#define GL_CURRENT_ATTRIB_NV              0x8626
+#define GL_PROGRAM_LENGTH_NV              0x8627
+#define GL_PROGRAM_STRING_NV              0x8628
+#define GL_MODELVIEW_PROJECTION_NV        0x8629
+#define GL_IDENTITY_NV                    0x862A
+#define GL_INVERSE_NV                     0x862B
+#define GL_TRANSPOSE_NV                   0x862C
+#define GL_INVERSE_TRANSPOSE_NV           0x862D
+#define GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV 0x862E
+#define GL_MAX_TRACK_MATRICES_NV          0x862F
+#define GL_MATRIX0_NV                     0x8630
+#define GL_MATRIX1_NV                     0x8631
+#define GL_MATRIX2_NV                     0x8632
+#define GL_MATRIX3_NV                     0x8633
+#define GL_MATRIX4_NV                     0x8634
+#define GL_MATRIX5_NV                     0x8635
+#define GL_MATRIX6_NV                     0x8636
+#define GL_MATRIX7_NV                     0x8637
+#define GL_CURRENT_MATRIX_STACK_DEPTH_NV  0x8640
+#define GL_CURRENT_MATRIX_NV              0x8641
+#define GL_VERTEX_PROGRAM_POINT_SIZE_NV   0x8642
+#define GL_VERTEX_PROGRAM_TWO_SIDE_NV     0x8643
+#define GL_PROGRAM_PARAMETER_NV           0x8644
+#define GL_ATTRIB_ARRAY_POINTER_NV        0x8645
+#define GL_PROGRAM_TARGET_NV              0x8646
+#define GL_PROGRAM_RESIDENT_NV            0x8647
+#define GL_TRACK_MATRIX_NV                0x8648
+#define GL_TRACK_MATRIX_TRANSFORM_NV      0x8649
+#define GL_VERTEX_PROGRAM_BINDING_NV      0x864A
+#define GL_PROGRAM_ERROR_POSITION_NV      0x864B
+#define GL_VERTEX_ATTRIB_ARRAY0_NV        0x8650
+#define GL_VERTEX_ATTRIB_ARRAY1_NV        0x8651
+#define GL_VERTEX_ATTRIB_ARRAY2_NV        0x8652
+#define GL_VERTEX_ATTRIB_ARRAY3_NV        0x8653
+#define GL_VERTEX_ATTRIB_ARRAY4_NV        0x8654
+#define GL_VERTEX_ATTRIB_ARRAY5_NV        0x8655
+#define GL_VERTEX_ATTRIB_ARRAY6_NV        0x8656
+#define GL_VERTEX_ATTRIB_ARRAY7_NV        0x8657
+#define GL_VERTEX_ATTRIB_ARRAY8_NV        0x8658
+#define GL_VERTEX_ATTRIB_ARRAY9_NV        0x8659
+#define GL_VERTEX_ATTRIB_ARRAY10_NV       0x865A
+#define GL_VERTEX_ATTRIB_ARRAY11_NV       0x865B
+#define GL_VERTEX_ATTRIB_ARRAY12_NV       0x865C
+#define GL_VERTEX_ATTRIB_ARRAY13_NV       0x865D
+#define GL_VERTEX_ATTRIB_ARRAY14_NV       0x865E
+#define GL_VERTEX_ATTRIB_ARRAY15_NV       0x865F
+#define GL_MAP1_VERTEX_ATTRIB0_4_NV       0x8660
+#define GL_MAP1_VERTEX_ATTRIB1_4_NV       0x8661
+#define GL_MAP1_VERTEX_ATTRIB2_4_NV       0x8662
+#define GL_MAP1_VERTEX_ATTRIB3_4_NV       0x8663
+#define GL_MAP1_VERTEX_ATTRIB4_4_NV       0x8664
+#define GL_MAP1_VERTEX_ATTRIB5_4_NV       0x8665
+#define GL_MAP1_VERTEX_ATTRIB6_4_NV       0x8666
+#define GL_MAP1_VERTEX_ATTRIB7_4_NV       0x8667
+#define GL_MAP1_VERTEX_ATTRIB8_4_NV       0x8668
+#define GL_MAP1_VERTEX_ATTRIB9_4_NV       0x8669
+#define GL_MAP1_VERTEX_ATTRIB10_4_NV      0x866A
+#define GL_MAP1_VERTEX_ATTRIB11_4_NV      0x866B
+#define GL_MAP1_VERTEX_ATTRIB12_4_NV      0x866C
+#define GL_MAP1_VERTEX_ATTRIB13_4_NV      0x866D
+#define GL_MAP1_VERTEX_ATTRIB14_4_NV      0x866E
+#define GL_MAP1_VERTEX_ATTRIB15_4_NV      0x866F
+#define GL_MAP2_VERTEX_ATTRIB0_4_NV       0x8670
+#define GL_MAP2_VERTEX_ATTRIB1_4_NV       0x8671
+#define GL_MAP2_VERTEX_ATTRIB2_4_NV       0x8672
+#define GL_MAP2_VERTEX_ATTRIB3_4_NV       0x8673
+#define GL_MAP2_VERTEX_ATTRIB4_4_NV       0x8674
+#define GL_MAP2_VERTEX_ATTRIB5_4_NV       0x8675
+#define GL_MAP2_VERTEX_ATTRIB6_4_NV       0x8676
+#define GL_MAP2_VERTEX_ATTRIB7_4_NV       0x8677
+#define GL_MAP2_VERTEX_ATTRIB8_4_NV       0x8678
+#define GL_MAP2_VERTEX_ATTRIB9_4_NV       0x8679
+#define GL_MAP2_VERTEX_ATTRIB10_4_NV      0x867A
+#define GL_MAP2_VERTEX_ATTRIB11_4_NV      0x867B
+#define GL_MAP2_VERTEX_ATTRIB12_4_NV      0x867C
+#define GL_MAP2_VERTEX_ATTRIB13_4_NV      0x867D
+#define GL_MAP2_VERTEX_ATTRIB14_4_NV      0x867E
+#define GL_MAP2_VERTEX_ATTRIB15_4_NV      0x867F
+#endif
+
+#ifndef GL_SGIX_texture_coordinate_clamp
+#define GL_TEXTURE_MAX_CLAMP_S_SGIX       0x8369
+#define GL_TEXTURE_MAX_CLAMP_T_SGIX       0x836A
+#define GL_TEXTURE_MAX_CLAMP_R_SGIX       0x836B
+#endif
+
+#ifndef GL_SGIX_scalebias_hint
+#define GL_SCALEBIAS_HINT_SGIX            0x8322
+#endif
+
+#ifndef GL_OML_interlace
+#define GL_INTERLACE_OML                  0x8980
+#define GL_INTERLACE_READ_OML             0x8981
+#endif
+
+#ifndef GL_OML_subsample
+#define GL_FORMAT_SUBSAMPLE_24_24_OML     0x8982
+#define GL_FORMAT_SUBSAMPLE_244_244_OML   0x8983
+#endif
+
+#ifndef GL_OML_resample
+#define GL_PACK_RESAMPLE_OML              0x8984
+#define GL_UNPACK_RESAMPLE_OML            0x8985
+#define GL_RESAMPLE_REPLICATE_OML         0x8986
+#define GL_RESAMPLE_ZERO_FILL_OML         0x8987
+#define GL_RESAMPLE_AVERAGE_OML           0x8988
+#define GL_RESAMPLE_DECIMATE_OML          0x8989
+#endif
+
+#ifndef GL_NV_copy_depth_to_color
+#define GL_DEPTH_STENCIL_TO_RGBA_NV       0x886E
+#define GL_DEPTH_STENCIL_TO_BGRA_NV       0x886F
+#endif
+
+#ifndef GL_ATI_envmap_bumpmap
+#define GL_BUMP_ROT_MATRIX_ATI            0x8775
+#define GL_BUMP_ROT_MATRIX_SIZE_ATI       0x8776
+#define GL_BUMP_NUM_TEX_UNITS_ATI         0x8777
+#define GL_BUMP_TEX_UNITS_ATI             0x8778
+#define GL_DUDV_ATI                       0x8779
+#define GL_DU8DV8_ATI                     0x877A
+#define GL_BUMP_ENVMAP_ATI                0x877B
+#define GL_BUMP_TARGET_ATI                0x877C
+#endif
+
+#ifndef GL_ATI_fragment_shader
+#define GL_FRAGMENT_SHADER_ATI            0x8920
+#define GL_REG_0_ATI                      0x8921
+#define GL_REG_1_ATI                      0x8922
+#define GL_REG_2_ATI                      0x8923
+#define GL_REG_3_ATI                      0x8924
+#define GL_REG_4_ATI                      0x8925
+#define GL_REG_5_ATI                      0x8926
+#define GL_REG_6_ATI                      0x8927
+#define GL_REG_7_ATI                      0x8928
+#define GL_REG_8_ATI                      0x8929
+#define GL_REG_9_ATI                      0x892A
+#define GL_REG_10_ATI                     0x892B
+#define GL_REG_11_ATI                     0x892C
+#define GL_REG_12_ATI                     0x892D
+#define GL_REG_13_ATI                     0x892E
+#define GL_REG_14_ATI                     0x892F
+#define GL_REG_15_ATI                     0x8930
+#define GL_REG_16_ATI                     0x8931
+#define GL_REG_17_ATI                     0x8932
+#define GL_REG_18_ATI                     0x8933
+#define GL_REG_19_ATI                     0x8934
+#define GL_REG_20_ATI                     0x8935
+#define GL_REG_21_ATI                     0x8936
+#define GL_REG_22_ATI                     0x8937
+#define GL_REG_23_ATI                     0x8938
+#define GL_REG_24_ATI                     0x8939
+#define GL_REG_25_ATI                     0x893A
+#define GL_REG_26_ATI                     0x893B
+#define GL_REG_27_ATI                     0x893C
+#define GL_REG_28_ATI                     0x893D
+#define GL_REG_29_ATI                     0x893E
+#define GL_REG_30_ATI                     0x893F
+#define GL_REG_31_ATI                     0x8940
+#define GL_CON_0_ATI                      0x8941
+#define GL_CON_1_ATI                      0x8942
+#define GL_CON_2_ATI                      0x8943
+#define GL_CON_3_ATI                      0x8944
+#define GL_CON_4_ATI                      0x8945
+#define GL_CON_5_ATI                      0x8946
+#define GL_CON_6_ATI                      0x8947
+#define GL_CON_7_ATI                      0x8948
+#define GL_CON_8_ATI                      0x8949
+#define GL_CON_9_ATI                      0x894A
+#define GL_CON_10_ATI                     0x894B
+#define GL_CON_11_ATI                     0x894C
+#define GL_CON_12_ATI                     0x894D
+#define GL_CON_13_ATI                     0x894E
+#define GL_CON_14_ATI                     0x894F
+#define GL_CON_15_ATI                     0x8950
+#define GL_CON_16_ATI                     0x8951
+#define GL_CON_17_ATI                     0x8952
+#define GL_CON_18_ATI                     0x8953
+#define GL_CON_19_ATI                     0x8954
+#define GL_CON_20_ATI                     0x8955
+#define GL_CON_21_ATI                     0x8956
+#define GL_CON_22_ATI                     0x8957
+#define GL_CON_23_ATI                     0x8958
+#define GL_CON_24_ATI                     0x8959
+#define GL_CON_25_ATI                     0x895A
+#define GL_CON_26_ATI                     0x895B
+#define GL_CON_27_ATI                     0x895C
+#define GL_CON_28_ATI                     0x895D
+#define GL_CON_29_ATI                     0x895E
+#define GL_CON_30_ATI                     0x895F
+#define GL_CON_31_ATI                     0x8960
+#define GL_MOV_ATI                        0x8961
+#define GL_ADD_ATI                        0x8963
+#define GL_MUL_ATI                        0x8964
+#define GL_SUB_ATI                        0x8965
+#define GL_DOT3_ATI                       0x8966
+#define GL_DOT4_ATI                       0x8967
+#define GL_MAD_ATI                        0x8968
+#define GL_LERP_ATI                       0x8969
+#define GL_CND_ATI                        0x896A
+#define GL_CND0_ATI                       0x896B
+#define GL_DOT2_ADD_ATI                   0x896C
+#define GL_SECONDARY_INTERPOLATOR_ATI     0x896D
+#define GL_NUM_FRAGMENT_REGISTERS_ATI     0x896E
+#define GL_NUM_FRAGMENT_CONSTANTS_ATI     0x896F
+#define GL_NUM_PASSES_ATI                 0x8970
+#define GL_NUM_INSTRUCTIONS_PER_PASS_ATI  0x8971
+#define GL_NUM_INSTRUCTIONS_TOTAL_ATI     0x8972
+#define GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI 0x8973
+#define GL_NUM_LOOPBACK_COMPONENTS_ATI    0x8974
+#define GL_COLOR_ALPHA_PAIRING_ATI        0x8975
+#define GL_SWIZZLE_STR_ATI                0x8976
+#define GL_SWIZZLE_STQ_ATI                0x8977
+#define GL_SWIZZLE_STR_DR_ATI             0x8978
+#define GL_SWIZZLE_STQ_DQ_ATI             0x8979
+#define GL_SWIZZLE_STRQ_ATI               0x897A
+#define GL_SWIZZLE_STRQ_DQ_ATI            0x897B
+#define GL_RED_BIT_ATI                    0x00000001
+#define GL_GREEN_BIT_ATI                  0x00000002
+#define GL_BLUE_BIT_ATI                   0x00000004
+#define GL_2X_BIT_ATI                     0x00000001
+#define GL_4X_BIT_ATI                     0x00000002
+#define GL_8X_BIT_ATI                     0x00000004
+#define GL_HALF_BIT_ATI                   0x00000008
+#define GL_QUARTER_BIT_ATI                0x00000010
+#define GL_EIGHTH_BIT_ATI                 0x00000020
+#define GL_SATURATE_BIT_ATI               0x00000040
+#define GL_COMP_BIT_ATI                   0x00000002
+#define GL_NEGATE_BIT_ATI                 0x00000004
+#define GL_BIAS_BIT_ATI                   0x00000008
+#endif
+
+#ifndef GL_ATI_pn_triangles
+#define GL_PN_TRIANGLES_ATI               0x87F0
+#define GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI 0x87F1
+#define GL_PN_TRIANGLES_POINT_MODE_ATI    0x87F2
+#define GL_PN_TRIANGLES_NORMAL_MODE_ATI   0x87F3
+#define GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI 0x87F4
+#define GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI 0x87F5
+#define GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI 0x87F6
+#define GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI 0x87F7
+#define GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI 0x87F8
+#endif
+
+#ifndef GL_ATI_vertex_array_object
+#define GL_STATIC_ATI                     0x8760
+#define GL_DYNAMIC_ATI                    0x8761
+#define GL_PRESERVE_ATI                   0x8762
+#define GL_DISCARD_ATI                    0x8763
+#define GL_OBJECT_BUFFER_SIZE_ATI         0x8764
+#define GL_OBJECT_BUFFER_USAGE_ATI        0x8765
+#define GL_ARRAY_OBJECT_BUFFER_ATI        0x8766
+#define GL_ARRAY_OBJECT_OFFSET_ATI        0x8767
+#endif
+
+#ifndef GL_EXT_vertex_shader
+#define GL_VERTEX_SHADER_EXT              0x8780
+#define GL_VERTEX_SHADER_BINDING_EXT      0x8781
+#define GL_OP_INDEX_EXT                   0x8782
+#define GL_OP_NEGATE_EXT                  0x8783
+#define GL_OP_DOT3_EXT                    0x8784
+#define GL_OP_DOT4_EXT                    0x8785
+#define GL_OP_MUL_EXT                     0x8786
+#define GL_OP_ADD_EXT                     0x8787
+#define GL_OP_MADD_EXT                    0x8788
+#define GL_OP_FRAC_EXT                    0x8789
+#define GL_OP_MAX_EXT                     0x878A
+#define GL_OP_MIN_EXT                     0x878B
+#define GL_OP_SET_GE_EXT                  0x878C
+#define GL_OP_SET_LT_EXT                  0x878D
+#define GL_OP_CLAMP_EXT                   0x878E
+#define GL_OP_FLOOR_EXT                   0x878F
+#define GL_OP_ROUND_EXT                   0x8790
+#define GL_OP_EXP_BASE_2_EXT              0x8791
+#define GL_OP_LOG_BASE_2_EXT              0x8792
+#define GL_OP_POWER_EXT                   0x8793
+#define GL_OP_RECIP_EXT                   0x8794
+#define GL_OP_RECIP_SQRT_EXT              0x8795
+#define GL_OP_SUB_EXT                     0x8796
+#define GL_OP_CROSS_PRODUCT_EXT           0x8797
+#define GL_OP_MULTIPLY_MATRIX_EXT         0x8798
+#define GL_OP_MOV_EXT                     0x8799
+#define GL_OUTPUT_VERTEX_EXT              0x879A
+#define GL_OUTPUT_COLOR0_EXT              0x879B
+#define GL_OUTPUT_COLOR1_EXT              0x879C
+#define GL_OUTPUT_TEXTURE_COORD0_EXT      0x879D
+#define GL_OUTPUT_TEXTURE_COORD1_EXT      0x879E
+#define GL_OUTPUT_TEXTURE_COORD2_EXT      0x879F
+#define GL_OUTPUT_TEXTURE_COORD3_EXT      0x87A0
+#define GL_OUTPUT_TEXTURE_COORD4_EXT      0x87A1
+#define GL_OUTPUT_TEXTURE_COORD5_EXT      0x87A2
+#define GL_OUTPUT_TEXTURE_COORD6_EXT      0x87A3
+#define GL_OUTPUT_TEXTURE_COORD7_EXT      0x87A4
+#define GL_OUTPUT_TEXTURE_COORD8_EXT      0x87A5
+#define GL_OUTPUT_TEXTURE_COORD9_EXT      0x87A6
+#define GL_OUTPUT_TEXTURE_COORD10_EXT     0x87A7
+#define GL_OUTPUT_TEXTURE_COORD11_EXT     0x87A8
+#define GL_OUTPUT_TEXTURE_COORD12_EXT     0x87A9
+#define GL_OUTPUT_TEXTURE_COORD13_EXT     0x87AA
+#define GL_OUTPUT_TEXTURE_COORD14_EXT     0x87AB
+#define GL_OUTPUT_TEXTURE_COORD15_EXT     0x87AC
+#define GL_OUTPUT_TEXTURE_COORD16_EXT     0x87AD
+#define GL_OUTPUT_TEXTURE_COORD17_EXT     0x87AE
+#define GL_OUTPUT_TEXTURE_COORD18_EXT     0x87AF
+#define GL_OUTPUT_TEXTURE_COORD19_EXT     0x87B0
+#define GL_OUTPUT_TEXTURE_COORD20_EXT     0x87B1
+#define GL_OUTPUT_TEXTURE_COORD21_EXT     0x87B2
+#define GL_OUTPUT_TEXTURE_COORD22_EXT     0x87B3
+#define GL_OUTPUT_TEXTURE_COORD23_EXT     0x87B4
+#define GL_OUTPUT_TEXTURE_COORD24_EXT     0x87B5
+#define GL_OUTPUT_TEXTURE_COORD25_EXT     0x87B6
+#define GL_OUTPUT_TEXTURE_COORD26_EXT     0x87B7
+#define GL_OUTPUT_TEXTURE_COORD27_EXT     0x87B8
+#define GL_OUTPUT_TEXTURE_COORD28_EXT     0x87B9
+#define GL_OUTPUT_TEXTURE_COORD29_EXT     0x87BA
+#define GL_OUTPUT_TEXTURE_COORD30_EXT     0x87BB
+#define GL_OUTPUT_TEXTURE_COORD31_EXT     0x87BC
+#define GL_OUTPUT_FOG_EXT                 0x87BD
+#define GL_SCALAR_EXT                     0x87BE
+#define GL_VECTOR_EXT                     0x87BF
+#define GL_MATRIX_EXT                     0x87C0
+#define GL_VARIANT_EXT                    0x87C1
+#define GL_INVARIANT_EXT                  0x87C2
+#define GL_LOCAL_CONSTANT_EXT             0x87C3
+#define GL_LOCAL_EXT                      0x87C4
+#define GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT 0x87C5
+#define GL_MAX_VERTEX_SHADER_VARIANTS_EXT 0x87C6
+#define GL_MAX_VERTEX_SHADER_INVARIANTS_EXT 0x87C7
+#define GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT 0x87C8
+#define GL_MAX_VERTEX_SHADER_LOCALS_EXT   0x87C9
+#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT 0x87CA
+#define GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT 0x87CB
+#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT 0x87CC
+#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT 0x87CD
+#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT 0x87CE
+#define GL_VERTEX_SHADER_INSTRUCTIONS_EXT 0x87CF
+#define GL_VERTEX_SHADER_VARIANTS_EXT     0x87D0
+#define GL_VERTEX_SHADER_INVARIANTS_EXT   0x87D1
+#define GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT 0x87D2
+#define GL_VERTEX_SHADER_LOCALS_EXT       0x87D3
+#define GL_VERTEX_SHADER_OPTIMIZED_EXT    0x87D4
+#define GL_X_EXT                          0x87D5
+#define GL_Y_EXT                          0x87D6
+#define GL_Z_EXT                          0x87D7
+#define GL_W_EXT                          0x87D8
+#define GL_NEGATIVE_X_EXT                 0x87D9
+#define GL_NEGATIVE_Y_EXT                 0x87DA
+#define GL_NEGATIVE_Z_EXT                 0x87DB
+#define GL_NEGATIVE_W_EXT                 0x87DC
+#define GL_ZERO_EXT                       0x87DD
+#define GL_ONE_EXT                        0x87DE
+#define GL_NEGATIVE_ONE_EXT               0x87DF
+#define GL_NORMALIZED_RANGE_EXT           0x87E0
+#define GL_FULL_RANGE_EXT                 0x87E1
+#define GL_CURRENT_VERTEX_EXT             0x87E2
+#define GL_MVP_MATRIX_EXT                 0x87E3
+#define GL_VARIANT_VALUE_EXT              0x87E4
+#define GL_VARIANT_DATATYPE_EXT           0x87E5
+#define GL_VARIANT_ARRAY_STRIDE_EXT       0x87E6
+#define GL_VARIANT_ARRAY_TYPE_EXT         0x87E7
+#define GL_VARIANT_ARRAY_EXT              0x87E8
+#define GL_VARIANT_ARRAY_POINTER_EXT      0x87E9
+#define GL_INVARIANT_VALUE_EXT            0x87EA
+#define GL_INVARIANT_DATATYPE_EXT         0x87EB
+#define GL_LOCAL_CONSTANT_VALUE_EXT       0x87EC
+#define GL_LOCAL_CONSTANT_DATATYPE_EXT    0x87ED
+#endif
+
+#ifndef GL_ATI_vertex_streams
+#define GL_MAX_VERTEX_STREAMS_ATI         0x876B
+#define GL_VERTEX_STREAM0_ATI             0x876C
+#define GL_VERTEX_STREAM1_ATI             0x876D
+#define GL_VERTEX_STREAM2_ATI             0x876E
+#define GL_VERTEX_STREAM3_ATI             0x876F
+#define GL_VERTEX_STREAM4_ATI             0x8770
+#define GL_VERTEX_STREAM5_ATI             0x8771
+#define GL_VERTEX_STREAM6_ATI             0x8772
+#define GL_VERTEX_STREAM7_ATI             0x8773
+#define GL_VERTEX_SOURCE_ATI              0x8774
+#endif
+
+#ifndef GL_ATI_element_array
+#define GL_ELEMENT_ARRAY_ATI              0x8768
+#define GL_ELEMENT_ARRAY_TYPE_ATI         0x8769
+#define GL_ELEMENT_ARRAY_POINTER_ATI      0x876A
+#endif
+
+#ifndef GL_SUN_mesh_array
+#define GL_QUAD_MESH_SUN                  0x8614
+#define GL_TRIANGLE_MESH_SUN              0x8615
+#endif
+
+#ifndef GL_SUN_slice_accum
+#define GL_SLICE_ACCUM_SUN                0x85CC
+#endif
+
+#ifndef GL_NV_multisample_filter_hint
+#define GL_MULTISAMPLE_FILTER_HINT_NV     0x8534
+#endif
+
+#ifndef GL_NV_depth_clamp
+#define GL_DEPTH_CLAMP_NV                 0x864F
+#endif
+
+#ifndef GL_NV_occlusion_query
+#define GL_PIXEL_COUNTER_BITS_NV          0x8864
+#define GL_CURRENT_OCCLUSION_QUERY_ID_NV  0x8865
+#define GL_PIXEL_COUNT_NV                 0x8866
+#define GL_PIXEL_COUNT_AVAILABLE_NV       0x8867
+#endif
+
+#ifndef GL_NV_point_sprite
+#define GL_POINT_SPRITE_NV                0x8861
+#define GL_COORD_REPLACE_NV               0x8862
+#define GL_POINT_SPRITE_R_MODE_NV         0x8863
+#endif
+
+#ifndef GL_NV_texture_shader3
+#define GL_OFFSET_PROJECTIVE_TEXTURE_2D_NV 0x8850
+#define GL_OFFSET_PROJECTIVE_TEXTURE_2D_SCALE_NV 0x8851
+#define GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_NV 0x8852
+#define GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_SCALE_NV 0x8853
+#define GL_OFFSET_HILO_TEXTURE_2D_NV      0x8854
+#define GL_OFFSET_HILO_TEXTURE_RECTANGLE_NV 0x8855
+#define GL_OFFSET_HILO_PROJECTIVE_TEXTURE_2D_NV 0x8856
+#define GL_OFFSET_HILO_PROJECTIVE_TEXTURE_RECTANGLE_NV 0x8857
+#define GL_DEPENDENT_HILO_TEXTURE_2D_NV   0x8858
+#define GL_DEPENDENT_RGB_TEXTURE_3D_NV    0x8859
+#define GL_DEPENDENT_RGB_TEXTURE_CUBE_MAP_NV 0x885A
+#define GL_DOT_PRODUCT_PASS_THROUGH_NV    0x885B
+#define GL_DOT_PRODUCT_TEXTURE_1D_NV      0x885C
+#define GL_DOT_PRODUCT_AFFINE_DEPTH_REPLACE_NV 0x885D
+#define GL_HILO8_NV                       0x885E
+#define GL_SIGNED_HILO8_NV                0x885F
+#define GL_FORCE_BLUE_TO_ONE_NV           0x8860
+#endif
+
+#ifndef GL_NV_vertex_program1_1
+#endif
+
+#ifndef GL_EXT_shadow_funcs
+#endif
+
+#ifndef GL_EXT_stencil_two_side
+#define GL_STENCIL_TEST_TWO_SIDE_EXT      0x8910
+#define GL_ACTIVE_STENCIL_FACE_EXT        0x8911
+#endif
+
+#ifndef GL_ATI_text_fragment_shader
+#define GL_TEXT_FRAGMENT_SHADER_ATI       0x8200
+#endif
+
+#ifndef GL_APPLE_client_storage
+#define GL_UNPACK_CLIENT_STORAGE_APPLE    0x85B2
+#endif
+
+#ifndef GL_APPLE_element_array
+#define GL_ELEMENT_ARRAY_APPLE            0x8768
+#define GL_ELEMENT_ARRAY_TYPE_APPLE       0x8769
+#define GL_ELEMENT_ARRAY_POINTER_APPLE    0x876A
+#endif
+
+#ifndef GL_APPLE_fence
+#define GL_DRAW_PIXELS_APPLE              0x8A0A
+#define GL_FENCE_APPLE                    0x8A0B
+#endif
+
+#ifndef GL_APPLE_vertex_array_object
+#define GL_VERTEX_ARRAY_BINDING_APPLE     0x85B5
+#endif
+
+#ifndef GL_APPLE_vertex_array_range
+#define GL_VERTEX_ARRAY_RANGE_APPLE       0x851D
+#define GL_VERTEX_ARRAY_RANGE_LENGTH_APPLE 0x851E
+#define GL_VERTEX_ARRAY_STORAGE_HINT_APPLE 0x851F
+#define GL_VERTEX_ARRAY_RANGE_POINTER_APPLE 0x8521
+#define GL_STORAGE_CACHED_APPLE           0x85BE
+#define GL_STORAGE_SHARED_APPLE           0x85BF
+#endif
+
+#ifndef GL_APPLE_ycbcr_422
+#define GL_YCBCR_422_APPLE                0x85B9
+#define GL_UNSIGNED_SHORT_8_8_APPLE       0x85BA
+#define GL_UNSIGNED_SHORT_8_8_REV_APPLE   0x85BB
+#endif
+
+#ifndef GL_S3_s3tc
+#define GL_RGB_S3TC                       0x83A0
+#define GL_RGB4_S3TC                      0x83A1
+#define GL_RGBA_S3TC                      0x83A2
+#define GL_RGBA4_S3TC                     0x83A3
+#endif
+
+#ifndef GL_ATI_draw_buffers
+#define GL_MAX_DRAW_BUFFERS_ATI           0x8824
+#define GL_DRAW_BUFFER0_ATI               0x8825
+#define GL_DRAW_BUFFER1_ATI               0x8826
+#define GL_DRAW_BUFFER2_ATI               0x8827
+#define GL_DRAW_BUFFER3_ATI               0x8828
+#define GL_DRAW_BUFFER4_ATI               0x8829
+#define GL_DRAW_BUFFER5_ATI               0x882A
+#define GL_DRAW_BUFFER6_ATI               0x882B
+#define GL_DRAW_BUFFER7_ATI               0x882C
+#define GL_DRAW_BUFFER8_ATI               0x882D
+#define GL_DRAW_BUFFER9_ATI               0x882E
+#define GL_DRAW_BUFFER10_ATI              0x882F
+#define GL_DRAW_BUFFER11_ATI              0x8830
+#define GL_DRAW_BUFFER12_ATI              0x8831
+#define GL_DRAW_BUFFER13_ATI              0x8832
+#define GL_DRAW_BUFFER14_ATI              0x8833
+#define GL_DRAW_BUFFER15_ATI              0x8834
+#endif
+
+#ifndef GL_ATI_pixel_format_float
+#define GL_TYPE_RGBA_FLOAT_ATI            0x8820
+#define GL_COLOR_CLEAR_UNCLAMPED_VALUE_ATI 0x8835
+#endif
+
+#ifndef GL_ATI_texture_env_combine3
+#define GL_MODULATE_ADD_ATI               0x8744
+#define GL_MODULATE_SIGNED_ADD_ATI        0x8745
+#define GL_MODULATE_SUBTRACT_ATI          0x8746
+#endif
+
+#ifndef GL_ATI_texture_float
+#define GL_RGBA_FLOAT32_ATI               0x8814
+#define GL_RGB_FLOAT32_ATI                0x8815
+#define GL_ALPHA_FLOAT32_ATI              0x8816
+#define GL_INTENSITY_FLOAT32_ATI          0x8817
+#define GL_LUMINANCE_FLOAT32_ATI          0x8818
+#define GL_LUMINANCE_ALPHA_FLOAT32_ATI    0x8819
+#define GL_RGBA_FLOAT16_ATI               0x881A
+#define GL_RGB_FLOAT16_ATI                0x881B
+#define GL_ALPHA_FLOAT16_ATI              0x881C
+#define GL_INTENSITY_FLOAT16_ATI          0x881D
+#define GL_LUMINANCE_FLOAT16_ATI          0x881E
+#define GL_LUMINANCE_ALPHA_FLOAT16_ATI    0x881F
+#endif
+
+#ifndef GL_NV_float_buffer
+#define GL_FLOAT_R_NV                     0x8880
+#define GL_FLOAT_RG_NV                    0x8881
+#define GL_FLOAT_RGB_NV                   0x8882
+#define GL_FLOAT_RGBA_NV                  0x8883
+#define GL_FLOAT_R16_NV                   0x8884
+#define GL_FLOAT_R32_NV                   0x8885
+#define GL_FLOAT_RG16_NV                  0x8886
+#define GL_FLOAT_RG32_NV                  0x8887
+#define GL_FLOAT_RGB16_NV                 0x8888
+#define GL_FLOAT_RGB32_NV                 0x8889
+#define GL_FLOAT_RGBA16_NV                0x888A
+#define GL_FLOAT_RGBA32_NV                0x888B
+#define GL_TEXTURE_FLOAT_COMPONENTS_NV    0x888C
+#define GL_FLOAT_CLEAR_COLOR_VALUE_NV     0x888D
+#define GL_FLOAT_RGBA_MODE_NV             0x888E
+#endif
+
+#ifndef GL_NV_fragment_program
+#define GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV 0x8868
+#define GL_FRAGMENT_PROGRAM_NV            0x8870
+#define GL_MAX_TEXTURE_COORDS_NV          0x8871
+#define GL_MAX_TEXTURE_IMAGE_UNITS_NV     0x8872
+#define GL_FRAGMENT_PROGRAM_BINDING_NV    0x8873
+#define GL_PROGRAM_ERROR_STRING_NV        0x8874
+#endif
+
+#ifndef GL_NV_half_float
+#define GL_HALF_FLOAT_NV                  0x140B
+#endif
+
+#ifndef GL_NV_pixel_data_range
+#define GL_WRITE_PIXEL_DATA_RANGE_NV      0x8878
+#define GL_READ_PIXEL_DATA_RANGE_NV       0x8879
+#define GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV 0x887A
+#define GL_READ_PIXEL_DATA_RANGE_LENGTH_NV 0x887B
+#define GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV 0x887C
+#define GL_READ_PIXEL_DATA_RANGE_POINTER_NV 0x887D
+#endif
+
+#ifndef GL_NV_primitive_restart
+#define GL_PRIMITIVE_RESTART_NV           0x8558
+#define GL_PRIMITIVE_RESTART_INDEX_NV     0x8559
+#endif
+
+#ifndef GL_NV_texture_expand_normal
+#define GL_TEXTURE_UNSIGNED_REMAP_MODE_NV 0x888F
+#endif
+
+#ifndef GL_NV_vertex_program2
+#endif
+
+#ifndef GL_ATI_map_object_buffer
+#endif
+
+#ifndef GL_ATI_separate_stencil
+#define GL_STENCIL_BACK_FUNC_ATI          0x8800
+#define GL_STENCIL_BACK_FAIL_ATI          0x8801
+#define GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI 0x8802
+#define GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI 0x8803
+#endif
+
+#ifndef GL_ATI_vertex_attrib_array_object
+#endif
+
+#ifndef GL_OES_read_format
+#define GL_IMPLEMENTATION_COLOR_READ_TYPE_OES 0x8B9A
+#define GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES 0x8B9B
+#endif
+
+#ifndef GL_EXT_depth_bounds_test
+#define GL_DEPTH_BOUNDS_TEST_EXT          0x8890
+#define GL_DEPTH_BOUNDS_EXT               0x8891
+#endif
+
+#ifndef GL_EXT_texture_mirror_clamp
+#define GL_MIRROR_CLAMP_EXT               0x8742
+#define GL_MIRROR_CLAMP_TO_EDGE_EXT       0x8743
+#define GL_MIRROR_CLAMP_TO_BORDER_EXT     0x8912
+#endif
+
+#ifndef GL_EXT_blend_equation_separate
+#define GL_BLEND_EQUATION_RGB_EXT         GL_BLEND_EQUATION
+#define GL_BLEND_EQUATION_ALPHA_EXT       0x883D
+#endif
+
+#ifndef GL_MESA_pack_invert
+#define GL_PACK_INVERT_MESA               0x8758
+#endif
+
+#ifndef GL_MESA_ycbcr_texture
+#define GL_UNSIGNED_SHORT_8_8_MESA        0x85BA
+#define GL_UNSIGNED_SHORT_8_8_REV_MESA    0x85BB
+#define GL_YCBCR_MESA                     0x8757
+#endif
+
+#ifndef GL_EXT_pixel_buffer_object
+#define GL_PIXEL_PACK_BUFFER_EXT          0x88EB
+#define GL_PIXEL_UNPACK_BUFFER_EXT        0x88EC
+#define GL_PIXEL_PACK_BUFFER_BINDING_EXT  0x88ED
+#define GL_PIXEL_UNPACK_BUFFER_BINDING_EXT 0x88EF
+#endif
+
+#ifndef GL_NV_fragment_program_option
+#endif
+
+#ifndef GL_NV_fragment_program2
+#define GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV 0x88F4
+#define GL_MAX_PROGRAM_CALL_DEPTH_NV      0x88F5
+#define GL_MAX_PROGRAM_IF_DEPTH_NV        0x88F6
+#define GL_MAX_PROGRAM_LOOP_DEPTH_NV      0x88F7
+#define GL_MAX_PROGRAM_LOOP_COUNT_NV      0x88F8
+#endif
+
+#ifndef GL_NV_vertex_program2_option
+  /* reuse GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV */
+  /* reuse GL_MAX_PROGRAM_CALL_DEPTH_NV */
+#endif
+
+#ifndef GL_NV_vertex_program3
+  /* reuse GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB */
+#endif
+
+#ifndef GL_EXT_framebuffer_object
+#define GL_INVALID_FRAMEBUFFER_OPERATION_EXT 0x0506
+#define GL_MAX_RENDERBUFFER_SIZE_EXT      0x84E8
+#define GL_FRAMEBUFFER_BINDING_EXT        0x8CA6
+#define GL_RENDERBUFFER_BINDING_EXT       0x8CA7
+#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT 0x8CD0
+#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT 0x8CD1
+#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT 0x8CD2
+#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT 0x8CD3
+#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT 0x8CD4
+#define GL_FRAMEBUFFER_COMPLETE_EXT       0x8CD5
+#define GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT 0x8CD6
+#define GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT 0x8CD7
+#define GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT_EXT 0x8CD8
+#define GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT 0x8CD9
+#define GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT 0x8CDA
+#define GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT 0x8CDB
+#define GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT 0x8CDC
+#define GL_FRAMEBUFFER_UNSUPPORTED_EXT    0x8CDD
+#define GL_MAX_COLOR_ATTACHMENTS_EXT      0x8CDF
+#define GL_COLOR_ATTACHMENT0_EXT          0x8CE0
+#define GL_COLOR_ATTACHMENT1_EXT          0x8CE1
+#define GL_COLOR_ATTACHMENT2_EXT          0x8CE2
+#define GL_COLOR_ATTACHMENT3_EXT          0x8CE3
+#define GL_COLOR_ATTACHMENT4_EXT          0x8CE4
+#define GL_COLOR_ATTACHMENT5_EXT          0x8CE5
+#define GL_COLOR_ATTACHMENT6_EXT          0x8CE6
+#define GL_COLOR_ATTACHMENT7_EXT          0x8CE7
+#define GL_COLOR_ATTACHMENT8_EXT          0x8CE8
+#define GL_COLOR_ATTACHMENT9_EXT          0x8CE9
+#define GL_COLOR_ATTACHMENT10_EXT         0x8CEA
+#define GL_COLOR_ATTACHMENT11_EXT         0x8CEB
+#define GL_COLOR_ATTACHMENT12_EXT         0x8CEC
+#define GL_COLOR_ATTACHMENT13_EXT         0x8CED
+#define GL_COLOR_ATTACHMENT14_EXT         0x8CEE
+#define GL_COLOR_ATTACHMENT15_EXT         0x8CEF
+#define GL_DEPTH_ATTACHMENT_EXT           0x8D00
+#define GL_STENCIL_ATTACHMENT_EXT         0x8D20
+#define GL_FRAMEBUFFER_EXT                0x8D40
+#define GL_RENDERBUFFER_EXT               0x8D41
+#define GL_RENDERBUFFER_WIDTH_EXT         0x8D42
+#define GL_RENDERBUFFER_HEIGHT_EXT        0x8D43
+#define GL_RENDERBUFFER_INTERNAL_FORMAT_EXT 0x8D44
+#define GL_STENCIL_INDEX_EXT              0x8D45
+#define GL_STENCIL_INDEX1_EXT             0x8D46
+#define GL_STENCIL_INDEX4_EXT             0x8D47
+#define GL_STENCIL_INDEX8_EXT             0x8D48
+#define GL_STENCIL_INDEX16_EXT            0x8D49
+#define GL_RENDERBUFFER_RED_SIZE_EXT      0x8D50
+#define GL_RENDERBUFFER_GREEN_SIZE_EXT    0x8D51
+#define GL_RENDERBUFFER_BLUE_SIZE_EXT     0x8D52
+#define GL_RENDERBUFFER_ALPHA_SIZE_EXT    0x8D53
+#define GL_RENDERBUFFER_DEPTH_SIZE_EXT    0x8D54
+#define GL_RENDERBUFFER_STENCIL_SIZE_EXT  0x8D55
+#endif
+
+#ifndef GL_GREMEDY_string_marker
+#endif
+
+#ifndef GL_EXT_Cg_shader
+#define GL_CG_VERTEX_SHADER_EXT           0x890E
+#define GL_CG_FRAGMENT_SHADER_EXT         0x890E
+#endif
+
+#ifndef GL_NV_element_array
+#define GL_ELEMENT_ARRAY_TYPE_NV          0x8769
+#define GL_ELEMENT_ARRAY_POINTER_NV       0x876A
+#endif
+
+#ifndef GL_NV_pixel_buffer_object
+#define GL_PIXEL_PACK_BUFFER_NV             0x88EB
+#define GL_PIXEL_UNPACK_BUFFER_NV           0x88EC
+#define GL_PIXEL_PACK_BUFFER_BINDING_NV     0x88ED
+#define GL_PIXEL_UNPACK_BUFFER_BINDING_NV   0x88EF
+#endif
+
+#ifndef GL_NV_stencil_two_side
+#define GL_STENCIL_TEST_TWO_SIDE_NV       0x8910
+#define GL_ACTIVE_STENCIL_FACE_NV         0x8911
+#endif
+
+  /*************************************************************/
+
+#include <stddef.h>
+#ifndef GL_VERSION_2_0
+  /* GL type for program/shader text */
+  typedef char GLchar;      /* native character */
+#endif
+
+#ifndef GL_VERSION_1_5
+  /* GL types for handling large vertex buffer objects */
+  typedef ptrdiff_t GLintptr;
+  typedef ptrdiff_t GLsizeiptr;
+#endif
+
+#ifndef GL_ARB_vertex_buffer_object
+  /* GL types for handling large vertex buffer objects */
+  typedef ptrdiff_t GLintptrARB;
+  typedef ptrdiff_t GLsizeiptrARB;
+#endif
+
+#ifndef GL_ARB_shader_objects
+  /* GL types for handling shader object handles and program/shader text */
+  typedef char GLcharARB;   /* native character */
+  typedef unsigned int GLhandleARB; /* shader object handle */
+#endif
+
+  /* GL types for "half" precision (s10e5) float data in host memory */
+#ifndef GL_ARB_half_float_pixel
+  typedef unsigned short GLhalfARB;
+#endif
+
+#ifndef GL_NV_half_float
+  typedef unsigned short GLhalfNV;
+#endif
+
+#ifndef GL_VERSION_1_2
+#define GL_VERSION_1_2 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendColor (GLclampf, GLclampf, GLclampf, GLclampf);
+  GLAPI void APIENTRY glBlendEquation (GLenum);
+  GLAPI void APIENTRY glDrawRangeElements (GLenum, GLuint, GLuint, GLsizei, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glColorTable (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glColorTableParameterfv (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glColorTableParameteriv (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glCopyColorTable (GLenum, GLenum, GLint, GLint, GLsizei);
+  GLAPI void APIENTRY glGetColorTable (GLenum, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetColorTableParameterfv (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetColorTableParameteriv (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glColorSubTable (GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glCopyColorSubTable (GLenum, GLsizei, GLint, GLint, GLsizei);
+  GLAPI void APIENTRY glConvolutionFilter1D (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glConvolutionFilter2D (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glConvolutionParameterf (GLenum, GLenum, GLfloat);
+  GLAPI void APIENTRY glConvolutionParameterfv (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glConvolutionParameteri (GLenum, GLenum, GLint);
+  GLAPI void APIENTRY glConvolutionParameteriv (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glCopyConvolutionFilter1D (GLenum, GLenum, GLint, GLint, GLsizei);
+  GLAPI void APIENTRY glCopyConvolutionFilter2D (GLenum, GLenum, GLint, GLint, GLsizei, GLsizei);
+  GLAPI void APIENTRY glGetConvolutionFilter (GLenum, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetConvolutionParameterfv (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetConvolutionParameteriv (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetSeparableFilter (GLenum, GLenum, GLenum, GLvoid *, GLvoid *, GLvoid *);
+  GLAPI void APIENTRY glSeparableFilter2D (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *, const GLvoid *);
+  GLAPI void APIENTRY glGetHistogram (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetHistogramParameterfv (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetHistogramParameteriv (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetMinmax (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetMinmaxParameterfv (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetMinmaxParameteriv (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glHistogram (GLenum, GLsizei, GLenum, GLboolean);
+  GLAPI void APIENTRY glMinmax (GLenum, GLenum, GLboolean);
+  GLAPI void APIENTRY glResetHistogram (GLenum);
+  GLAPI void APIENTRY glResetMinmax (GLenum);
+  GLAPI void APIENTRY glTexImage3D (GLenum, GLint, GLint, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glTexSubImage3D (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glCopyTexSubImage3D (GLenum, GLint, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDCOLORPROC) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
+  typedef void (APIENTRYP PFNGLBLENDEQUATIONPROC) (GLenum mode);
+  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTSPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices);
+  typedef void (APIENTRYP PFNGLCOLORTABLEPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table);
+  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERFVPROC) (GLenum target, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERIVPROC) (GLenum target, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLCOPYCOLORTABLEPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEPROC) (GLenum target, GLenum format, GLenum type, GLvoid *table);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLCOLORSUBTABLEPROC) (GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOPYCOLORSUBTABLEPROC) (GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER1DPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER2DPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFPROC) (GLenum target, GLenum pname, GLfloat params);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFVPROC) (GLenum target, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIPROC) (GLenum target, GLenum pname, GLint params);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIVPROC) (GLenum target, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER1DPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
+  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER2DPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
+  typedef void (APIENTRYP PFNGLGETCONVOLUTIONFILTERPROC) (GLenum target, GLenum format, GLenum type, GLvoid *image);
+  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETSEPARABLEFILTERPROC) (GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span);
+  typedef void (APIENTRYP PFNGLSEPARABLEFILTER2DPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column);
+  typedef void (APIENTRYP PFNGLGETHISTOGRAMPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
+  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETMINMAXPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
+  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERFVPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLHISTOGRAMPROC) (GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
+  typedef void (APIENTRYP PFNGLMINMAXPROC) (GLenum target, GLenum internalformat, GLboolean sink);
+  typedef void (APIENTRYP PFNGLRESETHISTOGRAMPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLRESETMINMAXPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLTEXIMAGE3DPROC) (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
+  typedef void (APIENTRYP PFNGLTEXSUBIMAGE3DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels);
+  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE3DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
+#endif
+
+#ifndef GL_VERSION_1_3
+#define GL_VERSION_1_3 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glActiveTexture (GLenum);
+  GLAPI void APIENTRY glClientActiveTexture (GLenum);
+  GLAPI void APIENTRY glMultiTexCoord1d (GLenum, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord1dv (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord1f (GLenum, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord1fv (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord1i (GLenum, GLint);
+  GLAPI void APIENTRY glMultiTexCoord1iv (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord1s (GLenum, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord1sv (GLenum, const GLshort *);
+  GLAPI void APIENTRY glMultiTexCoord2d (GLenum, GLdouble, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord2dv (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord2f (GLenum, GLfloat, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord2fv (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord2i (GLenum, GLint, GLint);
+  GLAPI void APIENTRY glMultiTexCoord2iv (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord2s (GLenum, GLshort, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord2sv (GLenum, const GLshort *);
+  GLAPI void APIENTRY glMultiTexCoord3d (GLenum, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord3dv (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord3f (GLenum, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord3fv (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord3i (GLenum, GLint, GLint, GLint);
+  GLAPI void APIENTRY glMultiTexCoord3iv (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord3s (GLenum, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord3sv (GLenum, const GLshort *);
+  GLAPI void APIENTRY glMultiTexCoord4d (GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord4dv (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord4f (GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord4fv (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord4i (GLenum, GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glMultiTexCoord4iv (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord4s (GLenum, GLshort, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord4sv (GLenum, const GLshort *);
+  GLAPI void APIENTRY glLoadTransposeMatrixf (const GLfloat *);
+  GLAPI void APIENTRY glLoadTransposeMatrixd (const GLdouble *);
+  GLAPI void APIENTRY glMultTransposeMatrixf (const GLfloat *);
+  GLAPI void APIENTRY glMultTransposeMatrixd (const GLdouble *);
+  GLAPI void APIENTRY glSampleCoverage (GLclampf, GLboolean);
+  GLAPI void APIENTRY glCompressedTexImage3D (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexImage2D (GLenum, GLint, GLenum, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexImage1D (GLenum, GLint, GLenum, GLsizei, GLint, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexSubImage3D (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexSubImage2D (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexSubImage1D (GLenum, GLint, GLint, GLsizei, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glGetCompressedTexImage (GLenum, GLint, GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLACTIVETEXTUREPROC) (GLenum texture);
+  typedef void (APIENTRYP PFNGLCLIENTACTIVETEXTUREPROC) (GLenum texture);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DPROC) (GLenum target, GLdouble s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DVPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FPROC) (GLenum target, GLfloat s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FVPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IPROC) (GLenum target, GLint s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IVPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SPROC) (GLenum target, GLshort s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SVPROC) (GLenum target, const GLshort *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DPROC) (GLenum target, GLdouble s, GLdouble t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DVPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FPROC) (GLenum target, GLfloat s, GLfloat t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FVPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IPROC) (GLenum target, GLint s, GLint t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IVPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SPROC) (GLenum target, GLshort s, GLshort t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SVPROC) (GLenum target, const GLshort *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DVPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FVPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IPROC) (GLenum target, GLint s, GLint t, GLint r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IVPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SPROC) (GLenum target, GLshort s, GLshort t, GLshort r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SVPROC) (GLenum target, const GLshort *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DVPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FVPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IPROC) (GLenum target, GLint s, GLint t, GLint r, GLint q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IVPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SPROC) (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SVPROC) (GLenum target, const GLshort *v);
+  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXFPROC) (const GLfloat *m);
+  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXDPROC) (const GLdouble *m);
+  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXFPROC) (const GLfloat *m);
+  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXDPROC) (const GLdouble *m);
+  typedef void (APIENTRYP PFNGLSAMPLECOVERAGEPROC) (GLclampf value, GLboolean invert);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE3DPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE2DPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE1DPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC) (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLGETCOMPRESSEDTEXIMAGEPROC) (GLenum target, GLint level, GLvoid *img);
+#endif
+
+#ifndef GL_VERSION_1_4
+#define GL_VERSION_1_4 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendFuncSeparate (GLenum, GLenum, GLenum, GLenum);
+  GLAPI void APIENTRY glFogCoordf (GLfloat);
+  GLAPI void APIENTRY glFogCoordfv (const GLfloat *);
+  GLAPI void APIENTRY glFogCoordd (GLdouble);
+  GLAPI void APIENTRY glFogCoorddv (const GLdouble *);
+  GLAPI void APIENTRY glFogCoordPointer (GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glMultiDrawArrays (GLenum, GLint *, GLsizei *, GLsizei);
+  GLAPI void APIENTRY glMultiDrawElements (GLenum, const GLsizei *, GLenum, const GLvoid* *, GLsizei);
+  GLAPI void APIENTRY glPointParameterf (GLenum, GLfloat);
+  GLAPI void APIENTRY glPointParameterfv (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glPointParameteri (GLenum, GLint);
+  GLAPI void APIENTRY glPointParameteriv (GLenum, const GLint *);
+  GLAPI void APIENTRY glSecondaryColor3b (GLbyte, GLbyte, GLbyte);
+  GLAPI void APIENTRY glSecondaryColor3bv (const GLbyte *);
+  GLAPI void APIENTRY glSecondaryColor3d (GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glSecondaryColor3dv (const GLdouble *);
+  GLAPI void APIENTRY glSecondaryColor3f (GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glSecondaryColor3fv (const GLfloat *);
+  GLAPI void APIENTRY glSecondaryColor3i (GLint, GLint, GLint);
+  GLAPI void APIENTRY glSecondaryColor3iv (const GLint *);
+  GLAPI void APIENTRY glSecondaryColor3s (GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glSecondaryColor3sv (const GLshort *);
+  GLAPI void APIENTRY glSecondaryColor3ub (GLubyte, GLubyte, GLubyte);
+  GLAPI void APIENTRY glSecondaryColor3ubv (const GLubyte *);
+  GLAPI void APIENTRY glSecondaryColor3ui (GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glSecondaryColor3uiv (const GLuint *);
+  GLAPI void APIENTRY glSecondaryColor3us (GLushort, GLushort, GLushort);
+  GLAPI void APIENTRY glSecondaryColor3usv (const GLushort *);
+  GLAPI void APIENTRY glSecondaryColorPointer (GLint, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glWindowPos2d (GLdouble, GLdouble);
+  GLAPI void APIENTRY glWindowPos2dv (const GLdouble *);
+  GLAPI void APIENTRY glWindowPos2f (GLfloat, GLfloat);
+  GLAPI void APIENTRY glWindowPos2fv (const GLfloat *);
+  GLAPI void APIENTRY glWindowPos2i (GLint, GLint);
+  GLAPI void APIENTRY glWindowPos2iv (const GLint *);
+  GLAPI void APIENTRY glWindowPos2s (GLshort, GLshort);
+  GLAPI void APIENTRY glWindowPos2sv (const GLshort *);
+  GLAPI void APIENTRY glWindowPos3d (GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glWindowPos3dv (const GLdouble *);
+  GLAPI void APIENTRY glWindowPos3f (GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glWindowPos3fv (const GLfloat *);
+  GLAPI void APIENTRY glWindowPos3i (GLint, GLint, GLint);
+  GLAPI void APIENTRY glWindowPos3iv (const GLint *);
+  GLAPI void APIENTRY glWindowPos3s (GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glWindowPos3sv (const GLshort *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDFUNCSEPARATEPROC) (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
+  typedef void (APIENTRYP PFNGLFOGCOORDFPROC) (GLfloat coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDFVPROC) (const GLfloat *coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDDPROC) (GLdouble coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDDVPROC) (const GLdouble *coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDPOINTERPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLMULTIDRAWARRAYSPROC) (GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
+  typedef void (APIENTRYP PFNGLMULTIDRAWELEMENTSPROC) (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVPROC) (GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERIPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERIVPROC) (GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BPROC) (GLbyte red, GLbyte green, GLbyte blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BVPROC) (const GLbyte *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DPROC) (GLdouble red, GLdouble green, GLdouble blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DVPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FPROC) (GLfloat red, GLfloat green, GLfloat blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FVPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IPROC) (GLint red, GLint green, GLint blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IVPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SPROC) (GLshort red, GLshort green, GLshort blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SVPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBPROC) (GLubyte red, GLubyte green, GLubyte blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBVPROC) (const GLubyte *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIPROC) (GLuint red, GLuint green, GLuint blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIVPROC) (const GLuint *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USPROC) (GLushort red, GLushort green, GLushort blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USVPROC) (const GLushort *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLORPOINTERPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2DPROC) (GLdouble x, GLdouble y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2DVPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2FPROC) (GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2FVPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2IPROC) (GLint x, GLint y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2IVPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2SPROC) (GLshort x, GLshort y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2SVPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3DPROC) (GLdouble x, GLdouble y, GLdouble z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3DVPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3FPROC) (GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3FVPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3IPROC) (GLint x, GLint y, GLint z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3IVPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3SPROC) (GLshort x, GLshort y, GLshort z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3SVPROC) (const GLshort *v);
+#endif
+
+#ifndef GL_VERSION_1_5
+#define GL_VERSION_1_5 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGenQueries (GLsizei, GLuint *);
+  GLAPI void APIENTRY glDeleteQueries (GLsizei, const GLuint *);
+  GLAPI GLboolean APIENTRY glIsQuery (GLuint);
+  GLAPI void APIENTRY glBeginQuery (GLenum, GLuint);
+  GLAPI void APIENTRY glEndQuery (GLenum);
+  GLAPI void APIENTRY glGetQueryiv (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetQueryObjectiv (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetQueryObjectuiv (GLuint, GLenum, GLuint *);
+  GLAPI void APIENTRY glBindBuffer (GLenum, GLuint);
+  GLAPI void APIENTRY glDeleteBuffers (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenBuffers (GLsizei, GLuint *);
+  GLAPI GLboolean APIENTRY glIsBuffer (GLuint);
+  GLAPI void APIENTRY glBufferData (GLenum, GLsizeiptr, const GLvoid *, GLenum);
+  GLAPI void APIENTRY glBufferSubData (GLenum, GLintptr, GLsizeiptr, const GLvoid *);
+  GLAPI void APIENTRY glGetBufferSubData (GLenum, GLintptr, GLsizeiptr, GLvoid *);
+  GLAPI GLvoid* APIENTRY glMapBuffer (GLenum, GLenum);
+  GLAPI GLboolean APIENTRY glUnmapBuffer (GLenum);
+  GLAPI void APIENTRY glGetBufferParameteriv (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetBufferPointerv (GLenum, GLenum, GLvoid* *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGENQUERIESPROC) (GLsizei n, GLuint *ids);
+  typedef void (APIENTRYP PFNGLDELETEQUERIESPROC) (GLsizei n, const GLuint *ids);
+  typedef GLboolean (APIENTRYP PFNGLISQUERYPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLBEGINQUERYPROC) (GLenum target, GLuint id);
+  typedef void (APIENTRYP PFNGLENDQUERYPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLGETQUERYIVPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETQUERYOBJECTIVPROC) (GLuint id, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETQUERYOBJECTUIVPROC) (GLuint id, GLenum pname, GLuint *params);
+  typedef void (APIENTRYP PFNGLBINDBUFFERPROC) (GLenum target, GLuint buffer);
+  typedef void (APIENTRYP PFNGLDELETEBUFFERSPROC) (GLsizei n, const GLuint *buffers);
+  typedef void (APIENTRYP PFNGLGENBUFFERSPROC) (GLsizei n, GLuint *buffers);
+  typedef GLboolean (APIENTRYP PFNGLISBUFFERPROC) (GLuint buffer);
+  typedef void (APIENTRYP PFNGLBUFFERDATAPROC) (GLenum target, GLsizeiptr size, const GLvoid *data, GLenum usage);
+  typedef void (APIENTRYP PFNGLBUFFERSUBDATAPROC) (GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLGETBUFFERSUBDATAPROC) (GLenum target, GLintptr offset, GLsizeiptr size, GLvoid *data);
+  typedef GLvoid* (APIENTRYP PFNGLMAPBUFFERPROC) (GLenum target, GLenum access);
+  typedef GLboolean (APIENTRYP PFNGLUNMAPBUFFERPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLGETBUFFERPARAMETERIVPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETBUFFERPOINTERVPROC) (GLenum target, GLenum pname, GLvoid* *params);
+#endif
+
+#ifndef GL_VERSION_2_0
+#define GL_VERSION_2_0 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendEquationSeparate (GLenum, GLenum);
+  GLAPI void APIENTRY glDrawBuffers (GLsizei, const GLenum *);
+  GLAPI void APIENTRY glStencilOpSeparate (GLenum, GLenum, GLenum, GLenum);
+  GLAPI void APIENTRY glStencilFuncSeparate (GLenum, GLenum, GLint, GLuint);
+  GLAPI void APIENTRY glStencilMaskSeparate (GLenum, GLuint);
+  GLAPI void APIENTRY glAttachShader (GLuint, GLuint);
+  GLAPI void APIENTRY glBindAttribLocation (GLuint, GLuint, const GLchar *);
+  GLAPI void APIENTRY glCompileShader (GLuint);
+  GLAPI GLuint APIENTRY glCreateProgram (void);
+  GLAPI GLuint APIENTRY glCreateShader (GLenum);
+  GLAPI void APIENTRY glDeleteProgram (GLuint);
+  GLAPI void APIENTRY glDeleteShader (GLuint);
+  GLAPI void APIENTRY glDetachShader (GLuint, GLuint);
+  GLAPI void APIENTRY glDisableVertexAttribArray (GLuint);
+  GLAPI void APIENTRY glEnableVertexAttribArray (GLuint);
+  GLAPI void APIENTRY glGetActiveAttrib (GLuint, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLchar *);
+  GLAPI void APIENTRY glGetActiveUniform (GLuint, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLchar *);
+  GLAPI void APIENTRY glGetAttachedShaders (GLuint, GLsizei, GLsizei *, GLuint *);
+  GLAPI GLint APIENTRY glGetAttribLocation (GLuint, const GLchar *);
+  GLAPI void APIENTRY glGetProgramiv (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetProgramInfoLog (GLuint, GLsizei, GLsizei *, GLchar *);
+  GLAPI void APIENTRY glGetShaderiv (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetShaderInfoLog (GLuint, GLsizei, GLsizei *, GLchar *);
+  GLAPI void APIENTRY glGetShaderSource (GLuint, GLsizei, GLsizei *, GLchar *);
+  GLAPI GLint APIENTRY glGetUniformLocation (GLuint, const GLchar *);
+  GLAPI void APIENTRY glGetUniformfv (GLuint, GLint, GLfloat *);
+  GLAPI void APIENTRY glGetUniformiv (GLuint, GLint, GLint *);
+  GLAPI void APIENTRY glGetVertexAttribdv (GLuint, GLenum, GLdouble *);
+  GLAPI void APIENTRY glGetVertexAttribfv (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetVertexAttribiv (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetVertexAttribPointerv (GLuint, GLenum, GLvoid* *);
+  GLAPI GLboolean APIENTRY glIsProgram (GLuint);
+  GLAPI GLboolean APIENTRY glIsShader (GLuint);
+  GLAPI void APIENTRY glLinkProgram (GLuint);
+  GLAPI void APIENTRY glShaderSource (GLuint, GLsizei, const GLchar* *, const GLint *);
+  GLAPI void APIENTRY glUseProgram (GLuint);
+  GLAPI void APIENTRY glUniform1f (GLint, GLfloat);
+  GLAPI void APIENTRY glUniform2f (GLint, GLfloat, GLfloat);
+  GLAPI void APIENTRY glUniform3f (GLint, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glUniform4f (GLint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glUniform1i (GLint, GLint);
+  GLAPI void APIENTRY glUniform2i (GLint, GLint, GLint);
+  GLAPI void APIENTRY glUniform3i (GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glUniform4i (GLint, GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glUniform1fv (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform2fv (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform3fv (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform4fv (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform1iv (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniform2iv (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniform3iv (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniform4iv (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniformMatrix2fv (GLint, GLsizei, GLboolean, const GLfloat *);
+  GLAPI void APIENTRY glUniformMatrix3fv (GLint, GLsizei, GLboolean, const GLfloat *);
+  GLAPI void APIENTRY glUniformMatrix4fv (GLint, GLsizei, GLboolean, const GLfloat *);
+  GLAPI void APIENTRY glValidateProgram (GLuint);
+  GLAPI void APIENTRY glVertexAttrib1d (GLuint, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib1dv (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib1f (GLuint, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib1fv (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib1s (GLuint, GLshort);
+  GLAPI void APIENTRY glVertexAttrib1sv (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib2d (GLuint, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib2dv (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib2f (GLuint, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib2fv (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib2s (GLuint, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib2sv (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib3d (GLuint, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib3dv (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib3f (GLuint, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib3fv (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib3s (GLuint, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib3sv (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4Nbv (GLuint, const GLbyte *);
+  GLAPI void APIENTRY glVertexAttrib4Niv (GLuint, const GLint *);
+  GLAPI void APIENTRY glVertexAttrib4Nsv (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4Nub (GLuint, GLubyte, GLubyte, GLubyte, GLubyte);
+  GLAPI void APIENTRY glVertexAttrib4Nubv (GLuint, const GLubyte *);
+  GLAPI void APIENTRY glVertexAttrib4Nuiv (GLuint, const GLuint *);
+  GLAPI void APIENTRY glVertexAttrib4Nusv (GLuint, const GLushort *);
+  GLAPI void APIENTRY glVertexAttrib4bv (GLuint, const GLbyte *);
+  GLAPI void APIENTRY glVertexAttrib4d (GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib4dv (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib4f (GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib4fv (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib4iv (GLuint, const GLint *);
+  GLAPI void APIENTRY glVertexAttrib4s (GLuint, GLshort, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib4sv (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4ubv (GLuint, const GLubyte *);
+  GLAPI void APIENTRY glVertexAttrib4uiv (GLuint, const GLuint *);
+  GLAPI void APIENTRY glVertexAttrib4usv (GLuint, const GLushort *);
+  GLAPI void APIENTRY glVertexAttribPointer (GLuint, GLint, GLenum, GLboolean, GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDEQUATIONSEPARATEPROC) (GLenum modeRGB, GLenum modeAlpha);
+  typedef void (APIENTRYP PFNGLDRAWBUFFERSPROC) (GLsizei n, const GLenum *bufs);
+  typedef void (APIENTRYP PFNGLSTENCILOPSEPARATEPROC) (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
+  typedef void (APIENTRYP PFNGLSTENCILFUNCSEPARATEPROC) (GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask);
+  typedef void (APIENTRYP PFNGLSTENCILMASKSEPARATEPROC) (GLenum face, GLuint mask);
+  typedef void (APIENTRYP PFNGLATTACHSHADERPROC) (GLuint program, GLuint shader);
+  typedef void (APIENTRYP PFNGLBINDATTRIBLOCATIONPROC) (GLuint program, GLuint index, const GLchar *name);
+  typedef void (APIENTRYP PFNGLCOMPILESHADERPROC) (GLuint shader);
+  typedef GLuint (APIENTRYP PFNGLCREATEPROGRAMPROC) (void);
+  typedef GLuint (APIENTRYP PFNGLCREATESHADERPROC) (GLenum type);
+  typedef void (APIENTRYP PFNGLDELETEPROGRAMPROC) (GLuint program);
+  typedef void (APIENTRYP PFNGLDELETESHADERPROC) (GLuint shader);
+  typedef void (APIENTRYP PFNGLDETACHSHADERPROC) (GLuint program, GLuint shader);
+  typedef void (APIENTRYP PFNGLDISABLEVERTEXATTRIBARRAYPROC) (GLuint index);
+  typedef void (APIENTRYP PFNGLENABLEVERTEXATTRIBARRAYPROC) (GLuint index);
+  typedef void (APIENTRYP PFNGLGETACTIVEATTRIBPROC) (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name);
+  typedef void (APIENTRYP PFNGLGETACTIVEUNIFORMPROC) (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name);
+  typedef void (APIENTRYP PFNGLGETATTACHEDSHADERSPROC) (GLuint program, GLsizei maxCount, GLsizei *count, GLuint *obj);
+  typedef GLint (APIENTRYP PFNGLGETATTRIBLOCATIONPROC) (GLuint program, const GLchar *name);
+  typedef void (APIENTRYP PFNGLGETPROGRAMIVPROC) (GLuint program, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMINFOLOGPROC) (GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog);
+  typedef void (APIENTRYP PFNGLGETSHADERIVPROC) (GLuint shader, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETSHADERINFOLOGPROC) (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog);
+  typedef void (APIENTRYP PFNGLGETSHADERSOURCEPROC) (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *source);
+  typedef GLint (APIENTRYP PFNGLGETUNIFORMLOCATIONPROC) (GLuint program, const GLchar *name);
+  typedef void (APIENTRYP PFNGLGETUNIFORMFVPROC) (GLuint program, GLint location, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETUNIFORMIVPROC) (GLuint program, GLint location, GLint *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBDVPROC) (GLuint index, GLenum pname, GLdouble *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBFVPROC) (GLuint index, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBIVPROC) (GLuint index, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBPOINTERVPROC) (GLuint index, GLenum pname, GLvoid* *pointer);
+  typedef GLboolean (APIENTRYP PFNGLISPROGRAMPROC) (GLuint program);
+  typedef GLboolean (APIENTRYP PFNGLISSHADERPROC) (GLuint shader);
+  typedef void (APIENTRYP PFNGLLINKPROGRAMPROC) (GLuint program);
+  typedef void (APIENTRYP PFNGLSHADERSOURCEPROC) (GLuint shader, GLsizei count, const GLchar* *string, const GLint *length);
+  typedef void (APIENTRYP PFNGLUSEPROGRAMPROC) (GLuint program);
+  typedef void (APIENTRYP PFNGLUNIFORM1FPROC) (GLint location, GLfloat v0);
+  typedef void (APIENTRYP PFNGLUNIFORM2FPROC) (GLint location, GLfloat v0, GLfloat v1);
+  typedef void (APIENTRYP PFNGLUNIFORM3FPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
+  typedef void (APIENTRYP PFNGLUNIFORM4FPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
+  typedef void (APIENTRYP PFNGLUNIFORM1IPROC) (GLint location, GLint v0);
+  typedef void (APIENTRYP PFNGLUNIFORM2IPROC) (GLint location, GLint v0, GLint v1);
+  typedef void (APIENTRYP PFNGLUNIFORM3IPROC) (GLint location, GLint v0, GLint v1, GLint v2);
+  typedef void (APIENTRYP PFNGLUNIFORM4IPROC) (GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
+  typedef void (APIENTRYP PFNGLUNIFORM1FVPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM2FVPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM3FVPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM4FVPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM1IVPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORM2IVPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORM3IVPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORM4IVPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORMMATRIX2FVPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORMMATRIX3FVPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORMMATRIX4FVPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLVALIDATEPROGRAMPROC) (GLuint program);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DPROC) (GLuint index, GLdouble x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FPROC) (GLuint index, GLfloat x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SPROC) (GLuint index, GLshort x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DPROC) (GLuint index, GLdouble x, GLdouble y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FPROC) (GLuint index, GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SPROC) (GLuint index, GLshort x, GLshort y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SPROC) (GLuint index, GLshort x, GLshort y, GLshort z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NBVPROC) (GLuint index, const GLbyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NIVPROC) (GLuint index, const GLint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NSVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBPROC) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBVPROC) (GLuint index, const GLubyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUIVPROC) (GLuint index, const GLuint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUSVPROC) (GLuint index, const GLushort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4BVPROC) (GLuint index, const GLbyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4IVPROC) (GLuint index, const GLint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SPROC) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBVPROC) (GLuint index, const GLubyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UIVPROC) (GLuint index, const GLuint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4USVPROC) (GLuint index, const GLushort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBPOINTERPROC) (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer);
+#endif
+
+#ifndef GL_ARB_multitexture
+#define GL_ARB_multitexture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glActiveTextureARB (GLenum);
+  GLAPI void APIENTRY glClientActiveTextureARB (GLenum);
+  GLAPI void APIENTRY glMultiTexCoord1dARB (GLenum, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord1dvARB (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord1fARB (GLenum, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord1fvARB (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord1iARB (GLenum, GLint);
+  GLAPI void APIENTRY glMultiTexCoord1ivARB (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord1sARB (GLenum, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord1svARB (GLenum, const GLshort *);
+  GLAPI void APIENTRY glMultiTexCoord2dARB (GLenum, GLdouble, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord2dvARB (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord2fARB (GLenum, GLfloat, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord2fvARB (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord2iARB (GLenum, GLint, GLint);
+  GLAPI void APIENTRY glMultiTexCoord2ivARB (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord2sARB (GLenum, GLshort, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord2svARB (GLenum, const GLshort *);
+  GLAPI void APIENTRY glMultiTexCoord3dARB (GLenum, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord3dvARB (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord3fARB (GLenum, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord3fvARB (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord3iARB (GLenum, GLint, GLint, GLint);
+  GLAPI void APIENTRY glMultiTexCoord3ivARB (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord3sARB (GLenum, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord3svARB (GLenum, const GLshort *);
+  GLAPI void APIENTRY glMultiTexCoord4dARB (GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glMultiTexCoord4dvARB (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glMultiTexCoord4fARB (GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glMultiTexCoord4fvARB (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glMultiTexCoord4iARB (GLenum, GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glMultiTexCoord4ivARB (GLenum, const GLint *);
+  GLAPI void APIENTRY glMultiTexCoord4sARB (GLenum, GLshort, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glMultiTexCoord4svARB (GLenum, const GLshort *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLACTIVETEXTUREARBPROC) (GLenum texture);
+  typedef void (APIENTRYP PFNGLCLIENTACTIVETEXTUREARBPROC) (GLenum texture);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DARBPROC) (GLenum target, GLdouble s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1DVARBPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FARBPROC) (GLenum target, GLfloat s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1FVARBPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IARBPROC) (GLenum target, GLint s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1IVARBPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SARBPROC) (GLenum target, GLshort s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1SVARBPROC) (GLenum target, const GLshort *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DARBPROC) (GLenum target, GLdouble s, GLdouble t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2DVARBPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FARBPROC) (GLenum target, GLfloat s, GLfloat t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2FVARBPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IARBPROC) (GLenum target, GLint s, GLint t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2IVARBPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SARBPROC) (GLenum target, GLshort s, GLshort t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2SVARBPROC) (GLenum target, const GLshort *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3DVARBPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3FVARBPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IARBPROC) (GLenum target, GLint s, GLint t, GLint r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3IVARBPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3SVARBPROC) (GLenum target, const GLshort *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4DVARBPROC) (GLenum target, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4FVARBPROC) (GLenum target, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IARBPROC) (GLenum target, GLint s, GLint t, GLint r, GLint q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4IVARBPROC) (GLenum target, const GLint *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4SVARBPROC) (GLenum target, const GLshort *v);
+#endif
+
+#ifndef GL_ARB_transpose_matrix
+#define GL_ARB_transpose_matrix 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glLoadTransposeMatrixfARB (const GLfloat *);
+  GLAPI void APIENTRY glLoadTransposeMatrixdARB (const GLdouble *);
+  GLAPI void APIENTRY glMultTransposeMatrixfARB (const GLfloat *);
+  GLAPI void APIENTRY glMultTransposeMatrixdARB (const GLdouble *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXFARBPROC) (const GLfloat *m);
+  typedef void (APIENTRYP PFNGLLOADTRANSPOSEMATRIXDARBPROC) (const GLdouble *m);
+  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXFARBPROC) (const GLfloat *m);
+  typedef void (APIENTRYP PFNGLMULTTRANSPOSEMATRIXDARBPROC) (const GLdouble *m);
+#endif
+
+#ifndef GL_ARB_multisample
+#define GL_ARB_multisample 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glSampleCoverageARB (GLclampf, GLboolean);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSAMPLECOVERAGEARBPROC) (GLclampf value, GLboolean invert);
+#endif
+
+#ifndef GL_ARB_texture_env_add
+#define GL_ARB_texture_env_add 1
+#endif
+
+#ifndef GL_ARB_texture_cube_map
+#define GL_ARB_texture_cube_map 1
+#endif
+
+#ifndef GL_ARB_texture_compression
+#define GL_ARB_texture_compression 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glCompressedTexImage3DARB (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexImage2DARB (GLenum, GLint, GLenum, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexImage1DARB (GLenum, GLint, GLenum, GLsizei, GLint, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexSubImage3DARB (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexSubImage2DARB (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glCompressedTexSubImage1DARB (GLenum, GLint, GLint, GLsizei, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glGetCompressedTexImageARB (GLenum, GLint, GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE3DARBPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE2DARBPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXIMAGE1DARBPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC) (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLGETCOMPRESSEDTEXIMAGEARBPROC) (GLenum target, GLint level, GLvoid *img);
+#endif
+
+#ifndef GL_ARB_texture_border_clamp
+#define GL_ARB_texture_border_clamp 1
+#endif
+
+#ifndef GL_ARB_point_parameters
+#define GL_ARB_point_parameters 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPointParameterfARB (GLenum, GLfloat);
+  GLAPI void APIENTRY glPointParameterfvARB (GLenum, const GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFARBPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVARBPROC) (GLenum pname, const GLfloat *params);
+#endif
+
+#ifndef GL_ARB_vertex_blend
+#define GL_ARB_vertex_blend 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glWeightbvARB (GLint, const GLbyte *);
+  GLAPI void APIENTRY glWeightsvARB (GLint, const GLshort *);
+  GLAPI void APIENTRY glWeightivARB (GLint, const GLint *);
+  GLAPI void APIENTRY glWeightfvARB (GLint, const GLfloat *);
+  GLAPI void APIENTRY glWeightdvARB (GLint, const GLdouble *);
+  GLAPI void APIENTRY glWeightubvARB (GLint, const GLubyte *);
+  GLAPI void APIENTRY glWeightusvARB (GLint, const GLushort *);
+  GLAPI void APIENTRY glWeightuivARB (GLint, const GLuint *);
+  GLAPI void APIENTRY glWeightPointerARB (GLint, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glVertexBlendARB (GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLWEIGHTBVARBPROC) (GLint size, const GLbyte *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTSVARBPROC) (GLint size, const GLshort *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTIVARBPROC) (GLint size, const GLint *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTFVARBPROC) (GLint size, const GLfloat *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTDVARBPROC) (GLint size, const GLdouble *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTUBVARBPROC) (GLint size, const GLubyte *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTUSVARBPROC) (GLint size, const GLushort *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTUIVARBPROC) (GLint size, const GLuint *weights);
+  typedef void (APIENTRYP PFNGLWEIGHTPOINTERARBPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLVERTEXBLENDARBPROC) (GLint count);
+#endif
+
+#ifndef GL_ARB_matrix_palette
+#define GL_ARB_matrix_palette 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glCurrentPaletteMatrixARB (GLint);
+  GLAPI void APIENTRY glMatrixIndexubvARB (GLint, const GLubyte *);
+  GLAPI void APIENTRY glMatrixIndexusvARB (GLint, const GLushort *);
+  GLAPI void APIENTRY glMatrixIndexuivARB (GLint, const GLuint *);
+  GLAPI void APIENTRY glMatrixIndexPointerARB (GLint, GLenum, GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCURRENTPALETTEMATRIXARBPROC) (GLint index);
+  typedef void (APIENTRYP PFNGLMATRIXINDEXUBVARBPROC) (GLint size, const GLubyte *indices);
+  typedef void (APIENTRYP PFNGLMATRIXINDEXUSVARBPROC) (GLint size, const GLushort *indices);
+  typedef void (APIENTRYP PFNGLMATRIXINDEXUIVARBPROC) (GLint size, const GLuint *indices);
+  typedef void (APIENTRYP PFNGLMATRIXINDEXPOINTERARBPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
+#endif
+
+#ifndef GL_ARB_texture_env_combine
+#define GL_ARB_texture_env_combine 1
+#endif
+
+#ifndef GL_ARB_texture_env_crossbar
+#define GL_ARB_texture_env_crossbar 1
+#endif
+
+#ifndef GL_ARB_texture_env_dot3
+#define GL_ARB_texture_env_dot3 1
+#endif
+
+#ifndef GL_ARB_texture_mirrored_repeat
+#define GL_ARB_texture_mirrored_repeat 1
+#endif
+
+#ifndef GL_ARB_depth_texture
+#define GL_ARB_depth_texture 1
+#endif
+
+#ifndef GL_ARB_shadow
+#define GL_ARB_shadow 1
+#endif
+
+#ifndef GL_ARB_shadow_ambient
+#define GL_ARB_shadow_ambient 1
+#endif
+
+#ifndef GL_ARB_window_pos
+#define GL_ARB_window_pos 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glWindowPos2dARB (GLdouble, GLdouble);
+  GLAPI void APIENTRY glWindowPos2dvARB (const GLdouble *);
+  GLAPI void APIENTRY glWindowPos2fARB (GLfloat, GLfloat);
+  GLAPI void APIENTRY glWindowPos2fvARB (const GLfloat *);
+  GLAPI void APIENTRY glWindowPos2iARB (GLint, GLint);
+  GLAPI void APIENTRY glWindowPos2ivARB (const GLint *);
+  GLAPI void APIENTRY glWindowPos2sARB (GLshort, GLshort);
+  GLAPI void APIENTRY glWindowPos2svARB (const GLshort *);
+  GLAPI void APIENTRY glWindowPos3dARB (GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glWindowPos3dvARB (const GLdouble *);
+  GLAPI void APIENTRY glWindowPos3fARB (GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glWindowPos3fvARB (const GLfloat *);
+  GLAPI void APIENTRY glWindowPos3iARB (GLint, GLint, GLint);
+  GLAPI void APIENTRY glWindowPos3ivARB (const GLint *);
+  GLAPI void APIENTRY glWindowPos3sARB (GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glWindowPos3svARB (const GLshort *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLWINDOWPOS2DARBPROC) (GLdouble x, GLdouble y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2DVARBPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2FARBPROC) (GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2FVARBPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2IARBPROC) (GLint x, GLint y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2IVARBPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2SARBPROC) (GLshort x, GLshort y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2SVARBPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3DARBPROC) (GLdouble x, GLdouble y, GLdouble z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3DVARBPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3FARBPROC) (GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3FVARBPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3IARBPROC) (GLint x, GLint y, GLint z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3IVARBPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3SARBPROC) (GLshort x, GLshort y, GLshort z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3SVARBPROC) (const GLshort *v);
+#endif
+
+#ifndef GL_ARB_vertex_program
+#define GL_ARB_vertex_program 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glVertexAttrib1dARB (GLuint, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib1dvARB (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib1fARB (GLuint, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib1fvARB (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib1sARB (GLuint, GLshort);
+  GLAPI void APIENTRY glVertexAttrib1svARB (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib2dARB (GLuint, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib2dvARB (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib2fARB (GLuint, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib2fvARB (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib2sARB (GLuint, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib2svARB (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib3dARB (GLuint, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib3dvARB (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib3fARB (GLuint, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib3fvARB (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib3sARB (GLuint, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib3svARB (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4NbvARB (GLuint, const GLbyte *);
+  GLAPI void APIENTRY glVertexAttrib4NivARB (GLuint, const GLint *);
+  GLAPI void APIENTRY glVertexAttrib4NsvARB (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4NubARB (GLuint, GLubyte, GLubyte, GLubyte, GLubyte);
+  GLAPI void APIENTRY glVertexAttrib4NubvARB (GLuint, const GLubyte *);
+  GLAPI void APIENTRY glVertexAttrib4NuivARB (GLuint, const GLuint *);
+  GLAPI void APIENTRY glVertexAttrib4NusvARB (GLuint, const GLushort *);
+  GLAPI void APIENTRY glVertexAttrib4bvARB (GLuint, const GLbyte *);
+  GLAPI void APIENTRY glVertexAttrib4dARB (GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib4dvARB (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib4fARB (GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib4fvARB (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib4ivARB (GLuint, const GLint *);
+  GLAPI void APIENTRY glVertexAttrib4sARB (GLuint, GLshort, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib4svARB (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4ubvARB (GLuint, const GLubyte *);
+  GLAPI void APIENTRY glVertexAttrib4uivARB (GLuint, const GLuint *);
+  GLAPI void APIENTRY glVertexAttrib4usvARB (GLuint, const GLushort *);
+  GLAPI void APIENTRY glVertexAttribPointerARB (GLuint, GLint, GLenum, GLboolean, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glEnableVertexAttribArrayARB (GLuint);
+  GLAPI void APIENTRY glDisableVertexAttribArrayARB (GLuint);
+  GLAPI void APIENTRY glProgramStringARB (GLenum, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glBindProgramARB (GLenum, GLuint);
+  GLAPI void APIENTRY glDeleteProgramsARB (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenProgramsARB (GLsizei, GLuint *);
+  GLAPI void APIENTRY glProgramEnvParameter4dARB (GLenum, GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glProgramEnvParameter4dvARB (GLenum, GLuint, const GLdouble *);
+  GLAPI void APIENTRY glProgramEnvParameter4fARB (GLenum, GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glProgramEnvParameter4fvARB (GLenum, GLuint, const GLfloat *);
+  GLAPI void APIENTRY glProgramLocalParameter4dARB (GLenum, GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glProgramLocalParameter4dvARB (GLenum, GLuint, const GLdouble *);
+  GLAPI void APIENTRY glProgramLocalParameter4fARB (GLenum, GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glProgramLocalParameter4fvARB (GLenum, GLuint, const GLfloat *);
+  GLAPI void APIENTRY glGetProgramEnvParameterdvARB (GLenum, GLuint, GLdouble *);
+  GLAPI void APIENTRY glGetProgramEnvParameterfvARB (GLenum, GLuint, GLfloat *);
+  GLAPI void APIENTRY glGetProgramLocalParameterdvARB (GLenum, GLuint, GLdouble *);
+  GLAPI void APIENTRY glGetProgramLocalParameterfvARB (GLenum, GLuint, GLfloat *);
+  GLAPI void APIENTRY glGetProgramivARB (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetProgramStringARB (GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetVertexAttribdvARB (GLuint, GLenum, GLdouble *);
+  GLAPI void APIENTRY glGetVertexAttribfvARB (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetVertexAttribivARB (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetVertexAttribPointervARB (GLuint, GLenum, GLvoid* *);
+  GLAPI GLboolean APIENTRY glIsProgramARB (GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DARBPROC) (GLuint index, GLdouble x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DVARBPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FARBPROC) (GLuint index, GLfloat x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FVARBPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SARBPROC) (GLuint index, GLshort x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SVARBPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DARBPROC) (GLuint index, GLdouble x, GLdouble y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DVARBPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FARBPROC) (GLuint index, GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FVARBPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SARBPROC) (GLuint index, GLshort x, GLshort y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SVARBPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DARBPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DVARBPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FARBPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FVARBPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SARBPROC) (GLuint index, GLshort x, GLshort y, GLshort z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SVARBPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NBVARBPROC) (GLuint index, const GLbyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NIVARBPROC) (GLuint index, const GLint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NSVARBPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBARBPROC) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUBVARBPROC) (GLuint index, const GLubyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUIVARBPROC) (GLuint index, const GLuint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4NUSVARBPROC) (GLuint index, const GLushort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4BVARBPROC) (GLuint index, const GLbyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DARBPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DVARBPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FARBPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FVARBPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4IVARBPROC) (GLuint index, const GLint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SARBPROC) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SVARBPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBVARBPROC) (GLuint index, const GLubyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UIVARBPROC) (GLuint index, const GLuint *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4USVARBPROC) (GLuint index, const GLushort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBPOINTERARBPROC) (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLENABLEVERTEXATTRIBARRAYARBPROC) (GLuint index);
+  typedef void (APIENTRYP PFNGLDISABLEVERTEXATTRIBARRAYARBPROC) (GLuint index);
+  typedef void (APIENTRYP PFNGLPROGRAMSTRINGARBPROC) (GLenum target, GLenum format, GLsizei len, const GLvoid *string);
+  typedef void (APIENTRYP PFNGLBINDPROGRAMARBPROC) (GLenum target, GLuint program);
+  typedef void (APIENTRYP PFNGLDELETEPROGRAMSARBPROC) (GLsizei n, const GLuint *programs);
+  typedef void (APIENTRYP PFNGLGENPROGRAMSARBPROC) (GLsizei n, GLuint *programs);
+  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4DARBPROC) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4DVARBPROC) (GLenum target, GLuint index, const GLdouble *params);
+  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4FARBPROC) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLPROGRAMENVPARAMETER4FVARBPROC) (GLenum target, GLuint index, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4DARBPROC) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4DVARBPROC) (GLenum target, GLuint index, const GLdouble *params);
+  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4FARBPROC) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLPROGRAMLOCALPARAMETER4FVARBPROC) (GLenum target, GLuint index, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMENVPARAMETERDVARBPROC) (GLenum target, GLuint index, GLdouble *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMENVPARAMETERFVARBPROC) (GLenum target, GLuint index, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC) (GLenum target, GLuint index, GLdouble *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC) (GLenum target, GLuint index, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMIVARBPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMSTRINGARBPROC) (GLenum target, GLenum pname, GLvoid *string);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBDVARBPROC) (GLuint index, GLenum pname, GLdouble *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBFVARBPROC) (GLuint index, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBIVARBPROC) (GLuint index, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBPOINTERVARBPROC) (GLuint index, GLenum pname, GLvoid* *pointer);
+  typedef GLboolean (APIENTRYP PFNGLISPROGRAMARBPROC) (GLuint program);
+#endif
+
+#ifndef GL_ARB_fragment_program
+#define GL_ARB_fragment_program 1
+  /* All ARB_fragment_program entry points are shared with ARB_vertex_program. */
+#endif
+
+#ifndef GL_ARB_vertex_buffer_object
+#define GL_ARB_vertex_buffer_object 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBindBufferARB (GLenum, GLuint);
+  GLAPI void APIENTRY glDeleteBuffersARB (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenBuffersARB (GLsizei, GLuint *);
+  GLAPI GLboolean APIENTRY glIsBufferARB (GLuint);
+  GLAPI void APIENTRY glBufferDataARB (GLenum, GLsizeiptrARB, const GLvoid *, GLenum);
+  GLAPI void APIENTRY glBufferSubDataARB (GLenum, GLintptrARB, GLsizeiptrARB, const GLvoid *);
+  GLAPI void APIENTRY glGetBufferSubDataARB (GLenum, GLintptrARB, GLsizeiptrARB, GLvoid *);
+  GLAPI GLvoid* APIENTRY glMapBufferARB (GLenum, GLenum);
+  GLAPI GLboolean APIENTRY glUnmapBufferARB (GLenum);
+  GLAPI void APIENTRY glGetBufferParameterivARB (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetBufferPointervARB (GLenum, GLenum, GLvoid* *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBINDBUFFERARBPROC) (GLenum target, GLuint buffer);
+  typedef void (APIENTRYP PFNGLDELETEBUFFERSARBPROC) (GLsizei n, const GLuint *buffers);
+  typedef void (APIENTRYP PFNGLGENBUFFERSARBPROC) (GLsizei n, GLuint *buffers);
+  typedef GLboolean (APIENTRYP PFNGLISBUFFERARBPROC) (GLuint buffer);
+  typedef void (APIENTRYP PFNGLBUFFERDATAARBPROC) (GLenum target, GLsizeiptrARB size, const GLvoid *data, GLenum usage);
+  typedef void (APIENTRYP PFNGLBUFFERSUBDATAARBPROC) (GLenum target, GLintptrARB offset, GLsizeiptrARB size, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLGETBUFFERSUBDATAARBPROC) (GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid *data);
+  typedef GLvoid* (APIENTRYP PFNGLMAPBUFFERARBPROC) (GLenum target, GLenum access);
+  typedef GLboolean (APIENTRYP PFNGLUNMAPBUFFERARBPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLGETBUFFERPARAMETERIVARBPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETBUFFERPOINTERVARBPROC) (GLenum target, GLenum pname, GLvoid* *params);
+#endif
+
+#ifndef GL_ARB_occlusion_query
+#define GL_ARB_occlusion_query 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGenQueriesARB (GLsizei, GLuint *);
+  GLAPI void APIENTRY glDeleteQueriesARB (GLsizei, const GLuint *);
+  GLAPI GLboolean APIENTRY glIsQueryARB (GLuint);
+  GLAPI void APIENTRY glBeginQueryARB (GLenum, GLuint);
+  GLAPI void APIENTRY glEndQueryARB (GLenum);
+  GLAPI void APIENTRY glGetQueryivARB (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetQueryObjectivARB (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetQueryObjectuivARB (GLuint, GLenum, GLuint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGENQUERIESARBPROC) (GLsizei n, GLuint *ids);
+  typedef void (APIENTRYP PFNGLDELETEQUERIESARBPROC) (GLsizei n, const GLuint *ids);
+  typedef GLboolean (APIENTRYP PFNGLISQUERYARBPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLBEGINQUERYARBPROC) (GLenum target, GLuint id);
+  typedef void (APIENTRYP PFNGLENDQUERYARBPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLGETQUERYIVARBPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETQUERYOBJECTIVARBPROC) (GLuint id, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETQUERYOBJECTUIVARBPROC) (GLuint id, GLenum pname, GLuint *params);
+#endif
+
+#ifndef GL_ARB_shader_objects
+#define GL_ARB_shader_objects 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDeleteObjectARB (GLhandleARB);
+  GLAPI GLhandleARB APIENTRY glGetHandleARB (GLenum);
+  GLAPI void APIENTRY glDetachObjectARB (GLhandleARB, GLhandleARB);
+  GLAPI GLhandleARB APIENTRY glCreateShaderObjectARB (GLenum);
+  GLAPI void APIENTRY glShaderSourceARB (GLhandleARB, GLsizei, const GLcharARB* *, const GLint *);
+  GLAPI void APIENTRY glCompileShaderARB (GLhandleARB);
+  GLAPI GLhandleARB APIENTRY glCreateProgramObjectARB (void);
+  GLAPI void APIENTRY glAttachObjectARB (GLhandleARB, GLhandleARB);
+  GLAPI void APIENTRY glLinkProgramARB (GLhandleARB);
+  GLAPI void APIENTRY glUseProgramObjectARB (GLhandleARB);
+  GLAPI void APIENTRY glValidateProgramARB (GLhandleARB);
+  GLAPI void APIENTRY glUniform1fARB (GLint, GLfloat);
+  GLAPI void APIENTRY glUniform2fARB (GLint, GLfloat, GLfloat);
+  GLAPI void APIENTRY glUniform3fARB (GLint, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glUniform4fARB (GLint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glUniform1iARB (GLint, GLint);
+  GLAPI void APIENTRY glUniform2iARB (GLint, GLint, GLint);
+  GLAPI void APIENTRY glUniform3iARB (GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glUniform4iARB (GLint, GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glUniform1fvARB (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform2fvARB (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform3fvARB (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform4fvARB (GLint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glUniform1ivARB (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniform2ivARB (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniform3ivARB (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniform4ivARB (GLint, GLsizei, const GLint *);
+  GLAPI void APIENTRY glUniformMatrix2fvARB (GLint, GLsizei, GLboolean, const GLfloat *);
+  GLAPI void APIENTRY glUniformMatrix3fvARB (GLint, GLsizei, GLboolean, const GLfloat *);
+  GLAPI void APIENTRY glUniformMatrix4fvARB (GLint, GLsizei, GLboolean, const GLfloat *);
+  GLAPI void APIENTRY glGetObjectParameterfvARB (GLhandleARB, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetObjectParameterivARB (GLhandleARB, GLenum, GLint *);
+  GLAPI void APIENTRY glGetInfoLogARB (GLhandleARB, GLsizei, GLsizei *, GLcharARB *);
+  GLAPI void APIENTRY glGetAttachedObjectsARB (GLhandleARB, GLsizei, GLsizei *, GLhandleARB *);
+  GLAPI GLint APIENTRY glGetUniformLocationARB (GLhandleARB, const GLcharARB *);
+  GLAPI void APIENTRY glGetActiveUniformARB (GLhandleARB, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLcharARB *);
+  GLAPI void APIENTRY glGetUniformfvARB (GLhandleARB, GLint, GLfloat *);
+  GLAPI void APIENTRY glGetUniformivARB (GLhandleARB, GLint, GLint *);
+  GLAPI void APIENTRY glGetShaderSourceARB (GLhandleARB, GLsizei, GLsizei *, GLcharARB *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDELETEOBJECTARBPROC) (GLhandleARB obj);
+  typedef GLhandleARB (APIENTRYP PFNGLGETHANDLEARBPROC) (GLenum pname);
+  typedef void (APIENTRYP PFNGLDETACHOBJECTARBPROC) (GLhandleARB containerObj, GLhandleARB attachedObj);
+  typedef GLhandleARB (APIENTRYP PFNGLCREATESHADEROBJECTARBPROC) (GLenum shaderType);
+  typedef void (APIENTRYP PFNGLSHADERSOURCEARBPROC) (GLhandleARB shaderObj, GLsizei count, const GLcharARB* *string, const GLint *length);
+  typedef void (APIENTRYP PFNGLCOMPILESHADERARBPROC) (GLhandleARB shaderObj);
+  typedef GLhandleARB (APIENTRYP PFNGLCREATEPROGRAMOBJECTARBPROC) (void);
+  typedef void (APIENTRYP PFNGLATTACHOBJECTARBPROC) (GLhandleARB containerObj, GLhandleARB obj);
+  typedef void (APIENTRYP PFNGLLINKPROGRAMARBPROC) (GLhandleARB programObj);
+  typedef void (APIENTRYP PFNGLUSEPROGRAMOBJECTARBPROC) (GLhandleARB programObj);
+  typedef void (APIENTRYP PFNGLVALIDATEPROGRAMARBPROC) (GLhandleARB programObj);
+  typedef void (APIENTRYP PFNGLUNIFORM1FARBPROC) (GLint location, GLfloat v0);
+  typedef void (APIENTRYP PFNGLUNIFORM2FARBPROC) (GLint location, GLfloat v0, GLfloat v1);
+  typedef void (APIENTRYP PFNGLUNIFORM3FARBPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
+  typedef void (APIENTRYP PFNGLUNIFORM4FARBPROC) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
+  typedef void (APIENTRYP PFNGLUNIFORM1IARBPROC) (GLint location, GLint v0);
+  typedef void (APIENTRYP PFNGLUNIFORM2IARBPROC) (GLint location, GLint v0, GLint v1);
+  typedef void (APIENTRYP PFNGLUNIFORM3IARBPROC) (GLint location, GLint v0, GLint v1, GLint v2);
+  typedef void (APIENTRYP PFNGLUNIFORM4IARBPROC) (GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
+  typedef void (APIENTRYP PFNGLUNIFORM1FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM2FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM3FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM4FVARBPROC) (GLint location, GLsizei count, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORM1IVARBPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORM2IVARBPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORM3IVARBPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORM4IVARBPROC) (GLint location, GLsizei count, const GLint *value);
+  typedef void (APIENTRYP PFNGLUNIFORMMATRIX2FVARBPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORMMATRIX3FVARBPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLUNIFORMMATRIX4FVARBPROC) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
+  typedef void (APIENTRYP PFNGLGETOBJECTPARAMETERFVARBPROC) (GLhandleARB obj, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETOBJECTPARAMETERIVARBPROC) (GLhandleARB obj, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETINFOLOGARBPROC) (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *infoLog);
+  typedef void (APIENTRYP PFNGLGETATTACHEDOBJECTSARBPROC) (GLhandleARB containerObj, GLsizei maxCount, GLsizei *count, GLhandleARB *obj);
+  typedef GLint (APIENTRYP PFNGLGETUNIFORMLOCATIONARBPROC) (GLhandleARB programObj, const GLcharARB *name);
+  typedef void (APIENTRYP PFNGLGETACTIVEUNIFORMARBPROC) (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
+  typedef void (APIENTRYP PFNGLGETUNIFORMFVARBPROC) (GLhandleARB programObj, GLint location, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETUNIFORMIVARBPROC) (GLhandleARB programObj, GLint location, GLint *params);
+  typedef void (APIENTRYP PFNGLGETSHADERSOURCEARBPROC) (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *source);
+#endif
+
+#ifndef GL_ARB_vertex_shader
+#define GL_ARB_vertex_shader 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBindAttribLocationARB (GLhandleARB, GLuint, const GLcharARB *);
+  GLAPI void APIENTRY glGetActiveAttribARB (GLhandleARB, GLuint, GLsizei, GLsizei *, GLint *, GLenum *, GLcharARB *);
+  GLAPI GLint APIENTRY glGetAttribLocationARB (GLhandleARB, const GLcharARB *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBINDATTRIBLOCATIONARBPROC) (GLhandleARB programObj, GLuint index, const GLcharARB *name);
+  typedef void (APIENTRYP PFNGLGETACTIVEATTRIBARBPROC) (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
+  typedef GLint (APIENTRYP PFNGLGETATTRIBLOCATIONARBPROC) (GLhandleARB programObj, const GLcharARB *name);
+#endif
+
+#ifndef GL_ARB_fragment_shader
+#define GL_ARB_fragment_shader 1
+#endif
+
+#ifndef GL_ARB_shading_language_100
+#define GL_ARB_shading_language_100 1
+#endif
+
+#ifndef GL_ARB_texture_non_power_of_two
+#define GL_ARB_texture_non_power_of_two 1
+#endif
+
+#ifndef GL_ARB_point_sprite
+#define GL_ARB_point_sprite 1
+#endif
+
+#ifndef GL_ARB_fragment_program_shadow
+#define GL_ARB_fragment_program_shadow 1
+#endif
+
+#ifndef GL_ARB_draw_buffers
+#define GL_ARB_draw_buffers 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDrawBuffersARB (GLsizei, const GLenum *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDRAWBUFFERSARBPROC) (GLsizei n, const GLenum *bufs);
+#endif
+
+#ifndef GL_ARB_texture_rectangle
+#define GL_ARB_texture_rectangle 1
+#endif
+
+#ifndef GL_ARB_color_buffer_float
+#define GL_ARB_color_buffer_float 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glClampColorARB (GLenum, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCLAMPCOLORARBPROC) (GLenum target, GLenum clamp);
+#endif
+
+#ifndef GL_ARB_half_float_pixel
+#define GL_ARB_half_float_pixel 1
+#endif
+
+#ifndef GL_ARB_texture_float
+#define GL_ARB_texture_float 1
+#endif
+
+#ifndef GL_ARB_pixel_buffer_object
+#define GL_ARB_pixel_buffer_object 1
+#endif
+
+#ifndef GL_EXT_abgr
+#define GL_EXT_abgr 1
+#endif
+
+#ifndef GL_EXT_blend_color
+#define GL_EXT_blend_color 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendColorEXT (GLclampf, GLclampf, GLclampf, GLclampf);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDCOLOREXTPROC) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
+#endif
+
+#ifndef GL_EXT_polygon_offset
+#define GL_EXT_polygon_offset 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPolygonOffsetEXT (GLfloat, GLfloat);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPOLYGONOFFSETEXTPROC) (GLfloat factor, GLfloat bias);
+#endif
+
+#ifndef GL_EXT_texture
+#define GL_EXT_texture 1
+#endif
+
+#ifndef GL_EXT_texture3D
+#define GL_EXT_texture3D 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTexImage3DEXT (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glTexSubImage3DEXT (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTEXIMAGE3DEXTPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
+  typedef void (APIENTRYP PFNGLTEXSUBIMAGE3DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels);
+#endif
+
+#ifndef GL_SGIS_texture_filter4
+#define GL_SGIS_texture_filter4 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGetTexFilterFuncSGIS (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glTexFilterFuncSGIS (GLenum, GLenum, GLsizei, const GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGETTEXFILTERFUNCSGISPROC) (GLenum target, GLenum filter, GLfloat *weights);
+  typedef void (APIENTRYP PFNGLTEXFILTERFUNCSGISPROC) (GLenum target, GLenum filter, GLsizei n, const GLfloat *weights);
+#endif
+
+#ifndef GL_EXT_subtexture
+#define GL_EXT_subtexture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTexSubImage1DEXT (GLenum, GLint, GLint, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glTexSubImage2DEXT (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTEXSUBIMAGE1DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels);
+  typedef void (APIENTRYP PFNGLTEXSUBIMAGE2DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
+#endif
+
+#ifndef GL_EXT_copy_texture
+#define GL_EXT_copy_texture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glCopyTexImage1DEXT (GLenum, GLint, GLenum, GLint, GLint, GLsizei, GLint);
+  GLAPI void APIENTRY glCopyTexImage2DEXT (GLenum, GLint, GLenum, GLint, GLint, GLsizei, GLsizei, GLint);
+  GLAPI void APIENTRY glCopyTexSubImage1DEXT (GLenum, GLint, GLint, GLint, GLint, GLsizei);
+  GLAPI void APIENTRY glCopyTexSubImage2DEXT (GLenum, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
+  GLAPI void APIENTRY glCopyTexSubImage3DEXT (GLenum, GLint, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOPYTEXIMAGE1DEXTPROC) (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border);
+  typedef void (APIENTRYP PFNGLCOPYTEXIMAGE2DEXTPROC) (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
+  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE1DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
+  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE2DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
+  typedef void (APIENTRYP PFNGLCOPYTEXSUBIMAGE3DEXTPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
+#endif
+
+#ifndef GL_EXT_histogram
+#define GL_EXT_histogram 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGetHistogramEXT (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetHistogramParameterfvEXT (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetHistogramParameterivEXT (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetMinmaxEXT (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetMinmaxParameterfvEXT (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetMinmaxParameterivEXT (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glHistogramEXT (GLenum, GLsizei, GLenum, GLboolean);
+  GLAPI void APIENTRY glMinmaxEXT (GLenum, GLenum, GLboolean);
+  GLAPI void APIENTRY glResetHistogramEXT (GLenum);
+  GLAPI void APIENTRY glResetMinmaxEXT (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGETHISTOGRAMEXTPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
+  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETHISTOGRAMPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETMINMAXEXTPROC) (GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
+  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETMINMAXPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLHISTOGRAMEXTPROC) (GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
+  typedef void (APIENTRYP PFNGLMINMAXEXTPROC) (GLenum target, GLenum internalformat, GLboolean sink);
+  typedef void (APIENTRYP PFNGLRESETHISTOGRAMEXTPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLRESETMINMAXEXTPROC) (GLenum target);
+#endif
+
+#ifndef GL_EXT_convolution
+#define GL_EXT_convolution 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glConvolutionFilter1DEXT (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glConvolutionFilter2DEXT (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glConvolutionParameterfEXT (GLenum, GLenum, GLfloat);
+  GLAPI void APIENTRY glConvolutionParameterfvEXT (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glConvolutionParameteriEXT (GLenum, GLenum, GLint);
+  GLAPI void APIENTRY glConvolutionParameterivEXT (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glCopyConvolutionFilter1DEXT (GLenum, GLenum, GLint, GLint, GLsizei);
+  GLAPI void APIENTRY glCopyConvolutionFilter2DEXT (GLenum, GLenum, GLint, GLint, GLsizei, GLsizei);
+  GLAPI void APIENTRY glGetConvolutionFilterEXT (GLenum, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetConvolutionParameterfvEXT (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetConvolutionParameterivEXT (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetSeparableFilterEXT (GLenum, GLenum, GLenum, GLvoid *, GLvoid *, GLvoid *);
+  GLAPI void APIENTRY glSeparableFilter2DEXT (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER1DEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONFILTER2DEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFEXTPROC) (GLenum target, GLenum pname, GLfloat params);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERFVEXTPROC) (GLenum target, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIEXTPROC) (GLenum target, GLenum pname, GLint params);
+  typedef void (APIENTRYP PFNGLCONVOLUTIONPARAMETERIVEXTPROC) (GLenum target, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER1DEXTPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
+  typedef void (APIENTRYP PFNGLCOPYCONVOLUTIONFILTER2DEXTPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
+  typedef void (APIENTRYP PFNGLGETCONVOLUTIONFILTEREXTPROC) (GLenum target, GLenum format, GLenum type, GLvoid *image);
+  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETCONVOLUTIONPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETSEPARABLEFILTEREXTPROC) (GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span);
+  typedef void (APIENTRYP PFNGLSEPARABLEFILTER2DEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column);
+#endif
+
+#ifndef GL_EXT_color_matrix
+#define GL_EXT_color_matrix 1
+#endif
+
+#ifndef GL_SGI_color_table
+#define GL_SGI_color_table 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glColorTableSGI (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glColorTableParameterfvSGI (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glColorTableParameterivSGI (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glCopyColorTableSGI (GLenum, GLenum, GLint, GLint, GLsizei);
+  GLAPI void APIENTRY glGetColorTableSGI (GLenum, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetColorTableParameterfvSGI (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetColorTableParameterivSGI (GLenum, GLenum, GLint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOLORTABLESGIPROC) (GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table);
+  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERFVSGIPROC) (GLenum target, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLCOLORTABLEPARAMETERIVSGIPROC) (GLenum target, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLCOPYCOLORTABLESGIPROC) (GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLESGIPROC) (GLenum target, GLenum format, GLenum type, GLvoid *table);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERFVSGIPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERIVSGIPROC) (GLenum target, GLenum pname, GLint *params);
+#endif
+
+#ifndef GL_SGIX_pixel_texture
+#define GL_SGIX_pixel_texture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPixelTexGenSGIX (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPIXELTEXGENSGIXPROC) (GLenum mode);
+#endif
+
+#ifndef GL_SGIS_pixel_texture
+#define GL_SGIS_pixel_texture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPixelTexGenParameteriSGIS (GLenum, GLint);
+  GLAPI void APIENTRY glPixelTexGenParameterivSGIS (GLenum, const GLint *);
+  GLAPI void APIENTRY glPixelTexGenParameterfSGIS (GLenum, GLfloat);
+  GLAPI void APIENTRY glPixelTexGenParameterfvSGIS (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glGetPixelTexGenParameterivSGIS (GLenum, GLint *);
+  GLAPI void APIENTRY glGetPixelTexGenParameterfvSGIS (GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERISGISPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERIVSGISPROC) (GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERFSGISPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLPIXELTEXGENPARAMETERFVSGISPROC) (GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETPIXELTEXGENPARAMETERIVSGISPROC) (GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETPIXELTEXGENPARAMETERFVSGISPROC) (GLenum pname, GLfloat *params);
+#endif
+
+#ifndef GL_SGIS_texture4D
+#define GL_SGIS_texture4D 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTexImage4DSGIS (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glTexSubImage4DSGIS (GLenum, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTEXIMAGE4DSGISPROC) (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
+  typedef void (APIENTRYP PFNGLTEXSUBIMAGE4DSGISPROC) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint woffset, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLenum format, GLenum type, const GLvoid *pixels);
+#endif
+
+#ifndef GL_SGI_texture_color_table
+#define GL_SGI_texture_color_table 1
+#endif
+
+#ifndef GL_EXT_cmyka
+#define GL_EXT_cmyka 1
+#endif
+
+#ifndef GL_EXT_texture_object
+#define GL_EXT_texture_object 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI GLboolean APIENTRY glAreTexturesResidentEXT (GLsizei, const GLuint *, GLboolean *);
+  GLAPI void APIENTRY glBindTextureEXT (GLenum, GLuint);
+  GLAPI void APIENTRY glDeleteTexturesEXT (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenTexturesEXT (GLsizei, GLuint *);
+  GLAPI GLboolean APIENTRY glIsTextureEXT (GLuint);
+  GLAPI void APIENTRY glPrioritizeTexturesEXT (GLsizei, const GLuint *, const GLclampf *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef GLboolean (APIENTRYP PFNGLARETEXTURESRESIDENTEXTPROC) (GLsizei n, const GLuint *textures, GLboolean *residences);
+  typedef void (APIENTRYP PFNGLBINDTEXTUREEXTPROC) (GLenum target, GLuint texture);
+  typedef void (APIENTRYP PFNGLDELETETEXTURESEXTPROC) (GLsizei n, const GLuint *textures);
+  typedef void (APIENTRYP PFNGLGENTEXTURESEXTPROC) (GLsizei n, GLuint *textures);
+  typedef GLboolean (APIENTRYP PFNGLISTEXTUREEXTPROC) (GLuint texture);
+  typedef void (APIENTRYP PFNGLPRIORITIZETEXTURESEXTPROC) (GLsizei n, const GLuint *textures, const GLclampf *priorities);
+#endif
+
+#ifndef GL_SGIS_detail_texture
+#define GL_SGIS_detail_texture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDetailTexFuncSGIS (GLenum, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glGetDetailTexFuncSGIS (GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDETAILTEXFUNCSGISPROC) (GLenum target, GLsizei n, const GLfloat *points);
+  typedef void (APIENTRYP PFNGLGETDETAILTEXFUNCSGISPROC) (GLenum target, GLfloat *points);
+#endif
+
+#ifndef GL_SGIS_sharpen_texture
+#define GL_SGIS_sharpen_texture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glSharpenTexFuncSGIS (GLenum, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glGetSharpenTexFuncSGIS (GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSHARPENTEXFUNCSGISPROC) (GLenum target, GLsizei n, const GLfloat *points);
+  typedef void (APIENTRYP PFNGLGETSHARPENTEXFUNCSGISPROC) (GLenum target, GLfloat *points);
+#endif
+
+#ifndef GL_EXT_packed_pixels
+#define GL_EXT_packed_pixels 1
+#endif
+
+#ifndef GL_SGIS_texture_lod
+#define GL_SGIS_texture_lod 1
+#endif
+
+#ifndef GL_SGIS_multisample
+#define GL_SGIS_multisample 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glSampleMaskSGIS (GLclampf, GLboolean);
+  GLAPI void APIENTRY glSamplePatternSGIS (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSAMPLEMASKSGISPROC) (GLclampf value, GLboolean invert);
+  typedef void (APIENTRYP PFNGLSAMPLEPATTERNSGISPROC) (GLenum pattern);
+#endif
+
+#ifndef GL_EXT_rescale_normal
+#define GL_EXT_rescale_normal 1
+#endif
+
+#ifndef GL_EXT_vertex_array
+#define GL_EXT_vertex_array 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glArrayElementEXT (GLint);
+  GLAPI void APIENTRY glColorPointerEXT (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glDrawArraysEXT (GLenum, GLint, GLsizei);
+  GLAPI void APIENTRY glEdgeFlagPointerEXT (GLsizei, GLsizei, const GLboolean *);
+  GLAPI void APIENTRY glGetPointervEXT (GLenum, GLvoid* *);
+  GLAPI void APIENTRY glIndexPointerEXT (GLenum, GLsizei, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glNormalPointerEXT (GLenum, GLsizei, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glTexCoordPointerEXT (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glVertexPointerEXT (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLARRAYELEMENTEXTPROC) (GLint i);
+  typedef void (APIENTRYP PFNGLCOLORPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLDRAWARRAYSEXTPROC) (GLenum mode, GLint first, GLsizei count);
+  typedef void (APIENTRYP PFNGLEDGEFLAGPOINTEREXTPROC) (GLsizei stride, GLsizei count, const GLboolean *pointer);
+  typedef void (APIENTRYP PFNGLGETPOINTERVEXTPROC) (GLenum pname, GLvoid* *params);
+  typedef void (APIENTRYP PFNGLINDEXPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLNORMALPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLTEXCOORDPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLVERTEXPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
+#endif
+
+#ifndef GL_EXT_misc_attribute
+#define GL_EXT_misc_attribute 1
+#endif
+
+#ifndef GL_SGIS_generate_mipmap
+#define GL_SGIS_generate_mipmap 1
+#endif
+
+#ifndef GL_SGIX_clipmap
+#define GL_SGIX_clipmap 1
+#endif
+
+#ifndef GL_SGIX_shadow
+#define GL_SGIX_shadow 1
+#endif
+
+#ifndef GL_SGIS_texture_edge_clamp
+#define GL_SGIS_texture_edge_clamp 1
+#endif
+
+#ifndef GL_SGIS_texture_border_clamp
+#define GL_SGIS_texture_border_clamp 1
+#endif
+
+#ifndef GL_EXT_blend_minmax
+#define GL_EXT_blend_minmax 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendEquationEXT (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDEQUATIONEXTPROC) (GLenum mode);
+#endif
+
+#ifndef GL_EXT_blend_subtract
+#define GL_EXT_blend_subtract 1
+#endif
+
+#ifndef GL_EXT_blend_logic_op
+#define GL_EXT_blend_logic_op 1
+#endif
+
+#ifndef GL_SGIX_interlace
+#define GL_SGIX_interlace 1
+#endif
+
+#ifndef GL_SGIX_pixel_tiles
+#define GL_SGIX_pixel_tiles 1
+#endif
+
+#ifndef GL_SGIX_texture_select
+#define GL_SGIX_texture_select 1
+#endif
+
+#ifndef GL_SGIX_sprite
+#define GL_SGIX_sprite 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glSpriteParameterfSGIX (GLenum, GLfloat);
+  GLAPI void APIENTRY glSpriteParameterfvSGIX (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glSpriteParameteriSGIX (GLenum, GLint);
+  GLAPI void APIENTRY glSpriteParameterivSGIX (GLenum, const GLint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSPRITEPARAMETERFSGIXPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLSPRITEPARAMETERFVSGIXPROC) (GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLSPRITEPARAMETERISGIXPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLSPRITEPARAMETERIVSGIXPROC) (GLenum pname, const GLint *params);
+#endif
+
+#ifndef GL_SGIX_texture_multi_buffer
+#define GL_SGIX_texture_multi_buffer 1
+#endif
+
+#ifndef GL_EXT_point_parameters
+#define GL_EXT_point_parameters 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPointParameterfEXT (GLenum, GLfloat);
+  GLAPI void APIENTRY glPointParameterfvEXT (GLenum, const GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFEXTPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVEXTPROC) (GLenum pname, const GLfloat *params);
+#endif
+
+#ifndef GL_SGIS_point_parameters
+#define GL_SGIS_point_parameters 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPointParameterfSGIS (GLenum, GLfloat);
+  GLAPI void APIENTRY glPointParameterfvSGIS (GLenum, const GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFSGISPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERFVSGISPROC) (GLenum pname, const GLfloat *params);
+#endif
+
+#ifndef GL_SGIX_instruments
+#define GL_SGIX_instruments 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI GLint APIENTRY glGetInstrumentsSGIX (void);
+  GLAPI void APIENTRY glInstrumentsBufferSGIX (GLsizei, GLint *);
+  GLAPI GLint APIENTRY glPollInstrumentsSGIX (GLint *);
+  GLAPI void APIENTRY glReadInstrumentsSGIX (GLint);
+  GLAPI void APIENTRY glStartInstrumentsSGIX (void);
+  GLAPI void APIENTRY glStopInstrumentsSGIX (GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef GLint (APIENTRYP PFNGLGETINSTRUMENTSSGIXPROC) (void);
+  typedef void (APIENTRYP PFNGLINSTRUMENTSBUFFERSGIXPROC) (GLsizei size, GLint *buffer);
+  typedef GLint (APIENTRYP PFNGLPOLLINSTRUMENTSSGIXPROC) (GLint *marker_p);
+  typedef void (APIENTRYP PFNGLREADINSTRUMENTSSGIXPROC) (GLint marker);
+  typedef void (APIENTRYP PFNGLSTARTINSTRUMENTSSGIXPROC) (void);
+  typedef void (APIENTRYP PFNGLSTOPINSTRUMENTSSGIXPROC) (GLint marker);
+#endif
+
+#ifndef GL_SGIX_texture_scale_bias
+#define GL_SGIX_texture_scale_bias 1
+#endif
+
+#ifndef GL_SGIX_framezoom
+#define GL_SGIX_framezoom 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glFrameZoomSGIX (GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLFRAMEZOOMSGIXPROC) (GLint factor);
+#endif
+
+#ifndef GL_SGIX_tag_sample_buffer
+#define GL_SGIX_tag_sample_buffer 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTagSampleBufferSGIX (void);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTAGSAMPLEBUFFERSGIXPROC) (void);
+#endif
+
+#ifndef GL_SGIX_polynomial_ffd
+#define GL_SGIX_polynomial_ffd 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDeformationMap3dSGIX (GLenum, GLdouble, GLdouble, GLint, GLint, GLdouble, GLdouble, GLint, GLint, GLdouble, GLdouble, GLint, GLint, const GLdouble *);
+  GLAPI void APIENTRY glDeformationMap3fSGIX (GLenum, GLfloat, GLfloat, GLint, GLint, GLfloat, GLfloat, GLint, GLint, GLfloat, GLfloat, GLint, GLint, const GLfloat *);
+  GLAPI void APIENTRY glDeformSGIX (GLbitfield);
+  GLAPI void APIENTRY glLoadIdentityDeformationMapSGIX (GLbitfield);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDEFORMATIONMAP3DSGIXPROC) (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble w1, GLdouble w2, GLint wstride, GLint worder, const GLdouble *points);
+  typedef void (APIENTRYP PFNGLDEFORMATIONMAP3FSGIXPROC) (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat w1, GLfloat w2, GLint wstride, GLint worder, const GLfloat *points);
+  typedef void (APIENTRYP PFNGLDEFORMSGIXPROC) (GLbitfield mask);
+  typedef void (APIENTRYP PFNGLLOADIDENTITYDEFORMATIONMAPSGIXPROC) (GLbitfield mask);
+#endif
+
+#ifndef GL_SGIX_reference_plane
+#define GL_SGIX_reference_plane 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glReferencePlaneSGIX (const GLdouble *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLREFERENCEPLANESGIXPROC) (const GLdouble *equation);
+#endif
+
+#ifndef GL_SGIX_flush_raster
+#define GL_SGIX_flush_raster 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glFlushRasterSGIX (void);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLFLUSHRASTERSGIXPROC) (void);
+#endif
+
+#ifndef GL_SGIX_depth_texture
+#define GL_SGIX_depth_texture 1
+#endif
+
+#ifndef GL_SGIS_fog_function
+#define GL_SGIS_fog_function 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glFogFuncSGIS (GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glGetFogFuncSGIS (GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLFOGFUNCSGISPROC) (GLsizei n, const GLfloat *points);
+  typedef void (APIENTRYP PFNGLGETFOGFUNCSGISPROC) (GLfloat *points);
+#endif
+
+#ifndef GL_SGIX_fog_offset
+#define GL_SGIX_fog_offset 1
+#endif
+
+#ifndef GL_HP_image_transform
+#define GL_HP_image_transform 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glImageTransformParameteriHP (GLenum, GLenum, GLint);
+  GLAPI void APIENTRY glImageTransformParameterfHP (GLenum, GLenum, GLfloat);
+  GLAPI void APIENTRY glImageTransformParameterivHP (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glImageTransformParameterfvHP (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glGetImageTransformParameterivHP (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetImageTransformParameterfvHP (GLenum, GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERIHPPROC) (GLenum target, GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERFHPPROC) (GLenum target, GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERIVHPPROC) (GLenum target, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLIMAGETRANSFORMPARAMETERFVHPPROC) (GLenum target, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETIMAGETRANSFORMPARAMETERIVHPPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETIMAGETRANSFORMPARAMETERFVHPPROC) (GLenum target, GLenum pname, GLfloat *params);
+#endif
+
+#ifndef GL_HP_convolution_border_modes
+#define GL_HP_convolution_border_modes 1
+#endif
+
+#ifndef GL_SGIX_texture_add_env
+#define GL_SGIX_texture_add_env 1
+#endif
+
+#ifndef GL_EXT_color_subtable
+#define GL_EXT_color_subtable 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glColorSubTableEXT (GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glCopyColorSubTableEXT (GLenum, GLsizei, GLint, GLint, GLsizei);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOLORSUBTABLEEXTPROC) (GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data);
+  typedef void (APIENTRYP PFNGLCOPYCOLORSUBTABLEEXTPROC) (GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
+#endif
+
+#ifndef GL_PGI_vertex_hints
+#define GL_PGI_vertex_hints 1
+#endif
+
+#ifndef GL_PGI_misc_hints
+#define GL_PGI_misc_hints 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glHintPGI (GLenum, GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLHINTPGIPROC) (GLenum target, GLint mode);
+#endif
+
+#ifndef GL_EXT_paletted_texture
+#define GL_EXT_paletted_texture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glColorTableEXT (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glGetColorTableEXT (GLenum, GLenum, GLenum, GLvoid *);
+  GLAPI void APIENTRY glGetColorTableParameterivEXT (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetColorTableParameterfvEXT (GLenum, GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOLORTABLEEXTPROC) (GLenum target, GLenum internalFormat, GLsizei width, GLenum format, GLenum type, const GLvoid *table);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEEXTPROC) (GLenum target, GLenum format, GLenum type, GLvoid *data);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETCOLORTABLEPARAMETERFVEXTPROC) (GLenum target, GLenum pname, GLfloat *params);
+#endif
+
+#ifndef GL_EXT_clip_volume_hint
+#define GL_EXT_clip_volume_hint 1
+#endif
+
+#ifndef GL_SGIX_list_priority
+#define GL_SGIX_list_priority 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGetListParameterfvSGIX (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetListParameterivSGIX (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glListParameterfSGIX (GLuint, GLenum, GLfloat);
+  GLAPI void APIENTRY glListParameterfvSGIX (GLuint, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glListParameteriSGIX (GLuint, GLenum, GLint);
+  GLAPI void APIENTRY glListParameterivSGIX (GLuint, GLenum, const GLint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGETLISTPARAMETERFVSGIXPROC) (GLuint list, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETLISTPARAMETERIVSGIXPROC) (GLuint list, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLLISTPARAMETERFSGIXPROC) (GLuint list, GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLLISTPARAMETERFVSGIXPROC) (GLuint list, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLLISTPARAMETERISGIXPROC) (GLuint list, GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLLISTPARAMETERIVSGIXPROC) (GLuint list, GLenum pname, const GLint *params);
+#endif
+
+#ifndef GL_SGIX_ir_instrument1
+#define GL_SGIX_ir_instrument1 1
+#endif
+
+#ifndef GL_SGIX_calligraphic_fragment
+#define GL_SGIX_calligraphic_fragment 1
+#endif
+
+#ifndef GL_SGIX_texture_lod_bias
+#define GL_SGIX_texture_lod_bias 1
+#endif
+
+#ifndef GL_SGIX_shadow_ambient
+#define GL_SGIX_shadow_ambient 1
+#endif
+
+#ifndef GL_EXT_index_texture
+#define GL_EXT_index_texture 1
+#endif
+
+#ifndef GL_EXT_index_material
+#define GL_EXT_index_material 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glIndexMaterialEXT (GLenum, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLINDEXMATERIALEXTPROC) (GLenum face, GLenum mode);
+#endif
+
+#ifndef GL_EXT_index_func
+#define GL_EXT_index_func 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glIndexFuncEXT (GLenum, GLclampf);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLINDEXFUNCEXTPROC) (GLenum func, GLclampf ref);
+#endif
+
+#ifndef GL_EXT_index_array_formats
+#define GL_EXT_index_array_formats 1
+#endif
+
+#ifndef GL_EXT_compiled_vertex_array
+#define GL_EXT_compiled_vertex_array 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glLockArraysEXT (GLint, GLsizei);
+  GLAPI void APIENTRY glUnlockArraysEXT (void);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLLOCKARRAYSEXTPROC) (GLint first, GLsizei count);
+  typedef void (APIENTRYP PFNGLUNLOCKARRAYSEXTPROC) (void);
+#endif
+
+#ifndef GL_EXT_cull_vertex
+#define GL_EXT_cull_vertex 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glCullParameterdvEXT (GLenum, GLdouble *);
+  GLAPI void APIENTRY glCullParameterfvEXT (GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCULLPARAMETERDVEXTPROC) (GLenum pname, GLdouble *params);
+  typedef void (APIENTRYP PFNGLCULLPARAMETERFVEXTPROC) (GLenum pname, GLfloat *params);
+#endif
+
+#ifndef GL_SGIX_ycrcb
+#define GL_SGIX_ycrcb 1
+#endif
+
+#ifndef GL_SGIX_fragment_lighting
+#define GL_SGIX_fragment_lighting 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glFragmentColorMaterialSGIX (GLenum, GLenum);
+  GLAPI void APIENTRY glFragmentLightfSGIX (GLenum, GLenum, GLfloat);
+  GLAPI void APIENTRY glFragmentLightfvSGIX (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glFragmentLightiSGIX (GLenum, GLenum, GLint);
+  GLAPI void APIENTRY glFragmentLightivSGIX (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glFragmentLightModelfSGIX (GLenum, GLfloat);
+  GLAPI void APIENTRY glFragmentLightModelfvSGIX (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glFragmentLightModeliSGIX (GLenum, GLint);
+  GLAPI void APIENTRY glFragmentLightModelivSGIX (GLenum, const GLint *);
+  GLAPI void APIENTRY glFragmentMaterialfSGIX (GLenum, GLenum, GLfloat);
+  GLAPI void APIENTRY glFragmentMaterialfvSGIX (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glFragmentMaterialiSGIX (GLenum, GLenum, GLint);
+  GLAPI void APIENTRY glFragmentMaterialivSGIX (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glGetFragmentLightfvSGIX (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetFragmentLightivSGIX (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetFragmentMaterialfvSGIX (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetFragmentMaterialivSGIX (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glLightEnviSGIX (GLenum, GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLFRAGMENTCOLORMATERIALSGIXPROC) (GLenum face, GLenum mode);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTFSGIXPROC) (GLenum light, GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTFVSGIXPROC) (GLenum light, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTISGIXPROC) (GLenum light, GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTIVSGIXPROC) (GLenum light, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELFSGIXPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELFVSGIXPROC) (GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELISGIXPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLFRAGMENTLIGHTMODELIVSGIXPROC) (GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALFSGIXPROC) (GLenum face, GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALFVSGIXPROC) (GLenum face, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALISGIXPROC) (GLenum face, GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLFRAGMENTMATERIALIVSGIXPROC) (GLenum face, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLGETFRAGMENTLIGHTFVSGIXPROC) (GLenum light, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETFRAGMENTLIGHTIVSGIXPROC) (GLenum light, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETFRAGMENTMATERIALFVSGIXPROC) (GLenum face, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETFRAGMENTMATERIALIVSGIXPROC) (GLenum face, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLLIGHTENVISGIXPROC) (GLenum pname, GLint param);
+#endif
+
+#ifndef GL_IBM_rasterpos_clip
+#define GL_IBM_rasterpos_clip 1
+#endif
+
+#ifndef GL_HP_texture_lighting
+#define GL_HP_texture_lighting 1
+#endif
+
+#ifndef GL_EXT_draw_range_elements
+#define GL_EXT_draw_range_elements 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDrawRangeElementsEXT (GLenum, GLuint, GLuint, GLsizei, GLenum, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTSEXTPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices);
+#endif
+
+#ifndef GL_WIN_phong_shading
+#define GL_WIN_phong_shading 1
+#endif
+
+#ifndef GL_WIN_specular_fog
+#define GL_WIN_specular_fog 1
+#endif
+
+#ifndef GL_EXT_light_texture
+#define GL_EXT_light_texture 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glApplyTextureEXT (GLenum);
+  GLAPI void APIENTRY glTextureLightEXT (GLenum);
+  GLAPI void APIENTRY glTextureMaterialEXT (GLenum, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLAPPLYTEXTUREEXTPROC) (GLenum mode);
+  typedef void (APIENTRYP PFNGLTEXTURELIGHTEXTPROC) (GLenum pname);
+  typedef void (APIENTRYP PFNGLTEXTUREMATERIALEXTPROC) (GLenum face, GLenum mode);
+#endif
+
+#ifndef GL_SGIX_blend_alpha_minmax
+#define GL_SGIX_blend_alpha_minmax 1
+#endif
+
+#ifndef GL_EXT_bgra
+#define GL_EXT_bgra 1
+#endif
+
+#ifndef GL_SGIX_async
+#define GL_SGIX_async 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glAsyncMarkerSGIX (GLuint);
+  GLAPI GLint APIENTRY glFinishAsyncSGIX (GLuint *);
+  GLAPI GLint APIENTRY glPollAsyncSGIX (GLuint *);
+  GLAPI GLuint APIENTRY glGenAsyncMarkersSGIX (GLsizei);
+  GLAPI void APIENTRY glDeleteAsyncMarkersSGIX (GLuint, GLsizei);
+  GLAPI GLboolean APIENTRY glIsAsyncMarkerSGIX (GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLASYNCMARKERSGIXPROC) (GLuint marker);
+  typedef GLint (APIENTRYP PFNGLFINISHASYNCSGIXPROC) (GLuint *markerp);
+  typedef GLint (APIENTRYP PFNGLPOLLASYNCSGIXPROC) (GLuint *markerp);
+  typedef GLuint (APIENTRYP PFNGLGENASYNCMARKERSSGIXPROC) (GLsizei range);
+  typedef void (APIENTRYP PFNGLDELETEASYNCMARKERSSGIXPROC) (GLuint marker, GLsizei range);
+  typedef GLboolean (APIENTRYP PFNGLISASYNCMARKERSGIXPROC) (GLuint marker);
+#endif
+
+#ifndef GL_SGIX_async_pixel
+#define GL_SGIX_async_pixel 1
+#endif
+
+#ifndef GL_SGIX_async_histogram
+#define GL_SGIX_async_histogram 1
+#endif
+
+#ifndef GL_INTEL_parallel_arrays
+#define GL_INTEL_parallel_arrays 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glVertexPointervINTEL (GLint, GLenum, const GLvoid* *);
+  GLAPI void APIENTRY glNormalPointervINTEL (GLenum, const GLvoid* *);
+  GLAPI void APIENTRY glColorPointervINTEL (GLint, GLenum, const GLvoid* *);
+  GLAPI void APIENTRY glTexCoordPointervINTEL (GLint, GLenum, const GLvoid* *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLVERTEXPOINTERVINTELPROC) (GLint size, GLenum type, const GLvoid* *pointer);
+  typedef void (APIENTRYP PFNGLNORMALPOINTERVINTELPROC) (GLenum type, const GLvoid* *pointer);
+  typedef void (APIENTRYP PFNGLCOLORPOINTERVINTELPROC) (GLint size, GLenum type, const GLvoid* *pointer);
+  typedef void (APIENTRYP PFNGLTEXCOORDPOINTERVINTELPROC) (GLint size, GLenum type, const GLvoid* *pointer);
+#endif
+
+#ifndef GL_HP_occlusion_test
+#define GL_HP_occlusion_test 1
+#endif
+
+#ifndef GL_EXT_pixel_transform
+#define GL_EXT_pixel_transform 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPixelTransformParameteriEXT (GLenum, GLenum, GLint);
+  GLAPI void APIENTRY glPixelTransformParameterfEXT (GLenum, GLenum, GLfloat);
+  GLAPI void APIENTRY glPixelTransformParameterivEXT (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glPixelTransformParameterfvEXT (GLenum, GLenum, const GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERIEXTPROC) (GLenum target, GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERFEXTPROC) (GLenum target, GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERIVEXTPROC) (GLenum target, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLPIXELTRANSFORMPARAMETERFVEXTPROC) (GLenum target, GLenum pname, const GLfloat *params);
+#endif
+
+#ifndef GL_EXT_pixel_transform_color_table
+#define GL_EXT_pixel_transform_color_table 1
+#endif
+
+#ifndef GL_EXT_shared_texture_palette
+#define GL_EXT_shared_texture_palette 1
+#endif
+
+#ifndef GL_EXT_separate_specular_color
+#define GL_EXT_separate_specular_color 1
+#endif
+
+#ifndef GL_EXT_secondary_color
+#define GL_EXT_secondary_color 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glSecondaryColor3bEXT (GLbyte, GLbyte, GLbyte);
+  GLAPI void APIENTRY glSecondaryColor3bvEXT (const GLbyte *);
+  GLAPI void APIENTRY glSecondaryColor3dEXT (GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glSecondaryColor3dvEXT (const GLdouble *);
+  GLAPI void APIENTRY glSecondaryColor3fEXT (GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glSecondaryColor3fvEXT (const GLfloat *);
+  GLAPI void APIENTRY glSecondaryColor3iEXT (GLint, GLint, GLint);
+  GLAPI void APIENTRY glSecondaryColor3ivEXT (const GLint *);
+  GLAPI void APIENTRY glSecondaryColor3sEXT (GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glSecondaryColor3svEXT (const GLshort *);
+  GLAPI void APIENTRY glSecondaryColor3ubEXT (GLubyte, GLubyte, GLubyte);
+  GLAPI void APIENTRY glSecondaryColor3ubvEXT (const GLubyte *);
+  GLAPI void APIENTRY glSecondaryColor3uiEXT (GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glSecondaryColor3uivEXT (const GLuint *);
+  GLAPI void APIENTRY glSecondaryColor3usEXT (GLushort, GLushort, GLushort);
+  GLAPI void APIENTRY glSecondaryColor3usvEXT (const GLushort *);
+  GLAPI void APIENTRY glSecondaryColorPointerEXT (GLint, GLenum, GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BEXTPROC) (GLbyte red, GLbyte green, GLbyte blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3BVEXTPROC) (const GLbyte *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DEXTPROC) (GLdouble red, GLdouble green, GLdouble blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3DVEXTPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FEXTPROC) (GLfloat red, GLfloat green, GLfloat blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3FVEXTPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IEXTPROC) (GLint red, GLint green, GLint blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3IVEXTPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SEXTPROC) (GLshort red, GLshort green, GLshort blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3SVEXTPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBEXTPROC) (GLubyte red, GLubyte green, GLubyte blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UBVEXTPROC) (const GLubyte *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIEXTPROC) (GLuint red, GLuint green, GLuint blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3UIVEXTPROC) (const GLuint *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USEXTPROC) (GLushort red, GLushort green, GLushort blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3USVEXTPROC) (const GLushort *v);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLORPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
+#endif
+
+#ifndef GL_EXT_texture_perturb_normal
+#define GL_EXT_texture_perturb_normal 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTextureNormalEXT (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTEXTURENORMALEXTPROC) (GLenum mode);
+#endif
+
+#ifndef GL_EXT_multi_draw_arrays
+#define GL_EXT_multi_draw_arrays 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glMultiDrawArraysEXT (GLenum, GLint *, GLsizei *, GLsizei);
+  GLAPI void APIENTRY glMultiDrawElementsEXT (GLenum, const GLsizei *, GLenum, const GLvoid* *, GLsizei);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLMULTIDRAWARRAYSEXTPROC) (GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
+  typedef void (APIENTRYP PFNGLMULTIDRAWELEMENTSEXTPROC) (GLenum mode, const GLsizei *count, GLenum type, const GLvoid* *indices, GLsizei primcount);
+#endif
+
+#ifndef GL_EXT_fog_coord
+#define GL_EXT_fog_coord 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glFogCoordfEXT (GLfloat);
+  GLAPI void APIENTRY glFogCoordfvEXT (const GLfloat *);
+  GLAPI void APIENTRY glFogCoorddEXT (GLdouble);
+  GLAPI void APIENTRY glFogCoorddvEXT (const GLdouble *);
+  GLAPI void APIENTRY glFogCoordPointerEXT (GLenum, GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLFOGCOORDFEXTPROC) (GLfloat coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDFVEXTPROC) (const GLfloat *coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDDEXTPROC) (GLdouble coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDDVEXTPROC) (const GLdouble *coord);
+  typedef void (APIENTRYP PFNGLFOGCOORDPOINTEREXTPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
+#endif
+
+#ifndef GL_REND_screen_coordinates
+#define GL_REND_screen_coordinates 1
+#endif
+
+#ifndef GL_EXT_coordinate_frame
+#define GL_EXT_coordinate_frame 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTangent3bEXT (GLbyte, GLbyte, GLbyte);
+  GLAPI void APIENTRY glTangent3bvEXT (const GLbyte *);
+  GLAPI void APIENTRY glTangent3dEXT (GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glTangent3dvEXT (const GLdouble *);
+  GLAPI void APIENTRY glTangent3fEXT (GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTangent3fvEXT (const GLfloat *);
+  GLAPI void APIENTRY glTangent3iEXT (GLint, GLint, GLint);
+  GLAPI void APIENTRY glTangent3ivEXT (const GLint *);
+  GLAPI void APIENTRY glTangent3sEXT (GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glTangent3svEXT (const GLshort *);
+  GLAPI void APIENTRY glBinormal3bEXT (GLbyte, GLbyte, GLbyte);
+  GLAPI void APIENTRY glBinormal3bvEXT (const GLbyte *);
+  GLAPI void APIENTRY glBinormal3dEXT (GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glBinormal3dvEXT (const GLdouble *);
+  GLAPI void APIENTRY glBinormal3fEXT (GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glBinormal3fvEXT (const GLfloat *);
+  GLAPI void APIENTRY glBinormal3iEXT (GLint, GLint, GLint);
+  GLAPI void APIENTRY glBinormal3ivEXT (const GLint *);
+  GLAPI void APIENTRY glBinormal3sEXT (GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glBinormal3svEXT (const GLshort *);
+  GLAPI void APIENTRY glTangentPointerEXT (GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glBinormalPointerEXT (GLenum, GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTANGENT3BEXTPROC) (GLbyte tx, GLbyte ty, GLbyte tz);
+  typedef void (APIENTRYP PFNGLTANGENT3BVEXTPROC) (const GLbyte *v);
+  typedef void (APIENTRYP PFNGLTANGENT3DEXTPROC) (GLdouble tx, GLdouble ty, GLdouble tz);
+  typedef void (APIENTRYP PFNGLTANGENT3DVEXTPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLTANGENT3FEXTPROC) (GLfloat tx, GLfloat ty, GLfloat tz);
+  typedef void (APIENTRYP PFNGLTANGENT3FVEXTPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTANGENT3IEXTPROC) (GLint tx, GLint ty, GLint tz);
+  typedef void (APIENTRYP PFNGLTANGENT3IVEXTPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLTANGENT3SEXTPROC) (GLshort tx, GLshort ty, GLshort tz);
+  typedef void (APIENTRYP PFNGLTANGENT3SVEXTPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLBINORMAL3BEXTPROC) (GLbyte bx, GLbyte by, GLbyte bz);
+  typedef void (APIENTRYP PFNGLBINORMAL3BVEXTPROC) (const GLbyte *v);
+  typedef void (APIENTRYP PFNGLBINORMAL3DEXTPROC) (GLdouble bx, GLdouble by, GLdouble bz);
+  typedef void (APIENTRYP PFNGLBINORMAL3DVEXTPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLBINORMAL3FEXTPROC) (GLfloat bx, GLfloat by, GLfloat bz);
+  typedef void (APIENTRYP PFNGLBINORMAL3FVEXTPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLBINORMAL3IEXTPROC) (GLint bx, GLint by, GLint bz);
+  typedef void (APIENTRYP PFNGLBINORMAL3IVEXTPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLBINORMAL3SEXTPROC) (GLshort bx, GLshort by, GLshort bz);
+  typedef void (APIENTRYP PFNGLBINORMAL3SVEXTPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLTANGENTPOINTEREXTPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLBINORMALPOINTEREXTPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
+#endif
+
+#ifndef GL_EXT_texture_env_combine
+#define GL_EXT_texture_env_combine 1
+#endif
+
+#ifndef GL_APPLE_specular_vector
+#define GL_APPLE_specular_vector 1
+#endif
+
+#ifndef GL_APPLE_transform_hint
+#define GL_APPLE_transform_hint 1
+#endif
+
+#ifndef GL_SGIX_fog_scale
+#define GL_SGIX_fog_scale 1
+#endif
+
+#ifndef GL_SUNX_constant_data
+#define GL_SUNX_constant_data 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glFinishTextureSUNX (void);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLFINISHTEXTURESUNXPROC) (void);
+#endif
+
+#ifndef GL_SUN_global_alpha
+#define GL_SUN_global_alpha 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGlobalAlphaFactorbSUN (GLbyte);
+  GLAPI void APIENTRY glGlobalAlphaFactorsSUN (GLshort);
+  GLAPI void APIENTRY glGlobalAlphaFactoriSUN (GLint);
+  GLAPI void APIENTRY glGlobalAlphaFactorfSUN (GLfloat);
+  GLAPI void APIENTRY glGlobalAlphaFactordSUN (GLdouble);
+  GLAPI void APIENTRY glGlobalAlphaFactorubSUN (GLubyte);
+  GLAPI void APIENTRY glGlobalAlphaFactorusSUN (GLushort);
+  GLAPI void APIENTRY glGlobalAlphaFactoruiSUN (GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORBSUNPROC) (GLbyte factor);
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORSSUNPROC) (GLshort factor);
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORISUNPROC) (GLint factor);
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORFSUNPROC) (GLfloat factor);
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORDSUNPROC) (GLdouble factor);
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORUBSUNPROC) (GLubyte factor);
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORUSSUNPROC) (GLushort factor);
+  typedef void (APIENTRYP PFNGLGLOBALALPHAFACTORUISUNPROC) (GLuint factor);
+#endif
+
+#ifndef GL_SUN_triangle_list
+#define GL_SUN_triangle_list 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glReplacementCodeuiSUN (GLuint);
+  GLAPI void APIENTRY glReplacementCodeusSUN (GLushort);
+  GLAPI void APIENTRY glReplacementCodeubSUN (GLubyte);
+  GLAPI void APIENTRY glReplacementCodeuivSUN (const GLuint *);
+  GLAPI void APIENTRY glReplacementCodeusvSUN (const GLushort *);
+  GLAPI void APIENTRY glReplacementCodeubvSUN (const GLubyte *);
+  GLAPI void APIENTRY glReplacementCodePointerSUN (GLenum, GLsizei, const GLvoid* *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUISUNPROC) (GLuint code);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUSSUNPROC) (GLushort code);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUBSUNPROC) (GLubyte code);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUIVSUNPROC) (const GLuint *code);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUSVSUNPROC) (const GLushort *code);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUBVSUNPROC) (const GLubyte *code);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEPOINTERSUNPROC) (GLenum type, GLsizei stride, const GLvoid* *pointer);
+#endif
+
+#ifndef GL_SUN_vertex
+#define GL_SUN_vertex 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glColor4ubVertex2fSUN (GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat);
+  GLAPI void APIENTRY glColor4ubVertex2fvSUN (const GLubyte *, const GLfloat *);
+  GLAPI void APIENTRY glColor4ubVertex3fSUN (GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glColor4ubVertex3fvSUN (const GLubyte *, const GLfloat *);
+  GLAPI void APIENTRY glColor3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glColor3fVertex3fvSUN (const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glColor4fNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glColor4fNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glTexCoord2fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTexCoord2fVertex3fvSUN (const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glTexCoord4fVertex4fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTexCoord4fVertex4fvSUN (const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glTexCoord2fColor4ubVertex3fSUN (GLfloat, GLfloat, GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTexCoord2fColor4ubVertex3fvSUN (const GLfloat *, const GLubyte *, const GLfloat *);
+  GLAPI void APIENTRY glTexCoord2fColor3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTexCoord2fColor3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glTexCoord2fNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTexCoord2fNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glTexCoord2fColor4fNormal3fVertex3fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTexCoord2fColor4fNormal3fVertex3fvSUN (const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glTexCoord4fColor4fNormal3fVertex4fSUN (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glTexCoord4fColor4fNormal3fVertex4fvSUN (const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiVertex3fvSUN (const GLuint *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiColor4ubVertex3fSUN (GLuint, GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiColor4ubVertex3fvSUN (const GLuint *, const GLubyte *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiColor3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiColor3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiColor4fNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiColor4fNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *, const GLfloat *);
+  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN (GLuint, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN (const GLuint *, const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX2FSUNPROC) (GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX2FVSUNPROC) (const GLubyte *c, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX3FSUNPROC) (GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLCOLOR4UBVERTEX3FVSUNPROC) (const GLubyte *c, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLCOLOR3FVERTEX3FSUNPROC) (GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLCOLOR3FVERTEX3FVSUNPROC) (const GLfloat *c, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLNORMAL3FVERTEX3FSUNPROC) (GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLCOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLCOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *c, const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD4FVERTEX4FSUNPROC) (GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLTEXCOORD4FVERTEX4FVSUNPROC) (const GLfloat *tc, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4UBVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4UBVERTEX3FVSUNPROC) (const GLfloat *tc, const GLubyte *c, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR3FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR3FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *c, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FNORMAL3FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FSUNPROC) (GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FVSUNPROC) (const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUIVERTEX3FSUNPROC) (GLuint rc, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUIVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FSUNPROC) (GLuint rc, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FVSUNPROC) (const GLuint *rc, const GLubyte *c, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FSUNPROC) (GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *c, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FSUNPROC) (GLuint rc, GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *tc, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *tc, const GLfloat *n, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC) (GLuint rc, GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC) (const GLuint *rc, const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v);
+#endif
+
+#ifndef GL_EXT_blend_func_separate
+#define GL_EXT_blend_func_separate 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendFuncSeparateEXT (GLenum, GLenum, GLenum, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDFUNCSEPARATEEXTPROC) (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
+#endif
+
+#ifndef GL_INGR_blend_func_separate
+#define GL_INGR_blend_func_separate 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendFuncSeparateINGR (GLenum, GLenum, GLenum, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDFUNCSEPARATEINGRPROC) (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
+#endif
+
+#ifndef GL_INGR_color_clamp
+#define GL_INGR_color_clamp 1
+#endif
+
+#ifndef GL_INGR_interlace_read
+#define GL_INGR_interlace_read 1
+#endif
+
+#ifndef GL_EXT_stencil_wrap
+#define GL_EXT_stencil_wrap 1
+#endif
+
+#ifndef GL_EXT_422_pixels
+#define GL_EXT_422_pixels 1
+#endif
+
+#ifndef GL_NV_texgen_reflection
+#define GL_NV_texgen_reflection 1
+#endif
+
+#ifndef GL_SUN_convolution_border_modes
+#define GL_SUN_convolution_border_modes 1
+#endif
+
+#ifndef GL_EXT_texture_env_add
+#define GL_EXT_texture_env_add 1
+#endif
+
+#ifndef GL_EXT_texture_lod_bias
+#define GL_EXT_texture_lod_bias 1
+#endif
+
+#ifndef GL_EXT_texture_filter_anisotropic
+#define GL_EXT_texture_filter_anisotropic 1
+#endif
+
+#ifndef GL_EXT_vertex_weighting
+#define GL_EXT_vertex_weighting 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glVertexWeightfEXT (GLfloat);
+  GLAPI void APIENTRY glVertexWeightfvEXT (const GLfloat *);
+  GLAPI void APIENTRY glVertexWeightPointerEXT (GLsizei, GLenum, GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLVERTEXWEIGHTFEXTPROC) (GLfloat weight);
+  typedef void (APIENTRYP PFNGLVERTEXWEIGHTFVEXTPROC) (const GLfloat *weight);
+  typedef void (APIENTRYP PFNGLVERTEXWEIGHTPOINTEREXTPROC) (GLsizei size, GLenum type, GLsizei stride, const GLvoid *pointer);
+#endif
+
+#ifndef GL_NV_light_max_exponent
+#define GL_NV_light_max_exponent 1
+#endif
+
+#ifndef GL_NV_vertex_array_range
+#define GL_NV_vertex_array_range 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glFlushVertexArrayRangeNV (void);
+  GLAPI void APIENTRY glVertexArrayRangeNV (GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLFLUSHVERTEXARRAYRANGENVPROC) (void);
+  typedef void (APIENTRYP PFNGLVERTEXARRAYRANGENVPROC) (GLsizei length, const GLvoid *pointer);
+#endif
+
+#ifndef GL_NV_register_combiners
+#define GL_NV_register_combiners 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glCombinerParameterfvNV (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glCombinerParameterfNV (GLenum, GLfloat);
+  GLAPI void APIENTRY glCombinerParameterivNV (GLenum, const GLint *);
+  GLAPI void APIENTRY glCombinerParameteriNV (GLenum, GLint);
+  GLAPI void APIENTRY glCombinerInputNV (GLenum, GLenum, GLenum, GLenum, GLenum, GLenum);
+  GLAPI void APIENTRY glCombinerOutputNV (GLenum, GLenum, GLenum, GLenum, GLenum, GLenum, GLenum, GLboolean, GLboolean, GLboolean);
+  GLAPI void APIENTRY glFinalCombinerInputNV (GLenum, GLenum, GLenum, GLenum);
+  GLAPI void APIENTRY glGetCombinerInputParameterfvNV (GLenum, GLenum, GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetCombinerInputParameterivNV (GLenum, GLenum, GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetCombinerOutputParameterfvNV (GLenum, GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetCombinerOutputParameterivNV (GLenum, GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetFinalCombinerInputParameterfvNV (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetFinalCombinerInputParameterivNV (GLenum, GLenum, GLint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERFVNVPROC) (GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERFNVPROC) (GLenum pname, GLfloat param);
+  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERIVNVPROC) (GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLCOMBINERPARAMETERINVPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLCOMBINERINPUTNVPROC) (GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
+  typedef void (APIENTRYP PFNGLCOMBINEROUTPUTNVPROC) (GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum);
+  typedef void (APIENTRYP PFNGLFINALCOMBINERINPUTNVPROC) (GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
+  typedef void (APIENTRYP PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC) (GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC) (GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC) (GLenum stage, GLenum portion, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC) (GLenum stage, GLenum portion, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC) (GLenum variable, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC) (GLenum variable, GLenum pname, GLint *params);
+#endif
+
+#ifndef GL_NV_fog_distance
+#define GL_NV_fog_distance 1
+#endif
+
+#ifndef GL_NV_texgen_emboss
+#define GL_NV_texgen_emboss 1
+#endif
+
+#ifndef GL_NV_blend_square
+#define GL_NV_blend_square 1
+#endif
+
+#ifndef GL_NV_texture_env_combine4
+#define GL_NV_texture_env_combine4 1
+#endif
+
+#ifndef GL_MESA_resize_buffers
+#define GL_MESA_resize_buffers 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glResizeBuffersMESA (void);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLRESIZEBUFFERSMESAPROC) (void);
+#endif
+
+#ifndef GL_MESA_window_pos
+#define GL_MESA_window_pos 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glWindowPos2dMESA (GLdouble, GLdouble);
+  GLAPI void APIENTRY glWindowPos2dvMESA (const GLdouble *);
+  GLAPI void APIENTRY glWindowPos2fMESA (GLfloat, GLfloat);
+  GLAPI void APIENTRY glWindowPos2fvMESA (const GLfloat *);
+  GLAPI void APIENTRY glWindowPos2iMESA (GLint, GLint);
+  GLAPI void APIENTRY glWindowPos2ivMESA (const GLint *);
+  GLAPI void APIENTRY glWindowPos2sMESA (GLshort, GLshort);
+  GLAPI void APIENTRY glWindowPos2svMESA (const GLshort *);
+  GLAPI void APIENTRY glWindowPos3dMESA (GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glWindowPos3dvMESA (const GLdouble *);
+  GLAPI void APIENTRY glWindowPos3fMESA (GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glWindowPos3fvMESA (const GLfloat *);
+  GLAPI void APIENTRY glWindowPos3iMESA (GLint, GLint, GLint);
+  GLAPI void APIENTRY glWindowPos3ivMESA (const GLint *);
+  GLAPI void APIENTRY glWindowPos3sMESA (GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glWindowPos3svMESA (const GLshort *);
+  GLAPI void APIENTRY glWindowPos4dMESA (GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glWindowPos4dvMESA (const GLdouble *);
+  GLAPI void APIENTRY glWindowPos4fMESA (GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glWindowPos4fvMESA (const GLfloat *);
+  GLAPI void APIENTRY glWindowPos4iMESA (GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glWindowPos4ivMESA (const GLint *);
+  GLAPI void APIENTRY glWindowPos4sMESA (GLshort, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glWindowPos4svMESA (const GLshort *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLWINDOWPOS2DMESAPROC) (GLdouble x, GLdouble y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2DVMESAPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2FMESAPROC) (GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2FVMESAPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2IMESAPROC) (GLint x, GLint y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2IVMESAPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2SMESAPROC) (GLshort x, GLshort y);
+  typedef void (APIENTRYP PFNGLWINDOWPOS2SVMESAPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3DMESAPROC) (GLdouble x, GLdouble y, GLdouble z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3DVMESAPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3FMESAPROC) (GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3FVMESAPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3IMESAPROC) (GLint x, GLint y, GLint z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3IVMESAPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3SMESAPROC) (GLshort x, GLshort y, GLshort z);
+  typedef void (APIENTRYP PFNGLWINDOWPOS3SVMESAPROC) (const GLshort *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4DMESAPROC) (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4DVMESAPROC) (const GLdouble *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4FMESAPROC) (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4FVMESAPROC) (const GLfloat *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4IMESAPROC) (GLint x, GLint y, GLint z, GLint w);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4IVMESAPROC) (const GLint *v);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4SMESAPROC) (GLshort x, GLshort y, GLshort z, GLshort w);
+  typedef void (APIENTRYP PFNGLWINDOWPOS4SVMESAPROC) (const GLshort *v);
+#endif
+
+#ifndef GL_EXT_texture_compression_s3tc
+#define GL_EXT_texture_compression_s3tc 1
+#endif
+
+#ifndef GL_IBM_cull_vertex
+#define GL_IBM_cull_vertex 1
+#endif
+
+#ifndef GL_IBM_multimode_draw_arrays
+#define GL_IBM_multimode_draw_arrays 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glMultiModeDrawArraysIBM (const GLenum *, const GLint *, const GLsizei *, GLsizei, GLint);
+  GLAPI void APIENTRY glMultiModeDrawElementsIBM (const GLenum *, const GLsizei *, GLenum, const GLvoid* const *, GLsizei, GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLMULTIMODEDRAWARRAYSIBMPROC) (const GLenum *mode, const GLint *first, const GLsizei *count, GLsizei primcount, GLint modestride);
+  typedef void (APIENTRYP PFNGLMULTIMODEDRAWELEMENTSIBMPROC) (const GLenum *mode, const GLsizei *count, GLenum type, const GLvoid* const *indices, GLsizei primcount, GLint modestride);
+#endif
+
+#ifndef GL_IBM_vertex_array_lists
+#define GL_IBM_vertex_array_lists 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glColorPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
+  GLAPI void APIENTRY glSecondaryColorPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
+  GLAPI void APIENTRY glEdgeFlagPointerListIBM (GLint, const GLboolean* *, GLint);
+  GLAPI void APIENTRY glFogCoordPointerListIBM (GLenum, GLint, const GLvoid* *, GLint);
+  GLAPI void APIENTRY glIndexPointerListIBM (GLenum, GLint, const GLvoid* *, GLint);
+  GLAPI void APIENTRY glNormalPointerListIBM (GLenum, GLint, const GLvoid* *, GLint);
+  GLAPI void APIENTRY glTexCoordPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
+  GLAPI void APIENTRY glVertexPointerListIBM (GLint, GLenum, GLint, const GLvoid* *, GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOLORPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLORPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
+  typedef void (APIENTRYP PFNGLEDGEFLAGPOINTERLISTIBMPROC) (GLint stride, const GLboolean* *pointer, GLint ptrstride);
+  typedef void (APIENTRYP PFNGLFOGCOORDPOINTERLISTIBMPROC) (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
+  typedef void (APIENTRYP PFNGLINDEXPOINTERLISTIBMPROC) (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
+  typedef void (APIENTRYP PFNGLNORMALPOINTERLISTIBMPROC) (GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
+  typedef void (APIENTRYP PFNGLTEXCOORDPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
+  typedef void (APIENTRYP PFNGLVERTEXPOINTERLISTIBMPROC) (GLint size, GLenum type, GLint stride, const GLvoid* *pointer, GLint ptrstride);
+#endif
+
+#ifndef GL_SGIX_subsample
+#define GL_SGIX_subsample 1
+#endif
+
+#ifndef GL_SGIX_ycrcba
+#define GL_SGIX_ycrcba 1
+#endif
+
+#ifndef GL_SGIX_ycrcb_subsample
+#define GL_SGIX_ycrcb_subsample 1
+#endif
+
+#ifndef GL_SGIX_depth_pass_instrument
+#define GL_SGIX_depth_pass_instrument 1
+#endif
+
+#ifndef GL_3DFX_texture_compression_FXT1
+#define GL_3DFX_texture_compression_FXT1 1
+#endif
+
+#ifndef GL_3DFX_multisample
+#define GL_3DFX_multisample 1
+#endif
+
+#ifndef GL_3DFX_tbuffer
+#define GL_3DFX_tbuffer 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTbufferMask3DFX (GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTBUFFERMASK3DFXPROC) (GLuint mask);
+#endif
+
+#ifndef GL_EXT_multisample
+#define GL_EXT_multisample 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glSampleMaskEXT (GLclampf, GLboolean);
+  GLAPI void APIENTRY glSamplePatternEXT (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSAMPLEMASKEXTPROC) (GLclampf value, GLboolean invert);
+  typedef void (APIENTRYP PFNGLSAMPLEPATTERNEXTPROC) (GLenum pattern);
+#endif
+
+#ifndef GL_SGIX_vertex_preclip
+#define GL_SGIX_vertex_preclip 1
+#endif
+
+#ifndef GL_SGIX_convolution_accuracy
+#define GL_SGIX_convolution_accuracy 1
+#endif
+
+#ifndef GL_SGIX_resample
+#define GL_SGIX_resample 1
+#endif
+
+#ifndef GL_SGIS_point_line_texgen
+#define GL_SGIS_point_line_texgen 1
+#endif
+
+#ifndef GL_SGIS_texture_color_mask
+#define GL_SGIS_texture_color_mask 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTextureColorMaskSGIS (GLboolean, GLboolean, GLboolean, GLboolean);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTEXTURECOLORMASKSGISPROC) (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
+#endif
+
+#ifndef GL_SGIX_igloo_interface
+#define GL_SGIX_igloo_interface 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glIglooInterfaceSGIX (GLenum, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLIGLOOINTERFACESGIXPROC) (GLenum pname, const GLvoid *params);
+#endif
+
+#ifndef GL_EXT_texture_env_dot3
+#define GL_EXT_texture_env_dot3 1
+#endif
+
+#ifndef GL_ATI_texture_mirror_once
+#define GL_ATI_texture_mirror_once 1
+#endif
+
+#ifndef GL_NV_fence
+#define GL_NV_fence 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDeleteFencesNV (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenFencesNV (GLsizei, GLuint *);
+  GLAPI GLboolean APIENTRY glIsFenceNV (GLuint);
+  GLAPI GLboolean APIENTRY glTestFenceNV (GLuint);
+  GLAPI void APIENTRY glGetFenceivNV (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glFinishFenceNV (GLuint);
+  GLAPI void APIENTRY glSetFenceNV (GLuint, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDELETEFENCESNVPROC) (GLsizei n, const GLuint *fences);
+  typedef void (APIENTRYP PFNGLGENFENCESNVPROC) (GLsizei n, GLuint *fences);
+  typedef GLboolean (APIENTRYP PFNGLISFENCENVPROC) (GLuint fence);
+  typedef GLboolean (APIENTRYP PFNGLTESTFENCENVPROC) (GLuint fence);
+  typedef void (APIENTRYP PFNGLGETFENCEIVNVPROC) (GLuint fence, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLFINISHFENCENVPROC) (GLuint fence);
+  typedef void (APIENTRYP PFNGLSETFENCENVPROC) (GLuint fence, GLenum condition);
+#endif
+
+#ifndef GL_NV_evaluators
+#define GL_NV_evaluators 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glMapControlPointsNV (GLenum, GLuint, GLenum, GLsizei, GLsizei, GLint, GLint, GLboolean, const GLvoid *);
+  GLAPI void APIENTRY glMapParameterivNV (GLenum, GLenum, const GLint *);
+  GLAPI void APIENTRY glMapParameterfvNV (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glGetMapControlPointsNV (GLenum, GLuint, GLenum, GLsizei, GLsizei, GLboolean, GLvoid *);
+  GLAPI void APIENTRY glGetMapParameterivNV (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGetMapParameterfvNV (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetMapAttribParameterivNV (GLenum, GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetMapAttribParameterfvNV (GLenum, GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glEvalMapsNV (GLenum, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLMAPCONTROLPOINTSNVPROC) (GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLint uorder, GLint vorder, GLboolean packed, const GLvoid *points);
+  typedef void (APIENTRYP PFNGLMAPPARAMETERIVNVPROC) (GLenum target, GLenum pname, const GLint *params);
+  typedef void (APIENTRYP PFNGLMAPPARAMETERFVNVPROC) (GLenum target, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETMAPCONTROLPOINTSNVPROC) (GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLboolean packed, GLvoid *points);
+  typedef void (APIENTRYP PFNGLGETMAPPARAMETERIVNVPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETMAPPARAMETERFVNVPROC) (GLenum target, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETMAPATTRIBPARAMETERIVNVPROC) (GLenum target, GLuint index, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETMAPATTRIBPARAMETERFVNVPROC) (GLenum target, GLuint index, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLEVALMAPSNVPROC) (GLenum target, GLenum mode);
+#endif
+
+#ifndef GL_NV_packed_depth_stencil
+#define GL_NV_packed_depth_stencil 1
+#endif
+
+#ifndef GL_NV_register_combiners2
+#define GL_NV_register_combiners2 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glCombinerStageParameterfvNV (GLenum, GLenum, const GLfloat *);
+  GLAPI void APIENTRY glGetCombinerStageParameterfvNV (GLenum, GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLCOMBINERSTAGEPARAMETERFVNVPROC) (GLenum stage, GLenum pname, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETCOMBINERSTAGEPARAMETERFVNVPROC) (GLenum stage, GLenum pname, GLfloat *params);
+#endif
+
+#ifndef GL_NV_texture_compression_vtc
+#define GL_NV_texture_compression_vtc 1
+#endif
+
+#ifndef GL_NV_texture_rectangle
+#define GL_NV_texture_rectangle 1
+#endif
+
+#ifndef GL_NV_texture_shader
+#define GL_NV_texture_shader 1
+#endif
+
+#ifndef GL_NV_texture_shader2
+#define GL_NV_texture_shader2 1
+#endif
+
+#ifndef GL_NV_vertex_array_range2
+#define GL_NV_vertex_array_range2 1
+#endif
+
+#ifndef GL_NV_vertex_program
+#define GL_NV_vertex_program 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI GLboolean APIENTRY glAreProgramsResidentNV (GLsizei, const GLuint *, GLboolean *);
+  GLAPI void APIENTRY glBindProgramNV (GLenum, GLuint);
+  GLAPI void APIENTRY glDeleteProgramsNV (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glExecuteProgramNV (GLenum, GLuint, const GLfloat *);
+  GLAPI void APIENTRY glGenProgramsNV (GLsizei, GLuint *);
+  GLAPI void APIENTRY glGetProgramParameterdvNV (GLenum, GLuint, GLenum, GLdouble *);
+  GLAPI void APIENTRY glGetProgramParameterfvNV (GLenum, GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetProgramivNV (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetProgramStringNV (GLuint, GLenum, GLubyte *);
+  GLAPI void APIENTRY glGetTrackMatrixivNV (GLenum, GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetVertexAttribdvNV (GLuint, GLenum, GLdouble *);
+  GLAPI void APIENTRY glGetVertexAttribfvNV (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetVertexAttribivNV (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetVertexAttribPointervNV (GLuint, GLenum, GLvoid* *);
+  GLAPI GLboolean APIENTRY glIsProgramNV (GLuint);
+  GLAPI void APIENTRY glLoadProgramNV (GLenum, GLuint, GLsizei, const GLubyte *);
+  GLAPI void APIENTRY glProgramParameter4dNV (GLenum, GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glProgramParameter4dvNV (GLenum, GLuint, const GLdouble *);
+  GLAPI void APIENTRY glProgramParameter4fNV (GLenum, GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glProgramParameter4fvNV (GLenum, GLuint, const GLfloat *);
+  GLAPI void APIENTRY glProgramParameters4dvNV (GLenum, GLuint, GLuint, const GLdouble *);
+  GLAPI void APIENTRY glProgramParameters4fvNV (GLenum, GLuint, GLuint, const GLfloat *);
+  GLAPI void APIENTRY glRequestResidentProgramsNV (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glTrackMatrixNV (GLenum, GLuint, GLenum, GLenum);
+  GLAPI void APIENTRY glVertexAttribPointerNV (GLuint, GLint, GLenum, GLsizei, const GLvoid *);
+  GLAPI void APIENTRY glVertexAttrib1dNV (GLuint, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib1dvNV (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib1fNV (GLuint, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib1fvNV (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib1sNV (GLuint, GLshort);
+  GLAPI void APIENTRY glVertexAttrib1svNV (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib2dNV (GLuint, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib2dvNV (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib2fNV (GLuint, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib2fvNV (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib2sNV (GLuint, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib2svNV (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib3dNV (GLuint, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib3dvNV (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib3fNV (GLuint, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib3fvNV (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib3sNV (GLuint, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib3svNV (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4dNV (GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexAttrib4dvNV (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttrib4fNV (GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexAttrib4fvNV (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttrib4sNV (GLuint, GLshort, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexAttrib4svNV (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVertexAttrib4ubNV (GLuint, GLubyte, GLubyte, GLubyte, GLubyte);
+  GLAPI void APIENTRY glVertexAttrib4ubvNV (GLuint, const GLubyte *);
+  GLAPI void APIENTRY glVertexAttribs1dvNV (GLuint, GLsizei, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttribs1fvNV (GLuint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttribs1svNV (GLuint, GLsizei, const GLshort *);
+  GLAPI void APIENTRY glVertexAttribs2dvNV (GLuint, GLsizei, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttribs2fvNV (GLuint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttribs2svNV (GLuint, GLsizei, const GLshort *);
+  GLAPI void APIENTRY glVertexAttribs3dvNV (GLuint, GLsizei, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttribs3fvNV (GLuint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttribs3svNV (GLuint, GLsizei, const GLshort *);
+  GLAPI void APIENTRY glVertexAttribs4dvNV (GLuint, GLsizei, const GLdouble *);
+  GLAPI void APIENTRY glVertexAttribs4fvNV (GLuint, GLsizei, const GLfloat *);
+  GLAPI void APIENTRY glVertexAttribs4svNV (GLuint, GLsizei, const GLshort *);
+  GLAPI void APIENTRY glVertexAttribs4ubvNV (GLuint, GLsizei, const GLubyte *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef GLboolean (APIENTRYP PFNGLAREPROGRAMSRESIDENTNVPROC) (GLsizei n, const GLuint *programs, GLboolean *residences);
+  typedef void (APIENTRYP PFNGLBINDPROGRAMNVPROC) (GLenum target, GLuint id);
+  typedef void (APIENTRYP PFNGLDELETEPROGRAMSNVPROC) (GLsizei n, const GLuint *programs);
+  typedef void (APIENTRYP PFNGLEXECUTEPROGRAMNVPROC) (GLenum target, GLuint id, const GLfloat *params);
+  typedef void (APIENTRYP PFNGLGENPROGRAMSNVPROC) (GLsizei n, GLuint *programs);
+  typedef void (APIENTRYP PFNGLGETPROGRAMPARAMETERDVNVPROC) (GLenum target, GLuint index, GLenum pname, GLdouble *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMPARAMETERFVNVPROC) (GLenum target, GLuint index, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMIVNVPROC) (GLuint id, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMSTRINGNVPROC) (GLuint id, GLenum pname, GLubyte *program);
+  typedef void (APIENTRYP PFNGLGETTRACKMATRIXIVNVPROC) (GLenum target, GLuint address, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBDVNVPROC) (GLuint index, GLenum pname, GLdouble *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBFVNVPROC) (GLuint index, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBIVNVPROC) (GLuint index, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBPOINTERVNVPROC) (GLuint index, GLenum pname, GLvoid* *pointer);
+  typedef GLboolean (APIENTRYP PFNGLISPROGRAMNVPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLLOADPROGRAMNVPROC) (GLenum target, GLuint id, GLsizei len, const GLubyte *program);
+  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4DNVPROC) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4DVNVPROC) (GLenum target, GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4FNVPROC) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLPROGRAMPARAMETER4FVNVPROC) (GLenum target, GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLPROGRAMPARAMETERS4DVNVPROC) (GLenum target, GLuint index, GLuint count, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLPROGRAMPARAMETERS4FVNVPROC) (GLenum target, GLuint index, GLuint count, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLREQUESTRESIDENTPROGRAMSNVPROC) (GLsizei n, const GLuint *programs);
+  typedef void (APIENTRYP PFNGLTRACKMATRIXNVPROC) (GLenum target, GLuint address, GLenum matrix, GLenum transform);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBPOINTERNVPROC) (GLuint index, GLint fsize, GLenum type, GLsizei stride, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DNVPROC) (GLuint index, GLdouble x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1DVNVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FNVPROC) (GLuint index, GLfloat x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1FVNVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SNVPROC) (GLuint index, GLshort x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1SVNVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DNVPROC) (GLuint index, GLdouble x, GLdouble y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2DVNVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FNVPROC) (GLuint index, GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2FVNVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SNVPROC) (GLuint index, GLshort x, GLshort y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2SVNVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DNVPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3DVNVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FNVPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3FVNVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SNVPROC) (GLuint index, GLshort x, GLshort y, GLshort z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3SVNVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DNVPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4DVNVPROC) (GLuint index, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FNVPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4FVNVPROC) (GLuint index, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SNVPROC) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4SVNVPROC) (GLuint index, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBNVPROC) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4UBVNVPROC) (GLuint index, const GLubyte *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4DVNVPROC) (GLuint index, GLsizei count, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4FVNVPROC) (GLuint index, GLsizei count, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4SVNVPROC) (GLuint index, GLsizei count, const GLshort *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4UBVNVPROC) (GLuint index, GLsizei count, const GLubyte *v);
+#endif
+
+#ifndef GL_SGIX_texture_coordinate_clamp
+#define GL_SGIX_texture_coordinate_clamp 1
+#endif
+
+#ifndef GL_SGIX_scalebias_hint
+#define GL_SGIX_scalebias_hint 1
+#endif
+
+#ifndef GL_OML_interlace
+#define GL_OML_interlace 1
+#endif
+
+#ifndef GL_OML_subsample
+#define GL_OML_subsample 1
+#endif
+
+#ifndef GL_OML_resample
+#define GL_OML_resample 1
+#endif
+
+#ifndef GL_NV_copy_depth_to_color
+#define GL_NV_copy_depth_to_color 1
+#endif
+
+#ifndef GL_ATI_envmap_bumpmap
+#define GL_ATI_envmap_bumpmap 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glTexBumpParameterivATI (GLenum, const GLint *);
+  GLAPI void APIENTRY glTexBumpParameterfvATI (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glGetTexBumpParameterivATI (GLenum, GLint *);
+  GLAPI void APIENTRY glGetTexBumpParameterfvATI (GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLTEXBUMPPARAMETERIVATIPROC) (GLenum pname, const GLint *param);
+  typedef void (APIENTRYP PFNGLTEXBUMPPARAMETERFVATIPROC) (GLenum pname, const GLfloat *param);
+  typedef void (APIENTRYP PFNGLGETTEXBUMPPARAMETERIVATIPROC) (GLenum pname, GLint *param);
+  typedef void (APIENTRYP PFNGLGETTEXBUMPPARAMETERFVATIPROC) (GLenum pname, GLfloat *param);
+#endif
+
+#ifndef GL_ATI_fragment_shader
+#define GL_ATI_fragment_shader 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI GLuint APIENTRY glGenFragmentShadersATI (GLuint);
+  GLAPI void APIENTRY glBindFragmentShaderATI (GLuint);
+  GLAPI void APIENTRY glDeleteFragmentShaderATI (GLuint);
+  GLAPI void APIENTRY glBeginFragmentShaderATI (void);
+  GLAPI void APIENTRY glEndFragmentShaderATI (void);
+  GLAPI void APIENTRY glPassTexCoordATI (GLuint, GLuint, GLenum);
+  GLAPI void APIENTRY glSampleMapATI (GLuint, GLuint, GLenum);
+  GLAPI void APIENTRY glColorFragmentOp1ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glColorFragmentOp2ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glColorFragmentOp3ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glAlphaFragmentOp1ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glAlphaFragmentOp2ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glAlphaFragmentOp3ATI (GLenum, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glSetFragmentShaderConstantATI (GLuint, const GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef GLuint (APIENTRYP PFNGLGENFRAGMENTSHADERSATIPROC) (GLuint range);
+  typedef void (APIENTRYP PFNGLBINDFRAGMENTSHADERATIPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLDELETEFRAGMENTSHADERATIPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLBEGINFRAGMENTSHADERATIPROC) (void);
+  typedef void (APIENTRYP PFNGLENDFRAGMENTSHADERATIPROC) (void);
+  typedef void (APIENTRYP PFNGLPASSTEXCOORDATIPROC) (GLuint dst, GLuint coord, GLenum swizzle);
+  typedef void (APIENTRYP PFNGLSAMPLEMAPATIPROC) (GLuint dst, GLuint interp, GLenum swizzle);
+  typedef void (APIENTRYP PFNGLCOLORFRAGMENTOP1ATIPROC) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
+  typedef void (APIENTRYP PFNGLCOLORFRAGMENTOP2ATIPROC) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
+  typedef void (APIENTRYP PFNGLCOLORFRAGMENTOP3ATIPROC) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
+  typedef void (APIENTRYP PFNGLALPHAFRAGMENTOP1ATIPROC) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
+  typedef void (APIENTRYP PFNGLALPHAFRAGMENTOP2ATIPROC) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
+  typedef void (APIENTRYP PFNGLALPHAFRAGMENTOP3ATIPROC) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
+  typedef void (APIENTRYP PFNGLSETFRAGMENTSHADERCONSTANTATIPROC) (GLuint dst, const GLfloat *value);
+#endif
+
+#ifndef GL_ATI_pn_triangles
+#define GL_ATI_pn_triangles 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPNTrianglesiATI (GLenum, GLint);
+  GLAPI void APIENTRY glPNTrianglesfATI (GLenum, GLfloat);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPNTRIANGLESIATIPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLPNTRIANGLESFATIPROC) (GLenum pname, GLfloat param);
+#endif
+
+#ifndef GL_ATI_vertex_array_object
+#define GL_ATI_vertex_array_object 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI GLuint APIENTRY glNewObjectBufferATI (GLsizei, const GLvoid *, GLenum);
+  GLAPI GLboolean APIENTRY glIsObjectBufferATI (GLuint);
+  GLAPI void APIENTRY glUpdateObjectBufferATI (GLuint, GLuint, GLsizei, const GLvoid *, GLenum);
+  GLAPI void APIENTRY glGetObjectBufferfvATI (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetObjectBufferivATI (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glFreeObjectBufferATI (GLuint);
+  GLAPI void APIENTRY glArrayObjectATI (GLenum, GLint, GLenum, GLsizei, GLuint, GLuint);
+  GLAPI void APIENTRY glGetArrayObjectfvATI (GLenum, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetArrayObjectivATI (GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glVariantArrayObjectATI (GLuint, GLenum, GLsizei, GLuint, GLuint);
+  GLAPI void APIENTRY glGetVariantArrayObjectfvATI (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetVariantArrayObjectivATI (GLuint, GLenum, GLint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef GLuint (APIENTRYP PFNGLNEWOBJECTBUFFERATIPROC) (GLsizei size, const GLvoid *pointer, GLenum usage);
+  typedef GLboolean (APIENTRYP PFNGLISOBJECTBUFFERATIPROC) (GLuint buffer);
+  typedef void (APIENTRYP PFNGLUPDATEOBJECTBUFFERATIPROC) (GLuint buffer, GLuint offset, GLsizei size, const GLvoid *pointer, GLenum preserve);
+  typedef void (APIENTRYP PFNGLGETOBJECTBUFFERFVATIPROC) (GLuint buffer, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETOBJECTBUFFERIVATIPROC) (GLuint buffer, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLFREEOBJECTBUFFERATIPROC) (GLuint buffer);
+  typedef void (APIENTRYP PFNGLARRAYOBJECTATIPROC) (GLenum array, GLint size, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
+  typedef void (APIENTRYP PFNGLGETARRAYOBJECTFVATIPROC) (GLenum array, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETARRAYOBJECTIVATIPROC) (GLenum array, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLVARIANTARRAYOBJECTATIPROC) (GLuint id, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
+  typedef void (APIENTRYP PFNGLGETVARIANTARRAYOBJECTFVATIPROC) (GLuint id, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETVARIANTARRAYOBJECTIVATIPROC) (GLuint id, GLenum pname, GLint *params);
+#endif
+
+#ifndef GL_EXT_vertex_shader
+#define GL_EXT_vertex_shader 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBeginVertexShaderEXT (void);
+  GLAPI void APIENTRY glEndVertexShaderEXT (void);
+  GLAPI void APIENTRY glBindVertexShaderEXT (GLuint);
+  GLAPI GLuint APIENTRY glGenVertexShadersEXT (GLuint);
+  GLAPI void APIENTRY glDeleteVertexShaderEXT (GLuint);
+  GLAPI void APIENTRY glShaderOp1EXT (GLenum, GLuint, GLuint);
+  GLAPI void APIENTRY glShaderOp2EXT (GLenum, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glShaderOp3EXT (GLenum, GLuint, GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glSwizzleEXT (GLuint, GLuint, GLenum, GLenum, GLenum, GLenum);
+  GLAPI void APIENTRY glWriteMaskEXT (GLuint, GLuint, GLenum, GLenum, GLenum, GLenum);
+  GLAPI void APIENTRY glInsertComponentEXT (GLuint, GLuint, GLuint);
+  GLAPI void APIENTRY glExtractComponentEXT (GLuint, GLuint, GLuint);
+  GLAPI GLuint APIENTRY glGenSymbolsEXT (GLenum, GLenum, GLenum, GLuint);
+  GLAPI void APIENTRY glSetInvariantEXT (GLuint, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glSetLocalConstantEXT (GLuint, GLenum, const GLvoid *);
+  GLAPI void APIENTRY glVariantbvEXT (GLuint, const GLbyte *);
+  GLAPI void APIENTRY glVariantsvEXT (GLuint, const GLshort *);
+  GLAPI void APIENTRY glVariantivEXT (GLuint, const GLint *);
+  GLAPI void APIENTRY glVariantfvEXT (GLuint, const GLfloat *);
+  GLAPI void APIENTRY glVariantdvEXT (GLuint, const GLdouble *);
+  GLAPI void APIENTRY glVariantubvEXT (GLuint, const GLubyte *);
+  GLAPI void APIENTRY glVariantusvEXT (GLuint, const GLushort *);
+  GLAPI void APIENTRY glVariantuivEXT (GLuint, const GLuint *);
+  GLAPI void APIENTRY glVariantPointerEXT (GLuint, GLenum, GLuint, const GLvoid *);
+  GLAPI void APIENTRY glEnableVariantClientStateEXT (GLuint);
+  GLAPI void APIENTRY glDisableVariantClientStateEXT (GLuint);
+  GLAPI GLuint APIENTRY glBindLightParameterEXT (GLenum, GLenum);
+  GLAPI GLuint APIENTRY glBindMaterialParameterEXT (GLenum, GLenum);
+  GLAPI GLuint APIENTRY glBindTexGenParameterEXT (GLenum, GLenum, GLenum);
+  GLAPI GLuint APIENTRY glBindTextureUnitParameterEXT (GLenum, GLenum);
+  GLAPI GLuint APIENTRY glBindParameterEXT (GLenum);
+  GLAPI GLboolean APIENTRY glIsVariantEnabledEXT (GLuint, GLenum);
+  GLAPI void APIENTRY glGetVariantBooleanvEXT (GLuint, GLenum, GLboolean *);
+  GLAPI void APIENTRY glGetVariantIntegervEXT (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetVariantFloatvEXT (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetVariantPointervEXT (GLuint, GLenum, GLvoid* *);
+  GLAPI void APIENTRY glGetInvariantBooleanvEXT (GLuint, GLenum, GLboolean *);
+  GLAPI void APIENTRY glGetInvariantIntegervEXT (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetInvariantFloatvEXT (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetLocalConstantBooleanvEXT (GLuint, GLenum, GLboolean *);
+  GLAPI void APIENTRY glGetLocalConstantIntegervEXT (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetLocalConstantFloatvEXT (GLuint, GLenum, GLfloat *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBEGINVERTEXSHADEREXTPROC) (void);
+  typedef void (APIENTRYP PFNGLENDVERTEXSHADEREXTPROC) (void);
+  typedef void (APIENTRYP PFNGLBINDVERTEXSHADEREXTPROC) (GLuint id);
+  typedef GLuint (APIENTRYP PFNGLGENVERTEXSHADERSEXTPROC) (GLuint range);
+  typedef void (APIENTRYP PFNGLDELETEVERTEXSHADEREXTPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLSHADEROP1EXTPROC) (GLenum op, GLuint res, GLuint arg1);
+  typedef void (APIENTRYP PFNGLSHADEROP2EXTPROC) (GLenum op, GLuint res, GLuint arg1, GLuint arg2);
+  typedef void (APIENTRYP PFNGLSHADEROP3EXTPROC) (GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3);
+  typedef void (APIENTRYP PFNGLSWIZZLEEXTPROC) (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
+  typedef void (APIENTRYP PFNGLWRITEMASKEXTPROC) (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
+  typedef void (APIENTRYP PFNGLINSERTCOMPONENTEXTPROC) (GLuint res, GLuint src, GLuint num);
+  typedef void (APIENTRYP PFNGLEXTRACTCOMPONENTEXTPROC) (GLuint res, GLuint src, GLuint num);
+  typedef GLuint (APIENTRYP PFNGLGENSYMBOLSEXTPROC) (GLenum datatype, GLenum storagetype, GLenum range, GLuint components);
+  typedef void (APIENTRYP PFNGLSETINVARIANTEXTPROC) (GLuint id, GLenum type, const GLvoid *addr);
+  typedef void (APIENTRYP PFNGLSETLOCALCONSTANTEXTPROC) (GLuint id, GLenum type, const GLvoid *addr);
+  typedef void (APIENTRYP PFNGLVARIANTBVEXTPROC) (GLuint id, const GLbyte *addr);
+  typedef void (APIENTRYP PFNGLVARIANTSVEXTPROC) (GLuint id, const GLshort *addr);
+  typedef void (APIENTRYP PFNGLVARIANTIVEXTPROC) (GLuint id, const GLint *addr);
+  typedef void (APIENTRYP PFNGLVARIANTFVEXTPROC) (GLuint id, const GLfloat *addr);
+  typedef void (APIENTRYP PFNGLVARIANTDVEXTPROC) (GLuint id, const GLdouble *addr);
+  typedef void (APIENTRYP PFNGLVARIANTUBVEXTPROC) (GLuint id, const GLubyte *addr);
+  typedef void (APIENTRYP PFNGLVARIANTUSVEXTPROC) (GLuint id, const GLushort *addr);
+  typedef void (APIENTRYP PFNGLVARIANTUIVEXTPROC) (GLuint id, const GLuint *addr);
+  typedef void (APIENTRYP PFNGLVARIANTPOINTEREXTPROC) (GLuint id, GLenum type, GLuint stride, const GLvoid *addr);
+  typedef void (APIENTRYP PFNGLENABLEVARIANTCLIENTSTATEEXTPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLDISABLEVARIANTCLIENTSTATEEXTPROC) (GLuint id);
+  typedef GLuint (APIENTRYP PFNGLBINDLIGHTPARAMETEREXTPROC) (GLenum light, GLenum value);
+  typedef GLuint (APIENTRYP PFNGLBINDMATERIALPARAMETEREXTPROC) (GLenum face, GLenum value);
+  typedef GLuint (APIENTRYP PFNGLBINDTEXGENPARAMETEREXTPROC) (GLenum unit, GLenum coord, GLenum value);
+  typedef GLuint (APIENTRYP PFNGLBINDTEXTUREUNITPARAMETEREXTPROC) (GLenum unit, GLenum value);
+  typedef GLuint (APIENTRYP PFNGLBINDPARAMETEREXTPROC) (GLenum value);
+  typedef GLboolean (APIENTRYP PFNGLISVARIANTENABLEDEXTPROC) (GLuint id, GLenum cap);
+  typedef void (APIENTRYP PFNGLGETVARIANTBOOLEANVEXTPROC) (GLuint id, GLenum value, GLboolean *data);
+  typedef void (APIENTRYP PFNGLGETVARIANTINTEGERVEXTPROC) (GLuint id, GLenum value, GLint *data);
+  typedef void (APIENTRYP PFNGLGETVARIANTFLOATVEXTPROC) (GLuint id, GLenum value, GLfloat *data);
+  typedef void (APIENTRYP PFNGLGETVARIANTPOINTERVEXTPROC) (GLuint id, GLenum value, GLvoid* *data);
+  typedef void (APIENTRYP PFNGLGETINVARIANTBOOLEANVEXTPROC) (GLuint id, GLenum value, GLboolean *data);
+  typedef void (APIENTRYP PFNGLGETINVARIANTINTEGERVEXTPROC) (GLuint id, GLenum value, GLint *data);
+  typedef void (APIENTRYP PFNGLGETINVARIANTFLOATVEXTPROC) (GLuint id, GLenum value, GLfloat *data);
+  typedef void (APIENTRYP PFNGLGETLOCALCONSTANTBOOLEANVEXTPROC) (GLuint id, GLenum value, GLboolean *data);
+  typedef void (APIENTRYP PFNGLGETLOCALCONSTANTINTEGERVEXTPROC) (GLuint id, GLenum value, GLint *data);
+  typedef void (APIENTRYP PFNGLGETLOCALCONSTANTFLOATVEXTPROC) (GLuint id, GLenum value, GLfloat *data);
+#endif
+
+#ifndef GL_ATI_vertex_streams
+#define GL_ATI_vertex_streams 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glVertexStream1sATI (GLenum, GLshort);
+  GLAPI void APIENTRY glVertexStream1svATI (GLenum, const GLshort *);
+  GLAPI void APIENTRY glVertexStream1iATI (GLenum, GLint);
+  GLAPI void APIENTRY glVertexStream1ivATI (GLenum, const GLint *);
+  GLAPI void APIENTRY glVertexStream1fATI (GLenum, GLfloat);
+  GLAPI void APIENTRY glVertexStream1fvATI (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glVertexStream1dATI (GLenum, GLdouble);
+  GLAPI void APIENTRY glVertexStream1dvATI (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glVertexStream2sATI (GLenum, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexStream2svATI (GLenum, const GLshort *);
+  GLAPI void APIENTRY glVertexStream2iATI (GLenum, GLint, GLint);
+  GLAPI void APIENTRY glVertexStream2ivATI (GLenum, const GLint *);
+  GLAPI void APIENTRY glVertexStream2fATI (GLenum, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexStream2fvATI (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glVertexStream2dATI (GLenum, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexStream2dvATI (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glVertexStream3sATI (GLenum, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexStream3svATI (GLenum, const GLshort *);
+  GLAPI void APIENTRY glVertexStream3iATI (GLenum, GLint, GLint, GLint);
+  GLAPI void APIENTRY glVertexStream3ivATI (GLenum, const GLint *);
+  GLAPI void APIENTRY glVertexStream3fATI (GLenum, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexStream3fvATI (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glVertexStream3dATI (GLenum, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexStream3dvATI (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glVertexStream4sATI (GLenum, GLshort, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glVertexStream4svATI (GLenum, const GLshort *);
+  GLAPI void APIENTRY glVertexStream4iATI (GLenum, GLint, GLint, GLint, GLint);
+  GLAPI void APIENTRY glVertexStream4ivATI (GLenum, const GLint *);
+  GLAPI void APIENTRY glVertexStream4fATI (GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glVertexStream4fvATI (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glVertexStream4dATI (GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glVertexStream4dvATI (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glNormalStream3bATI (GLenum, GLbyte, GLbyte, GLbyte);
+  GLAPI void APIENTRY glNormalStream3bvATI (GLenum, const GLbyte *);
+  GLAPI void APIENTRY glNormalStream3sATI (GLenum, GLshort, GLshort, GLshort);
+  GLAPI void APIENTRY glNormalStream3svATI (GLenum, const GLshort *);
+  GLAPI void APIENTRY glNormalStream3iATI (GLenum, GLint, GLint, GLint);
+  GLAPI void APIENTRY glNormalStream3ivATI (GLenum, const GLint *);
+  GLAPI void APIENTRY glNormalStream3fATI (GLenum, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glNormalStream3fvATI (GLenum, const GLfloat *);
+  GLAPI void APIENTRY glNormalStream3dATI (GLenum, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glNormalStream3dvATI (GLenum, const GLdouble *);
+  GLAPI void APIENTRY glClientActiveVertexStreamATI (GLenum);
+  GLAPI void APIENTRY glVertexBlendEnviATI (GLenum, GLint);
+  GLAPI void APIENTRY glVertexBlendEnvfATI (GLenum, GLfloat);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1SATIPROC) (GLenum stream, GLshort x);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1SVATIPROC) (GLenum stream, const GLshort *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1IATIPROC) (GLenum stream, GLint x);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1IVATIPROC) (GLenum stream, const GLint *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1FATIPROC) (GLenum stream, GLfloat x);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1FVATIPROC) (GLenum stream, const GLfloat *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1DATIPROC) (GLenum stream, GLdouble x);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM1DVATIPROC) (GLenum stream, const GLdouble *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2SATIPROC) (GLenum stream, GLshort x, GLshort y);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2SVATIPROC) (GLenum stream, const GLshort *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2IATIPROC) (GLenum stream, GLint x, GLint y);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2IVATIPROC) (GLenum stream, const GLint *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2FATIPROC) (GLenum stream, GLfloat x, GLfloat y);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2FVATIPROC) (GLenum stream, const GLfloat *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2DATIPROC) (GLenum stream, GLdouble x, GLdouble y);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM2DVATIPROC) (GLenum stream, const GLdouble *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3SATIPROC) (GLenum stream, GLshort x, GLshort y, GLshort z);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3SVATIPROC) (GLenum stream, const GLshort *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3IATIPROC) (GLenum stream, GLint x, GLint y, GLint z);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3IVATIPROC) (GLenum stream, const GLint *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3FATIPROC) (GLenum stream, GLfloat x, GLfloat y, GLfloat z);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3FVATIPROC) (GLenum stream, const GLfloat *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3DATIPROC) (GLenum stream, GLdouble x, GLdouble y, GLdouble z);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM3DVATIPROC) (GLenum stream, const GLdouble *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4SATIPROC) (GLenum stream, GLshort x, GLshort y, GLshort z, GLshort w);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4SVATIPROC) (GLenum stream, const GLshort *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4IATIPROC) (GLenum stream, GLint x, GLint y, GLint z, GLint w);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4IVATIPROC) (GLenum stream, const GLint *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4FATIPROC) (GLenum stream, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4FVATIPROC) (GLenum stream, const GLfloat *coords);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4DATIPROC) (GLenum stream, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLVERTEXSTREAM4DVATIPROC) (GLenum stream, const GLdouble *coords);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3BATIPROC) (GLenum stream, GLbyte nx, GLbyte ny, GLbyte nz);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3BVATIPROC) (GLenum stream, const GLbyte *coords);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3SATIPROC) (GLenum stream, GLshort nx, GLshort ny, GLshort nz);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3SVATIPROC) (GLenum stream, const GLshort *coords);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3IATIPROC) (GLenum stream, GLint nx, GLint ny, GLint nz);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3IVATIPROC) (GLenum stream, const GLint *coords);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3FATIPROC) (GLenum stream, GLfloat nx, GLfloat ny, GLfloat nz);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3FVATIPROC) (GLenum stream, const GLfloat *coords);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3DATIPROC) (GLenum stream, GLdouble nx, GLdouble ny, GLdouble nz);
+  typedef void (APIENTRYP PFNGLNORMALSTREAM3DVATIPROC) (GLenum stream, const GLdouble *coords);
+  typedef void (APIENTRYP PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC) (GLenum stream);
+  typedef void (APIENTRYP PFNGLVERTEXBLENDENVIATIPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLVERTEXBLENDENVFATIPROC) (GLenum pname, GLfloat param);
+#endif
+
+#ifndef GL_ATI_element_array
+#define GL_ATI_element_array 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glElementPointerATI (GLenum, const GLvoid *);
+  GLAPI void APIENTRY glDrawElementArrayATI (GLenum, GLsizei);
+  GLAPI void APIENTRY glDrawRangeElementArrayATI (GLenum, GLuint, GLuint, GLsizei);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLELEMENTPOINTERATIPROC) (GLenum type, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLDRAWELEMENTARRAYATIPROC) (GLenum mode, GLsizei count);
+  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTARRAYATIPROC) (GLenum mode, GLuint start, GLuint end, GLsizei count);
+#endif
+
+#ifndef GL_SUN_mesh_array
+#define GL_SUN_mesh_array 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDrawMeshArraysSUN (GLenum, GLint, GLsizei, GLsizei);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDRAWMESHARRAYSSUNPROC) (GLenum mode, GLint first, GLsizei count, GLsizei width);
+#endif
+
+#ifndef GL_SUN_slice_accum
+#define GL_SUN_slice_accum 1
+#endif
+
+#ifndef GL_NV_multisample_filter_hint
+#define GL_NV_multisample_filter_hint 1
+#endif
+
+#ifndef GL_NV_depth_clamp
+#define GL_NV_depth_clamp 1
+#endif
+
+#ifndef GL_NV_occlusion_query
+#define GL_NV_occlusion_query 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGenOcclusionQueriesNV (GLsizei, GLuint *);
+  GLAPI void APIENTRY glDeleteOcclusionQueriesNV (GLsizei, const GLuint *);
+  GLAPI GLboolean APIENTRY glIsOcclusionQueryNV (GLuint);
+  GLAPI void APIENTRY glBeginOcclusionQueryNV (GLuint);
+  GLAPI void APIENTRY glEndOcclusionQueryNV (void);
+  GLAPI void APIENTRY glGetOcclusionQueryivNV (GLuint, GLenum, GLint *);
+  GLAPI void APIENTRY glGetOcclusionQueryuivNV (GLuint, GLenum, GLuint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGENOCCLUSIONQUERIESNVPROC) (GLsizei n, GLuint *ids);
+  typedef void (APIENTRYP PFNGLDELETEOCCLUSIONQUERIESNVPROC) (GLsizei n, const GLuint *ids);
+  typedef GLboolean (APIENTRYP PFNGLISOCCLUSIONQUERYNVPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLBEGINOCCLUSIONQUERYNVPROC) (GLuint id);
+  typedef void (APIENTRYP PFNGLENDOCCLUSIONQUERYNVPROC) (void);
+  typedef void (APIENTRYP PFNGLGETOCCLUSIONQUERYIVNVPROC) (GLuint id, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGETOCCLUSIONQUERYUIVNVPROC) (GLuint id, GLenum pname, GLuint *params);
+#endif
+
+#ifndef GL_NV_point_sprite
+#define GL_NV_point_sprite 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPointParameteriNV (GLenum, GLint);
+  GLAPI void APIENTRY glPointParameterivNV (GLenum, const GLint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERINVPROC) (GLenum pname, GLint param);
+  typedef void (APIENTRYP PFNGLPOINTPARAMETERIVNVPROC) (GLenum pname, const GLint *params);
+#endif
+
+#ifndef GL_NV_texture_shader3
+#define GL_NV_texture_shader3 1
+#endif
+
+#ifndef GL_NV_vertex_program1_1
+#define GL_NV_vertex_program1_1 1
+#endif
+
+#ifndef GL_EXT_shadow_funcs
+#define GL_EXT_shadow_funcs 1
+#endif
+
+#ifndef GL_EXT_stencil_two_side
+#define GL_EXT_stencil_two_side 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glActiveStencilFaceEXT (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLACTIVESTENCILFACEEXTPROC) (GLenum face);
+#endif
+
+#ifndef GL_ATI_text_fragment_shader
+#define GL_ATI_text_fragment_shader 1
+#endif
+
+#ifndef GL_APPLE_client_storage
+#define GL_APPLE_client_storage 1
+#endif
+
+#ifndef GL_APPLE_element_array
+#define GL_APPLE_element_array 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glElementPointerAPPLE (GLenum, const GLvoid *);
+  GLAPI void APIENTRY glDrawElementArrayAPPLE (GLenum, GLint, GLsizei);
+  GLAPI void APIENTRY glDrawRangeElementArrayAPPLE (GLenum, GLuint, GLuint, GLint, GLsizei);
+  GLAPI void APIENTRY glMultiDrawElementArrayAPPLE (GLenum, const GLint *, const GLsizei *, GLsizei);
+  GLAPI void APIENTRY glMultiDrawRangeElementArrayAPPLE (GLenum, GLuint, GLuint, const GLint *, const GLsizei *, GLsizei);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLELEMENTPOINTERAPPLEPROC) (GLenum type, const GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLDRAWELEMENTARRAYAPPLEPROC) (GLenum mode, GLint first, GLsizei count);
+  typedef void (APIENTRYP PFNGLDRAWRANGEELEMENTARRAYAPPLEPROC) (GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
+  typedef void (APIENTRYP PFNGLMULTIDRAWELEMENTARRAYAPPLEPROC) (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount);
+  typedef void (APIENTRYP PFNGLMULTIDRAWRANGEELEMENTARRAYAPPLEPROC) (GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount);
+#endif
+
+#ifndef GL_APPLE_fence
+#define GL_APPLE_fence 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glGenFencesAPPLE (GLsizei, GLuint *);
+  GLAPI void APIENTRY glDeleteFencesAPPLE (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glSetFenceAPPLE (GLuint);
+  GLAPI GLboolean APIENTRY glIsFenceAPPLE (GLuint);
+  GLAPI GLboolean APIENTRY glTestFenceAPPLE (GLuint);
+  GLAPI void APIENTRY glFinishFenceAPPLE (GLuint);
+  GLAPI GLboolean APIENTRY glTestObjectAPPLE (GLenum, GLuint);
+  GLAPI void APIENTRY glFinishObjectAPPLE (GLenum, GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLGENFENCESAPPLEPROC) (GLsizei n, GLuint *fences);
+  typedef void (APIENTRYP PFNGLDELETEFENCESAPPLEPROC) (GLsizei n, const GLuint *fences);
+  typedef void (APIENTRYP PFNGLSETFENCEAPPLEPROC) (GLuint fence);
+  typedef GLboolean (APIENTRYP PFNGLISFENCEAPPLEPROC) (GLuint fence);
+  typedef GLboolean (APIENTRYP PFNGLTESTFENCEAPPLEPROC) (GLuint fence);
+  typedef void (APIENTRYP PFNGLFINISHFENCEAPPLEPROC) (GLuint fence);
+  typedef GLboolean (APIENTRYP PFNGLTESTOBJECTAPPLEPROC) (GLenum object, GLuint name);
+  typedef void (APIENTRYP PFNGLFINISHOBJECTAPPLEPROC) (GLenum object, GLint name);
+#endif
+
+#ifndef GL_APPLE_vertex_array_object
+#define GL_APPLE_vertex_array_object 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBindVertexArrayAPPLE (GLuint);
+  GLAPI void APIENTRY glDeleteVertexArraysAPPLE (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenVertexArraysAPPLE (GLsizei, const GLuint *);
+  GLAPI GLboolean APIENTRY glIsVertexArrayAPPLE (GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBINDVERTEXARRAYAPPLEPROC) (GLuint array);
+  typedef void (APIENTRYP PFNGLDELETEVERTEXARRAYSAPPLEPROC) (GLsizei n, const GLuint *arrays);
+  typedef void (APIENTRYP PFNGLGENVERTEXARRAYSAPPLEPROC) (GLsizei n, const GLuint *arrays);
+  typedef GLboolean (APIENTRYP PFNGLISVERTEXARRAYAPPLEPROC) (GLuint array);
+#endif
+
+#ifndef GL_APPLE_vertex_array_range
+#define GL_APPLE_vertex_array_range 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glVertexArrayRangeAPPLE (GLsizei, GLvoid *);
+  GLAPI void APIENTRY glFlushVertexArrayRangeAPPLE (GLsizei, GLvoid *);
+  GLAPI void APIENTRY glVertexArrayParameteriAPPLE (GLenum, GLint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLVERTEXARRAYRANGEAPPLEPROC) (GLsizei length, GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLFLUSHVERTEXARRAYRANGEAPPLEPROC) (GLsizei length, GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLVERTEXARRAYPARAMETERIAPPLEPROC) (GLenum pname, GLint param);
+#endif
+
+#ifndef GL_APPLE_ycbcr_422
+#define GL_APPLE_ycbcr_422 1
+#endif
+
+#ifndef GL_S3_s3tc
+#define GL_S3_s3tc 1
+#endif
+
+#ifndef GL_ATI_draw_buffers
+#define GL_ATI_draw_buffers 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDrawBuffersATI (GLsizei, const GLenum *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDRAWBUFFERSATIPROC) (GLsizei n, const GLenum *bufs);
+#endif
+
+#ifndef GL_ATI_pixel_format_float
+#define GL_ATI_pixel_format_float 1
+  /* This is really a WGL extension, but defines some associated GL enums.
+   * ATI does not export "GL_ATI_pixel_format_float" in the GL_EXTENSIONS string.
+   */
+#endif
+
+#ifndef GL_ATI_texture_env_combine3
+#define GL_ATI_texture_env_combine3 1
+#endif
+
+#ifndef GL_ATI_texture_float
+#define GL_ATI_texture_float 1
+#endif
+
+#ifndef GL_NV_float_buffer
+#define GL_NV_float_buffer 1
+#endif
+
+#ifndef GL_NV_fragment_program
+#define GL_NV_fragment_program 1
+  /* Some NV_fragment_program entry points are shared with ARB_vertex_program. */
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glProgramNamedParameter4fNV (GLuint, GLsizei, const GLubyte *, GLfloat, GLfloat, GLfloat, GLfloat);
+  GLAPI void APIENTRY glProgramNamedParameter4dNV (GLuint, GLsizei, const GLubyte *, GLdouble, GLdouble, GLdouble, GLdouble);
+  GLAPI void APIENTRY glProgramNamedParameter4fvNV (GLuint, GLsizei, const GLubyte *, const GLfloat *);
+  GLAPI void APIENTRY glProgramNamedParameter4dvNV (GLuint, GLsizei, const GLubyte *, const GLdouble *);
+  GLAPI void APIENTRY glGetProgramNamedParameterfvNV (GLuint, GLsizei, const GLubyte *, GLfloat *);
+  GLAPI void APIENTRY glGetProgramNamedParameterdvNV (GLuint, GLsizei, const GLubyte *, GLdouble *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4FNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4DNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4FVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, const GLfloat *v);
+  typedef void (APIENTRYP PFNGLPROGRAMNAMEDPARAMETER4DVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, const GLdouble *v);
+  typedef void (APIENTRYP PFNGLGETPROGRAMNAMEDPARAMETERFVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETPROGRAMNAMEDPARAMETERDVNVPROC) (GLuint id, GLsizei len, const GLubyte *name, GLdouble *params);
+#endif
+
+#ifndef GL_NV_half_float
+#define GL_NV_half_float 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glVertex2hNV (GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glVertex2hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glVertex3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glVertex3hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glVertex4hNV (GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glVertex4hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glNormal3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glNormal3hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glColor3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glColor3hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glColor4hNV (GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glColor4hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glTexCoord1hNV (GLhalfNV);
+  GLAPI void APIENTRY glTexCoord1hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glTexCoord2hNV (GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glTexCoord2hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glTexCoord3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glTexCoord3hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glTexCoord4hNV (GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glTexCoord4hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glMultiTexCoord1hNV (GLenum, GLhalfNV);
+  GLAPI void APIENTRY glMultiTexCoord1hvNV (GLenum, const GLhalfNV *);
+  GLAPI void APIENTRY glMultiTexCoord2hNV (GLenum, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glMultiTexCoord2hvNV (GLenum, const GLhalfNV *);
+  GLAPI void APIENTRY glMultiTexCoord3hNV (GLenum, GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glMultiTexCoord3hvNV (GLenum, const GLhalfNV *);
+  GLAPI void APIENTRY glMultiTexCoord4hNV (GLenum, GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glMultiTexCoord4hvNV (GLenum, const GLhalfNV *);
+  GLAPI void APIENTRY glFogCoordhNV (GLhalfNV);
+  GLAPI void APIENTRY glFogCoordhvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glSecondaryColor3hNV (GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glSecondaryColor3hvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glVertexWeighthNV (GLhalfNV);
+  GLAPI void APIENTRY glVertexWeighthvNV (const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttrib1hNV (GLuint, GLhalfNV);
+  GLAPI void APIENTRY glVertexAttrib1hvNV (GLuint, const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttrib2hNV (GLuint, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glVertexAttrib2hvNV (GLuint, const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttrib3hNV (GLuint, GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glVertexAttrib3hvNV (GLuint, const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttrib4hNV (GLuint, GLhalfNV, GLhalfNV, GLhalfNV, GLhalfNV);
+  GLAPI void APIENTRY glVertexAttrib4hvNV (GLuint, const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttribs1hvNV (GLuint, GLsizei, const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttribs2hvNV (GLuint, GLsizei, const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttribs3hvNV (GLuint, GLsizei, const GLhalfNV *);
+  GLAPI void APIENTRY glVertexAttribs4hvNV (GLuint, GLsizei, const GLhalfNV *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLVERTEX2HNVPROC) (GLhalfNV x, GLhalfNV y);
+  typedef void (APIENTRYP PFNGLVERTEX2HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEX3HNVPROC) (GLhalfNV x, GLhalfNV y, GLhalfNV z);
+  typedef void (APIENTRYP PFNGLVERTEX3HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEX4HNVPROC) (GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
+  typedef void (APIENTRYP PFNGLVERTEX4HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLNORMAL3HNVPROC) (GLhalfNV nx, GLhalfNV ny, GLhalfNV nz);
+  typedef void (APIENTRYP PFNGLNORMAL3HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLCOLOR3HNVPROC) (GLhalfNV red, GLhalfNV green, GLhalfNV blue);
+  typedef void (APIENTRYP PFNGLCOLOR3HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLCOLOR4HNVPROC) (GLhalfNV red, GLhalfNV green, GLhalfNV blue, GLhalfNV alpha);
+  typedef void (APIENTRYP PFNGLCOLOR4HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD1HNVPROC) (GLhalfNV s);
+  typedef void (APIENTRYP PFNGLTEXCOORD1HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD2HNVPROC) (GLhalfNV s, GLhalfNV t);
+  typedef void (APIENTRYP PFNGLTEXCOORD2HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD3HNVPROC) (GLhalfNV s, GLhalfNV t, GLhalfNV r);
+  typedef void (APIENTRYP PFNGLTEXCOORD3HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLTEXCOORD4HNVPROC) (GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
+  typedef void (APIENTRYP PFNGLTEXCOORD4HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1HNVPROC) (GLenum target, GLhalfNV s);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD1HVNVPROC) (GLenum target, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2HNVPROC) (GLenum target, GLhalfNV s, GLhalfNV t);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD2HVNVPROC) (GLenum target, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3HNVPROC) (GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD3HVNVPROC) (GLenum target, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4HNVPROC) (GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
+  typedef void (APIENTRYP PFNGLMULTITEXCOORD4HVNVPROC) (GLenum target, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLFOGCOORDHNVPROC) (GLhalfNV fog);
+  typedef void (APIENTRYP PFNGLFOGCOORDHVNVPROC) (const GLhalfNV *fog);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3HNVPROC) (GLhalfNV red, GLhalfNV green, GLhalfNV blue);
+  typedef void (APIENTRYP PFNGLSECONDARYCOLOR3HVNVPROC) (const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXWEIGHTHNVPROC) (GLhalfNV weight);
+  typedef void (APIENTRYP PFNGLVERTEXWEIGHTHVNVPROC) (const GLhalfNV *weight);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1HNVPROC) (GLuint index, GLhalfNV x);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB1HVNVPROC) (GLuint index, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2HNVPROC) (GLuint index, GLhalfNV x, GLhalfNV y);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB2HVNVPROC) (GLuint index, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3HNVPROC) (GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB3HVNVPROC) (GLuint index, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4HNVPROC) (GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIB4HVNVPROC) (GLuint index, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS1HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS2HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS3HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBS4HVNVPROC) (GLuint index, GLsizei n, const GLhalfNV *v);
+#endif
+
+#ifndef GL_NV_pixel_data_range
+#define GL_NV_pixel_data_range 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPixelDataRangeNV (GLenum, GLsizei, GLvoid *);
+  GLAPI void APIENTRY glFlushPixelDataRangeNV (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPIXELDATARANGENVPROC) (GLenum target, GLsizei length, GLvoid *pointer);
+  typedef void (APIENTRYP PFNGLFLUSHPIXELDATARANGENVPROC) (GLenum target);
+#endif
+
+#ifndef GL_NV_primitive_restart
+#define GL_NV_primitive_restart 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glPrimitiveRestartNV (void);
+  GLAPI void APIENTRY glPrimitiveRestartIndexNV (GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLPRIMITIVERESTARTNVPROC) (void);
+  typedef void (APIENTRYP PFNGLPRIMITIVERESTARTINDEXNVPROC) (GLuint index);
+#endif
+
+#ifndef GL_NV_texture_expand_normal
+#define GL_NV_texture_expand_normal 1
+#endif
+
+#ifndef GL_NV_vertex_program2
+#define GL_NV_vertex_program2 1
+#endif
+
+#ifndef GL_ATI_map_object_buffer
+#define GL_ATI_map_object_buffer 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI GLvoid* APIENTRY glMapObjectBufferATI (GLuint);
+  GLAPI void APIENTRY glUnmapObjectBufferATI (GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef GLvoid* (APIENTRYP PFNGLMAPOBJECTBUFFERATIPROC) (GLuint buffer);
+  typedef void (APIENTRYP PFNGLUNMAPOBJECTBUFFERATIPROC) (GLuint buffer);
+#endif
+
+#ifndef GL_ATI_separate_stencil
+#define GL_ATI_separate_stencil 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glStencilOpSeparateATI (GLenum, GLenum, GLenum, GLenum);
+  GLAPI void APIENTRY glStencilFuncSeparateATI (GLenum, GLenum, GLint, GLuint);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSTENCILOPSEPARATEATIPROC) (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
+  typedef void (APIENTRYP PFNGLSTENCILFUNCSEPARATEATIPROC) (GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask);
+#endif
+
+#ifndef GL_ATI_vertex_attrib_array_object
+#define GL_ATI_vertex_attrib_array_object 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glVertexAttribArrayObjectATI (GLuint, GLint, GLenum, GLboolean, GLsizei, GLuint, GLuint);
+  GLAPI void APIENTRY glGetVertexAttribArrayObjectfvATI (GLuint, GLenum, GLfloat *);
+  GLAPI void APIENTRY glGetVertexAttribArrayObjectivATI (GLuint, GLenum, GLint *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLVERTEXATTRIBARRAYOBJECTATIPROC) (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLuint buffer, GLuint offset);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBARRAYOBJECTFVATIPROC) (GLuint index, GLenum pname, GLfloat *params);
+  typedef void (APIENTRYP PFNGLGETVERTEXATTRIBARRAYOBJECTIVATIPROC) (GLuint index, GLenum pname, GLint *params);
+#endif
+
+#ifndef GL_OES_read_format
+#define GL_OES_read_format 1
+#endif
+
+#ifndef GL_EXT_depth_bounds_test
+#define GL_EXT_depth_bounds_test 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glDepthBoundsEXT (GLclampd, GLclampd);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLDEPTHBOUNDSEXTPROC) (GLclampd zmin, GLclampd zmax);
+#endif
+
+#ifndef GL_EXT_texture_mirror_clamp
+#define GL_EXT_texture_mirror_clamp 1
+#endif
+
+#ifndef GL_EXT_blend_equation_separate
+#define GL_EXT_blend_equation_separate 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glBlendEquationSeparateEXT (GLenum, GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLBLENDEQUATIONSEPARATEEXTPROC) (GLenum modeRGB, GLenum modeAlpha);
+#endif
+
+#ifndef GL_MESA_pack_invert
+#define GL_MESA_pack_invert 1
+#endif
+
+#ifndef GL_MESA_ycbcr_texture
+#define GL_MESA_ycbcr_texture 1
+#endif
+
+#ifndef GL_EXT_pixel_buffer_object
+#define GL_EXT_pixel_buffer_object 1
+#endif
+
+#ifndef GL_NV_fragment_program_option
+#define GL_NV_fragment_program_option 1
+#endif
+
+#ifndef GL_NV_fragment_program2
+#define GL_NV_fragment_program2 1
+#endif
+
+#ifndef GL_NV_vertex_program2_option
+#define GL_NV_vertex_program2_option 1
+#endif
+
+#ifndef GL_NV_vertex_program3
+#define GL_NV_vertex_program3 1
+#endif
+
+#ifndef GL_EXT_framebuffer_object
+#define GL_EXT_framebuffer_object 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI GLboolean APIENTRY glIsRenderbufferEXT (GLuint);
+  GLAPI void APIENTRY glBindRenderbufferEXT (GLenum, GLuint);
+  GLAPI void APIENTRY glDeleteRenderbuffersEXT (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenRenderbuffersEXT (GLsizei, GLuint *);
+  GLAPI void APIENTRY glRenderbufferStorageEXT (GLenum, GLenum, GLsizei, GLsizei);
+  GLAPI void APIENTRY glGetRenderbufferParameterivEXT (GLenum, GLenum, GLint *);
+  GLAPI GLboolean APIENTRY glIsFramebufferEXT (GLuint);
+  GLAPI void APIENTRY glBindFramebufferEXT (GLenum, GLuint);
+  GLAPI void APIENTRY glDeleteFramebuffersEXT (GLsizei, const GLuint *);
+  GLAPI void APIENTRY glGenFramebuffersEXT (GLsizei, GLuint *);
+  GLAPI GLenum APIENTRY glCheckFramebufferStatusEXT (GLenum);
+  GLAPI void APIENTRY glFramebufferTexture1DEXT (GLenum, GLenum, GLenum, GLuint, GLint);
+  GLAPI void APIENTRY glFramebufferTexture2DEXT (GLenum, GLenum, GLenum, GLuint, GLint);
+  GLAPI void APIENTRY glFramebufferTexture3DEXT (GLenum, GLenum, GLenum, GLuint, GLint, GLint);
+  GLAPI void APIENTRY glFramebufferRenderbufferEXT (GLenum, GLenum, GLenum, GLuint);
+  GLAPI void APIENTRY glGetFramebufferAttachmentParameterivEXT (GLenum, GLenum, GLenum, GLint *);
+  GLAPI void APIENTRY glGenerateMipmapEXT (GLenum);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef GLboolean (APIENTRYP PFNGLISRENDERBUFFEREXTPROC) (GLuint renderbuffer);
+  typedef void (APIENTRYP PFNGLBINDRENDERBUFFEREXTPROC) (GLenum target, GLuint renderbuffer);
+  typedef void (APIENTRYP PFNGLDELETERENDERBUFFERSEXTPROC) (GLsizei n, const GLuint *renderbuffers);
+  typedef void (APIENTRYP PFNGLGENRENDERBUFFERSEXTPROC) (GLsizei n, GLuint *renderbuffers);
+  typedef void (APIENTRYP PFNGLRENDERBUFFERSTORAGEEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
+  typedef void (APIENTRYP PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC) (GLenum target, GLenum pname, GLint *params);
+  typedef GLboolean (APIENTRYP PFNGLISFRAMEBUFFEREXTPROC) (GLuint framebuffer);
+  typedef void (APIENTRYP PFNGLBINDFRAMEBUFFEREXTPROC) (GLenum target, GLuint framebuffer);
+  typedef void (APIENTRYP PFNGLDELETEFRAMEBUFFERSEXTPROC) (GLsizei n, const GLuint *framebuffers);
+  typedef void (APIENTRYP PFNGLGENFRAMEBUFFERSEXTPROC) (GLsizei n, GLuint *framebuffers);
+  typedef GLenum (APIENTRYP PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC) (GLenum target);
+  typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE1DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
+  typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE2DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
+  typedef void (APIENTRYP PFNGLFRAMEBUFFERTEXTURE3DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset);
+  typedef void (APIENTRYP PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC) (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
+  typedef void (APIENTRYP PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC) (GLenum target, GLenum attachment, GLenum pname, GLint *params);
+  typedef void (APIENTRYP PFNGLGENERATEMIPMAPEXTPROC) (GLenum target);
+#endif
+
+#ifndef GL_GREMEDY_string_marker
+#define GL_GREMEDY_string_marker 1
+#ifdef GL_GLEXT_PROTOTYPES
+  GLAPI void APIENTRY glStringMarkerGREMEDY (GLsizei, const GLvoid *);
+#endif /* GL_GLEXT_PROTOTYPES */
+  typedef void (APIENTRYP PFNGLSTRINGMARKERGREMEDYPROC) (GLsizei len, const GLvoid *string);
+#endif
+
+#ifndef GL_EXT_Cg_shader
+#define GL_EXT_Cg_shader 1
+#endif
+
+#ifndef GL_NV_element_array
+#define GL_NV_element_array 1
+#ifdef GL_GLEXT_PROTOTYPES
+  extern void APIENTRY glElementPointerNV(GLenum type, const GLvoid *pointer);
+  extern void APIENTRY glDrawElementArrayNV(GLenum mode, GLint first, GLsizei count);
+  extern void APIENTRY glDrawRangeElementArrayNV(GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
+  extern void APIENTRY glMultiDrawElementArrayNV(GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount);
+  extern void APIENTRY glMultiDrawRangeElementArrayNV(GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount);
+#endif
+  typedef void (APIENTRY * PFNGLELEMENTPOINTERNVPROC) (GLenum type, const GLvoid *pointer);
+  typedef void (APIENTRY * PFNGLDRAWELEMENTARRAYNVPROC) (GLenum mode, GLint first, GLsizei count);
+  typedef void (APIENTRY * PFNGLDRAWRANGEELEMENTARRAYNVPROC) (GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
+  typedef void (APIENTRY * PFNGLMULTIDRAWELEMENTARRAYNVPROC) (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount);
+  typedef void (APIENTRY * PFNGLMULTIDRAWRANGEELEMENTARRAYNVPROC) (GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount);
+#endif
+
+#ifndef GL_NV_pixel_buffer_object
+#define GL_NV_pixel_buffer_object 1
+#endif
+
+#ifndef GL_NV_stencil_two_side
+#define GL_NV_stencil_two_side 1
+#ifdef GL_GLEXT_PROTOTYPES
+  extern void APIENTRY glActiveStencilFaceNV(GLenum face);
+#endif
+  typedef void (APIENTRY * PFNGLACTIVESTENCILFACENVPROC) (GLenum face);
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/opengl/wglext.h 8.2.0~beta1-1~exp1/src/opengl/wglext.h
--- 8.0.1-5/src/opengl/wglext.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/opengl/wglext.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,662 @@
+#ifndef __wglext_h_
+#define __wglext_h_
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+  /*
+  ** License Applicability. Except to the extent portions of this file are
+  ** made subject to an alternative license as permitted in the SGI Free
+  ** Software License B, Version 1.1 (the "License"), the contents of this
+  ** file are subject only to the provisions of the License. You may not use
+  ** this file except in compliance with the License. You may obtain a copy
+  ** of the License at Silicon Graphics, Inc., attn: Legal Services, 1600
+  ** Amphitheatre Parkway, Mountain View, CA 94043-1351, or at:
+  **
+  ** http://oss.sgi.com/projects/FreeB
+  **
+  ** Note that, as provided in the License, the Software is distributed on an
+  ** "AS IS" basis, with ALL EXPRESS AND IMPLIED WARRANTIES AND CONDITIONS
+  ** DISCLAIMED, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES AND
+  ** CONDITIONS OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A
+  ** PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
+  **
+  ** Original Code. The Original Code is: OpenGL Sample Implementation,
+  ** Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
+  ** Inc. The Original Code is Copyright (c) 1991-2004 Silicon Graphics, Inc.
+  ** Copyright in any portions created by third parties is as indicated
+  ** elsewhere herein. All Rights Reserved.
+  **
+  ** Additional Notice Provisions: This software was created using the
+  ** OpenGL(R) version 1.2.1 Sample Implementation published by SGI, but has
+  ** not been independently verified as being compliant with the OpenGL(R)
+  ** version 1.2.1 Specification.
+  */
+
+#if defined(_WIN32) && !defined(APIENTRY) && !defined(__CYGWIN__) && !defined(__SCITECH_SNAP__)
+#define WIN32_LEAN_AND_MEAN 1
+#include <windows.h>
+#endif
+
+#ifndef APIENTRY
+#define APIENTRY
+#endif
+#ifndef APIENTRYP
+#define APIENTRYP APIENTRY *
+#endif
+#ifndef GLAPI
+#define GLAPI extern
+#endif
+
+  /*************************************************************/
+
+  /* Header file version number */
+  /* wglext.h last updated 2005/01/07 */
+  /* Current version at http://oss.sgi.com/projects/ogl-sample/registry/ */
+#define WGL_WGLEXT_VERSION 6
+
+#ifndef WGL_ARB_buffer_region
+#define WGL_FRONT_COLOR_BUFFER_BIT_ARB 0x00000001
+#define WGL_BACK_COLOR_BUFFER_BIT_ARB  0x00000002
+#define WGL_DEPTH_BUFFER_BIT_ARB       0x00000004
+#define WGL_STENCIL_BUFFER_BIT_ARB     0x00000008
+#endif
+
+#ifndef WGL_ARB_multisample
+#define WGL_SAMPLE_BUFFERS_ARB         0x2041
+#define WGL_SAMPLES_ARB                0x2042
+#endif
+
+#ifndef WGL_ARB_extensions_string
+#endif
+
+#ifndef WGL_ARB_pixel_format
+#define WGL_NUMBER_PIXEL_FORMATS_ARB   0x2000
+#define WGL_DRAW_TO_WINDOW_ARB         0x2001
+#define WGL_DRAW_TO_BITMAP_ARB         0x2002
+#define WGL_ACCELERATION_ARB           0x2003
+#define WGL_NEED_PALETTE_ARB           0x2004
+#define WGL_NEED_SYSTEM_PALETTE_ARB    0x2005
+#define WGL_SWAP_LAYER_BUFFERS_ARB     0x2006
+#define WGL_SWAP_METHOD_ARB            0x2007
+#define WGL_NUMBER_OVERLAYS_ARB        0x2008
+#define WGL_NUMBER_UNDERLAYS_ARB       0x2009
+#define WGL_TRANSPARENT_ARB            0x200A
+#define WGL_TRANSPARENT_RED_VALUE_ARB  0x2037
+#define WGL_TRANSPARENT_GREEN_VALUE_ARB 0x2038
+#define WGL_TRANSPARENT_BLUE_VALUE_ARB 0x2039
+#define WGL_TRANSPARENT_ALPHA_VALUE_ARB 0x203A
+#define WGL_TRANSPARENT_INDEX_VALUE_ARB 0x203B
+#define WGL_SHARE_DEPTH_ARB            0x200C
+#define WGL_SHARE_STENCIL_ARB          0x200D
+#define WGL_SHARE_ACCUM_ARB            0x200E
+#define WGL_SUPPORT_GDI_ARB            0x200F
+#define WGL_SUPPORT_OPENGL_ARB         0x2010
+#define WGL_DOUBLE_BUFFER_ARB          0x2011
+#define WGL_STEREO_ARB                 0x2012
+#define WGL_PIXEL_TYPE_ARB             0x2013
+#define WGL_COLOR_BITS_ARB             0x2014
+#define WGL_RED_BITS_ARB               0x2015
+#define WGL_RED_SHIFT_ARB              0x2016
+#define WGL_GREEN_BITS_ARB             0x2017
+#define WGL_GREEN_SHIFT_ARB            0x2018
+#define WGL_BLUE_BITS_ARB              0x2019
+#define WGL_BLUE_SHIFT_ARB             0x201A
+#define WGL_ALPHA_BITS_ARB             0x201B
+#define WGL_ALPHA_SHIFT_ARB            0x201C
+#define WGL_ACCUM_BITS_ARB             0x201D
+#define WGL_ACCUM_RED_BITS_ARB         0x201E
+#define WGL_ACCUM_GREEN_BITS_ARB       0x201F
+#define WGL_ACCUM_BLUE_BITS_ARB        0x2020
+#define WGL_ACCUM_ALPHA_BITS_ARB       0x2021
+#define WGL_DEPTH_BITS_ARB             0x2022
+#define WGL_STENCIL_BITS_ARB           0x2023
+#define WGL_AUX_BUFFERS_ARB            0x2024
+#define WGL_NO_ACCELERATION_ARB        0x2025
+#define WGL_GENERIC_ACCELERATION_ARB   0x2026
+#define WGL_FULL_ACCELERATION_ARB      0x2027
+#define WGL_SWAP_EXCHANGE_ARB          0x2028
+#define WGL_SWAP_COPY_ARB              0x2029
+#define WGL_SWAP_UNDEFINED_ARB         0x202A
+#define WGL_TYPE_RGBA_ARB              0x202B
+#define WGL_TYPE_COLORINDEX_ARB        0x202C
+#endif
+
+#ifndef WGL_ARB_make_current_read
+#define ERROR_INVALID_PIXEL_TYPE_ARB   0x2043
+#define ERROR_INCOMPATIBLE_DEVICE_CONTEXTS_ARB 0x2054
+#endif
+
+#ifndef WGL_ARB_pbuffer
+#define WGL_DRAW_TO_PBUFFER_ARB        0x202D
+#define WGL_MAX_PBUFFER_PIXELS_ARB     0x202E
+#define WGL_MAX_PBUFFER_WIDTH_ARB      0x202F
+#define WGL_MAX_PBUFFER_HEIGHT_ARB     0x2030
+#define WGL_PBUFFER_LARGEST_ARB        0x2033
+#define WGL_PBUFFER_WIDTH_ARB          0x2034
+#define WGL_PBUFFER_HEIGHT_ARB         0x2035
+#define WGL_PBUFFER_LOST_ARB           0x2036
+#endif
+
+#ifndef WGL_ARB_render_texture
+#define WGL_BIND_TO_TEXTURE_RGB_ARB    0x2070
+#define WGL_BIND_TO_TEXTURE_RGBA_ARB   0x2071
+#define WGL_TEXTURE_FORMAT_ARB         0x2072
+#define WGL_TEXTURE_TARGET_ARB         0x2073
+#define WGL_MIPMAP_TEXTURE_ARB         0x2074
+#define WGL_TEXTURE_RGB_ARB            0x2075
+#define WGL_TEXTURE_RGBA_ARB           0x2076
+#define WGL_NO_TEXTURE_ARB             0x2077
+#define WGL_TEXTURE_CUBE_MAP_ARB       0x2078
+#define WGL_TEXTURE_1D_ARB             0x2079
+#define WGL_TEXTURE_2D_ARB             0x207A
+#define WGL_MIPMAP_LEVEL_ARB           0x207B
+#define WGL_CUBE_MAP_FACE_ARB          0x207C
+#define WGL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB 0x207D
+#define WGL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB 0x207E
+#define WGL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB 0x207F
+#define WGL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB 0x2080
+#define WGL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB 0x2081
+#define WGL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB 0x2082
+#define WGL_FRONT_LEFT_ARB             0x2083
+#define WGL_FRONT_RIGHT_ARB            0x2084
+#define WGL_BACK_LEFT_ARB              0x2085
+#define WGL_BACK_RIGHT_ARB             0x2086
+#define WGL_AUX0_ARB                   0x2087
+#define WGL_AUX1_ARB                   0x2088
+#define WGL_AUX2_ARB                   0x2089
+#define WGL_AUX3_ARB                   0x208A
+#define WGL_AUX4_ARB                   0x208B
+#define WGL_AUX5_ARB                   0x208C
+#define WGL_AUX6_ARB                   0x208D
+#define WGL_AUX7_ARB                   0x208E
+#define WGL_AUX8_ARB                   0x208F
+#define WGL_AUX9_ARB                   0x2090
+#endif
+
+#ifndef WGL_ARB_pixel_format_float
+#define WGL_TYPE_RGBA_FLOAT_ARB        0x21A0
+#endif
+
+#ifndef WGL_EXT_make_current_read
+#define ERROR_INVALID_PIXEL_TYPE_EXT   0x2043
+#endif
+
+#ifndef WGL_EXT_pixel_format
+#define WGL_NUMBER_PIXEL_FORMATS_EXT   0x2000
+#define WGL_DRAW_TO_WINDOW_EXT         0x2001
+#define WGL_DRAW_TO_BITMAP_EXT         0x2002
+#define WGL_ACCELERATION_EXT           0x2003
+#define WGL_NEED_PALETTE_EXT           0x2004
+#define WGL_NEED_SYSTEM_PALETTE_EXT    0x2005
+#define WGL_SWAP_LAYER_BUFFERS_EXT     0x2006
+#define WGL_SWAP_METHOD_EXT            0x2007
+#define WGL_NUMBER_OVERLAYS_EXT        0x2008
+#define WGL_NUMBER_UNDERLAYS_EXT       0x2009
+#define WGL_TRANSPARENT_EXT            0x200A
+#define WGL_TRANSPARENT_VALUE_EXT      0x200B
+#define WGL_SHARE_DEPTH_EXT            0x200C
+#define WGL_SHARE_STENCIL_EXT          0x200D
+#define WGL_SHARE_ACCUM_EXT            0x200E
+#define WGL_SUPPORT_GDI_EXT            0x200F
+#define WGL_SUPPORT_OPENGL_EXT         0x2010
+#define WGL_DOUBLE_BUFFER_EXT          0x2011
+#define WGL_STEREO_EXT                 0x2012
+#define WGL_PIXEL_TYPE_EXT             0x2013
+#define WGL_COLOR_BITS_EXT             0x2014
+#define WGL_RED_BITS_EXT               0x2015
+#define WGL_RED_SHIFT_EXT              0x2016
+#define WGL_GREEN_BITS_EXT             0x2017
+#define WGL_GREEN_SHIFT_EXT            0x2018
+#define WGL_BLUE_BITS_EXT              0x2019
+#define WGL_BLUE_SHIFT_EXT             0x201A
+#define WGL_ALPHA_BITS_EXT             0x201B
+#define WGL_ALPHA_SHIFT_EXT            0x201C
+#define WGL_ACCUM_BITS_EXT             0x201D
+#define WGL_ACCUM_RED_BITS_EXT         0x201E
+#define WGL_ACCUM_GREEN_BITS_EXT       0x201F
+#define WGL_ACCUM_BLUE_BITS_EXT        0x2020
+#define WGL_ACCUM_ALPHA_BITS_EXT       0x2021
+#define WGL_DEPTH_BITS_EXT             0x2022
+#define WGL_STENCIL_BITS_EXT           0x2023
+#define WGL_AUX_BUFFERS_EXT            0x2024
+#define WGL_NO_ACCELERATION_EXT        0x2025
+#define WGL_GENERIC_ACCELERATION_EXT   0x2026
+#define WGL_FULL_ACCELERATION_EXT      0x2027
+#define WGL_SWAP_EXCHANGE_EXT          0x2028
+#define WGL_SWAP_COPY_EXT              0x2029
+#define WGL_SWAP_UNDEFINED_EXT         0x202A
+#define WGL_TYPE_RGBA_EXT              0x202B
+#define WGL_TYPE_COLORINDEX_EXT        0x202C
+#endif
+
+#ifndef WGL_EXT_pbuffer
+#define WGL_DRAW_TO_PBUFFER_EXT        0x202D
+#define WGL_MAX_PBUFFER_PIXELS_EXT     0x202E
+#define WGL_MAX_PBUFFER_WIDTH_EXT      0x202F
+#define WGL_MAX_PBUFFER_HEIGHT_EXT     0x2030
+#define WGL_OPTIMAL_PBUFFER_WIDTH_EXT  0x2031
+#define WGL_OPTIMAL_PBUFFER_HEIGHT_EXT 0x2032
+#define WGL_PBUFFER_LARGEST_EXT        0x2033
+#define WGL_PBUFFER_WIDTH_EXT          0x2034
+#define WGL_PBUFFER_HEIGHT_EXT         0x2035
+#endif
+
+#ifndef WGL_EXT_depth_float
+#define WGL_DEPTH_FLOAT_EXT            0x2040
+#endif
+
+#ifndef WGL_3DFX_multisample
+#define WGL_SAMPLE_BUFFERS_3DFX        0x2060
+#define WGL_SAMPLES_3DFX               0x2061
+#endif
+
+#ifndef WGL_EXT_multisample
+#define WGL_SAMPLE_BUFFERS_EXT         0x2041
+#define WGL_SAMPLES_EXT                0x2042
+#endif
+
+#ifndef WGL_I3D_digital_video_control
+#define WGL_DIGITAL_VIDEO_CURSOR_ALPHA_FRAMEBUFFER_I3D 0x2050
+#define WGL_DIGITAL_VIDEO_CURSOR_ALPHA_VALUE_I3D 0x2051
+#define WGL_DIGITAL_VIDEO_CURSOR_INCLUDED_I3D 0x2052
+#define WGL_DIGITAL_VIDEO_GAMMA_CORRECTED_I3D 0x2053
+#endif
+
+#ifndef WGL_I3D_gamma
+#define WGL_GAMMA_TABLE_SIZE_I3D       0x204E
+#define WGL_GAMMA_EXCLUDE_DESKTOP_I3D  0x204F
+#endif
+
+#ifndef WGL_I3D_genlock
+#define WGL_GENLOCK_SOURCE_MULTIVIEW_I3D 0x2044
+#define WGL_GENLOCK_SOURCE_EXTENAL_SYNC_I3D 0x2045
+#define WGL_GENLOCK_SOURCE_EXTENAL_FIELD_I3D 0x2046
+#define WGL_GENLOCK_SOURCE_EXTENAL_TTL_I3D 0x2047
+#define WGL_GENLOCK_SOURCE_DIGITAL_SYNC_I3D 0x2048
+#define WGL_GENLOCK_SOURCE_DIGITAL_FIELD_I3D 0x2049
+#define WGL_GENLOCK_SOURCE_EDGE_FALLING_I3D 0x204A
+#define WGL_GENLOCK_SOURCE_EDGE_RISING_I3D 0x204B
+#define WGL_GENLOCK_SOURCE_EDGE_BOTH_I3D 0x204C
+#endif
+
+#ifndef WGL_I3D_image_buffer
+#define WGL_IMAGE_BUFFER_MIN_ACCESS_I3D 0x00000001
+#define WGL_IMAGE_BUFFER_LOCK_I3D      0x00000002
+#endif
+
+#ifndef WGL_I3D_swap_frame_lock
+#endif
+
+#ifndef WGL_NV_render_depth_texture
+#define WGL_BIND_TO_TEXTURE_DEPTH_NV   0x20A3
+#define WGL_BIND_TO_TEXTURE_RECTANGLE_DEPTH_NV 0x20A4
+#define WGL_DEPTH_TEXTURE_FORMAT_NV    0x20A5
+#define WGL_TEXTURE_DEPTH_COMPONENT_NV 0x20A6
+#define WGL_DEPTH_COMPONENT_NV         0x20A7
+#endif
+
+#ifndef WGL_NV_render_texture_rectangle
+#define WGL_BIND_TO_TEXTURE_RECTANGLE_RGB_NV 0x20A0
+#define WGL_BIND_TO_TEXTURE_RECTANGLE_RGBA_NV 0x20A1
+#define WGL_TEXTURE_RECTANGLE_NV       0x20A2
+#endif
+
+#ifndef WGL_ATI_pixel_format_float
+#define WGL_TYPE_RGBA_FLOAT_ATI        0x21A0
+#define WGL_RGBA_FLOAT_MODE_ATI        0x8820
+#define WGL_COLOR_CLEAR_UNCLAMPED_VALUE_ATI 0x8835
+#endif
+
+#ifndef WGL_NV_float_buffer
+#define WGL_FLOAT_COMPONENTS_NV        0x20B0
+#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_R_NV 0x20B1
+#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_RG_NV 0x20B2
+#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_RGB_NV 0x20B3
+#define WGL_BIND_TO_TEXTURE_RECTANGLE_FLOAT_RGBA_NV 0x20B4
+#define WGL_TEXTURE_FLOAT_R_NV         0x20B5
+#define WGL_TEXTURE_FLOAT_RG_NV        0x20B6
+#define WGL_TEXTURE_FLOAT_RGB_NV       0x20B7
+#define WGL_TEXTURE_FLOAT_RGBA_NV      0x20B8
+#endif
+
+#ifndef WGL_NV_swap_group
+#endif
+
+
+  /*************************************************************/
+
+#ifndef WGL_ARB_pbuffer
+  DECLARE_HANDLE(HPBUFFERARB);
+#endif
+#ifndef WGL_EXT_pbuffer
+  DECLARE_HANDLE(HPBUFFEREXT);
+#endif
+
+#ifndef WGL_ARB_buffer_region
+#define WGL_ARB_buffer_region 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern HANDLE WINAPI wglCreateBufferRegionARB (HDC, int, UINT);
+  extern VOID WINAPI wglDeleteBufferRegionARB (HANDLE);
+  extern BOOL WINAPI wglSaveBufferRegionARB (HANDLE, int, int, int, int);
+  extern BOOL WINAPI wglRestoreBufferRegionARB (HANDLE, int, int, int, int, int, int);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef HANDLE (WINAPI * PFNWGLCREATEBUFFERREGIONARBPROC) (HDC hDC, int iLayerPlane, UINT uType);
+  typedef VOID (WINAPI * PFNWGLDELETEBUFFERREGIONARBPROC) (HANDLE hRegion);
+  typedef BOOL (WINAPI * PFNWGLSAVEBUFFERREGIONARBPROC) (HANDLE hRegion, int x, int y, int width, int height);
+  typedef BOOL (WINAPI * PFNWGLRESTOREBUFFERREGIONARBPROC) (HANDLE hRegion, int x, int y, int width, int height, int xSrc, int ySrc);
+#endif
+
+#ifndef WGL_ARB_multisample
+#define WGL_ARB_multisample 1
+#endif
+
+#ifndef WGL_ARB_extensions_string
+#define WGL_ARB_extensions_string 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern const char * WINAPI wglGetExtensionsStringARB (HDC);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef const char * (WINAPI * PFNWGLGETEXTENSIONSSTRINGARBPROC) (HDC hdc);
+#endif
+
+#ifndef WGL_ARB_pixel_format
+#define WGL_ARB_pixel_format 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglGetPixelFormatAttribivARB (HDC, int, int, UINT, const int *, int *);
+  extern BOOL WINAPI wglGetPixelFormatAttribfvARB (HDC, int, int, UINT, const int *, FLOAT *);
+  extern BOOL WINAPI wglChoosePixelFormatARB (HDC, const int *, const FLOAT *, UINT, int *, UINT *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBIVARBPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, const int *piAttributes, int *piValues);
+  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBFVARBPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, const int *piAttributes, FLOAT *pfValues);
+  typedef BOOL (WINAPI * PFNWGLCHOOSEPIXELFORMATARBPROC) (HDC hdc, const int *piAttribIList, const FLOAT *pfAttribFList, UINT nMaxFormats, int *piFormats, UINT *nNumFormats);
+#endif
+
+#ifndef WGL_ARB_make_current_read
+#define WGL_ARB_make_current_read 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglMakeContextCurrentARB (HDC, HDC, HGLRC);
+  extern HDC WINAPI wglGetCurrentReadDCARB (void);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLMAKECONTEXTCURRENTARBPROC) (HDC hDrawDC, HDC hReadDC, HGLRC hglrc);
+  typedef HDC (WINAPI * PFNWGLGETCURRENTREADDCARBPROC) (void);
+#endif
+
+#ifndef WGL_ARB_pbuffer
+#define WGL_ARB_pbuffer 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern HPBUFFERARB WINAPI wglCreatePbufferARB (HDC, int, int, int, const int *);
+  extern HDC WINAPI wglGetPbufferDCARB (HPBUFFERARB);
+  extern int WINAPI wglReleasePbufferDCARB (HPBUFFERARB, HDC);
+  extern BOOL WINAPI wglDestroyPbufferARB (HPBUFFERARB);
+  extern BOOL WINAPI wglQueryPbufferARB (HPBUFFERARB, int, int *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef HPBUFFERARB (WINAPI * PFNWGLCREATEPBUFFERARBPROC) (HDC hDC, int iPixelFormat, int iWidth, int iHeight, const int *piAttribList);
+  typedef HDC (WINAPI * PFNWGLGETPBUFFERDCARBPROC) (HPBUFFERARB hPbuffer);
+  typedef int (WINAPI * PFNWGLRELEASEPBUFFERDCARBPROC) (HPBUFFERARB hPbuffer, HDC hDC);
+  typedef BOOL (WINAPI * PFNWGLDESTROYPBUFFERARBPROC) (HPBUFFERARB hPbuffer);
+  typedef BOOL (WINAPI * PFNWGLQUERYPBUFFERARBPROC) (HPBUFFERARB hPbuffer, int iAttribute, int *piValue);
+#endif
+
+#ifndef WGL_ARB_render_texture
+#define WGL_ARB_render_texture 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglBindTexImageARB (HPBUFFERARB, int);
+  extern BOOL WINAPI wglReleaseTexImageARB (HPBUFFERARB, int);
+  extern BOOL WINAPI wglSetPbufferAttribARB (HPBUFFERARB, const int *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLBINDTEXIMAGEARBPROC) (HPBUFFERARB hPbuffer, int iBuffer);
+  typedef BOOL (WINAPI * PFNWGLRELEASETEXIMAGEARBPROC) (HPBUFFERARB hPbuffer, int iBuffer);
+  typedef BOOL (WINAPI * PFNWGLSETPBUFFERATTRIBARBPROC) (HPBUFFERARB hPbuffer, const int *piAttribList);
+#endif
+
+#ifndef WGL_ARB_pixel_format_float
+#define WGL_ARB_pixel_format_float 1
+#endif
+
+#ifndef WGL_EXT_display_color_table
+#define WGL_EXT_display_color_table 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern GLboolean WINAPI wglCreateDisplayColorTableEXT (GLushort);
+  extern GLboolean WINAPI wglLoadDisplayColorTableEXT (const GLushort *, GLuint);
+  extern GLboolean WINAPI wglBindDisplayColorTableEXT (GLushort);
+  extern VOID WINAPI wglDestroyDisplayColorTableEXT (GLushort);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef GLboolean (WINAPI * PFNWGLCREATEDISPLAYCOLORTABLEEXTPROC) (GLushort id);
+  typedef GLboolean (WINAPI * PFNWGLLOADDISPLAYCOLORTABLEEXTPROC) (const GLushort *table, GLuint length);
+  typedef GLboolean (WINAPI * PFNWGLBINDDISPLAYCOLORTABLEEXTPROC) (GLushort id);
+  typedef VOID (WINAPI * PFNWGLDESTROYDISPLAYCOLORTABLEEXTPROC) (GLushort id);
+#endif
+
+#ifndef WGL_EXT_extensions_string
+#define WGL_EXT_extensions_string 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern const char * WINAPI wglGetExtensionsStringEXT (void);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef const char * (WINAPI * PFNWGLGETEXTENSIONSSTRINGEXTPROC) (void);
+#endif
+
+#ifndef WGL_EXT_make_current_read
+#define WGL_EXT_make_current_read 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglMakeContextCurrentEXT (HDC, HDC, HGLRC);
+  extern HDC WINAPI wglGetCurrentReadDCEXT (void);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLMAKECONTEXTCURRENTEXTPROC) (HDC hDrawDC, HDC hReadDC, HGLRC hglrc);
+  typedef HDC (WINAPI * PFNWGLGETCURRENTREADDCEXTPROC) (void);
+#endif
+
+#ifndef WGL_EXT_pbuffer
+#define WGL_EXT_pbuffer 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern HPBUFFEREXT WINAPI wglCreatePbufferEXT (HDC, int, int, int, const int *);
+  extern HDC WINAPI wglGetPbufferDCEXT (HPBUFFEREXT);
+  extern int WINAPI wglReleasePbufferDCEXT (HPBUFFEREXT, HDC);
+  extern BOOL WINAPI wglDestroyPbufferEXT (HPBUFFEREXT);
+  extern BOOL WINAPI wglQueryPbufferEXT (HPBUFFEREXT, int, int *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef HPBUFFEREXT (WINAPI * PFNWGLCREATEPBUFFEREXTPROC) (HDC hDC, int iPixelFormat, int iWidth, int iHeight, const int *piAttribList);
+  typedef HDC (WINAPI * PFNWGLGETPBUFFERDCEXTPROC) (HPBUFFEREXT hPbuffer);
+  typedef int (WINAPI * PFNWGLRELEASEPBUFFERDCEXTPROC) (HPBUFFEREXT hPbuffer, HDC hDC);
+  typedef BOOL (WINAPI * PFNWGLDESTROYPBUFFEREXTPROC) (HPBUFFEREXT hPbuffer);
+  typedef BOOL (WINAPI * PFNWGLQUERYPBUFFEREXTPROC) (HPBUFFEREXT hPbuffer, int iAttribute, int *piValue);
+#endif
+
+#ifndef WGL_EXT_pixel_format
+#define WGL_EXT_pixel_format 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglGetPixelFormatAttribivEXT (HDC, int, int, UINT, int *, int *);
+  extern BOOL WINAPI wglGetPixelFormatAttribfvEXT (HDC, int, int, UINT, int *, FLOAT *);
+  extern BOOL WINAPI wglChoosePixelFormatEXT (HDC, const int *, const FLOAT *, UINT, int *, UINT *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBIVEXTPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, int *piValues);
+  typedef BOOL (WINAPI * PFNWGLGETPIXELFORMATATTRIBFVEXTPROC) (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, FLOAT *pfValues);
+  typedef BOOL (WINAPI * PFNWGLCHOOSEPIXELFORMATEXTPROC) (HDC hdc, const int *piAttribIList, const FLOAT *pfAttribFList, UINT nMaxFormats, int *piFormats, UINT *nNumFormats);
+#endif
+
+#ifndef WGL_EXT_swap_control
+#define WGL_EXT_swap_control 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglSwapIntervalEXT (int);
+  extern int WINAPI wglGetSwapIntervalEXT (void);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLSWAPINTERVALEXTPROC) (int interval);
+  typedef int (WINAPI * PFNWGLGETSWAPINTERVALEXTPROC) (void);
+#endif
+
+#ifndef WGL_EXT_depth_float
+#define WGL_EXT_depth_float 1
+#endif
+
+#ifndef WGL_NV_vertex_array_range
+#define WGL_NV_vertex_array_range 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern void* WINAPI wglAllocateMemoryNV (GLsizei, GLfloat, GLfloat, GLfloat);
+  extern void WINAPI wglFreeMemoryNV (void *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef void* (WINAPI * PFNWGLALLOCATEMEMORYNVPROC) (GLsizei size, GLfloat readfreq, GLfloat writefreq, GLfloat priority);
+  typedef void (WINAPI * PFNWGLFREEMEMORYNVPROC) (void *pointer);
+#endif
+
+#ifndef WGL_3DFX_multisample
+#define WGL_3DFX_multisample 1
+#endif
+
+#ifndef WGL_EXT_multisample
+#define WGL_EXT_multisample 1
+#endif
+
+#ifndef WGL_OML_sync_control
+#define WGL_OML_sync_control 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglGetSyncValuesOML (HDC, INT64 *, INT64 *, INT64 *);
+  extern BOOL WINAPI wglGetMscRateOML (HDC, INT32 *, INT32 *);
+  extern INT64 WINAPI wglSwapBuffersMscOML (HDC, INT64, INT64, INT64);
+  extern INT64 WINAPI wglSwapLayerBuffersMscOML (HDC, int, INT64, INT64, INT64);
+  extern BOOL WINAPI wglWaitForMscOML (HDC, INT64, INT64, INT64, INT64 *, INT64 *, INT64 *);
+  extern BOOL WINAPI wglWaitForSbcOML (HDC, INT64, INT64 *, INT64 *, INT64 *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLGETSYNCVALUESOMLPROC) (HDC hdc, INT64 *ust, INT64 *msc, INT64 *sbc);
+  typedef BOOL (WINAPI * PFNWGLGETMSCRATEOMLPROC) (HDC hdc, INT32 *numerator, INT32 *denominator);
+  typedef INT64 (WINAPI * PFNWGLSWAPBUFFERSMSCOMLPROC) (HDC hdc, INT64 target_msc, INT64 divisor, INT64 remainder);
+  typedef INT64 (WINAPI * PFNWGLSWAPLAYERBUFFERSMSCOMLPROC) (HDC hdc, int fuPlanes, INT64 target_msc, INT64 divisor, INT64 remainder);
+  typedef BOOL (WINAPI * PFNWGLWAITFORMSCOMLPROC) (HDC hdc, INT64 target_msc, INT64 divisor, INT64 remainder, INT64 *ust, INT64 *msc, INT64 *sbc);
+  typedef BOOL (WINAPI * PFNWGLWAITFORSBCOMLPROC) (HDC hdc, INT64 target_sbc, INT64 *ust, INT64 *msc, INT64 *sbc);
+#endif
+
+#ifndef WGL_I3D_digital_video_control
+#define WGL_I3D_digital_video_control 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglGetDigitalVideoParametersI3D (HDC, int, int *);
+  extern BOOL WINAPI wglSetDigitalVideoParametersI3D (HDC, int, const int *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLGETDIGITALVIDEOPARAMETERSI3DPROC) (HDC hDC, int iAttribute, int *piValue);
+  typedef BOOL (WINAPI * PFNWGLSETDIGITALVIDEOPARAMETERSI3DPROC) (HDC hDC, int iAttribute, const int *piValue);
+#endif
+
+#ifndef WGL_I3D_gamma
+#define WGL_I3D_gamma 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglGetGammaTableParametersI3D (HDC, int, int *);
+  extern BOOL WINAPI wglSetGammaTableParametersI3D (HDC, int, const int *);
+  extern BOOL WINAPI wglGetGammaTableI3D (HDC, int, USHORT *, USHORT *, USHORT *);
+  extern BOOL WINAPI wglSetGammaTableI3D (HDC, int, const USHORT *, const USHORT *, const USHORT *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLGETGAMMATABLEPARAMETERSI3DPROC) (HDC hDC, int iAttribute, int *piValue);
+  typedef BOOL (WINAPI * PFNWGLSETGAMMATABLEPARAMETERSI3DPROC) (HDC hDC, int iAttribute, const int *piValue);
+  typedef BOOL (WINAPI * PFNWGLGETGAMMATABLEI3DPROC) (HDC hDC, int iEntries, USHORT *puRed, USHORT *puGreen, USHORT *puBlue);
+  typedef BOOL (WINAPI * PFNWGLSETGAMMATABLEI3DPROC) (HDC hDC, int iEntries, const USHORT *puRed, const USHORT *puGreen, const USHORT *puBlue);
+#endif
+
+#ifndef WGL_I3D_genlock
+#define WGL_I3D_genlock 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglEnableGenlockI3D (HDC);
+  extern BOOL WINAPI wglDisableGenlockI3D (HDC);
+  extern BOOL WINAPI wglIsEnabledGenlockI3D (HDC, BOOL *);
+  extern BOOL WINAPI wglGenlockSourceI3D (HDC, UINT);
+  extern BOOL WINAPI wglGetGenlockSourceI3D (HDC, UINT *);
+  extern BOOL WINAPI wglGenlockSourceEdgeI3D (HDC, UINT);
+  extern BOOL WINAPI wglGetGenlockSourceEdgeI3D (HDC, UINT *);
+  extern BOOL WINAPI wglGenlockSampleRateI3D (HDC, UINT);
+  extern BOOL WINAPI wglGetGenlockSampleRateI3D (HDC, UINT *);
+  extern BOOL WINAPI wglGenlockSourceDelayI3D (HDC, UINT);
+  extern BOOL WINAPI wglGetGenlockSourceDelayI3D (HDC, UINT *);
+  extern BOOL WINAPI wglQueryGenlockMaxSourceDelayI3D (HDC, UINT *, UINT *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLENABLEGENLOCKI3DPROC) (HDC hDC);
+  typedef BOOL (WINAPI * PFNWGLDISABLEGENLOCKI3DPROC) (HDC hDC);
+  typedef BOOL (WINAPI * PFNWGLISENABLEDGENLOCKI3DPROC) (HDC hDC, BOOL *pFlag);
+  typedef BOOL (WINAPI * PFNWGLGENLOCKSOURCEI3DPROC) (HDC hDC, UINT uSource);
+  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSOURCEI3DPROC) (HDC hDC, UINT *uSource);
+  typedef BOOL (WINAPI * PFNWGLGENLOCKSOURCEEDGEI3DPROC) (HDC hDC, UINT uEdge);
+  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSOURCEEDGEI3DPROC) (HDC hDC, UINT *uEdge);
+  typedef BOOL (WINAPI * PFNWGLGENLOCKSAMPLERATEI3DPROC) (HDC hDC, UINT uRate);
+  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSAMPLERATEI3DPROC) (HDC hDC, UINT *uRate);
+  typedef BOOL (WINAPI * PFNWGLGENLOCKSOURCEDELAYI3DPROC) (HDC hDC, UINT uDelay);
+  typedef BOOL (WINAPI * PFNWGLGETGENLOCKSOURCEDELAYI3DPROC) (HDC hDC, UINT *uDelay);
+  typedef BOOL (WINAPI * PFNWGLQUERYGENLOCKMAXSOURCEDELAYI3DPROC) (HDC hDC, UINT *uMaxLineDelay, UINT *uMaxPixelDelay);
+#endif
+
+#ifndef WGL_I3D_image_buffer
+#define WGL_I3D_image_buffer 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern LPVOID WINAPI wglCreateImageBufferI3D (HDC, DWORD, UINT);
+  extern BOOL WINAPI wglDestroyImageBufferI3D (HDC, LPVOID);
+  extern BOOL WINAPI wglAssociateImageBufferEventsI3D (HDC, const HANDLE *, const LPVOID *, const DWORD *, UINT);
+  extern BOOL WINAPI wglReleaseImageBufferEventsI3D (HDC, const LPVOID *, UINT);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef LPVOID (WINAPI * PFNWGLCREATEIMAGEBUFFERI3DPROC) (HDC hDC, DWORD dwSize, UINT uFlags);
+  typedef BOOL (WINAPI * PFNWGLDESTROYIMAGEBUFFERI3DPROC) (HDC hDC, LPVOID pAddress);
+  typedef BOOL (WINAPI * PFNWGLASSOCIATEIMAGEBUFFEREVENTSI3DPROC) (HDC hDC, const HANDLE *pEvent, const LPVOID *pAddress, const DWORD *pSize, UINT count);
+  typedef BOOL (WINAPI * PFNWGLRELEASEIMAGEBUFFEREVENTSI3DPROC) (HDC hDC, const LPVOID *pAddress, UINT count);
+#endif
+
+#ifndef WGL_I3D_swap_frame_lock
+#define WGL_I3D_swap_frame_lock 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglEnableFrameLockI3D (void);
+  extern BOOL WINAPI wglDisableFrameLockI3D (void);
+  extern BOOL WINAPI wglIsEnabledFrameLockI3D (BOOL *);
+  extern BOOL WINAPI wglQueryFrameLockMasterI3D (BOOL *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLENABLEFRAMELOCKI3DPROC) (void);
+  typedef BOOL (WINAPI * PFNWGLDISABLEFRAMELOCKI3DPROC) (void);
+  typedef BOOL (WINAPI * PFNWGLISENABLEDFRAMELOCKI3DPROC) (BOOL *pFlag);
+  typedef BOOL (WINAPI * PFNWGLQUERYFRAMELOCKMASTERI3DPROC) (BOOL *pFlag);
+#endif
+
+#ifndef WGL_I3D_swap_frame_usage
+#define WGL_I3D_swap_frame_usage 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglGetFrameUsageI3D (float *);
+  extern BOOL WINAPI wglBeginFrameTrackingI3D (void);
+  extern BOOL WINAPI wglEndFrameTrackingI3D (void);
+  extern BOOL WINAPI wglQueryFrameTrackingI3D (DWORD *, DWORD *, float *);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLGETFRAMEUSAGEI3DPROC) (float *pUsage);
+  typedef BOOL (WINAPI * PFNWGLBEGINFRAMETRACKINGI3DPROC) (void);
+  typedef BOOL (WINAPI * PFNWGLENDFRAMETRACKINGI3DPROC) (void);
+  typedef BOOL (WINAPI * PFNWGLQUERYFRAMETRACKINGI3DPROC) (DWORD *pFrameCount, DWORD *pMissedFrames, float *pLastMissedUsage);
+#endif
+
+#ifndef WGL_ATI_pixel_format_float
+#define WGL_ATI_pixel_format_float 1
+#endif
+
+#ifndef WGL_NV_render_depth_texture
+#define WGL_NV_render_depth_texture 1
+#endif
+
+#ifndef WGL_NV_render_texture_rectangle
+#define WGL_NV_render_texture_rectangle 1
+#endif
+
+#ifndef WGL_NV_float_buffer
+#define WGL_NV_float_buffer 1
+#endif
+
+#ifndef WGL_NV_swap_group
+#define WGL_NV_swap_group 1
+#ifdef WGL_WGLEXT_PROTOTYPES
+  extern BOOL WINAPI wglJoinSwapGroupNV(HDC hDC, GLuint group);
+  extern BOOL WINAPI wglBindSwapBarrierNV(GLuint group, GLuint barrier);
+  extern BOOL WINAPI wglQuerySwapGroupNV(HDC hDC GLuint *group, GLuint *barrier);
+  extern BOOL WINAPI wglQueryMaxSwapGroupsNV(HDC hDC, GLuint *maxGroups, GLuint *maxBarriers);
+  extern BOOL WINAPI wglQueryFrameCountNV(HDC hDC, GLuint *count);
+  extern BOOL WINAPI wglResetFrameCountNV(HDC hDC);
+#endif /* WGL_WGLEXT_PROTOTYPES */
+  typedef BOOL (WINAPI * PFNWGLJOINSWAPGROUPNVPROC) (HDC hDC, GLuint group);
+  typedef BOOL (WINAPI * PFNWGLBINDSWAPBARRIERNVPROC) (GLuint group, GLuint barrier);
+  typedef BOOL (WINAPI * PFNWGLQUERYSWAPGROUPNVPROC) (HDC hDC, GLuint *group, GLuint *barrier);
+  typedef BOOL (WINAPI * PFNWGLQUERYMAXSWAPGROUPSNVPROC) (HDC hDC, GLuint *maxGroups, GLuint *maxBarriers);
+  typedef BOOL (WINAPI * PFNWGLQUERYFRAMECOUNTNVPROC) (HDC hDC, GLuint *count);
+  typedef BOOL (WINAPI * PFNWGLRESETFRAMECOUNTNVPROC) (HDC hDC);
+#endif
+
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/LICENSE 8.2.0~beta1-1~exp1/src/renderers/agg/LICENSE
--- 8.0.1-5/src/renderers/agg/LICENSE	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/LICENSE	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,12 @@
+The Anti-Grain Geometry Project
+A high quality rendering engine for C++
+http://antigrain.com
+
+Anti-Grain Geometry - Version 2.4
+Copyright (C) 2002-2005 Maxim Shemanarev (McSeem)
+
+Permission to copy, use, modify, sell and distribute this software
+is granted provided this copyright notice appears in all copies.
+This software is provided "as is" without express or implied
+warranty, and with no claim as to its suitability for any purpose.
+
diff -pruN 8.0.1-5/src/renderers/agg/authors 8.2.0~beta1-1~exp1/src/renderers/agg/authors
--- 8.0.1-5/src/renderers/agg/authors	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/authors	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2 @@
+Anti-Grain Geometry - Version 2.4
+Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
diff -pruN 8.0.1-5/src/renderers/agg/copying 8.2.0~beta1-1~exp1/src/renderers/agg/copying
--- 8.0.1-5/src/renderers/agg/copying	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/copying	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,65 @@
+The Anti-Grain Geometry Project
+A high quality rendering engine for C++
+http://antigrain.com
+
+Anti-Grain Geometry has dual licensing model. The Modified BSD 
+License was first added in version v2.4 just for convenience.
+It is a simple, permissive non-copyleft free software license, 
+compatible with the GNU GPL. It's well proven and recognizable.
+See http://www.fsf.org/licensing/licenses/index_html#ModifiedBSD
+for details.
+
+Note that the Modified BSD license DOES NOT restrict your rights 
+if you choose the Anti-Grain Geometry Public License.
+
+
+
+
+Anti-Grain Geometry Public License
+====================================================
+
+Anti-Grain Geometry - Version 2.4 
+Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
+
+Permission to copy, use, modify, sell and distribute this software 
+is granted provided this copyright notice appears in all copies. 
+This software is provided "as is" without express or implied
+warranty, and with no claim as to its suitability for any purpose.
+
+
+
+
+
+Modified BSD License
+====================================================
+Anti-Grain Geometry - Version 2.4 
+Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
+
+Redistribution and use in source and binary forms, with or without 
+modification, are permitted provided that the following conditions 
+are met:
+
+  1. Redistributions of source code must retain the above copyright 
+     notice, this list of conditions and the following disclaimer. 
+
+  2. Redistributions in binary form must reproduce the above copyright
+     notice, this list of conditions and the following disclaimer in 
+     the documentation and/or other materials provided with the 
+     distribution. 
+
+  3. The name of the author may not be used to endorse or promote 
+     products derived from this software without specific prior 
+     written permission. 
+
+THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
+IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
+WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
+ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
+INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
+(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
+SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
+HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
+STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
+IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
+POSSIBILITY OF SUCH DAMAGE.
+
diff -pruN 8.0.1-5/src/renderers/agg/include/Makefile.am 8.2.0~beta1-1~exp1/src/renderers/agg/include/Makefile.am
--- 8.0.1-5/src/renderers/agg/include/Makefile.am	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/Makefile.am	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,47 @@
+SUBDIRS = ctrl util platform 
+
+aggincludedir = $(includedir)/agg2
+agginclude_HEADERS = \
+	agg_alpha_mask_u8.h          agg_glyph_raster_bin.h          agg_span_allocator.h \
+	agg_arc.h                    agg_gsv_text.h                  agg_span_converter.h \
+	agg_array.h                  agg_image_accessors.h           agg_span_gouraud.h \
+	agg_arrowhead.h              agg_image_filters.h             agg_span_gouraud_gray.h \
+	agg_basics.h                 agg_line_aa_basics.h            agg_span_gouraud_rgba.h \
+	agg_bezier_arc.h             agg_math.h                      agg_span_gradient.h \
+	agg_bitset_iterator.h        agg_blur.h                      agg_math_stroke.h \
+	agg_span_gradient_alpha.h    agg_gradient_lut.h \
+	agg_bounding_rect.h          agg_path_length.h               agg_span_image_filter.h \
+	agg_bspline.h                agg_path_storage.h              agg_span_image_filter_gray.h \
+	agg_clip_liang_barsky.h      agg_path_storage_integer.h      agg_span_image_filter_rgb.h \
+	agg_color_gray.h             agg_pattern_filters_rgba.h      agg_span_image_filter_rgba.h \
+	agg_color_rgba.h             agg_pixfmt_amask_adaptor.h      agg_span_interpolator_adaptor.h \
+	agg_config.h                 agg_pixfmt_gray.h               agg_span_interpolator_linear.h \
+	agg_conv_adaptor_vcgen.h     agg_pixfmt_rgb.h                agg_span_interpolator_persp.h \
+	agg_conv_adaptor_vpgen.h     agg_pixfmt_rgb_packed.h         agg_span_interpolator_trans.h \
+	agg_conv_bspline.h           agg_pixfmt_rgba.h               agg_pixfmt_transposer.h \
+	agg_span_pattern_gray.h \
+	agg_conv_clip_polygon.h      agg_rasterizer_cells_aa.h       agg_span_pattern_rgb.h \
+	agg_conv_clip_polyline.h     agg_rasterizer_compound_aa.h    agg_span_pattern_rgba.h \
+	agg_conv_close_polygon.h     agg_rasterizer_outline.h        agg_span_solid.h \
+	agg_conv_concat.h            agg_rasterizer_outline_aa.h     agg_span_subdiv_adaptor.h \
+	agg_conv_contour.h           agg_rasterizer_scanline_aa.h    agg_trans_affine.h \
+	agg_conv_curve.h             agg_rasterizer_sl_clip.h        agg_trans_bilinear.h \
+	agg_conv_dash.h              agg_renderer_base.h             agg_trans_double_path.h \
+	agg_conv_gpc.h               agg_renderer_markers.h \
+	agg_conv_marker.h            agg_renderer_mclip.h            agg_trans_perspective.h \
+	agg_conv_marker_adaptor.h    agg_renderer_outline_aa.h       agg_trans_single_path.h \
+	agg_conv_segmentator.h       agg_renderer_outline_image.h    agg_trans_viewport.h \
+	agg_conv_shorten_path.h      agg_renderer_primitives.h       agg_trans_warp_magnifier.h \
+	agg_conv_smooth_poly1.h      agg_renderer_raster_text.h      agg_vcgen_bspline.h \
+	agg_conv_stroke.h            agg_renderer_scanline.h         agg_vcgen_contour.h \
+	agg_conv_transform.h         agg_rendering_buffer.h          agg_vcgen_dash.h \
+	agg_conv_unclose_polygon.h   agg_rendering_buffer_dynarow.h  agg_vcgen_markers_term.h \
+	agg_curves.h                 agg_rounded_rect.h              agg_vcgen_smooth_poly1.h \
+	                             agg_scanline_bin.h              agg_vcgen_stroke.h \
+	agg_dda_line.h               agg_scanline_boolean_algebra.h  agg_vcgen_vertex_sequence.h \
+	agg_ellipse.h                agg_scanline_p.h                agg_vertex_sequence.h \
+	agg_ellipse_bresenham.h      agg_scanline_storage_aa.h       agg_vpgen_clip_polygon.h \
+	agg_embedded_raster_fonts.h  agg_scanline_storage_bin.h      agg_vpgen_clip_polyline.h \
+	agg_font_cache_manager.h     agg_scanline_u.h                agg_vpgen_segmentator.h \
+	agg_gamma_functions.h        agg_shorten_path.h \
+	agg_gamma_lut.h              agg_simul_eq.h
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_alpha_mask_u8.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_alpha_mask_u8.h
--- 8.0.1-5/src/renderers/agg/include/agg_alpha_mask_u8.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_alpha_mask_u8.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,499 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// scanline_u8 class
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_ALPHA_MASK_U8_INCLUDED
+#define AGG_ALPHA_MASK_U8_INCLUDED
+
+#include <string.h>
+#include "agg_basics.h"
+#include "agg_rendering_buffer.h"
+
+namespace mapserver
+{
+    //===================================================one_component_mask_u8
+    struct one_component_mask_u8
+    {
+        static unsigned calculate(const int8u* p) { return *p; }
+    };
+    
+
+    //=====================================================rgb_to_gray_mask_u8
+    template<unsigned R, unsigned G, unsigned B>
+    struct rgb_to_gray_mask_u8
+    {
+        static unsigned calculate(const int8u* p) 
+        { 
+            return (p[R]*77 + p[G]*150 + p[B]*29) >> 8; 
+        }
+    };
+
+    //==========================================================alpha_mask_u8
+    template<unsigned Step=1, unsigned Offset=0, class MaskF=one_component_mask_u8>
+    class alpha_mask_u8
+    {
+    public:
+        typedef int8u cover_type;
+        typedef alpha_mask_u8<Step, Offset, MaskF> self_type;
+        enum cover_scale_e
+        { 
+            cover_shift = 8,
+            cover_none  = 0,
+            cover_full  = 255
+        };
+
+        alpha_mask_u8() : m_rbuf(0) {}
+        explicit alpha_mask_u8(rendering_buffer& rbuf) : m_rbuf(&rbuf) {}
+
+        void attach(rendering_buffer& rbuf) { m_rbuf = &rbuf; }
+
+        MaskF& mask_function() { return m_mask_function; }
+        const MaskF& mask_function() const { return m_mask_function; }
+
+        
+        //--------------------------------------------------------------------
+        cover_type pixel(int x, int y) const
+        {
+            if(x >= 0 && y >= 0 && 
+               x < (int)m_rbuf->width() && 
+               y < (int)m_rbuf->height())
+            {
+                return (cover_type)m_mask_function.calculate(
+                                        m_rbuf->row_ptr(y) + x * Step + Offset);
+            }
+            return 0;
+        }
+
+        //--------------------------------------------------------------------
+        cover_type combine_pixel(int x, int y, cover_type val) const
+        {
+            if(x >= 0 && y >= 0 && 
+               x < (int)m_rbuf->width() && 
+               y < (int)m_rbuf->height())
+            {
+                return (cover_type)((cover_full + val * 
+                                     m_mask_function.calculate(
+                                        m_rbuf->row_ptr(y) + x * Step + Offset)) >> 
+                                     cover_shift);
+            }
+            return 0;
+        }
+
+
+        //--------------------------------------------------------------------
+        void fill_hspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            int xmax = m_rbuf->width() - 1;
+            int ymax = m_rbuf->height() - 1;
+
+            int count = num_pix;
+            cover_type* covers = dst;
+
+            if(y < 0 || y > ymax)
+            {
+                memset(dst, 0, num_pix * sizeof(cover_type));
+                return;
+            }
+
+            if(x < 0)
+            {
+                count += x;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers, 0, -x * sizeof(cover_type));
+                covers -= x;
+                x = 0;
+            }
+
+            if(x + count > xmax)
+            {
+                int rest = x + count - xmax - 1;
+                count -= rest;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers + count, 0, rest * sizeof(cover_type));
+            }
+
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *covers++ = (cover_type)m_mask_function.calculate(mask);
+                mask += Step;
+            }
+            while(--count);
+        }
+
+
+        //--------------------------------------------------------------------
+        void combine_hspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            int xmax = m_rbuf->width() - 1;
+            int ymax = m_rbuf->height() - 1;
+
+            int count = num_pix;
+            cover_type* covers = dst;
+
+            if(y < 0 || y > ymax)
+            {
+                memset(dst, 0, num_pix * sizeof(cover_type));
+                return;
+            }
+
+            if(x < 0)
+            {
+                count += x;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers, 0, -x * sizeof(cover_type));
+                covers -= x;
+                x = 0;
+            }
+
+            if(x + count > xmax)
+            {
+                int rest = x + count - xmax - 1;
+                count -= rest;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers + count, 0, rest * sizeof(cover_type));
+            }
+
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *covers = (cover_type)((cover_full + (*covers) * 
+                                       m_mask_function.calculate(mask)) >> 
+                                       cover_shift);
+                ++covers;
+                mask += Step;
+            }
+            while(--count);
+        }
+
+        //--------------------------------------------------------------------
+        void fill_vspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            int xmax = m_rbuf->width() - 1;
+            int ymax = m_rbuf->height() - 1;
+
+            int count = num_pix;
+            cover_type* covers = dst;
+
+            if(x < 0 || x > xmax)
+            {
+                memset(dst, 0, num_pix * sizeof(cover_type));
+                return;
+            }
+
+            if(y < 0)
+            {
+                count += y;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers, 0, -y * sizeof(cover_type));
+                covers -= y;
+                y = 0;
+            }
+
+            if(y + count > ymax)
+            {
+                int rest = y + count - ymax - 1;
+                count -= rest;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers + count, 0, rest * sizeof(cover_type));
+            }
+
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *covers++ = (cover_type)m_mask_function.calculate(mask);
+                mask += m_rbuf->stride();
+            }
+            while(--count);
+        }
+
+        //--------------------------------------------------------------------
+        void combine_vspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            int xmax = m_rbuf->width() - 1;
+            int ymax = m_rbuf->height() - 1;
+
+            int count = num_pix;
+            cover_type* covers = dst;
+
+            if(x < 0 || x > xmax)
+            {
+                memset(dst, 0, num_pix * sizeof(cover_type));
+                return;
+            }
+
+            if(y < 0)
+            {
+                count += y;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers, 0, -y * sizeof(cover_type));
+                covers -= y;
+                y = 0;
+            }
+
+            if(y + count > ymax)
+            {
+                int rest = y + count - ymax - 1;
+                count -= rest;
+                if(count <= 0) 
+                {
+                    memset(dst, 0, num_pix * sizeof(cover_type));
+                    return;
+                }
+                memset(covers + count, 0, rest * sizeof(cover_type));
+            }
+
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *covers = (cover_type)((cover_full + (*covers) * 
+                                       m_mask_function.calculate(mask)) >> 
+                                       cover_shift);
+                ++covers;
+                mask += m_rbuf->stride();
+            }
+            while(--count);
+        }
+
+
+    private:
+        alpha_mask_u8(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        rendering_buffer* m_rbuf;
+        MaskF             m_mask_function;
+    };
+    
+
+    typedef alpha_mask_u8<1, 0> alpha_mask_gray8;   //----alpha_mask_gray8
+
+    typedef alpha_mask_u8<3, 0> alpha_mask_rgb24r;  //----alpha_mask_rgb24r
+    typedef alpha_mask_u8<3, 1> alpha_mask_rgb24g;  //----alpha_mask_rgb24g
+    typedef alpha_mask_u8<3, 2> alpha_mask_rgb24b;  //----alpha_mask_rgb24b
+
+    typedef alpha_mask_u8<3, 2> alpha_mask_bgr24r;  //----alpha_mask_bgr24r
+    typedef alpha_mask_u8<3, 1> alpha_mask_bgr24g;  //----alpha_mask_bgr24g
+    typedef alpha_mask_u8<3, 0> alpha_mask_bgr24b;  //----alpha_mask_bgr24b
+
+    typedef alpha_mask_u8<4, 0> alpha_mask_rgba32r; //----alpha_mask_rgba32r
+    typedef alpha_mask_u8<4, 1> alpha_mask_rgba32g; //----alpha_mask_rgba32g
+    typedef alpha_mask_u8<4, 2> alpha_mask_rgba32b; //----alpha_mask_rgba32b
+    typedef alpha_mask_u8<4, 3> alpha_mask_rgba32a; //----alpha_mask_rgba32a
+
+    typedef alpha_mask_u8<4, 1> alpha_mask_argb32r; //----alpha_mask_argb32r
+    typedef alpha_mask_u8<4, 2> alpha_mask_argb32g; //----alpha_mask_argb32g
+    typedef alpha_mask_u8<4, 3> alpha_mask_argb32b; //----alpha_mask_argb32b
+    typedef alpha_mask_u8<4, 0> alpha_mask_argb32a; //----alpha_mask_argb32a
+
+    typedef alpha_mask_u8<4, 2> alpha_mask_bgra32r; //----alpha_mask_bgra32r
+    typedef alpha_mask_u8<4, 1> alpha_mask_bgra32g; //----alpha_mask_bgra32g
+    typedef alpha_mask_u8<4, 0> alpha_mask_bgra32b; //----alpha_mask_bgra32b
+    typedef alpha_mask_u8<4, 3> alpha_mask_bgra32a; //----alpha_mask_bgra32a
+
+    typedef alpha_mask_u8<4, 3> alpha_mask_abgr32r; //----alpha_mask_abgr32r
+    typedef alpha_mask_u8<4, 2> alpha_mask_abgr32g; //----alpha_mask_abgr32g
+    typedef alpha_mask_u8<4, 1> alpha_mask_abgr32b; //----alpha_mask_abgr32b
+    typedef alpha_mask_u8<4, 0> alpha_mask_abgr32a; //----alpha_mask_abgr32a
+
+    typedef alpha_mask_u8<3, 0, rgb_to_gray_mask_u8<0, 1, 2> > alpha_mask_rgb24gray;  //----alpha_mask_rgb24gray
+    typedef alpha_mask_u8<3, 0, rgb_to_gray_mask_u8<2, 1, 0> > alpha_mask_bgr24gray;  //----alpha_mask_bgr24gray
+    typedef alpha_mask_u8<4, 0, rgb_to_gray_mask_u8<0, 1, 2> > alpha_mask_rgba32gray; //----alpha_mask_rgba32gray
+    typedef alpha_mask_u8<4, 1, rgb_to_gray_mask_u8<0, 1, 2> > alpha_mask_argb32gray; //----alpha_mask_argb32gray
+    typedef alpha_mask_u8<4, 0, rgb_to_gray_mask_u8<2, 1, 0> > alpha_mask_bgra32gray; //----alpha_mask_bgra32gray
+    typedef alpha_mask_u8<4, 1, rgb_to_gray_mask_u8<2, 1, 0> > alpha_mask_abgr32gray; //----alpha_mask_abgr32gray
+
+
+
+    //==========================================================amask_no_clip_u8
+    template<unsigned Step=1, unsigned Offset=0, class MaskF=one_component_mask_u8>
+    class amask_no_clip_u8
+    {
+    public:
+        typedef int8u cover_type;
+        typedef amask_no_clip_u8<Step, Offset, MaskF> self_type;
+        enum cover_scale_e
+        { 
+            cover_shift = 8,
+            cover_none  = 0,
+            cover_full  = 255
+        };
+
+        amask_no_clip_u8() : m_rbuf(0) {}
+        explicit amask_no_clip_u8(rendering_buffer& rbuf) : m_rbuf(&rbuf) {}
+
+        void attach(rendering_buffer& rbuf) { m_rbuf = &rbuf; }
+
+        MaskF& mask_function() { return m_mask_function; }
+        const MaskF& mask_function() const { return m_mask_function; }
+
+
+        //--------------------------------------------------------------------
+        cover_type pixel(int x, int y) const
+        {
+            return (cover_type)m_mask_function.calculate(
+                                   m_rbuf->row_ptr(y) + x * Step + Offset);
+        }
+
+        
+        //--------------------------------------------------------------------
+        cover_type combine_pixel(int x, int y, cover_type val) const
+        {
+            return (cover_type)((cover_full + val * 
+                                 m_mask_function.calculate(
+                                    m_rbuf->row_ptr(y) + x * Step + Offset)) >> 
+                                 cover_shift);
+        }
+
+
+        //--------------------------------------------------------------------
+        void fill_hspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *dst++ = (cover_type)m_mask_function.calculate(mask);
+                mask += Step;
+            }
+            while(--num_pix);
+        }
+
+
+
+        //--------------------------------------------------------------------
+        void combine_hspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *dst = (cover_type)((cover_full + (*dst) * 
+                                    m_mask_function.calculate(mask)) >> 
+                                    cover_shift);
+                ++dst;
+                mask += Step;
+            }
+            while(--num_pix);
+        }
+
+
+        //--------------------------------------------------------------------
+        void fill_vspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *dst++ = (cover_type)m_mask_function.calculate(mask);
+                mask += m_rbuf->stride();
+            }
+            while(--num_pix);
+        }
+
+
+        //--------------------------------------------------------------------
+        void combine_vspan(int x, int y, cover_type* dst, int num_pix) const
+        {
+            const int8u* mask = m_rbuf->row_ptr(y) + x * Step + Offset;
+            do
+            {
+                *dst = (cover_type)((cover_full + (*dst) * 
+                                    m_mask_function.calculate(mask)) >> 
+                                    cover_shift);
+                ++dst;
+                mask += m_rbuf->stride();
+            }
+            while(--num_pix);
+        }
+
+    private:
+        amask_no_clip_u8(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        rendering_buffer* m_rbuf;
+        MaskF             m_mask_function;
+    };
+    
+
+    typedef amask_no_clip_u8<1, 0> amask_no_clip_gray8;   //----amask_no_clip_gray8
+
+    typedef amask_no_clip_u8<3, 0> amask_no_clip_rgb24r;  //----amask_no_clip_rgb24r
+    typedef amask_no_clip_u8<3, 1> amask_no_clip_rgb24g;  //----amask_no_clip_rgb24g
+    typedef amask_no_clip_u8<3, 2> amask_no_clip_rgb24b;  //----amask_no_clip_rgb24b
+
+    typedef amask_no_clip_u8<3, 2> amask_no_clip_bgr24r;  //----amask_no_clip_bgr24r
+    typedef amask_no_clip_u8<3, 1> amask_no_clip_bgr24g;  //----amask_no_clip_bgr24g
+    typedef amask_no_clip_u8<3, 0> amask_no_clip_bgr24b;  //----amask_no_clip_bgr24b
+
+    typedef amask_no_clip_u8<4, 0> amask_no_clip_rgba32r; //----amask_no_clip_rgba32r
+    typedef amask_no_clip_u8<4, 1> amask_no_clip_rgba32g; //----amask_no_clip_rgba32g
+    typedef amask_no_clip_u8<4, 2> amask_no_clip_rgba32b; //----amask_no_clip_rgba32b
+    typedef amask_no_clip_u8<4, 3> amask_no_clip_rgba32a; //----amask_no_clip_rgba32a
+
+    typedef amask_no_clip_u8<4, 1> amask_no_clip_argb32r; //----amask_no_clip_argb32r
+    typedef amask_no_clip_u8<4, 2> amask_no_clip_argb32g; //----amask_no_clip_argb32g
+    typedef amask_no_clip_u8<4, 3> amask_no_clip_argb32b; //----amask_no_clip_argb32b
+    typedef amask_no_clip_u8<4, 0> amask_no_clip_argb32a; //----amask_no_clip_argb32a
+
+    typedef amask_no_clip_u8<4, 2> amask_no_clip_bgra32r; //----amask_no_clip_bgra32r
+    typedef amask_no_clip_u8<4, 1> amask_no_clip_bgra32g; //----amask_no_clip_bgra32g
+    typedef amask_no_clip_u8<4, 0> amask_no_clip_bgra32b; //----amask_no_clip_bgra32b
+    typedef amask_no_clip_u8<4, 3> amask_no_clip_bgra32a; //----amask_no_clip_bgra32a
+
+    typedef amask_no_clip_u8<4, 3> amask_no_clip_abgr32r; //----amask_no_clip_abgr32r
+    typedef amask_no_clip_u8<4, 2> amask_no_clip_abgr32g; //----amask_no_clip_abgr32g
+    typedef amask_no_clip_u8<4, 1> amask_no_clip_abgr32b; //----amask_no_clip_abgr32b
+    typedef amask_no_clip_u8<4, 0> amask_no_clip_abgr32a; //----amask_no_clip_abgr32a
+
+    typedef amask_no_clip_u8<3, 0, rgb_to_gray_mask_u8<0, 1, 2> > amask_no_clip_rgb24gray;  //----amask_no_clip_rgb24gray
+    typedef amask_no_clip_u8<3, 0, rgb_to_gray_mask_u8<2, 1, 0> > amask_no_clip_bgr24gray;  //----amask_no_clip_bgr24gray
+    typedef amask_no_clip_u8<4, 0, rgb_to_gray_mask_u8<0, 1, 2> > amask_no_clip_rgba32gray; //----amask_no_clip_rgba32gray
+    typedef amask_no_clip_u8<4, 1, rgb_to_gray_mask_u8<0, 1, 2> > amask_no_clip_argb32gray; //----amask_no_clip_argb32gray
+    typedef amask_no_clip_u8<4, 0, rgb_to_gray_mask_u8<2, 1, 0> > amask_no_clip_bgra32gray; //----amask_no_clip_bgra32gray
+    typedef amask_no_clip_u8<4, 1, rgb_to_gray_mask_u8<2, 1, 0> > amask_no_clip_abgr32gray; //----amask_no_clip_abgr32gray
+
+
+}
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_arc.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_arc.h
--- 8.0.1-5/src/renderers/agg/include/agg_arc.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_arc.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,74 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Arc vertex generator
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_ARC_INCLUDED
+#define AGG_ARC_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //=====================================================================arc
+    //
+    // See Implementation agg_arc.cpp 
+    //
+    class arc
+    {
+    public:
+        arc() : m_scale(1.0), m_initialized(false) {}
+        arc(double x,  double y, 
+            double rx, double ry, 
+            double a1, double a2, 
+            bool ccw=true);
+
+        void init(double x,  double y, 
+                  double rx, double ry, 
+                  double a1, double a2, 
+                  bool ccw=true);
+
+        void approximation_scale(double s);
+        double approximation_scale() const { return m_scale;  }
+
+        void rewind(unsigned);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        void normalize(double a1, double a2, bool ccw);
+
+        double   m_x;
+        double   m_y;
+        double   m_rx;
+        double   m_ry;
+        double   m_angle = 0;
+        double   m_start;
+        double   m_end;
+        double   m_scale;
+        double   m_da;
+        bool     m_ccw;
+        bool     m_initialized;
+        unsigned m_path_cmd = 0;
+    };
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_array.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_array.h
--- 8.0.1-5/src/renderers/agg/include/agg_array.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_array.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1119 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_ARRAY_INCLUDED
+#define AGG_ARRAY_INCLUDED
+
+#include <stddef.h>
+#include <string.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //-------------------------------------------------------pod_array_adaptor
+    template<class T> class pod_array_adaptor
+    {
+    public:
+        typedef T value_type;
+        pod_array_adaptor(T* array, unsigned size) : 
+            m_array(array), m_size(size) {}
+
+        unsigned size() const { return m_size; }
+        const T& operator [] (unsigned i) const { return m_array[i]; }
+              T& operator [] (unsigned i)       { return m_array[i]; }
+        const T& at(unsigned i) const           { return m_array[i]; }
+              T& at(unsigned i)                 { return m_array[i]; }
+        T  value_at(unsigned i) const           { return m_array[i]; }
+
+    private:
+        T*       m_array;
+        unsigned m_size;
+    };
+
+
+    //---------------------------------------------------------pod_auto_array
+    template<class T, unsigned Size> class pod_auto_array
+    {
+    public:
+        typedef T value_type;
+        typedef pod_auto_array<T, Size> self_type;
+
+        pod_auto_array() {}
+        explicit pod_auto_array(const T* c)
+        {
+            memcpy(m_array, c, sizeof(T) * Size);
+        }
+
+        const self_type& operator = (const T* c)
+        {
+            memcpy(m_array, c, sizeof(T) * Size);
+            return *this;
+        }
+
+        static unsigned size() { return Size; }
+        const T& operator [] (unsigned i) const { return m_array[i]; }
+              T& operator [] (unsigned i)       { return m_array[i]; }
+        const T& at(unsigned i) const           { return m_array[i]; }
+              T& at(unsigned i)                 { return m_array[i]; }
+        T  value_at(unsigned i) const           { return m_array[i]; }
+
+    private:
+        T m_array[Size];
+    };
+
+
+    //--------------------------------------------------------pod_auto_vector
+    template<class T, unsigned Size> class pod_auto_vector
+    {
+    public:
+        typedef T value_type;
+        typedef pod_auto_vector<T, Size> self_type;
+
+        pod_auto_vector() : m_size(0) {}
+
+        void remove_all()            { m_size = 0; }
+        void clear()                 { m_size = 0; }
+        void add(const T& v)         { m_array[m_size++] = v; }
+        void push_back(const T& v)   { m_array[m_size++] = v; }
+        void inc_size(unsigned size) { m_size += size; }
+        
+        unsigned size() const { return m_size; }
+        const T& operator [] (unsigned i) const { return m_array[i]; }
+              T& operator [] (unsigned i)       { return m_array[i]; }
+        const T& at(unsigned i) const           { return m_array[i]; }
+              T& at(unsigned i)                 { return m_array[i]; }
+        T  value_at(unsigned i) const           { return m_array[i]; }
+
+    private:
+        T m_array[Size];
+        unsigned m_size;
+    };
+
+
+    //---------------------------------------------------------------pod_array
+    template<class T> class pod_array
+    {
+    public:
+        typedef T value_type;
+        typedef pod_array<T> self_type;
+
+        ~pod_array() { pod_allocator<T>::deallocate(m_array, m_size); }
+        pod_array() : m_array(0), m_size(0) {}
+
+        pod_array(unsigned size) : 
+            m_array(pod_allocator<T>::allocate(size)), 
+            m_size(size) 
+        {}
+
+        pod_array(const self_type& v) : 
+            m_array(pod_allocator<T>::allocate(v.m_size)), 
+            m_size(v.m_size) 
+        {
+            memcpy(m_array, v.m_array, sizeof(T) * m_size);
+        }
+
+        void resize(unsigned size)
+        {
+            if(size != m_size)
+            {
+                pod_allocator<T>::deallocate(m_array, m_size);
+                m_array = pod_allocator<T>::allocate(m_size = size);
+            }
+        }
+        const self_type& operator = (const self_type& v)
+        {
+            resize(v.size());
+            memcpy(m_array, v.m_array, sizeof(T) * m_size);
+            return *this;
+        }
+
+        unsigned size() const { return m_size; }
+        const T& operator [] (unsigned i) const { return m_array[i]; }
+              T& operator [] (unsigned i)       { return m_array[i]; }
+        const T& at(unsigned i) const           { return m_array[i]; }
+              T& at(unsigned i)                 { return m_array[i]; }
+        T  value_at(unsigned i) const           { return m_array[i]; }
+
+        const T* data() const { return m_array; }
+              T* data()       { return m_array; }
+    private:
+        T*       m_array;
+        unsigned m_size;
+    };
+
+
+
+    //--------------------------------------------------------------pod_vector
+    // A simple class template to store Plain Old Data, a vector
+    // of a fixed size. The data is continous in memory
+    //------------------------------------------------------------------------
+    template<class T> class pod_vector
+    {
+    public:
+        typedef T value_type;
+
+        ~pod_vector() { pod_allocator<T>::deallocate(m_array, m_capacity); }
+        pod_vector() : m_size(0), m_capacity(0), m_array(0) {}
+        pod_vector(unsigned cap, unsigned extra_tail=0);
+
+        // Copying
+        pod_vector(const pod_vector<T>&);
+        const pod_vector<T>& operator = (const pod_vector<T>&);
+
+        // Set new capacity. All data is lost, size is set to zero.
+        void capacity(unsigned cap, unsigned extra_tail=0);
+        unsigned capacity() const { return m_capacity; }
+
+        // Allocate n elements. All data is lost, 
+        // but elements can be accessed in range 0...size-1. 
+        void allocate(unsigned size, unsigned extra_tail=0);
+
+        // Resize keeping the content.
+        void resize(unsigned new_size);
+
+        void zero()
+        {
+            memset(m_array, 0, sizeof(T) * m_size);
+        }
+
+        void add(const T& v)         { m_array[m_size++] = v; }
+        void push_back(const T& v)   { m_array[m_size++] = v; }
+        void insert_at(unsigned pos, const T& val);
+        void inc_size(unsigned size) { m_size += size; }
+        unsigned size()      const   { return m_size; }
+        unsigned byte_size() const   { return m_size * sizeof(T); }
+        void serialize(int8u* ptr) const;
+        void deserialize(const int8u* data, unsigned byte_size);
+        const T& operator [] (unsigned i) const { return m_array[i]; }
+              T& operator [] (unsigned i)       { return m_array[i]; }
+        const T& at(unsigned i) const           { return m_array[i]; }
+              T& at(unsigned i)                 { return m_array[i]; }
+        T  value_at(unsigned i) const           { return m_array[i]; }
+
+        const T* data() const { return m_array; }
+              T* data()       { return m_array; }
+
+        void remove_all()         { m_size = 0; }
+        void clear()              { m_size = 0; }
+        void cut_at(unsigned num) { if(num < m_size) m_size = num; }
+
+    private:
+        unsigned m_size;
+        unsigned m_capacity;
+        T*       m_array;
+    };
+
+    //------------------------------------------------------------------------
+    template<class T> 
+    void pod_vector<T>::capacity(unsigned cap, unsigned extra_tail)
+    {
+        m_size = 0;
+        if(cap > m_capacity)
+        {
+            pod_allocator<T>::deallocate(m_array, m_capacity);
+            m_capacity = cap + extra_tail;
+            m_array = m_capacity ? pod_allocator<T>::allocate(m_capacity) : 0;
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class T> 
+    void pod_vector<T>::allocate(unsigned size, unsigned extra_tail)
+    {
+        capacity(size, extra_tail);
+        m_size = size;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T> 
+    void pod_vector<T>::resize(unsigned new_size)
+    {
+        if(new_size > m_size)
+        {
+            if(new_size > m_capacity)
+            {
+                T* data = pod_allocator<T>::allocate(new_size);
+                memcpy(data, m_array, m_size * sizeof(T));
+                pod_allocator<T>::deallocate(m_array, m_capacity);
+                m_array = data;
+            }
+        }
+        else
+        {
+            m_size = new_size;
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class T> pod_vector<T>::pod_vector(unsigned cap, unsigned extra_tail) :
+        m_size(0), 
+        m_capacity(cap + extra_tail), 
+        m_array(pod_allocator<T>::allocate(m_capacity)) {}
+
+    //------------------------------------------------------------------------
+    template<class T> pod_vector<T>::pod_vector(const pod_vector<T>& v) :
+        m_size(v.m_size),
+        m_capacity(v.m_capacity),
+        m_array(v.m_capacity ? pod_allocator<T>::allocate(v.m_capacity) : 0)
+    {
+        memcpy(m_array, v.m_array, sizeof(T) * v.m_size);
+    }
+
+    //------------------------------------------------------------------------
+    template<class T> const pod_vector<T>& 
+    pod_vector<T>::operator = (const pod_vector<T>&v)
+    {
+        allocate(v.m_size);
+        if(v.m_size) memcpy(m_array, v.m_array, sizeof(T) * v.m_size);
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T> void pod_vector<T>::serialize(int8u* ptr) const
+    { 
+        if(m_size) memcpy(ptr, m_array, m_size * sizeof(T)); 
+    }
+
+    //------------------------------------------------------------------------
+    template<class T> 
+    void pod_vector<T>::deserialize(const int8u* data, unsigned byte_size)
+    {
+        byte_size /= sizeof(T);
+        allocate(byte_size);
+        if(byte_size) memcpy(m_array, data, byte_size * sizeof(T));
+    }
+
+    //------------------------------------------------------------------------
+    template<class T> 
+    void pod_vector<T>::insert_at(unsigned pos, const T& val)
+    {
+        if(pos >= m_size) 
+        {
+            m_array[m_size] = val;
+        }
+        else
+        {
+            memmove(m_array + pos + 1, m_array + pos, (m_size - pos) * sizeof(T));
+            m_array[pos] = val;
+        }
+        ++m_size;
+    }
+
+    //---------------------------------------------------------------pod_bvector
+    // A simple class template to store Plain Old Data, similar to std::deque
+    // It doesn't reallocate memory but instead, uses blocks of data of size 
+    // of (1 << S), that is, power of two. The data is NOT contiguous in memory, 
+    // so the only valid access method is operator [] or curr(), prev(), next()
+    // 
+    // There reallocs occure only when the pool of pointers to blocks needs 
+    // to be extended (it happens very rarely). You can control the value 
+    // of increment to reallocate the pointer buffer. See the second constructor.
+    // By default, the incremeent value equals (1 << S), i.e., the block size.
+    //------------------------------------------------------------------------
+    template<class T, unsigned S=6> class pod_bvector
+    {
+    public:
+        enum block_scale_e
+        {   
+            block_shift = S,
+            block_size  = 1 << block_shift,
+            block_mask  = block_size - 1
+        };
+
+        typedef T value_type;
+
+        ~pod_bvector();
+        pod_bvector();
+        pod_bvector(unsigned block_ptr_inc);
+
+        // Copying
+        pod_bvector(const pod_bvector<T, S>& v);
+        const pod_bvector<T, S>& operator = (const pod_bvector<T, S>& v);
+
+        void remove_all() { m_size = 0; }
+        void clear()      { m_size = 0; }
+        void free_all()   { free_tail(0); }
+        void free_tail(unsigned size);
+        void add(const T& val);
+        void push_back(const T& val) { add(val); }
+        void modify_last(const T& val);
+        void remove_last();
+
+        int allocate_continuous_block(unsigned num_elements);
+
+        void add_array(const T* ptr, unsigned num_elem)
+        {
+            while(num_elem--)
+            {
+                add(*ptr++);
+            }
+        }
+
+        template<class DataAccessor> void add_data(DataAccessor& data)
+        {
+            while(data.size())
+            {
+                add(*data);
+                ++data;
+            }
+        }
+
+        void cut_at(unsigned size)
+        {
+            if(size < m_size) m_size = size;
+        }
+
+        unsigned size() const { return m_size; }
+
+        const T& operator [] (unsigned i) const
+        {
+            return m_blocks[i >> block_shift][i & block_mask];
+        }
+
+        T& operator [] (unsigned i)
+        {
+            return m_blocks[i >> block_shift][i & block_mask];
+        }
+
+        const T& at(unsigned i) const
+        { 
+            return m_blocks[i >> block_shift][i & block_mask];
+        }
+
+        T& at(unsigned i) 
+        { 
+            return m_blocks[i >> block_shift][i & block_mask];
+        }
+
+        T value_at(unsigned i) const
+        { 
+            return m_blocks[i >> block_shift][i & block_mask];
+        }
+
+        const T& curr(unsigned idx) const
+        {
+            return (*this)[idx];
+        }
+
+        T& curr(unsigned idx)
+        {
+            return (*this)[idx];
+        }
+
+        const T& prev(unsigned idx) const
+        {
+            return (*this)[(idx + m_size - 1) % m_size];
+        }
+
+        T& prev(unsigned idx)
+        {
+            return (*this)[(idx + m_size - 1) % m_size];
+        }
+
+        const T& next(unsigned idx) const
+        {
+            return (*this)[(idx + 1) % m_size];
+        }
+
+        T& next(unsigned idx)
+        {
+            return (*this)[(idx + 1) % m_size];
+        }
+
+        const T& last() const
+        {
+            return (*this)[m_size - 1];
+        }
+
+        T& last()
+        {
+            return (*this)[m_size - 1];
+        }
+
+        unsigned byte_size() const;
+        void serialize(int8u* ptr) const;
+        void deserialize(const int8u* data, unsigned byte_size);
+        void deserialize(unsigned start, const T& empty_val, 
+                         const int8u* data, unsigned byte_size);
+
+        template<class ByteAccessor> 
+        void deserialize(ByteAccessor data)
+        {
+            remove_all();
+            unsigned elem_size = data.size() / sizeof(T);
+
+            for(unsigned i = 0; i < elem_size; ++i)
+            {
+                int8u* ptr = (int8u*)data_ptr();
+                for(unsigned j = 0; j < sizeof(T); ++j)
+                {
+                    *ptr++ = *data;
+                    ++data;
+                }
+                ++m_size;
+            }
+        }
+
+        template<class ByteAccessor>
+        void deserialize(unsigned start, const T& empty_val, ByteAccessor data)
+        {
+            while(m_size < start)
+            {
+                add(empty_val);
+            }
+
+            unsigned elem_size = data.size() / sizeof(T);
+            for(unsigned i = 0; i < elem_size; ++i)
+            {
+                int8u* ptr;
+                if(start + i < m_size)
+                {
+                    ptr = (int8u*)(&((*this)[start + i]));
+                }
+                else
+                {
+                    ptr = (int8u*)data_ptr();
+                    ++m_size;
+                }
+                for(unsigned j = 0; j < sizeof(T); ++j)
+                {
+                    *ptr++ = *data;
+                    ++data;
+                }
+            }
+        }
+
+        const T* block(unsigned nb) const { return m_blocks[nb]; }
+
+    private:
+        void allocate_block(unsigned nb);
+        T*   data_ptr();
+
+        unsigned        m_size;
+        unsigned        m_num_blocks;
+        unsigned        m_max_blocks;
+        T**             m_blocks;
+        unsigned        m_block_ptr_inc;
+    };
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> pod_bvector<T, S>::~pod_bvector()
+    {
+        if(m_num_blocks)
+        {
+            T** blk = m_blocks + m_num_blocks - 1;
+            while(m_num_blocks--)
+            {
+                pod_allocator<T>::deallocate(*blk, block_size);
+                --blk;
+            }
+        }
+        pod_allocator<T*>::deallocate(m_blocks, m_max_blocks);
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void pod_bvector<T, S>::free_tail(unsigned size)
+    {
+        if(size < m_size)
+        {
+            unsigned nb = (size + block_mask) >> block_shift;
+            while(m_num_blocks > nb)
+            {
+                pod_allocator<T>::deallocate(m_blocks[--m_num_blocks], block_size);
+            }
+            if(m_num_blocks == 0)
+            {
+                pod_allocator<T*>::deallocate(m_blocks, m_max_blocks);
+                m_blocks = 0;
+                m_max_blocks = 0;
+            }
+            m_size = size;
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> pod_bvector<T, S>::pod_bvector() :
+        m_size(0),
+        m_num_blocks(0),
+        m_max_blocks(0),
+        m_blocks(0),
+        m_block_ptr_inc(block_size)
+    {
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    pod_bvector<T, S>::pod_bvector(unsigned block_ptr_inc) :
+        m_size(0),
+        m_num_blocks(0),
+        m_max_blocks(0),
+        m_blocks(0),
+        m_block_ptr_inc(block_ptr_inc)
+    {
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    pod_bvector<T, S>::pod_bvector(const pod_bvector<T, S>& v) :
+        m_size(v.m_size),
+        m_num_blocks(v.m_num_blocks),
+        m_max_blocks(v.m_max_blocks),
+        m_blocks(v.m_max_blocks ? 
+                 pod_allocator<T*>::allocate(v.m_max_blocks) : 
+                 0),
+        m_block_ptr_inc(v.m_block_ptr_inc)
+    {
+        unsigned i;
+        for(i = 0; i < v.m_num_blocks; ++i)
+        {
+            m_blocks[i] = pod_allocator<T>::allocate(block_size);
+            memcpy(m_blocks[i], v.m_blocks[i], block_size * sizeof(T));
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    const pod_bvector<T, S>& 
+    pod_bvector<T, S>::operator = (const pod_bvector<T, S>& v)
+    {
+        unsigned i;
+        for(i = m_num_blocks; i < v.m_num_blocks; ++i)
+        {
+            allocate_block(i);
+        }
+        for(i = 0; i < v.m_num_blocks; ++i)
+        {
+            memcpy(m_blocks[i], v.m_blocks[i], block_size * sizeof(T));
+        }
+        m_size = v.m_size;
+        return *this;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S>
+    void pod_bvector<T, S>::allocate_block(unsigned nb)
+    {
+        if(nb >= m_max_blocks) 
+        {
+            T** new_blocks = pod_allocator<T*>::allocate(m_max_blocks + m_block_ptr_inc);
+
+            if(m_blocks)
+            {
+                memcpy(new_blocks, 
+                       m_blocks, 
+                       m_num_blocks * sizeof(T*));
+
+                pod_allocator<T*>::deallocate(m_blocks, m_max_blocks);
+            }
+            m_blocks = new_blocks;
+            m_max_blocks += m_block_ptr_inc;
+        }
+        m_blocks[nb] = pod_allocator<T>::allocate(block_size);
+        m_num_blocks++;
+    }
+
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S>
+    inline T* pod_bvector<T, S>::data_ptr()
+    {
+        unsigned nb = m_size >> block_shift;
+        if(nb >= m_num_blocks)
+        {
+            allocate_block(nb);
+        }
+        return m_blocks[nb] + (m_size & block_mask);
+    }
+
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    inline void pod_bvector<T, S>::add(const T& val)
+    {
+        *data_ptr() = val;
+        ++m_size;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    inline void pod_bvector<T, S>::remove_last()
+    {
+        if(m_size) --m_size;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void pod_bvector<T, S>::modify_last(const T& val)
+    {
+        remove_last();
+        add(val);
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    int pod_bvector<T, S>::allocate_continuous_block(unsigned num_elements)
+    {
+        if(num_elements < block_size)
+        {
+            data_ptr(); // Allocate initial block if necessary
+            unsigned rest = block_size - (m_size & block_mask);
+            unsigned index;
+            if(num_elements <= rest)
+            {
+                // The rest of the block is good, we can use it
+                //-----------------
+                index = m_size;
+                m_size += num_elements;
+                return index;
+            }
+
+            // New block
+            //---------------
+            m_size += rest;
+            data_ptr();
+            index = m_size;
+            m_size += num_elements;
+            return index;
+        }
+        return -1; // Impossible to allocate
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    unsigned pod_bvector<T, S>::byte_size() const
+    {
+        return m_size * sizeof(T);
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void pod_bvector<T, S>::serialize(int8u* ptr) const
+    {
+        unsigned i;
+        for(i = 0; i < m_size; i++)
+        {
+            memcpy(ptr, &(*this)[i], sizeof(T));
+            ptr += sizeof(T);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void pod_bvector<T, S>::deserialize(const int8u* data, unsigned byte_size)
+    {
+        remove_all();
+        byte_size /= sizeof(T);
+        for(unsigned i = 0; i < byte_size; ++i)
+        {
+            T* ptr = data_ptr();
+            memcpy(ptr, data, sizeof(T));
+            ++m_size;
+            data += sizeof(T);
+        }
+    }
+
+
+    // Replace or add a number of elements starting from "start" position
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void pod_bvector<T, S>::deserialize(unsigned start, const T& empty_val, 
+                                        const int8u* data, unsigned byte_size)
+    {
+        while(m_size < start)
+        {
+            add(empty_val);
+        }
+
+        byte_size /= sizeof(T);
+        for(unsigned i = 0; i < byte_size; ++i)
+        {
+            if(start + i < m_size)
+            {
+                memcpy(&((*this)[start + i]), data, sizeof(T));
+            }
+            else
+            {
+                T* ptr = data_ptr();
+                memcpy(ptr, data, sizeof(T));
+                ++m_size;
+            }
+            data += sizeof(T);
+        }
+    }
+
+
+    //---------------------------------------------------------block_allocator
+    // Allocator for arbitrary POD data. Most usable in different cache
+    // systems for efficient memory allocations. 
+    // Memory is allocated with blocks of fixed size ("block_size" in
+    // the constructor). If required size exceeds the block size the allocator
+    // creates a new block of the required size. However, the most efficient
+    // use is when the average reqired size is much less than the block size. 
+    //------------------------------------------------------------------------
+    class block_allocator
+    {
+        struct block_type
+        {
+            int8u*   data;
+            unsigned size;
+        };
+
+    public:
+        void remove_all()
+        {
+            if(m_num_blocks)
+            {
+                block_type* blk = m_blocks + m_num_blocks - 1;
+                while(m_num_blocks--)
+                {
+                    pod_allocator<int8u>::deallocate(blk->data, blk->size);
+                    --blk;
+                }
+                pod_allocator<block_type>::deallocate(m_blocks, m_max_blocks);
+            }
+            m_num_blocks = 0;
+            m_max_blocks = 0;
+            m_blocks = 0;
+            m_buf_ptr = 0;
+            m_rest = 0;
+        }
+
+        ~block_allocator()
+        {
+            remove_all();
+        }
+
+        block_allocator(unsigned block_size, unsigned block_ptr_inc=256-8) :
+            m_block_size(block_size),
+            m_block_ptr_inc(block_ptr_inc),
+            m_num_blocks(0),
+            m_max_blocks(0),
+            m_blocks(0),
+            m_buf_ptr(0),
+            m_rest(0)
+        {
+        }
+       
+
+        int8u* allocate(unsigned size, unsigned alignment=1)
+        {
+            if(size == 0) return 0;
+            if(size <= m_rest)
+            {
+                int8u* ptr = m_buf_ptr;
+                if(alignment > 1)
+                {
+                    unsigned align = 
+                        (alignment - unsigned((size_t)ptr) % alignment) % alignment;
+
+                    size += align;
+                    ptr += align;
+                    if(size <= m_rest)
+                    {
+                        m_rest -= size;
+                        m_buf_ptr += size;
+                        return ptr;
+                    }
+                    allocate_block(size);
+                    return allocate(size - align, alignment);
+                }
+                m_rest -= size;
+                m_buf_ptr += size;
+                return ptr;
+            }
+            allocate_block(size + alignment - 1);
+            return allocate(size, alignment);
+        }
+
+
+    private:
+        void allocate_block(unsigned size)
+        {
+            if(size < m_block_size) size = m_block_size;
+            if(m_num_blocks >= m_max_blocks) 
+            {
+                block_type* new_blocks = 
+                    pod_allocator<block_type>::allocate(m_max_blocks + m_block_ptr_inc);
+
+                if(m_blocks)
+                {
+                    memcpy(new_blocks, 
+                           m_blocks, 
+                           m_num_blocks * sizeof(block_type));
+                    pod_allocator<block_type>::deallocate(m_blocks, m_max_blocks);
+                }
+                m_blocks = new_blocks;
+                m_max_blocks += m_block_ptr_inc;
+            }
+
+            m_blocks[m_num_blocks].size = size;
+            m_blocks[m_num_blocks].data = 
+                m_buf_ptr =
+                pod_allocator<int8u>::allocate(size);
+
+            m_num_blocks++;
+            m_rest = size;
+        }
+
+        unsigned    m_block_size;
+        unsigned    m_block_ptr_inc;
+        unsigned    m_num_blocks;
+        unsigned    m_max_blocks;
+        block_type* m_blocks;
+        int8u*      m_buf_ptr;
+        unsigned    m_rest;
+    };
+
+
+
+
+
+
+
+
+    //------------------------------------------------------------------------
+    enum quick_sort_threshold_e
+    {
+        quick_sort_threshold = 9
+    };
+
+    
+    //-----------------------------------------------------------swap_elements
+    template<class T> inline void swap_elements(T& a, T& b)
+    {
+        T temp = a;
+        a = b;
+        b = temp;
+    }
+
+
+    //--------------------------------------------------------------quick_sort
+    template<class Array, class Less>
+    void quick_sort(Array& arr, Less less)
+    {
+        if(arr.size() < 2) return;
+
+        typename Array::value_type* e1;
+        typename Array::value_type* e2;
+
+        int  stack[80];
+        int* top = stack; 
+        int  limit = arr.size();
+        int  base = 0;
+
+        for(;;)
+        {
+            int len = limit - base;
+
+            int i;
+            int j;
+            int pivot;
+
+            if(len > quick_sort_threshold)
+            {
+                // we use base + len/2 as the pivot
+                pivot = base + len / 2;
+                swap_elements(arr[base], arr[pivot]);
+
+                i = base + 1;
+                j = limit - 1;
+
+                // now ensure that *i <= *base <= *j 
+                e1 = &(arr[j]); 
+                e2 = &(arr[i]);
+                if(less(*e1, *e2)) swap_elements(*e1, *e2);
+
+                e1 = &(arr[base]); 
+                e2 = &(arr[i]);
+                if(less(*e1, *e2)) swap_elements(*e1, *e2);
+
+                e1 = &(arr[j]); 
+                e2 = &(arr[base]);
+                if(less(*e1, *e2)) swap_elements(*e1, *e2);
+
+                for(;;)
+                {
+                    do i++; while( less(arr[i], arr[base]) );
+                    do j--; while( less(arr[base], arr[j]) );
+
+                    if( i > j )
+                    {
+                        break;
+                    }
+
+                    swap_elements(arr[i], arr[j]);
+                }
+
+                swap_elements(arr[base], arr[j]);
+
+                // now, push the largest sub-array
+                if(j - base > limit - i)
+                {
+                    top[0] = base;
+                    top[1] = j;
+                    base   = i;
+                }
+                else
+                {
+                    top[0] = i;
+                    top[1] = limit;
+                    limit  = j;
+                }
+                top += 2;
+            }
+            else
+            {
+                // the sub-array is small, perform insertion sort
+                j = base;
+                i = j + 1;
+
+                for(; i < limit; j = i, i++)
+                {
+                    for(; less(*(e1 = &(arr[j + 1])), *(e2 = &(arr[j]))); j--)
+                    {
+                        swap_elements(*e1, *e2);
+                        if(j == base)
+                        {
+                            break;
+                        }
+                    }
+                }
+                if(top > stack)
+                {
+                    top  -= 2;
+                    base  = top[0];
+                    limit = top[1];
+                }
+                else
+                {
+                    break;
+                }
+            }
+        }
+    }
+
+
+
+
+    //------------------------------------------------------remove_duplicates
+    // Remove duplicates from a sorted array. It doesn't cut the 
+    // tail of the array, it just returns the number of remaining elements.
+    //-----------------------------------------------------------------------
+    template<class Array, class Equal>
+    unsigned remove_duplicates(Array& arr, Equal equal)
+    {
+        if(arr.size() < 2) return arr.size();
+
+        unsigned i, j;
+        for(i = 1, j = 1; i < arr.size(); i++)
+        {
+            typename Array::value_type& e = arr[i];
+            if(!equal(e, arr[i - 1]))
+            {
+                arr[j++] = e;
+            }
+        }
+        return j;
+    }
+
+    //--------------------------------------------------------invert_container
+    template<class Array> void invert_container(Array& arr)
+    {
+        int i = 0;
+        int j = arr.size() - 1;
+        while(i < j)
+        {
+            swap_elements(arr[i++], arr[j--]);
+        }
+    }
+
+    //------------------------------------------------------binary_search_pos
+    template<class Array, class Value, class Less>
+    unsigned binary_search_pos(const Array& arr, const Value& val, Less less)
+    {
+        if(arr.size() == 0) return 0;
+
+        unsigned beg = 0;
+        unsigned end = arr.size() - 1;
+
+        if(less(val, arr[0])) return 0;
+        if(less(arr[end], val)) return end + 1;
+
+        while(end - beg > 1)
+        {
+            unsigned mid = (end + beg) >> 1;
+            if(less(val, arr[mid])) end = mid; 
+            else                    beg = mid;
+        }
+
+        //if(beg <= 0 && less(val, arr[0])) return 0;
+        //if(end >= arr.size() - 1 && less(arr[end], val)) ++end;
+
+        return end;
+    }
+
+    //----------------------------------------------------------range_adaptor
+    template<class Array> class range_adaptor
+    {
+    public:
+        typedef typename Array::value_type value_type;
+
+        range_adaptor(Array& array, unsigned start, unsigned size) :
+            m_array(array), m_start(start), m_size(size)
+        {}
+
+        unsigned size() const { return m_size; }
+        const value_type& operator [] (unsigned i) const { return m_array[m_start + i]; }
+              value_type& operator [] (unsigned i)       { return m_array[m_start + i]; }
+        const value_type& at(unsigned i) const           { return m_array[m_start + i]; }
+              value_type& at(unsigned i)                 { return m_array[m_start + i]; }
+        value_type  value_at(unsigned i) const           { return m_array[m_start + i]; }
+
+    private:
+        Array& m_array;
+        unsigned m_start;
+        unsigned m_size;
+    };
+
+    //---------------------------------------------------------------int_less
+    inline bool int_less(int a, int b) { return a < b; }
+
+    //------------------------------------------------------------int_greater
+    inline bool int_greater(int a, int b) { return a > b; }
+
+    //----------------------------------------------------------unsigned_less
+    inline bool unsigned_less(unsigned a, unsigned b) { return a < b; }
+
+    //-------------------------------------------------------unsigned_greater
+    inline bool unsigned_greater(unsigned a, unsigned b) { return a > b; }
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_arrowhead.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_arrowhead.h
--- 8.0.1-5/src/renderers/agg/include/agg_arrowhead.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_arrowhead.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,82 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Simple arrowhead/arrowtail generator 
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_ARROWHEAD_INCLUDED
+#define AGG_ARROWHEAD_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //===============================================================arrowhead
+    //
+    // See implementation agg_arrowhead.cpp 
+    //
+    class arrowhead
+    {
+    public:
+        arrowhead();
+
+        void head(double d1, double d2, double d3, double d4)
+        {
+            m_head_d1 = d1;
+            m_head_d2 = d2;
+            m_head_d3 = d3;
+            m_head_d4 = d4;
+            m_head_flag = true;
+        }
+
+        void head()    { m_head_flag = true; }
+        void no_head() { m_head_flag = false; }
+
+        void tail(double d1, double d2, double d3, double d4)
+        {
+            m_tail_d1 = d1;
+            m_tail_d2 = d2;
+            m_tail_d3 = d3;
+            m_tail_d4 = d4;
+            m_tail_flag = true;
+        }
+
+        void tail()    { m_tail_flag = true;  }
+        void no_tail() { m_tail_flag = false; }
+
+        void rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        double   m_head_d1;
+        double   m_head_d2;
+        double   m_head_d3;
+        double   m_head_d4;
+        double   m_tail_d1;
+        double   m_tail_d2;
+        double   m_tail_d3;
+        double   m_tail_d4;
+        bool     m_head_flag;
+        bool     m_tail_flag;
+        double   m_coord[16];
+        unsigned m_cmd[8];
+        unsigned m_curr_id;
+        unsigned m_curr_coord;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_basics.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_basics.h
--- 8.0.1-5/src/renderers/agg/include/agg_basics.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_basics.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,538 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_BASICS_INCLUDED
+#define AGG_BASICS_INCLUDED
+
+#include <math.h>
+#include "agg_config.h"
+
+//---------------------------------------------------------AGG_CUSTOM_ALLOCATOR
+#ifdef AGG_CUSTOM_ALLOCATOR
+#include "agg_allocator.h"
+#else
+namespace mapserver
+{
+    // The policy of all AGG containers and memory allocation strategy 
+    // in general is that no allocated data requires explicit construction.
+    // It means that the allocator can be really simple; you can even
+    // replace new/delete to malloc/free. The constructors and destructors 
+    // won't be called in this case, however everything will remain working. 
+    // The second argument of deallocate() is the size of the allocated 
+    // block. You can use this information if you wish.
+    //------------------------------------------------------------pod_allocator
+    template<class T> struct pod_allocator
+    {
+        static T*   allocate(unsigned num)       { return new T [num]; }
+        static void deallocate(T* ptr, unsigned) { delete [] ptr;      }
+    };
+
+    // Single object allocator. It's also can be replaced with your custom
+    // allocator. The difference is that it can only allocate a single 
+    // object and the constructor and destructor must be called. 
+    // In AGG there is no need to allocate an array of objects with
+    // calling their constructors (only single ones). So that, if you
+    // replace these new/delete to malloc/free make sure that the in-place
+    // new is called and take care of calling the destructor too.
+    //------------------------------------------------------------obj_allocator
+    template<class T> struct obj_allocator
+    {
+        static T*   allocate()         { return new T; }
+        static void deallocate(T* ptr) { delete ptr;   }
+    };
+}
+#endif
+
+
+//-------------------------------------------------------- Default basic types
+//
+// If the compiler has different capacity of the basic types you can redefine
+// them via the compiler command line or by generating agg_config.h that is
+// empty by default.
+//
+#ifndef AGG_INT8
+#define AGG_INT8 signed char
+#endif
+
+#ifndef AGG_INT8U
+#define AGG_INT8U unsigned char
+#endif
+
+#ifndef AGG_INT16
+#define AGG_INT16 short
+#endif
+
+#ifndef AGG_INT16U
+#define AGG_INT16U unsigned short
+#endif
+
+#ifndef AGG_INT32
+#define AGG_INT32 int
+#endif
+
+#ifndef AGG_INT32U
+#define AGG_INT32U unsigned
+#endif
+
+#ifndef AGG_INT64
+#if defined(_MSC_VER) || defined(__BORLANDC__)
+#define AGG_INT64 signed __int64
+#define AGG_INT64_FRMT "%I64d"
+#else
+#define AGG_INT64 signed long long
+#define AGG_INT64_FRMT "%lld"
+#endif
+#endif
+
+#ifndef AGG_INT64U
+#if defined(_MSC_VER) || defined(__BORLANDC__)
+#define AGG_INT64U unsigned __int64
+#define AGG_INT64U_FRMT "%I64u"
+#else
+#define AGG_INT64U unsigned long long
+#define AGG_INT64U_FRMT "%llu"
+#endif
+#endif
+
+//------------------------------------------------ Some fixes for MS Visual C++
+#if defined(_MSC_VER)
+#pragma warning(disable:4786) // Identifier was truncated...
+#endif
+
+#if defined(_MSC_VER)
+#define AGG_INLINE __forceinline
+#else
+#define AGG_INLINE inline
+#endif
+
+namespace mapserver
+{
+    //-------------------------------------------------------------------------
+    typedef AGG_INT8   int8;         //----int8
+    typedef AGG_INT8U  int8u;        //----int8u
+    typedef AGG_INT16  int16;        //----int16
+    typedef AGG_INT16U int16u;       //----int16u
+    typedef AGG_INT32  int32;        //----int32
+    typedef AGG_INT32U int32u;       //----int32u
+    typedef AGG_INT64  int64;        //----int64
+    typedef AGG_INT64U int64u;       //----int64u
+
+#if defined(AGG_FISTP)
+#pragma warning(push)
+#pragma warning(disable : 4035) //Disable warning "no return value"
+    AGG_INLINE int iround(double v)              //-------iround
+    {
+        int t;
+        __asm fld   qword ptr [v]
+        __asm fistp dword ptr [t]
+        __asm mov eax, dword ptr [t]
+    }
+    AGG_INLINE unsigned uround(double v)         //-------uround
+    {
+        unsigned t;
+        __asm fld   qword ptr [v]
+        __asm fistp dword ptr [t]
+        __asm mov eax, dword ptr [t]
+    }
+#pragma warning(pop)
+    AGG_INLINE unsigned ufloor(double v)         //-------ufloor
+    {
+        return unsigned(floor(v));
+    }
+    AGG_INLINE unsigned uceil(double v)          //--------uceil
+    {
+        return unsigned(ceil(v));
+    }
+#elif defined(AGG_QIFIST)
+    AGG_INLINE int iround(double v)
+    {
+        return int(v);
+    }
+    AGG_INLINE int uround(double v)
+    {
+        return unsigned(v);
+    }
+    AGG_INLINE unsigned ufloor(double v)
+    {
+        return unsigned(floor(v));
+    }
+    AGG_INLINE unsigned uceil(double v)
+    {
+        return unsigned(ceil(v));
+    }
+#else
+    AGG_INLINE int iround(double v)
+    {
+#ifdef HAVE_LRINT
+        return lrint(v);
+#else
+        return int((v < 0.0) ? v - 0.5 : v + 0.5);
+#endif
+    }
+    AGG_INLINE int uround(double v)
+    {
+        return unsigned(v + 0.5);
+    }
+    AGG_INLINE unsigned ufloor(double v)
+    {
+        return unsigned(v);
+    }
+    AGG_INLINE unsigned uceil(double v)
+    {
+        return unsigned(ceil(v));
+    }
+#endif
+
+    //---------------------------------------------------------------saturation
+    template<int Limit> struct saturation
+    {
+        AGG_INLINE static int iround(double v)
+        {
+            if(v < double(-Limit)) return -Limit;
+            if(v > double( Limit)) return  Limit;
+            return mapserver::iround(v);
+        }
+    };
+
+    //------------------------------------------------------------------mul_one
+    template<unsigned Shift> struct mul_one
+    {
+        AGG_INLINE static unsigned mul(unsigned a, unsigned b)
+        {
+            const unsigned q = a * b + (1 << (Shift-1));
+            return (q + (q >> Shift)) >> Shift;
+        }
+    };
+
+    //-------------------------------------------------------------------------
+    typedef unsigned char cover_type;    //----cover_type
+    enum cover_scale_e
+    {
+        cover_shift = 8,                 //----cover_shift
+        cover_size  = 1 << cover_shift,  //----cover_size 
+        cover_mask  = cover_size - 1,    //----cover_mask 
+        cover_none  = 0,                 //----cover_none 
+        cover_full  = cover_mask         //----cover_full 
+    };
+
+    //----------------------------------------------------poly_subpixel_scale_e
+    // These constants determine the subpixel accuracy, to be more precise, 
+    // the number of bits of the fractional part of the coordinates. 
+    // The possible coordinate capacity in bits can be calculated by formula:
+    // sizeof(int) * 8 - poly_subpixel_shift, i.e, for 32-bit integers and
+    // 8-bits fractional part the capacity is 24 bits.
+    enum poly_subpixel_scale_e
+    {
+        poly_subpixel_shift = 8,                      //----poly_subpixel_shift
+        poly_subpixel_scale = 1<<poly_subpixel_shift, //----poly_subpixel_scale 
+        poly_subpixel_mask  = poly_subpixel_scale-1,  //----poly_subpixel_mask 
+    };
+
+    //----------------------------------------------------------filling_rule_e
+    enum filling_rule_e
+    {
+        fill_non_zero,
+        fill_even_odd
+    };
+
+    //-----------------------------------------------------------------------pi
+    const double pi = 3.14159265358979323846;
+
+    //------------------------------------------------------------------deg2rad
+    inline double deg2rad(double deg)
+    {
+        return deg * pi / 180.0;
+    }
+
+    //------------------------------------------------------------------rad2deg
+    inline double rad2deg(double rad)
+    {
+        return rad * 180.0 / pi;
+    }
+ 
+    //----------------------------------------------------------------rect_base
+    template<class T> struct rect_base
+    {
+        typedef T            value_type;
+        typedef rect_base<T> self_type;
+        T x1, y1, x2, y2;
+
+        rect_base() {}
+        rect_base(T x1_, T y1_, T x2_, T y2_) :
+            x1(x1_), y1(y1_), x2(x2_), y2(y2_) {}
+
+        void init(T x1_, T y1_, T x2_, T y2_) 
+        {
+            x1 = x1_; y1 = y1_; x2 = x2_; y2 = y2_; 
+        }
+
+        const self_type& normalize()
+        {
+            T t;
+            if(x1 > x2) { t = x1; x1 = x2; x2 = t; }
+            if(y1 > y2) { t = y1; y1 = y2; y2 = t; }
+            return *this;
+        }
+
+        bool clip(const self_type& r)
+        {
+            if(x2 > r.x2) x2 = r.x2;
+            if(y2 > r.y2) y2 = r.y2;
+            if(x1 < r.x1) x1 = r.x1;
+            if(y1 < r.y1) y1 = r.y1;
+            return x1 <= x2 && y1 <= y2;
+        }
+
+        bool is_valid() const
+        {
+            return x1 <= x2 && y1 <= y2;
+        }
+
+        bool hit_test(T x, T y) const
+        {
+            return (x >= x1 && x <= x2 && y >= y1 && y <= y2);
+        }
+    };
+
+    //-----------------------------------------------------intersect_rectangles
+    template<class Rect> 
+    inline Rect intersect_rectangles(const Rect& r1, const Rect& r2)
+    {
+        Rect r = r1;
+
+        // First process x2,y2 because the other order 
+        // results in Internal Compiler Error under 
+        // Microsoft Visual C++ .NET 2003 69462-335-0000007-18038 in 
+        // case of "Maximize Speed" optimization option.
+        //-----------------
+        if(r.x2 > r2.x2) r.x2 = r2.x2; 
+        if(r.y2 > r2.y2) r.y2 = r2.y2;
+        if(r.x1 < r2.x1) r.x1 = r2.x1;
+        if(r.y1 < r2.y1) r.y1 = r2.y1;
+        return r;
+    }
+
+
+    //---------------------------------------------------------unite_rectangles
+    template<class Rect> 
+    inline Rect unite_rectangles(const Rect& r1, const Rect& r2)
+    {
+        Rect r = r1;
+        if(r.x2 < r2.x2) r.x2 = r2.x2;
+        if(r.y2 < r2.y2) r.y2 = r2.y2;
+        if(r.x1 > r2.x1) r.x1 = r2.x1;
+        if(r.y1 > r2.y1) r.y1 = r2.y1;
+        return r;
+    }
+
+    typedef rect_base<int>    rect_i; //----rect_i
+    typedef rect_base<float>  rect_f; //----rect_f
+    typedef rect_base<double> rect_d; //----rect_d
+
+    //---------------------------------------------------------path_commands_e
+    enum path_commands_e
+    {
+        path_cmd_stop     = 0,        //----path_cmd_stop    
+        path_cmd_move_to  = 1,        //----path_cmd_move_to 
+        path_cmd_line_to  = 2,        //----path_cmd_line_to 
+        path_cmd_curve3   = 3,        //----path_cmd_curve3  
+        path_cmd_curve4   = 4,        //----path_cmd_curve4  
+        path_cmd_curveN   = 5,        //----path_cmd_curveN
+        path_cmd_catrom   = 6,        //----path_cmd_catrom
+        path_cmd_ubspline = 7,        //----path_cmd_ubspline
+        path_cmd_end_poly = 0x0F,     //----path_cmd_end_poly
+        path_cmd_mask     = 0x0F      //----path_cmd_mask    
+    };
+
+    //------------------------------------------------------------path_flags_e
+    enum path_flags_e
+    {
+        path_flags_none  = 0,         //----path_flags_none 
+        path_flags_ccw   = 0x10,      //----path_flags_ccw  
+        path_flags_cw    = 0x20,      //----path_flags_cw   
+        path_flags_close = 0x40,      //----path_flags_close
+        path_flags_mask  = 0xF0       //----path_flags_mask 
+    };
+
+    //---------------------------------------------------------------is_vertex
+    inline bool is_vertex(unsigned c)
+    {
+        return c >= path_cmd_move_to && c < path_cmd_end_poly;
+    }
+
+    //--------------------------------------------------------------is_drawing
+    inline bool is_drawing(unsigned c)
+    {
+        return c >= path_cmd_line_to && c < path_cmd_end_poly;
+    }
+
+    //-----------------------------------------------------------------is_stop
+    inline bool is_stop(unsigned c)
+    { 
+        return c == path_cmd_stop;
+    }
+
+    //--------------------------------------------------------------is_move_to
+    inline bool is_move_to(unsigned c)
+    {
+        return c == path_cmd_move_to;
+    }
+
+    //--------------------------------------------------------------is_line_to
+    inline bool is_line_to(unsigned c)
+    {
+        return c == path_cmd_line_to;
+    }
+
+    //----------------------------------------------------------------is_curve
+    inline bool is_curve(unsigned c)
+    {
+        return c == path_cmd_curve3 || c == path_cmd_curve4;
+    }
+
+    //---------------------------------------------------------------is_curve3
+    inline bool is_curve3(unsigned c)
+    {
+        return c == path_cmd_curve3;
+    }
+
+    //---------------------------------------------------------------is_curve4
+    inline bool is_curve4(unsigned c)
+    {
+        return c == path_cmd_curve4;
+    }
+
+    //-------------------------------------------------------------is_end_poly
+    inline bool is_end_poly(unsigned c)
+    {
+        return (c & path_cmd_mask) == path_cmd_end_poly;
+    }
+
+    //----------------------------------------------------------------is_close
+    inline bool is_close(unsigned c)
+    {
+        return (c & ~(path_flags_cw | path_flags_ccw)) ==
+               (path_cmd_end_poly | path_flags_close); 
+    }
+
+    //------------------------------------------------------------is_next_poly
+    inline bool is_next_poly(unsigned c)
+    {
+        return is_stop(c) || is_move_to(c) || is_end_poly(c);
+    }
+
+    //-------------------------------------------------------------------is_cw
+    inline bool is_cw(unsigned c)
+    {
+        return (c & path_flags_cw) != 0;
+    }
+
+    //------------------------------------------------------------------is_ccw
+    inline bool is_ccw(unsigned c)
+    {
+        return (c & path_flags_ccw) != 0;
+    }
+
+    //-------------------------------------------------------------is_oriented
+    inline bool is_oriented(unsigned c)
+    {
+        return (c & (path_flags_cw | path_flags_ccw)) != 0; 
+    }
+
+    //---------------------------------------------------------------is_closed
+    inline bool is_closed(unsigned c)
+    {
+        return (c & path_flags_close) != 0; 
+    }
+
+    //----------------------------------------------------------get_close_flag
+    inline unsigned get_close_flag(unsigned c)
+    {
+        return c & path_flags_close; 
+    }
+
+    //-------------------------------------------------------clear_orientation
+    inline unsigned clear_orientation(unsigned c)
+    {
+        return c & ~(path_flags_cw | path_flags_ccw);
+    }
+
+    //---------------------------------------------------------get_orientation
+    inline unsigned get_orientation(unsigned c)
+    {
+        return c & (path_flags_cw | path_flags_ccw);
+    }
+
+    //---------------------------------------------------------set_orientation
+    inline unsigned set_orientation(unsigned c, unsigned o)
+    {
+        return clear_orientation(c) | o;
+    }
+
+    //--------------------------------------------------------------point_base
+    template<class T> struct point_base
+    {
+        typedef T value_type;
+        T x = 0,y = 0;
+        point_base() = default;
+        point_base(T x_, T y_) : x(x_), y(y_) {}
+    };
+    typedef point_base<int>    point_i; //-----point_i
+    typedef point_base<float>  point_f; //-----point_f
+    typedef point_base<double> point_d; //-----point_d
+
+    //-------------------------------------------------------------vertex_base
+    template<class T> struct vertex_base
+    {
+        typedef T value_type;
+        T x,y;
+        unsigned cmd;
+        vertex_base() {}
+        vertex_base(T x_, T y_, unsigned cmd_) : x(x_), y(y_), cmd(cmd_) {}
+    };
+    typedef vertex_base<int>    vertex_i; //-----vertex_i
+    typedef vertex_base<float>  vertex_f; //-----vertex_f
+    typedef vertex_base<double> vertex_d; //-----vertex_d
+
+    //----------------------------------------------------------------row_info
+    template<class T> struct row_info
+    {
+        int x1, x2;
+        T* ptr;
+        row_info() {}
+        row_info(int x1_, int x2_, T* ptr_) : x1(x1_), x2(x2_), ptr(ptr_) {}
+    };
+
+    //----------------------------------------------------------const_row_info
+    template<class T> struct const_row_info
+    {
+        int x1, x2;
+        const T* ptr;
+        const_row_info() {}
+        const_row_info(int x1_, int x2_, const T* ptr_) : 
+            x1(x1_), x2(x2_), ptr(ptr_) {}
+    };
+
+    //------------------------------------------------------------is_equal_eps
+    template<class T> inline bool is_equal_eps(T v1, T v2, T epsilon)
+    {
+        return fabs(v1 - v2) <= double(epsilon);
+    }
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_bezier_arc.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bezier_arc.h
--- 8.0.1-5/src/renderers/agg/include/agg_bezier_arc.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bezier_arc.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,159 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Arc generator. Produces at most 4 consecutive cubic bezier curves, i.e., 
+// 4, 7, 10, or 13 vertices.
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_BEZIER_ARC_INCLUDED
+#define AGG_BEZIER_ARC_INCLUDED
+
+#include "agg_conv_transform.h"
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------------------------
+    void arc_to_bezier(double cx, double cy, double rx, double ry, 
+                       double start_angle, double sweep_angle,
+                       double* curve);
+
+
+    //==============================================================bezier_arc
+    // 
+    // See implemantaion agg_bezier_arc.cpp
+    //
+    class bezier_arc
+    {
+    public:
+        //--------------------------------------------------------------------
+        bezier_arc() : m_vertex(26), m_num_vertices(0), m_cmd(path_cmd_line_to) {}
+        bezier_arc(double x,  double y, 
+                   double rx, double ry, 
+                   double start_angle, 
+                   double sweep_angle)
+        {
+            init(x, y, rx, ry, start_angle, sweep_angle);
+        }
+
+        //--------------------------------------------------------------------
+        void init(double x,  double y, 
+                  double rx, double ry, 
+                  double start_angle, 
+                  double sweep_angle);
+
+        //--------------------------------------------------------------------
+        void rewind(unsigned)
+        {
+            m_vertex = 0;
+        }
+
+        //--------------------------------------------------------------------
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_vertex >= m_num_vertices) return path_cmd_stop;
+            *x = m_vertices[m_vertex];
+            *y = m_vertices[m_vertex + 1];
+            m_vertex += 2;
+            return (m_vertex == 2) ? (unsigned)path_cmd_move_to : m_cmd;
+        }
+
+        // Supplemantary functions. num_vertices() actually returns doubled 
+        // number of vertices. That is, for 1 vertex it returns 2.
+        //--------------------------------------------------------------------
+        unsigned  num_vertices() const { return m_num_vertices; }
+        const double* vertices() const { return m_vertices;     }
+        double*       vertices()       { return m_vertices;     }
+ 
+    private:
+        unsigned m_vertex;
+        unsigned m_num_vertices;
+        double   m_vertices[26];
+        unsigned m_cmd;
+    };
+
+
+
+    //==========================================================bezier_arc_svg
+    // Compute an SVG-style bezier arc. 
+    //
+    // Computes an elliptical arc from (x1, y1) to (x2, y2). The size and 
+    // orientation of the ellipse are defined by two radii (rx, ry) 
+    // and an x-axis-rotation, which indicates how the ellipse as a whole 
+    // is rotated relative to the current coordinate system. The center 
+    // (cx, cy) of the ellipse is calculated automatically to satisfy the 
+    // constraints imposed by the other parameters. 
+    // large-arc-flag and sweep-flag contribute to the automatic calculations 
+    // and help determine how the arc is drawn.
+    class bezier_arc_svg
+    {
+    public:
+        //--------------------------------------------------------------------
+        bezier_arc_svg() : m_arc(), m_radii_ok(false) {}
+
+        bezier_arc_svg(double x1, double y1, 
+                       double rx, double ry, 
+                       double angle,
+                       bool large_arc_flag,
+                       bool sweep_flag,
+                       double x2, double y2) : 
+            m_arc(), m_radii_ok(false)
+        {
+            init(x1, y1, rx, ry, angle, large_arc_flag, sweep_flag, x2, y2);
+        }
+
+        //--------------------------------------------------------------------
+        void init(double x1, double y1, 
+                  double rx, double ry, 
+                  double angle,
+                  bool large_arc_flag,
+                  bool sweep_flag,
+                  double x2, double y2);
+
+        //--------------------------------------------------------------------
+        bool radii_ok() const { return m_radii_ok; }
+
+        //--------------------------------------------------------------------
+        void rewind(unsigned)
+        {
+            m_arc.rewind(0);
+        }
+
+        //--------------------------------------------------------------------
+        unsigned vertex(double* x, double* y)
+        {
+            return m_arc.vertex(x, y);
+        }
+
+        // Supplemantary functions. num_vertices() actually returns doubled 
+        // number of vertices. That is, for 1 vertex it returns 2.
+        //--------------------------------------------------------------------
+        unsigned  num_vertices() const { return m_arc.num_vertices(); }
+        const double* vertices() const { return m_arc.vertices();     }
+        double*       vertices()       { return m_arc.vertices();     }
+
+    private:
+        bezier_arc m_arc;
+        bool       m_radii_ok;
+    };
+
+
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_bitset_iterator.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bitset_iterator.h
--- 8.0.1-5/src/renderers/agg/include/agg_bitset_iterator.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bitset_iterator.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,54 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_BITSET_ITERATOR_INCLUDED
+#define AGG_BITSET_ITERATOR_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    
+    class bitset_iterator
+    {
+    public:
+        bitset_iterator(const int8u* bits, unsigned offset = 0) :
+            m_bits(bits + (offset >> 3)),
+            m_mask(0x80 >> (offset & 7))
+        {}
+
+        void operator ++ ()
+        {
+            m_mask >>= 1;
+            if(m_mask == 0)
+            {
+                ++m_bits;
+                m_mask = 0x80;
+            }
+        }
+
+        unsigned bit() const
+        {
+            return (*m_bits) & m_mask;
+        }
+
+    private:
+        const int8u* m_bits;
+        int8u        m_mask;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_blur.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_blur.h
--- 8.0.1-5/src/renderers/agg/include/agg_blur.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_blur.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1294 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// The Stack Blur Algorithm was invented by Mario Klingemann, 
+// mario@quasimondo.com and described here:
+// http://incubator.quasimondo.com/processing/fast_blur_deluxe.php
+// (search phrase "Stackblur: Fast But Goodlooking"). 
+// The major improvement is that there's no more division table
+// that was very expensive to create for large blur radii. Insted, 
+// for 8-bit per channel and radius not exceeding 254 the division is 
+// replaced by multiplication and shift. 
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_BLUR_INCLUDED
+#define AGG_BLUR_INCLUDED
+
+#include "agg_array.h"
+#include "agg_pixfmt_transposer.h"
+
+namespace mapserver
+{
+
+    template<class T> struct stack_blur_tables
+    {
+        static int16u const g_stack_blur8_mul[255];
+        static int8u  const g_stack_blur8_shr[255];
+    };
+
+    //------------------------------------------------------------------------
+    template<class T> 
+    int16u const stack_blur_tables<T>::g_stack_blur8_mul[255] = 
+    {
+        512,512,456,512,328,456,335,512,405,328,271,456,388,335,292,512,
+        454,405,364,328,298,271,496,456,420,388,360,335,312,292,273,512,
+        482,454,428,405,383,364,345,328,312,298,284,271,259,496,475,456,
+        437,420,404,388,374,360,347,335,323,312,302,292,282,273,265,512,
+        497,482,468,454,441,428,417,405,394,383,373,364,354,345,337,328,
+        320,312,305,298,291,284,278,271,265,259,507,496,485,475,465,456,
+        446,437,428,420,412,404,396,388,381,374,367,360,354,347,341,335,
+        329,323,318,312,307,302,297,292,287,282,278,273,269,265,261,512,
+        505,497,489,482,475,468,461,454,447,441,435,428,422,417,411,405,
+        399,394,389,383,378,373,368,364,359,354,350,345,341,337,332,328,
+        324,320,316,312,309,305,301,298,294,291,287,284,281,278,274,271,
+        268,265,262,259,257,507,501,496,491,485,480,475,470,465,460,456,
+        451,446,442,437,433,428,424,420,416,412,408,404,400,396,392,388,
+        385,381,377,374,370,367,363,360,357,354,350,347,344,341,338,335,
+        332,329,326,323,320,318,315,312,310,307,304,302,299,297,294,292,
+        289,287,285,282,280,278,275,273,271,269,267,265,263,261,259
+    };
+
+    //------------------------------------------------------------------------
+    template<class T> 
+    int8u const stack_blur_tables<T>::g_stack_blur8_shr[255] = 
+    {
+          9, 11, 12, 13, 13, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 17, 
+         17, 17, 17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 18, 19, 
+         19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20, 20, 20,
+         20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 21,
+         21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
+         21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 22, 22, 22, 22, 22, 22, 
+         22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
+         22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 23, 
+         23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
+         23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
+         23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 
+         23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 
+         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
+         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
+         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
+         24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24
+    };
+
+
+
+    //==============================================================stack_blur
+    template<class ColorT, class CalculatorT> class stack_blur
+    {
+    public:
+        typedef ColorT      color_type;
+        typedef CalculatorT calculator_type;
+
+        //--------------------------------------------------------------------
+        template<class Img> void blur_x(Img& img, unsigned radius)
+        {
+            if(radius < 1) return;
+
+            unsigned x, y, xp, i;
+            unsigned stack_ptr;
+            unsigned stack_start;
+
+            color_type      pix;
+            color_type*     stack_pix;
+            calculator_type sum;
+            calculator_type sum_in;
+            calculator_type sum_out;
+
+            unsigned w   = img.width();
+            unsigned h   = img.height();
+            unsigned wm  = w - 1;
+            unsigned div = radius * 2 + 1;
+
+            unsigned div_sum = (radius + 1) * (radius + 1);
+            unsigned mul_sum = 0;
+            unsigned shr_sum = 0;
+            unsigned max_val = color_type::base_mask;
+
+            if(max_val <= 255 && radius < 255)
+            {
+                mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[radius];
+                shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[radius];
+            }
+
+            m_buf.allocate(w, 128);
+            m_stack.allocate(div, 32);
+
+            for(y = 0; y < h; y++)
+            {
+                sum.clear();
+                sum_in.clear();
+                sum_out.clear();
+
+                pix = img.pixel(0, y);
+                for(i = 0; i <= radius; i++)
+                {
+                    m_stack[i] = pix;
+                    sum.add(pix, i + 1);
+                    sum_out.add(pix);
+                }
+                for(i = 1; i <= radius; i++)
+                {
+                    pix = img.pixel((i > wm) ? wm : i, y);
+                    m_stack[i + radius] = pix;
+                    sum.add(pix, radius + 1 - i);
+                    sum_in.add(pix);
+                }
+
+                stack_ptr = radius;
+                for(x = 0; x < w; x++)
+                {
+                    if(mul_sum) sum.calc_pix(m_buf[x], mul_sum, shr_sum);
+                    else        sum.calc_pix(m_buf[x], div_sum);
+
+                    sum.sub(sum_out);
+           
+                    stack_start = stack_ptr + div - radius;
+                    if(stack_start >= div) stack_start -= div;
+                    stack_pix = &m_stack[stack_start];
+
+                    sum_out.sub(*stack_pix);
+
+                    xp = x + radius + 1;
+                    if(xp > wm) xp = wm;
+                    pix = img.pixel(xp, y);
+            
+                    *stack_pix = pix;
+            
+                    sum_in.add(pix);
+                    sum.add(sum_in);
+            
+                    ++stack_ptr;
+                    if(stack_ptr >= div) stack_ptr = 0;
+                    stack_pix = &m_stack[stack_ptr];
+
+                    sum_out.add(*stack_pix);
+                    sum_in.sub(*stack_pix);
+                }
+                img.copy_color_hspan(0, y, w, &m_buf[0]);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class Img> void blur_y(Img& img, unsigned radius)
+        {
+            pixfmt_transposer<Img> img2(img);
+            blur_x(img2, radius);
+        }
+
+        //--------------------------------------------------------------------
+        template<class Img> void blur(Img& img, unsigned radius)
+        {
+            blur_x(img, radius);
+            pixfmt_transposer<Img> img2(img);
+            blur_x(img2, radius);
+        }
+
+    private:
+        pod_vector<color_type> m_buf;
+        pod_vector<color_type> m_stack;
+    };
+
+    //====================================================stack_blur_calc_rgba
+    template<class T=unsigned> struct stack_blur_calc_rgba
+    {
+        typedef T value_type;
+        value_type r,g,b,a;
+
+        AGG_INLINE void clear() 
+        { 
+            r = g = b = a = 0; 
+        }
+
+        template<class ArgT> AGG_INLINE void add(const ArgT& v)
+        {
+            r += v.r;
+            g += v.g;
+            b += v.b;
+            a += v.a;
+        }
+
+        template<class ArgT> AGG_INLINE void add(const ArgT& v, unsigned k)
+        {
+            r += v.r * k;
+            g += v.g * k;
+            b += v.b * k;
+            a += v.a * k;
+        }
+
+        template<class ArgT> AGG_INLINE void sub(const ArgT& v)
+        {
+            r -= v.r;
+            g -= v.g;
+            b -= v.b;
+            a -= v.a;
+        }
+
+        template<class ArgT> AGG_INLINE void calc_pix(ArgT& v, unsigned div)
+        {
+            typedef typename ArgT::value_type value_type;
+            v.r = value_type(r / div);
+            v.g = value_type(g / div);
+            v.b = value_type(b / div);
+            v.a = value_type(a / div);
+        }
+
+        template<class ArgT> 
+        AGG_INLINE void calc_pix(ArgT& v, unsigned mul, unsigned shr)
+        {
+            typedef typename ArgT::value_type value_type;
+            v.r = value_type((r * mul) >> shr);
+            v.g = value_type((g * mul) >> shr);
+            v.b = value_type((b * mul) >> shr);
+            v.a = value_type((a * mul) >> shr);
+        }
+    };
+
+
+    //=====================================================stack_blur_calc_rgb
+    template<class T=unsigned> struct stack_blur_calc_rgb
+    {
+        typedef T value_type;
+        value_type r,g,b;
+
+        AGG_INLINE void clear() 
+        { 
+            r = g = b = 0; 
+        }
+
+        template<class ArgT> AGG_INLINE void add(const ArgT& v)
+        {
+            r += v.r;
+            g += v.g;
+            b += v.b;
+        }
+
+        template<class ArgT> AGG_INLINE void add(const ArgT& v, unsigned k)
+        {
+            r += v.r * k;
+            g += v.g * k;
+            b += v.b * k;
+        }
+
+        template<class ArgT> AGG_INLINE void sub(const ArgT& v)
+        {
+            r -= v.r;
+            g -= v.g;
+            b -= v.b;
+        }
+
+        template<class ArgT> AGG_INLINE void calc_pix(ArgT& v, unsigned div)
+        {
+            typedef typename ArgT::value_type value_type;
+            v.r = value_type(r / div);
+            v.g = value_type(g / div);
+            v.b = value_type(b / div);
+        }
+
+        template<class ArgT> 
+        AGG_INLINE void calc_pix(ArgT& v, unsigned mul, unsigned shr)
+        {
+            typedef typename ArgT::value_type value_type;
+            v.r = value_type((r * mul) >> shr);
+            v.g = value_type((g * mul) >> shr);
+            v.b = value_type((b * mul) >> shr);
+        }
+    };
+
+
+    //====================================================stack_blur_calc_gray
+    template<class T=unsigned> struct stack_blur_calc_gray
+    {
+        typedef T value_type;
+        value_type v;
+
+        AGG_INLINE void clear() 
+        { 
+            v = 0; 
+        }
+
+        template<class ArgT> AGG_INLINE void add(const ArgT& a)
+        {
+            v += a.v;
+        }
+
+        template<class ArgT> AGG_INLINE void add(const ArgT& a, unsigned k)
+        {
+            v += a.v * k;
+        }
+
+        template<class ArgT> AGG_INLINE void sub(const ArgT& a)
+        {
+            v -= a.v;
+        }
+
+        template<class ArgT> AGG_INLINE void calc_pix(ArgT& a, unsigned div)
+        {
+            typedef typename ArgT::value_type value_type;
+            a.v = value_type(v / div);
+        }
+
+        template<class ArgT> 
+        AGG_INLINE void calc_pix(ArgT& a, unsigned mul, unsigned shr)
+        {
+            typedef typename ArgT::value_type value_type;
+            a.v = value_type((v * mul) >> shr);
+        }
+    };
+
+
+
+    //========================================================stack_blur_gray8
+    template<class Img> 
+    void stack_blur_gray8(Img& img, unsigned rx, unsigned ry)
+    {
+        unsigned x, y, xp, yp, i;
+        unsigned stack_ptr;
+        unsigned stack_start;
+
+        const int8u* src_pix_ptr;
+              int8u* dst_pix_ptr;
+        unsigned pix;
+        unsigned stack_pix;
+        unsigned sum;
+        unsigned sum_in;
+        unsigned sum_out;
+
+        unsigned w   = img.width();
+        unsigned h   = img.height();
+        unsigned wm  = w - 1;
+        unsigned hm  = h - 1;
+
+        unsigned div;
+        unsigned mul_sum;
+        unsigned shr_sum;
+
+        pod_vector<int8u> stack;
+
+        if(rx > 0)
+        {
+            if(rx > 254) rx = 254;
+            div = rx * 2 + 1;
+            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[rx];
+            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[rx];
+            stack.allocate(div);
+
+            for(y = 0; y < h; y++)
+            {
+                sum = sum_in = sum_out = 0;
+
+                src_pix_ptr = img.pix_ptr(0, y);
+                pix = *src_pix_ptr;
+                for(i = 0; i <= rx; i++)
+                {
+                    stack[i] = pix;
+                    sum     += pix * (i + 1);
+                    sum_out += pix;
+                }
+                for(i = 1; i <= rx; i++)
+                {
+                    if(i <= wm) src_pix_ptr += Img::pix_step; 
+                    pix = *src_pix_ptr; 
+                    stack[i + rx] = pix;
+                    sum    += pix * (rx + 1 - i);
+                    sum_in += pix;
+                }
+
+                stack_ptr = rx;
+                xp = rx;
+                if(xp > wm) xp = wm;
+                src_pix_ptr = img.pix_ptr(xp, y);
+                dst_pix_ptr = img.pix_ptr(0, y);
+                for(x = 0; x < w; x++)
+                {
+                    *dst_pix_ptr = (sum * mul_sum) >> shr_sum;
+                    dst_pix_ptr += Img::pix_step;
+
+                    sum -= sum_out;
+       
+                    stack_start = stack_ptr + div - rx;
+                    if(stack_start >= div) stack_start -= div;
+                    sum_out -= stack[stack_start];
+
+                    if(xp < wm) 
+                    {
+                        src_pix_ptr += Img::pix_step;
+                        pix = *src_pix_ptr;
+                        ++xp;
+                    }
+        
+                    stack[stack_start] = pix;
+        
+                    sum_in += pix;
+                    sum    += sum_in;
+        
+                    ++stack_ptr;
+                    if(stack_ptr >= div) stack_ptr = 0;
+                    stack_pix = stack[stack_ptr];
+
+                    sum_out += stack_pix;
+                    sum_in  -= stack_pix;
+                }
+            }
+        }
+
+        if(ry > 0)
+        {
+            if(ry > 254) ry = 254;
+            div = ry * 2 + 1;
+            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[ry];
+            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[ry];
+            stack.allocate(div);
+
+            int stride = img.stride();
+            for(x = 0; x < w; x++)
+            {
+                sum = sum_in = sum_out = 0;
+
+                src_pix_ptr = img.pix_ptr(x, 0);
+                pix = *src_pix_ptr;
+                for(i = 0; i <= ry; i++)
+                {
+                    stack[i] = pix;
+                    sum     += pix * (i + 1);
+                    sum_out += pix;
+                }
+                for(i = 1; i <= ry; i++)
+                {
+                    if(i <= hm) src_pix_ptr += stride; 
+                    pix = *src_pix_ptr; 
+                    stack[i + ry] = pix;
+                    sum    += pix * (ry + 1 - i);
+                    sum_in += pix;
+                }
+
+                stack_ptr = ry;
+                yp = ry;
+                if(yp > hm) yp = hm;
+                src_pix_ptr = img.pix_ptr(x, yp);
+                dst_pix_ptr = img.pix_ptr(x, 0);
+                for(y = 0; y < h; y++)
+                {
+                    *dst_pix_ptr = (sum * mul_sum) >> shr_sum;
+                    dst_pix_ptr += stride;
+
+                    sum -= sum_out;
+       
+                    stack_start = stack_ptr + div - ry;
+                    if(stack_start >= div) stack_start -= div;
+                    sum_out -= stack[stack_start];
+
+                    if(yp < hm) 
+                    {
+                        src_pix_ptr += stride;
+                        pix = *src_pix_ptr;
+                        ++yp;
+                    }
+        
+                    stack[stack_start] = pix;
+        
+                    sum_in += pix;
+                    sum    += sum_in;
+        
+                    ++stack_ptr;
+                    if(stack_ptr >= div) stack_ptr = 0;
+                    stack_pix = stack[stack_ptr];
+
+                    sum_out += stack_pix;
+                    sum_in  -= stack_pix;
+                }
+            }
+        }
+    }
+
+
+
+    //========================================================stack_blur_rgb24
+    template<class Img> 
+    void stack_blur_rgb24(Img& img, unsigned rx, unsigned ry)
+    {
+        typedef typename Img::color_type color_type;
+        typedef typename Img::order_type order_type;
+        enum order_e 
+        { 
+            R = order_type::R, 
+            G = order_type::G, 
+            B = order_type::B 
+        };
+
+        unsigned x, y, xp, yp, i;
+        unsigned stack_ptr;
+        unsigned stack_start;
+
+        const int8u* src_pix_ptr;
+              int8u* dst_pix_ptr;
+        color_type*  stack_pix_ptr;
+
+        unsigned sum_r;
+        unsigned sum_g;
+        unsigned sum_b;
+        unsigned sum_in_r;
+        unsigned sum_in_g;
+        unsigned sum_in_b;
+        unsigned sum_out_r;
+        unsigned sum_out_g;
+        unsigned sum_out_b;
+
+        unsigned w   = img.width();
+        unsigned h   = img.height();
+        unsigned wm  = w - 1;
+        unsigned hm  = h - 1;
+
+        unsigned div;
+        unsigned mul_sum;
+        unsigned shr_sum;
+
+        pod_vector<color_type> stack;
+
+        if(rx > 0)
+        {
+            if(rx > 254) rx = 254;
+            div = rx * 2 + 1;
+            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[rx];
+            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[rx];
+            stack.allocate(div);
+
+            for(y = 0; y < h; y++)
+            {
+                sum_r = 
+                sum_g = 
+                sum_b = 
+                sum_in_r = 
+                sum_in_g = 
+                sum_in_b = 
+                sum_out_r = 
+                sum_out_g = 
+                sum_out_b = 0;
+
+                src_pix_ptr = img.pix_ptr(0, y);
+                for(i = 0; i <= rx; i++)
+                {
+                    stack_pix_ptr    = &stack[i];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    sum_r           += src_pix_ptr[R] * (i + 1);
+                    sum_g           += src_pix_ptr[G] * (i + 1);
+                    sum_b           += src_pix_ptr[B] * (i + 1);
+                    sum_out_r       += src_pix_ptr[R];
+                    sum_out_g       += src_pix_ptr[G];
+                    sum_out_b       += src_pix_ptr[B];
+                }
+                for(i = 1; i <= rx; i++)
+                {
+                    if(i <= wm) src_pix_ptr += Img::pix_width; 
+                    stack_pix_ptr = &stack[i + rx];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    sum_r           += src_pix_ptr[R] * (rx + 1 - i);
+                    sum_g           += src_pix_ptr[G] * (rx + 1 - i);
+                    sum_b           += src_pix_ptr[B] * (rx + 1 - i);
+                    sum_in_r        += src_pix_ptr[R];
+                    sum_in_g        += src_pix_ptr[G];
+                    sum_in_b        += src_pix_ptr[B];
+                }
+
+                stack_ptr = rx;
+                xp = rx;
+                if(xp > wm) xp = wm;
+                src_pix_ptr = img.pix_ptr(xp, y);
+                dst_pix_ptr = img.pix_ptr(0, y);
+                for(x = 0; x < w; x++)
+                {
+                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
+                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
+                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
+                    dst_pix_ptr   += Img::pix_width;
+
+                    sum_r -= sum_out_r;
+                    sum_g -= sum_out_g;
+                    sum_b -= sum_out_b;
+       
+                    stack_start = stack_ptr + div - rx;
+                    if(stack_start >= div) stack_start -= div;
+                    stack_pix_ptr = &stack[stack_start];
+
+                    sum_out_r -= stack_pix_ptr->r;
+                    sum_out_g -= stack_pix_ptr->g;
+                    sum_out_b -= stack_pix_ptr->b;
+
+                    if(xp < wm) 
+                    {
+                        src_pix_ptr += Img::pix_width;
+                        ++xp;
+                    }
+        
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+        
+                    sum_in_r += src_pix_ptr[R];
+                    sum_in_g += src_pix_ptr[G];
+                    sum_in_b += src_pix_ptr[B];
+                    sum_r    += sum_in_r;
+                    sum_g    += sum_in_g;
+                    sum_b    += sum_in_b;
+        
+                    ++stack_ptr;
+                    if(stack_ptr >= div) stack_ptr = 0;
+                    stack_pix_ptr = &stack[stack_ptr];
+
+                    sum_out_r += stack_pix_ptr->r;
+                    sum_out_g += stack_pix_ptr->g;
+                    sum_out_b += stack_pix_ptr->b;
+                    sum_in_r  -= stack_pix_ptr->r;
+                    sum_in_g  -= stack_pix_ptr->g;
+                    sum_in_b  -= stack_pix_ptr->b;
+                }
+            }
+        }
+
+        if(ry > 0)
+        {
+            if(ry > 254) ry = 254;
+            div = ry * 2 + 1;
+            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[ry];
+            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[ry];
+            stack.allocate(div);
+
+            int stride = img.stride();
+            for(x = 0; x < w; x++)
+            {
+                sum_r = 
+                sum_g = 
+                sum_b = 
+                sum_in_r = 
+                sum_in_g = 
+                sum_in_b = 
+                sum_out_r = 
+                sum_out_g = 
+                sum_out_b = 0;
+
+                src_pix_ptr = img.pix_ptr(x, 0);
+                for(i = 0; i <= ry; i++)
+                {
+                    stack_pix_ptr    = &stack[i];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    sum_r           += src_pix_ptr[R] * (i + 1);
+                    sum_g           += src_pix_ptr[G] * (i + 1);
+                    sum_b           += src_pix_ptr[B] * (i + 1);
+                    sum_out_r       += src_pix_ptr[R];
+                    sum_out_g       += src_pix_ptr[G];
+                    sum_out_b       += src_pix_ptr[B];
+                }
+                for(i = 1; i <= ry; i++)
+                {
+                    if(i <= hm) src_pix_ptr += stride; 
+                    stack_pix_ptr = &stack[i + ry];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    sum_r           += src_pix_ptr[R] * (ry + 1 - i);
+                    sum_g           += src_pix_ptr[G] * (ry + 1 - i);
+                    sum_b           += src_pix_ptr[B] * (ry + 1 - i);
+                    sum_in_r        += src_pix_ptr[R];
+                    sum_in_g        += src_pix_ptr[G];
+                    sum_in_b        += src_pix_ptr[B];
+                }
+
+                stack_ptr = ry;
+                yp = ry;
+                if(yp > hm) yp = hm;
+                src_pix_ptr = img.pix_ptr(x, yp);
+                dst_pix_ptr = img.pix_ptr(x, 0);
+                for(y = 0; y < h; y++)
+                {
+                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
+                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
+                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
+                    dst_pix_ptr += stride;
+
+                    sum_r -= sum_out_r;
+                    sum_g -= sum_out_g;
+                    sum_b -= sum_out_b;
+       
+                    stack_start = stack_ptr + div - ry;
+                    if(stack_start >= div) stack_start -= div;
+
+                    stack_pix_ptr = &stack[stack_start];
+                    sum_out_r -= stack_pix_ptr->r;
+                    sum_out_g -= stack_pix_ptr->g;
+                    sum_out_b -= stack_pix_ptr->b;
+
+                    if(yp < hm) 
+                    {
+                        src_pix_ptr += stride;
+                        ++yp;
+                    }
+        
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+        
+                    sum_in_r += src_pix_ptr[R];
+                    sum_in_g += src_pix_ptr[G];
+                    sum_in_b += src_pix_ptr[B];
+                    sum_r    += sum_in_r;
+                    sum_g    += sum_in_g;
+                    sum_b    += sum_in_b;
+        
+                    ++stack_ptr;
+                    if(stack_ptr >= div) stack_ptr = 0;
+                    stack_pix_ptr = &stack[stack_ptr];
+
+                    sum_out_r += stack_pix_ptr->r;
+                    sum_out_g += stack_pix_ptr->g;
+                    sum_out_b += stack_pix_ptr->b;
+                    sum_in_r  -= stack_pix_ptr->r;
+                    sum_in_g  -= stack_pix_ptr->g;
+                    sum_in_b  -= stack_pix_ptr->b;
+                }
+            }
+        }
+    }
+
+
+
+    //=======================================================stack_blur_rgba32
+    template<class Img> 
+    void stack_blur_rgba32(Img& img, unsigned rx, unsigned ry)
+    {
+        typedef typename Img::color_type color_type;
+        typedef typename Img::order_type order_type;
+        enum order_e 
+        { 
+            R = order_type::R, 
+            G = order_type::G, 
+            B = order_type::B,
+            A = order_type::A 
+        };
+
+        unsigned x, y, xp, yp, i;
+        unsigned stack_ptr;
+        unsigned stack_start;
+
+        const int8u* src_pix_ptr;
+              int8u* dst_pix_ptr;
+        color_type*  stack_pix_ptr;
+
+        unsigned sum_r;
+        unsigned sum_g;
+        unsigned sum_b;
+        unsigned sum_a;
+        unsigned sum_in_r;
+        unsigned sum_in_g;
+        unsigned sum_in_b;
+        unsigned sum_in_a;
+        unsigned sum_out_r;
+        unsigned sum_out_g;
+        unsigned sum_out_b;
+        unsigned sum_out_a;
+
+        unsigned w   = img.width();
+        unsigned h   = img.height();
+        unsigned wm  = w - 1;
+        unsigned hm  = h - 1;
+
+        unsigned div;
+        unsigned mul_sum;
+        unsigned shr_sum;
+
+        pod_vector<color_type> stack;
+
+        if(rx > 0)
+        {
+            if(rx > 254) rx = 254;
+            div = rx * 2 + 1;
+            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[rx];
+            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[rx];
+            stack.allocate(div);
+
+            for(y = 0; y < h; y++)
+            {
+                sum_r = 
+                sum_g = 
+                sum_b = 
+                sum_a = 
+                sum_in_r = 
+                sum_in_g = 
+                sum_in_b = 
+                sum_in_a = 
+                sum_out_r = 
+                sum_out_g = 
+                sum_out_b = 
+                sum_out_a = 0;
+
+                src_pix_ptr = img.pix_ptr(0, y);
+                for(i = 0; i <= rx; i++)
+                {
+                    stack_pix_ptr    = &stack[i];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    stack_pix_ptr->a = src_pix_ptr[A];
+                    sum_r           += src_pix_ptr[R] * (i + 1);
+                    sum_g           += src_pix_ptr[G] * (i + 1);
+                    sum_b           += src_pix_ptr[B] * (i + 1);
+                    sum_a           += src_pix_ptr[A] * (i + 1);
+                    sum_out_r       += src_pix_ptr[R];
+                    sum_out_g       += src_pix_ptr[G];
+                    sum_out_b       += src_pix_ptr[B];
+                    sum_out_a       += src_pix_ptr[A];
+                }
+                for(i = 1; i <= rx; i++)
+                {
+                    if(i <= wm) src_pix_ptr += Img::pix_width; 
+                    stack_pix_ptr = &stack[i + rx];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    stack_pix_ptr->a = src_pix_ptr[A];
+                    sum_r           += src_pix_ptr[R] * (rx + 1 - i);
+                    sum_g           += src_pix_ptr[G] * (rx + 1 - i);
+                    sum_b           += src_pix_ptr[B] * (rx + 1 - i);
+                    sum_a           += src_pix_ptr[A] * (rx + 1 - i);
+                    sum_in_r        += src_pix_ptr[R];
+                    sum_in_g        += src_pix_ptr[G];
+                    sum_in_b        += src_pix_ptr[B];
+                    sum_in_a        += src_pix_ptr[A];
+                }
+
+                stack_ptr = rx;
+                xp = rx;
+                if(xp > wm) xp = wm;
+                src_pix_ptr = img.pix_ptr(xp, y);
+                dst_pix_ptr = img.pix_ptr(0, y);
+                for(x = 0; x < w; x++)
+                {
+                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
+                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
+                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
+                    dst_pix_ptr[A] = (sum_a * mul_sum) >> shr_sum;
+                    dst_pix_ptr += Img::pix_width;
+
+                    sum_r -= sum_out_r;
+                    sum_g -= sum_out_g;
+                    sum_b -= sum_out_b;
+                    sum_a -= sum_out_a;
+       
+                    stack_start = stack_ptr + div - rx;
+                    if(stack_start >= div) stack_start -= div;
+                    stack_pix_ptr = &stack[stack_start];
+
+                    sum_out_r -= stack_pix_ptr->r;
+                    sum_out_g -= stack_pix_ptr->g;
+                    sum_out_b -= stack_pix_ptr->b;
+                    sum_out_a -= stack_pix_ptr->a;
+
+                    if(xp < wm) 
+                    {
+                        src_pix_ptr += Img::pix_width;
+                        ++xp;
+                    }
+        
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    stack_pix_ptr->a = src_pix_ptr[A];
+        
+                    sum_in_r += src_pix_ptr[R];
+                    sum_in_g += src_pix_ptr[G];
+                    sum_in_b += src_pix_ptr[B];
+                    sum_in_a += src_pix_ptr[A];
+                    sum_r    += sum_in_r;
+                    sum_g    += sum_in_g;
+                    sum_b    += sum_in_b;
+                    sum_a    += sum_in_a;
+        
+                    ++stack_ptr;
+                    if(stack_ptr >= div) stack_ptr = 0;
+                    stack_pix_ptr = &stack[stack_ptr];
+
+                    sum_out_r += stack_pix_ptr->r;
+                    sum_out_g += stack_pix_ptr->g;
+                    sum_out_b += stack_pix_ptr->b;
+                    sum_out_a += stack_pix_ptr->a;
+                    sum_in_r  -= stack_pix_ptr->r;
+                    sum_in_g  -= stack_pix_ptr->g;
+                    sum_in_b  -= stack_pix_ptr->b;
+                    sum_in_a  -= stack_pix_ptr->a;
+                }
+            }
+        }
+
+        if(ry > 0)
+        {
+            if(ry > 254) ry = 254;
+            div = ry * 2 + 1;
+            mul_sum = stack_blur_tables<int>::g_stack_blur8_mul[ry];
+            shr_sum = stack_blur_tables<int>::g_stack_blur8_shr[ry];
+            stack.allocate(div);
+
+            int stride = img.stride();
+            for(x = 0; x < w; x++)
+            {
+                sum_r = 
+                sum_g = 
+                sum_b = 
+                sum_a = 
+                sum_in_r = 
+                sum_in_g = 
+                sum_in_b = 
+                sum_in_a = 
+                sum_out_r = 
+                sum_out_g = 
+                sum_out_b = 
+                sum_out_a = 0;
+
+                src_pix_ptr = img.pix_ptr(x, 0);
+                for(i = 0; i <= ry; i++)
+                {
+                    stack_pix_ptr    = &stack[i];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    stack_pix_ptr->a = src_pix_ptr[A];
+                    sum_r           += src_pix_ptr[R] * (i + 1);
+                    sum_g           += src_pix_ptr[G] * (i + 1);
+                    sum_b           += src_pix_ptr[B] * (i + 1);
+                    sum_a           += src_pix_ptr[A] * (i + 1);
+                    sum_out_r       += src_pix_ptr[R];
+                    sum_out_g       += src_pix_ptr[G];
+                    sum_out_b       += src_pix_ptr[B];
+                    sum_out_a       += src_pix_ptr[A];
+                }
+                for(i = 1; i <= ry; i++)
+                {
+                    if(i <= hm) src_pix_ptr += stride; 
+                    stack_pix_ptr = &stack[i + ry];
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    stack_pix_ptr->a = src_pix_ptr[A];
+                    sum_r           += src_pix_ptr[R] * (ry + 1 - i);
+                    sum_g           += src_pix_ptr[G] * (ry + 1 - i);
+                    sum_b           += src_pix_ptr[B] * (ry + 1 - i);
+                    sum_a           += src_pix_ptr[A] * (ry + 1 - i);
+                    sum_in_r        += src_pix_ptr[R];
+                    sum_in_g        += src_pix_ptr[G];
+                    sum_in_b        += src_pix_ptr[B];
+                    sum_in_a        += src_pix_ptr[A];
+                }
+
+                stack_ptr = ry;
+                yp = ry;
+                if(yp > hm) yp = hm;
+                src_pix_ptr = img.pix_ptr(x, yp);
+                dst_pix_ptr = img.pix_ptr(x, 0);
+                for(y = 0; y < h; y++)
+                {
+                    dst_pix_ptr[R] = (sum_r * mul_sum) >> shr_sum;
+                    dst_pix_ptr[G] = (sum_g * mul_sum) >> shr_sum;
+                    dst_pix_ptr[B] = (sum_b * mul_sum) >> shr_sum;
+                    dst_pix_ptr[A] = (sum_a * mul_sum) >> shr_sum;
+                    dst_pix_ptr += stride;
+
+                    sum_r -= sum_out_r;
+                    sum_g -= sum_out_g;
+                    sum_b -= sum_out_b;
+                    sum_a -= sum_out_a;
+       
+                    stack_start = stack_ptr + div - ry;
+                    if(stack_start >= div) stack_start -= div;
+
+                    stack_pix_ptr = &stack[stack_start];
+                    sum_out_r -= stack_pix_ptr->r;
+                    sum_out_g -= stack_pix_ptr->g;
+                    sum_out_b -= stack_pix_ptr->b;
+                    sum_out_a -= stack_pix_ptr->a;
+
+                    if(yp < hm) 
+                    {
+                        src_pix_ptr += stride;
+                        ++yp;
+                    }
+        
+                    stack_pix_ptr->r = src_pix_ptr[R];
+                    stack_pix_ptr->g = src_pix_ptr[G];
+                    stack_pix_ptr->b = src_pix_ptr[B];
+                    stack_pix_ptr->a = src_pix_ptr[A];
+        
+                    sum_in_r += src_pix_ptr[R];
+                    sum_in_g += src_pix_ptr[G];
+                    sum_in_b += src_pix_ptr[B];
+                    sum_in_a += src_pix_ptr[A];
+                    sum_r    += sum_in_r;
+                    sum_g    += sum_in_g;
+                    sum_b    += sum_in_b;
+                    sum_a    += sum_in_a;
+        
+                    ++stack_ptr;
+                    if(stack_ptr >= div) stack_ptr = 0;
+                    stack_pix_ptr = &stack[stack_ptr];
+
+                    sum_out_r += stack_pix_ptr->r;
+                    sum_out_g += stack_pix_ptr->g;
+                    sum_out_b += stack_pix_ptr->b;
+                    sum_out_a += stack_pix_ptr->a;
+                    sum_in_r  -= stack_pix_ptr->r;
+                    sum_in_g  -= stack_pix_ptr->g;
+                    sum_in_b  -= stack_pix_ptr->b;
+                    sum_in_a  -= stack_pix_ptr->a;
+                }
+            }
+        }
+    }
+
+
+
+    //===========================================================recursive_blur
+    template<class ColorT, class CalculatorT> class recursive_blur
+    {
+    public:
+        typedef ColorT color_type;
+        typedef CalculatorT calculator_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename calculator_type::value_type calc_type;
+
+        //--------------------------------------------------------------------
+        template<class Img> void blur_x(Img& img, double radius)
+        {
+            if(radius < 0.62) return;
+            if(img.width() < 3) return;
+
+            calc_type s = calc_type(radius * 0.5);
+            calc_type q = calc_type((s < 2.5) ?
+                                    3.97156 - 4.14554 * sqrt(1 - 0.26891 * s) :
+                                    0.98711 * s - 0.96330);
+
+            calc_type q2 = calc_type(q * q);
+            calc_type q3 = calc_type(q2 * q);
+
+            calc_type b0 = calc_type(1.0 / (1.578250 + 
+                                            2.444130 * q + 
+                                            1.428100 * q2 + 
+                                            0.422205 * q3));
+
+            calc_type b1 = calc_type( 2.44413 * q + 
+                                      2.85619 * q2 + 
+                                      1.26661 * q3);
+
+            calc_type b2 = calc_type(-1.42810 * q2 + 
+                                     -1.26661 * q3);
+
+            calc_type b3 = calc_type(0.422205 * q3);
+
+            calc_type b  = calc_type(1 - (b1 + b2 + b3) * b0);
+
+            b1 *= b0;
+            b2 *= b0;
+            b3 *= b0;
+
+            int w = img.width();
+            int h = img.height();
+            int wm = w-1;
+            int x, y;
+
+            m_sum1.allocate(w);
+            m_sum2.allocate(w);
+            m_buf.allocate(w);
+
+            for(y = 0; y < h; y++)
+            {
+                calculator_type c;
+                c.from_pix(img.pixel(0, y));
+                m_sum1[0].calc(b, b1, b2, b3, c, c, c, c);
+                c.from_pix(img.pixel(1, y));
+                m_sum1[1].calc(b, b1, b2, b3, c, m_sum1[0], m_sum1[0], m_sum1[0]);
+                c.from_pix(img.pixel(2, y));
+                m_sum1[2].calc(b, b1, b2, b3, c, m_sum1[1], m_sum1[0], m_sum1[0]);
+
+                for(x = 3; x < w; ++x)
+                {
+                    c.from_pix(img.pixel(x, y));
+                    m_sum1[x].calc(b, b1, b2, b3, c, m_sum1[x-1], m_sum1[x-2], m_sum1[x-3]);
+                }
+    
+                m_sum2[wm  ].calc(b, b1, b2, b3, m_sum1[wm  ], m_sum1[wm  ], m_sum1[wm], m_sum1[wm]);
+                m_sum2[wm-1].calc(b, b1, b2, b3, m_sum1[wm-1], m_sum2[wm  ], m_sum2[wm], m_sum2[wm]);
+                m_sum2[wm-2].calc(b, b1, b2, b3, m_sum1[wm-2], m_sum2[wm-1], m_sum2[wm], m_sum2[wm]);
+                m_sum2[wm  ].to_pix(m_buf[wm  ]);
+                m_sum2[wm-1].to_pix(m_buf[wm-1]);
+                m_sum2[wm-2].to_pix(m_buf[wm-2]);
+
+                for(x = wm-3; x >= 0; --x)
+                {
+                    m_sum2[x].calc(b, b1, b2, b3, m_sum1[x], m_sum2[x+1], m_sum2[x+2], m_sum2[x+3]);
+                    m_sum2[x].to_pix(m_buf[x]);
+                }
+                img.copy_color_hspan(0, y, w, &m_buf[0]);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class Img> void blur_y(Img& img, double radius)
+        {
+            pixfmt_transposer<Img> img2(img);
+            blur_x(img2, radius);
+        }
+
+        //--------------------------------------------------------------------
+        template<class Img> void blur(Img& img, double radius)
+        {
+            blur_x(img, radius);
+            pixfmt_transposer<Img> img2(img);
+            blur_x(img2, radius);
+        }
+
+    private:
+        mapserver::pod_vector<calculator_type> m_sum1;
+        mapserver::pod_vector<calculator_type> m_sum2;
+        mapserver::pod_vector<color_type>      m_buf;
+    };
+
+
+    //=================================================recursive_blur_calc_rgba
+    template<class T=double> struct recursive_blur_calc_rgba
+    {
+        typedef T value_type;
+        typedef recursive_blur_calc_rgba<T> self_type;
+
+        value_type r,g,b,a;
+
+        template<class ColorT> 
+        AGG_INLINE void from_pix(const ColorT& c)
+        {
+            r = c.r;
+            g = c.g;
+            b = c.b;
+            a = c.a;
+        }
+
+        AGG_INLINE void calc(value_type b1, 
+                             value_type b2, 
+                             value_type b3, 
+                             value_type b4,
+                             const self_type& c1, 
+                             const self_type& c2, 
+                             const self_type& c3, 
+                             const self_type& c4)
+        {
+            r = b1*c1.r + b2*c2.r + b3*c3.r + b4*c4.r;
+            g = b1*c1.g + b2*c2.g + b3*c3.g + b4*c4.g;
+            b = b1*c1.b + b2*c2.b + b3*c3.b + b4*c4.b;
+            a = b1*c1.a + b2*c2.a + b3*c3.a + b4*c4.a;
+        }
+
+        template<class ColorT> 
+        AGG_INLINE void to_pix(ColorT& c) const
+        {
+            typedef typename ColorT::value_type cv_type;
+            c.r = (cv_type)uround(r);
+            c.g = (cv_type)uround(g);
+            c.b = (cv_type)uround(b);
+            c.a = (cv_type)uround(a);
+        }
+    };
+
+
+    //=================================================recursive_blur_calc_rgb
+    template<class T=double> struct recursive_blur_calc_rgb
+    {
+        typedef T value_type;
+        typedef recursive_blur_calc_rgb<T> self_type;
+
+        value_type r,g,b;
+
+        template<class ColorT> 
+        AGG_INLINE void from_pix(const ColorT& c)
+        {
+            r = c.r;
+            g = c.g;
+            b = c.b;
+        }
+
+        AGG_INLINE void calc(value_type b1, 
+                             value_type b2, 
+                             value_type b3, 
+                             value_type b4,
+                             const self_type& c1, 
+                             const self_type& c2, 
+                             const self_type& c3, 
+                             const self_type& c4)
+        {
+            r = b1*c1.r + b2*c2.r + b3*c3.r + b4*c4.r;
+            g = b1*c1.g + b2*c2.g + b3*c3.g + b4*c4.g;
+            b = b1*c1.b + b2*c2.b + b3*c3.b + b4*c4.b;
+        }
+
+        template<class ColorT> 
+        AGG_INLINE void to_pix(ColorT& c) const
+        {
+            typedef typename ColorT::value_type cv_type;
+            c.r = (cv_type)uround(r);
+            c.g = (cv_type)uround(g);
+            c.b = (cv_type)uround(b);
+        }
+    };
+
+
+    //================================================recursive_blur_calc_gray
+    template<class T=double> struct recursive_blur_calc_gray
+    {
+        typedef T value_type;
+        typedef recursive_blur_calc_gray<T> self_type;
+
+        value_type v;
+
+        template<class ColorT> 
+        AGG_INLINE void from_pix(const ColorT& c)
+        {
+            v = c.v;
+        }
+
+        AGG_INLINE void calc(value_type b1, 
+                             value_type b2, 
+                             value_type b3, 
+                             value_type b4,
+                             const self_type& c1, 
+                             const self_type& c2, 
+                             const self_type& c3, 
+                             const self_type& c4)
+        {
+            v = b1*c1.v + b2*c2.v + b3*c3.v + b4*c4.v;
+        }
+
+        template<class ColorT> 
+        AGG_INLINE void to_pix(ColorT& c) const
+        {
+            typedef typename ColorT::value_type cv_type;
+            c.v = (cv_type)uround(v);
+        }
+    };
+
+}
+
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_bounding_rect.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bounding_rect.h
--- 8.0.1-5/src/renderers/agg/include/agg_bounding_rect.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bounding_rect.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,116 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// bounding_rect function template
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_BOUNDING_RECT_INCLUDED
+#define AGG_BOUNDING_RECT_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------------bounding_rect
+    template<class VertexSource, class GetId, class CoordT>
+    bool bounding_rect(VertexSource& vs, GetId& gi, 
+                       unsigned start, unsigned num, 
+                       CoordT* x1, CoordT* y1, CoordT* x2, CoordT* y2)
+    {
+        unsigned i;
+        double x;
+        double y;
+        bool first = true;
+
+        *x1 = CoordT(1);
+        *y1 = CoordT(1);
+        *x2 = CoordT(0);
+        *y2 = CoordT(0);
+
+        for(i = 0; i < num; i++)
+        {
+            vs.rewind(gi[start + i]);
+            unsigned cmd;
+            while(!is_stop(cmd = vs.vertex(&x, &y)))
+            {
+                if(is_vertex(cmd))
+                {
+                    if(first)
+                    {
+                        *x1 = CoordT(x);
+                        *y1 = CoordT(y);
+                        *x2 = CoordT(x);
+                        *y2 = CoordT(y);
+                        first = false;
+                    }
+                    else
+                    {
+                        if(CoordT(x) < *x1) *x1 = CoordT(x);
+                        if(CoordT(y) < *y1) *y1 = CoordT(y);
+                        if(CoordT(x) > *x2) *x2 = CoordT(x);
+                        if(CoordT(y) > *y2) *y2 = CoordT(y);
+                    }
+                }
+            }
+        }
+        return *x1 <= *x2 && *y1 <= *y2;
+    }
+
+
+    //-----------------------------------------------------bounding_rect_single
+    template<class VertexSource, class CoordT> 
+    bool bounding_rect_single(VertexSource& vs, unsigned path_id,
+                              CoordT* x1, CoordT* y1, CoordT* x2, CoordT* y2)
+    {
+        double x;
+        double y;
+        bool first = true;
+
+        *x1 = CoordT(1);
+        *y1 = CoordT(1);
+        *x2 = CoordT(0);
+        *y2 = CoordT(0);
+
+        vs.rewind(path_id);
+        unsigned cmd;
+        while(!is_stop(cmd = vs.vertex(&x, &y)))
+        {
+            if(is_vertex(cmd))
+            {
+                if(first)
+                {
+                    *x1 = CoordT(x);
+                    *y1 = CoordT(y);
+                    *x2 = CoordT(x);
+                    *y2 = CoordT(y);
+                    first = false;
+                }
+                else
+                {
+                    if(CoordT(x) < *x1) *x1 = CoordT(x);
+                    if(CoordT(y) < *y1) *y1 = CoordT(y);
+                    if(CoordT(x) > *x2) *x2 = CoordT(x);
+                    if(CoordT(y) > *y2) *y2 = CoordT(y);
+                }
+            }
+        }
+        return *x1 <= *x2 && *y1 <= *y2;
+    }
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_bspline.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bspline.h
--- 8.0.1-5/src/renderers/agg/include/agg_bspline.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_bspline.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,76 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class bspline
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_BSPLINE_INCLUDED
+#define AGG_BSPLINE_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+    //----------------------------------------------------------------bspline
+    // A very simple class of Bi-cubic Spline interpolation.
+    // First call init(num, x[], y[]) where num - number of source points, 
+    // x, y - arrays of X and Y values respectively. Here Y must be a function 
+    // of X. It means that all the X-coordinates must be arranged in the ascending
+    // order. 
+    // Then call get(x) that calculates a value Y for the respective X. 
+    // The class supports extrapolation, i.e. you can call get(x) where x is
+    // outside the given with init() X-range. Extrapolation is a simple linear 
+    // function.
+    //
+    //  See Implementation agg_bspline.cpp
+    //------------------------------------------------------------------------
+    class bspline 
+    {
+    public:
+        bspline();
+        bspline(int num);
+        bspline(int num, const double* x, const double* y);
+
+        void   init(int num);
+        void   add_point(double x, double y);
+        void   prepare();
+
+        void   init(int num, const double* x, const double* y);
+
+        double get(double x) const;
+        double get_stateful(double x) const;
+    
+    private:
+        bspline(const bspline&);
+        const bspline& operator = (const bspline&);
+
+        static void bsearch(int n, const double *x, double x0, int *i);
+        double extrapolation_left(double x) const;
+        double extrapolation_right(double x) const;
+        double interpolation(double x, int i) const;
+
+        int               m_max;
+        int               m_num;
+        double*           m_x;
+        double*           m_y;
+        pod_array<double> m_am;
+        mutable int       m_last_idx;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_clip_liang_barsky.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_clip_liang_barsky.h
--- 8.0.1-5/src/renderers/agg/include/agg_clip_liang_barsky.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_clip_liang_barsky.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,333 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Liang-Barsky clipping 
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CLIP_LIANG_BARSKY_INCLUDED
+#define AGG_CLIP_LIANG_BARSKY_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    enum clipping_flags_e
+    {
+        clipping_flags_x1_clipped = 4,
+        clipping_flags_x2_clipped = 1,
+        clipping_flags_y1_clipped = 8,
+        clipping_flags_y2_clipped = 2,
+        clipping_flags_x_clipped = clipping_flags_x1_clipped | clipping_flags_x2_clipped,
+        clipping_flags_y_clipped = clipping_flags_y1_clipped | clipping_flags_y2_clipped
+    };
+
+    //----------------------------------------------------------clipping_flags
+    // Determine the clipping code of the vertex according to the 
+    // Cyrus-Beck line clipping algorithm
+    //
+    //        |        |
+    //  0110  |  0010  | 0011
+    //        |        |
+    // -------+--------+-------- clip_box.y2
+    //        |        |
+    //  0100  |  0000  | 0001
+    //        |        |
+    // -------+--------+-------- clip_box.y1
+    //        |        |
+    //  1100  |  1000  | 1001
+    //        |        |
+    //  clip_box.x1  clip_box.x2
+    //
+    // 
+    template<class T>
+    inline unsigned clipping_flags(T x, T y, const rect_base<T>& clip_box)
+    {
+        return  (x > clip_box.x2) |
+               ((y > clip_box.y2) << 1) |
+               ((x < clip_box.x1) << 2) |
+               ((y < clip_box.y1) << 3);
+    }
+
+    //--------------------------------------------------------clipping_flags_x
+    template<class T>
+    inline unsigned clipping_flags_x(T x, const rect_base<T>& clip_box)
+    {
+        return  (x > clip_box.x2) | ((x < clip_box.x1) << 2);
+    }
+
+
+    //--------------------------------------------------------clipping_flags_y
+    template<class T>
+    inline unsigned clipping_flags_y(T y, const rect_base<T>& clip_box)
+    {
+        return ((y > clip_box.y2) << 1) | ((y < clip_box.y1) << 3);
+    }
+
+
+    //-------------------------------------------------------clip_liang_barsky
+    template<class T>
+    inline unsigned clip_liang_barsky(T x1, T y1, T x2, T y2,
+                                      const rect_base<T>& clip_box,
+                                      T* x, T* y)
+    {
+        const double nearzero = 1e-30;
+
+        double deltax = x2 - x1;
+        double deltay = y2 - y1; 
+        double xin;
+        double xout;
+        double yin;
+        double yout;
+        double tinx;
+        double tiny;
+        double toutx;
+        double touty;  
+        double tin1;
+        double tin2;
+        double tout1;
+        unsigned np = 0;
+
+        if(deltax == 0.0) 
+        {   
+            // bump off of the vertical
+            deltax = (x1 > clip_box.x1) ? -nearzero : nearzero;
+        }
+
+        if(deltay == 0.0) 
+        { 
+            // bump off of the horizontal 
+            deltay = (y1 > clip_box.y1) ? -nearzero : nearzero;
+        }
+        
+        if(deltax > 0.0) 
+        {                
+            // points to right
+            xin  = clip_box.x1;
+            xout = clip_box.x2;
+        }
+        else 
+        {
+            xin  = clip_box.x2;
+            xout = clip_box.x1;
+        }
+
+        if(deltay > 0.0) 
+        {
+            // points up
+            yin  = clip_box.y1;
+            yout = clip_box.y2;
+        }
+        else 
+        {
+            yin  = clip_box.y2;
+            yout = clip_box.y1;
+        }
+        
+        tinx = (xin - x1) / deltax;
+        tiny = (yin - y1) / deltay;
+        
+        if (tinx < tiny) 
+        {
+            // hits x first
+            tin1 = tinx;
+            tin2 = tiny;
+        }
+        else
+        {
+            // hits y first
+            tin1 = tiny;
+            tin2 = tinx;
+        }
+        
+        if(tin1 <= 1.0) 
+        {
+            if(0.0 < tin1) 
+            {
+                *x++ = (T)xin;
+                *y++ = (T)yin;
+                ++np;
+            }
+
+            if(tin2 <= 1.0)
+            {
+                toutx = (xout - x1) / deltax;
+                touty = (yout - y1) / deltay;
+                
+                tout1 = (toutx < touty) ? toutx : touty;
+                
+                if(tin2 > 0.0 || tout1 > 0.0) 
+                {
+                    if(tin2 <= tout1) 
+                    {
+                        if(tin2 > 0.0) 
+                        {
+                            if(tinx > tiny) 
+                            {
+                                *x++ = (T)xin;
+                                *y++ = (T)(y1 + tinx * deltay);
+                            }
+                            else 
+                            {
+                                *x++ = (T)(x1 + tiny * deltax);
+                                *y++ = (T)yin;
+                            }
+                            ++np;
+                        }
+
+                        if(tout1 < 1.0) 
+                        {
+                            if(toutx < touty) 
+                            {
+                                *x++ = (T)xout;
+                                *y++ = (T)(y1 + toutx * deltay);
+                            }
+                            else 
+                            {
+                                *x++ = (T)(x1 + touty * deltax);
+                                *y++ = (T)yout;
+                            }
+                        }
+                        else 
+                        {
+                            *x++ = x2;
+                            *y++ = y2;
+                        }
+                        ++np;
+                    }
+                    else 
+                    {
+                        if(tinx > tiny) 
+                        {
+                            *x++ = (T)xin;
+                            *y++ = (T)yout;
+                        }
+                        else 
+                        {
+                            *x++ = (T)xout;
+                            *y++ = (T)yin;
+                        }
+                        ++np;
+                    }
+                }
+            }
+        }
+        return np;
+    }
+
+
+    //----------------------------------------------------------------------------
+    template<class T>
+    bool clip_move_point(T x1, T y1, T x2, T y2, 
+                         const rect_base<T>& clip_box, 
+                         T* x, T* y, unsigned flags)
+    {
+       T bound;
+
+       if(flags & clipping_flags_x_clipped)
+       {
+           if(x1 == x2)
+           {
+               return false;
+           }
+           bound = (flags & clipping_flags_x1_clipped) ? clip_box.x1 : clip_box.x2;
+           *y = (T)(double(bound - x1) * (y2 - y1) / (x2 - x1) + y1);
+           *x = bound;
+       }
+
+       flags = clipping_flags_y(*y, clip_box);
+       if(flags & clipping_flags_y_clipped)
+       {
+           if(y1 == y2)
+           {
+               return false;
+           }
+           bound = (flags & clipping_flags_y1_clipped) ? clip_box.y1 : clip_box.y2;
+           *x = (T)(double(bound - y1) * (x2 - x1) / (y2 - y1) + x1);
+           *y = bound;
+       }
+       return true;
+    }
+
+    //-------------------------------------------------------clip_line_segment
+    // Returns: ret >= 4        - Fully clipped
+    //          (ret & 1) != 0  - First point has been moved
+    //          (ret & 2) != 0  - Second point has been moved
+    //
+    template<class T>
+    unsigned clip_line_segment(T* x1, T* y1, T* x2, T* y2,
+                               const rect_base<T>& clip_box)
+    {
+        unsigned f1 = clipping_flags(*x1, *y1, clip_box);
+        unsigned f2 = clipping_flags(*x2, *y2, clip_box);
+        unsigned ret = 0;
+
+        if((f2 | f1) == 0)
+        {
+            // Fully visible
+            return 0;
+        }
+
+        if((f1 & clipping_flags_x_clipped) != 0 && 
+           (f1 & clipping_flags_x_clipped) == (f2 & clipping_flags_x_clipped))
+        {
+            // Fully clipped
+            return 4;
+        }
+
+        if((f1 & clipping_flags_y_clipped) != 0 && 
+           (f1 & clipping_flags_y_clipped) == (f2 & clipping_flags_y_clipped))
+        {
+            // Fully clipped
+            return 4;
+        }
+
+        T tx1 = *x1;
+        T ty1 = *y1;
+        T tx2 = *x2;
+        T ty2 = *y2;
+        if(f1) 
+        {   
+            if(!clip_move_point(tx1, ty1, tx2, ty2, clip_box, x1, y1, f1)) 
+            {
+                return 4;
+            }
+            if(*x1 == *x2 && *y1 == *y2) 
+            {
+                return 4;
+            }
+            ret |= 1;
+        }
+        if(f2) 
+        {
+            if(!clip_move_point(tx1, ty1, tx2, ty2, clip_box, x2, y2, f2))
+            {
+                return 4;
+            }
+            if(*x1 == *x2 && *y1 == *y2) 
+            {
+                return 4;
+            }
+            ret |= 2;
+        }
+        return ret;
+    }
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_color_gray.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_color_gray.h
--- 8.0.1-5/src/renderers/agg/include/agg_color_gray.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_color_gray.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,414 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+//
+// color types gray8, gray16
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_COLOR_GRAY_INCLUDED
+#define AGG_COLOR_GRAY_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_rgba.h"
+
+namespace mapserver
+{
+
+    //===================================================================gray8
+    struct gray8
+    {
+        typedef int8u  value_type;
+        typedef int32u calc_type;
+        typedef int32  long_type;
+        enum base_scale_e
+        {
+            base_shift = 8,
+            base_scale = 1 << base_shift,
+            base_mask  = base_scale - 1
+        };
+        typedef gray8 self_type;
+
+        value_type v;
+        value_type a;
+
+        //--------------------------------------------------------------------
+        gray8() {}
+
+        //--------------------------------------------------------------------
+        gray8(unsigned v_, unsigned a_=base_mask) :
+            v(int8u(v_)), a(int8u(a_)) {}
+
+        //--------------------------------------------------------------------
+        gray8(const self_type& c, unsigned a_) :
+            v(c.v), a(value_type(a_)) {}
+
+        //--------------------------------------------------------------------
+        gray8(const rgba& c) :
+            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
+            a((value_type)uround(c.a * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        gray8(const rgba& c, double a_) :
+            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
+            a((value_type)uround(a_ * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        gray8(const rgba8& c) :
+            v((c.r*77 + c.g*150 + c.b*29) >> 8),
+            a(c.a) {}
+
+        //--------------------------------------------------------------------
+        gray8(const rgba8& c, unsigned a_) :
+            v((c.r*77 + c.g*150 + c.b*29) >> 8),
+            a(a_) {}
+
+        //--------------------------------------------------------------------
+        void clear()
+        {
+            v = a = 0;
+        }
+
+        //--------------------------------------------------------------------
+        const self_type& transparent()
+        {
+            a = 0;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        void opacity(double a_)
+        {
+            if(a_ < 0.0) a_ = 0.0;
+            if(a_ > 1.0) a_ = 1.0;
+            a = (value_type)uround(a_ * double(base_mask));
+        }
+
+        //--------------------------------------------------------------------
+        double opacity() const
+        {
+            return double(a) / double(base_mask);
+        }
+
+
+        //--------------------------------------------------------------------
+        const self_type& premultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                v = 0;
+                return *this;
+            }
+            v = value_type((calc_type(v) * a) >> base_shift);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const self_type& premultiply(unsigned a_)
+        {
+            if(a == base_mask && a_ >= base_mask) return *this;
+            if(a == 0 || a_ == 0)
+            {
+                v = a = 0;
+                return *this;
+            }
+            calc_type v_ = (calc_type(v) * a_) / a;
+            v = value_type((v_ > a_) ? a_ : v_);
+            a = value_type(a_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const self_type& demultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                v = 0;
+                return *this;
+            }
+            calc_type v_ = (calc_type(v) * base_mask) / a;
+            v = value_type((v_ > base_mask) ? (value_type)base_mask : v_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        self_type gradient(self_type c, double k) const
+        {
+            self_type ret;
+            calc_type ik = uround(k * base_scale);
+            ret.v = value_type(calc_type(v) + (((calc_type(c.v) - v) * ik) >> base_shift));
+            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
+            return ret;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void add(const self_type& c, unsigned cover)
+        {
+            calc_type cv, ca;
+            if(cover == cover_mask)
+            {
+                if(c.a == base_mask) 
+                {
+                    *this = c;
+                }
+                else
+                {
+                    cv = v + c.v; v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
+                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+                }
+            }
+            else
+            {
+                cv = v + ((c.v * cover + cover_mask/2) >> cover_shift);
+                ca = a + ((c.a * cover + cover_mask/2) >> cover_shift);
+                v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
+                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        static self_type no_color() { return self_type(0,0); }
+    };
+
+
+    //-------------------------------------------------------------gray8_pre
+    inline gray8 gray8_pre(unsigned v, unsigned a = gray8::base_mask)
+    {
+        return gray8(v,a).premultiply();
+    }
+    inline gray8 gray8_pre(const gray8& c, unsigned a)
+    {
+        return gray8(c,a).premultiply();
+    }
+    inline gray8 gray8_pre(const rgba& c)
+    {
+        return gray8(c).premultiply();
+    }
+    inline gray8 gray8_pre(const rgba& c, double a)
+    {
+        return gray8(c,a).premultiply();
+    }
+    inline gray8 gray8_pre(const rgba8& c)
+    {
+        return gray8(c).premultiply();
+    }
+    inline gray8 gray8_pre(const rgba8& c, unsigned a)
+    {
+        return gray8(c,a).premultiply();
+    }
+
+
+
+
+    //==================================================================gray16
+    struct gray16
+    {
+        typedef int16u value_type;
+        typedef int32u calc_type;
+        typedef int64  long_type;
+        enum base_scale_e
+        {
+            base_shift = 16,
+            base_scale = 1 << base_shift,
+            base_mask  = base_scale - 1
+        };
+        typedef gray16 self_type;
+
+        value_type v;
+        value_type a;
+
+        //--------------------------------------------------------------------
+        gray16() {}
+
+        //--------------------------------------------------------------------
+        gray16(unsigned v_, unsigned a_=base_mask) :
+            v(int16u(v_)), a(int16u(a_)) {}
+
+        //--------------------------------------------------------------------
+        gray16(const self_type& c, unsigned a_) :
+            v(c.v), a(value_type(a_)) {}
+
+        //--------------------------------------------------------------------
+        gray16(const rgba& c) :
+            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
+            a((value_type)uround(c.a * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        gray16(const rgba& c, double a_) :
+            v((value_type)uround((0.299*c.r + 0.587*c.g + 0.114*c.b) * double(base_mask))),
+            a((value_type)uround(a_ * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        gray16(const rgba8& c) :
+            v(c.r*77 + c.g*150 + c.b*29),
+            a((value_type(c.a) << 8) | c.a) {}
+
+        //--------------------------------------------------------------------
+        gray16(const rgba8& c, unsigned a_) :
+            v(c.r*77 + c.g*150 + c.b*29),
+            a((value_type(a_) << 8) | c.a) {}
+
+        //--------------------------------------------------------------------
+        void clear()
+        {
+            v = a = 0;
+        }
+
+        //--------------------------------------------------------------------
+        const self_type& transparent()
+        {
+            a = 0;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        void opacity(double a_)
+        {
+            if(a_ < 0.0) a_ = 0.0;
+            if(a_ > 1.0) a_ = 1.0;
+            a = (value_type)uround(a_ * double(base_mask));
+        }
+
+        //--------------------------------------------------------------------
+        double opacity() const
+        {
+            return double(a) / double(base_mask);
+        }
+
+
+        //--------------------------------------------------------------------
+        const self_type& premultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                v = 0;
+                return *this;
+            }
+            v = value_type((calc_type(v) * a) >> base_shift);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const self_type& premultiply(unsigned a_)
+        {
+            if(a == base_mask && a_ >= base_mask) return *this;
+            if(a == 0 || a_ == 0)
+            {
+                v = a = 0;
+                return *this;
+            }
+            calc_type v_ = (calc_type(v) * a_) / a;
+            v = value_type((v_ > a_) ? a_ : v_);
+            a = value_type(a_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const self_type& demultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                v = 0;
+                return *this;
+            }
+            calc_type v_ = (calc_type(v) * base_mask) / a;
+            v = value_type((v_ > base_mask) ? base_mask : v_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        self_type gradient(self_type c, double k) const
+        {
+            self_type ret;
+            calc_type ik = uround(k * base_scale);
+            ret.v = value_type(calc_type(v) + (((calc_type(c.v) - v) * ik) >> base_shift));
+            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
+            return ret;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void add(const self_type& c, unsigned cover)
+        {
+            calc_type cv, ca;
+            if(cover == cover_mask)
+            {
+                if(c.a == base_mask) 
+                {
+                    *this = c;
+                }
+                else
+                {
+                    cv = v + c.v; v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
+                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+                }
+            }
+            else
+            {
+                cv = v + ((c.v * cover + cover_mask/2) >> cover_shift);
+                ca = a + ((c.a * cover + cover_mask/2) >> cover_shift);
+                v = (cv > calc_type(base_mask)) ? calc_type(base_mask) : cv;
+                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        static self_type no_color() { return self_type(0,0); }
+    };
+
+
+    //------------------------------------------------------------gray16_pre
+    inline gray16 gray16_pre(unsigned v, unsigned a = gray16::base_mask)
+    {
+        return gray16(v,a).premultiply();
+    }
+    inline gray16 gray16_pre(const gray16& c, unsigned a)
+    {
+        return gray16(c,a).premultiply();
+    }
+    inline gray16 gray16_pre(const rgba& c)
+    {
+        return gray16(c).premultiply();
+    }
+    inline gray16 gray16_pre(const rgba& c, double a)
+    {
+        return gray16(c,a).premultiply();
+    }
+    inline gray16 gray16_pre(const rgba8& c)
+    {
+        return gray16(c).premultiply();
+    }
+    inline gray16 gray16_pre(const rgba8& c, unsigned a)
+    {
+        return gray16(c,a).premultiply();
+    }
+
+
+}
+
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_color_rgba.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_color_rgba.h
--- 8.0.1-5/src/renderers/agg/include/agg_color_rgba.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_color_rgba.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,743 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_COLOR_RGBA_INCLUDED
+#define AGG_COLOR_RGBA_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    // Supported byte orders for RGB and RGBA pixel formats
+    //=======================================================================
+    struct order_rgb  { enum rgb_e  { R=0, G=1, B=2, rgb_tag }; };       //----order_rgb
+    struct order_bgr  { enum bgr_e  { B=0, G=1, R=2, rgb_tag }; };       //----order_bgr
+    struct order_rgba { enum rgba_e { R=0, G=1, B=2, A=3, rgba_tag }; }; //----order_rgba
+    struct order_argb { enum argb_e { A=0, R=1, G=2, B=3, rgba_tag }; }; //----order_argb
+    struct order_abgr { enum abgr_e { A=0, B=1, G=2, R=3, rgba_tag }; }; //----order_abgr
+    struct order_bgra { enum bgra_e { B=0, G=1, R=2, A=3, rgba_tag }; }; //----order_bgra
+
+    //====================================================================rgba
+    struct rgba
+    {
+        typedef double value_type;
+
+        double r;
+        double g;
+        double b;
+        double a;
+
+        //--------------------------------------------------------------------
+        rgba() {}
+
+        //--------------------------------------------------------------------
+        rgba(double r_, double g_, double b_, double a_=1.0) :
+            r(r_), g(g_), b(b_), a(a_) {}
+
+        //--------------------------------------------------------------------
+        rgba(const rgba& c, double a_) : r(c.r), g(c.g), b(c.b), a(a_) {}
+
+        //--------------------------------------------------------------------
+        void clear()
+        {
+            r = g = b = a = 0;
+        }
+
+        //--------------------------------------------------------------------
+        const rgba& transparent()
+        {
+            a = 0.0;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const rgba& opacity(double a_)
+        {
+            if(a_ < 0.0) a_ = 0.0;
+            if(a_ > 1.0) a_ = 1.0;
+            a = a_;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        double opacity() const
+        {
+            return a;
+        }
+
+        //--------------------------------------------------------------------
+        const rgba& premultiply()
+        {
+            r *= a;
+            g *= a;
+            b *= a;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const rgba& premultiply(double a_)
+        {
+            if(a <= 0.0 || a_ <= 0.0)
+            {
+                r = g = b = a = 0.0;
+                return *this;
+            }
+            a_ /= a;
+            r *= a_;
+            g *= a_;
+            b *= a_;
+            a  = a_;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const rgba& demultiply()
+        {
+            if(a == 0)
+            {
+                r = g = b = 0;
+                return *this;
+            }
+            double a_ = 1.0 / a;
+            r *= a_;
+            g *= a_;
+            b *= a_;
+            return *this;
+        }
+
+
+        //--------------------------------------------------------------------
+        rgba gradient(rgba c, double k) const
+        {
+            rgba ret;
+            ret.r = r + (c.r - r) * k;
+            ret.g = g + (c.g - g) * k;
+            ret.b = b + (c.b - b) * k;
+            ret.a = a + (c.a - a) * k;
+            return ret;
+        }
+
+        //--------------------------------------------------------------------
+        static rgba no_color() { return rgba(0,0,0,0); }
+
+        //--------------------------------------------------------------------
+        static rgba from_wavelength(double wl, double gamma = 1.0);
+	
+        //--------------------------------------------------------------------
+        explicit rgba(double wavelen, double gamma=1.0)
+        {
+            *this = from_wavelength(wavelen, gamma);
+        }
+
+    };
+
+    //----------------------------------------------------------------rgba_pre
+    inline rgba rgba_pre(double r, double g, double b, double a=1.0)
+    {
+        return rgba(r, g, b, a).premultiply();
+    }
+    inline rgba rgba_pre(const rgba& c)
+    {
+        return rgba(c).premultiply();
+    }
+    inline rgba rgba_pre(const rgba& c, double a)
+    {
+        return rgba(c, a).premultiply();
+    }
+
+    //------------------------------------------------------------------------
+    inline rgba rgba::from_wavelength(double wl, double gamma)
+    {
+        rgba t(0.0, 0.0, 0.0);
+
+        if(wl >= 380.0 && wl <= 440.0)
+        {
+            t.r = -1.0 * (wl - 440.0) / (440.0 - 380.0);
+            t.b = 1.0;
+        }
+        else 
+        if(wl >= 440.0 && wl <= 490.0)
+        {
+            t.g = (wl - 440.0) / (490.0 - 440.0);
+            t.b = 1.0;
+        }
+        else
+        if(wl >= 490.0 && wl <= 510.0)
+        {
+            t.g = 1.0;
+            t.b = -1.0 * (wl - 510.0) / (510.0 - 490.0);
+        }
+        else
+        if(wl >= 510.0 && wl <= 580.0)
+        {
+            t.r = (wl - 510.0) / (580.0 - 510.0);
+            t.g = 1.0;
+        }
+        else
+        if(wl >= 580.0 && wl <= 645.0)
+        {
+            t.r = 1.0;
+            t.g = -1.0 * (wl - 645.0) / (645.0 - 580.0);
+        }
+        else
+        if(wl >= 645.0 && wl <= 780.0)
+        {
+            t.r = 1.0;
+        }
+
+        double s = 1.0;
+        if(wl > 700.0)       s = 0.3 + 0.7 * (780.0 - wl) / (780.0 - 700.0);
+        else if(wl <  420.0) s = 0.3 + 0.7 * (wl - 380.0) / (420.0 - 380.0);
+
+        t.r = pow(t.r * s, gamma);
+        t.g = pow(t.g * s, gamma);
+        t.b = pow(t.b * s, gamma);
+        return t;
+    }
+
+
+
+    
+    //===================================================================rgba8
+    struct rgba8
+    {
+        typedef int8u  value_type;
+        typedef int32u calc_type;
+        typedef int32  long_type;
+        enum base_scale_e
+        {
+            base_shift = 8,
+            base_scale = 1 << base_shift,
+            base_mask  = base_scale - 1
+        };
+        typedef rgba8 self_type;
+
+
+        value_type r = 0;
+        value_type g = 0;
+        value_type b = 0;
+        value_type a = 0;
+
+        //--------------------------------------------------------------------
+        rgba8() = default;
+
+        //--------------------------------------------------------------------
+        rgba8(unsigned r_, unsigned g_, unsigned b_, unsigned a_=base_mask) :
+            r(value_type(r_)), 
+            g(value_type(g_)), 
+            b(value_type(b_)), 
+            a(value_type(a_)) {}
+
+        //--------------------------------------------------------------------
+        rgba8(const rgba& c, double a_) :
+            r((value_type)uround(c.r * double(base_mask))), 
+            g((value_type)uround(c.g * double(base_mask))), 
+            b((value_type)uround(c.b * double(base_mask))), 
+            a((value_type)uround(a_  * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        rgba8(const self_type& c, unsigned a_) :
+            r(c.r), g(c.g), b(c.b), a(value_type(a_)) {}
+
+        //--------------------------------------------------------------------
+        rgba8(const rgba& c) :
+            r((value_type)uround(c.r * double(base_mask))), 
+            g((value_type)uround(c.g * double(base_mask))), 
+            b((value_type)uround(c.b * double(base_mask))), 
+            a((value_type)uround(c.a * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        void clear()
+        {
+            r = g = b = a = 0;
+        }
+        
+        //--------------------------------------------------------------------
+        const self_type& transparent()
+        {
+            a = 0;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        const self_type& opacity(double a_)
+        {
+            if(a_ < 0.0) a_ = 0.0;
+            if(a_ > 1.0) a_ = 1.0;
+            a = (value_type)uround(a_ * double(base_mask));
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        double opacity() const
+        {
+            return double(a) / double(base_mask);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE const self_type& premultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                r = g = b = 0;
+                return *this;
+            }
+            r = value_type((calc_type(r) * a) >> base_shift);
+            g = value_type((calc_type(g) * a) >> base_shift);
+            b = value_type((calc_type(b) * a) >> base_shift);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE const self_type& premultiply(unsigned a_)
+        {
+            if(a == base_mask && a_ >= base_mask) return *this;
+            if(a == 0 || a_ == 0)
+            {
+                r = g = b = a = 0;
+                return *this;
+            }
+            calc_type r_ = (calc_type(r) * a_) / a;
+            calc_type g_ = (calc_type(g) * a_) / a;
+            calc_type b_ = (calc_type(b) * a_) / a;
+            r = value_type((r_ > a_) ? a_ : r_);
+            g = value_type((g_ > a_) ? a_ : g_);
+            b = value_type((b_ > a_) ? a_ : b_);
+            a = value_type(a_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE const self_type& demultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                r = g = b = 0;
+                return *this;
+            }
+            calc_type r_ = (calc_type(r) * base_mask) / a;
+            calc_type g_ = (calc_type(g) * base_mask) / a;
+            calc_type b_ = (calc_type(b) * base_mask) / a;
+            r = value_type((r_ > calc_type(base_mask)) ? calc_type(base_mask) : r_);
+            g = value_type((g_ > calc_type(base_mask)) ? calc_type(base_mask) : g_);
+            b = value_type((b_ > calc_type(base_mask)) ? calc_type(base_mask) : b_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE self_type gradient(const self_type& c, double k) const
+        {
+            self_type ret;
+            calc_type ik = uround(k * base_scale);
+            ret.r = value_type(calc_type(r) + (((calc_type(c.r) - r) * ik) >> base_shift));
+            ret.g = value_type(calc_type(g) + (((calc_type(c.g) - g) * ik) >> base_shift));
+            ret.b = value_type(calc_type(b) + (((calc_type(c.b) - b) * ik) >> base_shift));
+            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
+            return ret;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void add(const self_type& c, unsigned cover)
+        {
+            calc_type cr, cg, cb, ca;
+            if(cover == cover_mask)
+            {
+                if(c.a == base_mask) 
+                {
+                    *this = c;
+                }
+                else
+                {
+                    cr = r + c.r; r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
+                    cg = g + c.g; g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
+                    cb = b + c.b; b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
+                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+                }
+            }
+            else
+            {
+                cr = r + ((c.r * cover + cover_mask/2) >> cover_shift);
+                cg = g + ((c.g * cover + cover_mask/2) >> cover_shift);
+                cb = b + ((c.b * cover + cover_mask/2) >> cover_shift);
+                ca = a + ((c.a * cover + cover_mask/2) >> cover_shift);
+                r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
+                g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
+                b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
+                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLUT>
+        AGG_INLINE void apply_gamma_dir(const GammaLUT& gamma)
+        {
+            r = gamma.dir(r);
+            g = gamma.dir(g);
+            b = gamma.dir(b);
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLUT>
+        AGG_INLINE void apply_gamma_inv(const GammaLUT& gamma)
+        {
+            r = gamma.inv(r);
+            g = gamma.inv(g);
+            b = gamma.inv(b);
+        }
+
+        //--------------------------------------------------------------------
+        static self_type no_color() { return self_type(0,0,0,0); }
+
+        //--------------------------------------------------------------------
+        static self_type from_wavelength(double wl, double gamma = 1.0)
+        {
+            return self_type(rgba::from_wavelength(wl, gamma));
+        }
+    };
+
+
+    //-------------------------------------------------------------rgba8_pre
+    inline rgba8 rgba8_pre(unsigned r, unsigned g, unsigned b, 
+                           unsigned a = rgba8::base_mask)
+    {
+        return rgba8(r,g,b,a).premultiply();
+    }
+    inline rgba8 rgba8_pre(const rgba8& c)
+    {
+        return rgba8(c).premultiply();
+    }
+    inline rgba8 rgba8_pre(const rgba8& c, unsigned a)
+    {
+        return rgba8(c,a).premultiply();
+    }
+    inline rgba8 rgba8_pre(const rgba& c)
+    {
+        return rgba8(c).premultiply();
+    }
+    inline rgba8 rgba8_pre(const rgba& c, double a)
+    {
+        return rgba8(c,a).premultiply();
+    }
+
+
+    //-------------------------------------------------------------rgb8_packed
+    inline rgba8 rgb8_packed(unsigned v)
+    {
+        return rgba8((v >> 16) & 0xFF, (v >> 8) & 0xFF, v & 0xFF);
+    }
+
+    //-------------------------------------------------------------bgr8_packed
+    inline rgba8 bgr8_packed(unsigned v)
+    {
+        return rgba8(v & 0xFF, (v >> 8) & 0xFF, (v >> 16) & 0xFF);
+    }
+
+    //------------------------------------------------------------argb8_packed
+    inline rgba8 argb8_packed(unsigned v)
+    {
+        return rgba8((v >> 16) & 0xFF, (v >> 8) & 0xFF, v & 0xFF, v >> 24);
+    }
+
+    //---------------------------------------------------------rgba8_gamma_dir
+    template<class GammaLUT>
+    rgba8 rgba8_gamma_dir(rgba8 c, const GammaLUT& gamma)
+    {
+        return rgba8(gamma.dir(c.r), gamma.dir(c.g), gamma.dir(c.b), c.a);
+    }
+
+    //---------------------------------------------------------rgba8_gamma_inv
+    template<class GammaLUT>
+    rgba8 rgba8_gamma_inv(rgba8 c, const GammaLUT& gamma)
+    {
+        return rgba8(gamma.inv(c.r), gamma.inv(c.g), gamma.inv(c.b), c.a);
+    }
+
+
+
+
+
+    //==================================================================rgba16
+    struct rgba16
+    {
+        typedef int16u value_type;
+        typedef int32u calc_type;
+        typedef int64  long_type;
+        enum base_scale_e
+        {
+            base_shift = 16,
+            base_scale = 1 << base_shift,
+            base_mask  = base_scale - 1
+        };
+        typedef rgba16 self_type;
+
+        value_type r;
+        value_type g;
+        value_type b;
+        value_type a;
+
+        //--------------------------------------------------------------------
+        rgba16() {}
+
+        //--------------------------------------------------------------------
+        rgba16(unsigned r_, unsigned g_, unsigned b_, unsigned a_=base_mask) :
+            r(value_type(r_)), 
+            g(value_type(g_)), 
+            b(value_type(b_)), 
+            a(value_type(a_)) {}
+
+        //--------------------------------------------------------------------
+        rgba16(const self_type& c, unsigned a_) :
+            r(c.r), g(c.g), b(c.b), a(value_type(a_)) {}
+
+        //--------------------------------------------------------------------
+        rgba16(const rgba& c) :
+            r((value_type)uround(c.r * double(base_mask))), 
+            g((value_type)uround(c.g * double(base_mask))), 
+            b((value_type)uround(c.b * double(base_mask))), 
+            a((value_type)uround(c.a * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        rgba16(const rgba& c, double a_) :
+            r((value_type)uround(c.r * double(base_mask))), 
+            g((value_type)uround(c.g * double(base_mask))), 
+            b((value_type)uround(c.b * double(base_mask))), 
+            a((value_type)uround(a_  * double(base_mask))) {}
+
+        //--------------------------------------------------------------------
+        rgba16(const rgba8& c) :
+            r(value_type((value_type(c.r) << 8) | c.r)), 
+            g(value_type((value_type(c.g) << 8) | c.g)), 
+            b(value_type((value_type(c.b) << 8) | c.b)), 
+            a(value_type((value_type(c.a) << 8) | c.a)) {}
+
+        //--------------------------------------------------------------------
+        rgba16(const rgba8& c, unsigned a_) :
+            r(value_type((value_type(c.r) << 8) | c.r)), 
+            g(value_type((value_type(c.g) << 8) | c.g)), 
+            b(value_type((value_type(c.b) << 8) | c.b)), 
+            a(value_type((             a_ << 8) | c.a)) {}
+
+        //--------------------------------------------------------------------
+        void clear()
+        {
+            r = g = b = a = 0;
+        }
+        
+        //--------------------------------------------------------------------
+        const self_type& transparent()
+        {
+            a = 0;
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE const self_type& opacity(double a_)
+        {
+            if(a_ < 0.0) a_ = 0.0;
+            if(a_ > 1.0) a_ = 1.0;
+            a = (value_type)uround(a_ * double(base_mask));
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        double opacity() const
+        {
+            return double(a) / double(base_mask);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE const self_type& premultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                r = g = b = 0;
+                return *this;
+            }
+            r = value_type((calc_type(r) * a) >> base_shift);
+            g = value_type((calc_type(g) * a) >> base_shift);
+            b = value_type((calc_type(b) * a) >> base_shift);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE const self_type& premultiply(unsigned a_)
+        {
+            if(a == base_mask && a_ >= base_mask) return *this;
+            if(a == 0 || a_ == 0)
+            {
+                r = g = b = a = 0;
+                return *this;
+            }
+            calc_type r_ = (calc_type(r) * a_) / a;
+            calc_type g_ = (calc_type(g) * a_) / a;
+            calc_type b_ = (calc_type(b) * a_) / a;
+            r = value_type((r_ > a_) ? a_ : r_);
+            g = value_type((g_ > a_) ? a_ : g_);
+            b = value_type((b_ > a_) ? a_ : b_);
+            a = value_type(a_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE const self_type& demultiply()
+        {
+            if(a == base_mask) return *this;
+            if(a == 0)
+            {
+                r = g = b = 0;
+                return *this;
+            }
+            calc_type r_ = (calc_type(r) * base_mask) / a;
+            calc_type g_ = (calc_type(g) * base_mask) / a;
+            calc_type b_ = (calc_type(b) * base_mask) / a;
+            r = value_type((r_ > calc_type(base_mask)) ? calc_type(base_mask) : r_);
+            g = value_type((g_ > calc_type(base_mask)) ? calc_type(base_mask) : g_);
+            b = value_type((b_ > calc_type(base_mask)) ? calc_type(base_mask) : b_);
+            return *this;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE self_type gradient(const self_type& c, double k) const
+        {
+            self_type ret;
+            calc_type ik = uround(k * base_scale);
+            ret.r = value_type(calc_type(r) + (((calc_type(c.r) - r) * ik) >> base_shift));
+            ret.g = value_type(calc_type(g) + (((calc_type(c.g) - g) * ik) >> base_shift));
+            ret.b = value_type(calc_type(b) + (((calc_type(c.b) - b) * ik) >> base_shift));
+            ret.a = value_type(calc_type(a) + (((calc_type(c.a) - a) * ik) >> base_shift));
+            return ret;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void add(const self_type& c, unsigned cover)
+        {
+            calc_type cr, cg, cb, ca;
+            if(cover == cover_mask)
+            {
+                if(c.a == base_mask) 
+                {
+                    *this = c;
+                }
+                else
+                {
+                    cr = r + c.r; r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
+                    cg = g + c.g; g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
+                    cb = b + c.b; b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
+                    ca = a + c.a; a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+                }
+            }
+            else
+            {
+                cr = r + ((c.r * cover + cover_mask) >> cover_shift);
+                cg = g + ((c.g * cover + cover_mask) >> cover_shift);
+                cb = b + ((c.b * cover + cover_mask) >> cover_shift);
+                ca = a + ((c.a * cover + cover_mask) >> cover_shift);
+                r = (cr > calc_type(base_mask)) ? calc_type(base_mask) : cr;
+                g = (cg > calc_type(base_mask)) ? calc_type(base_mask) : cg;
+                b = (cb > calc_type(base_mask)) ? calc_type(base_mask) : cb;
+                a = (ca > calc_type(base_mask)) ? calc_type(base_mask) : ca;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLUT>
+        AGG_INLINE void apply_gamma_dir(const GammaLUT& gamma)
+        {
+            r = gamma.dir(r);
+            g = gamma.dir(g);
+            b = gamma.dir(b);
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLUT>
+        AGG_INLINE void apply_gamma_inv(const GammaLUT& gamma)
+        {
+            r = gamma.inv(r);
+            g = gamma.inv(g);
+            b = gamma.inv(b);
+        }
+
+        //--------------------------------------------------------------------
+        static self_type no_color() { return self_type(0,0,0,0); }
+
+        //--------------------------------------------------------------------
+        static self_type from_wavelength(double wl, double gamma = 1.0)
+        {
+            return self_type(rgba::from_wavelength(wl, gamma));
+        }
+    };
+
+
+
+    //--------------------------------------------------------------rgba16_pre
+    inline rgba16 rgba16_pre(unsigned r, unsigned g, unsigned b, 
+                             unsigned a = rgba16::base_mask)
+    {
+        return rgba16(r,g,b,a).premultiply();
+    }
+    inline rgba16 rgba16_pre(const rgba16& c, unsigned a)
+    {
+        return rgba16(c,a).premultiply();
+    }
+    inline rgba16 rgba16_pre(const rgba& c)
+    {
+        return rgba16(c).premultiply();
+    }
+    inline rgba16 rgba16_pre(const rgba& c, double a)
+    {
+        return rgba16(c,a).premultiply();
+    }
+    inline rgba16 rgba16_pre(const rgba8& c)
+    {
+        return rgba16(c).premultiply();
+    }
+    inline rgba16 rgba16_pre(const rgba8& c, unsigned a)
+    {
+        return rgba16(c,a).premultiply();
+    }
+
+
+    //------------------------------------------------------rgba16_gamma_dir
+    template<class GammaLUT>
+    rgba16 rgba16_gamma_dir(rgba16 c, const GammaLUT& gamma)
+    {
+        return rgba16(gamma.dir(c.r), gamma.dir(c.g), gamma.dir(c.b), c.a);
+    }
+
+    //------------------------------------------------------rgba16_gamma_inv
+    template<class GammaLUT>
+    rgba16 rgba16_gamma_inv(rgba16 c, const GammaLUT& gamma)
+    {
+        return rgba16(gamma.inv(c.r), gamma.inv(c.g), gamma.inv(c.b), c.a);
+    }
+
+
+}
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_config.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_config.h
--- 8.0.1-5/src/renderers/agg/include/agg_config.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_config.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,44 @@
+#ifndef AGG_CONFIG_INCLUDED
+#define AGG_CONFIG_INCLUDED
+
+// This file can be used to redefine certain data types.
+
+//---------------------------------------
+// 1. Default basic types such as:
+// 
+// AGG_INT8
+// AGG_INT8U
+// AGG_INT16
+// AGG_INT16U
+// AGG_INT32
+// AGG_INT32U
+// AGG_INT64
+// AGG_INT64U
+//
+// Just replace this file with new defines if necessary. 
+// For example, if your compiler doesn't have a 64 bit integer type
+// you can still use AGG if you define the follows:
+//
+// #define AGG_INT64  int
+// #define AGG_INT64U unsigned
+//
+// It will result in overflow in 16 bit-per-component image/pattern resampling
+// but it won't result any crash and the rest of the library will remain 
+// fully functional.
+
+
+//---------------------------------------
+// 2. Default rendering_buffer type. Can be:
+//
+// Provides faster access for massive pixel operations, 
+// such as blur, image filtering:
+// #define AGG_RENDERING_BUFFER row_ptr_cache<int8u>
+// 
+// Provides cheaper creation and destruction (no mem allocs):
+// #define AGG_RENDERING_BUFFER row_accessor<int8u>
+//
+// You can still use both of them simultaneouslyin your applications 
+// This #define is used only for default rendering_buffer type,
+// in short hand typedefs like pixfmt_rgba32.
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_adaptor_vcgen.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_adaptor_vcgen.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_adaptor_vcgen.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_adaptor_vcgen.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,159 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_ADAPTOR_VCGEN_INCLUDED
+#define AGG_CONV_ADAPTOR_VCGEN_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //------------------------------------------------------------null_markers
+    struct null_markers
+    {
+        void remove_all() {}
+        void add_vertex(double, double, unsigned) {}
+        void prepare_src() {}
+
+        void rewind(unsigned) {}
+        unsigned vertex(double*, double*) { return path_cmd_stop; }
+    };
+
+
+    //------------------------------------------------------conv_adaptor_vcgen
+    template<class VertexSource, 
+             class Generator, 
+             class Markers=null_markers> class conv_adaptor_vcgen
+    {
+        enum status
+        {
+            initial,
+            accumulate,
+            generate
+        };
+
+    public:
+        explicit conv_adaptor_vcgen(VertexSource& source) :
+            m_source(&source), 
+            m_status(initial)
+        {}
+        void attach(VertexSource& source) { m_source = &source; }
+
+        Generator& generator() { return m_generator; }
+        const Generator& generator() const { return m_generator; }
+
+        Markers& markers() { return m_markers; }
+        const Markers& markers() const { return m_markers; }
+        
+        void rewind(unsigned path_id) 
+        { 
+            m_source->rewind(path_id); 
+            m_status = initial;
+        }
+
+        unsigned vertex(double* x, double* y);
+
+    private:
+        // Prohibit copying
+        conv_adaptor_vcgen(const conv_adaptor_vcgen<VertexSource, Generator, Markers>&);
+        const conv_adaptor_vcgen<VertexSource, Generator, Markers>& 
+            operator = (const conv_adaptor_vcgen<VertexSource, Generator, Markers>&);
+
+        VertexSource* m_source;
+        Generator     m_generator;
+        Markers       m_markers;
+        status        m_status;
+        unsigned      m_last_cmd = 0;
+        double        m_start_x = 0;
+        double        m_start_y = 0;
+    };
+
+
+
+
+
+    //------------------------------------------------------------------------
+    template<class VertexSource, class Generator, class Markers> 
+    unsigned conv_adaptor_vcgen<VertexSource, Generator, Markers>::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_stop;
+        bool done = false;
+        while(!done)
+        {
+            switch(m_status)
+            {
+            case initial:
+                m_markers.remove_all();
+                m_last_cmd = m_source->vertex(&m_start_x, &m_start_y);
+                m_status = accumulate;
+                // FALLTHROUGH
+
+            case accumulate:
+                if(is_stop(m_last_cmd)) return path_cmd_stop;
+
+                m_generator.remove_all();
+                m_generator.add_vertex(m_start_x, m_start_y, path_cmd_move_to);
+                m_markers.add_vertex(m_start_x, m_start_y, path_cmd_move_to);
+
+                for(;;)
+                {
+                    cmd = m_source->vertex(x, y);
+                    if(is_vertex(cmd))
+                    {
+                        m_last_cmd = cmd;
+                        if(is_move_to(cmd))
+                        {
+                            m_start_x = *x;
+                            m_start_y = *y;
+                            break;
+                        }
+                        m_generator.add_vertex(*x, *y, cmd);
+                        m_markers.add_vertex(*x, *y, path_cmd_line_to);
+                    }
+                    else
+                    {
+                        if(is_stop(cmd))
+                        {
+                            m_last_cmd = path_cmd_stop;
+                            break;
+                        }
+                        if(is_end_poly(cmd))
+                        {
+                            m_generator.add_vertex(*x, *y, cmd);
+                            break;
+                        }
+                    }
+                }
+                m_generator.rewind(0);
+                m_status = generate;
+                // FALLTHROUGH
+
+            case generate:
+                cmd = m_generator.vertex(x, y);
+                if(is_stop(cmd))
+                {
+                    m_status = accumulate;
+                    break;
+                }
+                done = true;
+                break;
+            }
+        }
+        return cmd;
+    }
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_adaptor_vpgen.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_adaptor_vpgen.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_adaptor_vpgen.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_adaptor_vpgen.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,159 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_ADAPTOR_VPGEN_INCLUDED
+#define AGG_CONV_ADAPTOR_VPGEN_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //======================================================conv_adaptor_vpgen
+    template<class VertexSource, class VPGen> class conv_adaptor_vpgen
+    {
+    public:
+        explicit conv_adaptor_vpgen(VertexSource& source) : m_source(&source) {}
+        void attach(VertexSource& source) { m_source = &source; }
+
+        VPGen& vpgen() { return m_vpgen; }
+        const VPGen& vpgen() const { return m_vpgen; }
+
+        void rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        conv_adaptor_vpgen(const conv_adaptor_vpgen<VertexSource, VPGen>&);
+        const conv_adaptor_vpgen<VertexSource, VPGen>& 
+            operator = (const conv_adaptor_vpgen<VertexSource, VPGen>&);
+
+        VertexSource* m_source;
+        VPGen         m_vpgen;
+        double        m_start_x;
+        double        m_start_y;
+        unsigned      m_poly_flags;
+        int           m_vertices;
+    };
+
+
+
+    //------------------------------------------------------------------------
+    template<class VertexSource, class VPGen>
+    void conv_adaptor_vpgen<VertexSource, VPGen>::rewind(unsigned path_id) 
+    { 
+        m_source->rewind(path_id);
+        m_vpgen.reset();
+        m_start_x    = 0;
+        m_start_y    = 0;
+        m_poly_flags = 0;
+        m_vertices   = 0;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VertexSource, class VPGen>
+    unsigned conv_adaptor_vpgen<VertexSource, VPGen>::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_stop;
+        for(;;)
+        {
+            cmd = m_vpgen.vertex(x, y);
+            if(!is_stop(cmd)) break;
+
+            if(m_poly_flags && !m_vpgen.auto_unclose())
+            {
+                *x = 0.0;
+                *y = 0.0;
+                cmd = m_poly_flags;
+                m_poly_flags = 0;
+                break;
+            }
+
+            if(m_vertices < 0)
+            {
+                if(m_vertices < -1) 
+                {
+                    m_vertices = 0;
+                    return path_cmd_stop;
+                }
+                m_vpgen.move_to(m_start_x, m_start_y);
+                m_vertices = 1;
+                continue;
+            }
+
+            double tx, ty;
+            cmd = m_source->vertex(&tx, &ty);
+            if(is_vertex(cmd))
+            {
+                if(is_move_to(cmd)) 
+                {
+                    if(m_vpgen.auto_close() && m_vertices > 2)
+                    {
+                        m_vpgen.line_to(m_start_x, m_start_y);
+                        m_poly_flags = path_cmd_end_poly | path_flags_close;
+                        m_start_x    = tx;
+                        m_start_y    = ty;
+                        m_vertices   = -1;
+                        continue;
+                    }
+                    m_vpgen.move_to(tx, ty);
+                    m_start_x  = tx;
+                    m_start_y  = ty;
+                    m_vertices = 1;
+                }
+                else 
+                {
+                    m_vpgen.line_to(tx, ty);
+                    ++m_vertices;
+                }
+            }
+            else
+            {
+                if(is_end_poly(cmd))
+                {
+                    m_poly_flags = cmd;
+                    if(is_closed(cmd) || m_vpgen.auto_close())
+                    {
+                        if(m_vpgen.auto_close()) m_poly_flags |= path_flags_close;
+                        if(m_vertices > 2)
+                        {
+                            m_vpgen.line_to(m_start_x, m_start_y);
+                        }
+                        m_vertices = 0;
+                    }
+                }
+                else
+                {
+                    // path_cmd_stop
+                    if(m_vpgen.auto_close() && m_vertices > 2)
+                    {
+                        m_vpgen.line_to(m_start_x, m_start_y);
+                        m_poly_flags = path_cmd_end_poly | path_flags_close;
+                        m_vertices   = -2;
+                        continue;
+                    }
+                    break;
+                }
+            }
+        }
+        return cmd;
+    }
+
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_bspline.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_bspline.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_bspline.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_bspline.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,48 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_BSPLINE_INCLUDED
+#define AGG_CONV_BSPLINE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vcgen_bspline.h"
+#include "agg_conv_adaptor_vcgen.h"
+
+
+namespace mapserver
+{
+
+    //---------------------------------------------------------conv_bspline
+    template<class VertexSource> 
+    struct conv_bspline : public conv_adaptor_vcgen<VertexSource, vcgen_bspline>
+    {
+        typedef conv_adaptor_vcgen<VertexSource, vcgen_bspline> base_type;
+
+        conv_bspline(VertexSource& vs) : 
+            conv_adaptor_vcgen<VertexSource, vcgen_bspline>(vs) {}
+
+        void   interpolation_step(double v) { base_type::generator().interpolation_step(v); }
+        double interpolation_step() const { return base_type::generator().interpolation_step(); }
+
+    private:
+        conv_bspline(const conv_bspline<VertexSource>&);
+        const conv_bspline<VertexSource>& 
+            operator = (const conv_bspline<VertexSource>&);
+    };
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_clip_polygon.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_clip_polygon.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_clip_polygon.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_clip_polygon.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,63 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Polygon clipping converter
+// There an optimized Liang-Basky algorithm is used. 
+// The algorithm doesn't optimize the degenerate edges, i.e. it will never
+// break a closed polygon into two or more ones, instead, there will be 
+// degenerate edges coinciding with the respective clipping boundaries.
+// This is a sub-optimal solution, because that optimization would require 
+// extra, rather expensive math while the rasterizer tolerates it quite well, 
+// without any considerable overhead.
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_CLIP_POLYGON_INCLUDED
+#define AGG_CONV_CLIP_POLYGON_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_conv_adaptor_vpgen.h"
+#include "agg_vpgen_clip_polygon.h"
+
+namespace mapserver
+{
+
+    //=======================================================conv_clip_polygon
+    template<class VertexSource> 
+    struct conv_clip_polygon : public conv_adaptor_vpgen<VertexSource, vpgen_clip_polygon>
+    {
+        typedef conv_adaptor_vpgen<VertexSource, vpgen_clip_polygon> base_type;
+
+        conv_clip_polygon(VertexSource& vs) : 
+            conv_adaptor_vpgen<VertexSource, vpgen_clip_polygon>(vs) {}
+
+        void clip_box(double x1, double y1, double x2, double y2)
+        {
+            base_type::vpgen().clip_box(x1, y1, x2, y2);
+        }
+
+        double x1() const { return base_type::vpgen().x1(); }
+        double y1() const { return base_type::vpgen().y1(); }
+        double x2() const { return base_type::vpgen().x2(); }
+        double y2() const { return base_type::vpgen().y2(); }
+
+    private:
+        conv_clip_polygon(const conv_clip_polygon<VertexSource>&);
+        const conv_clip_polygon<VertexSource>& 
+            operator = (const conv_clip_polygon<VertexSource>&);
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_clip_polyline.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_clip_polyline.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_clip_polyline.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_clip_polyline.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,63 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// polyline clipping converter
+// There an optimized Liang-Basky algorithm is used. 
+// The algorithm doesn't optimize the degenerate edges, i.e. it will never
+// break a closed polyline into two or more ones, instead, there will be 
+// degenerate edges coinciding with the respective clipping boundaries.
+// This is a sub-optimal solution, because that optimization would require 
+// extra, rather expensive math while the rasterizer tolerates it quite well, 
+// without any considerable overhead.
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_CLIP_polyline_INCLUDED
+#define AGG_CONV_CLIP_polyline_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_conv_adaptor_vpgen.h"
+#include "agg_vpgen_clip_polyline.h"
+
+namespace mapserver
+{
+
+    //=======================================================conv_clip_polyline
+    template<class VertexSource> 
+    struct conv_clip_polyline : public conv_adaptor_vpgen<VertexSource, vpgen_clip_polyline>
+    {
+        typedef conv_adaptor_vpgen<VertexSource, vpgen_clip_polyline> base_type;
+
+        conv_clip_polyline(VertexSource& vs) : 
+            conv_adaptor_vpgen<VertexSource, vpgen_clip_polyline>(vs) {}
+
+        void clip_box(double x1, double y1, double x2, double y2)
+        {
+            base_type::vpgen().clip_box(x1, y1, x2, y2);
+        }
+
+        double x1() const { return base_type::vpgen().x1(); }
+        double y1() const { return base_type::vpgen().y1(); }
+        double x2() const { return base_type::vpgen().x2(); }
+        double y2() const { return base_type::vpgen().y2(); }
+
+    private:
+        conv_clip_polyline(const conv_clip_polyline<VertexSource>&);
+        const conv_clip_polyline<VertexSource>& 
+            operator = (const conv_clip_polyline<VertexSource>&);
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_clipper.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_clipper.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_clipper.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_clipper.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,299 @@
+/*******************************************************************************
+*                                                                              *
+* Author    :  Angus Johnson                                                   *
+* Version   :  1.1                                                             *
+* Date      :  4 April 2011                                                    *
+* Website   :  http://www.angusj.com                                           *
+* Copyright :  Angus Johnson 2010-2011                                         *
+*                                                                              *
+* License:                                                                     *
+* Use, modification & distribution is subject to Boost Software License Ver 1. *
+* http://www.boost.org/LICENSE_1_0.txt                                         *
+*                                                                              *
+*******************************************************************************/
+
+#ifndef AGG_CONV_CLIPPER_INCLUDED
+#define AGG_CONV_CLIPPER_INCLUDED
+
+#if defined(_MSC_VER) && (_MSC_VER >= 1800)
+#include <algorithm>
+#endif
+
+#include <cmath>
+#include "agg_basics.h"
+#include "agg_array.h"
+#include "clipper.hpp"
+
+namespace mapserver
+{
+  enum clipper_op_e { clipper_or,
+    clipper_and, clipper_xor, clipper_a_minus_b, clipper_b_minus_a };
+  enum clipper_PolyFillType {clipper_even_odd, clipper_non_zero, clipper_positive, clipper_negative};
+
+  template<class VSA, class VSB> class conv_clipper
+  {
+    enum status { status_move_to, status_line_to, status_stop };
+    typedef VSA source_a_type;
+    typedef VSB source_b_type;
+    typedef conv_clipper<source_a_type, source_b_type> self_type;
+
+  private:
+    source_a_type*							m_src_a;
+    source_b_type*							m_src_b;
+    status									m_status;
+    int										m_vertex;
+    int										m_contour;
+	int										m_scaling_factor;
+    clipper_op_e							m_operation;
+    pod_bvector<ClipperLib::IntPoint, 8>		m_vertex_accumulator;
+    ClipperLib::Polygons						m_poly_a;
+    ClipperLib::Polygons						m_poly_b;
+    ClipperLib::Polygons						m_result;
+    ClipperLib::Clipper						m_clipper;
+    clipper_PolyFillType					m_subjFillType;
+    clipper_PolyFillType					m_clipFillType;
+
+    int Round(double val)
+    {
+    if ((val < 0)) return (int)(val - 0.5); else return (int)(val + 0.5);
+    }
+
+  public:
+    conv_clipper(source_a_type &a, source_b_type &b,
+      clipper_op_e op = clipper_or,
+      clipper_PolyFillType subjFillType = clipper_even_odd,
+      clipper_PolyFillType clipFillType = clipper_even_odd,
+	  int scaling_factor = 2) :
+        m_src_a(&a),
+        m_src_b(&b),
+        m_status(status_move_to),
+        m_vertex(-1),
+        m_contour(-1),
+        m_operation(op),
+        m_subjFillType(subjFillType),
+        m_clipFillType(clipFillType)
+    {
+		m_scaling_factor = std::max(std::min(scaling_factor, 6),0);
+		m_scaling_factor = Round(std::pow((double)10, m_scaling_factor));
+	}
+
+    ~conv_clipper()
+    {
+    }
+
+    void attach1(VSA &source, clipper_PolyFillType subjFillType = clipper_even_odd)
+      { m_src_a = &source; m_subjFillType = subjFillType; }
+    void attach2(VSB &source, clipper_PolyFillType clipFillType = clipper_even_odd)
+      { m_src_b = &source; m_clipFillType = clipFillType; }
+
+    void operation(clipper_op_e v) { m_operation = v; }
+
+    void rewind(unsigned path_id);
+    unsigned vertex(double* x, double* y);
+  
+    bool next_contour();
+    bool next_vertex(double* x, double* y);
+    void start_extracting();
+    void add_vertex_(double &x, double &y);
+    void end_contour(ClipperLib::Polygons &p);
+
+	template<class VS> void add(VS &src, ClipperLib::Polygons &p){
+		unsigned cmd;
+		double x; double y; double start_x; double start_y;
+		bool starting_first_line;
+
+		start_x = 0.0;
+		start_y = 0.0;
+		starting_first_line = true;
+		p.resize(0);
+
+		cmd = src->vertex( &x , &y );
+		while(!is_stop(cmd))
+		{
+		  if(is_vertex(cmd))
+		  {
+			if(is_move_to(cmd))
+			{
+			  if(!starting_first_line ) end_contour(p);
+			  start_x = x;
+			  start_y = y;
+			}
+			add_vertex_( x, y );
+			starting_first_line = false;
+		  }
+		  else if(is_end_poly(cmd))
+		  {
+			if(!starting_first_line && is_closed(cmd))
+			  add_vertex_( start_x, start_y );
+		  }
+		  cmd = src->vertex( &x, &y );
+		}
+		end_contour(p);
+	}
+  };
+
+  //------------------------------------------------------------------------
+
+  template<class VSA, class VSB> 
+  void conv_clipper<VSA, VSB>::start_extracting()
+  {
+    m_status = status_move_to;
+    m_contour = -1;
+    m_vertex = -1;
+  }
+  //------------------------------------------------------------------------------
+
+  template<class VSA, class VSB>
+  void conv_clipper<VSA, VSB>::rewind(unsigned path_id)
+  {
+    m_src_a->rewind( path_id );
+    m_src_b->rewind( path_id );
+
+    add( m_src_a , m_poly_a );
+    add( m_src_b , m_poly_b );
+    m_result.resize(0);
+
+    ClipperLib::PolyFillType pftSubj, pftClip;
+    switch (m_subjFillType)
+    {
+      case clipper_even_odd: pftSubj = ClipperLib::pftEvenOdd; break;
+      case clipper_non_zero: pftSubj = ClipperLib::pftNonZero; break;
+      case clipper_positive: pftSubj = ClipperLib::pftPositive; break;
+      default: pftSubj = ClipperLib::pftNegative;
+    }
+    switch (m_clipFillType)
+    {
+      case clipper_even_odd: pftClip = ClipperLib::pftEvenOdd; break;
+      case clipper_non_zero: pftClip = ClipperLib::pftNonZero; break;
+      case clipper_positive: pftClip = ClipperLib::pftPositive; break;
+      default: pftClip = ClipperLib::pftNegative;
+    }
+
+    m_clipper.Clear();
+    switch( m_operation ) {
+      case clipper_or:
+        {
+        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
+        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
+        m_clipper.Execute( ClipperLib::ctUnion , m_result , pftSubj, pftClip);
+		break;
+        }
+      case clipper_and:
+        {
+        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
+        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
+        m_clipper.Execute( ClipperLib::ctIntersection , m_result, pftSubj, pftClip );
+		break;
+        }
+      case clipper_xor:
+        {
+        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
+        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
+        m_clipper.Execute( ClipperLib::ctXor , m_result, pftSubj, pftClip );
+		break;
+        }
+      case clipper_a_minus_b:
+        {
+        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptSubject );
+        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptClip );
+        m_clipper.Execute( ClipperLib::ctDifference , m_result, pftSubj, pftClip );
+		break;
+        }
+      case clipper_b_minus_a:
+        {
+        m_clipper.AddPolygons( m_poly_b , ClipperLib::ptSubject );
+        m_clipper.AddPolygons( m_poly_a , ClipperLib::ptClip );
+        m_clipper.Execute( ClipperLib::ctDifference , m_result, pftSubj, pftClip );
+		break;
+        }
+    }
+    start_extracting();
+  }
+  //------------------------------------------------------------------------------
+
+  template<class VSA, class VSB>
+  void conv_clipper<VSA, VSB>::end_contour( ClipperLib::Polygons &p)
+  {
+  unsigned i, len;
+
+  if( m_vertex_accumulator.size() < 3 ) return;
+  len = p.size();
+  p.resize(len+1);
+  p[len].resize(m_vertex_accumulator.size());
+  for( i = 0 ; i < m_vertex_accumulator.size() ; i++ )
+    p[len][i] = m_vertex_accumulator[i];
+  m_vertex_accumulator.remove_all();
+  }
+  //------------------------------------------------------------------------------
+
+  template<class VSA, class VSB> 
+  void conv_clipper<VSA, VSB>::add_vertex_(double &x, double &y)
+  {
+	  ClipperLib::IntPoint v;
+
+	  v.X = Round(x * m_scaling_factor);
+	  v.Y = Round(y * m_scaling_factor);
+	  m_vertex_accumulator.add( v );
+  }
+  //------------------------------------------------------------------------------
+
+  template<class VSA, class VSB> 
+  bool conv_clipper<VSA, VSB>::next_contour()
+  {   
+	m_contour++;
+	if(m_contour >= (int)m_result.size()) return false;
+	m_vertex =-1;
+	return true;
+}
+//------------------------------------------------------------------------------
+
+  template<class VSA, class VSB> 
+  bool conv_clipper<VSA, VSB>::next_vertex(double *x, double *y)
+  {
+    m_vertex++;
+    if(m_vertex >= (int)m_result[m_contour].size()) return false;
+    *x = (double)m_result[ m_contour ][ m_vertex ].X / m_scaling_factor;
+    *y = (double)m_result[ m_contour ][ m_vertex ].Y / m_scaling_factor;
+    return true;
+  }
+  //------------------------------------------------------------------------------
+
+  template<class VSA, class VSB>
+  unsigned conv_clipper<VSA, VSB>::vertex(double *x, double *y)
+{
+  if(  m_status == status_move_to )
+  {
+    if( next_contour() )
+    {
+      if(  next_vertex( x, y ) )
+      {
+        m_status =status_line_to;
+        return path_cmd_move_to;
+      }
+	  else
+	  {
+        m_status = status_stop;
+        return path_cmd_end_poly | path_flags_close;
+      }
+    }
+	else
+      return path_cmd_stop;
+  }
+  else
+  {
+    if(  next_vertex( x, y ) )
+    {
+      return path_cmd_line_to;
+    }
+	else
+    {
+      m_status = status_move_to;
+      return path_cmd_end_poly | path_flags_close;
+    }
+  }
+}
+//------------------------------------------------------------------------------
+
+
+} //namespace agg
+#endif //AGG_CONV_CLIPPER_INCLUDED
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_close_polygon.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_close_polygon.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_close_polygon.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_close_polygon.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,125 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_CLOSE_POLYGON_INCLUDED
+#define AGG_CONV_CLOSE_POLYGON_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //======================================================conv_close_polygon
+    template<class VertexSource> class conv_close_polygon
+    {
+    public:
+        explicit conv_close_polygon(VertexSource& vs) : m_source(&vs) {}
+        void attach(VertexSource& source) { m_source = &source; }
+
+        void rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        conv_close_polygon(const conv_close_polygon<VertexSource>&);
+        const conv_close_polygon<VertexSource>& 
+            operator = (const conv_close_polygon<VertexSource>&);
+
+        VertexSource* m_source;
+        unsigned      m_cmd[2];
+        double        m_x[2];
+        double        m_y[2];
+        unsigned      m_vertex;
+        bool          m_line_to;
+    };
+
+
+
+    //------------------------------------------------------------------------
+    template<class VertexSource> 
+    void conv_close_polygon<VertexSource>::rewind(unsigned path_id)
+    {
+        m_source->rewind(path_id);
+        m_vertex = 2;
+        m_line_to = false;
+    }
+
+
+    
+    //------------------------------------------------------------------------
+    template<class VertexSource> 
+    unsigned conv_close_polygon<VertexSource>::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_stop;
+        for(;;)
+        {
+            if(m_vertex < 2)
+            {
+                *x = m_x[m_vertex];
+                *y = m_y[m_vertex];
+                cmd = m_cmd[m_vertex];
+                ++m_vertex;
+                break;
+            }
+
+            cmd = m_source->vertex(x, y);
+
+            if(is_end_poly(cmd))
+            {
+                cmd |= path_flags_close;
+                break;
+            }
+
+            if(is_stop(cmd))
+            {
+                if(m_line_to)
+                {
+                    m_cmd[0]  = path_cmd_end_poly | path_flags_close;
+                    m_cmd[1]  = path_cmd_stop;
+                    m_vertex  = 0;
+                    m_line_to = false;
+                    continue;
+                }
+                break;
+            }
+
+            if(is_move_to(cmd))
+            {
+                if(m_line_to)
+                {
+                    m_x[0]    = 0.0;
+                    m_y[0]    = 0.0;
+                    m_cmd[0]  = path_cmd_end_poly | path_flags_close;
+                    m_x[1]    = *x;
+                    m_y[1]    = *y;
+                    m_cmd[1]  = cmd;
+                    m_vertex  = 0;
+                    m_line_to = false;
+                    continue;
+                }
+                break;
+            }
+
+            if(is_vertex(cmd))
+            {
+                m_line_to = true;
+                break;
+            }
+        }
+        return cmd;
+    }
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_concat.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_concat.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_concat.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_concat.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,73 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_CONCAT_INCLUDED
+#define AGG_CONV_CONCAT_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //=============================================================conv_concat
+    // Concatenation of two paths. Usually used to combine lines or curves 
+    // with markers such as arrowheads
+    template<class VS1, class VS2> class conv_concat
+    {
+    public:
+        conv_concat(VS1& source1, VS2& source2) :
+            m_source1(&source1), m_source2(&source2), m_status(2) {}
+        void attach1(VS1& source) { m_source1 = &source; }
+        void attach2(VS2& source) { m_source2 = &source; }
+
+
+        void rewind(unsigned path_id)
+        { 
+            m_source1->rewind(path_id);
+            m_source2->rewind(0);
+            m_status = 0;
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            unsigned cmd;
+            if(m_status == 0)
+            {
+                cmd = m_source1->vertex(x, y);
+                if(!is_stop(cmd)) return cmd;
+                m_status = 1;
+            }
+            if(m_status == 1)
+            {
+                cmd = m_source2->vertex(x, y);
+                if(!is_stop(cmd)) return cmd;
+                m_status = 2;
+            }
+            return path_cmd_stop;
+        }
+
+    private:
+        conv_concat(const conv_concat<VS1, VS2>&);
+        const conv_concat<VS1, VS2>& 
+            operator = (const conv_concat<VS1, VS2>&);
+
+        VS1* m_source1;
+        VS2* m_source2;
+        int  m_status;
+
+    };
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_contour.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_contour.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_contour.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_contour.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,65 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// conv_stroke
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_CONTOUR_INCLUDED
+#define AGG_CONV_CONTOUR_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vcgen_contour.h"
+#include "agg_conv_adaptor_vcgen.h"
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------------conv_contour
+    template<class VertexSource> 
+    struct conv_contour : public conv_adaptor_vcgen<VertexSource, vcgen_contour>
+    {
+        typedef conv_adaptor_vcgen<VertexSource, vcgen_contour> base_type;
+
+        conv_contour(VertexSource& vs) : 
+            conv_adaptor_vcgen<VertexSource, vcgen_contour>(vs)
+        {
+        }
+
+        void line_join(line_join_e lj) { base_type::generator().line_join(lj); }
+        void inner_join(inner_join_e ij) { base_type::generator().inner_join(ij); }
+        void width(double w) { base_type::generator().width(w); }
+        void miter_limit(double ml) { base_type::generator().miter_limit(ml); }
+        void miter_limit_theta(double t) { base_type::generator().miter_limit_theta(t); }
+        void inner_miter_limit(double ml) { base_type::generator().inner_miter_limit(ml); }
+        void approximation_scale(double as) { base_type::generator().approximation_scale(as); }
+        void auto_detect_orientation(bool v) { base_type::generator().auto_detect_orientation(v); }
+
+        line_join_e line_join() const { return base_type::generator().line_join(); }
+        inner_join_e inner_join() const { return base_type::generator().inner_join(); }
+        double width() const { return base_type::generator().width(); }
+        double miter_limit() const { return base_type::generator().miter_limit(); }
+        double inner_miter_limit() const { return base_type::generator().inner_miter_limit(); }
+        double approximation_scale() const { return base_type::generator().approximation_scale(); }
+        bool auto_detect_orientation() const { return base_type::generator().auto_detect_orientation(); }
+
+    private:
+        conv_contour(const conv_contour<VertexSource>&);
+        const conv_contour<VertexSource>& 
+            operator = (const conv_contour<VertexSource>&);
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_curve.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_curve.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_curve.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_curve.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,201 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// classes conv_curve
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_CURVE_INCLUDED
+#define AGG_CONV_CURVE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_curves.h"
+
+namespace mapserver
+{
+
+
+    //---------------------------------------------------------------conv_curve
+    // Curve converter class. Any path storage can have Bezier curves defined 
+    // by their control points. There're two types of curves supported: curve3 
+    // and curve4. Curve3 is a conic Bezier curve with 2 endpoints and 1 control
+    // point. Curve4 has 2 control points (4 points in total) and can be used
+    // to interpolate more complicated curves. Curve4, unlike curve3 can be used 
+    // to approximate arcs, both circular and elliptical. Curves are approximated 
+    // with straight lines and one of the approaches is just to store the whole 
+    // sequence of vertices that approximate our curve. It takes additional 
+    // memory, and at the same time the consecutive vertices can be calculated 
+    // on demand. 
+    //
+    // Initially, path storages are not suppose to keep all the vertices of the
+    // curves (although, nothing prevents us from doing so). Instead, path_storage
+    // keeps only vertices, needed to calculate a curve on demand. Those vertices
+    // are marked with special commands. So, if the path_storage contains curves 
+    // (which are not real curves yet), and we render this storage directly, 
+    // all we will see is only 2 or 3 straight line segments (for curve3 and 
+    // curve4 respectively). If we need to see real curves drawn we need to 
+    // include this class into the conversion pipeline. 
+    //
+    // Class conv_curve recognizes commands path_cmd_curve3 and path_cmd_curve4 
+    // and converts these vertices into a move_to/line_to sequence. 
+    //-----------------------------------------------------------------------
+    template<class VertexSource, 
+             class Curve3=curve3, 
+             class Curve4=curve4> class conv_curve
+    {
+    public:
+        typedef Curve3 curve3_type;
+        typedef Curve4 curve4_type;
+        typedef conv_curve<VertexSource, Curve3, Curve4> self_type;
+
+        explicit conv_curve(VertexSource& source) :
+          m_source(&source), m_last_x(0.0), m_last_y(0.0) {}
+        void attach(VertexSource& source) { m_source = &source; }
+
+        void approximation_method(curve_approximation_method_e v) 
+        { 
+            m_curve3.approximation_method(v);
+            m_curve4.approximation_method(v);
+        }
+
+        curve_approximation_method_e approximation_method() const 
+        { 
+            return m_curve4.approximation_method();
+        }
+
+        void approximation_scale(double s) 
+        { 
+            m_curve3.approximation_scale(s); 
+            m_curve4.approximation_scale(s); 
+        }
+
+        double approximation_scale() const 
+        { 
+            return m_curve4.approximation_scale();  
+        }
+
+        void angle_tolerance(double v) 
+        { 
+            m_curve3.angle_tolerance(v); 
+            m_curve4.angle_tolerance(v); 
+        }
+
+        double angle_tolerance() const 
+        { 
+            return m_curve4.angle_tolerance();  
+        }
+
+        void cusp_limit(double v) 
+        { 
+            m_curve3.cusp_limit(v); 
+            m_curve4.cusp_limit(v); 
+        }
+
+        double cusp_limit() const 
+        { 
+            return m_curve4.cusp_limit();  
+        }
+
+        void     rewind(unsigned path_id); 
+        unsigned vertex(double* x, double* y);
+
+    private:
+        conv_curve(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        VertexSource* m_source;
+        double        m_last_x;
+        double        m_last_y;
+        curve3_type   m_curve3;
+        curve4_type   m_curve4;
+    };
+
+
+
+    //------------------------------------------------------------------------
+    template<class VertexSource, class Curve3, class Curve4>
+    void conv_curve<VertexSource, Curve3, Curve4>::rewind(unsigned path_id)
+    {
+        m_source->rewind(path_id);
+        m_last_x = 0.0;
+        m_last_y = 0.0;
+        m_curve3.reset();
+        m_curve4.reset();
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VertexSource, class Curve3, class Curve4>
+    unsigned conv_curve<VertexSource, Curve3, Curve4>::vertex(double* x, double* y)
+    {
+        if(!is_stop(m_curve3.vertex(x, y)))
+        {
+            m_last_x = *x;
+            m_last_y = *y;
+            return path_cmd_line_to;
+        }
+
+        if(!is_stop(m_curve4.vertex(x, y)))
+        {
+            m_last_x = *x;
+            m_last_y = *y;
+            return path_cmd_line_to;
+        }
+
+        double ct2_x = 0;
+        double ct2_y = 0;
+        double end_x = 0;
+        double end_y = 0;
+
+        unsigned cmd = m_source->vertex(x, y);
+        switch(cmd)
+        {
+        case path_cmd_curve3:
+            m_source->vertex(&end_x, &end_y);
+
+            m_curve3.init(m_last_x, m_last_y, 
+                          *x,       *y, 
+                          end_x,     end_y);
+
+            m_curve3.vertex(x, y);    // First call returns path_cmd_move_to
+            m_curve3.vertex(x, y);    // This is the first vertex of the curve
+            cmd = path_cmd_line_to;
+            break;
+
+        case path_cmd_curve4:
+            m_source->vertex(&ct2_x, &ct2_y);
+            m_source->vertex(&end_x, &end_y);
+
+            m_curve4.init(m_last_x, m_last_y, 
+                          *x,       *y, 
+                          ct2_x,    ct2_y, 
+                          end_x,    end_y);
+
+            m_curve4.vertex(x, y);    // First call returns path_cmd_move_to
+            m_curve4.vertex(x, y);    // This is the first vertex of the curve
+            cmd = path_cmd_line_to;
+            break;
+        }
+        m_last_x = *x;
+        m_last_y = *y;
+        return cmd;
+    }
+
+
+}
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_dash.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_dash.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_dash.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_dash.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,68 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// conv_dash
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_DASH_INCLUDED
+#define AGG_CONV_DASH_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vcgen_dash.h"
+#include "agg_conv_adaptor_vcgen.h"
+
+namespace mapserver
+{
+
+    //---------------------------------------------------------------conv_dash
+    template<class VertexSource, class Markers=null_markers> 
+    struct conv_dash : public conv_adaptor_vcgen<VertexSource, vcgen_dash, Markers>
+    {
+        typedef Markers marker_type;
+        typedef conv_adaptor_vcgen<VertexSource, vcgen_dash, Markers> base_type;
+
+        conv_dash(VertexSource& vs) : 
+            conv_adaptor_vcgen<VertexSource, vcgen_dash, Markers>(vs)
+        {
+        }
+
+        void remove_all_dashes() 
+        { 
+            base_type::generator().remove_all_dashes(); 
+        }
+
+        void add_dash(double dash_len, double gap_len) 
+        { 
+            base_type::generator().add_dash(dash_len, gap_len); 
+        }
+
+        void dash_start(double ds) 
+        { 
+            base_type::generator().dash_start(ds); 
+        }
+
+        void shorten(double s) { base_type::generator().shorten(s); }
+        double shorten() const { return base_type::generator().shorten(); }
+
+    private:
+        conv_dash(const conv_dash<VertexSource, Markers>&);
+        const conv_dash<VertexSource, Markers>& 
+            operator = (const conv_dash<VertexSource, Markers>&);
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_gpc.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_gpc.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_gpc.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_gpc.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,432 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// General Polygon Clipper based on the GPC library by Alan Murta 
+// Union, Intersection, XOR, A-B, B-A
+// Contact the author if you intend to use it in commercial applications!
+// http://www.cs.man.ac.uk/aig/staff/alan/software/
+// Alan Murta (email: gpc@cs.man.ac.uk)
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_GPC_INCLUDED
+#define AGG_CONV_GPC_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+#include "agg_array.h"
+
+extern "C" 
+{ 
+#include "gpc.h" 
+}
+
+namespace mapserver
+{
+    enum gpc_op_e
+    {
+        gpc_or,
+        gpc_and,
+        gpc_xor,
+        gpc_a_minus_b,
+        gpc_b_minus_a
+    };
+
+
+    //================================================================conv_gpc
+    template<class VSA, class VSB> class conv_gpc
+    {
+        enum status
+        {
+            status_move_to,
+            status_line_to,
+            status_stop
+        };
+
+        struct contour_header_type
+        {
+            int num_vertices;
+            int hole_flag;
+            gpc_vertex* vertices;
+        };
+
+        typedef pod_bvector<gpc_vertex, 8>          vertex_array_type;
+        typedef pod_bvector<contour_header_type, 6> contour_header_array_type;
+
+
+    public:
+        typedef VSA source_a_type;
+        typedef VSB source_b_type;
+        typedef conv_gpc<source_a_type, source_b_type> self_type;
+
+        ~conv_gpc()
+        {
+            free_gpc_data();
+        }
+
+        conv_gpc(source_a_type& a, source_b_type& b, gpc_op_e op = gpc_or) :
+            m_src_a(&a),
+            m_src_b(&b),
+            m_status(status_move_to),
+            m_vertex(-1),
+            m_contour(-1),
+            m_operation(op)
+        {
+            memset(&m_poly_a, 0, sizeof(m_poly_a));
+            memset(&m_poly_b, 0, sizeof(m_poly_b));
+            memset(&m_result, 0, sizeof(m_result));
+        }
+
+        void attach1(VSA& source) { m_src_a = &source; }
+        void attach2(VSB& source) { m_src_b = &source; }
+
+        void operation(gpc_op_e v) { m_operation = v; }
+
+        // Vertex Source Interface
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        conv_gpc(const conv_gpc<VSA, VSB>&);
+        const conv_gpc<VSA, VSB>& operator = (const conv_gpc<VSA, VSB>&);
+
+        //--------------------------------------------------------------------
+        void free_polygon(gpc_polygon& p);
+        void free_result();
+        void free_gpc_data();
+        void start_contour();
+        void add_vertex(double x, double y);
+        void end_contour(unsigned orientation);
+        void make_polygon(gpc_polygon& p);
+        void start_extracting();
+        bool next_contour();
+        bool next_vertex(double* x, double* y);
+
+
+        //--------------------------------------------------------------------
+        template<class VS> void add(VS& src, gpc_polygon& p)
+        {
+            unsigned cmd;
+            double x, y;
+            double start_x = 0.0;
+            double start_y = 0.0;
+            bool line_to = false;
+            unsigned orientation = 0;
+
+            m_contour_accumulator.remove_all();
+
+            while(!is_stop(cmd = src.vertex(&x, &y)))
+            {
+                if(is_vertex(cmd))
+                {
+                    if(is_move_to(cmd))
+                    {
+                        if(line_to)
+                        {
+                            end_contour(orientation);
+                            orientation = 0;
+                        }
+                        start_contour();
+                        start_x = x;
+                        start_y = y;
+                    }
+                    add_vertex(x, y);
+                    line_to = true;
+                }
+                else
+                {
+                    if(is_end_poly(cmd))
+                    {
+                        orientation = get_orientation(cmd);
+                        if(line_to && is_closed(cmd))
+                        {
+                            add_vertex(start_x, start_y);
+                        }
+                    }
+                }
+            }
+            if(line_to)
+            {
+                end_contour(orientation);
+            }
+            make_polygon(p);
+        }
+
+
+    private:
+        //--------------------------------------------------------------------
+        source_a_type*             m_src_a;
+        source_b_type*             m_src_b;
+        status                     m_status;
+        int                        m_vertex;
+        int                        m_contour;
+        gpc_op_e                   m_operation;
+        vertex_array_type          m_vertex_accumulator;
+        contour_header_array_type  m_contour_accumulator;
+        gpc_polygon                m_poly_a;
+        gpc_polygon                m_poly_b;
+        gpc_polygon                m_result;
+    };
+
+
+
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::free_polygon(gpc_polygon& p)
+    {
+        int i;
+        for(i = 0; i < p.num_contours; i++)
+        {
+            pod_allocator<gpc_vertex>::deallocate(p.contour[i].vertex, 
+                                                  p.contour[i].num_vertices);
+        }
+        pod_allocator<gpc_vertex_list>::deallocate(p.contour, p.num_contours);
+        memset(&p, 0, sizeof(gpc_polygon));
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::free_result()
+    {
+        if(m_result.contour)
+        {
+            gpc_free_polygon(&m_result);
+        }
+        memset(&m_result, 0, sizeof(m_result));
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::free_gpc_data()
+    {
+        free_polygon(m_poly_a);
+        free_polygon(m_poly_b);
+        free_result();
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::start_contour()
+    {
+        contour_header_type h;
+        memset(&h, 0, sizeof(h));
+        m_contour_accumulator.add(h);
+        m_vertex_accumulator.remove_all();
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    inline void conv_gpc<VSA, VSB>::add_vertex(double x, double y)
+    {
+        gpc_vertex v;
+        v.x = x;
+        v.y = y;
+        m_vertex_accumulator.add(v);
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::end_contour(unsigned orientation)
+    {
+        if(m_contour_accumulator.size())
+        {
+            if(m_vertex_accumulator.size() > 2)
+            {
+                contour_header_type& h = 
+                    m_contour_accumulator[m_contour_accumulator.size() - 1];
+
+                h.num_vertices = m_vertex_accumulator.size();
+                h.hole_flag = 0;
+
+                // TO DO: Clarify the "holes"
+                //if(is_cw(orientation)) h.hole_flag = 1;
+
+                h.vertices = pod_allocator<gpc_vertex>::allocate(h.num_vertices);
+                gpc_vertex* d = h.vertices;
+                int i;
+                for(i = 0; i < h.num_vertices; i++)
+                {
+                    const gpc_vertex& s = m_vertex_accumulator[i];
+                    d->x = s.x;
+                    d->y = s.y;
+                    ++d;
+                }
+            }
+            else
+            {
+                m_vertex_accumulator.remove_last();
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::make_polygon(gpc_polygon& p)
+    {
+        free_polygon(p);
+        if(m_contour_accumulator.size())
+        {
+            p.num_contours = m_contour_accumulator.size();
+
+            p.hole = 0;
+            p.contour = pod_allocator<gpc_vertex_list>::allocate(p.num_contours);
+
+            int i;
+            gpc_vertex_list* pv = p.contour;
+            for(i = 0; i < p.num_contours; i++)
+            {
+                const contour_header_type& h = m_contour_accumulator[i];
+                pv->num_vertices = h.num_vertices;
+                pv->vertex = h.vertices;
+                ++pv;
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::start_extracting()
+    {
+        m_status = status_move_to;
+        m_contour = -1;
+        m_vertex = -1;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    bool conv_gpc<VSA, VSB>::next_contour()
+    {
+        if(++m_contour < m_result.num_contours)
+        {
+            m_vertex = -1;
+            return true;
+        }
+        return false;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    inline bool conv_gpc<VSA, VSB>::next_vertex(double* x, double* y)
+    {
+        const gpc_vertex_list& vlist = m_result.contour[m_contour];
+        if(++m_vertex < vlist.num_vertices)
+        {
+            const gpc_vertex& v = vlist.vertex[m_vertex];
+            *x = v.x;
+            *y = v.y;
+            return true;
+        }
+        return false;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    void conv_gpc<VSA, VSB>::rewind(unsigned path_id)
+    {
+        free_result();
+        m_src_a->rewind(path_id);
+        m_src_b->rewind(path_id);
+        add(*m_src_a, m_poly_a);
+        add(*m_src_b, m_poly_b);
+        switch(m_operation)
+        {
+           case gpc_or:
+                gpc_polygon_clip(GPC_UNION,
+                                 &m_poly_a,
+                                 &m_poly_b,
+                                 &m_result);
+               break;
+
+           case gpc_and:
+                gpc_polygon_clip(GPC_INT,
+                                 &m_poly_a,
+                                 &m_poly_b,
+                                 &m_result);
+               break;
+
+           case gpc_xor:
+                gpc_polygon_clip(GPC_XOR,
+                                 &m_poly_a,
+                                 &m_poly_b,
+                                 &m_result);
+               break;
+
+           case gpc_a_minus_b:
+                gpc_polygon_clip(GPC_DIFF,
+                                 &m_poly_a,
+                                 &m_poly_b,
+                                 &m_result);
+               break;
+
+           case gpc_b_minus_a:
+                gpc_polygon_clip(GPC_DIFF,
+                                 &m_poly_b,
+                                 &m_poly_a,
+                                 &m_result);
+               break;
+        }
+        start_extracting();
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VSA, class VSB> 
+    unsigned conv_gpc<VSA, VSB>::vertex(double* x, double* y)
+    {
+        if(m_status == status_move_to)
+        {
+            if(next_contour()) 
+            {
+                if(next_vertex(x, y))
+                {
+                    m_status = status_line_to;
+                    return path_cmd_move_to;
+                }
+                m_status = status_stop;
+                return path_cmd_end_poly | path_flags_close;
+            }
+        }
+        else
+        {
+            if(next_vertex(x, y))
+            {
+                return path_cmd_line_to;
+            }
+            else
+            {
+                m_status = status_move_to;
+            }
+            return path_cmd_end_poly | path_flags_close;
+        }
+        return path_cmd_stop;
+    }
+
+   
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_marker.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_marker.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_marker.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_marker.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,148 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// conv_marker
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_MARKER_INCLUDED
+#define AGG_CONV_MARKER_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_trans_affine.h"
+
+namespace mapserver
+{
+    //-------------------------------------------------------------conv_marker
+    template<class MarkerLocator, class MarkerShapes>
+    class conv_marker
+    {
+    public:
+        conv_marker(MarkerLocator& ml, MarkerShapes& ms);
+
+        trans_affine& transform() { return m_transform; }
+        const trans_affine& transform() const { return m_transform; }
+
+        void rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        conv_marker(const conv_marker<MarkerLocator, MarkerShapes>&);
+        const conv_marker<MarkerLocator, MarkerShapes>& 
+            operator = (const conv_marker<MarkerLocator, MarkerShapes>&);
+
+        enum status_e 
+        {
+            initial,
+            markers,
+            polygon,
+            stop
+        };
+
+        MarkerLocator* m_marker_locator;
+        MarkerShapes*  m_marker_shapes;
+        trans_affine   m_transform;
+        trans_affine   m_mtx;
+        status_e       m_status;
+        unsigned       m_marker;
+        unsigned       m_num_markers;
+    };
+
+
+    //------------------------------------------------------------------------
+    template<class MarkerLocator, class MarkerShapes> 
+    conv_marker<MarkerLocator, MarkerShapes>::conv_marker(MarkerLocator& ml, MarkerShapes& ms) :
+        m_marker_locator(&ml),
+        m_marker_shapes(&ms),
+        m_status(initial),
+        m_marker(0),
+        m_num_markers(1)
+    {
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class MarkerLocator, class MarkerShapes> 
+    void conv_marker<MarkerLocator, MarkerShapes>::rewind(unsigned)
+    {
+        m_status = initial;
+        m_marker = 0;
+        m_num_markers = 1;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class MarkerLocator, class MarkerShapes> 
+    unsigned conv_marker<MarkerLocator, MarkerShapes>::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_move_to;
+        double x1, y1, x2, y2;
+
+        while(!is_stop(cmd))
+        {
+            switch(m_status)
+            {
+            case initial:
+                if(m_num_markers == 0)
+                {
+                   cmd = path_cmd_stop;
+                   break;
+                }
+                m_marker_locator->rewind(m_marker);
+                ++m_marker;
+                m_num_markers = 0;
+                m_status = markers;
+
+            case markers:
+                if(is_stop(m_marker_locator->vertex(&x1, &y1)))
+                {
+                    m_status = initial;
+                    break;
+                }
+                if(is_stop(m_marker_locator->vertex(&x2, &y2)))
+                {
+                    m_status = initial;
+                    break;
+                }
+                ++m_num_markers;
+                m_mtx = m_transform;
+                m_mtx *= trans_affine_rotation(atan2(y2 - y1, x2 - x1));
+                m_mtx *= trans_affine_translation(x1, y1);
+                m_marker_shapes->rewind(m_marker - 1);
+                m_status = polygon;
+
+            case polygon:
+                cmd = m_marker_shapes->vertex(x, y);
+                if(is_stop(cmd))
+                {
+                    cmd = path_cmd_move_to;
+                    m_status = markers;
+                    break;
+                }
+                m_mtx.transform(x, y);
+                return cmd;
+
+            case stop:
+                cmd = path_cmd_stop;
+                break;
+            }
+        }
+        return cmd;
+    }
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_marker_adaptor.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_marker_adaptor.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_marker_adaptor.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_marker_adaptor.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,51 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_MARKER_ADAPTOR_INCLUDED
+#define AGG_CONV_MARKER_ADAPTOR_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_conv_adaptor_vcgen.h"
+#include "agg_vcgen_vertex_sequence.h"
+
+namespace mapserver
+{
+
+    //=====================================================conv_marker_adaptor
+    template<class VertexSource, class Markers=null_markers>
+    struct conv_marker_adaptor : 
+    public conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence, Markers>
+    {
+        typedef Markers marker_type;
+        typedef conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence, Markers> base_type;
+
+        conv_marker_adaptor(VertexSource& vs) : 
+            conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence, Markers>(vs)
+        {
+        }
+
+        void shorten(double s) { base_type::generator().shorten(s); }
+        double shorten() const { return base_type::generator().shorten(); }
+
+    private:
+        conv_marker_adaptor(const conv_marker_adaptor<VertexSource, Markers>&);
+        const conv_marker_adaptor<VertexSource, Markers>& 
+            operator = (const conv_marker_adaptor<VertexSource, Markers>&);
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_segmentator.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_segmentator.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_segmentator.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_segmentator.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,48 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_SEGMENTATOR_INCLUDED
+#define AGG_CONV_SEGMENTATOR_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_conv_adaptor_vpgen.h"
+#include "agg_vpgen_segmentator.h"
+
+namespace mapserver
+{
+
+    //========================================================conv_segmentator
+    template<class VertexSource> 
+    struct conv_segmentator : public conv_adaptor_vpgen<VertexSource, vpgen_segmentator>
+    {
+        typedef conv_adaptor_vpgen<VertexSource, vpgen_segmentator> base_type;
+
+        conv_segmentator(VertexSource& vs) : 
+            conv_adaptor_vpgen<VertexSource, vpgen_segmentator>(vs) {}
+
+        void approximation_scale(double s) { base_type::vpgen().approximation_scale(s);        }
+        double approximation_scale() const { return base_type::vpgen().approximation_scale();  }
+
+    private:
+        conv_segmentator(const conv_segmentator<VertexSource>&);
+        const conv_segmentator<VertexSource>& 
+            operator = (const conv_segmentator<VertexSource>&);
+    };
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_shorten_path.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_shorten_path.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_shorten_path.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_shorten_path.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,50 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_SHORTEN_PATH_INCLUDED
+#define AGG_CONV_SHORTEN_PATH_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_conv_adaptor_vcgen.h"
+#include "agg_vcgen_vertex_sequence.h"
+
+namespace mapserver
+{
+
+    //=======================================================conv_shorten_path
+    template<class VertexSource>  class conv_shorten_path : 
+    public conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence>
+    {
+    public:
+        typedef conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence> base_type;
+
+        conv_shorten_path(VertexSource& vs) : 
+            conv_adaptor_vcgen<VertexSource, vcgen_vertex_sequence>(vs)
+        {
+        }
+
+        void shorten(double s) { base_type::generator().shorten(s); }
+        double shorten() const { return base_type::generator().shorten(); }
+
+    private:
+        conv_shorten_path(const conv_shorten_path<VertexSource>&);
+        const conv_shorten_path<VertexSource>& 
+            operator = (const conv_shorten_path<VertexSource>&);
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_smooth_poly1.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_smooth_poly1.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_smooth_poly1.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_smooth_poly1.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,80 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Smooth polygon generator
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_SMOOTH_POLY1_INCLUDED
+#define AGG_CONV_SMOOTH_POLY1_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vcgen_smooth_poly1.h"
+#include "agg_conv_adaptor_vcgen.h"
+#include "agg_conv_curve.h"
+
+
+namespace mapserver
+{
+
+    //-------------------------------------------------------conv_smooth_poly1
+    template<class VertexSource> 
+    struct conv_smooth_poly1 : 
+    public conv_adaptor_vcgen<VertexSource, vcgen_smooth_poly1>
+    {
+        typedef conv_adaptor_vcgen<VertexSource, vcgen_smooth_poly1> base_type;
+
+        conv_smooth_poly1(VertexSource& vs) : 
+            conv_adaptor_vcgen<VertexSource, vcgen_smooth_poly1>(vs)
+        {
+        }
+
+        void   smooth_value(double v) { base_type::generator().smooth_value(v); }
+        double smooth_value() const { return base_type::generator().smooth_value(); }
+
+    private:
+        conv_smooth_poly1(const conv_smooth_poly1<VertexSource>&);
+        const conv_smooth_poly1<VertexSource>& 
+            operator = (const conv_smooth_poly1<VertexSource>&);
+    };
+
+
+
+    //-------------------------------------------------conv_smooth_poly1_curve
+    template<class VertexSource> 
+    struct conv_smooth_poly1_curve : 
+    public conv_curve<conv_smooth_poly1<VertexSource> >
+    {
+        conv_smooth_poly1_curve(VertexSource& vs) :
+            conv_curve<conv_smooth_poly1<VertexSource> >(m_smooth),
+            m_smooth(vs)
+        {
+        }
+
+        void   smooth_value(double v) { m_smooth.generator().smooth_value(v); }
+        double smooth_value() const { return m_smooth.generator().smooth_value(); }
+
+    private:
+        conv_smooth_poly1_curve(const conv_smooth_poly1_curve<VertexSource>&);
+        const conv_smooth_poly1_curve<VertexSource>& 
+            operator = (const conv_smooth_poly1_curve<VertexSource>&);
+
+        conv_smooth_poly1<VertexSource> m_smooth;
+    };
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_stroke.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_stroke.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_stroke.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_stroke.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,73 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// conv_stroke
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_STROKE_INCLUDED
+#define AGG_CONV_STROKE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vcgen_stroke.h"
+#include "agg_conv_adaptor_vcgen.h"
+
+namespace mapserver
+{
+
+    //-------------------------------------------------------------conv_stroke
+    template<class VertexSource, class Markers=null_markers> 
+    struct conv_stroke : 
+    public conv_adaptor_vcgen<VertexSource, vcgen_stroke, Markers>
+    {
+        typedef Markers marker_type;
+        typedef conv_adaptor_vcgen<VertexSource, vcgen_stroke, Markers> base_type;
+
+        conv_stroke(VertexSource& vs) : 
+            conv_adaptor_vcgen<VertexSource, vcgen_stroke, Markers>(vs)
+        {
+        }
+
+        void line_cap(line_cap_e lc)     { base_type::generator().line_cap(lc);  }
+        void line_join(line_join_e lj)   { base_type::generator().line_join(lj); }
+        void inner_join(inner_join_e ij) { base_type::generator().inner_join(ij); }
+
+        line_cap_e   line_cap()   const { return base_type::generator().line_cap();  }
+        line_join_e  line_join()  const { return base_type::generator().line_join(); }
+        inner_join_e inner_join() const { return base_type::generator().inner_join(); }
+
+        void width(double w) { base_type::generator().width(w); }
+        void miter_limit(double ml) { base_type::generator().miter_limit(ml); }
+        void miter_limit_theta(double t) { base_type::generator().miter_limit_theta(t); }
+        void inner_miter_limit(double ml) { base_type::generator().inner_miter_limit(ml); }
+        void approximation_scale(double as) { base_type::generator().approximation_scale(as); }
+
+        double width() const { return base_type::generator().width(); }
+        double miter_limit() const { return base_type::generator().miter_limit(); }
+        double inner_miter_limit() const { return base_type::generator().inner_miter_limit(); }
+        double approximation_scale() const { return base_type::generator().approximation_scale(); }
+
+        void shorten(double s) { base_type::generator().shorten(s); }
+        double shorten() const { return base_type::generator().shorten(); }
+
+    private:
+       conv_stroke(const conv_stroke<VertexSource, Markers>&);
+       const conv_stroke<VertexSource, Markers>& 
+           operator = (const conv_stroke<VertexSource, Markers>&);
+
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_transform.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_transform.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_transform.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_transform.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,68 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class conv_transform
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_CONV_TRANSFORM_INCLUDED
+#define AGG_CONV_TRANSFORM_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_trans_affine.h"
+
+namespace mapserver
+{
+
+    //----------------------------------------------------------conv_transform
+    template<class VertexSource, class Transformer=trans_affine> class conv_transform
+    {
+    public:
+        conv_transform(VertexSource& source, const Transformer& tr) :
+            m_source(&source), m_trans(&tr) {}
+        void attach(VertexSource& source) { m_source = &source; }
+
+        void rewind(unsigned path_id) 
+        { 
+            m_source->rewind(path_id); 
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            unsigned cmd = m_source->vertex(x, y);
+            if(is_vertex(cmd))
+            {
+                m_trans->transform(x, y);
+            }
+            return cmd;
+        }
+
+        void transformer(const Transformer& tr)
+        {
+            m_trans = &tr;
+        }
+
+    private:
+        conv_transform(const conv_transform<VertexSource>&);
+        const conv_transform<VertexSource>& 
+            operator = (const conv_transform<VertexSource>&);
+
+        VertexSource*      m_source;
+        const Transformer* m_trans;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_conv_unclose_polygon.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_unclose_polygon.h
--- 8.0.1-5/src/renderers/agg/include/agg_conv_unclose_polygon.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_conv_unclose_polygon.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,52 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CONV_UNCLOSE_POLYGON_INCLUDED
+#define AGG_CONV_UNCLOSE_POLYGON_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //====================================================conv_unclose_polygon
+    template<class VertexSource> class conv_unclose_polygon
+    {
+    public:
+        explicit conv_unclose_polygon(VertexSource& vs) : m_source(&vs) {}
+        void attach(VertexSource& source) { m_source = &source; }
+
+        void rewind(unsigned path_id)
+        {
+            m_source->rewind(path_id);
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            unsigned cmd = m_source->vertex(x, y);
+            if(is_end_poly(cmd)) cmd &= ~path_flags_close;
+            return cmd;
+        }
+
+    private:
+        conv_unclose_polygon(const conv_unclose_polygon<VertexSource>&);
+        const conv_unclose_polygon<VertexSource>& 
+            operator = (const conv_unclose_polygon<VertexSource>&);
+
+        VertexSource* m_source;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_curves.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_curves.h
--- 8.0.1-5/src/renderers/agg/include/agg_curves.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_curves.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,669 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+// Copyright (C) 2005 Tony Juricic (tonygeek@yahoo.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_CURVES_INCLUDED
+#define AGG_CURVES_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+
+    // See Implementation agg_curves.cpp
+
+    //--------------------------------------------curve_approximation_method_e
+    enum curve_approximation_method_e
+    {
+        curve_inc,
+        curve_div
+    };
+    
+    //--------------------------------------------------------------curve3_inc
+    class curve3_inc
+    {
+    public:
+        curve3_inc() = default;
+
+        curve3_inc(double x1, double y1, 
+                   double x2, double y2, 
+                   double x3, double y3)
+        { 
+            init(x1, y1, x2, y2, x3, y3);
+        }
+
+        void reset() { m_num_steps = 0; m_step = -1; }
+        void init(double x1, double y1, 
+                  double x2, double y2, 
+                  double x3, double y3);
+
+        void approximation_method(curve_approximation_method_e) {}
+        curve_approximation_method_e approximation_method() const { return curve_inc; }
+
+        void approximation_scale(double s);
+        double approximation_scale() const;
+
+        void angle_tolerance(double) {}
+        double angle_tolerance() const { return 0.0; }
+
+        void cusp_limit(double) {}
+        double cusp_limit() const { return 0.0; }
+
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        int      m_num_steps = 0;
+        int      m_step = 0;
+        double   m_scale = 1;
+        double   m_start_x = 0; 
+        double   m_start_y = 0;
+        double   m_end_x = 0; 
+        double   m_end_y = 0;
+        double   m_fx = 0; 
+        double   m_fy = 0;
+        double   m_dfx = 0; 
+        double   m_dfy = 0;
+        double   m_ddfx = 0; 
+        double   m_ddfy = 0;
+        double   m_saved_fx = 0; 
+        double   m_saved_fy = 0;
+        double   m_saved_dfx = 0; 
+        double   m_saved_dfy = 0;
+    };
+
+
+
+
+
+    //-------------------------------------------------------------curve3_div
+    class curve3_div
+    {
+    public:
+        curve3_div() = default;
+
+        curve3_div(double x1, double y1, 
+                   double x2, double y2, 
+                   double x3, double y3)
+        { 
+            init(x1, y1, x2, y2, x3, y3);
+        }
+
+        void reset() { m_points.remove_all(); m_count = 0; }
+        void init(double x1, double y1, 
+                  double x2, double y2, 
+                  double x3, double y3);
+
+        void approximation_method(curve_approximation_method_e) {}
+        curve_approximation_method_e approximation_method() const { return curve_div; }
+
+        void approximation_scale(double s) { m_approximation_scale = s; }
+        double approximation_scale() const { return m_approximation_scale;  }
+
+        void angle_tolerance(double a) { m_angle_tolerance = a; }
+        double angle_tolerance() const { return m_angle_tolerance;  }
+
+        void cusp_limit(double) {}
+        double cusp_limit() const { return 0.0; }
+
+        void rewind(unsigned)
+        {
+            m_count = 0;
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_count >= m_points.size()) return path_cmd_stop;
+            const point_d& p = m_points[m_count++];
+            *x = p.x;
+            *y = p.y;
+            return (m_count == 1) ? path_cmd_move_to : path_cmd_line_to;
+        }
+
+    private:
+        void bezier(double x1, double y1, 
+                    double x2, double y2, 
+                    double x3, double y3);
+        void recursive_bezier(double x1, double y1, 
+                              double x2, double y2, 
+                              double x3, double y3,
+                              unsigned level);
+
+        double               m_approximation_scale = 1.0;
+        double               m_distance_tolerance_square = 0;
+        double               m_angle_tolerance = 0;
+        unsigned             m_count = 0;
+        pod_bvector<point_d> m_points;
+    };
+
+
+
+
+
+
+
+    //-------------------------------------------------------------curve4_points
+    struct curve4_points
+    {
+        double cp[8];
+        curve4_points() {}
+        curve4_points(double x1, double y1,
+                      double x2, double y2,
+                      double x3, double y3,
+                      double x4, double y4)
+        {
+            cp[0] = x1; cp[1] = y1; cp[2] = x2; cp[3] = y2;
+            cp[4] = x3; cp[5] = y3; cp[6] = x4; cp[7] = y4;
+        }
+        void init(double x1, double y1,
+                  double x2, double y2,
+                  double x3, double y3,
+                  double x4, double y4)
+        {
+            cp[0] = x1; cp[1] = y1; cp[2] = x2; cp[3] = y2;
+            cp[4] = x3; cp[5] = y3; cp[6] = x4; cp[7] = y4;
+        }
+        double  operator [] (unsigned i) const { return cp[i]; }
+        double& operator [] (unsigned i)       { return cp[i]; }
+    };
+
+
+
+    //-------------------------------------------------------------curve4_inc
+    class curve4_inc
+    {
+    public:
+        curve4_inc() = default;
+
+        curve4_inc(double x1, double y1, 
+                   double x2, double y2, 
+                   double x3, double y3,
+                   double x4, double y4)
+        { 
+            init(x1, y1, x2, y2, x3, y3, x4, y4);
+        }
+
+        curve4_inc(const curve4_points& cp)
+        { 
+            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
+        }
+
+        void reset() { m_num_steps = 0; m_step = -1; }
+        void init(double x1, double y1, 
+                  double x2, double y2, 
+                  double x3, double y3,
+                  double x4, double y4);
+
+        void init(const curve4_points& cp)
+        {
+            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
+        }
+
+        void approximation_method(curve_approximation_method_e) {}
+        curve_approximation_method_e approximation_method() const { return curve_inc; }
+
+        void approximation_scale(double s);
+        double approximation_scale() const;
+
+        void angle_tolerance(double) {}
+        double angle_tolerance() const { return 0.0; }
+
+        void cusp_limit(double) {}
+        double cusp_limit() const { return 0.0; }
+
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        int      m_num_steps = 0;
+        int      m_step = 0;
+        double   m_scale = 1.0;
+        double   m_start_x = 0.0; 
+        double   m_start_y = 0.0;
+        double   m_end_x = 0.0; 
+        double   m_end_y = 0.0;
+        double   m_fx = 0.0; 
+        double   m_fy = 0.0;
+        double   m_dfx = 0.0; 
+        double   m_dfy = 0.0;
+        double   m_ddfx = 0.0; 
+        double   m_ddfy = 0.0;
+        double   m_dddfx = 0.0; 
+        double   m_dddfy = 0.0;
+        double   m_saved_fx = 0.0; 
+        double   m_saved_fy = 0.0;
+        double   m_saved_dfx = 0.0; 
+        double   m_saved_dfy = 0.0;
+        double   m_saved_ddfx = 0.0; 
+        double   m_saved_ddfy = 0.0;
+    };
+
+
+
+    //-------------------------------------------------------catrom_to_bezier
+    inline curve4_points catrom_to_bezier(double x1, double y1, 
+                                          double x2, double y2, 
+                                          double x3, double y3,
+                                          double x4, double y4)
+    {
+        // Trans. matrix Catmull-Rom to Bezier
+        //
+        //  0       1       0       0
+        //  -1/6    1       1/6     0
+        //  0       1/6     1       -1/6
+        //  0       0       1       0
+        //
+        return curve4_points(
+            x2,
+            y2,
+            (-x1 + 6*x2 + x3) / 6,
+            (-y1 + 6*y2 + y3) / 6,
+            ( x2 + 6*x3 - x4) / 6,
+            ( y2 + 6*y3 - y4) / 6,
+            x3,
+            y3);
+    }
+
+
+    //-----------------------------------------------------------------------
+    inline curve4_points
+    catrom_to_bezier(const curve4_points& cp)
+    {
+        return catrom_to_bezier(cp[0], cp[1], cp[2], cp[3], 
+                                cp[4], cp[5], cp[6], cp[7]);
+    }
+
+
+
+    //-----------------------------------------------------ubspline_to_bezier
+    inline curve4_points ubspline_to_bezier(double x1, double y1, 
+                                            double x2, double y2, 
+                                            double x3, double y3,
+                                            double x4, double y4)
+    {
+        // Trans. matrix Uniform BSpline to Bezier
+        //
+        //  1/6     4/6     1/6     0
+        //  0       4/6     2/6     0
+        //  0       2/6     4/6     0
+        //  0       1/6     4/6     1/6
+        //
+        return curve4_points(
+            (x1 + 4*x2 + x3) / 6,
+            (y1 + 4*y2 + y3) / 6,
+            (4*x2 + 2*x3) / 6,
+            (4*y2 + 2*y3) / 6,
+            (2*x2 + 4*x3) / 6,
+            (2*y2 + 4*y3) / 6,
+            (x2 + 4*x3 + x4) / 6,
+            (y2 + 4*y3 + y4) / 6);
+    }
+
+
+    //-----------------------------------------------------------------------
+    inline curve4_points 
+    ubspline_to_bezier(const curve4_points& cp)
+    {
+        return ubspline_to_bezier(cp[0], cp[1], cp[2], cp[3], 
+                                  cp[4], cp[5], cp[6], cp[7]);
+    }
+
+
+
+
+    //------------------------------------------------------hermite_to_bezier
+    inline curve4_points hermite_to_bezier(double x1, double y1, 
+                                           double x2, double y2, 
+                                           double x3, double y3,
+                                           double x4, double y4)
+    {
+        // Trans. matrix Hermite to Bezier
+        //
+        //  1       0       0       0
+        //  1       0       1/3     0
+        //  0       1       0       -1/3
+        //  0       1       0       0
+        //
+        return curve4_points(
+            x1,
+            y1,
+            (3*x1 + x3) / 3,
+            (3*y1 + y3) / 3,
+            (3*x2 - x4) / 3,
+            (3*y2 - y4) / 3,
+            x2,
+            y2);
+    }
+
+
+
+    //-----------------------------------------------------------------------
+    inline curve4_points 
+    hermite_to_bezier(const curve4_points& cp)
+    {
+        return hermite_to_bezier(cp[0], cp[1], cp[2], cp[3], 
+                                 cp[4], cp[5], cp[6], cp[7]);
+    }
+
+
+    //-------------------------------------------------------------curve4_div
+    class curve4_div
+    {
+    public:
+        curve4_div() = default;
+
+        curve4_div(double x1, double y1, 
+                   double x2, double y2, 
+                   double x3, double y3,
+                   double x4, double y4)
+        { 
+            init(x1, y1, x2, y2, x3, y3, x4, y4);
+        }
+
+        curve4_div(const curve4_points& cp)
+        { 
+            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
+        }
+
+        void reset() { m_points.remove_all(); m_count = 0; }
+        void init(double x1, double y1, 
+                  double x2, double y2, 
+                  double x3, double y3,
+                  double x4, double y4);
+
+        void init(const curve4_points& cp)
+        {
+            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
+        }
+
+        void approximation_method(curve_approximation_method_e) {}
+
+        curve_approximation_method_e approximation_method() const 
+        { 
+            return curve_div; 
+        }
+
+        void approximation_scale(double s) { m_approximation_scale = s; }
+        double approximation_scale() const { return m_approximation_scale;  }
+
+        void angle_tolerance(double a) { m_angle_tolerance = a; }
+        double angle_tolerance() const { return m_angle_tolerance;  }
+
+        void cusp_limit(double v) 
+        { 
+            m_cusp_limit = (v == 0.0) ? 0.0 : pi - v; 
+        }
+
+        double cusp_limit() const 
+        { 
+            return (m_cusp_limit == 0.0) ? 0.0 : pi - m_cusp_limit; 
+        }
+
+        void rewind(unsigned)
+        {
+            m_count = 0;
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_count >= m_points.size()) return path_cmd_stop;
+            const point_d& p = m_points[m_count++];
+            *x = p.x;
+            *y = p.y;
+            return (m_count == 1) ? path_cmd_move_to : path_cmd_line_to;
+        }
+
+    private:
+        void bezier(double x1, double y1, 
+                    double x2, double y2, 
+                    double x3, double y3, 
+                    double x4, double y4);
+
+        void recursive_bezier(double x1, double y1, 
+                              double x2, double y2, 
+                              double x3, double y3, 
+                              double x4, double y4,
+                              unsigned level);
+
+        double               m_approximation_scale = 1.0;
+        double               m_distance_tolerance_square = 0.0;
+        double               m_angle_tolerance = 0.0;
+        double               m_cusp_limit = 0.0;
+        unsigned             m_count = 0;
+        pod_bvector<point_d> m_points;
+    };
+
+
+    //-----------------------------------------------------------------curve3
+    class curve3
+    {
+    public:
+        curve3() : m_approximation_method(curve_div) {}
+        curve3(double x1, double y1, 
+               double x2, double y2, 
+               double x3, double y3) :
+            m_approximation_method(curve_div)
+        { 
+            init(x1, y1, x2, y2, x3, y3);
+        }
+
+        void reset() 
+        { 
+            m_curve_inc.reset();
+            m_curve_div.reset();
+        }
+
+        void init(double x1, double y1, 
+                  double x2, double y2, 
+                  double x3, double y3)
+        {
+            if(m_approximation_method == curve_inc) 
+            {
+                m_curve_inc.init(x1, y1, x2, y2, x3, y3);
+            }
+            else
+            {
+                m_curve_div.init(x1, y1, x2, y2, x3, y3);
+            }
+        }
+
+        void approximation_method(curve_approximation_method_e v) 
+        { 
+            m_approximation_method = v; 
+        }
+
+        curve_approximation_method_e approximation_method() const 
+        { 
+            return m_approximation_method; 
+        }
+
+        void approximation_scale(double s) 
+        { 
+            m_curve_inc.approximation_scale(s);
+            m_curve_div.approximation_scale(s);
+        }
+
+        double approximation_scale() const 
+        { 
+            return m_curve_inc.approximation_scale(); 
+        }
+
+        void angle_tolerance(double a) 
+        { 
+            m_curve_div.angle_tolerance(a); 
+        }
+
+        double angle_tolerance() const 
+        { 
+            return m_curve_div.angle_tolerance(); 
+        }
+
+        void cusp_limit(double v) 
+        { 
+            m_curve_div.cusp_limit(v); 
+        }
+
+        double cusp_limit() const 
+        { 
+            return m_curve_div.cusp_limit();  
+        }
+
+        void rewind(unsigned path_id)
+        {
+            if(m_approximation_method == curve_inc) 
+            {
+                m_curve_inc.rewind(path_id);
+            }
+            else
+            {
+                m_curve_div.rewind(path_id);
+            }
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_approximation_method == curve_inc) 
+            {
+                return m_curve_inc.vertex(x, y);
+            }
+            return m_curve_div.vertex(x, y);
+        }
+
+    private:
+        curve3_inc m_curve_inc;
+        curve3_div m_curve_div;
+        curve_approximation_method_e m_approximation_method;
+    };
+
+
+
+
+
+    //-----------------------------------------------------------------curve4
+    class curve4
+    {
+    public:
+        curve4() : m_approximation_method(curve_div) {}
+        curve4(double x1, double y1, 
+               double x2, double y2, 
+               double x3, double y3,
+               double x4, double y4) : 
+            m_approximation_method(curve_div)
+        { 
+            init(x1, y1, x2, y2, x3, y3, x4, y4);
+        }
+
+        curve4(const curve4_points& cp) :
+            m_approximation_method(curve_div)
+        { 
+            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
+        }
+
+        void reset() 
+        { 
+            m_curve_inc.reset();
+            m_curve_div.reset();
+        }
+
+        void init(double x1, double y1, 
+                  double x2, double y2, 
+                  double x3, double y3,
+                  double x4, double y4)
+        {
+            if(m_approximation_method == curve_inc) 
+            {
+                m_curve_inc.init(x1, y1, x2, y2, x3, y3, x4, y4);
+            }
+            else
+            {
+                m_curve_div.init(x1, y1, x2, y2, x3, y3, x4, y4);
+            }
+        }
+
+        void init(const curve4_points& cp)
+        {
+            init(cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
+        }
+
+        void approximation_method(curve_approximation_method_e v) 
+        { 
+            m_approximation_method = v; 
+        }
+
+        curve_approximation_method_e approximation_method() const 
+        { 
+            return m_approximation_method; 
+        }
+
+        void approximation_scale(double s) 
+        { 
+            m_curve_inc.approximation_scale(s);
+            m_curve_div.approximation_scale(s);
+        }
+        double approximation_scale() const { return m_curve_inc.approximation_scale(); }
+
+        void angle_tolerance(double v) 
+        { 
+            m_curve_div.angle_tolerance(v); 
+        }
+
+        double angle_tolerance() const 
+        { 
+            return m_curve_div.angle_tolerance();  
+        }
+
+        void cusp_limit(double v) 
+        { 
+            m_curve_div.cusp_limit(v); 
+        }
+
+        double cusp_limit() const 
+        { 
+            return m_curve_div.cusp_limit();  
+        }
+
+        void rewind(unsigned path_id)
+        {
+            if(m_approximation_method == curve_inc) 
+            {
+                m_curve_inc.rewind(path_id);
+            }
+            else
+            {
+                m_curve_div.rewind(path_id);
+            }
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_approximation_method == curve_inc) 
+            {
+                return m_curve_inc.vertex(x, y);
+            }
+            return m_curve_div.vertex(x, y);
+        }
+
+    private:
+        curve4_inc m_curve_inc;
+        curve4_div m_curve_div;
+        curve_approximation_method_e m_approximation_method;
+    };
+
+
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_dda_line.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_dda_line.h
--- 8.0.1-5/src/renderers/agg/include/agg_dda_line.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_dda_line.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,290 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// classes dda_line_interpolator, dda2_line_interpolator
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_DDA_LINE_INCLUDED
+#define AGG_DDA_LINE_INCLUDED
+
+#include <stdlib.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //===================================================dda_line_interpolator
+    template<int FractionShift, int YShift=0> class dda_line_interpolator
+    {
+    public:
+        //--------------------------------------------------------------------
+        dda_line_interpolator() {}
+
+        //--------------------------------------------------------------------
+        dda_line_interpolator(int y1, int y2, unsigned count) :
+            m_y(y1),
+            m_inc(((y2 - y1) << FractionShift) / int(count)),
+            m_dy(0)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        void operator ++ ()
+        {
+            m_dy += m_inc;
+        }
+
+        //--------------------------------------------------------------------
+        void operator -- ()
+        {
+            m_dy -= m_inc;
+        }
+
+        //--------------------------------------------------------------------
+        void operator += (unsigned n)
+        {
+            m_dy += m_inc * n;
+        }
+
+        //--------------------------------------------------------------------
+        void operator -= (unsigned n)
+        {
+            m_dy -= m_inc * n;
+        }
+
+
+        //--------------------------------------------------------------------
+        int y()  const { return m_y + (m_dy >> (FractionShift-YShift)); }
+        int dy() const { return m_dy; }
+
+
+    private:
+        int m_y;
+        int m_inc;
+        int m_dy;
+    };
+
+
+
+
+
+    //=================================================dda2_line_interpolator
+    class dda2_line_interpolator
+    {
+    public:
+        typedef int save_data_type;
+        enum save_size_e { save_size = 2 };
+
+        //--------------------------------------------------------------------
+        dda2_line_interpolator() = default;
+
+        //-------------------------------------------- Forward-adjusted line
+        dda2_line_interpolator(int y1, int y2, int count) :
+            m_cnt(count <= 0 ? 1 : count),
+            m_lft((y2 - y1) / m_cnt),
+            m_rem((y2 - y1) % m_cnt),
+            m_mod(m_rem),
+            m_y(y1)
+        {
+            if(m_mod <= 0)
+            {
+                m_mod += count;
+                m_rem += count;
+                m_lft--;
+            }
+            m_mod -= count;
+        }
+
+        //-------------------------------------------- Backward-adjusted line
+        dda2_line_interpolator(int y1, int y2, int count, int) :
+            m_cnt(count <= 0 ? 1 : count),
+            m_lft((y2 - y1) / m_cnt),
+            m_rem((y2 - y1) % m_cnt),
+            m_mod(m_rem),
+            m_y(y1)
+        {
+            if(m_mod <= 0)
+            {
+                m_mod += count;
+                m_rem += count;
+                m_lft--;
+            }
+        }
+
+        //-------------------------------------------- Backward-adjusted line
+        dda2_line_interpolator(int y, int count) :
+            m_cnt(count <= 0 ? 1 : count),
+            m_lft(y / m_cnt),
+            m_rem(y % m_cnt),
+            m_mod(m_rem),
+            m_y(0)
+        {
+            if(m_mod <= 0)
+            {
+                m_mod += count;
+                m_rem += count;
+                m_lft--;
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void save(save_data_type* data) const
+        {
+            data[0] = m_mod;
+            data[1] = m_y;
+        }
+
+        //--------------------------------------------------------------------
+        void load(const save_data_type* data)
+        {
+            m_mod = data[0];
+            m_y   = data[1];
+        }
+
+        //--------------------------------------------------------------------
+        void operator++()
+        {
+            m_mod += m_rem;
+            m_y += m_lft;
+            if(m_mod > 0)
+            {
+                m_mod -= m_cnt;
+                m_y++;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void operator--()
+        {
+            if(m_mod <= m_rem)
+            {
+                m_mod += m_cnt;
+                m_y--;
+            }
+            m_mod -= m_rem;
+            m_y -= m_lft;
+        }
+
+        //--------------------------------------------------------------------
+        void adjust_forward()
+        {
+            m_mod -= m_cnt;
+        }
+
+        //--------------------------------------------------------------------
+        void adjust_backward()
+        {
+            m_mod += m_cnt;
+        }
+
+        //--------------------------------------------------------------------
+        int mod() const { return m_mod; }
+        int rem() const { return m_rem; }
+        int lft() const { return m_lft; }
+
+        //--------------------------------------------------------------------
+        int y() const { return m_y; }
+
+    private:
+        int m_cnt = 0;
+        int m_lft = 0;
+        int m_rem = 0;
+        int m_mod = 0;
+        int m_y = 0;
+    };
+
+
+
+
+
+
+
+    //---------------------------------------------line_bresenham_interpolator
+    class line_bresenham_interpolator
+    {
+    public:
+        enum subpixel_scale_e
+        {
+            subpixel_shift = 8,
+            subpixel_scale = 1 << subpixel_shift,
+            subpixel_mask  = subpixel_scale - 1
+        };
+
+        //--------------------------------------------------------------------
+        static int line_lr(int v) { return v >> subpixel_shift; }
+
+        //--------------------------------------------------------------------
+        line_bresenham_interpolator(int x1, int y1, int x2, int y2) :
+            m_x1_lr(line_lr(x1)),
+            m_y1_lr(line_lr(y1)),
+            m_x2_lr(line_lr(x2)),
+            m_y2_lr(line_lr(y2)),
+            m_ver(abs(m_x2_lr - m_x1_lr) < abs(m_y2_lr - m_y1_lr)),
+            m_len(m_ver ? abs(m_y2_lr - m_y1_lr) : 
+                          abs(m_x2_lr - m_x1_lr)),
+            m_inc(m_ver ? ((y2 > y1) ? 1 : -1) : ((x2 > x1) ? 1 : -1)),
+            m_interpolator(m_ver ? x1 : y1, 
+                           m_ver ? x2 : y2, 
+                           m_len)
+        {
+        }
+    
+        //--------------------------------------------------------------------
+        bool     is_ver() const { return m_ver; }
+        unsigned len()    const { return m_len; }
+        int      inc()    const { return m_inc; }
+
+        //--------------------------------------------------------------------
+        void hstep()
+        {
+            ++m_interpolator;
+            m_x1_lr += m_inc;
+        }
+
+        //--------------------------------------------------------------------
+        void vstep()
+        {
+            ++m_interpolator;
+            m_y1_lr += m_inc;
+        }
+
+        //--------------------------------------------------------------------
+        int x1() const { return m_x1_lr; }
+        int y1() const { return m_y1_lr; }
+        int x2() const { return line_lr(m_interpolator.y()); }
+        int y2() const { return line_lr(m_interpolator.y()); }
+        int x2_hr() const { return m_interpolator.y(); }
+        int y2_hr() const { return m_interpolator.y(); }
+
+    private:
+        int                    m_x1_lr;
+        int                    m_y1_lr;
+        int                    m_x2_lr;
+        int                    m_y2_lr;
+        bool                   m_ver;
+        unsigned               m_len;
+        int                    m_inc;
+        dda2_line_interpolator m_interpolator;
+
+    };
+
+
+}
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_ellipse.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_ellipse.h
--- 8.0.1-5/src/renderers/agg/include/agg_ellipse.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_ellipse.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,123 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class ellipse
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_ELLIPSE_INCLUDED
+#define AGG_ELLIPSE_INCLUDED
+
+#include "agg_basics.h"
+#include <math.h>
+
+namespace mapserver
+{
+
+    //----------------------------------------------------------------ellipse
+    class ellipse
+    {
+    public:
+        ellipse() : 
+            m_x(0.0), m_y(0.0), m_rx(1.0), m_ry(1.0), m_scale(1.0), 
+            m_num(4), m_step(0), m_cw(false) {}
+
+        ellipse(double x, double y, double rx, double ry, 
+                unsigned num_steps=0, bool cw=false) :
+            m_x(x), m_y(y), m_rx(rx), m_ry(ry), m_scale(1.0), 
+            m_num(num_steps), m_step(0), m_cw(cw) 
+        {
+            if(m_num == 0) calc_num_steps();
+        }
+
+        void init(double x, double y, double rx, double ry, 
+                  unsigned num_steps=0, bool cw=false);
+
+        void approximation_scale(double scale);
+        void rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        void calc_num_steps();
+
+        double m_x;
+        double m_y;
+        double m_rx;
+        double m_ry;
+        double m_scale;
+        unsigned m_num;
+        unsigned m_step;
+        bool m_cw;
+    };
+
+    //------------------------------------------------------------------------
+    inline void ellipse::init(double x, double y, double rx, double ry, 
+                              unsigned num_steps, bool cw)
+    {
+        m_x = x;
+        m_y = y;
+        m_rx = rx;
+        m_ry = ry;
+        m_num = num_steps;
+        m_step = 0;
+        m_cw = cw;
+        if(m_num == 0) calc_num_steps();
+    }
+
+    //------------------------------------------------------------------------
+    inline void ellipse::approximation_scale(double scale)
+    {   
+        m_scale = scale;
+        calc_num_steps();
+    }
+
+    //------------------------------------------------------------------------
+    inline void ellipse::calc_num_steps()
+    {
+        double ra = (fabs(m_rx) + fabs(m_ry)) / 2;
+        double da = acos(ra / (ra + 0.125 / m_scale)) * 2;
+        m_num = uround(2*pi / da);
+    }
+
+    //------------------------------------------------------------------------
+    inline void ellipse::rewind(unsigned)
+    {
+        m_step = 0;
+    }
+
+    //------------------------------------------------------------------------
+    inline unsigned ellipse::vertex(double* x, double* y)
+    {
+        if(m_step == m_num) 
+        {
+            ++m_step;
+            return path_cmd_end_poly | path_flags_close | path_flags_ccw;
+        }
+        if(m_step > m_num) return path_cmd_stop;
+        double angle = double(m_step) / double(m_num) * 2.0 * pi;
+        if(m_cw) angle = 2.0 * pi - angle;
+        *x = m_x + cos(angle) * m_rx;
+        *y = m_y + sin(angle) * m_ry;
+        m_step++;
+        return ((m_step == 1) ? path_cmd_move_to : path_cmd_line_to);
+    }
+
+}
+
+
+
+#endif
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_ellipse_bresenham.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_ellipse_bresenham.h
--- 8.0.1-5/src/renderers/agg/include/agg_ellipse_bresenham.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_ellipse_bresenham.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,113 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Simple Bresenham interpolator for ellipsees
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_ELLIPSE_BRESENHAM_INCLUDED
+#define AGG_ELLIPSE_BRESENHAM_INCLUDED
+
+
+#include "agg_basics.h"
+
+
+namespace mapserver
+{
+
+    //------------------------------------------ellipse_bresenham_interpolator
+    class ellipse_bresenham_interpolator
+    {
+    public:
+        ellipse_bresenham_interpolator(int rx, int ry) :
+            m_rx2(rx * rx),
+            m_ry2(ry * ry),
+            m_two_rx2(m_rx2 << 1),
+            m_two_ry2(m_ry2 << 1),
+            m_dx(0),
+            m_dy(0),
+            m_inc_x(0),
+            m_inc_y(-ry * m_two_rx2),
+            m_cur_f(0)
+        {}
+        
+        int dx() const { return m_dx; }
+        int dy() const { return m_dy; }
+
+        void operator++ ()
+        {
+            int  mx, my, mxy, min_m;
+            int  fx, fy, fxy;
+
+            mx = fx = m_cur_f + m_inc_x + m_ry2;
+            if(mx < 0) mx = -mx;
+
+            my = fy = m_cur_f + m_inc_y + m_rx2;
+            if(my < 0) my = -my;
+
+            mxy = fxy = m_cur_f + m_inc_x + m_ry2 + m_inc_y + m_rx2;
+            if(mxy < 0) mxy = -mxy;
+
+            min_m = mx; 
+            bool flag = true;
+
+            if(min_m > my)  
+            { 
+                min_m = my; 
+                flag = false; 
+            }
+
+            m_dx = m_dy = 0;
+
+            if(min_m > mxy) 
+            { 
+                m_inc_x += m_two_ry2;
+                m_inc_y += m_two_rx2;
+                m_cur_f = fxy;
+                m_dx = 1; 
+                m_dy = 1;
+                return;
+            }
+
+            if(flag) 
+            {
+                m_inc_x += m_two_ry2;
+                m_cur_f = fx;
+                m_dx = 1;
+                return;
+            }
+
+            m_inc_y += m_two_rx2;
+            m_cur_f = fy;
+            m_dy = 1;
+        }
+
+    private:
+        int m_rx2;
+        int m_ry2;
+        int m_two_rx2;
+        int m_two_ry2;
+        int m_dx;
+        int m_dy;
+        int m_inc_x;
+        int m_inc_y;
+        int m_cur_f;
+
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_embedded_raster_fonts.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_embedded_raster_fonts.h
--- 8.0.1-5/src/renderers/agg/include/agg_embedded_raster_fonts.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_embedded_raster_fonts.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,59 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_EMBEDDED_RASTER_FONTS_INCLUDED
+#define AGG_EMBEDDED_RASTER_FONTS_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    extern const int8u gse4x6[];
+    extern const int8u gse4x8[];
+    extern const int8u gse5x7[];
+    extern const int8u gse5x9[];
+    extern const int8u gse6x12[];
+    extern const int8u gse6x9[];
+    extern const int8u gse7x11[];
+    extern const int8u gse7x11_bold[];
+    extern const int8u gse7x15[];
+    extern const int8u gse7x15_bold[];
+    extern const int8u gse8x16[];
+    extern const int8u gse8x16_bold[];
+    extern const int8u mcs11_prop[];
+    extern const int8u mcs11_prop_condensed[];
+    extern const int8u mcs12_prop[];
+    extern const int8u mcs13_prop[];
+    extern const int8u mcs5x10_mono[];
+    extern const int8u mcs5x11_mono[];
+    extern const int8u mcs6x10_mono[];
+    extern const int8u mcs6x11_mono[];
+    extern const int8u mcs7x12_mono_high[];
+    extern const int8u mcs7x12_mono_low[];
+    extern const int8u verdana12[];
+    extern const int8u verdana12_bold[];
+    extern const int8u verdana13[];
+    extern const int8u verdana13_bold[];
+    extern const int8u verdana14[];
+    extern const int8u verdana14_bold[];
+    extern const int8u verdana16[];
+    extern const int8u verdana16_bold[];
+    extern const int8u verdana17[];
+    extern const int8u verdana17_bold[];
+    extern const int8u verdana18[];
+    extern const int8u verdana18_bold[];
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_font_cache_manager.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_font_cache_manager.h
--- 8.0.1-5/src/renderers/agg/include/agg_font_cache_manager.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_font_cache_manager.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,409 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_FONT_CACHE_MANAGER_INCLUDED
+#define AGG_FONT_CACHE_MANAGER_INCLUDED
+
+#include <string.h>
+#include "agg_array.h"
+
+namespace mapserver
+{
+
+    //---------------------------------------------------------glyph_data_type
+    enum glyph_data_type
+    {
+        glyph_data_invalid = 0,
+        glyph_data_mono    = 1,
+        glyph_data_gray8   = 2,
+        glyph_data_outline = 3
+    };
+
+
+    //-------------------------------------------------------------glyph_cache
+    struct glyph_cache
+    {
+        unsigned        glyph_index;
+        int8u*          data;
+        unsigned        data_size;
+        glyph_data_type data_type;
+        rect_i          bounds;
+        double          advance_x;
+        double          advance_y;
+    };
+
+
+    //--------------------------------------------------------------font_cache
+    class font_cache
+    {
+    public:
+        enum block_size_e { block_size = 16384-16 };
+
+        //--------------------------------------------------------------------
+        font_cache() : 
+            m_allocator(block_size),
+            m_font_signature(0)
+        {}
+
+        //--------------------------------------------------------------------
+        void signature(const char* font_signature)
+        {
+            m_font_signature = (char*)m_allocator.allocate(strlen(font_signature) + 1);
+            strcpy(m_font_signature, font_signature);
+            memset(m_glyphs, 0, sizeof(m_glyphs));
+        }
+
+        //--------------------------------------------------------------------
+        bool font_is(const char* font_signature) const
+        {
+            return strcmp(font_signature, m_font_signature) == 0;
+        }
+
+        //--------------------------------------------------------------------
+        const glyph_cache* find_glyph(unsigned glyph_code) const
+        {
+            unsigned msb = (glyph_code >> 8) & 0xFF;
+            if(m_glyphs[msb]) 
+            {
+                return m_glyphs[msb][glyph_code & 0xFF];
+            }
+            return 0;
+        }
+
+        //--------------------------------------------------------------------
+        glyph_cache* cache_glyph(unsigned        glyph_code, 
+                                 unsigned        glyph_index,
+                                 unsigned        data_size,
+                                 glyph_data_type data_type,
+                                 const rect_i&   bounds,
+                                 double          advance_x,
+                                 double          advance_y)
+        {
+            unsigned msb = (glyph_code >> 8) & 0xFF;
+            if(m_glyphs[msb] == 0)
+            {
+                m_glyphs[msb] = 
+                    (glyph_cache**)m_allocator.allocate(sizeof(glyph_cache*) * 256, 
+                                                        sizeof(glyph_cache*));
+                memset(m_glyphs[msb], 0, sizeof(glyph_cache*) * 256);
+            }
+
+            unsigned lsb = glyph_code & 0xFF;
+            if(m_glyphs[msb][lsb]) return 0; // Already exists, do not overwrite
+
+            glyph_cache* glyph = 
+                (glyph_cache*)m_allocator.allocate(sizeof(glyph_cache),
+                                                   sizeof(double));
+
+            glyph->glyph_index        = glyph_index;
+            glyph->data               = m_allocator.allocate(data_size);
+            glyph->data_size          = data_size;
+            glyph->data_type          = data_type;
+            glyph->bounds             = bounds;
+            glyph->advance_x          = advance_x;
+            glyph->advance_y          = advance_y;
+            return m_glyphs[msb][lsb] = glyph;
+        }
+
+    private:
+        block_allocator m_allocator;
+        glyph_cache**   m_glyphs[256];
+        char*           m_font_signature;
+    };
+
+
+
+
+
+
+    
+    //---------------------------------------------------------font_cache_pool
+    class font_cache_pool
+    {
+    public:
+        //--------------------------------------------------------------------
+        ~font_cache_pool()
+        {
+            unsigned i;
+            for(i = 0; i < m_num_fonts; ++i)
+            {
+                obj_allocator<font_cache>::deallocate(m_fonts[i]);
+            }
+            pod_allocator<font_cache*>::deallocate(m_fonts, m_max_fonts);
+        }
+
+        //--------------------------------------------------------------------
+        font_cache_pool(unsigned max_fonts=32) : 
+            m_fonts(pod_allocator<font_cache*>::allocate(max_fonts)),
+            m_max_fonts(max_fonts),
+            m_num_fonts(0),
+            m_cur_font(0)
+        {}
+
+
+        //--------------------------------------------------------------------
+        void font(const char* font_signature, bool reset_cache = false)
+        {
+            int idx = find_font(font_signature);
+            if(idx >= 0)
+            {
+                if(reset_cache)
+                {
+                    obj_allocator<font_cache>::deallocate(m_fonts[idx]);
+                    m_fonts[idx] = obj_allocator<font_cache>::allocate();
+                    m_fonts[idx]->signature(font_signature);
+                }
+                m_cur_font = m_fonts[idx];
+            }
+            else
+            {
+                if(m_num_fonts >= m_max_fonts)
+                {
+                    obj_allocator<font_cache>::deallocate(m_fonts[0]);
+                    memcpy(m_fonts, 
+                           m_fonts + 1, 
+                           (m_max_fonts - 1) * sizeof(font_cache*));
+                    m_num_fonts = m_max_fonts - 1;
+                }
+                m_fonts[m_num_fonts] = obj_allocator<font_cache>::allocate();
+                m_fonts[m_num_fonts]->signature(font_signature);
+                m_cur_font = m_fonts[m_num_fonts];
+                ++m_num_fonts;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        const font_cache* font() const
+        {
+            return m_cur_font;
+        }
+
+        //--------------------------------------------------------------------
+        const glyph_cache* find_glyph(unsigned glyph_code) const
+        {
+            if(m_cur_font) return m_cur_font->find_glyph(glyph_code);
+            return 0;
+        }
+
+        //--------------------------------------------------------------------
+        glyph_cache* cache_glyph(unsigned        glyph_code, 
+                                 unsigned        glyph_index,
+                                 unsigned        data_size,
+                                 glyph_data_type data_type,
+                                 const rect_i&   bounds,
+                                 double          advance_x,
+                                 double          advance_y)
+        {
+            if(m_cur_font) 
+            {
+                return m_cur_font->cache_glyph(glyph_code,
+                                               glyph_index,
+                                               data_size,
+                                               data_type,
+                                               bounds,
+                                               advance_x,
+                                               advance_y);
+            }
+            return 0;
+        }
+
+
+        //--------------------------------------------------------------------
+        int find_font(const char* font_signature)
+        {
+            unsigned i;
+            for(i = 0; i < m_num_fonts; i++)
+            {
+                if(m_fonts[i]->font_is(font_signature)) return int(i);
+            }
+            return -1;
+        }
+
+    private:
+        font_cache** m_fonts;
+        unsigned     m_max_fonts;
+        unsigned     m_num_fonts;
+        font_cache*  m_cur_font;
+    };
+
+
+
+
+    //------------------------------------------------------------------------
+    enum glyph_rendering
+    {
+        glyph_ren_native_mono,
+        glyph_ren_native_gray8,
+        glyph_ren_outline,
+        glyph_ren_agg_mono,
+        glyph_ren_agg_gray8
+    };
+
+
+
+
+    //------------------------------------------------------font_cache_manager
+    template<class FontEngine> class font_cache_manager
+    {
+    public:
+        typedef FontEngine font_engine_type;
+        typedef font_cache_manager<FontEngine> self_type;
+        typedef typename font_engine_type::path_adaptor_type   path_adaptor_type;
+        typedef typename font_engine_type::gray8_adaptor_type  gray8_adaptor_type;
+        typedef typename gray8_adaptor_type::embedded_scanline gray8_scanline_type;
+        typedef typename font_engine_type::mono_adaptor_type   mono_adaptor_type;
+        typedef typename mono_adaptor_type::embedded_scanline  mono_scanline_type;
+
+        //--------------------------------------------------------------------
+        font_cache_manager(font_engine_type& engine, unsigned max_fonts=32) :
+            m_fonts(max_fonts),
+            m_engine(engine),
+            m_change_stamp(-1),
+            m_prev_glyph(0),
+            m_last_glyph(0)
+        {}
+
+        //--------------------------------------------------------------------
+        void reset_last_glyph()
+        {
+            m_prev_glyph = m_last_glyph = 0;
+        }
+
+        //--------------------------------------------------------------------
+        const glyph_cache* glyph(unsigned glyph_code)
+        {
+            synchronize();
+            const glyph_cache* gl = m_fonts.find_glyph(glyph_code);
+            if(gl) 
+            {
+                m_prev_glyph = m_last_glyph;
+                return m_last_glyph = gl;
+            }
+            else
+            {
+                if(m_engine.prepare_glyph(glyph_code))
+                {
+                    m_prev_glyph = m_last_glyph;
+                    m_last_glyph = m_fonts.cache_glyph(glyph_code, 
+                                                       m_engine.glyph_index(),
+                                                       m_engine.data_size(),
+                                                       m_engine.data_type(),
+                                                       m_engine.bounds(),
+                                                       m_engine.advance_x(),
+                                                       m_engine.advance_y());
+                    m_engine.write_glyph_to(m_last_glyph->data);
+                    return m_last_glyph;
+                }
+            }
+            return 0;
+        }
+
+        //--------------------------------------------------------------------
+        void init_embedded_adaptors(const glyph_cache* gl, 
+                                    double x, double y, 
+                                    double scale=1.0)
+        {
+            if(gl)
+            {
+                switch(gl->data_type)
+                {
+                default: return;
+                case glyph_data_mono:
+                    m_mono_adaptor.init(gl->data, gl->data_size, x, y);
+                    break;
+
+                case glyph_data_gray8:
+                    m_gray8_adaptor.init(gl->data, gl->data_size, x, y);
+                    break;
+
+                case glyph_data_outline:
+                    m_path_adaptor.init(gl->data, gl->data_size, x, y, scale);
+                    break;
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        path_adaptor_type&   path_adaptor()   { return m_path_adaptor;   }
+        gray8_adaptor_type&  gray8_adaptor()  { return m_gray8_adaptor;  }
+        gray8_scanline_type& gray8_scanline() { return m_gray8_scanline; }
+        mono_adaptor_type&   mono_adaptor()   { return m_mono_adaptor;   }
+        mono_scanline_type&  mono_scanline()  { return m_mono_scanline;  }
+
+        //--------------------------------------------------------------------
+        const glyph_cache* perv_glyph() const { return m_prev_glyph; }
+        const glyph_cache* last_glyph() const { return m_last_glyph; }
+
+        //--------------------------------------------------------------------
+        bool add_kerning(double* x, double* y)
+        {
+            if(m_prev_glyph && m_last_glyph)
+            {
+                return m_engine.add_kerning(m_prev_glyph->glyph_index, 
+                                            m_last_glyph->glyph_index,
+                                            x, y);
+            }
+            return false;
+        }
+
+        //--------------------------------------------------------------------
+        void precache(unsigned from, unsigned to)
+        {
+            for(; from <= to; ++from) glyph(from);
+        }
+
+        //--------------------------------------------------------------------
+        void reset_cache()
+        {
+            m_fonts.font(m_engine.font_signature(), true);
+            m_change_stamp = m_engine.change_stamp();
+            m_prev_glyph = m_last_glyph = 0;
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        font_cache_manager(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        //--------------------------------------------------------------------
+        void synchronize()
+        {
+            if(m_change_stamp != m_engine.change_stamp())
+            {
+                m_fonts.font(m_engine.font_signature());
+                m_change_stamp = m_engine.change_stamp();
+                m_prev_glyph = m_last_glyph = 0;
+            }
+        }
+
+        font_cache_pool     m_fonts;
+        font_engine_type&   m_engine;
+        int                 m_change_stamp;
+        double              m_dx = 0;
+        double              m_dy = 0;
+        const glyph_cache*  m_prev_glyph;
+        const glyph_cache*  m_last_glyph;
+        path_adaptor_type   m_path_adaptor;
+        gray8_adaptor_type  m_gray8_adaptor;
+        gray8_scanline_type m_gray8_scanline;
+        mono_adaptor_type   m_mono_adaptor;
+        mono_scanline_type  m_mono_scanline;
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_font_freetype.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_font_freetype.h
--- 8.0.1-5/src/renderers/agg/include/agg_font_freetype.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_font_freetype.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,196 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// See implementation agg_font_freetype.cpp
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_FONT_FREETYPE_INCLUDED
+#define AGG_FONT_FREETYPE_INCLUDED
+
+#include <ft2build.h>
+#include FT_FREETYPE_H
+
+
+#include "agg_scanline_storage_aa.h"
+#include "agg_scanline_storage_bin.h"
+#include "agg_scanline_u.h"
+#include "agg_scanline_bin.h"
+#include "agg_path_storage_integer.h"
+#include "agg_rasterizer_scanline_aa.h"
+#include "agg_conv_curve.h"
+#include "agg_font_cache_manager.h"
+#include "agg_trans_affine.h"
+
+namespace mapserver
+{
+
+
+    //-----------------------------------------------font_engine_freetype_base
+    class font_engine_freetype_base
+    {
+    public:
+        //--------------------------------------------------------------------
+        typedef serialized_scanlines_adaptor_aa<int8u>    gray8_adaptor_type;
+        typedef serialized_scanlines_adaptor_bin          mono_adaptor_type;
+        typedef scanline_storage_aa8                      scanlines_aa_type;
+        typedef scanline_storage_bin                      scanlines_bin_type;
+
+        //--------------------------------------------------------------------
+        ~font_engine_freetype_base();
+        font_engine_freetype_base(bool flag32, unsigned max_faces = 32);
+
+        // Set font parameters
+        //--------------------------------------------------------------------
+        void resolution(unsigned dpi);
+        bool load_font(const char* font_name, unsigned face_index, glyph_rendering ren_type,
+                       const char* font_mem = 0, const long font_mem_size = 0);
+        bool attach(const char* file_name);
+        bool char_map(FT_Encoding map);
+        bool height(double h);
+        bool width(double w);
+        void hinting(bool h);
+        void flip_y(bool f);
+        void transform(const trans_affine& affine);
+
+        // Set Gamma
+        //--------------------------------------------------------------------
+        template<class GammaF> void gamma(const GammaF& f)
+        {
+            m_rasterizer.gamma(f);
+        }
+
+        // Accessors
+        //--------------------------------------------------------------------
+        int         last_error()   const { return m_last_error; }
+        unsigned    resolution()   const { return m_resolution; }
+        const char* name()         const { return m_name;       }
+        unsigned    num_faces()    const;
+        FT_Encoding char_map()     const { return m_char_map;   }
+        double      height()       const { return double(m_height) / 64.0;    }
+        double      width()        const { return double(m_width) / 64.0;     }
+        double      ascender()     const;
+        double      descender()    const;
+        bool        hinting()      const { return m_hinting;    }
+        bool        flip_y()       const { return m_flip_y;     }
+
+
+        // Interface mandatory to implement for font_cache_manager
+        //--------------------------------------------------------------------
+        const char*     font_signature() const { return m_signature;    }
+        int             change_stamp()   const { return m_change_stamp; }
+
+        bool            prepare_glyph(unsigned glyph_code);
+        unsigned        glyph_index() const { return m_glyph_index; }
+        unsigned        data_size()   const { return m_data_size;   }
+        glyph_data_type data_type()   const { return m_data_type;   }
+        const rect_i&   bounds()      const { return m_bounds;      }
+        double          advance_x()   const { return m_advance_x;   }
+        double          advance_y()   const { return m_advance_y;   }
+        void            write_glyph_to(int8u* data) const;
+        bool            add_kerning(unsigned first, unsigned second,
+                                    double* x, double* y);
+
+    private:
+        font_engine_freetype_base(const font_engine_freetype_base&);
+        const font_engine_freetype_base& operator = (const font_engine_freetype_base&);
+
+        void update_char_size();
+        void update_signature();
+        int  find_face(const char* face_name) const;
+
+        bool            m_flag32;
+        int             m_change_stamp;
+        int             m_last_error;
+        char*           m_name;
+        unsigned        m_name_len;
+        unsigned        m_face_index;
+        FT_Encoding     m_char_map;
+        char*           m_signature;
+        unsigned        m_height;
+        unsigned        m_width;
+        bool            m_hinting;
+        bool            m_flip_y;
+        bool            m_library_initialized;
+        FT_Library      m_library;    // handle to library    
+        FT_Face*        m_faces;      // A pool of font faces
+        char**          m_face_names; 
+        unsigned        m_num_faces;
+        unsigned        m_max_faces;
+        FT_Face         m_cur_face;  // handle to the current face object
+        int             m_resolution;
+        glyph_rendering m_glyph_rendering;
+        unsigned        m_glyph_index;
+        unsigned        m_data_size;
+        glyph_data_type m_data_type;
+        rect_i          m_bounds;
+        double          m_advance_x;
+        double          m_advance_y;
+        trans_affine    m_affine;
+
+        path_storage_integer<int16, 6>              m_path16;
+        path_storage_integer<int32, 6>              m_path32;
+        conv_curve<path_storage_integer<int16, 6> > m_curves16;
+        conv_curve<path_storage_integer<int32, 6> > m_curves32;
+        scanline_u8              m_scanline_aa;
+        scanline_bin             m_scanline_bin;
+        scanlines_aa_type        m_scanlines_aa;
+        scanlines_bin_type       m_scanlines_bin;
+        rasterizer_scanline_aa<> m_rasterizer;
+    };
+
+
+
+
+    //------------------------------------------------font_engine_freetype_int16
+    // This class uses values of type int16 (10.6 format) for the vector cache. 
+    // The vector cache is compact, but when rendering glyphs of height
+    // more that 200 there integer overflow can occur.
+    //
+    class font_engine_freetype_int16 : public font_engine_freetype_base
+    {
+    public:
+        typedef serialized_integer_path_adaptor<int16, 6>     path_adaptor_type;
+        typedef font_engine_freetype_base::gray8_adaptor_type gray8_adaptor_type;
+        typedef font_engine_freetype_base::mono_adaptor_type  mono_adaptor_type;
+        typedef font_engine_freetype_base::scanlines_aa_type  scanlines_aa_type;
+        typedef font_engine_freetype_base::scanlines_bin_type scanlines_bin_type;
+
+        font_engine_freetype_int16(unsigned max_faces = 32) : 
+            font_engine_freetype_base(false, max_faces) {}
+    };
+
+    //------------------------------------------------font_engine_freetype_int32
+    // This class uses values of type int32 (26.6 format) for the vector cache. 
+    // The vector cache is twice larger than in font_engine_freetype_int16, 
+    // but it allows you to render glyphs of very large sizes.
+    //
+    class font_engine_freetype_int32 : public font_engine_freetype_base
+    {
+    public:
+        typedef serialized_integer_path_adaptor<int32, 6>     path_adaptor_type;
+        typedef font_engine_freetype_base::gray8_adaptor_type gray8_adaptor_type;
+        typedef font_engine_freetype_base::mono_adaptor_type  mono_adaptor_type;
+        typedef font_engine_freetype_base::scanlines_aa_type  scanlines_aa_type;
+        typedef font_engine_freetype_base::scanlines_bin_type scanlines_bin_type;
+
+        font_engine_freetype_int32(unsigned max_faces = 32) : 
+            font_engine_freetype_base(true, max_faces) {}
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_gamma_functions.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gamma_functions.h
--- 8.0.1-5/src/renderers/agg/include/agg_gamma_functions.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gamma_functions.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,123 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_GAMMA_FUNCTIONS_INCLUDED
+#define AGG_GAMMA_FUNCTIONS_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //===============================================================gamma_none
+    struct gamma_none
+    {
+        double operator()(double x) const { return x; }
+    };
+
+
+    //==============================================================gamma_power
+    class gamma_power
+    {
+    public:
+        gamma_power() : m_gamma(1.0) {}
+        gamma_power(double g) : m_gamma(g) {}
+
+        void gamma(double g) { m_gamma = g; }
+        double gamma() const { return m_gamma; }
+
+        double operator() (double x) const
+        {
+            return pow(x, m_gamma);
+        }
+
+    private:
+        double m_gamma;
+    };
+
+
+    //==========================================================gamma_threshold
+    class gamma_threshold
+    {
+    public:
+        gamma_threshold() : m_threshold(0.5) {}
+        gamma_threshold(double t) : m_threshold(t) {}
+
+        void threshold(double t) { m_threshold = t; }
+        double threshold() const { return m_threshold; }
+
+        double operator() (double x) const
+        {
+            return (x < m_threshold) ? 0.0 : 1.0;
+        }
+
+    private:
+        double m_threshold;
+    };
+
+
+    //============================================================gamma_linear
+    class gamma_linear
+    {
+    public:
+        gamma_linear() : m_start(0.0), m_end(1.0) {}
+        gamma_linear(double s, double e) : m_start(s), m_end(e) {}
+
+        void set(double s, double e) { m_start = s; m_end = e; }
+        void start(double s) { m_start = s; }
+        void end(double e) { m_end = e; }
+        double start() const { return m_start; }
+        double end() const { return m_end; }
+
+        double operator() (double x) const
+        {
+            if(x < m_start) return 0.0;
+            if(x > m_end) return 1.0;
+            return (x - m_start) / (m_end - m_start);
+        }
+
+    private:
+        double m_start;
+        double m_end;
+    };
+
+
+    //==========================================================gamma_multiply
+    class gamma_multiply
+    {
+    public:
+        gamma_multiply() : m_mul(1.0) {}
+        gamma_multiply(double v) : m_mul(v) {}
+
+        void value(double v) { m_mul = v; }
+        double value() const { return m_mul; }
+
+        double operator() (double x) const
+        {
+            double y = x * m_mul;
+            if(y > 1.0) y = 1.0;
+            return y;
+        }
+
+    private:
+        double m_mul;
+    };
+
+}
+
+#endif
+
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_gamma_lut.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gamma_lut.h
--- 8.0.1-5/src/renderers/agg/include/agg_gamma_lut.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gamma_lut.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,121 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_GAMMA_LUT_INCLUDED
+#define AGG_GAMMA_LUT_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    template<class LoResT=int8u, 
+             class HiResT=int8u, 
+             unsigned GammaShift=8, 
+             unsigned HiResShift=8> class gamma_lut
+    {
+    public:
+        typedef gamma_lut<LoResT, HiResT, GammaShift, HiResShift> self_type;
+
+        enum gamma_scale_e
+        {
+            gamma_shift = GammaShift,
+            gamma_size  = 1 << gamma_shift,
+            gamma_mask  = gamma_size - 1
+        };
+
+        enum hi_res_scale_e
+        {
+            hi_res_shift = HiResShift,
+            hi_res_size  = 1 << hi_res_shift,
+            hi_res_mask  = hi_res_size - 1
+        };
+
+        ~gamma_lut()
+        {
+            pod_allocator<LoResT>::deallocate(m_inv_gamma, hi_res_size);
+            pod_allocator<HiResT>::deallocate(m_dir_gamma, gamma_size);
+        }
+
+        gamma_lut() : 
+            m_gamma(1.0), 
+            m_dir_gamma(pod_allocator<HiResT>::allocate(gamma_size)),
+            m_inv_gamma(pod_allocator<LoResT>::allocate(hi_res_size))
+        {
+            unsigned i;
+            for(i = 0; i < gamma_size; i++)
+            {
+                m_dir_gamma[i] = HiResT(i << (hi_res_shift - gamma_shift));
+            }
+
+            for(i = 0; i < hi_res_size; i++)
+            {
+                m_inv_gamma[i] = LoResT(i >> (hi_res_shift - gamma_shift));
+            }
+        }
+
+        gamma_lut(double g) :
+            m_gamma(1.0), 
+            m_dir_gamma(pod_allocator<HiResT>::allocate(gamma_size)),
+            m_inv_gamma(pod_allocator<LoResT>::allocate(hi_res_size))
+        {
+            gamma(g);
+        }
+
+        void gamma(double g) 
+        {
+            m_gamma = g;
+
+            unsigned i;
+            for(i = 0; i < gamma_size; i++)
+            {
+                m_dir_gamma[i] = (HiResT)
+                    uround(pow(i / double(gamma_mask), m_gamma) * double(hi_res_mask));
+            }
+
+            double inv_g = 1.0 / g;
+            for(i = 0; i < hi_res_size; i++)
+            {
+                m_inv_gamma[i] = (LoResT)
+                    uround(pow(i / double(hi_res_mask), inv_g) * double(gamma_mask));
+            }
+        }
+
+        double gamma() const
+        {
+            return m_gamma;
+        }
+
+        HiResT dir(LoResT v) const 
+        { 
+            return m_dir_gamma[unsigned(v)]; 
+        }
+
+        LoResT inv(HiResT v) const 
+        { 
+            return m_inv_gamma[unsigned(v)];
+        }
+
+    private:
+        gamma_lut(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        double m_gamma;
+        HiResT* m_dir_gamma;
+        LoResT* m_inv_gamma;
+    };
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_glyph_raster_bin.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_glyph_raster_bin.h
--- 8.0.1-5/src/renderers/agg/include/agg_glyph_raster_bin.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_glyph_raster_bin.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,165 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_GLYPH_RASTER_BIN_INCLUDED
+#define AGG_GLYPH_RASTER_BIN_INCLUDED
+
+#include <string.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //========================================================glyph_raster_bin
+    template<class ColorT> class glyph_raster_bin
+    {
+    public:
+        typedef ColorT color_type;
+
+        //--------------------------------------------------------------------
+        struct glyph_rect
+        {
+            int x1,y1,x2,y2;
+            double dx, dy;
+        };
+
+        //--------------------------------------------------------------------
+        glyph_raster_bin(const int8u* font) :
+            m_font(font),
+            m_big_endian(false)
+        {
+            int t = 1;
+            if(*(char*)&t == 0) m_big_endian = true;
+            memset(m_span, 0, sizeof(m_span));
+        }
+
+        //--------------------------------------------------------------------
+        const int8u* font() const { return m_font; }
+        void font(const int8u* f) { m_font = f; }
+
+        //--------------------------------------------------------------------
+        double height()    const { return m_font[0]; }
+        double base_line() const { return m_font[1]; }
+
+        //--------------------------------------------------------------------
+        template<class CharT>
+        double width(const CharT* str) const
+        {
+            unsigned start_char = m_font[2];
+            unsigned num_chars = m_font[3];
+
+            unsigned w = 0;
+            while(*str)
+            {
+                unsigned glyph = *str;
+                const int8u* bits = m_font + 4 + num_chars * 2 + 
+                                    value(m_font + 4 + (glyph - start_char) * 2);
+                w += *bits;
+                ++str;
+            }
+            return w;
+        }
+
+        int8u glyph_width(unsigned glyph) const
+        {
+            unsigned start_char = m_font[2];
+            unsigned num_chars = m_font[3];
+
+            const int8u* bits = m_font + 4 + num_chars * 2 +
+                                    value(m_font + 4 + (glyph - start_char) * 2);
+            return *bits;
+        }
+
+        //--------------------------------------------------------------------
+        void prepare(glyph_rect* r, double x, double y, unsigned glyph, bool flip)
+        {
+            unsigned start_char = m_font[2];
+            unsigned num_chars = m_font[3];
+
+            m_bits = m_font + 4 + num_chars * 2 + 
+                     value(m_font + 4 + (glyph - start_char) * 2);
+
+            m_glyph_width = *m_bits++;
+            m_glyph_byte_width = (m_glyph_width + 7) >> 3;
+
+            r->x1 = int(x);
+            r->x2 = r->x1 + m_glyph_width - 1;
+            if(flip)
+            {
+                r->y1 = int(y) - m_font[0] + m_font[1];
+                r->y2 = r->y1 + m_font[0] - 1;
+            }
+            else
+            {
+                r->y1 = int(y) - m_font[1] + 1;
+                r->y2 = r->y1 + m_font[0] - 1;
+            }
+            r->dx = m_glyph_width; 
+            r->dy = 0;
+        }
+
+        //--------------------------------------------------------------------
+        const cover_type* span(unsigned i)
+        {
+            i = m_font[0] - i - 1;
+            const int8u* bits = m_bits + i * m_glyph_byte_width;
+            unsigned j;
+            unsigned val = *bits;
+            unsigned nb = 0;
+            for(j = 0; j < m_glyph_width; ++j)
+            {
+                m_span[j] = (cover_type)((val & 0x80) ? cover_full : cover_none);
+                val <<= 1;
+                if(++nb >= 8)
+                {
+                    val = *++bits;
+                    nb = 0;
+                }
+            }
+            return m_span;
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        int16u value(const int8u* p) const
+        {
+            int16u v;
+            if(m_big_endian)
+            {
+                 *(int8u*)&v      = p[1];
+                *((int8u*)&v + 1) = p[0];
+            }
+            else
+            {
+                 *(int8u*)&v      = p[0];
+                *((int8u*)&v + 1) = p[1];
+            }
+            return v;
+        }
+
+
+        //--------------------------------------------------------------------
+        const int8u* m_font;
+        bool m_big_endian;
+        cover_type m_span[32];
+        const int8u* m_bits;
+        unsigned m_glyph_width;
+        unsigned m_glyph_byte_width;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_gradient_lut.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gradient_lut.h
--- 8.0.1-5/src/renderers/agg/include/agg_gradient_lut.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gradient_lut.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,244 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_GRADIENT_LUT_INCLUDED
+#define AGG_GRADIENT_LUT_INCLUDED
+
+#include "agg_array.h"
+#include "agg_dda_line.h"
+#include "agg_color_rgba.h"
+#include "agg_color_gray.h"
+
+namespace mapserver
+{
+
+    //======================================================color_interpolator
+    template<class ColorT> struct color_interpolator
+    {
+    public:
+        typedef ColorT color_type;
+
+        color_interpolator(const color_type& c1, 
+                           const color_type& c2, 
+                           unsigned len) :
+            m_c1(c1),
+            m_c2(c2),
+            m_len(len),
+            m_count(0)
+        {}
+
+        void operator ++ ()
+        {
+            ++m_count;
+        }
+
+        color_type color() const
+        {
+            return m_c1.gradient(m_c2, double(m_count) / m_len);
+        }
+
+    private:
+        color_type m_c1;
+        color_type m_c2;
+        unsigned   m_len;
+        unsigned   m_count;
+    };
+
+    //========================================================================
+    // Fast specialization for rgba8
+    template<> struct color_interpolator<rgba8>
+    {
+    public:
+        typedef rgba8 color_type;
+
+        color_interpolator(const color_type& c1, 
+                           const color_type& c2, 
+                           unsigned len) :
+            r(c1.r, c2.r, len),
+            g(c1.g, c2.g, len),
+            b(c1.b, c2.b, len),
+            a(c1.a, c2.a, len)
+        {}
+
+        void operator ++ ()
+        {
+            ++r; ++g; ++b; ++a;
+        }
+
+        color_type color() const
+        {
+            return color_type(r.y(), g.y(), b.y(), a.y());
+        }
+
+    private:
+        mapserver::dda_line_interpolator<14> r, g, b, a;
+    };
+
+    //========================================================================
+    // Fast specialization for gray8
+    template<> struct color_interpolator<gray8>
+    {
+    public:
+        typedef gray8 color_type;
+
+        color_interpolator(const color_type& c1, 
+                           const color_type& c2, 
+                           unsigned len) :
+            v(c1.v, c2.v, len),
+            a(c1.a, c2.a, len)
+        {}
+
+        void operator ++ ()
+        {
+            ++v; ++a;
+        }
+
+        color_type color() const
+        {
+            return color_type(v.y(), a.y());
+        }
+
+    private:
+        mapserver::dda_line_interpolator<14> v,a;
+    };
+
+    //============================================================gradient_lut
+    template<class ColorInterpolator, 
+             unsigned ColorLutSize=256> class gradient_lut
+    {
+    public:
+        typedef ColorInterpolator interpolator_type;
+        typedef typename interpolator_type::color_type color_type;
+        enum { color_lut_size = ColorLutSize };
+
+        //--------------------------------------------------------------------
+        gradient_lut() : m_color_lut(color_lut_size) {}
+
+        // Build Gradient Lut
+        // First, call remove_all(), then add_color() at least twice, 
+        // then build_lut(). Argument "offset" in add_color must be 
+        // in range [0...1] and defines a color stop as it is described 
+        // in SVG specification, section Gradients and Patterns. 
+        // The simplest linear gradient is:
+        //    gradient_lut.add_color(0.0, start_color);
+        //    gradient_lut.add_color(1.0, end_color);
+        //--------------------------------------------------------------------
+        void remove_all();
+        void add_color(double offset, const color_type& color);
+        void build_lut();
+
+        // Size-index Interface. This class can be used directly as the 
+        // ColorF in span_gradient. All it needs is two access methods 
+        // size() and operator [].
+        //--------------------------------------------------------------------
+        static unsigned size() 
+        { 
+            return color_lut_size; 
+        }
+        const color_type& operator [] (unsigned i) const 
+        { 
+            return m_color_lut[i]; 
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        struct color_point
+        {
+            double     offset;
+            color_type color;
+
+            color_point() {}
+            color_point(double off, const color_type& c) : 
+                offset(off), color(c)
+            {
+                if(offset < 0.0) offset = 0.0;
+                if(offset > 1.0) offset = 1.0;
+            }
+        };
+        typedef mapserver::pod_bvector<color_point, 4> color_profile_type;
+        typedef mapserver::pod_array<color_type>       color_lut_type;
+
+        static bool offset_less(const color_point& a, const color_point& b)
+        {
+            return a.offset < b.offset;
+        }
+        static bool offset_equal(const color_point& a, const color_point& b)
+        {
+            return a.offset == b.offset;
+        }
+
+        //--------------------------------------------------------------------
+        color_profile_type  m_color_profile;
+        color_lut_type      m_color_lut;
+    };
+
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S>
+    void gradient_lut<T,S>::remove_all()
+    { 
+        m_color_profile.remove_all(); 
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S>
+    void gradient_lut<T,S>::add_color(double offset, const color_type& color)
+    {
+        m_color_profile.add(color_point(offset, color));
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S>
+    void gradient_lut<T,S>::build_lut()
+    {
+        quick_sort(m_color_profile, offset_less);
+        m_color_profile.cut_at(remove_duplicates(m_color_profile, offset_equal));
+        if(m_color_profile.size() >= 2)
+        {
+            unsigned i;
+            unsigned start = uround(m_color_profile[0].offset * color_lut_size);
+            unsigned end;
+            color_type c = m_color_profile[0].color;
+            for(i = 0; i < start; i++) 
+            {
+                m_color_lut[i] = c;
+            }
+            for(i = 1; i < m_color_profile.size(); i++)
+            {
+                end  = uround(m_color_profile[i].offset * color_lut_size);
+                interpolator_type ci(m_color_profile[i-1].color, 
+                                     m_color_profile[i  ].color, 
+                                     end - start + 1);
+                while(start < end)
+                {
+                    m_color_lut[start] = ci.color();
+                    ++ci;
+                    ++start;
+                }
+            }
+            c = m_color_profile.last().color;
+            for(; end < m_color_lut.size(); end++)
+            {
+                m_color_lut[end] = c;
+            }
+        }
+    }
+}
+
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_gsv_text.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gsv_text.h
--- 8.0.1-5/src/renderers/agg/include/agg_gsv_text.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_gsv_text.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,153 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Class gsv_text
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_GSV_TEXT_INCLUDED
+#define AGG_GSV_TEXT_INCLUDED
+
+#include "agg_array.h"
+#include "agg_conv_stroke.h"
+#include "agg_conv_transform.h"
+
+namespace mapserver
+{
+
+
+    //---------------------------------------------------------------gsv_text
+    //
+    // See Implementation agg_gsv_text.cpp 
+    //
+    class gsv_text
+    {
+        enum status
+        {
+            initial,
+            next_char,
+            start_glyph,
+            glyph
+        };
+
+    public:
+        gsv_text();
+
+        void font(const void* font);
+        void flip(bool flip_y) { m_flip = flip_y; }
+        void load_font(const char* file);
+        void size(double height, double width=0.0);
+        void space(double space);
+        void line_space(double line_space);
+        void start_point(double x, double y);
+        void text(const char* text);
+        
+        double text_width();
+
+        void rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        // not supposed to be copied
+        gsv_text(const gsv_text&);
+        const gsv_text& operator = (const gsv_text&);
+
+        int16u value(const int8u* p) const
+        {
+            int16u v;
+            if(m_big_endian)
+            {
+                 *(int8u*)&v      = p[1];
+                *((int8u*)&v + 1) = p[0];
+            }
+            else
+            {
+                 *(int8u*)&v      = p[0];
+                *((int8u*)&v + 1) = p[1];
+            }
+            return v;
+        }
+
+    private:
+        double          m_x;
+        double          m_y;
+        double          m_start_x;
+        double          m_width;
+        double          m_height;
+        double          m_space;
+        double          m_line_space;
+        char            m_chr[2];
+        char*           m_text;
+        pod_array<char> m_text_buf;
+        char*           m_cur_chr;
+        const void*     m_font;
+        pod_array<char> m_loaded_font;
+        status          m_status;
+        bool            m_big_endian;
+        bool            m_flip;
+        int8u*          m_indices;
+        int8*           m_glyphs;
+        int8*           m_bglyph;
+        int8*           m_eglyph;
+        double          m_w;
+        double          m_h;
+    };
+
+
+
+
+    //--------------------------------------------------------gsv_text_outline
+    template<class Transformer = trans_affine> class gsv_text_outline
+    {
+    public:
+        gsv_text_outline(gsv_text& text, const Transformer& trans) :
+          m_polyline(text),
+          m_trans(m_polyline, trans)
+        {
+        }
+
+        void width(double w) 
+        { 
+            m_polyline.width(w); 
+        }
+
+        void transformer(const Transformer* trans) 
+        {
+            m_trans->transformer(trans);
+        }
+
+        void rewind(unsigned path_id) 
+        { 
+            m_trans.rewind(path_id); 
+            m_polyline.line_join(round_join);
+            m_polyline.line_cap(round_cap);
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            return m_trans.vertex(x, y);
+        }
+
+    private:
+        conv_stroke<gsv_text> m_polyline;
+        conv_transform<conv_stroke<gsv_text>, Transformer> m_trans;
+    };
+
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_image_accessors.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_image_accessors.h
--- 8.0.1-5/src/renderers/agg/include/agg_image_accessors.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_image_accessors.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,481 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_IMAGE_ACCESSORS_INCLUDED
+#define AGG_IMAGE_ACCESSORS_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------image_accessor_clip
+    template<class PixFmt> class image_accessor_clip
+    {
+    public:
+        typedef PixFmt   pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::order_type order_type;
+        typedef typename pixfmt_type::value_type value_type;
+        enum pix_width_e { pix_width = pixfmt_type::pix_width };
+
+        image_accessor_clip() {}
+        explicit image_accessor_clip(const pixfmt_type& pixf, 
+                                     const color_type& bk) : 
+            m_pixf(&pixf)
+        {
+            pixfmt_type::make_pix(m_bk_buf, bk);
+        }
+
+        void attach(const pixfmt_type& pixf)
+        {
+            m_pixf = &pixf;
+        }
+
+        void background_color(const color_type& bk)
+        {
+            pixfmt_type::make_pix(m_bk_buf, bk);
+        }
+
+    private:
+        AGG_INLINE const int8u* pixel() const
+        {
+            if(m_y >= 0 && m_y < (int)m_pixf->height() &&
+               m_x >= 0 && m_x < (int)m_pixf->width())
+            {
+                return m_pixf->pix_ptr(m_x, m_y);
+            }
+            return m_bk_buf;
+        }
+
+    public:
+        AGG_INLINE const int8u* span(int x, int y, unsigned len)
+        {
+            m_x = m_x0 = x;
+            m_y = y;
+            if(y >= 0 && y < (int)m_pixf->height() &&
+               x >= 0 && x+(int)len <= (int)m_pixf->width())
+            {
+                return m_pix_ptr = m_pixf->pix_ptr(x, y);
+            }
+            m_pix_ptr = 0;
+            return pixel();
+        }
+
+        AGG_INLINE const int8u* next_x()
+        {
+            if(m_pix_ptr) return m_pix_ptr += pix_width;
+            ++m_x;
+            return pixel();
+        }
+
+        AGG_INLINE const int8u* next_y()
+        {
+            ++m_y;
+            m_x = m_x0;
+            if(m_pix_ptr && 
+               m_y >= 0 && m_y < (int)m_pixf->height())
+            {
+                return m_pix_ptr = m_pixf->pix_ptr(m_x, m_y);
+            }
+            m_pix_ptr = 0;
+            return pixel();
+        }
+
+    private:
+        const pixfmt_type* m_pixf;
+        int8u              m_bk_buf[4];
+        int                m_x, m_x0, m_y;
+        const int8u*       m_pix_ptr;
+    };
+
+
+
+
+    //--------------------------------------------------image_accessor_no_clip
+    template<class PixFmt> class image_accessor_no_clip
+    {
+    public:
+        typedef PixFmt   pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::order_type order_type;
+        typedef typename pixfmt_type::value_type value_type;
+        enum pix_width_e { pix_width = pixfmt_type::pix_width };
+
+        image_accessor_no_clip() {}
+        explicit image_accessor_no_clip(const pixfmt_type& pixf) : 
+            m_pixf(&pixf) 
+        {}
+
+        void attach(const pixfmt_type& pixf)
+        {
+            m_pixf = &pixf;
+        }
+
+        AGG_INLINE const int8u* span(int x, int y, unsigned)
+        {
+            m_x = x;
+            m_y = y;
+            return m_pix_ptr = m_pixf->pix_ptr(x, y);
+        }
+
+        AGG_INLINE const int8u* next_x()
+        {
+            return m_pix_ptr += pix_width;
+        }
+
+        AGG_INLINE const int8u* next_y()
+        {
+            ++m_y;
+            return m_pix_ptr = m_pixf->pix_ptr(m_x, m_y);
+        }
+
+    private:
+        const pixfmt_type* m_pixf;
+        int                m_x, m_y;
+        const int8u*       m_pix_ptr;
+    };
+
+
+
+
+    //----------------------------------------------------image_accessor_clone
+    template<class PixFmt> class image_accessor_clone
+    {
+    public:
+        typedef PixFmt   pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::order_type order_type;
+        typedef typename pixfmt_type::value_type value_type;
+        enum pix_width_e { pix_width = pixfmt_type::pix_width };
+
+        image_accessor_clone() {}
+        explicit image_accessor_clone(const pixfmt_type& pixf) : 
+            m_pixf(&pixf) 
+        {}
+
+        void attach(const pixfmt_type& pixf)
+        {
+            m_pixf = &pixf;
+        }
+
+    private:
+        AGG_INLINE const int8u* pixel() const
+        {
+            int x = m_x;
+            int y = m_y;
+            if(x < 0) x = 0;
+            if(y < 0) y = 0;
+            if(x >= (int)m_pixf->width())  x = m_pixf->width() - 1;
+            if(y >= (int)m_pixf->height()) y = m_pixf->height() - 1;
+            return m_pixf->pix_ptr(x, y);
+        }
+
+    public:
+        AGG_INLINE const int8u* span(int x, int y, unsigned len)
+        {
+            m_x = m_x0 = x;
+            m_y = y;
+            if(y >= 0 && y < (int)m_pixf->height() &&
+               x >= 0 && x+len <= (int)m_pixf->width())
+            {
+                return m_pix_ptr = m_pixf->pix_ptr(x, y);
+            }
+            m_pix_ptr = 0;
+            return pixel();
+        }
+
+        AGG_INLINE const int8u* next_x()
+        {
+            if(m_pix_ptr) return m_pix_ptr += pix_width;
+            ++m_x;
+            return pixel();
+        }
+
+        AGG_INLINE const int8u* next_y()
+        {
+            ++m_y;
+            m_x = m_x0;
+            if(m_pix_ptr && 
+               m_y >= 0 && m_y < (int)m_pixf->height())
+            {
+                return m_pix_ptr = m_pixf->pix_ptr(m_x, m_y);
+            }
+            m_pix_ptr = 0;
+            return pixel();
+        }
+
+    private:
+        const pixfmt_type* m_pixf;
+        int                m_x, m_x0, m_y;
+        const int8u*       m_pix_ptr;
+    };
+
+
+
+
+
+    //-----------------------------------------------------image_accessor_wrap
+    template<class PixFmt, class WrapX, class WrapY> class image_accessor_wrap
+    {
+    public:
+        typedef PixFmt   pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::order_type order_type;
+        typedef typename pixfmt_type::value_type value_type;
+        enum pix_width_e { pix_width = pixfmt_type::pix_width };
+
+        image_accessor_wrap() = default;
+        explicit image_accessor_wrap(const pixfmt_type& pixf) : 
+            m_pixf(&pixf), 
+            m_wrap_x(pixf.width()), 
+            m_wrap_y(pixf.height())
+        {}
+
+        void attach(const pixfmt_type& pixf)
+        {
+            m_pixf = &pixf;
+        }
+
+        AGG_INLINE const int8u* span(int x, int y, unsigned)
+        {
+            m_x = x;
+            m_row_ptr = m_pixf->row_ptr(m_wrap_y(y));
+            return m_row_ptr + m_wrap_x(x) * pix_width;
+        }
+
+        AGG_INLINE const int8u* next_x()
+        {
+            int x = ++m_wrap_x;
+            return m_row_ptr + x * pix_width;
+        }
+
+        AGG_INLINE const int8u* next_y()
+        {
+            m_row_ptr = m_pixf->row_ptr(++m_wrap_y);
+            return m_row_ptr + m_wrap_x(m_x) * pix_width;
+        }
+
+    private:
+        const pixfmt_type* m_pixf = nullptr;
+        const int8u*       m_row_ptr = nullptr;
+        int                m_x = 0;
+        WrapX              m_wrap_x = 0;
+        WrapY              m_wrap_y = 0;
+    };
+
+
+
+
+    //--------------------------------------------------------wrap_mode_repeat
+    class wrap_mode_repeat
+    {
+    public:
+        wrap_mode_repeat() {}
+        wrap_mode_repeat(unsigned size) : 
+            m_size(size), 
+            m_add(size * (0x3FFFFFFF / size)),
+            m_value(0)
+        {}
+
+        AGG_INLINE unsigned operator() (int v)
+        { 
+            return m_value = (unsigned(v) + m_add) % m_size; 
+        }
+
+        AGG_INLINE unsigned operator++ ()
+        {
+            ++m_value;
+            if(m_value >= m_size) m_value = 0;
+            return m_value;
+        }
+    private:
+        unsigned m_size;
+        unsigned m_add;
+        unsigned m_value;
+    };
+
+
+    //---------------------------------------------------wrap_mode_repeat_pow2
+    class wrap_mode_repeat_pow2
+    {
+    public:
+        wrap_mode_repeat_pow2() {}
+        wrap_mode_repeat_pow2(unsigned size) : m_value(0)
+        {
+            m_mask = 1;
+            while(m_mask < size) m_mask = (m_mask << 1) | 1;
+            m_mask >>= 1;
+        }
+        AGG_INLINE unsigned operator() (int v)
+        { 
+            return m_value = unsigned(v) & m_mask;
+        }
+        AGG_INLINE unsigned operator++ ()
+        {
+            ++m_value;
+            if(m_value > m_mask) m_value = 0;
+            return m_value;
+        }
+    private:
+        unsigned m_mask;
+        unsigned m_value;
+    };
+
+
+    //----------------------------------------------wrap_mode_repeat_auto_pow2
+    class wrap_mode_repeat_auto_pow2
+    {
+    public:
+        wrap_mode_repeat_auto_pow2() {}
+        wrap_mode_repeat_auto_pow2(unsigned size) :
+            m_size(size),
+            m_add(size * (0x3FFFFFFF / size)),
+            m_mask((m_size & (m_size-1)) ? 0 : m_size-1),
+            m_value(0)
+        {}
+
+        AGG_INLINE unsigned operator() (int v) 
+        { 
+            if(m_mask) return m_value = unsigned(v) & m_mask;
+            return m_value = (unsigned(v) + m_add) % m_size;
+        }
+        AGG_INLINE unsigned operator++ ()
+        {
+            ++m_value;
+            if(m_value >= m_size) m_value = 0;
+            return m_value;
+        }
+
+    private:
+        unsigned m_size;
+        unsigned m_add;
+        unsigned m_mask;
+        unsigned m_value;
+    };
+
+
+    //-------------------------------------------------------wrap_mode_reflect
+    class wrap_mode_reflect
+    {
+    public:
+        wrap_mode_reflect() {}
+        wrap_mode_reflect(unsigned size) : 
+            m_size(size), 
+            m_size2(size * 2),
+            m_add(m_size2 * (0x3FFFFFFF / m_size2)),
+            m_value(0)
+        {}
+
+        AGG_INLINE unsigned operator() (int v)
+        { 
+            m_value = (unsigned(v) + m_add) % m_size2;
+            if(m_value >= m_size) return m_size2 - m_value - 1;
+            return m_value;
+        }
+
+        AGG_INLINE unsigned operator++ ()
+        {
+            ++m_value;
+            if(m_value >= m_size2) m_value = 0;
+            if(m_value >= m_size) return m_size2 - m_value - 1;
+            return m_value;
+        }
+    private:
+        unsigned m_size;
+        unsigned m_size2;
+        unsigned m_add;
+        unsigned m_value;
+    };
+
+
+
+    //--------------------------------------------------wrap_mode_reflect_pow2
+    class wrap_mode_reflect_pow2
+    {
+    public:
+        wrap_mode_reflect_pow2() {}
+        wrap_mode_reflect_pow2(unsigned size) : m_value(0)
+        {
+            m_mask = 1;
+            m_size = 1;
+            while(m_mask < size) 
+            {
+                m_mask = (m_mask << 1) | 1;
+                m_size <<= 1;
+            }
+        }
+        AGG_INLINE unsigned operator() (int v)
+        { 
+            m_value = unsigned(v) & m_mask;
+            if(m_value >= m_size) return m_mask - m_value;
+            return m_value;
+        }
+        AGG_INLINE unsigned operator++ ()
+        {
+            ++m_value;
+            m_value &= m_mask;
+            if(m_value >= m_size) return m_mask - m_value;
+            return m_value;
+        }
+    private:
+        unsigned m_size;
+        unsigned m_mask;
+        unsigned m_value;
+    };
+
+
+
+    //---------------------------------------------wrap_mode_reflect_auto_pow2
+    class wrap_mode_reflect_auto_pow2
+    {
+    public:
+        wrap_mode_reflect_auto_pow2() {}
+        wrap_mode_reflect_auto_pow2(unsigned size) :
+            m_size(size),
+            m_size2(size * 2),
+            m_add(m_size2 * (0x3FFFFFFF / m_size2)),
+            m_mask((m_size2 & (m_size2-1)) ? 0 : m_size2-1),
+            m_value(0)
+        {}
+
+        AGG_INLINE unsigned operator() (int v) 
+        { 
+            m_value = m_mask ? unsigned(v) & m_mask : 
+                              (unsigned(v) + m_add) % m_size2;
+            if(m_value >= m_size) return m_size2 - m_value - 1;
+            return m_value;            
+        }
+        AGG_INLINE unsigned operator++ ()
+        {
+            ++m_value;
+            if(m_value >= m_size2) m_value = 0;
+            if(m_value >= m_size) return m_size2 - m_value - 1;
+            return m_value;
+        }
+
+    private:
+        unsigned m_size;
+        unsigned m_size2;
+        unsigned m_add;
+        unsigned m_mask;
+        unsigned m_value;
+    };
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_image_filters.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_image_filters.h
--- 8.0.1-5/src/renderers/agg/include/agg_image_filters.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_image_filters.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,448 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Image transformation filters,
+// Filtering classes (image_filter_lut, image_filter),
+// Basic filter shape classes
+//----------------------------------------------------------------------------
+#ifndef AGG_IMAGE_FILTERS_INCLUDED
+#define AGG_IMAGE_FILTERS_INCLUDED
+
+#include "agg_array.h"
+#include "agg_math.h"
+
+namespace mapserver
+{
+
+    // See Implementation agg_image_filters.cpp 
+
+    enum image_filter_scale_e
+    {
+        image_filter_shift = 14,                      //----image_filter_shift
+        image_filter_scale = 1 << image_filter_shift, //----image_filter_scale 
+        image_filter_mask  = image_filter_scale - 1   //----image_filter_mask 
+    };
+
+    enum image_subpixel_scale_e
+    {
+        image_subpixel_shift = 8,                         //----image_subpixel_shift
+        image_subpixel_scale = 1 << image_subpixel_shift, //----image_subpixel_scale 
+        image_subpixel_mask  = image_subpixel_scale - 1   //----image_subpixel_mask 
+    };
+
+
+    //-----------------------------------------------------image_filter_lut
+    class image_filter_lut
+    {
+    public:
+        template<class FilterF> void calculate(const FilterF& filter,
+                                               bool normalization=true)
+        {
+            double r = filter.radius();
+            realloc_lut(r);
+            unsigned i;
+            unsigned pivot = diameter() << (image_subpixel_shift - 1);
+            for(i = 0; i < pivot; i++)
+            {
+                double x = double(i) / double(image_subpixel_scale);
+                double y = filter.calc_weight(x);
+                m_weight_array[pivot + i] = 
+                m_weight_array[pivot - i] = (int16)iround(y * image_filter_scale);
+            }
+            unsigned end = (diameter() << image_subpixel_shift) - 1;
+            m_weight_array[0] = m_weight_array[end];
+            if(normalization) 
+            {
+                normalize();
+            }
+        }
+
+        image_filter_lut() : m_radius(0), m_diameter(0), m_start(0) {}
+
+        template<class FilterF> image_filter_lut(const FilterF& filter, 
+                                                 bool normalization=true)
+        {
+            calculate(filter, normalization);
+        }
+
+        double       radius()       const { return m_radius;   }
+        unsigned     diameter()     const { return m_diameter; }
+        int          start()        const { return m_start;    }
+        const int16* weight_array() const { return &m_weight_array[0]; }
+        void         normalize();
+
+    private:
+        void realloc_lut(double radius);
+        image_filter_lut(const image_filter_lut&);
+        const image_filter_lut& operator = (const image_filter_lut&);
+
+        double           m_radius;
+        unsigned         m_diameter;
+        int              m_start;
+        pod_array<int16> m_weight_array;
+    };
+
+
+
+    //--------------------------------------------------------image_filter
+    template<class FilterF> class image_filter : public image_filter_lut
+    {
+    public:
+        image_filter()
+        {
+            calculate(m_filter_function);
+        }
+    private:
+        FilterF m_filter_function;
+    };
+
+
+    //-----------------------------------------------image_filter_bilinear
+    struct image_filter_bilinear
+    {
+        static double radius() { return 1.0; }
+        static double calc_weight(double x)
+        {
+            return 1.0 - x;
+        }
+    };
+
+
+    //-----------------------------------------------image_filter_hanning
+    struct image_filter_hanning
+    {
+        static double radius() { return 1.0; }
+        static double calc_weight(double x)
+        {
+            return 0.5 + 0.5 * cos(pi * x);
+        }
+    };
+
+
+    //-----------------------------------------------image_filter_hamming
+    struct image_filter_hamming
+    {
+        static double radius() { return 1.0; }
+        static double calc_weight(double x)
+        {
+            return 0.54 + 0.46 * cos(pi * x);
+        }
+    };
+
+    //-----------------------------------------------image_filter_hermite
+    struct image_filter_hermite
+    {
+        static double radius() { return 1.0; }
+        static double calc_weight(double x)
+        {
+            return (2.0 * x - 3.0) * x * x + 1.0;
+        }
+    };
+   
+    //------------------------------------------------image_filter_quadric
+    struct image_filter_quadric
+    {
+        static double radius() { return 1.5; }
+        static double calc_weight(double x)
+        {
+            double t;
+            if(x <  0.5) return 0.75 - x * x;
+            if(x <  1.5) {t = x - 1.5; return 0.5 * t * t;}
+            return 0.0;
+        }
+    };
+
+    //------------------------------------------------image_filter_bicubic
+    class image_filter_bicubic
+    {
+        static double pow3(double x)
+        {
+            return (x <= 0.0) ? 0.0 : x * x * x;
+        }
+
+    public:
+        static double radius() { return 2.0; }
+        static double calc_weight(double x)
+        {
+            return
+                (1.0/6.0) * 
+                (pow3(x + 2) - 4 * pow3(x + 1) + 6 * pow3(x) - 4 * pow3(x - 1));
+        }
+    };
+
+    //-------------------------------------------------image_filter_kaiser
+    class image_filter_kaiser
+    {
+        double a;
+        double i0a;
+        double epsilon;
+
+    public:
+        image_filter_kaiser(double b = 6.33) :
+            a(b), epsilon(1e-12)
+        {
+            i0a = 1.0 / bessel_i0(b);
+        }
+
+        static double radius() { return 1.0; }
+        double calc_weight(double x) const
+        {
+            return bessel_i0(a * sqrt(1. - x * x)) * i0a;
+        }
+
+    private:
+        double bessel_i0(double x) const
+        {
+            int i;
+            double sum, y, t;
+
+            sum = 1.;
+            y = x * x / 4.;
+            t = y;
+        
+            for(i = 2; t > epsilon; i++)
+            {
+                sum += t;
+                t *= (double)y / (i * i);
+            }
+            return sum;
+        }
+    };
+
+    //----------------------------------------------image_filter_catrom
+    struct image_filter_catrom
+    {
+        static double radius() { return 2.0; }
+        static double calc_weight(double x)
+        {
+            if(x <  1.0) return 0.5 * (2.0 + x * x * (-5.0 + x * 3.0));
+            if(x <  2.0) return 0.5 * (4.0 + x * (-8.0 + x * (5.0 - x)));
+            return 0.;
+        }
+    };
+
+    //---------------------------------------------image_filter_mitchell
+    class image_filter_mitchell
+    {
+        double p0, p2, p3;
+        double q0, q1, q2, q3;
+
+    public:
+        image_filter_mitchell(double b = 1.0/3.0, double c = 1.0/3.0) :
+            p0((6.0 - 2.0 * b) / 6.0),
+            p2((-18.0 + 12.0 * b + 6.0 * c) / 6.0),
+            p3((12.0 - 9.0 * b - 6.0 * c) / 6.0),
+            q0((8.0 * b + 24.0 * c) / 6.0),
+            q1((-12.0 * b - 48.0 * c) / 6.0),
+            q2((6.0 * b + 30.0 * c) / 6.0),
+            q3((-b - 6.0 * c) / 6.0)
+        {}
+
+        static double radius() { return 2.0; }
+        double calc_weight(double x) const
+        {
+            if(x < 1.0) return p0 + x * x * (p2 + x * p3);
+            if(x < 2.0) return q0 + x * (q1 + x * (q2 + x * q3));
+            return 0.0;
+        }
+    };
+
+
+    //----------------------------------------------image_filter_spline16
+    struct image_filter_spline16
+    {
+        static double radius() { return 2.0; }
+        static double calc_weight(double x)
+        {
+            if(x < 1.0)
+            {
+                return ((x - 9.0/5.0 ) * x - 1.0/5.0 ) * x + 1.0;
+            }
+            return ((-1.0/3.0 * (x-1) + 4.0/5.0) * (x-1) - 7.0/15.0 ) * (x-1);
+        }
+    };
+
+
+    //---------------------------------------------image_filter_spline36
+    struct image_filter_spline36
+    {
+        static double radius() { return 3.0; }
+        static double calc_weight(double x)
+        {
+           if(x < 1.0)
+           {
+              return ((13.0/11.0 * x - 453.0/209.0) * x - 3.0/209.0) * x + 1.0;
+           }
+           if(x < 2.0)
+           {
+              return ((-6.0/11.0 * (x-1) + 270.0/209.0) * (x-1) - 156.0/ 209.0) * (x-1);
+           }
+           return ((1.0/11.0 * (x-2) - 45.0/209.0) * (x-2) +  26.0/209.0) * (x-2);
+        }
+    };
+
+
+    //----------------------------------------------image_filter_gaussian
+    struct image_filter_gaussian
+    {
+        static double radius() { return 2.0; }
+        static double calc_weight(double x) 
+        {
+            return exp(-2.0 * x * x) * sqrt(2.0 / pi);
+        }
+    };
+
+
+    //------------------------------------------------image_filter_bessel
+    struct image_filter_bessel
+    {
+        static double radius() { return 3.2383; } 
+        static double calc_weight(double x)
+        {
+            return (x == 0.0) ? pi / 4.0 : besj(pi * x, 1) / (2.0 * x);
+        }
+    };
+
+
+    //-------------------------------------------------image_filter_sinc
+    class image_filter_sinc
+    {
+    public:
+        image_filter_sinc(double r) : m_radius(r < 2.0 ? 2.0 : r) {}
+        double radius() const { return m_radius; }
+        double calc_weight(double x) const
+        {
+            if(x == 0.0) return 1.0;
+            x *= pi;
+            return sin(x) / x;
+        }
+    private:
+        double m_radius;
+    };
+
+
+    //-----------------------------------------------image_filter_lanczos
+    class image_filter_lanczos
+    {
+    public:
+        image_filter_lanczos(double r) : m_radius(r < 2.0 ? 2.0 : r) {}
+        double radius() const { return m_radius; }
+        double calc_weight(double x) const
+        {
+           if(x == 0.0) return 1.0;
+           if(x > m_radius) return 0.0;
+           x *= pi;
+           double xr = x / m_radius;
+           return (sin(x) / x) * (sin(xr) / xr);
+        }
+    private:
+        double m_radius;
+    };
+
+
+    //----------------------------------------------image_filter_blackman
+    class image_filter_blackman
+    {
+    public:
+        image_filter_blackman(double r) : m_radius(r < 2.0 ? 2.0 : r) {}
+        double radius() const { return m_radius; }
+        double calc_weight(double x) const
+        {
+           if(x == 0.0) return 1.0;
+           if(x > m_radius) return 0.0;
+           x *= pi;
+           double xr = x / m_radius;
+           return (sin(x) / x) * (0.42 + 0.5*cos(xr) + 0.08*cos(2*xr));
+        }
+    private:
+        double m_radius;
+    };
+
+    //------------------------------------------------image_filter_sinc36
+    class image_filter_sinc36 : public image_filter_sinc
+    { public: image_filter_sinc36() : image_filter_sinc(3.0){} };
+
+    //------------------------------------------------image_filter_sinc64
+    class image_filter_sinc64 : public image_filter_sinc
+    { public: image_filter_sinc64() : image_filter_sinc(4.0){} };
+
+    //-----------------------------------------------image_filter_sinc100
+    class image_filter_sinc100 : public image_filter_sinc
+    { public: image_filter_sinc100() : image_filter_sinc(5.0){} };
+
+    //-----------------------------------------------image_filter_sinc144
+    class image_filter_sinc144 : public image_filter_sinc
+    { public: image_filter_sinc144() : image_filter_sinc(6.0){} };
+
+    //-----------------------------------------------image_filter_sinc196
+    class image_filter_sinc196 : public image_filter_sinc
+    { public: image_filter_sinc196() : image_filter_sinc(7.0){} };
+
+    //-----------------------------------------------image_filter_sinc256
+    class image_filter_sinc256 : public image_filter_sinc
+    { public: image_filter_sinc256() : image_filter_sinc(8.0){} };
+
+    //---------------------------------------------image_filter_lanczos36
+    class image_filter_lanczos36 : public image_filter_lanczos
+    { public: image_filter_lanczos36() : image_filter_lanczos(3.0){} };
+
+    //---------------------------------------------image_filter_lanczos64
+    class image_filter_lanczos64 : public image_filter_lanczos
+    { public: image_filter_lanczos64() : image_filter_lanczos(4.0){} };
+
+    //--------------------------------------------image_filter_lanczos100
+    class image_filter_lanczos100 : public image_filter_lanczos
+    { public: image_filter_lanczos100() : image_filter_lanczos(5.0){} };
+
+    //--------------------------------------------image_filter_lanczos144
+    class image_filter_lanczos144 : public image_filter_lanczos
+    { public: image_filter_lanczos144() : image_filter_lanczos(6.0){} };
+
+    //--------------------------------------------image_filter_lanczos196
+    class image_filter_lanczos196 : public image_filter_lanczos
+    { public: image_filter_lanczos196() : image_filter_lanczos(7.0){} };
+
+    //--------------------------------------------image_filter_lanczos256
+    class image_filter_lanczos256 : public image_filter_lanczos
+    { public: image_filter_lanczos256() : image_filter_lanczos(8.0){} };
+
+    //--------------------------------------------image_filter_blackman36
+    class image_filter_blackman36 : public image_filter_blackman
+    { public: image_filter_blackman36() : image_filter_blackman(3.0){} };
+
+    //--------------------------------------------image_filter_blackman64
+    class image_filter_blackman64 : public image_filter_blackman
+    { public: image_filter_blackman64() : image_filter_blackman(4.0){} };
+
+    //-------------------------------------------image_filter_blackman100
+    class image_filter_blackman100 : public image_filter_blackman
+    { public: image_filter_blackman100() : image_filter_blackman(5.0){} };
+
+    //-------------------------------------------image_filter_blackman144
+    class image_filter_blackman144 : public image_filter_blackman
+    { public: image_filter_blackman144() : image_filter_blackman(6.0){} };
+
+    //-------------------------------------------image_filter_blackman196
+    class image_filter_blackman196 : public image_filter_blackman
+    { public: image_filter_blackman196() : image_filter_blackman(7.0){} };
+
+    //-------------------------------------------image_filter_blackman256
+    class image_filter_blackman256 : public image_filter_blackman
+    { public: image_filter_blackman256() : image_filter_blackman(8.0){} };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_line_aa_basics.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_line_aa_basics.h
--- 8.0.1-5/src/renderers/agg/include/agg_line_aa_basics.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_line_aa_basics.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,189 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_LINE_AA_BASICS_INCLUDED
+#define AGG_LINE_AA_BASICS_INCLUDED
+
+#include <stdlib.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    // See Implementation agg_line_aa_basics.cpp 
+
+    //-------------------------------------------------------------------------
+    enum line_subpixel_scale_e
+    {
+        line_subpixel_shift = 8,                          //----line_subpixel_shift
+        line_subpixel_scale  = 1 << line_subpixel_shift,  //----line_subpixel_scale
+        line_subpixel_mask  = line_subpixel_scale - 1,    //----line_subpixel_mask
+        line_max_coord      = (1 << 28) - 1,              //----line_max_coord
+        line_max_length = 1 << (line_subpixel_shift + 10) //----line_max_length
+    };
+
+    //-------------------------------------------------------------------------
+    enum line_mr_subpixel_scale_e
+    {
+        line_mr_subpixel_shift = 4,                           //----line_mr_subpixel_shift
+        line_mr_subpixel_scale = 1 << line_mr_subpixel_shift, //----line_mr_subpixel_scale 
+        line_mr_subpixel_mask  = line_mr_subpixel_scale - 1   //----line_mr_subpixel_mask 
+    };
+
+    //------------------------------------------------------------------line_mr
+    AGG_INLINE int line_mr(int x) 
+    { 
+        return x >> (line_subpixel_shift - line_mr_subpixel_shift); 
+    }
+
+    //-------------------------------------------------------------------line_hr
+    AGG_INLINE int line_hr(int x) 
+    { 
+        return x << (line_subpixel_shift - line_mr_subpixel_shift); 
+    }
+
+    //---------------------------------------------------------------line_dbl_hr
+    AGG_INLINE int line_dbl_hr(int x) 
+    { 
+        return x << line_subpixel_shift;
+    }
+
+    //---------------------------------------------------------------line_coord
+    struct line_coord
+    {
+        AGG_INLINE static int conv(double x)
+        {
+            return iround(x * line_subpixel_scale);
+        }
+    };
+
+    //-----------------------------------------------------------line_coord_sat
+    struct line_coord_sat
+    {
+        AGG_INLINE static int conv(double x)
+        {
+            return saturation<line_max_coord>::iround(x * line_subpixel_scale);
+        }
+    };
+
+    //==========================================================line_parameters
+    struct line_parameters
+    {
+        //---------------------------------------------------------------------
+        line_parameters() = default;
+        line_parameters(int x1_, int y1_, int x2_, int y2_, int len_) :
+            x1(x1_), y1(y1_), x2(x2_), y2(y2_), 
+            dx(abs(x2_ - x1_)),
+            dy(abs(y2_ - y1_)),
+            sx((x2_ > x1_) ? 1 : -1),
+            sy((y2_ > y1_) ? 1 : -1),
+            vertical(dy >= dx),
+            inc(vertical ? sy : sx),
+            len(len_),
+            octant((sy & 4) | (sx & 2) | int(vertical))
+        {
+        }
+
+        //---------------------------------------------------------------------
+        unsigned orthogonal_quadrant() const { return s_orthogonal_quadrant[octant]; }
+        unsigned diagonal_quadrant()   const { return s_diagonal_quadrant[octant];   }
+
+        //---------------------------------------------------------------------
+        bool same_orthogonal_quadrant(const line_parameters& lp) const
+        {
+            return s_orthogonal_quadrant[octant] == s_orthogonal_quadrant[lp.octant];
+        }
+
+        //---------------------------------------------------------------------
+        bool same_diagonal_quadrant(const line_parameters& lp) const
+        {
+            return s_diagonal_quadrant[octant] == s_diagonal_quadrant[lp.octant];
+        }
+
+        //---------------------------------------------------------------------
+        void divide(line_parameters& lp1, line_parameters& lp2) const
+        {
+            int xmid = (x1 + x2) >> 1;
+            int ymid = (y1 + y2) >> 1;
+            int len2 = len >> 1;
+
+            lp1 = *this;
+            lp2 = *this;
+
+            lp1.x2  = xmid;
+            lp1.y2  = ymid;
+            lp1.len = len2;
+            lp1.dx  = abs(lp1.x2 - lp1.x1);
+            lp1.dy  = abs(lp1.y2 - lp1.y1);
+
+            lp2.x1  = xmid;
+            lp2.y1  = ymid;
+            lp2.len = len2;
+            lp2.dx  = abs(lp2.x2 - lp2.x1);
+            lp2.dy  = abs(lp2.y2 - lp2.y1);
+        }
+        
+        //---------------------------------------------------------------------
+        int x1 = 0, y1 = 0, x2 = 0, y2 = 0, dx = 0, dy = 0, sx = 0, sy = 0;
+        bool vertical = false;
+        int inc = 0;
+        int len = 0;
+        int octant = 0;
+
+        //---------------------------------------------------------------------
+        static const int8u s_orthogonal_quadrant[8];
+        static const int8u s_diagonal_quadrant[8];
+    };
+
+
+
+    // See Implementation agg_line_aa_basics.cpp 
+
+    //----------------------------------------------------------------bisectrix
+    void bisectrix(const line_parameters& l1, 
+                   const line_parameters& l2, 
+                   int* x, int* y);
+
+
+    //-------------------------------------------fix_degenerate_bisectrix_start
+    void inline fix_degenerate_bisectrix_start(const line_parameters& lp, 
+                                               int* x, int* y)
+    {
+        int d = iround((double(*x - lp.x2) * double(lp.y2 - lp.y1) - 
+                        double(*y - lp.y2) * double(lp.x2 - lp.x1)) / lp.len);
+        if(d < line_subpixel_scale/2)
+        {
+            *x = lp.x1 + (lp.y2 - lp.y1);
+            *y = lp.y1 - (lp.x2 - lp.x1);
+        }
+    }
+
+
+    //---------------------------------------------fix_degenerate_bisectrix_end
+    void inline fix_degenerate_bisectrix_end(const line_parameters& lp, 
+                                             int* x, int* y)
+    {
+        int d = iround((double(*x - lp.x2) * double(lp.y2 - lp.y1) - 
+                        double(*y - lp.y2) * double(lp.x2 - lp.x1)) / lp.len);
+        if(d < line_subpixel_scale/2)
+        {
+            *x = lp.x2 + (lp.y2 - lp.y1);
+            *y = lp.y2 - (lp.x2 - lp.x1);
+        }
+    }
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_math.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_math.h
--- 8.0.1-5/src/renderers/agg/include/agg_math.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_math.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,437 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+// Bessel function (besj) was adapted for use in AGG library by Andy Wilk 
+// Contact: castor.vulgaris@gmail.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_MATH_INCLUDED
+#define AGG_MATH_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------vertex_dist_epsilon
+    // Coinciding points maximal distance (Epsilon)
+    const double vertex_dist_epsilon = 1e-14;
+
+    //-----------------------------------------------------intersection_epsilon
+    // See calc_intersection
+    const double intersection_epsilon = 1.0e-30;
+
+    //------------------------------------------------------------cross_product
+    AGG_INLINE double cross_product(double x1, double y1, 
+                                    double x2, double y2, 
+                                    double x,  double y)
+    {
+        return (x - x2) * (y2 - y1) - (y - y2) * (x2 - x1);
+    }
+
+    //--------------------------------------------------------point_in_triangle
+    AGG_INLINE bool point_in_triangle(double x1, double y1, 
+                                      double x2, double y2, 
+                                      double x3, double y3, 
+                                      double x,  double y)
+    {
+        bool cp1 = cross_product(x1, y1, x2, y2, x, y) < 0.0;
+        bool cp2 = cross_product(x2, y2, x3, y3, x, y) < 0.0;
+        bool cp3 = cross_product(x3, y3, x1, y1, x, y) < 0.0;
+        return cp1 == cp2 && cp2 == cp3 && cp3 == cp1;
+    }
+
+    //-----------------------------------------------------------calc_distance
+    AGG_INLINE double calc_distance(double x1, double y1, double x2, double y2)
+    {
+        double dx = x2-x1;
+        double dy = y2-y1;
+        return sqrt(dx * dx + dy * dy);
+    }
+
+    //--------------------------------------------------------calc_sq_distance
+    AGG_INLINE double calc_sq_distance(double x1, double y1, double x2, double y2)
+    {
+        double dx = x2-x1;
+        double dy = y2-y1;
+        return dx * dx + dy * dy;
+    }
+
+    //------------------------------------------------calc_line_point_distance
+    AGG_INLINE double calc_line_point_distance(double x1, double y1, 
+                                               double x2, double y2, 
+                                               double x,  double y)
+    {
+        double dx = x2-x1;
+        double dy = y2-y1;
+        double d = sqrt(dx * dx + dy * dy);
+        if(d < vertex_dist_epsilon)
+        {
+            return calc_distance(x1, y1, x, y);
+        }
+        return ((x - x2) * dy - (y - y2) * dx) / d;
+    }
+
+    //-------------------------------------------------------calc_line_point_u
+    AGG_INLINE double calc_segment_point_u(double x1, double y1, 
+                                           double x2, double y2, 
+                                           double x,  double y)
+    {
+        double dx = x2 - x1;
+        double dy = y2 - y1;
+
+        if(dx == 0 && dy == 0)
+        {
+	        return 0;
+        }
+
+        double pdx = x - x1;
+        double pdy = y - y1;
+
+        return (pdx * dx + pdy * dy) / (dx * dx + dy * dy);
+    }
+
+    //---------------------------------------------calc_line_point_sq_distance
+    AGG_INLINE double calc_segment_point_sq_distance(double x1, double y1, 
+                                                     double x2, double y2, 
+                                                     double x,  double y,
+                                                     double u)
+    {
+        if(u <= 0)
+        {
+	        return calc_sq_distance(x, y, x1, y1);
+        }
+        else 
+        if(u >= 1)
+        {
+	        return calc_sq_distance(x, y, x2, y2);
+        }
+        return calc_sq_distance(x, y, x1 + u * (x2 - x1), y1 + u * (y2 - y1));
+    }
+
+    //---------------------------------------------calc_line_point_sq_distance
+    AGG_INLINE double calc_segment_point_sq_distance(double x1, double y1, 
+                                                     double x2, double y2, 
+                                                     double x,  double y)
+    {
+        return 
+            calc_segment_point_sq_distance(
+                x1, y1, x2, y2, x, y,
+                calc_segment_point_u(x1, y1, x2, y2, x, y));
+    }
+
+    //-------------------------------------------------------calc_intersection
+    AGG_INLINE bool calc_intersection(double ax, double ay, double bx, double by,
+                                      double cx, double cy, double dx, double dy,
+                                      double* x, double* y)
+    {
+        double num = (ay-cy) * (dx-cx) - (ax-cx) * (dy-cy);
+        double den = (bx-ax) * (dy-cy) - (by-ay) * (dx-cx);
+        if(fabs(den) < intersection_epsilon) return false;
+        double r = num / den;
+        *x = ax + r * (bx-ax);
+        *y = ay + r * (by-ay);
+        return true;
+    }
+
+    //-----------------------------------------------------intersection_exists
+    AGG_INLINE bool intersection_exists(double x1, double y1, double x2, double y2,
+                                        double x3, double y3, double x4, double y4)
+    {
+        // It's less expensive but you can't control the 
+        // boundary conditions: Less or LessEqual
+        double dx1 = x2 - x1;
+        double dy1 = y2 - y1;
+        double dx2 = x4 - x3;
+        double dy2 = y4 - y3;
+        return ((x3 - x2) * dy1 - (y3 - y2) * dx1 < 0.0) != 
+               ((x4 - x2) * dy1 - (y4 - y2) * dx1 < 0.0) &&
+               ((x1 - x4) * dy2 - (y1 - y4) * dx2 < 0.0) !=
+               ((x2 - x4) * dy2 - (y2 - y4) * dx2 < 0.0);
+
+        // It's is more expensive but more flexible 
+        // in terms of boundary conditions.
+        //--------------------
+        //double den  = (x2-x1) * (y4-y3) - (y2-y1) * (x4-x3);
+        //if(fabs(den) < intersection_epsilon) return false;
+        //double nom1 = (x4-x3) * (y1-y3) - (y4-y3) * (x1-x3);
+        //double nom2 = (x2-x1) * (y1-y3) - (y2-y1) * (x1-x3);
+        //double ua = nom1 / den;
+        //double ub = nom2 / den;
+        //return ua >= 0.0 && ua <= 1.0 && ub >= 0.0 && ub <= 1.0;
+    }
+
+    //--------------------------------------------------------calc_orthogonal
+    AGG_INLINE void calc_orthogonal(double thickness,
+                                    double x1, double y1,
+                                    double x2, double y2,
+                                    double* x, double* y)
+    {
+        double dx = x2 - x1;
+        double dy = y2 - y1;
+        double d = sqrt(dx*dx + dy*dy); 
+        *x =  thickness * dy / d;
+        *y = -thickness * dx / d;
+    }
+
+    //--------------------------------------------------------dilate_triangle
+    AGG_INLINE void dilate_triangle(double x1, double y1,
+                                    double x2, double y2,
+                                    double x3, double y3,
+                                    double *x, double* y,
+                                    double d)
+    {
+        double dx1=0.0;
+        double dy1=0.0; 
+        double dx2=0.0;
+        double dy2=0.0; 
+        double dx3=0.0;
+        double dy3=0.0; 
+        double loc = cross_product(x1, y1, x2, y2, x3, y3);
+        if(fabs(loc) > intersection_epsilon)
+        {
+            if(cross_product(x1, y1, x2, y2, x3, y3) > 0.0) 
+            {
+                d = -d;
+            }
+            calc_orthogonal(d, x1, y1, x2, y2, &dx1, &dy1);
+            calc_orthogonal(d, x2, y2, x3, y3, &dx2, &dy2);
+            calc_orthogonal(d, x3, y3, x1, y1, &dx3, &dy3);
+        }
+        *x++ = x1 + dx1;  *y++ = y1 + dy1;
+        *x++ = x2 + dx1;  *y++ = y2 + dy1;
+        *x++ = x2 + dx2;  *y++ = y2 + dy2;
+        *x++ = x3 + dx2;  *y++ = y3 + dy2;
+        *x++ = x3 + dx3;  *y++ = y3 + dy3;
+        *x++ = x1 + dx3;  *y++ = y1 + dy3;
+    }
+
+    //------------------------------------------------------calc_triangle_area
+    AGG_INLINE double calc_triangle_area(double x1, double y1,
+                                         double x2, double y2,
+                                         double x3, double y3)
+    {
+        return (x1*y2 - x2*y1 + x2*y3 - x3*y2 + x3*y1 - x1*y3) * 0.5;
+    }
+
+    //-------------------------------------------------------calc_polygon_area
+    template<class Storage> double calc_polygon_area(const Storage& st)
+    {
+        unsigned i;
+        double sum = 0.0;
+        double x  = st[0].x;
+        double y  = st[0].y;
+        double xs = x;
+        double ys = y;
+
+        for(i = 1; i < st.size(); i++)
+        {
+            const typename Storage::value_type& v = st[i];
+            sum += x * v.y - y * v.x;
+            x = v.x;
+            y = v.y;
+        }
+        return (sum + x * ys - y * xs) * 0.5;
+    }
+
+    //------------------------------------------------------------------------
+    // Tables for fast sqrt
+    extern int16u g_sqrt_table[1024];
+    extern int8   g_elder_bit_table[256];
+
+
+    //---------------------------------------------------------------fast_sqrt
+    //Fast integer Sqrt - really fast: no cycles, divisions or multiplications
+    #if defined(_MSC_VER)
+    #pragma warning(push)
+    #pragma warning(disable : 4035) //Disable warning "no return value"
+    #endif
+    AGG_INLINE unsigned fast_sqrt(unsigned val)
+    {
+    #if defined(_M_IX86) && defined(_MSC_VER) && !defined(AGG_NO_ASM)
+        //For Ix86 family processors this assembler code is used. 
+        //The key command here is bsr - determination the number of the most 
+        //significant bit of the value. For other processors
+        //(and maybe compilers) the pure C "#else" section is used.
+        __asm
+        {
+            mov ebx, val
+            mov edx, 11
+            bsr ecx, ebx
+            sub ecx, 9
+            jle less_than_9_bits
+            shr ecx, 1
+            adc ecx, 0
+            sub edx, ecx
+            shl ecx, 1
+            shr ebx, cl
+    less_than_9_bits:
+            xor eax, eax
+            mov  ax, g_sqrt_table[ebx*2]
+            mov ecx, edx
+            shr eax, cl
+        }
+    #else
+
+        //This code is actually pure C and portable to most 
+        //arcitectures including 64bit ones. 
+        unsigned t = val;
+        int bit=0;
+        unsigned shift = 11;
+
+        //The following piece of code is just an emulation of the
+        //Ix86 assembler command "bsr" (see above). However on old
+        //Intels (like Intel MMX 233MHz) this code is about twice 
+        //faster (sic!) then just one "bsr". On PIII and PIV the
+        //bsr is optimized quite well.
+        bit = t >> 24;
+        if(bit)
+        {
+            bit = g_elder_bit_table[bit] + 24;
+        }
+        else
+        {
+            bit = (t >> 16) & 0xFF;
+            if(bit)
+            {
+                bit = g_elder_bit_table[bit] + 16;
+            }
+            else
+            {
+                bit = (t >> 8) & 0xFF;
+                if(bit)
+                {
+                    bit = g_elder_bit_table[bit] + 8;
+                }
+                else
+                {
+                    bit = g_elder_bit_table[t];
+                }
+            }
+        }
+
+        //This code calculates the sqrt.
+        bit -= 9;
+        if(bit > 0)
+        {
+            bit = (bit >> 1) + (bit & 1);
+            shift -= bit;
+            val >>= (bit << 1);
+        }
+        return g_sqrt_table[val] >> shift;
+    #endif
+    }
+    #if defined(_MSC_VER)
+    #pragma warning(pop)
+    #endif
+
+
+
+
+    //--------------------------------------------------------------------besj
+    // Function BESJ calculates Bessel function of first kind of order n
+    // Arguments:
+    //     n - an integer (>=0), the order
+    //     x - value at which the Bessel function is required
+    //--------------------
+    // C++ Mathematical Library
+    // Convereted from equivalent FORTRAN library
+    // Converetd by Gareth Walker for use by course 392 computational project
+    // All functions tested and yield the same results as the corresponding
+    // FORTRAN versions.
+    //
+    // If you have any problems using these functions please report them to
+    // M.Muldoon@UMIST.ac.uk
+    //
+    // Documentation available on the web
+    // http://www.ma.umist.ac.uk/mrm/Teaching/392/libs/392.html
+    // Version 1.0   8/98
+    // 29 October, 1999
+    //--------------------
+    // Adapted for use in AGG library by Andy Wilk (castor.vulgaris@gmail.com)
+    //------------------------------------------------------------------------
+    inline double besj(double x, int n)
+    {
+        if(n < 0)
+        {
+            return 0;
+        }
+        double d = 1E-6;
+        double b = 0;
+        if(fabs(x) <= d) 
+        {
+            if(n != 0) return 0;
+            return 1;
+        }
+        double b1 = 0; // b1 is the value from the previous iteration
+        // Set up a starting order for recurrence
+        int m1 = (int)fabs(x) + 6;
+        if(fabs(x) > 5) 
+        {
+            m1 = (int)(fabs(1.4 * x + 60 / x));
+        }
+        int m2 = (int)(n + 2 + fabs(x) / 4);
+        if (m1 > m2) 
+        {
+            m2 = m1;
+        }
+    
+        // Apply recurrence down from curent max order
+        for(;;) 
+        {
+            double c3 = 0;
+            double c2 = 1E-30;
+            double c4 = 0;
+            int m8 = 1;
+            if (m2 / 2 * 2 == m2) 
+            {
+                m8 = -1;
+            }
+            int imax = m2 - 2;
+            for (int i = 1; i <= imax; i++) 
+            {
+                double c6 = 2 * (m2 - i) * c2 / x - c3;
+                c3 = c2;
+                c2 = c6;
+                if(m2 - i - 1 == n)
+                {
+                    b = c6;
+                }
+                m8 = -1 * m8;
+                if (m8 > 0)
+                {
+                    c4 = c4 + 2 * c6;
+                }
+            }
+            double c6 = 2 * c2 / x - c3;
+            if(n == 0)
+            {
+                b = c6;
+            }
+            c4 += c6;
+            b /= c4;
+            if(fabs(b - b1) < d)
+            {
+                return b;
+            }
+            b1 = b;
+            m2 += 3;
+        }
+    }
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_math_stroke.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_math_stroke.h
--- 8.0.1-5/src/renderers/agg/include/agg_math_stroke.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_math_stroke.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,526 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Stroke math
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_STROKE_MATH_INCLUDED
+#define AGG_STROKE_MATH_INCLUDED
+
+#include "agg_math.h"
+#include "agg_vertex_sequence.h"
+
+namespace mapserver
+{
+    //-------------------------------------------------------------line_cap_e
+    enum line_cap_e
+    {
+        butt_cap,
+        square_cap,
+        round_cap
+    };
+
+    //------------------------------------------------------------line_join_e
+    enum line_join_e
+    {
+        miter_join         = 0,
+        miter_join_revert  = 1,
+        round_join         = 2,
+        bevel_join         = 3,
+        miter_join_round   = 4
+    };
+
+
+    //-----------------------------------------------------------inner_join_e
+    enum inner_join_e
+    {
+        inner_bevel,
+        inner_miter,
+        inner_jag,
+        inner_round
+    };
+
+    //------------------------------------------------------------math_stroke
+    template<class VertexConsumer> class math_stroke
+    {
+    public:
+        typedef typename VertexConsumer::value_type coord_type;
+
+        math_stroke();
+
+        void line_cap(line_cap_e lc)     { m_line_cap = lc; }
+        void line_join(line_join_e lj)   { m_line_join = lj; }
+        void inner_join(inner_join_e ij) { m_inner_join = ij; }
+
+        line_cap_e   line_cap()   const { return m_line_cap; }
+        line_join_e  line_join()  const { return m_line_join; }
+        inner_join_e inner_join() const { return m_inner_join; }
+
+        void width(double w);
+        void miter_limit(double ml) { m_miter_limit = ml; }
+        void miter_limit_theta(double t);
+        void inner_miter_limit(double ml) { m_inner_miter_limit = ml; }
+        void approximation_scale(double as) { m_approx_scale = as; }
+
+        double width() const { return m_width * 2.0; }
+        double miter_limit() const { return m_miter_limit; }
+        double inner_miter_limit() const { return m_inner_miter_limit; }
+        double approximation_scale() const { return m_approx_scale; }
+
+        void calc_cap(VertexConsumer& vc,
+                      const vertex_dist& v0, 
+                      const vertex_dist& v1, 
+                      double len);
+
+        void calc_join(VertexConsumer& vc,
+                       const vertex_dist& v0, 
+                       const vertex_dist& v1, 
+                       const vertex_dist& v2,
+                       double len1, 
+                       double len2);
+
+    private:
+        AGG_INLINE void add_vertex(VertexConsumer& vc, double x, double y)
+        {
+            vc.add(coord_type(x, y));
+        }
+
+        void calc_arc(VertexConsumer& vc,
+                      double x,   double y, 
+                      double dx1, double dy1, 
+                      double dx2, double dy2);
+
+        void calc_miter(VertexConsumer& vc,
+                        const vertex_dist& v0, 
+                        const vertex_dist& v1, 
+                        const vertex_dist& v2,
+                        double dx1, double dy1, 
+                        double dx2, double dy2,
+                        line_join_e lj,
+                        double mlimit,
+                        double dbevel);
+
+        double       m_width;
+        double       m_width_abs;
+        double       m_width_eps;
+        int          m_width_sign;
+        double       m_miter_limit;
+        double       m_inner_miter_limit;
+        double       m_approx_scale;
+        line_cap_e   m_line_cap;
+        line_join_e  m_line_join;
+        inner_join_e m_inner_join;
+    };
+
+    //-----------------------------------------------------------------------
+    template<class VC> math_stroke<VC>::math_stroke() :
+        m_width(0.5),
+        m_width_abs(0.5),
+        m_width_eps(0.5/1024.0),
+        m_width_sign(1),
+        m_miter_limit(4.0),
+        m_inner_miter_limit(1.01),
+        m_approx_scale(1.0),
+        m_line_cap(butt_cap),
+        m_line_join(miter_join),
+        m_inner_join(inner_miter)
+    {
+    }
+
+    //-----------------------------------------------------------------------
+    template<class VC> void math_stroke<VC>::width(double w)
+    { 
+        m_width = w * 0.5; 
+        if(m_width < 0)
+        {
+            m_width_abs  = -m_width;
+            m_width_sign = -1;
+        }
+        else
+        {
+            m_width_abs  = m_width;
+            m_width_sign = 1;
+        }
+        m_width_eps = m_width / 1024.0;
+    }
+
+    //-----------------------------------------------------------------------
+    template<class VC> void math_stroke<VC>::miter_limit_theta(double t)
+    { 
+        m_miter_limit = 1.0 / sin(t * 0.5) ;
+    }
+
+    //-----------------------------------------------------------------------
+    template<class VC> 
+    void math_stroke<VC>::calc_arc(VC& vc,
+                                   double x,   double y, 
+                                   double dx1, double dy1, 
+                                   double dx2, double dy2)
+    {
+        double a1 = atan2(dy1 * m_width_sign, dx1 * m_width_sign);
+        double a2 = atan2(dy2 * m_width_sign, dx2 * m_width_sign);
+        double da = a1 - a2;
+        int i, n;
+
+        da = acos(m_width_abs / (m_width_abs + 0.125 / m_approx_scale)) * 2;
+
+        add_vertex(vc, x + dx1, y + dy1);
+        if(m_width_sign > 0)
+        {
+            if(a1 > a2) a2 += 2 * pi;
+            n = int((a2 - a1) / da);
+            da = (a2 - a1) / (n + 1);
+            a1 += da;
+            for(i = 0; i < n; i++)
+            {
+                add_vertex(vc, x + cos(a1) * m_width, y + sin(a1) * m_width);
+                a1 += da;
+            }
+        }
+        else
+        {
+            if(a1 < a2) a2 -= 2 * pi;
+            n = int((a1 - a2) / da);
+            da = (a1 - a2) / (n + 1);
+            a1 -= da;
+            for(i = 0; i < n; i++)
+            {
+                add_vertex(vc, x + cos(a1) * m_width, y + sin(a1) * m_width);
+                a1 -= da;
+            }
+        }
+        add_vertex(vc, x + dx2, y + dy2);
+    }
+
+    //-----------------------------------------------------------------------
+    template<class VC> 
+    void math_stroke<VC>::calc_miter(VC& vc,
+                                     const vertex_dist& v0, 
+                                     const vertex_dist& v1, 
+                                     const vertex_dist& v2,
+                                     double dx1, double dy1, 
+                                     double dx2, double dy2,
+                                     line_join_e lj,
+                                     double mlimit,
+                                     double dbevel)
+    {
+        double xi  = v1.x;
+        double yi  = v1.y;
+        double di  = 1;
+        double lim = m_width_abs * mlimit;
+        bool miter_limit_exceeded = true; // Assume the worst
+        bool intersection_failed  = true; // Assume the worst
+
+        if(calc_intersection(v0.x + dx1, v0.y - dy1,
+                             v1.x + dx1, v1.y - dy1,
+                             v1.x + dx2, v1.y - dy2,
+                             v2.x + dx2, v2.y - dy2,
+                             &xi, &yi))
+        {
+            // Calculation of the intersection succeeded
+            //---------------------
+            di = calc_distance(v1.x, v1.y, xi, yi);
+            if(di <= lim)
+            {
+                // Inside the miter limit
+                //---------------------
+                add_vertex(vc, xi, yi);
+                miter_limit_exceeded = false;
+            }
+            intersection_failed = false;
+        }
+        else
+        {
+            // Calculation of the intersection failed, most probably
+            // the three points lie one straight line. 
+            // First check if v0 and v2 lie on the opposite sides of vector: 
+            // (v1.x, v1.y) -> (v1.x+dx1, v1.y-dy1), that is, the perpendicular
+            // to the line determined by vertices v0 and v1.
+            // This condition determines whether the next line segments continues
+            // the previous one or goes back.
+            //----------------
+            double x2 = v1.x + dx1;
+            double y2 = v1.y - dy1;
+            if((cross_product(v0.x, v0.y, v1.x, v1.y, x2, y2) < 0.0) == 
+               (cross_product(v1.x, v1.y, v2.x, v2.y, x2, y2) < 0.0))
+            {
+                // This case means that the next segment continues 
+                // the previous one (straight line)
+                //-----------------
+                add_vertex(vc, v1.x + dx1, v1.y - dy1);
+                miter_limit_exceeded = false;
+            }
+        }
+
+        if(miter_limit_exceeded)
+        {
+            // Miter limit exceeded
+            //------------------------
+            switch(lj)
+            {
+            case miter_join_revert:
+                // For the compatibility with SVG, PDF, etc, 
+                // we use a simple bevel join instead of
+                // "smart" bevel
+                //-------------------
+                add_vertex(vc, v1.x + dx1, v1.y - dy1);
+                add_vertex(vc, v1.x + dx2, v1.y - dy2);
+                break;
+
+            case miter_join_round:
+                calc_arc(vc, v1.x, v1.y, dx1, -dy1, dx2, -dy2);
+                break;
+
+            default:
+                // If no miter-revert, calculate new dx1, dy1, dx2, dy2
+                //----------------
+                if(intersection_failed)
+                {
+                    mlimit *= m_width_sign;
+                    add_vertex(vc, v1.x + dx1 + dy1 * mlimit, 
+                                   v1.y - dy1 + dx1 * mlimit);
+                    add_vertex(vc, v1.x + dx2 - dy2 * mlimit, 
+                                   v1.y - dy2 - dx2 * mlimit);
+                }
+                else
+                {
+                    double x1 = v1.x + dx1;
+                    double y1 = v1.y - dy1;
+                    double x2 = v1.x + dx2;
+                    double y2 = v1.y - dy2;
+                    di = (lim - dbevel) / (di - dbevel);
+                    add_vertex(vc, x1 + (xi - x1) * di, 
+                                   y1 + (yi - y1) * di);
+                    add_vertex(vc, x2 + (xi - x2) * di, 
+                                   y2 + (yi - y2) * di);
+                }
+                break;
+            }
+        }
+    }
+
+    //--------------------------------------------------------stroke_calc_cap
+    template<class VC> 
+    void math_stroke<VC>::calc_cap(VC& vc,
+                                   const vertex_dist& v0, 
+                                   const vertex_dist& v1, 
+                                   double len)
+    {
+        vc.remove_all();
+
+        double dx1 = (v1.y - v0.y) / len;
+        double dy1 = (v1.x - v0.x) / len;
+        double dx2 = 0;
+        double dy2 = 0;
+
+        dx1 *= m_width;
+        dy1 *= m_width;
+
+        if(m_line_cap != round_cap)
+        {
+            if(m_line_cap == square_cap)
+            {
+                dx2 = dy1 * m_width_sign;
+                dy2 = dx1 * m_width_sign;
+            }
+            add_vertex(vc, v0.x - dx1 - dx2, v0.y + dy1 - dy2);
+            add_vertex(vc, v0.x + dx1 - dx2, v0.y - dy1 - dy2);
+        }
+        else
+        {
+            double da = acos(m_width_abs / (m_width_abs + 0.125 / m_approx_scale)) * 2;
+            double a1;
+            int i;
+            int n = int(pi / da);
+
+            da = pi / (n + 1);
+            add_vertex(vc, v0.x - dx1, v0.y + dy1);
+            if(m_width_sign > 0)
+            {
+                a1 = atan2(dy1, -dx1);
+                a1 += da;
+                for(i = 0; i < n; i++)
+                {
+                    add_vertex(vc, v0.x + cos(a1) * m_width, 
+                                   v0.y + sin(a1) * m_width);
+                    a1 += da;
+                }
+            }
+            else
+            {
+                a1 = atan2(-dy1, dx1);
+                a1 -= da;
+                for(i = 0; i < n; i++)
+                {
+                    add_vertex(vc, v0.x + cos(a1) * m_width, 
+                                   v0.y + sin(a1) * m_width);
+                    a1 -= da;
+                }
+            }
+            add_vertex(vc, v0.x + dx1, v0.y - dy1);
+        }
+    }
+
+    //-----------------------------------------------------------------------
+    template<class VC> 
+    void math_stroke<VC>::calc_join(VC& vc,
+                                    const vertex_dist& v0, 
+                                    const vertex_dist& v1, 
+                                    const vertex_dist& v2,
+                                    double len1, 
+                                    double len2)
+    {
+        double dx1 = m_width * (v1.y - v0.y) / len1;
+        double dy1 = m_width * (v1.x - v0.x) / len1;
+        double dx2 = m_width * (v2.y - v1.y) / len2;
+        double dy2 = m_width * (v2.x - v1.x) / len2;
+
+        vc.remove_all();
+
+        double cp = cross_product(v0.x, v0.y, v1.x, v1.y, v2.x, v2.y);
+        if(cp != 0 && (cp > 0) == (m_width > 0))
+        {
+            // Inner join
+            //---------------
+            double limit = ((len1 < len2) ? len1 : len2) / m_width_abs;
+            if(limit < m_inner_miter_limit)
+            {
+                limit = m_inner_miter_limit;
+            }
+
+            switch(m_inner_join)
+            {
+            default: // inner_bevel
+                add_vertex(vc, v1.x + dx1, v1.y - dy1);
+                add_vertex(vc, v1.x + dx2, v1.y - dy2);
+                break;
+
+            case inner_miter:
+                calc_miter(vc,
+                           v0, v1, v2, dx1, dy1, dx2, dy2, 
+                           miter_join_revert, 
+                           limit, 0);
+                break;
+
+            case inner_jag:
+            case inner_round:
+                cp = (dx1-dx2) * (dx1-dx2) + (dy1-dy2) * (dy1-dy2);
+                if(cp < len1 * len1 && cp < len2 * len2)
+                {
+                    calc_miter(vc,
+                               v0, v1, v2, dx1, dy1, dx2, dy2, 
+                               miter_join_revert, 
+                               limit, 0);
+                }
+                else
+                {
+                    if(m_inner_join == inner_jag)
+                    {
+                        add_vertex(vc, v1.x + dx1, v1.y - dy1);
+                        add_vertex(vc, v1.x,       v1.y      );
+                        add_vertex(vc, v1.x + dx2, v1.y - dy2);
+                    }
+                    else
+                    {
+                        add_vertex(vc, v1.x + dx1, v1.y - dy1);
+                        add_vertex(vc, v1.x,       v1.y      );
+                        calc_arc(vc, v1.x, v1.y, dx2, -dy2, dx1, -dy1);
+                        add_vertex(vc, v1.x,       v1.y      );
+                        add_vertex(vc, v1.x + dx2, v1.y - dy2);
+                    }
+                }
+                break;
+            }
+        }
+        else
+        {
+            // Outer join
+            //---------------
+
+            // Calculate the distance between v1 and 
+            // the central point of the bevel line segment
+            //---------------
+            double dx = (dx1 + dx2) / 2;
+            double dy = (dy1 + dy2) / 2;
+            double dbevel = sqrt(dx * dx + dy * dy);
+
+            if(m_line_join == round_join || m_line_join == bevel_join)
+            {
+                // This is an optimization that reduces the number of points 
+                // in cases of almost collinear segments. If there's no
+                // visible difference between bevel and miter joins we'd rather
+                // use miter join because it adds only one point instead of two. 
+                //
+                // Here we calculate the middle point between the bevel points 
+                // and then, the distance between v1 and this middle point. 
+                // At outer joins this distance always less than stroke width, 
+                // because it's actually the height of an isosceles triangle of
+                // v1 and its two bevel points. If the difference between this
+                // width and this value is small (no visible bevel) we can 
+                // add just one point. 
+                //
+                // The constant in the expression makes the result approximately 
+                // the same as in round joins and caps. You can safely comment 
+                // out this entire "if".
+                //-------------------
+                if(m_approx_scale * (m_width_abs - dbevel) < m_width_eps)
+                {
+                    if(calc_intersection(v0.x + dx1, v0.y - dy1,
+                                         v1.x + dx1, v1.y - dy1,
+                                         v1.x + dx2, v1.y - dy2,
+                                         v2.x + dx2, v2.y - dy2,
+                                         &dx, &dy))
+                    {
+                        add_vertex(vc, dx, dy);
+                    }
+                    else
+                    {
+                        add_vertex(vc, v1.x + dx1, v1.y - dy1);
+                    }
+                    return;
+                }
+            }
+
+            switch(m_line_join)
+            {
+            case miter_join:
+            case miter_join_revert:
+            case miter_join_round:
+                calc_miter(vc, 
+                           v0, v1, v2, dx1, dy1, dx2, dy2, 
+                           m_line_join, 
+                           m_miter_limit,
+                           dbevel);
+                break;
+
+            case round_join:
+                calc_arc(vc, v1.x, v1.y, dx1, -dy1, dx2, -dy2);
+                break;
+
+            default: // Bevel join
+                add_vertex(vc, v1.x + dx1, v1.y - dy1);
+                add_vertex(vc, v1.x + dx2, v1.y - dy2);
+                break;
+            }
+        }
+    }
+
+
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_path_length.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_path_length.h
--- 8.0.1-5/src/renderers/agg/include/agg_path_length.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_path_length.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,65 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_PATH_LENGTH_INCLUDED
+#define AGG_PATH_LENGTH_INCLUDED
+
+#include "agg_math.h"
+
+namespace mapserver
+{
+    template<class VertexSource> 
+    double path_length(VertexSource& vs, unsigned path_id = 0)
+    {
+        double len = 0.0;
+        double start_x = 0.0;
+        double start_y = 0.0;
+        double x1 = 0.0;
+        double y1 = 0.0;
+        double x2 = 0.0;
+        double y2 = 0.0;
+        bool first = true;
+
+        unsigned cmd;
+        vs.rewind(path_id);
+        while(!is_stop(cmd = vs.vertex(&x2, &y2)))
+        {
+            if(is_vertex(cmd))
+            {
+                if(first || is_move_to(cmd))
+                {
+                    start_x = x2;
+                    start_y = y2;
+                }
+                else
+                {
+                    len += calc_distance(x1, y1, x2, y2);
+                }
+                x1 = x2;
+                y1 = y2;
+                first = false;
+            }
+            else
+            {
+                if(is_close(cmd) && !first)
+                {
+                    len += calc_distance(x1, y1, start_x, start_y);
+                }
+            }
+        }
+        return len;
+    }
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_path_storage.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_path_storage.h
--- 8.0.1-5/src/renderers/agg/include/agg_path_storage.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_path_storage.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1551 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PATH_STORAGE_INCLUDED
+#define AGG_PATH_STORAGE_INCLUDED
+
+#include <cassert>
+#include <string.h>
+#include <math.h>
+#include "agg_math.h"
+#include "agg_array.h"
+#include "agg_bezier_arc.h"
+
+namespace mapserver
+{
+
+
+    //----------------------------------------------------vertex_block_storage
+    template<class T, unsigned BlockShift=8, unsigned BlockPool=256>
+    class vertex_block_storage
+    {
+    public:
+        // Allocation parameters
+        enum block_scale_e
+        {
+            block_shift = BlockShift,
+            block_size  = 1 << block_shift,
+            block_mask  = block_size - 1,
+            block_pool  = BlockPool
+        };
+
+        typedef T value_type;
+        typedef vertex_block_storage<T, BlockShift, BlockPool> self_type;
+
+        ~vertex_block_storage();
+        vertex_block_storage();
+        vertex_block_storage(const self_type& v);
+        const self_type& operator = (const self_type& ps);
+
+        void remove_all();
+        void free_all();
+
+        void add_vertex(double x, double y, unsigned cmd);
+        void modify_vertex(unsigned idx, double x, double y);
+        void modify_vertex(unsigned idx, double x, double y, unsigned cmd);
+        void modify_command(unsigned idx, unsigned cmd);
+        void swap_vertices(unsigned v1, unsigned v2);
+
+        unsigned last_command() const;
+        unsigned last_vertex(double* x, double* y) const;
+        unsigned prev_vertex(double* x, double* y) const;
+
+        double last_x() const;
+        double last_y() const;
+
+        unsigned total_vertices() const;
+        unsigned vertex(unsigned idx, double* x, double* y) const;
+        unsigned command(unsigned idx) const;
+
+    private:
+        void   allocate_block(unsigned nb);
+        int8u* storage_ptrs(T** xy_ptr);
+
+    private:
+        unsigned m_total_vertices;
+        unsigned m_total_blocks;
+        unsigned m_max_blocks;
+        T**      m_coord_blocks;
+        int8u**  m_cmd_blocks;
+    };
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    void vertex_block_storage<T,S,P>::free_all()
+    {
+        if(m_total_blocks)
+        {
+            T** coord_blk = m_coord_blocks + m_total_blocks - 1;
+            while(m_total_blocks--)
+            {
+                pod_allocator<T>::deallocate(
+                    *coord_blk,
+                    block_size * 2 + 
+                    block_size / (sizeof(T) / sizeof(unsigned char)));
+                --coord_blk;
+            }
+            pod_allocator<T*>::deallocate(m_coord_blocks, m_max_blocks * 2);
+            m_total_blocks   = 0;
+            m_max_blocks     = 0;
+            m_coord_blocks   = 0;
+            m_cmd_blocks     = 0;
+            m_total_vertices = 0;
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    vertex_block_storage<T,S,P>::~vertex_block_storage()
+    {
+        free_all();
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    vertex_block_storage<T,S,P>::vertex_block_storage() :
+        m_total_vertices(0),
+        m_total_blocks(0),
+        m_max_blocks(0),
+        m_coord_blocks(0),
+        m_cmd_blocks(0)
+    {
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    vertex_block_storage<T,S,P>::vertex_block_storage(const vertex_block_storage<T,S,P>& v) :
+        m_total_vertices(0),
+        m_total_blocks(0),
+        m_max_blocks(0),
+        m_coord_blocks(0),
+        m_cmd_blocks(0)
+    {
+        *this = v;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    const vertex_block_storage<T,S,P>& 
+    vertex_block_storage<T,S,P>::operator = (const vertex_block_storage<T,S,P>& v)
+    {
+        remove_all();
+        unsigned i;
+        for(i = 0; i < v.total_vertices(); i++)
+        {
+            double x, y;
+            unsigned cmd = v.vertex(i, &x, &y);
+            add_vertex(x, y, cmd);
+        }
+	    return *this;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline void vertex_block_storage<T,S,P>::remove_all()
+    {
+        m_total_vertices = 0;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline void vertex_block_storage<T,S,P>::add_vertex(double x, double y, 
+                                                        unsigned cmd)
+    {
+        T* coord_ptr = 0;
+        *storage_ptrs(&coord_ptr) = (int8u)cmd;
+        coord_ptr[0] = T(x);
+        coord_ptr[1] = T(y);
+        m_total_vertices++;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline void vertex_block_storage<T,S,P>::modify_vertex(unsigned idx, 
+                                                           double x, double y)
+    {
+        T* pv = m_coord_blocks[idx >> block_shift] + ((idx & block_mask) << 1);
+        pv[0] = T(x);
+        pv[1] = T(y);
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline void vertex_block_storage<T,S,P>::modify_vertex(unsigned idx, 
+                                                           double x, double y, 
+                                                           unsigned cmd)
+    {
+        unsigned block = idx >> block_shift;
+        unsigned offset = idx & block_mask;
+        T* pv = m_coord_blocks[block] + (offset << 1);
+        pv[0] = T(x);
+        pv[1] = T(y);
+        m_cmd_blocks[block][offset] = (int8u)cmd;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline void vertex_block_storage<T,S,P>::modify_command(unsigned idx, 
+                                                            unsigned cmd)
+    {
+        m_cmd_blocks[idx >> block_shift][idx & block_mask] = (int8u)cmd;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline void vertex_block_storage<T,S,P>::swap_vertices(unsigned v1, unsigned v2)
+    {
+        unsigned b1 = v1 >> block_shift;
+        unsigned b2 = v2 >> block_shift;
+        unsigned o1 = v1 & block_mask;
+        unsigned o2 = v2 & block_mask;
+        T* pv1 = m_coord_blocks[b1] + (o1 << 1);
+        T* pv2 = m_coord_blocks[b2] + (o2 << 1);
+        T  val;
+        val = pv1[0]; pv1[0] = pv2[0]; pv2[0] = val;
+        val = pv1[1]; pv1[1] = pv2[1]; pv2[1] = val;
+        int8u cmd = m_cmd_blocks[b1][o1];
+        m_cmd_blocks[b1][o1] = m_cmd_blocks[b2][o2];
+        m_cmd_blocks[b2][o2] = cmd;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline unsigned vertex_block_storage<T,S,P>::last_command() const
+    {
+        if(m_total_vertices) return command(m_total_vertices - 1);
+        return path_cmd_stop;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline unsigned vertex_block_storage<T,S,P>::last_vertex(double* x, double* y) const
+    {
+        if(m_total_vertices) return vertex(m_total_vertices - 1, x, y);
+        return path_cmd_stop;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline unsigned vertex_block_storage<T,S,P>::prev_vertex(double* x, double* y) const
+    {
+        if(m_total_vertices > 1) return vertex(m_total_vertices - 2, x, y);
+        return path_cmd_stop;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline double vertex_block_storage<T,S,P>::last_x() const
+    {
+        if(m_total_vertices)
+        {
+            unsigned idx = m_total_vertices - 1;
+            return m_coord_blocks[idx >> block_shift][(idx & block_mask) << 1];
+        }
+        return 0.0;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline double vertex_block_storage<T,S,P>::last_y() const
+    {
+        if(m_total_vertices)
+        {
+            unsigned idx = m_total_vertices - 1;
+            return m_coord_blocks[idx >> block_shift][((idx & block_mask) << 1) + 1];
+        }
+        return 0.0;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline unsigned vertex_block_storage<T,S,P>::total_vertices() const
+    {
+        return m_total_vertices;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline unsigned vertex_block_storage<T,S,P>::vertex(unsigned idx, 
+                                                        double* x, double* y) const
+    {
+        unsigned nb = idx >> block_shift;
+        const T* pv = m_coord_blocks[nb] + ((idx & block_mask) << 1);
+        *x = pv[0];
+        *y = pv[1];
+        return m_cmd_blocks[nb][idx & block_mask];
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    inline unsigned vertex_block_storage<T,S,P>::command(unsigned idx) const
+    {
+        return m_cmd_blocks[idx >> block_shift][idx & block_mask];
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    void vertex_block_storage<T,S,P>::allocate_block(unsigned nb)
+    {
+        if(nb >= m_max_blocks) 
+        {
+            T** new_coords = 
+                pod_allocator<T*>::allocate((m_max_blocks + block_pool) * 2);
+
+            unsigned char** new_cmds = 
+                (unsigned char**)(new_coords + m_max_blocks + block_pool);
+
+            if(m_coord_blocks)
+            {
+                memcpy(new_coords, 
+                       m_coord_blocks, 
+                       m_max_blocks * sizeof(T*));
+
+                assert(m_cmd_blocks);
+                memcpy(new_cmds, 
+                       m_cmd_blocks, 
+                       m_max_blocks * sizeof(unsigned char*));
+
+                pod_allocator<T*>::deallocate(m_coord_blocks, m_max_blocks * 2);
+            }
+            m_coord_blocks = new_coords;
+            m_cmd_blocks   = new_cmds;
+            m_max_blocks  += block_pool;
+        }
+        assert(m_coord_blocks);
+        m_coord_blocks[nb] = 
+            pod_allocator<T>::allocate(block_size * 2 + 
+                   block_size / (sizeof(T) / sizeof(unsigned char)));
+
+        assert(m_cmd_blocks);
+        m_cmd_blocks[nb]  = 
+            (unsigned char*)(m_coord_blocks[nb] + block_size * 2);
+
+        m_total_blocks++;
+    }
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S, unsigned P>
+    int8u* vertex_block_storage<T,S,P>::storage_ptrs(T** xy_ptr)
+    {
+        unsigned nb = m_total_vertices >> block_shift;
+        if(nb >= m_total_blocks)
+        {
+            allocate_block(nb);
+        }
+        assert(m_coord_blocks);
+        assert(m_cmd_blocks);
+        *xy_ptr = m_coord_blocks[nb] + ((m_total_vertices & block_mask) << 1);
+        return m_cmd_blocks[nb] + (m_total_vertices & block_mask);
+    }
+
+
+
+
+    //-----------------------------------------------------poly_plain_adaptor
+    template<class T> class poly_plain_adaptor
+    {
+    public:
+        typedef T value_type;
+
+        poly_plain_adaptor() : 
+            m_data(0), 
+            m_ptr(0),
+            m_end(0),
+            m_closed(false),
+            m_stop(false)
+        {}
+
+        poly_plain_adaptor(const T* data, unsigned num_points, bool closed) :
+            m_data(data), 
+            m_ptr(data),
+            m_end(data + num_points * 2),
+            m_closed(closed),
+            m_stop(false)
+        {}
+
+        void init(const T* data, unsigned num_points, bool closed)
+        {
+            m_data = data;
+            m_ptr = data;
+            m_end = data + num_points * 2;
+            m_closed = closed;
+            m_stop = false;
+        }
+
+        void rewind(unsigned)
+        {
+            m_ptr = m_data;
+            m_stop = false;
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_ptr < m_end)
+            {
+                bool first = m_ptr == m_data;
+                *x = *m_ptr++;
+                *y = *m_ptr++;
+                return first ? path_cmd_move_to : path_cmd_line_to;
+            }
+            *x = *y = 0.0;
+            if(m_closed && !m_stop)
+            {
+                m_stop = true;
+                return path_cmd_end_poly | path_flags_close;
+            }
+            return path_cmd_stop;
+        }
+
+    private:
+        const T* m_data;
+        const T* m_ptr;
+        const T* m_end;
+        bool     m_closed;
+        bool     m_stop;
+    };
+
+
+
+
+
+    //-------------------------------------------------poly_container_adaptor
+    template<class Container> class poly_container_adaptor
+    {
+    public:
+        typedef typename Container::value_type vertex_type;
+
+        poly_container_adaptor() : 
+            m_container(0), 
+            m_index(0),
+            m_closed(false),
+            m_stop(false)
+        {}
+
+        poly_container_adaptor(const Container& data, bool closed) :
+            m_container(&data), 
+            m_index(0),
+            m_closed(closed),
+            m_stop(false)
+        {}
+
+        void init(const Container& data, bool closed)
+        {
+            m_container = &data;
+            m_index = 0;
+            m_closed = closed;
+            m_stop = false;
+        }
+
+        void rewind(unsigned)
+        {
+            m_index = 0;
+            m_stop = false;
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_index < m_container->size())
+            {
+                bool first = m_index == 0;
+                const vertex_type& v = (*m_container)[m_index++];
+                *x = v.x;
+                *y = v.y;
+                return first ? path_cmd_move_to : path_cmd_line_to;
+            }
+            *x = *y = 0.0;
+            if(m_closed && !m_stop)
+            {
+                m_stop = true;
+                return path_cmd_end_poly | path_flags_close;
+            }
+            return path_cmd_stop;
+        }
+
+    private:
+        const Container* m_container;
+        unsigned m_index;
+        bool     m_closed;
+        bool     m_stop;
+    };
+
+
+
+    //-----------------------------------------poly_container_reverse_adaptor
+    template<class Container> class poly_container_reverse_adaptor
+    {
+    public:
+        typedef typename Container::value_type vertex_type;
+
+        poly_container_reverse_adaptor() : 
+            m_container(0), 
+            m_index(-1),
+            m_closed(false),
+            m_stop(false)
+        {}
+
+        poly_container_reverse_adaptor(const Container& data, bool closed) :
+            m_container(&data), 
+            m_index(-1),
+            m_closed(closed),
+            m_stop(false)
+        {}
+
+        void init(const Container& data, bool closed)
+        {
+            m_container = &data;
+            m_index = m_container->size() - 1;
+            m_closed = closed;
+            m_stop = false;
+        }
+
+        void rewind(unsigned)
+        {
+            m_index = m_container->size() - 1;
+            m_stop = false;
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_index >= 0)
+            {
+                bool first = m_index == int(m_container->size() - 1);
+                const vertex_type& v = (*m_container)[m_index--];
+                *x = v.x;
+                *y = v.y;
+                return first ? path_cmd_move_to : path_cmd_line_to;
+            }
+            *x = *y = 0.0;
+            if(m_closed && !m_stop)
+            {
+                m_stop = true;
+                return path_cmd_end_poly | path_flags_close;
+            }
+            return path_cmd_stop;
+        }
+
+    private:
+        const Container* m_container;
+        int  m_index;
+        bool m_closed;
+        bool m_stop;
+    };
+
+
+
+
+
+    //--------------------------------------------------------line_adaptor
+    class line_adaptor
+    {
+    public:
+        typedef double value_type;
+
+        line_adaptor() : m_line(m_coord, 2, false) {}
+        line_adaptor(double x1, double y1, double x2, double y2) :
+            m_line(m_coord, 2, false)
+        {
+            m_coord[0] = x1;
+            m_coord[1] = y1;
+            m_coord[2] = x2;
+            m_coord[3] = y2;
+        }
+        
+        void init(double x1, double y1, double x2, double y2)
+        {
+            m_coord[0] = x1;
+            m_coord[1] = y1;
+            m_coord[2] = x2;
+            m_coord[3] = y2;
+            m_line.rewind(0);
+        }
+
+        void rewind(unsigned)
+        {
+            m_line.rewind(0);
+        }
+
+        unsigned vertex(double* x, double* y)
+        {
+            return m_line.vertex(x, y);
+        }
+
+    private:
+        double                     m_coord[4];
+        poly_plain_adaptor<double> m_line;
+    };
+
+
+
+
+
+
+
+
+
+
+
+
+
+    //---------------------------------------------------------------path_base
+    // A container to store vertices with their flags. 
+    // A path consists of a number of contours separated with "move_to" 
+    // commands. The path storage can keep and maintain more than one
+    // path. 
+    // To navigate to the beginning of a particular path, use rewind(path_id);
+    // Where path_id is what start_new_path() returns. So, when you call
+    // start_new_path() you need to store its return value somewhere else
+    // to navigate to the path afterwards.
+    //
+    // See also: vertex_source concept
+    //------------------------------------------------------------------------
+    template<class VertexContainer> class path_base
+    {
+    public:
+        typedef VertexContainer            container_type;
+        typedef path_base<VertexContainer> self_type;
+
+        //--------------------------------------------------------------------
+        path_base() : m_vertices(), m_iterator(0) {}
+        void remove_all() { m_vertices.remove_all(); m_iterator = 0; }
+        void free_all()   { m_vertices.free_all();   m_iterator = 0; }
+
+        // Make path functions
+        //--------------------------------------------------------------------
+        unsigned start_new_path();
+
+        void move_to(double x, double y);
+        void move_rel(double dx, double dy);
+
+        void line_to(double x, double y);
+        void line_rel(double dx, double dy);
+
+        void hline_to(double x);
+        void hline_rel(double dx);
+
+        void vline_to(double y);
+        void vline_rel(double dy);
+
+        void arc_to(double rx, double ry,
+                    double angle,
+                    bool large_arc_flag,
+                    bool sweep_flag,
+                    double x, double y);
+
+        void arc_rel(double rx, double ry,
+                     double angle,
+                     bool large_arc_flag,
+                     bool sweep_flag,
+                     double dx, double dy);
+
+        void curve3(double x_ctrl, double y_ctrl, 
+                    double x_to,   double y_to);
+
+        void curve3_rel(double dx_ctrl, double dy_ctrl, 
+                        double dx_to,   double dy_to);
+
+        void curve3(double x_to, double y_to);
+
+        void curve3_rel(double dx_to, double dy_to);
+
+        void curve4(double x_ctrl1, double y_ctrl1, 
+                    double x_ctrl2, double y_ctrl2, 
+                    double x_to,    double y_to);
+
+        void curve4_rel(double dx_ctrl1, double dy_ctrl1, 
+                        double dx_ctrl2, double dy_ctrl2, 
+                        double dx_to,    double dy_to);
+
+        void curve4(double x_ctrl2, double y_ctrl2, 
+                    double x_to,    double y_to);
+
+        void curve4_rel(double x_ctrl2, double y_ctrl2, 
+                        double x_to,    double y_to);
+
+
+        void end_poly(unsigned flags = path_flags_close);
+        void close_polygon(unsigned flags = path_flags_none);
+
+        // Accessors
+        //--------------------------------------------------------------------
+        const container_type& vertices() const { return m_vertices; } 
+              container_type& vertices()       { return m_vertices; } 
+
+        unsigned total_vertices() const;
+
+        void rel_to_abs(double* x, double* y) const;
+
+        unsigned last_vertex(double* x, double* y) const;
+        unsigned prev_vertex(double* x, double* y) const;
+
+        double last_x() const;
+        double last_y() const;
+
+        unsigned vertex(unsigned idx, double* x, double* y) const;
+        unsigned command(unsigned idx) const;
+
+        void modify_vertex(unsigned idx, double x, double y);
+        void modify_vertex(unsigned idx, double x, double y, unsigned cmd);
+        void modify_command(unsigned idx, unsigned cmd);
+
+        // VertexSource interface
+        //--------------------------------------------------------------------
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+        // Arrange the orientation of a polygon, all polygons in a path, 
+        // or in all paths. After calling arrange_orientations() or 
+        // arrange_orientations_all_paths(), all the polygons will have 
+        // the same orientation, i.e. path_flags_cw or path_flags_ccw
+        //--------------------------------------------------------------------
+        unsigned arrange_polygon_orientation(unsigned start, path_flags_e orientation);
+        unsigned arrange_orientations(unsigned path_id, path_flags_e orientation);
+        void     arrange_orientations_all_paths(path_flags_e orientation);
+        void     invert_polygon(unsigned start);
+
+        // Flip all vertices horizontally or vertically, 
+        // between x1 and x2, or between y1 and y2 respectively
+        //--------------------------------------------------------------------
+        void flip_x(double x1, double x2);
+        void flip_y(double y1, double y2);
+
+        // Concatenate path. The path is added as is.
+        //--------------------------------------------------------------------
+        template<class VertexSource> 
+        void concat_path(VertexSource& vs, unsigned path_id = 0)
+        {
+            double x = 0, y = 0;
+            unsigned cmd;
+            vs.rewind(path_id);
+            while(!is_stop(cmd = vs.vertex(&x, &y)))
+            {
+                m_vertices.add_vertex(x, y, cmd);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        // Join path. The path is joined with the existing one, that is, 
+        // it behaves as if the pen of a plotter was always down (drawing)
+        template<class VertexSource> 
+        void join_path(VertexSource& vs, unsigned path_id = 0)
+        {
+            double x, y;
+            unsigned cmd;
+            vs.rewind(path_id);
+            cmd = vs.vertex(&x, &y);
+            if(!is_stop(cmd))
+            {
+                if(is_vertex(cmd))
+                {
+                    double x0, y0;
+                    unsigned cmd0 = last_vertex(&x0, &y0);
+                    if(is_vertex(cmd0))
+                    {
+                        if(calc_distance(x, y, x0, y0) > vertex_dist_epsilon)
+                        {
+                            if(is_move_to(cmd)) cmd = path_cmd_line_to;
+                            m_vertices.add_vertex(x, y, cmd);
+                        }
+                    }
+                    else
+                    {
+                        if(is_stop(cmd0))
+                        {
+                            cmd = path_cmd_move_to;
+                        }
+                        else
+                        {
+                            if(is_move_to(cmd)) cmd = path_cmd_line_to;
+                        }
+                        m_vertices.add_vertex(x, y, cmd);
+                    }
+                }
+                while(!is_stop(cmd = vs.vertex(&x, &y)))
+                {
+                    m_vertices.add_vertex(x, y, is_move_to(cmd) ? 
+                                                    unsigned(path_cmd_line_to) : 
+                                                    cmd);
+                }
+            }
+        }
+
+        // Concatenate polygon/polyline. 
+        //--------------------------------------------------------------------
+        template<class T> void concat_poly(const T* data, 
+                                           unsigned num_points,
+                                           bool closed)
+        {
+            poly_plain_adaptor<T> poly(data, num_points, closed);
+            concat_path(poly);
+        }
+
+        // Join polygon/polyline continuously.
+        //--------------------------------------------------------------------
+        template<class T> void join_poly(const T* data, 
+                                         unsigned num_points,
+                                         bool closed)
+        {
+            poly_plain_adaptor<T> poly(data, num_points, closed);
+            join_path(poly);
+        }
+
+        //--------------------------------------------------------------------
+        void translate(double dx, double dy, unsigned path_id=0);
+        void translate_all_paths(double dx, double dy);
+
+        //--------------------------------------------------------------------
+        template<class Trans>
+        void transform(const Trans& trans, unsigned path_id=0)
+        {
+            unsigned num_ver = m_vertices.total_vertices();
+            for(; path_id < num_ver; path_id++)
+            {
+                double x, y;
+                unsigned cmd = m_vertices.vertex(path_id, &x, &y);
+                if(is_stop(cmd)) break;
+                if(is_vertex(cmd))
+                {
+                    trans.transform(&x, &y);
+                    m_vertices.modify_vertex(path_id, x, y);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class Trans>
+        void transform_all_paths(const Trans& trans)
+        {
+            unsigned idx;
+            unsigned num_ver = m_vertices.total_vertices();
+            for(idx = 0; idx < num_ver; idx++)
+            {
+                double x, y;
+                if(is_vertex(m_vertices.vertex(idx, &x, &y)))
+                {
+                    trans.transform(&x, &y);
+                    m_vertices.modify_vertex(idx, x, y);
+                }
+            }
+        }
+
+
+
+    private:
+        unsigned perceive_polygon_orientation(unsigned start, unsigned end);
+        void     invert_polygon(unsigned start, unsigned end);
+
+        VertexContainer m_vertices;
+        unsigned        m_iterator;
+    };
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    unsigned path_base<VC>::start_new_path()
+    {
+        if(!is_stop(m_vertices.last_command()))
+        {
+            m_vertices.add_vertex(0.0, 0.0, path_cmd_stop);
+        }
+        return m_vertices.total_vertices();
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::rel_to_abs(double* x, double* y) const
+    {
+        if(m_vertices.total_vertices())
+        {
+            double x2;
+            double y2;
+            if(is_vertex(m_vertices.last_vertex(&x2, &y2)))
+            {
+                *x += x2;
+                *y += y2;
+            }
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::move_to(double x, double y)
+    {
+        m_vertices.add_vertex(x, y, path_cmd_move_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::move_rel(double dx, double dy)
+    {
+        rel_to_abs(&dx, &dy);
+        m_vertices.add_vertex(dx, dy, path_cmd_move_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::line_to(double x, double y)
+    {
+        m_vertices.add_vertex(x, y, path_cmd_line_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::line_rel(double dx, double dy)
+    {
+        rel_to_abs(&dx, &dy);
+        m_vertices.add_vertex(dx, dy, path_cmd_line_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::hline_to(double x)
+    {
+        m_vertices.add_vertex(x, last_y(), path_cmd_line_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::hline_rel(double dx)
+    {
+        double dy = 0;
+        rel_to_abs(&dx, &dy);
+        m_vertices.add_vertex(dx, dy, path_cmd_line_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::vline_to(double y)
+    {
+        m_vertices.add_vertex(last_x(), y, path_cmd_line_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::vline_rel(double dy)
+    {
+        double dx = 0;
+        rel_to_abs(&dx, &dy);
+        m_vertices.add_vertex(dx, dy, path_cmd_line_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::arc_to(double rx, double ry,
+                               double angle,
+                               bool large_arc_flag,
+                               bool sweep_flag,
+                               double x, double y)
+    {
+        if(m_vertices.total_vertices() && is_vertex(m_vertices.last_command()))
+        {
+            const double epsilon = 1e-30;
+            double x0 = 0.0;
+            double y0 = 0.0;
+            m_vertices.last_vertex(&x0, &y0);
+
+            rx = fabs(rx);
+            ry = fabs(ry);
+
+            // Ensure radii are valid
+            //-------------------------
+            if(rx < epsilon || ry < epsilon) 
+            {
+                line_to(x, y);
+                return;
+            }
+
+            if(calc_distance(x0, y0, x, y) < epsilon)
+            {
+                // If the endpoints (x, y) and (x0, y0) are identical, then this
+                // is equivalent to omitting the elliptical arc segment entirely.
+                return;
+            }
+            bezier_arc_svg a(x0, y0, rx, ry, angle, large_arc_flag, sweep_flag, x, y);
+            if(a.radii_ok())
+            {
+                join_path(a);
+            }
+            else
+            {
+                line_to(x, y);
+            }
+        }
+        else
+        {
+            move_to(x, y);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::arc_rel(double rx, double ry,
+                                double angle,
+                                bool large_arc_flag,
+                                bool sweep_flag,
+                                double dx, double dy)
+    {
+        rel_to_abs(&dx, &dy);
+        arc_to(rx, ry, angle, large_arc_flag, sweep_flag, dx, dy);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve3(double x_ctrl, double y_ctrl, 
+                               double x_to,   double y_to)
+    {
+        m_vertices.add_vertex(x_ctrl, y_ctrl, path_cmd_curve3);
+        m_vertices.add_vertex(x_to,   y_to,   path_cmd_curve3);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve3_rel(double dx_ctrl, double dy_ctrl, 
+                                   double dx_to,   double dy_to)
+    {
+        rel_to_abs(&dx_ctrl, &dy_ctrl);
+        rel_to_abs(&dx_to,   &dy_to);
+        m_vertices.add_vertex(dx_ctrl, dy_ctrl, path_cmd_curve3);
+        m_vertices.add_vertex(dx_to,   dy_to,   path_cmd_curve3);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve3(double x_to, double y_to)
+    {
+        double x0;
+        double y0;
+        if(is_vertex(m_vertices.last_vertex(&x0, &y0)))
+        {
+            double x_ctrl;
+            double y_ctrl; 
+            unsigned cmd = m_vertices.prev_vertex(&x_ctrl, &y_ctrl);
+            if(is_curve(cmd))
+            {
+                x_ctrl = x0 + x0 - x_ctrl;
+                y_ctrl = y0 + y0 - y_ctrl;
+            }
+            else
+            {
+                x_ctrl = x0;
+                y_ctrl = y0;
+            }
+            curve3(x_ctrl, y_ctrl, x_to, y_to);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve3_rel(double dx_to, double dy_to)
+    {
+        rel_to_abs(&dx_to, &dy_to);
+        curve3(dx_to, dy_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve4(double x_ctrl1, double y_ctrl1, 
+                               double x_ctrl2, double y_ctrl2, 
+                               double x_to,    double y_to)
+    {
+        m_vertices.add_vertex(x_ctrl1, y_ctrl1, path_cmd_curve4);
+        m_vertices.add_vertex(x_ctrl2, y_ctrl2, path_cmd_curve4);
+        m_vertices.add_vertex(x_to,    y_to,    path_cmd_curve4);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve4_rel(double dx_ctrl1, double dy_ctrl1, 
+                                   double dx_ctrl2, double dy_ctrl2, 
+                                   double dx_to,    double dy_to)
+    {
+        rel_to_abs(&dx_ctrl1, &dy_ctrl1);
+        rel_to_abs(&dx_ctrl2, &dy_ctrl2);
+        rel_to_abs(&dx_to,    &dy_to);
+        m_vertices.add_vertex(dx_ctrl1, dy_ctrl1, path_cmd_curve4);
+        m_vertices.add_vertex(dx_ctrl2, dy_ctrl2, path_cmd_curve4);
+        m_vertices.add_vertex(dx_to,    dy_to,    path_cmd_curve4);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve4(double x_ctrl2, double y_ctrl2, 
+                               double x_to,    double y_to)
+    {
+        double x0;
+        double y0;
+        if(is_vertex(last_vertex(&x0, &y0)))
+        {
+            double x_ctrl1;
+            double y_ctrl1; 
+            unsigned cmd = prev_vertex(&x_ctrl1, &y_ctrl1);
+            if(is_curve(cmd))
+            {
+                x_ctrl1 = x0 + x0 - x_ctrl1;
+                y_ctrl1 = y0 + y0 - y_ctrl1;
+            }
+            else
+            {
+                x_ctrl1 = x0;
+                y_ctrl1 = y0;
+            }
+            curve4(x_ctrl1, y_ctrl1, x_ctrl2, y_ctrl2, x_to, y_to);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::curve4_rel(double dx_ctrl2, double dy_ctrl2, 
+                                   double dx_to,    double dy_to)
+    {
+        rel_to_abs(&dx_ctrl2, &dy_ctrl2);
+        rel_to_abs(&dx_to,    &dy_to);
+        curve4(dx_ctrl2, dy_ctrl2, dx_to, dy_to);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::end_poly(unsigned flags)
+    {
+        if(is_vertex(m_vertices.last_command()))
+        {
+            m_vertices.add_vertex(0.0, 0.0, path_cmd_end_poly | flags);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::close_polygon(unsigned flags)
+    {
+        end_poly(path_flags_close | flags);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline unsigned path_base<VC>::total_vertices() const
+    {
+        return m_vertices.total_vertices();
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline unsigned path_base<VC>::last_vertex(double* x, double* y) const
+    {
+        return m_vertices.last_vertex(x, y);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline unsigned path_base<VC>::prev_vertex(double* x, double* y) const
+    {
+        return m_vertices.prev_vertex(x, y);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline double path_base<VC>::last_x() const
+    {
+        return m_vertices.last_x();
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline double path_base<VC>::last_y() const
+    {
+        return m_vertices.last_y();
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline unsigned path_base<VC>::vertex(unsigned idx, double* x, double* y) const
+    {
+        return m_vertices.vertex(idx, x, y);
+    }
+ 
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline unsigned path_base<VC>::command(unsigned idx) const
+    {
+        return m_vertices.command(idx);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::modify_vertex(unsigned idx, double x, double y)
+    {
+        m_vertices.modify_vertex(idx, x, y);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::modify_vertex(unsigned idx, double x, double y, unsigned cmd)
+    {
+        m_vertices.modify_vertex(idx, x, y, cmd);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::modify_command(unsigned idx, unsigned cmd)
+    {
+        m_vertices.modify_command(idx, cmd);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline void path_base<VC>::rewind(unsigned path_id)
+    {
+        m_iterator = path_id;
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    inline unsigned path_base<VC>::vertex(double* x, double* y)
+    {
+        if(m_iterator >= m_vertices.total_vertices()) return path_cmd_stop;
+        return m_vertices.vertex(m_iterator++, x, y);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    unsigned path_base<VC>::perceive_polygon_orientation(unsigned start,
+                                                         unsigned end)
+    {
+        // Calculate signed area (double area to be exact)
+        //---------------------
+        unsigned np = end - start;
+        double area = 0.0;
+        unsigned i;
+        for(i = 0; i < np; i++)
+        {
+            double x1, y1, x2, y2;
+            m_vertices.vertex(start + i,            &x1, &y1);
+            m_vertices.vertex(start + (i + 1) % np, &x2, &y2);
+            area += x1 * y2 - y1 * x2;
+        }
+        return (area < 0.0) ? path_flags_cw : path_flags_ccw;
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::invert_polygon(unsigned start, unsigned end)
+    {
+        unsigned i;
+        unsigned tmp_cmd = m_vertices.command(start);
+        
+        --end; // Make "end" inclusive
+
+        // Shift all commands to one position
+        for(i = start; i < end; i++)
+        {
+            m_vertices.modify_command(i, m_vertices.command(i + 1));
+        }
+
+        // Assign starting command to the ending command
+        m_vertices.modify_command(end, tmp_cmd);
+
+        // Reverse the polygon
+        while(end > start)
+        {
+            m_vertices.swap_vertices(start++, end--);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::invert_polygon(unsigned start)
+    {
+        // Skip all non-vertices at the beginning
+        while(start < m_vertices.total_vertices() && 
+              !is_vertex(m_vertices.command(start))) ++start;
+
+        // Skip all insignificant move_to
+        while(start+1 < m_vertices.total_vertices() && 
+              is_move_to(m_vertices.command(start)) &&
+              is_move_to(m_vertices.command(start+1))) ++start;
+
+        // Find the last vertex
+        unsigned end = start + 1;
+        while(end < m_vertices.total_vertices() && 
+              !is_next_poly(m_vertices.command(end))) ++end;
+
+        invert_polygon(start, end);
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    unsigned path_base<VC>::arrange_polygon_orientation(unsigned start, 
+                                                        path_flags_e orientation)
+    {
+        if(orientation == path_flags_none) return start;
+        
+        // Skip all non-vertices at the beginning
+        while(start < m_vertices.total_vertices() && 
+              !is_vertex(m_vertices.command(start))) ++start;
+
+        // Skip all insignificant move_to
+        while(start+1 < m_vertices.total_vertices() && 
+              is_move_to(m_vertices.command(start)) &&
+              is_move_to(m_vertices.command(start+1))) ++start;
+
+        // Find the last vertex
+        unsigned end = start + 1;
+        while(end < m_vertices.total_vertices() && 
+              !is_next_poly(m_vertices.command(end))) ++end;
+
+        if(end - start > 2)
+        {
+            if(perceive_polygon_orientation(start, end) != unsigned(orientation))
+            {
+                // Invert polygon, set orientation flag, and skip all end_poly
+                invert_polygon(start, end);
+                unsigned cmd;
+                while(end < m_vertices.total_vertices() && 
+                      is_end_poly(cmd = m_vertices.command(end)))
+                {
+                    m_vertices.modify_command(end++, set_orientation(cmd, orientation));
+                }
+            }
+        }
+        return end;
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    unsigned path_base<VC>::arrange_orientations(unsigned start, 
+                                                 path_flags_e orientation)
+    {
+        if(orientation != path_flags_none)
+        {
+            while(start < m_vertices.total_vertices())
+            {
+                start = arrange_polygon_orientation(start, orientation);
+                if(is_stop(m_vertices.command(start)))
+                {
+                    ++start;
+                    break;
+                }
+            }
+        }
+        return start;
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::arrange_orientations_all_paths(path_flags_e orientation)
+    {
+        if(orientation != path_flags_none)
+        {
+            unsigned start = 0;
+            while(start < m_vertices.total_vertices())
+            {
+                start = arrange_orientations(start, orientation);
+            }
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::flip_x(double x1, double x2)
+    {
+        unsigned i;
+        double x, y;
+        for(i = 0; i < m_vertices.total_vertices(); i++)
+        {
+            unsigned cmd = m_vertices.vertex(i, &x, &y);
+            if(is_vertex(cmd))
+            {
+                m_vertices.modify_vertex(i, x2 - x + x1, y);
+            }
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::flip_y(double y1, double y2)
+    {
+        unsigned i;
+        double x, y;
+        for(i = 0; i < m_vertices.total_vertices(); i++)
+        {
+            unsigned cmd = m_vertices.vertex(i, &x, &y);
+            if(is_vertex(cmd))
+            {
+                m_vertices.modify_vertex(i, x, y2 - y + y1);
+            }
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::translate(double dx, double dy, unsigned path_id)
+    {
+        unsigned num_ver = m_vertices.total_vertices();
+        for(; path_id < num_ver; path_id++)
+        {
+            double x, y;
+            unsigned cmd = m_vertices.vertex(path_id, &x, &y);
+            if(is_stop(cmd)) break;
+            if(is_vertex(cmd))
+            {
+                x += dx;
+                y += dy;
+                m_vertices.modify_vertex(path_id, x, y);
+            }
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class VC> 
+    void path_base<VC>::translate_all_paths(double dx, double dy)
+    {
+        unsigned idx;
+        unsigned num_ver = m_vertices.total_vertices();
+        for(idx = 0; idx < num_ver; idx++)
+        {
+            double x, y;
+            if(is_vertex(m_vertices.vertex(idx, &x, &y)))
+            {
+                x += dx;
+                y += dy;
+                m_vertices.modify_vertex(idx, x, y);
+            }
+        }
+    }
+
+    //-----------------------------------------------------vertex_stl_storage
+    template<class Container> class vertex_stl_storage
+    {
+    public:
+        typedef typename Container::value_type vertex_type;
+        typedef typename vertex_type::value_type value_type;
+
+        void remove_all() { m_vertices.clear(); }
+        void free_all()   { m_vertices.clear(); }
+
+        void add_vertex(double x, double y, unsigned cmd)
+        {
+            m_vertices.push_back(vertex_type(value_type(x), 
+                                             value_type(y), 
+                                             int8u(cmd)));
+        }
+
+        void modify_vertex(unsigned idx, double x, double y)
+        {
+            vertex_type& v = m_vertices[idx];
+            v.x = value_type(x);
+            v.y = value_type(y);
+        }
+
+        void modify_vertex(unsigned idx, double x, double y, unsigned cmd)
+        {
+            vertex_type& v = m_vertices[idx];
+            v.x   = value_type(x);
+            v.y   = value_type(y);
+            v.cmd = int8u(cmd);
+        }
+
+        void modify_command(unsigned idx, unsigned cmd)
+        {
+            m_vertices[idx].cmd = int8u(cmd);
+        }
+
+        void swap_vertices(unsigned v1, unsigned v2)
+        {
+            vertex_type t = m_vertices[v1];
+            m_vertices[v1] = m_vertices[v2];
+            m_vertices[v2] = t;
+        }
+
+        unsigned last_command() const
+        {
+            return m_vertices.size() ? 
+                m_vertices[m_vertices.size() - 1].cmd : 
+                path_cmd_stop;
+        }
+
+        unsigned last_vertex(double* x, double* y) const
+        {
+            if(m_vertices.size() == 0)
+            {
+                *x = *y = 0.0;
+                return path_cmd_stop;
+            }
+            return vertex(m_vertices.size() - 1, x, y);
+        }
+
+        unsigned prev_vertex(double* x, double* y) const
+        {
+            if(m_vertices.size() < 2)
+            {
+                *x = *y = 0.0;
+                return path_cmd_stop;
+            }
+            return vertex(m_vertices.size() - 2, x, y);
+        }
+
+        double last_x() const
+        {
+            return m_vertices.size() ? m_vertices[m_vertices.size() - 1].x : 0.0;
+        }
+
+        double last_y() const
+        {
+            return m_vertices.size() ? m_vertices[m_vertices.size() - 1].y : 0.0;
+        }
+
+        unsigned total_vertices() const
+        {
+            return m_vertices.size();
+        }
+
+        unsigned vertex(unsigned idx, double* x, double* y) const
+        {
+            const vertex_type& v = m_vertices[idx];
+            *x = v.x;
+            *y = v.y;
+            return v.cmd;
+        }
+
+        unsigned command(unsigned idx) const
+        {
+            return m_vertices[idx].cmd;
+        }
+
+    private:
+        Container m_vertices;
+    };
+
+    //-----------------------------------------------------------path_storage
+    typedef path_base<vertex_block_storage<double> > path_storage;
+
+    // Example of declarations path_storage with pod_bvector as a container
+    //-----------------------------------------------------------------------
+    //typedef path_base<vertex_stl_storage<pod_bvector<vertex_d> > > path_storage;
+
+}
+
+
+
+// Example of declarations path_storage with std::vector as a container
+//---------------------------------------------------------------------------
+//#include <vector>
+//namespace mapserver
+//{
+//    typedef path_base<vertex_stl_storage<std::vector<vertex_d> > > stl_path_storage; 
+//}
+
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_path_storage_integer.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_path_storage_integer.h
--- 8.0.1-5/src/renderers/agg/include/agg_path_storage_integer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_path_storage_integer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,295 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PATH_STORAGE_INTEGER_INCLUDED
+#define AGG_PATH_STORAGE_INTEGER_INCLUDED
+
+#include <string.h>
+#include "agg_array.h"
+
+namespace mapserver
+{
+    //---------------------------------------------------------vertex_integer
+    template<class T, unsigned CoordShift=6> struct vertex_integer
+    {
+        enum path_cmd
+        {
+            cmd_move_to = 0,
+            cmd_line_to = 1,
+            cmd_curve3  = 2,
+            cmd_curve4  = 3
+        };
+
+        enum coord_scale_e
+        {
+            coord_shift = CoordShift,
+            coord_scale  = 1 << coord_shift
+        };
+
+        T x = 0,y = 0;
+        vertex_integer() = default;
+        vertex_integer(T x_, T y_, unsigned flag) :
+            x(((x_ << 1) & ~1) | (flag &  1)),
+            y(((y_ << 1) & ~1) | (flag >> 1)) {}
+
+        unsigned vertex(double* x_, double* y_, 
+                        double dx=0, double dy=0,
+                        double scale=1.0) const
+        {
+            *x_ = dx + (double(x >> 1) / coord_scale) * scale;
+            *y_ = dy + (double(y >> 1) / coord_scale) * scale;
+            switch(((y & 1) << 1) | (x & 1))
+            {
+                case cmd_move_to: return path_cmd_move_to;
+                case cmd_line_to: return path_cmd_line_to;
+                case cmd_curve3:  return path_cmd_curve3;
+                case cmd_curve4:  return path_cmd_curve4;
+            }
+            return path_cmd_stop;
+        }
+    };
+
+
+    //---------------------------------------------------path_storage_integer
+    template<class T, unsigned CoordShift=6> class path_storage_integer
+    {
+    public:
+        typedef T value_type;
+        typedef vertex_integer<T, CoordShift> vertex_integer_type;
+
+        //--------------------------------------------------------------------
+        path_storage_integer() : m_storage(), m_vertex_idx(0), m_closed(true) {}
+
+        //--------------------------------------------------------------------
+        void remove_all() { m_storage.remove_all(); }
+
+        //--------------------------------------------------------------------
+        void move_to(T x, T y)
+        {
+            m_storage.add(vertex_integer_type(x, y, vertex_integer_type::cmd_move_to));
+        }
+
+        //--------------------------------------------------------------------
+        void line_to(T x, T y)
+        {
+            m_storage.add(vertex_integer_type(x, y, vertex_integer_type::cmd_line_to));
+        }
+
+        //--------------------------------------------------------------------
+        void curve3(T x_ctrl,  T y_ctrl, 
+                    T x_to,    T y_to)
+        {
+            m_storage.add(vertex_integer_type(x_ctrl, y_ctrl, vertex_integer_type::cmd_curve3));
+            m_storage.add(vertex_integer_type(x_to,   y_to,   vertex_integer_type::cmd_curve3));
+        }
+
+        //--------------------------------------------------------------------
+        void curve4(T x_ctrl1, T y_ctrl1, 
+                    T x_ctrl2, T y_ctrl2, 
+                    T x_to,    T y_to)
+        {
+            m_storage.add(vertex_integer_type(x_ctrl1, y_ctrl1, vertex_integer_type::cmd_curve4));
+            m_storage.add(vertex_integer_type(x_ctrl2, y_ctrl2, vertex_integer_type::cmd_curve4));
+            m_storage.add(vertex_integer_type(x_to,    y_to,    vertex_integer_type::cmd_curve4));
+        }
+
+        //--------------------------------------------------------------------
+        void close_polygon() {}
+
+        //--------------------------------------------------------------------
+        unsigned size() const { return m_storage.size(); }
+        unsigned vertex(unsigned idx, double* x, double* y) const
+        {
+            return m_storage[idx].vertex(x, y);
+        }
+
+        //--------------------------------------------------------------------
+        unsigned byte_size() const { return m_storage.size() * sizeof(vertex_integer_type); }
+        void serialize(int8u* ptr) const
+        {
+            unsigned i;
+            for(i = 0; i < m_storage.size(); i++)
+            {
+                memcpy(ptr, &m_storage[i], sizeof(vertex_integer_type));
+                ptr += sizeof(vertex_integer_type);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void rewind(unsigned) 
+        { 
+            m_vertex_idx = 0; 
+            m_closed = true;
+        }
+
+        //--------------------------------------------------------------------
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_storage.size() < 2 || m_vertex_idx > m_storage.size()) 
+            {
+                *x = 0;
+                *y = 0;
+                return path_cmd_stop;
+            }
+            if(m_vertex_idx == m_storage.size())
+            {
+                *x = 0;
+                *y = 0;
+                ++m_vertex_idx;
+                return path_cmd_end_poly | path_flags_close;
+            }
+            unsigned cmd = m_storage[m_vertex_idx].vertex(x, y);
+            if(is_move_to(cmd) && !m_closed)
+            {
+                *x = 0;
+                *y = 0;
+                m_closed = true;
+                return path_cmd_end_poly | path_flags_close;
+            }
+            m_closed = false;
+            ++m_vertex_idx;
+            return cmd;
+        }
+
+        //--------------------------------------------------------------------
+        rect_d bounding_rect() const
+        {
+            rect_d bounds(1e100, 1e100, -1e100, -1e100);
+            if(m_storage.size() == 0)
+            {
+                bounds.x1 = bounds.y1 = bounds.x2 = bounds.y2 = 0.0;
+            }
+            else
+            {
+                unsigned i;
+                for(i = 0; i < m_storage.size(); i++)
+                {
+                    double x, y;
+                    m_storage[i].vertex(&x, &y);
+                    if(x < bounds.x1) bounds.x1 = x;
+                    if(y < bounds.y1) bounds.y1 = y;
+                    if(x > bounds.x2) bounds.x2 = x;
+                    if(y > bounds.y2) bounds.y2 = y;
+                }
+            }
+            return bounds;
+        }
+
+    private:
+        pod_bvector<vertex_integer_type, 6> m_storage;
+        unsigned                            m_vertex_idx;
+        bool                                m_closed;
+    };
+
+
+
+
+    //-----------------------------------------serialized_integer_path_adaptor
+    template<class T, unsigned CoordShift=6> class serialized_integer_path_adaptor
+    {
+    public:
+        typedef vertex_integer<T, CoordShift> vertex_integer_type;
+
+        //--------------------------------------------------------------------
+        serialized_integer_path_adaptor() :
+            m_data(0),
+            m_end(0),
+            m_ptr(0),
+            m_dx(0.0),
+            m_dy(0.0),
+            m_scale(1.0),
+            m_vertices(0)
+        {}
+
+        //--------------------------------------------------------------------
+        serialized_integer_path_adaptor(const int8u* data, unsigned size,
+                                        double dx, double dy) :
+            m_data(data),
+            m_end(data + size),
+            m_ptr(data),
+            m_dx(dx),
+            m_dy(dy),
+            m_vertices(0)
+        {}
+
+        //--------------------------------------------------------------------
+        void init(const int8u* data, unsigned size, 
+                  double dx, double dy, double scale=1.0)
+        {
+            m_data     = data;
+            m_end      = data + size;
+            m_ptr      = data;
+            m_dx       = dx;
+            m_dy       = dy;
+            m_scale    = scale;
+            m_vertices = 0;
+        }
+
+
+        //--------------------------------------------------------------------
+        void rewind(unsigned) 
+        { 
+            m_ptr      = m_data; 
+            m_vertices = 0;
+        }
+
+        //--------------------------------------------------------------------
+        unsigned vertex(double* x, double* y)
+        {
+            if(m_data == 0 || m_ptr > m_end) 
+            {
+                *x = 0;
+                *y = 0;
+                return path_cmd_stop;
+            }
+
+            if(m_ptr == m_end)
+            {
+                *x = 0;
+                *y = 0;
+                m_ptr += sizeof(vertex_integer_type);
+                return path_cmd_end_poly | path_flags_close;
+            }
+
+            vertex_integer_type v;
+            memcpy(&v, m_ptr, sizeof(vertex_integer_type));
+            unsigned cmd = v.vertex(x, y, m_dx, m_dy, m_scale);
+            if(is_move_to(cmd) && m_vertices > 2)
+            {
+                *x = 0;
+                *y = 0;
+                m_vertices = 0;
+                return path_cmd_end_poly | path_flags_close;
+            }
+            ++m_vertices;
+            m_ptr += sizeof(vertex_integer_type);
+            return cmd;
+        }
+
+    private:
+        const int8u* m_data;
+        const int8u* m_end;
+        const int8u* m_ptr;
+        double       m_dx;
+        double       m_dy;
+        double       m_scale;
+        unsigned     m_vertices;
+    };
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_pattern_filters_rgba.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pattern_filters_rgba.h
--- 8.0.1-5/src/renderers/agg/include/agg_pattern_filters_rgba.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pattern_filters_rgba.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,122 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_PATTERN_FILTERS_RGBA8_INCLUDED
+#define AGG_PATTERN_FILTERS_RGBA8_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_line_aa_basics.h"
+#include "agg_color_rgba.h"
+
+
+namespace mapserver
+{
+
+    //=======================================================pattern_filter_nn
+    template<class ColorT> struct pattern_filter_nn
+    {
+        typedef ColorT color_type;
+        static unsigned dilation() { return 0; }
+
+        static void AGG_INLINE pixel_low_res(color_type const* const* buf, 
+                                             color_type* p, int x, int y)
+        {
+            *p = buf[y][x];
+        }
+
+        static void AGG_INLINE pixel_high_res(color_type const* const* buf, 
+                                              color_type* p, int x, int y)
+        {
+            *p = buf[y >> line_subpixel_shift]
+                    [x >> line_subpixel_shift];
+        }
+    };
+
+    typedef pattern_filter_nn<rgba8>  pattern_filter_nn_rgba8;
+    typedef pattern_filter_nn<rgba16> pattern_filter_nn_rgba16;
+
+
+    //===========================================pattern_filter_bilinear_rgba
+    template<class ColorT> struct pattern_filter_bilinear_rgba
+    {
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+
+
+        static unsigned dilation() { return 1; }
+
+        static AGG_INLINE void pixel_low_res(color_type const* const* buf, 
+                                             color_type* p, int x, int y)
+        {
+            *p = buf[y][x];
+        }
+
+        static AGG_INLINE void pixel_high_res(color_type const* const* buf, 
+                                              color_type* p, int x, int y)
+        {
+            calc_type r, g, b, a;
+            r = g = b = a = line_subpixel_scale * line_subpixel_scale / 2;
+
+            calc_type weight;
+            int x_lr = x >> line_subpixel_shift;
+            int y_lr = y >> line_subpixel_shift;
+
+            x &= line_subpixel_mask;
+            y &= line_subpixel_mask;
+            const color_type* ptr = buf[y_lr] + x_lr;
+
+            weight = (line_subpixel_scale - x) * 
+                     (line_subpixel_scale - y);
+            r += weight * ptr->r;
+            g += weight * ptr->g;
+            b += weight * ptr->b;
+            a += weight * ptr->a;
+
+            ++ptr;
+
+            weight = x * (line_subpixel_scale - y);
+            r += weight * ptr->r;
+            g += weight * ptr->g;
+            b += weight * ptr->b;
+            a += weight * ptr->a;
+
+            ptr = buf[y_lr + 1] + x_lr;
+
+            weight = (line_subpixel_scale - x) * y;
+            r += weight * ptr->r;
+            g += weight * ptr->g;
+            b += weight * ptr->b;
+            a += weight * ptr->a;
+
+            ++ptr;
+
+            weight = x * y;
+            r += weight * ptr->r;
+            g += weight * ptr->g;
+            b += weight * ptr->b;
+            a += weight * ptr->a;
+
+            p->r = (value_type)(r >> line_subpixel_shift * 2);
+            p->g = (value_type)(g >> line_subpixel_shift * 2);
+            p->b = (value_type)(b >> line_subpixel_shift * 2);
+            p->a = (value_type)(a >> line_subpixel_shift * 2);
+        }
+    };
+
+    typedef pattern_filter_bilinear_rgba<rgba8>  pattern_filter_bilinear_rgba8;
+    typedef pattern_filter_bilinear_rgba<rgba16> pattern_filter_bilinear_rgba16;
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_pixfmt_amask_adaptor.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_amask_adaptor.h
--- 8.0.1-5/src/renderers/agg/include/agg_pixfmt_amask_adaptor.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_amask_adaptor.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,240 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PIXFMT_AMASK_ADAPTOR_INCLUDED
+#define AGG_PIXFMT_AMASK_ADAPTOR_INCLUDED
+
+
+#include <string.h>
+#include "agg_array.h"
+#include "agg_rendering_buffer.h"
+
+
+namespace mapserver
+{
+    //==================================================pixfmt_amask_adaptor
+    template<class PixFmt, class AlphaMask> class pixfmt_amask_adaptor
+    {
+    public:
+        typedef PixFmt pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::row_data row_data;
+        typedef AlphaMask amask_type;
+        typedef typename amask_type::cover_type cover_type;
+
+    private:
+        enum span_extra_tail_e { span_extra_tail = 256 };
+
+        void realloc_span(unsigned len)
+        {
+            if(len > m_span.size())
+            {
+                m_span.resize(len + span_extra_tail);
+            }
+        }
+
+        void init_span(unsigned len)
+        {
+            realloc_span(len);
+            memset(&m_span[0], amask_type::cover_full, len * sizeof(cover_type));
+        }
+
+        void init_span(unsigned len, const cover_type* covers)
+        {
+            realloc_span(len);
+            memcpy(&m_span[0], covers, len * sizeof(cover_type));
+        }
+
+
+    public:
+        pixfmt_amask_adaptor(pixfmt_type& pixf, const amask_type& mask) :
+            m_pixf(&pixf), m_mask(&mask), m_span()
+        {}
+
+        void attach_pixfmt(pixfmt_type& pixf)          { m_pixf = &pixf; }
+        void attach_alpha_mask(const amask_type& mask) { m_mask = &mask; }
+
+        //--------------------------------------------------------------------
+        template<class PixFmt2>
+        bool attach_pixfmt(PixFmt2& pixf, int x1, int y1, int x2, int y2)
+        {
+            return m_pixf->attach(pixf, x1, y1, x2, y2);
+        }
+
+        //--------------------------------------------------------------------
+        unsigned width()  const { return m_pixf->width();  }
+        unsigned height() const { return m_pixf->height(); }
+
+        //--------------------------------------------------------------------
+        color_type pixel(int x, int y)
+        {
+            return m_pixf->pixel(x, y);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_pixel(int x, int y, const color_type& c)
+        {
+            m_pixf->blend_pixel(x, y, c, m_mask->pixel(x, y));
+        }
+
+        //--------------------------------------------------------------------
+        void blend_pixel(int x, int y, const color_type& c, cover_type cover)
+        {
+            m_pixf->blend_pixel(x, y, c, m_mask->combine_pixel(x, y, cover));
+        }
+
+        //--------------------------------------------------------------------
+        void copy_hline(int x, int y, 
+                        unsigned len, 
+                        const color_type& c)
+        {
+            realloc_span(len);
+            m_mask->fill_hspan(x, y, &m_span[0], len);
+            m_pixf->blend_solid_hspan(x, y, len, c, &m_span[0]);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         cover_type cover)
+        {
+            init_span(len);
+            m_mask->combine_hspan(x, y, &m_span[0], len);
+            m_pixf->blend_solid_hspan(x, y, len, c, &m_span[0]);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_vline(int x, int y,
+                        unsigned len, 
+                        const color_type& c)
+        {
+            realloc_span(len);
+            m_mask->fill_vspan(x, y, &m_span[0], len);
+            m_pixf->blend_solid_vspan(x, y, len, c, &m_span[0]);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         cover_type cover)
+        {
+            init_span(len);
+            m_mask->combine_vspan(x, y, &m_span[0], len);
+            m_pixf->blend_solid_vspan(x, y, len, c, &m_span[0]);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_from(const rendering_buffer& from, 
+                       int xdst, int ydst,
+                       int xsrc, int ysrc,
+                       unsigned len)
+        {
+            m_pixf->copy_from(from, xdst, ydst, xsrc, ysrc, len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const cover_type* covers)
+        {
+            init_span(len, covers);
+            m_mask->combine_hspan(x, y, &m_span[0], len);
+            m_pixf->blend_solid_hspan(x, y, len, c, &m_span[0]);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const cover_type* covers)
+        {
+            init_span(len, covers);
+            m_mask->combine_vspan(x, y, &m_span[0], len);
+            m_pixf->blend_solid_vspan(x, y, len, c, &m_span[0]);
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y, unsigned len, const color_type* colors)
+        {
+            realloc_span(len);
+            m_mask->fill_hspan(x, y, &m_span[0], len);
+            m_pixf->blend_color_hspan(x, y, len, colors, &m_span[0], cover_full);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_color_vspan(int x, int y, unsigned len, const color_type* colors)
+        {
+            realloc_span(len);
+            m_mask->fill_vspan(x, y, &m_span[0], len);
+            m_pixf->blend_color_vspan(x, y, len, colors, &m_span[0], cover_full);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const cover_type* covers,
+                               cover_type cover = cover_full)
+        {
+            if(covers) 
+            {
+                init_span(len, covers);
+                m_mask->combine_hspan(x, y, &m_span[0], len);
+            }
+            else
+            {
+                realloc_span(len);
+                m_mask->fill_hspan(x, y, &m_span[0], len);
+            }
+            m_pixf->blend_color_hspan(x, y, len, colors, &m_span[0], cover);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const cover_type* covers,
+                               cover_type cover = cover_full)
+        {
+            if(covers) 
+            {
+                init_span(len, covers);
+                m_mask->combine_vspan(x, y, &m_span[0], len);
+            }
+            else
+            {
+                realloc_span(len);
+                m_mask->fill_vspan(x, y, &m_span[0], len);
+            }
+            m_pixf->blend_color_vspan(x, y, len, colors, &m_span[0], cover);
+        }
+
+    private:
+        pixfmt_type*          m_pixf;
+        const amask_type*     m_mask;
+        pod_array<cover_type> m_span;
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_pixfmt_gray.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_gray.h
--- 8.0.1-5/src/renderers/agg/include/agg_pixfmt_gray.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_gray.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,670 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PIXFMT_GRAY_INCLUDED
+#define AGG_PIXFMT_GRAY_INCLUDED
+
+#include <string.h>
+#include "agg_basics.h"
+#include "agg_color_gray.h"
+#include "agg_rendering_buffer.h"
+
+namespace mapserver
+{
+ 
+    //============================================================blender_gray
+    template<class ColorT> struct blender_gray
+    {
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e { base_shift = color_type::base_shift };
+
+        static AGG_INLINE void blend_pix(value_type* p, unsigned cv, 
+                                         unsigned alpha, unsigned cover=0)
+        {
+            *p = (value_type)((((cv - calc_type(*p)) * alpha) + (calc_type(*p) << base_shift)) >> base_shift);
+        }
+    };
+
+
+    //======================================================blender_gray_pre
+    template<class ColorT> struct blender_gray_pre
+    {
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e { base_shift = color_type::base_shift };
+
+        static AGG_INLINE void blend_pix(value_type* p, unsigned cv,
+                                         unsigned alpha, unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            cover = (cover + 1) << (base_shift - 8);
+            *p = (value_type)((*p * alpha + cv * cover) >> base_shift);
+        }
+
+        static AGG_INLINE void blend_pix(value_type* p, unsigned cv,
+                                         unsigned alpha)
+        {
+            *p = (value_type)(((*p * (color_type::base_mask - alpha)) >> base_shift) + cv);
+        }
+    };
+    
+
+
+    //=====================================================apply_gamma_dir_gray
+    template<class ColorT, class GammaLut> class apply_gamma_dir_gray
+    {
+    public:
+        typedef typename ColorT::value_type value_type;
+
+        apply_gamma_dir_gray(const GammaLut& gamma) : m_gamma(gamma) {}
+
+        AGG_INLINE void operator () (value_type* p)
+        {
+            *p = m_gamma.dir(*p);
+        }
+
+    private:
+        const GammaLut& m_gamma;
+    };
+
+
+
+    //=====================================================apply_gamma_inv_gray
+    template<class ColorT, class GammaLut> class apply_gamma_inv_gray
+    {
+    public:
+        typedef typename ColorT::value_type value_type;
+
+        apply_gamma_inv_gray(const GammaLut& gamma) : m_gamma(gamma) {}
+
+        AGG_INLINE void operator () (value_type* p)
+        {
+            *p = m_gamma.inv(*p);
+        }
+
+    private:
+        const GammaLut& m_gamma;
+    };
+
+
+
+    //=================================================pixfmt_alpha_blend_gray
+    template<class Blender, class RenBuf, unsigned Step=1, unsigned Offset=0>
+    class pixfmt_alpha_blend_gray
+    {
+    public:
+        typedef RenBuf   rbuf_type;
+        typedef typename rbuf_type::row_data row_data;
+        typedef Blender  blender_type;
+        typedef typename blender_type::color_type color_type;
+        typedef int                               order_type; // A fake one
+        typedef typename color_type::value_type   value_type;
+        typedef typename color_type::calc_type    calc_type;
+        enum base_scale_e 
+        {
+            base_shift = color_type::base_shift,
+            base_scale = color_type::base_scale,
+            base_mask  = color_type::base_mask,
+            pix_width  = sizeof(value_type),
+            pix_step   = Step,
+            pix_offset = Offset
+        };
+
+    private:
+        //--------------------------------------------------------------------
+        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
+                                                 const color_type& c, 
+                                                 unsigned cover)
+        {
+            if (c.a)
+            {
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    *p = c.v;
+                }
+                else
+                {
+                    Blender::blend_pix(p, c.v, alpha, cover);
+                }
+            }
+        }
+
+
+        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
+                                                 const color_type& c)
+        {
+            if (c.a)
+            {
+                if(c.a == base_mask)
+                {
+                    *p = c.v;
+                }
+                else
+                {
+                    Blender::blend_pix(p, c.v, c.a);
+                }
+            }
+        }
+
+
+    public:
+        //--------------------------------------------------------------------
+        explicit pixfmt_alpha_blend_gray(rbuf_type& rb) :
+            m_rbuf(&rb)
+        {}
+        void attach(rbuf_type& rb) { m_rbuf = &rb; }
+        //--------------------------------------------------------------------
+
+        template<class PixFmt>
+        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
+        {
+            rect_i r(x1, y1, x2, y2);
+            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
+            {
+                int stride = pixf.stride();
+                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
+                               (r.x2 - r.x1) + 1,
+                               (r.y2 - r.y1) + 1,
+                               stride);
+                return true;
+            }
+            return false;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
+        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
+        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
+
+        //--------------------------------------------------------------------
+              int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
+        const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
+        row_data     row(int y)     const { return m_rbuf->row(y); }
+
+        const int8u* pix_ptr(int x, int y) const
+        {
+            return m_rbuf->row_ptr(y) + x * Step + Offset;
+        }
+
+        int8u* pix_ptr(int x, int y)
+        {
+            return m_rbuf->row_ptr(y) + x * Step + Offset;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
+        {
+            *(value_type*)p = c.v;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE color_type pixel(int x, int y) const
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(y) + x * Step + Offset;
+            return color_type(*p);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
+        {
+            *((value_type*)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset) = c.v;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
+        {
+            copy_or_blend_pix((value_type*)
+                               m_rbuf->row_ptr(x, y, 1) + x * Step + Offset, 
+                               c, 
+                               cover);
+        }
+
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_hline(int x, int y, 
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            value_type* p = (value_type*)
+                m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+
+            do
+            {
+                *p = c.v; 
+                p += Step;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_vline(int x, int y,
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            do
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+                *p = c.v;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    do
+                    {
+                        *p = c.v; 
+                        p += Step;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do
+                    {
+                        Blender::blend_pix(p, c.v, alpha, cover);
+                        p += Step;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                value_type* p;
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    do
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+                        *p = c.v; 
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+                        Blender::blend_pix(p, c.v, alpha, cover);
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            if (c.a)
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+
+                do 
+                {
+                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
+                    if(alpha == base_mask)
+                    {
+                        *p = c.v;
+                    }
+                    else
+                    {
+                        Blender::blend_pix(p, c.v, alpha, *covers);
+                    }
+                    p += Step;
+                    ++covers;
+                }
+                while(--len);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            if (c.a)
+            {
+                do 
+                {
+                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
+
+                    value_type* p = (value_type*)
+                        m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+                    if(alpha == base_mask)
+                    {
+                        *p = c.v;
+                    }
+                    else
+                    {
+                        Blender::blend_pix(p, c.v, alpha, *covers);
+                    }
+                    ++covers;
+                }
+                while(--len);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            value_type* p = (value_type*)
+                m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+
+            do 
+            {
+                *p = colors->v;
+                p += Step;
+                ++colors;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_vspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            do 
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+                *p = colors->v;
+                ++colors;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            value_type* p = (value_type*)
+                m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+
+            if(covers)
+            {
+                do 
+                {
+                    copy_or_blend_pix(p, *colors++, *covers++);
+                    p += Step;
+                }
+                while(--len);
+            }
+            else
+            {
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        if(colors->a == base_mask)
+                        {
+                            *p = colors->v;
+                        }
+                        else
+                        {
+                            copy_or_blend_pix(p, *colors);
+                        }
+                        p += Step;
+                        ++colors;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        copy_or_blend_pix(p, *colors++, cover);
+                        p += Step;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            value_type* p;
+            if(covers)
+            {
+                do 
+                {
+                    p = (value_type*)
+                        m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+                    copy_or_blend_pix(p, *colors++, *covers++);
+                }
+                while(--len);
+            }
+            else
+            {
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+                        if(colors->a == base_mask)
+                        {
+                            *p = colors->v;
+                        }
+                        else
+                        {
+                            copy_or_blend_pix(p, *colors);
+                        }
+                        ++colors;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+
+                        copy_or_blend_pix(p, *colors++, cover);
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class Function> void for_each_pixel(Function f)
+        {
+            unsigned y;
+            for(y = 0; y < height(); ++y)
+            {
+                row_data r = m_rbuf->row(y);
+                if(r.ptr)
+                {
+                    unsigned len = r.x2 - r.x1 + 1;
+
+                    value_type* p = (value_type*)
+                        m_rbuf->row_ptr(r.x1, y, len) + r.x1 * Step + Offset;
+
+                    do
+                    {
+                        f(p);
+                        p += Step;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_dir_gray<color_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_inv_gray<color_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class RenBuf2>
+        void copy_from(const RenBuf2& from, 
+                       int xdst, int ydst,
+                       int xsrc, int ysrc,
+                       unsigned len)
+        {
+            const int8u* p = from.row_ptr(ysrc);
+            if(p)
+            {
+                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
+                        p + xsrc * pix_width, 
+                        len * pix_width);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_color(const SrcPixelFormatRenderer& from, 
+                              const color_type& color,
+                              int xdst, int ydst,
+                              int xsrc, int ysrc,
+                              unsigned len,
+                              int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
+                do 
+                {
+                    copy_or_blend_pix(pdst, 
+                                      color, 
+                                      (*psrc * cover + base_mask) >> base_shift);
+                    ++psrc;
+                    ++pdst;
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_lut(const SrcPixelFormatRenderer& from, 
+                            const color_type* color_lut,
+                            int xdst, int ydst,
+                            int xsrc, int ysrc,
+                            unsigned len,
+                            int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
+                do 
+                {
+                    copy_or_blend_pix(pdst, color_lut[*psrc], cover);
+                    ++psrc;
+                    ++pdst;
+                }
+                while(--len);
+            }
+        }
+
+    private:
+        rbuf_type* m_rbuf;
+    };
+
+    typedef blender_gray<gray8>      blender_gray8;
+    typedef blender_gray_pre<gray8>  blender_gray8_pre;
+    typedef blender_gray<gray16>     blender_gray16;
+    typedef blender_gray_pre<gray16> blender_gray16_pre;
+
+    typedef pixfmt_alpha_blend_gray<blender_gray8,      rendering_buffer> pixfmt_gray8;      //----pixfmt_gray8
+    typedef pixfmt_alpha_blend_gray<blender_gray8_pre,  rendering_buffer> pixfmt_gray8_pre;  //----pixfmt_gray8_pre
+    typedef pixfmt_alpha_blend_gray<blender_gray16,     rendering_buffer> pixfmt_gray16;     //----pixfmt_gray16
+    typedef pixfmt_alpha_blend_gray<blender_gray16_pre, rendering_buffer> pixfmt_gray16_pre; //----pixfmt_gray16_pre
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_pixfmt_rgb.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_rgb.h
--- 8.0.1-5/src/renderers/agg/include/agg_pixfmt_rgb.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_rgb.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,860 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PIXFMT_RGB_INCLUDED
+#define AGG_PIXFMT_RGB_INCLUDED
+
+#include <string.h>
+#include "agg_basics.h"
+#include "agg_color_rgba.h"
+#include "agg_rendering_buffer.h"
+
+namespace mapserver
+{
+
+    //=====================================================apply_gamma_dir_rgb
+    template<class ColorT, class Order, class GammaLut> class apply_gamma_dir_rgb
+    {
+    public:
+        typedef typename ColorT::value_type value_type;
+
+        apply_gamma_dir_rgb(const GammaLut& gamma) : m_gamma(gamma) {}
+
+        AGG_INLINE void operator () (value_type* p)
+        {
+            p[Order::R] = m_gamma.dir(p[Order::R]);
+            p[Order::G] = m_gamma.dir(p[Order::G]);
+            p[Order::B] = m_gamma.dir(p[Order::B]);
+        }
+
+    private:
+        const GammaLut& m_gamma;
+    };
+
+
+
+    //=====================================================apply_gamma_inv_rgb
+    template<class ColorT, class Order, class GammaLut> class apply_gamma_inv_rgb
+    {
+    public:
+        typedef typename ColorT::value_type value_type;
+
+        apply_gamma_inv_rgb(const GammaLut& gamma) : m_gamma(gamma) {}
+
+        AGG_INLINE void operator () (value_type* p)
+        {
+            p[Order::R] = m_gamma.inv(p[Order::R]);
+            p[Order::G] = m_gamma.inv(p[Order::G]);
+            p[Order::B] = m_gamma.inv(p[Order::B]);
+        }
+
+    private:
+        const GammaLut& m_gamma;
+    };
+
+
+    //=========================================================blender_rgb
+    template<class ColorT, class Order> struct blender_rgb
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e { base_shift = color_type::base_shift };
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb, 
+                                         unsigned alpha, 
+                                         unsigned cover=0)
+        {
+            p[Order::R] += (value_type)(((cr - p[Order::R]) * alpha) >> base_shift);
+            p[Order::G] += (value_type)(((cg - p[Order::G]) * alpha) >> base_shift);
+            p[Order::B] += (value_type)(((cb - p[Order::B]) * alpha) >> base_shift);
+        }
+    };
+
+
+    //======================================================blender_rgb_pre
+    template<class ColorT, class Order> struct blender_rgb_pre
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e { base_shift = color_type::base_shift };
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha,
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            cover = (cover + 1) << (base_shift - 8);
+            p[Order::R] = (value_type)((p[Order::R] * alpha + cr * cover) >> base_shift);
+            p[Order::G] = (value_type)((p[Order::G] * alpha + cg * cover) >> base_shift);
+            p[Order::B] = (value_type)((p[Order::B] * alpha + cb * cover) >> base_shift);
+        }
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha)
+        {
+            alpha = color_type::base_mask - alpha;
+            p[Order::R] = (value_type)(((p[Order::R] * alpha) >> base_shift) + cr);
+            p[Order::G] = (value_type)(((p[Order::G] * alpha) >> base_shift) + cg);
+            p[Order::B] = (value_type)(((p[Order::B] * alpha) >> base_shift) + cb);
+        }
+
+    };
+
+
+
+    //===================================================blender_rgb_gamma
+    template<class ColorT, class Order, class Gamma> class blender_rgb_gamma
+    {
+    public:
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef Gamma gamma_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e { base_shift = color_type::base_shift };
+
+        //--------------------------------------------------------------------
+        blender_rgb_gamma() : m_gamma(0) {}
+        void gamma(const gamma_type& g) { m_gamma = &g; }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_pix(value_type* p, 
+                                  unsigned cr, unsigned cg, unsigned cb,
+                                  unsigned alpha, 
+                                  unsigned cover=0)
+        {
+            calc_type r = m_gamma->dir(p[Order::R]);
+            calc_type g = m_gamma->dir(p[Order::G]);
+            calc_type b = m_gamma->dir(p[Order::B]);
+            p[Order::R] = m_gamma->inv((((m_gamma->dir(cr) - r) * alpha) >> base_shift) + r);
+            p[Order::G] = m_gamma->inv((((m_gamma->dir(cg) - g) * alpha) >> base_shift) + g);
+            p[Order::B] = m_gamma->inv((((m_gamma->dir(cb) - b) * alpha) >> base_shift) + b);
+        }
+
+    private:
+        const gamma_type* m_gamma;
+    };
+
+
+
+    
+    //==================================================pixfmt_alpha_blend_rgb
+    template<class Blender, class RenBuf> class pixfmt_alpha_blend_rgb
+    {
+    public:
+        typedef RenBuf   rbuf_type;
+        typedef Blender  blender_type;
+        typedef typename rbuf_type::row_data row_data;
+        typedef typename blender_type::color_type color_type;
+        typedef typename blender_type::order_type order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e 
+        {
+            base_shift = color_type::base_shift,
+            base_scale = color_type::base_scale,
+            base_mask  = color_type::base_mask,
+            pix_width  = sizeof(value_type) * 3
+        };
+
+    private:
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_or_blend_pix(value_type* p, 
+                                          const color_type& c, 
+                                          unsigned cover)
+        {
+            if (c.a)
+            {
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    p[order_type::R] = c.r;
+                    p[order_type::G] = c.g;
+                    p[order_type::B] = c.b;
+                }
+                else
+                {
+                    m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_or_blend_pix(value_type* p, 
+                                          const color_type& c)
+        {
+            if (c.a)
+            {
+                if(c.a == base_mask)
+                {
+                    p[order_type::R] = c.r;
+                    p[order_type::G] = c.g;
+                    p[order_type::B] = c.b;
+                }
+                else
+                {
+                    m_blender.blend_pix(p, c.r, c.g, c.b, c.a);
+                }
+            }
+        }
+
+
+    public:
+        //--------------------------------------------------------------------
+        explicit pixfmt_alpha_blend_rgb(rbuf_type& rb) :
+            m_rbuf(&rb)
+        {}
+        void attach(rbuf_type& rb) { m_rbuf = &rb; }
+
+        //--------------------------------------------------------------------
+        template<class PixFmt>
+        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
+        {
+            rect_i r(x1, y1, x2, y2);
+            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
+            {
+                int stride = pixf.stride();
+                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
+                               (r.x2 - r.x1) + 1,
+                               (r.y2 - r.y1) + 1,
+                               stride);
+                return true;
+            }
+            return false;
+        }
+
+        //--------------------------------------------------------------------
+        Blender& blender() { return m_blender; }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
+        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
+        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
+        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
+        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE int8u* pix_ptr(int x, int y) 
+        { 
+            return m_rbuf->row_ptr(y) + x * pix_width; 
+        }
+
+        AGG_INLINE const int8u* pix_ptr(int x, int y) const 
+        { 
+            return m_rbuf->row_ptr(y) + x * pix_width; 
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
+        {
+            ((value_type*)p)[order_type::R] = c.r;
+            ((value_type*)p)[order_type::G] = c.g;
+            ((value_type*)p)[order_type::B] = c.b;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE color_type pixel(int x, int y) const
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(y) + x + x + x;
+            return color_type(p[order_type::R], 
+                              p[order_type::G], 
+                              p[order_type::B]);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, 1) + x + x + x;
+            p[order_type::R] = c.r;
+            p[order_type::G] = c.g;
+            p[order_type::B] = c.b;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
+        {
+            copy_or_blend_pix((value_type*)m_rbuf->row_ptr(x, y, 1) + x + x + x, c, cover);
+        }
+
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_hline(int x, int y, 
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + x + x + x;
+            do
+            {
+                p[order_type::R] = c.r; 
+                p[order_type::G] = c.g; 
+                p[order_type::B] = c.b;
+                p += 3;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_vline(int x, int y,
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            do
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+                p[order_type::R] = c.r; 
+                p[order_type::G] = c.g; 
+                p[order_type::B] = c.b;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y, len) + x + x + x;
+
+                calc_type alpha = (calc_type(c.a) * (calc_type(cover) + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    do
+                    {
+                        p[order_type::R] = c.r; 
+                        p[order_type::G] = c.g; 
+                        p[order_type::B] = c.b;
+                        p += 3;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do
+                    {
+                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
+                        p += 3;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                value_type* p;
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    do
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+
+                        p[order_type::R] = c.r; 
+                        p[order_type::G] = c.g; 
+                        p[order_type::B] = c.b;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+
+                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            if (c.a)
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y, len) + x + x + x;
+
+                do 
+                {
+                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
+                    if(alpha == base_mask)
+                    {
+                        p[order_type::R] = c.r;
+                        p[order_type::G] = c.g;
+                        p[order_type::B] = c.b;
+                    }
+                    else
+                    {
+                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, *covers);
+                    }
+                    p += 3;
+                    ++covers;
+                }
+                while(--len);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            if (c.a)
+            {
+                do 
+                {
+                    value_type* p = (value_type*)
+                        m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+
+                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
+                    if(alpha == base_mask)
+                    {
+                        p[order_type::R] = c.r;
+                        p[order_type::G] = c.g;
+                        p[order_type::B] = c.b;
+                    }
+                    else
+                    {
+                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, *covers);
+                    }
+                    ++covers;
+                }
+                while(--len);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            value_type* p = (value_type*)
+                m_rbuf->row_ptr(x, y, len) + x + x + x;
+
+            do 
+            {
+                p[order_type::R] = colors->r;
+                p[order_type::G] = colors->g;
+                p[order_type::B] = colors->b;
+                ++colors;
+                p += 3;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_vspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            do 
+            {
+                value_type* p = (value_type*)
+                    m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+                p[order_type::R] = colors->r;
+                p[order_type::G] = colors->g;
+                p[order_type::B] = colors->b;
+                ++colors;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            value_type* p = (value_type*)
+                m_rbuf->row_ptr(x, y, len) + x + x + x;
+
+            if(covers)
+            {
+                do 
+                {
+                    copy_or_blend_pix(p, *colors++, *covers++);
+                    p += 3;
+                }
+                while(--len);
+            }
+            else
+            {
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        copy_or_blend_pix(p, *colors++);
+                        p += 3;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        copy_or_blend_pix(p, *colors++, cover);
+                        p += 3;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            value_type* p;
+            if(covers)
+            {
+                do 
+                {
+                    p = (value_type*)
+                        m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+
+                    copy_or_blend_pix(p, *colors++, *covers++);
+                }
+                while(--len);
+            }
+            else
+            {
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+
+                        copy_or_blend_pix(p, *colors++);
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        p = (value_type*)
+                            m_rbuf->row_ptr(x, y++, 1) + x + x + x;
+
+                        copy_or_blend_pix(p, *colors++, cover);
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class Function> void for_each_pixel(Function f)
+        {
+            unsigned y;
+            for(y = 0; y < height(); ++y)
+            {
+                row_data r = m_rbuf->row(y);
+                if(r.ptr)
+                {
+                    unsigned len = r.x2 - r.x1 + 1;
+                    value_type* p = (value_type*)
+                        m_rbuf->row_ptr(r.x1, y, len) + r.x1 * 3;
+                    do
+                    {
+                        f(p);
+                        p += 3;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_dir_rgb<color_type, order_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_inv_rgb<color_type, order_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class RenBuf2>
+        void copy_from(const RenBuf2& from, 
+                       int xdst, int ydst,
+                       int xsrc, int ysrc,
+                       unsigned len)
+        {
+            const int8u* p = from.row_ptr(ysrc);
+            if(p)
+            {
+                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
+                        p + xsrc * pix_width, 
+                        len * pix_width);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from(const SrcPixelFormatRenderer& from, 
+                        int xdst, int ydst,
+                        int xsrc, int ysrc,
+                        unsigned len,
+                        int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::order_type src_order;
+
+            const value_type* psrc = (const value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                psrc += xsrc * 4;
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst * 3;   
+
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        value_type alpha = psrc[src_order::A];
+                        if(alpha)
+                        {
+                            if(alpha == base_mask)
+                            {
+                                pdst[order_type::R] = psrc[src_order::R];
+                                pdst[order_type::G] = psrc[src_order::G];
+                                pdst[order_type::B] = psrc[src_order::B];
+                            }
+                            else
+                            {
+                                m_blender.blend_pix(pdst, 
+                                                    psrc[src_order::R],
+                                                    psrc[src_order::G],
+                                                    psrc[src_order::B],
+                                                    alpha);
+                            }
+                        }
+                        psrc += 4;
+                        pdst += 3;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    color_type color;
+                    do 
+                    {
+                        color.r = psrc[src_order::R];
+                        color.g = psrc[src_order::G];
+                        color.b = psrc[src_order::B];
+                        color.a = psrc[src_order::A];
+                        copy_or_blend_pix(pdst, color, cover);
+                        psrc += 4;
+                        pdst += 3;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_color(const SrcPixelFormatRenderer& from, 
+                              const color_type& color,
+                              int xdst, int ydst,
+                              int xsrc, int ysrc,
+                              unsigned len,
+                              int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst * 3;
+                do 
+                {
+                    copy_or_blend_pix(pdst, 
+                                      color, 
+                                      (*psrc * cover + base_mask) >> base_shift);
+                    ++psrc;
+                    pdst += 3;
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_lut(const SrcPixelFormatRenderer& from, 
+                            const color_type* color_lut,
+                            int xdst, int ydst,
+                            int xsrc, int ysrc,
+                            unsigned len,
+                            int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst * 3;
+
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        const color_type& color = color_lut[*psrc];
+                        m_blender.blend_pix(pdst, 
+                                            color.r, color.g, color.b, color.a);
+                        ++psrc;
+                        pdst += 3;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        copy_or_blend_pix(pdst, color_lut[*psrc], cover);
+                        ++psrc;
+                        pdst += 3;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+    private:
+        rbuf_type* m_rbuf;
+        Blender    m_blender;
+    };
+
+    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba8,  order_rgb>, rendering_buffer> pixfmt_rgb24;    //----pixfmt_rgb24
+    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba8,  order_bgr>, rendering_buffer> pixfmt_bgr24;    //----pixfmt_bgr24
+    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba16, order_rgb>, rendering_buffer> pixfmt_rgb48;    //----pixfmt_rgb48
+    typedef pixfmt_alpha_blend_rgb<blender_rgb<rgba16, order_bgr>, rendering_buffer> pixfmt_bgr48;    //----pixfmt_bgr48
+
+    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba8,  order_rgb>, rendering_buffer> pixfmt_rgb24_pre; //----pixfmt_rgb24_pre
+    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba8,  order_bgr>, rendering_buffer> pixfmt_bgr24_pre; //----pixfmt_bgr24_pre
+    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba16, order_rgb>, rendering_buffer> pixfmt_rgb48_pre; //----pixfmt_rgb48_pre
+    typedef pixfmt_alpha_blend_rgb<blender_rgb_pre<rgba16, order_bgr>, rendering_buffer> pixfmt_bgr48_pre; //----pixfmt_bgr48_pre
+
+    //-----------------------------------------------------pixfmt_rgb24_gamma
+    template<class Gamma> class pixfmt_rgb24_gamma : 
+    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_rgb, Gamma>, rendering_buffer>
+    {
+    public:
+        pixfmt_rgb24_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_rgb, Gamma>, rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+        
+    //-----------------------------------------------------pixfmt_bgr24_gamma
+    template<class Gamma> class pixfmt_bgr24_gamma : 
+    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_bgr, Gamma>, rendering_buffer>
+    {
+    public:
+        pixfmt_bgr24_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba8, order_bgr, Gamma>, rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+    //-----------------------------------------------------pixfmt_rgb48_gamma
+    template<class Gamma> class pixfmt_rgb48_gamma : 
+    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_rgb, Gamma>, rendering_buffer>
+    {
+    public:
+        pixfmt_rgb48_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_rgb, Gamma>, rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+        
+    //-----------------------------------------------------pixfmt_bgr48_gamma
+    template<class Gamma> class pixfmt_bgr48_gamma : 
+    public pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_bgr, Gamma>, rendering_buffer>
+    {
+    public:
+        pixfmt_bgr48_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb<blender_rgb_gamma<rgba16, order_bgr, Gamma>, rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_pixfmt_rgb_packed.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_rgb_packed.h
--- 8.0.1-5/src/renderers/agg/include/agg_pixfmt_rgb_packed.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_rgb_packed.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1309 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PIXFMT_RGB_PACKED_INCLUDED
+#define AGG_PIXFMT_RGB_PACKED_INCLUDED
+
+#include <string.h>
+#include "agg_basics.h"
+#include "agg_color_rgba.h"
+#include "agg_rendering_buffer.h"
+
+namespace mapserver
+{
+    //=========================================================blender_rgb555
+    struct blender_rgb555
+    {
+        typedef rgba8 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int16u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 7) & 0xF8;
+            calc_type g = (rgb >> 2) & 0xF8;
+            calc_type b = (rgb << 3) & 0xF8;
+            *p = (pixel_type)
+               (((((cr - r) * alpha + (r << 8)) >> 1)  & 0x7C00) |
+                ((((cg - g) * alpha + (g << 8)) >> 6)  & 0x03E0) |
+                 (((cb - b) * alpha + (b << 8)) >> 11) | 0x8000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xF8) << 7) | 
+                                ((g & 0xF8) << 2) | 
+                                 (b >> 3) | 0x8000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 7) & 0xF8, 
+                              (p >> 2) & 0xF8, 
+                              (p << 3) & 0xF8);
+        }
+    };
+
+
+    //=====================================================blender_rgb555_pre
+    struct blender_rgb555_pre
+    {
+        typedef rgba8 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int16u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 7) & 0xF8;
+            calc_type g = (rgb >> 2) & 0xF8;
+            calc_type b = (rgb << 3) & 0xF8;
+            *p = (pixel_type)
+               ((((r * alpha + cr * cover) >> 1)  & 0x7C00) |
+                (((g * alpha + cg * cover) >> 6)  & 0x03E0) |
+                 ((b * alpha + cb * cover) >> 11) | 0x8000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xF8) << 7) | 
+                                ((g & 0xF8) << 2) | 
+                                 (b >> 3) | 0x8000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 7) & 0xF8, 
+                              (p >> 2) & 0xF8, 
+                              (p << 3) & 0xF8);
+        }
+    };
+
+
+
+
+    //=====================================================blender_rgb555_gamma
+    template<class Gamma> class blender_rgb555_gamma
+    {
+    public:
+        typedef rgba8 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int16u pixel_type;
+        typedef Gamma gamma_type;
+
+        blender_rgb555_gamma() : m_gamma(0) {}
+        void gamma(const gamma_type& g) { m_gamma = &g; }
+
+        AGG_INLINE void blend_pix(pixel_type* p, 
+                                  unsigned cr, unsigned cg, unsigned cb,
+                                  unsigned alpha, 
+                                  unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = m_gamma->dir((rgb >> 7) & 0xF8);
+            calc_type g = m_gamma->dir((rgb >> 2) & 0xF8);
+            calc_type b = m_gamma->dir((rgb << 3) & 0xF8);
+            *p = (pixel_type)
+               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 8)) >> 8) << 7) & 0x7C00) |
+                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 8)) >> 8) << 2) & 0x03E0) |
+                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 8)) >> 8) >> 3) | 0x8000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xF8) << 7) | 
+                                ((g & 0xF8) << 2) | 
+                                 (b >> 3) | 0x8000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 7) & 0xF8, 
+                              (p >> 2) & 0xF8, 
+                              (p << 3) & 0xF8);
+        }
+
+    private:
+        const Gamma* m_gamma;
+    };
+
+
+
+
+
+    //=========================================================blender_rgb565
+    struct blender_rgb565
+    {
+        typedef rgba8 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int16u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 8) & 0xF8;
+            calc_type g = (rgb >> 3) & 0xFC;
+            calc_type b = (rgb << 3) & 0xF8;
+            *p = (pixel_type)
+               (((((cr - r) * alpha + (r << 8))     ) & 0xF800) |
+                ((((cg - g) * alpha + (g << 8)) >> 5) & 0x07E0) |
+                 (((cb - b) * alpha + (b << 8)) >> 11));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 8) & 0xF8, 
+                              (p >> 3) & 0xFC, 
+                              (p << 3) & 0xF8);
+        }
+    };
+
+
+
+    //=====================================================blender_rgb565_pre
+    struct blender_rgb565_pre
+    {
+        typedef rgba8 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int16u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 8) & 0xF8;
+            calc_type g = (rgb >> 3) & 0xFC;
+            calc_type b = (rgb << 3) & 0xF8;
+            *p = (pixel_type)
+               ((((r * alpha + cr * cover)      ) & 0xF800) |
+                (((g * alpha + cg * cover) >> 5 ) & 0x07E0) |
+                 ((b * alpha + cb * cover) >> 11));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 8) & 0xF8, 
+                              (p >> 3) & 0xFC, 
+                              (p << 3) & 0xF8);
+        }
+    };
+
+
+
+    //=====================================================blender_rgb565_gamma
+    template<class Gamma> class blender_rgb565_gamma
+    {
+    public:
+        typedef rgba8 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int16u pixel_type;
+        typedef Gamma gamma_type;
+
+        blender_rgb565_gamma() : m_gamma(0) {}
+        void gamma(const gamma_type& g) { m_gamma = &g; }
+
+        AGG_INLINE void blend_pix(pixel_type* p, 
+                                  unsigned cr, unsigned cg, unsigned cb,
+                                  unsigned alpha, 
+                                  unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = m_gamma->dir((rgb >> 8) & 0xF8);
+            calc_type g = m_gamma->dir((rgb >> 3) & 0xFC);
+            calc_type b = m_gamma->dir((rgb << 3) & 0xF8);
+            *p = (pixel_type)
+               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 8)) >> 8) << 8) & 0xF800) |
+                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 8)) >> 8) << 3) & 0x07E0) |
+                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 8)) >> 8) >> 3));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 8) & 0xF8, 
+                              (p >> 3) & 0xFC, 
+                              (p << 3) & 0xF8);
+        }
+
+    private:
+        const Gamma* m_gamma;
+    };
+
+
+
+    //=====================================================blender_rgbAAA
+    struct blender_rgbAAA
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 14) & 0xFFC0;
+            calc_type g = (rgb >> 4)  & 0xFFC0;
+            calc_type b = (rgb << 6)  & 0xFFC0;
+            *p = (pixel_type)
+               (((((cr - r) * alpha + (r << 16)) >> 2)  & 0x3FF00000) |
+                ((((cg - g) * alpha + (g << 16)) >> 12) & 0x000FFC00) |
+                 (((cb - b) * alpha + (b << 16)) >> 22) | 0xC0000000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xFFC0) << 14) | 
+                                ((g & 0xFFC0) << 4) | 
+                                 (b >> 6) | 0xC0000000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 14) & 0xFFC0, 
+                              (p >> 4)  & 0xFFC0, 
+                              (p << 6)  & 0xFFC0);
+        }
+    };
+
+
+
+    //==================================================blender_rgbAAA_pre
+    struct blender_rgbAAA_pre
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            cover = (cover + 1) << (color_type::base_shift - 8);
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 14) & 0xFFC0;
+            calc_type g = (rgb >> 4)  & 0xFFC0;
+            calc_type b = (rgb << 6)  & 0xFFC0;
+            *p = (pixel_type)
+               ((((r * alpha + cr * cover) >> 2)  & 0x3FF00000) |
+                (((g * alpha + cg * cover) >> 12) & 0x000FFC00) |
+                 ((b * alpha + cb * cover) >> 22) | 0xC0000000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xFFC0) << 14) | 
+                                ((g & 0xFFC0) << 4) | 
+                                 (b >> 6) | 0xC0000000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 14) & 0xFFC0, 
+                              (p >> 4)  & 0xFFC0, 
+                              (p << 6)  & 0xFFC0);
+        }
+    };
+
+
+
+    //=================================================blender_rgbAAA_gamma
+    template<class Gamma> class blender_rgbAAA_gamma
+    {
+    public:
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+        typedef Gamma gamma_type;
+
+        blender_rgbAAA_gamma() : m_gamma(0) {}
+        void gamma(const gamma_type& g) { m_gamma = &g; }
+
+        AGG_INLINE void blend_pix(pixel_type* p, 
+                                  unsigned cr, unsigned cg, unsigned cb,
+                                  unsigned alpha, 
+                                  unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = m_gamma->dir((rgb >> 14) & 0xFFC0);
+            calc_type g = m_gamma->dir((rgb >> 4)  & 0xFFC0);
+            calc_type b = m_gamma->dir((rgb << 6)  & 0xFFC0);
+            *p = (pixel_type)
+               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) << 14) & 0x3FF00000) |
+                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 4 ) & 0x000FFC00) |
+                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) >> 6 ) | 0xC0000000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xFFC0) << 14) | 
+                                ((g & 0xFFC0) << 4) | 
+                                 (b >> 6) | 0xC0000000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 14) & 0xFFC0, 
+                              (p >> 4)  & 0xFFC0, 
+                              (p << 6)  & 0xFFC0);
+        }
+    private:
+        const Gamma* m_gamma;
+    };
+
+
+    //=====================================================blender_bgrAAA
+    struct blender_bgrAAA
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned)
+        {
+            pixel_type bgr = *p;
+            calc_type b = (bgr >> 14) & 0xFFC0;
+            calc_type g = (bgr >> 4)  & 0xFFC0;
+            calc_type r = (bgr << 6)  & 0xFFC0;
+            *p = (pixel_type)
+               (((((cb - b) * alpha + (b << 16)) >> 2)  & 0x3FF00000) |
+                ((((cg - g) * alpha + (g << 16)) >> 12) & 0x000FFC00) |
+                 (((cr - r) * alpha + (r << 16)) >> 22) | 0xC0000000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((b & 0xFFC0) << 14) | 
+                                ((g & 0xFFC0) << 4) | 
+                                 (r >> 6) | 0xC0000000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p << 6)  & 0xFFC0, 
+                              (p >> 4)  & 0xFFC0, 
+                              (p >> 14) & 0xFFC0);
+        }
+    };
+
+
+
+    //=================================================blender_bgrAAA_pre
+    struct blender_bgrAAA_pre
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            cover = (cover + 1) << (color_type::base_shift - 8);
+            pixel_type bgr = *p;
+            calc_type b = (bgr >> 14) & 0xFFC0;
+            calc_type g = (bgr >> 4)  & 0xFFC0;
+            calc_type r = (bgr << 6)  & 0xFFC0;
+            *p = (pixel_type)
+               ((((b * alpha + cb * cover) >> 2)  & 0x3FF00000) |
+                (((g * alpha + cg * cover) >> 12) & 0x000FFC00) |
+                 ((r * alpha + cr * cover) >> 22) | 0xC0000000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((b & 0xFFC0) << 14) | 
+                                ((g & 0xFFC0) << 4) | 
+                                 (r >> 6) | 0xC0000000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p << 6)  & 0xFFC0, 
+                              (p >> 4)  & 0xFFC0, 
+                              (p >> 14) & 0xFFC0);
+        }
+    };
+
+
+
+    //=================================================blender_bgrAAA_gamma
+    template<class Gamma> class blender_bgrAAA_gamma
+    {
+    public:
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+        typedef Gamma gamma_type;
+
+        blender_bgrAAA_gamma() : m_gamma(0) {}
+        void gamma(const gamma_type& g) { m_gamma = &g; }
+
+        AGG_INLINE void blend_pix(pixel_type* p, 
+                                  unsigned cr, unsigned cg, unsigned cb,
+                                  unsigned alpha, 
+                                  unsigned)
+        {
+            pixel_type bgr = *p;
+            calc_type b = m_gamma->dir((bgr >> 14) & 0xFFC0);
+            calc_type g = m_gamma->dir((bgr >> 4)  & 0xFFC0);
+            calc_type r = m_gamma->dir((bgr << 6)  & 0xFFC0);
+            *p = (pixel_type)
+               (((m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) << 14) & 0x3FF00000) |
+                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 4 ) & 0x000FFC00) |
+                 (m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) >> 6 ) | 0xC0000000);
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((b & 0xFFC0) << 14) | 
+                                ((g & 0xFFC0) << 4) | 
+                                 (r >> 6) | 0xC0000000);
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p << 6)  & 0xFFC0, 
+                              (p >> 4)  & 0xFFC0, 
+                              (p >> 14) & 0xFFC0);
+        }
+
+    private:
+        const Gamma* m_gamma;
+    };
+
+
+
+    //=====================================================blender_rgbBBA
+    struct blender_rgbBBA
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 16) & 0xFFE0;
+            calc_type g = (rgb >> 5)  & 0xFFE0;
+            calc_type b = (rgb << 6)  & 0xFFC0;
+            *p = (pixel_type)
+               (((((cr - r) * alpha + (r << 16))      ) & 0xFFE00000) |
+                ((((cg - g) * alpha + (g << 16)) >> 11) & 0x001FFC00) |
+                 (((cb - b) * alpha + (b << 16)) >> 22));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xFFE0) << 16) | ((g & 0xFFE0) << 5) | (b >> 6));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 16) & 0xFFE0, 
+                              (p >> 5)  & 0xFFE0, 
+                              (p << 6)  & 0xFFC0);
+        }
+    };
+
+
+    //=================================================blender_rgbBBA_pre
+    struct blender_rgbBBA_pre
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            cover = (cover + 1) << (color_type::base_shift - 8);
+            pixel_type rgb = *p;
+            calc_type r = (rgb >> 16) & 0xFFE0;
+            calc_type g = (rgb >> 5)  & 0xFFE0;
+            calc_type b = (rgb << 6)  & 0xFFC0;
+            *p = (pixel_type)
+               ((((r * alpha + cr * cover)      ) & 0xFFE00000) |
+                (((g * alpha + cg * cover) >> 11) & 0x001FFC00) |
+                 ((b * alpha + cb * cover) >> 22));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xFFE0) << 16) | ((g & 0xFFE0) << 5) | (b >> 6));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 16) & 0xFFE0, 
+                              (p >> 5)  & 0xFFE0, 
+                              (p << 6)  & 0xFFC0);
+        }
+    };
+
+
+
+    //=================================================blender_rgbBBA_gamma
+    template<class Gamma> class blender_rgbBBA_gamma
+    {
+    public:
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+        typedef Gamma gamma_type;
+
+        blender_rgbBBA_gamma() : m_gamma(0) {}
+        void gamma(const gamma_type& g) { m_gamma = &g; }
+
+        AGG_INLINE void blend_pix(pixel_type* p, 
+                                  unsigned cr, unsigned cg, unsigned cb,
+                                  unsigned alpha, 
+                                  unsigned)
+        {
+            pixel_type rgb = *p;
+            calc_type r = m_gamma->dir((rgb >> 16) & 0xFFE0);
+            calc_type g = m_gamma->dir((rgb >> 5)  & 0xFFE0);
+            calc_type b = m_gamma->dir((rgb << 6)  & 0xFFC0);
+            *p = (pixel_type)
+               (((m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) << 16) & 0xFFE00000) |
+                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 5 ) & 0x001FFC00) |
+                 (m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) >> 6 ));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((r & 0xFFE0) << 16) | ((g & 0xFFE0) << 5) | (b >> 6));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p >> 16) & 0xFFE0, 
+                              (p >> 5)  & 0xFFE0, 
+                              (p << 6)  & 0xFFC0);
+        }
+
+    private:
+        const Gamma* m_gamma;
+    };
+
+
+    //=====================================================blender_bgrABB
+    struct blender_bgrABB
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned)
+        {
+            pixel_type bgr = *p;
+            calc_type b = (bgr >> 16) & 0xFFC0;
+            calc_type g = (bgr >> 6)  & 0xFFE0;
+            calc_type r = (bgr << 5)  & 0xFFE0;
+            *p = (pixel_type)
+               (((((cb - b) * alpha + (b << 16))      ) & 0xFFC00000) |
+                ((((cg - g) * alpha + (g << 16)) >> 10) & 0x003FF800) |
+                 (((cr - r) * alpha + (r << 16)) >> 21));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((b & 0xFFC0) << 16) | ((g & 0xFFE0) << 6) | (r >> 5));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p << 5)  & 0xFFE0,
+                              (p >> 6)  & 0xFFE0, 
+                              (p >> 16) & 0xFFC0);
+        }
+    };
+
+
+    //=================================================blender_bgrABB_pre
+    struct blender_bgrABB_pre
+    {
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+
+        static AGG_INLINE void blend_pix(pixel_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            cover = (cover + 1) << (color_type::base_shift - 8);
+            pixel_type bgr = *p;
+            calc_type b = (bgr >> 16) & 0xFFC0;
+            calc_type g = (bgr >> 6)  & 0xFFE0;
+            calc_type r = (bgr << 5)  & 0xFFE0;
+            *p = (pixel_type)
+               ((((b * alpha + cb * cover)      ) & 0xFFC00000) |
+                (((g * alpha + cg * cover) >> 10) & 0x003FF800) |
+                 ((r * alpha + cr * cover) >> 21));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((b & 0xFFC0) << 16) | ((g & 0xFFE0) << 6) | (r >> 5));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p << 5)  & 0xFFE0,
+                              (p >> 6)  & 0xFFE0, 
+                              (p >> 16) & 0xFFC0);
+        }
+    };
+
+
+
+    //=================================================blender_bgrABB_gamma
+    template<class Gamma> class blender_bgrABB_gamma
+    {
+    public:
+        typedef rgba16 color_type;
+        typedef color_type::value_type value_type;
+        typedef color_type::calc_type calc_type;
+        typedef int32u pixel_type;
+        typedef Gamma gamma_type;
+
+        blender_bgrABB_gamma() : m_gamma(0) {}
+        void gamma(const gamma_type& g) { m_gamma = &g; }
+
+        AGG_INLINE void blend_pix(pixel_type* p, 
+                                  unsigned cr, unsigned cg, unsigned cb,
+                                  unsigned alpha, 
+                                  unsigned)
+        {
+            pixel_type bgr = *p;
+            calc_type b = m_gamma->dir((bgr >> 16) & 0xFFC0);
+            calc_type g = m_gamma->dir((bgr >> 6)  & 0xFFE0);
+            calc_type r = m_gamma->dir((bgr << 5)  & 0xFFE0);
+            *p = (pixel_type)
+               (((m_gamma->inv(((m_gamma->dir(cb) - b) * alpha + (b << 16)) >> 16) << 16) & 0xFFC00000) |
+                ((m_gamma->inv(((m_gamma->dir(cg) - g) * alpha + (g << 16)) >> 16) << 6 ) & 0x003FF800) |
+                 (m_gamma->inv(((m_gamma->dir(cr) - r) * alpha + (r << 16)) >> 16) >> 5 ));
+        }
+
+        static AGG_INLINE pixel_type make_pix(unsigned r, unsigned g, unsigned b)
+        {
+            return (pixel_type)(((b & 0xFFC0) << 16) | ((g & 0xFFE0) << 6) | (r >> 5));
+        }
+
+        static AGG_INLINE color_type make_color(pixel_type p)
+        {
+            return color_type((p << 5)  & 0xFFE0,
+                              (p >> 6)  & 0xFFE0, 
+                              (p >> 16) & 0xFFC0);
+        }
+
+    private:
+        const Gamma* m_gamma;
+    };
+
+
+    
+    //===========================================pixfmt_alpha_blend_rgb_packed
+    template<class Blender,  class RenBuf> class pixfmt_alpha_blend_rgb_packed
+    {
+    public:
+        typedef RenBuf   rbuf_type;
+        typedef typename rbuf_type::row_data row_data;
+        typedef Blender  blender_type;
+        typedef typename blender_type::color_type color_type;
+        typedef typename blender_type::pixel_type pixel_type;
+        typedef int                               order_type; // A fake one
+        typedef typename color_type::value_type   value_type;
+        typedef typename color_type::calc_type    calc_type;
+        enum base_scale_e 
+        {
+            base_shift = color_type::base_shift,
+            base_scale = color_type::base_scale,
+            base_mask  = color_type::base_mask,
+            pix_width  = sizeof(pixel_type)
+        };
+
+    private:
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_or_blend_pix(pixel_type* p, const color_type& c, unsigned cover)
+        {
+            if (c.a)
+            {
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    *p = m_blender.make_pix(c.r, c.g, c.b);
+                }
+                else
+                {
+                    m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
+                }
+            }
+        }
+
+    public:
+        //--------------------------------------------------------------------
+        explicit pixfmt_alpha_blend_rgb_packed(rbuf_type& rb) : m_rbuf(&rb) {}
+        void attach(rbuf_type& rb) { m_rbuf = &rb; }
+
+        //--------------------------------------------------------------------
+        template<class PixFmt>
+        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
+        {
+            rect_i r(x1, y1, x2, y2);
+            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
+            {
+                int stride = pixf.stride();
+                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
+                               (r.x2 - r.x1) + 1,
+                               (r.y2 - r.y1) + 1,
+                               stride);
+                return true;
+            }
+            return false;
+        }
+
+        Blender& blender() { return m_blender; }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
+        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
+        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
+        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
+        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE int8u* pix_ptr(int x, int y)
+        {
+            return m_rbuf->row_ptr(y) + x * pix_width;
+        }
+
+        AGG_INLINE const int8u* pix_ptr(int x, int y) const
+        {
+            return m_rbuf->row_ptr(y) + x * pix_width;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void make_pix(int8u* p, const color_type& c)
+        {
+            *(pixel_type*)p = m_blender.make_pix(c.r, c.g, c.b);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE color_type pixel(int x, int y) const
+        {
+            return m_blender.make_color(((pixel_type*)m_rbuf->row_ptr(y))[x]);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
+        {
+            ((pixel_type*)
+                m_rbuf->row_ptr(x, y, 1))[x] = 
+                    m_blender.make_pix(c.r, c.g, c.b);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
+        {
+            copy_or_blend_pix((pixel_type*)m_rbuf->row_ptr(x, y, 1) + x, c, cover);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_hline(int x, int y, 
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
+            pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
+            do
+            {
+                *p++ = v;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_vline(int x, int y,
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
+            do
+            {
+                pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x;
+                *p = v;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
+                    do
+                    {
+                        *p++ = v;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do
+                    {
+                        m_blender.blend_pix(p, c.r, c.g, c.b, alpha, cover);
+                        ++p;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    pixel_type v = m_blender.make_pix(c.r, c.g, c.b);
+                    do
+                    {
+                        ((pixel_type*)m_rbuf->row_ptr(x, y++, 1))[x] = v;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do
+                    {
+                        m_blender.blend_pix(
+                            (pixel_type*)m_rbuf->row_ptr(x, y++, 1), 
+                            c.r, c.g, c.b, alpha, cover);
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
+            do 
+            {
+                copy_or_blend_pix(p, c, *covers++);
+                ++p;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            do 
+            {
+                copy_or_blend_pix((pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x, 
+                                  c, *covers++);
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
+            do 
+            {
+                *p++ = m_blender.make_pix(colors->r, colors->g, colors->b);
+                ++colors;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_color_vspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            do 
+            {
+                pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x;
+                *p = m_blender.make_pix(colors->r, colors->g, colors->b);
+                ++colors;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            pixel_type* p = (pixel_type*)m_rbuf->row_ptr(x, y, len) + x;
+            do 
+            {
+                copy_or_blend_pix(p++, *colors++, covers ? *covers++ : cover);
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            do 
+            {
+                copy_or_blend_pix((pixel_type*)m_rbuf->row_ptr(x, y++, 1) + x, 
+                                  *colors++, covers ? *covers++ : cover);
+            }
+            while(--len);
+        }
+        
+        //--------------------------------------------------------------------
+        template<class RenBuf2>
+        void copy_from(const RenBuf2& from, 
+                       int xdst, int ydst,
+                       int xsrc, int ysrc,
+                       unsigned len)
+        {
+            const int8u* p = from.row_ptr(ysrc);
+            if(p)
+            {
+                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
+                        p + xsrc * pix_width, 
+                        len * pix_width);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from(const SrcPixelFormatRenderer& from, 
+                        int xdst, int ydst,
+                        int xsrc, int ysrc,
+                        unsigned len,
+                        int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::order_type src_order;
+
+            const value_type* psrc = (const value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                psrc += xsrc * 4;
+                pixel_type* pdst = 
+                    (pixel_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
+                do 
+                {
+                    value_type alpha = psrc[src_order::A];
+                    if(alpha)
+                    {
+                        if(alpha == base_mask && cover == 255)
+                        {
+                            *pdst = m_blender.make_pix(psrc[src_order::R], 
+                                                       psrc[src_order::G],
+                                                       psrc[src_order::B]);
+                        }
+                        else
+                        {
+                            m_blender.blend_pix(pdst, 
+                                                psrc[src_order::R],
+                                                psrc[src_order::G],
+                                                psrc[src_order::B],
+                                                alpha,
+                                                cover);
+                        }
+                    }
+                    psrc += 4;
+                    ++pdst;
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_color(const SrcPixelFormatRenderer& from, 
+                              const color_type& color,
+                              int xdst, int ydst,
+                              int xsrc, int ysrc,
+                              unsigned len,
+                              int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                pixel_type* pdst = 
+                    (pixel_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
+
+                do 
+                {
+                    m_blender.blend_pix(pdst, 
+                                        color.r, color.g, color.b, color.a,
+                                        cover);
+                    ++psrc;
+                    ++pdst;
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_lut(const SrcPixelFormatRenderer& from, 
+                            const color_type* color_lut,
+                            int xdst, int ydst,
+                            int xsrc, int ysrc,
+                            unsigned len,
+                            int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                pixel_type* pdst = 
+                    (pixel_type*)m_rbuf->row_ptr(xdst, ydst, len) + xdst;
+
+                do 
+                {
+                    const color_type& color = color_lut[*psrc];
+                    m_blender.blend_pix(pdst, 
+                                        color.r, color.g, color.b, color.a,
+                                        cover);
+                    ++psrc;
+                    ++pdst;
+                }
+                while(--len);
+            }
+        }
+
+
+
+    private:
+        rbuf_type* m_rbuf;
+        Blender    m_blender;
+    };
+
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb555, rendering_buffer> pixfmt_rgb555; //----pixfmt_rgb555
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb565, rendering_buffer> pixfmt_rgb565; //----pixfmt_rgb565
+
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb555_pre, rendering_buffer> pixfmt_rgb555_pre; //----pixfmt_rgb555_pre
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgb565_pre, rendering_buffer> pixfmt_rgb565_pre; //----pixfmt_rgb565_pre
+
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbAAA, rendering_buffer> pixfmt_rgbAAA; //----pixfmt_rgbAAA
+    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrAAA, rendering_buffer> pixfmt_bgrAAA; //----pixfmt_bgrAAA
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbBBA, rendering_buffer> pixfmt_rgbBBA; //----pixfmt_rgbBBA
+    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrABB, rendering_buffer> pixfmt_bgrABB; //----pixfmt_bgrABB
+
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbAAA_pre, rendering_buffer> pixfmt_rgbAAA_pre; //----pixfmt_rgbAAA_pre
+    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrAAA_pre, rendering_buffer> pixfmt_bgrAAA_pre; //----pixfmt_bgrAAA_pre
+    typedef pixfmt_alpha_blend_rgb_packed<blender_rgbBBA_pre, rendering_buffer> pixfmt_rgbBBA_pre; //----pixfmt_rgbBBA_pre
+    typedef pixfmt_alpha_blend_rgb_packed<blender_bgrABB_pre, rendering_buffer> pixfmt_bgrABB_pre; //----pixfmt_bgrABB_pre
+
+
+    //-----------------------------------------------------pixfmt_rgb555_gamma
+    template<class Gamma> class pixfmt_rgb555_gamma : 
+    public pixfmt_alpha_blend_rgb_packed<blender_rgb555_gamma<Gamma>, 
+                                         rendering_buffer>
+    {
+    public:
+        pixfmt_rgb555_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb_packed<blender_rgb555_gamma<Gamma>, 
+                                          rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+
+    //-----------------------------------------------------pixfmt_rgb565_gamma
+    template<class Gamma> class pixfmt_rgb565_gamma : 
+    public pixfmt_alpha_blend_rgb_packed<blender_rgb565_gamma<Gamma>, rendering_buffer>
+    {
+    public:
+        pixfmt_rgb565_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb_packed<blender_rgb565_gamma<Gamma>, rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+
+    //-----------------------------------------------------pixfmt_rgbAAA_gamma
+    template<class Gamma> class pixfmt_rgbAAA_gamma : 
+    public pixfmt_alpha_blend_rgb_packed<blender_rgbAAA_gamma<Gamma>, 
+                                         rendering_buffer>
+    {
+    public:
+        pixfmt_rgbAAA_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb_packed<blender_rgbAAA_gamma<Gamma>, 
+                                          rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+
+    //-----------------------------------------------------pixfmt_bgrAAA_gamma
+    template<class Gamma> class pixfmt_bgrAAA_gamma : 
+    public pixfmt_alpha_blend_rgb_packed<blender_bgrAAA_gamma<Gamma>, 
+                                         rendering_buffer>
+    {
+    public:
+        pixfmt_bgrAAA_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb_packed<blender_bgrAAA_gamma<Gamma>, 
+                                          rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+
+    //-----------------------------------------------------pixfmt_rgbBBA_gamma
+    template<class Gamma> class pixfmt_rgbBBA_gamma : 
+    public pixfmt_alpha_blend_rgb_packed<blender_rgbBBA_gamma<Gamma>, 
+                                         rendering_buffer>
+    {
+    public:
+        pixfmt_rgbBBA_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb_packed<blender_rgbBBA_gamma<Gamma>, 
+                                          rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+
+    //-----------------------------------------------------pixfmt_bgrABB_gamma
+    template<class Gamma> class pixfmt_bgrABB_gamma : 
+    public pixfmt_alpha_blend_rgb_packed<blender_bgrABB_gamma<Gamma>, 
+                                         rendering_buffer>
+    {
+    public:
+        pixfmt_bgrABB_gamma(rendering_buffer& rb, const Gamma& g) :
+            pixfmt_alpha_blend_rgb_packed<blender_bgrABB_gamma<Gamma>, 
+                                          rendering_buffer>(rb) 
+        {
+            this->blender().gamma(g);
+        }
+    };
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_pixfmt_rgba.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_rgba.h
--- 8.0.1-5/src/renderers/agg/include/agg_pixfmt_rgba.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_rgba.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2902 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PIXFMT_RGBA_INCLUDED
+#define AGG_PIXFMT_RGBA_INCLUDED
+
+#include <string.h>
+#include <math.h>
+#include "agg_basics.h"
+#include "agg_color_rgba.h"
+#include "agg_rendering_buffer.h"
+
+namespace mapserver
+{
+
+    //=========================================================multiplier_rgba
+    template<class ColorT, class Order> struct multiplier_rgba
+    {
+        typedef typename ColorT::value_type value_type;
+        typedef typename ColorT::calc_type calc_type;
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void premultiply(value_type* p)
+        {
+            calc_type a = p[Order::A];
+            if(a < ColorT::base_mask)
+            {
+                if(a == 0)
+                {
+                    p[Order::R] = p[Order::G] = p[Order::B] = 0;
+                    return;
+                }
+                p[Order::R] = value_type((p[Order::R] * a + ColorT::base_mask) >> ColorT::base_shift);
+                p[Order::G] = value_type((p[Order::G] * a + ColorT::base_mask) >> ColorT::base_shift);
+                p[Order::B] = value_type((p[Order::B] * a + ColorT::base_mask) >> ColorT::base_shift);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void demultiply(value_type* p)
+        {
+            calc_type a = p[Order::A];
+            if(a < ColorT::base_mask)
+            {
+                if(a == 0)
+                {
+                    p[Order::R] = p[Order::G] = p[Order::B] = 0;
+                    return;
+                }
+                calc_type r = (calc_type(p[Order::R]) * ColorT::base_mask) / a;
+                calc_type g = (calc_type(p[Order::G]) * ColorT::base_mask) / a;
+                calc_type b = (calc_type(p[Order::B]) * ColorT::base_mask) / a;
+                p[Order::R] = value_type((r > ColorT::base_mask) ? ColorT::base_mask : r);
+                p[Order::G] = value_type((g > ColorT::base_mask) ? ColorT::base_mask : g);
+                p[Order::B] = value_type((b > ColorT::base_mask) ? ColorT::base_mask : b);
+            }
+        }
+    };
+
+    //=====================================================apply_gamma_dir_rgba
+    template<class ColorT, class Order, class GammaLut> class apply_gamma_dir_rgba
+    {
+    public:
+        typedef typename ColorT::value_type value_type;
+
+        apply_gamma_dir_rgba(const GammaLut& gamma) : m_gamma(gamma) {}
+
+        AGG_INLINE void operator () (value_type* p)
+        {
+            p[Order::R] = m_gamma.dir(p[Order::R]);
+            p[Order::G] = m_gamma.dir(p[Order::G]);
+            p[Order::B] = m_gamma.dir(p[Order::B]);
+        }
+
+    private:
+        const GammaLut& m_gamma;
+    };
+
+    //=====================================================apply_gamma_inv_rgba
+    template<class ColorT, class Order, class GammaLut> class apply_gamma_inv_rgba
+    {
+    public:
+        typedef typename ColorT::value_type value_type;
+
+        apply_gamma_inv_rgba(const GammaLut& gamma) : m_gamma(gamma) {}
+
+        AGG_INLINE void operator () (value_type* p)
+        {
+            p[Order::R] = m_gamma.inv(p[Order::R]);
+            p[Order::G] = m_gamma.inv(p[Order::G]);
+            p[Order::B] = m_gamma.inv(p[Order::B]);
+        }
+
+    private:
+        const GammaLut& m_gamma;
+    };
+
+
+    
+
+
+
+
+
+
+
+    //=============================================================blender_rgba
+    template<class ColorT, class Order> struct blender_rgba
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e 
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha, 
+                                         unsigned cover=0)
+        {
+            calc_type r = p[Order::R];
+            calc_type g = p[Order::G];
+            calc_type b = p[Order::B];
+            calc_type a = p[Order::A];
+            p[Order::R] = (value_type)(((cr - r) * alpha + (r << base_shift)) >> base_shift);
+            p[Order::G] = (value_type)(((cg - g) * alpha + (g << base_shift)) >> base_shift);
+            p[Order::B] = (value_type)(((cb - b) * alpha + (b << base_shift)) >> base_shift);
+            p[Order::A] = (value_type)((alpha + a) - ((alpha * a + base_mask) >> base_shift));
+        }
+    };
+
+    //=========================================================blender_rgba_pre
+    template<class ColorT, class Order> struct blender_rgba_pre
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha,
+                                         unsigned cover)
+        {
+            alpha = color_type::base_mask - alpha;
+            cover = (cover + 1) << (base_shift - 8);
+            p[Order::R] = (value_type)((p[Order::R] * alpha + cr * cover) >> base_shift);
+            p[Order::G] = (value_type)((p[Order::G] * alpha + cg * cover) >> base_shift);
+            p[Order::B] = (value_type)((p[Order::B] * alpha + cb * cover) >> base_shift);
+            p[Order::A] = (value_type)(base_mask - ((alpha * (base_mask - p[Order::A])) >> base_shift));
+        }
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha)
+        {
+            alpha = color_type::base_mask - alpha;
+            p[Order::R] = (value_type)(((p[Order::R] * alpha) >> base_shift) + cr);
+            p[Order::G] = (value_type)(((p[Order::G] * alpha) >> base_shift) + cg);
+            p[Order::B] = (value_type)(((p[Order::B] * alpha) >> base_shift) + cb);
+            p[Order::A] = (value_type)(base_mask - ((alpha * (base_mask - p[Order::A])) >> base_shift));
+        }
+    };
+
+    //======================================================blender_rgba_plain
+    template<class ColorT, class Order> struct blender_rgba_plain
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e { base_shift = color_type::base_shift };
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned alpha,
+                                         unsigned cover=0)
+        {
+            if(alpha == 0) return;
+            calc_type a = p[Order::A];
+            calc_type r = p[Order::R] * a;
+            calc_type g = p[Order::G] * a;
+            calc_type b = p[Order::B] * a;
+            a = ((alpha + a) << base_shift) - alpha * a;
+            p[Order::A] = (value_type)(a >> base_shift);
+            p[Order::R] = (value_type)((((cr << base_shift) - r) * alpha + (r << base_shift)) / a);
+            p[Order::G] = (value_type)((((cg << base_shift) - g) * alpha + (g << base_shift)) / a);
+            p[Order::B] = (value_type)((((cb << base_shift) - b) * alpha + (b << base_shift)) / a);
+        }
+    };
+
+
+
+
+
+
+
+
+
+
+
+    //=========================================================comp_op_rgba_clear
+    template<class ColorT, class Order> struct comp_op_rgba_clear
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned, unsigned, unsigned, unsigned,
+                                         unsigned cover)
+        {
+            if(cover < 255)
+            {
+                cover = 255 - cover;
+                p[Order::R] = (value_type)((p[Order::R] * cover + 255) >> 8);
+                p[Order::G] = (value_type)((p[Order::G] * cover + 255) >> 8);
+                p[Order::B] = (value_type)((p[Order::B] * cover + 255) >> 8);
+                p[Order::A] = (value_type)((p[Order::A] * cover + 255) >> 8);
+            }
+            else
+            {
+                p[0] = p[1] = p[2] = p[3] = 0; 
+            }
+        }
+    };
+
+    //===========================================================comp_op_rgba_src
+    template<class ColorT, class Order> struct comp_op_rgba_src
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                unsigned alpha = 255 - cover;
+                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((sr * cover + 255) >> 8));
+                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((sg * cover + 255) >> 8));
+                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((sb * cover + 255) >> 8));
+                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((sa * cover + 255) >> 8));
+            }
+            else
+            {
+                p[Order::R] = sr;
+                p[Order::G] = sg;
+                p[Order::B] = sb;
+                p[Order::A] = sa;
+            }
+        }
+    };
+
+    //===========================================================comp_op_rgba_dst
+    template<class ColorT, class Order> struct comp_op_rgba_dst
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+
+        static AGG_INLINE void blend_pix(value_type*, 
+                                         unsigned, unsigned, unsigned, 
+                                         unsigned, unsigned)
+        {
+        }
+    };
+
+    //======================================================comp_op_rgba_src_over
+    template<class ColorT, class Order> struct comp_op_rgba_src_over
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //   Dca' = Sca + Dca.(1 - Sa)
+        //   Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            calc_type s1a = base_mask - sa;
+            p[Order::R] = (value_type)(sr + ((p[Order::R] * s1a + base_mask) >> base_shift));
+            p[Order::G] = (value_type)(sg + ((p[Order::G] * s1a + base_mask) >> base_shift));
+            p[Order::B] = (value_type)(sb + ((p[Order::B] * s1a + base_mask) >> base_shift));
+            p[Order::A] = (value_type)(sa + ((p[Order::A] * s1a + base_mask) >> base_shift));
+        }
+    };
+
+    //======================================================comp_op_rgba_dst_over
+    template<class ColorT, class Order> struct comp_op_rgba_dst_over
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Dca + Sca.(1 - Da)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            calc_type d1a = base_mask - p[Order::A];
+            p[Order::R] = (value_type)(p[Order::R] + ((sr * d1a + base_mask) >> base_shift));
+            p[Order::G] = (value_type)(p[Order::G] + ((sg * d1a + base_mask) >> base_shift));
+            p[Order::B] = (value_type)(p[Order::B] + ((sb * d1a + base_mask) >> base_shift));
+            p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask) >> base_shift));
+        }
+    };
+
+    //======================================================comp_op_rgba_src_in
+    template<class ColorT, class Order> struct comp_op_rgba_src_in
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca.Da
+        // Da'  = Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            calc_type da = p[Order::A];
+            if(cover < 255)
+            {
+                unsigned alpha = 255 - cover;
+                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((((sr * da + base_mask) >> base_shift) * cover + 255) >> 8));
+                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((((sg * da + base_mask) >> base_shift) * cover + 255) >> 8));
+                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((((sb * da + base_mask) >> base_shift) * cover + 255) >> 8));
+                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((((sa * da + base_mask) >> base_shift) * cover + 255) >> 8));
+            }
+            else
+            {
+                p[Order::R] = (value_type)((sr * da + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((sg * da + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((sb * da + base_mask) >> base_shift);
+                p[Order::A] = (value_type)((sa * da + base_mask) >> base_shift);
+            }
+        }
+    };
+
+    //======================================================comp_op_rgba_dst_in
+    template<class ColorT, class Order> struct comp_op_rgba_dst_in
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Dca.Sa
+        // Da'  = Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned, unsigned, unsigned, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sa = base_mask - ((cover * (base_mask - sa) + 255) >> 8);
+            }
+            p[Order::R] = (value_type)((p[Order::R] * sa + base_mask) >> base_shift);
+            p[Order::G] = (value_type)((p[Order::G] * sa + base_mask) >> base_shift);
+            p[Order::B] = (value_type)((p[Order::B] * sa + base_mask) >> base_shift);
+            p[Order::A] = (value_type)((p[Order::A] * sa + base_mask) >> base_shift);
+        }
+    };
+
+    //======================================================comp_op_rgba_src_out
+    template<class ColorT, class Order> struct comp_op_rgba_src_out
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca.(1 - Da)
+        // Da'  = Sa.(1 - Da) 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            calc_type da = base_mask - p[Order::A];
+            if(cover < 255)
+            {
+                unsigned alpha = 255 - cover;
+                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((((sr * da + base_mask) >> base_shift) * cover + 255) >> 8));
+                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((((sg * da + base_mask) >> base_shift) * cover + 255) >> 8));
+                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((((sb * da + base_mask) >> base_shift) * cover + 255) >> 8));
+                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((((sa * da + base_mask) >> base_shift) * cover + 255) >> 8));
+            }
+            else
+            {
+                p[Order::R] = (value_type)((sr * da + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((sg * da + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((sb * da + base_mask) >> base_shift);
+                p[Order::A] = (value_type)((sa * da + base_mask) >> base_shift);
+            }
+        }
+    };
+
+    //======================================================comp_op_rgba_dst_out
+    template<class ColorT, class Order> struct comp_op_rgba_dst_out
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Dca.(1 - Sa) 
+        // Da'  = Da.(1 - Sa) 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned, unsigned, unsigned, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sa = (sa * cover + 255) >> 8;
+            }
+            sa = base_mask - sa;
+            p[Order::R] = (value_type)((p[Order::R] * sa + base_shift) >> base_shift);
+            p[Order::G] = (value_type)((p[Order::G] * sa + base_shift) >> base_shift);
+            p[Order::B] = (value_type)((p[Order::B] * sa + base_shift) >> base_shift);
+            p[Order::A] = (value_type)((p[Order::A] * sa + base_shift) >> base_shift);
+        }
+    };
+
+    //=====================================================comp_op_rgba_src_atop
+    template<class ColorT, class Order> struct comp_op_rgba_src_atop
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca.Da + Dca.(1 - Sa)
+        // Da'  = Da
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            calc_type da = p[Order::A];
+            sa = base_mask - sa;
+            p[Order::R] = (value_type)((sr * da + p[Order::R] * sa + base_mask) >> base_shift);
+            p[Order::G] = (value_type)((sg * da + p[Order::G] * sa + base_mask) >> base_shift);
+            p[Order::B] = (value_type)((sb * da + p[Order::B] * sa + base_mask) >> base_shift);
+        }
+    };
+
+    //=====================================================comp_op_rgba_dst_atop
+    template<class ColorT, class Order> struct comp_op_rgba_dst_atop
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Dca.Sa + Sca.(1 - Da)
+        // Da'  = Sa 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            calc_type da = base_mask - p[Order::A];
+            if(cover < 255)
+            {
+                unsigned alpha = 255 - cover;
+                sr = (p[Order::R] * sa + sr * da + base_mask) >> base_shift;
+                sg = (p[Order::G] * sa + sg * da + base_mask) >> base_shift;
+                sb = (p[Order::B] * sa + sb * da + base_mask) >> base_shift;
+                p[Order::R] = (value_type)(((p[Order::R] * alpha + 255) >> 8) + ((sr * cover + 255) >> 8));
+                p[Order::G] = (value_type)(((p[Order::G] * alpha + 255) >> 8) + ((sg * cover + 255) >> 8));
+                p[Order::B] = (value_type)(((p[Order::B] * alpha + 255) >> 8) + ((sb * cover + 255) >> 8));
+                p[Order::A] = (value_type)(((p[Order::A] * alpha + 255) >> 8) + ((sa * cover + 255) >> 8));
+
+            }
+            else
+            {
+                p[Order::R] = (value_type)((p[Order::R] * sa + sr * da + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((p[Order::G] * sa + sg * da + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((p[Order::B] * sa + sb * da + base_mask) >> base_shift);
+                p[Order::A] = (value_type)sa;
+            }
+        }
+    };
+
+    //=========================================================comp_op_rgba_xor
+    template<class ColorT, class Order> struct comp_op_rgba_xor
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca.(1 - Da) + Dca.(1 - Sa)
+        // Da'  = Sa + Da - 2.Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type s1a = base_mask - sa;
+                calc_type d1a = base_mask - p[Order::A];
+                p[Order::R] = (value_type)((p[Order::R] * s1a + sr * d1a + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((p[Order::G] * s1a + sg * d1a + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((p[Order::B] * s1a + sb * d1a + base_mask) >> base_shift);
+                p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask/2) >> (base_shift - 1)));
+            }
+        }
+    };
+
+    //=========================================================comp_op_rgba_plus
+    template<class ColorT, class Order> struct comp_op_rgba_plus
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca + Dca
+        // Da'  = Sa + Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type dr = p[Order::R] + sr;
+                calc_type dg = p[Order::G] + sg;
+                calc_type db = p[Order::B] + sb;
+                calc_type da = p[Order::A] + sa;
+                p[Order::R] = (dr > base_mask) ? (value_type)base_mask : dr;
+                p[Order::G] = (dg > base_mask) ? (value_type)base_mask : dg;
+                p[Order::B] = (db > base_mask) ? (value_type)base_mask : db;
+                p[Order::A] = (da > base_mask) ? (value_type)base_mask : da;
+            }
+        }
+    };
+
+    //========================================================comp_op_rgba_minus
+    template<class ColorT, class Order> struct comp_op_rgba_minus
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Dca - Sca
+        // Da' = 1 - (1 - Sa).(1 - Da)
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type dr = p[Order::R] - sr;
+                calc_type dg = p[Order::G] - sg;
+                calc_type db = p[Order::B] - sb;
+                p[Order::R] = (dr > base_mask) ? 0 : dr;
+                p[Order::G] = (dg > base_mask) ? 0 : dg;
+                p[Order::B] = (db > base_mask) ? 0 : db;
+                p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask) >> base_shift));
+                //p[Order::A] = (value_type)(base_mask - (((base_mask - sa) * (base_mask - p[Order::A]) + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_multiply
+    template<class ColorT, class Order> struct comp_op_rgba_multiply
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca.Dca + Sca.(1 - Da) + Dca.(1 - Sa)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type s1a = base_mask - sa;
+                calc_type d1a = base_mask - p[Order::A];
+                calc_type dr = p[Order::R];
+                calc_type dg = p[Order::G];
+                calc_type db = p[Order::B];
+                p[Order::R] = (value_type)((sr * dr + sr * d1a + dr * s1a + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((sg * dg + sg * d1a + dg * s1a + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((sb * db + sb * d1a + db * s1a + base_mask) >> base_shift);
+                p[Order::A] = (value_type)(sa + p[Order::A] - ((sa * p[Order::A] + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_screen
+    template<class ColorT, class Order> struct comp_op_rgba_screen
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca + Dca - Sca.Dca
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type dr = p[Order::R];
+                calc_type dg = p[Order::G];
+                calc_type db = p[Order::B];
+                calc_type da = p[Order::A];
+                p[Order::R] = (value_type)(sr + dr - ((sr * dr + base_mask) >> base_shift));
+                p[Order::G] = (value_type)(sg + dg - ((sg * dg + base_mask) >> base_shift));
+                p[Order::B] = (value_type)(sb + db - ((sb * db + base_mask) >> base_shift));
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_overlay
+    template<class ColorT, class Order> struct comp_op_rgba_overlay
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // if 2.Dca < Da
+        //   Dca' = 2.Sca.Dca + Sca.(1 - Da) + Dca.(1 - Sa)
+        // otherwise
+        //   Dca' = Sa.Da - 2.(Da - Dca).(Sa - Sca) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // 
+        // Da' = Sa + Da - Sa.Da
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type d1a  = base_mask - p[Order::A];
+                calc_type s1a  = base_mask - sa;
+                calc_type dr   = p[Order::R];
+                calc_type dg   = p[Order::G];
+                calc_type db   = p[Order::B];
+                calc_type da   = p[Order::A];
+                calc_type sada = sa * p[Order::A];
+
+                p[Order::R] = (value_type)(((2*dr < da) ? 
+                    2*sr*dr + sr*d1a + dr*s1a : 
+                    sada - 2*(da - dr)*(sa - sr) + sr*d1a + dr*s1a + base_mask) >> base_shift);
+
+                p[Order::G] = (value_type)(((2*dg < da) ? 
+                    2*sg*dg + sg*d1a + dg*s1a : 
+                    sada - 2*(da - dg)*(sa - sg) + sg*d1a + dg*s1a + base_mask) >> base_shift);
+
+                p[Order::B] = (value_type)(((2*db < da) ? 
+                    2*sb*db + sb*d1a + db*s1a : 
+                    sada - 2*(da - db)*(sa - sb) + sb*d1a + db*s1a + base_mask) >> base_shift);
+
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+
+    template<class T> inline T sd_min(T a, T b) { return (a < b) ? a : b; }
+    template<class T> inline T sd_max(T a, T b) { return (a > b) ? a : b; }
+
+    //=====================================================comp_op_rgba_darken
+    template<class ColorT, class Order> struct comp_op_rgba_darken
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = min(Sca.Da, Dca.Sa) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type d1a = base_mask - p[Order::A];
+                calc_type s1a = base_mask - sa;
+                calc_type dr  = p[Order::R];
+                calc_type dg  = p[Order::G];
+                calc_type db  = p[Order::B];
+                calc_type da  = p[Order::A];
+
+                p[Order::R] = (value_type)((sd_min(sr * da, dr * sa) + sr * d1a + dr * s1a + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((sd_min(sg * da, dg * sa) + sg * d1a + dg * s1a + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((sd_min(sb * da, db * sa) + sb * d1a + db * s1a + base_mask) >> base_shift);
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_lighten
+    template<class ColorT, class Order> struct comp_op_rgba_lighten
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = max(Sca.Da, Dca.Sa) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type d1a = base_mask - p[Order::A];
+                calc_type s1a = base_mask - sa;
+                calc_type dr  = p[Order::R];
+                calc_type dg  = p[Order::G];
+                calc_type db  = p[Order::B];
+                calc_type da  = p[Order::A];
+
+                p[Order::R] = (value_type)((sd_max(sr * da, dr * sa) + sr * d1a + dr * s1a + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((sd_max(sg * da, dg * sa) + sg * d1a + dg * s1a + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((sd_max(sb * da, db * sa) + sb * d1a + db * s1a + base_mask) >> base_shift);
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_color_dodge
+    template<class ColorT, class Order> struct comp_op_rgba_color_dodge
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // if Sca.Da + Dca.Sa >= Sa.Da
+        //   Dca' = Sa.Da + Sca.(1 - Da) + Dca.(1 - Sa)
+        // otherwise
+        //   Dca' = Dca.Sa/(1-Sca/Sa) + Sca.(1 - Da) + Dca.(1 - Sa)
+        //
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type d1a  = base_mask - p[Order::A];
+                calc_type s1a  = base_mask - sa;
+                calc_type dr   = p[Order::R];
+                calc_type dg   = p[Order::G];
+                calc_type db   = p[Order::B];
+                calc_type da   = p[Order::A];
+                long_type drsa = dr * sa;
+                long_type dgsa = dg * sa;
+                long_type dbsa = db * sa;
+                long_type srda = sr * da;
+                long_type sgda = sg * da;
+                long_type sbda = sb * da;
+                long_type sada = sa * da;
+
+                p[Order::R] = (value_type)((srda + drsa >= sada) ? 
+                    (sada + sr * d1a + dr * s1a + base_mask) >> base_shift :
+                    drsa / (base_mask - (sr << base_shift) / sa) + ((sr * d1a + dr * s1a + base_mask) >> base_shift));
+
+                p[Order::G] = (value_type)((sgda + dgsa >= sada) ? 
+                    (sada + sg * d1a + dg * s1a + base_mask) >> base_shift :
+                    dgsa / (base_mask - (sg << base_shift) / sa) + ((sg * d1a + dg * s1a + base_mask) >> base_shift));
+
+                p[Order::B] = (value_type)((sbda + dbsa >= sada) ? 
+                    (sada + sb * d1a + db * s1a + base_mask) >> base_shift :
+                    dbsa / (base_mask - (sb << base_shift) / sa) + ((sb * d1a + db * s1a + base_mask) >> base_shift));
+
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_color_burn
+    template<class ColorT, class Order> struct comp_op_rgba_color_burn
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // if Sca.Da + Dca.Sa <= Sa.Da
+        //   Dca' = Sca.(1 - Da) + Dca.(1 - Sa)
+        // otherwise
+        //   Dca' = Sa.(Sca.Da + Dca.Sa - Sa.Da)/Sca + Sca.(1 - Da) + Dca.(1 - Sa)
+        // 
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type d1a  = base_mask - p[Order::A];
+                calc_type s1a  = base_mask - sa;
+                calc_type dr   = p[Order::R];
+                calc_type dg   = p[Order::G];
+                calc_type db   = p[Order::B];
+                calc_type da   = p[Order::A];
+                long_type drsa = dr * sa;
+                long_type dgsa = dg * sa;
+                long_type dbsa = db * sa;
+                long_type srda = sr * da;
+                long_type sgda = sg * da;
+                long_type sbda = sb * da;
+                long_type sada = sa * da;
+
+                p[Order::R] = (value_type)(((srda + drsa <= sada) ? 
+                    sr * d1a + dr * s1a :
+                    sa * (srda + drsa - sada) / sr + sr * d1a + dr * s1a + base_mask) >> base_shift);
+
+                p[Order::G] = (value_type)(((sgda + dgsa <= sada) ? 
+                    sg * d1a + dg * s1a :
+                    sa * (sgda + dgsa - sada) / sg + sg * d1a + dg * s1a + base_mask) >> base_shift);
+
+                p[Order::B] = (value_type)(((sbda + dbsa <= sada) ? 
+                    sb * d1a + db * s1a :
+                    sa * (sbda + dbsa - sada) / sb + sb * d1a + db * s1a + base_mask) >> base_shift);
+
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_hard_light
+    template<class ColorT, class Order> struct comp_op_rgba_hard_light
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // if 2.Sca < Sa
+        //    Dca' = 2.Sca.Dca + Sca.(1 - Da) + Dca.(1 - Sa)
+        // otherwise
+        //    Dca' = Sa.Da - 2.(Da - Dca).(Sa - Sca) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // 
+        // Da'  = Sa + Da - Sa.Da
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type d1a  = base_mask - p[Order::A];
+                calc_type s1a  = base_mask - sa;
+                calc_type dr   = p[Order::R];
+                calc_type dg   = p[Order::G];
+                calc_type db   = p[Order::B];
+                calc_type da   = p[Order::A];
+                calc_type sada = sa * da;
+
+                p[Order::R] = (value_type)(((2*sr < sa) ? 
+                    2*sr*dr + sr*d1a + dr*s1a : 
+                    sada - 2*(da - dr)*(sa - sr) + sr*d1a + dr*s1a + base_mask) >> base_shift);
+
+                p[Order::G] = (value_type)(((2*sg < sa) ? 
+                    2*sg*dg + sg*d1a + dg*s1a : 
+                    sada - 2*(da - dg)*(sa - sg) + sg*d1a + dg*s1a + base_mask) >> base_shift);
+
+                p[Order::B] = (value_type)(((2*sb < sa) ? 
+                    2*sb*db + sb*d1a + db*s1a : 
+                    sada - 2*(da - db)*(sa - sb) + sb*d1a + db*s1a + base_mask) >> base_shift);
+
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_soft_light
+    template<class ColorT, class Order> struct comp_op_rgba_soft_light
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // if 2.Sca < Sa
+        //   Dca' = Dca.(Sa + (1 - Dca/Da).(2.Sca - Sa)) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // otherwise if 8.Dca <= Da
+        //   Dca' = Dca.(Sa + (1 - Dca/Da).(2.Sca - Sa).(3 - 8.Dca/Da)) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // otherwise
+        //   Dca' = (Dca.Sa + ((Dca/Da)^(0.5).Da - Dca).(2.Sca - Sa)) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // 
+        // Da'  = Sa + Da - Sa.Da 
+
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned r, unsigned g, unsigned b, 
+                                         unsigned a, unsigned cover)
+        {
+            double sr = double(r * cover) / (base_mask * 255);
+            double sg = double(g * cover) / (base_mask * 255);
+            double sb = double(b * cover) / (base_mask * 255);
+            double sa = double(a * cover) / (base_mask * 255);
+            if(sa > 0)
+            {
+                double dr = double(p[Order::R]) / base_mask;
+                double dg = double(p[Order::G]) / base_mask;
+                double db = double(p[Order::B]) / base_mask;
+                double da = double(p[Order::A] ? p[Order::A] : 1) / base_mask;
+                if(cover < 255)
+                {
+                    a = (a * cover + 255) >> 8;
+                }
+
+                if(2*sr < sa)       dr = dr*(sa + (1 - dr/da)*(2*sr - sa)) + sr*(1 - da) + dr*(1 - sa);
+                else if(8*dr <= da) dr = dr*(sa + (1 - dr/da)*(2*sr - sa)*(3 - 8*dr/da)) + sr*(1 - da) + dr*(1 - sa);
+                else                dr = (dr*sa + (sqrt(dr/da)*da - dr)*(2*sr - sa)) + sr*(1 - da) + dr*(1 - sa);
+
+                if(2*sg < sa)       dg = dg*(sa + (1 - dg/da)*(2*sg - sa)) + sg*(1 - da) + dg*(1 - sa);
+                else if(8*dg <= da) dg = dg*(sa + (1 - dg/da)*(2*sg - sa)*(3 - 8*dg/da)) + sg*(1 - da) + dg*(1 - sa);
+                else                dg = (dg*sa + (sqrt(dg/da)*da - dg)*(2*sg - sa)) + sg*(1 - da) + dg*(1 - sa);
+
+                if(2*sb < sa)       db = db*(sa + (1 - db/da)*(2*sb - sa)) + sb*(1 - da) + db*(1 - sa);
+                else if(8*db <= da) db = db*(sa + (1 - db/da)*(2*sb - sa)*(3 - 8*db/da)) + sb*(1 - da) + db*(1 - sa);
+                else                db = (db*sa + (sqrt(db/da)*da - db)*(2*sb - sa)) + sb*(1 - da) + db*(1 - sa);
+
+                p[Order::R] = (value_type)uround(dr * base_mask);
+                p[Order::G] = (value_type)uround(dg * base_mask);
+                p[Order::B] = (value_type)uround(db * base_mask);
+                p[Order::A] = (value_type)(a + p[Order::A] - ((a * p[Order::A] + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_difference
+    template<class ColorT, class Order> struct comp_op_rgba_difference
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_scale = color_type::base_scale,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = Sca + Dca - 2.min(Sca.Da, Dca.Sa)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type dr = p[Order::R];
+                calc_type dg = p[Order::G];
+                calc_type db = p[Order::B];
+                calc_type da = p[Order::A];
+                p[Order::R] = (value_type)(sr + dr - ((2 * sd_min(sr*da, dr*sa) + base_mask) >> base_shift));
+                p[Order::G] = (value_type)(sg + dg - ((2 * sd_min(sg*da, dg*sa) + base_mask) >> base_shift));
+                p[Order::B] = (value_type)(sb + db - ((2 * sd_min(sb*da, db*sa) + base_mask) >> base_shift));
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_exclusion
+    template<class ColorT, class Order> struct comp_op_rgba_exclusion
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = (Sca.Da + Dca.Sa - 2.Sca.Dca) + Sca.(1 - Da) + Dca.(1 - Sa)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type d1a = base_mask - p[Order::A];
+                calc_type s1a = base_mask - sa;
+                calc_type dr = p[Order::R];
+                calc_type dg = p[Order::G];
+                calc_type db = p[Order::B];
+                calc_type da = p[Order::A];
+                p[Order::R] = (value_type)((sr*da + dr*sa - 2*sr*dr + sr*d1a + dr*s1a + base_mask) >> base_shift);
+                p[Order::G] = (value_type)((sg*da + dg*sa - 2*sg*dg + sg*d1a + dg*s1a + base_mask) >> base_shift);
+                p[Order::B] = (value_type)((sb*da + db*sa - 2*sb*db + sb*d1a + db*s1a + base_mask) >> base_shift);
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=====================================================comp_op_rgba_contrast
+    template<class ColorT, class Order> struct comp_op_rgba_contrast
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            long_type dr = p[Order::R];
+            long_type dg = p[Order::G];
+            long_type db = p[Order::B];
+            int       da = p[Order::A];
+            long_type d2a = da >> 1;
+            unsigned s2a = sa >> 1;
+
+            int r = (int)((((dr - d2a) * int((sr - s2a)*2 + base_mask)) >> base_shift) + d2a); 
+            int g = (int)((((dg - d2a) * int((sg - s2a)*2 + base_mask)) >> base_shift) + d2a); 
+            int b = (int)((((db - d2a) * int((sb - s2a)*2 + base_mask)) >> base_shift) + d2a); 
+
+            r = (r < 0) ? 0 : r;
+            g = (g < 0) ? 0 : g;
+            b = (b < 0) ? 0 : b;
+
+            p[Order::R] = (value_type)((r > da) ? da : r);
+            p[Order::G] = (value_type)((g > da) ? da : g);
+            p[Order::B] = (value_type)((b > da) ? da : b);
+        }
+    };
+
+    //=====================================================comp_op_rgba_invert
+    template<class ColorT, class Order> struct comp_op_rgba_invert
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = (Da - Dca) * Sa + Dca.(1 - Sa)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned /*sr*/, unsigned /*sg*/, unsigned /*sb*/, 
+                                         unsigned sa, unsigned cover)
+        {
+            sa = (sa * cover + 255) >> 8;
+            if(sa)
+            {
+                calc_type da = p[Order::A];
+                calc_type dr = ((da - p[Order::R]) * sa + base_mask) >> base_shift;
+                calc_type dg = ((da - p[Order::G]) * sa + base_mask) >> base_shift;
+                calc_type db = ((da - p[Order::B]) * sa + base_mask) >> base_shift;
+                calc_type s1a = base_mask - sa;
+                p[Order::R] = (value_type)(dr + ((p[Order::R] * s1a + base_mask) >> base_shift));
+                p[Order::G] = (value_type)(dg + ((p[Order::G] * s1a + base_mask) >> base_shift));
+                p[Order::B] = (value_type)(db + ((p[Order::B] * s1a + base_mask) >> base_shift));
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+    //=================================================comp_op_rgba_invert_rgb
+    template<class ColorT, class Order> struct comp_op_rgba_invert_rgb
+    {
+        typedef ColorT color_type;
+        typedef Order order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        { 
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        // Dca' = (Da - Dca) * Sca + Dca.(1 - Sa)
+        // Da'  = Sa + Da - Sa.Da 
+        static AGG_INLINE void blend_pix(value_type* p, 
+                                         unsigned sr, unsigned sg, unsigned sb, 
+                                         unsigned sa, unsigned cover)
+        {
+            if(cover < 255)
+            {
+                sr = (sr * cover + 255) >> 8;
+                sg = (sg * cover + 255) >> 8;
+                sb = (sb * cover + 255) >> 8;
+                sa = (sa * cover + 255) >> 8;
+            }
+            if(sa)
+            {
+                calc_type da = p[Order::A];
+                calc_type dr = ((da - p[Order::R]) * sr + base_mask) >> base_shift;
+                calc_type dg = ((da - p[Order::G]) * sg + base_mask) >> base_shift;
+                calc_type db = ((da - p[Order::B]) * sb + base_mask) >> base_shift;
+                calc_type s1a = base_mask - sa;
+                p[Order::R] = (value_type)(dr + ((p[Order::R] * s1a + base_mask) >> base_shift));
+                p[Order::G] = (value_type)(dg + ((p[Order::G] * s1a + base_mask) >> base_shift));
+                p[Order::B] = (value_type)(db + ((p[Order::B] * s1a + base_mask) >> base_shift));
+                p[Order::A] = (value_type)(sa + da - ((sa * da + base_mask) >> base_shift));
+            }
+        }
+    };
+
+
+
+
+
+    //======================================================comp_op_table_rgba
+    template<class ColorT, class Order> struct comp_op_table_rgba
+    {
+        typedef typename ColorT::value_type value_type;
+        typedef void (*comp_op_func_type)(value_type* p, 
+                                          unsigned cr, 
+                                          unsigned cg, 
+                                          unsigned cb,
+                                          unsigned ca,
+                                          unsigned cover);
+        static comp_op_func_type g_comp_op_func[];
+    };
+
+    //==========================================================g_comp_op_func
+    template<class ColorT, class Order> 
+    typename comp_op_table_rgba<ColorT, Order>::comp_op_func_type
+    comp_op_table_rgba<ColorT, Order>::g_comp_op_func[] = 
+    {
+        comp_op_rgba_clear      <ColorT,Order>::blend_pix,
+        comp_op_rgba_src        <ColorT,Order>::blend_pix,
+        comp_op_rgba_dst        <ColorT,Order>::blend_pix,
+        comp_op_rgba_src_over   <ColorT,Order>::blend_pix,
+        comp_op_rgba_dst_over   <ColorT,Order>::blend_pix,
+        comp_op_rgba_src_in     <ColorT,Order>::blend_pix,
+        comp_op_rgba_dst_in     <ColorT,Order>::blend_pix,
+        comp_op_rgba_src_out    <ColorT,Order>::blend_pix,
+        comp_op_rgba_dst_out    <ColorT,Order>::blend_pix,
+        comp_op_rgba_src_atop   <ColorT,Order>::blend_pix,
+        comp_op_rgba_dst_atop   <ColorT,Order>::blend_pix,
+        comp_op_rgba_xor        <ColorT,Order>::blend_pix,
+        comp_op_rgba_plus       <ColorT,Order>::blend_pix,
+        comp_op_rgba_minus      <ColorT,Order>::blend_pix,
+        comp_op_rgba_multiply   <ColorT,Order>::blend_pix,
+        comp_op_rgba_screen     <ColorT,Order>::blend_pix,
+        comp_op_rgba_overlay    <ColorT,Order>::blend_pix,
+        comp_op_rgba_darken     <ColorT,Order>::blend_pix,
+        comp_op_rgba_lighten    <ColorT,Order>::blend_pix,
+        comp_op_rgba_color_dodge<ColorT,Order>::blend_pix,
+        comp_op_rgba_color_burn <ColorT,Order>::blend_pix,
+        comp_op_rgba_hard_light <ColorT,Order>::blend_pix,
+        comp_op_rgba_soft_light <ColorT,Order>::blend_pix,
+        comp_op_rgba_difference <ColorT,Order>::blend_pix,
+        comp_op_rgba_exclusion  <ColorT,Order>::blend_pix,
+        comp_op_rgba_contrast   <ColorT,Order>::blend_pix,
+        comp_op_rgba_invert     <ColorT,Order>::blend_pix,
+        comp_op_rgba_invert_rgb <ColorT,Order>::blend_pix,
+        0
+    };
+
+
+    //==============================================================comp_op_e
+    enum comp_op_e
+    {
+        comp_op_clear,         //----comp_op_clear
+        comp_op_src,           //----comp_op_src
+        comp_op_dst,           //----comp_op_dst
+        comp_op_src_over,      //----comp_op_src_over
+        comp_op_dst_over,      //----comp_op_dst_over
+        comp_op_src_in,        //----comp_op_src_in
+        comp_op_dst_in,        //----comp_op_dst_in
+        comp_op_src_out,       //----comp_op_src_out
+        comp_op_dst_out,       //----comp_op_dst_out
+        comp_op_src_atop,      //----comp_op_src_atop
+        comp_op_dst_atop,      //----comp_op_dst_atop
+        comp_op_xor,           //----comp_op_xor
+        comp_op_plus,          //----comp_op_plus
+        comp_op_minus,         //----comp_op_minus
+        comp_op_multiply,      //----comp_op_multiply
+        comp_op_screen,        //----comp_op_screen
+        comp_op_overlay,       //----comp_op_overlay
+        comp_op_darken,        //----comp_op_darken
+        comp_op_lighten,       //----comp_op_lighten
+        comp_op_color_dodge,   //----comp_op_color_dodge
+        comp_op_color_burn,    //----comp_op_color_burn
+        comp_op_hard_light,    //----comp_op_hard_light
+        comp_op_soft_light,    //----comp_op_soft_light
+        comp_op_difference,    //----comp_op_difference
+        comp_op_exclusion,     //----comp_op_exclusion
+        comp_op_contrast,      //----comp_op_contrast
+        comp_op_invert,        //----comp_op_invert
+        comp_op_invert_rgb,    //----comp_op_invert_rgb
+
+        end_of_comp_op_e
+    };
+
+
+
+
+
+
+
+    //====================================================comp_op_adaptor_rgba
+    template<class ColorT, class Order> struct comp_op_adaptor_rgba
+    {
+        typedef Order  order_type;
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        {  
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask 
+        };
+
+        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned ca,
+                                         unsigned cover)
+        {
+            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op]
+                (p, (cr * ca + base_mask) >> base_shift, 
+                    (cg * ca + base_mask) >> base_shift,
+                    (cb * ca + base_mask) >> base_shift,
+                     ca, cover);
+        }
+    };
+
+    //=========================================comp_op_adaptor_clip_to_dst_rgba
+    template<class ColorT, class Order> struct comp_op_adaptor_clip_to_dst_rgba
+    {
+        typedef Order  order_type;
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        {  
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask 
+        };
+
+        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned ca,
+                                         unsigned cover)
+        {
+            cr = (cr * ca + base_mask) >> base_shift;
+            cg = (cg * ca + base_mask) >> base_shift;
+            cb = (cb * ca + base_mask) >> base_shift;
+            unsigned da = p[Order::A];
+            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op]
+                (p, (cr * da + base_mask) >> base_shift, 
+                    (cg * da + base_mask) >> base_shift, 
+                    (cb * da + base_mask) >> base_shift, 
+                    (ca * da + base_mask) >> base_shift, 
+                    cover);
+        }
+    };
+
+    //================================================comp_op_adaptor_rgba_pre
+    template<class ColorT, class Order> struct comp_op_adaptor_rgba_pre
+    {
+        typedef Order  order_type;
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        {  
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask 
+        };
+
+        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned ca,
+                                         unsigned cover)
+        {
+            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op](p, cr, cg, cb, ca, cover);
+        }
+    };
+
+    //=====================================comp_op_adaptor_clip_to_dst_rgba_pre
+    template<class ColorT, class Order> struct comp_op_adaptor_clip_to_dst_rgba_pre
+    {
+        typedef Order  order_type;
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        {  
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask 
+        };
+
+        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned ca,
+                                         unsigned cover)
+        {
+            unsigned da = p[Order::A];
+            comp_op_table_rgba<ColorT, Order>::g_comp_op_func[op]
+                (p, (cr * da + base_mask) >> base_shift, 
+                    (cg * da + base_mask) >> base_shift, 
+                    (cb * da + base_mask) >> base_shift, 
+                    (ca * da + base_mask) >> base_shift, 
+                    cover);
+        }
+    };
+
+    //=======================================================comp_adaptor_rgba
+    template<class BlenderPre> struct comp_adaptor_rgba
+    {
+        typedef typename BlenderPre::order_type order_type;
+        typedef typename BlenderPre::color_type color_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        {  
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask 
+        };
+
+        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned ca,
+                                         unsigned cover)
+        {
+            BlenderPre::blend_pix(p, 
+                                  (cr * ca + base_mask) >> base_shift, 
+                                  (cg * ca + base_mask) >> base_shift,
+                                  (cb * ca + base_mask) >> base_shift,
+                                  ca, cover);
+        }
+    };
+
+    //==========================================comp_adaptor_clip_to_dst_rgba
+    template<class BlenderPre> struct comp_adaptor_clip_to_dst_rgba
+    {
+        typedef typename BlenderPre::order_type order_type;
+        typedef typename BlenderPre::color_type color_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        {  
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask 
+        };
+
+        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned ca,
+                                         unsigned cover)
+        {
+            cr = (cr * ca + base_mask) >> base_shift;
+            cg = (cg * ca + base_mask) >> base_shift;
+            cb = (cb * ca + base_mask) >> base_shift;
+            unsigned da = p[order_type::A];
+            BlenderPre::blend_pix(p, 
+                                  (cr * da + base_mask) >> base_shift, 
+                                  (cg * da + base_mask) >> base_shift, 
+                                  (cb * da + base_mask) >> base_shift, 
+                                  (ca * da + base_mask) >> base_shift, 
+                                  cover);
+        }
+    };
+
+    //======================================comp_adaptor_clip_to_dst_rgba_pre
+    template<class BlenderPre> struct comp_adaptor_clip_to_dst_rgba_pre
+    {
+        typedef typename BlenderPre::order_type order_type;
+        typedef typename BlenderPre::color_type color_type;
+        typedef typename color_type::value_type value_type;
+        enum base_scale_e
+        {  
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask 
+        };
+
+        static AGG_INLINE void blend_pix(unsigned op, value_type* p, 
+                                         unsigned cr, unsigned cg, unsigned cb,
+                                         unsigned ca,
+                                         unsigned cover)
+        {
+            unsigned da = p[order_type::A];
+            BlenderPre::blend_pix(p, 
+                                  (cr * da + base_mask) >> base_shift, 
+                                  (cg * da + base_mask) >> base_shift, 
+                                  (cb * da + base_mask) >> base_shift, 
+                                  (ca * da + base_mask) >> base_shift, 
+                                  cover);
+        }
+    };
+
+
+
+
+
+
+    //===============================================copy_or_blend_rgba_wrapper
+    template<class Blender> struct copy_or_blend_rgba_wrapper
+    {
+        typedef typename Blender::color_type color_type;
+        typedef typename Blender::order_type order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_scale = color_type::base_scale,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
+                                                 unsigned cr, unsigned cg, unsigned cb,
+                                                 unsigned alpha)
+        {
+            if(alpha)
+            {
+                if(alpha == base_mask)
+                {
+                    p[order_type::R] = cr;
+                    p[order_type::G] = cg;
+                    p[order_type::B] = cb;
+                    p[order_type::A] = base_mask;
+                }
+                else
+                {
+                    Blender::blend_pix(p, cr, cg, cb, alpha);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        static AGG_INLINE void copy_or_blend_pix(value_type* p, 
+                                                 unsigned cr, unsigned cg, unsigned cb,
+                                                 unsigned alpha,
+                                                 unsigned cover)
+        {
+            if(cover == 255)
+            {
+                copy_or_blend_pix(p, cr, cg, cb, alpha);
+            }
+            else
+            {
+                if(alpha)
+                {
+                    alpha = (alpha * (cover + 1)) >> 8;
+                    if(alpha == base_mask)
+                    {
+                        p[order_type::R] = cr;
+                        p[order_type::G] = cg;
+                        p[order_type::B] = cb;
+                        p[order_type::A] = base_mask;
+                    }
+                    else
+                    {
+                        Blender::blend_pix(p, cr, cg, cb, alpha, cover);
+                    }
+                }
+            }
+        }
+    };
+
+
+
+
+
+    
+    //=================================================pixfmt_alpha_blend_rgba
+    template<class Blender, class RenBuf, class PixelT = int32u> 
+    class pixfmt_alpha_blend_rgba
+    {
+    public:
+        typedef RenBuf   rbuf_type;
+        typedef typename rbuf_type::row_data row_data;
+        typedef PixelT   pixel_type;
+        typedef Blender  blender_type;
+        typedef typename blender_type::color_type color_type;
+        typedef typename blender_type::order_type order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        typedef copy_or_blend_rgba_wrapper<blender_type> cob_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_scale = color_type::base_scale,
+            base_mask  = color_type::base_mask,
+            pix_width  = sizeof(pixel_type)
+        };
+
+        //--------------------------------------------------------------------
+        pixfmt_alpha_blend_rgba() : m_rbuf(0) {}
+        explicit pixfmt_alpha_blend_rgba(rbuf_type& rb) : m_rbuf(&rb) {}
+        void attach(rbuf_type& rb) { m_rbuf = &rb; }
+
+        //--------------------------------------------------------------------
+        template<class PixFmt>
+        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
+        {
+            rect_i r(x1, y1, x2, y2);
+            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
+            {
+                int stride = pixf.stride();
+                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
+                               (r.x2 - r.x1) + 1,
+                               (r.y2 - r.y1) + 1,
+                               stride);
+                return true;
+            }
+            return false;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
+        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
+        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
+        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
+        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE int8u* pix_ptr(int x, int y)
+        {
+            return m_rbuf->row_ptr(y) + x * pix_width;
+        }
+
+        AGG_INLINE const int8u* pix_ptr(int x, int y) const
+        {
+            return m_rbuf->row_ptr(y) + x * pix_width;
+        }
+
+
+        //--------------------------------------------------------------------
+        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
+        {
+            ((value_type*)p)[order_type::R] = c.r;
+            ((value_type*)p)[order_type::G] = c.g;
+            ((value_type*)p)[order_type::B] = c.b;
+            ((value_type*)p)[order_type::A] = c.a;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE color_type pixel(int x, int y) const
+        {
+            const value_type* p = (const value_type*)m_rbuf->row_ptr(y);
+            if(p)
+            {
+                p += x << 2;
+                return color_type(p[order_type::R], 
+                                  p[order_type::G], 
+                                  p[order_type::B], 
+                                  p[order_type::A]);
+            }
+            return color_type::no_color();
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2);
+            p[order_type::R] = c.r;
+            p[order_type::G] = c.g;
+            p[order_type::B] = c.b;
+            p[order_type::A] = c.a;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_pixel(int x, int y, const color_type& c, int8u cover)
+        {
+            cob_type::copy_or_blend_pix(
+                (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2), 
+                c.r, c.g, c.b, c.a, 
+                cover);
+        }
+
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_hline(int x, int y, 
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+            pixel_type v;
+            ((value_type*)&v)[order_type::R] = c.r;
+            ((value_type*)&v)[order_type::G] = c.g;
+            ((value_type*)&v)[order_type::B] = c.b;
+            ((value_type*)&v)[order_type::A] = c.a;
+            do
+            {
+                *(pixel_type*)p = v;
+                p += 4;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_vline(int x, int y,
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            pixel_type v;
+            ((value_type*)&v)[order_type::R] = c.r;
+            ((value_type*)&v)[order_type::G] = c.g;
+            ((value_type*)&v)[order_type::B] = c.b;
+            ((value_type*)&v)[order_type::A] = c.a;
+            do
+            {
+                value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                *(pixel_type*)p = v;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    pixel_type v;
+                    ((value_type*)&v)[order_type::R] = c.r;
+                    ((value_type*)&v)[order_type::G] = c.g;
+                    ((value_type*)&v)[order_type::B] = c.b;
+                    ((value_type*)&v)[order_type::A] = c.a;
+                    do
+                    {
+                        *(pixel_type*)p = v;
+                        p += 4;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    if(cover == 255)
+                    {
+                        do
+                        {
+                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha);
+                            p += 4;
+                        }
+                        while(--len);
+                    }
+                    else
+                    {
+                        do
+                        {
+                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha, cover);
+                            p += 4;
+                        }
+                        while(--len);
+                    }
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y,
+                         unsigned len, 
+                         const color_type& c,
+                         int8u cover)
+        {
+            if (c.a)
+            {
+                value_type* p;
+                calc_type alpha = (calc_type(c.a) * (cover + 1)) >> 8;
+                if(alpha == base_mask)
+                {
+                    pixel_type v;
+                    ((value_type*)&v)[order_type::R] = c.r;
+                    ((value_type*)&v)[order_type::G] = c.g;
+                    ((value_type*)&v)[order_type::B] = c.b;
+                    ((value_type*)&v)[order_type::A] = c.a;
+                    do
+                    {
+                        p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                        *(pixel_type*)p = v;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    if(cover == 255)
+                    {
+                        do
+                        {
+                            p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha);
+                        }
+                        while(--len);
+                    }
+                    else
+                    {
+                        do
+                        {
+                            p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                            blender_type::blend_pix(p, c.r, c.g, c.b, alpha, cover);
+                        }
+                        while(--len);
+                    }
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            if (c.a)
+            {
+                value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+                do 
+                {
+                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
+                    if(alpha == base_mask)
+                    {
+                        p[order_type::R] = c.r;
+                        p[order_type::G] = c.g;
+                        p[order_type::B] = c.b;
+                        p[order_type::A] = base_mask;
+                    }
+                    else
+                    {
+                        blender_type::blend_pix(p, c.r, c.g, c.b, alpha, *covers);
+                    }
+                    p += 4;
+                    ++covers;
+                }
+                while(--len);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type& c,
+                               const int8u* covers)
+        {
+            if (c.a)
+            {
+                do 
+                {
+                    value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                    calc_type alpha = (calc_type(c.a) * (calc_type(*covers) + 1)) >> 8;
+                    if(alpha == base_mask)
+                    {
+                        p[order_type::R] = c.r;
+                        p[order_type::G] = c.g;
+                        p[order_type::B] = c.b;
+                        p[order_type::A] = base_mask;
+                    }
+                    else
+                    {
+                        blender_type::blend_pix(p, c.r, c.g, c.b, alpha, *covers);
+                    }
+                    ++covers;
+                }
+                while(--len);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+            do 
+            {
+                p[order_type::R] = colors->r;
+                p[order_type::G] = colors->g;
+                p[order_type::B] = colors->b;
+                p[order_type::A] = colors->a;
+                ++colors;
+                p += 4;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_vspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            do 
+            {
+                value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                p[order_type::R] = colors->r;
+                p[order_type::G] = colors->g;
+                p[order_type::B] = colors->b;
+                p[order_type::A] = colors->a;
+                ++colors;
+            }
+            while(--len);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+            if(covers)
+            {
+                do 
+                {
+                    cob_type::copy_or_blend_pix(p, 
+                                                colors->r, 
+                                                colors->g, 
+                                                colors->b, 
+                                                colors->a, 
+                                                *covers++);
+                    p += 4;
+                    ++colors;
+                }
+                while(--len);
+            }
+            else
+            {
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        cob_type::copy_or_blend_pix(p, 
+                                                    colors->r, 
+                                                    colors->g, 
+                                                    colors->b, 
+                                                    colors->a);
+                        p += 4;
+                        ++colors;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        cob_type::copy_or_blend_pix(p, 
+                                                    colors->r, 
+                                                    colors->g, 
+                                                    colors->b, 
+                                                    colors->a, 
+                                                    cover);
+                        p += 4;
+                        ++colors;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            value_type* p;
+            if(covers)
+            {
+                do 
+                {
+                    p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                    cob_type::copy_or_blend_pix(p, 
+                                                colors->r, 
+                                                colors->g, 
+                                                colors->b, 
+                                                colors->a,
+                                                *covers++);
+                    ++colors;
+                }
+                while(--len);
+            }
+            else
+            {
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                        cob_type::copy_or_blend_pix(p, 
+                                                    colors->r, 
+                                                    colors->g, 
+                                                    colors->b, 
+                                                    colors->a);
+                        ++colors;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                        cob_type::copy_or_blend_pix(p, 
+                                                    colors->r, 
+                                                    colors->g, 
+                                                    colors->b, 
+                                                    colors->a, 
+                                                    cover);
+                        ++colors;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class Function> void for_each_pixel(Function f)
+        {
+            unsigned y;
+            for(y = 0; y < height(); ++y)
+            {
+                row_data r = m_rbuf->row(y);
+                if(r.ptr)
+                {
+                    unsigned len = r.x2 - r.x1 + 1;
+                    value_type* p = 
+                        (value_type*)m_rbuf->row_ptr(r.x1, y, len) + (r.x1 << 2);
+                    do
+                    {
+                        f(p);
+                        p += 4;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void premultiply()
+        {
+            for_each_pixel(multiplier_rgba<color_type, order_type>::premultiply);
+        }
+
+        //--------------------------------------------------------------------
+        void demultiply()
+        {
+            for_each_pixel(multiplier_rgba<color_type, order_type>::demultiply);
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_dir_rgba<color_type, order_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_inv_rgba<color_type, order_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class RenBuf2> void copy_from(const RenBuf2& from, 
+                                               int xdst, int ydst,
+                                               int xsrc, int ysrc,
+                                               unsigned len)
+        {
+            const int8u* p = from.row_ptr(ysrc);
+            if(p)
+            {
+                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
+                        p + xsrc * pix_width, 
+                        len * pix_width);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from(const SrcPixelFormatRenderer& from, 
+                        int xdst, int ydst,
+                        int xsrc, int ysrc,
+                        unsigned len,
+                        int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::order_type src_order;
+            const value_type* psrc = (value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                psrc += xsrc << 2;
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
+                int incp = 4;
+                if(xdst > xsrc)
+                {
+                    psrc += (len-1) << 2;
+                    pdst += (len-1) << 2;
+                    incp = -4;
+                }
+
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        cob_type::copy_or_blend_pix(pdst, 
+                                                    psrc[src_order::R],
+                                                    psrc[src_order::G],
+                                                    psrc[src_order::B],
+                                                    psrc[src_order::A]);
+                        psrc += incp;
+                        pdst += incp;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        cob_type::copy_or_blend_pix(pdst, 
+                                                    psrc[src_order::R],
+                                                    psrc[src_order::G],
+                                                    psrc[src_order::B],
+                                                    psrc[src_order::A],
+                                                    cover);
+                        psrc += incp;
+                        pdst += incp;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_color(const SrcPixelFormatRenderer& from, 
+                              const color_type& color,
+                              int xdst, int ydst,
+                              int xsrc, int ysrc,
+                              unsigned len,
+                              int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
+                do 
+                {
+                    cob_type::copy_or_blend_pix(pdst, 
+                                                color.r, color.g, color.b, color.a,
+                                                (*psrc * cover + base_mask) >> base_shift);
+                    ++psrc;
+                    pdst += 4;
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_lut(const SrcPixelFormatRenderer& from, 
+                            const color_type* color_lut,
+                            int xdst, int ydst,
+                            int xsrc, int ysrc,
+                            unsigned len,
+                            int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
+
+                if(cover == 255)
+                {
+                    do 
+                    {
+                        const color_type& color = color_lut[*psrc];
+                        cob_type::copy_or_blend_pix(pdst, 
+                                                    color.r, color.g, color.b, color.a);
+                        ++psrc;
+                        pdst += 4;
+                    }
+                    while(--len);
+                }
+                else
+                {
+                    do 
+                    {
+                        const color_type& color = color_lut[*psrc];
+                        cob_type::copy_or_blend_pix(pdst, 
+                                                    color.r, color.g, color.b, color.a,
+                                                    cover);
+                        ++psrc;
+                        pdst += 4;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+    private:
+        rbuf_type* m_rbuf;
+    };
+
+
+
+
+    //================================================pixfmt_custom_blend_rgba
+    template<class Blender, class RenBuf> class pixfmt_custom_blend_rgba
+    {
+    public:
+        typedef RenBuf   rbuf_type;
+        typedef typename rbuf_type::row_data row_data;
+        typedef Blender  blender_type;
+        typedef typename blender_type::color_type color_type;
+        typedef typename blender_type::order_type order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_scale = color_type::base_scale,
+            base_mask  = color_type::base_mask,
+            pix_width  = sizeof(value_type) * 4 
+        };
+
+
+        //--------------------------------------------------------------------
+        pixfmt_custom_blend_rgba() : m_rbuf(0), m_comp_op(3) {}
+        explicit pixfmt_custom_blend_rgba(rbuf_type& rb, unsigned comp_op=3) : 
+            m_rbuf(&rb),
+            m_comp_op(comp_op)
+        {}
+        void attach(rbuf_type& rb) { m_rbuf = &rb; }
+
+        //--------------------------------------------------------------------
+        template<class PixFmt>
+        bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
+        {
+            rect_i r(x1, y1, x2, y2);
+            if(r.clip(rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
+            {
+                int stride = pixf.stride();
+                m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
+                               (r.x2 - r.x1) + 1,
+                               (r.y2 - r.y1) + 1,
+                               stride);
+                return true;
+            }
+            return false;
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
+        AGG_INLINE unsigned height() const { return m_rbuf->height(); }
+        AGG_INLINE int      stride() const { return m_rbuf->stride(); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE       int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
+        AGG_INLINE const int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
+        AGG_INLINE row_data     row(int y)     const { return m_rbuf->row(y); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE int8u* pix_ptr(int x, int y)
+        {
+            return m_rbuf->row_ptr(y) + x * pix_width;
+        }
+
+        AGG_INLINE const int8u* pix_ptr(int x, int y) const
+        {
+            return m_rbuf->row_ptr(y) + x * pix_width;
+        }
+
+        //--------------------------------------------------------------------
+        void comp_op(unsigned op) { m_comp_op = op; }
+        unsigned comp_op() const  { return m_comp_op; }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE static void make_pix(int8u* p, const color_type& c)
+        {
+            ((value_type*)p)[order_type::R] = c.r;
+            ((value_type*)p)[order_type::G] = c.g;
+            ((value_type*)p)[order_type::B] = c.b;
+            ((value_type*)p)[order_type::A] = c.a;
+        }
+
+        //--------------------------------------------------------------------
+        color_type pixel(int x, int y) const
+        {
+            const value_type* p = (value_type*)m_rbuf->row_ptr(y) + (x << 2);
+            return color_type(p[order_type::R], 
+                              p[order_type::G], 
+                              p[order_type::B], 
+                              p[order_type::A]);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_pixel(int x, int y, const color_type& c)
+        {
+            blender_type::blend_pix(
+                m_comp_op, 
+                (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2), 
+                c.r, c.g, c.b, c.a, 255);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_pixel(int x, int y, const color_type& c, int8u cover)
+        {
+            blender_type::blend_pix(
+                m_comp_op, 
+                (value_type*)m_rbuf->row_ptr(x, y, 1) + (x << 2),
+                c.r, c.g, c.b, c.a, 
+                cover);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_hline(int x, int y, unsigned len, const color_type& c)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);;
+            do
+            {
+                blender_type::blend_pix(m_comp_op, p, c.r, c.g, c.b, c.a, 255);
+                p += 4;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_vline(int x, int y, unsigned len, const color_type& c)
+        {
+            do
+            {
+                blender_type::blend_pix(
+                    m_comp_op, 
+                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2),
+                    c.r, c.g, c.b, c.a, 255);
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x, int y, unsigned len, 
+                         const color_type& c, int8u cover)
+        {
+
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+            do
+            {
+                blender_type::blend_pix(m_comp_op, p, c.r, c.g, c.b, c.a, cover);
+                p += 4;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y, unsigned len, 
+                         const color_type& c, int8u cover)
+        {
+
+            do
+            {
+                blender_type::blend_pix(
+                    m_comp_op, 
+                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2), 
+                    c.r, c.g, c.b, c.a, 
+                    cover);
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y, unsigned len, 
+                               const color_type& c, const int8u* covers)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+            do 
+            {
+                blender_type::blend_pix(m_comp_op, 
+                                        p, c.r, c.g, c.b, c.a, 
+                                        *covers++);
+                p += 4;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y, unsigned len, 
+                               const color_type& c, const int8u* covers)
+        {
+            do 
+            {
+                blender_type::blend_pix(
+                    m_comp_op, 
+                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2), 
+                    c.r, c.g, c.b, c.a, 
+                    *covers++);
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+            do 
+            {
+                p[order_type::R] = colors->r;
+                p[order_type::G] = colors->g;
+                p[order_type::B] = colors->b;
+                p[order_type::A] = colors->a;
+                ++colors;
+                p += 4;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_color_vspan(int x, int y,
+                              unsigned len, 
+                              const color_type* colors)
+        {
+            do 
+            {
+                value_type* p = (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2);
+                p[order_type::R] = colors->r;
+                p[order_type::G] = colors->g;
+                p[order_type::B] = colors->b;
+                p[order_type::A] = colors->a;
+                ++colors;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y, unsigned len, 
+                               const color_type* colors, 
+                               const int8u* covers,
+                               int8u cover)
+        {
+            value_type* p = (value_type*)m_rbuf->row_ptr(x, y, len) + (x << 2);
+            do 
+            {
+                blender_type::blend_pix(m_comp_op, 
+                                        p, 
+                                        colors->r, 
+                                        colors->g, 
+                                        colors->b, 
+                                        colors->a, 
+                                        covers ? *covers++ : cover);
+                p += 4;
+                ++colors;
+            }
+            while(--len);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y, unsigned len, 
+                               const color_type* colors, 
+                               const int8u* covers,
+                               int8u cover)
+        {
+            do 
+            {
+                blender_type::blend_pix(
+                    m_comp_op, 
+                    (value_type*)m_rbuf->row_ptr(x, y++, 1) + (x << 2), 
+                    colors->r,
+                    colors->g,
+                    colors->b,
+                    colors->a,
+                    covers ? *covers++ : cover);
+                ++colors;
+            }
+            while(--len);
+
+        }
+
+        //--------------------------------------------------------------------
+        template<class Function> void for_each_pixel(Function f)
+        {
+            unsigned y;
+            for(y = 0; y < height(); ++y)
+            {
+                row_data r = m_rbuf->row(y);
+                if(r.ptr)
+                {
+                    unsigned len = r.x2 - r.x1 + 1;
+                    value_type* p = 
+                        (value_type*)m_rbuf->row_ptr(r.x1, y, len) + (r.x1 << 2);
+                    do
+                    {
+                        f(p);
+                        p += 4;
+                    }
+                    while(--len);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void premultiply()
+        {
+            for_each_pixel(multiplier_rgba<color_type, order_type>::premultiply);
+        }
+
+        //--------------------------------------------------------------------
+        void demultiply()
+        {
+            for_each_pixel(multiplier_rgba<color_type, order_type>::demultiply);
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_dir(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_dir_rgba<color_type, order_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaLut> void apply_gamma_inv(const GammaLut& g)
+        {
+            for_each_pixel(apply_gamma_inv_rgba<color_type, order_type, GammaLut>(g));
+        }
+
+        //--------------------------------------------------------------------
+        template<class RenBuf2> void copy_from(const RenBuf2& from, 
+                                               int xdst, int ydst,
+                                               int xsrc, int ysrc,
+                                               unsigned len)
+        {
+            const int8u* p = from.row_ptr(ysrc);
+            if(p)
+            {
+                memmove(m_rbuf->row_ptr(xdst, ydst, len) + xdst * pix_width, 
+                        p + xsrc * pix_width, 
+                        len * pix_width);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer> 
+        void blend_from(const SrcPixelFormatRenderer& from, 
+                        int xdst, int ydst,
+                        int xsrc, int ysrc,
+                        unsigned len,
+                        int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::order_type src_order;
+            const value_type* psrc = (const value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                psrc += xsrc << 2;
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
+
+                int incp = 4;
+                if(xdst > xsrc)
+                {
+                    psrc += (len-1) << 2;
+                    pdst += (len-1) << 2;
+                    incp = -4;
+                }
+
+                do 
+                {
+                    blender_type::blend_pix(m_comp_op, 
+                                            pdst, 
+                                            psrc[src_order::R],
+                                            psrc[src_order::G],
+                                            psrc[src_order::B],
+                                            psrc[src_order::A],
+                                            cover);
+                    psrc += incp;
+                    pdst += incp;
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_color(const SrcPixelFormatRenderer& from, 
+                              const color_type& color,
+                              int xdst, int ydst,
+                              int xsrc, int ysrc,
+                              unsigned len,
+                              int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
+                do 
+                {
+                    blender_type::blend_pix(m_comp_op,
+                                            pdst, 
+                                            color.r, color.g, color.b, color.a,
+                                            (*psrc * cover + base_mask) >> base_shift);
+                    ++psrc;
+                    pdst += 4;
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_lut(const SrcPixelFormatRenderer& from, 
+                            const color_type* color_lut,
+                            int xdst, int ydst,
+                            int xsrc, int ysrc,
+                            unsigned len,
+                            int8u cover)
+        {
+            typedef typename SrcPixelFormatRenderer::value_type src_value_type;
+            const src_value_type* psrc = (src_value_type*)from.row_ptr(ysrc);
+            if(psrc)
+            {
+                value_type* pdst = 
+                    (value_type*)m_rbuf->row_ptr(xdst, ydst, len) + (xdst << 2);
+                do 
+                {
+                    const color_type& color = color_lut[*psrc];
+                    blender_type::blend_pix(m_comp_op,
+                                            pdst, 
+                                            color.r, color.g, color.b, color.a,
+                                            cover);
+                    ++psrc;
+                    pdst += 4;
+                }
+                while(--len);
+            }
+        }
+
+    private:
+        rbuf_type* m_rbuf;
+        unsigned m_comp_op;
+    };
+
+
+
+
+    //-----------------------------------------------------------------------
+    typedef blender_rgba<rgba8, order_rgba> blender_rgba32; //----blender_rgba32
+    typedef blender_rgba<rgba8, order_argb> blender_argb32; //----blender_argb32
+    typedef blender_rgba<rgba8, order_abgr> blender_abgr32; //----blender_abgr32
+    typedef blender_rgba<rgba8, order_bgra> blender_bgra32; //----blender_bgra32
+
+    typedef blender_rgba_pre<rgba8, order_rgba> blender_rgba32_pre; //----blender_rgba32_pre
+    typedef blender_rgba_pre<rgba8, order_argb> blender_argb32_pre; //----blender_argb32_pre
+    typedef blender_rgba_pre<rgba8, order_abgr> blender_abgr32_pre; //----blender_abgr32_pre
+    typedef blender_rgba_pre<rgba8, order_bgra> blender_bgra32_pre; //----blender_bgra32_pre
+
+    typedef blender_rgba_plain<rgba8, order_rgba> blender_rgba32_plain; //----blender_rgba32_plain
+    typedef blender_rgba_plain<rgba8, order_argb> blender_argb32_plain; //----blender_argb32_plain
+    typedef blender_rgba_plain<rgba8, order_abgr> blender_abgr32_plain; //----blender_abgr32_plain
+    typedef blender_rgba_plain<rgba8, order_bgra> blender_bgra32_plain; //----blender_bgra32_plain
+
+    typedef blender_rgba<rgba16, order_rgba> blender_rgba64; //----blender_rgba64
+    typedef blender_rgba<rgba16, order_argb> blender_argb64; //----blender_argb64
+    typedef blender_rgba<rgba16, order_abgr> blender_abgr64; //----blender_abgr64
+    typedef blender_rgba<rgba16, order_bgra> blender_bgra64; //----blender_bgra64
+
+    typedef blender_rgba_pre<rgba16, order_rgba> blender_rgba64_pre; //----blender_rgba64_pre
+    typedef blender_rgba_pre<rgba16, order_argb> blender_argb64_pre; //----blender_argb64_pre
+    typedef blender_rgba_pre<rgba16, order_abgr> blender_abgr64_pre; //----blender_abgr64_pre
+    typedef blender_rgba_pre<rgba16, order_bgra> blender_bgra64_pre; //----blender_bgra64_pre
+
+
+    //-----------------------------------------------------------------------
+    typedef int32u pixel32_type;
+    typedef pixfmt_alpha_blend_rgba<blender_rgba32, rendering_buffer, pixel32_type> pixfmt_rgba32; //----pixfmt_rgba32
+    typedef pixfmt_alpha_blend_rgba<blender_argb32, rendering_buffer, pixel32_type> pixfmt_argb32; //----pixfmt_argb32
+    typedef pixfmt_alpha_blend_rgba<blender_abgr32, rendering_buffer, pixel32_type> pixfmt_abgr32; //----pixfmt_abgr32
+    typedef pixfmt_alpha_blend_rgba<blender_bgra32, rendering_buffer, pixel32_type> pixfmt_bgra32; //----pixfmt_bgra32
+
+    typedef pixfmt_alpha_blend_rgba<blender_rgba32_pre, rendering_buffer, pixel32_type> pixfmt_rgba32_pre; //----pixfmt_rgba32_pre
+    typedef pixfmt_alpha_blend_rgba<blender_argb32_pre, rendering_buffer, pixel32_type> pixfmt_argb32_pre; //----pixfmt_argb32_pre
+    typedef pixfmt_alpha_blend_rgba<blender_abgr32_pre, rendering_buffer, pixel32_type> pixfmt_abgr32_pre; //----pixfmt_abgr32_pre
+    typedef pixfmt_alpha_blend_rgba<blender_bgra32_pre, rendering_buffer, pixel32_type> pixfmt_bgra32_pre; //----pixfmt_bgra32_pre
+
+    typedef pixfmt_alpha_blend_rgba<blender_rgba32_plain, rendering_buffer, pixel32_type> pixfmt_rgba32_plain; //----pixfmt_rgba32_plain
+    typedef pixfmt_alpha_blend_rgba<blender_argb32_plain, rendering_buffer, pixel32_type> pixfmt_argb32_plain; //----pixfmt_argb32_plain
+    typedef pixfmt_alpha_blend_rgba<blender_abgr32_plain, rendering_buffer, pixel32_type> pixfmt_abgr32_plain; //----pixfmt_abgr32_plain
+    typedef pixfmt_alpha_blend_rgba<blender_bgra32_plain, rendering_buffer, pixel32_type> pixfmt_bgra32_plain; //----pixfmt_bgra32_plain
+
+    struct  pixel64_type { int16u c[4]; };
+    typedef pixfmt_alpha_blend_rgba<blender_rgba64, rendering_buffer, pixel64_type> pixfmt_rgba64; //----pixfmt_rgba64
+    typedef pixfmt_alpha_blend_rgba<blender_argb64, rendering_buffer, pixel64_type> pixfmt_argb64; //----pixfmt_argb64
+    typedef pixfmt_alpha_blend_rgba<blender_abgr64, rendering_buffer, pixel64_type> pixfmt_abgr64; //----pixfmt_abgr64
+    typedef pixfmt_alpha_blend_rgba<blender_bgra64, rendering_buffer, pixel64_type> pixfmt_bgra64; //----pixfmt_bgra64
+
+    typedef pixfmt_alpha_blend_rgba<blender_rgba64_pre, rendering_buffer, pixel64_type> pixfmt_rgba64_pre; //----pixfmt_rgba64_pre
+    typedef pixfmt_alpha_blend_rgba<blender_argb64_pre, rendering_buffer, pixel64_type> pixfmt_argb64_pre; //----pixfmt_argb64_pre
+    typedef pixfmt_alpha_blend_rgba<blender_abgr64_pre, rendering_buffer, pixel64_type> pixfmt_abgr64_pre; //----pixfmt_abgr64_pre
+    typedef pixfmt_alpha_blend_rgba<blender_bgra64_pre, rendering_buffer, pixel64_type> pixfmt_bgra64_pre; //----pixfmt_bgra64_pre
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_pixfmt_transposer.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_transposer.h
--- 8.0.1-5/src/renderers/agg/include/agg_pixfmt_transposer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_pixfmt_transposer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,157 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_PIXFMT_TRANSPOSER_INCLUDED
+#define AGG_PIXFMT_TRANSPOSER_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //=======================================================pixfmt_transposer
+    template<class PixFmt> class pixfmt_transposer
+    {
+    public:
+        typedef PixFmt pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::row_data row_data;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+
+        //--------------------------------------------------------------------
+        pixfmt_transposer() : m_pixf(0) {}
+        explicit pixfmt_transposer(pixfmt_type& pixf) : m_pixf(&pixf) {}
+        void attach(pixfmt_type& pixf) { m_pixf = &pixf; }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned width()  const { return m_pixf->height();  }
+        AGG_INLINE unsigned height() const { return m_pixf->width(); }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE color_type pixel(int x, int y) const
+        {
+            return m_pixf->pixel(y, x);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
+        {
+            m_pixf->copy_pixel(y, x, c);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_pixel(int x, int y, 
+                                    const color_type& c, 
+                                    int8u cover)
+        {
+            m_pixf->blend_pixel(y, x, c, cover);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_hline(int x, int y, 
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            m_pixf->copy_vline(y, x, len, c);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_vline(int x, int y,
+                                   unsigned len, 
+                                   const color_type& c)
+        {
+            m_pixf->copy_hline(y, x, len, c);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_hline(int x, int y,
+                                    unsigned len, 
+                                    const color_type& c,
+                                    int8u cover)
+        {
+            m_pixf->blend_vline(y, x, len, c, cover);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_vline(int x, int y,
+                                    unsigned len, 
+                                    const color_type& c,
+                                    int8u cover)
+        {
+            m_pixf->blend_hline(y, x, len, c, cover);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_solid_hspan(int x, int y,
+                                          unsigned len, 
+                                          const color_type& c,
+                                          const int8u* covers)
+        {
+            m_pixf->blend_solid_vspan(y, x, len, c, covers);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_solid_vspan(int x, int y,
+                                          unsigned len, 
+                                          const color_type& c,
+                                          const int8u* covers)
+        {
+            m_pixf->blend_solid_hspan(y, x, len, c, covers);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_color_hspan(int x, int y,
+                                         unsigned len, 
+                                         const color_type* colors)
+        {
+            m_pixf->copy_color_vspan(y, x, len, colors);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void copy_color_vspan(int x, int y,
+                                         unsigned len, 
+                                         const color_type* colors)
+        {
+            m_pixf->copy_color_hspan(y, x, len, colors);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_color_hspan(int x, int y,
+                                          unsigned len, 
+                                          const color_type* colors,
+                                          const int8u* covers,
+                                          int8u cover)
+        {
+            m_pixf->blend_color_vspan(y, x, len, colors, covers, cover);
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE void blend_color_vspan(int x, int y,
+                               unsigned len, 
+                               const color_type* colors,
+                               const int8u* covers,
+                               int8u cover)
+        {
+            m_pixf->blend_color_hspan(y, x, len, colors, covers, cover);
+        }
+
+    private:
+        pixfmt_type* m_pixf;
+    };
+}
+
+#endif
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rasterizer_cells_aa.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_cells_aa.h
--- 8.0.1-5/src/renderers/agg/include/agg_rasterizer_cells_aa.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_cells_aa.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,758 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+//
+// The author gratefully acknowleges the support of David Turner, 
+// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
+// libray - in producing this work. See http://www.freetype.org for details.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+#ifndef AGG_RASTERIZER_CELLS_AA_INCLUDED
+#define AGG_RASTERIZER_CELLS_AA_INCLUDED
+
+#include <string.h>
+#include <math.h>
+#include "agg_math.h"
+#include "agg_array.h"
+
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------rasterizer_cells_aa
+    // An internal class that implements the main rasterization algorithm.
+    // Used in the rasterizer. Should not be used direcly.
+    template<class Cell> class rasterizer_cells_aa
+    {
+        enum cell_block_scale_e
+        {
+            cell_block_shift = 12,
+            cell_block_size  = 1 << cell_block_shift,
+            cell_block_mask  = cell_block_size - 1,
+            cell_block_pool  = 256,
+            cell_block_limit = 1024
+        };
+
+        struct sorted_y
+        {
+            unsigned start;
+            unsigned num;
+        };
+
+    public:
+        typedef Cell cell_type;
+        typedef rasterizer_cells_aa<Cell> self_type;
+
+        ~rasterizer_cells_aa();
+        rasterizer_cells_aa();
+
+        void reset();
+        void style(const cell_type& style_cell);
+        void line(int x1, int y1, int x2, int y2);
+
+        int min_x() const { return m_min_x; }
+        int min_y() const { return m_min_y; }
+        int max_x() const { return m_max_x; }
+        int max_y() const { return m_max_y; }
+
+        void sort_cells();
+
+        unsigned total_cells() const 
+        {
+            return m_num_cells;
+        }
+
+        unsigned scanline_num_cells(unsigned y) const 
+        { 
+            return m_sorted_y[y - m_min_y].num; 
+        }
+
+        const cell_type* const* scanline_cells(unsigned y) const
+        { 
+            return m_sorted_cells.data() + m_sorted_y[y - m_min_y].start; 
+        }
+
+        bool sorted() const { return m_sorted; }
+
+    private:
+        rasterizer_cells_aa(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        void set_curr_cell(int x, int y);
+        void add_curr_cell();
+        void render_hline(int ey, int x1, int y1, int x2, int y2);
+        void allocate_block();
+        
+    private:
+        unsigned                m_num_blocks;
+        unsigned                m_max_blocks;
+        unsigned                m_curr_block;
+        unsigned                m_num_cells;
+        cell_type**             m_cells;
+        cell_type*              m_curr_cell_ptr;
+        pod_vector<cell_type*>  m_sorted_cells;
+        pod_vector<sorted_y>    m_sorted_y;
+        cell_type               m_curr_cell;
+        cell_type               m_style_cell;
+        int                     m_min_x;
+        int                     m_min_y;
+        int                     m_max_x;
+        int                     m_max_y;
+        bool                    m_sorted;
+    };
+
+
+
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    rasterizer_cells_aa<Cell>::~rasterizer_cells_aa()
+    {
+        if(m_num_blocks)
+        {
+            cell_type** ptr = m_cells + m_num_blocks - 1;
+            while(m_num_blocks--)
+            {
+                pod_allocator<cell_type>::deallocate(*ptr, cell_block_size);
+                ptr--;
+            }
+            pod_allocator<cell_type*>::deallocate(m_cells, m_max_blocks);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    rasterizer_cells_aa<Cell>::rasterizer_cells_aa() :
+        m_num_blocks(0),
+        m_max_blocks(0),
+        m_curr_block(0),
+        m_num_cells(0),
+        m_cells(0),
+        m_curr_cell_ptr(0),
+        m_sorted_cells(),
+        m_sorted_y(),
+        m_min_x(0x7FFFFFFF),
+        m_min_y(0x7FFFFFFF),
+        m_max_x(-0x7FFFFFFF),
+        m_max_y(-0x7FFFFFFF),
+        m_sorted(false)
+    {
+        m_style_cell.initial();
+        m_curr_cell.initial();
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    void rasterizer_cells_aa<Cell>::reset()
+    {
+        m_num_cells = 0; 
+        m_curr_block = 0;
+        m_curr_cell.initial();
+        m_style_cell.initial();
+        m_sorted = false;
+        m_min_x =  0x7FFFFFFF;
+        m_min_y =  0x7FFFFFFF;
+        m_max_x = -0x7FFFFFFF;
+        m_max_y = -0x7FFFFFFF;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    AGG_INLINE void rasterizer_cells_aa<Cell>::add_curr_cell()
+    {
+        if(m_curr_cell.area | m_curr_cell.cover)
+        {
+            if((m_num_cells & cell_block_mask) == 0)
+            {
+                if(m_num_blocks >= cell_block_limit) return;
+                allocate_block();
+            }
+            *m_curr_cell_ptr++ = m_curr_cell;
+            ++m_num_cells;
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    AGG_INLINE void rasterizer_cells_aa<Cell>::set_curr_cell(int x, int y)
+    {
+        if(m_curr_cell.not_equal(x, y, m_style_cell))
+        {
+            add_curr_cell();
+            m_curr_cell.style(m_style_cell);
+            m_curr_cell.x     = x;
+            m_curr_cell.y     = y;
+            m_curr_cell.cover = 0;
+            m_curr_cell.area  = 0;
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    AGG_INLINE void rasterizer_cells_aa<Cell>::render_hline(int ey, 
+                                                            int x1, int y1, 
+                                                            int x2, int y2)
+    {
+        int ex1 = x1 >> poly_subpixel_shift;
+        int ex2 = x2 >> poly_subpixel_shift;
+        int fx1 = x1 & poly_subpixel_mask;
+        int fx2 = x2 & poly_subpixel_mask;
+
+        int delta, p, first, dx;
+        int incr, lift, mod, rem;
+
+        //trivial case. Happens often
+        if(y1 == y2)
+        {
+            set_curr_cell(ex2, ey);
+            return;
+        }
+
+        //everything is located in a single cell.  That is easy!
+        if(ex1 == ex2)
+        {
+            delta = y2 - y1;
+            m_curr_cell.cover += delta;
+            m_curr_cell.area  += (fx1 + fx2) * delta;
+            return;
+        }
+
+        //ok, we'll have to render a run of adjacent cells on the same
+        //hline...
+        p     = (poly_subpixel_scale - fx1) * (y2 - y1);
+        first = poly_subpixel_scale;
+        incr  = 1;
+
+        dx = x2 - x1;
+
+        if(dx < 0)
+        {
+            p     = fx1 * (y2 - y1);
+            first = 0;
+            incr  = -1;
+            dx    = -dx;
+        }
+
+        delta = p / dx;
+        mod   = p % dx;
+
+        if(mod < 0)
+        {
+            delta--;
+            mod += dx;
+        }
+
+        m_curr_cell.cover += delta;
+        m_curr_cell.area  += (fx1 + first) * delta;
+
+        ex1 += incr;
+        set_curr_cell(ex1, ey);
+        y1  += delta;
+
+        if(ex1 != ex2)
+        {
+            p     = poly_subpixel_scale * (y2 - y1 + delta);
+            lift  = p / dx;
+            rem   = p % dx;
+
+            if (rem < 0)
+            {
+                lift--;
+                rem += dx;
+            }
+
+            mod -= dx;
+
+            while (ex1 != ex2)
+            {
+                delta = lift;
+                mod  += rem;
+                if(mod >= 0)
+                {
+                    mod -= dx;
+                    delta++;
+                }
+
+                m_curr_cell.cover += delta;
+                m_curr_cell.area  += poly_subpixel_scale * delta;
+                y1  += delta;
+                ex1 += incr;
+                set_curr_cell(ex1, ey);
+            }
+        }
+        delta = y2 - y1;
+        m_curr_cell.cover += delta;
+        m_curr_cell.area  += (fx2 + poly_subpixel_scale - first) * delta;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    AGG_INLINE void rasterizer_cells_aa<Cell>::style(const cell_type& style_cell)
+    { 
+        m_style_cell.style(style_cell); 
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    void rasterizer_cells_aa<Cell>::line(int x1, int y1, int x2, int y2)
+    {
+        enum dx_limit_e { dx_limit = 16384 << poly_subpixel_shift };
+
+        // Checking the limit and avoid integer overflows
+        if(((x1 < x2)? ((x1 < 0)? (x1 + dx_limit <= x2) : (x1 <= x2 - dx_limit)) : 
+                      ((x2 < 0)? (x2 + dx_limit <= x1) : (x2 <= x1 - dx_limit))) ||
+           ((y1 < y2)? ((y1 < 0)? (y1 + dx_limit <= y2) : (y1 <= y2 - dx_limit)) : 
+                      ((y2 < 0)? (y2 + dx_limit <= y1) : (y2 <= y1 - dx_limit))))
+        {
+            int cx = (x2&x1) + ((x2^x1)>>1);
+            int cy = (y2&y1) + ((y2^y1)>>1);
+
+            line(x1, y1, cx, cy);
+            line(cx, cy, x2, y2);
+        }
+
+        int dx = x2 - x1;
+        int dy = y2 - y1;
+        int ex1 = x1 >> poly_subpixel_shift;
+        int ex2 = x2 >> poly_subpixel_shift;
+        int ey1 = y1 >> poly_subpixel_shift;
+        int ey2 = y2 >> poly_subpixel_shift;
+        int fy1 = y1 & poly_subpixel_mask;
+        int fy2 = y2 & poly_subpixel_mask;
+
+        int x_from, x_to;
+        int p, rem, mod, lift, delta, first, incr;
+
+        if(ex1 < m_min_x) m_min_x = ex1;
+        if(ex1 > m_max_x) m_max_x = ex1;
+        if(ey1 < m_min_y) m_min_y = ey1;
+        if(ey1 > m_max_y) m_max_y = ey1;
+        if(ex2 < m_min_x) m_min_x = ex2;
+        if(ex2 > m_max_x) m_max_x = ex2;
+        if(ey2 < m_min_y) m_min_y = ey2;
+        if(ey2 > m_max_y) m_max_y = ey2;
+
+        set_curr_cell(ex1, ey1);
+
+        //everything is on a single hline
+        if(ey1 == ey2)
+        {
+            render_hline(ey1, x1, fy1, x2, fy2);
+            return;
+        }
+
+        //Vertical line - we have to calculate start and end cells,
+        //and then - the common values of the area and coverage for
+        //all cells of the line. We know exactly there's only one 
+        //cell, so, we don't have to call render_hline().
+        incr  = 1;
+        if(dx == 0)
+        {
+            int ex = x1 >> poly_subpixel_shift;
+            int two_fx = (x1 - (ex << poly_subpixel_shift)) << 1;
+            int area;
+
+            first = poly_subpixel_scale;
+            if(dy < 0)
+            {
+                first = 0;
+                incr  = -1;
+            }
+
+            x_from = x1;
+
+            //render_hline(ey1, x_from, fy1, x_from, first);
+            delta = first - fy1;
+            m_curr_cell.cover += delta;
+            m_curr_cell.area  += two_fx * delta;
+
+            ey1 += incr;
+            set_curr_cell(ex, ey1);
+
+            delta = first + first - poly_subpixel_scale;
+            area = two_fx * delta;
+            while(ey1 != ey2)
+            {
+                //render_hline(ey1, x_from, poly_subpixel_scale - first, x_from, first);
+                m_curr_cell.cover = delta;
+                m_curr_cell.area  = area;
+                ey1 += incr;
+                set_curr_cell(ex, ey1);
+            }
+            //render_hline(ey1, x_from, poly_subpixel_scale - first, x_from, fy2);
+            delta = fy2 - poly_subpixel_scale + first;
+            m_curr_cell.cover += delta;
+            m_curr_cell.area  += two_fx * delta;
+            return;
+        }
+
+        //ok, we have to render several hlines
+        p     = (poly_subpixel_scale - fy1) * dx;
+        first = poly_subpixel_scale;
+
+        if(dy < 0)
+        {
+            p     = fy1 * dx;
+            first = 0;
+            incr  = -1;
+            dy    = -dy;
+        }
+
+        delta = p / dy;
+        mod   = p % dy;
+
+        if(mod < 0)
+        {
+            delta--;
+            mod += dy;
+        }
+
+        x_from = x1 + delta;
+        render_hline(ey1, x1, fy1, x_from, first);
+
+        ey1 += incr;
+        set_curr_cell(x_from >> poly_subpixel_shift, ey1);
+
+        if(ey1 != ey2)
+        {
+            p     = poly_subpixel_scale * dx;
+            lift  = p / dy;
+            rem   = p % dy;
+
+            if(rem < 0)
+            {
+                lift--;
+                rem += dy;
+            }
+            mod -= dy;
+
+            while(ey1 != ey2)
+            {
+                delta = lift;
+                mod  += rem;
+                if (mod >= 0)
+                {
+                    mod -= dy;
+                    delta++;
+                }
+
+                x_to = x_from + delta;
+                render_hline(ey1, x_from, poly_subpixel_scale - first, x_to, first);
+                x_from = x_to;
+
+                ey1 += incr;
+                set_curr_cell(x_from >> poly_subpixel_shift, ey1);
+            }
+        }
+        render_hline(ey1, x_from, poly_subpixel_scale - first, x2, fy2);
+    }
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    void rasterizer_cells_aa<Cell>::allocate_block()
+    {
+        if(m_curr_block >= m_num_blocks)
+        {
+            if(m_num_blocks >= m_max_blocks)
+            {
+                cell_type** new_cells = 
+                    pod_allocator<cell_type*>::allocate(m_max_blocks + 
+                                                        cell_block_pool);
+
+                if(m_cells)
+                {
+                    memcpy(new_cells, m_cells, m_max_blocks * sizeof(cell_type*));
+                    pod_allocator<cell_type*>::deallocate(m_cells, m_max_blocks);
+                }
+                m_cells = new_cells;
+                m_max_blocks += cell_block_pool;
+            }
+
+            m_cells[m_num_blocks++] = 
+                pod_allocator<cell_type>::allocate(cell_block_size);
+
+        }
+        m_curr_cell_ptr = m_cells[m_curr_block++];
+    }
+
+
+
+    //------------------------------------------------------------------------
+    template <class T> static AGG_INLINE void swap_cells(T* a, T* b)
+    {
+        T temp = *a;
+        *a = *b;
+        *b = temp;
+    }
+
+
+    //------------------------------------------------------------------------
+    enum
+    {
+        qsort_threshold = 9
+    };
+
+
+    //------------------------------------------------------------------------
+    template<class Cell>
+    void qsort_cells(Cell** start, unsigned num)
+    {
+        Cell**  stack[80];
+        Cell*** top; 
+        Cell**  limit;
+        Cell**  base;
+
+        limit = start + num;
+        base  = start;
+        top   = stack;
+
+        for (;;)
+        {
+            int len = int(limit - base);
+
+            Cell** i;
+            Cell** j;
+            Cell** pivot;
+
+            if(len > qsort_threshold)
+            {
+                // we use base + len/2 as the pivot
+                pivot = base + len / 2;
+                swap_cells(base, pivot);
+
+                i = base + 1;
+                j = limit - 1;
+
+                // now ensure that *i <= *base <= *j 
+                if((*j)->x < (*i)->x)
+                {
+                    swap_cells(i, j);
+                }
+
+                if((*base)->x < (*i)->x)
+                {
+                    swap_cells(base, i);
+                }
+
+                if((*j)->x < (*base)->x)
+                {
+                    swap_cells(base, j);
+                }
+
+                for(;;)
+                {
+                    int x = (*base)->x;
+                    do i++; while( (*i)->x < x );
+                    do j--; while( x < (*j)->x );
+
+                    if(i > j)
+                    {
+                        break;
+                    }
+
+                    swap_cells(i, j);
+                }
+
+                swap_cells(base, j);
+
+                // now, push the largest sub-array
+                if(j - base > limit - i)
+                {
+                    top[0] = base;
+                    top[1] = j;
+                    base   = i;
+                }
+                else
+                {
+                    top[0] = i;
+                    top[1] = limit;
+                    limit  = j;
+                }
+                top += 2;
+            }
+            else
+            {
+                // the sub-array is small, perform insertion sort
+                j = base;
+                i = j + 1;
+
+                for(; i < limit; j = i, i++)
+                {
+                    for(; j[1]->x < (*j)->x; j--)
+                    {
+                        swap_cells(j + 1, j);
+                        if (j == base)
+                        {
+                            break;
+                        }
+                    }
+                }
+
+                if(top > stack)
+                {
+                    top  -= 2;
+                    base  = top[0];
+                    limit = top[1];
+                }
+                else
+                {
+                    break;
+                }
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class Cell> 
+    void rasterizer_cells_aa<Cell>::sort_cells()
+    {
+        if(m_sorted) return; //Perform sort only the first time.
+
+        add_curr_cell();
+        m_curr_cell.x     = 0x7FFFFFFF;
+        m_curr_cell.y     = 0x7FFFFFFF;
+        m_curr_cell.cover = 0;
+        m_curr_cell.area  = 0;
+
+        if(m_num_cells == 0) return;
+
+// DBG: Check to see if min/max works well.
+//for(unsigned nc = 0; nc < m_num_cells; nc++)
+//{
+//    cell_type* cell = m_cells[nc >> cell_block_shift] + (nc & cell_block_mask);
+//    if(cell->x < m_min_x || 
+//       cell->y < m_min_y || 
+//       cell->x > m_max_x || 
+//       cell->y > m_max_y)
+//    {
+//        cell = cell; // Breakpoint here
+//    }
+//}
+        // Allocate the array of cell pointers
+        m_sorted_cells.allocate(m_num_cells, 16);
+
+        // Allocate and zero the Y array
+        m_sorted_y.allocate(m_max_y - m_min_y + 1, 16);
+        m_sorted_y.zero();
+
+        // Create the Y-histogram (count the numbers of cells for each Y)
+        cell_type** block_ptr = m_cells;
+        cell_type*  cell_ptr;
+        unsigned nb = m_num_cells >> cell_block_shift;
+        unsigned i;
+        while(nb--)
+        {
+            cell_ptr = *block_ptr++;
+            i = cell_block_size;
+            while(i--) 
+            {
+                m_sorted_y[cell_ptr->y - m_min_y].start++;
+                ++cell_ptr;
+            }
+        }
+
+        cell_ptr = *block_ptr++;
+        i = m_num_cells & cell_block_mask;
+        while(i--) 
+        {
+            m_sorted_y[cell_ptr->y - m_min_y].start++;
+            ++cell_ptr;
+        }
+
+        // Convert the Y-histogram into the array of starting indexes
+        unsigned start = 0;
+        for(i = 0; i < m_sorted_y.size(); i++)
+        {
+            unsigned v = m_sorted_y[i].start;
+            m_sorted_y[i].start = start;
+            start += v;
+        }
+
+        // Fill the cell pointer array sorted by Y
+        block_ptr = m_cells;
+        nb = m_num_cells >> cell_block_shift;
+        while(nb--)
+        {
+            cell_ptr = *block_ptr++;
+            i = cell_block_size;
+            while(i--) 
+            {
+                sorted_y& curr_y = m_sorted_y[cell_ptr->y - m_min_y];
+                m_sorted_cells[curr_y.start + curr_y.num] = cell_ptr;
+                ++curr_y.num;
+                ++cell_ptr;
+            }
+        }
+        
+        cell_ptr = *block_ptr++;
+        i = m_num_cells & cell_block_mask;
+        while(i--) 
+        {
+            sorted_y& curr_y = m_sorted_y[cell_ptr->y - m_min_y];
+            m_sorted_cells[curr_y.start + curr_y.num] = cell_ptr;
+            ++curr_y.num;
+            ++cell_ptr;
+        }
+
+        // Finally arrange the X-arrays
+        for(i = 0; i < m_sorted_y.size(); i++)
+        {
+            const sorted_y& curr_y = m_sorted_y[i];
+            if(curr_y.num)
+            {
+                qsort_cells(m_sorted_cells.data() + curr_y.start, curr_y.num);
+            }
+        }
+        m_sorted = true;
+    }
+
+
+
+    //------------------------------------------------------scanline_hit_test
+    class scanline_hit_test
+    {
+    public:
+        scanline_hit_test(int x) : m_x(x), m_hit(false) {}
+
+        void reset_spans() {}
+        void finalize(int) {}
+        void add_cell(int x, int)
+        {
+            if(m_x == x) m_hit = true;
+        }
+        void add_span(int x, int len, int)
+        {
+            if(m_x >= x && m_x < x+len) m_hit = true;
+        }
+        unsigned num_spans() const { return 1; }
+        bool hit() const { return m_hit; }
+
+    private:
+        int  m_x;
+        bool m_hit;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rasterizer_compound_aa.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_compound_aa.h
--- 8.0.1-5/src/renderers/agg/include/agg_rasterizer_compound_aa.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_compound_aa.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,698 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+//
+// The author gratefully acknowleges the support of David Turner, 
+// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
+// libray - in producing this work. See http://www.freetype.org for details.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+#ifndef AGG_RASTERIZER_COMPOUND_AA_INCLUDED
+#define AGG_RASTERIZER_COMPOUND_AA_INCLUDED
+
+#include "agg_rasterizer_cells_aa.h"
+#include "agg_rasterizer_sl_clip.h"
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------------cell_style_aa
+    // A pixel cell. There're no constructors defined and it was done 
+    // intentionally in order to avoid extra overhead when allocating an 
+    // array of cells.
+    struct cell_style_aa
+    {
+        int   x;
+        int   y;
+        int   cover;
+        int   area;
+        int16 left, right;
+
+        void initial()
+        {
+            x     = 0x7FFFFFFF;
+            y     = 0x7FFFFFFF;
+            cover = 0;
+            area  = 0;
+            left  = -1;
+            right = -1;
+        }
+
+        void style(const cell_style_aa& c)
+        {
+            left  = c.left;
+            right = c.right;
+        }
+
+        int not_equal(int ex, int ey, const cell_style_aa& c) const
+        {
+            return (ex - x) | (ey - y) | (left - c.left) | (right - c.right);
+        }
+    };
+
+
+    //===========================================================layer_order_e
+    enum layer_order_e
+    {
+        layer_unsorted, //------layer_unsorted
+        layer_direct,   //------layer_direct
+        layer_inverse   //------layer_inverse
+    };
+
+
+    //==================================================rasterizer_compound_aa
+    template<class Clip=rasterizer_sl_clip_int> class rasterizer_compound_aa
+    {
+        struct style_info 
+        { 
+            unsigned start_cell;
+            unsigned num_cells;
+            int      last_x;
+        };
+
+        struct cell_info
+        {
+            int x, area, cover; 
+        };
+
+    public:
+        typedef Clip                      clip_type;
+        typedef typename Clip::conv_type  conv_type;
+        typedef typename Clip::coord_type coord_type;
+
+        enum aa_scale_e
+        {
+            aa_shift  = 8,
+            aa_scale  = 1 << aa_shift,
+            aa_mask   = aa_scale - 1,
+            aa_scale2 = aa_scale * 2,
+            aa_mask2  = aa_scale2 - 1
+        };
+
+        //--------------------------------------------------------------------
+        rasterizer_compound_aa() : 
+            m_outline(),
+            m_clipper(),
+            m_filling_rule(fill_non_zero),
+            m_layer_order(layer_direct),
+            m_styles(),  // Active Styles
+            m_ast(),     // Active Style Table (unique values)
+            m_asm(),     // Active Style Mask 
+            m_cells(),
+            m_cover_buf(),
+            m_master_alpha(),
+            m_min_style(0x7FFFFFFF),
+            m_max_style(-0x7FFFFFFF),
+            m_start_x(0),
+            m_start_y(0),
+            m_scan_y(0x7FFFFFFF),
+            m_sl_start(0),
+            m_sl_len(0)
+        {}
+
+        //--------------------------------------------------------------------
+        void reset(); 
+        void reset_clipping();
+        void clip_box(double x1, double y1, double x2, double y2);
+        void filling_rule(filling_rule_e filling_rule);
+        void layer_order(layer_order_e order);
+        void master_alpha(int style, double alpha);
+
+        //--------------------------------------------------------------------
+        void styles(int left, int right);
+        void move_to(int x, int y);
+        void line_to(int x, int y);
+        void move_to_d(double x, double y);
+        void line_to_d(double x, double y);
+        void add_vertex(double x, double y, unsigned cmd);
+
+        void edge(int x1, int y1, int x2, int y2);
+        void edge_d(double x1, double y1, double x2, double y2);
+
+        //-------------------------------------------------------------------
+        template<class VertexSource>
+        void add_path(VertexSource& vs, unsigned path_id=0)
+        {
+            double x;
+            double y;
+
+            unsigned cmd;
+            vs.rewind(path_id);
+            if(m_outline.sorted()) reset();
+            while(!is_stop(cmd = vs.vertex(&x, &y)))
+            {
+                add_vertex(x, y, cmd);
+            }
+        }
+
+        
+        //--------------------------------------------------------------------
+        int min_x()     const { return m_outline.min_x(); }
+        int min_y()     const { return m_outline.min_y(); }
+        int max_x()     const { return m_outline.max_x(); }
+        int max_y()     const { return m_outline.max_y(); }
+        int min_style() const { return m_min_style; }
+        int max_style() const { return m_max_style; }
+
+        //--------------------------------------------------------------------
+        void sort();
+        bool rewind_scanlines();
+        unsigned sweep_styles();
+        int      scanline_start()  const { return m_sl_start; }
+        unsigned scanline_length() const { return m_sl_len;   }
+        unsigned style(unsigned style_idx) const;
+
+        cover_type* allocate_cover_buffer(unsigned len);
+
+        //--------------------------------------------------------------------
+        bool navigate_scanline(int y); 
+        bool hit_test(int tx, int ty);
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned calculate_alpha(int area, unsigned master_alpha) const
+        {
+            int cover = area >> (poly_subpixel_shift*2 + 1 - aa_shift);
+            if(cover < 0) cover = -cover;
+            if(m_filling_rule == fill_even_odd)
+            {
+                cover &= aa_mask2;
+                if(cover > aa_scale)
+                {
+                    cover = aa_scale2 - cover;
+                }
+            }
+            if(cover > aa_mask) cover = aa_mask;
+            return (cover * master_alpha + aa_mask) >> aa_shift;
+        }
+
+        //--------------------------------------------------------------------
+        // Sweeps one scanline with one style index. The style ID can be 
+        // determined by calling style(). 
+        template<class Scanline> bool sweep_scanline(Scanline& sl, int style_idx)
+        {
+            int scan_y = m_scan_y - 1;
+            if(scan_y > m_outline.max_y()) return false;
+
+            sl.reset_spans();
+
+            unsigned master_alpha = aa_mask;
+
+            if(style_idx < 0) 
+            {
+                style_idx = 0;
+            }
+            else 
+            {
+                style_idx++;
+                master_alpha = m_master_alpha[m_ast[style_idx] + m_min_style - 1];
+            }
+
+            const style_info& st = m_styles[m_ast[style_idx]];
+
+            unsigned num_cells = st.num_cells;
+            cell_info* cell = &m_cells[st.start_cell];
+
+            int cover = 0;
+            while(num_cells--)
+            {
+                unsigned alpha;
+                int x = cell->x;
+                int area = cell->area;
+
+                cover += cell->cover;
+
+                ++cell;
+
+                if(area)
+                {
+                    alpha = calculate_alpha((cover << (poly_subpixel_shift + 1)) - area,
+                                            master_alpha);
+                    sl.add_cell(x, alpha);
+                    x++;
+                }
+
+                if(num_cells && cell->x > x)
+                {
+                    alpha = calculate_alpha(cover << (poly_subpixel_shift + 1),
+                                            master_alpha);
+                    if(alpha)
+                    {
+                        sl.add_span(x, cell->x - x, alpha);
+                    }
+                }
+            }
+
+            if(sl.num_spans() == 0) return false;
+            sl.finalize(scan_y);
+            return true;
+        }
+
+    private:
+        void add_style(int style_id);
+        void allocate_master_alpha();
+
+        //--------------------------------------------------------------------
+        // Disable copying
+        rasterizer_compound_aa(const rasterizer_compound_aa<Clip>&);
+        const rasterizer_compound_aa<Clip>& 
+        operator = (const rasterizer_compound_aa<Clip>&);
+
+    private:
+        rasterizer_cells_aa<cell_style_aa> m_outline;
+        clip_type              m_clipper;
+        filling_rule_e         m_filling_rule;
+        layer_order_e          m_layer_order;
+        pod_vector<style_info> m_styles;  // Active Styles
+        pod_vector<unsigned>   m_ast;     // Active Style Table (unique values)
+        pod_vector<int8u>      m_asm;     // Active Style Mask 
+        pod_vector<cell_info>  m_cells;
+        pod_vector<cover_type> m_cover_buf;
+        pod_bvector<unsigned>  m_master_alpha;
+
+        int        m_min_style;
+        int        m_max_style;
+        coord_type m_start_x;
+        coord_type m_start_y;
+        int        m_scan_y;
+        int        m_sl_start;
+        unsigned   m_sl_len;
+    };
+
+
+
+
+
+
+
+
+
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::reset() 
+    { 
+        m_outline.reset(); 
+        m_min_style =  0x7FFFFFFF;
+        m_max_style = -0x7FFFFFFF;
+        m_scan_y    =  0x7FFFFFFF;
+        m_sl_start  =  0;
+        m_sl_len    = 0;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::filling_rule(filling_rule_e filling_rule) 
+    { 
+        m_filling_rule = filling_rule; 
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::layer_order(layer_order_e order)
+    {
+        m_layer_order = order;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::clip_box(double x1, double y1, 
+                                                double x2, double y2)
+    {
+        reset();
+        m_clipper.clip_box(conv_type::upscale(x1), conv_type::upscale(y1), 
+                           conv_type::upscale(x2), conv_type::upscale(y2));
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::reset_clipping()
+    {
+        reset();
+        m_clipper.reset_clipping();
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::styles(int left, int right)
+    {
+        cell_style_aa cell;
+        cell.initial();
+        cell.left = (int16)left;
+        cell.right = (int16)right;
+        m_outline.style(cell);
+        if(left  >= 0 && left  < m_min_style) m_min_style = left;
+        if(left  >= 0 && left  > m_max_style) m_max_style = left;
+        if(right >= 0 && right < m_min_style) m_min_style = right;
+        if(right >= 0 && right > m_max_style) m_max_style = right;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::move_to(int x, int y)
+    {
+        if(m_outline.sorted()) reset();
+        m_clipper.move_to(m_start_x = conv_type::downscale(x), 
+                          m_start_y = conv_type::downscale(y));
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::line_to(int x, int y)
+    {
+        m_clipper.line_to(m_outline, 
+                          conv_type::downscale(x), 
+                          conv_type::downscale(y));
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::move_to_d(double x, double y) 
+    { 
+        if(m_outline.sorted()) reset();
+        m_clipper.move_to(m_start_x = conv_type::upscale(x), 
+                          m_start_y = conv_type::upscale(y)); 
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::line_to_d(double x, double y) 
+    { 
+        m_clipper.line_to(m_outline, 
+                          conv_type::upscale(x), 
+                          conv_type::upscale(y)); 
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::add_vertex(double x, double y, unsigned cmd)
+    {
+        if(is_move_to(cmd)) 
+        {
+            move_to_d(x, y);
+        }
+        else 
+        if(is_vertex(cmd))
+        {
+            line_to_d(x, y);
+        }
+        else
+        if(is_close(cmd))
+        {
+            m_clipper.line_to(m_outline, m_start_x, m_start_y);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::edge(int x1, int y1, int x2, int y2)
+    {
+        if(m_outline.sorted()) reset();
+        m_clipper.move_to(conv_type::downscale(x1), conv_type::downscale(y1));
+        m_clipper.line_to(m_outline, 
+                          conv_type::downscale(x2), 
+                          conv_type::downscale(y2));
+    }
+    
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::edge_d(double x1, double y1, 
+                                              double x2, double y2)
+    {
+        if(m_outline.sorted()) reset();
+        m_clipper.move_to(conv_type::upscale(x1), conv_type::upscale(y1)); 
+        m_clipper.line_to(m_outline, 
+                          conv_type::upscale(x2), 
+                          conv_type::upscale(y2)); 
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    AGG_INLINE void rasterizer_compound_aa<Clip>::sort()
+    {
+        m_outline.sort_cells();
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    AGG_INLINE bool rasterizer_compound_aa<Clip>::rewind_scanlines()
+    {
+        m_outline.sort_cells();
+        if(m_outline.total_cells() == 0) 
+        {
+            return false;
+        }
+        if(m_max_style < m_min_style)
+        {
+            return false;
+        }
+        m_scan_y = m_outline.min_y();
+        m_styles.allocate(m_max_style - m_min_style + 2, 128);
+        allocate_master_alpha();
+        return true;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    AGG_INLINE void rasterizer_compound_aa<Clip>::add_style(int style_id)
+    {
+        if(style_id < 0) style_id  = 0;
+        else             style_id -= m_min_style - 1;
+
+        unsigned nbyte = style_id >> 3;
+        unsigned mask = 1 << (style_id & 7);
+
+        style_info* style = &m_styles[style_id];
+        if((m_asm[nbyte] & mask) == 0)
+        {
+            m_ast.add(style_id);
+            m_asm[nbyte] |= mask;
+            style->start_cell = 0;
+            style->num_cells = 0;
+            style->last_x = -0x7FFFFFFF;
+        }
+        ++style->start_cell;
+    }
+
+    //------------------------------------------------------------------------
+    // Returns the number of styles
+    template<class Clip> 
+    unsigned rasterizer_compound_aa<Clip>::sweep_styles()
+    {
+        for(;;)
+        {
+            if(m_scan_y > m_outline.max_y()) return 0;
+            unsigned num_cells = m_outline.scanline_num_cells(m_scan_y);
+            const cell_style_aa* const* cells = m_outline.scanline_cells(m_scan_y);
+            unsigned num_styles = m_max_style - m_min_style + 2;
+            const cell_style_aa* curr_cell;
+            unsigned style_id;
+            style_info* style;
+            cell_info* cell;
+
+            m_cells.allocate(num_cells * 2, 256); // Each cell can have two styles
+            m_ast.capacity(num_styles, 64);
+            m_asm.allocate((num_styles + 7) >> 3, 8);
+            m_asm.zero();
+
+            if(num_cells)
+            {
+                // Pre-add zero (for no-fill style, that is, -1).
+                // We need that to ensure that the "-1 style" would go first.
+                m_asm[0] |= 1; 
+                m_ast.add(0);
+                style = &m_styles[0];
+                style->start_cell = 0;
+                style->num_cells = 0;
+                style->last_x = -0x7FFFFFFF;
+
+                m_sl_start = cells[0]->x;
+                m_sl_len   = cells[num_cells-1]->x - m_sl_start + 1;
+                while(num_cells--)
+                {
+                    curr_cell = *cells++;
+                    add_style(curr_cell->left);
+                    add_style(curr_cell->right);
+                }
+
+                // Convert the Y-histogram into the array of starting indexes
+                unsigned i;
+                unsigned start_cell = 0;
+                for(i = 0; i < m_ast.size(); i++)
+                {
+                    style_info& st = m_styles[m_ast[i]];
+                    unsigned v = st.start_cell;
+                    st.start_cell = start_cell;
+                    start_cell += v;
+                }
+
+                cells = m_outline.scanline_cells(m_scan_y);
+                num_cells = m_outline.scanline_num_cells(m_scan_y);
+
+                while(num_cells--)
+                {
+                    curr_cell = *cells++;
+                    style_id = (curr_cell->left < 0) ? 0 : 
+                                curr_cell->left - m_min_style + 1;
+
+                    style = &m_styles[style_id];
+                    if(curr_cell->x == style->last_x)
+                    {
+                        cell = &m_cells[style->start_cell + style->num_cells - 1];
+                        cell->area  += curr_cell->area;
+                        cell->cover += curr_cell->cover;
+                    }
+                    else
+                    {
+                        cell = &m_cells[style->start_cell + style->num_cells];
+                        cell->x       = curr_cell->x;
+                        cell->area    = curr_cell->area;
+                        cell->cover   = curr_cell->cover;
+                        style->last_x = curr_cell->x;
+                        style->num_cells++;
+                    }
+
+                    style_id = (curr_cell->right < 0) ? 0 : 
+                                curr_cell->right - m_min_style + 1;
+
+                    style = &m_styles[style_id];
+                    if(curr_cell->x == style->last_x)
+                    {
+                        cell = &m_cells[style->start_cell + style->num_cells - 1];
+                        cell->area  -= curr_cell->area;
+                        cell->cover -= curr_cell->cover;
+                    }
+                    else
+                    {
+                        cell = &m_cells[style->start_cell + style->num_cells];
+                        cell->x       =  curr_cell->x;
+                        cell->area    = -curr_cell->area;
+                        cell->cover   = -curr_cell->cover;
+                        style->last_x =  curr_cell->x;
+                        style->num_cells++;
+                    }
+                }
+            }
+            if(m_ast.size() > 1) break;
+            ++m_scan_y;
+        }
+        ++m_scan_y;
+
+        if(m_layer_order != layer_unsorted)
+        {
+            range_adaptor<pod_vector<unsigned> > ra(m_ast, 1, m_ast.size() - 1);
+            if(m_layer_order == layer_direct) quick_sort(ra, unsigned_greater);
+            else                              quick_sort(ra, unsigned_less);
+        }
+
+        return m_ast.size() - 1;
+    }
+
+    //------------------------------------------------------------------------
+    // Returns style ID depending of the existing style index
+    template<class Clip> 
+    AGG_INLINE 
+    unsigned rasterizer_compound_aa<Clip>::style(unsigned style_idx) const
+    {
+        return m_ast[style_idx + 1] + m_min_style - 1;
+    }
+
+    //------------------------------------------------------------------------ 
+    template<class Clip> 
+    AGG_INLINE bool rasterizer_compound_aa<Clip>::navigate_scanline(int y)
+    {
+        m_outline.sort_cells();
+        if(m_outline.total_cells() == 0) 
+        {
+            return false;
+        }
+        if(m_max_style < m_min_style)
+        {
+            return false;
+        }
+        if(y < m_outline.min_y() || y > m_outline.max_y()) 
+        {
+            return false;
+        }
+        m_scan_y = y;
+        m_styles.allocate(m_max_style - m_min_style + 2, 128);
+        allocate_master_alpha();
+        return true;
+    }
+    
+    //------------------------------------------------------------------------ 
+    template<class Clip> 
+    bool rasterizer_compound_aa<Clip>::hit_test(int tx, int ty)
+    {
+        if(!navigate_scanline(ty)) 
+        {
+            return false;
+        }
+
+        unsigned num_styles = sweep_styles(); 
+        if(num_styles <= 0)
+        {
+            return false;
+        }
+
+        scanline_hit_test sl(tx);
+        sweep_scanline(sl, -1);
+        return sl.hit();
+    }
+
+    //------------------------------------------------------------------------ 
+    template<class Clip> 
+    cover_type* rasterizer_compound_aa<Clip>::allocate_cover_buffer(unsigned len)
+    {
+        m_cover_buf.allocate(len, 256);
+        return &m_cover_buf[0];
+    }
+
+    //------------------------------------------------------------------------ 
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::allocate_master_alpha()
+    {
+        while((int)m_master_alpha.size() <= m_max_style)
+        {
+            m_master_alpha.add(aa_mask);
+        }
+    }
+
+    //------------------------------------------------------------------------ 
+    template<class Clip> 
+    void rasterizer_compound_aa<Clip>::master_alpha(int style, double alpha)
+    {
+        if(style >= 0)
+        {
+            while((int)m_master_alpha.size() <= style)
+            {
+                m_master_alpha.add(aa_mask);
+            }
+            m_master_alpha[style] = uround(alpha * aa_mask);
+        }
+    }
+
+}
+
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rasterizer_outline.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_outline.h
--- 8.0.1-5/src/renderers/agg/include/agg_rasterizer_outline.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_outline.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,147 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_RASTERIZER_OUTLINE_INCLUDED
+#define AGG_RASTERIZER_OUTLINE_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //======================================================rasterizer_outline
+    template<class Renderer> class rasterizer_outline
+    {
+    public:
+        explicit rasterizer_outline(Renderer& ren) : 
+            m_ren(&ren), 
+            m_start_x(0), 
+            m_start_y(0), 
+            m_vertices(0)
+        {}
+        void attach(Renderer& ren) { m_ren = &ren; }
+
+
+        //--------------------------------------------------------------------
+        void move_to(int x, int y)
+        {
+            m_vertices = 1;
+            m_ren->move_to(m_start_x = x, m_start_y = y);
+        }
+
+        //--------------------------------------------------------------------
+        void line_to(int x, int y)
+        {
+            ++m_vertices;
+            m_ren->line_to(x, y);
+        }
+
+        //--------------------------------------------------------------------
+        void move_to_d(double x, double y)
+        {
+            move_to(m_ren->coord(x), m_ren->coord(y));
+        }
+
+        //--------------------------------------------------------------------
+        void line_to_d(double x, double y)
+        {
+            line_to(m_ren->coord(x), m_ren->coord(y));
+        }
+
+        //--------------------------------------------------------------------
+        void close()
+        {
+            if(m_vertices > 2)
+            {
+                line_to(m_start_x, m_start_y);
+            }
+            m_vertices = 0;
+        }
+
+        //--------------------------------------------------------------------
+        void add_vertex(double x, double y, unsigned cmd)
+        {
+            if(is_move_to(cmd)) 
+            {
+                move_to_d(x, y);
+            }
+            else 
+            {
+                if(is_end_poly(cmd))
+                {
+                    if(is_closed(cmd)) close();
+                }
+                else
+                {
+                    line_to_d(x, y);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        template<class VertexSource>
+        void add_path(VertexSource& vs, unsigned path_id=0)
+        {
+            double x;
+            double y;
+
+            unsigned cmd;
+            vs.rewind(path_id);
+            while(!is_stop(cmd = vs.vertex(&x, &y)))
+            {
+                add_vertex(x, y, cmd);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        template<class VertexSource, class ColorStorage, class PathId>
+        void render_all_paths(VertexSource& vs, 
+                              const ColorStorage& colors, 
+                              const PathId& path_id,
+                              unsigned num_paths)
+        {
+            for(unsigned i = 0; i < num_paths; i++)
+            {
+                m_ren->line_color(colors[i]);
+                add_path(vs, path_id[i]);
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        template<class Ctrl> void render_ctrl(Ctrl& c)
+        {
+            unsigned i;
+            for(i = 0; i < c.num_paths(); i++)
+            {
+                m_ren->line_color(c.color(i));
+                add_path(c, i);
+            }
+        }
+
+
+    private:
+        Renderer* m_ren;
+        int       m_start_x;
+        int       m_start_y;
+        unsigned  m_vertices;
+    };
+
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rasterizer_outline_aa.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_outline_aa.h
--- 8.0.1-5/src/renderers/agg/include/agg_rasterizer_outline_aa.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_outline_aa.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,598 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_RASTERIZER_OUTLINE_AA_INCLUDED
+#define AGG_RASTERIZER_OUTLINE_AA_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_line_aa_basics.h"
+#include "agg_vertex_sequence.h"
+
+namespace mapserver
+{
+
+    //-------------------------------------------------------------------------
+    inline bool cmp_dist_start(int d) { return d > 0;  }
+    inline bool cmp_dist_end(int d)   { return d <= 0; }
+
+
+
+    //-----------------------------------------------------------line_aa_vertex
+    // Vertex (x, y) with the distance to the next one. The last vertex has 
+    // the distance between the last and the first points
+    struct line_aa_vertex
+    {
+        int x = 0;
+        int y = 0;
+        int len = 0;
+
+        line_aa_vertex() = default;
+        line_aa_vertex(int x_, int y_) :
+            x(x_),
+            y(y_)
+        {
+        }
+
+        bool operator () (const line_aa_vertex& val)
+        {
+            double dx = val.x - x;
+            double dy = val.y - y;
+            return (len = uround(sqrt(dx * dx + dy * dy))) > 
+                   (line_subpixel_scale + line_subpixel_scale / 2);
+        }
+    };
+
+
+    //----------------------------------------------------------outline_aa_join_e
+    enum outline_aa_join_e
+    {
+        outline_no_join,             //-----outline_no_join
+        outline_miter_join,          //-----outline_miter_join
+        outline_round_join,          //-----outline_round_join
+        outline_miter_accurate_join  //-----outline_accurate_join
+    };
+
+    //=======================================================rasterizer_outline_aa
+    template<class Renderer, class Coord=line_coord> class rasterizer_outline_aa
+    {
+    private:
+        //------------------------------------------------------------------------
+        struct draw_vars
+        {
+            unsigned idx;
+            int x1, y1, x2, y2;
+            line_parameters curr, next;
+            int lcurr, lnext;
+            int xb1, yb1, xb2, yb2;
+            unsigned flags;
+        };
+
+        void draw(draw_vars& dv, unsigned start, unsigned end);
+
+    public:
+        typedef line_aa_vertex                  vertex_type;
+        typedef vertex_sequence<vertex_type, 6> vertex_storage_type;
+
+        explicit rasterizer_outline_aa(Renderer& ren) : 
+            m_ren(&ren), 
+            m_line_join(ren.accurate_join_only() ? 
+                            outline_miter_accurate_join : 
+                            outline_round_join),
+            m_round_cap(false),
+            m_start_x(0),
+            m_start_y(0)
+        {}
+        void attach(Renderer& ren) { m_ren = &ren; }
+
+        //------------------------------------------------------------------------
+        void line_join(outline_aa_join_e join) 
+        { 
+            m_line_join = m_ren->accurate_join_only() ? 
+                outline_miter_accurate_join : 
+                join; 
+        }
+        bool line_join() const { return m_line_join; }
+
+        //------------------------------------------------------------------------
+        void round_cap(bool v) { m_round_cap = v; }
+        bool round_cap() const { return m_round_cap; }
+
+        //------------------------------------------------------------------------
+        void move_to(int x, int y)
+        {
+            m_src_vertices.modify_last(vertex_type(m_start_x = x, m_start_y = y));
+        }
+
+        //------------------------------------------------------------------------
+        void line_to(int x, int y)
+        {
+            m_src_vertices.add(vertex_type(x, y));
+        }
+
+        //------------------------------------------------------------------------
+        void move_to_d(double x, double y)
+        {
+            move_to(Coord::conv(x), Coord::conv(y));
+        }
+
+        //------------------------------------------------------------------------
+        void line_to_d(double x, double y)
+        {
+            line_to(Coord::conv(x), Coord::conv(y));
+        }
+
+        //------------------------------------------------------------------------
+        void render(bool close_polygon);
+
+        //------------------------------------------------------------------------
+        void add_vertex(double x, double y, unsigned cmd)
+        {
+            if(is_move_to(cmd)) 
+            {
+                render(false);
+                move_to_d(x, y);
+            }
+            else 
+            {
+                if(is_end_poly(cmd))
+                {
+                    render(is_closed(cmd));
+                    if(is_closed(cmd)) 
+                    {
+                        move_to(m_start_x, m_start_y);
+                    }
+                }
+                else
+                {
+                    line_to_d(x, y);
+                }
+            }
+        }
+
+        //------------------------------------------------------------------------
+        template<class VertexSource>
+        void add_path(VertexSource& vs, unsigned path_id=0)
+        {
+            double x;
+            double y;
+
+            unsigned cmd;
+            vs.rewind(path_id);
+            while(!is_stop(cmd = vs.vertex(&x, &y)))
+            {
+                add_vertex(x, y, cmd);
+            }
+            render(false);
+        }
+
+
+        //------------------------------------------------------------------------
+        template<class VertexSource, class ColorStorage, class PathId>
+        void render_all_paths(VertexSource& vs, 
+                              const ColorStorage& colors, 
+                              const PathId& path_id,
+                              unsigned num_paths)
+        {
+            for(unsigned i = 0; i < num_paths; i++)
+            {
+                m_ren->color(colors[i]);
+                add_path(vs, path_id[i]);
+            }
+        }
+
+
+        //------------------------------------------------------------------------
+        template<class Ctrl> void render_ctrl(Ctrl& c)
+        {
+            unsigned i;
+            for(i = 0; i < c.num_paths(); i++)
+            {
+                m_ren->color(c.color(i));
+                add_path(c, i);
+            }
+        }
+
+    private:
+        rasterizer_outline_aa(const rasterizer_outline_aa<Renderer, Coord>&);
+        const rasterizer_outline_aa<Renderer, Coord>& operator = 
+            (const rasterizer_outline_aa<Renderer, Coord>&);
+
+        Renderer*           m_ren;
+        vertex_storage_type m_src_vertices;
+        outline_aa_join_e   m_line_join;
+        bool                m_round_cap;
+        int                 m_start_x;
+        int                 m_start_y;
+    };
+
+
+
+
+
+
+
+
+    //----------------------------------------------------------------------------
+    template<class Renderer, class Coord> 
+    void rasterizer_outline_aa<Renderer, Coord>::draw(draw_vars& dv, 
+                                                      unsigned start, 
+                                                      unsigned end)
+    {
+        unsigned i;
+        const vertex_storage_type::value_type* v;
+
+        for(i = start; i < end; i++)
+        {
+            if(m_line_join == outline_round_join)
+            {
+                dv.xb1 = dv.curr.x1 + (dv.curr.y2 - dv.curr.y1); 
+                dv.yb1 = dv.curr.y1 - (dv.curr.x2 - dv.curr.x1); 
+                dv.xb2 = dv.curr.x2 + (dv.curr.y2 - dv.curr.y1); 
+                dv.yb2 = dv.curr.y2 - (dv.curr.x2 - dv.curr.x1);
+            }
+
+            switch(dv.flags)
+            {
+            case 0: m_ren->line3(dv.curr, dv.xb1, dv.yb1, dv.xb2, dv.yb2); break;
+            case 1: m_ren->line2(dv.curr, dv.xb2, dv.yb2); break;
+            case 2: m_ren->line1(dv.curr, dv.xb1, dv.yb1); break;
+            case 3: m_ren->line0(dv.curr); break;
+            }
+
+            if(m_line_join == outline_round_join && (dv.flags & 2) == 0)
+            {
+                m_ren->pie(dv.curr.x2, dv.curr.y2, 
+                           dv.curr.x2 + (dv.curr.y2 - dv.curr.y1),
+                           dv.curr.y2 - (dv.curr.x2 - dv.curr.x1),
+                           dv.curr.x2 + (dv.next.y2 - dv.next.y1),
+                           dv.curr.y2 - (dv.next.x2 - dv.next.x1));
+            }
+
+            dv.x1 = dv.x2;
+            dv.y1 = dv.y2;
+            dv.lcurr = dv.lnext;
+            dv.lnext = m_src_vertices[dv.idx].len;
+
+            ++dv.idx;
+            if(dv.idx >= m_src_vertices.size()) dv.idx = 0; 
+
+            v = &m_src_vertices[dv.idx];
+            dv.x2 = v->x;
+            dv.y2 = v->y;
+
+            dv.curr = dv.next;
+            dv.next = line_parameters(dv.x1, dv.y1, dv.x2, dv.y2, dv.lnext);
+            dv.xb1 = dv.xb2;
+            dv.yb1 = dv.yb2;
+
+            switch(m_line_join)
+            {
+            case outline_no_join:
+                dv.flags = 3;
+                break;
+
+            case outline_miter_join:
+                dv.flags >>= 1;
+                dv.flags |= ((dv.curr.diagonal_quadrant() == 
+                              dv.next.diagonal_quadrant()) << 1);
+                if((dv.flags & 2) == 0)
+                {
+                    bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
+                }
+                break;
+
+            case outline_round_join:
+                dv.flags >>= 1;
+                dv.flags |= ((dv.curr.diagonal_quadrant() == 
+                              dv.next.diagonal_quadrant()) << 1);
+                break;
+
+            case outline_miter_accurate_join:
+                dv.flags = 0;
+                bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
+                break;
+            }
+        }
+    }
+
+
+
+
+    //----------------------------------------------------------------------------
+    template<class Renderer, class Coord> 
+    void rasterizer_outline_aa<Renderer, Coord>::render(bool close_polygon)
+    {
+        m_src_vertices.close(close_polygon);
+        draw_vars dv;
+        const vertex_storage_type::value_type* v;
+        int x1;
+        int y1;
+        int x2;
+        int y2;
+        int lprev;
+
+        if(close_polygon)
+        {
+            if(m_src_vertices.size() >= 3)
+            {
+                dv.idx = 2;
+
+                v     = &m_src_vertices[m_src_vertices.size() - 1];
+                x1    = v->x;
+                y1    = v->y;
+                lprev = v->len;
+
+                v  = &m_src_vertices[0];
+                x2 = v->x;
+                y2 = v->y;
+                dv.lcurr = v->len;
+                line_parameters prev(x1, y1, x2, y2, lprev);
+
+                v = &m_src_vertices[1];
+                dv.x1    = v->x;
+                dv.y1    = v->y;
+                dv.lnext = v->len;
+                dv.curr = line_parameters(x2, y2, dv.x1, dv.y1, dv.lcurr);
+
+                v = &m_src_vertices[dv.idx];
+                dv.x2 = v->x;
+                dv.y2 = v->y;
+                dv.next = line_parameters(dv.x1, dv.y1, dv.x2, dv.y2, dv.lnext);
+
+                dv.xb1 = 0;
+                dv.yb1 = 0;
+                dv.xb2 = 0;
+                dv.yb2 = 0;
+
+                switch(m_line_join)
+                {
+                case outline_no_join:
+                    dv.flags = 3;
+                    break;
+
+                case outline_miter_join:
+                case outline_round_join:
+                    dv.flags = 
+                            (prev.diagonal_quadrant() == dv.curr.diagonal_quadrant()) |
+                        ((dv.curr.diagonal_quadrant() == dv.next.diagonal_quadrant()) << 1);
+                    break;
+
+                case outline_miter_accurate_join:
+                    dv.flags = 0;
+                    break;
+                }
+
+                if((dv.flags & 1) == 0 && m_line_join != outline_round_join)
+                {
+                    bisectrix(prev, dv.curr, &dv.xb1, &dv.yb1);
+                }
+
+                if((dv.flags & 2) == 0 && m_line_join != outline_round_join)
+                {
+                    bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
+                }
+                draw(dv, 0, m_src_vertices.size());
+            }
+        }
+        else
+        {
+            switch(m_src_vertices.size())
+            {
+                case 0:
+                case 1:
+                    break;
+
+                case 2:
+                {
+                    v     = &m_src_vertices[0];
+                    x1    = v->x;
+                    y1    = v->y;
+                    lprev = v->len;
+                    v     = &m_src_vertices[1];
+                    x2    = v->x;
+                    y2    = v->y;
+                    line_parameters lp(x1, y1, x2, y2, lprev);
+                    if(m_round_cap) 
+                    {
+                        m_ren->semidot(cmp_dist_start, x1, y1, x1 + (y2 - y1), y1 - (x2 - x1));
+                    }
+                    m_ren->line3(lp, 
+                                 x1 + (y2 - y1), 
+                                 y1 - (x2 - x1),
+                                 x2 + (y2 - y1), 
+                                 y2 - (x2 - x1));
+                    if(m_round_cap) 
+                    {
+                        m_ren->semidot(cmp_dist_end, x2, y2, x2 + (y2 - y1), y2 - (x2 - x1));
+                    }
+                }
+                break;
+
+                case 3:
+                {
+                    int x3, y3;
+                    int lnext;
+                    v     = &m_src_vertices[0];
+                    x1    = v->x;
+                    y1    = v->y;
+                    lprev = v->len;
+                    v     = &m_src_vertices[1];
+                    x2    = v->x;
+                    y2    = v->y;
+                    lnext = v->len;
+                    v     = &m_src_vertices[2];
+                    x3    = v->x;
+                    y3    = v->y;
+                    line_parameters lp1(x1, y1, x2, y2, lprev);
+                    line_parameters lp2(x2, y2, x3, y3, lnext);
+
+                    if(m_round_cap) 
+                    {
+                        m_ren->semidot(cmp_dist_start, x1, y1, x1 + (y2 - y1), y1 - (x2 - x1));
+                    }
+
+                    if(m_line_join == outline_round_join)
+                    {
+                        m_ren->line3(lp1, x1 + (y2 - y1), y1 - (x2 - x1), 
+                                          x2 + (y2 - y1), y2 - (x2 - x1));
+
+                        m_ren->pie(x2, y2, x2 + (y2 - y1), y2 - (x2 - x1),
+                                           x2 + (y3 - y2), y2 - (x3 - x2));
+
+                        m_ren->line3(lp2, x2 + (y3 - y2), y2 - (x3 - x2),
+                                          x3 + (y3 - y2), y3 - (x3 - x2));
+                    }
+                    else
+                    {
+                        bisectrix(lp1, lp2, &dv.xb1, &dv.yb1);
+                        m_ren->line3(lp1, x1 + (y2 - y1), y1 - (x2 - x1),
+                                          dv.xb1,         dv.yb1);
+
+                        m_ren->line3(lp2, dv.xb1,         dv.yb1,
+                                          x3 + (y3 - y2), y3 - (x3 - x2));
+                    }
+                    if(m_round_cap) 
+                    {
+                        m_ren->semidot(cmp_dist_end, x3, y3, x3 + (y3 - y2), y3 - (x3 - x2));
+                    }
+                }
+                break;
+
+                default:
+                {
+                    dv.idx = 3;
+
+                    v     = &m_src_vertices[0];
+                    x1    = v->x;
+                    y1    = v->y;
+                    lprev = v->len;
+
+                    v  = &m_src_vertices[1];
+                    x2 = v->x;
+                    y2 = v->y;
+                    dv.lcurr = v->len;
+                    line_parameters prev(x1, y1, x2, y2, lprev);
+
+                    v = &m_src_vertices[2];
+                    dv.x1    = v->x;
+                    dv.y1    = v->y;
+                    dv.lnext = v->len;
+                    dv.curr = line_parameters(x2, y2, dv.x1, dv.y1, dv.lcurr);
+
+                    v = &m_src_vertices[dv.idx];
+                    dv.x2 = v->x;
+                    dv.y2 = v->y;
+                    dv.next = line_parameters(dv.x1, dv.y1, dv.x2, dv.y2, dv.lnext);
+
+                    dv.xb1 = 0;
+                    dv.yb1 = 0;
+                    dv.xb2 = 0;
+                    dv.yb2 = 0;
+
+                    switch(m_line_join)
+                    {
+                    case outline_no_join:
+                        dv.flags = 3;
+                        break;
+
+                    case outline_miter_join:
+                    case outline_round_join:
+                        dv.flags = 
+                                (prev.diagonal_quadrant() == dv.curr.diagonal_quadrant()) |
+                            ((dv.curr.diagonal_quadrant() == dv.next.diagonal_quadrant()) << 1);
+                        break;
+
+                    case outline_miter_accurate_join:
+                        dv.flags = 0;
+                        break;
+                    }
+
+                    if(m_round_cap) 
+                    {
+                        m_ren->semidot(cmp_dist_start, x1, y1, x1 + (y2 - y1), y1 - (x2 - x1));
+                    }
+                    if((dv.flags & 1) == 0)
+                    {
+                        if(m_line_join == outline_round_join)
+                        {
+                            m_ren->line3(prev, x1 + (y2 - y1), y1 - (x2 - x1),
+                                               x2 + (y2 - y1), y2 - (x2 - x1));
+                            m_ren->pie(prev.x2, prev.y2, 
+                                       x2 + (y2 - y1), y2 - (x2 - x1),
+                                       dv.curr.x1 + (dv.curr.y2 - dv.curr.y1), 
+                                       dv.curr.y1 - (dv.curr.x2 - dv.curr.x1));
+                        }
+                        else
+                        {
+                            bisectrix(prev, dv.curr, &dv.xb1, &dv.yb1);
+                            m_ren->line3(prev, x1 + (y2 - y1), y1 - (x2 - x1),
+                                               dv.xb1,         dv.yb1);
+                        }
+                    }
+                    else
+                    {
+                        m_ren->line1(prev, 
+                                     x1 + (y2 - y1), 
+                                     y1 - (x2 - x1));
+                    }
+                    if((dv.flags & 2) == 0 && m_line_join != outline_round_join)
+                    {
+                        bisectrix(dv.curr, dv.next, &dv.xb2, &dv.yb2);
+                    }
+
+                    draw(dv, 1, m_src_vertices.size() - 2);
+
+                    if((dv.flags & 1) == 0)
+                    {
+                        if(m_line_join == outline_round_join)
+                        {
+                            m_ren->line3(dv.curr, 
+                                         dv.curr.x1 + (dv.curr.y2 - dv.curr.y1), 
+                                         dv.curr.y1 - (dv.curr.x2 - dv.curr.x1),
+                                         dv.curr.x2 + (dv.curr.y2 - dv.curr.y1), 
+                                         dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
+                        }
+                        else
+                        {
+                            m_ren->line3(dv.curr, dv.xb1, dv.yb1,
+                                         dv.curr.x2 + (dv.curr.y2 - dv.curr.y1), 
+                                         dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
+                        }
+                    }
+                    else
+                    {
+                        m_ren->line2(dv.curr, 
+                                     dv.curr.x2 + (dv.curr.y2 - dv.curr.y1), 
+                                     dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
+                    }
+                    if(m_round_cap) 
+                    {
+                        m_ren->semidot(cmp_dist_end, dv.curr.x2, dv.curr.y2,
+                                       dv.curr.x2 + (dv.curr.y2 - dv.curr.y1),
+                                       dv.curr.y2 - (dv.curr.x2 - dv.curr.x1));
+                    }
+
+                }
+                break;
+            }
+        }
+        m_src_vertices.remove_all();
+    }
+
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rasterizer_scanline_aa.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_scanline_aa.h
--- 8.0.1-5/src/renderers/agg/include/agg_rasterizer_scanline_aa.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_scanline_aa.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,510 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+//
+// The author gratefully acknowleges the support of David Turner, 
+// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
+// libray - in producing this work. See http://www.freetype.org for details.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+#ifndef AGG_RASTERIZER_SCANLINE_AA_INCLUDED
+#define AGG_RASTERIZER_SCANLINE_AA_INCLUDED
+
+#include "agg_rasterizer_cells_aa.h"
+#include "agg_rasterizer_sl_clip.h"
+#include "agg_gamma_functions.h"
+
+
+namespace mapserver
+{
+
+
+    //-----------------------------------------------------------------cell_aa
+    // A pixel cell. There're no constructors defined and it was done 
+    // intentionally in order to avoid extra overhead when allocating an 
+    // array of cells.
+    struct cell_aa
+    {
+        int x;
+        int y;
+        int cover;
+        int area;
+
+        void initial()
+        {
+            x = 0x7FFFFFFF;
+            y = 0x7FFFFFFF;
+            cover = 0;
+            area  = 0;
+        }
+
+        void style(const cell_aa&) {}
+
+        int not_equal(int ex, int ey, const cell_aa&) const
+        {
+            return (ex - x) | (ey - y);
+        }
+    };
+
+
+    //==================================================rasterizer_scanline_aa
+    // Polygon rasterizer that is used to render filled polygons with 
+    // high-quality Anti-Aliasing. Internally, by default, the class uses 
+    // integer coordinates in format 24.8, i.e. 24 bits for integer part 
+    // and 8 bits for fractional - see poly_subpixel_shift. This class can be 
+    // used in the following  way:
+    //
+    // 1. filling_rule(filling_rule_e ft) - optional.
+    //
+    // 2. gamma() - optional.
+    //
+    // 3. reset()
+    //
+    // 4. move_to(x, y) / line_to(x, y) - make the polygon. One can create 
+    //    more than one contour, but each contour must consist of at least 3
+    //    vertices, i.e. move_to(x1, y1); line_to(x2, y2); line_to(x3, y3);
+    //    is the absolute minimum of vertices that define a triangle.
+    //    The algorithm does not check either the number of vertices nor
+    //    coincidence of their coordinates, but in the worst case it just 
+    //    won't draw anything.
+    //    The orger of the vertices (clockwise or counterclockwise) 
+    //    is important when using the non-zero filling rule (fill_non_zero).
+    //    In this case the vertex order of all the contours must be the same
+    //    if you want your intersecting polygons to be without "holes".
+    //    You actually can use different vertices order. If the contours do not 
+    //    intersect each other the order is not important anyway. If they do, 
+    //    contours with the same vertex order will be rendered without "holes" 
+    //    while the intersecting contours with different orders will have "holes".
+    //
+    // filling_rule() and gamma() can be called anytime before "sweeping".
+    //------------------------------------------------------------------------
+    template<class Clip=rasterizer_sl_clip_int> class rasterizer_scanline_aa
+    {
+        enum status
+        {
+            status_initial,
+            status_move_to,
+            status_line_to,
+            status_closed
+        };
+
+    public:
+        typedef Clip                      clip_type;
+        typedef typename Clip::conv_type  conv_type;
+        typedef typename Clip::coord_type coord_type;
+
+        enum aa_scale_e
+        {
+            aa_shift  = 8,
+            aa_scale  = 1 << aa_shift,
+            aa_mask   = aa_scale - 1,
+            aa_scale2 = aa_scale * 2,
+            aa_mask2  = aa_scale2 - 1
+        };
+
+        //--------------------------------------------------------------------
+        rasterizer_scanline_aa() : 
+            m_outline(),
+            m_clipper(),
+            m_filling_rule(fill_non_zero),
+            m_auto_close(true),
+            m_start_x(0),
+            m_start_y(0),
+            m_status(status_initial)
+        {
+            int i;
+            for(i = 0; i < aa_scale; i++) m_gamma[i] = i;
+        }
+
+        //--------------------------------------------------------------------
+        template<class GammaF> 
+        rasterizer_scanline_aa(const GammaF& gamma_function) : 
+            m_outline(),
+            m_clipper(m_outline),
+            m_filling_rule(fill_non_zero),
+            m_auto_close(true),
+            m_start_x(0),
+            m_start_y(0),
+            m_status(status_initial)
+        {
+            gamma(gamma_function);
+        }
+
+        //--------------------------------------------------------------------
+        void reset(); 
+        void reset_clipping();
+        void clip_box(double x1, double y1, double x2, double y2);
+        void filling_rule(filling_rule_e filling_rule);
+        void auto_close(bool flag) { m_auto_close = flag; }
+
+        //--------------------------------------------------------------------
+        template<class GammaF> void gamma(const GammaF& gamma_function)
+        { 
+            int i;
+            for(i = 0; i < aa_scale; i++)
+            {
+                m_gamma[i] = uround(gamma_function(double(i) / aa_mask) * aa_mask);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        unsigned apply_gamma(unsigned cover) const 
+        { 
+            return m_gamma[cover]; 
+        }
+
+        //--------------------------------------------------------------------
+        void move_to(int x, int y);
+        void line_to(int x, int y);
+        void move_to_d(double x, double y);
+        void line_to_d(double x, double y);
+        void close_polygon();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        void edge(int x1, int y1, int x2, int y2);
+        void edge_d(double x1, double y1, double x2, double y2);
+
+        //-------------------------------------------------------------------
+        template<class VertexSource>
+        void add_path(VertexSource& vs, unsigned path_id=0)
+        {
+            double x = 0;
+            double y = 0;
+
+            unsigned cmd;
+            vs.rewind(path_id);
+            if(m_outline.sorted()) reset();
+            while(!is_stop(cmd = vs.vertex(&x, &y)))
+            {
+                add_vertex(x, y, cmd);
+            }
+        }
+        
+        //--------------------------------------------------------------------
+        int min_x() const { return m_outline.min_x(); }
+        int min_y() const { return m_outline.min_y(); }
+        int max_x() const { return m_outline.max_x(); }
+        int max_y() const { return m_outline.max_y(); }
+
+        //--------------------------------------------------------------------
+        void sort();
+        bool rewind_scanlines();
+        bool navigate_scanline(int y);
+
+        //--------------------------------------------------------------------
+        AGG_INLINE unsigned calculate_alpha(int area) const
+        {
+            int cover = area >> (poly_subpixel_shift*2 + 1 - aa_shift);
+
+            if(cover < 0) cover = -cover;
+            if(m_filling_rule == fill_even_odd)
+            {
+                cover &= aa_mask2;
+                if(cover > aa_scale)
+                {
+                    cover = aa_scale2 - cover;
+                }
+            }
+            if(cover > aa_mask) cover = aa_mask;
+            return m_gamma[cover];
+        }
+
+        //--------------------------------------------------------------------
+        template<class Scanline> bool sweep_scanline(Scanline& sl)
+        {
+            for(;;)
+            {
+                if(m_scan_y > m_outline.max_y()) return false;
+                sl.reset_spans();
+                unsigned num_cells = m_outline.scanline_num_cells(m_scan_y);
+                const cell_aa* const* cells = m_outline.scanline_cells(m_scan_y);
+                int cover = 0;
+
+                while(num_cells)
+                {
+                    const cell_aa* cur_cell = *cells;
+                    int x    = cur_cell->x;
+                    int area = cur_cell->area;
+                    unsigned alpha;
+
+                    cover += cur_cell->cover;
+
+                    //accumulate all cells with the same X
+                    while(--num_cells)
+                    {
+                        cur_cell = *++cells;
+                        if(cur_cell->x != x) break;
+                        area  += cur_cell->area;
+                        cover += cur_cell->cover;
+                    }
+
+                    if(area)
+                    {
+                        alpha = calculate_alpha((cover << (poly_subpixel_shift + 1)) - area);
+                        if(alpha)
+                        {
+                            sl.add_cell(x, alpha);
+                        }
+                        x++;
+                    }
+
+                    if(num_cells && cur_cell->x > x)
+                    {
+                        alpha = calculate_alpha(cover << (poly_subpixel_shift + 1));
+                        if(alpha)
+                        {
+                            sl.add_span(x, cur_cell->x - x, alpha);
+                        }
+                    }
+                }
+        
+                if(sl.num_spans()) break;
+                ++m_scan_y;
+            }
+
+            sl.finalize(m_scan_y);
+            ++m_scan_y;
+            return true;
+        }
+
+        //--------------------------------------------------------------------
+        bool hit_test(int tx, int ty);
+
+
+    private:
+        //--------------------------------------------------------------------
+        // Disable copying
+        rasterizer_scanline_aa(const rasterizer_scanline_aa<Clip>&);
+        const rasterizer_scanline_aa<Clip>& 
+        operator = (const rasterizer_scanline_aa<Clip>&);
+
+    private:
+        rasterizer_cells_aa<cell_aa> m_outline;
+        clip_type      m_clipper;
+        int            m_gamma[aa_scale];
+        filling_rule_e m_filling_rule;
+        bool           m_auto_close;
+        coord_type     m_start_x;
+        coord_type     m_start_y;
+        unsigned       m_status;
+        int            m_scan_y = 0;
+    };
+
+
+
+
+
+
+
+
+
+
+
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::reset() 
+    { 
+        m_outline.reset(); 
+        m_status = status_initial;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::filling_rule(filling_rule_e filling_rule) 
+    { 
+        m_filling_rule = filling_rule; 
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::clip_box(double x1, double y1, 
+                                                double x2, double y2)
+    {
+        reset();
+        m_clipper.clip_box(conv_type::upscale(x1), conv_type::upscale(y1), 
+                           conv_type::upscale(x2), conv_type::upscale(y2));
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::reset_clipping()
+    {
+        reset();
+        m_clipper.reset_clipping();
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::close_polygon()
+    {
+        if(m_status == status_line_to)
+        {
+            m_clipper.line_to(m_outline, m_start_x, m_start_y);
+            m_status = status_closed;
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::move_to(int x, int y)
+    {
+        if(m_outline.sorted()) reset();
+        if(m_auto_close) close_polygon();
+        m_clipper.move_to(m_start_x = conv_type::downscale(x), 
+                          m_start_y = conv_type::downscale(y));
+        m_status = status_move_to;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::line_to(int x, int y)
+    {
+        m_clipper.line_to(m_outline, 
+                          conv_type::downscale(x), 
+                          conv_type::downscale(y));
+        m_status = status_line_to;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::move_to_d(double x, double y) 
+    { 
+        if(m_outline.sorted()) reset();
+        if(m_auto_close) close_polygon();
+        m_clipper.move_to(m_start_x = conv_type::upscale(x), 
+                          m_start_y = conv_type::upscale(y)); 
+        m_status = status_move_to;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::line_to_d(double x, double y) 
+    { 
+        m_clipper.line_to(m_outline, 
+                          conv_type::upscale(x), 
+                          conv_type::upscale(y)); 
+        m_status = status_line_to;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::add_vertex(double x, double y, unsigned cmd)
+    {
+        if(is_move_to(cmd)) 
+        {
+            move_to_d(x, y);
+        }
+        else 
+        if(is_vertex(cmd))
+        {
+            line_to_d(x, y);
+        }
+        else
+        if(is_close(cmd))
+        {
+            close_polygon();
+        }
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::edge(int x1, int y1, int x2, int y2)
+    {
+        if(m_outline.sorted()) reset();
+        m_clipper.move_to(conv_type::downscale(x1), conv_type::downscale(y1));
+        m_clipper.line_to(m_outline, 
+                          conv_type::downscale(x2), 
+                          conv_type::downscale(y2));
+        m_status = status_move_to;
+    }
+    
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::edge_d(double x1, double y1, 
+                                              double x2, double y2)
+    {
+        if(m_outline.sorted()) reset();
+        m_clipper.move_to(conv_type::upscale(x1), conv_type::upscale(y1)); 
+        m_clipper.line_to(m_outline, 
+                          conv_type::upscale(x2), 
+                          conv_type::upscale(y2)); 
+        m_status = status_move_to;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    void rasterizer_scanline_aa<Clip>::sort()
+    {
+        if(m_auto_close) close_polygon();
+        m_outline.sort_cells();
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    AGG_INLINE bool rasterizer_scanline_aa<Clip>::rewind_scanlines()
+    {
+        if(m_auto_close) close_polygon();
+        m_outline.sort_cells();
+        if(m_outline.total_cells() == 0) 
+        {
+            return false;
+        }
+        m_scan_y = m_outline.min_y();
+        return true;
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    AGG_INLINE bool rasterizer_scanline_aa<Clip>::navigate_scanline(int y)
+    {
+        if(m_auto_close) close_polygon();
+        m_outline.sort_cells();
+        if(m_outline.total_cells() == 0 || 
+           y < m_outline.min_y() || 
+           y > m_outline.max_y()) 
+        {
+            return false;
+        }
+        m_scan_y = y;
+        return true;
+    }
+
+    //------------------------------------------------------------------------
+    template<class Clip> 
+    bool rasterizer_scanline_aa<Clip>::hit_test(int tx, int ty)
+    {
+        if(!navigate_scanline(ty)) return false;
+        scanline_hit_test sl(tx);
+        sweep_scanline(sl);
+        return sl.hit();
+    }
+
+
+
+}
+
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rasterizer_sl_clip.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_sl_clip.h
--- 8.0.1-5/src/renderers/agg/include/agg_rasterizer_sl_clip.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rasterizer_sl_clip.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,351 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_RASTERIZER_SL_CLIP_INCLUDED
+#define AGG_RASTERIZER_SL_CLIP_INCLUDED
+
+#include "agg_clip_liang_barsky.h"
+
+namespace mapserver
+{
+    //--------------------------------------------------------poly_max_coord_e
+    enum poly_max_coord_e
+    {
+        poly_max_coord = (1 << 30) - 1 //----poly_max_coord
+    };
+    
+    //------------------------------------------------------------ras_conv_int
+    struct ras_conv_int
+    {
+        typedef int coord_type;
+        static AGG_INLINE int mul_div(double a, double b, double c)
+        {
+            return iround(a * b / c);
+        }
+        static int xi(int v) { return v; }
+        static int yi(int v) { return v; }
+        static int upscale(double v) { return iround(v * poly_subpixel_scale); }
+        static int downscale(int v)  { return v; }
+    };
+
+    //--------------------------------------------------------ras_conv_int_sat
+    struct ras_conv_int_sat
+    {
+        typedef int coord_type;
+        static AGG_INLINE int mul_div(double a, double b, double c)
+        {
+            return saturation<poly_max_coord>::iround(a * b / c);
+        }
+        static int xi(int v) { return v; }
+        static int yi(int v) { return v; }
+        static int upscale(double v) 
+        { 
+            return saturation<poly_max_coord>::iround(v * poly_subpixel_scale); 
+        }
+        static int downscale(int v) { return v; }
+    };
+
+    //---------------------------------------------------------ras_conv_int_3x
+    struct ras_conv_int_3x
+    {
+        typedef int coord_type;
+        static AGG_INLINE int mul_div(double a, double b, double c)
+        {
+            return iround(a * b / c);
+        }
+        static int xi(int v) { return v * 3; }
+        static int yi(int v) { return v; }
+        static int upscale(double v) { return iround(v * poly_subpixel_scale); }
+        static int downscale(int v)  { return v; }
+    };
+
+    //-----------------------------------------------------------ras_conv_dbl
+    struct ras_conv_dbl
+    {
+        typedef double coord_type;
+        static AGG_INLINE double mul_div(double a, double b, double c)
+        {
+            return a * b / c;
+        }
+        static int xi(double v) { return iround(v * poly_subpixel_scale); }
+        static int yi(double v) { return iround(v * poly_subpixel_scale); }
+        static double upscale(double v) { return v; }
+        static double downscale(int v)  { return v / double(poly_subpixel_scale); }
+    };
+
+    //--------------------------------------------------------ras_conv_dbl_3x
+    struct ras_conv_dbl_3x
+    {
+        typedef double coord_type;
+        static AGG_INLINE double mul_div(double a, double b, double c)
+        {
+            return a * b / c;
+        }
+        static int xi(double v) { return iround(v * poly_subpixel_scale * 3); }
+        static int yi(double v) { return iround(v * poly_subpixel_scale); }
+        static double upscale(double v) { return v; }
+        static double downscale(int v)  { return v / double(poly_subpixel_scale); }
+    };
+
+
+
+
+
+    //------------------------------------------------------rasterizer_sl_clip
+    template<class Conv> class rasterizer_sl_clip
+    {
+    public:
+        typedef Conv                      conv_type;
+        typedef typename Conv::coord_type coord_type;
+        typedef rect_base<coord_type>     rect_type;
+
+        //--------------------------------------------------------------------
+        rasterizer_sl_clip() :  
+            m_clip_box(0,0,0,0),
+            m_x1(0),
+            m_y1(0),
+            m_f1(0),
+            m_clipping(false) 
+        {}
+
+        //--------------------------------------------------------------------
+        void reset_clipping()
+        {
+            m_clipping = false;
+        }
+
+        //--------------------------------------------------------------------
+        void clip_box(coord_type x1, coord_type y1, coord_type x2, coord_type y2)
+        {
+            m_clip_box = rect_type(x1, y1, x2, y2);
+            m_clip_box.normalize();
+            m_clipping = true;
+        }
+
+        //--------------------------------------------------------------------
+        void move_to(coord_type x1, coord_type y1)
+        {
+            m_x1 = x1;
+            m_y1 = y1;
+            if(m_clipping) m_f1 = clipping_flags(x1, y1, m_clip_box);
+        }
+
+    private:
+        //------------------------------------------------------------------------
+        template<class Rasterizer>
+        AGG_INLINE void line_clip_y(Rasterizer& ras,
+                                    coord_type x1, coord_type y1, 
+                                    coord_type x2, coord_type y2, 
+                                    unsigned   f1, unsigned   f2) const
+        {
+            f1 &= 10;
+            f2 &= 10;
+            if((f1 | f2) == 0)
+            {
+                // Fully visible
+                ras.line(Conv::xi(x1), Conv::yi(y1), Conv::xi(x2), Conv::yi(y2)); 
+            }
+            else
+            {
+                if(f1 == f2)
+                {
+                    // Invisible by Y
+                    return;
+                }
+
+                coord_type tx1 = x1;
+                coord_type ty1 = y1;
+                coord_type tx2 = x2;
+                coord_type ty2 = y2;
+
+                if(f1 & 8) // y1 < clip.y1
+                {
+                    tx1 = x1 + Conv::mul_div(m_clip_box.y1-y1, x2-x1, y2-y1);
+                    ty1 = m_clip_box.y1;
+                }
+
+                if(f1 & 2) // y1 > clip.y2
+                {
+                    tx1 = x1 + Conv::mul_div(m_clip_box.y2-y1, x2-x1, y2-y1);
+                    ty1 = m_clip_box.y2;
+                }
+
+                if(f2 & 8) // y2 < clip.y1
+                {
+                    tx2 = x1 + Conv::mul_div(m_clip_box.y1-y1, x2-x1, y2-y1);
+                    ty2 = m_clip_box.y1;
+                }
+
+                if(f2 & 2) // y2 > clip.y2
+                {
+                    tx2 = x1 + Conv::mul_div(m_clip_box.y2-y1, x2-x1, y2-y1);
+                    ty2 = m_clip_box.y2;
+                }
+                ras.line(Conv::xi(tx1), Conv::yi(ty1), 
+                         Conv::xi(tx2), Conv::yi(ty2)); 
+            }
+        }
+
+
+    public:
+        //--------------------------------------------------------------------
+        template<class Rasterizer>
+        void line_to(Rasterizer& ras, coord_type x2, coord_type y2)
+        {
+            if(m_clipping)
+            {
+                unsigned f2 = clipping_flags(x2, y2, m_clip_box);
+
+                if((m_f1 & 10) == (f2 & 10) && (m_f1 & 10) != 0)
+                {
+                    // Invisible by Y
+                    m_x1 = x2;
+                    m_y1 = y2;
+                    m_f1 = f2;
+                    return;
+                }
+
+                coord_type x1 = m_x1;
+                coord_type y1 = m_y1;
+                unsigned   f1 = m_f1;
+                coord_type y3, y4;
+                unsigned   f3, f4;
+
+                switch(((f1 & 5) << 1) | (f2 & 5))
+                {
+                case 0: // Visible by X
+                    line_clip_y(ras, x1, y1, x2, y2, f1, f2);
+                    break;
+
+                case 1: // x2 > clip.x2
+                    y3 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
+                    f3 = clipping_flags_y(y3, m_clip_box);
+                    line_clip_y(ras, x1, y1, m_clip_box.x2, y3, f1, f3);
+                    line_clip_y(ras, m_clip_box.x2, y3, m_clip_box.x2, y2, f3, f2);
+                    break;
+
+                case 2: // x1 > clip.x2
+                    y3 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
+                    f3 = clipping_flags_y(y3, m_clip_box);
+                    line_clip_y(ras, m_clip_box.x2, y1, m_clip_box.x2, y3, f1, f3);
+                    line_clip_y(ras, m_clip_box.x2, y3, x2, y2, f3, f2);
+                    break;
+
+                case 3: // x1 > clip.x2 && x2 > clip.x2
+                    line_clip_y(ras, m_clip_box.x2, y1, m_clip_box.x2, y2, f1, f2);
+                    break;
+
+                case 4: // x2 < clip.x1
+                    y3 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
+                    f3 = clipping_flags_y(y3, m_clip_box);
+                    line_clip_y(ras, x1, y1, m_clip_box.x1, y3, f1, f3);
+                    line_clip_y(ras, m_clip_box.x1, y3, m_clip_box.x1, y2, f3, f2);
+                    break;
+
+                case 6: // x1 > clip.x2 && x2 < clip.x1
+                    y3 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
+                    y4 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
+                    f3 = clipping_flags_y(y3, m_clip_box);
+                    f4 = clipping_flags_y(y4, m_clip_box);
+                    line_clip_y(ras, m_clip_box.x2, y1, m_clip_box.x2, y3, f1, f3);
+                    line_clip_y(ras, m_clip_box.x2, y3, m_clip_box.x1, y4, f3, f4);
+                    line_clip_y(ras, m_clip_box.x1, y4, m_clip_box.x1, y2, f4, f2);
+                    break;
+
+                case 8: // x1 < clip.x1
+                    y3 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
+                    f3 = clipping_flags_y(y3, m_clip_box);
+                    line_clip_y(ras, m_clip_box.x1, y1, m_clip_box.x1, y3, f1, f3);
+                    line_clip_y(ras, m_clip_box.x1, y3, x2, y2, f3, f2);
+                    break;
+
+                case 9:  // x1 < clip.x1 && x2 > clip.x2
+                    y3 = y1 + Conv::mul_div(m_clip_box.x1-x1, y2-y1, x2-x1);
+                    y4 = y1 + Conv::mul_div(m_clip_box.x2-x1, y2-y1, x2-x1);
+                    f3 = clipping_flags_y(y3, m_clip_box);
+                    f4 = clipping_flags_y(y4, m_clip_box);
+                    line_clip_y(ras, m_clip_box.x1, y1, m_clip_box.x1, y3, f1, f3);
+                    line_clip_y(ras, m_clip_box.x1, y3, m_clip_box.x2, y4, f3, f4);
+                    line_clip_y(ras, m_clip_box.x2, y4, m_clip_box.x2, y2, f4, f2);
+                    break;
+
+                case 12: // x1 < clip.x1 && x2 < clip.x1
+                    line_clip_y(ras, m_clip_box.x1, y1, m_clip_box.x1, y2, f1, f2);
+                    break;
+                }
+                m_f1 = f2;
+            }
+            else
+            {
+                ras.line(Conv::xi(m_x1), Conv::yi(m_y1), 
+                         Conv::xi(x2),   Conv::yi(y2)); 
+            }
+            m_x1 = x2;
+            m_y1 = y2;
+        }
+
+
+    private:
+        rect_type        m_clip_box;
+        coord_type       m_x1;
+        coord_type       m_y1;
+        unsigned         m_f1;
+        bool             m_clipping;
+    };
+
+
+
+
+    //---------------------------------------------------rasterizer_sl_no_clip
+    class rasterizer_sl_no_clip
+    {
+    public:
+        typedef ras_conv_int conv_type;
+        typedef int          coord_type;
+
+        rasterizer_sl_no_clip() : m_x1(0), m_y1(0) {}
+
+        void reset_clipping() {}
+        void clip_box(coord_type /*x1*/, coord_type /*y1*/, coord_type /*x2*/, coord_type /*y2*/) {}
+        void move_to(coord_type x1, coord_type y1) { m_x1 = x1; m_y1 = y1; }
+
+        template<class Rasterizer>
+        void line_to(Rasterizer& ras, coord_type x2, coord_type y2) 
+        { 
+            ras.line(m_x1, m_y1, x2, y2); 
+            m_x1 = x2; 
+            m_y1 = y2;
+        }
+
+    private:
+        int m_x1, m_y1;
+    };
+
+
+    //                                         -----rasterizer_sl_clip_int
+    //                                         -----rasterizer_sl_clip_int_sat
+    //                                         -----rasterizer_sl_clip_int_3x
+    //                                         -----rasterizer_sl_clip_dbl
+    //                                         -----rasterizer_sl_clip_dbl_3x
+    //------------------------------------------------------------------------
+    typedef rasterizer_sl_clip<ras_conv_int>     rasterizer_sl_clip_int;
+    typedef rasterizer_sl_clip<ras_conv_int_sat> rasterizer_sl_clip_int_sat;
+    typedef rasterizer_sl_clip<ras_conv_int_3x>  rasterizer_sl_clip_int_3x;
+    typedef rasterizer_sl_clip<ras_conv_dbl>     rasterizer_sl_clip_dbl;
+    typedef rasterizer_sl_clip<ras_conv_dbl_3x>  rasterizer_sl_clip_dbl_3x;
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_base.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_base.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_base.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_base.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,718 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class renderer_base
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERER_BASE_INCLUDED
+#define AGG_RENDERER_BASE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_rendering_buffer.h"
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------------renderer_base
+    template<class PixelFormat> class renderer_base
+    {
+    public:
+        typedef PixelFormat pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::row_data row_data;
+
+        //--------------------------------------------------------------------
+        renderer_base() : m_ren(0), m_clip_box(1, 1, 0, 0) {}
+        explicit renderer_base(pixfmt_type& ren) :
+            m_ren(&ren),
+            m_clip_box(0, 0, ren.width() - 1, ren.height() - 1)
+        {}
+        void attach(pixfmt_type& ren)
+        {
+            m_ren = &ren;
+            m_clip_box = rect_i(0, 0, ren.width() - 1, ren.height() - 1);
+        }
+
+        //--------------------------------------------------------------------
+        const pixfmt_type& ren() const { return *m_ren;  }
+        pixfmt_type& ren() { return *m_ren;  }
+          
+        //--------------------------------------------------------------------
+        unsigned width()  const { return m_ren->width();  }
+        unsigned height() const { return m_ren->height(); }
+
+        //--------------------------------------------------------------------
+        bool clip_box(int x1, int y1, int x2, int y2)
+        {
+            rect_i cb(x1, y1, x2, y2);
+            cb.normalize();
+            if(cb.clip(rect_i(0, 0, width() - 1, height() - 1)))
+            {
+                m_clip_box = cb;
+                return true;
+            }
+            m_clip_box.x1 = 1;
+            m_clip_box.y1 = 1;
+            m_clip_box.x2 = 0;
+            m_clip_box.y2 = 0;
+            return false;
+        }
+
+        //--------------------------------------------------------------------
+        void reset_clipping(bool visibility)
+        {
+            if(visibility)
+            {
+                m_clip_box.x1 = 0;
+                m_clip_box.y1 = 0;
+                m_clip_box.x2 = width() - 1;
+                m_clip_box.y2 = height() - 1;
+            }
+            else
+            {
+                m_clip_box.x1 = 1;
+                m_clip_box.y1 = 1;
+                m_clip_box.x2 = 0;
+                m_clip_box.y2 = 0;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void clip_box_naked(int x1, int y1, int x2, int y2)
+        {
+            m_clip_box.x1 = x1;
+            m_clip_box.y1 = y1;
+            m_clip_box.x2 = x2;
+            m_clip_box.y2 = y2;
+        }
+
+        //--------------------------------------------------------------------
+        bool inbox(int x, int y) const
+        {
+            return x >= m_clip_box.x1 && y >= m_clip_box.y1 &&
+                   x <= m_clip_box.x2 && y <= m_clip_box.y2;
+        }
+
+        //--------------------------------------------------------------------
+        const rect_i& clip_box() const { return m_clip_box;    }
+        int           xmin()     const { return m_clip_box.x1; }
+        int           ymin()     const { return m_clip_box.y1; }
+        int           xmax()     const { return m_clip_box.x2; }
+        int           ymax()     const { return m_clip_box.y2; }
+
+        //--------------------------------------------------------------------
+        const rect_i& bounding_clip_box() const { return m_clip_box;    }
+        int           bounding_xmin()     const { return m_clip_box.x1; }
+        int           bounding_ymin()     const { return m_clip_box.y1; }
+        int           bounding_xmax()     const { return m_clip_box.x2; }
+        int           bounding_ymax()     const { return m_clip_box.y2; }
+
+        //--------------------------------------------------------------------
+        void clear(const color_type& c)
+        {
+            unsigned y;
+            if(width())
+            {
+                for(y = 0; y < height(); y++)
+                {
+                    m_ren->copy_hline(0, y, width(), c);
+                }
+            }
+        }
+          
+
+        //--------------------------------------------------------------------
+        void copy_pixel(int x, int y, const color_type& c)
+        {
+            if(inbox(x, y))
+            {
+                m_ren->copy_pixel(x, y, c);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void blend_pixel(int x, int y, const color_type& c, cover_type cover)
+        {
+            if(inbox(x, y))
+            {
+                m_ren->blend_pixel(x, y, c, cover);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        color_type pixel(int x, int y) const
+        {
+            return inbox(x, y) ? 
+                   m_ren->pixel(x, y) :
+                   color_type::no_color();
+        }
+
+        //--------------------------------------------------------------------
+        void copy_hline(int x1, int y, int x2, const color_type& c)
+        {
+            if(x1 > x2) { int t = x2; x2 = x1; x1 = t; }
+            if(y  > ymax()) return;
+            if(y  < ymin()) return;
+            if(x1 > xmax()) return;
+            if(x2 < xmin()) return;
+
+            if(x1 < xmin()) x1 = xmin();
+            if(x2 > xmax()) x2 = xmax();
+
+            m_ren->copy_hline(x1, y, x2 - x1 + 1, c);
+        }
+
+        //--------------------------------------------------------------------
+        void copy_vline(int x, int y1, int y2, const color_type& c)
+        {
+            if(y1 > y2) { int t = y2; y2 = y1; y1 = t; }
+            if(x  > xmax()) return;
+            if(x  < xmin()) return;
+            if(y1 > ymax()) return;
+            if(y2 < ymin()) return;
+
+            if(y1 < ymin()) y1 = ymin();
+            if(y2 > ymax()) y2 = ymax();
+
+            m_ren->copy_vline(x, y1, y2 - y1 + 1, c);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x1, int y, int x2, 
+                         const color_type& c, cover_type cover)
+        {
+            if(x1 > x2) { int t = x2; x2 = x1; x1 = t; }
+            if(y  > ymax()) return;
+            if(y  < ymin()) return;
+            if(x1 > xmax()) return;
+            if(x2 < xmin()) return;
+
+            if(x1 < xmin()) x1 = xmin();
+            if(x2 > xmax()) x2 = xmax();
+
+            m_ren->blend_hline(x1, y, x2 - x1 + 1, c, cover);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y1, int y2, 
+                         const color_type& c, cover_type cover)
+        {
+            if(y1 > y2) { int t = y2; y2 = y1; y1 = t; }
+            if(x  > xmax()) return;
+            if(x  < xmin()) return;
+            if(y1 > ymax()) return;
+            if(y2 < ymin()) return;
+
+            if(y1 < ymin()) y1 = ymin();
+            if(y2 > ymax()) y2 = ymax();
+
+            m_ren->blend_vline(x, y1, y2 - y1 + 1, c, cover);
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_bar(int x1, int y1, int x2, int y2, const color_type& c)
+        {
+            rect_i rc(x1, y1, x2, y2);
+            rc.normalize();
+            if(rc.clip(clip_box()))
+            {
+                int y;
+                for(y = rc.y1; y <= rc.y2; y++)
+                {
+                    m_ren->copy_hline(rc.x1, y, unsigned(rc.x2 - rc.x1 + 1), c);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void blend_bar(int x1, int y1, int x2, int y2, 
+                       const color_type& c, cover_type cover)
+        {
+            rect_i rc(x1, y1, x2, y2);
+            rc.normalize();
+            if(rc.clip(clip_box()))
+            {
+                int y;
+                for(y = rc.y1; y <= rc.y2; y++)
+                {
+                    m_ren->blend_hline(rc.x1,
+                                       y,
+                                       unsigned(rc.x2 - rc.x1 + 1), 
+                                       c, 
+                                       cover);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y, int len, 
+                               const color_type& c, 
+                               const cover_type* covers)
+        {
+            if(y > ymax()) return;
+            if(y < ymin()) return;
+
+            if(x < xmin())
+            {
+                len -= xmin() - x;
+                if(len <= 0) return;
+                covers += xmin() - x;
+                x = xmin();
+            }
+            if(x + len > xmax())
+            {
+                len = xmax() - x + 1;
+                if(len <= 0) return;
+            }
+            m_ren->blend_solid_hspan(x, y, len, c, covers);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y, int len, 
+                               const color_type& c, 
+                               const cover_type* covers)
+        {
+            if(x > xmax()) return;
+            if(x < xmin()) return;
+
+            if(y < ymin())
+            {
+                len -= ymin() - y;
+                if(len <= 0) return;
+                covers += ymin() - y;
+                y = ymin();
+            }
+            if(y + len > ymax())
+            {
+                len = ymax() - y + 1;
+                if(len <= 0) return;
+            }
+            m_ren->blend_solid_vspan(x, y, len, c, covers);
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y, int len, const color_type* colors)
+        {
+            if(y > ymax()) return;
+            if(y < ymin()) return;
+
+            if(x < xmin())
+            {
+                int d = xmin() - x;
+                len -= d;
+                if(len <= 0) return;
+                colors += d;
+                x = xmin();
+            }
+            if(x + len > xmax())
+            {
+                len = xmax() - x + 1;
+                if(len <= 0) return;
+            }
+            m_ren->copy_color_hspan(x, y, len, colors);
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_vspan(int x, int y, int len, const color_type* colors)
+        {
+            if(x > xmax()) return;
+            if(x < xmin()) return;
+
+            if(y < ymin())
+            {
+                int d = ymin() - y;
+                len -= d;
+                if(len <= 0) return;
+                colors += d;
+                y = ymin();
+            }
+            if(y + len > ymax())
+            {
+                len = ymax() - y + 1;
+                if(len <= 0) return;
+            }
+            m_ren->copy_color_vspan(x, y, len, colors);
+        }
+
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y, int len, 
+                               const color_type* colors, 
+                               const cover_type* covers,
+                               cover_type cover = mapserver::cover_full)
+        {
+            if(y > ymax()) return;
+            if(y < ymin()) return;
+
+            if(x < xmin())
+            {
+                int d = xmin() - x;
+                len -= d;
+                if(len <= 0) return;
+                if(covers) covers += d;
+                colors += d;
+                x = xmin();
+            }
+            if(x + len > xmax())
+            {
+                len = xmax() - x + 1;
+                if(len <= 0) return;
+            }
+            m_ren->blend_color_hspan(x, y, len, colors, covers, cover);
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y, int len, 
+                               const color_type* colors, 
+                               const cover_type* covers,
+                               cover_type cover = mapserver::cover_full)
+        {
+            if(x > xmax()) return;
+            if(x < xmin()) return;
+
+            if(y < ymin())
+            {
+                int d = ymin() - y;
+                len -= d;
+                if(len <= 0) return;
+                if(covers) covers += d;
+                colors += d;
+                y = ymin();
+            }
+            if(y + len > ymax())
+            {
+                len = ymax() - y + 1;
+                if(len <= 0) return;
+            }
+            m_ren->blend_color_vspan(x, y, len, colors, covers, cover);
+        }
+
+        //--------------------------------------------------------------------
+        rect_i clip_rect_area(rect_i& dst, rect_i& src, int wsrc, int hsrc) const
+        {
+            rect_i rc(0,0,0,0);
+            rect_i cb = clip_box();
+            ++cb.x2;
+            ++cb.y2;
+
+            if(src.x1 < 0)
+            {
+                dst.x1 -= src.x1;
+                src.x1 = 0;
+            }
+            if(src.y1 < 0)
+            {
+                dst.y1 -= src.y1;
+                src.y1 = 0;
+            }
+
+            if(src.x2 > wsrc) src.x2 = wsrc;
+            if(src.y2 > hsrc) src.y2 = hsrc;
+
+            if(dst.x1 < cb.x1)
+            {
+                src.x1 += cb.x1 - dst.x1;
+                dst.x1 = cb.x1;
+            }
+            if(dst.y1 < cb.y1)
+            {
+                src.y1 += cb.y1 - dst.y1;
+                dst.y1 = cb.y1;
+            }
+
+            if(dst.x2 > cb.x2) dst.x2 = cb.x2;
+            if(dst.y2 > cb.y2) dst.y2 = cb.y2;
+
+            rc.x2 = dst.x2 - dst.x1;
+            rc.y2 = dst.y2 - dst.y1;
+
+            if(rc.x2 > src.x2 - src.x1) rc.x2 = src.x2 - src.x1;
+            if(rc.y2 > src.y2 - src.y1) rc.y2 = src.y2 - src.y1;
+            return rc;
+        }
+
+        //--------------------------------------------------------------------
+        template<class RenBuf>
+        void copy_from(const RenBuf& src, 
+                       const rect_i* rect_src_ptr = 0, 
+                       int dx = 0, 
+                       int dy = 0)
+        {
+            rect_i rsrc(0, 0, src.width(), src.height());
+            if(rect_src_ptr)
+            {
+                rsrc.x1 = rect_src_ptr->x1; 
+                rsrc.y1 = rect_src_ptr->y1;
+                rsrc.x2 = rect_src_ptr->x2 + 1;
+                rsrc.y2 = rect_src_ptr->y2 + 1;
+            }
+
+            // Version with xdst, ydst (absolute positioning)
+            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
+
+            // Version with dx, dy (relative positioning)
+            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
+
+            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
+
+            if(rc.x2 > 0)
+            {
+                int incy = 1;
+                if(rdst.y1 > rsrc.y1)
+                {
+                    rsrc.y1 += rc.y2 - 1;
+                    rdst.y1 += rc.y2 - 1;
+                    incy = -1;
+                }
+                while(rc.y2 > 0)
+                {
+                    m_ren->copy_from(src, 
+                                     rdst.x1, rdst.y1,
+                                     rsrc.x1, rsrc.y1,
+                                     rc.x2);
+                    rdst.y1 += incy;
+                    rsrc.y1 += incy;
+                    --rc.y2;
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from(const SrcPixelFormatRenderer& src, 
+                        const rect_i* rect_src_ptr = 0, 
+                        int dx = 0, 
+                        int dy = 0,
+                        cover_type cover = mapserver::cover_full)
+        {
+            rect_i rsrc(0, 0, src.width(), src.height());
+            if(rect_src_ptr)
+            {
+                rsrc.x1 = rect_src_ptr->x1; 
+                rsrc.y1 = rect_src_ptr->y1;
+                rsrc.x2 = rect_src_ptr->x2 + 1;
+                rsrc.y2 = rect_src_ptr->y2 + 1;
+            }
+
+            // Version with xdst, ydst (absolute positioning)
+            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
+
+            // Version with dx, dy (relative positioning)
+            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
+            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
+
+            if(rc.x2 > 0)
+            {
+                int incy = 1;
+                if(rdst.y1 > rsrc.y1)
+                {
+                    rsrc.y1 += rc.y2 - 1;
+                    rdst.y1 += rc.y2 - 1;
+                    incy = -1;
+                }
+                while(rc.y2 > 0)
+                {
+                    typename SrcPixelFormatRenderer::row_data rw = src.row(rsrc.y1);
+                    if(rw.ptr)
+                    {
+                        int x1src = rsrc.x1;
+                        int x1dst = rdst.x1;
+                        int len   = rc.x2;
+                        if(rw.x1 > x1src)
+                        {
+                            x1dst += rw.x1 - x1src;
+                            len   -= rw.x1 - x1src;
+                            x1src  = rw.x1;
+                        }
+                        if(len > 0)
+                        {
+                            if(x1src + len-1 > rw.x2)
+                            {
+                                len -= x1src + len - rw.x2 - 1;
+                            }
+                            if(len > 0)
+                            {
+                                m_ren->blend_from(src,
+                                                  x1dst, rdst.y1,
+                                                  x1src, rsrc.y1,
+                                                  len,
+                                                  cover);
+                            }
+                        }
+                    }
+                    rdst.y1 += incy;
+                    rsrc.y1 += incy;
+                    --rc.y2;
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_color(const SrcPixelFormatRenderer& src, 
+                              const color_type& color,
+                              const rect_i* rect_src_ptr = 0, 
+                              int dx = 0, 
+                              int dy = 0,
+                              cover_type cover = mapserver::cover_full)
+        {
+            rect_i rsrc(0, 0, src.width(), src.height());
+            if(rect_src_ptr)
+            {
+                rsrc.x1 = rect_src_ptr->x1; 
+                rsrc.y1 = rect_src_ptr->y1;
+                rsrc.x2 = rect_src_ptr->x2 + 1;
+                rsrc.y2 = rect_src_ptr->y2 + 1;
+            }
+
+            // Version with xdst, ydst (absolute positioning)
+            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
+
+            // Version with dx, dy (relative positioning)
+            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
+            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
+
+            if(rc.x2 > 0)
+            {
+                int incy = 1;
+                if(rdst.y1 > rsrc.y1)
+                {
+                    rsrc.y1 += rc.y2 - 1;
+                    rdst.y1 += rc.y2 - 1;
+                    incy = -1;
+                }
+                while(rc.y2 > 0)
+                {
+                    typename SrcPixelFormatRenderer::row_data rw = src.row(rsrc.y1);
+                    if(rw.ptr)
+                    {
+                        int x1src = rsrc.x1;
+                        int x1dst = rdst.x1;
+                        int len   = rc.x2;
+                        if(rw.x1 > x1src)
+                        {
+                            x1dst += rw.x1 - x1src;
+                            len   -= rw.x1 - x1src;
+                            x1src  = rw.x1;
+                        }
+                        if(len > 0)
+                        {
+                            if(x1src + len-1 > rw.x2)
+                            {
+                                len -= x1src + len - rw.x2 - 1;
+                            }
+                            if(len > 0)
+                            {
+                                m_ren->blend_from_color(src,
+                                                        color,
+                                                        x1dst, rdst.y1,
+                                                        x1src, rsrc.y1,
+                                                        len,
+                                                        cover);
+                            }
+                        }
+                    }
+                    rdst.y1 += incy;
+                    rsrc.y1 += incy;
+                    --rc.y2;
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from_lut(const SrcPixelFormatRenderer& src, 
+                            const color_type* color_lut,
+                            const rect_i* rect_src_ptr = 0, 
+                            int dx = 0, 
+                            int dy = 0,
+                            cover_type cover = mapserver::cover_full)
+        {
+            rect_i rsrc(0, 0, src.width(), src.height());
+            if(rect_src_ptr)
+            {
+                rsrc.x1 = rect_src_ptr->x1; 
+                rsrc.y1 = rect_src_ptr->y1;
+                rsrc.x2 = rect_src_ptr->x2 + 1;
+                rsrc.y2 = rect_src_ptr->y2 + 1;
+            }
+
+            // Version with xdst, ydst (absolute positioning)
+            //rect_i rdst(xdst, ydst, xdst + rsrc.x2 - rsrc.x1, ydst + rsrc.y2 - rsrc.y1);
+
+            // Version with dx, dy (relative positioning)
+            rect_i rdst(rsrc.x1 + dx, rsrc.y1 + dy, rsrc.x2 + dx, rsrc.y2 + dy);
+            rect_i rc = clip_rect_area(rdst, rsrc, src.width(), src.height());
+
+            if(rc.x2 > 0)
+            {
+                int incy = 1;
+                if(rdst.y1 > rsrc.y1)
+                {
+                    rsrc.y1 += rc.y2 - 1;
+                    rdst.y1 += rc.y2 - 1;
+                    incy = -1;
+                }
+                while(rc.y2 > 0)
+                {
+                    typename SrcPixelFormatRenderer::row_data rw = src.row(rsrc.y1);
+                    if(rw.ptr)
+                    {
+                        int x1src = rsrc.x1;
+                        int x1dst = rdst.x1;
+                        int len   = rc.x2;
+                        if(rw.x1 > x1src)
+                        {
+                            x1dst += rw.x1 - x1src;
+                            len   -= rw.x1 - x1src;
+                            x1src  = rw.x1;
+                        }
+                        if(len > 0)
+                        {
+                            if(x1src + len-1 > rw.x2)
+                            {
+                                len -= x1src + len - rw.x2 - 1;
+                            }
+                            if(len > 0)
+                            {
+                                m_ren->blend_from_lut(src,
+                                                      color_lut,
+                                                      x1dst, rdst.y1,
+                                                      x1src, rsrc.y1,
+                                                      len,
+                                                      cover);
+                            }
+                        }
+                    }
+                    rdst.y1 += incy;
+                    rsrc.y1 += incy;
+                    --rc.y2;
+                }
+            }
+        }
+
+    private:
+        pixfmt_type* m_ren;
+        rect_i       m_clip_box;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_markers.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_markers.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_markers.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_markers.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,706 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class renderer_markers
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERER_MARKERS_INCLUDED
+#define AGG_RENDERER_MARKERS_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_renderer_primitives.h"
+
+namespace mapserver
+{
+
+    //---------------------------------------------------------------marker_e
+    enum marker_e
+    {
+        marker_square,
+        marker_diamond,
+        marker_circle,
+        marker_crossed_circle,
+        marker_semiellipse_left,
+        marker_semiellipse_right,
+        marker_semiellipse_up,
+        marker_semiellipse_down,
+        marker_triangle_left,
+        marker_triangle_right,
+        marker_triangle_up,
+        marker_triangle_down,
+        marker_four_rays,
+        marker_cross,
+        marker_x,
+        marker_dash,
+        marker_dot,
+        marker_pixel,
+        
+        end_of_markers
+    };
+
+
+
+    //--------------------------------------------------------renderer_markers
+    template<class BaseRenderer> class renderer_markers :
+    public renderer_primitives<BaseRenderer>
+    {
+    public:
+        typedef renderer_primitives<BaseRenderer> base_type;
+        typedef BaseRenderer base_ren_type;
+        typedef typename base_ren_type::color_type color_type;
+
+        //--------------------------------------------------------------------
+        renderer_markers(base_ren_type& rbuf) :
+            base_type(rbuf)
+        {}
+
+        //--------------------------------------------------------------------
+        bool visible(int x, int y, int r) const
+        {
+            rect_i rc(x-r, y-r, x+y, y+r);
+            return rc.clip(base_type::ren().bounding_clip_box());  
+        }
+
+        //--------------------------------------------------------------------
+        void square(int x, int y, int r)
+        {
+            if(visible(x, y, r)) 
+            {  
+                if(r) base_type::outlined_rectangle(x-r, y-r, x+r, y+r);
+                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void diamond(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int dy = -r;
+                    int dx = 0;
+                    do
+                    {
+                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
+                        
+                        if(dx)
+                        {
+                            base_type::ren().blend_hline(x-dx+1, y+dy, x+dx-1, base_type::fill_color(), cover_full);
+                            base_type::ren().blend_hline(x-dx+1, y-dy, x+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++dy;
+                        ++dx;
+                    }
+                    while(dy <= 0);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void circle(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r) base_type::outlined_ellipse(x, y, r, r);
+                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+            }
+        }
+
+
+
+        //--------------------------------------------------------------------
+        void crossed_circle(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    base_type::outlined_ellipse(x, y, r, r);
+                    int r6 = r + (r >> 1);
+                    if(r <= 2) r6++;
+                    r >>= 1;
+                    base_type::ren().blend_hline(x-r6, y, x-r,  base_type::line_color(), cover_full);
+                    base_type::ren().blend_hline(x+r,  y, x+r6, base_type::line_color(), cover_full);
+                    base_type::ren().blend_vline(x, y-r6, y-r,  base_type::line_color(), cover_full);
+                    base_type::ren().blend_vline(x, y+r,  y+r6, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //------------------------------------------------------------------------
+        void semiellipse_left(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int r8 = r * 4 / 5;
+                    int dy = -r;
+                    int dx = 0;
+                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
+                    do
+                    {
+                        dx += ei.dx();
+                        dy += ei.dy();
+                        
+                        base_type::ren().blend_pixel(x + dy, y + dx, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dy, y - dx, base_type::line_color(), cover_full);
+                        
+                        if(ei.dy() && dx)
+                        {
+                            base_type::ren().blend_vline(x+dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++ei;
+                    }
+                    while(dy < r8);
+                    base_type::ren().blend_vline(x+dy, y-dx, y+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void semiellipse_right(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int r8 = r * 4 / 5;
+                    int dy = -r;
+                    int dx = 0;
+                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
+                    do
+                    {
+                        dx += ei.dx();
+                        dy += ei.dy();
+                        
+                        base_type::ren().blend_pixel(x - dy, y + dx, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dy, y - dx, base_type::line_color(), cover_full);
+                        
+                        if(ei.dy() && dx)
+                        {
+                            base_type::ren().blend_vline(x-dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++ei;
+                    }
+                    while(dy < r8);
+                    base_type::ren().blend_vline(x-dy, y-dx, y+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void semiellipse_up(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int r8 = r * 4 / 5;
+                    int dy = -r;
+                    int dx = 0;
+                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
+                    do
+                    {
+                        dx += ei.dx();
+                        dy += ei.dy();
+                        
+                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
+                        
+                        if(ei.dy() && dx)
+                        {
+                            base_type::ren().blend_hline(x-dx+1, y-dy, x+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++ei;
+                    }
+                    while(dy < r8);
+                    base_type::ren().blend_hline(x-dx, y-dy-1, x+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void semiellipse_down(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int r8 = r * 4 / 5;
+                    int dy = -r;
+                    int dx = 0;
+                    ellipse_bresenham_interpolator ei(r * 3 / 5, r+r8);
+                    do
+                    {
+                        dx += ei.dx();
+                        dy += ei.dy();
+                        
+                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
+                        
+                        if(ei.dy() && dx)
+                        {
+                            base_type::ren().blend_hline(x-dx+1, y+dy, x+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++ei;
+                    }
+                    while(dy < r8);
+                    base_type::ren().blend_hline(x-dx, y+dy+1, x+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void triangle_left(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int dy = -r;
+                    int dx = 0;
+                    int flip = 0;
+                    int r6 = r * 3 / 5;
+                    do
+                    {
+                        base_type::ren().blend_pixel(x + dy, y - dx, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dy, y + dx, base_type::line_color(), cover_full);
+                        
+                        if(dx)
+                        {
+                            base_type::ren().blend_vline(x+dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++dy;
+                        dx += flip;
+                        flip ^= 1;
+                    }
+                    while(dy < r6);
+                    base_type::ren().blend_vline(x+dy, y-dx, y+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void triangle_right(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int dy = -r;
+                    int dx = 0;
+                    int flip = 0;
+                    int r6 = r * 3 / 5;
+                    do
+                    {
+                        base_type::ren().blend_pixel(x - dy, y - dx, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dy, y + dx, base_type::line_color(), cover_full);
+                        
+                        if(dx)
+                        {
+                            base_type::ren().blend_vline(x-dy, y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++dy;
+                        dx += flip;
+                        flip ^= 1;
+                    }
+                    while(dy < r6);
+                    base_type::ren().blend_vline(x-dy, y-dx, y+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void triangle_up(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int dy = -r;
+                    int dx = 0;
+                    int flip = 0;
+                    int r6 = r * 3 / 5;
+                    do
+                    {
+                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
+                        
+                        if(dx)
+                        {
+                            base_type::ren().blend_hline(x-dx+1, y-dy, x+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++dy;
+                        dx += flip;
+                        flip ^= 1;
+                    }
+                    while(dy < r6);
+                    base_type::ren().blend_hline(x-dx, y-dy, x+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void triangle_down(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int dy = -r;
+                    int dx = 0;
+                    int flip = 0;
+                    int r6 = r * 3 / 5;
+                    do
+                    {
+                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
+                        
+                        if(dx)
+                        {
+                            base_type::ren().blend_hline(x-dx+1, y+dy, x+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++dy;
+                        dx += flip;
+                        flip ^= 1;
+                    }
+                    while(dy < r6);
+                    base_type::ren().blend_hline(x-dx, y+dy, x+dx, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void four_rays(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int dy = -r;
+                    int dx = 0;
+                    int flip = 0;
+                    int r3 = -(r / 3);
+                    do
+                    {
+                        base_type::ren().blend_pixel(x - dx, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dx, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dx, y - dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dx, y - dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dy, y - dx, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dy, y + dx, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dy, y - dx, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dy, y + dx, base_type::line_color(), cover_full);
+                        
+                        if(dx)
+                        {
+                            base_type::ren().blend_hline(x-dx+1, y+dy,   x+dx-1, base_type::fill_color(), cover_full);
+                            base_type::ren().blend_hline(x-dx+1, y-dy,   x+dx-1, base_type::fill_color(), cover_full);
+                            base_type::ren().blend_vline(x+dy,   y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
+                            base_type::ren().blend_vline(x-dy,   y-dx+1, y+dx-1, base_type::fill_color(), cover_full);
+                        }
+                        ++dy;
+                        dx += flip;
+                        flip ^= 1;
+                    }
+                    while(dy <= r3);
+                    base_type::solid_rectangle(x+r3+1, y+r3+1, x-r3-1, y-r3-1);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        void cross(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    base_type::ren().blend_vline(x, y-r, y+r, base_type::line_color(), cover_full);
+                    base_type::ren().blend_hline(x-r, y, x+r, base_type::line_color(), cover_full);
+                }
+                else
+                {
+                    base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+                }
+            }
+        }
+        
+        
+        //--------------------------------------------------------------------
+        void xing(int x, int y, int r)
+        {
+            if(visible(x, y, r))
+            {
+                if(r)
+                {
+                    int dy = -r * 7 / 10;
+                    do
+                    {
+                        base_type::ren().blend_pixel(x + dy, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dy, y + dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x + dy, y - dy, base_type::line_color(), cover_full);
+                        base_type::ren().blend_pixel(x - dy, y - dy, base_type::line_color(), cover_full);
+                        ++dy;
+                    }
+                    while(dy < 0);
+                }
+                base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+            }
+        }
+        
+        
+        //--------------------------------------------------------------------
+        void dash(int x, int y, int r)
+        {
+            if(visible(x, y, r)) 
+            {
+                if(r) base_type::ren().blend_hline(x-r, y, x+r, base_type::line_color(), cover_full);
+                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+            }
+        }
+        
+        
+        //--------------------------------------------------------------------
+        void dot(int x, int y, int r)
+        {
+            if(visible(x, y, r)) 
+            {
+                if(r) base_type::solid_ellipse(x, y, r, r);
+                else  base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+            }
+        }
+        
+        //--------------------------------------------------------------------
+        void pixel(int x, int y, int)
+        {
+            base_type::ren().blend_pixel(x, y, base_type::fill_color(), cover_full);
+        }
+        
+        //--------------------------------------------------------------------
+        void marker(int x, int y, int r, marker_e type)
+        {
+            switch(type)
+            {
+                case marker_square:            square(x, y, r);            break;
+                case marker_diamond:           diamond(x, y, r);           break;
+                case marker_circle:            circle(x, y, r);            break;
+                case marker_crossed_circle:    crossed_circle(x, y, r);    break;
+                case marker_semiellipse_left:  semiellipse_left(x, y, r);  break;
+                case marker_semiellipse_right: semiellipse_right(x, y, r); break;
+                case marker_semiellipse_up:    semiellipse_up(x, y, r);    break;
+                case marker_semiellipse_down:  semiellipse_down(x, y, r);  break;
+                case marker_triangle_left:     triangle_left(x, y, r);     break;
+                case marker_triangle_right:    triangle_right(x, y, r);    break;
+                case marker_triangle_up:       triangle_up(x, y, r);       break;
+                case marker_triangle_down:     triangle_down(x, y, r);     break;
+                case marker_four_rays:         four_rays(x, y, r);         break;
+                case marker_cross:             cross(x, y, r);             break;
+                case marker_x:                 xing(x, y, r);              break;
+                case marker_dash:              dash(x, y, r);              break;
+                case marker_dot:               dot(x, y, r);               break;
+                case marker_pixel:             pixel(x, y, r);             break;
+            }
+        }
+
+
+        //--------------------------------------------------------------------
+        template<class T>
+        void markers(int n, const T* x, const T* y, T r, marker_e type)
+        {
+            if(n <= 0) return;
+            if(r == 0)
+            {
+                do
+                {
+                    base_type::ren().blend_pixel(int(*x), int(*y), base_type::fill_color(), cover_full);
+                    ++x;
+                    ++y;
+                }
+                while(--n);
+                return;
+            }
+            
+            switch(type)
+            {
+                case marker_square:            do { square           (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_diamond:           do { diamond          (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_circle:            do { circle           (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_crossed_circle:    do { crossed_circle   (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_semiellipse_left:  do { semiellipse_left (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_semiellipse_right: do { semiellipse_right(int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_semiellipse_up:    do { semiellipse_up   (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_semiellipse_down:  do { semiellipse_down (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_triangle_left:     do { triangle_left    (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_triangle_right:    do { triangle_right   (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_triangle_up:       do { triangle_up      (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_triangle_down:     do { triangle_down    (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_four_rays:         do { four_rays        (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_cross:             do { cross            (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_x:                 do { xing             (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_dash:              do { dash             (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_dot:               do { dot              (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+                case marker_pixel:             do { pixel            (int(*x), int(*y), int(r)); ++x; ++y; } while(--n); break;
+            }                                                                                  
+        }
+        
+        //--------------------------------------------------------------------
+        template<class T>
+        void markers(int n, const T* x, const T* y, const T* r, marker_e type)
+        {
+            if(n <= 0) return;
+            switch(type)
+            {
+                case marker_square:            do { square           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_diamond:           do { diamond          (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_circle:            do { circle           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_crossed_circle:    do { crossed_circle   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_semiellipse_left:  do { semiellipse_left (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_semiellipse_right: do { semiellipse_right(int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_semiellipse_up:    do { semiellipse_up   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_semiellipse_down:  do { semiellipse_down (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_triangle_left:     do { triangle_left    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_triangle_right:    do { triangle_right   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_triangle_up:       do { triangle_up      (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_triangle_down:     do { triangle_down    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_four_rays:         do { four_rays        (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_cross:             do { cross            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_x:                 do { xing             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_dash:              do { dash             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_dot:               do { dot              (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+                case marker_pixel:             do { pixel            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; } while(--n); break;
+            }                                                                                  
+        }
+        
+        //--------------------------------------------------------------------
+        template<class T>
+        void markers(int n, const T* x, const T* y, const T* r, const color_type* fc, marker_e type)
+        {
+            if(n <= 0) return;
+            switch(type)
+            {
+                case marker_square:            do { base_type::fill_color(*fc); square           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_diamond:           do { base_type::fill_color(*fc); diamond          (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_circle:            do { base_type::fill_color(*fc); circle           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_crossed_circle:    do { base_type::fill_color(*fc); crossed_circle   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_semiellipse_left:  do { base_type::fill_color(*fc); semiellipse_left (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_semiellipse_right: do { base_type::fill_color(*fc); semiellipse_right(int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_semiellipse_up:    do { base_type::fill_color(*fc); semiellipse_up   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_semiellipse_down:  do { base_type::fill_color(*fc); semiellipse_down (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_triangle_left:     do { base_type::fill_color(*fc); triangle_left    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_triangle_right:    do { base_type::fill_color(*fc); triangle_right   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_triangle_up:       do { base_type::fill_color(*fc); triangle_up      (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_triangle_down:     do { base_type::fill_color(*fc); triangle_down    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_four_rays:         do { base_type::fill_color(*fc); four_rays        (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_cross:             do { base_type::fill_color(*fc); cross            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_x:                 do { base_type::fill_color(*fc); xing             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_dash:              do { base_type::fill_color(*fc); dash             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_dot:               do { base_type::fill_color(*fc); dot              (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+                case marker_pixel:             do { base_type::fill_color(*fc); pixel            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; } while(--n); break;
+            }
+        }
+        
+        //--------------------------------------------------------------------
+        template<class T>
+        void markers(int n, const T* x, const T* y, const T* r, const color_type* fc, const color_type* lc, marker_e type)
+        {
+            if(n <= 0) return;
+            switch(type)
+            {
+                case marker_square:            do { base_type::fill_color(*fc); base_type::line_color(*lc); square           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_diamond:           do { base_type::fill_color(*fc); base_type::line_color(*lc); diamond          (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_circle:            do { base_type::fill_color(*fc); base_type::line_color(*lc); circle           (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_crossed_circle:    do { base_type::fill_color(*fc); base_type::line_color(*lc); crossed_circle   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_semiellipse_left:  do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_left (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_semiellipse_right: do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_right(int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_semiellipse_up:    do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_up   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_semiellipse_down:  do { base_type::fill_color(*fc); base_type::line_color(*lc); semiellipse_down (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_triangle_left:     do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_left    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_triangle_right:    do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_right   (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_triangle_up:       do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_up      (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_triangle_down:     do { base_type::fill_color(*fc); base_type::line_color(*lc); triangle_down    (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_four_rays:         do { base_type::fill_color(*fc); base_type::line_color(*lc); four_rays        (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_cross:             do { base_type::fill_color(*fc); base_type::line_color(*lc); cross            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_x:                 do { base_type::fill_color(*fc); base_type::line_color(*lc); xing             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_dash:              do { base_type::fill_color(*fc); base_type::line_color(*lc); dash             (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_dot:               do { base_type::fill_color(*fc); base_type::line_color(*lc); dot              (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+                case marker_pixel:             do { base_type::fill_color(*fc); base_type::line_color(*lc); pixel            (int(*x), int(*y), int(*r)); ++x; ++y; ++r; ++fc; ++lc; } while(--n); break;
+            }
+        }
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_mclip.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_mclip.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_mclip.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_mclip.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,349 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class renderer_mclip
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERER_MCLIP_INCLUDED
+#define AGG_RENDERER_MCLIP_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_array.h"
+#include "agg_renderer_base.h"
+
+namespace mapserver
+{
+
+    //----------------------------------------------------------renderer_mclip
+    template<class PixelFormat> class renderer_mclip
+    {
+    public:
+        typedef PixelFormat pixfmt_type;
+        typedef typename pixfmt_type::color_type color_type;
+        typedef typename pixfmt_type::row_data row_data;
+        typedef renderer_base<pixfmt_type> base_ren_type;
+
+        //--------------------------------------------------------------------
+        explicit renderer_mclip(pixfmt_type& pixf) :
+            m_ren(pixf),
+            m_curr_cb(0),
+            m_bounds(m_ren.xmin(), m_ren.ymin(), m_ren.xmax(), m_ren.ymax())
+        {}
+        void attach(pixfmt_type& pixf)
+        {
+            m_ren.attach(pixf);
+            reset_clipping(true);
+        }
+          
+        //--------------------------------------------------------------------
+        const pixfmt_type& ren() const { return m_ren.ren();  }
+        pixfmt_type& ren() { return m_ren.ren();  }
+
+        //--------------------------------------------------------------------
+        unsigned width()  const { return m_ren.width();  }
+        unsigned height() const { return m_ren.height(); }
+
+        //--------------------------------------------------------------------
+        const rect_i& clip_box() const { return m_ren.clip_box(); }
+        int           xmin()     const { return m_ren.xmin(); }
+        int           ymin()     const { return m_ren.ymin(); }
+        int           xmax()     const { return m_ren.xmax(); }
+        int           ymax()     const { return m_ren.ymax(); }
+
+        //--------------------------------------------------------------------
+        const rect_i& bounding_clip_box() const { return m_bounds;    }
+        int           bounding_xmin()     const { return m_bounds.x1; }
+        int           bounding_ymin()     const { return m_bounds.y1; }
+        int           bounding_xmax()     const { return m_bounds.x2; }
+        int           bounding_ymax()     const { return m_bounds.y2; }
+
+        //--------------------------------------------------------------------
+        void first_clip_box() 
+        {
+            m_curr_cb = 0;
+            if(m_clip.size())
+            {
+                const rect_i& cb = m_clip[0];
+                m_ren.clip_box_naked(cb.x1, cb.y1, cb.x2, cb.y2);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        bool next_clip_box() 
+        { 
+            if(++m_curr_cb < m_clip.size())
+            {
+                const rect_i& cb = m_clip[m_curr_cb];
+                m_ren.clip_box_naked(cb.x1, cb.y1, cb.x2, cb.y2);
+                return true;
+            }
+            return false; 
+        }
+
+        //--------------------------------------------------------------------
+        void reset_clipping(bool visibility)
+        {
+            m_ren.reset_clipping(visibility);
+            m_clip.remove_all();
+            m_curr_cb = 0;
+            m_bounds = m_ren.clip_box();
+        }
+        
+        //--------------------------------------------------------------------
+        void add_clip_box(int x1, int y1, int x2, int y2)
+        {
+            rect_i cb(x1, y1, x2, y2); 
+            cb.normalize();
+            if(cb.clip(rect_i(0, 0, width() - 1, height() - 1)))
+            {
+                m_clip.add(cb);
+                if(cb.x1 < m_bounds.x1) m_bounds.x1 = cb.x1;
+                if(cb.y1 < m_bounds.y1) m_bounds.y1 = cb.y1;
+                if(cb.x2 > m_bounds.x2) m_bounds.x2 = cb.x2;
+                if(cb.y2 > m_bounds.y2) m_bounds.y2 = cb.y2;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void clear(const color_type& c)
+        {
+            m_ren.clear(c);
+        }
+          
+        //--------------------------------------------------------------------
+        void copy_pixel(int x, int y, const color_type& c)
+        {
+            first_clip_box();
+            do
+            {
+                if(m_ren.inbox(x, y))
+                {
+                    m_ren.ren().copy_pixel(x, y, c);
+                    break;
+                }
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_pixel(int x, int y, const color_type& c, cover_type cover)
+        {
+            first_clip_box();
+            do
+            {
+                if(m_ren.inbox(x, y))
+                {
+                    m_ren.ren().blend_pixel(x, y, c, cover);
+                    break;
+                }
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        color_type pixel(int x, int y) const
+        {
+            first_clip_box();
+            do
+            {
+                if(m_ren.inbox(x, y))
+                {
+                    return m_ren.ren().pixel(x, y);
+                }
+            }
+            while(next_clip_box());
+            return color_type::no_color();
+        }
+
+        //--------------------------------------------------------------------
+        void copy_hline(int x1, int y, int x2, const color_type& c)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.copy_hline(x1, y, x2, c);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void copy_vline(int x, int y1, int y2, const color_type& c)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.copy_vline(x, y1, y2, c);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_hline(int x1, int y, int x2, 
+                         const color_type& c, cover_type cover)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_hline(x1, y, x2, c, cover);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_vline(int x, int y1, int y2, 
+                         const color_type& c, cover_type cover)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_vline(x, y1, y2, c, cover);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void copy_bar(int x1, int y1, int x2, int y2, const color_type& c)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.copy_bar(x1, y1, x2, y2, c);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_bar(int x1, int y1, int x2, int y2, 
+                       const color_type& c, cover_type cover)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_bar(x1, y1, x2, y2, c, cover);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y, int len, 
+                               const color_type& c, const cover_type* covers)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_solid_hspan(x, y, len, c, covers);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y, int len, 
+                               const color_type& c, const cover_type* covers)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_solid_vspan(x, y, len, c, covers);
+            }
+            while(next_clip_box());
+        }
+
+
+        //--------------------------------------------------------------------
+        void copy_color_hspan(int x, int y, int len, const color_type* colors)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.copy_color_hspan(x, y, len, colors);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_hspan(int x, int y, int len, 
+                               const color_type* colors, 
+                               const cover_type* covers,
+                               cover_type cover = cover_full)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_color_hspan(x, y, len, colors, covers, cover);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void blend_color_vspan(int x, int y, int len, 
+                               const color_type* colors, 
+                               const cover_type* covers,
+                               cover_type cover = cover_full)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_color_vspan(x, y, len, colors, covers, cover);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        void copy_from(const rendering_buffer& from, 
+                       const rect_i* rc=0, 
+                       int x_to=0, 
+                       int y_to=0)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.copy_from(from, rc, x_to, y_to);
+            }
+            while(next_clip_box());
+        }
+
+        //--------------------------------------------------------------------
+        template<class SrcPixelFormatRenderer>
+        void blend_from(const SrcPixelFormatRenderer& src, 
+                        const rect_i* rect_src_ptr = 0, 
+                        int dx = 0, 
+                        int dy = 0,
+                        cover_type cover = cover_full)
+        {
+            first_clip_box();
+            do
+            {
+                m_ren.blend_from(src, rect_src_ptr, dx, dy, cover);
+            }
+            while(next_clip_box());
+        }
+
+        
+    private:
+        renderer_mclip(const renderer_mclip<PixelFormat>&);
+        const renderer_mclip<PixelFormat>& 
+            operator = (const renderer_mclip<PixelFormat>&);
+
+        base_ren_type          m_ren;
+        pod_bvector<rect_i, 4> m_clip;
+        unsigned               m_curr_cb;
+        rect_i                 m_bounds;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_outline_aa.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_outline_aa.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_outline_aa.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_outline_aa.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1836 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_RENDERER_OUTLINE_AA_INCLUDED
+#define AGG_RENDERER_OUTLINE_AA_INCLUDED
+
+#include "agg_array.h"
+#include "agg_math.h"
+#include "agg_line_aa_basics.h"
+#include "agg_dda_line.h"
+#include "agg_ellipse_bresenham.h"
+#include "agg_renderer_base.h"
+#include "agg_gamma_functions.h"
+#include "agg_clip_liang_barsky.h"
+
+namespace mapserver
+{
+
+    //===================================================distance_interpolator0
+    class distance_interpolator0
+    {
+    public:
+        //---------------------------------------------------------------------
+        distance_interpolator0() {}
+        distance_interpolator0(int x1, int y1, int x2, int y2, int x, int y) :
+            m_dx(line_mr(x2) - line_mr(x1)),
+            m_dy(line_mr(y2) - line_mr(y1)),
+            m_dist((line_mr(x + line_subpixel_scale/2) - line_mr(x2)) * m_dy - 
+                   (line_mr(y + line_subpixel_scale/2) - line_mr(y2)) * m_dx)
+        {
+            m_dx <<= line_mr_subpixel_shift;
+            m_dy <<= line_mr_subpixel_shift;
+        }
+
+        //---------------------------------------------------------------------
+        void inc_x() { m_dist += m_dy; }
+        int  dist() const { return m_dist; }
+
+    private:
+        //---------------------------------------------------------------------
+        int m_dx;
+        int m_dy;
+        int m_dist;
+    };
+
+    //==================================================distance_interpolator00
+    class distance_interpolator00
+    {
+    public:
+        //---------------------------------------------------------------------
+        distance_interpolator00() {}
+        distance_interpolator00(int xc, int yc, 
+                                int x1, int y1, int x2, int y2, 
+                                int x,  int y) :
+            m_dx1(line_mr(x1) - line_mr(xc)),
+            m_dy1(line_mr(y1) - line_mr(yc)),
+            m_dx2(line_mr(x2) - line_mr(xc)),
+            m_dy2(line_mr(y2) - line_mr(yc)),
+            m_dist1((line_mr(x + line_subpixel_scale/2) - line_mr(x1)) * m_dy1 - 
+                    (line_mr(y + line_subpixel_scale/2) - line_mr(y1)) * m_dx1),
+            m_dist2((line_mr(x + line_subpixel_scale/2) - line_mr(x2)) * m_dy2 - 
+                    (line_mr(y + line_subpixel_scale/2) - line_mr(y2)) * m_dx2)
+        {
+            m_dx1 <<= line_mr_subpixel_shift;
+            m_dy1 <<= line_mr_subpixel_shift;
+            m_dx2 <<= line_mr_subpixel_shift;
+            m_dy2 <<= line_mr_subpixel_shift;
+        }
+
+        //---------------------------------------------------------------------
+        void inc_x() { m_dist1 += m_dy1; m_dist2 += m_dy2; }
+        int  dist1() const { return m_dist1; }
+        int  dist2() const { return m_dist2; }
+
+    private:
+        //---------------------------------------------------------------------
+        int m_dx1;
+        int m_dy1;
+        int m_dx2;
+        int m_dy2;
+        int m_dist1;
+        int m_dist2;
+    };
+
+    //===================================================distance_interpolator1
+    class distance_interpolator1
+    {
+    public:
+        //---------------------------------------------------------------------
+        distance_interpolator1() {}
+        distance_interpolator1(int x1, int y1, int x2, int y2, int x, int y) :
+            m_dx(x2 - x1),
+            m_dy(y2 - y1),
+            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
+                          double(y + line_subpixel_scale/2 - y2) * double(m_dx)))
+        {
+            m_dx <<= line_subpixel_shift;
+            m_dy <<= line_subpixel_shift;
+        }
+
+        //---------------------------------------------------------------------
+        void inc_x() { m_dist += m_dy; }
+        void dec_x() { m_dist -= m_dy; }
+        void inc_y() { m_dist -= m_dx; }
+        void dec_y() { m_dist += m_dx; }
+
+        //---------------------------------------------------------------------
+        void inc_x(int dy)
+        {
+            m_dist += m_dy; 
+            if(dy > 0) m_dist -= m_dx; 
+            if(dy < 0) m_dist += m_dx; 
+        }
+
+        //---------------------------------------------------------------------
+        void dec_x(int dy)
+        {
+            m_dist -= m_dy; 
+            if(dy > 0) m_dist -= m_dx; 
+            if(dy < 0) m_dist += m_dx; 
+        }
+
+        //---------------------------------------------------------------------
+        void inc_y(int dx)
+        {
+            m_dist -= m_dx; 
+            if(dx > 0) m_dist += m_dy; 
+            if(dx < 0) m_dist -= m_dy; 
+        }
+
+        void dec_y(int dx)
+        //---------------------------------------------------------------------
+        {
+            m_dist += m_dx; 
+            if(dx > 0) m_dist += m_dy; 
+            if(dx < 0) m_dist -= m_dy; 
+        }
+
+        //---------------------------------------------------------------------
+        int dist() const { return m_dist; }
+        int dx()   const { return m_dx;   }
+        int dy()   const { return m_dy;   }
+
+    private:
+        //---------------------------------------------------------------------
+        int m_dx;
+        int m_dy;
+        int m_dist;
+    };
+
+
+
+
+
+    //===================================================distance_interpolator2
+    class distance_interpolator2
+    {
+    public:
+        //---------------------------------------------------------------------
+        distance_interpolator2() {}
+        distance_interpolator2(int x1, int y1, int x2, int y2,
+                               int sx, int sy, int x,  int y) :
+            m_dx(x2 - x1),
+            m_dy(y2 - y1),
+            m_dx_start(line_mr(sx) - line_mr(x1)),
+            m_dy_start(line_mr(sy) - line_mr(y1)),
+
+            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
+                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
+
+            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(sx)) * m_dy_start - 
+                         (line_mr(y + line_subpixel_scale/2) - line_mr(sy)) * m_dx_start)
+        {
+            m_dx       <<= line_subpixel_shift;
+            m_dy       <<= line_subpixel_shift;
+            m_dx_start <<= line_mr_subpixel_shift;
+            m_dy_start <<= line_mr_subpixel_shift;
+        }
+
+        distance_interpolator2(int x1, int y1, int x2, int y2,
+                               int ex, int ey, int x,  int y, int) :
+            m_dx(x2 - x1),
+            m_dy(y2 - y1),
+            m_dx_start(line_mr(ex) - line_mr(x2)),
+            m_dy_start(line_mr(ey) - line_mr(y2)),
+
+            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
+                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
+
+            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(ex)) * m_dy_start - 
+                         (line_mr(y + line_subpixel_scale/2) - line_mr(ey)) * m_dx_start)
+        {
+            m_dx       <<= line_subpixel_shift;
+            m_dy       <<= line_subpixel_shift;
+            m_dx_start <<= line_mr_subpixel_shift;
+            m_dy_start <<= line_mr_subpixel_shift;
+        }
+
+
+        //---------------------------------------------------------------------
+        void inc_x() { m_dist += m_dy; m_dist_start += m_dy_start; }
+        void dec_x() { m_dist -= m_dy; m_dist_start -= m_dy_start; }
+        void inc_y() { m_dist -= m_dx; m_dist_start -= m_dx_start; }
+        void dec_y() { m_dist += m_dx; m_dist_start += m_dx_start; }
+
+        //---------------------------------------------------------------------
+        void inc_x(int dy)
+        {
+            m_dist       += m_dy; 
+            m_dist_start += m_dy_start; 
+            if(dy > 0)
+            {
+                m_dist       -= m_dx; 
+                m_dist_start -= m_dx_start; 
+            }
+            if(dy < 0)
+            {
+                m_dist       += m_dx; 
+                m_dist_start += m_dx_start; 
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void dec_x(int dy)
+        {
+            m_dist       -= m_dy; 
+            m_dist_start -= m_dy_start; 
+            if(dy > 0)
+            {
+                m_dist       -= m_dx; 
+                m_dist_start -= m_dx_start; 
+            }
+            if(dy < 0)
+            {
+                m_dist       += m_dx; 
+                m_dist_start += m_dx_start; 
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void inc_y(int dx)
+        {
+            m_dist       -= m_dx; 
+            m_dist_start -= m_dx_start; 
+            if(dx > 0)
+            {
+                m_dist       += m_dy; 
+                m_dist_start += m_dy_start; 
+            }
+            if(dx < 0)
+            {
+                m_dist       -= m_dy; 
+                m_dist_start -= m_dy_start; 
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void dec_y(int dx)
+        {
+            m_dist       += m_dx; 
+            m_dist_start += m_dx_start; 
+            if(dx > 0)
+            {
+                m_dist       += m_dy; 
+                m_dist_start += m_dy_start; 
+            }
+            if(dx < 0)
+            {
+                m_dist       -= m_dy; 
+                m_dist_start -= m_dy_start; 
+            }
+        }
+
+        //---------------------------------------------------------------------
+        int dist()       const { return m_dist;       }
+        int dist_start() const { return m_dist_start; }
+        int dist_end()   const { return m_dist_start; }
+
+        //---------------------------------------------------------------------
+        int dx()       const { return m_dx;       }
+        int dy()       const { return m_dy;       }
+        int dx_start() const { return m_dx_start; }
+        int dy_start() const { return m_dy_start; }
+        int dx_end()   const { return m_dx_start; }
+        int dy_end()   const { return m_dy_start; }
+
+    private:
+        //---------------------------------------------------------------------
+        int m_dx;
+        int m_dy;
+        int m_dx_start;
+        int m_dy_start;
+
+        int m_dist;
+        int m_dist_start;
+    };
+
+
+
+
+
+    //===================================================distance_interpolator3
+    class distance_interpolator3
+    {
+    public:
+        //---------------------------------------------------------------------
+        distance_interpolator3() {}
+        distance_interpolator3(int x1, int y1, int x2, int y2,
+                               int sx, int sy, int ex, int ey, 
+                               int x,  int y) :
+            m_dx(x2 - x1),
+            m_dy(y2 - y1),
+            m_dx_start(line_mr(sx) - line_mr(x1)),
+            m_dy_start(line_mr(sy) - line_mr(y1)),
+            m_dx_end(line_mr(ex) - line_mr(x2)),
+            m_dy_end(line_mr(ey) - line_mr(y2)),
+
+            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
+                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
+
+            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(sx)) * m_dy_start - 
+                         (line_mr(y + line_subpixel_scale/2) - line_mr(sy)) * m_dx_start),
+
+            m_dist_end((line_mr(x + line_subpixel_scale/2) - line_mr(ex)) * m_dy_end - 
+                       (line_mr(y + line_subpixel_scale/2) - line_mr(ey)) * m_dx_end)
+        {
+            m_dx       <<= line_subpixel_shift;
+            m_dy       <<= line_subpixel_shift;
+            m_dx_start <<= line_mr_subpixel_shift;
+            m_dy_start <<= line_mr_subpixel_shift;
+            m_dx_end   <<= line_mr_subpixel_shift;
+            m_dy_end   <<= line_mr_subpixel_shift;
+        }
+
+        //---------------------------------------------------------------------
+        void inc_x() { m_dist += m_dy; m_dist_start += m_dy_start; m_dist_end += m_dy_end; }
+        void dec_x() { m_dist -= m_dy; m_dist_start -= m_dy_start; m_dist_end -= m_dy_end; }
+        void inc_y() { m_dist -= m_dx; m_dist_start -= m_dx_start; m_dist_end -= m_dx_end; }
+        void dec_y() { m_dist += m_dx; m_dist_start += m_dx_start; m_dist_end += m_dx_end; }
+
+        //---------------------------------------------------------------------
+        void inc_x(int dy)
+        {
+            m_dist       += m_dy; 
+            m_dist_start += m_dy_start; 
+            m_dist_end   += m_dy_end;
+            if(dy > 0)
+            {
+                m_dist       -= m_dx; 
+                m_dist_start -= m_dx_start; 
+                m_dist_end   -= m_dx_end;
+            }
+            if(dy < 0)
+            {
+                m_dist       += m_dx; 
+                m_dist_start += m_dx_start; 
+                m_dist_end   += m_dx_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void dec_x(int dy)
+        {
+            m_dist       -= m_dy; 
+            m_dist_start -= m_dy_start; 
+            m_dist_end   -= m_dy_end;
+            if(dy > 0)
+            {
+                m_dist       -= m_dx; 
+                m_dist_start -= m_dx_start; 
+                m_dist_end   -= m_dx_end;
+            }
+            if(dy < 0)
+            {
+                m_dist       += m_dx; 
+                m_dist_start += m_dx_start; 
+                m_dist_end   += m_dx_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void inc_y(int dx)
+        {
+            m_dist       -= m_dx; 
+            m_dist_start -= m_dx_start; 
+            m_dist_end   -= m_dx_end;
+            if(dx > 0)
+            {
+                m_dist       += m_dy; 
+                m_dist_start += m_dy_start; 
+                m_dist_end   += m_dy_end;
+            }
+            if(dx < 0)
+            {
+                m_dist       -= m_dy; 
+                m_dist_start -= m_dy_start; 
+                m_dist_end   -= m_dy_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void dec_y(int dx)
+        {
+            m_dist       += m_dx; 
+            m_dist_start += m_dx_start; 
+            m_dist_end   += m_dx_end;
+            if(dx > 0)
+            {
+                m_dist       += m_dy; 
+                m_dist_start += m_dy_start; 
+                m_dist_end   += m_dy_end;
+            }
+            if(dx < 0)
+            {
+                m_dist       -= m_dy; 
+                m_dist_start -= m_dy_start; 
+                m_dist_end   -= m_dy_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        int dist()       const { return m_dist;       }
+        int dist_start() const { return m_dist_start; }
+        int dist_end()   const { return m_dist_end;   }
+
+        //---------------------------------------------------------------------
+        int dx()       const { return m_dx;       }
+        int dy()       const { return m_dy;       }
+        int dx_start() const { return m_dx_start; }
+        int dy_start() const { return m_dy_start; }
+        int dx_end()   const { return m_dx_end;   }
+        int dy_end()   const { return m_dy_end;   }
+
+    private:
+        //---------------------------------------------------------------------
+        int m_dx;
+        int m_dy;
+        int m_dx_start;
+        int m_dy_start;
+        int m_dx_end;
+        int m_dy_end;
+
+        int m_dist;
+        int m_dist_start;
+        int m_dist_end;
+    };
+
+
+
+
+    
+    //================================================line_interpolator_aa_base
+    template<class Renderer> class line_interpolator_aa_base
+    {
+    public:
+        typedef Renderer renderer_type;
+        typedef typename Renderer::color_type color_type;
+
+        //---------------------------------------------------------------------
+        enum max_half_width_e
+        { 
+            max_half_width = 64
+        };
+
+        //---------------------------------------------------------------------
+        line_interpolator_aa_base(renderer_type& ren, const line_parameters& lp) :
+            m_lp(&lp),
+            m_li(lp.vertical ? line_dbl_hr(lp.x2 - lp.x1) :
+                               line_dbl_hr(lp.y2 - lp.y1),
+                 lp.vertical ? abs(lp.y2 - lp.y1) : 
+                               abs(lp.x2 - lp.x1) + 1),
+            m_ren(ren),
+            m_len((lp.vertical == (lp.inc > 0)) ? -lp.len : lp.len),
+            m_x(lp.x1 >> line_subpixel_shift),
+            m_y(lp.y1 >> line_subpixel_shift),
+            m_old_x(m_x),
+            m_old_y(m_y),
+            m_count((lp.vertical ? abs((lp.y2 >> line_subpixel_shift) - m_y) :
+                                   abs((lp.x2 >> line_subpixel_shift) - m_x))),
+            m_width(ren.subpixel_width()),
+            //m_max_extent(m_width >> (line_subpixel_shift - 2)),
+            m_max_extent((m_width + line_subpixel_mask) >> line_subpixel_shift),
+            m_step(0)
+        {
+            mapserver::dda2_line_interpolator li(0, lp.vertical ? 
+                                              (lp.dy << mapserver::line_subpixel_shift) :
+                                              (lp.dx << mapserver::line_subpixel_shift),
+                                           lp.len);
+
+            unsigned i;
+            int stop = m_width + line_subpixel_scale * 2;
+            for(i = 0; i < max_half_width; ++i)
+            {
+                m_dist[i] = li.y();
+                if(m_dist[i] >= stop) break;
+                ++li;
+            }
+            m_dist[i++] = 0x7FFF0000;
+        }
+
+        //---------------------------------------------------------------------
+        template<class DI> int step_hor_base(DI& di)
+        {
+            ++m_li;
+            m_x += m_lp->inc;
+            m_y = (m_lp->y1 + m_li.y()) >> line_subpixel_shift;
+
+            if(m_lp->inc > 0) di.inc_x(m_y - m_old_y);
+            else              di.dec_x(m_y - m_old_y);
+
+            m_old_y = m_y;
+
+            return di.dist() / m_len;
+        }
+
+        //---------------------------------------------------------------------
+        template<class DI> int step_ver_base(DI& di)
+        {
+            ++m_li;
+            m_y += m_lp->inc;
+            m_x = (m_lp->x1 + m_li.y()) >> line_subpixel_shift;
+
+            if(m_lp->inc > 0) di.inc_y(m_x - m_old_x);
+            else              di.dec_y(m_x - m_old_x);
+
+            m_old_x = m_x;
+
+            return di.dist() / m_len;
+        }
+
+        //---------------------------------------------------------------------
+        bool vertical() const { return m_lp->vertical; }
+        int  width() const { return m_width; }
+        int  count() const { return m_count; }
+
+    private:
+        line_interpolator_aa_base(const line_interpolator_aa_base<Renderer>&);
+        const line_interpolator_aa_base<Renderer>& 
+            operator = (const line_interpolator_aa_base<Renderer>&);
+
+    protected:
+        const line_parameters* m_lp;
+        dda2_line_interpolator m_li;
+        renderer_type&         m_ren;
+        int m_len;
+        int m_x;
+        int m_y;
+        int m_old_x;
+        int m_old_y;
+        int m_count;
+        int m_width;
+        int m_max_extent;
+        int m_step;
+        int m_dist[max_half_width + 1];
+        cover_type m_covers[max_half_width * 2 + 4];
+    };
+
+
+
+
+
+
+
+    //====================================================line_interpolator_aa0
+    template<class Renderer> class line_interpolator_aa0 :
+    public line_interpolator_aa_base<Renderer>
+    {
+    public:
+        typedef Renderer renderer_type;
+        typedef typename Renderer::color_type color_type;
+        typedef line_interpolator_aa_base<Renderer> base_type;
+
+        //---------------------------------------------------------------------
+        line_interpolator_aa0(renderer_type& ren, const line_parameters& lp) :
+            line_interpolator_aa_base<Renderer>(ren, lp),
+            m_di(lp.x1, lp.y1, lp.x2, lp.y2, 
+                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask)
+        {
+            base_type::m_li.adjust_forward();
+        }
+
+        //---------------------------------------------------------------------
+        bool step_hor()
+        {
+            int dist;
+            int dy;
+            int s1 = base_type::step_hor_base(m_di);
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            *p1++ = (cover_type)base_type::m_ren.cover(s1);
+
+            dy = 1;
+            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
+            {
+                *p1++ = (cover_type)base_type::m_ren.cover(dist);
+                ++dy;
+            }
+
+            dy = 1;
+            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
+            {
+                *--p0 = (cover_type)base_type::m_ren.cover(dist);
+                ++dy;
+            }
+            base_type::m_ren.blend_solid_vspan(base_type::m_x, 
+                                               base_type::m_y - dy + 1, 
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return ++base_type::m_step < base_type::m_count;
+        }
+
+        //---------------------------------------------------------------------
+        bool step_ver()
+        {
+            int dist;
+            int dx;
+            int s1 = base_type::step_ver_base(m_di);
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            *p1++ = (cover_type)base_type::m_ren.cover(s1);
+
+            dx = 1;
+            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
+            {
+                *p1++ = (cover_type)base_type::m_ren.cover(dist);
+                ++dx;
+            }
+
+            dx = 1;
+            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
+            {
+                *--p0 = (cover_type)base_type::m_ren.cover(dist);
+                ++dx;
+            }
+            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1, 
+                                               base_type::m_y,
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return ++base_type::m_step < base_type::m_count;
+        }
+
+    private:
+        line_interpolator_aa0(const line_interpolator_aa0<Renderer>&);
+        const line_interpolator_aa0<Renderer>& 
+            operator = (const line_interpolator_aa0<Renderer>&);
+
+        //---------------------------------------------------------------------
+        distance_interpolator1 m_di; 
+    };
+
+
+
+
+
+
+    //====================================================line_interpolator_aa1
+    template<class Renderer> class line_interpolator_aa1 :
+    public line_interpolator_aa_base<Renderer>
+    {
+    public:
+        typedef Renderer renderer_type;
+        typedef typename Renderer::color_type color_type;
+        typedef line_interpolator_aa_base<Renderer> base_type;
+
+        //---------------------------------------------------------------------
+        line_interpolator_aa1(renderer_type& ren, const line_parameters& lp, 
+                              int sx, int sy) :
+            line_interpolator_aa_base<Renderer>(ren, lp),
+            m_di(lp.x1, lp.y1, lp.x2, lp.y2, sx, sy,
+                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask)
+        {
+            int dist1_start;
+            int dist2_start;
+
+            int npix = 1;
+
+            if(lp.vertical)
+            {
+                do
+                {
+                    --base_type::m_li;
+                    base_type::m_y -= lp.inc;
+                    base_type::m_x = (base_type::m_lp->x1 + base_type::m_li.y()) >> line_subpixel_shift;
+
+                    if(lp.inc > 0) m_di.dec_y(base_type::m_x - base_type::m_old_x);
+                    else           m_di.inc_y(base_type::m_x - base_type::m_old_x);
+
+                    base_type::m_old_x = base_type::m_x;
+
+                    dist1_start = dist2_start = m_di.dist_start(); 
+
+                    int dx = 0;
+                    if(dist1_start < 0) ++npix;
+                    do
+                    {
+                        dist1_start += m_di.dy_start();
+                        dist2_start -= m_di.dy_start();
+                        if(dist1_start < 0) ++npix;
+                        if(dist2_start < 0) ++npix;
+                        ++dx;
+                    }
+                    while(base_type::m_dist[dx] <= base_type::m_width);
+                    --base_type::m_step;
+                    if(npix == 0) break;
+                    npix = 0;
+                }
+                while(base_type::m_step >= -base_type::m_max_extent);
+            }
+            else
+            {
+                do
+                {
+                    --base_type::m_li;
+                    base_type::m_x -= lp.inc;
+                    base_type::m_y = (base_type::m_lp->y1 + base_type::m_li.y()) >> line_subpixel_shift;
+
+                    if(lp.inc > 0) m_di.dec_x(base_type::m_y - base_type::m_old_y);
+                    else           m_di.inc_x(base_type::m_y - base_type::m_old_y);
+
+                    base_type::m_old_y = base_type::m_y;
+
+                    dist1_start = dist2_start = m_di.dist_start(); 
+
+                    int dy = 0;
+                    if(dist1_start < 0) ++npix;
+                    do
+                    {
+                        dist1_start -= m_di.dx_start();
+                        dist2_start += m_di.dx_start();
+                        if(dist1_start < 0) ++npix;
+                        if(dist2_start < 0) ++npix;
+                        ++dy;
+                    }
+                    while(base_type::m_dist[dy] <= base_type::m_width);
+                    --base_type::m_step;
+                    if(npix == 0) break;
+                    npix = 0;
+                }
+                while(base_type::m_step >= -base_type::m_max_extent);
+            }
+            base_type::m_li.adjust_forward();
+        }
+
+        //---------------------------------------------------------------------
+        bool step_hor()
+        {
+            int dist_start;
+            int dist;
+            int dy;
+            int s1 = base_type::step_hor_base(m_di);
+
+            dist_start = m_di.dist_start();
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            *p1 = 0;
+            if(dist_start <= 0)
+            {
+                *p1 = (cover_type)base_type::m_ren.cover(s1);
+            }
+            ++p1;
+
+            dy = 1;
+            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
+            {
+                dist_start -= m_di.dx_start();
+                *p1 = 0;
+                if(dist_start <= 0)
+                {   
+                    *p1 = (cover_type)base_type::m_ren.cover(dist);
+                }
+                ++p1;
+                ++dy;
+            }
+
+            dy = 1;
+            dist_start = m_di.dist_start();
+            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
+            {
+                dist_start += m_di.dx_start();
+                *--p0 = 0;
+                if(dist_start <= 0)
+                {   
+                    *p0 = (cover_type)base_type::m_ren.cover(dist);
+                }
+                ++dy;
+            }
+
+            base_type::m_ren.blend_solid_vspan(base_type::m_x, 
+                                               base_type::m_y - dy + 1,
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return ++base_type::m_step < base_type::m_count;
+        }
+
+        //---------------------------------------------------------------------
+        bool step_ver()
+        {
+            int dist_start;
+            int dist;
+            int dx;
+            int s1 = base_type::step_ver_base(m_di);
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            dist_start = m_di.dist_start();
+
+            *p1 = 0;
+            if(dist_start <= 0)
+            {
+                *p1 = (cover_type)base_type::m_ren.cover(s1);
+            }
+            ++p1;
+
+            dx = 1;
+            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
+            {
+                dist_start += m_di.dy_start();
+                *p1 = 0;
+                if(dist_start <= 0)
+                {   
+                    *p1 = (cover_type)base_type::m_ren.cover(dist);
+                }
+                ++p1;
+                ++dx;
+            }
+
+            dx = 1;
+            dist_start = m_di.dist_start();
+            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
+            {
+                dist_start -= m_di.dy_start();
+                *--p0 = 0;
+                if(dist_start <= 0)
+                {   
+                    *p0 = (cover_type)base_type::m_ren.cover(dist);
+                }
+                ++dx;
+            }
+            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1, 
+                                               base_type::m_y,
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return ++base_type::m_step < base_type::m_count;
+        }
+
+    private:
+        line_interpolator_aa1(const line_interpolator_aa1<Renderer>&);
+        const line_interpolator_aa1<Renderer>& 
+            operator = (const line_interpolator_aa1<Renderer>&);
+
+        //---------------------------------------------------------------------
+        distance_interpolator2 m_di; 
+    };
+
+
+
+
+
+
+
+
+
+
+
+
+    //====================================================line_interpolator_aa2
+    template<class Renderer> class line_interpolator_aa2 :
+    public line_interpolator_aa_base<Renderer>
+    {
+    public:
+        typedef Renderer renderer_type;
+        typedef typename Renderer::color_type color_type;
+        typedef line_interpolator_aa_base<Renderer> base_type;
+
+        //---------------------------------------------------------------------
+        line_interpolator_aa2(renderer_type& ren, const line_parameters& lp, 
+                              int ex, int ey) :
+            line_interpolator_aa_base<Renderer>(ren, lp),
+            m_di(lp.x1, lp.y1, lp.x2, lp.y2, ex, ey, 
+                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask,
+                 0)
+        {
+            base_type::m_li.adjust_forward();
+            base_type::m_step -= base_type::m_max_extent;
+        }
+
+        //---------------------------------------------------------------------
+        bool step_hor()
+        {
+            int dist_end;
+            int dist;
+            int dy;
+            int s1 = base_type::step_hor_base(m_di);
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            dist_end = m_di.dist_end();
+
+            int npix = 0;
+            *p1 = 0;
+            if(dist_end > 0)
+            {
+                *p1 = (cover_type)base_type::m_ren.cover(s1);
+                ++npix;
+            }
+            ++p1;
+
+            dy = 1;
+            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
+            {
+                dist_end -= m_di.dx_end();
+                *p1 = 0;
+                if(dist_end > 0)
+                {   
+                    *p1 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++p1;
+                ++dy;
+            }
+
+            dy = 1;
+            dist_end = m_di.dist_end();
+            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
+            {
+                dist_end += m_di.dx_end();
+                *--p0 = 0;
+                if(dist_end > 0)
+                {   
+                    *p0 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++dy;
+            }
+            base_type::m_ren.blend_solid_vspan(base_type::m_x,
+                                               base_type::m_y - dy + 1, 
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return npix && ++base_type::m_step < base_type::m_count;
+        }
+
+        //---------------------------------------------------------------------
+        bool step_ver()
+        {
+            int dist_end;
+            int dist;
+            int dx;
+            int s1 = base_type::step_ver_base(m_di);
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            dist_end = m_di.dist_end();
+
+            int npix = 0;
+            *p1 = 0;
+            if(dist_end > 0)
+            {
+                *p1 = (cover_type)base_type::m_ren.cover(s1);
+                ++npix;
+            }
+            ++p1;
+
+            dx = 1;
+            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
+            {
+                dist_end += m_di.dy_end();
+                *p1 = 0;
+                if(dist_end > 0)
+                {   
+                    *p1 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++p1;
+                ++dx;
+            }
+
+            dx = 1;
+            dist_end = m_di.dist_end();
+            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
+            {
+                dist_end -= m_di.dy_end();
+                *--p0 = 0;
+                if(dist_end > 0)
+                {   
+                    *p0 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++dx;
+            }
+            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1,
+                                               base_type::m_y, 
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return npix && ++base_type::m_step < base_type::m_count;
+        }
+
+    private:
+        line_interpolator_aa2(const line_interpolator_aa2<Renderer>&);
+        const line_interpolator_aa2<Renderer>& 
+            operator = (const line_interpolator_aa2<Renderer>&);
+
+        //---------------------------------------------------------------------
+        distance_interpolator2 m_di; 
+    };
+
+
+
+
+
+
+
+
+
+
+    //====================================================line_interpolator_aa3
+    template<class Renderer> class line_interpolator_aa3 :
+    public line_interpolator_aa_base<Renderer>
+    {
+    public:
+        typedef Renderer renderer_type;
+        typedef typename Renderer::color_type color_type;
+        typedef line_interpolator_aa_base<Renderer> base_type;
+
+        //---------------------------------------------------------------------
+        line_interpolator_aa3(renderer_type& ren, const line_parameters& lp, 
+                              int sx, int sy, int ex, int ey) :
+            line_interpolator_aa_base<Renderer>(ren, lp),
+            m_di(lp.x1, lp.y1, lp.x2, lp.y2, sx, sy, ex, ey, 
+                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask)
+        {
+            int dist1_start;
+            int dist2_start;
+            int npix = 1;
+            if(lp.vertical)
+            {
+                do
+                {
+                    --base_type::m_li;
+                    base_type::m_y -= lp.inc;
+                    base_type::m_x = (base_type::m_lp->x1 + base_type::m_li.y()) >> line_subpixel_shift;
+
+                    if(lp.inc > 0) m_di.dec_y(base_type::m_x - base_type::m_old_x);
+                    else           m_di.inc_y(base_type::m_x - base_type::m_old_x);
+
+                    base_type::m_old_x = base_type::m_x;
+
+                    dist1_start = dist2_start = m_di.dist_start(); 
+
+                    int dx = 0;
+                    if(dist1_start < 0) ++npix;
+                    do
+                    {
+                        dist1_start += m_di.dy_start();
+                        dist2_start -= m_di.dy_start();
+                        if(dist1_start < 0) ++npix;
+                        if(dist2_start < 0) ++npix;
+                        ++dx;
+                    }
+                    while(base_type::m_dist[dx] <= base_type::m_width);
+                    if(npix == 0) break;
+                    npix = 0;
+                }
+                while(--base_type::m_step >= -base_type::m_max_extent);
+            }
+            else
+            {
+                do
+                {
+                    --base_type::m_li;
+                    base_type::m_x -= lp.inc;
+                    base_type::m_y = (base_type::m_lp->y1 + base_type::m_li.y()) >> line_subpixel_shift;
+
+                    if(lp.inc > 0) m_di.dec_x(base_type::m_y - base_type::m_old_y);
+                    else           m_di.inc_x(base_type::m_y - base_type::m_old_y);
+
+                    base_type::m_old_y = base_type::m_y;
+
+                    dist1_start = dist2_start = m_di.dist_start(); 
+
+                    int dy = 0;
+                    if(dist1_start < 0) ++npix;
+                    do
+                    {
+                        dist1_start -= m_di.dx_start();
+                        dist2_start += m_di.dx_start();
+                        if(dist1_start < 0) ++npix;
+                        if(dist2_start < 0) ++npix;
+                        ++dy;
+                    }
+                    while(base_type::m_dist[dy] <= base_type::m_width);
+                    if(npix == 0) break;
+                    npix = 0;
+                }
+                while(--base_type::m_step >= -base_type::m_max_extent);
+            }
+            base_type::m_li.adjust_forward();
+            base_type::m_step -= base_type::m_max_extent;
+        }
+
+
+        //---------------------------------------------------------------------
+        bool step_hor()
+        {
+            int dist_start;
+            int dist_end;
+            int dist;
+            int dy;
+            int s1 = base_type::step_hor_base(m_di);
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            dist_start = m_di.dist_start();
+            dist_end   = m_di.dist_end();
+
+            int npix = 0;
+            *p1 = 0;
+            if(dist_end > 0)
+            {
+                if(dist_start <= 0)
+                {
+                    *p1 = (cover_type)base_type::m_ren.cover(s1);
+                }
+                ++npix;
+            }
+            ++p1;
+
+            dy = 1;
+            while((dist = base_type::m_dist[dy] - s1) <= base_type::m_width)
+            {
+                dist_start -= m_di.dx_start();
+                dist_end   -= m_di.dx_end();
+                *p1 = 0;
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    *p1 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++p1;
+                ++dy;
+            }
+
+            dy = 1;
+            dist_start = m_di.dist_start();
+            dist_end   = m_di.dist_end();
+            while((dist = base_type::m_dist[dy] + s1) <= base_type::m_width)
+            {
+                dist_start += m_di.dx_start();
+                dist_end   += m_di.dx_end();
+                *--p0 = 0;
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    *p0 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++dy;
+            }
+            base_type::m_ren.blend_solid_vspan(base_type::m_x,
+                                               base_type::m_y - dy + 1, 
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return npix && ++base_type::m_step < base_type::m_count;
+        }
+
+        //---------------------------------------------------------------------
+        bool step_ver()
+        {
+            int dist_start;
+            int dist_end;
+            int dist;
+            int dx;
+            int s1 = base_type::step_ver_base(m_di);
+            cover_type* p0 = base_type::m_covers + base_type::max_half_width + 2;
+            cover_type* p1 = p0;
+
+            dist_start = m_di.dist_start();
+            dist_end   = m_di.dist_end();
+
+            int npix = 0;
+            *p1 = 0;
+            if(dist_end > 0)
+            {
+                if(dist_start <= 0)
+                {
+                    *p1 = (cover_type)base_type::m_ren.cover(s1);
+                }
+                ++npix;
+            }
+            ++p1;
+
+            dx = 1;
+            while((dist = base_type::m_dist[dx] - s1) <= base_type::m_width)
+            {
+                dist_start += m_di.dy_start();
+                dist_end   += m_di.dy_end();
+                *p1 = 0;
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    *p1 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++p1;
+                ++dx;
+            }
+
+            dx = 1;
+            dist_start = m_di.dist_start();
+            dist_end   = m_di.dist_end();
+            while((dist = base_type::m_dist[dx] + s1) <= base_type::m_width)
+            {
+                dist_start -= m_di.dy_start();
+                dist_end   -= m_di.dy_end();
+                *--p0 = 0;
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    *p0 = (cover_type)base_type::m_ren.cover(dist);
+                    ++npix;
+                }
+                ++dx;
+            }
+            base_type::m_ren.blend_solid_hspan(base_type::m_x - dx + 1,
+                                               base_type::m_y, 
+                                               unsigned(p1 - p0), 
+                                               p0);
+            return npix && ++base_type::m_step < base_type::m_count;
+        }
+
+    private:
+        line_interpolator_aa3(const line_interpolator_aa3<Renderer>&);
+        const line_interpolator_aa3<Renderer>& 
+            operator = (const line_interpolator_aa3<Renderer>&);
+
+        //---------------------------------------------------------------------
+        distance_interpolator3 m_di; 
+    };
+
+
+
+
+    //==========================================================line_profile_aa
+    //
+    // See Implementation agg_line_profile_aa.cpp 
+    // 
+    class line_profile_aa
+    {
+    public:
+        //---------------------------------------------------------------------
+        typedef int8u value_type;
+        enum subpixel_scale_e
+        {
+            subpixel_shift = line_subpixel_shift,
+            subpixel_scale = 1 << subpixel_shift,
+            subpixel_mask  = subpixel_scale - 1
+        };
+
+        enum aa_scale_e
+        {
+            aa_shift = 8,
+            aa_scale = 1 << aa_shift,
+            aa_mask  = aa_scale - 1
+        };
+        
+        //---------------------------------------------------------------------
+        line_profile_aa() : 
+            m_subpixel_width(0),
+            m_min_width(1.0),
+            m_smoother_width(1.0)
+        {
+            int i;
+            for(i = 0; i < aa_scale; i++) m_gamma[i] = (value_type)i;
+        }
+
+        //---------------------------------------------------------------------
+        template<class GammaF> 
+        line_profile_aa(double w, const GammaF& gamma_function) : 
+            m_subpixel_width(0),
+            m_min_width(1.0),
+            m_smoother_width(1.0)
+        {
+            gamma(gamma_function);
+            width(w);
+        }
+
+        //---------------------------------------------------------------------
+        void min_width(double w) { m_min_width = w; }
+        void smoother_width(double w) { m_smoother_width = w; }
+
+        //---------------------------------------------------------------------
+        template<class GammaF> void gamma(const GammaF& gamma_function)
+        { 
+            int i;
+            for(i = 0; i < aa_scale; i++)
+            {
+                m_gamma[i] = value_type(
+                    uround(gamma_function(double(i) / aa_mask) * aa_mask));
+            }
+        }
+
+        void width(double w);
+
+        unsigned profile_size() const { return m_profile.size(); }
+        int subpixel_width() const { return m_subpixel_width; }
+
+        //---------------------------------------------------------------------
+        double min_width() const { return m_min_width; }
+        double smoother_width() const { return m_smoother_width; }
+
+        //---------------------------------------------------------------------
+        value_type value(int dist) const
+        {
+            return m_profile[dist + subpixel_scale*2];
+        }
+
+    private:
+        line_profile_aa(const line_profile_aa&);
+        const line_profile_aa& operator = (const line_profile_aa&);
+
+        value_type* profile(double w);
+        void set(double center_width, double smoother_width);
+
+        //---------------------------------------------------------------------
+        pod_array<value_type> m_profile;
+        value_type            m_gamma[aa_scale];
+        int                   m_subpixel_width;
+        double                m_min_width;
+        double                m_smoother_width;
+    };
+
+
+    //======================================================renderer_outline_aa
+    template<class BaseRenderer> class renderer_outline_aa
+    {
+    public:
+        //---------------------------------------------------------------------
+        typedef BaseRenderer base_ren_type;
+        typedef renderer_outline_aa<base_ren_type> self_type;
+        typedef typename base_ren_type::color_type color_type;
+
+        //---------------------------------------------------------------------
+        renderer_outline_aa(base_ren_type& ren, const line_profile_aa& prof) :
+            m_ren(&ren),
+            m_profile(&prof),
+            m_clip_box(0,0,0,0),
+            m_clipping(false)
+        {}
+        void attach(base_ren_type& ren) { m_ren = &ren; }
+
+        //---------------------------------------------------------------------
+        void color(const color_type& c) { m_color = c; }
+        const color_type& color() const { return m_color; }
+
+        //---------------------------------------------------------------------
+        void profile(const line_profile_aa& prof) { m_profile = &prof; }
+        const line_profile_aa& profile() const { return *m_profile; }
+
+        //---------------------------------------------------------------------
+        int subpixel_width() const { return m_profile->subpixel_width(); }
+
+        //---------------------------------------------------------------------
+        void reset_clipping() { m_clipping = false; }
+        void clip_box(double x1, double y1, double x2, double y2)
+        {
+            m_clip_box.x1 = line_coord_sat::conv(x1);
+            m_clip_box.y1 = line_coord_sat::conv(y1);
+            m_clip_box.x2 = line_coord_sat::conv(x2);
+            m_clip_box.y2 = line_coord_sat::conv(y2);
+            m_clipping = true;
+        }
+
+        //---------------------------------------------------------------------
+        int cover(int d) const
+        {
+            return m_profile->value(d);
+        }
+
+        //-------------------------------------------------------------------------
+        void blend_solid_hspan(int x, int y, unsigned len, const cover_type* covers)
+        {
+            m_ren->blend_solid_hspan(x, y, len, m_color, covers);
+        }
+
+        //-------------------------------------------------------------------------
+        void blend_solid_vspan(int x, int y, unsigned len, const cover_type* covers)
+        {
+            m_ren->blend_solid_vspan(x, y, len, m_color, covers);
+        }
+
+        //-------------------------------------------------------------------------
+        static bool accurate_join_only() { return false; }
+
+        //-------------------------------------------------------------------------
+        template<class Cmp>
+        void semidot_hline(Cmp cmp,
+                           int xc1, int yc1, int xc2, int yc2, 
+                           int x1,  int y1,  int x2)
+        {
+            cover_type covers[line_interpolator_aa_base<self_type>::max_half_width * 2 + 4];
+            cover_type* p0 = covers;
+            cover_type* p1 = covers;
+            int x = x1 << line_subpixel_shift;
+            int y = y1 << line_subpixel_shift;
+            int w = subpixel_width();
+            distance_interpolator0 di(xc1, yc1, xc2, yc2, x, y);
+            x += line_subpixel_scale/2;
+            y += line_subpixel_scale/2;
+
+            int x0 = x1;
+            int dx = x - xc1;
+            int dy = y - yc1;
+            do
+            {
+                int d = int(fast_sqrt(dx*dx + dy*dy));
+                *p1 = 0;
+                if(cmp(di.dist()) && d <= w)
+                {
+                    *p1 = (cover_type)cover(d);
+                }
+                ++p1;
+                dx += line_subpixel_scale;
+                di.inc_x();
+            }
+            while(++x1 <= x2);
+            m_ren->blend_solid_hspan(x0, y1, 
+                                     unsigned(p1 - p0), 
+                                     color(), 
+                                     p0);
+        }
+
+        //-------------------------------------------------------------------------
+        template<class Cmp> 
+        void semidot(Cmp cmp, int xc1, int yc1, int xc2, int yc2)
+        {
+            if(m_clipping && clipping_flags(xc1, yc1, m_clip_box)) return;
+
+            int r = ((subpixel_width() + line_subpixel_mask) >> line_subpixel_shift);
+            if(r < 1) r = 1;
+            ellipse_bresenham_interpolator ei(r, r);
+            int dx = 0;
+            int dy = -r;
+            int dy0 = dy;
+            int dx0 = dx;
+            int x = xc1 >> line_subpixel_shift;
+            int y = yc1 >> line_subpixel_shift;
+
+            do
+            {
+                dx += ei.dx();
+                dy += ei.dy();
+
+                if(dy != dy0)
+                {
+                    semidot_hline(cmp, xc1, yc1, xc2, yc2, x-dx0, y+dy0, x+dx0);
+                    semidot_hline(cmp, xc1, yc1, xc2, yc2, x-dx0, y-dy0, x+dx0);
+                }
+                dx0 = dx;
+                dy0 = dy;
+                ++ei;
+            }
+            while(dy < 0);
+            semidot_hline(cmp, xc1, yc1, xc2, yc2, x-dx0, y+dy0, x+dx0);
+        }
+
+        //-------------------------------------------------------------------------
+        void pie_hline(int xc, int yc, int xp1, int yp1, int xp2, int yp2, 
+                       int xh1, int yh1, int xh2)
+        {
+            if(m_clipping && clipping_flags(xc, yc, m_clip_box)) return;
+           
+            cover_type covers[line_interpolator_aa_base<self_type>::max_half_width * 2 + 4];
+            cover_type* p0 = covers;
+            cover_type* p1 = covers;
+            int x = xh1 << line_subpixel_shift;
+            int y = yh1 << line_subpixel_shift;
+            int w = subpixel_width();
+
+            distance_interpolator00 di(xc, yc, xp1, yp1, xp2, yp2, x, y);
+            x += line_subpixel_scale/2;
+            y += line_subpixel_scale/2;
+
+            int xh0 = xh1;
+            int dx = x - xc;
+            int dy = y - yc;
+            do
+            {
+                int d = int(fast_sqrt(dx*dx + dy*dy));
+                *p1 = 0;
+                if(di.dist1() <= 0 && di.dist2() > 0 && d <= w)
+                {
+                    *p1 = (cover_type)cover(d);
+                }
+                ++p1;
+                dx += line_subpixel_scale;
+                di.inc_x();
+            }
+            while(++xh1 <= xh2);
+            m_ren->blend_solid_hspan(xh0, yh1, 
+                                     unsigned(p1 - p0), 
+                                     color(), 
+                                     p0);
+        }
+
+
+        //-------------------------------------------------------------------------
+        void pie(int xc, int yc, int x1, int y1, int x2, int y2)
+        {
+            int r = ((subpixel_width() + line_subpixel_mask) >> line_subpixel_shift);
+            if(r < 1) r = 1;
+            ellipse_bresenham_interpolator ei(r, r);
+            int dx = 0;
+            int dy = -r;
+            int dy0 = dy;
+            int dx0 = dx;
+            int x = xc >> line_subpixel_shift;
+            int y = yc >> line_subpixel_shift;
+
+            do
+            {
+                dx += ei.dx();
+                dy += ei.dy();
+
+                if(dy != dy0)
+                {
+                    pie_hline(xc, yc, x1, y1, x2, y2, x-dx0, y+dy0, x+dx0);
+                    pie_hline(xc, yc, x1, y1, x2, y2, x-dx0, y-dy0, x+dx0);
+                }
+                dx0 = dx;
+                dy0 = dy;
+                ++ei;
+            }
+            while(dy < 0);
+            pie_hline(xc, yc, x1, y1, x2, y2, x-dx0, y+dy0, x+dx0);
+        }
+
+        //-------------------------------------------------------------------------
+        void line0_no_clip(const line_parameters& lp)
+        {
+            if(lp.len > line_max_length)
+            {
+                line_parameters lp1, lp2;
+                lp.divide(lp1, lp2);
+                line0_no_clip(lp1);
+                line0_no_clip(lp2);
+                return;
+            }
+
+            line_interpolator_aa0<self_type> li(*this, lp);
+            if(li.count())
+            {
+                if(li.vertical())
+                {
+                    while(li.step_ver());
+                }
+                else
+                {
+                    while(li.step_hor());
+                }
+            }
+        }
+
+        //-------------------------------------------------------------------------
+        void line0(const line_parameters& lp)
+        {
+            if(m_clipping)
+            {
+                int x1 = lp.x1;
+                int y1 = lp.y1;
+                int x2 = lp.x2;
+                int y2 = lp.y2;
+                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
+                if((flags & 4) == 0)
+                {
+                    if(flags)
+                    {
+                        line_parameters lp2(x1, y1, x2, y2, 
+                                           uround(calc_distance(x1, y1, x2, y2)));
+                        line0_no_clip(lp2);
+                    }
+                    else
+                    {
+                        line0_no_clip(lp);
+                    }
+                }
+            }
+            else
+            {
+                line0_no_clip(lp);
+            }
+        }
+
+        //-------------------------------------------------------------------------
+        void line1_no_clip(const line_parameters& lp, int sx, int sy)
+        {
+            if(lp.len > line_max_length)
+            {
+                line_parameters lp1, lp2;
+                lp.divide(lp1, lp2);
+                line1_no_clip(lp1, (lp.x1 + sx) >> 1, (lp.y1 + sy) >> 1);
+                line1_no_clip(lp2, lp1.x2 + (lp1.y2 - lp1.y1), lp1.y2 - (lp1.x2 - lp1.x1));
+                return;
+            }
+
+            fix_degenerate_bisectrix_start(lp, &sx, &sy);
+            line_interpolator_aa1<self_type> li(*this, lp, sx, sy);
+            if(li.vertical())
+            {
+                while(li.step_ver());
+            }
+            else
+            {
+                while(li.step_hor());
+            }
+        }
+
+
+        //-------------------------------------------------------------------------
+        void line1(const line_parameters& lp, int sx, int sy)
+        {
+            if(m_clipping)
+            {
+                int x1 = lp.x1;
+                int y1 = lp.y1;
+                int x2 = lp.x2;
+                int y2 = lp.y2;
+                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
+                if((flags & 4) == 0)
+                {
+                    if(flags)
+                    {
+                        line_parameters lp2(x1, y1, x2, y2, 
+                                           uround(calc_distance(x1, y1, x2, y2)));
+                        if(flags & 1)
+                        {
+                            sx = x1 + (y2 - y1); 
+                            sy = y1 - (x2 - x1);
+                        }
+                        else
+                        {
+                            while(abs(sx - lp.x1) + abs(sy - lp.y1) > lp2.len)
+                            {
+                                sx = (lp.x1 + sx) >> 1;
+                                sy = (lp.y1 + sy) >> 1;
+                            }
+                        }
+                        line1_no_clip(lp2, sx, sy);
+                    }
+                    else
+                    {
+                        line1_no_clip(lp, sx, sy);
+                    }
+                }
+            }
+            else
+            {
+                line1_no_clip(lp, sx, sy);
+            }
+        }
+
+        //-------------------------------------------------------------------------
+        void line2_no_clip(const line_parameters& lp, int ex, int ey)
+        {
+            if(lp.len > line_max_length)
+            {
+                line_parameters lp1, lp2;
+                lp.divide(lp1, lp2);
+                line2_no_clip(lp1, lp1.x2 + (lp1.y2 - lp1.y1), lp1.y2 - (lp1.x2 - lp1.x1));
+                line2_no_clip(lp2, (lp.x2 + ex) >> 1, (lp.y2 + ey) >> 1);
+                return;
+            }
+
+            fix_degenerate_bisectrix_end(lp, &ex, &ey);
+            line_interpolator_aa2<self_type> li(*this, lp, ex, ey);
+            if(li.vertical())
+            {
+                while(li.step_ver());
+            }
+            else
+            {
+                while(li.step_hor());
+            }
+        }
+
+        //-------------------------------------------------------------------------
+        void line2(const line_parameters& lp, int ex, int ey)
+        {
+            if(m_clipping)
+            {
+                int x1 = lp.x1;
+                int y1 = lp.y1;
+                int x2 = lp.x2;
+                int y2 = lp.y2;
+                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
+                if((flags & 4) == 0)
+                {
+                    if(flags)
+                    {
+                        line_parameters lp2(x1, y1, x2, y2, 
+                                           uround(calc_distance(x1, y1, x2, y2)));
+                        if(flags & 2)
+                        {
+                            ex = x2 + (y2 - y1); 
+                            ey = y2 - (x2 - x1);
+                        }
+                        else
+                        {
+                            while(abs(ex - lp.x2) + abs(ey - lp.y2) > lp2.len)
+                            {
+                                ex = (lp.x2 + ex) >> 1;
+                                ey = (lp.y2 + ey) >> 1;
+                            }
+                        }
+                        line2_no_clip(lp2, ex, ey);
+                    }
+                    else
+                    {
+                        line2_no_clip(lp, ex, ey);
+                    }
+                }
+            }
+            else
+            {
+                line2_no_clip(lp, ex, ey);
+            }
+        }
+
+        //-------------------------------------------------------------------------
+        void line3_no_clip(const line_parameters& lp, 
+                           int sx, int sy, int ex, int ey)
+        {
+            if(lp.len > line_max_length)
+            {
+                line_parameters lp1, lp2;
+                lp.divide(lp1, lp2);
+                int mx = lp1.x2 + (lp1.y2 - lp1.y1);
+                int my = lp1.y2 - (lp1.x2 - lp1.x1);
+                line3_no_clip(lp1, (lp.x1 + sx) >> 1, (lp.y1 + sy) >> 1, mx, my);
+                line3_no_clip(lp2, mx, my, (lp.x2 + ex) >> 1, (lp.y2 + ey) >> 1);
+                return;
+            }
+
+            fix_degenerate_bisectrix_start(lp, &sx, &sy);
+            fix_degenerate_bisectrix_end(lp, &ex, &ey);
+            line_interpolator_aa3<self_type> li(*this, lp, sx, sy, ex, ey);
+            if(li.vertical())
+            {
+                while(li.step_ver());
+            }
+            else
+            {
+                while(li.step_hor());
+            }
+        }
+
+        //-------------------------------------------------------------------------
+        void line3(const line_parameters& lp, 
+                   int sx, int sy, int ex, int ey)
+        {
+            if(m_clipping)
+            {
+                int x1 = lp.x1;
+                int y1 = lp.y1;
+                int x2 = lp.x2;
+                int y2 = lp.y2;
+                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
+                if((flags & 4) == 0)
+                {
+                    if(flags)
+                    {
+                        line_parameters lp2(x1, y1, x2, y2, 
+                                           uround(calc_distance(x1, y1, x2, y2)));
+                        if(flags & 1)
+                        {
+                            sx = x1 + (y2 - y1); 
+                            sy = y1 - (x2 - x1);
+                        }
+                        else
+                        {
+                            while(abs(sx - lp.x1) + abs(sy - lp.y1) > lp2.len)
+                            {
+                                sx = (lp.x1 + sx) >> 1;
+                                sy = (lp.y1 + sy) >> 1;
+                            }
+                        }
+                        if(flags & 2)
+                        {
+                            ex = x2 + (y2 - y1); 
+                            ey = y2 - (x2 - x1);
+                        }
+                        else
+                        {
+                            while(abs(ex - lp.x2) + abs(ey - lp.y2) > lp2.len)
+                            {
+                                ex = (lp.x2 + ex) >> 1;
+                                ey = (lp.y2 + ey) >> 1;
+                            }
+                        }
+                        line3_no_clip(lp2, sx, sy, ex, ey);
+                    }
+                    else
+                    {
+                        line3_no_clip(lp, sx, sy, ex, ey);
+                    }
+                }
+            }
+            else
+            {
+                line3_no_clip(lp, sx, sy, ex, ey);
+            }
+        }
+
+
+    private:
+        base_ren_type*         m_ren;
+        const line_profile_aa* m_profile; 
+        color_type             m_color;
+        rect_i                 m_clip_box;
+        bool                   m_clipping;
+    };
+
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_outline_image.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_outline_image.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_outline_image.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_outline_image.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1013 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_RENDERER_OUTLINE_IMAGE_INCLUDED
+#define AGG_RENDERER_OUTLINE_IMAGE_INCLUDED
+
+#include "agg_array.h"
+#include "agg_math.h"
+#include "agg_line_aa_basics.h"
+#include "agg_dda_line.h"
+#include "agg_rendering_buffer.h"
+#include "agg_clip_liang_barsky.h"
+
+
+namespace mapserver
+{
+    //========================================================line_image_scale
+    template<class Source> class line_image_scale
+    {
+    public:
+        typedef typename Source::color_type color_type;
+
+        line_image_scale(const Source& src, double height) :
+            m_source(src), 
+            m_height(height),
+            m_scale(src.height() / height)
+        {
+        }
+
+        double width()  const { return m_source.width(); }
+        double height() const { return m_height; }
+
+        color_type pixel(int x, int y) const 
+        { 
+            double src_y = (y + 0.5) * m_scale - 0.5;
+            int h  = m_source.height() - 1;
+            int y1 = ufloor(src_y);
+            int y2 = y1 + 1;
+            color_type pix1 = (y1 < 0) ? color_type::no_color() : m_source.pixel(x, y1);
+            color_type pix2 = (y2 > h) ? color_type::no_color() : m_source.pixel(x, y2);
+            return pix1.gradient(pix2, src_y - y1);
+        }
+
+    private:
+        line_image_scale(const line_image_scale<Source>&);
+        const line_image_scale<Source>& operator = (const line_image_scale<Source>&);
+
+        const Source& m_source;
+        double        m_height;
+        double        m_scale;
+    };
+
+
+
+    //======================================================line_image_pattern
+    template<class Filter> class line_image_pattern
+    {
+    public:
+        typedef Filter filter_type;
+        typedef typename filter_type::color_type color_type;
+
+        //--------------------------------------------------------------------
+        line_image_pattern(const Filter& filter) :
+            m_filter(&filter),
+            m_dilation(filter.dilation() + 1),
+            m_dilation_hr(m_dilation << line_subpixel_shift),
+            m_data(),
+            m_width(0),
+            m_height(0),
+            m_width_hr(0),
+            m_half_height_hr(0),
+            m_offset_y_hr(0)
+        {
+        }
+
+        // Create
+        //--------------------------------------------------------------------
+        template<class Source> 
+        line_image_pattern(const Filter& filter, const Source& src) :
+            m_filter(&filter),
+            m_dilation(filter.dilation() + 1),
+            m_dilation_hr(m_dilation << line_subpixel_shift),
+            m_data(),
+            m_width(0),
+            m_height(0),
+            m_width_hr(0),
+            m_half_height_hr(0),
+            m_offset_y_hr(0)
+        {
+            create(src);
+        }
+
+        // Create
+        //--------------------------------------------------------------------
+        template<class Source> void create(const Source& src)
+        {
+            m_height = uceil(src.height());
+            m_width  = uceil(src.width());
+            m_width_hr = uround(src.width() * line_subpixel_scale);
+            m_half_height_hr = uround(src.height() * line_subpixel_scale/2);
+            m_offset_y_hr = m_dilation_hr + m_half_height_hr - line_subpixel_scale/2;
+            m_half_height_hr += line_subpixel_scale/2;
+
+            m_data.resize((m_width + m_dilation * 2) * (m_height + m_dilation * 2));
+
+            m_buf.attach(&m_data[0], m_width  + m_dilation * 2, 
+                                     m_height + m_dilation * 2, 
+                                     m_width  + m_dilation * 2);
+            unsigned x, y;
+            color_type* d1;
+            color_type* d2;
+            for(y = 0; y < m_height; y++)
+            {
+                d1 = m_buf.row_ptr(y + m_dilation) + m_dilation;
+                for(x = 0; x < m_width; x++)
+                {
+                    *d1++ = src.pixel(x, y);
+                }
+            }
+
+            const color_type* s1;
+            const color_type* s2;
+            for(y = 0; y < m_dilation; y++)
+            {
+                //s1 = m_buf.row_ptr(m_height + m_dilation - 1) + m_dilation;
+                //s2 = m_buf.row_ptr(m_dilation) + m_dilation;
+                d1 = m_buf.row_ptr(m_dilation + m_height + y) + m_dilation;
+                d2 = m_buf.row_ptr(m_dilation - y - 1) + m_dilation;
+                for(x = 0; x < m_width; x++)
+                {
+                    //*d1++ = color_type(*s1++, 0);
+                    //*d2++ = color_type(*s2++, 0);
+                    *d1++ = color_type::no_color();
+                    *d2++ = color_type::no_color();
+                }
+            }
+
+            unsigned h = m_height + m_dilation * 2;
+            for(y = 0; y < h; y++)
+            {
+                s1 = m_buf.row_ptr(y) + m_dilation;
+                s2 = m_buf.row_ptr(y) + m_dilation + m_width;
+                d1 = m_buf.row_ptr(y) + m_dilation + m_width;
+                d2 = m_buf.row_ptr(y) + m_dilation;
+
+                for(x = 0; x < m_dilation; x++)
+                {
+                    *d1++ = *s1++;
+                    *--d2 = *--s2;
+                }
+            }
+        }
+
+        //--------------------------------------------------------------------
+        int pattern_width() const { return m_width_hr; }
+        int line_width()    const { return m_half_height_hr; }
+        double width()      const { return m_height; }
+
+        //--------------------------------------------------------------------
+        void pixel(color_type* p, int x, int y) const
+        {
+            m_filter->pixel_high_res(m_buf.rows(), 
+                                     p, 
+                                     x % m_width_hr + m_dilation_hr,
+                                     y + m_offset_y_hr);
+        }
+
+        //--------------------------------------------------------------------
+        const filter_type& filter() const { return *m_filter; }
+
+    private:
+        line_image_pattern(const line_image_pattern<filter_type>&);
+        const line_image_pattern<filter_type>& 
+            operator = (const line_image_pattern<filter_type>&);
+
+    protected:
+        row_ptr_cache<color_type> m_buf;
+        const filter_type*        m_filter;
+        unsigned                  m_dilation;
+        int                       m_dilation_hr;
+        pod_array<color_type>     m_data;
+        unsigned                  m_width;
+        unsigned                  m_height;
+        int                       m_width_hr;
+        int                       m_half_height_hr;
+        int                       m_offset_y_hr;
+    };
+
+
+
+
+
+
+    //=================================================line_image_pattern_pow2
+    template<class Filter> class line_image_pattern_pow2 : 
+    public line_image_pattern<Filter>
+    {
+    public:
+        typedef Filter filter_type;
+        typedef typename filter_type::color_type color_type;
+        typedef line_image_pattern<Filter> base_type;
+	
+        //--------------------------------------------------------------------
+        line_image_pattern_pow2(const Filter& filter) :
+            line_image_pattern<Filter>(filter), m_mask(line_subpixel_mask) {}
+
+        //--------------------------------------------------------------------
+        template<class Source> 
+        line_image_pattern_pow2(const Filter& filter, const Source& src) :
+            line_image_pattern<Filter>(filter), m_mask(line_subpixel_mask)
+        {
+            create(src);
+        }
+            
+        //--------------------------------------------------------------------
+        template<class Source> void create(const Source& src)
+        {
+            line_image_pattern<Filter>::create(src);
+            m_mask = 1;
+            while(m_mask < base_type::m_width) 
+            {
+                m_mask <<= 1;
+                m_mask |= 1;
+            }
+            m_mask <<= line_subpixel_shift - 1;
+            m_mask |=  line_subpixel_mask;
+            base_type::m_width_hr = m_mask + 1;
+        }
+
+        //--------------------------------------------------------------------
+        void pixel(color_type* p, int x, int y) const
+        {
+            base_type::m_filter->pixel_high_res(
+                    base_type::m_buf.rows(), 
+                    p,
+                    (x & m_mask) + base_type::m_dilation_hr,
+                    y + base_type::m_offset_y_hr);
+        }
+    private:
+        unsigned m_mask;
+    };
+    
+    
+    
+    
+    
+    
+    
+    //===================================================distance_interpolator4
+    class distance_interpolator4
+    {
+    public:
+        //---------------------------------------------------------------------
+        distance_interpolator4() {}
+        distance_interpolator4(int x1,  int y1, int x2, int y2,
+                               int sx,  int sy, int ex, int ey, 
+                               int len, double scale, int x, int y) :
+            m_dx(x2 - x1),
+            m_dy(y2 - y1),
+            m_dx_start(line_mr(sx) - line_mr(x1)),
+            m_dy_start(line_mr(sy) - line_mr(y1)),
+            m_dx_end(line_mr(ex) - line_mr(x2)),
+            m_dy_end(line_mr(ey) - line_mr(y2)),
+
+            m_dist(iround(double(x + line_subpixel_scale/2 - x2) * double(m_dy) - 
+                          double(y + line_subpixel_scale/2 - y2) * double(m_dx))),
+
+            m_dist_start((line_mr(x + line_subpixel_scale/2) - line_mr(sx)) * m_dy_start - 
+                         (line_mr(y + line_subpixel_scale/2) - line_mr(sy)) * m_dx_start),
+
+            m_dist_end((line_mr(x + line_subpixel_scale/2) - line_mr(ex)) * m_dy_end - 
+                       (line_mr(y + line_subpixel_scale/2) - line_mr(ey)) * m_dx_end),
+            m_len(uround(len / scale))
+        {
+            double d = len * scale;
+            int dx = iround(((x2 - x1) << line_subpixel_shift) / d);
+            int dy = iround(((y2 - y1) << line_subpixel_shift) / d);
+            m_dx_pict   = -dy;
+            m_dy_pict   =  dx;
+            m_dist_pict =  ((x + line_subpixel_scale/2 - (x1 - dy)) * m_dy_pict - 
+                            (y + line_subpixel_scale/2 - (y1 + dx)) * m_dx_pict) >> 
+                           line_subpixel_shift;
+
+            m_dx       <<= line_subpixel_shift;
+            m_dy       <<= line_subpixel_shift;
+            m_dx_start <<= line_mr_subpixel_shift;
+            m_dy_start <<= line_mr_subpixel_shift;
+            m_dx_end   <<= line_mr_subpixel_shift;
+            m_dy_end   <<= line_mr_subpixel_shift;
+        }
+
+        //---------------------------------------------------------------------
+        void inc_x() 
+        { 
+            m_dist += m_dy; 
+            m_dist_start += m_dy_start; 
+            m_dist_pict += m_dy_pict; 
+            m_dist_end += m_dy_end; 
+        }
+
+        //---------------------------------------------------------------------
+        void dec_x() 
+        { 
+            m_dist -= m_dy; 
+            m_dist_start -= m_dy_start; 
+            m_dist_pict -= m_dy_pict; 
+            m_dist_end -= m_dy_end; 
+        }
+
+        //---------------------------------------------------------------------
+        void inc_y() 
+        { 
+            m_dist -= m_dx; 
+            m_dist_start -= m_dx_start; 
+            m_dist_pict -= m_dx_pict; 
+            m_dist_end -= m_dx_end; 
+        }
+
+        //---------------------------------------------------------------------
+        void dec_y() 
+        { 
+            m_dist += m_dx; 
+            m_dist_start += m_dx_start; 
+            m_dist_pict += m_dx_pict; 
+            m_dist_end += m_dx_end; 
+        }
+
+        //---------------------------------------------------------------------
+        void inc_x(int dy)
+        {
+            m_dist       += m_dy; 
+            m_dist_start += m_dy_start; 
+            m_dist_pict  += m_dy_pict; 
+            m_dist_end   += m_dy_end;
+            if(dy > 0)
+            {
+                m_dist       -= m_dx; 
+                m_dist_start -= m_dx_start; 
+                m_dist_pict  -= m_dx_pict; 
+                m_dist_end   -= m_dx_end;
+            }
+            if(dy < 0)
+            {
+                m_dist       += m_dx; 
+                m_dist_start += m_dx_start; 
+                m_dist_pict  += m_dx_pict; 
+                m_dist_end   += m_dx_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void dec_x(int dy)
+        {
+            m_dist       -= m_dy; 
+            m_dist_start -= m_dy_start; 
+            m_dist_pict  -= m_dy_pict; 
+            m_dist_end   -= m_dy_end;
+            if(dy > 0)
+            {
+                m_dist       -= m_dx; 
+                m_dist_start -= m_dx_start; 
+                m_dist_pict  -= m_dx_pict; 
+                m_dist_end   -= m_dx_end;
+            }
+            if(dy < 0)
+            {
+                m_dist       += m_dx; 
+                m_dist_start += m_dx_start; 
+                m_dist_pict  += m_dx_pict; 
+                m_dist_end   += m_dx_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void inc_y(int dx)
+        {
+            m_dist       -= m_dx; 
+            m_dist_start -= m_dx_start; 
+            m_dist_pict  -= m_dx_pict; 
+            m_dist_end   -= m_dx_end;
+            if(dx > 0)
+            {
+                m_dist       += m_dy; 
+                m_dist_start += m_dy_start; 
+                m_dist_pict  += m_dy_pict; 
+                m_dist_end   += m_dy_end;
+            }
+            if(dx < 0)
+            {
+                m_dist       -= m_dy; 
+                m_dist_start -= m_dy_start; 
+                m_dist_pict  -= m_dy_pict; 
+                m_dist_end   -= m_dy_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        void dec_y(int dx)
+        {
+            m_dist       += m_dx; 
+            m_dist_start += m_dx_start; 
+            m_dist_pict  += m_dx_pict; 
+            m_dist_end   += m_dx_end;
+            if(dx > 0)
+            {
+                m_dist       += m_dy; 
+                m_dist_start += m_dy_start; 
+                m_dist_pict  += m_dy_pict; 
+                m_dist_end   += m_dy_end;
+            }
+            if(dx < 0)
+            {
+                m_dist       -= m_dy; 
+                m_dist_start -= m_dy_start; 
+                m_dist_pict  -= m_dy_pict; 
+                m_dist_end   -= m_dy_end;
+            }
+        }
+
+        //---------------------------------------------------------------------
+        int dist()       const { return m_dist;       }
+        int dist_start() const { return m_dist_start; }
+        int dist_pict()  const { return m_dist_pict;  }
+        int dist_end()   const { return m_dist_end;   }
+
+        //---------------------------------------------------------------------
+        int dx()       const { return m_dx;       }
+        int dy()       const { return m_dy;       }
+        int dx_start() const { return m_dx_start; }
+        int dy_start() const { return m_dy_start; }
+        int dx_pict()  const { return m_dx_pict;  }
+        int dy_pict()  const { return m_dy_pict;  }
+        int dx_end()   const { return m_dx_end;   }
+        int dy_end()   const { return m_dy_end;   }
+        int len()      const { return m_len;      }
+
+    private:
+        //---------------------------------------------------------------------
+        int m_dx;
+        int m_dy;
+        int m_dx_start;
+        int m_dy_start;
+        int m_dx_pict;
+        int m_dy_pict;
+        int m_dx_end;
+        int m_dy_end;
+
+        int m_dist;
+        int m_dist_start;
+        int m_dist_pict;
+        int m_dist_end;
+        int m_len;
+    };
+
+
+
+
+
+    //==================================================line_interpolator_image
+    template<class Renderer> class line_interpolator_image
+    {
+    public:
+        typedef Renderer renderer_type;
+        typedef typename Renderer::color_type color_type;
+
+        //---------------------------------------------------------------------
+        enum max_half_width_e
+        { 
+            max_half_width = 64
+        };
+
+        //---------------------------------------------------------------------
+        line_interpolator_image(renderer_type& ren, const line_parameters& lp,
+                                int sx, int sy, int ex, int ey, 
+                                int pattern_start,
+                                double scale_x) :
+            m_lp(lp),
+            m_li(lp.vertical ? line_dbl_hr(lp.x2 - lp.x1) :
+                               line_dbl_hr(lp.y2 - lp.y1),
+                 lp.vertical ? abs(lp.y2 - lp.y1) : 
+                               abs(lp.x2 - lp.x1) + 1),
+            m_di(lp.x1, lp.y1, lp.x2, lp.y2, sx, sy, ex, ey, lp.len, scale_x,
+                 lp.x1 & ~line_subpixel_mask, lp.y1 & ~line_subpixel_mask),
+            m_ren(ren),
+            m_x(lp.x1 >> line_subpixel_shift),
+            m_y(lp.y1 >> line_subpixel_shift),
+            m_old_x(m_x),
+            m_old_y(m_y),
+            m_count((lp.vertical ? abs((lp.y2 >> line_subpixel_shift) - m_y) :
+                                   abs((lp.x2 >> line_subpixel_shift) - m_x))),
+            m_width(ren.subpixel_width()),
+            //m_max_extent(m_width >> (line_subpixel_shift - 2)),
+            m_max_extent((m_width + line_subpixel_scale) >> line_subpixel_shift),
+            m_start(pattern_start + (m_max_extent + 2) * ren.pattern_width()),
+            m_step(0)
+        {
+            mapserver::dda2_line_interpolator li(0, lp.vertical ? 
+                                              (lp.dy << mapserver::line_subpixel_shift) :
+                                              (lp.dx << mapserver::line_subpixel_shift),
+                                           lp.len);
+
+            unsigned i;
+            int stop = m_width + line_subpixel_scale * 2;
+            for(i = 0; i < max_half_width; ++i)
+            {
+                m_dist_pos[i] = li.y();
+                if(m_dist_pos[i] >= stop) break;
+                ++li;
+            }
+            m_dist_pos[i] = 0x7FFF0000;
+
+            int dist1_start;
+            int dist2_start;
+            int npix = 1;
+
+            if(lp.vertical)
+            {
+                do
+                {
+                    --m_li;
+                    m_y -= lp.inc;
+                    m_x = (m_lp.x1 + m_li.y()) >> line_subpixel_shift;
+
+                    if(lp.inc > 0) m_di.dec_y(m_x - m_old_x);
+                    else           m_di.inc_y(m_x - m_old_x);
+
+                    m_old_x = m_x;
+
+                    dist1_start = dist2_start = m_di.dist_start(); 
+
+                    int dx = 0;
+                    if(dist1_start < 0) ++npix;
+                    do
+                    {
+                        dist1_start += m_di.dy_start();
+                        dist2_start -= m_di.dy_start();
+                        if(dist1_start < 0) ++npix;
+                        if(dist2_start < 0) ++npix;
+                        ++dx;
+                    }
+                    while(m_dist_pos[dx] <= m_width);
+                    if(npix == 0) break;
+
+                    npix = 0;
+                }
+                while(--m_step >= -m_max_extent);
+            }
+            else
+            {
+                do
+                {
+                    --m_li;
+
+                    m_x -= lp.inc;
+                    m_y = (m_lp.y1 + m_li.y()) >> line_subpixel_shift;
+
+                    if(lp.inc > 0) m_di.dec_x(m_y - m_old_y);
+                    else           m_di.inc_x(m_y - m_old_y);
+
+                    m_old_y = m_y;
+
+                    dist1_start = dist2_start = m_di.dist_start(); 
+
+                    int dy = 0;
+                    if(dist1_start < 0) ++npix;
+                    do
+                    {
+                        dist1_start -= m_di.dx_start();
+                        dist2_start += m_di.dx_start();
+                        if(dist1_start < 0) ++npix;
+                        if(dist2_start < 0) ++npix;
+                        ++dy;
+                    }
+                    while(m_dist_pos[dy] <= m_width);
+                    if(npix == 0) break;
+
+                    npix = 0;
+                }
+                while(--m_step >= -m_max_extent);
+            }
+            m_li.adjust_forward();
+            m_step -= m_max_extent;
+        }
+
+        //---------------------------------------------------------------------
+        bool step_hor()
+        {
+            ++m_li;
+            m_x += m_lp.inc;
+            m_y = (m_lp.y1 + m_li.y()) >> line_subpixel_shift;
+
+            if(m_lp.inc > 0) m_di.inc_x(m_y - m_old_y);
+            else             m_di.dec_x(m_y - m_old_y);
+
+            m_old_y = m_y;
+
+            int s1 = m_di.dist() / m_lp.len;
+            int s2 = -s1;
+
+            if(m_lp.inc < 0) s1 = -s1;
+
+            int dist_start;
+            int dist_pict;
+            int dist_end;
+            int dy;
+            int dist;
+
+            dist_start = m_di.dist_start();
+            dist_pict  = m_di.dist_pict() + m_start;
+            dist_end   = m_di.dist_end();
+            color_type* p0 = m_colors + max_half_width + 2;
+            color_type* p1 = p0;
+
+            int npix = 0;
+            p1->clear();
+            if(dist_end > 0)
+            {
+                if(dist_start <= 0)
+                {
+                    m_ren.pixel(p1, dist_pict, s2);
+                }
+                ++npix;
+            }
+            ++p1;
+
+            dy = 1;
+            while((dist = m_dist_pos[dy]) - s1 <= m_width)
+            {
+                dist_start -= m_di.dx_start();
+                dist_pict  -= m_di.dx_pict();
+                dist_end   -= m_di.dx_end();
+                p1->clear();
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    if(m_lp.inc > 0) dist = -dist;
+                    m_ren.pixel(p1, dist_pict, s2 - dist);
+                    ++npix;
+                }
+                ++p1;
+                ++dy;
+            }
+
+            dy = 1;
+            dist_start = m_di.dist_start();
+            dist_pict  = m_di.dist_pict() + m_start;
+            dist_end   = m_di.dist_end();
+            while((dist = m_dist_pos[dy]) + s1 <= m_width)
+            {
+                dist_start += m_di.dx_start();
+                dist_pict  += m_di.dx_pict();
+                dist_end   += m_di.dx_end();
+                --p0;
+                p0->clear();
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    if(m_lp.inc > 0) dist = -dist;
+                    m_ren.pixel(p0, dist_pict, s2 + dist);
+                    ++npix;
+                }
+                ++dy;
+            }
+            m_ren.blend_color_vspan(m_x, 
+                                    m_y - dy + 1, 
+                                    unsigned(p1 - p0), 
+                                    p0); 
+            return npix && ++m_step < m_count;
+        }
+
+
+
+        //---------------------------------------------------------------------
+        bool step_ver()
+        {
+            ++m_li;
+            m_y += m_lp.inc;
+            m_x = (m_lp.x1 + m_li.y()) >> line_subpixel_shift;
+
+            if(m_lp.inc > 0) m_di.inc_y(m_x - m_old_x);
+            else             m_di.dec_y(m_x - m_old_x);
+
+            m_old_x = m_x;
+
+            int s1 = m_di.dist() / m_lp.len;
+            int s2 = -s1;
+
+            if(m_lp.inc > 0) s1 = -s1;
+
+            int dist_start;
+            int dist_pict;
+            int dist_end;
+            int dist;
+            int dx;
+
+            dist_start = m_di.dist_start();
+            dist_pict  = m_di.dist_pict() + m_start;
+            dist_end   = m_di.dist_end();
+            color_type* p0 = m_colors + max_half_width + 2;
+            color_type* p1 = p0;
+
+            int npix = 0;
+            p1->clear();
+            if(dist_end > 0)
+            {
+                if(dist_start <= 0)
+                {
+                    m_ren.pixel(p1, dist_pict, s2);
+                }
+                ++npix;
+            }
+            ++p1;
+
+            dx = 1;
+            while((dist = m_dist_pos[dx]) - s1 <= m_width)
+            {
+                dist_start += m_di.dy_start();
+                dist_pict  += m_di.dy_pict();
+                dist_end   += m_di.dy_end();
+                p1->clear();
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    if(m_lp.inc > 0) dist = -dist;
+                    m_ren.pixel(p1, dist_pict, s2 + dist);
+                    ++npix;
+                }
+                ++p1;
+                ++dx;
+            }
+
+            dx = 1;
+            dist_start = m_di.dist_start();
+            dist_pict  = m_di.dist_pict() + m_start;
+            dist_end   = m_di.dist_end();
+            while((dist = m_dist_pos[dx]) + s1 <= m_width)
+            {
+                dist_start -= m_di.dy_start();
+                dist_pict  -= m_di.dy_pict();
+                dist_end   -= m_di.dy_end();
+                --p0;
+                p0->clear();
+                if(dist_end > 0 && dist_start <= 0)
+                {   
+                    if(m_lp.inc > 0) dist = -dist;
+                    m_ren.pixel(p0, dist_pict, s2 - dist);
+                    ++npix;
+                }
+                ++dx;
+            }
+            m_ren.blend_color_hspan(m_x - dx + 1, 
+                                    m_y, 
+                                    unsigned(p1 - p0), 
+                                    p0);
+            return npix && ++m_step < m_count;
+        }
+
+
+        //---------------------------------------------------------------------
+        int  pattern_end() const { return m_start + m_di.len(); }
+
+        //---------------------------------------------------------------------
+        bool vertical() const { return m_lp.vertical; }
+        int  width() const { return m_width; }
+        int  count() const { return m_count; }
+
+    private:
+        line_interpolator_image(const line_interpolator_image<Renderer>&);
+        const line_interpolator_image<Renderer>&
+            operator = (const line_interpolator_image<Renderer>&);
+
+    protected:
+        const line_parameters& m_lp;
+        dda2_line_interpolator m_li;
+        distance_interpolator4 m_di; 
+        renderer_type&         m_ren;
+        int m_plen = 0;
+        int m_x;
+        int m_y;
+        int m_old_x;
+        int m_old_y;
+        int m_count;
+        int m_width;
+        int m_max_extent;
+        int m_start;
+        int m_step;
+        int m_dist_pos[max_half_width + 1];
+        color_type m_colors[max_half_width * 2 + 4];
+    };
+
+
+
+
+
+
+
+
+    //===================================================renderer_outline_image
+    template<class BaseRenderer, class ImagePattern> 
+    class renderer_outline_image
+    {
+    public:
+        //---------------------------------------------------------------------
+        typedef BaseRenderer base_ren_type;
+        typedef renderer_outline_image<BaseRenderer, ImagePattern> self_type;
+        typedef typename base_ren_type::color_type color_type;
+        typedef ImagePattern pattern_type;
+
+
+        //---------------------------------------------------------------------
+        renderer_outline_image(base_ren_type& ren, const pattern_type& patt) :
+            m_ren(&ren),
+            m_pattern(&patt),
+            m_start(0),
+            m_scale_x(1.0),
+            m_clip_box(0,0,0,0),
+            m_clipping(false)
+        {}
+        void attach(base_ren_type& ren) { m_ren = &ren; }
+
+        //---------------------------------------------------------------------
+        void pattern(const pattern_type& p) { m_pattern = &p; }
+        const pattern_type& pattern() const { return *m_pattern; }
+
+        //---------------------------------------------------------------------
+        void reset_clipping() { m_clipping = false; }
+        void clip_box(double x1, double y1, double x2, double y2)
+        {
+            m_clip_box.x1 = line_coord_sat::conv(x1);
+            m_clip_box.y1 = line_coord_sat::conv(y1);
+            m_clip_box.x2 = line_coord_sat::conv(x2);
+            m_clip_box.y2 = line_coord_sat::conv(y2);
+            m_clipping = true;
+        }
+
+        //---------------------------------------------------------------------
+        void   scale_x(double s) { m_scale_x = s; }
+        double scale_x() const   { return m_scale_x; }
+
+        //---------------------------------------------------------------------
+        void   start_x(double s) { m_start = iround(s * line_subpixel_scale); }
+        double start_x() const   { return double(m_start) / line_subpixel_scale; }
+
+        //---------------------------------------------------------------------
+        int subpixel_width() const { return m_pattern->line_width(); }
+        int pattern_width() const { return m_pattern->pattern_width(); }
+        double width() const { return double(subpixel_width()) / line_subpixel_scale; }
+
+        //-------------------------------------------------------------------------
+        void pixel(color_type* p, int x, int y) const
+        {
+            m_pattern->pixel(p, x, y);
+        }
+
+        //-------------------------------------------------------------------------
+        void blend_color_hspan(int x, int y, unsigned len, const color_type* colors)
+        {
+            m_ren->blend_color_hspan(x, y, len, colors, 0);
+        }
+
+        //-------------------------------------------------------------------------
+        void blend_color_vspan(int x, int y, unsigned len, const color_type* colors)
+        {
+            m_ren->blend_color_vspan(x, y, len, colors, 0);
+        }
+
+        //-------------------------------------------------------------------------
+        static bool accurate_join_only() { return true; }
+
+        //-------------------------------------------------------------------------
+        template<class Cmp> 
+        void semidot(Cmp, int, int, int, int)
+        {
+        }
+
+        //-------------------------------------------------------------------------
+        void pie(int, int, int, int, int, int)
+        {
+        }
+
+        //-------------------------------------------------------------------------
+        void line0(const line_parameters&)
+        {
+        }
+
+        //-------------------------------------------------------------------------
+        void line1(const line_parameters&, int, int)
+        {
+        }
+
+        //-------------------------------------------------------------------------
+        void line2(const line_parameters&, int, int)
+        {
+        }
+
+        //-------------------------------------------------------------------------
+        void line3_no_clip(const line_parameters& lp, 
+                           int sx, int sy, int ex, int ey)
+        {
+            if(lp.len > line_max_length)
+            {
+                line_parameters lp1, lp2;
+                lp.divide(lp1, lp2);
+                int mx = lp1.x2 + (lp1.y2 - lp1.y1);
+                int my = lp1.y2 - (lp1.x2 - lp1.x1);
+                line3_no_clip(lp1, (lp.x1 + sx) >> 1, (lp.y1 + sy) >> 1, mx, my);
+                line3_no_clip(lp2, mx, my, (lp.x2 + ex) >> 1, (lp.y2 + ey) >> 1);
+                return;
+            }
+            
+            fix_degenerate_bisectrix_start(lp, &sx, &sy);
+            fix_degenerate_bisectrix_end(lp, &ex, &ey);
+            line_interpolator_image<self_type> li(*this, lp, 
+                                                  sx, sy, 
+                                                  ex, ey, 
+                                                  m_start, m_scale_x);
+            if(li.vertical())
+            {
+                while(li.step_ver());
+            }
+            else
+            {
+                while(li.step_hor());
+            }
+            m_start += uround(lp.len / m_scale_x);
+        }
+
+        //-------------------------------------------------------------------------
+        void line3(const line_parameters& lp, 
+                   int sx, int sy, int ex, int ey)
+        {
+            if(m_clipping)
+            {
+                int x1 = lp.x1;
+                int y1 = lp.y1;
+                int x2 = lp.x2;
+                int y2 = lp.y2;
+                unsigned flags = clip_line_segment(&x1, &y1, &x2, &y2, m_clip_box);
+                int start = m_start;
+                if((flags & 4) == 0)
+                {
+                    if(flags)
+                    {
+                        line_parameters lp2(x1, y1, x2, y2, 
+                                           uround(calc_distance(x1, y1, x2, y2)));
+                        if(flags & 1)
+                        {
+                            m_start += uround(calc_distance(lp.x1, lp.y1, x1, y1) / m_scale_x);
+                            sx = x1 + (y2 - y1); 
+                            sy = y1 - (x2 - x1);
+                        }
+                        else
+                        {
+                            while(abs(sx - lp.x1) + abs(sy - lp.y1) > lp2.len)
+                            {
+                                sx = (lp.x1 + sx) >> 1;
+                                sy = (lp.y1 + sy) >> 1;
+                            }
+                        }
+                        if(flags & 2)
+                        {
+                            ex = x2 + (y2 - y1); 
+                            ey = y2 - (x2 - x1);
+                        }
+                        else
+                        {
+                            while(abs(ex - lp.x2) + abs(ey - lp.y2) > lp2.len)
+                            {
+                                ex = (lp.x2 + ex) >> 1;
+                                ey = (lp.y2 + ey) >> 1;
+                            }
+                        }
+                        line3_no_clip(lp2, sx, sy, ex, ey);
+                    }
+                    else
+                    {
+                        line3_no_clip(lp, sx, sy, ex, ey);
+                    }
+                }
+                m_start = start + uround(lp.len / m_scale_x);
+            }
+            else
+            {
+                line3_no_clip(lp, sx, sy, ex, ey);
+            }
+        }
+
+    private:
+        base_ren_type*      m_ren;
+        const pattern_type* m_pattern;
+        int                 m_start;
+        double              m_scale_x;
+        rect_i              m_clip_box;
+        bool                m_clipping;
+    };
+
+
+
+
+
+}
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_primitives.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_primitives.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_primitives.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_primitives.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,224 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class renderer_primitives
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERER_PRIMITIVES_INCLUDED
+#define AGG_RENDERER_PRIMITIVES_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_renderer_base.h"
+#include "agg_dda_line.h"
+#include "agg_ellipse_bresenham.h"
+
+namespace mapserver
+{
+    //-----------------------------------------------------renderer_primitives
+    template<class BaseRenderer> class renderer_primitives
+    {
+    public:
+        typedef BaseRenderer base_ren_type;
+        typedef typename base_ren_type::color_type color_type;
+
+        //--------------------------------------------------------------------
+        explicit renderer_primitives(base_ren_type& ren) :
+            m_ren(&ren),
+            m_fill_color(),
+            m_line_color(),
+            m_curr_x(0),
+            m_curr_y(0)
+        {}
+        void attach(base_ren_type& ren) { m_ren = &ren; }
+
+        //--------------------------------------------------------------------
+        static int coord(double c) 
+        { 
+            return iround(c * line_bresenham_interpolator::subpixel_scale); 
+        }
+
+        //--------------------------------------------------------------------
+        void fill_color(const color_type& c) { m_fill_color = c; }
+        void line_color(const color_type& c) { m_line_color = c; }
+        const color_type& fill_color() const { return m_fill_color; }
+        const color_type& line_color() const { return m_line_color; }
+
+        //--------------------------------------------------------------------
+        void rectangle(int x1, int y1, int x2, int y2)
+        {
+            m_ren->blend_hline(x1,   y1,   x2-1, m_line_color, cover_full);
+            m_ren->blend_vline(x2,   y1,   y2-1, m_line_color, cover_full);
+            m_ren->blend_hline(x1+1, y2,   x2,   m_line_color, cover_full);
+            m_ren->blend_vline(x1,   y1+1, y2,   m_line_color, cover_full);
+        }
+
+        //--------------------------------------------------------------------
+        void solid_rectangle(int x1, int y1, int x2, int y2)
+        {
+            m_ren->blend_bar(x1, y1, x2, y2, m_fill_color, cover_full);
+        }
+
+        //--------------------------------------------------------------------
+        void outlined_rectangle(int x1, int y1, int x2, int y2) 
+        {
+            rectangle(x1, y1, x2, y2);
+            m_ren->blend_bar(x1+1, y1+1, x2-1, y2-1, m_fill_color, cover_full);
+        }
+
+        //--------------------------------------------------------------------
+        void ellipse(int x, int y, int rx, int ry)
+        {
+            ellipse_bresenham_interpolator ei(rx, ry);
+            int dx = 0;
+            int dy = -ry;
+            do
+            {
+                dx += ei.dx();
+                dy += ei.dy();
+                m_ren->blend_pixel(x + dx, y + dy, m_line_color, cover_full);
+                m_ren->blend_pixel(x + dx, y - dy, m_line_color, cover_full);
+                m_ren->blend_pixel(x - dx, y - dy, m_line_color, cover_full);
+                m_ren->blend_pixel(x - dx, y + dy, m_line_color, cover_full);
+                ++ei;
+            }
+            while(dy < 0);
+        }
+
+        //--------------------------------------------------------------------
+        void solid_ellipse(int x, int y, int rx, int ry)
+        {
+            ellipse_bresenham_interpolator ei(rx, ry);
+            int dx = 0;
+            int dy = -ry;
+            int dy0 = dy;
+            int dx0 = dx;
+
+            do
+            {
+                dx += ei.dx();
+                dy += ei.dy();
+
+                if(dy != dy0)
+                {
+                    m_ren->blend_hline(x-dx0, y+dy0, x+dx0, m_fill_color, cover_full);
+                    m_ren->blend_hline(x-dx0, y-dy0, x+dx0, m_fill_color, cover_full);
+                }
+                dx0 = dx;
+                dy0 = dy;
+                ++ei;
+            }
+            while(dy < 0);
+            m_ren->blend_hline(x-dx0, y+dy0, x+dx0, m_fill_color, cover_full);
+        }
+
+        //--------------------------------------------------------------------
+        void outlined_ellipse(int x, int y, int rx, int ry)
+        {
+            ellipse_bresenham_interpolator ei(rx, ry);
+            int dx = 0;
+            int dy = -ry;
+
+            do
+            {
+                dx += ei.dx();
+                dy += ei.dy();
+
+                m_ren->blend_pixel(x + dx, y + dy, m_line_color, cover_full);
+                m_ren->blend_pixel(x + dx, y - dy, m_line_color, cover_full);
+                m_ren->blend_pixel(x - dx, y - dy, m_line_color, cover_full);
+                m_ren->blend_pixel(x - dx, y + dy, m_line_color, cover_full);
+
+                if(ei.dy() && dx)
+                {
+                   m_ren->blend_hline(x-dx+1, y+dy, x+dx-1, m_fill_color, cover_full);
+                   m_ren->blend_hline(x-dx+1, y-dy, x+dx-1, m_fill_color, cover_full);
+                }
+                ++ei;
+            }
+            while(dy < 0);
+        }
+
+        //--------------------------------------------------------------------
+        void line(int x1, int y1, int x2, int y2, bool last=false)
+        {
+            line_bresenham_interpolator li(x1, y1, x2, y2);
+
+            unsigned len = li.len();
+            if(len == 0)
+            {
+                if(last)
+                {
+                    m_ren->blend_pixel(li.line_lr(x1), li.line_lr(y1), m_line_color, cover_full);
+                }
+                return;
+            }
+
+            if(last) ++len;
+
+            if(li.is_ver())
+            {
+                do
+                {
+                    m_ren->blend_pixel(li.x2(), li.y1(), m_line_color, cover_full);
+                    li.vstep();
+                }
+                while(--len);
+            }
+            else
+            {
+                do
+                {
+                    m_ren->blend_pixel(li.x1(), li.y2(), m_line_color, cover_full);
+                    li.hstep();
+                }
+                while(--len);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void move_to(int x, int y)
+        {
+            m_curr_x = x;
+            m_curr_y = y;
+        }
+
+        //--------------------------------------------------------------------
+        void line_to(int x, int y, bool last=false)
+        {
+            line(m_curr_x, m_curr_y, x, y, last);
+            m_curr_x = x;
+            m_curr_y = y;
+        }
+
+        //--------------------------------------------------------------------
+        const base_ren_type& ren() const { return *m_ren; }        
+        base_ren_type& ren() { return *m_ren; }        
+
+        //--------------------------------------------------------------------
+        const rendering_buffer& rbuf() const { return m_ren->rbuf(); }
+        rendering_buffer& rbuf() { return m_ren->rbuf(); }
+
+    private:
+        base_ren_type* m_ren;
+        color_type m_fill_color;
+        color_type m_line_color;
+        int m_curr_x;
+        int m_curr_y;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_raster_text.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_raster_text.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_raster_text.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_raster_text.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,292 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERER_RASTER_TEXT_INCLUDED
+#define AGG_RENDERER_RASTER_TEXT_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //==============================================renderer_raster_htext_solid
+    template<class BaseRenderer, class GlyphGenerator> 
+    class renderer_raster_htext_solid
+    {
+    public:
+        typedef BaseRenderer ren_type;
+        typedef GlyphGenerator glyph_gen_type;
+        typedef typename glyph_gen_type::glyph_rect glyph_rect;
+        typedef typename ren_type::color_type color_type;
+
+        renderer_raster_htext_solid(ren_type& ren, glyph_gen_type& glyph) :
+            m_ren(&ren),
+            m_glyph(&glyph)
+        {}
+        void attach(ren_type& ren) { m_ren = &ren; }
+
+        //--------------------------------------------------------------------
+        void color(const color_type& c) { m_color = c; }
+        const color_type& color() const { return m_color; }
+
+        //--------------------------------------------------------------------
+        template<class CharT>
+        void render_text(double x, double y, const CharT* str, bool flip=false)
+        {
+            glyph_rect r;
+            while(*str)
+            {
+                m_glyph->prepare(&r, x, y, *str, flip);
+                if(r.x2 >= r.x1)
+                {
+                    int i;
+                    if(flip)
+                    {
+                        for(i = r.y1; i <= r.y2; i++)
+                        {
+                            m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
+                                                     m_color,
+                                                     m_glyph->span(r.y2 - i));
+                        }
+                    }
+                    else
+                    {
+                        for(i = r.y1; i <= r.y2; i++)
+                        {
+                            m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
+                                                     m_color,
+                                                     m_glyph->span(i - r.y1));
+                        }
+                    }
+                }
+                x += r.dx;
+                y += r.dy;
+                ++str;
+            }
+        }
+
+        void render_glyph(double x, double y, unsigned glyph, bool flip=false)
+        {
+          glyph_rect r;
+          m_glyph->prepare(&r, x, y, glyph, flip);
+          if(r.x2 >= r.x1)
+          {
+            int i;
+            if(flip)
+            {
+              for(i = r.y1; i <= r.y2; i++)
+              {
+                m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
+                    m_color,
+                    m_glyph->span(r.y2 - i));
+              }
+            }
+            else
+            {
+              for(i = r.y1; i <= r.y2; i++)
+              {
+                m_ren->blend_solid_hspan(r.x1, i, (r.x2 - r.x1 + 1),
+                    m_color,
+                    m_glyph->span(i - r.y1));
+              }
+            }
+          }
+        }
+
+    private:
+        ren_type* m_ren;
+        glyph_gen_type* m_glyph;
+        color_type m_color;
+    };
+
+
+
+    //=============================================renderer_raster_vtext_solid
+    template<class BaseRenderer, class GlyphGenerator> 
+    class renderer_raster_vtext_solid
+    {
+    public:
+        typedef BaseRenderer ren_type;
+        typedef GlyphGenerator glyph_gen_type;
+        typedef typename glyph_gen_type::glyph_rect glyph_rect;
+        typedef typename ren_type::color_type color_type;
+
+        renderer_raster_vtext_solid(ren_type& ren, glyph_gen_type& glyph) :
+            m_ren(&ren),
+            m_glyph(&glyph)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        void color(const color_type& c) { m_color = c; }
+        const color_type& color() const { return m_color; }
+
+        //--------------------------------------------------------------------
+        template<class CharT>
+        void render_text(double x, double y, const CharT* str, bool flip=false)
+        {
+            glyph_rect r;
+            while(*str)
+            {
+                m_glyph->prepare(&r, x, y, *str, !flip);
+                if(r.x2 >= r.x1)
+                {
+                    int i;
+                    if(flip)
+                    {
+                        for(i = r.y1; i <= r.y2; i++)
+                        {
+                            m_ren->blend_solid_vspan(i, r.x1, (r.x2 - r.x1 + 1),
+                                                     m_color,
+                                                     m_glyph->span(i - r.y1));
+                        }
+                    }
+                    else
+                    {
+                        for(i = r.y1; i <= r.y2; i++)
+                        {
+                            m_ren->blend_solid_vspan(i, r.x1, (r.x2 - r.x1 + 1),
+                                                     m_color,
+                                                     m_glyph->span(r.y2 - i));
+                        }
+                    }
+                }
+                x += r.dx;
+                y += r.dy;
+                ++str;
+            }
+        }
+
+    private:
+        ren_type* m_ren;
+        glyph_gen_type* m_glyph;
+        color_type m_color;
+    };
+
+
+
+
+
+
+    //===================================================renderer_raster_htext
+    template<class ScanlineRenderer, class GlyphGenerator> 
+    class renderer_raster_htext
+    {
+    public:
+        typedef ScanlineRenderer ren_type;
+        typedef GlyphGenerator glyph_gen_type;
+        typedef typename glyph_gen_type::glyph_rect glyph_rect;
+
+        class scanline_single_span
+        {
+        public:
+            typedef mapserver::cover_type cover_type;
+
+            //----------------------------------------------------------------
+            struct const_span
+            {
+                int x;
+                unsigned len;
+                const cover_type* covers;
+
+                const_span() {}
+                const_span(int x_, unsigned len_, const cover_type* covers_) :
+                    x(x_), len(len_), covers(covers_) 
+                {}
+            };
+
+            typedef const const_span* const_iterator;
+
+            //----------------------------------------------------------------
+            scanline_single_span(int x, int y, unsigned len, 
+                                 const cover_type* covers) :
+                m_y(y),
+                m_span(x, len, covers)
+            {}
+
+            //----------------------------------------------------------------
+            int      y()           const { return m_y; }
+            unsigned num_spans()   const { return 1;   }
+            const_iterator begin() const { return &m_span; }
+
+        private:
+            //----------------------------------------------------------------
+            int m_y;
+            const_span m_span;
+        };
+
+
+
+        //--------------------------------------------------------------------
+        renderer_raster_htext(ren_type& ren, glyph_gen_type& glyph) :
+            m_ren(&ren),
+            m_glyph(&glyph)
+        {
+        }
+
+
+        //--------------------------------------------------------------------
+        template<class CharT>
+        void render_text(double x, double y, const CharT* str, bool flip=false)
+        {
+            glyph_rect r;
+            while(*str)
+            {
+                m_glyph->prepare(&r, x, y, *str, flip);
+                if(r.x2 >= r.x1)
+                {
+                    m_ren->prepare();
+                    int i;
+                    if(flip)
+                    {
+                        for(i = r.y1; i <= r.y2; i++)
+                        {
+                            m_ren->render(
+                                scanline_single_span(r.x1, 
+                                                     i, 
+                                                     (r.x2 - r.x1 + 1),
+                                                     m_glyph->span(r.y2 - i)));
+                        }
+                    }
+                    else
+                    {
+                        for(i = r.y1; i <= r.y2; i++)
+                        {
+                            m_ren->render(
+                                scanline_single_span(r.x1, 
+                                                     i, 
+                                                     (r.x2 - r.x1 + 1),
+                                                     m_glyph->span(i - r.y1)));
+                        }
+                    }
+                }
+                x += r.dx;
+                y += r.dy;
+                ++str;
+            }
+        }
+
+    private:
+        ren_type* m_ren;
+        glyph_gen_type* m_glyph;
+    };
+
+
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_renderer_scanline.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_scanline.h
--- 8.0.1-5/src/renderers/agg/include/agg_renderer_scanline.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_renderer_scanline.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,852 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERER_SCANLINE_INCLUDED
+#define AGG_RENDERER_SCANLINE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_renderer_base.h"
+
+namespace mapserver
+{
+
+    //================================================render_scanline_aa_solid
+    template<class Scanline, class BaseRenderer, class ColorT> 
+    void render_scanline_aa_solid(const Scanline& sl, 
+                                  BaseRenderer& ren, 
+                                  const ColorT& color)
+    {
+        int y = sl.y();
+        unsigned num_spans = sl.num_spans();
+        typename Scanline::const_iterator span = sl.begin();
+
+        for(;;)
+        {
+            int x = span->x;
+            if(span->len > 0)
+            {
+                ren.blend_solid_hspan(x, y, (unsigned)span->len, 
+                                      color, 
+                                      span->covers);
+            }
+            else
+            {
+                ren.blend_hline(x, y, (unsigned)(x - span->len - 1), 
+                                color, 
+                                *(span->covers));
+            }
+            if(--num_spans == 0) break;
+            ++span;
+        }
+    }
+
+    //===============================================render_scanlines_aa_solid
+    template<class Rasterizer, class Scanline, 
+             class BaseRenderer, class ColorT>
+    void render_scanlines_aa_solid(Rasterizer& ras, Scanline& sl, 
+                                   BaseRenderer& ren, const ColorT& color)
+    {
+        if(ras.rewind_scanlines())
+        {
+            // Explicitly convert "color" to the BaseRenderer color type.
+            // For example, it can be called with color type "rgba", while
+            // "rgba8" is needed. Otherwise it will be implicitly 
+            // converted in the loop many times.
+            //----------------------
+            typename BaseRenderer::color_type ren_color(color);
+
+            sl.reset(ras.min_x(), ras.max_x());
+            while(ras.sweep_scanline(sl))
+            {
+                //render_scanline_aa_solid(sl, ren, ren_color);
+
+                // This code is equivalent to the above call (copy/paste). 
+                // It's just a "manual" optimization for old compilers,
+                // like Microsoft Visual C++ v6.0
+                //-------------------------------
+                int y = sl.y();
+                unsigned num_spans = sl.num_spans();
+                typename Scanline::const_iterator span = sl.begin();
+
+                for(;;)
+                {
+                    int x = span->x;
+                    if(span->len > 0)
+                    {
+                        ren.blend_solid_hspan(x, y, (unsigned)span->len, 
+                                              ren_color, 
+                                              span->covers);
+                    }
+                    else
+                    {
+                        ren.blend_hline(x, y, (unsigned)(x - span->len - 1), 
+                                        ren_color, 
+                                        *(span->covers));
+                    }
+                    if(--num_spans == 0) break;
+                    ++span;
+                }
+            }
+        }
+    }
+
+    //==============================================renderer_scanline_aa_solid
+    template<class BaseRenderer> class renderer_scanline_aa_solid
+    {
+    public:
+        typedef BaseRenderer base_ren_type;
+        typedef typename base_ren_type::color_type color_type;
+
+        //--------------------------------------------------------------------
+        renderer_scanline_aa_solid() : m_ren(0) {}
+        explicit renderer_scanline_aa_solid(base_ren_type& ren) : m_ren(&ren) {}
+        void attach(base_ren_type& ren)
+        {
+            m_ren = &ren;
+        }
+        
+        //--------------------------------------------------------------------
+        void color(const color_type& c) { m_color = c; }
+        const color_type& color() const { return m_color; }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+
+        //--------------------------------------------------------------------
+        template<class Scanline> void render(const Scanline& sl)
+        {
+            render_scanline_aa_solid(sl, *m_ren, m_color);
+        }
+        
+    private:
+        base_ren_type* m_ren;
+        color_type m_color;
+    };
+
+
+
+
+
+
+
+
+
+
+
+
+
+    //======================================================render_scanline_aa
+    template<class Scanline, class BaseRenderer, 
+             class SpanAllocator, class SpanGenerator> 
+    void render_scanline_aa(const Scanline& sl, BaseRenderer& ren, 
+                            SpanAllocator& alloc, SpanGenerator& span_gen)
+    {
+        int y = sl.y();
+
+        unsigned num_spans = sl.num_spans();
+        typename Scanline::const_iterator span = sl.begin();
+        for(;;)
+        {
+            int x = span->x;
+            int len = span->len;
+            const typename Scanline::cover_type* covers = span->covers;
+
+            if(len < 0) len = -len;
+            typename BaseRenderer::color_type* colors = alloc.allocate(len);
+            span_gen.generate(colors, x, y, len);
+            ren.blend_color_hspan(x, y, len, colors, 
+                                  (span->len < 0) ? 0 : covers, *covers);
+
+            if(--num_spans == 0) break;
+            ++span;
+        }
+    }
+
+    //=====================================================render_scanlines_aa
+    template<class Rasterizer, class Scanline, class BaseRenderer, 
+             class SpanAllocator, class SpanGenerator>
+    void render_scanlines_aa(Rasterizer& ras, Scanline& sl, BaseRenderer& ren, 
+                             SpanAllocator& alloc, SpanGenerator& span_gen)
+    {
+        if(ras.rewind_scanlines())
+        {
+            sl.reset(ras.min_x(), ras.max_x());
+            span_gen.prepare();
+            while(ras.sweep_scanline(sl))
+            {
+                render_scanline_aa(sl, ren, alloc, span_gen);
+            }
+        }
+    }
+
+    //====================================================renderer_scanline_aa
+    template<class BaseRenderer, class SpanAllocator, class SpanGenerator> 
+    class renderer_scanline_aa
+    {
+    public:
+        typedef BaseRenderer  base_ren_type;
+        typedef SpanAllocator alloc_type;
+        typedef SpanGenerator span_gen_type;
+
+        //--------------------------------------------------------------------
+        renderer_scanline_aa() : m_ren(0), m_alloc(0), m_span_gen(0) {}
+        renderer_scanline_aa(base_ren_type& ren, 
+                             alloc_type& alloc, 
+                             span_gen_type& span_gen) :
+            m_ren(&ren),
+            m_alloc(&alloc),
+            m_span_gen(&span_gen)
+        {}
+        void attach(base_ren_type& ren, 
+                    alloc_type& alloc, 
+                    span_gen_type& span_gen)
+        {
+            m_ren = &ren;
+            m_alloc = &alloc;
+            m_span_gen = &span_gen;
+        }
+        
+        //--------------------------------------------------------------------
+        void prepare() { m_span_gen->prepare(); }
+
+        //--------------------------------------------------------------------
+        template<class Scanline> void render(const Scanline& sl)
+        {
+            render_scanline_aa(sl, *m_ren, *m_alloc, *m_span_gen);
+        }
+
+    private:
+        base_ren_type* m_ren;
+        alloc_type*    m_alloc;
+        span_gen_type* m_span_gen;
+    };
+
+
+
+
+
+
+    //===============================================render_scanline_bin_solid
+    template<class Scanline, class BaseRenderer, class ColorT> 
+    void render_scanline_bin_solid(const Scanline& sl, 
+                                   BaseRenderer& ren, 
+                                   const ColorT& color)
+    {
+        unsigned num_spans = sl.num_spans();
+        typename Scanline::const_iterator span = sl.begin();
+        for(;;)
+        {
+            ren.blend_hline(span->x, 
+                            sl.y(), 
+                            span->x - 1 + ((span->len < 0) ? 
+                                              -span->len : 
+                                               span->len), 
+                               color, 
+                               cover_full);
+            if(--num_spans == 0) break;
+            ++span;
+        }
+    }
+
+    //==============================================render_scanlines_bin_solid
+    template<class Rasterizer, class Scanline, 
+             class BaseRenderer, class ColorT>
+    void render_scanlines_bin_solid(Rasterizer& ras, Scanline& sl, 
+                                    BaseRenderer& ren, const ColorT& color)
+    {
+        if(ras.rewind_scanlines())
+        {
+            // Explicitly convert "color" to the BaseRenderer color type.
+            // For example, it can be called with color type "rgba", while
+            // "rgba8" is needed. Otherwise it will be implicitly 
+            // converted in the loop many times.
+            //----------------------
+            typename BaseRenderer::color_type ren_color(color);
+
+            sl.reset(ras.min_x(), ras.max_x());
+            while(ras.sweep_scanline(sl))
+            {
+                //render_scanline_bin_solid(sl, ren, ren_color);
+
+                // This code is equivalent to the above call (copy/paste). 
+                // It's just a "manual" optimization for old compilers,
+                // like Microsoft Visual C++ v6.0
+                //-------------------------------
+                unsigned num_spans = sl.num_spans();
+                typename Scanline::const_iterator span = sl.begin();
+                for(;;)
+                {
+                    ren.blend_hline(span->x, 
+                                    sl.y(), 
+                                    span->x - 1 + ((span->len < 0) ? 
+                                                      -span->len : 
+                                                       span->len), 
+                                       ren_color, 
+                                       cover_full);
+                    if(--num_spans == 0) break;
+                    ++span;
+                }
+            }
+        }
+    }
+
+    //=============================================renderer_scanline_bin_solid
+    template<class BaseRenderer> class renderer_scanline_bin_solid
+    {
+    public:
+        typedef BaseRenderer base_ren_type;
+        typedef typename base_ren_type::color_type color_type;
+
+        //--------------------------------------------------------------------
+        renderer_scanline_bin_solid() : m_ren(0) {}
+        explicit renderer_scanline_bin_solid(base_ren_type& ren) : m_ren(&ren) {}
+        void attach(base_ren_type& ren)
+        {
+            m_ren = &ren;
+        }
+        
+        //--------------------------------------------------------------------
+        void color(const color_type& c) { m_color = c; }
+        const color_type& color() const { return m_color; }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+
+        //--------------------------------------------------------------------
+        template<class Scanline> void render(const Scanline& sl)
+        {
+            render_scanline_bin_solid(sl, *m_ren, m_color);
+        }
+        
+    private:
+        base_ren_type* m_ren;
+        color_type m_color;
+    };
+
+
+
+
+
+
+
+
+    //======================================================render_scanline_bin
+    template<class Scanline, class BaseRenderer, 
+             class SpanAllocator, class SpanGenerator> 
+    void render_scanline_bin(const Scanline& sl, BaseRenderer& ren, 
+                             SpanAllocator& alloc, SpanGenerator& span_gen)
+    {
+        int y = sl.y();
+
+        unsigned num_spans = sl.num_spans();
+        typename Scanline::const_iterator span = sl.begin();
+        for(;;)
+        {
+            int x = span->x;
+            int len = span->len;
+            if(len < 0) len = -len;
+            typename BaseRenderer::color_type* colors = alloc.allocate(len);
+            span_gen.generate(colors, x, y, len);
+            ren.blend_color_hspan(x, y, len, colors, 0, cover_full); 
+            if(--num_spans == 0) break;
+            ++span;
+        }
+    }
+
+    //=====================================================render_scanlines_bin
+    template<class Rasterizer, class Scanline, class BaseRenderer, 
+             class SpanAllocator, class SpanGenerator>
+    void render_scanlines_bin(Rasterizer& ras, Scanline& sl, BaseRenderer& ren, 
+                              SpanAllocator& alloc, SpanGenerator& span_gen)
+    {
+        if(ras.rewind_scanlines())
+        {
+            sl.reset(ras.min_x(), ras.max_x());
+            span_gen.prepare();
+            while(ras.sweep_scanline(sl))
+            {
+                render_scanline_bin(sl, ren, alloc, span_gen);
+            }
+        }
+    }
+
+    //====================================================renderer_scanline_bin
+    template<class BaseRenderer, class SpanAllocator, class SpanGenerator> 
+    class renderer_scanline_bin
+    {
+    public:
+        typedef BaseRenderer  base_ren_type;
+        typedef SpanAllocator alloc_type;
+        typedef SpanGenerator span_gen_type;
+
+        //--------------------------------------------------------------------
+        renderer_scanline_bin() : m_ren(0), m_alloc(0), m_span_gen(0) {}
+        renderer_scanline_bin(base_ren_type& ren, 
+                              alloc_type& alloc, 
+                              span_gen_type& span_gen) :
+            m_ren(&ren),
+            m_alloc(&alloc),
+            m_span_gen(&span_gen)
+        {}
+        void attach(base_ren_type& ren, 
+                    alloc_type& alloc, 
+                    span_gen_type& span_gen)
+        {
+            m_ren = &ren;
+            m_alloc = &alloc;
+            m_span_gen = &span_gen;
+        }
+        
+        //--------------------------------------------------------------------
+        void prepare() { m_span_gen->prepare(); }
+
+        //--------------------------------------------------------------------
+        template<class Scanline> void render(const Scanline& sl)
+        {
+            render_scanline_bin(sl, *m_ren, *m_alloc, *m_span_gen);
+        }
+
+    private:
+        base_ren_type* m_ren;
+        alloc_type*    m_alloc;
+        span_gen_type* m_span_gen;
+    };
+
+
+
+
+
+
+
+
+
+
+    //========================================================render_scanlines
+    template<class Rasterizer, class Scanline, class Renderer>
+    void render_scanlines(Rasterizer& ras, Scanline& sl, Renderer& ren)
+    {
+        if(ras.rewind_scanlines())
+        {
+            sl.reset(ras.min_x(), ras.max_x());
+            ren.prepare();
+            while(ras.sweep_scanline(sl))
+            {
+                ren.render(sl);
+            }
+        }
+    }
+
+    //========================================================render_all_paths
+    template<class Rasterizer, class Scanline, class Renderer, 
+             class VertexSource, class ColorStorage, class PathId>
+    void render_all_paths(Rasterizer& ras, 
+                          Scanline& sl,
+                          Renderer& r, 
+                          VertexSource& vs, 
+                          const ColorStorage& as, 
+                          const PathId& path_id,
+                          unsigned num_paths)
+    {
+        for(unsigned i = 0; i < num_paths; i++)
+        {
+            ras.reset();
+            ras.add_path(vs, path_id[i]);
+            r.color(as[i]);
+            render_scanlines(ras, sl, r);
+        }
+    }
+
+
+
+
+
+
+    //=============================================render_scanlines_compound
+    template<class Rasterizer, 
+             class ScanlineAA, 
+             class ScanlineBin, 
+             class BaseRenderer, 
+             class SpanAllocator,
+             class StyleHandler>
+    void render_scanlines_compound(Rasterizer& ras, 
+                                   ScanlineAA& sl_aa,
+                                   ScanlineBin& sl_bin,
+                                   BaseRenderer& ren,
+                                   SpanAllocator& alloc,
+                                   StyleHandler& sh)
+    {
+        if(ras.rewind_scanlines())
+        {
+            int min_x = ras.min_x();
+            int len = ras.max_x() - min_x + 2;
+            sl_aa.reset(min_x, ras.max_x());
+            sl_bin.reset(min_x, ras.max_x());
+
+            typedef typename BaseRenderer::color_type color_type;
+            color_type* color_span = alloc.allocate(len * 2);
+            color_type* mix_buffer = color_span + len;
+            unsigned num_spans;
+
+            unsigned num_styles;
+            unsigned style;
+            bool     solid;
+            while((num_styles = ras.sweep_styles()) > 0)
+            {
+                typename ScanlineAA::const_iterator span_aa;
+                if(num_styles == 1)
+                {
+                    // Optimization for a single style. Happens often
+                    //-------------------------
+                    if(ras.sweep_scanline(sl_aa, 0))
+                    {
+                        style = ras.style(0);
+                        if(sh.is_solid(style))
+                        {
+                            // Just solid fill
+                            //-----------------------
+                            render_scanline_aa_solid(sl_aa, ren, sh.color(style));
+                        }
+                        else
+                        {
+                            // Arbitrary span generator
+                            //-----------------------
+                            span_aa   = sl_aa.begin();
+                            num_spans = sl_aa.num_spans();
+                            for(;;)
+                            {
+                                len = span_aa->len;
+                                sh.generate_span(color_span, 
+                                                 span_aa->x, 
+                                                 sl_aa.y(), 
+                                                 len, 
+                                                 style);
+
+                                ren.blend_color_hspan(span_aa->x, 
+                                                      sl_aa.y(), 
+                                                      span_aa->len,
+                                                      color_span,
+                                                      span_aa->covers);
+                                if(--num_spans == 0) break;
+                                ++span_aa;
+                            }
+                        }
+                    }
+                }
+                else
+                {
+                    if(ras.sweep_scanline(sl_bin, -1))
+                    {
+                        // Clear the spans of the mix_buffer
+                        //--------------------
+                        typename ScanlineBin::const_iterator span_bin = sl_bin.begin();
+                        num_spans = sl_bin.num_spans();
+                        for(;;)
+                        {
+                            memset(mix_buffer + span_bin->x - min_x, 
+                                   0, 
+                                   span_bin->len * sizeof(color_type));
+
+                            if(--num_spans == 0) break;
+                            ++span_bin;
+                        }
+
+                        unsigned i;
+                        for(i = 0; i < num_styles; i++)
+                        {
+                            style = ras.style(i);
+                            solid = sh.is_solid(style);
+
+                            if(ras.sweep_scanline(sl_aa, i))
+                            {
+                                color_type* colors;
+                                color_type* cspan;
+                                typename ScanlineAA::cover_type* covers;
+                                span_aa   = sl_aa.begin();
+                                num_spans = sl_aa.num_spans();
+                                if(solid)
+                                {
+                                    // Just solid fill
+                                    //-----------------------
+                                    for(;;)
+                                    {
+                                        color_type c = sh.color(style);
+                                        len    = span_aa->len;
+                                        colors = mix_buffer + span_aa->x - min_x;
+                                        covers = span_aa->covers;
+                                        do
+                                        {
+                                            if(*covers == cover_full) 
+                                            {
+                                                *colors = c;
+                                            }
+                                            else
+                                            {
+                                                colors->add(c, *covers);
+                                            }
+                                            ++colors;
+                                            ++covers;
+                                        }
+                                        while(--len);
+                                        if(--num_spans == 0) break;
+                                        ++span_aa;
+                                    }
+                                }
+                                else
+                                {
+                                    // Arbitrary span generator
+                                    //-----------------------
+                                    for(;;)
+                                    {
+                                        len = span_aa->len;
+                                        colors = mix_buffer + span_aa->x - min_x;
+                                        cspan  = color_span;
+                                        sh.generate_span(cspan, 
+                                                         span_aa->x, 
+                                                         sl_aa.y(), 
+                                                         len, 
+                                                         style);
+                                        covers = span_aa->covers;
+                                        do
+                                        {
+                                            if(*covers == cover_full) 
+                                            {
+                                                *colors = *cspan;
+                                            }
+                                            else
+                                            {
+                                                colors->add(*cspan, *covers);
+                                            }
+                                            ++cspan;
+                                            ++colors;
+                                            ++covers;
+                                        }
+                                        while(--len);
+                                        if(--num_spans == 0) break;
+                                        ++span_aa;
+                                    }
+                                }
+                            }
+                        }
+
+                        // Emit the blended result as a color hspan
+                        //-------------------------
+                        span_bin = sl_bin.begin();
+                        num_spans = sl_bin.num_spans();
+                        for(;;)
+                        {
+                            ren.blend_color_hspan(span_bin->x, 
+                                                  sl_bin.y(), 
+                                                  span_bin->len,
+                                                  mix_buffer + span_bin->x - min_x,
+                                                  0,
+                                                  cover_full);
+                            if(--num_spans == 0) break;
+                            ++span_bin;
+                        }
+                    } // if(ras.sweep_scanline(sl_bin, -1))
+                } // if(num_styles == 1) ... else
+            } // while((num_styles = ras.sweep_styles()) > 0)
+        } // if(ras.rewind_scanlines())
+    }
+
+    //=======================================render_scanlines_compound_layered
+    template<class Rasterizer, 
+             class ScanlineAA, 
+             class BaseRenderer, 
+             class SpanAllocator,
+             class StyleHandler>
+    void render_scanlines_compound_layered(Rasterizer& ras, 
+                                           ScanlineAA& sl_aa,
+                                           BaseRenderer& ren,
+                                           SpanAllocator& alloc,
+                                           StyleHandler& sh)
+    {
+        if(ras.rewind_scanlines())
+        {
+            int min_x = ras.min_x();
+            int len = ras.max_x() - min_x + 2;
+            sl_aa.reset(min_x, ras.max_x());
+
+            typedef typename BaseRenderer::color_type color_type;
+            color_type* color_span   = alloc.allocate(len * 2);
+            color_type* mix_buffer   = color_span + len;
+            cover_type* cover_buffer = ras.allocate_cover_buffer(len);
+            unsigned num_spans;
+
+            unsigned num_styles;
+            unsigned style;
+            bool     solid;
+            while((num_styles = ras.sweep_styles()) > 0)
+            {
+                typename ScanlineAA::const_iterator span_aa;
+                if(num_styles == 1)
+                {
+                    // Optimization for a single style. Happens often
+                    //-------------------------
+                    if(ras.sweep_scanline(sl_aa, 0))
+                    {
+                        style = ras.style(0);
+                        if(sh.is_solid(style))
+                        {
+                            // Just solid fill
+                            //-----------------------
+                            render_scanline_aa_solid(sl_aa, ren, sh.color(style));
+                        }
+                        else
+                        {
+                            // Arbitrary span generator
+                            //-----------------------
+                            span_aa   = sl_aa.begin();
+                            num_spans = sl_aa.num_spans();
+                            for(;;)
+                            {
+                                len = span_aa->len;
+                                sh.generate_span(color_span, 
+                                                 span_aa->x, 
+                                                 sl_aa.y(), 
+                                                 len, 
+                                                 style);
+
+                                ren.blend_color_hspan(span_aa->x, 
+                                                      sl_aa.y(), 
+                                                      span_aa->len,
+                                                      color_span,
+                                                      span_aa->covers);
+                                if(--num_spans == 0) break;
+                                ++span_aa;
+                            }
+                        }
+                    }
+                }
+                else
+                {
+                    int      sl_start = ras.scanline_start();
+                    unsigned sl_len   = ras.scanline_length();
+
+                    if(sl_len)
+                    {
+                        memset(mix_buffer + sl_start - min_x, 
+                               0, 
+                               sl_len * sizeof(color_type));
+
+                        memset(cover_buffer + sl_start - min_x, 
+                               0, 
+                               sl_len * sizeof(cover_type));
+
+                        int sl_y = 0x7FFFFFFF;
+                        unsigned i;
+                        for(i = 0; i < num_styles; i++)
+                        {
+                            style = ras.style(i);
+                            solid = sh.is_solid(style);
+
+                            if(ras.sweep_scanline(sl_aa, i))
+                            {
+                                unsigned    cover;
+                                color_type* colors;
+                                color_type* cspan;
+                                cover_type* src_covers;
+                                cover_type* dst_covers;
+                                span_aa   = sl_aa.begin();
+                                num_spans = sl_aa.num_spans();
+                                sl_y      = sl_aa.y();
+                                if(solid)
+                                {
+                                    // Just solid fill
+                                    //-----------------------
+                                    for(;;)
+                                    {
+                                        color_type c = sh.color(style);
+                                        len    = span_aa->len;
+                                        colors = mix_buffer + span_aa->x - min_x;
+                                        src_covers = span_aa->covers;
+                                        dst_covers = cover_buffer + span_aa->x - min_x;
+                                        do
+                                        {
+                                            cover = *src_covers;
+                                            if(*dst_covers + cover > cover_full)
+                                            {
+                                                cover = cover_full - *dst_covers;
+                                            }
+                                            if(cover)
+                                            {
+                                                colors->add(c, cover);
+                                                *dst_covers += cover;
+                                            }
+                                            ++colors;
+                                            ++src_covers;
+                                            ++dst_covers;
+                                        }
+                                        while(--len);
+                                        if(--num_spans == 0) break;
+                                        ++span_aa;
+                                    }
+                                }
+                                else
+                                {
+                                    // Arbitrary span generator
+                                    //-----------------------
+                                    for(;;)
+                                    {
+                                        len = span_aa->len;
+                                        colors = mix_buffer + span_aa->x - min_x;
+                                        cspan  = color_span;
+                                        sh.generate_span(cspan, 
+                                                         span_aa->x, 
+                                                         sl_aa.y(), 
+                                                         len, 
+                                                         style);
+                                        src_covers = span_aa->covers;
+                                        dst_covers = cover_buffer + span_aa->x - min_x;
+                                        do
+                                        {
+                                            cover = *src_covers;
+                                            if(*dst_covers + cover > cover_full)
+                                            {
+                                                cover = cover_full - *dst_covers;
+                                            }
+                                            if(cover)
+                                            {
+                                                colors->add(*cspan, cover);
+                                                *dst_covers += cover;
+                                            }
+                                            ++cspan;
+                                            ++colors;
+                                            ++src_covers;
+                                            ++dst_covers;
+                                        }
+                                        while(--len);
+                                        if(--num_spans == 0) break;
+                                        ++span_aa;
+                                    }
+                                }
+                            }
+                        }
+                        ren.blend_color_hspan(sl_start, 
+                                              sl_y, 
+                                              sl_len,
+                                              mix_buffer + sl_start - min_x,
+                                              0,
+                                              cover_full);
+                    } //if(sl_len)
+                } //if(num_styles == 1) ... else
+            } //while((num_styles = ras.sweep_styles()) > 0)
+        } //if(ras.rewind_scanlines())
+    }
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rendering_buffer.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rendering_buffer.h
--- 8.0.1-5/src/renderers/agg/include/agg_rendering_buffer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rendering_buffer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,300 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class rendering_buffer
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERING_BUFFER_INCLUDED
+#define AGG_RENDERING_BUFFER_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+
+    //===========================================================row_accessor
+    template<class T> class row_accessor
+    {
+    public:
+        typedef const_row_info<T> row_data;
+
+        //-------------------------------------------------------------------
+        row_accessor() :
+            m_buf(0),
+            m_start(0),
+            m_width(0),
+            m_height(0),
+            m_stride(0)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        row_accessor(T* buf, unsigned width, unsigned height, int stride) :
+            m_buf(0),
+            m_start(0),
+            m_width(0),
+            m_height(0),
+            m_stride(0)
+        {
+            attach(buf, width, height, stride);
+        }
+
+
+        //--------------------------------------------------------------------
+        void attach(T* buf, unsigned width, unsigned height, int stride)
+        {
+			m_buf = m_start = buf;
+			m_width = width;
+			m_height = height;
+			m_stride = stride;
+			if(stride < 0) 
+            { 
+				m_start = m_buf - (size_t)(height - 1) * stride;
+			}
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE       T* buf()          { return m_buf;    }
+        AGG_INLINE const T* buf()    const { return m_buf;    }
+        AGG_INLINE unsigned width()  const { return m_width;  }
+        AGG_INLINE unsigned height() const { return m_height; }
+        AGG_INLINE int      stride() const { return m_stride; }
+        AGG_INLINE unsigned stride_abs() const 
+        {
+            return (m_stride < 0) ? unsigned(-m_stride) : unsigned(m_stride); 
+        }
+
+        //--------------------------------------------------------------------
+		AGG_INLINE       T* row_ptr(int, int y, unsigned) 
+        { 
+            return m_start + (size_t)y * m_stride; 
+        }
+		AGG_INLINE       T* row_ptr(int y)       { return m_start + (size_t)y * m_stride; }
+		AGG_INLINE const T* row_ptr(int y) const { return m_start + (size_t)y * m_stride; }
+		AGG_INLINE row_data row    (int y) const 
+        { 
+            return row_data(0, m_width-1, row_ptr(y)); 
+        }
+
+        //--------------------------------------------------------------------
+        template<class RenBuf>
+        void copy_from(const RenBuf& src)
+        {
+            unsigned h = height();
+            if(src.height() < h) h = src.height();
+        
+            unsigned l = stride_abs();
+            if(src.stride_abs() < l) l = src.stride_abs();
+        
+            l *= sizeof(T);
+
+            unsigned y;
+            unsigned w = width();
+            for (y = 0; y < h; y++)
+            {
+                memcpy(row_ptr(0, y, w), src.row_ptr(y), l);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void clear(T value)
+        {
+            unsigned y;
+            unsigned w = width();
+            unsigned stride = stride_abs();
+            for(y = 0; y < height(); y++)
+            {
+                T* p = row_ptr(0, y, w);
+                unsigned x;
+                for(x = 0; x < stride; x++)
+                {
+                    *p++ = value;
+                }
+            }
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        T*            m_buf;    // Pointer to rendering buffer
+        T*            m_start;  // Pointer to first pixel depending on stride 
+        unsigned      m_width;  // Width in pixels
+        unsigned      m_height; // Height in pixels
+        int           m_stride; // Number of bytes per row. Can be < 0
+    };
+
+
+
+
+    //==========================================================row_ptr_cache
+    template<class T> class row_ptr_cache
+    {
+    public:
+        typedef const_row_info<T> row_data;
+
+        //-------------------------------------------------------------------
+        row_ptr_cache() :
+            m_buf(0),
+            m_rows(),
+            m_width(0),
+            m_height(0),
+            m_stride(0)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        row_ptr_cache(T* buf, unsigned width, unsigned height, int stride) :
+            m_buf(0),
+            m_rows(),
+            m_width(0),
+            m_height(0),
+            m_stride(0)
+        {
+            attach(buf, width, height, stride);
+        }
+
+        //--------------------------------------------------------------------
+        void attach(T* buf, unsigned width, unsigned height, int stride)
+        {
+            m_buf = buf;
+            m_width = width;
+            m_height = height;
+            m_stride = stride;
+            if(height > m_rows.size())
+            {
+                m_rows.resize(height);
+            }
+
+            T* row_ptr = m_buf;
+
+            if(stride < 0)
+            {
+                row_ptr = m_buf - int(height - 1) * stride;
+            }
+
+            T** rows = &m_rows[0];
+
+            while(height--)
+            {
+                *rows++ = row_ptr;
+                row_ptr += stride;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE       T* buf()          { return m_buf;    }
+        AGG_INLINE const T* buf()    const { return m_buf;    }
+        AGG_INLINE unsigned width()  const { return m_width;  }
+        AGG_INLINE unsigned height() const { return m_height; }
+        AGG_INLINE int      stride() const { return m_stride; }
+        AGG_INLINE unsigned stride_abs() const 
+        {
+            return (m_stride < 0) ? unsigned(-m_stride) : unsigned(m_stride); 
+        }
+
+        //--------------------------------------------------------------------
+        AGG_INLINE       T* row_ptr(int, int y, unsigned) 
+        { 
+            return m_rows[y]; 
+        }
+        AGG_INLINE       T* row_ptr(int y)       { return m_rows[y]; }
+        AGG_INLINE const T* row_ptr(int y) const { return m_rows[y]; }
+        AGG_INLINE row_data row    (int y) const 
+        { 
+            return row_data(0, m_width-1, m_rows[y]); 
+        }
+
+        //--------------------------------------------------------------------
+        T const* const* rows() const { return &m_rows[0]; }
+
+        //--------------------------------------------------------------------
+        template<class RenBuf>
+        void copy_from(const RenBuf& src)
+        {
+            unsigned h = height();
+            if(src.height() < h) h = src.height();
+        
+            unsigned l = stride_abs();
+            if(src.stride_abs() < l) l = src.stride_abs();
+        
+            l *= sizeof(T);
+
+            unsigned y;
+            unsigned w = width();
+            for (y = 0; y < h; y++)
+            {
+                memcpy(row_ptr(0, y, w), src.row_ptr(y), l);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        void clear(T value)
+        {
+            unsigned y;
+            unsigned w = width();
+            unsigned stride = stride_abs();
+            for(y = 0; y < height(); y++)
+            {
+                T* p = row_ptr(0, y, w);
+                unsigned x;
+                for(x = 0; x < stride; x++)
+                {
+                    *p++ = value;
+                }
+            }
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        T*            m_buf;        // Pointer to rendering buffer
+        pod_array<T*> m_rows;       // Pointers to each row of the buffer
+        unsigned      m_width;      // Width in pixels
+        unsigned      m_height;     // Height in pixels
+        int           m_stride;     // Number of bytes per row. Can be < 0
+    };
+
+
+
+
+    //========================================================rendering_buffer
+    // 
+    // The definition of the main type for accessing the rows in the frame 
+    // buffer. It provides functionality to navigate to the rows in a 
+    // rectangular matrix, from top to bottom or from bottom to top depending 
+    // on stride.
+    //
+    // row_accessor is cheap to create/destroy, but performs one multiplication
+    // when calling row_ptr().
+    // 
+    // row_ptr_cache creates an array of pointers to rows, so, the access 
+    // via row_ptr() may be faster. But it requires memory allocation 
+    // when creating. For example, on typical Intel Pentium hardware 
+    // row_ptr_cache speeds span_image_filter_rgb_nn up to 10%
+    //
+    // It's used only in short hand typedefs like pixfmt_rgba32 and can be 
+    // redefined in agg_config.h
+    // In real applications you can use both, depending on your needs
+    //------------------------------------------------------------------------
+#ifdef AGG_RENDERING_BUFFER
+    typedef AGG_RENDERING_BUFFER rendering_buffer;
+#else
+//  typedef row_ptr_cache<int8u> rendering_buffer;
+    typedef row_accessor<int8u> rendering_buffer;
+#endif
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rendering_buffer_dynarow.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rendering_buffer_dynarow.h
--- 8.0.1-5/src/renderers/agg/include/agg_rendering_buffer_dynarow.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rendering_buffer_dynarow.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,137 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class rendering_buffer_dynarow
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_RENDERING_BUFFER_DYNAROW_INCLUDED
+#define AGG_RENDERING_BUFFER_DYNAROW_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+
+    //===============================================rendering_buffer_dynarow
+    // Rendering buffer class with dynamic allocation of the rows.
+    // The rows are allocated as needed when requesting for span_ptr().
+    // The class automatically calculates min_x and max_x for each row.
+    // Generally it's more efficient to use this class as a temporary buffer
+    // for rendering a few lines and then to blend it with another buffer.
+    //
+    class rendering_buffer_dynarow
+    {
+    public:
+        typedef row_info<int8u> row_data;
+
+        //-------------------------------------------------------------------
+        ~rendering_buffer_dynarow()
+        {
+            init(0,0,0);
+        }
+
+        //-------------------------------------------------------------------
+        rendering_buffer_dynarow() :
+            m_rows(),
+            m_width(0),
+            m_height(0),
+            m_byte_width(0)
+        {
+        }
+
+        // Allocate and clear the buffer
+        //--------------------------------------------------------------------
+        rendering_buffer_dynarow(unsigned width, unsigned height, 
+                                 unsigned byte_width) :
+            m_rows(height),
+            m_width(width),
+            m_height(height),
+            m_byte_width(byte_width)
+        {
+            memset(&m_rows[0], 0, sizeof(row_data) * height);
+        }
+
+        // Allocate and clear the buffer
+        //--------------------------------------------------------------------
+        void init(unsigned width, unsigned height, unsigned byte_width)
+        {
+            unsigned i;
+            for(i = 0; i < m_height; ++i) 
+            {
+                pod_allocator<int8u>::deallocate((int8u*)m_rows[i].ptr, m_byte_width);
+            }
+            if(width && height)
+            {
+                m_width  = width;
+                m_height = height;
+                m_byte_width = byte_width;
+                m_rows.resize(height);
+                memset(&m_rows[0], 0, sizeof(row_data) * height);
+            }
+        }
+
+        //--------------------------------------------------------------------
+        unsigned width()      const { return m_width;  }
+        unsigned height()     const { return m_height; }
+        unsigned byte_width() const { return m_byte_width; }
+
+        // The main function used for rendering. Returns pointer to the 
+        // pre-allocated span. Memory for the row is allocated as needed.
+        //--------------------------------------------------------------------
+        int8u* row_ptr(int x, int y, unsigned len)
+        {
+            row_data* r = &m_rows[y];
+            int x2 = x + len - 1;
+            if(r->ptr)
+            {
+                if(x  < r->x1) { r->x1 = x;  }
+                if(x2 > r->x2) { r->x2 = x2; }
+            }
+            else
+            {
+                int8u* p = pod_allocator<int8u>::allocate(m_byte_width);
+                r->ptr = p;
+                r->x1  = x;
+                r->x2  = x2;
+                memset(p, 0, m_byte_width);
+            }
+            return (int8u*)r->ptr;
+        }
+
+        //--------------------------------------------------------------------
+        const int8u* row_ptr(int y) const { return m_rows[y].ptr; }
+              int8u* row_ptr(int y)       { return row_ptr(0, y, m_width); }
+        row_data     row    (int y) const { return m_rows[y]; }
+
+    private:
+        //--------------------------------------------------------------------
+        // Prohibit copying
+        rendering_buffer_dynarow(const rendering_buffer_dynarow&);
+        const rendering_buffer_dynarow& operator = (const rendering_buffer_dynarow&);
+
+    private:
+        //--------------------------------------------------------------------
+        pod_array<row_data> m_rows;       // Pointers to each row of the buffer
+        unsigned            m_width;      // Width in pixels
+        unsigned            m_height;     // Height in pixels
+        unsigned            m_byte_width; // Width in bytes
+    };
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_rounded_rect.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rounded_rect.h
--- 8.0.1-5/src/renderers/agg/include/agg_rounded_rect.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_rounded_rect.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,72 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Rounded rectangle vertex generator
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_ROUNDED_RECT_INCLUDED
+#define AGG_ROUNDED_RECT_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_arc.h"
+
+namespace mapserver
+{
+    //------------------------------------------------------------rounded_rect
+    //
+    // See Implemantation agg_rounded_rect.cpp
+    //
+    class rounded_rect
+    {
+    public:
+        rounded_rect() {}
+        rounded_rect(double x1, double y1, double x2, double y2, double r);
+
+        void rect(double x1, double y1, double x2, double y2);
+        void radius(double r);
+        void radius(double rx, double ry);
+        void radius(double rx_bottom, double ry_bottom, double rx_top, double ry_top);
+        void radius(double rx1, double ry1, double rx2, double ry2, 
+                    double rx3, double ry3, double rx4, double ry4);
+        void normalize_radius();
+
+        void approximation_scale(double s) { m_arc.approximation_scale(s); }
+        double approximation_scale() const { return m_arc.approximation_scale(); }
+
+        void rewind(unsigned);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        double m_x1;
+        double m_y1;
+        double m_x2;
+        double m_y2;
+        double m_rx1;
+        double m_ry1;
+        double m_rx2;
+        double m_ry2;
+        double m_rx3;
+        double m_ry3;
+        double m_rx4;
+        double m_ry4;
+        unsigned m_status;
+        arc      m_arc;
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_scanline_bin.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_bin.h
--- 8.0.1-5/src/renderers/agg/include/agg_scanline_bin.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_bin.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,264 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Class scanline_bin - binary scanline.
+//
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates (scanline32_bin) has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SCANLINE_BIN_INCLUDED
+#define AGG_SCANLINE_BIN_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+
+    //=============================================================scanline_bin
+    // 
+    // This is binary scaline container which supports the interface 
+    // used in the rasterizer::render(). See description of agg_scanline_u8 
+    // for details.
+    // 
+    //------------------------------------------------------------------------
+    class scanline_bin
+    {
+    public:
+        typedef int32 coord_type;
+
+        struct span
+        {
+            int16 x;
+            int16 len;
+        };
+
+        typedef const span* const_iterator;
+
+        //--------------------------------------------------------------------
+        scanline_bin() :
+            m_last_x(0x7FFFFFF0),
+            m_spans(),
+            m_cur_span(0)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        void reset(int min_x, int max_x)
+        {
+            unsigned max_len = max_x - min_x + 3;
+            if(max_len > m_spans.size())
+            {
+                m_spans.resize(max_len);
+            }
+            m_last_x   = 0x7FFFFFF0;
+            m_cur_span = &m_spans[0];
+        }
+
+        //--------------------------------------------------------------------
+        void add_cell(int x, unsigned)
+        {
+            if(x == m_last_x+1)
+            {
+                m_cur_span->len++;
+            }
+            else
+            {
+                ++m_cur_span;
+                m_cur_span->x = (int16)x;
+                m_cur_span->len = 1;
+            }
+            m_last_x = x;
+        }
+
+        //--------------------------------------------------------------------
+        void add_span(int x, unsigned len, unsigned)
+        {
+            if(x == m_last_x+1)
+            {
+                m_cur_span->len = (int16)(m_cur_span->len + len);
+            }
+            else
+            {
+                ++m_cur_span;
+                m_cur_span->x = (int16)x;
+                m_cur_span->len = (int16)len;
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void add_cells(int x, unsigned len, const void*)
+        {
+            add_span(x, len, 0);
+        }
+
+        //--------------------------------------------------------------------
+        void finalize(int y) 
+        { 
+            m_y = y; 
+        }
+
+        //--------------------------------------------------------------------
+        void reset_spans()
+        {
+            m_last_x    = 0x7FFFFFF0;
+            m_cur_span  = &m_spans[0];
+        }
+
+        //--------------------------------------------------------------------
+        int            y()         const { return m_y; }
+        unsigned       num_spans() const { return unsigned(m_cur_span - &m_spans[0]); }
+        const_iterator begin()     const { return &m_spans[1]; }
+
+    private:
+        scanline_bin(const scanline_bin&);
+        const scanline_bin operator = (const scanline_bin&);
+
+        int             m_last_x;
+        int             m_y = 0;
+        pod_array<span> m_spans;
+        span*           m_cur_span;
+    };
+
+
+
+
+
+
+    //===========================================================scanline32_bin
+    class scanline32_bin
+    {
+    public:
+        typedef int32 coord_type;
+
+        //--------------------------------------------------------------------
+        struct span
+        {
+            span() {}
+            span(coord_type x_, coord_type len_) : x(x_), len(len_) {}
+
+            coord_type x;
+            coord_type len;
+        };
+        typedef pod_bvector<span, 4> span_array_type;
+
+
+        //--------------------------------------------------------------------
+        class const_iterator
+        {
+        public:
+            const_iterator(const span_array_type& spans) :
+                m_spans(spans),
+                m_span_idx(0)
+            {}
+
+            const span& operator*()  const { return m_spans[m_span_idx];  }
+            const span* operator->() const { return &m_spans[m_span_idx]; }
+
+            void operator ++ () { ++m_span_idx; }
+
+        private:
+            const span_array_type& m_spans;
+            unsigned               m_span_idx;
+        };
+
+
+        //--------------------------------------------------------------------
+        scanline32_bin() : m_max_len(0), m_last_x(0x7FFFFFF0) {}
+
+        //--------------------------------------------------------------------
+        void reset(int /*min_x*/, int /*max_x*/)
+        {
+            m_last_x = 0x7FFFFFF0;
+            m_spans.remove_all();
+        }
+
+        //--------------------------------------------------------------------
+        void add_cell(int x, unsigned)
+        {
+            if(x == m_last_x+1)
+            {
+                m_spans.last().len++;
+            }
+            else
+            {
+                m_spans.add(span(coord_type(x), 1));
+            }
+            m_last_x = x;
+        }
+
+        //--------------------------------------------------------------------
+        void add_span(int x, unsigned len, unsigned)
+        {
+            if(x == m_last_x+1)
+            {
+                m_spans.last().len += coord_type(len);
+            }
+            else
+            {
+                m_spans.add(span(coord_type(x), coord_type(len)));
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void add_cells(int x, unsigned len, const void*)
+        {
+            add_span(x, len, 0);
+        }
+
+        //--------------------------------------------------------------------
+        void finalize(int y) 
+        { 
+            m_y = y; 
+        }
+
+        //--------------------------------------------------------------------
+        void reset_spans()
+        {
+            m_last_x = 0x7FFFFFF0;
+            m_spans.remove_all();
+        }
+
+        //--------------------------------------------------------------------
+        int            y()         const { return m_y; }
+        unsigned       num_spans() const { return m_spans.size(); }
+        const_iterator begin()     const { return const_iterator(m_spans); }
+
+    private:
+        scanline32_bin(const scanline32_bin&);
+        const scanline32_bin operator = (const scanline32_bin&);
+
+        unsigned        m_max_len;
+        int             m_last_x;
+        int             m_y;
+        span_array_type m_spans;
+    };
+
+
+
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_scanline_boolean_algebra.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_boolean_algebra.h
--- 8.0.1-5/src/renderers/agg/include/agg_scanline_boolean_algebra.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_boolean_algebra.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1567 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SCANLINE_BOOLEAN_ALGEBRA_INCLUDED
+#define AGG_SCANLINE_BOOLEAN_ALGEBRA_INCLUDED
+
+#include <stdlib.h>
+#include <math.h>
+#include "agg_basics.h"
+
+
+namespace mapserver
+{
+
+    //-----------------------------------------------sbool_combine_spans_bin
+    // Functor.
+    // Combine two binary encoded spans, i.e., when we don't have any
+    // anti-aliasing information, but only X and Length. The function
+    // is compatible with any type of scanlines.
+    //----------------
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline> 
+    struct sbool_combine_spans_bin
+    {
+        void operator () (const typename Scanline1::const_iterator&, 
+                          const typename Scanline2::const_iterator&, 
+                          int x, unsigned len, 
+                          Scanline& sl) const
+        {
+            sl.add_span(x, len, cover_full);
+        }
+    };
+
+
+
+    //---------------------------------------------sbool_combine_spans_empty
+    // Functor.
+    // Combine two spans as empty ones. The functor does nothing
+    // and is used to XOR binary spans.
+    //----------------
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline> 
+    struct sbool_combine_spans_empty
+    {
+        void operator () (const typename Scanline1::const_iterator&, 
+                          const typename Scanline2::const_iterator&, 
+                          int, unsigned, 
+                          Scanline&) const
+        {}
+    };
+
+
+
+    //--------------------------------------------------sbool_add_span_empty
+    // Functor.
+    // Add nothing. Used in conbine_shapes_sub
+    //----------------
+    template<class Scanline1, 
+             class Scanline> 
+    struct sbool_add_span_empty
+    {
+        void operator () (const typename Scanline1::const_iterator&, 
+                          int, unsigned, 
+                          Scanline&) const
+        {}
+    };
+
+
+    //----------------------------------------------------sbool_add_span_bin
+    // Functor.
+    // Add a binary span
+    //----------------
+    template<class Scanline1, 
+             class Scanline> 
+    struct sbool_add_span_bin
+    {
+        void operator () (const typename Scanline1::const_iterator&, 
+                          int x, unsigned len, 
+                          Scanline& sl) const
+        {
+            sl.add_span(x, len, cover_full);
+        }
+    };
+
+    
+
+
+    //-----------------------------------------------------sbool_add_span_aa
+    // Functor.
+    // Add an anti-aliased span
+    // anti-aliasing information, but only X and Length. The function
+    // is compatible with any type of scanlines.
+    //----------------
+    template<class Scanline1, 
+             class Scanline> 
+    struct sbool_add_span_aa
+    {
+        void operator () (const typename Scanline1::const_iterator& span, 
+                          int x, unsigned len, 
+                          Scanline& sl) const
+        {
+            if(span->len < 0)
+            {
+                sl.add_span(x, len, *span->covers);
+            }
+            else
+            if(span->len > 0)
+            {
+                const typename Scanline1::cover_type* covers = span->covers;
+                if(span->x < x) covers += x - span->x;
+                sl.add_cells(x, len, covers);
+            }
+        }
+    };
+
+
+
+
+    //----------------------------------------------sbool_intersect_spans_aa
+    // Functor.
+    // Intersect two spans preserving the anti-aliasing information.
+    // The result is added to the "sl" scanline.
+    //------------------
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             unsigned CoverShift = cover_shift> 
+    struct sbool_intersect_spans_aa
+    {
+        enum cover_scale_e
+        {
+            cover_shift = CoverShift,
+            cover_size  = 1 << cover_shift,
+            cover_mask  = cover_size - 1,
+            cover_full  = cover_mask
+        };
+        
+
+        void operator () (const typename Scanline1::const_iterator& span1, 
+                          const typename Scanline2::const_iterator& span2, 
+                          int x, unsigned len, 
+                          Scanline& sl) const
+        {
+            unsigned cover;
+            const typename Scanline1::cover_type* covers1;
+            const typename Scanline2::cover_type* covers2;
+
+            // Calculate the operation code and choose the 
+            // proper combination algorithm.
+            // 0 = Both spans are of AA type
+            // 1 = span1 is solid, span2 is AA
+            // 2 = span1 is AA, span2 is solid
+            // 3 = Both spans are of solid type
+            //-----------------
+            switch((span1->len < 0) | ((span2->len < 0) << 1))
+            {
+            case 0:      // Both are AA spans
+                covers1 = span1->covers;
+                covers2 = span2->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                if(span2->x < x) covers2 += x - span2->x;
+                do
+                {
+                    cover = *covers1++ * *covers2++;
+                    sl.add_cell(x++, 
+                                (cover == cover_full * cover_full) ?
+                                cover_full : 
+                                (cover >> cover_shift));
+                }
+                while(--len);
+                break;
+
+            case 1:      // span1 is solid, span2 is AA
+                covers2 = span2->covers;
+                if(span2->x < x) covers2 += x - span2->x;
+                if(*(span1->covers) == cover_full)
+                {
+                    sl.add_cells(x, len, covers2);
+                }
+                else
+                {
+                    do
+                    {
+                        cover = *(span1->covers) * *covers2++;
+                        sl.add_cell(x++, 
+                                    (cover == cover_full * cover_full) ?
+                                    cover_full : 
+                                    (cover >> cover_shift));
+                    }
+                    while(--len);
+                }
+                break;
+
+            case 2:      // span1 is AA, span2 is solid
+                covers1 = span1->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                if(*(span2->covers) == cover_full)
+                {
+                    sl.add_cells(x, len, covers1);
+                }
+                else
+                {
+                    do
+                    {
+                        cover = *covers1++ * *(span2->covers);
+                        sl.add_cell(x++, 
+                                    (cover == cover_full * cover_full) ?
+                                    cover_full : 
+                                    (cover >> cover_shift));
+                    }
+                    while(--len);
+                }
+                break;
+
+            case 3:      // Both are solid spans
+                cover = *(span1->covers) * *(span2->covers);
+                sl.add_span(x, len, 
+                            (cover == cover_full * cover_full) ?
+                            cover_full : 
+                            (cover >> cover_shift));
+                break;
+            }
+        }
+    };
+
+
+
+
+
+
+    //--------------------------------------------------sbool_unite_spans_aa
+    // Functor.
+    // Unite two spans preserving the anti-aliasing information.
+    // The result is added to the "sl" scanline.
+    //------------------
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             unsigned CoverShift = cover_shift> 
+    struct sbool_unite_spans_aa
+    {
+        enum cover_scale_e
+        {
+            cover_shift = CoverShift,
+            cover_size  = 1 << cover_shift,
+            cover_mask  = cover_size - 1,
+            cover_full  = cover_mask
+        };
+        
+
+        void operator () (const typename Scanline1::const_iterator& span1, 
+                          const typename Scanline2::const_iterator& span2, 
+                          int x, unsigned len, 
+                          Scanline& sl) const
+        {
+            unsigned cover;
+            const typename Scanline1::cover_type* covers1;
+            const typename Scanline2::cover_type* covers2;
+
+            // Calculate the operation code and choose the 
+            // proper combination algorithm.
+            // 0 = Both spans are of AA type
+            // 1 = span1 is solid, span2 is AA
+            // 2 = span1 is AA, span2 is solid
+            // 3 = Both spans are of solid type
+            //-----------------
+            switch((span1->len < 0) | ((span2->len < 0) << 1))
+            {
+            case 0:      // Both are AA spans
+                covers1 = span1->covers;
+                covers2 = span2->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                if(span2->x < x) covers2 += x - span2->x;
+                do
+                {
+                    cover = cover_mask * cover_mask - 
+                                (cover_mask - *covers1++) * 
+                                (cover_mask - *covers2++);
+                    sl.add_cell(x++, 
+                                (cover == cover_full * cover_full) ?
+                                cover_full : 
+                                (cover >> cover_shift));
+                }
+                while(--len);
+                break;
+
+            case 1:      // span1 is solid, span2 is AA
+                covers2 = span2->covers;
+                if(span2->x < x) covers2 += x - span2->x;
+                if(*(span1->covers) == cover_full)
+                {
+                    sl.add_span(x, len, cover_full);
+                }
+                else
+                {
+                    do
+                    {
+                        cover = cover_mask * cover_mask - 
+                                    (cover_mask - *(span1->covers)) * 
+                                    (cover_mask - *covers2++);
+                        sl.add_cell(x++, 
+                                    (cover == cover_full * cover_full) ?
+                                    cover_full : 
+                                    (cover >> cover_shift));
+                    }
+                    while(--len);
+                }
+                break;
+
+            case 2:      // span1 is AA, span2 is solid
+                covers1 = span1->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                if(*(span2->covers) == cover_full)
+                {
+                    sl.add_span(x, len, cover_full);
+                }
+                else
+                {
+                    do
+                    {
+                        cover = cover_mask * cover_mask - 
+                                    (cover_mask - *covers1++) * 
+                                    (cover_mask - *(span2->covers));
+                        sl.add_cell(x++, 
+                                    (cover == cover_full * cover_full) ?
+                                    cover_full : 
+                                    (cover >> cover_shift));
+                    }
+                    while(--len);
+                }
+                break;
+
+            case 3:      // Both are solid spans
+                cover = cover_mask * cover_mask - 
+                            (cover_mask - *(span1->covers)) * 
+                            (cover_mask - *(span2->covers));
+                sl.add_span(x, len, 
+                            (cover == cover_full * cover_full) ?
+                            cover_full : 
+                            (cover >> cover_shift));
+                break;
+            }
+        }
+    };
+
+
+    //---------------------------------------------sbool_xor_formula_linear
+    template<unsigned CoverShift = cover_shift> 
+    struct sbool_xor_formula_linear
+    {
+        enum cover_scale_e
+        {
+            cover_shift = CoverShift,
+            cover_size  = 1 << cover_shift,
+            cover_mask  = cover_size - 1
+        };
+
+        static AGG_INLINE unsigned calculate(unsigned a, unsigned b)
+        {
+            unsigned cover = a + b;
+            if(cover > cover_mask) cover = cover_mask + cover_mask - cover;
+            return cover;
+        }
+    };
+
+
+    //---------------------------------------------sbool_xor_formula_saddle
+    template<unsigned CoverShift = cover_shift> 
+    struct sbool_xor_formula_saddle
+    {
+        enum cover_scale_e
+        {
+            cover_shift = CoverShift,
+            cover_size  = 1 << cover_shift,
+            cover_mask  = cover_size - 1
+        };
+
+        static AGG_INLINE unsigned calculate(unsigned a, unsigned b)
+        {
+            unsigned k = a * b;
+            if(k == cover_mask * cover_mask) return 0;
+
+            a = (cover_mask * cover_mask - (a << cover_shift) + k) >> cover_shift;
+            b = (cover_mask * cover_mask - (b << cover_shift) + k) >> cover_shift;
+            return cover_mask - ((a * b) >> cover_shift);
+        }
+    };
+
+
+    //-------------------------------------------sbool_xor_formula_abs_diff
+    struct sbool_xor_formula_abs_diff
+    {
+        static AGG_INLINE unsigned calculate(unsigned a, unsigned b)
+        {
+            return unsigned(abs(int(a) - int(b)));
+        }
+    };
+
+
+
+    //----------------------------------------------------sbool_xor_spans_aa
+    // Functor.
+    // XOR two spans preserving the anti-aliasing information.
+    // The result is added to the "sl" scanline.
+    //------------------
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class XorFormula,
+             unsigned CoverShift = cover_shift> 
+    struct sbool_xor_spans_aa
+    {
+        enum cover_scale_e
+        {
+            cover_shift = CoverShift,
+            cover_size  = 1 << cover_shift,
+            cover_mask  = cover_size - 1,
+            cover_full  = cover_mask
+        };
+        
+
+        void operator () (const typename Scanline1::const_iterator& span1, 
+                          const typename Scanline2::const_iterator& span2, 
+                          int x, unsigned len, 
+                          Scanline& sl) const
+        {
+            unsigned cover;
+            const typename Scanline1::cover_type* covers1;
+            const typename Scanline2::cover_type* covers2;
+
+            // Calculate the operation code and choose the 
+            // proper combination algorithm.
+            // 0 = Both spans are of AA type
+            // 1 = span1 is solid, span2 is AA
+            // 2 = span1 is AA, span2 is solid
+            // 3 = Both spans are of solid type
+            //-----------------
+            switch((span1->len < 0) | ((span2->len < 0) << 1))
+            {
+            case 0:      // Both are AA spans
+                covers1 = span1->covers;
+                covers2 = span2->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                if(span2->x < x) covers2 += x - span2->x;
+                do
+                {
+                    cover = XorFormula::calculate(*covers1++, *covers2++);
+                    if(cover) sl.add_cell(x, cover);
+                    ++x;
+                }
+                while(--len);
+                break;
+
+            case 1:      // span1 is solid, span2 is AA
+                covers2 = span2->covers;
+                if(span2->x < x) covers2 += x - span2->x;
+                do
+                {
+                    cover = XorFormula::calculate(*(span1->covers), *covers2++);
+                    if(cover) sl.add_cell(x, cover);
+                    ++x;
+                }
+                while(--len);
+                break;
+
+            case 2:      // span1 is AA, span2 is solid
+                covers1 = span1->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                do
+                {
+                    cover = XorFormula::calculate(*covers1++, *(span2->covers));
+                    if(cover) sl.add_cell(x, cover);
+                    ++x;
+                }
+                while(--len);
+                break;
+
+            case 3:      // Both are solid spans
+                cover = XorFormula::calculate(*(span1->covers), *(span2->covers));
+                if(cover) sl.add_span(x, len, cover);
+                break;
+
+            }
+        }
+    };
+
+
+
+
+
+    //-----------------------------------------------sbool_subtract_spans_aa
+    // Functor.
+    // Unite two spans preserving the anti-aliasing information.
+    // The result is added to the "sl" scanline.
+    //------------------
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             unsigned CoverShift = cover_shift> 
+    struct sbool_subtract_spans_aa
+    {
+        enum cover_scale_e
+        {
+            cover_shift = CoverShift,
+            cover_size  = 1 << cover_shift,
+            cover_mask  = cover_size - 1,
+            cover_full  = cover_mask
+        };
+        
+
+        void operator () (const typename Scanline1::const_iterator& span1, 
+                          const typename Scanline2::const_iterator& span2, 
+                          int x, unsigned len, 
+                          Scanline& sl) const
+        {
+            unsigned cover;
+            const typename Scanline1::cover_type* covers1;
+            const typename Scanline2::cover_type* covers2;
+
+            // Calculate the operation code and choose the 
+            // proper combination algorithm.
+            // 0 = Both spans are of AA type
+            // 1 = span1 is solid, span2 is AA
+            // 2 = span1 is AA, span2 is solid
+            // 3 = Both spans are of solid type
+            //-----------------
+            switch((span1->len < 0) | ((span2->len < 0) << 1))
+            {
+            case 0:      // Both are AA spans
+                covers1 = span1->covers;
+                covers2 = span2->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                if(span2->x < x) covers2 += x - span2->x;
+                do
+                {
+                    cover = *covers1++ * (cover_mask - *covers2++);
+                    if(cover)
+                    {
+                        sl.add_cell(x, 
+                                    (cover == cover_full * cover_full) ?
+                                    cover_full : 
+                                    (cover >> cover_shift));
+                    }
+                    ++x;
+                }
+                while(--len);
+                break;
+
+            case 1:      // span1 is solid, span2 is AA
+                covers2 = span2->covers;
+                if(span2->x < x) covers2 += x - span2->x;
+                do
+                {
+                    cover = *(span1->covers) * (cover_mask - *covers2++);
+                    if(cover)
+                    {
+                        sl.add_cell(x, 
+                                    (cover == cover_full * cover_full) ?
+                                    cover_full : 
+                                    (cover >> cover_shift));
+                    }
+                    ++x;
+                }
+                while(--len);
+                break;
+
+            case 2:      // span1 is AA, span2 is solid
+                covers1 = span1->covers;
+                if(span1->x < x) covers1 += x - span1->x;
+                if(*(span2->covers) != cover_full)
+                {
+                    do
+                    {
+                        cover = *covers1++ * (cover_mask - *(span2->covers));
+                        if(cover)
+                        {
+                            sl.add_cell(x, 
+                                        (cover == cover_full * cover_full) ?
+                                        cover_full : 
+                                        (cover >> cover_shift));
+                        }
+                        ++x;
+                    }
+                    while(--len);
+                }
+                break;
+
+            case 3:      // Both are solid spans
+                cover = *(span1->covers) * (cover_mask - *(span2->covers));
+                if(cover)
+                {
+                    sl.add_span(x, len, 
+                                (cover == cover_full * cover_full) ?
+                                cover_full : 
+                                (cover >> cover_shift));
+                }
+                break;
+            }
+        }
+    };
+
+
+
+
+
+
+    //--------------------------------------------sbool_add_spans_and_render
+    template<class Scanline1, 
+             class Scanline, 
+             class Renderer, 
+             class AddSpanFunctor>
+    void sbool_add_spans_and_render(const Scanline1& sl1, 
+                                    Scanline& sl, 
+                                    Renderer& ren, 
+                                    AddSpanFunctor add_span)
+    {
+        sl.reset_spans();
+        typename Scanline1::const_iterator span = sl1.begin();
+        unsigned num_spans = sl1.num_spans();
+        for(;;)
+        {
+            add_span(span, span->x, abs((int)span->len), sl);
+            if(--num_spans == 0) break;
+            ++span;
+        }
+        sl.finalize(sl1.y());
+        ren.render(sl);
+    }
+
+
+
+
+
+
+
+    //---------------------------------------------sbool_intersect_scanlines
+    // Intersect two scanlines, "sl1" and "sl2" and generate a new "sl" one.
+    // The combine_spans functor can be of type sbool_combine_spans_bin or
+    // sbool_intersect_spans_aa. First is a general functor to combine
+    // two spans without Anti-Aliasing, the second preserves the AA
+    // information, but works slower
+    //
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class CombineSpansFunctor>
+    void sbool_intersect_scanlines(const Scanline1& sl1, 
+                                   const Scanline2& sl2, 
+                                   Scanline& sl, 
+                                   CombineSpansFunctor combine_spans)
+    {
+        sl.reset_spans();
+
+        unsigned num1 = sl1.num_spans();
+        if(num1 == 0) return;
+
+        unsigned num2 = sl2.num_spans();
+        if(num2 == 0) return;
+
+        typename Scanline1::const_iterator span1 = sl1.begin();
+        typename Scanline2::const_iterator span2 = sl2.begin();
+
+        while(num1 && num2)
+        {
+            int xb1 = span1->x;
+            int xb2 = span2->x;
+            int xe1 = xb1 + abs((int)span1->len) - 1;
+            int xe2 = xb2 + abs((int)span2->len) - 1;
+
+            // Determine what spans we should advance in the next step
+            // The span with the least ending X should be advanced
+            // advance_both is just an optimization when we ending 
+            // coordinates are the same and we can advance both
+            //--------------
+            bool advance_span1 = xe1 <  xe2;
+            bool advance_both  = xe1 == xe2;
+
+            // Find the intersection of the spans
+            // and check if they intersect
+            //--------------
+            if(xb1 < xb2) xb1 = xb2;
+            if(xe1 > xe2) xe1 = xe2;
+            if(xb1 <= xe1)
+            {
+                combine_spans(span1, span2, xb1, xe1 - xb1 + 1, sl);
+            }
+
+            // Advance the spans
+            //--------------
+            if(advance_both)
+            {
+                --num1;
+                --num2;
+                if(num1) ++span1;
+                if(num2) ++span2;
+            }
+            else
+            {
+                if(advance_span1)
+                {
+                    --num1;
+                    if(num1) ++span1;
+                }
+                else
+                {
+                    --num2;
+                    if(num2) ++span2;
+                }
+            }
+        }
+    }
+
+
+
+
+
+
+
+
+    //------------------------------------------------sbool_intersect_shapes
+    // Intersect the scanline shapes. Here the "Scanline Generator" 
+    // abstraction is used. ScanlineGen1 and ScanlineGen2 are 
+    // the generators, and can be of type rasterizer_scanline_aa<>.
+    // There function requires three scanline containers that can be of
+    // different types.
+    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
+    // "sl" is ised as the resulting scanline to render it.
+    // The external "sl1" and "sl2" are used only for the sake of
+    // optimization and reusing of the scanline objects.
+    // the function calls sbool_intersect_scanlines with CombineSpansFunctor 
+    // as the last argument. See sbool_intersect_scanlines for details.
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer,
+             class CombineSpansFunctor>
+    void sbool_intersect_shapes(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                Scanline1& sl1, Scanline2& sl2,
+                                Scanline& sl, Renderer& ren, 
+                                CombineSpansFunctor combine_spans)
+    {
+        // Prepare the scanline generators.
+        // If anyone of them doesn't contain 
+        // any scanlines, then return.
+        //-----------------
+        if(!sg1.rewind_scanlines()) return;
+        if(!sg2.rewind_scanlines()) return;
+
+        // Get the bounding boxes
+        //----------------
+        rect_i r1(sg1.min_x(), sg1.min_y(), sg1.max_x(), sg1.max_y());
+        rect_i r2(sg2.min_x(), sg2.min_y(), sg2.max_x(), sg2.max_y());
+
+        // Calculate the intersection of the bounding 
+        // boxes and return if they don't intersect.
+        //-----------------
+        rect_i ir = intersect_rectangles(r1, r2);
+        if(!ir.is_valid()) return;
+
+        // Reset the scanlines and get two first ones
+        //-----------------
+        sl.reset(ir.x1, ir.x2);
+        sl1.reset(sg1.min_x(), sg1.max_x());
+        sl2.reset(sg2.min_x(), sg2.max_x());
+        if(!sg1.sweep_scanline(sl1)) return;
+        if(!sg2.sweep_scanline(sl2)) return;
+
+        ren.prepare();
+
+        // The main loop
+        // Here we synchronize the scanlines with 
+        // the same Y coordinate, ignoring all other ones.
+        // Only scanlines having the same Y-coordinate 
+        // are to be combined.
+        //-----------------
+        for(;;)
+        {
+            while(sl1.y() < sl2.y())
+            {
+                if(!sg1.sweep_scanline(sl1)) return;
+            }
+            while(sl2.y() < sl1.y())
+            {
+                if(!sg2.sweep_scanline(sl2)) return;
+            }
+
+            if(sl1.y() == sl2.y())
+            {
+                // The Y coordinates are the same.
+                // Combine the scanlines, render if they contain any spans,
+                // and advance both generators to the next scanlines
+                //----------------------
+                sbool_intersect_scanlines(sl1, sl2, sl, combine_spans);
+                if(sl.num_spans())
+                {
+                    sl.finalize(sl1.y());
+                    ren.render(sl);
+                }
+                if(!sg1.sweep_scanline(sl1)) return;
+                if(!sg2.sweep_scanline(sl2)) return;
+            }
+        }
+    }
+
+
+
+
+
+
+
+    //-------------------------------------------------sbool_unite_scanlines
+    // Unite two scanlines, "sl1" and "sl2" and generate a new "sl" one.
+    // The combine_spans functor can be of type sbool_combine_spans_bin or
+    // sbool_intersect_spans_aa. First is a general functor to combine
+    // two spans without Anti-Aliasing, the second preserves the AA
+    // information, but works slower
+    //
+    template<class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class AddSpanFunctor1,
+             class AddSpanFunctor2,
+             class CombineSpansFunctor>
+    void sbool_unite_scanlines(const Scanline1& sl1, 
+                               const Scanline2& sl2, 
+                               Scanline& sl, 
+                               AddSpanFunctor1 add_span1,
+                               AddSpanFunctor2 add_span2,
+                               CombineSpansFunctor combine_spans)
+    {
+        sl.reset_spans();
+
+        unsigned num1 = sl1.num_spans();
+        unsigned num2 = sl2.num_spans();
+
+        typename Scanline1::const_iterator span1 = NULL;// = sl1.begin();
+        typename Scanline2::const_iterator span2 = NULL;// = sl2.begin();
+
+        enum invalidation_e 
+        { 
+            invalid_b = 0xFFFFFFF, 
+            invalid_e = invalid_b - 1 
+        };
+
+        // Initialize the spans as invalid
+        //---------------
+        int xb1 = invalid_b;
+        int xb2 = invalid_b;
+        int xe1 = invalid_e;
+        int xe2 = invalid_e;
+
+        // Initialize span1 if there are spans
+        //---------------
+        if(num1)
+        {
+            span1 = sl1.begin();
+            xb1 = span1->x;
+            xe1 = xb1 + abs((int)span1->len) - 1;
+            --num1;
+        }
+
+        // Initialize span2 if there are spans
+        //---------------
+        if(num2)
+        {
+            span2 = sl2.begin();
+            xb2 = span2->x;
+            xe2 = xb2 + abs((int)span2->len) - 1;
+            --num2;
+        }
+
+
+        for(;;)
+        {
+            // Retrieve a new span1 if it's invalid
+            //----------------
+            if(num1 && xb1 > xe1) 
+            {
+                --num1;
+                ++span1;
+                xb1 = span1->x;
+                xe1 = xb1 + abs((int)span1->len) - 1;
+            }
+
+            // Retrieve a new span2 if it's invalid
+            //----------------
+            if(num2 && xb2 > xe2) 
+            {
+                --num2;
+                ++span2;
+                xb2 = span2->x;
+                xe2 = xb2 + abs((int)span2->len) - 1;
+            }
+
+            if(xb1 > xe1 && xb2 > xe2) break;
+
+            // Calculate the intersection
+            //----------------
+            int xb = xb1;
+            int xe = xe1;
+            if(xb < xb2) xb = xb2;
+            if(xe > xe2) xe = xe2;
+            int len = xe - xb + 1; // The length of the intersection
+            if(len > 0)
+            {
+                // The spans intersect,
+                // add the beginning of the span
+                //----------------
+                if(xb1 < xb2)
+                {
+                    add_span1(span1, xb1, xb2 - xb1, sl);
+                    xb1 = xb2;
+                }
+                else
+                if(xb2 < xb1)
+                {
+                    add_span2(span2, xb2, xb1 - xb2, sl);
+                    xb2 = xb1;
+                }
+
+                // Add the combination part of the spans
+                //----------------
+                combine_spans(span1, span2, xb, len, sl);
+
+
+                // Invalidate the fully processed span or both
+                //----------------
+                if(xe1 < xe2)
+                {
+                    // Invalidate span1 and eat
+                    // the processed part of span2
+                    //--------------
+                    xb1 = invalid_b;    
+                    xe1 = invalid_e;
+                    xb2 += len;
+                }
+                else
+                if(xe2 < xe1)
+                {
+                    // Invalidate span2 and eat
+                    // the processed part of span1
+                    //--------------
+                    xb2 = invalid_b;  
+                    xe2 = invalid_e;
+                    xb1 += len;
+                }
+                else
+                {
+                    xb1 = invalid_b;  // Invalidate both
+                    xb2 = invalid_b;
+                    xe1 = invalid_e;
+                    xe2 = invalid_e;
+                }
+            }
+            else
+            {
+                // The spans do not intersect
+                //--------------
+                if(xb1 < xb2) 
+                {
+                    // Advance span1
+                    //---------------
+                    if(xb1 <= xe1)
+                    {
+                        add_span1(span1, xb1, xe1 - xb1 + 1, sl);
+                    }
+                    xb1 = invalid_b; // Invalidate
+                    xe1 = invalid_e;
+                }
+                else
+                {
+                    // Advance span2
+                    //---------------
+                    if(xb2 <= xe2)
+                    {
+                        add_span2(span2, xb2, xe2 - xb2 + 1, sl);
+                    }
+                    xb2 = invalid_b; // Invalidate
+                    xe2 = invalid_e;
+                }
+            }
+        }
+    }
+
+
+
+
+    //----------------------------------------------------sbool_unite_shapes
+    // Unite the scanline shapes. Here the "Scanline Generator" 
+    // abstraction is used. ScanlineGen1 and ScanlineGen2 are 
+    // the generators, and can be of type rasterizer_scanline_aa<>.
+    // There function requires three scanline containers that can be 
+    // of different type.
+    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
+    // "sl" is ised as the resulting scanline to render it.
+    // The external "sl1" and "sl2" are used only for the sake of
+    // optimization and reusing of the scanline objects.
+    // the function calls sbool_unite_scanlines with CombineSpansFunctor 
+    // as the last argument. See sbool_unite_scanlines for details.
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer,
+             class AddSpanFunctor1,
+             class AddSpanFunctor2,
+             class CombineSpansFunctor>
+    void sbool_unite_shapes(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                            Scanline1& sl1, Scanline2& sl2,
+                            Scanline& sl, Renderer& ren, 
+                            AddSpanFunctor1 add_span1,
+                            AddSpanFunctor2 add_span2,
+                            CombineSpansFunctor combine_spans)
+    {
+        // Prepare the scanline generators.
+        // If anyone of them doesn't contain 
+        // any scanlines, then return.
+        //-----------------
+        bool flag1 = sg1.rewind_scanlines();
+        bool flag2 = sg2.rewind_scanlines();
+        if(!flag1 && !flag2) return;
+
+        // Get the bounding boxes
+        //----------------
+        rect_i r1(sg1.min_x(), sg1.min_y(), sg1.max_x(), sg1.max_y());
+        rect_i r2(sg2.min_x(), sg2.min_y(), sg2.max_x(), sg2.max_y());
+
+        // Calculate the union of the bounding boxes
+        //-----------------
+        rect_i ur(1,1,0,0);
+             if(flag1 && flag2) ur = unite_rectangles(r1, r2);
+        else if(flag1)          ur = r1;
+        else if(flag2)          ur = r2;
+
+        if(!ur.is_valid()) return;
+
+        ren.prepare();
+
+        // Reset the scanlines and get two first ones
+        //-----------------
+        sl.reset(ur.x1, ur.x2);
+        if(flag1) 
+        {
+            sl1.reset(sg1.min_x(), sg1.max_x());
+            flag1 = sg1.sweep_scanline(sl1);
+        }
+
+        if(flag2) 
+        {
+            sl2.reset(sg2.min_x(), sg2.max_x());
+            flag2 = sg2.sweep_scanline(sl2);
+        }
+
+        // The main loop
+        // Here we synchronize the scanlines with 
+        // the same Y coordinate.
+        //-----------------
+        while(flag1 || flag2)
+        {
+            if(flag1 && flag2)
+            {
+                if(sl1.y() == sl2.y())
+                {
+                    // The Y coordinates are the same.
+                    // Combine the scanlines, render if they contain any spans,
+                    // and advance both generators to the next scanlines
+                    //----------------------
+                    sbool_unite_scanlines(sl1, sl2, sl, 
+                                          add_span1, add_span2, combine_spans);
+                    if(sl.num_spans())
+                    {
+                        sl.finalize(sl1.y());
+                        ren.render(sl);
+                    }
+                    flag1 = sg1.sweep_scanline(sl1);
+                    flag2 = sg2.sweep_scanline(sl2);
+                }
+                else
+                {
+                    if(sl1.y() < sl2.y())
+                    {
+                        sbool_add_spans_and_render(sl1, sl, ren, add_span1);
+                        flag1 = sg1.sweep_scanline(sl1);
+                    }
+                    else
+                    {
+                        sbool_add_spans_and_render(sl2, sl, ren, add_span2);
+                        flag2 = sg2.sweep_scanline(sl2);
+                    }
+                }
+            }
+            else
+            {
+                if(flag1)
+                {
+                    sbool_add_spans_and_render(sl1, sl, ren, add_span1);
+                    flag1 = sg1.sweep_scanline(sl1);
+                }
+                if(flag2)
+                {
+                    sbool_add_spans_and_render(sl2, sl, ren, add_span2);
+                    flag2 = sg2.sweep_scanline(sl2);
+                }
+            }
+        }
+    }
+
+
+
+
+
+
+
+
+    //-------------------------------------------------sbool_subtract_shapes
+    // Subtract the scanline shapes, "sg1-sg2". Here the "Scanline Generator" 
+    // abstraction is used. ScanlineGen1 and ScanlineGen2 are 
+    // the generators, and can be of type rasterizer_scanline_aa<>.
+    // There function requires three scanline containers that can be of
+    // different types.
+    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
+    // "sl" is ised as the resulting scanline to render it.
+    // The external "sl1" and "sl2" are used only for the sake of
+    // optimization and reusing of the scanline objects.
+    // the function calls sbool_intersect_scanlines with CombineSpansFunctor 
+    // as the last argument. See combine_scanlines_sub for details.
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer,
+             class AddSpanFunctor1,
+             class CombineSpansFunctor>
+    void sbool_subtract_shapes(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                               Scanline1& sl1, Scanline2& sl2,
+                               Scanline& sl, Renderer& ren, 
+                               AddSpanFunctor1 add_span1,
+                               CombineSpansFunctor combine_spans)
+    {
+        // Prepare the scanline generators.
+        // Here "sg1" is master, "sg2" is slave.
+        //-----------------
+        if(!sg1.rewind_scanlines()) return;
+        bool flag2 = sg2.rewind_scanlines();
+
+        // Get the bounding box
+        //----------------
+        rect_i r1(sg1.min_x(), sg1.min_y(), sg1.max_x(), sg1.max_y());
+
+        // Reset the scanlines and get two first ones
+        //-----------------
+        sl.reset(sg1.min_x(), sg1.max_x());
+        sl1.reset(sg1.min_x(), sg1.max_x());
+        sl2.reset(sg2.min_x(), sg2.max_x());
+        if(!sg1.sweep_scanline(sl1)) return;
+
+        if(flag2) flag2 = sg2.sweep_scanline(sl2);
+
+        ren.prepare();
+
+        // A fake span2 processor
+        sbool_add_span_empty<Scanline2, Scanline> add_span2;
+
+        // The main loop
+        // Here we synchronize the scanlines with 
+        // the same Y coordinate, ignoring all other ones.
+        // Only scanlines having the same Y-coordinate 
+        // are to be combined.
+        //-----------------
+        bool flag1 = true;
+        do
+        {
+            // Synchronize "slave" with "master"
+            //-----------------
+            while(flag2 && sl2.y() < sl1.y())
+            {
+                flag2 = sg2.sweep_scanline(sl2);
+            }
+
+
+            if(flag2 && sl2.y() == sl1.y())
+            {
+                // The Y coordinates are the same.
+                // Combine the scanlines and render if they contain any spans.
+                //----------------------
+                sbool_unite_scanlines(sl1, sl2, sl, add_span1, add_span2, combine_spans);
+                if(sl.num_spans())
+                {
+                    sl.finalize(sl1.y());
+                    ren.render(sl);
+                }
+            }
+            else
+            {
+                sbool_add_spans_and_render(sl1, sl, ren, add_span1);
+            }
+
+            // Advance the "master"
+            flag1 = sg1.sweep_scanline(sl1);
+        }
+        while(flag1);
+    }
+
+
+
+
+
+
+
+    //---------------------------------------------sbool_intersect_shapes_aa
+    // Intersect two anti-aliased scanline shapes. 
+    // Here the "Scanline Generator" abstraction is used. 
+    // ScanlineGen1 and ScanlineGen2 are the generators, and can be of 
+    // type rasterizer_scanline_aa<>. There function requires three 
+    // scanline containers that can be of different types.
+    // "sl1" and "sl2" are used to retrieve scanlines from the generators,
+    // "sl" is ised as the resulting scanline to render it.
+    // The external "sl1" and "sl2" are used only for the sake of
+    // optimization and reusing of the scanline objects.
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_intersect_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                   Scanline1& sl1, Scanline2& sl2,
+                                   Scanline& sl, Renderer& ren)
+    {
+        sbool_intersect_spans_aa<Scanline1, Scanline2, Scanline> combine_functor;
+        sbool_intersect_shapes(sg1, sg2, sl1, sl2, sl, ren, combine_functor);
+    }
+
+
+
+
+
+    //--------------------------------------------sbool_intersect_shapes_bin
+    // Intersect two binary scanline shapes (without anti-aliasing). 
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_intersect_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                    Scanline1& sl1, Scanline2& sl2,
+                                    Scanline& sl, Renderer& ren)
+    {
+        sbool_combine_spans_bin<Scanline1, Scanline2, Scanline> combine_functor;
+        sbool_intersect_shapes(sg1, sg2, sl1, sl2, sl, ren, combine_functor);
+    }
+
+
+
+
+
+    //-------------------------------------------------sbool_unite_shapes_aa
+    // Unite two anti-aliased scanline shapes 
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_unite_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                               Scanline1& sl1, Scanline2& sl2,
+                               Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
+        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
+        sbool_unite_spans_aa<Scanline1, Scanline2, Scanline> combine_functor;
+        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                           add_functor1, add_functor2, combine_functor);
+    }
+
+
+
+
+
+    //------------------------------------------------sbool_unite_shapes_bin
+    // Unite two binary scanline shapes (without anti-aliasing). 
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_unite_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                Scanline1& sl1, Scanline2& sl2,
+                                Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_bin<Scanline1, Scanline> add_functor1;
+        sbool_add_span_bin<Scanline2, Scanline> add_functor2;
+        sbool_combine_spans_bin<Scanline1, Scanline2, Scanline> combine_functor;
+        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                           add_functor1, add_functor2, combine_functor);
+    }
+
+
+
+
+
+
+
+
+
+    //---------------------------------------------------sbool_xor_shapes_aa
+    // Apply eXclusive OR to two anti-aliased scanline shapes. There's 
+    // a modified "Linear" XOR used instead of classical "Saddle" one.
+    // The reason is to have the result absolutely conststent with what
+    // the scanline rasterizer produces.
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_xor_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                             Scanline1& sl1, Scanline2& sl2,
+                             Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
+        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
+        sbool_xor_spans_aa<Scanline1, Scanline2, Scanline, 
+                           sbool_xor_formula_linear<> > combine_functor;
+        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                           add_functor1, add_functor2, combine_functor);
+    }
+
+
+
+    //------------------------------------------sbool_xor_shapes_saddle_aa
+    // Apply eXclusive OR to two anti-aliased scanline shapes. 
+    // There's the classical "Saddle" used to calculate the 
+    // Anti-Aliasing values, that is:
+    // a XOR b : 1-((1-a+a*b)*(1-b+a*b))
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_xor_shapes_saddle_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                    Scanline1& sl1, Scanline2& sl2,
+                                    Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
+        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
+        sbool_xor_spans_aa<Scanline1, 
+                           Scanline2, 
+                           Scanline, 
+                           sbool_xor_formula_saddle<> > combine_functor;
+        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                           add_functor1, add_functor2, combine_functor);
+    }
+
+
+    //--------------------------------------sbool_xor_shapes_abs_diff_aa
+    // Apply eXclusive OR to two anti-aliased scanline shapes. 
+    // There's the absolute difference used to calculate 
+    // Anti-Aliasing values, that is:
+    // a XOR b : abs(a-b)
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_xor_shapes_abs_diff_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                      Scanline1& sl1, Scanline2& sl2,
+                                      Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_aa<Scanline1, Scanline> add_functor1;
+        sbool_add_span_aa<Scanline2, Scanline> add_functor2;
+        sbool_xor_spans_aa<Scanline1, 
+                           Scanline2, 
+                           Scanline, 
+                           sbool_xor_formula_abs_diff> combine_functor;
+        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                           add_functor1, add_functor2, combine_functor);
+    }
+
+
+
+    //--------------------------------------------------sbool_xor_shapes_bin
+    // Apply eXclusive OR to two binary scanline shapes (without anti-aliasing). 
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_xor_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                              Scanline1& sl1, Scanline2& sl2,
+                              Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_bin<Scanline1, Scanline> add_functor1;
+        sbool_add_span_bin<Scanline2, Scanline> add_functor2;
+        sbool_combine_spans_empty<Scanline1, Scanline2, Scanline> combine_functor;
+        sbool_unite_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                           add_functor1, add_functor2, combine_functor);
+    }
+
+
+
+
+
+
+    //----------------------------------------------sbool_subtract_shapes_aa
+    // Subtract shapes "sg1-sg2" with anti-aliasing
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_subtract_shapes_aa(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                  Scanline1& sl1, Scanline2& sl2,
+                                  Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_aa<Scanline1, Scanline> add_functor;
+        sbool_subtract_spans_aa<Scanline1, Scanline2, Scanline> combine_functor;
+        sbool_subtract_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                              add_functor, combine_functor);
+    }
+
+
+
+
+
+    //---------------------------------------------sbool_subtract_shapes_bin
+    // Subtract binary shapes "sg1-sg2" without anti-aliasing
+    // See intersect_shapes_aa for more comments
+    //----------
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_subtract_shapes_bin(ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                   Scanline1& sl1, Scanline2& sl2,
+                                   Scanline& sl, Renderer& ren)
+    {
+        sbool_add_span_bin<Scanline1, Scanline> add_functor;
+        sbool_combine_spans_empty<Scanline1, Scanline2, Scanline> combine_functor;
+        sbool_subtract_shapes(sg1, sg2, sl1, sl2, sl, ren, 
+                              add_functor, combine_functor);
+    }
+
+
+
+
+
+
+    //------------------------------------------------------------sbool_op_e
+    enum sbool_op_e
+    {
+        sbool_or,            //----sbool_or
+        sbool_and,           //----sbool_and
+        sbool_xor,           //----sbool_xor
+        sbool_xor_saddle,    //----sbool_xor_saddle
+        sbool_xor_abs_diff,  //----sbool_xor_abs_diff
+        sbool_a_minus_b,     //----sbool_a_minus_b
+        sbool_b_minus_a      //----sbool_b_minus_a
+    };
+
+
+
+
+
+
+    //----------------------------------------------sbool_combine_shapes_bin
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_combine_shapes_bin(sbool_op_e op,
+                                  ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                  Scanline1& sl1, Scanline2& sl2,
+                                  Scanline& sl, Renderer& ren)
+    {
+        switch(op)
+        {
+        case sbool_or          : sbool_unite_shapes_bin    (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_and         : sbool_intersect_shapes_bin(sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_xor         :
+        case sbool_xor_saddle  : 
+        case sbool_xor_abs_diff: sbool_xor_shapes_bin      (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_a_minus_b   : sbool_subtract_shapes_bin (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_b_minus_a   : sbool_subtract_shapes_bin (sg2, sg1, sl2, sl1, sl, ren); break;
+        }
+    }
+
+
+
+
+    //-----------------------------------------------sbool_combine_shapes_aa
+    template<class ScanlineGen1, 
+             class ScanlineGen2, 
+             class Scanline1, 
+             class Scanline2, 
+             class Scanline, 
+             class Renderer>
+    void sbool_combine_shapes_aa(sbool_op_e op,
+                                 ScanlineGen1& sg1, ScanlineGen2& sg2,
+                                 Scanline1& sl1, Scanline2& sl2,
+                                 Scanline& sl, Renderer& ren)
+    {
+        switch(op)
+        {
+        case sbool_or          : sbool_unite_shapes_aa       (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_and         : sbool_intersect_shapes_aa   (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_xor         : sbool_xor_shapes_aa         (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_xor_saddle  : sbool_xor_shapes_saddle_aa  (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_xor_abs_diff: sbool_xor_shapes_abs_diff_aa(sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_a_minus_b   : sbool_subtract_shapes_aa    (sg1, sg2, sl1, sl2, sl, ren); break;
+        case sbool_b_minus_a   : sbool_subtract_shapes_aa    (sg2, sg1, sl2, sl1, sl, ren); break;
+        }
+    }
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_scanline_p.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_p.h
--- 8.0.1-5/src/renderers/agg/include/agg_scanline_p.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_p.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,329 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Class scanline_p - a general purpose scanline container with packed spans.
+//
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates (scanline32_p) has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+#ifndef AGG_SCANLINE_P_INCLUDED
+#define AGG_SCANLINE_P_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+
+    //=============================================================scanline_p8
+    // 
+    // This is a general purpose scaline container which supports the interface 
+    // used in the rasterizer::render(). See description of scanline_u8
+    // for details.
+    // 
+    //------------------------------------------------------------------------
+    class scanline_p8
+    {
+    public:
+        typedef scanline_p8 self_type;
+        typedef int8u       cover_type;
+        typedef int16       coord_type;
+
+        //--------------------------------------------------------------------
+        struct span
+        {
+            coord_type        x;
+            coord_type        len; // If negative, it's a solid span, covers is valid
+            const cover_type* covers;
+        };
+
+        typedef span* iterator;
+        typedef const span* const_iterator;
+
+        scanline_p8() :
+            m_last_x(0x7FFFFFF0),
+            m_covers(),
+            m_cover_ptr(0),
+            m_spans(),
+            m_cur_span(0)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        void reset(int min_x, int max_x)
+        {
+            unsigned max_len = max_x - min_x + 3;
+            if(max_len > m_spans.size())
+            {
+                m_spans.resize(max_len);
+                m_covers.resize(max_len);
+            }
+            m_last_x    = 0x7FFFFFF0;
+            m_cover_ptr = &m_covers[0];
+            m_cur_span  = &m_spans[0];
+            m_cur_span->len = 0;
+        }
+
+        //--------------------------------------------------------------------
+        void add_cell(int x, unsigned cover)
+        {
+            *m_cover_ptr = (cover_type)cover;
+            if(x == m_last_x+1 && m_cur_span->len > 0)
+            {
+                m_cur_span->len++;
+            }
+            else
+            {
+                m_cur_span++;
+                m_cur_span->covers = m_cover_ptr;
+                m_cur_span->x = (int16)x;
+                m_cur_span->len = 1;
+            }
+            m_last_x = x;
+            m_cover_ptr++;
+        }
+
+        //--------------------------------------------------------------------
+        void add_cells(int x, unsigned len, const cover_type* covers)
+        {
+            memcpy(m_cover_ptr, covers, len * sizeof(cover_type));
+            if(x == m_last_x+1 && m_cur_span->len > 0)
+            {
+                m_cur_span->len += (int16)len;
+            }
+            else
+            {
+                m_cur_span++;
+                m_cur_span->covers = m_cover_ptr;
+                m_cur_span->x = (int16)x;
+                m_cur_span->len = (int16)len;
+            }
+            m_cover_ptr += len;
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void add_span(int x, unsigned len, unsigned cover)
+        {
+            if(x == m_last_x+1 && 
+               m_cur_span->len < 0 && 
+               cover == *m_cur_span->covers)
+            {
+                m_cur_span->len -= (int16)len;
+            }
+            else
+            {
+                *m_cover_ptr = (cover_type)cover;
+                m_cur_span++;
+                m_cur_span->covers = m_cover_ptr++;
+                m_cur_span->x      = (int16)x;
+                m_cur_span->len    = (int16)(-int(len));
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void finalize(int y) 
+        { 
+            m_y = y; 
+        }
+
+        //--------------------------------------------------------------------
+        void reset_spans()
+        {
+            m_last_x    = 0x7FFFFFF0;
+            m_cover_ptr = &m_covers[0];
+            m_cur_span  = &m_spans[0];
+            m_cur_span->len = 0;
+        }
+
+        //--------------------------------------------------------------------
+        int            y()         const { return m_y; }
+        unsigned       num_spans() const { return unsigned(m_cur_span - &m_spans[0]); }
+        const_iterator begin()     const { return &m_spans[1]; }
+
+    private:
+        scanline_p8(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        int                   m_last_x;
+        int                   m_y = 0;
+        pod_array<cover_type> m_covers;
+        cover_type*           m_cover_ptr;
+        pod_array<span>       m_spans;
+        span*                 m_cur_span;
+    };
+
+
+
+
+
+
+
+
+    //==========================================================scanline32_p8
+    class scanline32_p8
+    {
+    public:
+        typedef scanline32_p8 self_type;
+        typedef int8u         cover_type;
+        typedef int32         coord_type;
+
+        struct span
+        {
+            span() {}
+            span(coord_type x_, coord_type len_, const cover_type* covers_) :
+                x(x_), len(len_), covers(covers_) {}
+
+            coord_type x;
+            coord_type len; // If negative, it's a solid span, covers is valid
+            const cover_type* covers;
+        };
+        typedef pod_bvector<span, 4> span_array_type;
+
+
+        //--------------------------------------------------------------------
+        class const_iterator
+        {
+        public:
+            const_iterator(const span_array_type& spans) :
+                m_spans(spans),
+                m_span_idx(0)
+            {}
+
+            const span& operator*()  const { return m_spans[m_span_idx];  }
+            const span* operator->() const { return &m_spans[m_span_idx]; }
+
+            void operator ++ () { ++m_span_idx; }
+
+        private:
+            const span_array_type& m_spans;
+            unsigned               m_span_idx;
+        };
+
+        //--------------------------------------------------------------------
+        scanline32_p8() :
+            m_max_len(0),
+            m_last_x(0x7FFFFFF0),
+            m_covers(),
+            m_cover_ptr(0)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        void reset(int min_x, int max_x)
+        {
+            unsigned max_len = max_x - min_x + 3;
+            if(max_len > m_covers.size())
+            {
+                m_covers.resize(max_len);
+            }
+            m_last_x    = 0x7FFFFFF0;
+            m_cover_ptr = &m_covers[0];
+            m_spans.remove_all();
+        }
+
+        //--------------------------------------------------------------------
+        void add_cell(int x, unsigned cover)
+        {
+            *m_cover_ptr = cover_type(cover);
+            if(x == m_last_x+1 && m_spans.size() && m_spans.last().len > 0)
+            {
+                m_spans.last().len++;
+            }
+            else
+            {
+                m_spans.add(span(coord_type(x), 1, m_cover_ptr));
+            }
+            m_last_x = x;
+            m_cover_ptr++;
+        }
+
+        //--------------------------------------------------------------------
+        void add_cells(int x, unsigned len, const cover_type* covers)
+        {
+            memcpy(m_cover_ptr, covers, len * sizeof(cover_type));
+            if(x == m_last_x+1 && m_spans.size() && m_spans.last().len > 0)
+            {
+                m_spans.last().len += coord_type(len);
+            }
+            else
+            {
+                m_spans.add(span(coord_type(x), coord_type(len), m_cover_ptr));
+            }
+            m_cover_ptr += len;
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void add_span(int x, unsigned len, unsigned cover)
+        {
+            if(x == m_last_x+1 && 
+               m_spans.size() &&
+               m_spans.last().len < 0 && 
+               cover == *m_spans.last().covers)
+            {
+                m_spans.last().len -= coord_type(len);
+            }
+            else
+            {
+                *m_cover_ptr = cover_type(cover);
+                m_spans.add(span(coord_type(x), -coord_type(len), m_cover_ptr++));
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void finalize(int y) 
+        { 
+            m_y = y; 
+        }
+
+        //--------------------------------------------------------------------
+        void reset_spans()
+        {
+            m_last_x    = 0x7FFFFFF0;
+            m_cover_ptr = &m_covers[0];
+            m_spans.remove_all();
+        }
+
+        //--------------------------------------------------------------------
+        int            y()         const { return m_y; }
+        unsigned       num_spans() const { return m_spans.size(); }
+        const_iterator begin()     const { return const_iterator(m_spans); }
+
+    private:
+        scanline32_p8(const self_type&);
+        const self_type& operator = (const self_type&);
+
+        unsigned              m_max_len;
+        int                   m_last_x;
+        int                   m_y;
+        pod_array<cover_type> m_covers;
+        cover_type*           m_cover_ptr;
+        span_array_type       m_spans;
+    };
+
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_scanline_storage_aa.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_storage_aa.h
--- 8.0.1-5/src/renderers/agg/include/agg_scanline_storage_aa.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_storage_aa.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,815 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SCANLINE_STORAGE_AA_INCLUDED
+#define AGG_SCANLINE_STORAGE_AA_INCLUDED
+
+#include <string.h>
+#include <stdlib.h>
+#include <math.h>
+#include "agg_array.h"
+
+
+namespace mapserver
+{
+
+    //----------------------------------------------scanline_cell_storage
+    template<class T> class scanline_cell_storage
+    {
+        struct extra_span
+        {
+            unsigned len;
+            T*       ptr;
+        };
+
+    public:
+        typedef T value_type;
+
+        //---------------------------------------------------------------
+        ~scanline_cell_storage()
+        {
+            remove_all();
+        }
+
+        //---------------------------------------------------------------
+        scanline_cell_storage() :
+            m_cells(128-2),
+            m_extra_storage()
+        {}
+
+
+        // Copying
+        //---------------------------------------------------------------
+        scanline_cell_storage(const scanline_cell_storage<T>& v) :
+            m_cells(v.m_cells),
+            m_extra_storage()
+        {
+            copy_extra_storage(v);
+        }
+
+        //---------------------------------------------------------------
+        const scanline_cell_storage<T>& 
+        operator = (const scanline_cell_storage<T>& v)
+        {
+            remove_all();
+            m_cells = v.m_cells;
+            copy_extra_storage(v);
+            return *this;
+        }
+
+        //---------------------------------------------------------------
+        void remove_all()
+        {
+            int i;
+            for(i = m_extra_storage.size()-1; i >= 0; --i)
+            {
+                pod_allocator<T>::deallocate(m_extra_storage[i].ptr,
+                                             m_extra_storage[i].len);
+            }
+            m_extra_storage.remove_all();
+            m_cells.remove_all();
+        }
+
+        //---------------------------------------------------------------
+        int add_cells(const T* cells, unsigned num_cells)
+        {
+            int idx = m_cells.allocate_continuous_block(num_cells);
+            if(idx >= 0)
+            {
+                T* ptr = &m_cells[idx];
+                memcpy(ptr, cells, sizeof(T) * num_cells);
+                return idx;
+            }
+            extra_span s;
+            s.len = num_cells;
+            s.ptr = pod_allocator<T>::allocate(num_cells);
+            memcpy(s.ptr, cells, sizeof(T) * num_cells);
+            m_extra_storage.add(s);
+            return -int(m_extra_storage.size());
+        }
+
+        //---------------------------------------------------------------
+        const T* operator [] (int idx) const
+        {
+            if(idx >= 0)
+            {
+                if((unsigned)idx >= m_cells.size()) return 0;
+                return &m_cells[(unsigned)idx];
+            }
+            unsigned i = unsigned(-idx - 1);
+            if(i >= m_extra_storage.size()) return 0;
+            return m_extra_storage[i].ptr;
+        }
+
+        //---------------------------------------------------------------
+        T* operator [] (int idx)
+        {
+            if(idx >= 0)
+            {
+                if((unsigned)idx >= m_cells.size()) return 0;
+                return &m_cells[(unsigned)idx];
+            }
+            unsigned i = unsigned(-idx - 1);
+            if(i >= m_extra_storage.size()) return 0;
+            return m_extra_storage[i].ptr;
+        }
+
+    private:
+        void copy_extra_storage(const scanline_cell_storage<T>& v)
+        {
+            unsigned i;
+            for(i = 0; i < v.m_extra_storage.size(); ++i)
+            {
+                const extra_span& src = v.m_extra_storage[i];
+                extra_span dst;
+                dst.len = src.len;
+                dst.ptr = pod_allocator<T>::allocate(dst.len);
+                memcpy(dst.ptr, src.ptr, dst.len * sizeof(T));
+                m_extra_storage.add(dst);
+            }
+        }
+
+        pod_bvector<T, 12>         m_cells;
+        pod_bvector<extra_span, 6> m_extra_storage;
+    };
+
+
+
+
+
+
+    //-----------------------------------------------scanline_storage_aa
+    template<class T> class scanline_storage_aa
+    {
+    public:
+        typedef T cover_type;
+
+        //---------------------------------------------------------------
+        struct span_data
+        {
+            int32 x;
+            int32 len;       // If negative, it's a solid span, covers is valid
+            int   covers_id; // The index of the cells in the scanline_cell_storage
+        };
+
+        //---------------------------------------------------------------
+        struct scanline_data
+        {
+            int      y;
+            unsigned num_spans;
+            unsigned start_span;
+        };
+
+
+        //---------------------------------------------------------------
+        class embedded_scanline
+        {
+        public:
+
+            //-----------------------------------------------------------
+            class const_iterator
+            {
+            public:
+                struct span
+                {
+                    int32    x;
+                    int32    len; // If negative, it's a solid span, covers is valid
+                    const T* covers;
+                };
+
+                const_iterator() : m_storage(0) {}
+                const_iterator(const embedded_scanline& sl) :
+                    m_storage(sl.m_storage),
+                    m_span_idx(sl.m_scanline.start_span)
+                {
+                    init_span();
+                }
+
+                const span& operator*()  const { return m_span;  }
+                const span* operator->() const { return &m_span; }
+
+                void operator ++ ()
+                {
+                    ++m_span_idx;
+                    init_span();
+                }
+
+            private:
+                void init_span()
+                {
+                    const span_data& s = m_storage->span_by_index(m_span_idx);
+                    m_span.x      = s.x;
+                    m_span.len    = s.len;
+                    m_span.covers = m_storage->covers_by_index(s.covers_id);
+                }
+
+                const scanline_storage_aa* m_storage;
+                unsigned                   m_span_idx;
+                span                       m_span;
+            };
+
+            friend class const_iterator;
+
+
+            //-----------------------------------------------------------
+            embedded_scanline(const scanline_storage_aa& storage) :
+                m_storage(&storage)
+            {
+                init(0);
+            }
+
+            //-----------------------------------------------------------
+            void     reset(int, int)     {}
+            unsigned num_spans()   const { return m_scanline.num_spans;  }
+            int      y()           const { return m_scanline.y;          }
+            const_iterator begin() const { return const_iterator(*this); }
+
+            //-----------------------------------------------------------
+            void init(unsigned scanline_idx)
+            {
+                m_scanline_idx = scanline_idx;
+                m_scanline = m_storage->scanline_by_index(m_scanline_idx);
+            }
+
+        private:
+            const scanline_storage_aa* m_storage;
+            scanline_data              m_scanline;
+            unsigned                   m_scanline_idx;
+        };
+
+
+        //---------------------------------------------------------------
+        scanline_storage_aa() :
+            m_covers(),
+            m_spans(256-2),         // Block increment size
+            m_scanlines(),
+            m_min_x( 0x7FFFFFFF),
+            m_min_y( 0x7FFFFFFF),
+            m_max_x(-0x7FFFFFFF),
+            m_max_y(-0x7FFFFFFF),
+            m_cur_scanline(0)
+        {
+            m_fake_scanline.y = 0;
+            m_fake_scanline.num_spans = 0;
+            m_fake_scanline.start_span = 0;
+            m_fake_span.x = 0;
+            m_fake_span.len = 0;
+            m_fake_span.covers_id = 0;
+        }
+
+        // Renderer Interface
+        //---------------------------------------------------------------
+        void prepare()
+        {
+            m_covers.remove_all();
+            m_scanlines.remove_all();
+            m_spans.remove_all();
+            m_min_x =  0x7FFFFFFF;
+            m_min_y =  0x7FFFFFFF;
+            m_max_x = -0x7FFFFFFF;
+            m_max_y = -0x7FFFFFFF;
+            m_cur_scanline = 0;
+        }
+
+        //---------------------------------------------------------------
+        template<class Scanline> void render(const Scanline& sl)
+        {
+            scanline_data sl_this;
+
+            int y = sl.y();
+            if(y < m_min_y) m_min_y = y;
+            if(y > m_max_y) m_max_y = y;
+
+            sl_this.y = y;
+            sl_this.num_spans = sl.num_spans();
+            sl_this.start_span = m_spans.size();
+            typename Scanline::const_iterator span_iterator = sl.begin();
+
+            unsigned num_spans = sl_this.num_spans;
+            for(;;)
+            {
+                span_data sp;
+
+                sp.x         = span_iterator->x;
+                sp.len       = span_iterator->len;
+                int len      = abs(int(sp.len));
+                sp.covers_id = 
+                    m_covers.add_cells(span_iterator->covers, 
+                                       unsigned(len));
+                m_spans.add(sp);
+                int x1 = sp.x;
+                int x2 = sp.x + len - 1;
+                if(x1 < m_min_x) m_min_x = x1;
+                if(x2 > m_max_x) m_max_x = x2;
+                if(--num_spans == 0) break;
+                ++span_iterator;
+            }
+            m_scanlines.add(sl_this);
+        }
+
+
+        //---------------------------------------------------------------
+        // Iterate scanlines interface
+        int min_x() const { return m_min_x; }
+        int min_y() const { return m_min_y; }
+        int max_x() const { return m_max_x; }
+        int max_y() const { return m_max_y; }
+
+        //---------------------------------------------------------------
+        bool rewind_scanlines()
+        {
+            m_cur_scanline = 0;
+            return m_scanlines.size() > 0;
+        }
+
+
+        //---------------------------------------------------------------
+        template<class Scanline> bool sweep_scanline(Scanline& sl)
+        {
+            sl.reset_spans();
+            for(;;)
+            {
+                if(m_cur_scanline >= m_scanlines.size()) return false;
+                const scanline_data& sl_this = m_scanlines[m_cur_scanline];
+
+                unsigned num_spans = sl_this.num_spans;
+                unsigned span_idx  = sl_this.start_span;
+                do
+                {
+                    const span_data& sp = m_spans[span_idx++];
+                    const T* covers = covers_by_index(sp.covers_id);
+                    if(sp.len < 0)
+                    {
+                        sl.add_span(sp.x, unsigned(-sp.len), *covers);
+                    }
+                    else
+                    {
+                        sl.add_cells(sp.x, sp.len, covers);
+                    }
+                }
+                while(--num_spans);
+                ++m_cur_scanline;
+                if(sl.num_spans())
+                {
+                    sl.finalize(sl_this.y);
+                    break;
+                }
+            }
+            return true;
+        }
+
+
+        //---------------------------------------------------------------
+        // Specialization for embedded_scanline
+        bool sweep_scanline(embedded_scanline& sl)
+        {
+            do
+            {
+                if(m_cur_scanline >= m_scanlines.size()) return false;
+                sl.init(m_cur_scanline);
+                ++m_cur_scanline;
+            }
+            while(sl.num_spans() == 0);
+            return true;
+        }
+
+        //---------------------------------------------------------------
+        unsigned byte_size() const
+        {
+            unsigned i;
+            unsigned size = sizeof(int32) * 4; // min_x, min_y, max_x, max_y
+
+            for(i = 0; i < m_scanlines.size(); ++i)
+            {
+                size += sizeof(int32) * 3; // scanline size in bytes, Y, num_spans
+
+                const scanline_data& sl_this = m_scanlines[i];
+
+                unsigned num_spans = sl_this.num_spans;
+                unsigned span_idx  = sl_this.start_span;
+                do
+                {
+                    const span_data& sp = m_spans[span_idx++];
+
+                    size += sizeof(int32) * 2;                // X, span_len
+                    if(sp.len < 0)
+                    {
+                        size += sizeof(T);                    // cover
+                    }
+                    else
+                    {
+                        size += sizeof(T) * unsigned(sp.len); // covers
+                    }
+                }
+                while(--num_spans);
+            }
+            return size;
+        }
+
+
+        //---------------------------------------------------------------
+        static void write_int32(int8u* dst, int32 val)
+        {
+            dst[0] = ((const int8u*)&val)[0];
+            dst[1] = ((const int8u*)&val)[1];
+            dst[2] = ((const int8u*)&val)[2];
+            dst[3] = ((const int8u*)&val)[3];
+        }
+
+
+        //---------------------------------------------------------------
+        void serialize(int8u* data) const
+        {
+            unsigned i;
+
+            write_int32(data, min_x()); // min_x
+            data += sizeof(int32);
+            write_int32(data, min_y()); // min_y
+            data += sizeof(int32);
+            write_int32(data, max_x()); // max_x
+            data += sizeof(int32);
+            write_int32(data, max_y()); // max_y
+            data += sizeof(int32);
+
+            for(i = 0; i < m_scanlines.size(); ++i)
+            {
+                const scanline_data& sl_this = m_scanlines[i];
+                
+                int8u* size_ptr = data;
+                data += sizeof(int32);  // Reserve space for scanline size in bytes
+
+                write_int32(data, sl_this.y);            // Y
+                data += sizeof(int32);
+
+                write_int32(data, sl_this.num_spans);    // num_spans
+                data += sizeof(int32);
+
+                unsigned num_spans = sl_this.num_spans;
+                unsigned span_idx  = sl_this.start_span;
+                do
+                {
+                    const span_data& sp = m_spans[span_idx++];
+                    const T* covers = covers_by_index(sp.covers_id);
+
+                    write_int32(data, sp.x);            // X
+                    data += sizeof(int32);
+
+                    write_int32(data, sp.len);          // span_len
+                    data += sizeof(int32);
+
+                    if(sp.len < 0)
+                    {
+                        memcpy(data, covers, sizeof(T));
+                        data += sizeof(T);
+                    }
+                    else
+                    {
+                        memcpy(data, covers, unsigned(sp.len) * sizeof(T));
+                        data += sizeof(T) * unsigned(sp.len);
+                    }
+                }
+                while(--num_spans);
+                write_int32(size_ptr, int32(unsigned(data - size_ptr)));
+            }
+        }
+
+
+        //---------------------------------------------------------------
+        const scanline_data& scanline_by_index(unsigned i) const
+        {
+            return (i < m_scanlines.size()) ? m_scanlines[i] : m_fake_scanline;
+        }
+
+        //---------------------------------------------------------------
+        const span_data& span_by_index(unsigned i) const
+        {
+            return (i < m_spans.size()) ? m_spans[i] : m_fake_span;
+        }
+
+        //---------------------------------------------------------------
+        const T* covers_by_index(int i) const
+        {
+            return m_covers[i];
+        }
+
+    private:
+        scanline_cell_storage<T>      m_covers;
+        pod_bvector<span_data, 10>    m_spans;
+        pod_bvector<scanline_data, 8> m_scanlines;
+        span_data     m_fake_span;
+        scanline_data m_fake_scanline;
+        int           m_min_x;
+        int           m_min_y;
+        int           m_max_x;
+        int           m_max_y;
+        unsigned      m_cur_scanline;
+    };
+
+
+    typedef scanline_storage_aa<int8u>  scanline_storage_aa8;  //--------scanline_storage_aa8
+    typedef scanline_storage_aa<int16u> scanline_storage_aa16; //--------scanline_storage_aa16
+    typedef scanline_storage_aa<int32u> scanline_storage_aa32; //--------scanline_storage_aa32
+
+
+
+
+    //------------------------------------------serialized_scanlines_adaptor_aa
+    template<class T> class serialized_scanlines_adaptor_aa
+    {
+    public:
+        typedef T cover_type;
+
+        //---------------------------------------------------------------------
+        class embedded_scanline
+        {
+        public:
+            typedef T cover_type;
+
+            //-----------------------------------------------------------------
+            class const_iterator
+            {
+            public:
+                struct span
+                {
+                    int32    x;
+                    int32    len; // If negative, it's a solid span, "covers" is valid
+                    const T* covers; 
+                };
+
+                const_iterator() : m_ptr(0) {}
+                const_iterator(const embedded_scanline& sl) :
+                    m_ptr(sl.m_ptr),
+                    m_dx(sl.m_dx)
+                {
+                    init_span();
+                }
+
+                const span& operator*()  const { return m_span;  }
+                const span* operator->() const { return &m_span; }
+
+                void operator ++ ()
+                {
+                    if(m_span.len < 0) 
+                    {
+                        m_ptr += sizeof(T);
+                    }
+                    else 
+                    {
+                        m_ptr += m_span.len * sizeof(T);
+                    }
+                    init_span();
+                }
+
+            private:
+                int read_int32()
+                {
+                    int32 val;
+                    ((int8u*)&val)[0] = *m_ptr++;
+                    ((int8u*)&val)[1] = *m_ptr++;
+                    ((int8u*)&val)[2] = *m_ptr++;
+                    ((int8u*)&val)[3] = *m_ptr++;
+                    return val;
+                }
+
+                void init_span()
+                {
+                    m_span.x      = read_int32() + m_dx;
+                    m_span.len    = read_int32();
+                    m_span.covers = m_ptr;
+                }
+
+                const int8u* m_ptr;
+                span         m_span;
+                int          m_dx;
+            };
+
+            friend class const_iterator;
+
+
+            //-----------------------------------------------------------------
+            embedded_scanline() = default;
+
+            //-----------------------------------------------------------------
+            void     reset(int, int)     {}
+            unsigned num_spans()   const { return m_num_spans;  }
+            int      y()           const { return m_y;          }
+            const_iterator begin() const { return const_iterator(*this); }
+
+
+        private:
+            //-----------------------------------------------------------------
+            int read_int32()
+            {
+                int32 val;
+                ((int8u*)&val)[0] = *m_ptr++;
+                ((int8u*)&val)[1] = *m_ptr++;
+                ((int8u*)&val)[2] = *m_ptr++;
+                ((int8u*)&val)[3] = *m_ptr++;
+                return val;
+            }
+
+        public:
+            //-----------------------------------------------------------------
+            void init(const int8u* ptr, int dx, int dy)
+            {
+                m_ptr       = ptr;
+                m_y         = read_int32() + dy;
+                m_num_spans = unsigned(read_int32());
+                m_dx        = dx;
+            }
+
+        private:
+            const int8u* m_ptr = nullptr;
+            int          m_y = 0;
+            unsigned     m_num_spans = 0;
+            int          m_dx = 0;
+        };
+
+
+
+    public:
+        //--------------------------------------------------------------------
+        serialized_scanlines_adaptor_aa() :
+            m_data(0),
+            m_end(0),
+            m_ptr(0),
+            m_dx(0),
+            m_dy(0),
+            m_min_x(0x7FFFFFFF),
+            m_min_y(0x7FFFFFFF),
+            m_max_x(-0x7FFFFFFF),
+            m_max_y(-0x7FFFFFFF)
+        {}
+
+        //--------------------------------------------------------------------
+        serialized_scanlines_adaptor_aa(const int8u* data, unsigned size,
+                                        double dx, double dy) :
+            m_data(data),
+            m_end(data + size),
+            m_ptr(data),
+            m_dx(iround(dx)),
+            m_dy(iround(dy)),
+            m_min_x(0x7FFFFFFF),
+            m_min_y(0x7FFFFFFF),
+            m_max_x(-0x7FFFFFFF),
+            m_max_y(-0x7FFFFFFF)
+        {}
+
+        //--------------------------------------------------------------------
+        void init(const int8u* data, unsigned size, double dx, double dy)
+        {
+            m_data  = data;
+            m_end   = data + size;
+            m_ptr   = data;
+            m_dx    = iround(dx);
+            m_dy    = iround(dy);
+            m_min_x = 0x7FFFFFFF;
+            m_min_y = 0x7FFFFFFF;
+            m_max_x = -0x7FFFFFFF;
+            m_max_y = -0x7FFFFFFF;
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        int read_int32()
+        {
+            int32 val;
+            ((int8u*)&val)[0] = *m_ptr++;
+            ((int8u*)&val)[1] = *m_ptr++;
+            ((int8u*)&val)[2] = *m_ptr++;
+            ((int8u*)&val)[3] = *m_ptr++;
+            return val;
+        }
+
+        //--------------------------------------------------------------------
+        unsigned read_int32u()
+        {
+            int32u val;
+            ((int8u*)&val)[0] = *m_ptr++;
+            ((int8u*)&val)[1] = *m_ptr++;
+            ((int8u*)&val)[2] = *m_ptr++;
+            ((int8u*)&val)[3] = *m_ptr++;
+            return val;
+        }
+        
+    public:
+        // Iterate scanlines interface
+        //--------------------------------------------------------------------
+        bool rewind_scanlines()
+        {
+            m_ptr = m_data;
+            if(m_ptr < m_end)
+            {
+                m_min_x = read_int32() + m_dx; 
+                m_min_y = read_int32() + m_dy;
+                m_max_x = read_int32() + m_dx;
+                m_max_y = read_int32() + m_dy;
+            }
+            return m_ptr < m_end;
+        }
+
+        //--------------------------------------------------------------------
+        int min_x() const { return m_min_x; }
+        int min_y() const { return m_min_y; }
+        int max_x() const { return m_max_x; }
+        int max_y() const { return m_max_y; }
+
+        //--------------------------------------------------------------------
+        template<class Scanline> bool sweep_scanline(Scanline& sl)
+        {
+            sl.reset_spans();
+            for(;;)
+            {
+                if(m_ptr >= m_end) return false;
+
+                read_int32();      // Skip scanline size in bytes
+                int y = read_int32() + m_dy;
+                unsigned num_spans = read_int32();
+
+                do
+                {
+                    int x = read_int32() + m_dx;
+                    int len = read_int32();
+
+                    if(len < 0)
+                    {
+                        sl.add_span(x, unsigned(-len), *m_ptr);
+                        m_ptr += sizeof(T);
+                    }
+                    else
+                    {
+                        sl.add_cells(x, len, m_ptr);
+                        m_ptr += len * sizeof(T);
+                    }
+                }
+                while(--num_spans);
+
+                if(sl.num_spans())
+                {
+                    sl.finalize(y);
+                    break;
+                }
+            }
+            return true;
+        }
+
+
+        //--------------------------------------------------------------------
+        // Specialization for embedded_scanline
+        bool sweep_scanline(embedded_scanline& sl)
+        {
+            do
+            {
+                if(m_ptr >= m_end) return false;
+
+                unsigned byte_size = read_int32u();
+                sl.init(m_ptr, m_dx, m_dy);
+                m_ptr += byte_size - sizeof(int32);
+            }
+            while(sl.num_spans() == 0);
+            return true;
+        }
+
+    private:
+        const int8u* m_data;
+        const int8u* m_end;
+        const int8u* m_ptr;
+        int          m_dx;
+        int          m_dy;
+        int          m_min_x;
+        int          m_min_y;
+        int          m_max_x;
+        int          m_max_y;
+    };
+
+
+
+    typedef serialized_scanlines_adaptor_aa<int8u>  serialized_scanlines_adaptor_aa8;  //----serialized_scanlines_adaptor_aa8
+    typedef serialized_scanlines_adaptor_aa<int16u> serialized_scanlines_adaptor_aa16; //----serialized_scanlines_adaptor_aa16
+    typedef serialized_scanlines_adaptor_aa<int32u> serialized_scanlines_adaptor_aa32; //----serialized_scanlines_adaptor_aa32
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_scanline_storage_bin.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_storage_bin.h
--- 8.0.1-5/src/renderers/agg/include/agg_scanline_storage_bin.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_storage_bin.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,586 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+
+#ifndef AGG_SCANLINE_STORAGE_BIN_INCLUDED
+#define AGG_SCANLINE_STORAGE_BIN_INCLUDED
+
+#include <string.h>
+#include <stdlib.h>
+#include <math.h>
+#include "agg_array.h"
+
+
+namespace mapserver
+{
+
+    //-----------------------------------------------scanline_storage_bin
+    class scanline_storage_bin
+    {
+    public:
+        //---------------------------------------------------------------
+        struct span_data
+        {
+            int32 x;
+            int32 len;
+        };
+
+        //---------------------------------------------------------------
+        struct scanline_data
+        {
+            int      y;
+            unsigned num_spans;
+            unsigned start_span;
+        };
+
+
+        //---------------------------------------------------------------
+        class embedded_scanline
+        {
+        public:
+
+            //-----------------------------------------------------------
+            class const_iterator
+            {
+            public:
+                const_iterator() : m_storage(0) {}
+                const_iterator(const embedded_scanline& sl) :
+                    m_storage(sl.m_storage),
+                    m_span_idx(sl.m_scanline.start_span)
+                {
+                    m_span = m_storage->span_by_index(m_span_idx);
+                }
+
+                const span_data& operator*()  const { return m_span;  }
+                const span_data* operator->() const { return &m_span; }
+
+                void operator ++ ()
+                {
+                    ++m_span_idx;
+                    m_span = m_storage->span_by_index(m_span_idx);
+                }
+
+            private:
+                const scanline_storage_bin* m_storage;
+                unsigned                    m_span_idx;
+                span_data                   m_span;
+            };
+
+            friend class const_iterator;
+
+
+            //-----------------------------------------------------------
+            embedded_scanline(const scanline_storage_bin& storage) :
+                m_storage(&storage)
+            {
+                setup(0);
+            }
+
+            //-----------------------------------------------------------
+            void     reset(int, int)     {}
+            unsigned num_spans()   const { return m_scanline.num_spans;  }
+            int      y()           const { return m_scanline.y;          }
+            const_iterator begin() const { return const_iterator(*this); }
+
+            //-----------------------------------------------------------
+            void setup(unsigned scanline_idx)
+            {
+                m_scanline_idx = scanline_idx;
+                m_scanline = m_storage->scanline_by_index(m_scanline_idx);
+            }
+
+        private:
+            const scanline_storage_bin* m_storage;
+            scanline_data               m_scanline;
+            unsigned                    m_scanline_idx;
+        };
+
+
+        //---------------------------------------------------------------
+        scanline_storage_bin() :
+            m_spans(256-2),         // Block increment size
+            m_scanlines(),
+            m_min_x( 0x7FFFFFFF),
+            m_min_y( 0x7FFFFFFF),
+            m_max_x(-0x7FFFFFFF),
+            m_max_y(-0x7FFFFFFF),
+            m_cur_scanline(0)
+        {
+            m_fake_scanline.y = 0;
+            m_fake_scanline.num_spans = 0;
+            m_fake_scanline.start_span = 0;
+            m_fake_span.x = 0;
+            m_fake_span.len = 0;
+        }
+
+        // Renderer Interface
+        //---------------------------------------------------------------
+        void prepare()
+        {
+            m_scanlines.remove_all();
+            m_spans.remove_all();
+            m_min_x =  0x7FFFFFFF;
+            m_min_y =  0x7FFFFFFF;
+            m_max_x = -0x7FFFFFFF;
+            m_max_y = -0x7FFFFFFF;
+            m_cur_scanline = 0;
+        }
+
+        //---------------------------------------------------------------
+        template<class Scanline> void render(const Scanline& sl)
+        {
+            scanline_data sl_this;
+
+            int y = sl.y();
+            if(y < m_min_y) m_min_y = y;
+            if(y > m_max_y) m_max_y = y;
+
+            sl_this.y = y;
+            sl_this.num_spans = sl.num_spans();
+            sl_this.start_span = m_spans.size();
+            typename Scanline::const_iterator span_iterator = sl.begin();
+
+            unsigned num_spans = sl_this.num_spans;
+            for(;;)
+            {
+                span_data sp;
+                sp.x   = span_iterator->x;
+                sp.len = (int32)abs((int)(span_iterator->len));
+                m_spans.add(sp);
+                int x1 = sp.x;
+                int x2 = sp.x + sp.len - 1;
+                if(x1 < m_min_x) m_min_x = x1;
+                if(x2 > m_max_x) m_max_x = x2;
+                if(--num_spans == 0) break;
+                ++span_iterator;
+            }
+            m_scanlines.add(sl_this);
+        }
+
+
+        //---------------------------------------------------------------
+        // Iterate scanlines interface
+        int min_x() const { return m_min_x; }
+        int min_y() const { return m_min_y; }
+        int max_x() const { return m_max_x; }
+        int max_y() const { return m_max_y; }
+
+        //---------------------------------------------------------------
+        bool rewind_scanlines()
+        {
+            m_cur_scanline = 0;
+            return m_scanlines.size() > 0;
+        }
+
+
+        //---------------------------------------------------------------
+        template<class Scanline> bool sweep_scanline(Scanline& sl)
+        {
+            sl.reset_spans();
+            for(;;)
+            {
+                if(m_cur_scanline >= m_scanlines.size()) return false;
+                const scanline_data& sl_this = m_scanlines[m_cur_scanline];
+
+                unsigned num_spans = sl_this.num_spans;
+                unsigned span_idx  = sl_this.start_span;
+                do
+                {
+                    const span_data& sp = m_spans[span_idx++];
+                    sl.add_span(sp.x, sp.len, cover_full);
+                }
+                while(--num_spans);
+
+                ++m_cur_scanline;
+                if(sl.num_spans())
+                {
+                    sl.finalize(sl_this.y);
+                    break;
+                }
+            }
+            return true;
+        }
+
+
+        //---------------------------------------------------------------
+        // Specialization for embedded_scanline
+        bool sweep_scanline(embedded_scanline& sl)
+        {
+            do
+            {
+                if(m_cur_scanline >= m_scanlines.size()) return false;
+                sl.setup(m_cur_scanline);
+                ++m_cur_scanline;
+            }
+            while(sl.num_spans() == 0);
+            return true;
+        }
+
+
+        //---------------------------------------------------------------
+        unsigned byte_size() const
+        {
+            unsigned i;
+            unsigned size = sizeof(int32) * 4; // min_x, min_y, max_x, max_y
+
+            for(i = 0; i < m_scanlines.size(); ++i)
+            {
+                size += sizeof(int32) * 2 + // Y, num_spans
+                        unsigned(m_scanlines[i].num_spans) * sizeof(int32) * 2; // X, span_len
+            }
+            return size;
+        }
+
+
+        //---------------------------------------------------------------
+        static void write_int32(int8u* dst, int32 val)
+        {
+            dst[0] = ((const int8u*)&val)[0];
+            dst[1] = ((const int8u*)&val)[1];
+            dst[2] = ((const int8u*)&val)[2];
+            dst[3] = ((const int8u*)&val)[3];
+        }
+
+
+        //---------------------------------------------------------------
+        void serialize(int8u* data) const
+        {
+            unsigned i;
+
+            write_int32(data, min_x()); // min_x
+            data += sizeof(int32);
+            write_int32(data, min_y()); // min_y
+            data += sizeof(int32);
+            write_int32(data, max_x()); // max_x
+            data += sizeof(int32);
+            write_int32(data, max_y()); // max_y
+            data += sizeof(int32);
+
+            for(i = 0; i < m_scanlines.size(); ++i)
+            {
+                const scanline_data& sl_this = m_scanlines[i];
+
+                write_int32(data, sl_this.y);            // Y
+                data += sizeof(int32);
+
+                write_int32(data, sl_this.num_spans);    // num_spans
+                data += sizeof(int32);
+
+                unsigned num_spans = sl_this.num_spans;
+                unsigned span_idx  = sl_this.start_span;
+                do
+                {
+                    const span_data& sp = m_spans[span_idx++];
+
+                    write_int32(data, sp.x);             // X
+                    data += sizeof(int32);
+
+                    write_int32(data, sp.len);           // len
+                    data += sizeof(int32);
+                }
+                while(--num_spans);
+            }
+        }
+
+
+        //---------------------------------------------------------------
+        const scanline_data& scanline_by_index(unsigned i) const
+        {
+            return (i < m_scanlines.size()) ? m_scanlines[i] : m_fake_scanline;
+        }
+
+        //---------------------------------------------------------------
+        const span_data& span_by_index(unsigned i) const
+        {
+            return (i < m_spans.size()) ? m_spans[i] : m_fake_span;
+        }
+
+
+    private:
+        pod_bvector<span_data, 10>    m_spans;
+        pod_bvector<scanline_data, 8> m_scanlines;
+        span_data     m_fake_span;
+        scanline_data m_fake_scanline;
+        int           m_min_x;
+        int           m_min_y;
+        int           m_max_x;
+        int           m_max_y;
+        unsigned      m_cur_scanline;
+    };
+
+
+
+
+
+
+
+
+
+
+
+
+
+    //---------------------------------------serialized_scanlines_adaptor_bin
+    class serialized_scanlines_adaptor_bin
+    {
+    public:
+        typedef bool cover_type;
+
+        //--------------------------------------------------------------------
+        class embedded_scanline
+        {
+        public:
+
+            //----------------------------------------------------------------
+            class const_iterator
+            {
+            public:
+                struct span
+                {
+                    int32 x;
+                    int32 len;
+                };
+
+                const_iterator() : m_ptr(0) {}
+                const_iterator(const embedded_scanline& sl) :
+                    m_ptr(sl.m_ptr),
+                    m_dx(sl.m_dx)
+                {
+                    m_span.x   = read_int32() + m_dx;
+                    m_span.len = read_int32();
+                }
+
+                const span& operator*()  const { return m_span;  }
+                const span* operator->() const { return &m_span; }
+
+                void operator ++ ()
+                {
+                    m_span.x   = read_int32() + m_dx;
+                    m_span.len = read_int32();
+                }
+
+            private:
+                int read_int32()
+                {
+                    int32 val;
+                    ((int8u*)&val)[0] = *m_ptr++;
+                    ((int8u*)&val)[1] = *m_ptr++;
+                    ((int8u*)&val)[2] = *m_ptr++;
+                    ((int8u*)&val)[3] = *m_ptr++;
+                    return val;
+                }
+
+                const int8u* m_ptr;
+                span         m_span;
+                int          m_dx;
+            };
+
+            friend class const_iterator;
+
+
+            //----------------------------------------------------------------
+            embedded_scanline() = default;
+
+            //----------------------------------------------------------------
+            void     reset(int, int)     {}
+            unsigned num_spans()   const { return m_num_spans;  }
+            int      y()           const { return m_y;          }
+            const_iterator begin() const { return const_iterator(*this); }
+
+
+        private:
+            //----------------------------------------------------------------
+            int read_int32()
+            {
+                int32 val;
+                ((int8u*)&val)[0] = *m_ptr++;
+                ((int8u*)&val)[1] = *m_ptr++;
+                ((int8u*)&val)[2] = *m_ptr++;
+                ((int8u*)&val)[3] = *m_ptr++;
+                return val;
+            }
+
+        public:
+            //----------------------------------------------------------------
+            void init(const int8u* ptr, int dx, int dy)
+            {
+                m_ptr       = ptr;
+                m_y         = read_int32() + dy;
+                m_num_spans = unsigned(read_int32());
+                m_dx        = dx;
+            }
+
+        private:
+            const int8u* m_ptr = nullptr;
+            int          m_y = 0;
+            unsigned     m_num_spans = 0;
+            int          m_dx = 0;
+        };
+
+
+
+    public:
+        //--------------------------------------------------------------------
+        serialized_scanlines_adaptor_bin() :
+            m_data(0),
+            m_end(0),
+            m_ptr(0),
+            m_dx(0),
+            m_dy(0),
+            m_min_x(0x7FFFFFFF),
+            m_min_y(0x7FFFFFFF),
+            m_max_x(-0x7FFFFFFF),
+            m_max_y(-0x7FFFFFFF)
+        {}
+
+        //--------------------------------------------------------------------
+        serialized_scanlines_adaptor_bin(const int8u* data, unsigned size,
+                                         double dx, double dy) :
+            m_data(data),
+            m_end(data + size),
+            m_ptr(data),
+            m_dx(iround(dx)),
+            m_dy(iround(dy)),
+            m_min_x(0x7FFFFFFF),
+            m_min_y(0x7FFFFFFF),
+            m_max_x(-0x7FFFFFFF),
+            m_max_y(-0x7FFFFFFF)
+        {}
+
+        //--------------------------------------------------------------------
+        void init(const int8u* data, unsigned size, double dx, double dy)
+        {
+            m_data  = data;
+            m_end   = data + size;
+            m_ptr   = data;
+            m_dx    = iround(dx);
+            m_dy    = iround(dy);
+            m_min_x = 0x7FFFFFFF;
+            m_min_y = 0x7FFFFFFF;
+            m_max_x = -0x7FFFFFFF;
+            m_max_y = -0x7FFFFFFF;
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        int read_int32()
+        {
+            int32 val;
+            ((int8u*)&val)[0] = *m_ptr++;
+            ((int8u*)&val)[1] = *m_ptr++;
+            ((int8u*)&val)[2] = *m_ptr++;
+            ((int8u*)&val)[3] = *m_ptr++;
+            return val;
+        }
+       
+    public:
+        // Iterate scanlines interface
+        //--------------------------------------------------------------------
+        bool rewind_scanlines()
+        {
+            m_ptr = m_data;
+            if(m_ptr < m_end)
+            {
+                m_min_x = read_int32() + m_dx; 
+                m_min_y = read_int32() + m_dy;
+                m_max_x = read_int32() + m_dx;
+                m_max_y = read_int32() + m_dy;
+            }
+            return m_ptr < m_end;
+        }
+
+        //--------------------------------------------------------------------
+        int min_x() const { return m_min_x; }
+        int min_y() const { return m_min_y; }
+        int max_x() const { return m_max_x; }
+        int max_y() const { return m_max_y; }
+
+        //--------------------------------------------------------------------
+        template<class Scanline> bool sweep_scanline(Scanline& sl)
+        {
+            sl.reset_spans();
+            for(;;)
+            {
+                if(m_ptr >= m_end) return false;
+
+                int y = read_int32() + m_dy;
+                unsigned num_spans = read_int32();
+
+                do
+                {
+                    int x = read_int32() + m_dx;
+                    int len = read_int32();
+
+                    if(len < 0) len = -len;
+                    sl.add_span(x, unsigned(len), cover_full);
+                }
+                while(--num_spans);
+
+                if(sl.num_spans())
+                {
+                    sl.finalize(y);
+                    break;
+                }
+            }
+            return true;
+        }
+
+
+        //--------------------------------------------------------------------
+        // Specialization for embedded_scanline
+        bool sweep_scanline(embedded_scanline& sl)
+        {
+            do
+            {
+                if(m_ptr >= m_end) return false;
+
+                sl.init(m_ptr, m_dx, m_dy);
+
+                // Jump to the next scanline
+                //--------------------------
+                read_int32();                    // Y
+                int num_spans = read_int32();    // num_spans
+                m_ptr += num_spans * sizeof(int32) * 2;
+            }
+            while(sl.num_spans() == 0);
+            return true;
+        }
+
+    private:
+        const int8u* m_data;
+        const int8u* m_end;
+        const int8u* m_ptr;
+        int          m_dx;
+        int          m_dy;
+        int          m_min_x;
+        int          m_min_y;
+        int          m_max_x;
+        int          m_max_y;
+    };
+
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_scanline_u.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_u.h
--- 8.0.1-5/src/renderers/agg/include/agg_scanline_u.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_scanline_u.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,499 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for 32-bit screen coordinates (scanline32_u) has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SCANLINE_U_INCLUDED
+#define AGG_SCANLINE_U_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+    //=============================================================scanline_u8
+    //
+    // Unpacked scanline container class
+    //
+    // This class is used to transfer data from a scanline rasterizer 
+    // to the rendering buffer. It's organized very simple. The class stores 
+    // information of horizontal spans to render it into a pixel-map buffer. 
+    // Each span has staring X, length, and an array of bytes that determine the 
+    // cover-values for each pixel. 
+    // Before using this class you should know the minimal and maximal pixel 
+    // coordinates of your scanline. The protocol of using is:
+    // 1. reset(min_x, max_x)
+    // 2. add_cell() / add_span() - accumulate scanline. 
+    //    When forming one scanline the next X coordinate must be always greater
+    //    than the last stored one, i.e. it works only with ordered coordinates.
+    // 3. Call finalize(y) and render the scanline.
+    // 3. Call reset_spans() to prepare for the new scanline.
+    //    
+    // 4. Rendering:
+    // 
+    // Scanline provides an iterator class that allows you to extract
+    // the spans and the cover values for each pixel. Be aware that clipping
+    // has not been done yet, so you should perform it yourself.
+    // Use scanline_u8::iterator to render spans:
+    //-------------------------------------------------------------------------
+    //
+    // int y = sl.y();                    // Y-coordinate of the scanline
+    //
+    // ************************************
+    // ...Perform vertical clipping here...
+    // ************************************
+    //
+    // scanline_u8::const_iterator span = sl.begin();
+    // 
+    // unsigned char* row = m_rbuf->row(y); // The the address of the beginning 
+    //                                      // of the current row
+    // 
+    // unsigned num_spans = sl.num_spans(); // Number of spans. It's guaranteed that
+    //                                      // num_spans is always greater than 0.
+    //
+    // do
+    // {
+    //     const scanline_u8::cover_type* covers =
+    //         span->covers;                     // The array of the cover values
+    //
+    //     int num_pix = span->len;              // Number of pixels of the span.
+    //                                           // Always greater than 0, still it's
+    //                                           // better to use "int" instead of 
+    //                                           // "unsigned" because it's more
+    //                                           // convenient for clipping
+    //     int x = span->x;
+    //
+    //     **************************************
+    //     ...Perform horizontal clipping here...
+    //     ...you have x, covers, and pix_count..
+    //     **************************************
+    //
+    //     unsigned char* dst = row + x;  // Calculate the start address of the row.
+    //                                    // In this case we assume a simple 
+    //                                    // grayscale image 1-byte per pixel.
+    //     do
+    //     {
+    //         *dst++ = *covers++;        // Hypotetical rendering. 
+    //     }
+    //     while(--num_pix);
+    //
+    //     ++span;
+    // } 
+    // while(--num_spans);  // num_spans cannot be 0, so this loop is quite safe
+    //------------------------------------------------------------------------
+    //
+    // The question is: why should we accumulate the whole scanline when we
+    // could render just separate spans when they're ready?
+    // That's because using the scanline is generally faster. When is consists 
+    // of more than one span the conditions for the processor cash system
+    // are better, because switching between two different areas of memory 
+    // (that can be very large) occurs less frequently.
+    //------------------------------------------------------------------------
+    class scanline_u8
+    {
+    public:
+        typedef scanline_u8 self_type;
+        typedef int8u       cover_type;
+        typedef int16       coord_type;
+
+        //--------------------------------------------------------------------
+        struct span
+        {
+            coord_type  x;
+            coord_type  len;
+            cover_type* covers;
+        };
+
+        typedef span* iterator;
+        typedef const span* const_iterator;
+
+        //--------------------------------------------------------------------
+        scanline_u8() :
+            m_min_x(0),
+            m_last_x(0x7FFFFFF0),
+            m_cur_span(0)
+        {}
+
+        //--------------------------------------------------------------------
+        void reset(int min_x, int max_x)
+        {
+            unsigned max_len = max_x - min_x + 2;
+            if(max_len > m_spans.size())
+            {
+                m_spans.resize(max_len);
+                m_covers.resize(max_len);
+            }
+            m_last_x   = 0x7FFFFFF0;
+            m_min_x    = min_x;
+            m_cur_span = &m_spans[0];
+        }
+
+        //--------------------------------------------------------------------
+        void add_cell(int x, unsigned cover)
+        {
+            x -= m_min_x;
+            m_covers[x] = (cover_type)cover;
+            if(x == m_last_x+1)
+            {
+                m_cur_span->len++;
+            }
+            else
+            {
+                m_cur_span++;
+                m_cur_span->x      = (coord_type)(x + m_min_x);
+                m_cur_span->len    = 1;
+                m_cur_span->covers = &m_covers[x];
+            }
+            m_last_x = x;
+        }
+
+        //--------------------------------------------------------------------
+        void add_cells(int x, unsigned len, const cover_type* covers)
+        {
+            x -= m_min_x;
+            memcpy(&m_covers[x], covers, len * sizeof(cover_type));
+            if(x == m_last_x+1)
+            {
+                m_cur_span->len += (coord_type)len;
+            }
+            else
+            {
+                m_cur_span++;
+                m_cur_span->x      = (coord_type)(x + m_min_x);
+                m_cur_span->len    = (coord_type)len;
+                m_cur_span->covers = &m_covers[x];
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void add_span(int x, unsigned len, unsigned cover)
+        {
+            x -= m_min_x;
+            memset(&m_covers[x], cover, len);
+            if(x == m_last_x+1)
+            {
+                m_cur_span->len += (coord_type)len;
+            }
+            else
+            {
+                m_cur_span++;
+                m_cur_span->x      = (coord_type)(x + m_min_x);
+                m_cur_span->len    = (coord_type)len;
+                m_cur_span->covers = &m_covers[x];
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void finalize(int y) 
+        { 
+            m_y = y; 
+        }
+
+        //--------------------------------------------------------------------
+        void reset_spans()
+        {
+            m_last_x    = 0x7FFFFFF0;
+            m_cur_span  = &m_spans[0];
+        }
+
+        //--------------------------------------------------------------------
+        int      y()           const { return m_y; }
+        unsigned num_spans()   const { return unsigned(m_cur_span - &m_spans[0]); }
+        const_iterator begin() const { return &m_spans[1]; }
+        iterator       begin()       { return &m_spans[1]; }
+
+    private:
+        scanline_u8(const self_type&);
+        const self_type& operator = (const self_type&);
+
+    private:
+        int                   m_min_x;
+        int                   m_last_x;
+        int                   m_y = 0;
+        pod_array<cover_type> m_covers;
+        pod_array<span>       m_spans;
+        span*                 m_cur_span;
+    };
+
+
+
+
+    //==========================================================scanline_u8_am
+    // 
+    // The scanline container with alpha-masking
+    // 
+    //------------------------------------------------------------------------
+    template<class AlphaMask> 
+    class scanline_u8_am : public scanline_u8
+    {
+    public:
+        typedef scanline_u8           base_type;
+        typedef AlphaMask             alpha_mask_type;
+        typedef base_type::cover_type cover_type;
+        typedef base_type::coord_type coord_type;
+
+        scanline_u8_am() : base_type(), m_alpha_mask(0) {}
+        scanline_u8_am(const AlphaMask& am) : base_type(), m_alpha_mask(&am) {}
+
+        //--------------------------------------------------------------------
+        void finalize(int span_y)
+        {
+            base_type::finalize(span_y);
+            if(m_alpha_mask)
+            {
+                typename base_type::iterator span = base_type::begin();
+                unsigned count = base_type::num_spans();
+                do
+                {
+                    m_alpha_mask->combine_hspan(span->x, 
+                                                base_type::y(), 
+                                                span->covers, 
+                                                span->len);
+                    ++span;
+                }
+                while(--count);
+            }
+        }
+
+    private:
+        const AlphaMask* m_alpha_mask;
+    };
+
+
+
+
+    //===========================================================scanline32_u8
+    class scanline32_u8
+    {
+    public:
+        typedef scanline32_u8 self_type;
+        typedef int8u         cover_type;
+        typedef int32         coord_type;
+
+        //--------------------------------------------------------------------
+        struct span
+        {
+            span() {}
+            span(coord_type x_, coord_type len_, cover_type* covers_) :
+                x(x_), len(len_), covers(covers_) {}
+
+            coord_type  x;
+            coord_type  len;
+            cover_type* covers;
+        };
+
+        typedef pod_bvector<span, 4> span_array_type;
+
+        //--------------------------------------------------------------------
+        class const_iterator
+        {
+        public:
+            const_iterator(const span_array_type& spans) :
+                m_spans(spans),
+                m_span_idx(0)
+            {}
+
+            const span& operator*()  const { return m_spans[m_span_idx];  }
+            const span* operator->() const { return &m_spans[m_span_idx]; }
+
+            void operator ++ () { ++m_span_idx; }
+
+        private:
+            const span_array_type& m_spans;
+            unsigned               m_span_idx;
+        };
+
+        //--------------------------------------------------------------------
+        class iterator
+        {
+        public:
+            iterator(span_array_type& spans) :
+                m_spans(spans),
+                m_span_idx(0)
+            {}
+
+            span& operator*()  { return m_spans[m_span_idx];  }
+            span* operator->() { return &m_spans[m_span_idx]; }
+
+            void operator ++ () { ++m_span_idx; }
+
+        private:
+            span_array_type& m_spans;
+            unsigned         m_span_idx;
+        };
+
+
+
+        //--------------------------------------------------------------------
+        scanline32_u8() :
+            m_min_x(0),
+            m_last_x(0x7FFFFFF0),
+            m_covers()
+        {}
+
+        //--------------------------------------------------------------------
+        void reset(int min_x, int max_x)
+        {
+            unsigned max_len = max_x - min_x + 2;
+            if(max_len > m_covers.size())
+            {
+                m_covers.resize(max_len);
+            }
+            m_last_x = 0x7FFFFFF0;
+            m_min_x  = min_x;
+            m_spans.remove_all();
+        }
+
+        //--------------------------------------------------------------------
+        void add_cell(int x, unsigned cover)
+        {
+            x -= m_min_x;
+            m_covers[x] = cover_type(cover);
+            if(x == m_last_x+1)
+            {
+                m_spans.last().len++;
+            }
+            else
+            {
+                m_spans.add(span(coord_type(x + m_min_x), 1, &m_covers[x]));
+            }
+            m_last_x = x;
+        }
+
+        //--------------------------------------------------------------------
+        void add_cells(int x, unsigned len, const cover_type* covers)
+        {
+            x -= m_min_x;
+            memcpy(&m_covers[x], covers, len * sizeof(cover_type));
+            if(x == m_last_x+1)
+            {
+                m_spans.last().len += coord_type(len);
+            }
+            else
+            {
+                m_spans.add(span(coord_type(x + m_min_x), 
+                                 coord_type(len), 
+                                 &m_covers[x]));
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void add_span(int x, unsigned len, unsigned cover)
+        {
+            x -= m_min_x;
+            memset(&m_covers[x], cover, len);
+            if(x == m_last_x+1)
+            {
+                m_spans.last().len += coord_type(len);
+            }
+            else
+            {
+                m_spans.add(span(coord_type(x + m_min_x), 
+                                 coord_type(len), 
+                                 &m_covers[x]));
+            }
+            m_last_x = x + len - 1;
+        }
+
+        //--------------------------------------------------------------------
+        void finalize(int y) 
+        { 
+            m_y = y; 
+        }
+
+        //--------------------------------------------------------------------
+        void reset_spans()
+        {
+            m_last_x = 0x7FFFFFF0;
+            m_spans.remove_all();
+        }
+
+        //--------------------------------------------------------------------
+        int      y()           const { return m_y; }
+        unsigned num_spans()   const { return m_spans.size(); }
+        const_iterator begin() const { return const_iterator(m_spans); }
+        iterator       begin()       { return iterator(m_spans); }
+
+    private:
+        scanline32_u8(const self_type&);
+        const self_type& operator = (const self_type&);
+
+    private:
+        int                   m_min_x;
+        int                   m_last_x;
+        int                   m_y;
+        pod_array<cover_type> m_covers;
+        span_array_type       m_spans;
+    };
+
+
+
+
+    //========================================================scanline32_u8_am
+    // 
+    // The scanline container with alpha-masking
+    // 
+    //------------------------------------------------------------------------
+    template<class AlphaMask> 
+        class scanline32_u8_am : public scanline32_u8
+    {
+    public:
+        typedef scanline32_u8         base_type;
+        typedef AlphaMask             alpha_mask_type;
+        typedef base_type::cover_type cover_type;
+        typedef base_type::coord_type coord_type;
+
+
+        scanline32_u8_am() : base_type(), m_alpha_mask(0) {}
+        scanline32_u8_am(const AlphaMask& am) : base_type(), m_alpha_mask(&am) {}
+
+        //--------------------------------------------------------------------
+        void finalize(int span_y)
+        {
+            base_type::finalize(span_y);
+            if(m_alpha_mask)
+            {
+                typename base_type::iterator span = base_type::begin();
+                unsigned count = base_type::num_spans();
+                do
+                {
+                    m_alpha_mask->combine_hspan(span->x, 
+                                                base_type::y(), 
+                                                span->covers, 
+                                                span->len);
+                    ++span;
+                }
+                while(--count);
+            }
+        }
+
+    private:
+        const AlphaMask* m_alpha_mask;
+    };
+
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_shorten_path.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_shorten_path.h
--- 8.0.1-5/src/renderers/agg/include/agg_shorten_path.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_shorten_path.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SHORTEN_PATH_INCLUDED
+#define AGG_SHORTEN_PATH_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vertex_sequence.h"
+
+namespace mapserver
+{
+
+    //===========================================================shorten_path
+    template<class VertexSequence> 
+    void shorten_path(VertexSequence& vs, double s, unsigned closed = 0)
+    {
+        typedef typename VertexSequence::value_type vertex_type;
+
+        if(s > 0.0 && vs.size() > 1)
+        {
+            double d;
+            int n = int(vs.size() - 2);
+            while(n)
+            {
+                d = vs[n].dist;
+                if(d > s) break;
+                vs.remove_last();
+                s -= d;
+                --n;
+            }
+            if(vs.size() < 2)
+            {
+                vs.remove_all();
+            }
+            else
+            {
+                n = vs.size() - 1;
+                vertex_type& prev = vs[n-1];
+                vertex_type& last = vs[n];
+                d = (prev.dist - s) / prev.dist;
+                double x = prev.x + (last.x - prev.x) * d;
+                double y = prev.y + (last.y - prev.y) * d;
+                last.x = x;
+                last.y = y;
+                if(!prev(last)) vs.remove_last();
+                vs.close(closed != 0);
+            }
+        }
+    }
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_simul_eq.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_simul_eq.h
--- 8.0.1-5/src/renderers/agg/include/agg_simul_eq.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_simul_eq.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,147 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Solving simultaneous equations
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_SIMUL_EQ_INCLUDED
+#define AGG_SIMUL_EQ_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //=============================================================swap_arrays
+    template<class T> void swap_arrays(T* a1, T* a2, unsigned n)
+    {
+        unsigned i;
+        for(i = 0; i < n; i++)
+        {
+            T tmp = *a1;
+            *a1++ = *a2;
+            *a2++ = tmp;
+        }
+    }
+
+
+    //============================================================matrix_pivot
+    template<unsigned Rows, unsigned Cols>
+    struct matrix_pivot
+    {
+        static int pivot(double m[Rows][Cols], unsigned row)
+        {
+            int k = int(row);
+            double max_val, tmp;
+
+            max_val = -1.0;
+            unsigned i;
+            for(i = row; i < Rows; i++)
+            {
+                if((tmp = fabs(m[i][row])) > max_val && tmp != 0.0)
+                {
+                    max_val = tmp;
+                    k = i;
+                }
+            }
+
+            if(m[k][row] == 0.0)
+            {
+                return -1;
+            }
+
+            if(k != int(row))
+            {
+                swap_arrays(m[k], m[row], Cols);
+                return k;
+            }
+            return 0;
+        }
+    };
+    
+
+
+    //===============================================================simul_eq
+    template<unsigned Size, unsigned RightCols>
+    struct simul_eq
+    {
+        static bool solve(const double left[Size][Size], 
+                          const double right[Size][RightCols],
+                          double result[Size][RightCols])
+        {
+            unsigned i, j, k;
+            double a1;
+
+            double tmp[Size][Size + RightCols];
+
+            for(i = 0; i < Size; i++)
+            {
+                for(j = 0; j < Size; j++)
+                {
+                    tmp[i][j] = left[i][j];
+                } 
+                for(j = 0; j < RightCols; j++)
+                {
+                    tmp[i][Size + j] = right[i][j];
+                }
+            }
+
+            for(k = 0; k < Size; k++)
+            {
+                if(matrix_pivot<Size, Size + RightCols>::pivot(tmp, k) < 0)
+                {
+                    return false; // Singularity....
+                }
+
+                a1 = tmp[k][k];
+
+                for(j = k; j < Size + RightCols; j++)
+                {
+                    tmp[k][j] /= a1;
+                }
+
+                for(i = k + 1; i < Size; i++)
+                {
+                    a1 = tmp[i][k];
+                    for (j = k; j < Size + RightCols; j++)
+                    {
+                        tmp[i][j] -= a1 * tmp[k][j];
+                    }
+                }
+            }
+
+
+            for(k = 0; k < RightCols; k++)
+            {
+                int m;
+                for(m = int(Size - 1); m >= 0; m--)
+                {
+                    result[m][k] = tmp[m][Size + k];
+                    for(j = m + 1; j < Size; j++)
+                    {
+                        result[m][k] -= tmp[m][j] * result[j][k];
+                    }
+                }
+            }
+            return true;
+        }
+
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_allocator.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_allocator.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_allocator.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_allocator.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,54 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_ALLOCATOR_INCLUDED
+#define AGG_SPAN_ALLOCATOR_INCLUDED
+
+#include "agg_array.h"
+
+namespace mapserver
+{
+    //----------------------------------------------------------span_allocator
+    template<class ColorT> class span_allocator
+    {
+    public:
+        typedef ColorT color_type;
+
+        //--------------------------------------------------------------------
+        AGG_INLINE color_type* allocate(unsigned span_len)
+        {
+            if(span_len > m_span.size())
+            {
+                // To reduce the number of reallocs we align the 
+                // span_len to 256 color elements. 
+                // Well, I just like this number and it looks reasonable.
+                //-----------------------
+                m_span.resize(((span_len + 255) >> 8) << 8);
+            }
+            return &m_span[0];
+        }
+
+        AGG_INLINE color_type* span()               { return &m_span[0]; }
+        AGG_INLINE unsigned    max_span_len() const { return m_span.size(); }
+
+    private:
+        pod_array<color_type> m_span;
+    };
+}
+
+
+#endif
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_converter.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_converter.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_converter.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_converter.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,56 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_CONVERTER_INCLUDED
+#define AGG_SPAN_CONVERTER_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //----------------------------------------------------------span_converter
+    template<class SpanGenerator, class SpanConverter> class span_converter
+    {
+    public:
+        typedef typename SpanGenerator::color_type color_type;
+
+        span_converter(SpanGenerator& span_gen, SpanConverter& span_cnv) : 
+            m_span_gen(&span_gen), m_span_cnv(&span_cnv) {}
+
+        void attach_generator(SpanGenerator& span_gen) { m_span_gen = &span_gen; }
+        void attach_converter(SpanConverter& span_cnv) { m_span_cnv = &span_cnv; }
+
+        //--------------------------------------------------------------------
+        void prepare() 
+        { 
+            m_span_gen->prepare(); 
+            m_span_cnv->prepare();
+        }
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            m_span_gen->generate(span, x, y, len);
+            m_span_cnv->generate(span, x, y, len);
+        }
+
+    private:
+        SpanGenerator* m_span_gen;
+        SpanConverter* m_span_cnv;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_gouraud.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gouraud.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_gouraud.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gouraud.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,172 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_GOURAUD_INCLUDED
+#define AGG_SPAN_GOURAUD_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_math.h"
+
+namespace mapserver
+{
+
+    //============================================================span_gouraud
+    template<class ColorT> class span_gouraud
+    {
+    public:
+        typedef ColorT color_type;
+
+        struct coord_type
+        {
+            double x;
+            double y;
+            color_type color;
+        };
+
+        //--------------------------------------------------------------------
+        span_gouraud() : 
+            m_vertex(0)
+        {
+            m_cmd[0] = path_cmd_stop;
+        }
+
+        //--------------------------------------------------------------------
+        span_gouraud(const color_type& c1,
+                     const color_type& c2,
+                     const color_type& c3,
+                     double x1, double y1,
+                     double x2, double y2,
+                     double x3, double y3,
+                     double d) : 
+            m_vertex(0)
+        {
+            colors(c1, c2, c3);
+            triangle(x1, y1, x2, y2, x3, y3, d);
+        }
+
+        //--------------------------------------------------------------------
+        void colors(ColorT c1, ColorT c2, ColorT c3)
+        {
+            m_coord[0].color = c1;
+            m_coord[1].color = c2;
+            m_coord[2].color = c3;
+        }
+
+        //--------------------------------------------------------------------
+        // Sets the triangle and dilates it if needed.
+        // The trick here is to calculate beveled joins in the vertices of the 
+        // triangle and render it as a 6-vertex polygon. 
+        // It's necessary to achieve numerical stability. 
+        // However, the coordinates to interpolate colors are calculated
+        // as miter joins (calc_intersection).
+        void triangle(double x1, double y1, 
+                      double x2, double y2,
+                      double x3, double y3,
+                      double d)
+        {
+            m_coord[0].x = m_x[0] = x1; 
+            m_coord[0].y = m_y[0] = y1;
+            m_coord[1].x = m_x[1] = x2; 
+            m_coord[1].y = m_y[1] = y2;
+            m_coord[2].x = m_x[2] = x3; 
+            m_coord[2].y = m_y[2] = y3;
+            m_cmd[0] = path_cmd_move_to;
+            m_cmd[1] = path_cmd_line_to;
+            m_cmd[2] = path_cmd_line_to;
+            m_cmd[3] = path_cmd_stop;
+
+            if(d != 0.0)
+            {   
+                dilate_triangle(m_coord[0].x, m_coord[0].y,
+                                m_coord[1].x, m_coord[1].y,
+                                m_coord[2].x, m_coord[2].y,
+                                m_x, m_y, d);
+
+                calc_intersection(m_x[4], m_y[4], m_x[5], m_y[5],
+                                  m_x[0], m_y[0], m_x[1], m_y[1],
+                                  &m_coord[0].x, &m_coord[0].y);
+
+                calc_intersection(m_x[0], m_y[0], m_x[1], m_y[1],
+                                  m_x[2], m_y[2], m_x[3], m_y[3],
+                                  &m_coord[1].x, &m_coord[1].y);
+
+                calc_intersection(m_x[2], m_y[2], m_x[3], m_y[3],
+                                  m_x[4], m_y[4], m_x[5], m_y[5],
+                                  &m_coord[2].x, &m_coord[2].y);
+                m_cmd[3] = path_cmd_line_to;
+                m_cmd[4] = path_cmd_line_to;
+                m_cmd[5] = path_cmd_line_to;
+                m_cmd[6] = path_cmd_stop;
+            }
+        }
+
+        //--------------------------------------------------------------------
+        // Vertex Source Interface to feed the coordinates to the rasterizer
+        void rewind(unsigned)
+        {
+            m_vertex = 0;
+        }
+
+        //--------------------------------------------------------------------
+        unsigned vertex(double* x, double* y)
+        {
+            *x = m_x[m_vertex];
+            *y = m_y[m_vertex];
+            return m_cmd[m_vertex++];
+        }
+
+    protected:
+        //--------------------------------------------------------------------
+        void arrange_vertices(coord_type* coord) const
+        {
+            coord[0] = m_coord[0];
+            coord[1] = m_coord[1];
+            coord[2] = m_coord[2];
+
+            if(m_coord[0].y > m_coord[2].y)
+            {
+                coord[0] = m_coord[2]; 
+                coord[2] = m_coord[0];
+            }
+
+            coord_type tmp;
+            if(coord[0].y > coord[1].y)
+            {
+                tmp      = coord[1];
+                coord[1] = coord[0];
+                coord[0] = tmp;
+            }
+
+            if(coord[1].y > coord[2].y)
+            {
+                tmp      = coord[2];
+                coord[2] = coord[1];
+                coord[1] = tmp;
+            }
+       }
+
+    private:
+        //--------------------------------------------------------------------
+        coord_type m_coord[3];
+        double m_x[8];
+        double m_y[8];
+        unsigned m_cmd[8];
+        unsigned m_vertex;
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_gouraud_gray.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gouraud_gray.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_gouraud_gray.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gouraud_gray.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,241 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_GOURAUD_GRAY_INCLUDED
+#define AGG_SPAN_GOURAUD_GRAY_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_gray.h"
+#include "agg_dda_line.h"
+#include "agg_span_gouraud.h"
+
+namespace mapserver
+{
+
+    //=======================================================span_gouraud_gray
+    template<class ColorT> class span_gouraud_gray : public span_gouraud<ColorT>
+    {
+    public:
+        typedef ColorT color_type;
+        typedef typename color_type::value_type value_type;
+        typedef span_gouraud<color_type> base_type;
+        typedef typename base_type::coord_type coord_type;
+        enum subpixel_scale_e
+        { 
+            subpixel_shift = 4, 
+            subpixel_scale = 1 << subpixel_shift
+        };
+
+    private:
+        //--------------------------------------------------------------------
+        struct gray_calc
+        {
+            void init(const coord_type& c1, const coord_type& c2)
+            {
+                m_x1  = c1.x - 0.5;
+                m_y1  = c1.y - 0.5;
+                m_dx  = c2.x - c1.x;
+                double dy = c2.y - c1.y;
+                m_1dy = (fabs(dy) < 1e-10) ? 1e10 : 1.0 / dy;
+                m_v1 = c1.color.v;
+                m_a1 = c1.color.a;
+                m_dv = c2.color.v - m_v1;
+                m_da = c2.color.a - m_a1;
+            }
+
+            void calc(double y)
+            {
+                double k = (y - m_y1) * m_1dy;
+                if(k < 0.0) k = 0.0;
+                if(k > 1.0) k = 1.0;
+                m_v = m_v1 + iround(m_dv * k);
+                m_a = m_a1 + iround(m_da * k);
+                m_x = iround((m_x1 + m_dx * k) * subpixel_scale);
+            }
+
+            double m_x1;
+            double m_y1;
+            double m_dx;
+            double m_1dy;
+            int    m_v1;
+            int    m_a1;
+            int    m_dv;
+            int    m_da;
+            int    m_v;
+            int    m_a;
+            int    m_x;
+        };
+
+
+    public:
+        //--------------------------------------------------------------------
+        span_gouraud_gray() {}
+        span_gouraud_gray(const color_type& c1, 
+                          const color_type& c2, 
+                          const color_type& c3,
+                          double x1, double y1, 
+                          double x2, double y2,
+                          double x3, double y3, 
+                          double d = 0) : 
+            base_type(c1, c2, c3, x1, y1, x2, y2, x3, y3, d)
+        {}
+
+        //--------------------------------------------------------------------
+        void prepare()
+        {
+            coord_type coord[3];
+            base_type::arrange_vertices(coord);
+
+            m_y2 = int(coord[1].y);
+
+            m_swap = cross_product(coord[0].x, coord[0].y, 
+                                   coord[2].x, coord[2].y,
+                                   coord[1].x, coord[1].y) < 0.0;
+
+            m_c1.init(coord[0], coord[2]);
+            m_c2.init(coord[0], coord[1]);
+            m_c3.init(coord[1], coord[2]);
+        }
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            m_c1.calc(y);
+            const gray_calc* pc1 = &m_c1;
+            const gray_calc* pc2 = &m_c2;
+
+            if(y < m_y2)
+            {
+                // Bottom part of the triangle (first subtriangle)
+                //-------------------------
+                m_c2.calc(y + m_c2.m_1dy);
+            }
+            else
+            {
+                // Upper part (second subtriangle)
+                //-------------------------
+                m_c3.calc(y - m_c3.m_1dy);
+                pc2 = &m_c3;
+            }
+
+            if(m_swap)
+            {
+                // It means that the triangle is oriented clockwise, 
+                // so that we need to swap the controlling structures
+                //-------------------------
+                const gray_calc* t = pc2;
+                pc2 = pc1;
+                pc1 = t;
+            }
+
+            // Get the horizontal length with subpixel accuracy
+            // and protect it from division by zero
+            //-------------------------
+            int nlen = abs(pc2->m_x - pc1->m_x);
+            if(nlen <= 0) nlen = 1;
+
+            dda_line_interpolator<14> v(pc1->m_v, pc2->m_v, nlen);
+            dda_line_interpolator<14> a(pc1->m_a, pc2->m_a, nlen);
+
+            // Calculate the starting point of the gradient with subpixel 
+            // accuracy and correct (roll back) the interpolators.
+            // This operation will also clip the beginning of the span
+            // if necessary.
+            //-------------------------
+            int start = pc1->m_x - (x << subpixel_shift);
+            v    -= start; 
+            a    -= start;
+            nlen += start;
+
+            int vv, va;
+            enum lim_e { lim = color_type::base_mask };
+
+            // Beginning part of the span. Since we rolled back the 
+            // interpolators, the color values may have overflow.
+            // So that, we render the beginning part with checking 
+            // for overflow. It lasts until "start" is positive;
+            // typically it's 1-2 pixels, but may be more in some cases.
+            //-------------------------
+            while(len && start > 0)
+            {
+                vv = v.y();
+                va = a.y();
+                if(vv < 0) vv = 0; if(vv > lim) vv = lim;
+                if(va < 0) va = 0; if(va > lim) va = lim;
+                span->v = (value_type)vv;
+                span->a = (value_type)va;
+                v     += subpixel_scale; 
+                a     += subpixel_scale;
+                nlen  -= subpixel_scale;
+                start -= subpixel_scale;
+                ++span;
+                --len;
+            }
+
+            // Middle part, no checking for overflow.
+            // Actual spans can be longer than the calculated length
+            // because of anti-aliasing, thus, the interpolators can 
+            // overflow. But while "nlen" is positive we are safe.
+            //-------------------------
+            while(len && nlen > 0)
+            {
+                span->v = (value_type)v.y();
+                span->a = (value_type)a.y();
+                v    += subpixel_scale; 
+                a    += subpixel_scale;
+                nlen -= subpixel_scale;
+                ++span;
+                --len;
+            }
+
+            // Ending part; checking for overflow.
+            // Typically it's 1-2 pixels, but may be more in some cases.
+            //-------------------------
+            while(len)
+            {
+                vv = v.y();
+                va = a.y();
+                if(vv < 0) vv = 0; if(vv > lim) vv = lim;
+                if(va < 0) va = 0; if(va > lim) va = lim;
+                span->v = (value_type)vv;
+                span->a = (value_type)va;
+                v += subpixel_scale; 
+                a += subpixel_scale;
+                ++span;
+                --len;
+            }
+        }
+
+
+    private:
+        bool      m_swap;
+        int       m_y2;
+        gray_calc m_c1;
+        gray_calc m_c2;
+        gray_calc m_c3;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_gouraud_rgba.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gouraud_rgba.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_gouraud_rgba.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gouraud_rgba.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,277 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_GOURAUD_RGBA_INCLUDED
+#define AGG_SPAN_GOURAUD_RGBA_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_rgba.h"
+#include "agg_dda_line.h"
+#include "agg_span_gouraud.h"
+
+namespace mapserver
+{
+
+    //=======================================================span_gouraud_rgba
+    template<class ColorT> class span_gouraud_rgba : public span_gouraud<ColorT>
+    {
+    public:
+        typedef ColorT color_type;
+        typedef typename ColorT::value_type value_type;
+        typedef span_gouraud<color_type> base_type;
+        typedef typename base_type::coord_type coord_type;
+        enum subpixel_scale_e
+        { 
+            subpixel_shift = 4, 
+            subpixel_scale = 1 << subpixel_shift
+        };
+
+    private:
+        //--------------------------------------------------------------------
+        struct rgba_calc
+        {
+            void init(const coord_type& c1, const coord_type& c2)
+            {
+                m_x1  = c1.x - 0.5; 
+                m_y1  = c1.y - 0.5;
+                m_dx  = c2.x - c1.x;
+                double dy = c2.y - c1.y;
+                m_1dy = (dy < 1e-5) ? 1e5 : 1.0 / dy;
+                m_r1  = c1.color.r;
+                m_g1  = c1.color.g;
+                m_b1  = c1.color.b;
+                m_a1  = c1.color.a;
+                m_dr  = c2.color.r - m_r1;
+                m_dg  = c2.color.g - m_g1;
+                m_db  = c2.color.b - m_b1;
+                m_da  = c2.color.a - m_a1;
+            }
+
+            void calc(double y)
+            {
+                double k = (y - m_y1) * m_1dy;
+                if(k < 0.0) k = 0.0;
+                if(k > 1.0) k = 1.0;
+                m_r = m_r1 + iround(m_dr * k);
+                m_g = m_g1 + iround(m_dg * k);
+                m_b = m_b1 + iround(m_db * k);
+                m_a = m_a1 + iround(m_da * k);
+                m_x = iround((m_x1 + m_dx * k) * subpixel_scale);
+            }
+
+            double m_x1;
+            double m_y1;
+            double m_dx;
+            double m_1dy;
+            int    m_r1;
+            int    m_g1;
+            int    m_b1;
+            int    m_a1;
+            int    m_dr;
+            int    m_dg;
+            int    m_db;
+            int    m_da;
+            int    m_r;
+            int    m_g;
+            int    m_b;
+            int    m_a;
+            int    m_x;
+        };
+
+    public:
+
+        //--------------------------------------------------------------------
+        span_gouraud_rgba() {}
+        span_gouraud_rgba(const color_type& c1, 
+                          const color_type& c2, 
+                          const color_type& c3,
+                          double x1, double y1, 
+                          double x2, double y2,
+                          double x3, double y3, 
+                          double d = 0) : 
+            base_type(c1, c2, c3, x1, y1, x2, y2, x3, y3, d)
+        {}
+
+        //--------------------------------------------------------------------
+        void prepare()
+        {
+            coord_type coord[3];
+            base_type::arrange_vertices(coord);
+
+            m_y2 = int(coord[1].y);
+
+            m_swap = cross_product(coord[0].x, coord[0].y, 
+                                   coord[2].x, coord[2].y,
+                                   coord[1].x, coord[1].y) < 0.0;
+
+            m_rgba1.init(coord[0], coord[2]);
+            m_rgba2.init(coord[0], coord[1]);
+            m_rgba3.init(coord[1], coord[2]);
+        }
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            m_rgba1.calc(y);//(m_rgba1.m_1dy > 2) ? m_rgba1.m_y1 : y);
+            const rgba_calc* pc1 = &m_rgba1;
+            const rgba_calc* pc2 = &m_rgba2;
+
+            if(y <= m_y2)
+            {          
+                // Bottom part of the triangle (first subtriangle)
+                //-------------------------
+                m_rgba2.calc(y + m_rgba2.m_1dy);
+            }
+            else
+            {
+                // Upper part (second subtriangle)
+                m_rgba3.calc(y - m_rgba3.m_1dy);
+                //-------------------------
+                pc2 = &m_rgba3;
+            }
+
+            if(m_swap)
+            {
+                // It means that the triangle is oriented clockwise, 
+                // so that we need to swap the controlling structures
+                //-------------------------
+                const rgba_calc* t = pc2;
+                pc2 = pc1;
+                pc1 = t;
+            }
+
+            // Get the horizontal length with subpixel accuracy
+            // and protect it from division by zero
+            //-------------------------
+            int nlen = abs(pc2->m_x - pc1->m_x);
+            if(nlen <= 0) nlen = 1;
+
+            dda_line_interpolator<14> r(pc1->m_r, pc2->m_r, nlen);
+            dda_line_interpolator<14> g(pc1->m_g, pc2->m_g, nlen);
+            dda_line_interpolator<14> b(pc1->m_b, pc2->m_b, nlen);
+            dda_line_interpolator<14> a(pc1->m_a, pc2->m_a, nlen);
+
+            // Calculate the starting point of the gradient with subpixel 
+            // accuracy and correct (roll back) the interpolators.
+            // This operation will also clip the beginning of the span
+            // if necessary.
+            //-------------------------
+            int start = pc1->m_x - (x << subpixel_shift);
+            r    -= start; 
+            g    -= start; 
+            b    -= start; 
+            a    -= start;
+            nlen += start;
+
+            int vr, vg, vb, va;
+            enum lim_e { lim = color_type::base_mask };
+
+            // Beginning part of the span. Since we rolled back the 
+            // interpolators, the color values may have overflow.
+            // So that, we render the beginning part with checking 
+            // for overflow. It lasts until "start" is positive;
+            // typically it's 1-2 pixels, but may be more in some cases.
+            //-------------------------
+            while(len && start > 0)
+            {
+                vr = r.y();
+                vg = g.y();
+                vb = b.y();
+                va = a.y();
+                if(vr < 0) vr = 0; if(vr > lim) vr = lim;
+                if(vg < 0) vg = 0; if(vg > lim) vg = lim;
+                if(vb < 0) vb = 0; if(vb > lim) vb = lim;
+                if(va < 0) va = 0; if(va > lim) va = lim;
+                span->r = (value_type)vr;
+                span->g = (value_type)vg;
+                span->b = (value_type)vb;
+                span->a = (value_type)va;
+                r     += subpixel_scale; 
+                g     += subpixel_scale; 
+                b     += subpixel_scale; 
+                a     += subpixel_scale;
+                nlen  -= subpixel_scale;
+                start -= subpixel_scale;
+                ++span;
+                --len;
+            }
+
+            // Middle part, no checking for overflow.
+            // Actual spans can be longer than the calculated length
+            // because of anti-aliasing, thus, the interpolators can 
+            // overflow. But while "nlen" is positive we are safe.
+            //-------------------------
+            while(len && nlen > 0)
+            {
+                span->r = (value_type)r.y();
+                span->g = (value_type)g.y();
+                span->b = (value_type)b.y();
+                span->a = (value_type)a.y();
+                r    += subpixel_scale; 
+                g    += subpixel_scale; 
+                b    += subpixel_scale; 
+                a    += subpixel_scale;
+                nlen -= subpixel_scale;
+                ++span;
+                --len;
+            }
+
+            // Ending part; checking for overflow.
+            // Typically it's 1-2 pixels, but may be more in some cases.
+            //-------------------------
+            while(len)
+            {
+                vr = r.y();
+                vg = g.y();
+                vb = b.y();
+                va = a.y();
+                if(vr < 0) vr = 0; if(vr > lim) vr = lim;
+                if(vg < 0) vg = 0; if(vg > lim) vg = lim;
+                if(vb < 0) vb = 0; if(vb > lim) vb = lim;
+                if(va < 0) va = 0; if(va > lim) va = lim;
+                span->r = (value_type)vr;
+                span->g = (value_type)vg;
+                span->b = (value_type)vb;
+                span->a = (value_type)va;
+                r += subpixel_scale; 
+                g += subpixel_scale; 
+                b += subpixel_scale; 
+                a += subpixel_scale;
+                ++span;
+                --len;
+            }
+        }
+
+    private:
+        bool      m_swap;
+        int       m_y2;
+        rgba_calc m_rgba1;
+        rgba_calc m_rgba2;
+        rgba_calc m_rgba3;
+    };
+
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_gradient.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gradient.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_gradient.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gradient.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,364 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_GRADIENT_INCLUDED
+#define AGG_SPAN_GRADIENT_INCLUDED
+
+#include <math.h>
+#include <stdlib.h>
+#include <string.h>
+#include "agg_basics.h"
+#include "agg_math.h"
+#include "agg_array.h"
+
+
+namespace mapserver
+{
+
+    enum gradient_subpixel_scale_e
+    {
+        gradient_subpixel_shift = 4,                              //-----gradient_subpixel_shift
+        gradient_subpixel_scale = 1 << gradient_subpixel_shift,   //-----gradient_subpixel_scale
+        gradient_subpixel_mask  = gradient_subpixel_scale - 1     //-----gradient_subpixel_mask
+    };
+
+
+
+    //==========================================================span_gradient
+    template<class ColorT,
+             class Interpolator,
+             class GradientF, 
+             class ColorF>
+    class span_gradient
+    {
+    public:
+        typedef Interpolator interpolator_type;
+        typedef ColorT color_type;
+
+        enum downscale_shift_e
+        {
+            downscale_shift = interpolator_type::subpixel_shift - 
+                              gradient_subpixel_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_gradient() {}
+
+        //--------------------------------------------------------------------
+        span_gradient(interpolator_type& inter,
+                      const GradientF& gradient_function,
+                      const ColorF& color_function,
+                      double d1, double d2) : 
+            m_interpolator(&inter),
+            m_gradient_function(&gradient_function),
+            m_color_function(&color_function),
+            m_d1(iround(d1 * gradient_subpixel_scale)),
+            m_d2(iround(d2 * gradient_subpixel_scale))
+        {}
+
+        //--------------------------------------------------------------------
+        interpolator_type& interpolator() { return *m_interpolator; }
+        const GradientF& gradient_function() const { return *m_gradient_function; }
+        const ColorF& color_function() const { return *m_color_function; }
+        double d1() const { return double(m_d1) / gradient_subpixel_scale; }
+        double d2() const { return double(m_d2) / gradient_subpixel_scale; }
+
+        //--------------------------------------------------------------------
+        void interpolator(interpolator_type& i) { m_interpolator = &i; }
+        void gradient_function(const GradientF& gf) { m_gradient_function = &gf; }
+        void color_function(const ColorF& cf) { m_color_function = &cf; }
+        void d1(double v) { m_d1 = iround(v * gradient_subpixel_scale); }
+        void d2(double v) { m_d2 = iround(v * gradient_subpixel_scale); }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {   
+            int dd = m_d2 - m_d1;
+            if(dd < 1) dd = 1;
+            m_interpolator->begin(x+0.5, y+0.5, len);
+            do
+            {
+                m_interpolator->coordinates(&x, &y);
+                int d = m_gradient_function->calculate(x >> downscale_shift, 
+                                                       y >> downscale_shift, m_d2);
+                d = ((d - m_d1) * (int)m_color_function->size()) / dd;
+                if(d < 0) d = 0;
+                if(d >= (int)m_color_function->size()) d = m_color_function->size() - 1;
+                *span++ = (*m_color_function)[d];
+                ++(*m_interpolator);
+            }
+            while(--len);
+        }
+
+    private:
+        interpolator_type* m_interpolator;
+        const GradientF*   m_gradient_function;
+        const ColorF*      m_color_function;
+        int                m_d1;
+        int                m_d2;
+    };
+
+
+
+
+    //=====================================================gradient_linear_color
+    template<class ColorT> 
+    struct gradient_linear_color
+    {
+        typedef ColorT color_type;
+
+        gradient_linear_color() {}
+        gradient_linear_color(const color_type& c1, const color_type& c2, 
+                              unsigned size = 256) :
+            m_c1(c1), m_c2(c2), m_size(size) {}
+
+        unsigned size() const { return m_size; }
+        color_type operator [] (unsigned v) const 
+        {
+            return m_c1.gradient(m_c2, double(v) / double(m_size - 1));
+        }
+
+        void colors(const color_type& c1, const color_type& c2, unsigned size = 256)
+        {
+            m_c1 = c1;
+            m_c2 = c2;
+            m_size = size;
+        }
+
+        color_type m_c1;
+        color_type m_c2;
+        unsigned m_size;
+    };
+
+
+
+
+
+
+    //==========================================================gradient_circle
+    class gradient_circle
+    {
+        // Actually the same as radial. Just for compatibility
+    public:
+        static AGG_INLINE int calculate(int x, int y, int)
+        {
+            return int(fast_sqrt(x*x + y*y));
+        }
+    };
+
+
+    //==========================================================gradient_radial
+    class gradient_radial
+    {
+    public:
+        static AGG_INLINE int calculate(int x, int y, int)
+        {
+            return int(fast_sqrt(x*x + y*y));
+        }
+    };
+
+    //========================================================gradient_radial_d
+    class gradient_radial_d
+    {
+    public:
+        static AGG_INLINE int calculate(int x, int y, int)
+        {
+            return uround(sqrt(double(x)*double(x) + double(y)*double(y)));
+        }
+    };
+
+    //====================================================gradient_radial_focus
+    class gradient_radial_focus
+    {
+    public:
+        //---------------------------------------------------------------------
+        gradient_radial_focus() : 
+            m_r(100 * gradient_subpixel_scale), 
+            m_fx(0), 
+            m_fy(0)
+        {
+            update_values();
+        }
+
+        //---------------------------------------------------------------------
+        gradient_radial_focus(double r, double fx, double fy) : 
+            m_r (iround(r  * gradient_subpixel_scale)), 
+            m_fx(iround(fx * gradient_subpixel_scale)), 
+            m_fy(iround(fy * gradient_subpixel_scale))
+        {
+            update_values();
+        }
+
+        //---------------------------------------------------------------------
+        void init(double r, double fx, double fy)
+        {
+            m_r  = iround(r  * gradient_subpixel_scale);
+            m_fx = iround(fx * gradient_subpixel_scale);
+            m_fy = iround(fy * gradient_subpixel_scale);
+            update_values();
+        }
+
+        //---------------------------------------------------------------------
+        double radius()  const { return double(m_r)  / gradient_subpixel_scale; }
+        double focus_x() const { return double(m_fx) / gradient_subpixel_scale; }
+        double focus_y() const { return double(m_fy) / gradient_subpixel_scale; }
+
+        //---------------------------------------------------------------------
+        int calculate(int x, int y, int) const
+        {
+            double dx = x - m_fx;
+            double dy = y - m_fy;
+            double d2 = dx * m_fy - dy * m_fx;
+            double d3 = m_r2 * (dx * dx + dy * dy) - d2 * d2;
+            return iround((dx * m_fx + dy * m_fy + sqrt(fabs(d3))) * m_mul);
+        }
+
+    private:
+        //---------------------------------------------------------------------
+        void update_values()
+        {
+            // Calculate the invariant values. In case the focal center
+            // lies exactly on the gradient circle the divisor degenerates
+            // into zero. In this case we just move the focal center by
+            // one subpixel unit possibly in the direction to the origin (0,0)
+            // and calculate the values again.
+            //-------------------------
+            m_r2  = double(m_r)  * double(m_r);
+            m_fx2 = double(m_fx) * double(m_fx);
+            m_fy2 = double(m_fy) * double(m_fy);
+            double d = (m_r2 - (m_fx2 + m_fy2));
+            if(d == 0)
+            {
+                if(m_fx) { if(m_fx < 0) ++m_fx; else --m_fx; }
+                if(m_fy) { if(m_fy < 0) ++m_fy; else --m_fy; }
+                m_fx2 = double(m_fx) * double(m_fx);
+                m_fy2 = double(m_fy) * double(m_fy);
+                d = (m_r2 - (m_fx2 + m_fy2));
+            }
+            m_mul = m_r / d;
+        }
+
+        int    m_r;
+        int    m_fx;
+        int    m_fy;
+        double m_r2;
+        double m_fx2;
+        double m_fy2;
+        double m_mul;
+    };
+
+
+    //==============================================================gradient_x
+    class gradient_x
+    {
+    public:
+        static int calculate(int x, int, int) { return x; }
+    };
+
+
+    //==============================================================gradient_y
+    class gradient_y
+    {
+    public:
+        static int calculate(int, int y, int) { return y; }
+    };
+
+    //========================================================gradient_diamond
+    class gradient_diamond
+    {
+    public:
+        static AGG_INLINE int calculate(int x, int y, int) 
+        { 
+            int ax = abs(x);
+            int ay = abs(y);
+            return ax > ay ? ax : ay; 
+        }
+    };
+
+    //=============================================================gradient_xy
+    class gradient_xy
+    {
+    public:
+        static AGG_INLINE int calculate(int x, int y, int d) 
+        { 
+            return abs(x) * abs(y) / d; 
+        }
+    };
+
+    //========================================================gradient_sqrt_xy
+    class gradient_sqrt_xy
+    {
+    public:
+        static AGG_INLINE int calculate(int x, int y, int) 
+        { 
+            return fast_sqrt(abs(x) * abs(y)); 
+        }
+    };
+
+    //==========================================================gradient_conic
+    class gradient_conic
+    {
+    public:
+        static AGG_INLINE int calculate(int x, int y, int d) 
+        { 
+            return uround(fabs(atan2(double(y), double(x))) * double(d) / pi);
+        }
+    };
+
+    //=================================================gradient_repeat_adaptor
+    template<class GradientF> class gradient_repeat_adaptor
+    {
+    public:
+        gradient_repeat_adaptor(const GradientF& gradient) : 
+            m_gradient(&gradient) {}
+
+        AGG_INLINE int calculate(int x, int y, int d) const
+        {
+            int ret = m_gradient->calculate(x, y, d) % d;
+            if(ret < 0) ret += d;
+            return ret;
+        }
+
+    private:
+        const GradientF* m_gradient;
+    };
+
+    //================================================gradient_reflect_adaptor
+    template<class GradientF> class gradient_reflect_adaptor
+    {
+    public:
+        gradient_reflect_adaptor(const GradientF& gradient) : 
+            m_gradient(&gradient) {}
+
+        AGG_INLINE int calculate(int x, int y, int d) const
+        {
+            int d2 = d << 1;
+            int ret = m_gradient->calculate(x, y, d) % d2;
+            if(ret <  0) ret += d2;
+            if(ret >= d) ret  = d2 - ret;
+            return ret;
+        }
+
+    private:
+        const GradientF* m_gradient;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_gradient_alpha.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gradient_alpha.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_gradient_alpha.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_gradient_alpha.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,126 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_GRADIENT_ALPHA_INCLUDED
+#define AGG_SPAN_GRADIENT_ALPHA_INCLUDED
+
+#include "agg_span_gradient.h"
+
+namespace mapserver
+{
+    //======================================================span_gradient_alpha
+    template<class ColorT, 
+             class Interpolator,
+             class GradientF, 
+             class AlphaF>
+    class span_gradient_alpha
+    {
+    public:
+        typedef Interpolator interpolator_type;
+        typedef ColorT color_type;
+        typedef typename color_type::value_type alpha_type;
+
+        enum downscale_shift_e
+        {
+            downscale_shift = interpolator_type::subpixel_shift - gradient_subpixel_shift
+        };
+
+
+        //--------------------------------------------------------------------
+        span_gradient_alpha() {}
+
+        //--------------------------------------------------------------------
+        span_gradient_alpha(interpolator_type& inter,
+                            const GradientF& gradient_function,
+                            const AlphaF& alpha_function,
+                            double d1, double d2) : 
+            m_interpolator(&inter),
+            m_gradient_function(&gradient_function),
+            m_alpha_function(&alpha_function),
+            m_d1(iround(d1 * gradient_subpixel_scale)),
+            m_d2(iround(d2 * gradient_subpixel_scale))
+        {}
+
+        //--------------------------------------------------------------------
+        interpolator_type& interpolator() { return *m_interpolator; }
+        const GradientF& gradient_function() const { return *m_gradient_function; }
+        const AlphaF& alpha_function() const { return *m_alpha_function; }
+        double d1() const { return double(m_d1) / gradient_subpixel_scale; }
+        double d2() const { return double(m_d2) / gradient_subpixel_scale; }
+
+        //--------------------------------------------------------------------
+        void interpolator(interpolator_type& i) { m_interpolator = &i; }
+        void gradient_function(const GradientF& gf) { m_gradient_function = &gf; }
+        void alpha_function(const AlphaF& af) { m_alpha_function = &af; }
+        void d1(double v) { m_d1 = iround(v * gradient_subpixel_scale); }
+        void d2(double v) { m_d2 = iround(v * gradient_subpixel_scale); }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {   
+            int dd = m_d2 - m_d1;
+            if(dd < 1) dd = 1;
+            m_interpolator->begin(x+0.5, y+0.5, len);
+            do
+            {
+                m_interpolator->coordinates(&x, &y);
+                int d = m_gradient_function->calculate(x >> downscale_shift, 
+                                                       y >> downscale_shift, m_d2);
+                d = ((d - m_d1) * (int)m_alpha_function->size()) / dd;
+                if(d < 0) d = 0;
+                if(d >= (int)m_alpha_function->size()) d = m_alpha_function->size() - 1;
+                span->a = (*m_alpha_function)[d];
+                ++span;
+                ++(*m_interpolator);
+            }
+            while(--len);
+        }
+
+    private:
+        interpolator_type* m_interpolator;
+        const GradientF*   m_gradient_function;
+        const AlphaF*      m_alpha_function;
+        int                m_d1;
+        int                m_d2;
+    };
+
+
+    //=======================================================gradient_alpha_x
+    template<class ColorT> struct gradient_alpha_x
+    {
+        typedef typename ColorT::value_type alpha_type;
+        alpha_type operator [] (alpha_type x) const { return x; }
+    };
+
+    //====================================================gradient_alpha_x_u8
+    struct gradient_alpha_x_u8
+    {
+        typedef int8u alpha_type;
+        alpha_type operator [] (alpha_type x) const { return x; }
+    };
+
+    //==========================================gradient_alpha_one_munus_x_u8
+    struct gradient_alpha_one_munus_x_u8
+    {
+        typedef int8u alpha_type;
+        alpha_type operator [] (alpha_type x) const { return 255-x; }
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_image_filter.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_image_filter.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,246 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Image transformations with filtering. Span generator base class
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_SPAN_IMAGE_FILTER_INCLUDED
+#define AGG_SPAN_IMAGE_FILTER_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_image_filters.h"
+#include "agg_span_interpolator_linear.h"
+
+namespace mapserver
+{
+
+    //-------------------------------------------------------span_image_filter
+    template<class Source, class Interpolator> class span_image_filter
+    {
+    public:
+        typedef Source source_type;
+        typedef Interpolator interpolator_type;
+
+        //--------------------------------------------------------------------
+        span_image_filter() {}
+        span_image_filter(source_type& src, 
+                          interpolator_type& interpolator,
+                          const image_filter_lut* filter) : 
+            m_src(&src),
+            m_interpolator(&interpolator),
+            m_filter(filter),
+            m_dx_dbl(0.5),
+            m_dy_dbl(0.5),
+            m_dx_int(image_subpixel_scale / 2),
+            m_dy_int(image_subpixel_scale / 2)
+        {}
+        void attach(source_type& v) { m_src = &v; }
+
+        //--------------------------------------------------------------------
+               source_type& source()            { return *m_src; }
+        const  source_type& source()      const { return *m_src; }
+        const  image_filter_lut& filter() const { return *m_filter; }
+        int    filter_dx_int()            const { return m_dx_int; }
+        int    filter_dy_int()            const { return m_dy_int; }
+        double filter_dx_dbl()            const { return m_dx_dbl; }
+        double filter_dy_dbl()            const { return m_dy_dbl; }
+
+        //--------------------------------------------------------------------
+        void interpolator(interpolator_type& v)  { m_interpolator = &v; }
+        void filter(const image_filter_lut& v)   { m_filter = &v; }
+        void filter_offset(double dx, double dy)
+        {
+            m_dx_dbl = dx;
+            m_dy_dbl = dy;
+            m_dx_int = iround(dx * image_subpixel_scale);
+            m_dy_int = iround(dy * image_subpixel_scale);
+        }
+        void filter_offset(double d) { filter_offset(d, d); }
+
+        //--------------------------------------------------------------------
+        interpolator_type& interpolator() { return *m_interpolator; }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+
+        //--------------------------------------------------------------------
+    private:
+        source_type*            m_src;
+        interpolator_type*      m_interpolator;
+        const image_filter_lut* m_filter;
+        double   m_dx_dbl;
+        double   m_dy_dbl;
+        unsigned m_dx_int;
+        unsigned m_dy_int;
+    };
+
+
+
+
+    //==============================================span_image_resample_affine
+    template<class Source> 
+    class span_image_resample_affine : 
+    public span_image_filter<Source, span_interpolator_linear<trans_affine> >
+    {
+    public:
+        typedef Source source_type;
+        typedef span_interpolator_linear<trans_affine> interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+
+        //--------------------------------------------------------------------
+        span_image_resample_affine() : 
+            m_scale_limit(200.0),
+            m_blur_x(1.0),
+            m_blur_y(1.0)
+        {}
+
+        //--------------------------------------------------------------------
+        span_image_resample_affine(source_type& src, 
+                                   interpolator_type& inter,
+                                   const image_filter_lut& filter) :
+            base_type(src, inter, &filter),
+            m_scale_limit(200.0),
+            m_blur_x(1.0),
+            m_blur_y(1.0)
+        {}
+
+
+        //--------------------------------------------------------------------
+        int  scale_limit() const { return uround(m_scale_limit); }
+        void scale_limit(int v)  { m_scale_limit = v; }
+
+        //--------------------------------------------------------------------
+        double blur_x() const { return m_blur_x; }
+        double blur_y() const { return m_blur_y; }
+        void blur_x(double v) { m_blur_x = v; }
+        void blur_y(double v) { m_blur_y = v; }
+        void blur(double v) { m_blur_x = m_blur_y = v; }
+
+        //--------------------------------------------------------------------
+        void prepare() 
+        {
+            double scale_x;
+            double scale_y;
+
+            base_type::interpolator().transformer().scaling_abs(&scale_x, &scale_y);
+
+            if(scale_x * scale_y > m_scale_limit)
+            {
+                scale_x = scale_x * m_scale_limit / (scale_x * scale_y);
+                scale_y = scale_y * m_scale_limit / (scale_x * scale_y);
+            }
+
+            if(scale_x < 1) scale_x = 1;
+            if(scale_y < 1) scale_y = 1;
+
+            if(scale_x > m_scale_limit) scale_x = m_scale_limit;
+            if(scale_y > m_scale_limit) scale_y = m_scale_limit;
+
+            scale_x *= m_blur_x;
+            scale_y *= m_blur_y;
+
+            if(scale_x < 1) scale_x = 1;
+            if(scale_y < 1) scale_y = 1;
+
+            m_rx     = uround(    scale_x * double(image_subpixel_scale));
+            m_rx_inv = uround(1.0/scale_x * double(image_subpixel_scale));
+
+            m_ry     = uround(    scale_y * double(image_subpixel_scale));
+            m_ry_inv = uround(1.0/scale_y * double(image_subpixel_scale));
+        }
+
+    protected:
+        int m_rx;
+        int m_ry;
+        int m_rx_inv;
+        int m_ry_inv;
+
+    private:
+        double m_scale_limit;
+        double m_blur_x;
+        double m_blur_y;
+    };
+
+
+
+    //=====================================================span_image_resample
+    template<class Source, class Interpolator> 
+    class span_image_resample : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+
+        //--------------------------------------------------------------------
+        span_image_resample() : 
+            m_scale_limit(20),
+            m_blur_x(image_subpixel_scale),
+            m_blur_y(image_subpixel_scale)
+        {}
+
+        //--------------------------------------------------------------------
+        span_image_resample(source_type& src, 
+                            interpolator_type& inter,
+                            const image_filter_lut& filter) :
+            base_type(src, inter, &filter),
+            m_scale_limit(20),
+            m_blur_x(image_subpixel_scale),
+            m_blur_y(image_subpixel_scale)
+        {}
+
+        //--------------------------------------------------------------------
+        int  scale_limit() const { return m_scale_limit; }
+        void scale_limit(int v)  { m_scale_limit = v; }
+
+        //--------------------------------------------------------------------
+        double blur_x() const { return double(m_blur_x) / double(image_subpixel_scale); }
+        double blur_y() const { return double(m_blur_y) / double(image_subpixel_scale); }
+        void blur_x(double v) { m_blur_x = uround(v * double(image_subpixel_scale)); }
+        void blur_y(double v) { m_blur_y = uround(v * double(image_subpixel_scale)); }
+        void blur(double v)   { m_blur_x = 
+                                m_blur_y = uround(v * double(image_subpixel_scale)); }
+
+    protected:
+        AGG_INLINE void adjust_scale(int* rx, int* ry)
+        {
+            if(*rx < image_subpixel_scale) *rx = image_subpixel_scale;
+            if(*ry < image_subpixel_scale) *ry = image_subpixel_scale;
+            if(*rx > image_subpixel_scale * m_scale_limit) 
+            {
+                *rx = image_subpixel_scale * m_scale_limit;
+            }
+            if(*ry > image_subpixel_scale * m_scale_limit) 
+            {
+                *ry = image_subpixel_scale * m_scale_limit;
+            }
+            *rx = (*rx * m_blur_x) >> image_subpixel_shift;
+            *ry = (*ry * m_blur_y) >> image_subpixel_shift;
+            if(*rx < image_subpixel_scale) *rx = image_subpixel_scale;
+            if(*ry < image_subpixel_scale) *ry = image_subpixel_scale;
+        }
+
+        int m_scale_limit;
+        int m_blur_x;
+        int m_blur_y;
+    };
+
+
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_image_filter_gray.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter_gray.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_image_filter_gray.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter_gray.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,748 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+#ifndef AGG_SPAN_IMAGE_FILTER_GRAY_INCLUDED
+#define AGG_SPAN_IMAGE_FILTER_GRAY_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_gray.h"
+#include "agg_span_image_filter.h"
+
+
+namespace mapserver
+{
+
+    //==============================================span_image_filter_gray_nn
+    template<class Source, class Interpolator> 
+    class span_image_filter_gray_nn : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_gray_nn() {}
+        span_image_filter_gray_nn(source_type& src, 
+                                  interpolator_type& inter) :
+            base_type(src, inter, 0) 
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+                span->v = *(const value_type*)
+                    base_type::source().span(x >> image_subpixel_shift, 
+                                             y >> image_subpixel_shift, 
+                                             1);
+                span->a = base_mask;
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+
+    //=========================================span_image_filter_gray_bilinear
+    template<class Source, class Interpolator> 
+    class span_image_filter_gray_bilinear : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_gray_bilinear() {}
+        span_image_filter_gray_bilinear(source_type& src, 
+                                        interpolator_type& inter) :
+            base_type(src, inter, 0) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            calc_type fg;
+            const value_type *fg_ptr;
+            do
+            {
+                int x_hr;
+                int y_hr;
+
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                fg = image_subpixel_scale * image_subpixel_scale / 2;
+
+                x_hr &= image_subpixel_mask;
+                y_hr &= image_subpixel_mask;
+
+                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
+                fg    += *fg_ptr * (image_subpixel_scale - x_hr) * (image_subpixel_scale - y_hr);
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                fg    += *fg_ptr * x_hr * (image_subpixel_scale - y_hr);
+
+                fg_ptr = (const value_type*)base_type::source().next_y();
+                fg    += *fg_ptr * (image_subpixel_scale - x_hr) * y_hr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                fg    += *fg_ptr * x_hr * y_hr;
+
+                span->v = value_type(fg >> (image_subpixel_shift * 2));
+                span->a = base_mask;
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+    //====================================span_image_filter_gray_bilinear_clip
+    template<class Source, class Interpolator> 
+    class span_image_filter_gray_bilinear_clip : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_gray_bilinear_clip() {}
+        span_image_filter_gray_bilinear_clip(source_type& src, 
+                                             const color_type& back_color,
+                                             interpolator_type& inter) :
+            base_type(src, inter, 0), 
+            m_back_color(back_color)
+        {}
+        const color_type& background_color() const { return m_back_color; }
+        void background_color(const color_type& v)   { m_back_color = v; }
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            calc_type fg;
+            calc_type src_alpha;
+            value_type back_v = m_back_color.v;
+            value_type back_a = m_back_color.a;
+
+            const value_type *fg_ptr;
+
+            int maxx = base_type::source().width() - 1;
+            int maxy = base_type::source().height() - 1;
+
+            do
+            {
+                int x_hr;
+                int y_hr;
+                
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                if(x_lr >= 0    && y_lr >= 0 &&
+                   x_lr <  maxx && y_lr <  maxy) 
+                {
+                    fg = image_subpixel_scale * image_subpixel_scale / 2;
+
+                    x_hr &= image_subpixel_mask;
+                    y_hr &= image_subpixel_mask;
+                    fg_ptr = (const value_type*)base_type::source().row_ptr(y_lr) + x_lr;
+
+                    fg += *fg_ptr++ * (image_subpixel_scale - x_hr) * (image_subpixel_scale - y_hr);
+                    fg += *fg_ptr++ * (image_subpixel_scale - y_hr) * x_hr;
+
+                    ++y_lr;
+                    fg_ptr = (const value_type*)base_type::source().row_ptr(y_lr) + x_lr;
+
+                    fg += *fg_ptr++ * (image_subpixel_scale - x_hr) * y_hr;
+                    fg += *fg_ptr++ * x_hr * y_hr;
+
+                    fg >>= image_subpixel_shift * 2;
+                    src_alpha = base_mask;
+                }
+                else
+                {
+                    unsigned weight;
+                    if(x_lr < -1   || y_lr < -1 ||
+                       x_lr > maxx || y_lr > maxy)
+                    {
+                        fg        = back_v;
+                        src_alpha = back_a;
+                    }
+                    else
+                    {
+                        fg = 
+                        src_alpha = image_subpixel_scale * image_subpixel_scale / 2;
+
+                        x_hr &= image_subpixel_mask;
+                        y_hr &= image_subpixel_mask;
+
+                        weight = (image_subpixel_scale - x_hr) * 
+                                 (image_subpixel_scale - y_hr);
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg += weight * 
+                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg        += back_v * weight;
+                            src_alpha += back_a * weight;
+                        }
+
+                        x_lr++;
+
+                        weight = x_hr * (image_subpixel_scale - y_hr);
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg += weight * 
+                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg        += back_v * weight;
+                            src_alpha += back_a * weight;
+                        }
+
+                        x_lr--;
+                        y_lr++;
+
+                        weight = (image_subpixel_scale - x_hr) * y_hr;
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg += weight * 
+                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg        += back_v * weight;
+                            src_alpha += back_a * weight;
+                        }
+
+                        x_lr++;
+
+                        weight = x_hr * y_hr;
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg += weight * 
+                                *((const value_type*)base_type::source().row_ptr(y_lr) + x_lr);
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg        += back_v * weight;
+                            src_alpha += back_a * weight;
+                        }
+
+                        fg        >>= image_subpixel_shift * 2;
+                        src_alpha >>= image_subpixel_shift * 2;
+                    }
+                }
+
+                span->v = (value_type)fg;
+                span->a = (value_type)src_alpha;
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    private:
+        color_type m_back_color;
+    };
+
+
+
+    //==============================================span_image_filter_gray_2x2
+    template<class Source, class Interpolator> 
+    class span_image_filter_gray_2x2 : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_gray_2x2() {}
+        span_image_filter_gray_2x2(source_type& src, 
+                                   interpolator_type& inter,
+                                   const image_filter_lut& filter) :
+            base_type(src, inter, &filter) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            calc_type fg;
+
+            const value_type *fg_ptr;
+            const int16* weight_array = base_type::filter().weight_array() + 
+                                        ((base_type::filter().diameter()/2 - 1) << 
+                                          image_subpixel_shift);
+            do
+            {
+                int x_hr;
+                int y_hr;
+
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                unsigned weight;
+                fg = image_filter_scale / 2;
+
+                x_hr &= image_subpixel_mask;
+                y_hr &= image_subpixel_mask;
+
+                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
+                weight = (weight_array[x_hr + image_subpixel_scale] * 
+                          weight_array[y_hr + image_subpixel_scale] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = (weight_array[x_hr] * 
+                          weight_array[y_hr + image_subpixel_scale] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_y();
+                weight = (weight_array[x_hr + image_subpixel_scale] * 
+                          weight_array[y_hr] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = (weight_array[x_hr] * 
+                          weight_array[y_hr] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg += weight * *fg_ptr;
+
+                fg >>= image_filter_shift;
+                if(fg > base_mask) fg = base_mask;
+
+                span->v = (value_type)fg;
+                span->a = base_mask;
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+
+    //==================================================span_image_filter_gray
+    template<class Source, class Interpolator> 
+    class span_image_filter_gray : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_gray() {}
+        span_image_filter_gray(source_type& src, 
+                               interpolator_type& inter,
+                               const image_filter_lut& filter) :
+            base_type(src, inter, &filter) 
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            int fg;
+            const value_type *fg_ptr;
+
+            unsigned     diameter     = base_type::filter().diameter();
+            int          start        = base_type::filter().start();
+            const int16* weight_array = base_type::filter().weight_array();
+
+            int x_count; 
+            int weight_y;
+
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+
+                x -= base_type::filter_dx_int();
+                y -= base_type::filter_dy_int();
+
+                int x_hr = x; 
+                int y_hr = y; 
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                fg = image_filter_scale / 2;
+
+                int x_fract = x_hr & image_subpixel_mask;
+                unsigned y_count = diameter;
+
+                y_hr = image_subpixel_mask - (y_hr & image_subpixel_mask);
+                fg_ptr = (const value_type*)base_type::source().span(x_lr + start, 
+                                                                     y_lr + start, 
+                                                                     diameter);
+                for(;;)
+                {
+                    x_count  = diameter;
+                    weight_y = weight_array[y_hr];
+                    x_hr = image_subpixel_mask - x_fract;
+                    for(;;)
+                    {
+                        fg += *fg_ptr * 
+                              ((weight_y * weight_array[x_hr] + 
+                                image_filter_scale / 2) >> 
+                                image_filter_shift);
+                        if(--x_count == 0) break;
+                        x_hr  += image_subpixel_scale;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+
+                    if(--y_count == 0) break;
+                    y_hr  += image_subpixel_scale;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg >>= image_filter_shift;
+                if(fg < 0) fg = 0;
+                if(fg > base_mask) fg = base_mask;
+                span->v = (value_type)fg;
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //=========================================span_image_resample_gray_affine
+    template<class Source> 
+    class span_image_resample_gray_affine : 
+    public span_image_resample_affine<Source>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef span_image_resample_affine<source_type> base_type;
+        typedef typename base_type::interpolator_type interpolator_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        {
+            base_shift      = color_type::base_shift,
+            base_mask       = color_type::base_mask,
+            downscale_shift = image_filter_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_image_resample_gray_affine() {}
+        span_image_resample_gray_affine(source_type& src, 
+                                        interpolator_type& inter,
+                                        const image_filter_lut& filter) :
+            base_type(src, inter, filter) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            long_type fg;
+
+            int diameter     = base_type::filter().diameter();
+            int filter_scale = diameter << image_subpixel_shift;
+            int radius_x     = (diameter * base_type::m_rx) >> 1;
+            int radius_y     = (diameter * base_type::m_ry) >> 1;
+            int len_x_lr     = 
+                (diameter * base_type::m_rx + image_subpixel_mask) >> 
+                    image_subpixel_shift;
+
+            const int16* weight_array = base_type::filter().weight_array();
+
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+
+                x += base_type::filter_dx_int() - radius_x;
+                y += base_type::filter_dy_int() - radius_y;
+
+                fg = image_filter_scale / 2;
+
+                int y_lr = y >> image_subpixel_shift;
+                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
+                                base_type::m_ry_inv) >> 
+                                    image_subpixel_shift;
+                int total_weight = 0;
+                int x_lr = x >> image_subpixel_shift;
+                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
+                                base_type::m_rx_inv) >> 
+                                    image_subpixel_shift;
+
+                int x_hr2 = x_hr;
+                const value_type* fg_ptr = 
+                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
+                for(;;)
+                {
+                    int weight_y = weight_array[y_hr];
+                    x_hr = x_hr2;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     downscale_shift;
+
+                        fg += *fg_ptr * weight;
+                        total_weight += weight;
+                        x_hr  += base_type::m_rx_inv;
+                        if(x_hr >= filter_scale) break;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+                    y_hr += base_type::m_ry_inv;
+                    if(y_hr >= filter_scale) break;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg /= total_weight;
+                if(fg < 0) fg = 0;
+                if(fg > base_mask) fg = base_mask;
+
+                span->v = (value_type)fg;
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+
+    //================================================span_image_resample_gray
+    template<class Source, class Interpolator>
+    class span_image_resample_gray : 
+    public span_image_resample<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_resample<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask,
+            downscale_shift = image_filter_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_image_resample_gray() {}
+        span_image_resample_gray(source_type& src, 
+                                 interpolator_type& inter,
+                                 const image_filter_lut& filter) :
+            base_type(src, inter, filter)
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            long_type fg;
+
+            int diameter = base_type::filter().diameter();
+            int filter_scale = diameter << image_subpixel_shift;
+
+            const int16* weight_array = base_type::filter().weight_array();
+            do
+            {
+                int rx;
+                int ry;
+                int rx_inv = image_subpixel_scale;
+                int ry_inv = image_subpixel_scale;
+                base_type::interpolator().coordinates(&x,  &y);
+                base_type::interpolator().local_scale(&rx, &ry);
+                base_type::adjust_scale(&rx, &ry);
+
+                rx_inv = image_subpixel_scale * image_subpixel_scale / rx;
+                ry_inv = image_subpixel_scale * image_subpixel_scale / ry;
+
+                int radius_x = (diameter * rx) >> 1;
+                int radius_y = (diameter * ry) >> 1;
+                int len_x_lr = 
+                    (diameter * rx + image_subpixel_mask) >> 
+                        image_subpixel_shift;
+
+                x += base_type::filter_dx_int() - radius_x;
+                y += base_type::filter_dy_int() - radius_y;
+
+                fg = image_filter_scale / 2;
+
+                int y_lr = y >> image_subpixel_shift;
+                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
+                               ry_inv) >> 
+                                   image_subpixel_shift;
+                int total_weight = 0;
+                int x_lr = x >> image_subpixel_shift;
+                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
+                               rx_inv) >> 
+                                   image_subpixel_shift;
+                int x_hr2 = x_hr;
+                const value_type* fg_ptr = 
+                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
+
+                for(;;)
+                {
+                    int weight_y = weight_array[y_hr];
+                    x_hr = x_hr2;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     downscale_shift;
+                        fg += *fg_ptr * weight;
+                        total_weight += weight;
+                        x_hr  += rx_inv;
+                        if(x_hr >= filter_scale) break;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+                    y_hr += ry_inv;
+                    if(y_hr >= filter_scale) break;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg /= total_weight;
+                if(fg < 0) fg = 0;
+                if(fg > base_mask) fg = base_mask;
+
+                span->v = (value_type)fg;
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+}
+
+
+#endif
+
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_image_filter_rgb.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter_rgb.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_image_filter_rgb.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter_rgb.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,892 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+#ifndef AGG_SPAN_IMAGE_FILTER_RGB_INCLUDED
+#define AGG_SPAN_IMAGE_FILTER_RGB_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_rgba.h"
+#include "agg_span_image_filter.h"
+
+
+namespace mapserver
+{
+
+    //===============================================span_image_filter_rgb_nn
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgb_nn : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgb_nn() {}
+        span_image_filter_rgb_nn(source_type& src, 
+                                 interpolator_type& inter) :
+            base_type(src, inter, 0) 
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+                const value_type* fg_ptr = (const value_type*)
+                    base_type::source().span(x >> image_subpixel_shift, 
+                                             y >> image_subpixel_shift, 
+                                             1);
+                span->r = fg_ptr[order_type::R];
+                span->g = fg_ptr[order_type::G];
+                span->b = fg_ptr[order_type::B];
+                span->a = base_mask;
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //==========================================span_image_filter_rgb_bilinear
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgb_bilinear : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgb_bilinear() {}
+        span_image_filter_rgb_bilinear(source_type& src, 
+                                       interpolator_type& inter) :
+            base_type(src, inter, 0) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            calc_type fg[3];
+            const value_type *fg_ptr;
+            do
+            {
+                int x_hr;
+                int y_hr;
+
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                unsigned weight;
+
+                fg[0] = 
+                fg[1] = 
+                fg[2] = image_subpixel_scale * image_subpixel_scale / 2;
+
+                x_hr &= image_subpixel_mask;
+                y_hr &= image_subpixel_mask;
+
+                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
+                weight = (image_subpixel_scale - x_hr) * 
+                         (image_subpixel_scale - y_hr);
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = x_hr * (image_subpixel_scale - y_hr);
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_y();
+                weight = (image_subpixel_scale - x_hr) * y_hr;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = x_hr * y_hr;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                span->r = value_type(fg[order_type::R] >> (image_subpixel_shift * 2));
+                span->g = value_type(fg[order_type::G] >> (image_subpixel_shift * 2));
+                span->b = value_type(fg[order_type::B] >> (image_subpixel_shift * 2));
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //=====================================span_image_filter_rgb_bilinear_clip
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgb_bilinear_clip : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgb_bilinear_clip() {}
+        span_image_filter_rgb_bilinear_clip(source_type& src, 
+                                            const color_type& back_color,
+                                            interpolator_type& inter) :
+            base_type(src, inter, 0),
+            m_back_color(back_color)
+        {}
+        const color_type& background_color() const { return m_back_color; }
+        void background_color(const color_type& v)   { m_back_color = v; }
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            calc_type fg[3];
+            calc_type src_alpha;
+            value_type back_r = m_back_color.r;
+            value_type back_g = m_back_color.g;
+            value_type back_b = m_back_color.b;
+            value_type back_a = m_back_color.a;
+
+            const value_type *fg_ptr;
+
+            int maxx = base_type::source().width() - 1;
+            int maxy = base_type::source().height() - 1;
+
+            do
+            {
+                int x_hr;
+                int y_hr;
+                
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+                unsigned weight;
+
+                if(x_lr >= 0    && y_lr >= 0 &&
+                   x_lr <  maxx && y_lr <  maxy) 
+                {
+                    fg[0] = 
+                    fg[1] = 
+                    fg[2] = image_subpixel_scale * image_subpixel_scale / 2;
+
+                    x_hr &= image_subpixel_mask;
+                    y_hr &= image_subpixel_mask;
+
+                    fg_ptr = (const value_type*)
+                        base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
+
+                    weight = (image_subpixel_scale - x_hr) * 
+                             (image_subpixel_scale - y_hr);
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+
+                    weight = x_hr * (image_subpixel_scale - y_hr);
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+
+                    ++y_lr;
+                    fg_ptr = (const value_type*)
+                        base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
+
+                    weight = (image_subpixel_scale - x_hr) * y_hr;
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+
+                    weight = x_hr * y_hr;
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+
+                    fg[0] >>= image_subpixel_shift * 2;
+                    fg[1] >>= image_subpixel_shift * 2;
+                    fg[2] >>= image_subpixel_shift * 2;
+                    src_alpha = base_mask;
+                }
+                else
+                {
+                    if(x_lr < -1   || y_lr < -1 ||
+                       x_lr > maxx || y_lr > maxy)
+                    {
+                        fg[order_type::R] = back_r;
+                        fg[order_type::G] = back_g;
+                        fg[order_type::B] = back_b;
+                        src_alpha         = back_a;
+                    }
+                    else
+                    {
+                        fg[0] = 
+                        fg[1] = 
+                        fg[2] = 
+                        src_alpha = image_subpixel_scale * image_subpixel_scale / 2;
+
+                        x_hr &= image_subpixel_mask;
+                        y_hr &= image_subpixel_mask;
+
+                        weight = (image_subpixel_scale - x_hr) * 
+                                 (image_subpixel_scale - y_hr);
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
+
+                            fg[0] += weight * *fg_ptr++;
+                            fg[1] += weight * *fg_ptr++;
+                            fg[2] += weight * *fg_ptr++;
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            src_alpha         += back_a * weight;
+                        }
+
+                        x_lr++;
+
+                        weight = x_hr * (image_subpixel_scale - y_hr);
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
+
+                            fg[0]     += weight * *fg_ptr++;
+                            fg[1]     += weight * *fg_ptr++;
+                            fg[2]     += weight * *fg_ptr++;
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            src_alpha         += back_a * weight;
+                        }
+
+                        x_lr--;
+                        y_lr++;
+
+                        weight = (image_subpixel_scale - x_hr) * y_hr;
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
+
+                            fg[0] += weight * *fg_ptr++;
+                            fg[1] += weight * *fg_ptr++;
+                            fg[2] += weight * *fg_ptr++;
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            src_alpha         += back_a * weight;
+                        }
+
+                        x_lr++;
+
+                        weight = x_hr * y_hr;
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + x_lr + x_lr + x_lr;
+
+                            fg[0] += weight * *fg_ptr++;
+                            fg[1] += weight * *fg_ptr++;
+                            fg[2] += weight * *fg_ptr++;
+                            src_alpha += weight * base_mask;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            src_alpha         += back_a * weight;
+                        }
+
+                        fg[0] >>= image_subpixel_shift * 2;
+                        fg[1] >>= image_subpixel_shift * 2;
+                        fg[2] >>= image_subpixel_shift * 2;
+                        src_alpha >>= image_subpixel_shift * 2;
+                    }
+                }
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = (value_type)src_alpha;
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    private:
+        color_type m_back_color;
+    };
+
+
+
+    //===============================================span_image_filter_rgb_2x2
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgb_2x2 : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgb_2x2() {}
+        span_image_filter_rgb_2x2(source_type& src, 
+                                  interpolator_type& inter,
+                                  const image_filter_lut& filter) :
+            base_type(src, inter, &filter) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            calc_type fg[3];
+
+            const value_type *fg_ptr;
+            const int16* weight_array = base_type::filter().weight_array() + 
+                                        ((base_type::filter().diameter()/2 - 1) << 
+                                          image_subpixel_shift);
+            do
+            {
+                int x_hr;
+                int y_hr;
+
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                unsigned weight;
+                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
+
+                x_hr &= image_subpixel_mask;
+                y_hr &= image_subpixel_mask;
+
+                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
+                weight = (weight_array[x_hr + image_subpixel_scale] * 
+                          weight_array[y_hr + image_subpixel_scale] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = (weight_array[x_hr] * 
+                          weight_array[y_hr + image_subpixel_scale] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_y();
+                weight = (weight_array[x_hr + image_subpixel_scale] * 
+                          weight_array[y_hr] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = (weight_array[x_hr] * 
+                          weight_array[y_hr] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr;
+
+                fg[0] >>= image_filter_shift;
+                fg[1] >>= image_filter_shift;
+                fg[2] >>= image_filter_shift;
+
+                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
+                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
+                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //===================================================span_image_filter_rgb
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgb : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgb() {}
+        span_image_filter_rgb(source_type& src, 
+                              interpolator_type& inter,
+                              const image_filter_lut& filter) :
+            base_type(src, inter, &filter) 
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            int fg[3];
+            const value_type *fg_ptr;
+
+            unsigned     diameter     = base_type::filter().diameter();
+            int          start        = base_type::filter().start();
+            const int16* weight_array = base_type::filter().weight_array();
+
+            int x_count; 
+            int weight_y;
+
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+
+                x -= base_type::filter_dx_int();
+                y -= base_type::filter_dy_int();
+
+                int x_hr = x; 
+                int y_hr = y; 
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
+
+                int x_fract = x_hr & image_subpixel_mask;
+                unsigned y_count = diameter;
+
+                y_hr = image_subpixel_mask - (y_hr & image_subpixel_mask);
+                fg_ptr = (const value_type*)base_type::source().span(x_lr + start, 
+                                                                     y_lr + start, 
+                                                                     diameter);
+                for(;;)
+                {
+                    x_count  = diameter;
+                    weight_y = weight_array[y_hr];
+                    x_hr = image_subpixel_mask - x_fract;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     image_filter_shift;
+
+                        fg[0] += weight * *fg_ptr++;
+                        fg[1] += weight * *fg_ptr++;
+                        fg[2] += weight * *fg_ptr;
+
+                        if(--x_count == 0) break;
+                        x_hr  += image_subpixel_scale;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+
+                    if(--y_count == 0) break;
+                    y_hr  += image_subpixel_scale;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg[0] >>= image_filter_shift;
+                fg[1] >>= image_filter_shift;
+                fg[2] >>= image_filter_shift;
+
+                if(fg[0] < 0) fg[0] = 0;
+                if(fg[1] < 0) fg[1] = 0;
+                if(fg[2] < 0) fg[2] = 0;
+
+                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
+                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
+                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //==========================================span_image_resample_rgb_affine
+    template<class Source> 
+    class span_image_resample_rgb_affine : 
+    public span_image_resample_affine<Source>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef span_image_resample_affine<source_type> base_type;
+        typedef typename base_type::interpolator_type interpolator_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        {
+            base_shift      = color_type::base_shift,
+            base_mask       = color_type::base_mask,
+            downscale_shift = image_filter_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_image_resample_rgb_affine() {}
+        span_image_resample_rgb_affine(source_type& src, 
+                                       interpolator_type& inter,
+                                       const image_filter_lut& filter) :
+            base_type(src, inter, filter) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            long_type fg[3];
+
+            int diameter     = base_type::filter().diameter();
+            int filter_scale = diameter << image_subpixel_shift;
+            int radius_x     = (diameter * base_type::m_rx) >> 1;
+            int radius_y     = (diameter * base_type::m_ry) >> 1;
+            int len_x_lr     = 
+                (diameter * base_type::m_rx + image_subpixel_mask) >> 
+                    image_subpixel_shift;
+
+            const int16* weight_array = base_type::filter().weight_array();
+
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+
+                x += base_type::filter_dx_int() - radius_x;
+                y += base_type::filter_dy_int() - radius_y;
+
+                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
+
+                int y_lr = y >> image_subpixel_shift;
+                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
+                                base_type::m_ry_inv) >> 
+                                    image_subpixel_shift;
+                int total_weight = 0;
+                int x_lr = x >> image_subpixel_shift;
+                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
+                                base_type::m_rx_inv) >> 
+                                    image_subpixel_shift;
+
+                int x_hr2 = x_hr;
+                const value_type* fg_ptr = 
+                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
+                for(;;)
+                {
+                    int weight_y = weight_array[y_hr];
+                    x_hr = x_hr2;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     downscale_shift;
+
+                        fg[0] += *fg_ptr++ * weight;
+                        fg[1] += *fg_ptr++ * weight;
+                        fg[2] += *fg_ptr   * weight;
+                        total_weight += weight;
+                        x_hr  += base_type::m_rx_inv;
+                        if(x_hr >= filter_scale) break;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+                    y_hr += base_type::m_ry_inv;
+                    if(y_hr >= filter_scale) break;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg[0] /= total_weight;
+                fg[1] /= total_weight;
+                fg[2] /= total_weight;
+
+                if(fg[0] < 0) fg[0] = 0;
+                if(fg[1] < 0) fg[1] = 0;
+                if(fg[2] < 0) fg[2] = 0;
+
+                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
+                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
+                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+
+    //=================================================span_image_resample_rgb
+    template<class Source, class Interpolator>
+    class span_image_resample_rgb : 
+    public span_image_resample<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_resample<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask,
+            downscale_shift = image_filter_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_image_resample_rgb() {}
+        span_image_resample_rgb(source_type& src, 
+                                interpolator_type& inter,
+                                const image_filter_lut& filter) :
+            base_type(src, inter, filter)
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            long_type fg[3];
+
+            int diameter = base_type::filter().diameter();
+            int filter_scale = diameter << image_subpixel_shift;
+
+            const int16* weight_array = base_type::filter().weight_array();
+            do
+            {
+                int rx;
+                int ry;
+                int rx_inv = image_subpixel_scale;
+                int ry_inv = image_subpixel_scale;
+                base_type::interpolator().coordinates(&x,  &y);
+                base_type::interpolator().local_scale(&rx, &ry);
+                base_type::adjust_scale(&rx, &ry);
+
+                rx_inv = image_subpixel_scale * image_subpixel_scale / rx;
+                ry_inv = image_subpixel_scale * image_subpixel_scale / ry;
+
+                int radius_x = (diameter * rx) >> 1;
+                int radius_y = (diameter * ry) >> 1;
+                int len_x_lr = 
+                    (diameter * rx + image_subpixel_mask) >> 
+                        image_subpixel_shift;
+
+                x += base_type::filter_dx_int() - radius_x;
+                y += base_type::filter_dy_int() - radius_y;
+
+                fg[0] = fg[1] = fg[2] = image_filter_scale / 2;
+
+                int y_lr = y >> image_subpixel_shift;
+                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
+                               ry_inv) >> 
+                                   image_subpixel_shift;
+                int total_weight = 0;
+                int x_lr = x >> image_subpixel_shift;
+                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
+                               rx_inv) >> 
+                                   image_subpixel_shift;
+                int x_hr2 = x_hr;
+                const value_type* fg_ptr = 
+                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
+
+                for(;;)
+                {
+                    int weight_y = weight_array[y_hr];
+                    x_hr = x_hr2;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     downscale_shift;
+                        fg[0] += *fg_ptr++ * weight;
+                        fg[1] += *fg_ptr++ * weight;
+                        fg[2] += *fg_ptr   * weight;
+                        total_weight += weight;
+                        x_hr  += rx_inv;
+                        if(x_hr >= filter_scale) break;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+                    y_hr += ry_inv;
+                    if(y_hr >= filter_scale) break;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg[0] /= total_weight;
+                fg[1] /= total_weight;
+                fg[2] /= total_weight;
+
+                if(fg[0] < 0) fg[0] = 0;
+                if(fg[1] < 0) fg[1] = 0;
+                if(fg[2] < 0) fg[2] = 0;
+
+                if(fg[order_type::R] > base_mask) fg[order_type::R] = base_mask;
+                if(fg[order_type::G] > base_mask) fg[order_type::G] = base_mask;
+                if(fg[order_type::B] > base_mask) fg[order_type::B] = base_mask;
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = base_mask;
+
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+}
+
+
+#endif
+
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_image_filter_rgba.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter_rgba.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_image_filter_rgba.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_image_filter_rgba.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,920 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+#ifndef AGG_SPAN_IMAGE_FILTER_RGBA_INCLUDED
+#define AGG_SPAN_IMAGE_FILTER_RGBA_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_rgba.h"
+#include "agg_span_image_filter.h"
+
+
+namespace mapserver
+{
+
+    //==============================================span_image_filter_rgba_nn
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgba_nn : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgba_nn() {}
+        span_image_filter_rgba_nn(source_type& src, 
+                                  interpolator_type& inter) :
+            base_type(src, inter, 0) 
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+                const value_type* fg_ptr = (const value_type*)
+                    base_type::source().span(x >> image_subpixel_shift, 
+                                             y >> image_subpixel_shift, 
+                                             1);
+                span->r = fg_ptr[order_type::R];
+                span->g = fg_ptr[order_type::G];
+                span->b = fg_ptr[order_type::B];
+                span->a = fg_ptr[order_type::A];
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //=========================================span_image_filter_rgba_bilinear
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgba_bilinear : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgba_bilinear() {}
+        span_image_filter_rgba_bilinear(source_type& src, 
+                                        interpolator_type& inter) :
+            base_type(src, inter, 0) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            calc_type fg[4];
+            const value_type *fg_ptr;
+
+            do
+            {
+                int x_hr;
+                int y_hr;
+
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                unsigned weight;
+
+                fg[0] = 
+                fg[1] = 
+                fg[2] = 
+                fg[3] = image_subpixel_scale * image_subpixel_scale / 2;
+
+                x_hr &= image_subpixel_mask;
+                y_hr &= image_subpixel_mask;
+
+                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
+                weight = (image_subpixel_scale - x_hr) * 
+                         (image_subpixel_scale - y_hr);
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = x_hr * (image_subpixel_scale - y_hr);
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_y();
+                weight = (image_subpixel_scale - x_hr) * y_hr;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = x_hr * y_hr;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                span->r = value_type(fg[order_type::R] >> (image_subpixel_shift * 2));
+                span->g = value_type(fg[order_type::G] >> (image_subpixel_shift * 2));
+                span->b = value_type(fg[order_type::B] >> (image_subpixel_shift * 2));
+                span->a = value_type(fg[order_type::A] >> (image_subpixel_shift * 2));
+
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+    //====================================span_image_filter_rgba_bilinear_clip
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgba_bilinear_clip : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgba_bilinear_clip() {}
+        span_image_filter_rgba_bilinear_clip(source_type& src, 
+                                             const color_type& back_color,
+                                             interpolator_type& inter) :
+            base_type(src, inter, 0),
+            m_back_color(back_color)
+        {}
+        const color_type& background_color() const { return m_back_color; }
+        void background_color(const color_type& v)   { m_back_color = v; }
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            calc_type fg[4];
+            value_type back_r = m_back_color.r;
+            value_type back_g = m_back_color.g;
+            value_type back_b = m_back_color.b;
+            value_type back_a = m_back_color.a;
+
+            const value_type *fg_ptr;
+            int maxx = base_type::source().width() - 1;
+            int maxy = base_type::source().height() - 1;
+
+            do
+            {
+                int x_hr;
+                int y_hr;
+
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                unsigned weight;
+
+                if(x_lr >= 0    && y_lr >= 0 &&
+                   x_lr <  maxx && y_lr <  maxy) 
+                {
+                    fg[0] = 
+                    fg[1] = 
+                    fg[2] = 
+                    fg[3] = image_subpixel_scale * image_subpixel_scale / 2;
+
+                    x_hr &= image_subpixel_mask;
+                    y_hr &= image_subpixel_mask;
+
+                    fg_ptr = (const value_type*)
+                        base_type::source().row_ptr(y_lr) + (x_lr << 2);
+
+                    weight = (image_subpixel_scale - x_hr) * 
+                             (image_subpixel_scale - y_hr);
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+                    fg[3] += weight * *fg_ptr++;
+
+                    weight = x_hr * (image_subpixel_scale - y_hr);
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+                    fg[3] += weight * *fg_ptr++;
+
+                    ++y_lr;
+                    fg_ptr = (const value_type*)
+                        base_type::source().row_ptr(y_lr) + (x_lr << 2);
+
+                    weight = (image_subpixel_scale - x_hr) * y_hr;
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+                    fg[3] += weight * *fg_ptr++;
+
+                    weight = x_hr * y_hr;
+                    fg[0] += weight * *fg_ptr++;
+                    fg[1] += weight * *fg_ptr++;
+                    fg[2] += weight * *fg_ptr++;
+                    fg[3] += weight * *fg_ptr++;
+
+                    fg[0] >>= image_subpixel_shift * 2;
+                    fg[1] >>= image_subpixel_shift * 2;
+                    fg[2] >>= image_subpixel_shift * 2;
+                    fg[3] >>= image_subpixel_shift * 2;
+                }
+                else
+                {
+                    if(x_lr < -1   || y_lr < -1 ||
+                       x_lr > maxx || y_lr > maxy)
+                    {
+                        fg[order_type::R] = back_r;
+                        fg[order_type::G] = back_g;
+                        fg[order_type::B] = back_b;
+                        fg[order_type::A] = back_a;
+                    }
+                    else
+                    {
+                        fg[0] = 
+                        fg[1] = 
+                        fg[2] = 
+                        fg[3] = image_subpixel_scale * image_subpixel_scale / 2;
+
+                        x_hr &= image_subpixel_mask;
+                        y_hr &= image_subpixel_mask;
+
+                        weight = (image_subpixel_scale - x_hr) * 
+                                 (image_subpixel_scale - y_hr);
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
+
+                            fg[0] += weight * *fg_ptr++;
+                            fg[1] += weight * *fg_ptr++;
+                            fg[2] += weight * *fg_ptr++;
+                            fg[3] += weight * *fg_ptr++;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            fg[order_type::A] += back_a * weight;
+                        }
+
+                        x_lr++;
+
+                        weight = x_hr * (image_subpixel_scale - y_hr);
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
+
+                            fg[0] += weight * *fg_ptr++;
+                            fg[1] += weight * *fg_ptr++;
+                            fg[2] += weight * *fg_ptr++;
+                            fg[3] += weight * *fg_ptr++;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            fg[order_type::A] += back_a * weight;
+                        }
+
+                        x_lr--;
+                        y_lr++;
+
+                        weight = (image_subpixel_scale - x_hr) * y_hr;
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
+
+                            fg[0] += weight * *fg_ptr++;
+                            fg[1] += weight * *fg_ptr++;
+                            fg[2] += weight * *fg_ptr++;
+                            fg[3] += weight * *fg_ptr++;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            fg[order_type::A] += back_a * weight;
+                        }
+
+                        x_lr++;
+
+                        weight = x_hr * y_hr;
+                        if(x_lr >= 0    && y_lr >= 0 &&
+                           x_lr <= maxx && y_lr <= maxy)
+                        {
+                            fg_ptr = (const value_type*)
+                                base_type::source().row_ptr(y_lr) + (x_lr << 2);
+
+                            fg[0] += weight * *fg_ptr++;
+                            fg[1] += weight * *fg_ptr++;
+                            fg[2] += weight * *fg_ptr++;
+                            fg[3] += weight * *fg_ptr++;
+                        }
+                        else
+                        {
+                            fg[order_type::R] += back_r * weight;
+                            fg[order_type::G] += back_g * weight;
+                            fg[order_type::B] += back_b * weight;
+                            fg[order_type::A] += back_a * weight;
+                        }
+
+                        fg[0] >>= image_subpixel_shift * 2;
+                        fg[1] >>= image_subpixel_shift * 2;
+                        fg[2] >>= image_subpixel_shift * 2;
+                        fg[3] >>= image_subpixel_shift * 2;
+                    }
+                }
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = (value_type)fg[order_type::A];
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    private:
+        color_type m_back_color;
+    };
+
+
+    //==============================================span_image_filter_rgba_2x2
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgba_2x2 : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgba_2x2() {}
+        span_image_filter_rgba_2x2(source_type& src, 
+                                   interpolator_type& inter,
+                                   const image_filter_lut& filter) :
+            base_type(src, inter, &filter) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            calc_type fg[4];
+
+            const value_type *fg_ptr;
+            const int16* weight_array = base_type::filter().weight_array() + 
+                                        ((base_type::filter().diameter()/2 - 1) << 
+                                          image_subpixel_shift);
+
+            do
+            {
+                int x_hr;
+                int y_hr;
+
+                base_type::interpolator().coordinates(&x_hr, &y_hr);
+
+                x_hr -= base_type::filter_dx_int();
+                y_hr -= base_type::filter_dy_int();
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                unsigned weight;
+                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
+
+                x_hr &= image_subpixel_mask;
+                y_hr &= image_subpixel_mask;
+
+                fg_ptr = (const value_type*)base_type::source().span(x_lr, y_lr, 2);
+                weight = (weight_array[x_hr + image_subpixel_scale] * 
+                          weight_array[y_hr + image_subpixel_scale] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = (weight_array[x_hr] * 
+                          weight_array[y_hr + image_subpixel_scale] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_y();
+                weight = (weight_array[x_hr + image_subpixel_scale] * 
+                          weight_array[y_hr] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                fg_ptr = (const value_type*)base_type::source().next_x();
+                weight = (weight_array[x_hr] * 
+                          weight_array[y_hr] + 
+                          image_filter_scale / 2) >> 
+                          image_filter_shift;
+                fg[0] += weight * *fg_ptr++;
+                fg[1] += weight * *fg_ptr++;
+                fg[2] += weight * *fg_ptr++;
+                fg[3] += weight * *fg_ptr;
+
+                fg[0] >>= image_filter_shift;
+                fg[1] >>= image_filter_shift;
+                fg[2] >>= image_filter_shift;
+                fg[3] >>= image_filter_shift;
+
+                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
+                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
+                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
+                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = (value_type)fg[order_type::A];
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //==================================================span_image_filter_rgba
+    template<class Source, class Interpolator> 
+    class span_image_filter_rgba : 
+    public span_image_filter<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_filter<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask
+        };
+
+        //--------------------------------------------------------------------
+        span_image_filter_rgba() {}
+        span_image_filter_rgba(source_type& src, 
+                               interpolator_type& inter,
+                               const image_filter_lut& filter) :
+            base_type(src, inter, &filter) 
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            int fg[4];
+            const value_type *fg_ptr;
+
+            unsigned     diameter     = base_type::filter().diameter();
+            int          start        = base_type::filter().start();
+            const int16* weight_array = base_type::filter().weight_array();
+
+            int x_count; 
+            int weight_y;
+
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+
+                x -= base_type::filter_dx_int();
+                y -= base_type::filter_dy_int();
+
+                int x_hr = x; 
+                int y_hr = y; 
+
+                int x_lr = x_hr >> image_subpixel_shift;
+                int y_lr = y_hr >> image_subpixel_shift;
+
+                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
+
+                int x_fract = x_hr & image_subpixel_mask;
+                unsigned y_count = diameter;
+
+                y_hr = image_subpixel_mask - (y_hr & image_subpixel_mask);
+                fg_ptr = (const value_type*)base_type::source().span(x_lr + start, 
+                                                                     y_lr + start, 
+                                                                     diameter);
+                for(;;)
+                {
+                    x_count  = diameter;
+                    weight_y = weight_array[y_hr];
+                    x_hr = image_subpixel_mask - x_fract;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     image_filter_shift;
+
+                        fg[0] += weight * *fg_ptr++;
+                        fg[1] += weight * *fg_ptr++;
+                        fg[2] += weight * *fg_ptr++;
+                        fg[3] += weight * *fg_ptr;
+
+                        if(--x_count == 0) break;
+                        x_hr  += image_subpixel_scale;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+
+                    if(--y_count == 0) break;
+                    y_hr  += image_subpixel_scale;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg[0] >>= image_filter_shift;
+                fg[1] >>= image_filter_shift;
+                fg[2] >>= image_filter_shift;
+                fg[3] >>= image_filter_shift;
+
+                if(fg[0] < 0) fg[0] = 0;
+                if(fg[1] < 0) fg[1] = 0;
+                if(fg[2] < 0) fg[2] = 0;
+                if(fg[3] < 0) fg[3] = 0;
+
+                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
+                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
+                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
+                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = (value_type)fg[order_type::A];
+                ++span;
+                ++base_type::interpolator();
+
+            } while(--len);
+        }
+    };
+
+
+
+    //========================================span_image_resample_rgba_affine
+    template<class Source> 
+    class span_image_resample_rgba_affine : 
+    public span_image_resample_affine<Source>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef span_image_resample_affine<source_type> base_type;
+        typedef typename base_type::interpolator_type interpolator_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        {
+            base_shift      = color_type::base_shift,
+            base_mask       = color_type::base_mask,
+            downscale_shift = image_filter_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_image_resample_rgba_affine() {}
+        span_image_resample_rgba_affine(source_type& src, 
+                                        interpolator_type& inter,
+                                        const image_filter_lut& filter) :
+            base_type(src, inter, filter) 
+        {}
+
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+
+            long_type fg[4];
+
+            int diameter     = base_type::filter().diameter();
+            int filter_scale = diameter << image_subpixel_shift;
+            int radius_x     = (diameter * base_type::m_rx) >> 1;
+            int radius_y     = (diameter * base_type::m_ry) >> 1;
+            int len_x_lr     = 
+                (diameter * base_type::m_rx + image_subpixel_mask) >> 
+                    image_subpixel_shift;
+
+            const int16* weight_array = base_type::filter().weight_array();
+
+            do
+            {
+                base_type::interpolator().coordinates(&x, &y);
+
+                x += base_type::filter_dx_int() - radius_x;
+                y += base_type::filter_dy_int() - radius_y;
+
+                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
+
+                int y_lr = y >> image_subpixel_shift;
+                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
+                                base_type::m_ry_inv) >> 
+                                    image_subpixel_shift;
+                int total_weight = 0;
+                int x_lr = x >> image_subpixel_shift;
+                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
+                                base_type::m_rx_inv) >> 
+                                    image_subpixel_shift;
+
+                int x_hr2 = x_hr;
+                const value_type* fg_ptr = 
+                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
+                for(;;)
+                {
+                    int weight_y = weight_array[y_hr];
+                    x_hr = x_hr2;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     downscale_shift;
+
+                        fg[0] += *fg_ptr++ * weight;
+                        fg[1] += *fg_ptr++ * weight;
+                        fg[2] += *fg_ptr++ * weight;
+                        fg[3] += *fg_ptr++ * weight;
+                        total_weight += weight;
+                        x_hr  += base_type::m_rx_inv;
+                        if(x_hr >= filter_scale) break;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+                    y_hr += base_type::m_ry_inv;
+                    if(y_hr >= filter_scale) break;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg[0] /= total_weight;
+                fg[1] /= total_weight;
+                fg[2] /= total_weight;
+                fg[3] /= total_weight;
+
+                if(fg[0] < 0) fg[0] = 0;
+                if(fg[1] < 0) fg[1] = 0;
+                if(fg[2] < 0) fg[2] = 0;
+                if(fg[3] < 0) fg[3] = 0;
+
+                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
+                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
+                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
+                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = (value_type)fg[order_type::A];
+
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+
+    //==============================================span_image_resample_rgba
+    template<class Source, class Interpolator>
+    class span_image_resample_rgba : 
+    public span_image_resample<Source, Interpolator>
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef Interpolator interpolator_type;
+        typedef span_image_resample<source_type, interpolator_type> base_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::long_type long_type;
+        enum base_scale_e
+        {
+            base_shift = color_type::base_shift,
+            base_mask  = color_type::base_mask,
+            downscale_shift = image_filter_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_image_resample_rgba() {}
+        span_image_resample_rgba(source_type& src, 
+                                 interpolator_type& inter,
+                                 const image_filter_lut& filter) :
+            base_type(src, inter, filter)
+        {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {
+            base_type::interpolator().begin(x + base_type::filter_dx_dbl(), 
+                                            y + base_type::filter_dy_dbl(), len);
+            long_type fg[4];
+
+            int diameter = base_type::filter().diameter();
+            int filter_scale = diameter << image_subpixel_shift;
+
+            const int16* weight_array = base_type::filter().weight_array();
+            do
+            {
+                int rx;
+                int ry;
+                int rx_inv = image_subpixel_scale;
+                int ry_inv = image_subpixel_scale;
+                base_type::interpolator().coordinates(&x,  &y);
+                base_type::interpolator().local_scale(&rx, &ry);
+                base_type::adjust_scale(&rx, &ry);
+
+                rx_inv = image_subpixel_scale * image_subpixel_scale / rx;
+                ry_inv = image_subpixel_scale * image_subpixel_scale / ry;
+
+                int radius_x = (diameter * rx) >> 1;
+                int radius_y = (diameter * ry) >> 1;
+                int len_x_lr = 
+                    (diameter * rx + image_subpixel_mask) >> 
+                        image_subpixel_shift;
+
+                x += base_type::filter_dx_int() - radius_x;
+                y += base_type::filter_dy_int() - radius_y;
+
+                fg[0] = fg[1] = fg[2] = fg[3] = image_filter_scale / 2;
+
+                int y_lr = y >> image_subpixel_shift;
+                int y_hr = ((image_subpixel_mask - (y & image_subpixel_mask)) * 
+                               ry_inv) >> 
+                                   image_subpixel_shift;
+                int total_weight = 0;
+                int x_lr = x >> image_subpixel_shift;
+                int x_hr = ((image_subpixel_mask - (x & image_subpixel_mask)) * 
+                               rx_inv) >> 
+                                   image_subpixel_shift;
+                int x_hr2 = x_hr;
+                const value_type* fg_ptr = 
+                    (const value_type*)base_type::source().span(x_lr, y_lr, len_x_lr);
+
+                for(;;)
+                {
+                    int weight_y = weight_array[y_hr];
+                    x_hr = x_hr2;
+                    for(;;)
+                    {
+                        int weight = (weight_y * weight_array[x_hr] + 
+                                     image_filter_scale / 2) >> 
+                                     downscale_shift;
+                        fg[0] += *fg_ptr++ * weight;
+                        fg[1] += *fg_ptr++ * weight;
+                        fg[2] += *fg_ptr++ * weight;
+                        fg[3] += *fg_ptr++ * weight;
+                        total_weight += weight;
+                        x_hr  += rx_inv;
+                        if(x_hr >= filter_scale) break;
+                        fg_ptr = (const value_type*)base_type::source().next_x();
+                    }
+                    y_hr += ry_inv;
+                    if(y_hr >= filter_scale) break;
+                    fg_ptr = (const value_type*)base_type::source().next_y();
+                }
+
+                fg[0] /= total_weight;
+                fg[1] /= total_weight;
+                fg[2] /= total_weight;
+                fg[3] /= total_weight;
+
+                if(fg[0] < 0) fg[0] = 0;
+                if(fg[1] < 0) fg[1] = 0;
+                if(fg[2] < 0) fg[2] = 0;
+                if(fg[3] < 0) fg[3] = 0;
+
+                if(fg[order_type::A] > base_mask)         fg[order_type::A] = base_mask;
+                if(fg[order_type::R] > fg[order_type::A]) fg[order_type::R] = fg[order_type::A];
+                if(fg[order_type::G] > fg[order_type::A]) fg[order_type::G] = fg[order_type::A];
+                if(fg[order_type::B] > fg[order_type::A]) fg[order_type::B] = fg[order_type::A];
+
+                span->r = (value_type)fg[order_type::R];
+                span->g = (value_type)fg[order_type::G];
+                span->b = (value_type)fg[order_type::B];
+                span->a = (value_type)fg[order_type::A];
+
+                ++span;
+                ++base_type::interpolator();
+            } while(--len);
+        }
+    };
+
+
+}
+
+
+#endif
+
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_adaptor.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_adaptor.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_adaptor.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_adaptor.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,77 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_INTERPOLATOR_ADAPTOR_INCLUDED
+#define AGG_SPAN_INTERPOLATOR_ADAPTOR_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //===============================================span_interpolator_adaptor
+    template<class Interpolator, class Distortion>
+    class span_interpolator_adaptor : public Interpolator
+    {
+    public:
+        typedef Interpolator base_type;
+        typedef typename base_type::trans_type trans_type;
+        typedef Distortion distortion_type;
+
+        //--------------------------------------------------------------------
+        span_interpolator_adaptor() {}
+        span_interpolator_adaptor(const trans_type& trans, 
+                                  const distortion_type& dist) :
+            base_type(trans),
+            m_distortion(&dist)
+        {   
+        }
+
+        //--------------------------------------------------------------------
+        span_interpolator_adaptor(const trans_type& trans,
+                                  const distortion_type& dist,
+                                  double x, double y, unsigned len) :
+            base_type(trans, x, y, len),
+            m_distortion(&dist)
+        {
+        }
+
+        //--------------------------------------------------------------------
+        const distortion_type& distortion() const
+        {
+            return *m_distortion;
+        }
+
+        //--------------------------------------------------------------------
+        void distortion(const distortion_type& dist)
+        {
+            m_distortion = dist;
+        }
+
+        //--------------------------------------------------------------------
+        void coordinates(int* x, int* y) const
+        {
+            base_type::coordinates(x, y);
+            m_distortion->calculate(x, y);
+        }
+
+    private:
+        //--------------------------------------------------------------------
+        const distortion_type* m_distortion;
+    };
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_linear.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_linear.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_linear.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_linear.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,232 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_INTERPOLATOR_LINEAR_INCLUDED
+#define AGG_SPAN_INTERPOLATOR_LINEAR_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_dda_line.h"
+#include "agg_trans_affine.h"
+
+namespace mapserver
+{
+
+    //================================================span_interpolator_linear
+    template<class Transformer = trans_affine, unsigned SubpixelShift = 8> 
+    class span_interpolator_linear
+    {
+    public:
+        typedef Transformer trans_type;
+
+        enum subpixel_scale_e
+        {
+            subpixel_shift = SubpixelShift,
+            subpixel_scale  = 1 << subpixel_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_interpolator_linear() {}
+        span_interpolator_linear(const trans_type& trans) : m_trans(&trans) {}
+        span_interpolator_linear(const trans_type& trans,
+                                 double x, double y, unsigned len) :
+            m_trans(&trans)
+        {
+            begin(x, y, len);
+        }
+
+        //----------------------------------------------------------------
+        const trans_type& transformer() const { return *m_trans; }
+        void transformer(const trans_type& trans) { m_trans = &trans; }
+
+        //----------------------------------------------------------------
+        void begin(double x, double y, unsigned len)
+        {
+            double tx;
+            double ty;
+
+            tx = x;
+            ty = y;
+            m_trans->transform(&tx, &ty);
+            int x1 = iround(tx * subpixel_scale);
+            int y1 = iround(ty * subpixel_scale);
+
+            tx = x + len;
+            ty = y;
+            m_trans->transform(&tx, &ty);
+            int x2 = iround(tx * subpixel_scale);
+            int y2 = iround(ty * subpixel_scale);
+
+            m_li_x = dda2_line_interpolator(x1, x2, len);
+            m_li_y = dda2_line_interpolator(y1, y2, len);
+        }
+
+        //----------------------------------------------------------------
+        void resynchronize(double xe, double ye, unsigned len)
+        {
+            m_trans->transform(&xe, &ye);
+            m_li_x = dda2_line_interpolator(m_li_x.y(), iround(xe * subpixel_scale), len);
+            m_li_y = dda2_line_interpolator(m_li_y.y(), iround(ye * subpixel_scale), len);
+        }
+    
+        //----------------------------------------------------------------
+        void operator++()
+        {
+            ++m_li_x;
+            ++m_li_y;
+        }
+
+        //----------------------------------------------------------------
+        void coordinates(int* x, int* y) const
+        {
+            *x = m_li_x.y();
+            *y = m_li_y.y();
+        }
+
+    private:
+        const trans_type* m_trans;
+        dda2_line_interpolator m_li_x;
+        dda2_line_interpolator m_li_y;
+    };
+
+
+
+
+
+
+    //=====================================span_interpolator_linear_subdiv
+    template<class Transformer = trans_affine, unsigned SubpixelShift = 8> 
+    class span_interpolator_linear_subdiv
+    {
+    public:
+        typedef Transformer trans_type;
+
+        enum subpixel_scale_e
+        {
+            subpixel_shift = SubpixelShift,
+            subpixel_scale = 1 << subpixel_shift
+        };
+
+
+        //----------------------------------------------------------------
+        span_interpolator_linear_subdiv() :
+            m_subdiv_shift(4),
+            m_subdiv_size(1 << m_subdiv_shift),
+            m_subdiv_mask(m_subdiv_size - 1) {}
+
+        span_interpolator_linear_subdiv(const trans_type& trans, 
+                                        unsigned subdiv_shift = 4) : 
+            m_subdiv_shift(subdiv_shift),
+            m_subdiv_size(1 << m_subdiv_shift),
+            m_subdiv_mask(m_subdiv_size - 1),
+            m_trans(&trans) {}
+
+        span_interpolator_linear_subdiv(const trans_type& trans,
+                                        double x, double y, unsigned len,
+                                        unsigned subdiv_shift = 4) :
+            m_subdiv_shift(subdiv_shift),
+            m_subdiv_size(1 << m_subdiv_shift),
+            m_subdiv_mask(m_subdiv_size - 1),
+            m_trans(&trans)
+        {
+            begin(x, y, len);
+        }
+
+        //----------------------------------------------------------------
+        const trans_type& transformer() const { return *m_trans; }
+        void transformer(const trans_type& trans) { m_trans = &trans; }
+
+        //----------------------------------------------------------------
+        unsigned subdiv_shift() const { return m_subdiv_shift; }
+        void subdiv_shift(unsigned shift) 
+        {
+            m_subdiv_shift = shift;
+            m_subdiv_size = 1 << m_subdiv_shift;
+            m_subdiv_mask = m_subdiv_size - 1;
+        }
+
+        //----------------------------------------------------------------
+        void begin(double x, double y, unsigned len)
+        {
+            double tx;
+            double ty;
+            m_pos   = 1;
+            m_src_x = iround(x * subpixel_scale) + subpixel_scale;
+            m_src_y = y;
+            m_len   = len;
+
+            if(len > m_subdiv_size) len = m_subdiv_size;
+            tx = x;
+            ty = y;
+            m_trans->transform(&tx, &ty);
+            int x1 = iround(tx * subpixel_scale);
+            int y1 = iround(ty * subpixel_scale);
+
+            tx = x + len;
+            ty = y;
+            m_trans->transform(&tx, &ty);
+
+            m_li_x = dda2_line_interpolator(x1, iround(tx * subpixel_scale), len);
+            m_li_y = dda2_line_interpolator(y1, iround(ty * subpixel_scale), len);
+        }
+
+        //----------------------------------------------------------------
+        void operator++()
+        {
+            ++m_li_x;
+            ++m_li_y;
+            if(m_pos >= m_subdiv_size)
+            {
+                unsigned len = m_len;
+                if(len > m_subdiv_size) len = m_subdiv_size;
+                double tx = double(m_src_x) / double(subpixel_scale) + len;
+                double ty = m_src_y;
+                m_trans->transform(&tx, &ty);
+                m_li_x = dda2_line_interpolator(m_li_x.y(), iround(tx * subpixel_scale), len);
+                m_li_y = dda2_line_interpolator(m_li_y.y(), iround(ty * subpixel_scale), len);
+                m_pos = 0;
+            }
+            m_src_x += subpixel_scale;
+            ++m_pos;
+            --m_len;
+        }
+
+        //----------------------------------------------------------------
+        void coordinates(int* x, int* y) const
+        {
+            *x = m_li_x.y();
+            *y = m_li_y.y();
+        }
+
+    private:
+        unsigned m_subdiv_shift;
+        unsigned m_subdiv_size;
+        unsigned m_subdiv_mask;
+        const trans_type* m_trans;
+        dda2_line_interpolator m_li_x;
+        dda2_line_interpolator m_li_y;
+        int      m_src_x;
+        double   m_src_y;
+        unsigned m_pos;
+        unsigned m_len;
+    };
+
+
+}
+
+
+
+#endif
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_persp.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_persp.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_persp.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_persp.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,462 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_SPAN_INTERPOLATOR_PERSP_INCLUDED
+#define AGG_SPAN_INTERPOLATOR_PERSP_INCLUDED
+
+#include "agg_trans_perspective.h"
+#include "agg_dda_line.h"
+
+namespace mapserver
+{
+
+
+
+    //===========================================span_interpolator_persp_exact
+    template<unsigned SubpixelShift = 8> 
+    class span_interpolator_persp_exact
+    {
+    public:
+        typedef trans_perspective trans_type;
+        typedef trans_perspective::iterator_x iterator_type;
+        enum subpixel_scale_e
+        {
+            subpixel_shift = SubpixelShift,
+            subpixel_scale = 1 << subpixel_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_interpolator_persp_exact() {}
+
+        //--------------------------------------------------------------------
+        // Arbitrary quadrangle transformations
+        span_interpolator_persp_exact(const double* src, const double* dst) 
+        {
+            quad_to_quad(src, dst);
+        }
+
+        //--------------------------------------------------------------------
+        // Direct transformations 
+        span_interpolator_persp_exact(double x1, double y1, 
+                                      double x2, double y2, 
+                                      const double* quad)
+        {
+            rect_to_quad(x1, y1, x2, y2, quad);
+        }
+
+        //--------------------------------------------------------------------
+        // Reverse transformations 
+        span_interpolator_persp_exact(const double* quad, 
+                                      double x1, double y1, 
+                                      double x2, double y2)
+        {
+            quad_to_rect(quad, x1, y1, x2, y2);
+        }
+
+        //--------------------------------------------------------------------
+        // Set the transformations using two arbitrary quadrangles.
+        void quad_to_quad(const double* src, const double* dst)
+        {
+            m_trans_dir.quad_to_quad(src, dst);
+            m_trans_inv.quad_to_quad(dst, src);
+        }
+
+        //--------------------------------------------------------------------
+        // Set the direct transformations, i.e., rectangle -> quadrangle
+        void rect_to_quad(double x1, double y1, double x2, double y2, 
+                          const double* quad)
+        {
+            double src[8];
+            src[0] = src[6] = x1;
+            src[2] = src[4] = x2;
+            src[1] = src[3] = y1;
+            src[5] = src[7] = y2;
+            quad_to_quad(src, quad);
+        }
+
+
+        //--------------------------------------------------------------------
+        // Set the reverse transformations, i.e., quadrangle -> rectangle
+        void quad_to_rect(const double* quad, 
+                          double x1, double y1, double x2, double y2)
+        {
+            double dst[8];
+            dst[0] = dst[6] = x1;
+            dst[2] = dst[4] = x2;
+            dst[1] = dst[3] = y1;
+            dst[5] = dst[7] = y2;
+            quad_to_quad(quad, dst);
+        }
+
+        //--------------------------------------------------------------------
+        // Check if the equations were solved successfully
+        bool is_valid() const { return m_trans_dir.is_valid(); }
+
+        //----------------------------------------------------------------
+        void begin(double x, double y, unsigned len)
+        {
+            m_iterator = m_trans_dir.begin(x, y, 1.0);
+            double xt = m_iterator.x;
+            double yt = m_iterator.y;
+
+            double dx;
+            double dy;
+            const double delta = 1/double(subpixel_scale);
+            dx = xt + delta;
+            dy = yt;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sx1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+            dx = xt;
+            dy = yt + delta;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sy1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            x += len;
+            xt = x;
+            yt = y;
+            m_trans_dir.transform(&xt, &yt);
+
+            dx = xt + delta;
+            dy = yt;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+            dx = xt;
+            dy = yt + delta;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
+            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
+        }
+
+
+        //----------------------------------------------------------------
+        void resynchronize(double xe, double ye, unsigned len)
+        {
+            // Assume x1,y1 are equal to the ones at the previous end point 
+            int sx1 = m_scale_x.y();
+            int sy1 = m_scale_y.y();
+
+            // Calculate transformed coordinates at x2,y2 
+            double xt = xe;
+            double yt = ye;
+            m_trans_dir.transform(&xt, &yt);
+
+            const double delta = 1/double(subpixel_scale);
+            double dx;
+            double dy;
+
+            // Calculate scale by X at x2,y2
+            dx = xt + delta;
+            dy = yt;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= xe;
+            dy -= ye;
+            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Calculate scale by Y at x2,y2
+            dx = xt;
+            dy = yt + delta;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= xe;
+            dy -= ye;
+            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Initialize the interpolators
+            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
+            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
+        }
+
+
+
+        //----------------------------------------------------------------
+        void operator++()
+        {
+            ++m_iterator;
+            ++m_scale_x;
+            ++m_scale_y;
+        }
+
+        //----------------------------------------------------------------
+        void coordinates(int* x, int* y) const
+        {
+            *x = iround(m_iterator.x * subpixel_scale);
+            *y = iround(m_iterator.y * subpixel_scale);
+        }
+
+        //----------------------------------------------------------------
+        void local_scale(int* x, int* y)
+        {
+            *x = m_scale_x.y();
+            *y = m_scale_y.y();
+        }
+
+        //----------------------------------------------------------------
+        void transform(double* x, double* y) const
+        {
+            m_trans_dir.transform(x, y);
+        }
+        
+    private:
+        trans_type             m_trans_dir;
+        trans_type             m_trans_inv;
+        iterator_type          m_iterator;
+        dda2_line_interpolator m_scale_x;
+        dda2_line_interpolator m_scale_y;
+    };
+
+
+
+
+
+
+
+
+
+
+
+    //============================================span_interpolator_persp_lerp
+    template<unsigned SubpixelShift = 8> 
+    class span_interpolator_persp_lerp
+    {
+    public:
+        typedef trans_perspective trans_type;
+        enum subpixel_scale_e
+        {
+            subpixel_shift = SubpixelShift,
+            subpixel_scale = 1 << subpixel_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_interpolator_persp_lerp() {}
+
+        //--------------------------------------------------------------------
+        // Arbitrary quadrangle transformations
+        span_interpolator_persp_lerp(const double* src, const double* dst) 
+        {
+            quad_to_quad(src, dst);
+        }
+
+        //--------------------------------------------------------------------
+        // Direct transformations 
+        span_interpolator_persp_lerp(double x1, double y1, 
+                                     double x2, double y2, 
+                                     const double* quad)
+        {
+            rect_to_quad(x1, y1, x2, y2, quad);
+        }
+
+        //--------------------------------------------------------------------
+        // Reverse transformations 
+        span_interpolator_persp_lerp(const double* quad, 
+                                     double x1, double y1, 
+                                     double x2, double y2)
+        {
+            quad_to_rect(quad, x1, y1, x2, y2);
+        }
+
+        //--------------------------------------------------------------------
+        // Set the transformations using two arbitrary quadrangles.
+        void quad_to_quad(const double* src, const double* dst)
+        {
+            m_trans_dir.quad_to_quad(src, dst);
+            m_trans_inv.quad_to_quad(dst, src);
+        }
+
+        //--------------------------------------------------------------------
+        // Set the direct transformations, i.e., rectangle -> quadrangle
+        void rect_to_quad(double x1, double y1, double x2, double y2, 
+                          const double* quad)
+        {
+            double src[8];
+            src[0] = src[6] = x1;
+            src[2] = src[4] = x2;
+            src[1] = src[3] = y1;
+            src[5] = src[7] = y2;
+            quad_to_quad(src, quad);
+        }
+
+
+        //--------------------------------------------------------------------
+        // Set the reverse transformations, i.e., quadrangle -> rectangle
+        void quad_to_rect(const double* quad, 
+                          double x1, double y1, double x2, double y2)
+        {
+            double dst[8];
+            dst[0] = dst[6] = x1;
+            dst[2] = dst[4] = x2;
+            dst[1] = dst[3] = y1;
+            dst[5] = dst[7] = y2;
+            quad_to_quad(quad, dst);
+        }
+
+        //--------------------------------------------------------------------
+        // Check if the equations were solved successfully
+        bool is_valid() const { return m_trans_dir.is_valid(); }
+
+        //----------------------------------------------------------------
+        void begin(double x, double y, unsigned len)
+        {
+            // Calculate transformed coordinates at x1,y1 
+            double xt = x;
+            double yt = y;
+            m_trans_dir.transform(&xt, &yt);
+            int x1 = iround(xt * subpixel_scale);
+            int y1 = iround(yt * subpixel_scale);
+
+            double dx;
+            double dy;
+            const double delta = 1/double(subpixel_scale);
+
+            // Calculate scale by X at x1,y1
+            dx = xt + delta;
+            dy = yt;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sx1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Calculate scale by Y at x1,y1
+            dx = xt;
+            dy = yt + delta;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sy1 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Calculate transformed coordinates at x2,y2 
+            x += len;
+            xt = x;
+            yt = y;
+            m_trans_dir.transform(&xt, &yt);
+            int x2 = iround(xt * subpixel_scale);
+            int y2 = iround(yt * subpixel_scale);
+
+            // Calculate scale by X at x2,y2
+            dx = xt + delta;
+            dy = yt;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Calculate scale by Y at x2,y2
+            dx = xt;
+            dy = yt + delta;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= x;
+            dy -= y;
+            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Initialize the interpolators
+            m_coord_x = dda2_line_interpolator(x1,  x2,  len);
+            m_coord_y = dda2_line_interpolator(y1,  y2,  len);
+            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
+            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
+        }
+
+
+        //----------------------------------------------------------------
+        void resynchronize(double xe, double ye, unsigned len)
+        {
+            // Assume x1,y1 are equal to the ones at the previous end point 
+            int x1  = m_coord_x.y();
+            int y1  = m_coord_y.y();
+            int sx1 = m_scale_x.y();
+            int sy1 = m_scale_y.y();
+
+            // Calculate transformed coordinates at x2,y2 
+            double xt = xe;
+            double yt = ye;
+            m_trans_dir.transform(&xt, &yt);
+            int x2 = iround(xt * subpixel_scale);
+            int y2 = iround(yt * subpixel_scale);
+
+            const double delta = 1/double(subpixel_scale);
+            double dx;
+            double dy;
+
+            // Calculate scale by X at x2,y2
+            dx = xt + delta;
+            dy = yt;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= xe;
+            dy -= ye;
+            int sx2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Calculate scale by Y at x2,y2
+            dx = xt;
+            dy = yt + delta;
+            m_trans_inv.transform(&dx, &dy);
+            dx -= xe;
+            dy -= ye;
+            int sy2 = uround(subpixel_scale/sqrt(dx*dx + dy*dy)) >> subpixel_shift;
+
+            // Initialize the interpolators
+            m_coord_x = dda2_line_interpolator(x1,  x2,  len);
+            m_coord_y = dda2_line_interpolator(y1,  y2,  len);
+            m_scale_x = dda2_line_interpolator(sx1, sx2, len);
+            m_scale_y = dda2_line_interpolator(sy1, sy2, len);
+        }
+
+
+        //----------------------------------------------------------------
+        void operator++()
+        {
+            ++m_coord_x;
+            ++m_coord_y;
+            ++m_scale_x;
+            ++m_scale_y;
+        }
+
+        //----------------------------------------------------------------
+        void coordinates(int* x, int* y) const
+        {
+            *x = m_coord_x.y();
+            *y = m_coord_y.y();
+        }
+
+        //----------------------------------------------------------------
+        void local_scale(int* x, int* y)
+        {
+            *x = m_scale_x.y();
+            *y = m_scale_y.y();
+        }
+
+        //----------------------------------------------------------------
+        void transform(double* x, double* y) const
+        {
+            m_trans_dir.transform(x, y);
+        }
+        
+    private:
+        trans_type             m_trans_dir;
+        trans_type             m_trans_inv;
+        dda2_line_interpolator m_coord_x;
+        dda2_line_interpolator m_coord_y;
+        dda2_line_interpolator m_scale_x;
+        dda2_line_interpolator m_scale_y;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_trans.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_trans.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_interpolator_trans.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_interpolator_trans.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,92 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Horizontal span interpolator for use with an arbitrary transformer
+// The efficiency highly depends on the operations done in the transformer
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_INTERPOLATOR_TRANS_INCLUDED
+#define AGG_SPAN_INTERPOLATOR_TRANS_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //=================================================span_interpolator_trans
+    template<class Transformer, unsigned SubpixelShift = 8> 
+    class span_interpolator_trans
+    {
+    public:
+        typedef Transformer trans_type;
+        enum subpixel_scale_e
+        {
+            subpixel_shift = SubpixelShift,
+            subpixel_scale = 1 << subpixel_shift
+        };
+
+        //--------------------------------------------------------------------
+        span_interpolator_trans() {}
+        span_interpolator_trans(const trans_type& trans) : m_trans(&trans) {}
+        span_interpolator_trans(const trans_type& trans,
+                                double x, double y, unsigned) :
+            m_trans(&trans)
+        {
+            begin(x, y, 0);
+        }
+
+        //----------------------------------------------------------------
+        const trans_type& transformer() const { return *m_trans; }
+        void transformer(const trans_type& trans) { m_trans = &trans; }
+
+        //----------------------------------------------------------------
+        void begin(double x, double y, unsigned)
+        {
+            m_x = x;
+            m_y = y;
+            m_trans->transform(&x, &y);
+            m_ix = iround(x * subpixel_scale);
+            m_iy = iround(y * subpixel_scale);
+        }
+
+        //----------------------------------------------------------------
+        void operator++()
+        {
+            m_x += 1.0;
+            double x = m_x;
+            double y = m_y;
+            m_trans->transform(&x, &y);
+            m_ix = iround(x * subpixel_scale);
+            m_iy = iround(y * subpixel_scale);
+        }
+
+        //----------------------------------------------------------------
+        void coordinates(int* x, int* y) const
+        {
+            *x = m_ix;
+            *y = m_iy;
+        }
+
+    private:
+        const trans_type* m_trans;
+        double            m_x;
+        double            m_y;
+        int               m_ix;
+        int               m_iy;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_pattern_gray.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_pattern_gray.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_pattern_gray.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_pattern_gray.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,93 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+
+#ifndef AGG_SPAN_PATTERN_GRAY_INCLUDED
+#define AGG_SPAN_PATTERN_GRAY_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //=======================================================span_pattern_gray
+    template<class Source> class span_pattern_gray
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+
+        //--------------------------------------------------------------------
+        span_pattern_gray() {}
+        span_pattern_gray(source_type& src, 
+                          unsigned offset_x, unsigned offset_y) :
+            m_src(&src),
+            m_offset_x(offset_x),
+            m_offset_y(offset_y),
+            m_alpha(color_type::base_mask)
+        {}
+
+        //--------------------------------------------------------------------
+        void   attach(source_type& v)      { m_src = &v; }
+               source_type& source()       { return *m_src; }
+        const  source_type& source() const { return *m_src; }
+
+        //--------------------------------------------------------------------
+        void       offset_x(unsigned v) { m_offset_x = v; }
+        void       offset_y(unsigned v) { m_offset_y = v; }
+        unsigned   offset_x() const { return m_offset_x; }
+        unsigned   offset_y() const { return m_offset_y; }
+        void       alpha(value_type v) { m_alpha = v; }
+        value_type alpha() const { return m_alpha; }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+        void generate(color_type* span, int x, int y, unsigned len)
+        {   
+            x += m_offset_x;
+            y += m_offset_y;
+            const value_type* p = (const value_type*)m_src->span(x, y, len);
+            do
+            {
+                span->v = *p;
+                span->a = m_alpha;
+                p = m_src->next_x();
+                ++span;
+            }
+            while(--len);
+        }
+
+    private:
+        source_type* m_src;
+        unsigned     m_offset_x;
+        unsigned     m_offset_y;
+        value_type   m_alpha;
+
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_pattern_rgb.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_pattern_rgb.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_pattern_rgb.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_pattern_rgb.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,96 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+
+#ifndef AGG_SPAN_PATTERN_RGB_INCLUDED
+#define AGG_SPAN_PATTERN_RGB_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //========================================================span_pattern_rgb
+    template<class Source> class span_pattern_rgb
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+
+        //--------------------------------------------------------------------
+        span_pattern_rgb() {}
+        span_pattern_rgb(source_type& src, 
+                         unsigned offset_x, unsigned offset_y) :
+            m_src(&src),
+            m_offset_x(offset_x),
+            m_offset_y(offset_y),
+            m_alpha(color_type::base_mask)
+        {}
+
+        //--------------------------------------------------------------------
+        void   attach(source_type& v)      { m_src = &v; }
+               source_type& source()       { return *m_src; }
+        const  source_type& source() const { return *m_src; }
+
+        //--------------------------------------------------------------------
+        void       offset_x(unsigned v) { m_offset_x = v; }
+        void       offset_y(unsigned v) { m_offset_y = v; }
+        unsigned   offset_x() const { return m_offset_x; }
+        unsigned   offset_y() const { return m_offset_y; }
+        void       alpha(value_type v) { m_alpha = v; }
+        value_type alpha() const { return m_alpha; }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+        void generate(color_type* span, int x, int y, unsigned len)
+        {   
+            x += m_offset_x;
+            y += m_offset_y;
+            const value_type* p = (const value_type*)m_src->span(x, y, len);
+            do
+            {
+                span->r = p[order_type::R];
+                span->g = p[order_type::G];
+                span->b = p[order_type::B];
+                span->a = m_alpha;
+                p = m_src->next_x();
+                ++span;
+            }
+            while(--len);
+        }
+
+    private:
+        source_type* m_src;
+        unsigned     m_offset_x;
+        unsigned     m_offset_y;
+        value_type   m_alpha;
+
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_pattern_rgba.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_pattern_rgba.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_pattern_rgba.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_pattern_rgba.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,94 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Adaptation for high precision colors has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+
+
+#ifndef AGG_SPAN_PATTERN_RGBA_INCLUDED
+#define AGG_SPAN_PATTERN_RGBA_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //======================================================span_pattern_rgba
+    template<class Source> class span_pattern_rgba
+    {
+    public:
+        typedef Source source_type;
+        typedef typename source_type::color_type color_type;
+        typedef typename source_type::order_type order_type;
+        typedef typename color_type::value_type value_type;
+        typedef typename color_type::calc_type calc_type;
+
+        //--------------------------------------------------------------------
+        span_pattern_rgba() {}
+        span_pattern_rgba(source_type& src, 
+                          unsigned offset_x, unsigned offset_y) :
+            m_src(&src),
+            m_offset_x(offset_x),
+            m_offset_y(offset_y)
+        {}
+
+        //--------------------------------------------------------------------
+        void   attach(source_type& v)      { m_src = &v; }
+               source_type& source()       { return *m_src; }
+        const  source_type& source() const { return *m_src; }
+
+        //--------------------------------------------------------------------
+        void       offset_x(unsigned v) { m_offset_x = v; }
+        void       offset_y(unsigned v) { m_offset_y = v; }
+        unsigned   offset_x() const { return m_offset_x; }
+        unsigned   offset_y() const { return m_offset_y; }
+        void       alpha(value_type) {}
+        value_type alpha() const { return 0; }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+        void generate(color_type* span, int x, int y, unsigned len)
+        {   
+            x += m_offset_x;
+            y += m_offset_y;
+            const value_type* p = (const value_type*)m_src->span(x, y, len);
+            do
+            {
+                span->r = p[order_type::R];
+                span->g = p[order_type::G];
+                span->b = p[order_type::B];
+                span->a = p[order_type::A];
+                p = (const value_type*)m_src->next_x();
+                ++span;
+            }
+            while(--len);
+        }
+
+    private:
+        source_type* m_src;
+        unsigned     m_offset_x;
+        unsigned     m_offset_y;
+
+    };
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_solid.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_solid.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_solid.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_solid.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,53 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// span_solid_rgba8
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SPAN_SOLID_INCLUDED
+#define AGG_SPAN_SOLID_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    //--------------------------------------------------------------span_solid
+    template<class ColorT> class span_solid
+    {
+    public:
+        typedef ColorT color_type;
+
+        //--------------------------------------------------------------------
+        void color(const color_type& c) { m_color = c; }
+        const color_type& color() const { return m_color; }
+
+        //--------------------------------------------------------------------
+        void prepare() {}
+
+        //--------------------------------------------------------------------
+        void generate(color_type* span, int x, int y, unsigned len)
+        {   
+            do { *span++ = m_color; } while(--len);
+        }
+
+    private:
+        color_type m_color;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_span_subdiv_adaptor.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_subdiv_adaptor.h
--- 8.0.1-5/src/renderers/agg/include/agg_span_subdiv_adaptor.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_span_subdiv_adaptor.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,141 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+#ifndef AGG_SPAN_SUBDIV_ADAPTOR_INCLUDED
+#define AGG_SPAN_SUBDIV_ADAPTOR_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //=================================================span_subdiv_adaptor
+    template<class Interpolator, unsigned SubpixelShift = 8> 
+    class span_subdiv_adaptor
+    {
+    public:
+        typedef Interpolator interpolator_type;
+        typedef typename interpolator_type::trans_type trans_type;
+
+        enum sublixel_scale_e
+        {
+            subpixel_shift = SubpixelShift,
+            subpixel_scale = 1 << subpixel_shift
+        };
+
+
+        //----------------------------------------------------------------
+        span_subdiv_adaptor() :
+            m_subdiv_shift(4),
+            m_subdiv_size(1 << m_subdiv_shift),
+            m_subdiv_mask(m_subdiv_size - 1) {}
+
+        span_subdiv_adaptor(interpolator_type& interpolator, 
+                             unsigned subdiv_shift = 4) : 
+            m_subdiv_shift(subdiv_shift),
+            m_subdiv_size(1 << m_subdiv_shift),
+            m_subdiv_mask(m_subdiv_size - 1),
+            m_interpolator(&interpolator) {}
+
+        span_subdiv_adaptor(interpolator_type& interpolator, 
+                             double x, double y, unsigned len,
+                             unsigned subdiv_shift = 4) :
+            m_subdiv_shift(subdiv_shift),
+            m_subdiv_size(1 << m_subdiv_shift),
+            m_subdiv_mask(m_subdiv_size - 1),
+            m_interpolator(&interpolator)
+        {
+            begin(x, y, len);
+        }
+
+
+        //----------------------------------------------------------------
+        const interpolator_type& interpolator() const { return *m_interpolator; }
+        void interpolator(interpolator_type& intr) { m_interpolator = &intr; }
+
+        //----------------------------------------------------------------
+        const trans_type& transformer() const 
+        { 
+            return *m_interpolator->transformer(); 
+        }
+        void transformer(const trans_type& trans) 
+        { 
+            m_interpolator->transformer(trans); 
+        }
+
+        //----------------------------------------------------------------
+        unsigned subdiv_shift() const { return m_subdiv_shift; }
+        void subdiv_shift(unsigned shift) 
+        {
+            m_subdiv_shift = shift;
+            m_subdiv_size = 1 << m_subdiv_shift;
+            m_subdiv_mask = m_subdiv_size - 1;
+        }
+
+        //----------------------------------------------------------------
+        void begin(double x, double y, unsigned len)
+        {
+            m_pos   = 1;
+            m_src_x = iround(x * subpixel_scale) + subpixel_scale;
+            m_src_y = y;
+            m_len   = len;
+            if(len > m_subdiv_size) len = m_subdiv_size;
+            m_interpolator->begin(x, y, len);
+        }
+
+        //----------------------------------------------------------------
+        void operator++()
+        {
+            ++(*m_interpolator);
+            if(m_pos >= m_subdiv_size)
+            {
+                unsigned len = m_len;
+                if(len > m_subdiv_size) len = m_subdiv_size;
+                m_interpolator->resynchronize(double(m_src_x) / double(subpixel_scale) + len, 
+                                              m_src_y, 
+                                              len);
+                m_pos = 0;
+            }
+            m_src_x += subpixel_scale;
+            ++m_pos;
+            --m_len;
+        }
+
+        //----------------------------------------------------------------
+        void coordinates(int* x, int* y) const
+        {
+            m_interpolator->coordinates(x, y);
+        }
+
+        //----------------------------------------------------------------
+        void local_scale(int* x, int* y) const
+        {
+            m_interpolator->local_scale(x, y);
+        }
+
+
+    private:
+        unsigned m_subdiv_shift;
+        unsigned m_subdiv_size;
+        unsigned m_subdiv_mask;
+        interpolator_type* m_interpolator;
+        int      m_src_x;
+        double   m_src_y;
+        unsigned m_pos;
+        unsigned m_len;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_svg_exception.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_exception.h
--- 8.0.1-5/src/renderers/agg/include/agg_svg_exception.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_exception.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,69 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// SVG exception
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SVG_EXCEPTION_INCLUDED
+#define AGG_SVG_EXCEPTION_INCLUDED
+
+#include <stdio.h>
+#include <string.h>
+#include <stdarg.h>
+
+namespace mapserver 
+{ 
+namespace svg
+{
+    class exception
+    {
+    public:
+        ~exception()
+        {
+            delete [] m_msg;
+        }
+
+        exception() : m_msg(0) {}
+          
+        exception(const char* fmt, ...) :
+            m_msg(0)
+        {
+            if(fmt) 
+            {
+                m_msg = new char [4096];
+                va_list arg;
+                va_start(arg, fmt);
+                vsprintf(m_msg, fmt, arg);
+                va_end(arg);
+            }
+        }
+
+        exception(const exception& exc) :
+            m_msg(exc.m_msg ? new char[strlen(exc.m_msg) + 1] : 0)
+        {
+            if(m_msg) strcpy(m_msg, exc.m_msg);
+        }
+        
+        const char* msg() const { return m_msg; }
+
+    private:
+        char* m_msg;
+    };
+
+}
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_svg_parser.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_parser.h
--- 8.0.1-5/src/renderers/agg/include/agg_svg_parser.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_parser.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,85 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// SVG parser.
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_SVG_PARSER_INCLUDED
+#define AGG_SVG_PARSER_INCLUDED
+
+#include "agg_svg_path_tokenizer.h"
+#include "agg_svg_path_renderer.h"
+
+namespace mapserver
+{
+namespace svg
+{
+
+    class parser
+    {
+        enum buf_size_e { buf_size = BUFSIZ };
+    public:
+
+        ~parser();
+        parser(path_renderer& path);
+
+        void parse(const char* fname);
+        const char* title() const { return m_title; }
+
+    private:
+        // XML event handlers
+        static void start_element(void* data, const char* el, const char** attr);
+        static void end_element(void* data, const char* el);
+        static void content(void* data, const char* s, int len);
+
+        void parse_attr(const char** attr);
+        void parse_path(const char** attr);
+        void parse_poly(const char** attr, bool close_flag);
+        void parse_rect(const char** attr);
+        void parse_line(const char** attr);
+        void parse_style(const char* str);
+        void parse_transform(const char* str);
+
+        unsigned parse_matrix(const char* str);
+        unsigned parse_translate(const char* str);
+        unsigned parse_rotate(const char* str);
+        unsigned parse_scale(const char* str);
+        unsigned parse_skew_x(const char* str);
+        unsigned parse_skew_y(const char* str);
+        
+        bool parse_attr(const char* name, const char* value);
+        bool parse_name_value(const char* nv_start, const char* nv_end);
+        void copy_name(const char* start, const char* end);
+        void copy_value(const char* start, const char* end);
+        
+    private:
+        path_renderer& m_path;
+        path_tokenizer m_tokenizer;
+        char*          m_buf;
+        char*          m_title;
+        unsigned       m_title_len;
+        bool           m_title_flag;
+        bool           m_path_flag;
+        char*          m_attr_name;
+        char*          m_attr_value;
+        unsigned       m_attr_name_len;
+        unsigned       m_attr_value_len;
+    };
+
+}
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_svg_path_renderer.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_path_renderer.h
--- 8.0.1-5/src/renderers/agg/include/agg_svg_path_renderer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_path_renderer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,321 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// SVG path renderer.
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_SVG_PATH_RENDERER_INCLUDED
+#define AGG_SVG_PATH_RENDERER_INCLUDED
+
+#include "agg_path_storage.h"
+#include "agg_conv_transform.h"
+#include "agg_conv_stroke.h"
+#include "agg_conv_contour.h"
+#include "agg_conv_curve.h"
+#include "agg_color_rgba.h"
+#include "agg_renderer_scanline.h"
+#include "agg_bounding_rect.h"
+#include "agg_rasterizer_scanline_aa.h"
+#include "agg_svg_path_tokenizer.h"
+
+namespace mapserver
+{
+namespace svg
+{
+    template<class VertexSource> class conv_count
+    {
+    public:
+        conv_count(VertexSource& vs) : m_source(&vs), m_count(0) {}
+
+        void count(unsigned n) { m_count = n; }
+        unsigned count() const { return m_count; }
+
+        void rewind(unsigned path_id) { m_source->rewind(path_id); }
+        unsigned vertex(double* x, double* y) 
+        { 
+            ++m_count; 
+            return m_source->vertex(x, y); 
+        }
+
+    private:
+        VertexSource* m_source;
+        unsigned m_count;
+    };
+
+
+
+
+    //============================================================================
+    // Basic path attributes
+    struct path_attributes
+    {
+        unsigned     index;
+        rgba8        fill_color;
+        rgba8        stroke_color;
+        bool         fill_flag;
+        bool         stroke_flag;
+        bool         even_odd_flag;
+        line_join_e  line_join;
+        line_cap_e   line_cap;
+        double       miter_limit;
+        double       stroke_width;
+        trans_affine transform;
+
+        // Empty constructor
+        path_attributes() :
+            index(0),
+            fill_color(rgba(0,0,0)),
+            stroke_color(rgba(0,0,0)),
+            fill_flag(true),
+            stroke_flag(false),
+            even_odd_flag(false),
+            line_join(miter_join),
+            line_cap(butt_cap),
+            miter_limit(4.0),
+            stroke_width(1.0),
+            transform()
+        {
+        }
+
+        // Copy constructor
+        path_attributes(const path_attributes& attr) :
+            index(attr.index),
+            fill_color(attr.fill_color),
+            stroke_color(attr.stroke_color),
+            fill_flag(attr.fill_flag),
+            stroke_flag(attr.stroke_flag),
+            even_odd_flag(attr.even_odd_flag),
+            line_join(attr.line_join),
+            line_cap(attr.line_cap),
+            miter_limit(attr.miter_limit),
+            stroke_width(attr.stroke_width),
+            transform(attr.transform)
+        {
+        }
+
+        // Copy constructor with new index value
+        path_attributes(const path_attributes& attr, unsigned idx) :
+            index(idx),
+            fill_color(attr.fill_color),
+            stroke_color(attr.stroke_color),
+            fill_flag(attr.fill_flag),
+            stroke_flag(attr.stroke_flag),
+            even_odd_flag(attr.even_odd_flag),
+            line_join(attr.line_join),
+            line_cap(attr.line_cap),
+            miter_limit(attr.miter_limit),
+            stroke_width(attr.stroke_width),
+            transform(attr.transform)
+        {
+        }
+    };
+
+
+    //============================================================================
+    // Path container and renderer. 
+    class path_renderer
+    {
+    public:
+        typedef pod_bvector<path_attributes>   attr_storage;
+
+        typedef conv_curve<path_storage>       curved;
+        typedef conv_count<curved>             curved_count;
+
+        typedef conv_stroke<curved_count>      curved_stroked;
+        typedef conv_transform<curved_stroked> curved_stroked_trans;
+
+        typedef conv_transform<curved_count>   curved_trans;
+        typedef conv_contour<curved_trans>     curved_trans_contour;
+
+        path_renderer();
+
+        void remove_all();
+
+        // Use these functions as follows:
+        // begin_path() when the XML tag <path> comes ("start_element" handler)
+        // parse_path() on "d=" tag attribute
+        // end_path() when parsing of the entire tag is done.
+        void begin_path();
+        void parse_path(path_tokenizer& tok);
+        void end_path();
+
+        // The following functions are essentially a "reflection" of
+        // the respective SVG path commands.
+        void move_to(double x, double y, bool rel=false);   // M, m
+        void line_to(double x,  double y, bool rel=false);  // L, l
+        void hline_to(double x, bool rel=false);            // H, h
+        void vline_to(double y, bool rel=false);            // V, v
+        void curve3(double x1, double y1,                   // Q, q
+                    double x,  double y, bool rel=false);
+        void curve3(double x, double y, bool rel=false);    // T, t
+        void curve4(double x1, double y1,                   // C, c
+                    double x2, double y2, 
+                    double x,  double y, bool rel=false);
+        void curve4(double x2, double y2,                   // S, s
+                    double x,  double y, bool rel=false);
+        void close_subpath();                               // Z, z
+
+//        template<class VertexSource> 
+//        void add_path(VertexSource& vs, 
+//                      unsigned path_id = 0, 
+//                      bool solid_path = true)
+//        {
+//            m_storage.add_path(vs, path_id, solid_path);
+//        }
+
+
+        unsigned vertex_count() const { return m_curved_count.count(); }
+        
+
+        // Call these functions on <g> tag (start_element, end_element respectively)
+        void push_attr();
+        void pop_attr();
+
+        // Attribute setting functions.
+        void fill(const rgba8& f);
+        void stroke(const rgba8& s);
+        void even_odd(bool flag);
+        void stroke_width(double w);
+        void fill_none();
+        void stroke_none();
+        void fill_opacity(double op);
+        void stroke_opacity(double op);
+        void line_join(line_join_e join);
+        void line_cap(line_cap_e cap);
+        void miter_limit(double ml);
+        trans_affine& transform();
+
+        // Make all polygons CCW-oriented
+        void arrange_orientations()
+        {
+            m_storage.arrange_orientations_all_paths(path_flags_ccw);
+        }
+
+        // Expand all polygons 
+        void expand(double value)
+        {
+            m_curved_trans_contour.width(value);
+        }
+
+        unsigned operator [](unsigned idx)
+        {
+            m_transform = m_attr_storage[idx].transform;
+            return m_attr_storage[idx].index;
+        }
+
+        void bounding_rect(double* x1, double* y1, double* x2, double* y2)
+        {
+            mapserver::conv_transform<mapserver::path_storage> trans(m_storage, m_transform);
+            mapserver::bounding_rect(trans, *this, 0, m_attr_storage.size(), x1, y1, x2, y2);
+        }
+
+        // Rendering. One can specify two additional parameters: 
+        // trans_affine and opacity. They can be used to transform the whole
+        // image and/or to make it translucent.
+        template<class Rasterizer, class Scanline, class Renderer> 
+        void render(Rasterizer& ras, 
+                    Scanline& sl,
+                    Renderer& ren, 
+                    const trans_affine& mtx, 
+                    const rect_i& cb,
+                    double opacity=1.0)
+        {
+            unsigned i;
+
+            ras.clip_box(cb.x1, cb.y1, cb.x2, cb.y2);
+            m_curved_count.count(0);
+
+            for(i = 0; i < m_attr_storage.size(); i++)
+            {
+                const path_attributes& attr = m_attr_storage[i];
+                m_transform = attr.transform;
+                m_transform *= mtx;
+                double scl = m_transform.scale();
+                //m_curved.approximation_method(curve_inc);
+                m_curved.approximation_scale(scl);
+                m_curved.angle_tolerance(0.0);
+
+                rgba8 color;
+
+                if(attr.fill_flag)
+                {
+                    ras.reset();
+                    ras.filling_rule(attr.even_odd_flag ? fill_even_odd : fill_non_zero);
+                    if(fabs(m_curved_trans_contour.width()) < 0.0001)
+                    {
+                        ras.add_path(m_curved_trans, attr.index);
+                    }
+                    else
+                    {
+                        m_curved_trans_contour.miter_limit(attr.miter_limit);
+                        ras.add_path(m_curved_trans_contour, attr.index);
+                    }
+
+                    color = attr.fill_color;
+                    color.opacity(color.opacity() * opacity);
+                    ren.color(color);
+                    mapserver::render_scanlines(ras, sl, ren);
+                }
+
+                if(attr.stroke_flag)
+                {
+                    m_curved_stroked.width(attr.stroke_width);
+                    //m_curved_stroked.line_join((attr.line_join == miter_join) ? miter_join_round : attr.line_join);
+                    m_curved_stroked.line_join(attr.line_join);
+                    m_curved_stroked.line_cap(attr.line_cap);
+                    m_curved_stroked.miter_limit(attr.miter_limit);
+                    m_curved_stroked.inner_join(inner_round);
+                    m_curved_stroked.approximation_scale(scl);
+
+                    // If the *visual* line width is considerable we 
+                    // turn on processing of curve cusps.
+                    //---------------------
+                    if(attr.stroke_width * scl > 1.0)
+                    {
+                        m_curved.angle_tolerance(0.2);
+                    }
+                    ras.reset();
+                    ras.filling_rule(fill_non_zero);
+                    ras.add_path(m_curved_stroked_trans, attr.index);
+                    color = attr.stroke_color;
+                    color.opacity(color.opacity() * opacity);
+                    ren.color(color);
+                    mapserver::render_scanlines(ras, sl, ren);
+                }
+            }
+        }
+
+    private:
+        path_attributes& cur_attr();
+
+        path_storage   m_storage;
+        attr_storage   m_attr_storage;
+        attr_storage   m_attr_stack;
+        trans_affine   m_transform;
+
+        curved                       m_curved;
+        curved_count                 m_curved_count;
+
+        curved_stroked               m_curved_stroked;
+        curved_stroked_trans         m_curved_stroked_trans;
+
+        curved_trans                 m_curved_trans;
+        curved_trans_contour         m_curved_trans_contour;
+    };
+
+}
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_svg_path_tokenizer.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_path_tokenizer.h
--- 8.0.1-5/src/renderers/agg/include/agg_svg_path_tokenizer.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_svg_path_tokenizer.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,114 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// SVG path tokenizer.
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_SVG_PATH_TOKENIZER_INCLUDED
+#define AGG_SVG_PATH_TOKENIZER_INCLUDED
+
+#include "agg_svg_exception.h"
+
+namespace mapserver 
+{ 
+namespace svg
+{
+    // SVG path tokenizer. 
+    // Example:
+    //
+    // agg::svg::path_tokenizer tok;
+    //
+    // tok.set_str("M-122.304 84.285L-122.304 84.285 122.203 86.179 ");
+    // while(tok.next())
+    // {
+    //     printf("command='%c' number=%f\n", 
+    //             tok.last_command(), 
+    //             tok.last_number());
+    // }
+    //
+    // The tokenizer does all the routine job of parsing the SVG paths.
+    // It doesn't recognize any graphical primitives, it even doesn't know
+    // anything about pairs of coordinates (X,Y). The purpose of this class 
+    // is to tokenize the numeric values and commands. SVG paths can 
+    // have single numeric values for Horizontal or Vertical line_to commands 
+    // as well as more than two coordinates (4 or 6) for Bezier curves 
+    // depending on the semantics of the command.
+    // The behaviour is as follows:
+    //
+    // Each call to next() returns true if there's new command or new numeric
+    // value or false when the path ends. How to interpret the result
+    // depends on the sematics of the command. For example, command "C" 
+    // (cubic Bezier curve) implies 6 floating point numbers preceded by this 
+    // command. If the command assumes no arguments (like z or Z) the 
+    // the last_number() values won't change, that is, last_number() always
+    // returns the last recognized numeric value, so does last_command().
+    //===============================================================
+    class path_tokenizer
+    {
+     public:
+        path_tokenizer();
+
+        void set_path_str(const char* str);
+        bool next();
+
+        double next(char cmd);
+
+        char   last_command() const { return m_last_command; }
+        double last_number() const { return m_last_number; }
+
+
+    private:
+        static void init_char_mask(char* mask, const char* char_set);
+
+        bool contains(const char* mask, unsigned c) const
+        {
+            return (mask[(c >> 3) & (256/8-1)] & (1 << (c & 7))) != 0;
+        }
+
+        bool is_command(unsigned c) const
+        {
+            return contains(m_commands_mask, c);
+        }
+
+        bool is_numeric(unsigned c) const
+        {
+            return contains(m_numeric_mask, c);
+        }
+
+        bool is_separator(unsigned c) const
+        {
+            return contains(m_separators_mask, c);
+        }
+
+        bool parse_number();
+
+        char m_separators_mask[256/8];
+        char m_commands_mask[256/8];
+        char m_numeric_mask[256/8];
+
+        const char* m_path;
+        double m_last_number;
+        char   m_last_command;
+
+        static const char s_commands[];
+        static const char s_numeric[];
+        static const char s_separators[];
+    };
+
+} //namespace svg
+} //namespace mapserver
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_trans_affine.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_affine.h
--- 8.0.1-5/src/renderers/agg/include/agg_trans_affine.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_affine.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,518 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Affine transformation classes.
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_TRANS_AFFINE_INCLUDED
+#define AGG_TRANS_AFFINE_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+    const double affine_epsilon = 1e-14; 
+
+    //============================================================trans_affine
+    //
+    // See Implementation agg_trans_affine.cpp
+    //
+    // Affine transformation are linear transformations in Cartesian coordinates
+    // (strictly speaking not only in Cartesian, but for the beginning we will 
+    // think so). They are rotation, scaling, translation and skewing.  
+    // After any affine transformation a line segment remains a line segment 
+    // and it will never become a curve. 
+    //
+    // There will be no math about matrix calculations, since it has been 
+    // described many times. Ask yourself a very simple question:
+    // "why do we need to understand and use some matrix stuff instead of just 
+    // rotating, scaling and so on". The answers are:
+    //
+    // 1. Any combination of transformations can be done by only 4 multiplications
+    //    and 4 additions in floating point.
+    // 2. One matrix transformation is equivalent to the number of consecutive
+    //    discrete transformations, i.e. the matrix "accumulates" all transformations 
+    //    in the order of their settings. Suppose we have 4 transformations: 
+    //       * rotate by 30 degrees,
+    //       * scale X to 2.0, 
+    //       * scale Y to 1.5, 
+    //       * move to (100, 100). 
+    //    The result will depend on the order of these transformations, 
+    //    and the advantage of matrix is that the sequence of discret calls:
+    //    rotate(30), scaleX(2.0), scaleY(1.5), move(100,100) 
+    //    will have exactly the same result as the following matrix transformations:
+    //   
+    //    affine_matrix m;
+    //    m *= rotate_matrix(30); 
+    //    m *= scaleX_matrix(2.0);
+    //    m *= scaleY_matrix(1.5);
+    //    m *= move_matrix(100,100);
+    //
+    //    m.transform_my_point_at_last(x, y);
+    //
+    // What is the good of it? In real life we will set-up the matrix only once
+    // and then transform many points, let alone the convenience to set any 
+    // combination of transformations.
+    //
+    // So, how to use it? Very easy - literally as it's shown above. Not quite,
+    // let us write a correct example:
+    //
+    // mapserver::trans_affine m;
+    // m *= mapserver::trans_affine_rotation(30.0 * 3.1415926 / 180.0);
+    // m *= mapserver::trans_affine_scaling(2.0, 1.5);
+    // m *= mapserver::trans_affine_translation(100.0, 100.0);
+    // m.transform(&x, &y);
+    //
+    // The affine matrix is all you need to perform any linear transformation,
+    // but all transformations have origin point (0,0). It means that we need to 
+    // use 2 translations if we want to rotate someting around (100,100):
+    // 
+    // m *= mapserver::trans_affine_translation(-100.0, -100.0);         // move to (0,0)
+    // m *= mapserver::trans_affine_rotation(30.0 * 3.1415926 / 180.0);  // rotate
+    // m *= mapserver::trans_affine_translation(100.0, 100.0);           // move back to (100,100)
+    //----------------------------------------------------------------------
+    struct trans_affine
+    {
+        double sx, shy, shx, sy, tx, ty;
+
+        //------------------------------------------ Construction
+        // Identity matrix
+        trans_affine() :
+            sx(1.0), shy(0.0), shx(0.0), sy(1.0), tx(0.0), ty(0.0)
+        {}
+
+        // Custom matrix. Usually used in derived classes
+        trans_affine(double v0, double v1, double v2, 
+                     double v3, double v4, double v5) :
+            sx(v0), shy(v1), shx(v2), sy(v3), tx(v4), ty(v5)
+        {}
+
+        // Custom matrix from m[6]
+        explicit trans_affine(const double* m) :
+            sx(m[0]), shy(m[1]), shx(m[2]), sy(m[3]), tx(m[4]), ty(m[5])
+        {}
+
+        // Rectangle to a parallelogram.
+        trans_affine(double x1, double y1, double x2, double y2, 
+                     const double* parl)
+        {
+            rect_to_parl(x1, y1, x2, y2, parl);
+        }
+
+        // Parallelogram to a rectangle.
+        trans_affine(const double* parl, 
+                     double x1, double y1, double x2, double y2)
+        {
+            parl_to_rect(parl, x1, y1, x2, y2);
+        }
+
+        // Arbitrary parallelogram transformation.
+        trans_affine(const double* src, const double* dst)
+        {
+            parl_to_parl(src, dst);
+        }
+
+        //---------------------------------- Parellelogram transformations
+        // transform a parallelogram to another one. Src and dst are 
+        // pointers to arrays of three points (double[6], x1,y1,...) that 
+        // identify three corners of the parallelograms assuming implicit 
+        // fourth point. The arguments are arrays of double[6] mapped 
+        // to x1,y1, x2,y2, x3,y3  where the coordinates are:
+        //        *-----------------*
+        //       /          (x3,y3)/
+        //      /                 /
+        //     /(x1,y1)   (x2,y2)/
+        //    *-----------------*
+        const trans_affine& parl_to_parl(const double* src, 
+                                         const double* dst);
+
+        const trans_affine& rect_to_parl(double x1, double y1, 
+                                         double x2, double y2, 
+                                         const double* parl);
+
+        const trans_affine& parl_to_rect(const double* parl, 
+                                         double x1, double y1, 
+                                         double x2, double y2);
+
+
+        //------------------------------------------ Operations
+        // Reset - load an identity matrix
+        const trans_affine& reset();
+
+        // Direct transformations operations
+        const trans_affine& translate(double x, double y);
+        const trans_affine& rotate(double a);
+        const trans_affine& scale(double s);
+        const trans_affine& scale(double x, double y);
+
+        // Multiply matrix to another one
+        const trans_affine& multiply(const trans_affine& m);
+
+        // Multiply "m" to "this" and assign the result to "this"
+        const trans_affine& premultiply(const trans_affine& m);
+
+        // Multiply matrix to inverse of another one
+        const trans_affine& multiply_inv(const trans_affine& m);
+
+        // Multiply inverse of "m" to "this" and assign the result to "this"
+        const trans_affine& premultiply_inv(const trans_affine& m);
+
+        // Invert matrix. Do not try to invert degenerate matrices, 
+        // there's no check for validity. If you set scale to 0 and 
+        // then try to invert matrix, expect unpredictable result.
+        const trans_affine& invert();
+
+        // Mirroring around X
+        const trans_affine& flip_x();
+
+        // Mirroring around Y
+        const trans_affine& flip_y();
+
+        //------------------------------------------- Load/Store
+        // Store matrix to an array [6] of double
+        void store_to(double* m) const
+        {
+            *m++ = sx; *m++ = shy; *m++ = shx; *m++ = sy; *m++ = tx; *m++ = ty;
+        }
+
+        // Load matrix from an array [6] of double
+        const trans_affine& load_from(const double* m)
+        {
+            sx = *m++; shy = *m++; shx = *m++; sy = *m++; tx = *m++;  ty = *m++;
+            return *this;
+        }
+
+        //------------------------------------------- Operators
+        
+        // Multiply the matrix by another one
+        const trans_affine& operator *= (const trans_affine& m)
+        {
+            return multiply(m);
+        }
+
+        // Multiply the matrix by inverse of another one
+        const trans_affine& operator /= (const trans_affine& m)
+        {
+            return multiply_inv(m);
+        }
+
+        // Multiply the matrix by another one and return
+        // the result in a separete matrix.
+        trans_affine operator * (const trans_affine& m)
+        {
+            return trans_affine(*this).multiply(m);
+        }
+
+        // Multiply the matrix by inverse of another one 
+        // and return the result in a separete matrix.
+        trans_affine operator / (const trans_affine& m)
+        {
+            return trans_affine(*this).multiply_inv(m);
+        }
+
+        // Calculate and return the inverse matrix
+        trans_affine operator ~ () const
+        {
+            trans_affine ret = *this;
+            return ret.invert();
+        }
+
+        // Equal operator with default epsilon
+        bool operator == (const trans_affine& m) const
+        {
+            return is_equal(m, affine_epsilon);
+        }
+
+        // Not Equal operator with default epsilon
+        bool operator != (const trans_affine& m) const
+        {
+            return !is_equal(m, affine_epsilon);
+        }
+
+        //-------------------------------------------- Transformations
+        // Direct transformation of x and y
+        void transform(double* x, double* y) const;
+
+        // Direct transformation of x and y, 2x2 matrix only, no translation
+        void transform_2x2(double* x, double* y) const;
+
+        // Inverse transformation of x and y. It works slower than the 
+        // direct transformation. For massive operations it's better to 
+        // invert() the matrix and then use direct transformations. 
+        void inverse_transform(double* x, double* y) const;
+
+        //-------------------------------------------- Auxiliary
+        // Calculate the determinant of matrix
+        double determinant() const
+        {
+            return sx * sy - shy * shx;
+        }
+
+        // Calculate the reciprocal of the determinant
+        double determinant_reciprocal() const
+        {
+            return 1.0 / (sx * sy - shy * shx);
+        }
+
+        // Get the average scale (by X and Y). 
+        // Basically used to calculate the approximation_scale when
+        // decomposinting curves into line segments.
+        double scale() const;
+
+        // Check to see if the matrix is not degenerate
+        bool is_valid(double epsilon = affine_epsilon) const;
+
+        // Check to see if it's an identity matrix
+        bool is_identity(double epsilon = affine_epsilon) const;
+
+        // Check to see if two matrices are equal
+        bool is_equal(const trans_affine& m, double epsilon = affine_epsilon) const;
+
+        // Determine the major parameters. Use with caution considering 
+        // possible degenerate cases.
+        double rotation() const;
+        void   translation(double* dx, double* dy) const;
+        void   scaling(double* x, double* y) const;
+        void   scaling_abs(double* x, double* y) const;
+    };
+
+    //------------------------------------------------------------------------
+    inline void trans_affine::transform(double* x, double* y) const
+    {
+        const double tmp = *x;
+        *x = tmp * sx  + *y * shx + tx;
+        *y = tmp * shy + *y * sy  + ty;
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_affine::transform_2x2(double* x, double* y) const
+    {
+        const double tmp = *x;
+        *x = tmp * sx  + *y * shx;
+        *y = tmp * shy + *y * sy;
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_affine::inverse_transform(double* x, double* y) const
+    {
+        const double d = determinant_reciprocal();
+        const double a = (*x - tx) * d;
+        const double b = (*y - ty) * d;
+        *x = a * sy - b * shx;
+        *y = b * sx - a * shy;
+    }
+
+    //------------------------------------------------------------------------
+    inline double trans_affine::scale() const
+    {
+        double x = 0.707106781 * sx  + 0.707106781 * shx;
+        double y = 0.707106781 * shy + 0.707106781 * sy;
+        return sqrt(x*x + y*y);
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_affine& trans_affine::translate(double x, double y) 
+    { 
+        tx += x;
+        ty += y; 
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_affine& trans_affine::rotate(double a) 
+    {
+        double ca = cos(a); 
+        double sa = sin(a);
+        double t0 = sx  * ca - shy * sa;
+        double t2 = shx * ca - sy * sa;
+        double t4 = tx  * ca - ty * sa;
+        shy = sx  * sa + shy * ca;
+        sy  = shx * sa + sy * ca; 
+        ty  = tx  * sa + ty * ca;
+        sx  = t0;
+        shx = t2;
+        tx  = t4;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_affine& trans_affine::scale(double x, double y) 
+    {
+        double mm0 = x; // Possible hint for the optimizer
+        double mm3 = y; 
+        sx  *= mm0;
+        shx *= mm0;
+        tx  *= mm0;
+        shy *= mm3;
+        sy  *= mm3;
+        ty  *= mm3;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_affine& trans_affine::scale(double s) 
+    {
+        double m = s; // Possible hint for the optimizer
+        sx  *= m;
+        shx *= m;
+        tx  *= m;
+        shy *= m;
+        sy  *= m;
+        ty  *= m;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_affine& trans_affine::premultiply(const trans_affine& m)
+    {
+        trans_affine t = m;
+        return *this = t.multiply(*this);
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_affine& trans_affine::multiply_inv(const trans_affine& m)
+    {
+        trans_affine t = m;
+        t.invert();
+        return multiply(t);
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_affine& trans_affine::premultiply_inv(const trans_affine& m)
+    {
+        trans_affine t = m;
+        t.invert();
+        return *this = t.multiply(*this);
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_affine::scaling_abs(double* x, double* y) const
+    {
+        // Used to calculate scaling coefficients in image resampling. 
+        // When there is considerable shear this method gives us much
+        // better estimation than just sx, sy.
+        *x = sqrt(sx  * sx  + shx * shx);
+        *y = sqrt(shy * shy + sy  * sy);
+    }
+
+    //====================================================trans_affine_rotation
+    // Rotation matrix. sin() and cos() are calculated twice for the same angle.
+    // There's no harm because the performance of sin()/cos() is very good on all
+    // modern processors. Besides, this operation is not going to be invoked too 
+    // often.
+    class trans_affine_rotation : public trans_affine
+    {
+    public:
+        trans_affine_rotation(double a) : 
+          trans_affine(cos(a), sin(a), -sin(a), cos(a), 0.0, 0.0)
+        {}
+    };
+
+    //====================================================trans_affine_scaling
+    // Scaling matrix. x, y - scale coefficients by X and Y respectively
+    class trans_affine_scaling : public trans_affine
+    {
+    public:
+        trans_affine_scaling(double x, double y) : 
+          trans_affine(x, 0.0, 0.0, y, 0.0, 0.0)
+        {}
+
+        trans_affine_scaling(double s) : 
+          trans_affine(s, 0.0, 0.0, s, 0.0, 0.0)
+        {}
+    };
+
+    //================================================trans_affine_translation
+    // Translation matrix
+    class trans_affine_translation : public trans_affine
+    {
+    public:
+        trans_affine_translation(double x, double y) : 
+          trans_affine(1.0, 0.0, 0.0, 1.0, x, y)
+        {}
+    };
+
+    //====================================================trans_affine_skewing
+    // Sckewing (shear) matrix
+    class trans_affine_skewing : public trans_affine
+    {
+    public:
+        trans_affine_skewing(double x, double y) : 
+          trans_affine(1.0, tan(y), tan(x), 1.0, 0.0, 0.0)
+        {}
+    };
+
+
+    //===============================================trans_affine_line_segment
+    // Rotate, Scale and Translate, associating 0...dist with line segment 
+    // x1,y1,x2,y2
+    class trans_affine_line_segment : public trans_affine
+    {
+    public:
+        trans_affine_line_segment(double x1, double y1, double x2, double y2, 
+                                  double dist)
+        {
+            double dx = x2 - x1;
+            double dy = y2 - y1;
+            if(dist > 0.0)
+            {
+                multiply(trans_affine_scaling(sqrt(dx * dx + dy * dy) / dist));
+            }
+            multiply(trans_affine_rotation(atan2(dy, dx)));
+            multiply(trans_affine_translation(x1, y1));
+        }
+    };
+
+
+    //============================================trans_affine_reflection_unit
+    // Reflection matrix. Reflect coordinates across the line through 
+    // the origin containing the unit vector (ux, uy).
+    // Contributed by John Horigan
+    class trans_affine_reflection_unit : public trans_affine
+    {
+    public:
+        trans_affine_reflection_unit(double ux, double uy) :
+          trans_affine(2.0 * ux * ux - 1.0, 
+                       2.0 * ux * uy, 
+                       2.0 * ux * uy, 
+                       2.0 * uy * uy - 1.0, 
+                       0.0, 0.0)
+        {}
+    };
+
+
+    //=================================================trans_affine_reflection
+    // Reflection matrix. Reflect coordinates across the line through 
+    // the origin at the angle a or containing the non-unit vector (x, y).
+    // Contributed by John Horigan
+    class trans_affine_reflection : public trans_affine_reflection_unit
+    {
+    public:
+        trans_affine_reflection(double a) :
+          trans_affine_reflection_unit(cos(a), sin(a))
+        {}
+
+
+        trans_affine_reflection(double x, double y) :
+          trans_affine_reflection_unit(x / sqrt(x * x + y * y), y / sqrt(x * x + y * y))
+        {}
+    };
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_trans_bilinear.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_bilinear.h
--- 8.0.1-5/src/renderers/agg/include/agg_trans_bilinear.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_bilinear.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,166 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Bilinear 2D transformations
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_TRANS_BILINEAR_INCLUDED
+#define AGG_TRANS_BILINEAR_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_simul_eq.h"
+
+namespace mapserver
+{
+
+    //==========================================================trans_bilinear
+    class trans_bilinear
+    {
+    public:
+        //--------------------------------------------------------------------
+        trans_bilinear() : m_valid(false) {}
+
+        //--------------------------------------------------------------------
+        // Arbitrary quadrangle transformations
+        trans_bilinear(const double* src, const double* dst) 
+        {
+            quad_to_quad(src, dst);
+        }
+
+
+        //--------------------------------------------------------------------
+        // Direct transformations 
+        trans_bilinear(double x1, double y1, double x2, double y2, 
+                       const double* quad)
+        {
+            rect_to_quad(x1, y1, x2, y2, quad);
+        }
+
+
+        //--------------------------------------------------------------------
+        // Reverse transformations 
+        trans_bilinear(const double* quad, 
+                       double x1, double y1, double x2, double y2)
+        {
+            quad_to_rect(quad, x1, y1, x2, y2);
+        }
+
+
+        //--------------------------------------------------------------------
+        // Set the transformations using two arbitrary quadrangles.
+        void quad_to_quad(const double* src, const double* dst)
+        {
+            double left[4][4];
+            double right[4][2];
+
+            unsigned i;
+            for(i = 0; i < 4; i++)
+            {
+                unsigned ix = i * 2;
+                unsigned iy = ix + 1;
+                left[i][0] = 1.0;
+                left[i][1] = src[ix] * src[iy];
+                left[i][2] = src[ix];
+                left[i][3] = src[iy];
+
+                right[i][0] = dst[ix];
+                right[i][1] = dst[iy];
+            }
+            m_valid = simul_eq<4, 2>::solve(left, right, m_mtx);
+        }
+
+
+        //--------------------------------------------------------------------
+        // Set the direct transformations, i.e., rectangle -> quadrangle
+        void rect_to_quad(double x1, double y1, double x2, double y2, 
+                          const double* quad)
+        {
+            double src[8];
+            src[0] = src[6] = x1;
+            src[2] = src[4] = x2;
+            src[1] = src[3] = y1;
+            src[5] = src[7] = y2;
+            quad_to_quad(src, quad);
+        }
+
+
+        //--------------------------------------------------------------------
+        // Set the reverse transformations, i.e., quadrangle -> rectangle
+        void quad_to_rect(const double* quad, 
+                          double x1, double y1, double x2, double y2)
+        {
+            double dst[8];
+            dst[0] = dst[6] = x1;
+            dst[2] = dst[4] = x2;
+            dst[1] = dst[3] = y1;
+            dst[5] = dst[7] = y2;
+            quad_to_quad(quad, dst);
+        }
+
+        //--------------------------------------------------------------------
+        // Check if the equations were solved successfully
+        bool is_valid() const { return m_valid; }
+
+        //--------------------------------------------------------------------
+        // Transform a point (x, y)
+        void transform(double* x, double* y) const
+        {
+            double tx = *x;
+            double ty = *y;
+            double xy = tx * ty;
+            *x = m_mtx[0][0] + m_mtx[1][0] * xy + m_mtx[2][0] * tx + m_mtx[3][0] * ty;
+            *y = m_mtx[0][1] + m_mtx[1][1] * xy + m_mtx[2][1] * tx + m_mtx[3][1] * ty;
+        }
+
+
+        //--------------------------------------------------------------------
+        class iterator_x
+        {
+            double inc_x;
+            double inc_y;
+
+        public:
+            double x;
+            double y;
+
+            iterator_x() {}
+            iterator_x(double tx, double ty, double step, const double m[4][2]) :
+                inc_x(m[1][0] * step * ty + m[2][0] * step),
+                inc_y(m[1][1] * step * ty + m[2][1] * step),
+                x(m[0][0] + m[1][0] * tx * ty + m[2][0] * tx + m[3][0] * ty),
+                y(m[0][1] + m[1][1] * tx * ty + m[2][1] * tx + m[3][1] * ty)
+            {
+            }
+
+            void operator ++ ()
+            {
+                x += inc_x;
+                y += inc_y;
+            }
+        };
+
+        iterator_x begin(double x, double y, double step) const
+        {
+            return iterator_x(x, y, step, m_mtx);
+        }
+
+    private:
+        double m_mtx[4][2];
+        bool   m_valid;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_trans_double_path.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_double_path.h
--- 8.0.1-5/src/renderers/agg/include/agg_trans_double_path.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_double_path.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,131 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_TRANS_DOUBLE_PATH_INCLUDED
+#define AGG_TRANS_DOUBLE_PATH_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vertex_sequence.h"
+
+namespace mapserver
+{
+    
+    // See also: agg_trans_double_path.cpp
+    //
+    //-------------------------------------------------------trans_double_path
+    class trans_double_path
+    {
+        enum status_e
+        {
+            initial,
+            making_path,
+            ready
+        };
+
+    public:
+        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
+
+        trans_double_path();
+
+        //--------------------------------------------------------------------
+        void   base_length(double v)  { m_base_length = v; }
+        double base_length() const { return m_base_length; }
+
+        //--------------------------------------------------------------------
+        void   base_height(double v)  { m_base_height = v; }
+        double base_height() const { return m_base_height; }
+
+        //--------------------------------------------------------------------
+        void preserve_x_scale(bool f) { m_preserve_x_scale = f;    }
+        bool preserve_x_scale() const { return m_preserve_x_scale; }
+
+        //--------------------------------------------------------------------
+        void reset();
+        void move_to1(double x, double y);
+        void line_to1(double x, double y);
+        void move_to2(double x, double y);
+        void line_to2(double x, double y);
+        void finalize_paths();
+
+        //--------------------------------------------------------------------
+        template<class VertexSource1, class VertexSource2> 
+        void add_paths(VertexSource1& vs1, VertexSource2& vs2, 
+                       unsigned path1_id=0, unsigned path2_id=0)
+        {
+            double x;
+            double y;
+
+            unsigned cmd;
+
+            vs1.rewind(path1_id);
+            while(!is_stop(cmd = vs1.vertex(&x, &y)))
+            {
+                if(is_move_to(cmd)) 
+                {
+                    move_to1(x, y);
+                }
+                else 
+                {
+                    if(is_vertex(cmd))
+                    {
+                        line_to1(x, y);
+                    }
+                }
+            }
+
+            vs2.rewind(path2_id);
+            while(!is_stop(cmd = vs2.vertex(&x, &y)))
+            {
+                if(is_move_to(cmd)) 
+                {
+                    move_to2(x, y);
+                }
+                else 
+                {
+                    if(is_vertex(cmd))
+                    {
+                        line_to2(x, y);
+                    }
+                }
+            }
+            finalize_paths();
+        }
+
+        //--------------------------------------------------------------------
+        double total_length1() const;
+        double total_length2() const;
+        void transform(double *x, double *y) const;
+
+    private:
+        double finalize_path(vertex_storage& vertices);
+        void transform1(const vertex_storage& vertices, 
+                        double kindex, double kx,
+                        double *x, double* y) const;
+
+        vertex_storage m_src_vertices1;
+        vertex_storage m_src_vertices2;
+        double         m_base_length;
+        double         m_base_height;
+        double         m_kindex1;
+        double         m_kindex2;
+        status_e       m_status1;
+        status_e       m_status2;
+        bool           m_preserve_x_scale;
+    };
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_trans_perspective.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_perspective.h
--- 8.0.1-5/src/renderers/agg/include/agg_trans_perspective.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_perspective.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,731 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Perspective 2D transformations
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_TRANS_PERSPECTIVE_INCLUDED
+#define AGG_TRANS_PERSPECTIVE_INCLUDED
+
+#include "agg_trans_affine.h"
+
+namespace mapserver
+{
+    //=======================================================trans_perspective
+    struct trans_perspective
+    {
+        double sx, shy, w0, shx, sy, w1, tx, ty, w2;
+
+        //------------------------------------------------------- Construction
+        // Identity matrix
+        trans_perspective() : 
+            sx (1), shy(0), w0(0), 
+            shx(0), sy (1), w1(0), 
+            tx (0), ty (0), w2(1) {}
+
+        // Custom matrix
+        trans_perspective(double v0, double v1, double v2, 
+                          double v3, double v4, double v5,
+                          double v6, double v7, double v8) :
+           sx (v0), shy(v1), w0(v2), 
+           shx(v3), sy (v4), w1(v5), 
+           tx (v6), ty (v7), w2(v8) {}
+
+        // Custom matrix from m[9]
+        explicit trans_perspective(const double* m) :
+           sx (m[0]), shy(m[1]), w0(m[2]), 
+           shx(m[3]), sy (m[4]), w1(m[5]), 
+           tx (m[6]), ty (m[7]), w2(m[8]) {}
+
+        // From affine
+        explicit trans_perspective(const trans_affine& a) : 
+           sx (a.sx ), shy(a.shy), w0(0), 
+           shx(a.shx), sy (a.sy ), w1(0), 
+           tx (a.tx ), ty (a.ty ), w2(1) {}
+
+        // Rectangle to quadrilateral
+        trans_perspective(double x1, double y1, double x2, double y2, 
+                          const double* quad);
+
+        // Quadrilateral to rectangle
+        trans_perspective(const double* quad, 
+                          double x1, double y1, double x2, double y2);
+
+        // Arbitrary quadrilateral transformations
+        trans_perspective(const double* src, const double* dst);
+
+        //-------------------------------------- Quadrilateral transformations
+        // The arguments are double[8] that are mapped to quadrilaterals:
+        // x1,y1, x2,y2, x3,y3, x4,y4
+        bool quad_to_quad(const double* qs, const double* qd);
+
+        bool rect_to_quad(double x1, double y1, 
+                          double x2, double y2,
+                          const double* q);
+
+        bool quad_to_rect(const double* q,
+                          double x1, double y1, 
+                          double x2, double y2);
+
+        // Map square (0,0,1,1) to the quadrilateral and vice versa
+        bool square_to_quad(const double* q);
+        bool quad_to_square(const double* q);
+
+
+        //--------------------------------------------------------- Operations
+        // Reset - load an identity matrix
+        const trans_perspective& reset();
+
+        // Invert matrix. Returns false in degenerate case
+        bool invert();
+
+        // Direct transformations operations
+        const trans_perspective& translate(double x, double y);
+        const trans_perspective& rotate(double a);
+        const trans_perspective& scale(double s);
+        const trans_perspective& scale(double x, double y);
+
+        // Multiply the matrix by another one
+        const trans_perspective& multiply(const trans_perspective& m);
+
+        // Multiply "m" by "this" and assign the result to "this"
+        const trans_perspective& premultiply(const trans_perspective& m);
+
+        // Multiply matrix to inverse of another one
+        const trans_perspective& multiply_inv(const trans_perspective& m);
+
+        // Multiply inverse of "m" by "this" and assign the result to "this"
+        const trans_perspective& premultiply_inv(const trans_perspective& m);
+
+        // Multiply the matrix by another one
+        const trans_perspective& multiply(const trans_affine& m);
+
+        // Multiply "m" by "this" and assign the result to "this"
+        const trans_perspective& premultiply(const trans_affine& m);
+
+        // Multiply the matrix by inverse of another one
+        const trans_perspective& multiply_inv(const trans_affine& m);
+
+        // Multiply inverse of "m" by "this" and assign the result to "this"
+        const trans_perspective& premultiply_inv(const trans_affine& m);
+
+        //--------------------------------------------------------- Load/Store
+        void store_to(double* m) const;
+        const trans_perspective& load_from(const double* m);
+
+        //---------------------------------------------------------- Operators
+        // Multiply the matrix by another one
+        const trans_perspective& operator *= (const trans_perspective& m)
+        {
+            return multiply(m);
+        }
+        const trans_perspective& operator *= (const trans_affine& m)
+        {
+            return multiply(m);
+        }
+
+        // Multiply the matrix by inverse of another one
+        const trans_perspective& operator /= (const trans_perspective& m)
+        {
+            return multiply_inv(m);
+        }
+        const trans_perspective& operator /= (const trans_affine& m)
+        {
+            return multiply_inv(m);
+        }
+
+        // Multiply the matrix by another one and return
+        // the result in a separete matrix.
+        trans_perspective operator * (const trans_perspective& m)
+        {
+            return trans_perspective(*this).multiply(m);
+        }
+        trans_perspective operator * (const trans_affine& m)
+        {
+            return trans_perspective(*this).multiply(m);
+        }
+
+        // Multiply the matrix by inverse of another one 
+        // and return the result in a separete matrix.
+        trans_perspective operator / (const trans_perspective& m)
+        {
+            return trans_perspective(*this).multiply_inv(m);
+        }
+        trans_perspective operator / (const trans_affine& m)
+        {
+            return trans_perspective(*this).multiply_inv(m);
+        }
+
+        // Calculate and return the inverse matrix
+        trans_perspective operator ~ () const
+        {
+            trans_perspective ret = *this;
+            ret.invert();
+            return ret;
+        }
+
+        // Equal operator with default epsilon
+        bool operator == (const trans_perspective& m) const
+        {
+            return is_equal(m, affine_epsilon);
+        }
+
+        // Not Equal operator with default epsilon
+        bool operator != (const trans_perspective& m) const
+        {
+            return !is_equal(m, affine_epsilon);
+        }
+
+        //---------------------------------------------------- Transformations
+        // Direct transformation of x and y
+        void transform(double* x, double* y) const;
+
+        // Direct transformation of x and y, affine part only
+        void transform_affine(double* x, double* y) const;
+
+        // Direct transformation of x and y, 2x2 matrix only, no translation
+        void transform_2x2(double* x, double* y) const;
+
+        // Inverse transformation of x and y. It works slow because
+        // it explicitly inverts the matrix on every call. For massive 
+        // operations it's better to invert() the matrix and then use 
+        // direct transformations. 
+        void inverse_transform(double* x, double* y) const;
+
+
+        //---------------------------------------------------------- Auxiliary
+        const trans_perspective& from_affine(const trans_affine& a);
+        double determinant() const;
+        double determinant_reciprocal() const;
+
+        bool is_valid(double epsilon = affine_epsilon) const;
+        bool is_identity(double epsilon = affine_epsilon) const;
+        bool is_equal(const trans_perspective& m, 
+                      double epsilon = affine_epsilon) const;
+
+        // Determine the major affine parameters. Use with caution 
+        // considering possible degenerate cases.
+        double scale() const;
+        double rotation() const;
+        void   translation(double* dx, double* dy) const;
+        void   scaling(double* x, double* y) const;
+        void   scaling_abs(double* x, double* y) const;
+
+
+
+        //--------------------------------------------------------------------
+        class iterator_x
+        {
+            double den;
+            double den_step;
+            double nom_x;
+            double nom_x_step;
+            double nom_y;
+            double nom_y_step;
+
+        public:
+            double x;
+            double y;
+
+            iterator_x() {}
+            iterator_x(double px, double py, double step, const trans_perspective& m) :
+                den(px * m.w0 + py * m.w1 + m.w2),
+                den_step(m.w0 * step),
+                nom_x(px * m.sx + py * m.shx + m.tx),
+                nom_x_step(step * m.sx),
+                nom_y(px * m.shy + py * m.sy + m.ty),
+                nom_y_step(step * m.shy),
+                x(nom_x / den),
+                y(nom_y / den)
+            {}
+
+            void operator ++ ()
+            {
+                den   += den_step;
+                nom_x += nom_x_step;
+                nom_y += nom_y_step;
+                double d = 1.0 / den;
+                x = nom_x * d;
+                y = nom_y * d;
+            }
+        };
+
+        //--------------------------------------------------------------------
+        iterator_x begin(double x, double y, double step) const
+        {
+            return iterator_x(x, y, step, *this);
+        }
+    };
+
+
+
+
+
+
+
+
+
+   
+
+
+
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::square_to_quad(const double* q)
+    {
+        double dx = q[0] - q[2] + q[4] - q[6];
+        double dy = q[1] - q[3] + q[5] - q[7];
+        if(dx == 0.0 && dy == 0.0)
+        {   
+            // Affine case (parallelogram)
+            //---------------
+            sx  = q[2] - q[0];
+            shy = q[3] - q[1];
+            w0  = 0.0;
+            shx = q[4] - q[2];
+            sy  = q[5] - q[3];
+            w1  = 0.0;
+            tx  = q[0];
+            ty  = q[1];
+            w2  = 1.0;
+        }
+        else
+        {
+            double dx1 = q[2] - q[4];
+            double dy1 = q[3] - q[5];
+            double dx2 = q[6] - q[4];
+            double dy2 = q[7] - q[5];
+            double den = dx1 * dy2 - dx2 * dy1;
+            if(den == 0.0)
+            {
+                // Singular case
+                //---------------
+                sx = shy = w0 = shx = sy = w1 = tx = ty = w2 = 0.0;
+                return false;
+            }
+            // General case
+            //---------------
+            double u = (dx * dy2 - dy * dx2) / den;
+            double v = (dy * dx1 - dx * dy1) / den;
+            sx  = q[2] - q[0] + u * q[2];
+            shy = q[3] - q[1] + u * q[3];
+            w0  = u;
+            shx = q[6] - q[0] + v * q[6];
+            sy  = q[7] - q[1] + v * q[7];
+            w1  = v;
+            tx  = q[0];
+            ty  = q[1];
+            w2  = 1.0;
+        }
+        return true;
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::invert()
+    {
+        double d0 = sy  * w2 - w1  * ty;
+        double d1 = w0  * ty - shy * w2;
+        double d2 = shy * w1 - w0  * sy;
+        double d  = sx  * d0 + shx * d1 + tx * d2;
+        if(d == 0.0) 
+        {
+            sx = shy = w0 = shx = sy = w1 = tx = ty = w2 = 0.0;
+            return false;
+        }
+        d = 1.0 / d;
+        trans_perspective a = *this;
+        sx  = d * d0;
+        shy = d * d1;
+        w0  = d * d2;
+        shx = d * (a.w1 *a.tx  - a.shx*a.w2);
+        sy  = d * (a.sx *a.w2  - a.w0 *a.tx);
+        w1  = d * (a.w0 *a.shx - a.sx *a.w1);
+        tx  = d * (a.shx*a.ty  - a.sy *a.tx);
+        ty  = d * (a.shy*a.tx  - a.sx *a.ty);
+        w2  = d * (a.sx *a.sy  - a.shy*a.shx);
+        return true;
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::quad_to_square(const double* q)
+    {
+        if(!square_to_quad(q)) return false;
+        invert();
+        return true;
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::quad_to_quad(const double* qs, 
+                                                const double* qd)
+    {
+        trans_perspective p;
+        if(!  quad_to_square(qs)) return false;
+        if(!p.square_to_quad(qd)) return false;
+        multiply(p);
+        return true;
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::rect_to_quad(double x1, double y1, 
+                                                double x2, double y2,
+                                                const double* q)
+    {
+        double r[8];
+        r[0] = r[6] = x1;
+        r[2] = r[4] = x2;
+        r[1] = r[3] = y1;
+        r[5] = r[7] = y2;
+        return quad_to_quad(r, q);
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::quad_to_rect(const double* q,
+                                                double x1, double y1, 
+                                                double x2, double y2)
+    {
+        double r[8];
+        r[0] = r[6] = x1;
+        r[2] = r[4] = x2;
+        r[1] = r[3] = y1;
+        r[5] = r[7] = y2;
+        return quad_to_quad(q, r);
+    }
+
+    //------------------------------------------------------------------------
+    inline trans_perspective::trans_perspective(double x1, double y1, 
+                                                double x2, double y2, 
+                                                const double* quad)
+    {
+        rect_to_quad(x1, y1, x2, y2, quad);
+    }
+
+    //------------------------------------------------------------------------
+    inline trans_perspective::trans_perspective(const double* quad, 
+                                                double x1, double y1, 
+                                                double x2, double y2)
+    {
+        quad_to_rect(quad, x1, y1, x2, y2);
+    }
+
+    //------------------------------------------------------------------------
+    inline trans_perspective::trans_perspective(const double* src, 
+                                                const double* dst) 
+    {
+        quad_to_quad(src, dst);
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& trans_perspective::reset()
+    {
+        sx  = 1; shy = 0; w0 = 0; 
+        shx = 0; sy  = 1; w1 = 0;
+        tx  = 0; ty  = 0; w2 = 1;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& 
+    trans_perspective::multiply(const trans_perspective& a)
+    {
+        trans_perspective b = *this;
+        sx  = a.sx *b.sx  + a.shx*b.shy + a.tx*b.w0;
+        shx = a.sx *b.shx + a.shx*b.sy  + a.tx*b.w1;
+        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx*b.w2;
+        shy = a.shy*b.sx  + a.sy *b.shy + a.ty*b.w0;
+        sy  = a.shy*b.shx + a.sy *b.sy  + a.ty*b.w1;
+        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty*b.w2;
+        w0  = a.w0 *b.sx  + a.w1 *b.shy + a.w2*b.w0;
+        w1  = a.w0 *b.shx + a.w1 *b.sy  + a.w2*b.w1;
+        w2  = a.w0 *b.tx  + a.w1 *b.ty  + a.w2*b.w2;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& 
+    trans_perspective::multiply(const trans_affine& a)
+    {
+        trans_perspective b = *this;
+        sx  = a.sx *b.sx  + a.shx*b.shy + a.tx*b.w0;
+        shx = a.sx *b.shx + a.shx*b.sy  + a.tx*b.w1;
+        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx*b.w2;
+        shy = a.shy*b.sx  + a.sy *b.shy + a.ty*b.w0;
+        sy  = a.shy*b.shx + a.sy *b.sy  + a.ty*b.w1;
+        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty*b.w2;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& 
+    trans_perspective::premultiply(const trans_perspective& b)
+    {
+        trans_perspective a = *this;
+        sx  = a.sx *b.sx  + a.shx*b.shy + a.tx*b.w0;
+        shx = a.sx *b.shx + a.shx*b.sy  + a.tx*b.w1;
+        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx*b.w2;
+        shy = a.shy*b.sx  + a.sy *b.shy + a.ty*b.w0;
+        sy  = a.shy*b.shx + a.sy *b.sy  + a.ty*b.w1;
+        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty*b.w2;
+        w0  = a.w0 *b.sx  + a.w1 *b.shy + a.w2*b.w0;
+        w1  = a.w0 *b.shx + a.w1 *b.sy  + a.w2*b.w1;
+        w2  = a.w0 *b.tx  + a.w1 *b.ty  + a.w2*b.w2;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& 
+    trans_perspective::premultiply(const trans_affine& b)
+    {
+        trans_perspective a = *this;
+        sx  = a.sx *b.sx  + a.shx*b.shy;
+        shx = a.sx *b.shx + a.shx*b.sy;
+        tx  = a.sx *b.tx  + a.shx*b.ty  + a.tx;
+        shy = a.shy*b.sx  + a.sy *b.shy;
+        sy  = a.shy*b.shx + a.sy *b.sy;
+        ty  = a.shy*b.tx  + a.sy *b.ty  + a.ty;
+        w0  = a.w0 *b.sx  + a.w1 *b.shy;
+        w1  = a.w0 *b.shx + a.w1 *b.sy;
+        w2  = a.w0 *b.tx  + a.w1 *b.ty  + a.w2;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    const trans_perspective& 
+    trans_perspective::multiply_inv(const trans_perspective& m)
+    {
+        trans_perspective t = m;
+        t.invert();
+        return multiply(t);
+    }
+
+    //------------------------------------------------------------------------
+    const trans_perspective&
+    trans_perspective::multiply_inv(const trans_affine& m)
+    {
+        trans_affine t = m;
+        t.invert();
+        return multiply(t);
+    }
+
+    //------------------------------------------------------------------------
+    const trans_perspective&
+    trans_perspective::premultiply_inv(const trans_perspective& m)
+    {
+        trans_perspective t = m;
+        t.invert();
+        return *this = t.multiply(*this);
+    }
+
+    //------------------------------------------------------------------------
+    const trans_perspective&
+    trans_perspective::premultiply_inv(const trans_affine& m)
+    {
+        trans_perspective t(m);
+        t.invert();
+        return *this = t.multiply(*this);
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& 
+    trans_perspective::translate(double x, double y)
+    {
+        tx += x;
+        ty += y;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& trans_perspective::rotate(double a)
+    {
+        multiply(trans_affine_rotation(a));
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& trans_perspective::scale(double s)
+    {
+        multiply(trans_affine_scaling(s));
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& trans_perspective::scale(double x, double y)
+    {
+        multiply(trans_affine_scaling(x, y));
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_perspective::transform(double* px, double* py) const
+    {
+        double x = *px;
+        double y = *py;
+        double m = 1.0 / (x*w0 + y*w1 + w2);
+        *px = m * (x*sx  + y*shx + tx);
+        *py = m * (x*shy + y*sy  + ty);
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_perspective::transform_affine(double* x, double* y) const
+    {
+        double tmp = *x;
+        *x = tmp * sx  + *y * shx + tx;
+        *y = tmp * shy + *y * sy  + ty;
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_perspective::transform_2x2(double* x, double* y) const
+    {
+        double tmp = *x;
+        *x = tmp * sx  + *y * shx;
+        *y = tmp * shy + *y * sy;
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_perspective::inverse_transform(double* x, double* y) const
+    {
+        trans_perspective t(*this);
+        if(t.invert()) t.transform(x, y);
+    }
+
+    //------------------------------------------------------------------------
+    inline void trans_perspective::store_to(double* m) const
+    {
+        *m++ = sx;  *m++ = shy; *m++ = w0; 
+        *m++ = shx; *m++ = sy;  *m++ = w1;
+        *m++ = tx;  *m++ = ty;  *m++ = w2;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& trans_perspective::load_from(const double* m)
+    {
+        sx  = *m++; shy = *m++; w0 = *m++; 
+        shx = *m++; sy  = *m++; w1 = *m++;
+        tx  = *m++; ty  = *m++; w2 = *m++;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline const trans_perspective& 
+    trans_perspective::from_affine(const trans_affine& a)
+    {
+        sx  = a.sx;  shy = a.shy; w0 = 0; 
+        shx = a.shx; sy  = a.sy;  w1 = 0;
+        tx  = a.tx;  ty  = a.ty;  w2 = 1;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    inline double trans_perspective::determinant() const
+    {
+        return sx  * (sy  * w2 - ty  * w1) +
+               shx * (ty  * w0 - shy * w2) +
+               tx  * (shy * w1 - sy  * w0);
+    }
+  
+    //------------------------------------------------------------------------
+    inline double trans_perspective::determinant_reciprocal() const
+    {
+        return 1.0 / determinant();
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::is_valid(double epsilon) const
+    {
+        return fabs(sx) > epsilon && fabs(sy) > epsilon && fabs(w2) > epsilon;
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::is_identity(double epsilon) const
+    {
+        return is_equal_eps(sx,  1.0, epsilon) &&
+               is_equal_eps(shy, 0.0, epsilon) &&
+               is_equal_eps(w0,  0.0, epsilon) &&
+               is_equal_eps(shx, 0.0, epsilon) && 
+               is_equal_eps(sy,  1.0, epsilon) &&
+               is_equal_eps(w1,  0.0, epsilon) &&
+               is_equal_eps(tx,  0.0, epsilon) &&
+               is_equal_eps(ty,  0.0, epsilon) &&
+               is_equal_eps(w2,  1.0, epsilon);
+    }
+
+    //------------------------------------------------------------------------
+    inline bool trans_perspective::is_equal(const trans_perspective& m, 
+                                            double epsilon) const
+    {
+        return is_equal_eps(sx,  m.sx,  epsilon) &&
+               is_equal_eps(shy, m.shy, epsilon) &&
+               is_equal_eps(w0,  m.w0,  epsilon) &&
+               is_equal_eps(shx, m.shx, epsilon) && 
+               is_equal_eps(sy,  m.sy,  epsilon) &&
+               is_equal_eps(w1,  m.w1,  epsilon) &&
+               is_equal_eps(tx,  m.tx,  epsilon) &&
+               is_equal_eps(ty,  m.ty,  epsilon) &&
+               is_equal_eps(w2,  m.w2,  epsilon);
+    }
+
+    //------------------------------------------------------------------------
+    inline double trans_perspective::scale() const
+    {
+        double x = 0.707106781 * sx  + 0.707106781 * shx;
+        double y = 0.707106781 * shy + 0.707106781 * sy;
+        return sqrt(x*x + y*y);
+    }
+
+    //------------------------------------------------------------------------
+    inline double trans_perspective::rotation() const
+    {
+        double x1 = 0.0;
+        double y1 = 0.0;
+        double x2 = 1.0;
+        double y2 = 0.0;
+        transform(&x1, &y1);
+        transform(&x2, &y2);
+        return atan2(y2-y1, x2-x1);
+    }
+
+    //------------------------------------------------------------------------
+    void trans_perspective::translation(double* dx, double* dy) const
+    {
+        *dx = tx;
+        *dy = ty;
+    }
+
+    //------------------------------------------------------------------------
+    void trans_perspective::scaling(double* x, double* y) const
+    {
+        double x1 = 0.0;
+        double y1 = 0.0;
+        double x2 = 1.0;
+        double y2 = 1.0;
+        trans_perspective t(*this);
+        t *= trans_affine_rotation(-rotation());
+        t.transform(&x1, &y1);
+        t.transform(&x2, &y2);
+        *x = x2 - x1;
+        *y = y2 - y1;
+    }
+
+    //------------------------------------------------------------------------
+    void trans_perspective::scaling_abs(double* x, double* y) const
+    {
+        *x = sqrt(sx  * sx  + shx * shx);
+        *y = sqrt(shy * shy + sy  * sy);
+    }
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_trans_single_path.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_single_path.h
--- 8.0.1-5/src/renderers/agg/include/agg_trans_single_path.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_single_path.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,97 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_TRANS_SINGLE_PATH_INCLUDED
+#define AGG_TRANS_SINGLE_PATH_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vertex_sequence.h"
+
+namespace mapserver
+{
+
+    // See also: agg_trans_single_path.cpp
+    //
+    //-------------------------------------------------------trans_single_path
+    class trans_single_path
+    {
+        enum status_e
+        {
+            initial,
+            making_path,
+            ready
+        };
+
+    public:
+        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
+
+        trans_single_path();
+
+        //--------------------------------------------------------------------
+        void   base_length(double v)  { m_base_length = v; }
+        double base_length() const { return m_base_length; }
+
+        //--------------------------------------------------------------------
+        void preserve_x_scale(bool f) { m_preserve_x_scale = f;    }
+        bool preserve_x_scale() const { return m_preserve_x_scale; }
+
+        //--------------------------------------------------------------------
+        void reset();
+        void move_to(double x, double y);
+        void line_to(double x, double y);
+        void finalize_path();
+
+        //--------------------------------------------------------------------
+        template<class VertexSource> 
+        void add_path(VertexSource& vs, unsigned path_id=0)
+        {
+            double x;
+            double y;
+
+            unsigned cmd;
+            vs.rewind(path_id);
+            while(!is_stop(cmd = vs.vertex(&x, &y)))
+            {
+                if(is_move_to(cmd)) 
+                {
+                    move_to(x, y);
+                }
+                else 
+                {
+                    if(is_vertex(cmd))
+                    {
+                        line_to(x, y);
+                    }
+                }
+            }
+            finalize_path();
+        }
+
+        //--------------------------------------------------------------------
+        double total_length() const;
+        void transform(double *x, double *y) const;
+
+    private:
+        vertex_storage m_src_vertices;
+        double         m_base_length;
+        double         m_kindex;
+        status_e       m_status;
+        bool           m_preserve_x_scale;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_trans_viewport.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_viewport.h
--- 8.0.1-5/src/renderers/agg/include/agg_trans_viewport.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_viewport.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,303 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Viewport transformer - simple orthogonal conversions from world coordinates
+//                        to screen (device) ones.
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_TRANS_VIEWPORT_INCLUDED
+#define AGG_TRANS_VIEWPORT_INCLUDED
+
+#include <string.h>
+#include "agg_trans_affine.h"
+
+
+namespace mapserver
+{
+
+    enum aspect_ratio_e
+    {
+        aspect_ratio_stretch,
+        aspect_ratio_meet,
+        aspect_ratio_slice
+    };
+
+
+    //----------------------------------------------------------trans_viewport
+    class trans_viewport
+    {
+    public:
+        //-------------------------------------------------------------------
+        trans_viewport() : 
+            m_world_x1(0.0),
+            m_world_y1(0.0),
+            m_world_x2(1.0),
+            m_world_y2(1.0),
+            m_device_x1(0.0),
+            m_device_y1(0.0),
+            m_device_x2(1.0),
+            m_device_y2(1.0),
+            m_aspect(aspect_ratio_stretch),
+            m_is_valid(true),
+            m_align_x(0.5),
+            m_align_y(0.5),
+            m_wx1(0.0),
+            m_wy1(0.0),
+            m_wx2(1.0),
+            m_wy2(1.0),
+            m_dx1(0.0),
+            m_dy1(0.0),
+            m_kx(1.0),
+            m_ky(1.0)
+        {}
+
+        //-------------------------------------------------------------------
+        void preserve_aspect_ratio(double alignx, 
+                                   double aligny, 
+                                   aspect_ratio_e aspect)
+        {
+            m_align_x = alignx;
+            m_align_y = aligny;
+            m_aspect  = aspect;
+            update();
+        }
+
+        //-------------------------------------------------------------------
+        void device_viewport(double x1, double y1, double x2, double y2)
+        {
+            m_device_x1 = x1;
+            m_device_y1 = y1;
+            m_device_x2 = x2;
+            m_device_y2 = y2;
+            update();
+        }
+
+        //-------------------------------------------------------------------
+        void world_viewport(double x1, double y1, double x2, double y2)
+        {
+            m_world_x1 = x1;
+            m_world_y1 = y1;
+            m_world_x2 = x2;
+            m_world_y2 = y2;
+            update();
+        }
+
+        //-------------------------------------------------------------------
+        void device_viewport(double* x1, double* y1, double* x2, double* y2) const
+        {
+            *x1 = m_device_x1;
+            *y1 = m_device_y1;
+            *x2 = m_device_x2;
+            *y2 = m_device_y2;
+        }
+
+        //-------------------------------------------------------------------
+        void world_viewport(double* x1, double* y1, double* x2, double* y2) const
+        {
+            *x1 = m_world_x1;
+            *y1 = m_world_y1;
+            *x2 = m_world_x2;
+            *y2 = m_world_y2;
+        }
+
+        //-------------------------------------------------------------------
+        void world_viewport_actual(double* x1, double* y1, 
+                                   double* x2, double* y2) const
+        {
+            *x1 = m_wx1;
+            *y1 = m_wy1;
+            *x2 = m_wx2;
+            *y2 = m_wy2;
+        }
+
+        //-------------------------------------------------------------------
+        bool   is_valid()             const { return m_is_valid; }
+        double align_x()              const { return m_align_x; }
+        double align_y()              const { return m_align_y; }
+        aspect_ratio_e aspect_ratio() const { return m_aspect; }
+
+        //-------------------------------------------------------------------
+        void transform(double* x, double* y) const
+        {
+            *x = (*x - m_wx1) * m_kx + m_dx1;
+            *y = (*y - m_wy1) * m_ky + m_dy1;
+        }
+
+        //-------------------------------------------------------------------
+        void transform_scale_only(double* x, double* y) const
+        {
+            *x *= m_kx;
+            *y *= m_ky;
+        }
+
+        //-------------------------------------------------------------------
+        void inverse_transform(double* x, double* y) const
+        {
+            *x = (*x - m_dx1) / m_kx + m_wx1;
+            *y = (*y - m_dy1) / m_ky + m_wy1;
+        }
+
+        //-------------------------------------------------------------------
+        void inverse_transform_scale_only(double* x, double* y) const
+        {
+            *x /= m_kx;
+            *y /= m_ky;
+        }
+
+        //-------------------------------------------------------------------
+        double device_dx() const { return m_dx1 - m_wx1 * m_kx; }
+        double device_dy() const { return m_dy1 - m_wy1 * m_ky; }
+
+        //-------------------------------------------------------------------
+        double scale_x() const
+        {
+            return m_kx;
+        }
+
+        //-------------------------------------------------------------------
+        double scale_y() const
+        {
+            return m_ky;
+        }
+
+        //-------------------------------------------------------------------
+        double scale() const
+        {
+            return (m_kx + m_ky) * 0.5;
+        }
+
+        //-------------------------------------------------------------------
+        trans_affine to_affine() const
+        {
+            trans_affine mtx = trans_affine_translation(-m_wx1, -m_wy1);
+            mtx *= trans_affine_scaling(m_kx, m_ky);
+            mtx *= trans_affine_translation(m_dx1, m_dy1);
+            return mtx;
+        }
+
+        //-------------------------------------------------------------------
+        trans_affine to_affine_scale_only() const
+        {
+            return trans_affine_scaling(m_kx, m_ky);
+        }
+
+        //-------------------------------------------------------------------
+        unsigned byte_size() const
+        {
+            return sizeof(*this);
+        }
+
+        void serialize(int8u* ptr) const
+        {
+            memcpy(ptr, this, sizeof(*this)); 
+        }
+
+        void deserialize(const int8u* ptr)
+        {
+            memcpy(this,  ptr, sizeof(*this));
+        }
+
+    private:
+        void update();
+
+        double         m_world_x1;
+        double         m_world_y1;
+        double         m_world_x2;
+        double         m_world_y2;
+        double         m_device_x1;
+        double         m_device_y1;
+        double         m_device_x2;
+        double         m_device_y2;
+        aspect_ratio_e m_aspect;
+        bool           m_is_valid;
+        double         m_align_x;
+        double         m_align_y;
+        double         m_wx1;
+        double         m_wy1;
+        double         m_wx2;
+        double         m_wy2;
+        double         m_dx1;
+        double         m_dy1;
+        double         m_kx;
+        double         m_ky;
+    };
+
+
+
+    //-----------------------------------------------------------------------
+    inline void trans_viewport::update()
+    {
+        const double epsilon = 1e-30;
+        if(fabs(m_world_x1  - m_world_x2)  < epsilon ||
+           fabs(m_world_y1  - m_world_y2)  < epsilon ||
+           fabs(m_device_x1 - m_device_x2) < epsilon ||
+           fabs(m_device_y1 - m_device_y2) < epsilon)
+        {
+            m_wx1 = m_world_x1;
+            m_wy1 = m_world_y1;
+            m_wx2 = m_world_x1 + 1.0;
+            m_wy2 = m_world_y2 + 1.0;
+            m_dx1 = m_device_x1;
+            m_dy1 = m_device_y1;
+            m_kx  = 1.0;
+            m_ky  = 1.0;
+            m_is_valid = false;
+            return;
+        }
+
+        double world_x1  = m_world_x1;
+        double world_y1  = m_world_y1;
+        double world_x2  = m_world_x2;
+        double world_y2  = m_world_y2;
+        double device_x1 = m_device_x1;
+        double device_y1 = m_device_y1;
+        double device_x2 = m_device_x2;
+        double device_y2 = m_device_y2;
+        if(m_aspect != aspect_ratio_stretch)
+        {
+            double d;
+            m_kx = (device_x2 - device_x1) / (world_x2 - world_x1);
+            m_ky = (device_y2 - device_y1) / (world_y2 - world_y1);
+
+            if((m_aspect == aspect_ratio_meet) == (m_kx < m_ky))
+            {
+                d         = (world_y2 - world_y1) * m_ky / m_kx;
+                world_y1 += (world_y2 - world_y1 - d) * m_align_y;
+                world_y2  =  world_y1 + d;
+            }
+            else
+            {
+                d         = (world_x2 - world_x1) * m_kx / m_ky;
+                world_x1 += (world_x2 - world_x1 - d) * m_align_x;
+                world_x2  =  world_x1 + d;
+            }
+        }
+        m_wx1 = world_x1;
+        m_wy1 = world_y1;
+        m_wx2 = world_x2;
+        m_wy2 = world_y2;
+        m_dx1 = device_x1;
+        m_dy1 = device_y1;
+        m_kx  = (device_x2 - device_x1) / (world_x2 - world_x1);
+        m_ky  = (device_y2 - device_y1) / (world_y2 - world_y1);
+        m_is_valid = true;
+    }
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_trans_warp_magnifier.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_warp_magnifier.h
--- 8.0.1-5/src/renderers/agg/include/agg_trans_warp_magnifier.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_trans_warp_magnifier.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,56 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_WARP_MAGNIFIER_INCLUDED
+#define AGG_WARP_MAGNIFIER_INCLUDED
+
+
+namespace mapserver
+{
+
+    //----------------------------------------------------trans_warp_magnifier
+    //
+    // See Inmplementation agg_trans_warp_magnifier.cpp
+    //
+    class trans_warp_magnifier
+    {
+    public:
+        trans_warp_magnifier() : m_xc(0.0), m_yc(0.0), m_magn(1.0), m_radius(1.0) {}
+ 
+        void center(double x, double y) { m_xc = x; m_yc = y; }
+        void magnification(double m)    { m_magn = m;         }
+        void radius(double r)           { m_radius = r;       }
+
+        double xc()            const { return m_xc; }
+        double yc()            const { return m_yc; }
+        double magnification() const { return m_magn;   }
+        double radius()        const { return m_radius; }
+
+        void transform(double* x, double* y) const;
+        void inverse_transform(double* x, double* y) const;
+
+    private:
+        double m_xc;
+        double m_yc;
+        double m_magn;
+        double m_radius;
+    };
+
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vcgen_bspline.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_bspline.h
--- 8.0.1-5/src/renderers/agg/include/agg_vcgen_bspline.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_bspline.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,74 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VCGEN_BSPLINE_INCLUDED
+#define AGG_VCGEN_BSPLINE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_array.h"
+#include "agg_bspline.h"
+
+
+namespace mapserver
+{
+
+    //==========================================================vcgen_bspline
+    class vcgen_bspline
+    {
+        enum status_e
+        {
+            initial,
+            ready,
+            polygon,
+            end_poly,
+            stop
+        };
+
+    public:
+        typedef pod_bvector<point_d, 6> vertex_storage;
+
+        vcgen_bspline();
+
+        void interpolation_step(double v) { m_interpolation_step = v; }
+        double interpolation_step() const { return m_interpolation_step; }
+
+        // Vertex Generator Interface
+        void remove_all();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        // Vertex Source Interface
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        vcgen_bspline(const vcgen_bspline&);
+        const vcgen_bspline& operator = (const vcgen_bspline&);
+
+        vertex_storage m_src_vertices;
+        bspline        m_spline_x;
+        bspline        m_spline_y;
+        double         m_interpolation_step;
+        unsigned       m_closed;
+        status_e       m_status;
+        unsigned       m_src_vertex;
+        double         m_cur_abscissa;
+        double         m_max_abscissa;
+    };
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vcgen_contour.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_contour.h
--- 8.0.1-5/src/renderers/agg/include/agg_vcgen_contour.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_contour.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,94 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VCGEN_CONTOUR_INCLUDED
+#define AGG_VCGEN_CONTOUR_INCLUDED
+
+#include "agg_math_stroke.h"
+
+namespace mapserver
+{
+
+    //----------------------------------------------------------vcgen_contour
+    //
+    // See Implementation agg_vcgen_contour.cpp
+    //
+    class vcgen_contour
+    {
+        enum status_e
+        {
+            initial,
+            ready,
+            outline,
+            out_vertices,
+            end_poly,
+            stop
+        };
+
+    public:
+        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
+        typedef pod_bvector<point_d, 6>         coord_storage;
+
+        vcgen_contour();
+
+        void line_cap(line_cap_e lc)     { m_stroker.line_cap(lc); }
+        void line_join(line_join_e lj)   { m_stroker.line_join(lj); }
+        void inner_join(inner_join_e ij) { m_stroker.inner_join(ij); }
+
+        line_cap_e   line_cap()   const { return m_stroker.line_cap(); }
+        line_join_e  line_join()  const { return m_stroker.line_join(); }
+        inner_join_e inner_join() const { return m_stroker.inner_join(); }
+
+        void width(double w) { m_stroker.width(m_width = w); }
+        void miter_limit(double ml) { m_stroker.miter_limit(ml); }
+        void miter_limit_theta(double t) { m_stroker.miter_limit_theta(t); }
+        void inner_miter_limit(double ml) { m_stroker.inner_miter_limit(ml); }
+        void approximation_scale(double as) { m_stroker.approximation_scale(as); }
+
+        double width() const { return m_width; }
+        double miter_limit() const { return m_stroker.miter_limit(); }
+        double inner_miter_limit() const { return m_stroker.inner_miter_limit(); }
+        double approximation_scale() const { return m_stroker.approximation_scale(); }
+
+        void auto_detect_orientation(bool v) { m_auto_detect = v; }
+        bool auto_detect_orientation() const { return m_auto_detect; }
+
+        // Generator interface
+        void remove_all();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        // Vertex Source Interface
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        vcgen_contour(const vcgen_contour&);
+        const vcgen_contour& operator = (const vcgen_contour&);
+
+        math_stroke<coord_storage> m_stroker;
+        double                     m_width;
+        vertex_storage             m_src_vertices;
+        coord_storage              m_out_vertices;
+        status_e                   m_status;
+        unsigned                   m_src_vertex;
+        unsigned                   m_out_vertex = 0;
+        unsigned                   m_closed;
+        unsigned                   m_orientation;
+        bool                       m_auto_detect;
+    };
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vcgen_dash.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_dash.h
--- 8.0.1-5/src/renderers/agg/include/agg_vcgen_dash.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_dash.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,93 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Line dash generator
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_VCGEN_DASH_INCLUDED
+#define AGG_VCGEN_DASH_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vertex_sequence.h"
+
+namespace mapserver
+{
+
+    //---------------------------------------------------------------vcgen_dash
+    //
+    // See Implementation agg_vcgen_dash.cpp
+    //
+    class vcgen_dash
+    {
+        enum max_dashes_e
+        {
+            max_dashes = 32
+        };
+
+        enum status_e
+        {
+            initial,
+            ready,
+            polyline,
+            stop
+        };
+
+    public:
+        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
+
+        vcgen_dash();
+
+        void remove_all_dashes();
+        void add_dash(double dash_len, double gap_len);
+        void dash_start(double ds);
+
+        void shorten(double s) { m_shorten = s; }
+        double shorten() const { return m_shorten; }
+
+        // Vertex Generator Interface
+        void remove_all();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        // Vertex Source Interface
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        vcgen_dash(const vcgen_dash&);
+        const vcgen_dash& operator = (const vcgen_dash&);
+
+        void calc_dash_start(double ds);
+
+        double             m_dashes[max_dashes];
+        double             m_total_dash_len;
+        unsigned           m_num_dashes;
+        double             m_dash_start;
+        double             m_shorten;
+        double             m_curr_dash_start;
+        unsigned           m_curr_dash;
+        double             m_curr_rest = 0;
+        const vertex_dist* m_v1 = nullptr;
+        const vertex_dist* m_v2 = nullptr;
+
+        vertex_storage m_src_vertices;
+        unsigned       m_closed;
+        status_e       m_status;
+        unsigned       m_src_vertex;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vcgen_markers_term.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_markers_term.h
--- 8.0.1-5/src/renderers/agg/include/agg_vcgen_markers_term.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_markers_term.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,66 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VCGEN_MARKERS_TERM_INCLUDED
+#define AGG_VCGEN_MARKERS_TERM_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vertex_sequence.h"
+
+namespace mapserver
+{
+
+    //======================================================vcgen_markers_term
+    //
+    // See Implemantation agg_vcgen_markers_term.cpp
+    // Terminal markers generator (arrowhead/arrowtail)
+    //
+    //------------------------------------------------------------------------
+    class vcgen_markers_term
+    {
+    public:
+        vcgen_markers_term() : m_curr_id(0), m_curr_idx(0) {}
+
+        // Vertex Generator Interface
+        void remove_all();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        // Vertex Source Interface
+        void rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        vcgen_markers_term(const vcgen_markers_term&);
+        const vcgen_markers_term& operator = (const vcgen_markers_term&);
+
+        struct coord_type
+        {
+            double x, y;
+
+            coord_type() {}
+            coord_type(double x_, double y_) : x(x_), y(y_) {}
+        };
+
+        typedef pod_bvector<coord_type, 6> coord_storage; 
+
+        coord_storage m_markers;
+        unsigned      m_curr_id;
+        unsigned      m_curr_idx;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vcgen_smooth_poly1.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_smooth_poly1.h
--- 8.0.1-5/src/renderers/agg/include/agg_vcgen_smooth_poly1.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_smooth_poly1.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,87 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VCGEN_SMOOTH_POLY1_INCLUDED
+#define AGG_VCGEN_SMOOTH_POLY1_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vertex_sequence.h"
+
+
+namespace mapserver
+{
+
+    //======================================================vcgen_smooth_poly1
+    //
+    // See Implementation agg_vcgen_smooth_poly1.cpp 
+    // Smooth polygon generator
+    //
+    //------------------------------------------------------------------------
+    class vcgen_smooth_poly1
+    {
+        enum status_e
+        {
+            initial,
+            ready,
+            polygon,
+            ctrl_b,
+            ctrl_e,
+            ctrl1,
+            ctrl2,
+            end_poly,
+            stop
+        };
+
+    public:
+        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
+
+        vcgen_smooth_poly1();
+
+        void   smooth_value(double v) { m_smooth_value = v * 0.5; }
+        double smooth_value() const { return m_smooth_value * 2.0; }
+
+        // Vertex Generator Interface
+        void remove_all();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        // Vertex Source Interface
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        vcgen_smooth_poly1(const vcgen_smooth_poly1&);
+        const vcgen_smooth_poly1& operator = (const vcgen_smooth_poly1&);
+
+        void calculate(const vertex_dist& v0, 
+                       const vertex_dist& v1, 
+                       const vertex_dist& v2,
+                       const vertex_dist& v3);
+
+        vertex_storage m_src_vertices;
+        double         m_smooth_value;
+        unsigned       m_closed;
+        status_e       m_status;
+        unsigned       m_src_vertex;
+        double         m_ctrl1_x;
+        double         m_ctrl1_y;
+        double         m_ctrl2_x;
+        double         m_ctrl2_y;
+    };
+
+}
+
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vcgen_stroke.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_stroke.h
--- 8.0.1-5/src/renderers/agg/include/agg_vcgen_stroke.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_stroke.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,102 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VCGEN_STROKE_INCLUDED
+#define AGG_VCGEN_STROKE_INCLUDED
+
+#include "agg_math_stroke.h"
+
+
+namespace mapserver
+{
+
+    //============================================================vcgen_stroke
+    //
+    // See Implementation agg_vcgen_stroke.cpp
+    // Stroke generator
+    //
+    //------------------------------------------------------------------------
+    class vcgen_stroke
+    {
+        enum status_e
+        {
+            initial,
+            ready,
+            cap1,
+            cap2,
+            outline1,
+            close_first,
+            outline2,
+            out_vertices,
+            end_poly1,
+            end_poly2,
+            stop
+        };
+
+    public:
+        typedef vertex_sequence<vertex_dist, 6> vertex_storage;
+        typedef pod_bvector<point_d, 6>         coord_storage;
+
+        vcgen_stroke();
+
+        void line_cap(line_cap_e lc)     { m_stroker.line_cap(lc); }
+        void line_join(line_join_e lj)   { m_stroker.line_join(lj); }
+        void inner_join(inner_join_e ij) { m_stroker.inner_join(ij); }
+
+        line_cap_e   line_cap()   const { return m_stroker.line_cap(); }
+        line_join_e  line_join()  const { return m_stroker.line_join(); }
+        inner_join_e inner_join() const { return m_stroker.inner_join(); }
+
+        void width(double w) { m_stroker.width(w); }
+        void miter_limit(double ml) { m_stroker.miter_limit(ml); }
+        void miter_limit_theta(double t) { m_stroker.miter_limit_theta(t); }
+        void inner_miter_limit(double ml) { m_stroker.inner_miter_limit(ml); }
+        void approximation_scale(double as) { m_stroker.approximation_scale(as); }
+
+        double width() const { return m_stroker.width(); }
+        double miter_limit() const { return m_stroker.miter_limit(); }
+        double inner_miter_limit() const { return m_stroker.inner_miter_limit(); }
+        double approximation_scale() const { return m_stroker.approximation_scale(); }
+
+        void shorten(double s) { m_shorten = s; }
+        double shorten() const { return m_shorten; }
+
+        // Vertex Generator Interface
+        void remove_all();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        // Vertex Source Interface
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        vcgen_stroke(const vcgen_stroke&);
+        const vcgen_stroke& operator = (const vcgen_stroke&);
+
+        math_stroke<coord_storage> m_stroker;
+        vertex_storage             m_src_vertices;
+        coord_storage              m_out_vertices;
+        double                     m_shorten;
+        unsigned                   m_closed;
+        status_e                   m_status;
+        status_e                   m_prev_status = initial;
+        unsigned                   m_src_vertex;
+        unsigned                   m_out_vertex;
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vcgen_vertex_sequence.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_vertex_sequence.h
--- 8.0.1-5/src/renderers/agg/include/agg_vcgen_vertex_sequence.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vcgen_vertex_sequence.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,135 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VCGEN_VERTEX_SEQUENCE_INCLUDED
+#define AGG_VCGEN_VERTEX_SEQUENCE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_vertex_sequence.h"
+#include "agg_shorten_path.h"
+
+namespace mapserver
+{
+
+    //===================================================vcgen_vertex_sequence
+    class vcgen_vertex_sequence
+    {
+    public:
+        typedef vertex_dist_cmd                 vertex_type;
+        typedef vertex_sequence<vertex_type, 6> vertex_storage;
+
+        vcgen_vertex_sequence() :
+            m_flags(0),
+            m_cur_vertex(0),
+            m_shorten(0.0),
+            m_ready(false)
+        {
+        }
+
+        // Vertex Generator Interface
+        void remove_all();
+        void add_vertex(double x, double y, unsigned cmd);
+
+        // Vertex Source Interface
+        void     rewind(unsigned path_id);
+        unsigned vertex(double* x, double* y);
+
+        void shorten(double s) { m_shorten = s; }
+        double shorten() const { return m_shorten; }
+
+    private:
+        vcgen_vertex_sequence(const vcgen_vertex_sequence&);
+        const vcgen_vertex_sequence& operator = (const vcgen_vertex_sequence&);
+
+        vertex_storage m_src_vertices;
+        unsigned       m_flags;
+        unsigned       m_cur_vertex;
+        double         m_shorten;
+        bool           m_ready;
+    };
+
+
+    //------------------------------------------------------------------------
+    inline void vcgen_vertex_sequence::remove_all()
+    {
+        m_ready = false;
+        m_src_vertices.remove_all();
+        m_cur_vertex = 0;
+        m_flags = 0;
+    }
+
+    //------------------------------------------------------------------------
+    inline void vcgen_vertex_sequence::add_vertex(double x, double y, unsigned cmd)
+    {
+        m_ready = false;
+        if(is_move_to(cmd))
+        {
+            m_src_vertices.modify_last(vertex_dist_cmd(x, y, cmd));
+        }
+        else
+        {
+            if(is_vertex(cmd))
+            {
+                m_src_vertices.add(vertex_dist_cmd(x, y, cmd));
+            }
+            else
+            {
+                m_flags = cmd & path_flags_mask;
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    inline void vcgen_vertex_sequence::rewind(unsigned) 
+    { 
+        if(!m_ready)
+        {
+            m_src_vertices.close(is_closed(m_flags));
+            shorten_path(m_src_vertices, m_shorten, get_close_flag(m_flags));
+        }
+        m_ready = true;
+        m_cur_vertex = 0; 
+    }
+
+    //------------------------------------------------------------------------
+    inline unsigned vcgen_vertex_sequence::vertex(double* x, double* y)
+    {
+        if(!m_ready)
+        {
+            rewind(0);
+        }
+
+        if(m_cur_vertex == m_src_vertices.size())
+        {
+            ++m_cur_vertex;
+            return path_cmd_end_poly | m_flags;
+        }
+
+        if(m_cur_vertex > m_src_vertices.size())
+        {
+            return path_cmd_stop;
+        }
+
+        vertex_type& v = m_src_vertices[m_cur_vertex++];
+        *x = v.x;
+        *y = v.y;
+        return v.cmd;
+    }
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vertex_sequence.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vertex_sequence.h
--- 8.0.1-5/src/renderers/agg/include/agg_vertex_sequence.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vertex_sequence.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,171 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// vertex_sequence container and vertex_dist struct
+//
+//----------------------------------------------------------------------------
+#ifndef AGG_VERTEX_SEQUENCE_INCLUDED
+#define AGG_VERTEX_SEQUENCE_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_array.h"
+#include "agg_math.h"
+
+namespace mapserver
+{
+
+    //----------------------------------------------------------vertex_sequence
+    // Modified mapserver::pod_bvector. The data is interpreted as a sequence 
+    // of vertices. It means that the type T must expose:
+    //
+    // bool T::operator() (const T& val)
+    // 
+    // that is called every time new vertex is being added. The main purpose
+    // of this operator is the possibility to calculate some values during 
+    // adding and to return true if the vertex fits some criteria or false if
+    // it doesn't. In the last case the new vertex is not added. 
+    // 
+    // The simple example is filtering coinciding vertices with calculation 
+    // of the distance between the current and previous ones:
+    //
+    //    struct vertex_dist
+    //    {
+    //        double   x;
+    //        double   y;
+    //        double   dist;
+    //
+    //        vertex_dist() {}
+    //        vertex_dist(double x_, double y_) :
+    //            x(x_),
+    //            y(y_),
+    //            dist(0.0)
+    //        {
+    //        }
+    //
+    //        bool operator () (const vertex_dist& val)
+    //        {
+    //            return (dist = calc_distance(x, y, val.x, val.y)) > EPSILON;
+    //        }
+    //    };
+    //
+    // Function close() calls this operator and removes the last vertex if 
+    // necessary.
+    //------------------------------------------------------------------------
+    template<class T, unsigned S=6> 
+    class vertex_sequence : public pod_bvector<T, S>
+    {
+    public:
+        typedef pod_bvector<T, S> base_type;
+
+        void add(const T& val);
+        void modify_last(const T& val);
+        void close(bool remove_flag);
+    };
+
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void vertex_sequence<T, S>::add(const T& val)
+    {
+        if(base_type::size() > 1)
+        {
+            if(!(*this)[base_type::size() - 2]((*this)[base_type::size() - 1])) 
+            {
+                base_type::remove_last();
+            }
+        }
+        base_type::add(val);
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void vertex_sequence<T, S>::modify_last(const T& val)
+    {
+        base_type::remove_last();
+        add(val);
+    }
+
+
+
+    //------------------------------------------------------------------------
+    template<class T, unsigned S> 
+    void vertex_sequence<T, S>::close(bool closed)
+    {
+        while(base_type::size() > 1)
+        {
+            if((*this)[base_type::size() - 2]((*this)[base_type::size() - 1])) break;
+            T t = (*this)[base_type::size() - 1];
+            base_type::remove_last();
+            modify_last(t);
+        }
+
+        if(closed)
+        {
+            while(base_type::size() > 1)
+            {
+                if((*this)[base_type::size() - 1]((*this)[0])) break;
+                base_type::remove_last();
+            }
+        }
+    }
+
+
+    //-------------------------------------------------------------vertex_dist
+    // Vertex (x, y) with the distance to the next one. The last vertex has 
+    // distance between the last and the first points if the polygon is closed
+    // and 0.0 if it's a polyline.
+    struct vertex_dist
+    {
+        double   x = 0;
+        double   y = 0;
+        double   dist = 0;
+
+        vertex_dist() = default;
+        vertex_dist(double x_, double y_) :
+            x(x_),
+            y(y_)
+        {
+        }
+
+        bool operator () (const vertex_dist& val)
+        {
+            bool ret = (dist = calc_distance(x, y, val.x, val.y)) > vertex_dist_epsilon;
+            if(!ret) dist = 1.0 / vertex_dist_epsilon;
+            return ret;
+        }
+    };
+
+
+
+    //--------------------------------------------------------vertex_dist_cmd
+    // Save as the above but with additional "command" value
+    struct vertex_dist_cmd : public vertex_dist
+    {
+        unsigned cmd;
+
+        vertex_dist_cmd() {}
+        vertex_dist_cmd(double x_, double y_, unsigned cmd_) :
+            vertex_dist(x_, y_),
+            cmd(cmd_)
+        {
+        }
+    };
+
+
+}
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vpgen_clip_polygon.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vpgen_clip_polygon.h
--- 8.0.1-5/src/renderers/agg/include/agg_vpgen_clip_polygon.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vpgen_clip_polygon.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,83 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VPGEN_CLIP_POLYGON_INCLUDED
+#define AGG_VPGEN_CLIP_POLYGON_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //======================================================vpgen_clip_polygon
+    //
+    // See Implementation agg_vpgen_clip_polygon.cpp
+    //
+    class vpgen_clip_polygon
+    {
+    public:
+        vpgen_clip_polygon() : 
+            m_clip_box(0, 0, 1, 1),
+            m_x1(0),
+            m_y1(0),
+            m_clip_flags(0),
+            m_num_vertices(0),
+            m_vertex(0),
+            m_cmd(path_cmd_move_to)
+        {
+        }
+
+        void clip_box(double x1, double y1, double x2, double y2)
+        {
+            m_clip_box.x1 = x1;
+            m_clip_box.y1 = y1;
+            m_clip_box.x2 = x2;
+            m_clip_box.y2 = y2;
+            m_clip_box.normalize();
+        }
+
+
+        double x1() const { return m_clip_box.x1; }
+        double y1() const { return m_clip_box.y1; }
+        double x2() const { return m_clip_box.x2; }
+        double y2() const { return m_clip_box.y2; }
+
+        static bool auto_close()   { return true;  }
+        static bool auto_unclose() { return false; }
+
+        void     reset();
+        void     move_to(double x, double y);
+        void     line_to(double x, double y);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        unsigned clipping_flags(double x, double y);
+
+    private:
+        rect_d        m_clip_box;
+        double        m_x1;
+        double        m_y1;
+        unsigned      m_clip_flags;
+        double        m_x[4];
+        double        m_y[4];
+        unsigned      m_num_vertices;
+        unsigned      m_vertex;
+        unsigned      m_cmd;
+    };
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vpgen_clip_polyline.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vpgen_clip_polyline.h
--- 8.0.1-5/src/renderers/agg/include/agg_vpgen_clip_polyline.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vpgen_clip_polyline.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,78 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VPGEN_CLIP_POLYLINE_INCLUDED
+#define AGG_VPGEN_CLIP_POLYLINE_INCLUDED
+
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //======================================================vpgen_clip_polyline
+    //
+    // See Implementation agg_vpgen_clip_polyline.cpp
+    //
+    class vpgen_clip_polyline
+    {
+    public:
+        vpgen_clip_polyline() : 
+            m_clip_box(0, 0, 1, 1),
+            m_x1(0),
+            m_y1(0),
+            m_num_vertices(0),
+            m_vertex(0),
+            m_move_to(false)
+        {
+        }
+
+        void clip_box(double x1, double y1, double x2, double y2)
+        {
+            m_clip_box.x1 = x1;
+            m_clip_box.y1 = y1;
+            m_clip_box.x2 = x2;
+            m_clip_box.y2 = y2;
+            m_clip_box.normalize();
+        }
+
+        double x1() const { return m_clip_box.x1; }
+        double y1() const { return m_clip_box.y1; }
+        double x2() const { return m_clip_box.x2; }
+        double y2() const { return m_clip_box.y2; }
+
+        static bool auto_close()   { return false; }
+        static bool auto_unclose() { return true; }
+
+        void     reset();
+        void     move_to(double x, double y);
+        void     line_to(double x, double y);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        rect_d        m_clip_box;
+        double        m_x1;
+        double        m_y1;
+        double        m_x[2];
+        double        m_y[2];
+        unsigned      m_cmd[2];
+        unsigned      m_num_vertices;
+        unsigned      m_vertex;
+        bool          m_move_to;
+    };
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/agg_vpgen_segmentator.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vpgen_segmentator.h
--- 8.0.1-5/src/renderers/agg/include/agg_vpgen_segmentator.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/agg_vpgen_segmentator.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,61 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#ifndef AGG_VPGEN_SEGMENTATOR_INCLUDED
+#define AGG_VPGEN_SEGMENTATOR_INCLUDED
+
+#include <math.h>
+#include "agg_basics.h"
+
+namespace mapserver
+{
+
+    //=======================================================vpgen_segmentator
+    // 
+    // See Implementation agg_vpgen_segmentator.cpp
+    //
+    class vpgen_segmentator
+    {
+    public:
+        vpgen_segmentator() : m_approximation_scale(1.0) {}
+
+        void approximation_scale(double s) { m_approximation_scale = s;     }
+        double approximation_scale() const { return m_approximation_scale;  }
+
+        static bool auto_close()   { return false; }
+        static bool auto_unclose() { return false; }
+
+        void reset() { m_cmd = path_cmd_stop; }
+        void move_to(double x, double y);
+        void line_to(double x, double y);
+        unsigned vertex(double* x, double* y);
+
+    private:
+        double   m_approximation_scale;
+        double   m_x1;
+        double   m_y1;
+        double   m_dx;
+        double   m_dy;
+        double   m_dl;
+        double   m_ddl;
+        unsigned m_cmd;
+    };
+
+
+
+}
+
+#endif
+
diff -pruN 8.0.1-5/src/renderers/agg/include/clipper.hpp 8.2.0~beta1-1~exp1/src/renderers/agg/include/clipper.hpp
--- 8.0.1-5/src/renderers/agg/include/clipper.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/clipper.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,302 @@
+/*******************************************************************************
+*                                                                              *
+* Author    :  Angus Johnson                                                   *
+* Version   :  4.6.3                                                           *
+* Date      :  11 November 2011                                                *
+* Website   :  http://www.angusj.com                                           *
+* Copyright :  Angus Johnson 2010-2011                                         *
+*                                                                              *
+* License:                                                                     *
+* Use, modification & distribution is subject to Boost Software License Ver 1. *
+* http://www.boost.org/LICENSE_1_0.txt                                         *
+*                                                                              *
+* Attributions:                                                                *
+* The code in this library is an extension of Bala Vatti's clipping algorithm: *
+* "A generic solution to polygon clipping"                                     *
+* Communications of the ACM, Vol 35, Issue 7 (July 1992) pp 56-63.             *
+* http://portal.acm.org/citation.cfm?id=129906                                 *
+*                                                                              *
+* Computer graphics and geometric modeling: implementation and algorithms      *
+* By Max K. Agoston                                                            *
+* Springer; 1 edition (January 4, 2005)                                        *
+* http://books.google.com/books?q=vatti+clipping+agoston                       *
+*                                                                              *
+* See also:                                                                    *
+* "Polygon Offsetting by Computing Winding Numbers"                            *
+* Paper no. DETC2005-85513 pp. 565-575                                         *
+* ASME 2005 International Design Engineering Technical Conferences             *
+* and Computers and Information in Engineering Conference (IDETC/CIE2005)      *
+* September 24-28, 2005 , Long Beach, California, USA                          *
+* http://www.me.berkeley.edu/~mcmains/pubs/DAC05OffsetPolygon.pdf              *
+*                                                                              *
+*******************************************************************************/
+
+#ifndef clipper_hpp
+#define clipper_hpp
+
+#include <vector>
+#include <stdexcept>
+#include <cstring>
+#include <cstdlib>
+#include <ostream>
+
+namespace ClipperLib {
+
+enum ClipType { ctIntersection, ctUnion, ctDifference, ctXor };
+enum PolyType { ptSubject, ptClip };
+//By far the most widely used winding rules for polygon filling are
+//EvenOdd & NonZero (GDI, GDI+, XLib, OpenGL, Cairo, AGG, Quartz, SVG, Gr32)
+//Others rules include Positive, Negative and ABS_GTR_EQ_TWO (only in OpenGL)
+//see http://glprogramming.com/red/chapter11.html
+enum PolyFillType { pftEvenOdd, pftNonZero, pftPositive, pftNegative };
+
+typedef signed long long long64;
+typedef unsigned long long ulong64;
+
+struct IntPoint {
+public:
+  long64 X;
+  long64 Y;
+  IntPoint(long64 x = 0, long64 y = 0): X(x), Y(y) {};
+  friend std::ostream& operator <<(std::ostream &s, IntPoint &p);
+};
+
+typedef std::vector< IntPoint > Polygon;
+typedef std::vector< Polygon > Polygons;
+
+std::ostream& operator <<(std::ostream &s, Polygon &p);
+std::ostream& operator <<(std::ostream &s, Polygons &p);
+
+struct ExPolygon {
+  Polygon  outer;
+  Polygons holes;
+};
+typedef std::vector< ExPolygon > ExPolygons;
+
+enum JoinType { jtSquare, jtMiter, jtRound };
+
+bool Orientation(const Polygon &poly);
+double Area(const Polygon &poly);
+void OffsetPolygons(const Polygons &in_polys, Polygons &out_polys,
+  double delta, JoinType jointype = jtSquare, double MiterLimit = 2);
+
+void ReversePoints(Polygon& p);
+void ReversePoints(Polygons& p);
+
+//used internally ...
+enum EdgeSide { esLeft, esRight };
+enum IntersectProtects { ipNone = 0, ipLeft = 1, ipRight = 2, ipBoth = 3 };
+
+struct TEdge {
+  long64 xbot;
+  long64 ybot;
+  long64 xcurr;
+  long64 ycurr;
+  long64 xtop;
+  long64 ytop;
+  double dx;
+  long64 tmpX;
+  PolyType polyType;
+  EdgeSide side;
+  int windDelta; //1 or -1 depending on winding direction
+  int windCnt;
+  int windCnt2; //winding count of the opposite polytype
+  int outIdx;
+  TEdge *next;
+  TEdge *prev;
+  TEdge *nextInLML;
+  TEdge *nextInAEL;
+  TEdge *prevInAEL;
+  TEdge *nextInSEL;
+  TEdge *prevInSEL;
+};
+
+struct IntersectNode {
+  TEdge          *edge1;
+  TEdge          *edge2;
+  IntPoint        pt;
+  IntersectNode  *next;
+};
+
+struct LocalMinima {
+  long64        Y;
+  TEdge        *leftBound;
+  TEdge        *rightBound;
+  LocalMinima  *next;
+};
+
+struct Scanbeam {
+  long64    Y;
+  Scanbeam *next;
+};
+
+struct OutPt; //forward declaration
+
+struct OutRec {
+  int     idx;
+  bool    isHole;
+  OutRec *FirstLeft;
+  OutRec *AppendLink;
+  OutPt  *pts;
+  OutPt  *bottomPt;
+  TEdge  *bottomE1;
+  TEdge  *bottomE2;
+};
+
+struct OutPt {
+  int     idx;
+  IntPoint pt;
+  OutPt   *next;
+  OutPt   *prev;
+};
+
+struct JoinRec {
+  IntPoint  pt1a;
+  IntPoint  pt1b;
+  int       poly1Idx;
+  IntPoint  pt2a;
+  IntPoint  pt2b;
+  int       poly2Idx;
+};
+
+struct HorzJoinRec {
+  TEdge    *edge;
+  int       savedIdx;
+};
+
+struct IntRect { long64 left; long64 top; long64 right; long64 bottom; };
+
+typedef std::vector < OutRec* > PolyOutList;
+typedef std::vector < TEdge* > EdgeList;
+typedef std::vector < JoinRec* > JoinList;
+typedef std::vector < HorzJoinRec* > HorzJoinList;
+
+//ClipperBase is the ancestor to the Clipper class. It should not be
+//instantiated directly. This class simply abstracts the conversion of sets of
+//polygon coordinates into edge objects that are stored in a LocalMinima list.
+class ClipperBase
+{
+public:
+  ClipperBase();
+  virtual ~ClipperBase();
+  bool AddPolygon(const Polygon &pg, PolyType polyType);
+  bool AddPolygons( const Polygons &ppg, PolyType polyType);
+  virtual void Clear();
+  IntRect GetBounds();
+protected:
+  void DisposeLocalMinimaList();
+  TEdge* AddBoundsToLML(TEdge *e);
+  void PopLocalMinima();
+  virtual void Reset();
+  void InsertLocalMinima(LocalMinima *newLm);
+  LocalMinima      *m_CurrentLM;
+  LocalMinima      *m_MinimaList;
+  bool              m_UseFullRange;
+  EdgeList          m_edges;
+};
+
+class Clipper : public virtual ClipperBase
+{
+public:
+  Clipper();
+  ~Clipper();
+  bool Execute(ClipType clipType,
+  Polygons &solution,
+  PolyFillType subjFillType = pftEvenOdd,
+  PolyFillType clipFillType = pftEvenOdd);
+  bool Execute(ClipType clipType,
+  ExPolygons &solution,
+  PolyFillType subjFillType = pftEvenOdd,
+  PolyFillType clipFillType = pftEvenOdd);
+  void Clear();
+  bool ReverseSolution() {return m_ReverseOutput;};
+  void ReverseSolution(bool value) {m_ReverseOutput = value;};
+protected:
+  void Reset();
+  virtual bool ExecuteInternal(bool fixHoleLinkages);
+private:
+  PolyOutList       m_PolyOuts;
+  JoinList          m_Joins;
+  HorzJoinList      m_HorizJoins;
+  ClipType          m_ClipType = ctIntersection;
+  Scanbeam         *m_Scanbeam;
+  TEdge           *m_ActiveEdges;
+  TEdge           *m_SortedEdges;
+  IntersectNode    *m_IntersectNodes;
+  bool              m_ExecuteLocked;
+  PolyFillType      m_ClipFillType = pftEvenOdd;
+  PolyFillType      m_SubjFillType = pftEvenOdd;
+  bool              m_ReverseOutput;
+  void DisposeScanbeamList();
+  void SetWindingCount(TEdge& edge);
+  bool IsEvenOddFillType(const TEdge& edge) const;
+  bool IsEvenOddAltFillType(const TEdge& edge) const;
+  void InsertScanbeam(const long64 Y);
+  long64 PopScanbeam();
+  void InsertLocalMinimaIntoAEL(const long64 botY);
+  void InsertEdgeIntoAEL(TEdge *edge);
+  void AddEdgeToSEL(TEdge *edge);
+  void CopyAELToSEL();
+  void DeleteFromSEL(TEdge *e);
+  void DeleteFromAEL(TEdge *e);
+  void UpdateEdgeIntoAEL(TEdge *&e);
+  void SwapPositionsInSEL(TEdge *edge1, TEdge *edge2);
+  bool IsContributing(const TEdge& edge) const;
+  bool IsTopHorz(const long64 XPos);
+  void SwapPositionsInAEL(TEdge *edge1, TEdge *edge2);
+  void DoMaxima(TEdge *e, long64 topY);
+  void ProcessHorizontals();
+  void ProcessHorizontal(TEdge *horzEdge);
+  void AddLocalMaxPoly(TEdge *e1, TEdge *e2, const IntPoint &pt);
+  void AddLocalMinPoly(TEdge *e1, TEdge *e2, const IntPoint &pt);
+  void AppendPolygon(TEdge *e1, TEdge *e2);
+  void DoEdge1(TEdge *edge1, TEdge *edge2, const IntPoint &pt);
+  void DoEdge2(TEdge *edge1, TEdge *edge2, const IntPoint &pt);
+  void DoBothEdges(TEdge *edge1, TEdge *edge2, const IntPoint &pt);
+  void IntersectEdges(TEdge *e1, TEdge *e2,
+    const IntPoint &pt, IntersectProtects protects);
+  OutRec* CreateOutRec();
+  void AddOutPt(TEdge *e, TEdge *altE, const IntPoint &pt);
+  void DisposeAllPolyPts();
+  void DisposeOutRec(PolyOutList::size_type index, bool ignorePts = false);
+  bool ProcessIntersections(const long64 botY, const long64 topY);
+  void AddIntersectNode(TEdge *e1, TEdge *e2, const IntPoint &pt);
+  void BuildIntersectList(const long64 botY, const long64 topY);
+  void ProcessIntersectList();
+  void ProcessEdgesAtTopOfScanbeam(const long64 topY);
+  void BuildResult(Polygons& polys);
+  void BuildResultEx(ExPolygons& polys);
+  void SetHoleState(TEdge *e, OutRec *OutRec);
+  void DisposeIntersectNodes();
+  bool FixupIntersections();
+  void FixupOutPolygon(OutRec &outRec);
+  bool IsHole(TEdge *e);
+  void FixHoleLinkage(OutRec *outRec);
+  void CheckHoleLinkages1(OutRec *outRec1, OutRec *outRec2);
+  void CheckHoleLinkages2(OutRec *outRec1, OutRec *outRec2);
+  void AddJoin(TEdge *e1, TEdge *e2, int e1OutIdx = -1, int e2OutIdx = -1);
+  void ClearJoins();
+  void AddHorzJoin(TEdge *e, int idx);
+  void ClearHorzJoins();
+  void JoinCommonEdges(bool fixHoleLinkages);
+};
+
+//------------------------------------------------------------------------------
+//------------------------------------------------------------------------------
+
+class clipperException : public std::exception
+{
+  public:
+    clipperException(const char* description): m_descr(description) {}
+    virtual ~clipperException() throw() {}
+    virtual const char* what() const throw() {return m_descr.c_str();}
+  private:
+    std::string m_descr;
+};
+//------------------------------------------------------------------------------
+
+} //ClipperLib namespace
+
+#endif //clipper_hpp
+
+
diff -pruN 8.0.1-5/src/renderers/agg/include/util/Makefile.am 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/Makefile.am
--- 8.0.1-5/src/renderers/agg/include/util/Makefile.am	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/Makefile.am	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,2 @@
+myincludedir = $(includedir)/agg2/util
+myinclude_HEADERS = agg_color_conv.h agg_color_conv_rgb8.h agg_color_conv_rgb16.h
diff -pruN 8.0.1-5/src/renderers/agg/include/util/agg_color_conv.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/agg_color_conv.h
--- 8.0.1-5/src/renderers/agg/include/util/agg_color_conv.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/agg_color_conv.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,84 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Conversion from one colorspace/pixel format to another
+//
+//----------------------------------------------------------------------------
+
+#ifndef AGG_COLOR_CONV_INCLUDED
+#define AGG_COLOR_CONV_INCLUDED
+
+#include <string.h>
+#include "agg_basics.h"
+#include "agg_rendering_buffer.h"
+
+
+
+
+namespace mapserver
+{
+
+    //--------------------------------------------------------------color_conv
+    template<class RenBuf, class CopyRow> 
+    void color_conv(RenBuf* dst, const RenBuf* src, CopyRow copy_row_functor)
+    {
+        unsigned width = src->width();
+        unsigned height = src->height();
+
+        if(dst->width()  < width)  width  = dst->width();
+        if(dst->height() < height) height = dst->height();
+
+        if(width)
+        {
+            unsigned y;
+            for(y = 0; y < height; y++)
+            {
+                copy_row_functor(dst->row_ptr(0, y, width), 
+                                 src->row_ptr(y), 
+                                 width);
+            }
+        }
+    }
+
+
+    //---------------------------------------------------------color_conv_row
+    template<class CopyRow> 
+    void color_conv_row(int8u* dst, 
+                        const int8u* src,
+                        unsigned width,
+                        CopyRow copy_row_functor)
+    {
+        copy_row_functor(dst, src, width);
+    }
+
+
+    //---------------------------------------------------------color_conv_same
+    template<int BPP> class color_conv_same
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            memmove(dst, src, width*BPP);
+        }
+    };
+
+
+}
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/util/agg_color_conv_rgb16.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/agg_color_conv_rgb16.h
--- 8.0.1-5/src/renderers/agg/include/util/agg_color_conv_rgb16.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/agg_color_conv_rgb16.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,285 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// This part of the library has been sponsored by 
+// Liberty Technology Systems, Inc., visit http://lib-sys.com
+//
+// Liberty Technology Systems, Inc. is the provider of
+// PostScript and PDF technology for software developers.
+// 
+//----------------------------------------------------------------------------
+//
+// A set of functors used with color_conv(). See file agg_color_conv.h
+// These functors can convert images with up to 8 bits per component.
+// Use convertors in the following way:
+//
+// mapserver::color_conv(dst, src, mapserver::color_conv_XXXX_to_YYYY());
+//----------------------------------------------------------------------------
+
+#ifndef AGG_COLOR_CONV_RGB16_INCLUDED
+#define AGG_COLOR_CONV_RGB16_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_conv.h"
+
+namespace mapserver
+{
+
+    //-------------------------------------------------color_conv_gray16_to_gray8
+    class color_conv_gray16_to_gray8
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            int16u* s = (int16u*)src;
+            do
+            {
+                *dst++ = *s++ >> 8;
+            }
+            while(--width);
+        }
+    };
+
+
+    //-----------------------------------------------------color_conv_rgb24_rgb48
+    template<int I1, int I3> class color_conv_rgb24_rgb48
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            int16u* d = (int16u*)dst;
+            do
+            {
+                *d++ = (src[I1] << 8) | src[I1];
+                *d++ = (src[1]  << 8) | src[1] ;
+                *d++ = (src[I3] << 8) | src[I3];
+                src += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_rgb24_rgb48<0,2> color_conv_rgb24_to_rgb48;
+    typedef color_conv_rgb24_rgb48<0,2> color_conv_bgr24_to_bgr48;
+    typedef color_conv_rgb24_rgb48<2,0> color_conv_rgb24_to_bgr48;
+    typedef color_conv_rgb24_rgb48<2,0> color_conv_bgr24_to_rgb48;
+
+
+    //-----------------------------------------------------color_conv_rgb24_rgb48
+    template<int I1, int I3> class color_conv_rgb48_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            const int16u* s = (const int16u*)src;
+            do
+            {
+                *dst++ = s[I1] >> 8;
+                *dst++ = s[1]  >> 8;
+                *dst++ = s[I3] >> 8;
+                s += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_rgb48_rgb24<0,2> color_conv_rgb48_to_rgb24;
+    typedef color_conv_rgb48_rgb24<0,2> color_conv_bgr48_to_bgr24;
+    typedef color_conv_rgb48_rgb24<2,0> color_conv_rgb48_to_bgr24;
+    typedef color_conv_rgb48_rgb24<2,0> color_conv_bgr48_to_rgb24;
+
+
+    //----------------------------------------------color_conv_rgbAAA_rgb24
+    template<int R, int B> class color_conv_rgbAAA_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                int32u rgb = *(int32u*)src;
+                dst[R] = int8u(rgb >> 22);
+                dst[1] = int8u(rgb >> 12);
+                dst[B] = int8u(rgb >> 2);
+                src += 4;
+                dst += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_rgbAAA_rgb24<0,2> color_conv_rgbAAA_to_rgb24;
+    typedef color_conv_rgbAAA_rgb24<2,0> color_conv_rgbAAA_to_bgr24;
+    typedef color_conv_rgbAAA_rgb24<2,0> color_conv_bgrAAA_to_rgb24;
+    typedef color_conv_rgbAAA_rgb24<0,2> color_conv_bgrAAA_to_bgr24;
+
+
+    //----------------------------------------------color_conv_rgbBBA_rgb24
+    template<int R, int B> class color_conv_rgbBBA_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                int32u rgb = *(int32u*)src;
+                dst[R] = int8u(rgb >> 24);
+                dst[1] = int8u(rgb >> 13);
+                dst[B] = int8u(rgb >> 2);
+                src += 4;
+                dst += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_rgbBBA_rgb24<0,2> color_conv_rgbBBA_to_rgb24;
+    typedef color_conv_rgbBBA_rgb24<2,0> color_conv_rgbBBA_to_bgr24;
+
+
+    //----------------------------------------------color_conv_bgrABB_rgb24
+    template<int B, int R> class color_conv_bgrABB_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                int32u bgr = *(int32u*)src;
+                dst[R] = int8u(bgr >> 3);
+                dst[1] = int8u(bgr >> 14);
+                dst[B] = int8u(bgr >> 24);
+                src += 4;
+                dst += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_bgrABB_rgb24<2,0> color_conv_bgrABB_to_rgb24;
+    typedef color_conv_bgrABB_rgb24<0,2> color_conv_bgrABB_to_bgr24;
+
+
+    //-------------------------------------------------color_conv_rgba64_rgba32
+    template<int I1, int I2, int I3, int I4> class color_conv_rgba64_rgba32
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *dst++ = int8u(((int16u*)src)[I1] >> 8);
+                *dst++ = int8u(((int16u*)src)[I2] >> 8);
+                *dst++ = int8u(((int16u*)src)[I3] >> 8);
+                *dst++ = int8u(((int16u*)src)[I4] >> 8); 
+                src += 8;
+            }
+            while(--width);
+        }
+    };
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_rgba64_to_rgba32; //----color_conv_rgba64_to_rgba32
+    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_argb64_to_argb32; //----color_conv_argb64_to_argb32
+    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_bgra64_to_bgra32; //----color_conv_bgra64_to_bgra32
+    typedef color_conv_rgba64_rgba32<0,1,2,3> color_conv_abgr64_to_abgr32; //----color_conv_abgr64_to_abgr32
+    typedef color_conv_rgba64_rgba32<0,3,2,1> color_conv_argb64_to_abgr32; //----color_conv_argb64_to_abgr32
+    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_argb64_to_bgra32; //----color_conv_argb64_to_bgra32
+    typedef color_conv_rgba64_rgba32<1,2,3,0> color_conv_argb64_to_rgba32; //----color_conv_argb64_to_rgba32
+    typedef color_conv_rgba64_rgba32<3,0,1,2> color_conv_bgra64_to_abgr32; //----color_conv_bgra64_to_abgr32
+    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_bgra64_to_argb32; //----color_conv_bgra64_to_argb32
+    typedef color_conv_rgba64_rgba32<2,1,0,3> color_conv_bgra64_to_rgba32; //----color_conv_bgra64_to_rgba32
+    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_rgba64_to_abgr32; //----color_conv_rgba64_to_abgr32
+    typedef color_conv_rgba64_rgba32<3,0,1,2> color_conv_rgba64_to_argb32; //----color_conv_rgba64_to_argb32
+    typedef color_conv_rgba64_rgba32<2,1,0,3> color_conv_rgba64_to_bgra32; //----color_conv_rgba64_to_bgra32
+    typedef color_conv_rgba64_rgba32<0,3,2,1> color_conv_abgr64_to_argb32; //----color_conv_abgr64_to_argb32
+    typedef color_conv_rgba64_rgba32<1,2,3,0> color_conv_abgr64_to_bgra32; //----color_conv_abgr64_to_bgra32
+    typedef color_conv_rgba64_rgba32<3,2,1,0> color_conv_abgr64_to_rgba32; //----color_conv_abgr64_to_rgba32
+
+
+
+    //--------------------------------------------color_conv_rgb24_rgba64
+    template<int I1, int I2, int I3, int A> class color_conv_rgb24_rgba64
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            int16u* d = (int16u*)dst;
+            do
+            {
+                d[I1] = (src[0] << 8) | src[0];
+                d[I2] = (src[1] << 8) | src[1];
+                d[I3] = (src[2] << 8) | src[2];
+                d[A]  = 65535; 
+                d   += 4;
+                src += 3;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb24_rgba64<1,2,3,0> color_conv_rgb24_to_argb64; //----color_conv_rgb24_to_argb64
+    typedef color_conv_rgb24_rgba64<3,2,1,0> color_conv_rgb24_to_abgr64; //----color_conv_rgb24_to_abgr64
+    typedef color_conv_rgb24_rgba64<2,1,0,3> color_conv_rgb24_to_bgra64; //----color_conv_rgb24_to_bgra64
+    typedef color_conv_rgb24_rgba64<0,1,2,3> color_conv_rgb24_to_rgba64; //----color_conv_rgb24_to_rgba64
+    typedef color_conv_rgb24_rgba64<3,2,1,0> color_conv_bgr24_to_argb64; //----color_conv_bgr24_to_argb64
+    typedef color_conv_rgb24_rgba64<1,2,3,0> color_conv_bgr24_to_abgr64; //----color_conv_bgr24_to_abgr64
+    typedef color_conv_rgb24_rgba64<0,1,2,3> color_conv_bgr24_to_bgra64; //----color_conv_bgr24_to_bgra64
+    typedef color_conv_rgb24_rgba64<2,1,0,3> color_conv_bgr24_to_rgba64; //----color_conv_bgr24_to_rgba64
+
+
+    template<int R, int B> class color_conv_rgb24_gray16
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            int16u* d = (int16u*)dst;
+            do
+            {
+                *d++ = src[R]*77 + src[1]*150 + src[B]*29;
+                src += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_rgb24_gray16<0,2> color_conv_rgb24_to_gray16;
+    typedef color_conv_rgb24_gray16<2,0> color_conv_bgr24_to_gray16;
+
+
+}
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/include/util/agg_color_conv_rgb8.h 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/agg_color_conv_rgb8.h
--- 8.0.1-5/src/renderers/agg/include/util/agg_color_conv_rgb8.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/include/util/agg_color_conv_rgb8.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,469 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// A set of functors used with color_conv(). See file agg_color_conv.h
+// These functors can convert images with up to 8 bits per component.
+// Use convertors in the following way:
+//
+// mapserver::color_conv(dst, src, mapserver::color_conv_XXXX_to_YYYY());
+// whare XXXX and YYYY can be any of:
+//  rgb24
+//  bgr24
+//  rgba32
+//  abgr32
+//  argb32
+//  bgra32
+//  rgb555
+//  rgb565
+//----------------------------------------------------------------------------
+
+#ifndef AGG_COLOR_CONV_RGB8_INCLUDED
+#define AGG_COLOR_CONV_RGB8_INCLUDED
+
+#include "agg_basics.h"
+#include "agg_color_conv.h"
+
+namespace mapserver
+{
+
+    //-----------------------------------------------------color_conv_rgb24
+    class color_conv_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *dst++ = src[2];
+                *dst++ = src[1];
+                *dst++ = src[0];
+                src += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_rgb24 color_conv_rgb24_to_bgr24;
+    typedef color_conv_rgb24 color_conv_bgr24_to_rgb24;
+
+    typedef color_conv_same<3> color_conv_bgr24_to_bgr24;
+    typedef color_conv_same<3> color_conv_rgb24_to_rgb24;
+
+
+
+    //------------------------------------------------------color_conv_rgba32
+    template<int I1, int I2, int I3, int I4> class color_conv_rgba32
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *dst++ = src[I1];
+                *dst++ = src[I2];
+                *dst++ = src[I3];
+                *dst++ = src[I4]; 
+                src += 4;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgba32<0,3,2,1> color_conv_argb32_to_abgr32; //----color_conv_argb32_to_abgr32
+    typedef color_conv_rgba32<3,2,1,0> color_conv_argb32_to_bgra32; //----color_conv_argb32_to_bgra32
+    typedef color_conv_rgba32<1,2,3,0> color_conv_argb32_to_rgba32; //----color_conv_argb32_to_rgba32
+    typedef color_conv_rgba32<3,0,1,2> color_conv_bgra32_to_abgr32; //----color_conv_bgra32_to_abgr32
+    typedef color_conv_rgba32<3,2,1,0> color_conv_bgra32_to_argb32; //----color_conv_bgra32_to_argb32
+    typedef color_conv_rgba32<2,1,0,3> color_conv_bgra32_to_rgba32; //----color_conv_bgra32_to_rgba32
+    typedef color_conv_rgba32<3,2,1,0> color_conv_rgba32_to_abgr32; //----color_conv_rgba32_to_abgr32
+    typedef color_conv_rgba32<3,0,1,2> color_conv_rgba32_to_argb32; //----color_conv_rgba32_to_argb32
+    typedef color_conv_rgba32<2,1,0,3> color_conv_rgba32_to_bgra32; //----color_conv_rgba32_to_bgra32
+    typedef color_conv_rgba32<0,3,2,1> color_conv_abgr32_to_argb32; //----color_conv_abgr32_to_argb32
+    typedef color_conv_rgba32<1,2,3,0> color_conv_abgr32_to_bgra32; //----color_conv_abgr32_to_bgra32
+    typedef color_conv_rgba32<3,2,1,0> color_conv_abgr32_to_rgba32; //----color_conv_abgr32_to_rgba32
+
+    //------------------------------------------------------------------------
+    typedef color_conv_same<4> color_conv_rgba32_to_rgba32; //----color_conv_rgba32_to_rgba32
+    typedef color_conv_same<4> color_conv_argb32_to_argb32; //----color_conv_argb32_to_argb32
+    typedef color_conv_same<4> color_conv_bgra32_to_bgra32; //----color_conv_bgra32_to_bgra32
+    typedef color_conv_same<4> color_conv_abgr32_to_abgr32; //----color_conv_abgr32_to_abgr32
+
+
+    //--------------------------------------------color_conv_rgb24_rgba32
+    template<int I1, int I2, int I3, int A> class color_conv_rgb24_rgba32
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                dst[I1] = *src++;
+                dst[I2] = *src++;
+                dst[I3] = *src++;
+                dst[A]  = 255; 
+                dst += 4;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb24_rgba32<1,2,3,0> color_conv_rgb24_to_argb32; //----color_conv_rgb24_to_argb32
+    typedef color_conv_rgb24_rgba32<3,2,1,0> color_conv_rgb24_to_abgr32; //----color_conv_rgb24_to_abgr32
+    typedef color_conv_rgb24_rgba32<2,1,0,3> color_conv_rgb24_to_bgra32; //----color_conv_rgb24_to_bgra32
+    typedef color_conv_rgb24_rgba32<0,1,2,3> color_conv_rgb24_to_rgba32; //----color_conv_rgb24_to_rgba32
+    typedef color_conv_rgb24_rgba32<3,2,1,0> color_conv_bgr24_to_argb32; //----color_conv_bgr24_to_argb32
+    typedef color_conv_rgb24_rgba32<1,2,3,0> color_conv_bgr24_to_abgr32; //----color_conv_bgr24_to_abgr32
+    typedef color_conv_rgb24_rgba32<0,1,2,3> color_conv_bgr24_to_bgra32; //----color_conv_bgr24_to_bgra32
+    typedef color_conv_rgb24_rgba32<2,1,0,3> color_conv_bgr24_to_rgba32; //----color_conv_bgr24_to_rgba32
+
+    
+
+    //-------------------------------------------------color_conv_rgba32_rgb24
+    template<int I1, int I2, int I3> class color_conv_rgba32_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *dst++ = src[I1];
+                *dst++ = src[I2];
+                *dst++ = src[I3];
+                src += 4;
+            }
+            while(--width);
+        }
+    };
+
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgba32_rgb24<1,2,3> color_conv_argb32_to_rgb24; //----color_conv_argb32_to_rgb24
+    typedef color_conv_rgba32_rgb24<3,2,1> color_conv_abgr32_to_rgb24; //----color_conv_abgr32_to_rgb24
+    typedef color_conv_rgba32_rgb24<2,1,0> color_conv_bgra32_to_rgb24; //----color_conv_bgra32_to_rgb24
+    typedef color_conv_rgba32_rgb24<0,1,2> color_conv_rgba32_to_rgb24; //----color_conv_rgba32_to_rgb24
+    typedef color_conv_rgba32_rgb24<3,2,1> color_conv_argb32_to_bgr24; //----color_conv_argb32_to_bgr24
+    typedef color_conv_rgba32_rgb24<1,2,3> color_conv_abgr32_to_bgr24; //----color_conv_abgr32_to_bgr24
+    typedef color_conv_rgba32_rgb24<0,1,2> color_conv_bgra32_to_bgr24; //----color_conv_bgra32_to_bgr24
+    typedef color_conv_rgba32_rgb24<2,1,0> color_conv_rgba32_to_bgr24; //----color_conv_rgba32_to_bgr24
+
+
+    //------------------------------------------------color_conv_rgb555_rgb24
+    template<int R, int B> class color_conv_rgb555_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                unsigned rgb = *(int16u*)src;
+                dst[R] = (int8u)((rgb >> 7) & 0xF8);
+                dst[1] = (int8u)((rgb >> 2) & 0xF8);
+                dst[B] = (int8u)((rgb << 3) & 0xF8);
+                src += 2;
+                dst += 3;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb555_rgb24<2,0> color_conv_rgb555_to_bgr24; //----color_conv_rgb555_to_bgr24
+    typedef color_conv_rgb555_rgb24<0,2> color_conv_rgb555_to_rgb24; //----color_conv_rgb555_to_rgb24
+
+
+    //-------------------------------------------------color_conv_rgb24_rgb555
+    template<int R, int B> class color_conv_rgb24_rgb555
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 7) & 0x7C00) | 
+                                         ((unsigned(src[1]) << 2) & 0x3E0)  |
+                                         ((unsigned(src[B]) >> 3)));
+                src += 3;
+                dst += 2;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb24_rgb555<2,0> color_conv_bgr24_to_rgb555; //----color_conv_bgr24_to_rgb555
+    typedef color_conv_rgb24_rgb555<0,2> color_conv_rgb24_to_rgb555; //----color_conv_rgb24_to_rgb555
+
+
+    //-------------------------------------------------color_conv_rgb565_rgb24
+    template<int R, int B> class color_conv_rgb565_rgb24
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                unsigned rgb = *(int16u*)src;
+                dst[R] = (rgb >> 8) & 0xF8;
+                dst[1] = (rgb >> 3) & 0xFC;
+                dst[B] = (rgb << 3) & 0xF8;
+                src += 2;
+                dst += 3;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb565_rgb24<2,0> color_conv_rgb565_to_bgr24; //----color_conv_rgb565_to_bgr24
+    typedef color_conv_rgb565_rgb24<0,2> color_conv_rgb565_to_rgb24; //----color_conv_rgb565_to_rgb24
+
+
+    //-------------------------------------------------color_conv_rgb24_rgb565
+    template<int R, int B> class color_conv_rgb24_rgb565
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 8) & 0xF800) | 
+                                         ((unsigned(src[1]) << 3) & 0x7E0)  |
+                                         ((unsigned(src[B]) >> 3)));
+                src += 3;
+                dst += 2;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb24_rgb565<2,0> color_conv_bgr24_to_rgb565; //----color_conv_bgr24_to_rgb565
+    typedef color_conv_rgb24_rgb565<0,2> color_conv_rgb24_to_rgb565; //----color_conv_rgb24_to_rgb565
+
+
+
+    //-------------------------------------------------color_conv_rgb555_rgba32
+    template<int R, int G, int B, int A> class color_conv_rgb555_rgba32
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                int rgb = *(int16*)src;
+                dst[R] = (int8u)((rgb >> 7) & 0xF8);
+                dst[G] = (int8u)((rgb >> 2) & 0xF8);
+                dst[B] = (int8u)((rgb << 3) & 0xF8);
+                dst[A] = (int8u)(rgb >> 15);
+                src += 2;
+                dst += 4;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb555_rgba32<1,2,3,0> color_conv_rgb555_to_argb32; //----color_conv_rgb555_to_argb32
+    typedef color_conv_rgb555_rgba32<3,2,1,0> color_conv_rgb555_to_abgr32; //----color_conv_rgb555_to_abgr32
+    typedef color_conv_rgb555_rgba32<2,1,0,3> color_conv_rgb555_to_bgra32; //----color_conv_rgb555_to_bgra32
+    typedef color_conv_rgb555_rgba32<0,1,2,3> color_conv_rgb555_to_rgba32; //----color_conv_rgb555_to_rgba32
+
+
+    //------------------------------------------------color_conv_rgba32_rgb555
+    template<int R, int G, int B, int A> class color_conv_rgba32_rgb555
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 7) & 0x7C00) | 
+                                         ((unsigned(src[G]) << 2) & 0x3E0)  |
+                                         ((unsigned(src[B]) >> 3)) |
+                                         ((unsigned(src[A]) << 8) & 0x8000));
+                src += 4;
+                dst += 2;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgba32_rgb555<1,2,3,0> color_conv_argb32_to_rgb555; //----color_conv_argb32_to_rgb555
+    typedef color_conv_rgba32_rgb555<3,2,1,0> color_conv_abgr32_to_rgb555; //----color_conv_abgr32_to_rgb555
+    typedef color_conv_rgba32_rgb555<2,1,0,3> color_conv_bgra32_to_rgb555; //----color_conv_bgra32_to_rgb555
+    typedef color_conv_rgba32_rgb555<0,1,2,3> color_conv_rgba32_to_rgb555; //----color_conv_rgba32_to_rgb555
+
+
+
+    //------------------------------------------------color_conv_rgb565_rgba32
+    template<int R, int G, int B, int A> class color_conv_rgb565_rgba32
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                int rgb = *(int16*)src;
+                dst[R] = (rgb >> 8) & 0xF8;
+                dst[G] = (rgb >> 3) & 0xFC;
+                dst[B] = (rgb << 3) & 0xF8;
+                dst[A] = 255;
+                src += 2;
+                dst += 4;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgb565_rgba32<1,2,3,0> color_conv_rgb565_to_argb32; //----color_conv_rgb565_to_argb32
+    typedef color_conv_rgb565_rgba32<3,2,1,0> color_conv_rgb565_to_abgr32; //----color_conv_rgb565_to_abgr32
+    typedef color_conv_rgb565_rgba32<2,1,0,3> color_conv_rgb565_to_bgra32; //----color_conv_rgb565_to_bgra32
+    typedef color_conv_rgb565_rgba32<0,1,2,3> color_conv_rgb565_to_rgba32; //----color_conv_rgb565_to_rgba32
+
+
+    //------------------------------------------------color_conv_rgba32_rgb565
+    template<int R, int G, int B> class color_conv_rgba32_rgb565
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *(int16u*)dst = (int16u)(((unsigned(src[R]) << 8) & 0xF800) | 
+                                         ((unsigned(src[G]) << 3) & 0x7E0)  |
+                                         ((unsigned(src[B]) >> 3)));
+                src += 4;
+                dst += 2;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_rgba32_rgb565<1,2,3> color_conv_argb32_to_rgb565; //----color_conv_argb32_to_rgb565
+    typedef color_conv_rgba32_rgb565<3,2,1> color_conv_abgr32_to_rgb565; //----color_conv_abgr32_to_rgb565
+    typedef color_conv_rgba32_rgb565<2,1,0> color_conv_bgra32_to_rgb565; //----color_conv_bgra32_to_rgb565
+    typedef color_conv_rgba32_rgb565<0,1,2> color_conv_rgba32_to_rgb565; //----color_conv_rgba32_to_rgb565
+
+
+    //---------------------------------------------color_conv_rgb555_to_rgb565
+    class color_conv_rgb555_to_rgb565
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                unsigned rgb = *(int16u*)src;
+                *(int16u*)dst = (int16u)(((rgb << 1) & 0xFFC0) | (rgb & 0x1F));
+                src += 2;
+                dst += 2;
+            }
+            while(--width);
+        }
+    };
+
+
+    //----------------------------------------------color_conv_rgb565_to_rgb555
+    class color_conv_rgb565_to_rgb555
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                unsigned rgb = *(int16u*)src;
+                *(int16u*)dst = (int16u)(((rgb >> 1) & 0x7FE0) | (rgb & 0x1F));
+                src += 2;
+                dst += 2;
+            }
+            while(--width);
+        }
+    };
+
+
+    //------------------------------------------------------------------------
+    typedef color_conv_same<2> color_conv_rgb555_to_rgb555; //----color_conv_rgb555_to_rgb555
+    typedef color_conv_same<2> color_conv_rgb565_to_rgb565; //----color_conv_rgb565_to_rgb565
+
+    
+    template<int R, int B> class color_conv_rgb24_gray8
+    {
+    public:
+        void operator () (int8u* dst, 
+                          const int8u* src,
+                          unsigned width) const
+        {
+            do
+            {
+                *dst++ = (src[R]*77 + src[1]*150 + src[B]*29) >> 8;
+                src += 3;
+            }
+            while(--width);
+        }
+    };
+
+    typedef color_conv_rgb24_gray8<0,2> color_conv_rgb24_to_gray8; //----color_conv_rgb24_to_gray8
+    typedef color_conv_rgb24_gray8<2,0> color_conv_bgr24_to_gray8; //----color_conv_bgr24_to_gray8
+
+
+}
+
+
+
+#endif
diff -pruN 8.0.1-5/src/renderers/agg/readme 8.2.0~beta1-1~exp1/src/renderers/agg/readme
--- 8.0.1-5/src/renderers/agg/readme	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/readme	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,63 @@
+The Anti-Grain Geometry Project
+A high quality rendering engine for C++
+http://antigrain.com
+
+Anti-Grain Geometry - Version 2.4
+Copyright (C) 2002-2005 Maxim Shemanarev (McSeem)
+
+Permission to copy, use, modify, sell and distribute this software
+is granted provided this copyright notice appears in all copies.
+This software is provided "as is" without express or implied
+warranty, and with no claim as to its suitability for any purpose.
+
+---------------------------------
+
+Use automake to build the library.
+
+If automake is not available you still can use the old make.
+There is a very simple Makefile that can be used. Note that
+if you use automake it will overwrite Makefile.
+
+---------------------------------
+
+If building on AmigaOS 4.0 or higher type the following for
+instructions on what targets are available.
+ make -f Makefile.AmigaOS
+
+To just build and install AGG into the standard AmigaOS SDK
+ready for use type:
+ make -f Makefile.AmigaOS install
+
+If you just want to build one demo (e.g. lion) use:
+ make -f Makefile.AmigaOS bin/lion
+
+If you have any questions about the AmigaOS port please
+contact Steven Solie (ssolie@telus.net) for help.
+
+---------------------------------
+
+To build all examples using SDL (Mac or Linux) just type:
+
+cd /examples/sdl
+make
+
+Individual examples can be built with
+
+make aa_test
+
+In the same way the native Carbon examples can be built with
+
+cd /examples/macosx_carbon
+make
+
+In both cases the static library will be built (if it was not already) 
+from the existing global Makefile in /src/.
+
+The Makefiles for both SDL and Carbon will also attempt to download the 
+required .bmp files if they are not found in the system for a given 
+example. If the files could not be fetched (wget) the user will receive 
+a message explaining where to download the samples from (sphere.bmp, 
+etc.)  Since all programs reside in the same directory there is no need 
+to duplicate the .bmp files for each program that needs to use them.
+
+---------------------------------
diff -pruN 8.0.1-5/src/renderers/agg/src/Makefile.am 8.2.0~beta1-1~exp1/src/renderers/agg/src/Makefile.am
--- 8.0.1-5/src/renderers/agg/src/Makefile.am	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/Makefile.am	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,47 @@
+SUBDIRS = ctrl . platform
+
+INCLUDES = -I$(top_srcdir)/include
+
+lib_LTLIBRARIES = libagg.la
+
+libagg_la_LDFLAGS = -no-undefined -version-info @AGG_LIB_VERSION@
+libagg_la_SOURCES =  agg_arc.cpp \
+										 agg_arrowhead.cpp \
+										 agg_bezier_arc.cpp \
+										 agg_bspline.cpp \
+										 agg_curves.cpp \
+										 agg_embedded_raster_fonts.cpp \
+										 agg_gsv_text.cpp \
+										 agg_image_filters.cpp \
+										 agg_line_aa_basics.cpp \
+										 agg_line_profile_aa.cpp \
+										 agg_rounded_rect.cpp \
+										 agg_sqrt_tables.cpp \
+										 agg_trans_affine.cpp \
+										 agg_trans_double_path.cpp \
+										 agg_trans_single_path.cpp \
+										 agg_trans_warp_magnifier.cpp \
+										 agg_vcgen_bspline.cpp \
+										 agg_vcgen_contour.cpp \
+										 agg_vcgen_dash.cpp \
+										 agg_vcgen_markers_term.cpp \
+										 agg_vcgen_smooth_poly1.cpp \
+										 agg_vcgen_stroke.cpp \
+										 agg_vpgen_clip_polygon.cpp \
+										 agg_vpgen_clip_polyline.cpp \
+										 agg_vpgen_segmentator.cpp
+
+if ENABLE_GPC
+GPCLD=$(top_builddir)/gpc/libagggpc.la 
+else
+GPCLD=
+endif
+
+if ENABLE_CTRL
+CTRLLD=$(top_builddir)/src/ctrl/libaggctrl.la 
+else
+CTRLLD=
+endif
+
+libagg_la_LIBADD = $(GPCLD) $(CTRLLD)
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_arc.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_arc.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_arc.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_arc.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,106 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Arc vertex generator
+//
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_arc.h"
+
+
+namespace mapserver
+{
+    //------------------------------------------------------------------------
+    arc::arc(double x,  double y, 
+             double rx, double ry, 
+             double a1, double a2, 
+             bool ccw) :
+        m_x(x), m_y(y), m_rx(rx), m_ry(ry), m_scale(1.0)
+    {
+        normalize(a1, a2, ccw);
+    }
+
+    //------------------------------------------------------------------------
+    void arc::init(double x,  double y, 
+                   double rx, double ry, 
+                   double a1, double a2, 
+                   bool ccw)
+    {
+        m_x   = x;  m_y  = y;
+        m_rx  = rx; m_ry = ry; 
+        normalize(a1, a2, ccw);
+    }
+    
+    //------------------------------------------------------------------------
+    void arc::approximation_scale(double s)
+    {
+        m_scale = s;
+        if(m_initialized)
+        {
+            normalize(m_start, m_end, m_ccw);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void arc::rewind(unsigned)
+    {
+        m_path_cmd = path_cmd_move_to; 
+        m_angle = m_start;
+    }
+
+    //------------------------------------------------------------------------
+    unsigned arc::vertex(double* x, double* y)
+    {
+        if(is_stop(m_path_cmd)) return path_cmd_stop;
+        if((m_angle < m_end - m_da/4) != m_ccw)
+        {
+            *x = m_x + cos(m_end) * m_rx;
+            *y = m_y + sin(m_end) * m_ry;
+            m_path_cmd = path_cmd_stop;
+            return path_cmd_line_to;
+        }
+
+        *x = m_x + cos(m_angle) * m_rx;
+        *y = m_y + sin(m_angle) * m_ry;
+
+        m_angle += m_da;
+
+        unsigned pf = m_path_cmd;
+        m_path_cmd = path_cmd_line_to;
+        return pf;
+    }
+
+    //------------------------------------------------------------------------
+    void arc::normalize(double a1, double a2, bool ccw)
+    {
+        double ra = (fabs(m_rx) + fabs(m_ry)) / 2;
+        m_da = acos(ra / (ra + 0.125 / m_scale)) * 2;
+        if(ccw)
+        {
+            while(a2 < a1) a2 += pi * 2.0;
+        }
+        else
+        {
+            while(a1 < a2) a1 += pi * 2.0;
+            m_da = -m_da;
+        }
+        m_ccw   = ccw;
+        m_start = a1;
+        m_end   = a2;
+        m_initialized = true;
+    }
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_arrowhead.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_arrowhead.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_arrowhead.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_arrowhead.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,110 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Simple arrowhead/arrowtail generator 
+//
+//----------------------------------------------------------------------------
+
+#include "../include/agg_arrowhead.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    arrowhead::arrowhead() :
+        m_head_d1(1.0),
+        m_head_d2(1.0),
+        m_head_d3(1.0),
+        m_head_d4(0.0),
+        m_tail_d1(1.0),
+        m_tail_d2(1.0),
+        m_tail_d3(1.0),
+        m_tail_d4(0.0),
+        m_head_flag(false),
+        m_tail_flag(false),
+        m_curr_id(0),
+        m_curr_coord(0)
+    {
+    }
+
+
+
+    //------------------------------------------------------------------------
+    void arrowhead::rewind(unsigned path_id)
+    {
+        m_curr_id = path_id;
+        m_curr_coord = 0;
+        if(path_id == 0)
+        {
+            if(!m_tail_flag)
+            {
+                m_cmd[0] = path_cmd_stop;
+                return;
+            }
+            m_coord[0]  =  m_tail_d1;             m_coord[1]  =  0.0;
+            m_coord[2]  =  m_tail_d1 - m_tail_d4; m_coord[3]  =  m_tail_d3;
+            m_coord[4]  = -m_tail_d2 - m_tail_d4; m_coord[5]  =  m_tail_d3;
+            m_coord[6]  = -m_tail_d2;             m_coord[7]  =  0.0;
+            m_coord[8]  = -m_tail_d2 - m_tail_d4; m_coord[9]  = -m_tail_d3;
+            m_coord[10] =  m_tail_d1 - m_tail_d4; m_coord[11] = -m_tail_d3;
+
+            m_cmd[0] = path_cmd_move_to;
+            m_cmd[1] = path_cmd_line_to;
+            m_cmd[2] = path_cmd_line_to;
+            m_cmd[3] = path_cmd_line_to;
+            m_cmd[4] = path_cmd_line_to;
+            m_cmd[5] = path_cmd_line_to;
+            m_cmd[7] = path_cmd_end_poly | path_flags_close | path_flags_ccw;
+            m_cmd[6] = path_cmd_stop;
+            return;
+        }
+
+        if(path_id == 1)
+        {
+            if(!m_head_flag)
+            {
+                m_cmd[0] = path_cmd_stop;
+                return;
+            }
+            m_coord[0]  = -m_head_d1;            m_coord[1]  = 0.0;
+            m_coord[2]  = m_head_d2 + m_head_d4; m_coord[3]  = -m_head_d3;
+            m_coord[4]  = m_head_d2;             m_coord[5]  = 0.0;
+            m_coord[6]  = m_head_d2 + m_head_d4; m_coord[7]  = m_head_d3;
+
+            m_cmd[0] = path_cmd_move_to;
+            m_cmd[1] = path_cmd_line_to;
+            m_cmd[2] = path_cmd_line_to;
+            m_cmd[3] = path_cmd_line_to;
+            m_cmd[4] = path_cmd_end_poly | path_flags_close | path_flags_ccw;
+            m_cmd[5] = path_cmd_stop;
+            return;
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    unsigned arrowhead::vertex(double* x, double* y)
+    {
+        if(m_curr_id < 2)
+        {
+            unsigned curr_idx = m_curr_coord * 2;
+            *x = m_coord[curr_idx];
+            *y = m_coord[curr_idx + 1];
+            return m_cmd[m_curr_coord++];
+        }
+        return path_cmd_stop;
+    }
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_bezier_arc.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_bezier_arc.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_bezier_arc.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_bezier_arc.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,258 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Arc generator. Produces at most 4 consecutive cubic bezier curves, i.e., 
+// 4, 7, 10, or 13 vertices.
+//
+//----------------------------------------------------------------------------
+
+
+#include <math.h>
+#include "../include/agg_bezier_arc.h"
+
+
+namespace mapserver
+{
+
+    // This epsilon is used to prevent us from adding degenerate curves 
+    // (converging to a single point).
+    // The value isn't very critical. Function arc_to_bezier() has a limit 
+    // of the sweep_angle. If fabs(sweep_angle) exceeds pi/2 the curve 
+    // becomes inaccurate. But slight exceeding is quite appropriate.
+    //-------------------------------------------------bezier_arc_angle_epsilon
+    const double bezier_arc_angle_epsilon = 0.01;
+
+    //------------------------------------------------------------arc_to_bezier
+    void arc_to_bezier(double cx, double cy, double rx, double ry, 
+                       double start_angle, double sweep_angle,
+                       double* curve)
+    {
+        double x0 = cos(sweep_angle / 2.0);
+        double y0 = sin(sweep_angle / 2.0);
+        double tx = (1.0 - x0) * 4.0 / 3.0;
+        double ty = y0 - tx * x0 / y0;
+        double px[4];
+        double py[4];
+        px[0] =  x0;
+        py[0] = -y0;
+        px[1] =  x0 + tx;
+        py[1] = -ty;
+        px[2] =  x0 + tx;
+        py[2] =  ty;
+        px[3] =  x0;
+        py[3] =  y0;
+
+        double sn = sin(start_angle + sweep_angle / 2.0);
+        double cs = cos(start_angle + sweep_angle / 2.0);
+
+        unsigned i;
+        for(i = 0; i < 4; i++)
+        {
+            curve[i * 2]     = cx + rx * (px[i] * cs - py[i] * sn);
+            curve[i * 2 + 1] = cy + ry * (px[i] * sn + py[i] * cs);
+        }
+    }
+
+
+
+    //------------------------------------------------------------------------
+    void bezier_arc::init(double x,  double y, 
+                          double rx, double ry, 
+                          double start_angle, 
+                          double sweep_angle)
+    {
+        start_angle = fmod(start_angle, 2.0 * pi);
+        if(sweep_angle >=  2.0 * pi) sweep_angle =  2.0 * pi;
+        if(sweep_angle <= -2.0 * pi) sweep_angle = -2.0 * pi;
+
+        if(fabs(sweep_angle) < 1e-10)
+        {
+            m_num_vertices = 4;
+            m_cmd = path_cmd_line_to;
+            m_vertices[0] = x + rx * cos(start_angle);
+            m_vertices[1] = y + ry * sin(start_angle);
+            m_vertices[2] = x + rx * cos(start_angle + sweep_angle);
+            m_vertices[3] = y + ry * sin(start_angle + sweep_angle);
+            return;
+        }
+
+        double total_sweep = 0.0;
+        double local_sweep = 0.0;
+        double prev_sweep;
+        m_num_vertices = 2;
+        m_cmd = path_cmd_curve4;
+        bool done = false;
+        do
+        {
+            if(sweep_angle < 0.0)
+            {
+                prev_sweep  = total_sweep;
+                local_sweep = -pi * 0.5;
+                total_sweep -= pi * 0.5;
+                if(total_sweep <= sweep_angle + bezier_arc_angle_epsilon)
+                {
+                    local_sweep = sweep_angle - prev_sweep;
+                    done = true;
+                }
+            }
+            else
+            {
+                prev_sweep  = total_sweep;
+                local_sweep =  pi * 0.5;
+                total_sweep += pi * 0.5;
+                if(total_sweep >= sweep_angle - bezier_arc_angle_epsilon)
+                {
+                    local_sweep = sweep_angle - prev_sweep;
+                    done = true;
+                }
+            }
+
+            arc_to_bezier(x, y, rx, ry, 
+                          start_angle, 
+                          local_sweep, 
+                          m_vertices + m_num_vertices - 2);
+
+            m_num_vertices += 6;
+            start_angle += local_sweep;
+        }
+        while(!done && m_num_vertices < 26);
+    }
+
+
+
+
+    //--------------------------------------------------------------------
+    void bezier_arc_svg::init(double x0, double y0, 
+                              double rx, double ry, 
+                              double angle,
+                              bool large_arc_flag,
+                              bool sweep_flag,
+                              double x2, double y2)
+    {
+        m_radii_ok = true;
+
+        if(rx < 0.0) rx = -rx;
+        if(ry < 0.0) ry = -rx;
+
+        // Calculate the middle point between 
+        // the current and the final points
+        //------------------------
+        double dx2 = (x0 - x2) / 2.0;
+        double dy2 = (y0 - y2) / 2.0;
+
+        double cos_a = cos(angle);
+        double sin_a = sin(angle);
+
+        // Calculate (x1, y1)
+        //------------------------
+        double x1 =  cos_a * dx2 + sin_a * dy2;
+        double y1 = -sin_a * dx2 + cos_a * dy2;
+
+        // Ensure radii are large enough
+        //------------------------
+        double prx = rx * rx;
+        double pry = ry * ry;
+        double px1 = x1 * x1;
+        double py1 = y1 * y1;
+
+        // Check that radii are large enough
+        //------------------------
+        double radii_check = px1/prx + py1/pry;
+        if(radii_check > 1.0) 
+        {
+            rx = sqrt(radii_check) * rx;
+            ry = sqrt(radii_check) * ry;
+            prx = rx * rx;
+            pry = ry * ry;
+            if(radii_check > 10.0) m_radii_ok = false;
+        }
+
+        // Calculate (cx1, cy1)
+        //------------------------
+        double sign = (large_arc_flag == sweep_flag) ? -1.0 : 1.0;
+        double sq   = (prx*pry - prx*py1 - pry*px1) / (prx*py1 + pry*px1);
+        double coef = sign * sqrt((sq < 0) ? 0 : sq);
+        double cx1  = coef *  ((rx * y1) / ry);
+        double cy1  = coef * -((ry * x1) / rx);
+
+        //
+        // Calculate (cx, cy) from (cx1, cy1)
+        //------------------------
+        double sx2 = (x0 + x2) / 2.0;
+        double sy2 = (y0 + y2) / 2.0;
+        double cx = sx2 + (cos_a * cx1 - sin_a * cy1);
+        double cy = sy2 + (sin_a * cx1 + cos_a * cy1);
+
+        // Calculate the start_angle (angle1) and the sweep_angle (dangle)
+        //------------------------
+        double ux =  (x1 - cx1) / rx;
+        double uy =  (y1 - cy1) / ry;
+        double vx = (-x1 - cx1) / rx;
+        double vy = (-y1 - cy1) / ry;
+        double p, n;
+
+        // Calculate the angle start
+        //------------------------
+        n = sqrt(ux*ux + uy*uy);
+        p = ux; // (1 * ux) + (0 * uy)
+        sign = (uy < 0) ? -1.0 : 1.0;
+        double v = p / n;
+        if(v < -1.0) v = -1.0;
+        if(v >  1.0) v =  1.0;
+        double start_angle = sign * acos(v);
+
+        // Calculate the sweep angle
+        //------------------------
+        n = sqrt((ux*ux + uy*uy) * (vx*vx + vy*vy));
+        p = ux * vx + uy * vy;
+        sign = (ux * vy - uy * vx < 0) ? -1.0 : 1.0;
+        v = p / n;
+        if(v < -1.0) v = -1.0;
+        if(v >  1.0) v =  1.0;
+        double sweep_angle = sign * acos(v);
+        if(!sweep_flag && sweep_angle > 0) 
+        {
+            sweep_angle -= pi * 2.0;
+        } 
+        else 
+        if (sweep_flag && sweep_angle < 0) 
+        {
+            sweep_angle += pi * 2.0;
+        }
+
+        // We can now build and transform the resulting arc
+        //------------------------
+        m_arc.init(0.0, 0.0, rx, ry, start_angle, sweep_angle);
+        trans_affine mtx = trans_affine_rotation(angle);
+        mtx *= trans_affine_translation(cx, cy);
+        
+        for(unsigned i = 2; i < m_arc.num_vertices()-2; i += 2)
+        {
+            mtx.transform(m_arc.vertices() + i, m_arc.vertices() + i + 1);
+        }
+
+        // We must make sure that the starting and ending points
+        // exactly coincide with the initial (x0,y0) and (x2,y2)
+        m_arc.vertices()[0] = x0;
+        m_arc.vertices()[1] = y0;
+        if(m_arc.num_vertices() > 2)
+        {
+            m_arc.vertices()[m_arc.num_vertices() - 2] = x2;
+            m_arc.vertices()[m_arc.num_vertices() - 1] = y2;
+        }
+    }
+
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_bspline.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_bspline.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_bspline.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_bspline.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,284 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// class bspline
+//
+//----------------------------------------------------------------------------
+
+#include "../include/agg_bspline.h"
+
+namespace mapserver
+{
+    //------------------------------------------------------------------------
+    bspline::bspline() :
+        m_max(0),
+        m_num(0),
+        m_x(0),
+        m_y(0),
+        m_last_idx(-1)
+    {
+    }
+
+    //------------------------------------------------------------------------
+    bspline::bspline(int num) :
+        m_max(0),
+        m_num(0),
+        m_x(0),
+        m_y(0),
+        m_last_idx(-1)
+    {
+        init(num);
+    }
+
+    //------------------------------------------------------------------------
+    bspline::bspline(int num, const double* x, const double* y) :
+        m_max(0),
+        m_num(0),
+        m_x(0),
+        m_y(0),
+        m_last_idx(-1)
+    {
+        init(num, x, y);
+    }
+
+    
+    //------------------------------------------------------------------------
+    void bspline::init(int max)
+    {
+        if(max > 2 && max > m_max)
+        {
+            m_am.resize(max * 3);
+            m_max = max;
+            m_x   = &m_am[m_max];
+            m_y   = &m_am[m_max * 2];
+        }
+        m_num = 0;
+        m_last_idx = -1;
+    }
+
+
+    //------------------------------------------------------------------------
+    void bspline::add_point(double x, double y)
+    {
+        if(m_num < m_max)
+        {
+            m_x[m_num] = x;
+            m_y[m_num] = y;
+            ++m_num;
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void bspline::prepare()
+    {
+        if(m_num > 2)
+        {
+            int i, k, n1;
+            double* temp; 
+            double* r; 
+            double* s;
+            double h, p, d, f, e;
+    
+            for(k = 0; k < m_num; k++) 
+            {
+                m_am[k] = 0.0;
+            }
+
+            n1 = 3 * m_num;
+
+            pod_array<double> al(n1);
+            temp = &al[0];
+
+            for(k = 0; k < n1; k++) 
+            {
+                temp[k] = 0.0;
+            }
+
+            r = temp + m_num;
+            s = temp + m_num * 2;
+
+            n1 = m_num - 1;
+            d = m_x[1] - m_x[0];
+            e = (m_y[1] - m_y[0]) / d;
+
+            for(k = 1; k < n1; k++) 
+            {
+                h     = d;
+                d     = m_x[k + 1] - m_x[k];
+                f     = e;
+                e     = (m_y[k + 1] - m_y[k]) / d;
+                al[k] = d / (d + h);
+                r[k]  = 1.0 - al[k];
+                s[k]  = 6.0 * (e - f) / (h + d);
+            }
+
+            for(k = 1; k < n1; k++) 
+            {
+                p = 1.0 / (r[k] * al[k - 1] + 2.0);
+                al[k] *= -p;
+                s[k] = (s[k] - r[k] * s[k - 1]) * p; 
+            }
+
+            m_am[n1]     = 0.0;
+            al[n1 - 1]   = s[n1 - 1];
+            m_am[n1 - 1] = al[n1 - 1];
+
+            for(k = n1 - 2, i = 0; i < m_num - 2; i++, k--) 
+            {
+                al[k]   = al[k] * al[k + 1] + s[k];
+                m_am[k] = al[k];
+            }
+        }
+        m_last_idx = -1;
+    }
+
+
+
+    //------------------------------------------------------------------------
+    void bspline::init(int num, const double* x, const double* y)
+    {
+        if(num > 2)
+        {
+            init(num);
+            int i;
+            for(i = 0; i < num; i++)
+            {
+                add_point(*x++, *y++);
+            }
+            prepare();
+        }
+        m_last_idx = -1;
+    }
+
+
+    //------------------------------------------------------------------------
+    void bspline::bsearch(int n, const double *x, double x0, int *i) 
+    {
+        int j = n - 1;
+        int k;
+          
+        for(*i = 0; (j - *i) > 1; ) 
+        {
+            if(x0 < x[k = (*i + j) >> 1]) j = k; 
+            else                         *i = k;
+        }
+    }
+
+
+
+    //------------------------------------------------------------------------
+    double bspline::interpolation(double x, int i) const
+    {
+        int j = i + 1;
+        double d = m_x[i] - m_x[j];
+        double h = x - m_x[j];
+        double r = m_x[i] - x;
+        double p = d * d / 6.0;
+        return (m_am[j] * r * r * r + m_am[i] * h * h * h) / 6.0 / d +
+               ((m_y[j] - m_am[j] * p) * r + (m_y[i] - m_am[i] * p) * h) / d;
+    }
+
+
+    //------------------------------------------------------------------------
+    double bspline::extrapolation_left(double x) const
+    {
+        double d = m_x[1] - m_x[0];
+        return (-d * m_am[1] / 6 + (m_y[1] - m_y[0]) / d) * 
+               (x - m_x[0]) + 
+               m_y[0];
+    }
+
+    //------------------------------------------------------------------------
+    double bspline::extrapolation_right(double x) const
+    {
+        double d = m_x[m_num - 1] - m_x[m_num - 2];
+        return (d * m_am[m_num - 2] / 6 + (m_y[m_num - 1] - m_y[m_num - 2]) / d) * 
+               (x - m_x[m_num - 1]) + 
+               m_y[m_num - 1];
+    }
+
+    //------------------------------------------------------------------------
+    double bspline::get(double x) const
+    {
+        if(m_num > 2)
+        {
+            int i;
+
+            // Extrapolation on the left
+            if(x < m_x[0]) return extrapolation_left(x);
+
+            // Extrapolation on the right
+            if(x >= m_x[m_num - 1]) return extrapolation_right(x);
+
+            // Interpolation
+            bsearch(m_num, m_x, x, &i);
+            return interpolation(x, i);
+        }
+        return 0.0;
+    }
+
+
+    //------------------------------------------------------------------------
+    double bspline::get_stateful(double x) const
+    {
+        if(m_num > 2)
+        {
+            // Extrapolation on the left
+            if(x < m_x[0]) return extrapolation_left(x);
+
+            // Extrapolation on the right
+            if(x >= m_x[m_num - 1]) return extrapolation_right(x);
+
+            if(m_last_idx >= 0)
+            {
+                // Check if x is not in current range
+                if(x < m_x[m_last_idx] || x > m_x[m_last_idx + 1])
+                {
+                    // Check if x between next points (most probably)
+                    if(m_last_idx < m_num - 2 && 
+                       x >= m_x[m_last_idx + 1] &&
+                       x <= m_x[m_last_idx + 2])
+                    {
+                        ++m_last_idx;
+                    }
+                    else
+                    if(m_last_idx > 0 && 
+                       x >= m_x[m_last_idx - 1] && 
+                       x <= m_x[m_last_idx])
+                    {
+                        // x is between pevious points
+                        --m_last_idx;
+                    }
+                    else
+                    {
+                        // Else perform full search
+                        bsearch(m_num, m_x, x, &m_last_idx);
+                    }
+                }
+                return interpolation(x, m_last_idx);
+            }
+            else
+            {
+                // Interpolation
+                bsearch(m_num, m_x, x, &m_last_idx);
+                return interpolation(x, m_last_idx);
+            }
+        }
+        return 0.0;
+    }
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_curves.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_curves.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_curves.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_curves.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,611 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_curves.h"
+#include "../include/agg_math.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    const double curve_collinearity_epsilon              = 1e-30;
+    const double curve_angle_tolerance_epsilon           = 0.01;
+    enum curve_recursion_limit_e { curve_recursion_limit = 32 };
+
+
+
+    //------------------------------------------------------------------------
+    void curve3_inc::approximation_scale(double s) 
+    { 
+        m_scale = s;
+    }
+
+    //------------------------------------------------------------------------
+    double curve3_inc::approximation_scale() const 
+    { 
+        return m_scale;
+    }
+
+    //------------------------------------------------------------------------
+    void curve3_inc::init(double x1, double y1, 
+                          double x2, double y2, 
+                          double x3, double y3)
+    {
+        m_start_x = x1;
+        m_start_y = y1;
+        m_end_x   = x3;
+        m_end_y   = y3;
+
+        double dx1 = x2 - x1;
+        double dy1 = y2 - y1;
+        double dx2 = x3 - x2;
+        double dy2 = y3 - y2;
+
+        double len = sqrt(dx1 * dx1 + dy1 * dy1) + sqrt(dx2 * dx2 + dy2 * dy2); 
+
+        m_num_steps = uround(len * 0.25 * m_scale);
+
+        if(m_num_steps < 4)
+        {
+            m_num_steps = 4;   
+        }
+
+        double subdivide_step  = 1.0 / m_num_steps;
+        double subdivide_step2 = subdivide_step * subdivide_step;
+
+        double tmpx = (x1 - x2 * 2.0 + x3) * subdivide_step2;
+        double tmpy = (y1 - y2 * 2.0 + y3) * subdivide_step2;
+
+        m_saved_fx = m_fx = x1;
+        m_saved_fy = m_fy = y1;
+        
+        m_saved_dfx = m_dfx = tmpx + (x2 - x1) * (2.0 * subdivide_step);
+        m_saved_dfy = m_dfy = tmpy + (y2 - y1) * (2.0 * subdivide_step);
+
+        m_ddfx = tmpx * 2.0;
+        m_ddfy = tmpy * 2.0;
+
+        m_step = m_num_steps;
+    }
+
+    //------------------------------------------------------------------------
+    void curve3_inc::rewind(unsigned)
+    {
+        if(m_num_steps == 0)
+        {
+            m_step = -1;
+            return;
+        }
+        m_step = m_num_steps;
+        m_fx   = m_saved_fx;
+        m_fy   = m_saved_fy;
+        m_dfx  = m_saved_dfx;
+        m_dfy  = m_saved_dfy;
+    }
+
+    //------------------------------------------------------------------------
+    unsigned curve3_inc::vertex(double* x, double* y)
+    {
+        if(m_step < 0) return path_cmd_stop;
+        if(m_step == m_num_steps)
+        {
+            *x = m_start_x;
+            *y = m_start_y;
+            --m_step;
+            return path_cmd_move_to;
+        }
+        if(m_step == 0)
+        {
+            *x = m_end_x;
+            *y = m_end_y;
+            --m_step;
+            return path_cmd_line_to;
+        }
+        m_fx  += m_dfx; 
+        m_fy  += m_dfy;
+        m_dfx += m_ddfx; 
+        m_dfy += m_ddfy; 
+        *x = m_fx;
+        *y = m_fy;
+        --m_step;
+        return path_cmd_line_to;
+    }
+
+    //------------------------------------------------------------------------
+    void curve3_div::init(double x1, double y1, 
+                          double x2, double y2, 
+                          double x3, double y3)
+    {
+        m_points.remove_all();
+        m_distance_tolerance_square = 0.5 / m_approximation_scale;
+        m_distance_tolerance_square *= m_distance_tolerance_square;
+        bezier(x1, y1, x2, y2, x3, y3);
+        m_count = 0;
+    }
+
+    //------------------------------------------------------------------------
+    void curve3_div::recursive_bezier(double x1, double y1, 
+                                      double x2, double y2, 
+                                      double x3, double y3,
+                                      unsigned level)
+    {
+        if(level > curve_recursion_limit) 
+        {
+            return;
+        }
+
+        // Calculate all the mid-points of the line segments
+        //----------------------
+        double x12   = (x1 + x2) / 2;                
+        double y12   = (y1 + y2) / 2;
+        double x23   = (x2 + x3) / 2;
+        double y23   = (y2 + y3) / 2;
+        double x123  = (x12 + x23) / 2;
+        double y123  = (y12 + y23) / 2;
+
+        double dx = x3-x1;
+        double dy = y3-y1;
+        double d = fabs(((x2 - x3) * dy - (y2 - y3) * dx));
+        double da;
+
+        if(d > curve_collinearity_epsilon)
+        { 
+            // Regular case
+            //-----------------
+            if(d * d <= m_distance_tolerance_square * (dx*dx + dy*dy))
+            {
+                // If the curvature doesn't exceed the distance_tolerance value
+                // we tend to finish subdivisions.
+                //----------------------
+                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
+                {
+                    m_points.add(point_d(x123, y123));
+                    return;
+                }
+
+                // Angle & Cusp Condition
+                //----------------------
+                da = fabs(atan2(y3 - y2, x3 - x2) - atan2(y2 - y1, x2 - x1));
+                if(da >= pi) da = 2*pi - da;
+
+                if(da < m_angle_tolerance)
+                {
+                    // Finally we can stop the recursion
+                    //----------------------
+                    m_points.add(point_d(x123, y123));
+                    return;                 
+                }
+            }
+        }
+        else
+        {
+            // Collinear case
+            //------------------
+            da = dx*dx + dy*dy;
+            if(da == 0)
+            {
+                d = calc_sq_distance(x1, y1, x2, y2);
+            }
+            else
+            {
+                d = ((x2 - x1)*dx + (y2 - y1)*dy) / da;
+                if(d > 0 && d < 1)
+                {
+                    // Simple collinear case, 1---2---3
+                    // We can leave just two endpoints
+                    return;
+                }
+                     if(d <= 0) d = calc_sq_distance(x2, y2, x1, y1);
+                else if(d >= 1) d = calc_sq_distance(x2, y2, x3, y3);
+                else            d = calc_sq_distance(x2, y2, x1 + d*dx, y1 + d*dy);
+            }
+            if(d < m_distance_tolerance_square)
+            {
+                m_points.add(point_d(x2, y2));
+                return;
+            }
+        }
+
+        // Continue subdivision
+        //----------------------
+        recursive_bezier(x1, y1, x12, y12, x123, y123, level + 1); 
+        recursive_bezier(x123, y123, x23, y23, x3, y3, level + 1); 
+    }
+
+    //------------------------------------------------------------------------
+    void curve3_div::bezier(double x1, double y1, 
+                            double x2, double y2, 
+                            double x3, double y3)
+    {
+        m_points.add(point_d(x1, y1));
+        recursive_bezier(x1, y1, x2, y2, x3, y3, 0);
+        m_points.add(point_d(x3, y3));
+    }
+
+
+
+
+
+    //------------------------------------------------------------------------
+    void curve4_inc::approximation_scale(double s) 
+    { 
+        m_scale = s;
+    }
+
+    //------------------------------------------------------------------------
+    double curve4_inc::approximation_scale() const 
+    { 
+        return m_scale;
+    }
+
+#if defined(_MSC_VER) && _MSC_VER <= 1200
+    //------------------------------------------------------------------------
+    static double MSC60_fix_ICE(double v) { return v; }
+#endif
+    //------------------------------------------------------------------------
+    void curve4_inc::init(double x1, double y1, 
+                          double x2, double y2, 
+                          double x3, double y3,
+                          double x4, double y4)
+    {
+        m_start_x = x1;
+        m_start_y = y1;
+        m_end_x   = x4;
+        m_end_y   = y4;
+
+        double dx1 = x2 - x1;
+        double dy1 = y2 - y1;
+        double dx2 = x3 - x2;
+        double dy2 = y3 - y2;
+        double dx3 = x4 - x3;
+        double dy3 = y4 - y3;
+
+        double len = (sqrt(dx1 * dx1 + dy1 * dy1) + 
+                      sqrt(dx2 * dx2 + dy2 * dy2) + 
+                      sqrt(dx3 * dx3 + dy3 * dy3)) * 0.25 * m_scale;
+
+#if defined(_MSC_VER) && _MSC_VER <= 1200
+        m_num_steps = uround(MSC60_fix_ICE(len));
+#else
+        m_num_steps = uround(len);
+#endif
+
+        if(m_num_steps < 4)
+        {
+            m_num_steps = 4;   
+        }
+
+        double subdivide_step  = 1.0 / m_num_steps;
+        double subdivide_step2 = subdivide_step * subdivide_step;
+        double subdivide_step3 = subdivide_step * subdivide_step * subdivide_step;
+
+        double pre1 = 3.0 * subdivide_step;
+        double pre2 = 3.0 * subdivide_step2;
+        double pre4 = 6.0 * subdivide_step2;
+        double pre5 = 6.0 * subdivide_step3;
+	
+        double tmp1x = x1 - x2 * 2.0 + x3;
+        double tmp1y = y1 - y2 * 2.0 + y3;
+
+        double tmp2x = (x2 - x3) * 3.0 - x1 + x4;
+        double tmp2y = (y2 - y3) * 3.0 - y1 + y4;
+
+        m_saved_fx = m_fx = x1;
+        m_saved_fy = m_fy = y1;
+
+        m_saved_dfx = m_dfx = (x2 - x1) * pre1 + tmp1x * pre2 + tmp2x * subdivide_step3;
+        m_saved_dfy = m_dfy = (y2 - y1) * pre1 + tmp1y * pre2 + tmp2y * subdivide_step3;
+
+        m_saved_ddfx = m_ddfx = tmp1x * pre4 + tmp2x * pre5;
+        m_saved_ddfy = m_ddfy = tmp1y * pre4 + tmp2y * pre5;
+
+        m_dddfx = tmp2x * pre5;
+        m_dddfy = tmp2y * pre5;
+
+        m_step = m_num_steps;
+    }
+
+    //------------------------------------------------------------------------
+    void curve4_inc::rewind(unsigned)
+    {
+        if(m_num_steps == 0)
+        {
+            m_step = -1;
+            return;
+        }
+        m_step = m_num_steps;
+        m_fx   = m_saved_fx;
+        m_fy   = m_saved_fy;
+        m_dfx  = m_saved_dfx;
+        m_dfy  = m_saved_dfy;
+        m_ddfx = m_saved_ddfx;
+        m_ddfy = m_saved_ddfy;
+    }
+
+    //------------------------------------------------------------------------
+    unsigned curve4_inc::vertex(double* x, double* y)
+    {
+        if(m_step < 0) return path_cmd_stop;
+        if(m_step == m_num_steps)
+        {
+            *x = m_start_x;
+            *y = m_start_y;
+            --m_step;
+            return path_cmd_move_to;
+        }
+
+        if(m_step == 0)
+        {
+            *x = m_end_x;
+            *y = m_end_y;
+            --m_step;
+            return path_cmd_line_to;
+        }
+
+        m_fx   += m_dfx;
+        m_fy   += m_dfy;
+        m_dfx  += m_ddfx; 
+        m_dfy  += m_ddfy; 
+        m_ddfx += m_dddfx; 
+        m_ddfy += m_dddfy; 
+
+        *x = m_fx;
+        *y = m_fy;
+        --m_step;
+        return path_cmd_line_to;
+    }
+
+
+
+
+    //------------------------------------------------------------------------
+    void curve4_div::init(double x1, double y1, 
+                          double x2, double y2, 
+                          double x3, double y3,
+                          double x4, double y4)
+    {
+        m_points.remove_all();
+        m_distance_tolerance_square = 0.5 / m_approximation_scale;
+        m_distance_tolerance_square *= m_distance_tolerance_square;
+        bezier(x1, y1, x2, y2, x3, y3, x4, y4);
+        m_count = 0;
+    }
+
+    //------------------------------------------------------------------------
+    void curve4_div::recursive_bezier(double x1, double y1, 
+                                      double x2, double y2, 
+                                      double x3, double y3, 
+                                      double x4, double y4,
+                                      unsigned level)
+    {
+        if(level > curve_recursion_limit) 
+        {
+            return;
+        }
+
+        // Calculate all the mid-points of the line segments
+        //----------------------
+        double x12   = (x1 + x2) / 2;
+        double y12   = (y1 + y2) / 2;
+        double x23   = (x2 + x3) / 2;
+        double y23   = (y2 + y3) / 2;
+        double x34   = (x3 + x4) / 2;
+        double y34   = (y3 + y4) / 2;
+        double x123  = (x12 + x23) / 2;
+        double y123  = (y12 + y23) / 2;
+        double x234  = (x23 + x34) / 2;
+        double y234  = (y23 + y34) / 2;
+        double x1234 = (x123 + x234) / 2;
+        double y1234 = (y123 + y234) / 2;
+
+
+        // Try to approximate the full cubic curve by a single straight line
+        //------------------
+        double dx = x4-x1;
+        double dy = y4-y1;
+
+        double d2 = fabs(((x2 - x4) * dy - (y2 - y4) * dx));
+        double d3 = fabs(((x3 - x4) * dy - (y3 - y4) * dx));
+        double da1, da2, k;
+
+        switch((int(d2 > curve_collinearity_epsilon) << 1) +
+                int(d3 > curve_collinearity_epsilon))
+        {
+        case 0:
+            // All collinear OR p1==p4
+            //----------------------
+            k = dx*dx + dy*dy;
+            if(k == 0)
+            {
+                d2 = calc_sq_distance(x1, y1, x2, y2);
+                d3 = calc_sq_distance(x4, y4, x3, y3);
+            }
+            else
+            {
+                k   = 1 / k;
+                da1 = x2 - x1;
+                da2 = y2 - y1;
+                d2  = k * (da1*dx + da2*dy);
+                da1 = x3 - x1;
+                da2 = y3 - y1;
+                d3  = k * (da1*dx + da2*dy);
+                if(d2 > 0 && d2 < 1 && d3 > 0 && d3 < 1)
+                {
+                    // Simple collinear case, 1---2---3---4
+                    // We can leave just two endpoints
+                    return;
+                }
+                     if(d2 <= 0) d2 = calc_sq_distance(x2, y2, x1, y1);
+                else if(d2 >= 1) d2 = calc_sq_distance(x2, y2, x4, y4);
+                else             d2 = calc_sq_distance(x2, y2, x1 + d2*dx, y1 + d2*dy);
+
+                     if(d3 <= 0) d3 = calc_sq_distance(x3, y3, x1, y1);
+                else if(d3 >= 1) d3 = calc_sq_distance(x3, y3, x4, y4);
+                else             d3 = calc_sq_distance(x3, y3, x1 + d3*dx, y1 + d3*dy);
+            }
+            if(d2 > d3)
+            {
+                if(d2 < m_distance_tolerance_square)
+                {
+                    m_points.add(point_d(x2, y2));
+                    return;
+                }
+            }
+            else
+            {
+                if(d3 < m_distance_tolerance_square)
+                {
+                    m_points.add(point_d(x3, y3));
+                    return;
+                }
+            }
+            break;
+
+        case 1:
+            // p1,p2,p4 are collinear, p3 is significant
+            //----------------------
+            if(d3 * d3 <= m_distance_tolerance_square * (dx*dx + dy*dy))
+            {
+                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
+                {
+                    m_points.add(point_d(x23, y23));
+                    return;
+                }
+
+                // Angle Condition
+                //----------------------
+                da1 = fabs(atan2(y4 - y3, x4 - x3) - atan2(y3 - y2, x3 - x2));
+                if(da1 >= pi) da1 = 2*pi - da1;
+
+                if(da1 < m_angle_tolerance)
+                {
+                    m_points.add(point_d(x2, y2));
+                    m_points.add(point_d(x3, y3));
+                    return;
+                }
+
+                if(m_cusp_limit != 0.0)
+                {
+                    if(da1 > m_cusp_limit)
+                    {
+                        m_points.add(point_d(x3, y3));
+                        return;
+                    }
+                }
+            }
+            break;
+
+        case 2:
+            // p1,p3,p4 are collinear, p2 is significant
+            //----------------------
+            if(d2 * d2 <= m_distance_tolerance_square * (dx*dx + dy*dy))
+            {
+                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
+                {
+                    m_points.add(point_d(x23, y23));
+                    return;
+                }
+
+                // Angle Condition
+                //----------------------
+                da1 = fabs(atan2(y3 - y2, x3 - x2) - atan2(y2 - y1, x2 - x1));
+                if(da1 >= pi) da1 = 2*pi - da1;
+
+                if(da1 < m_angle_tolerance)
+                {
+                    m_points.add(point_d(x2, y2));
+                    m_points.add(point_d(x3, y3));
+                    return;
+                }
+
+                if(m_cusp_limit != 0.0)
+                {
+                    if(da1 > m_cusp_limit)
+                    {
+                        m_points.add(point_d(x2, y2));
+                        return;
+                    }
+                }
+            }
+            break;
+
+        case 3: 
+            // Regular case
+            //-----------------
+            if((d2 + d3)*(d2 + d3) <= m_distance_tolerance_square * (dx*dx + dy*dy))
+            {
+                // If the curvature doesn't exceed the distance_tolerance value
+                // we tend to finish subdivisions.
+                //----------------------
+                if(m_angle_tolerance < curve_angle_tolerance_epsilon)
+                {
+                    m_points.add(point_d(x23, y23));
+                    return;
+                }
+
+                // Angle & Cusp Condition
+                //----------------------
+                k   = atan2(y3 - y2, x3 - x2);
+                da1 = fabs(k - atan2(y2 - y1, x2 - x1));
+                da2 = fabs(atan2(y4 - y3, x4 - x3) - k);
+                if(da1 >= pi) da1 = 2*pi - da1;
+                if(da2 >= pi) da2 = 2*pi - da2;
+
+                if(da1 + da2 < m_angle_tolerance)
+                {
+                    // Finally we can stop the recursion
+                    //----------------------
+                    m_points.add(point_d(x23, y23));
+                    return;
+                }
+
+                if(m_cusp_limit != 0.0)
+                {
+                    if(da1 > m_cusp_limit)
+                    {
+                        m_points.add(point_d(x2, y2));
+                        return;
+                    }
+
+                    if(da2 > m_cusp_limit)
+                    {
+                        m_points.add(point_d(x3, y3));
+                        return;
+                    }
+                }
+            }
+            break;
+        }
+
+        // Continue subdivision
+        //----------------------
+        recursive_bezier(x1, y1, x12, y12, x123, y123, x1234, y1234, level + 1); 
+        recursive_bezier(x1234, y1234, x234, y234, x34, y34, x4, y4, level + 1); 
+    }
+
+    //------------------------------------------------------------------------
+    void curve4_div::bezier(double x1, double y1, 
+                            double x2, double y2, 
+                            double x3, double y3, 
+                            double x4, double y4)
+    {
+        m_points.add(point_d(x1, y1));
+        recursive_bezier(x1, y1, x2, y2, x3, y3, x4, y4, 0);
+        m_points.add(point_d(x4, y4));
+    }
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_embedded_raster_fonts.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_embedded_raster_fonts.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_embedded_raster_fonts.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_embedded_raster_fonts.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,10426 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include "../include/agg_embedded_raster_fonts.h"
+
+namespace mapserver
+{
+
+    const int8u gse4x6[] = 
+    {
+        6, 0, 32, 128-32,
+
+        0x00,0x00,0x07,0x00,0x0e,0x00,0x15,0x00,0x1c,0x00,0x23,0x00,0x2a,0x00,0x31,0x00,0x38,0x00,
+        0x3f,0x00,0x46,0x00,0x4d,0x00,0x54,0x00,0x5b,0x00,0x62,0x00,0x69,0x00,0x70,0x00,0x77,0x00,
+        0x7e,0x00,0x85,0x00,0x8c,0x00,0x93,0x00,0x9a,0x00,0xa1,0x00,0xa8,0x00,0xaf,0x00,0xb6,0x00,
+        0xbd,0x00,0xc4,0x00,0xcb,0x00,0xd2,0x00,0xd9,0x00,0xe0,0x00,0xe7,0x00,0xee,0x00,0xf5,0x00,
+        0xfc,0x00,0x03,0x01,0x0a,0x01,0x11,0x01,0x18,0x01,0x1f,0x01,0x26,0x01,0x2d,0x01,0x34,0x01,
+        0x3b,0x01,0x42,0x01,0x49,0x01,0x50,0x01,0x57,0x01,0x5e,0x01,0x65,0x01,0x6c,0x01,0x73,0x01,
+        0x7a,0x01,0x81,0x01,0x88,0x01,0x8f,0x01,0x96,0x01,0x9d,0x01,0xa4,0x01,0xab,0x01,0xb2,0x01,
+        0xb9,0x01,0xc0,0x01,0xc7,0x01,0xce,0x01,0xd5,0x01,0xdc,0x01,0xe3,0x01,0xea,0x01,0xf1,0x01,
+        0xf8,0x01,0xff,0x01,0x06,0x02,0x0d,0x02,0x14,0x02,0x1b,0x02,0x22,0x02,0x29,0x02,0x30,0x02,
+        0x37,0x02,0x3e,0x02,0x45,0x02,0x4c,0x02,0x53,0x02,0x5a,0x02,0x61,0x02,0x68,0x02,0x6f,0x02,
+        0x76,0x02,0x7d,0x02,0x84,0x02,0x8b,0x02,0x92,0x02,0x99,0x02,
+
+        4, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x40,0x40,0x40,0x00,0x40,0x00,
+
+        4, // 0x22 '"'
+        0xa0,0xa0,0x00,0x00,0x00,0x00,
+
+        4, // 0x23 '#'
+        0x60,0xf0,0x60,0xf0,0x60,0x00,
+
+        4, // 0x24 '$'
+        0x40,0x60,0xc0,0x60,0xc0,0x40,
+
+        4, // 0x25 '%'
+        0xa0,0x20,0x40,0x80,0xa0,0x00,
+
+        4, // 0x26 '&'
+        0xe0,0xa0,0x50,0xa0,0xd0,0x00,
+
+        4, // 0x27 '''
+        0x40,0x40,0x00,0x00,0x00,0x00,
+
+        4, // 0x28 '('
+        0x20,0x40,0x40,0x40,0x20,0x00,
+
+        4, // 0x29 ')'
+        0x40,0x20,0x20,0x20,0x40,0x00,
+
+        4, // 0x2a '*'
+        0xa0,0x40,0xe0,0x40,0xa0,0x00,
+
+        4, // 0x2b '+'
+        0x40,0x40,0xe0,0x40,0x40,0x00,
+
+        4, // 0x2c ','
+        0x00,0x00,0x00,0x40,0x40,0x80,
+
+        4, // 0x2d '-'
+        0x00,0x00,0xe0,0x00,0x00,0x00,
+
+        4, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x40,0x00,
+
+        4, // 0x2f '/'
+        0x10,0x20,0x20,0x40,0x40,0x80,
+
+        4, // 0x30 '0'
+        0xe0,0xa0,0xa0,0xa0,0xe0,0x00,
+
+        4, // 0x31 '1'
+        0x40,0xc0,0x40,0x40,0xe0,0x00,
+
+        4, // 0x32 '2'
+        0xe0,0xa0,0x20,0x40,0xe0,0x00,
+
+        4, // 0x33 '3'
+        0xe0,0x20,0x40,0x20,0xe0,0x00,
+
+        4, // 0x34 '4'
+        0xa0,0xa0,0xe0,0x20,0x20,0x00,
+
+        4, // 0x35 '5'
+        0xe0,0x80,0xc0,0x20,0xc0,0x00,
+
+        4, // 0x36 '6'
+        0x40,0x80,0xe0,0xa0,0xe0,0x00,
+
+        4, // 0x37 '7'
+        0xe0,0xa0,0x20,0x40,0x40,0x00,
+
+        4, // 0x38 '8'
+        0xe0,0xa0,0x40,0xa0,0xe0,0x00,
+
+        4, // 0x39 '9'
+        0xe0,0xa0,0xe0,0x20,0xc0,0x00,
+
+        4, // 0x3a ':'
+        0x00,0x40,0x00,0x40,0x00,0x00,
+
+        4, // 0x3b ';'
+        0x00,0x40,0x00,0x40,0x40,0x80,
+
+        4, // 0x3c '<'
+        0x20,0x40,0x80,0x40,0x20,0x00,
+
+        4, // 0x3d '='
+        0x00,0xe0,0x00,0xe0,0x00,0x00,
+
+        4, // 0x3e '>'
+        0x80,0x40,0x20,0x40,0x80,0x00,
+
+        4, // 0x3f '?'
+        0xc0,0x20,0x40,0x00,0x40,0x00,
+
+        4, // 0x40 '@'
+        0x40,0xa0,0xe0,0xe0,0x80,0x60,
+
+        4, // 0x41 'A'
+        0x40,0xa0,0xe0,0xa0,0xa0,0x00,
+
+        4, // 0x42 'B'
+        0xc0,0xa0,0xc0,0xa0,0xc0,0x00,
+
+        4, // 0x43 'C'
+        0x60,0x80,0x80,0x80,0x60,0x00,
+
+        4, // 0x44 'D'
+        0xc0,0xa0,0xa0,0xa0,0xc0,0x00,
+
+        4, // 0x45 'E'
+        0xe0,0x80,0xc0,0x80,0xe0,0x00,
+
+        4, // 0x46 'F'
+        0xe0,0x80,0xc0,0x80,0x80,0x00,
+
+        4, // 0x47 'G'
+        0x60,0x80,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x48 'H'
+        0xa0,0xa0,0xe0,0xa0,0xa0,0x00,
+
+        4, // 0x49 'I'
+        0xe0,0x40,0x40,0x40,0xe0,0x00,
+
+        4, // 0x4a 'J'
+        0x20,0x20,0x20,0x20,0xa0,0x40,
+
+        4, // 0x4b 'K'
+        0xa0,0xa0,0xc0,0xc0,0xa0,0x00,
+
+        4, // 0x4c 'L'
+        0x80,0x80,0x80,0x80,0xe0,0x00,
+
+        4, // 0x4d 'M'
+        0xa0,0xe0,0xa0,0xa0,0xa0,0x00,
+
+        4, // 0x4e 'N'
+        0x90,0xd0,0xb0,0x90,0x90,0x00,
+
+        4, // 0x4f 'O'
+        0x40,0xa0,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x50 'P'
+        0xc0,0xa0,0xa0,0xc0,0x80,0x00,
+
+        4, // 0x51 'Q'
+        0x40,0xa0,0xa0,0xa0,0x60,0x00,
+
+        4, // 0x52 'R'
+        0xc0,0xa0,0xa0,0xc0,0xa0,0x00,
+
+        4, // 0x53 'S'
+        0x60,0x80,0x40,0x20,0xc0,0x00,
+
+        4, // 0x54 'T'
+        0xe0,0x40,0x40,0x40,0x40,0x00,
+
+        4, // 0x55 'U'
+        0xa0,0xa0,0xa0,0xa0,0xe0,0x00,
+
+        4, // 0x56 'V'
+        0xa0,0xa0,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x57 'W'
+        0xa0,0xa0,0xa0,0xe0,0xa0,0x00,
+
+        4, // 0x58 'X'
+        0xa0,0xa0,0x40,0xa0,0xa0,0x00,
+
+        4, // 0x59 'Y'
+        0xa0,0xa0,0x40,0x40,0x40,0x00,
+
+        4, // 0x5a 'Z'
+        0xe0,0x20,0x40,0x80,0xe0,0x00,
+
+        4, // 0x5b '['
+        0xc0,0x80,0x80,0x80,0xc0,0x00,
+
+        4, // 0x5c '\'
+        0x80,0x40,0x40,0x20,0x20,0x10,
+
+        4, // 0x5d ']'
+        0xc0,0x40,0x40,0x40,0xc0,0x00,
+
+        4, // 0x5e '^'
+        0x40,0xa0,0x00,0x00,0x00,0x00,
+
+        4, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0xf0,
+
+        4, // 0x60 '`'
+        0x40,0x20,0x00,0x00,0x00,0x00,
+
+        4, // 0x61 'a'
+        0x00,0x60,0xa0,0xa0,0x70,0x00,
+
+        4, // 0x62 'b'
+        0x80,0x80,0xc0,0xa0,0xc0,0x00,
+
+        4, // 0x63 'c'
+        0x00,0x60,0x80,0x80,0x60,0x00,
+
+        4, // 0x64 'd'
+        0x20,0x20,0x60,0xa0,0x60,0x00,
+
+        4, // 0x65 'e'
+        0x00,0x40,0xe0,0x80,0x60,0x00,
+
+        4, // 0x66 'f'
+        0x20,0x40,0xe0,0x40,0x40,0x00,
+
+        4, // 0x67 'g'
+        0x00,0x60,0xa0,0x60,0x20,0xc0,
+
+        4, // 0x68 'h'
+        0x80,0x80,0xc0,0xa0,0xa0,0x00,
+
+        4, // 0x69 'i'
+        0x40,0x00,0xc0,0x40,0xe0,0x00,
+
+        4, // 0x6a 'j'
+        0x40,0x00,0xc0,0x40,0x40,0x80,
+
+        4, // 0x6b 'k'
+        0x80,0x80,0xa0,0xc0,0xa0,0x00,
+
+        4, // 0x6c 'l'
+        0xc0,0x40,0x40,0x40,0xe0,0x00,
+
+        4, // 0x6d 'm'
+        0x00,0xa0,0xf0,0xf0,0x90,0x00,
+
+        4, // 0x6e 'n'
+        0x00,0xc0,0xa0,0xa0,0xa0,0x00,
+
+        4, // 0x6f 'o'
+        0x00,0x40,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x70 'p'
+        0x00,0xc0,0xa0,0xc0,0x80,0x80,
+
+        4, // 0x71 'q'
+        0x00,0x60,0xa0,0x60,0x20,0x20,
+
+        4, // 0x72 'r'
+        0x00,0xa0,0x50,0x40,0x40,0x00,
+
+        4, // 0x73 's'
+        0x00,0x60,0xc0,0x20,0xc0,0x00,
+
+        4, // 0x74 't'
+        0x40,0x40,0xe0,0x40,0x60,0x00,
+
+        4, // 0x75 'u'
+        0x00,0xa0,0xa0,0xa0,0x60,0x00,
+
+        4, // 0x76 'v'
+        0x00,0xa0,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x77 'w'
+        0x00,0xa0,0xa0,0xe0,0xa0,0x00,
+
+        4, // 0x78 'x'
+        0x00,0xa0,0x40,0xa0,0xa0,0x00,
+
+        4, // 0x79 'y'
+        0x00,0xa0,0xa0,0x60,0x20,0xc0,
+
+        4, // 0x7a 'z'
+        0x00,0xe0,0x40,0x80,0xe0,0x00,
+
+        4, // 0x7b '{'
+        0x30,0x20,0xc0,0x20,0x30,0x00,
+
+        4, // 0x7c '|'
+        0x40,0x40,0x00,0x40,0x40,0x40,
+
+        4, // 0x7d '}'
+        0xc0,0x40,0x30,0x40,0xc0,0x00,
+
+        4, // 0x7e '~'
+        0x50,0xa0,0x00,0x00,0x00,0x00,
+
+        4, // 0x7f ''
+        0x00,0x60,0x90,0xf0,0x00,0x00,
+        0
+    };
+
+    const int8u gse4x8[] = 
+    {
+        8, 0, 32, 128-32,
+
+        0x00,0x00,0x09,0x00,0x12,0x00,0x1b,0x00,0x24,0x00,0x2d,0x00,0x36,0x00,0x3f,0x00,0x48,0x00,
+        0x51,0x00,0x5a,0x00,0x63,0x00,0x6c,0x00,0x75,0x00,0x7e,0x00,0x87,0x00,0x90,0x00,0x99,0x00,
+        0xa2,0x00,0xab,0x00,0xb4,0x00,0xbd,0x00,0xc6,0x00,0xcf,0x00,0xd8,0x00,0xe1,0x00,0xea,0x00,
+        0xf3,0x00,0xfc,0x00,0x05,0x01,0x0e,0x01,0x17,0x01,0x20,0x01,0x29,0x01,0x32,0x01,0x3b,0x01,
+        0x44,0x01,0x4d,0x01,0x56,0x01,0x5f,0x01,0x68,0x01,0x71,0x01,0x7a,0x01,0x83,0x01,0x8c,0x01,
+        0x95,0x01,0x9e,0x01,0xa7,0x01,0xb0,0x01,0xb9,0x01,0xc2,0x01,0xcb,0x01,0xd4,0x01,0xdd,0x01,
+        0xe6,0x01,0xef,0x01,0xf8,0x01,0x01,0x02,0x0a,0x02,0x13,0x02,0x1c,0x02,0x25,0x02,0x2e,0x02,
+        0x37,0x02,0x40,0x02,0x49,0x02,0x52,0x02,0x5b,0x02,0x64,0x02,0x6d,0x02,0x76,0x02,0x7f,0x02,
+        0x88,0x02,0x91,0x02,0x9a,0x02,0xa3,0x02,0xac,0x02,0xb5,0x02,0xbe,0x02,0xc7,0x02,0xd0,0x02,
+        0xd9,0x02,0xe2,0x02,0xeb,0x02,0xf4,0x02,0xfd,0x02,0x06,0x03,0x0f,0x03,0x18,0x03,0x21,0x03,
+        0x2a,0x03,0x33,0x03,0x3c,0x03,0x45,0x03,0x4e,0x03,0x57,0x03,
+
+        4, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x00,0x40,0x40,0x40,0x40,0x00,0x40,0x00,
+
+        4, // 0x22 '"'
+        0x00,0xa0,0xa0,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x23 '#'
+        0x60,0x60,0xf0,0x60,0x60,0xf0,0x60,0x60,
+
+        4, // 0x24 '$'
+        0x40,0x60,0xc0,0xc0,0x60,0x60,0xc0,0x40,
+
+        4, // 0x25 '%'
+        0x00,0xa0,0x20,0x40,0x40,0x80,0xa0,0x00,
+
+        4, // 0x26 '&'
+        0x00,0x40,0xa0,0xa0,0x40,0xb0,0xa0,0x70,
+
+        4, // 0x27 '''
+        0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x28 '('
+        0x20,0x40,0x80,0x80,0x80,0x80,0x40,0x20,
+
+        4, // 0x29 ')'
+        0x80,0x40,0x20,0x20,0x20,0x20,0x40,0x80,
+
+        4, // 0x2a '*'
+        0x00,0xa0,0x40,0xe0,0x40,0xa0,0x00,0x00,
+
+        4, // 0x2b '+'
+        0x00,0x40,0x40,0xe0,0x40,0x40,0x00,0x00,
+
+        4, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x80,
+
+        4, // 0x2d '-'
+        0x00,0x00,0x00,0xe0,0x00,0x00,0x00,0x00,
+
+        4, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,
+
+        4, // 0x2f '/'
+        0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,
+
+        4, // 0x30 '0'
+        0x00,0xe0,0xa0,0xa0,0xa0,0xa0,0xe0,0x00,
+
+        4, // 0x31 '1'
+        0x00,0x40,0xc0,0x40,0x40,0x40,0xe0,0x00,
+
+        4, // 0x32 '2'
+        0x00,0xe0,0xa0,0x20,0x40,0x80,0xe0,0x00,
+
+        4, // 0x33 '3'
+        0x00,0xe0,0x20,0x40,0x20,0x20,0xe0,0x00,
+
+        4, // 0x34 '4'
+        0x00,0x60,0xa0,0xa0,0xf0,0x20,0x20,0x00,
+
+        4, // 0x35 '5'
+        0x00,0xe0,0x80,0xc0,0x20,0x20,0xc0,0x00,
+
+        4, // 0x36 '6'
+        0x00,0x40,0x80,0xe0,0xa0,0xa0,0xe0,0x00,
+
+        4, // 0x37 '7'
+        0x00,0xe0,0xa0,0x20,0x40,0x40,0x40,0x00,
+
+        4, // 0x38 '8'
+        0x00,0xe0,0xa0,0x40,0xa0,0xa0,0xe0,0x00,
+
+        4, // 0x39 '9'
+        0x00,0xe0,0xa0,0xe0,0x20,0x20,0x40,0x00,
+
+        4, // 0x3a ':'
+        0x00,0x00,0x40,0x00,0x00,0x40,0x00,0x00,
+
+        4, // 0x3b ';'
+        0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x80,
+
+        4, // 0x3c '<'
+        0x00,0x20,0x40,0x80,0x40,0x20,0x00,0x00,
+
+        4, // 0x3d '='
+        0x00,0x00,0xe0,0x00,0xe0,0x00,0x00,0x00,
+
+        4, // 0x3e '>'
+        0x00,0x80,0x40,0x20,0x40,0x80,0x00,0x00,
+
+        4, // 0x3f '?'
+        0x00,0x40,0xa0,0x20,0x40,0x00,0x40,0x00,
+
+        4, // 0x40 '@'
+        0x00,0x40,0xa0,0xe0,0xe0,0x80,0x60,0x00,
+
+        4, // 0x41 'A'
+        0x00,0x40,0xa0,0xa0,0xe0,0xa0,0xa0,0x00,
+
+        4, // 0x42 'B'
+        0x00,0xc0,0xa0,0xc0,0xa0,0xa0,0xc0,0x00,
+
+        4, // 0x43 'C'
+        0x00,0x40,0xa0,0x80,0x80,0xa0,0x40,0x00,
+
+        4, // 0x44 'D'
+        0x00,0xc0,0xa0,0xa0,0xa0,0xa0,0xc0,0x00,
+
+        4, // 0x45 'E'
+        0x00,0xe0,0x80,0xc0,0x80,0x80,0xe0,0x00,
+
+        4, // 0x46 'F'
+        0x00,0xe0,0x80,0xc0,0x80,0x80,0x80,0x00,
+
+        4, // 0x47 'G'
+        0x00,0x60,0x80,0xa0,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x48 'H'
+        0x00,0xa0,0xa0,0xe0,0xa0,0xa0,0xa0,0x00,
+
+        4, // 0x49 'I'
+        0x00,0xe0,0x40,0x40,0x40,0x40,0xe0,0x00,
+
+        4, // 0x4a 'J'
+        0x00,0x20,0x20,0x20,0x20,0xa0,0x40,0x00,
+
+        4, // 0x4b 'K'
+        0x00,0xa0,0xa0,0xc0,0xc0,0xa0,0xa0,0x00,
+
+        4, // 0x4c 'L'
+        0x00,0x80,0x80,0x80,0x80,0x80,0xe0,0x00,
+
+        4, // 0x4d 'M'
+        0x00,0xa0,0xe0,0xa0,0xa0,0xa0,0xa0,0x00,
+
+        4, // 0x4e 'N'
+        0x00,0x90,0x90,0xd0,0xb0,0x90,0x90,0x00,
+
+        4, // 0x4f 'O'
+        0x00,0x40,0xa0,0xa0,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x50 'P'
+        0x00,0xc0,0xa0,0xa0,0xc0,0x80,0x80,0x00,
+
+        4, // 0x51 'Q'
+        0x00,0x40,0xa0,0xa0,0xa0,0xa0,0x60,0x00,
+
+        4, // 0x52 'R'
+        0x00,0xc0,0xa0,0xa0,0xc0,0xc0,0xa0,0x00,
+
+        4, // 0x53 'S'
+        0x00,0x60,0x80,0x40,0x20,0x20,0xc0,0x00,
+
+        4, // 0x54 'T'
+        0x00,0xe0,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        4, // 0x55 'U'
+        0x00,0xa0,0xa0,0xa0,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x56 'V'
+        0x00,0xa0,0xa0,0xa0,0xa0,0x40,0x40,0x00,
+
+        4, // 0x57 'W'
+        0x00,0xa0,0xa0,0xa0,0xa0,0xe0,0xa0,0x00,
+
+        4, // 0x58 'X'
+        0x00,0xa0,0xa0,0x40,0xa0,0xa0,0xa0,0x00,
+
+        4, // 0x59 'Y'
+        0x00,0xa0,0xa0,0x40,0x40,0x40,0x40,0x00,
+
+        4, // 0x5a 'Z'
+        0x00,0xe0,0x20,0x40,0x40,0x80,0xe0,0x00,
+
+        4, // 0x5b '['
+        0xc0,0x80,0x80,0x80,0x80,0x80,0x80,0xc0,
+
+        4, // 0x5c '\'
+        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,
+
+        4, // 0x5d ']'
+        0xc0,0x40,0x40,0x40,0x40,0x40,0x40,0xc0,
+
+        4, // 0x5e '^'
+        0x00,0x40,0xa0,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,
+
+        4, // 0x60 '`'
+        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x61 'a'
+        0x00,0x00,0x60,0xa0,0xa0,0xa0,0x70,0x00,
+
+        4, // 0x62 'b'
+        0x00,0x80,0x80,0xc0,0xa0,0xa0,0xc0,0x00,
+
+        4, // 0x63 'c'
+        0x00,0x00,0x40,0xa0,0x80,0xa0,0x40,0x00,
+
+        4, // 0x64 'd'
+        0x00,0x20,0x20,0x60,0xa0,0xa0,0x60,0x00,
+
+        4, // 0x65 'e'
+        0x00,0x00,0x40,0xa0,0xe0,0x80,0x60,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x20,0x40,0x40,0xe0,0x40,0x40,0x00,
+
+        4, // 0x67 'g'
+        0x00,0x00,0x60,0xa0,0xa0,0x60,0x20,0xc0,
+
+        4, // 0x68 'h'
+        0x00,0x80,0x80,0xc0,0xa0,0xa0,0xa0,0x00,
+
+        4, // 0x69 'i'
+        0x00,0x40,0x00,0xc0,0x40,0x40,0xe0,0x00,
+
+        4, // 0x6a 'j'
+        0x00,0x40,0x00,0xc0,0x40,0x40,0x40,0x80,
+
+        4, // 0x6b 'k'
+        0x00,0x80,0x80,0xa0,0xc0,0xc0,0xa0,0x00,
+
+        4, // 0x6c 'l'
+        0x00,0xc0,0x40,0x40,0x40,0x40,0xe0,0x00,
+
+        4, // 0x6d 'm'
+        0x00,0x00,0xa0,0xf0,0xf0,0xf0,0x90,0x00,
+
+        4, // 0x6e 'n'
+        0x00,0x00,0xc0,0xa0,0xa0,0xa0,0xa0,0x00,
+
+        4, // 0x6f 'o'
+        0x00,0x00,0x40,0xa0,0xa0,0xa0,0x40,0x00,
+
+        4, // 0x70 'p'
+        0x00,0x00,0xc0,0xa0,0xa0,0xc0,0x80,0x80,
+
+        4, // 0x71 'q'
+        0x00,0x00,0x60,0xa0,0xa0,0x60,0x20,0x20,
+
+        4, // 0x72 'r'
+        0x00,0x00,0xa0,0x50,0x40,0x40,0x40,0x00,
+
+        4, // 0x73 's'
+        0x00,0x00,0x60,0x80,0x40,0x20,0xc0,0x00,
+
+        4, // 0x74 't'
+        0x00,0x40,0x40,0xe0,0x40,0x40,0x20,0x00,
+
+        4, // 0x75 'u'
+        0x00,0x00,0xa0,0xa0,0xa0,0xa0,0x60,0x00,
+
+        4, // 0x76 'v'
+        0x00,0x00,0xa0,0xa0,0xa0,0x40,0x40,0x00,
+
+        4, // 0x77 'w'
+        0x00,0x00,0xa0,0xa0,0xa0,0xe0,0xa0,0x00,
+
+        4, // 0x78 'x'
+        0x00,0x00,0xa0,0xa0,0x40,0xa0,0xa0,0x00,
+
+        4, // 0x79 'y'
+        0x00,0x00,0xa0,0xa0,0xa0,0x60,0x20,0xc0,
+
+        4, // 0x7a 'z'
+        0x00,0x00,0xe0,0x20,0x40,0x80,0xe0,0x00,
+
+        4, // 0x7b '{'
+        0x10,0x20,0x20,0xc0,0x20,0x20,0x10,0x00,
+
+        4, // 0x7c '|'
+        0x00,0x40,0x40,0x40,0x00,0x40,0x40,0x40,
+
+        4, // 0x7d '}'
+        0x80,0x40,0x40,0x30,0x40,0x40,0x80,0x00,
+
+        4, // 0x7e '~'
+        0x00,0x50,0xa0,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x7f ''
+        0x00,0x00,0x00,0x60,0x90,0xf0,0x00,0x00,
+        0
+    };
+
+    const int8u gse5x7[] = 
+    {
+        7, 0, 32, 128-32,
+
+        0x00,0x00,0x08,0x00,0x10,0x00,0x18,0x00,0x20,0x00,0x28,0x00,0x30,0x00,0x38,0x00,0x40,0x00,
+        0x48,0x00,0x50,0x00,0x58,0x00,0x60,0x00,0x68,0x00,0x70,0x00,0x78,0x00,0x80,0x00,0x88,0x00,
+        0x90,0x00,0x98,0x00,0xa0,0x00,0xa8,0x00,0xb0,0x00,0xb8,0x00,0xc0,0x00,0xc8,0x00,0xd0,0x00,
+        0xd8,0x00,0xe0,0x00,0xe8,0x00,0xf0,0x00,0xf8,0x00,0x00,0x01,0x08,0x01,0x10,0x01,0x18,0x01,
+        0x20,0x01,0x28,0x01,0x30,0x01,0x38,0x01,0x40,0x01,0x48,0x01,0x50,0x01,0x58,0x01,0x60,0x01,
+        0x68,0x01,0x70,0x01,0x78,0x01,0x80,0x01,0x88,0x01,0x90,0x01,0x98,0x01,0xa0,0x01,0xa8,0x01,
+        0xb0,0x01,0xb8,0x01,0xc0,0x01,0xc8,0x01,0xd0,0x01,0xd8,0x01,0xe0,0x01,0xe8,0x01,0xf0,0x01,
+        0xf8,0x01,0x00,0x02,0x08,0x02,0x10,0x02,0x18,0x02,0x20,0x02,0x28,0x02,0x30,0x02,0x38,0x02,
+        0x40,0x02,0x48,0x02,0x50,0x02,0x58,0x02,0x60,0x02,0x68,0x02,0x70,0x02,0x78,0x02,0x80,0x02,
+        0x88,0x02,0x90,0x02,0x98,0x02,0xa0,0x02,0xa8,0x02,0xb0,0x02,0xb8,0x02,0xc0,0x02,0xc8,0x02,
+        0xd0,0x02,0xd8,0x02,0xe0,0x02,0xe8,0x02,0xf0,0x02,0xf8,0x02,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x00,0x20,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x50,0x50,0x00,0x00,0x00,0x00,
+
+        5, // 0x23 '#'
+        0x00,0x50,0xf8,0x50,0xf8,0x50,0x00,
+
+        5, // 0x24 '$'
+        0x20,0x78,0xa0,0x70,0x28,0xf0,0x20,
+
+        5, // 0x25 '%'
+        0x00,0x88,0x10,0x20,0x40,0x88,0x00,
+
+        5, // 0x26 '&'
+        0x00,0x40,0xa0,0x68,0x90,0x68,0x00,
+
+        5, // 0x27 '''
+        0x00,0x20,0x20,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x10,0x20,0x40,0x40,0x40,0x20,0x10,
+
+        5, // 0x29 ')'
+        0x80,0x40,0x20,0x20,0x20,0x40,0x80,
+
+        5, // 0x2a '*'
+        0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,
+
+        5, // 0x2b '+'
+        0x00,0x20,0x20,0xf8,0x20,0x20,0x00,
+
+        5, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x20,0x20,0x40,
+
+        5, // 0x2d '-'
+        0x00,0x00,0x00,0xf0,0x00,0x00,0x00,
+
+        5, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x40,0x00,
+
+        5, // 0x2f '/'
+        0x00,0x08,0x10,0x20,0x40,0x80,0x00,
+
+        5, // 0x30 '0'
+        0x00,0x60,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x70,0x00,
+
+        5, // 0x32 '2'
+        0x00,0x60,0x90,0x20,0x40,0xf0,0x00,
+
+        5, // 0x33 '3'
+        0x00,0xf0,0x20,0x60,0x10,0xe0,0x00,
+
+        5, // 0x34 '4'
+        0x00,0x30,0x50,0x90,0xf0,0x10,0x00,
+
+        5, // 0x35 '5'
+        0x00,0xf0,0x80,0xe0,0x10,0xe0,0x00,
+
+        5, // 0x36 '6'
+        0x00,0x60,0x80,0xe0,0x90,0x60,0x00,
+
+        5, // 0x37 '7'
+        0x00,0xf0,0x90,0x20,0x40,0x40,0x00,
+
+        5, // 0x38 '8'
+        0x00,0x60,0x90,0x60,0x90,0x60,0x00,
+
+        5, // 0x39 '9'
+        0x00,0x60,0x90,0x70,0x10,0x60,0x00,
+
+        5, // 0x3a ':'
+        0x00,0x00,0x20,0x00,0x20,0x00,0x00,
+
+        5, // 0x3b ';'
+        0x00,0x00,0x20,0x00,0x20,0x20,0x40,
+
+        5, // 0x3c '<'
+        0x00,0x10,0x20,0x40,0x20,0x10,0x00,
+
+        5, // 0x3d '='
+        0x00,0x00,0xf0,0x00,0xf0,0x00,0x00,
+
+        5, // 0x3e '>'
+        0x00,0x80,0x40,0x20,0x40,0x80,0x00,
+
+        5, // 0x3f '?'
+        0x00,0x60,0x90,0x20,0x00,0x20,0x00,
+
+        5, // 0x40 '@'
+        0x00,0x60,0x90,0xb0,0x80,0x70,0x00,
+
+        5, // 0x41 'A'
+        0x00,0x60,0x90,0xf0,0x90,0x90,0x00,
+
+        5, // 0x42 'B'
+        0x00,0xe0,0x90,0xe0,0x90,0xe0,0x00,
+
+        5, // 0x43 'C'
+        0x00,0x60,0x90,0x80,0x90,0x60,0x00,
+
+        5, // 0x44 'D'
+        0x00,0xe0,0x90,0x90,0x90,0xe0,0x00,
+
+        5, // 0x45 'E'
+        0x00,0xf0,0x80,0xe0,0x80,0xf0,0x00,
+
+        5, // 0x46 'F'
+        0x00,0xf0,0x80,0xe0,0x80,0x80,0x00,
+
+        5, // 0x47 'G'
+        0x00,0x70,0x80,0xb0,0x90,0x60,0x00,
+
+        5, // 0x48 'H'
+        0x00,0x90,0x90,0xf0,0x90,0x90,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x4a 'J'
+        0x00,0x70,0x20,0x20,0xa0,0x40,0x00,
+
+        5, // 0x4b 'K'
+        0x00,0x90,0xa0,0xc0,0xa0,0x90,0x00,
+
+        5, // 0x4c 'L'
+        0x00,0x80,0x80,0x80,0x80,0xf0,0x00,
+
+        5, // 0x4d 'M'
+        0x00,0x90,0xf0,0x90,0x90,0x90,0x00,
+
+        5, // 0x4e 'N'
+        0x00,0x90,0xd0,0xb0,0x90,0x90,0x00,
+
+        5, // 0x4f 'O'
+        0x00,0x60,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x50 'P'
+        0x00,0xe0,0x90,0xe0,0x80,0x80,0x00,
+
+        5, // 0x51 'Q'
+        0x00,0x60,0x90,0x90,0xa0,0x50,0x00,
+
+        5, // 0x52 'R'
+        0x00,0xe0,0x90,0xe0,0xa0,0x90,0x00,
+
+        5, // 0x53 'S'
+        0x00,0x70,0x80,0x60,0x10,0xe0,0x00,
+
+        5, // 0x54 'T'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x55 'U'
+        0x00,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x56 'V'
+        0x00,0x50,0x50,0x50,0x20,0x20,0x00,
+
+        5, // 0x57 'W'
+        0x00,0x90,0x90,0x90,0xf0,0x90,0x00,
+
+        5, // 0x58 'X'
+        0x00,0x90,0x90,0x60,0x90,0x90,0x00,
+
+        5, // 0x59 'Y'
+        0x00,0x50,0x50,0x20,0x20,0x20,0x00,
+
+        5, // 0x5a 'Z'
+        0x00,0xf0,0x10,0x20,0x40,0xf0,0x00,
+
+        5, // 0x5b '['
+        0x70,0x40,0x40,0x40,0x40,0x40,0x70,
+
+        5, // 0x5c '\'
+        0x00,0x80,0x40,0x20,0x10,0x08,0x00,
+
+        5, // 0x5d ']'
+        0xe0,0x20,0x20,0x20,0x20,0x20,0xe0,
+
+        5, // 0x5e '^'
+        0x00,0x20,0x50,0x00,0x00,0x00,0x00,
+
+        5, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0xf8,0x00,
+
+        5, // 0x60 '`'
+        0x00,0x40,0x20,0x00,0x00,0x00,0x00,
+
+        5, // 0x61 'a'
+        0x00,0x00,0x60,0xa0,0xa0,0x50,0x00,
+
+        5, // 0x62 'b'
+        0x00,0x80,0x80,0xe0,0x90,0xe0,0x00,
+
+        5, // 0x63 'c'
+        0x00,0x00,0x70,0x80,0x80,0x70,0x00,
+
+        5, // 0x64 'd'
+        0x00,0x10,0x10,0x70,0x90,0x70,0x00,
+
+        5, // 0x65 'e'
+        0x00,0x00,0x60,0xf0,0x80,0x70,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x30,0x40,0xe0,0x40,0x40,0x00,
+
+        5, // 0x67 'g'
+        0x00,0x00,0x70,0x90,0x70,0x10,0x60,
+
+        5, // 0x68 'h'
+        0x00,0x80,0x80,0xe0,0x90,0x90,0x00,
+
+        5, // 0x69 'i'
+        0x20,0x00,0x60,0x20,0x20,0x70,0x00,
+
+        5, // 0x6a 'j'
+        0x20,0x00,0x60,0x20,0x20,0xa0,0x40,
+
+        5, // 0x6b 'k'
+        0x80,0x80,0x90,0xa0,0xe0,0x90,0x00,
+
+        5, // 0x6c 'l'
+        0x00,0x60,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x6d 'm'
+        0x00,0x00,0xa0,0xf0,0xf0,0x90,0x00,
+
+        5, // 0x6e 'n'
+        0x00,0x00,0xa0,0xd0,0x90,0x90,0x00,
+
+        5, // 0x6f 'o'
+        0x00,0x00,0x60,0x90,0x90,0x60,0x00,
+
+        5, // 0x70 'p'
+        0x00,0x00,0xe0,0x90,0xe0,0x80,0x80,
+
+        5, // 0x71 'q'
+        0x00,0x00,0x70,0x90,0x70,0x10,0x10,
+
+        5, // 0x72 'r'
+        0x00,0x00,0xe0,0x90,0x80,0x80,0x00,
+
+        5, // 0x73 's'
+        0x00,0x00,0x70,0xe0,0x10,0xe0,0x00,
+
+        5, // 0x74 't'
+        0x40,0x40,0xe0,0x40,0x40,0x70,0x00,
+
+        5, // 0x75 'u'
+        0x00,0x00,0x90,0x90,0x90,0x70,0x00,
+
+        5, // 0x76 'v'
+        0x00,0x00,0x50,0x50,0x50,0x20,0x00,
+
+        5, // 0x77 'w'
+        0x00,0x00,0x90,0x90,0xf0,0x90,0x00,
+
+        5, // 0x78 'x'
+        0x00,0x00,0x90,0x60,0x60,0x90,0x00,
+
+        5, // 0x79 'y'
+        0x00,0x00,0x90,0x90,0x70,0x10,0x60,
+
+        5, // 0x7a 'z'
+        0x00,0x00,0xf0,0x20,0x40,0xf0,0x00,
+
+        5, // 0x7b '{'
+        0x10,0x20,0x20,0xc0,0x20,0x20,0x10,
+
+        5, // 0x7c '|'
+        0x20,0x20,0x20,0x00,0x20,0x20,0x20,
+
+        5, // 0x7d '}'
+        0x40,0x20,0x20,0x18,0x20,0x20,0x40,
+
+        5, // 0x7e '~'
+        0x00,0x40,0xa8,0x10,0x00,0x00,0x00,
+
+        5, // 0x7f ''
+        0x00,0x00,0x20,0x50,0x88,0xf8,0x00,
+        0
+    };
+
+    const int8u gse5x9[] = 
+    {
+        9, 0, 32, 128-32,
+
+        0x00,0x00,0x0a,0x00,0x14,0x00,0x1e,0x00,0x28,0x00,0x32,0x00,0x3c,0x00,0x46,0x00,0x50,0x00,
+        0x5a,0x00,0x64,0x00,0x6e,0x00,0x78,0x00,0x82,0x00,0x8c,0x00,0x96,0x00,0xa0,0x00,0xaa,0x00,
+        0xb4,0x00,0xbe,0x00,0xc8,0x00,0xd2,0x00,0xdc,0x00,0xe6,0x00,0xf0,0x00,0xfa,0x00,0x04,0x01,
+        0x0e,0x01,0x18,0x01,0x22,0x01,0x2c,0x01,0x36,0x01,0x40,0x01,0x4a,0x01,0x54,0x01,0x5e,0x01,
+        0x68,0x01,0x72,0x01,0x7c,0x01,0x86,0x01,0x90,0x01,0x9a,0x01,0xa4,0x01,0xae,0x01,0xb8,0x01,
+        0xc2,0x01,0xcc,0x01,0xd6,0x01,0xe0,0x01,0xea,0x01,0xf4,0x01,0xfe,0x01,0x08,0x02,0x12,0x02,
+        0x1c,0x02,0x26,0x02,0x30,0x02,0x3a,0x02,0x44,0x02,0x4e,0x02,0x58,0x02,0x62,0x02,0x6c,0x02,
+        0x76,0x02,0x80,0x02,0x8a,0x02,0x94,0x02,0x9e,0x02,0xa8,0x02,0xb2,0x02,0xbc,0x02,0xc6,0x02,
+        0xd0,0x02,0xda,0x02,0xe4,0x02,0xee,0x02,0xf8,0x02,0x02,0x03,0x0c,0x03,0x16,0x03,0x20,0x03,
+        0x2a,0x03,0x34,0x03,0x3e,0x03,0x48,0x03,0x52,0x03,0x5c,0x03,0x66,0x03,0x70,0x03,0x7a,0x03,
+        0x84,0x03,0x8e,0x03,0x98,0x03,0xa2,0x03,0xac,0x03,0xb6,0x03,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x23 '#'
+        0x00,0x50,0x50,0xf8,0x50,0xf8,0x50,0x50,0x00,
+
+        5, // 0x24 '$'
+        0x00,0x20,0x78,0xa0,0x70,0x28,0xf0,0x20,0x00,
+
+        5, // 0x25 '%'
+        0x00,0xc8,0xc8,0x10,0x20,0x40,0x98,0x98,0x00,
+
+        5, // 0x26 '&'
+        0x00,0x40,0xa0,0xa0,0x40,0xa8,0x90,0x68,0x00,
+
+        5, // 0x27 '''
+        0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x10,
+
+        5, // 0x29 ')'
+        0x80,0x40,0x20,0x20,0x20,0x20,0x20,0x40,0x80,
+
+        5, // 0x2a '*'
+        0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,
+
+        5, // 0x2b '+'
+        0x00,0x00,0x20,0x20,0xf8,0x20,0x20,0x00,0x00,
+
+        5, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x40,
+
+        5, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0xf0,0x00,0x00,0x00,0x00,
+
+        5, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,
+
+        5, // 0x2f '/'
+        0x00,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,
+
+        5, // 0x30 '0'
+        0x00,0x60,0x90,0xb0,0xd0,0x90,0x90,0x60,0x00,
+
+        5, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x32 '2'
+        0x00,0x60,0x90,0x10,0x20,0x40,0x80,0xf0,0x00,
+
+        5, // 0x33 '3'
+        0x00,0xf0,0x10,0x20,0x60,0x10,0x90,0x60,0x00,
+
+        5, // 0x34 '4'
+        0x00,0x30,0x50,0x90,0x90,0xf8,0x10,0x10,0x00,
+
+        5, // 0x35 '5'
+        0x00,0xf0,0x80,0xe0,0x10,0x10,0x10,0xe0,0x00,
+
+        5, // 0x36 '6'
+        0x00,0x60,0x80,0xe0,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x37 '7'
+        0x00,0xf0,0x90,0x10,0x20,0x40,0x40,0x40,0x00,
+
+        5, // 0x38 '8'
+        0x00,0x60,0x90,0x90,0x60,0x90,0x90,0x60,0x00,
+
+        5, // 0x39 '9'
+        0x00,0x60,0x90,0x90,0x70,0x10,0x90,0x60,0x00,
+
+        5, // 0x3a ':'
+        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x00,0x00,
+
+        5, // 0x3b ';'
+        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x20,0x40,
+
+        5, // 0x3c '<'
+        0x00,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x00,
+
+        5, // 0x3d '='
+        0x00,0x00,0x00,0xf0,0x00,0xf0,0x00,0x00,0x00,
+
+        5, // 0x3e '>'
+        0x00,0x80,0x40,0x20,0x10,0x20,0x40,0x80,0x00,
+
+        5, // 0x3f '?'
+        0x00,0x60,0x90,0x10,0x20,0x20,0x00,0x20,0x00,
+
+        5, // 0x40 '@'
+        0x00,0x60,0x90,0xb0,0xb0,0xb0,0x80,0x70,0x00,
+
+        5, // 0x41 'A'
+        0x00,0x60,0x90,0x90,0xf0,0x90,0x90,0x90,0x00,
+
+        5, // 0x42 'B'
+        0x00,0xe0,0x90,0x90,0xe0,0x90,0x90,0xe0,0x00,
+
+        5, // 0x43 'C'
+        0x00,0x60,0x90,0x80,0x80,0x80,0x90,0x60,0x00,
+
+        5, // 0x44 'D'
+        0x00,0xe0,0x90,0x90,0x90,0x90,0x90,0xe0,0x00,
+
+        5, // 0x45 'E'
+        0x00,0xf0,0x80,0x80,0xe0,0x80,0x80,0xf0,0x00,
+
+        5, // 0x46 'F'
+        0x00,0xf0,0x80,0x80,0xe0,0x80,0x80,0x80,0x00,
+
+        5, // 0x47 'G'
+        0x00,0x60,0x90,0x80,0xb0,0x90,0x90,0x60,0x00,
+
+        5, // 0x48 'H'
+        0x00,0x90,0x90,0x90,0xf0,0x90,0x90,0x90,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x4a 'J'
+        0x00,0x70,0x20,0x20,0x20,0x20,0xa0,0x40,0x00,
+
+        5, // 0x4b 'K'
+        0x00,0x90,0x90,0xa0,0xc0,0xa0,0x90,0x90,0x00,
+
+        5, // 0x4c 'L'
+        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xf0,0x00,
+
+        5, // 0x4d 'M'
+        0x00,0x90,0xf0,0x90,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x4e 'N'
+        0x00,0x90,0x90,0xd0,0xb0,0x90,0x90,0x90,0x00,
+
+        5, // 0x4f 'O'
+        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x50 'P'
+        0x00,0xe0,0x90,0x90,0xe0,0x80,0x80,0x80,0x00,
+
+        5, // 0x51 'Q'
+        0x00,0x60,0x90,0x90,0x90,0x90,0xa0,0x50,0x00,
+
+        5, // 0x52 'R'
+        0x00,0xe0,0x90,0x90,0xe0,0xa0,0x90,0x90,0x00,
+
+        5, // 0x53 'S'
+        0x00,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x00,
+
+        5, // 0x54 'T'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x55 'U'
+        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x56 'V'
+        0x00,0x50,0x50,0x50,0x50,0x50,0x20,0x20,0x00,
+
+        5, // 0x57 'W'
+        0x00,0x90,0x90,0x90,0x90,0x90,0xf0,0x90,0x00,
+
+        5, // 0x58 'X'
+        0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,
+
+        5, // 0x59 'Y'
+        0x00,0x50,0x50,0x50,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x5a 'Z'
+        0x00,0xf0,0x10,0x10,0x20,0x40,0x80,0xf0,0x00,
+
+        5, // 0x5b '['
+        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,
+
+        5, // 0x5c '\'
+        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x00,
+
+        5, // 0x5d ']'
+        0xe0,0x20,0x20,0x20,0x20,0x20,0x20,0xe0,0x00,
+
+        5, // 0x5e '^'
+        0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,
+
+        5, // 0x60 '`'
+        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x61 'a'
+        0x00,0x00,0x60,0x10,0x70,0x90,0x90,0x70,0x00,
+
+        5, // 0x62 'b'
+        0x00,0x80,0x80,0xe0,0x90,0x90,0x90,0xe0,0x00,
+
+        5, // 0x63 'c'
+        0x00,0x00,0x60,0x90,0x80,0x80,0x90,0x60,0x00,
+
+        5, // 0x64 'd'
+        0x00,0x10,0x10,0x70,0x90,0x90,0x90,0x70,0x00,
+
+        5, // 0x65 'e'
+        0x00,0x00,0x60,0x90,0xf0,0x80,0x80,0x70,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x30,0x40,0x40,0xe0,0x40,0x40,0x40,0x00,
+
+        5, // 0x67 'g'
+        0x00,0x00,0x70,0x90,0x90,0x70,0x10,0x90,0x60,
+
+        5, // 0x68 'h'
+        0x00,0x80,0x80,0xe0,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x69 'i'
+        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x6a 'j'
+        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0xa0,0x40,
+
+        5, // 0x6b 'k'
+        0x00,0x80,0x80,0x90,0xa0,0xc0,0xa0,0x90,0x00,
+
+        5, // 0x6c 'l'
+        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x6d 'm'
+        0x00,0x00,0xa0,0xf0,0xf0,0xf0,0x90,0x90,0x00,
+
+        5, // 0x6e 'n'
+        0x00,0x00,0xa0,0xd0,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x6f 'o'
+        0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x70 'p'
+        0x00,0x00,0xe0,0x90,0x90,0x90,0xe0,0x80,0x80,
+
+        5, // 0x71 'q'
+        0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0x10,
+
+        5, // 0x72 'r'
+        0x00,0x00,0xe0,0x90,0x80,0x80,0x80,0x80,0x00,
+
+        5, // 0x73 's'
+        0x00,0x00,0x60,0x90,0x40,0x20,0x90,0x60,0x00,
+
+        5, // 0x74 't'
+        0x00,0x40,0x40,0xe0,0x40,0x40,0x50,0x20,0x00,
+
+        5, // 0x75 'u'
+        0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x00,
+
+        5, // 0x76 'v'
+        0x00,0x00,0x50,0x50,0x50,0x50,0x20,0x20,0x00,
+
+        5, // 0x77 'w'
+        0x00,0x00,0x90,0x90,0x90,0x90,0xf0,0x90,0x00,
+
+        5, // 0x78 'x'
+        0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x00,
+
+        5, // 0x79 'y'
+        0x00,0x00,0x90,0x90,0x90,0x90,0x70,0x10,0xe0,
+
+        5, // 0x7a 'z'
+        0x00,0x00,0xf0,0x10,0x20,0x40,0x80,0xf0,0x00,
+
+        5, // 0x7b '{'
+        0x10,0x20,0x20,0x20,0xc0,0x20,0x20,0x20,0x10,
+
+        5, // 0x7c '|'
+        0x00,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00,
+
+        5, // 0x7d '}'
+        0x80,0x40,0x40,0x40,0x30,0x40,0x40,0x40,0x80,
+
+        5, // 0x7e '~'
+        0x00,0x40,0xa8,0x10,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x7f ''
+        0x00,0x00,0x00,0x20,0x50,0x88,0xf8,0x00,0x00,
+        0
+    };
+
+    const int8u gse6x12[] = 
+    {
+        12, 0, 32, 128-32,
+
+        0x00,0x00,0x0d,0x00,0x1a,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4e,0x00,0x5b,0x00,0x68,0x00,
+        0x75,0x00,0x82,0x00,0x8f,0x00,0x9c,0x00,0xa9,0x00,0xb6,0x00,0xc3,0x00,0xd0,0x00,0xdd,0x00,
+        0xea,0x00,0xf7,0x00,0x04,0x01,0x11,0x01,0x1e,0x01,0x2b,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
+        0x5f,0x01,0x6c,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xa0,0x01,0xad,0x01,0xba,0x01,0xc7,0x01,
+        0xd4,0x01,0xe1,0x01,0xee,0x01,0xfb,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2f,0x02,0x3c,0x02,
+        0x49,0x02,0x56,0x02,0x63,0x02,0x70,0x02,0x7d,0x02,0x8a,0x02,0x97,0x02,0xa4,0x02,0xb1,0x02,
+        0xbe,0x02,0xcb,0x02,0xd8,0x02,0xe5,0x02,0xf2,0x02,0xff,0x02,0x0c,0x03,0x19,0x03,0x26,0x03,
+        0x33,0x03,0x40,0x03,0x4d,0x03,0x5a,0x03,0x67,0x03,0x74,0x03,0x81,0x03,0x8e,0x03,0x9b,0x03,
+        0xa8,0x03,0xb5,0x03,0xc2,0x03,0xcf,0x03,0xdc,0x03,0xe9,0x03,0xf6,0x03,0x03,0x04,0x10,0x04,
+        0x1d,0x04,0x2a,0x04,0x37,0x04,0x44,0x04,0x51,0x04,0x5e,0x04,0x6b,0x04,0x78,0x04,0x85,0x04,
+        0x92,0x04,0x9f,0x04,0xac,0x04,0xb9,0x04,0xc6,0x04,0xd3,0x04,
+
+        6, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        6, // 0x22 '"'
+        0x00,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x23 '#'
+        0x00,0x50,0x50,0xf8,0x50,0x50,0x50,0xf8,0x50,0x50,0x00,0x00,
+
+        6, // 0x24 '$'
+        0x00,0x20,0x70,0xa8,0xa0,0x70,0x28,0xa8,0x70,0x20,0x00,0x00,
+
+        6, // 0x25 '%'
+        0x00,0xc8,0xd8,0x10,0x30,0x20,0x60,0x40,0xd8,0x98,0x00,0x00,
+
+        6, // 0x26 '&'
+        0x00,0x60,0x90,0x90,0x90,0x60,0xa8,0x90,0x90,0x68,0x00,0x00,
+
+        6, // 0x27 '''
+        0x00,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x28 '('
+        0x00,0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x10,0x00,0x00,
+
+        6, // 0x29 ')'
+        0x00,0x40,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x40,0x00,0x00,
+
+        6, // 0x2a '*'
+        0x00,0x00,0x00,0x50,0x20,0xf8,0x20,0x50,0x00,0x00,0x00,0x00,
+
+        6, // 0x2b '+'
+        0x00,0x00,0x20,0x20,0x20,0xf8,0x20,0x20,0x20,0x00,0x00,0x00,
+
+        6, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
+
+        6, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0x00,0xf8,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x00,
+
+        6, // 0x2f '/'
+        0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,0x00,
+
+        6, // 0x30 '0'
+        0x00,0x70,0x88,0x88,0x98,0xa8,0xc8,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x31 '1'
+        0x00,0x20,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        6, // 0x32 '2'
+        0x00,0x70,0x88,0x88,0x08,0x10,0x20,0x40,0x80,0xf8,0x00,0x00,
+
+        6, // 0x33 '3'
+        0x00,0xf8,0x10,0x20,0x70,0x08,0x08,0x08,0x88,0x70,0x00,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x10,0x20,0x40,0x90,0x90,0xf8,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x35 '5'
+        0x00,0xf8,0x80,0x80,0xf0,0x08,0x08,0x08,0x88,0x70,0x00,0x00,
+
+        6, // 0x36 '6'
+        0x00,0x70,0x88,0x80,0x80,0xf0,0x88,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x37 '7'
+        0x00,0xf8,0x88,0x08,0x08,0x10,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        6, // 0x38 '8'
+        0x00,0x70,0x88,0x88,0x88,0x70,0x88,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x39 '9'
+        0x00,0x70,0x88,0x88,0x88,0x78,0x08,0x08,0x88,0x70,0x00,0x00,
+
+        6, // 0x3a ':'
+        0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,
+
+        6, // 0x3b ';'
+        0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
+
+        6, // 0x3c '<'
+        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x00,0x00,
+
+        6, // 0x3d '='
+        0x00,0x00,0x00,0x00,0xf8,0x00,0xf8,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x3e '>'
+        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,0x00,0x00,
+
+        6, // 0x3f '?'
+        0x00,0x70,0x88,0x88,0x08,0x10,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        6, // 0x40 '@'
+        0x00,0x70,0x88,0x88,0xb8,0xb8,0xb0,0x80,0x88,0x70,0x00,0x00,
+
+        6, // 0x41 'A'
+        0x00,0x20,0x50,0x88,0x88,0x88,0xf8,0x88,0x88,0x88,0x00,0x00,
+
+        6, // 0x42 'B'
+        0x00,0xf0,0x88,0x88,0x88,0xf0,0x88,0x88,0x88,0xf0,0x00,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x70,0x88,0x88,0x80,0x80,0x80,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x44 'D'
+        0x00,0xe0,0x90,0x88,0x88,0x88,0x88,0x88,0x90,0xe0,0x00,0x00,
+
+        6, // 0x45 'E'
+        0x00,0xf8,0x80,0x80,0x80,0xf0,0x80,0x80,0x80,0xf8,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0xf8,0x80,0x80,0x80,0xf0,0x80,0x80,0x80,0x80,0x00,0x00,
+
+        6, // 0x47 'G'
+        0x00,0x70,0x88,0x80,0x80,0xb8,0x88,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x48 'H'
+        0x00,0x88,0x88,0x88,0x88,0xf8,0x88,0x88,0x88,0x88,0x00,0x00,
+
+        6, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        6, // 0x4a 'J'
+        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x90,0x60,0x00,0x00,
+
+        6, // 0x4b 'K'
+        0x00,0x88,0x88,0x90,0xa0,0xc0,0xa0,0x90,0x88,0x88,0x00,0x00,
+
+        6, // 0x4c 'L'
+        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xf8,0x00,0x00,
+
+        6, // 0x4d 'M'
+        0x00,0x88,0x88,0xd8,0xa8,0x88,0x88,0x88,0x88,0x88,0x00,0x00,
+
+        6, // 0x4e 'N'
+        0x00,0x88,0x88,0xc8,0xa8,0x98,0x88,0x88,0x88,0x88,0x00,0x00,
+
+        6, // 0x4f 'O'
+        0x00,0x70,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x50 'P'
+        0x00,0xf0,0x88,0x88,0x88,0xf0,0x80,0x80,0x80,0x80,0x00,0x00,
+
+        6, // 0x51 'Q'
+        0x00,0x70,0x88,0x88,0x88,0x88,0x88,0xa8,0x90,0x68,0x00,0x00,
+
+        6, // 0x52 'R'
+        0x00,0xf0,0x88,0x88,0x88,0x88,0xf0,0xa0,0x90,0x88,0x00,0x00,
+
+        6, // 0x53 'S'
+        0x00,0x70,0x88,0x80,0x80,0x70,0x08,0x08,0x88,0x70,0x00,0x00,
+
+        6, // 0x54 'T'
+        0x00,0xf8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        6, // 0x55 'U'
+        0x00,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x88,0x88,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,0x00,
+
+        6, // 0x57 'W'
+        0x00,0x88,0x88,0x88,0x88,0x88,0xa8,0xa8,0xd8,0x88,0x00,0x00,
+
+        6, // 0x58 'X'
+        0x00,0x88,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x88,0x00,0x00,
+
+        6, // 0x59 'Y'
+        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        6, // 0x5a 'Z'
+        0x00,0xf8,0x08,0x08,0x10,0x20,0x40,0x80,0x80,0xf8,0x00,0x00,
+
+        6, // 0x5b '['
+        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,
+
+        6, // 0x5c '\'
+        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,0x00,
+
+        6, // 0x5d ']'
+        0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,0x00,
+
+        6, // 0x5e '^'
+        0x00,0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,0x00,
+
+        6, // 0x60 '`'
+        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x61 'a'
+        0x00,0x00,0x00,0x70,0x88,0x08,0x78,0x88,0x88,0x78,0x00,0x00,
+
+        6, // 0x62 'b'
+        0x00,0x80,0x80,0x80,0xf0,0x88,0x88,0x88,0x88,0xf0,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x70,0x88,0x80,0x80,0x80,0x88,0x70,0x00,0x00,
+
+        6, // 0x64 'd'
+        0x00,0x08,0x08,0x08,0x78,0x88,0x88,0x88,0x88,0x78,0x00,0x00,
+
+        6, // 0x65 'e'
+        0x00,0x00,0x00,0x70,0x88,0x88,0xf8,0x80,0x80,0x78,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x18,0x20,0x20,0xf8,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        6, // 0x67 'g'
+        0x00,0x00,0x00,0x78,0x88,0x88,0x88,0x88,0x78,0x08,0x08,0xf0,
+
+        6, // 0x68 'h'
+        0x00,0x80,0x80,0x80,0xf0,0x88,0x88,0x88,0x88,0x88,0x00,0x00,
+
+        6, // 0x69 'i'
+        0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        6, // 0x6a 'j'
+        0x00,0x10,0x00,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x90,0x60,
+
+        6, // 0x6b 'k'
+        0x00,0x80,0x80,0x80,0x88,0x90,0xa0,0xd0,0x88,0x88,0x00,0x00,
+
+        6, // 0x6c 'l'
+        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        6, // 0x6d 'm'
+        0x00,0x00,0x00,0xd0,0xa8,0xa8,0xa8,0xa8,0xa8,0xa8,0x00,0x00,
+
+        6, // 0x6e 'n'
+        0x00,0x00,0x00,0xb0,0xc8,0x88,0x88,0x88,0x88,0x88,0x00,0x00,
+
+        6, // 0x6f 'o'
+        0x00,0x00,0x00,0x70,0x88,0x88,0x88,0x88,0x88,0x70,0x00,0x00,
+
+        6, // 0x70 'p'
+        0x00,0x00,0x00,0xf0,0x88,0x88,0x88,0x88,0xf0,0x80,0x80,0x80,
+
+        6, // 0x71 'q'
+        0x00,0x00,0x00,0x78,0x88,0x88,0x88,0x88,0x78,0x08,0x08,0x08,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0xb0,0xc8,0x88,0x80,0x80,0x80,0x80,0x00,0x00,
+
+        6, // 0x73 's'
+        0x00,0x00,0x00,0x70,0x88,0x80,0x70,0x08,0x88,0x70,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x40,0x40,0x40,0xe0,0x40,0x40,0x40,0x48,0x30,0x00,0x00,
+
+        6, // 0x75 'u'
+        0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x88,0x88,0x78,0x00,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,0x00,
+
+        6, // 0x77 'w'
+        0x00,0x00,0x00,0x88,0x88,0x88,0xa8,0xa8,0xd8,0x88,0x00,0x00,
+
+        6, // 0x78 'x'
+        0x00,0x00,0x00,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x00,0x00,
+
+        6, // 0x79 'y'
+        0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x88,0x78,0x08,0x10,0xe0,
+
+        6, // 0x7a 'z'
+        0x00,0x00,0x00,0xf8,0x08,0x10,0x20,0x40,0x80,0xf8,0x00,0x00,
+
+        6, // 0x7b '{'
+        0x18,0x20,0x20,0x20,0x20,0xc0,0x20,0x20,0x20,0x20,0x18,0x00,
+
+        6, // 0x7c '|'
+        0x00,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        6, // 0x7d '}'
+        0xc0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xc0,0x00,
+
+        6, // 0x7e '~'
+        0x00,0x00,0x40,0xa8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x7f ''
+        0x00,0x00,0x00,0x00,0x20,0x50,0x88,0xf8,0x00,0x00,0x00,0x00,
+        0
+    };
+
+    const int8u gse6x9[] = 
+    {
+        9, 0, 32, 128-32,
+
+        0x00,0x00,0x0a,0x00,0x14,0x00,0x1e,0x00,0x28,0x00,0x32,0x00,0x3c,0x00,0x46,0x00,0x50,0x00,
+        0x5a,0x00,0x64,0x00,0x6e,0x00,0x78,0x00,0x82,0x00,0x8c,0x00,0x96,0x00,0xa0,0x00,0xaa,0x00,
+        0xb4,0x00,0xbe,0x00,0xc8,0x00,0xd2,0x00,0xdc,0x00,0xe6,0x00,0xf0,0x00,0xfa,0x00,0x04,0x01,
+        0x0e,0x01,0x18,0x01,0x22,0x01,0x2c,0x01,0x36,0x01,0x40,0x01,0x4a,0x01,0x54,0x01,0x5e,0x01,
+        0x68,0x01,0x72,0x01,0x7c,0x01,0x86,0x01,0x90,0x01,0x9a,0x01,0xa4,0x01,0xae,0x01,0xb8,0x01,
+        0xc2,0x01,0xcc,0x01,0xd6,0x01,0xe0,0x01,0xea,0x01,0xf4,0x01,0xfe,0x01,0x08,0x02,0x12,0x02,
+        0x1c,0x02,0x26,0x02,0x30,0x02,0x3a,0x02,0x44,0x02,0x4e,0x02,0x58,0x02,0x62,0x02,0x6c,0x02,
+        0x76,0x02,0x80,0x02,0x8a,0x02,0x94,0x02,0x9e,0x02,0xa8,0x02,0xb2,0x02,0xbc,0x02,0xc6,0x02,
+        0xd0,0x02,0xda,0x02,0xe4,0x02,0xee,0x02,0xf8,0x02,0x02,0x03,0x0c,0x03,0x16,0x03,0x20,0x03,
+        0x2a,0x03,0x34,0x03,0x3e,0x03,0x48,0x03,0x52,0x03,0x5c,0x03,0x66,0x03,0x70,0x03,0x7a,0x03,
+        0x84,0x03,0x8e,0x03,0x98,0x03,0xa2,0x03,0xac,0x03,0xb6,0x03,
+
+        6, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
+
+        6, // 0x22 '"'
+        0x00,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x23 '#'
+        0x00,0x50,0x50,0xf8,0x50,0xf8,0x50,0x50,0x00,
+
+        6, // 0x24 '$'
+        0x00,0x70,0xa8,0xa0,0x70,0x28,0xa8,0x70,0x00,
+
+        6, // 0x25 '%'
+        0x00,0xc8,0xc8,0x10,0x20,0x40,0x98,0x98,0x00,
+
+        6, // 0x26 '&'
+        0x00,0x60,0x90,0x90,0x60,0xa8,0x90,0x68,0x00,
+
+        6, // 0x27 '''
+        0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x28 '('
+        0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x10,
+
+        6, // 0x29 ')'
+        0x40,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x40,
+
+        6, // 0x2a '*'
+        0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,
+
+        6, // 0x2b '+'
+        0x00,0x00,0x20,0x20,0xf8,0x20,0x20,0x00,0x00,
+
+        6, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x40,
+
+        6, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0xf8,0x00,0x00,0x00,0x00,
+
+        6, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,
+
+        6, // 0x2f '/'
+        0x00,0x08,0x08,0x10,0x20,0x40,0x80,0x80,0x00,
+
+        6, // 0x30 '0'
+        0x00,0x70,0x88,0x98,0xa8,0xc8,0x88,0x70,0x00,
+
+        6, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        6, // 0x32 '2'
+        0x00,0x70,0x88,0x08,0x10,0x20,0x40,0xf8,0x00,
+
+        6, // 0x33 '3'
+        0x00,0xf8,0x10,0x20,0x70,0x08,0x88,0x70,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x10,0x20,0x40,0x90,0xf8,0x10,0x10,0x00,
+
+        6, // 0x35 '5'
+        0x00,0xf8,0x80,0xf0,0x08,0x08,0x88,0x70,0x00,
+
+        6, // 0x36 '6'
+        0x00,0x70,0x88,0x80,0xf0,0x88,0x88,0x70,0x00,
+
+        6, // 0x37 '7'
+        0x00,0xf8,0x08,0x08,0x10,0x20,0x40,0x40,0x00,
+
+        6, // 0x38 '8'
+        0x00,0x70,0x88,0x88,0x70,0x88,0x88,0x70,0x00,
+
+        6, // 0x39 '9'
+        0x00,0x70,0x88,0x88,0x78,0x08,0x88,0x70,0x00,
+
+        6, // 0x3a ':'
+        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x00,0x00,
+
+        6, // 0x3b ';'
+        0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x20,0x40,
+
+        6, // 0x3c '<'
+        0x00,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x00,
+
+        6, // 0x3d '='
+        0x00,0x00,0x00,0xf8,0x00,0xf8,0x00,0x00,0x00,
+
+        6, // 0x3e '>'
+        0x00,0x80,0x40,0x20,0x10,0x20,0x40,0x80,0x00,
+
+        6, // 0x3f '?'
+        0x00,0x70,0x88,0x08,0x10,0x20,0x00,0x20,0x00,
+
+        6, // 0x40 '@'
+        0x00,0x70,0x88,0x88,0xb8,0xb8,0x80,0x70,0x00,
+
+        6, // 0x41 'A'
+        0x00,0x20,0x50,0x88,0x88,0xf8,0x88,0x88,0x00,
+
+        6, // 0x42 'B'
+        0x00,0xf0,0x88,0x88,0xf0,0x88,0x88,0xf0,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x70,0x88,0x80,0x80,0x80,0x88,0x70,0x00,
+
+        6, // 0x44 'D'
+        0x00,0xe0,0x90,0x88,0x88,0x88,0x90,0xe0,0x00,
+
+        6, // 0x45 'E'
+        0x00,0xf8,0x80,0x80,0xf0,0x80,0x80,0xf8,0x00,
+
+        6, // 0x46 'F'
+        0x00,0xf8,0x80,0x80,0xf0,0x80,0x80,0x80,0x00,
+
+        6, // 0x47 'G'
+        0x00,0x70,0x88,0x80,0xb8,0x88,0x88,0x70,0x00,
+
+        6, // 0x48 'H'
+        0x00,0x88,0x88,0x88,0xf8,0x88,0x88,0x88,0x00,
+
+        6, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        6, // 0x4a 'J'
+        0x00,0x38,0x10,0x10,0x10,0x10,0x90,0x60,0x00,
+
+        6, // 0x4b 'K'
+        0x00,0x88,0x90,0xa0,0xc0,0xa0,0x90,0x88,0x00,
+
+        6, // 0x4c 'L'
+        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xf8,0x00,
+
+        6, // 0x4d 'M'
+        0x00,0x88,0xd8,0xa8,0x88,0x88,0x88,0x88,0x00,
+
+        6, // 0x4e 'N'
+        0x00,0x88,0x88,0xc8,0xa8,0x98,0x88,0x88,0x00,
+
+        6, // 0x4f 'O'
+        0x00,0x70,0x88,0x88,0x88,0x88,0x88,0x70,0x00,
+
+        6, // 0x50 'P'
+        0x00,0xf0,0x88,0x88,0xf0,0x80,0x80,0x80,0x00,
+
+        6, // 0x51 'Q'
+        0x00,0x70,0x88,0x88,0x88,0xa8,0x90,0x68,0x00,
+
+        6, // 0x52 'R'
+        0x00,0xf0,0x88,0x88,0x88,0xf0,0x90,0x88,0x00,
+
+        6, // 0x53 'S'
+        0x00,0x70,0x88,0x80,0x70,0x08,0x88,0x70,0x00,
+
+        6, // 0x54 'T'
+        0x00,0xf8,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        6, // 0x55 'U'
+        0x00,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,
+
+        6, // 0x57 'W'
+        0x00,0x88,0x88,0x88,0xa8,0xa8,0xd8,0x88,0x00,
+
+        6, // 0x58 'X'
+        0x00,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x00,
+
+        6, // 0x59 'Y'
+        0x00,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x00,
+
+        6, // 0x5a 'Z'
+        0x00,0xf8,0x08,0x10,0x20,0x40,0x80,0xf8,0x00,
+
+        6, // 0x5b '['
+        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,
+
+        6, // 0x5c '\'
+        0x00,0x80,0x80,0x40,0x20,0x10,0x08,0x08,0x00,
+
+        6, // 0x5d ']'
+        0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,
+
+        6, // 0x5e '^'
+        0x00,0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,
+
+        6, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,
+
+        6, // 0x60 '`'
+        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x61 'a'
+        0x00,0x00,0x00,0x70,0x08,0x78,0x88,0x78,0x00,
+
+        6, // 0x62 'b'
+        0x00,0x80,0x80,0xf0,0x88,0x88,0x88,0xf0,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x70,0x88,0x80,0x88,0x70,0x00,
+
+        6, // 0x64 'd'
+        0x00,0x08,0x08,0x78,0x88,0x88,0x88,0x78,0x00,
+
+        6, // 0x65 'e'
+        0x00,0x00,0x00,0x70,0x88,0xf8,0x80,0x78,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x18,0x20,0x20,0xf8,0x20,0x20,0x20,0x00,
+
+        6, // 0x67 'g'
+        0x00,0x00,0x00,0x78,0x88,0x88,0x78,0x08,0x70,
+
+        6, // 0x68 'h'
+        0x00,0x80,0x80,0xf0,0x88,0x88,0x88,0x88,0x00,
+
+        6, // 0x69 'i'
+        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x70,0x00,
+
+        6, // 0x6a 'j'
+        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x90,0x60,
+
+        6, // 0x6b 'k'
+        0x00,0x00,0x80,0x88,0x90,0xa0,0xd0,0x88,0x00,
+
+        6, // 0x6c 'l'
+        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        6, // 0x6d 'm'
+        0x00,0x00,0x00,0xd0,0xa8,0xa8,0xa8,0xa8,0x00,
+
+        6, // 0x6e 'n'
+        0x00,0x00,0x00,0xb0,0xc8,0x88,0x88,0x88,0x00,
+
+        6, // 0x6f 'o'
+        0x00,0x00,0x00,0x70,0x88,0x88,0x88,0x70,0x00,
+
+        6, // 0x70 'p'
+        0x00,0x00,0x00,0xf0,0x88,0x88,0xf0,0x80,0x80,
+
+        6, // 0x71 'q'
+        0x00,0x00,0x00,0x78,0x88,0x88,0x78,0x08,0x08,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0xb8,0xc0,0x80,0x80,0x80,0x00,
+
+        6, // 0x73 's'
+        0x00,0x00,0x00,0x78,0x80,0x70,0x08,0xf0,0x00,
+
+        6, // 0x74 't'
+        0x00,0x40,0x40,0xe0,0x40,0x40,0x48,0x30,0x00,
+
+        6, // 0x75 'u'
+        0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x78,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x20,0x00,
+
+        6, // 0x77 'w'
+        0x00,0x00,0x00,0x88,0x88,0xa8,0xd8,0x88,0x00,
+
+        6, // 0x78 'x'
+        0x00,0x00,0x00,0x88,0x50,0x20,0x50,0x88,0x00,
+
+        6, // 0x79 'y'
+        0x00,0x00,0x00,0x88,0x88,0x88,0x78,0x08,0x70,
+
+        6, // 0x7a 'z'
+        0x00,0x00,0x00,0xf8,0x10,0x20,0x40,0xf8,0x00,
+
+        6, // 0x7b '{'
+        0x18,0x20,0x20,0x20,0xc0,0x20,0x20,0x20,0x18,
+
+        6, // 0x7c '|'
+        0x00,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00,
+
+        6, // 0x7d '}'
+        0xc0,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0xc0,
+
+        6, // 0x7e '~'
+        0x00,0x40,0xa8,0x10,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x7f ''
+        0x00,0x00,0x00,0x20,0x50,0x88,0xf8,0x00,0x00,
+        0
+    };
+
+    const int8u gse7x11[] = 
+    {
+        11, 0, 32, 128-32,
+
+        0x00,0x00,0x0c,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3c,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
+        0x6c,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9c,0x00,0xa8,0x00,0xb4,0x00,0xc0,0x00,0xcc,0x00,
+        0xd8,0x00,0xe4,0x00,0xf0,0x00,0xfc,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2c,0x01,0x38,0x01,
+        0x44,0x01,0x50,0x01,0x5c,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8c,0x01,0x98,0x01,0xa4,0x01,
+        0xb0,0x01,0xbc,0x01,0xc8,0x01,0xd4,0x01,0xe0,0x01,0xec,0x01,0xf8,0x01,0x04,0x02,0x10,0x02,
+        0x1c,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4c,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7c,0x02,
+        0x88,0x02,0x94,0x02,0xa0,0x02,0xac,0x02,0xb8,0x02,0xc4,0x02,0xd0,0x02,0xdc,0x02,0xe8,0x02,
+        0xf4,0x02,0x00,0x03,0x0c,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3c,0x03,0x48,0x03,0x54,0x03,
+        0x60,0x03,0x6c,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9c,0x03,0xa8,0x03,0xb4,0x03,0xc0,0x03,
+        0xcc,0x03,0xd8,0x03,0xe4,0x03,0xf0,0x03,0xfc,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2c,0x04,
+        0x38,0x04,0x44,0x04,0x50,0x04,0x5c,0x04,0x68,0x04,0x74,0x04,
+
+        7, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x21 '!'
+        0x00,0x10,0x38,0x38,0x38,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x00,0x24,0x24,0x24,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x23 '#'
+        0x00,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x00,0x00,
+
+        7, // 0x24 '$'
+        0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,
+
+        7, // 0x25 '%'
+        0x00,0x00,0x42,0xa4,0x48,0x10,0x24,0x4a,0x84,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x30,0x48,0x48,0x30,0x60,0x94,0x98,0x6c,0x00,0x00,
+
+        7, // 0x27 '''
+        0x00,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x00,0x04,0x08,0x10,0x10,0x10,0x10,0x08,0x04,0x00,0x00,
+
+        7, // 0x29 ')'
+        0x00,0x40,0x20,0x10,0x10,0x10,0x10,0x20,0x40,0x00,0x00,
+
+        7, // 0x2a '*'
+        0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,
+
+        7, // 0x2b '+'
+        0x00,0x00,0x00,0x10,0x10,0x7c,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,
+
+        7, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        7, // 0x2f '/'
+        0x00,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x38,0x44,0x4c,0x54,0x64,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x7c,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x38,0x44,0x04,0x08,0x10,0x20,0x44,0x7c,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x7c,0x48,0x10,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x08,0x10,0x20,0x48,0x48,0x7c,0x08,0x1c,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x7c,0x40,0x40,0x78,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x18,0x20,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0x7c,0x44,0x04,0x08,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x44,0x3c,0x04,0x08,0x30,0x00,0x00,
+
+        7, // 0x3a ':'
+        0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x30,0x00,0x00,0x00,
+
+        7, // 0x3b ';'
+        0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x30,0x30,0x60,0x00,
+
+        7, // 0x3c '<'
+        0x00,0x00,0x04,0x08,0x10,0x20,0x10,0x08,0x04,0x00,0x00,
+
+        7, // 0x3d '='
+        0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,
+
+        7, // 0x3e '>'
+        0x00,0x00,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x00,0x00,
+
+        7, // 0x3f '?'
+        0x00,0x70,0x88,0x88,0x10,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x30,0x48,0x04,0x34,0x54,0x54,0x54,0x28,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x10,0x28,0x44,0x44,0x7c,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        7, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0x7c,0x40,0x40,0x70,0x40,0x40,0x40,0x7c,0x00,0x00,
+
+        7, // 0x46 'F'
+        0x00,0x7c,0x40,0x40,0x70,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x40,0x5c,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x7c,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x49 'I'
+        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x4a 'J'
+        0x00,0x1c,0x08,0x08,0x08,0x08,0x08,0x48,0x30,0x00,0x00,
+
+        7, // 0x4b 'K'
+        0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
+
+        7, // 0x4c 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7c,0x00,0x00,
+
+        7, // 0x4d 'M'
+        0x00,0x44,0x6c,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x4e 'N'
+        0x00,0x44,0x44,0x64,0x54,0x4c,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x4f 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x50,0x48,0x44,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x7c,0x54,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        7, // 0x57 'W'
+        0x00,0x44,0x44,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x5a 'Z'
+        0x00,0x7c,0x04,0x08,0x10,0x20,0x40,0x44,0x7c,0x00,0x00,
+
+        7, // 0x5b '['
+        0x00,0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,0x00,
+
+        7, // 0x5c '\'
+        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,0x00,
+
+        7, // 0x5d ']'
+        0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,0x00,
+
+        7, // 0x5e '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,
+
+        7, // 0x60 '`'
+        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3c,0x44,0x44,0x3c,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x04,0x04,0x3c,0x44,0x44,0x44,0x44,0x3c,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x7c,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x66 'f'
+        0x00,0x18,0x24,0x20,0x70,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x3c,0x44,0x44,0x44,0x3c,0x04,0x44,0x38,
+
+        7, // 0x68 'h'
+        0x00,0x40,0x40,0x40,0x58,0x64,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x69 'i'
+        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x6a 'j'
+        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x48,0x30,0x00,
+
+        7, // 0x6b 'k'
+        0x00,0x40,0x40,0x44,0x48,0x50,0x68,0x44,0x44,0x00,0x00,
+
+        7, // 0x6c 'l'
+        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x6d 'm'
+        0x00,0x00,0x00,0xa8,0x54,0x54,0x54,0x54,0x54,0x00,0x00,
+
+        7, // 0x6e 'n'
+        0x00,0x00,0x00,0xb8,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x6f 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x3c,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x64,0x44,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x3c,0x40,0x38,0x04,0x04,0x78,0x00,0x00,
+
+        7, // 0x74 't'
+        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x24,0x18,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3a,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x00,0x00,
+
+        7, // 0x77 'w'
+        0x00,0x00,0x00,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x3c,0x04,0x08,0x30,0x00,
+
+        7, // 0x7a 'z'
+        0x00,0x00,0x00,0x7c,0x08,0x10,0x20,0x44,0x7c,0x00,0x00,
+
+        7, // 0x7b '{'
+        0x00,0x0c,0x10,0x10,0x10,0x60,0x10,0x10,0x0c,0x00,0x00,
+
+        7, // 0x7c '|'
+        0x00,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        7, // 0x7d '}'
+        0x00,0x60,0x10,0x10,0x10,0x0c,0x10,0x10,0x60,0x00,0x00,
+
+        7, // 0x7e '~'
+        0x00,0x00,0x64,0x98,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7f ''
+        0x00,0x00,0x00,0x10,0x28,0x44,0x44,0x7c,0x00,0x00,0x00,
+        0
+    };
+
+    const int8u gse7x11_bold[] = 
+    {
+        11, 0, 32, 128-32,
+
+        0x00,0x00,0x0c,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3c,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
+        0x6c,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9c,0x00,0xa8,0x00,0xb4,0x00,0xc0,0x00,0xcc,0x00,
+        0xd8,0x00,0xe4,0x00,0xf0,0x00,0xfc,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2c,0x01,0x38,0x01,
+        0x44,0x01,0x50,0x01,0x5c,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8c,0x01,0x98,0x01,0xa4,0x01,
+        0xb0,0x01,0xbc,0x01,0xc8,0x01,0xd4,0x01,0xe0,0x01,0xec,0x01,0xf8,0x01,0x04,0x02,0x10,0x02,
+        0x1c,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4c,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7c,0x02,
+        0x88,0x02,0x94,0x02,0xa0,0x02,0xac,0x02,0xb8,0x02,0xc4,0x02,0xd0,0x02,0xdc,0x02,0xe8,0x02,
+        0xf4,0x02,0x00,0x03,0x0c,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3c,0x03,0x48,0x03,0x54,0x03,
+        0x60,0x03,0x6c,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9c,0x03,0xa8,0x03,0xb4,0x03,0xc0,0x03,
+        0xcc,0x03,0xd8,0x03,0xe4,0x03,0xf0,0x03,0xfc,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2c,0x04,
+        0x38,0x04,0x44,0x04,0x50,0x04,0x5c,0x04,0x68,0x04,0x74,0x04,
+
+        7, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x21 '!'
+        0x00,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x6c,0x6c,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x23 '#'
+        0x00,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x00,0x00,
+
+        7, // 0x24 '$'
+        0x30,0x30,0x78,0xcc,0xc0,0x78,0x0c,0xcc,0x78,0x30,0x30,
+
+        7, // 0x25 '%'
+        0x00,0x00,0xc4,0x0c,0x18,0x30,0x60,0xc0,0x8c,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x30,0x58,0x58,0x30,0x74,0xdc,0xd8,0x6c,0x00,0x00,
+
+        7, // 0x27 '''
+        0x00,0x30,0x30,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x00,0x0c,0x18,0x30,0x30,0x30,0x30,0x18,0x0c,0x00,0x00,
+
+        7, // 0x29 ')'
+        0x00,0xc0,0x60,0x30,0x30,0x30,0x30,0x60,0xc0,0x00,0x00,
+
+        7, // 0x2a '*'
+        0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,
+
+        7, // 0x2b '+'
+        0x00,0x00,0x00,0x30,0x30,0xfc,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x60,0x00,
+
+        7, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        7, // 0x2f '/'
+        0x00,0x0c,0x0c,0x18,0x18,0x30,0x30,0x60,0x60,0x00,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x78,0xcc,0xcc,0xdc,0xec,0xcc,0xcc,0x78,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x30,0x70,0xf0,0x30,0x30,0x30,0x30,0xfc,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x78,0xcc,0xcc,0x18,0x30,0x60,0xcc,0xfc,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0xfc,0x98,0x30,0x78,0x0c,0x0c,0xcc,0x78,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x18,0x30,0x68,0xd8,0xd8,0xfc,0x18,0x3c,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0xfc,0xc0,0xc0,0xf8,0x0c,0x0c,0xcc,0x78,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x38,0x60,0xc0,0xf8,0xcc,0xcc,0xcc,0x78,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0xfc,0x8c,0x0c,0x18,0x30,0x30,0x30,0x30,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x78,0xcc,0xcc,0x78,0xcc,0xcc,0xcc,0x78,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x78,0xcc,0xcc,0xcc,0x7c,0x0c,0x18,0x70,0x00,0x00,
+
+        7, // 0x3a ':'
+        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x3b ';'
+        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
+
+        7, // 0x3c '<'
+        0x00,0x00,0x0c,0x18,0x30,0x60,0x30,0x18,0x0c,0x00,0x00,
+
+        7, // 0x3d '='
+        0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,
+
+        7, // 0x3e '>'
+        0x00,0x00,0x60,0x30,0x18,0x0c,0x18,0x30,0x60,0x00,0x00,
+
+        7, // 0x3f '?'
+        0x00,0x78,0xcc,0xcc,0x18,0x30,0x30,0x00,0x30,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x70,0x88,0x04,0x74,0xb4,0xb4,0xb4,0x68,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x30,0x78,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0xf8,0xcc,0xcc,0xf8,0xcc,0xcc,0xcc,0xf8,0x00,0x00,
+
+        7, // 0x43 'C'
+        0x00,0x78,0xcc,0xc0,0xc0,0xc0,0xc0,0xcc,0x78,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0xf0,0xd8,0xcc,0xcc,0xcc,0xcc,0xd8,0xf0,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0xfc,0xc4,0xd0,0xf0,0xd0,0xc0,0xc4,0xfc,0x00,0x00,
+
+        7, // 0x46 'F'
+        0x00,0xfc,0xc4,0xd0,0xf0,0xd0,0xc0,0xc0,0xc0,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x78,0xcc,0xc0,0xc0,0xdc,0xcc,0xcc,0x78,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x49 'I'
+        0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        7, // 0x4a 'J'
+        0x00,0x3c,0x18,0x18,0x18,0x18,0xd8,0xd8,0x70,0x00,0x00,
+
+        7, // 0x4b 'K'
+        0x00,0xcc,0xcc,0xd8,0xf0,0xd8,0xcc,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x4c 'L'
+        0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc4,0xfc,0x00,0x00,
+
+        7, // 0x4d 'M'
+        0x00,0x84,0xcc,0xfc,0xb4,0xcc,0xcc,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x4e 'N'
+        0x00,0xcc,0xcc,0xec,0xfc,0xdc,0xcc,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x4f 'O'
+        0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xdc,0x78,0x18,0x0c,0x00,
+
+        7, // 0x52 'R'
+        0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xd8,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x78,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0x78,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0xfc,0xb4,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,
+
+        7, // 0x56 'V'
+        0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,
+
+        7, // 0x57 'W'
+        0x00,0xcc,0xcc,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0xcc,0xcc,0x78,0x30,0x78,0xcc,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0xcc,0xcc,0xcc,0x78,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        7, // 0x5a 'Z'
+        0x00,0xfc,0x8c,0x18,0x30,0x60,0xc0,0xc4,0xfc,0x00,0x00,
+
+        7, // 0x5b '['
+        0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x78,0x00,0x00,
+
+        7, // 0x5c '\'
+        0x00,0x60,0x60,0x30,0x30,0x18,0x18,0x0c,0x0c,0x00,0x00,
+
+        7, // 0x5d ']'
+        0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x78,0x00,0x00,
+
+        7, // 0x5e '^'
+        0x00,0x10,0x38,0x6c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,
+
+        7, // 0x60 '`'
+        0x00,0x30,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x70,0x18,0x78,0xd8,0xd8,0x6c,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x60,0x60,0x60,0x78,0x6c,0x6c,0x6c,0x78,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x78,0xcc,0xc0,0xc0,0xcc,0x78,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x18,0x18,0x18,0x78,0xd8,0xd8,0xd8,0x6c,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x78,0xcc,0xfc,0xc0,0xcc,0x78,0x00,0x00,
+
+        7, // 0x66 'f'
+        0x00,0x18,0x34,0x30,0x78,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x6c,0xd8,0xd8,0xd8,0x78,0x18,0xd8,0x70,
+
+        7, // 0x68 'h'
+        0x00,0xc0,0xc0,0xd8,0xec,0xcc,0xcc,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x69 'i'
+        0x00,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        7, // 0x6a 'j'
+        0x00,0x0c,0x00,0x1c,0x0c,0x0c,0x0c,0x0c,0x6c,0x6c,0x38,
+
+        7, // 0x6b 'k'
+        0x00,0xc0,0xc0,0xcc,0xcc,0xd8,0xf0,0xd8,0xcc,0x00,0x00,
+
+        7, // 0x6c 'l'
+        0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        7, // 0x6d 'm'
+        0x00,0x00,0x00,0xe8,0xfc,0xd4,0xd4,0xc4,0xc4,0x00,0x00,
+
+        7, // 0x6e 'n'
+        0x00,0x00,0x00,0xd8,0x6c,0x6c,0x6c,0x6c,0x6c,0x00,0x00,
+
+        7, // 0x6f 'o'
+        0x00,0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x7c,0xcc,0xcc,0xcc,0x7c,0x0c,0x0c,0x0c,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0xd8,0xec,0xcc,0xc0,0xc0,0xc0,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x78,0xcc,0x60,0x18,0xcc,0x78,0x00,0x00,
+
+        7, // 0x74 't'
+        0x00,0x20,0x60,0x60,0xf0,0x60,0x60,0x68,0x30,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0xd8,0xd8,0xd8,0xd8,0xd8,0x6c,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,
+
+        7, // 0x77 'w'
+        0x00,0x00,0x00,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0xcc,0x78,0x30,0x78,0xcc,0xcc,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x18,0xf0,
+
+        7, // 0x7a 'z'
+        0x00,0x00,0x00,0xfc,0x98,0x30,0x60,0xc4,0xfc,0x00,0x00,
+
+        7, // 0x7b '{'
+        0x1c,0x30,0x30,0x30,0xe0,0x30,0x30,0x30,0x1c,0x00,0x00,
+
+        7, // 0x7c '|'
+        0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x30,0x30,0x00,0x00,
+
+        7, // 0x7d '}'
+        0xe0,0x30,0x30,0x30,0x1c,0x30,0x30,0x30,0xe0,0x00,0x00,
+
+        7, // 0x7e '~'
+        0x00,0x34,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7f ''
+        0x00,0x00,0x00,0x30,0x78,0xcc,0xcc,0xfc,0x00,0x00,0x00,
+        0
+    };
+
+    const int8u gse7x15[] = 
+    {
+        15, 0, 32, 128-32,
+
+        0x00,0x00,0x10,0x00,0x20,0x00,0x30,0x00,0x40,0x00,0x50,0x00,0x60,0x00,0x70,0x00,0x80,0x00,
+        0x90,0x00,0xa0,0x00,0xb0,0x00,0xc0,0x00,0xd0,0x00,0xe0,0x00,0xf0,0x00,0x00,0x01,0x10,0x01,
+        0x20,0x01,0x30,0x01,0x40,0x01,0x50,0x01,0x60,0x01,0x70,0x01,0x80,0x01,0x90,0x01,0xa0,0x01,
+        0xb0,0x01,0xc0,0x01,0xd0,0x01,0xe0,0x01,0xf0,0x01,0x00,0x02,0x10,0x02,0x20,0x02,0x30,0x02,
+        0x40,0x02,0x50,0x02,0x60,0x02,0x70,0x02,0x80,0x02,0x90,0x02,0xa0,0x02,0xb0,0x02,0xc0,0x02,
+        0xd0,0x02,0xe0,0x02,0xf0,0x02,0x00,0x03,0x10,0x03,0x20,0x03,0x30,0x03,0x40,0x03,0x50,0x03,
+        0x60,0x03,0x70,0x03,0x80,0x03,0x90,0x03,0xa0,0x03,0xb0,0x03,0xc0,0x03,0xd0,0x03,0xe0,0x03,
+        0xf0,0x03,0x00,0x04,0x10,0x04,0x20,0x04,0x30,0x04,0x40,0x04,0x50,0x04,0x60,0x04,0x70,0x04,
+        0x80,0x04,0x90,0x04,0xa0,0x04,0xb0,0x04,0xc0,0x04,0xd0,0x04,0xe0,0x04,0xf0,0x04,0x00,0x05,
+        0x10,0x05,0x20,0x05,0x30,0x05,0x40,0x05,0x50,0x05,0x60,0x05,0x70,0x05,0x80,0x05,0x90,0x05,
+        0xa0,0x05,0xb0,0x05,0xc0,0x05,0xd0,0x05,0xe0,0x05,0xf0,0x05,
+
+        7, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x21 '!'
+        0x00,0x00,0x10,0x38,0x38,0x38,0x38,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x00,0x24,0x24,0x24,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x23 '#'
+        0x00,0x00,0x48,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x48,0x00,0x00,0x00,
+
+        7, // 0x24 '$'
+        0x00,0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x54,0x38,0x10,0x00,0x00,0x00,
+
+        7, // 0x25 '%'
+        0x00,0x00,0x44,0x44,0x08,0x08,0x10,0x10,0x20,0x20,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x00,0x00,0x30,0x48,0x48,0x30,0x60,0x94,0x98,0x90,0x6c,0x00,0x00,0x00,
+
+        7, // 0x27 '''
+        0x00,0x00,0x20,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x00,0x04,0x08,0x10,0x20,0x20,0x20,0x20,0x20,0x10,0x08,0x04,0x00,0x00,0x00,
+
+        7, // 0x29 ')'
+        0x00,0x40,0x20,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x20,0x40,0x00,0x00,0x00,
+
+        7, // 0x2a '*'
+        0x00,0x00,0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2b '+'
+        0x00,0x00,0x00,0x00,0x10,0x10,0x10,0x7c,0x10,0x10,0x10,0x00,0x00,0x00,0x00,
+
+        7, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
+
+        7, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x2f '/'
+        0x00,0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x00,0x38,0x44,0x44,0x4c,0x54,0x64,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x00,0x10,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x7c,0x00,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x00,0x38,0x44,0x44,0x04,0x08,0x10,0x20,0x40,0x44,0x7c,0x00,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x00,0x7c,0x44,0x08,0x10,0x38,0x04,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x00,0x08,0x10,0x20,0x40,0x48,0x48,0x7c,0x08,0x08,0x1c,0x00,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x00,0x7c,0x40,0x40,0x40,0x78,0x04,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x00,0x18,0x20,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0x00,0x7c,0x44,0x04,0x04,0x08,0x08,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,0x08,0x30,0x00,0x00,0x00,
+
+        7, // 0x3a ':'
+        0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,
+
+        7, // 0x3b ';'
+        0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x30,0x30,0x60,0x00,0x00,
+
+        7, // 0x3c '<'
+        0x00,0x00,0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,0x00,
+
+        7, // 0x3d '='
+        0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x3e '>'
+        0x00,0x00,0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,0x00,
+
+        7, // 0x3f '?'
+        0x00,0x00,0x78,0x84,0x84,0x84,0x08,0x10,0x20,0x20,0x00,0x20,0x00,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x00,0x00,0x30,0x48,0x04,0x34,0x54,0x54,0x54,0x54,0x28,0x00,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x00,0x10,0x28,0x44,0x44,0x44,0x7c,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
+
+        7, // 0x43 'C'
+        0x00,0x00,0x38,0x44,0x44,0x40,0x40,0x40,0x40,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0x00,0x7c,0x40,0x40,0x40,0x70,0x40,0x40,0x40,0x40,0x7c,0x00,0x00,0x00,
+
+        7, // 0x46 'F'
+        0x00,0x00,0x7c,0x40,0x40,0x40,0x70,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x5c,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x00,0x44,0x44,0x44,0x44,0x7c,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x49 'I'
+        0x00,0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x4a 'J'
+        0x00,0x00,0x1c,0x08,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,0x00,
+
+        7, // 0x4b 'K'
+        0x00,0x00,0x44,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x4c 'L'
+        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7c,0x00,0x00,0x00,
+
+        7, // 0x4d 'M'
+        0x00,0x00,0x44,0x6c,0x54,0x54,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x4e 'N'
+        0x00,0x00,0x44,0x44,0x44,0x64,0x54,0x4c,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x4f 'O'
+        0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x50,0x48,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x00,0x38,0x44,0x44,0x40,0x38,0x04,0x04,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x00,0x7c,0x54,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x56 'V'
+        0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x57 'W'
+        0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x5a 'Z'
+        0x00,0x00,0x7c,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x40,0x7c,0x00,0x00,0x00,
+
+        7, // 0x5b '['
+        0x00,0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,0x00,
+
+        7, // 0x5c '\'
+        0x00,0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,0x00,0x00,
+
+        7, // 0x5d ']'
+        0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,0x00,
+
+        7, // 0x5e '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,
+
+        7, // 0x60 '`'
+        0x00,0x20,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x38,0x44,0x04,0x3c,0x44,0x44,0x44,0x3a,0x00,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x00,0x40,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x00,0x04,0x04,0x04,0x3c,0x44,0x44,0x44,0x44,0x44,0x3a,0x00,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x38,0x44,0x44,0x7c,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x66 'f'
+        0x00,0x00,0x18,0x24,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x3a,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x44,0x38,0x00,
+
+        7, // 0x68 'h'
+        0x00,0x00,0x40,0x40,0x40,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x69 'i'
+        0x00,0x00,0x10,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x6a 'j'
+        0x00,0x00,0x08,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,
+
+        7, // 0x6b 'k'
+        0x00,0x00,0x40,0x40,0x44,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
+
+        7, // 0x6c 'l'
+        0x00,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x6d 'm'
+        0x00,0x00,0x00,0x00,0xa8,0x54,0x54,0x54,0x54,0x54,0x54,0x54,0x00,0x00,0x00,
+
+        7, // 0x6e 'n'
+        0x00,0x00,0x00,0x00,0xb8,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x6f 'o'
+        0x00,0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x3c,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,0x04,0x00,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x58,0x64,0x44,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x74 't'
+        0x00,0x00,0x20,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x24,0x18,0x00,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x3a,0x00,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x54,0x54,0x6c,0x44,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x08,0x70,0x00,
+
+        7, // 0x7a 'z'
+        0x00,0x00,0x00,0x00,0x7c,0x04,0x08,0x10,0x20,0x40,0x40,0x7c,0x00,0x00,0x00,
+
+        7, // 0x7b '{'
+        0x00,0x0c,0x10,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x0c,0x00,0x00,
+
+        7, // 0x7c '|'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        7, // 0x7d '}'
+        0x00,0x60,0x10,0x10,0x10,0x10,0x10,0x0c,0x10,0x10,0x10,0x10,0x60,0x00,0x00,
+
+        7, // 0x7e '~'
+        0x00,0x00,0x64,0x98,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7f ''
+        0x00,0x00,0x00,0x00,0x00,0x10,0x28,0x44,0x44,0x7c,0x00,0x00,0x00,0x00,0x00,
+        0
+    };
+
+    const int8u gse7x15_bold[] = 
+    {
+        15, 0, 32, 128-32,
+
+        0x00,0x00,0x10,0x00,0x20,0x00,0x30,0x00,0x40,0x00,0x50,0x00,0x60,0x00,0x70,0x00,0x80,0x00,
+        0x90,0x00,0xa0,0x00,0xb0,0x00,0xc0,0x00,0xd0,0x00,0xe0,0x00,0xf0,0x00,0x00,0x01,0x10,0x01,
+        0x20,0x01,0x30,0x01,0x40,0x01,0x50,0x01,0x60,0x01,0x70,0x01,0x80,0x01,0x90,0x01,0xa0,0x01,
+        0xb0,0x01,0xc0,0x01,0xd0,0x01,0xe0,0x01,0xf0,0x01,0x00,0x02,0x10,0x02,0x20,0x02,0x30,0x02,
+        0x40,0x02,0x50,0x02,0x60,0x02,0x70,0x02,0x80,0x02,0x90,0x02,0xa0,0x02,0xb0,0x02,0xc0,0x02,
+        0xd0,0x02,0xe0,0x02,0xf0,0x02,0x00,0x03,0x10,0x03,0x20,0x03,0x30,0x03,0x40,0x03,0x50,0x03,
+        0x60,0x03,0x70,0x03,0x80,0x03,0x90,0x03,0xa0,0x03,0xb0,0x03,0xc0,0x03,0xd0,0x03,0xe0,0x03,
+        0xf0,0x03,0x00,0x04,0x10,0x04,0x20,0x04,0x30,0x04,0x40,0x04,0x50,0x04,0x60,0x04,0x70,0x04,
+        0x80,0x04,0x90,0x04,0xa0,0x04,0xb0,0x04,0xc0,0x04,0xd0,0x04,0xe0,0x04,0xf0,0x04,0x00,0x05,
+        0x10,0x05,0x20,0x05,0x30,0x05,0x40,0x05,0x50,0x05,0x60,0x05,0x70,0x05,0x80,0x05,0x90,0x05,
+        0xa0,0x05,0xb0,0x05,0xc0,0x05,0xd0,0x05,0xe0,0x05,0xf0,0x05,
+
+        7, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x21 '!'
+        0x00,0x00,0x00,0x30,0x78,0x78,0x78,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x00,0x6c,0x6c,0x6c,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x23 '#'
+        0x00,0x00,0x48,0x48,0x48,0xfc,0x48,0x48,0xfc,0x48,0x48,0x48,0x00,0x00,0x00,
+
+        7, // 0x24 '$'
+        0x00,0x30,0x30,0x78,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0x78,0x30,0x30,0x00,0x00,
+
+        7, // 0x25 '%'
+        0x00,0x00,0x00,0x64,0x6c,0x08,0x18,0x10,0x30,0x20,0x6c,0x4c,0x00,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x00,0x00,0x30,0x58,0x58,0x30,0x74,0xdc,0xd8,0xd8,0x6c,0x00,0x00,0x00,
+
+        7, // 0x27 '''
+        0x00,0x00,0x30,0x30,0x30,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x00,0x0c,0x18,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x18,0x0c,0x00,0x00,0x00,
+
+        7, // 0x29 ')'
+        0x00,0xc0,0x60,0x30,0x18,0x18,0x18,0x18,0x18,0x30,0x60,0xc0,0x00,0x00,0x00,
+
+        7, // 0x2a '*'
+        0x00,0x00,0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2b '+'
+        0x00,0x00,0x00,0x00,0x00,0x30,0x30,0xfc,0x30,0x30,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
+
+        7, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x2f '/'
+        0x00,0x00,0x0c,0x0c,0x18,0x18,0x30,0x30,0x60,0x60,0xc0,0xc0,0x00,0x00,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xdc,0xec,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x00,0x30,0x30,0x70,0xf0,0x30,0x30,0x30,0x30,0x30,0xfc,0x00,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x00,0x78,0xcc,0xcc,0x0c,0x18,0x30,0x60,0xc0,0xcc,0xfc,0x00,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x00,0xfc,0x8c,0x18,0x30,0x78,0x0c,0x0c,0x0c,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x00,0x18,0x30,0x60,0xc8,0xd8,0xd8,0xfc,0x18,0x18,0x3c,0x00,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x00,0xfc,0xc0,0xc0,0xc0,0xf8,0x0c,0x0c,0x0c,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x00,0x38,0x60,0xc0,0xc0,0xf8,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0x00,0xfc,0x8c,0x0c,0x0c,0x18,0x18,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x00,0x78,0xcc,0xcc,0xcc,0x78,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x0c,0x18,0x70,0x00,0x00,0x00,
+
+        7, // 0x3a ':'
+        0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,
+
+        7, // 0x3b ';'
+        0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x00,
+
+        7, // 0x3c '<'
+        0x00,0x00,0x00,0x0c,0x18,0x30,0x60,0xc0,0x60,0x30,0x18,0x0c,0x00,0x00,0x00,
+
+        7, // 0x3d '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x3e '>'
+        0x00,0x00,0x00,0xc0,0x60,0x30,0x18,0x0c,0x18,0x30,0x60,0xc0,0x00,0x00,0x00,
+
+        7, // 0x3f '?'
+        0x00,0x00,0x78,0xcc,0xcc,0x18,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x00,0x00,0x70,0x88,0x04,0x74,0xb4,0xb4,0xb4,0xb4,0x68,0x00,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x00,0x30,0x78,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xf8,0xcc,0xcc,0xcc,0xcc,0xf8,0x00,0x00,0x00,
+
+        7, // 0x43 'C'
+        0x00,0x00,0x78,0xcc,0xc4,0xc0,0xc0,0xc0,0xc0,0xc4,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x00,0xf0,0xd8,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xd8,0xf0,0x00,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0x00,0xfc,0xc4,0xc0,0xd0,0xf0,0xd0,0xc0,0xc0,0xc4,0xfc,0x00,0x00,0x00,
+
+        7, // 0x46 'F'
+        0x00,0x00,0xfc,0xc4,0xc0,0xd0,0xf0,0xd0,0xc0,0xc0,0xc0,0xc0,0x00,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x00,0x78,0xcc,0xc0,0xc0,0xc0,0xdc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x49 'I'
+        0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
+
+        7, // 0x4a 'J'
+        0x00,0x00,0x3c,0x18,0x18,0x18,0x18,0x18,0x18,0xd8,0xd8,0x70,0x00,0x00,0x00,
+
+        7, // 0x4b 'K'
+        0x00,0x00,0xcc,0xcc,0xd8,0xd8,0xf0,0xd8,0xd8,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x4c 'L'
+        0x00,0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc4,0xfc,0x00,0x00,0x00,
+
+        7, // 0x4d 'M'
+        0x00,0x00,0x84,0xcc,0xfc,0xb4,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x4e 'N'
+        0x00,0x00,0xcc,0xcc,0xcc,0xec,0xfc,0xdc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x4f 'O'
+        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,0xc0,0x00,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xdc,0x78,0x18,0x0c,0x00,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xcc,0xf8,0xd8,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x00,0x78,0xcc,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x00,0xfc,0xb4,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x56 'V'
+        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,0x00,
+
+        7, // 0x57 'W'
+        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x00,0xcc,0xcc,0xcc,0x78,0x30,0x78,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x00,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
+
+        7, // 0x5a 'Z'
+        0x00,0x00,0xfc,0x8c,0x0c,0x18,0x30,0x60,0xc0,0xc0,0xc4,0xfc,0x00,0x00,0x00,
+
+        7, // 0x5b '['
+        0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,0x00,0x00,
+
+        7, // 0x5c '\'
+        0x00,0x00,0xc0,0xc0,0x60,0x60,0x30,0x30,0x18,0x18,0x0c,0x0c,0x00,0x00,0x00,
+
+        7, // 0x5d ']'
+        0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,0x00,0x00,
+
+        7, // 0x5e '^'
+        0x00,0x10,0x38,0x6c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,
+
+        7, // 0x60 '`'
+        0x00,0x30,0x30,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x70,0xd8,0x18,0x78,0xd8,0xd8,0xd8,0x6c,0x00,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x00,0x60,0x60,0x60,0x78,0x6c,0x6c,0x6c,0x6c,0x6c,0x78,0x00,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x78,0xcc,0xc0,0xc0,0xc0,0xc0,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x00,0x18,0x18,0x18,0x78,0xd8,0xd8,0xd8,0xd8,0xd8,0x6c,0x00,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x78,0xcc,0xcc,0xfc,0xc0,0xc0,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x66 'f'
+        0x00,0x00,0x30,0x68,0x60,0x60,0xf0,0x60,0x60,0x60,0x60,0xf0,0x00,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x6c,0xd8,0xd8,0xd8,0xd8,0xd8,0x78,0x18,0xd8,0x70,0x00,
+
+        7, // 0x68 'h'
+        0x00,0x00,0xc0,0xc0,0xc0,0xd8,0xec,0xcc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x69 'i'
+        0x00,0x00,0x30,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
+
+        7, // 0x6a 'j'
+        0x00,0x00,0x18,0x18,0x00,0x38,0x18,0x18,0x18,0x18,0x18,0xd8,0xd8,0x70,0x00,
+
+        7, // 0x6b 'k'
+        0x00,0x00,0xc0,0xc0,0xcc,0xcc,0xcc,0xd8,0xf0,0xd8,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x6c 'l'
+        0x00,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
+
+        7, // 0x6d 'm'
+        0x00,0x00,0x00,0x00,0xe8,0xfc,0xd4,0xd4,0xd4,0xc4,0xc4,0xc4,0x00,0x00,0x00,
+
+        7, // 0x6e 'n'
+        0x00,0x00,0x00,0x00,0xd8,0x6c,0x6c,0x6c,0x6c,0x6c,0x6c,0x6c,0x00,0x00,0x00,
+
+        7, // 0x6f 'o'
+        0x00,0x00,0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0xf8,0xcc,0xcc,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,0x00,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x7c,0xcc,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x0c,0x0c,0x00,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0xd8,0xec,0xcc,0xc0,0xc0,0xc0,0xc0,0xc0,0x00,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x78,0xcc,0xe0,0x70,0x38,0x1c,0xcc,0x78,0x00,0x00,0x00,
+
+        7, // 0x74 't'
+        0x00,0x00,0x20,0x60,0x60,0xf0,0x60,0x60,0x60,0x60,0x6c,0x38,0x00,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0xd8,0xd8,0xd8,0xd8,0xd8,0xd8,0xd8,0x6c,0x00,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,0x00,0x00,
+
+        7, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xb4,0xfc,0xcc,0x84,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0xcc,0xcc,0x78,0x30,0x78,0xcc,0xcc,0xcc,0x00,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x18,0xf0,0x00,
+
+        7, // 0x7a 'z'
+        0x00,0x00,0x00,0x00,0xfc,0x8c,0x18,0x30,0x60,0xc0,0xc4,0xfc,0x00,0x00,0x00,
+
+        7, // 0x7b '{'
+        0x00,0x1c,0x30,0x30,0x30,0x30,0x30,0xe0,0x30,0x30,0x30,0x30,0x1c,0x00,0x00,
+
+        7, // 0x7c '|'
+        0x00,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x00,0x00,
+
+        7, // 0x7d '}'
+        0x00,0xe0,0x30,0x30,0x30,0x30,0x30,0x1c,0x30,0x30,0x30,0x30,0xe0,0x00,0x00,
+
+        7, // 0x7e '~'
+        0x00,0x00,0x34,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7f ''
+        0x00,0x00,0x00,0x00,0x00,0x30,0x78,0xcc,0xcc,0xfc,0x00,0x00,0x00,0x00,0x00,
+        0
+    };
+
+    const int8u gse8x16[] = 
+    {
+        16, 0, 32, 128-32,
+
+        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x44,0x00,0x55,0x00,0x66,0x00,0x77,0x00,0x88,0x00,
+        0x99,0x00,0xaa,0x00,0xbb,0x00,0xcc,0x00,0xdd,0x00,0xee,0x00,0xff,0x00,0x10,0x01,0x21,0x01,
+        0x32,0x01,0x43,0x01,0x54,0x01,0x65,0x01,0x76,0x01,0x87,0x01,0x98,0x01,0xa9,0x01,0xba,0x01,
+        0xcb,0x01,0xdc,0x01,0xed,0x01,0xfe,0x01,0x0f,0x02,0x20,0x02,0x31,0x02,0x42,0x02,0x53,0x02,
+        0x64,0x02,0x75,0x02,0x86,0x02,0x97,0x02,0xa8,0x02,0xb9,0x02,0xca,0x02,0xdb,0x02,0xec,0x02,
+        0xfd,0x02,0x0e,0x03,0x1f,0x03,0x30,0x03,0x41,0x03,0x52,0x03,0x63,0x03,0x74,0x03,0x85,0x03,
+        0x96,0x03,0xa7,0x03,0xb8,0x03,0xc9,0x03,0xda,0x03,0xeb,0x03,0xfc,0x03,0x0d,0x04,0x1e,0x04,
+        0x2f,0x04,0x40,0x04,0x51,0x04,0x62,0x04,0x73,0x04,0x84,0x04,0x95,0x04,0xa6,0x04,0xb7,0x04,
+        0xc8,0x04,0xd9,0x04,0xea,0x04,0xfb,0x04,0x0c,0x05,0x1d,0x05,0x2e,0x05,0x3f,0x05,0x50,0x05,
+        0x61,0x05,0x72,0x05,0x83,0x05,0x94,0x05,0xa5,0x05,0xb6,0x05,0xc7,0x05,0xd8,0x05,0xe9,0x05,
+        0xfa,0x05,0x0b,0x06,0x1c,0x06,0x2d,0x06,0x3e,0x06,0x4f,0x06,
+
+        8, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x21 '!'
+        0x00,0x00,0x10,0x38,0x38,0x38,0x38,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,0x00,
+
+        8, // 0x22 '"'
+        0x00,0x24,0x24,0x24,0x24,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x23 '#'
+        0x00,0x00,0x24,0x24,0x24,0x7e,0x24,0x24,0x7e,0x24,0x24,0x24,0x00,0x00,0x00,0x00,
+
+        8, // 0x24 '$'
+        0x00,0x14,0x14,0x3e,0x55,0x54,0x54,0x3e,0x15,0x15,0x55,0x3e,0x14,0x14,0x00,0x00,
+
+        8, // 0x25 '%'
+        0x00,0x00,0x32,0x56,0x6c,0x04,0x08,0x08,0x10,0x13,0x25,0x26,0x00,0x00,0x00,0x00,
+
+        8, // 0x26 '&'
+        0x00,0x00,0x18,0x24,0x24,0x24,0x18,0x28,0x45,0x46,0x44,0x3b,0x00,0x00,0x00,0x00,
+
+        8, // 0x27 '''
+        0x00,0x00,0x08,0x08,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x28 '('
+        0x00,0x04,0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x04,0x00,0x00,0x00,
+
+        8, // 0x29 ')'
+        0x00,0x10,0x08,0x04,0x04,0x02,0x02,0x02,0x02,0x04,0x04,0x08,0x10,0x00,0x00,0x00,
+
+        8, // 0x2a '*'
+        0x00,0x00,0x00,0x00,0x66,0x24,0x18,0xff,0x18,0x24,0x66,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x2b '+'
+        0x00,0x00,0x00,0x00,0x08,0x08,0x08,0x7f,0x08,0x08,0x08,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x20,0x00,
+
+        8, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,
+
+        8, // 0x2f '/'
+        0x00,0x02,0x02,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,0x00,
+
+        8, // 0x30 '0'
+        0x00,0x00,0x3c,0x42,0x42,0x46,0x4a,0x52,0x62,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x31 '1'
+        0x00,0x00,0x08,0x08,0x18,0x38,0x08,0x08,0x08,0x08,0x08,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x32 '2'
+        0x00,0x00,0x3c,0x42,0x42,0x02,0x04,0x08,0x10,0x20,0x42,0x7e,0x00,0x00,0x00,0x00,
+
+        8, // 0x33 '3'
+        0x00,0x00,0x7e,0x42,0x04,0x08,0x1c,0x02,0x02,0x02,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x34 '4'
+        0x00,0x00,0x04,0x08,0x10,0x24,0x44,0x44,0x7e,0x04,0x04,0x0e,0x00,0x00,0x00,0x00,
+
+        8, // 0x35 '5'
+        0x00,0x00,0x7e,0x42,0x40,0x40,0x7c,0x02,0x02,0x02,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x36 '6'
+        0x00,0x00,0x1c,0x20,0x40,0x40,0x7c,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x37 '7'
+        0x00,0x00,0x7e,0x42,0x42,0x02,0x04,0x08,0x10,0x10,0x10,0x10,0x00,0x00,0x00,0x00,
+
+        8, // 0x38 '8'
+        0x00,0x00,0x3c,0x42,0x42,0x42,0x3c,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x39 '9'
+        0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x3e,0x02,0x02,0x04,0x38,0x00,0x00,0x00,0x00,
+
+        8, // 0x3a ':'
+        0x00,0x00,0x00,0x00,0x18,0x00,0x00,0x00,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x3b ';'
+        0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x40,0x00,
+
+        8, // 0x3c '<'
+        0x00,0x00,0x00,0x02,0x04,0x08,0x10,0x20,0x10,0x08,0x04,0x02,0x00,0x00,0x00,0x00,
+
+        8, // 0x3d '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x3e '>'
+        0x00,0x00,0x00,0x20,0x10,0x08,0x04,0x02,0x04,0x08,0x10,0x20,0x00,0x00,0x00,0x00,
+
+        8, // 0x3f '?'
+        0x00,0x00,0x3c,0x42,0x42,0x42,0x04,0x08,0x08,0x00,0x08,0x08,0x00,0x00,0x00,0x00,
+
+        8, // 0x40 '@'
+        0x00,0x00,0x3c,0x42,0x01,0x39,0x49,0x49,0x49,0x49,0x49,0x36,0x00,0x00,0x00,0x00,
+
+        8, // 0x41 'A'
+        0x00,0x00,0x18,0x24,0x42,0x42,0x42,0x7e,0x42,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
+
+        8, // 0x42 'B'
+        0x00,0x00,0x7c,0x22,0x22,0x22,0x3c,0x22,0x22,0x22,0x22,0x7c,0x00,0x00,0x00,0x00,
+
+        8, // 0x43 'C'
+        0x00,0x00,0x3c,0x42,0x42,0x40,0x40,0x40,0x40,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x44 'D'
+        0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x7c,0x00,0x00,0x00,0x00,
+
+        8, // 0x45 'E'
+        0x00,0x00,0x7e,0x22,0x20,0x28,0x38,0x28,0x20,0x20,0x22,0x7e,0x00,0x00,0x00,0x00,
+
+        8, // 0x46 'F'
+        0x00,0x00,0x7e,0x22,0x20,0x28,0x38,0x28,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,
+
+        8, // 0x47 'G'
+        0x00,0x00,0x3c,0x42,0x42,0x40,0x40,0x4e,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x48 'H'
+        0x00,0x00,0x42,0x42,0x42,0x42,0x7e,0x42,0x42,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
+
+        8, // 0x49 'I'
+        0x00,0x00,0x1c,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
+
+        8, // 0x4a 'J'
+        0x00,0x00,0x0e,0x04,0x04,0x04,0x04,0x04,0x04,0x44,0x44,0x38,0x00,0x00,0x00,0x00,
+
+        8, // 0x4b 'K'
+        0x00,0x00,0x62,0x22,0x24,0x28,0x30,0x28,0x24,0x22,0x22,0x62,0x00,0x00,0x00,0x00,
+
+        8, // 0x4c 'L'
+        0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x22,0x7e,0x00,0x00,0x00,0x00,
+
+        8, // 0x4d 'M'
+        0x00,0x00,0x41,0x63,0x55,0x49,0x41,0x41,0x41,0x41,0x41,0x41,0x00,0x00,0x00,0x00,
+
+        8, // 0x4e 'N'
+        0x00,0x00,0x42,0x42,0x62,0x52,0x4a,0x46,0x42,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
+
+        8, // 0x4f 'O'
+        0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x50 'P'
+        0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x3c,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,
+
+        8, // 0x51 'Q'
+        0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x42,0x42,0x4a,0x44,0x3a,0x02,0x00,0x00,0x00,
+
+        8, // 0x52 'R'
+        0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x3c,0x28,0x24,0x22,0x62,0x00,0x00,0x00,0x00,
+
+        8, // 0x53 'S'
+        0x00,0x00,0x3c,0x42,0x42,0x40,0x30,0x0c,0x02,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x54 'T'
+        0x00,0x00,0x7f,0x49,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
+
+        8, // 0x55 'U'
+        0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x56 'V'
+        0x00,0x00,0x41,0x41,0x41,0x41,0x22,0x22,0x14,0x14,0x08,0x08,0x00,0x00,0x00,0x00,
+
+        8, // 0x57 'W'
+        0x00,0x00,0x41,0x41,0x41,0x41,0x41,0x49,0x49,0x55,0x63,0x41,0x00,0x00,0x00,0x00,
+
+        8, // 0x58 'X'
+        0x00,0x00,0x42,0x42,0x42,0x24,0x18,0x18,0x24,0x42,0x42,0x42,0x00,0x00,0x00,0x00,
+
+        8, // 0x59 'Y'
+        0x00,0x00,0x22,0x22,0x22,0x22,0x14,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
+
+        8, // 0x5a 'Z'
+        0x00,0x00,0x7e,0x42,0x02,0x04,0x08,0x10,0x20,0x40,0x42,0x7e,0x00,0x00,0x00,0x00,
+
+        8, // 0x5b '['
+        0x00,0x1e,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x1e,0x00,0x00,0x00,
+
+        8, // 0x5c '\'
+        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x02,0x02,0x00,0x00,0x00,
+
+        8, // 0x5d ']'
+        0x00,0x3c,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x3c,0x00,0x00,0x00,
+
+        8, // 0x5e '^'
+        0x00,0x00,0x08,0x14,0x22,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,0x00,0x00,
+
+        8, // 0x60 '`'
+        0x00,0x00,0x08,0x08,0x08,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x04,0x3c,0x44,0x44,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x62 'b'
+        0x00,0x00,0x60,0x20,0x20,0x38,0x24,0x22,0x22,0x22,0x22,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x40,0x40,0x40,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x64 'd'
+        0x00,0x00,0x0c,0x04,0x04,0x1c,0x24,0x44,0x44,0x44,0x44,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x42,0x7e,0x40,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x66 'f'
+        0x00,0x00,0x0c,0x12,0x10,0x10,0x38,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,0x00,
+
+        8, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x3e,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x44,0x38,0x00,
+
+        8, // 0x68 'h'
+        0x00,0x00,0x60,0x20,0x20,0x2c,0x32,0x22,0x22,0x22,0x22,0x62,0x00,0x00,0x00,0x00,
+
+        8, // 0x69 'i'
+        0x00,0x00,0x08,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
+
+        8, // 0x6a 'j'
+        0x00,0x00,0x04,0x04,0x00,0x0c,0x04,0x04,0x04,0x04,0x04,0x44,0x44,0x38,0x00,0x00,
+
+        8, // 0x6b 'k'
+        0x00,0x00,0x60,0x20,0x20,0x22,0x24,0x28,0x38,0x24,0x22,0x62,0x00,0x00,0x00,0x00,
+
+        8, // 0x6c 'l'
+        0x00,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x1c,0x00,0x00,0x00,0x00,
+
+        8, // 0x6d 'm'
+        0x00,0x00,0x00,0x00,0x00,0x76,0x49,0x49,0x49,0x49,0x41,0x41,0x00,0x00,0x00,0x00,
+
+        8, // 0x6e 'n'
+        0x00,0x00,0x00,0x00,0x00,0x5c,0x22,0x22,0x22,0x22,0x22,0x22,0x00,0x00,0x00,0x00,
+
+        8, // 0x6f 'o'
+        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x42,0x42,0x42,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x7c,0x22,0x22,0x22,0x22,0x22,0x3c,0x20,0x20,0x70,0x00,
+
+        8, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x3e,0x44,0x44,0x44,0x44,0x44,0x3c,0x04,0x04,0x0e,0x00,
+
+        8, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x7c,0x22,0x22,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,
+
+        8, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x3c,0x42,0x40,0x3c,0x02,0x42,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x74 't'
+        0x00,0x00,0x10,0x10,0x10,0x7c,0x10,0x10,0x10,0x10,0x12,0x0c,0x00,0x00,0x00,0x00,
+
+        8, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x41,0x41,0x41,0x41,0x22,0x14,0x08,0x00,0x00,0x00,0x00,
+
+        8, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x41,0x41,0x41,0x49,0x49,0x55,0x22,0x00,0x00,0x00,0x00,
+
+        8, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x18,0x24,0x42,0x42,0x00,0x00,0x00,0x00,
+
+        8, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x3e,0x02,0x04,0x78,0x00,
+
+        8, // 0x7a 'z'
+        0x00,0x00,0x00,0x00,0x00,0x7e,0x44,0x08,0x10,0x20,0x42,0x7e,0x00,0x00,0x00,0x00,
+
+        8, // 0x7b '{'
+        0x00,0x06,0x08,0x08,0x08,0x08,0x08,0x30,0x08,0x08,0x08,0x08,0x08,0x06,0x00,0x00,
+
+        8, // 0x7c '|'
+        0x00,0x00,0x08,0x08,0x08,0x08,0x08,0x00,0x08,0x08,0x08,0x08,0x08,0x00,0x00,0x00,
+
+        8, // 0x7d '}'
+        0x00,0x30,0x08,0x08,0x08,0x08,0x08,0x06,0x08,0x08,0x08,0x08,0x08,0x30,0x00,0x00,
+
+        8, // 0x7e '~'
+        0x00,0x00,0x39,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x7f ''
+        0x00,0x00,0x00,0x00,0x00,0x08,0x14,0x22,0x41,0x41,0x7f,0x00,0x00,0x00,0x00,0x00,
+        0
+    };
+
+    const int8u gse8x16_bold[] = 
+    {
+        16, 0, 32, 128-32,
+
+        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x44,0x00,0x55,0x00,0x66,0x00,0x77,0x00,0x88,0x00,
+        0x99,0x00,0xaa,0x00,0xbb,0x00,0xcc,0x00,0xdd,0x00,0xee,0x00,0xff,0x00,0x10,0x01,0x21,0x01,
+        0x32,0x01,0x43,0x01,0x54,0x01,0x65,0x01,0x76,0x01,0x87,0x01,0x98,0x01,0xa9,0x01,0xba,0x01,
+        0xcb,0x01,0xdc,0x01,0xed,0x01,0xfe,0x01,0x0f,0x02,0x20,0x02,0x31,0x02,0x42,0x02,0x53,0x02,
+        0x64,0x02,0x75,0x02,0x86,0x02,0x97,0x02,0xa8,0x02,0xb9,0x02,0xca,0x02,0xdb,0x02,0xec,0x02,
+        0xfd,0x02,0x0e,0x03,0x1f,0x03,0x30,0x03,0x41,0x03,0x52,0x03,0x63,0x03,0x74,0x03,0x85,0x03,
+        0x96,0x03,0xa7,0x03,0xb8,0x03,0xc9,0x03,0xda,0x03,0xeb,0x03,0xfc,0x03,0x0d,0x04,0x1e,0x04,
+        0x2f,0x04,0x40,0x04,0x51,0x04,0x62,0x04,0x73,0x04,0x84,0x04,0x95,0x04,0xa6,0x04,0xb7,0x04,
+        0xc8,0x04,0xd9,0x04,0xea,0x04,0xfb,0x04,0x0c,0x05,0x1d,0x05,0x2e,0x05,0x3f,0x05,0x50,0x05,
+        0x61,0x05,0x72,0x05,0x83,0x05,0x94,0x05,0xa5,0x05,0xb6,0x05,0xc7,0x05,0xd8,0x05,0xe9,0x05,
+        0xfa,0x05,0x0b,0x06,0x1c,0x06,0x2d,0x06,0x3e,0x06,0x4f,0x06,
+
+        8, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x21 '!'
+        0x00,0x00,0x18,0x3c,0x3c,0x3c,0x3c,0x18,0x18,0x00,0x18,0x18,0x00,0x00,0x00,0x00,
+
+        8, // 0x22 '"'
+        0x00,0x66,0x66,0x66,0x66,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x23 '#'
+        0x00,0x00,0x66,0x66,0x66,0xff,0x66,0x66,0xff,0x66,0x66,0x66,0x00,0x00,0x00,0x00,
+
+        8, // 0x24 '$'
+        0x00,0x08,0x08,0x3e,0x6b,0x6b,0x68,0x3e,0x0b,0x6b,0x6b,0x3e,0x08,0x08,0x00,0x00,
+
+        8, // 0x25 '%'
+        0x00,0x00,0x66,0xbe,0xcc,0x0c,0x18,0x18,0x30,0x33,0x65,0x66,0x00,0x00,0x00,0x00,
+
+        8, // 0x26 '&'
+        0x00,0x00,0x1c,0x36,0x36,0x36,0x1c,0x3b,0x6e,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
+
+        8, // 0x27 '''
+        0x00,0x00,0x18,0x18,0x18,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x28 '('
+        0x00,0x06,0x0c,0x18,0x18,0x30,0x30,0x30,0x30,0x18,0x18,0x0c,0x06,0x00,0x00,0x00,
+
+        8, // 0x29 ')'
+        0x00,0x30,0x18,0x0c,0x0c,0x06,0x06,0x06,0x06,0x0c,0x0c,0x18,0x30,0x00,0x00,0x00,
+
+        8, // 0x2a '*'
+        0x00,0x00,0x00,0x00,0x66,0x24,0x18,0xff,0x18,0x24,0x66,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x2b '+'
+        0x00,0x00,0x00,0x00,0x18,0x18,0x18,0xff,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x2c ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x20,0x00,
+
+        8, // 0x2d '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x2e '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,
+
+        8, // 0x2f '/'
+        0x00,0x03,0x03,0x06,0x06,0x0c,0x0c,0x18,0x18,0x30,0x30,0x60,0x60,0x00,0x00,0x00,
+
+        8, // 0x30 '0'
+        0x00,0x00,0x3e,0x63,0x63,0x67,0x6b,0x73,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x31 '1'
+        0x00,0x00,0x0c,0x0c,0x1c,0x3c,0x0c,0x0c,0x0c,0x0c,0x0c,0x3f,0x00,0x00,0x00,0x00,
+
+        8, // 0x32 '2'
+        0x00,0x00,0x3e,0x63,0x63,0x03,0x06,0x0c,0x18,0x30,0x61,0x7f,0x00,0x00,0x00,0x00,
+
+        8, // 0x33 '3'
+        0x00,0x00,0x7f,0x43,0x06,0x0c,0x1e,0x03,0x03,0x03,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x34 '4'
+        0x00,0x00,0x06,0x0c,0x18,0x32,0x66,0x66,0x7f,0x06,0x06,0x0f,0x00,0x00,0x00,0x00,
+
+        8, // 0x35 '5'
+        0x00,0x00,0x7f,0x61,0x60,0x60,0x7e,0x03,0x03,0x03,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x36 '6'
+        0x00,0x00,0x1e,0x30,0x60,0x60,0x7e,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x37 '7'
+        0x00,0x00,0x7f,0x63,0x63,0x03,0x06,0x0c,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,
+
+        8, // 0x38 '8'
+        0x00,0x00,0x3e,0x63,0x63,0x63,0x3e,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x39 '9'
+        0x00,0x00,0x3e,0x63,0x63,0x63,0x63,0x3f,0x03,0x03,0x06,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x3a ':'
+        0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x3b ';'
+        0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x60,0x40,0x00,
+
+        8, // 0x3c '<'
+        0x00,0x00,0x00,0x06,0x0c,0x18,0x30,0x60,0x30,0x18,0x0c,0x06,0x00,0x00,0x00,0x00,
+
+        8, // 0x3d '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x00,0x7f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x3e '>'
+        0x00,0x00,0x00,0x30,0x18,0x0c,0x06,0x03,0x06,0x0c,0x18,0x30,0x00,0x00,0x00,0x00,
+
+        8, // 0x3f '?'
+        0x00,0x00,0x3e,0x63,0x63,0x63,0x06,0x0c,0x0c,0x00,0x0c,0x0c,0x00,0x00,0x00,0x00,
+
+        8, // 0x40 '@'
+        0x00,0x00,0x7c,0x86,0x03,0x73,0xdb,0xdb,0xdb,0xdb,0xdb,0x6e,0x00,0x00,0x00,0x00,
+
+        8, // 0x41 'A'
+        0x00,0x00,0x08,0x1c,0x36,0x63,0x63,0x63,0x7f,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x42 'B'
+        0x00,0x00,0x7e,0x33,0x33,0x33,0x3e,0x33,0x33,0x33,0x33,0x7e,0x00,0x00,0x00,0x00,
+
+        8, // 0x43 'C'
+        0x00,0x00,0x1e,0x33,0x61,0x60,0x60,0x60,0x60,0x61,0x33,0x1e,0x00,0x00,0x00,0x00,
+
+        8, // 0x44 'D'
+        0x00,0x00,0x7c,0x36,0x33,0x33,0x33,0x33,0x33,0x33,0x36,0x7c,0x00,0x00,0x00,0x00,
+
+        8, // 0x45 'E'
+        0x00,0x00,0x7f,0x33,0x31,0x34,0x3c,0x34,0x30,0x31,0x33,0x7f,0x00,0x00,0x00,0x00,
+
+        8, // 0x46 'F'
+        0x00,0x00,0x7f,0x33,0x31,0x34,0x3c,0x34,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00,
+
+        8, // 0x47 'G'
+        0x00,0x00,0x1f,0x33,0x61,0x60,0x60,0x6f,0x63,0x63,0x33,0x1e,0x00,0x00,0x00,0x00,
+
+        8, // 0x48 'H'
+        0x00,0x00,0x63,0x63,0x63,0x63,0x7f,0x63,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x49 'I'
+        0x00,0x00,0x1e,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
+
+        8, // 0x4a 'J'
+        0x00,0x00,0x0f,0x06,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x4b 'K'
+        0x00,0x00,0x73,0x33,0x36,0x36,0x3c,0x36,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00,
+
+        8, // 0x4c 'L'
+        0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x31,0x33,0x7f,0x00,0x00,0x00,0x00,
+
+        8, // 0x4d 'M'
+        0x00,0x00,0x63,0x63,0x77,0x77,0x7f,0x6b,0x6b,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x4e 'N'
+        0x00,0x00,0x63,0x63,0x73,0x7b,0x6f,0x67,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x4f 'O'
+        0x00,0x00,0x1c,0x36,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1c,0x00,0x00,0x00,0x00,
+
+        8, // 0x50 'P'
+        0x00,0x00,0x7e,0x33,0x33,0x33,0x33,0x3e,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00,
+
+        8, // 0x51 'Q'
+        0x00,0x00,0x1c,0x36,0x63,0x63,0x63,0x63,0x63,0x6f,0x36,0x1e,0x03,0x00,0x00,0x00,
+
+        8, // 0x52 'R'
+        0x00,0x00,0x7e,0x33,0x33,0x33,0x33,0x3e,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00,
+
+        8, // 0x53 'S'
+        0x00,0x00,0x3e,0x63,0x63,0x30,0x18,0x0c,0x06,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x54 'T'
+        0x00,0x00,0x3f,0x3f,0x2d,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
+
+        8, // 0x55 'U'
+        0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x56 'V'
+        0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1c,0x08,0x00,0x00,0x00,0x00,
+
+        8, // 0x57 'W'
+        0x00,0x00,0x63,0x63,0x63,0x6b,0x6b,0x7f,0x77,0x77,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x58 'X'
+        0x00,0x00,0x63,0x63,0x63,0x36,0x1c,0x1c,0x36,0x63,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x59 'Y'
+        0x00,0x00,0x33,0x33,0x33,0x33,0x1e,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
+
+        8, // 0x5a 'Z'
+        0x00,0x00,0x7f,0x63,0x43,0x06,0x0c,0x18,0x30,0x61,0x63,0x7f,0x00,0x00,0x00,0x00,
+
+        8, // 0x5b '['
+        0x00,0x1f,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x1f,0x00,0x00,0x00,
+
+        8, // 0x5c '\'
+        0x00,0x60,0x60,0x30,0x30,0x18,0x18,0x0c,0x0c,0x06,0x06,0x03,0x03,0x00,0x00,0x00,
+
+        8, // 0x5d ']'
+        0x00,0x7c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x7c,0x00,0x00,0x00,
+
+        8, // 0x5e '^'
+        0x00,0x00,0x08,0x1c,0x36,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5f '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,0x00,0x00,
+
+        8, // 0x60 '`'
+        0x00,0x00,0x18,0x18,0x18,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x3c,0x66,0x06,0x3e,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
+
+        8, // 0x62 'b'
+        0x00,0x00,0x70,0x30,0x30,0x3c,0x36,0x33,0x33,0x33,0x33,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x63,0x60,0x60,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x64 'd'
+        0x00,0x00,0x0e,0x06,0x06,0x1e,0x36,0x66,0x66,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
+
+        8, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x63,0x7f,0x60,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x66 'f'
+        0x00,0x00,0x0e,0x1b,0x1b,0x18,0x3c,0x18,0x18,0x18,0x18,0x3c,0x00,0x00,0x00,0x00,
+
+        8, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x3b,0x66,0x66,0x66,0x66,0x66,0x3e,0x06,0x66,0x3c,0x00,
+
+        8, // 0x68 'h'
+        0x00,0x00,0x70,0x30,0x30,0x36,0x3b,0x33,0x33,0x33,0x33,0x73,0x00,0x00,0x00,0x00,
+
+        8, // 0x69 'i'
+        0x00,0x00,0x0c,0x0c,0x00,0x1c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
+
+        8, // 0x6a 'j'
+        0x00,0x00,0x06,0x06,0x00,0x0e,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3c,0x00,0x00,
+
+        8, // 0x6b 'k'
+        0x00,0x00,0x70,0x30,0x30,0x33,0x33,0x36,0x3c,0x36,0x33,0x73,0x00,0x00,0x00,0x00,
+
+        8, // 0x6c 'l'
+        0x00,0x00,0x1c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x1e,0x00,0x00,0x00,0x00,
+
+        8, // 0x6d 'm'
+        0x00,0x00,0x00,0x00,0x00,0x76,0x7f,0x6b,0x6b,0x6b,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x6e 'n'
+        0x00,0x00,0x00,0x00,0x00,0x6e,0x33,0x33,0x33,0x33,0x33,0x33,0x00,0x00,0x00,0x00,
+
+        8, // 0x6f 'o'
+        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x63,0x63,0x63,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x6e,0x33,0x33,0x33,0x33,0x33,0x3e,0x30,0x30,0x78,0x00,
+
+        8, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x3b,0x66,0x66,0x66,0x66,0x66,0x3e,0x06,0x06,0x0f,0x00,
+
+        8, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x6e,0x3b,0x33,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00,
+
+        8, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x3e,0x63,0x60,0x3e,0x03,0x63,0x3e,0x00,0x00,0x00,0x00,
+
+        8, // 0x74 't'
+        0x00,0x00,0x08,0x18,0x18,0x7e,0x18,0x18,0x18,0x18,0x1b,0x0e,0x00,0x00,0x00,0x00,
+
+        8, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x66,0x3b,0x00,0x00,0x00,0x00,
+
+        8, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x63,0x36,0x1c,0x08,0x00,0x00,0x00,0x00,
+
+        8, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x6b,0x6b,0x7f,0x36,0x36,0x00,0x00,0x00,0x00,
+
+        8, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x36,0x1c,0x36,0x63,0x63,0x00,0x00,0x00,0x00,
+
+        8, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x3f,0x03,0x06,0x7c,0x00,
+
+        8, // 0x7a 'z'
+        0x00,0x00,0x00,0x00,0x00,0x7f,0x63,0x06,0x0c,0x18,0x31,0x7f,0x00,0x00,0x00,0x00,
+
+        8, // 0x7b '{'
+        0x00,0x03,0x04,0x0c,0x0c,0x0c,0x08,0x30,0x08,0x0c,0x0c,0x0c,0x04,0x03,0x00,0x00,
+
+        8, // 0x7c '|'
+        0x00,0x00,0x0c,0x0c,0x0c,0x0c,0x0c,0x00,0x0c,0x0c,0x0c,0x0c,0x0c,0x00,0x00,0x00,
+
+        8, // 0x7d '}'
+        0x00,0x60,0x10,0x18,0x18,0x18,0x08,0x06,0x08,0x18,0x18,0x18,0x10,0x60,0x00,0x00,
+
+        8, // 0x7e '~'
+        0x00,0x00,0x3b,0x6e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x7f ''
+        0x00,0x00,0x00,0x00,0x00,0x08,0x1c,0x36,0x63,0x63,0x7f,0x00,0x00,0x00,0x00,0x00,
+        0
+    };
+
+    const int8u mcs11_prop[] = 
+    {
+        11, 2, 32, 128-32,
+        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
+        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
+        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
+        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
+        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
+        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
+        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
+        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
+        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
+        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
+        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
+
+        4, // 0x22 '"'
+        0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x23 '#'
+        0x00,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x00,
+
+        6, // 0x24 '$'
+        0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,
+
+        6, // 0x25 '%'
+        0x00,0x00,0x68,0xA8,0xD0,0x10,0x20,0x2C,0x54,0x58,0x00,
+
+        6, // 0x26 '&'
+        0x00,0x20,0x50,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,
+
+        3, // 0x27 '''
+        0x40,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x28 '('
+        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
+
+        5, // 0x29 ')'
+        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
+
+        6, // 0x2A '*'
+        0x00,0x00,0x28,0x7C,0x38,0x7C,0x28,0x00,0x00,0x00,0x00,
+
+        6, // 0x2B '+'
+        0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0xC0,
+
+        6, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,
+
+        7, // 0x2F '/'
+        0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,
+
+        6, // 0x30 '0'
+        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,
+
+        4, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        6, // 0x32 '2'
+        0x00,0x38,0x44,0x44,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,
+
+        6, // 0x33 '3'
+        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x08,0x18,0x18,0x28,0x28,0x48,0x7C,0x08,0x08,0x00,
+
+        6, // 0x35 '5'
+        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,
+
+        6, // 0x36 '6'
+        0x00,0x38,0x44,0x40,0x40,0x78,0x44,0x44,0x44,0x38,0x00,
+
+        6, // 0x37 '7'
+        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,
+
+        6, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,
+
+        6, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,
+
+        4, // 0x3A ':'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,
+
+        4, // 0x3B ';'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0xC0,
+
+        6, // 0x3C '<'
+        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
+
+        6, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,
+
+        6, // 0x3E '>'
+        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,
+
+        6, // 0x40 '@'
+        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,
+
+        6, // 0x41 'A'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,
+
+        6, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,
+
+        6, // 0x44 'D'
+        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,
+
+        6, // 0x45 'E'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,
+
+        6, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,
+
+        6, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,
+
+        4, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x08,0x48,0x30,0x00,
+
+        6, // 0x4B 'K'
+        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,
+
+        8, // 0x4D 'M'
+        0x00,0x41,0x63,0x55,0x49,0x49,0x41,0x41,0x41,0x41,0x00,
+
+        7, // 0x4E 'N'
+        0x00,0x42,0x42,0x62,0x52,0x4A,0x46,0x42,0x42,0x42,0x00,
+
+        6, // 0x4F 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,
+
+        6, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x40,0x00,
+
+        6, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,
+
+        6, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x44,0x00,
+
+        6, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,
+
+        6, // 0x54 'T'
+        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
+
+        6, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,
+
+        8, // 0x57 'W'
+        0x00,0x41,0x41,0x41,0x41,0x49,0x49,0x49,0x55,0x22,0x00,
+
+        6, // 0x58 'X'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,
+
+        6, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x10,0x00,
+
+        6, // 0x5A 'Z'
+        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,
+
+        5, // 0x5B '['
+        0x30,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x30,
+
+        7, // 0x5C '\'
+        0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
+
+        4, // 0x5D ']'
+        0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
+
+        6, // 0x5E '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,
+
+        4, // 0x60 '`'
+        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,
+
+        6, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,
+
+        6, // 0x64 'd'
+        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,
+
+        6, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x10,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        6, // 0x67 'g'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,
+
+        6, // 0x68 'h'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,
+
+        2, // 0x69 'i'
+        0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        3, // 0x6A 'j'
+        0x00,0x20,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,
+
+        5, // 0x6B 'k'
+        0x00,0x40,0x40,0x48,0x50,0x60,0x60,0x50,0x48,0x48,0x00,
+
+        2, // 0x6C 'l'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        8, // 0x6D 'm'
+        0x00,0x00,0x00,0x76,0x49,0x49,0x49,0x49,0x41,0x41,0x00,
+
+        6, // 0x6E 'n'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,
+
+        6, // 0x6F 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,
+
+        6, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
+
+        6, // 0x71 'q'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        6, // 0x73 's'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,
+
+        5, // 0x74 't'
+        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x28,0x10,0x00,
+
+        6, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,
+
+        8, // 0x77 'w'
+        0x00,0x00,0x00,0x41,0x41,0x41,0x41,0x49,0x49,0x36,0x00,
+
+        6, // 0x78 'x'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,
+
+        6, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x3C,0x04,0x08,0x70,
+
+        6, // 0x7A 'z'
+        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,
+
+        5, // 0x7B '{'
+        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,
+
+        3, // 0x7C '|'
+        0x00,0x40,0x40,0x40,0x40,0x00,0x40,0x40,0x40,0x40,0x00,
+
+        5, // 0x7D '}'
+        0xC0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xC0,
+
+        6, // 0x7E '~'
+        0x00,0x24,0x54,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x7F ''
+        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs11_prop_condensed[] = 
+    {
+        11, 2, 32, 128-32,
+        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
+        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
+        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
+        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
+        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
+        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
+        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
+        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
+        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
+        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
+        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
+
+        3, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        3, // 0x21 '!'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x40,0x00,
+
+        4, // 0x22 '"'
+        0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x23 '#'
+        0x00,0x50,0x50,0xF8,0x50,0x50,0x50,0xF8,0x50,0x50,0x00,
+
+        5, // 0x24 '$'
+        0x00,0x40,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x20,0x00,
+
+        5, // 0x25 '%'
+        0x00,0x00,0x90,0x90,0x20,0x20,0x40,0x40,0x90,0x90,0x00,
+
+        5, // 0x26 '&'
+        0x00,0x40,0xA0,0xA0,0xA0,0x40,0xA8,0x90,0x90,0x68,0x00,
+
+        5, // 0x27 '''
+        0x00,0x00,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
+
+        4, // 0x29 ')'
+        0x80,0x40,0x40,0x20,0x20,0x20,0x20,0x20,0x40,0x40,0x80,
+
+        5, // 0x2A '*'
+        0x00,0x00,0x90,0x60,0xF0,0x60,0x90,0x00,0x00,0x00,0x00,
+
+        5, // 0x2B '+'
+        0x00,0x00,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0xC0,
+
+        5, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x00,
+
+        6, // 0x2F '/'
+        0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
+
+        5, // 0x30 '0'
+        0x00,0x70,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
+
+        3, // 0x31 '1'
+        0x00,0x40,0xC0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        5, // 0x32 '2'
+        0x00,0x60,0x90,0x90,0x10,0x10,0x20,0x40,0x80,0xF0,0x00,
+
+        5, // 0x33 '3'
+        0x00,0x60,0x90,0x10,0x10,0x60,0x10,0x10,0x90,0x60,0x00,
+
+        5, // 0x34 '4'
+        0x00,0x10,0x30,0x30,0x50,0x50,0x90,0xF0,0x10,0x10,0x00,
+
+        5, // 0x35 '5'
+        0x00,0xF0,0x80,0x80,0xE0,0x90,0x10,0x10,0x90,0x60,0x00,
+
+        5, // 0x36 '6'
+        0x00,0x60,0x90,0x80,0x80,0xE0,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x37 '7'
+        0x00,0xF0,0x10,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x00,
+
+        5, // 0x38 '8'
+        0x00,0x60,0x90,0x90,0x90,0x60,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x39 '9'
+        0x00,0x60,0x90,0x90,0x90,0x70,0x10,0x10,0x90,0x60,0x00,
+
+        4, // 0x3A ':'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,
+
+        4, // 0x3B ';'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0xC0,
+
+        6, // 0x3C '<'
+        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x00,
+
+        5, // 0x3D '='
+        0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0xF0,0x00,0x00,0x00,
+
+        6, // 0x3E '>'
+        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,0x00,
+
+        5, // 0x3F '?'
+        0x00,0x60,0x90,0x10,0x10,0x20,0x40,0x00,0x40,0x00,0x00,
+
+        5, // 0x40 '@'
+        0x00,0x60,0x90,0x90,0xB0,0xB0,0xB0,0x80,0x80,0x70,0x00,
+
+        5, // 0x41 'A'
+        0x00,0x60,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x42 'B'
+        0x00,0xE0,0x90,0x90,0x90,0xE0,0x90,0x90,0x90,0xE0,0x00,
+
+        5, // 0x43 'C'
+        0x00,0x60,0x90,0x80,0x80,0x80,0x80,0x80,0x90,0x60,0x00,
+
+        5, // 0x44 'D'
+        0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
+
+        5, // 0x45 'E'
+        0x00,0xF0,0x80,0x80,0x80,0xF0,0x80,0x80,0x80,0xF0,0x00,
+
+        5, // 0x46 'F'
+        0x00,0xF0,0x80,0x80,0x80,0xF0,0x80,0x80,0x80,0x80,0x00,
+
+        5, // 0x47 'G'
+        0x00,0x70,0x80,0x80,0x80,0xB0,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x48 'H'
+        0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,
+
+        4, // 0x49 'I'
+        0x00,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,
+
+        5, // 0x4A 'J'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0xA0,0xA0,0x40,0x00,
+
+        5, // 0x4B 'K'
+        0x00,0x90,0x90,0xA0,0xA0,0xC0,0xA0,0xA0,0x90,0x90,0x00,
+
+        5, // 0x4C 'L'
+        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xF0,0x00,
+
+        6, // 0x4D 'M'
+        0x00,0x88,0xD8,0xA8,0xA8,0xA8,0x88,0x88,0x88,0x88,0x00,
+
+        5, // 0x4E 'N'
+        0x00,0x90,0x90,0xD0,0xD0,0xB0,0xB0,0x90,0x90,0x90,0x00,
+
+        5, // 0x4F 'O'
+        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x50 'P'
+        0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0x80,0x80,0x80,0x00,
+
+        5, // 0x51 'Q'
+        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x30,
+
+        5, // 0x52 'R'
+        0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0xA0,0x90,0x90,0x00,
+
+        5, // 0x53 'S'
+        0x00,0x60,0x90,0x80,0x80,0x60,0x10,0x10,0x90,0x60,0x00,
+
+        6, // 0x54 'T'
+        0x00,0xF8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x55 'U'
+        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x88,0x88,0x88,0x88,0x50,0x50,0x50,0x20,0x20,0x00,
+
+        6, // 0x57 'W'
+        0x00,0x88,0x88,0x88,0xA8,0xA8,0xA8,0xA8,0xA8,0x50,0x00,
+
+        5, // 0x58 'X'
+        0x00,0x90,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x90,0x00,
+
+        6, // 0x59 'Y'
+        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x5A 'Z'
+        0x00,0xF0,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0xF0,0x00,
+
+        4, // 0x5B '['
+        0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,0x00,
+
+        6, // 0x5C '\'
+        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
+
+        4, // 0x5D ']'
+        0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,0x00,
+
+        5, // 0x5E '^'
+        0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,
+
+        5, // 0x60 '`'
+        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x61 'a'
+        0x00,0x00,0x00,0x60,0x90,0x10,0x70,0x90,0x90,0x70,0x00,
+
+        5, // 0x62 'b'
+        0x00,0x80,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0xE0,0x00,
+
+        5, // 0x63 'c'
+        0x00,0x00,0x00,0x60,0x90,0x80,0x80,0x80,0x90,0x60,0x00,
+
+        5, // 0x64 'd'
+        0x00,0x10,0x10,0x10,0x70,0x90,0x90,0x90,0x90,0x70,0x00,
+
+        5, // 0x65 'e'
+        0x00,0x00,0x00,0x60,0x90,0x90,0xF0,0x80,0x90,0x60,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x20,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        5, // 0x67 'g'
+        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0x90,0x60,
+
+        5, // 0x68 'h'
+        0x00,0x80,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,
+
+        2, // 0x69 'i'
+        0x00,0x80,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,
+
+        4, // 0x6A 'j'
+        0x00,0x20,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,
+
+        5, // 0x6B 'k'
+        0x00,0x80,0x80,0x90,0x90,0xA0,0xC0,0xA0,0x90,0x90,0x00,
+
+        2, // 0x6C 'l'
+        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,
+
+        6, // 0x6D 'm'
+        0x00,0x00,0x00,0xD0,0xA8,0xA8,0xA8,0x88,0x88,0x88,0x00,
+
+        5, // 0x6E 'n'
+        0x00,0x00,0x00,0xA0,0xD0,0x90,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x6F 'o'
+        0x00,0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x70 'p'
+        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0x80,0x80,
+
+        5, // 0x71 'q'
+        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x90,0x70,0x10,0x10,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0xB8,0x48,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        5, // 0x73 's'
+        0x00,0x00,0x00,0x60,0x90,0x40,0x20,0x10,0x90,0x60,0x00,
+
+        4, // 0x74 't'
+        0x00,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x20,0x00,
+
+        5, // 0x75 'u'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x70,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x50,0x20,0x20,0x00,
+
+        6, // 0x77 'w'
+        0x00,0x00,0x00,0x88,0x88,0x88,0xA8,0xA8,0xA8,0x50,0x00,
+
+        5, // 0x78 'x'
+        0x00,0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,
+
+        5, // 0x79 'y'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x70,0x10,0x20,0xC0,
+
+        5, // 0x7A 'z'
+        0x00,0x00,0x00,0xF0,0x10,0x20,0x40,0x80,0x80,0xF0,0x00,
+
+        5, // 0x7B '{'
+        0x30,0x40,0x40,0x40,0x40,0x80,0x40,0x40,0x40,0x40,0x30,
+
+        3, // 0x7C '|'
+        0x00,0x40,0x40,0x40,0x40,0x00,0x40,0x40,0x40,0x40,0x00,
+
+        5, // 0x7D '}'
+        0xC0,0x20,0x20,0x20,0x20,0x10,0x20,0x20,0x20,0x20,0xC0,
+
+        5, // 0x7E '~'
+        0x00,0x40,0xA8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x7F ''
+        0x00,0x20,0x70,0xD8,0x88,0x88,0xF8,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs12_prop[] = 
+    {
+        12, 3, 32, 128-32,
+        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4E,0x00,0x5B,0x00,0x68,0x00,
+        0x75,0x00,0x82,0x00,0x8F,0x00,0x9C,0x00,0xA9,0x00,0xB6,0x00,0xC3,0x00,0xD0,0x00,0xDD,0x00,
+        0xEA,0x00,0xF7,0x00,0x04,0x01,0x11,0x01,0x1E,0x01,0x2B,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
+        0x5F,0x01,0x6C,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xA0,0x01,0xAD,0x01,0xBA,0x01,0xC7,0x01,
+        0xD4,0x01,0xE1,0x01,0xEE,0x01,0xFB,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2F,0x02,0x3C,0x02,
+        0x49,0x02,0x62,0x02,0x6F,0x02,0x7C,0x02,0x89,0x02,0x96,0x02,0xA3,0x02,0xB0,0x02,0xBD,0x02,
+        0xCA,0x02,0xD7,0x02,0xF0,0x02,0xFD,0x02,0x0A,0x03,0x17,0x03,0x24,0x03,0x31,0x03,0x3E,0x03,
+        0x4B,0x03,0x58,0x03,0x65,0x03,0x72,0x03,0x7F,0x03,0x8C,0x03,0x99,0x03,0xA6,0x03,0xB3,0x03,
+        0xC0,0x03,0xCD,0x03,0xDA,0x03,0xE7,0x03,0xF4,0x03,0x01,0x04,0x1A,0x04,0x27,0x04,0x34,0x04,
+        0x41,0x04,0x4E,0x04,0x5B,0x04,0x68,0x04,0x75,0x04,0x82,0x04,0x8F,0x04,0xA8,0x04,0xB5,0x04,
+        0xC2,0x04,0xCF,0x04,0xDC,0x04,0xE9,0x04,0xF6,0x04,0x03,0x05,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        4, // 0x22 '"'
+        0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x23 '#'
+        0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x00,
+
+        6, // 0x24 '$'
+        0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,0x00,
+
+        7, // 0x25 '%'
+        0x32,0x54,0x64,0x08,0x08,0x10,0x10,0x26,0x2A,0x4C,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x30,0x48,0x48,0x48,0x30,0x4A,0x4A,0x44,0x3A,0x00,0x00,
+
+        3, // 0x27 '''
+        0x40,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x00,
+
+        5, // 0x29 ')'
+        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,0x00,
+
+        6, // 0x2A '*'
+        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,
+
+        6, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x40,0x80,
+
+        6, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        7, // 0x2F '/'
+        0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,0x00,
+
+        4, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x08,0x18,0x28,0x28,0x48,0x48,0x7C,0x08,0x08,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x37 '7'
+        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        4, // 0x3A ':'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        4, // 0x3B ';'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x40,0x80,
+
+        6, // 0x3C '<'
+        0x00,0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
+
+        6, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,
+
+        6, // 0x3E '>'
+        0x00,0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
+
+        6, // 0x45 'E'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
+
+        6, // 0x4B 'K'
+        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        9, // 0x4D 'M'
+        0x00,0x00,0x41,0x00,0x63,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x4E 'N'
+        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x44,0x00,0x00,
+
+        7, // 0x4F 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x54 'T'
+        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        9, // 0x57 'W'
+        0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x22,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x5A 'Z'
+        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,
+
+        4, // 0x5B '['
+        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,
+
+        7, // 0x5C '\'
+        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
+
+        4, // 0x5D ']'
+        0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xE0,0x00,
+
+        6, // 0x5E '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
+
+        4, // 0x60 '`'
+        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x78,
+
+        7, // 0x68 'h'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x10,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x90,0x60,
+
+        6, // 0x6B 'k'
+        0x00,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        9, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x76,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x6E 'n'
+        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x6F 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
+
+        5, // 0x74 't'
+        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x18,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        9, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x36,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3C,0x08,0x70,
+
+        6, // 0x7A 'z'
+        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        5, // 0x7B '{'
+        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,
+
+        3, // 0x7C '|'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        5, // 0x7D '}'
+        0xC0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xC0,0x00,
+
+        7, // 0x7E '~'
+        0x00,0x60,0x92,0x92,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7F ''
+        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs13_prop[] = 
+    {
+        13, 4, 32, 128-32,
+        0x00,0x00,0x0E,0x00,0x1C,0x00,0x2A,0x00,0x38,0x00,0x46,0x00,0x54,0x00,0x62,0x00,0x70,0x00,
+        0x7E,0x00,0x8C,0x00,0x9A,0x00,0xA8,0x00,0xB6,0x00,0xC4,0x00,0xD2,0x00,0xE0,0x00,0xEE,0x00,
+        0xFC,0x00,0x0A,0x01,0x18,0x01,0x26,0x01,0x34,0x01,0x42,0x01,0x50,0x01,0x5E,0x01,0x6C,0x01,
+        0x7A,0x01,0x88,0x01,0x96,0x01,0xA4,0x01,0xB2,0x01,0xC0,0x01,0xCE,0x01,0xDC,0x01,0xEA,0x01,
+        0xF8,0x01,0x06,0x02,0x14,0x02,0x22,0x02,0x30,0x02,0x3E,0x02,0x4C,0x02,0x5A,0x02,0x68,0x02,
+        0x76,0x02,0x91,0x02,0x9F,0x02,0xAD,0x02,0xBB,0x02,0xC9,0x02,0xD7,0x02,0xE5,0x02,0xF3,0x02,
+        0x01,0x03,0x0F,0x03,0x2A,0x03,0x38,0x03,0x46,0x03,0x54,0x03,0x62,0x03,0x70,0x03,0x7E,0x03,
+        0x8C,0x03,0x9A,0x03,0xA8,0x03,0xB6,0x03,0xC4,0x03,0xD2,0x03,0xE0,0x03,0xEE,0x03,0xFC,0x03,
+        0x0A,0x04,0x18,0x04,0x26,0x04,0x34,0x04,0x42,0x04,0x50,0x04,0x6B,0x04,0x79,0x04,0x87,0x04,
+        0x95,0x04,0xA3,0x04,0xB1,0x04,0xBF,0x04,0xCD,0x04,0xDB,0x04,0xE9,0x04,0x04,0x05,0x12,0x05,
+        0x20,0x05,0x2E,0x05,0x3C,0x05,0x4A,0x05,0x58,0x05,0x66,0x05,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        4, // 0x22 '"'
+        0x00,0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x23 '#'
+        0x00,0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x28,0x00,
+
+        6, // 0x24 '$'
+        0x00,0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,0x00,
+
+        7, // 0x25 '%'
+        0x00,0x32,0x54,0x64,0x08,0x08,0x10,0x10,0x26,0x2A,0x4C,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x30,0x48,0x48,0x48,0x30,0x4A,0x4A,0x44,0x3A,0x00,0x00,0x00,
+
+        3, // 0x27 '''
+        0x00,0x40,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x00,0x00,
+
+        5, // 0x29 ')'
+        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,0x00,0x00,
+
+        6, // 0x2A '*'
+        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,0x00,
+
+        6, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x20,0x40,0x80,
+
+        6, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,
+
+        7, // 0x2F '/'
+        0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        4, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x08,0x18,0x28,0x28,0x48,0x48,0x7C,0x08,0x08,0x00,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        6, // 0x37 '7'
+        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        4, // 0x3A ':'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,
+
+        4, // 0x3B ';'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x20,0x40,0x80,
+
+        6, // 0x3C '<'
+        0x00,0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,
+
+        6, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x3E '>'
+        0x00,0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,0x00,
+
+        6, // 0x45 'E'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,0x00,
+
+        6, // 0x4B 'K'
+        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,0x00,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
+
+        9, // 0x4D 'M'
+        0x00,0x00,0x41,0x00,0x63,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x4E 'N'
+        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x4F 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        6, // 0x54 'T'
+        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
+
+        9, // 0x57 'W'
+        0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        6, // 0x5A 'Z'
+        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,0x00,
+
+        4, // 0x5B '['
+        0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,0x00,
+
+        7, // 0x5C '\'
+        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,0x00,
+
+        4, // 0x5D ']'
+        0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xE0,0x00,0x00,
+
+        6, // 0x5E '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,
+
+        4, // 0x60 '`'
+        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,
+
+        7, // 0x68 'h'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x10,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x90,0x60,0x00,
+
+        6, // 0x6B 'k'
+        0x00,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        9, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x76,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x6E 'n'
+        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x6F 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,0x04,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        5, // 0x74 't'
+        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x20,0x18,0x00,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
+
+        9, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x36,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x08,0x70,
+
+        6, // 0x7A 'z'
+        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
+
+        5, // 0x7B '{'
+        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,0x00,
+
+        3, // 0x7C '|'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        5, // 0x7D '}'
+        0xC0,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0xC0,0x00,0x00,
+
+        7, // 0x7E '~'
+        0x00,0x60,0x92,0x92,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7F ''
+        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs5x10_mono[] = 
+    {
+        10, 2, 32, 128-32,
+        0x00,0x00,0x0B,0x00,0x16,0x00,0x21,0x00,0x2C,0x00,0x37,0x00,0x42,0x00,0x4D,0x00,0x58,0x00,
+        0x63,0x00,0x6E,0x00,0x79,0x00,0x84,0x00,0x8F,0x00,0x9A,0x00,0xA5,0x00,0xB0,0x00,0xBB,0x00,
+        0xC6,0x00,0xD1,0x00,0xDC,0x00,0xE7,0x00,0xF2,0x00,0xFD,0x00,0x08,0x01,0x13,0x01,0x1E,0x01,
+        0x29,0x01,0x34,0x01,0x3F,0x01,0x4A,0x01,0x55,0x01,0x60,0x01,0x6B,0x01,0x76,0x01,0x81,0x01,
+        0x8C,0x01,0x97,0x01,0xA2,0x01,0xAD,0x01,0xB8,0x01,0xC3,0x01,0xCE,0x01,0xD9,0x01,0xE4,0x01,
+        0xEF,0x01,0xFA,0x01,0x05,0x02,0x10,0x02,0x1B,0x02,0x26,0x02,0x31,0x02,0x3C,0x02,0x47,0x02,
+        0x52,0x02,0x5D,0x02,0x68,0x02,0x73,0x02,0x7E,0x02,0x89,0x02,0x94,0x02,0x9F,0x02,0xAA,0x02,
+        0xB5,0x02,0xC0,0x02,0xCB,0x02,0xD6,0x02,0xE1,0x02,0xEC,0x02,0xF7,0x02,0x02,0x03,0x0D,0x03,
+        0x18,0x03,0x23,0x03,0x2E,0x03,0x39,0x03,0x44,0x03,0x4F,0x03,0x5A,0x03,0x65,0x03,0x70,0x03,
+        0x7B,0x03,0x86,0x03,0x91,0x03,0x9C,0x03,0xA7,0x03,0xB2,0x03,0xBD,0x03,0xC8,0x03,0xD3,0x03,
+        0xDE,0x03,0xE9,0x03,0xF4,0x03,0xFF,0x03,0x0A,0x04,0x15,0x04,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x23 '#'
+        0x00,0x50,0x50,0xF8,0x50,0x50,0x50,0xF8,0x50,0x50,
+
+        5, // 0x24 '$'
+        0x00,0x40,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x20,
+
+        5, // 0x25 '%'
+        0x00,0x00,0x90,0x90,0x20,0x20,0x40,0x40,0x90,0x90,
+
+        5, // 0x26 '&'
+        0x00,0x40,0xA0,0xA0,0xA0,0x40,0xA8,0x90,0x90,0x68,
+
+        5, // 0x27 '''
+        0x00,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
+
+        5, // 0x29 ')'
+        0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
+
+        5, // 0x2A '*'
+        0x00,0x00,0x90,0x60,0xF0,0x60,0x90,0x00,0x00,0x00,
+
+        5, // 0x2B '+'
+        0x00,0x00,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0xC0,
+
+        5, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,
+
+        5, // 0x2F '/'
+        0x00,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x00,
+
+        5, // 0x30 '0'
+        0x00,0x70,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
+
+        5, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x32 '2'
+        0x00,0x60,0x90,0x90,0x10,0x20,0x40,0x80,0xF0,0x00,
+
+        5, // 0x33 '3'
+        0x00,0x60,0x90,0x10,0x60,0x10,0x10,0x90,0x60,0x00,
+
+        5, // 0x34 '4'
+        0x00,0x10,0x30,0x50,0x50,0x90,0xF0,0x10,0x10,0x00,
+
+        5, // 0x35 '5'
+        0x00,0xF0,0x80,0x80,0xE0,0x10,0x10,0x90,0x60,0x00,
+
+        5, // 0x36 '6'
+        0x00,0x60,0x80,0x80,0xE0,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x37 '7'
+        0x00,0xF0,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x00,
+
+        5, // 0x38 '8'
+        0x00,0x60,0x90,0x90,0x60,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x39 '9'
+        0x00,0x60,0x90,0x90,0x90,0x70,0x10,0x10,0x60,0x00,
+
+        5, // 0x3A ':'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x00,
+
+        5, // 0x3B ';'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0xC0,
+
+        5, // 0x3C '<'
+        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,
+
+        5, // 0x3D '='
+        0x00,0x00,0x00,0x00,0xF0,0x00,0xF0,0x00,0x00,0x00,
+
+        5, // 0x3E '>'
+        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,
+
+        5, // 0x3F '?'
+        0x00,0x60,0x90,0x10,0x10,0x20,0x40,0x00,0x40,0x00,
+
+        5, // 0x40 '@'
+        0x00,0x60,0x90,0x90,0xB0,0xB0,0x80,0x80,0x70,0x00,
+
+        5, // 0x41 'A'
+        0x00,0x60,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x00,
+
+        5, // 0x42 'B'
+        0x00,0xE0,0x90,0x90,0xE0,0x90,0x90,0x90,0xE0,0x00,
+
+        5, // 0x43 'C'
+        0x00,0x60,0x90,0x80,0x80,0x80,0x80,0x90,0x60,0x00,
+
+        5, // 0x44 'D'
+        0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,
+
+        5, // 0x45 'E'
+        0x00,0xF0,0x80,0x80,0xF0,0x80,0x80,0x80,0xF0,0x00,
+
+        5, // 0x46 'F'
+        0x00,0xF0,0x80,0x80,0xF0,0x80,0x80,0x80,0x80,0x00,
+
+        5, // 0x47 'G'
+        0x00,0x60,0x90,0x80,0x80,0xB0,0x90,0x90,0x60,0x00,
+
+        5, // 0x48 'H'
+        0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x4A 'J'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,0x00,
+
+        5, // 0x4B 'K'
+        0x00,0x90,0xA0,0xA0,0xC0,0xC0,0xA0,0xA0,0x90,0x00,
+
+        5, // 0x4C 'L'
+        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xF0,0x00,
+
+        5, // 0x4D 'M'
+        0x00,0x90,0x90,0xF0,0xF0,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x4E 'N'
+        0x00,0x90,0x90,0xD0,0xD0,0xB0,0xB0,0x90,0x90,0x00,
+
+        5, // 0x4F 'O'
+        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x50 'P'
+        0x00,0xE0,0x90,0x90,0x90,0xE0,0x80,0x80,0x80,0x00,
+
+        5, // 0x51 'Q'
+        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x30,
+
+        5, // 0x52 'R'
+        0x00,0xE0,0x90,0x90,0x90,0xE0,0xA0,0x90,0x90,0x00,
+
+        5, // 0x53 'S'
+        0x00,0x60,0x90,0x80,0x60,0x10,0x90,0x90,0x60,0x00,
+
+        5, // 0x54 'T'
+        0x00,0xF8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x55 'U'
+        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x56 'V'
+        0x00,0x90,0x90,0x90,0x50,0x50,0x50,0x20,0x20,0x00,
+
+        5, // 0x57 'W'
+        0x00,0x90,0x90,0x90,0x90,0x90,0xF0,0xF0,0x90,0x00,
+
+        5, // 0x58 'X'
+        0x00,0x90,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,
+
+        5, // 0x59 'Y'
+        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x5A 'Z'
+        0x00,0xF0,0x10,0x20,0x20,0x40,0x40,0x80,0xF0,0x00,
+
+        5, // 0x5B '['
+        0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,
+
+        5, // 0x5C '\'
+        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,
+
+        5, // 0x5D ']'
+        0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
+
+        5, // 0x5E '^'
+        0x00,0x20,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,
+
+        5, // 0x60 '`'
+        0x00,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x61 'a'
+        0x00,0x00,0x00,0x60,0x10,0x70,0x90,0x90,0x70,0x00,
+
+        5, // 0x62 'b'
+        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0xE0,0x00,
+
+        5, // 0x63 'c'
+        0x00,0x00,0x00,0x60,0x90,0x80,0x80,0x90,0x60,0x00,
+
+        5, // 0x64 'd'
+        0x00,0x10,0x10,0x70,0x90,0x90,0x90,0x90,0x70,0x00,
+
+        5, // 0x65 'e'
+        0x00,0x00,0x00,0x60,0x90,0x90,0xF0,0x80,0x70,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x00,
+
+        5, // 0x67 'g'
+        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0xE0,
+
+        5, // 0x68 'h'
+        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x69 'i'
+        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0xC0,
+
+        5, // 0x6B 'k'
+        0x00,0x80,0x80,0x90,0xA0,0xC0,0xA0,0x90,0x90,0x00,
+
+        5, // 0x6C 'l'
+        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,
+
+        5, // 0x6D 'm'
+        0x00,0x00,0x00,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x6E 'n'
+        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,
+
+        5, // 0x6F 'o'
+        0x00,0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x60,0x00,
+
+        5, // 0x70 'p'
+        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0xE0,0x80,0x80,
+
+        5, // 0x71 'q'
+        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x70,0x10,0x10,
+
+        5, // 0x72 'r'
+        0x00,0x00,0x00,0xB0,0x50,0x40,0x40,0x40,0xE0,0x00,
+
+        5, // 0x73 's'
+        0x00,0x00,0x00,0x60,0x90,0x40,0x20,0x90,0x60,0x00,
+
+        5, // 0x74 't'
+        0x00,0x40,0x40,0xE0,0x40,0x40,0x40,0x50,0x20,0x00,
+
+        5, // 0x75 'u'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x00,
+
+        5, // 0x76 'v'
+        0x00,0x00,0x00,0x90,0x90,0x50,0x50,0x20,0x20,0x00,
+
+        5, // 0x77 'w'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x00,
+
+        5, // 0x78 'x'
+        0x00,0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x00,
+
+        5, // 0x79 'y'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x70,0x10,0xE0,
+
+        5, // 0x7A 'z'
+        0x00,0x00,0x00,0xF0,0x10,0x20,0x40,0x80,0xF0,0x00,
+
+        5, // 0x7B '{'
+        0x30,0x40,0x40,0x40,0x80,0x40,0x40,0x40,0x40,0x30,
+
+        5, // 0x7C '|'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
+
+        5, // 0x7D '}'
+        0xC0,0x20,0x20,0x20,0x10,0x20,0x20,0x20,0x20,0xC0,
+
+        5, // 0x7E '~'
+        0x00,0x40,0xA8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x7F ''
+        0x00,0x20,0x70,0xD8,0x88,0x88,0xF8,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs5x11_mono[] = 
+    {
+        11, 3, 32, 128-32,
+        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
+        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
+        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
+        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
+        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
+        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
+        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
+        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
+        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
+        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
+        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x50,0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x23 '#'
+        0x00,0x50,0x50,0xF8,0x50,0x50,0x50,0xF8,0x50,0x50,0x00,
+
+        5, // 0x24 '$'
+        0x00,0x40,0x60,0x90,0x80,0x60,0x10,0x90,0x60,0x20,0x00,
+
+        5, // 0x25 '%'
+        0x00,0x00,0x90,0x90,0x20,0x20,0x40,0x40,0x90,0x90,0x00,
+
+        5, // 0x26 '&'
+        0x00,0x40,0xA0,0xA0,0x40,0xA8,0x90,0x90,0x68,0x00,0x00,
+
+        5, // 0x27 '''
+        0x00,0x20,0x20,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x00,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
+
+        5, // 0x29 ')'
+        0x00,0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
+
+        5, // 0x2A '*'
+        0x00,0x00,0x90,0x60,0xF0,0x60,0x90,0x00,0x00,0x00,0x00,
+
+        5, // 0x2B '+'
+        0x00,0x00,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x40,0x80,
+
+        5, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        5, // 0x2F '/'
+        0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
+
+        5, // 0x30 '0'
+        0x00,0x70,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,0x00,
+
+        5, // 0x31 '1'
+        0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        5, // 0x32 '2'
+        0x00,0x60,0x90,0x90,0x10,0x20,0x40,0x80,0xF0,0x00,0x00,
+
+        5, // 0x33 '3'
+        0x00,0x60,0x90,0x10,0x60,0x10,0x10,0x90,0x60,0x00,0x00,
+
+        5, // 0x34 '4'
+        0x00,0x10,0x30,0x50,0x50,0x90,0xF8,0x10,0x10,0x00,0x00,
+
+        5, // 0x35 '5'
+        0x00,0xF0,0x80,0xE0,0x90,0x10,0x10,0x90,0x60,0x00,0x00,
+
+        5, // 0x36 '6'
+        0x00,0x60,0x90,0x80,0xE0,0x90,0x90,0x90,0x60,0x00,0x00,
+
+        5, // 0x37 '7'
+        0x00,0xF0,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x00,0x00,
+
+        5, // 0x38 '8'
+        0x00,0x60,0x90,0x90,0x60,0x90,0x90,0x90,0x60,0x00,0x00,
+
+        5, // 0x39 '9'
+        0x00,0x60,0x90,0x90,0x90,0x70,0x10,0x90,0x60,0x00,0x00,
+
+        5, // 0x3A ':'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        5, // 0x3B ';'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x40,0x80,
+
+        5, // 0x3C '<'
+        0x00,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x00,
+
+        5, // 0x3D '='
+        0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0xF0,0x00,0x00,0x00,
+
+        5, // 0x3E '>'
+        0x00,0x80,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x80,0x00,
+
+        5, // 0x3F '?'
+        0x00,0x60,0x90,0x10,0x10,0x20,0x40,0x00,0x40,0x00,0x00,
+
+        5, // 0x40 '@'
+        0x00,0x60,0x90,0x90,0xB0,0xB0,0x80,0x80,0x70,0x00,0x00,
+
+        5, // 0x41 'A'
+        0x00,0x60,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x00,0x00,
+
+        5, // 0x42 'B'
+        0x00,0xE0,0x90,0x90,0xE0,0x90,0x90,0x90,0xE0,0x00,0x00,
+
+        5, // 0x43 'C'
+        0x00,0x60,0x90,0x80,0x80,0x80,0x80,0x90,0x60,0x00,0x00,
+
+        5, // 0x44 'D'
+        0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x90,0xE0,0x00,0x00,
+
+        5, // 0x45 'E'
+        0x00,0xF0,0x80,0x80,0xE0,0x80,0x80,0x80,0xF0,0x00,0x00,
+
+        5, // 0x46 'F'
+        0x00,0xF0,0x80,0x80,0xE0,0x80,0x80,0x80,0x80,0x00,0x00,
+
+        5, // 0x47 'G'
+        0x00,0x60,0x90,0x80,0x80,0xB0,0x90,0x90,0x60,0x00,0x00,
+
+        5, // 0x48 'H'
+        0x00,0x90,0x90,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        5, // 0x4A 'J'
+        0x00,0x70,0x20,0x20,0x20,0x20,0xA0,0xA0,0x40,0x00,0x00,
+
+        5, // 0x4B 'K'
+        0x00,0x90,0xA0,0xA0,0xC0,0xA0,0xA0,0x90,0x90,0x00,0x00,
+
+        5, // 0x4C 'L'
+        0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xF0,0x00,0x00,
+
+        5, // 0x4D 'M'
+        0x00,0x90,0xF0,0xF0,0x90,0x90,0x90,0x90,0x90,0x00,0x00,
+
+        5, // 0x4E 'N'
+        0x00,0x90,0x90,0xD0,0xD0,0xB0,0xB0,0x90,0x90,0x00,0x00,
+
+        5, // 0x4F 'O'
+        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,0x00,
+
+        5, // 0x50 'P'
+        0x00,0xE0,0x90,0x90,0x90,0xE0,0x80,0x80,0x80,0x00,0x00,
+
+        5, // 0x51 'Q'
+        0x00,0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x30,0x00,
+
+        5, // 0x52 'R'
+        0x00,0xE0,0x90,0x90,0x90,0xE0,0xA0,0x90,0x90,0x00,0x00,
+
+        5, // 0x53 'S'
+        0x00,0x60,0x90,0x80,0x60,0x10,0x90,0x90,0x60,0x00,0x00,
+
+        5, // 0x54 'T'
+        0x00,0xF8,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        5, // 0x55 'U'
+        0x00,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x60,0x00,0x00,
+
+        5, // 0x56 'V'
+        0x00,0x90,0x90,0x90,0x50,0x50,0x50,0x20,0x20,0x00,0x00,
+
+        5, // 0x57 'W'
+        0x00,0x90,0x90,0x90,0x90,0x90,0xF0,0xF0,0x90,0x00,0x00,
+
+        5, // 0x58 'X'
+        0x00,0x90,0x90,0x90,0x60,0x60,0x90,0x90,0x90,0x00,0x00,
+
+        5, // 0x59 'Y'
+        0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x00,0x00,
+
+        5, // 0x5A 'Z'
+        0x00,0xF0,0x10,0x20,0x20,0x40,0x40,0x80,0xF0,0x00,0x00,
+
+        5, // 0x5B '['
+        0x00,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,
+
+        5, // 0x5C '\'
+        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
+
+        5, // 0x5D ']'
+        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
+
+        5, // 0x5E '^'
+        0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,
+
+        5, // 0x60 '`'
+        0x00,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x61 'a'
+        0x00,0x00,0x00,0x60,0x10,0x70,0x90,0x90,0x70,0x00,0x00,
+
+        5, // 0x62 'b'
+        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0xE0,0x00,0x00,
+
+        5, // 0x63 'c'
+        0x00,0x00,0x00,0x60,0x90,0x80,0x80,0x90,0x60,0x00,0x00,
+
+        5, // 0x64 'd'
+        0x00,0x10,0x10,0x70,0x90,0x90,0x90,0x90,0x70,0x00,0x00,
+
+        5, // 0x65 'e'
+        0x00,0x00,0x00,0x60,0x90,0x90,0xF0,0x80,0x70,0x00,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        5, // 0x67 'g'
+        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x90,0x70,0x10,0xE0,
+
+        5, // 0x68 'h'
+        0x00,0x80,0x80,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,0x00,
+
+        5, // 0x69 'i'
+        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0xA0,0x40,
+
+        5, // 0x6B 'k'
+        0x00,0x80,0x80,0x90,0xA0,0xC0,0xA0,0x90,0x90,0x00,0x00,
+
+        5, // 0x6C 'l'
+        0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        5, // 0x6D 'm'
+        0x00,0x00,0x00,0x90,0xF0,0x90,0x90,0x90,0x90,0x00,0x00,
+
+        5, // 0x6E 'n'
+        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0x90,0x00,0x00,
+
+        5, // 0x6F 'o'
+        0x00,0x00,0x00,0x60,0x90,0x90,0x90,0x90,0x60,0x00,0x00,
+
+        5, // 0x70 'p'
+        0x00,0x00,0x00,0xE0,0x90,0x90,0x90,0x90,0xE0,0x80,0x80,
+
+        5, // 0x71 'q'
+        0x00,0x00,0x00,0x70,0x90,0x90,0x90,0x90,0x70,0x10,0x10,
+
+        5, // 0x72 'r'
+        0x00,0x00,0x00,0xA0,0x50,0x40,0x40,0x40,0xE0,0x00,0x00,
+
+        5, // 0x73 's'
+        0x00,0x00,0x00,0x60,0x90,0x40,0x20,0x90,0x60,0x00,0x00,
+
+        5, // 0x74 't'
+        0x00,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x30,0x00,0x00,
+
+        5, // 0x75 'u'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x00,0x00,
+
+        5, // 0x76 'v'
+        0x00,0x00,0x00,0x90,0x90,0x50,0x50,0x20,0x20,0x00,0x00,
+
+        5, // 0x77 'w'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0xF0,0x90,0x00,0x00,
+
+        5, // 0x78 'x'
+        0x00,0x00,0x00,0x90,0x90,0x60,0x60,0x90,0x90,0x00,0x00,
+
+        5, // 0x79 'y'
+        0x00,0x00,0x00,0x90,0x90,0x90,0x90,0x90,0x70,0x10,0xE0,
+
+        5, // 0x7A 'z'
+        0x00,0x00,0x00,0xF0,0x10,0x20,0x40,0x80,0xF0,0x00,0x00,
+
+        5, // 0x7B '{'
+        0x30,0x40,0x40,0x40,0x40,0x80,0x40,0x40,0x40,0x40,0x30,
+
+        5, // 0x7C '|'
+        0x00,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x20,0x00,
+
+        5, // 0x7D '}'
+        0xC0,0x20,0x20,0x20,0x20,0x10,0x20,0x20,0x20,0x20,0xC0,
+
+        5, // 0x7E '~'
+        0x00,0x40,0xA8,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x7F ''
+        0x00,0x20,0x70,0xD8,0x88,0x88,0xF8,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs6x10_mono[] = 
+    {
+        10, 3, 32, 128-32,
+        0x00,0x00,0x0B,0x00,0x16,0x00,0x21,0x00,0x2C,0x00,0x37,0x00,0x42,0x00,0x4D,0x00,0x58,0x00,
+        0x63,0x00,0x6E,0x00,0x79,0x00,0x84,0x00,0x8F,0x00,0x9A,0x00,0xA5,0x00,0xB0,0x00,0xBB,0x00,
+        0xC6,0x00,0xD1,0x00,0xDC,0x00,0xE7,0x00,0xF2,0x00,0xFD,0x00,0x08,0x01,0x13,0x01,0x1E,0x01,
+        0x29,0x01,0x34,0x01,0x3F,0x01,0x4A,0x01,0x55,0x01,0x60,0x01,0x6B,0x01,0x76,0x01,0x81,0x01,
+        0x8C,0x01,0x97,0x01,0xA2,0x01,0xAD,0x01,0xB8,0x01,0xC3,0x01,0xCE,0x01,0xD9,0x01,0xE4,0x01,
+        0xEF,0x01,0xFA,0x01,0x05,0x02,0x10,0x02,0x1B,0x02,0x26,0x02,0x31,0x02,0x3C,0x02,0x47,0x02,
+        0x52,0x02,0x5D,0x02,0x68,0x02,0x73,0x02,0x7E,0x02,0x89,0x02,0x94,0x02,0x9F,0x02,0xAA,0x02,
+        0xB5,0x02,0xC0,0x02,0xCB,0x02,0xD6,0x02,0xE1,0x02,0xEC,0x02,0xF7,0x02,0x02,0x03,0x0D,0x03,
+        0x18,0x03,0x23,0x03,0x2E,0x03,0x39,0x03,0x44,0x03,0x4F,0x03,0x5A,0x03,0x65,0x03,0x70,0x03,
+        0x7B,0x03,0x86,0x03,0x91,0x03,0x9C,0x03,0xA7,0x03,0xB2,0x03,0xBD,0x03,0xC8,0x03,0xD3,0x03,
+        0xDE,0x03,0xE9,0x03,0xF4,0x03,0xFF,0x03,0x0A,0x04,0x15,0x04,
+
+        6, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x10,0x10,0x10,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        6, // 0x22 '"'
+        0x00,0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x23 '#'
+        0x00,0x28,0x28,0x7C,0x28,0x28,0x7C,0x28,0x28,0x00,
+
+        6, // 0x24 '$'
+        0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,
+
+        6, // 0x25 '%'
+        0x00,0x08,0xC8,0xD0,0x10,0x20,0x2C,0x4C,0x40,0x00,
+
+        6, // 0x26 '&'
+        0x00,0x20,0x50,0x50,0x24,0x54,0x48,0x34,0x00,0x00,
+
+        6, // 0x27 '''
+        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x28 '('
+        0x08,0x10,0x10,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
+
+        6, // 0x29 ')'
+        0x20,0x10,0x10,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
+
+        6, // 0x2A '*'
+        0x00,0x00,0x28,0x7C,0x38,0x7C,0x28,0x00,0x00,0x00,
+
+        6, // 0x2B '+'
+        0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
+
+        6, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
+
+        6, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        6, // 0x2F '/'
+        0x00,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,
+
+        6, // 0x30 '0'
+        0x00,0x38,0x44,0x4C,0x54,0x64,0x44,0x38,0x00,0x00,
+
+        6, // 0x31 '1'
+        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x32 '2'
+        0x00,0x38,0x44,0x04,0x18,0x20,0x40,0x7C,0x00,0x00,
+
+        6, // 0x33 '3'
+        0x00,0x38,0x44,0x04,0x38,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x08,0x18,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,
+
+        6, // 0x35 '5'
+        0x00,0x7C,0x40,0x40,0x78,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x36 '6'
+        0x00,0x38,0x40,0x40,0x78,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x37 '7'
+        0x00,0x7C,0x04,0x08,0x10,0x20,0x20,0x20,0x00,0x00,
+
+        6, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x3C,0x04,0x04,0x38,0x00,0x00,
+
+        6, // 0x3A ':'
+        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        6, // 0x3B ';'
+        0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x20,0x40,
+
+        6, // 0x3C '<'
+        0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
+
+        6, // 0x3D '='
+        0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,
+
+        6, // 0x3E '>'
+        0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x38,0x44,0x04,0x18,0x10,0x00,0x10,0x00,0x00,
+
+        6, // 0x40 '@'
+        0x00,0x38,0x44,0x5C,0x54,0x5C,0x40,0x38,0x00,0x00,
+
+        6, // 0x41 'A'
+        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x00,0x00,
+
+        6, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        6, // 0x44 'D'
+        0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x45 'E'
+        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        6, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x4C,0x44,0x44,0x3C,0x00,0x00,
+
+        6, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x49 'I'
+        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x1C,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
+
+        6, // 0x4B 'K'
+        0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x4D 'M'
+        0x00,0x44,0x6C,0x54,0x54,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x4E 'N'
+        0x00,0x44,0x44,0x64,0x54,0x4C,0x44,0x44,0x00,0x00,
+
+        6, // 0x4F 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        6, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
+
+        6, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
+
+        6, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x54 'T'
+        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x10,0x00,0x00,
+
+        6, // 0x57 'W'
+        0x00,0x44,0x44,0x54,0x54,0x54,0x54,0x28,0x00,0x00,
+
+        6, // 0x58 'X'
+        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
+
+        6, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x5A 'Z'
+        0x00,0x78,0x08,0x10,0x20,0x40,0x40,0x78,0x00,0x00,
+
+        6, // 0x5B '['
+        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
+
+        6, // 0x5C '\'
+        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
+
+        6, // 0x5D ']'
+        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
+
+        6, // 0x5E '^'
+        0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
+
+        6, // 0x60 '`'
+        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x3C,0x00,0x00,
+
+        6, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x3C,0x00,0x00,
+
+        6, // 0x64 'd'
+        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        6, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x78,0x40,0x3C,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x0C,0x10,0x10,0x38,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x67 'g'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x3C,0x04,0x38,
+
+        6, // 0x68 'h'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x69 'i'
+        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x6A 'j'
+        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x48,0x30,
+
+        6, // 0x6B 'k'
+        0x00,0x40,0x40,0x48,0x50,0x60,0x50,0x48,0x00,0x00,
+
+        6, // 0x6C 'l'
+        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x6D 'm'
+        0x00,0x00,0x00,0x68,0x54,0x54,0x44,0x44,0x00,0x00,
+
+        6, // 0x6E 'n'
+        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x6F 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,
+
+        6, // 0x71 'q'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x3C,0x04,0x04,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x70,0x00,0x00,
+
+        6, // 0x73 's'
+        0x00,0x00,0x00,0x38,0x40,0x38,0x04,0x78,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x10,0x10,0x38,0x10,0x10,0x14,0x08,0x00,0x00,
+
+        6, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x10,0x00,0x00,
+
+        6, // 0x77 'w'
+        0x00,0x00,0x00,0x44,0x44,0x54,0x7C,0x28,0x00,0x00,
+
+        6, // 0x78 'x'
+        0x00,0x00,0x00,0x48,0x48,0x30,0x48,0x48,0x00,0x00,
+
+        6, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x3C,0x04,0x38,
+
+        6, // 0x7A 'z'
+        0x00,0x00,0x00,0x78,0x08,0x30,0x40,0x78,0x00,0x00,
+
+        6, // 0x7B '{'
+        0x18,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x18,0x00,
+
+        6, // 0x7C '|'
+        0x10,0x10,0x10,0x10,0x00,0x10,0x10,0x10,0x10,0x00,
+
+        6, // 0x7D '}'
+        0x60,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x60,0x00,
+
+        6, // 0x7E '~'
+        0x00,0x48,0xA8,0x90,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x7F ''
+        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs6x11_mono[] = 
+    {
+        11, 3, 32, 128-32,
+        0x00,0x00,0x0C,0x00,0x18,0x00,0x24,0x00,0x30,0x00,0x3C,0x00,0x48,0x00,0x54,0x00,0x60,0x00,
+        0x6C,0x00,0x78,0x00,0x84,0x00,0x90,0x00,0x9C,0x00,0xA8,0x00,0xB4,0x00,0xC0,0x00,0xCC,0x00,
+        0xD8,0x00,0xE4,0x00,0xF0,0x00,0xFC,0x00,0x08,0x01,0x14,0x01,0x20,0x01,0x2C,0x01,0x38,0x01,
+        0x44,0x01,0x50,0x01,0x5C,0x01,0x68,0x01,0x74,0x01,0x80,0x01,0x8C,0x01,0x98,0x01,0xA4,0x01,
+        0xB0,0x01,0xBC,0x01,0xC8,0x01,0xD4,0x01,0xE0,0x01,0xEC,0x01,0xF8,0x01,0x04,0x02,0x10,0x02,
+        0x1C,0x02,0x28,0x02,0x34,0x02,0x40,0x02,0x4C,0x02,0x58,0x02,0x64,0x02,0x70,0x02,0x7C,0x02,
+        0x88,0x02,0x94,0x02,0xA0,0x02,0xAC,0x02,0xB8,0x02,0xC4,0x02,0xD0,0x02,0xDC,0x02,0xE8,0x02,
+        0xF4,0x02,0x00,0x03,0x0C,0x03,0x18,0x03,0x24,0x03,0x30,0x03,0x3C,0x03,0x48,0x03,0x54,0x03,
+        0x60,0x03,0x6C,0x03,0x78,0x03,0x84,0x03,0x90,0x03,0x9C,0x03,0xA8,0x03,0xB4,0x03,0xC0,0x03,
+        0xCC,0x03,0xD8,0x03,0xE4,0x03,0xF0,0x03,0xFC,0x03,0x08,0x04,0x14,0x04,0x20,0x04,0x2C,0x04,
+        0x38,0x04,0x44,0x04,0x50,0x04,0x5C,0x04,0x68,0x04,0x74,0x04,
+
+        6, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        6, // 0x22 '"'
+        0x00,0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x23 '#'
+        0x00,0x28,0x28,0x7C,0x28,0x28,0x7C,0x28,0x28,0x00,0x00,
+
+        6, // 0x24 '$'
+        0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,
+
+        6, // 0x25 '%'
+        0x00,0x68,0xA8,0xD0,0x10,0x20,0x2C,0x54,0x58,0x00,0x00,
+
+        6, // 0x26 '&'
+        0x00,0x20,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,0x00,
+
+        6, // 0x27 '''
+        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x28 '('
+        0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
+
+        6, // 0x29 ')'
+        0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
+
+        6, // 0x2A '*'
+        0x00,0x00,0x28,0x7C,0x38,0x7C,0x28,0x00,0x00,0x00,0x00,
+
+        6, // 0x2B '+'
+        0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
+
+        6, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
+
+        6, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        6, // 0x2F '/'
+        0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,
+
+        6, // 0x30 '0'
+        0x00,0x38,0x44,0x44,0x54,0x54,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x31 '1'
+        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x32 '2'
+        0x00,0x38,0x44,0x44,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        6, // 0x33 '3'
+        0x00,0x38,0x44,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x08,0x18,0x28,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,
+
+        6, // 0x35 '5'
+        0x00,0x7C,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x36 '6'
+        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x37 '7'
+        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x00,0x00,
+
+        6, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x3A ':'
+        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        6, // 0x3B ';'
+        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x20,0x40,
+
+        6, // 0x3C '<'
+        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,
+
+        6, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,
+
+        6, // 0x3E '>'
+        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x38,0x44,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        6, // 0x40 '@'
+        0x00,0x38,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,
+
+        6, // 0x41 'A'
+        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        6, // 0x44 'D'
+        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
+
+        6, // 0x45 'E'
+        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        6, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x4C,0x34,0x00,0x00,
+
+        6, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x49 'I'
+        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x1C,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
+
+        6, // 0x4B 'K'
+        0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x4D 'M'
+        0x00,0x44,0x6C,0x54,0x54,0x54,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x4E 'N'
+        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x00,0x00,
+
+        6, // 0x4F 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        6, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
+
+        6, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
+
+        6, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        6, // 0x54 'T'
+        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        6, // 0x57 'W'
+        0x00,0x44,0x44,0x54,0x54,0x54,0x54,0x54,0x28,0x00,0x00,
+
+        6, // 0x58 'X'
+        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x5A 'Z'
+        0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x5B '['
+        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
+
+        6, // 0x5C '\'
+        0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
+
+        6, // 0x5D ']'
+        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
+
+        6, // 0x5E '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
+
+        6, // 0x60 '`'
+        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x3C,0x00,0x00,
+
+        6, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        6, // 0x64 'd'
+        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        6, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x0C,0x10,0x38,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        6, // 0x67 'g'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x78,
+
+        6, // 0x68 'h'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x69 'i'
+        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x6A 'j'
+        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x50,0x20,
+
+        6, // 0x6B 'k'
+        0x00,0x40,0x40,0x4C,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
+
+        6, // 0x6C 'l'
+        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        6, // 0x6D 'm'
+        0x00,0x00,0x00,0x68,0x54,0x54,0x54,0x44,0x44,0x00,0x00,
+
+        6, // 0x6E 'n'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        6, // 0x6F 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        6, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
+
+        6, // 0x71 'q'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        6, // 0x73 's'
+        0x00,0x00,0x00,0x38,0x44,0x30,0x08,0x44,0x38,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x18,0x00,0x00,
+
+        6, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        6, // 0x77 'w'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x54,0x7C,0x28,0x00,0x00,
+
+        6, // 0x78 'x'
+        0x00,0x00,0x00,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
+
+        6, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3C,0x08,0x70,
+
+        6, // 0x7A 'z'
+        0x00,0x00,0x00,0x7C,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        6, // 0x7B '{'
+        0x18,0x20,0x20,0x20,0xC0,0xC0,0x20,0x20,0x20,0x18,0x00,
+
+        6, // 0x7C '|'
+        0x00,0x10,0x10,0x10,0x10,0x00,0x10,0x10,0x10,0x10,0x00,
+
+        6, // 0x7D '}'
+        0x60,0x10,0x10,0x10,0x0C,0x0C,0x10,0x10,0x10,0x60,0x00,
+
+        6, // 0x7E '~'
+        0x00,0x24,0x54,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x7F ''
+        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs7x12_mono_high[] = 
+    {
+        12, 3, 32, 128-32,
+        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4E,0x00,0x5B,0x00,0x68,0x00,
+        0x75,0x00,0x82,0x00,0x8F,0x00,0x9C,0x00,0xA9,0x00,0xB6,0x00,0xC3,0x00,0xD0,0x00,0xDD,0x00,
+        0xEA,0x00,0xF7,0x00,0x04,0x01,0x11,0x01,0x1E,0x01,0x2B,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
+        0x5F,0x01,0x6C,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xA0,0x01,0xAD,0x01,0xBA,0x01,0xC7,0x01,
+        0xD4,0x01,0xE1,0x01,0xEE,0x01,0xFB,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2F,0x02,0x3C,0x02,
+        0x49,0x02,0x56,0x02,0x63,0x02,0x70,0x02,0x7D,0x02,0x8A,0x02,0x97,0x02,0xA4,0x02,0xB1,0x02,
+        0xBE,0x02,0xCB,0x02,0xD8,0x02,0xE5,0x02,0xF2,0x02,0xFF,0x02,0x0C,0x03,0x19,0x03,0x26,0x03,
+        0x33,0x03,0x40,0x03,0x4D,0x03,0x5A,0x03,0x67,0x03,0x74,0x03,0x81,0x03,0x8E,0x03,0x9B,0x03,
+        0xA8,0x03,0xB5,0x03,0xC2,0x03,0xCF,0x03,0xDC,0x03,0xE9,0x03,0xF6,0x03,0x03,0x04,0x10,0x04,
+        0x1D,0x04,0x2A,0x04,0x37,0x04,0x44,0x04,0x51,0x04,0x5E,0x04,0x6B,0x04,0x78,0x04,0x85,0x04,
+        0x92,0x04,0x9F,0x04,0xAC,0x04,0xB9,0x04,0xC6,0x04,0xD3,0x04,
+
+        7, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x21 '!'
+        0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x23 '#'
+        0x24,0x24,0x24,0x7E,0x24,0x24,0x24,0x7E,0x24,0x24,0x24,0x00,
+
+        7, // 0x24 '$'
+        0x10,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x10,0x00,
+
+        7, // 0x25 '%'
+        0x32,0x54,0x64,0x08,0x08,0x10,0x10,0x26,0x2A,0x4C,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x20,0x50,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,0x00,
+
+        7, // 0x27 '''
+        0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
+
+        7, // 0x29 ')'
+        0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
+
+        7, // 0x2A '*'
+        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,
+
+        7, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        7, // 0x2F '/'
+        0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x38,0x44,0x44,0x54,0x54,0x54,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x38,0x44,0x04,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x08,0x18,0x28,0x28,0x48,0x48,0x7C,0x08,0x08,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x7C,0x40,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x3A ':'
+        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x00,0x00,
+
+        7, // 0x3B ';'
+        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x20,0x40,
+
+        7, // 0x3C '<'
+        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,
+
+        7, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,
+
+        7, // 0x3E '>'
+        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,
+
+        7, // 0x3F '?'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x38,0x44,0x44,0x5C,0x54,0x54,0x4C,0x40,0x38,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        7, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        7, // 0x46 'F'
+        0x00,0x7C,0x40,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x40,0x5C,0x44,0x44,0x4C,0x34,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x49 'I'
+        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x4A 'J'
+        0x00,0x1C,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,
+
+        7, // 0x4B 'K'
+        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x44,0x00,0x00,
+
+        7, // 0x4C 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        7, // 0x4D 'M'
+        0x00,0x44,0x6C,0x6C,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x4E 'N'
+        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x44,0x00,0x00,
+
+        7, // 0x4F 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x40,0x38,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        7, // 0x57 'W'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x5A 'Z'
+        0x00,0x7C,0x04,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,
+
+        7, // 0x5B '['
+        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
+
+        7, // 0x5C '\'
+        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
+
+        7, // 0x5D ']'
+        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
+
+        7, // 0x5E '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,
+
+        7, // 0x60 '`'
+        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x66 'f'
+        0x00,0x0C,0x10,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x78,
+
+        7, // 0x68 'h'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x69 'i'
+        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x6A 'j'
+        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x08,0x48,0x30,
+
+        7, // 0x6B 'k'
+        0x00,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
+
+        7, // 0x6C 'l'
+        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x6D 'm'
+        0x00,0x00,0x00,0x68,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x6E 'n'
+        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x6F 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x74 't'
+        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x20,0x24,0x18,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        7, // 0x77 'w'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x3C,0x08,0x70,
+
+        7, // 0x7A 'z'
+        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        7, // 0x7B '{'
+        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,
+
+        7, // 0x7C '|'
+        0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
+
+        7, // 0x7D '}'
+        0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x10,0x60,0x00,
+
+        7, // 0x7E '~'
+        0x00,0x60,0x92,0x92,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7F ''
+        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u mcs7x12_mono_low[] = 
+    {
+        12, 4, 32, 128-32,
+        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x4E,0x00,0x5B,0x00,0x68,0x00,
+        0x75,0x00,0x82,0x00,0x8F,0x00,0x9C,0x00,0xA9,0x00,0xB6,0x00,0xC3,0x00,0xD0,0x00,0xDD,0x00,
+        0xEA,0x00,0xF7,0x00,0x04,0x01,0x11,0x01,0x1E,0x01,0x2B,0x01,0x38,0x01,0x45,0x01,0x52,0x01,
+        0x5F,0x01,0x6C,0x01,0x79,0x01,0x86,0x01,0x93,0x01,0xA0,0x01,0xAD,0x01,0xBA,0x01,0xC7,0x01,
+        0xD4,0x01,0xE1,0x01,0xEE,0x01,0xFB,0x01,0x08,0x02,0x15,0x02,0x22,0x02,0x2F,0x02,0x3C,0x02,
+        0x49,0x02,0x56,0x02,0x63,0x02,0x70,0x02,0x7D,0x02,0x8A,0x02,0x97,0x02,0xA4,0x02,0xB1,0x02,
+        0xBE,0x02,0xCB,0x02,0xD8,0x02,0xE5,0x02,0xF2,0x02,0xFF,0x02,0x0C,0x03,0x19,0x03,0x26,0x03,
+        0x33,0x03,0x40,0x03,0x4D,0x03,0x5A,0x03,0x67,0x03,0x74,0x03,0x81,0x03,0x8E,0x03,0x9B,0x03,
+        0xA8,0x03,0xB5,0x03,0xC2,0x03,0xCF,0x03,0xDC,0x03,0xE9,0x03,0xF6,0x03,0x03,0x04,0x10,0x04,
+        0x1D,0x04,0x2A,0x04,0x37,0x04,0x44,0x04,0x51,0x04,0x5E,0x04,0x6B,0x04,0x78,0x04,0x85,0x04,
+        0x92,0x04,0x9F,0x04,0xAC,0x04,0xB9,0x04,0xC6,0x04,0xD3,0x04,
+
+        7, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x21 '!'
+        0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x28,0x28,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x23 '#'
+        0x00,0x28,0x28,0x7C,0x28,0x28,0x28,0x7C,0x28,0x28,0x00,0x00,
+
+        7, // 0x24 '$'
+        0x00,0x10,0x38,0x54,0x50,0x38,0x14,0x54,0x38,0x10,0x00,0x00,
+
+        7, // 0x25 '%'
+        0x34,0x54,0x68,0x08,0x10,0x10,0x20,0x2C,0x54,0x58,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x20,0x50,0x50,0x20,0x54,0x54,0x48,0x34,0x00,0x00,0x00,
+
+        7, // 0x27 '''
+        0x00,0x10,0x10,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x08,0x10,0x10,0x20,0x20,0x20,0x20,0x20,0x10,0x10,0x08,0x00,
+
+        7, // 0x29 ')'
+        0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x00,
+
+        7, // 0x2A '*'
+        0x00,0x00,0x10,0x54,0x38,0x7C,0x38,0x54,0x10,0x00,0x00,0x00,
+
+        7, // 0x2B '+'
+        0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,0x00,
+
+        7, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40,0x00,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x2F '/'
+        0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x00,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x38,0x44,0x44,0x54,0x54,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x38,0x44,0x44,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x38,0x44,0x04,0x38,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x08,0x18,0x28,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x7C,0x40,0x78,0x44,0x04,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x38,0x44,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x00,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x3A ':'
+        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x3B ';'
+        0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x30,0x30,0x20,0x40,0x00,
+
+        7, // 0x3C '<'
+        0x00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,0x00,0x00,
+
+        7, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,
+
+        7, // 0x3E '>'
+        0x00,0x40,0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x40,0x00,0x00,
+
+        7, // 0x3F '?'
+        0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        7, // 0x40 '@'
+        0x00,0x38,0x44,0x44,0x5C,0x54,0x4C,0x40,0x38,0x00,0x00,0x00,
+
+        7, // 0x41 'A'
+        0x00,0x38,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x78,0x44,0x44,0x78,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
+
+        7, // 0x43 'C'
+        0x00,0x38,0x44,0x40,0x40,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x70,0x48,0x44,0x44,0x44,0x44,0x48,0x70,0x00,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
+
+        7, // 0x46 'F'
+        0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x38,0x44,0x40,0x40,0x4C,0x44,0x4C,0x34,0x00,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x49 'I'
+        0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x4A 'J'
+        0x00,0x1C,0x08,0x08,0x08,0x08,0x48,0x48,0x30,0x00,0x00,0x00,
+
+        7, // 0x4B 'K'
+        0x00,0x44,0x48,0x50,0x60,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
+
+        7, // 0x4C 'L'
+        0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,0x00,
+
+        7, // 0x4D 'M'
+        0x00,0x44,0x6C,0x54,0x54,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x4E 'N'
+        0x00,0x44,0x64,0x64,0x54,0x54,0x4C,0x4C,0x44,0x00,0x00,0x00,
+
+        7, // 0x4F 'O'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x51 'Q'
+        0x00,0x38,0x44,0x44,0x44,0x44,0x54,0x48,0x34,0x00,0x00,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x78,0x44,0x44,0x44,0x78,0x48,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x56 'V'
+        0x00,0x44,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x57 'W'
+        0x00,0x44,0x44,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x44,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x5A 'Z'
+        0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x40,0x7C,0x00,0x00,0x00,
+
+        7, // 0x5B '['
+        0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
+
+        7, // 0x5C '\'
+        0x00,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
+
+        7, // 0x5D ']'
+        0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
+
+        7, // 0x5E '^'
+        0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,
+
+        7, // 0x60 '`'
+        0x00,0x20,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x3C,0x00,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x38,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x66 'f'
+        0x00,0x0C,0x10,0x38,0x10,0x10,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x44,0x38,
+
+        7, // 0x68 'h'
+        0x00,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x69 'i'
+        0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x6A 'j'
+        0x00,0x08,0x00,0x18,0x08,0x08,0x08,0x08,0x08,0x48,0x48,0x30,
+
+        7, // 0x6B 'k'
+        0x00,0x40,0x40,0x4C,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
+
+        7, // 0x6C 'l'
+        0x00,0x30,0x10,0x10,0x10,0x10,0x10,0x10,0x38,0x00,0x00,0x00,
+
+        7, // 0x6D 'm'
+        0x00,0x00,0x00,0x68,0x54,0x54,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x6E 'n'
+        0x00,0x00,0x00,0x58,0x64,0x44,0x44,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x6F 'o'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,0x40,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,0x04,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0x58,0x24,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x38,0x44,0x30,0x08,0x44,0x38,0x00,0x00,0x00,
+
+        7, // 0x74 't'
+        0x00,0x20,0x20,0x70,0x20,0x20,0x20,0x24,0x18,0x00,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x4C,0x34,0x00,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x77 'w'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x54,0x54,0x28,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3C,0x04,0x08,0x70,
+
+        7, // 0x7A 'z'
+        0x00,0x00,0x00,0x7C,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
+
+        7, // 0x7B '{'
+        0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x18,0x00,
+
+        7, // 0x7C '|'
+        0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
+
+        7, // 0x7D '}'
+        0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x10,0x60,0x00,
+
+        7, // 0x7E '~'
+        0x00,0x24,0x54,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x7F ''
+        0x00,0x10,0x38,0x6C,0x44,0x44,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana12[] = 
+    {
+        12, 3, 32, 128-32,
+        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x5A,0x00,0x67,0x00,0x74,0x00,
+        0x81,0x00,0x8E,0x00,0x9B,0x00,0xA8,0x00,0xB5,0x00,0xC2,0x00,0xCF,0x00,0xDC,0x00,0xE9,0x00,
+        0xF6,0x00,0x03,0x01,0x10,0x01,0x1D,0x01,0x2A,0x01,0x37,0x01,0x44,0x01,0x51,0x01,0x5E,0x01,
+        0x6B,0x01,0x78,0x01,0x85,0x01,0x92,0x01,0x9F,0x01,0xAC,0x01,0xC5,0x01,0xD2,0x01,0xDF,0x01,
+        0xEC,0x01,0xF9,0x01,0x06,0x02,0x13,0x02,0x20,0x02,0x2D,0x02,0x3A,0x02,0x47,0x02,0x54,0x02,
+        0x61,0x02,0x7A,0x02,0x87,0x02,0xA0,0x02,0xAD,0x02,0xC6,0x02,0xD3,0x02,0xE0,0x02,0xED,0x02,
+        0xFA,0x02,0x07,0x03,0x20,0x03,0x2D,0x03,0x3A,0x03,0x47,0x03,0x54,0x03,0x61,0x03,0x6E,0x03,
+        0x7B,0x03,0x88,0x03,0x95,0x03,0xA2,0x03,0xAF,0x03,0xBC,0x03,0xC9,0x03,0xD6,0x03,0xE3,0x03,
+        0xF0,0x03,0xFD,0x03,0x0A,0x04,0x17,0x04,0x24,0x04,0x31,0x04,0x4A,0x04,0x57,0x04,0x64,0x04,
+        0x71,0x04,0x7E,0x04,0x8B,0x04,0x98,0x04,0xA5,0x04,0xB2,0x04,0xBF,0x04,0xCC,0x04,0xD9,0x04,
+        0xE6,0x04,0xF3,0x04,0x00,0x05,0x0D,0x05,0x1A,0x05,0x27,0x05,
+
+        3, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x00,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x28,0x7C,0x28,0x7C,0x28,0x00,0x00,0x00,
+
+        7, // 0x24 '$'
+        0x00,0x00,0x10,0x10,0x3C,0x50,0x30,0x18,0x14,0x78,0x10,0x10,
+
+        11, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x4A,0x00,0x4A,0x00,0x35,0x80,0x0A,0x40,0x0A,0x40,0x11,0x80,0x00,0x00,0x00,0x00,
+
+        7, // 0x26 '&'
+        0x00,0x00,0x00,0x30,0x48,0x48,0x32,0x4A,0x44,0x3A,0x00,0x00,
+
+        3, // 0x27 '''
+        0x00,0x00,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x28 '('
+        0x00,0x00,0x10,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x10,
+
+        4, // 0x29 ')'
+        0x00,0x00,0x80,0x40,0x20,0x20,0x20,0x20,0x20,0x20,0x40,0x80,
+
+        7, // 0x2A '*'
+        0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
+
+        3, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x80,0x00,
+
+        5, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x00,0x00,
+
+        3, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,
+
+        4, // 0x2F '/'
+        0x00,0x00,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x80,0x80,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x00,0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x38,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x00,0x00,0x38,0x44,0x04,0x08,0x10,0x20,0x7C,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x00,0x00,0x38,0x44,0x04,0x18,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x00,0x00,0x08,0x18,0x28,0x48,0x7C,0x08,0x08,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x00,0x00,0x7C,0x40,0x78,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x00,0x00,0x18,0x20,0x40,0x78,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0x00,0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x3C,0x04,0x08,0x30,0x00,0x00,
+
+        4, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x40,0x40,0x00,0x00,
+
+        4, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x40,0x40,0x80,0x00,
+
+        7, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x04,0x18,0x60,0x18,0x04,0x00,0x00,0x00,
+
+        7, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x7C,0x00,0x00,0x00,0x00,
+
+        7, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x40,0x30,0x0C,0x30,0x40,0x00,0x00,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x00,0x00,0x70,0x08,0x08,0x10,0x20,0x00,0x20,0x00,0x00,
+
+        10, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x4E,0x80,0x52,0x80,0x52,0x80,0x4D,0x00,0x20,0x00,0x1F,0x00,0x00,0x00,
+
+        8, // 0x41 'A'
+        0x00,0x00,0x00,0x18,0x18,0x24,0x24,0x7E,0x42,0x42,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x00,0x00,0x70,0x48,0x48,0x78,0x44,0x44,0x78,0x00,0x00,
+
+        8, // 0x43 'C'
+        0x00,0x00,0x00,0x1C,0x22,0x40,0x40,0x40,0x22,0x1C,0x00,0x00,
+
+        8, // 0x44 'D'
+        0x00,0x00,0x00,0x78,0x44,0x42,0x42,0x42,0x44,0x78,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        8, // 0x47 'G'
+        0x00,0x00,0x00,0x1C,0x22,0x40,0x4E,0x42,0x22,0x1C,0x00,0x00,
+
+        8, // 0x48 'H'
+        0x00,0x00,0x00,0x42,0x42,0x42,0x7E,0x42,0x42,0x42,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        5, // 0x4A 'J'
+        0x00,0x00,0x00,0x30,0x10,0x10,0x10,0x10,0x10,0xE0,0x00,0x00,
+
+        7, // 0x4B 'K'
+        0x00,0x00,0x00,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        9, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x55,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x4E 'N'
+        0x00,0x00,0x00,0x42,0x62,0x52,0x4A,0x46,0x42,0x42,0x00,0x00,
+
+        9, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x00,0x00,
+
+        9, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x04,0x00,0x03,0x00,
+
+        7, // 0x52 'R'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x78,0x50,0x48,0x44,0x00,0x00,
+
+        7, // 0x53 'S'
+        0x00,0x00,0x00,0x38,0x44,0x40,0x38,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x00,0x00,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        8, // 0x55 'U'
+        0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
+
+        8, // 0x56 'V'
+        0x00,0x00,0x00,0x42,0x42,0x42,0x24,0x24,0x18,0x18,0x00,0x00,
+
+        9, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x55,0x00,0x22,0x00,0x22,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x10,0x00,0x00,
+
+        7, // 0x5A 'Z'
+        0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        4, // 0x5B '['
+        0x00,0x00,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x60,
+
+        4, // 0x5C '\'
+        0x00,0x00,0x80,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x00,
+
+        4, // 0x5D ']'
+        0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,
+
+        7, // 0x5E '^'
+        0x00,0x00,0x00,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFC,
+
+        6, // 0x60 '`'
+        0x00,0x00,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x30,0x08,0x38,0x48,0x38,0x00,0x00,
+
+        6, // 0x62 'b'
+        0x00,0x00,0x40,0x40,0x40,0x70,0x48,0x48,0x48,0x70,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x40,0x40,0x38,0x00,0x00,
+
+        6, // 0x64 'd'
+        0x00,0x00,0x08,0x08,0x08,0x38,0x48,0x48,0x48,0x38,0x00,0x00,
+
+        6, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x30,0x48,0x78,0x40,0x38,0x00,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x00,0x30,0x40,0x40,0xE0,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        6, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x48,0x48,0x48,0x38,0x08,0x30,
+
+        6, // 0x68 'h'
+        0x00,0x00,0x40,0x40,0x40,0x70,0x48,0x48,0x48,0x48,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x00,0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        3, // 0x6A 'j'
+        0x00,0x00,0x00,0x40,0x00,0xC0,0x40,0x40,0x40,0x40,0x40,0x80,
+
+        6, // 0x6B 'k'
+        0x00,0x00,0x40,0x40,0x40,0x48,0x50,0x60,0x50,0x48,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        9, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x76,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x49,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x70,0x48,0x48,0x48,0x48,0x00,0x00,
+
+        6, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x30,0x48,0x48,0x48,0x30,0x00,0x00,
+
+        6, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x70,0x48,0x48,0x48,0x70,0x40,0x40,
+
+        6, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x48,0x48,0x48,0x38,0x08,0x08,
+
+        4, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x50,0x60,0x40,0x40,0x40,0x00,0x00,
+
+        6, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x30,0x08,0x70,0x00,0x00,
+
+        4, // 0x74 't'
+        0x00,0x00,0x00,0x00,0x40,0xF0,0x40,0x40,0x40,0x30,0x00,0x00,
+
+        6, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x48,0x48,0x38,0x00,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x48,0x30,0x30,0x00,0x00,
+
+        7, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x54,0x54,0x28,0x28,0x00,0x00,
+
+        6, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x30,0x48,0x48,0x00,0x00,
+
+        6, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x48,0x48,0x48,0x30,0x10,0x20,0x20,
+
+        5, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x70,0x10,0x20,0x40,0x70,0x00,0x00,
+
+        6, // 0x7B '{'
+        0x00,0x00,0x18,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x18,
+
+        5, // 0x7C '|'
+        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
+
+        6, // 0x7D '}'
+        0x00,0x00,0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x60,
+
+        7, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x34,0x58,0x00,0x00,0x00,0x00,
+
+        9, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana12_bold[] = 
+    {
+        12, 3, 32, 128-32,
+        0x00,0x00,0x0D,0x00,0x1A,0x00,0x27,0x00,0x34,0x00,0x41,0x00,0x5A,0x00,0x67,0x00,0x74,0x00,
+        0x81,0x00,0x8E,0x00,0x9B,0x00,0xA8,0x00,0xB5,0x00,0xC2,0x00,0xCF,0x00,0xDC,0x00,0xE9,0x00,
+        0xF6,0x00,0x03,0x01,0x10,0x01,0x1D,0x01,0x2A,0x01,0x37,0x01,0x44,0x01,0x51,0x01,0x5E,0x01,
+        0x6B,0x01,0x78,0x01,0x85,0x01,0x92,0x01,0x9F,0x01,0xAC,0x01,0xC5,0x01,0xD2,0x01,0xDF,0x01,
+        0xEC,0x01,0xF9,0x01,0x06,0x02,0x13,0x02,0x20,0x02,0x2D,0x02,0x3A,0x02,0x47,0x02,0x54,0x02,
+        0x61,0x02,0x6E,0x02,0x7B,0x02,0x88,0x02,0x95,0x02,0xA2,0x02,0xAF,0x02,0xBC,0x02,0xC9,0x02,
+        0xD6,0x02,0xE3,0x02,0xFC,0x02,0x09,0x03,0x16,0x03,0x23,0x03,0x30,0x03,0x3D,0x03,0x4A,0x03,
+        0x57,0x03,0x64,0x03,0x71,0x03,0x7E,0x03,0x8B,0x03,0x98,0x03,0xA5,0x03,0xB2,0x03,0xBF,0x03,
+        0xCC,0x03,0xD9,0x03,0xE6,0x03,0xF3,0x03,0x00,0x04,0x0D,0x04,0x26,0x04,0x33,0x04,0x40,0x04,
+        0x4D,0x04,0x5A,0x04,0x67,0x04,0x74,0x04,0x81,0x04,0x8E,0x04,0x9B,0x04,0xB4,0x04,0xC1,0x04,
+        0xCE,0x04,0xDB,0x04,0xE8,0x04,0xF5,0x04,0x02,0x05,0x0F,0x05,
+
+        3, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x00,0x60,0x00,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x00,0xD8,0xD8,0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x23 '#'
+        0x00,0x00,0x00,0x14,0x14,0x7E,0x28,0xFC,0x50,0x50,0x00,0x00,
+
+        6, // 0x24 '$'
+        0x00,0x00,0x20,0x20,0x70,0xE8,0xE0,0x38,0xB8,0x70,0x20,0x20,
+
+        11, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x00,0x94,0x00,0x94,0x00,0x69,0x80,0x0A,0x40,0x0A,0x40,0x11,0x80,0x00,0x00,0x00,0x00,
+
+        8, // 0x26 '&'
+        0x00,0x00,0x00,0x70,0xD8,0xD8,0x76,0xDC,0xCC,0x76,0x00,0x00,
+
+        3, // 0x27 '''
+        0x00,0x00,0xC0,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x00,0x00,0x30,0x60,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0x60,0x30,
+
+        5, // 0x29 ')'
+        0x00,0x00,0xC0,0x60,0x30,0x30,0x30,0x30,0x30,0x30,0x60,0xC0,
+
+        6, // 0x2A '*'
+        0x00,0x00,0x20,0xA8,0x70,0xA8,0x20,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x10,0x10,0x7C,0x10,0x10,0x00,0x00,0x00,
+
+        3, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x80,0x00,
+
+        4, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0x00,0x00,0x00,0x00,0x00,
+
+        3, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x00,0x00,
+
+        6, // 0x2F '/'
+        0x00,0x00,0x08,0x08,0x10,0x10,0x20,0x40,0x40,0x80,0x80,0x00,
+
+        6, // 0x30 '0'
+        0x00,0x00,0x00,0x70,0xD8,0xD8,0xD8,0xD8,0xD8,0x70,0x00,0x00,
+
+        6, // 0x31 '1'
+        0x00,0x00,0x00,0x30,0x70,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        6, // 0x32 '2'
+        0x00,0x00,0x00,0x70,0x98,0x18,0x30,0x60,0xC0,0xF8,0x00,0x00,
+
+        6, // 0x33 '3'
+        0x00,0x00,0x00,0x70,0x98,0x18,0x70,0x18,0x98,0x70,0x00,0x00,
+
+        6, // 0x34 '4'
+        0x00,0x00,0x00,0x18,0x38,0x58,0x98,0xFC,0x18,0x18,0x00,0x00,
+
+        6, // 0x35 '5'
+        0x00,0x00,0x00,0xF8,0xC0,0xF0,0x18,0x18,0x98,0x70,0x00,0x00,
+
+        6, // 0x36 '6'
+        0x00,0x00,0x00,0x70,0xC0,0xF0,0xD8,0xD8,0xD8,0x70,0x00,0x00,
+
+        6, // 0x37 '7'
+        0x00,0x00,0x00,0xF8,0x18,0x30,0x30,0x60,0x60,0xC0,0x00,0x00,
+
+        6, // 0x38 '8'
+        0x00,0x00,0x00,0x70,0xD8,0xD8,0x70,0xD8,0xD8,0x70,0x00,0x00,
+
+        6, // 0x39 '9'
+        0x00,0x00,0x00,0x70,0xD8,0xD8,0xD8,0x78,0x18,0x70,0x00,0x00,
+
+        4, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x00,0x00,
+
+        4, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x40,0x00,
+
+        8, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x04,0x18,0x60,0x60,0x18,0x04,0x00,0x00,
+
+        8, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x7C,0x00,0x00,0x00,0x00,
+
+        8, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x40,0x30,0x0C,0x0C,0x30,0x40,0x00,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x00,0x00,0xF0,0x18,0x18,0x30,0x60,0x00,0x60,0x00,0x00,
+
+        9, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x42,0x00,0x9D,0x00,0xA5,0x00,0xA5,0x00,0x9E,0x00,0x40,0x00,0x3C,0x00,0x00,0x00,
+
+        8, // 0x41 'A'
+        0x00,0x00,0x00,0x38,0x38,0x6C,0x6C,0x7C,0xC6,0xC6,0x00,0x00,
+
+        7, // 0x42 'B'
+        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xF8,0xCC,0xCC,0xF8,0x00,0x00,
+
+        6, // 0x43 'C'
+        0x00,0x00,0x00,0x70,0xC8,0xC0,0xC0,0xC0,0xC8,0x70,0x00,0x00,
+
+        7, // 0x44 'D'
+        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xCC,0xCC,0xCC,0xF8,0x00,0x00,
+
+        6, // 0x45 'E'
+        0x00,0x00,0x00,0xF8,0xC0,0xC0,0xF8,0xC0,0xC0,0xF8,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x00,0x00,0xF8,0xC0,0xC0,0xF8,0xC0,0xC0,0xC0,0x00,0x00,
+
+        7, // 0x47 'G'
+        0x00,0x00,0x00,0x78,0xC4,0xC0,0xC0,0xDC,0xCC,0x7C,0x00,0x00,
+
+        7, // 0x48 'H'
+        0x00,0x00,0x00,0xCC,0xCC,0xCC,0xFC,0xCC,0xCC,0xCC,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x00,0x00,0xF0,0x60,0x60,0x60,0x60,0x60,0xF0,0x00,0x00,
+
+        5, // 0x4A 'J'
+        0x00,0x00,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0xE0,0x00,0x00,
+
+        7, // 0x4B 'K'
+        0x00,0x00,0x00,0xCC,0xD8,0xF0,0xE0,0xF0,0xD8,0xCC,0x00,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x00,0x00,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xF8,0x00,0x00,
+
+        8, // 0x4D 'M'
+        0x00,0x00,0x00,0x82,0xC6,0xEE,0xB6,0xB6,0x86,0x86,0x00,0x00,
+
+        7, // 0x4E 'N'
+        0x00,0x00,0x00,0x84,0xC4,0xE4,0xB4,0x9C,0x8C,0x84,0x00,0x00,
+
+        8, // 0x4F 'O'
+        0x00,0x00,0x00,0x7C,0xC6,0xC6,0xC6,0xC6,0xC6,0x7C,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xCC,0xF8,0xC0,0xC0,0x00,0x00,
+
+        8, // 0x51 'Q'
+        0x00,0x00,0x00,0x7C,0xC6,0xC6,0xC6,0xC6,0xC6,0x7C,0x18,0x0E,
+
+        7, // 0x52 'R'
+        0x00,0x00,0x00,0xF8,0xCC,0xCC,0xF8,0xD8,0xCC,0xC6,0x00,0x00,
+
+        6, // 0x53 'S'
+        0x00,0x00,0x00,0x70,0xC8,0xC0,0x70,0x18,0x98,0x70,0x00,0x00,
+
+        6, // 0x54 'T'
+        0x00,0x00,0x00,0xFC,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,
+
+        7, // 0x55 'U'
+        0x00,0x00,0x00,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0x78,0x00,0x00,
+
+        7, // 0x56 'V'
+        0x00,0x00,0x00,0xCC,0xCC,0x78,0x78,0x78,0x30,0x30,0x00,0x00,
+
+        11, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0xCC,0xC0,0xCC,0xC0,0x6D,0x80,0x6D,0x80,0x73,0x80,0x33,0x00,0x33,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x58 'X'
+        0x00,0x00,0x00,0xCC,0xCC,0x78,0x30,0x78,0xCC,0xCC,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x00,0x00,0xCC,0xCC,0x78,0x30,0x30,0x30,0x30,0x00,0x00,
+
+        6, // 0x5A 'Z'
+        0x00,0x00,0x00,0xF8,0x18,0x30,0x60,0xC0,0xC0,0xF8,0x00,0x00,
+
+        5, // 0x5B '['
+        0x00,0x00,0x70,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x70,
+
+        6, // 0x5C '\'
+        0x00,0x00,0x80,0x80,0x40,0x40,0x20,0x10,0x10,0x08,0x08,0x00,
+
+        5, // 0x5D ']'
+        0x00,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x70,
+
+        8, // 0x5E '^'
+        0x00,0x00,0x00,0x18,0x3C,0x66,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFC,
+
+        6, // 0x60 '`'
+        0x00,0x00,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x70,0x18,0x78,0xD8,0x78,0x00,0x00,
+
+        6, // 0x62 'b'
+        0x00,0x00,0xC0,0xC0,0xC0,0xF0,0xD8,0xD8,0xD8,0xF0,0x00,0x00,
+
+        5, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x70,0xC0,0xC0,0xC0,0x70,0x00,0x00,
+
+        6, // 0x64 'd'
+        0x00,0x00,0x18,0x18,0x18,0x78,0xD8,0xD8,0xD8,0x78,0x00,0x00,
+
+        6, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x70,0xD8,0xF8,0xC0,0x78,0x00,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        6, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x78,0xD8,0xD8,0xD8,0x78,0x18,0x70,
+
+        6, // 0x68 'h'
+        0x00,0x00,0xC0,0xC0,0xC0,0xF0,0xD8,0xD8,0xD8,0xD8,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x00,0x00,0xC0,0x00,0xC0,0xC0,0xC0,0xC0,0xC0,0x00,0x00,
+
+        4, // 0x6A 'j'
+        0x00,0x00,0x00,0x60,0x00,0xE0,0x60,0x60,0x60,0x60,0x60,0xC0,
+
+        6, // 0x6B 'k'
+        0x00,0x00,0xC0,0xC0,0xC0,0xD8,0xD8,0xF0,0xD8,0xD8,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x00,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0x00,0x00,
+
+        9, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF6,0x00,0xDB,0x00,0xDB,0x00,0xDB,0x00,0xDB,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0xF0,0xD8,0xD8,0xD8,0xD8,0x00,0x00,
+
+        6, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x70,0xD8,0xD8,0xD8,0x70,0x00,0x00,
+
+        6, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0xF0,0xD8,0xD8,0xD8,0xF0,0xC0,0xC0,
+
+        6, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x78,0xD8,0xD8,0xD8,0x78,0x18,0x18,
+
+        4, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0xD0,0xE0,0xC0,0xC0,0xC0,0x00,0x00,
+
+        5, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x70,0xC0,0xF0,0x30,0xE0,0x00,0x00,
+
+        5, // 0x74 't'
+        0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x38,0x00,0x00,
+
+        6, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0xD8,0xD8,0x78,0x00,0x00,
+
+        6, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0xD8,0x70,0x70,0x00,0x00,
+
+        9, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xDB,0x00,0xDB,0x00,0xDB,0x00,0x66,0x00,0x66,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0x70,0xD8,0xD8,0x00,0x00,
+
+        6, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0xD8,0xD8,0xD8,0x70,0x70,0x30,0x60,
+
+        5, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0xF0,0x30,0x60,0xC0,0xF0,0x00,0x00,
+
+        6, // 0x7B '{'
+        0x00,0x00,0x18,0x30,0x30,0x30,0xE0,0x30,0x30,0x30,0x30,0x18,
+
+        5, // 0x7C '|'
+        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
+
+        6, // 0x7D '}'
+        0x00,0x00,0xC0,0x60,0x60,0x60,0x38,0x60,0x60,0x60,0x60,0xC0,
+
+        8, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x92,0x8C,0x00,0x00,0x00,
+
+        9, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana13[] = 
+    {
+        13, 3, 32, 128-32,
+        0x00,0x00,0x0E,0x00,0x1C,0x00,0x2A,0x00,0x45,0x00,0x53,0x00,0x6E,0x00,0x7C,0x00,0x8A,0x00,
+        0x98,0x00,0xA6,0x00,0xB4,0x00,0xCF,0x00,0xDD,0x00,0xEB,0x00,0xF9,0x00,0x07,0x01,0x15,0x01,
+        0x23,0x01,0x31,0x01,0x3F,0x01,0x4D,0x01,0x5B,0x01,0x69,0x01,0x77,0x01,0x85,0x01,0x93,0x01,
+        0xA1,0x01,0xAF,0x01,0xCA,0x01,0xE5,0x01,0x00,0x02,0x0E,0x02,0x29,0x02,0x37,0x02,0x45,0x02,
+        0x60,0x02,0x7B,0x02,0x89,0x02,0x97,0x02,0xB2,0x02,0xC0,0x02,0xCE,0x02,0xDC,0x02,0xEA,0x02,
+        0xF8,0x02,0x13,0x03,0x21,0x03,0x3C,0x03,0x4A,0x03,0x65,0x03,0x73,0x03,0x81,0x03,0x8F,0x03,
+        0x9D,0x03,0xAB,0x03,0xC6,0x03,0xD4,0x03,0xE2,0x03,0xF0,0x03,0xFE,0x03,0x0C,0x04,0x1A,0x04,
+        0x35,0x04,0x43,0x04,0x51,0x04,0x5F,0x04,0x6D,0x04,0x7B,0x04,0x89,0x04,0x97,0x04,0xA5,0x04,
+        0xB3,0x04,0xC1,0x04,0xCF,0x04,0xDD,0x04,0xEB,0x04,0xF9,0x04,0x14,0x05,0x22,0x05,0x30,0x05,
+        0x3E,0x05,0x4C,0x05,0x5A,0x05,0x68,0x05,0x76,0x05,0x84,0x05,0x92,0x05,0xAD,0x05,0xBB,0x05,
+        0xC9,0x05,0xD7,0x05,0xE5,0x05,0xF3,0x05,0x01,0x06,0x1C,0x06,
+
+        4, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x00,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0A,0x00,0x0A,0x00,0x3F,0x00,0x14,0x00,0x14,0x00,0x7E,0x00,0x28,0x00,0x28,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x24 '$'
+        0x00,0x00,0x10,0x10,0x3C,0x50,0x50,0x38,0x14,0x14,0x78,0x10,0x10,
+
+        12, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x49,0x00,0x4A,0x00,0x32,0x00,0x04,0xC0,0x05,0x20,0x09,0x20,0x08,0xC0,0x00,0x00,0x00,0x00,
+
+        8, // 0x26 '&'
+        0x00,0x00,0x00,0x30,0x48,0x48,0x32,0x4A,0x44,0x46,0x39,0x00,0x00,
+
+        3, // 0x27 '''
+        0x00,0x00,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x00,0x00,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
+
+        5, // 0x29 ')'
+        0x00,0x00,0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
+
+        7, // 0x2A '*'
+        0x00,0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
+
+        5, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,
+
+        5, // 0x2F '/'
+        0x00,0x00,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
+
+        7, // 0x30 '0'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x31 '1'
+        0x00,0x00,0x00,0x10,0x70,0x10,0x10,0x10,0x10,0x10,0x7C,0x00,0x00,
+
+        7, // 0x32 '2'
+        0x00,0x00,0x00,0x38,0x44,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        7, // 0x33 '3'
+        0x00,0x00,0x00,0x38,0x44,0x04,0x18,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x34 '4'
+        0x00,0x00,0x00,0x08,0x18,0x28,0x48,0x88,0xFC,0x08,0x08,0x00,0x00,
+
+        7, // 0x35 '5'
+        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x04,0x04,0x44,0x38,0x00,0x00,
+
+        7, // 0x36 '6'
+        0x00,0x00,0x00,0x18,0x20,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x37 '7'
+        0x00,0x00,0x00,0x7C,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x00,0x00,
+
+        7, // 0x38 '8'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x39 '9'
+        0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x3C,0x04,0x08,0x30,0x00,0x00,
+
+        5, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x20,0x20,0x00,0x00,
+
+        5, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x20,0x20,0x20,0x40,
+
+        9, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x3F '?'
+        0x00,0x00,0x00,0x70,0x08,0x08,0x10,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        10, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x4E,0x80,0x52,0x80,0x52,0x80,0x52,0x80,0x4D,0x00,0x20,0x00,0x1E,0x00,0x00,0x00,
+
+        8, // 0x41 'A'
+        0x00,0x00,0x00,0x18,0x18,0x24,0x24,0x24,0x7E,0x42,0x42,0x00,0x00,
+
+        8, // 0x42 'B'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x7C,0x42,0x42,0x42,0x7C,0x00,0x00,
+
+        9, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x45 'E'
+        0x00,0x00,0x00,0x7C,0x40,0x40,0x7C,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        6, // 0x46 'F'
+        0x00,0x00,0x00,0x7C,0x40,0x40,0x78,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        9, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x47,0x00,0x41,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x48 'H'
+        0x00,0x00,0x00,0x42,0x42,0x42,0x7E,0x42,0x42,0x42,0x42,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        5, // 0x4A 'J'
+        0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,0x00,0x00,
+
+        8, // 0x4B 'K'
+        0x00,0x00,0x00,0x42,0x44,0x48,0x50,0x70,0x48,0x44,0x42,0x00,0x00,
+
+        6, // 0x4C 'L'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C,0x00,0x00,
+
+        9, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x55,0x00,0x55,0x00,0x49,0x00,0x49,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x4E 'N'
+        0x00,0x00,0x00,0x62,0x62,0x52,0x52,0x4A,0x4A,0x46,0x46,0x00,0x00,
+
+        9, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x50 'P'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0x00,0x00,
+
+        9, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x04,0x00,0x03,0x00,
+
+        8, // 0x52 'R'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x78,0x48,0x44,0x42,0x00,0x00,
+
+        8, // 0x53 'S'
+        0x00,0x00,0x00,0x3C,0x42,0x40,0x30,0x0C,0x02,0x42,0x3C,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x00,0x00,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        8, // 0x55 'U'
+        0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
+
+        8, // 0x56 'V'
+        0x00,0x00,0x00,0x42,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x00,0x00,
+
+        11, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x58 'X'
+        0x00,0x00,0x00,0x42,0x42,0x24,0x18,0x18,0x24,0x42,0x42,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x00,0x00,0x82,0x44,0x28,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        8, // 0x5A 'Z'
+        0x00,0x00,0x00,0x7E,0x02,0x04,0x08,0x10,0x20,0x40,0x7E,0x00,0x00,
+
+        5, // 0x5B '['
+        0x00,0x00,0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,
+
+        5, // 0x5C '\'
+        0x00,0x00,0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x00,
+
+        5, // 0x5D ']'
+        0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,
+
+        9, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFE,
+
+        7, // 0x60 '`'
+        0x00,0x00,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x04,0x3C,0x44,0x44,0x3C,0x00,0x00,
+
+        7, // 0x62 'b'
+        0x00,0x00,0x40,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x78,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        7, // 0x64 'd'
+        0x00,0x00,0x04,0x04,0x04,0x3C,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        7, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x7C,0x40,0x44,0x38,0x00,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x00,0x30,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x38,
+
+        7, // 0x68 'h'
+        0x00,0x00,0x40,0x40,0x40,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        4, // 0x6A 'j'
+        0x00,0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0xC0,
+
+        7, // 0x6B 'k'
+        0x00,0x00,0x40,0x40,0x40,0x44,0x48,0x50,0x70,0x48,0x44,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        11, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7B,0x80,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x00,0x00,0x00,0x00,
+
+        7, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x44,0x00,0x00,
+
+        7, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x44,0x44,0x44,0x38,0x00,0x00,
+
+        7, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x44,0x78,0x40,0x40,
+
+        7, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x44,0x44,0x44,0x44,0x3C,0x04,0x04,
+
+        5, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x58,0x60,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        6, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x60,0x18,0x08,0x70,0x00,0x00,
+
+        4, // 0x74 't'
+        0x00,0x00,0x00,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x30,0x00,0x00,
+
+        7, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x44,0x44,0x44,0x3C,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        9, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x49,0x00,0x55,0x00,0x55,0x00,0x22,0x00,0x22,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x28,0x10,0x10,0x28,0x44,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x28,0x28,0x28,0x10,0x10,0x10,0x20,
+
+        6, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x78,0x08,0x10,0x20,0x40,0x78,0x00,0x00,
+
+        7, // 0x7B '{'
+        0x00,0x00,0x0C,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x0C,
+
+        5, // 0x7C '|'
+        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
+
+        7, // 0x7D '}'
+        0x00,0x00,0x60,0x10,0x10,0x10,0x10,0x0C,0x10,0x10,0x10,0x10,0x60,
+
+        9, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x49,0x00,0x46,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x7F,0x80,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana13_bold[] = 
+    {
+        13, 3, 32, 128-32,
+        0x00,0x00,0x0E,0x00,0x1C,0x00,0x2A,0x00,0x45,0x00,0x53,0x00,0x6E,0x00,0x89,0x00,0x97,0x00,
+        0xA5,0x00,0xB3,0x00,0xC1,0x00,0xDC,0x00,0xEA,0x00,0xF8,0x00,0x06,0x01,0x14,0x01,0x22,0x01,
+        0x30,0x01,0x3E,0x01,0x4C,0x01,0x5A,0x01,0x68,0x01,0x76,0x01,0x84,0x01,0x92,0x01,0xA0,0x01,
+        0xAE,0x01,0xBC,0x01,0xD7,0x01,0xF2,0x01,0x0D,0x02,0x1B,0x02,0x36,0x02,0x51,0x02,0x5F,0x02,
+        0x6D,0x02,0x88,0x02,0x96,0x02,0xA4,0x02,0xBF,0x02,0xDA,0x02,0xE8,0x02,0xF6,0x02,0x04,0x03,
+        0x12,0x03,0x2D,0x03,0x48,0x03,0x63,0x03,0x71,0x03,0x8C,0x03,0x9A,0x03,0xA8,0x03,0xB6,0x03,
+        0xD1,0x03,0xDF,0x03,0xFA,0x03,0x08,0x04,0x16,0x04,0x24,0x04,0x32,0x04,0x40,0x04,0x4E,0x04,
+        0x69,0x04,0x77,0x04,0x85,0x04,0x93,0x04,0xA1,0x04,0xAF,0x04,0xBD,0x04,0xCB,0x04,0xD9,0x04,
+        0xE7,0x04,0xF5,0x04,0x03,0x05,0x11,0x05,0x1F,0x05,0x2D,0x05,0x48,0x05,0x56,0x05,0x64,0x05,
+        0x72,0x05,0x80,0x05,0x8E,0x05,0x9C,0x05,0xAA,0x05,0xB8,0x05,0xC6,0x05,0xE1,0x05,0xEF,0x05,
+        0xFD,0x05,0x0B,0x06,0x19,0x06,0x27,0x06,0x35,0x06,0x50,0x06,
+
+        4, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x21 '!'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x60,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x00,0x6C,0x6C,0x6C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0A,0x00,0x0A,0x00,0x3F,0x00,0x14,0x00,0x14,0x00,0x7E,0x00,0x28,0x00,0x28,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x24 '$'
+        0x00,0x00,0x08,0x08,0x3C,0x6A,0x68,0x3C,0x16,0x56,0x3C,0x10,0x10,
+
+        14, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x80,0x6C,0x80,0x6D,0x00,0x6D,0x70,0x3A,0xD8,0x02,0xD8,0x04,0xD8,0x04,0x70,0x00,0x00,0x00,0x00,
+
+        10, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x6C,0x00,0x6C,0x00,0x39,0x80,0x6D,0x00,0x66,0x00,0x63,0x00,0x3D,0x80,0x00,0x00,0x00,0x00,
+
+        4, // 0x27 '''
+        0x00,0x00,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x28 '('
+        0x00,0x00,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,
+
+        6, // 0x29 ')'
+        0x00,0x00,0x60,0x30,0x30,0x18,0x18,0x18,0x18,0x18,0x30,0x30,0x60,
+
+        8, // 0x2A '*'
+        0x00,0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x40,
+
+        6, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        8, // 0x2F '/'
+        0x00,0x00,0x06,0x06,0x0C,0x0C,0x18,0x18,0x18,0x30,0x30,0x60,0x60,
+
+        8, // 0x30 '0'
+        0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x66,0x66,0x66,0x3C,0x00,0x00,
+
+        8, // 0x31 '1'
+        0x00,0x00,0x00,0x18,0x38,0x18,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,
+
+        8, // 0x32 '2'
+        0x00,0x00,0x00,0x3C,0x66,0x06,0x0C,0x18,0x30,0x60,0x7E,0x00,0x00,
+
+        8, // 0x33 '3'
+        0x00,0x00,0x00,0x3C,0x66,0x06,0x1C,0x06,0x06,0x66,0x3C,0x00,0x00,
+
+        8, // 0x34 '4'
+        0x00,0x00,0x00,0x04,0x0C,0x1C,0x2C,0x4C,0x7E,0x0C,0x0C,0x00,0x00,
+
+        8, // 0x35 '5'
+        0x00,0x00,0x00,0x3E,0x30,0x30,0x3C,0x06,0x06,0x66,0x3C,0x00,0x00,
+
+        8, // 0x36 '6'
+        0x00,0x00,0x00,0x1C,0x30,0x60,0x7C,0x66,0x66,0x66,0x3C,0x00,0x00,
+
+        8, // 0x37 '7'
+        0x00,0x00,0x00,0x7E,0x06,0x0C,0x0C,0x18,0x18,0x30,0x30,0x00,0x00,
+
+        8, // 0x38 '8'
+        0x00,0x00,0x00,0x3C,0x66,0x66,0x3C,0x66,0x66,0x66,0x3C,0x00,0x00,
+
+        8, // 0x39 '9'
+        0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x3E,0x06,0x0C,0x38,0x00,0x00,
+
+        4, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        4, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x60,0x40,
+
+        9, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x3F '?'
+        0x00,0x00,0x00,0x38,0x4C,0x0C,0x18,0x30,0x30,0x00,0x30,0x00,0x00,
+
+        11, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x20,0x40,0x4F,0x40,0x5B,0x40,0x5B,0x40,0x5B,0x40,0x4F,0x80,0x20,0x00,0x1F,0x00,0x00,0x00,
+
+        9, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x7F,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x42 'B'
+        0x00,0x00,0x00,0x7C,0x66,0x66,0x7C,0x66,0x66,0x66,0x7C,0x00,0x00,
+
+        8, // 0x43 'C'
+        0x00,0x00,0x00,0x3C,0x62,0x60,0x60,0x60,0x60,0x62,0x3C,0x00,0x00,
+
+        9, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x66,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x66,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x45 'E'
+        0x00,0x00,0x00,0x7E,0x60,0x60,0x7E,0x60,0x60,0x60,0x7E,0x00,0x00,
+
+        8, // 0x46 'F'
+        0x00,0x00,0x00,0x7E,0x60,0x60,0x7E,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        9, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x61,0x00,0x60,0x00,0x60,0x00,0x67,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x49 'I'
+        0x00,0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0xF0,0x00,0x00,
+
+        8, // 0x4B 'K'
+        0x00,0x00,0x00,0x66,0x6C,0x78,0x70,0x70,0x78,0x6C,0x66,0x00,0x00,
+
+        7, // 0x4C 'L'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7E,0x00,0x00,
+
+        10, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x80,0x71,0x80,0x7B,0x80,0x5D,0x80,0x49,0x80,0x41,0x80,0x41,0x80,0x41,0x80,0x00,0x00,0x00,0x00,
+
+        9, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x61,0x00,0x71,0x00,0x59,0x00,0x4D,0x00,0x47,0x00,0x43,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x50 'P'
+        0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x7C,0x60,0x60,0x60,0x00,0x00,
+
+        9, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x0C,0x00,0x07,0x00,
+
+        8, // 0x52 'R'
+        0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x7C,0x6C,0x66,0x63,0x00,0x00,
+
+        8, // 0x53 'S'
+        0x00,0x00,0x00,0x3C,0x62,0x60,0x7C,0x3E,0x06,0x46,0x3C,0x00,0x00,
+
+        8, // 0x54 'T'
+        0x00,0x00,0x00,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,
+
+        9, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x56 'V'
+        0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x3C,0x18,0x18,0x00,0x00,
+
+        12, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x60,0x66,0x60,0x66,0x60,0x36,0xC0,0x3F,0xC0,0x39,0xC0,0x19,0x80,0x19,0x80,0x00,0x00,0x00,0x00,
+
+        8, // 0x58 'X'
+        0x00,0x00,0x00,0x66,0x66,0x3C,0x18,0x18,0x3C,0x66,0x66,0x00,0x00,
+
+        8, // 0x59 'Y'
+        0x00,0x00,0x00,0x66,0x66,0x3C,0x3C,0x18,0x18,0x18,0x18,0x00,0x00,
+
+        8, // 0x5A 'Z'
+        0x00,0x00,0x00,0x7E,0x06,0x0E,0x1C,0x38,0x70,0x60,0x7E,0x00,0x00,
+
+        6, // 0x5B '['
+        0x00,0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,
+
+        8, // 0x5C '\'
+        0x00,0x00,0x60,0x60,0x30,0x30,0x18,0x18,0x18,0x0C,0x0C,0x06,0x06,
+
+        6, // 0x5D ']'
+        0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,
+
+        10, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,
+
+        8, // 0x60 '`'
+        0x00,0x00,0x30,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x06,0x3E,0x66,0x66,0x3E,0x00,0x00,
+
+        8, // 0x62 'b'
+        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x7C,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x60,0x60,0x60,0x60,0x3C,0x00,0x00,
+
+        8, // 0x64 'd'
+        0x00,0x00,0x06,0x06,0x06,0x3E,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
+
+        8, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x7E,0x60,0x62,0x3C,0x00,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        8, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x3E,0x06,0x3C,
+
+        8, // 0x68 'h'
+        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
+
+        4, // 0x69 'i'
+        0x00,0x00,0x00,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x00,0x00,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0xE0,
+
+        8, // 0x6B 'k'
+        0x00,0x00,0x60,0x60,0x60,0x66,0x6C,0x78,0x78,0x6C,0x66,0x00,0x00,
+
+        4, // 0x6C 'l'
+        0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        12, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7D,0xC0,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x00,0x00,0x00,0x00,
+
+        8, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
+
+        8, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x66,0x3C,0x00,0x00,
+
+        8, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x7C,0x60,0x60,
+
+        8, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x3E,0x06,0x06,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x6C,0x7C,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x60,0x78,0x3C,0x0C,0x78,0x00,0x00,
+
+        5, // 0x74 't'
+        0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x38,0x00,0x00,
+
+        8, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
+
+        8, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x18,0x00,0x00,
+
+        10, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6D,0x80,0x6D,0x80,0x6D,0x80,0x6D,0x80,0x33,0x00,0x33,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x3C,0x3C,0x66,0x66,0x00,0x00,
+
+        8, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x3C,0x3C,0x18,0x18,0x30,0x30,
+
+        7, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x0C,0x18,0x30,0x60,0x7C,0x00,0x00,
+
+        8, // 0x7B '{'
+        0x00,0x00,0x0E,0x18,0x18,0x18,0x18,0x70,0x18,0x18,0x18,0x18,0x0E,
+
+        6, // 0x7C '|'
+        0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
+
+        8, // 0x7D '}'
+        0x00,0x00,0x70,0x18,0x18,0x18,0x18,0x0E,0x18,0x18,0x18,0x18,0x70,
+
+        9, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x49,0x00,0x49,0x00,0x46,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x7F,0x80,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana14[] = 
+    {
+        14, 3, 32, 128-32,
+        0x00,0x00,0x0F,0x00,0x1E,0x00,0x2D,0x00,0x4A,0x00,0x59,0x00,0x76,0x00,0x93,0x00,0xA2,0x00,
+        0xB1,0x00,0xC0,0x00,0xCF,0x00,0xEC,0x00,0xFB,0x00,0x0A,0x01,0x19,0x01,0x28,0x01,0x37,0x01,
+        0x46,0x01,0x55,0x01,0x64,0x01,0x73,0x01,0x82,0x01,0x91,0x01,0xA0,0x01,0xAF,0x01,0xBE,0x01,
+        0xCD,0x01,0xDC,0x01,0xF9,0x01,0x16,0x02,0x33,0x02,0x42,0x02,0x5F,0x02,0x6E,0x02,0x7D,0x02,
+        0x9A,0x02,0xB7,0x02,0xC6,0x02,0xD5,0x02,0xF2,0x02,0x0F,0x03,0x1E,0x03,0x2D,0x03,0x3C,0x03,
+        0x4B,0x03,0x68,0x03,0x85,0x03,0xA2,0x03,0xB1,0x03,0xCE,0x03,0xDD,0x03,0xEC,0x03,0xFB,0x03,
+        0x18,0x04,0x27,0x04,0x44,0x04,0x53,0x04,0x62,0x04,0x71,0x04,0x80,0x04,0x8F,0x04,0x9E,0x04,
+        0xBB,0x04,0xCA,0x04,0xD9,0x04,0xE8,0x04,0xF7,0x04,0x06,0x05,0x15,0x05,0x24,0x05,0x33,0x05,
+        0x42,0x05,0x51,0x05,0x60,0x05,0x6F,0x05,0x7E,0x05,0x8D,0x05,0xAA,0x05,0xB9,0x05,0xC8,0x05,
+        0xD7,0x05,0xE6,0x05,0xF5,0x05,0x04,0x06,0x13,0x06,0x22,0x06,0x31,0x06,0x4E,0x06,0x5D,0x06,
+        0x6C,0x06,0x7B,0x06,0x8A,0x06,0x99,0x06,0xA8,0x06,0xC5,0x06,
+
+        4, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00,0x00,
+
+        6, // 0x22 '"'
+        0x00,0x00,0x48,0x48,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x12,0x00,0x3F,0x80,0x12,0x00,0x12,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x24 '$'
+        0x00,0x00,0x10,0x10,0x3E,0x50,0x50,0x30,0x1C,0x12,0x12,0x7C,0x10,0x10,
+
+        13, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x49,0x00,0x49,0x00,0x4A,0x00,0x32,0x60,0x02,0x90,0x04,0x90,0x04,0x90,0x08,0x60,0x00,0x00,0x00,0x00,
+
+        10, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x44,0x00,0x44,0x00,0x44,0x00,0x39,0x00,0x45,0x00,0x42,0x00,0x43,0x00,0x3C,0x80,0x00,0x00,0x00,0x00,
+
+        3, // 0x27 '''
+        0x00,0x00,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x28 '('
+        0x00,0x00,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,
+
+        5, // 0x29 ')'
+        0x00,0x00,0x40,0x20,0x20,0x10,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x40,
+
+        8, // 0x2A '*'
+        0x00,0x00,0x10,0x54,0x38,0x54,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
+
+        5, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,
+
+        5, // 0x2F '/'
+        0x00,0x00,0x08,0x08,0x10,0x10,0x10,0x20,0x20,0x20,0x40,0x40,0x40,0x80,
+
+        8, // 0x30 '0'
+        0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
+
+        8, // 0x31 '1'
+        0x00,0x00,0x00,0x08,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x3E,0x00,0x00,
+
+        8, // 0x32 '2'
+        0x00,0x00,0x00,0x3C,0x42,0x42,0x02,0x04,0x18,0x20,0x40,0x7E,0x00,0x00,
+
+        8, // 0x33 '3'
+        0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x1C,0x02,0x02,0x42,0x3C,0x00,0x00,
+
+        8, // 0x34 '4'
+        0x00,0x00,0x00,0x04,0x0C,0x14,0x24,0x44,0x7F,0x04,0x04,0x04,0x00,0x00,
+
+        8, // 0x35 '5'
+        0x00,0x00,0x00,0x7E,0x40,0x40,0x7C,0x02,0x02,0x02,0x42,0x3C,0x00,0x00,
+
+        8, // 0x36 '6'
+        0x00,0x00,0x00,0x1C,0x20,0x40,0x7C,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
+
+        8, // 0x37 '7'
+        0x00,0x00,0x00,0x7E,0x02,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x00,0x00,
+
+        8, // 0x38 '8'
+        0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x3C,0x42,0x42,0x42,0x3C,0x00,0x00,
+
+        8, // 0x39 '9'
+        0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x3E,0x02,0x04,0x38,0x00,0x00,
+
+        5, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x00,0x00,
+
+        5, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x20,0x40,
+
+        9, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x3F '?'
+        0x00,0x00,0x00,0x38,0x44,0x04,0x04,0x08,0x10,0x10,0x00,0x10,0x00,0x00,
+
+        12, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x27,0x40,0x49,0x20,0x49,0x20,0x49,0x20,0x49,0x20,0x27,0xC0,0x30,0x00,0x0F,0x00,0x00,0x00,
+
+        8, // 0x41 'A'
+        0x00,0x00,0x00,0x18,0x18,0x24,0x24,0x42,0x42,0x7E,0x81,0x81,0x00,0x00,
+
+        8, // 0x42 'B'
+        0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x7C,0x42,0x42,0x42,0x7C,0x00,0x00,
+
+        9, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x45 'E'
+        0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7E,0x40,0x40,0x40,0x7E,0x00,0x00,
+
+        7, // 0x46 'F'
+        0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7C,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        9, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x47,0x00,0x41,0x00,0x41,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,
+
+        5, // 0x4A 'J'
+        0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,0x00,0x00,
+
+        8, // 0x4B 'K'
+        0x00,0x00,0x00,0x42,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x42,0x00,0x00,
+
+        7, // 0x4C 'L'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7E,0x00,0x00,
+
+        10, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x52,0x80,0x52,0x80,0x52,0x80,0x4C,0x80,0x4C,0x80,0x40,0x80,0x40,0x80,0x00,0x00,0x00,0x00,
+
+        9, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x00,0x61,0x00,0x51,0x00,0x51,0x00,0x49,0x00,0x45,0x00,0x45,0x00,0x43,0x00,0x43,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x50 'P'
+        0x00,0x00,0x00,0x7C,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,0x40,0x00,0x00,
+
+        10, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x02,0x00,0x01,0x80,
+
+        8, // 0x52 'R'
+        0x00,0x00,0x00,0x7C,0x42,0x42,0x42,0x7C,0x48,0x44,0x42,0x41,0x00,0x00,
+
+        8, // 0x53 'S'
+        0x00,0x00,0x00,0x3C,0x42,0x40,0x40,0x3C,0x02,0x02,0x42,0x3C,0x00,0x00,
+
+        7, // 0x54 'T'
+        0x00,0x00,0x00,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        9, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x56 'V'
+        0x00,0x00,0x00,0x81,0x81,0x42,0x42,0x42,0x24,0x24,0x18,0x18,0x00,0x00,
+
+        13, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x10,0x42,0x10,0x45,0x10,0x45,0x10,0x25,0x20,0x28,0xA0,0x28,0xA0,0x10,0x40,0x10,0x40,0x00,0x00,0x00,0x00,
+
+        8, // 0x58 'X'
+        0x00,0x00,0x00,0x42,0x42,0x24,0x18,0x18,0x18,0x24,0x42,0x42,0x00,0x00,
+
+        7, // 0x59 'Y'
+        0x00,0x00,0x00,0x82,0x44,0x44,0x28,0x10,0x10,0x10,0x10,0x10,0x00,0x00,
+
+        8, // 0x5A 'Z'
+        0x00,0x00,0x00,0x7E,0x02,0x04,0x08,0x10,0x10,0x20,0x40,0x7E,0x00,0x00,
+
+        5, // 0x5B '['
+        0x00,0x00,0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,
+
+        5, // 0x5C '\'
+        0x00,0x00,0x80,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x10,0x08,0x08,
+
+        5, // 0x5D ']'
+        0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,
+
+        10, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x12,0x00,0x21,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,
+
+        8, // 0x60 '`'
+        0x00,0x00,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x02,0x02,0x3E,0x42,0x42,0x3E,0x00,0x00,
+
+        8, // 0x62 'b'
+        0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x00,0x00,
+
+        6, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x38,0x44,0x40,0x40,0x40,0x44,0x38,0x00,0x00,
+
+        8, // 0x64 'd'
+        0x00,0x00,0x02,0x02,0x02,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,
+
+        8, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x7E,0x40,0x42,0x3C,0x00,0x00,
+
+        4, // 0x66 'f'
+        0x00,0x00,0x30,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        8, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x3C,
+
+        8, // 0x68 'h'
+        0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        4, // 0x6A 'j'
+        0x00,0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xC0,
+
+        7, // 0x6B 'k'
+        0x00,0x00,0x40,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        11, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7B,0x80,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x00,0x00,0x00,0x00,
+
+        8, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,
+
+        8, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,
+
+        8, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,
+
+        8, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x02,
+
+        5, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x58,0x60,0x40,0x40,0x40,0x40,0x40,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x40,0x40,0x38,0x04,0x04,0x78,0x00,0x00,
+
+        5, // 0x74 't'
+        0x00,0x00,0x00,0x40,0x40,0xF8,0x40,0x40,0x40,0x40,0x40,0x38,0x00,0x00,
+
+        8, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,
+
+        7, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x00,0x00,
+
+        11, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,
+
+        7, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x10,0x20,
+
+        7, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,
+
+        8, // 0x7B '{'
+        0x00,0x00,0x0C,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x10,0x0C,
+
+        5, // 0x7C '|'
+        0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
+
+        8, // 0x7D '}'
+        0x00,0x00,0x30,0x08,0x08,0x08,0x08,0x06,0x08,0x08,0x08,0x08,0x08,0x30,
+
+        10, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x4C,0x80,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3F,0xE0,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana14_bold[] = 
+    {
+        14, 3, 32, 128-32,
+        0x00,0x00,0x0F,0x00,0x1E,0x00,0x2D,0x00,0x4A,0x00,0x67,0x00,0x84,0x00,0xA1,0x00,0xB0,0x00,
+        0xBF,0x00,0xCE,0x00,0xEB,0x00,0x08,0x01,0x17,0x01,0x26,0x01,0x35,0x01,0x44,0x01,0x61,0x01,
+        0x7E,0x01,0x9B,0x01,0xB8,0x01,0xD5,0x01,0xF2,0x01,0x0F,0x02,0x2C,0x02,0x49,0x02,0x66,0x02,
+        0x75,0x02,0x84,0x02,0xA1,0x02,0xBE,0x02,0xDB,0x02,0xEA,0x02,0x07,0x03,0x24,0x03,0x41,0x03,
+        0x5E,0x03,0x7B,0x03,0x8A,0x03,0x99,0x03,0xB6,0x03,0xD3,0x03,0xE2,0x03,0xF1,0x03,0x0E,0x04,
+        0x1D,0x04,0x3A,0x04,0x57,0x04,0x74,0x04,0x91,0x04,0xAE,0x04,0xCB,0x04,0xE8,0x04,0xF7,0x04,
+        0x14,0x05,0x31,0x05,0x4E,0x05,0x6B,0x05,0x88,0x05,0x97,0x05,0xA6,0x05,0xB5,0x05,0xC4,0x05,
+        0xE1,0x05,0xFE,0x05,0x1B,0x06,0x2A,0x06,0x39,0x06,0x48,0x06,0x57,0x06,0x66,0x06,0x75,0x06,
+        0x84,0x06,0x93,0x06,0xA2,0x06,0xB1,0x06,0xC0,0x06,0xCF,0x06,0xEC,0x06,0xFB,0x06,0x0A,0x07,
+        0x19,0x07,0x28,0x07,0x37,0x07,0x46,0x07,0x55,0x07,0x64,0x07,0x73,0x07,0x90,0x07,0x9F,0x07,
+        0xAE,0x07,0xBD,0x07,0xDA,0x07,0xE9,0x07,0x06,0x08,0x23,0x08,
+
+        4, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x60,0x60,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x00,0x6C,0x6C,0x6C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x3F,0x80,0x3F,0x80,0x12,0x00,0x7F,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x24 '$'
+        0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x69,0x00,0x68,0x00,0x7E,0x00,0x3F,0x00,0x0B,0x00,0x4B,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,
+
+        15, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x6C,0x40,0x6C,0x80,0x6C,0xB8,0x6D,0x6C,0x3A,0x6C,0x02,0x6C,0x04,0x6C,0x04,0x38,0x00,0x00,0x00,0x00,
+
+        10, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x6C,0x00,0x6C,0x00,0x6C,0x00,0x39,0x80,0x6D,0x00,0x66,0x00,0x63,0x00,0x3D,0x80,0x00,0x00,0x00,0x00,
+
+        4, // 0x27 '''
+        0x00,0x00,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x00,0x00,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,
+
+        7, // 0x29 ')'
+        0x00,0x00,0x30,0x18,0x18,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x18,0x18,0x30,
+
+        9, // 0x2A '*'
+        0x00,0x00,0x00,0x00,0x08,0x00,0x2A,0x00,0x1C,0x00,0x1C,0x00,0x2A,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x40,
+
+        6, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        8, // 0x2F '/'
+        0x00,0x00,0x06,0x06,0x0C,0x0C,0x0C,0x18,0x18,0x30,0x30,0x30,0x60,0x60,
+
+        9, // 0x30 '0'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x31 '1'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x3C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x32 '2'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x33 '3'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x03,0x00,0x1E,0x00,0x03,0x00,0x03,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x34 '4'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0E,0x00,0x16,0x00,0x16,0x00,0x26,0x00,0x46,0x00,0x7F,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x35 '5'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x30,0x00,0x30,0x00,0x3E,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x36 '6'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x30,0x00,0x60,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x37 '7'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x38 '8'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x39 '9'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x03,0x00,0x06,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x00,0x00,
+
+        5, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x60,0x60,0x60,0x40,
+
+        10, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x3F '?'
+        0x00,0x00,0x00,0x38,0x4C,0x0C,0x18,0x30,0x30,0x00,0x30,0x30,0x00,0x00,
+
+        12, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x2F,0x40,0x5B,0x20,0x5B,0x20,0x5B,0x20,0x5B,0x20,0x2F,0xC0,0x30,0x00,0x0F,0x00,0x00,0x00,
+
+        9, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x7F,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x42 'B'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x66,0x00,0x66,0x00,0x66,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x31,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x31,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x45 'E'
+        0x00,0x00,0x00,0x7E,0x60,0x60,0x60,0x7E,0x60,0x60,0x60,0x7E,0x00,0x00,
+
+        8, // 0x46 'F'
+        0x00,0x00,0x00,0x7E,0x60,0x60,0x60,0x7E,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        10, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x30,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x67,0x80,0x61,0x80,0x31,0x80,0x1F,0x80,0x00,0x00,0x00,0x00,
+
+        10, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x7F,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,
+
+        6, // 0x49 'I'
+        0x00,0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,
+
+        7, // 0x4A 'J'
+        0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0xF8,0x00,0x00,
+
+        9, // 0x4B 'K'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x66,0x00,0x6C,0x00,0x78,0x00,0x70,0x00,0x78,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x4C 'L'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7F,0x00,0x00,
+
+        11, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x71,0xC0,0x71,0xC0,0x5A,0xC0,0x5A,0xC0,0x4C,0xC0,0x4C,0xC0,0x40,0xC0,0x40,0xC0,0x00,0x00,0x00,0x00,
+
+        10, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x80,0x70,0x80,0x58,0x80,0x58,0x80,0x4C,0x80,0x46,0x80,0x46,0x80,0x43,0x80,0x41,0x80,0x00,0x00,0x00,0x00,
+
+        11, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x50 'P'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x06,0x00,0x03,0xC0,
+
+        9, // 0x52 'R'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,
+
+        9, // 0x53 'S'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x61,0x00,0x60,0x00,0x70,0x00,0x3E,0x00,0x07,0x00,0x03,0x00,0x43,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x54 'T'
+        0x00,0x00,0x00,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,
+
+        10, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x56 'V'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x63,0x18,0x33,0x30,0x37,0xB0,0x34,0xB0,0x1C,0xE0,0x18,0x60,0x18,0x60,0x00,0x00,0x00,0x00,
+
+        9, // 0x58 'X'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x59 'Y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5A 'Z'
+        0x00,0x00,0x00,0x7E,0x0C,0x0C,0x18,0x18,0x30,0x30,0x60,0x7E,0x00,0x00,
+
+        6, // 0x5B '['
+        0x00,0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,
+
+        8, // 0x5C '\'
+        0x00,0x00,0x60,0x60,0x30,0x30,0x30,0x18,0x18,0x0C,0x0C,0x0C,0x06,0x06,
+
+        6, // 0x5D ']'
+        0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,
+
+        10, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
+
+        9, // 0x60 '`'
+        0x00,0x00,0x00,0x00,0x30,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x06,0x3E,0x66,0x66,0x66,0x3E,0x00,0x00,
+
+        8, // 0x62 'b'
+        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x66,0x7C,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x62,0x60,0x60,0x60,0x62,0x3C,0x00,0x00,
+
+        8, // 0x64 'd'
+        0x00,0x00,0x06,0x06,0x06,0x3E,0x66,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
+
+        8, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x66,0x7E,0x60,0x62,0x3C,0x00,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        8, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x66,0x3E,0x06,0x3C,
+
+        8, // 0x68 'h'
+        0x00,0x00,0x60,0x60,0x60,0x7C,0x66,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
+
+        4, // 0x69 'i'
+        0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x00,0x30,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0xE0,
+
+        8, // 0x6B 'k'
+        0x00,0x00,0x60,0x60,0x60,0x66,0x6C,0x78,0x78,0x6C,0x66,0x63,0x00,0x00,
+
+        4, // 0x6C 'l'
+        0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        12, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6C,0xC0,0x77,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x66,0x60,0x00,0x00,0x00,0x00,
+
+        8, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x66,0x66,0x00,0x00,
+
+        8, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x66,0x66,0x66,0x66,0x66,0x3C,0x00,0x00,
+
+        8, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x66,0x7C,0x60,0x60,
+
+        8, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x3E,0x66,0x66,0x66,0x66,0x66,0x3E,0x06,0x06,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x6C,0x7C,0x60,0x60,0x60,0x60,0x60,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x3C,0x60,0x60,0x38,0x0C,0x0C,0x78,0x00,0x00,
+
+        5, // 0x74 't'
+        0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x38,0x00,0x00,
+
+        8, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x66,0x3E,0x00,0x00,
+
+        8, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x3C,0x18,0x00,0x00,
+
+        12, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x60,0x66,0x60,0x66,0x60,0x69,0x60,0x39,0xC0,0x30,0xC0,0x30,0xC0,0x00,0x00,0x00,0x00,
+
+        8, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x3C,0x18,0x3C,0x66,0x66,0x00,0x00,
+
+        8, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x3C,0x3C,0x3C,0x18,0x18,0x30,
+
+        7, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x7C,0x0C,0x18,0x38,0x30,0x60,0x7C,0x00,0x00,
+
+        9, // 0x7B '{'
+        0x00,0x00,0x00,0x00,0x0E,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x0E,0x00,
+
+        6, // 0x7C '|'
+        0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
+
+        9, // 0x7D '}'
+        0x00,0x00,0x00,0x00,0x38,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x38,0x00,
+
+        10, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x48,0x80,0x44,0x80,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3F,0xE0,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana16[] = 
+    {
+        16, 4, 32, 128-32,
+        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x54,0x00,0x65,0x00,0x86,0x00,0xA7,0x00,0xB8,0x00,
+        0xC9,0x00,0xDA,0x00,0xFB,0x00,0x1C,0x01,0x2D,0x01,0x3E,0x01,0x4F,0x01,0x60,0x01,0x71,0x01,
+        0x82,0x01,0x93,0x01,0xA4,0x01,0xB5,0x01,0xC6,0x01,0xD7,0x01,0xE8,0x01,0xF9,0x01,0x0A,0x02,
+        0x1B,0x02,0x2C,0x02,0x4D,0x02,0x6E,0x02,0x8F,0x02,0xA0,0x02,0xC1,0x02,0xE2,0x02,0xF3,0x02,
+        0x14,0x03,0x35,0x03,0x46,0x03,0x57,0x03,0x78,0x03,0x99,0x03,0xAA,0x03,0xBB,0x03,0xCC,0x03,
+        0xDD,0x03,0xFE,0x03,0x1F,0x04,0x40,0x04,0x51,0x04,0x72,0x04,0x93,0x04,0xB4,0x04,0xD5,0x04,
+        0xF6,0x04,0x17,0x05,0x38,0x05,0x59,0x05,0x7A,0x05,0x9B,0x05,0xAC,0x05,0xBD,0x05,0xCE,0x05,
+        0xEF,0x05,0x00,0x06,0x11,0x06,0x22,0x06,0x33,0x06,0x44,0x06,0x55,0x06,0x66,0x06,0x77,0x06,
+        0x88,0x06,0x99,0x06,0xAA,0x06,0xBB,0x06,0xCC,0x06,0xDD,0x06,0xFE,0x06,0x0F,0x07,0x20,0x07,
+        0x31,0x07,0x42,0x07,0x53,0x07,0x64,0x07,0x75,0x07,0x86,0x07,0x97,0x07,0xB8,0x07,0xC9,0x07,
+        0xDA,0x07,0xEB,0x07,0xFC,0x07,0x0D,0x08,0x1E,0x08,0x3F,0x08,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x21 '!'
+        0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        5, // 0x22 '"'
+        0x00,0x00,0x00,0x50,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x3F,0x80,0x12,0x00,0x12,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x24 '$'
+        0x00,0x00,0x00,0x10,0x10,0x3E,0x50,0x50,0x30,0x1C,0x12,0x12,0x7C,0x10,0x10,0x00,
+
+        13, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x44,0x80,0x45,0x00,0x45,0x00,0x3A,0xE0,0x05,0x10,0x05,0x10,0x09,0x10,0x10,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x44,0x00,0x44,0x00,0x44,0x00,0x38,0x80,0x45,0x00,0x42,0x00,0x46,0x00,0x39,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        3, // 0x27 '''
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x28 '('
+        0x00,0x00,0x00,0x08,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x08,
+
+        6, // 0x29 ')'
+        0x00,0x00,0x00,0x40,0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x40,
+
+        9, // 0x2A '*'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        6, // 0x2F '/'
+        0x00,0x00,0x00,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
+
+        8, // 0x30 '0'
+        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
+
+        8, // 0x31 '1'
+        0x00,0x00,0x00,0x00,0x08,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x3E,0x00,0x00,0x00,
+
+        8, // 0x32 '2'
+        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x02,0x04,0x18,0x20,0x40,0x7E,0x00,0x00,0x00,
+
+        8, // 0x33 '3'
+        0x00,0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x1C,0x02,0x02,0x42,0x3C,0x00,0x00,0x00,
+
+        8, // 0x34 '4'
+        0x00,0x00,0x00,0x00,0x04,0x0C,0x14,0x24,0x44,0x7F,0x04,0x04,0x04,0x00,0x00,0x00,
+
+        8, // 0x35 '5'
+        0x00,0x00,0x00,0x00,0x3E,0x20,0x20,0x20,0x3C,0x02,0x02,0x42,0x3C,0x00,0x00,0x00,
+
+        8, // 0x36 '6'
+        0x00,0x00,0x00,0x00,0x1C,0x20,0x40,0x7C,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
+
+        8, // 0x37 '7'
+        0x00,0x00,0x00,0x00,0x7E,0x02,0x04,0x04,0x08,0x08,0x10,0x10,0x10,0x00,0x00,0x00,
+
+        8, // 0x38 '8'
+        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x3C,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
+
+        8, // 0x39 '9'
+        0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x3E,0x02,0x04,0x38,0x00,0x00,0x00,
+
+        6, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        6, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
+
+        9, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x00,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x3F '?'
+        0x00,0x00,0x00,0x00,0x38,0x44,0x04,0x08,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
+
+        13, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x10,0x40,0x27,0xA0,0x48,0x90,0x48,0x90,0x48,0x90,0x48,0x90,0x48,0x90,0x27,0xE0,0x10,0x00,0x0F,0x80,0x00,0x00,
+
+        9, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x3E,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x42 'B'
+        0x00,0x00,0x00,0x00,0x78,0x44,0x44,0x44,0x7C,0x42,0x42,0x42,0x7C,0x00,0x00,0x00,
+
+        9, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x45 'E'
+        0x00,0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7E,0x40,0x40,0x40,0x7E,0x00,0x00,0x00,
+
+        8, // 0x46 'F'
+        0x00,0x00,0x00,0x00,0x7E,0x40,0x40,0x40,0x7C,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        9, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x47,0x00,0x41,0x00,0x21,0x00,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x00,0x00,0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xF0,0x00,0x00,0x00,
+
+        8, // 0x4B 'K'
+        0x00,0x00,0x00,0x00,0x42,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x42,0x00,0x00,0x00,
+
+        7, // 0x4C 'L'
+        0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7E,0x00,0x00,0x00,
+
+        11, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x51,0x40,0x51,0x40,0x4A,0x40,0x4A,0x40,0x44,0x40,0x44,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x00,0x61,0x00,0x51,0x00,0x51,0x00,0x49,0x00,0x45,0x00,0x45,0x00,0x43,0x00,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x50 'P'
+        0x00,0x00,0x00,0x00,0x7C,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        10, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x02,0x00,0x01,0x80,0x00,0x00,
+
+        9, // 0x52 'R'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x42,0x00,0x42,0x00,0x44,0x00,0x78,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x53 'S'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x40,0x00,0x40,0x00,0x3E,0x00,0x01,0x00,0x01,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x54 'T'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x56 'V'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x10,0x42,0x10,0x45,0x10,0x45,0x10,0x25,0x20,0x28,0xA0,0x28,0xA0,0x10,0x40,0x10,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x58 'X'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x59 'Y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x5A 'Z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x01,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5B '['
+        0x00,0x00,0x00,0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x38,0x00,
+
+        6, // 0x5C '\'
+        0x00,0x00,0x00,0x80,0x80,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x00,
+
+        6, // 0x5D ']'
+        0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,0x00,
+
+        11, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x0A,0x00,0x11,0x00,0x20,0x80,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
+
+        8, // 0x60 '`'
+        0x00,0x00,0x00,0x10,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x02,0x02,0x3E,0x42,0x42,0x3E,0x00,0x00,0x00,
+
+        8, // 0x62 'b'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x00,0x00,0x00,
+
+        8, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x40,0x40,0x40,0x42,0x3C,0x00,0x00,0x00,
+
+        8, // 0x64 'd'
+        0x00,0x00,0x00,0x02,0x02,0x02,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,0x00,
+
+        8, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x7E,0x40,0x42,0x3C,0x00,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x00,0x00,0x1C,0x20,0x20,0x78,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
+
+        8, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x02,0x3C,
+
+        8, // 0x68 'h'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        4, // 0x6A 'j'
+        0x00,0x00,0x00,0x20,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xC0,
+
+        7, // 0x6B 'k'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x00,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        11, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x59,0x80,0x66,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x42,0x00,0x00,0x00,
+
+        8, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,0x00,0x00,
+
+        8, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x42,0x7C,0x40,0x40,0x40,
+
+        8, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x42,0x42,0x42,0x42,0x46,0x3A,0x02,0x02,0x02,
+
+        5, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x58,0x60,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        7, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x40,0x40,0x38,0x04,0x04,0x78,0x00,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x00,0x00,0x00,0x20,0x20,0x78,0x20,0x20,0x20,0x20,0x20,0x18,0x00,0x00,0x00,
+
+        8, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x42,0x42,0x42,0x46,0x3A,0x00,0x00,0x00,
+
+        8, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x00,0x00,0x00,
+
+        11, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x44,0x28,0x10,0x28,0x44,0x44,0x00,0x00,0x00,
+
+        8, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x10,0x10,0x20,
+
+        7, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x04,0x08,0x10,0x20,0x40,0x7C,0x00,0x00,0x00,
+
+        8, // 0x7B '{'
+        0x00,0x00,0x00,0x0C,0x10,0x10,0x10,0x10,0x60,0x10,0x10,0x10,0x10,0x10,0x0C,0x00,
+
+        7, // 0x7C '|'
+        0x00,0x00,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x00,
+
+        8, // 0x7D '}'
+        0x00,0x00,0x00,0x30,0x08,0x08,0x08,0x08,0x06,0x08,0x08,0x08,0x08,0x08,0x30,0x00,
+
+        11, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x80,0x4C,0x80,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF0,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x3F,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana16_bold[] = 
+    {
+        16, 4, 32, 128-32,
+        0x00,0x00,0x11,0x00,0x22,0x00,0x33,0x00,0x54,0x00,0x75,0x00,0xA6,0x00,0xC7,0x00,0xD8,0x00,
+        0xE9,0x00,0xFA,0x00,0x1B,0x01,0x3C,0x01,0x4D,0x01,0x5E,0x01,0x6F,0x01,0x90,0x01,0xB1,0x01,
+        0xD2,0x01,0xF3,0x01,0x14,0x02,0x35,0x02,0x56,0x02,0x77,0x02,0x98,0x02,0xB9,0x02,0xDA,0x02,
+        0xEB,0x02,0xFC,0x02,0x1D,0x03,0x3E,0x03,0x5F,0x03,0x70,0x03,0x91,0x03,0xB2,0x03,0xD3,0x03,
+        0xF4,0x03,0x15,0x04,0x36,0x04,0x57,0x04,0x78,0x04,0x99,0x04,0xAA,0x04,0xBB,0x04,0xDC,0x04,
+        0xED,0x04,0x0E,0x05,0x2F,0x05,0x50,0x05,0x71,0x05,0x92,0x05,0xB3,0x05,0xD4,0x05,0xE5,0x05,
+        0x06,0x06,0x27,0x06,0x48,0x06,0x69,0x06,0x8A,0x06,0xAB,0x06,0xBC,0x06,0xDD,0x06,0xEE,0x06,
+        0x0F,0x07,0x30,0x07,0x51,0x07,0x72,0x07,0x93,0x07,0xA4,0x07,0xC5,0x07,0xE6,0x07,0xF7,0x07,
+        0x18,0x08,0x39,0x08,0x4A,0x08,0x5B,0x08,0x6C,0x08,0x7D,0x08,0x9E,0x08,0xBF,0x08,0xE0,0x08,
+        0x01,0x09,0x22,0x09,0x33,0x09,0x44,0x09,0x55,0x09,0x76,0x09,0x97,0x09,0xB8,0x09,0xD9,0x09,
+        0xFA,0x09,0x0B,0x0A,0x2C,0x0A,0x3D,0x0A,0x5E,0x0A,0x7F,0x0A,
+
+        4, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x00,0x00,0x6C,0x6C,0x6C,0x6C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x00,0x09,0x00,0x3F,0x80,0x3F,0x80,0x12,0x00,0x7F,0x00,0x7F,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x24 '$'
+        0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x69,0x00,0x68,0x00,0x78,0x00,0x3E,0x00,0x0F,0x00,0x0B,0x00,0x4B,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x00,0x00,
+
+        17, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x20,0x00,0x66,0x20,0x00,0x66,0x40,0x00,0x66,0x5E,0x00,0x66,0xB3,0x00,0x3D,0x33,0x00,0x01,0x33,0x00,0x02,0x33,0x00,0x02,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x66,0x00,0x66,0x00,0x66,0xC0,0x3C,0xC0,0x66,0x80,0x63,0x00,0x63,0x80,0x3C,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x27 '''
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x00,0x00,0x00,0x0C,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,0x0C,
+
+        7, // 0x29 ')'
+        0x00,0x00,0x00,0x60,0x30,0x18,0x18,0x0C,0x0C,0x0C,0x0C,0x0C,0x18,0x18,0x30,0x60,
+
+        9, // 0x2A '*'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x3F,0x80,0x04,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x60,0x60,0xC0,0xC0,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        9, // 0x2F '/'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x60,0x00,0x60,0x00,0x00,0x00,
+
+        9, // 0x30 '0'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x31 '1'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x3C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x32 '2'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x33 '3'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x03,0x00,0x0E,0x00,0x03,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x34 '4'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0E,0x00,0x16,0x00,0x26,0x00,0x46,0x00,0x7F,0x80,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x35 '5'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x30,0x00,0x30,0x00,0x3E,0x00,0x03,0x00,0x03,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x36 '6'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x30,0x00,0x60,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x37 '7'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x38 '8'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x39 '9'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x03,0x00,0x06,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        5, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x38,0x30,0x30,0x60,0x60,
+
+        11, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x40,0x01,0x80,0x06,0x00,0x18,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x3F '?'
+        0x00,0x00,0x00,0x00,0x3C,0x66,0x06,0x0C,0x18,0x18,0x00,0x18,0x18,0x00,0x00,0x00,
+
+        13, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0x60,0x27,0xA0,0x4D,0x90,0x4D,0x90,0x4D,0x90,0x4D,0x90,0x27,0xE0,0x30,0x00,0x0F,0x80,0x00,0x00,0x00,0x00,
+
+        10, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x0C,0x00,0x1E,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x7F,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x42 'B'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x61,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x61,0x80,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x45 'E'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x46 'F'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x61,0x80,0x60,0x00,0x60,0x00,0x63,0x80,0x61,0x80,0x31,0x80,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x7F,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x49 'I'
+        0x00,0x00,0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,
+
+        7, // 0x4A 'J'
+        0x00,0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0xF8,0x00,0x00,0x00,
+
+        9, // 0x4B 'K'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x66,0x00,0x6C,0x00,0x78,0x00,0x78,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x4C 'L'
+        0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7F,0x00,0x00,0x00,
+
+        12, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0xE0,0x70,0xE0,0x59,0x60,0x59,0x60,0x4E,0x60,0x4E,0x60,0x44,0x60,0x44,0x60,0x40,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x80,0x70,0x80,0x58,0x80,0x58,0x80,0x4C,0x80,0x46,0x80,0x46,0x80,0x43,0x80,0x43,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x50 'P'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x03,0x00,0x01,0xC0,0x00,0x00,
+
+        9, // 0x52 'R'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x6C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x53 'S'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x70,0x00,0x3E,0x00,0x07,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x54 'T'
+        0x00,0x00,0x00,0x00,0xFF,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00,
+
+        10, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x56 'V'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x63,0x18,0x33,0x30,0x37,0xB0,0x34,0xB0,0x1C,0xE0,0x18,0x60,0x18,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x58 'X'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x33,0x00,0x33,0x00,0x1E,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x59 'Y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x5A 'Z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5B '['
+        0x00,0x00,0x00,0x78,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x78,0x00,
+
+        9, // 0x5C '\'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x30,0x00,0x30,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x00,0x00,
+
+        6, // 0x5D ']'
+        0x00,0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,0x00,
+
+        10, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,0x00,
+
+        9, // 0x60 '`'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x03,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x62 'b'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x60,0x60,0x60,0x63,0x3E,0x00,0x00,0x00,
+
+        9, // 0x64 'd'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x7F,0x00,0x60,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x66 'f'
+        0x00,0x00,0x00,0x38,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        9, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x03,0x00,0x03,0x00,0x3E,0x00,
+
+        9, // 0x68 'h'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x69 'i'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x00,0x00,0x30,0x30,0x00,0x70,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0xE0,
+
+        8, // 0x6B 'k'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x66,0x6C,0x78,0x78,0x6C,0x66,0x63,0x00,0x00,0x00,
+
+        4, // 0x6C 'l'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        14, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x70,0x73,0x98,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,
+
+        9, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x03,0x00,0x03,0x00,0x03,0x00,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x6C,0x7C,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        8, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x60,0x70,0x3C,0x0E,0x06,0x7C,0x00,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x00,0x00,0x00,0x60,0x60,0xF8,0x60,0x60,0x60,0x60,0x60,0x38,0x00,0x00,0x00,
+
+        9, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x67,0x00,0x3B,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0x60,0x66,0x60,0x66,0x60,0x69,0x60,0x39,0xC0,0x30,0xC0,0x30,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x1C,0x00,0x36,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,
+
+        8, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x06,0x0C,0x18,0x30,0x60,0x7E,0x00,0x00,0x00,
+
+        9, // 0x7B '{'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x00,0x00,0x00,
+
+        8, // 0x7C '|'
+        0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,
+
+        9, // 0x7D '}'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x07,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x70,0x00,0x00,0x00,
+
+        11, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x44,0x40,0x44,0x40,0x43,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF0,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x20,0x10,0x3F,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana17[] = 
+    {
+        17, 4, 32, 128-32,
+        0x00,0x00,0x12,0x00,0x24,0x00,0x36,0x00,0x59,0x00,0x7C,0x00,0x9F,0x00,0xC2,0x00,0xD4,0x00,
+        0xE6,0x00,0xF8,0x00,0x1B,0x01,0x3E,0x01,0x50,0x01,0x62,0x01,0x74,0x01,0x86,0x01,0xA9,0x01,
+        0xCC,0x01,0xEF,0x01,0x12,0x02,0x35,0x02,0x58,0x02,0x7B,0x02,0x9E,0x02,0xC1,0x02,0xE4,0x02,
+        0xF6,0x02,0x08,0x03,0x2B,0x03,0x4E,0x03,0x71,0x03,0x83,0x03,0xA6,0x03,0xC9,0x03,0xEC,0x03,
+        0x0F,0x04,0x32,0x04,0x55,0x04,0x67,0x04,0x8A,0x04,0xAD,0x04,0xBF,0x04,0xD1,0x04,0xF4,0x04,
+        0x06,0x05,0x29,0x05,0x4C,0x05,0x6F,0x05,0x81,0x05,0xA4,0x05,0xC7,0x05,0xEA,0x05,0x0D,0x06,
+        0x30,0x06,0x53,0x06,0x76,0x06,0x99,0x06,0xBC,0x06,0xDF,0x06,0xF1,0x06,0x03,0x07,0x15,0x07,
+        0x38,0x07,0x5B,0x07,0x7E,0x07,0x90,0x07,0xB3,0x07,0xC5,0x07,0xE8,0x07,0xFA,0x07,0x0C,0x08,
+        0x2F,0x08,0x52,0x08,0x64,0x08,0x76,0x08,0x88,0x08,0x9A,0x08,0xBD,0x08,0xE0,0x08,0x03,0x09,
+        0x26,0x09,0x49,0x09,0x5B,0x09,0x6D,0x09,0x7F,0x09,0xA2,0x09,0xB4,0x09,0xD7,0x09,0xFA,0x09,
+        0x0C,0x0A,0x1E,0x0A,0x41,0x0A,0x53,0x0A,0x76,0x0A,0x99,0x0A,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        6, // 0x22 '"'
+        0x00,0x00,0x00,0x48,0x48,0x48,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x80,0x04,0x80,0x09,0x00,0x3F,0xC0,0x09,0x00,0x12,0x00,0x7F,0x80,0x12,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x24 '$'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x49,0x00,0x48,0x00,0x48,0x00,0x3E,0x00,0x09,0x00,0x09,0x00,0x49,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x00,0x00,
+
+        15, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x20,0x44,0x40,0x44,0x80,0x44,0x80,0x45,0x38,0x39,0x44,0x02,0x44,0x04,0x44,0x04,0x44,0x08,0x38,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x42,0x00,0x42,0x00,0x44,0x00,0x38,0x80,0x44,0x80,0x42,0x80,0x41,0x00,0x22,0x80,0x1C,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x27 '''
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x28 '('
+        0x00,0x00,0x00,0x08,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x08,
+
+        6, // 0x29 ')'
+        0x00,0x00,0x00,0x40,0x20,0x10,0x10,0x08,0x08,0x08,0x08,0x08,0x08,0x10,0x10,0x20,0x40,
+
+        9, // 0x2A '*'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x7F,0xC0,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        6, // 0x2F '/'
+        0x00,0x00,0x00,0x04,0x08,0x08,0x08,0x10,0x10,0x20,0x20,0x20,0x40,0x40,0x80,0x80,0x00,
+
+        9, // 0x30 '0'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x31 '1'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x38,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x32 '2'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x01,0x00,0x01,0x00,0x02,0x00,0x0C,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x33 '3'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x01,0x00,0x02,0x00,0x1C,0x00,0x02,0x00,0x01,0x00,0x01,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x34 '4'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x06,0x00,0x0A,0x00,0x12,0x00,0x22,0x00,0x42,0x00,0x7F,0x80,0x02,0x00,0x02,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x35 '5'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7C,0x00,0x02,0x00,0x01,0x00,0x01,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x36 '6'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x30,0x00,0x20,0x00,0x40,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x37 '7'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x01,0x00,0x02,0x00,0x02,0x00,0x04,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x10,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x38 '8'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x3E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x39 '9'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x21,0x00,0x1F,0x00,0x01,0x00,0x02,0x00,0x06,0x00,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        6, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x00,
+
+        11, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x06,0x00,0x18,0x00,0x60,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xC0,0x00,0x00,0x00,0x00,0x3F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x3F '?'
+        0x00,0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x0C,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
+
+        14, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xC0,0x18,0x20,0x20,0x10,0x27,0xC8,0x48,0x48,0x48,0x48,0x48,0x48,0x48,0x48,0x27,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
+
+        10, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x12,0x00,0x12,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x7F,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x42 'B'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7E,0x00,0x41,0x00,0x40,0x80,0x40,0x80,0x41,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0x80,0x20,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x20,0x00,0x30,0x80,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x80,0x40,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x80,0x41,0x80,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x45 'E'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x46 'F'
+        0x00,0x00,0x00,0x00,0x7F,0x40,0x40,0x40,0x7E,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        11, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x00,0x40,0x00,0x43,0xC0,0x40,0x40,0x20,0x40,0x30,0x40,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x7F,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
+
+        6, // 0x4A 'J'
+        0x00,0x00,0x00,0x00,0x38,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0xF0,0x00,0x00,0x00,
+
+        10, // 0x4B 'K'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x42,0x00,0x44,0x00,0x48,0x00,0x50,0x00,0x68,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x4C 'L'
+        0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x00,0x00,0x00,
+
+        11, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x51,0x40,0x51,0x40,0x4A,0x40,0x4A,0x40,0x44,0x40,0x44,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x80,0x60,0x80,0x50,0x80,0x48,0x80,0x48,0x80,0x44,0x80,0x44,0x80,0x42,0x80,0x41,0x80,0x41,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x31,0x80,0x20,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x80,0x31,0x80,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x50 'P'
+        0x00,0x00,0x00,0x00,0x7C,0x42,0x41,0x41,0x42,0x7C,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        11, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x31,0x80,0x20,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x80,0x31,0x80,0x0E,0x00,0x02,0x00,0x02,0x00,0x01,0xC0,
+
+        10, // 0x52 'R'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x42,0x00,0x42,0x00,0x44,0x00,0x78,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x53 'S'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x40,0x00,0x40,0x00,0x38,0x00,0x07,0x00,0x00,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x54 'T'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x56 'V'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x80,0x40,0x40,0x80,0x40,0x80,0x21,0x00,0x21,0x00,0x21,0x00,0x12,0x00,0x12,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        15, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x04,0x41,0x04,0x22,0x88,0x22,0x88,0x22,0x88,0x14,0x50,0x14,0x50,0x14,0x50,0x08,0x20,0x08,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x58 'X'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x21,0x00,0x12,0x00,0x12,0x00,0x0C,0x00,0x0C,0x00,0x12,0x00,0x12,0x00,0x21,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x59 'Y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x5A 'Z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x5B '['
+        0x00,0x00,0x00,0x3C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3C,
+
+        6, // 0x5C '\'
+        0x00,0x00,0x00,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x10,0x08,0x08,0x08,0x04,0x00,
+
+        6, // 0x5D ']'
+        0x00,0x00,0x00,0x78,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x78,
+
+        11, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x0A,0x00,0x11,0x00,0x20,0x80,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,0x00,
+
+        9, // 0x60 '`'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x22,0x02,0x3E,0x42,0x42,0x46,0x3A,0x00,0x00,0x00,
+
+        9, // 0x62 'b'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x22,0x40,0x40,0x40,0x40,0x22,0x1C,0x00,0x00,0x00,
+
+        9, // 0x64 'd'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x24,0x42,0x7E,0x40,0x40,0x22,0x1C,0x00,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x00,0x00,0x1C,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
+
+        9, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x22,0x00,0x1C,0x00,
+
+        9, // 0x68 'h'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x00,0x00,0x00,0x10,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,
+
+        8, // 0x6B 'k'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x42,0x44,0x48,0x50,0x70,0x48,0x44,0x42,0x00,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        13, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0xE0,0x63,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x42,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x40,0x00,0x40,0x00,0x40,0x00,
+
+        9, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        8, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x40,0x30,0x0C,0x02,0x42,0x3C,0x00,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x00,0x00,0x00,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x1C,0x00,0x00,0x00,
+
+        9, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x43,0x00,0x3D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x18,0x00,0x00,0x00,
+
+        11, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x40,0x44,0x40,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x2A,0x80,0x11,0x00,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x42,0x24,0x24,0x24,0x18,0x18,0x18,0x10,0x10,0x20,
+
+        8, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x02,0x04,0x08,0x10,0x20,0x40,0x7E,0x00,0x00,0x00,
+
+        9, // 0x7B '{'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x60,0x00,0x10,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x07,0x00,
+
+        6, // 0x7C '|'
+        0x00,0x00,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
+
+        9, // 0x7D '}'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x04,0x00,0x03,0x00,0x04,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x70,0x00,
+
+        11, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x40,0x44,0x40,0x44,0x40,0x43,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana17_bold[] = 
+    {
+        17, 4, 32, 128-32,
+        0x00,0x00,0x12,0x00,0x24,0x00,0x36,0x00,0x59,0x00,0x7C,0x00,0xB0,0x00,0xD3,0x00,0xE5,0x00,
+        0xF7,0x00,0x09,0x01,0x2C,0x01,0x4F,0x01,0x61,0x01,0x73,0x01,0x85,0x01,0xA8,0x01,0xCB,0x01,
+        0xEE,0x01,0x11,0x02,0x34,0x02,0x57,0x02,0x7A,0x02,0x9D,0x02,0xC0,0x02,0xE3,0x02,0x06,0x03,
+        0x18,0x03,0x2A,0x03,0x4D,0x03,0x70,0x03,0x93,0x03,0xB6,0x03,0xD9,0x03,0xFC,0x03,0x1F,0x04,
+        0x42,0x04,0x65,0x04,0x88,0x04,0xAB,0x04,0xCE,0x04,0xF1,0x04,0x03,0x05,0x15,0x05,0x38,0x05,
+        0x5B,0x05,0x7E,0x05,0xA1,0x05,0xC4,0x05,0xE7,0x05,0x0A,0x06,0x2D,0x06,0x50,0x06,0x73,0x06,
+        0x96,0x06,0xB9,0x06,0xDC,0x06,0xFF,0x06,0x22,0x07,0x45,0x07,0x57,0x07,0x7A,0x07,0x8C,0x07,
+        0xAF,0x07,0xD2,0x07,0xF5,0x07,0x18,0x08,0x3B,0x08,0x4D,0x08,0x70,0x08,0x93,0x08,0xA5,0x08,
+        0xC8,0x08,0xEB,0x08,0xFD,0x08,0x0F,0x09,0x32,0x09,0x44,0x09,0x67,0x09,0x8A,0x09,0xAD,0x09,
+        0xD0,0x09,0xF3,0x09,0x05,0x0A,0x17,0x0A,0x29,0x0A,0x4C,0x0A,0x6F,0x0A,0x92,0x0A,0xB5,0x0A,
+        0xD8,0x0A,0xEA,0x0A,0x0D,0x0B,0x1F,0x0B,0x42,0x0B,0x65,0x0B,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        8, // 0x22 '"'
+        0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x40,0x04,0x40,0x3F,0xE0,0x3F,0xE0,0x08,0x80,0x11,0x00,0x7F,0xC0,0x7F,0xC0,0x22,0x00,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x24 '$'
+        0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x1F,0x00,0x34,0x80,0x64,0x00,0x74,0x00,0x3C,0x00,0x0F,0x00,0x0B,0x80,0x09,0x80,0x4B,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x00,0x00,
+
+        18, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x08,0x00,0x66,0x10,0x00,0x66,0x20,0x00,0x66,0x2F,0x00,0x66,0x59,0x80,0x66,0x99,0x80,0x3D,0x19,0x80,0x01,0x19,0x80,0x02,0x19,0x80,0x04,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x36,0x00,0x1C,0x60,0x36,0x60,0x63,0x60,0x61,0xC0,0x31,0xC0,0x1F,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x27 '''
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x28 '('
+        0x00,0x00,0x00,0x0C,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,0x0C,
+
+        8, // 0x29 ')'
+        0x00,0x00,0x00,0x30,0x18,0x0C,0x0C,0x06,0x06,0x06,0x06,0x06,0x06,0x0C,0x0C,0x18,0x30,
+
+        10, // 0x2A '*'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x7F,0xC0,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x60,0x60,0xC0,0xC0,0x00,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        10, // 0x2F '/'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x60,0x00,0x60,0x00,0x00,0x00,
+
+        10, // 0x30 '0'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x31 '1'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x3C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x32 '2'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x61,0x80,0x01,0x80,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x33 '3'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x61,0x80,0x01,0x80,0x0F,0x00,0x03,0x00,0x01,0x80,0x61,0x80,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x34 '4'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x07,0x00,0x0B,0x00,0x13,0x00,0x23,0x00,0x43,0x00,0x7F,0xC0,0x03,0x00,0x03,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x35 '5'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x30,0x00,0x30,0x00,0x3E,0x00,0x03,0x00,0x01,0x80,0x01,0x80,0x61,0x80,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x36 '6'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x38,0x00,0x30,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x37 '7'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x38 '8'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x39 '9'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x03,0x00,0x07,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        6, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x38,0x30,0x30,0x60,0x60,0x00,
+
+        12, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x40,0x01,0x80,0x06,0x00,0x18,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3F '?'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xC0,0x18,0x20,0x20,0x10,0x27,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x27,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
+
+        11, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x0E,0x00,0x0E,0x00,0x1B,0x00,0x1B,0x00,0x31,0x80,0x3F,0x80,0x31,0x80,0x60,0xC0,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x42 'B'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0xC0,0x30,0xC0,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x30,0xC0,0x30,0xC0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x61,0x80,0x61,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x61,0x80,0x61,0x80,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x45 'E'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x46 'F'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0xC0,0x30,0xC0,0x60,0x00,0x60,0x00,0x63,0xC0,0x60,0xC0,0x30,0xC0,0x30,0xC0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x7F,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x49 'I'
+        0x00,0x00,0x00,0x00,0x7E,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x7E,0x00,0x00,0x00,
+
+        8, // 0x4A 'J'
+        0x00,0x00,0x00,0x00,0x3E,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x0C,0xF8,0x00,0x00,0x00,
+
+        11, // 0x4B 'K'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x61,0x80,0x63,0x00,0x66,0x00,0x6C,0x00,0x7C,0x00,0x76,0x00,0x63,0x00,0x61,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x4C 'L'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x70,0x70,0x70,0x70,0xF0,0x58,0xB0,0x59,0xB0,0x4D,0x30,0x4F,0x30,0x46,0x30,0x46,0x30,0x40,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x40,0x70,0x40,0x58,0x40,0x4C,0x40,0x4C,0x40,0x46,0x40,0x43,0x40,0x43,0x40,0x41,0xC0,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x30,0xC0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0xC0,0x30,0xC0,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x50 'P'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x63,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x30,0xC0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0xC0,0x30,0xC0,0x0F,0x80,0x03,0x00,0x03,0x00,0x01,0xE0,
+
+        11, // 0x52 'R'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x63,0x00,0x61,0x80,0x60,0xC0,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x53 'S'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x61,0x80,0x60,0x00,0x3E,0x00,0x1F,0x00,0x01,0x80,0x61,0x80,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x54 'T'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x56 'V'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x31,0x80,0x31,0x80,0x1B,0x00,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        16, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x86,0x61,0x86,0x63,0xC6,0x32,0x4C,0x36,0x6C,0x36,0x6C,0x34,0x2C,0x1C,0x38,0x18,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x58 'X'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x31,0x80,0x31,0x80,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x1B,0x00,0x31,0x80,0x31,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x59 'Y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x5A 'Z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x01,0x80,0x03,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5B '['
+        0x00,0x00,0x00,0x3E,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x3E,
+
+        10, // 0x5C '\'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x30,0x00,0x30,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x01,0x80,0x01,0x80,0x00,0x00,
+
+        8, // 0x5D ']'
+        0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x7C,
+
+        12, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x0E,0x00,0x1B,0x00,0x31,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xC0,0x00,0x00,
+
+        10, // 0x60 '`'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x03,0x00,0x03,0x00,0x3F,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x62 'b'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,0x60,0x60,0x60,0x60,0x33,0x1E,0x00,0x00,0x00,
+
+        10, // 0x64 'd'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x01,0x80,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x63,0x00,0x7F,0x00,0x60,0x00,0x60,0x00,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x00,0x00,0x1C,0x30,0x30,0x7C,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        10, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x03,0x00,0x3E,0x00,
+
+        10, // 0x68 'h'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x69 'i'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        6, // 0x6A 'j'
+        0x00,0x00,0x00,0x18,0x18,0x00,0x38,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0xF0,
+
+        9, // 0x6B 'k'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x63,0x00,0x66,0x00,0x6C,0x00,0x78,0x00,0x7C,0x00,0x66,0x00,0x63,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x6C 'l'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        14, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x70,0x73,0x98,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x63,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,
+
+        10, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x01,0x80,0x01,0x80,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x7E,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        8, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x62,0x60,0x7C,0x3E,0x06,0x46,0x3C,0x00,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x00,0x00,0x00,0x60,0x60,0xFC,0x60,0x60,0x60,0x60,0x60,0x60,0x3C,0x00,0x00,0x00,
+
+        10, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x80,0x3D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x33,0x30,0x37,0xB0,0x34,0xB0,0x1C,0xE0,0x1C,0xE0,0x0C,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x36,0x00,0x63,0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x1C,0x00,0x1C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,
+
+        8, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x06,0x0C,0x18,0x18,0x30,0x60,0x7E,0x00,0x00,0x00,
+
+        10, // 0x7B '{'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x80,
+
+        8, // 0x7C '|'
+        0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
+
+        10, // 0x7D '}'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x06,0x00,0x03,0x80,0x06,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x78,0x00,
+
+        12, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x20,0x24,0x20,0x46,0x20,0x42,0x40,0x41,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana18[] = 
+    {
+        18, 4, 32, 128-32,
+        0x00,0x00,0x13,0x00,0x26,0x00,0x39,0x00,0x5E,0x00,0x83,0x00,0xA8,0x00,0xCD,0x00,0xE0,0x00,
+        0xF3,0x00,0x06,0x01,0x2B,0x01,0x50,0x01,0x63,0x01,0x76,0x01,0x89,0x01,0x9C,0x01,0xC1,0x01,
+        0xE6,0x01,0x0B,0x02,0x30,0x02,0x55,0x02,0x7A,0x02,0x9F,0x02,0xC4,0x02,0xE9,0x02,0x0E,0x03,
+        0x21,0x03,0x34,0x03,0x59,0x03,0x7E,0x03,0xA3,0x03,0xB6,0x03,0xDB,0x03,0x00,0x04,0x25,0x04,
+        0x4A,0x04,0x6F,0x04,0x94,0x04,0xB9,0x04,0xDE,0x04,0x03,0x05,0x16,0x05,0x29,0x05,0x4E,0x05,
+        0x61,0x05,0x86,0x05,0xAB,0x05,0xD0,0x05,0xF5,0x05,0x1A,0x06,0x3F,0x06,0x64,0x06,0x89,0x06,
+        0xAE,0x06,0xD3,0x06,0xF8,0x06,0x1D,0x07,0x42,0x07,0x67,0x07,0x7A,0x07,0x8D,0x07,0xA0,0x07,
+        0xC5,0x07,0xEA,0x07,0x0F,0x08,0x34,0x08,0x59,0x08,0x6C,0x08,0x91,0x08,0xB6,0x08,0xC9,0x08,
+        0xEE,0x08,0x13,0x09,0x26,0x09,0x39,0x09,0x5E,0x09,0x71,0x09,0x96,0x09,0xBB,0x09,0xE0,0x09,
+        0x05,0x0A,0x2A,0x0A,0x3D,0x0A,0x50,0x0A,0x63,0x0A,0x88,0x0A,0xAD,0x0A,0xD2,0x0A,0xF7,0x0A,
+        0x1C,0x0B,0x41,0x0B,0x66,0x0B,0x79,0x0B,0x9E,0x0B,0xC3,0x0B,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        7, // 0x22 '"'
+        0x00,0x00,0x00,0x48,0x48,0x48,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x80,0x04,0x80,0x09,0x00,0x3F,0xC0,0x09,0x00,0x11,0x00,0x12,0x00,0x7F,0x80,0x12,0x00,0x24,0x00,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x24 '$'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x3E,0x00,0x49,0x00,0x48,0x00,0x48,0x00,0x38,0x00,0x0E,0x00,0x09,0x00,0x09,0x00,0x49,0x00,0x3E,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
+
+        16, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x20,0x44,0x40,0x44,0x40,0x44,0x80,0x44,0x80,0x38,0x9C,0x01,0x22,0x01,0x22,0x02,0x22,0x02,0x22,0x04,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x1E,0x40,0x24,0x40,0x42,0x40,0x41,0x40,0x40,0x80,0x21,0x40,0x1E,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x27 '''
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x28 '('
+        0x00,0x00,0x00,0x08,0x10,0x20,0x20,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,0x08,
+
+        7, // 0x29 ')'
+        0x00,0x00,0x00,0x20,0x10,0x08,0x08,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x08,0x08,0x10,0x20,
+
+        10, // 0x2A '*'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x49,0x00,0x2A,0x00,0x1C,0x00,0x2A,0x00,0x49,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x3F,0xE0,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x40,0x40,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x00,0x00,0x00,
+
+        7, // 0x2F '/'
+        0x00,0x00,0x00,0x02,0x04,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x40,0x40,0x40,0x80,0x00,
+
+        10, // 0x30 '0'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x31 '1'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x1C,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x32 '2'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x41,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x0C,0x00,0x30,0x00,0x40,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x33 '3'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x40,0x80,0x00,0x80,0x01,0x00,0x0E,0x00,0x01,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x34 '4'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x03,0x00,0x05,0x00,0x09,0x00,0x11,0x00,0x21,0x00,0x41,0x00,0x7F,0xC0,0x01,0x00,0x01,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x35 '5'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x20,0x00,0x20,0x00,0x20,0x00,0x3E,0x00,0x01,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x36 '6'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x5E,0x00,0x61,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x37 '7'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x01,0x00,0x02,0x00,0x02,0x00,0x04,0x00,0x04,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x10,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x38 '8'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x39 '9'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x20,0x80,0x1F,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x10,0x00,0x00,0x00,0x00,0x10,0x10,0x00,0x00,0x00,
+
+        7, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x10,0x00,0x00,0x00,0x00,0x10,0x10,0x10,0x20,0x20,
+
+        12, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x3F '?'
+        0x00,0x00,0x00,0x00,0x3C,0x42,0x02,0x02,0x04,0x08,0x10,0x10,0x00,0x10,0x10,0x00,0x00,0x00,
+
+        15, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x18,0x60,0x20,0x10,0x23,0xD0,0x44,0x48,0x48,0x48,0x48,0x48,0x48,0x48,0x44,0x48,0x23,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
+
+        10, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x21,0x00,0x21,0x00,0x40,0x80,0x7F,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x42 'B'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x7E,0x00,0x41,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x41,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x20,0x40,0x30,0xC0,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x80,0x40,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x80,0x41,0x80,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x45 'E'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x46 'F'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x40,0x00,0x40,0x00,0x40,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x30,0x60,0x20,0x20,0x40,0x00,0x40,0x00,0x41,0xE0,0x40,0x20,0x40,0x20,0x20,0x20,0x30,0x20,0x0F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0xC0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x49 'I'
+        0x00,0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,
+
+        7, // 0x4A 'J'
+        0x00,0x00,0x00,0x00,0x3C,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x08,0xF0,0x00,0x00,0x00,
+
+        10, // 0x4B 'K'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x41,0x00,0x42,0x00,0x44,0x00,0x48,0x00,0x50,0x00,0x68,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x4C 'L'
+        0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x00,0x00,0x00,
+
+        13, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x50,0x50,0x50,0x50,0x48,0x90,0x48,0x90,0x45,0x10,0x45,0x10,0x42,0x10,0x42,0x10,0x40,0x10,0x40,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x60,0x40,0x50,0x40,0x48,0x40,0x48,0x40,0x44,0x40,0x42,0x40,0x42,0x40,0x41,0x40,0x40,0xC0,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x20,0x40,0x30,0xC0,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x50 'P'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x41,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x41,0x00,0x7E,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x00,0x30,0xC0,0x20,0x40,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x20,0x40,0x30,0xC0,0x0F,0x00,0x01,0x00,0x01,0x00,0x00,0xE0,
+
+        10, // 0x52 'R'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x42,0x00,0x41,0x00,0x40,0x80,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x53 'S'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x20,0x80,0x40,0x00,0x40,0x00,0x20,0x00,0x1E,0x00,0x01,0x00,0x00,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x54 'T'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x56 'V'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x80,0x40,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x21,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        15, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x04,0x41,0x04,0x22,0x88,0x22,0x88,0x22,0x88,0x12,0x90,0x14,0x50,0x14,0x50,0x14,0x50,0x08,0x20,0x08,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x58 'X'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x21,0x00,0x21,0x00,0x12,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x12,0x00,0x21,0x00,0x21,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x59 'Y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x5A 'Z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x00,0x80,0x01,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x5B '['
+        0x00,0x00,0x00,0x3C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x3C,
+
+        7, // 0x5C '\'
+        0x00,0x00,0x00,0x80,0x40,0x40,0x40,0x20,0x20,0x10,0x10,0x08,0x08,0x04,0x04,0x04,0x02,0x00,
+
+        7, // 0x5D ']'
+        0x00,0x00,0x00,0x78,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x78,
+
+        12, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x09,0x00,0x10,0x80,0x20,0x40,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xC0,0x00,0x00,
+
+        10, // 0x60 '`'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x01,0x00,0x3F,0x00,0x41,0x00,0x41,0x00,0x43,0x00,0x3D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x62 'b'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x21,0x40,0x40,0x40,0x40,0x21,0x1E,0x00,0x00,0x00,
+
+        9, // 0x64 'd'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x40,0x00,0x40,0x00,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x00,0x00,0x1C,0x20,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,
+
+        9, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x22,0x00,0x1C,0x00,
+
+        9, // 0x68 'h'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        3, // 0x69 'i'
+        0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        5, // 0x6A 'j'
+        0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,
+
+        9, // 0x6B 'k'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x42,0x00,0x44,0x00,0x48,0x00,0x50,0x00,0x68,0x00,0x44,0x00,0x42,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        3, // 0x6C 'l'
+        0x00,0x00,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        15, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2E,0x70,0x31,0x88,0x21,0x08,0x21,0x08,0x21,0x08,0x21,0x08,0x21,0x08,0x21,0x08,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5E,0x00,0x61,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x21,0x00,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x21,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x00,0x62,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x42,0x00,0x7C,0x00,0x40,0x00,0x40,0x00,0x40,0x00,
+
+        9, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x23,0x00,0x1D,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
+
+        6, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,0x60,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,
+
+        8, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x42,0x40,0x30,0x0C,0x02,0x42,0x3C,0x00,0x00,0x00,
+
+        6, // 0x74 't'
+        0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x7C,0x20,0x20,0x20,0x20,0x20,0x20,0x1C,0x00,0x00,0x00,
+
+        9, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x43,0x00,0x3D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x10,0x42,0x10,0x25,0x20,0x25,0x20,0x28,0xA0,0x28,0xA0,0x10,0x40,0x10,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x10,0x00,
+
+        9, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x02,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x20,0x00,0x40,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x7B '{'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x10,0x00,0x60,0x00,0x10,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x07,0x00,
+
+        7, // 0x7C '|'
+        0x00,0x00,0x00,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,
+
+        10, // 0x7D '}'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x02,0x00,0x01,0x80,0x02,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x38,0x00,
+
+        12, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x20,0x24,0x20,0x42,0x40,0x41,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        15, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+    const int8u verdana18_bold[] = 
+    {
+        18, 4, 32, 128-32,
+        0x00,0x00,0x13,0x00,0x26,0x00,0x4B,0x00,0x70,0x00,0x95,0x00,0xCC,0x00,0xF1,0x00,0x04,0x01,
+        0x17,0x01,0x2A,0x01,0x4F,0x01,0x74,0x01,0x87,0x01,0x9A,0x01,0xAD,0x01,0xD2,0x01,0xF7,0x01,
+        0x1C,0x02,0x41,0x02,0x66,0x02,0x8B,0x02,0xB0,0x02,0xD5,0x02,0xFA,0x02,0x1F,0x03,0x44,0x03,
+        0x57,0x03,0x6A,0x03,0x8F,0x03,0xB4,0x03,0xD9,0x03,0xFE,0x03,0x23,0x04,0x48,0x04,0x6D,0x04,
+        0x92,0x04,0xB7,0x04,0xDC,0x04,0x01,0x05,0x26,0x05,0x4B,0x05,0x5E,0x05,0x71,0x05,0x96,0x05,
+        0xBB,0x05,0xE0,0x05,0x05,0x06,0x2A,0x06,0x4F,0x06,0x74,0x06,0x99,0x06,0xBE,0x06,0xE3,0x06,
+        0x08,0x07,0x2D,0x07,0x52,0x07,0x77,0x07,0x9C,0x07,0xC1,0x07,0xD4,0x07,0xF9,0x07,0x0C,0x08,
+        0x31,0x08,0x56,0x08,0x7B,0x08,0xA0,0x08,0xC5,0x08,0xD8,0x08,0xFD,0x08,0x22,0x09,0x35,0x09,
+        0x5A,0x09,0x7F,0x09,0x92,0x09,0xA5,0x09,0xCA,0x09,0xDD,0x09,0x02,0x0A,0x27,0x0A,0x4C,0x0A,
+        0x71,0x0A,0x96,0x0A,0xA9,0x0A,0xCE,0x0A,0xE1,0x0A,0x06,0x0B,0x2B,0x0B,0x50,0x0B,0x75,0x0B,
+        0x9A,0x0B,0xBF,0x0B,0xE4,0x0B,0xF7,0x0B,0x1C,0x0C,0x41,0x0C,
+
+        5, // 0x20 ' '
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x21 '!'
+        0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x30,0x30,0x00,0x00,0x00,
+
+        9, // 0x22 '"'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x23 '#'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x20,0x04,0x20,0x08,0x40,0x3F,0xF0,0x3F,0xF0,0x08,0x40,0x10,0x80,0x7F,0xE0,0x7F,0xE0,0x21,0x00,0x21,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x24 '$'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x04,0x00,0x1F,0x80,0x34,0xC0,0x64,0xC0,0x64,0x00,0x3C,0x00,0x07,0x80,0x04,0xC0,0x64,0xC0,0x65,0x80,0x3F,0x00,0x04,0x00,0x04,0x00,0x00,0x00,
+
+        19, // 0x25 '%'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x08,0x00,0x63,0x10,0x00,0x63,0x10,0x00,0x63,0x20,0x00,0x63,0x2F,0x80,0x63,0x58,0xC0,0x3E,0x98,0xC0,0x00,0x98,0xC0,0x01,0x18,0xC0,0x01,0x18,0xC0,0x02,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x26 '&'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x33,0x00,0x1E,0x60,0x36,0x60,0x63,0x60,0x61,0xC0,0x60,0xC0,0x30,0xE0,0x1F,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x27 '''
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x28 '('
+        0x00,0x00,0x00,0x06,0x0C,0x18,0x30,0x30,0x60,0x60,0x60,0x60,0x60,0x30,0x30,0x18,0x0C,0x06,
+
+        8, // 0x29 ')'
+        0x00,0x00,0x00,0x60,0x30,0x18,0x0C,0x0C,0x06,0x06,0x06,0x06,0x06,0x0C,0x0C,0x18,0x30,0x60,
+
+        11, // 0x2A '*'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x24,0x80,0x15,0x00,0x0E,0x00,0x15,0x00,0x24,0x80,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x2B '+'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x3F,0xE0,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2C ','
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x60,0x60,0x60,0xC0,0xC0,
+
+        7, // 0x2D '-'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        5, // 0x2E '.'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        10, // 0x2F '/'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x30,0x00,0x60,0x00,0x60,0x00,0x00,0x00,
+
+        11, // 0x30 '0'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x31 '1'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x1E,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x32 '2'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x60,0xC0,0x00,0xC0,0x01,0x80,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x7F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x33 '3'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x61,0x80,0x60,0xC0,0x00,0xC0,0x01,0x80,0x0F,0x00,0x01,0x80,0x00,0xC0,0x60,0xC0,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x34 '4'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x03,0x80,0x05,0x80,0x09,0x80,0x11,0x80,0x21,0x80,0x41,0x80,0x7F,0xE0,0x01,0x80,0x01,0x80,0x01,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x35 '5'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xC0,0x30,0x00,0x30,0x00,0x30,0x00,0x3F,0x00,0x01,0x80,0x00,0xC0,0x00,0xC0,0x60,0xC0,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x36 '6'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x18,0x00,0x30,0x00,0x60,0x00,0x6F,0x00,0x71,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x37 '7'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xC0,0x00,0xC0,0x01,0x80,0x01,0x80,0x03,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x38 '8'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x39 '9'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x31,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0xC0,0x1E,0xC0,0x00,0xC0,0x01,0x80,0x03,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x3A ':'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        6, // 0x3B ';'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x00,0x00,0x38,0x30,0x30,0x30,0x60,0x60,
+
+        13, // 0x3C '<'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0xC0,0x03,0x00,0x0C,0x00,0x30,0x00,0x30,0x00,0x0C,0x00,0x03,0x00,0x00,0xC0,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x3D '='
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x3E '>'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x18,0x00,0x06,0x00,0x01,0x80,0x00,0x60,0x00,0x60,0x01,0x80,0x06,0x00,0x18,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        9, // 0x3F '?'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x63,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x40 '@'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x18,0x60,0x20,0x10,0x27,0xD0,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x4C,0xC8,0x27,0xF0,0x20,0x00,0x18,0x00,0x07,0xC0,0x00,0x00,
+
+        12, // 0x41 'A'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x0F,0x00,0x0F,0x00,0x19,0x80,0x19,0x80,0x30,0xC0,0x3F,0xC0,0x30,0xC0,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x42 'B'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x43 'C'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x38,0xC0,0x30,0xC0,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x30,0xC0,0x38,0xC0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x44 'D'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0xC0,0x60,0xC0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0xC0,0x61,0xC0,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x45 'E'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x46 'F'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x47 'G'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x38,0x60,0x30,0x60,0x60,0x00,0x60,0x00,0x63,0xE0,0x60,0x60,0x60,0x60,0x30,0x60,0x38,0x60,0x0F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x48 'H'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7F,0xE0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x49 'I'
+        0x00,0x00,0x00,0x00,0x7E,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x7E,0x00,0x00,0x00,
+
+        8, // 0x4A 'J'
+        0x00,0x00,0x00,0x00,0x3E,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x0C,0xF8,0x00,0x00,0x00,
+
+        12, // 0x4B 'K'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0xC0,0x61,0x80,0x63,0x00,0x66,0x00,0x6C,0x00,0x7E,0x00,0x73,0x00,0x61,0x80,0x60,0xC0,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x4C 'L'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x4D 'M'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x38,0x70,0x38,0x70,0x78,0x58,0x58,0x58,0xD8,0x4C,0x98,0x4D,0x98,0x47,0x18,0x47,0x18,0x42,0x18,0x40,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x4E 'N'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x20,0x70,0x20,0x58,0x20,0x4C,0x20,0x4C,0x20,0x46,0x20,0x43,0x20,0x43,0x20,0x41,0xA0,0x40,0xE0,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x4F 'O'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x38,0xE0,0x30,0x60,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x30,0x60,0x38,0xE0,0x0F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x50 'P'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        13, // 0x51 'Q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x38,0xE0,0x30,0x60,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x60,0x30,0x30,0x60,0x38,0xE0,0x0F,0x80,0x03,0x00,0x03,0x80,0x01,0xF0,
+
+        12, // 0x52 'R'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x61,0x80,0x7F,0x00,0x61,0x80,0x60,0xC0,0x60,0x60,0x60,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x53 'S'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x30,0xC0,0x60,0xC0,0x60,0x00,0x7C,0x00,0x3F,0x80,0x03,0xC0,0x00,0xC0,0x60,0xC0,0x61,0x80,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x54 'T'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        12, // 0x55 'U'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x30,0xC0,0x1F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x56 'V'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x60,0xC0,0x60,0xC0,0x31,0x80,0x31,0x80,0x31,0x80,0x1B,0x00,0x1B,0x00,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        16, // 0x57 'W'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x86,0x61,0x86,0x63,0xC6,0x33,0xCC,0x32,0x4C,0x32,0x4C,0x1E,0x78,0x1C,0x38,0x1C,0x38,0x0C,0x30,0x0C,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x58 'X'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xC0,0x31,0x80,0x31,0x80,0x1B,0x00,0x0E,0x00,0x0E,0x00,0x0E,0x00,0x1B,0x00,0x31,0x80,0x31,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x59 'Y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x5A 'Z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x80,0x01,0x80,0x03,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x30,0x00,0x60,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x5B '['
+        0x00,0x00,0x00,0x3E,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x3E,
+
+        10, // 0x5C '\'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x30,0x00,0x30,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x01,0x80,0x01,0x80,0x00,0x00,
+
+        8, // 0x5D ']'
+        0x00,0x00,0x00,0x7C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x7C,
+
+        13, // 0x5E '^'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0F,0x00,0x19,0x80,0x30,0xC0,0x60,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x5F '_'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xE0,0x00,0x00,
+
+        11, // 0x60 '`'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x61 'a'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x01,0x80,0x01,0x80,0x3F,0x80,0x61,0x80,0x61,0x80,0x63,0x80,0x3D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x62 'b'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        8, // 0x63 'c'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x33,0x60,0x60,0x60,0x60,0x33,0x1E,0x00,0x00,0x00,
+
+        10, // 0x64 'd'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x01,0x80,0x01,0x80,0x01,0x80,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x65 'e'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x7F,0x80,0x60,0x00,0x60,0x00,0x31,0x80,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        6, // 0x66 'f'
+        0x00,0x00,0x00,0x1C,0x30,0x30,0x30,0x7C,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,
+
+        10, // 0x67 'g'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x03,0x00,0x3E,0x00,
+
+        10, // 0x68 'h'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x69 'i'
+        0x00,0x00,0x00,0x60,0x60,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        6, // 0x6A 'j'
+        0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x78,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0xF0,
+
+        10, // 0x6B 'k'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x61,0x80,0x63,0x00,0x66,0x00,0x6C,0x00,0x7E,0x00,0x73,0x00,0x61,0x80,0x60,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        4, // 0x6C 'l'
+        0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        16, // 0x6D 'm'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0x3C,0x71,0xC6,0x61,0x86,0x61,0x86,0x61,0x86,0x61,0x86,0x61,0x86,0x61,0x86,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x6E 'n'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0x00,0x71,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x6F 'o'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x33,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x70 'p'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x00,0x73,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x00,0x7E,0x00,0x60,0x00,0x60,0x00,0x60,0x00,
+
+        10, // 0x71 'q'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x33,0x80,0x1D,0x80,0x01,0x80,0x01,0x80,0x01,0x80,
+
+        7, // 0x72 'r'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6E,0x7E,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,
+
+        9, // 0x73 's'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x61,0x00,0x60,0x00,0x7E,0x00,0x3F,0x00,0x03,0x00,0x43,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        7, // 0x74 't'
+        0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x7E,0x30,0x30,0x30,0x30,0x30,0x30,0x1E,0x00,0x00,0x00,
+
+        10, // 0x75 'u'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x61,0x80,0x63,0x80,0x3D,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x76 'v'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        14, // 0x77 'w'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0x18,0x63,0x18,0x63,0x18,0x37,0xB0,0x34,0xB0,0x3C,0xF0,0x18,0x60,0x18,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x78 'x'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x33,0x00,0x33,0x00,0x61,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        10, // 0x79 'y'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0x80,0x61,0x80,0x33,0x00,0x33,0x00,0x33,0x00,0x1E,0x00,0x1E,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,
+
+        9, // 0x7A 'z'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x60,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        11, // 0x7B '{'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x70,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x07,0x80,
+
+        8, // 0x7C '|'
+        0x00,0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,
+
+        11, // 0x7D '}'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x01,0xC0,0x03,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x3C,0x00,
+
+        13, // 0x7E '~'
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x10,0x24,0x10,0x42,0x10,0x41,0x20,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        15, // 0x7F ''
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x20,0x08,0x3F,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,
+
+        0
+    };
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_font_freetype.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_font_freetype.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_font_freetype.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_font_freetype.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1164 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+
+#include <stdio.h>
+#include "../include/agg_font_freetype.h"
+#include "../include/agg_bitset_iterator.h"
+#include "../include/agg_renderer_scanline.h"
+
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------------
+    //
+    // This code implements the AUTODIN II polynomial
+    // The variable corresponding to the macro argument "crc" should
+    // be an unsigned long.
+    // Oroginal code  by Spencer Garrett <srg@quick.com>
+    //
+
+    // generated using the AUTODIN II polynomial
+    //   x^32 + x^26 + x^23 + x^22 + x^16 +
+    //   x^12 + x^11 + x^10 + x^8 + x^7 + x^5 + x^4 + x^2 + x^1 + 1
+    //
+    //------------------------------------------------------------------------------
+
+    static const unsigned crc32tab[256] = 
+    {
+       0x00000000, 0x77073096, 0xee0e612c, 0x990951ba,
+       0x076dc419, 0x706af48f, 0xe963a535, 0x9e6495a3,
+       0x0edb8832, 0x79dcb8a4, 0xe0d5e91e, 0x97d2d988,
+       0x09b64c2b, 0x7eb17cbd, 0xe7b82d07, 0x90bf1d91,
+       0x1db71064, 0x6ab020f2, 0xf3b97148, 0x84be41de,
+       0x1adad47d, 0x6ddde4eb, 0xf4d4b551, 0x83d385c7,
+       0x136c9856, 0x646ba8c0, 0xfd62f97a, 0x8a65c9ec,
+       0x14015c4f, 0x63066cd9, 0xfa0f3d63, 0x8d080df5,
+       0x3b6e20c8, 0x4c69105e, 0xd56041e4, 0xa2677172,
+       0x3c03e4d1, 0x4b04d447, 0xd20d85fd, 0xa50ab56b,
+       0x35b5a8fa, 0x42b2986c, 0xdbbbc9d6, 0xacbcf940,
+       0x32d86ce3, 0x45df5c75, 0xdcd60dcf, 0xabd13d59,
+       0x26d930ac, 0x51de003a, 0xc8d75180, 0xbfd06116,
+       0x21b4f4b5, 0x56b3c423, 0xcfba9599, 0xb8bda50f,
+       0x2802b89e, 0x5f058808, 0xc60cd9b2, 0xb10be924,
+       0x2f6f7c87, 0x58684c11, 0xc1611dab, 0xb6662d3d,
+       0x76dc4190, 0x01db7106, 0x98d220bc, 0xefd5102a,
+       0x71b18589, 0x06b6b51f, 0x9fbfe4a5, 0xe8b8d433,
+       0x7807c9a2, 0x0f00f934, 0x9609a88e, 0xe10e9818,
+       0x7f6a0dbb, 0x086d3d2d, 0x91646c97, 0xe6635c01,
+       0x6b6b51f4, 0x1c6c6162, 0x856530d8, 0xf262004e,
+       0x6c0695ed, 0x1b01a57b, 0x8208f4c1, 0xf50fc457,
+       0x65b0d9c6, 0x12b7e950, 0x8bbeb8ea, 0xfcb9887c,
+       0x62dd1ddf, 0x15da2d49, 0x8cd37cf3, 0xfbd44c65,
+       0x4db26158, 0x3ab551ce, 0xa3bc0074, 0xd4bb30e2,
+       0x4adfa541, 0x3dd895d7, 0xa4d1c46d, 0xd3d6f4fb,
+       0x4369e96a, 0x346ed9fc, 0xad678846, 0xda60b8d0,
+       0x44042d73, 0x33031de5, 0xaa0a4c5f, 0xdd0d7cc9,
+       0x5005713c, 0x270241aa, 0xbe0b1010, 0xc90c2086,
+       0x5768b525, 0x206f85b3, 0xb966d409, 0xce61e49f,
+       0x5edef90e, 0x29d9c998, 0xb0d09822, 0xc7d7a8b4,
+       0x59b33d17, 0x2eb40d81, 0xb7bd5c3b, 0xc0ba6cad,
+       0xedb88320, 0x9abfb3b6, 0x03b6e20c, 0x74b1d29a,
+       0xead54739, 0x9dd277af, 0x04db2615, 0x73dc1683,
+       0xe3630b12, 0x94643b84, 0x0d6d6a3e, 0x7a6a5aa8,
+       0xe40ecf0b, 0x9309ff9d, 0x0a00ae27, 0x7d079eb1,
+       0xf00f9344, 0x8708a3d2, 0x1e01f268, 0x6906c2fe,
+       0xf762575d, 0x806567cb, 0x196c3671, 0x6e6b06e7,
+       0xfed41b76, 0x89d32be0, 0x10da7a5a, 0x67dd4acc,
+       0xf9b9df6f, 0x8ebeeff9, 0x17b7be43, 0x60b08ed5,
+       0xd6d6a3e8, 0xa1d1937e, 0x38d8c2c4, 0x4fdff252,
+       0xd1bb67f1, 0xa6bc5767, 0x3fb506dd, 0x48b2364b,
+       0xd80d2bda, 0xaf0a1b4c, 0x36034af6, 0x41047a60,
+       0xdf60efc3, 0xa867df55, 0x316e8eef, 0x4669be79,
+       0xcb61b38c, 0xbc66831a, 0x256fd2a0, 0x5268e236,
+       0xcc0c7795, 0xbb0b4703, 0x220216b9, 0x5505262f,
+       0xc5ba3bbe, 0xb2bd0b28, 0x2bb45a92, 0x5cb36a04,
+       0xc2d7ffa7, 0xb5d0cf31, 0x2cd99e8b, 0x5bdeae1d,
+       0x9b64c2b0, 0xec63f226, 0x756aa39c, 0x026d930a,
+       0x9c0906a9, 0xeb0e363f, 0x72076785, 0x05005713,
+       0x95bf4a82, 0xe2b87a14, 0x7bb12bae, 0x0cb61b38,
+       0x92d28e9b, 0xe5d5be0d, 0x7cdcefb7, 0x0bdbdf21,
+       0x86d3d2d4, 0xf1d4e242, 0x68ddb3f8, 0x1fda836e,
+       0x81be16cd, 0xf6b9265b, 0x6fb077e1, 0x18b74777,
+       0x88085ae6, 0xff0f6a70, 0x66063bca, 0x11010b5c,
+       0x8f659eff, 0xf862ae69, 0x616bffd3, 0x166ccf45,
+       0xa00ae278, 0xd70dd2ee, 0x4e048354, 0x3903b3c2,
+       0xa7672661, 0xd06016f7, 0x4969474d, 0x3e6e77db,
+       0xaed16a4a, 0xd9d65adc, 0x40df0b66, 0x37d83bf0,
+       0xa9bcae53, 0xdebb9ec5, 0x47b2cf7f, 0x30b5ffe9,
+       0xbdbdf21c, 0xcabac28a, 0x53b39330, 0x24b4a3a6,
+       0xbad03605, 0xcdd70693, 0x54de5729, 0x23d967bf,
+       0xb3667a2e, 0xc4614ab8, 0x5d681b02, 0x2a6f2b94,
+       0xb40bbe37, 0xc30c8ea1, 0x5a05df1b, 0x2d02ef8d,
+    };
+
+
+    //------------------------------------------------------------------------------
+
+    static unsigned calc_crc32(const unsigned char* buf, unsigned size)
+    {
+        unsigned crc = (unsigned)~0;
+        const unsigned char* p;
+        unsigned len = 0; 
+        unsigned nr = size;
+
+        for (len += nr, p = buf; nr--; ++p) 
+        {
+            crc = (crc >> 8) ^ crc32tab[(crc ^ *p) & 0xff];
+        }
+        return ~crc;
+    }
+
+    //------------------------------------------------------------------------
+    static inline int dbl_to_plain_fx(double d)
+    {
+        return int(d * 65536.0);
+    }
+
+    //------------------------------------------------------------------------
+    static inline double int26p6_to_dbl(int p)
+    {
+        return double(p) / 64.0;
+    }
+
+    //------------------------------------------------------------------------
+    static inline int dbl_to_int26p6(double p)
+    {
+        return int(p * 64.0 + 0.5);
+    }
+
+
+    //------------------------------------------------------------------------
+    template<class PathStorage>
+    bool decompose_ft_outline(const FT_Outline& outline,
+                              bool flip_y,
+                              const trans_affine& mtx,
+                              PathStorage& path)
+    {   
+        typedef typename PathStorage::value_type value_type;
+
+        double x1, y1, x2, y2, x3, y3;
+
+        FT_Vector*  point;
+        FT_Vector*  limit;
+        char*       tags;
+
+        int   n;         // index of contour in outline
+        int   first;     // index of first point in contour
+        char  tag;       // current point's state
+
+        first = 0;
+
+        for(n = 0; n < outline.n_contours; n++)
+        {
+            int  last;  // index of last point in contour
+
+            last  = outline.contours[n];
+            limit = outline.points + last;
+
+            FT_Vector v_start = outline.points[first];
+
+            FT_Vector v_control = v_start;
+
+            point = outline.points + first;
+            tags  = outline.tags  + first;
+            tag   = FT_CURVE_TAG(tags[0]);
+
+            // A contour cannot start with a cubic control point!
+            if(tag == FT_CURVE_TAG_CUBIC) return false;
+
+            // check first point to determine origin
+            if( tag == FT_CURVE_TAG_CONIC)
+            {
+                const FT_Vector v_last  = outline.points[last];
+
+                // first point is conic control.  Yes, this happens.
+                if(FT_CURVE_TAG(outline.tags[last]) == FT_CURVE_TAG_ON)
+                {
+                    // start at last point if it is on the curve
+                    v_start = v_last;
+                    limit--;
+                }
+                else
+                {
+                    // if both first and last points are conic,
+                    // start at their middle and record its position
+                    // for closure
+                    v_start.x = (v_start.x + v_last.x) / 2;
+                    v_start.y = (v_start.y + v_last.y) / 2;
+                }
+                point--;
+                tags--;
+            }
+
+            x1 = int26p6_to_dbl(v_start.x);
+            y1 = int26p6_to_dbl(v_start.y);
+            if(flip_y) y1 = -y1;
+            mtx.transform(&x1, &y1);
+            path.move_to(value_type(dbl_to_int26p6(x1)), 
+                         value_type(dbl_to_int26p6(y1)));
+
+            while(point < limit)
+            {
+                point++;
+                tags++;
+
+                tag = FT_CURVE_TAG(tags[0]);
+                switch(tag)
+                {
+                    case FT_CURVE_TAG_ON:  // emit a single line_to
+                    {
+                        x1 = int26p6_to_dbl(point->x);
+                        y1 = int26p6_to_dbl(point->y);
+                        if(flip_y) y1 = -y1;
+                        mtx.transform(&x1, &y1);
+                        path.line_to(value_type(dbl_to_int26p6(x1)), 
+                                     value_type(dbl_to_int26p6(y1)));
+                        //path.line_to(conv(point->x), flip_y ? -conv(point->y) : conv(point->y));
+                        continue;
+                    }
+
+                    case FT_CURVE_TAG_CONIC:  // consume conic arcs
+                    {
+                        v_control.x = point->x;
+                        v_control.y = point->y;
+
+                    Do_Conic:
+                        if(point < limit)
+                        {
+                            FT_Vector vec;
+                            FT_Vector v_middle;
+
+                            point++;
+                            tags++;
+                            tag = FT_CURVE_TAG(tags[0]);
+
+                            vec.x = point->x;
+                            vec.y = point->y;
+
+                            if(tag == FT_CURVE_TAG_ON)
+                            {
+                                x1 = int26p6_to_dbl(v_control.x);
+                                y1 = int26p6_to_dbl(v_control.y);
+                                x2 = int26p6_to_dbl(vec.x);
+                                y2 = int26p6_to_dbl(vec.y);
+                                if(flip_y) { y1 = -y1; y2 = -y2; }
+                                mtx.transform(&x1, &y1);
+                                mtx.transform(&x2, &y2);
+                                path.curve3(value_type(dbl_to_int26p6(x1)), 
+                                            value_type(dbl_to_int26p6(y1)),
+                                            value_type(dbl_to_int26p6(x2)), 
+                                            value_type(dbl_to_int26p6(y2)));
+                                continue;
+                            }
+
+                            if(tag != FT_CURVE_TAG_CONIC) return false;
+
+                            v_middle.x = (v_control.x + vec.x) / 2;
+                            v_middle.y = (v_control.y + vec.y) / 2;
+
+                            x1 = int26p6_to_dbl(v_control.x);
+                            y1 = int26p6_to_dbl(v_control.y);
+                            x2 = int26p6_to_dbl(v_middle.x);
+                            y2 = int26p6_to_dbl(v_middle.y);
+                            if(flip_y) { y1 = -y1; y2 = -y2; }
+                            mtx.transform(&x1, &y1);
+                            mtx.transform(&x2, &y2);
+                            path.curve3(value_type(dbl_to_int26p6(x1)), 
+                                        value_type(dbl_to_int26p6(y1)),
+                                        value_type(dbl_to_int26p6(x2)), 
+                                        value_type(dbl_to_int26p6(y2)));
+
+                            //path.curve3(conv(v_control.x), 
+                            //            flip_y ? -conv(v_control.y) : conv(v_control.y), 
+                            //            conv(v_middle.x), 
+                            //            flip_y ? -conv(v_middle.y) : conv(v_middle.y));
+
+                            v_control = vec;
+                            goto Do_Conic;
+                        }
+
+                        x1 = int26p6_to_dbl(v_control.x);
+                        y1 = int26p6_to_dbl(v_control.y);
+                        x2 = int26p6_to_dbl(v_start.x);
+                        y2 = int26p6_to_dbl(v_start.y);
+                        if(flip_y) { y1 = -y1; y2 = -y2; }
+                        mtx.transform(&x1, &y1);
+                        mtx.transform(&x2, &y2);
+                        path.curve3(value_type(dbl_to_int26p6(x1)), 
+                                    value_type(dbl_to_int26p6(y1)),
+                                    value_type(dbl_to_int26p6(x2)), 
+                                    value_type(dbl_to_int26p6(y2)));
+
+                        //path.curve3(conv(v_control.x), 
+                        //            flip_y ? -conv(v_control.y) : conv(v_control.y), 
+                        //            conv(v_start.x), 
+                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
+                        goto Close;
+                    }
+
+                    default:  // FT_CURVE_TAG_CUBIC
+                    {
+                        FT_Vector vec1, vec2;
+
+                        if(point + 1 > limit || FT_CURVE_TAG(tags[1]) != FT_CURVE_TAG_CUBIC)
+                        {
+                            return false;
+                        }
+
+                        vec1.x = point[0].x; 
+                        vec1.y = point[0].y;
+                        vec2.x = point[1].x; 
+                        vec2.y = point[1].y;
+
+                        point += 2;
+                        tags  += 2;
+
+                        if(point <= limit)
+                        {
+                            FT_Vector vec;
+
+                            vec.x = point->x;
+                            vec.y = point->y;
+
+                            x1 = int26p6_to_dbl(vec1.x);
+                            y1 = int26p6_to_dbl(vec1.y);
+                            x2 = int26p6_to_dbl(vec2.x);
+                            y2 = int26p6_to_dbl(vec2.y);
+                            x3 = int26p6_to_dbl(vec.x);
+                            y3 = int26p6_to_dbl(vec.y);
+                            if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
+                            mtx.transform(&x1, &y1);
+                            mtx.transform(&x2, &y2);
+                            mtx.transform(&x3, &y3);
+                            path.curve4(value_type(dbl_to_int26p6(x1)), 
+                                        value_type(dbl_to_int26p6(y1)),
+                                        value_type(dbl_to_int26p6(x2)), 
+                                        value_type(dbl_to_int26p6(y2)),
+                                        value_type(dbl_to_int26p6(x3)), 
+                                        value_type(dbl_to_int26p6(y3)));
+
+                            //path.curve4(conv(vec1.x), 
+                            //            flip_y ? -conv(vec1.y) : conv(vec1.y), 
+                            //            conv(vec2.x), 
+                            //            flip_y ? -conv(vec2.y) : conv(vec2.y),
+                            //            conv(vec.x), 
+                            //            flip_y ? -conv(vec.y) : conv(vec.y));
+                            continue;
+                        }
+
+                        x1 = int26p6_to_dbl(vec1.x);
+                        y1 = int26p6_to_dbl(vec1.y);
+                        x2 = int26p6_to_dbl(vec2.x);
+                        y2 = int26p6_to_dbl(vec2.y);
+                        x3 = int26p6_to_dbl(v_start.x);
+                        y3 = int26p6_to_dbl(v_start.y);
+                        if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
+                        mtx.transform(&x1, &y1);
+                        mtx.transform(&x2, &y2);
+                        mtx.transform(&x3, &y3);
+                        path.curve4(value_type(dbl_to_int26p6(x1)), 
+                                    value_type(dbl_to_int26p6(y1)),
+                                    value_type(dbl_to_int26p6(x2)), 
+                                    value_type(dbl_to_int26p6(y2)),
+                                    value_type(dbl_to_int26p6(x3)), 
+                                    value_type(dbl_to_int26p6(y3)));
+
+                        //path.curve4(conv(vec1.x), 
+                        //            flip_y ? -conv(vec1.y) : conv(vec1.y), 
+                        //            conv(vec2.x), 
+                        //            flip_y ? -conv(vec2.y) : conv(vec2.y),
+                        //            conv(v_start.x), 
+                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
+                        goto Close;
+                    }
+                }
+            }
+
+            path.close_polygon();
+
+       Close:
+            first = last + 1; 
+        }
+
+        return true;
+    }
+
+
+
+    //------------------------------------------------------------------------
+    template<class Scanline, class ScanlineStorage>
+    void decompose_ft_bitmap_mono(const FT_Bitmap& bitmap,
+                                  int x, int y,
+                                  bool flip_y,
+                                  Scanline& sl,
+                                  ScanlineStorage& storage)
+    {
+        unsigned int i;
+        const int8u* buf = (const int8u*)bitmap.buffer;
+        int pitch = bitmap.pitch;
+        sl.reset(x, x + bitmap.width);
+        storage.prepare();
+        if(flip_y)
+        {
+            buf += bitmap.pitch * (bitmap.rows - 1);
+            y += bitmap.rows;
+            pitch = -pitch;
+        }
+        for(i = 0; i < (unsigned int)bitmap.rows; i++)
+        {
+            sl.reset_spans();
+            bitset_iterator bits(buf, 0);
+            unsigned int j;
+            for(j = 0; j < (unsigned int)bitmap.width; j++)
+            {
+                if(bits.bit()) sl.add_cell(x + j, cover_full);
+                ++bits;
+            }
+            buf += pitch;
+            if(sl.num_spans())
+            {
+                sl.finalize(y - i - 1);
+                storage.render(sl);
+            }
+        }
+    }
+
+
+
+    //------------------------------------------------------------------------
+    template<class Rasterizer, class Scanline, class ScanlineStorage>
+    void decompose_ft_bitmap_gray8(const FT_Bitmap& bitmap,
+                                   int x, int y,
+                                   bool flip_y,
+                                   Rasterizer& ras,
+                                   Scanline& sl,
+                                   ScanlineStorage& storage)
+    {
+        unsigned int i, j;
+        const int8u* buf = (const int8u*)bitmap.buffer;
+        int pitch = bitmap.pitch;
+        sl.reset(x, x + bitmap.width);
+        storage.prepare();
+        if(flip_y)
+        {
+            buf += bitmap.pitch * (bitmap.rows - 1);
+            y += bitmap.rows;
+            pitch = -pitch;
+        }
+        for(i = 0; i < (unsigned int)bitmap.rows; i++)
+        {
+            sl.reset_spans();
+            const int8u* p = buf;
+            for(j = 0; j < (unsigned int)bitmap.width; j++)
+            {
+                if(*p) sl.add_cell(x + j, ras.apply_gamma(*p));
+                ++p;
+            }
+            buf += pitch;
+            if(sl.num_spans())
+            {
+                sl.finalize(y - i - 1);
+                storage.render(sl);
+            }
+        }
+    }
+
+
+
+
+
+
+
+
+
+
+
+
+
+    //------------------------------------------------------------------------
+    font_engine_freetype_base::~font_engine_freetype_base()
+    {
+        unsigned i;
+        for(i = 0; i < m_num_faces; ++i)
+        {
+            delete [] m_face_names[i];
+            FT_Done_Face(m_faces[i]);
+        }
+        delete [] m_face_names;
+        delete [] m_faces;
+        delete [] m_signature;
+        if(m_library_initialized) FT_Done_FreeType(m_library);
+    }
+
+
+    //------------------------------------------------------------------------
+    font_engine_freetype_base::font_engine_freetype_base(bool flag32, 
+                                                         unsigned max_faces) :
+        m_flag32(flag32),
+        m_change_stamp(0),
+        m_last_error(0),
+        m_name(0),
+        m_name_len(256-16-1),
+        m_face_index(0),
+        m_char_map(FT_ENCODING_NONE),
+        m_signature(new char [256+256-16]),
+        m_height(0),
+        m_width(0),
+        m_hinting(true),
+        m_flip_y(false),
+        m_library_initialized(false),
+        m_library(0),
+        m_faces(new FT_Face [max_faces]),
+        m_face_names(new char* [max_faces]),
+        m_num_faces(0),
+        m_max_faces(max_faces),
+        m_cur_face(0),
+        m_resolution(0),
+        m_glyph_rendering(glyph_ren_native_gray8),
+        m_glyph_index(0),
+        m_data_size(0),
+        m_data_type(glyph_data_invalid),
+        m_bounds(1,1,0,0),
+        m_advance_x(0.0),
+        m_advance_y(0.0),
+
+        m_path16(),
+        m_path32(),
+        m_curves16(m_path16),
+        m_curves32(m_path32),
+        m_scanline_aa(),
+        m_scanline_bin(),
+        m_scanlines_aa(),
+        m_scanlines_bin(),
+        m_rasterizer()
+    {
+        m_curves16.approximation_scale(4.0);
+        m_curves32.approximation_scale(4.0);
+        m_last_error = FT_Init_FreeType(&m_library);
+        if(m_last_error == 0) m_library_initialized = true;
+    }
+
+
+
+    //------------------------------------------------------------------------
+    void font_engine_freetype_base::resolution(unsigned dpi) 
+    { 
+        m_resolution = dpi;
+        update_char_size();
+    }
+
+
+    //------------------------------------------------------------------------
+    int font_engine_freetype_base::find_face(const char* face_name) const
+    {
+        unsigned i;
+        for(i = 0; i < m_num_faces; ++i)
+        {
+            if(strcmp(face_name, m_face_names[i]) == 0) return i;
+        }
+        return -1;
+    }
+
+
+    //------------------------------------------------------------------------
+    double font_engine_freetype_base::ascender() const
+    {
+        if(m_cur_face)
+        {
+            return m_cur_face->ascender * height() / m_cur_face->height;
+        }
+        return 0.0;
+    }
+
+    //------------------------------------------------------------------------
+    double font_engine_freetype_base::descender() const
+    {
+        if(m_cur_face)
+        {
+            return m_cur_face->descender * height() / m_cur_face->height;
+        }
+        return 0.0;
+    }
+
+
+    //------------------------------------------------------------------------
+    bool font_engine_freetype_base::load_font(const char* font_name, 
+                                              unsigned face_index,
+                                              glyph_rendering ren_type,
+                                              const char* font_mem, 
+                                              const long font_mem_size)
+    {
+        bool ret = false;
+
+        if(m_library_initialized)
+        {
+            m_last_error = 0;
+
+            int idx = find_face(font_name);
+            if(idx >= 0)
+            {
+                m_cur_face = m_faces[idx];
+                m_name     = m_face_names[idx];
+            }
+            else
+            {
+                if(m_num_faces >= m_max_faces)
+                {
+                    delete [] m_face_names[0];
+                    FT_Done_Face(m_faces[0]);
+                    memmove(m_faces, 
+                           m_faces + 1, 
+                           (m_max_faces - 1) * sizeof(FT_Face));
+                    memmove(m_face_names, 
+                           m_face_names + 1, 
+                           (m_max_faces - 1) * sizeof(char*));
+                    m_num_faces = m_max_faces - 1;
+                }
+
+                if (font_mem && font_mem_size)
+                {
+                    m_last_error = FT_New_Memory_Face(m_library, 
+                                                      (const FT_Byte*)font_mem, 
+                                                      font_mem_size, 
+                                                      face_index, 
+                                                      &m_faces[m_num_faces]);
+                }
+                else
+                {
+                    m_last_error = FT_New_Face(m_library,
+                                               font_name,
+                                               face_index,
+                                               &m_faces[m_num_faces]);
+                }
+
+                if(m_last_error == 0)
+                {
+                    m_face_names[m_num_faces] = new char [strlen(font_name) + 1];
+                    strcpy(m_face_names[m_num_faces], font_name);
+                    m_cur_face = m_faces[m_num_faces];
+                    m_name     = m_face_names[m_num_faces];
+                    ++m_num_faces;
+                }
+                else
+                {
+                    m_face_names[m_num_faces] = 0;
+                    m_cur_face = 0;
+                    m_name = 0;
+                }
+                if( FT_Select_Charmap(m_cur_face, FT_ENCODING_UNICODE) ) {
+                    if( FT_Select_Charmap(m_cur_face, FT_ENCODING_MS_SYMBOL) ) {
+                        if( FT_Select_Charmap(m_cur_face, FT_ENCODING_APPLE_ROMAN) ) {
+                            m_char_map = FT_ENCODING_NONE;
+                        } else {
+                            m_char_map = FT_ENCODING_APPLE_ROMAN;
+                        }
+                    } else {
+                        m_char_map = FT_ENCODING_MS_SYMBOL;
+                    }
+                } else {
+                    m_char_map = FT_ENCODING_UNICODE;
+                }   
+            }
+
+
+            if(m_last_error == 0)
+            {
+                ret = true;
+                
+                switch(ren_type)
+                {
+                case glyph_ren_native_mono:
+                    m_glyph_rendering = glyph_ren_native_mono;
+                    break;
+
+                case glyph_ren_native_gray8:
+                    m_glyph_rendering = glyph_ren_native_gray8;
+                    break;
+
+                case glyph_ren_outline:
+                    if(FT_IS_SCALABLE(m_cur_face))
+                    {
+                        m_glyph_rendering = glyph_ren_outline;
+                    }
+                    else
+                    {
+                        m_glyph_rendering = glyph_ren_native_gray8;
+                    }
+                    break;
+
+                case glyph_ren_agg_mono:
+                    if(FT_IS_SCALABLE(m_cur_face))
+                    {
+                        m_glyph_rendering = glyph_ren_agg_mono;
+                    }
+                    else
+                    {
+                        m_glyph_rendering = glyph_ren_native_mono;
+                    }
+                    break;
+
+                case glyph_ren_agg_gray8:
+                    if(FT_IS_SCALABLE(m_cur_face))
+                    {
+                        m_glyph_rendering = glyph_ren_agg_gray8;
+                    }
+                    else
+                    {
+                        m_glyph_rendering = glyph_ren_native_gray8;
+                    }
+                    break;
+                }
+                update_signature();
+            }
+        }
+        return ret;
+    }
+
+
+    //------------------------------------------------------------------------
+    bool font_engine_freetype_base::attach(const char* file_name)
+    {
+        if(m_cur_face)
+        {
+            m_last_error = FT_Attach_File(m_cur_face, file_name);
+            return m_last_error == 0;
+        }
+        return false;
+    }
+
+    //------------------------------------------------------------------------
+    unsigned font_engine_freetype_base::num_faces() const
+    {
+        if(m_cur_face)
+        {
+            return m_cur_face->num_faces;
+        }
+        return 0;
+    }
+
+    //------------------------------------------------------------------------
+    bool font_engine_freetype_base::char_map(FT_Encoding /*char_map*/)
+    {
+        if(m_cur_face)
+        {
+            m_last_error = FT_Select_Charmap(m_cur_face, m_char_map);
+            if(m_last_error == 0)
+            {
+                update_signature();
+                return true;
+            }
+        }
+        return false;
+    }
+
+    //------------------------------------------------------------------------
+    bool font_engine_freetype_base::height(double h)
+    {
+        m_height = int(h * 64.0);
+        if(m_cur_face)
+        {
+            update_char_size();
+            return true;
+        }
+        return false;
+    }
+
+    //------------------------------------------------------------------------
+    bool font_engine_freetype_base::width(double w)
+    {
+        m_width = int(w * 64.0);
+        if(m_cur_face)
+        {
+            update_char_size();
+            return true;
+        }
+        return false;
+    }
+
+    //------------------------------------------------------------------------
+    void font_engine_freetype_base::hinting(bool h)
+    { 
+        m_hinting = h; 
+        if(m_cur_face)
+        {
+            update_signature();
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void font_engine_freetype_base::flip_y(bool f)
+    { 
+        m_flip_y = f; 
+        if(m_cur_face)
+        {
+            update_signature();
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void font_engine_freetype_base::transform(const trans_affine& affine)
+    {
+        m_affine = affine;
+        if(m_cur_face)
+        {
+            update_signature();
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void font_engine_freetype_base::update_signature()
+    {
+        if(m_cur_face && m_name)
+        {
+            unsigned name_len = strlen(m_name);
+            if(name_len > m_name_len)
+            {
+                delete [] m_signature;
+                m_signature = new char [name_len + 32 + 256];
+                m_name_len = name_len + 32 - 1;
+            }
+
+            unsigned gamma_hash = 0;
+            if(m_glyph_rendering == glyph_ren_native_gray8 ||
+               m_glyph_rendering == glyph_ren_agg_mono || 
+               m_glyph_rendering == glyph_ren_agg_gray8)
+            {
+                unsigned char gamma_table[rasterizer_scanline_aa<>::aa_scale];
+                unsigned i;
+                for(i = 0; i < rasterizer_scanline_aa<>::aa_scale; ++i)
+                {
+                    gamma_table[i] = m_rasterizer.apply_gamma(i);
+                }
+                gamma_hash = calc_crc32(gamma_table, sizeof(gamma_table));
+            }
+
+            sprintf(m_signature, 
+                    "%s,%u,%d,%d,%d:%dx%d,%d,%d,%08X", 
+                    m_name,
+                    m_char_map,
+                    m_face_index,
+                    int(m_glyph_rendering),
+                    m_resolution,
+                    m_height,
+                    m_width,
+                    int(m_hinting),
+                    int(m_flip_y),
+                    gamma_hash);
+            if(m_glyph_rendering == glyph_ren_outline ||
+               m_glyph_rendering == glyph_ren_agg_mono ||
+               m_glyph_rendering == glyph_ren_agg_gray8)
+            {
+                double mtx[6];
+                char buf[100];
+                m_affine.store_to(mtx);
+                sprintf(buf, ",%08X%08X%08X%08X%08X%08X", 
+                    dbl_to_plain_fx(mtx[0]), 
+                    dbl_to_plain_fx(mtx[1]), 
+                    dbl_to_plain_fx(mtx[2]), 
+                    dbl_to_plain_fx(mtx[3]), 
+                    dbl_to_plain_fx(mtx[4]), 
+                    dbl_to_plain_fx(mtx[5]));
+                strcat(m_signature, buf);
+            }
+            ++m_change_stamp;
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void font_engine_freetype_base::update_char_size()
+    {
+        if(m_cur_face)
+        {
+            if(m_resolution)
+            {
+                FT_Set_Char_Size(m_cur_face, 
+                                 m_width,       // char_width in 1/64th of points
+                                 m_height,      // char_height in 1/64th of points
+                                 m_resolution,  // horizontal device resolution 
+                                 m_resolution); // vertical device resolution 
+            }
+            else
+            {
+                FT_Set_Pixel_Sizes(m_cur_face,    
+                                   m_width >> 6,    // pixel_width
+                                   m_height >> 6);  // pixel_height
+            }
+            update_signature();
+        }
+    }
+
+
+
+
+
+    //------------------------------------------------------------------------
+    bool font_engine_freetype_base::prepare_glyph(unsigned glyph_code)
+    {
+        /* FT_ENCODING_MS_SYMBOL hack inspired from GD's gdft.c:  */
+        /* I do not know the significance of the constant 0xf000. */
+        /* It was determined by inspection of the character codes */
+        /* stored in Microsoft font symbol.ttf                    */
+        if (m_cur_face->charmap &&
+            m_cur_face->charmap->encoding == FT_ENCODING_MS_SYMBOL)
+            glyph_code |= 0xf000;
+
+        m_glyph_index = FT_Get_Char_Index(m_cur_face, glyph_code);
+        m_last_error = FT_Load_Glyph(m_cur_face, 
+                                     m_glyph_index, 
+                                     m_hinting ? FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP : FT_LOAD_NO_HINTING|FT_LOAD_NO_BITMAP);
+//                                     m_hinting ? FT_LOAD_FORCE_AUTOHINT : FT_LOAD_NO_HINTING);
+        if(m_last_error == 0)
+        {
+            switch(m_glyph_rendering)
+            {
+            case glyph_ren_native_mono:
+                m_last_error = FT_Render_Glyph(m_cur_face->glyph, FT_RENDER_MODE_MONO);
+                if(m_last_error == 0)
+                {
+                    decompose_ft_bitmap_mono(m_cur_face->glyph->bitmap, 
+                                             m_cur_face->glyph->bitmap_left,
+                                             m_flip_y ? -m_cur_face->glyph->bitmap_top : 
+                                                         m_cur_face->glyph->bitmap_top,
+                                             m_flip_y,
+                                             m_scanline_bin,
+                                             m_scanlines_bin);
+                    m_bounds.x1 = m_scanlines_bin.min_x();
+                    m_bounds.y1 = m_scanlines_bin.min_y();
+                    m_bounds.x2 = m_scanlines_bin.max_x() + 1;
+                    m_bounds.y2 = m_scanlines_bin.max_y() + 1;
+                    m_data_size = m_scanlines_bin.byte_size(); 
+                    m_data_type = glyph_data_mono;
+                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
+                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
+                    return true;
+                }
+                break;
+
+
+            case glyph_ren_native_gray8:
+                m_last_error = FT_Render_Glyph(m_cur_face->glyph, FT_RENDER_MODE_NORMAL);
+                if(m_last_error == 0)
+                {
+                    decompose_ft_bitmap_gray8(m_cur_face->glyph->bitmap, 
+                                              m_cur_face->glyph->bitmap_left,
+                                              m_flip_y ? -m_cur_face->glyph->bitmap_top : 
+                                                          m_cur_face->glyph->bitmap_top,
+                                              m_flip_y,
+                                              m_rasterizer,
+                                              m_scanline_aa,
+                                              m_scanlines_aa);
+                    m_bounds.x1 = m_scanlines_aa.min_x();
+                    m_bounds.y1 = m_scanlines_aa.min_y();
+                    m_bounds.x2 = m_scanlines_aa.max_x() + 1;
+                    m_bounds.y2 = m_scanlines_aa.max_y() + 1;
+                    m_data_size = m_scanlines_aa.byte_size(); 
+                    m_data_type = glyph_data_gray8;
+                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
+                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
+                    return true;
+                }
+                break;
+
+
+            case glyph_ren_outline:
+                if(m_last_error == 0)
+                {
+                    if(m_flag32)
+                    {
+                        m_path32.remove_all();
+                        if(decompose_ft_outline(m_cur_face->glyph->outline,
+                                                m_flip_y, 
+                                                m_affine,
+                                                m_path32))
+                        {
+                            rect_d bnd  = m_path32.bounding_rect();
+                            m_data_size = m_path32.byte_size();
+                            m_data_type = glyph_data_outline;
+                            m_bounds.x1 = int(floor(bnd.x1));
+                            m_bounds.y1 = int(floor(bnd.y1));
+                            m_bounds.x2 = int(ceil(bnd.x2));
+                            m_bounds.y2 = int(ceil(bnd.y2));
+                            m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
+                            m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
+                            m_affine.transform(&m_advance_x, &m_advance_y);
+                            return true;
+                        }
+                    }
+                    else
+                    {
+                        m_path16.remove_all();
+                        if(decompose_ft_outline(m_cur_face->glyph->outline,
+                                                m_flip_y, 
+                                                m_affine,
+                                                m_path16))
+                        {
+                            rect_d bnd  = m_path16.bounding_rect();
+                            m_data_size = m_path16.byte_size();
+                            m_data_type = glyph_data_outline;
+                            m_bounds.x1 = int(floor(bnd.x1));
+                            m_bounds.y1 = int(floor(bnd.y1));
+                            m_bounds.x2 = int(ceil(bnd.x2));
+                            m_bounds.y2 = int(ceil(bnd.y2));
+                            m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
+                            m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
+                            m_affine.transform(&m_advance_x, &m_advance_y);
+                            return true;
+                        }
+                    }
+                }
+                return false;
+
+            case glyph_ren_agg_mono:
+                if(m_last_error == 0)
+                {
+                    m_rasterizer.reset();
+                    if(m_flag32)
+                    {
+                        m_path32.remove_all();
+                        decompose_ft_outline(m_cur_face->glyph->outline,
+                                             m_flip_y, 
+                                             m_affine,
+                                             m_path32);
+                        m_rasterizer.add_path(m_curves32);
+                    }
+                    else
+                    {
+                        m_path16.remove_all();
+                        decompose_ft_outline(m_cur_face->glyph->outline,
+                                             m_flip_y, 
+                                             m_affine,
+                                             m_path16);
+                        m_rasterizer.add_path(m_curves16);
+                    }
+                    m_scanlines_bin.prepare(); // Remove all 
+                    render_scanlines(m_rasterizer, m_scanline_bin, m_scanlines_bin);
+                    m_bounds.x1 = m_scanlines_bin.min_x();
+                    m_bounds.y1 = m_scanlines_bin.min_y();
+                    m_bounds.x2 = m_scanlines_bin.max_x() + 1;
+                    m_bounds.y2 = m_scanlines_bin.max_y() + 1;
+                    m_data_size = m_scanlines_bin.byte_size(); 
+                    m_data_type = glyph_data_mono;
+                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
+                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
+                    m_affine.transform(&m_advance_x, &m_advance_y);
+                    return true;
+                }
+                return false;
+
+
+            case glyph_ren_agg_gray8:
+                if(m_last_error == 0)
+                {
+                    m_rasterizer.reset();
+                    if(m_flag32)
+                    {
+                        m_path32.remove_all();
+                        decompose_ft_outline(m_cur_face->glyph->outline,
+                                             m_flip_y, 
+                                             m_affine,
+                                             m_path32);
+                        m_rasterizer.add_path(m_curves32);
+                    }
+                    else
+                    {
+                        m_path16.remove_all();
+                        decompose_ft_outline(m_cur_face->glyph->outline,
+                                             m_flip_y, 
+                                             m_affine,
+                                             m_path16);
+                        m_rasterizer.add_path(m_curves16);
+                    }
+                    m_scanlines_aa.prepare(); // Remove all 
+                    render_scanlines(m_rasterizer, m_scanline_aa, m_scanlines_aa);
+                    m_bounds.x1 = m_scanlines_aa.min_x();
+                    m_bounds.y1 = m_scanlines_aa.min_y();
+                    m_bounds.x2 = m_scanlines_aa.max_x() + 1;
+                    m_bounds.y2 = m_scanlines_aa.max_y() + 1;
+                    m_data_size = m_scanlines_aa.byte_size(); 
+                    m_data_type = glyph_data_gray8;
+                    m_advance_x = int26p6_to_dbl(m_cur_face->glyph->advance.x);
+                    m_advance_y = int26p6_to_dbl(m_cur_face->glyph->advance.y);
+                    m_affine.transform(&m_advance_x, &m_advance_y);
+                    return true;
+                }
+                return false;
+            }
+        }
+        return false;
+    }
+
+
+
+
+    //------------------------------------------------------------------------
+    void font_engine_freetype_base::write_glyph_to(int8u* data) const
+    {
+        if(data && m_data_size)
+        {
+            switch(m_data_type)
+            {
+            default: return;
+            case glyph_data_mono:    m_scanlines_bin.serialize(data); break;
+            case glyph_data_gray8:   m_scanlines_aa.serialize(data);  break;
+            case glyph_data_outline: 
+                if(m_flag32)
+                {
+                    m_path32.serialize(data);
+                }
+                else
+                {
+                    m_path16.serialize(data);
+                }
+                break;
+            case glyph_data_invalid: break;
+            }
+        }
+    }
+
+
+
+    //------------------------------------------------------------------------
+    bool font_engine_freetype_base::add_kerning(unsigned first, unsigned second,
+                                           double* x, double* y)
+    {
+        if(m_cur_face && first && second && FT_HAS_KERNING(m_cur_face))
+        {
+            FT_Vector delta;
+            FT_Get_Kerning(m_cur_face, first, second,
+                           FT_KERNING_DEFAULT, &delta);
+            double dx = int26p6_to_dbl(delta.x);
+            double dy = int26p6_to_dbl(delta.y);
+            if(m_glyph_rendering == glyph_ren_outline ||
+               m_glyph_rendering == glyph_ren_agg_mono ||
+               m_glyph_rendering == glyph_ren_agg_gray8)
+            {
+                m_affine.transform_2x2(&dx, &dy);
+            }
+            *x += dx;
+            *y += dy;
+
+            return true;
+        }
+        return false;
+    }
+
+
+
+}
+
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_gsv_text.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_gsv_text.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_gsv_text.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_gsv_text.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,675 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Class gsv_text
+//
+//----------------------------------------------------------------------------
+#include <string.h>
+#include <stdio.h>
+#include "../include/agg_gsv_text.h"
+#include "../include/agg_bounding_rect.h"
+
+
+
+namespace mapserver
+{
+    int8u gsv_default_font[] = 
+    {
+        0x40,0x00,0x6c,0x0f,0x15,0x00,0x0e,0x00,0xf9,0xff,
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x0d,0x0a,0x0d,0x0a,0x46,0x6f,0x6e,0x74,0x20,0x28,
+        0x63,0x29,0x20,0x4d,0x69,0x63,0x72,0x6f,0x50,0x72,
+        0x6f,0x66,0x20,0x32,0x37,0x20,0x53,0x65,0x70,0x74,
+        0x65,0x6d,0x62,0x2e,0x31,0x39,0x38,0x39,0x00,0x0d,
+        0x0a,0x0d,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
+        0x02,0x00,0x12,0x00,0x34,0x00,0x46,0x00,0x94,0x00,
+        0xd0,0x00,0x2e,0x01,0x3e,0x01,0x64,0x01,0x8a,0x01,
+        0x98,0x01,0xa2,0x01,0xb4,0x01,0xba,0x01,0xc6,0x01,
+        0xcc,0x01,0xf0,0x01,0xfa,0x01,0x18,0x02,0x38,0x02,
+        0x44,0x02,0x68,0x02,0x98,0x02,0xa2,0x02,0xde,0x02,
+        0x0e,0x03,0x24,0x03,0x40,0x03,0x48,0x03,0x52,0x03,
+        0x5a,0x03,0x82,0x03,0xec,0x03,0xfa,0x03,0x26,0x04,
+        0x4c,0x04,0x6a,0x04,0x7c,0x04,0x8a,0x04,0xb6,0x04,
+        0xc4,0x04,0xca,0x04,0xe0,0x04,0xee,0x04,0xf8,0x04,
+        0x0a,0x05,0x18,0x05,0x44,0x05,0x5e,0x05,0x8e,0x05,
+        0xac,0x05,0xd6,0x05,0xe0,0x05,0xf6,0x05,0x00,0x06,
+        0x12,0x06,0x1c,0x06,0x28,0x06,0x36,0x06,0x48,0x06,
+        0x4e,0x06,0x60,0x06,0x6e,0x06,0x74,0x06,0x84,0x06,
+        0xa6,0x06,0xc8,0x06,0xe6,0x06,0x08,0x07,0x2c,0x07,
+        0x3c,0x07,0x68,0x07,0x7c,0x07,0x8c,0x07,0xa2,0x07,
+        0xb0,0x07,0xb6,0x07,0xd8,0x07,0xec,0x07,0x10,0x08,
+        0x32,0x08,0x54,0x08,0x64,0x08,0x88,0x08,0x98,0x08,
+        0xac,0x08,0xb6,0x08,0xc8,0x08,0xd2,0x08,0xe4,0x08,
+        0xf2,0x08,0x3e,0x09,0x48,0x09,0x94,0x09,0xc2,0x09,
+        0xc4,0x09,0xd0,0x09,0xe2,0x09,0x04,0x0a,0x0e,0x0a,
+        0x26,0x0a,0x34,0x0a,0x4a,0x0a,0x66,0x0a,0x70,0x0a,
+        0x7e,0x0a,0x8e,0x0a,0x9a,0x0a,0xa6,0x0a,0xb4,0x0a,
+        0xd8,0x0a,0xe2,0x0a,0xf6,0x0a,0x18,0x0b,0x22,0x0b,
+        0x32,0x0b,0x56,0x0b,0x60,0x0b,0x6e,0x0b,0x7c,0x0b,
+        0x8a,0x0b,0x9c,0x0b,0x9e,0x0b,0xb2,0x0b,0xc2,0x0b,
+        0xd8,0x0b,0xf4,0x0b,0x08,0x0c,0x30,0x0c,0x56,0x0c,
+        0x72,0x0c,0x90,0x0c,0xb2,0x0c,0xce,0x0c,0xe2,0x0c,
+        0xfe,0x0c,0x10,0x0d,0x26,0x0d,0x36,0x0d,0x42,0x0d,
+        0x4e,0x0d,0x5c,0x0d,0x78,0x0d,0x8c,0x0d,0x8e,0x0d,
+        0x90,0x0d,0x92,0x0d,0x94,0x0d,0x96,0x0d,0x98,0x0d,
+        0x9a,0x0d,0x9c,0x0d,0x9e,0x0d,0xa0,0x0d,0xa2,0x0d,
+        0xa4,0x0d,0xa6,0x0d,0xa8,0x0d,0xaa,0x0d,0xac,0x0d,
+        0xae,0x0d,0xb0,0x0d,0xb2,0x0d,0xb4,0x0d,0xb6,0x0d,
+        0xb8,0x0d,0xba,0x0d,0xbc,0x0d,0xbe,0x0d,0xc0,0x0d,
+        0xc2,0x0d,0xc4,0x0d,0xc6,0x0d,0xc8,0x0d,0xca,0x0d,
+        0xcc,0x0d,0xce,0x0d,0xd0,0x0d,0xd2,0x0d,0xd4,0x0d,
+        0xd6,0x0d,0xd8,0x0d,0xda,0x0d,0xdc,0x0d,0xde,0x0d,
+        0xe0,0x0d,0xe2,0x0d,0xe4,0x0d,0xe6,0x0d,0xe8,0x0d,
+        0xea,0x0d,0xec,0x0d,0x0c,0x0e,0x26,0x0e,0x48,0x0e,
+        0x64,0x0e,0x88,0x0e,0x92,0x0e,0xa6,0x0e,0xb4,0x0e,
+        0xd0,0x0e,0xee,0x0e,0x02,0x0f,0x16,0x0f,0x26,0x0f,
+        0x3c,0x0f,0x58,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,
+        0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,
+        0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,
+        0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x6c,0x0f,0x10,0x80,
+        0x05,0x95,0x00,0x72,0x00,0xfb,0xff,0x7f,0x01,0x7f,
+        0x01,0x01,0xff,0x01,0x05,0xfe,0x05,0x95,0xff,0x7f,
+        0x00,0x7a,0x01,0x86,0xff,0x7a,0x01,0x87,0x01,0x7f,
+        0xfe,0x7a,0x0a,0x87,0xff,0x7f,0x00,0x7a,0x01,0x86,
+        0xff,0x7a,0x01,0x87,0x01,0x7f,0xfe,0x7a,0x05,0xf2,
+        0x0b,0x95,0xf9,0x64,0x0d,0x9c,0xf9,0x64,0xfa,0x91,
+        0x0e,0x00,0xf1,0xfa,0x0e,0x00,0x04,0xfc,0x08,0x99,
+        0x00,0x63,0x04,0x9d,0x00,0x63,0x04,0x96,0xff,0x7f,
+        0x01,0x7f,0x01,0x01,0x00,0x01,0xfe,0x02,0xfd,0x01,
+        0xfc,0x00,0xfd,0x7f,0xfe,0x7e,0x00,0x7e,0x01,0x7e,
+        0x01,0x7f,0x02,0x7f,0x06,0x7e,0x02,0x7f,0x02,0x7e,
+        0xf2,0x89,0x02,0x7e,0x02,0x7f,0x06,0x7e,0x02,0x7f,
+        0x01,0x7f,0x01,0x7e,0x00,0x7c,0xfe,0x7e,0xfd,0x7f,
+        0xfc,0x00,0xfd,0x01,0xfe,0x02,0x00,0x01,0x01,0x01,
+        0x01,0x7f,0xff,0x7f,0x10,0xfd,0x15,0x95,0xee,0x6b,
+        0x05,0x95,0x02,0x7e,0x00,0x7e,0xff,0x7e,0xfe,0x7f,
+        0xfe,0x00,0xfe,0x02,0x00,0x02,0x01,0x02,0x02,0x01,
+        0x02,0x00,0x02,0x7f,0x03,0x7f,0x03,0x00,0x03,0x01,
+        0x02,0x01,0xfc,0xf2,0xfe,0x7f,0xff,0x7e,0x00,0x7e,
+        0x02,0x7e,0x02,0x00,0x02,0x01,0x01,0x02,0x00,0x02,
+        0xfe,0x02,0xfe,0x00,0x07,0xf9,0x15,0x8d,0xff,0x7f,
+        0x01,0x7f,0x01,0x01,0x00,0x01,0xff,0x01,0xff,0x00,
+        0xff,0x7f,0xff,0x7e,0xfe,0x7b,0xfe,0x7d,0xfe,0x7e,
+        0xfe,0x7f,0xfd,0x00,0xfd,0x01,0xff,0x02,0x00,0x03,
+        0x01,0x02,0x06,0x04,0x02,0x02,0x01,0x02,0x00,0x02,
+        0xff,0x02,0xfe,0x01,0xfe,0x7f,0xff,0x7e,0x00,0x7e,
+        0x01,0x7d,0x02,0x7d,0x05,0x79,0x02,0x7e,0x03,0x7f,
+        0x01,0x00,0x01,0x01,0x00,0x01,0xf1,0xfe,0xfe,0x01,
+        0xff,0x02,0x00,0x03,0x01,0x02,0x02,0x02,0x00,0x86,
+        0x01,0x7e,0x08,0x75,0x02,0x7e,0x02,0x7f,0x05,0x80,
+        0x05,0x93,0xff,0x01,0x01,0x01,0x01,0x7f,0x00,0x7e,
+        0xff,0x7e,0xff,0x7f,0x06,0xf1,0x0b,0x99,0xfe,0x7e,
+        0xfe,0x7d,0xfe,0x7c,0xff,0x7b,0x00,0x7c,0x01,0x7b,
+        0x02,0x7c,0x02,0x7d,0x02,0x7e,0xfe,0x9e,0xfe,0x7c,
+        0xff,0x7d,0xff,0x7b,0x00,0x7c,0x01,0x7b,0x01,0x7d,
+        0x02,0x7c,0x05,0x85,0x03,0x99,0x02,0x7e,0x02,0x7d,
+        0x02,0x7c,0x01,0x7b,0x00,0x7c,0xff,0x7b,0xfe,0x7c,
+        0xfe,0x7d,0xfe,0x7e,0x02,0x9e,0x02,0x7c,0x01,0x7d,
+        0x01,0x7b,0x00,0x7c,0xff,0x7b,0xff,0x7d,0xfe,0x7c,
+        0x09,0x85,0x08,0x95,0x00,0x74,0xfb,0x89,0x0a,0x7a,
+        0x00,0x86,0xf6,0x7a,0x0d,0xf4,0x0d,0x92,0x00,0x6e,
+        0xf7,0x89,0x12,0x00,0x04,0xf7,0x06,0x81,0xff,0x7f,
+        0xff,0x01,0x01,0x01,0x01,0x7f,0x00,0x7e,0xff,0x7e,
+        0xff,0x7f,0x06,0x84,0x04,0x89,0x12,0x00,0x04,0xf7,
+        0x05,0x82,0xff,0x7f,0x01,0x7f,0x01,0x01,0xff,0x01,
+        0x05,0xfe,0x00,0xfd,0x0e,0x18,0x00,0xeb,0x09,0x95,
+        0xfd,0x7f,0xfe,0x7d,0xff,0x7b,0x00,0x7d,0x01,0x7b,
+        0x02,0x7d,0x03,0x7f,0x02,0x00,0x03,0x01,0x02,0x03,
+        0x01,0x05,0x00,0x03,0xff,0x05,0xfe,0x03,0xfd,0x01,
+        0xfe,0x00,0x0b,0xeb,0x06,0x91,0x02,0x01,0x03,0x03,
+        0x00,0x6b,0x09,0x80,0x04,0x90,0x00,0x01,0x01,0x02,
+        0x01,0x01,0x02,0x01,0x04,0x00,0x02,0x7f,0x01,0x7f,
+        0x01,0x7e,0x00,0x7e,0xff,0x7e,0xfe,0x7d,0xf6,0x76,
+        0x0e,0x00,0x03,0x80,0x05,0x95,0x0b,0x00,0xfa,0x78,
+        0x03,0x00,0x02,0x7f,0x01,0x7f,0x01,0x7d,0x00,0x7e,
+        0xff,0x7d,0xfe,0x7e,0xfd,0x7f,0xfd,0x00,0xfd,0x01,
+        0xff,0x01,0xff,0x02,0x11,0xfc,0x0d,0x95,0xf6,0x72,
+        0x0f,0x00,0xfb,0x8e,0x00,0x6b,0x07,0x80,0x0f,0x95,
+        0xf6,0x00,0xff,0x77,0x01,0x01,0x03,0x01,0x03,0x00,
+        0x03,0x7f,0x02,0x7e,0x01,0x7d,0x00,0x7e,0xff,0x7d,
+        0xfe,0x7e,0xfd,0x7f,0xfd,0x00,0xfd,0x01,0xff,0x01,
+        0xff,0x02,0x11,0xfc,0x10,0x92,0xff,0x02,0xfd,0x01,
+        0xfe,0x00,0xfd,0x7f,0xfe,0x7d,0xff,0x7b,0x00,0x7b,
+        0x01,0x7c,0x02,0x7e,0x03,0x7f,0x01,0x00,0x03,0x01,
+        0x02,0x02,0x01,0x03,0x00,0x01,0xff,0x03,0xfe,0x02,
+        0xfd,0x01,0xff,0x00,0xfd,0x7f,0xfe,0x7e,0xff,0x7d,
+        0x10,0xf9,0x11,0x95,0xf6,0x6b,0xfc,0x95,0x0e,0x00,
+        0x03,0xeb,0x08,0x95,0xfd,0x7f,0xff,0x7e,0x00,0x7e,
+        0x01,0x7e,0x02,0x7f,0x04,0x7f,0x03,0x7f,0x02,0x7e,
+        0x01,0x7e,0x00,0x7d,0xff,0x7e,0xff,0x7f,0xfd,0x7f,
+        0xfc,0x00,0xfd,0x01,0xff,0x01,0xff,0x02,0x00,0x03,
+        0x01,0x02,0x02,0x02,0x03,0x01,0x04,0x01,0x02,0x01,
+        0x01,0x02,0x00,0x02,0xff,0x02,0xfd,0x01,0xfc,0x00,
+        0x0c,0xeb,0x10,0x8e,0xff,0x7d,0xfe,0x7e,0xfd,0x7f,
+        0xff,0x00,0xfd,0x01,0xfe,0x02,0xff,0x03,0x00,0x01,
+        0x01,0x03,0x02,0x02,0x03,0x01,0x01,0x00,0x03,0x7f,
+        0x02,0x7e,0x01,0x7c,0x00,0x7b,0xff,0x7b,0xfe,0x7d,
+        0xfd,0x7f,0xfe,0x00,0xfd,0x01,0xff,0x02,0x10,0xfd,
+        0x05,0x8e,0xff,0x7f,0x01,0x7f,0x01,0x01,0xff,0x01,
+        0x00,0xf4,0xff,0x7f,0x01,0x7f,0x01,0x01,0xff,0x01,
+        0x05,0xfe,0x05,0x8e,0xff,0x7f,0x01,0x7f,0x01,0x01,
+        0xff,0x01,0x01,0xf3,0xff,0x7f,0xff,0x01,0x01,0x01,
+        0x01,0x7f,0x00,0x7e,0xff,0x7e,0xff,0x7f,0x06,0x84,
+        0x14,0x92,0xf0,0x77,0x10,0x77,0x04,0x80,0x04,0x8c,
+        0x12,0x00,0xee,0xfa,0x12,0x00,0x04,0xfa,0x04,0x92,
+        0x10,0x77,0xf0,0x77,0x14,0x80,0x03,0x90,0x00,0x01,
+        0x01,0x02,0x01,0x01,0x02,0x01,0x04,0x00,0x02,0x7f,
+        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xff,0x7e,0xff,0x7f,
+        0xfc,0x7e,0x00,0x7d,0x00,0xfb,0xff,0x7f,0x01,0x7f,
+        0x01,0x01,0xff,0x01,0x09,0xfe,0x12,0x8d,0xff,0x02,
+        0xfe,0x01,0xfd,0x00,0xfe,0x7f,0xff,0x7f,0xff,0x7d,
+        0x00,0x7d,0x01,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
+        0x01,0x02,0xfb,0x88,0xfe,0x7e,0xff,0x7d,0x00,0x7d,
+        0x01,0x7e,0x01,0x7f,0x07,0x8b,0xff,0x78,0x00,0x7e,
+        0x02,0x7f,0x02,0x00,0x02,0x02,0x01,0x03,0x00,0x02,
+        0xff,0x03,0xff,0x02,0xfe,0x02,0xfe,0x01,0xfd,0x01,
+        0xfd,0x00,0xfd,0x7f,0xfe,0x7f,0xfe,0x7e,0xff,0x7e,
+        0xff,0x7d,0x00,0x7d,0x01,0x7d,0x01,0x7e,0x02,0x7e,
+        0x02,0x7f,0x03,0x7f,0x03,0x00,0x03,0x01,0x02,0x01,
+        0x01,0x01,0xfe,0x8d,0xff,0x78,0x00,0x7e,0x01,0x7f,
+        0x08,0xfb,0x09,0x95,0xf8,0x6b,0x08,0x95,0x08,0x6b,
+        0xf3,0x87,0x0a,0x00,0x04,0xf9,0x04,0x95,0x00,0x6b,
+        0x00,0x95,0x09,0x00,0x03,0x7f,0x01,0x7f,0x01,0x7e,
+        0x00,0x7e,0xff,0x7e,0xff,0x7f,0xfd,0x7f,0xf7,0x80,
+        0x09,0x00,0x03,0x7f,0x01,0x7f,0x01,0x7e,0x00,0x7d,
+        0xff,0x7e,0xff,0x7f,0xfd,0x7f,0xf7,0x00,0x11,0x80,
+        0x12,0x90,0xff,0x02,0xfe,0x02,0xfe,0x01,0xfc,0x00,
+        0xfe,0x7f,0xfe,0x7e,0xff,0x7e,0xff,0x7d,0x00,0x7b,
+        0x01,0x7d,0x01,0x7e,0x02,0x7e,0x02,0x7f,0x04,0x00,
+        0x02,0x01,0x02,0x02,0x01,0x02,0x03,0xfb,0x04,0x95,
+        0x00,0x6b,0x00,0x95,0x07,0x00,0x03,0x7f,0x02,0x7e,
+        0x01,0x7e,0x01,0x7d,0x00,0x7b,0xff,0x7d,0xff,0x7e,
+        0xfe,0x7e,0xfd,0x7f,0xf9,0x00,0x11,0x80,0x04,0x95,
+        0x00,0x6b,0x00,0x95,0x0d,0x00,0xf3,0xf6,0x08,0x00,
+        0xf8,0xf5,0x0d,0x00,0x02,0x80,0x04,0x95,0x00,0x6b,
+        0x00,0x95,0x0d,0x00,0xf3,0xf6,0x08,0x00,0x06,0xf5,
+        0x12,0x90,0xff,0x02,0xfe,0x02,0xfe,0x01,0xfc,0x00,
+        0xfe,0x7f,0xfe,0x7e,0xff,0x7e,0xff,0x7d,0x00,0x7b,
+        0x01,0x7d,0x01,0x7e,0x02,0x7e,0x02,0x7f,0x04,0x00,
+        0x02,0x01,0x02,0x02,0x01,0x02,0x00,0x03,0xfb,0x80,
+        0x05,0x00,0x03,0xf8,0x04,0x95,0x00,0x6b,0x0e,0x95,
+        0x00,0x6b,0xf2,0x8b,0x0e,0x00,0x04,0xf5,0x04,0x95,
+        0x00,0x6b,0x04,0x80,0x0c,0x95,0x00,0x70,0xff,0x7d,
+        0xff,0x7f,0xfe,0x7f,0xfe,0x00,0xfe,0x01,0xff,0x01,
+        0xff,0x03,0x00,0x02,0x0e,0xf9,0x04,0x95,0x00,0x6b,
+        0x0e,0x95,0xf2,0x72,0x05,0x85,0x09,0x74,0x03,0x80,
+        0x04,0x95,0x00,0x6b,0x00,0x80,0x0c,0x00,0x01,0x80,
+        0x04,0x95,0x00,0x6b,0x00,0x95,0x08,0x6b,0x08,0x95,
+        0xf8,0x6b,0x08,0x95,0x00,0x6b,0x04,0x80,0x04,0x95,
+        0x00,0x6b,0x00,0x95,0x0e,0x6b,0x00,0x95,0x00,0x6b,
+        0x04,0x80,0x09,0x95,0xfe,0x7f,0xfe,0x7e,0xff,0x7e,
+        0xff,0x7d,0x00,0x7b,0x01,0x7d,0x01,0x7e,0x02,0x7e,
+        0x02,0x7f,0x04,0x00,0x02,0x01,0x02,0x02,0x01,0x02,
+        0x01,0x03,0x00,0x05,0xff,0x03,0xff,0x02,0xfe,0x02,
+        0xfe,0x01,0xfc,0x00,0x0d,0xeb,0x04,0x95,0x00,0x6b,
+        0x00,0x95,0x09,0x00,0x03,0x7f,0x01,0x7f,0x01,0x7e,
+        0x00,0x7d,0xff,0x7e,0xff,0x7f,0xfd,0x7f,0xf7,0x00,
+        0x11,0xf6,0x09,0x95,0xfe,0x7f,0xfe,0x7e,0xff,0x7e,
+        0xff,0x7d,0x00,0x7b,0x01,0x7d,0x01,0x7e,0x02,0x7e,
+        0x02,0x7f,0x04,0x00,0x02,0x01,0x02,0x02,0x01,0x02,
+        0x01,0x03,0x00,0x05,0xff,0x03,0xff,0x02,0xfe,0x02,
+        0xfe,0x01,0xfc,0x00,0x03,0xef,0x06,0x7a,0x04,0x82,
+        0x04,0x95,0x00,0x6b,0x00,0x95,0x09,0x00,0x03,0x7f,
+        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xff,0x7e,0xff,0x7f,
+        0xfd,0x7f,0xf7,0x00,0x07,0x80,0x07,0x75,0x03,0x80,
+        0x11,0x92,0xfe,0x02,0xfd,0x01,0xfc,0x00,0xfd,0x7f,
+        0xfe,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,0x02,0x7f,
+        0x06,0x7e,0x02,0x7f,0x01,0x7f,0x01,0x7e,0x00,0x7d,
+        0xfe,0x7e,0xfd,0x7f,0xfc,0x00,0xfd,0x01,0xfe,0x02,
+        0x11,0xfd,0x08,0x95,0x00,0x6b,0xf9,0x95,0x0e,0x00,
+        0x01,0xeb,0x04,0x95,0x00,0x71,0x01,0x7d,0x02,0x7e,
+        0x03,0x7f,0x02,0x00,0x03,0x01,0x02,0x02,0x01,0x03,
+        0x00,0x0f,0x04,0xeb,0x01,0x95,0x08,0x6b,0x08,0x95,
+        0xf8,0x6b,0x09,0x80,0x02,0x95,0x05,0x6b,0x05,0x95,
+        0xfb,0x6b,0x05,0x95,0x05,0x6b,0x05,0x95,0xfb,0x6b,
+        0x07,0x80,0x03,0x95,0x0e,0x6b,0x00,0x95,0xf2,0x6b,
+        0x11,0x80,0x01,0x95,0x08,0x76,0x00,0x75,0x08,0x95,
+        0xf8,0x76,0x09,0xf5,0x11,0x95,0xf2,0x6b,0x00,0x95,
+        0x0e,0x00,0xf2,0xeb,0x0e,0x00,0x03,0x80,0x03,0x93,
+        0x00,0x6c,0x01,0x94,0x00,0x6c,0xff,0x94,0x05,0x00,
+        0xfb,0xec,0x05,0x00,0x02,0x81,0x00,0x95,0x0e,0x68,
+        0x00,0x83,0x06,0x93,0x00,0x6c,0x01,0x94,0x00,0x6c,
+        0xfb,0x94,0x05,0x00,0xfb,0xec,0x05,0x00,0x03,0x81,
+        0x03,0x87,0x08,0x05,0x08,0x7b,0xf0,0x80,0x08,0x04,
+        0x08,0x7c,0x03,0xf9,0x01,0x80,0x10,0x00,0x01,0x80,
+        0x06,0x95,0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7f,
+        0x01,0x01,0xff,0x01,0x05,0xef,0x0f,0x8e,0x00,0x72,
+        0x00,0x8b,0xfe,0x02,0xfe,0x01,0xfd,0x00,0xfe,0x7f,
+        0xfe,0x7e,0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,
+        0x02,0x7f,0x03,0x00,0x02,0x01,0x02,0x02,0x04,0xfd,
+        0x04,0x95,0x00,0x6b,0x00,0x8b,0x02,0x02,0x02,0x01,
+        0x03,0x00,0x02,0x7f,0x02,0x7e,0x01,0x7d,0x00,0x7e,
+        0xff,0x7d,0xfe,0x7e,0xfe,0x7f,0xfd,0x00,0xfe,0x01,
+        0xfe,0x02,0x0f,0xfd,0x0f,0x8b,0xfe,0x02,0xfe,0x01,
+        0xfd,0x00,0xfe,0x7f,0xfe,0x7e,0xff,0x7d,0x00,0x7e,
+        0x01,0x7d,0x02,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
+        0x02,0x02,0x03,0xfd,0x0f,0x95,0x00,0x6b,0x00,0x8b,
+        0xfe,0x02,0xfe,0x01,0xfd,0x00,0xfe,0x7f,0xfe,0x7e,
+        0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,0x02,0x7f,
+        0x03,0x00,0x02,0x01,0x02,0x02,0x04,0xfd,0x03,0x88,
+        0x0c,0x00,0x00,0x02,0xff,0x02,0xff,0x01,0xfe,0x01,
+        0xfd,0x00,0xfe,0x7f,0xfe,0x7e,0xff,0x7d,0x00,0x7e,
+        0x01,0x7d,0x02,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
+        0x02,0x02,0x03,0xfd,0x0a,0x95,0xfe,0x00,0xfe,0x7f,
+        0xff,0x7d,0x00,0x6f,0xfd,0x8e,0x07,0x00,0x03,0xf2,
+        0x0f,0x8e,0x00,0x70,0xff,0x7d,0xff,0x7f,0xfe,0x7f,
+        0xfd,0x00,0xfe,0x01,0x09,0x91,0xfe,0x02,0xfe,0x01,
+        0xfd,0x00,0xfe,0x7f,0xfe,0x7e,0xff,0x7d,0x00,0x7e,
+        0x01,0x7d,0x02,0x7e,0x02,0x7f,0x03,0x00,0x02,0x01,
+        0x02,0x02,0x04,0xfd,0x04,0x95,0x00,0x6b,0x00,0x8a,
+        0x03,0x03,0x02,0x01,0x03,0x00,0x02,0x7f,0x01,0x7d,
+        0x00,0x76,0x04,0x80,0x03,0x95,0x01,0x7f,0x01,0x01,
+        0xff,0x01,0xff,0x7f,0x01,0xf9,0x00,0x72,0x04,0x80,
+        0x05,0x95,0x01,0x7f,0x01,0x01,0xff,0x01,0xff,0x7f,
+        0x01,0xf9,0x00,0x6f,0xff,0x7d,0xfe,0x7f,0xfe,0x00,
+        0x09,0x87,0x04,0x95,0x00,0x6b,0x0a,0x8e,0xf6,0x76,
+        0x04,0x84,0x07,0x78,0x02,0x80,0x04,0x95,0x00,0x6b,
+        0x04,0x80,0x04,0x8e,0x00,0x72,0x00,0x8a,0x03,0x03,
+        0x02,0x01,0x03,0x00,0x02,0x7f,0x01,0x7d,0x00,0x76,
+        0x00,0x8a,0x03,0x03,0x02,0x01,0x03,0x00,0x02,0x7f,
+        0x01,0x7d,0x00,0x76,0x04,0x80,0x04,0x8e,0x00,0x72,
+        0x00,0x8a,0x03,0x03,0x02,0x01,0x03,0x00,0x02,0x7f,
+        0x01,0x7d,0x00,0x76,0x04,0x80,0x08,0x8e,0xfe,0x7f,
+        0xfe,0x7e,0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,
+        0x02,0x7f,0x03,0x00,0x02,0x01,0x02,0x02,0x01,0x03,
+        0x00,0x02,0xff,0x03,0xfe,0x02,0xfe,0x01,0xfd,0x00,
+        0x0b,0xf2,0x04,0x8e,0x00,0x6b,0x00,0x92,0x02,0x02,
+        0x02,0x01,0x03,0x00,0x02,0x7f,0x02,0x7e,0x01,0x7d,
+        0x00,0x7e,0xff,0x7d,0xfe,0x7e,0xfe,0x7f,0xfd,0x00,
+        0xfe,0x01,0xfe,0x02,0x0f,0xfd,0x0f,0x8e,0x00,0x6b,
+        0x00,0x92,0xfe,0x02,0xfe,0x01,0xfd,0x00,0xfe,0x7f,
+        0xfe,0x7e,0xff,0x7d,0x00,0x7e,0x01,0x7d,0x02,0x7e,
+        0x02,0x7f,0x03,0x00,0x02,0x01,0x02,0x02,0x04,0xfd,
+        0x04,0x8e,0x00,0x72,0x00,0x88,0x01,0x03,0x02,0x02,
+        0x02,0x01,0x03,0x00,0x01,0xf2,0x0e,0x8b,0xff,0x02,
+        0xfd,0x01,0xfd,0x00,0xfd,0x7f,0xff,0x7e,0x01,0x7e,
+        0x02,0x7f,0x05,0x7f,0x02,0x7f,0x01,0x7e,0x00,0x7f,
+        0xff,0x7e,0xfd,0x7f,0xfd,0x00,0xfd,0x01,0xff,0x02,
+        0x0e,0xfd,0x05,0x95,0x00,0x6f,0x01,0x7d,0x02,0x7f,
+        0x02,0x00,0xf8,0x8e,0x07,0x00,0x03,0xf2,0x04,0x8e,
+        0x00,0x76,0x01,0x7d,0x02,0x7f,0x03,0x00,0x02,0x01,
+        0x03,0x03,0x00,0x8a,0x00,0x72,0x04,0x80,0x02,0x8e,
+        0x06,0x72,0x06,0x8e,0xfa,0x72,0x08,0x80,0x03,0x8e,
+        0x04,0x72,0x04,0x8e,0xfc,0x72,0x04,0x8e,0x04,0x72,
+        0x04,0x8e,0xfc,0x72,0x07,0x80,0x03,0x8e,0x0b,0x72,
+        0x00,0x8e,0xf5,0x72,0x0e,0x80,0x02,0x8e,0x06,0x72,
+        0x06,0x8e,0xfa,0x72,0xfe,0x7c,0xfe,0x7e,0xfe,0x7f,
+        0xff,0x00,0x0f,0x87,0x0e,0x8e,0xf5,0x72,0x00,0x8e,
+        0x0b,0x00,0xf5,0xf2,0x0b,0x00,0x03,0x80,0x09,0x99,
+        0xfe,0x7f,0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7e,
+        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xfe,0x7e,0x01,0x8e,
+        0xff,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,0x01,0x7e,
+        0x00,0x7e,0xff,0x7e,0xfc,0x7e,0x04,0x7e,0x01,0x7e,
+        0x00,0x7e,0xff,0x7e,0xff,0x7f,0xff,0x7e,0x00,0x7e,
+        0x01,0x7e,0xff,0x8e,0x02,0x7e,0x00,0x7e,0xff,0x7e,
+        0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,
+        0x02,0x7f,0x05,0x87,0x04,0x95,0x00,0x77,0x00,0xfd,
+        0x00,0x77,0x04,0x80,0x05,0x99,0x02,0x7f,0x01,0x7f,
+        0x01,0x7e,0x00,0x7e,0xff,0x7e,0xff,0x7f,0xff,0x7e,
+        0x00,0x7e,0x02,0x7e,0xff,0x8e,0x01,0x7e,0x00,0x7e,
+        0xff,0x7e,0xff,0x7f,0xff,0x7e,0x00,0x7e,0x01,0x7e,
+        0x04,0x7e,0xfc,0x7e,0xff,0x7e,0x00,0x7e,0x01,0x7e,
+        0x01,0x7f,0x01,0x7e,0x00,0x7e,0xff,0x7e,0x01,0x8e,
+        0xfe,0x7e,0x00,0x7e,0x01,0x7e,0x01,0x7f,0x01,0x7e,
+        0x00,0x7e,0xff,0x7e,0xff,0x7f,0xfe,0x7f,0x09,0x87,
+        0x03,0x86,0x00,0x02,0x01,0x03,0x02,0x01,0x02,0x00,
+        0x02,0x7f,0x04,0x7d,0x02,0x7f,0x02,0x00,0x02,0x01,
+        0x01,0x02,0xee,0xfe,0x01,0x02,0x02,0x01,0x02,0x00,
+        0x02,0x7f,0x04,0x7d,0x02,0x7f,0x02,0x00,0x02,0x01,
+        0x01,0x03,0x00,0x02,0x03,0xf4,0x10,0x80,0x03,0x80,
+        0x07,0x15,0x08,0x6b,0xfe,0x85,0xf5,0x00,0x10,0xfb,
+        0x0d,0x95,0xf6,0x00,0x00,0x6b,0x0a,0x00,0x02,0x02,
+        0x00,0x08,0xfe,0x02,0xf6,0x00,0x0e,0xf4,0x03,0x80,
+        0x00,0x15,0x0a,0x00,0x02,0x7e,0x00,0x7e,0x00,0x7d,
+        0x00,0x7e,0xfe,0x7f,0xf6,0x00,0x0a,0x80,0x02,0x7e,
+        0x01,0x7e,0x00,0x7d,0xff,0x7d,0xfe,0x7f,0xf6,0x00,
+        0x10,0x80,0x03,0x80,0x00,0x15,0x0c,0x00,0xff,0x7e,
+        0x03,0xed,0x03,0xfd,0x00,0x03,0x02,0x00,0x00,0x12,
+        0x02,0x03,0x0a,0x00,0x00,0x6b,0x02,0x00,0x00,0x7d,
+        0xfe,0x83,0xf4,0x00,0x11,0x80,0x0f,0x80,0xf4,0x00,
+        0x00,0x15,0x0c,0x00,0xff,0xf6,0xf5,0x00,0x0f,0xf5,
+        0x04,0x95,0x07,0x76,0x00,0x0a,0x07,0x80,0xf9,0x76,
+        0x00,0x75,0xf8,0x80,0x07,0x0c,0x09,0xf4,0xf9,0x0c,
+        0x09,0xf4,0x03,0x92,0x02,0x03,0x07,0x00,0x03,0x7d,
+        0x00,0x7b,0xfc,0x7e,0x04,0x7d,0x00,0x7a,0xfd,0x7e,
+        0xf9,0x00,0xfe,0x02,0x06,0x89,0x02,0x00,0x06,0xf5,
+        0x03,0x95,0x00,0x6b,0x0c,0x15,0x00,0x6b,0x02,0x80,
+        0x03,0x95,0x00,0x6b,0x0c,0x15,0x00,0x6b,0xf8,0x96,
+        0x03,0x00,0x07,0xea,0x03,0x80,0x00,0x15,0x0c,0x80,
+        0xf7,0x76,0xfd,0x00,0x03,0x80,0x0a,0x75,0x03,0x80,
+        0x03,0x80,0x07,0x13,0x02,0x02,0x03,0x00,0x00,0x6b,
+        0x02,0x80,0x03,0x80,0x00,0x15,0x09,0x6b,0x09,0x15,
+        0x00,0x6b,0x03,0x80,0x03,0x80,0x00,0x15,0x00,0xf6,
+        0x0d,0x00,0x00,0x8a,0x00,0x6b,0x03,0x80,0x07,0x80,
+        0xfd,0x00,0xff,0x03,0x00,0x04,0x00,0x07,0x00,0x04,
+        0x01,0x02,0x03,0x01,0x06,0x00,0x03,0x7f,0x01,0x7e,
+        0x01,0x7c,0x00,0x79,0xff,0x7c,0xff,0x7d,0xfd,0x00,
+        0xfa,0x00,0x0e,0x80,0x03,0x80,0x00,0x15,0x0c,0x00,
+        0x00,0x6b,0x02,0x80,0x03,0x80,0x00,0x15,0x0a,0x00,
+        0x02,0x7f,0x01,0x7d,0x00,0x7b,0xff,0x7e,0xfe,0x7f,
+        0xf6,0x00,0x10,0xf7,0x11,0x8f,0xff,0x03,0xff,0x02,
+        0xfe,0x01,0xfa,0x00,0xfd,0x7f,0xff,0x7e,0x00,0x7c,
+        0x00,0x79,0x00,0x7b,0x01,0x7e,0x03,0x00,0x06,0x00,
+        0x02,0x00,0x01,0x03,0x01,0x02,0x03,0xfb,0x03,0x95,
+        0x0c,0x00,0xfa,0x80,0x00,0x6b,0x09,0x80,0x03,0x95,
+        0x00,0x77,0x06,0x7a,0x06,0x06,0x00,0x09,0xfa,0xf1,
+        0xfa,0x7a,0x0e,0x80,0x03,0x87,0x00,0x0b,0x02,0x02,
+        0x03,0x00,0x02,0x7e,0x01,0x02,0x04,0x00,0x02,0x7e,
+        0x00,0x75,0xfe,0x7e,0xfc,0x00,0xff,0x01,0xfe,0x7f,
+        0xfd,0x00,0xfe,0x02,0x07,0x8e,0x00,0x6b,0x09,0x80,
+        0x03,0x80,0x0e,0x15,0xf2,0x80,0x0e,0x6b,0x03,0x80,
+        0x03,0x95,0x00,0x6b,0x0e,0x00,0x00,0x7d,0xfe,0x98,
+        0x00,0x6b,0x05,0x80,0x03,0x95,0x00,0x75,0x02,0x7d,
+        0x0a,0x00,0x00,0x8e,0x00,0x6b,0x02,0x80,0x03,0x95,
+        0x00,0x6b,0x10,0x00,0x00,0x15,0xf8,0x80,0x00,0x6b,
+        0x0a,0x80,0x03,0x95,0x00,0x6b,0x10,0x00,0x00,0x15,
+        0xf8,0x80,0x00,0x6b,0x0a,0x00,0x00,0x7d,0x02,0x83,
+        0x10,0x80,0x03,0x95,0x00,0x6b,0x09,0x00,0x03,0x02,
+        0x00,0x08,0xfd,0x02,0xf7,0x00,0x0e,0x89,0x00,0x6b,
+        0x03,0x80,0x03,0x95,0x00,0x6b,0x09,0x00,0x03,0x02,
+        0x00,0x08,0xfd,0x02,0xf7,0x00,0x0e,0xf4,0x03,0x92,
+        0x02,0x03,0x07,0x00,0x03,0x7d,0x00,0x70,0xfd,0x7e,
+        0xf9,0x00,0xfe,0x02,0x03,0x89,0x09,0x00,0x02,0xf5,
+        0x03,0x80,0x00,0x15,0x00,0xf5,0x07,0x00,0x00,0x08,
+        0x02,0x03,0x06,0x00,0x02,0x7d,0x00,0x70,0xfe,0x7e,
+        0xfa,0x00,0xfe,0x02,0x00,0x08,0x0c,0xf6,0x0f,0x80,
+        0x00,0x15,0xf6,0x00,0xfe,0x7d,0x00,0x79,0x02,0x7e,
+        0x0a,0x00,0xf4,0xf7,0x07,0x09,0x07,0xf7,0x03,0x8c,
+        0x01,0x02,0x01,0x01,0x05,0x00,0x02,0x7f,0x01,0x7e,
+        0x00,0x74,0x00,0x86,0xff,0x01,0xfe,0x01,0xfb,0x00,
+        0xff,0x7f,0xff,0x7f,0x00,0x7c,0x01,0x7e,0x01,0x00,
+        0x05,0x00,0x02,0x00,0x01,0x02,0x03,0xfe,0x04,0x8e,
+        0x02,0x01,0x04,0x00,0x02,0x7f,0x01,0x7e,0x00,0x77,
+        0xff,0x7e,0xfe,0x7f,0xfc,0x00,0xfe,0x01,0xff,0x02,
+        0x00,0x09,0x01,0x02,0x02,0x02,0x03,0x01,0x02,0x01,
+        0x01,0x01,0x01,0x02,0x02,0xeb,0x03,0x80,0x00,0x15,
+        0x03,0x00,0x02,0x7e,0x00,0x7b,0xfe,0x7e,0xfd,0x00,
+        0x03,0x80,0x04,0x00,0x03,0x7e,0x00,0x78,0xfd,0x7e,
+        0xf9,0x00,0x0c,0x80,0x03,0x8c,0x02,0x02,0x02,0x01,
+        0x03,0x00,0x02,0x7f,0x01,0x7d,0xfe,0x7e,0xf9,0x7d,
+        0xff,0x7e,0x00,0x7d,0x03,0x7f,0x02,0x00,0x03,0x01,
+        0x02,0x01,0x02,0xfe,0x0d,0x8c,0xff,0x02,0xfe,0x01,
+        0xfc,0x00,0xfe,0x7f,0xff,0x7e,0x00,0x77,0x01,0x7e,
+        0x02,0x7f,0x04,0x00,0x02,0x01,0x01,0x02,0x00,0x0f,
+        0xff,0x02,0xfe,0x01,0xf9,0x00,0x0c,0xeb,0x03,0x88,
+        0x0a,0x00,0x00,0x02,0x00,0x03,0xfe,0x02,0xfa,0x00,
+        0xff,0x7e,0xff,0x7d,0x00,0x7b,0x01,0x7c,0x01,0x7f,
+        0x06,0x00,0x02,0x02,0x03,0xfe,0x03,0x8f,0x06,0x77,
+        0x06,0x09,0xfa,0x80,0x00,0x71,0xff,0x87,0xfb,0x79,
+        0x07,0x87,0x05,0x79,0x02,0x80,0x03,0x8d,0x02,0x02,
+        0x06,0x00,0x02,0x7e,0x00,0x7d,0xfc,0x7d,0x04,0x7e,
+        0x00,0x7d,0xfe,0x7e,0xfa,0x00,0xfe,0x02,0x04,0x85,
+        0x02,0x00,0x06,0xf9,0x03,0x8f,0x00,0x73,0x01,0x7e,
+        0x07,0x00,0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,
+        0x03,0x80,0x03,0x8f,0x00,0x73,0x01,0x7e,0x07,0x00,
+        0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,0xf8,0x90,
+        0x03,0x00,0x08,0xf0,0x03,0x80,0x00,0x15,0x00,0xf3,
+        0x02,0x00,0x06,0x07,0xfa,0xf9,0x07,0x78,0x03,0x80,
+        0x03,0x80,0x04,0x0c,0x02,0x03,0x04,0x00,0x00,0x71,
+        0x02,0x80,0x03,0x80,0x00,0x0f,0x06,0x77,0x06,0x09,
+        0x00,0x71,0x02,0x80,0x03,0x80,0x00,0x0f,0x0a,0xf1,
+        0x00,0x0f,0xf6,0xf8,0x0a,0x00,0x02,0xf9,0x05,0x80,
+        0xff,0x01,0xff,0x04,0x00,0x05,0x01,0x03,0x01,0x02,
+        0x06,0x00,0x02,0x7e,0x00,0x7d,0x00,0x7b,0x00,0x7c,
+        0xfe,0x7f,0xfa,0x00,0x0b,0x80,0x03,0x80,0x00,0x0f,
+        0x00,0xfb,0x01,0x03,0x01,0x02,0x05,0x00,0x02,0x7e,
+        0x01,0x7d,0x00,0x76,0x03,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,0x10,0x80,
+        0x10,0x80,0x0a,0x8f,0x02,0x7f,0x01,0x7e,0x00,0x76,
+        0xff,0x7f,0xfe,0x7f,0xfb,0x00,0xff,0x01,0xff,0x01,
+        0x00,0x0a,0x01,0x02,0x01,0x01,0x05,0x00,0xf9,0x80,
+        0x00,0x6b,0x0c,0x86,0x0d,0x8a,0xff,0x03,0xfe,0x02,
+        0xfb,0x00,0xff,0x7e,0xff,0x7d,0x00,0x7b,0x01,0x7c,
+        0x01,0x7f,0x05,0x00,0x02,0x01,0x01,0x03,0x03,0xfc,
+        0x03,0x80,0x00,0x0f,0x00,0xfb,0x01,0x03,0x01,0x02,
+        0x04,0x00,0x01,0x7e,0x01,0x7d,0x00,0x76,0x00,0x8a,
+        0x01,0x03,0x02,0x02,0x03,0x00,0x02,0x7e,0x01,0x7d,
+        0x00,0x76,0x03,0x80,0x03,0x8f,0x00,0x74,0x01,0x7e,
+        0x02,0x7f,0x04,0x00,0x02,0x01,0x01,0x01,0x00,0x8d,
+        0x00,0x6e,0xff,0x7e,0xfe,0x7f,0xfb,0x00,0xfe,0x01,
+        0x0c,0x85,0x03,0x8d,0x01,0x02,0x03,0x00,0x02,0x7e,
+        0x01,0x02,0x03,0x00,0x02,0x7e,0x00,0x74,0xfe,0x7f,
+        0xfd,0x00,0xff,0x01,0xfe,0x7f,0xfd,0x00,0xff,0x01,
+        0x00,0x0c,0x06,0x82,0x00,0x6b,0x08,0x86,0x03,0x80,
+        0x0a,0x0f,0xf6,0x80,0x0a,0x71,0x03,0x80,0x03,0x8f,
+        0x00,0x73,0x01,0x7e,0x07,0x00,0x02,0x02,0x00,0x0d,
+        0x00,0xf3,0x01,0x7e,0x00,0x7e,0x03,0x82,0x03,0x8f,
+        0x00,0x79,0x02,0x7e,0x08,0x00,0x00,0x89,0x00,0x71,
+        0x02,0x80,0x03,0x8f,0x00,0x73,0x01,0x7e,0x03,0x00,
+        0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,0x03,0x00,
+        0x02,0x02,0x00,0x0d,0x00,0xf3,0x01,0x7e,0x03,0x80,
+        0x03,0x8f,0x00,0x73,0x01,0x7e,0x03,0x00,0x02,0x02,
+        0x00,0x0d,0x00,0xf3,0x01,0x7e,0x03,0x00,0x02,0x02,
+        0x00,0x0d,0x00,0xf3,0x01,0x7e,0x00,0x7e,0x03,0x82,
+        0x03,0x8d,0x00,0x02,0x02,0x00,0x00,0x71,0x08,0x00,
+        0x02,0x02,0x00,0x06,0xfe,0x02,0xf8,0x00,0x0c,0xf6,
+        0x03,0x8f,0x00,0x71,0x07,0x00,0x02,0x02,0x00,0x06,
+        0xfe,0x02,0xf9,0x00,0x0c,0x85,0x00,0x71,0x02,0x80,
+        0x03,0x8f,0x00,0x71,0x07,0x00,0x03,0x02,0x00,0x06,
+        0xfd,0x02,0xf9,0x00,0x0c,0xf6,0x03,0x8d,0x02,0x02,
+        0x06,0x00,0x02,0x7e,0x00,0x75,0xfe,0x7e,0xfa,0x00,
+        0xfe,0x02,0x04,0x85,0x06,0x00,0x02,0xf9,0x03,0x80,
+        0x00,0x0f,0x00,0xf8,0x04,0x00,0x00,0x06,0x02,0x02,
+        0x04,0x00,0x02,0x7e,0x00,0x75,0xfe,0x7e,0xfc,0x00,
+        0xfe,0x02,0x00,0x05,0x0a,0xf9,0x0d,0x80,0x00,0x0f,
+        0xf7,0x00,0xff,0x7e,0x00,0x7b,0x01,0x7e,0x09,0x00,
+        0xf6,0xfa,0x04,0x06,0x08,0xfa
+    };
+
+    //-------------------------------------------------------------------------
+    gsv_text::gsv_text() :
+      m_x(0.0),
+      m_y(0.0),
+      m_start_x(0.0),
+      m_width(10.0),
+      m_height(0.0),
+      m_space(0.0),
+      m_line_space(0.0),
+      m_text(m_chr),
+      m_text_buf(),
+      m_cur_chr(m_chr),
+      m_font(gsv_default_font),
+      m_loaded_font(),
+      m_status(initial),
+      m_big_endian(false),
+      m_flip(false)
+    {
+        m_chr[0] = m_chr[1] = 0;
+
+        int t = 1;
+        if(*(char*)&t == 0) m_big_endian = true;
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::font(const void* font)
+    {
+        m_font = font;
+        if(m_font == 0) m_font = &m_loaded_font[0];
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::size(double height, double width)
+    {
+        m_height = height;
+        m_width  = width;
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::space(double space)
+    {
+        m_space = space;
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::line_space(double line_space)
+    {
+        m_line_space = line_space;
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::start_point(double x, double y)
+    {
+        m_x = m_start_x = x;
+        m_y = y;
+        //if(m_flip) m_y += m_height;
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::load_font(const char* file)
+    {
+        m_loaded_font.resize(0);
+        FILE* fd = fopen(file, "rb");
+        if(fd)
+        {
+            unsigned len;
+
+            fseek(fd, 0l, SEEK_END);
+            len = ftell(fd);
+            fseek(fd, 0l, SEEK_SET);
+            if(len > 0)
+            {
+                m_loaded_font.resize(len);
+                fread(&m_loaded_font[0], 1, len, fd);
+                m_font = &m_loaded_font[0];
+            }
+            fclose(fd);
+        }
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::text(const char* text)
+    {
+        if(text == 0)
+        {
+            m_chr[0] = 0;
+            m_text = m_chr;
+            return;
+        }
+        unsigned new_size = strlen(text) + 1;
+        if(new_size > m_text_buf.size())
+        {
+            m_text_buf.resize(new_size);
+        }
+        memcpy(&m_text_buf[0], text, new_size);
+        m_text = &m_text_buf[0];
+    }
+
+    //-------------------------------------------------------------------------
+    void gsv_text::rewind(unsigned)
+    {
+        m_status = initial;
+        if(m_font == 0) return;
+        
+        m_indices = (int8u*)m_font;
+        double base_height = value(m_indices + 4);
+        m_indices += value(m_indices);
+        m_glyphs = (int8*)(m_indices + 257*2);
+        m_h = m_height / base_height;
+        m_w = (m_width == 0.0) ? m_h : m_width / base_height;
+        if(m_flip) m_h = -m_h;
+        m_cur_chr = m_text;
+    }
+
+    //-------------------------------------------------------------------------
+    unsigned gsv_text::vertex(double* x, double* y)
+    {
+        unsigned idx;
+        int8 yc, yf;
+        int dx, dy;
+        bool quit = false;
+        
+        while(!quit)
+        {
+            switch(m_status)
+            {
+            case initial:
+                if(m_font == 0) 
+                {
+                    quit = true;
+                    break;
+                }
+                m_status = next_char;
+
+            case next_char:
+                if(*m_cur_chr == 0) 
+                {
+                    quit = true;
+                    break;
+                }
+                idx = (*m_cur_chr++) & 0xFF;
+                if(idx == '\n')
+                {
+                    m_x = m_start_x;
+                    m_y -= m_flip ? -m_height - m_line_space : m_height + m_line_space;
+                    break;
+                }
+                idx <<= 1;
+                m_bglyph = m_glyphs + value(m_indices + idx);
+                m_eglyph = m_glyphs + value(m_indices + idx + 2);
+                m_status = start_glyph;
+
+            case start_glyph:
+                *x = m_x;
+                *y = m_y;
+                m_status = glyph;
+                return path_cmd_move_to;
+
+            case glyph:
+                if(m_bglyph >= m_eglyph)
+                {
+                    m_status = next_char;
+                    m_x += m_space;
+                    break;
+                }
+                dx = int(*m_bglyph++);
+                yf = (yc = *m_bglyph++) & 0x80;
+                yc <<= 1; 
+                yc >>= 1;
+                dy = int(yc);
+                m_x += double(dx) * m_w;
+                m_y += double(dy) * m_h;
+                *x = m_x;
+                *y = m_y;
+                return yf ? path_cmd_move_to : path_cmd_line_to;
+            }
+
+        }
+        return path_cmd_stop;
+    }
+
+    //-------------------------------------------------------------------------
+    double gsv_text::text_width()
+    {
+        double x1, y1, x2, y2;
+        bounding_rect_single(*this, 0, &x1, &y1, &x2, &y2);
+        return x2 - x1;
+    }
+
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_image_filters.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_image_filters.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_image_filters.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_image_filters.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,103 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Filtering class image_filter_lut implemantation
+//
+//----------------------------------------------------------------------------
+
+
+#include "../include/agg_image_filters.h"
+
+
+namespace mapserver
+{
+    //--------------------------------------------------------------------
+    void image_filter_lut::realloc_lut(double radius)
+    {
+        m_radius = radius;
+        m_diameter = uceil(radius) * 2;
+        m_start = -int(m_diameter / 2 - 1);
+        unsigned size = m_diameter << image_subpixel_shift;
+        if(size > m_weight_array.size())
+        {
+            m_weight_array.resize(size);
+        }
+    }
+
+
+
+    //--------------------------------------------------------------------
+    // This function normalizes integer values and corrects the rounding 
+    // errors. It doesn't do anything with the source floating point values
+    // (m_weight_array_dbl), it corrects only integers according to the rule 
+    // of 1.0 which means that any sum of pixel weights must be equal to 1.0.
+    // So, the filter function must produce a graph of the proper shape.
+    //--------------------------------------------------------------------
+    void image_filter_lut::normalize()
+    {
+        unsigned i;
+        int flip = 1;
+
+        for(i = 0; i < image_subpixel_scale; i++)
+        {
+            for(;;)
+            {
+                int sum = 0;
+                unsigned j;
+                for(j = 0; j < m_diameter; j++)
+                {
+                    sum += m_weight_array[j * image_subpixel_scale + i];
+                }
+
+                if(sum == image_filter_scale) break;
+
+                double k = double(image_filter_scale) / double(sum);
+                sum = 0;
+                for(j = 0; j < m_diameter; j++)
+                {
+                    sum +=     m_weight_array[j * image_subpixel_scale + i] = 
+                        iround(m_weight_array[j * image_subpixel_scale + i] * k);
+                }
+
+                sum -= image_filter_scale;
+                int inc = (sum > 0) ? -1 : 1;
+
+                for(j = 0; j < m_diameter && sum; j++)
+                {
+                    flip ^= 1;
+                    unsigned idx = flip ? m_diameter/2 + j/2 : m_diameter/2 - j/2;
+                    int v = m_weight_array[idx * image_subpixel_scale + i];
+                    if(v < image_filter_scale)
+                    {
+                        m_weight_array[idx * image_subpixel_scale + i] += inc;
+                        sum += inc;
+                    }
+                }
+            }
+        }
+
+        unsigned pivot = m_diameter << (image_subpixel_shift - 1);
+
+        for(i = 0; i < pivot; i++)
+        {
+            m_weight_array[pivot + i] = m_weight_array[pivot - i];
+        }
+        unsigned end = (diameter() << image_subpixel_shift) - 1;
+        m_weight_array[0] = m_weight_array[end];
+    }
+
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_line_aa_basics.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_line_aa_basics.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_line_aa_basics.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_line_aa_basics.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,82 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_line_aa_basics.h"
+
+namespace mapserver
+{
+    //-------------------------------------------------------------------------
+    // The number of the octant is determined as a 3-bit value as follows:
+    // bit 0 = vertical flag
+    // bit 1 = sx < 0
+    // bit 2 = sy < 0
+    //
+    // [N] shows the number of the orthogonal quadrant
+    // <M> shows the number of the diagonal quadrant
+    //               <1>
+    //   [1]          |          [0]
+    //       . (3)011 | 001(1) .
+    //         .      |      .
+    //           .    |    . 
+    //             .  |  . 
+    //    (2)010     .|.     000(0)
+    // <2> ----------.+.----------- <0>
+    //    (6)110   .  |  .   100(4)
+    //           .    |    .
+    //         .      |      .
+    //       .        |        .
+    //         (7)111 | 101(5) 
+    //   [2]          |          [3]
+    //               <3> 
+    //                                                        0,1,2,3,4,5,6,7 
+    const int8u line_parameters::s_orthogonal_quadrant[8] = { 0,0,1,1,3,3,2,2 };
+    const int8u line_parameters::s_diagonal_quadrant[8]   = { 0,1,2,1,0,3,2,3 };
+
+
+
+    //-------------------------------------------------------------------------
+    void bisectrix(const line_parameters& l1, 
+                   const line_parameters& l2, 
+                   int* x, int* y)
+    {
+        double k = double(l2.len) / double(l1.len);
+        double tx = l2.x2 - (l2.x1 - l1.x1) * k;
+        double ty = l2.y2 - (l2.y1 - l1.y1) * k;
+
+        //All bisectrices must be on the right of the line
+        //If the next point is on the left (l1 => l2.2)
+        //then the bisectix should be rotated by 180 degrees.
+        if(double(l2.x2 - l2.x1) * double(l2.y1 - l1.y1) <
+           double(l2.y2 - l2.y1) * double(l2.x1 - l1.x1) + 100.0)
+        {
+            tx -= (tx - l2.x1) * 2.0;
+            ty -= (ty - l2.y1) * 2.0;
+        }
+
+        // Check if the bisectrix is too short
+        double dx = tx - l2.x1;
+        double dy = ty - l2.y1;
+        if((int)sqrt(dx * dx + dy * dy) < line_subpixel_scale)
+        {
+            *x = (l2.x1 + l2.x1 + (l2.y1 - l1.y1) + (l2.y2 - l2.y1)) >> 1;
+            *y = (l2.y1 + l2.y1 - (l2.x1 - l1.x1) - (l2.x2 - l2.x1)) >> 1;
+            return;
+        }
+        *x = iround(tx);
+        *y = iround(ty);
+    }
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_line_profile_aa.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_line_profile_aa.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_line_profile_aa.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_line_profile_aa.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,116 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include "../include/agg_renderer_outline_aa.h"
+
+namespace mapserver
+{
+
+    //---------------------------------------------------------------------
+    void line_profile_aa::width(double w)
+    {
+        if(w < 0.0) w = 0.0;
+
+        if(w < m_smoother_width) w += w;
+        else                     w += m_smoother_width;
+
+        w *= 0.5;
+
+        w -= m_smoother_width;
+        double s = m_smoother_width;
+        if(w < 0.0) 
+        {
+            s += w;
+            w = 0.0;
+        }
+        set(w, s);
+    }
+
+
+    //---------------------------------------------------------------------
+    line_profile_aa::value_type* line_profile_aa::profile(double w)
+    {
+        m_subpixel_width = uround(w * subpixel_scale);
+        unsigned size = m_subpixel_width + subpixel_scale * 6;
+        if(size > m_profile.size())
+        {
+            m_profile.resize(size);
+        }
+        return &m_profile[0];
+    }
+
+
+    //---------------------------------------------------------------------
+    void line_profile_aa::set(double center_width, double smoother_width)
+    {
+        double base_val = 1.0;
+        if(center_width == 0.0)   center_width = 1.0 / subpixel_scale;
+        if(smoother_width == 0.0) smoother_width = 1.0 / subpixel_scale;
+
+        double width = center_width + smoother_width;
+        if(width < m_min_width)
+        {
+            double k = width / m_min_width;
+            base_val *= k;
+            center_width /= k;
+            smoother_width /= k;
+        }
+
+        value_type* ch = profile(center_width + smoother_width);
+
+        unsigned subpixel_center_width = unsigned(center_width * subpixel_scale);
+        unsigned subpixel_smoother_width = unsigned(smoother_width * subpixel_scale);
+
+        value_type* ch_center   = ch + subpixel_scale*2;
+        value_type* ch_smoother = ch_center + subpixel_center_width;
+
+        unsigned i;
+
+        unsigned val = m_gamma[unsigned(base_val * aa_mask)];
+        ch = ch_center;
+        for(i = 0; i < subpixel_center_width; i++)
+        {
+            *ch++ = (value_type)val;
+        }
+
+        for(i = 0; i < subpixel_smoother_width; i++)
+        {
+            *ch_smoother++ = 
+                m_gamma[unsigned((base_val - 
+                                  base_val * 
+                                  (double(i) / subpixel_smoother_width)) * aa_mask)];
+        }
+
+        unsigned n_smoother = profile_size() - 
+                              subpixel_smoother_width - 
+                              subpixel_center_width - 
+                              subpixel_scale*2;
+
+        val = m_gamma[0];
+        for(i = 0; i < n_smoother; i++)
+        {
+            *ch_smoother++ = (value_type)val;
+        }
+
+        ch = ch_center;
+        for(i = 0; i < subpixel_scale*2; i++)
+        {
+            *--ch = *ch_center++;
+        }
+    }
+
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_rounded_rect.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_rounded_rect.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_rounded_rect.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_rounded_rect.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,164 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Rounded rectangle vertex generator
+//
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_rounded_rect.h"
+
+
+namespace mapserver
+{
+    //------------------------------------------------------------------------
+    rounded_rect::rounded_rect(double x1, double y1, double x2, double y2, double r) :
+        m_x1(x1), m_y1(y1), m_x2(x2), m_y2(y2),
+        m_rx1(r), m_ry1(r), m_rx2(r), m_ry2(r), 
+        m_rx3(r), m_ry3(r), m_rx4(r), m_ry4(r)
+    {
+        if(x1 > x2) { m_x1 = x2; m_x2 = x1; }
+        if(y1 > y2) { m_y1 = y2; m_y2 = y1; }
+    }
+
+    //--------------------------------------------------------------------
+    void rounded_rect::rect(double x1, double y1, double x2, double y2)
+    {
+        m_x1 = x1;
+        m_y1 = y1;
+        m_x2 = x2;
+        m_y2 = y2;
+        if(x1 > x2) { m_x1 = x2; m_x2 = x1; }
+        if(y1 > y2) { m_y1 = y2; m_y2 = y1; }
+    }
+
+    //--------------------------------------------------------------------
+    void rounded_rect::radius(double r)
+    {
+        m_rx1 = m_ry1 = m_rx2 = m_ry2 = m_rx3 = m_ry3 = m_rx4 = m_ry4 = r; 
+    }
+
+    //--------------------------------------------------------------------
+    void rounded_rect::radius(double rx, double ry)
+    {
+        m_rx1 = m_rx2 = m_rx3 = m_rx4 = rx; 
+        m_ry1 = m_ry2 = m_ry3 = m_ry4 = ry; 
+    }
+
+    //--------------------------------------------------------------------
+    void rounded_rect::radius(double rx_bottom, double ry_bottom, 
+                              double rx_top,    double ry_top)
+    {
+        m_rx1 = m_rx2 = rx_bottom; 
+        m_rx3 = m_rx4 = rx_top; 
+        m_ry1 = m_ry2 = ry_bottom; 
+        m_ry3 = m_ry4 = ry_top; 
+    }
+
+    //--------------------------------------------------------------------
+    void rounded_rect::radius(double rx1, double ry1, double rx2, double ry2, 
+                              double rx3, double ry3, double rx4, double ry4)
+    {
+        m_rx1 = rx1; m_ry1 = ry1; m_rx2 = rx2; m_ry2 = ry2; 
+        m_rx3 = rx3; m_ry3 = ry3; m_rx4 = rx4; m_ry4 = ry4;
+    }
+
+    //--------------------------------------------------------------------
+    void rounded_rect::normalize_radius()
+    {
+        double dx = fabs(m_y2 - m_y1);
+        double dy = fabs(m_x2 - m_x1);
+
+        double k = 1.0;
+        double t;
+        t = dx / (m_rx1 + m_rx2); if(t < k) k = t; 
+        t = dx / (m_rx3 + m_rx4); if(t < k) k = t; 
+        t = dy / (m_ry1 + m_ry2); if(t < k) k = t; 
+        t = dy / (m_ry3 + m_ry4); if(t < k) k = t; 
+
+        if(k < 1.0)
+        {
+            m_rx1 *= k; m_ry1 *= k; m_rx2 *= k; m_ry2 *= k;
+            m_rx3 *= k; m_ry3 *= k; m_rx4 *= k; m_ry4 *= k;
+        }
+    }
+
+    //--------------------------------------------------------------------
+    void rounded_rect::rewind(unsigned)
+    {
+        m_status = 0;
+    }
+
+    //--------------------------------------------------------------------
+    unsigned rounded_rect::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_stop;
+        switch(m_status)
+        {
+        case 0:
+            m_arc.init(m_x1 + m_rx1, m_y1 + m_ry1, m_rx1, m_ry1,
+                       pi, pi+pi*0.5);
+            m_arc.rewind(0);
+            m_status++;
+
+        case 1:
+            cmd = m_arc.vertex(x, y);
+            if(is_stop(cmd)) m_status++;
+            else return cmd;
+
+        case 2:
+            m_arc.init(m_x2 - m_rx2, m_y1 + m_ry2, m_rx2, m_ry2,
+                       pi+pi*0.5, 0.0);
+            m_arc.rewind(0);
+            m_status++;
+
+        case 3:
+            cmd = m_arc.vertex(x, y);
+            if(is_stop(cmd)) m_status++;
+            else return path_cmd_line_to;
+
+        case 4:
+            m_arc.init(m_x2 - m_rx3, m_y2 - m_ry3, m_rx3, m_ry3,
+                       0.0, pi*0.5);
+            m_arc.rewind(0);
+            m_status++;
+
+        case 5:
+            cmd = m_arc.vertex(x, y);
+            if(is_stop(cmd)) m_status++;
+            else return path_cmd_line_to;
+
+        case 6:
+            m_arc.init(m_x1 + m_rx4, m_y2 - m_ry4, m_rx4, m_ry4,
+                       pi*0.5, pi);
+            m_arc.rewind(0);
+            m_status++;
+
+        case 7:
+            cmd = m_arc.vertex(x, y);
+            if(is_stop(cmd)) m_status++;
+            else return path_cmd_line_to;
+
+        case 8:
+            cmd = path_cmd_end_poly | path_flags_close | path_flags_ccw;
+            m_status++;
+            break;
+        }
+        return cmd;
+    }
+
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_sqrt_tables.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_sqrt_tables.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_sqrt_tables.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_sqrt_tables.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,115 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// static tables for fast integer sqrt
+//
+//----------------------------------------------------------------------------
+
+#include "../include/agg_basics.h"
+
+namespace mapserver
+{
+    int16u g_sqrt_table[1024] =                       //----------g_sqrt_table
+    {
+        0,
+        2048,2896,3547,4096,4579,5017,5418,5793,6144,6476,6792,7094,7384,7663,7932,8192,8444,
+        8689,8927,9159,9385,9606,9822,10033,10240,10443,10642,10837,11029,11217,11403,11585,
+        11765,11942,12116,12288,12457,12625,12790,12953,13114,13273,13430,13585,13738,13890,
+        14040,14189,14336,14482,14626,14768,14910,15050,15188,15326,15462,15597,15731,15864,
+        15995,16126,16255,16384,16512,16638,16764,16888,17012,17135,17257,17378,17498,17618,
+        17736,17854,17971,18087,18203,18318,18432,18545,18658,18770,18882,18992,19102,19212,
+        19321,19429,19537,19644,19750,19856,19961,20066,20170,20274,20377,20480,20582,20684,
+        20785,20886,20986,21085,21185,21283,21382,21480,21577,21674,21771,21867,21962,22058,
+        22153,22247,22341,22435,22528,22621,22713,22806,22897,22989,23080,23170,23261,23351,
+        23440,23530,23619,23707,23796,23884,23971,24059,24146,24232,24319,24405,24491,24576,
+        24661,24746,24831,24915,24999,25083,25166,25249,25332,25415,25497,25580,25661,25743,
+        25824,25905,25986,26067,26147,26227,26307,26387,26466,26545,26624,26703,26781,26859,
+        26937,27015,27092,27170,27247,27324,27400,27477,27553,27629,27705,27780,27856,27931,
+        28006,28081,28155,28230,28304,28378,28452,28525,28599,28672,28745,28818,28891,28963,
+        29035,29108,29180,29251,29323,29394,29466,29537,29608,29678,29749,29819,29890,29960,
+        30030,30099,30169,30238,30308,30377,30446,30515,30583,30652,30720,30788,30856,30924,
+        30992,31059,31127,31194,31261,31328,31395,31462,31529,31595,31661,31727,31794,31859,
+        31925,31991,32056,32122,32187,32252,32317,32382,32446,32511,32575,32640,32704,32768,
+        32832,32896,32959,33023,33086,33150,33213,33276,33339,33402,33465,33527,33590,33652,
+        33714,33776,33839,33900,33962,34024,34086,34147,34208,34270,34331,34392,34453,34514,
+        34574,34635,34695,34756,34816,34876,34936,34996,35056,35116,35176,35235,35295,35354,
+        35413,35472,35531,35590,35649,35708,35767,35825,35884,35942,36001,36059,36117,36175,
+        36233,36291,36348,36406,36464,36521,36578,36636,36693,36750,36807,36864,36921,36978,
+        37034,37091,37147,37204,37260,37316,37372,37429,37485,37540,37596,37652,37708,37763,
+        37819,37874,37929,37985,38040,38095,38150,38205,38260,38315,38369,38424,38478,38533,
+        38587,38642,38696,38750,38804,38858,38912,38966,39020,39073,39127,39181,39234,39287,
+        39341,39394,39447,39500,39553,39606,39659,39712,39765,39818,39870,39923,39975,40028,
+        40080,40132,40185,40237,40289,40341,40393,40445,40497,40548,40600,40652,40703,40755,
+        40806,40857,40909,40960,41011,41062,41113,41164,41215,41266,41317,41368,41418,41469,
+        41519,41570,41620,41671,41721,41771,41821,41871,41922,41972,42021,42071,42121,42171,
+        42221,42270,42320,42369,42419,42468,42518,42567,42616,42665,42714,42763,42813,42861,
+        42910,42959,43008,43057,43105,43154,43203,43251,43300,43348,43396,43445,43493,43541,
+        43589,43637,43685,43733,43781,43829,43877,43925,43972,44020,44068,44115,44163,44210,
+        44258,44305,44352,44400,44447,44494,44541,44588,44635,44682,44729,44776,44823,44869,
+        44916,44963,45009,45056,45103,45149,45195,45242,45288,45334,45381,45427,45473,45519,
+        45565,45611,45657,45703,45749,45795,45840,45886,45932,45977,46023,46069,46114,46160,
+        46205,46250,46296,46341,46386,46431,46477,46522,46567,46612,46657,46702,46746,46791,
+        46836,46881,46926,46970,47015,47059,47104,47149,47193,47237,47282,47326,47370,47415,
+        47459,47503,47547,47591,47635,47679,47723,47767,47811,47855,47899,47942,47986,48030,
+        48074,48117,48161,48204,48248,48291,48335,48378,48421,48465,48508,48551,48594,48637,
+        48680,48723,48766,48809,48852,48895,48938,48981,49024,49067,49109,49152,49195,49237,
+        49280,49322,49365,49407,49450,49492,49535,49577,49619,49661,49704,49746,49788,49830,
+        49872,49914,49956,49998,50040,50082,50124,50166,50207,50249,50291,50332,50374,50416,
+        50457,50499,50540,50582,50623,50665,50706,50747,50789,50830,50871,50912,50954,50995,
+        51036,51077,51118,51159,51200,51241,51282,51323,51364,51404,51445,51486,51527,51567,
+        51608,51649,51689,51730,51770,51811,51851,51892,51932,51972,52013,52053,52093,52134,
+        52174,52214,52254,52294,52334,52374,52414,52454,52494,52534,52574,52614,52654,52694,
+        52734,52773,52813,52853,52892,52932,52972,53011,53051,53090,53130,53169,53209,53248,
+        53287,53327,53366,53405,53445,53484,53523,53562,53601,53640,53679,53719,53758,53797,
+        53836,53874,53913,53952,53991,54030,54069,54108,54146,54185,54224,54262,54301,54340,
+        54378,54417,54455,54494,54532,54571,54609,54647,54686,54724,54762,54801,54839,54877,
+        54915,54954,54992,55030,55068,55106,55144,55182,55220,55258,55296,55334,55372,55410,
+        55447,55485,55523,55561,55599,55636,55674,55712,55749,55787,55824,55862,55900,55937,
+        55975,56012,56049,56087,56124,56162,56199,56236,56273,56311,56348,56385,56422,56459,
+        56497,56534,56571,56608,56645,56682,56719,56756,56793,56830,56867,56903,56940,56977,
+        57014,57051,57087,57124,57161,57198,57234,57271,57307,57344,57381,57417,57454,57490,
+        57527,57563,57599,57636,57672,57709,57745,57781,57817,57854,57890,57926,57962,57999,
+        58035,58071,58107,58143,58179,58215,58251,58287,58323,58359,58395,58431,58467,58503,
+        58538,58574,58610,58646,58682,58717,58753,58789,58824,58860,58896,58931,58967,59002,
+        59038,59073,59109,59144,59180,59215,59251,59286,59321,59357,59392,59427,59463,59498,
+        59533,59568,59603,59639,59674,59709,59744,59779,59814,59849,59884,59919,59954,59989,
+        60024,60059,60094,60129,60164,60199,60233,60268,60303,60338,60373,60407,60442,60477,
+        60511,60546,60581,60615,60650,60684,60719,60753,60788,60822,60857,60891,60926,60960,
+        60995,61029,61063,61098,61132,61166,61201,61235,61269,61303,61338,61372,61406,61440,
+        61474,61508,61542,61576,61610,61644,61678,61712,61746,61780,61814,61848,61882,61916,
+        61950,61984,62018,62051,62085,62119,62153,62186,62220,62254,62287,62321,62355,62388,
+        62422,62456,62489,62523,62556,62590,62623,62657,62690,62724,62757,62790,62824,62857,
+        62891,62924,62957,62991,63024,63057,63090,63124,63157,63190,63223,63256,63289,63323,
+        63356,63389,63422,63455,63488,63521,63554,63587,63620,63653,63686,63719,63752,63785,
+        63817,63850,63883,63916,63949,63982,64014,64047,64080,64113,64145,64178,64211,64243,
+        64276,64309,64341,64374,64406,64439,64471,64504,64536,64569,64601,64634,64666,64699,
+        64731,64763,64796,64828,64861,64893,64925,64957,64990,65022,65054,65086,65119,65151,
+        65183,65215,65247,65279,65312,65344,65376,65408,65440,65472,65504
+    };
+
+
+    int8 g_elder_bit_table[256] =          //---------g_elder_bit_table
+    {
+        0,0,1,1,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
+        5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
+        6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
+        6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
+        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
+        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
+        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
+        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
+    };
+ 
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_svg_parser.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_svg_parser.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_svg_parser.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_svg_parser.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,886 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// SVG parser.
+//
+//----------------------------------------------------------------------------
+
+#include <stdio.h>
+#include <string.h>
+#include <ctype.h>
+#include "agg_svg_parser.h"
+#include "expat.h"
+
+namespace mapserver
+{
+namespace svg
+{
+    struct named_color
+    {
+        char  name[22];
+        int8u r, g, b, a;
+    };
+
+    named_color colors[] = 
+    {
+        { "aliceblue",240,248,255, 255 },
+        { "antiquewhite",250,235,215, 255 },
+        { "aqua",0,255,255, 255 },
+        { "aquamarine",127,255,212, 255 },
+        { "azure",240,255,255, 255 },
+        { "beige",245,245,220, 255 },
+        { "bisque",255,228,196, 255 },
+        { "black",0,0,0, 255 },
+        { "blanchedalmond",255,235,205, 255 },
+        { "blue",0,0,255, 255 },
+        { "blueviolet",138,43,226, 255 },
+        { "brown",165,42,42, 255 },
+        { "burlywood",222,184,135, 255 },
+        { "cadetblue",95,158,160, 255 },
+        { "chartreuse",127,255,0, 255 },
+        { "chocolate",210,105,30, 255 },
+        { "coral",255,127,80, 255 },
+        { "cornflowerblue",100,149,237, 255 },
+        { "cornsilk",255,248,220, 255 },
+        { "crimson",220,20,60, 255 },
+        { "cyan",0,255,255, 255 },
+        { "darkblue",0,0,139, 255 },
+        { "darkcyan",0,139,139, 255 },
+        { "darkgoldenrod",184,134,11, 255 },
+        { "darkgray",169,169,169, 255 },
+        { "darkgreen",0,100,0, 255 },
+        { "darkgrey",169,169,169, 255 },
+        { "darkkhaki",189,183,107, 255 },
+        { "darkmagenta",139,0,139, 255 },
+        { "darkolivegreen",85,107,47, 255 },
+        { "darkorange",255,140,0, 255 },
+        { "darkorchid",153,50,204, 255 },
+        { "darkred",139,0,0, 255 },
+        { "darksalmon",233,150,122, 255 },
+        { "darkseagreen",143,188,143, 255 },
+        { "darkslateblue",72,61,139, 255 },
+        { "darkslategray",47,79,79, 255 },
+        { "darkslategrey",47,79,79, 255 },
+        { "darkturquoise",0,206,209, 255 },
+        { "darkviolet",148,0,211, 255 },
+        { "deeppink",255,20,147, 255 },
+        { "deepskyblue",0,191,255, 255 },
+        { "dimgray",105,105,105, 255 },
+        { "dimgrey",105,105,105, 255 },
+        { "dodgerblue",30,144,255, 255 },
+        { "firebrick",178,34,34, 255 },
+        { "floralwhite",255,250,240, 255 },
+        { "forestgreen",34,139,34, 255 },
+        { "fuchsia",255,0,255, 255 },
+        { "gainsboro",220,220,220, 255 },
+        { "ghostwhite",248,248,255, 255 },
+        { "gold",255,215,0, 255 },
+        { "goldenrod",218,165,32, 255 },
+        { "gray",128,128,128, 255 },
+        { "green",0,128,0, 255 },
+        { "greenyellow",173,255,47, 255 },
+        { "grey",128,128,128, 255 },
+        { "honeydew",240,255,240, 255 },
+        { "hotpink",255,105,180, 255 },
+        { "indianred",205,92,92, 255 },
+        { "indigo",75,0,130, 255 },
+        { "ivory",255,255,240, 255 },
+        { "khaki",240,230,140, 255 },
+        { "lavender",230,230,250, 255 },
+        { "lavenderblush",255,240,245, 255 },
+        { "lawngreen",124,252,0, 255 },
+        { "lemonchiffon",255,250,205, 255 },
+        { "lightblue",173,216,230, 255 },
+        { "lightcoral",240,128,128, 255 },
+        { "lightcyan",224,255,255, 255 },
+        { "lightgoldenrodyellow",250,250,210, 255 },
+        { "lightgray",211,211,211, 255 },
+        { "lightgreen",144,238,144, 255 },
+        { "lightgrey",211,211,211, 255 },
+        { "lightpink",255,182,193, 255 },
+        { "lightsalmon",255,160,122, 255 },
+        { "lightseagreen",32,178,170, 255 },
+        { "lightskyblue",135,206,250, 255 },
+        { "lightslategray",119,136,153, 255 },
+        { "lightslategrey",119,136,153, 255 },
+        { "lightsteelblue",176,196,222, 255 },
+        { "lightyellow",255,255,224, 255 },
+        { "lime",0,255,0, 255 },
+        { "limegreen",50,205,50, 255 },
+        { "linen",250,240,230, 255 },
+        { "magenta",255,0,255, 255 },
+        { "maroon",128,0,0, 255 },
+        { "mediumaquamarine",102,205,170, 255 },
+        { "mediumblue",0,0,205, 255 },
+        { "mediumorchid",186,85,211, 255 },
+        { "mediumpurple",147,112,219, 255 },
+        { "mediumseagreen",60,179,113, 255 },
+        { "mediumslateblue",123,104,238, 255 },
+        { "mediumspringgreen",0,250,154, 255 },
+        { "mediumturquoise",72,209,204, 255 },
+        { "mediumvioletred",199,21,133, 255 },
+        { "midnightblue",25,25,112, 255 },
+        { "mintcream",245,255,250, 255 },
+        { "mistyrose",255,228,225, 255 },
+        { "moccasin",255,228,181, 255 },
+        { "navajowhite",255,222,173, 255 },
+        { "navy",0,0,128, 255 },
+        { "oldlace",253,245,230, 255 },
+        { "olive",128,128,0, 255 },
+        { "olivedrab",107,142,35, 255 },
+        { "orange",255,165,0, 255 },
+        { "orangered",255,69,0, 255 },
+        { "orchid",218,112,214, 255 },
+        { "palegoldenrod",238,232,170, 255 },
+        { "palegreen",152,251,152, 255 },
+        { "paleturquoise",175,238,238, 255 },
+        { "palevioletred",219,112,147, 255 },
+        { "papayawhip",255,239,213, 255 },
+        { "peachpuff",255,218,185, 255 },
+        { "peru",205,133,63, 255 },
+        { "pink",255,192,203, 255 },
+        { "plum",221,160,221, 255 },
+        { "powderblue",176,224,230, 255 },
+        { "purple",128,0,128, 255 },
+        { "red",255,0,0, 255 },
+        { "rosybrown",188,143,143, 255 },
+        { "royalblue",65,105,225, 255 },
+        { "saddlebrown",139,69,19, 255 },
+        { "salmon",250,128,114, 255 },
+        { "sandybrown",244,164,96, 255 },
+        { "seagreen",46,139,87, 255 },
+        { "seashell",255,245,238, 255 },
+        { "sienna",160,82,45, 255 },
+        { "silver",192,192,192, 255 },
+        { "skyblue",135,206,235, 255 },
+        { "slateblue",106,90,205, 255 },
+        { "slategray",112,128,144, 255 },
+        { "slategrey",112,128,144, 255 },
+        { "snow",255,250,250, 255 },
+        { "springgreen",0,255,127, 255 },
+        { "steelblue",70,130,180, 255 },
+        { "tan",210,180,140, 255 },
+        { "teal",0,128,128, 255 },
+        { "thistle",216,191,216, 255 },
+        { "tomato",255,99,71, 255 },
+        { "turquoise",64,224,208, 255 },
+        { "violet",238,130,238, 255 },
+        { "wheat",245,222,179, 255 },
+        { "white",255,255,255, 255 },
+        { "whitesmoke",245,245,245, 255 },
+        { "yellow",255,255,0, 255 },
+        { "yellowgreen",154,205,50, 255 },
+        { "zzzzzzzzzzz",0,0,0, 0 }
+    }; 
+
+
+    //------------------------------------------------------------------------
+    parser::~parser()
+    {
+        delete [] m_attr_value;
+        delete [] m_attr_name;
+        delete [] m_buf;
+        delete [] m_title;
+    }
+
+    //------------------------------------------------------------------------
+    parser::parser(path_renderer& path) :
+        m_path(path),
+        m_tokenizer(),
+        m_buf(new char[buf_size]),
+        m_title(new char[256]),
+        m_title_len(0),
+        m_title_flag(false),
+        m_path_flag(false),
+        m_attr_name(new char[128]),
+        m_attr_value(new char[1024]),
+        m_attr_name_len(127),
+        m_attr_value_len(1023)
+    {
+        m_title[0] = 0;
+    }
+
+    //------------------------------------------------------------------------
+    void parser::parse(const char* fname)
+    {
+        char msg[1024];
+	    XML_Parser p = XML_ParserCreate(NULL);
+	    if(p == 0) 
+	    {
+		    throw exception("Couldn't allocate memory for parser");
+	    }
+
+        XML_SetUserData(p, this);
+	    XML_SetElementHandler(p, start_element, end_element);
+	    XML_SetCharacterDataHandler(p, content);
+
+        FILE* fd = fopen(fname, "r");
+        if(fd == 0)
+        {
+            sprintf(msg, "Couldn't open file %s", fname);
+		    throw exception(msg);
+        }
+
+        bool done = false;
+        do
+        {
+            size_t len = fread(m_buf, 1, buf_size, fd);
+            done = len < buf_size;
+            if(!XML_Parse(p, m_buf, len, done))
+            {
+                sprintf(msg,
+                    "%s at line %d\n",
+                    XML_ErrorString(XML_GetErrorCode(p)),
+                    (int)XML_GetCurrentLineNumber(p));
+                throw exception(msg);
+            }
+        }
+        while(!done);
+        fclose(fd);
+        XML_ParserFree(p);
+
+        char* ts = m_title;
+        while(*ts)
+        {
+            if(*ts < ' ') *ts = ' ';
+            ++ts;
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void parser::start_element(void* data, const char* el, const char** attr)
+    {
+        parser& self = *(parser*)data;
+
+        if(strcmp(el, "title") == 0)
+        {
+            self.m_title_flag = true;
+        }
+        else
+        if(strcmp(el, "g") == 0)
+        {
+            self.m_path.push_attr();
+            self.parse_attr(attr);
+        }
+        else
+        if(strcmp(el, "path") == 0)
+        {
+            if(self.m_path_flag)
+            {
+                throw exception("start_element: Nested path");
+            }
+            self.m_path.begin_path();
+            self.parse_path(attr);
+            self.m_path.end_path();
+            self.m_path_flag = true;
+        }
+        else
+        if(strcmp(el, "rect") == 0) 
+        {
+            self.parse_rect(attr);
+        }
+        else
+        if(strcmp(el, "line") == 0) 
+        {
+            self.parse_line(attr);
+        }
+        else
+        if(strcmp(el, "polyline") == 0) 
+        {
+            self.parse_poly(attr, false);
+        }
+        else
+        if(strcmp(el, "polygon") == 0) 
+        {
+            self.parse_poly(attr, true);
+        }
+        //else
+        //if(strcmp(el, "<OTHER_ELEMENTS>") == 0) 
+        //{
+        //}
+        // . . .
+    } 
+
+
+    //------------------------------------------------------------------------
+    void parser::end_element(void* data, const char* el)
+    {
+        parser& self = *(parser*)data;
+
+        if(strcmp(el, "title") == 0)
+        {
+            self.m_title_flag = false;
+        }
+        else
+        if(strcmp(el, "g") == 0)
+        {
+            self.m_path.pop_attr();
+        }
+        else
+        if(strcmp(el, "path") == 0)
+        {
+            self.m_path_flag = false;
+        }
+        //else
+        //if(strcmp(el, "<OTHER_ELEMENTS>") == 0) 
+        //{
+        //}
+        // . . .
+    }
+
+
+    //------------------------------------------------------------------------
+    void parser::content(void* data, const char* s, int len)
+    {
+        parser& self = *(parser*)data;
+
+        // m_title_flag signals that the <title> tag is being parsed now.
+        // The following code concatenates the pieces of content of the <title> tag.
+        if(self.m_title_flag)
+        {
+            if(len + self.m_title_len > 255) len = 255 - self.m_title_len;
+            if(len > 0) 
+            {
+                memcpy(self.m_title + self.m_title_len, s, len);
+                self.m_title_len += len;
+                self.m_title[self.m_title_len] = 0;
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void parser::parse_attr(const char** attr)
+    {
+        int i;
+        for(i = 0; attr[i]; i += 2)
+        {
+            if(strcmp(attr[i], "style") == 0)
+            {
+                parse_style(attr[i + 1]);
+            }
+            else
+            {
+                parse_attr(attr[i], attr[i + 1]);
+            }
+        }
+    }
+
+    //-------------------------------------------------------------
+    void parser::parse_path(const char** attr)
+    {
+        int i;
+
+        for(i = 0; attr[i]; i += 2)
+        {
+            // The <path> tag can consist of the path itself ("d=") 
+            // as well as of other parameters like "style=", "transform=", etc.
+            // In the last case we simply rely on the function of parsing 
+            // attributes (see 'else' branch).
+            if(strcmp(attr[i], "d") == 0)
+            {
+                m_tokenizer.set_path_str(attr[i + 1]);
+                m_path.parse_path(m_tokenizer);
+            }
+            else
+            {
+                // Create a temporary single pair "name-value" in order
+                // to avoid multiple calls for the same attribute.
+                const char* tmp[4];
+                tmp[0] = attr[i];
+                tmp[1] = attr[i + 1];
+                tmp[2] = 0;
+                tmp[3] = 0;
+                parse_attr(tmp);
+            }
+        }
+    }
+
+
+    //-------------------------------------------------------------
+    int cmp_color(const void* p1, const void* p2)
+    {
+        return strcmp(((named_color*)p1)->name, ((named_color*)p2)->name);
+    }
+
+    //-------------------------------------------------------------
+    rgba8 parse_color(const char* str)
+    {
+        while(*str == ' ') ++str;
+        unsigned c = 0;
+        if(*str == '#')
+        {
+            sscanf(str + 1, "%x", &c);
+            return rgb8_packed(c);
+        }
+        else
+        {
+            named_color c;
+            unsigned len = strlen(str);
+            if(len > sizeof(c.name) - 1)
+            {
+                throw exception("parse_color: Invalid color name '%s'", str);
+            }
+            strcpy(c.name, str);
+            const void* p = bsearch(&c, 
+                                    colors, 
+                                    sizeof(colors) / sizeof(colors[0]), 
+                                    sizeof(colors[0]), 
+                                    cmp_color);
+            if(p == 0)
+            {
+                throw exception("parse_color: Invalid color name '%s'", str);
+            }
+            const named_color* pc = (const named_color*)p;
+            return rgba8(pc->r, pc->g, pc->b, pc->a);
+        }
+    }
+
+    double parse_double(const char* str)
+    {
+        while(*str == ' ') ++str;
+        return atof(str);
+    }
+
+
+
+    //-------------------------------------------------------------
+    bool parser::parse_attr(const char* name, const char* value)
+    {
+        if(strcmp(name, "style") == 0)
+        {
+            parse_style(value);
+        }
+        else
+        if(strcmp(name, "fill") == 0)
+        {
+            if(strcmp(value, "none") == 0)
+            {
+                m_path.fill_none();
+            }
+            else
+            {
+                m_path.fill(parse_color(value));
+            }
+        }
+        else
+        if(strcmp(name, "fill-opacity") == 0)
+        {
+            m_path.fill_opacity(parse_double(value));
+        }
+        else
+        if(strcmp(name, "stroke") == 0)
+        {
+            if(strcmp(value, "none") == 0)
+            {
+                m_path.stroke_none();
+            }
+            else
+            {
+                m_path.stroke(parse_color(value));
+            }
+        }
+        else
+        if(strcmp(name, "stroke-width") == 0)
+        {
+            m_path.stroke_width(parse_double(value));
+        }
+        else
+        if(strcmp(name, "stroke-linecap") == 0)
+        {
+            if(strcmp(value, "butt") == 0)        m_path.line_cap(butt_cap);
+            else if(strcmp(value, "round") == 0)  m_path.line_cap(round_cap);
+            else if(strcmp(value, "square") == 0) m_path.line_cap(square_cap);
+        }
+        else
+        if(strcmp(name, "stroke-linejoin") == 0)
+        {
+            if(strcmp(value, "miter") == 0)      m_path.line_join(miter_join);
+            else if(strcmp(value, "round") == 0) m_path.line_join(round_join);
+            else if(strcmp(value, "bevel") == 0) m_path.line_join(bevel_join);
+        }
+        else
+        if(strcmp(name, "stroke-miterlimit") == 0)
+        {
+            m_path.miter_limit(parse_double(value));
+        }
+        else
+        if(strcmp(name, "stroke-opacity") == 0)
+        {
+            m_path.stroke_opacity(parse_double(value));
+        }
+        else
+        if(strcmp(name, "transform") == 0)
+        {
+            parse_transform(value);
+        }
+        //else
+        //if(strcmp(el, "<OTHER_ATTRIBUTES>") == 0) 
+        //{
+        //}
+        // . . .
+        else
+        {
+            return false;
+        }
+        return true;
+    }
+
+
+
+    //-------------------------------------------------------------
+    void parser::copy_name(const char* start, const char* end)
+    {
+        unsigned len = unsigned(end - start);
+        if(m_attr_name_len == 0 || len > m_attr_name_len)
+        {
+            delete [] m_attr_name;
+            m_attr_name = new char[len + 1];
+            m_attr_name_len = len;
+        }
+        if(len) memcpy(m_attr_name, start, len);
+        m_attr_name[len] = 0;
+    }
+
+
+
+    //-------------------------------------------------------------
+    void parser::copy_value(const char* start, const char* end)
+    {
+        unsigned len = unsigned(end - start);
+        if(m_attr_value_len == 0 || len > m_attr_value_len)
+        {
+            delete [] m_attr_value;
+            m_attr_value = new char[len + 1];
+            m_attr_value_len = len;
+        }
+        if(len) memcpy(m_attr_value, start, len);
+        m_attr_value[len] = 0;
+    }
+
+
+    //-------------------------------------------------------------
+    bool parser::parse_name_value(const char* nv_start, const char* nv_end)
+    {
+        const char* str = nv_start;
+        while(str < nv_end && *str != ':') ++str;
+
+        const char* val = str;
+
+        // Right Trim
+        while(str > nv_start && 
+            (*str == ':' || isspace(*str))) --str;
+        ++str;
+
+        copy_name(nv_start, str);
+
+        while(val < nv_end && (*val == ':' || isspace(*val))) ++val;
+        
+        copy_value(val, nv_end);
+        return parse_attr(m_attr_name, m_attr_value);
+    }
+
+
+
+    //-------------------------------------------------------------
+    void parser::parse_style(const char* str)
+    {
+        while(*str)
+        {
+            // Left Trim
+            while(*str && isspace(*str)) ++str;
+            const char* nv_start = str;
+            while(*str && *str != ';') ++str;
+            const char* nv_end = str;
+
+            // Right Trim
+            while(nv_end > nv_start && 
+                (*nv_end == ';' || isspace(*nv_end))) --nv_end;
+            ++nv_end;
+
+            parse_name_value(nv_start, nv_end);
+            if(*str) ++str;
+        }
+
+    }
+
+
+    //-------------------------------------------------------------
+    void parser::parse_rect(const char** attr)
+    {
+        int i;
+        double x = 0.0;
+        double y = 0.0;
+        double w = 0.0;
+        double h = 0.0;
+
+        m_path.begin_path();
+        for(i = 0; attr[i]; i += 2)
+        {
+            if(!parse_attr(attr[i], attr[i + 1]))
+            {
+                if(strcmp(attr[i], "x") == 0)      x = parse_double(attr[i + 1]);
+                if(strcmp(attr[i], "y") == 0)      y = parse_double(attr[i + 1]);
+                if(strcmp(attr[i], "width") == 0)  w = parse_double(attr[i + 1]);
+                if(strcmp(attr[i], "height") == 0) h = parse_double(attr[i + 1]);
+                // rx - to be implemented 
+                // ry - to be implemented
+            }
+        }
+
+
+        if(w != 0.0 && h != 0.0)
+        {
+            if(w < 0.0) throw exception("parse_rect: Invalid width: %f", w);
+            if(h < 0.0) throw exception("parse_rect: Invalid height: %f", h);
+
+            m_path.move_to(x,     y);
+            m_path.line_to(x + w, y);
+            m_path.line_to(x + w, y + h);
+            m_path.line_to(x,     y + h);
+            m_path.close_subpath();
+        }
+        m_path.end_path();
+    }
+
+
+    //-------------------------------------------------------------
+    void parser::parse_line(const char** attr)
+    {
+        int i;
+        double x1 = 0.0;
+        double y1 = 0.0;
+        double x2 = 0.0;
+        double y2 = 0.0;
+
+        m_path.begin_path();
+        for(i = 0; attr[i]; i += 2)
+        {
+            if(!parse_attr(attr[i], attr[i + 1]))
+            {
+                if(strcmp(attr[i], "x1") == 0) x1 = parse_double(attr[i + 1]);
+                if(strcmp(attr[i], "y1") == 0) y1 = parse_double(attr[i + 1]);
+                if(strcmp(attr[i], "x2") == 0) x2 = parse_double(attr[i + 1]);
+                if(strcmp(attr[i], "y2") == 0) y2 = parse_double(attr[i + 1]);
+            }
+        }
+
+        m_path.move_to(x1, y1);
+        m_path.line_to(x2, y2);
+        m_path.end_path();
+    }
+
+
+    //-------------------------------------------------------------
+    void parser::parse_poly(const char** attr, bool close_flag)
+    {
+        int i;
+        double x = 0.0;
+        double y = 0.0;
+
+        m_path.begin_path();
+        for(i = 0; attr[i]; i += 2)
+        {
+            if(!parse_attr(attr[i], attr[i + 1]))
+            {
+                if(strcmp(attr[i], "points") == 0) 
+                {
+                    m_tokenizer.set_path_str(attr[i + 1]);
+                    if(!m_tokenizer.next())
+                    {
+                        throw exception("parse_poly: Too few coordinates");
+                    }
+                    x = m_tokenizer.last_number();
+                    if(!m_tokenizer.next())
+                    {
+                        throw exception("parse_poly: Too few coordinates");
+                    }
+                    y = m_tokenizer.last_number();
+                    m_path.move_to(x, y);
+                    while(m_tokenizer.next())
+                    {
+                        x = m_tokenizer.last_number();
+                        if(!m_tokenizer.next())
+                        {
+                            throw exception("parse_poly: Odd number of coordinates");
+                        }
+                        y = m_tokenizer.last_number();
+                        m_path.line_to(x, y);
+                    }
+                }
+            }
+        }
+        if(close_flag) 
+        {
+            m_path.close_subpath();
+        }
+        m_path.end_path();
+    }
+
+    //-------------------------------------------------------------
+    void parser::parse_transform(const char* str)
+    {
+        while(*str)
+        {
+            if(islower(*str))
+            {
+                if(strncmp(str, "matrix", 6) == 0)    str += parse_matrix(str);    else 
+                if(strncmp(str, "translate", 9) == 0) str += parse_translate(str); else 
+                if(strncmp(str, "rotate", 6) == 0)    str += parse_rotate(str);    else 
+                if(strncmp(str, "scale", 5) == 0)     str += parse_scale(str);     else 
+                if(strncmp(str, "skewX", 5) == 0)     str += parse_skew_x(str);    else 
+                if(strncmp(str, "skewY", 5) == 0)     str += parse_skew_y(str);    else
+                {
+                    ++str;
+                }
+            }
+            else
+            {
+                ++str;
+            }
+        }
+    }
+
+
+    //-------------------------------------------------------------
+    static bool is_numeric(char c)
+    {
+        return strchr("0123456789+-.eE", c) != 0;
+    }
+
+    //-------------------------------------------------------------
+    static unsigned parse_transform_args(const char* str, 
+                                         double* args, 
+                                         unsigned max_na, 
+                                         unsigned* na)
+    {
+        *na = 0;
+        const char* ptr = str;
+        while(*ptr && *ptr != '(') ++ptr;
+        if(*ptr == 0)
+        {
+            throw exception("parse_transform_args: Invalid syntax");
+        }
+        const char* end = ptr;
+        while(*end && *end != ')') ++end;
+        if(*end == 0)
+        {
+            throw exception("parse_transform_args: Invalid syntax");
+        }
+
+        while(ptr < end)
+        {
+            if(is_numeric(*ptr))
+            {
+                if(*na >= max_na)
+                {
+                    throw exception("parse_transform_args: Too many arguments");
+                }
+                args[(*na)++] = atof(ptr);
+                while(ptr < end && is_numeric(*ptr)) ++ptr;
+            }
+            else
+            {
+                ++ptr;
+            }
+        }
+        return unsigned(end - str);
+    }
+
+    //-------------------------------------------------------------
+    unsigned parser::parse_matrix(const char* str)
+    {
+        double args[6];
+        unsigned na = 0;
+        unsigned len = parse_transform_args(str, args, 6, &na);
+        if(na != 6)
+        {
+            throw exception("parse_matrix: Invalid number of arguments");
+        }
+        m_path.transform().premultiply(trans_affine(args[0], args[1], args[2], args[3], args[4], args[5]));
+        return len;
+    }
+
+    //-------------------------------------------------------------
+    unsigned parser::parse_translate(const char* str)
+    {
+        double args[2];
+        unsigned na = 0;
+        unsigned len = parse_transform_args(str, args, 2, &na);
+        if(na == 1) args[1] = 0.0;
+        m_path.transform().premultiply(trans_affine_translation(args[0], args[1]));
+        return len;
+    }
+
+    //-------------------------------------------------------------
+    unsigned parser::parse_rotate(const char* str)
+    {
+        double args[3];
+        unsigned na = 0;
+        unsigned len = parse_transform_args(str, args, 3, &na);
+        if(na == 1) 
+        {
+            m_path.transform().premultiply(trans_affine_rotation(deg2rad(args[0])));
+        }
+        else if(na == 3)
+        {
+            trans_affine t = trans_affine_translation(-args[1], -args[2]);
+            t *= trans_affine_rotation(deg2rad(args[0]));
+            t *= trans_affine_translation(args[1], args[2]);
+            m_path.transform().premultiply(t);
+        }
+        else
+        {
+            throw exception("parse_rotate: Invalid number of arguments");
+        }
+        return len;
+    }
+
+    //-------------------------------------------------------------
+    unsigned parser::parse_scale(const char* str)
+    {
+        double args[2];
+        unsigned na = 0;
+        unsigned len = parse_transform_args(str, args, 2, &na);
+        if(na == 1) args[1] = args[0];
+        m_path.transform().premultiply(trans_affine_scaling(args[0], args[1]));
+        return len;
+    }
+
+    //-------------------------------------------------------------
+    unsigned parser::parse_skew_x(const char* str)
+    {
+        double arg;
+        unsigned na = 0;
+        unsigned len = parse_transform_args(str, &arg, 1, &na);
+        m_path.transform().premultiply(trans_affine_skewing(deg2rad(arg), 0.0));
+        return len;
+    }
+
+    //-------------------------------------------------------------
+    unsigned parser::parse_skew_y(const char* str)
+    {
+        double arg;
+        unsigned na = 0;
+        unsigned len = parse_transform_args(str, &arg, 1, &na);
+        m_path.transform().premultiply(trans_affine_skewing(0.0, deg2rad(arg)));
+        return len;
+    }
+
+}
+}
+
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_svg_path_renderer.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_svg_path_renderer.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_svg_path_renderer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_svg_path_renderer.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,358 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// SVG path renderer.
+//
+//----------------------------------------------------------------------------
+
+#include <stdio.h>
+#include "agg_svg_path_renderer.h"
+
+namespace mapserver
+{
+namespace svg
+{
+
+    //------------------------------------------------------------------------
+    path_renderer::path_renderer() :
+        m_curved(m_storage),
+        m_curved_count(m_curved),
+
+        m_curved_stroked(m_curved_count),
+        m_curved_stroked_trans(m_curved_stroked, m_transform),
+
+        m_curved_trans(m_curved_count, m_transform),
+        m_curved_trans_contour(m_curved_trans)
+    {
+        m_curved_trans_contour.auto_detect_orientation(false);
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::remove_all()
+    {
+        m_storage.remove_all();
+        m_attr_storage.remove_all();
+        m_attr_stack.remove_all();
+        m_transform.reset();
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::begin_path()
+    {
+        push_attr();
+        unsigned idx = m_storage.start_new_path();
+        m_attr_storage.add(path_attributes(cur_attr(), idx));
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::end_path()
+    {
+        if(m_attr_storage.size() == 0) 
+        {
+            throw exception("end_path : The path was not begun");
+        }
+        path_attributes attr = cur_attr();
+        unsigned idx = m_attr_storage[m_attr_storage.size() - 1].index;
+        attr.index = idx;
+        m_attr_storage[m_attr_storage.size() - 1] = attr;
+        pop_attr();
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::move_to(double x, double y, bool rel)          // M, m
+    {
+        if(rel) m_storage.rel_to_abs(&x, &y);
+        m_storage.move_to(x, y);
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::line_to(double x,  double y, bool rel)         // L, l
+    {
+        if(rel) m_storage.rel_to_abs(&x, &y);
+        m_storage.line_to(x, y);
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::hline_to(double x, bool rel)                   // H, h
+    {
+        double x2 = 0.0;
+        double y2 = 0.0;
+        if(m_storage.total_vertices())
+        {
+            m_storage.vertex(m_storage.total_vertices() - 1, &x2, &y2);
+            if(rel) x += x2;
+            m_storage.line_to(x, y2);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::vline_to(double y, bool rel)                   // V, v
+    {
+        double x2 = 0.0;
+        double y2 = 0.0;
+        if(m_storage.total_vertices())
+        {
+            m_storage.vertex(m_storage.total_vertices() - 1, &x2, &y2);
+            if(rel) y += y2;
+            m_storage.line_to(x2, y);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::curve3(double x1, double y1,                   // Q, q
+                               double x,  double y, bool rel)
+    {
+        if(rel) 
+        {
+            m_storage.rel_to_abs(&x1, &y1);
+            m_storage.rel_to_abs(&x,  &y);
+        }
+        m_storage.curve3(x1, y1, x, y);
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::curve3(double x, double y, bool rel)           // T, t
+    {
+//        throw exception("curve3(x, y) : NOT IMPLEMENTED YET");
+        if(rel) 
+        {
+            m_storage.curve3_rel(x, y);
+        } else 
+        {
+            m_storage.curve3(x, y);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::curve4(double x1, double y1,                   // C, c
+                               double x2, double y2, 
+                               double x,  double y, bool rel)
+    {
+        if(rel) 
+        {
+            m_storage.rel_to_abs(&x1, &y1);
+            m_storage.rel_to_abs(&x2, &y2);
+            m_storage.rel_to_abs(&x,  &y);
+        }
+        m_storage.curve4(x1, y1, x2, y2, x, y);
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::curve4(double x2, double y2,                   // S, s
+                               double x,  double y, bool rel)
+    {
+        //throw exception("curve4(x2, y2, x, y) : NOT IMPLEMENTED YET");
+        if(rel) 
+        {
+            m_storage.curve4_rel(x2, y2, x, y);
+        } else 
+        {
+            m_storage.curve4(x2, y2, x, y);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::close_subpath()
+    {
+        m_storage.end_poly(path_flags_close);
+    }
+
+    //------------------------------------------------------------------------
+    path_attributes& path_renderer::cur_attr()
+    {
+        if(m_attr_stack.size() == 0)
+        {
+            throw exception("cur_attr : Attribute stack is empty");
+        }
+        return m_attr_stack[m_attr_stack.size() - 1];
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::push_attr()
+    {
+        m_attr_stack.add(m_attr_stack.size() ? 
+                         m_attr_stack[m_attr_stack.size() - 1] :
+                         path_attributes());
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::pop_attr()
+    {
+        if(m_attr_stack.size() == 0)
+        {
+            throw exception("pop_attr : Attribute stack is empty");
+        }
+        m_attr_stack.remove_last();
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::fill(const rgba8& f)
+    {
+        path_attributes& attr = cur_attr();
+        attr.fill_color = f;
+        attr.fill_flag = true;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::stroke(const rgba8& s)
+    {
+        path_attributes& attr = cur_attr();
+        attr.stroke_color = s;
+        attr.stroke_flag = true;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::even_odd(bool flag)
+    {
+        cur_attr().even_odd_flag = flag;
+    }
+    
+    //------------------------------------------------------------------------
+    void path_renderer::stroke_width(double w)
+    {
+        cur_attr().stroke_width = w;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::fill_none()
+    {
+        cur_attr().fill_flag = false;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::stroke_none()
+    {
+        cur_attr().stroke_flag = false;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::fill_opacity(double op)
+    {
+        cur_attr().fill_color.opacity(op);
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::stroke_opacity(double op)
+    {
+        cur_attr().stroke_color.opacity(op);
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::line_join(line_join_e join)
+    {
+        cur_attr().line_join = join;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::line_cap(line_cap_e cap)
+    {
+        cur_attr().line_cap = cap;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::miter_limit(double ml)
+    {
+        cur_attr().miter_limit = ml;
+    }
+
+    //------------------------------------------------------------------------
+    trans_affine& path_renderer::transform()
+    {
+        return cur_attr().transform;
+    }
+
+    //------------------------------------------------------------------------
+    void path_renderer::parse_path(path_tokenizer& tok)
+    {
+        while(tok.next())
+        {
+            double arg[10];
+            char cmd = tok.last_command();
+            unsigned i;
+            switch(cmd)
+            {
+                case 'M': case 'm':
+                    arg[0] = tok.last_number();
+                    arg[1] = tok.next(cmd);
+                    move_to(arg[0], arg[1], cmd == 'm');
+                    break;
+
+                case 'L': case 'l':
+                    arg[0] = tok.last_number();
+                    arg[1] = tok.next(cmd);
+                    line_to(arg[0], arg[1], cmd == 'l');
+                    break;
+
+                case 'V': case 'v':
+                    vline_to(tok.last_number(), cmd == 'v');
+                    break;
+
+                case 'H': case 'h':
+                    hline_to(tok.last_number(), cmd == 'h');
+                    break;
+                
+                case 'Q': case 'q':
+                    arg[0] = tok.last_number();
+                    for(i = 1; i < 4; i++)
+                    {
+                        arg[i] = tok.next(cmd);
+                    }
+                    curve3(arg[0], arg[1], arg[2], arg[3], cmd == 'q');
+                    break;
+
+                case 'T': case 't':
+                    arg[0] = tok.last_number();
+                    arg[1] = tok.next(cmd);
+                    curve3(arg[0], arg[1], cmd == 't');
+                    break;
+
+                case 'C': case 'c':
+                    arg[0] = tok.last_number();
+                    for(i = 1; i < 6; i++)
+                    {
+                        arg[i] = tok.next(cmd);
+                    }
+                    curve4(arg[0], arg[1], arg[2], arg[3], arg[4], arg[5], cmd == 'c');
+                    break;
+
+                case 'S': case 's':
+                    arg[0] = tok.last_number();
+                    for(i = 1; i < 4; i++)
+                    {
+                        arg[i] = tok.next(cmd);
+                    }
+                    curve4(arg[0], arg[1], arg[2], arg[3], cmd == 's');
+                    break;
+
+                case 'A': case 'a':
+                    throw exception("parse_path: Command A: NOT IMPLEMENTED YET");
+
+                case 'Z': case 'z':
+                    close_subpath();
+                    break;
+
+                default:
+                {
+                    char buf[100];
+                    sprintf(buf, "parse_path: Invalid Command %c", cmd);
+                    throw exception(buf);
+                }
+            }
+        }
+    }
+
+}
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_svg_path_tokenizer.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_svg_path_tokenizer.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_svg_path_tokenizer.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_svg_path_tokenizer.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,144 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.3
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// SVG path tokenizer.
+//
+//----------------------------------------------------------------------------
+#include <string.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include "agg_svg_exception.h"
+#include "agg_svg_path_tokenizer.h"
+
+
+namespace mapserver 
+{ 
+namespace svg
+{
+
+    //------------------------------------------------------------------------
+    const char path_tokenizer::s_commands[]   = "+-MmZzLlHhVvCcSsQqTtAaFfPp";
+    const char path_tokenizer::s_numeric[]    = ".Ee0123456789";
+    const char path_tokenizer::s_separators[] = " ,\t\n\r";
+
+    //------------------------------------------------------------------------
+    path_tokenizer::path_tokenizer()
+        : m_path(0), m_last_number(0.0), m_last_command(0)
+    {
+        init_char_mask(m_commands_mask,   s_commands);
+        init_char_mask(m_numeric_mask,    s_numeric);
+        init_char_mask(m_separators_mask, s_separators);
+    }
+
+
+    //------------------------------------------------------------------------
+    void path_tokenizer::set_path_str(const char* str)
+    {
+        m_path = str;
+        m_last_command = 0;
+        m_last_number = 0.0;
+    }
+
+
+    //------------------------------------------------------------------------
+    void path_tokenizer::init_char_mask(char* mask, const char* char_set)
+    {
+        memset(mask, 0, 256/8);
+        while(*char_set) 
+        {
+            unsigned c = unsigned(*char_set++) & 0xFF;
+            mask[c >> 3] |= 1 << (c & 7);
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    bool path_tokenizer::next()
+    {
+        if(m_path == 0) return false;
+
+        // Skip all white spaces and other garbage
+        while(*m_path && !is_command(*m_path) && !is_numeric(*m_path)) 
+        {
+            if(!is_separator(*m_path))
+            {
+                char buf[100];
+                sprintf(buf, "path_tokenizer::next : Invalid Character %c", *m_path);
+                throw exception(buf);
+            }
+            m_path++;
+        }
+
+        if(*m_path == 0) return false;
+
+        if(is_command(*m_path))
+        {
+            // Check if the command is a numeric sign character
+            if(*m_path == '-' || *m_path == '+')
+            {
+                return parse_number();
+            }
+            m_last_command = *m_path++;
+            while(*m_path && is_separator(*m_path)) m_path++;
+            if(*m_path == 0) return true;
+        }
+        return parse_number();
+    }
+
+
+
+    //------------------------------------------------------------------------
+    double path_tokenizer::next(char cmd)
+    {
+        if(!next()) throw exception("parse_path: Unexpected end of path");
+        if(last_command() != cmd)
+        {
+            char buf[100];
+            sprintf(buf, "parse_path: Command %c: bad or missing parameters", cmd);
+            throw exception(buf);
+        }
+        return last_number();
+    }
+
+
+    //------------------------------------------------------------------------
+    bool path_tokenizer::parse_number()
+    {
+        char buf[256]; // Should be enough for any number
+        char* buf_ptr = buf;
+
+        // Copy all sign characters
+        while((buf_ptr < buf+255 && *m_path == '-') || *m_path == '+')
+        {
+            *buf_ptr++ = *m_path++;
+        }
+
+        // Copy all numeric characters
+        while(buf_ptr < buf+255 && is_numeric(*m_path))
+        {
+            *buf_ptr++ = *m_path++;
+        }
+        *buf_ptr = 0;
+        m_last_number = atof(buf);
+        return true;
+    }
+
+
+} //namespace svg
+} //namespace mapserver
+
+
+
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_trans_affine.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_affine.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_trans_affine.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_affine.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,194 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Affine transformations
+//
+//----------------------------------------------------------------------------
+#include "../include/agg_trans_affine.h"
+
+
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    const trans_affine& trans_affine::parl_to_parl(const double* src, 
+                                                   const double* dst)
+    {
+        sx  = src[2] - src[0];
+        shy = src[3] - src[1];
+        shx = src[4] - src[0];
+        sy  = src[5] - src[1];
+        tx  = src[0];
+        ty  = src[1];
+        invert();
+        multiply(trans_affine(dst[2] - dst[0], dst[3] - dst[1], 
+                              dst[4] - dst[0], dst[5] - dst[1],
+                              dst[0], dst[1]));
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    const trans_affine& trans_affine::rect_to_parl(double x1, double y1, 
+                                                   double x2, double y2, 
+                                                   const double* parl)
+    {
+        double src[6];
+        src[0] = x1; src[1] = y1;
+        src[2] = x2; src[3] = y1;
+        src[4] = x2; src[5] = y2;
+        parl_to_parl(src, parl);
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    const trans_affine& trans_affine::parl_to_rect(const double* parl, 
+                                                   double x1, double y1, 
+                                                   double x2, double y2)
+    {
+        double dst[6];
+        dst[0] = x1; dst[1] = y1;
+        dst[2] = x2; dst[3] = y1;
+        dst[4] = x2; dst[5] = y2;
+        parl_to_parl(parl, dst);
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    const trans_affine& trans_affine::multiply(const trans_affine& m)
+    {
+        double t0 = sx  * m.sx + shy * m.shx;
+        double t2 = shx * m.sx + sy  * m.shx;
+        double t4 = tx  * m.sx + ty  * m.shx + m.tx;
+        shy = sx  * m.shy + shy * m.sy;
+        sy  = shx * m.shy + sy  * m.sy;
+        ty  = tx  * m.shy + ty  * m.sy + m.ty;
+        sx  = t0;
+        shx = t2;
+        tx  = t4;
+        return *this;
+    }
+
+
+    //------------------------------------------------------------------------
+    const trans_affine& trans_affine::invert()
+    {
+        double d  = determinant_reciprocal();
+
+        double t0  =  sy  * d;
+               sy  =  sx  * d;
+               shy = -shy * d;
+               shx = -shx * d;
+
+        double t4 = -tx * t0  - ty * shx;
+               ty = -tx * shy - ty * sy;
+
+        sx = t0;
+        tx = t4;
+        return *this;
+    }
+
+
+   //------------------------------------------------------------------------
+    const trans_affine& trans_affine::flip_x()
+    {
+        sx  = -sx;
+        shy = -shy;
+        tx  = -tx;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    const trans_affine& trans_affine::flip_y()
+    {
+        shx = -shx;
+        sy  = -sy;
+        ty  = -ty;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    const trans_affine& trans_affine::reset()
+    {
+        sx  = sy  = 1.0; 
+        shy = shx = tx = ty = 0.0;
+        return *this;
+    }
+
+    //------------------------------------------------------------------------
+    bool trans_affine::is_identity(double epsilon) const
+    {
+        return is_equal_eps(sx,  1.0, epsilon) &&
+               is_equal_eps(shy, 0.0, epsilon) &&
+               is_equal_eps(shx, 0.0, epsilon) && 
+               is_equal_eps(sy,  1.0, epsilon) &&
+               is_equal_eps(tx,  0.0, epsilon) &&
+               is_equal_eps(ty,  0.0, epsilon);
+    }
+
+    //------------------------------------------------------------------------
+    bool trans_affine::is_valid(double epsilon) const
+    {
+        return fabs(sx) > epsilon && fabs(sy) > epsilon;
+    }
+
+    //------------------------------------------------------------------------
+    bool trans_affine::is_equal(const trans_affine& m, double epsilon) const
+    {
+        return is_equal_eps(sx,  m.sx,  epsilon) &&
+               is_equal_eps(shy, m.shy, epsilon) &&
+               is_equal_eps(shx, m.shx, epsilon) && 
+               is_equal_eps(sy,  m.sy,  epsilon) &&
+               is_equal_eps(tx,  m.tx,  epsilon) &&
+               is_equal_eps(ty,  m.ty,  epsilon);
+    }
+
+    //------------------------------------------------------------------------
+    double trans_affine::rotation() const
+    {
+        double x1 = 0.0;
+        double y1 = 0.0;
+        double x2 = 1.0;
+        double y2 = 0.0;
+        transform(&x1, &y1);
+        transform(&x2, &y2);
+        return atan2(y2-y1, x2-x1);
+    }
+
+    //------------------------------------------------------------------------
+    void trans_affine::translation(double* dx, double* dy) const
+    {
+        *dx = tx;
+        *dy = ty;
+    }
+
+    //------------------------------------------------------------------------
+    void trans_affine::scaling(double* x, double* y) const
+    {
+        double x1 = 0.0;
+        double y1 = 0.0;
+        double x2 = 1.0;
+        double y2 = 1.0;
+        trans_affine t(*this);
+        t *= trans_affine_rotation(-rotation());
+        t.transform(&x1, &y1);
+        t.transform(&x2, &y2);
+        *x = x2 - x1;
+        *y = y2 - y1;
+    }
+
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_trans_double_path.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_double_path.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_trans_double_path.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_double_path.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,273 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include "../include/agg_math.h"
+#include "../include/agg_trans_double_path.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    trans_double_path::trans_double_path() :
+        m_kindex1(0.0),
+        m_kindex2(0.0),
+        m_base_length(0.0),
+        m_base_height(1.0),
+        m_status1(initial),
+        m_status2(initial),
+        m_preserve_x_scale(true)
+    {
+    }
+
+
+        //------------------------------------------------------------------------
+    void trans_double_path::reset()
+    {
+        m_src_vertices1.remove_all();
+        m_src_vertices2.remove_all();
+        m_kindex1 = 0.0;
+        m_kindex1 = 0.0;
+        m_status1 = initial;
+        m_status2 = initial;
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_double_path::move_to1(double x, double y)
+    {
+        if(m_status1 == initial)
+        {
+            m_src_vertices1.modify_last(vertex_dist(x, y));
+            m_status1 = making_path;
+        }
+        else
+        {
+            line_to1(x, y);
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_double_path::line_to1(double x, double y)
+    {
+        if(m_status1 == making_path)
+        {
+            m_src_vertices1.add(vertex_dist(x, y));
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_double_path::move_to2(double x, double y)
+    {
+        if(m_status2 == initial)
+        {
+            m_src_vertices2.modify_last(vertex_dist(x, y));
+            m_status2 = making_path;
+        }
+        else
+        {
+            line_to2(x, y);
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_double_path::line_to2(double x, double y)
+    {
+        if(m_status2 == making_path)
+        {
+            m_src_vertices2.add(vertex_dist(x, y));
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    double trans_double_path::finalize_path(vertex_storage& vertices)
+    {
+        unsigned i;
+        double dist;
+        double d;
+
+        vertices.close(false);
+        if(vertices.size() > 2)
+        {
+            if(vertices[vertices.size() - 2].dist * 10.0 < 
+               vertices[vertices.size() - 3].dist)
+            {
+                d = vertices[vertices.size() - 3].dist + 
+                    vertices[vertices.size() - 2].dist;
+
+                vertices[vertices.size() - 2] = 
+                    vertices[vertices.size() - 1];
+
+                vertices.remove_last();
+                vertices[vertices.size() - 2].dist = d;
+            }
+        }
+
+        dist = 0;
+        for(i = 0; i < vertices.size(); i++)
+        {
+            vertex_dist& v = vertices[i];
+            d = v.dist;
+            v.dist = dist;
+            dist += d;
+        }
+
+        return (vertices.size() - 1) / dist;
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_double_path::finalize_paths()
+    {
+        if(m_status1 == making_path && m_src_vertices1.size() > 1 &&
+           m_status2 == making_path && m_src_vertices2.size() > 1)
+        {
+            m_kindex1 = finalize_path(m_src_vertices1);
+            m_kindex2 = finalize_path(m_src_vertices2);
+            m_status1 = ready;
+            m_status2 = ready;
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    double trans_double_path::total_length1() const
+    {
+        if(m_base_length >= 1e-10) return m_base_length;
+        return (m_status1 == ready) ? 
+            m_src_vertices1[m_src_vertices1.size() - 1].dist :
+            0.0;
+    }
+
+
+    //------------------------------------------------------------------------
+    double trans_double_path::total_length2() const
+    {
+        if(m_base_length >= 1e-10) return m_base_length;
+        return (m_status2 == ready) ? 
+            m_src_vertices2[m_src_vertices2.size() - 1].dist :
+            0.0;
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_double_path::transform1(const vertex_storage& vertices, 
+                                       double kindex, double kx, 
+                                       double *x, double* y) const
+    {
+        double x1 = 0.0;
+        double y1 = 0.0;
+        double dx = 1.0;
+        double dy = 1.0;
+        double d  = 0.0;
+        double dd = 1.0;
+        *x *= kx;
+        if(*x < 0.0)
+        {
+            // Extrapolation on the left
+            //--------------------------
+            x1 = vertices[0].x;
+            y1 = vertices[0].y;
+            dx = vertices[1].x - x1;
+            dy = vertices[1].y - y1;
+            dd = vertices[1].dist - vertices[0].dist;
+            d  = *x;
+        }
+        else
+        if(*x > vertices[vertices.size() - 1].dist)
+        {
+            // Extrapolation on the right
+            //--------------------------
+            unsigned i = vertices.size() - 2;
+            unsigned j = vertices.size() - 1;
+            x1 = vertices[j].x;
+            y1 = vertices[j].y;
+            dx = x1 - vertices[i].x;
+            dy = y1 - vertices[i].y;
+            dd = vertices[j].dist - vertices[i].dist;
+            d  = *x - vertices[j].dist;
+        }
+        else
+        {
+            // Interpolation
+            //--------------------------
+            unsigned i = 0;
+            unsigned j = vertices.size() - 1;
+            if(m_preserve_x_scale)
+            {
+                unsigned k;
+                for(i = 0; (j - i) > 1; ) 
+                {
+                    if(*x < vertices[k = (i + j) >> 1].dist) 
+                    {
+                        j = k; 
+                    }
+                    else 
+                    {
+                        i = k;
+                    }
+                }
+                d  = vertices[i].dist;
+                dd = vertices[j].dist - d;
+                d  = *x - d;
+            }
+            else
+            {
+                i = unsigned(*x * kindex);
+                j = i + 1;
+                dd = vertices[j].dist - vertices[i].dist;
+                d = ((*x * kindex) - i) * dd;
+            }
+            x1 = vertices[i].x;
+            y1 = vertices[i].y;
+            dx = vertices[j].x - x1;
+            dy = vertices[j].y - y1;
+        }
+        *x = x1 + dx * d / dd;
+        *y = y1 + dy * d / dd;
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_double_path::transform(double *x, double *y) const
+    {
+        if(m_status1 == ready && m_status2 == ready)
+        {
+            if(m_base_length > 1e-10)
+            {
+                *x *= m_src_vertices1[m_src_vertices1.size() - 1].dist / 
+                      m_base_length;
+            }
+
+            double x1 = *x;
+            double y1 = *y;
+            double x2 = *x;
+            double y2 = *y;
+            double dd = m_src_vertices2[m_src_vertices2.size() - 1].dist /
+                        m_src_vertices1[m_src_vertices1.size() - 1].dist;
+
+            transform1(m_src_vertices1, m_kindex1, 1.0, &x1, &y1);
+            transform1(m_src_vertices2, m_kindex2, dd,  &x2, &y2);
+
+            *x = x1 + *y * (x2 - x1) / m_base_height;
+            *y = y1 + *y * (y2 - y1) / m_base_height;
+        }
+    }
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_trans_single_path.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_single_path.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_trans_single_path.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_single_path.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,202 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include "../include/agg_math.h"
+#include "../include/agg_vertex_sequence.h"
+#include "../include/agg_trans_single_path.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    trans_single_path::trans_single_path() :
+        m_base_length(0.0),
+        m_kindex(0.0),
+        m_status(initial),
+        m_preserve_x_scale(true)
+    {
+    }
+
+    //------------------------------------------------------------------------
+    void trans_single_path::reset()
+    {
+        m_src_vertices.remove_all();
+        m_kindex = 0.0;
+        m_status = initial;
+    }
+
+    //------------------------------------------------------------------------
+    void trans_single_path::move_to(double x, double y)
+    {
+        if(m_status == initial)
+        {
+            m_src_vertices.modify_last(vertex_dist(x, y));
+            m_status = making_path;
+        }
+        else
+        {
+            line_to(x, y);
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void trans_single_path::line_to(double x, double y)
+    {
+        if(m_status == making_path)
+        {
+            m_src_vertices.add(vertex_dist(x, y));
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_single_path::finalize_path()
+    {
+        if(m_status == making_path && m_src_vertices.size() > 1)
+        {
+            unsigned i;
+            double dist;
+            double d;
+
+            m_src_vertices.close(false);
+            if(m_src_vertices.size() > 2)
+            {
+                if(m_src_vertices[m_src_vertices.size() - 2].dist * 10.0 < 
+                   m_src_vertices[m_src_vertices.size() - 3].dist)
+                {
+                    d = m_src_vertices[m_src_vertices.size() - 3].dist + 
+                        m_src_vertices[m_src_vertices.size() - 2].dist;
+
+                    m_src_vertices[m_src_vertices.size() - 2] = 
+                        m_src_vertices[m_src_vertices.size() - 1];
+
+                    m_src_vertices.remove_last();
+                    m_src_vertices[m_src_vertices.size() - 2].dist = d;
+                }
+            }
+
+            dist = 0.0;
+            for(i = 0; i < m_src_vertices.size(); i++)
+            {
+                vertex_dist& v = m_src_vertices[i];
+                double d = v.dist;
+                v.dist = dist;
+                dist += d;
+            }
+            m_kindex = (m_src_vertices.size() - 1) / dist;
+            m_status = ready;
+        }
+    }
+
+
+
+    //------------------------------------------------------------------------
+    double trans_single_path::total_length() const
+    {
+        if(m_base_length >= 1e-10) return m_base_length;
+        return (m_status == ready) ? 
+            m_src_vertices[m_src_vertices.size() - 1].dist :
+            0.0;
+    }
+
+
+    //------------------------------------------------------------------------
+    void trans_single_path::transform(double *x, double *y) const
+    {
+        if(m_status == ready)
+        {
+            if(m_base_length > 1e-10)
+            {
+                *x *= m_src_vertices[m_src_vertices.size() - 1].dist / 
+                      m_base_length;
+            }
+
+            double x1 = 0.0;
+            double y1 = 0.0;
+            double dx = 1.0;
+            double dy = 1.0;
+            double d  = 0.0;
+            double dd = 1.0;
+            if(*x < 0.0)
+            {
+                // Extrapolation on the left
+                //--------------------------
+                x1 = m_src_vertices[0].x;
+                y1 = m_src_vertices[0].y;
+                dx = m_src_vertices[1].x - x1;
+                dy = m_src_vertices[1].y - y1;
+                dd = m_src_vertices[1].dist - m_src_vertices[0].dist;
+                d  = *x;
+            }
+            else
+            if(*x > m_src_vertices[m_src_vertices.size() - 1].dist)
+            {
+                // Extrapolation on the right
+                //--------------------------
+                unsigned i = m_src_vertices.size() - 2;
+                unsigned j = m_src_vertices.size() - 1;
+                x1 = m_src_vertices[j].x;
+                y1 = m_src_vertices[j].y;
+                dx = x1 - m_src_vertices[i].x;
+                dy = y1 - m_src_vertices[i].y;
+                dd = m_src_vertices[j].dist - m_src_vertices[i].dist;
+                d  = *x - m_src_vertices[j].dist;
+            }
+            else
+            {
+                // Interpolation
+                //--------------------------
+                unsigned i = 0;
+                unsigned j = m_src_vertices.size() - 1;
+                if(m_preserve_x_scale)
+                {
+                    unsigned k;
+                    for(i = 0; (j - i) > 1; ) 
+                    {
+                        if(*x < m_src_vertices[k = (i + j) >> 1].dist) 
+                        {
+                            j = k; 
+                        }
+                        else 
+                        {
+                            i = k;
+                        }
+                    }
+                    d  = m_src_vertices[i].dist;
+                    dd = m_src_vertices[j].dist - d;
+                    d  = *x - d;
+                }
+                else
+                {
+                    i = unsigned(*x * m_kindex);
+                    j = i + 1;
+                    dd = m_src_vertices[j].dist - m_src_vertices[i].dist;
+                    d = ((*x * m_kindex) - i) * dd;
+                }
+                x1 = m_src_vertices[i].x;
+                y1 = m_src_vertices[i].y;
+                dx = m_src_vertices[j].x - x1;
+                dy = m_src_vertices[j].y - y1;
+            }
+            double x2 = x1 + dx * d / dd;
+            double y2 = y1 + dy * d / dd;
+            *x = x2 - *y * dy / dd;
+            *y = y2 + *y * dx / dd;
+        }
+    }
+
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_trans_warp_magnifier.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_warp_magnifier.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_trans_warp_magnifier.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_trans_warp_magnifier.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,70 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_trans_warp_magnifier.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    void trans_warp_magnifier::transform(double* x, double* y) const
+    {
+        double dx = *x - m_xc;
+        double dy = *y - m_yc;
+        double r = sqrt(dx * dx + dy * dy);
+        if(r < m_radius)
+        {
+            *x = m_xc + dx * m_magn;
+            *y = m_yc + dy * m_magn;
+            return;
+        }
+
+        double m = (r + m_radius * (m_magn - 1.0)) / r;
+        *x = m_xc + dx * m;
+        *y = m_yc + dy * m;
+    }
+
+    //------------------------------------------------------------------------
+    void trans_warp_magnifier::inverse_transform(double* x, double* y) const
+    {
+        // New version by Andrew Skalkin
+        //-----------------
+        double dx = *x - m_xc;
+        double dy = *y - m_yc;
+        double r = sqrt(dx * dx + dy * dy);
+
+        if(r < m_radius * m_magn) 
+        {
+            *x = m_xc + dx / m_magn;
+            *y = m_yc + dy / m_magn;
+        }
+        else
+        {
+            double rnew = r - m_radius * (m_magn - 1.0);
+            *x = m_xc + rnew * dx / r; 
+            *y = m_yc + rnew * dy / r;
+        }
+
+        // Old version
+        //-----------------
+        //trans_warp_magnifier t(*this);
+        //t.magnification(1.0 / m_magn);
+        //t.radius(m_radius * m_magn);
+        //t.transform(x, y);
+    }
+
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vcgen_bspline.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_bspline.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vcgen_bspline.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_bspline.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,194 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include "../include/agg_vcgen_bspline.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    vcgen_bspline::vcgen_bspline() :
+        m_src_vertices(),
+        m_spline_x(),
+        m_spline_y(),
+        m_interpolation_step(1.0/50.0),
+        m_closed(0),
+        m_status(initial),
+        m_src_vertex(0)
+    {
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_bspline::remove_all()
+    {
+        m_src_vertices.remove_all();
+        m_closed = 0;
+        m_status = initial;
+        m_src_vertex = 0;
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_bspline::add_vertex(double x, double y, unsigned cmd)
+    {
+        m_status = initial;
+        if(is_move_to(cmd))
+        {
+            m_src_vertices.modify_last(point_d(x, y));
+        }
+        else
+        {
+            if(is_vertex(cmd))
+            {
+                m_src_vertices.add(point_d(x, y));
+            }
+            else
+            {
+                m_closed = get_close_flag(cmd);
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_bspline::rewind(unsigned)
+    {
+        m_cur_abscissa = 0.0;
+        m_max_abscissa = 0.0;
+        m_src_vertex = 0;
+        if(m_status == initial && m_src_vertices.size() > 2)
+        {
+            if(m_closed)
+            {
+                m_spline_x.init(m_src_vertices.size() + 8);
+                m_spline_y.init(m_src_vertices.size() + 8);
+                m_spline_x.add_point(0.0, m_src_vertices.prev(m_src_vertices.size() - 3).x);
+                m_spline_y.add_point(0.0, m_src_vertices.prev(m_src_vertices.size() - 3).y);
+                m_spline_x.add_point(1.0, m_src_vertices[m_src_vertices.size() - 3].x);
+                m_spline_y.add_point(1.0, m_src_vertices[m_src_vertices.size() - 3].y);
+                m_spline_x.add_point(2.0, m_src_vertices[m_src_vertices.size() - 2].x);
+                m_spline_y.add_point(2.0, m_src_vertices[m_src_vertices.size() - 2].y);
+                m_spline_x.add_point(3.0, m_src_vertices[m_src_vertices.size() - 1].x);
+                m_spline_y.add_point(3.0, m_src_vertices[m_src_vertices.size() - 1].y);
+            }
+            else
+            {
+                m_spline_x.init(m_src_vertices.size());
+                m_spline_y.init(m_src_vertices.size());
+            }
+            unsigned i;
+            for(i = 0; i < m_src_vertices.size(); i++)
+            {
+                double x = m_closed ? i + 4 : i;
+                m_spline_x.add_point(x, m_src_vertices[i].x);
+                m_spline_y.add_point(x, m_src_vertices[i].y);
+            }
+            m_cur_abscissa = 0.0;
+            m_max_abscissa = m_src_vertices.size() - 1;
+            if(m_closed)
+            {
+                m_cur_abscissa = 4.0;
+                m_max_abscissa += 5.0;
+                m_spline_x.add_point(m_src_vertices.size() + 4, m_src_vertices[0].x);
+                m_spline_y.add_point(m_src_vertices.size() + 4, m_src_vertices[0].y);
+                m_spline_x.add_point(m_src_vertices.size() + 5, m_src_vertices[1].x);
+                m_spline_y.add_point(m_src_vertices.size() + 5, m_src_vertices[1].y);
+                m_spline_x.add_point(m_src_vertices.size() + 6, m_src_vertices[2].x);
+                m_spline_y.add_point(m_src_vertices.size() + 6, m_src_vertices[2].y);
+                m_spline_x.add_point(m_src_vertices.size() + 7, m_src_vertices.next(2).x);
+                m_spline_y.add_point(m_src_vertices.size() + 7, m_src_vertices.next(2).y);
+            }
+            m_spline_x.prepare();
+            m_spline_y.prepare();
+        }
+        m_status = ready;
+    }
+
+
+
+
+
+
+    //------------------------------------------------------------------------
+    unsigned vcgen_bspline::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_line_to;
+        while(!is_stop(cmd))
+        {
+            switch(m_status)
+            {
+            case initial:
+                rewind(0);
+
+            case ready:
+                if(m_src_vertices.size() < 2)
+                {
+                    cmd = path_cmd_stop;
+                    break;
+                }
+
+                if(m_src_vertices.size() == 2)
+                {
+                    *x = m_src_vertices[m_src_vertex].x;
+                    *y = m_src_vertices[m_src_vertex].y;
+                    m_src_vertex++;
+                    if(m_src_vertex == 1) return path_cmd_move_to;
+                    if(m_src_vertex == 2) return path_cmd_line_to;
+                    cmd = path_cmd_stop;
+                    break;
+                }
+
+                cmd = path_cmd_move_to;
+                m_status = polygon;
+                m_src_vertex = 0;
+
+            case polygon:
+                if(m_cur_abscissa >= m_max_abscissa)
+                {
+                    if(m_closed)
+                    {
+                        m_status = end_poly;
+                        break;
+                    }
+                    else
+                    {
+                        *x = m_src_vertices[m_src_vertices.size() - 1].x;
+                        *y = m_src_vertices[m_src_vertices.size() - 1].y;
+                        m_status = end_poly;
+                        return path_cmd_line_to;
+                    }
+                }
+
+                *x = m_spline_x.get_stateful(m_cur_abscissa);
+                *y = m_spline_y.get_stateful(m_cur_abscissa);
+                m_src_vertex++;
+                m_cur_abscissa += m_interpolation_step;
+                return (m_src_vertex == 1) ? path_cmd_move_to : path_cmd_line_to;
+
+            case end_poly:
+                m_status = stop;
+                return path_cmd_end_poly | m_closed;
+
+            case stop:
+                return path_cmd_stop;
+            }
+        }
+        return cmd;
+    }
+
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vcgen_contour.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_contour.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vcgen_contour.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_contour.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,168 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Contour generator
+//
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_vcgen_contour.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    vcgen_contour::vcgen_contour() :
+        m_stroker(),
+        m_width(1),
+        m_src_vertices(),
+        m_out_vertices(),
+        m_status(initial),
+        m_src_vertex(0),
+        m_closed(0),
+        m_orientation(0),
+        m_auto_detect(false)
+    {
+    }
+
+    //------------------------------------------------------------------------
+    void vcgen_contour::remove_all()
+    {
+        m_src_vertices.remove_all();
+        m_closed = 0;
+        m_orientation = 0;
+        m_status = initial;
+    }
+
+    //------------------------------------------------------------------------
+    void vcgen_contour::add_vertex(double x, double y, unsigned cmd)
+    {
+        m_status = initial;
+        if(is_move_to(cmd))
+        {
+            m_src_vertices.modify_last(vertex_dist(x, y));
+        }
+        else
+        {
+            if(is_vertex(cmd))
+            {
+                m_src_vertices.add(vertex_dist(x, y));
+            }
+            else
+            {
+                if(is_end_poly(cmd))
+                {
+                    m_closed = get_close_flag(cmd);
+                    if(m_orientation == path_flags_none) 
+                    {
+                        m_orientation = get_orientation(cmd);
+                    }
+                }
+            }
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void vcgen_contour::rewind(unsigned)
+    {
+        if(m_status == initial)
+        {
+            m_src_vertices.close(true);
+            if(m_auto_detect)
+            {
+                if(!is_oriented(m_orientation))
+                {
+                    m_orientation = (calc_polygon_area(m_src_vertices) > 0.0) ? 
+                                    path_flags_ccw : 
+                                    path_flags_cw;
+                }
+            }
+            if(is_oriented(m_orientation))
+            {
+                m_stroker.width(is_ccw(m_orientation) ? m_width : -m_width);
+            }
+        }
+        m_status = ready;
+        m_src_vertex = 0;
+    }
+
+    //------------------------------------------------------------------------
+    unsigned vcgen_contour::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_line_to;
+        while(!is_stop(cmd))
+        {
+            switch(m_status)
+            {
+            case initial:
+                rewind(0);
+                // FALLTHROUGH
+
+            case ready:
+                if(m_src_vertices.size() < 2 + unsigned(m_closed != 0))
+                {
+                    cmd = path_cmd_stop;
+                    break;
+                }
+                m_status = outline;
+                cmd = path_cmd_move_to;
+                m_src_vertex = 0;
+                m_out_vertex = 0;
+                // FALLTHROUGH
+
+            case outline:
+                if(m_src_vertex >= m_src_vertices.size())
+                {
+                    m_status = end_poly;
+                    break;
+                }
+                m_stroker.calc_join(m_out_vertices, 
+                                    m_src_vertices.prev(m_src_vertex), 
+                                    m_src_vertices.curr(m_src_vertex), 
+                                    m_src_vertices.next(m_src_vertex), 
+                                    m_src_vertices.prev(m_src_vertex).dist,
+                                    m_src_vertices.curr(m_src_vertex).dist);
+                ++m_src_vertex;
+                m_status = out_vertices;
+                m_out_vertex = 0;
+                // FALLTHROUGH
+
+            case out_vertices:
+                if(m_out_vertex >= m_out_vertices.size())
+                {
+                    m_status = outline;
+                }
+                else
+                {
+                    const point_d& c = m_out_vertices[m_out_vertex++];
+                    *x = c.x;
+                    *y = c.y;
+                    return cmd;
+                }
+                break;
+
+            case end_poly:
+                if(!m_closed) return path_cmd_stop;
+                m_status = stop;
+                return path_cmd_end_poly | path_flags_close | path_flags_ccw;
+
+            case stop:
+                return path_cmd_stop;
+            }
+        }
+        return cmd;
+    }
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vcgen_dash.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_dash.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vcgen_dash.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_dash.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,236 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Line dash generator
+//
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_vcgen_dash.h"
+#include "../include/agg_shorten_path.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    vcgen_dash::vcgen_dash() :
+        m_total_dash_len(0.0),
+        m_num_dashes(0),
+        m_dash_start(0.0),
+        m_shorten(0.0),
+        m_curr_dash_start(0.0),
+        m_curr_dash(0),
+        m_src_vertices(),
+        m_closed(0),
+        m_status(initial),
+        m_src_vertex(0)
+    {
+    }
+
+
+
+    //------------------------------------------------------------------------
+    void vcgen_dash::remove_all_dashes()
+    {
+        m_total_dash_len = 0.0;
+        m_num_dashes = 0;
+        m_curr_dash_start = 0.0;
+        m_curr_dash = 0;
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_dash::add_dash(double dash_len, double gap_len)
+    {
+        if(m_num_dashes < max_dashes-1)
+        {
+            m_total_dash_len += dash_len + gap_len;
+            m_dashes[m_num_dashes++] = dash_len;
+            m_dashes[m_num_dashes++] = gap_len;
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_dash::dash_start(double ds)
+    {
+        m_dash_start = ds;
+        calc_dash_start(fabs(ds));
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_dash::calc_dash_start(double ds)
+    {
+        m_curr_dash = 0;
+        m_curr_dash_start = 0.0;
+        while(ds > 0.0)
+        {
+            if(ds > m_dashes[m_curr_dash])
+            {
+                ds -= m_dashes[m_curr_dash];
+                ++m_curr_dash;
+                m_curr_dash_start = 0.0;
+                if(m_curr_dash >= m_num_dashes) m_curr_dash = 0;
+            }
+            else
+            {
+                m_curr_dash_start = ds;
+                ds = 0.0;
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_dash::remove_all()
+    {
+        m_status = initial;
+        m_src_vertices.remove_all();
+        m_closed = 0;
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_dash::add_vertex(double x, double y, unsigned cmd)
+    {
+        m_status = initial;
+        if(is_move_to(cmd))
+        {
+            m_src_vertices.modify_last(vertex_dist(x, y));
+        }
+        else
+        {
+            if(is_vertex(cmd))
+            {
+                m_src_vertices.add(vertex_dist(x, y));
+            }
+            else
+            {
+                m_closed = get_close_flag(cmd);
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_dash::rewind(unsigned)
+    {
+        if(m_status == initial)
+        {
+            m_src_vertices.close(m_closed != 0);
+            shorten_path(m_src_vertices, m_shorten, m_closed);
+        }
+        m_status = ready;
+        m_src_vertex = 0;
+    }
+
+
+    //------------------------------------------------------------------------
+    unsigned vcgen_dash::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_move_to;
+        while(!is_stop(cmd))
+        {
+            switch(m_status)
+            {
+            case initial:
+                rewind(0);
+                // FALLTHROUGH
+
+            case ready:
+                if(m_num_dashes < 2 || m_src_vertices.size() < 2)
+                {
+                    cmd = path_cmd_stop;
+                    break;
+                }
+                m_status = polyline;
+                m_src_vertex = 1;
+                m_v1 = &m_src_vertices[0];
+                m_v2 = &m_src_vertices[1];
+                m_curr_rest = m_v1->dist;
+                *x = m_v1->x;
+                *y = m_v1->y;
+                if(m_dash_start >= 0.0) calc_dash_start(m_dash_start);
+                return path_cmd_move_to;
+
+            case polyline:
+                {
+                    double dash_rest = m_dashes[m_curr_dash] - m_curr_dash_start;
+
+                    unsigned cmd = (m_curr_dash & 1) ? 
+                                   path_cmd_move_to : 
+                                   path_cmd_line_to;
+
+                    if(m_curr_rest > dash_rest)
+                    {
+                        m_curr_rest -= dash_rest;
+                        ++m_curr_dash;
+                        if(m_curr_dash >= m_num_dashes) m_curr_dash = 0;
+                        m_curr_dash_start = 0.0;
+                        *x = m_v2->x - (m_v2->x - m_v1->x) * m_curr_rest / m_v1->dist;
+                        *y = m_v2->y - (m_v2->y - m_v1->y) * m_curr_rest / m_v1->dist;
+                    }
+                    else
+                    {
+                        m_curr_dash_start += m_curr_rest;
+                        *x = m_v2->x;
+                        *y = m_v2->y;
+                        ++m_src_vertex;
+                        m_v1 = m_v2;
+                        m_curr_rest = m_v1->dist;
+                        if(m_closed)
+                        {
+                            if(m_src_vertex > m_src_vertices.size())
+                            {
+                                m_status = stop;
+                            }
+                            else
+                            {
+                                m_v2 = &m_src_vertices
+                                [
+                                    (m_src_vertex >= m_src_vertices.size()) ? 0 : 
+                                    m_src_vertex
+                                ];
+                            }
+                        }
+                        else
+                        {
+                            if(m_src_vertex >= m_src_vertices.size())
+                            {
+                                m_status = stop;
+                            }
+                            else
+                            {
+                                m_v2 = &m_src_vertices[m_src_vertex];
+                            }
+                        }
+                    }
+                    return cmd;
+                }
+                break;
+
+            case stop:
+                cmd = path_cmd_stop;
+                break;
+            }
+
+        }
+        return path_cmd_stop;
+    }
+
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vcgen_markers_term.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_markers_term.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vcgen_markers_term.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_markers_term.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,103 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Terminal markers generator (arrowhead/arrowtail)
+//
+//----------------------------------------------------------------------------
+
+#include "../include/agg_vcgen_markers_term.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    void vcgen_markers_term::remove_all()
+    {
+        m_markers.remove_all();
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_markers_term::add_vertex(double x, double y, unsigned cmd)
+    {
+        if(is_move_to(cmd))
+        {
+            if(m_markers.size() & 1)
+            {
+                // Initial state, the first coordinate was added.
+                // If two of more calls of start_vertex() occures
+                // we just modify the last one.
+                m_markers.modify_last(coord_type(x, y));
+            }
+            else
+            {
+                m_markers.add(coord_type(x, y));
+            }
+        }
+        else
+        {
+            if(is_vertex(cmd))
+            {
+                if(m_markers.size() & 1)
+                {
+                    // Initial state, the first coordinate was added.
+                    // Add three more points, 0,1,1,0
+                    m_markers.add(coord_type(x, y));
+                    m_markers.add(m_markers[m_markers.size() - 1]);
+                    m_markers.add(m_markers[m_markers.size() - 3]);
+                }
+                else
+                {
+                    if(m_markers.size())
+                    {
+                        // Replace two last points: 0,1,1,0 -> 0,1,2,1
+                        m_markers[m_markers.size() - 1] = m_markers[m_markers.size() - 2];
+                        m_markers[m_markers.size() - 2] = coord_type(x, y);
+                    }
+                }
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_markers_term::rewind(unsigned path_id)
+    {
+        m_curr_id = path_id * 2;
+        m_curr_idx = m_curr_id;
+    }
+
+
+    //------------------------------------------------------------------------
+    unsigned vcgen_markers_term::vertex(double* x, double* y)
+    {
+        if(m_curr_id > 2 || m_curr_idx >= m_markers.size()) 
+        {
+            return path_cmd_stop;
+        }
+        const coord_type& c = m_markers[m_curr_idx];
+        *x = c.x;
+        *y = c.y;
+        if(m_curr_idx & 1)
+        {
+            m_curr_idx += 3;
+            return path_cmd_line_to;
+        }
+        ++m_curr_idx;
+        return path_cmd_move_to;
+    }
+
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vcgen_smooth_poly1.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_smooth_poly1.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vcgen_smooth_poly1.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_smooth_poly1.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,225 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Smooth polygon generator
+//
+//----------------------------------------------------------------------------
+
+#include "../include/agg_vcgen_smooth_poly1.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    vcgen_smooth_poly1::vcgen_smooth_poly1() :
+        m_src_vertices(),
+        m_smooth_value(0.5),
+        m_closed(0),
+        m_status(initial),
+        m_src_vertex(0)
+    {
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_smooth_poly1::remove_all()
+    {
+        m_src_vertices.remove_all();
+        m_closed = 0;
+        m_status = initial;
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_smooth_poly1::add_vertex(double x, double y, unsigned cmd)
+    {
+        m_status = initial;
+        if(is_move_to(cmd))
+        {
+            m_src_vertices.modify_last(vertex_dist(x, y));
+        }
+        else
+        {
+            if(is_vertex(cmd))
+            {
+                m_src_vertices.add(vertex_dist(x, y));
+            }
+            else
+            {
+                m_closed = get_close_flag(cmd);
+            }
+        }
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_smooth_poly1::rewind(unsigned)
+    {
+        if(m_status == initial)
+        {
+            m_src_vertices.close(m_closed != 0);
+        }
+        m_status = ready;
+        m_src_vertex = 0;
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_smooth_poly1::calculate(const vertex_dist& v0, 
+                                       const vertex_dist& v1, 
+                                       const vertex_dist& v2,
+                                       const vertex_dist& v3)
+    {
+
+        double k1 = v0.dist / (v0.dist + v1.dist);
+        double k2 = v1.dist / (v1.dist + v2.dist);
+
+        double xm1 = v0.x + (v2.x - v0.x) * k1;
+        double ym1 = v0.y + (v2.y - v0.y) * k1;
+        double xm2 = v1.x + (v3.x - v1.x) * k2;
+        double ym2 = v1.y + (v3.y - v1.y) * k2;
+
+        m_ctrl1_x = v1.x + m_smooth_value * (v2.x - xm1);
+        m_ctrl1_y = v1.y + m_smooth_value * (v2.y - ym1);
+        m_ctrl2_x = v2.x + m_smooth_value * (v1.x - xm2);
+        m_ctrl2_y = v2.y + m_smooth_value * (v1.y - ym2);
+    }
+
+
+    //------------------------------------------------------------------------
+    unsigned vcgen_smooth_poly1::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_line_to;
+        while(!is_stop(cmd))
+        {
+            switch(m_status)
+            {
+            case initial:
+                rewind(0);
+
+            case ready:
+                if(m_src_vertices.size() <  2)
+                {
+                    cmd = path_cmd_stop;
+                    break;
+                }
+
+                if(m_src_vertices.size() == 2)
+                {
+                    *x = m_src_vertices[m_src_vertex].x;
+                    *y = m_src_vertices[m_src_vertex].y;
+                    m_src_vertex++;
+                    if(m_src_vertex == 1) return path_cmd_move_to;
+                    if(m_src_vertex == 2) return path_cmd_line_to;
+                    cmd = path_cmd_stop;
+                    break;
+                }
+
+                cmd = path_cmd_move_to;
+                m_status = polygon;
+                m_src_vertex = 0;
+
+            case polygon:
+                if(m_closed)
+                {
+                    if(m_src_vertex >= m_src_vertices.size())
+                    {
+                        *x = m_src_vertices[0].x;
+                        *y = m_src_vertices[0].y;
+                        m_status = end_poly;
+                        return path_cmd_curve4;
+                    }
+                }
+                else
+                {
+                    if(m_src_vertex >= m_src_vertices.size() - 1)
+                    {
+                        *x = m_src_vertices[m_src_vertices.size() - 1].x;
+                        *y = m_src_vertices[m_src_vertices.size() - 1].y;
+                        m_status = end_poly;
+                        return path_cmd_curve3;
+                    }
+                }
+
+                calculate(m_src_vertices.prev(m_src_vertex), 
+                          m_src_vertices.curr(m_src_vertex), 
+                          m_src_vertices.next(m_src_vertex),
+                          m_src_vertices.next(m_src_vertex + 1));
+
+                *x = m_src_vertices[m_src_vertex].x;
+                *y = m_src_vertices[m_src_vertex].y;
+                m_src_vertex++;
+
+                if(m_closed)
+                {
+                    m_status = ctrl1;
+                    return ((m_src_vertex == 1) ? 
+                             path_cmd_move_to : 
+                             path_cmd_curve4);
+                }
+                else
+                {
+                    if(m_src_vertex == 1)
+                    {
+                        m_status = ctrl_b;
+                        return path_cmd_move_to;
+                    }
+                    if(m_src_vertex >= m_src_vertices.size() - 1)
+                    {
+                        m_status = ctrl_e;
+                        return path_cmd_curve3;
+                    }
+                    m_status = ctrl1;
+                    return path_cmd_curve4;
+                }
+                break;
+
+            case ctrl_b:
+                *x = m_ctrl2_x;
+                *y = m_ctrl2_y;
+                m_status = polygon;
+                return path_cmd_curve3;
+
+            case ctrl_e:
+                *x = m_ctrl1_x;
+                *y = m_ctrl1_y;
+                m_status = polygon;
+                return path_cmd_curve3;
+
+            case ctrl1:
+                *x = m_ctrl1_x;
+                *y = m_ctrl1_y;
+                m_status = ctrl2;
+                return path_cmd_curve4;
+
+            case ctrl2:
+                *x = m_ctrl2_x;
+                *y = m_ctrl2_y;
+                m_status = polygon;
+                return path_cmd_curve4;
+
+            case end_poly:
+                m_status = stop;
+                return path_cmd_end_poly | m_closed;
+
+            case stop:
+                return path_cmd_stop;
+            }
+        }
+        return cmd;
+    }
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vcgen_stroke.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_stroke.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vcgen_stroke.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vcgen_stroke.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,215 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+//
+// Stroke generator
+//
+//----------------------------------------------------------------------------
+#include <math.h>
+#include "../include/agg_vcgen_stroke.h"
+#include "../include/agg_shorten_path.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    vcgen_stroke::vcgen_stroke() :
+        m_stroker(),
+        m_src_vertices(),
+        m_out_vertices(),
+        m_shorten(0.0),
+        m_closed(0),
+        m_status(initial),
+        m_src_vertex(0),
+        m_out_vertex(0)
+    {
+    }
+
+    //------------------------------------------------------------------------
+    void vcgen_stroke::remove_all()
+    {
+        m_src_vertices.remove_all();
+        m_closed = 0;
+        m_status = initial;
+    }
+
+
+    //------------------------------------------------------------------------
+    void vcgen_stroke::add_vertex(double x, double y, unsigned cmd)
+    {
+        m_status = initial;
+        if(is_move_to(cmd))
+        {
+            m_src_vertices.modify_last(vertex_dist(x, y));
+        }
+        else
+        {
+            if(is_vertex(cmd))
+            {
+                m_src_vertices.add(vertex_dist(x, y));
+            }
+            else
+            {
+                m_closed = get_close_flag(cmd);
+            }
+        }
+    }
+
+    //------------------------------------------------------------------------
+    void vcgen_stroke::rewind(unsigned)
+    {
+        if(m_status == initial)
+        {
+            m_src_vertices.close(m_closed != 0);
+            shorten_path(m_src_vertices, m_shorten, m_closed);
+            if(m_src_vertices.size() < 3) m_closed = 0;
+        }
+        m_status = ready;
+        m_src_vertex = 0;
+        m_out_vertex = 0;
+    }
+
+
+    //------------------------------------------------------------------------
+    unsigned vcgen_stroke::vertex(double* x, double* y)
+    {
+        unsigned cmd = path_cmd_line_to;
+        while(!is_stop(cmd))
+        {
+            switch(m_status)
+            {
+            case initial:
+                rewind(0);
+                // FALLTHROUGH
+
+            case ready:
+                if(m_src_vertices.size() < 2 + unsigned(m_closed != 0))
+                {
+                    cmd = path_cmd_stop;
+                    break;
+                }
+                m_status = m_closed ? outline1 : cap1;
+                cmd = path_cmd_move_to;
+                m_src_vertex = 0;
+                m_out_vertex = 0;
+                break;
+
+            case cap1:
+                m_stroker.calc_cap(m_out_vertices,
+                                   m_src_vertices[0], 
+                                   m_src_vertices[1], 
+                                   m_src_vertices[0].dist);
+                m_src_vertex = 1;
+                m_prev_status = outline1;
+                m_status = out_vertices;
+                m_out_vertex = 0;
+                break;
+
+            case cap2:
+                m_stroker.calc_cap(m_out_vertices,
+                                   m_src_vertices[m_src_vertices.size() - 1], 
+                                   m_src_vertices[m_src_vertices.size() - 2], 
+                                   m_src_vertices[m_src_vertices.size() - 2].dist);
+                m_prev_status = outline2;
+                m_status = out_vertices;
+                m_out_vertex = 0;
+                break;
+
+            case outline1:
+                if(m_closed)
+                {
+                    if(m_src_vertex >= m_src_vertices.size())
+                    {
+                        m_prev_status = close_first;
+                        m_status = end_poly1;
+                        break;
+                    }
+                }
+                else
+                {
+                    if(m_src_vertex >= m_src_vertices.size() - 1)
+                    {
+                        m_status = cap2;
+                        break;
+                    }
+                }
+                m_stroker.calc_join(m_out_vertices, 
+                                    m_src_vertices.prev(m_src_vertex), 
+                                    m_src_vertices.curr(m_src_vertex), 
+                                    m_src_vertices.next(m_src_vertex), 
+                                    m_src_vertices.prev(m_src_vertex).dist,
+                                    m_src_vertices.curr(m_src_vertex).dist);
+                ++m_src_vertex;
+                m_prev_status = m_status;
+                m_status = out_vertices;
+                m_out_vertex = 0;
+                break;
+
+            case close_first:
+                m_status = outline2;
+                cmd = path_cmd_move_to;
+                // FALLTHROUGH
+
+            case outline2:
+                if(m_src_vertex <= unsigned(m_closed == 0))
+                {
+                    m_status = end_poly2;
+                    m_prev_status = stop;
+                    break;
+                }
+
+                --m_src_vertex;
+                m_stroker.calc_join(m_out_vertices,
+                                    m_src_vertices.next(m_src_vertex), 
+                                    m_src_vertices.curr(m_src_vertex), 
+                                    m_src_vertices.prev(m_src_vertex), 
+                                    m_src_vertices.curr(m_src_vertex).dist, 
+                                    m_src_vertices.prev(m_src_vertex).dist);
+
+                m_prev_status = m_status;
+                m_status = out_vertices;
+                m_out_vertex = 0;
+                break;
+
+            case out_vertices:
+                if(m_out_vertex >= m_out_vertices.size())
+                {
+                    m_status = m_prev_status;
+                }
+                else
+                {
+                    const point_d& c = m_out_vertices[m_out_vertex++];
+                    *x = c.x;
+                    *y = c.y;
+                    return cmd;
+                }
+                break;
+
+            case end_poly1:
+                m_status = m_prev_status;
+                return path_cmd_end_poly | path_flags_close | path_flags_ccw;
+
+            case end_poly2:
+                m_status = m_prev_status;
+                return path_cmd_end_poly | path_flags_close | path_flags_cw;
+
+            case stop:
+                cmd = path_cmd_stop;
+                break;
+            }
+        }
+        return cmd;
+    }
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vpgen_clip_polygon.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vpgen_clip_polygon.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vpgen_clip_polygon.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vpgen_clip_polygon.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,133 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include "../include/agg_vpgen_clip_polygon.h"
+#include "../include/agg_clip_liang_barsky.h"
+
+namespace mapserver
+{
+
+    //------------------------------------------------------------------------
+    // Determine the clipping code of the vertex according to the 
+    // Cyrus-Beck line clipping algorithm
+    //
+    //        |        |
+    //  0110  |  0010  | 0011
+    //        |        |
+    // -------+--------+-------- clip_box.y2
+    //        |        |
+    //  0100  |  0000  | 0001
+    //        |        |
+    // -------+--------+-------- clip_box.y1
+    //        |        |
+    //  1100  |  1000  | 1001
+    //        |        |
+    //  clip_box.x1  clip_box.x2
+    //
+    // 
+    unsigned vpgen_clip_polygon::clipping_flags(double x, double y)
+    {
+        if(x < m_clip_box.x1) 
+        {
+            if(y > m_clip_box.y2) return 6;
+            if(y < m_clip_box.y1) return 12;
+            return 4;
+        }
+
+        if(x > m_clip_box.x2) 
+        {
+            if(y > m_clip_box.y2) return 3;
+            if(y < m_clip_box.y1) return 9;
+            return 1;
+        }
+
+        if(y > m_clip_box.y2) return 2;
+        if(y < m_clip_box.y1) return 8;
+
+        return 0;
+    }
+
+    //----------------------------------------------------------------------------
+    void vpgen_clip_polygon::reset()
+    {
+        m_vertex = 0;
+        m_num_vertices = 0;
+    }
+
+    //----------------------------------------------------------------------------
+    void vpgen_clip_polygon::move_to(double x, double y)
+    {
+        m_vertex = 0;
+        m_num_vertices = 0;
+        m_clip_flags = clipping_flags(x, y);
+        if(m_clip_flags == 0)
+        {
+            m_x[0] = x;
+            m_y[0] = y;
+            m_num_vertices = 1;
+        }
+        m_x1  = x;
+        m_y1  = y;
+        m_cmd = path_cmd_move_to;
+    }
+
+
+    //----------------------------------------------------------------------------
+    void vpgen_clip_polygon::line_to(double x, double y)
+    {
+        m_vertex = 0;
+        m_num_vertices = 0;
+        unsigned flags = clipping_flags(x, y);
+
+        if(m_clip_flags == flags)
+        {
+            if(flags == 0)
+            {
+                m_x[0] = x;
+                m_y[0] = y;
+                m_num_vertices = 1;
+            }
+        }
+        else
+        {
+            m_num_vertices = clip_liang_barsky(m_x1, m_y1, 
+                                               x, y, 
+                                               m_clip_box, 
+                                               m_x, m_y);
+        }
+
+        m_clip_flags = flags;
+        m_x1 = x;
+        m_y1 = y;
+    }
+
+
+    //----------------------------------------------------------------------------
+    unsigned vpgen_clip_polygon::vertex(double* x, double* y)
+    {
+        if(m_vertex < m_num_vertices)
+        {
+            *x = m_x[m_vertex];
+            *y = m_y[m_vertex];
+            ++m_vertex;
+            unsigned cmd = m_cmd;
+            m_cmd = path_cmd_line_to;
+            return cmd;
+        }
+        return path_cmd_stop;
+    }
+
+
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vpgen_clip_polyline.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vpgen_clip_polyline.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vpgen_clip_polyline.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vpgen_clip_polyline.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,77 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include "../include/agg_vpgen_clip_polyline.h"
+#include "../include/agg_clip_liang_barsky.h"
+
+namespace mapserver
+{
+    //----------------------------------------------------------------------------
+    void vpgen_clip_polyline::reset()
+    {
+        m_vertex = 0;
+        m_num_vertices = 0;
+        m_move_to = false;
+    }
+
+    //----------------------------------------------------------------------------
+    void vpgen_clip_polyline::move_to(double x, double y)
+    {
+        m_vertex = 0;
+        m_num_vertices = 0;
+        m_x1 = x;
+        m_y1 = y;
+        m_move_to = true;
+    }
+
+    //----------------------------------------------------------------------------
+    void vpgen_clip_polyline::line_to(double x, double y)
+    {
+        double x2 = x;
+        double y2 = y;
+        unsigned flags = clip_line_segment(&m_x1, &m_y1, &x2, &y2, m_clip_box);
+
+        m_vertex = 0;
+        m_num_vertices = 0;
+        if((flags & 4) == 0)
+        {
+            if((flags & 1) != 0 || m_move_to)
+            {
+                m_x[0] = m_x1;
+                m_y[0] = m_y1;
+                m_cmd[0] = path_cmd_move_to;
+                m_num_vertices = 1;
+            }
+            m_x[m_num_vertices] = x2;
+            m_y[m_num_vertices] = y2;
+            m_cmd[m_num_vertices++] = path_cmd_line_to;
+            m_move_to = (flags & 2) != 0;
+        }
+        m_x1 = x;
+        m_y1 = y;
+    }
+
+    //----------------------------------------------------------------------------
+    unsigned vpgen_clip_polyline::vertex(double* x, double* y)
+    {
+        if(m_vertex < m_num_vertices)
+        {
+            *x = m_x[m_vertex];
+            *y = m_y[m_vertex];
+            return m_cmd[m_vertex++];
+        }
+        return path_cmd_stop;
+    }
+}
diff -pruN 8.0.1-5/src/renderers/agg/src/agg_vpgen_segmentator.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vpgen_segmentator.cpp
--- 8.0.1-5/src/renderers/agg/src/agg_vpgen_segmentator.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/agg_vpgen_segmentator.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,67 @@
+//----------------------------------------------------------------------------
+// Anti-Grain Geometry - Version 2.4
+// Copyright (C) 2002-2005 Maxim Shemanarev (http://www.antigrain.com)
+//
+// Permission to copy, use, modify, sell and distribute this software 
+// is granted provided this copyright notice appears in all copies. 
+// This software is provided "as is" without express or implied
+// warranty, and with no claim as to its suitability for any purpose.
+//
+//----------------------------------------------------------------------------
+// Contact: mcseem@antigrain.com
+//          mcseemagg@yahoo.com
+//          http://www.antigrain.com
+//----------------------------------------------------------------------------
+
+#include <math.h>
+#include "../include/agg_vpgen_segmentator.h"
+
+namespace mapserver
+{
+
+    void vpgen_segmentator::move_to(double x, double y)
+    {
+        m_x1 = x;
+        m_y1 = y;
+        m_dx = 0.0;
+        m_dy = 0.0;
+        m_dl = 2.0;
+        m_ddl = 2.0;
+        m_cmd = path_cmd_move_to;
+    }
+
+    void vpgen_segmentator::line_to(double x, double y)
+    {
+        m_x1 += m_dx;
+        m_y1 += m_dy;
+        m_dx  = x - m_x1;
+        m_dy  = y - m_y1;
+        double len = sqrt(m_dx * m_dx + m_dy * m_dy) * m_approximation_scale;
+        if(len < 1e-30) len = 1e-30;
+        m_ddl = 1.0 / len;
+        m_dl  = (m_cmd == path_cmd_move_to) ? 0.0 : m_ddl;
+        if(m_cmd == path_cmd_stop) m_cmd = path_cmd_line_to;
+    }
+
+    unsigned vpgen_segmentator::vertex(double* x, double* y)
+    {
+        if(m_cmd == path_cmd_stop) return path_cmd_stop;
+
+        unsigned cmd = m_cmd;
+        m_cmd = path_cmd_line_to;
+        if(m_dl >= 1.0 - m_ddl)
+        {
+            m_dl = 1.0;
+            m_cmd = path_cmd_stop;
+            *x = m_x1 + m_dx;
+            *y = m_y1 + m_dy;
+            return cmd;
+        }
+        *x = m_x1 + m_dx * m_dl;
+        *y = m_y1 + m_dy * m_dl;
+        m_dl += m_ddl;
+        return cmd;
+    }
+
+}
+
diff -pruN 8.0.1-5/src/renderers/agg/src/autogen.sh 8.2.0~beta1-1~exp1/src/renderers/agg/src/autogen.sh
--- 8.0.1-5/src/renderers/agg/src/autogen.sh	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/autogen.sh	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,20 @@
+# autogen.sh
+#
+# invoke the auto* tools to create the configureation system
+
+# build aclocal.m4
+aclocal
+
+# build the configure script
+autoconf
+
+# set up libtool
+libtoolize --force
+
+# invoke automake
+automake --foreign --add-missing
+
+# and finally invoke our new configure
+./configure $*
+
+# end
diff -pruN 8.0.1-5/src/renderers/agg/src/clipper.cpp 8.2.0~beta1-1~exp1/src/renderers/agg/src/clipper.cpp
--- 8.0.1-5/src/renderers/agg/src/clipper.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/clipper.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,3310 @@
+/*******************************************************************************
+*                                                                              *
+* Author    :  Angus Johnson                                                   *
+* Version   :  4.6.3                                                           *
+* Date      :  11 November 2011                                                *
+* Website   :  http://www.angusj.com                                           *
+* Copyright :  Angus Johnson 2010-2011                                         *
+*                                                                              *
+* License:                                                                     *
+* Use, modification & distribution is subject to Boost Software License Ver 1. *
+* http://www.boost.org/LICENSE_1_0.txt                                         *
+*                                                                              *
+* Attributions:                                                                *
+* The code in this library is an extension of Bala Vatti's clipping algorithm: *
+* "A generic solution to polygon clipping"                                     *
+* Communications of the ACM, Vol 35, Issue 7 (July 1992) pp 56-63.             *
+* http://portal.acm.org/citation.cfm?id=129906                                 *
+*                                                                              *
+* Computer graphics and geometric modeling: implementation and algorithms      *
+* By Max K. Agoston                                                            *
+* Springer; 1 edition (January 4, 2005)                                        *
+* http://books.google.com/books?q=vatti+clipping+agoston                       *
+*                                                                              *
+* See also:                                                                    *
+* "Polygon Offsetting by Computing Winding Numbers"                            *
+* Paper no. DETC2005-85513 pp. 565-575                                         *
+* ASME 2005 International Design Engineering Technical Conferences             *
+* and Computers and Information in Engineering Conference (IDETC/CIE2005)      *
+* September 24-28, 2005 , Long Beach, California, USA                          *
+* http://www.me.berkeley.edu/~mcmains/pubs/DAC05OffsetPolygon.pdf              *
+*                                                                              *
+*******************************************************************************/
+
+/*******************************************************************************
+*                                                                              *
+* This is a translation of the Delphi Clipper library and the naming style     *
+* used has retained a Delphi flavour.                                          *
+*                                                                              *
+*******************************************************************************/
+
+#include "../include/clipper.hpp"
+#include <cassert>
+#include <cmath>
+#include <vector>
+#include <algorithm>
+#include <stdexcept>
+#include <cstring>
+#include <cstdlib>
+#include <ostream>
+
+namespace ClipperLib {
+
+static long64 const loRange = 1518500249;            //sqrt(2^63 -1)/2
+static long64 const hiRange = 6521908912666391106LL; //sqrt(2^127 -1)/2
+static double const pi = 3.141592653589793238;
+enum Direction { dRightToLeft, dLeftToRight };
+enum RangeTest { rtLo, rtHi, rtError };
+
+#define HORIZONTAL (-1.0E+40)
+#define TOLERANCE (1.0e-20)
+#define NEAR_ZERO(val) (((val) > -TOLERANCE) && ((val) < TOLERANCE))
+#define NEAR_EQUAL(a, b) NEAR_ZERO((a) - (b))
+
+inline long64 Abs(long64 val)
+{
+  if (val < 0) return -val; else return val;
+}
+//------------------------------------------------------------------------------
+
+//------------------------------------------------------------------------------
+// Int128 class (enables safe math on signed 64bit integers)
+// eg Int128 val1((long64)9223372036854775807); //ie 2^63 -1
+//    Int128 val2((long64)9223372036854775807);
+//    Int128 val3 = val1 * val2;
+//    val3.AsString => "85070591730234615847396907784232501249" (8.5e+37)
+//------------------------------------------------------------------------------
+
+class Int128
+{
+  public:
+
+    Int128(long64 _lo = 0)
+    {
+      hi = 0;
+      if (_lo < 0) {
+        lo = -_lo;
+        Negate(*this);
+      } else
+          lo = _lo;
+    }
+
+    Int128(const Int128 &val): hi(val.hi), lo(val.lo){}
+
+    Int128& operator=( const Int128& ) = default;
+
+    long64 operator = (const long64 &val)
+    {
+      hi = 0;
+      lo = Abs(val);
+      if (val < 0) Negate(*this);
+      return val;
+    }
+
+    bool operator == (const Int128 &val) const
+      {return (hi == val.hi && lo == val.lo);}
+
+    bool operator != (const Int128 &val) const { return !(*this == val);}
+
+    bool operator > (const Int128 &val) const
+    {
+      if (hi > val.hi) return true;
+      else if (hi < val.hi) return false;
+      else return ulong64(lo) > ulong64(val.lo);
+    }
+
+    bool operator < (const Int128 &val) const
+    {
+      if (hi < val.hi) return true;
+      else if (hi > val.hi) return false;
+      else return ulong64(lo) < ulong64(val.lo);
+    }
+
+    Int128& operator += (const Int128 &rhs)
+    {
+      hi += rhs.hi;
+      lo += rhs.lo;
+      if (ulong64(lo) < ulong64(rhs.lo)) hi++;
+      return *this;
+    }
+
+    Int128 operator + (const Int128 &rhs) const
+    {
+      Int128 result(*this);
+      result+= rhs;
+      return result;
+    }
+
+    Int128& operator -= (const Int128 &rhs)
+    {
+      Int128 tmp(rhs);
+      Negate(tmp);
+      *this += tmp;
+      return *this;
+    }
+
+    Int128 operator - (const Int128 &rhs) const
+    {
+      Int128 result(*this);
+      result-= rhs;
+      return result;
+    }
+
+    Int128 operator * (const Int128 &rhs) const {
+      if ( !(hi == 0 || hi == -1) || !(rhs.hi == 0 || rhs.hi == -1))
+        throw "Int128 operator*: overflow error";
+      bool negate = (hi < 0) != (rhs.hi < 0);
+
+      Int128 tmp(*this);
+      if (tmp.hi < 0) Negate(tmp);
+      ulong64 int1Hi = ulong64(tmp.lo) >> 32;
+      ulong64 int1Lo = ulong64(tmp.lo & 0xFFFFFFFF);
+
+      tmp = rhs;
+      if (tmp.hi < 0) Negate(tmp);
+      ulong64 int2Hi = ulong64(tmp.lo) >> 32;
+      ulong64 int2Lo = ulong64(tmp.lo & 0xFFFFFFFF);
+
+      //nb: see comments in clipper.pas
+      ulong64 a = int1Hi * int2Hi;
+      ulong64 b = int1Lo * int2Lo;
+      ulong64 c = int1Hi * int2Lo + int1Lo * int2Hi;
+
+      tmp.hi = long64(a + (c >> 32));
+      tmp.lo = long64(c << 32);
+      tmp.lo += long64(b);
+      if (ulong64(tmp.lo) < b) tmp.hi++;
+      if (negate) Negate(tmp);
+      return tmp;
+    }
+
+    Int128 operator/ (const Int128 &rhs) const
+    {
+      if (rhs.lo == 0 && rhs.hi == 0)
+        throw "Int128 operator/: divide by zero";
+      bool negate = (rhs.hi < 0) != (hi < 0);
+      Int128 result(*this), denom(rhs);
+      if (result.hi < 0) Negate(result);
+      if (denom.hi < 0)  Negate(denom);
+      if (denom > result) return Int128(0); //result is only a fraction of 1
+      Negate(denom);
+
+      Int128 p(0);
+      for (int i = 0; i < 128; ++i)
+      {
+        p.hi = p.hi << 1;
+        if (p.lo < 0) p.hi++;
+        p.lo = long64(p.lo) << 1;
+        if (result.hi < 0) p.lo++;
+        result.hi = result.hi << 1;
+        if (result.lo < 0) result.hi++;
+        result.lo = long64(result.lo) << 1;
+        Int128 p2(p);
+        p += denom;
+        if (p.hi < 0) p = p2;
+        else result.lo++;
+      }
+      if (negate) Negate(result);
+      return result;
+    }
+
+    double AsDouble() const
+    {
+      const double shift64 = 18446744073709551616.0; //2^64
+      const double bit64 = 9223372036854775808.0;
+      if (hi < 0)
+      {
+        Int128 tmp(*this);
+        Negate(tmp);
+        if (tmp.lo < 0)
+          return (double)tmp.lo - bit64 - tmp.hi * shift64;
+        else
+          return -(double)tmp.lo - tmp.hi * shift64;
+      }
+      else if (lo < 0)
+        return -(double)lo + bit64 + hi * shift64;
+      else
+        return (double)lo + (double)hi * shift64;
+    }
+
+    //for bug testing ...
+    std::string AsString() const
+    {
+      std::string result;
+      unsigned char r = 0;
+      Int128 tmp(0), val(*this);
+      if (hi < 0) Negate(val);
+      result.resize(50);
+      std::string::size_type i = result.size() -1;
+      while (val.hi != 0 || val.lo != 0)
+      {
+        Div10(val, tmp, r);
+        result[i--] = char('0' + r);
+        val = tmp;
+      }
+      if (hi < 0) result[i--] = '-';
+      result.erase(0,i+1);
+      if (result.size() == 0) result = "0";
+      return result;
+    }
+
+private:
+    long64 hi;
+    long64 lo;
+
+    static void Negate(Int128 &val)
+    {
+      if (val.lo == 0)
+      {
+        if( val.hi == 0) return;
+        val.lo = ~val.lo;
+        val.hi = ~val.hi +1;
+      }
+      else
+      {
+        val.lo = ~val.lo +1;
+        val.hi = ~val.hi;
+      }
+    }
+
+    //debugging only ...
+    void Div10(const Int128 val, Int128& result, unsigned char & remainder) const
+    {
+      remainder = 0;
+      result = 0;
+      for (int i = 63; i >= 0; --i)
+      {
+        if ((val.hi & ((long64)1 << i)) != 0)
+          remainder = char((remainder * 2) + 1); else
+          remainder *= char(2);
+        if (remainder >= 10)
+        {
+          result.hi += ((long64)1 << i);
+          remainder -= char(10);
+        }
+      }
+      for (int i = 63; i >= 0; --i)
+      {
+        if ((val.lo & ((long64)1 << i)) != 0)
+          remainder = char((remainder * 2) + 1); else
+          remainder *= char(2);
+        if (remainder >= 10)
+        {
+          result.lo += ((long64)1 << i);
+          remainder -= char(10);
+        }
+      }
+    }
+};
+
+//------------------------------------------------------------------------------
+//------------------------------------------------------------------------------
+
+RangeTest TestRange(const Polygon &pts)
+{
+  RangeTest result = rtLo;
+  for (Polygon::size_type i = 0; i <  pts.size(); ++i)
+  {
+    if (Abs(pts[i].X) > hiRange || Abs(pts[i].Y) > hiRange)
+        return rtError;
+      else if (Abs(pts[i].X) > loRange || Abs(pts[i].Y) > loRange)
+        result = rtHi;
+  }
+  return result;
+}
+//------------------------------------------------------------------------------
+
+bool Orientation(const Polygon &poly)
+{
+  int highI = (int)poly.size() -1;
+  if (highI < 2) return false;
+  bool UseFullInt64Range = false;
+
+  int j = 0, jplus, jminus;
+  for (int i = 0; i <= highI; ++i)
+  {
+    if (Abs(poly[i].X) > hiRange || Abs(poly[i].Y) > hiRange)
+    throw "Coordinate exceeds range bounds.";
+    if (Abs(poly[i].X) > loRange || Abs(poly[i].Y) > loRange)
+    UseFullInt64Range = true;
+    if (poly[i].Y < poly[j].Y) continue;
+    if ((poly[i].Y > poly[j].Y || poly[i].X < poly[j].X)) j = i;
+  };
+  if (j == highI) jplus = 0;
+  else jplus = j +1;
+  if (j == 0) jminus = highI;
+  else jminus = j -1;
+
+  IntPoint vec1, vec2;
+  //get cross product of vectors of the edges adjacent to highest point ...
+  vec1.X = poly[j].X - poly[jminus].X;
+  vec1.Y = poly[j].Y - poly[jminus].Y;
+  vec2.X = poly[jplus].X - poly[j].X;
+  vec2.Y = poly[jplus].Y - poly[j].Y;
+
+  if (UseFullInt64Range)
+  {
+    Int128 cross = Int128(vec1.X) * Int128(vec2.Y) -
+      Int128(vec2.X) * Int128(vec1.Y);
+    return cross > 0;
+  }
+  else
+  {
+    return (vec1.X * vec2.Y - vec2.X * vec1.Y) > 0;
+  }
+}
+//------------------------------------------------------------------------------
+
+bool Orientation(OutRec *outRec, bool UseFullInt64Range)
+{
+  OutPt *opBottom = outRec->pts, *op = outRec->pts->next;
+  while (op != outRec->pts)
+  {
+    if (op->pt.Y >= opBottom->pt.Y)
+    {
+      if (op->pt.Y > opBottom->pt.Y || op->pt.X < opBottom->pt.X)
+      opBottom = op;
+    }
+    op = op->next;
+  }
+
+  IntPoint vec1, vec2;
+  vec1.X = op->pt.X - op->prev->pt.X;
+  vec1.Y = op->pt.Y - op->prev->pt.Y;
+  vec2.X = op->next->pt.X - op->pt.X;
+  vec2.Y = op->next->pt.Y - op->pt.Y;
+
+  if (UseFullInt64Range)
+  {
+    Int128 cross = Int128(vec1.X) * Int128(vec2.Y) - Int128(vec2.X) * Int128(vec1.Y);
+    return cross > 0;
+  }
+  else
+  {
+    return (vec1.X * vec2.Y - vec2.X * vec1.Y) > 0;
+  }
+}
+//------------------------------------------------------------------------------
+
+inline bool PointsEqual( const IntPoint &pt1, const IntPoint &pt2)
+{
+  return ( pt1.X == pt2.X && pt1.Y == pt2.Y );
+}
+//------------------------------------------------------------------------------
+
+double Area(const Polygon &poly)
+{
+  int highI = (int)poly.size() -1;
+  if (highI < 2) return 0;
+  bool UseFullInt64Range;
+  RangeTest rt = TestRange(poly);
+  switch (rt) {
+    case rtLo:
+      UseFullInt64Range = false;
+      break;
+    case rtHi:
+      UseFullInt64Range = true;
+      break;
+    default:
+      throw "Coordinate exceeds range bounds.";
+  }
+
+  if (UseFullInt64Range) {
+    Int128 a(0);
+    a = (Int128(poly[highI].X) * Int128(poly[0].Y)) -
+      Int128(poly[0].X) * Int128(poly[highI].Y);
+    for (int i = 0; i < highI; ++i)
+      a += Int128(poly[i].X) * Int128(poly[i+1].Y) -
+        Int128(poly[i+1].X) * Int128(poly[i].Y);
+    return a.AsDouble() / 2;
+  }
+  else
+  {
+    double a;
+    a = (double)poly[highI].X * poly[0].Y - (double)poly[0].X * poly[highI].Y;
+    for (int i = 0; i < highI; ++i)
+      a += (double)poly[i].X * poly[i+1].Y - (double)poly[i+1].X * poly[i].Y;
+    return a/2;
+  }
+}
+//------------------------------------------------------------------------------
+
+bool PointIsVertex(const IntPoint &pt, OutPt *pp)
+{
+  OutPt *pp2 = pp;
+  do
+  {
+    if (PointsEqual(pp2->pt, pt)) return true;
+    pp2 = pp2->next;
+  }
+  while (pp2 != pp);
+  return false;
+}
+//------------------------------------------------------------------------------
+
+bool PointInPolygon(const IntPoint &pt, OutPt *pp, bool UseFullInt64Range)
+{
+  OutPt *pp2 = pp;
+  bool result = false;
+  if (UseFullInt64Range) {
+    do
+    {
+      if ((((pp2->pt.Y <= pt.Y) && (pt.Y < pp2->prev->pt.Y)) ||
+          ((pp2->prev->pt.Y <= pt.Y) && (pt.Y < pp2->pt.Y))) &&
+          Int128(pt.X - pp2->pt.X) < (Int128(pp2->prev->pt.X - pp2->pt.X) *
+          Int128(pt.Y - pp2->pt.Y)) / Int128(pp2->prev->pt.Y - pp2->pt.Y))
+            result = !result;
+      pp2 = pp2->next;
+    }
+    while (pp2 != pp);
+  }
+  else
+  {
+    do
+    {
+      if ((((pp2->pt.Y <= pt.Y) && (pt.Y < pp2->prev->pt.Y)) ||
+        ((pp2->prev->pt.Y <= pt.Y) && (pt.Y < pp2->pt.Y))) &&
+        (pt.X < (pp2->prev->pt.X - pp2->pt.X) * (pt.Y - pp2->pt.Y) /
+        (pp2->prev->pt.Y - pp2->pt.Y) + pp2->pt.X )) result = !result;
+      pp2 = pp2->next;
+    }
+    while (pp2 != pp);
+  }
+  return result;
+}
+//------------------------------------------------------------------------------
+
+bool SlopesEqual(TEdge &e1, TEdge &e2, bool UseFullInt64Range)
+{
+  if (e1.ybot == e1.ytop) return (e2.ybot == e2.ytop);
+  else if (e1.xbot == e1.xtop) return (e2.xbot == e2.xtop);
+  else if (UseFullInt64Range)
+    return Int128(e1.ytop - e1.ybot) * Int128(e2.xtop - e2.xbot) ==
+      Int128(e1.xtop - e1.xbot) * Int128(e2.ytop - e2.ybot);
+  else return (e1.ytop - e1.ybot)*(e2.xtop - e2.xbot) ==
+      (e1.xtop - e1.xbot)*(e2.ytop - e2.ybot);
+}
+//------------------------------------------------------------------------------
+
+bool SlopesEqual(const IntPoint pt1, const IntPoint pt2,
+  const IntPoint pt3, bool UseFullInt64Range)
+{
+  if (pt1.Y == pt2.Y) return (pt2.Y == pt3.Y);
+  else if (pt1.X == pt2.X) return (pt2.X == pt3.X);
+  else if (UseFullInt64Range)
+    return Int128(pt1.Y-pt2.Y) * Int128(pt2.X-pt3.X) ==
+      Int128(pt1.X-pt2.X) * Int128(pt2.Y-pt3.Y);
+  else return (pt1.Y-pt2.Y)*(pt2.X-pt3.X) == (pt1.X-pt2.X)*(pt2.Y-pt3.Y);
+}
+//------------------------------------------------------------------------------
+
+bool SlopesEqual(const IntPoint pt1, const IntPoint pt2,
+  const IntPoint pt3, const IntPoint pt4, bool UseFullInt64Range)
+{
+  if (pt1.Y == pt2.Y) return (pt3.Y == pt4.Y);
+  else if (pt1.X == pt2.X) return (pt3.X == pt4.X);
+  else if (UseFullInt64Range)
+    return Int128(pt1.Y-pt2.Y) * Int128(pt3.X-pt4.X) ==
+      Int128(pt1.X-pt2.X) * Int128(pt3.Y-pt4.Y);
+  else return (pt1.Y-pt2.Y)*(pt3.X-pt4.X) == (pt1.X-pt2.X)*(pt3.Y-pt4.Y);
+}
+//------------------------------------------------------------------------------
+
+double GetDx(const IntPoint pt1, const IntPoint pt2)
+{
+  if (pt1.Y == pt2.Y) return HORIZONTAL;
+  else return
+    (double)(pt2.X - pt1.X) / (double)(pt2.Y - pt1.Y);
+}
+//---------------------------------------------------------------------------
+
+void SetDx(TEdge &e)
+{
+  if (e.ybot == e.ytop) e.dx = HORIZONTAL;
+  else e.dx =
+    (double)(e.xtop - e.xbot) / (double)(e.ytop - e.ybot);
+}
+//---------------------------------------------------------------------------
+
+void SwapSides(TEdge &edge1, TEdge &edge2)
+{
+  EdgeSide side =  edge1.side;
+  edge1.side = edge2.side;
+  edge2.side = side;
+}
+//------------------------------------------------------------------------------
+
+void SwapPolyIndexes(TEdge &edge1, TEdge &edge2)
+{
+  int outIdx =  edge1.outIdx;
+  edge1.outIdx = edge2.outIdx;
+  edge2.outIdx = outIdx;
+}
+//------------------------------------------------------------------------------
+
+inline long64 Round(double val)
+{
+  if ((val < 0)) return static_cast<long64>(val - 0.5);
+  else return static_cast<long64>(val + 0.5);
+}
+//------------------------------------------------------------------------------
+
+long64 TopX(TEdge &edge, const long64 currentY)
+{
+  if( currentY == edge.ytop ) return edge.xtop;
+  return edge.xbot + Round(edge.dx *(currentY - edge.ybot));
+}
+//------------------------------------------------------------------------------
+
+long64 TopX(const IntPoint pt1, const IntPoint pt2, const long64 currentY)
+{
+  //preconditions: pt1.Y <> pt2.Y and pt1.Y > pt2.Y
+  if (currentY >= pt1.Y) return pt1.X;
+  else if (currentY == pt2.Y) return pt2.X;
+  else if (pt1.X == pt2.X) return pt1.X;
+  else
+  {
+    double q = (double)(pt1.X-pt2.X)/(double)(pt1.Y-pt2.Y);
+    return Round(pt1.X + (currentY - pt1.Y) *q);
+  }
+}
+//------------------------------------------------------------------------------
+
+bool IntersectPoint(TEdge &edge1, TEdge &edge2,
+  IntPoint &ip, bool UseFullInt64Range)
+{
+  double b1, b2;
+  if (SlopesEqual(edge1, edge2, UseFullInt64Range)) return false;
+  else if (NEAR_ZERO(edge1.dx))
+  {
+    ip.X = edge1.xbot;
+    if (NEAR_EQUAL(edge2.dx, HORIZONTAL))
+    {
+      ip.Y = edge2.ybot;
+    } else
+    {
+      b2 = edge2.ybot - (edge2.xbot/edge2.dx);
+      ip.Y = Round(ip.X/edge2.dx + b2);
+    }
+  }
+  else if (NEAR_ZERO(edge2.dx))
+  {
+    ip.X = edge2.xbot;
+    if (NEAR_EQUAL(edge1.dx, HORIZONTAL))
+    {
+      ip.Y = edge1.ybot;
+    } else
+    {
+      b1 = edge1.ybot - (edge1.xbot/edge1.dx);
+      ip.Y = Round(ip.X/edge1.dx + b1);
+    }
+  } else
+  {
+    b1 = edge1.xbot - edge1.ybot * edge1.dx;
+    b2 = edge2.xbot - edge2.ybot * edge2.dx;
+    b2 = (b2-b1)/(edge1.dx - edge2.dx);
+    ip.Y = Round(b2);
+    ip.X = Round(edge1.dx * b2 + b1);
+  }
+
+  return
+    //can be *so close* to the top of one edge that the rounded Y equals one ytop ...
+    (ip.Y == edge1.ytop && ip.Y >= edge2.ytop && edge1.tmpX > edge2.tmpX) ||
+    (ip.Y == edge2.ytop && ip.Y >= edge1.ytop && edge1.tmpX > edge2.tmpX) ||
+    (ip.Y > edge1.ytop && ip.Y > edge2.ytop);
+}
+//------------------------------------------------------------------------------
+
+void ReversePolyPtLinks(OutPt &pp)
+{
+  OutPt *pp1, *pp2;
+  pp1 = &pp;
+  do {
+  pp2 = pp1->next;
+  pp1->next = pp1->prev;
+  pp1->prev = pp2;
+  pp1 = pp2;
+  } while( pp1 != &pp );
+}
+//------------------------------------------------------------------------------
+
+void DisposeOutPts(OutPt*& pp)
+{
+  if (pp == 0) return;
+  pp->prev->next = 0;
+  while( pp )
+  {
+    OutPt *tmpPp = pp;
+    pp = pp->next;
+    delete tmpPp ;
+  }
+}
+//------------------------------------------------------------------------------
+
+void InitEdge(TEdge *e, TEdge *eNext,
+  TEdge *ePrev, const IntPoint &pt, PolyType polyType)
+{
+  std::memset( e, 0, sizeof( TEdge ));
+
+  e->next = eNext;
+  e->prev = ePrev;
+  e->xcurr = pt.X;
+  e->ycurr = pt.Y;
+  if (e->ycurr >= e->next->ycurr)
+  {
+    e->xbot = e->xcurr;
+    e->ybot = e->ycurr;
+    e->xtop = e->next->xcurr;
+    e->ytop = e->next->ycurr;
+    e->windDelta = 1;
+  } else
+  {
+    e->xtop = e->xcurr;
+    e->ytop = e->ycurr;
+    e->xbot = e->next->xcurr;
+    e->ybot = e->next->ycurr;
+    e->windDelta = -1;
+  }
+  SetDx(*e);
+  e->polyType = polyType;
+  e->outIdx = -1;
+}
+//------------------------------------------------------------------------------
+
+inline void SwapX(TEdge &e)
+{
+  //swap horizontal edges' top and bottom x's so they follow the natural
+  //progression of the bounds - ie so their xbots will align with the
+  //adjoining lower edge. [Helpful in the ProcessHorizontal() method.]
+  e.xcurr = e.xtop;
+  e.xtop = e.xbot;
+  e.xbot = e.xcurr;
+}
+//------------------------------------------------------------------------------
+
+void SwapPoints(IntPoint &pt1, IntPoint &pt2)
+{
+  IntPoint tmp = pt1;
+  pt1 = pt2;
+  pt2 = tmp;
+}
+//------------------------------------------------------------------------------
+
+bool GetOverlapSegment(IntPoint pt1a, IntPoint pt1b, IntPoint pt2a,
+  IntPoint pt2b, IntPoint &pt1, IntPoint &pt2)
+{
+  //precondition: segments are colinear.
+  if ( pt1a.Y == pt1b.Y || Abs((pt1a.X - pt1b.X)/(pt1a.Y - pt1b.Y)) > 1 )
+  {
+    if (pt1a.X > pt1b.X) SwapPoints(pt1a, pt1b);
+    if (pt2a.X > pt2b.X) SwapPoints(pt2a, pt2b);
+    if (pt1a.X > pt2a.X) pt1 = pt1a; else pt1 = pt2a;
+    if (pt1b.X < pt2b.X) pt2 = pt1b; else pt2 = pt2b;
+    return pt1.X < pt2.X;
+  } else
+  {
+    if (pt1a.Y < pt1b.Y) SwapPoints(pt1a, pt1b);
+    if (pt2a.Y < pt2b.Y) SwapPoints(pt2a, pt2b);
+    if (pt1a.Y < pt2a.Y) pt1 = pt1a; else pt1 = pt2a;
+    if (pt1b.Y > pt2b.Y) pt2 = pt1b; else pt2 = pt2b;
+    return pt1.Y > pt2.Y;
+  }
+}
+//------------------------------------------------------------------------------
+
+OutPt* PolygonBottom(OutPt* pp)
+{
+  OutPt* p = pp->next;
+  OutPt* result = pp;
+  while (p != pp)
+  {
+    if (p->pt.Y > result->pt.Y) result = p;
+    else if (p->pt.Y == result->pt.Y && p->pt.X < result->pt.X) result = p;
+    p = p->next;
+  }
+  return result;
+}
+//------------------------------------------------------------------------------
+
+bool FindSegment(OutPt* &pp, IntPoint &pt1, IntPoint &pt2)
+{
+  //outPt1 & outPt2 => the overlap segment (if the function returns true)
+  if (!pp) return false;
+  OutPt* pp2 = pp;
+  IntPoint pt1a = pt1, pt2a = pt2;
+  do
+  {
+    if (SlopesEqual(pt1a, pt2a, pp->pt, pp->prev->pt, true) &&
+      SlopesEqual(pt1a, pt2a, pp->pt, true) &&
+      GetOverlapSegment(pt1a, pt2a, pp->pt, pp->prev->pt, pt1, pt2))
+        return true;
+    pp = pp->next;
+  }
+  while (pp != pp2);
+  return false;
+}
+//------------------------------------------------------------------------------
+
+bool Pt3IsBetweenPt1AndPt2(const IntPoint pt1,
+  const IntPoint pt2, const IntPoint pt3)
+{
+  if (PointsEqual(pt1, pt3) || PointsEqual(pt2, pt3)) return true;
+  else if (pt1.X != pt2.X) return (pt1.X < pt3.X) == (pt3.X < pt2.X);
+  else return (pt1.Y < pt3.Y) == (pt3.Y < pt2.Y);
+}
+//------------------------------------------------------------------------------
+
+OutPt* InsertPolyPtBetween(OutPt* p1, OutPt* p2, const IntPoint pt)
+{
+  if (p1 == p2) throw "JoinError";
+  OutPt* result = new OutPt;
+  result->pt = pt;
+  if (p2 == p1->next)
+  {
+    p1->next = result;
+    p2->prev = result;
+    result->next = p2;
+    result->prev = p1;
+  } else
+  {
+    p2->next = result;
+    p1->prev = result;
+    result->next = p1;
+    result->prev = p2;
+  }
+  return result;
+}
+
+//------------------------------------------------------------------------------
+// ClipperBase class methods ...
+//------------------------------------------------------------------------------
+
+ClipperBase::ClipperBase() //constructor
+{
+  m_MinimaList = 0;
+  m_CurrentLM = 0;
+  m_UseFullRange = true;
+}
+//------------------------------------------------------------------------------
+
+ClipperBase::~ClipperBase() //destructor
+{
+  Clear();
+}
+//------------------------------------------------------------------------------
+
+bool ClipperBase::AddPolygon( const Polygon &pg, PolyType polyType)
+{
+  int len = (int)pg.size();
+  if (len < 3) return false;
+  Polygon p(len);
+  p[0] = pg[0];
+  int j = 0;
+
+  long64 maxVal;
+  if (m_UseFullRange) maxVal = hiRange; else maxVal = loRange;
+
+  for (int i = 0; i < len; ++i)
+  {
+    if (Abs(pg[i].X) > maxVal || Abs(pg[i].Y) > maxVal)
+    {
+      if (m_UseFullRange)
+        throw "Coordinate exceeds range bounds";
+      maxVal = hiRange;
+      if (Abs(pg[i].X) > maxVal || Abs(pg[i].Y) > maxVal)
+        throw "Coordinate exceeds range bounds";
+      m_UseFullRange = true;
+    }
+
+    if (i == 0 || PointsEqual(p[j], pg[i])) continue;
+    else if (j > 0 && SlopesEqual(p[j-1], p[j], pg[i], m_UseFullRange))
+    {
+      if (PointsEqual(p[j-1], pg[i])) j--;
+    } else j++;
+    p[j] = pg[i];
+  }
+  if (j < 2) return false;
+
+  len = j+1;
+  for (;;)
+  {
+    //nb: test for point equality before testing slopes ...
+    if (PointsEqual(p[j], p[0])) j--;
+    else if (PointsEqual(p[0], p[1]) ||
+      SlopesEqual(p[j], p[0], p[1], m_UseFullRange))
+      p[0] = p[j--];
+    else if (SlopesEqual(p[j-1], p[j], p[0], m_UseFullRange)) j--;
+    else if (SlopesEqual(p[0], p[1], p[2], m_UseFullRange))
+    {
+      for (int i = 2; i <= j; ++i) p[i-1] = p[i];
+      j--;
+    }
+    //exit loop if nothing is changed or there are too few vertices ...
+    if (j == len-1 || j < 2) break;
+    len = j +1;
+  }
+  // if (len < 3) return false;
+
+  //create a new edge array ...
+  TEdge *edges = new TEdge [len];
+  m_edges.push_back(edges);
+
+  //convert vertices to a double-linked-list of edges and initialize ...
+  edges[0].xcurr = p[0].X;
+  edges[0].ycurr = p[0].Y;
+  InitEdge(&edges[len-1], &edges[0], &edges[len-2], p[len-1], polyType);
+  for (int i = len-2; i > 0; --i)
+    InitEdge(&edges[i], &edges[i+1], &edges[i-1], p[i], polyType);
+  InitEdge(&edges[0], &edges[1], &edges[len-1], p[0], polyType);
+
+  //reset xcurr & ycurr and find 'eHighest' (given the Y axis coordinates
+  //increase downward so the 'highest' edge will have the smallest ytop) ...
+  TEdge *e = &edges[0];
+  TEdge *eHighest = e;
+  do
+  {
+    e->xcurr = e->xbot;
+    e->ycurr = e->ybot;
+    if (e->ytop < eHighest->ytop) eHighest = e;
+    e = e->next;
+  }
+  while ( e != &edges[0]);
+
+  //make sure eHighest is positioned so the following loop works safely ...
+  if (eHighest->windDelta > 0) eHighest = eHighest->next;
+  if (NEAR_EQUAL(eHighest->dx, HORIZONTAL)) eHighest = eHighest->next;
+
+  //finally insert each local minima ...
+  e = eHighest;
+  do {
+    e = AddBoundsToLML(e);
+  }
+  while( e != eHighest );
+  return true;
+}
+//------------------------------------------------------------------------------
+
+void ClipperBase::InsertLocalMinima(LocalMinima *newLm)
+{
+  if( ! m_MinimaList )
+  {
+    m_MinimaList = newLm;
+  }
+  else if( newLm->Y >= m_MinimaList->Y )
+  {
+    newLm->next = m_MinimaList;
+    m_MinimaList = newLm;
+  } else
+  {
+    LocalMinima* tmpLm = m_MinimaList;
+    while( tmpLm->next  && ( newLm->Y < tmpLm->next->Y ) )
+      tmpLm = tmpLm->next;
+    newLm->next = tmpLm->next;
+    tmpLm->next = newLm;
+  }
+}
+//------------------------------------------------------------------------------
+
+TEdge* ClipperBase::AddBoundsToLML(TEdge *e)
+{
+  //Starting at the top of one bound we progress to the bottom where there's
+  //a local minima. We then go to the top of the next bound. These two bounds
+  //form the left and right (or right and left) bounds of the local minima.
+  e->nextInLML = 0;
+  e = e->next;
+  for (;;)
+  {
+    if (NEAR_EQUAL(e->dx, HORIZONTAL))
+    {
+      //nb: proceed through horizontals when approaching from their right,
+      //    but break on horizontal minima if approaching from their left.
+      //    This ensures 'local minima' are always on the left of horizontals.
+      if (e->next->ytop < e->ytop && e->next->xbot > e->prev->xbot) break;
+      // coverity[copy_paste_error]
+      if (e->xtop != e->prev->xbot) SwapX(*e);
+      e->nextInLML = e->prev;
+    }
+    else if (e->ycurr == e->prev->ycurr) break;
+    else e->nextInLML = e->prev;
+    e = e->next;
+  }
+
+  //e and e.prev are now at a local minima ...
+  LocalMinima* newLm = new LocalMinima;
+  newLm->next = 0;
+  newLm->Y = e->prev->ybot;
+
+  if ( NEAR_EQUAL(e->dx, HORIZONTAL) ) //horizontal edges never start a left bound
+  {
+    if (e->xbot != e->prev->xbot) SwapX(*e);
+    newLm->leftBound = e->prev;
+    newLm->rightBound = e;
+  } else if (e->dx < e->prev->dx)
+  {
+    newLm->leftBound = e->prev;
+    newLm->rightBound = e;
+  } else
+  {
+    newLm->leftBound = e;
+    newLm->rightBound = e->prev;
+  }
+  newLm->leftBound->side = esLeft;
+  newLm->rightBound->side = esRight;
+  InsertLocalMinima( newLm );
+
+  for (;;)
+  {
+    if ( e->next->ytop == e->ytop && !NEAR_EQUAL(e->next->dx, HORIZONTAL) ) break;
+    e->nextInLML = e->next;
+    e = e->next;
+    if ( NEAR_EQUAL(e->dx, HORIZONTAL) && e->xbot != e->prev->xtop) SwapX(*e);
+  }
+  return e->next;
+}
+//------------------------------------------------------------------------------
+
+bool ClipperBase::AddPolygons(const Polygons &ppg, PolyType polyType)
+{
+  bool result = true;
+  for (Polygons::size_type i = 0; i < ppg.size(); ++i)
+    if (AddPolygon(ppg[i], polyType)) result = false;
+  return result;
+}
+//------------------------------------------------------------------------------
+
+void ClipperBase::Clear()
+{
+  DisposeLocalMinimaList();
+  for (EdgeList::size_type i = 0; i < m_edges.size(); ++i) delete [] m_edges[i];
+  m_edges.clear();
+  m_UseFullRange = false;
+}
+//------------------------------------------------------------------------------
+
+void ClipperBase::Reset()
+{
+  m_CurrentLM = m_MinimaList;
+  if( !m_CurrentLM ) return; //ie nothing to process
+
+  //reset all edges ...
+  LocalMinima* lm = m_MinimaList;
+  while( lm )
+  {
+    TEdge* e = lm->leftBound;
+    while( e )
+    {
+      e->xcurr = e->xbot;
+      e->ycurr = e->ybot;
+      e->side = esLeft;
+      e->outIdx = -1;
+      e = e->nextInLML;
+    }
+    e = lm->rightBound;
+    while( e )
+    {
+      e->xcurr = e->xbot;
+      e->ycurr = e->ybot;
+      e->side = esRight;
+      e->outIdx = -1;
+      e = e->nextInLML;
+    }
+    lm = lm->next;
+  }
+}
+//------------------------------------------------------------------------------
+
+void ClipperBase::DisposeLocalMinimaList()
+{
+  while( m_MinimaList )
+  {
+    LocalMinima* tmpLm = m_MinimaList->next;
+    delete m_MinimaList;
+    m_MinimaList = tmpLm;
+  }
+  m_CurrentLM = 0;
+}
+//------------------------------------------------------------------------------
+
+void ClipperBase::PopLocalMinima()
+{
+  if( ! m_CurrentLM ) return;
+  m_CurrentLM = m_CurrentLM->next;
+}
+//------------------------------------------------------------------------------
+
+IntRect ClipperBase::GetBounds()
+{
+  IntRect result;
+  LocalMinima* lm = m_MinimaList;
+  if (!lm)
+  {
+    result.left = result.top = result.right = result.bottom = 0;
+    return result;
+  }
+  result.left = lm->leftBound->xbot;
+  result.top = lm->leftBound->ybot;
+  result.right = lm->leftBound->xbot;
+  result.bottom = lm->leftBound->ybot;
+  while (lm)
+  {
+    if (lm->leftBound->ybot > result.bottom)
+      result.bottom = lm->leftBound->ybot;
+    TEdge* e = lm->leftBound;
+    for (;;) {
+      TEdge* bottomE = e;
+      while (e->nextInLML)
+      {
+        if (e->xbot < result.left) result.left = e->xbot;
+        if (e->xbot > result.right) result.right = e->xbot;
+        e = e->nextInLML;
+      }
+      if (e->xbot < result.left) result.left = e->xbot;
+      if (e->xbot > result.right) result.right = e->xbot;
+      if (e->xtop < result.left) result.left = e->xtop;
+      if (e->xtop > result.right) result.right = e->xtop;
+      if (e->ytop < result.top) result.top = e->ytop;
+
+      if (bottomE == lm->leftBound) e = lm->rightBound;
+      else break;
+    }
+    lm = lm->next;
+  }
+  return result;
+}
+
+
+//------------------------------------------------------------------------------
+// TClipper methods ...
+//------------------------------------------------------------------------------
+
+Clipper::Clipper() : ClipperBase() //constructor
+{
+  m_Scanbeam = 0;
+  m_ActiveEdges = 0;
+  m_SortedEdges = 0;
+  m_IntersectNodes = 0;
+  m_ExecuteLocked = false;
+  m_UseFullRange = false;
+  m_ReverseOutput = false;
+}
+//------------------------------------------------------------------------------
+
+Clipper::~Clipper() //destructor
+{
+  Clear();
+  DisposeScanbeamList();
+}
+//------------------------------------------------------------------------------
+
+void Clipper::Clear()
+{
+  if (m_edges.size() == 0) return; //avoids problems with ClipperBase destructor
+  DisposeAllPolyPts();
+  ClipperBase::Clear();
+}
+//------------------------------------------------------------------------------
+
+void Clipper::DisposeScanbeamList()
+{
+  while ( m_Scanbeam ) {
+  Scanbeam* sb2 = m_Scanbeam->next;
+  delete m_Scanbeam;
+  m_Scanbeam = sb2;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::Reset()
+{
+  ClipperBase::Reset();
+  m_Scanbeam = 0;
+  m_ActiveEdges = 0;
+  m_SortedEdges = 0;
+  LocalMinima* lm = m_MinimaList;
+  while (lm)
+  {
+    InsertScanbeam(lm->Y);
+    InsertScanbeam(lm->leftBound->ytop);
+    lm = lm->next;
+  }
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::Execute(ClipType clipType, Polygons &solution,
+    PolyFillType subjFillType, PolyFillType clipFillType)
+{
+  if( m_ExecuteLocked ) return false;
+  m_ExecuteLocked = true;
+  solution.resize(0);
+  m_SubjFillType = subjFillType;
+  m_ClipFillType = clipFillType;
+  m_ClipType = clipType;
+  bool succeeded = ExecuteInternal(false);
+  if (succeeded) BuildResult(solution);
+  m_ExecuteLocked = false;
+  return succeeded;
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::Execute(ClipType clipType, ExPolygons &solution,
+    PolyFillType subjFillType, PolyFillType clipFillType)
+{
+  if( m_ExecuteLocked ) return false;
+  m_ExecuteLocked = true;
+  solution.resize(0);
+  m_SubjFillType = subjFillType;
+  m_ClipFillType = clipFillType;
+  m_ClipType = clipType;
+  bool succeeded = ExecuteInternal(true);
+  if (succeeded) BuildResultEx(solution);
+  m_ExecuteLocked = false;
+  return succeeded;
+}
+//------------------------------------------------------------------------------
+
+bool PolySort(OutRec *or1, OutRec *or2)
+{
+  if (or1 == or2) return false;
+  if (!or1->pts || !or2->pts)
+  {
+    if (or1->pts != or2->pts)
+    {
+      if (or1->pts) return true; else return false;
+    }
+    else return false;
+  }
+  int i1, i2;
+  if (or1->isHole)
+    i1 = or1->FirstLeft->idx; else
+    i1 = or1->idx;
+  if (or2->isHole)
+    i2 = or2->FirstLeft->idx; else
+    i2 = or2->idx;
+  int result = i1 - i2;
+  if (result == 0 && (or1->isHole != or2->isHole))
+  {
+    if (or1->isHole) return false;
+    else return true;
+  }
+  else return result < 0;
+}
+//------------------------------------------------------------------------------
+
+OutRec* FindAppendLinkEnd(OutRec *outRec)
+{
+  while (outRec->AppendLink) outRec = outRec->AppendLink;
+  return outRec;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::FixHoleLinkage(OutRec *outRec)
+{
+  OutRec *tmp;
+  if (outRec->bottomPt)
+    tmp = m_PolyOuts[outRec->bottomPt->idx]->FirstLeft;
+  else
+    tmp = outRec->FirstLeft;
+  if (outRec == tmp) throw clipperException("HoleLinkage error");
+
+  if (tmp)
+  {
+    if (tmp->AppendLink) tmp = FindAppendLinkEnd(tmp);
+    if (tmp == outRec) tmp = 0;
+    else if (tmp->isHole)
+    {
+      FixHoleLinkage(tmp);
+      tmp = tmp->FirstLeft;
+    }
+  }
+  outRec->FirstLeft = tmp;
+  if (!tmp) outRec->isHole = false;
+  outRec->AppendLink = 0;
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::ExecuteInternal(bool fixHoleLinkages)
+{
+  bool succeeded;
+  try {
+    Reset();
+    if (!m_CurrentLM ) return true;
+    long64 botY = PopScanbeam();
+    do {
+      InsertLocalMinimaIntoAEL(botY);
+      ClearHorzJoins();
+      ProcessHorizontals();
+      long64 topY = PopScanbeam();
+      succeeded = ProcessIntersections(botY, topY);
+      if (!succeeded) break;
+      ProcessEdgesAtTopOfScanbeam(topY);
+      botY = topY;
+    } while( m_Scanbeam );
+  }
+  catch(...) {
+    succeeded = false;
+  }
+
+  if (succeeded)
+  {
+    //tidy up output polygons and fix orientations where necessary ...
+    for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
+    {
+      OutRec *outRec = m_PolyOuts[i];
+      if (!outRec->pts) continue;
+      FixupOutPolygon(*outRec);
+      if (!outRec->pts) continue;
+      if (outRec->isHole && fixHoleLinkages) FixHoleLinkage(outRec);
+      if (outRec->isHole ==
+        (m_ReverseOutput ^ Orientation(outRec, m_UseFullRange)))
+          ReversePolyPtLinks(*outRec->pts);
+    }
+
+    JoinCommonEdges(fixHoleLinkages);
+    if (fixHoleLinkages)
+      std::sort(m_PolyOuts.begin(), m_PolyOuts.end(), PolySort);
+  }
+
+  ClearJoins();
+  ClearHorzJoins();
+  return succeeded;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::InsertScanbeam(const long64 Y)
+{
+  if( !m_Scanbeam )
+  {
+    m_Scanbeam = new Scanbeam;
+    m_Scanbeam->next = 0;
+    m_Scanbeam->Y = Y;
+  }
+  else if(  Y > m_Scanbeam->Y )
+  {
+    Scanbeam* newSb = new Scanbeam;
+    newSb->Y = Y;
+    newSb->next = m_Scanbeam;
+    m_Scanbeam = newSb;
+  } else
+  {
+    Scanbeam* sb2 = m_Scanbeam;
+    while( sb2->next  && ( Y <= sb2->next->Y ) ) sb2 = sb2->next;
+    if(  Y == sb2->Y ) return; //ie ignores duplicates
+    Scanbeam* newSb = new Scanbeam;
+    newSb->Y = Y;
+    newSb->next = sb2->next;
+    sb2->next = newSb;
+  }
+}
+//------------------------------------------------------------------------------
+
+long64 Clipper::PopScanbeam()
+{
+  long64 Y = m_Scanbeam->Y;
+  Scanbeam* sb2 = m_Scanbeam;
+  m_Scanbeam = m_Scanbeam->next;
+  delete sb2;
+  return Y;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::DisposeAllPolyPts(){
+  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
+    DisposeOutRec(i);
+  m_PolyOuts.clear();
+}
+//------------------------------------------------------------------------------
+
+void Clipper::DisposeOutRec(PolyOutList::size_type index, bool ignorePts)
+{
+  OutRec *outRec = m_PolyOuts[index];
+  if (!ignorePts && outRec->pts) DisposeOutPts(outRec->pts);
+  delete outRec;
+  m_PolyOuts[index] = 0;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::SetWindingCount(TEdge &edge)
+{
+  TEdge *e = edge.prevInAEL;
+  //find the edge of the same polytype that immediately preceeds 'edge' in AEL
+  while ( e  && e->polyType != edge.polyType ) e = e->prevInAEL;
+  if ( !e )
+  {
+    edge.windCnt = edge.windDelta;
+    edge.windCnt2 = 0;
+    e = m_ActiveEdges; //ie get ready to calc windCnt2
+  } else if ( IsEvenOddFillType(edge) )
+  {
+    //EvenOdd filling ...
+    edge.windCnt = 1;
+    edge.windCnt2 = e->windCnt2;
+    e = e->nextInAEL; //ie get ready to calc windCnt2
+  } else
+  {
+    //nonZero, Positive or Negative filling ...
+    if ( e->windCnt * e->windDelta < 0 )
+    {
+      if (Abs(e->windCnt) > 1)
+      {
+        if (e->windDelta * edge.windDelta < 0) edge.windCnt = e->windCnt;
+        else edge.windCnt = e->windCnt + edge.windDelta;
+      } else
+        edge.windCnt = e->windCnt + e->windDelta + edge.windDelta;
+    } else
+    {
+      if ( Abs(e->windCnt) > 1 && e->windDelta * edge.windDelta < 0)
+        edge.windCnt = e->windCnt;
+      else if ( e->windCnt + edge.windDelta == 0 )
+        edge.windCnt = e->windCnt;
+      else edge.windCnt = e->windCnt + edge.windDelta;
+    }
+    edge.windCnt2 = e->windCnt2;
+    e = e->nextInAEL; //ie get ready to calc windCnt2
+  }
+
+  //update windCnt2 ...
+  if ( IsEvenOddAltFillType(edge) )
+  {
+    //EvenOdd filling ...
+    while ( e != &edge )
+    {
+      edge.windCnt2 = (edge.windCnt2 == 0) ? 1 : 0;
+      e = e->nextInAEL;
+    }
+  } else
+  {
+    //nonZero, Positive or Negative filling ...
+    while ( e != &edge )
+    {
+      edge.windCnt2 += e->windDelta;
+      e = e->nextInAEL;
+    }
+  }
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::IsEvenOddFillType(const TEdge& edge) const
+{
+  if (edge.polyType == ptSubject)
+    return m_SubjFillType == pftEvenOdd; else
+    return m_ClipFillType == pftEvenOdd;
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::IsEvenOddAltFillType(const TEdge& edge) const
+{
+  if (edge.polyType == ptSubject)
+    return m_ClipFillType == pftEvenOdd; else
+    return m_SubjFillType == pftEvenOdd;
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::IsContributing(const TEdge& edge) const
+{
+  PolyFillType pft, pft2;
+  if (edge.polyType == ptSubject)
+  {
+    pft = m_SubjFillType;
+    pft2 = m_ClipFillType;
+  } else
+  {
+    pft = m_ClipFillType;
+    pft2 = m_SubjFillType;
+  }
+
+  switch(pft)
+  {
+    case pftEvenOdd: 
+    case pftNonZero:
+      if (Abs(edge.windCnt) != 1) return false;
+      break;
+    case pftPositive: 
+      if (edge.windCnt != 1) return false;
+      break;
+    default: //pftNegative
+      if (edge.windCnt != -1) return false;
+  }
+
+  switch(m_ClipType)
+  {
+    case ctIntersection:
+      switch(pft2)
+      {
+        case pftEvenOdd: 
+        case pftNonZero: 
+          return (edge.windCnt2 != 0);
+        case pftPositive: 
+          return (edge.windCnt2 > 0);
+        default: 
+          return (edge.windCnt2 < 0);
+      }
+    case ctUnion:
+      switch(pft2)
+      {
+        case pftEvenOdd: 
+        case pftNonZero: 
+          return (edge.windCnt2 == 0);
+        case pftPositive: 
+          return (edge.windCnt2 <= 0);
+        default: 
+          return (edge.windCnt2 >= 0);
+      }
+    case ctDifference:
+      if (edge.polyType == ptSubject)
+        switch(pft2)
+        {
+          case pftEvenOdd: 
+          case pftNonZero: 
+            return (edge.windCnt2 == 0);
+          case pftPositive: 
+            return (edge.windCnt2 <= 0);
+          default: 
+            return (edge.windCnt2 >= 0);
+        }
+      else
+        switch(pft2)
+        {
+          case pftEvenOdd: 
+          case pftNonZero: 
+            return (edge.windCnt2 != 0);
+          case pftPositive: 
+            return (edge.windCnt2 > 0);
+          default: 
+            return (edge.windCnt2 < 0);
+        }
+    default:
+      return true;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AddLocalMinPoly(TEdge *e1, TEdge *e2, const IntPoint &pt)
+{
+  if( NEAR_EQUAL(e2->dx, HORIZONTAL) || ( e1->dx > e2->dx ) )
+  {
+    AddOutPt( e1, e2, pt );
+    e2->outIdx = e1->outIdx;
+    e1->side = esLeft;
+    e2->side = esRight;
+  } else
+  {
+    AddOutPt( e2, e1, pt );
+    e1->outIdx = e2->outIdx;
+    e1->side = esRight;
+    e2->side = esLeft;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AddLocalMaxPoly(TEdge *e1, TEdge *e2, const IntPoint &pt)
+{
+  AddOutPt( e1, 0, pt );
+  if( e1->outIdx == e2->outIdx )
+  {
+    e1->outIdx = -1;
+    e2->outIdx = -1;
+  }
+  else
+    AppendPolygon( e1, e2 );
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AddEdgeToSEL(TEdge *edge)
+{
+  //SEL pointers in PEdge are reused to build a list of horizontal edges.
+  //However, we don't need to worry about order with horizontal edge processing.
+  if( !m_SortedEdges )
+  {
+    m_SortedEdges = edge;
+    edge->prevInSEL = 0;
+    edge->nextInSEL = 0;
+  }
+  else
+  {
+    edge->nextInSEL = m_SortedEdges;
+    edge->prevInSEL = 0;
+    m_SortedEdges->prevInSEL = edge;
+    m_SortedEdges = edge;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::CopyAELToSEL()
+{
+  TEdge* e = m_ActiveEdges;
+  m_SortedEdges = e;
+  if (!m_ActiveEdges) return;
+  m_SortedEdges->prevInSEL = 0;
+  e = e->nextInAEL;
+  while ( e )
+  {
+    e->prevInSEL = e->prevInAEL;
+    e->prevInSEL->nextInSEL = e;
+    e->nextInSEL = 0;
+    e = e->nextInAEL;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AddJoin(TEdge *e1, TEdge *e2, int e1OutIdx, int e2OutIdx)
+{
+  JoinRec* jr = new JoinRec;
+  if (e1OutIdx >= 0)
+    jr->poly1Idx = e1OutIdx; else
+    jr->poly1Idx = e1->outIdx;
+  jr->pt1a = IntPoint(e1->xcurr, e1->ycurr);
+  jr->pt1b = IntPoint(e1->xtop, e1->ytop);
+  if (e2OutIdx >= 0)
+    jr->poly2Idx = e2OutIdx; else
+    jr->poly2Idx = e2->outIdx;
+  jr->pt2a = IntPoint(e2->xcurr, e2->ycurr);
+  jr->pt2b = IntPoint(e2->xtop, e2->ytop);
+  m_Joins.push_back(jr);
+}
+//------------------------------------------------------------------------------
+
+void Clipper::ClearJoins()
+{
+  for (JoinList::size_type i = 0; i < m_Joins.size(); i++)
+    delete m_Joins[i];
+  m_Joins.resize(0);
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AddHorzJoin(TEdge *e, int idx)
+{
+  HorzJoinRec* hj = new HorzJoinRec;
+  hj->edge = e;
+  hj->savedIdx = idx;
+  m_HorizJoins.push_back(hj);
+}
+//------------------------------------------------------------------------------
+
+void Clipper::ClearHorzJoins()
+{
+  for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); i++)
+    delete m_HorizJoins[i];
+  m_HorizJoins.resize(0);
+}
+//------------------------------------------------------------------------------
+
+void Clipper::InsertLocalMinimaIntoAEL( const long64 botY)
+{
+  while(  m_CurrentLM  && ( m_CurrentLM->Y == botY ) )
+  {
+    TEdge* lb = m_CurrentLM->leftBound;
+    TEdge* rb = m_CurrentLM->rightBound;
+
+    InsertEdgeIntoAEL( lb );
+    InsertScanbeam( lb->ytop );
+    InsertEdgeIntoAEL( rb );
+
+    if (IsEvenOddFillType(*lb))
+    {
+      lb->windDelta = 1;
+      rb->windDelta = 1;
+    }
+    else
+    {
+      rb->windDelta = -lb->windDelta;
+    }
+    SetWindingCount( *lb );
+    rb->windCnt = lb->windCnt;
+    rb->windCnt2 = lb->windCnt2;
+
+    if( NEAR_EQUAL(rb->dx, HORIZONTAL) )
+    {
+      //nb: only rightbounds can have a horizontal bottom edge
+      AddEdgeToSEL( rb );
+      InsertScanbeam( rb->nextInLML->ytop );
+    }
+    else
+      InsertScanbeam( rb->ytop );
+
+    if( IsContributing(*lb) )
+      AddLocalMinPoly( lb, rb, IntPoint(lb->xcurr, m_CurrentLM->Y) );
+
+    //if output polygons share an edge, they'll need joining later ...
+    if (lb->outIdx >= 0 && lb->prevInAEL &&
+      lb->prevInAEL->outIdx >= 0 && lb->prevInAEL->xcurr == lb->xbot &&
+       SlopesEqual(*lb, *lb->prevInAEL, m_UseFullRange))
+         AddJoin(lb, lb->prevInAEL);
+
+    //if any output polygons share an edge, they'll need joining later ...
+    if (rb->outIdx >= 0)
+    {
+      if (NEAR_EQUAL(rb->dx, HORIZONTAL))
+      {
+        for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); ++i)
+        {
+          IntPoint pt, pt2; //returned by GetOverlapSegment() but unused here.
+          HorzJoinRec* hj = m_HorizJoins[i];
+          //if horizontals rb and hj.edge overlap, flag for joining later ...
+          if (GetOverlapSegment(IntPoint(hj->edge->xbot, hj->edge->ybot),
+            IntPoint(hj->edge->xtop, hj->edge->ytop),
+            IntPoint(rb->xbot, rb->ybot),
+            IntPoint(rb->xtop, rb->ytop), pt, pt2))
+              AddJoin(hj->edge, rb, hj->savedIdx);
+        }
+      }
+    }
+
+    if( lb->nextInAEL != rb )
+    {
+      if (rb->outIdx >= 0 && rb->prevInAEL->outIdx >= 0 &&
+        SlopesEqual(*rb->prevInAEL, *rb, m_UseFullRange))
+          AddJoin(rb, rb->prevInAEL);
+
+      TEdge* e = lb->nextInAEL;
+      IntPoint pt = IntPoint(lb->xcurr, lb->ycurr);
+      while( e != rb )
+      {
+        if(!e) throw clipperException("InsertLocalMinimaIntoAEL: missing rightbound!");
+        //nb: For calculating winding counts etc, IntersectEdges() assumes
+        //that param1 will be to the right of param2 ABOVE the intersection ...
+        IntersectEdges( rb , e , pt , ipNone); //order important here
+        e = e->nextInAEL;
+      }
+    }
+    PopLocalMinima();
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::DeleteFromAEL(TEdge *e)
+{
+  TEdge* AelPrev = e->prevInAEL;
+  TEdge* AelNext = e->nextInAEL;
+  if(  !AelPrev &&  !AelNext && (e != m_ActiveEdges) ) return; //already deleted
+  if( AelPrev ) AelPrev->nextInAEL = AelNext;
+  else m_ActiveEdges = AelNext;
+  if( AelNext ) AelNext->prevInAEL = AelPrev;
+  e->nextInAEL = 0;
+  e->prevInAEL = 0;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::DeleteFromSEL(TEdge *e)
+{
+  TEdge* SelPrev = e->prevInSEL;
+  TEdge* SelNext = e->nextInSEL;
+  if( !SelPrev &&  !SelNext && (e != m_SortedEdges) ) return; //already deleted
+  if( SelPrev ) SelPrev->nextInSEL = SelNext;
+  else m_SortedEdges = SelNext;
+  if( SelNext ) SelNext->prevInSEL = SelPrev;
+  e->nextInSEL = 0;
+  e->prevInSEL = 0;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::IntersectEdges(TEdge *e1, TEdge *e2,
+     const IntPoint &pt, IntersectProtects protects)
+{
+  //e1 will be to the left of e2 BELOW the intersection. Therefore e1 is before
+  //e2 in AEL except when e1 is being inserted at the intersection point ...
+  bool e1stops = !(ipLeft & protects) &&  !e1->nextInLML &&
+    e1->xtop == pt.X && e1->ytop == pt.Y;
+  bool e2stops = !(ipRight & protects) &&  !e2->nextInLML &&
+    e2->xtop == pt.X && e2->ytop == pt.Y;
+  bool e1Contributing = ( e1->outIdx >= 0 );
+  bool e2contributing = ( e2->outIdx >= 0 );
+
+  //update winding counts...
+  //assumes that e1 will be to the right of e2 ABOVE the intersection
+  if ( e1->polyType == e2->polyType )
+  {
+    if ( IsEvenOddFillType( *e1) )
+    {
+      int oldE1WindCnt = e1->windCnt;
+      e1->windCnt = e2->windCnt;
+      e2->windCnt = oldE1WindCnt;
+    } else
+    {
+      if (e1->windCnt + e2->windDelta == 0 ) e1->windCnt = -e1->windCnt;
+      else e1->windCnt += e2->windDelta;
+      if ( e2->windCnt - e1->windDelta == 0 ) e2->windCnt = -e2->windCnt;
+      else e2->windCnt -= e1->windDelta;
+    }
+  } else
+  {
+    if (!IsEvenOddFillType(*e2)) e1->windCnt2 += e2->windDelta;
+    else e1->windCnt2 = ( e1->windCnt2 == 0 ) ? 1 : 0;
+    if (!IsEvenOddFillType(*e1)) e2->windCnt2 -= e1->windDelta;
+    else e2->windCnt2 = ( e2->windCnt2 == 0 ) ? 1 : 0;
+  }
+
+  PolyFillType e1FillType, e2FillType, e1FillType2, e2FillType2;
+  if (e1->polyType == ptSubject)
+  {
+    e1FillType = m_SubjFillType;
+    e1FillType2 = m_ClipFillType;
+  } else
+  {
+    e1FillType = m_ClipFillType;
+    e1FillType2 = m_SubjFillType;
+  }
+  if (e2->polyType == ptSubject)
+  {
+    e2FillType = m_SubjFillType;
+    e2FillType2 = m_ClipFillType;
+  } else
+  {
+    e2FillType = m_ClipFillType;
+    e2FillType2 = m_SubjFillType;
+  }
+
+  long64 e1Wc, e2Wc;
+  switch (e1FillType)
+  {
+    case pftPositive: e1Wc = e1->windCnt; break;
+    case pftNegative: e1Wc = -e1->windCnt; break;
+    default: e1Wc = Abs(e1->windCnt);
+  }
+  switch(e2FillType)
+  {
+    case pftPositive: e2Wc = e2->windCnt; break;
+    case pftNegative: e2Wc = -e2->windCnt; break;
+    default: e2Wc = Abs(e2->windCnt);
+  }
+
+  if ( e1Contributing && e2contributing )
+  {
+    if ( e1stops || e2stops || 
+      (e1Wc != 0 && e1Wc != 1) || (e2Wc != 0 && e2Wc != 1) ||
+      (e1->polyType != e2->polyType && m_ClipType != ctXor) )
+        AddLocalMaxPoly(e1, e2, pt); 
+    else
+        DoBothEdges( e1, e2, pt );
+  }
+  else if ( e1Contributing )
+  {
+    if ((e2Wc == 0 || e2Wc == 1) && 
+      (m_ClipType != ctIntersection || 
+      e2->polyType == ptSubject || (e2->windCnt2 != 0))) 
+        DoEdge1(e1, e2, pt);
+  }
+  else if ( e2contributing )
+  {
+    if ((e1Wc == 0 || e1Wc == 1) && 
+      (m_ClipType != ctIntersection || 
+      e1->polyType == ptSubject || (e1->windCnt2 != 0))) 
+        DoEdge2(e1, e2, pt);
+  } 
+  else if ( (e1Wc == 0 || e1Wc == 1) && 
+    (e2Wc == 0 || e2Wc == 1) && !e1stops && !e2stops )
+  {
+    //neither edge is currently contributing ...
+
+    long64 e1Wc2, e2Wc2;
+    switch (e1FillType2)
+    {
+      case pftPositive: e1Wc2 = e1->windCnt2; break;
+      case pftNegative : e1Wc2 = -e1->windCnt2; break;
+      default: e1Wc2 = Abs(e1->windCnt2);
+    }
+    switch (e2FillType2)
+    {
+      case pftPositive: e2Wc2 = e2->windCnt2; break;
+      case pftNegative: e2Wc2 = -e2->windCnt2; break;
+      default: e2Wc2 = Abs(e2->windCnt2);
+    }
+
+    if (e1->polyType != e2->polyType)
+        AddLocalMinPoly(e1, e2, pt);
+    else if (e1Wc == 1 && e2Wc == 1)
+      switch( m_ClipType ) {
+        case ctIntersection:
+          if (e1Wc2 > 0 && e2Wc2 > 0)
+            AddLocalMinPoly(e1, e2, pt);
+          break;
+        case ctUnion:
+          if ( e1Wc2 <= 0 && e2Wc2 <= 0 )
+            AddLocalMinPoly(e1, e2, pt);
+          break;
+        case ctDifference:
+          if ((e1->polyType == ptClip && e2->polyType == ptClip && 
+              e1Wc2 > 0 && e2Wc2 > 0) || 
+              (e1->polyType == ptSubject && e2->polyType == ptSubject && 
+              e1Wc2 <= 0 && e2Wc2 <= 0)) 
+                AddLocalMinPoly(e1, e2, pt);
+          break;
+        case ctXor:
+          AddLocalMinPoly(e1, e2, pt);
+      }
+    else
+      SwapSides( *e1, *e2 );
+  }
+
+  if(  (e1stops != e2stops) &&
+    ( (e1stops && (e1->outIdx >= 0)) || (e2stops && (e2->outIdx >= 0)) ) )
+  {
+    SwapSides( *e1, *e2 );
+    SwapPolyIndexes( *e1, *e2 );
+  }
+
+  //finally, delete any non-contributing maxima edges  ...
+  if( e1stops ) DeleteFromAEL( e1 );
+  if( e2stops ) DeleteFromAEL( e2 );
+}
+//------------------------------------------------------------------------------
+
+void Clipper::SetHoleState(TEdge *e, OutRec *outRec)
+{
+  bool isHole = false;
+  TEdge *e2 = e->prevInAEL;
+  while (e2)
+  {
+    if (e2->outIdx >= 0)
+    {
+      isHole = !isHole;
+      if (! outRec->FirstLeft)
+        outRec->FirstLeft = m_PolyOuts[e2->outIdx];
+    }
+    e2 = e2->prevInAEL;
+  }
+  if (isHole) outRec->isHole = true;
+}
+//------------------------------------------------------------------------------
+
+bool GetNextNonDupOutPt(OutPt* pp, OutPt*& next)
+{
+  next = pp->next;
+  while (next != pp && PointsEqual(pp->pt, next->pt))
+    next = next->next;
+  return next != pp;
+}
+//------------------------------------------------------------------------------
+
+bool GetPrevNonDupOutPt(OutPt* pp, OutPt*& prev)
+{
+  prev = pp->prev;
+  while (prev != pp && PointsEqual(pp->pt, prev->pt))
+    prev = prev->prev;
+  return prev != pp;
+}
+//------------------------------------------------------------------------------
+
+OutRec* GetLowermostRec(OutRec *outRec1, OutRec *outRec2)
+{
+  //work out which polygon fragment has the correct hole state ...
+  OutPt *outPt1 = outRec1->bottomPt;
+  OutPt *outPt2 = outRec2->bottomPt;
+  if (outPt1->pt.Y > outPt2->pt.Y) return outRec1;
+  else if (outPt1->pt.Y < outPt2->pt.Y) return outRec2;
+  else if (outPt1->pt.X < outPt2->pt.X) return outRec1;
+  else if (outPt1->pt.X > outPt2->pt.X) return outRec2;
+  else if (outRec1->bottomE2 == 0) return outRec2;
+  else if (outRec2->bottomE2 == 0) return outRec1;
+  else
+  {
+    long64 y1 = std::max(outRec1->bottomE1->ybot, outRec1->bottomE2->ybot);
+    long64 y2 = std::max(outRec2->bottomE1->ybot, outRec2->bottomE2->ybot);
+    if (y2 == y1 || (y1 > outPt1->pt.Y && y2 > outPt1->pt.Y))
+    {
+      double dx1 = std::max(outRec1->bottomE1->dx, outRec1->bottomE2->dx);
+      double dx2 = std::max(outRec2->bottomE1->dx, outRec2->bottomE2->dx);
+      if (dx2 > dx1) return outRec2; else return outRec1;
+    }
+    else if (y2 > y1) return outRec2;
+    else return outRec1;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AppendPolygon(TEdge *e1, TEdge *e2)
+{
+  //get the start and ends of both output polygons ...
+  OutRec *outRec1 = m_PolyOuts[e1->outIdx];
+  OutRec *outRec2 = m_PolyOuts[e2->outIdx];
+  OutRec *holeStateRec = GetLowermostRec(outRec1, outRec2);
+
+  //fixup hole status ...
+  if (holeStateRec == outRec2)
+    outRec1->isHole = outRec2->isHole;
+  else
+    outRec2->isHole = outRec1->isHole;
+
+  OutPt* p1_lft = outRec1->pts;
+  OutPt* p1_rt = p1_lft->prev;
+  OutPt* p2_lft = outRec2->pts;
+  OutPt* p2_rt = p2_lft->prev;
+
+  EdgeSide side;
+  //join e2 poly onto e1 poly and delete pointers to e2 ...
+  if(  e1->side == esLeft )
+  {
+    if(  e2->side == esLeft )
+    {
+      //z y x a b c
+      ReversePolyPtLinks(*p2_lft);
+      p2_lft->next = p1_lft;
+      p1_lft->prev = p2_lft;
+      p1_rt->next = p2_rt;
+      p2_rt->prev = p1_rt;
+      outRec1->pts = p2_rt;
+    } else
+    {
+      //x y z a b c
+      p2_rt->next = p1_lft;
+      p1_lft->prev = p2_rt;
+      p2_lft->prev = p1_rt;
+      p1_rt->next = p2_lft;
+      outRec1->pts = p2_lft;
+    }
+    side = esLeft;
+  } else
+  {
+    if(  e2->side == esRight )
+    {
+      //a b c z y x
+      ReversePolyPtLinks( *p2_lft );
+      p1_rt->next = p2_rt;
+      p2_rt->prev = p1_rt;
+      p2_lft->next = p1_lft;
+      p1_lft->prev = p2_lft;
+    } else
+    {
+      //a b c x y z
+      p1_rt->next = p2_lft;
+      p2_lft->prev = p1_rt;
+      p1_lft->prev = p2_rt;
+      p2_rt->next = p1_lft;
+    }
+    side = esRight;
+  }
+
+  if (holeStateRec == outRec2)
+  {
+    outRec1->bottomPt = outRec2->bottomPt;
+    outRec1->bottomPt->idx = outRec1->idx;
+    outRec1->bottomE1 = outRec2->bottomE1;
+    outRec1->bottomE2 = outRec2->bottomE2;
+
+    if (outRec2->FirstLeft != outRec1)
+      outRec1->FirstLeft = outRec2->FirstLeft;
+  }
+  outRec2->pts = 0;
+  outRec2->bottomPt = 0;
+  outRec2->AppendLink = outRec1;
+  int OKIdx = e1->outIdx;
+  int ObsoleteIdx = e2->outIdx;
+
+  e1->outIdx = -1; //nb: safe because we only get here via AddLocalMaxPoly
+  e2->outIdx = -1;
+
+  TEdge* e = m_ActiveEdges;
+  while( e )
+  {
+    if( e->outIdx == ObsoleteIdx )
+    {
+      e->outIdx = OKIdx;
+      e->side = side;
+      break;
+    }
+    e = e->nextInAEL;
+  }
+
+  for (JoinList::size_type i = 0; i < m_Joins.size(); ++i)
+  {
+      if (m_Joins[i]->poly1Idx == ObsoleteIdx) m_Joins[i]->poly1Idx = OKIdx;
+      if (m_Joins[i]->poly2Idx == ObsoleteIdx) m_Joins[i]->poly2Idx = OKIdx;
+  }
+
+  for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); ++i)
+  {
+      if (m_HorizJoins[i]->savedIdx == ObsoleteIdx)
+        m_HorizJoins[i]->savedIdx = OKIdx;
+  }
+
+}
+//------------------------------------------------------------------------------
+
+OutRec* Clipper::CreateOutRec()
+{
+  OutRec* result = new OutRec;
+  result->isHole = false;
+  result->FirstLeft = 0;
+  result->AppendLink = 0;
+  result->pts = 0;
+  result->bottomPt = 0;
+  return result;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AddOutPt(TEdge *e, TEdge *altE, const IntPoint &pt)
+{
+  bool ToFront = (e->side == esLeft);
+  if(  e->outIdx < 0 )
+  {
+    OutRec *outRec = CreateOutRec();
+    m_PolyOuts.push_back(outRec);
+    outRec->idx = (int)m_PolyOuts.size()-1;
+    e->outIdx = outRec->idx;
+    OutPt* op = new OutPt;
+    outRec->pts = op;
+    outRec->bottomE1 = e;
+    outRec->bottomE2 = altE;
+    outRec->bottomPt = op;
+    op->pt = pt;
+    op->idx = outRec->idx;
+    op->next = op;
+    op->prev = op;
+    SetHoleState(e, outRec);
+  } else
+  {
+    OutRec *outRec = m_PolyOuts[e->outIdx];
+    OutPt* op = outRec->pts;
+    if ((ToFront && PointsEqual(pt, op->pt)) ||
+      (!ToFront && PointsEqual(pt, op->prev->pt))) return;
+    OutPt* op2 = new OutPt;
+    op2->pt = pt;
+    op2->idx = outRec->idx;
+    if (op2->pt.Y == outRec->bottomPt->pt.Y &&
+      op2->pt.X < outRec->bottomPt->pt.X)
+    {
+      outRec->bottomPt = op2;
+      outRec->bottomE1 = e;
+      outRec->bottomE2 = altE;
+    }
+    op2->next = op;
+    op2->prev = op->prev;
+    op2->prev->next = op2;
+    op->prev = op2;
+    if (ToFront) outRec->pts = op2;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::ProcessHorizontals()
+{
+  TEdge* horzEdge = m_SortedEdges;
+  while( horzEdge )
+  {
+    DeleteFromSEL( horzEdge );
+    ProcessHorizontal( horzEdge );
+    horzEdge = m_SortedEdges;
+  }
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::IsTopHorz(const long64 XPos)
+{
+  TEdge* e = m_SortedEdges;
+  while( e )
+  {
+    if(  ( XPos >= std::min(e->xcurr, e->xtop) ) &&
+      ( XPos <= std::max(e->xcurr, e->xtop) ) ) return false;
+    e = e->nextInSEL;
+  }
+  return true;
+}
+//------------------------------------------------------------------------------
+
+bool IsMinima(TEdge *e)
+{
+  return e  && (e->prev->nextInLML != e) && (e->next->nextInLML != e);
+}
+//------------------------------------------------------------------------------
+
+bool IsMaxima(TEdge *e, const long64 Y)
+{
+  return e && e->ytop == Y && !e->nextInLML;
+}
+//------------------------------------------------------------------------------
+
+bool IsIntermediate(TEdge *e, const long64 Y)
+{
+  return e->ytop == Y && e->nextInLML;
+}
+//------------------------------------------------------------------------------
+
+TEdge *GetMaximaPair(TEdge *e)
+{
+  if( !IsMaxima(e->next, e->ytop) || e->next->xtop != e->xtop )
+    return e->prev; else
+    return e->next;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::SwapPositionsInAEL(TEdge *edge1, TEdge *edge2)
+{
+  if(  !edge1->nextInAEL &&  !edge1->prevInAEL ) return;
+  if(  !edge2->nextInAEL &&  !edge2->prevInAEL ) return;
+
+  if(  edge1->nextInAEL == edge2 )
+  {
+    TEdge* next = edge2->nextInAEL;
+    if( next ) next->prevInAEL = edge1;
+    TEdge* prev = edge1->prevInAEL;
+    if( prev ) prev->nextInAEL = edge2;
+    edge2->prevInAEL = prev;
+    edge2->nextInAEL = edge1;
+    edge1->prevInAEL = edge2;
+    edge1->nextInAEL = next;
+  }
+  else if(  edge2->nextInAEL == edge1 )
+  {
+    TEdge* next = edge1->nextInAEL;
+    if( next ) next->prevInAEL = edge2;
+    TEdge* prev = edge2->prevInAEL;
+    if( prev ) prev->nextInAEL = edge1;
+    edge1->prevInAEL = prev;
+    edge1->nextInAEL = edge2;
+    edge2->prevInAEL = edge1;
+    edge2->nextInAEL = next;
+  }
+  else
+  {
+    TEdge* next = edge1->nextInAEL;
+    TEdge* prev = edge1->prevInAEL;
+    edge1->nextInAEL = edge2->nextInAEL;
+    if( edge1->nextInAEL ) edge1->nextInAEL->prevInAEL = edge1;
+    edge1->prevInAEL = edge2->prevInAEL;
+    if( edge1->prevInAEL ) edge1->prevInAEL->nextInAEL = edge1;
+    edge2->nextInAEL = next;
+    if( edge2->nextInAEL ) edge2->nextInAEL->prevInAEL = edge2;
+    edge2->prevInAEL = prev;
+    if( edge2->prevInAEL ) edge2->prevInAEL->nextInAEL = edge2;
+  }
+
+  if( !edge1->prevInAEL ) m_ActiveEdges = edge1;
+  else if( !edge2->prevInAEL ) m_ActiveEdges = edge2;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::SwapPositionsInSEL(TEdge *edge1, TEdge *edge2)
+{
+  if(  !( edge1->nextInSEL ) &&  !( edge1->prevInSEL ) ) return;
+  if(  !( edge2->nextInSEL ) &&  !( edge2->prevInSEL ) ) return;
+
+  if(  edge1->nextInSEL == edge2 )
+  {
+    TEdge* next = edge2->nextInSEL;
+    if( next ) next->prevInSEL = edge1;
+    TEdge* prev = edge1->prevInSEL;
+    if( prev ) prev->nextInSEL = edge2;
+    edge2->prevInSEL = prev;
+    edge2->nextInSEL = edge1;
+    edge1->prevInSEL = edge2;
+    edge1->nextInSEL = next;
+  }
+  else if(  edge2->nextInSEL == edge1 )
+  {
+    TEdge* next = edge1->nextInSEL;
+    if( next ) next->prevInSEL = edge2;
+    TEdge* prev = edge2->prevInSEL;
+    if( prev ) prev->nextInSEL = edge1;
+    edge1->prevInSEL = prev;
+    edge1->nextInSEL = edge2;
+    edge2->prevInSEL = edge1;
+    edge2->nextInSEL = next;
+  }
+  else
+  {
+    TEdge* next = edge1->nextInSEL;
+    TEdge* prev = edge1->prevInSEL;
+    edge1->nextInSEL = edge2->nextInSEL;
+    if( edge1->nextInSEL ) edge1->nextInSEL->prevInSEL = edge1;
+    edge1->prevInSEL = edge2->prevInSEL;
+    if( edge1->prevInSEL ) edge1->prevInSEL->nextInSEL = edge1;
+    edge2->nextInSEL = next;
+    if( edge2->nextInSEL ) edge2->nextInSEL->prevInSEL = edge2;
+    edge2->prevInSEL = prev;
+    if( edge2->prevInSEL ) edge2->prevInSEL->nextInSEL = edge2;
+  }
+
+  if( !edge1->prevInSEL ) m_SortedEdges = edge1;
+  else if( !edge2->prevInSEL ) m_SortedEdges = edge2;
+}
+//------------------------------------------------------------------------------
+
+TEdge* GetNextInAEL(TEdge *e, Direction dir)
+{
+  if( dir == dLeftToRight ) return e->nextInAEL;
+  else return e->prevInAEL;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::ProcessHorizontal(TEdge *horzEdge)
+{
+  Direction dir;
+  long64 horzLeft, horzRight;
+
+  if( horzEdge->xcurr < horzEdge->xtop )
+  {
+    horzLeft = horzEdge->xcurr;
+    horzRight = horzEdge->xtop;
+    dir = dLeftToRight;
+  } else
+  {
+    horzLeft = horzEdge->xtop;
+    horzRight = horzEdge->xcurr;
+    dir = dRightToLeft;
+  }
+
+  TEdge* eMaxPair;
+  if( horzEdge->nextInLML ) eMaxPair = 0;
+  else eMaxPair = GetMaximaPair(horzEdge);
+
+  TEdge* e = GetNextInAEL( horzEdge , dir );
+  while( e )
+  {
+    TEdge* eNext = GetNextInAEL( e, dir );
+
+    if (eMaxPair ||
+      ((dir == dLeftToRight) && (e->xcurr <= horzRight)) ||
+      ((dir == dRightToLeft) && (e->xcurr >= horzLeft)))
+    {
+      //ok, so far it looks like we're still in range of the horizontal edge
+      if ( e->xcurr == horzEdge->xtop && !eMaxPair )
+      {
+        assert(horzEdge->nextInLML);
+        if (SlopesEqual(*e, *horzEdge->nextInLML, m_UseFullRange))
+        {
+          //if output polygons share an edge, they'll need joining later ...
+          if (horzEdge->outIdx >= 0 && e->outIdx >= 0)
+            AddJoin(horzEdge->nextInLML, e, horzEdge->outIdx);
+          break; //we've reached the end of the horizontal line
+        }
+        else if (e->dx < horzEdge->nextInLML->dx)
+        //we really have got to the end of the intermediate horz edge so quit.
+        //nb: More -ve slopes follow more +ve slopes ABOVE the horizontal.
+          break;
+      }
+
+      if( e == eMaxPair )
+      {
+        //horzEdge is evidently a maxima horizontal and we've arrived at its end.
+        if (dir == dLeftToRight)
+          IntersectEdges(horzEdge, e, IntPoint(e->xcurr, horzEdge->ycurr), ipNone);
+        else
+          IntersectEdges(e, horzEdge, IntPoint(e->xcurr, horzEdge->ycurr), ipNone);
+        if (eMaxPair->outIdx >= 0) throw clipperException("ProcessHorizontal error");
+        return;
+      }
+      else if( NEAR_EQUAL(e->dx, HORIZONTAL) &&  !IsMinima(e) && !(e->xcurr > e->xtop) )
+      {
+        //An overlapping horizontal edge. Overlapping horizontal edges are
+        //processed as if layered with the current horizontal edge (horizEdge)
+        //being infinitesimally lower that the next (e). Therfore, we
+        //intersect with e only if e.xcurr is within the bounds of horzEdge ...
+        if( dir == dLeftToRight )
+          IntersectEdges( horzEdge , e, IntPoint(e->xcurr, horzEdge->ycurr),
+            (IsTopHorz( e->xcurr ))? ipLeft : ipBoth );
+        else
+          IntersectEdges( e, horzEdge, IntPoint(e->xcurr, horzEdge->ycurr),
+            (IsTopHorz( e->xcurr ))? ipRight : ipBoth );
+      }
+      else if( dir == dLeftToRight )
+      {
+        IntersectEdges( horzEdge, e, IntPoint(e->xcurr, horzEdge->ycurr),
+          (IsTopHorz( e->xcurr ))? ipLeft : ipBoth );
+      }
+      else
+      {
+        IntersectEdges( e, horzEdge, IntPoint(e->xcurr, horzEdge->ycurr),
+          (IsTopHorz( e->xcurr ))? ipRight : ipBoth );
+      }
+      SwapPositionsInAEL( horzEdge, e );
+    }
+    else if( (dir == dLeftToRight && e->xcurr > horzRight  && m_SortedEdges) ||
+     (dir == dRightToLeft && e->xcurr < horzLeft && m_SortedEdges) ) break;
+    e = eNext;
+  } //end while
+
+  if( horzEdge->nextInLML )
+  {
+    if( horzEdge->outIdx >= 0 )
+      AddOutPt( horzEdge, 0, IntPoint(horzEdge->xtop, horzEdge->ytop));
+    UpdateEdgeIntoAEL( horzEdge );
+  }
+  else
+  {
+    assert(eMaxPair);
+    if ( horzEdge->outIdx >= 0 )
+    {
+      IntersectEdges( horzEdge, eMaxPair,
+          IntPoint(horzEdge->xtop, horzEdge->ycurr), ipBoth);
+    }
+    if (eMaxPair->outIdx >= 0) throw clipperException("ProcessHorizontal error");
+    DeleteFromAEL(eMaxPair);
+    DeleteFromAEL(horzEdge);
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::UpdateEdgeIntoAEL(TEdge *&e)
+{
+  if( !e->nextInLML ) throw
+    clipperException("UpdateEdgeIntoAEL: invalid call");
+  TEdge* AelPrev = e->prevInAEL;
+  TEdge* AelNext = e->nextInAEL;
+  e->nextInLML->outIdx = e->outIdx;
+  if( AelPrev ) AelPrev->nextInAEL = e->nextInLML;
+  else m_ActiveEdges = e->nextInLML;
+  if( AelNext ) AelNext->prevInAEL = e->nextInLML;
+  e->nextInLML->side = e->side;
+  e->nextInLML->windDelta = e->windDelta;
+  e->nextInLML->windCnt = e->windCnt;
+  e->nextInLML->windCnt2 = e->windCnt2;
+  e = e->nextInLML;
+  e->prevInAEL = AelPrev;
+  e->nextInAEL = AelNext;
+  if( !NEAR_EQUAL(e->dx, HORIZONTAL) ) InsertScanbeam( e->ytop );
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::ProcessIntersections(const long64 botY, const long64 topY)
+{
+  if( !m_ActiveEdges ) return true;
+  try {
+    BuildIntersectList(botY, topY);
+    if ( !m_IntersectNodes) return true;
+    if ( FixupIntersections() ) ProcessIntersectList();
+    else return false;
+  }
+  catch(...) {
+    m_SortedEdges = 0;
+    DisposeIntersectNodes();
+    throw clipperException("ProcessIntersections error");
+  }
+  return true;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::DisposeIntersectNodes()
+{
+  while ( m_IntersectNodes )
+  {
+    IntersectNode* iNode = m_IntersectNodes->next;
+    delete m_IntersectNodes;
+    m_IntersectNodes = iNode;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::BuildIntersectList(const long64 botY, const long64 topY)
+{
+  if ( !m_ActiveEdges ) return;
+
+  //prepare for sorting ...
+  TEdge* e = m_ActiveEdges;
+  e->tmpX = TopX( *e, topY );
+  m_SortedEdges = e;
+  m_SortedEdges->prevInSEL = 0;
+  e = e->nextInAEL;
+  while( e )
+  {
+    e->prevInSEL = e->prevInAEL;
+    e->prevInSEL->nextInSEL = e;
+    e->nextInSEL = 0;
+    e->tmpX = TopX( *e, topY );
+    e = e->nextInAEL;
+  }
+
+  //bubblesort ...
+  bool isModified = true;
+  while( isModified && m_SortedEdges )
+  {
+    isModified = false;
+    e = m_SortedEdges;
+    while( e->nextInSEL )
+    {
+      TEdge *eNext = e->nextInSEL;
+      IntPoint pt;
+      if(e->tmpX > eNext->tmpX &&
+        IntersectPoint(*e, *eNext, pt, m_UseFullRange))
+      {
+        if (pt.Y > botY)
+        {
+            pt.Y = botY;
+            pt.X = TopX(*e, pt.Y);
+        }
+        AddIntersectNode( e, eNext, pt );
+        SwapPositionsInSEL(e, eNext);
+        isModified = true;
+      }
+      else
+        e = eNext;
+    }
+    if( e->prevInSEL ) e->prevInSEL->nextInSEL = 0;
+    else break;
+  }
+  m_SortedEdges = 0;
+}
+//------------------------------------------------------------------------------
+
+bool Process1Before2(IntersectNode &node1, IntersectNode &node2)
+{
+  bool result;
+  if (node1.pt.Y == node2.pt.Y)
+  {
+    if (node1.edge1 == node2.edge1 || node1.edge2 == node2.edge1)
+    {
+      result = node2.pt.X > node1.pt.X;
+      if (node2.edge1->dx > 0) return !result; else return result;
+    }
+    else if (node1.edge1 == node2.edge2 || node1.edge2 == node2.edge2)
+    {
+      result = node2.pt.X > node1.pt.X;
+      if (node2.edge2->dx > 0) return !result; else return result;
+    }
+    else return node2.pt.X > node1.pt.X;
+  }
+  else return node1.pt.Y > node2.pt.Y;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::AddIntersectNode(TEdge *e1, TEdge *e2, const IntPoint &pt)
+{
+  IntersectNode* newNode = new IntersectNode;
+  newNode->edge1 = e1;
+  newNode->edge2 = e2;
+  newNode->pt = pt;
+  newNode->next = 0;
+  if( !m_IntersectNodes ) m_IntersectNodes = newNode;
+  else if(  Process1Before2(*newNode, *m_IntersectNodes) )
+  {
+    newNode->next = m_IntersectNodes;
+    m_IntersectNodes = newNode;
+  }
+  else
+  {
+    IntersectNode* iNode = m_IntersectNodes;
+    while( iNode->next  && Process1Before2(*iNode->next, *newNode) )
+        iNode = iNode->next;
+    newNode->next = iNode->next;
+    iNode->next = newNode;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::ProcessIntersectList()
+{
+  while( m_IntersectNodes )
+  {
+    IntersectNode* iNode = m_IntersectNodes->next;
+    {
+      IntersectEdges( m_IntersectNodes->edge1 ,
+        m_IntersectNodes->edge2 , m_IntersectNodes->pt, ipBoth );
+      SwapPositionsInAEL( m_IntersectNodes->edge1 , m_IntersectNodes->edge2 );
+    }
+    delete m_IntersectNodes;
+    m_IntersectNodes = iNode;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::DoMaxima(TEdge *e, long64 topY)
+{
+  TEdge* eMaxPair = GetMaximaPair(e);
+  long64 X = e->xtop;
+  TEdge* eNext = e->nextInAEL;
+  while( eNext != eMaxPair )
+  {
+    if (!eNext) throw clipperException("DoMaxima error");
+    IntersectEdges( e, eNext, IntPoint(X, topY), ipBoth );
+    eNext = eNext->nextInAEL;
+  }
+  if( e->outIdx < 0 && eMaxPair->outIdx < 0 )
+  {
+    DeleteFromAEL( e );
+    DeleteFromAEL( eMaxPair );
+  }
+  else if( e->outIdx >= 0 && eMaxPair->outIdx >= 0 )
+  {
+    IntersectEdges( e, eMaxPair, IntPoint(X, topY), ipNone );
+  }
+  else throw clipperException("DoMaxima error");
+}
+//------------------------------------------------------------------------------
+
+void Clipper::ProcessEdgesAtTopOfScanbeam(const long64 topY)
+{
+  TEdge* e = m_ActiveEdges;
+  while( e )
+  {
+    //1. process maxima, treating them as if they're 'bent' horizontal edges,
+    //   but exclude maxima with horizontal edges. nb: e can't be a horizontal.
+    if( IsMaxima(e, topY) && !NEAR_EQUAL(GetMaximaPair(e)->dx, HORIZONTAL) )
+    {
+      //'e' might be removed from AEL, as may any following edges so ...
+      TEdge* ePrior = e->prevInAEL;
+      DoMaxima(e, topY);
+      if( !ePrior ) e = m_ActiveEdges;
+      else e = ePrior->nextInAEL;
+    }
+    else
+    {
+      //2. promote horizontal edges, otherwise update xcurr and ycurr ...
+      if(  IsIntermediate(e, topY) && NEAR_EQUAL(e->nextInLML->dx, HORIZONTAL) )
+      {
+        if (e->outIdx >= 0)
+        {
+          AddOutPt(e, 0, IntPoint(e->xtop, e->ytop));
+
+          for (HorzJoinList::size_type i = 0; i < m_HorizJoins.size(); ++i)
+          {
+            IntPoint pt, pt2;
+            HorzJoinRec* hj = m_HorizJoins[i];
+            if (GetOverlapSegment(IntPoint(hj->edge->xbot, hj->edge->ybot),
+              IntPoint(hj->edge->xtop, hj->edge->ytop),
+              IntPoint(e->nextInLML->xbot, e->nextInLML->ybot),
+              IntPoint(e->nextInLML->xtop, e->nextInLML->ytop), pt, pt2))
+                AddJoin(hj->edge, e->nextInLML, hj->savedIdx, e->outIdx);
+          }
+
+          AddHorzJoin(e->nextInLML, e->outIdx);
+        }
+        UpdateEdgeIntoAEL(e);
+        AddEdgeToSEL(e);
+      } else
+      {
+        //this just simplifies horizontal processing ...
+        e->xcurr = TopX( *e, topY );
+        e->ycurr = topY;
+      }
+      e = e->nextInAEL;
+    }
+  }
+
+  //3. Process horizontals at the top of the scanbeam ...
+  ProcessHorizontals();
+
+  //4. Promote intermediate vertices ...
+  e = m_ActiveEdges;
+  while( e )
+  {
+    if( IsIntermediate( e, topY ) )
+    {
+      if( e->outIdx >= 0 ) AddOutPt(e, 0, IntPoint(e->xtop,e->ytop));
+      UpdateEdgeIntoAEL(e);
+
+      //if output polygons share an edge, they'll need joining later ...
+      if (e->outIdx >= 0 && e->prevInAEL && e->prevInAEL->outIdx >= 0 &&
+        e->prevInAEL->xcurr == e->xbot && e->prevInAEL->ycurr == e->ybot &&
+        SlopesEqual(IntPoint(e->xbot,e->ybot), IntPoint(e->xtop, e->ytop),
+          IntPoint(e->xbot,e->ybot),
+          IntPoint(e->prevInAEL->xtop, e->prevInAEL->ytop), m_UseFullRange))
+      {
+        AddOutPt(e->prevInAEL, 0, IntPoint(e->xbot, e->ybot));
+        AddJoin(e, e->prevInAEL);
+      }
+      else if (e->outIdx >= 0 && e->nextInAEL && e->nextInAEL->outIdx >= 0 &&
+        e->nextInAEL->ycurr > e->nextInAEL->ytop &&
+        e->nextInAEL->ycurr < e->nextInAEL->ybot &&
+        e->nextInAEL->xcurr == e->xbot && e->nextInAEL->ycurr == e->ybot &&
+        SlopesEqual(IntPoint(e->xbot,e->ybot), IntPoint(e->xtop, e->ytop),
+          IntPoint(e->xbot,e->ybot),
+          IntPoint(e->nextInAEL->xtop, e->nextInAEL->ytop), m_UseFullRange))
+      {
+        AddOutPt(e->nextInAEL, 0, IntPoint(e->xbot, e->ybot));
+        AddJoin(e, e->nextInAEL);
+      }
+    }
+    e = e->nextInAEL;
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::FixupOutPolygon(OutRec &outRec)
+{
+  //FixupOutPolygon() - removes duplicate points and simplifies consecutive
+  //parallel edges by removing the middle vertex.
+  OutPt *lastOK = 0;
+  outRec.pts = outRec.bottomPt;
+  OutPt *pp = outRec.bottomPt;
+
+  for (;;)
+  {
+    if (pp->prev == pp || pp->prev == pp->next )
+    {
+      DisposeOutPts(pp);
+      outRec.pts = 0;
+      outRec.bottomPt = 0;
+      return;
+    }
+    //test for duplicate points and for same slope (cross-product) ...
+    if ( PointsEqual(pp->pt, pp->next->pt) ||
+      SlopesEqual(pp->prev->pt, pp->pt, pp->next->pt, m_UseFullRange) )
+    {
+      lastOK = 0;
+      OutPt *tmp = pp;
+      if (pp == outRec.bottomPt)
+      {
+          if (tmp->prev->pt.Y > tmp->next->pt.Y)
+            outRec.bottomPt = tmp->prev; else
+            outRec.bottomPt = tmp->next;
+          outRec.pts = outRec.bottomPt;
+          outRec.bottomPt->idx = outRec.idx;
+      }
+      pp->prev->next = pp->next;
+      pp->next->prev = pp->prev;
+      pp = pp->prev;
+      delete tmp;
+    }
+    else if (pp == lastOK) break;
+    else
+    {
+      if (!lastOK) lastOK = pp;
+      pp = pp->next;
+    }
+  }
+}
+//------------------------------------------------------------------------------
+
+void Clipper::BuildResult(Polygons &polys)
+{
+  int k = 0;
+  polys.resize(m_PolyOuts.size());
+  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
+  {
+    if (m_PolyOuts[i]->pts)
+    {
+      Polygon* pg = &polys[k];
+      pg->clear();
+      OutPt* p = m_PolyOuts[i]->pts;
+      do
+      {
+        pg->push_back(p->pt);
+        p = p->next;
+      } while (p != m_PolyOuts[i]->pts);
+      //make sure each polygon has at least 3 vertices ...
+      if (pg->size() < 3) pg->clear(); else k++;
+    }
+  }
+  polys.resize(k);
+}
+//------------------------------------------------------------------------------
+
+void Clipper::BuildResultEx(ExPolygons &polys)
+{
+  PolyOutList::size_type i = 0;
+  int k = 0;
+  polys.resize(0);
+  polys.reserve(m_PolyOuts.size());
+  while (i < m_PolyOuts.size() && m_PolyOuts[i]->pts)
+  {
+    ExPolygon epg;
+    OutPt* p = m_PolyOuts[i]->pts;
+    do {
+      epg.outer.push_back(p->pt);
+      p = p->next;
+    } while (p != m_PolyOuts[i]->pts);
+    i++;
+    //make sure polygons have at least 3 vertices ...
+    if (epg.outer.size() < 3) continue;
+    while (i < m_PolyOuts.size()
+      && m_PolyOuts[i]->pts && m_PolyOuts[i]->isHole)
+    {
+      Polygon pg;
+      p = m_PolyOuts[i]->pts;
+      do {
+        pg.push_back(p->pt);
+        p = p->next;
+      } while (p != m_PolyOuts[i]->pts);
+      epg.holes.push_back(pg);
+      i++;
+    }
+    polys.push_back(epg);
+    k++;
+  }
+  polys.resize(k);
+}
+//------------------------------------------------------------------------------
+
+void SwapIntersectNodes(IntersectNode &int1, IntersectNode &int2)
+{
+  TEdge *e1 = int1.edge1;
+  TEdge *e2 = int1.edge2;
+  IntPoint p = int1.pt;
+
+  int1.edge1 = int2.edge1;
+  int1.edge2 = int2.edge2;
+  int1.pt = int2.pt;
+
+  int2.edge1 = e1;
+  int2.edge2 = e2;
+  int2.pt = p;
+}
+//------------------------------------------------------------------------------
+
+bool Clipper::FixupIntersections()
+{
+  if ( !m_IntersectNodes->next ) return true;
+
+  CopyAELToSEL();
+  IntersectNode *int1 = m_IntersectNodes;
+  IntersectNode *int2 = m_IntersectNodes->next;
+  while (int2)
+  {
+    TEdge *e1 = int1->edge1;
+    TEdge *e2;
+    if (e1->prevInSEL == int1->edge2) e2 = e1->prevInSEL;
+    else if (e1->nextInSEL == int1->edge2) e2 = e1->nextInSEL;
+    else
+    {
+      //The current intersection is out of order, so try and swap it with
+      //a subsequent intersection ...
+      while (int2)
+      {
+        if (int2->edge1->nextInSEL == int2->edge2 ||
+          int2->edge1->prevInSEL == int2->edge2) break;
+        else int2 = int2->next;
+      }
+      if ( !int2 ) return false; //oops!!!
+
+      //found an intersect node that can be swapped ...
+      SwapIntersectNodes(*int1, *int2);
+      e1 = int1->edge1;
+      e2 = int1->edge2;
+    }
+    SwapPositionsInSEL(e1, e2);
+    int1 = int1->next;
+    int2 = int1->next;
+  }
+
+  m_SortedEdges = 0;
+
+  //finally, check the last intersection too ...
+  return (int1->edge1->prevInSEL == int1->edge2 ||
+    int1->edge1->nextInSEL == int1->edge2);
+}
+//------------------------------------------------------------------------------
+
+bool E2InsertsBeforeE1(TEdge &e1, TEdge &e2)
+{
+  if (e2.xcurr == e1.xcurr) return e2.dx > e1.dx;
+  else return e2.xcurr < e1.xcurr;
+}
+//------------------------------------------------------------------------------
+
+void Clipper::InsertEdgeIntoAEL(TEdge *edge)
+{
+  edge->prevInAEL = 0;
+  edge->nextInAEL = 0;
+  if( !m_ActiveEdges )
+  {
+    m_ActiveEdges = edge;
+  }
+  else if( E2InsertsBeforeE1(*m_ActiveEdges, *edge) )
+  {
+    edge->nextInAEL = m_ActiveEdges;
+    m_ActiveEdges->prevInAEL = edge;
+    m_ActiveEdges = edge;
+  } else
+  {
+    TEdge* e = m_ActiveEdges;
+    while( e->nextInAEL  && !E2InsertsBeforeE1(*e->nextInAEL , *edge) )
+      e = e->nextInAEL;
+    edge->nextInAEL = e->nextInAEL;
+    if( e->nextInAEL ) e->nextInAEL->prevInAEL = edge;
+    edge->prevInAEL = e;
+    e->nextInAEL = edge;
+  }
+}
+//----------------------------------------------------------------------
+
+void Clipper::DoEdge1(TEdge *edge1, TEdge *edge2, const IntPoint &pt)
+{
+  AddOutPt(edge1, edge2, pt);
+  SwapSides(*edge1, *edge2);
+  SwapPolyIndexes(*edge1, *edge2);
+}
+//----------------------------------------------------------------------
+
+void Clipper::DoEdge2(TEdge *edge1, TEdge *edge2, const IntPoint &pt)
+{
+  AddOutPt(edge2, edge1, pt);
+  SwapSides(*edge1, *edge2);
+  SwapPolyIndexes(*edge1, *edge2);
+}
+//----------------------------------------------------------------------
+
+void Clipper::DoBothEdges(TEdge *edge1, TEdge *edge2, const IntPoint &pt)
+{
+  AddOutPt(edge1, edge2, pt);
+  AddOutPt(edge2, edge1, pt);
+  SwapSides( *edge1 , *edge2 );
+  SwapPolyIndexes( *edge1 , *edge2 );
+}
+//----------------------------------------------------------------------
+
+void Clipper::CheckHoleLinkages1(OutRec *outRec1, OutRec *outRec2)
+{
+  //when a polygon is split into 2 polygons, make sure any holes the original
+  //polygon contained link to the correct polygon ...
+  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
+  {
+    OutRec *orec = m_PolyOuts[i];
+    if (orec->isHole && orec->bottomPt && orec->FirstLeft == outRec1 &&
+      !PointInPolygon(orec->bottomPt->pt, outRec1->pts, m_UseFullRange))
+        orec->FirstLeft = outRec2;
+  }
+}
+//----------------------------------------------------------------------
+
+void Clipper::CheckHoleLinkages2(OutRec *outRec1, OutRec *outRec2)
+{
+  //if a hole is owned by outRec2 then make it owned by outRec1 ...
+  for (PolyOutList::size_type i = 0; i < m_PolyOuts.size(); ++i)
+    if (m_PolyOuts[i]->isHole && m_PolyOuts[i]->bottomPt &&
+      m_PolyOuts[i]->FirstLeft == outRec2)
+        m_PolyOuts[i]->FirstLeft = outRec1;
+}
+//----------------------------------------------------------------------
+
+void Clipper::JoinCommonEdges(bool fixHoleLinkages)
+{
+  for (JoinList::size_type i = 0; i < m_Joins.size(); i++)
+  {
+    JoinRec* j = m_Joins[i];
+    OutRec *outRec1 = m_PolyOuts[j->poly1Idx];
+    OutPt *pp1a = outRec1->pts;
+    OutRec *outRec2 = m_PolyOuts[j->poly2Idx];
+    OutPt *pp2a = outRec2->pts;
+    IntPoint pt1 = j->pt2a, pt2 = j->pt2b;
+    IntPoint pt3 = j->pt1a, pt4 = j->pt1b;
+    if (!FindSegment(pp1a, pt1, pt2)) continue;
+    if (j->poly1Idx == j->poly2Idx)
+    {
+      //we're searching the same polygon for overlapping segments so
+      //segment 2 mustn't be the same as segment 1 ...
+      pp2a = pp1a->next;
+      if (!FindSegment(pp2a, pt3, pt4) || (pp2a == pp1a)) continue;
+    }
+    else if (!FindSegment(pp2a, pt3, pt4)) continue;
+
+    if (!GetOverlapSegment(pt1, pt2, pt3, pt4, pt1, pt2)) continue;
+
+    OutPt *p1, *p2, *p3, *p4;
+    OutPt *prev = pp1a->prev;
+    //get p1 & p2 polypts - the overlap start & endpoints on poly1
+    if (PointsEqual(pp1a->pt, pt1)) p1 = pp1a;
+    else if (PointsEqual(prev->pt, pt1)) p1 = prev;
+    else p1 = InsertPolyPtBetween(pp1a, prev, pt1);
+
+    if (PointsEqual(pp1a->pt, pt2)) p2 = pp1a;
+    else if (PointsEqual(prev->pt, pt2)) p2 = prev;
+    else if ((p1 == pp1a) || (p1 == prev))
+      p2 = InsertPolyPtBetween(pp1a, prev, pt2);
+    else if (Pt3IsBetweenPt1AndPt2(pp1a->pt, p1->pt, pt2))
+      p2 = InsertPolyPtBetween(pp1a, p1, pt2); else
+      p2 = InsertPolyPtBetween(p1, prev, pt2);
+
+    //get p3 & p4 polypts - the overlap start & endpoints on poly2
+    prev = pp2a->prev;
+    if (PointsEqual(pp2a->pt, pt1)) p3 = pp2a;
+    else if (PointsEqual(prev->pt, pt1)) p3 = prev;
+    else p3 = InsertPolyPtBetween(pp2a, prev, pt1);
+
+    if (PointsEqual(pp2a->pt, pt2)) p4 = pp2a;
+    else if (PointsEqual(prev->pt, pt2)) p4 = prev;
+    else if ((p3 == pp2a) || (p3 == prev))
+      p4 = InsertPolyPtBetween(pp2a, prev, pt2);
+    else if (Pt3IsBetweenPt1AndPt2(pp2a->pt, p3->pt, pt2))
+      p4 = InsertPolyPtBetween(pp2a, p3, pt2); else
+      p4 = InsertPolyPtBetween(p3, prev, pt2);
+
+    //p1.pt == p3.pt and p2.pt == p4.pt so join p1 to p3 and p2 to p4 ...
+    if (p1->next == p2 && p3->prev == p4)
+    {
+      p1->next = p3;
+      p3->prev = p1;
+      p2->prev = p4;
+      p4->next = p2;
+    }
+    else if (p1->prev == p2 && p3->next == p4)
+    {
+      p1->prev = p3;
+      p3->next = p1;
+      p2->next = p4;
+      p4->prev = p2;
+    }
+    else
+      continue; //an orientation is probably wrong
+
+    if (j->poly2Idx == j->poly1Idx)
+    {
+      //instead of joining two polygons, we've just created a new one by
+      //splitting one polygon into two.
+      outRec1->pts = PolygonBottom(p1);
+      outRec1->bottomPt = outRec1->pts;
+      outRec1->bottomPt->idx = outRec1->idx;
+      outRec2 = CreateOutRec();
+      m_PolyOuts.push_back(outRec2);
+      outRec2->idx = (int)m_PolyOuts.size()-1;
+      j->poly2Idx = outRec2->idx;
+      outRec2->pts = PolygonBottom(p2);
+      outRec2->bottomPt = outRec2->pts;
+      outRec2->bottomPt->idx = outRec2->idx;
+
+      if (PointInPolygon(outRec2->pts->pt, outRec1->pts, m_UseFullRange))
+      {
+        outRec2->isHole = !outRec1->isHole;
+        outRec2->FirstLeft = outRec1;
+        if (outRec2->isHole == Orientation(outRec2, m_UseFullRange))
+          ReversePolyPtLinks(*outRec2->pts);
+      } else if (PointInPolygon(outRec1->pts->pt, outRec2->pts, m_UseFullRange))
+      {
+        outRec2->isHole = outRec1->isHole;
+        outRec1->isHole = !outRec2->isHole;
+        outRec2->FirstLeft = outRec1->FirstLeft;
+        outRec1->FirstLeft = outRec2;
+        if (outRec1->isHole == Orientation(outRec1, m_UseFullRange))
+          ReversePolyPtLinks(*outRec1->pts);
+      } else
+      {
+        outRec2->isHole = outRec1->isHole;
+        outRec2->FirstLeft = outRec1->FirstLeft;
+        //make sure any contained holes now link to the correct polygon ...
+        if (fixHoleLinkages) CheckHoleLinkages1(outRec1, outRec2);
+      }
+
+      //now fixup any subsequent joins that match this polygon
+      for (JoinList::size_type k = i+1; k < m_Joins.size(); k++)
+      {
+        JoinRec* j2 = m_Joins[k];
+        if (j2->poly1Idx == j->poly1Idx && PointIsVertex(j2->pt1a, p2))
+          j2->poly1Idx = j->poly2Idx;
+        if (j2->poly2Idx == j->poly1Idx && PointIsVertex(j2->pt2a, p2))
+          j2->poly2Idx = j->poly2Idx;
+      }
+
+      //now cleanup redundant edges too ...
+      FixupOutPolygon(*outRec1);
+      FixupOutPolygon(*outRec2);
+    } else
+    {
+      //joined 2 polygons together ...
+
+      //make sure any holes contained by outRec2 now link to outRec1 ...
+      if (fixHoleLinkages) CheckHoleLinkages2(outRec1, outRec2);
+
+      //delete the obsolete pointer ...
+      int OKIdx = outRec1->idx;
+      int ObsoleteIdx = outRec2->idx;
+      outRec2->pts = 0;
+      outRec2->bottomPt = 0;
+      outRec2->AppendLink = outRec1;
+      //holes are practically always joined to outers, not vice versa ...
+      if (outRec1->isHole && !outRec2->isHole) outRec1->isHole = false;
+
+      //now fixup any subsequent Joins that match this polygon
+      for (JoinList::size_type k = i+1; k < m_Joins.size(); k++)
+      {
+        JoinRec* j2 = m_Joins[k];
+        if (j2->poly1Idx == ObsoleteIdx) j2->poly1Idx = OKIdx;
+        if (j2->poly2Idx == ObsoleteIdx) j2->poly2Idx = OKIdx;
+      }
+
+      //now cleanup redundant edges too ...
+      if (outRec1->pts)
+        FixupOutPolygon(*outRec1);
+      else
+        FixupOutPolygon(*outRec2);
+    }
+  }
+}
+//------------------------------------------------------------------------------
+
+void ReversePoints(Polygon& p)
+{
+  std::reverse(p.begin(), p.end());
+}
+//------------------------------------------------------------------------------
+
+void ReversePoints(Polygons& p)
+{
+  for (Polygons::size_type i = 0; i < p.size(); ++i)
+    ReversePoints(p[i]);
+}
+
+//------------------------------------------------------------------------------
+// OffsetPolygon functions ...
+//------------------------------------------------------------------------------
+
+struct DoublePoint
+{
+  double X;
+  double Y;
+  DoublePoint(double x = 0, double y = 0) : X(x), Y(y) {}
+};
+//------------------------------------------------------------------------------
+
+Polygon BuildArc(const IntPoint &pt,
+  const double a1, const double a2, const double r)
+{
+  int steps = std::max(6, int(std::sqrt(std::fabs(r)) * std::fabs(a2 - a1)));
+  Polygon result(steps);
+  int n = steps - 1;
+  double da = (a2 - a1) / n;
+  double a = a1;
+  for (int i = 0; i <= n; ++i)
+  {
+    result[i].X = pt.X + Round(std::cos(a)*r);
+    result[i].Y = pt.Y + Round(std::sin(a)*r);
+    a += da;
+  }
+  return result;
+}
+//------------------------------------------------------------------------------
+
+DoublePoint GetUnitNormal( const IntPoint &pt1, const IntPoint &pt2)
+{
+  if(pt2.X == pt1.X && pt2.Y == pt1.Y) 
+    return DoublePoint(0, 0);
+
+  double dx = (double)(pt2.X - pt1.X);
+  double dy = (double)(pt2.Y - pt1.Y);
+  double f = 1 *1.0/ std::sqrt( dx*dx + dy*dy );
+  dx *= f;
+  dy *= f;
+  return DoublePoint(dy, -dx);
+}
+
+//------------------------------------------------------------------------------
+//------------------------------------------------------------------------------
+
+class PolyOffsetBuilder
+{
+private:
+  Polygons m_p;
+  Polygon* m_curr_poly = nullptr;
+  std::vector<DoublePoint> normals;
+  double m_delta = 0, m_RMin = 0, m_R = 0;
+  size_t m_i = 0, m_j = 0, m_k = 0;
+  static const int buffLength = 128;
+  JoinType m_jointype = jtSquare;
+ 
+public:
+
+PolyOffsetBuilder(const Polygons& in_polys, Polygons& out_polys,
+  double delta, JoinType jointype, double MiterLimit)
+{
+    //nb precondition - out_polys != ptsin_polys
+    if (NEAR_ZERO(delta))
+    {
+        out_polys = in_polys;
+        return;
+    }
+
+    this->m_p = in_polys;
+    this->m_delta = delta;
+    this->m_jointype = jointype;
+    if (MiterLimit <= 1) MiterLimit = 1;
+    m_RMin = 2/(MiterLimit*MiterLimit);
+ 
+    double deltaSq = delta*delta;
+    out_polys.clear();
+    out_polys.resize(in_polys.size());
+    for (m_i = 0; m_i < in_polys.size(); m_i++)
+    {
+        m_curr_poly = &out_polys[m_i];
+        size_t len = in_polys[m_i].size();
+        if (len > 1 && m_p[m_i][0].X == m_p[m_i][len - 1].X &&
+            m_p[m_i][0].Y == m_p[m_i][len-1].Y) len--;
+
+        //when 'shrinking' polygons - to minimize artefacts
+        //strip those polygons that have an area < pi * delta^2 ...
+        double a1 = Area(in_polys[m_i]);
+        if (delta < 0) { if (a1 > 0 && a1 < deltaSq *pi) len = 0; }
+        else if (a1 < 0 && -a1 < deltaSq *pi) len = 0; //holes have neg. area
+
+        if (len == 0 || (len < 3 && delta <= 0))
+          continue;
+        else if (len == 1)
+        {
+            Polygon arc;
+            arc = BuildArc(in_polys[m_i][len-1], 0, 2 * pi, delta);
+            out_polys[m_i] = arc;
+            continue;
+        }
+
+        //build normals ...
+        normals.clear();
+        normals.resize(len);
+        normals[len-1] = GetUnitNormal(in_polys[m_i][len-1], in_polys[m_i][0]);
+        for (m_j = 0; m_j < len -1; ++m_j)
+            normals[m_j] = GetUnitNormal(in_polys[m_i][m_j], in_polys[m_i][m_j+1]);
+        
+        m_k = len -1;
+        for (m_j = 0; m_j < len; ++m_j)
+        {
+          switch (jointype)
+          {
+            case jtMiter:
+            {
+              m_R = 1 + (normals[m_j].X*normals[m_k].X + 
+                normals[m_j].Y*normals[m_k].Y);
+              if (m_R >= m_RMin) DoMiter(); else DoSquare(MiterLimit);
+              break;
+            }
+            case jtSquare: DoSquare(); break;
+            case jtRound: DoRound(); break;
+          }
+        m_k = m_j;
+        }
+    }
+
+    //finally, clean up untidy corners using Clipper ...
+    Clipper clpr;
+    clpr.AddPolygons(out_polys, ptSubject);
+    if (delta > 0)
+    {
+        if (!clpr.Execute(ctUnion, out_polys, pftPositive, pftPositive))
+            out_polys.clear();
+    }
+    else
+    {
+        IntRect r = clpr.GetBounds();
+        Polygon outer(4);
+        outer[0] = IntPoint(r.left - 10, r.bottom + 10);
+        outer[1] = IntPoint(r.right + 10, r.bottom + 10);
+        outer[2] = IntPoint(r.right + 10, r.top - 10);
+        outer[3] = IntPoint(r.left - 10, r.top - 10);
+
+        clpr.AddPolygon(outer, ptSubject);
+        if (clpr.Execute(ctUnion, out_polys, pftNegative, pftNegative))
+        {
+            out_polys.erase(out_polys.begin());
+            ReversePoints(out_polys);
+
+        } else
+            out_polys.clear();
+    }
+}
+//------------------------------------------------------------------------------
+
+private:
+
+void AddPoint(const IntPoint& pt)
+{
+    Polygon::size_type len = m_curr_poly->size();
+    if (len == m_curr_poly->capacity())
+        m_curr_poly->reserve(len + buffLength);
+    m_curr_poly->push_back(pt);
+}
+//------------------------------------------------------------------------------
+
+void DoSquare(double mul = 1.0)
+{
+    IntPoint pt1 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_k].X * m_delta),
+        (long64)Round(m_p[m_i][m_j].Y + normals[m_k].Y * m_delta));
+    IntPoint pt2 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_j].X * m_delta),
+        (long64)Round(m_p[m_i][m_j].Y + normals[m_j].Y * m_delta));
+    if ((normals[m_k].X * normals[m_j].Y - normals[m_j].X * normals[m_k].Y) * m_delta >= 0)
+    {
+        double a1 = std::atan2(normals[m_k].Y, normals[m_k].X);
+        double a2 = std::atan2(-normals[m_j].Y, -normals[m_j].X);
+        a1 = std::fabs(a2 - a1);
+        if (a1 > pi) a1 = pi * 2 - a1;
+        double dx = std::tan((pi - a1)/4) * std::fabs(m_delta * mul);
+        pt1 = IntPoint((long64)(pt1.X -normals[m_k].Y * dx),
+          (long64)(pt1.Y + normals[m_k].X * dx));
+        AddPoint(pt1);
+        pt2 = IntPoint((long64)(pt2.X + normals[m_j].Y * dx),
+          (long64)(pt2.Y -normals[m_j].X * dx));
+        AddPoint(pt2);
+    }
+    else
+    {
+        AddPoint(pt1);
+        AddPoint(m_p[m_i][m_j]);
+        AddPoint(pt2);
+    }
+}
+//------------------------------------------------------------------------------
+
+void DoMiter()
+{
+    if ((normals[m_k].X * normals[m_j].Y - normals[m_j].X * normals[m_k].Y) * m_delta >= 0)
+    {
+        double q = m_delta / m_R;
+        AddPoint(IntPoint((long64)Round(m_p[m_i][m_j].X + 
+            (normals[m_k].X + normals[m_j].X) * q),
+            (long64)Round(m_p[m_i][m_j].Y + (normals[m_k].Y + normals[m_j].Y) * q)));
+    }
+    else
+    {
+        IntPoint pt1 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_k].X *
+          m_delta), (long64)Round(m_p[m_i][m_j].Y + normals[m_k].Y * m_delta));
+        IntPoint pt2 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_j].X *
+          m_delta), (long64)Round(m_p[m_i][m_j].Y + normals[m_j].Y * m_delta));
+        AddPoint(pt1);
+        AddPoint(m_p[m_i][m_j]);
+        AddPoint(pt2);
+    }
+}
+//------------------------------------------------------------------------------
+
+void DoRound()
+{
+    IntPoint pt1 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_k].X * m_delta),
+        (long64)Round(m_p[m_i][m_j].Y + normals[m_k].Y * m_delta));
+    IntPoint pt2 = IntPoint((long64)Round(m_p[m_i][m_j].X + normals[m_j].X * m_delta),
+        (long64)Round(m_p[m_i][m_j].Y + normals[m_j].Y * m_delta));
+    AddPoint(pt1);
+    //round off reflex angles (ie > 180 deg) unless almost flat (ie < ~10deg).
+    if ((normals[m_k].X*normals[m_j].Y - normals[m_j].X*normals[m_k].Y) * m_delta >= 0)
+    {
+      if (normals[m_j].X * normals[m_k].X + normals[m_j].Y * normals[m_k].Y < 0.985)
+      {
+        double a1 = std::atan2(normals[m_k].Y, normals[m_k].X);
+        double a2 = std::atan2(normals[m_j].Y, normals[m_j].X);
+        if (m_delta > 0 && a2 < a1) a2 += pi *2;
+        else if (m_delta < 0 && a2 > a1) a2 -= pi *2;
+        Polygon arc = BuildArc(m_p[m_i][m_j], a1, a2, m_delta);
+        for (Polygon::size_type m = 0; m < arc.size(); m++)
+          AddPoint(arc[m]);
+      }
+    }
+    else
+      AddPoint(m_p[m_i][m_j]);
+    AddPoint(pt2);
+}
+//--------------------------------------------------------------------------
+
+}; //end PolyOffsetBuilder
+
+//------------------------------------------------------------------------------
+//------------------------------------------------------------------------------
+
+void OffsetPolygons(const Polygons &in_polys, Polygons &out_polys,
+  double delta, JoinType jointype, double MiterLimit)
+{
+  if (&out_polys == &in_polys)
+  {
+    Polygons poly2(in_polys);
+    PolyOffsetBuilder(poly2, out_polys, delta, jointype, MiterLimit);
+  }
+  else PolyOffsetBuilder(in_polys, out_polys, delta, jointype, MiterLimit);
+}
+//------------------------------------------------------------------------------
+
+std::ostream& operator <<(std::ostream &s, IntPoint& p)
+{
+  s << p.X << ' ' << p.Y << "\n";
+  return s;
+}
+//------------------------------------------------------------------------------
+
+std::ostream& operator <<(std::ostream &s, Polygon &p)
+{
+  for (Polygon::size_type i = 0; i < p.size(); i++)
+    s << p[i];
+  s << "\n";
+  return s;
+}
+//------------------------------------------------------------------------------
+
+std::ostream& operator <<(std::ostream &s, Polygons &p)
+{
+  for (Polygons::size_type i = 0; i < p.size(); i++)
+    s << p[i];
+  s << "\n";
+  return s;
+}
+//------------------------------------------------------------------------------
+
+} //ClipperLib namespace
diff -pruN 8.0.1-5/src/renderers/agg/src/configure.in 8.2.0~beta1-1~exp1/src/renderers/agg/src/configure.in
--- 8.0.1-5/src/renderers/agg/src/configure.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/configure.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,15 @@
+AC_INIT(src/agg_arc.cpp) # give me a source file, any source file...
+AM_INIT_AUTOMAKE(agg, 2.0.0)
+
+AC_PROG_LN_S
+AC_PROG_CC
+AC_PROG_CPP
+AC_PROG_CXX
+AC_PROG_LIBTOOL
+
+AC_OUTPUT(
+   Makefile 
+   gpc/Makefile
+   src/Makefile
+   src/ctrl/Makefile
+) 
diff -pruN 8.0.1-5/src/renderers/agg/src/copying 8.2.0~beta1-1~exp1/src/renderers/agg/src/copying
--- 8.0.1-5/src/renderers/agg/src/copying	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/copying	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,11 @@
+The Anti-Grain Geometry Project
+A high quality rendering engine for C++
+http://antigrain.com
+
+Anti-Grain Geometry - Version 2.4 
+Copyright (C) 2002-2005 Maxim Shemanarev (McSeem) 
+
+Permission to copy, use, modify, sell and distribute this software 
+is granted provided this copyright notice appears in all copies. 
+This software is provided "as is" without express or implied
+warranty, and with no claim as to its suitability for any purpose.
diff -pruN 8.0.1-5/src/renderers/agg/src/readme 8.2.0~beta1-1~exp1/src/renderers/agg/src/readme
--- 8.0.1-5/src/renderers/agg/src/readme	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/agg/src/readme	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,5 @@
+Use automake to build the library. 
+
+If automake is not available you still can use the old make. 
+There is a very simple Makefile that can be used. Note that
+if you use automake it will overwrite Makefile.
diff -pruN 8.0.1-5/src/renderers/mvt/vector_tile.proto 8.2.0~beta1-1~exp1/src/renderers/mvt/vector_tile.proto
--- 8.0.1-5/src/renderers/mvt/vector_tile.proto	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/renderers/mvt/vector_tile.proto	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,81 @@
+//set version statement to avoid warnings thrown in protobuf >= 3
+syntax = "proto2";
+
+package vector_tile;
+
+option optimize_for = LITE_RUNTIME;
+
+message Tile {
+
+        // GeomType is described in section 4.3.4 of the specification
+        enum GeomType {
+             UNKNOWN = 0;
+             POINT = 1;
+             LINESTRING = 2;
+             POLYGON = 3;
+        }
+
+        // Variant type encoding
+        // The use of values is described in section 4.1 of the specification
+        message Value {
+                // Exactly one of these values must be present in a valid message
+                optional string string_value = 1;
+                optional float float_value = 2;
+                optional double double_value = 3;
+                optional int64 int_value = 4;
+                optional uint64 uint_value = 5;
+                optional sint64 sint_value = 6;
+                optional bool bool_value = 7;
+
+                extensions 8 to max;
+        }
+
+        // Features are described in section 4.2 of the specification
+        message Feature {
+                optional uint64 id = 1 [ default = 0 ];
+
+                // Tags of this feature are encoded as repeated pairs of
+                // integers.
+                // A detailed description of tags is located in sections
+                // 4.2 and 4.4 of the specification
+                repeated uint32 tags = 2 [ packed = true ];
+
+                // The type of geometry stored in this feature.
+                optional GeomType type = 3 [ default = UNKNOWN ];
+
+                // Contains a stream of commands and parameters (vertices).
+                // A detailed description on geometry encoding is located in 
+                // section 4.3 of the specification.
+                repeated uint32 geometry = 4 [ packed = true ];
+        }
+
+        // Layers are described in section 4.1 of the specification
+        message Layer {
+                // Any compliant implementation must first read the version
+                // number encoded in this message and choose the correct
+                // implementation for this version number before proceeding to
+                // decode other parts of this message.
+                required uint32 version = 15 [ default = 1 ];
+
+                required string name = 1;
+
+                // The actual features in this tile.
+                repeated Feature features = 2;
+
+                // Dictionary encoding for keys
+                repeated string keys = 3;
+
+                // Dictionary encoding for values
+                repeated Value values = 4;
+
+                // Although this is an "optional" field it is required by the specification.
+                // See https://github.com/mapbox/vector-tile-spec/issues/47
+                optional uint32 extent = 5 [ default = 4096 ];
+
+                extensions 16 to max;
+        }
+
+        repeated Layer layers = 3;
+
+        extensions 16 to 8191;
+}
diff -pruN 8.0.1-5/src/strptime.c 8.2.0~beta1-1~exp1/src/strptime.c
--- 8.0.1-5/src/strptime.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/strptime.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,387 @@
+/*
+ * Copyright (c) 1999 Kungliga Tekniska Högskolan
+ * (Royal Institute of Technology, Stockholm, Sweden).
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * 3. Neither the name of KTH nor the names of its contributors may be
+ *    used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY KTH AND ITS CONTRIBUTORS ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL KTH OR ITS CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+ * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+ * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+
+#include <ctype.h>
+#include <stdlib.h>
+#include <stddef.h>
+#include <stdio.h>
+#include <string.h>
+#include <time.h>
+#include "mapserver.h"
+
+static const char *const abb_weekdays[] = {"Sun", "Mon", "Tue", "Wed",
+                                           "Thu", "Fri", "Sat", NULL};
+
+static const char *const full_weekdays[] = {"Sunday",    "Monday",   "Tuesday",
+                                            "Wednesday", "Thursday", "Friday",
+                                            "Saturday",  NULL};
+
+static const char *const abb_month[] = {"Jan", "Feb", "Mar", "Apr", "May",
+                                        "Jun", "Jul", "Aug", "Sep", "Oct",
+                                        "Nov", "Dec", NULL};
+
+static const char *const full_month[] = {
+    "January", "February",  "Mars",    "April",    "May",      "June", "July",
+    "August",  "September", "October", "November", "December", NULL,
+};
+
+static const char *const ampm[] = {"am", "pm", NULL};
+
+/*
+ * tm_year is relative this year
+ */
+static const int tm_year_base = 1900;
+
+/*
+ * Return TRUE iff `year' was a leap year.
+ * Needed for strptime.
+ */
+static int is_leap_year(int year) {
+  return (year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0);
+}
+
+/* Needed for strptime. */
+static int match_string(const char **buf, const char *const *strs) {
+  int i = 0;
+
+  for (i = 0; strs[i] != NULL; ++i) {
+    int len = strlen(strs[i]);
+
+    if (strncasecmp(*buf, strs[i], len) == 0) {
+      *buf += len;
+      return i;
+    }
+  }
+  return -1;
+}
+
+/* Needed for strptime. */
+static int first_day(int year) {
+  int ret = 4;
+
+  for (; year > 1970; --year)
+    ret = (ret + 365 + is_leap_year(year) ? 1 : 0) % 7;
+  return ret;
+}
+
+/*
+ * Set `timeptr' given `wnum' (week number [0, 53])
+ * Needed for strptime
+ */
+
+static void set_week_number_sun(struct tm *timeptr, int wnum) {
+  int fday = first_day(timeptr->tm_year + tm_year_base);
+
+  timeptr->tm_yday = wnum * 7 + timeptr->tm_wday - fday;
+  if (timeptr->tm_yday < 0) {
+    timeptr->tm_wday = fday;
+    timeptr->tm_yday = 0;
+  }
+}
+
+/*
+ * Set `timeptr' given `wnum' (week number [0, 53])
+ * Needed for strptime
+ */
+
+static void set_week_number_mon(struct tm *timeptr, int wnum) {
+  int fday = (first_day(timeptr->tm_year + tm_year_base) + 6) % 7;
+
+  timeptr->tm_yday = wnum * 7 + (timeptr->tm_wday + 6) % 7 - fday;
+  if (timeptr->tm_yday < 0) {
+    timeptr->tm_wday = (fday + 1) % 7;
+    timeptr->tm_yday = 0;
+  }
+}
+
+/*
+ * Set `timeptr' given `wnum' (week number [0, 53])
+ * Needed for strptime
+ */
+static void set_week_number_mon4(struct tm *timeptr, int wnum) {
+  int fday = (first_day(timeptr->tm_year + tm_year_base) + 6) % 7;
+  int offset = 0;
+
+  if (fday < 4)
+    offset += 7;
+
+  timeptr->tm_yday = offset + (wnum - 1) * 7 + timeptr->tm_wday - fday;
+  if (timeptr->tm_yday < 0) {
+    timeptr->tm_wday = fday;
+    timeptr->tm_yday = 0;
+  }
+}
+
+/* strptime: roken */
+/* extern "C" */
+char *
+/* strptime (const char *buf, const char *format, struct tm *timeptr) */
+strptime(const char *buf, const char *format, struct tm *timeptr) {
+  char c;
+
+  for (; (c = *format) != '\0'; ++format) {
+    char *s;
+    int ret;
+
+    if (isspace(c)) {
+      while (isspace(*buf))
+        ++buf;
+    } else if (c == '%' && format[1] != '\0') {
+      c = *++format;
+      if (c == 'E' || c == 'O')
+        c = *++format;
+      switch (c) {
+      case 'A':
+        ret = match_string(&buf, full_weekdays);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_wday = ret;
+        break;
+      case 'a':
+        ret = match_string(&buf, abb_weekdays);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_wday = ret;
+        break;
+      case 'B':
+        ret = match_string(&buf, full_month);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_mon = ret;
+        break;
+      case 'b':
+      case 'h':
+        ret = match_string(&buf, abb_month);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_mon = ret;
+        break;
+      case 'C':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_year = (ret * 100) - tm_year_base;
+        buf = s;
+        break;
+      case 'c':
+        abort();
+      case 'D': /* %m/%d/%y */
+        s = strptime(buf, "%m/%d/%y", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'd':
+      case 'e':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_mday = ret;
+        buf = s;
+        break;
+      case 'H':
+      case 'k':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_hour = ret;
+        buf = s;
+        break;
+      case 'I':
+      case 'l':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        if (ret == 12)
+          timeptr->tm_hour = 0;
+        else
+          timeptr->tm_hour = ret;
+        buf = s;
+        break;
+      case 'j':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_yday = ret - 1;
+        buf = s;
+        break;
+      case 'm':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_mon = ret - 1;
+        buf = s;
+        break;
+      case 'M':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_min = ret;
+        buf = s;
+        break;
+      case 'n':
+        if (*buf == '\n')
+          ++buf;
+        else
+          return NULL;
+        break;
+      case 'p':
+        ret = match_string(&buf, ampm);
+        if (ret < 0)
+          return NULL;
+        if (timeptr->tm_hour == 0) {
+          if (ret == 1)
+            timeptr->tm_hour = 12;
+        } else
+          timeptr->tm_hour += 12;
+        break;
+      case 'r': /* %I:%M:%S %p */
+        s = strptime(buf, "%I:%M:%S %p", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'R': /* %H:%M */
+        s = strptime(buf, "%H:%M", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'S':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_sec = ret;
+        buf = s;
+        break;
+      case 't':
+        if (*buf == '\t')
+          ++buf;
+        else
+          return NULL;
+        break;
+      case 'T': /* %H:%M:%S */
+      case 'X':
+        s = strptime(buf, "%H:%M:%S", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'u':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_wday = ret - 1;
+        buf = s;
+        break;
+      case 'w':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_wday = ret;
+        buf = s;
+        break;
+      case 'U':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        set_week_number_sun(timeptr, ret);
+        buf = s;
+        break;
+      case 'V':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        set_week_number_mon4(timeptr, ret);
+        buf = s;
+        break;
+      case 'W':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        set_week_number_mon(timeptr, ret);
+        buf = s;
+        break;
+      case 'x':
+        s = strptime(buf, "%Y:%m:%d", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'y':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        if (ret < 70)
+          timeptr->tm_year = 100 + ret;
+        else
+          timeptr->tm_year = ret;
+        buf = s;
+        break;
+      case 'Y':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_year = ret - tm_year_base;
+        buf = s;
+        break;
+      case 'Z':
+        abort();
+      case '\0':
+        --format;
+        /* FALLTHROUGH */
+      case '%':
+        if (*buf == '%')
+          ++buf;
+        else
+          return NULL;
+        break;
+      default:
+        if (*buf == '%' || *++buf == c)
+          ++buf;
+        else
+          return NULL;
+        break;
+      }
+    } else {
+      if (*buf == c)
+        ++buf;
+      else
+        return NULL;
+    }
+  }
+  return (char *)buf;
+}
+
+#endif
diff -pruN 8.0.1-5/src/textlayout.c 8.2.0~beta1-1~exp1/src/textlayout.c
--- 8.0.1-5/src/textlayout.c	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/textlayout.c	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,992 @@
+/******************************************************************************
+ *
+ * Project:  MapServer
+ * Purpose:  Text Layout functions, eventually using Harfbuzz and Fribidi/ICU
+ * Author:   Thomas Bonfort and the MapServer team.
+ *
+ ******************************************************************************
+ * Copyright (c) 1996-2013 Regents of the University of Minnesota.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies of this Software or works derived from this Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *****************************************************************************/
+
+#include <float.h>
+#include "mapserver.h"
+
+#ifdef USE_ICONV
+#include <iconv.h>
+#include <wchar.h>
+#endif
+#include "fontcache.h"
+#include FT_ADVANCES_H
+#include FT_TYPES_H
+
+typedef struct {
+  unsigned int *unicodes;
+  unsigned int *codepoints;
+#ifdef USE_FRIBIDI
+  FriBidiCharType *ctypes;
+  FriBidiLevel *bidi_levels;
+#endif
+#ifdef USE_HARFBUZZ
+  hb_script_t *scripts;
+#endif
+} TextInfo;
+
+typedef struct {
+  int offset; /* offset in TextInfo entries where the current run is starting */
+  int length; /* number of unicode glyphs in this run */
+#ifdef USE_FRIBIDI
+  FriBidiLevel rtl;   /* bidi embedding level of run: -1 to skip shaping,
+                         otherwise if pair:ltr, odd:rtl */
+  hb_script_t script; /* script: latin, arabic, thai, etc... */
+#endif
+  int line_number;
+  face_element *face; /* font face to use for this run */
+} text_run;
+
+#ifdef USE_HARFBUZZ
+struct _ms_hb_user_data {
+  text_run *run;
+  TextInfo *info;
+  int glyph_size;
+};
+
+const char *_ms_script_prefix_en = "en:";
+const char *_ms_script_prefix_ar = "ar:";
+const char *_ms_script_prefix_cn = "cn:";
+const char *_ms_script_prefix_hy = "hy:";
+const char *_ms_script_prefix_bn = "bn:";
+const char *_ms_script_prefix_iu = "iu";
+const char *_ms_script_prefix_chr = "chr:";
+const char *_ms_script_prefix_cop = "cop:";
+const char *_ms_script_prefix_ru = "ru:";
+const char *_ms_script_prefix_hi = "hi:";
+const char *_ms_script_prefix_ka = "ka:";
+const char *_ms_script_prefix_el = "el:";
+const char *_ms_script_prefix_gu = "gu:";
+const char *_ms_script_prefix_pa = "pa:";
+const char *_ms_script_prefix_ko = "ko:";
+const char *_ms_script_prefix_he = "he:";
+const char *_ms_script_prefix_ja = "ja:";
+const char *_ms_script_prefix_kn = "kn:";
+const char *_ms_script_prefix_lo = "lo:";
+const char *_ms_script_prefix_ml = "ml:";
+const char *_ms_script_prefix_mn = "mn:";
+const char *_ms_script_prefix_or = "or:";
+const char *_ms_script_prefix_syr = "syr:";
+const char *_ms_script_prefix_ta = "ta:";
+const char *_ms_script_prefix_te = "te:";
+const char *_ms_script_prefix_th = "th:";
+const char *_ms_script_prefix_bo = "bo:";
+const char *_ms_script_prefix_am = "am:";
+const char *_ms_script_prefix_km = "km:";
+const char *_ms_script_prefix_my = "my:";
+const char *_ms_script_prefix_si = "si:";
+const char *_ms_script_prefix_dv = "dv:";
+const char *_ms_script_prefix_bku = "bku:";
+const char *_ms_script_prefix_hnn = "hnn:";
+const char *_ms_script_prefix_tl = "tl:";
+const char *_ms_script_prefix_tbw = "tbw:";
+const char *_ms_script_prefix_uga = "uga:";
+const char *_ms_script_prefix_bug = "bug:";
+const char *_ms_script_prefix_peo = "peo:";
+const char *_ms_script_prefix_syl = "syl:";
+const char *_ms_script_prefix_nko = "nko:";
+
+const char *prefix_from_script(hb_script_t script) {
+  switch (script) {
+  case HB_SCRIPT_LATIN:
+    return _ms_script_prefix_en;
+  case HB_SCRIPT_ARABIC:
+    return _ms_script_prefix_ar;
+  case HB_SCRIPT_HAN:
+    return _ms_script_prefix_cn;
+  case HB_SCRIPT_ARMENIAN:
+    return _ms_script_prefix_hy;
+  case HB_SCRIPT_BENGALI:
+    return _ms_script_prefix_bn;
+  case HB_SCRIPT_CANADIAN_ABORIGINAL:
+    return _ms_script_prefix_iu;
+  case HB_SCRIPT_CHEROKEE:
+    return _ms_script_prefix_chr;
+  case HB_SCRIPT_COPTIC:
+    return _ms_script_prefix_cop;
+  case HB_SCRIPT_CYRILLIC:
+    return _ms_script_prefix_ru;
+  case HB_SCRIPT_DEVANAGARI:
+    return _ms_script_prefix_hi;
+  case HB_SCRIPT_GEORGIAN:
+    return _ms_script_prefix_ka;
+  case HB_SCRIPT_GREEK:
+    return _ms_script_prefix_el;
+  case HB_SCRIPT_GUJARATI:
+    return _ms_script_prefix_gu;
+  case HB_SCRIPT_GURMUKHI:
+    return _ms_script_prefix_pa;
+  case HB_SCRIPT_HANGUL:
+    return _ms_script_prefix_ko;
+  case HB_SCRIPT_HEBREW:
+    return _ms_script_prefix_he;
+  case HB_SCRIPT_HIRAGANA:
+    return _ms_script_prefix_ja;
+  case HB_SCRIPT_KANNADA:
+    return _ms_script_prefix_kn;
+  case HB_SCRIPT_KATAKANA:
+    return _ms_script_prefix_ja;
+  case HB_SCRIPT_LAO:
+    return _ms_script_prefix_lo;
+  case HB_SCRIPT_MALAYALAM:
+    return _ms_script_prefix_ml;
+  case HB_SCRIPT_MONGOLIAN:
+    return _ms_script_prefix_mn;
+  case HB_SCRIPT_ORIYA:
+    return _ms_script_prefix_or;
+  case HB_SCRIPT_SYRIAC:
+    return _ms_script_prefix_syr;
+  case HB_SCRIPT_TAMIL:
+    return _ms_script_prefix_ta;
+  case HB_SCRIPT_TELUGU:
+    return _ms_script_prefix_te;
+  case HB_SCRIPT_THAI:
+    return _ms_script_prefix_th;
+  case HB_SCRIPT_TIBETAN:
+    return _ms_script_prefix_bo;
+  case HB_SCRIPT_ETHIOPIC:
+    return _ms_script_prefix_am;
+  case HB_SCRIPT_KHMER:
+    return _ms_script_prefix_km;
+  case HB_SCRIPT_MYANMAR:
+    return _ms_script_prefix_my;
+  case HB_SCRIPT_SINHALA:
+    return _ms_script_prefix_si;
+  case HB_SCRIPT_THAANA:
+    return _ms_script_prefix_dv;
+  case HB_SCRIPT_BUHID:
+    return _ms_script_prefix_bku;
+  case HB_SCRIPT_HANUNOO:
+    return _ms_script_prefix_hnn;
+  case HB_SCRIPT_TAGALOG:
+    return _ms_script_prefix_tl;
+  case HB_SCRIPT_TAGBANWA:
+    return _ms_script_prefix_tbw;
+  case HB_SCRIPT_UGARITIC:
+    return _ms_script_prefix_uga;
+  case HB_SCRIPT_BUGINESE:
+    return _ms_script_prefix_bug;
+  case HB_SCRIPT_OLD_PERSIAN:
+    return _ms_script_prefix_peo;
+  case HB_SCRIPT_SYLOTI_NAGRI:
+    return _ms_script_prefix_syl;
+  case HB_SCRIPT_NKO:
+    return _ms_script_prefix_nko;
+  default:
+    return NULL;
+  }
+}
+
+hb_feature_t hbfeatures[2] = {{HB_TAG('v', 'e', 'r', 't'), 0, 0, INT_MAX},
+                              {HB_TAG('k', 'e', 'r', 'n'), 0, 0, INT_MAX}};
+
+static hb_bool_t _ms_get_glyph_func(hb_font_t *font, void *font_data,
+                                    hb_codepoint_t unicode,
+                                    hb_codepoint_t variation_selector,
+                                    hb_codepoint_t *glyph, void *user_data)
+
+{
+  (void)font;
+  (void)variation_selector;
+  (void)user_data;
+  /* first check our run, as we have probably already computed this */
+  int i;
+  struct _ms_hb_user_data *ud = font_data;
+  unsigned int *unicodes = ud->info->unicodes + ud->run->offset;
+
+  for (i = 0; i < ud->run->length; i++) {
+    if (unicodes[i] == unicode) {
+      *glyph = *(ud->info->codepoints + ud->run->offset + i);
+      return *glyph != 0;
+    }
+  }
+
+  {
+    FT_Face ft_face = ud->run->face->face;
+
+#ifdef HAVE_FT_FACE_GETCHARVARIANTINDEX
+    if ((variation_selector)) {
+      *glyph =
+          FT_Face_GetCharVariantIndex(ft_face, unicode, variation_selector);
+      return *glyph != 0;
+    }
+#endif
+
+    *glyph = FT_Get_Char_Index(ft_face, unicode);
+    return *glyph != 0;
+  }
+}
+
+#if HB_VERSION_ATLEAST(1, 2, 3)
+static hb_bool_t _ms_get_nominal_glyph_func(hb_font_t *font, void *font_data,
+                                            hb_codepoint_t unicode,
+                                            hb_codepoint_t *glyph,
+                                            void *user_data) {
+  return _ms_get_glyph_func(font, font_data, unicode, 0, glyph, user_data);
+}
+
+static hb_bool_t _ms_get_variation_glyph_func(hb_font_t *font, void *font_data,
+                                              hb_codepoint_t unicode,
+                                              hb_codepoint_t variation_selector,
+                                              hb_codepoint_t *glyph,
+                                              void *user_data) {
+  return _ms_get_glyph_func(font, font_data, unicode, variation_selector, glyph,
+                            user_data);
+}
+#endif
+
+static hb_position_t _ms_get_glyph_h_advance_func(hb_font_t *font,
+                                                  void *font_data,
+                                                  hb_codepoint_t glyph,
+                                                  void *user_data) {
+  (void)font;
+  (void)user_data;
+  struct _ms_hb_user_data *ud = font_data;
+  glyph_element *glyphc =
+      msGetGlyphByIndex(ud->run->face, ud->glyph_size, glyph);
+  if (!glyphc)
+    return 0;
+  return glyphc->metrics.advance * 64;
+}
+
+static hb_position_t _ms_get_glyph_v_advance_func(hb_font_t *font,
+                                                  void *font_data,
+                                                  hb_codepoint_t glyph,
+                                                  void *user_data) {
+  (void)font;
+  (void)font_data;
+  (void)glyph;
+  (void)user_data;
+  return 0; /* we don't support vertical layouts */
+}
+#endif
+
+static int check_single_font(fontSetObj *fontset, char *fontkey, text_run *run,
+                             TextInfo *glyphs, int ignore_missing) {
+  int i;
+  face_element *fcache = NULL;
+  if (fontset && fontkey) {
+    char *fontkey2 = strchr(fontkey, ':'); /* try skipping prefix */
+    if (fontkey2) {
+      fcache = msGetFontFace(fontkey2 + 1, fontset);
+    }
+  }
+  if (!fcache)
+    fcache = msGetFontFace(fontkey, fontset);
+  run->face = fcache;
+  if (MS_UNLIKELY(!fcache))
+    return MS_FAILURE;
+  for (i = 0; i < run->length; i++) {
+    unsigned int codepoint =
+        msGetGlyphIndex(fcache, glyphs->unicodes[run->offset + i]);
+    if (codepoint || ignore_missing) {
+      if (codepoint == 0) {
+        msDebug("Unable to find glyph for codepoint %u. Using ? as fallback.\n",
+                glyphs->unicodes[run->offset + i]);
+        codepoint = msGetGlyphIndex(fcache, '?');
+      }
+      glyphs->codepoints[run->offset + i] = codepoint;
+    } else
+      return MS_FAILURE;
+  }
+  return MS_SUCCESS;
+}
+
+static int get_face_for_run(fontSetObj *fontset, char *fontlist, text_run *run,
+                            TextInfo *glyphs) {
+  char *startfont, *endfont;
+#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
+  const char *prefix = NULL;
+#endif
+
+  if (!fontset || !fontlist) {
+    int ok = check_single_font(fontset, fontlist, run, glyphs, 0);
+    (void)ok;
+    return MS_SUCCESS;
+  }
+
+#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
+  if (run->rtl >= 0) {
+    prefix = prefix_from_script(run->script);
+  } else {
+    prefix = _ms_script_prefix_en;
+  }
+
+  if (prefix) {
+    /* we'll first look for a font who's prefixed by the current script prefix,
+     * e.g, given the fontlist "arial,ar:arialuni,cn:cjk" check the "cjk" font
+     * first for HAN scripts
+     */
+    int prefixlen = strlen(prefix);
+    startfont = fontlist;
+    for (;;) {
+      if (!*startfont)
+        break;
+      endfont = strchr(startfont, ',');
+      if (!strncmp(startfont, prefix, prefixlen)) {
+        startfont += strlen(prefix);
+        if (endfont)
+          *endfont = 0;
+        int ok = check_single_font(fontset, startfont, run, glyphs, 0);
+        if (endfont) {
+          *endfont = ',';
+          if (ok == MS_SUCCESS)
+            return MS_SUCCESS;
+          startfont = endfont + 1; /* go to next font in list */
+        } else {
+          if (ok == MS_SUCCESS)
+            return MS_SUCCESS;
+          break;
+        }
+      }
+      if (endfont)
+        startfont = endfont + 1;
+      else
+        break;
+    }
+  }
+#endif
+
+  /* no prefix, or prefix search didn't return satisfying result */
+  startfont = fontlist;
+  for (;;) {
+    if (!*startfont)
+      break;
+    endfont = strchr(startfont, ',');
+    if (endfont)
+      *endfont = 0;
+    int ok = check_single_font(fontset, startfont, run, glyphs,
+                               !endfont); /* ignore failing glyphs if we're
+                                             using the last font in the list */
+    if (endfont) {
+      *endfont = ',';
+      if (ok == MS_SUCCESS)
+        return MS_SUCCESS;
+      startfont = endfont + 1; /* go to next font in list */
+    } else {
+      if (ok == MS_SUCCESS)
+        return MS_SUCCESS;
+      break;
+    }
+  }
+
+  return MS_FAILURE;
+}
+
+#ifdef USE_HARFBUZZ
+hb_font_t *get_hb_font(struct _ms_hb_user_data *font_data) {
+  face_element *fcache = font_data->run->face;
+  hb_font_element *hbf = fcache->hbfont;
+  FT_Face face = fcache->face;
+  int reqsize = MS_NINT(font_data->glyph_size * 96.0 / 72.0);
+
+  if (reqsize != fcache->face->size->metrics.x_ppem) {
+    FT_Set_Pixel_Sizes(face, 0, reqsize);
+  }
+
+  if (!hbf) {
+    hbf = msSmallMalloc(sizeof(hb_font_element));
+    hbf->hbparentfont = hb_ft_font_create(face, NULL);
+    hbf->hbfont = hb_font_create_sub_font(hbf->hbparentfont);
+    hbf->funcs = hb_font_funcs_create();
+    hb_font_funcs_set_glyph_h_advance_func(
+        hbf->funcs, _ms_get_glyph_h_advance_func, NULL, NULL);
+#if HB_VERSION_ATLEAST(1, 2, 3)
+    hb_font_funcs_set_nominal_glyph_func(hbf->funcs, _ms_get_nominal_glyph_func,
+                                         NULL, NULL);
+    hb_font_funcs_set_variation_glyph_func(
+        hbf->funcs, _ms_get_variation_glyph_func, NULL, NULL);
+#else
+    hb_font_funcs_set_glyph_func(hbf->funcs, _ms_get_glyph_func, NULL, NULL);
+#endif
+    hb_font_funcs_set_glyph_v_advance_func(
+        hbf->funcs, _ms_get_glyph_v_advance_func, NULL, NULL);
+    hbf->cursize = reqsize;
+    fcache->hbfont = hbf;
+    hb_font_set_funcs(hbf->hbfont, hbf->funcs, font_data, NULL);
+  } else {
+    if (hbf->cursize != reqsize) {
+      hb_font_set_scale(hbf->hbparentfont,
+                        ((uint64_t)face->size->metrics.x_scale *
+                         (uint64_t)face->units_per_EM) >>
+                            16,
+                        ((uint64_t)face->size->metrics.y_scale *
+                         (uint64_t)face->units_per_EM) >>
+                            16);
+      hb_font_set_ppem(hbf->hbparentfont, face->size->metrics.x_ppem,
+                       face->size->metrics.y_ppem);
+      hbf->cursize = reqsize;
+    }
+  }
+  hb_font_set_funcs_data(hbf->hbfont, font_data, NULL);
+  return hbf->hbfont;
+}
+
+/*
+ *  Return non-zero (true) if the given unicode array contains
+ *  only ASCII and ISO Latin-1 characters, otherwise return zero.
+ */
+int unicode_is_latin1(const unsigned int *unicode, long nglyphs) {
+  long i;
+
+  for (i = 0; i < nglyphs; i++) {
+    if (unicode[i] < 0x2B0)
+      continue;
+    return 0;
+  }
+  return 1;
+}
+
+void get_scripts(unsigned int *cp, int len, hb_script_t *scripts) {
+  int i;
+  int backwards_scan = 0;
+  hb_unicode_funcs_t *ufuncs = hb_unicode_funcs_get_default();
+  hb_script_t last_script = HB_SCRIPT_UNKNOWN;
+
+  // determine script (forward scan)
+  for (i = 0; i < len; i++) {
+    scripts[i] = hb_unicode_script(ufuncs, cp[i]);
+
+    // common/inherit codepoints inherit script from context
+    if (scripts[i] == HB_SCRIPT_COMMON || scripts[i] == HB_SCRIPT_INHERITED) {
+      // unknown is not a valid context
+      if (last_script != HB_SCRIPT_UNKNOWN)
+        scripts[i] = last_script;
+      else
+        // do a backwards scan to check if next codepoint
+        // contains a valid script for context
+        backwards_scan = 1;
+    } else {
+      last_script = scripts[i];
+    }
+  }
+
+  // determine script (backwards scan, if needed)
+  last_script = HB_SCRIPT_UNKNOWN;
+  for (i = len - 1; i >= 0 && backwards_scan; i--) {
+    // common/inherit codepoints inherit script from context
+    if (scripts[i] == HB_SCRIPT_COMMON || scripts[i] == HB_SCRIPT_INHERITED) {
+      // unknown script is not a valid context
+      if (last_script != HB_SCRIPT_UNKNOWN)
+        scripts[i] = last_script;
+    } else {
+      last_script = scripts[i];
+    }
+  }
+}
+#endif
+
+/* returns 1 if this is a codepoint we should skip. only checks \r for now */
+static int skip_unicode(unsigned int unicode) {
+  switch (unicode) {
+  case '\r':
+    return 1;
+    break;
+  default:
+    return 0;
+  }
+}
+
+#define MS_RTL_LTR 0
+#define MS_RTL_RTL 1
+#define MS_RTL_MIXED 2
+
+struct line_desc {
+  int length;
+  int rtl;
+};
+
+int msLayoutTextSymbol(mapObj *map, textSymbolObj *ts, textPathObj *tgret) {
+#define STATIC_GLYPHS 100
+#define STATIC_LINES 10
+  text_run static_runs[STATIC_GLYPHS];
+  int i, nruns, start, ret = MS_SUCCESS;
+  size_t text_num_bytes;
+  char *inp;
+  unsigned int static_unicodes[STATIC_GLYPHS];
+  unsigned int static_codepoints[STATIC_GLYPHS];
+#ifdef USE_FRIBIDI
+  FriBidiCharType static_ctypes[STATIC_GLYPHS];
+  FriBidiLevel static_bidi_levels[STATIC_GLYPHS];
+#endif
+#ifdef USE_HARFBUZZ
+  hb_script_t static_scripts[STATIC_GLYPHS];
+  hb_buffer_t *buf = NULL;
+#endif
+  struct line_desc static_line_descs[STATIC_LINES];
+  int alloc_glyphs = 0;
+  struct line_desc *line_descs = NULL;
+  text_run *runs;
+  double oldpeny = 3455, peny,
+         penx = 0; /*oldpeny is set to an unreasonable default initial value */
+  fontSetObj *fontset = NULL;
+
+  TextInfo glyphs;
+  int num_glyphs = 0;
+
+  assert(
+      ts->annotext &&
+      *ts->annotext); /* ensure we have at least one character/glyph to treat */
+
+  if (map)
+    fontset = &map->fontset;
+    /* go through iconv beforehand, so we know we're handling utf8 */
+#ifdef USE_ICONV
+  if (ts->label->encoding && strcasecmp(ts->label->encoding, "UTF-8")) {
+    iconv_t cd;
+    size_t len, bufleft;
+    char *encoded_text, *outp;
+    len = strlen(ts->annotext);
+    bufleft = len * 6;
+    encoded_text = msSmallMalloc(bufleft + 1);
+    cd = iconv_open("UTF-8", ts->label->encoding);
+
+    if (cd == (iconv_t)-1) {
+      msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
+                 "msGetEncodedString()", ts->label->encoding);
+      return MS_FAILURE;
+    }
+
+    inp = ts->annotext;
+    outp = encoded_text;
+
+    while (len > 0) {
+      const size_t iconv_status = iconv(cd, &inp, &len, &outp, &bufleft);
+      if (iconv_status == (size_t)-1) {
+        break;
+      }
+    }
+
+    text_num_bytes = outp - encoded_text;
+    encoded_text[text_num_bytes] = 0;
+    free(ts->annotext);
+    ts->annotext = encoded_text;
+    iconv_close(cd);
+  } else
+#endif
+  {
+    text_num_bytes = strlen(ts->annotext);
+  }
+
+  if (text_num_bytes == 0)
+    return 0;
+
+  if (text_num_bytes > STATIC_GLYPHS) {
+#ifdef USE_FRIBIDI
+    glyphs.bidi_levels = msSmallMalloc(text_num_bytes * sizeof(FriBidiLevel));
+    glyphs.ctypes = msSmallMalloc(text_num_bytes * sizeof(FriBidiCharType));
+#endif
+    glyphs.unicodes = msSmallMalloc(text_num_bytes * sizeof(unsigned int));
+    glyphs.codepoints = msSmallMalloc(text_num_bytes * sizeof(unsigned int));
+#ifdef USE_HARFBUZZ
+    glyphs.scripts = msSmallMalloc(text_num_bytes * sizeof(hb_script_t));
+#endif
+    runs = msSmallMalloc(text_num_bytes * sizeof(text_run));
+  } else {
+#ifdef USE_FRIBIDI
+    glyphs.bidi_levels = static_bidi_levels;
+    glyphs.ctypes = static_ctypes;
+#endif
+    glyphs.unicodes = static_unicodes;
+    glyphs.codepoints = static_codepoints;
+#ifdef USE_HARFBUZZ
+    glyphs.scripts = static_scripts;
+#endif
+    runs = static_runs;
+  }
+
+  /* populate the unicode entries once and for all */
+  inp = ts->annotext;
+  while (*inp) {
+    unsigned int unicode;
+    inp += msUTF8ToUniChar(inp, &unicode);
+    if (!skip_unicode(unicode)) {
+      glyphs.unicodes[num_glyphs++] = unicode;
+    }
+  }
+
+  if (ts->label->wrap || ts->label->maxlength > 0) {
+    if (ts->label->wrap && ts->label->maxlength == 0) {
+      for (i = 0; i < num_glyphs; i++) {
+        /* replace all occurences of the wrap character with a newline */
+        if (glyphs.unicodes[i] == (unsigned)ts->label->wrap)
+          glyphs.unicodes[i] = '\n';
+      }
+    } else {
+      assert(ts->label->maxlength > 0);
+      if (num_glyphs > ts->label->maxlength) {
+        int num_cur_glyph_on_line =
+            0; /*count for the number of glyphs on the current line*/
+        for (i = 0; i < num_glyphs; i++) {
+          /* wrap at wrap character or at ZERO WIDTH SPACE (unicode 0x200b), if
+           * current line is too long */
+          if ((glyphs.unicodes[i] == (unsigned)ts->label->wrap ||
+               glyphs.unicodes[i] == (unsigned)0x200b) &&
+              num_cur_glyph_on_line >= ts->label->maxlength) {
+            glyphs.unicodes[i] = '\n';
+            num_cur_glyph_on_line = 0;
+          } else {
+            num_cur_glyph_on_line++;
+          }
+        }
+      }
+    }
+    /*
+     * TODO RFC98: RFC40 negative label->wrap. This is left out for the moment
+     * as it requires handling a realloc and imho is never used and is an
+     * overly-complex use-case.
+     */
+  }
+
+  /* split our text into runs (one for each line) */
+  nruns = 0;
+  start = 0;
+  runs[0].offset = 0;
+  runs[0].line_number = 0;
+  for (i = 0; i < num_glyphs; i++) {
+    if (glyphs.unicodes[i] != '\n')
+      continue;
+    runs[nruns].length = i - start; /* length of current line (without \n) */
+    start = i + 1;                  /* start of next line */
+    runs[nruns + 1].line_number = runs[nruns].line_number + 1;
+    runs[nruns + 1].offset = start;
+    nruns++;
+  }
+  /* unless the last glyph was a \n, we need to "close" the last run */
+  if (glyphs.unicodes[num_glyphs - 1] != '\n') {
+    runs[nruns].length = num_glyphs - start;
+    nruns++;
+  }
+
+  if (runs[nruns - 1].line_number + 1 > STATIC_LINES) {
+    line_descs = msSmallMalloc((runs[nruns - 1].line_number + 1) *
+                               sizeof(struct line_desc));
+  } else {
+    line_descs = static_line_descs;
+  }
+
+#ifdef USE_FRIBIDI
+  for (i = 0; i < nruns; i++) {
+    /* check the run (at this stage, one run per line), decide if we need to go
+     * through bidi and/or shaping */
+    if (unicode_is_latin1(glyphs.unicodes + runs[i].offset, runs[i].length)) {
+      runs[i].rtl = -1;
+      line_descs[i].rtl = MS_RTL_LTR;
+    } else {
+      runs[i].rtl = 0;
+    }
+  }
+
+  for (i = 0; i < nruns; i++) {
+    /* split the text into bidi runs */
+    if (runs[i].rtl >= 0) {
+      int j, original_num_glyphs, original_offset;
+      FriBidiLevel prevlevel;
+      FriBidiParType dir = FRIBIDI_PAR_LTR;
+      original_offset = runs[i].offset;
+      original_num_glyphs = runs[i].length;
+      fribidi_get_bidi_types(glyphs.unicodes + original_offset, runs[i].length,
+                             glyphs.ctypes + original_offset);
+      {
+        FriBidiLevel level = fribidi_get_par_embedding_levels(
+            glyphs.ctypes + original_offset, runs[i].length, &dir,
+            glyphs.bidi_levels + runs[i].offset);
+        (void)level;
+      }
+      /* if we have different embedding levels, create a run for each one */
+      runs[i].rtl = prevlevel = glyphs.bidi_levels[original_offset];
+      line_descs[runs[i].line_number].rtl =
+          (prevlevel % 2) ? MS_RTL_RTL : MS_RTL_LTR;
+      for (j = 1; j < original_num_glyphs; j++) {
+        if (glyphs.bidi_levels[original_offset + j] != prevlevel) {
+          line_descs[runs[i].line_number].rtl = MS_RTL_MIXED;
+          /* create a new run for the different embedding level */
+          nruns++;
+
+          /* first move remaining runs */
+          memmove(runs + i + 2, runs + i + 1,
+                  (nruns - i - 2) * sizeof(text_run));
+
+          i++;
+          /* new run inherints line number */
+          runs[i].line_number = runs[i - 1].line_number;
+          runs[i].offset = original_offset + j;
+          runs[i].length =
+              (runs[i - 1].offset + runs[i - 1].length) - runs[i].offset;
+          runs[i - 1].length = runs[i].offset - runs[i - 1].offset;
+
+          /* new run starts at current postition */
+          runs[i].rtl = prevlevel = glyphs.bidi_levels[original_offset + j];
+        }
+      }
+    }
+  }
+#else
+  for (i = 0; i < nruns; i++) {
+    line_descs[i].rtl = MS_RTL_LTR;
+  }
+#endif
+
+#ifdef USE_FRIBIDI
+  /* determine the scripts of each run, and split again into runs with identical
+   * script */
+  for (i = 0; i < nruns; i++) {
+    if (runs[i].rtl == -1) {
+      runs[i].script = HB_SCRIPT_LATIN;
+      continue; /* skip runs we have determined we are latin (no shaping needed)
+                 */
+    } else {
+      int j, original_num_glyphs, original_offset;
+      hb_script_t prevscript;
+      original_offset = runs[i].offset;
+      original_num_glyphs = runs[i].length;
+      get_scripts(glyphs.unicodes + original_offset, runs[i].length,
+                  glyphs.scripts + original_offset);
+      /* if we have different scripts, create a run for each one */
+      runs[i].script = prevscript = glyphs.scripts[original_offset];
+      for (j = 1; j < original_num_glyphs; j++) {
+        if (glyphs.scripts[original_offset + j] != prevscript) {
+          /* create a new run for the different embedding level */
+          nruns++;
+
+          /* first move remaining runs */
+          memmove(runs + i + 2, runs + i + 1,
+                  (nruns - i - 2) * sizeof(text_run));
+
+          i++;
+          /* new run inherints line number and rtl*/
+          runs[i].line_number = runs[i - 1].line_number;
+          runs[i].rtl = runs[i - 1].rtl;
+          runs[i].offset = original_offset + j;
+          runs[i].length =
+              (runs[i - 1].offset + runs[i - 1].length) - runs[i].offset;
+          runs[i - 1].length = runs[i].offset - runs[i - 1].offset;
+
+          runs[i].script = prevscript = glyphs.scripts[original_offset + j];
+        }
+      }
+    }
+  }
+#endif
+
+  for (i = 0; i < nruns; i++) {
+    ret = get_face_for_run(fontset, ts->label->font, runs + i, &glyphs);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto cleanup;
+  }
+
+  /*
+   * determine the font face to use for a given run. No splitting needed here
+   * for now, as we suppose that the decomposition of each run into individual
+   * bidi direction and script level is sufficient to ensure that a given run
+   * can be represented by a single font (i.e. there's no need to look into
+   * multiple fonts to find the glyphs of the run)
+   */
+
+  tgret->numlines = runs[nruns - 1].line_number + 1;
+  tgret->bounds.bbox.minx = 0;
+  tgret->bounds.bbox.miny = FLT_MAX;
+  tgret->bounds.bbox.maxx = tgret->bounds.bbox.maxy = -FLT_MAX;
+
+  for (i = 0; i < nruns; i++) {
+    if (!runs[i].face)
+      continue;
+    peny = (1 - tgret->numlines + runs[i].line_number) * tgret->line_height;
+    if (peny != oldpeny) {
+      if (i > 0)
+        line_descs[runs[i - 1].line_number].length = penx;
+      if (penx > tgret->bounds.bbox.maxx)
+        tgret->bounds.bbox.maxx = penx;
+      oldpeny = peny;
+      penx = 0;
+    }
+#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
+    if (runs[i].rtl == -1 || runs[i].script == HB_SCRIPT_LATIN ||
+        runs[i].script == HB_SCRIPT_COMMON)
+#endif
+    {
+      /* use our basic shaper */
+      unsigned int *codepoint = glyphs.codepoints + runs[i].offset;
+      alloc_glyphs += runs[i].length;
+      tgret->glyphs =
+          msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
+      for (int j = 0; j < runs[i].length; j++) {
+        glyphObj *g = &tgret->glyphs[tgret->numglyphs + j];
+        g->glyph =
+            msGetGlyphByIndex(runs[i].face, tgret->glyph_size, *codepoint);
+        g->face = runs[i].face;
+        codepoint++;
+        g->pnt.x = penx;
+        g->pnt.y = peny;
+        g->rot = 0.0;
+        penx += g->glyph->metrics.advance;
+        if (runs[i].line_number == 0 &&
+            peny - g->glyph->metrics.maxy <
+                tgret->bounds.bbox
+                    .miny) /*compute minimal y, only for the first line */
+          tgret->bounds.bbox.miny = peny - g->glyph->metrics.maxy;
+        if (peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
+          tgret->bounds.bbox.maxy = peny - g->glyph->metrics.miny;
+      }
+#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
+    } else {
+      struct _ms_hb_user_data user_data;
+      hb_font_t *font;
+      hb_glyph_info_t *glyph_info;
+      hb_glyph_position_t *glyph_pos;
+      if (!buf) {
+        buf = hb_buffer_create();
+      }
+      user_data.info = &glyphs;
+      user_data.run = runs + i;
+      user_data.glyph_size = tgret->glyph_size;
+      hb_buffer_clear_contents(buf);
+      hb_buffer_set_script(buf, runs[i].script);
+      font = get_hb_font(&user_data);
+      hb_buffer_set_direction(buf, (runs[i].rtl % 2) ? HB_DIRECTION_RTL
+                                                     : HB_DIRECTION_LTR);
+      hb_buffer_add_utf32(buf, glyphs.unicodes + runs[i].offset, runs[i].length,
+                          0, runs[i].length);
+      hb_shape(font, buf, hbfeatures, 2);
+
+      unsigned int glyph_count;
+      glyph_info = hb_buffer_get_glyph_infos(buf, &glyph_count);
+      glyph_pos = hb_buffer_get_glyph_positions(buf, &glyph_count);
+      alloc_glyphs += glyph_count;
+      tgret->glyphs =
+          msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
+      for (unsigned j = 0; j < glyph_count; j++) {
+        glyphObj *g = &tgret->glyphs[tgret->numglyphs + j];
+        g->glyph = msGetGlyphByIndex(runs[i].face, tgret->glyph_size,
+                                     glyph_info[j].codepoint);
+        g->face = runs[i].face;
+        g->pnt.x = penx + glyph_pos[j].x_offset / 64;
+        g->pnt.y = peny - glyph_pos[j].y_offset / 64;
+        g->rot = 0;
+        penx += glyph_pos[j].x_advance / 64.0;
+        /* peny -= glyph_pos[j].y_advance/64; // we don't do vertical layouts */
+        if (runs[i].line_number == 0 &&
+            peny - g->glyph->metrics.maxy <
+                tgret->bounds.bbox
+                    .miny) /*compute minimal y, only for the first line */
+          tgret->bounds.bbox.miny = peny - g->glyph->metrics.maxy;
+        if (peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
+          tgret->bounds.bbox.maxy = peny - g->glyph->metrics.miny;
+      }
+#endif
+    }
+    tgret->numglyphs = alloc_glyphs;
+    line_descs[runs[nruns - 1].line_number].length = penx;
+    if (penx > tgret->bounds.bbox.maxx)
+      tgret->bounds.bbox.maxx = penx;
+  }
+
+#ifdef USE_HARFBUZZ
+  if (buf) {
+    hb_buffer_destroy(buf);
+  }
+#endif
+
+  if (tgret->numlines > 1) {
+    int max_line_length = 0;
+    int line = -1;
+    double cur_line_offset = 0;
+    int prev_default_align =
+        MS_ALIGN_LEFT; /* if we have mixed rtl status, use the alignment of the
+                          previous line. this defaults to left-alignment if the
+                          first line is mixed */
+    int cur_default_align = 0;
+    for (i = 0; i < tgret->numlines; i++) {
+      if (line_descs[i].length > max_line_length) {
+        max_line_length = line_descs[i].length;
+      }
+    }
+    oldpeny = 3455;
+    for (i = 0; i < alloc_glyphs; i++) {
+      if (tgret->glyphs[i].pnt.y != oldpeny) {
+        oldpeny = tgret->glyphs[i].pnt.y;
+        line++;
+        /* compute offset to apply to coming line */
+        switch (ts->label->align) {
+        case MS_ALIGN_CENTER:
+          cur_line_offset = (max_line_length - line_descs[line].length) / 2.0;
+          break;
+        case MS_ALIGN_RIGHT:
+          cur_line_offset = (max_line_length - line_descs[line].length);
+          break;
+        case MS_ALIGN_LEFT:
+          cur_line_offset = 0;
+          break;
+        case MS_ALIGN_DEFAULT:
+        default:
+          switch (line_descs[line].rtl) {
+          case MS_RTL_MIXED:
+            cur_default_align = prev_default_align;
+            break;
+          case MS_RTL_RTL:
+            cur_default_align = prev_default_align = MS_RTL_RTL;
+            break;
+          case MS_RTL_LTR:
+            cur_default_align = prev_default_align = MS_RTL_LTR;
+            break;
+          }
+          switch (cur_default_align) {
+          case MS_RTL_RTL:
+            /* align to the right */
+            cur_line_offset = (max_line_length - line_descs[line].length);
+            break;
+          case MS_RTL_LTR:
+            cur_line_offset = 0;
+            break;
+          }
+        }
+      }
+      tgret->glyphs[i].pnt.x += cur_line_offset;
+    }
+  }
+  /*
+   * msDebug("bounds for %s: %f %f %f
+   * %f\n",ts->annotext,tgret->bounds.bbox.minx,tgret->bounds.bbox.miny,tgret->bounds.bbox.maxx,tgret->bounds.bbox.maxy);
+   */
+
+cleanup:
+  if (line_descs != static_line_descs)
+    free(line_descs);
+  if (glyphs.codepoints != static_codepoints) {
+#ifdef USE_FRIBIDI
+    free(glyphs.bidi_levels);
+    free(glyphs.ctypes);
+#endif
+    free(glyphs.codepoints);
+#ifdef USE_HARFBUZZ
+    free(glyphs.scripts);
+#endif
+    free(glyphs.unicodes);
+    free(runs);
+  }
+  return ret;
+}
diff -pruN 8.0.1-5/src/third-party/include_nlohmann_json.hpp 8.2.0~beta1-1~exp1/src/third-party/include_nlohmann_json.hpp
--- 8.0.1-5/src/third-party/include_nlohmann_json.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/third-party/include_nlohmann_json.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,41 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Wrapper for nlohmann/json.hpp
+ * Author:   Even Rouault <even dot rouault at spatialys dot com>
+ *
+ * Notes: Derived from PROJ project file of the same name.
+ *
+ ******************************************************************************
+ * Copyright (c) 2019, Even Rouault <even dot rouault at spatialys dot com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included
+ * in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#if defined(__GNUC__)
+#pragma GCC system_header
+#endif
+
+// avoid any clash if other packages (e.g. PROJ) are using another version of nlohmann/json.hpp
+#define nlohmann ms_nlohmann
+
+#if !defined(DOXYGEN_ENABLED)
+#include "nlohmann/json.hpp"
+#endif
diff -pruN 8.0.1-5/src/third-party/include_pantor_inja.hpp 8.2.0~beta1-1~exp1/src/third-party/include_pantor_inja.hpp
--- 8.0.1-5/src/third-party/include_pantor_inja.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/third-party/include_pantor_inja.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,36 @@
+/******************************************************************************
+ * $Id$
+ *
+ * Project:  MapServer
+ * Purpose:  Wrapper for pantor/inja.hpp
+ * Author:   Even Rouault <even dot rouault at spatialys dot com>
+ *
+ ******************************************************************************
+ * Copyright (c) 2019, Even Rouault <even dot rouault at spatialys dot com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included
+ * in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+ * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ ****************************************************************************/
+
+#if defined(__GNUC__)
+#pragma GCC system_header
+#endif
+
+#if !defined(DOXYGEN_ENABLED)
+#include "pantor/inja.hpp"
+#endif
diff -pruN 8.0.1-5/src/third-party/nlohmann/json.hpp 8.2.0~beta1-1~exp1/src/third-party/nlohmann/json.hpp
--- 8.0.1-5/src/third-party/nlohmann/json.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/third-party/nlohmann/json.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,22091 @@
+/*
+    __ _____ _____ _____
+ __|  |   __|     |   | |  JSON for Modern C++
+|  |  |__   |  |  | | | |  version 3.10.5
+|_____|_____|_____|_|___|  https://github.com/nlohmann/json
+
+Licensed under the MIT License <http://opensource.org/licenses/MIT>.
+SPDX-License-Identifier: MIT
+Copyright (c) 2013-2022 Niels Lohmann <http://nlohmann.me>.
+
+Permission is hereby  granted, free of charge, to any  person obtaining a copy
+of this software and associated  documentation files (the "Software"), to deal
+in the Software  without restriction, including without  limitation the rights
+to  use, copy,  modify, merge,  publish, distribute,  sublicense, and/or  sell
+copies  of  the Software,  and  to  permit persons  to  whom  the Software  is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all
+copies or substantial portions of the Software.
+
+THE SOFTWARE  IS PROVIDED "AS  IS", WITHOUT WARRANTY  OF ANY KIND,  EXPRESS OR
+IMPLIED,  INCLUDING BUT  NOT  LIMITED TO  THE  WARRANTIES OF  MERCHANTABILITY,
+FITNESS FOR  A PARTICULAR PURPOSE AND  NONINFRINGEMENT. IN NO EVENT  SHALL THE
+AUTHORS  OR COPYRIGHT  HOLDERS  BE  LIABLE FOR  ANY  CLAIM,  DAMAGES OR  OTHER
+LIABILITY, WHETHER IN AN ACTION OF  CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE  OR THE USE OR OTHER DEALINGS IN THE
+SOFTWARE.
+*/
+
+/****************************************************************************\
+ * Note on documentation: The source files contain links to the online      *
+ * documentation of the public API at https://json.nlohmann.me. This URL    *
+ * contains the most recent documentation and should also be applicable to  *
+ * previous versions; documentation for deprecated functions is not         *
+ * removed, but marked deprecated. See "Generate documentation" section in  *
+ * file doc/README.md.                                                      *
+\****************************************************************************/
+
+#ifndef INCLUDE_NLOHMANN_JSON_HPP_
+#define INCLUDE_NLOHMANN_JSON_HPP_
+
+#define NLOHMANN_JSON_VERSION_MAJOR 3
+#define NLOHMANN_JSON_VERSION_MINOR 10
+#define NLOHMANN_JSON_VERSION_PATCH 5
+
+#include <algorithm> // all_of, find, for_each
+#include <cstddef> // nullptr_t, ptrdiff_t, size_t
+#include <functional> // hash, less
+#include <initializer_list> // initializer_list
+#ifndef JSON_NO_IO
+    #include <iosfwd> // istream, ostream
+#endif  // JSON_NO_IO
+#include <iterator> // random_access_iterator_tag
+#include <memory> // unique_ptr
+#include <numeric> // accumulate
+#include <string> // string, stoi, to_string
+#include <utility> // declval, forward, move, pair, swap
+#include <vector> // vector
+
+// #include <nlohmann/adl_serializer.hpp>
+
+
+#include <type_traits>
+#include <utility>
+
+// #include <nlohmann/detail/conversions/from_json.hpp>
+
+
+#include <algorithm> // transform
+#include <array> // array
+#include <forward_list> // forward_list
+#include <iterator> // inserter, front_inserter, end
+#include <map> // map
+#include <string> // string
+#include <tuple> // tuple, make_tuple
+#include <type_traits> // is_arithmetic, is_same, is_enum, underlying_type, is_convertible
+#include <unordered_map> // unordered_map
+#include <utility> // pair, declval
+#include <valarray> // valarray
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+
+#include <exception> // exception
+#include <stdexcept> // runtime_error
+#include <string> // to_string
+#include <vector> // vector
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+#include <array> // array
+#include <cstddef> // size_t
+#include <cstdint> // uint8_t
+#include <string> // string
+
+namespace nlohmann
+{
+namespace detail
+{
+///////////////////////////
+// JSON type enumeration //
+///////////////////////////
+
+/*!
+@brief the JSON type enumeration
+
+This enumeration collects the different JSON types. It is internally used to
+distinguish the stored values, and the functions @ref basic_json::is_null(),
+@ref basic_json::is_object(), @ref basic_json::is_array(),
+@ref basic_json::is_string(), @ref basic_json::is_boolean(),
+@ref basic_json::is_number() (with @ref basic_json::is_number_integer(),
+@ref basic_json::is_number_unsigned(), and @ref basic_json::is_number_float()),
+@ref basic_json::is_discarded(), @ref basic_json::is_primitive(), and
+@ref basic_json::is_structured() rely on it.
+
+@note There are three enumeration entries (number_integer, number_unsigned, and
+number_float), because the library distinguishes these three types for numbers:
+@ref basic_json::number_unsigned_t is used for unsigned integers,
+@ref basic_json::number_integer_t is used for signed integers, and
+@ref basic_json::number_float_t is used for floating-point numbers or to
+approximate integers which do not fit in the limits of their respective type.
+
+@sa see @ref basic_json::basic_json(const value_t value_type) -- create a JSON
+value with the default value for a given type
+
+@since version 1.0.0
+*/
+enum class value_t : std::uint8_t
+{
+    null,             ///< null value
+    object,           ///< object (unordered set of name/value pairs)
+    array,            ///< array (ordered collection of values)
+    string,           ///< string value
+    boolean,          ///< boolean value
+    number_integer,   ///< number value (signed integer)
+    number_unsigned,  ///< number value (unsigned integer)
+    number_float,     ///< number value (floating-point)
+    binary,           ///< binary array (ordered collection of bytes)
+    discarded         ///< discarded by the parser callback function
+};
+
+/*!
+@brief comparison operator for JSON types
+
+Returns an ordering that is similar to Python:
+- order: null < boolean < number < object < array < string < binary
+- furthermore, each type is not smaller than itself
+- discarded values are not comparable
+- binary is represented as a b"" string in python and directly comparable to a
+  string; however, making a binary array directly comparable with a string would
+  be surprising behavior in a JSON file.
+
+@since version 1.0.0
+*/
+inline bool operator<(const value_t lhs, const value_t rhs) noexcept
+{
+    static constexpr std::array<std::uint8_t, 9> order = {{
+            0 /* null */, 3 /* object */, 4 /* array */, 5 /* string */,
+            1 /* boolean */, 2 /* integer */, 2 /* unsigned */, 2 /* float */,
+            6 /* binary */
+        }
+    };
+
+    const auto l_index = static_cast<std::size_t>(lhs);
+    const auto r_index = static_cast<std::size_t>(rhs);
+    return l_index < order.size() && r_index < order.size() && order[l_index] < order[r_index];
+}
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/string_escape.hpp>
+
+
+#include <string>
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+#include <utility> // declval, pair
+// #include <nlohmann/thirdparty/hedley/hedley.hpp>
+
+
+/* Hedley - https://nemequ.github.io/hedley
+ * Created by Evan Nemerson <evan@nemerson.com>
+ *
+ * To the extent possible under law, the author(s) have dedicated all
+ * copyright and related and neighboring rights to this software to
+ * the public domain worldwide. This software is distributed without
+ * any warranty.
+ *
+ * For details, see <http://creativecommons.org/publicdomain/zero/1.0/>.
+ * SPDX-License-Identifier: CC0-1.0
+ */
+
+#if !defined(JSON_HEDLEY_VERSION) || (JSON_HEDLEY_VERSION < 15)
+#if defined(JSON_HEDLEY_VERSION)
+    #undef JSON_HEDLEY_VERSION
+#endif
+#define JSON_HEDLEY_VERSION 15
+
+#if defined(JSON_HEDLEY_STRINGIFY_EX)
+    #undef JSON_HEDLEY_STRINGIFY_EX
+#endif
+#define JSON_HEDLEY_STRINGIFY_EX(x) #x
+
+#if defined(JSON_HEDLEY_STRINGIFY)
+    #undef JSON_HEDLEY_STRINGIFY
+#endif
+#define JSON_HEDLEY_STRINGIFY(x) JSON_HEDLEY_STRINGIFY_EX(x)
+
+#if defined(JSON_HEDLEY_CONCAT_EX)
+    #undef JSON_HEDLEY_CONCAT_EX
+#endif
+#define JSON_HEDLEY_CONCAT_EX(a,b) a##b
+
+#if defined(JSON_HEDLEY_CONCAT)
+    #undef JSON_HEDLEY_CONCAT
+#endif
+#define JSON_HEDLEY_CONCAT(a,b) JSON_HEDLEY_CONCAT_EX(a,b)
+
+#if defined(JSON_HEDLEY_CONCAT3_EX)
+    #undef JSON_HEDLEY_CONCAT3_EX
+#endif
+#define JSON_HEDLEY_CONCAT3_EX(a,b,c) a##b##c
+
+#if defined(JSON_HEDLEY_CONCAT3)
+    #undef JSON_HEDLEY_CONCAT3
+#endif
+#define JSON_HEDLEY_CONCAT3(a,b,c) JSON_HEDLEY_CONCAT3_EX(a,b,c)
+
+#if defined(JSON_HEDLEY_VERSION_ENCODE)
+    #undef JSON_HEDLEY_VERSION_ENCODE
+#endif
+#define JSON_HEDLEY_VERSION_ENCODE(major,minor,revision) (((major) * 1000000) + ((minor) * 1000) + (revision))
+
+#if defined(JSON_HEDLEY_VERSION_DECODE_MAJOR)
+    #undef JSON_HEDLEY_VERSION_DECODE_MAJOR
+#endif
+#define JSON_HEDLEY_VERSION_DECODE_MAJOR(version) ((version) / 1000000)
+
+#if defined(JSON_HEDLEY_VERSION_DECODE_MINOR)
+    #undef JSON_HEDLEY_VERSION_DECODE_MINOR
+#endif
+#define JSON_HEDLEY_VERSION_DECODE_MINOR(version) (((version) % 1000000) / 1000)
+
+#if defined(JSON_HEDLEY_VERSION_DECODE_REVISION)
+    #undef JSON_HEDLEY_VERSION_DECODE_REVISION
+#endif
+#define JSON_HEDLEY_VERSION_DECODE_REVISION(version) ((version) % 1000)
+
+#if defined(JSON_HEDLEY_GNUC_VERSION)
+    #undef JSON_HEDLEY_GNUC_VERSION
+#endif
+#if defined(__GNUC__) && defined(__GNUC_PATCHLEVEL__)
+    #define JSON_HEDLEY_GNUC_VERSION JSON_HEDLEY_VERSION_ENCODE(__GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__)
+#elif defined(__GNUC__)
+    #define JSON_HEDLEY_GNUC_VERSION JSON_HEDLEY_VERSION_ENCODE(__GNUC__, __GNUC_MINOR__, 0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_VERSION_CHECK)
+    #undef JSON_HEDLEY_GNUC_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_GNUC_VERSION)
+    #define JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_GNUC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_MSVC_VERSION)
+    #undef JSON_HEDLEY_MSVC_VERSION
+#endif
+#if defined(_MSC_FULL_VER) && (_MSC_FULL_VER >= 140000000) && !defined(__ICL)
+    #define JSON_HEDLEY_MSVC_VERSION JSON_HEDLEY_VERSION_ENCODE(_MSC_FULL_VER / 10000000, (_MSC_FULL_VER % 10000000) / 100000, (_MSC_FULL_VER % 100000) / 100)
+#elif defined(_MSC_FULL_VER) && !defined(__ICL)
+    #define JSON_HEDLEY_MSVC_VERSION JSON_HEDLEY_VERSION_ENCODE(_MSC_FULL_VER / 1000000, (_MSC_FULL_VER % 1000000) / 10000, (_MSC_FULL_VER % 10000) / 10)
+#elif defined(_MSC_VER) && !defined(__ICL)
+    #define JSON_HEDLEY_MSVC_VERSION JSON_HEDLEY_VERSION_ENCODE(_MSC_VER / 100, _MSC_VER % 100, 0)
+#endif
+
+#if defined(JSON_HEDLEY_MSVC_VERSION_CHECK)
+    #undef JSON_HEDLEY_MSVC_VERSION_CHECK
+#endif
+#if !defined(JSON_HEDLEY_MSVC_VERSION)
+    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (0)
+#elif defined(_MSC_VER) && (_MSC_VER >= 1400)
+    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (_MSC_FULL_VER >= ((major * 10000000) + (minor * 100000) + (patch)))
+#elif defined(_MSC_VER) && (_MSC_VER >= 1200)
+    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (_MSC_FULL_VER >= ((major * 1000000) + (minor * 10000) + (patch)))
+#else
+    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (_MSC_VER >= ((major * 100) + (minor)))
+#endif
+
+#if defined(JSON_HEDLEY_INTEL_VERSION)
+    #undef JSON_HEDLEY_INTEL_VERSION
+#endif
+#if defined(__INTEL_COMPILER) && defined(__INTEL_COMPILER_UPDATE) && !defined(__ICL)
+    #define JSON_HEDLEY_INTEL_VERSION JSON_HEDLEY_VERSION_ENCODE(__INTEL_COMPILER / 100, __INTEL_COMPILER % 100, __INTEL_COMPILER_UPDATE)
+#elif defined(__INTEL_COMPILER) && !defined(__ICL)
+    #define JSON_HEDLEY_INTEL_VERSION JSON_HEDLEY_VERSION_ENCODE(__INTEL_COMPILER / 100, __INTEL_COMPILER % 100, 0)
+#endif
+
+#if defined(JSON_HEDLEY_INTEL_VERSION_CHECK)
+    #undef JSON_HEDLEY_INTEL_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_INTEL_VERSION)
+    #define JSON_HEDLEY_INTEL_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_INTEL_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_INTEL_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_INTEL_CL_VERSION)
+    #undef JSON_HEDLEY_INTEL_CL_VERSION
+#endif
+#if defined(__INTEL_COMPILER) && defined(__INTEL_COMPILER_UPDATE) && defined(__ICL)
+    #define JSON_HEDLEY_INTEL_CL_VERSION JSON_HEDLEY_VERSION_ENCODE(__INTEL_COMPILER, __INTEL_COMPILER_UPDATE, 0)
+#endif
+
+#if defined(JSON_HEDLEY_INTEL_CL_VERSION_CHECK)
+    #undef JSON_HEDLEY_INTEL_CL_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_INTEL_CL_VERSION)
+    #define JSON_HEDLEY_INTEL_CL_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_INTEL_CL_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_INTEL_CL_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_PGI_VERSION)
+    #undef JSON_HEDLEY_PGI_VERSION
+#endif
+#if defined(__PGI) && defined(__PGIC__) && defined(__PGIC_MINOR__) && defined(__PGIC_PATCHLEVEL__)
+    #define JSON_HEDLEY_PGI_VERSION JSON_HEDLEY_VERSION_ENCODE(__PGIC__, __PGIC_MINOR__, __PGIC_PATCHLEVEL__)
+#endif
+
+#if defined(JSON_HEDLEY_PGI_VERSION_CHECK)
+    #undef JSON_HEDLEY_PGI_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_PGI_VERSION)
+    #define JSON_HEDLEY_PGI_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_PGI_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_PGI_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_SUNPRO_VERSION)
+    #undef JSON_HEDLEY_SUNPRO_VERSION
+#endif
+#if defined(__SUNPRO_C) && (__SUNPRO_C > 0x1000)
+    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((((__SUNPRO_C >> 16) & 0xf) * 10) + ((__SUNPRO_C >> 12) & 0xf), (((__SUNPRO_C >> 8) & 0xf) * 10) + ((__SUNPRO_C >> 4) & 0xf), (__SUNPRO_C & 0xf) * 10)
+#elif defined(__SUNPRO_C)
+    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((__SUNPRO_C >> 8) & 0xf, (__SUNPRO_C >> 4) & 0xf, (__SUNPRO_C) & 0xf)
+#elif defined(__SUNPRO_CC) && (__SUNPRO_CC > 0x1000)
+    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((((__SUNPRO_CC >> 16) & 0xf) * 10) + ((__SUNPRO_CC >> 12) & 0xf), (((__SUNPRO_CC >> 8) & 0xf) * 10) + ((__SUNPRO_CC >> 4) & 0xf), (__SUNPRO_CC & 0xf) * 10)
+#elif defined(__SUNPRO_CC)
+    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((__SUNPRO_CC >> 8) & 0xf, (__SUNPRO_CC >> 4) & 0xf, (__SUNPRO_CC) & 0xf)
+#endif
+
+#if defined(JSON_HEDLEY_SUNPRO_VERSION_CHECK)
+    #undef JSON_HEDLEY_SUNPRO_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_SUNPRO_VERSION)
+    #define JSON_HEDLEY_SUNPRO_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_SUNPRO_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_SUNPRO_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_EMSCRIPTEN_VERSION)
+    #undef JSON_HEDLEY_EMSCRIPTEN_VERSION
+#endif
+#if defined(__EMSCRIPTEN__)
+    #define JSON_HEDLEY_EMSCRIPTEN_VERSION JSON_HEDLEY_VERSION_ENCODE(__EMSCRIPTEN_major__, __EMSCRIPTEN_minor__, __EMSCRIPTEN_tiny__)
+#endif
+
+#if defined(JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK)
+    #undef JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_EMSCRIPTEN_VERSION)
+    #define JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_EMSCRIPTEN_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_ARM_VERSION)
+    #undef JSON_HEDLEY_ARM_VERSION
+#endif
+#if defined(__CC_ARM) && defined(__ARMCOMPILER_VERSION)
+    #define JSON_HEDLEY_ARM_VERSION JSON_HEDLEY_VERSION_ENCODE(__ARMCOMPILER_VERSION / 1000000, (__ARMCOMPILER_VERSION % 1000000) / 10000, (__ARMCOMPILER_VERSION % 10000) / 100)
+#elif defined(__CC_ARM) && defined(__ARMCC_VERSION)
+    #define JSON_HEDLEY_ARM_VERSION JSON_HEDLEY_VERSION_ENCODE(__ARMCC_VERSION / 1000000, (__ARMCC_VERSION % 1000000) / 10000, (__ARMCC_VERSION % 10000) / 100)
+#endif
+
+#if defined(JSON_HEDLEY_ARM_VERSION_CHECK)
+    #undef JSON_HEDLEY_ARM_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_ARM_VERSION)
+    #define JSON_HEDLEY_ARM_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_ARM_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_ARM_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_IBM_VERSION)
+    #undef JSON_HEDLEY_IBM_VERSION
+#endif
+#if defined(__ibmxl__)
+    #define JSON_HEDLEY_IBM_VERSION JSON_HEDLEY_VERSION_ENCODE(__ibmxl_version__, __ibmxl_release__, __ibmxl_modification__)
+#elif defined(__xlC__) && defined(__xlC_ver__)
+    #define JSON_HEDLEY_IBM_VERSION JSON_HEDLEY_VERSION_ENCODE(__xlC__ >> 8, __xlC__ & 0xff, (__xlC_ver__ >> 8) & 0xff)
+#elif defined(__xlC__)
+    #define JSON_HEDLEY_IBM_VERSION JSON_HEDLEY_VERSION_ENCODE(__xlC__ >> 8, __xlC__ & 0xff, 0)
+#endif
+
+#if defined(JSON_HEDLEY_IBM_VERSION_CHECK)
+    #undef JSON_HEDLEY_IBM_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_IBM_VERSION)
+    #define JSON_HEDLEY_IBM_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_IBM_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_IBM_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TI_VERSION)
+    #undef JSON_HEDLEY_TI_VERSION
+#endif
+#if \
+    defined(__TI_COMPILER_VERSION__) && \
+    ( \
+      defined(__TMS470__) || defined(__TI_ARM__) || \
+      defined(__MSP430__) || \
+      defined(__TMS320C2000__) \
+    )
+#if (__TI_COMPILER_VERSION__ >= 16000000)
+    #define JSON_HEDLEY_TI_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
+#endif
+#endif
+
+#if defined(JSON_HEDLEY_TI_VERSION_CHECK)
+    #undef JSON_HEDLEY_TI_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TI_VERSION)
+    #define JSON_HEDLEY_TI_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TI_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL2000_VERSION)
+    #undef JSON_HEDLEY_TI_CL2000_VERSION
+#endif
+#if defined(__TI_COMPILER_VERSION__) && defined(__TMS320C2000__)
+    #define JSON_HEDLEY_TI_CL2000_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL2000_VERSION_CHECK)
+    #undef JSON_HEDLEY_TI_CL2000_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TI_CL2000_VERSION)
+    #define JSON_HEDLEY_TI_CL2000_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL2000_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TI_CL2000_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL430_VERSION)
+    #undef JSON_HEDLEY_TI_CL430_VERSION
+#endif
+#if defined(__TI_COMPILER_VERSION__) && defined(__MSP430__)
+    #define JSON_HEDLEY_TI_CL430_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL430_VERSION_CHECK)
+    #undef JSON_HEDLEY_TI_CL430_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TI_CL430_VERSION)
+    #define JSON_HEDLEY_TI_CL430_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL430_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TI_CL430_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TI_ARMCL_VERSION)
+    #undef JSON_HEDLEY_TI_ARMCL_VERSION
+#endif
+#if defined(__TI_COMPILER_VERSION__) && (defined(__TMS470__) || defined(__TI_ARM__))
+    #define JSON_HEDLEY_TI_ARMCL_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
+#endif
+
+#if defined(JSON_HEDLEY_TI_ARMCL_VERSION_CHECK)
+    #undef JSON_HEDLEY_TI_ARMCL_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TI_ARMCL_VERSION)
+    #define JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_ARMCL_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL6X_VERSION)
+    #undef JSON_HEDLEY_TI_CL6X_VERSION
+#endif
+#if defined(__TI_COMPILER_VERSION__) && defined(__TMS320C6X__)
+    #define JSON_HEDLEY_TI_CL6X_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL6X_VERSION_CHECK)
+    #undef JSON_HEDLEY_TI_CL6X_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TI_CL6X_VERSION)
+    #define JSON_HEDLEY_TI_CL6X_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL6X_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TI_CL6X_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL7X_VERSION)
+    #undef JSON_HEDLEY_TI_CL7X_VERSION
+#endif
+#if defined(__TI_COMPILER_VERSION__) && defined(__C7000__)
+    #define JSON_HEDLEY_TI_CL7X_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
+#endif
+
+#if defined(JSON_HEDLEY_TI_CL7X_VERSION_CHECK)
+    #undef JSON_HEDLEY_TI_CL7X_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TI_CL7X_VERSION)
+    #define JSON_HEDLEY_TI_CL7X_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL7X_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TI_CL7X_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TI_CLPRU_VERSION)
+    #undef JSON_HEDLEY_TI_CLPRU_VERSION
+#endif
+#if defined(__TI_COMPILER_VERSION__) && defined(__PRU__)
+    #define JSON_HEDLEY_TI_CLPRU_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
+#endif
+
+#if defined(JSON_HEDLEY_TI_CLPRU_VERSION_CHECK)
+    #undef JSON_HEDLEY_TI_CLPRU_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TI_CLPRU_VERSION)
+    #define JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CLPRU_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_CRAY_VERSION)
+    #undef JSON_HEDLEY_CRAY_VERSION
+#endif
+#if defined(_CRAYC)
+    #if defined(_RELEASE_PATCHLEVEL)
+        #define JSON_HEDLEY_CRAY_VERSION JSON_HEDLEY_VERSION_ENCODE(_RELEASE_MAJOR, _RELEASE_MINOR, _RELEASE_PATCHLEVEL)
+    #else
+        #define JSON_HEDLEY_CRAY_VERSION JSON_HEDLEY_VERSION_ENCODE(_RELEASE_MAJOR, _RELEASE_MINOR, 0)
+    #endif
+#endif
+
+#if defined(JSON_HEDLEY_CRAY_VERSION_CHECK)
+    #undef JSON_HEDLEY_CRAY_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_CRAY_VERSION)
+    #define JSON_HEDLEY_CRAY_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_CRAY_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_CRAY_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_IAR_VERSION)
+    #undef JSON_HEDLEY_IAR_VERSION
+#endif
+#if defined(__IAR_SYSTEMS_ICC__)
+    #if __VER__ > 1000
+        #define JSON_HEDLEY_IAR_VERSION JSON_HEDLEY_VERSION_ENCODE((__VER__ / 1000000), ((__VER__ / 1000) % 1000), (__VER__ % 1000))
+    #else
+        #define JSON_HEDLEY_IAR_VERSION JSON_HEDLEY_VERSION_ENCODE(__VER__ / 100, __VER__ % 100, 0)
+    #endif
+#endif
+
+#if defined(JSON_HEDLEY_IAR_VERSION_CHECK)
+    #undef JSON_HEDLEY_IAR_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_IAR_VERSION)
+    #define JSON_HEDLEY_IAR_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_IAR_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_IAR_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_TINYC_VERSION)
+    #undef JSON_HEDLEY_TINYC_VERSION
+#endif
+#if defined(__TINYC__)
+    #define JSON_HEDLEY_TINYC_VERSION JSON_HEDLEY_VERSION_ENCODE(__TINYC__ / 1000, (__TINYC__ / 100) % 10, __TINYC__ % 100)
+#endif
+
+#if defined(JSON_HEDLEY_TINYC_VERSION_CHECK)
+    #undef JSON_HEDLEY_TINYC_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_TINYC_VERSION)
+    #define JSON_HEDLEY_TINYC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TINYC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_TINYC_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_DMC_VERSION)
+    #undef JSON_HEDLEY_DMC_VERSION
+#endif
+#if defined(__DMC__)
+    #define JSON_HEDLEY_DMC_VERSION JSON_HEDLEY_VERSION_ENCODE(__DMC__ >> 8, (__DMC__ >> 4) & 0xf, __DMC__ & 0xf)
+#endif
+
+#if defined(JSON_HEDLEY_DMC_VERSION_CHECK)
+    #undef JSON_HEDLEY_DMC_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_DMC_VERSION)
+    #define JSON_HEDLEY_DMC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_DMC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_DMC_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_COMPCERT_VERSION)
+    #undef JSON_HEDLEY_COMPCERT_VERSION
+#endif
+#if defined(__COMPCERT_VERSION__)
+    #define JSON_HEDLEY_COMPCERT_VERSION JSON_HEDLEY_VERSION_ENCODE(__COMPCERT_VERSION__ / 10000, (__COMPCERT_VERSION__ / 100) % 100, __COMPCERT_VERSION__ % 100)
+#endif
+
+#if defined(JSON_HEDLEY_COMPCERT_VERSION_CHECK)
+    #undef JSON_HEDLEY_COMPCERT_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_COMPCERT_VERSION)
+    #define JSON_HEDLEY_COMPCERT_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_COMPCERT_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_COMPCERT_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_PELLES_VERSION)
+    #undef JSON_HEDLEY_PELLES_VERSION
+#endif
+#if defined(__POCC__)
+    #define JSON_HEDLEY_PELLES_VERSION JSON_HEDLEY_VERSION_ENCODE(__POCC__ / 100, __POCC__ % 100, 0)
+#endif
+
+#if defined(JSON_HEDLEY_PELLES_VERSION_CHECK)
+    #undef JSON_HEDLEY_PELLES_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_PELLES_VERSION)
+    #define JSON_HEDLEY_PELLES_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_PELLES_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_PELLES_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_MCST_LCC_VERSION)
+    #undef JSON_HEDLEY_MCST_LCC_VERSION
+#endif
+#if defined(__LCC__) && defined(__LCC_MINOR__)
+    #define JSON_HEDLEY_MCST_LCC_VERSION JSON_HEDLEY_VERSION_ENCODE(__LCC__ / 100, __LCC__ % 100, __LCC_MINOR__)
+#endif
+
+#if defined(JSON_HEDLEY_MCST_LCC_VERSION_CHECK)
+    #undef JSON_HEDLEY_MCST_LCC_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_MCST_LCC_VERSION)
+    #define JSON_HEDLEY_MCST_LCC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_MCST_LCC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_MCST_LCC_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_VERSION)
+    #undef JSON_HEDLEY_GCC_VERSION
+#endif
+#if \
+    defined(JSON_HEDLEY_GNUC_VERSION) && \
+    !defined(__clang__) && \
+    !defined(JSON_HEDLEY_INTEL_VERSION) && \
+    !defined(JSON_HEDLEY_PGI_VERSION) && \
+    !defined(JSON_HEDLEY_ARM_VERSION) && \
+    !defined(JSON_HEDLEY_CRAY_VERSION) && \
+    !defined(JSON_HEDLEY_TI_VERSION) && \
+    !defined(JSON_HEDLEY_TI_ARMCL_VERSION) && \
+    !defined(JSON_HEDLEY_TI_CL430_VERSION) && \
+    !defined(JSON_HEDLEY_TI_CL2000_VERSION) && \
+    !defined(JSON_HEDLEY_TI_CL6X_VERSION) && \
+    !defined(JSON_HEDLEY_TI_CL7X_VERSION) && \
+    !defined(JSON_HEDLEY_TI_CLPRU_VERSION) && \
+    !defined(__COMPCERT__) && \
+    !defined(JSON_HEDLEY_MCST_LCC_VERSION)
+    #define JSON_HEDLEY_GCC_VERSION JSON_HEDLEY_GNUC_VERSION
+#endif
+
+#if defined(JSON_HEDLEY_GCC_VERSION_CHECK)
+    #undef JSON_HEDLEY_GCC_VERSION_CHECK
+#endif
+#if defined(JSON_HEDLEY_GCC_VERSION)
+    #define JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_GCC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
+#else
+    #define JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch) (0)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_ATTRIBUTE)
+    #undef JSON_HEDLEY_HAS_ATTRIBUTE
+#endif
+#if \
+  defined(__has_attribute) && \
+  ( \
+    (!defined(JSON_HEDLEY_IAR_VERSION) || JSON_HEDLEY_IAR_VERSION_CHECK(8,5,9)) \
+  )
+#  define JSON_HEDLEY_HAS_ATTRIBUTE(attribute) __has_attribute(attribute)
+#else
+#  define JSON_HEDLEY_HAS_ATTRIBUTE(attribute) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_HAS_ATTRIBUTE)
+    #undef JSON_HEDLEY_GNUC_HAS_ATTRIBUTE
+#endif
+#if defined(__has_attribute)
+    #define JSON_HEDLEY_GNUC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_HAS_ATTRIBUTE(attribute)
+#else
+    #define JSON_HEDLEY_GNUC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_HAS_ATTRIBUTE)
+    #undef JSON_HEDLEY_GCC_HAS_ATTRIBUTE
+#endif
+#if defined(__has_attribute)
+    #define JSON_HEDLEY_GCC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_HAS_ATTRIBUTE(attribute)
+#else
+    #define JSON_HEDLEY_GCC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_CPP_ATTRIBUTE)
+    #undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE
+#endif
+#if \
+    defined(__has_cpp_attribute) && \
+    defined(__cplusplus) && \
+    (!defined(JSON_HEDLEY_SUNPRO_VERSION) || JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0))
+    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE(attribute) __has_cpp_attribute(attribute)
+#else
+    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE(attribute) (0)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS)
+    #undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS
+#endif
+#if !defined(__cplusplus) || !defined(__has_cpp_attribute)
+    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(ns,attribute) (0)
+#elif \
+    !defined(JSON_HEDLEY_PGI_VERSION) && \
+    !defined(JSON_HEDLEY_IAR_VERSION) && \
+    (!defined(JSON_HEDLEY_SUNPRO_VERSION) || JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0)) && \
+    (!defined(JSON_HEDLEY_MSVC_VERSION) || JSON_HEDLEY_MSVC_VERSION_CHECK(19,20,0))
+    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(ns,attribute) JSON_HEDLEY_HAS_CPP_ATTRIBUTE(ns::attribute)
+#else
+    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(ns,attribute) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE)
+    #undef JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE
+#endif
+#if defined(__has_cpp_attribute) && defined(__cplusplus)
+    #define JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) __has_cpp_attribute(attribute)
+#else
+    #define JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE)
+    #undef JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE
+#endif
+#if defined(__has_cpp_attribute) && defined(__cplusplus)
+    #define JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) __has_cpp_attribute(attribute)
+#else
+    #define JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_BUILTIN)
+    #undef JSON_HEDLEY_HAS_BUILTIN
+#endif
+#if defined(__has_builtin)
+    #define JSON_HEDLEY_HAS_BUILTIN(builtin) __has_builtin(builtin)
+#else
+    #define JSON_HEDLEY_HAS_BUILTIN(builtin) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_HAS_BUILTIN)
+    #undef JSON_HEDLEY_GNUC_HAS_BUILTIN
+#endif
+#if defined(__has_builtin)
+    #define JSON_HEDLEY_GNUC_HAS_BUILTIN(builtin,major,minor,patch) __has_builtin(builtin)
+#else
+    #define JSON_HEDLEY_GNUC_HAS_BUILTIN(builtin,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_HAS_BUILTIN)
+    #undef JSON_HEDLEY_GCC_HAS_BUILTIN
+#endif
+#if defined(__has_builtin)
+    #define JSON_HEDLEY_GCC_HAS_BUILTIN(builtin,major,minor,patch) __has_builtin(builtin)
+#else
+    #define JSON_HEDLEY_GCC_HAS_BUILTIN(builtin,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_FEATURE)
+    #undef JSON_HEDLEY_HAS_FEATURE
+#endif
+#if defined(__has_feature)
+    #define JSON_HEDLEY_HAS_FEATURE(feature) __has_feature(feature)
+#else
+    #define JSON_HEDLEY_HAS_FEATURE(feature) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_HAS_FEATURE)
+    #undef JSON_HEDLEY_GNUC_HAS_FEATURE
+#endif
+#if defined(__has_feature)
+    #define JSON_HEDLEY_GNUC_HAS_FEATURE(feature,major,minor,patch) __has_feature(feature)
+#else
+    #define JSON_HEDLEY_GNUC_HAS_FEATURE(feature,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_HAS_FEATURE)
+    #undef JSON_HEDLEY_GCC_HAS_FEATURE
+#endif
+#if defined(__has_feature)
+    #define JSON_HEDLEY_GCC_HAS_FEATURE(feature,major,minor,patch) __has_feature(feature)
+#else
+    #define JSON_HEDLEY_GCC_HAS_FEATURE(feature,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_EXTENSION)
+    #undef JSON_HEDLEY_HAS_EXTENSION
+#endif
+#if defined(__has_extension)
+    #define JSON_HEDLEY_HAS_EXTENSION(extension) __has_extension(extension)
+#else
+    #define JSON_HEDLEY_HAS_EXTENSION(extension) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_HAS_EXTENSION)
+    #undef JSON_HEDLEY_GNUC_HAS_EXTENSION
+#endif
+#if defined(__has_extension)
+    #define JSON_HEDLEY_GNUC_HAS_EXTENSION(extension,major,minor,patch) __has_extension(extension)
+#else
+    #define JSON_HEDLEY_GNUC_HAS_EXTENSION(extension,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_HAS_EXTENSION)
+    #undef JSON_HEDLEY_GCC_HAS_EXTENSION
+#endif
+#if defined(__has_extension)
+    #define JSON_HEDLEY_GCC_HAS_EXTENSION(extension,major,minor,patch) __has_extension(extension)
+#else
+    #define JSON_HEDLEY_GCC_HAS_EXTENSION(extension,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE)
+    #undef JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE
+#endif
+#if defined(__has_declspec_attribute)
+    #define JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE(attribute) __has_declspec_attribute(attribute)
+#else
+    #define JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE(attribute) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE)
+    #undef JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE
+#endif
+#if defined(__has_declspec_attribute)
+    #define JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) __has_declspec_attribute(attribute)
+#else
+    #define JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE)
+    #undef JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE
+#endif
+#if defined(__has_declspec_attribute)
+    #define JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) __has_declspec_attribute(attribute)
+#else
+    #define JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_HAS_WARNING)
+    #undef JSON_HEDLEY_HAS_WARNING
+#endif
+#if defined(__has_warning)
+    #define JSON_HEDLEY_HAS_WARNING(warning) __has_warning(warning)
+#else
+    #define JSON_HEDLEY_HAS_WARNING(warning) (0)
+#endif
+
+#if defined(JSON_HEDLEY_GNUC_HAS_WARNING)
+    #undef JSON_HEDLEY_GNUC_HAS_WARNING
+#endif
+#if defined(__has_warning)
+    #define JSON_HEDLEY_GNUC_HAS_WARNING(warning,major,minor,patch) __has_warning(warning)
+#else
+    #define JSON_HEDLEY_GNUC_HAS_WARNING(warning,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_GCC_HAS_WARNING)
+    #undef JSON_HEDLEY_GCC_HAS_WARNING
+#endif
+#if defined(__has_warning)
+    #define JSON_HEDLEY_GCC_HAS_WARNING(warning,major,minor,patch) __has_warning(warning)
+#else
+    #define JSON_HEDLEY_GCC_HAS_WARNING(warning,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if \
+    (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L)) || \
+    defined(__clang__) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,0,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0) || \
+    JSON_HEDLEY_PGI_VERSION_CHECK(18,4,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,7,0) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(2,0,1) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,1,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,0,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_CRAY_VERSION_CHECK(5,0,0) || \
+    JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,17) || \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(8,0,0) || \
+    (JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) && defined(__C99_PRAGMA_OPERATOR))
+    #define JSON_HEDLEY_PRAGMA(value) _Pragma(#value)
+#elif JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0)
+    #define JSON_HEDLEY_PRAGMA(value) __pragma(value)
+#else
+    #define JSON_HEDLEY_PRAGMA(value)
+#endif
+
+#if defined(JSON_HEDLEY_DIAGNOSTIC_PUSH)
+    #undef JSON_HEDLEY_DIAGNOSTIC_PUSH
+#endif
+#if defined(JSON_HEDLEY_DIAGNOSTIC_POP)
+    #undef JSON_HEDLEY_DIAGNOSTIC_POP
+#endif
+#if defined(__clang__)
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("clang diagnostic push")
+    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("clang diagnostic pop")
+#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("warning(push)")
+    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("warning(pop)")
+#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,6,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("GCC diagnostic push")
+    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("GCC diagnostic pop")
+#elif \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH __pragma(warning(push))
+    #define JSON_HEDLEY_DIAGNOSTIC_POP __pragma(warning(pop))
+#elif JSON_HEDLEY_ARM_VERSION_CHECK(5,6,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("push")
+    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("pop")
+#elif \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,4,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,1,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("diag_push")
+    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("diag_pop")
+#elif JSON_HEDLEY_PELLES_VERSION_CHECK(2,90,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("warning(push)")
+    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("warning(pop)")
+#else
+    #define JSON_HEDLEY_DIAGNOSTIC_PUSH
+    #define JSON_HEDLEY_DIAGNOSTIC_POP
+#endif
+
+/* JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_ is for
+   HEDLEY INTERNAL USE ONLY.  API subject to change without notice. */
+#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_)
+    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_
+#endif
+#if defined(__cplusplus)
+#  if JSON_HEDLEY_HAS_WARNING("-Wc++98-compat")
+#    if JSON_HEDLEY_HAS_WARNING("-Wc++17-extensions")
+#      if JSON_HEDLEY_HAS_WARNING("-Wc++1z-extensions")
+#        define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(xpr) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    _Pragma("clang diagnostic ignored \"-Wc++98-compat\"") \
+    _Pragma("clang diagnostic ignored \"-Wc++17-extensions\"") \
+    _Pragma("clang diagnostic ignored \"-Wc++1z-extensions\"") \
+    xpr \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#      else
+#        define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(xpr) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    _Pragma("clang diagnostic ignored \"-Wc++98-compat\"") \
+    _Pragma("clang diagnostic ignored \"-Wc++17-extensions\"") \
+    xpr \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#      endif
+#    else
+#      define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(xpr) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    _Pragma("clang diagnostic ignored \"-Wc++98-compat\"") \
+    xpr \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#    endif
+#  endif
+#endif
+#if !defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(x) x
+#endif
+
+#if defined(JSON_HEDLEY_CONST_CAST)
+    #undef JSON_HEDLEY_CONST_CAST
+#endif
+#if defined(__cplusplus)
+#  define JSON_HEDLEY_CONST_CAST(T, expr) (const_cast<T>(expr))
+#elif \
+  JSON_HEDLEY_HAS_WARNING("-Wcast-qual") || \
+  JSON_HEDLEY_GCC_VERSION_CHECK(4,6,0) || \
+  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
+#  define JSON_HEDLEY_CONST_CAST(T, expr) (__extension__ ({ \
+        JSON_HEDLEY_DIAGNOSTIC_PUSH \
+        JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL \
+        ((T) (expr)); \
+        JSON_HEDLEY_DIAGNOSTIC_POP \
+    }))
+#else
+#  define JSON_HEDLEY_CONST_CAST(T, expr) ((T) (expr))
+#endif
+
+#if defined(JSON_HEDLEY_REINTERPRET_CAST)
+    #undef JSON_HEDLEY_REINTERPRET_CAST
+#endif
+#if defined(__cplusplus)
+    #define JSON_HEDLEY_REINTERPRET_CAST(T, expr) (reinterpret_cast<T>(expr))
+#else
+    #define JSON_HEDLEY_REINTERPRET_CAST(T, expr) ((T) (expr))
+#endif
+
+#if defined(JSON_HEDLEY_STATIC_CAST)
+    #undef JSON_HEDLEY_STATIC_CAST
+#endif
+#if defined(__cplusplus)
+    #define JSON_HEDLEY_STATIC_CAST(T, expr) (static_cast<T>(expr))
+#else
+    #define JSON_HEDLEY_STATIC_CAST(T, expr) ((T) (expr))
+#endif
+
+#if defined(JSON_HEDLEY_CPP_CAST)
+    #undef JSON_HEDLEY_CPP_CAST
+#endif
+#if defined(__cplusplus)
+#  if JSON_HEDLEY_HAS_WARNING("-Wold-style-cast")
+#    define JSON_HEDLEY_CPP_CAST(T, expr) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    _Pragma("clang diagnostic ignored \"-Wold-style-cast\"") \
+    ((T) (expr)) \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#  elif JSON_HEDLEY_IAR_VERSION_CHECK(8,3,0)
+#    define JSON_HEDLEY_CPP_CAST(T, expr) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    _Pragma("diag_suppress=Pe137") \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#  else
+#    define JSON_HEDLEY_CPP_CAST(T, expr) ((T) (expr))
+#  endif
+#else
+#  define JSON_HEDLEY_CPP_CAST(T, expr) (expr)
+#endif
+
+#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED)
+    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wdeprecated-declarations")
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("clang diagnostic ignored \"-Wdeprecated-declarations\"")
+#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("warning(disable:1478 1786)")
+#elif JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED __pragma(warning(disable:1478 1786))
+#elif JSON_HEDLEY_PGI_VERSION_CHECK(20,7,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1215,1216,1444,1445")
+#elif JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1215,1444")
+#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,3,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("GCC diagnostic ignored \"-Wdeprecated-declarations\"")
+#elif JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED __pragma(warning(disable:4996))
+#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1215,1444")
+#elif \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1291,1718")
+#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,13,0) && !defined(__cplusplus)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("error_messages(off,E_DEPRECATED_ATT,E_DEPRECATED_ATT_MESS)")
+#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,13,0) && defined(__cplusplus)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("error_messages(off,symdeprecated,symdeprecated2)")
+#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress=Pe1444,Pe1215")
+#elif JSON_HEDLEY_PELLES_VERSION_CHECK(2,90,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("warn(disable:2241)")
+#else
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED
+#endif
+
+#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS)
+    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wunknown-pragmas")
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("clang diagnostic ignored \"-Wunknown-pragmas\"")
+#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("warning(disable:161)")
+#elif JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS __pragma(warning(disable:161))
+#elif JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 1675")
+#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,3,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("GCC diagnostic ignored \"-Wunknown-pragmas\"")
+#elif JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS __pragma(warning(disable:4068))
+#elif \
+    JSON_HEDLEY_TI_VERSION_CHECK(16,9,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,0,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,3,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 163")
+#elif JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 163")
+#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress=Pe161")
+#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 161")
+#else
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS
+#endif
+
+#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES)
+    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wunknown-attributes")
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("clang diagnostic ignored \"-Wunknown-attributes\"")
+#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,6,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("GCC diagnostic ignored \"-Wdeprecated-declarations\"")
+#elif JSON_HEDLEY_INTEL_VERSION_CHECK(17,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("warning(disable:1292)")
+#elif JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES __pragma(warning(disable:1292))
+#elif JSON_HEDLEY_MSVC_VERSION_CHECK(19,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES __pragma(warning(disable:5030))
+#elif JSON_HEDLEY_PGI_VERSION_CHECK(20,7,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1097,1098")
+#elif JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1097")
+#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,14,0) && defined(__cplusplus)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("error_messages(off,attrskipunsup)")
+#elif \
+    JSON_HEDLEY_TI_VERSION_CHECK(18,1,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,3,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1173")
+#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress=Pe1097")
+#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1097")
+#else
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES
+#endif
+
+#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL)
+    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wcast-qual")
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL _Pragma("clang diagnostic ignored \"-Wcast-qual\"")
+#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL _Pragma("warning(disable:2203 2331)")
+#elif JSON_HEDLEY_GCC_VERSION_CHECK(3,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL _Pragma("GCC diagnostic ignored \"-Wcast-qual\"")
+#else
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL
+#endif
+
+#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION)
+    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wunused-function")
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION _Pragma("clang diagnostic ignored \"-Wunused-function\"")
+#elif JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION _Pragma("GCC diagnostic ignored \"-Wunused-function\"")
+#elif JSON_HEDLEY_MSVC_VERSION_CHECK(1,0,0)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION __pragma(warning(disable:4505))
+#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION _Pragma("diag_suppress 3142")
+#else
+    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION
+#endif
+
+#if defined(JSON_HEDLEY_DEPRECATED)
+    #undef JSON_HEDLEY_DEPRECATED
+#endif
+#if defined(JSON_HEDLEY_DEPRECATED_FOR)
+    #undef JSON_HEDLEY_DEPRECATED_FOR
+#endif
+#if \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(14,0,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_DEPRECATED(since) __declspec(deprecated("Since " # since))
+    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __declspec(deprecated("Since " #since "; use " #replacement))
+#elif \
+    (JSON_HEDLEY_HAS_EXTENSION(attribute_deprecated_with_message) && !defined(JSON_HEDLEY_IAR_VERSION)) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(4,5,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(5,6,0) || \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,13,0) || \
+    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(18,1,0) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(18,1,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,3,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,3,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_DEPRECATED(since) __attribute__((__deprecated__("Since " #since)))
+    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __attribute__((__deprecated__("Since " #since "; use " #replacement)))
+#elif defined(__cplusplus) && (__cplusplus >= 201402L)
+    #define JSON_HEDLEY_DEPRECATED(since) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[deprecated("Since " #since)]])
+    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[deprecated("Since " #since "; use " #replacement)]])
+#elif \
+    JSON_HEDLEY_HAS_ATTRIBUTE(deprecated) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10) || \
+    JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
+    #define JSON_HEDLEY_DEPRECATED(since) __attribute__((__deprecated__))
+    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __attribute__((__deprecated__))
+#elif \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
+    JSON_HEDLEY_PELLES_VERSION_CHECK(6,50,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_DEPRECATED(since) __declspec(deprecated)
+    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __declspec(deprecated)
+#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+    #define JSON_HEDLEY_DEPRECATED(since) _Pragma("deprecated")
+    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) _Pragma("deprecated")
+#else
+    #define JSON_HEDLEY_DEPRECATED(since)
+    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement)
+#endif
+
+#if defined(JSON_HEDLEY_UNAVAILABLE)
+    #undef JSON_HEDLEY_UNAVAILABLE
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(warning) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(4,3,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_UNAVAILABLE(available_since) __attribute__((__warning__("Not available until " #available_since)))
+#else
+    #define JSON_HEDLEY_UNAVAILABLE(available_since)
+#endif
+
+#if defined(JSON_HEDLEY_WARN_UNUSED_RESULT)
+    #undef JSON_HEDLEY_WARN_UNUSED_RESULT
+#endif
+#if defined(JSON_HEDLEY_WARN_UNUSED_RESULT_MSG)
+    #undef JSON_HEDLEY_WARN_UNUSED_RESULT_MSG
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(warn_unused_result) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0) && defined(__cplusplus)) || \
+    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT __attribute__((__warn_unused_result__))
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) __attribute__((__warn_unused_result__))
+#elif (JSON_HEDLEY_HAS_CPP_ATTRIBUTE(nodiscard) >= 201907L)
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard]])
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard(msg)]])
+#elif JSON_HEDLEY_HAS_CPP_ATTRIBUTE(nodiscard)
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard]])
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard]])
+#elif defined(_Check_return_) /* SAL */
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT _Check_return_
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) _Check_return_
+#else
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT
+    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg)
+#endif
+
+#if defined(JSON_HEDLEY_SENTINEL)
+    #undef JSON_HEDLEY_SENTINEL
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(sentinel) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(4,0,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(5,4,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_SENTINEL(position) __attribute__((__sentinel__(position)))
+#else
+    #define JSON_HEDLEY_SENTINEL(position)
+#endif
+
+#if defined(JSON_HEDLEY_NO_RETURN)
+    #undef JSON_HEDLEY_NO_RETURN
+#endif
+#if JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+    #define JSON_HEDLEY_NO_RETURN __noreturn
+#elif \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_NO_RETURN __attribute__((__noreturn__))
+#elif defined(__STDC_VERSION__) && __STDC_VERSION__ >= 201112L
+    #define JSON_HEDLEY_NO_RETURN _Noreturn
+#elif defined(__cplusplus) && (__cplusplus >= 201103L)
+    #define JSON_HEDLEY_NO_RETURN JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[noreturn]])
+#elif \
+    JSON_HEDLEY_HAS_ATTRIBUTE(noreturn) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,2,0) || \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
+    #define JSON_HEDLEY_NO_RETURN __attribute__((__noreturn__))
+#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
+    #define JSON_HEDLEY_NO_RETURN _Pragma("does_not_return")
+#elif \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_NO_RETURN __declspec(noreturn)
+#elif JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,0,0) && defined(__cplusplus)
+    #define JSON_HEDLEY_NO_RETURN _Pragma("FUNC_NEVER_RETURNS;")
+#elif JSON_HEDLEY_COMPCERT_VERSION_CHECK(3,2,0)
+    #define JSON_HEDLEY_NO_RETURN __attribute((noreturn))
+#elif JSON_HEDLEY_PELLES_VERSION_CHECK(9,0,0)
+    #define JSON_HEDLEY_NO_RETURN __declspec(noreturn)
+#else
+    #define JSON_HEDLEY_NO_RETURN
+#endif
+
+#if defined(JSON_HEDLEY_NO_ESCAPE)
+    #undef JSON_HEDLEY_NO_ESCAPE
+#endif
+#if JSON_HEDLEY_HAS_ATTRIBUTE(noescape)
+    #define JSON_HEDLEY_NO_ESCAPE __attribute__((__noescape__))
+#else
+    #define JSON_HEDLEY_NO_ESCAPE
+#endif
+
+#if defined(JSON_HEDLEY_UNREACHABLE)
+    #undef JSON_HEDLEY_UNREACHABLE
+#endif
+#if defined(JSON_HEDLEY_UNREACHABLE_RETURN)
+    #undef JSON_HEDLEY_UNREACHABLE_RETURN
+#endif
+#if defined(JSON_HEDLEY_ASSUME)
+    #undef JSON_HEDLEY_ASSUME
+#endif
+#if \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_ASSUME(expr) __assume(expr)
+#elif JSON_HEDLEY_HAS_BUILTIN(__builtin_assume)
+    #define JSON_HEDLEY_ASSUME(expr) __builtin_assume(expr)
+#elif \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(4,0,0)
+    #if defined(__cplusplus)
+        #define JSON_HEDLEY_ASSUME(expr) std::_nassert(expr)
+    #else
+        #define JSON_HEDLEY_ASSUME(expr) _nassert(expr)
+    #endif
+#endif
+#if \
+    (JSON_HEDLEY_HAS_BUILTIN(__builtin_unreachable) && (!defined(JSON_HEDLEY_ARM_VERSION))) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(4,5,0) || \
+    JSON_HEDLEY_PGI_VERSION_CHECK(18,10,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(13,1,5) || \
+    JSON_HEDLEY_CRAY_VERSION_CHECK(10,0,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_UNREACHABLE() __builtin_unreachable()
+#elif defined(JSON_HEDLEY_ASSUME)
+    #define JSON_HEDLEY_UNREACHABLE() JSON_HEDLEY_ASSUME(0)
+#endif
+#if !defined(JSON_HEDLEY_ASSUME)
+    #if defined(JSON_HEDLEY_UNREACHABLE)
+        #define JSON_HEDLEY_ASSUME(expr) JSON_HEDLEY_STATIC_CAST(void, ((expr) ? 1 : (JSON_HEDLEY_UNREACHABLE(), 1)))
+    #else
+        #define JSON_HEDLEY_ASSUME(expr) JSON_HEDLEY_STATIC_CAST(void, expr)
+    #endif
+#endif
+#if defined(JSON_HEDLEY_UNREACHABLE)
+    #if  \
+        JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,0) || \
+        JSON_HEDLEY_TI_CL6X_VERSION_CHECK(4,0,0)
+        #define JSON_HEDLEY_UNREACHABLE_RETURN(value) return (JSON_HEDLEY_STATIC_CAST(void, JSON_HEDLEY_ASSUME(0)), (value))
+    #else
+        #define JSON_HEDLEY_UNREACHABLE_RETURN(value) JSON_HEDLEY_UNREACHABLE()
+    #endif
+#else
+    #define JSON_HEDLEY_UNREACHABLE_RETURN(value) return (value)
+#endif
+#if !defined(JSON_HEDLEY_UNREACHABLE)
+    #define JSON_HEDLEY_UNREACHABLE() JSON_HEDLEY_ASSUME(0)
+#endif
+
+JSON_HEDLEY_DIAGNOSTIC_PUSH
+#if JSON_HEDLEY_HAS_WARNING("-Wpedantic")
+    #pragma clang diagnostic ignored "-Wpedantic"
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wc++98-compat-pedantic") && defined(__cplusplus)
+    #pragma clang diagnostic ignored "-Wc++98-compat-pedantic"
+#endif
+#if JSON_HEDLEY_GCC_HAS_WARNING("-Wvariadic-macros",4,0,0)
+    #if defined(__clang__)
+        #pragma clang diagnostic ignored "-Wvariadic-macros"
+    #elif defined(JSON_HEDLEY_GCC_VERSION)
+        #pragma GCC diagnostic ignored "-Wvariadic-macros"
+    #endif
+#endif
+#if defined(JSON_HEDLEY_NON_NULL)
+    #undef JSON_HEDLEY_NON_NULL
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(nonnull) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,3,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0)
+    #define JSON_HEDLEY_NON_NULL(...) __attribute__((__nonnull__(__VA_ARGS__)))
+#else
+    #define JSON_HEDLEY_NON_NULL(...)
+#endif
+JSON_HEDLEY_DIAGNOSTIC_POP
+
+#if defined(JSON_HEDLEY_PRINTF_FORMAT)
+    #undef JSON_HEDLEY_PRINTF_FORMAT
+#endif
+#if defined(__MINGW32__) && JSON_HEDLEY_GCC_HAS_ATTRIBUTE(format,4,4,0) && !defined(__USE_MINGW_ANSI_STDIO)
+    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __attribute__((__format__(ms_printf, string_idx, first_to_check)))
+#elif defined(__MINGW32__) && JSON_HEDLEY_GCC_HAS_ATTRIBUTE(format,4,4,0) && defined(__USE_MINGW_ANSI_STDIO)
+    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __attribute__((__format__(gnu_printf, string_idx, first_to_check)))
+#elif \
+    JSON_HEDLEY_HAS_ATTRIBUTE(format) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(5,6,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __attribute__((__format__(__printf__, string_idx, first_to_check)))
+#elif JSON_HEDLEY_PELLES_VERSION_CHECK(6,0,0)
+    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __declspec(vaformat(printf,string_idx,first_to_check))
+#else
+    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check)
+#endif
+
+#if defined(JSON_HEDLEY_CONSTEXPR)
+    #undef JSON_HEDLEY_CONSTEXPR
+#endif
+#if defined(__cplusplus)
+    #if __cplusplus >= 201103L
+        #define JSON_HEDLEY_CONSTEXPR JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(constexpr)
+    #endif
+#endif
+#if !defined(JSON_HEDLEY_CONSTEXPR)
+    #define JSON_HEDLEY_CONSTEXPR
+#endif
+
+#if defined(JSON_HEDLEY_PREDICT)
+    #undef JSON_HEDLEY_PREDICT
+#endif
+#if defined(JSON_HEDLEY_LIKELY)
+    #undef JSON_HEDLEY_LIKELY
+#endif
+#if defined(JSON_HEDLEY_UNLIKELY)
+    #undef JSON_HEDLEY_UNLIKELY
+#endif
+#if defined(JSON_HEDLEY_UNPREDICTABLE)
+    #undef JSON_HEDLEY_UNPREDICTABLE
+#endif
+#if JSON_HEDLEY_HAS_BUILTIN(__builtin_unpredictable)
+    #define JSON_HEDLEY_UNPREDICTABLE(expr) __builtin_unpredictable((expr))
+#endif
+#if \
+  (JSON_HEDLEY_HAS_BUILTIN(__builtin_expect_with_probability) && !defined(JSON_HEDLEY_PGI_VERSION)) || \
+  JSON_HEDLEY_GCC_VERSION_CHECK(9,0,0) || \
+  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+#  define JSON_HEDLEY_PREDICT(expr, value, probability) __builtin_expect_with_probability(  (expr), (value), (probability))
+#  define JSON_HEDLEY_PREDICT_TRUE(expr, probability)   __builtin_expect_with_probability(!!(expr),    1   , (probability))
+#  define JSON_HEDLEY_PREDICT_FALSE(expr, probability)  __builtin_expect_with_probability(!!(expr),    0   , (probability))
+#  define JSON_HEDLEY_LIKELY(expr)                      __builtin_expect                 (!!(expr),    1                  )
+#  define JSON_HEDLEY_UNLIKELY(expr)                    __builtin_expect                 (!!(expr),    0                  )
+#elif \
+  (JSON_HEDLEY_HAS_BUILTIN(__builtin_expect) && !defined(JSON_HEDLEY_INTEL_CL_VERSION)) || \
+  JSON_HEDLEY_GCC_VERSION_CHECK(3,0,0) || \
+  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+  (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0) && defined(__cplusplus)) || \
+  JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+  JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+  JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+  JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,7,0) || \
+  JSON_HEDLEY_TI_CL430_VERSION_CHECK(3,1,0) || \
+  JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,1,0) || \
+  JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,1,0) || \
+  JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+  JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+  JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,27) || \
+  JSON_HEDLEY_CRAY_VERSION_CHECK(8,1,0) || \
+  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+#  define JSON_HEDLEY_PREDICT(expr, expected, probability) \
+    (((probability) >= 0.9) ? __builtin_expect((expr), (expected)) : (JSON_HEDLEY_STATIC_CAST(void, expected), (expr)))
+#  define JSON_HEDLEY_PREDICT_TRUE(expr, probability) \
+    (__extension__ ({ \
+        double hedley_probability_ = (probability); \
+        ((hedley_probability_ >= 0.9) ? __builtin_expect(!!(expr), 1) : ((hedley_probability_ <= 0.1) ? __builtin_expect(!!(expr), 0) : !!(expr))); \
+    }))
+#  define JSON_HEDLEY_PREDICT_FALSE(expr, probability) \
+    (__extension__ ({ \
+        double hedley_probability_ = (probability); \
+        ((hedley_probability_ >= 0.9) ? __builtin_expect(!!(expr), 0) : ((hedley_probability_ <= 0.1) ? __builtin_expect(!!(expr), 1) : !!(expr))); \
+    }))
+#  define JSON_HEDLEY_LIKELY(expr)   __builtin_expect(!!(expr), 1)
+#  define JSON_HEDLEY_UNLIKELY(expr) __builtin_expect(!!(expr), 0)
+#else
+#  define JSON_HEDLEY_PREDICT(expr, expected, probability) (JSON_HEDLEY_STATIC_CAST(void, expected), (expr))
+#  define JSON_HEDLEY_PREDICT_TRUE(expr, probability) (!!(expr))
+#  define JSON_HEDLEY_PREDICT_FALSE(expr, probability) (!!(expr))
+#  define JSON_HEDLEY_LIKELY(expr) (!!(expr))
+#  define JSON_HEDLEY_UNLIKELY(expr) (!!(expr))
+#endif
+#if !defined(JSON_HEDLEY_UNPREDICTABLE)
+    #define JSON_HEDLEY_UNPREDICTABLE(expr) JSON_HEDLEY_PREDICT(expr, 1, 0.5)
+#endif
+
+#if defined(JSON_HEDLEY_MALLOC)
+    #undef JSON_HEDLEY_MALLOC
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(malloc) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(12,1,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_MALLOC __attribute__((__malloc__))
+#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
+    #define JSON_HEDLEY_MALLOC _Pragma("returns_new_memory")
+#elif \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(14,0,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_MALLOC __declspec(restrict)
+#else
+    #define JSON_HEDLEY_MALLOC
+#endif
+
+#if defined(JSON_HEDLEY_PURE)
+    #undef JSON_HEDLEY_PURE
+#endif
+#if \
+  JSON_HEDLEY_HAS_ATTRIBUTE(pure) || \
+  JSON_HEDLEY_GCC_VERSION_CHECK(2,96,0) || \
+  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+  JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
+  JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+  JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+  JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+  (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+  (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+  (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+  (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+  JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+  JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+  JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
+  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+#  define JSON_HEDLEY_PURE __attribute__((__pure__))
+#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
+#  define JSON_HEDLEY_PURE _Pragma("does_not_write_global_data")
+#elif defined(__cplusplus) && \
+    ( \
+      JSON_HEDLEY_TI_CL430_VERSION_CHECK(2,0,1) || \
+      JSON_HEDLEY_TI_CL6X_VERSION_CHECK(4,0,0) || \
+      JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) \
+    )
+#  define JSON_HEDLEY_PURE _Pragma("FUNC_IS_PURE;")
+#else
+#  define JSON_HEDLEY_PURE
+#endif
+
+#if defined(JSON_HEDLEY_CONST)
+    #undef JSON_HEDLEY_CONST
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(const) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(2,5,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_CONST __attribute__((__const__))
+#elif \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
+    #define JSON_HEDLEY_CONST _Pragma("no_side_effect")
+#else
+    #define JSON_HEDLEY_CONST JSON_HEDLEY_PURE
+#endif
+
+#if defined(JSON_HEDLEY_RESTRICT)
+    #undef JSON_HEDLEY_RESTRICT
+#endif
+#if defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L) && !defined(__cplusplus)
+    #define JSON_HEDLEY_RESTRICT restrict
+#elif \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(14,0,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,4) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,1,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,14,0) && defined(__cplusplus)) || \
+    JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0) || \
+    defined(__clang__) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_RESTRICT __restrict
+#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,3,0) && !defined(__cplusplus)
+    #define JSON_HEDLEY_RESTRICT _Restrict
+#else
+    #define JSON_HEDLEY_RESTRICT
+#endif
+
+#if defined(JSON_HEDLEY_INLINE)
+    #undef JSON_HEDLEY_INLINE
+#endif
+#if \
+    (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L)) || \
+    (defined(__cplusplus) && (__cplusplus >= 199711L))
+    #define JSON_HEDLEY_INLINE inline
+#elif \
+    defined(JSON_HEDLEY_GCC_VERSION) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(6,2,0)
+    #define JSON_HEDLEY_INLINE __inline__
+#elif \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(12,0,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,1,0) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(3,1,0) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,0,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_INLINE __inline
+#else
+    #define JSON_HEDLEY_INLINE
+#endif
+
+#if defined(JSON_HEDLEY_ALWAYS_INLINE)
+    #undef JSON_HEDLEY_ALWAYS_INLINE
+#endif
+#if \
+  JSON_HEDLEY_HAS_ATTRIBUTE(always_inline) || \
+  JSON_HEDLEY_GCC_VERSION_CHECK(4,0,0) || \
+  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+  JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
+  JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+  JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+  JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+  (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+  (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+  (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+  (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+  JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+  JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+  JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10) || \
+  JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
+#  define JSON_HEDLEY_ALWAYS_INLINE __attribute__((__always_inline__)) JSON_HEDLEY_INLINE
+#elif \
+  JSON_HEDLEY_MSVC_VERSION_CHECK(12,0,0) || \
+  JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+#  define JSON_HEDLEY_ALWAYS_INLINE __forceinline
+#elif defined(__cplusplus) && \
+    ( \
+      JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+      JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+      JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+      JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,1,0) || \
+      JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+      JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) \
+    )
+#  define JSON_HEDLEY_ALWAYS_INLINE _Pragma("FUNC_ALWAYS_INLINE;")
+#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+#  define JSON_HEDLEY_ALWAYS_INLINE _Pragma("inline=forced")
+#else
+#  define JSON_HEDLEY_ALWAYS_INLINE JSON_HEDLEY_INLINE
+#endif
+
+#if defined(JSON_HEDLEY_NEVER_INLINE)
+    #undef JSON_HEDLEY_NEVER_INLINE
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(noinline) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(4,0,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
+    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
+    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
+    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
+    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
+    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
+    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
+    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10) || \
+    JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
+    #define JSON_HEDLEY_NEVER_INLINE __attribute__((__noinline__))
+#elif \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_NEVER_INLINE __declspec(noinline)
+#elif JSON_HEDLEY_PGI_VERSION_CHECK(10,2,0)
+    #define JSON_HEDLEY_NEVER_INLINE _Pragma("noinline")
+#elif JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,0,0) && defined(__cplusplus)
+    #define JSON_HEDLEY_NEVER_INLINE _Pragma("FUNC_CANNOT_INLINE;")
+#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+    #define JSON_HEDLEY_NEVER_INLINE _Pragma("inline=never")
+#elif JSON_HEDLEY_COMPCERT_VERSION_CHECK(3,2,0)
+    #define JSON_HEDLEY_NEVER_INLINE __attribute((noinline))
+#elif JSON_HEDLEY_PELLES_VERSION_CHECK(9,0,0)
+    #define JSON_HEDLEY_NEVER_INLINE __declspec(noinline)
+#else
+    #define JSON_HEDLEY_NEVER_INLINE
+#endif
+
+#if defined(JSON_HEDLEY_PRIVATE)
+    #undef JSON_HEDLEY_PRIVATE
+#endif
+#if defined(JSON_HEDLEY_PUBLIC)
+    #undef JSON_HEDLEY_PUBLIC
+#endif
+#if defined(JSON_HEDLEY_IMPORT)
+    #undef JSON_HEDLEY_IMPORT
+#endif
+#if defined(_WIN32) || defined(__CYGWIN__)
+#  define JSON_HEDLEY_PRIVATE
+#  define JSON_HEDLEY_PUBLIC   __declspec(dllexport)
+#  define JSON_HEDLEY_IMPORT   __declspec(dllimport)
+#else
+#  if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(visibility) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,3,0) || \
+    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(13,1,0) || \
+    ( \
+      defined(__TI_EABI__) && \
+      ( \
+        (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
+        JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) \
+      ) \
+    ) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+#    define JSON_HEDLEY_PRIVATE __attribute__((__visibility__("hidden")))
+#    define JSON_HEDLEY_PUBLIC  __attribute__((__visibility__("default")))
+#  else
+#    define JSON_HEDLEY_PRIVATE
+#    define JSON_HEDLEY_PUBLIC
+#  endif
+#  define JSON_HEDLEY_IMPORT    extern
+#endif
+
+#if defined(JSON_HEDLEY_NO_THROW)
+    #undef JSON_HEDLEY_NO_THROW
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(nothrow) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,3,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_NO_THROW __attribute__((__nothrow__))
+#elif \
+    JSON_HEDLEY_MSVC_VERSION_CHECK(13,1,0) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0)
+    #define JSON_HEDLEY_NO_THROW __declspec(nothrow)
+#else
+    #define JSON_HEDLEY_NO_THROW
+#endif
+
+#if defined(JSON_HEDLEY_FALL_THROUGH)
+    #undef JSON_HEDLEY_FALL_THROUGH
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(fallthrough) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(7,0,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_FALL_THROUGH __attribute__((__fallthrough__))
+#elif JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(clang,fallthrough)
+    #define JSON_HEDLEY_FALL_THROUGH JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[clang::fallthrough]])
+#elif JSON_HEDLEY_HAS_CPP_ATTRIBUTE(fallthrough)
+    #define JSON_HEDLEY_FALL_THROUGH JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[fallthrough]])
+#elif defined(__fallthrough) /* SAL */
+    #define JSON_HEDLEY_FALL_THROUGH __fallthrough
+#else
+    #define JSON_HEDLEY_FALL_THROUGH
+#endif
+
+#if defined(JSON_HEDLEY_RETURNS_NON_NULL)
+    #undef JSON_HEDLEY_RETURNS_NON_NULL
+#endif
+#if \
+    JSON_HEDLEY_HAS_ATTRIBUTE(returns_nonnull) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(4,9,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_RETURNS_NON_NULL __attribute__((__returns_nonnull__))
+#elif defined(_Ret_notnull_) /* SAL */
+    #define JSON_HEDLEY_RETURNS_NON_NULL _Ret_notnull_
+#else
+    #define JSON_HEDLEY_RETURNS_NON_NULL
+#endif
+
+#if defined(JSON_HEDLEY_ARRAY_PARAM)
+    #undef JSON_HEDLEY_ARRAY_PARAM
+#endif
+#if \
+    defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L) && \
+    !defined(__STDC_NO_VLA__) && \
+    !defined(__cplusplus) && \
+    !defined(JSON_HEDLEY_PGI_VERSION) && \
+    !defined(JSON_HEDLEY_TINYC_VERSION)
+    #define JSON_HEDLEY_ARRAY_PARAM(name) (name)
+#else
+    #define JSON_HEDLEY_ARRAY_PARAM(name)
+#endif
+
+#if defined(JSON_HEDLEY_IS_CONSTANT)
+    #undef JSON_HEDLEY_IS_CONSTANT
+#endif
+#if defined(JSON_HEDLEY_REQUIRE_CONSTEXPR)
+    #undef JSON_HEDLEY_REQUIRE_CONSTEXPR
+#endif
+/* JSON_HEDLEY_IS_CONSTEXPR_ is for
+   HEDLEY INTERNAL USE ONLY.  API subject to change without notice. */
+#if defined(JSON_HEDLEY_IS_CONSTEXPR_)
+    #undef JSON_HEDLEY_IS_CONSTEXPR_
+#endif
+#if \
+    JSON_HEDLEY_HAS_BUILTIN(__builtin_constant_p) || \
+    JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0) || \
+    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+    JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,19) || \
+    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
+    JSON_HEDLEY_IBM_VERSION_CHECK(13,1,0) || \
+    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,1,0) || \
+    (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0) && !defined(__cplusplus)) || \
+    JSON_HEDLEY_CRAY_VERSION_CHECK(8,1,0) || \
+    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
+    #define JSON_HEDLEY_IS_CONSTANT(expr) __builtin_constant_p(expr)
+#endif
+#if !defined(__cplusplus)
+#  if \
+       JSON_HEDLEY_HAS_BUILTIN(__builtin_types_compatible_p) || \
+       JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0) || \
+       JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+       JSON_HEDLEY_IBM_VERSION_CHECK(13,1,0) || \
+       JSON_HEDLEY_CRAY_VERSION_CHECK(8,1,0) || \
+       JSON_HEDLEY_ARM_VERSION_CHECK(5,4,0) || \
+       JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,24)
+#if defined(__INTPTR_TYPE__)
+    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) __builtin_types_compatible_p(__typeof__((1 ? (void*) ((__INTPTR_TYPE__) ((expr) * 0)) : (int*) 0)), int*)
+#else
+    #include <stdint.h>
+    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) __builtin_types_compatible_p(__typeof__((1 ? (void*) ((intptr_t) ((expr) * 0)) : (int*) 0)), int*)
+#endif
+#  elif \
+       ( \
+          defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 201112L) && \
+          !defined(JSON_HEDLEY_SUNPRO_VERSION) && \
+          !defined(JSON_HEDLEY_PGI_VERSION) && \
+          !defined(JSON_HEDLEY_IAR_VERSION)) || \
+       (JSON_HEDLEY_HAS_EXTENSION(c_generic_selections) && !defined(JSON_HEDLEY_IAR_VERSION)) || \
+       JSON_HEDLEY_GCC_VERSION_CHECK(4,9,0) || \
+       JSON_HEDLEY_INTEL_VERSION_CHECK(17,0,0) || \
+       JSON_HEDLEY_IBM_VERSION_CHECK(12,1,0) || \
+       JSON_HEDLEY_ARM_VERSION_CHECK(5,3,0)
+#if defined(__INTPTR_TYPE__)
+    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) _Generic((1 ? (void*) ((__INTPTR_TYPE__) ((expr) * 0)) : (int*) 0), int*: 1, void*: 0)
+#else
+    #include <stdint.h>
+    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) _Generic((1 ? (void*) ((intptr_t) * 0) : (int*) 0), int*: 1, void*: 0)
+#endif
+#  elif \
+       defined(JSON_HEDLEY_GCC_VERSION) || \
+       defined(JSON_HEDLEY_INTEL_VERSION) || \
+       defined(JSON_HEDLEY_TINYC_VERSION) || \
+       defined(JSON_HEDLEY_TI_ARMCL_VERSION) || \
+       JSON_HEDLEY_TI_CL430_VERSION_CHECK(18,12,0) || \
+       defined(JSON_HEDLEY_TI_CL2000_VERSION) || \
+       defined(JSON_HEDLEY_TI_CL6X_VERSION) || \
+       defined(JSON_HEDLEY_TI_CL7X_VERSION) || \
+       defined(JSON_HEDLEY_TI_CLPRU_VERSION) || \
+       defined(__clang__)
+#    define JSON_HEDLEY_IS_CONSTEXPR_(expr) ( \
+        sizeof(void) != \
+        sizeof(*( \
+                  1 ? \
+                  ((void*) ((expr) * 0L) ) : \
+((struct { char v[sizeof(void) * 2]; } *) 1) \
+                ) \
+              ) \
+                                            )
+#  endif
+#endif
+#if defined(JSON_HEDLEY_IS_CONSTEXPR_)
+    #if !defined(JSON_HEDLEY_IS_CONSTANT)
+        #define JSON_HEDLEY_IS_CONSTANT(expr) JSON_HEDLEY_IS_CONSTEXPR_(expr)
+    #endif
+    #define JSON_HEDLEY_REQUIRE_CONSTEXPR(expr) (JSON_HEDLEY_IS_CONSTEXPR_(expr) ? (expr) : (-1))
+#else
+    #if !defined(JSON_HEDLEY_IS_CONSTANT)
+        #define JSON_HEDLEY_IS_CONSTANT(expr) (0)
+    #endif
+    #define JSON_HEDLEY_REQUIRE_CONSTEXPR(expr) (expr)
+#endif
+
+#if defined(JSON_HEDLEY_BEGIN_C_DECLS)
+    #undef JSON_HEDLEY_BEGIN_C_DECLS
+#endif
+#if defined(JSON_HEDLEY_END_C_DECLS)
+    #undef JSON_HEDLEY_END_C_DECLS
+#endif
+#if defined(JSON_HEDLEY_C_DECL)
+    #undef JSON_HEDLEY_C_DECL
+#endif
+#if defined(__cplusplus)
+    #define JSON_HEDLEY_BEGIN_C_DECLS extern "C" {
+    #define JSON_HEDLEY_END_C_DECLS }
+    #define JSON_HEDLEY_C_DECL extern "C"
+#else
+    #define JSON_HEDLEY_BEGIN_C_DECLS
+    #define JSON_HEDLEY_END_C_DECLS
+    #define JSON_HEDLEY_C_DECL
+#endif
+
+#if defined(JSON_HEDLEY_STATIC_ASSERT)
+    #undef JSON_HEDLEY_STATIC_ASSERT
+#endif
+#if \
+  !defined(__cplusplus) && ( \
+      (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 201112L)) || \
+      (JSON_HEDLEY_HAS_FEATURE(c_static_assert) && !defined(JSON_HEDLEY_INTEL_CL_VERSION)) || \
+      JSON_HEDLEY_GCC_VERSION_CHECK(6,0,0) || \
+      JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
+      defined(_Static_assert) \
+    )
+#  define JSON_HEDLEY_STATIC_ASSERT(expr, message) _Static_assert(expr, message)
+#elif \
+  (defined(__cplusplus) && (__cplusplus >= 201103L)) || \
+  JSON_HEDLEY_MSVC_VERSION_CHECK(16,0,0) || \
+  JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+#  define JSON_HEDLEY_STATIC_ASSERT(expr, message) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(static_assert(expr, message))
+#else
+#  define JSON_HEDLEY_STATIC_ASSERT(expr, message)
+#endif
+
+#if defined(JSON_HEDLEY_NULL)
+    #undef JSON_HEDLEY_NULL
+#endif
+#if defined(__cplusplus)
+    #if __cplusplus >= 201103L
+        #define JSON_HEDLEY_NULL JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(nullptr)
+    #elif defined(NULL)
+        #define JSON_HEDLEY_NULL NULL
+    #else
+        #define JSON_HEDLEY_NULL JSON_HEDLEY_STATIC_CAST(void*, 0)
+    #endif
+#elif defined(NULL)
+    #define JSON_HEDLEY_NULL NULL
+#else
+    #define JSON_HEDLEY_NULL ((void*) 0)
+#endif
+
+#if defined(JSON_HEDLEY_MESSAGE)
+    #undef JSON_HEDLEY_MESSAGE
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wunknown-pragmas")
+#  define JSON_HEDLEY_MESSAGE(msg) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS \
+    JSON_HEDLEY_PRAGMA(message msg) \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#elif \
+  JSON_HEDLEY_GCC_VERSION_CHECK(4,4,0) || \
+  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
+#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(message msg)
+#elif JSON_HEDLEY_CRAY_VERSION_CHECK(5,0,0)
+#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(_CRI message msg)
+#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
+#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(message(msg))
+#elif JSON_HEDLEY_PELLES_VERSION_CHECK(2,0,0)
+#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(message(msg))
+#else
+#  define JSON_HEDLEY_MESSAGE(msg)
+#endif
+
+#if defined(JSON_HEDLEY_WARNING)
+    #undef JSON_HEDLEY_WARNING
+#endif
+#if JSON_HEDLEY_HAS_WARNING("-Wunknown-pragmas")
+#  define JSON_HEDLEY_WARNING(msg) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS \
+    JSON_HEDLEY_PRAGMA(clang warning msg) \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#elif \
+  JSON_HEDLEY_GCC_VERSION_CHECK(4,8,0) || \
+  JSON_HEDLEY_PGI_VERSION_CHECK(18,4,0) || \
+  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
+#  define JSON_HEDLEY_WARNING(msg) JSON_HEDLEY_PRAGMA(GCC warning msg)
+#elif \
+  JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0) || \
+  JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+#  define JSON_HEDLEY_WARNING(msg) JSON_HEDLEY_PRAGMA(message(msg))
+#else
+#  define JSON_HEDLEY_WARNING(msg) JSON_HEDLEY_MESSAGE(msg)
+#endif
+
+#if defined(JSON_HEDLEY_REQUIRE)
+    #undef JSON_HEDLEY_REQUIRE
+#endif
+#if defined(JSON_HEDLEY_REQUIRE_MSG)
+    #undef JSON_HEDLEY_REQUIRE_MSG
+#endif
+#if JSON_HEDLEY_HAS_ATTRIBUTE(diagnose_if)
+#  if JSON_HEDLEY_HAS_WARNING("-Wgcc-compat")
+#    define JSON_HEDLEY_REQUIRE(expr) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    _Pragma("clang diagnostic ignored \"-Wgcc-compat\"") \
+    __attribute__((diagnose_if(!(expr), #expr, "error"))) \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#    define JSON_HEDLEY_REQUIRE_MSG(expr,msg) \
+    JSON_HEDLEY_DIAGNOSTIC_PUSH \
+    _Pragma("clang diagnostic ignored \"-Wgcc-compat\"") \
+    __attribute__((diagnose_if(!(expr), msg, "error"))) \
+    JSON_HEDLEY_DIAGNOSTIC_POP
+#  else
+#    define JSON_HEDLEY_REQUIRE(expr) __attribute__((diagnose_if(!(expr), #expr, "error")))
+#    define JSON_HEDLEY_REQUIRE_MSG(expr,msg) __attribute__((diagnose_if(!(expr), msg, "error")))
+#  endif
+#else
+#  define JSON_HEDLEY_REQUIRE(expr)
+#  define JSON_HEDLEY_REQUIRE_MSG(expr,msg)
+#endif
+
+#if defined(JSON_HEDLEY_FLAGS)
+    #undef JSON_HEDLEY_FLAGS
+#endif
+#if JSON_HEDLEY_HAS_ATTRIBUTE(flag_enum) && (!defined(__cplusplus) || JSON_HEDLEY_HAS_WARNING("-Wbitfield-enum-conversion"))
+    #define JSON_HEDLEY_FLAGS __attribute__((__flag_enum__))
+#else
+    #define JSON_HEDLEY_FLAGS
+#endif
+
+#if defined(JSON_HEDLEY_FLAGS_CAST)
+    #undef JSON_HEDLEY_FLAGS_CAST
+#endif
+#if JSON_HEDLEY_INTEL_VERSION_CHECK(19,0,0)
+#  define JSON_HEDLEY_FLAGS_CAST(T, expr) (__extension__ ({ \
+        JSON_HEDLEY_DIAGNOSTIC_PUSH \
+        _Pragma("warning(disable:188)") \
+        ((T) (expr)); \
+        JSON_HEDLEY_DIAGNOSTIC_POP \
+    }))
+#else
+#  define JSON_HEDLEY_FLAGS_CAST(T, expr) JSON_HEDLEY_STATIC_CAST(T, expr)
+#endif
+
+#if defined(JSON_HEDLEY_EMPTY_BASES)
+    #undef JSON_HEDLEY_EMPTY_BASES
+#endif
+#if \
+    (JSON_HEDLEY_MSVC_VERSION_CHECK(19,0,23918) && !JSON_HEDLEY_MSVC_VERSION_CHECK(20,0,0)) || \
+    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
+    #define JSON_HEDLEY_EMPTY_BASES __declspec(empty_bases)
+#else
+    #define JSON_HEDLEY_EMPTY_BASES
+#endif
+
+/* Remaining macros are deprecated. */
+
+#if defined(JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK)
+    #undef JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK
+#endif
+#if defined(__clang__)
+    #define JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK(major,minor,patch) (0)
+#else
+    #define JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK(major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
+#endif
+
+#if defined(JSON_HEDLEY_CLANG_HAS_ATTRIBUTE)
+    #undef JSON_HEDLEY_CLANG_HAS_ATTRIBUTE
+#endif
+#define JSON_HEDLEY_CLANG_HAS_ATTRIBUTE(attribute) JSON_HEDLEY_HAS_ATTRIBUTE(attribute)
+
+#if defined(JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE)
+    #undef JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE
+#endif
+#define JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE(attribute) JSON_HEDLEY_HAS_CPP_ATTRIBUTE(attribute)
+
+#if defined(JSON_HEDLEY_CLANG_HAS_BUILTIN)
+    #undef JSON_HEDLEY_CLANG_HAS_BUILTIN
+#endif
+#define JSON_HEDLEY_CLANG_HAS_BUILTIN(builtin) JSON_HEDLEY_HAS_BUILTIN(builtin)
+
+#if defined(JSON_HEDLEY_CLANG_HAS_FEATURE)
+    #undef JSON_HEDLEY_CLANG_HAS_FEATURE
+#endif
+#define JSON_HEDLEY_CLANG_HAS_FEATURE(feature) JSON_HEDLEY_HAS_FEATURE(feature)
+
+#if defined(JSON_HEDLEY_CLANG_HAS_EXTENSION)
+    #undef JSON_HEDLEY_CLANG_HAS_EXTENSION
+#endif
+#define JSON_HEDLEY_CLANG_HAS_EXTENSION(extension) JSON_HEDLEY_HAS_EXTENSION(extension)
+
+#if defined(JSON_HEDLEY_CLANG_HAS_DECLSPEC_DECLSPEC_ATTRIBUTE)
+    #undef JSON_HEDLEY_CLANG_HAS_DECLSPEC_DECLSPEC_ATTRIBUTE
+#endif
+#define JSON_HEDLEY_CLANG_HAS_DECLSPEC_ATTRIBUTE(attribute) JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE(attribute)
+
+#if defined(JSON_HEDLEY_CLANG_HAS_WARNING)
+    #undef JSON_HEDLEY_CLANG_HAS_WARNING
+#endif
+#define JSON_HEDLEY_CLANG_HAS_WARNING(warning) JSON_HEDLEY_HAS_WARNING(warning)
+
+#endif /* !defined(JSON_HEDLEY_VERSION) || (JSON_HEDLEY_VERSION < X) */
+
+// #include <nlohmann/detail/meta/detected.hpp>
+
+
+#include <type_traits>
+
+// #include <nlohmann/detail/meta/void_t.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+template<typename ...Ts> struct make_void
+{
+    using type = void;
+};
+template<typename ...Ts> using void_t = typename make_void<Ts...>::type;
+} // namespace detail
+}  // namespace nlohmann
+
+
+// https://en.cppreference.com/w/cpp/experimental/is_detected
+namespace nlohmann
+{
+namespace detail
+{
+struct nonesuch
+{
+    nonesuch() = delete;
+    ~nonesuch() = delete;
+    nonesuch(nonesuch const&) = delete;
+    nonesuch(nonesuch const&&) = delete;
+    void operator=(nonesuch const&) = delete;
+    void operator=(nonesuch&&) = delete;
+};
+
+template<class Default,
+         class AlwaysVoid,
+         template<class...> class Op,
+         class... Args>
+struct detector
+{
+    using value_t = std::false_type;
+    using type = Default;
+};
+
+template<class Default, template<class...> class Op, class... Args>
+struct detector<Default, void_t<Op<Args...>>, Op, Args...>
+{
+    using value_t = std::true_type;
+    using type = Op<Args...>;
+};
+
+template<template<class...> class Op, class... Args>
+using is_detected = typename detector<nonesuch, void, Op, Args...>::value_t;
+
+template<template<class...> class Op, class... Args>
+struct is_detected_lazy : is_detected<Op, Args...> { };
+
+template<template<class...> class Op, class... Args>
+using detected_t = typename detector<nonesuch, void, Op, Args...>::type;
+
+template<class Default, template<class...> class Op, class... Args>
+using detected_or = detector<Default, void, Op, Args...>;
+
+template<class Default, template<class...> class Op, class... Args>
+using detected_or_t = typename detected_or<Default, Op, Args...>::type;
+
+template<class Expected, template<class...> class Op, class... Args>
+using is_detected_exact = std::is_same<Expected, detected_t<Op, Args...>>;
+
+template<class To, template<class...> class Op, class... Args>
+using is_detected_convertible =
+    std::is_convertible<detected_t<Op, Args...>, To>;
+}  // namespace detail
+}  // namespace nlohmann
+
+
+// This file contains all internal macro definitions
+// You MUST include macro_unscope.hpp at the end of json.hpp to undef all of them
+
+// exclude unsupported compilers
+#if !defined(JSON_SKIP_UNSUPPORTED_COMPILER_CHECK)
+    #if defined(__clang__)
+        #if (__clang_major__ * 10000 + __clang_minor__ * 100 + __clang_patchlevel__) < 30400
+            #error "unsupported Clang version - see https://github.com/nlohmann/json#supported-compilers"
+        #endif
+    #elif defined(__GNUC__) && !(defined(__ICC) || defined(__INTEL_COMPILER))
+        #if (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__) < 40800
+            #error "unsupported GCC version - see https://github.com/nlohmann/json#supported-compilers"
+        #endif
+    #endif
+#endif
+
+// C++ language standard detection
+// if the user manually specified the used c++ version this is skipped
+#if !defined(JSON_HAS_CPP_20) && !defined(JSON_HAS_CPP_17) && !defined(JSON_HAS_CPP_14) && !defined(JSON_HAS_CPP_11)
+    #if (defined(__cplusplus) && __cplusplus >= 202002L) || (defined(_MSVC_LANG) && _MSVC_LANG >= 202002L)
+        #define JSON_HAS_CPP_20
+        #define JSON_HAS_CPP_17
+        #define JSON_HAS_CPP_14
+    #elif (defined(__cplusplus) && __cplusplus >= 201703L) || (defined(_HAS_CXX17) && _HAS_CXX17 == 1) // fix for issue #464
+        #define JSON_HAS_CPP_17
+        #define JSON_HAS_CPP_14
+    #elif (defined(__cplusplus) && __cplusplus >= 201402L) || (defined(_HAS_CXX14) && _HAS_CXX14 == 1)
+        #define JSON_HAS_CPP_14
+    #endif
+    // the cpp 11 flag is always specified because it is the minimal required version
+    #define JSON_HAS_CPP_11
+#endif
+
+#if !defined(JSON_HAS_FILESYSTEM) && !defined(JSON_HAS_EXPERIMENTAL_FILESYSTEM)
+    #ifdef JSON_HAS_CPP_17
+        #if defined(__cpp_lib_filesystem)
+            #define JSON_HAS_FILESYSTEM 1
+        #elif defined(__cpp_lib_experimental_filesystem)
+            #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 1
+        #elif !defined(__has_include)
+            #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 1
+        #elif __has_include(<filesystem>)
+            #define JSON_HAS_FILESYSTEM 1
+        #elif __has_include(<experimental/filesystem>)
+            #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 1
+        #endif
+
+        // std::filesystem does not work on MinGW GCC 8: https://sourceforge.net/p/mingw-w64/bugs/737/
+        #if defined(__MINGW32__) && defined(__GNUC__) && __GNUC__ == 8
+            #undef JSON_HAS_FILESYSTEM
+            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+        #endif
+
+        // no filesystem support before GCC 8: https://en.cppreference.com/w/cpp/compiler_support
+        #if defined(__GNUC__) && !defined(__clang__) && __GNUC__ < 8
+            #undef JSON_HAS_FILESYSTEM
+            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+        #endif
+
+        // no filesystem support before Clang 7: https://en.cppreference.com/w/cpp/compiler_support
+        #if defined(__clang_major__) && __clang_major__ < 7
+            #undef JSON_HAS_FILESYSTEM
+            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+        #endif
+
+        // no filesystem support before MSVC 19.14: https://en.cppreference.com/w/cpp/compiler_support
+        #if defined(_MSC_VER) && _MSC_VER < 1940
+            #undef JSON_HAS_FILESYSTEM
+            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+        #endif
+
+        // no filesystem support before iOS 13
+        #if defined(__IPHONE_OS_VERSION_MIN_REQUIRED) && __IPHONE_OS_VERSION_MIN_REQUIRED < 130000
+            #undef JSON_HAS_FILESYSTEM
+            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+        #endif
+
+        // no filesystem support before macOS Catalina
+        #if defined(__MAC_OS_X_VERSION_MIN_REQUIRED) && __MAC_OS_X_VERSION_MIN_REQUIRED < 101500
+            #undef JSON_HAS_FILESYSTEM
+            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+        #endif
+    #endif
+#endif
+
+#ifndef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+    #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 0
+#endif
+
+#ifndef JSON_HAS_FILESYSTEM
+    #define JSON_HAS_FILESYSTEM 0
+#endif
+
+// disable documentation warnings on clang
+#if defined(__clang__)
+    #pragma clang diagnostic push
+    #pragma clang diagnostic ignored "-Wdocumentation"
+    #pragma clang diagnostic ignored "-Wdocumentation-unknown-command"
+#endif
+
+// allow disabling exceptions
+#if (defined(__cpp_exceptions) || defined(__EXCEPTIONS) || defined(_CPPUNWIND)) && !defined(JSON_NOEXCEPTION)
+    #define JSON_THROW(exception) throw exception
+    #define JSON_TRY try
+    #define JSON_CATCH(exception) catch(exception)
+    #define JSON_INTERNAL_CATCH(exception) catch(exception)
+#else
+    #include <cstdlib>
+    #define JSON_THROW(exception) std::abort()
+    #define JSON_TRY if(true)
+    #define JSON_CATCH(exception) if(false)
+    #define JSON_INTERNAL_CATCH(exception) if(false)
+#endif
+
+// override exception macros
+#if defined(JSON_THROW_USER)
+    #undef JSON_THROW
+    #define JSON_THROW JSON_THROW_USER
+#endif
+#if defined(JSON_TRY_USER)
+    #undef JSON_TRY
+    #define JSON_TRY JSON_TRY_USER
+#endif
+#if defined(JSON_CATCH_USER)
+    #undef JSON_CATCH
+    #define JSON_CATCH JSON_CATCH_USER
+    #undef JSON_INTERNAL_CATCH
+    #define JSON_INTERNAL_CATCH JSON_CATCH_USER
+#endif
+#if defined(JSON_INTERNAL_CATCH_USER)
+    #undef JSON_INTERNAL_CATCH
+    #define JSON_INTERNAL_CATCH JSON_INTERNAL_CATCH_USER
+#endif
+
+// allow overriding assert
+#if !defined(JSON_ASSERT)
+    #include <cassert> // assert
+    #define JSON_ASSERT(x) assert(x)
+#endif
+
+// allow to access some private functions (needed by the test suite)
+#if defined(JSON_TESTS_PRIVATE)
+    #define JSON_PRIVATE_UNLESS_TESTED public
+#else
+    #define JSON_PRIVATE_UNLESS_TESTED private
+#endif
+
+/*!
+@brief macro to briefly define a mapping between an enum and JSON
+@def NLOHMANN_JSON_SERIALIZE_ENUM
+@since version 3.4.0
+*/
+#define NLOHMANN_JSON_SERIALIZE_ENUM(ENUM_TYPE, ...)                                            \
+    template<typename BasicJsonType>                                                            \
+    inline void to_json(BasicJsonType& j, const ENUM_TYPE& e)                                   \
+    {                                                                                           \
+        static_assert(std::is_enum<ENUM_TYPE>::value, #ENUM_TYPE " must be an enum!");          \
+        static const std::pair<ENUM_TYPE, BasicJsonType> m[] = __VA_ARGS__;                     \
+        auto it = std::find_if(std::begin(m), std::end(m),                                      \
+                               [e](const std::pair<ENUM_TYPE, BasicJsonType>& ej_pair) -> bool  \
+        {                                                                                       \
+            return ej_pair.first == e;                                                          \
+        });                                                                                     \
+        j = ((it != std::end(m)) ? it : std::begin(m))->second;                                 \
+    }                                                                                           \
+    template<typename BasicJsonType>                                                            \
+    inline void from_json(const BasicJsonType& j, ENUM_TYPE& e)                                 \
+    {                                                                                           \
+        static_assert(std::is_enum<ENUM_TYPE>::value, #ENUM_TYPE " must be an enum!");          \
+        static const std::pair<ENUM_TYPE, BasicJsonType> m[] = __VA_ARGS__;                     \
+        auto it = std::find_if(std::begin(m), std::end(m),                                      \
+                               [&j](const std::pair<ENUM_TYPE, BasicJsonType>& ej_pair) -> bool \
+        {                                                                                       \
+            return ej_pair.second == j;                                                         \
+        });                                                                                     \
+        e = ((it != std::end(m)) ? it : std::begin(m))->first;                                  \
+    }
+
+// Ugly macros to avoid uglier copy-paste when specializing basic_json. They
+// may be removed in the future once the class is split.
+
+#define NLOHMANN_BASIC_JSON_TPL_DECLARATION                                \
+    template<template<typename, typename, typename...> class ObjectType,   \
+             template<typename, typename...> class ArrayType,              \
+             class StringType, class BooleanType, class NumberIntegerType, \
+             class NumberUnsignedType, class NumberFloatType,              \
+             template<typename> class AllocatorType,                       \
+             template<typename, typename = void> class JSONSerializer,     \
+             class BinaryType>
+
+#define NLOHMANN_BASIC_JSON_TPL                                            \
+    basic_json<ObjectType, ArrayType, StringType, BooleanType,             \
+    NumberIntegerType, NumberUnsignedType, NumberFloatType,                \
+    AllocatorType, JSONSerializer, BinaryType>
+
+// Macros to simplify conversion from/to types
+
+#define NLOHMANN_JSON_EXPAND( x ) x
+#define NLOHMANN_JSON_GET_MACRO(_1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, _51, _52, _53, _54, _55, _56, _57, _58, _59, _60, _61, _62, _63, _64, NAME,...) NAME
+#define NLOHMANN_JSON_PASTE(...) NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_GET_MACRO(__VA_ARGS__, \
+        NLOHMANN_JSON_PASTE64, \
+        NLOHMANN_JSON_PASTE63, \
+        NLOHMANN_JSON_PASTE62, \
+        NLOHMANN_JSON_PASTE61, \
+        NLOHMANN_JSON_PASTE60, \
+        NLOHMANN_JSON_PASTE59, \
+        NLOHMANN_JSON_PASTE58, \
+        NLOHMANN_JSON_PASTE57, \
+        NLOHMANN_JSON_PASTE56, \
+        NLOHMANN_JSON_PASTE55, \
+        NLOHMANN_JSON_PASTE54, \
+        NLOHMANN_JSON_PASTE53, \
+        NLOHMANN_JSON_PASTE52, \
+        NLOHMANN_JSON_PASTE51, \
+        NLOHMANN_JSON_PASTE50, \
+        NLOHMANN_JSON_PASTE49, \
+        NLOHMANN_JSON_PASTE48, \
+        NLOHMANN_JSON_PASTE47, \
+        NLOHMANN_JSON_PASTE46, \
+        NLOHMANN_JSON_PASTE45, \
+        NLOHMANN_JSON_PASTE44, \
+        NLOHMANN_JSON_PASTE43, \
+        NLOHMANN_JSON_PASTE42, \
+        NLOHMANN_JSON_PASTE41, \
+        NLOHMANN_JSON_PASTE40, \
+        NLOHMANN_JSON_PASTE39, \
+        NLOHMANN_JSON_PASTE38, \
+        NLOHMANN_JSON_PASTE37, \
+        NLOHMANN_JSON_PASTE36, \
+        NLOHMANN_JSON_PASTE35, \
+        NLOHMANN_JSON_PASTE34, \
+        NLOHMANN_JSON_PASTE33, \
+        NLOHMANN_JSON_PASTE32, \
+        NLOHMANN_JSON_PASTE31, \
+        NLOHMANN_JSON_PASTE30, \
+        NLOHMANN_JSON_PASTE29, \
+        NLOHMANN_JSON_PASTE28, \
+        NLOHMANN_JSON_PASTE27, \
+        NLOHMANN_JSON_PASTE26, \
+        NLOHMANN_JSON_PASTE25, \
+        NLOHMANN_JSON_PASTE24, \
+        NLOHMANN_JSON_PASTE23, \
+        NLOHMANN_JSON_PASTE22, \
+        NLOHMANN_JSON_PASTE21, \
+        NLOHMANN_JSON_PASTE20, \
+        NLOHMANN_JSON_PASTE19, \
+        NLOHMANN_JSON_PASTE18, \
+        NLOHMANN_JSON_PASTE17, \
+        NLOHMANN_JSON_PASTE16, \
+        NLOHMANN_JSON_PASTE15, \
+        NLOHMANN_JSON_PASTE14, \
+        NLOHMANN_JSON_PASTE13, \
+        NLOHMANN_JSON_PASTE12, \
+        NLOHMANN_JSON_PASTE11, \
+        NLOHMANN_JSON_PASTE10, \
+        NLOHMANN_JSON_PASTE9, \
+        NLOHMANN_JSON_PASTE8, \
+        NLOHMANN_JSON_PASTE7, \
+        NLOHMANN_JSON_PASTE6, \
+        NLOHMANN_JSON_PASTE5, \
+        NLOHMANN_JSON_PASTE4, \
+        NLOHMANN_JSON_PASTE3, \
+        NLOHMANN_JSON_PASTE2, \
+        NLOHMANN_JSON_PASTE1)(__VA_ARGS__))
+#define NLOHMANN_JSON_PASTE2(func, v1) func(v1)
+#define NLOHMANN_JSON_PASTE3(func, v1, v2) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE2(func, v2)
+#define NLOHMANN_JSON_PASTE4(func, v1, v2, v3) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE3(func, v2, v3)
+#define NLOHMANN_JSON_PASTE5(func, v1, v2, v3, v4) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE4(func, v2, v3, v4)
+#define NLOHMANN_JSON_PASTE6(func, v1, v2, v3, v4, v5) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE5(func, v2, v3, v4, v5)
+#define NLOHMANN_JSON_PASTE7(func, v1, v2, v3, v4, v5, v6) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE6(func, v2, v3, v4, v5, v6)
+#define NLOHMANN_JSON_PASTE8(func, v1, v2, v3, v4, v5, v6, v7) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE7(func, v2, v3, v4, v5, v6, v7)
+#define NLOHMANN_JSON_PASTE9(func, v1, v2, v3, v4, v5, v6, v7, v8) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE8(func, v2, v3, v4, v5, v6, v7, v8)
+#define NLOHMANN_JSON_PASTE10(func, v1, v2, v3, v4, v5, v6, v7, v8, v9) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE9(func, v2, v3, v4, v5, v6, v7, v8, v9)
+#define NLOHMANN_JSON_PASTE11(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE10(func, v2, v3, v4, v5, v6, v7, v8, v9, v10)
+#define NLOHMANN_JSON_PASTE12(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE11(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11)
+#define NLOHMANN_JSON_PASTE13(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE12(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12)
+#define NLOHMANN_JSON_PASTE14(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE13(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13)
+#define NLOHMANN_JSON_PASTE15(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE14(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14)
+#define NLOHMANN_JSON_PASTE16(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE15(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15)
+#define NLOHMANN_JSON_PASTE17(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE16(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16)
+#define NLOHMANN_JSON_PASTE18(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE17(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17)
+#define NLOHMANN_JSON_PASTE19(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE18(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18)
+#define NLOHMANN_JSON_PASTE20(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE19(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19)
+#define NLOHMANN_JSON_PASTE21(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE20(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20)
+#define NLOHMANN_JSON_PASTE22(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE21(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21)
+#define NLOHMANN_JSON_PASTE23(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE22(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22)
+#define NLOHMANN_JSON_PASTE24(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE23(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23)
+#define NLOHMANN_JSON_PASTE25(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE24(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24)
+#define NLOHMANN_JSON_PASTE26(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE25(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25)
+#define NLOHMANN_JSON_PASTE27(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE26(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26)
+#define NLOHMANN_JSON_PASTE28(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE27(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27)
+#define NLOHMANN_JSON_PASTE29(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE28(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28)
+#define NLOHMANN_JSON_PASTE30(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE29(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29)
+#define NLOHMANN_JSON_PASTE31(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE30(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30)
+#define NLOHMANN_JSON_PASTE32(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE31(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31)
+#define NLOHMANN_JSON_PASTE33(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE32(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32)
+#define NLOHMANN_JSON_PASTE34(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE33(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33)
+#define NLOHMANN_JSON_PASTE35(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE34(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34)
+#define NLOHMANN_JSON_PASTE36(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE35(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35)
+#define NLOHMANN_JSON_PASTE37(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE36(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36)
+#define NLOHMANN_JSON_PASTE38(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE37(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37)
+#define NLOHMANN_JSON_PASTE39(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE38(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38)
+#define NLOHMANN_JSON_PASTE40(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE39(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39)
+#define NLOHMANN_JSON_PASTE41(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE40(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40)
+#define NLOHMANN_JSON_PASTE42(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE41(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41)
+#define NLOHMANN_JSON_PASTE43(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE42(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42)
+#define NLOHMANN_JSON_PASTE44(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE43(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43)
+#define NLOHMANN_JSON_PASTE45(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE44(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44)
+#define NLOHMANN_JSON_PASTE46(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE45(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45)
+#define NLOHMANN_JSON_PASTE47(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE46(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46)
+#define NLOHMANN_JSON_PASTE48(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE47(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47)
+#define NLOHMANN_JSON_PASTE49(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE48(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48)
+#define NLOHMANN_JSON_PASTE50(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE49(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49)
+#define NLOHMANN_JSON_PASTE51(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE50(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50)
+#define NLOHMANN_JSON_PASTE52(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE51(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51)
+#define NLOHMANN_JSON_PASTE53(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE52(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52)
+#define NLOHMANN_JSON_PASTE54(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE53(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53)
+#define NLOHMANN_JSON_PASTE55(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE54(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54)
+#define NLOHMANN_JSON_PASTE56(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE55(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55)
+#define NLOHMANN_JSON_PASTE57(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE56(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56)
+#define NLOHMANN_JSON_PASTE58(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE57(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57)
+#define NLOHMANN_JSON_PASTE59(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE58(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58)
+#define NLOHMANN_JSON_PASTE60(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE59(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59)
+#define NLOHMANN_JSON_PASTE61(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE60(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60)
+#define NLOHMANN_JSON_PASTE62(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE61(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61)
+#define NLOHMANN_JSON_PASTE63(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE62(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62)
+#define NLOHMANN_JSON_PASTE64(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62, v63) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE63(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62, v63)
+
+#define NLOHMANN_JSON_TO(v1) nlohmann_json_j[#v1] = nlohmann_json_t.v1;
+#define NLOHMANN_JSON_FROM(v1) nlohmann_json_j.at(#v1).get_to(nlohmann_json_t.v1);
+
+/*!
+@brief macro
+@def NLOHMANN_DEFINE_TYPE_INTRUSIVE
+@since version 3.9.0
+*/
+#define NLOHMANN_DEFINE_TYPE_INTRUSIVE(Type, ...)  \
+    friend void to_json(nlohmann::json& nlohmann_json_j, const Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_TO, __VA_ARGS__)) } \
+    friend void from_json(const nlohmann::json& nlohmann_json_j, Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_FROM, __VA_ARGS__)) }
+
+/*!
+@brief macro
+@def NLOHMANN_DEFINE_TYPE_NON_INTRUSIVE
+@since version 3.9.0
+*/
+#define NLOHMANN_DEFINE_TYPE_NON_INTRUSIVE(Type, ...)  \
+    inline void to_json(nlohmann::json& nlohmann_json_j, const Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_TO, __VA_ARGS__)) } \
+    inline void from_json(const nlohmann::json& nlohmann_json_j, Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_FROM, __VA_ARGS__)) }
+
+
+// inspired from https://stackoverflow.com/a/26745591
+// allows to call any std function as if (e.g. with begin):
+// using std::begin; begin(x);
+//
+// it allows using the detected idiom to retrieve the return type
+// of such an expression
+#define NLOHMANN_CAN_CALL_STD_FUNC_IMPL(std_name)                                 \
+    namespace detail {                                                            \
+    using std::std_name;                                                          \
+    \
+    template<typename... T>                                                       \
+    using result_of_##std_name = decltype(std_name(std::declval<T>()...));        \
+    }                                                                             \
+    \
+    namespace detail2 {                                                           \
+    struct std_name##_tag                                                         \
+    {                                                                             \
+    };                                                                            \
+    \
+    template<typename... T>                                                       \
+    std_name##_tag std_name(T&&...);                                              \
+    \
+    template<typename... T>                                                       \
+    using result_of_##std_name = decltype(std_name(std::declval<T>()...));        \
+    \
+    template<typename... T>                                                       \
+    struct would_call_std_##std_name                                              \
+    {                                                                             \
+        static constexpr auto const value = ::nlohmann::detail::                  \
+                                            is_detected_exact<std_name##_tag, result_of_##std_name, T...>::value; \
+    };                                                                            \
+    } /* namespace detail2 */ \
+    \
+    template<typename... T>                                                       \
+    struct would_call_std_##std_name : detail2::would_call_std_##std_name<T...>   \
+    {                                                                             \
+    }
+
+#ifndef JSON_USE_IMPLICIT_CONVERSIONS
+    #define JSON_USE_IMPLICIT_CONVERSIONS 1
+#endif
+
+#if JSON_USE_IMPLICIT_CONVERSIONS
+    #define JSON_EXPLICIT
+#else
+    #define JSON_EXPLICIT explicit
+#endif
+
+#ifndef JSON_DIAGNOSTICS
+    #define JSON_DIAGNOSTICS 0
+#endif
+
+
+namespace nlohmann
+{
+namespace detail
+{
+
+/*!
+@brief replace all occurrences of a substring by another string
+
+@param[in,out] s  the string to manipulate; changed so that all
+               occurrences of @a f are replaced with @a t
+@param[in]     f  the substring to replace with @a t
+@param[in]     t  the string to replace @a f
+
+@pre The search string @a f must not be empty. **This precondition is
+enforced with an assertion.**
+
+@since version 2.0.0
+*/
+inline void replace_substring(std::string& s, const std::string& f,
+                              const std::string& t)
+{
+    JSON_ASSERT(!f.empty());
+    for (auto pos = s.find(f);                // find first occurrence of f
+            pos != std::string::npos;         // make sure f was found
+            s.replace(pos, f.size(), t),      // replace with t, and
+            pos = s.find(f, pos + t.size()))  // find next occurrence of f
+    {}
+}
+
+/*!
+ * @brief string escaping as described in RFC 6901 (Sect. 4)
+ * @param[in] s string to escape
+ * @return    escaped string
+ *
+ * Note the order of escaping "~" to "~0" and "/" to "~1" is important.
+ */
+inline std::string escape(std::string s)
+{
+    replace_substring(s, "~", "~0");
+    replace_substring(s, "/", "~1");
+    return s;
+}
+
+/*!
+ * @brief string unescaping as described in RFC 6901 (Sect. 4)
+ * @param[in] s string to unescape
+ * @return    unescaped string
+ *
+ * Note the order of escaping "~1" to "/" and "~0" to "~" is important.
+ */
+static void unescape(std::string& s)
+{
+    replace_substring(s, "~1", "/");
+    replace_substring(s, "~0", "~");
+}
+
+} // namespace detail
+} // namespace nlohmann
+
+// #include <nlohmann/detail/input/position_t.hpp>
+
+
+#include <cstddef> // size_t
+
+namespace nlohmann
+{
+namespace detail
+{
+/// struct to capture the start position of the current token
+struct position_t
+{
+    /// the total number of characters read
+    std::size_t chars_read_total = 0;
+    /// the number of characters read in the current line
+    std::size_t chars_read_current_line = 0;
+    /// the number of lines read
+    std::size_t lines_read = 0;
+
+    /// conversion to size_t to preserve SAX interface
+    constexpr operator size_t() const
+    {
+        return chars_read_total;
+    }
+};
+
+} // namespace detail
+} // namespace nlohmann
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+////////////////
+// exceptions //
+////////////////
+
+/// @brief general exception of the @ref basic_json class
+/// @sa https://json.nlohmann.me/api/basic_json/exception/
+class exception : public std::exception
+{
+  public:
+    /// returns the explanatory string
+    const char* what() const noexcept override
+    {
+        return m.what();
+    }
+
+    /// the id of the exception
+    const int id; // NOLINT(cppcoreguidelines-non-private-member-variables-in-classes)
+
+  protected:
+    JSON_HEDLEY_NON_NULL(3)
+    exception(int id_, const char* what_arg) : id(id_), m(what_arg) {} // NOLINT(bugprone-throw-keyword-missing)
+
+    static std::string name(const std::string& ename, int id_)
+    {
+        return "[json.exception." + ename + "." + std::to_string(id_) + "] ";
+    }
+
+    template<typename BasicJsonType>
+    static std::string diagnostics(const BasicJsonType& leaf_element)
+    {
+#if JSON_DIAGNOSTICS
+        std::vector<std::string> tokens;
+        for (const auto* current = &leaf_element; current->m_parent != nullptr; current = current->m_parent)
+        {
+            switch (current->m_parent->type())
+            {
+                case value_t::array:
+                {
+                    for (std::size_t i = 0; i < current->m_parent->m_value.array->size(); ++i)
+                    {
+                        if (&current->m_parent->m_value.array->operator[](i) == current)
+                        {
+                            tokens.emplace_back(std::to_string(i));
+                            break;
+                        }
+                    }
+                    break;
+                }
+
+                case value_t::object:
+                {
+                    for (const auto& element : *current->m_parent->m_value.object)
+                    {
+                        if (&element.second == current)
+                        {
+                            tokens.emplace_back(element.first.c_str());
+                            break;
+                        }
+                    }
+                    break;
+                }
+
+                case value_t::null: // LCOV_EXCL_LINE
+                case value_t::string: // LCOV_EXCL_LINE
+                case value_t::boolean: // LCOV_EXCL_LINE
+                case value_t::number_integer: // LCOV_EXCL_LINE
+                case value_t::number_unsigned: // LCOV_EXCL_LINE
+                case value_t::number_float: // LCOV_EXCL_LINE
+                case value_t::binary: // LCOV_EXCL_LINE
+                case value_t::discarded: // LCOV_EXCL_LINE
+                default:   // LCOV_EXCL_LINE
+                    break; // LCOV_EXCL_LINE
+            }
+        }
+
+        if (tokens.empty())
+        {
+            return "";
+        }
+
+        return "(" + std::accumulate(tokens.rbegin(), tokens.rend(), std::string{},
+                                     [](const std::string & a, const std::string & b)
+        {
+            return a + "/" + detail::escape(b);
+        }) + ") ";
+#else
+        static_cast<void>(leaf_element);
+        return "";
+#endif
+    }
+
+  private:
+    /// an exception object as storage for error messages
+    std::runtime_error m;
+};
+
+/// @brief exception indicating a parse error
+/// @sa https://json.nlohmann.me/api/basic_json/parse_error/
+class parse_error : public exception
+{
+  public:
+    /*!
+    @brief create a parse error exception
+    @param[in] id_       the id of the exception
+    @param[in] pos       the position where the error occurred (or with
+                         chars_read_total=0 if the position cannot be
+                         determined)
+    @param[in] what_arg  the explanatory string
+    @return parse_error object
+    */
+    template<typename BasicJsonType>
+    static parse_error create(int id_, const position_t& pos, const std::string& what_arg, const BasicJsonType& context)
+    {
+        std::string w = exception::name("parse_error", id_) + "parse error" +
+                        position_string(pos) + ": " + exception::diagnostics(context) + what_arg;
+        return {id_, pos.chars_read_total, w.c_str()};
+    }
+
+    template<typename BasicJsonType>
+    static parse_error create(int id_, std::size_t byte_, const std::string& what_arg, const BasicJsonType& context)
+    {
+        std::string w = exception::name("parse_error", id_) + "parse error" +
+                        (byte_ != 0 ? (" at byte " + std::to_string(byte_)) : "") +
+                        ": " + exception::diagnostics(context) + what_arg;
+        return {id_, byte_, w.c_str()};
+    }
+
+    /*!
+    @brief byte index of the parse error
+
+    The byte index of the last read character in the input file.
+
+    @note For an input with n bytes, 1 is the index of the first character and
+          n+1 is the index of the terminating null byte or the end of file.
+          This also holds true when reading a byte vector (CBOR or MessagePack).
+    */
+    const std::size_t byte;
+
+  private:
+    parse_error(int id_, std::size_t byte_, const char* what_arg)
+        : exception(id_, what_arg), byte(byte_) {}
+
+    static std::string position_string(const position_t& pos)
+    {
+        return " at line " + std::to_string(pos.lines_read + 1) +
+               ", column " + std::to_string(pos.chars_read_current_line);
+    }
+};
+
+/// @brief exception indicating errors with iterators
+/// @sa https://json.nlohmann.me/api/basic_json/invalid_iterator/
+class invalid_iterator : public exception
+{
+  public:
+    template<typename BasicJsonType>
+    static invalid_iterator create(int id_, const std::string& what_arg, const BasicJsonType& context)
+    {
+        std::string w = exception::name("invalid_iterator", id_) + exception::diagnostics(context) + what_arg;
+        return {id_, w.c_str()};
+    }
+
+  private:
+    JSON_HEDLEY_NON_NULL(3)
+    invalid_iterator(int id_, const char* what_arg)
+        : exception(id_, what_arg) {}
+};
+
+/// @brief exception indicating executing a member function with a wrong type
+/// @sa https://json.nlohmann.me/api/basic_json/type_error/
+class type_error : public exception
+{
+  public:
+    template<typename BasicJsonType>
+    static type_error create(int id_, const std::string& what_arg, const BasicJsonType& context)
+    {
+        std::string w = exception::name("type_error", id_) + exception::diagnostics(context) + what_arg;
+        return {id_, w.c_str()};
+    }
+
+  private:
+    JSON_HEDLEY_NON_NULL(3)
+    type_error(int id_, const char* what_arg) : exception(id_, what_arg) {}
+};
+
+/// @brief exception indicating access out of the defined range
+/// @sa https://json.nlohmann.me/api/basic_json/out_of_range/
+class out_of_range : public exception
+{
+  public:
+    template<typename BasicJsonType>
+    static out_of_range create(int id_, const std::string& what_arg, const BasicJsonType& context)
+    {
+        std::string w = exception::name("out_of_range", id_) + exception::diagnostics(context) + what_arg;
+        return {id_, w.c_str()};
+    }
+
+  private:
+    JSON_HEDLEY_NON_NULL(3)
+    out_of_range(int id_, const char* what_arg) : exception(id_, what_arg) {}
+};
+
+/// @brief exception indicating other library errors
+/// @sa https://json.nlohmann.me/api/basic_json/other_error/
+class other_error : public exception
+{
+  public:
+    template<typename BasicJsonType>
+    static other_error create(int id_, const std::string& what_arg, const BasicJsonType& context)
+    {
+        std::string w = exception::name("other_error", id_) + exception::diagnostics(context) + what_arg;
+        return {id_, w.c_str()};
+    }
+
+  private:
+    JSON_HEDLEY_NON_NULL(3)
+    other_error(int id_, const char* what_arg) : exception(id_, what_arg) {}
+};
+
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/meta/cpp_future.hpp>
+
+
+#include <cstddef> // size_t
+#include <type_traits> // conditional, enable_if, false_type, integral_constant, is_constructible, is_integral, is_same, remove_cv, remove_reference, true_type
+#include <utility> // index_sequence, make_index_sequence, index_sequence_for
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+
+template<typename T>
+using uncvref_t = typename std::remove_cv<typename std::remove_reference<T>::type>::type;
+
+#ifdef JSON_HAS_CPP_14
+
+// the following utilities are natively available in C++14
+using std::enable_if_t;
+using std::index_sequence;
+using std::make_index_sequence;
+using std::index_sequence_for;
+
+#else
+
+// alias templates to reduce boilerplate
+template<bool B, typename T = void>
+using enable_if_t = typename std::enable_if<B, T>::type;
+
+// The following code is taken from https://github.com/abseil/abseil-cpp/blob/10cb35e459f5ecca5b2ff107635da0bfa41011b4/absl/utility/utility.h
+// which is part of Google Abseil (https://github.com/abseil/abseil-cpp), licensed under the Apache License 2.0.
+
+//// START OF CODE FROM GOOGLE ABSEIL
+
+// integer_sequence
+//
+// Class template representing a compile-time integer sequence. An instantiation
+// of `integer_sequence<T, Ints...>` has a sequence of integers encoded in its
+// type through its template arguments (which is a common need when
+// working with C++11 variadic templates). `absl::integer_sequence` is designed
+// to be a drop-in replacement for C++14's `std::integer_sequence`.
+//
+// Example:
+//
+//   template< class T, T... Ints >
+//   void user_function(integer_sequence<T, Ints...>);
+//
+//   int main()
+//   {
+//     // user_function's `T` will be deduced to `int` and `Ints...`
+//     // will be deduced to `0, 1, 2, 3, 4`.
+//     user_function(make_integer_sequence<int, 5>());
+//   }
+template <typename T, T... Ints>
+struct integer_sequence
+{
+    using value_type = T;
+    static constexpr std::size_t size() noexcept
+    {
+        return sizeof...(Ints);
+    }
+};
+
+// index_sequence
+//
+// A helper template for an `integer_sequence` of `size_t`,
+// `absl::index_sequence` is designed to be a drop-in replacement for C++14's
+// `std::index_sequence`.
+template <size_t... Ints>
+using index_sequence = integer_sequence<size_t, Ints...>;
+
+namespace utility_internal
+{
+
+template <typename Seq, size_t SeqSize, size_t Rem>
+struct Extend;
+
+// Note that SeqSize == sizeof...(Ints). It's passed explicitly for efficiency.
+template <typename T, T... Ints, size_t SeqSize>
+struct Extend<integer_sequence<T, Ints...>, SeqSize, 0>
+{
+    using type = integer_sequence < T, Ints..., (Ints + SeqSize)... >;
+};
+
+template <typename T, T... Ints, size_t SeqSize>
+struct Extend<integer_sequence<T, Ints...>, SeqSize, 1>
+{
+    using type = integer_sequence < T, Ints..., (Ints + SeqSize)..., 2 * SeqSize >;
+};
+
+// Recursion helper for 'make_integer_sequence<T, N>'.
+// 'Gen<T, N>::type' is an alias for 'integer_sequence<T, 0, 1, ... N-1>'.
+template <typename T, size_t N>
+struct Gen
+{
+    using type =
+        typename Extend < typename Gen < T, N / 2 >::type, N / 2, N % 2 >::type;
+};
+
+template <typename T>
+struct Gen<T, 0>
+{
+    using type = integer_sequence<T>;
+};
+
+}  // namespace utility_internal
+
+// Compile-time sequences of integers
+
+// make_integer_sequence
+//
+// This template alias is equivalent to
+// `integer_sequence<int, 0, 1, ..., N-1>`, and is designed to be a drop-in
+// replacement for C++14's `std::make_integer_sequence`.
+template <typename T, T N>
+using make_integer_sequence = typename utility_internal::Gen<T, N>::type;
+
+// make_index_sequence
+//
+// This template alias is equivalent to `index_sequence<0, 1, ..., N-1>`,
+// and is designed to be a drop-in replacement for C++14's
+// `std::make_index_sequence`.
+template <size_t N>
+using make_index_sequence = make_integer_sequence<size_t, N>;
+
+// index_sequence_for
+//
+// Converts a typename pack into an index sequence of the same length, and
+// is designed to be a drop-in replacement for C++14's
+// `std::index_sequence_for()`
+template <typename... Ts>
+using index_sequence_for = make_index_sequence<sizeof...(Ts)>;
+
+//// END OF CODE FROM GOOGLE ABSEIL
+
+#endif
+
+// dispatch utility (taken from ranges-v3)
+template<unsigned N> struct priority_tag : priority_tag < N - 1 > {};
+template<> struct priority_tag<0> {};
+
+// taken from ranges-v3
+template<typename T>
+struct static_const
+{
+    static constexpr T value{};
+};
+
+template<typename T>
+constexpr T static_const<T>::value; // NOLINT(readability-redundant-declaration)
+
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/meta/identity_tag.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+// dispatching helper struct
+template <class T> struct identity_tag {};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+
+#include <limits> // numeric_limits
+#include <type_traits> // false_type, is_constructible, is_integral, is_same, true_type
+#include <utility> // declval
+#include <tuple> // tuple
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+// #include <nlohmann/detail/iterators/iterator_traits.hpp>
+
+
+#include <iterator> // random_access_iterator_tag
+
+// #include <nlohmann/detail/meta/void_t.hpp>
+
+// #include <nlohmann/detail/meta/cpp_future.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+template<typename It, typename = void>
+struct iterator_types {};
+
+template<typename It>
+struct iterator_types <
+    It,
+    void_t<typename It::difference_type, typename It::value_type, typename It::pointer,
+    typename It::reference, typename It::iterator_category >>
+{
+    using difference_type = typename It::difference_type;
+    using value_type = typename It::value_type;
+    using pointer = typename It::pointer;
+    using reference = typename It::reference;
+    using iterator_category = typename It::iterator_category;
+};
+
+// This is required as some compilers implement std::iterator_traits in a way that
+// doesn't work with SFINAE. See https://github.com/nlohmann/json/issues/1341.
+template<typename T, typename = void>
+struct iterator_traits
+{
+};
+
+template<typename T>
+struct iterator_traits < T, enable_if_t < !std::is_pointer<T>::value >>
+            : iterator_types<T>
+{
+};
+
+template<typename T>
+struct iterator_traits<T*, enable_if_t<std::is_object<T>::value>>
+{
+    using iterator_category = std::random_access_iterator_tag;
+    using value_type = T;
+    using difference_type = ptrdiff_t;
+    using pointer = T*;
+    using reference = T&;
+};
+} // namespace detail
+} // namespace nlohmann
+
+// #include <nlohmann/detail/meta/call_std/begin.hpp>
+
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+NLOHMANN_CAN_CALL_STD_FUNC_IMPL(begin);
+} // namespace nlohmann
+
+// #include <nlohmann/detail/meta/call_std/end.hpp>
+
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+NLOHMANN_CAN_CALL_STD_FUNC_IMPL(end);
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/meta/cpp_future.hpp>
+
+// #include <nlohmann/detail/meta/detected.hpp>
+
+// #include <nlohmann/json_fwd.hpp>
+#ifndef INCLUDE_NLOHMANN_JSON_FWD_HPP_
+#define INCLUDE_NLOHMANN_JSON_FWD_HPP_
+
+#include <cstdint> // int64_t, uint64_t
+#include <map> // map
+#include <memory> // allocator
+#include <string> // string
+#include <vector> // vector
+
+/*!
+@brief namespace for Niels Lohmann
+@see https://github.com/nlohmann
+@since version 1.0.0
+*/
+namespace nlohmann
+{
+/*!
+@brief default JSONSerializer template argument
+
+This serializer ignores the template arguments and uses ADL
+([argument-dependent lookup](https://en.cppreference.com/w/cpp/language/adl))
+for serialization.
+*/
+template<typename T = void, typename SFINAE = void>
+struct adl_serializer;
+
+/// a class to store JSON values
+/// @sa https://json.nlohmann.me/api/basic_json/
+template<template<typename U, typename V, typename... Args> class ObjectType =
+         std::map,
+         template<typename U, typename... Args> class ArrayType = std::vector,
+         class StringType = std::string, class BooleanType = bool,
+         class NumberIntegerType = std::int64_t,
+         class NumberUnsignedType = std::uint64_t,
+         class NumberFloatType = double,
+         template<typename U> class AllocatorType = std::allocator,
+         template<typename T, typename SFINAE = void> class JSONSerializer =
+         adl_serializer,
+         class BinaryType = std::vector<std::uint8_t>>
+class basic_json;
+
+/// @brief JSON Pointer defines a string syntax for identifying a specific value within a JSON document
+/// @sa https://json.nlohmann.me/api/json_pointer/
+template<typename BasicJsonType>
+class json_pointer;
+
+/*!
+@brief default specialization
+@sa https://json.nlohmann.me/api/json/
+*/
+using json = basic_json<>;
+
+/// @brief a minimal map-like container that preserves insertion order
+/// @sa https://json.nlohmann.me/api/ordered_map/
+template<class Key, class T, class IgnoredLess, class Allocator>
+struct ordered_map;
+
+/// @brief specialization that maintains the insertion order of object keys
+/// @sa https://json.nlohmann.me/api/ordered_json/
+using ordered_json = basic_json<nlohmann::ordered_map>;
+
+}  // namespace nlohmann
+
+#endif  // INCLUDE_NLOHMANN_JSON_FWD_HPP_
+
+
+namespace nlohmann
+{
+/*!
+@brief detail namespace with internal helper functions
+
+This namespace collects functions that should not be exposed,
+implementations of some @ref basic_json methods, and meta-programming helpers.
+
+@since version 2.1.0
+*/
+namespace detail
+{
+/////////////
+// helpers //
+/////////////
+
+// Note to maintainers:
+//
+// Every trait in this file expects a non CV-qualified type.
+// The only exceptions are in the 'aliases for detected' section
+// (i.e. those of the form: decltype(T::member_function(std::declval<T>())))
+//
+// In this case, T has to be properly CV-qualified to constraint the function arguments
+// (e.g. to_json(BasicJsonType&, const T&))
+
+template<typename> struct is_basic_json : std::false_type {};
+
+NLOHMANN_BASIC_JSON_TPL_DECLARATION
+struct is_basic_json<NLOHMANN_BASIC_JSON_TPL> : std::true_type {};
+
+//////////////////////
+// json_ref helpers //
+//////////////////////
+
+template<typename>
+class json_ref;
+
+template<typename>
+struct is_json_ref : std::false_type {};
+
+template<typename T>
+struct is_json_ref<json_ref<T>> : std::true_type {};
+
+//////////////////////////
+// aliases for detected //
+//////////////////////////
+
+template<typename T>
+using mapped_type_t = typename T::mapped_type;
+
+template<typename T>
+using key_type_t = typename T::key_type;
+
+template<typename T>
+using value_type_t = typename T::value_type;
+
+template<typename T>
+using difference_type_t = typename T::difference_type;
+
+template<typename T>
+using pointer_t = typename T::pointer;
+
+template<typename T>
+using reference_t = typename T::reference;
+
+template<typename T>
+using iterator_category_t = typename T::iterator_category;
+
+template<typename T, typename... Args>
+using to_json_function = decltype(T::to_json(std::declval<Args>()...));
+
+template<typename T, typename... Args>
+using from_json_function = decltype(T::from_json(std::declval<Args>()...));
+
+template<typename T, typename U>
+using get_template_function = decltype(std::declval<T>().template get<U>());
+
+// trait checking if JSONSerializer<T>::from_json(json const&, udt&) exists
+template<typename BasicJsonType, typename T, typename = void>
+struct has_from_json : std::false_type {};
+
+// trait checking if j.get<T> is valid
+// use this trait instead of std::is_constructible or std::is_convertible,
+// both rely on, or make use of implicit conversions, and thus fail when T
+// has several constructors/operator= (see https://github.com/nlohmann/json/issues/958)
+template <typename BasicJsonType, typename T>
+struct is_getable
+{
+    static constexpr bool value = is_detected<get_template_function, const BasicJsonType&, T>::value;
+};
+
+template<typename BasicJsonType, typename T>
+struct has_from_json < BasicJsonType, T, enable_if_t < !is_basic_json<T>::value >>
+{
+    using serializer = typename BasicJsonType::template json_serializer<T, void>;
+
+    static constexpr bool value =
+        is_detected_exact<void, from_json_function, serializer,
+        const BasicJsonType&, T&>::value;
+};
+
+// This trait checks if JSONSerializer<T>::from_json(json const&) exists
+// this overload is used for non-default-constructible user-defined-types
+template<typename BasicJsonType, typename T, typename = void>
+struct has_non_default_from_json : std::false_type {};
+
+template<typename BasicJsonType, typename T>
+struct has_non_default_from_json < BasicJsonType, T, enable_if_t < !is_basic_json<T>::value >>
+{
+    using serializer = typename BasicJsonType::template json_serializer<T, void>;
+
+    static constexpr bool value =
+        is_detected_exact<T, from_json_function, serializer,
+        const BasicJsonType&>::value;
+};
+
+// This trait checks if BasicJsonType::json_serializer<T>::to_json exists
+// Do not evaluate the trait when T is a basic_json type, to avoid template instantiation infinite recursion.
+template<typename BasicJsonType, typename T, typename = void>
+struct has_to_json : std::false_type {};
+
+template<typename BasicJsonType, typename T>
+struct has_to_json < BasicJsonType, T, enable_if_t < !is_basic_json<T>::value >>
+{
+    using serializer = typename BasicJsonType::template json_serializer<T, void>;
+
+    static constexpr bool value =
+        is_detected_exact<void, to_json_function, serializer, BasicJsonType&,
+        T>::value;
+};
+
+
+///////////////////
+// is_ functions //
+///////////////////
+
+// https://en.cppreference.com/w/cpp/types/conjunction
+template<class...> struct conjunction : std::true_type { };
+template<class B1> struct conjunction<B1> : B1 { };
+template<class B1, class... Bn>
+struct conjunction<B1, Bn...>
+: std::conditional<bool(B1::value), conjunction<Bn...>, B1>::type {};
+
+// https://en.cppreference.com/w/cpp/types/negation
+template<class B> struct negation : std::integral_constant < bool, !B::value > { };
+
+// Reimplementation of is_constructible and is_default_constructible, due to them being broken for
+// std::pair and std::tuple until LWG 2367 fix (see https://cplusplus.github.io/LWG/lwg-defects.html#2367).
+// This causes compile errors in e.g. clang 3.5 or gcc 4.9.
+template <typename T>
+struct is_default_constructible : std::is_default_constructible<T> {};
+
+template <typename T1, typename T2>
+struct is_default_constructible<std::pair<T1, T2>>
+            : conjunction<is_default_constructible<T1>, is_default_constructible<T2>> {};
+
+template <typename T1, typename T2>
+struct is_default_constructible<const std::pair<T1, T2>>
+            : conjunction<is_default_constructible<T1>, is_default_constructible<T2>> {};
+
+template <typename... Ts>
+struct is_default_constructible<std::tuple<Ts...>>
+            : conjunction<is_default_constructible<Ts>...> {};
+
+template <typename... Ts>
+struct is_default_constructible<const std::tuple<Ts...>>
+            : conjunction<is_default_constructible<Ts>...> {};
+
+
+template <typename T, typename... Args>
+struct is_constructible : std::is_constructible<T, Args...> {};
+
+template <typename T1, typename T2>
+struct is_constructible<std::pair<T1, T2>> : is_default_constructible<std::pair<T1, T2>> {};
+
+template <typename T1, typename T2>
+struct is_constructible<const std::pair<T1, T2>> : is_default_constructible<const std::pair<T1, T2>> {};
+
+template <typename... Ts>
+struct is_constructible<std::tuple<Ts...>> : is_default_constructible<std::tuple<Ts...>> {};
+
+template <typename... Ts>
+struct is_constructible<const std::tuple<Ts...>> : is_default_constructible<const std::tuple<Ts...>> {};
+
+
+template<typename T, typename = void>
+struct is_iterator_traits : std::false_type {};
+
+template<typename T>
+struct is_iterator_traits<iterator_traits<T>>
+{
+  private:
+    using traits = iterator_traits<T>;
+
+  public:
+    static constexpr auto value =
+        is_detected<value_type_t, traits>::value &&
+        is_detected<difference_type_t, traits>::value &&
+        is_detected<pointer_t, traits>::value &&
+        is_detected<iterator_category_t, traits>::value &&
+        is_detected<reference_t, traits>::value;
+};
+
+template<typename T>
+struct is_range
+{
+  private:
+    using t_ref = typename std::add_lvalue_reference<T>::type;
+
+    using iterator = detected_t<result_of_begin, t_ref>;
+    using sentinel = detected_t<result_of_end, t_ref>;
+
+    // to be 100% correct, it should use https://en.cppreference.com/w/cpp/iterator/input_or_output_iterator
+    // and https://en.cppreference.com/w/cpp/iterator/sentinel_for
+    // but reimplementing these would be too much work, as a lot of other concepts are used underneath
+    static constexpr auto is_iterator_begin =
+        is_iterator_traits<iterator_traits<iterator>>::value;
+
+  public:
+    static constexpr bool value = !std::is_same<iterator, nonesuch>::value && !std::is_same<sentinel, nonesuch>::value && is_iterator_begin;
+};
+
+template<typename R>
+using iterator_t = enable_if_t<is_range<R>::value, result_of_begin<decltype(std::declval<R&>())>>;
+
+template<typename T>
+using range_value_t = value_type_t<iterator_traits<iterator_t<T>>>;
+
+// The following implementation of is_complete_type is taken from
+// https://blogs.msdn.microsoft.com/vcblog/2015/12/02/partial-support-for-expression-sfinae-in-vs-2015-update-1/
+// and is written by Xiang Fan who agreed to using it in this library.
+
+template<typename T, typename = void>
+struct is_complete_type : std::false_type {};
+
+template<typename T>
+struct is_complete_type<T, decltype(void(sizeof(T)))> : std::true_type {};
+
+template<typename BasicJsonType, typename CompatibleObjectType,
+         typename = void>
+struct is_compatible_object_type_impl : std::false_type {};
+
+template<typename BasicJsonType, typename CompatibleObjectType>
+struct is_compatible_object_type_impl <
+    BasicJsonType, CompatibleObjectType,
+    enable_if_t < is_detected<mapped_type_t, CompatibleObjectType>::value&&
+    is_detected<key_type_t, CompatibleObjectType>::value >>
+{
+    using object_t = typename BasicJsonType::object_t;
+
+    // macOS's is_constructible does not play well with nonesuch...
+    static constexpr bool value =
+        is_constructible<typename object_t::key_type,
+        typename CompatibleObjectType::key_type>::value &&
+        is_constructible<typename object_t::mapped_type,
+        typename CompatibleObjectType::mapped_type>::value;
+};
+
+template<typename BasicJsonType, typename CompatibleObjectType>
+struct is_compatible_object_type
+    : is_compatible_object_type_impl<BasicJsonType, CompatibleObjectType> {};
+
+template<typename BasicJsonType, typename ConstructibleObjectType,
+         typename = void>
+struct is_constructible_object_type_impl : std::false_type {};
+
+template<typename BasicJsonType, typename ConstructibleObjectType>
+struct is_constructible_object_type_impl <
+    BasicJsonType, ConstructibleObjectType,
+    enable_if_t < is_detected<mapped_type_t, ConstructibleObjectType>::value&&
+    is_detected<key_type_t, ConstructibleObjectType>::value >>
+{
+    using object_t = typename BasicJsonType::object_t;
+
+    static constexpr bool value =
+        (is_default_constructible<ConstructibleObjectType>::value &&
+         (std::is_move_assignable<ConstructibleObjectType>::value ||
+          std::is_copy_assignable<ConstructibleObjectType>::value) &&
+         (is_constructible<typename ConstructibleObjectType::key_type,
+          typename object_t::key_type>::value &&
+          std::is_same <
+          typename object_t::mapped_type,
+          typename ConstructibleObjectType::mapped_type >::value)) ||
+        (has_from_json<BasicJsonType,
+         typename ConstructibleObjectType::mapped_type>::value ||
+         has_non_default_from_json <
+         BasicJsonType,
+         typename ConstructibleObjectType::mapped_type >::value);
+};
+
+template<typename BasicJsonType, typename ConstructibleObjectType>
+struct is_constructible_object_type
+    : is_constructible_object_type_impl<BasicJsonType,
+      ConstructibleObjectType> {};
+
+template<typename BasicJsonType, typename CompatibleStringType>
+struct is_compatible_string_type
+{
+    static constexpr auto value =
+        is_constructible<typename BasicJsonType::string_t, CompatibleStringType>::value;
+};
+
+template<typename BasicJsonType, typename ConstructibleStringType>
+struct is_constructible_string_type
+{
+    static constexpr auto value =
+        is_constructible<ConstructibleStringType,
+        typename BasicJsonType::string_t>::value;
+};
+
+template<typename BasicJsonType, typename CompatibleArrayType, typename = void>
+struct is_compatible_array_type_impl : std::false_type {};
+
+template<typename BasicJsonType, typename CompatibleArrayType>
+struct is_compatible_array_type_impl <
+    BasicJsonType, CompatibleArrayType,
+    enable_if_t <
+    is_detected<iterator_t, CompatibleArrayType>::value&&
+    is_iterator_traits<iterator_traits<detected_t<iterator_t, CompatibleArrayType>>>::value&&
+// special case for types like std::filesystem::path whose iterator's value_type are themselves
+// c.f. https://github.com/nlohmann/json/pull/3073
+    !std::is_same<CompatibleArrayType, detected_t<range_value_t, CompatibleArrayType>>::value >>
+{
+    static constexpr bool value =
+        is_constructible<BasicJsonType,
+        range_value_t<CompatibleArrayType>>::value;
+};
+
+template<typename BasicJsonType, typename CompatibleArrayType>
+struct is_compatible_array_type
+    : is_compatible_array_type_impl<BasicJsonType, CompatibleArrayType> {};
+
+template<typename BasicJsonType, typename ConstructibleArrayType, typename = void>
+struct is_constructible_array_type_impl : std::false_type {};
+
+template<typename BasicJsonType, typename ConstructibleArrayType>
+struct is_constructible_array_type_impl <
+    BasicJsonType, ConstructibleArrayType,
+    enable_if_t<std::is_same<ConstructibleArrayType,
+    typename BasicJsonType::value_type>::value >>
+            : std::true_type {};
+
+template<typename BasicJsonType, typename ConstructibleArrayType>
+struct is_constructible_array_type_impl <
+    BasicJsonType, ConstructibleArrayType,
+    enable_if_t < !std::is_same<ConstructibleArrayType,
+    typename BasicJsonType::value_type>::value&&
+    !is_compatible_string_type<BasicJsonType, ConstructibleArrayType>::value&&
+    is_default_constructible<ConstructibleArrayType>::value&&
+(std::is_move_assignable<ConstructibleArrayType>::value ||
+ std::is_copy_assignable<ConstructibleArrayType>::value)&&
+is_detected<iterator_t, ConstructibleArrayType>::value&&
+is_iterator_traits<iterator_traits<detected_t<iterator_t, ConstructibleArrayType>>>::value&&
+is_detected<range_value_t, ConstructibleArrayType>::value&&
+// special case for types like std::filesystem::path whose iterator's value_type are themselves
+// c.f. https://github.com/nlohmann/json/pull/3073
+!std::is_same<ConstructibleArrayType, detected_t<range_value_t, ConstructibleArrayType>>::value&&
+        is_complete_type <
+        detected_t<range_value_t, ConstructibleArrayType >>::value >>
+{
+    using value_type = range_value_t<ConstructibleArrayType>;
+
+    static constexpr bool value =
+        std::is_same<value_type,
+        typename BasicJsonType::array_t::value_type>::value ||
+        has_from_json<BasicJsonType,
+        value_type>::value ||
+        has_non_default_from_json <
+        BasicJsonType,
+        value_type >::value;
+};
+
+template<typename BasicJsonType, typename ConstructibleArrayType>
+struct is_constructible_array_type
+    : is_constructible_array_type_impl<BasicJsonType, ConstructibleArrayType> {};
+
+template<typename RealIntegerType, typename CompatibleNumberIntegerType,
+         typename = void>
+struct is_compatible_integer_type_impl : std::false_type {};
+
+template<typename RealIntegerType, typename CompatibleNumberIntegerType>
+struct is_compatible_integer_type_impl <
+    RealIntegerType, CompatibleNumberIntegerType,
+    enable_if_t < std::is_integral<RealIntegerType>::value&&
+    std::is_integral<CompatibleNumberIntegerType>::value&&
+    !std::is_same<bool, CompatibleNumberIntegerType>::value >>
+{
+    // is there an assert somewhere on overflows?
+    using RealLimits = std::numeric_limits<RealIntegerType>;
+    using CompatibleLimits = std::numeric_limits<CompatibleNumberIntegerType>;
+
+    static constexpr auto value =
+        is_constructible<RealIntegerType,
+        CompatibleNumberIntegerType>::value &&
+        CompatibleLimits::is_integer &&
+        RealLimits::is_signed == CompatibleLimits::is_signed;
+};
+
+template<typename RealIntegerType, typename CompatibleNumberIntegerType>
+struct is_compatible_integer_type
+    : is_compatible_integer_type_impl<RealIntegerType,
+      CompatibleNumberIntegerType> {};
+
+template<typename BasicJsonType, typename CompatibleType, typename = void>
+struct is_compatible_type_impl: std::false_type {};
+
+template<typename BasicJsonType, typename CompatibleType>
+struct is_compatible_type_impl <
+    BasicJsonType, CompatibleType,
+    enable_if_t<is_complete_type<CompatibleType>::value >>
+{
+    static constexpr bool value =
+        has_to_json<BasicJsonType, CompatibleType>::value;
+};
+
+template<typename BasicJsonType, typename CompatibleType>
+struct is_compatible_type
+    : is_compatible_type_impl<BasicJsonType, CompatibleType> {};
+
+template<typename T1, typename T2>
+struct is_constructible_tuple : std::false_type {};
+
+template<typename T1, typename... Args>
+struct is_constructible_tuple<T1, std::tuple<Args...>> : conjunction<is_constructible<T1, Args>...> {};
+
+// a naive helper to check if a type is an ordered_map (exploits the fact that
+// ordered_map inherits capacity() from std::vector)
+template <typename T>
+struct is_ordered_map
+{
+    using one = char;
+
+    struct two
+    {
+        char x[2]; // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
+    };
+
+    template <typename C> static one test( decltype(&C::capacity) ) ;
+    template <typename C> static two test(...);
+
+    enum { value = sizeof(test<T>(nullptr)) == sizeof(char) }; // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+};
+
+// to avoid useless casts (see https://github.com/nlohmann/json/issues/2893#issuecomment-889152324)
+template < typename T, typename U, enable_if_t < !std::is_same<T, U>::value, int > = 0 >
+T conditional_static_cast(U value)
+{
+    return static_cast<T>(value);
+}
+
+template<typename T, typename U, enable_if_t<std::is_same<T, U>::value, int> = 0>
+T conditional_static_cast(U value)
+{
+    return value;
+}
+
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+#if JSON_HAS_EXPERIMENTAL_FILESYSTEM
+#include <experimental/filesystem>
+namespace nlohmann::detail
+{
+namespace std_fs = std::experimental::filesystem;
+} // namespace nlohmann::detail
+#elif JSON_HAS_FILESYSTEM
+#include <filesystem>
+namespace nlohmann::detail
+{
+namespace std_fs = std::filesystem;
+} // namespace nlohmann::detail
+#endif
+
+namespace nlohmann
+{
+namespace detail
+{
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, typename std::nullptr_t& n)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_null()))
+    {
+        JSON_THROW(type_error::create(302, "type must be null, but is " + std::string(j.type_name()), j));
+    }
+    n = nullptr;
+}
+
+// overloads for basic_json template parameters
+template < typename BasicJsonType, typename ArithmeticType,
+           enable_if_t < std::is_arithmetic<ArithmeticType>::value&&
+                         !std::is_same<ArithmeticType, typename BasicJsonType::boolean_t>::value,
+                         int > = 0 >
+void get_arithmetic_value(const BasicJsonType& j, ArithmeticType& val)
+{
+    switch (static_cast<value_t>(j))
+    {
+        case value_t::number_unsigned:
+        {
+            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_unsigned_t*>());
+            break;
+        }
+        case value_t::number_integer:
+        {
+            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_integer_t*>());
+            break;
+        }
+        case value_t::number_float:
+        {
+            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_float_t*>());
+            break;
+        }
+
+        case value_t::null:
+        case value_t::object:
+        case value_t::array:
+        case value_t::string:
+        case value_t::boolean:
+        case value_t::binary:
+        case value_t::discarded:
+        default:
+            JSON_THROW(type_error::create(302, "type must be number, but is " + std::string(j.type_name()), j));
+    }
+}
+
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, typename BasicJsonType::boolean_t& b)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_boolean()))
+    {
+        JSON_THROW(type_error::create(302, "type must be boolean, but is " + std::string(j.type_name()), j));
+    }
+    b = *j.template get_ptr<const typename BasicJsonType::boolean_t*>();
+}
+
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, typename BasicJsonType::string_t& s)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_string()))
+    {
+        JSON_THROW(type_error::create(302, "type must be string, but is " + std::string(j.type_name()), j));
+    }
+    s = *j.template get_ptr<const typename BasicJsonType::string_t*>();
+}
+
+template <
+    typename BasicJsonType, typename ConstructibleStringType,
+    enable_if_t <
+        is_constructible_string_type<BasicJsonType, ConstructibleStringType>::value&&
+        !std::is_same<typename BasicJsonType::string_t,
+                      ConstructibleStringType>::value,
+        int > = 0 >
+void from_json(const BasicJsonType& j, ConstructibleStringType& s)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_string()))
+    {
+        JSON_THROW(type_error::create(302, "type must be string, but is " + std::string(j.type_name()), j));
+    }
+
+    s = *j.template get_ptr<const typename BasicJsonType::string_t*>();
+}
+
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, typename BasicJsonType::number_float_t& val)
+{
+    get_arithmetic_value(j, val);
+}
+
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, typename BasicJsonType::number_unsigned_t& val)
+{
+    get_arithmetic_value(j, val);
+}
+
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, typename BasicJsonType::number_integer_t& val)
+{
+    get_arithmetic_value(j, val);
+}
+
+template<typename BasicJsonType, typename EnumType,
+         enable_if_t<std::is_enum<EnumType>::value, int> = 0>
+void from_json(const BasicJsonType& j, EnumType& e)
+{
+    typename std::underlying_type<EnumType>::type val;
+    get_arithmetic_value(j, val);
+    e = static_cast<EnumType>(val);
+}
+
+// forward_list doesn't have an insert method
+template<typename BasicJsonType, typename T, typename Allocator,
+         enable_if_t<is_getable<BasicJsonType, T>::value, int> = 0>
+void from_json(const BasicJsonType& j, std::forward_list<T, Allocator>& l)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
+    {
+        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
+    }
+    l.clear();
+    std::transform(j.rbegin(), j.rend(),
+                   std::front_inserter(l), [](const BasicJsonType & i)
+    {
+        return i.template get<T>();
+    });
+}
+
+// valarray doesn't have an insert method
+template<typename BasicJsonType, typename T,
+         enable_if_t<is_getable<BasicJsonType, T>::value, int> = 0>
+void from_json(const BasicJsonType& j, std::valarray<T>& l)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
+    {
+        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
+    }
+    l.resize(j.size());
+    std::transform(j.begin(), j.end(), std::begin(l),
+                   [](const BasicJsonType & elem)
+    {
+        return elem.template get<T>();
+    });
+}
+
+template<typename BasicJsonType, typename T, std::size_t N>
+auto from_json(const BasicJsonType& j, T (&arr)[N])  // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
+-> decltype(j.template get<T>(), void())
+{
+    for (std::size_t i = 0; i < N; ++i)
+    {
+        arr[i] = j.at(i).template get<T>();
+    }
+}
+
+template<typename BasicJsonType>
+void from_json_array_impl(const BasicJsonType& j, typename BasicJsonType::array_t& arr, priority_tag<3> /*unused*/)
+{
+    arr = *j.template get_ptr<const typename BasicJsonType::array_t*>();
+}
+
+template<typename BasicJsonType, typename T, std::size_t N>
+auto from_json_array_impl(const BasicJsonType& j, std::array<T, N>& arr,
+                          priority_tag<2> /*unused*/)
+-> decltype(j.template get<T>(), void())
+{
+    for (std::size_t i = 0; i < N; ++i)
+    {
+        arr[i] = j.at(i).template get<T>();
+    }
+}
+
+template<typename BasicJsonType, typename ConstructibleArrayType,
+         enable_if_t<
+             std::is_assignable<ConstructibleArrayType&, ConstructibleArrayType>::value,
+             int> = 0>
+auto from_json_array_impl(const BasicJsonType& j, ConstructibleArrayType& arr, priority_tag<1> /*unused*/)
+-> decltype(
+    arr.reserve(std::declval<typename ConstructibleArrayType::size_type>()),
+    j.template get<typename ConstructibleArrayType::value_type>(),
+    void())
+{
+    using std::end;
+
+    ConstructibleArrayType ret;
+    ret.reserve(j.size());
+    std::transform(j.begin(), j.end(),
+                   std::inserter(ret, end(ret)), [](const BasicJsonType & i)
+    {
+        // get<BasicJsonType>() returns *this, this won't call a from_json
+        // method when value_type is BasicJsonType
+        return i.template get<typename ConstructibleArrayType::value_type>();
+    });
+    arr = std::move(ret);
+}
+
+template<typename BasicJsonType, typename ConstructibleArrayType,
+         enable_if_t<
+             std::is_assignable<ConstructibleArrayType&, ConstructibleArrayType>::value,
+             int> = 0>
+void from_json_array_impl(const BasicJsonType& j, ConstructibleArrayType& arr,
+                          priority_tag<0> /*unused*/)
+{
+    using std::end;
+
+    ConstructibleArrayType ret;
+    std::transform(
+        j.begin(), j.end(), std::inserter(ret, end(ret)),
+        [](const BasicJsonType & i)
+    {
+        // get<BasicJsonType>() returns *this, this won't call a from_json
+        // method when value_type is BasicJsonType
+        return i.template get<typename ConstructibleArrayType::value_type>();
+    });
+    arr = std::move(ret);
+}
+
+template < typename BasicJsonType, typename ConstructibleArrayType,
+           enable_if_t <
+               is_constructible_array_type<BasicJsonType, ConstructibleArrayType>::value&&
+               !is_constructible_object_type<BasicJsonType, ConstructibleArrayType>::value&&
+               !is_constructible_string_type<BasicJsonType, ConstructibleArrayType>::value&&
+               !std::is_same<ConstructibleArrayType, typename BasicJsonType::binary_t>::value&&
+               !is_basic_json<ConstructibleArrayType>::value,
+               int > = 0 >
+auto from_json(const BasicJsonType& j, ConstructibleArrayType& arr)
+-> decltype(from_json_array_impl(j, arr, priority_tag<3> {}),
+j.template get<typename ConstructibleArrayType::value_type>(),
+void())
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
+    {
+        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
+    }
+
+    from_json_array_impl(j, arr, priority_tag<3> {});
+}
+
+template < typename BasicJsonType, typename T, std::size_t... Idx >
+std::array<T, sizeof...(Idx)> from_json_inplace_array_impl(BasicJsonType&& j,
+        identity_tag<std::array<T, sizeof...(Idx)>> /*unused*/, index_sequence<Idx...> /*unused*/)
+{
+    return { { std::forward<BasicJsonType>(j).at(Idx).template get<T>()... } };
+}
+
+template < typename BasicJsonType, typename T, std::size_t N >
+auto from_json(BasicJsonType&& j, identity_tag<std::array<T, N>> tag)
+-> decltype(from_json_inplace_array_impl(std::forward<BasicJsonType>(j), tag, make_index_sequence<N> {}))
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
+    {
+        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
+    }
+
+    return from_json_inplace_array_impl(std::forward<BasicJsonType>(j), tag, make_index_sequence<N> {});
+}
+
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, typename BasicJsonType::binary_t& bin)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_binary()))
+    {
+        JSON_THROW(type_error::create(302, "type must be binary, but is " + std::string(j.type_name()), j));
+    }
+
+    bin = *j.template get_ptr<const typename BasicJsonType::binary_t*>();
+}
+
+template<typename BasicJsonType, typename ConstructibleObjectType,
+         enable_if_t<is_constructible_object_type<BasicJsonType, ConstructibleObjectType>::value, int> = 0>
+void from_json(const BasicJsonType& j, ConstructibleObjectType& obj)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_object()))
+    {
+        JSON_THROW(type_error::create(302, "type must be object, but is " + std::string(j.type_name()), j));
+    }
+
+    ConstructibleObjectType ret;
+    const auto* inner_object = j.template get_ptr<const typename BasicJsonType::object_t*>();
+    using value_type = typename ConstructibleObjectType::value_type;
+    std::transform(
+        inner_object->begin(), inner_object->end(),
+        std::inserter(ret, ret.begin()),
+        [](typename BasicJsonType::object_t::value_type const & p)
+    {
+        return value_type(p.first, p.second.template get<typename ConstructibleObjectType::mapped_type>());
+    });
+    obj = std::move(ret);
+}
+
+// overload for arithmetic types, not chosen for basic_json template arguments
+// (BooleanType, etc..); note: Is it really necessary to provide explicit
+// overloads for boolean_t etc. in case of a custom BooleanType which is not
+// an arithmetic type?
+template < typename BasicJsonType, typename ArithmeticType,
+           enable_if_t <
+               std::is_arithmetic<ArithmeticType>::value&&
+               !std::is_same<ArithmeticType, typename BasicJsonType::number_unsigned_t>::value&&
+               !std::is_same<ArithmeticType, typename BasicJsonType::number_integer_t>::value&&
+               !std::is_same<ArithmeticType, typename BasicJsonType::number_float_t>::value&&
+               !std::is_same<ArithmeticType, typename BasicJsonType::boolean_t>::value,
+               int > = 0 >
+void from_json(const BasicJsonType& j, ArithmeticType& val)
+{
+    switch (static_cast<value_t>(j))
+    {
+        case value_t::number_unsigned:
+        {
+            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_unsigned_t*>());
+            break;
+        }
+        case value_t::number_integer:
+        {
+            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_integer_t*>());
+            break;
+        }
+        case value_t::number_float:
+        {
+            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_float_t*>());
+            break;
+        }
+        case value_t::boolean:
+        {
+            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::boolean_t*>());
+            break;
+        }
+
+        case value_t::null:
+        case value_t::object:
+        case value_t::array:
+        case value_t::string:
+        case value_t::binary:
+        case value_t::discarded:
+        default:
+            JSON_THROW(type_error::create(302, "type must be number, but is " + std::string(j.type_name()), j));
+    }
+}
+
+template<typename BasicJsonType, typename... Args, std::size_t... Idx>
+std::tuple<Args...> from_json_tuple_impl_base(BasicJsonType&& j, index_sequence<Idx...> /*unused*/)
+{
+    return std::make_tuple(std::forward<BasicJsonType>(j).at(Idx).template get<Args>()...);
+}
+
+template < typename BasicJsonType, class A1, class A2 >
+std::pair<A1, A2> from_json_tuple_impl(BasicJsonType&& j, identity_tag<std::pair<A1, A2>> /*unused*/, priority_tag<0> /*unused*/)
+{
+    return {std::forward<BasicJsonType>(j).at(0).template get<A1>(),
+            std::forward<BasicJsonType>(j).at(1).template get<A2>()};
+}
+
+template<typename BasicJsonType, typename A1, typename A2>
+void from_json_tuple_impl(BasicJsonType&& j, std::pair<A1, A2>& p, priority_tag<1> /*unused*/)
+{
+    p = from_json_tuple_impl(std::forward<BasicJsonType>(j), identity_tag<std::pair<A1, A2>> {}, priority_tag<0> {});
+}
+
+template<typename BasicJsonType, typename... Args>
+std::tuple<Args...> from_json_tuple_impl(BasicJsonType&& j, identity_tag<std::tuple<Args...>> /*unused*/, priority_tag<2> /*unused*/)
+{
+    return from_json_tuple_impl_base<BasicJsonType, Args...>(std::forward<BasicJsonType>(j), index_sequence_for<Args...> {});
+}
+
+template<typename BasicJsonType, typename... Args>
+void from_json_tuple_impl(BasicJsonType&& j, std::tuple<Args...>& t, priority_tag<3> /*unused*/)
+{
+    t = from_json_tuple_impl_base<BasicJsonType, Args...>(std::forward<BasicJsonType>(j), index_sequence_for<Args...> {});
+}
+
+template<typename BasicJsonType, typename TupleRelated>
+auto from_json(BasicJsonType&& j, TupleRelated&& t)
+-> decltype(from_json_tuple_impl(std::forward<BasicJsonType>(j), std::forward<TupleRelated>(t), priority_tag<3> {}))
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
+    {
+        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
+    }
+
+    return from_json_tuple_impl(std::forward<BasicJsonType>(j), std::forward<TupleRelated>(t), priority_tag<3> {});
+}
+
+template < typename BasicJsonType, typename Key, typename Value, typename Compare, typename Allocator,
+           typename = enable_if_t < !std::is_constructible <
+                                        typename BasicJsonType::string_t, Key >::value >>
+void from_json(const BasicJsonType& j, std::map<Key, Value, Compare, Allocator>& m)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
+    {
+        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
+    }
+    m.clear();
+    for (const auto& p : j)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!p.is_array()))
+        {
+            JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(p.type_name()), j));
+        }
+        m.emplace(p.at(0).template get<Key>(), p.at(1).template get<Value>());
+    }
+}
+
+template < typename BasicJsonType, typename Key, typename Value, typename Hash, typename KeyEqual, typename Allocator,
+           typename = enable_if_t < !std::is_constructible <
+                                        typename BasicJsonType::string_t, Key >::value >>
+void from_json(const BasicJsonType& j, std::unordered_map<Key, Value, Hash, KeyEqual, Allocator>& m)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
+    {
+        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
+    }
+    m.clear();
+    for (const auto& p : j)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!p.is_array()))
+        {
+            JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(p.type_name()), j));
+        }
+        m.emplace(p.at(0).template get<Key>(), p.at(1).template get<Value>());
+    }
+}
+
+#if JSON_HAS_FILESYSTEM || JSON_HAS_EXPERIMENTAL_FILESYSTEM
+template<typename BasicJsonType>
+void from_json(const BasicJsonType& j, std_fs::path& p)
+{
+    if (JSON_HEDLEY_UNLIKELY(!j.is_string()))
+    {
+        JSON_THROW(type_error::create(302, "type must be string, but is " + std::string(j.type_name()), j));
+    }
+    p = *j.template get_ptr<const typename BasicJsonType::string_t*>();
+}
+#endif
+
+struct from_json_fn
+{
+    template<typename BasicJsonType, typename T>
+    auto operator()(const BasicJsonType& j, T&& val) const
+    noexcept(noexcept(from_json(j, std::forward<T>(val))))
+    -> decltype(from_json(j, std::forward<T>(val)))
+    {
+        return from_json(j, std::forward<T>(val));
+    }
+};
+}  // namespace detail
+
+/// namespace to hold default `from_json` function
+/// to see why this is required:
+/// http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2015/n4381.html
+namespace // NOLINT(cert-dcl59-cpp,fuchsia-header-anon-namespaces,google-build-namespaces)
+{
+constexpr const auto& from_json = detail::static_const<detail::from_json_fn>::value; // NOLINT(misc-definitions-in-headers)
+} // namespace
+} // namespace nlohmann
+
+// #include <nlohmann/detail/conversions/to_json.hpp>
+
+
+#include <algorithm> // copy
+#include <iterator> // begin, end
+#include <string> // string
+#include <tuple> // tuple, get
+#include <type_traits> // is_same, is_constructible, is_floating_point, is_enum, underlying_type
+#include <utility> // move, forward, declval, pair
+#include <valarray> // valarray
+#include <vector> // vector
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/iterators/iteration_proxy.hpp>
+
+
+#include <cstddef> // size_t
+#include <iterator> // input_iterator_tag
+#include <string> // string, to_string
+#include <tuple> // tuple_size, get, tuple_element
+#include <utility> // move
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+template<typename string_type>
+void int_to_string( string_type& target, std::size_t value )
+{
+    // For ADL
+    using std::to_string;
+    target = to_string(value);
+}
+template<typename IteratorType> class iteration_proxy_value
+{
+  public:
+    using difference_type = std::ptrdiff_t;
+    using value_type = iteration_proxy_value;
+    using pointer = value_type * ;
+    using reference = value_type & ;
+    using iterator_category = std::input_iterator_tag;
+    using string_type = typename std::remove_cv< typename std::remove_reference<decltype( std::declval<IteratorType>().key() ) >::type >::type;
+
+  private:
+    /// the iterator
+    IteratorType anchor;
+    /// an index for arrays (used to create key names)
+    std::size_t array_index = 0;
+    /// last stringified array index
+    mutable std::size_t array_index_last = 0;
+    /// a string representation of the array index
+    mutable string_type array_index_str = "0";
+    /// an empty string (to return a reference for primitive values)
+    const string_type empty_str{};
+
+  public:
+    explicit iteration_proxy_value(IteratorType it) noexcept
+        : anchor(std::move(it))
+    {}
+
+    /// dereference operator (needed for range-based for)
+    iteration_proxy_value& operator*()
+    {
+        return *this;
+    }
+
+    /// increment operator (needed for range-based for)
+    iteration_proxy_value& operator++()
+    {
+        ++anchor;
+        ++array_index;
+
+        return *this;
+    }
+
+    /// equality operator (needed for InputIterator)
+    bool operator==(const iteration_proxy_value& o) const
+    {
+        return anchor == o.anchor;
+    }
+
+    /// inequality operator (needed for range-based for)
+    bool operator!=(const iteration_proxy_value& o) const
+    {
+        return anchor != o.anchor;
+    }
+
+    /// return key of the iterator
+    const string_type& key() const
+    {
+        JSON_ASSERT(anchor.m_object != nullptr);
+
+        switch (anchor.m_object->type())
+        {
+            // use integer array index as key
+            case value_t::array:
+            {
+                if (array_index != array_index_last)
+                {
+                    int_to_string( array_index_str, array_index );
+                    array_index_last = array_index;
+                }
+                return array_index_str;
+            }
+
+            // use key from the object
+            case value_t::object:
+                return anchor.key();
+
+            // use an empty key for all primitive types
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+                return empty_str;
+        }
+    }
+
+    /// return value of the iterator
+    typename IteratorType::reference value() const
+    {
+        return anchor.value();
+    }
+};
+
+/// proxy class for the items() function
+template<typename IteratorType> class iteration_proxy
+{
+  private:
+    /// the container to iterate
+    typename IteratorType::reference container;
+
+  public:
+    /// construct iteration proxy from a container
+    explicit iteration_proxy(typename IteratorType::reference cont) noexcept
+        : container(cont) {}
+
+    /// return iterator begin (needed for range-based for)
+    iteration_proxy_value<IteratorType> begin() noexcept
+    {
+        return iteration_proxy_value<IteratorType>(container.begin());
+    }
+
+    /// return iterator end (needed for range-based for)
+    iteration_proxy_value<IteratorType> end() noexcept
+    {
+        return iteration_proxy_value<IteratorType>(container.end());
+    }
+};
+// Structured Bindings Support
+// For further reference see https://blog.tartanllama.xyz/structured-bindings/
+// And see https://github.com/nlohmann/json/pull/1391
+template<std::size_t N, typename IteratorType, enable_if_t<N == 0, int> = 0>
+auto get(const nlohmann::detail::iteration_proxy_value<IteratorType>& i) -> decltype(i.key())
+{
+    return i.key();
+}
+// Structured Bindings Support
+// For further reference see https://blog.tartanllama.xyz/structured-bindings/
+// And see https://github.com/nlohmann/json/pull/1391
+template<std::size_t N, typename IteratorType, enable_if_t<N == 1, int> = 0>
+auto get(const nlohmann::detail::iteration_proxy_value<IteratorType>& i) -> decltype(i.value())
+{
+    return i.value();
+}
+}  // namespace detail
+}  // namespace nlohmann
+
+// The Addition to the STD Namespace is required to add
+// Structured Bindings Support to the iteration_proxy_value class
+// For further reference see https://blog.tartanllama.xyz/structured-bindings/
+// And see https://github.com/nlohmann/json/pull/1391
+namespace std
+{
+#if defined(__clang__)
+    // Fix: https://github.com/nlohmann/json/issues/1401
+    #pragma clang diagnostic push
+    #pragma clang diagnostic ignored "-Wmismatched-tags"
+#endif
+template<typename IteratorType>
+class tuple_size<::nlohmann::detail::iteration_proxy_value<IteratorType>>
+            : public std::integral_constant<std::size_t, 2> {};
+
+template<std::size_t N, typename IteratorType>
+class tuple_element<N, ::nlohmann::detail::iteration_proxy_value<IteratorType >>
+{
+  public:
+    using type = decltype(
+                     get<N>(std::declval <
+                            ::nlohmann::detail::iteration_proxy_value<IteratorType >> ()));
+};
+#if defined(__clang__)
+    #pragma clang diagnostic pop
+#endif
+} // namespace std
+
+// #include <nlohmann/detail/meta/cpp_future.hpp>
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+#if JSON_HAS_EXPERIMENTAL_FILESYSTEM
+#include <experimental/filesystem>
+namespace nlohmann::detail
+{
+namespace std_fs = std::experimental::filesystem;
+} // namespace nlohmann::detail
+#elif JSON_HAS_FILESYSTEM
+#include <filesystem>
+namespace nlohmann::detail
+{
+namespace std_fs = std::filesystem;
+} // namespace nlohmann::detail
+#endif
+
+namespace nlohmann
+{
+namespace detail
+{
+//////////////////
+// constructors //
+//////////////////
+
+/*
+ * Note all external_constructor<>::construct functions need to call
+ * j.m_value.destroy(j.m_type) to avoid a memory leak in case j contains an
+ * allocated value (e.g., a string). See bug issue
+ * https://github.com/nlohmann/json/issues/2865 for more information.
+ */
+
+template<value_t> struct external_constructor;
+
+template<>
+struct external_constructor<value_t::boolean>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::boolean_t b) noexcept
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::boolean;
+        j.m_value = b;
+        j.assert_invariant();
+    }
+};
+
+template<>
+struct external_constructor<value_t::string>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, const typename BasicJsonType::string_t& s)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::string;
+        j.m_value = s;
+        j.assert_invariant();
+    }
+
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::string_t&& s)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::string;
+        j.m_value = std::move(s);
+        j.assert_invariant();
+    }
+
+    template < typename BasicJsonType, typename CompatibleStringType,
+               enable_if_t < !std::is_same<CompatibleStringType, typename BasicJsonType::string_t>::value,
+                             int > = 0 >
+    static void construct(BasicJsonType& j, const CompatibleStringType& str)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::string;
+        j.m_value.string = j.template create<typename BasicJsonType::string_t>(str);
+        j.assert_invariant();
+    }
+};
+
+template<>
+struct external_constructor<value_t::binary>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, const typename BasicJsonType::binary_t& b)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::binary;
+        j.m_value = typename BasicJsonType::binary_t(b);
+        j.assert_invariant();
+    }
+
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::binary_t&& b)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::binary;
+        j.m_value = typename BasicJsonType::binary_t(std::move(b));
+        j.assert_invariant();
+    }
+};
+
+template<>
+struct external_constructor<value_t::number_float>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::number_float_t val) noexcept
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::number_float;
+        j.m_value = val;
+        j.assert_invariant();
+    }
+};
+
+template<>
+struct external_constructor<value_t::number_unsigned>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::number_unsigned_t val) noexcept
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::number_unsigned;
+        j.m_value = val;
+        j.assert_invariant();
+    }
+};
+
+template<>
+struct external_constructor<value_t::number_integer>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::number_integer_t val) noexcept
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::number_integer;
+        j.m_value = val;
+        j.assert_invariant();
+    }
+};
+
+template<>
+struct external_constructor<value_t::array>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, const typename BasicJsonType::array_t& arr)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::array;
+        j.m_value = arr;
+        j.set_parents();
+        j.assert_invariant();
+    }
+
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::array_t&& arr)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::array;
+        j.m_value = std::move(arr);
+        j.set_parents();
+        j.assert_invariant();
+    }
+
+    template < typename BasicJsonType, typename CompatibleArrayType,
+               enable_if_t < !std::is_same<CompatibleArrayType, typename BasicJsonType::array_t>::value,
+                             int > = 0 >
+    static void construct(BasicJsonType& j, const CompatibleArrayType& arr)
+    {
+        using std::begin;
+        using std::end;
+
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::array;
+        j.m_value.array = j.template create<typename BasicJsonType::array_t>(begin(arr), end(arr));
+        j.set_parents();
+        j.assert_invariant();
+    }
+
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, const std::vector<bool>& arr)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::array;
+        j.m_value = value_t::array;
+        j.m_value.array->reserve(arr.size());
+        for (const bool x : arr)
+        {
+            j.m_value.array->push_back(x);
+            j.set_parent(j.m_value.array->back());
+        }
+        j.assert_invariant();
+    }
+
+    template<typename BasicJsonType, typename T,
+             enable_if_t<std::is_convertible<T, BasicJsonType>::value, int> = 0>
+    static void construct(BasicJsonType& j, const std::valarray<T>& arr)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::array;
+        j.m_value = value_t::array;
+        j.m_value.array->resize(arr.size());
+        if (arr.size() > 0)
+        {
+            std::copy(std::begin(arr), std::end(arr), j.m_value.array->begin());
+        }
+        j.set_parents();
+        j.assert_invariant();
+    }
+};
+
+template<>
+struct external_constructor<value_t::object>
+{
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, const typename BasicJsonType::object_t& obj)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::object;
+        j.m_value = obj;
+        j.set_parents();
+        j.assert_invariant();
+    }
+
+    template<typename BasicJsonType>
+    static void construct(BasicJsonType& j, typename BasicJsonType::object_t&& obj)
+    {
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::object;
+        j.m_value = std::move(obj);
+        j.set_parents();
+        j.assert_invariant();
+    }
+
+    template < typename BasicJsonType, typename CompatibleObjectType,
+               enable_if_t < !std::is_same<CompatibleObjectType, typename BasicJsonType::object_t>::value, int > = 0 >
+    static void construct(BasicJsonType& j, const CompatibleObjectType& obj)
+    {
+        using std::begin;
+        using std::end;
+
+        j.m_value.destroy(j.m_type);
+        j.m_type = value_t::object;
+        j.m_value.object = j.template create<typename BasicJsonType::object_t>(begin(obj), end(obj));
+        j.set_parents();
+        j.assert_invariant();
+    }
+};
+
+/////////////
+// to_json //
+/////////////
+
+template<typename BasicJsonType, typename T,
+         enable_if_t<std::is_same<T, typename BasicJsonType::boolean_t>::value, int> = 0>
+void to_json(BasicJsonType& j, T b) noexcept
+{
+    external_constructor<value_t::boolean>::construct(j, b);
+}
+
+template<typename BasicJsonType, typename CompatibleString,
+         enable_if_t<std::is_constructible<typename BasicJsonType::string_t, CompatibleString>::value, int> = 0>
+void to_json(BasicJsonType& j, const CompatibleString& s)
+{
+    external_constructor<value_t::string>::construct(j, s);
+}
+
+template<typename BasicJsonType>
+void to_json(BasicJsonType& j, typename BasicJsonType::string_t&& s)
+{
+    external_constructor<value_t::string>::construct(j, std::move(s));
+}
+
+template<typename BasicJsonType, typename FloatType,
+         enable_if_t<std::is_floating_point<FloatType>::value, int> = 0>
+void to_json(BasicJsonType& j, FloatType val) noexcept
+{
+    external_constructor<value_t::number_float>::construct(j, static_cast<typename BasicJsonType::number_float_t>(val));
+}
+
+template<typename BasicJsonType, typename CompatibleNumberUnsignedType,
+         enable_if_t<is_compatible_integer_type<typename BasicJsonType::number_unsigned_t, CompatibleNumberUnsignedType>::value, int> = 0>
+void to_json(BasicJsonType& j, CompatibleNumberUnsignedType val) noexcept
+{
+    external_constructor<value_t::number_unsigned>::construct(j, static_cast<typename BasicJsonType::number_unsigned_t>(val));
+}
+
+template<typename BasicJsonType, typename CompatibleNumberIntegerType,
+         enable_if_t<is_compatible_integer_type<typename BasicJsonType::number_integer_t, CompatibleNumberIntegerType>::value, int> = 0>
+void to_json(BasicJsonType& j, CompatibleNumberIntegerType val) noexcept
+{
+    external_constructor<value_t::number_integer>::construct(j, static_cast<typename BasicJsonType::number_integer_t>(val));
+}
+
+template<typename BasicJsonType, typename EnumType,
+         enable_if_t<std::is_enum<EnumType>::value, int> = 0>
+void to_json(BasicJsonType& j, EnumType e) noexcept
+{
+    using underlying_type = typename std::underlying_type<EnumType>::type;
+    external_constructor<value_t::number_integer>::construct(j, static_cast<underlying_type>(e));
+}
+
+template<typename BasicJsonType>
+void to_json(BasicJsonType& j, const std::vector<bool>& e)
+{
+    external_constructor<value_t::array>::construct(j, e);
+}
+
+template < typename BasicJsonType, typename CompatibleArrayType,
+           enable_if_t < is_compatible_array_type<BasicJsonType,
+                         CompatibleArrayType>::value&&
+                         !is_compatible_object_type<BasicJsonType, CompatibleArrayType>::value&&
+                         !is_compatible_string_type<BasicJsonType, CompatibleArrayType>::value&&
+                         !std::is_same<typename BasicJsonType::binary_t, CompatibleArrayType>::value&&
+                         !is_basic_json<CompatibleArrayType>::value,
+                         int > = 0 >
+void to_json(BasicJsonType& j, const CompatibleArrayType& arr)
+{
+    external_constructor<value_t::array>::construct(j, arr);
+}
+
+template<typename BasicJsonType>
+void to_json(BasicJsonType& j, const typename BasicJsonType::binary_t& bin)
+{
+    external_constructor<value_t::binary>::construct(j, bin);
+}
+
+template<typename BasicJsonType, typename T,
+         enable_if_t<std::is_convertible<T, BasicJsonType>::value, int> = 0>
+void to_json(BasicJsonType& j, const std::valarray<T>& arr)
+{
+    external_constructor<value_t::array>::construct(j, std::move(arr));
+}
+
+template<typename BasicJsonType>
+void to_json(BasicJsonType& j, typename BasicJsonType::array_t&& arr)
+{
+    external_constructor<value_t::array>::construct(j, std::move(arr));
+}
+
+template < typename BasicJsonType, typename CompatibleObjectType,
+           enable_if_t < is_compatible_object_type<BasicJsonType, CompatibleObjectType>::value&& !is_basic_json<CompatibleObjectType>::value, int > = 0 >
+void to_json(BasicJsonType& j, const CompatibleObjectType& obj)
+{
+    external_constructor<value_t::object>::construct(j, obj);
+}
+
+template<typename BasicJsonType>
+void to_json(BasicJsonType& j, typename BasicJsonType::object_t&& obj)
+{
+    external_constructor<value_t::object>::construct(j, std::move(obj));
+}
+
+template <
+    typename BasicJsonType, typename T, std::size_t N,
+    enable_if_t < !std::is_constructible<typename BasicJsonType::string_t,
+                  const T(&)[N]>::value, // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
+                  int > = 0 >
+void to_json(BasicJsonType& j, const T(&arr)[N]) // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
+{
+    external_constructor<value_t::array>::construct(j, arr);
+}
+
+template < typename BasicJsonType, typename T1, typename T2, enable_if_t < std::is_constructible<BasicJsonType, T1>::value&& std::is_constructible<BasicJsonType, T2>::value, int > = 0 >
+void to_json(BasicJsonType& j, const std::pair<T1, T2>& p)
+{
+    j = { p.first, p.second };
+}
+
+// for https://github.com/nlohmann/json/pull/1134
+template<typename BasicJsonType, typename T,
+         enable_if_t<std::is_same<T, iteration_proxy_value<typename BasicJsonType::iterator>>::value, int> = 0>
+void to_json(BasicJsonType& j, const T& b)
+{
+    j = { {b.key(), b.value()} };
+}
+
+template<typename BasicJsonType, typename Tuple, std::size_t... Idx>
+void to_json_tuple_impl(BasicJsonType& j, const Tuple& t, index_sequence<Idx...> /*unused*/)
+{
+    j = { std::get<Idx>(t)... };
+}
+
+template<typename BasicJsonType, typename T, enable_if_t<is_constructible_tuple<BasicJsonType, T>::value, int > = 0>
+void to_json(BasicJsonType& j, const T& t)
+{
+    to_json_tuple_impl(j, t, make_index_sequence<std::tuple_size<T>::value> {});
+}
+
+#if JSON_HAS_FILESYSTEM || JSON_HAS_EXPERIMENTAL_FILESYSTEM
+template<typename BasicJsonType>
+void to_json(BasicJsonType& j, const std_fs::path& p)
+{
+    j = p.string();
+}
+#endif
+
+struct to_json_fn
+{
+    template<typename BasicJsonType, typename T>
+    auto operator()(BasicJsonType& j, T&& val) const noexcept(noexcept(to_json(j, std::forward<T>(val))))
+    -> decltype(to_json(j, std::forward<T>(val)), void())
+    {
+        return to_json(j, std::forward<T>(val));
+    }
+};
+}  // namespace detail
+
+/// namespace to hold default `to_json` function
+/// to see why this is required:
+/// http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2015/n4381.html
+namespace // NOLINT(cert-dcl59-cpp,fuchsia-header-anon-namespaces,google-build-namespaces)
+{
+constexpr const auto& to_json = detail::static_const<detail::to_json_fn>::value; // NOLINT(misc-definitions-in-headers)
+} // namespace
+} // namespace nlohmann
+
+// #include <nlohmann/detail/meta/identity_tag.hpp>
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+
+namespace nlohmann
+{
+
+/// @sa https://json.nlohmann.me/api/adl_serializer/
+template<typename ValueType, typename>
+struct adl_serializer
+{
+    /// @brief convert a JSON value to any value type
+    /// @sa https://json.nlohmann.me/api/adl_serializer/from_json/
+    template<typename BasicJsonType, typename TargetType = ValueType>
+    static auto from_json(BasicJsonType && j, TargetType& val) noexcept(
+        noexcept(::nlohmann::from_json(std::forward<BasicJsonType>(j), val)))
+    -> decltype(::nlohmann::from_json(std::forward<BasicJsonType>(j), val), void())
+    {
+        ::nlohmann::from_json(std::forward<BasicJsonType>(j), val);
+    }
+
+    /// @brief convert a JSON value to any value type
+    /// @sa https://json.nlohmann.me/api/adl_serializer/from_json/
+    template<typename BasicJsonType, typename TargetType = ValueType>
+    static auto from_json(BasicJsonType && j) noexcept(
+    noexcept(::nlohmann::from_json(std::forward<BasicJsonType>(j), detail::identity_tag<TargetType> {})))
+    -> decltype(::nlohmann::from_json(std::forward<BasicJsonType>(j), detail::identity_tag<TargetType> {}))
+    {
+        return ::nlohmann::from_json(std::forward<BasicJsonType>(j), detail::identity_tag<TargetType> {});
+    }
+
+    /// @brief convert any value type to a JSON value
+    /// @sa https://json.nlohmann.me/api/adl_serializer/to_json/
+    template<typename BasicJsonType, typename TargetType = ValueType>
+    static auto to_json(BasicJsonType& j, TargetType && val) noexcept(
+        noexcept(::nlohmann::to_json(j, std::forward<TargetType>(val))))
+    -> decltype(::nlohmann::to_json(j, std::forward<TargetType>(val)), void())
+    {
+        ::nlohmann::to_json(j, std::forward<TargetType>(val));
+    }
+};
+}  // namespace nlohmann
+
+// #include <nlohmann/byte_container_with_subtype.hpp>
+
+
+#include <cstdint> // uint8_t, uint64_t
+#include <tuple> // tie
+#include <utility> // move
+
+namespace nlohmann
+{
+
+/// @brief an internal type for a backed binary type
+/// @sa https://json.nlohmann.me/api/byte_container_with_subtype/
+template<typename BinaryType>
+class byte_container_with_subtype : public BinaryType
+{
+  public:
+    using container_type = BinaryType;
+    using subtype_type = std::uint64_t;
+
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
+    byte_container_with_subtype() noexcept(noexcept(container_type()))
+        : container_type()
+    {}
+
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
+    byte_container_with_subtype(const container_type& b) noexcept(noexcept(container_type(b)))
+        : container_type(b)
+    {}
+
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
+    byte_container_with_subtype(container_type&& b) noexcept(noexcept(container_type(std::move(b))))
+        : container_type(std::move(b))
+    {}
+
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
+    byte_container_with_subtype(const container_type& b, subtype_type subtype_) noexcept(noexcept(container_type(b)))
+        : container_type(b)
+        , m_subtype(subtype_)
+        , m_has_subtype(true)
+    {}
+
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
+    byte_container_with_subtype(container_type&& b, subtype_type subtype_) noexcept(noexcept(container_type(std::move(b))))
+        : container_type(std::move(b))
+        , m_subtype(subtype_)
+        , m_has_subtype(true)
+    {}
+
+    bool operator==(const byte_container_with_subtype& rhs) const
+    {
+        return std::tie(static_cast<const BinaryType&>(*this), m_subtype, m_has_subtype) ==
+               std::tie(static_cast<const BinaryType&>(rhs), rhs.m_subtype, rhs.m_has_subtype);
+    }
+
+    bool operator!=(const byte_container_with_subtype& rhs) const
+    {
+        return !(rhs == *this);
+    }
+
+    /// @brief sets the binary subtype
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/set_subtype/
+    void set_subtype(subtype_type subtype_) noexcept
+    {
+        m_subtype = subtype_;
+        m_has_subtype = true;
+    }
+
+    /// @brief return the binary subtype
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/subtype/
+    constexpr subtype_type subtype() const noexcept
+    {
+        return m_has_subtype ? m_subtype : static_cast<subtype_type>(-1);
+    }
+
+    /// @brief return whether the value has a subtype
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/has_subtype/
+    constexpr bool has_subtype() const noexcept
+    {
+        return m_has_subtype;
+    }
+
+    /// @brief clears the binary subtype
+    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/clear_subtype/
+    void clear_subtype() noexcept
+    {
+        m_subtype = 0;
+        m_has_subtype = false;
+    }
+
+  private:
+    subtype_type m_subtype = 0;
+    bool m_has_subtype = false;
+};
+
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/conversions/from_json.hpp>
+
+// #include <nlohmann/detail/conversions/to_json.hpp>
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+// #include <nlohmann/detail/hash.hpp>
+
+
+#include <cstdint> // uint8_t
+#include <cstddef> // size_t
+#include <functional> // hash
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+
+// boost::hash_combine
+inline std::size_t combine(std::size_t seed, std::size_t h) noexcept
+{
+    seed ^= h + 0x9e3779b9 + (seed << 6U) + (seed >> 2U);
+    return seed;
+}
+
+/*!
+@brief hash a JSON value
+
+The hash function tries to rely on std::hash where possible. Furthermore, the
+type of the JSON value is taken into account to have different hash values for
+null, 0, 0U, and false, etc.
+
+@tparam BasicJsonType basic_json specialization
+@param j JSON value to hash
+@return hash value of j
+*/
+template<typename BasicJsonType>
+std::size_t hash(const BasicJsonType& j)
+{
+    using string_t = typename BasicJsonType::string_t;
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+
+    const auto type = static_cast<std::size_t>(j.type());
+    switch (j.type())
+    {
+        case BasicJsonType::value_t::null:
+        case BasicJsonType::value_t::discarded:
+        {
+            return combine(type, 0);
+        }
+
+        case BasicJsonType::value_t::object:
+        {
+            auto seed = combine(type, j.size());
+            for (const auto& element : j.items())
+            {
+                const auto h = std::hash<string_t> {}(element.key());
+                seed = combine(seed, h);
+                seed = combine(seed, hash(element.value()));
+            }
+            return seed;
+        }
+
+        case BasicJsonType::value_t::array:
+        {
+            auto seed = combine(type, j.size());
+            for (const auto& element : j)
+            {
+                seed = combine(seed, hash(element));
+            }
+            return seed;
+        }
+
+        case BasicJsonType::value_t::string:
+        {
+            const auto h = std::hash<string_t> {}(j.template get_ref<const string_t&>());
+            return combine(type, h);
+        }
+
+        case BasicJsonType::value_t::boolean:
+        {
+            const auto h = std::hash<bool> {}(j.template get<bool>());
+            return combine(type, h);
+        }
+
+        case BasicJsonType::value_t::number_integer:
+        {
+            const auto h = std::hash<number_integer_t> {}(j.template get<number_integer_t>());
+            return combine(type, h);
+        }
+
+        case BasicJsonType::value_t::number_unsigned:
+        {
+            const auto h = std::hash<number_unsigned_t> {}(j.template get<number_unsigned_t>());
+            return combine(type, h);
+        }
+
+        case BasicJsonType::value_t::number_float:
+        {
+            const auto h = std::hash<number_float_t> {}(j.template get<number_float_t>());
+            return combine(type, h);
+        }
+
+        case BasicJsonType::value_t::binary:
+        {
+            auto seed = combine(type, j.get_binary().size());
+            const auto h = std::hash<bool> {}(j.get_binary().has_subtype());
+            seed = combine(seed, h);
+            seed = combine(seed, static_cast<std::size_t>(j.get_binary().subtype()));
+            for (const auto byte : j.get_binary())
+            {
+                seed = combine(seed, std::hash<std::uint8_t> {}(byte));
+            }
+            return seed;
+        }
+
+        default:                   // LCOV_EXCL_LINE
+            JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+            return 0;              // LCOV_EXCL_LINE
+    }
+}
+
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/input/binary_reader.hpp>
+
+
+#include <algorithm> // generate_n
+#include <array> // array
+#include <cmath> // ldexp
+#include <cstddef> // size_t
+#include <cstdint> // uint8_t, uint16_t, uint32_t, uint64_t
+#include <cstdio> // snprintf
+#include <cstring> // memcpy
+#include <iterator> // back_inserter
+#include <limits> // numeric_limits
+#include <string> // char_traits, string
+#include <utility> // make_pair, move
+#include <vector> // vector
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+// #include <nlohmann/detail/input/input_adapters.hpp>
+
+
+#include <array> // array
+#include <cstddef> // size_t
+#include <cstring> // strlen
+#include <iterator> // begin, end, iterator_traits, random_access_iterator_tag, distance, next
+#include <memory> // shared_ptr, make_shared, addressof
+#include <numeric> // accumulate
+#include <string> // string, char_traits
+#include <type_traits> // enable_if, is_base_of, is_pointer, is_integral, remove_pointer
+#include <utility> // pair, declval
+
+#ifndef JSON_NO_IO
+    #include <cstdio>   // FILE *
+    #include <istream>  // istream
+#endif                  // JSON_NO_IO
+
+// #include <nlohmann/detail/iterators/iterator_traits.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+/// the supported input formats
+enum class input_format_t { json, cbor, msgpack, ubjson, bson };
+
+////////////////////
+// input adapters //
+////////////////////
+
+#ifndef JSON_NO_IO
+/*!
+Input adapter for stdio file access. This adapter read only 1 byte and do not use any
+ buffer. This adapter is a very low level adapter.
+*/
+class file_input_adapter
+{
+  public:
+    using char_type = char;
+
+    JSON_HEDLEY_NON_NULL(2)
+    explicit file_input_adapter(std::FILE* f) noexcept
+        : m_file(f)
+    {}
+
+    // make class move-only
+    file_input_adapter(const file_input_adapter&) = delete;
+    file_input_adapter(file_input_adapter&&) noexcept = default;
+    file_input_adapter& operator=(const file_input_adapter&) = delete;
+    file_input_adapter& operator=(file_input_adapter&&) = delete;
+    ~file_input_adapter() = default;
+
+    std::char_traits<char>::int_type get_character() noexcept
+    {
+        return std::fgetc(m_file);
+    }
+
+  private:
+    /// the file pointer to read from
+    std::FILE* m_file;
+};
+
+
+/*!
+Input adapter for a (caching) istream. Ignores a UFT Byte Order Mark at
+beginning of input. Does not support changing the underlying std::streambuf
+in mid-input. Maintains underlying std::istream and std::streambuf to support
+subsequent use of standard std::istream operations to process any input
+characters following those used in parsing the JSON input.  Clears the
+std::istream flags; any input errors (e.g., EOF) will be detected by the first
+subsequent call for input from the std::istream.
+*/
+class input_stream_adapter
+{
+  public:
+    using char_type = char;
+
+    ~input_stream_adapter()
+    {
+        // clear stream flags; we use underlying streambuf I/O, do not
+        // maintain ifstream flags, except eof
+        if (is != nullptr)
+        {
+            is->clear(is->rdstate() & std::ios::eofbit);
+        }
+    }
+
+    explicit input_stream_adapter(std::istream& i)
+        : is(&i), sb(i.rdbuf())
+    {}
+
+    // delete because of pointer members
+    input_stream_adapter(const input_stream_adapter&) = delete;
+    input_stream_adapter& operator=(input_stream_adapter&) = delete;
+    input_stream_adapter& operator=(input_stream_adapter&&) = delete;
+
+    input_stream_adapter(input_stream_adapter&& rhs) noexcept
+        : is(rhs.is), sb(rhs.sb)
+    {
+        rhs.is = nullptr;
+        rhs.sb = nullptr;
+    }
+
+    // std::istream/std::streambuf use std::char_traits<char>::to_int_type, to
+    // ensure that std::char_traits<char>::eof() and the character 0xFF do not
+    // end up as the same value, e.g. 0xFFFFFFFF.
+    std::char_traits<char>::int_type get_character()
+    {
+        auto res = sb->sbumpc();
+        // set eof manually, as we don't use the istream interface.
+        if (JSON_HEDLEY_UNLIKELY(res == std::char_traits<char>::eof()))
+        {
+            is->clear(is->rdstate() | std::ios::eofbit);
+        }
+        return res;
+    }
+
+  private:
+    /// the associated input stream
+    std::istream* is = nullptr;
+    std::streambuf* sb = nullptr;
+};
+#endif  // JSON_NO_IO
+
+// General-purpose iterator-based adapter. It might not be as fast as
+// theoretically possible for some containers, but it is extremely versatile.
+template<typename IteratorType>
+class iterator_input_adapter
+{
+  public:
+    using char_type = typename std::iterator_traits<IteratorType>::value_type;
+
+    iterator_input_adapter(IteratorType first, IteratorType last)
+        : current(std::move(first)), end(std::move(last))
+    {}
+
+    typename std::char_traits<char_type>::int_type get_character()
+    {
+        if (JSON_HEDLEY_LIKELY(current != end))
+        {
+            auto result = std::char_traits<char_type>::to_int_type(*current);
+            std::advance(current, 1);
+            return result;
+        }
+
+        return std::char_traits<char_type>::eof();
+    }
+
+  private:
+    IteratorType current;
+    IteratorType end;
+
+    template<typename BaseInputAdapter, size_t T>
+    friend struct wide_string_input_helper;
+
+    bool empty() const
+    {
+        return current == end;
+    }
+};
+
+
+template<typename BaseInputAdapter, size_t T>
+struct wide_string_input_helper;
+
+template<typename BaseInputAdapter>
+struct wide_string_input_helper<BaseInputAdapter, 4>
+{
+    // UTF-32
+    static void fill_buffer(BaseInputAdapter& input,
+                            std::array<std::char_traits<char>::int_type, 4>& utf8_bytes,
+                            size_t& utf8_bytes_index,
+                            size_t& utf8_bytes_filled)
+    {
+        utf8_bytes_index = 0;
+
+        if (JSON_HEDLEY_UNLIKELY(input.empty()))
+        {
+            utf8_bytes[0] = std::char_traits<char>::eof();
+            utf8_bytes_filled = 1;
+        }
+        else
+        {
+            // get the current character
+            const auto wc = input.get_character();
+
+            // UTF-32 to UTF-8 encoding
+            if (wc < 0x80)
+            {
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
+                utf8_bytes_filled = 1;
+            }
+            else if (wc <= 0x7FF)
+            {
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xC0u | ((static_cast<unsigned int>(wc) >> 6u) & 0x1Fu));
+                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
+                utf8_bytes_filled = 2;
+            }
+            else if (wc <= 0xFFFF)
+            {
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xE0u | ((static_cast<unsigned int>(wc) >> 12u) & 0x0Fu));
+                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 6u) & 0x3Fu));
+                utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
+                utf8_bytes_filled = 3;
+            }
+            else if (wc <= 0x10FFFF)
+            {
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xF0u | ((static_cast<unsigned int>(wc) >> 18u) & 0x07u));
+                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 12u) & 0x3Fu));
+                utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 6u) & 0x3Fu));
+                utf8_bytes[3] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
+                utf8_bytes_filled = 4;
+            }
+            else
+            {
+                // unknown character
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
+                utf8_bytes_filled = 1;
+            }
+        }
+    }
+};
+
+template<typename BaseInputAdapter>
+struct wide_string_input_helper<BaseInputAdapter, 2>
+{
+    // UTF-16
+    static void fill_buffer(BaseInputAdapter& input,
+                            std::array<std::char_traits<char>::int_type, 4>& utf8_bytes,
+                            size_t& utf8_bytes_index,
+                            size_t& utf8_bytes_filled)
+    {
+        utf8_bytes_index = 0;
+
+        if (JSON_HEDLEY_UNLIKELY(input.empty()))
+        {
+            utf8_bytes[0] = std::char_traits<char>::eof();
+            utf8_bytes_filled = 1;
+        }
+        else
+        {
+            // get the current character
+            const auto wc = input.get_character();
+
+            // UTF-16 to UTF-8 encoding
+            if (wc < 0x80)
+            {
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
+                utf8_bytes_filled = 1;
+            }
+            else if (wc <= 0x7FF)
+            {
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xC0u | ((static_cast<unsigned int>(wc) >> 6u)));
+                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
+                utf8_bytes_filled = 2;
+            }
+            else if (0xD800 > wc || wc >= 0xE000)
+            {
+                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xE0u | ((static_cast<unsigned int>(wc) >> 12u)));
+                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 6u) & 0x3Fu));
+                utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
+                utf8_bytes_filled = 3;
+            }
+            else
+            {
+                if (JSON_HEDLEY_UNLIKELY(!input.empty()))
+                {
+                    const auto wc2 = static_cast<unsigned int>(input.get_character());
+                    const auto charcode = 0x10000u + (((static_cast<unsigned int>(wc) & 0x3FFu) << 10u) | (wc2 & 0x3FFu));
+                    utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xF0u | (charcode >> 18u));
+                    utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((charcode >> 12u) & 0x3Fu));
+                    utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | ((charcode >> 6u) & 0x3Fu));
+                    utf8_bytes[3] = static_cast<std::char_traits<char>::int_type>(0x80u | (charcode & 0x3Fu));
+                    utf8_bytes_filled = 4;
+                }
+                else
+                {
+                    utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
+                    utf8_bytes_filled = 1;
+                }
+            }
+        }
+    }
+};
+
+// Wraps another input apdater to convert wide character types into individual bytes.
+template<typename BaseInputAdapter, typename WideCharType>
+class wide_string_input_adapter
+{
+  public:
+    using char_type = char;
+
+    wide_string_input_adapter(BaseInputAdapter base)
+        : base_adapter(base) {}
+
+    typename std::char_traits<char>::int_type get_character() noexcept
+    {
+        // check if buffer needs to be filled
+        if (utf8_bytes_index == utf8_bytes_filled)
+        {
+            fill_buffer<sizeof(WideCharType)>();
+
+            JSON_ASSERT(utf8_bytes_filled > 0);
+            JSON_ASSERT(utf8_bytes_index == 0);
+        }
+
+        // use buffer
+        JSON_ASSERT(utf8_bytes_filled > 0);
+        JSON_ASSERT(utf8_bytes_index < utf8_bytes_filled);
+        return utf8_bytes[utf8_bytes_index++];
+    }
+
+  private:
+    BaseInputAdapter base_adapter;
+
+    template<size_t T>
+    void fill_buffer()
+    {
+        wide_string_input_helper<BaseInputAdapter, T>::fill_buffer(base_adapter, utf8_bytes, utf8_bytes_index, utf8_bytes_filled);
+    }
+
+    /// a buffer for UTF-8 bytes
+    std::array<std::char_traits<char>::int_type, 4> utf8_bytes = {{0, 0, 0, 0}};
+
+    /// index to the utf8_codes array for the next valid byte
+    std::size_t utf8_bytes_index = 0;
+    /// number of valid bytes in the utf8_codes array
+    std::size_t utf8_bytes_filled = 0;
+};
+
+
+template<typename IteratorType, typename Enable = void>
+struct iterator_input_adapter_factory
+{
+    using iterator_type = IteratorType;
+    using char_type = typename std::iterator_traits<iterator_type>::value_type;
+    using adapter_type = iterator_input_adapter<iterator_type>;
+
+    static adapter_type create(IteratorType first, IteratorType last)
+    {
+        return adapter_type(std::move(first), std::move(last));
+    }
+};
+
+template<typename T>
+struct is_iterator_of_multibyte
+{
+    using value_type = typename std::iterator_traits<T>::value_type;
+    enum
+    {
+        value = sizeof(value_type) > 1
+    };
+};
+
+template<typename IteratorType>
+struct iterator_input_adapter_factory<IteratorType, enable_if_t<is_iterator_of_multibyte<IteratorType>::value>>
+{
+    using iterator_type = IteratorType;
+    using char_type = typename std::iterator_traits<iterator_type>::value_type;
+    using base_adapter_type = iterator_input_adapter<iterator_type>;
+    using adapter_type = wide_string_input_adapter<base_adapter_type, char_type>;
+
+    static adapter_type create(IteratorType first, IteratorType last)
+    {
+        return adapter_type(base_adapter_type(std::move(first), std::move(last)));
+    }
+};
+
+// General purpose iterator-based input
+template<typename IteratorType>
+typename iterator_input_adapter_factory<IteratorType>::adapter_type input_adapter(IteratorType first, IteratorType last)
+{
+    using factory_type = iterator_input_adapter_factory<IteratorType>;
+    return factory_type::create(first, last);
+}
+
+// Convenience shorthand from container to iterator
+// Enables ADL on begin(container) and end(container)
+// Encloses the using declarations in namespace for not to leak them to outside scope
+
+namespace container_input_adapter_factory_impl
+{
+
+using std::begin;
+using std::end;
+
+template<typename ContainerType, typename Enable = void>
+struct container_input_adapter_factory {};
+
+template<typename ContainerType>
+struct container_input_adapter_factory< ContainerType,
+       void_t<decltype(begin(std::declval<ContainerType>()), end(std::declval<ContainerType>()))>>
+       {
+           using adapter_type = decltype(input_adapter(begin(std::declval<ContainerType>()), end(std::declval<ContainerType>())));
+
+           static adapter_type create(const ContainerType& container)
+{
+    return input_adapter(begin(container), end(container));
+}
+       };
+
+} // namespace container_input_adapter_factory_impl
+
+template<typename ContainerType>
+typename container_input_adapter_factory_impl::container_input_adapter_factory<ContainerType>::adapter_type input_adapter(const ContainerType& container)
+{
+    return container_input_adapter_factory_impl::container_input_adapter_factory<ContainerType>::create(container);
+}
+
+#ifndef JSON_NO_IO
+// Special cases with fast paths
+inline file_input_adapter input_adapter(std::FILE* file)
+{
+    return file_input_adapter(file);
+}
+
+inline input_stream_adapter input_adapter(std::istream& stream)
+{
+    return input_stream_adapter(stream);
+}
+
+inline input_stream_adapter input_adapter(std::istream&& stream)
+{
+    return input_stream_adapter(stream);
+}
+#endif  // JSON_NO_IO
+
+using contiguous_bytes_input_adapter = decltype(input_adapter(std::declval<const char*>(), std::declval<const char*>()));
+
+// Null-delimited strings, and the like.
+template < typename CharT,
+           typename std::enable_if <
+               std::is_pointer<CharT>::value&&
+               !std::is_array<CharT>::value&&
+               std::is_integral<typename std::remove_pointer<CharT>::type>::value&&
+               sizeof(typename std::remove_pointer<CharT>::type) == 1,
+               int >::type = 0 >
+contiguous_bytes_input_adapter input_adapter(CharT b)
+{
+    auto length = std::strlen(reinterpret_cast<const char*>(b));
+    const auto* ptr = reinterpret_cast<const char*>(b);
+    return input_adapter(ptr, ptr + length);
+}
+
+template<typename T, std::size_t N>
+auto input_adapter(T (&array)[N]) -> decltype(input_adapter(array, array + N)) // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
+{
+    return input_adapter(array, array + N);
+}
+
+// This class only handles inputs of input_buffer_adapter type.
+// It's required so that expressions like {ptr, len} can be implicitly cast
+// to the correct adapter.
+class span_input_adapter
+{
+  public:
+    template < typename CharT,
+               typename std::enable_if <
+                   std::is_pointer<CharT>::value&&
+                   std::is_integral<typename std::remove_pointer<CharT>::type>::value&&
+                   sizeof(typename std::remove_pointer<CharT>::type) == 1,
+                   int >::type = 0 >
+    span_input_adapter(CharT b, std::size_t l)
+        : ia(reinterpret_cast<const char*>(b), reinterpret_cast<const char*>(b) + l) {}
+
+    template<class IteratorType,
+             typename std::enable_if<
+                 std::is_same<typename iterator_traits<IteratorType>::iterator_category, std::random_access_iterator_tag>::value,
+                 int>::type = 0>
+    span_input_adapter(IteratorType first, IteratorType last)
+        : ia(input_adapter(first, last)) {}
+
+    contiguous_bytes_input_adapter&& get()
+    {
+        return std::move(ia); // NOLINT(hicpp-move-const-arg,performance-move-const-arg)
+    }
+
+  private:
+    contiguous_bytes_input_adapter ia;
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/input/json_sax.hpp>
+
+
+#include <cstddef>
+#include <string> // string
+#include <utility> // move
+#include <vector> // vector
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+
+/*!
+@brief SAX interface
+
+This class describes the SAX interface used by @ref nlohmann::json::sax_parse.
+Each function is called in different situations while the input is parsed. The
+boolean return value informs the parser whether to continue processing the
+input.
+*/
+template<typename BasicJsonType>
+struct json_sax
+{
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+
+    /*!
+    @brief a null value was read
+    @return whether parsing should proceed
+    */
+    virtual bool null() = 0;
+
+    /*!
+    @brief a boolean value was read
+    @param[in] val  boolean value
+    @return whether parsing should proceed
+    */
+    virtual bool boolean(bool val) = 0;
+
+    /*!
+    @brief an integer number was read
+    @param[in] val  integer value
+    @return whether parsing should proceed
+    */
+    virtual bool number_integer(number_integer_t val) = 0;
+
+    /*!
+    @brief an unsigned integer number was read
+    @param[in] val  unsigned integer value
+    @return whether parsing should proceed
+    */
+    virtual bool number_unsigned(number_unsigned_t val) = 0;
+
+    /*!
+    @brief a floating-point number was read
+    @param[in] val  floating-point value
+    @param[in] s    raw token value
+    @return whether parsing should proceed
+    */
+    virtual bool number_float(number_float_t val, const string_t& s) = 0;
+
+    /*!
+    @brief a string value was read
+    @param[in] val  string value
+    @return whether parsing should proceed
+    @note It is safe to move the passed string value.
+    */
+    virtual bool string(string_t& val) = 0;
+
+    /*!
+    @brief a binary value was read
+    @param[in] val  binary value
+    @return whether parsing should proceed
+    @note It is safe to move the passed binary value.
+    */
+    virtual bool binary(binary_t& val) = 0;
+
+    /*!
+    @brief the beginning of an object was read
+    @param[in] elements  number of object elements or -1 if unknown
+    @return whether parsing should proceed
+    @note binary formats may report the number of elements
+    */
+    virtual bool start_object(std::size_t elements) = 0;
+
+    /*!
+    @brief an object key was read
+    @param[in] val  object key
+    @return whether parsing should proceed
+    @note It is safe to move the passed string.
+    */
+    virtual bool key(string_t& val) = 0;
+
+    /*!
+    @brief the end of an object was read
+    @return whether parsing should proceed
+    */
+    virtual bool end_object() = 0;
+
+    /*!
+    @brief the beginning of an array was read
+    @param[in] elements  number of array elements or -1 if unknown
+    @return whether parsing should proceed
+    @note binary formats may report the number of elements
+    */
+    virtual bool start_array(std::size_t elements) = 0;
+
+    /*!
+    @brief the end of an array was read
+    @return whether parsing should proceed
+    */
+    virtual bool end_array() = 0;
+
+    /*!
+    @brief a parse error occurred
+    @param[in] position    the position in the input where the error occurs
+    @param[in] last_token  the last read token
+    @param[in] ex          an exception object describing the error
+    @return whether parsing should proceed (must return false)
+    */
+    virtual bool parse_error(std::size_t position,
+                             const std::string& last_token,
+                             const detail::exception& ex) = 0;
+
+    json_sax() = default;
+    json_sax(const json_sax&) = default;
+    json_sax(json_sax&&) noexcept = default;
+    json_sax& operator=(const json_sax&) = default;
+    json_sax& operator=(json_sax&&) noexcept = default;
+    virtual ~json_sax() = default;
+};
+
+
+namespace detail
+{
+/*!
+@brief SAX implementation to create a JSON value from SAX events
+
+This class implements the @ref json_sax interface and processes the SAX events
+to create a JSON value which makes it basically a DOM parser. The structure or
+hierarchy of the JSON value is managed by the stack `ref_stack` which contains
+a pointer to the respective array or object for each recursion depth.
+
+After successful parsing, the value that is passed by reference to the
+constructor contains the parsed value.
+
+@tparam BasicJsonType  the JSON type
+*/
+template<typename BasicJsonType>
+class json_sax_dom_parser
+{
+  public:
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+
+    /*!
+    @param[in,out] r  reference to a JSON value that is manipulated while
+                       parsing
+    @param[in] allow_exceptions_  whether parse errors yield exceptions
+    */
+    explicit json_sax_dom_parser(BasicJsonType& r, const bool allow_exceptions_ = true)
+        : root(r), allow_exceptions(allow_exceptions_)
+    {}
+
+    // make class move-only
+    json_sax_dom_parser(const json_sax_dom_parser&) = delete;
+    json_sax_dom_parser(json_sax_dom_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    json_sax_dom_parser& operator=(const json_sax_dom_parser&) = delete;
+    json_sax_dom_parser& operator=(json_sax_dom_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    ~json_sax_dom_parser() = default;
+
+    bool null()
+    {
+        handle_value(nullptr);
+        return true;
+    }
+
+    bool boolean(bool val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool number_integer(number_integer_t val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool number_unsigned(number_unsigned_t val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool number_float(number_float_t val, const string_t& /*unused*/)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool string(string_t& val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool binary(binary_t& val)
+    {
+        handle_value(std::move(val));
+        return true;
+    }
+
+    bool start_object(std::size_t len)
+    {
+        ref_stack.push_back(handle_value(BasicJsonType::value_t::object));
+
+        if (JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
+        {
+            JSON_THROW(out_of_range::create(408, "excessive object size: " + std::to_string(len), *ref_stack.back()));
+        }
+
+        return true;
+    }
+
+    bool key(string_t& val)
+    {
+        // add null at given key and store the reference for later
+        object_element = &(ref_stack.back()->m_value.object->operator[](val));
+        return true;
+    }
+
+    bool end_object()
+    {
+        ref_stack.back()->set_parents();
+        ref_stack.pop_back();
+        return true;
+    }
+
+    bool start_array(std::size_t len)
+    {
+        ref_stack.push_back(handle_value(BasicJsonType::value_t::array));
+
+        if (JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
+        {
+            JSON_THROW(out_of_range::create(408, "excessive array size: " + std::to_string(len), *ref_stack.back()));
+        }
+
+        return true;
+    }
+
+    bool end_array()
+    {
+        ref_stack.back()->set_parents();
+        ref_stack.pop_back();
+        return true;
+    }
+
+    template<class Exception>
+    bool parse_error(std::size_t /*unused*/, const std::string& /*unused*/,
+                     const Exception& ex)
+    {
+        errored = true;
+        static_cast<void>(ex);
+        if (allow_exceptions)
+        {
+            JSON_THROW(ex);
+        }
+        return false;
+    }
+
+    constexpr bool is_errored() const
+    {
+        return errored;
+    }
+
+  private:
+    /*!
+    @invariant If the ref stack is empty, then the passed value will be the new
+               root.
+    @invariant If the ref stack contains a value, then it is an array or an
+               object to which we can add elements
+    */
+    template<typename Value>
+    JSON_HEDLEY_RETURNS_NON_NULL
+    BasicJsonType* handle_value(Value&& v)
+    {
+        if (ref_stack.empty())
+        {
+            root = BasicJsonType(std::forward<Value>(v));
+            return &root;
+        }
+
+        JSON_ASSERT(ref_stack.back()->is_array() || ref_stack.back()->is_object());
+
+        if (ref_stack.back()->is_array())
+        {
+            ref_stack.back()->m_value.array->emplace_back(std::forward<Value>(v));
+            return &(ref_stack.back()->m_value.array->back());
+        }
+
+        JSON_ASSERT(ref_stack.back()->is_object());
+        JSON_ASSERT(object_element);
+        *object_element = BasicJsonType(std::forward<Value>(v));
+        return object_element;
+    }
+
+    /// the parsed JSON value
+    BasicJsonType& root;
+    /// stack to model hierarchy of values
+    std::vector<BasicJsonType*> ref_stack {};
+    /// helper to hold the reference for the next object element
+    BasicJsonType* object_element = nullptr;
+    /// whether a syntax error occurred
+    bool errored = false;
+    /// whether to throw exceptions in case of errors
+    const bool allow_exceptions = true;
+};
+
+template<typename BasicJsonType>
+class json_sax_dom_callback_parser
+{
+  public:
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+    using parser_callback_t = typename BasicJsonType::parser_callback_t;
+    using parse_event_t = typename BasicJsonType::parse_event_t;
+
+    json_sax_dom_callback_parser(BasicJsonType& r,
+                                 const parser_callback_t cb,
+                                 const bool allow_exceptions_ = true)
+        : root(r), callback(cb), allow_exceptions(allow_exceptions_)
+    {
+        keep_stack.push_back(true);
+    }
+
+    // make class move-only
+    json_sax_dom_callback_parser(const json_sax_dom_callback_parser&) = delete;
+    json_sax_dom_callback_parser(json_sax_dom_callback_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    json_sax_dom_callback_parser& operator=(const json_sax_dom_callback_parser&) = delete;
+    json_sax_dom_callback_parser& operator=(json_sax_dom_callback_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    ~json_sax_dom_callback_parser() = default;
+
+    bool null()
+    {
+        handle_value(nullptr);
+        return true;
+    }
+
+    bool boolean(bool val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool number_integer(number_integer_t val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool number_unsigned(number_unsigned_t val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool number_float(number_float_t val, const string_t& /*unused*/)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool string(string_t& val)
+    {
+        handle_value(val);
+        return true;
+    }
+
+    bool binary(binary_t& val)
+    {
+        handle_value(std::move(val));
+        return true;
+    }
+
+    bool start_object(std::size_t len)
+    {
+        // check callback for object start
+        const bool keep = callback(static_cast<int>(ref_stack.size()), parse_event_t::object_start, discarded);
+        keep_stack.push_back(keep);
+
+        auto val = handle_value(BasicJsonType::value_t::object, true);
+        ref_stack.push_back(val.second);
+
+        // check object limit
+        if (ref_stack.back() && JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
+        {
+            JSON_THROW(out_of_range::create(408, "excessive object size: " + std::to_string(len), *ref_stack.back()));
+        }
+
+        return true;
+    }
+
+    bool key(string_t& val)
+    {
+        BasicJsonType k = BasicJsonType(val);
+
+        // check callback for key
+        const bool keep = callback(static_cast<int>(ref_stack.size()), parse_event_t::key, k);
+        key_keep_stack.push_back(keep);
+
+        // add discarded value at given key and store the reference for later
+        if (keep && ref_stack.back())
+        {
+            object_element = &(ref_stack.back()->m_value.object->operator[](val) = discarded);
+        }
+
+        return true;
+    }
+
+    bool end_object()
+    {
+        if (ref_stack.back())
+        {
+            if (!callback(static_cast<int>(ref_stack.size()) - 1, parse_event_t::object_end, *ref_stack.back()))
+            {
+                // discard object
+                *ref_stack.back() = discarded;
+            }
+            else
+            {
+                ref_stack.back()->set_parents();
+            }
+        }
+
+        JSON_ASSERT(!ref_stack.empty());
+        JSON_ASSERT(!keep_stack.empty());
+        ref_stack.pop_back();
+        keep_stack.pop_back();
+
+        if (!ref_stack.empty() && ref_stack.back() && ref_stack.back()->is_structured())
+        {
+            // remove discarded value
+            for (auto it = ref_stack.back()->begin(); it != ref_stack.back()->end(); ++it)
+            {
+                if (it->is_discarded())
+                {
+                    ref_stack.back()->erase(it);
+                    break;
+                }
+            }
+        }
+
+        return true;
+    }
+
+    bool start_array(std::size_t len)
+    {
+        const bool keep = callback(static_cast<int>(ref_stack.size()), parse_event_t::array_start, discarded);
+        keep_stack.push_back(keep);
+
+        auto val = handle_value(BasicJsonType::value_t::array, true);
+        ref_stack.push_back(val.second);
+
+        // check array limit
+        if (ref_stack.back() && JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
+        {
+            JSON_THROW(out_of_range::create(408, "excessive array size: " + std::to_string(len), *ref_stack.back()));
+        }
+
+        return true;
+    }
+
+    bool end_array()
+    {
+        bool keep = true;
+
+        if (ref_stack.back())
+        {
+            keep = callback(static_cast<int>(ref_stack.size()) - 1, parse_event_t::array_end, *ref_stack.back());
+            if (keep)
+            {
+                ref_stack.back()->set_parents();
+            }
+            else
+            {
+                // discard array
+                *ref_stack.back() = discarded;
+            }
+        }
+
+        JSON_ASSERT(!ref_stack.empty());
+        JSON_ASSERT(!keep_stack.empty());
+        ref_stack.pop_back();
+        keep_stack.pop_back();
+
+        // remove discarded value
+        if (!keep && !ref_stack.empty() && ref_stack.back()->is_array())
+        {
+            ref_stack.back()->m_value.array->pop_back();
+        }
+
+        return true;
+    }
+
+    template<class Exception>
+    bool parse_error(std::size_t /*unused*/, const std::string& /*unused*/,
+                     const Exception& ex)
+    {
+        errored = true;
+        static_cast<void>(ex);
+        if (allow_exceptions)
+        {
+            JSON_THROW(ex);
+        }
+        return false;
+    }
+
+    constexpr bool is_errored() const
+    {
+        return errored;
+    }
+
+  private:
+    /*!
+    @param[in] v  value to add to the JSON value we build during parsing
+    @param[in] skip_callback  whether we should skip calling the callback
+               function; this is required after start_array() and
+               start_object() SAX events, because otherwise we would call the
+               callback function with an empty array or object, respectively.
+
+    @invariant If the ref stack is empty, then the passed value will be the new
+               root.
+    @invariant If the ref stack contains a value, then it is an array or an
+               object to which we can add elements
+
+    @return pair of boolean (whether value should be kept) and pointer (to the
+            passed value in the ref_stack hierarchy; nullptr if not kept)
+    */
+    template<typename Value>
+    std::pair<bool, BasicJsonType*> handle_value(Value&& v, const bool skip_callback = false)
+    {
+        JSON_ASSERT(!keep_stack.empty());
+
+        // do not handle this value if we know it would be added to a discarded
+        // container
+        if (!keep_stack.back())
+        {
+            return {false, nullptr};
+        }
+
+        // create value
+        auto value = BasicJsonType(std::forward<Value>(v));
+
+        // check callback
+        const bool keep = skip_callback || callback(static_cast<int>(ref_stack.size()), parse_event_t::value, value);
+
+        // do not handle this value if we just learnt it shall be discarded
+        if (!keep)
+        {
+            return {false, nullptr};
+        }
+
+        if (ref_stack.empty())
+        {
+            root = std::move(value);
+            return {true, &root};
+        }
+
+        // skip this value if we already decided to skip the parent
+        // (https://github.com/nlohmann/json/issues/971#issuecomment-413678360)
+        if (!ref_stack.back())
+        {
+            return {false, nullptr};
+        }
+
+        // we now only expect arrays and objects
+        JSON_ASSERT(ref_stack.back()->is_array() || ref_stack.back()->is_object());
+
+        // array
+        if (ref_stack.back()->is_array())
+        {
+            ref_stack.back()->m_value.array->emplace_back(std::move(value));
+            return {true, &(ref_stack.back()->m_value.array->back())};
+        }
+
+        // object
+        JSON_ASSERT(ref_stack.back()->is_object());
+        // check if we should store an element for the current key
+        JSON_ASSERT(!key_keep_stack.empty());
+        const bool store_element = key_keep_stack.back();
+        key_keep_stack.pop_back();
+
+        if (!store_element)
+        {
+            return {false, nullptr};
+        }
+
+        JSON_ASSERT(object_element);
+        *object_element = std::move(value);
+        return {true, object_element};
+    }
+
+    /// the parsed JSON value
+    BasicJsonType& root;
+    /// stack to model hierarchy of values
+    std::vector<BasicJsonType*> ref_stack {};
+    /// stack to manage which values to keep
+    std::vector<bool> keep_stack {};
+    /// stack to manage which object keys to keep
+    std::vector<bool> key_keep_stack {};
+    /// helper to hold the reference for the next object element
+    BasicJsonType* object_element = nullptr;
+    /// whether a syntax error occurred
+    bool errored = false;
+    /// callback function
+    const parser_callback_t callback = nullptr;
+    /// whether to throw exceptions in case of errors
+    const bool allow_exceptions = true;
+    /// a discarded value for the callback
+    BasicJsonType discarded = BasicJsonType::value_t::discarded;
+};
+
+template<typename BasicJsonType>
+class json_sax_acceptor
+{
+  public:
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+
+    bool null()
+    {
+        return true;
+    }
+
+    bool boolean(bool /*unused*/)
+    {
+        return true;
+    }
+
+    bool number_integer(number_integer_t /*unused*/)
+    {
+        return true;
+    }
+
+    bool number_unsigned(number_unsigned_t /*unused*/)
+    {
+        return true;
+    }
+
+    bool number_float(number_float_t /*unused*/, const string_t& /*unused*/)
+    {
+        return true;
+    }
+
+    bool string(string_t& /*unused*/)
+    {
+        return true;
+    }
+
+    bool binary(binary_t& /*unused*/)
+    {
+        return true;
+    }
+
+    bool start_object(std::size_t /*unused*/ = static_cast<std::size_t>(-1))
+    {
+        return true;
+    }
+
+    bool key(string_t& /*unused*/)
+    {
+        return true;
+    }
+
+    bool end_object()
+    {
+        return true;
+    }
+
+    bool start_array(std::size_t /*unused*/ = static_cast<std::size_t>(-1))
+    {
+        return true;
+    }
+
+    bool end_array()
+    {
+        return true;
+    }
+
+    bool parse_error(std::size_t /*unused*/, const std::string& /*unused*/, const detail::exception& /*unused*/)
+    {
+        return false;
+    }
+};
+}  // namespace detail
+
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/input/lexer.hpp>
+
+
+#include <array> // array
+#include <clocale> // localeconv
+#include <cstddef> // size_t
+#include <cstdio> // snprintf
+#include <cstdlib> // strtof, strtod, strtold, strtoll, strtoull
+#include <initializer_list> // initializer_list
+#include <string> // char_traits, string
+#include <utility> // move
+#include <vector> // vector
+
+// #include <nlohmann/detail/input/input_adapters.hpp>
+
+// #include <nlohmann/detail/input/position_t.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+///////////
+// lexer //
+///////////
+
+template<typename BasicJsonType>
+class lexer_base
+{
+  public:
+    /// token types for the parser
+    enum class token_type
+    {
+        uninitialized,    ///< indicating the scanner is uninitialized
+        literal_true,     ///< the `true` literal
+        literal_false,    ///< the `false` literal
+        literal_null,     ///< the `null` literal
+        value_string,     ///< a string -- use get_string() for actual value
+        value_unsigned,   ///< an unsigned integer -- use get_number_unsigned() for actual value
+        value_integer,    ///< a signed integer -- use get_number_integer() for actual value
+        value_float,      ///< an floating point number -- use get_number_float() for actual value
+        begin_array,      ///< the character for array begin `[`
+        begin_object,     ///< the character for object begin `{`
+        end_array,        ///< the character for array end `]`
+        end_object,       ///< the character for object end `}`
+        name_separator,   ///< the name separator `:`
+        value_separator,  ///< the value separator `,`
+        parse_error,      ///< indicating a parse error
+        end_of_input,     ///< indicating the end of the input buffer
+        literal_or_value  ///< a literal or the begin of a value (only for diagnostics)
+    };
+
+    /// return name of values of type token_type (only used for errors)
+    JSON_HEDLEY_RETURNS_NON_NULL
+    JSON_HEDLEY_CONST
+    static const char* token_type_name(const token_type t) noexcept
+    {
+        switch (t)
+        {
+            case token_type::uninitialized:
+                return "<uninitialized>";
+            case token_type::literal_true:
+                return "true literal";
+            case token_type::literal_false:
+                return "false literal";
+            case token_type::literal_null:
+                return "null literal";
+            case token_type::value_string:
+                return "string literal";
+            case token_type::value_unsigned:
+            case token_type::value_integer:
+            case token_type::value_float:
+                return "number literal";
+            case token_type::begin_array:
+                return "'['";
+            case token_type::begin_object:
+                return "'{'";
+            case token_type::end_array:
+                return "']'";
+            case token_type::end_object:
+                return "'}'";
+            case token_type::name_separator:
+                return "':'";
+            case token_type::value_separator:
+                return "','";
+            case token_type::parse_error:
+                return "<parse error>";
+            case token_type::end_of_input:
+                return "end of input";
+            case token_type::literal_or_value:
+                return "'[', '{', or a literal";
+            // LCOV_EXCL_START
+            default: // catch non-enum values
+                return "unknown token";
+                // LCOV_EXCL_STOP
+        }
+    }
+};
+/*!
+@brief lexical analysis
+
+This class organizes the lexical analysis during JSON deserialization.
+*/
+template<typename BasicJsonType, typename InputAdapterType>
+class lexer : public lexer_base<BasicJsonType>
+{
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using char_type = typename InputAdapterType::char_type;
+    using char_int_type = typename std::char_traits<char_type>::int_type;
+
+  public:
+    using token_type = typename lexer_base<BasicJsonType>::token_type;
+
+    explicit lexer(InputAdapterType&& adapter, bool ignore_comments_ = false) noexcept
+        : ia(std::move(adapter))
+        , ignore_comments(ignore_comments_)
+        , decimal_point_char(static_cast<char_int_type>(get_decimal_point()))
+    {}
+
+    // delete because of pointer members
+    lexer(const lexer&) = delete;
+    lexer(lexer&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    lexer& operator=(lexer&) = delete;
+    lexer& operator=(lexer&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    ~lexer() = default;
+
+  private:
+    /////////////////////
+    // locales
+    /////////////////////
+
+    /// return the locale-dependent decimal point
+    JSON_HEDLEY_PURE
+    static char get_decimal_point() noexcept
+    {
+        const auto* loc = localeconv();
+        JSON_ASSERT(loc != nullptr);
+        return (loc->decimal_point == nullptr) ? '.' : *(loc->decimal_point);
+    }
+
+    /////////////////////
+    // scan functions
+    /////////////////////
+
+    /*!
+    @brief get codepoint from 4 hex characters following `\u`
+
+    For input "\u c1 c2 c3 c4" the codepoint is:
+      (c1 * 0x1000) + (c2 * 0x0100) + (c3 * 0x0010) + c4
+    = (c1 << 12) + (c2 << 8) + (c3 << 4) + (c4 << 0)
+
+    Furthermore, the possible characters '0'..'9', 'A'..'F', and 'a'..'f'
+    must be converted to the integers 0x0..0x9, 0xA..0xF, 0xA..0xF, resp. The
+    conversion is done by subtracting the offset (0x30, 0x37, and 0x57)
+    between the ASCII value of the character and the desired integer value.
+
+    @return codepoint (0x0000..0xFFFF) or -1 in case of an error (e.g. EOF or
+            non-hex character)
+    */
+    int get_codepoint()
+    {
+        // this function only makes sense after reading `\u`
+        JSON_ASSERT(current == 'u');
+        int codepoint = 0;
+
+        const auto factors = { 12u, 8u, 4u, 0u };
+        for (const auto factor : factors)
+        {
+            get();
+
+            if (current >= '0' && current <= '9')
+            {
+                codepoint += static_cast<int>((static_cast<unsigned int>(current) - 0x30u) << factor);
+            }
+            else if (current >= 'A' && current <= 'F')
+            {
+                codepoint += static_cast<int>((static_cast<unsigned int>(current) - 0x37u) << factor);
+            }
+            else if (current >= 'a' && current <= 'f')
+            {
+                codepoint += static_cast<int>((static_cast<unsigned int>(current) - 0x57u) << factor);
+            }
+            else
+            {
+                return -1;
+            }
+        }
+
+        JSON_ASSERT(0x0000 <= codepoint && codepoint <= 0xFFFF);
+        return codepoint;
+    }
+
+    /*!
+    @brief check if the next byte(s) are inside a given range
+
+    Adds the current byte and, for each passed range, reads a new byte and
+    checks if it is inside the range. If a violation was detected, set up an
+    error message and return false. Otherwise, return true.
+
+    @param[in] ranges  list of integers; interpreted as list of pairs of
+                       inclusive lower and upper bound, respectively
+
+    @pre The passed list @a ranges must have 2, 4, or 6 elements; that is,
+         1, 2, or 3 pairs. This precondition is enforced by an assertion.
+
+    @return true if and only if no range violation was detected
+    */
+    bool next_byte_in_range(std::initializer_list<char_int_type> ranges)
+    {
+        JSON_ASSERT(ranges.size() == 2 || ranges.size() == 4 || ranges.size() == 6);
+        add(current);
+
+        for (auto range = ranges.begin(); range != ranges.end(); ++range)
+        {
+            get();
+            if (JSON_HEDLEY_LIKELY(*range <= current && current <= *(++range)))
+            {
+                add(current);
+            }
+            else
+            {
+                error_message = "invalid string: ill-formed UTF-8 byte";
+                return false;
+            }
+        }
+
+        return true;
+    }
+
+    /*!
+    @brief scan a string literal
+
+    This function scans a string according to Sect. 7 of RFC 8259. While
+    scanning, bytes are escaped and copied into buffer token_buffer. Then the
+    function returns successfully, token_buffer is *not* null-terminated (as it
+    may contain \0 bytes), and token_buffer.size() is the number of bytes in the
+    string.
+
+    @return token_type::value_string if string could be successfully scanned,
+            token_type::parse_error otherwise
+
+    @note In case of errors, variable error_message contains a textual
+          description.
+    */
+    token_type scan_string()
+    {
+        // reset token_buffer (ignore opening quote)
+        reset();
+
+        // we entered the function by reading an open quote
+        JSON_ASSERT(current == '\"');
+
+        while (true)
+        {
+            // get next character
+            switch (get())
+            {
+                // end of file while parsing string
+                case std::char_traits<char_type>::eof():
+                {
+                    error_message = "invalid string: missing closing quote";
+                    return token_type::parse_error;
+                }
+
+                // closing quote
+                case '\"':
+                {
+                    return token_type::value_string;
+                }
+
+                // escapes
+                case '\\':
+                {
+                    switch (get())
+                    {
+                        // quotation mark
+                        case '\"':
+                            add('\"');
+                            break;
+                        // reverse solidus
+                        case '\\':
+                            add('\\');
+                            break;
+                        // solidus
+                        case '/':
+                            add('/');
+                            break;
+                        // backspace
+                        case 'b':
+                            add('\b');
+                            break;
+                        // form feed
+                        case 'f':
+                            add('\f');
+                            break;
+                        // line feed
+                        case 'n':
+                            add('\n');
+                            break;
+                        // carriage return
+                        case 'r':
+                            add('\r');
+                            break;
+                        // tab
+                        case 't':
+                            add('\t');
+                            break;
+
+                        // unicode escapes
+                        case 'u':
+                        {
+                            const int codepoint1 = get_codepoint();
+                            int codepoint = codepoint1; // start with codepoint1
+
+                            if (JSON_HEDLEY_UNLIKELY(codepoint1 == -1))
+                            {
+                                error_message = "invalid string: '\\u' must be followed by 4 hex digits";
+                                return token_type::parse_error;
+                            }
+
+                            // check if code point is a high surrogate
+                            if (0xD800 <= codepoint1 && codepoint1 <= 0xDBFF)
+                            {
+                                // expect next \uxxxx entry
+                                if (JSON_HEDLEY_LIKELY(get() == '\\' && get() == 'u'))
+                                {
+                                    const int codepoint2 = get_codepoint();
+
+                                    if (JSON_HEDLEY_UNLIKELY(codepoint2 == -1))
+                                    {
+                                        error_message = "invalid string: '\\u' must be followed by 4 hex digits";
+                                        return token_type::parse_error;
+                                    }
+
+                                    // check if codepoint2 is a low surrogate
+                                    if (JSON_HEDLEY_LIKELY(0xDC00 <= codepoint2 && codepoint2 <= 0xDFFF))
+                                    {
+                                        // overwrite codepoint
+                                        codepoint = static_cast<int>(
+                                                        // high surrogate occupies the most significant 22 bits
+                                                        (static_cast<unsigned int>(codepoint1) << 10u)
+                                                        // low surrogate occupies the least significant 15 bits
+                                                        + static_cast<unsigned int>(codepoint2)
+                                                        // there is still the 0xD800, 0xDC00 and 0x10000 noise
+                                                        // in the result, so we have to subtract with:
+                                                        // (0xD800 << 10) + DC00 - 0x10000 = 0x35FDC00
+                                                        - 0x35FDC00u);
+                                    }
+                                    else
+                                    {
+                                        error_message = "invalid string: surrogate U+D800..U+DBFF must be followed by U+DC00..U+DFFF";
+                                        return token_type::parse_error;
+                                    }
+                                }
+                                else
+                                {
+                                    error_message = "invalid string: surrogate U+D800..U+DBFF must be followed by U+DC00..U+DFFF";
+                                    return token_type::parse_error;
+                                }
+                            }
+                            else
+                            {
+                                if (JSON_HEDLEY_UNLIKELY(0xDC00 <= codepoint1 && codepoint1 <= 0xDFFF))
+                                {
+                                    error_message = "invalid string: surrogate U+DC00..U+DFFF must follow U+D800..U+DBFF";
+                                    return token_type::parse_error;
+                                }
+                            }
+
+                            // result of the above calculation yields a proper codepoint
+                            JSON_ASSERT(0x00 <= codepoint && codepoint <= 0x10FFFF);
+
+                            // translate codepoint into bytes
+                            if (codepoint < 0x80)
+                            {
+                                // 1-byte characters: 0xxxxxxx (ASCII)
+                                add(static_cast<char_int_type>(codepoint));
+                            }
+                            else if (codepoint <= 0x7FF)
+                            {
+                                // 2-byte characters: 110xxxxx 10xxxxxx
+                                add(static_cast<char_int_type>(0xC0u | (static_cast<unsigned int>(codepoint) >> 6u)));
+                                add(static_cast<char_int_type>(0x80u | (static_cast<unsigned int>(codepoint) & 0x3Fu)));
+                            }
+                            else if (codepoint <= 0xFFFF)
+                            {
+                                // 3-byte characters: 1110xxxx 10xxxxxx 10xxxxxx
+                                add(static_cast<char_int_type>(0xE0u | (static_cast<unsigned int>(codepoint) >> 12u)));
+                                add(static_cast<char_int_type>(0x80u | ((static_cast<unsigned int>(codepoint) >> 6u) & 0x3Fu)));
+                                add(static_cast<char_int_type>(0x80u | (static_cast<unsigned int>(codepoint) & 0x3Fu)));
+                            }
+                            else
+                            {
+                                // 4-byte characters: 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
+                                add(static_cast<char_int_type>(0xF0u | (static_cast<unsigned int>(codepoint) >> 18u)));
+                                add(static_cast<char_int_type>(0x80u | ((static_cast<unsigned int>(codepoint) >> 12u) & 0x3Fu)));
+                                add(static_cast<char_int_type>(0x80u | ((static_cast<unsigned int>(codepoint) >> 6u) & 0x3Fu)));
+                                add(static_cast<char_int_type>(0x80u | (static_cast<unsigned int>(codepoint) & 0x3Fu)));
+                            }
+
+                            break;
+                        }
+
+                        // other characters after escape
+                        default:
+                            error_message = "invalid string: forbidden character after backslash";
+                            return token_type::parse_error;
+                    }
+
+                    break;
+                }
+
+                // invalid control characters
+                case 0x00:
+                {
+                    error_message = "invalid string: control character U+0000 (NUL) must be escaped to \\u0000";
+                    return token_type::parse_error;
+                }
+
+                case 0x01:
+                {
+                    error_message = "invalid string: control character U+0001 (SOH) must be escaped to \\u0001";
+                    return token_type::parse_error;
+                }
+
+                case 0x02:
+                {
+                    error_message = "invalid string: control character U+0002 (STX) must be escaped to \\u0002";
+                    return token_type::parse_error;
+                }
+
+                case 0x03:
+                {
+                    error_message = "invalid string: control character U+0003 (ETX) must be escaped to \\u0003";
+                    return token_type::parse_error;
+                }
+
+                case 0x04:
+                {
+                    error_message = "invalid string: control character U+0004 (EOT) must be escaped to \\u0004";
+                    return token_type::parse_error;
+                }
+
+                case 0x05:
+                {
+                    error_message = "invalid string: control character U+0005 (ENQ) must be escaped to \\u0005";
+                    return token_type::parse_error;
+                }
+
+                case 0x06:
+                {
+                    error_message = "invalid string: control character U+0006 (ACK) must be escaped to \\u0006";
+                    return token_type::parse_error;
+                }
+
+                case 0x07:
+                {
+                    error_message = "invalid string: control character U+0007 (BEL) must be escaped to \\u0007";
+                    return token_type::parse_error;
+                }
+
+                case 0x08:
+                {
+                    error_message = "invalid string: control character U+0008 (BS) must be escaped to \\u0008 or \\b";
+                    return token_type::parse_error;
+                }
+
+                case 0x09:
+                {
+                    error_message = "invalid string: control character U+0009 (HT) must be escaped to \\u0009 or \\t";
+                    return token_type::parse_error;
+                }
+
+                case 0x0A:
+                {
+                    error_message = "invalid string: control character U+000A (LF) must be escaped to \\u000A or \\n";
+                    return token_type::parse_error;
+                }
+
+                case 0x0B:
+                {
+                    error_message = "invalid string: control character U+000B (VT) must be escaped to \\u000B";
+                    return token_type::parse_error;
+                }
+
+                case 0x0C:
+                {
+                    error_message = "invalid string: control character U+000C (FF) must be escaped to \\u000C or \\f";
+                    return token_type::parse_error;
+                }
+
+                case 0x0D:
+                {
+                    error_message = "invalid string: control character U+000D (CR) must be escaped to \\u000D or \\r";
+                    return token_type::parse_error;
+                }
+
+                case 0x0E:
+                {
+                    error_message = "invalid string: control character U+000E (SO) must be escaped to \\u000E";
+                    return token_type::parse_error;
+                }
+
+                case 0x0F:
+                {
+                    error_message = "invalid string: control character U+000F (SI) must be escaped to \\u000F";
+                    return token_type::parse_error;
+                }
+
+                case 0x10:
+                {
+                    error_message = "invalid string: control character U+0010 (DLE) must be escaped to \\u0010";
+                    return token_type::parse_error;
+                }
+
+                case 0x11:
+                {
+                    error_message = "invalid string: control character U+0011 (DC1) must be escaped to \\u0011";
+                    return token_type::parse_error;
+                }
+
+                case 0x12:
+                {
+                    error_message = "invalid string: control character U+0012 (DC2) must be escaped to \\u0012";
+                    return token_type::parse_error;
+                }
+
+                case 0x13:
+                {
+                    error_message = "invalid string: control character U+0013 (DC3) must be escaped to \\u0013";
+                    return token_type::parse_error;
+                }
+
+                case 0x14:
+                {
+                    error_message = "invalid string: control character U+0014 (DC4) must be escaped to \\u0014";
+                    return token_type::parse_error;
+                }
+
+                case 0x15:
+                {
+                    error_message = "invalid string: control character U+0015 (NAK) must be escaped to \\u0015";
+                    return token_type::parse_error;
+                }
+
+                case 0x16:
+                {
+                    error_message = "invalid string: control character U+0016 (SYN) must be escaped to \\u0016";
+                    return token_type::parse_error;
+                }
+
+                case 0x17:
+                {
+                    error_message = "invalid string: control character U+0017 (ETB) must be escaped to \\u0017";
+                    return token_type::parse_error;
+                }
+
+                case 0x18:
+                {
+                    error_message = "invalid string: control character U+0018 (CAN) must be escaped to \\u0018";
+                    return token_type::parse_error;
+                }
+
+                case 0x19:
+                {
+                    error_message = "invalid string: control character U+0019 (EM) must be escaped to \\u0019";
+                    return token_type::parse_error;
+                }
+
+                case 0x1A:
+                {
+                    error_message = "invalid string: control character U+001A (SUB) must be escaped to \\u001A";
+                    return token_type::parse_error;
+                }
+
+                case 0x1B:
+                {
+                    error_message = "invalid string: control character U+001B (ESC) must be escaped to \\u001B";
+                    return token_type::parse_error;
+                }
+
+                case 0x1C:
+                {
+                    error_message = "invalid string: control character U+001C (FS) must be escaped to \\u001C";
+                    return token_type::parse_error;
+                }
+
+                case 0x1D:
+                {
+                    error_message = "invalid string: control character U+001D (GS) must be escaped to \\u001D";
+                    return token_type::parse_error;
+                }
+
+                case 0x1E:
+                {
+                    error_message = "invalid string: control character U+001E (RS) must be escaped to \\u001E";
+                    return token_type::parse_error;
+                }
+
+                case 0x1F:
+                {
+                    error_message = "invalid string: control character U+001F (US) must be escaped to \\u001F";
+                    return token_type::parse_error;
+                }
+
+                // U+0020..U+007F (except U+0022 (quote) and U+005C (backspace))
+                case 0x20:
+                case 0x21:
+                case 0x23:
+                case 0x24:
+                case 0x25:
+                case 0x26:
+                case 0x27:
+                case 0x28:
+                case 0x29:
+                case 0x2A:
+                case 0x2B:
+                case 0x2C:
+                case 0x2D:
+                case 0x2E:
+                case 0x2F:
+                case 0x30:
+                case 0x31:
+                case 0x32:
+                case 0x33:
+                case 0x34:
+                case 0x35:
+                case 0x36:
+                case 0x37:
+                case 0x38:
+                case 0x39:
+                case 0x3A:
+                case 0x3B:
+                case 0x3C:
+                case 0x3D:
+                case 0x3E:
+                case 0x3F:
+                case 0x40:
+                case 0x41:
+                case 0x42:
+                case 0x43:
+                case 0x44:
+                case 0x45:
+                case 0x46:
+                case 0x47:
+                case 0x48:
+                case 0x49:
+                case 0x4A:
+                case 0x4B:
+                case 0x4C:
+                case 0x4D:
+                case 0x4E:
+                case 0x4F:
+                case 0x50:
+                case 0x51:
+                case 0x52:
+                case 0x53:
+                case 0x54:
+                case 0x55:
+                case 0x56:
+                case 0x57:
+                case 0x58:
+                case 0x59:
+                case 0x5A:
+                case 0x5B:
+                case 0x5D:
+                case 0x5E:
+                case 0x5F:
+                case 0x60:
+                case 0x61:
+                case 0x62:
+                case 0x63:
+                case 0x64:
+                case 0x65:
+                case 0x66:
+                case 0x67:
+                case 0x68:
+                case 0x69:
+                case 0x6A:
+                case 0x6B:
+                case 0x6C:
+                case 0x6D:
+                case 0x6E:
+                case 0x6F:
+                case 0x70:
+                case 0x71:
+                case 0x72:
+                case 0x73:
+                case 0x74:
+                case 0x75:
+                case 0x76:
+                case 0x77:
+                case 0x78:
+                case 0x79:
+                case 0x7A:
+                case 0x7B:
+                case 0x7C:
+                case 0x7D:
+                case 0x7E:
+                case 0x7F:
+                {
+                    add(current);
+                    break;
+                }
+
+                // U+0080..U+07FF: bytes C2..DF 80..BF
+                case 0xC2:
+                case 0xC3:
+                case 0xC4:
+                case 0xC5:
+                case 0xC6:
+                case 0xC7:
+                case 0xC8:
+                case 0xC9:
+                case 0xCA:
+                case 0xCB:
+                case 0xCC:
+                case 0xCD:
+                case 0xCE:
+                case 0xCF:
+                case 0xD0:
+                case 0xD1:
+                case 0xD2:
+                case 0xD3:
+                case 0xD4:
+                case 0xD5:
+                case 0xD6:
+                case 0xD7:
+                case 0xD8:
+                case 0xD9:
+                case 0xDA:
+                case 0xDB:
+                case 0xDC:
+                case 0xDD:
+                case 0xDE:
+                case 0xDF:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!next_byte_in_range({0x80, 0xBF})))
+                    {
+                        return token_type::parse_error;
+                    }
+                    break;
+                }
+
+                // U+0800..U+0FFF: bytes E0 A0..BF 80..BF
+                case 0xE0:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0xA0, 0xBF, 0x80, 0xBF}))))
+                    {
+                        return token_type::parse_error;
+                    }
+                    break;
+                }
+
+                // U+1000..U+CFFF: bytes E1..EC 80..BF 80..BF
+                // U+E000..U+FFFF: bytes EE..EF 80..BF 80..BF
+                case 0xE1:
+                case 0xE2:
+                case 0xE3:
+                case 0xE4:
+                case 0xE5:
+                case 0xE6:
+                case 0xE7:
+                case 0xE8:
+                case 0xE9:
+                case 0xEA:
+                case 0xEB:
+                case 0xEC:
+                case 0xEE:
+                case 0xEF:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0xBF, 0x80, 0xBF}))))
+                    {
+                        return token_type::parse_error;
+                    }
+                    break;
+                }
+
+                // U+D000..U+D7FF: bytes ED 80..9F 80..BF
+                case 0xED:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0x9F, 0x80, 0xBF}))))
+                    {
+                        return token_type::parse_error;
+                    }
+                    break;
+                }
+
+                // U+10000..U+3FFFF F0 90..BF 80..BF 80..BF
+                case 0xF0:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x90, 0xBF, 0x80, 0xBF, 0x80, 0xBF}))))
+                    {
+                        return token_type::parse_error;
+                    }
+                    break;
+                }
+
+                // U+40000..U+FFFFF F1..F3 80..BF 80..BF 80..BF
+                case 0xF1:
+                case 0xF2:
+                case 0xF3:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0xBF, 0x80, 0xBF, 0x80, 0xBF}))))
+                    {
+                        return token_type::parse_error;
+                    }
+                    break;
+                }
+
+                // U+100000..U+10FFFF F4 80..8F 80..BF 80..BF
+                case 0xF4:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0x8F, 0x80, 0xBF, 0x80, 0xBF}))))
+                    {
+                        return token_type::parse_error;
+                    }
+                    break;
+                }
+
+                // remaining bytes (80..C1 and F5..FF) are ill-formed
+                default:
+                {
+                    error_message = "invalid string: ill-formed UTF-8 byte";
+                    return token_type::parse_error;
+                }
+            }
+        }
+    }
+
+    /*!
+     * @brief scan a comment
+     * @return whether comment could be scanned successfully
+     */
+    bool scan_comment()
+    {
+        switch (get())
+        {
+            // single-line comments skip input until a newline or EOF is read
+            case '/':
+            {
+                while (true)
+                {
+                    switch (get())
+                    {
+                        case '\n':
+                        case '\r':
+                        case std::char_traits<char_type>::eof():
+                        case '\0':
+                            return true;
+
+                        default:
+                            break;
+                    }
+                }
+            }
+
+            // multi-line comments skip input until */ is read
+            case '*':
+            {
+                while (true)
+                {
+                    switch (get())
+                    {
+                        case std::char_traits<char_type>::eof():
+                        case '\0':
+                        {
+                            error_message = "invalid comment; missing closing '*/'";
+                            return false;
+                        }
+
+                        case '*':
+                        {
+                            switch (get())
+                            {
+                                case '/':
+                                    return true;
+
+                                default:
+                                {
+                                    unget();
+                                    continue;
+                                }
+                            }
+                        }
+
+                        default:
+                            continue;
+                    }
+                }
+            }
+
+            // unexpected character after reading '/'
+            default:
+            {
+                error_message = "invalid comment; expecting '/' or '*' after '/'";
+                return false;
+            }
+        }
+    }
+
+    JSON_HEDLEY_NON_NULL(2)
+    static void strtof(float& f, const char* str, char** endptr) noexcept
+    {
+        f = std::strtof(str, endptr);
+    }
+
+    JSON_HEDLEY_NON_NULL(2)
+    static void strtof(double& f, const char* str, char** endptr) noexcept
+    {
+        f = std::strtod(str, endptr);
+    }
+
+    JSON_HEDLEY_NON_NULL(2)
+    static void strtof(long double& f, const char* str, char** endptr) noexcept
+    {
+        f = std::strtold(str, endptr);
+    }
+
+    /*!
+    @brief scan a number literal
+
+    This function scans a string according to Sect. 6 of RFC 8259.
+
+    The function is realized with a deterministic finite state machine derived
+    from the grammar described in RFC 8259. Starting in state "init", the
+    input is read and used to determined the next state. Only state "done"
+    accepts the number. State "error" is a trap state to model errors. In the
+    table below, "anything" means any character but the ones listed before.
+
+    state    | 0        | 1-9      | e E      | +       | -       | .        | anything
+    ---------|----------|----------|----------|---------|---------|----------|-----------
+    init     | zero     | any1     | [error]  | [error] | minus   | [error]  | [error]
+    minus    | zero     | any1     | [error]  | [error] | [error] | [error]  | [error]
+    zero     | done     | done     | exponent | done    | done    | decimal1 | done
+    any1     | any1     | any1     | exponent | done    | done    | decimal1 | done
+    decimal1 | decimal2 | decimal2 | [error]  | [error] | [error] | [error]  | [error]
+    decimal2 | decimal2 | decimal2 | exponent | done    | done    | done     | done
+    exponent | any2     | any2     | [error]  | sign    | sign    | [error]  | [error]
+    sign     | any2     | any2     | [error]  | [error] | [error] | [error]  | [error]
+    any2     | any2     | any2     | done     | done    | done    | done     | done
+
+    The state machine is realized with one label per state (prefixed with
+    "scan_number_") and `goto` statements between them. The state machine
+    contains cycles, but any cycle can be left when EOF is read. Therefore,
+    the function is guaranteed to terminate.
+
+    During scanning, the read bytes are stored in token_buffer. This string is
+    then converted to a signed integer, an unsigned integer, or a
+    floating-point number.
+
+    @return token_type::value_unsigned, token_type::value_integer, or
+            token_type::value_float if number could be successfully scanned,
+            token_type::parse_error otherwise
+
+    @note The scanner is independent of the current locale. Internally, the
+          locale's decimal point is used instead of `.` to work with the
+          locale-dependent converters.
+    */
+    token_type scan_number()  // lgtm [cpp/use-of-goto]
+    {
+        // reset token_buffer to store the number's bytes
+        reset();
+
+        // the type of the parsed number; initially set to unsigned; will be
+        // changed if minus sign, decimal point or exponent is read
+        token_type number_type = token_type::value_unsigned;
+
+        // state (init): we just found out we need to scan a number
+        switch (current)
+        {
+            case '-':
+            {
+                add(current);
+                goto scan_number_minus;
+            }
+
+            case '0':
+            {
+                add(current);
+                goto scan_number_zero;
+            }
+
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_any1;
+            }
+
+            // all other characters are rejected outside scan_number()
+            default:            // LCOV_EXCL_LINE
+                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+        }
+
+scan_number_minus:
+        // state: we just parsed a leading minus sign
+        number_type = token_type::value_integer;
+        switch (get())
+        {
+            case '0':
+            {
+                add(current);
+                goto scan_number_zero;
+            }
+
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_any1;
+            }
+
+            default:
+            {
+                error_message = "invalid number; expected digit after '-'";
+                return token_type::parse_error;
+            }
+        }
+
+scan_number_zero:
+        // state: we just parse a zero (maybe with a leading minus sign)
+        switch (get())
+        {
+            case '.':
+            {
+                add(decimal_point_char);
+                goto scan_number_decimal1;
+            }
+
+            case 'e':
+            case 'E':
+            {
+                add(current);
+                goto scan_number_exponent;
+            }
+
+            default:
+                goto scan_number_done;
+        }
+
+scan_number_any1:
+        // state: we just parsed a number 0-9 (maybe with a leading minus sign)
+        switch (get())
+        {
+            case '0':
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_any1;
+            }
+
+            case '.':
+            {
+                add(decimal_point_char);
+                goto scan_number_decimal1;
+            }
+
+            case 'e':
+            case 'E':
+            {
+                add(current);
+                goto scan_number_exponent;
+            }
+
+            default:
+                goto scan_number_done;
+        }
+
+scan_number_decimal1:
+        // state: we just parsed a decimal point
+        number_type = token_type::value_float;
+        switch (get())
+        {
+            case '0':
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_decimal2;
+            }
+
+            default:
+            {
+                error_message = "invalid number; expected digit after '.'";
+                return token_type::parse_error;
+            }
+        }
+
+scan_number_decimal2:
+        // we just parsed at least one number after a decimal point
+        switch (get())
+        {
+            case '0':
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_decimal2;
+            }
+
+            case 'e':
+            case 'E':
+            {
+                add(current);
+                goto scan_number_exponent;
+            }
+
+            default:
+                goto scan_number_done;
+        }
+
+scan_number_exponent:
+        // we just parsed an exponent
+        number_type = token_type::value_float;
+        switch (get())
+        {
+            case '+':
+            case '-':
+            {
+                add(current);
+                goto scan_number_sign;
+            }
+
+            case '0':
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_any2;
+            }
+
+            default:
+            {
+                error_message =
+                    "invalid number; expected '+', '-', or digit after exponent";
+                return token_type::parse_error;
+            }
+        }
+
+scan_number_sign:
+        // we just parsed an exponent sign
+        switch (get())
+        {
+            case '0':
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_any2;
+            }
+
+            default:
+            {
+                error_message = "invalid number; expected digit after exponent sign";
+                return token_type::parse_error;
+            }
+        }
+
+scan_number_any2:
+        // we just parsed a number after the exponent or exponent sign
+        switch (get())
+        {
+            case '0':
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+            {
+                add(current);
+                goto scan_number_any2;
+            }
+
+            default:
+                goto scan_number_done;
+        }
+
+scan_number_done:
+        // unget the character after the number (we only read it to know that
+        // we are done scanning a number)
+        unget();
+
+        char* endptr = nullptr; // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+        errno = 0;
+
+        // try to parse integers first and fall back to floats
+        if (number_type == token_type::value_unsigned)
+        {
+            const auto x = std::strtoull(token_buffer.data(), &endptr, 10);
+
+            // we checked the number format before
+            JSON_ASSERT(endptr == token_buffer.data() + token_buffer.size());
+
+            if (errno == 0)
+            {
+                value_unsigned = static_cast<number_unsigned_t>(x);
+                if (value_unsigned == x)
+                {
+                    return token_type::value_unsigned;
+                }
+            }
+        }
+        else if (number_type == token_type::value_integer)
+        {
+            const auto x = std::strtoll(token_buffer.data(), &endptr, 10);
+
+            // we checked the number format before
+            JSON_ASSERT(endptr == token_buffer.data() + token_buffer.size());
+
+            if (errno == 0)
+            {
+                value_integer = static_cast<number_integer_t>(x);
+                if (value_integer == x)
+                {
+                    return token_type::value_integer;
+                }
+            }
+        }
+
+        // this code is reached if we parse a floating-point number or if an
+        // integer conversion above failed
+        strtof(value_float, token_buffer.data(), &endptr);
+
+        // we checked the number format before
+        JSON_ASSERT(endptr == token_buffer.data() + token_buffer.size());
+
+        return token_type::value_float;
+    }
+
+    /*!
+    @param[in] literal_text  the literal text to expect
+    @param[in] length        the length of the passed literal text
+    @param[in] return_type   the token type to return on success
+    */
+    JSON_HEDLEY_NON_NULL(2)
+    token_type scan_literal(const char_type* literal_text, const std::size_t length,
+                            token_type return_type)
+    {
+        JSON_ASSERT(std::char_traits<char_type>::to_char_type(current) == literal_text[0]);
+        for (std::size_t i = 1; i < length; ++i)
+        {
+            if (JSON_HEDLEY_UNLIKELY(std::char_traits<char_type>::to_char_type(get()) != literal_text[i]))
+            {
+                error_message = "invalid literal";
+                return token_type::parse_error;
+            }
+        }
+        return return_type;
+    }
+
+    /////////////////////
+    // input management
+    /////////////////////
+
+    /// reset token_buffer; current character is beginning of token
+    void reset() noexcept
+    {
+        token_buffer.clear();
+        token_string.clear();
+        token_string.push_back(std::char_traits<char_type>::to_char_type(current));
+    }
+
+    /*
+    @brief get next character from the input
+
+    This function provides the interface to the used input adapter. It does
+    not throw in case the input reached EOF, but returns a
+    `std::char_traits<char>::eof()` in that case.  Stores the scanned characters
+    for use in error messages.
+
+    @return character read from the input
+    */
+    char_int_type get()
+    {
+        ++position.chars_read_total;
+        ++position.chars_read_current_line;
+
+        if (next_unget)
+        {
+            // just reset the next_unget variable and work with current
+            next_unget = false;
+        }
+        else
+        {
+            current = ia.get_character();
+        }
+
+        if (JSON_HEDLEY_LIKELY(current != std::char_traits<char_type>::eof()))
+        {
+            token_string.push_back(std::char_traits<char_type>::to_char_type(current));
+        }
+
+        if (current == '\n')
+        {
+            ++position.lines_read;
+            position.chars_read_current_line = 0;
+        }
+
+        return current;
+    }
+
+    /*!
+    @brief unget current character (read it again on next get)
+
+    We implement unget by setting variable next_unget to true. The input is not
+    changed - we just simulate ungetting by modifying chars_read_total,
+    chars_read_current_line, and token_string. The next call to get() will
+    behave as if the unget character is read again.
+    */
+    void unget()
+    {
+        next_unget = true;
+
+        --position.chars_read_total;
+
+        // in case we "unget" a newline, we have to also decrement the lines_read
+        if (position.chars_read_current_line == 0)
+        {
+            if (position.lines_read > 0)
+            {
+                --position.lines_read;
+            }
+        }
+        else
+        {
+            --position.chars_read_current_line;
+        }
+
+        if (JSON_HEDLEY_LIKELY(current != std::char_traits<char_type>::eof()))
+        {
+            JSON_ASSERT(!token_string.empty());
+            token_string.pop_back();
+        }
+    }
+
+    /// add a character to token_buffer
+    void add(char_int_type c)
+    {
+        token_buffer.push_back(static_cast<typename string_t::value_type>(c));
+    }
+
+  public:
+    /////////////////////
+    // value getters
+    /////////////////////
+
+    /// return integer value
+    constexpr number_integer_t get_number_integer() const noexcept
+    {
+        return value_integer;
+    }
+
+    /// return unsigned integer value
+    constexpr number_unsigned_t get_number_unsigned() const noexcept
+    {
+        return value_unsigned;
+    }
+
+    /// return floating-point value
+    constexpr number_float_t get_number_float() const noexcept
+    {
+        return value_float;
+    }
+
+    /// return current string value (implicitly resets the token; useful only once)
+    string_t& get_string()
+    {
+        return token_buffer;
+    }
+
+    /////////////////////
+    // diagnostics
+    /////////////////////
+
+    /// return position of last read token
+    constexpr position_t get_position() const noexcept
+    {
+        return position;
+    }
+
+    /// return the last read token (for errors only).  Will never contain EOF
+    /// (an arbitrary value that is not a valid char value, often -1), because
+    /// 255 may legitimately occur.  May contain NUL, which should be escaped.
+    std::string get_token_string() const
+    {
+        // escape control characters
+        std::string result;
+        for (const auto c : token_string)
+        {
+            if (static_cast<unsigned char>(c) <= '\x1F')
+            {
+                // escape control characters
+                std::array<char, 9> cs{{}};
+                static_cast<void>((std::snprintf)(cs.data(), cs.size(), "<U+%.4X>", static_cast<unsigned char>(c))); // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+                result += cs.data();
+            }
+            else
+            {
+                // add character as is
+                result.push_back(static_cast<std::string::value_type>(c));
+            }
+        }
+
+        return result;
+    }
+
+    /// return syntax error message
+    JSON_HEDLEY_RETURNS_NON_NULL
+    constexpr const char* get_error_message() const noexcept
+    {
+        return error_message;
+    }
+
+    /////////////////////
+    // actual scanner
+    /////////////////////
+
+    /*!
+    @brief skip the UTF-8 byte order mark
+    @return true iff there is no BOM or the correct BOM has been skipped
+    */
+    bool skip_bom()
+    {
+        if (get() == 0xEF)
+        {
+            // check if we completely parse the BOM
+            return get() == 0xBB && get() == 0xBF;
+        }
+
+        // the first character is not the beginning of the BOM; unget it to
+        // process is later
+        unget();
+        return true;
+    }
+
+    void skip_whitespace()
+    {
+        do
+        {
+            get();
+        }
+        while (current == ' ' || current == '\t' || current == '\n' || current == '\r');
+    }
+
+    token_type scan()
+    {
+        // initially, skip the BOM
+        if (position.chars_read_total == 0 && !skip_bom())
+        {
+            error_message = "invalid BOM; must be 0xEF 0xBB 0xBF if given";
+            return token_type::parse_error;
+        }
+
+        // read next character and ignore whitespace
+        skip_whitespace();
+
+        // ignore comments
+        while (ignore_comments && current == '/')
+        {
+            if (!scan_comment())
+            {
+                return token_type::parse_error;
+            }
+
+            // skip following whitespace
+            skip_whitespace();
+        }
+
+        switch (current)
+        {
+            // structural characters
+            case '[':
+                return token_type::begin_array;
+            case ']':
+                return token_type::end_array;
+            case '{':
+                return token_type::begin_object;
+            case '}':
+                return token_type::end_object;
+            case ':':
+                return token_type::name_separator;
+            case ',':
+                return token_type::value_separator;
+
+            // literals
+            case 't':
+            {
+                std::array<char_type, 4> true_literal = {{static_cast<char_type>('t'), static_cast<char_type>('r'), static_cast<char_type>('u'), static_cast<char_type>('e')}};
+                return scan_literal(true_literal.data(), true_literal.size(), token_type::literal_true);
+            }
+            case 'f':
+            {
+                std::array<char_type, 5> false_literal = {{static_cast<char_type>('f'), static_cast<char_type>('a'), static_cast<char_type>('l'), static_cast<char_type>('s'), static_cast<char_type>('e')}};
+                return scan_literal(false_literal.data(), false_literal.size(), token_type::literal_false);
+            }
+            case 'n':
+            {
+                std::array<char_type, 4> null_literal = {{static_cast<char_type>('n'), static_cast<char_type>('u'), static_cast<char_type>('l'), static_cast<char_type>('l')}};
+                return scan_literal(null_literal.data(), null_literal.size(), token_type::literal_null);
+            }
+
+            // string
+            case '\"':
+                return scan_string();
+
+            // number
+            case '-':
+            case '0':
+            case '1':
+            case '2':
+            case '3':
+            case '4':
+            case '5':
+            case '6':
+            case '7':
+            case '8':
+            case '9':
+                return scan_number();
+
+            // end of input (the null byte is needed when parsing from
+            // string literals)
+            case '\0':
+            case std::char_traits<char_type>::eof():
+                return token_type::end_of_input;
+
+            // error
+            default:
+                error_message = "invalid literal";
+                return token_type::parse_error;
+        }
+    }
+
+  private:
+    /// input adapter
+    InputAdapterType ia;
+
+    /// whether comments should be ignored (true) or signaled as errors (false)
+    const bool ignore_comments = false;
+
+    /// the current character
+    char_int_type current = std::char_traits<char_type>::eof();
+
+    /// whether the next get() call should just return current
+    bool next_unget = false;
+
+    /// the start position of the current token
+    position_t position {};
+
+    /// raw input token string (for error messages)
+    std::vector<char_type> token_string {};
+
+    /// buffer for variable-length tokens (numbers, strings)
+    string_t token_buffer {};
+
+    /// a description of occurred lexer errors
+    const char* error_message = "";
+
+    // number values
+    number_integer_t value_integer = 0;
+    number_unsigned_t value_unsigned = 0;
+    number_float_t value_float = 0;
+
+    /// the decimal point
+    const char_int_type decimal_point_char = '.';
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/meta/is_sax.hpp>
+
+
+#include <cstdint> // size_t
+#include <utility> // declval
+#include <string> // string
+
+// #include <nlohmann/detail/meta/detected.hpp>
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+template<typename T>
+using null_function_t = decltype(std::declval<T&>().null());
+
+template<typename T>
+using boolean_function_t =
+    decltype(std::declval<T&>().boolean(std::declval<bool>()));
+
+template<typename T, typename Integer>
+using number_integer_function_t =
+    decltype(std::declval<T&>().number_integer(std::declval<Integer>()));
+
+template<typename T, typename Unsigned>
+using number_unsigned_function_t =
+    decltype(std::declval<T&>().number_unsigned(std::declval<Unsigned>()));
+
+template<typename T, typename Float, typename String>
+using number_float_function_t = decltype(std::declval<T&>().number_float(
+                                    std::declval<Float>(), std::declval<const String&>()));
+
+template<typename T, typename String>
+using string_function_t =
+    decltype(std::declval<T&>().string(std::declval<String&>()));
+
+template<typename T, typename Binary>
+using binary_function_t =
+    decltype(std::declval<T&>().binary(std::declval<Binary&>()));
+
+template<typename T>
+using start_object_function_t =
+    decltype(std::declval<T&>().start_object(std::declval<std::size_t>()));
+
+template<typename T, typename String>
+using key_function_t =
+    decltype(std::declval<T&>().key(std::declval<String&>()));
+
+template<typename T>
+using end_object_function_t = decltype(std::declval<T&>().end_object());
+
+template<typename T>
+using start_array_function_t =
+    decltype(std::declval<T&>().start_array(std::declval<std::size_t>()));
+
+template<typename T>
+using end_array_function_t = decltype(std::declval<T&>().end_array());
+
+template<typename T, typename Exception>
+using parse_error_function_t = decltype(std::declval<T&>().parse_error(
+        std::declval<std::size_t>(), std::declval<const std::string&>(),
+        std::declval<const Exception&>()));
+
+template<typename SAX, typename BasicJsonType>
+struct is_sax
+{
+  private:
+    static_assert(is_basic_json<BasicJsonType>::value,
+                  "BasicJsonType must be of type basic_json<...>");
+
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+    using exception_t = typename BasicJsonType::exception;
+
+  public:
+    static constexpr bool value =
+        is_detected_exact<bool, null_function_t, SAX>::value &&
+        is_detected_exact<bool, boolean_function_t, SAX>::value &&
+        is_detected_exact<bool, number_integer_function_t, SAX, number_integer_t>::value &&
+        is_detected_exact<bool, number_unsigned_function_t, SAX, number_unsigned_t>::value &&
+        is_detected_exact<bool, number_float_function_t, SAX, number_float_t, string_t>::value &&
+        is_detected_exact<bool, string_function_t, SAX, string_t>::value &&
+        is_detected_exact<bool, binary_function_t, SAX, binary_t>::value &&
+        is_detected_exact<bool, start_object_function_t, SAX>::value &&
+        is_detected_exact<bool, key_function_t, SAX, string_t>::value &&
+        is_detected_exact<bool, end_object_function_t, SAX>::value &&
+        is_detected_exact<bool, start_array_function_t, SAX>::value &&
+        is_detected_exact<bool, end_array_function_t, SAX>::value &&
+        is_detected_exact<bool, parse_error_function_t, SAX, exception_t>::value;
+};
+
+template<typename SAX, typename BasicJsonType>
+struct is_sax_static_asserts
+{
+  private:
+    static_assert(is_basic_json<BasicJsonType>::value,
+                  "BasicJsonType must be of type basic_json<...>");
+
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+    using exception_t = typename BasicJsonType::exception;
+
+  public:
+    static_assert(is_detected_exact<bool, null_function_t, SAX>::value,
+                  "Missing/invalid function: bool null()");
+    static_assert(is_detected_exact<bool, boolean_function_t, SAX>::value,
+                  "Missing/invalid function: bool boolean(bool)");
+    static_assert(is_detected_exact<bool, boolean_function_t, SAX>::value,
+                  "Missing/invalid function: bool boolean(bool)");
+    static_assert(
+        is_detected_exact<bool, number_integer_function_t, SAX,
+        number_integer_t>::value,
+        "Missing/invalid function: bool number_integer(number_integer_t)");
+    static_assert(
+        is_detected_exact<bool, number_unsigned_function_t, SAX,
+        number_unsigned_t>::value,
+        "Missing/invalid function: bool number_unsigned(number_unsigned_t)");
+    static_assert(is_detected_exact<bool, number_float_function_t, SAX,
+                  number_float_t, string_t>::value,
+                  "Missing/invalid function: bool number_float(number_float_t, const string_t&)");
+    static_assert(
+        is_detected_exact<bool, string_function_t, SAX, string_t>::value,
+        "Missing/invalid function: bool string(string_t&)");
+    static_assert(
+        is_detected_exact<bool, binary_function_t, SAX, binary_t>::value,
+        "Missing/invalid function: bool binary(binary_t&)");
+    static_assert(is_detected_exact<bool, start_object_function_t, SAX>::value,
+                  "Missing/invalid function: bool start_object(std::size_t)");
+    static_assert(is_detected_exact<bool, key_function_t, SAX, string_t>::value,
+                  "Missing/invalid function: bool key(string_t&)");
+    static_assert(is_detected_exact<bool, end_object_function_t, SAX>::value,
+                  "Missing/invalid function: bool end_object()");
+    static_assert(is_detected_exact<bool, start_array_function_t, SAX>::value,
+                  "Missing/invalid function: bool start_array(std::size_t)");
+    static_assert(is_detected_exact<bool, end_array_function_t, SAX>::value,
+                  "Missing/invalid function: bool end_array()");
+    static_assert(
+        is_detected_exact<bool, parse_error_function_t, SAX, exception_t>::value,
+        "Missing/invalid function: bool parse_error(std::size_t, const "
+        "std::string&, const exception&)");
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+
+/// how to treat CBOR tags
+enum class cbor_tag_handler_t
+{
+    error,   ///< throw a parse_error exception in case of a tag
+    ignore,  ///< ignore tags
+    store    ///< store tags as binary type
+};
+
+/*!
+@brief determine system byte order
+
+@return true if and only if system's byte order is little endian
+
+@note from https://stackoverflow.com/a/1001328/266378
+*/
+static inline bool little_endianness(int num = 1) noexcept
+{
+    return *reinterpret_cast<char*>(&num) == 1;
+}
+
+
+///////////////////
+// binary reader //
+///////////////////
+
+/*!
+@brief deserialization of CBOR, MessagePack, and UBJSON values
+*/
+template<typename BasicJsonType, typename InputAdapterType, typename SAX = json_sax_dom_parser<BasicJsonType>>
+class binary_reader
+{
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+    using json_sax_t = SAX;
+    using char_type = typename InputAdapterType::char_type;
+    using char_int_type = typename std::char_traits<char_type>::int_type;
+
+  public:
+    /*!
+    @brief create a binary reader
+
+    @param[in] adapter  input adapter to read from
+    */
+    explicit binary_reader(InputAdapterType&& adapter) noexcept : ia(std::move(adapter))
+    {
+        (void)detail::is_sax_static_asserts<SAX, BasicJsonType> {};
+    }
+
+    // make class move-only
+    binary_reader(const binary_reader&) = delete;
+    binary_reader(binary_reader&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    binary_reader& operator=(const binary_reader&) = delete;
+    binary_reader& operator=(binary_reader&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
+    ~binary_reader() = default;
+
+    /*!
+    @param[in] format  the binary format to parse
+    @param[in] sax_    a SAX event processor
+    @param[in] strict  whether to expect the input to be consumed completed
+    @param[in] tag_handler  how to treat CBOR tags
+
+    @return whether parsing was successful
+    */
+    JSON_HEDLEY_NON_NULL(3)
+    bool sax_parse(const input_format_t format,
+                   json_sax_t* sax_,
+                   const bool strict = true,
+                   const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
+    {
+        sax = sax_;
+        bool result = false;
+
+        switch (format)
+        {
+            case input_format_t::bson:
+                result = parse_bson_internal();
+                break;
+
+            case input_format_t::cbor:
+                result = parse_cbor_internal(true, tag_handler);
+                break;
+
+            case input_format_t::msgpack:
+                result = parse_msgpack_internal();
+                break;
+
+            case input_format_t::ubjson:
+                result = parse_ubjson_internal();
+                break;
+
+            case input_format_t::json: // LCOV_EXCL_LINE
+            default:            // LCOV_EXCL_LINE
+                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+        }
+
+        // strict mode: next byte must be EOF
+        if (result && strict)
+        {
+            if (format == input_format_t::ubjson)
+            {
+                get_ignore_noop();
+            }
+            else
+            {
+                get();
+            }
+
+            if (JSON_HEDLEY_UNLIKELY(current != std::char_traits<char_type>::eof()))
+            {
+                return sax->parse_error(chars_read, get_token_string(),
+                                        parse_error::create(110, chars_read, exception_message(format, "expected end of input; last byte: 0x" + get_token_string(), "value"), BasicJsonType()));
+            }
+        }
+
+        return result;
+    }
+
+  private:
+    //////////
+    // BSON //
+    //////////
+
+    /*!
+    @brief Reads in a BSON-object and passes it to the SAX-parser.
+    @return whether a valid BSON-value was passed to the SAX parser
+    */
+    bool parse_bson_internal()
+    {
+        std::int32_t document_size{};
+        get_number<std::int32_t, true>(input_format_t::bson, document_size);
+
+        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(static_cast<std::size_t>(-1))))
+        {
+            return false;
+        }
+
+        if (JSON_HEDLEY_UNLIKELY(!parse_bson_element_list(/*is_array*/false)))
+        {
+            return false;
+        }
+
+        return sax->end_object();
+    }
+
+    /*!
+    @brief Parses a C-style string from the BSON input.
+    @param[in,out] result  A reference to the string variable where the read
+                            string is to be stored.
+    @return `true` if the \x00-byte indicating the end of the string was
+             encountered before the EOF; false` indicates an unexpected EOF.
+    */
+    bool get_bson_cstr(string_t& result)
+    {
+        auto out = std::back_inserter(result);
+        while (true)
+        {
+            get();
+            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::bson, "cstring")))
+            {
+                return false;
+            }
+            if (current == 0x00)
+            {
+                return true;
+            }
+            *out++ = static_cast<typename string_t::value_type>(current);
+        }
+    }
+
+    /*!
+    @brief Parses a zero-terminated string of length @a len from the BSON
+           input.
+    @param[in] len  The length (including the zero-byte at the end) of the
+                    string to be read.
+    @param[in,out] result  A reference to the string variable where the read
+                            string is to be stored.
+    @tparam NumberType The type of the length @a len
+    @pre len >= 1
+    @return `true` if the string was successfully parsed
+    */
+    template<typename NumberType>
+    bool get_bson_string(const NumberType len, string_t& result)
+    {
+        if (JSON_HEDLEY_UNLIKELY(len < 1))
+        {
+            auto last_token = get_token_string();
+            return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::bson, "string length must be at least 1, is " + std::to_string(len), "string"), BasicJsonType()));
+        }
+
+        return get_string(input_format_t::bson, len - static_cast<NumberType>(1), result) && get() != std::char_traits<char_type>::eof();
+    }
+
+    /*!
+    @brief Parses a byte array input of length @a len from the BSON input.
+    @param[in] len  The length of the byte array to be read.
+    @param[in,out] result  A reference to the binary variable where the read
+                            array is to be stored.
+    @tparam NumberType The type of the length @a len
+    @pre len >= 0
+    @return `true` if the byte array was successfully parsed
+    */
+    template<typename NumberType>
+    bool get_bson_binary(const NumberType len, binary_t& result)
+    {
+        if (JSON_HEDLEY_UNLIKELY(len < 0))
+        {
+            auto last_token = get_token_string();
+            return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::bson, "byte array length cannot be negative, is " + std::to_string(len), "binary"), BasicJsonType()));
+        }
+
+        // All BSON binary values have a subtype
+        std::uint8_t subtype{};
+        get_number<std::uint8_t>(input_format_t::bson, subtype);
+        result.set_subtype(subtype);
+
+        return get_binary(input_format_t::bson, len, result);
+    }
+
+    /*!
+    @brief Read a BSON document element of the given @a element_type.
+    @param[in] element_type The BSON element type, c.f. http://bsonspec.org/spec.html
+    @param[in] element_type_parse_position The position in the input stream,
+               where the `element_type` was read.
+    @warning Not all BSON element types are supported yet. An unsupported
+             @a element_type will give rise to a parse_error.114:
+             Unsupported BSON record type 0x...
+    @return whether a valid BSON-object/array was passed to the SAX parser
+    */
+    bool parse_bson_element_internal(const char_int_type element_type,
+                                     const std::size_t element_type_parse_position)
+    {
+        switch (element_type)
+        {
+            case 0x01: // double
+            {
+                double number{};
+                return get_number<double, true>(input_format_t::bson, number) && sax->number_float(static_cast<number_float_t>(number), "");
+            }
+
+            case 0x02: // string
+            {
+                std::int32_t len{};
+                string_t value;
+                return get_number<std::int32_t, true>(input_format_t::bson, len) && get_bson_string(len, value) && sax->string(value);
+            }
+
+            case 0x03: // object
+            {
+                return parse_bson_internal();
+            }
+
+            case 0x04: // array
+            {
+                return parse_bson_array();
+            }
+
+            case 0x05: // binary
+            {
+                std::int32_t len{};
+                binary_t value;
+                return get_number<std::int32_t, true>(input_format_t::bson, len) && get_bson_binary(len, value) && sax->binary(value);
+            }
+
+            case 0x08: // boolean
+            {
+                return sax->boolean(get() != 0);
+            }
+
+            case 0x0A: // null
+            {
+                return sax->null();
+            }
+
+            case 0x10: // int32
+            {
+                std::int32_t value{};
+                return get_number<std::int32_t, true>(input_format_t::bson, value) && sax->number_integer(value);
+            }
+
+            case 0x12: // int64
+            {
+                std::int64_t value{};
+                return get_number<std::int64_t, true>(input_format_t::bson, value) && sax->number_integer(value);
+            }
+
+            default: // anything else not supported (yet)
+            {
+                std::array<char, 3> cr{{}};
+                static_cast<void>((std::snprintf)(cr.data(), cr.size(), "%.2hhX", static_cast<unsigned char>(element_type))); // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+                return sax->parse_error(element_type_parse_position, std::string(cr.data()), parse_error::create(114, element_type_parse_position, "Unsupported BSON record type 0x" + std::string(cr.data()), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @brief Read a BSON element list (as specified in the BSON-spec)
+
+    The same binary layout is used for objects and arrays, hence it must be
+    indicated with the argument @a is_array which one is expected
+    (true --> array, false --> object).
+
+    @param[in] is_array Determines if the element list being read is to be
+                        treated as an object (@a is_array == false), or as an
+                        array (@a is_array == true).
+    @return whether a valid BSON-object/array was passed to the SAX parser
+    */
+    bool parse_bson_element_list(const bool is_array)
+    {
+        string_t key;
+
+        while (auto element_type = get())
+        {
+            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::bson, "element list")))
+            {
+                return false;
+            }
+
+            const std::size_t element_type_parse_position = chars_read;
+            if (JSON_HEDLEY_UNLIKELY(!get_bson_cstr(key)))
+            {
+                return false;
+            }
+
+            if (!is_array && !sax->key(key))
+            {
+                return false;
+            }
+
+            if (JSON_HEDLEY_UNLIKELY(!parse_bson_element_internal(element_type, element_type_parse_position)))
+            {
+                return false;
+            }
+
+            // get_bson_cstr only appends
+            key.clear();
+        }
+
+        return true;
+    }
+
+    /*!
+    @brief Reads an array from the BSON input and passes it to the SAX-parser.
+    @return whether a valid BSON-array was passed to the SAX parser
+    */
+    bool parse_bson_array()
+    {
+        std::int32_t document_size{};
+        get_number<std::int32_t, true>(input_format_t::bson, document_size);
+
+        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(static_cast<std::size_t>(-1))))
+        {
+            return false;
+        }
+
+        if (JSON_HEDLEY_UNLIKELY(!parse_bson_element_list(/*is_array*/true)))
+        {
+            return false;
+        }
+
+        return sax->end_array();
+    }
+
+    //////////
+    // CBOR //
+    //////////
+
+    /*!
+    @param[in] get_char  whether a new character should be retrieved from the
+                         input (true) or whether the last read character should
+                         be considered instead (false)
+    @param[in] tag_handler how CBOR tags should be treated
+
+    @return whether a valid CBOR value was passed to the SAX parser
+    */
+    bool parse_cbor_internal(const bool get_char,
+                             const cbor_tag_handler_t tag_handler)
+    {
+        switch (get_char ? get() : current)
+        {
+            // EOF
+            case std::char_traits<char_type>::eof():
+                return unexpect_eof(input_format_t::cbor, "value");
+
+            // Integer 0x00..0x17 (0..23)
+            case 0x00:
+            case 0x01:
+            case 0x02:
+            case 0x03:
+            case 0x04:
+            case 0x05:
+            case 0x06:
+            case 0x07:
+            case 0x08:
+            case 0x09:
+            case 0x0A:
+            case 0x0B:
+            case 0x0C:
+            case 0x0D:
+            case 0x0E:
+            case 0x0F:
+            case 0x10:
+            case 0x11:
+            case 0x12:
+            case 0x13:
+            case 0x14:
+            case 0x15:
+            case 0x16:
+            case 0x17:
+                return sax->number_unsigned(static_cast<number_unsigned_t>(current));
+
+            case 0x18: // Unsigned integer (one-byte uint8_t follows)
+            {
+                std::uint8_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
+            }
+
+            case 0x19: // Unsigned integer (two-byte uint16_t follows)
+            {
+                std::uint16_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
+            }
+
+            case 0x1A: // Unsigned integer (four-byte uint32_t follows)
+            {
+                std::uint32_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
+            }
+
+            case 0x1B: // Unsigned integer (eight-byte uint64_t follows)
+            {
+                std::uint64_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
+            }
+
+            // Negative integer -1-0x00..-1-0x17 (-1..-24)
+            case 0x20:
+            case 0x21:
+            case 0x22:
+            case 0x23:
+            case 0x24:
+            case 0x25:
+            case 0x26:
+            case 0x27:
+            case 0x28:
+            case 0x29:
+            case 0x2A:
+            case 0x2B:
+            case 0x2C:
+            case 0x2D:
+            case 0x2E:
+            case 0x2F:
+            case 0x30:
+            case 0x31:
+            case 0x32:
+            case 0x33:
+            case 0x34:
+            case 0x35:
+            case 0x36:
+            case 0x37:
+                return sax->number_integer(static_cast<std::int8_t>(0x20 - 1 - current));
+
+            case 0x38: // Negative integer (one-byte uint8_t follows)
+            {
+                std::uint8_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1) - number);
+            }
+
+            case 0x39: // Negative integer -1-n (two-byte uint16_t follows)
+            {
+                std::uint16_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1) - number);
+            }
+
+            case 0x3A: // Negative integer -1-n (four-byte uint32_t follows)
+            {
+                std::uint32_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1) - number);
+            }
+
+            case 0x3B: // Negative integer -1-n (eight-byte uint64_t follows)
+            {
+                std::uint64_t number{};
+                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1)
+                        - static_cast<number_integer_t>(number));
+            }
+
+            // Binary data (0x00..0x17 bytes follow)
+            case 0x40:
+            case 0x41:
+            case 0x42:
+            case 0x43:
+            case 0x44:
+            case 0x45:
+            case 0x46:
+            case 0x47:
+            case 0x48:
+            case 0x49:
+            case 0x4A:
+            case 0x4B:
+            case 0x4C:
+            case 0x4D:
+            case 0x4E:
+            case 0x4F:
+            case 0x50:
+            case 0x51:
+            case 0x52:
+            case 0x53:
+            case 0x54:
+            case 0x55:
+            case 0x56:
+            case 0x57:
+            case 0x58: // Binary data (one-byte uint8_t for n follows)
+            case 0x59: // Binary data (two-byte uint16_t for n follow)
+            case 0x5A: // Binary data (four-byte uint32_t for n follow)
+            case 0x5B: // Binary data (eight-byte uint64_t for n follow)
+            case 0x5F: // Binary data (indefinite length)
+            {
+                binary_t b;
+                return get_cbor_binary(b) && sax->binary(b);
+            }
+
+            // UTF-8 string (0x00..0x17 bytes follow)
+            case 0x60:
+            case 0x61:
+            case 0x62:
+            case 0x63:
+            case 0x64:
+            case 0x65:
+            case 0x66:
+            case 0x67:
+            case 0x68:
+            case 0x69:
+            case 0x6A:
+            case 0x6B:
+            case 0x6C:
+            case 0x6D:
+            case 0x6E:
+            case 0x6F:
+            case 0x70:
+            case 0x71:
+            case 0x72:
+            case 0x73:
+            case 0x74:
+            case 0x75:
+            case 0x76:
+            case 0x77:
+            case 0x78: // UTF-8 string (one-byte uint8_t for n follows)
+            case 0x79: // UTF-8 string (two-byte uint16_t for n follow)
+            case 0x7A: // UTF-8 string (four-byte uint32_t for n follow)
+            case 0x7B: // UTF-8 string (eight-byte uint64_t for n follow)
+            case 0x7F: // UTF-8 string (indefinite length)
+            {
+                string_t s;
+                return get_cbor_string(s) && sax->string(s);
+            }
+
+            // array (0x00..0x17 data items follow)
+            case 0x80:
+            case 0x81:
+            case 0x82:
+            case 0x83:
+            case 0x84:
+            case 0x85:
+            case 0x86:
+            case 0x87:
+            case 0x88:
+            case 0x89:
+            case 0x8A:
+            case 0x8B:
+            case 0x8C:
+            case 0x8D:
+            case 0x8E:
+            case 0x8F:
+            case 0x90:
+            case 0x91:
+            case 0x92:
+            case 0x93:
+            case 0x94:
+            case 0x95:
+            case 0x96:
+            case 0x97:
+                return get_cbor_array(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x1Fu), tag_handler);
+
+            case 0x98: // array (one-byte uint8_t for n follows)
+            {
+                std::uint8_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_array(static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0x99: // array (two-byte uint16_t for n follow)
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_array(static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0x9A: // array (four-byte uint32_t for n follow)
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_array(static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0x9B: // array (eight-byte uint64_t for n follow)
+            {
+                std::uint64_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_array(detail::conditional_static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0x9F: // array (indefinite length)
+                return get_cbor_array(static_cast<std::size_t>(-1), tag_handler);
+
+            // map (0x00..0x17 pairs of data items follow)
+            case 0xA0:
+            case 0xA1:
+            case 0xA2:
+            case 0xA3:
+            case 0xA4:
+            case 0xA5:
+            case 0xA6:
+            case 0xA7:
+            case 0xA8:
+            case 0xA9:
+            case 0xAA:
+            case 0xAB:
+            case 0xAC:
+            case 0xAD:
+            case 0xAE:
+            case 0xAF:
+            case 0xB0:
+            case 0xB1:
+            case 0xB2:
+            case 0xB3:
+            case 0xB4:
+            case 0xB5:
+            case 0xB6:
+            case 0xB7:
+                return get_cbor_object(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x1Fu), tag_handler);
+
+            case 0xB8: // map (one-byte uint8_t for n follows)
+            {
+                std::uint8_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_object(static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0xB9: // map (two-byte uint16_t for n follow)
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_object(static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0xBA: // map (four-byte uint32_t for n follow)
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_object(static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0xBB: // map (eight-byte uint64_t for n follow)
+            {
+                std::uint64_t len{};
+                return get_number(input_format_t::cbor, len) && get_cbor_object(detail::conditional_static_cast<std::size_t>(len), tag_handler);
+            }
+
+            case 0xBF: // map (indefinite length)
+                return get_cbor_object(static_cast<std::size_t>(-1), tag_handler);
+
+            case 0xC6: // tagged item
+            case 0xC7:
+            case 0xC8:
+            case 0xC9:
+            case 0xCA:
+            case 0xCB:
+            case 0xCC:
+            case 0xCD:
+            case 0xCE:
+            case 0xCF:
+            case 0xD0:
+            case 0xD1:
+            case 0xD2:
+            case 0xD3:
+            case 0xD4:
+            case 0xD8: // tagged item (1 bytes follow)
+            case 0xD9: // tagged item (2 bytes follow)
+            case 0xDA: // tagged item (4 bytes follow)
+            case 0xDB: // tagged item (8 bytes follow)
+            {
+                switch (tag_handler)
+                {
+                    case cbor_tag_handler_t::error:
+                    {
+                        auto last_token = get_token_string();
+                        return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::cbor, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
+                    }
+
+                    case cbor_tag_handler_t::ignore:
+                    {
+                        // ignore binary subtype
+                        switch (current)
+                        {
+                            case 0xD8:
+                            {
+                                std::uint8_t subtype_to_ignore{};
+                                get_number(input_format_t::cbor, subtype_to_ignore);
+                                break;
+                            }
+                            case 0xD9:
+                            {
+                                std::uint16_t subtype_to_ignore{};
+                                get_number(input_format_t::cbor, subtype_to_ignore);
+                                break;
+                            }
+                            case 0xDA:
+                            {
+                                std::uint32_t subtype_to_ignore{};
+                                get_number(input_format_t::cbor, subtype_to_ignore);
+                                break;
+                            }
+                            case 0xDB:
+                            {
+                                std::uint64_t subtype_to_ignore{};
+                                get_number(input_format_t::cbor, subtype_to_ignore);
+                                break;
+                            }
+                            default:
+                                break;
+                        }
+                        return parse_cbor_internal(true, tag_handler);
+                    }
+
+                    case cbor_tag_handler_t::store:
+                    {
+                        binary_t b;
+                        // use binary subtype and store in binary container
+                        switch (current)
+                        {
+                            case 0xD8:
+                            {
+                                std::uint8_t subtype{};
+                                get_number(input_format_t::cbor, subtype);
+                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
+                                break;
+                            }
+                            case 0xD9:
+                            {
+                                std::uint16_t subtype{};
+                                get_number(input_format_t::cbor, subtype);
+                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
+                                break;
+                            }
+                            case 0xDA:
+                            {
+                                std::uint32_t subtype{};
+                                get_number(input_format_t::cbor, subtype);
+                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
+                                break;
+                            }
+                            case 0xDB:
+                            {
+                                std::uint64_t subtype{};
+                                get_number(input_format_t::cbor, subtype);
+                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
+                                break;
+                            }
+                            default:
+                                return parse_cbor_internal(true, tag_handler);
+                        }
+                        get();
+                        return get_cbor_binary(b) && sax->binary(b);
+                    }
+
+                    default:                 // LCOV_EXCL_LINE
+                        JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+                        return false;        // LCOV_EXCL_LINE
+                }
+            }
+
+            case 0xF4: // false
+                return sax->boolean(false);
+
+            case 0xF5: // true
+                return sax->boolean(true);
+
+            case 0xF6: // null
+                return sax->null();
+
+            case 0xF9: // Half-Precision Float (two-byte IEEE 754)
+            {
+                const auto byte1_raw = get();
+                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "number")))
+                {
+                    return false;
+                }
+                const auto byte2_raw = get();
+                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "number")))
+                {
+                    return false;
+                }
+
+                const auto byte1 = static_cast<unsigned char>(byte1_raw);
+                const auto byte2 = static_cast<unsigned char>(byte2_raw);
+
+                // code from RFC 7049, Appendix D, Figure 3:
+                // As half-precision floating-point numbers were only added
+                // to IEEE 754 in 2008, today's programming platforms often
+                // still only have limited support for them. It is very
+                // easy to include at least decoding support for them even
+                // without such support. An example of a small decoder for
+                // half-precision floating-point numbers in the C language
+                // is shown in Fig. 3.
+                const auto half = static_cast<unsigned int>((byte1 << 8u) + byte2);
+                const double val = [&half]
+                {
+                    const int exp = (half >> 10u) & 0x1Fu;
+                    const unsigned int mant = half & 0x3FFu;
+                    JSON_ASSERT(0 <= exp&& exp <= 32);
+                    JSON_ASSERT(mant <= 1024);
+                    switch (exp)
+                    {
+                        case 0:
+                            return std::ldexp(mant, -24);
+                        case 31:
+                            return (mant == 0)
+                            ? std::numeric_limits<double>::infinity()
+                            : std::numeric_limits<double>::quiet_NaN();
+                        default:
+                            return std::ldexp(mant + 1024, exp - 25);
+                    }
+                }();
+                return sax->number_float((half & 0x8000u) != 0
+                                         ? static_cast<number_float_t>(-val)
+                                         : static_cast<number_float_t>(val), "");
+            }
+
+            case 0xFA: // Single-Precision Float (four-byte IEEE 754)
+            {
+                float number{};
+                return get_number(input_format_t::cbor, number) && sax->number_float(static_cast<number_float_t>(number), "");
+            }
+
+            case 0xFB: // Double-Precision Float (eight-byte IEEE 754)
+            {
+                double number{};
+                return get_number(input_format_t::cbor, number) && sax->number_float(static_cast<number_float_t>(number), "");
+            }
+
+            default: // anything else (0xFF is handled inside the other types)
+            {
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::cbor, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @brief reads a CBOR string
+
+    This function first reads starting bytes to determine the expected
+    string length and then copies this number of bytes into a string.
+    Additionally, CBOR's strings with indefinite lengths are supported.
+
+    @param[out] result  created string
+
+    @return whether string creation completed
+    */
+    bool get_cbor_string(string_t& result)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "string")))
+        {
+            return false;
+        }
+
+        switch (current)
+        {
+            // UTF-8 string (0x00..0x17 bytes follow)
+            case 0x60:
+            case 0x61:
+            case 0x62:
+            case 0x63:
+            case 0x64:
+            case 0x65:
+            case 0x66:
+            case 0x67:
+            case 0x68:
+            case 0x69:
+            case 0x6A:
+            case 0x6B:
+            case 0x6C:
+            case 0x6D:
+            case 0x6E:
+            case 0x6F:
+            case 0x70:
+            case 0x71:
+            case 0x72:
+            case 0x73:
+            case 0x74:
+            case 0x75:
+            case 0x76:
+            case 0x77:
+            {
+                return get_string(input_format_t::cbor, static_cast<unsigned int>(current) & 0x1Fu, result);
+            }
+
+            case 0x78: // UTF-8 string (one-byte uint8_t for n follows)
+            {
+                std::uint8_t len{};
+                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
+            }
+
+            case 0x79: // UTF-8 string (two-byte uint16_t for n follow)
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
+            }
+
+            case 0x7A: // UTF-8 string (four-byte uint32_t for n follow)
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
+            }
+
+            case 0x7B: // UTF-8 string (eight-byte uint64_t for n follow)
+            {
+                std::uint64_t len{};
+                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
+            }
+
+            case 0x7F: // UTF-8 string (indefinite length)
+            {
+                while (get() != 0xFF)
+                {
+                    string_t chunk;
+                    if (!get_cbor_string(chunk))
+                    {
+                        return false;
+                    }
+                    result.append(chunk);
+                }
+                return true;
+            }
+
+            default:
+            {
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::cbor, "expected length specification (0x60-0x7B) or indefinite string type (0x7F); last byte: 0x" + last_token, "string"), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @brief reads a CBOR byte array
+
+    This function first reads starting bytes to determine the expected
+    byte array length and then copies this number of bytes into the byte array.
+    Additionally, CBOR's byte arrays with indefinite lengths are supported.
+
+    @param[out] result  created byte array
+
+    @return whether byte array creation completed
+    */
+    bool get_cbor_binary(binary_t& result)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "binary")))
+        {
+            return false;
+        }
+
+        switch (current)
+        {
+            // Binary data (0x00..0x17 bytes follow)
+            case 0x40:
+            case 0x41:
+            case 0x42:
+            case 0x43:
+            case 0x44:
+            case 0x45:
+            case 0x46:
+            case 0x47:
+            case 0x48:
+            case 0x49:
+            case 0x4A:
+            case 0x4B:
+            case 0x4C:
+            case 0x4D:
+            case 0x4E:
+            case 0x4F:
+            case 0x50:
+            case 0x51:
+            case 0x52:
+            case 0x53:
+            case 0x54:
+            case 0x55:
+            case 0x56:
+            case 0x57:
+            {
+                return get_binary(input_format_t::cbor, static_cast<unsigned int>(current) & 0x1Fu, result);
+            }
+
+            case 0x58: // Binary data (one-byte uint8_t for n follows)
+            {
+                std::uint8_t len{};
+                return get_number(input_format_t::cbor, len) &&
+                       get_binary(input_format_t::cbor, len, result);
+            }
+
+            case 0x59: // Binary data (two-byte uint16_t for n follow)
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::cbor, len) &&
+                       get_binary(input_format_t::cbor, len, result);
+            }
+
+            case 0x5A: // Binary data (four-byte uint32_t for n follow)
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::cbor, len) &&
+                       get_binary(input_format_t::cbor, len, result);
+            }
+
+            case 0x5B: // Binary data (eight-byte uint64_t for n follow)
+            {
+                std::uint64_t len{};
+                return get_number(input_format_t::cbor, len) &&
+                       get_binary(input_format_t::cbor, len, result);
+            }
+
+            case 0x5F: // Binary data (indefinite length)
+            {
+                while (get() != 0xFF)
+                {
+                    binary_t chunk;
+                    if (!get_cbor_binary(chunk))
+                    {
+                        return false;
+                    }
+                    result.insert(result.end(), chunk.begin(), chunk.end());
+                }
+                return true;
+            }
+
+            default:
+            {
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::cbor, "expected length specification (0x40-0x5B) or indefinite binary array type (0x5F); last byte: 0x" + last_token, "binary"), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @param[in] len  the length of the array or static_cast<std::size_t>(-1) for an
+                    array of indefinite size
+    @param[in] tag_handler how CBOR tags should be treated
+    @return whether array creation completed
+    */
+    bool get_cbor_array(const std::size_t len,
+                        const cbor_tag_handler_t tag_handler)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(len)))
+        {
+            return false;
+        }
+
+        if (len != static_cast<std::size_t>(-1))
+        {
+            for (std::size_t i = 0; i < len; ++i)
+            {
+                if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(true, tag_handler)))
+                {
+                    return false;
+                }
+            }
+        }
+        else
+        {
+            while (get() != 0xFF)
+            {
+                if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(false, tag_handler)))
+                {
+                    return false;
+                }
+            }
+        }
+
+        return sax->end_array();
+    }
+
+    /*!
+    @param[in] len  the length of the object or static_cast<std::size_t>(-1) for an
+                    object of indefinite size
+    @param[in] tag_handler how CBOR tags should be treated
+    @return whether object creation completed
+    */
+    bool get_cbor_object(const std::size_t len,
+                         const cbor_tag_handler_t tag_handler)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(len)))
+        {
+            return false;
+        }
+
+        if (len != 0)
+        {
+            string_t key;
+            if (len != static_cast<std::size_t>(-1))
+            {
+                for (std::size_t i = 0; i < len; ++i)
+                {
+                    get();
+                    if (JSON_HEDLEY_UNLIKELY(!get_cbor_string(key) || !sax->key(key)))
+                    {
+                        return false;
+                    }
+
+                    if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(true, tag_handler)))
+                    {
+                        return false;
+                    }
+                    key.clear();
+                }
+            }
+            else
+            {
+                while (get() != 0xFF)
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!get_cbor_string(key) || !sax->key(key)))
+                    {
+                        return false;
+                    }
+
+                    if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(true, tag_handler)))
+                    {
+                        return false;
+                    }
+                    key.clear();
+                }
+            }
+        }
+
+        return sax->end_object();
+    }
+
+    /////////////
+    // MsgPack //
+    /////////////
+
+    /*!
+    @return whether a valid MessagePack value was passed to the SAX parser
+    */
+    bool parse_msgpack_internal()
+    {
+        switch (get())
+        {
+            // EOF
+            case std::char_traits<char_type>::eof():
+                return unexpect_eof(input_format_t::msgpack, "value");
+
+            // positive fixint
+            case 0x00:
+            case 0x01:
+            case 0x02:
+            case 0x03:
+            case 0x04:
+            case 0x05:
+            case 0x06:
+            case 0x07:
+            case 0x08:
+            case 0x09:
+            case 0x0A:
+            case 0x0B:
+            case 0x0C:
+            case 0x0D:
+            case 0x0E:
+            case 0x0F:
+            case 0x10:
+            case 0x11:
+            case 0x12:
+            case 0x13:
+            case 0x14:
+            case 0x15:
+            case 0x16:
+            case 0x17:
+            case 0x18:
+            case 0x19:
+            case 0x1A:
+            case 0x1B:
+            case 0x1C:
+            case 0x1D:
+            case 0x1E:
+            case 0x1F:
+            case 0x20:
+            case 0x21:
+            case 0x22:
+            case 0x23:
+            case 0x24:
+            case 0x25:
+            case 0x26:
+            case 0x27:
+            case 0x28:
+            case 0x29:
+            case 0x2A:
+            case 0x2B:
+            case 0x2C:
+            case 0x2D:
+            case 0x2E:
+            case 0x2F:
+            case 0x30:
+            case 0x31:
+            case 0x32:
+            case 0x33:
+            case 0x34:
+            case 0x35:
+            case 0x36:
+            case 0x37:
+            case 0x38:
+            case 0x39:
+            case 0x3A:
+            case 0x3B:
+            case 0x3C:
+            case 0x3D:
+            case 0x3E:
+            case 0x3F:
+            case 0x40:
+            case 0x41:
+            case 0x42:
+            case 0x43:
+            case 0x44:
+            case 0x45:
+            case 0x46:
+            case 0x47:
+            case 0x48:
+            case 0x49:
+            case 0x4A:
+            case 0x4B:
+            case 0x4C:
+            case 0x4D:
+            case 0x4E:
+            case 0x4F:
+            case 0x50:
+            case 0x51:
+            case 0x52:
+            case 0x53:
+            case 0x54:
+            case 0x55:
+            case 0x56:
+            case 0x57:
+            case 0x58:
+            case 0x59:
+            case 0x5A:
+            case 0x5B:
+            case 0x5C:
+            case 0x5D:
+            case 0x5E:
+            case 0x5F:
+            case 0x60:
+            case 0x61:
+            case 0x62:
+            case 0x63:
+            case 0x64:
+            case 0x65:
+            case 0x66:
+            case 0x67:
+            case 0x68:
+            case 0x69:
+            case 0x6A:
+            case 0x6B:
+            case 0x6C:
+            case 0x6D:
+            case 0x6E:
+            case 0x6F:
+            case 0x70:
+            case 0x71:
+            case 0x72:
+            case 0x73:
+            case 0x74:
+            case 0x75:
+            case 0x76:
+            case 0x77:
+            case 0x78:
+            case 0x79:
+            case 0x7A:
+            case 0x7B:
+            case 0x7C:
+            case 0x7D:
+            case 0x7E:
+            case 0x7F:
+                return sax->number_unsigned(static_cast<number_unsigned_t>(current));
+
+            // fixmap
+            case 0x80:
+            case 0x81:
+            case 0x82:
+            case 0x83:
+            case 0x84:
+            case 0x85:
+            case 0x86:
+            case 0x87:
+            case 0x88:
+            case 0x89:
+            case 0x8A:
+            case 0x8B:
+            case 0x8C:
+            case 0x8D:
+            case 0x8E:
+            case 0x8F:
+                return get_msgpack_object(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x0Fu));
+
+            // fixarray
+            case 0x90:
+            case 0x91:
+            case 0x92:
+            case 0x93:
+            case 0x94:
+            case 0x95:
+            case 0x96:
+            case 0x97:
+            case 0x98:
+            case 0x99:
+            case 0x9A:
+            case 0x9B:
+            case 0x9C:
+            case 0x9D:
+            case 0x9E:
+            case 0x9F:
+                return get_msgpack_array(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x0Fu));
+
+            // fixstr
+            case 0xA0:
+            case 0xA1:
+            case 0xA2:
+            case 0xA3:
+            case 0xA4:
+            case 0xA5:
+            case 0xA6:
+            case 0xA7:
+            case 0xA8:
+            case 0xA9:
+            case 0xAA:
+            case 0xAB:
+            case 0xAC:
+            case 0xAD:
+            case 0xAE:
+            case 0xAF:
+            case 0xB0:
+            case 0xB1:
+            case 0xB2:
+            case 0xB3:
+            case 0xB4:
+            case 0xB5:
+            case 0xB6:
+            case 0xB7:
+            case 0xB8:
+            case 0xB9:
+            case 0xBA:
+            case 0xBB:
+            case 0xBC:
+            case 0xBD:
+            case 0xBE:
+            case 0xBF:
+            case 0xD9: // str 8
+            case 0xDA: // str 16
+            case 0xDB: // str 32
+            {
+                string_t s;
+                return get_msgpack_string(s) && sax->string(s);
+            }
+
+            case 0xC0: // nil
+                return sax->null();
+
+            case 0xC2: // false
+                return sax->boolean(false);
+
+            case 0xC3: // true
+                return sax->boolean(true);
+
+            case 0xC4: // bin 8
+            case 0xC5: // bin 16
+            case 0xC6: // bin 32
+            case 0xC7: // ext 8
+            case 0xC8: // ext 16
+            case 0xC9: // ext 32
+            case 0xD4: // fixext 1
+            case 0xD5: // fixext 2
+            case 0xD6: // fixext 4
+            case 0xD7: // fixext 8
+            case 0xD8: // fixext 16
+            {
+                binary_t b;
+                return get_msgpack_binary(b) && sax->binary(b);
+            }
+
+            case 0xCA: // float 32
+            {
+                float number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_float(static_cast<number_float_t>(number), "");
+            }
+
+            case 0xCB: // float 64
+            {
+                double number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_float(static_cast<number_float_t>(number), "");
+            }
+
+            case 0xCC: // uint 8
+            {
+                std::uint8_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
+            }
+
+            case 0xCD: // uint 16
+            {
+                std::uint16_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
+            }
+
+            case 0xCE: // uint 32
+            {
+                std::uint32_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
+            }
+
+            case 0xCF: // uint 64
+            {
+                std::uint64_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
+            }
+
+            case 0xD0: // int 8
+            {
+                std::int8_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
+            }
+
+            case 0xD1: // int 16
+            {
+                std::int16_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
+            }
+
+            case 0xD2: // int 32
+            {
+                std::int32_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
+            }
+
+            case 0xD3: // int 64
+            {
+                std::int64_t number{};
+                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
+            }
+
+            case 0xDC: // array 16
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::msgpack, len) && get_msgpack_array(static_cast<std::size_t>(len));
+            }
+
+            case 0xDD: // array 32
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::msgpack, len) && get_msgpack_array(static_cast<std::size_t>(len));
+            }
+
+            case 0xDE: // map 16
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::msgpack, len) && get_msgpack_object(static_cast<std::size_t>(len));
+            }
+
+            case 0xDF: // map 32
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::msgpack, len) && get_msgpack_object(static_cast<std::size_t>(len));
+            }
+
+            // negative fixint
+            case 0xE0:
+            case 0xE1:
+            case 0xE2:
+            case 0xE3:
+            case 0xE4:
+            case 0xE5:
+            case 0xE6:
+            case 0xE7:
+            case 0xE8:
+            case 0xE9:
+            case 0xEA:
+            case 0xEB:
+            case 0xEC:
+            case 0xED:
+            case 0xEE:
+            case 0xEF:
+            case 0xF0:
+            case 0xF1:
+            case 0xF2:
+            case 0xF3:
+            case 0xF4:
+            case 0xF5:
+            case 0xF6:
+            case 0xF7:
+            case 0xF8:
+            case 0xF9:
+            case 0xFA:
+            case 0xFB:
+            case 0xFC:
+            case 0xFD:
+            case 0xFE:
+            case 0xFF:
+                return sax->number_integer(static_cast<std::int8_t>(current));
+
+            default: // anything else
+            {
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::msgpack, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @brief reads a MessagePack string
+
+    This function first reads starting bytes to determine the expected
+    string length and then copies this number of bytes into a string.
+
+    @param[out] result  created string
+
+    @return whether string creation completed
+    */
+    bool get_msgpack_string(string_t& result)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::msgpack, "string")))
+        {
+            return false;
+        }
+
+        switch (current)
+        {
+            // fixstr
+            case 0xA0:
+            case 0xA1:
+            case 0xA2:
+            case 0xA3:
+            case 0xA4:
+            case 0xA5:
+            case 0xA6:
+            case 0xA7:
+            case 0xA8:
+            case 0xA9:
+            case 0xAA:
+            case 0xAB:
+            case 0xAC:
+            case 0xAD:
+            case 0xAE:
+            case 0xAF:
+            case 0xB0:
+            case 0xB1:
+            case 0xB2:
+            case 0xB3:
+            case 0xB4:
+            case 0xB5:
+            case 0xB6:
+            case 0xB7:
+            case 0xB8:
+            case 0xB9:
+            case 0xBA:
+            case 0xBB:
+            case 0xBC:
+            case 0xBD:
+            case 0xBE:
+            case 0xBF:
+            {
+                return get_string(input_format_t::msgpack, static_cast<unsigned int>(current) & 0x1Fu, result);
+            }
+
+            case 0xD9: // str 8
+            {
+                std::uint8_t len{};
+                return get_number(input_format_t::msgpack, len) && get_string(input_format_t::msgpack, len, result);
+            }
+
+            case 0xDA: // str 16
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::msgpack, len) && get_string(input_format_t::msgpack, len, result);
+            }
+
+            case 0xDB: // str 32
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::msgpack, len) && get_string(input_format_t::msgpack, len, result);
+            }
+
+            default:
+            {
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::msgpack, "expected length specification (0xA0-0xBF, 0xD9-0xDB); last byte: 0x" + last_token, "string"), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @brief reads a MessagePack byte array
+
+    This function first reads starting bytes to determine the expected
+    byte array length and then copies this number of bytes into a byte array.
+
+    @param[out] result  created byte array
+
+    @return whether byte array creation completed
+    */
+    bool get_msgpack_binary(binary_t& result)
+    {
+        // helper function to set the subtype
+        auto assign_and_return_true = [&result](std::int8_t subtype)
+        {
+            result.set_subtype(static_cast<std::uint8_t>(subtype));
+            return true;
+        };
+
+        switch (current)
+        {
+            case 0xC4: // bin 8
+            {
+                std::uint8_t len{};
+                return get_number(input_format_t::msgpack, len) &&
+                       get_binary(input_format_t::msgpack, len, result);
+            }
+
+            case 0xC5: // bin 16
+            {
+                std::uint16_t len{};
+                return get_number(input_format_t::msgpack, len) &&
+                       get_binary(input_format_t::msgpack, len, result);
+            }
+
+            case 0xC6: // bin 32
+            {
+                std::uint32_t len{};
+                return get_number(input_format_t::msgpack, len) &&
+                       get_binary(input_format_t::msgpack, len, result);
+            }
+
+            case 0xC7: // ext 8
+            {
+                std::uint8_t len{};
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, len) &&
+                       get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, len, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            case 0xC8: // ext 16
+            {
+                std::uint16_t len{};
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, len) &&
+                       get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, len, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            case 0xC9: // ext 32
+            {
+                std::uint32_t len{};
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, len) &&
+                       get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, len, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            case 0xD4: // fixext 1
+            {
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, 1, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            case 0xD5: // fixext 2
+            {
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, 2, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            case 0xD6: // fixext 4
+            {
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, 4, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            case 0xD7: // fixext 8
+            {
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, 8, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            case 0xD8: // fixext 16
+            {
+                std::int8_t subtype{};
+                return get_number(input_format_t::msgpack, subtype) &&
+                       get_binary(input_format_t::msgpack, 16, result) &&
+                       assign_and_return_true(subtype);
+            }
+
+            default:           // LCOV_EXCL_LINE
+                return false;  // LCOV_EXCL_LINE
+        }
+    }
+
+    /*!
+    @param[in] len  the length of the array
+    @return whether array creation completed
+    */
+    bool get_msgpack_array(const std::size_t len)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(len)))
+        {
+            return false;
+        }
+
+        for (std::size_t i = 0; i < len; ++i)
+        {
+            if (JSON_HEDLEY_UNLIKELY(!parse_msgpack_internal()))
+            {
+                return false;
+            }
+        }
+
+        return sax->end_array();
+    }
+
+    /*!
+    @param[in] len  the length of the object
+    @return whether object creation completed
+    */
+    bool get_msgpack_object(const std::size_t len)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(len)))
+        {
+            return false;
+        }
+
+        string_t key;
+        for (std::size_t i = 0; i < len; ++i)
+        {
+            get();
+            if (JSON_HEDLEY_UNLIKELY(!get_msgpack_string(key) || !sax->key(key)))
+            {
+                return false;
+            }
+
+            if (JSON_HEDLEY_UNLIKELY(!parse_msgpack_internal()))
+            {
+                return false;
+            }
+            key.clear();
+        }
+
+        return sax->end_object();
+    }
+
+    ////////////
+    // UBJSON //
+    ////////////
+
+    /*!
+    @param[in] get_char  whether a new character should be retrieved from the
+                         input (true, default) or whether the last read
+                         character should be considered instead
+
+    @return whether a valid UBJSON value was passed to the SAX parser
+    */
+    bool parse_ubjson_internal(const bool get_char = true)
+    {
+        return get_ubjson_value(get_char ? get_ignore_noop() : current);
+    }
+
+    /*!
+    @brief reads a UBJSON string
+
+    This function is either called after reading the 'S' byte explicitly
+    indicating a string, or in case of an object key where the 'S' byte can be
+    left out.
+
+    @param[out] result   created string
+    @param[in] get_char  whether a new character should be retrieved from the
+                         input (true, default) or whether the last read
+                         character should be considered instead
+
+    @return whether string creation completed
+    */
+    bool get_ubjson_string(string_t& result, const bool get_char = true)
+    {
+        if (get_char)
+        {
+            get();  // TODO(niels): may we ignore N here?
+        }
+
+        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "value")))
+        {
+            return false;
+        }
+
+        switch (current)
+        {
+            case 'U':
+            {
+                std::uint8_t len{};
+                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
+            }
+
+            case 'i':
+            {
+                std::int8_t len{};
+                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
+            }
+
+            case 'I':
+            {
+                std::int16_t len{};
+                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
+            }
+
+            case 'l':
+            {
+                std::int32_t len{};
+                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
+            }
+
+            case 'L':
+            {
+                std::int64_t len{};
+                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
+            }
+
+            default:
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::ubjson, "expected length type specification (U, i, I, l, L); last byte: 0x" + last_token, "string"), BasicJsonType()));
+        }
+    }
+
+    /*!
+    @param[out] result  determined size
+    @return whether size determination completed
+    */
+    bool get_ubjson_size_value(std::size_t& result)
+    {
+        switch (get_ignore_noop())
+        {
+            case 'U':
+            {
+                std::uint8_t number{};
+                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
+                {
+                    return false;
+                }
+                result = static_cast<std::size_t>(number);
+                return true;
+            }
+
+            case 'i':
+            {
+                std::int8_t number{};
+                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
+                {
+                    return false;
+                }
+                result = static_cast<std::size_t>(number); // NOLINT(bugprone-signed-char-misuse,cert-str34-c): number is not a char
+                return true;
+            }
+
+            case 'I':
+            {
+                std::int16_t number{};
+                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
+                {
+                    return false;
+                }
+                result = static_cast<std::size_t>(number);
+                return true;
+            }
+
+            case 'l':
+            {
+                std::int32_t number{};
+                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
+                {
+                    return false;
+                }
+                result = static_cast<std::size_t>(number);
+                return true;
+            }
+
+            case 'L':
+            {
+                std::int64_t number{};
+                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
+                {
+                    return false;
+                }
+                result = static_cast<std::size_t>(number);
+                return true;
+            }
+
+            default:
+            {
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::ubjson, "expected length type specification (U, i, I, l, L) after '#'; last byte: 0x" + last_token, "size"), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @brief determine the type and size for a container
+
+    In the optimized UBJSON format, a type and a size can be provided to allow
+    for a more compact representation.
+
+    @param[out] result  pair of the size and the type
+
+    @return whether pair creation completed
+    */
+    bool get_ubjson_size_type(std::pair<std::size_t, char_int_type>& result)
+    {
+        result.first = string_t::npos; // size
+        result.second = 0; // type
+
+        get_ignore_noop();
+
+        if (current == '$')
+        {
+            result.second = get();  // must not ignore 'N', because 'N' maybe the type
+            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "type")))
+            {
+                return false;
+            }
+
+            get_ignore_noop();
+            if (JSON_HEDLEY_UNLIKELY(current != '#'))
+            {
+                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "value")))
+                {
+                    return false;
+                }
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::ubjson, "expected '#' after type information; last byte: 0x" + last_token, "size"), BasicJsonType()));
+            }
+
+            return get_ubjson_size_value(result.first);
+        }
+
+        if (current == '#')
+        {
+            return get_ubjson_size_value(result.first);
+        }
+
+        return true;
+    }
+
+    /*!
+    @param prefix  the previously read or set type prefix
+    @return whether value creation completed
+    */
+    bool get_ubjson_value(const char_int_type prefix)
+    {
+        switch (prefix)
+        {
+            case std::char_traits<char_type>::eof():  // EOF
+                return unexpect_eof(input_format_t::ubjson, "value");
+
+            case 'T':  // true
+                return sax->boolean(true);
+            case 'F':  // false
+                return sax->boolean(false);
+
+            case 'Z':  // null
+                return sax->null();
+
+            case 'U':
+            {
+                std::uint8_t number{};
+                return get_number(input_format_t::ubjson, number) && sax->number_unsigned(number);
+            }
+
+            case 'i':
+            {
+                std::int8_t number{};
+                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
+            }
+
+            case 'I':
+            {
+                std::int16_t number{};
+                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
+            }
+
+            case 'l':
+            {
+                std::int32_t number{};
+                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
+            }
+
+            case 'L':
+            {
+                std::int64_t number{};
+                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
+            }
+
+            case 'd':
+            {
+                float number{};
+                return get_number(input_format_t::ubjson, number) && sax->number_float(static_cast<number_float_t>(number), "");
+            }
+
+            case 'D':
+            {
+                double number{};
+                return get_number(input_format_t::ubjson, number) && sax->number_float(static_cast<number_float_t>(number), "");
+            }
+
+            case 'H':
+            {
+                return get_ubjson_high_precision_number();
+            }
+
+            case 'C':  // char
+            {
+                get();
+                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "char")))
+                {
+                    return false;
+                }
+                if (JSON_HEDLEY_UNLIKELY(current > 127))
+                {
+                    auto last_token = get_token_string();
+                    return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::ubjson, "byte after 'C' must be in range 0x00..0x7F; last byte: 0x" + last_token, "char"), BasicJsonType()));
+                }
+                string_t s(1, static_cast<typename string_t::value_type>(current));
+                return sax->string(s);
+            }
+
+            case 'S':  // string
+            {
+                string_t s;
+                return get_ubjson_string(s) && sax->string(s);
+            }
+
+            case '[':  // array
+                return get_ubjson_array();
+
+            case '{':  // object
+                return get_ubjson_object();
+
+            default: // anything else
+            {
+                auto last_token = get_token_string();
+                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::ubjson, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
+            }
+        }
+    }
+
+    /*!
+    @return whether array creation completed
+    */
+    bool get_ubjson_array()
+    {
+        std::pair<std::size_t, char_int_type> size_and_type;
+        if (JSON_HEDLEY_UNLIKELY(!get_ubjson_size_type(size_and_type)))
+        {
+            return false;
+        }
+
+        if (size_and_type.first != string_t::npos)
+        {
+            if (JSON_HEDLEY_UNLIKELY(!sax->start_array(size_and_type.first)))
+            {
+                return false;
+            }
+
+            if (size_and_type.second != 0)
+            {
+                if (size_and_type.second != 'N')
+                {
+                    for (std::size_t i = 0; i < size_and_type.first; ++i)
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!get_ubjson_value(size_and_type.second)))
+                        {
+                            return false;
+                        }
+                    }
+                }
+            }
+            else
+            {
+                for (std::size_t i = 0; i < size_and_type.first; ++i)
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal()))
+                    {
+                        return false;
+                    }
+                }
+            }
+        }
+        else
+        {
+            if (JSON_HEDLEY_UNLIKELY(!sax->start_array(static_cast<std::size_t>(-1))))
+            {
+                return false;
+            }
+
+            while (current != ']')
+            {
+                if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal(false)))
+                {
+                    return false;
+                }
+                get_ignore_noop();
+            }
+        }
+
+        return sax->end_array();
+    }
+
+    /*!
+    @return whether object creation completed
+    */
+    bool get_ubjson_object()
+    {
+        std::pair<std::size_t, char_int_type> size_and_type;
+        if (JSON_HEDLEY_UNLIKELY(!get_ubjson_size_type(size_and_type)))
+        {
+            return false;
+        }
+
+        string_t key;
+        if (size_and_type.first != string_t::npos)
+        {
+            if (JSON_HEDLEY_UNLIKELY(!sax->start_object(size_and_type.first)))
+            {
+                return false;
+            }
+
+            if (size_and_type.second != 0)
+            {
+                for (std::size_t i = 0; i < size_and_type.first; ++i)
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!get_ubjson_string(key) || !sax->key(key)))
+                    {
+                        return false;
+                    }
+                    if (JSON_HEDLEY_UNLIKELY(!get_ubjson_value(size_and_type.second)))
+                    {
+                        return false;
+                    }
+                    key.clear();
+                }
+            }
+            else
+            {
+                for (std::size_t i = 0; i < size_and_type.first; ++i)
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!get_ubjson_string(key) || !sax->key(key)))
+                    {
+                        return false;
+                    }
+                    if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal()))
+                    {
+                        return false;
+                    }
+                    key.clear();
+                }
+            }
+        }
+        else
+        {
+            if (JSON_HEDLEY_UNLIKELY(!sax->start_object(static_cast<std::size_t>(-1))))
+            {
+                return false;
+            }
+
+            while (current != '}')
+            {
+                if (JSON_HEDLEY_UNLIKELY(!get_ubjson_string(key, false) || !sax->key(key)))
+                {
+                    return false;
+                }
+                if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal()))
+                {
+                    return false;
+                }
+                get_ignore_noop();
+                key.clear();
+            }
+        }
+
+        return sax->end_object();
+    }
+
+    // Note, no reader for UBJSON binary types is implemented because they do
+    // not exist
+
+    bool get_ubjson_high_precision_number()
+    {
+        // get size of following number string
+        std::size_t size{};
+        auto res = get_ubjson_size_value(size);
+        if (JSON_HEDLEY_UNLIKELY(!res))
+        {
+            return res;
+        }
+
+        // get number string
+        std::vector<char> number_vector;
+        for (std::size_t i = 0; i < size; ++i)
+        {
+            get();
+            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "number")))
+            {
+                return false;
+            }
+            number_vector.push_back(static_cast<char>(current));
+        }
+
+        // parse number string
+        using ia_type = decltype(detail::input_adapter(number_vector));
+        auto number_lexer = detail::lexer<BasicJsonType, ia_type>(detail::input_adapter(number_vector), false);
+        const auto result_number = number_lexer.scan();
+        const auto number_string = number_lexer.get_token_string();
+        const auto result_remainder = number_lexer.scan();
+
+        using token_type = typename detail::lexer_base<BasicJsonType>::token_type;
+
+        if (JSON_HEDLEY_UNLIKELY(result_remainder != token_type::end_of_input))
+        {
+            return sax->parse_error(chars_read, number_string, parse_error::create(115, chars_read, exception_message(input_format_t::ubjson, "invalid number text: " + number_lexer.get_token_string(), "high-precision number"), BasicJsonType()));
+        }
+
+        switch (result_number)
+        {
+            case token_type::value_integer:
+                return sax->number_integer(number_lexer.get_number_integer());
+            case token_type::value_unsigned:
+                return sax->number_unsigned(number_lexer.get_number_unsigned());
+            case token_type::value_float:
+                return sax->number_float(number_lexer.get_number_float(), std::move(number_string));
+            case token_type::uninitialized:
+            case token_type::literal_true:
+            case token_type::literal_false:
+            case token_type::literal_null:
+            case token_type::value_string:
+            case token_type::begin_array:
+            case token_type::begin_object:
+            case token_type::end_array:
+            case token_type::end_object:
+            case token_type::name_separator:
+            case token_type::value_separator:
+            case token_type::parse_error:
+            case token_type::end_of_input:
+            case token_type::literal_or_value:
+            default:
+                return sax->parse_error(chars_read, number_string, parse_error::create(115, chars_read, exception_message(input_format_t::ubjson, "invalid number text: " + number_lexer.get_token_string(), "high-precision number"), BasicJsonType()));
+        }
+    }
+
+    ///////////////////////
+    // Utility functions //
+    ///////////////////////
+
+    /*!
+    @brief get next character from the input
+
+    This function provides the interface to the used input adapter. It does
+    not throw in case the input reached EOF, but returns a -'ve valued
+    `std::char_traits<char_type>::eof()` in that case.
+
+    @return character read from the input
+    */
+    char_int_type get()
+    {
+        ++chars_read;
+        return current = ia.get_character();
+    }
+
+    /*!
+    @return character read from the input after ignoring all 'N' entries
+    */
+    char_int_type get_ignore_noop()
+    {
+        do
+        {
+            get();
+        }
+        while (current == 'N');
+
+        return current;
+    }
+
+    /*
+    @brief read a number from the input
+
+    @tparam NumberType the type of the number
+    @param[in] format   the current format (for diagnostics)
+    @param[out] result  number of type @a NumberType
+
+    @return whether conversion completed
+
+    @note This function needs to respect the system's endianness, because
+          bytes in CBOR, MessagePack, and UBJSON are stored in network order
+          (big endian) and therefore need reordering on little endian systems.
+    */
+    template<typename NumberType, bool InputIsLittleEndian = false>
+    bool get_number(const input_format_t format, NumberType& result)
+    {
+        // step 1: read input into array with system's byte order
+        std::array<std::uint8_t, sizeof(NumberType)> vec{};
+        for (std::size_t i = 0; i < sizeof(NumberType); ++i)
+        {
+            get();
+            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(format, "number")))
+            {
+                return false;
+            }
+
+            // reverse byte order prior to conversion if necessary
+            if (is_little_endian != InputIsLittleEndian)
+            {
+                vec[sizeof(NumberType) - i - 1] = static_cast<std::uint8_t>(current);
+            }
+            else
+            {
+                vec[i] = static_cast<std::uint8_t>(current); // LCOV_EXCL_LINE
+            }
+        }
+
+        // step 2: convert array into number of type T and return
+        std::memcpy(&result, vec.data(), sizeof(NumberType));
+        return true;
+    }
+
+    /*!
+    @brief create a string by reading characters from the input
+
+    @tparam NumberType the type of the number
+    @param[in] format the current format (for diagnostics)
+    @param[in] len number of characters to read
+    @param[out] result string created by reading @a len bytes
+
+    @return whether string creation completed
+
+    @note We can not reserve @a len bytes for the result, because @a len
+          may be too large. Usually, @ref unexpect_eof() detects the end of
+          the input before we run out of string memory.
+    */
+    template<typename NumberType>
+    bool get_string(const input_format_t format,
+                    const NumberType len,
+                    string_t& result)
+    {
+        bool success = true;
+        for (NumberType i = 0; i < len; i++)
+        {
+            get();
+            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(format, "string")))
+            {
+                success = false;
+                break;
+            }
+            result.push_back(static_cast<typename string_t::value_type>(current));
+        }
+        return success;
+    }
+
+    /*!
+    @brief create a byte array by reading bytes from the input
+
+    @tparam NumberType the type of the number
+    @param[in] format the current format (for diagnostics)
+    @param[in] len number of bytes to read
+    @param[out] result byte array created by reading @a len bytes
+
+    @return whether byte array creation completed
+
+    @note We can not reserve @a len bytes for the result, because @a len
+          may be too large. Usually, @ref unexpect_eof() detects the end of
+          the input before we run out of memory.
+    */
+    template<typename NumberType>
+    bool get_binary(const input_format_t format,
+                    const NumberType len,
+                    binary_t& result)
+    {
+        bool success = true;
+        for (NumberType i = 0; i < len; i++)
+        {
+            get();
+            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(format, "binary")))
+            {
+                success = false;
+                break;
+            }
+            result.push_back(static_cast<std::uint8_t>(current));
+        }
+        return success;
+    }
+
+    /*!
+    @param[in] format   the current format (for diagnostics)
+    @param[in] context  further context information (for diagnostics)
+    @return whether the last read character is not EOF
+    */
+    JSON_HEDLEY_NON_NULL(3)
+    bool unexpect_eof(const input_format_t format, const char* context) const
+    {
+        if (JSON_HEDLEY_UNLIKELY(current == std::char_traits<char_type>::eof()))
+        {
+            return sax->parse_error(chars_read, "<end of file>",
+                                    parse_error::create(110, chars_read, exception_message(format, "unexpected end of input", context), BasicJsonType()));
+        }
+        return true;
+    }
+
+    /*!
+    @return a string representation of the last read byte
+    */
+    std::string get_token_string() const
+    {
+        std::array<char, 3> cr{{}};
+        static_cast<void>((std::snprintf)(cr.data(), cr.size(), "%.2hhX", static_cast<unsigned char>(current))); // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+        return std::string{cr.data()};
+    }
+
+    /*!
+    @param[in] format   the current format
+    @param[in] detail   a detailed error message
+    @param[in] context  further context information
+    @return a message string to use in the parse_error exceptions
+    */
+    std::string exception_message(const input_format_t format,
+                                  const std::string& detail,
+                                  const std::string& context) const
+    {
+        std::string error_msg = "syntax error while parsing ";
+
+        switch (format)
+        {
+            case input_format_t::cbor:
+                error_msg += "CBOR";
+                break;
+
+            case input_format_t::msgpack:
+                error_msg += "MessagePack";
+                break;
+
+            case input_format_t::ubjson:
+                error_msg += "UBJSON";
+                break;
+
+            case input_format_t::bson:
+                error_msg += "BSON";
+                break;
+
+            case input_format_t::json: // LCOV_EXCL_LINE
+            default:            // LCOV_EXCL_LINE
+                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+        }
+
+        return error_msg + " " + context + ": " + detail;
+    }
+
+  private:
+    /// input adapter
+    InputAdapterType ia;
+
+    /// the current character
+    char_int_type current = std::char_traits<char_type>::eof();
+
+    /// the number of characters read
+    std::size_t chars_read = 0;
+
+    /// whether we can assume little endianness
+    const bool is_little_endian = little_endianness();
+
+    /// the SAX parser
+    json_sax_t* sax = nullptr;
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/input/input_adapters.hpp>
+
+// #include <nlohmann/detail/input/lexer.hpp>
+
+// #include <nlohmann/detail/input/parser.hpp>
+
+
+#include <cmath> // isfinite
+#include <cstdint> // uint8_t
+#include <functional> // function
+#include <string> // string
+#include <utility> // move
+#include <vector> // vector
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+// #include <nlohmann/detail/input/input_adapters.hpp>
+
+// #include <nlohmann/detail/input/json_sax.hpp>
+
+// #include <nlohmann/detail/input/lexer.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/meta/is_sax.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+////////////
+// parser //
+////////////
+
+enum class parse_event_t : std::uint8_t
+{
+    /// the parser read `{` and started to process a JSON object
+    object_start,
+    /// the parser read `}` and finished processing a JSON object
+    object_end,
+    /// the parser read `[` and started to process a JSON array
+    array_start,
+    /// the parser read `]` and finished processing a JSON array
+    array_end,
+    /// the parser read a key of a value in an object
+    key,
+    /// the parser finished reading a JSON value
+    value
+};
+
+template<typename BasicJsonType>
+using parser_callback_t =
+    std::function<bool(int /*depth*/, parse_event_t /*event*/, BasicJsonType& /*parsed*/)>;
+
+/*!
+@brief syntax analysis
+
+This class implements a recursive descent parser.
+*/
+template<typename BasicJsonType, typename InputAdapterType>
+class parser
+{
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using string_t = typename BasicJsonType::string_t;
+    using lexer_t = lexer<BasicJsonType, InputAdapterType>;
+    using token_type = typename lexer_t::token_type;
+
+  public:
+    /// a parser reading from an input adapter
+    explicit parser(InputAdapterType&& adapter,
+                    const parser_callback_t<BasicJsonType> cb = nullptr,
+                    const bool allow_exceptions_ = true,
+                    const bool skip_comments = false)
+        : callback(cb)
+        , m_lexer(std::move(adapter), skip_comments)
+        , allow_exceptions(allow_exceptions_)
+    {
+        // read first token
+        get_token();
+    }
+
+    /*!
+    @brief public parser interface
+
+    @param[in] strict      whether to expect the last token to be EOF
+    @param[in,out] result  parsed JSON value
+
+    @throw parse_error.101 in case of an unexpected token
+    @throw parse_error.102 if to_unicode fails or surrogate error
+    @throw parse_error.103 if to_unicode fails
+    */
+    void parse(const bool strict, BasicJsonType& result)
+    {
+        if (callback)
+        {
+            json_sax_dom_callback_parser<BasicJsonType> sdp(result, callback, allow_exceptions);
+            sax_parse_internal(&sdp);
+
+            // in strict mode, input must be completely read
+            if (strict && (get_token() != token_type::end_of_input))
+            {
+                sdp.parse_error(m_lexer.get_position(),
+                                m_lexer.get_token_string(),
+                                parse_error::create(101, m_lexer.get_position(),
+                                                    exception_message(token_type::end_of_input, "value"), BasicJsonType()));
+            }
+
+            // in case of an error, return discarded value
+            if (sdp.is_errored())
+            {
+                result = value_t::discarded;
+                return;
+            }
+
+            // set top-level value to null if it was discarded by the callback
+            // function
+            if (result.is_discarded())
+            {
+                result = nullptr;
+            }
+        }
+        else
+        {
+            json_sax_dom_parser<BasicJsonType> sdp(result, allow_exceptions);
+            sax_parse_internal(&sdp);
+
+            // in strict mode, input must be completely read
+            if (strict && (get_token() != token_type::end_of_input))
+            {
+                sdp.parse_error(m_lexer.get_position(),
+                                m_lexer.get_token_string(),
+                                parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_of_input, "value"), BasicJsonType()));
+            }
+
+            // in case of an error, return discarded value
+            if (sdp.is_errored())
+            {
+                result = value_t::discarded;
+                return;
+            }
+        }
+
+        result.assert_invariant();
+    }
+
+    /*!
+    @brief public accept interface
+
+    @param[in] strict  whether to expect the last token to be EOF
+    @return whether the input is a proper JSON text
+    */
+    bool accept(const bool strict = true)
+    {
+        json_sax_acceptor<BasicJsonType> sax_acceptor;
+        return sax_parse(&sax_acceptor, strict);
+    }
+
+    template<typename SAX>
+    JSON_HEDLEY_NON_NULL(2)
+    bool sax_parse(SAX* sax, const bool strict = true)
+    {
+        (void)detail::is_sax_static_asserts<SAX, BasicJsonType> {};
+        const bool result = sax_parse_internal(sax);
+
+        // strict mode: next byte must be EOF
+        if (result && strict && (get_token() != token_type::end_of_input))
+        {
+            return sax->parse_error(m_lexer.get_position(),
+                                    m_lexer.get_token_string(),
+                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_of_input, "value"), BasicJsonType()));
+        }
+
+        return result;
+    }
+
+  private:
+    template<typename SAX>
+    JSON_HEDLEY_NON_NULL(2)
+    bool sax_parse_internal(SAX* sax)
+    {
+        // stack to remember the hierarchy of structured values we are parsing
+        // true = array; false = object
+        std::vector<bool> states;
+        // value to avoid a goto (see comment where set to true)
+        bool skip_to_state_evaluation = false;
+
+        while (true)
+        {
+            if (!skip_to_state_evaluation)
+            {
+                // invariant: get_token() was called before each iteration
+                switch (last_token)
+                {
+                    case token_type::begin_object:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(static_cast<std::size_t>(-1))))
+                        {
+                            return false;
+                        }
+
+                        // closing } -> we are done
+                        if (get_token() == token_type::end_object)
+                        {
+                            if (JSON_HEDLEY_UNLIKELY(!sax->end_object()))
+                            {
+                                return false;
+                            }
+                            break;
+                        }
+
+                        // parse key
+                        if (JSON_HEDLEY_UNLIKELY(last_token != token_type::value_string))
+                        {
+                            return sax->parse_error(m_lexer.get_position(),
+                                                    m_lexer.get_token_string(),
+                                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::value_string, "object key"), BasicJsonType()));
+                        }
+                        if (JSON_HEDLEY_UNLIKELY(!sax->key(m_lexer.get_string())))
+                        {
+                            return false;
+                        }
+
+                        // parse separator (:)
+                        if (JSON_HEDLEY_UNLIKELY(get_token() != token_type::name_separator))
+                        {
+                            return sax->parse_error(m_lexer.get_position(),
+                                                    m_lexer.get_token_string(),
+                                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::name_separator, "object separator"), BasicJsonType()));
+                        }
+
+                        // remember we are now inside an object
+                        states.push_back(false);
+
+                        // parse values
+                        get_token();
+                        continue;
+                    }
+
+                    case token_type::begin_array:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(static_cast<std::size_t>(-1))))
+                        {
+                            return false;
+                        }
+
+                        // closing ] -> we are done
+                        if (get_token() == token_type::end_array)
+                        {
+                            if (JSON_HEDLEY_UNLIKELY(!sax->end_array()))
+                            {
+                                return false;
+                            }
+                            break;
+                        }
+
+                        // remember we are now inside an array
+                        states.push_back(true);
+
+                        // parse values (no need to call get_token)
+                        continue;
+                    }
+
+                    case token_type::value_float:
+                    {
+                        const auto res = m_lexer.get_number_float();
+
+                        if (JSON_HEDLEY_UNLIKELY(!std::isfinite(res)))
+                        {
+                            return sax->parse_error(m_lexer.get_position(),
+                                                    m_lexer.get_token_string(),
+                                                    out_of_range::create(406, "number overflow parsing '" + m_lexer.get_token_string() + "'", BasicJsonType()));
+                        }
+
+                        if (JSON_HEDLEY_UNLIKELY(!sax->number_float(res, m_lexer.get_string())))
+                        {
+                            return false;
+                        }
+
+                        break;
+                    }
+
+                    case token_type::literal_false:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->boolean(false)))
+                        {
+                            return false;
+                        }
+                        break;
+                    }
+
+                    case token_type::literal_null:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->null()))
+                        {
+                            return false;
+                        }
+                        break;
+                    }
+
+                    case token_type::literal_true:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->boolean(true)))
+                        {
+                            return false;
+                        }
+                        break;
+                    }
+
+                    case token_type::value_integer:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->number_integer(m_lexer.get_number_integer())))
+                        {
+                            return false;
+                        }
+                        break;
+                    }
+
+                    case token_type::value_string:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->string(m_lexer.get_string())))
+                        {
+                            return false;
+                        }
+                        break;
+                    }
+
+                    case token_type::value_unsigned:
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!sax->number_unsigned(m_lexer.get_number_unsigned())))
+                        {
+                            return false;
+                        }
+                        break;
+                    }
+
+                    case token_type::parse_error:
+                    {
+                        // using "uninitialized" to avoid "expected" message
+                        return sax->parse_error(m_lexer.get_position(),
+                                                m_lexer.get_token_string(),
+                                                parse_error::create(101, m_lexer.get_position(), exception_message(token_type::uninitialized, "value"), BasicJsonType()));
+                    }
+
+                    case token_type::uninitialized:
+                    case token_type::end_array:
+                    case token_type::end_object:
+                    case token_type::name_separator:
+                    case token_type::value_separator:
+                    case token_type::end_of_input:
+                    case token_type::literal_or_value:
+                    default: // the last token was unexpected
+                    {
+                        return sax->parse_error(m_lexer.get_position(),
+                                                m_lexer.get_token_string(),
+                                                parse_error::create(101, m_lexer.get_position(), exception_message(token_type::literal_or_value, "value"), BasicJsonType()));
+                    }
+                }
+            }
+            else
+            {
+                skip_to_state_evaluation = false;
+            }
+
+            // we reached this line after we successfully parsed a value
+            if (states.empty())
+            {
+                // empty stack: we reached the end of the hierarchy: done
+                return true;
+            }
+
+            if (states.back())  // array
+            {
+                // comma -> next value
+                if (get_token() == token_type::value_separator)
+                {
+                    // parse a new value
+                    get_token();
+                    continue;
+                }
+
+                // closing ]
+                if (JSON_HEDLEY_LIKELY(last_token == token_type::end_array))
+                {
+                    if (JSON_HEDLEY_UNLIKELY(!sax->end_array()))
+                    {
+                        return false;
+                    }
+
+                    // We are done with this array. Before we can parse a
+                    // new value, we need to evaluate the new state first.
+                    // By setting skip_to_state_evaluation to false, we
+                    // are effectively jumping to the beginning of this if.
+                    JSON_ASSERT(!states.empty());
+                    states.pop_back();
+                    skip_to_state_evaluation = true;
+                    continue;
+                }
+
+                return sax->parse_error(m_lexer.get_position(),
+                                        m_lexer.get_token_string(),
+                                        parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_array, "array"), BasicJsonType()));
+            }
+
+            // states.back() is false -> object
+
+            // comma -> next value
+            if (get_token() == token_type::value_separator)
+            {
+                // parse key
+                if (JSON_HEDLEY_UNLIKELY(get_token() != token_type::value_string))
+                {
+                    return sax->parse_error(m_lexer.get_position(),
+                                            m_lexer.get_token_string(),
+                                            parse_error::create(101, m_lexer.get_position(), exception_message(token_type::value_string, "object key"), BasicJsonType()));
+                }
+
+                if (JSON_HEDLEY_UNLIKELY(!sax->key(m_lexer.get_string())))
+                {
+                    return false;
+                }
+
+                // parse separator (:)
+                if (JSON_HEDLEY_UNLIKELY(get_token() != token_type::name_separator))
+                {
+                    return sax->parse_error(m_lexer.get_position(),
+                                            m_lexer.get_token_string(),
+                                            parse_error::create(101, m_lexer.get_position(), exception_message(token_type::name_separator, "object separator"), BasicJsonType()));
+                }
+
+                // parse values
+                get_token();
+                continue;
+            }
+
+            // closing }
+            if (JSON_HEDLEY_LIKELY(last_token == token_type::end_object))
+            {
+                if (JSON_HEDLEY_UNLIKELY(!sax->end_object()))
+                {
+                    return false;
+                }
+
+                // We are done with this object. Before we can parse a
+                // new value, we need to evaluate the new state first.
+                // By setting skip_to_state_evaluation to false, we
+                // are effectively jumping to the beginning of this if.
+                JSON_ASSERT(!states.empty());
+                states.pop_back();
+                skip_to_state_evaluation = true;
+                continue;
+            }
+
+            return sax->parse_error(m_lexer.get_position(),
+                                    m_lexer.get_token_string(),
+                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_object, "object"), BasicJsonType()));
+        }
+    }
+
+    /// get next token from lexer
+    token_type get_token()
+    {
+        return last_token = m_lexer.scan();
+    }
+
+    std::string exception_message(const token_type expected, const std::string& context)
+    {
+        std::string error_msg = "syntax error ";
+
+        if (!context.empty())
+        {
+            error_msg += "while parsing " + context + " ";
+        }
+
+        error_msg += "- ";
+
+        if (last_token == token_type::parse_error)
+        {
+            error_msg += std::string(m_lexer.get_error_message()) + "; last read: '" +
+                         m_lexer.get_token_string() + "'";
+        }
+        else
+        {
+            error_msg += "unexpected " + std::string(lexer_t::token_type_name(last_token));
+        }
+
+        if (expected != token_type::uninitialized)
+        {
+            error_msg += "; expected " + std::string(lexer_t::token_type_name(expected));
+        }
+
+        return error_msg;
+    }
+
+  private:
+    /// callback function
+    const parser_callback_t<BasicJsonType> callback = nullptr;
+    /// the type of the last read token
+    token_type last_token = token_type::uninitialized;
+    /// the lexer
+    lexer_t m_lexer;
+    /// whether to throw exceptions in case of errors
+    const bool allow_exceptions = true;
+};
+
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/iterators/internal_iterator.hpp>
+
+
+// #include <nlohmann/detail/iterators/primitive_iterator.hpp>
+
+
+#include <cstddef> // ptrdiff_t
+#include <limits>  // numeric_limits
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+/*
+@brief an iterator for primitive JSON types
+
+This class models an iterator for primitive JSON types (boolean, number,
+string). It's only purpose is to allow the iterator/const_iterator classes
+to "iterate" over primitive values. Internally, the iterator is modeled by
+a `difference_type` variable. Value begin_value (`0`) models the begin,
+end_value (`1`) models past the end.
+*/
+class primitive_iterator_t
+{
+  private:
+    using difference_type = std::ptrdiff_t;
+    static constexpr difference_type begin_value = 0;
+    static constexpr difference_type end_value = begin_value + 1;
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    /// iterator as signed integer type
+    difference_type m_it = (std::numeric_limits<std::ptrdiff_t>::min)();
+
+  public:
+    constexpr difference_type get_value() const noexcept
+    {
+        return m_it;
+    }
+
+    /// set iterator to a defined beginning
+    void set_begin() noexcept
+    {
+        m_it = begin_value;
+    }
+
+    /// set iterator to a defined past the end
+    void set_end() noexcept
+    {
+        m_it = end_value;
+    }
+
+    /// return whether the iterator can be dereferenced
+    constexpr bool is_begin() const noexcept
+    {
+        return m_it == begin_value;
+    }
+
+    /// return whether the iterator is at end
+    constexpr bool is_end() const noexcept
+    {
+        return m_it == end_value;
+    }
+
+    friend constexpr bool operator==(primitive_iterator_t lhs, primitive_iterator_t rhs) noexcept
+    {
+        return lhs.m_it == rhs.m_it;
+    }
+
+    friend constexpr bool operator<(primitive_iterator_t lhs, primitive_iterator_t rhs) noexcept
+    {
+        return lhs.m_it < rhs.m_it;
+    }
+
+    primitive_iterator_t operator+(difference_type n) noexcept
+    {
+        auto result = *this;
+        result += n;
+        return result;
+    }
+
+    friend constexpr difference_type operator-(primitive_iterator_t lhs, primitive_iterator_t rhs) noexcept
+    {
+        return lhs.m_it - rhs.m_it;
+    }
+
+    primitive_iterator_t& operator++() noexcept
+    {
+        ++m_it;
+        return *this;
+    }
+
+    primitive_iterator_t const operator++(int) noexcept // NOLINT(readability-const-return-type)
+    {
+        auto result = *this;
+        ++m_it;
+        return result;
+    }
+
+    primitive_iterator_t& operator--() noexcept
+    {
+        --m_it;
+        return *this;
+    }
+
+    primitive_iterator_t const operator--(int) noexcept // NOLINT(readability-const-return-type)
+    {
+        auto result = *this;
+        --m_it;
+        return result;
+    }
+
+    primitive_iterator_t& operator+=(difference_type n) noexcept
+    {
+        m_it += n;
+        return *this;
+    }
+
+    primitive_iterator_t& operator-=(difference_type n) noexcept
+    {
+        m_it -= n;
+        return *this;
+    }
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+
+namespace nlohmann
+{
+namespace detail
+{
+/*!
+@brief an iterator value
+
+@note This structure could easily be a union, but MSVC currently does not allow
+unions members with complex constructors, see https://github.com/nlohmann/json/pull/105.
+*/
+template<typename BasicJsonType> struct internal_iterator
+{
+    /// iterator for JSON objects
+    typename BasicJsonType::object_t::iterator object_iterator {};
+    /// iterator for JSON arrays
+    typename BasicJsonType::array_t::iterator array_iterator {};
+    /// generic iterator for all other types
+    primitive_iterator_t primitive_iterator {};
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/iterators/iter_impl.hpp>
+
+
+#include <iterator> // iterator, random_access_iterator_tag, bidirectional_iterator_tag, advance, next
+#include <type_traits> // conditional, is_const, remove_const
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+// #include <nlohmann/detail/iterators/internal_iterator.hpp>
+
+// #include <nlohmann/detail/iterators/primitive_iterator.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/meta/cpp_future.hpp>
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+// forward declare, to be able to friend it later on
+template<typename IteratorType> class iteration_proxy;
+template<typename IteratorType> class iteration_proxy_value;
+
+/*!
+@brief a template for a bidirectional iterator for the @ref basic_json class
+This class implements a both iterators (iterator and const_iterator) for the
+@ref basic_json class.
+@note An iterator is called *initialized* when a pointer to a JSON value has
+      been set (e.g., by a constructor or a copy assignment). If the iterator is
+      default-constructed, it is *uninitialized* and most methods are undefined.
+      **The library uses assertions to detect calls on uninitialized iterators.**
+@requirement The class satisfies the following concept requirements:
+-
+[BidirectionalIterator](https://en.cppreference.com/w/cpp/named_req/BidirectionalIterator):
+  The iterator that can be moved can be moved in both directions (i.e.
+  incremented and decremented).
+@since version 1.0.0, simplified in version 2.0.9, change to bidirectional
+       iterators in version 3.0.0 (see https://github.com/nlohmann/json/issues/593)
+*/
+template<typename BasicJsonType>
+class iter_impl // NOLINT(cppcoreguidelines-special-member-functions,hicpp-special-member-functions)
+{
+    /// the iterator with BasicJsonType of different const-ness
+    using other_iter_impl = iter_impl<typename std::conditional<std::is_const<BasicJsonType>::value, typename std::remove_const<BasicJsonType>::type, const BasicJsonType>::type>;
+    /// allow basic_json to access private members
+    friend other_iter_impl;
+    friend BasicJsonType;
+    friend iteration_proxy<iter_impl>;
+    friend iteration_proxy_value<iter_impl>;
+
+    using object_t = typename BasicJsonType::object_t;
+    using array_t = typename BasicJsonType::array_t;
+    // make sure BasicJsonType is basic_json or const basic_json
+    static_assert(is_basic_json<typename std::remove_const<BasicJsonType>::type>::value,
+                  "iter_impl only accepts (const) basic_json");
+
+  public:
+
+    /// The std::iterator class template (used as a base class to provide typedefs) is deprecated in C++17.
+    /// The C++ Standard has never required user-defined iterators to derive from std::iterator.
+    /// A user-defined iterator should provide publicly accessible typedefs named
+    /// iterator_category, value_type, difference_type, pointer, and reference.
+    /// Note that value_type is required to be non-const, even for constant iterators.
+    using iterator_category = std::bidirectional_iterator_tag;
+
+    /// the type of the values when the iterator is dereferenced
+    using value_type = typename BasicJsonType::value_type;
+    /// a type to represent differences between iterators
+    using difference_type = typename BasicJsonType::difference_type;
+    /// defines a pointer to the type iterated over (value_type)
+    using pointer = typename std::conditional<std::is_const<BasicJsonType>::value,
+          typename BasicJsonType::const_pointer,
+          typename BasicJsonType::pointer>::type;
+    /// defines a reference to the type iterated over (value_type)
+    using reference =
+        typename std::conditional<std::is_const<BasicJsonType>::value,
+        typename BasicJsonType::const_reference,
+        typename BasicJsonType::reference>::type;
+
+    iter_impl() = default;
+    ~iter_impl() = default;
+    iter_impl(iter_impl&&) noexcept = default;
+    iter_impl& operator=(iter_impl&&) noexcept = default;
+
+    /*!
+    @brief constructor for a given JSON instance
+    @param[in] object  pointer to a JSON object for this iterator
+    @pre object != nullptr
+    @post The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    explicit iter_impl(pointer object) noexcept : m_object(object)
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+            {
+                m_it.object_iterator = typename object_t::iterator();
+                break;
+            }
+
+            case value_t::array:
+            {
+                m_it.array_iterator = typename array_t::iterator();
+                break;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                m_it.primitive_iterator = primitive_iterator_t();
+                break;
+            }
+        }
+    }
+
+    /*!
+    @note The conventional copy constructor and copy assignment are implicitly
+          defined. Combined with the following converting constructor and
+          assignment, they support: (1) copy from iterator to iterator, (2)
+          copy from const iterator to const iterator, and (3) conversion from
+          iterator to const iterator. However conversion from const iterator
+          to iterator is not defined.
+    */
+
+    /*!
+    @brief const copy constructor
+    @param[in] other const iterator to copy from
+    @note This copy constructor had to be defined explicitly to circumvent a bug
+          occurring on msvc v19.0 compiler (VS 2015) debug build. For more
+          information refer to: https://github.com/nlohmann/json/issues/1608
+    */
+    iter_impl(const iter_impl<const BasicJsonType>& other) noexcept
+        : m_object(other.m_object), m_it(other.m_it)
+    {}
+
+    /*!
+    @brief converting assignment
+    @param[in] other const iterator to copy from
+    @return const/non-const iterator
+    @note It is not checked whether @a other is initialized.
+    */
+    iter_impl& operator=(const iter_impl<const BasicJsonType>& other) noexcept
+    {
+        if (&other != this)
+        {
+            m_object = other.m_object;
+            m_it = other.m_it;
+        }
+        return *this;
+    }
+
+    /*!
+    @brief converting constructor
+    @param[in] other  non-const iterator to copy from
+    @note It is not checked whether @a other is initialized.
+    */
+    iter_impl(const iter_impl<typename std::remove_const<BasicJsonType>::type>& other) noexcept
+        : m_object(other.m_object), m_it(other.m_it)
+    {}
+
+    /*!
+    @brief converting assignment
+    @param[in] other  non-const iterator to copy from
+    @return const/non-const iterator
+    @note It is not checked whether @a other is initialized.
+    */
+    iter_impl& operator=(const iter_impl<typename std::remove_const<BasicJsonType>::type>& other) noexcept // NOLINT(cert-oop54-cpp)
+    {
+        m_object = other.m_object;
+        m_it = other.m_it;
+        return *this;
+    }
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    /*!
+    @brief set the iterator to the first value
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    void set_begin() noexcept
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+            {
+                m_it.object_iterator = m_object->m_value.object->begin();
+                break;
+            }
+
+            case value_t::array:
+            {
+                m_it.array_iterator = m_object->m_value.array->begin();
+                break;
+            }
+
+            case value_t::null:
+            {
+                // set to end so begin()==end() is true: null is empty
+                m_it.primitive_iterator.set_end();
+                break;
+            }
+
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                m_it.primitive_iterator.set_begin();
+                break;
+            }
+        }
+    }
+
+    /*!
+    @brief set the iterator past the last value
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    void set_end() noexcept
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+            {
+                m_it.object_iterator = m_object->m_value.object->end();
+                break;
+            }
+
+            case value_t::array:
+            {
+                m_it.array_iterator = m_object->m_value.array->end();
+                break;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                m_it.primitive_iterator.set_end();
+                break;
+            }
+        }
+    }
+
+  public:
+    /*!
+    @brief return a reference to the value pointed to by the iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    reference operator*() const
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+            {
+                JSON_ASSERT(m_it.object_iterator != m_object->m_value.object->end());
+                return m_it.object_iterator->second;
+            }
+
+            case value_t::array:
+            {
+                JSON_ASSERT(m_it.array_iterator != m_object->m_value.array->end());
+                return *m_it.array_iterator;
+            }
+
+            case value_t::null:
+                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
+
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                if (JSON_HEDLEY_LIKELY(m_it.primitive_iterator.is_begin()))
+                {
+                    return *m_object;
+                }
+
+                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
+            }
+        }
+    }
+
+    /*!
+    @brief dereference the iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    pointer operator->() const
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+            {
+                JSON_ASSERT(m_it.object_iterator != m_object->m_value.object->end());
+                return &(m_it.object_iterator->second);
+            }
+
+            case value_t::array:
+            {
+                JSON_ASSERT(m_it.array_iterator != m_object->m_value.array->end());
+                return &*m_it.array_iterator;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                if (JSON_HEDLEY_LIKELY(m_it.primitive_iterator.is_begin()))
+                {
+                    return m_object;
+                }
+
+                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
+            }
+        }
+    }
+
+    /*!
+    @brief post-increment (it++)
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl const operator++(int) // NOLINT(readability-const-return-type)
+    {
+        auto result = *this;
+        ++(*this);
+        return result;
+    }
+
+    /*!
+    @brief pre-increment (++it)
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl& operator++()
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+            {
+                std::advance(m_it.object_iterator, 1);
+                break;
+            }
+
+            case value_t::array:
+            {
+                std::advance(m_it.array_iterator, 1);
+                break;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                ++m_it.primitive_iterator;
+                break;
+            }
+        }
+
+        return *this;
+    }
+
+    /*!
+    @brief post-decrement (it--)
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl const operator--(int) // NOLINT(readability-const-return-type)
+    {
+        auto result = *this;
+        --(*this);
+        return result;
+    }
+
+    /*!
+    @brief pre-decrement (--it)
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl& operator--()
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+            {
+                std::advance(m_it.object_iterator, -1);
+                break;
+            }
+
+            case value_t::array:
+            {
+                std::advance(m_it.array_iterator, -1);
+                break;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                --m_it.primitive_iterator;
+                break;
+            }
+        }
+
+        return *this;
+    }
+
+    /*!
+    @brief comparison: equal
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    template < typename IterImpl, detail::enable_if_t < (std::is_same<IterImpl, iter_impl>::value || std::is_same<IterImpl, other_iter_impl>::value), std::nullptr_t > = nullptr >
+    bool operator==(const IterImpl& other) const
+    {
+        // if objects are not the same, the comparison is undefined
+        if (JSON_HEDLEY_UNLIKELY(m_object != other.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(212, "cannot compare iterators of different containers", *m_object));
+        }
+
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+                return (m_it.object_iterator == other.m_it.object_iterator);
+
+            case value_t::array:
+                return (m_it.array_iterator == other.m_it.array_iterator);
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+                return (m_it.primitive_iterator == other.m_it.primitive_iterator);
+        }
+    }
+
+    /*!
+    @brief comparison: not equal
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    template < typename IterImpl, detail::enable_if_t < (std::is_same<IterImpl, iter_impl>::value || std::is_same<IterImpl, other_iter_impl>::value), std::nullptr_t > = nullptr >
+    bool operator!=(const IterImpl& other) const
+    {
+        return !operator==(other);
+    }
+
+    /*!
+    @brief comparison: smaller
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    bool operator<(const iter_impl& other) const
+    {
+        // if objects are not the same, the comparison is undefined
+        if (JSON_HEDLEY_UNLIKELY(m_object != other.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(212, "cannot compare iterators of different containers", *m_object));
+        }
+
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+                JSON_THROW(invalid_iterator::create(213, "cannot compare order of object iterators", *m_object));
+
+            case value_t::array:
+                return (m_it.array_iterator < other.m_it.array_iterator);
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+                return (m_it.primitive_iterator < other.m_it.primitive_iterator);
+        }
+    }
+
+    /*!
+    @brief comparison: less than or equal
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    bool operator<=(const iter_impl& other) const
+    {
+        return !other.operator < (*this);
+    }
+
+    /*!
+    @brief comparison: greater than
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    bool operator>(const iter_impl& other) const
+    {
+        return !operator<=(other);
+    }
+
+    /*!
+    @brief comparison: greater than or equal
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    bool operator>=(const iter_impl& other) const
+    {
+        return !operator<(other);
+    }
+
+    /*!
+    @brief add to iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl& operator+=(difference_type i)
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+                JSON_THROW(invalid_iterator::create(209, "cannot use offsets with object iterators", *m_object));
+
+            case value_t::array:
+            {
+                std::advance(m_it.array_iterator, i);
+                break;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                m_it.primitive_iterator += i;
+                break;
+            }
+        }
+
+        return *this;
+    }
+
+    /*!
+    @brief subtract from iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl& operator-=(difference_type i)
+    {
+        return operator+=(-i);
+    }
+
+    /*!
+    @brief add to iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl operator+(difference_type i) const
+    {
+        auto result = *this;
+        result += i;
+        return result;
+    }
+
+    /*!
+    @brief addition of distance and iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    friend iter_impl operator+(difference_type i, const iter_impl& it)
+    {
+        auto result = it;
+        result += i;
+        return result;
+    }
+
+    /*!
+    @brief subtract from iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    iter_impl operator-(difference_type i) const
+    {
+        auto result = *this;
+        result -= i;
+        return result;
+    }
+
+    /*!
+    @brief return difference
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    difference_type operator-(const iter_impl& other) const
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+                JSON_THROW(invalid_iterator::create(209, "cannot use offsets with object iterators", *m_object));
+
+            case value_t::array:
+                return m_it.array_iterator - other.m_it.array_iterator;
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+                return m_it.primitive_iterator - other.m_it.primitive_iterator;
+        }
+    }
+
+    /*!
+    @brief access to successor
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    reference operator[](difference_type n) const
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        switch (m_object->m_type)
+        {
+            case value_t::object:
+                JSON_THROW(invalid_iterator::create(208, "cannot use operator[] for object iterators", *m_object));
+
+            case value_t::array:
+                return *std::next(m_it.array_iterator, n);
+
+            case value_t::null:
+                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
+
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                if (JSON_HEDLEY_LIKELY(m_it.primitive_iterator.get_value() == -n))
+                {
+                    return *m_object;
+                }
+
+                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
+            }
+        }
+    }
+
+    /*!
+    @brief return the key of an object iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    const typename object_t::key_type& key() const
+    {
+        JSON_ASSERT(m_object != nullptr);
+
+        if (JSON_HEDLEY_LIKELY(m_object->is_object()))
+        {
+            return m_it.object_iterator->first;
+        }
+
+        JSON_THROW(invalid_iterator::create(207, "cannot use key() for non-object iterators", *m_object));
+    }
+
+    /*!
+    @brief return the value of an iterator
+    @pre The iterator is initialized; i.e. `m_object != nullptr`.
+    */
+    reference value() const
+    {
+        return operator*();
+    }
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    /// associated JSON instance
+    pointer m_object = nullptr;
+    /// the actual iterator of the associated instance
+    internal_iterator<typename std::remove_const<BasicJsonType>::type> m_it {};
+};
+} // namespace detail
+} // namespace nlohmann
+
+// #include <nlohmann/detail/iterators/iteration_proxy.hpp>
+
+// #include <nlohmann/detail/iterators/json_reverse_iterator.hpp>
+
+
+#include <cstddef> // ptrdiff_t
+#include <iterator> // reverse_iterator
+#include <utility> // declval
+
+namespace nlohmann
+{
+namespace detail
+{
+//////////////////////
+// reverse_iterator //
+//////////////////////
+
+/*!
+@brief a template for a reverse iterator class
+
+@tparam Base the base iterator type to reverse. Valid types are @ref
+iterator (to create @ref reverse_iterator) and @ref const_iterator (to
+create @ref const_reverse_iterator).
+
+@requirement The class satisfies the following concept requirements:
+-
+[BidirectionalIterator](https://en.cppreference.com/w/cpp/named_req/BidirectionalIterator):
+  The iterator that can be moved can be moved in both directions (i.e.
+  incremented and decremented).
+- [OutputIterator](https://en.cppreference.com/w/cpp/named_req/OutputIterator):
+  It is possible to write to the pointed-to element (only if @a Base is
+  @ref iterator).
+
+@since version 1.0.0
+*/
+template<typename Base>
+class json_reverse_iterator : public std::reverse_iterator<Base>
+{
+  public:
+    using difference_type = std::ptrdiff_t;
+    /// shortcut to the reverse iterator adapter
+    using base_iterator = std::reverse_iterator<Base>;
+    /// the reference type for the pointed-to element
+    using reference = typename Base::reference;
+
+    /// create reverse iterator from iterator
+    explicit json_reverse_iterator(const typename base_iterator::iterator_type& it) noexcept
+        : base_iterator(it) {}
+
+    /// create reverse iterator from base class
+    explicit json_reverse_iterator(const base_iterator& it) noexcept : base_iterator(it) {}
+
+    /// post-increment (it++)
+    json_reverse_iterator const operator++(int) // NOLINT(readability-const-return-type)
+    {
+        return static_cast<json_reverse_iterator>(base_iterator::operator++(1));
+    }
+
+    /// pre-increment (++it)
+    json_reverse_iterator& operator++()
+    {
+        return static_cast<json_reverse_iterator&>(base_iterator::operator++());
+    }
+
+    /// post-decrement (it--)
+    json_reverse_iterator const operator--(int) // NOLINT(readability-const-return-type)
+    {
+        return static_cast<json_reverse_iterator>(base_iterator::operator--(1));
+    }
+
+    /// pre-decrement (--it)
+    json_reverse_iterator& operator--()
+    {
+        return static_cast<json_reverse_iterator&>(base_iterator::operator--());
+    }
+
+    /// add to iterator
+    json_reverse_iterator& operator+=(difference_type i)
+    {
+        return static_cast<json_reverse_iterator&>(base_iterator::operator+=(i));
+    }
+
+    /// add to iterator
+    json_reverse_iterator operator+(difference_type i) const
+    {
+        return static_cast<json_reverse_iterator>(base_iterator::operator+(i));
+    }
+
+    /// subtract from iterator
+    json_reverse_iterator operator-(difference_type i) const
+    {
+        return static_cast<json_reverse_iterator>(base_iterator::operator-(i));
+    }
+
+    /// return difference
+    difference_type operator-(const json_reverse_iterator& other) const
+    {
+        return base_iterator(*this) - base_iterator(other);
+    }
+
+    /// access to successor
+    reference operator[](difference_type n) const
+    {
+        return *(this->operator+(n));
+    }
+
+    /// return the key of an object iterator
+    auto key() const -> decltype(std::declval<Base>().key())
+    {
+        auto it = --this->base();
+        return it.key();
+    }
+
+    /// return the value of an iterator
+    reference value() const
+    {
+        auto it = --this->base();
+        return it.operator * ();
+    }
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/iterators/primitive_iterator.hpp>
+
+// #include <nlohmann/detail/json_pointer.hpp>
+
+
+#include <algorithm> // all_of
+#include <cctype> // isdigit
+#include <limits> // max
+#include <numeric> // accumulate
+#include <string> // string
+#include <utility> // move
+#include <vector> // vector
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/string_escape.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+namespace nlohmann
+{
+
+/// @brief JSON Pointer defines a string syntax for identifying a specific value within a JSON document
+/// @sa https://json.nlohmann.me/api/json_pointer/
+template<typename BasicJsonType>
+class json_pointer
+{
+    // allow basic_json to access private members
+    NLOHMANN_BASIC_JSON_TPL_DECLARATION
+    friend class basic_json;
+
+  public:
+    /// @brief create JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/json_pointer/
+    explicit json_pointer(const std::string& s = "")
+        : reference_tokens(split(s))
+    {}
+
+    /// @brief return a string representation of the JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/to_string/
+    std::string to_string() const
+    {
+        return std::accumulate(reference_tokens.begin(), reference_tokens.end(),
+                               std::string{},
+                               [](const std::string & a, const std::string & b)
+        {
+            return a + "/" + detail::escape(b);
+        });
+    }
+
+    /// @brief return a string representation of the JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/operator_string/
+    operator std::string() const
+    {
+        return to_string();
+    }
+
+    /// @brief append another JSON pointer at the end of this JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slasheq/
+    json_pointer& operator/=(const json_pointer& ptr)
+    {
+        reference_tokens.insert(reference_tokens.end(),
+                                ptr.reference_tokens.begin(),
+                                ptr.reference_tokens.end());
+        return *this;
+    }
+
+    /// @brief append an unescaped reference token at the end of this JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slasheq/
+    json_pointer& operator/=(std::string token)
+    {
+        push_back(std::move(token));
+        return *this;
+    }
+
+    /// @brief append an array index at the end of this JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slasheq/
+    json_pointer& operator/=(std::size_t array_idx)
+    {
+        return *this /= std::to_string(array_idx);
+    }
+
+    /// @brief create a new JSON pointer by appending the right JSON pointer at the end of the left JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slash/
+    friend json_pointer operator/(const json_pointer& lhs,
+                                  const json_pointer& rhs)
+    {
+        return json_pointer(lhs) /= rhs;
+    }
+
+    /// @brief create a new JSON pointer by appending the unescaped token at the end of the JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slash/
+    friend json_pointer operator/(const json_pointer& lhs, std::string token) // NOLINT(performance-unnecessary-value-param)
+    {
+        return json_pointer(lhs) /= std::move(token);
+    }
+
+    /// @brief create a new JSON pointer by appending the array-index-token at the end of the JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slash/
+    friend json_pointer operator/(const json_pointer& lhs, std::size_t array_idx)
+    {
+        return json_pointer(lhs) /= array_idx;
+    }
+
+    /// @brief returns the parent of this JSON pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/parent_pointer/
+    json_pointer parent_pointer() const
+    {
+        if (empty())
+        {
+            return *this;
+        }
+
+        json_pointer res = *this;
+        res.pop_back();
+        return res;
+    }
+
+    /// @brief remove last reference token
+    /// @sa https://json.nlohmann.me/api/json_pointer/pop_back/
+    void pop_back()
+    {
+        if (JSON_HEDLEY_UNLIKELY(empty()))
+        {
+            JSON_THROW(detail::out_of_range::create(405, "JSON pointer has no parent", BasicJsonType()));
+        }
+
+        reference_tokens.pop_back();
+    }
+
+    /// @brief return last reference token
+    /// @sa https://json.nlohmann.me/api/json_pointer/back/
+    const std::string& back() const
+    {
+        if (JSON_HEDLEY_UNLIKELY(empty()))
+        {
+            JSON_THROW(detail::out_of_range::create(405, "JSON pointer has no parent", BasicJsonType()));
+        }
+
+        return reference_tokens.back();
+    }
+
+    /// @brief append an unescaped token at the end of the reference pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/push_back/
+    void push_back(const std::string& token)
+    {
+        reference_tokens.push_back(token);
+    }
+
+    /// @brief append an unescaped token at the end of the reference pointer
+    /// @sa https://json.nlohmann.me/api/json_pointer/push_back/
+    void push_back(std::string&& token)
+    {
+        reference_tokens.push_back(std::move(token));
+    }
+
+    /// @brief return whether pointer points to the root document
+    /// @sa https://json.nlohmann.me/api/json_pointer/empty/
+    bool empty() const noexcept
+    {
+        return reference_tokens.empty();
+    }
+
+  private:
+    /*!
+    @param[in] s  reference token to be converted into an array index
+
+    @return integer representation of @a s
+
+    @throw parse_error.106  if an array index begins with '0'
+    @throw parse_error.109  if an array index begins not with a digit
+    @throw out_of_range.404 if string @a s could not be converted to an integer
+    @throw out_of_range.410 if an array index exceeds size_type
+    */
+    static typename BasicJsonType::size_type array_index(const std::string& s)
+    {
+        using size_type = typename BasicJsonType::size_type;
+
+        // error condition (cf. RFC 6901, Sect. 4)
+        if (JSON_HEDLEY_UNLIKELY(s.size() > 1 && s[0] == '0'))
+        {
+            JSON_THROW(detail::parse_error::create(106, 0, "array index '" + s + "' must not begin with '0'", BasicJsonType()));
+        }
+
+        // error condition (cf. RFC 6901, Sect. 4)
+        if (JSON_HEDLEY_UNLIKELY(s.size() > 1 && !(s[0] >= '1' && s[0] <= '9')))
+        {
+            JSON_THROW(detail::parse_error::create(109, 0, "array index '" + s + "' is not a number", BasicJsonType()));
+        }
+
+        std::size_t processed_chars = 0;
+        unsigned long long res = 0;  // NOLINT(runtime/int)
+        JSON_TRY
+        {
+            res = std::stoull(s, &processed_chars);
+        }
+        JSON_CATCH(std::out_of_range&)
+        {
+            JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + s + "'", BasicJsonType()));
+        }
+
+        // check if the string was completely read
+        if (JSON_HEDLEY_UNLIKELY(processed_chars != s.size()))
+        {
+            JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + s + "'", BasicJsonType()));
+        }
+
+        // only triggered on special platforms (like 32bit), see also
+        // https://github.com/nlohmann/json/pull/2203
+        if (res >= static_cast<unsigned long long>((std::numeric_limits<size_type>::max)()))  // NOLINT(runtime/int)
+        {
+            JSON_THROW(detail::out_of_range::create(410, "array index " + s + " exceeds size_type", BasicJsonType())); // LCOV_EXCL_LINE
+        }
+
+        return static_cast<size_type>(res);
+    }
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    json_pointer top() const
+    {
+        if (JSON_HEDLEY_UNLIKELY(empty()))
+        {
+            JSON_THROW(detail::out_of_range::create(405, "JSON pointer has no parent", BasicJsonType()));
+        }
+
+        json_pointer result = *this;
+        result.reference_tokens = {reference_tokens[0]};
+        return result;
+    }
+
+  private:
+    /*!
+    @brief create and return a reference to the pointed to value
+
+    @complexity Linear in the number of reference tokens.
+
+    @throw parse_error.109 if array index is not a number
+    @throw type_error.313 if value cannot be unflattened
+    */
+    BasicJsonType& get_and_create(BasicJsonType& j) const
+    {
+        auto* result = &j;
+
+        // in case no reference tokens exist, return a reference to the JSON value
+        // j which will be overwritten by a primitive value
+        for (const auto& reference_token : reference_tokens)
+        {
+            switch (result->type())
+            {
+                case detail::value_t::null:
+                {
+                    if (reference_token == "0")
+                    {
+                        // start a new array if reference token is 0
+                        result = &result->operator[](0);
+                    }
+                    else
+                    {
+                        // start a new object otherwise
+                        result = &result->operator[](reference_token);
+                    }
+                    break;
+                }
+
+                case detail::value_t::object:
+                {
+                    // create an entry in the object
+                    result = &result->operator[](reference_token);
+                    break;
+                }
+
+                case detail::value_t::array:
+                {
+                    // create an entry in the array
+                    result = &result->operator[](array_index(reference_token));
+                    break;
+                }
+
+                /*
+                The following code is only reached if there exists a reference
+                token _and_ the current value is primitive. In this case, we have
+                an error situation, because primitive values may only occur as
+                single value; that is, with an empty list of reference tokens.
+                */
+                case detail::value_t::string:
+                case detail::value_t::boolean:
+                case detail::value_t::number_integer:
+                case detail::value_t::number_unsigned:
+                case detail::value_t::number_float:
+                case detail::value_t::binary:
+                case detail::value_t::discarded:
+                default:
+                    JSON_THROW(detail::type_error::create(313, "invalid value to unflatten", j));
+            }
+        }
+
+        return *result;
+    }
+
+    /*!
+    @brief return a reference to the pointed to value
+
+    @note This version does not throw if a value is not present, but tries to
+          create nested values instead. For instance, calling this function
+          with pointer `"/this/that"` on a null value is equivalent to calling
+          `operator[]("this").operator[]("that")` on that value, effectively
+          changing the null value to an object.
+
+    @param[in] ptr  a JSON value
+
+    @return reference to the JSON value pointed to by the JSON pointer
+
+    @complexity Linear in the length of the JSON pointer.
+
+    @throw parse_error.106   if an array index begins with '0'
+    @throw parse_error.109   if an array index was not a number
+    @throw out_of_range.404  if the JSON pointer can not be resolved
+    */
+    BasicJsonType& get_unchecked(BasicJsonType* ptr) const
+    {
+        for (const auto& reference_token : reference_tokens)
+        {
+            // convert null values to arrays or objects before continuing
+            if (ptr->is_null())
+            {
+                // check if reference token is a number
+                const bool nums =
+                    std::all_of(reference_token.begin(), reference_token.end(),
+                                [](const unsigned char x)
+                {
+                    return std::isdigit(x);
+                });
+
+                // change value to array for numbers or "-" or to object otherwise
+                *ptr = (nums || reference_token == "-")
+                       ? detail::value_t::array
+                       : detail::value_t::object;
+            }
+
+            switch (ptr->type())
+            {
+                case detail::value_t::object:
+                {
+                    // use unchecked object access
+                    ptr = &ptr->operator[](reference_token);
+                    break;
+                }
+
+                case detail::value_t::array:
+                {
+                    if (reference_token == "-")
+                    {
+                        // explicitly treat "-" as index beyond the end
+                        ptr = &ptr->operator[](ptr->m_value.array->size());
+                    }
+                    else
+                    {
+                        // convert array index to number; unchecked access
+                        ptr = &ptr->operator[](array_index(reference_token));
+                    }
+                    break;
+                }
+
+                case detail::value_t::null:
+                case detail::value_t::string:
+                case detail::value_t::boolean:
+                case detail::value_t::number_integer:
+                case detail::value_t::number_unsigned:
+                case detail::value_t::number_float:
+                case detail::value_t::binary:
+                case detail::value_t::discarded:
+                default:
+                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
+            }
+        }
+
+        return *ptr;
+    }
+
+    /*!
+    @throw parse_error.106   if an array index begins with '0'
+    @throw parse_error.109   if an array index was not a number
+    @throw out_of_range.402  if the array index '-' is used
+    @throw out_of_range.404  if the JSON pointer can not be resolved
+    */
+    BasicJsonType& get_checked(BasicJsonType* ptr) const
+    {
+        for (const auto& reference_token : reference_tokens)
+        {
+            switch (ptr->type())
+            {
+                case detail::value_t::object:
+                {
+                    // note: at performs range check
+                    ptr = &ptr->at(reference_token);
+                    break;
+                }
+
+                case detail::value_t::array:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
+                    {
+                        // "-" always fails the range check
+                        JSON_THROW(detail::out_of_range::create(402,
+                                                                "array index '-' (" + std::to_string(ptr->m_value.array->size()) +
+                                                                ") is out of range", *ptr));
+                    }
+
+                    // note: at performs range check
+                    ptr = &ptr->at(array_index(reference_token));
+                    break;
+                }
+
+                case detail::value_t::null:
+                case detail::value_t::string:
+                case detail::value_t::boolean:
+                case detail::value_t::number_integer:
+                case detail::value_t::number_unsigned:
+                case detail::value_t::number_float:
+                case detail::value_t::binary:
+                case detail::value_t::discarded:
+                default:
+                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
+            }
+        }
+
+        return *ptr;
+    }
+
+    /*!
+    @brief return a const reference to the pointed to value
+
+    @param[in] ptr  a JSON value
+
+    @return const reference to the JSON value pointed to by the JSON
+    pointer
+
+    @throw parse_error.106   if an array index begins with '0'
+    @throw parse_error.109   if an array index was not a number
+    @throw out_of_range.402  if the array index '-' is used
+    @throw out_of_range.404  if the JSON pointer can not be resolved
+    */
+    const BasicJsonType& get_unchecked(const BasicJsonType* ptr) const
+    {
+        for (const auto& reference_token : reference_tokens)
+        {
+            switch (ptr->type())
+            {
+                case detail::value_t::object:
+                {
+                    // use unchecked object access
+                    ptr = &ptr->operator[](reference_token);
+                    break;
+                }
+
+                case detail::value_t::array:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
+                    {
+                        // "-" cannot be used for const access
+                        JSON_THROW(detail::out_of_range::create(402, "array index '-' (" + std::to_string(ptr->m_value.array->size()) + ") is out of range", *ptr));
+                    }
+
+                    // use unchecked array access
+                    ptr = &ptr->operator[](array_index(reference_token));
+                    break;
+                }
+
+                case detail::value_t::null:
+                case detail::value_t::string:
+                case detail::value_t::boolean:
+                case detail::value_t::number_integer:
+                case detail::value_t::number_unsigned:
+                case detail::value_t::number_float:
+                case detail::value_t::binary:
+                case detail::value_t::discarded:
+                default:
+                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
+            }
+        }
+
+        return *ptr;
+    }
+
+    /*!
+    @throw parse_error.106   if an array index begins with '0'
+    @throw parse_error.109   if an array index was not a number
+    @throw out_of_range.402  if the array index '-' is used
+    @throw out_of_range.404  if the JSON pointer can not be resolved
+    */
+    const BasicJsonType& get_checked(const BasicJsonType* ptr) const
+    {
+        for (const auto& reference_token : reference_tokens)
+        {
+            switch (ptr->type())
+            {
+                case detail::value_t::object:
+                {
+                    // note: at performs range check
+                    ptr = &ptr->at(reference_token);
+                    break;
+                }
+
+                case detail::value_t::array:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
+                    {
+                        // "-" always fails the range check
+                        JSON_THROW(detail::out_of_range::create(402,
+                                                                "array index '-' (" + std::to_string(ptr->m_value.array->size()) +
+                                                                ") is out of range", *ptr));
+                    }
+
+                    // note: at performs range check
+                    ptr = &ptr->at(array_index(reference_token));
+                    break;
+                }
+
+                case detail::value_t::null:
+                case detail::value_t::string:
+                case detail::value_t::boolean:
+                case detail::value_t::number_integer:
+                case detail::value_t::number_unsigned:
+                case detail::value_t::number_float:
+                case detail::value_t::binary:
+                case detail::value_t::discarded:
+                default:
+                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
+            }
+        }
+
+        return *ptr;
+    }
+
+    /*!
+    @throw parse_error.106   if an array index begins with '0'
+    @throw parse_error.109   if an array index was not a number
+    */
+    bool contains(const BasicJsonType* ptr) const
+    {
+        for (const auto& reference_token : reference_tokens)
+        {
+            switch (ptr->type())
+            {
+                case detail::value_t::object:
+                {
+                    if (!ptr->contains(reference_token))
+                    {
+                        // we did not find the key in the object
+                        return false;
+                    }
+
+                    ptr = &ptr->operator[](reference_token);
+                    break;
+                }
+
+                case detail::value_t::array:
+                {
+                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
+                    {
+                        // "-" always fails the range check
+                        return false;
+                    }
+                    if (JSON_HEDLEY_UNLIKELY(reference_token.size() == 1 && !("0" <= reference_token && reference_token <= "9")))
+                    {
+                        // invalid char
+                        return false;
+                    }
+                    if (JSON_HEDLEY_UNLIKELY(reference_token.size() > 1))
+                    {
+                        if (JSON_HEDLEY_UNLIKELY(!('1' <= reference_token[0] && reference_token[0] <= '9')))
+                        {
+                            // first char should be between '1' and '9'
+                            return false;
+                        }
+                        for (std::size_t i = 1; i < reference_token.size(); i++)
+                        {
+                            if (JSON_HEDLEY_UNLIKELY(!('0' <= reference_token[i] && reference_token[i] <= '9')))
+                            {
+                                // other char should be between '0' and '9'
+                                return false;
+                            }
+                        }
+                    }
+
+                    const auto idx = array_index(reference_token);
+                    if (idx >= ptr->size())
+                    {
+                        // index out of range
+                        return false;
+                    }
+
+                    ptr = &ptr->operator[](idx);
+                    break;
+                }
+
+                case detail::value_t::null:
+                case detail::value_t::string:
+                case detail::value_t::boolean:
+                case detail::value_t::number_integer:
+                case detail::value_t::number_unsigned:
+                case detail::value_t::number_float:
+                case detail::value_t::binary:
+                case detail::value_t::discarded:
+                default:
+                {
+                    // we do not expect primitive values if there is still a
+                    // reference token to process
+                    return false;
+                }
+            }
+        }
+
+        // no reference token left means we found a primitive value
+        return true;
+    }
+
+    /*!
+    @brief split the string input to reference tokens
+
+    @note This function is only called by the json_pointer constructor.
+          All exceptions below are documented there.
+
+    @throw parse_error.107  if the pointer is not empty or begins with '/'
+    @throw parse_error.108  if character '~' is not followed by '0' or '1'
+    */
+    static std::vector<std::string> split(const std::string& reference_string)
+    {
+        std::vector<std::string> result;
+
+        // special case: empty reference string -> no reference tokens
+        if (reference_string.empty())
+        {
+            return result;
+        }
+
+        // check if nonempty reference string begins with slash
+        if (JSON_HEDLEY_UNLIKELY(reference_string[0] != '/'))
+        {
+            JSON_THROW(detail::parse_error::create(107, 1, "JSON pointer must be empty or begin with '/' - was: '" + reference_string + "'", BasicJsonType()));
+        }
+
+        // extract the reference tokens:
+        // - slash: position of the last read slash (or end of string)
+        // - start: position after the previous slash
+        for (
+            // search for the first slash after the first character
+            std::size_t slash = reference_string.find_first_of('/', 1),
+            // set the beginning of the first reference token
+            start = 1;
+            // we can stop if start == 0 (if slash == std::string::npos)
+            start != 0;
+            // set the beginning of the next reference token
+            // (will eventually be 0 if slash == std::string::npos)
+            start = (slash == std::string::npos) ? 0 : slash + 1,
+            // find next slash
+            slash = reference_string.find_first_of('/', start))
+        {
+            // use the text between the beginning of the reference token
+            // (start) and the last slash (slash).
+            auto reference_token = reference_string.substr(start, slash - start);
+
+            // check reference tokens are properly escaped
+            for (std::size_t pos = reference_token.find_first_of('~');
+                    pos != std::string::npos;
+                    pos = reference_token.find_first_of('~', pos + 1))
+            {
+                JSON_ASSERT(reference_token[pos] == '~');
+
+                // ~ must be followed by 0 or 1
+                if (JSON_HEDLEY_UNLIKELY(pos == reference_token.size() - 1 ||
+                                         (reference_token[pos + 1] != '0' &&
+                                          reference_token[pos + 1] != '1')))
+                {
+                    JSON_THROW(detail::parse_error::create(108, 0, "escape character '~' must be followed with '0' or '1'", BasicJsonType()));
+                }
+            }
+
+            // finally, store the reference token
+            detail::unescape(reference_token);
+            result.push_back(reference_token);
+        }
+
+        return result;
+    }
+
+  private:
+    /*!
+    @param[in] reference_string  the reference string to the current value
+    @param[in] value             the value to consider
+    @param[in,out] result        the result object to insert values to
+
+    @note Empty objects or arrays are flattened to `null`.
+    */
+    static void flatten(const std::string& reference_string,
+                        const BasicJsonType& value,
+                        BasicJsonType& result)
+    {
+        switch (value.type())
+        {
+            case detail::value_t::array:
+            {
+                if (value.m_value.array->empty())
+                {
+                    // flatten empty array as null
+                    result[reference_string] = nullptr;
+                }
+                else
+                {
+                    // iterate array and use index as reference string
+                    for (std::size_t i = 0; i < value.m_value.array->size(); ++i)
+                    {
+                        flatten(reference_string + "/" + std::to_string(i),
+                                value.m_value.array->operator[](i), result);
+                    }
+                }
+                break;
+            }
+
+            case detail::value_t::object:
+            {
+                if (value.m_value.object->empty())
+                {
+                    // flatten empty object as null
+                    result[reference_string] = nullptr;
+                }
+                else
+                {
+                    // iterate object and use keys as reference string
+                    for (const auto& element : *value.m_value.object)
+                    {
+                        flatten(reference_string + "/" + detail::escape(element.first), element.second, result);
+                    }
+                }
+                break;
+            }
+
+            case detail::value_t::null:
+            case detail::value_t::string:
+            case detail::value_t::boolean:
+            case detail::value_t::number_integer:
+            case detail::value_t::number_unsigned:
+            case detail::value_t::number_float:
+            case detail::value_t::binary:
+            case detail::value_t::discarded:
+            default:
+            {
+                // add primitive value with its reference string
+                result[reference_string] = value;
+                break;
+            }
+        }
+    }
+
+    /*!
+    @param[in] value  flattened JSON
+
+    @return unflattened JSON
+
+    @throw parse_error.109 if array index is not a number
+    @throw type_error.314  if value is not an object
+    @throw type_error.315  if object values are not primitive
+    @throw type_error.313  if value cannot be unflattened
+    */
+    static BasicJsonType
+    unflatten(const BasicJsonType& value)
+    {
+        if (JSON_HEDLEY_UNLIKELY(!value.is_object()))
+        {
+            JSON_THROW(detail::type_error::create(314, "only objects can be unflattened", value));
+        }
+
+        BasicJsonType result;
+
+        // iterate the JSON object values
+        for (const auto& element : *value.m_value.object)
+        {
+            if (JSON_HEDLEY_UNLIKELY(!element.second.is_primitive()))
+            {
+                JSON_THROW(detail::type_error::create(315, "values in object must be primitive", element.second));
+            }
+
+            // assign value to reference pointed to by JSON pointer; Note that if
+            // the JSON pointer is "" (i.e., points to the whole value), function
+            // get_and_create returns a reference to result itself. An assignment
+            // will then create a primitive value.
+            json_pointer(element.first).get_and_create(result) = element.second;
+        }
+
+        return result;
+    }
+
+    /*!
+    @brief compares two JSON pointers for equality
+
+    @param[in] lhs  JSON pointer to compare
+    @param[in] rhs  JSON pointer to compare
+    @return whether @a lhs is equal to @a rhs
+
+    @complexity Linear in the length of the JSON pointer
+
+    @exceptionsafety No-throw guarantee: this function never throws exceptions.
+    */
+    friend bool operator==(json_pointer const& lhs,
+                           json_pointer const& rhs) noexcept
+    {
+        return lhs.reference_tokens == rhs.reference_tokens;
+    }
+
+    /*!
+    @brief compares two JSON pointers for inequality
+
+    @param[in] lhs  JSON pointer to compare
+    @param[in] rhs  JSON pointer to compare
+    @return whether @a lhs is not equal @a rhs
+
+    @complexity Linear in the length of the JSON pointer
+
+    @exceptionsafety No-throw guarantee: this function never throws exceptions.
+    */
+    friend bool operator!=(json_pointer const& lhs,
+                           json_pointer const& rhs) noexcept
+    {
+        return !(lhs == rhs);
+    }
+
+    /// the reference tokens
+    std::vector<std::string> reference_tokens;
+};
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/json_ref.hpp>
+
+
+#include <initializer_list>
+#include <utility>
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+template<typename BasicJsonType>
+class json_ref
+{
+  public:
+    using value_type = BasicJsonType;
+
+    json_ref(value_type&& value)
+        : owned_value(std::move(value))
+    {}
+
+    json_ref(const value_type& value)
+        : value_ref(&value)
+    {}
+
+    json_ref(std::initializer_list<json_ref> init)
+        : owned_value(init)
+    {}
+
+    template <
+        class... Args,
+        enable_if_t<std::is_constructible<value_type, Args...>::value, int> = 0 >
+    json_ref(Args && ... args)
+        : owned_value(std::forward<Args>(args)...)
+    {}
+
+    // class should be movable only
+    json_ref(json_ref&&) noexcept = default;
+    json_ref(const json_ref&) = delete;
+    json_ref& operator=(const json_ref&) = delete;
+    json_ref& operator=(json_ref&&) = delete;
+    ~json_ref() = default;
+
+    value_type moved_or_copied() const
+    {
+        if (value_ref == nullptr)
+        {
+            return std::move(owned_value);
+        }
+        return *value_ref;
+    }
+
+    value_type const& operator*() const
+    {
+        return value_ref ? *value_ref : owned_value;
+    }
+
+    value_type const* operator->() const
+    {
+        return &** this;
+    }
+
+  private:
+    mutable value_type owned_value = nullptr;
+    value_type const* value_ref = nullptr;
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/string_escape.hpp>
+
+// #include <nlohmann/detail/meta/cpp_future.hpp>
+
+// #include <nlohmann/detail/meta/type_traits.hpp>
+
+// #include <nlohmann/detail/output/binary_writer.hpp>
+
+
+#include <algorithm> // reverse
+#include <array> // array
+#include <cmath> // isnan, isinf
+#include <cstdint> // uint8_t, uint16_t, uint32_t, uint64_t
+#include <cstring> // memcpy
+#include <limits> // numeric_limits
+#include <string> // string
+#include <utility> // move
+
+// #include <nlohmann/detail/input/binary_reader.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/output/output_adapters.hpp>
+
+
+#include <algorithm> // copy
+#include <cstddef> // size_t
+#include <iterator> // back_inserter
+#include <memory> // shared_ptr, make_shared
+#include <string> // basic_string
+#include <vector> // vector
+
+#ifndef JSON_NO_IO
+    #include <ios>      // streamsize
+    #include <ostream>  // basic_ostream
+#endif  // JSON_NO_IO
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+/// abstract output adapter interface
+template<typename CharType> struct output_adapter_protocol
+{
+    virtual void write_character(CharType c) = 0;
+    virtual void write_characters(const CharType* s, std::size_t length) = 0;
+    virtual ~output_adapter_protocol() = default;
+
+    output_adapter_protocol() = default;
+    output_adapter_protocol(const output_adapter_protocol&) = default;
+    output_adapter_protocol(output_adapter_protocol&&) noexcept = default;
+    output_adapter_protocol& operator=(const output_adapter_protocol&) = default;
+    output_adapter_protocol& operator=(output_adapter_protocol&&) noexcept = default;
+};
+
+/// a type to simplify interfaces
+template<typename CharType>
+using output_adapter_t = std::shared_ptr<output_adapter_protocol<CharType>>;
+
+/// output adapter for byte vectors
+template<typename CharType, typename AllocatorType = std::allocator<CharType>>
+class output_vector_adapter : public output_adapter_protocol<CharType>
+{
+  public:
+    explicit output_vector_adapter(std::vector<CharType, AllocatorType>& vec) noexcept
+        : v(vec)
+    {}
+
+    void write_character(CharType c) override
+    {
+        v.push_back(c);
+    }
+
+    JSON_HEDLEY_NON_NULL(2)
+    void write_characters(const CharType* s, std::size_t length) override
+    {
+        std::copy(s, s + length, std::back_inserter(v));
+    }
+
+  private:
+    std::vector<CharType, AllocatorType>& v;
+};
+
+#ifndef JSON_NO_IO
+/// output adapter for output streams
+template<typename CharType>
+class output_stream_adapter : public output_adapter_protocol<CharType>
+{
+  public:
+    explicit output_stream_adapter(std::basic_ostream<CharType>& s) noexcept
+        : stream(s)
+    {}
+
+    void write_character(CharType c) override
+    {
+        stream.put(c);
+    }
+
+    JSON_HEDLEY_NON_NULL(2)
+    void write_characters(const CharType* s, std::size_t length) override
+    {
+        stream.write(s, static_cast<std::streamsize>(length));
+    }
+
+  private:
+    std::basic_ostream<CharType>& stream;
+};
+#endif  // JSON_NO_IO
+
+/// output adapter for basic_string
+template<typename CharType, typename StringType = std::basic_string<CharType>>
+class output_string_adapter : public output_adapter_protocol<CharType>
+{
+  public:
+    explicit output_string_adapter(StringType& s) noexcept
+        : str(s)
+    {}
+
+    void write_character(CharType c) override
+    {
+        str.push_back(c);
+    }
+
+    JSON_HEDLEY_NON_NULL(2)
+    void write_characters(const CharType* s, std::size_t length) override
+    {
+        str.append(s, length);
+    }
+
+  private:
+    StringType& str;
+};
+
+template<typename CharType, typename StringType = std::basic_string<CharType>>
+class output_adapter
+{
+  public:
+    template<typename AllocatorType = std::allocator<CharType>>
+    output_adapter(std::vector<CharType, AllocatorType>& vec)
+        : oa(std::make_shared<output_vector_adapter<CharType, AllocatorType>>(vec)) {}
+
+#ifndef JSON_NO_IO
+    output_adapter(std::basic_ostream<CharType>& s)
+        : oa(std::make_shared<output_stream_adapter<CharType>>(s)) {}
+#endif  // JSON_NO_IO
+
+    output_adapter(StringType& s)
+        : oa(std::make_shared<output_string_adapter<CharType, StringType>>(s)) {}
+
+    operator output_adapter_t<CharType>()
+    {
+        return oa;
+    }
+
+  private:
+    output_adapter_t<CharType> oa = nullptr;
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+
+namespace nlohmann
+{
+namespace detail
+{
+///////////////////
+// binary writer //
+///////////////////
+
+/*!
+@brief serialization to CBOR and MessagePack values
+*/
+template<typename BasicJsonType, typename CharType>
+class binary_writer
+{
+    using string_t = typename BasicJsonType::string_t;
+    using binary_t = typename BasicJsonType::binary_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+
+  public:
+    /*!
+    @brief create a binary writer
+
+    @param[in] adapter  output adapter to write to
+    */
+    explicit binary_writer(output_adapter_t<CharType> adapter) : oa(std::move(adapter))
+    {
+        JSON_ASSERT(oa);
+    }
+
+    /*!
+    @param[in] j  JSON value to serialize
+    @pre       j.type() == value_t::object
+    */
+    void write_bson(const BasicJsonType& j)
+    {
+        switch (j.type())
+        {
+            case value_t::object:
+            {
+                write_bson_object(*j.m_value.object);
+                break;
+            }
+
+            case value_t::null:
+            case value_t::array:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                JSON_THROW(type_error::create(317, "to serialize to BSON, top-level type must be object, but is " + std::string(j.type_name()), j));
+            }
+        }
+    }
+
+    /*!
+    @param[in] j  JSON value to serialize
+    */
+    void write_cbor(const BasicJsonType& j)
+    {
+        switch (j.type())
+        {
+            case value_t::null:
+            {
+                oa->write_character(to_char_type(0xF6));
+                break;
+            }
+
+            case value_t::boolean:
+            {
+                oa->write_character(j.m_value.boolean
+                                    ? to_char_type(0xF5)
+                                    : to_char_type(0xF4));
+                break;
+            }
+
+            case value_t::number_integer:
+            {
+                if (j.m_value.number_integer >= 0)
+                {
+                    // CBOR does not differentiate between positive signed
+                    // integers and unsigned integers. Therefore, we used the
+                    // code from the value_t::number_unsigned case here.
+                    if (j.m_value.number_integer <= 0x17)
+                    {
+                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_integer <= (std::numeric_limits<std::uint8_t>::max)())
+                    {
+                        oa->write_character(to_char_type(0x18));
+                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_integer <= (std::numeric_limits<std::uint16_t>::max)())
+                    {
+                        oa->write_character(to_char_type(0x19));
+                        write_number(static_cast<std::uint16_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_integer <= (std::numeric_limits<std::uint32_t>::max)())
+                    {
+                        oa->write_character(to_char_type(0x1A));
+                        write_number(static_cast<std::uint32_t>(j.m_value.number_integer));
+                    }
+                    else
+                    {
+                        oa->write_character(to_char_type(0x1B));
+                        write_number(static_cast<std::uint64_t>(j.m_value.number_integer));
+                    }
+                }
+                else
+                {
+                    // The conversions below encode the sign in the first
+                    // byte, and the value is converted to a positive number.
+                    const auto positive_number = -1 - j.m_value.number_integer;
+                    if (j.m_value.number_integer >= -24)
+                    {
+                        write_number(static_cast<std::uint8_t>(0x20 + positive_number));
+                    }
+                    else if (positive_number <= (std::numeric_limits<std::uint8_t>::max)())
+                    {
+                        oa->write_character(to_char_type(0x38));
+                        write_number(static_cast<std::uint8_t>(positive_number));
+                    }
+                    else if (positive_number <= (std::numeric_limits<std::uint16_t>::max)())
+                    {
+                        oa->write_character(to_char_type(0x39));
+                        write_number(static_cast<std::uint16_t>(positive_number));
+                    }
+                    else if (positive_number <= (std::numeric_limits<std::uint32_t>::max)())
+                    {
+                        oa->write_character(to_char_type(0x3A));
+                        write_number(static_cast<std::uint32_t>(positive_number));
+                    }
+                    else
+                    {
+                        oa->write_character(to_char_type(0x3B));
+                        write_number(static_cast<std::uint64_t>(positive_number));
+                    }
+                }
+                break;
+            }
+
+            case value_t::number_unsigned:
+            {
+                if (j.m_value.number_unsigned <= 0x17)
+                {
+                    write_number(static_cast<std::uint8_t>(j.m_value.number_unsigned));
+                }
+                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x18));
+                    write_number(static_cast<std::uint8_t>(j.m_value.number_unsigned));
+                }
+                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x19));
+                    write_number(static_cast<std::uint16_t>(j.m_value.number_unsigned));
+                }
+                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x1A));
+                    write_number(static_cast<std::uint32_t>(j.m_value.number_unsigned));
+                }
+                else
+                {
+                    oa->write_character(to_char_type(0x1B));
+                    write_number(static_cast<std::uint64_t>(j.m_value.number_unsigned));
+                }
+                break;
+            }
+
+            case value_t::number_float:
+            {
+                if (std::isnan(j.m_value.number_float))
+                {
+                    // NaN is 0xf97e00 in CBOR
+                    oa->write_character(to_char_type(0xF9));
+                    oa->write_character(to_char_type(0x7E));
+                    oa->write_character(to_char_type(0x00));
+                }
+                else if (std::isinf(j.m_value.number_float))
+                {
+                    // Infinity is 0xf97c00, -Infinity is 0xf9fc00
+                    oa->write_character(to_char_type(0xf9));
+                    oa->write_character(j.m_value.number_float > 0 ? to_char_type(0x7C) : to_char_type(0xFC));
+                    oa->write_character(to_char_type(0x00));
+                }
+                else
+                {
+                    write_compact_float(j.m_value.number_float, detail::input_format_t::cbor);
+                }
+                break;
+            }
+
+            case value_t::string:
+            {
+                // step 1: write control byte and the string length
+                const auto N = j.m_value.string->size();
+                if (N <= 0x17)
+                {
+                    write_number(static_cast<std::uint8_t>(0x60 + N));
+                }
+                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x78));
+                    write_number(static_cast<std::uint8_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x79));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x7A));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+                // LCOV_EXCL_START
+                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x7B));
+                    write_number(static_cast<std::uint64_t>(N));
+                }
+                // LCOV_EXCL_STOP
+
+                // step 2: write the string
+                oa->write_characters(
+                    reinterpret_cast<const CharType*>(j.m_value.string->c_str()),
+                    j.m_value.string->size());
+                break;
+            }
+
+            case value_t::array:
+            {
+                // step 1: write control byte and the array size
+                const auto N = j.m_value.array->size();
+                if (N <= 0x17)
+                {
+                    write_number(static_cast<std::uint8_t>(0x80 + N));
+                }
+                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x98));
+                    write_number(static_cast<std::uint8_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x99));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x9A));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+                // LCOV_EXCL_START
+                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x9B));
+                    write_number(static_cast<std::uint64_t>(N));
+                }
+                // LCOV_EXCL_STOP
+
+                // step 2: write each element
+                for (const auto& el : *j.m_value.array)
+                {
+                    write_cbor(el);
+                }
+                break;
+            }
+
+            case value_t::binary:
+            {
+                if (j.m_value.binary->has_subtype())
+                {
+                    if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint8_t>::max)())
+                    {
+                        write_number(static_cast<std::uint8_t>(0xd8));
+                        write_number(static_cast<std::uint8_t>(j.m_value.binary->subtype()));
+                    }
+                    else if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint16_t>::max)())
+                    {
+                        write_number(static_cast<std::uint8_t>(0xd9));
+                        write_number(static_cast<std::uint16_t>(j.m_value.binary->subtype()));
+                    }
+                    else if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint32_t>::max)())
+                    {
+                        write_number(static_cast<std::uint8_t>(0xda));
+                        write_number(static_cast<std::uint32_t>(j.m_value.binary->subtype()));
+                    }
+                    else if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint64_t>::max)())
+                    {
+                        write_number(static_cast<std::uint8_t>(0xdb));
+                        write_number(static_cast<std::uint64_t>(j.m_value.binary->subtype()));
+                    }
+                }
+
+                // step 1: write control byte and the binary array size
+                const auto N = j.m_value.binary->size();
+                if (N <= 0x17)
+                {
+                    write_number(static_cast<std::uint8_t>(0x40 + N));
+                }
+                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x58));
+                    write_number(static_cast<std::uint8_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x59));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x5A));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+                // LCOV_EXCL_START
+                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
+                {
+                    oa->write_character(to_char_type(0x5B));
+                    write_number(static_cast<std::uint64_t>(N));
+                }
+                // LCOV_EXCL_STOP
+
+                // step 2: write each element
+                oa->write_characters(
+                    reinterpret_cast<const CharType*>(j.m_value.binary->data()),
+                    N);
+
+                break;
+            }
+
+            case value_t::object:
+            {
+                // step 1: write control byte and the object size
+                const auto N = j.m_value.object->size();
+                if (N <= 0x17)
+                {
+                    write_number(static_cast<std::uint8_t>(0xA0 + N));
+                }
+                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    oa->write_character(to_char_type(0xB8));
+                    write_number(static_cast<std::uint8_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    oa->write_character(to_char_type(0xB9));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    oa->write_character(to_char_type(0xBA));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+                // LCOV_EXCL_START
+                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
+                {
+                    oa->write_character(to_char_type(0xBB));
+                    write_number(static_cast<std::uint64_t>(N));
+                }
+                // LCOV_EXCL_STOP
+
+                // step 2: write each element
+                for (const auto& el : *j.m_value.object)
+                {
+                    write_cbor(el.first);
+                    write_cbor(el.second);
+                }
+                break;
+            }
+
+            case value_t::discarded:
+            default:
+                break;
+        }
+    }
+
+    /*!
+    @param[in] j  JSON value to serialize
+    */
+    void write_msgpack(const BasicJsonType& j)
+    {
+        switch (j.type())
+        {
+            case value_t::null: // nil
+            {
+                oa->write_character(to_char_type(0xC0));
+                break;
+            }
+
+            case value_t::boolean: // true and false
+            {
+                oa->write_character(j.m_value.boolean
+                                    ? to_char_type(0xC3)
+                                    : to_char_type(0xC2));
+                break;
+            }
+
+            case value_t::number_integer:
+            {
+                if (j.m_value.number_integer >= 0)
+                {
+                    // MessagePack does not differentiate between positive
+                    // signed integers and unsigned integers. Therefore, we used
+                    // the code from the value_t::number_unsigned case here.
+                    if (j.m_value.number_unsigned < 128)
+                    {
+                        // positive fixnum
+                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint8_t>::max)())
+                    {
+                        // uint 8
+                        oa->write_character(to_char_type(0xCC));
+                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint16_t>::max)())
+                    {
+                        // uint 16
+                        oa->write_character(to_char_type(0xCD));
+                        write_number(static_cast<std::uint16_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint32_t>::max)())
+                    {
+                        // uint 32
+                        oa->write_character(to_char_type(0xCE));
+                        write_number(static_cast<std::uint32_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint64_t>::max)())
+                    {
+                        // uint 64
+                        oa->write_character(to_char_type(0xCF));
+                        write_number(static_cast<std::uint64_t>(j.m_value.number_integer));
+                    }
+                }
+                else
+                {
+                    if (j.m_value.number_integer >= -32)
+                    {
+                        // negative fixnum
+                        write_number(static_cast<std::int8_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int8_t>::min)() &&
+                             j.m_value.number_integer <= (std::numeric_limits<std::int8_t>::max)())
+                    {
+                        // int 8
+                        oa->write_character(to_char_type(0xD0));
+                        write_number(static_cast<std::int8_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int16_t>::min)() &&
+                             j.m_value.number_integer <= (std::numeric_limits<std::int16_t>::max)())
+                    {
+                        // int 16
+                        oa->write_character(to_char_type(0xD1));
+                        write_number(static_cast<std::int16_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int32_t>::min)() &&
+                             j.m_value.number_integer <= (std::numeric_limits<std::int32_t>::max)())
+                    {
+                        // int 32
+                        oa->write_character(to_char_type(0xD2));
+                        write_number(static_cast<std::int32_t>(j.m_value.number_integer));
+                    }
+                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int64_t>::min)() &&
+                             j.m_value.number_integer <= (std::numeric_limits<std::int64_t>::max)())
+                    {
+                        // int 64
+                        oa->write_character(to_char_type(0xD3));
+                        write_number(static_cast<std::int64_t>(j.m_value.number_integer));
+                    }
+                }
+                break;
+            }
+
+            case value_t::number_unsigned:
+            {
+                if (j.m_value.number_unsigned < 128)
+                {
+                    // positive fixnum
+                    write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
+                }
+                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    // uint 8
+                    oa->write_character(to_char_type(0xCC));
+                    write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
+                }
+                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    // uint 16
+                    oa->write_character(to_char_type(0xCD));
+                    write_number(static_cast<std::uint16_t>(j.m_value.number_integer));
+                }
+                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    // uint 32
+                    oa->write_character(to_char_type(0xCE));
+                    write_number(static_cast<std::uint32_t>(j.m_value.number_integer));
+                }
+                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint64_t>::max)())
+                {
+                    // uint 64
+                    oa->write_character(to_char_type(0xCF));
+                    write_number(static_cast<std::uint64_t>(j.m_value.number_integer));
+                }
+                break;
+            }
+
+            case value_t::number_float:
+            {
+                write_compact_float(j.m_value.number_float, detail::input_format_t::msgpack);
+                break;
+            }
+
+            case value_t::string:
+            {
+                // step 1: write control byte and the string length
+                const auto N = j.m_value.string->size();
+                if (N <= 31)
+                {
+                    // fixstr
+                    write_number(static_cast<std::uint8_t>(0xA0 | N));
+                }
+                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    // str 8
+                    oa->write_character(to_char_type(0xD9));
+                    write_number(static_cast<std::uint8_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    // str 16
+                    oa->write_character(to_char_type(0xDA));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    // str 32
+                    oa->write_character(to_char_type(0xDB));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+
+                // step 2: write the string
+                oa->write_characters(
+                    reinterpret_cast<const CharType*>(j.m_value.string->c_str()),
+                    j.m_value.string->size());
+                break;
+            }
+
+            case value_t::array:
+            {
+                // step 1: write control byte and the array size
+                const auto N = j.m_value.array->size();
+                if (N <= 15)
+                {
+                    // fixarray
+                    write_number(static_cast<std::uint8_t>(0x90 | N));
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    // array 16
+                    oa->write_character(to_char_type(0xDC));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    // array 32
+                    oa->write_character(to_char_type(0xDD));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+
+                // step 2: write each element
+                for (const auto& el : *j.m_value.array)
+                {
+                    write_msgpack(el);
+                }
+                break;
+            }
+
+            case value_t::binary:
+            {
+                // step 0: determine if the binary type has a set subtype to
+                // determine whether or not to use the ext or fixext types
+                const bool use_ext = j.m_value.binary->has_subtype();
+
+                // step 1: write control byte and the byte string length
+                const auto N = j.m_value.binary->size();
+                if (N <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    std::uint8_t output_type{};
+                    bool fixed = true;
+                    if (use_ext)
+                    {
+                        switch (N)
+                        {
+                            case 1:
+                                output_type = 0xD4; // fixext 1
+                                break;
+                            case 2:
+                                output_type = 0xD5; // fixext 2
+                                break;
+                            case 4:
+                                output_type = 0xD6; // fixext 4
+                                break;
+                            case 8:
+                                output_type = 0xD7; // fixext 8
+                                break;
+                            case 16:
+                                output_type = 0xD8; // fixext 16
+                                break;
+                            default:
+                                output_type = 0xC7; // ext 8
+                                fixed = false;
+                                break;
+                        }
+
+                    }
+                    else
+                    {
+                        output_type = 0xC4; // bin 8
+                        fixed = false;
+                    }
+
+                    oa->write_character(to_char_type(output_type));
+                    if (!fixed)
+                    {
+                        write_number(static_cast<std::uint8_t>(N));
+                    }
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    std::uint8_t output_type = use_ext
+                                               ? 0xC8 // ext 16
+                                               : 0xC5; // bin 16
+
+                    oa->write_character(to_char_type(output_type));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    std::uint8_t output_type = use_ext
+                                               ? 0xC9 // ext 32
+                                               : 0xC6; // bin 32
+
+                    oa->write_character(to_char_type(output_type));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+
+                // step 1.5: if this is an ext type, write the subtype
+                if (use_ext)
+                {
+                    write_number(static_cast<std::int8_t>(j.m_value.binary->subtype()));
+                }
+
+                // step 2: write the byte string
+                oa->write_characters(
+                    reinterpret_cast<const CharType*>(j.m_value.binary->data()),
+                    N);
+
+                break;
+            }
+
+            case value_t::object:
+            {
+                // step 1: write control byte and the object size
+                const auto N = j.m_value.object->size();
+                if (N <= 15)
+                {
+                    // fixmap
+                    write_number(static_cast<std::uint8_t>(0x80 | (N & 0xF)));
+                }
+                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
+                {
+                    // map 16
+                    oa->write_character(to_char_type(0xDE));
+                    write_number(static_cast<std::uint16_t>(N));
+                }
+                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
+                {
+                    // map 32
+                    oa->write_character(to_char_type(0xDF));
+                    write_number(static_cast<std::uint32_t>(N));
+                }
+
+                // step 2: write each element
+                for (const auto& el : *j.m_value.object)
+                {
+                    write_msgpack(el.first);
+                    write_msgpack(el.second);
+                }
+                break;
+            }
+
+            case value_t::discarded:
+            default:
+                break;
+        }
+    }
+
+    /*!
+    @param[in] j  JSON value to serialize
+    @param[in] use_count   whether to use '#' prefixes (optimized format)
+    @param[in] use_type    whether to use '$' prefixes (optimized format)
+    @param[in] add_prefix  whether prefixes need to be used for this value
+    */
+    void write_ubjson(const BasicJsonType& j, const bool use_count,
+                      const bool use_type, const bool add_prefix = true)
+    {
+        switch (j.type())
+        {
+            case value_t::null:
+            {
+                if (add_prefix)
+                {
+                    oa->write_character(to_char_type('Z'));
+                }
+                break;
+            }
+
+            case value_t::boolean:
+            {
+                if (add_prefix)
+                {
+                    oa->write_character(j.m_value.boolean
+                                        ? to_char_type('T')
+                                        : to_char_type('F'));
+                }
+                break;
+            }
+
+            case value_t::number_integer:
+            {
+                write_number_with_ubjson_prefix(j.m_value.number_integer, add_prefix);
+                break;
+            }
+
+            case value_t::number_unsigned:
+            {
+                write_number_with_ubjson_prefix(j.m_value.number_unsigned, add_prefix);
+                break;
+            }
+
+            case value_t::number_float:
+            {
+                write_number_with_ubjson_prefix(j.m_value.number_float, add_prefix);
+                break;
+            }
+
+            case value_t::string:
+            {
+                if (add_prefix)
+                {
+                    oa->write_character(to_char_type('S'));
+                }
+                write_number_with_ubjson_prefix(j.m_value.string->size(), true);
+                oa->write_characters(
+                    reinterpret_cast<const CharType*>(j.m_value.string->c_str()),
+                    j.m_value.string->size());
+                break;
+            }
+
+            case value_t::array:
+            {
+                if (add_prefix)
+                {
+                    oa->write_character(to_char_type('['));
+                }
+
+                bool prefix_required = true;
+                if (use_type && !j.m_value.array->empty())
+                {
+                    JSON_ASSERT(use_count);
+                    const CharType first_prefix = ubjson_prefix(j.front());
+                    const bool same_prefix = std::all_of(j.begin() + 1, j.end(),
+                                                         [this, first_prefix](const BasicJsonType & v)
+                    {
+                        return ubjson_prefix(v) == first_prefix;
+                    });
+
+                    if (same_prefix)
+                    {
+                        prefix_required = false;
+                        oa->write_character(to_char_type('$'));
+                        oa->write_character(first_prefix);
+                    }
+                }
+
+                if (use_count)
+                {
+                    oa->write_character(to_char_type('#'));
+                    write_number_with_ubjson_prefix(j.m_value.array->size(), true);
+                }
+
+                for (const auto& el : *j.m_value.array)
+                {
+                    write_ubjson(el, use_count, use_type, prefix_required);
+                }
+
+                if (!use_count)
+                {
+                    oa->write_character(to_char_type(']'));
+                }
+
+                break;
+            }
+
+            case value_t::binary:
+            {
+                if (add_prefix)
+                {
+                    oa->write_character(to_char_type('['));
+                }
+
+                if (use_type && !j.m_value.binary->empty())
+                {
+                    JSON_ASSERT(use_count);
+                    oa->write_character(to_char_type('$'));
+                    oa->write_character('U');
+                }
+
+                if (use_count)
+                {
+                    oa->write_character(to_char_type('#'));
+                    write_number_with_ubjson_prefix(j.m_value.binary->size(), true);
+                }
+
+                if (use_type)
+                {
+                    oa->write_characters(
+                        reinterpret_cast<const CharType*>(j.m_value.binary->data()),
+                        j.m_value.binary->size());
+                }
+                else
+                {
+                    for (size_t i = 0; i < j.m_value.binary->size(); ++i)
+                    {
+                        oa->write_character(to_char_type('U'));
+                        oa->write_character(j.m_value.binary->data()[i]);
+                    }
+                }
+
+                if (!use_count)
+                {
+                    oa->write_character(to_char_type(']'));
+                }
+
+                break;
+            }
+
+            case value_t::object:
+            {
+                if (add_prefix)
+                {
+                    oa->write_character(to_char_type('{'));
+                }
+
+                bool prefix_required = true;
+                if (use_type && !j.m_value.object->empty())
+                {
+                    JSON_ASSERT(use_count);
+                    const CharType first_prefix = ubjson_prefix(j.front());
+                    const bool same_prefix = std::all_of(j.begin(), j.end(),
+                                                         [this, first_prefix](const BasicJsonType & v)
+                    {
+                        return ubjson_prefix(v) == first_prefix;
+                    });
+
+                    if (same_prefix)
+                    {
+                        prefix_required = false;
+                        oa->write_character(to_char_type('$'));
+                        oa->write_character(first_prefix);
+                    }
+                }
+
+                if (use_count)
+                {
+                    oa->write_character(to_char_type('#'));
+                    write_number_with_ubjson_prefix(j.m_value.object->size(), true);
+                }
+
+                for (const auto& el : *j.m_value.object)
+                {
+                    write_number_with_ubjson_prefix(el.first.size(), true);
+                    oa->write_characters(
+                        reinterpret_cast<const CharType*>(el.first.c_str()),
+                        el.first.size());
+                    write_ubjson(el.second, use_count, use_type, prefix_required);
+                }
+
+                if (!use_count)
+                {
+                    oa->write_character(to_char_type('}'));
+                }
+
+                break;
+            }
+
+            case value_t::discarded:
+            default:
+                break;
+        }
+    }
+
+  private:
+    //////////
+    // BSON //
+    //////////
+
+    /*!
+    @return The size of a BSON document entry header, including the id marker
+            and the entry name size (and its null-terminator).
+    */
+    static std::size_t calc_bson_entry_header_size(const string_t& name, const BasicJsonType& j)
+    {
+        const auto it = name.find(static_cast<typename string_t::value_type>(0));
+        if (JSON_HEDLEY_UNLIKELY(it != BasicJsonType::string_t::npos))
+        {
+            JSON_THROW(out_of_range::create(409, "BSON key cannot contain code point U+0000 (at byte " + std::to_string(it) + ")", j));
+            static_cast<void>(j);
+        }
+
+        return /*id*/ 1ul + name.size() + /*zero-terminator*/1u;
+    }
+
+    /*!
+    @brief Writes the given @a element_type and @a name to the output adapter
+    */
+    void write_bson_entry_header(const string_t& name,
+                                 const std::uint8_t element_type)
+    {
+        oa->write_character(to_char_type(element_type)); // boolean
+        oa->write_characters(
+            reinterpret_cast<const CharType*>(name.c_str()),
+            name.size() + 1u);
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and boolean value @a value
+    */
+    void write_bson_boolean(const string_t& name,
+                            const bool value)
+    {
+        write_bson_entry_header(name, 0x08);
+        oa->write_character(value ? to_char_type(0x01) : to_char_type(0x00));
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and double value @a value
+    */
+    void write_bson_double(const string_t& name,
+                           const double value)
+    {
+        write_bson_entry_header(name, 0x01);
+        write_number<double, true>(value);
+    }
+
+    /*!
+    @return The size of the BSON-encoded string in @a value
+    */
+    static std::size_t calc_bson_string_size(const string_t& value)
+    {
+        return sizeof(std::int32_t) + value.size() + 1ul;
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and string value @a value
+    */
+    void write_bson_string(const string_t& name,
+                           const string_t& value)
+    {
+        write_bson_entry_header(name, 0x02);
+
+        write_number<std::int32_t, true>(static_cast<std::int32_t>(value.size() + 1ul));
+        oa->write_characters(
+            reinterpret_cast<const CharType*>(value.c_str()),
+            value.size() + 1);
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and null value
+    */
+    void write_bson_null(const string_t& name)
+    {
+        write_bson_entry_header(name, 0x0A);
+    }
+
+    /*!
+    @return The size of the BSON-encoded integer @a value
+    */
+    static std::size_t calc_bson_integer_size(const std::int64_t value)
+    {
+        return (std::numeric_limits<std::int32_t>::min)() <= value && value <= (std::numeric_limits<std::int32_t>::max)()
+               ? sizeof(std::int32_t)
+               : sizeof(std::int64_t);
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and integer @a value
+    */
+    void write_bson_integer(const string_t& name,
+                            const std::int64_t value)
+    {
+        if ((std::numeric_limits<std::int32_t>::min)() <= value && value <= (std::numeric_limits<std::int32_t>::max)())
+        {
+            write_bson_entry_header(name, 0x10); // int32
+            write_number<std::int32_t, true>(static_cast<std::int32_t>(value));
+        }
+        else
+        {
+            write_bson_entry_header(name, 0x12); // int64
+            write_number<std::int64_t, true>(static_cast<std::int64_t>(value));
+        }
+    }
+
+    /*!
+    @return The size of the BSON-encoded unsigned integer in @a j
+    */
+    static constexpr std::size_t calc_bson_unsigned_size(const std::uint64_t value) noexcept
+    {
+        return (value <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
+               ? sizeof(std::int32_t)
+               : sizeof(std::int64_t);
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and unsigned @a value
+    */
+    void write_bson_unsigned(const string_t& name,
+                             const BasicJsonType& j)
+    {
+        if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
+        {
+            write_bson_entry_header(name, 0x10 /* int32 */);
+            write_number<std::int32_t, true>(static_cast<std::int32_t>(j.m_value.number_unsigned));
+        }
+        else if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int64_t>::max)()))
+        {
+            write_bson_entry_header(name, 0x12 /* int64 */);
+            write_number<std::int64_t, true>(static_cast<std::int64_t>(j.m_value.number_unsigned));
+        }
+        else
+        {
+            JSON_THROW(out_of_range::create(407, "integer number " + std::to_string(j.m_value.number_unsigned) + " cannot be represented by BSON as it does not fit int64", j));
+        }
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and object @a value
+    */
+    void write_bson_object_entry(const string_t& name,
+                                 const typename BasicJsonType::object_t& value)
+    {
+        write_bson_entry_header(name, 0x03); // object
+        write_bson_object(value);
+    }
+
+    /*!
+    @return The size of the BSON-encoded array @a value
+    */
+    static std::size_t calc_bson_array_size(const typename BasicJsonType::array_t& value)
+    {
+        std::size_t array_index = 0ul;
+
+        const std::size_t embedded_document_size = std::accumulate(std::begin(value), std::end(value), static_cast<std::size_t>(0), [&array_index](std::size_t result, const typename BasicJsonType::array_t::value_type & el)
+        {
+            return result + calc_bson_element_size(std::to_string(array_index++), el);
+        });
+
+        return sizeof(std::int32_t) + embedded_document_size + 1ul;
+    }
+
+    /*!
+    @return The size of the BSON-encoded binary array @a value
+    */
+    static std::size_t calc_bson_binary_size(const typename BasicJsonType::binary_t& value)
+    {
+        return sizeof(std::int32_t) + value.size() + 1ul;
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and array @a value
+    */
+    void write_bson_array(const string_t& name,
+                          const typename BasicJsonType::array_t& value)
+    {
+        write_bson_entry_header(name, 0x04); // array
+        write_number<std::int32_t, true>(static_cast<std::int32_t>(calc_bson_array_size(value)));
+
+        std::size_t array_index = 0ul;
+
+        for (const auto& el : value)
+        {
+            write_bson_element(std::to_string(array_index++), el);
+        }
+
+        oa->write_character(to_char_type(0x00));
+    }
+
+    /*!
+    @brief Writes a BSON element with key @a name and binary value @a value
+    */
+    void write_bson_binary(const string_t& name,
+                           const binary_t& value)
+    {
+        write_bson_entry_header(name, 0x05);
+
+        write_number<std::int32_t, true>(static_cast<std::int32_t>(value.size()));
+        write_number(value.has_subtype() ? static_cast<std::uint8_t>(value.subtype()) : static_cast<std::uint8_t>(0x00));
+
+        oa->write_characters(reinterpret_cast<const CharType*>(value.data()), value.size());
+    }
+
+    /*!
+    @brief Calculates the size necessary to serialize the JSON value @a j with its @a name
+    @return The calculated size for the BSON document entry for @a j with the given @a name.
+    */
+    static std::size_t calc_bson_element_size(const string_t& name,
+            const BasicJsonType& j)
+    {
+        const auto header_size = calc_bson_entry_header_size(name, j);
+        switch (j.type())
+        {
+            case value_t::object:
+                return header_size + calc_bson_object_size(*j.m_value.object);
+
+            case value_t::array:
+                return header_size + calc_bson_array_size(*j.m_value.array);
+
+            case value_t::binary:
+                return header_size + calc_bson_binary_size(*j.m_value.binary);
+
+            case value_t::boolean:
+                return header_size + 1ul;
+
+            case value_t::number_float:
+                return header_size + 8ul;
+
+            case value_t::number_integer:
+                return header_size + calc_bson_integer_size(j.m_value.number_integer);
+
+            case value_t::number_unsigned:
+                return header_size + calc_bson_unsigned_size(j.m_value.number_unsigned);
+
+            case value_t::string:
+                return header_size + calc_bson_string_size(*j.m_value.string);
+
+            case value_t::null:
+                return header_size + 0ul;
+
+            // LCOV_EXCL_START
+            case value_t::discarded:
+            default:
+                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert)
+                return 0ul;
+                // LCOV_EXCL_STOP
+        }
+    }
+
+    /*!
+    @brief Serializes the JSON value @a j to BSON and associates it with the
+           key @a name.
+    @param name The name to associate with the JSON entity @a j within the
+                current BSON document
+    */
+    void write_bson_element(const string_t& name,
+                            const BasicJsonType& j)
+    {
+        switch (j.type())
+        {
+            case value_t::object:
+                return write_bson_object_entry(name, *j.m_value.object);
+
+            case value_t::array:
+                return write_bson_array(name, *j.m_value.array);
+
+            case value_t::binary:
+                return write_bson_binary(name, *j.m_value.binary);
+
+            case value_t::boolean:
+                return write_bson_boolean(name, j.m_value.boolean);
+
+            case value_t::number_float:
+                return write_bson_double(name, j.m_value.number_float);
+
+            case value_t::number_integer:
+                return write_bson_integer(name, j.m_value.number_integer);
+
+            case value_t::number_unsigned:
+                return write_bson_unsigned(name, j);
+
+            case value_t::string:
+                return write_bson_string(name, *j.m_value.string);
+
+            case value_t::null:
+                return write_bson_null(name);
+
+            // LCOV_EXCL_START
+            case value_t::discarded:
+            default:
+                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert)
+                return;
+                // LCOV_EXCL_STOP
+        }
+    }
+
+    /*!
+    @brief Calculates the size of the BSON serialization of the given
+           JSON-object @a j.
+    @param[in] value  JSON value to serialize
+    @pre       value.type() == value_t::object
+    */
+    static std::size_t calc_bson_object_size(const typename BasicJsonType::object_t& value)
+    {
+        std::size_t document_size = std::accumulate(value.begin(), value.end(), static_cast<std::size_t>(0),
+                                    [](size_t result, const typename BasicJsonType::object_t::value_type & el)
+        {
+            return result += calc_bson_element_size(el.first, el.second);
+        });
+
+        return sizeof(std::int32_t) + document_size + 1ul;
+    }
+
+    /*!
+    @param[in] value  JSON value to serialize
+    @pre       value.type() == value_t::object
+    */
+    void write_bson_object(const typename BasicJsonType::object_t& value)
+    {
+        write_number<std::int32_t, true>(static_cast<std::int32_t>(calc_bson_object_size(value)));
+
+        for (const auto& el : value)
+        {
+            write_bson_element(el.first, el.second);
+        }
+
+        oa->write_character(to_char_type(0x00));
+    }
+
+    //////////
+    // CBOR //
+    //////////
+
+    static constexpr CharType get_cbor_float_prefix(float /*unused*/)
+    {
+        return to_char_type(0xFA);  // Single-Precision Float
+    }
+
+    static constexpr CharType get_cbor_float_prefix(double /*unused*/)
+    {
+        return to_char_type(0xFB);  // Double-Precision Float
+    }
+
+    /////////////
+    // MsgPack //
+    /////////////
+
+    static constexpr CharType get_msgpack_float_prefix(float /*unused*/)
+    {
+        return to_char_type(0xCA);  // float 32
+    }
+
+    static constexpr CharType get_msgpack_float_prefix(double /*unused*/)
+    {
+        return to_char_type(0xCB);  // float 64
+    }
+
+    ////////////
+    // UBJSON //
+    ////////////
+
+    // UBJSON: write number (floating point)
+    template<typename NumberType, typename std::enable_if<
+                 std::is_floating_point<NumberType>::value, int>::type = 0>
+    void write_number_with_ubjson_prefix(const NumberType n,
+                                         const bool add_prefix)
+    {
+        if (add_prefix)
+        {
+            oa->write_character(get_ubjson_float_prefix(n));
+        }
+        write_number(n);
+    }
+
+    // UBJSON: write number (unsigned integer)
+    template<typename NumberType, typename std::enable_if<
+                 std::is_unsigned<NumberType>::value, int>::type = 0>
+    void write_number_with_ubjson_prefix(const NumberType n,
+                                         const bool add_prefix)
+    {
+        if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int8_t>::max)()))
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('i'));  // int8
+            }
+            write_number(static_cast<std::uint8_t>(n));
+        }
+        else if (n <= (std::numeric_limits<std::uint8_t>::max)())
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('U'));  // uint8
+            }
+            write_number(static_cast<std::uint8_t>(n));
+        }
+        else if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int16_t>::max)()))
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('I'));  // int16
+            }
+            write_number(static_cast<std::int16_t>(n));
+        }
+        else if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('l'));  // int32
+            }
+            write_number(static_cast<std::int32_t>(n));
+        }
+        else if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int64_t>::max)()))
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('L'));  // int64
+            }
+            write_number(static_cast<std::int64_t>(n));
+        }
+        else
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('H'));  // high-precision number
+            }
+
+            const auto number = BasicJsonType(n).dump();
+            write_number_with_ubjson_prefix(number.size(), true);
+            for (std::size_t i = 0; i < number.size(); ++i)
+            {
+                oa->write_character(to_char_type(static_cast<std::uint8_t>(number[i])));
+            }
+        }
+    }
+
+    // UBJSON: write number (signed integer)
+    template < typename NumberType, typename std::enable_if <
+                   std::is_signed<NumberType>::value&&
+                   !std::is_floating_point<NumberType>::value, int >::type = 0 >
+    void write_number_with_ubjson_prefix(const NumberType n,
+                                         const bool add_prefix)
+    {
+        if ((std::numeric_limits<std::int8_t>::min)() <= n && n <= (std::numeric_limits<std::int8_t>::max)())
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('i'));  // int8
+            }
+            write_number(static_cast<std::int8_t>(n));
+        }
+        else if (static_cast<std::int64_t>((std::numeric_limits<std::uint8_t>::min)()) <= n && n <= static_cast<std::int64_t>((std::numeric_limits<std::uint8_t>::max)()))
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('U'));  // uint8
+            }
+            write_number(static_cast<std::uint8_t>(n));
+        }
+        else if ((std::numeric_limits<std::int16_t>::min)() <= n && n <= (std::numeric_limits<std::int16_t>::max)())
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('I'));  // int16
+            }
+            write_number(static_cast<std::int16_t>(n));
+        }
+        else if ((std::numeric_limits<std::int32_t>::min)() <= n && n <= (std::numeric_limits<std::int32_t>::max)())
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('l'));  // int32
+            }
+            write_number(static_cast<std::int32_t>(n));
+        }
+        else if ((std::numeric_limits<std::int64_t>::min)() <= n && n <= (std::numeric_limits<std::int64_t>::max)())
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('L'));  // int64
+            }
+            write_number(static_cast<std::int64_t>(n));
+        }
+        // LCOV_EXCL_START
+        else
+        {
+            if (add_prefix)
+            {
+                oa->write_character(to_char_type('H'));  // high-precision number
+            }
+
+            const auto number = BasicJsonType(n).dump();
+            write_number_with_ubjson_prefix(number.size(), true);
+            for (std::size_t i = 0; i < number.size(); ++i)
+            {
+                oa->write_character(to_char_type(static_cast<std::uint8_t>(number[i])));
+            }
+        }
+        // LCOV_EXCL_STOP
+    }
+
+    /*!
+    @brief determine the type prefix of container values
+    */
+    CharType ubjson_prefix(const BasicJsonType& j) const noexcept
+    {
+        switch (j.type())
+        {
+            case value_t::null:
+                return 'Z';
+
+            case value_t::boolean:
+                return j.m_value.boolean ? 'T' : 'F';
+
+            case value_t::number_integer:
+            {
+                if ((std::numeric_limits<std::int8_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int8_t>::max)())
+                {
+                    return 'i';
+                }
+                if ((std::numeric_limits<std::uint8_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::uint8_t>::max)())
+                {
+                    return 'U';
+                }
+                if ((std::numeric_limits<std::int16_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int16_t>::max)())
+                {
+                    return 'I';
+                }
+                if ((std::numeric_limits<std::int32_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int32_t>::max)())
+                {
+                    return 'l';
+                }
+                if ((std::numeric_limits<std::int64_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int64_t>::max)())
+                {
+                    return 'L';
+                }
+                // anything else is treated as high-precision number
+                return 'H'; // LCOV_EXCL_LINE
+            }
+
+            case value_t::number_unsigned:
+            {
+                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int8_t>::max)()))
+                {
+                    return 'i';
+                }
+                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::uint8_t>::max)()))
+                {
+                    return 'U';
+                }
+                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int16_t>::max)()))
+                {
+                    return 'I';
+                }
+                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
+                {
+                    return 'l';
+                }
+                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int64_t>::max)()))
+                {
+                    return 'L';
+                }
+                // anything else is treated as high-precision number
+                return 'H'; // LCOV_EXCL_LINE
+            }
+
+            case value_t::number_float:
+                return get_ubjson_float_prefix(j.m_value.number_float);
+
+            case value_t::string:
+                return 'S';
+
+            case value_t::array: // fallthrough
+            case value_t::binary:
+                return '[';
+
+            case value_t::object:
+                return '{';
+
+            case value_t::discarded:
+            default:  // discarded values
+                return 'N';
+        }
+    }
+
+    static constexpr CharType get_ubjson_float_prefix(float /*unused*/)
+    {
+        return 'd';  // float 32
+    }
+
+    static constexpr CharType get_ubjson_float_prefix(double /*unused*/)
+    {
+        return 'D';  // float 64
+    }
+
+    ///////////////////////
+    // Utility functions //
+    ///////////////////////
+
+    /*
+    @brief write a number to output input
+    @param[in] n number of type @a NumberType
+    @tparam NumberType the type of the number
+    @tparam OutputIsLittleEndian Set to true if output data is
+                                 required to be little endian
+
+    @note This function needs to respect the system's endianness, because bytes
+          in CBOR, MessagePack, and UBJSON are stored in network order (big
+          endian) and therefore need reordering on little endian systems.
+    */
+    template<typename NumberType, bool OutputIsLittleEndian = false>
+    void write_number(const NumberType n)
+    {
+        // step 1: write number to array of length NumberType
+        std::array<CharType, sizeof(NumberType)> vec{};
+        std::memcpy(vec.data(), &n, sizeof(NumberType));
+
+        // step 2: write array to output (with possible reordering)
+        if (is_little_endian != OutputIsLittleEndian)
+        {
+            // reverse byte order prior to conversion if necessary
+            std::reverse(vec.begin(), vec.end());
+        }
+
+        oa->write_characters(vec.data(), sizeof(NumberType));
+    }
+
+    void write_compact_float(const number_float_t n, detail::input_format_t format)
+    {
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wfloat-equal"
+#endif
+        if (static_cast<double>(n) >= static_cast<double>(std::numeric_limits<float>::lowest()) &&
+                static_cast<double>(n) <= static_cast<double>((std::numeric_limits<float>::max)()) &&
+                static_cast<double>(static_cast<float>(n)) == static_cast<double>(n))
+        {
+            oa->write_character(format == detail::input_format_t::cbor
+                                ? get_cbor_float_prefix(static_cast<float>(n))
+                                : get_msgpack_float_prefix(static_cast<float>(n)));
+            write_number(static_cast<float>(n));
+        }
+        else
+        {
+            oa->write_character(format == detail::input_format_t::cbor
+                                ? get_cbor_float_prefix(n)
+                                : get_msgpack_float_prefix(n));
+            write_number(n);
+        }
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+    }
+
+  public:
+    // The following to_char_type functions are implement the conversion
+    // between uint8_t and CharType. In case CharType is not unsigned,
+    // such a conversion is required to allow values greater than 128.
+    // See <https://github.com/nlohmann/json/issues/1286> for a discussion.
+    template < typename C = CharType,
+               enable_if_t < std::is_signed<C>::value && std::is_signed<char>::value > * = nullptr >
+    static constexpr CharType to_char_type(std::uint8_t x) noexcept
+    {
+        return *reinterpret_cast<char*>(&x);
+    }
+
+    template < typename C = CharType,
+               enable_if_t < std::is_signed<C>::value && std::is_unsigned<char>::value > * = nullptr >
+    static CharType to_char_type(std::uint8_t x) noexcept
+    {
+        static_assert(sizeof(std::uint8_t) == sizeof(CharType), "size of CharType must be equal to std::uint8_t");
+        static_assert(std::is_trivial<CharType>::value, "CharType must be trivial");
+        CharType result;
+        std::memcpy(&result, &x, sizeof(x));
+        return result;
+    }
+
+    template<typename C = CharType,
+             enable_if_t<std::is_unsigned<C>::value>* = nullptr>
+    static constexpr CharType to_char_type(std::uint8_t x) noexcept
+    {
+        return x;
+    }
+
+    template < typename InputCharType, typename C = CharType,
+               enable_if_t <
+                   std::is_signed<C>::value &&
+                   std::is_signed<char>::value &&
+                   std::is_same<char, typename std::remove_cv<InputCharType>::type>::value
+                   > * = nullptr >
+    static constexpr CharType to_char_type(InputCharType x) noexcept
+    {
+        return x;
+    }
+
+  private:
+    /// whether we can assume little endianness
+    const bool is_little_endian = little_endianness();
+
+    /// the output
+    output_adapter_t<CharType> oa = nullptr;
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/output/output_adapters.hpp>
+
+// #include <nlohmann/detail/output/serializer.hpp>
+
+
+#include <algorithm> // reverse, remove, fill, find, none_of
+#include <array> // array
+#include <clocale> // localeconv, lconv
+#include <cmath> // labs, isfinite, isnan, signbit
+#include <cstddef> // size_t, ptrdiff_t
+#include <cstdint> // uint8_t
+#include <cstdio> // snprintf
+#include <limits> // numeric_limits
+#include <string> // string, char_traits
+#include <iomanip> // setfill, setw
+#include <sstream> // stringstream
+#include <type_traits> // is_same
+#include <utility> // move
+
+// #include <nlohmann/detail/conversions/to_chars.hpp>
+
+
+#include <array> // array
+#include <cmath>   // signbit, isfinite
+#include <cstdint> // intN_t, uintN_t
+#include <cstring> // memcpy, memmove
+#include <limits> // numeric_limits
+#include <type_traits> // conditional
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+
+/*!
+@brief implements the Grisu2 algorithm for binary to decimal floating-point
+conversion.
+
+This implementation is a slightly modified version of the reference
+implementation which may be obtained from
+http://florian.loitsch.com/publications (bench.tar.gz).
+
+The code is distributed under the MIT license, Copyright (c) 2009 Florian Loitsch.
+
+For a detailed description of the algorithm see:
+
+[1] Loitsch, "Printing Floating-Point Numbers Quickly and Accurately with
+    Integers", Proceedings of the ACM SIGPLAN 2010 Conference on Programming
+    Language Design and Implementation, PLDI 2010
+[2] Burger, Dybvig, "Printing Floating-Point Numbers Quickly and Accurately",
+    Proceedings of the ACM SIGPLAN 1996 Conference on Programming Language
+    Design and Implementation, PLDI 1996
+*/
+namespace dtoa_impl
+{
+
+template<typename Target, typename Source>
+Target reinterpret_bits(const Source source)
+{
+    static_assert(sizeof(Target) == sizeof(Source), "size mismatch");
+
+    Target target;
+    std::memcpy(&target, &source, sizeof(Source));
+    return target;
+}
+
+struct diyfp // f * 2^e
+{
+    static constexpr int kPrecision = 64; // = q
+
+    std::uint64_t f = 0;
+    int e = 0;
+
+    constexpr diyfp(std::uint64_t f_, int e_) noexcept : f(f_), e(e_) {}
+
+    /*!
+    @brief returns x - y
+    @pre x.e == y.e and x.f >= y.f
+    */
+    static diyfp sub(const diyfp& x, const diyfp& y) noexcept
+    {
+        JSON_ASSERT(x.e == y.e);
+        JSON_ASSERT(x.f >= y.f);
+
+        return {x.f - y.f, x.e};
+    }
+
+    /*!
+    @brief returns x * y
+    @note The result is rounded. (Only the upper q bits are returned.)
+    */
+    static diyfp mul(const diyfp& x, const diyfp& y) noexcept
+    {
+        static_assert(kPrecision == 64, "internal error");
+
+        // Computes:
+        //  f = round((x.f * y.f) / 2^q)
+        //  e = x.e + y.e + q
+
+        // Emulate the 64-bit * 64-bit multiplication:
+        //
+        // p = u * v
+        //   = (u_lo + 2^32 u_hi) (v_lo + 2^32 v_hi)
+        //   = (u_lo v_lo         ) + 2^32 ((u_lo v_hi         ) + (u_hi v_lo         )) + 2^64 (u_hi v_hi         )
+        //   = (p0                ) + 2^32 ((p1                ) + (p2                )) + 2^64 (p3                )
+        //   = (p0_lo + 2^32 p0_hi) + 2^32 ((p1_lo + 2^32 p1_hi) + (p2_lo + 2^32 p2_hi)) + 2^64 (p3                )
+        //   = (p0_lo             ) + 2^32 (p0_hi + p1_lo + p2_lo                      ) + 2^64 (p1_hi + p2_hi + p3)
+        //   = (p0_lo             ) + 2^32 (Q                                          ) + 2^64 (H                 )
+        //   = (p0_lo             ) + 2^32 (Q_lo + 2^32 Q_hi                           ) + 2^64 (H                 )
+        //
+        // (Since Q might be larger than 2^32 - 1)
+        //
+        //   = (p0_lo + 2^32 Q_lo) + 2^64 (Q_hi + H)
+        //
+        // (Q_hi + H does not overflow a 64-bit int)
+        //
+        //   = p_lo + 2^64 p_hi
+
+        const std::uint64_t u_lo = x.f & 0xFFFFFFFFu;
+        const std::uint64_t u_hi = x.f >> 32u;
+        const std::uint64_t v_lo = y.f & 0xFFFFFFFFu;
+        const std::uint64_t v_hi = y.f >> 32u;
+
+        const std::uint64_t p0 = u_lo * v_lo;
+        const std::uint64_t p1 = u_lo * v_hi;
+        const std::uint64_t p2 = u_hi * v_lo;
+        const std::uint64_t p3 = u_hi * v_hi;
+
+        const std::uint64_t p0_hi = p0 >> 32u;
+        const std::uint64_t p1_lo = p1 & 0xFFFFFFFFu;
+        const std::uint64_t p1_hi = p1 >> 32u;
+        const std::uint64_t p2_lo = p2 & 0xFFFFFFFFu;
+        const std::uint64_t p2_hi = p2 >> 32u;
+
+        std::uint64_t Q = p0_hi + p1_lo + p2_lo;
+
+        // The full product might now be computed as
+        //
+        // p_hi = p3 + p2_hi + p1_hi + (Q >> 32)
+        // p_lo = p0_lo + (Q << 32)
+        //
+        // But in this particular case here, the full p_lo is not required.
+        // Effectively we only need to add the highest bit in p_lo to p_hi (and
+        // Q_hi + 1 does not overflow).
+
+        Q += std::uint64_t{1} << (64u - 32u - 1u); // round, ties up
+
+        const std::uint64_t h = p3 + p2_hi + p1_hi + (Q >> 32u);
+
+        return {h, x.e + y.e + 64};
+    }
+
+    /*!
+    @brief normalize x such that the significand is >= 2^(q-1)
+    @pre x.f != 0
+    */
+    static diyfp normalize(diyfp x) noexcept
+    {
+        JSON_ASSERT(x.f != 0);
+
+        while ((x.f >> 63u) == 0)
+        {
+            x.f <<= 1u;
+            x.e--;
+        }
+
+        return x;
+    }
+
+    /*!
+    @brief normalize x such that the result has the exponent E
+    @pre e >= x.e and the upper e - x.e bits of x.f must be zero.
+    */
+    static diyfp normalize_to(const diyfp& x, const int target_exponent) noexcept
+    {
+        const int delta = x.e - target_exponent;
+
+        JSON_ASSERT(delta >= 0);
+        JSON_ASSERT(((x.f << delta) >> delta) == x.f);
+
+        return {x.f << delta, target_exponent};
+    }
+};
+
+struct boundaries
+{
+    diyfp w;
+    diyfp minus;
+    diyfp plus;
+};
+
+/*!
+Compute the (normalized) diyfp representing the input number 'value' and its
+boundaries.
+
+@pre value must be finite and positive
+*/
+template<typename FloatType>
+boundaries compute_boundaries(FloatType value)
+{
+    JSON_ASSERT(std::isfinite(value));
+    JSON_ASSERT(value > 0);
+
+    // Convert the IEEE representation into a diyfp.
+    //
+    // If v is denormal:
+    //      value = 0.F * 2^(1 - bias) = (          F) * 2^(1 - bias - (p-1))
+    // If v is normalized:
+    //      value = 1.F * 2^(E - bias) = (2^(p-1) + F) * 2^(E - bias - (p-1))
+
+    static_assert(std::numeric_limits<FloatType>::is_iec559,
+                  "internal error: dtoa_short requires an IEEE-754 floating-point implementation");
+
+    constexpr int      kPrecision = std::numeric_limits<FloatType>::digits; // = p (includes the hidden bit)
+    constexpr int      kBias      = std::numeric_limits<FloatType>::max_exponent - 1 + (kPrecision - 1);
+    constexpr int      kMinExp    = 1 - kBias;
+    constexpr std::uint64_t kHiddenBit = std::uint64_t{1} << (kPrecision - 1); // = 2^(p-1)
+
+    using bits_type = typename std::conditional<kPrecision == 24, std::uint32_t, std::uint64_t >::type;
+
+    const auto bits = static_cast<std::uint64_t>(reinterpret_bits<bits_type>(value));
+    const std::uint64_t E = bits >> (kPrecision - 1);
+    const std::uint64_t F = bits & (kHiddenBit - 1);
+
+    const bool is_denormal = E == 0;
+    const diyfp v = is_denormal
+                    ? diyfp(F, kMinExp)
+                    : diyfp(F + kHiddenBit, static_cast<int>(E) - kBias);
+
+    // Compute the boundaries m- and m+ of the floating-point value
+    // v = f * 2^e.
+    //
+    // Determine v- and v+, the floating-point predecessor and successor if v,
+    // respectively.
+    //
+    //      v- = v - 2^e        if f != 2^(p-1) or e == e_min                (A)
+    //         = v - 2^(e-1)    if f == 2^(p-1) and e > e_min                (B)
+    //
+    //      v+ = v + 2^e
+    //
+    // Let m- = (v- + v) / 2 and m+ = (v + v+) / 2. All real numbers _strictly_
+    // between m- and m+ round to v, regardless of how the input rounding
+    // algorithm breaks ties.
+    //
+    //      ---+-------------+-------------+-------------+-------------+---  (A)
+    //         v-            m-            v             m+            v+
+    //
+    //      -----------------+------+------+-------------+-------------+---  (B)
+    //                       v-     m-     v             m+            v+
+
+    const bool lower_boundary_is_closer = F == 0 && E > 1;
+    const diyfp m_plus = diyfp(2 * v.f + 1, v.e - 1);
+    const diyfp m_minus = lower_boundary_is_closer
+                          ? diyfp(4 * v.f - 1, v.e - 2)  // (B)
+                          : diyfp(2 * v.f - 1, v.e - 1); // (A)
+
+    // Determine the normalized w+ = m+.
+    const diyfp w_plus = diyfp::normalize(m_plus);
+
+    // Determine w- = m- such that e_(w-) = e_(w+).
+    const diyfp w_minus = diyfp::normalize_to(m_minus, w_plus.e);
+
+    return {diyfp::normalize(v), w_minus, w_plus};
+}
+
+// Given normalized diyfp w, Grisu needs to find a (normalized) cached
+// power-of-ten c, such that the exponent of the product c * w = f * 2^e lies
+// within a certain range [alpha, gamma] (Definition 3.2 from [1])
+//
+//      alpha <= e = e_c + e_w + q <= gamma
+//
+// or
+//
+//      f_c * f_w * 2^alpha <= f_c 2^(e_c) * f_w 2^(e_w) * 2^q
+//                          <= f_c * f_w * 2^gamma
+//
+// Since c and w are normalized, i.e. 2^(q-1) <= f < 2^q, this implies
+//
+//      2^(q-1) * 2^(q-1) * 2^alpha <= c * w * 2^q < 2^q * 2^q * 2^gamma
+//
+// or
+//
+//      2^(q - 2 + alpha) <= c * w < 2^(q + gamma)
+//
+// The choice of (alpha,gamma) determines the size of the table and the form of
+// the digit generation procedure. Using (alpha,gamma)=(-60,-32) works out well
+// in practice:
+//
+// The idea is to cut the number c * w = f * 2^e into two parts, which can be
+// processed independently: An integral part p1, and a fractional part p2:
+//
+//      f * 2^e = ( (f div 2^-e) * 2^-e + (f mod 2^-e) ) * 2^e
+//              = (f div 2^-e) + (f mod 2^-e) * 2^e
+//              = p1 + p2 * 2^e
+//
+// The conversion of p1 into decimal form requires a series of divisions and
+// modulos by (a power of) 10. These operations are faster for 32-bit than for
+// 64-bit integers, so p1 should ideally fit into a 32-bit integer. This can be
+// achieved by choosing
+//
+//      -e >= 32   or   e <= -32 := gamma
+//
+// In order to convert the fractional part
+//
+//      p2 * 2^e = p2 / 2^-e = d[-1] / 10^1 + d[-2] / 10^2 + ...
+//
+// into decimal form, the fraction is repeatedly multiplied by 10 and the digits
+// d[-i] are extracted in order:
+//
+//      (10 * p2) div 2^-e = d[-1]
+//      (10 * p2) mod 2^-e = d[-2] / 10^1 + ...
+//
+// The multiplication by 10 must not overflow. It is sufficient to choose
+//
+//      10 * p2 < 16 * p2 = 2^4 * p2 <= 2^64.
+//
+// Since p2 = f mod 2^-e < 2^-e,
+//
+//      -e <= 60   or   e >= -60 := alpha
+
+constexpr int kAlpha = -60;
+constexpr int kGamma = -32;
+
+struct cached_power // c = f * 2^e ~= 10^k
+{
+    std::uint64_t f;
+    int e;
+    int k;
+};
+
+/*!
+For a normalized diyfp w = f * 2^e, this function returns a (normalized) cached
+power-of-ten c = f_c * 2^e_c, such that the exponent of the product w * c
+satisfies (Definition 3.2 from [1])
+
+     alpha <= e_c + e + q <= gamma.
+*/
+inline cached_power get_cached_power_for_binary_exponent(int e)
+{
+    // Now
+    //
+    //      alpha <= e_c + e + q <= gamma                                    (1)
+    //      ==> f_c * 2^alpha <= c * 2^e * 2^q
+    //
+    // and since the c's are normalized, 2^(q-1) <= f_c,
+    //
+    //      ==> 2^(q - 1 + alpha) <= c * 2^(e + q)
+    //      ==> 2^(alpha - e - 1) <= c
+    //
+    // If c were an exact power of ten, i.e. c = 10^k, one may determine k as
+    //
+    //      k = ceil( log_10( 2^(alpha - e - 1) ) )
+    //        = ceil( (alpha - e - 1) * log_10(2) )
+    //
+    // From the paper:
+    // "In theory the result of the procedure could be wrong since c is rounded,
+    //  and the computation itself is approximated [...]. In practice, however,
+    //  this simple function is sufficient."
+    //
+    // For IEEE double precision floating-point numbers converted into
+    // normalized diyfp's w = f * 2^e, with q = 64,
+    //
+    //      e >= -1022      (min IEEE exponent)
+    //           -52        (p - 1)
+    //           -52        (p - 1, possibly normalize denormal IEEE numbers)
+    //           -11        (normalize the diyfp)
+    //         = -1137
+    //
+    // and
+    //
+    //      e <= +1023      (max IEEE exponent)
+    //           -52        (p - 1)
+    //           -11        (normalize the diyfp)
+    //         = 960
+    //
+    // This binary exponent range [-1137,960] results in a decimal exponent
+    // range [-307,324]. One does not need to store a cached power for each
+    // k in this range. For each such k it suffices to find a cached power
+    // such that the exponent of the product lies in [alpha,gamma].
+    // This implies that the difference of the decimal exponents of adjacent
+    // table entries must be less than or equal to
+    //
+    //      floor( (gamma - alpha) * log_10(2) ) = 8.
+    //
+    // (A smaller distance gamma-alpha would require a larger table.)
+
+    // NB:
+    // Actually this function returns c, such that -60 <= e_c + e + 64 <= -34.
+
+    constexpr int kCachedPowersMinDecExp = -300;
+    constexpr int kCachedPowersDecStep = 8;
+
+    static constexpr std::array<cached_power, 79> kCachedPowers =
+    {
+        {
+            { 0xAB70FE17C79AC6CA, -1060, -300 },
+            { 0xFF77B1FCBEBCDC4F, -1034, -292 },
+            { 0xBE5691EF416BD60C, -1007, -284 },
+            { 0x8DD01FAD907FFC3C,  -980, -276 },
+            { 0xD3515C2831559A83,  -954, -268 },
+            { 0x9D71AC8FADA6C9B5,  -927, -260 },
+            { 0xEA9C227723EE8BCB,  -901, -252 },
+            { 0xAECC49914078536D,  -874, -244 },
+            { 0x823C12795DB6CE57,  -847, -236 },
+            { 0xC21094364DFB5637,  -821, -228 },
+            { 0x9096EA6F3848984F,  -794, -220 },
+            { 0xD77485CB25823AC7,  -768, -212 },
+            { 0xA086CFCD97BF97F4,  -741, -204 },
+            { 0xEF340A98172AACE5,  -715, -196 },
+            { 0xB23867FB2A35B28E,  -688, -188 },
+            { 0x84C8D4DFD2C63F3B,  -661, -180 },
+            { 0xC5DD44271AD3CDBA,  -635, -172 },
+            { 0x936B9FCEBB25C996,  -608, -164 },
+            { 0xDBAC6C247D62A584,  -582, -156 },
+            { 0xA3AB66580D5FDAF6,  -555, -148 },
+            { 0xF3E2F893DEC3F126,  -529, -140 },
+            { 0xB5B5ADA8AAFF80B8,  -502, -132 },
+            { 0x87625F056C7C4A8B,  -475, -124 },
+            { 0xC9BCFF6034C13053,  -449, -116 },
+            { 0x964E858C91BA2655,  -422, -108 },
+            { 0xDFF9772470297EBD,  -396, -100 },
+            { 0xA6DFBD9FB8E5B88F,  -369,  -92 },
+            { 0xF8A95FCF88747D94,  -343,  -84 },
+            { 0xB94470938FA89BCF,  -316,  -76 },
+            { 0x8A08F0F8BF0F156B,  -289,  -68 },
+            { 0xCDB02555653131B6,  -263,  -60 },
+            { 0x993FE2C6D07B7FAC,  -236,  -52 },
+            { 0xE45C10C42A2B3B06,  -210,  -44 },
+            { 0xAA242499697392D3,  -183,  -36 },
+            { 0xFD87B5F28300CA0E,  -157,  -28 },
+            { 0xBCE5086492111AEB,  -130,  -20 },
+            { 0x8CBCCC096F5088CC,  -103,  -12 },
+            { 0xD1B71758E219652C,   -77,   -4 },
+            { 0x9C40000000000000,   -50,    4 },
+            { 0xE8D4A51000000000,   -24,   12 },
+            { 0xAD78EBC5AC620000,     3,   20 },
+            { 0x813F3978F8940984,    30,   28 },
+            { 0xC097CE7BC90715B3,    56,   36 },
+            { 0x8F7E32CE7BEA5C70,    83,   44 },
+            { 0xD5D238A4ABE98068,   109,   52 },
+            { 0x9F4F2726179A2245,   136,   60 },
+            { 0xED63A231D4C4FB27,   162,   68 },
+            { 0xB0DE65388CC8ADA8,   189,   76 },
+            { 0x83C7088E1AAB65DB,   216,   84 },
+            { 0xC45D1DF942711D9A,   242,   92 },
+            { 0x924D692CA61BE758,   269,  100 },
+            { 0xDA01EE641A708DEA,   295,  108 },
+            { 0xA26DA3999AEF774A,   322,  116 },
+            { 0xF209787BB47D6B85,   348,  124 },
+            { 0xB454E4A179DD1877,   375,  132 },
+            { 0x865B86925B9BC5C2,   402,  140 },
+            { 0xC83553C5C8965D3D,   428,  148 },
+            { 0x952AB45CFA97A0B3,   455,  156 },
+            { 0xDE469FBD99A05FE3,   481,  164 },
+            { 0xA59BC234DB398C25,   508,  172 },
+            { 0xF6C69A72A3989F5C,   534,  180 },
+            { 0xB7DCBF5354E9BECE,   561,  188 },
+            { 0x88FCF317F22241E2,   588,  196 },
+            { 0xCC20CE9BD35C78A5,   614,  204 },
+            { 0x98165AF37B2153DF,   641,  212 },
+            { 0xE2A0B5DC971F303A,   667,  220 },
+            { 0xA8D9D1535CE3B396,   694,  228 },
+            { 0xFB9B7CD9A4A7443C,   720,  236 },
+            { 0xBB764C4CA7A44410,   747,  244 },
+            { 0x8BAB8EEFB6409C1A,   774,  252 },
+            { 0xD01FEF10A657842C,   800,  260 },
+            { 0x9B10A4E5E9913129,   827,  268 },
+            { 0xE7109BFBA19C0C9D,   853,  276 },
+            { 0xAC2820D9623BF429,   880,  284 },
+            { 0x80444B5E7AA7CF85,   907,  292 },
+            { 0xBF21E44003ACDD2D,   933,  300 },
+            { 0x8E679C2F5E44FF8F,   960,  308 },
+            { 0xD433179D9C8CB841,   986,  316 },
+            { 0x9E19DB92B4E31BA9,  1013,  324 },
+        }
+    };
+
+    // This computation gives exactly the same results for k as
+    //      k = ceil((kAlpha - e - 1) * 0.30102999566398114)
+    // for |e| <= 1500, but doesn't require floating-point operations.
+    // NB: log_10(2) ~= 78913 / 2^18
+    JSON_ASSERT(e >= -1500);
+    JSON_ASSERT(e <=  1500);
+    const int f = kAlpha - e - 1;
+    const int k = (f * 78913) / (1 << 18) + static_cast<int>(f > 0);
+
+    const int index = (-kCachedPowersMinDecExp + k + (kCachedPowersDecStep - 1)) / kCachedPowersDecStep;
+    JSON_ASSERT(index >= 0);
+    JSON_ASSERT(static_cast<std::size_t>(index) < kCachedPowers.size());
+
+    const cached_power cached = kCachedPowers[static_cast<std::size_t>(index)];
+    JSON_ASSERT(kAlpha <= cached.e + e + 64);
+    JSON_ASSERT(kGamma >= cached.e + e + 64);
+
+    return cached;
+}
+
+/*!
+For n != 0, returns k, such that pow10 := 10^(k-1) <= n < 10^k.
+For n == 0, returns 1 and sets pow10 := 1.
+*/
+inline int find_largest_pow10(const std::uint32_t n, std::uint32_t& pow10)
+{
+    // LCOV_EXCL_START
+    if (n >= 1000000000)
+    {
+        pow10 = 1000000000;
+        return 10;
+    }
+    // LCOV_EXCL_STOP
+    if (n >= 100000000)
+    {
+        pow10 = 100000000;
+        return  9;
+    }
+    if (n >= 10000000)
+    {
+        pow10 = 10000000;
+        return  8;
+    }
+    if (n >= 1000000)
+    {
+        pow10 = 1000000;
+        return  7;
+    }
+    if (n >= 100000)
+    {
+        pow10 = 100000;
+        return  6;
+    }
+    if (n >= 10000)
+    {
+        pow10 = 10000;
+        return  5;
+    }
+    if (n >= 1000)
+    {
+        pow10 = 1000;
+        return  4;
+    }
+    if (n >= 100)
+    {
+        pow10 = 100;
+        return  3;
+    }
+    if (n >= 10)
+    {
+        pow10 = 10;
+        return  2;
+    }
+
+    pow10 = 1;
+    return 1;
+}
+
+inline void grisu2_round(char* buf, int len, std::uint64_t dist, std::uint64_t delta,
+                         std::uint64_t rest, std::uint64_t ten_k)
+{
+    JSON_ASSERT(len >= 1);
+    JSON_ASSERT(dist <= delta);
+    JSON_ASSERT(rest <= delta);
+    JSON_ASSERT(ten_k > 0);
+
+    //               <--------------------------- delta ---->
+    //                                  <---- dist --------->
+    // --------------[------------------+-------------------]--------------
+    //               M-                 w                   M+
+    //
+    //                                  ten_k
+    //                                <------>
+    //                                       <---- rest ---->
+    // --------------[------------------+----+--------------]--------------
+    //                                  w    V
+    //                                       = buf * 10^k
+    //
+    // ten_k represents a unit-in-the-last-place in the decimal representation
+    // stored in buf.
+    // Decrement buf by ten_k while this takes buf closer to w.
+
+    // The tests are written in this order to avoid overflow in unsigned
+    // integer arithmetic.
+
+    while (rest < dist
+            && delta - rest >= ten_k
+            && (rest + ten_k < dist || dist - rest > rest + ten_k - dist))
+    {
+        JSON_ASSERT(buf[len - 1] != '0');
+        buf[len - 1]--;
+        rest += ten_k;
+    }
+}
+
+/*!
+Generates V = buffer * 10^decimal_exponent, such that M- <= V <= M+.
+M- and M+ must be normalized and share the same exponent -60 <= e <= -32.
+*/
+inline void grisu2_digit_gen(char* buffer, int& length, int& decimal_exponent,
+                             diyfp M_minus, diyfp w, diyfp M_plus)
+{
+    static_assert(kAlpha >= -60, "internal error");
+    static_assert(kGamma <= -32, "internal error");
+
+    // Generates the digits (and the exponent) of a decimal floating-point
+    // number V = buffer * 10^decimal_exponent in the range [M-, M+]. The diyfp's
+    // w, M- and M+ share the same exponent e, which satisfies alpha <= e <= gamma.
+    //
+    //               <--------------------------- delta ---->
+    //                                  <---- dist --------->
+    // --------------[------------------+-------------------]--------------
+    //               M-                 w                   M+
+    //
+    // Grisu2 generates the digits of M+ from left to right and stops as soon as
+    // V is in [M-,M+].
+
+    JSON_ASSERT(M_plus.e >= kAlpha);
+    JSON_ASSERT(M_plus.e <= kGamma);
+
+    std::uint64_t delta = diyfp::sub(M_plus, M_minus).f; // (significand of (M+ - M-), implicit exponent is e)
+    std::uint64_t dist  = diyfp::sub(M_plus, w      ).f; // (significand of (M+ - w ), implicit exponent is e)
+
+    // Split M+ = f * 2^e into two parts p1 and p2 (note: e < 0):
+    //
+    //      M+ = f * 2^e
+    //         = ((f div 2^-e) * 2^-e + (f mod 2^-e)) * 2^e
+    //         = ((p1        ) * 2^-e + (p2        )) * 2^e
+    //         = p1 + p2 * 2^e
+
+    const diyfp one(std::uint64_t{1} << -M_plus.e, M_plus.e);
+
+    auto p1 = static_cast<std::uint32_t>(M_plus.f >> -one.e); // p1 = f div 2^-e (Since -e >= 32, p1 fits into a 32-bit int.)
+    std::uint64_t p2 = M_plus.f & (one.f - 1);                    // p2 = f mod 2^-e
+
+    // 1)
+    //
+    // Generate the digits of the integral part p1 = d[n-1]...d[1]d[0]
+
+    JSON_ASSERT(p1 > 0);
+
+    std::uint32_t pow10{};
+    const int k = find_largest_pow10(p1, pow10);
+
+    //      10^(k-1) <= p1 < 10^k, pow10 = 10^(k-1)
+    //
+    //      p1 = (p1 div 10^(k-1)) * 10^(k-1) + (p1 mod 10^(k-1))
+    //         = (d[k-1]         ) * 10^(k-1) + (p1 mod 10^(k-1))
+    //
+    //      M+ = p1                                             + p2 * 2^e
+    //         = d[k-1] * 10^(k-1) + (p1 mod 10^(k-1))          + p2 * 2^e
+    //         = d[k-1] * 10^(k-1) + ((p1 mod 10^(k-1)) * 2^-e + p2) * 2^e
+    //         = d[k-1] * 10^(k-1) + (                         rest) * 2^e
+    //
+    // Now generate the digits d[n] of p1 from left to right (n = k-1,...,0)
+    //
+    //      p1 = d[k-1]...d[n] * 10^n + d[n-1]...d[0]
+    //
+    // but stop as soon as
+    //
+    //      rest * 2^e = (d[n-1]...d[0] * 2^-e + p2) * 2^e <= delta * 2^e
+
+    int n = k;
+    while (n > 0)
+    {
+        // Invariants:
+        //      M+ = buffer * 10^n + (p1 + p2 * 2^e)    (buffer = 0 for n = k)
+        //      pow10 = 10^(n-1) <= p1 < 10^n
+        //
+        const std::uint32_t d = p1 / pow10;  // d = p1 div 10^(n-1)
+        const std::uint32_t r = p1 % pow10;  // r = p1 mod 10^(n-1)
+        //
+        //      M+ = buffer * 10^n + (d * 10^(n-1) + r) + p2 * 2^e
+        //         = (buffer * 10 + d) * 10^(n-1) + (r + p2 * 2^e)
+        //
+        JSON_ASSERT(d <= 9);
+        buffer[length++] = static_cast<char>('0' + d); // buffer := buffer * 10 + d
+        //
+        //      M+ = buffer * 10^(n-1) + (r + p2 * 2^e)
+        //
+        p1 = r;
+        n--;
+        //
+        //      M+ = buffer * 10^n + (p1 + p2 * 2^e)
+        //      pow10 = 10^n
+        //
+
+        // Now check if enough digits have been generated.
+        // Compute
+        //
+        //      p1 + p2 * 2^e = (p1 * 2^-e + p2) * 2^e = rest * 2^e
+        //
+        // Note:
+        // Since rest and delta share the same exponent e, it suffices to
+        // compare the significands.
+        const std::uint64_t rest = (std::uint64_t{p1} << -one.e) + p2;
+        if (rest <= delta)
+        {
+            // V = buffer * 10^n, with M- <= V <= M+.
+
+            decimal_exponent += n;
+
+            // We may now just stop. But instead look if the buffer could be
+            // decremented to bring V closer to w.
+            //
+            // pow10 = 10^n is now 1 ulp in the decimal representation V.
+            // The rounding procedure works with diyfp's with an implicit
+            // exponent of e.
+            //
+            //      10^n = (10^n * 2^-e) * 2^e = ulp * 2^e
+            //
+            const std::uint64_t ten_n = std::uint64_t{pow10} << -one.e;
+            grisu2_round(buffer, length, dist, delta, rest, ten_n);
+
+            return;
+        }
+
+        pow10 /= 10;
+        //
+        //      pow10 = 10^(n-1) <= p1 < 10^n
+        // Invariants restored.
+    }
+
+    // 2)
+    //
+    // The digits of the integral part have been generated:
+    //
+    //      M+ = d[k-1]...d[1]d[0] + p2 * 2^e
+    //         = buffer            + p2 * 2^e
+    //
+    // Now generate the digits of the fractional part p2 * 2^e.
+    //
+    // Note:
+    // No decimal point is generated: the exponent is adjusted instead.
+    //
+    // p2 actually represents the fraction
+    //
+    //      p2 * 2^e
+    //          = p2 / 2^-e
+    //          = d[-1] / 10^1 + d[-2] / 10^2 + ...
+    //
+    // Now generate the digits d[-m] of p1 from left to right (m = 1,2,...)
+    //
+    //      p2 * 2^e = d[-1]d[-2]...d[-m] * 10^-m
+    //                      + 10^-m * (d[-m-1] / 10^1 + d[-m-2] / 10^2 + ...)
+    //
+    // using
+    //
+    //      10^m * p2 = ((10^m * p2) div 2^-e) * 2^-e + ((10^m * p2) mod 2^-e)
+    //                = (                   d) * 2^-e + (                   r)
+    //
+    // or
+    //      10^m * p2 * 2^e = d + r * 2^e
+    //
+    // i.e.
+    //
+    //      M+ = buffer + p2 * 2^e
+    //         = buffer + 10^-m * (d + r * 2^e)
+    //         = (buffer * 10^m + d) * 10^-m + 10^-m * r * 2^e
+    //
+    // and stop as soon as 10^-m * r * 2^e <= delta * 2^e
+
+    JSON_ASSERT(p2 > delta);
+
+    int m = 0;
+    for (;;)
+    {
+        // Invariant:
+        //      M+ = buffer * 10^-m + 10^-m * (d[-m-1] / 10 + d[-m-2] / 10^2 + ...) * 2^e
+        //         = buffer * 10^-m + 10^-m * (p2                                 ) * 2^e
+        //         = buffer * 10^-m + 10^-m * (1/10 * (10 * p2)                   ) * 2^e
+        //         = buffer * 10^-m + 10^-m * (1/10 * ((10*p2 div 2^-e) * 2^-e + (10*p2 mod 2^-e)) * 2^e
+        //
+        JSON_ASSERT(p2 <= (std::numeric_limits<std::uint64_t>::max)() / 10);
+        p2 *= 10;
+        const std::uint64_t d = p2 >> -one.e;     // d = (10 * p2) div 2^-e
+        const std::uint64_t r = p2 & (one.f - 1); // r = (10 * p2) mod 2^-e
+        //
+        //      M+ = buffer * 10^-m + 10^-m * (1/10 * (d * 2^-e + r) * 2^e
+        //         = buffer * 10^-m + 10^-m * (1/10 * (d + r * 2^e))
+        //         = (buffer * 10 + d) * 10^(-m-1) + 10^(-m-1) * r * 2^e
+        //
+        JSON_ASSERT(d <= 9);
+        buffer[length++] = static_cast<char>('0' + d); // buffer := buffer * 10 + d
+        //
+        //      M+ = buffer * 10^(-m-1) + 10^(-m-1) * r * 2^e
+        //
+        p2 = r;
+        m++;
+        //
+        //      M+ = buffer * 10^-m + 10^-m * p2 * 2^e
+        // Invariant restored.
+
+        // Check if enough digits have been generated.
+        //
+        //      10^-m * p2 * 2^e <= delta * 2^e
+        //              p2 * 2^e <= 10^m * delta * 2^e
+        //                    p2 <= 10^m * delta
+        delta *= 10;
+        dist  *= 10;
+        if (p2 <= delta)
+        {
+            break;
+        }
+    }
+
+    // V = buffer * 10^-m, with M- <= V <= M+.
+
+    decimal_exponent -= m;
+
+    // 1 ulp in the decimal representation is now 10^-m.
+    // Since delta and dist are now scaled by 10^m, we need to do the
+    // same with ulp in order to keep the units in sync.
+    //
+    //      10^m * 10^-m = 1 = 2^-e * 2^e = ten_m * 2^e
+    //
+    const std::uint64_t ten_m = one.f;
+    grisu2_round(buffer, length, dist, delta, p2, ten_m);
+
+    // By construction this algorithm generates the shortest possible decimal
+    // number (Loitsch, Theorem 6.2) which rounds back to w.
+    // For an input number of precision p, at least
+    //
+    //      N = 1 + ceil(p * log_10(2))
+    //
+    // decimal digits are sufficient to identify all binary floating-point
+    // numbers (Matula, "In-and-Out conversions").
+    // This implies that the algorithm does not produce more than N decimal
+    // digits.
+    //
+    //      N = 17 for p = 53 (IEEE double precision)
+    //      N = 9  for p = 24 (IEEE single precision)
+}
+
+/*!
+v = buf * 10^decimal_exponent
+len is the length of the buffer (number of decimal digits)
+The buffer must be large enough, i.e. >= max_digits10.
+*/
+JSON_HEDLEY_NON_NULL(1)
+inline void grisu2(char* buf, int& len, int& decimal_exponent,
+                   diyfp m_minus, diyfp v, diyfp m_plus)
+{
+    JSON_ASSERT(m_plus.e == m_minus.e);
+    JSON_ASSERT(m_plus.e == v.e);
+
+    //  --------(-----------------------+-----------------------)--------    (A)
+    //          m-                      v                       m+
+    //
+    //  --------------------(-----------+-----------------------)--------    (B)
+    //                      m-          v                       m+
+    //
+    // First scale v (and m- and m+) such that the exponent is in the range
+    // [alpha, gamma].
+
+    const cached_power cached = get_cached_power_for_binary_exponent(m_plus.e);
+
+    const diyfp c_minus_k(cached.f, cached.e); // = c ~= 10^-k
+
+    // The exponent of the products is = v.e + c_minus_k.e + q and is in the range [alpha,gamma]
+    const diyfp w       = diyfp::mul(v,       c_minus_k);
+    const diyfp w_minus = diyfp::mul(m_minus, c_minus_k);
+    const diyfp w_plus  = diyfp::mul(m_plus,  c_minus_k);
+
+    //  ----(---+---)---------------(---+---)---------------(---+---)----
+    //          w-                      w                       w+
+    //          = c*m-                  = c*v                   = c*m+
+    //
+    // diyfp::mul rounds its result and c_minus_k is approximated too. w, w- and
+    // w+ are now off by a small amount.
+    // In fact:
+    //
+    //      w - v * 10^k < 1 ulp
+    //
+    // To account for this inaccuracy, add resp. subtract 1 ulp.
+    //
+    //  --------+---[---------------(---+---)---------------]---+--------
+    //          w-  M-                  w                   M+  w+
+    //
+    // Now any number in [M-, M+] (bounds included) will round to w when input,
+    // regardless of how the input rounding algorithm breaks ties.
+    //
+    // And digit_gen generates the shortest possible such number in [M-, M+].
+    // Note that this does not mean that Grisu2 always generates the shortest
+    // possible number in the interval (m-, m+).
+    const diyfp M_minus(w_minus.f + 1, w_minus.e);
+    const diyfp M_plus (w_plus.f  - 1, w_plus.e );
+
+    decimal_exponent = -cached.k; // = -(-k) = k
+
+    grisu2_digit_gen(buf, len, decimal_exponent, M_minus, w, M_plus);
+}
+
+/*!
+v = buf * 10^decimal_exponent
+len is the length of the buffer (number of decimal digits)
+The buffer must be large enough, i.e. >= max_digits10.
+*/
+template<typename FloatType>
+JSON_HEDLEY_NON_NULL(1)
+void grisu2(char* buf, int& len, int& decimal_exponent, FloatType value)
+{
+    static_assert(diyfp::kPrecision >= std::numeric_limits<FloatType>::digits + 3,
+                  "internal error: not enough precision");
+
+    JSON_ASSERT(std::isfinite(value));
+    JSON_ASSERT(value > 0);
+
+    // If the neighbors (and boundaries) of 'value' are always computed for double-precision
+    // numbers, all float's can be recovered using strtod (and strtof). However, the resulting
+    // decimal representations are not exactly "short".
+    //
+    // The documentation for 'std::to_chars' (https://en.cppreference.com/w/cpp/utility/to_chars)
+    // says "value is converted to a string as if by std::sprintf in the default ("C") locale"
+    // and since sprintf promotes floats to doubles, I think this is exactly what 'std::to_chars'
+    // does.
+    // On the other hand, the documentation for 'std::to_chars' requires that "parsing the
+    // representation using the corresponding std::from_chars function recovers value exactly". That
+    // indicates that single precision floating-point numbers should be recovered using
+    // 'std::strtof'.
+    //
+    // NB: If the neighbors are computed for single-precision numbers, there is a single float
+    //     (7.0385307e-26f) which can't be recovered using strtod. The resulting double precision
+    //     value is off by 1 ulp.
+#if 0
+    const boundaries w = compute_boundaries(static_cast<double>(value));
+#else
+    const boundaries w = compute_boundaries(value);
+#endif
+
+    grisu2(buf, len, decimal_exponent, w.minus, w.w, w.plus);
+}
+
+/*!
+@brief appends a decimal representation of e to buf
+@return a pointer to the element following the exponent.
+@pre -1000 < e < 1000
+*/
+JSON_HEDLEY_NON_NULL(1)
+JSON_HEDLEY_RETURNS_NON_NULL
+inline char* append_exponent(char* buf, int e)
+{
+    JSON_ASSERT(e > -1000);
+    JSON_ASSERT(e <  1000);
+
+    if (e < 0)
+    {
+        e = -e;
+        *buf++ = '-';
+    }
+    else
+    {
+        *buf++ = '+';
+    }
+
+    auto k = static_cast<std::uint32_t>(e);
+    if (k < 10)
+    {
+        // Always print at least two digits in the exponent.
+        // This is for compatibility with printf("%g").
+        *buf++ = '0';
+        *buf++ = static_cast<char>('0' + k);
+    }
+    else if (k < 100)
+    {
+        *buf++ = static_cast<char>('0' + k / 10);
+        k %= 10;
+        *buf++ = static_cast<char>('0' + k);
+    }
+    else
+    {
+        *buf++ = static_cast<char>('0' + k / 100);
+        k %= 100;
+        *buf++ = static_cast<char>('0' + k / 10);
+        k %= 10;
+        *buf++ = static_cast<char>('0' + k);
+    }
+
+    return buf;
+}
+
+/*!
+@brief prettify v = buf * 10^decimal_exponent
+
+If v is in the range [10^min_exp, 10^max_exp) it will be printed in fixed-point
+notation. Otherwise it will be printed in exponential notation.
+
+@pre min_exp < 0
+@pre max_exp > 0
+*/
+JSON_HEDLEY_NON_NULL(1)
+JSON_HEDLEY_RETURNS_NON_NULL
+inline char* format_buffer(char* buf, int len, int decimal_exponent,
+                           int min_exp, int max_exp)
+{
+    JSON_ASSERT(min_exp < 0);
+    JSON_ASSERT(max_exp > 0);
+
+    const int k = len;
+    const int n = len + decimal_exponent;
+
+    // v = buf * 10^(n-k)
+    // k is the length of the buffer (number of decimal digits)
+    // n is the position of the decimal point relative to the start of the buffer.
+
+    if (k <= n && n <= max_exp)
+    {
+        // digits[000]
+        // len <= max_exp + 2
+
+        std::memset(buf + k, '0', static_cast<size_t>(n) - static_cast<size_t>(k));
+        // Make it look like a floating-point number (#362, #378)
+        buf[n + 0] = '.';
+        buf[n + 1] = '0';
+        return buf + (static_cast<size_t>(n) + 2);
+    }
+
+    if (0 < n && n <= max_exp)
+    {
+        // dig.its
+        // len <= max_digits10 + 1
+
+        JSON_ASSERT(k > n);
+
+        std::memmove(buf + (static_cast<size_t>(n) + 1), buf + n, static_cast<size_t>(k) - static_cast<size_t>(n));
+        buf[n] = '.';
+        return buf + (static_cast<size_t>(k) + 1U);
+    }
+
+    if (min_exp < n && n <= 0)
+    {
+        // 0.[000]digits
+        // len <= 2 + (-min_exp - 1) + max_digits10
+
+        std::memmove(buf + (2 + static_cast<size_t>(-n)), buf, static_cast<size_t>(k));
+        buf[0] = '0';
+        buf[1] = '.';
+        std::memset(buf + 2, '0', static_cast<size_t>(-n));
+        return buf + (2U + static_cast<size_t>(-n) + static_cast<size_t>(k));
+    }
+
+    if (k == 1)
+    {
+        // dE+123
+        // len <= 1 + 5
+
+        buf += 1;
+    }
+    else
+    {
+        // d.igitsE+123
+        // len <= max_digits10 + 1 + 5
+
+        std::memmove(buf + 2, buf + 1, static_cast<size_t>(k) - 1);
+        buf[1] = '.';
+        buf += 1 + static_cast<size_t>(k);
+    }
+
+    *buf++ = 'e';
+    return append_exponent(buf, n - 1);
+}
+
+} // namespace dtoa_impl
+
+/*!
+@brief generates a decimal representation of the floating-point number value in [first, last).
+
+The format of the resulting decimal representation is similar to printf's %g
+format. Returns an iterator pointing past-the-end of the decimal representation.
+
+@note The input number must be finite, i.e. NaN's and Inf's are not supported.
+@note The buffer must be large enough.
+@note The result is NOT null-terminated.
+*/
+template<typename FloatType>
+JSON_HEDLEY_NON_NULL(1, 2)
+JSON_HEDLEY_RETURNS_NON_NULL
+char* to_chars(char* first, const char* last, FloatType value)
+{
+    static_cast<void>(last); // maybe unused - fix warning
+    JSON_ASSERT(std::isfinite(value));
+
+    // Use signbit(value) instead of (value < 0) since signbit works for -0.
+    if (std::signbit(value))
+    {
+        value = -value;
+        *first++ = '-';
+    }
+
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wfloat-equal"
+#endif
+    if (value == 0) // +-0
+    {
+        *first++ = '0';
+        // Make it look like a floating-point number (#362, #378)
+        *first++ = '.';
+        *first++ = '0';
+        return first;
+    }
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+
+    JSON_ASSERT(last - first >= std::numeric_limits<FloatType>::max_digits10);
+
+    // Compute v = buffer * 10^decimal_exponent.
+    // The decimal digits are stored in the buffer, which needs to be interpreted
+    // as an unsigned decimal integer.
+    // len is the length of the buffer, i.e. the number of decimal digits.
+    int len = 0;
+    int decimal_exponent = 0;
+    dtoa_impl::grisu2(first, len, decimal_exponent, value);
+
+    JSON_ASSERT(len <= std::numeric_limits<FloatType>::max_digits10);
+
+    // Format the buffer like printf("%.*g", prec, value)
+    constexpr int kMinExp = -4;
+    // Use digits10 here to increase compatibility with version 2.
+    constexpr int kMaxExp = std::numeric_limits<FloatType>::digits10;
+
+    JSON_ASSERT(last - first >= kMaxExp + 2);
+    JSON_ASSERT(last - first >= 2 + (-kMinExp - 1) + std::numeric_limits<FloatType>::max_digits10);
+    JSON_ASSERT(last - first >= std::numeric_limits<FloatType>::max_digits10 + 6);
+
+    return dtoa_impl::format_buffer(first, len, decimal_exponent, kMinExp, kMaxExp);
+}
+
+} // namespace detail
+} // namespace nlohmann
+
+// #include <nlohmann/detail/exceptions.hpp>
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+// #include <nlohmann/detail/meta/cpp_future.hpp>
+
+// #include <nlohmann/detail/output/binary_writer.hpp>
+
+// #include <nlohmann/detail/output/output_adapters.hpp>
+
+// #include <nlohmann/detail/value_t.hpp>
+
+
+namespace nlohmann
+{
+namespace detail
+{
+///////////////////
+// serialization //
+///////////////////
+
+/// how to treat decoding errors
+enum class error_handler_t
+{
+    strict,  ///< throw a type_error exception in case of invalid UTF-8
+    replace, ///< replace invalid UTF-8 sequences with U+FFFD
+    ignore   ///< ignore invalid UTF-8 sequences
+};
+
+template<typename BasicJsonType>
+class serializer
+{
+    using string_t = typename BasicJsonType::string_t;
+    using number_float_t = typename BasicJsonType::number_float_t;
+    using number_integer_t = typename BasicJsonType::number_integer_t;
+    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+    using binary_char_t = typename BasicJsonType::binary_t::value_type;
+    static constexpr std::uint8_t UTF8_ACCEPT = 0;
+    static constexpr std::uint8_t UTF8_REJECT = 1;
+
+  public:
+    /*!
+    @param[in] s  output stream to serialize to
+    @param[in] ichar  indentation character to use
+    @param[in] error_handler_  how to react on decoding errors
+    */
+    serializer(output_adapter_t<char> s, const char ichar,
+               error_handler_t error_handler_ = error_handler_t::strict)
+        : o(std::move(s))
+        , loc(std::localeconv())
+        , thousands_sep(loc->thousands_sep == nullptr ? '\0' : std::char_traits<char>::to_char_type(* (loc->thousands_sep)))
+        , decimal_point(loc->decimal_point == nullptr ? '\0' : std::char_traits<char>::to_char_type(* (loc->decimal_point)))
+        , indent_char(ichar)
+        , indent_string(512, indent_char)
+        , error_handler(error_handler_)
+    {}
+
+    // delete because of pointer members
+    serializer(const serializer&) = delete;
+    serializer& operator=(const serializer&) = delete;
+    serializer(serializer&&) = delete;
+    serializer& operator=(serializer&&) = delete;
+    ~serializer() = default;
+
+    /*!
+    @brief internal implementation of the serialization function
+
+    This function is called by the public member function dump and organizes
+    the serialization internally. The indentation level is propagated as
+    additional parameter. In case of arrays and objects, the function is
+    called recursively.
+
+    - strings and object keys are escaped using `escape_string()`
+    - integer numbers are converted implicitly via `operator<<`
+    - floating-point numbers are converted to a string using `"%g"` format
+    - binary values are serialized as objects containing the subtype and the
+      byte array
+
+    @param[in] val               value to serialize
+    @param[in] pretty_print      whether the output shall be pretty-printed
+    @param[in] ensure_ascii If @a ensure_ascii is true, all non-ASCII characters
+    in the output are escaped with `\uXXXX` sequences, and the result consists
+    of ASCII characters only.
+    @param[in] indent_step       the indent level
+    @param[in] current_indent    the current indent level (only used internally)
+    */
+    void dump(const BasicJsonType& val,
+              const bool pretty_print,
+              const bool ensure_ascii,
+              const unsigned int indent_step,
+              const unsigned int current_indent = 0)
+    {
+        switch (val.m_type)
+        {
+            case value_t::object:
+            {
+                if (val.m_value.object->empty())
+                {
+                    o->write_characters("{}", 2);
+                    return;
+                }
+
+                if (pretty_print)
+                {
+                    o->write_characters("{\n", 2);
+
+                    // variable to hold indentation for recursive calls
+                    const auto new_indent = current_indent + indent_step;
+                    if (JSON_HEDLEY_UNLIKELY(indent_string.size() < new_indent))
+                    {
+                        indent_string.resize(indent_string.size() * 2, ' ');
+                    }
+
+                    // first n-1 elements
+                    auto i = val.m_value.object->cbegin();
+                    for (std::size_t cnt = 0; cnt < val.m_value.object->size() - 1; ++cnt, ++i)
+                    {
+                        o->write_characters(indent_string.c_str(), new_indent);
+                        o->write_character('\"');
+                        dump_escaped(i->first, ensure_ascii);
+                        o->write_characters("\": ", 3);
+                        dump(i->second, true, ensure_ascii, indent_step, new_indent);
+                        o->write_characters(",\n", 2);
+                    }
+
+                    // last element
+                    JSON_ASSERT(i != val.m_value.object->cend());
+                    JSON_ASSERT(std::next(i) == val.m_value.object->cend());
+                    o->write_characters(indent_string.c_str(), new_indent);
+                    o->write_character('\"');
+                    dump_escaped(i->first, ensure_ascii);
+                    o->write_characters("\": ", 3);
+                    dump(i->second, true, ensure_ascii, indent_step, new_indent);
+
+                    o->write_character('\n');
+                    o->write_characters(indent_string.c_str(), current_indent);
+                    o->write_character('}');
+                }
+                else
+                {
+                    o->write_character('{');
+
+                    // first n-1 elements
+                    auto i = val.m_value.object->cbegin();
+                    for (std::size_t cnt = 0; cnt < val.m_value.object->size() - 1; ++cnt, ++i)
+                    {
+                        o->write_character('\"');
+                        dump_escaped(i->first, ensure_ascii);
+                        o->write_characters("\":", 2);
+                        dump(i->second, false, ensure_ascii, indent_step, current_indent);
+                        o->write_character(',');
+                    }
+
+                    // last element
+                    JSON_ASSERT(i != val.m_value.object->cend());
+                    JSON_ASSERT(std::next(i) == val.m_value.object->cend());
+                    o->write_character('\"');
+                    dump_escaped(i->first, ensure_ascii);
+                    o->write_characters("\":", 2);
+                    dump(i->second, false, ensure_ascii, indent_step, current_indent);
+
+                    o->write_character('}');
+                }
+
+                return;
+            }
+
+            case value_t::array:
+            {
+                if (val.m_value.array->empty())
+                {
+                    o->write_characters("[]", 2);
+                    return;
+                }
+
+                if (pretty_print)
+                {
+                    o->write_characters("[\n", 2);
+
+                    // variable to hold indentation for recursive calls
+                    const auto new_indent = current_indent + indent_step;
+                    if (JSON_HEDLEY_UNLIKELY(indent_string.size() < new_indent))
+                    {
+                        indent_string.resize(indent_string.size() * 2, ' ');
+                    }
+
+                    // first n-1 elements
+                    for (auto i = val.m_value.array->cbegin();
+                            i != val.m_value.array->cend() - 1; ++i)
+                    {
+                        o->write_characters(indent_string.c_str(), new_indent);
+                        dump(*i, true, ensure_ascii, indent_step, new_indent);
+                        o->write_characters(",\n", 2);
+                    }
+
+                    // last element
+                    JSON_ASSERT(!val.m_value.array->empty());
+                    o->write_characters(indent_string.c_str(), new_indent);
+                    dump(val.m_value.array->back(), true, ensure_ascii, indent_step, new_indent);
+
+                    o->write_character('\n');
+                    o->write_characters(indent_string.c_str(), current_indent);
+                    o->write_character(']');
+                }
+                else
+                {
+                    o->write_character('[');
+
+                    // first n-1 elements
+                    for (auto i = val.m_value.array->cbegin();
+                            i != val.m_value.array->cend() - 1; ++i)
+                    {
+                        dump(*i, false, ensure_ascii, indent_step, current_indent);
+                        o->write_character(',');
+                    }
+
+                    // last element
+                    JSON_ASSERT(!val.m_value.array->empty());
+                    dump(val.m_value.array->back(), false, ensure_ascii, indent_step, current_indent);
+
+                    o->write_character(']');
+                }
+
+                return;
+            }
+
+            case value_t::string:
+            {
+                o->write_character('\"');
+                dump_escaped(*val.m_value.string, ensure_ascii);
+                o->write_character('\"');
+                return;
+            }
+
+            case value_t::binary:
+            {
+                if (pretty_print)
+                {
+                    o->write_characters("{\n", 2);
+
+                    // variable to hold indentation for recursive calls
+                    const auto new_indent = current_indent + indent_step;
+                    if (JSON_HEDLEY_UNLIKELY(indent_string.size() < new_indent))
+                    {
+                        indent_string.resize(indent_string.size() * 2, ' ');
+                    }
+
+                    o->write_characters(indent_string.c_str(), new_indent);
+
+                    o->write_characters("\"bytes\": [", 10);
+
+                    if (!val.m_value.binary->empty())
+                    {
+                        for (auto i = val.m_value.binary->cbegin();
+                                i != val.m_value.binary->cend() - 1; ++i)
+                        {
+                            dump_integer(*i);
+                            o->write_characters(", ", 2);
+                        }
+                        dump_integer(val.m_value.binary->back());
+                    }
+
+                    o->write_characters("],\n", 3);
+                    o->write_characters(indent_string.c_str(), new_indent);
+
+                    o->write_characters("\"subtype\": ", 11);
+                    if (val.m_value.binary->has_subtype())
+                    {
+                        dump_integer(val.m_value.binary->subtype());
+                    }
+                    else
+                    {
+                        o->write_characters("null", 4);
+                    }
+                    o->write_character('\n');
+                    o->write_characters(indent_string.c_str(), current_indent);
+                    o->write_character('}');
+                }
+                else
+                {
+                    o->write_characters("{\"bytes\":[", 10);
+
+                    if (!val.m_value.binary->empty())
+                    {
+                        for (auto i = val.m_value.binary->cbegin();
+                                i != val.m_value.binary->cend() - 1; ++i)
+                        {
+                            dump_integer(*i);
+                            o->write_character(',');
+                        }
+                        dump_integer(val.m_value.binary->back());
+                    }
+
+                    o->write_characters("],\"subtype\":", 12);
+                    if (val.m_value.binary->has_subtype())
+                    {
+                        dump_integer(val.m_value.binary->subtype());
+                        o->write_character('}');
+                    }
+                    else
+                    {
+                        o->write_characters("null}", 5);
+                    }
+                }
+                return;
+            }
+
+            case value_t::boolean:
+            {
+                if (val.m_value.boolean)
+                {
+                    o->write_characters("true", 4);
+                }
+                else
+                {
+                    o->write_characters("false", 5);
+                }
+                return;
+            }
+
+            case value_t::number_integer:
+            {
+                dump_integer(val.m_value.number_integer);
+                return;
+            }
+
+            case value_t::number_unsigned:
+            {
+                dump_integer(val.m_value.number_unsigned);
+                return;
+            }
+
+            case value_t::number_float:
+            {
+                dump_float(val.m_value.number_float);
+                return;
+            }
+
+            case value_t::discarded:
+            {
+                o->write_characters("<discarded>", 11);
+                return;
+            }
+
+            case value_t::null:
+            {
+                o->write_characters("null", 4);
+                return;
+            }
+
+            default:            // LCOV_EXCL_LINE
+                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+        }
+    }
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    /*!
+    @brief dump escaped string
+
+    Escape a string by replacing certain special characters by a sequence of an
+    escape character (backslash) and another character and other control
+    characters by a sequence of "\u" followed by a four-digit hex
+    representation. The escaped string is written to output stream @a o.
+
+    @param[in] s  the string to escape
+    @param[in] ensure_ascii  whether to escape non-ASCII characters with
+                             \uXXXX sequences
+
+    @complexity Linear in the length of string @a s.
+    */
+    void dump_escaped(const string_t& s, const bool ensure_ascii)
+    {
+        std::uint32_t codepoint{};
+        std::uint8_t state = UTF8_ACCEPT;
+        std::size_t bytes = 0;  // number of bytes written to string_buffer
+
+        // number of bytes written at the point of the last valid byte
+        std::size_t bytes_after_last_accept = 0;
+        std::size_t undumped_chars = 0;
+
+        for (std::size_t i = 0; i < s.size(); ++i)
+        {
+            const auto byte = static_cast<std::uint8_t>(s[i]);
+
+            switch (decode(state, codepoint, byte))
+            {
+                case UTF8_ACCEPT:  // decode found a new code point
+                {
+                    switch (codepoint)
+                    {
+                        case 0x08: // backspace
+                        {
+                            string_buffer[bytes++] = '\\';
+                            string_buffer[bytes++] = 'b';
+                            break;
+                        }
+
+                        case 0x09: // horizontal tab
+                        {
+                            string_buffer[bytes++] = '\\';
+                            string_buffer[bytes++] = 't';
+                            break;
+                        }
+
+                        case 0x0A: // newline
+                        {
+                            string_buffer[bytes++] = '\\';
+                            string_buffer[bytes++] = 'n';
+                            break;
+                        }
+
+                        case 0x0C: // formfeed
+                        {
+                            string_buffer[bytes++] = '\\';
+                            string_buffer[bytes++] = 'f';
+                            break;
+                        }
+
+                        case 0x0D: // carriage return
+                        {
+                            string_buffer[bytes++] = '\\';
+                            string_buffer[bytes++] = 'r';
+                            break;
+                        }
+
+                        case 0x22: // quotation mark
+                        {
+                            string_buffer[bytes++] = '\\';
+                            string_buffer[bytes++] = '\"';
+                            break;
+                        }
+
+                        case 0x5C: // reverse solidus
+                        {
+                            string_buffer[bytes++] = '\\';
+                            string_buffer[bytes++] = '\\';
+                            break;
+                        }
+
+                        default:
+                        {
+                            // escape control characters (0x00..0x1F) or, if
+                            // ensure_ascii parameter is used, non-ASCII characters
+                            if ((codepoint <= 0x1F) || (ensure_ascii && (codepoint >= 0x7F)))
+                            {
+                                if (codepoint <= 0xFFFF)
+                                {
+                                    // NOLINTNEXTLINE(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+                                    static_cast<void>((std::snprintf)(string_buffer.data() + bytes, 7, "\\u%04x",
+                                                                      static_cast<std::uint16_t>(codepoint)));
+                                    bytes += 6;
+                                }
+                                else
+                                {
+                                    // NOLINTNEXTLINE(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+                                    static_cast<void>((std::snprintf)(string_buffer.data() + bytes, 13, "\\u%04x\\u%04x",
+                                                                      static_cast<std::uint16_t>(0xD7C0u + (codepoint >> 10u)),
+                                                                      static_cast<std::uint16_t>(0xDC00u + (codepoint & 0x3FFu))));
+                                    bytes += 12;
+                                }
+                            }
+                            else
+                            {
+                                // copy byte to buffer (all previous bytes
+                                // been copied have in default case above)
+                                string_buffer[bytes++] = s[i];
+                            }
+                            break;
+                        }
+                    }
+
+                    // write buffer and reset index; there must be 13 bytes
+                    // left, as this is the maximal number of bytes to be
+                    // written ("\uxxxx\uxxxx\0") for one code point
+                    if (string_buffer.size() - bytes < 13)
+                    {
+                        o->write_characters(string_buffer.data(), bytes);
+                        bytes = 0;
+                    }
+
+                    // remember the byte position of this accept
+                    bytes_after_last_accept = bytes;
+                    undumped_chars = 0;
+                    break;
+                }
+
+                case UTF8_REJECT:  // decode found invalid UTF-8 byte
+                {
+                    switch (error_handler)
+                    {
+                        case error_handler_t::strict:
+                        {
+                            std::stringstream ss;
+                            ss << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << (byte | 0);
+                            JSON_THROW(type_error::create(316, "invalid UTF-8 byte at index " + std::to_string(i) + ": 0x" + ss.str(), BasicJsonType()));
+                        }
+
+                        case error_handler_t::ignore:
+                        case error_handler_t::replace:
+                        {
+                            // in case we saw this character the first time, we
+                            // would like to read it again, because the byte
+                            // may be OK for itself, but just not OK for the
+                            // previous sequence
+                            if (undumped_chars > 0)
+                            {
+                                --i;
+                            }
+
+                            // reset length buffer to the last accepted index;
+                            // thus removing/ignoring the invalid characters
+                            bytes = bytes_after_last_accept;
+
+                            if (error_handler == error_handler_t::replace)
+                            {
+                                // add a replacement character
+                                if (ensure_ascii)
+                                {
+                                    string_buffer[bytes++] = '\\';
+                                    string_buffer[bytes++] = 'u';
+                                    string_buffer[bytes++] = 'f';
+                                    string_buffer[bytes++] = 'f';
+                                    string_buffer[bytes++] = 'f';
+                                    string_buffer[bytes++] = 'd';
+                                }
+                                else
+                                {
+                                    string_buffer[bytes++] = detail::binary_writer<BasicJsonType, char>::to_char_type('\xEF');
+                                    string_buffer[bytes++] = detail::binary_writer<BasicJsonType, char>::to_char_type('\xBF');
+                                    string_buffer[bytes++] = detail::binary_writer<BasicJsonType, char>::to_char_type('\xBD');
+                                }
+
+                                // write buffer and reset index; there must be 13 bytes
+                                // left, as this is the maximal number of bytes to be
+                                // written ("\uxxxx\uxxxx\0") for one code point
+                                if (string_buffer.size() - bytes < 13)
+                                {
+                                    o->write_characters(string_buffer.data(), bytes);
+                                    bytes = 0;
+                                }
+
+                                bytes_after_last_accept = bytes;
+                            }
+
+                            undumped_chars = 0;
+
+                            // continue processing the string
+                            state = UTF8_ACCEPT;
+                            break;
+                        }
+
+                        default:            // LCOV_EXCL_LINE
+                            JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+                    }
+                    break;
+                }
+
+                default:  // decode found yet incomplete multi-byte code point
+                {
+                    if (!ensure_ascii)
+                    {
+                        // code point will not be escaped - copy byte to buffer
+                        string_buffer[bytes++] = s[i];
+                    }
+                    ++undumped_chars;
+                    break;
+                }
+            }
+        }
+
+        // we finished processing the string
+        if (JSON_HEDLEY_LIKELY(state == UTF8_ACCEPT))
+        {
+            // write buffer
+            if (bytes > 0)
+            {
+                o->write_characters(string_buffer.data(), bytes);
+            }
+        }
+        else
+        {
+            // we finish reading, but do not accept: string was incomplete
+            switch (error_handler)
+            {
+                case error_handler_t::strict:
+                {
+                    std::stringstream ss;
+                    ss << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << (static_cast<std::uint8_t>(s.back()) | 0);
+                    JSON_THROW(type_error::create(316, "incomplete UTF-8 string; last byte: 0x" + ss.str(), BasicJsonType()));
+                }
+
+                case error_handler_t::ignore:
+                {
+                    // write all accepted bytes
+                    o->write_characters(string_buffer.data(), bytes_after_last_accept);
+                    break;
+                }
+
+                case error_handler_t::replace:
+                {
+                    // write all accepted bytes
+                    o->write_characters(string_buffer.data(), bytes_after_last_accept);
+                    // add a replacement character
+                    if (ensure_ascii)
+                    {
+                        o->write_characters("\\ufffd", 6);
+                    }
+                    else
+                    {
+                        o->write_characters("\xEF\xBF\xBD", 3);
+                    }
+                    break;
+                }
+
+                default:            // LCOV_EXCL_LINE
+                    JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+            }
+        }
+    }
+
+  private:
+    /*!
+    @brief count digits
+
+    Count the number of decimal (base 10) digits for an input unsigned integer.
+
+    @param[in] x  unsigned integer number to count its digits
+    @return    number of decimal digits
+    */
+    inline unsigned int count_digits(number_unsigned_t x) noexcept
+    {
+        unsigned int n_digits = 1;
+        for (;;)
+        {
+            if (x < 10)
+            {
+                return n_digits;
+            }
+            if (x < 100)
+            {
+                return n_digits + 1;
+            }
+            if (x < 1000)
+            {
+                return n_digits + 2;
+            }
+            if (x < 10000)
+            {
+                return n_digits + 3;
+            }
+            x = x / 10000u;
+            n_digits += 4;
+        }
+    }
+
+    // templates to avoid warnings about useless casts
+    template <typename NumberType, enable_if_t<std::is_signed<NumberType>::value, int> = 0>
+    bool is_negative_number(NumberType x)
+    {
+        return x < 0;
+    }
+
+    template < typename NumberType, enable_if_t <std::is_unsigned<NumberType>::value, int > = 0 >
+    bool is_negative_number(NumberType /*unused*/)
+    {
+        return false;
+    }
+
+    /*!
+    @brief dump an integer
+
+    Dump a given integer to output stream @a o. Works internally with
+    @a number_buffer.
+
+    @param[in] x  integer number (signed or unsigned) to dump
+    @tparam NumberType either @a number_integer_t or @a number_unsigned_t
+    */
+    template < typename NumberType, detail::enable_if_t <
+                   std::is_integral<NumberType>::value ||
+                   std::is_same<NumberType, number_unsigned_t>::value ||
+                   std::is_same<NumberType, number_integer_t>::value ||
+                   std::is_same<NumberType, binary_char_t>::value,
+                   int > = 0 >
+    void dump_integer(NumberType x)
+    {
+        static constexpr std::array<std::array<char, 2>, 100> digits_to_99
+        {
+            {
+                {{'0', '0'}}, {{'0', '1'}}, {{'0', '2'}}, {{'0', '3'}}, {{'0', '4'}}, {{'0', '5'}}, {{'0', '6'}}, {{'0', '7'}}, {{'0', '8'}}, {{'0', '9'}},
+                {{'1', '0'}}, {{'1', '1'}}, {{'1', '2'}}, {{'1', '3'}}, {{'1', '4'}}, {{'1', '5'}}, {{'1', '6'}}, {{'1', '7'}}, {{'1', '8'}}, {{'1', '9'}},
+                {{'2', '0'}}, {{'2', '1'}}, {{'2', '2'}}, {{'2', '3'}}, {{'2', '4'}}, {{'2', '5'}}, {{'2', '6'}}, {{'2', '7'}}, {{'2', '8'}}, {{'2', '9'}},
+                {{'3', '0'}}, {{'3', '1'}}, {{'3', '2'}}, {{'3', '3'}}, {{'3', '4'}}, {{'3', '5'}}, {{'3', '6'}}, {{'3', '7'}}, {{'3', '8'}}, {{'3', '9'}},
+                {{'4', '0'}}, {{'4', '1'}}, {{'4', '2'}}, {{'4', '3'}}, {{'4', '4'}}, {{'4', '5'}}, {{'4', '6'}}, {{'4', '7'}}, {{'4', '8'}}, {{'4', '9'}},
+                {{'5', '0'}}, {{'5', '1'}}, {{'5', '2'}}, {{'5', '3'}}, {{'5', '4'}}, {{'5', '5'}}, {{'5', '6'}}, {{'5', '7'}}, {{'5', '8'}}, {{'5', '9'}},
+                {{'6', '0'}}, {{'6', '1'}}, {{'6', '2'}}, {{'6', '3'}}, {{'6', '4'}}, {{'6', '5'}}, {{'6', '6'}}, {{'6', '7'}}, {{'6', '8'}}, {{'6', '9'}},
+                {{'7', '0'}}, {{'7', '1'}}, {{'7', '2'}}, {{'7', '3'}}, {{'7', '4'}}, {{'7', '5'}}, {{'7', '6'}}, {{'7', '7'}}, {{'7', '8'}}, {{'7', '9'}},
+                {{'8', '0'}}, {{'8', '1'}}, {{'8', '2'}}, {{'8', '3'}}, {{'8', '4'}}, {{'8', '5'}}, {{'8', '6'}}, {{'8', '7'}}, {{'8', '8'}}, {{'8', '9'}},
+                {{'9', '0'}}, {{'9', '1'}}, {{'9', '2'}}, {{'9', '3'}}, {{'9', '4'}}, {{'9', '5'}}, {{'9', '6'}}, {{'9', '7'}}, {{'9', '8'}}, {{'9', '9'}},
+            }
+        };
+
+        // special case for "0"
+        if (x == 0)
+        {
+            o->write_character('0');
+            return;
+        }
+
+        // use a pointer to fill the buffer
+        auto buffer_ptr = number_buffer.begin(); // NOLINT(llvm-qualified-auto,readability-qualified-auto,cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+
+        number_unsigned_t abs_value;
+
+        unsigned int n_chars{};
+
+        if (is_negative_number(x))
+        {
+            *buffer_ptr = '-';
+            abs_value = remove_sign(static_cast<number_integer_t>(x));
+
+            // account one more byte for the minus sign
+            n_chars = 1 + count_digits(abs_value);
+        }
+        else
+        {
+            abs_value = static_cast<number_unsigned_t>(x);
+            n_chars = count_digits(abs_value);
+        }
+
+        // spare 1 byte for '\0'
+        JSON_ASSERT(n_chars < number_buffer.size() - 1);
+
+        // jump to the end to generate the string from backward,
+        // so we later avoid reversing the result
+        buffer_ptr += n_chars;
+
+        // Fast int2ascii implementation inspired by "Fastware" talk by Andrei Alexandrescu
+        // See: https://www.youtube.com/watch?v=o4-CwDo2zpg
+        while (abs_value >= 100)
+        {
+            const auto digits_index = static_cast<unsigned>((abs_value % 100));
+            abs_value /= 100;
+            *(--buffer_ptr) = digits_to_99[digits_index][1];
+            *(--buffer_ptr) = digits_to_99[digits_index][0];
+        }
+
+        if (abs_value >= 10)
+        {
+            const auto digits_index = static_cast<unsigned>(abs_value);
+            *(--buffer_ptr) = digits_to_99[digits_index][1];
+            *(--buffer_ptr) = digits_to_99[digits_index][0];
+        }
+        else
+        {
+            *(--buffer_ptr) = static_cast<char>('0' + abs_value);
+        }
+
+        o->write_characters(number_buffer.data(), n_chars);
+    }
+
+    /*!
+    @brief dump a floating-point number
+
+    Dump a given floating-point number to output stream @a o. Works internally
+    with @a number_buffer.
+
+    @param[in] x  floating-point number to dump
+    */
+    void dump_float(number_float_t x)
+    {
+        // NaN / inf
+        if (!std::isfinite(x))
+        {
+            o->write_characters("null", 4);
+            return;
+        }
+
+        // If number_float_t is an IEEE-754 single or double precision number,
+        // use the Grisu2 algorithm to produce short numbers which are
+        // guaranteed to round-trip, using strtof and strtod, resp.
+        //
+        // NB: The test below works if <long double> == <double>.
+        static constexpr bool is_ieee_single_or_double
+            = (std::numeric_limits<number_float_t>::is_iec559 && std::numeric_limits<number_float_t>::digits == 24 && std::numeric_limits<number_float_t>::max_exponent == 128) ||
+              (std::numeric_limits<number_float_t>::is_iec559 && std::numeric_limits<number_float_t>::digits == 53 && std::numeric_limits<number_float_t>::max_exponent == 1024);
+
+        dump_float(x, std::integral_constant<bool, is_ieee_single_or_double>());
+    }
+
+    void dump_float(number_float_t x, std::true_type /*is_ieee_single_or_double*/)
+    {
+        auto* begin = number_buffer.data();
+        auto* end = ::nlohmann::detail::to_chars(begin, begin + number_buffer.size(), x);
+
+        o->write_characters(begin, static_cast<size_t>(end - begin));
+    }
+
+    void dump_float(number_float_t x, std::false_type /*is_ieee_single_or_double*/)
+    {
+        // get number of digits for a float -> text -> float round-trip
+        static constexpr auto d = std::numeric_limits<number_float_t>::max_digits10;
+
+        // the actual conversion
+        // NOLINTNEXTLINE(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
+        std::ptrdiff_t len = (std::snprintf)(number_buffer.data(), number_buffer.size(), "%.*g", d, x);
+
+        // negative value indicates an error
+        JSON_ASSERT(len > 0);
+        // check if buffer was large enough
+        JSON_ASSERT(static_cast<std::size_t>(len) < number_buffer.size());
+
+        // erase thousands separator
+        if (thousands_sep != '\0')
+        {
+            // NOLINTNEXTLINE(readability-qualified-auto,llvm-qualified-auto): std::remove returns an iterator, see https://github.com/nlohmann/json/issues/3081
+            const auto end = std::remove(number_buffer.begin(), number_buffer.begin() + len, thousands_sep);
+            std::fill(end, number_buffer.end(), '\0');
+            JSON_ASSERT((end - number_buffer.begin()) <= len);
+            len = (end - number_buffer.begin());
+        }
+
+        // convert decimal point to '.'
+        if (decimal_point != '\0' && decimal_point != '.')
+        {
+            // NOLINTNEXTLINE(readability-qualified-auto,llvm-qualified-auto): std::find returns an iterator, see https://github.com/nlohmann/json/issues/3081
+            const auto dec_pos = std::find(number_buffer.begin(), number_buffer.end(), decimal_point);
+            if (dec_pos != number_buffer.end())
+            {
+                *dec_pos = '.';
+            }
+        }
+
+        o->write_characters(number_buffer.data(), static_cast<std::size_t>(len));
+
+        // determine if we need to append ".0"
+        const bool value_is_int_like =
+            std::none_of(number_buffer.begin(), number_buffer.begin() + len + 1,
+                         [](char c)
+        {
+            return c == '.' || c == 'e';
+        });
+
+        if (value_is_int_like)
+        {
+            o->write_characters(".0", 2);
+        }
+    }
+
+    /*!
+    @brief check whether a string is UTF-8 encoded
+
+    The function checks each byte of a string whether it is UTF-8 encoded. The
+    result of the check is stored in the @a state parameter. The function must
+    be called initially with state 0 (accept). State 1 means the string must
+    be rejected, because the current byte is not allowed. If the string is
+    completely processed, but the state is non-zero, the string ended
+    prematurely; that is, the last byte indicated more bytes should have
+    followed.
+
+    @param[in,out] state  the state of the decoding
+    @param[in,out] codep  codepoint (valid only if resulting state is UTF8_ACCEPT)
+    @param[in] byte       next byte to decode
+    @return               new state
+
+    @note The function has been edited: a std::array is used.
+
+    @copyright Copyright (c) 2008-2009 Bjoern Hoehrmann <bjoern@hoehrmann.de>
+    @sa http://bjoern.hoehrmann.de/utf-8/decoder/dfa/
+    */
+    static std::uint8_t decode(std::uint8_t& state, std::uint32_t& codep, const std::uint8_t byte) noexcept
+    {
+        static const std::array<std::uint8_t, 400> utf8d =
+        {
+            {
+                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 00..1F
+                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 20..3F
+                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 40..5F
+                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 60..7F
+                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, // 80..9F
+                7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, // A0..BF
+                8, 8, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, // C0..DF
+                0xA, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x4, 0x3, 0x3, // E0..EF
+                0xB, 0x6, 0x6, 0x6, 0x5, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, // F0..FF
+                0x0, 0x1, 0x2, 0x3, 0x5, 0x8, 0x7, 0x1, 0x1, 0x1, 0x4, 0x6, 0x1, 0x1, 0x1, 0x1, // s0..s0
+                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, // s1..s2
+                1, 2, 1, 1, 1, 1, 1, 2, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, // s3..s4
+                1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, // s5..s6
+                1, 3, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 // s7..s8
+            }
+        };
+
+        JSON_ASSERT(byte < utf8d.size());
+        const std::uint8_t type = utf8d[byte];
+
+        codep = (state != UTF8_ACCEPT)
+                ? (byte & 0x3fu) | (codep << 6u)
+                : (0xFFu >> type) & (byte);
+
+        std::size_t index = 256u + static_cast<size_t>(state) * 16u + static_cast<size_t>(type);
+        JSON_ASSERT(index < 400);
+        state = utf8d[index];
+        return state;
+    }
+
+    /*
+     * Overload to make the compiler happy while it is instantiating
+     * dump_integer for number_unsigned_t.
+     * Must never be called.
+     */
+    number_unsigned_t remove_sign(number_unsigned_t x)
+    {
+        JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+        return x; // LCOV_EXCL_LINE
+    }
+
+    /*
+     * Helper function for dump_integer
+     *
+     * This function takes a negative signed integer and returns its absolute
+     * value as unsigned integer. The plus/minus shuffling is necessary as we can
+     * not directly remove the sign of an arbitrary signed integer as the
+     * absolute values of INT_MIN and INT_MAX are usually not the same. See
+     * #1708 for details.
+     */
+    inline number_unsigned_t remove_sign(number_integer_t x) noexcept
+    {
+        JSON_ASSERT(x < 0 && x < (std::numeric_limits<number_integer_t>::max)()); // NOLINT(misc-redundant-expression)
+        return static_cast<number_unsigned_t>(-(x + 1)) + 1;
+    }
+
+  private:
+    /// the output of the serializer
+    output_adapter_t<char> o = nullptr;
+
+    /// a (hopefully) large enough character buffer
+    std::array<char, 64> number_buffer{{}};
+
+    /// the locale
+    const std::lconv* loc = nullptr;
+    /// the locale's thousand separator character
+    const char thousands_sep = '\0';
+    /// the locale's decimal point character
+    const char decimal_point = '\0';
+
+    /// string buffer
+    std::array<char, 512> string_buffer{{}};
+
+    /// the indentation character
+    const char indent_char;
+    /// the indentation string
+    string_t indent_string;
+
+    /// error_handler how to react on decoding errors
+    const error_handler_t error_handler;
+};
+}  // namespace detail
+}  // namespace nlohmann
+
+// #include <nlohmann/detail/value_t.hpp>
+
+// #include <nlohmann/json_fwd.hpp>
+
+// #include <nlohmann/ordered_map.hpp>
+
+
+#include <functional> // less
+#include <initializer_list> // initializer_list
+#include <iterator> // input_iterator_tag, iterator_traits
+#include <memory> // allocator
+#include <stdexcept> // for out_of_range
+#include <type_traits> // enable_if, is_convertible
+#include <utility> // pair
+#include <vector> // vector
+
+// #include <nlohmann/detail/macro_scope.hpp>
+
+
+namespace nlohmann
+{
+
+/// ordered_map: a minimal map-like container that preserves insertion order
+/// for use within nlohmann::basic_json<ordered_map>
+template <class Key, class T, class IgnoredLess = std::less<Key>,
+          class Allocator = std::allocator<std::pair<const Key, T>>>
+                  struct ordered_map : std::vector<std::pair<const Key, T>, Allocator>
+{
+    using key_type = Key;
+    using mapped_type = T;
+    using Container = std::vector<std::pair<const Key, T>, Allocator>;
+    using iterator = typename Container::iterator;
+    using const_iterator = typename Container::const_iterator;
+    using size_type = typename Container::size_type;
+    using value_type = typename Container::value_type;
+
+    // Explicit constructors instead of `using Container::Container`
+    // otherwise older compilers choke on it (GCC <= 5.5, xcode <= 9.4)
+    ordered_map(const Allocator& alloc = Allocator()) : Container{alloc} {}
+    template <class It>
+    ordered_map(It first, It last, const Allocator& alloc = Allocator())
+        : Container{first, last, alloc} {}
+    ordered_map(std::initializer_list<T> init, const Allocator& alloc = Allocator() )
+        : Container{init, alloc} {}
+
+    std::pair<iterator, bool> emplace(const key_type& key, T&& t)
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == key)
+            {
+                return {it, false};
+            }
+        }
+        Container::emplace_back(key, t);
+        return {--this->end(), true};
+    }
+
+    T& operator[](const Key& key)
+    {
+        return emplace(key, T{}).first->second;
+    }
+
+    const T& operator[](const Key& key) const
+    {
+        return at(key);
+    }
+
+    T& at(const Key& key)
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == key)
+            {
+                return it->second;
+            }
+        }
+
+        JSON_THROW(std::out_of_range("key not found"));
+    }
+
+    const T& at(const Key& key) const
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == key)
+            {
+                return it->second;
+            }
+        }
+
+        JSON_THROW(std::out_of_range("key not found"));
+    }
+
+    size_type erase(const Key& key)
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == key)
+            {
+                // Since we cannot move const Keys, re-construct them in place
+                for (auto next = it; ++next != this->end(); ++it)
+                {
+                    it->~value_type(); // Destroy but keep allocation
+                    new (&*it) value_type{std::move(*next)};
+                }
+                Container::pop_back();
+                return 1;
+            }
+        }
+        return 0;
+    }
+
+    iterator erase(iterator pos)
+    {
+        return erase(pos, std::next(pos));
+    }
+
+    iterator erase(iterator first, iterator last)
+    {
+        const auto elements_affected = std::distance(first, last);
+        const auto offset = std::distance(Container::begin(), first);
+
+        // This is the start situation. We need to delete elements_affected
+        // elements (3 in this example: e, f, g), and need to return an
+        // iterator past the last deleted element (h in this example).
+        // Note that offset is the distance from the start of the vector
+        // to first. We will need this later.
+
+        // [ a, b, c, d, e, f, g, h, i, j ]
+        //               ^        ^
+        //             first    last
+
+        // Since we cannot move const Keys, we re-construct them in place.
+        // We start at first and re-construct (viz. copy) the elements from
+        // the back of the vector. Example for first iteration:
+
+        //               ,--------.
+        //               v        |   destroy e and re-construct with h
+        // [ a, b, c, d, e, f, g, h, i, j ]
+        //               ^        ^
+        //               it       it + elements_affected
+
+        for (auto it = first; std::next(it, elements_affected) != Container::end(); ++it)
+        {
+            it->~value_type(); // destroy but keep allocation
+            new (&*it) value_type{std::move(*std::next(it, elements_affected))}; // "move" next element to it
+        }
+
+        // [ a, b, c, d, h, i, j, h, i, j ]
+        //               ^        ^
+        //             first    last
+
+        // remove the unneeded elements at the end of the vector
+        Container::resize(this->size() - static_cast<size_type>(elements_affected));
+
+        // [ a, b, c, d, h, i, j ]
+        //               ^        ^
+        //             first    last
+
+        // first is now pointing past the last deleted element, but we cannot
+        // use this iterator, because it may have been invalidated by the
+        // resize call. Instead, we can return begin() + offset.
+        return Container::begin() + offset;
+    }
+
+    size_type count(const Key& key) const
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == key)
+            {
+                return 1;
+            }
+        }
+        return 0;
+    }
+
+    iterator find(const Key& key)
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == key)
+            {
+                return it;
+            }
+        }
+        return Container::end();
+    }
+
+    const_iterator find(const Key& key) const
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == key)
+            {
+                return it;
+            }
+        }
+        return Container::end();
+    }
+
+    std::pair<iterator, bool> insert( value_type&& value )
+    {
+        return emplace(value.first, std::move(value.second));
+    }
+
+    std::pair<iterator, bool> insert( const value_type& value )
+    {
+        for (auto it = this->begin(); it != this->end(); ++it)
+        {
+            if (it->first == value.first)
+            {
+                return {it, false};
+            }
+        }
+        Container::push_back(value);
+        return {--this->end(), true};
+    }
+
+    template<typename InputIt>
+    using require_input_iter = typename std::enable_if<std::is_convertible<typename std::iterator_traits<InputIt>::iterator_category,
+            std::input_iterator_tag>::value>::type;
+
+    template<typename InputIt, typename = require_input_iter<InputIt>>
+    void insert(InputIt first, InputIt last)
+    {
+        for (auto it = first; it != last; ++it)
+        {
+            insert(*it);
+        }
+    }
+};
+
+}  // namespace nlohmann
+
+
+#if defined(JSON_HAS_CPP_17)
+    #include <string_view>
+#endif
+
+/*!
+@brief namespace for Niels Lohmann
+@see https://github.com/nlohmann
+@since version 1.0.0
+*/
+namespace nlohmann
+{
+
+/*!
+@brief a class to store JSON values
+
+@internal
+@invariant The member variables @a m_value and @a m_type have the following
+relationship:
+- If `m_type == value_t::object`, then `m_value.object != nullptr`.
+- If `m_type == value_t::array`, then `m_value.array != nullptr`.
+- If `m_type == value_t::string`, then `m_value.string != nullptr`.
+The invariants are checked by member function assert_invariant().
+
+@note ObjectType trick from https://stackoverflow.com/a/9860911
+@endinternal
+
+@since version 1.0.0
+
+@nosubgrouping
+*/
+NLOHMANN_BASIC_JSON_TPL_DECLARATION
+class basic_json // NOLINT(cppcoreguidelines-special-member-functions,hicpp-special-member-functions)
+{
+  private:
+    template<detail::value_t> friend struct detail::external_constructor;
+    friend ::nlohmann::json_pointer<basic_json>;
+
+    template<typename BasicJsonType, typename InputType>
+    friend class ::nlohmann::detail::parser;
+    friend ::nlohmann::detail::serializer<basic_json>;
+    template<typename BasicJsonType>
+    friend class ::nlohmann::detail::iter_impl;
+    template<typename BasicJsonType, typename CharType>
+    friend class ::nlohmann::detail::binary_writer;
+    template<typename BasicJsonType, typename InputType, typename SAX>
+    friend class ::nlohmann::detail::binary_reader;
+    template<typename BasicJsonType>
+    friend class ::nlohmann::detail::json_sax_dom_parser;
+    template<typename BasicJsonType>
+    friend class ::nlohmann::detail::json_sax_dom_callback_parser;
+    friend class ::nlohmann::detail::exception;
+
+    /// workaround type for MSVC
+    using basic_json_t = NLOHMANN_BASIC_JSON_TPL;
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    // convenience aliases for types residing in namespace detail;
+    using lexer = ::nlohmann::detail::lexer_base<basic_json>;
+
+    template<typename InputAdapterType>
+    static ::nlohmann::detail::parser<basic_json, InputAdapterType> parser(
+        InputAdapterType adapter,
+        detail::parser_callback_t<basic_json>cb = nullptr,
+        const bool allow_exceptions = true,
+        const bool ignore_comments = false
+                                 )
+    {
+        return ::nlohmann::detail::parser<basic_json, InputAdapterType>(std::move(adapter),
+                std::move(cb), allow_exceptions, ignore_comments);
+    }
+
+  private:
+    using primitive_iterator_t = ::nlohmann::detail::primitive_iterator_t;
+    template<typename BasicJsonType>
+    using internal_iterator = ::nlohmann::detail::internal_iterator<BasicJsonType>;
+    template<typename BasicJsonType>
+    using iter_impl = ::nlohmann::detail::iter_impl<BasicJsonType>;
+    template<typename Iterator>
+    using iteration_proxy = ::nlohmann::detail::iteration_proxy<Iterator>;
+    template<typename Base> using json_reverse_iterator = ::nlohmann::detail::json_reverse_iterator<Base>;
+
+    template<typename CharType>
+    using output_adapter_t = ::nlohmann::detail::output_adapter_t<CharType>;
+
+    template<typename InputType>
+    using binary_reader = ::nlohmann::detail::binary_reader<basic_json, InputType>;
+    template<typename CharType> using binary_writer = ::nlohmann::detail::binary_writer<basic_json, CharType>;
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    using serializer = ::nlohmann::detail::serializer<basic_json>;
+
+  public:
+    using value_t = detail::value_t;
+    /// JSON Pointer, see @ref nlohmann::json_pointer
+    using json_pointer = ::nlohmann::json_pointer<basic_json>;
+    template<typename T, typename SFINAE>
+    using json_serializer = JSONSerializer<T, SFINAE>;
+    /// how to treat decoding errors
+    using error_handler_t = detail::error_handler_t;
+    /// how to treat CBOR tags
+    using cbor_tag_handler_t = detail::cbor_tag_handler_t;
+    /// helper type for initializer lists of basic_json values
+    using initializer_list_t = std::initializer_list<detail::json_ref<basic_json>>;
+
+    using input_format_t = detail::input_format_t;
+    /// SAX interface type, see @ref nlohmann::json_sax
+    using json_sax_t = json_sax<basic_json>;
+
+    ////////////////
+    // exceptions //
+    ////////////////
+
+    /// @name exceptions
+    /// Classes to implement user-defined exceptions.
+    /// @{
+
+    using exception = detail::exception;
+    using parse_error = detail::parse_error;
+    using invalid_iterator = detail::invalid_iterator;
+    using type_error = detail::type_error;
+    using out_of_range = detail::out_of_range;
+    using other_error = detail::other_error;
+
+    /// @}
+
+
+    /////////////////////
+    // container types //
+    /////////////////////
+
+    /// @name container types
+    /// The canonic container types to use @ref basic_json like any other STL
+    /// container.
+    /// @{
+
+    /// the type of elements in a basic_json container
+    using value_type = basic_json;
+
+    /// the type of an element reference
+    using reference = value_type&;
+    /// the type of an element const reference
+    using const_reference = const value_type&;
+
+    /// a type to represent differences between iterators
+    using difference_type = std::ptrdiff_t;
+    /// a type to represent container sizes
+    using size_type = std::size_t;
+
+    /// the allocator type
+    using allocator_type = AllocatorType<basic_json>;
+
+    /// the type of an element pointer
+    using pointer = typename std::allocator_traits<allocator_type>::pointer;
+    /// the type of an element const pointer
+    using const_pointer = typename std::allocator_traits<allocator_type>::const_pointer;
+
+    /// an iterator for a basic_json container
+    using iterator = iter_impl<basic_json>;
+    /// a const iterator for a basic_json container
+    using const_iterator = iter_impl<const basic_json>;
+    /// a reverse iterator for a basic_json container
+    using reverse_iterator = json_reverse_iterator<typename basic_json::iterator>;
+    /// a const reverse iterator for a basic_json container
+    using const_reverse_iterator = json_reverse_iterator<typename basic_json::const_iterator>;
+
+    /// @}
+
+
+    /// @brief returns the allocator associated with the container
+    /// @sa https://json.nlohmann.me/api/basic_json/get_allocator/
+    static allocator_type get_allocator()
+    {
+        return allocator_type();
+    }
+
+    /// @brief returns version information on the library
+    /// @sa https://json.nlohmann.me/api/basic_json/meta/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json meta()
+    {
+        basic_json result;
+
+        result["copyright"] = "(C) 2013-2022 Niels Lohmann";
+        result["name"] = "JSON for Modern C++";
+        result["url"] = "https://github.com/nlohmann/json";
+        result["version"]["string"] =
+            std::to_string(NLOHMANN_JSON_VERSION_MAJOR) + "." +
+            std::to_string(NLOHMANN_JSON_VERSION_MINOR) + "." +
+            std::to_string(NLOHMANN_JSON_VERSION_PATCH);
+        result["version"]["major"] = NLOHMANN_JSON_VERSION_MAJOR;
+        result["version"]["minor"] = NLOHMANN_JSON_VERSION_MINOR;
+        result["version"]["patch"] = NLOHMANN_JSON_VERSION_PATCH;
+
+#ifdef _WIN32
+        result["platform"] = "win32";
+#elif defined __linux__
+        result["platform"] = "linux";
+#elif defined __APPLE__
+        result["platform"] = "apple";
+#elif defined __unix__
+        result["platform"] = "unix";
+#else
+        result["platform"] = "unknown";
+#endif
+
+#if defined(__ICC) || defined(__INTEL_COMPILER)
+        result["compiler"] = {{"family", "icc"}, {"version", __INTEL_COMPILER}};
+#elif defined(__clang__)
+        result["compiler"] = {{"family", "clang"}, {"version", __clang_version__}};
+#elif defined(__GNUC__) || defined(__GNUG__)
+        result["compiler"] = {{"family", "gcc"}, {"version", std::to_string(__GNUC__) + "." + std::to_string(__GNUC_MINOR__) + "." + std::to_string(__GNUC_PATCHLEVEL__)}};
+#elif defined(__HP_cc) || defined(__HP_aCC)
+        result["compiler"] = "hp"
+#elif defined(__IBMCPP__)
+        result["compiler"] = {{"family", "ilecpp"}, {"version", __IBMCPP__}};
+#elif defined(_MSC_VER)
+        result["compiler"] = {{"family", "msvc"}, {"version", _MSC_VER}};
+#elif defined(__PGI)
+        result["compiler"] = {{"family", "pgcpp"}, {"version", __PGI}};
+#elif defined(__SUNPRO_CC)
+        result["compiler"] = {{"family", "sunpro"}, {"version", __SUNPRO_CC}};
+#else
+        result["compiler"] = {{"family", "unknown"}, {"version", "unknown"}};
+#endif
+
+#ifdef __cplusplus
+        result["compiler"]["c++"] = std::to_string(__cplusplus);
+#else
+        result["compiler"]["c++"] = "unknown";
+#endif
+        return result;
+    }
+
+
+    ///////////////////////////
+    // JSON value data types //
+    ///////////////////////////
+
+    /// @name JSON value data types
+    /// The data types to store a JSON value. These types are derived from
+    /// the template arguments passed to class @ref basic_json.
+    /// @{
+
+    /// @brief object key comparator type
+    /// @sa https://json.nlohmann.me/api/basic_json/object_comparator_t/
+#if defined(JSON_HAS_CPP_14)
+    // Use transparent comparator if possible, combined with perfect forwarding
+    // on find() and count() calls prevents unnecessary string construction.
+    using object_comparator_t = std::less<>;
+#else
+    using object_comparator_t = std::less<StringType>;
+#endif
+
+    /// @brief a type for an object
+    /// @sa https://json.nlohmann.me/api/basic_json/object_t/
+    using object_t = ObjectType<StringType,
+          basic_json,
+          object_comparator_t,
+          AllocatorType<std::pair<const StringType,
+          basic_json>>>;
+
+    /// @brief a type for an array
+    /// @sa https://json.nlohmann.me/api/basic_json/array_t/
+    using array_t = ArrayType<basic_json, AllocatorType<basic_json>>;
+
+    /// @brief a type for a string
+    /// @sa https://json.nlohmann.me/api/basic_json/string_t/
+    using string_t = StringType;
+
+    /// @brief a type for a boolean
+    /// @sa https://json.nlohmann.me/api/basic_json/boolean_t/
+    using boolean_t = BooleanType;
+
+    /// @brief a type for a number (integer)
+    /// @sa https://json.nlohmann.me/api/basic_json/number_integer_t/
+    using number_integer_t = NumberIntegerType;
+
+    /// @brief a type for a number (unsigned)
+    /// @sa https://json.nlohmann.me/api/basic_json/number_unsigned_t/
+    using number_unsigned_t = NumberUnsignedType;
+
+    /// @brief a type for a number (floating-point)
+    /// @sa https://json.nlohmann.me/api/basic_json/number_float_t/
+    using number_float_t = NumberFloatType;
+
+    /// @brief a type for a packed binary type
+    /// @sa https://json.nlohmann.me/api/basic_json/binary_t/
+    using binary_t = nlohmann::byte_container_with_subtype<BinaryType>;
+
+    /// @}
+
+  private:
+
+    /// helper for exception-safe object creation
+    template<typename T, typename... Args>
+    JSON_HEDLEY_RETURNS_NON_NULL
+    static T* create(Args&& ... args)
+    {
+        AllocatorType<T> alloc;
+        using AllocatorTraits = std::allocator_traits<AllocatorType<T>>;
+
+        auto deleter = [&](T * obj)
+        {
+            AllocatorTraits::deallocate(alloc, obj, 1);
+        };
+        std::unique_ptr<T, decltype(deleter)> obj(AllocatorTraits::allocate(alloc, 1), deleter);
+        AllocatorTraits::construct(alloc, obj.get(), std::forward<Args>(args)...);
+        JSON_ASSERT(obj != nullptr);
+        return obj.release();
+    }
+
+    ////////////////////////
+    // JSON value storage //
+    ////////////////////////
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    /*!
+    @brief a JSON value
+
+    The actual storage for a JSON value of the @ref basic_json class. This
+    union combines the different storage types for the JSON value types
+    defined in @ref value_t.
+
+    JSON type | value_t type    | used type
+    --------- | --------------- | ------------------------
+    object    | object          | pointer to @ref object_t
+    array     | array           | pointer to @ref array_t
+    string    | string          | pointer to @ref string_t
+    boolean   | boolean         | @ref boolean_t
+    number    | number_integer  | @ref number_integer_t
+    number    | number_unsigned | @ref number_unsigned_t
+    number    | number_float    | @ref number_float_t
+    binary    | binary          | pointer to @ref binary_t
+    null      | null            | *no value is stored*
+
+    @note Variable-length types (objects, arrays, and strings) are stored as
+    pointers. The size of the union should not exceed 64 bits if the default
+    value types are used.
+
+    @since version 1.0.0
+    */
+    union json_value
+    {
+        /// object (stored with pointer to save storage)
+        object_t* object;
+        /// array (stored with pointer to save storage)
+        array_t* array;
+        /// string (stored with pointer to save storage)
+        string_t* string;
+        /// binary (stored with pointer to save storage)
+        binary_t* binary;
+        /// boolean
+        boolean_t boolean;
+        /// number (integer)
+        number_integer_t number_integer;
+        /// number (unsigned integer)
+        number_unsigned_t number_unsigned;
+        /// number (floating-point)
+        number_float_t number_float;
+
+        /// default constructor (for null values)
+        json_value() = default;
+        /// constructor for booleans
+        json_value(boolean_t v) noexcept : boolean(v) {}
+        /// constructor for numbers (integer)
+        json_value(number_integer_t v) noexcept : number_integer(v) {}
+        /// constructor for numbers (unsigned)
+        json_value(number_unsigned_t v) noexcept : number_unsigned(v) {}
+        /// constructor for numbers (floating-point)
+        json_value(number_float_t v) noexcept : number_float(v) {}
+        /// constructor for empty values of a given type
+        json_value(value_t t)
+        {
+            switch (t)
+            {
+                case value_t::object:
+                {
+                    object = create<object_t>();
+                    break;
+                }
+
+                case value_t::array:
+                {
+                    array = create<array_t>();
+                    break;
+                }
+
+                case value_t::string:
+                {
+                    string = create<string_t>("");
+                    break;
+                }
+
+                case value_t::binary:
+                {
+                    binary = create<binary_t>();
+                    break;
+                }
+
+                case value_t::boolean:
+                {
+                    boolean = static_cast<boolean_t>(false);
+                    break;
+                }
+
+                case value_t::number_integer:
+                {
+                    number_integer = static_cast<number_integer_t>(0);
+                    break;
+                }
+
+                case value_t::number_unsigned:
+                {
+                    number_unsigned = static_cast<number_unsigned_t>(0);
+                    break;
+                }
+
+                case value_t::number_float:
+                {
+                    number_float = static_cast<number_float_t>(0.0);
+                    break;
+                }
+
+                case value_t::null:
+                {
+                    object = nullptr;  // silence warning, see #821
+                    break;
+                }
+
+                case value_t::discarded:
+                default:
+                {
+                    object = nullptr;  // silence warning, see #821
+                    if (JSON_HEDLEY_UNLIKELY(t == value_t::null))
+                    {
+                        JSON_THROW(other_error::create(500, "961c151d2e87f2686a955a9be24d316f1362bf21 3.10.5", basic_json())); // LCOV_EXCL_LINE
+                    }
+                    break;
+                }
+            }
+        }
+
+        /// constructor for strings
+        json_value(const string_t& value) : string(create<string_t>(value)) {}
+
+        /// constructor for rvalue strings
+        json_value(string_t&& value) : string(create<string_t>(std::move(value))) {}
+
+        /// constructor for objects
+        json_value(const object_t& value) : object(create<object_t>(value)) {}
+
+        /// constructor for rvalue objects
+        json_value(object_t&& value) : object(create<object_t>(std::move(value))) {}
+
+        /// constructor for arrays
+        json_value(const array_t& value) : array(create<array_t>(value)) {}
+
+        /// constructor for rvalue arrays
+        json_value(array_t&& value) : array(create<array_t>(std::move(value))) {}
+
+        /// constructor for binary arrays
+        json_value(const typename binary_t::container_type& value) : binary(create<binary_t>(value)) {}
+
+        /// constructor for rvalue binary arrays
+        json_value(typename binary_t::container_type&& value) : binary(create<binary_t>(std::move(value))) {}
+
+        /// constructor for binary arrays (internal type)
+        json_value(const binary_t& value) : binary(create<binary_t>(value)) {}
+
+        /// constructor for rvalue binary arrays (internal type)
+        json_value(binary_t&& value) : binary(create<binary_t>(std::move(value))) {}
+
+        void destroy(value_t t)
+        {
+            if (t == value_t::array || t == value_t::object)
+            {
+                // flatten the current json_value to a heap-allocated stack
+                std::vector<basic_json> stack;
+
+                // move the top-level items to stack
+                if (t == value_t::array)
+                {
+                    stack.reserve(array->size());
+                    std::move(array->begin(), array->end(), std::back_inserter(stack));
+                }
+                else
+                {
+                    stack.reserve(object->size());
+                    for (auto&& it : *object)
+                    {
+                        stack.push_back(std::move(it.second));
+                    }
+                }
+
+                while (!stack.empty())
+                {
+                    // move the last item to local variable to be processed
+                    basic_json current_item(std::move(stack.back()));
+                    stack.pop_back();
+
+                    // if current_item is array/object, move
+                    // its children to the stack to be processed later
+                    if (current_item.is_array())
+                    {
+                        std::move(current_item.m_value.array->begin(), current_item.m_value.array->end(), std::back_inserter(stack));
+
+                        current_item.m_value.array->clear();
+                    }
+                    else if (current_item.is_object())
+                    {
+                        for (auto&& it : *current_item.m_value.object)
+                        {
+                            stack.push_back(std::move(it.second));
+                        }
+
+                        current_item.m_value.object->clear();
+                    }
+
+                    // it's now safe that current_item get destructed
+                    // since it doesn't have any children
+                }
+            }
+
+            switch (t)
+            {
+                case value_t::object:
+                {
+                    AllocatorType<object_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, object);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, object, 1);
+                    break;
+                }
+
+                case value_t::array:
+                {
+                    AllocatorType<array_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, array);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, array, 1);
+                    break;
+                }
+
+                case value_t::string:
+                {
+                    AllocatorType<string_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, string);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, string, 1);
+                    break;
+                }
+
+                case value_t::binary:
+                {
+                    AllocatorType<binary_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, binary);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, binary, 1);
+                    break;
+                }
+
+                case value_t::null:
+                case value_t::boolean:
+                case value_t::number_integer:
+                case value_t::number_unsigned:
+                case value_t::number_float:
+                case value_t::discarded:
+                default:
+                {
+                    break;
+                }
+            }
+        }
+    };
+
+  private:
+    /*!
+    @brief checks the class invariants
+
+    This function asserts the class invariants. It needs to be called at the
+    end of every constructor to make sure that created objects respect the
+    invariant. Furthermore, it has to be called each time the type of a JSON
+    value is changed, because the invariant expresses a relationship between
+    @a m_type and @a m_value.
+
+    Furthermore, the parent relation is checked for arrays and objects: If
+    @a check_parents true and the value is an array or object, then the
+    container's elements must have the current value as parent.
+
+    @param[in] check_parents  whether the parent relation should be checked.
+               The value is true by default and should only be set to false
+               during destruction of objects when the invariant does not
+               need to hold.
+    */
+    void assert_invariant(bool check_parents = true) const noexcept
+    {
+        JSON_ASSERT(m_type != value_t::object || m_value.object != nullptr);
+        JSON_ASSERT(m_type != value_t::array || m_value.array != nullptr);
+        JSON_ASSERT(m_type != value_t::string || m_value.string != nullptr);
+        JSON_ASSERT(m_type != value_t::binary || m_value.binary != nullptr);
+
+#if JSON_DIAGNOSTICS
+        JSON_TRY
+        {
+            // cppcheck-suppress assertWithSideEffect
+            JSON_ASSERT(!check_parents || !is_structured() || std::all_of(begin(), end(), [this](const basic_json & j)
+            {
+                return j.m_parent == this;
+            }));
+        }
+        JSON_CATCH(...) {} // LCOV_EXCL_LINE
+#endif
+        static_cast<void>(check_parents);
+    }
+
+    void set_parents()
+    {
+#if JSON_DIAGNOSTICS
+        switch (m_type)
+        {
+            case value_t::array:
+            {
+                for (auto& element : *m_value.array)
+                {
+                    element.m_parent = this;
+                }
+                break;
+            }
+
+            case value_t::object:
+            {
+                for (auto& element : *m_value.object)
+                {
+                    element.second.m_parent = this;
+                }
+                break;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+                break;
+        }
+#endif
+    }
+
+    iterator set_parents(iterator it, typename iterator::difference_type count_set_parents)
+    {
+#if JSON_DIAGNOSTICS
+        for (typename iterator::difference_type i = 0; i < count_set_parents; ++i)
+        {
+            (it + i)->m_parent = this;
+        }
+#else
+        static_cast<void>(count_set_parents);
+#endif
+        return it;
+    }
+
+    reference set_parent(reference j, std::size_t old_capacity = static_cast<std::size_t>(-1))
+    {
+#if JSON_DIAGNOSTICS
+        if (old_capacity != static_cast<std::size_t>(-1))
+        {
+            // see https://github.com/nlohmann/json/issues/2838
+            JSON_ASSERT(type() == value_t::array);
+            if (JSON_HEDLEY_UNLIKELY(m_value.array->capacity() != old_capacity))
+            {
+                // capacity has changed: update all parents
+                set_parents();
+                return j;
+            }
+        }
+
+        // ordered_json uses a vector internally, so pointers could have
+        // been invalidated; see https://github.com/nlohmann/json/issues/2962
+#ifdef JSON_HEDLEY_MSVC_VERSION
+#pragma warning(push )
+#pragma warning(disable : 4127) // ignore warning to replace if with if constexpr
+#endif
+        if (detail::is_ordered_map<object_t>::value)
+        {
+            set_parents();
+            return j;
+        }
+#ifdef JSON_HEDLEY_MSVC_VERSION
+#pragma warning( pop )
+#endif
+
+        j.m_parent = this;
+#else
+        static_cast<void>(j);
+        static_cast<void>(old_capacity);
+#endif
+        return j;
+    }
+
+  public:
+    //////////////////////////
+    // JSON parser callback //
+    //////////////////////////
+
+    /// @brief parser event types
+    /// @sa https://json.nlohmann.me/api/basic_json/parse_event_t/
+    using parse_event_t = detail::parse_event_t;
+
+    /// @brief per-element parser callback type
+    /// @sa https://json.nlohmann.me/api/basic_json/parser_callback_t/
+    using parser_callback_t = detail::parser_callback_t<basic_json>;
+
+    //////////////////
+    // constructors //
+    //////////////////
+
+    /// @name constructors and destructors
+    /// Constructors of class @ref basic_json, copy/move constructor, copy
+    /// assignment, static functions creating objects, and the destructor.
+    /// @{
+
+    /// @brief create an empty value with a given type
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    basic_json(const value_t v)
+        : m_type(v), m_value(v)
+    {
+        assert_invariant();
+    }
+
+    /// @brief create a null object
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    basic_json(std::nullptr_t = nullptr) noexcept
+        : basic_json(value_t::null)
+    {
+        assert_invariant();
+    }
+
+    /// @brief create a JSON value from compatible types
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    template < typename CompatibleType,
+               typename U = detail::uncvref_t<CompatibleType>,
+               detail::enable_if_t <
+                   !detail::is_basic_json<U>::value && detail::is_compatible_type<basic_json_t, U>::value, int > = 0 >
+    basic_json(CompatibleType && val) noexcept(noexcept( // NOLINT(bugprone-forwarding-reference-overload,bugprone-exception-escape)
+                JSONSerializer<U>::to_json(std::declval<basic_json_t&>(),
+                                           std::forward<CompatibleType>(val))))
+    {
+        JSONSerializer<U>::to_json(*this, std::forward<CompatibleType>(val));
+        set_parents();
+        assert_invariant();
+    }
+
+    /// @brief create a JSON value from an existing one
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    template < typename BasicJsonType,
+               detail::enable_if_t <
+                   detail::is_basic_json<BasicJsonType>::value&& !std::is_same<basic_json, BasicJsonType>::value, int > = 0 >
+    basic_json(const BasicJsonType& val)
+    {
+        using other_boolean_t = typename BasicJsonType::boolean_t;
+        using other_number_float_t = typename BasicJsonType::number_float_t;
+        using other_number_integer_t = typename BasicJsonType::number_integer_t;
+        using other_number_unsigned_t = typename BasicJsonType::number_unsigned_t;
+        using other_string_t = typename BasicJsonType::string_t;
+        using other_object_t = typename BasicJsonType::object_t;
+        using other_array_t = typename BasicJsonType::array_t;
+        using other_binary_t = typename BasicJsonType::binary_t;
+
+        switch (val.type())
+        {
+            case value_t::boolean:
+                JSONSerializer<other_boolean_t>::to_json(*this, val.template get<other_boolean_t>());
+                break;
+            case value_t::number_float:
+                JSONSerializer<other_number_float_t>::to_json(*this, val.template get<other_number_float_t>());
+                break;
+            case value_t::number_integer:
+                JSONSerializer<other_number_integer_t>::to_json(*this, val.template get<other_number_integer_t>());
+                break;
+            case value_t::number_unsigned:
+                JSONSerializer<other_number_unsigned_t>::to_json(*this, val.template get<other_number_unsigned_t>());
+                break;
+            case value_t::string:
+                JSONSerializer<other_string_t>::to_json(*this, val.template get_ref<const other_string_t&>());
+                break;
+            case value_t::object:
+                JSONSerializer<other_object_t>::to_json(*this, val.template get_ref<const other_object_t&>());
+                break;
+            case value_t::array:
+                JSONSerializer<other_array_t>::to_json(*this, val.template get_ref<const other_array_t&>());
+                break;
+            case value_t::binary:
+                JSONSerializer<other_binary_t>::to_json(*this, val.template get_ref<const other_binary_t&>());
+                break;
+            case value_t::null:
+                *this = nullptr;
+                break;
+            case value_t::discarded:
+                m_type = value_t::discarded;
+                break;
+            default:            // LCOV_EXCL_LINE
+                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+        }
+        set_parents();
+        assert_invariant();
+    }
+
+    /// @brief create a container (array or object) from an initializer list
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    basic_json(initializer_list_t init,
+               bool type_deduction = true,
+               value_t manual_type = value_t::array)
+    {
+        // check if each element is an array with two elements whose first
+        // element is a string
+        bool is_an_object = std::all_of(init.begin(), init.end(),
+                                        [](const detail::json_ref<basic_json>& element_ref)
+        {
+            return element_ref->is_array() && element_ref->size() == 2 && (*element_ref)[0].is_string();
+        });
+
+        // adjust type if type deduction is not wanted
+        if (!type_deduction)
+        {
+            // if array is wanted, do not create an object though possible
+            if (manual_type == value_t::array)
+            {
+                is_an_object = false;
+            }
+
+            // if object is wanted but impossible, throw an exception
+            if (JSON_HEDLEY_UNLIKELY(manual_type == value_t::object && !is_an_object))
+            {
+                JSON_THROW(type_error::create(301, "cannot create object from initializer list", basic_json()));
+            }
+        }
+
+        if (is_an_object)
+        {
+            // the initializer list is a list of pairs -> create object
+            m_type = value_t::object;
+            m_value = value_t::object;
+
+            for (auto& element_ref : init)
+            {
+                auto element = element_ref.moved_or_copied();
+                m_value.object->emplace(
+                    std::move(*((*element.m_value.array)[0].m_value.string)),
+                    std::move((*element.m_value.array)[1]));
+            }
+        }
+        else
+        {
+            // the initializer list describes an array -> create array
+            m_type = value_t::array;
+            m_value.array = create<array_t>(init.begin(), init.end());
+        }
+
+        set_parents();
+        assert_invariant();
+    }
+
+    /// @brief explicitly create a binary array (without subtype)
+    /// @sa https://json.nlohmann.me/api/basic_json/binary/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json binary(const typename binary_t::container_type& init)
+    {
+        auto res = basic_json();
+        res.m_type = value_t::binary;
+        res.m_value = init;
+        return res;
+    }
+
+    /// @brief explicitly create a binary array (with subtype)
+    /// @sa https://json.nlohmann.me/api/basic_json/binary/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json binary(const typename binary_t::container_type& init, typename binary_t::subtype_type subtype)
+    {
+        auto res = basic_json();
+        res.m_type = value_t::binary;
+        res.m_value = binary_t(init, subtype);
+        return res;
+    }
+
+    /// @brief explicitly create a binary array
+    /// @sa https://json.nlohmann.me/api/basic_json/binary/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json binary(typename binary_t::container_type&& init)
+    {
+        auto res = basic_json();
+        res.m_type = value_t::binary;
+        res.m_value = std::move(init);
+        return res;
+    }
+
+    /// @brief explicitly create a binary array (with subtype)
+    /// @sa https://json.nlohmann.me/api/basic_json/binary/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json binary(typename binary_t::container_type&& init, typename binary_t::subtype_type subtype)
+    {
+        auto res = basic_json();
+        res.m_type = value_t::binary;
+        res.m_value = binary_t(std::move(init), subtype);
+        return res;
+    }
+
+    /// @brief explicitly create an array from an initializer list
+    /// @sa https://json.nlohmann.me/api/basic_json/array/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json array(initializer_list_t init = {})
+    {
+        return basic_json(init, false, value_t::array);
+    }
+
+    /// @brief explicitly create an object from an initializer list
+    /// @sa https://json.nlohmann.me/api/basic_json/object/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json object(initializer_list_t init = {})
+    {
+        return basic_json(init, false, value_t::object);
+    }
+
+    /// @brief construct an array with count copies of given value
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    basic_json(size_type cnt, const basic_json& val)
+        : m_type(value_t::array)
+    {
+        m_value.array = create<array_t>(cnt, val);
+        set_parents();
+        assert_invariant();
+    }
+
+    /// @brief construct a JSON container given an iterator range
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    template < class InputIT, typename std::enable_if <
+                   std::is_same<InputIT, typename basic_json_t::iterator>::value ||
+                   std::is_same<InputIT, typename basic_json_t::const_iterator>::value, int >::type = 0 >
+    basic_json(InputIT first, InputIT last)
+    {
+        JSON_ASSERT(first.m_object != nullptr);
+        JSON_ASSERT(last.m_object != nullptr);
+
+        // make sure iterator fits the current value
+        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(201, "iterators are not compatible", basic_json()));
+        }
+
+        // copy type from first iterator
+        m_type = first.m_object->m_type;
+
+        // check if iterator range is complete for primitive values
+        switch (m_type)
+        {
+            case value_t::boolean:
+            case value_t::number_float:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::string:
+            {
+                if (JSON_HEDLEY_UNLIKELY(!first.m_it.primitive_iterator.is_begin()
+                                         || !last.m_it.primitive_iterator.is_end()))
+                {
+                    JSON_THROW(invalid_iterator::create(204, "iterators out of range", *first.m_object));
+                }
+                break;
+            }
+
+            case value_t::null:
+            case value_t::object:
+            case value_t::array:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+                break;
+        }
+
+        switch (m_type)
+        {
+            case value_t::number_integer:
+            {
+                m_value.number_integer = first.m_object->m_value.number_integer;
+                break;
+            }
+
+            case value_t::number_unsigned:
+            {
+                m_value.number_unsigned = first.m_object->m_value.number_unsigned;
+                break;
+            }
+
+            case value_t::number_float:
+            {
+                m_value.number_float = first.m_object->m_value.number_float;
+                break;
+            }
+
+            case value_t::boolean:
+            {
+                m_value.boolean = first.m_object->m_value.boolean;
+                break;
+            }
+
+            case value_t::string:
+            {
+                m_value = *first.m_object->m_value.string;
+                break;
+            }
+
+            case value_t::object:
+            {
+                m_value.object = create<object_t>(first.m_it.object_iterator,
+                                                  last.m_it.object_iterator);
+                break;
+            }
+
+            case value_t::array:
+            {
+                m_value.array = create<array_t>(first.m_it.array_iterator,
+                                                last.m_it.array_iterator);
+                break;
+            }
+
+            case value_t::binary:
+            {
+                m_value = *first.m_object->m_value.binary;
+                break;
+            }
+
+            case value_t::null:
+            case value_t::discarded:
+            default:
+                JSON_THROW(invalid_iterator::create(206, "cannot construct with iterators from " + std::string(first.m_object->type_name()), *first.m_object));
+        }
+
+        set_parents();
+        assert_invariant();
+    }
+
+
+    ///////////////////////////////////////
+    // other constructors and destructor //
+    ///////////////////////////////////////
+
+    template<typename JsonRef,
+             detail::enable_if_t<detail::conjunction<detail::is_json_ref<JsonRef>,
+                                 std::is_same<typename JsonRef::value_type, basic_json>>::value, int> = 0 >
+    basic_json(const JsonRef& ref) : basic_json(ref.moved_or_copied()) {}
+
+    /// @brief copy constructor
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    basic_json(const basic_json& other)
+        : m_type(other.m_type)
+    {
+        // check of passed value is valid
+        other.assert_invariant();
+
+        switch (m_type)
+        {
+            case value_t::object:
+            {
+                m_value = *other.m_value.object;
+                break;
+            }
+
+            case value_t::array:
+            {
+                m_value = *other.m_value.array;
+                break;
+            }
+
+            case value_t::string:
+            {
+                m_value = *other.m_value.string;
+                break;
+            }
+
+            case value_t::boolean:
+            {
+                m_value = other.m_value.boolean;
+                break;
+            }
+
+            case value_t::number_integer:
+            {
+                m_value = other.m_value.number_integer;
+                break;
+            }
+
+            case value_t::number_unsigned:
+            {
+                m_value = other.m_value.number_unsigned;
+                break;
+            }
+
+            case value_t::number_float:
+            {
+                m_value = other.m_value.number_float;
+                break;
+            }
+
+            case value_t::binary:
+            {
+                m_value = *other.m_value.binary;
+                break;
+            }
+
+            case value_t::null:
+            case value_t::discarded:
+            default:
+                break;
+        }
+
+        set_parents();
+        assert_invariant();
+    }
+
+    /// @brief move constructor
+    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
+    basic_json(basic_json&& other) noexcept
+        : m_type(std::move(other.m_type)),
+          m_value(std::move(other.m_value))
+    {
+        // check that passed value is valid
+        other.assert_invariant(false);
+
+        // invalidate payload
+        other.m_type = value_t::null;
+        other.m_value = {};
+
+        set_parents();
+        assert_invariant();
+    }
+
+    /// @brief copy assignment
+    /// @sa https://json.nlohmann.me/api/basic_json/operator=/
+    basic_json& operator=(basic_json other) noexcept (
+        std::is_nothrow_move_constructible<value_t>::value&&
+        std::is_nothrow_move_assignable<value_t>::value&&
+        std::is_nothrow_move_constructible<json_value>::value&&
+        std::is_nothrow_move_assignable<json_value>::value
+    )
+    {
+        // check that passed value is valid
+        other.assert_invariant();
+
+        using std::swap;
+        swap(m_type, other.m_type);
+        swap(m_value, other.m_value);
+
+        set_parents();
+        assert_invariant();
+        return *this;
+    }
+
+    /// @brief destructor
+    /// @sa https://json.nlohmann.me/api/basic_json/~basic_json/
+    ~basic_json() noexcept
+    {
+        assert_invariant(false);
+        m_value.destroy(m_type);
+    }
+
+    /// @}
+
+  public:
+    ///////////////////////
+    // object inspection //
+    ///////////////////////
+
+    /// @name object inspection
+    /// Functions to inspect the type of a JSON value.
+    /// @{
+
+    /// @brief serialization
+    /// @sa https://json.nlohmann.me/api/basic_json/dump/
+    string_t dump(const int indent = -1,
+                  const char indent_char = ' ',
+                  const bool ensure_ascii = false,
+                  const error_handler_t error_handler = error_handler_t::strict) const
+    {
+        string_t result;
+        serializer s(detail::output_adapter<char, string_t>(result), indent_char, error_handler);
+
+        if (indent >= 0)
+        {
+            s.dump(*this, true, ensure_ascii, static_cast<unsigned int>(indent));
+        }
+        else
+        {
+            s.dump(*this, false, ensure_ascii, 0);
+        }
+
+        return result;
+    }
+
+    /// @brief return the type of the JSON value (explicit)
+    /// @sa https://json.nlohmann.me/api/basic_json/type/
+    constexpr value_t type() const noexcept
+    {
+        return m_type;
+    }
+
+    /// @brief return whether type is primitive
+    /// @sa https://json.nlohmann.me/api/basic_json/is_primitive/
+    constexpr bool is_primitive() const noexcept
+    {
+        return is_null() || is_string() || is_boolean() || is_number() || is_binary();
+    }
+
+    /// @brief return whether type is structured
+    /// @sa https://json.nlohmann.me/api/basic_json/is_structured/
+    constexpr bool is_structured() const noexcept
+    {
+        return is_array() || is_object();
+    }
+
+    /// @brief return whether value is null
+    /// @sa https://json.nlohmann.me/api/basic_json/is_null/
+    constexpr bool is_null() const noexcept
+    {
+        return m_type == value_t::null;
+    }
+
+    /// @brief return whether value is a boolean
+    /// @sa https://json.nlohmann.me/api/basic_json/is_boolean/
+    constexpr bool is_boolean() const noexcept
+    {
+        return m_type == value_t::boolean;
+    }
+
+    /// @brief return whether value is a number
+    /// @sa https://json.nlohmann.me/api/basic_json/is_number/
+    constexpr bool is_number() const noexcept
+    {
+        return is_number_integer() || is_number_float();
+    }
+
+    /// @brief return whether value is an integer number
+    /// @sa https://json.nlohmann.me/api/basic_json/is_number_integer/
+    constexpr bool is_number_integer() const noexcept
+    {
+        return m_type == value_t::number_integer || m_type == value_t::number_unsigned;
+    }
+
+    /// @brief return whether value is an unsigned integer number
+    /// @sa https://json.nlohmann.me/api/basic_json/is_number_unsigned/
+    constexpr bool is_number_unsigned() const noexcept
+    {
+        return m_type == value_t::number_unsigned;
+    }
+
+    /// @brief return whether value is a floating-point number
+    /// @sa https://json.nlohmann.me/api/basic_json/is_number_float/
+    constexpr bool is_number_float() const noexcept
+    {
+        return m_type == value_t::number_float;
+    }
+
+    /// @brief return whether value is an object
+    /// @sa https://json.nlohmann.me/api/basic_json/is_object/
+    constexpr bool is_object() const noexcept
+    {
+        return m_type == value_t::object;
+    }
+
+    /// @brief return whether value is an array
+    /// @sa https://json.nlohmann.me/api/basic_json/is_array/
+    constexpr bool is_array() const noexcept
+    {
+        return m_type == value_t::array;
+    }
+
+    /// @brief return whether value is a string
+    /// @sa https://json.nlohmann.me/api/basic_json/is_string/
+    constexpr bool is_string() const noexcept
+    {
+        return m_type == value_t::string;
+    }
+
+    /// @brief return whether value is a binary array
+    /// @sa https://json.nlohmann.me/api/basic_json/is_binary/
+    constexpr bool is_binary() const noexcept
+    {
+        return m_type == value_t::binary;
+    }
+
+    /// @brief return whether value is discarded
+    /// @sa https://json.nlohmann.me/api/basic_json/is_discarded/
+    constexpr bool is_discarded() const noexcept
+    {
+        return m_type == value_t::discarded;
+    }
+
+    /// @brief return the type of the JSON value (implicit)
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_value_t/
+    constexpr operator value_t() const noexcept
+    {
+        return m_type;
+    }
+
+    /// @}
+
+  private:
+    //////////////////
+    // value access //
+    //////////////////
+
+    /// get a boolean (explicit)
+    boolean_t get_impl(boolean_t* /*unused*/) const
+    {
+        if (JSON_HEDLEY_LIKELY(is_boolean()))
+        {
+            return m_value.boolean;
+        }
+
+        JSON_THROW(type_error::create(302, "type must be boolean, but is " + std::string(type_name()), *this));
+    }
+
+    /// get a pointer to the value (object)
+    object_t* get_impl_ptr(object_t* /*unused*/) noexcept
+    {
+        return is_object() ? m_value.object : nullptr;
+    }
+
+    /// get a pointer to the value (object)
+    constexpr const object_t* get_impl_ptr(const object_t* /*unused*/) const noexcept
+    {
+        return is_object() ? m_value.object : nullptr;
+    }
+
+    /// get a pointer to the value (array)
+    array_t* get_impl_ptr(array_t* /*unused*/) noexcept
+    {
+        return is_array() ? m_value.array : nullptr;
+    }
+
+    /// get a pointer to the value (array)
+    constexpr const array_t* get_impl_ptr(const array_t* /*unused*/) const noexcept
+    {
+        return is_array() ? m_value.array : nullptr;
+    }
+
+    /// get a pointer to the value (string)
+    string_t* get_impl_ptr(string_t* /*unused*/) noexcept
+    {
+        return is_string() ? m_value.string : nullptr;
+    }
+
+    /// get a pointer to the value (string)
+    constexpr const string_t* get_impl_ptr(const string_t* /*unused*/) const noexcept
+    {
+        return is_string() ? m_value.string : nullptr;
+    }
+
+    /// get a pointer to the value (boolean)
+    boolean_t* get_impl_ptr(boolean_t* /*unused*/) noexcept
+    {
+        return is_boolean() ? &m_value.boolean : nullptr;
+    }
+
+    /// get a pointer to the value (boolean)
+    constexpr const boolean_t* get_impl_ptr(const boolean_t* /*unused*/) const noexcept
+    {
+        return is_boolean() ? &m_value.boolean : nullptr;
+    }
+
+    /// get a pointer to the value (integer number)
+    number_integer_t* get_impl_ptr(number_integer_t* /*unused*/) noexcept
+    {
+        return is_number_integer() ? &m_value.number_integer : nullptr;
+    }
+
+    /// get a pointer to the value (integer number)
+    constexpr const number_integer_t* get_impl_ptr(const number_integer_t* /*unused*/) const noexcept
+    {
+        return is_number_integer() ? &m_value.number_integer : nullptr;
+    }
+
+    /// get a pointer to the value (unsigned number)
+    number_unsigned_t* get_impl_ptr(number_unsigned_t* /*unused*/) noexcept
+    {
+        return is_number_unsigned() ? &m_value.number_unsigned : nullptr;
+    }
+
+    /// get a pointer to the value (unsigned number)
+    constexpr const number_unsigned_t* get_impl_ptr(const number_unsigned_t* /*unused*/) const noexcept
+    {
+        return is_number_unsigned() ? &m_value.number_unsigned : nullptr;
+    }
+
+    /// get a pointer to the value (floating-point number)
+    number_float_t* get_impl_ptr(number_float_t* /*unused*/) noexcept
+    {
+        return is_number_float() ? &m_value.number_float : nullptr;
+    }
+
+    /// get a pointer to the value (floating-point number)
+    constexpr const number_float_t* get_impl_ptr(const number_float_t* /*unused*/) const noexcept
+    {
+        return is_number_float() ? &m_value.number_float : nullptr;
+    }
+
+    /// get a pointer to the value (binary)
+    binary_t* get_impl_ptr(binary_t* /*unused*/) noexcept
+    {
+        return is_binary() ? m_value.binary : nullptr;
+    }
+
+    /// get a pointer to the value (binary)
+    constexpr const binary_t* get_impl_ptr(const binary_t* /*unused*/) const noexcept
+    {
+        return is_binary() ? m_value.binary : nullptr;
+    }
+
+    /*!
+    @brief helper function to implement get_ref()
+
+    This function helps to implement get_ref() without code duplication for
+    const and non-const overloads
+
+    @tparam ThisType will be deduced as `basic_json` or `const basic_json`
+
+    @throw type_error.303 if ReferenceType does not match underlying value
+    type of the current JSON
+    */
+    template<typename ReferenceType, typename ThisType>
+    static ReferenceType get_ref_impl(ThisType& obj)
+    {
+        // delegate the call to get_ptr<>()
+        auto* ptr = obj.template get_ptr<typename std::add_pointer<ReferenceType>::type>();
+
+        if (JSON_HEDLEY_LIKELY(ptr != nullptr))
+        {
+            return *ptr;
+        }
+
+        JSON_THROW(type_error::create(303, "incompatible ReferenceType for get_ref, actual type is " + std::string(obj.type_name()), obj));
+    }
+
+  public:
+    /// @name value access
+    /// Direct access to the stored value of a JSON value.
+    /// @{
+
+    /// @brief get a pointer value (implicit)
+    /// @sa https://json.nlohmann.me/api/basic_json/get_ptr/
+    template<typename PointerType, typename std::enable_if<
+                 std::is_pointer<PointerType>::value, int>::type = 0>
+    auto get_ptr() noexcept -> decltype(std::declval<basic_json_t&>().get_impl_ptr(std::declval<PointerType>()))
+    {
+        // delegate the call to get_impl_ptr<>()
+        return get_impl_ptr(static_cast<PointerType>(nullptr));
+    }
+
+    /// @brief get a pointer value (implicit)
+    /// @sa https://json.nlohmann.me/api/basic_json/get_ptr/
+    template < typename PointerType, typename std::enable_if <
+                   std::is_pointer<PointerType>::value&&
+                   std::is_const<typename std::remove_pointer<PointerType>::type>::value, int >::type = 0 >
+    constexpr auto get_ptr() const noexcept -> decltype(std::declval<const basic_json_t&>().get_impl_ptr(std::declval<PointerType>()))
+    {
+        // delegate the call to get_impl_ptr<>() const
+        return get_impl_ptr(static_cast<PointerType>(nullptr));
+    }
+
+  private:
+    /*!
+    @brief get a value (explicit)
+
+    Explicit type conversion between the JSON value and a compatible value
+    which is [CopyConstructible](https://en.cppreference.com/w/cpp/named_req/CopyConstructible)
+    and [DefaultConstructible](https://en.cppreference.com/w/cpp/named_req/DefaultConstructible).
+    The value is converted by calling the @ref json_serializer<ValueType>
+    `from_json()` method.
+
+    The function is equivalent to executing
+    @code {.cpp}
+    ValueType ret;
+    JSONSerializer<ValueType>::from_json(*this, ret);
+    return ret;
+    @endcode
+
+    This overloads is chosen if:
+    - @a ValueType is not @ref basic_json,
+    - @ref json_serializer<ValueType> has a `from_json()` method of the form
+      `void from_json(const basic_json&, ValueType&)`, and
+    - @ref json_serializer<ValueType> does not have a `from_json()` method of
+      the form `ValueType from_json(const basic_json&)`
+
+    @tparam ValueType the returned value type
+
+    @return copy of the JSON value, converted to @a ValueType
+
+    @throw what @ref json_serializer<ValueType> `from_json()` method throws
+
+    @liveexample{The example below shows several conversions from JSON values
+    to other types. There a few things to note: (1) Floating-point numbers can
+    be converted to integers\, (2) A JSON array can be converted to a standard
+    `std::vector<short>`\, (3) A JSON object can be converted to C++
+    associative containers such as `std::unordered_map<std::string\,
+    json>`.,get__ValueType_const}
+
+    @since version 2.1.0
+    */
+    template < typename ValueType,
+               detail::enable_if_t <
+                   detail::is_default_constructible<ValueType>::value&&
+                   detail::has_from_json<basic_json_t, ValueType>::value,
+                   int > = 0 >
+    ValueType get_impl(detail::priority_tag<0> /*unused*/) const noexcept(noexcept(
+                JSONSerializer<ValueType>::from_json(std::declval<const basic_json_t&>(), std::declval<ValueType&>())))
+    {
+        auto ret = ValueType();
+        JSONSerializer<ValueType>::from_json(*this, ret);
+        return ret;
+    }
+
+    /*!
+    @brief get a value (explicit); special case
+
+    Explicit type conversion between the JSON value and a compatible value
+    which is **not** [CopyConstructible](https://en.cppreference.com/w/cpp/named_req/CopyConstructible)
+    and **not** [DefaultConstructible](https://en.cppreference.com/w/cpp/named_req/DefaultConstructible).
+    The value is converted by calling the @ref json_serializer<ValueType>
+    `from_json()` method.
+
+    The function is equivalent to executing
+    @code {.cpp}
+    return JSONSerializer<ValueType>::from_json(*this);
+    @endcode
+
+    This overloads is chosen if:
+    - @a ValueType is not @ref basic_json and
+    - @ref json_serializer<ValueType> has a `from_json()` method of the form
+      `ValueType from_json(const basic_json&)`
+
+    @note If @ref json_serializer<ValueType> has both overloads of
+    `from_json()`, this one is chosen.
+
+    @tparam ValueType the returned value type
+
+    @return copy of the JSON value, converted to @a ValueType
+
+    @throw what @ref json_serializer<ValueType> `from_json()` method throws
+
+    @since version 2.1.0
+    */
+    template < typename ValueType,
+               detail::enable_if_t <
+                   detail::has_non_default_from_json<basic_json_t, ValueType>::value,
+                   int > = 0 >
+    ValueType get_impl(detail::priority_tag<1> /*unused*/) const noexcept(noexcept(
+                JSONSerializer<ValueType>::from_json(std::declval<const basic_json_t&>())))
+    {
+        return JSONSerializer<ValueType>::from_json(*this);
+    }
+
+    /*!
+    @brief get special-case overload
+
+    This overloads converts the current @ref basic_json in a different
+    @ref basic_json type
+
+    @tparam BasicJsonType == @ref basic_json
+
+    @return a copy of *this, converted into @a BasicJsonType
+
+    @complexity Depending on the implementation of the called `from_json()`
+                method.
+
+    @since version 3.2.0
+    */
+    template < typename BasicJsonType,
+               detail::enable_if_t <
+                   detail::is_basic_json<BasicJsonType>::value,
+                   int > = 0 >
+    BasicJsonType get_impl(detail::priority_tag<2> /*unused*/) const
+    {
+        return *this;
+    }
+
+    /*!
+    @brief get special-case overload
+
+    This overloads avoids a lot of template boilerplate, it can be seen as the
+    identity method
+
+    @tparam BasicJsonType == @ref basic_json
+
+    @return a copy of *this
+
+    @complexity Constant.
+
+    @since version 2.1.0
+    */
+    template<typename BasicJsonType,
+             detail::enable_if_t<
+                 std::is_same<BasicJsonType, basic_json_t>::value,
+                 int> = 0>
+    basic_json get_impl(detail::priority_tag<3> /*unused*/) const
+    {
+        return *this;
+    }
+
+    /*!
+    @brief get a pointer value (explicit)
+    @copydoc get()
+    */
+    template<typename PointerType,
+             detail::enable_if_t<
+                 std::is_pointer<PointerType>::value,
+                 int> = 0>
+    constexpr auto get_impl(detail::priority_tag<4> /*unused*/) const noexcept
+    -> decltype(std::declval<const basic_json_t&>().template get_ptr<PointerType>())
+    {
+        // delegate the call to get_ptr
+        return get_ptr<PointerType>();
+    }
+
+  public:
+    /*!
+    @brief get a (pointer) value (explicit)
+
+    Performs explicit type conversion between the JSON value and a compatible value if required.
+
+    - If the requested type is a pointer to the internally stored JSON value that pointer is returned.
+    No copies are made.
+
+    - If the requested type is the current @ref basic_json, or a different @ref basic_json convertible
+    from the current @ref basic_json.
+
+    - Otherwise the value is converted by calling the @ref json_serializer<ValueType> `from_json()`
+    method.
+
+    @tparam ValueTypeCV the provided value type
+    @tparam ValueType the returned value type
+
+    @return copy of the JSON value, converted to @tparam ValueType if necessary
+
+    @throw what @ref json_serializer<ValueType> `from_json()` method throws if conversion is required
+
+    @since version 2.1.0
+    */
+    template < typename ValueTypeCV, typename ValueType = detail::uncvref_t<ValueTypeCV>>
+#if defined(JSON_HAS_CPP_14)
+    constexpr
+#endif
+    auto get() const noexcept(
+    noexcept(std::declval<const basic_json_t&>().template get_impl<ValueType>(detail::priority_tag<4> {})))
+    -> decltype(std::declval<const basic_json_t&>().template get_impl<ValueType>(detail::priority_tag<4> {}))
+    {
+        // we cannot static_assert on ValueTypeCV being non-const, because
+        // there is support for get<const basic_json_t>(), which is why we
+        // still need the uncvref
+        static_assert(!std::is_reference<ValueTypeCV>::value,
+                      "get() cannot be used with reference types, you might want to use get_ref()");
+        return get_impl<ValueType>(detail::priority_tag<4> {});
+    }
+
+    /*!
+    @brief get a pointer value (explicit)
+
+    Explicit pointer access to the internally stored JSON value. No copies are
+    made.
+
+    @warning The pointer becomes invalid if the underlying JSON object
+    changes.
+
+    @tparam PointerType pointer type; must be a pointer to @ref array_t, @ref
+    object_t, @ref string_t, @ref boolean_t, @ref number_integer_t,
+    @ref number_unsigned_t, or @ref number_float_t.
+
+    @return pointer to the internally stored JSON value if the requested
+    pointer type @a PointerType fits to the JSON value; `nullptr` otherwise
+
+    @complexity Constant.
+
+    @liveexample{The example below shows how pointers to internal values of a
+    JSON value can be requested. Note that no type conversions are made and a
+    `nullptr` is returned if the value and the requested pointer type does not
+    match.,get__PointerType}
+
+    @sa see @ref get_ptr() for explicit pointer-member access
+
+    @since version 1.0.0
+    */
+    template<typename PointerType, typename std::enable_if<
+                 std::is_pointer<PointerType>::value, int>::type = 0>
+    auto get() noexcept -> decltype(std::declval<basic_json_t&>().template get_ptr<PointerType>())
+    {
+        // delegate the call to get_ptr
+        return get_ptr<PointerType>();
+    }
+
+    /// @brief get a value (explicit)
+    /// @sa https://json.nlohmann.me/api/basic_json/get_to/
+    template < typename ValueType,
+               detail::enable_if_t <
+                   !detail::is_basic_json<ValueType>::value&&
+                   detail::has_from_json<basic_json_t, ValueType>::value,
+                   int > = 0 >
+    ValueType & get_to(ValueType& v) const noexcept(noexcept(
+                JSONSerializer<ValueType>::from_json(std::declval<const basic_json_t&>(), v)))
+    {
+        JSONSerializer<ValueType>::from_json(*this, v);
+        return v;
+    }
+
+    // specialization to allow calling get_to with a basic_json value
+    // see https://github.com/nlohmann/json/issues/2175
+    template<typename ValueType,
+             detail::enable_if_t <
+                 detail::is_basic_json<ValueType>::value,
+                 int> = 0>
+    ValueType & get_to(ValueType& v) const
+    {
+        v = *this;
+        return v;
+    }
+
+    template <
+        typename T, std::size_t N,
+        typename Array = T (&)[N], // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
+        detail::enable_if_t <
+            detail::has_from_json<basic_json_t, Array>::value, int > = 0 >
+    Array get_to(T (&v)[N]) const // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
+    noexcept(noexcept(JSONSerializer<Array>::from_json(
+                          std::declval<const basic_json_t&>(), v)))
+    {
+        JSONSerializer<Array>::from_json(*this, v);
+        return v;
+    }
+
+    /// @brief get a reference value (implicit)
+    /// @sa https://json.nlohmann.me/api/basic_json/get_ref/
+    template<typename ReferenceType, typename std::enable_if<
+                 std::is_reference<ReferenceType>::value, int>::type = 0>
+    ReferenceType get_ref()
+    {
+        // delegate call to get_ref_impl
+        return get_ref_impl<ReferenceType>(*this);
+    }
+
+    /// @brief get a reference value (implicit)
+    /// @sa https://json.nlohmann.me/api/basic_json/get_ref/
+    template < typename ReferenceType, typename std::enable_if <
+                   std::is_reference<ReferenceType>::value&&
+                   std::is_const<typename std::remove_reference<ReferenceType>::type>::value, int >::type = 0 >
+    ReferenceType get_ref() const
+    {
+        // delegate call to get_ref_impl
+        return get_ref_impl<ReferenceType>(*this);
+    }
+
+    /*!
+    @brief get a value (implicit)
+
+    Implicit type conversion between the JSON value and a compatible value.
+    The call is realized by calling @ref get() const.
+
+    @tparam ValueType non-pointer type compatible to the JSON value, for
+    instance `int` for JSON integer numbers, `bool` for JSON booleans, or
+    `std::vector` types for JSON arrays. The character type of @ref string_t
+    as well as an initializer list of this type is excluded to avoid
+    ambiguities as these types implicitly convert to `std::string`.
+
+    @return copy of the JSON value, converted to type @a ValueType
+
+    @throw type_error.302 in case passed type @a ValueType is incompatible
+    to the JSON value type (e.g., the JSON value is of type boolean, but a
+    string is requested); see example below
+
+    @complexity Linear in the size of the JSON value.
+
+    @liveexample{The example below shows several conversions from JSON values
+    to other types. There a few things to note: (1) Floating-point numbers can
+    be converted to integers\, (2) A JSON array can be converted to a standard
+    `std::vector<short>`\, (3) A JSON object can be converted to C++
+    associative containers such as `std::unordered_map<std::string\,
+    json>`.,operator__ValueType}
+
+    @since version 1.0.0
+    */
+    template < typename ValueType, typename std::enable_if <
+                   detail::conjunction <
+                       detail::negation<std::is_pointer<ValueType>>,
+                       detail::negation<std::is_same<ValueType, detail::json_ref<basic_json>>>,
+                                        detail::negation<std::is_same<ValueType, typename string_t::value_type>>,
+                                        detail::negation<detail::is_basic_json<ValueType>>,
+                                        detail::negation<std::is_same<ValueType, std::initializer_list<typename string_t::value_type>>>,
+
+#if defined(JSON_HAS_CPP_17) && (defined(__GNUC__) || (defined(_MSC_VER) && _MSC_VER >= 1910 && _MSC_VER <= 1914))
+                                                detail::negation<std::is_same<ValueType, std::string_view>>,
+#endif
+                                                detail::is_detected_lazy<detail::get_template_function, const basic_json_t&, ValueType>
+                                                >::value, int >::type = 0 >
+                                        JSON_EXPLICIT operator ValueType() const
+    {
+        // delegate the call to get<>() const
+        return get<ValueType>();
+    }
+
+    /// @brief get a binary value
+    /// @sa https://json.nlohmann.me/api/basic_json/get_binary/
+    binary_t& get_binary()
+    {
+        if (!is_binary())
+        {
+            JSON_THROW(type_error::create(302, "type must be binary, but is " + std::string(type_name()), *this));
+        }
+
+        return *get_ptr<binary_t*>();
+    }
+
+    /// @brief get a binary value
+    /// @sa https://json.nlohmann.me/api/basic_json/get_binary/
+    const binary_t& get_binary() const
+    {
+        if (!is_binary())
+        {
+            JSON_THROW(type_error::create(302, "type must be binary, but is " + std::string(type_name()), *this));
+        }
+
+        return *get_ptr<const binary_t*>();
+    }
+
+    /// @}
+
+
+    ////////////////////
+    // element access //
+    ////////////////////
+
+    /// @name element access
+    /// Access to the JSON value.
+    /// @{
+
+    /// @brief access specified array element with bounds checking
+    /// @sa https://json.nlohmann.me/api/basic_json/at/
+    reference at(size_type idx)
+    {
+        // at only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            JSON_TRY
+            {
+                return set_parent(m_value.array->at(idx));
+            }
+            JSON_CATCH (std::out_of_range&)
+            {
+                // create better exception explanation
+                JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", *this));
+            }
+        }
+        else
+        {
+            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief access specified array element with bounds checking
+    /// @sa https://json.nlohmann.me/api/basic_json/at/
+    const_reference at(size_type idx) const
+    {
+        // at only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            JSON_TRY
+            {
+                return m_value.array->at(idx);
+            }
+            JSON_CATCH (std::out_of_range&)
+            {
+                // create better exception explanation
+                JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", *this));
+            }
+        }
+        else
+        {
+            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief access specified object element with bounds checking
+    /// @sa https://json.nlohmann.me/api/basic_json/at/
+    reference at(const typename object_t::key_type& key)
+    {
+        // at only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            JSON_TRY
+            {
+                return set_parent(m_value.object->at(key));
+            }
+            JSON_CATCH (std::out_of_range&)
+            {
+                // create better exception explanation
+                JSON_THROW(out_of_range::create(403, "key '" + key + "' not found", *this));
+            }
+        }
+        else
+        {
+            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief access specified object element with bounds checking
+    /// @sa https://json.nlohmann.me/api/basic_json/at/
+    const_reference at(const typename object_t::key_type& key) const
+    {
+        // at only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            JSON_TRY
+            {
+                return m_value.object->at(key);
+            }
+            JSON_CATCH (std::out_of_range&)
+            {
+                // create better exception explanation
+                JSON_THROW(out_of_range::create(403, "key '" + key + "' not found", *this));
+            }
+        }
+        else
+        {
+            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief access specified array element
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    reference operator[](size_type idx)
+    {
+        // implicitly convert null value to an empty array
+        if (is_null())
+        {
+            m_type = value_t::array;
+            m_value.array = create<array_t>();
+            assert_invariant();
+        }
+
+        // operator[] only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            // fill up array with null values if given idx is outside range
+            if (idx >= m_value.array->size())
+            {
+#if JSON_DIAGNOSTICS
+                // remember array size & capacity before resizing
+                const auto old_size = m_value.array->size();
+                const auto old_capacity = m_value.array->capacity();
+#endif
+                m_value.array->resize(idx + 1);
+
+#if JSON_DIAGNOSTICS
+                if (JSON_HEDLEY_UNLIKELY(m_value.array->capacity() != old_capacity))
+                {
+                    // capacity has changed: update all parents
+                    set_parents();
+                }
+                else
+                {
+                    // set parent for values added above
+                    set_parents(begin() + static_cast<typename iterator::difference_type>(old_size), static_cast<typename iterator::difference_type>(idx + 1 - old_size));
+                }
+#endif
+                assert_invariant();
+            }
+
+            return m_value.array->operator[](idx);
+        }
+
+        JSON_THROW(type_error::create(305, "cannot use operator[] with a numeric argument with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified array element
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    const_reference operator[](size_type idx) const
+    {
+        // const operator[] only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            return m_value.array->operator[](idx);
+        }
+
+        JSON_THROW(type_error::create(305, "cannot use operator[] with a numeric argument with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified object element
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    reference operator[](const typename object_t::key_type& key)
+    {
+        // implicitly convert null value to an empty object
+        if (is_null())
+        {
+            m_type = value_t::object;
+            m_value.object = create<object_t>();
+            assert_invariant();
+        }
+
+        // operator[] only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            return set_parent(m_value.object->operator[](key));
+        }
+
+        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified object element
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    const_reference operator[](const typename object_t::key_type& key) const
+    {
+        // const operator[] only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            JSON_ASSERT(m_value.object->find(key) != m_value.object->end());
+            return m_value.object->find(key)->second;
+        }
+
+        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified object element
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    template<typename T>
+    JSON_HEDLEY_NON_NULL(2)
+    reference operator[](T* key)
+    {
+        // implicitly convert null to object
+        if (is_null())
+        {
+            m_type = value_t::object;
+            m_value = value_t::object;
+            assert_invariant();
+        }
+
+        // at only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            return set_parent(m_value.object->operator[](key));
+        }
+
+        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified object element
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    template<typename T>
+    JSON_HEDLEY_NON_NULL(2)
+    const_reference operator[](T* key) const
+    {
+        // at only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            JSON_ASSERT(m_value.object->find(key) != m_value.object->end());
+            return m_value.object->find(key)->second;
+        }
+
+        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified object element with default value
+    /// @sa https://json.nlohmann.me/api/basic_json/value/
+    /// using std::is_convertible in a std::enable_if will fail when using explicit conversions
+    template < class ValueType, typename std::enable_if <
+                   detail::is_getable<basic_json_t, ValueType>::value
+                   && !std::is_same<value_t, ValueType>::value, int >::type = 0 >
+    ValueType value(const typename object_t::key_type& key, const ValueType& default_value) const
+    {
+        // at only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            // if key is found, return value and given default value otherwise
+            const auto it = find(key);
+            if (it != end())
+            {
+                return it->template get<ValueType>();
+            }
+
+            return default_value;
+        }
+
+        JSON_THROW(type_error::create(306, "cannot use value() with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified object element with default value
+    /// @sa https://json.nlohmann.me/api/basic_json/value/
+    /// overload for a default value of type const char*
+    string_t value(const typename object_t::key_type& key, const char* default_value) const
+    {
+        return value(key, string_t(default_value));
+    }
+
+    /// @brief access specified object element via JSON Pointer with default value
+    /// @sa https://json.nlohmann.me/api/basic_json/value/
+    template<class ValueType, typename std::enable_if<
+                 detail::is_getable<basic_json_t, ValueType>::value, int>::type = 0>
+    ValueType value(const json_pointer& ptr, const ValueType& default_value) const
+    {
+        // at only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            // if pointer resolves a value, return it or use default value
+            JSON_TRY
+            {
+                return ptr.get_checked(this).template get<ValueType>();
+            }
+            JSON_INTERNAL_CATCH (out_of_range&)
+            {
+                return default_value;
+            }
+        }
+
+        JSON_THROW(type_error::create(306, "cannot use value() with " + std::string(type_name()), *this));
+    }
+
+    /// @brief access specified object element via JSON Pointer with default value
+    /// @sa https://json.nlohmann.me/api/basic_json/value/
+    /// overload for a default value of type const char*
+    JSON_HEDLEY_NON_NULL(3)
+    string_t value(const json_pointer& ptr, const char* default_value) const
+    {
+        return value(ptr, string_t(default_value));
+    }
+
+    /// @brief access the first element
+    /// @sa https://json.nlohmann.me/api/basic_json/front/
+    reference front()
+    {
+        return *begin();
+    }
+
+    /// @brief access the first element
+    /// @sa https://json.nlohmann.me/api/basic_json/front/
+    const_reference front() const
+    {
+        return *cbegin();
+    }
+
+    /// @brief access the last element
+    /// @sa https://json.nlohmann.me/api/basic_json/back/
+    reference back()
+    {
+        auto tmp = end();
+        --tmp;
+        return *tmp;
+    }
+
+    /// @brief access the last element
+    /// @sa https://json.nlohmann.me/api/basic_json/back/
+    const_reference back() const
+    {
+        auto tmp = cend();
+        --tmp;
+        return *tmp;
+    }
+
+    /// @brief remove element given an iterator
+    /// @sa https://json.nlohmann.me/api/basic_json/erase/
+    template < class IteratorType, typename std::enable_if <
+                   std::is_same<IteratorType, typename basic_json_t::iterator>::value ||
+                   std::is_same<IteratorType, typename basic_json_t::const_iterator>::value, int >::type
+               = 0 >
+    IteratorType erase(IteratorType pos)
+    {
+        // make sure iterator fits the current value
+        if (JSON_HEDLEY_UNLIKELY(this != pos.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
+        }
+
+        IteratorType result = end();
+
+        switch (m_type)
+        {
+            case value_t::boolean:
+            case value_t::number_float:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::string:
+            case value_t::binary:
+            {
+                if (JSON_HEDLEY_UNLIKELY(!pos.m_it.primitive_iterator.is_begin()))
+                {
+                    JSON_THROW(invalid_iterator::create(205, "iterator out of range", *this));
+                }
+
+                if (is_string())
+                {
+                    AllocatorType<string_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.string);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.string, 1);
+                    m_value.string = nullptr;
+                }
+                else if (is_binary())
+                {
+                    AllocatorType<binary_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.binary);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.binary, 1);
+                    m_value.binary = nullptr;
+                }
+
+                m_type = value_t::null;
+                assert_invariant();
+                break;
+            }
+
+            case value_t::object:
+            {
+                result.m_it.object_iterator = m_value.object->erase(pos.m_it.object_iterator);
+                break;
+            }
+
+            case value_t::array:
+            {
+                result.m_it.array_iterator = m_value.array->erase(pos.m_it.array_iterator);
+                break;
+            }
+
+            case value_t::null:
+            case value_t::discarded:
+            default:
+                JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
+        }
+
+        return result;
+    }
+
+    /// @brief remove elements given an iterator range
+    /// @sa https://json.nlohmann.me/api/basic_json/erase/
+    template < class IteratorType, typename std::enable_if <
+                   std::is_same<IteratorType, typename basic_json_t::iterator>::value ||
+                   std::is_same<IteratorType, typename basic_json_t::const_iterator>::value, int >::type
+               = 0 >
+    IteratorType erase(IteratorType first, IteratorType last)
+    {
+        // make sure iterator fits the current value
+        if (JSON_HEDLEY_UNLIKELY(this != first.m_object || this != last.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(203, "iterators do not fit current value", *this));
+        }
+
+        IteratorType result = end();
+
+        switch (m_type)
+        {
+            case value_t::boolean:
+            case value_t::number_float:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::string:
+            case value_t::binary:
+            {
+                if (JSON_HEDLEY_LIKELY(!first.m_it.primitive_iterator.is_begin()
+                                       || !last.m_it.primitive_iterator.is_end()))
+                {
+                    JSON_THROW(invalid_iterator::create(204, "iterators out of range", *this));
+                }
+
+                if (is_string())
+                {
+                    AllocatorType<string_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.string);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.string, 1);
+                    m_value.string = nullptr;
+                }
+                else if (is_binary())
+                {
+                    AllocatorType<binary_t> alloc;
+                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.binary);
+                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.binary, 1);
+                    m_value.binary = nullptr;
+                }
+
+                m_type = value_t::null;
+                assert_invariant();
+                break;
+            }
+
+            case value_t::object:
+            {
+                result.m_it.object_iterator = m_value.object->erase(first.m_it.object_iterator,
+                                              last.m_it.object_iterator);
+                break;
+            }
+
+            case value_t::array:
+            {
+                result.m_it.array_iterator = m_value.array->erase(first.m_it.array_iterator,
+                                             last.m_it.array_iterator);
+                break;
+            }
+
+            case value_t::null:
+            case value_t::discarded:
+            default:
+                JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
+        }
+
+        return result;
+    }
+
+    /// @brief remove element from a JSON object given a key
+    /// @sa https://json.nlohmann.me/api/basic_json/erase/
+    size_type erase(const typename object_t::key_type& key)
+    {
+        // this erase only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            return m_value.object->erase(key);
+        }
+
+        JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
+    }
+
+    /// @brief remove element from a JSON array given an index
+    /// @sa https://json.nlohmann.me/api/basic_json/erase/
+    void erase(const size_type idx)
+    {
+        // this erase only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            if (JSON_HEDLEY_UNLIKELY(idx >= size()))
+            {
+                JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", *this));
+            }
+
+            m_value.array->erase(m_value.array->begin() + static_cast<difference_type>(idx));
+        }
+        else
+        {
+            JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @}
+
+
+    ////////////
+    // lookup //
+    ////////////
+
+    /// @name lookup
+    /// @{
+
+    /// @brief find an element in a JSON object
+    /// @sa https://json.nlohmann.me/api/basic_json/find/
+    template<typename KeyT>
+    iterator find(KeyT&& key)
+    {
+        auto result = end();
+
+        if (is_object())
+        {
+            result.m_it.object_iterator = m_value.object->find(std::forward<KeyT>(key));
+        }
+
+        return result;
+    }
+
+    /// @brief find an element in a JSON object
+    /// @sa https://json.nlohmann.me/api/basic_json/find/
+    template<typename KeyT>
+    const_iterator find(KeyT&& key) const
+    {
+        auto result = cend();
+
+        if (is_object())
+        {
+            result.m_it.object_iterator = m_value.object->find(std::forward<KeyT>(key));
+        }
+
+        return result;
+    }
+
+    /// @brief returns the number of occurrences of a key in a JSON object
+    /// @sa https://json.nlohmann.me/api/basic_json/count/
+    template<typename KeyT>
+    size_type count(KeyT&& key) const
+    {
+        // return 0 for all nonobject types
+        return is_object() ? m_value.object->count(std::forward<KeyT>(key)) : 0;
+    }
+
+    /// @brief check the existence of an element in a JSON object
+    /// @sa https://json.nlohmann.me/api/basic_json/contains/
+    template < typename KeyT, typename std::enable_if <
+                   !std::is_same<typename std::decay<KeyT>::type, json_pointer>::value, int >::type = 0 >
+    bool contains(KeyT && key) const
+    {
+        return is_object() && m_value.object->find(std::forward<KeyT>(key)) != m_value.object->end();
+    }
+
+    /// @brief check the existence of an element in a JSON object given a JSON pointer
+    /// @sa https://json.nlohmann.me/api/basic_json/contains/
+    bool contains(const json_pointer& ptr) const
+    {
+        return ptr.contains(this);
+    }
+
+    /// @}
+
+
+    ///////////////
+    // iterators //
+    ///////////////
+
+    /// @name iterators
+    /// @{
+
+    /// @brief returns an iterator to the first element
+    /// @sa https://json.nlohmann.me/api/basic_json/begin/
+    iterator begin() noexcept
+    {
+        iterator result(this);
+        result.set_begin();
+        return result;
+    }
+
+    /// @brief returns an iterator to the first element
+    /// @sa https://json.nlohmann.me/api/basic_json/begin/
+    const_iterator begin() const noexcept
+    {
+        return cbegin();
+    }
+
+    /// @brief returns a const iterator to the first element
+    /// @sa https://json.nlohmann.me/api/basic_json/cbegin/
+    const_iterator cbegin() const noexcept
+    {
+        const_iterator result(this);
+        result.set_begin();
+        return result;
+    }
+
+    /// @brief returns an iterator to one past the last element
+    /// @sa https://json.nlohmann.me/api/basic_json/end/
+    iterator end() noexcept
+    {
+        iterator result(this);
+        result.set_end();
+        return result;
+    }
+
+    /// @brief returns an iterator to one past the last element
+    /// @sa https://json.nlohmann.me/api/basic_json/end/
+    const_iterator end() const noexcept
+    {
+        return cend();
+    }
+
+    /// @brief returns an iterator to one past the last element
+    /// @sa https://json.nlohmann.me/api/basic_json/cend/
+    const_iterator cend() const noexcept
+    {
+        const_iterator result(this);
+        result.set_end();
+        return result;
+    }
+
+    /// @brief returns an iterator to the reverse-beginning
+    /// @sa https://json.nlohmann.me/api/basic_json/rbegin/
+    reverse_iterator rbegin() noexcept
+    {
+        return reverse_iterator(end());
+    }
+
+    /// @brief returns an iterator to the reverse-beginning
+    /// @sa https://json.nlohmann.me/api/basic_json/rbegin/
+    const_reverse_iterator rbegin() const noexcept
+    {
+        return crbegin();
+    }
+
+    /// @brief returns an iterator to the reverse-end
+    /// @sa https://json.nlohmann.me/api/basic_json/rend/
+    reverse_iterator rend() noexcept
+    {
+        return reverse_iterator(begin());
+    }
+
+    /// @brief returns an iterator to the reverse-end
+    /// @sa https://json.nlohmann.me/api/basic_json/rend/
+    const_reverse_iterator rend() const noexcept
+    {
+        return crend();
+    }
+
+    /// @brief returns a const reverse iterator to the last element
+    /// @sa https://json.nlohmann.me/api/basic_json/crbegin/
+    const_reverse_iterator crbegin() const noexcept
+    {
+        return const_reverse_iterator(cend());
+    }
+
+    /// @brief returns a const reverse iterator to one before the first
+    /// @sa https://json.nlohmann.me/api/basic_json/crend/
+    const_reverse_iterator crend() const noexcept
+    {
+        return const_reverse_iterator(cbegin());
+    }
+
+  public:
+    /// @brief wrapper to access iterator member functions in range-based for
+    /// @sa https://json.nlohmann.me/api/basic_json/items/
+    /// @deprecated This function is deprecated since 3.1.0 and will be removed in
+    ///             version 4.0.0 of the library. Please use @ref items() instead;
+    ///             that is, replace `json::iterator_wrapper(j)` with `j.items()`.
+    JSON_HEDLEY_DEPRECATED_FOR(3.1.0, items())
+    static iteration_proxy<iterator> iterator_wrapper(reference ref) noexcept
+    {
+        return ref.items();
+    }
+
+    /// @brief wrapper to access iterator member functions in range-based for
+    /// @sa https://json.nlohmann.me/api/basic_json/items/
+    /// @deprecated This function is deprecated since 3.1.0 and will be removed in
+    ///         version 4.0.0 of the library. Please use @ref items() instead;
+    ///         that is, replace `json::iterator_wrapper(j)` with `j.items()`.
+    JSON_HEDLEY_DEPRECATED_FOR(3.1.0, items())
+    static iteration_proxy<const_iterator> iterator_wrapper(const_reference ref) noexcept
+    {
+        return ref.items();
+    }
+
+    /// @brief helper to access iterator member functions in range-based for
+    /// @sa https://json.nlohmann.me/api/basic_json/items/
+    iteration_proxy<iterator> items() noexcept
+    {
+        return iteration_proxy<iterator>(*this);
+    }
+
+    /// @brief helper to access iterator member functions in range-based for
+    /// @sa https://json.nlohmann.me/api/basic_json/items/
+    iteration_proxy<const_iterator> items() const noexcept
+    {
+        return iteration_proxy<const_iterator>(*this);
+    }
+
+    /// @}
+
+
+    //////////////
+    // capacity //
+    //////////////
+
+    /// @name capacity
+    /// @{
+
+    /// @brief checks whether the container is empty.
+    /// @sa https://json.nlohmann.me/api/basic_json/empty/
+    bool empty() const noexcept
+    {
+        switch (m_type)
+        {
+            case value_t::null:
+            {
+                // null values are empty
+                return true;
+            }
+
+            case value_t::array:
+            {
+                // delegate call to array_t::empty()
+                return m_value.array->empty();
+            }
+
+            case value_t::object:
+            {
+                // delegate call to object_t::empty()
+                return m_value.object->empty();
+            }
+
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                // all other types are nonempty
+                return false;
+            }
+        }
+    }
+
+    /// @brief returns the number of elements
+    /// @sa https://json.nlohmann.me/api/basic_json/size/
+    size_type size() const noexcept
+    {
+        switch (m_type)
+        {
+            case value_t::null:
+            {
+                // null values are empty
+                return 0;
+            }
+
+            case value_t::array:
+            {
+                // delegate call to array_t::size()
+                return m_value.array->size();
+            }
+
+            case value_t::object:
+            {
+                // delegate call to object_t::size()
+                return m_value.object->size();
+            }
+
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                // all other types have size 1
+                return 1;
+            }
+        }
+    }
+
+    /// @brief returns the maximum possible number of elements
+    /// @sa https://json.nlohmann.me/api/basic_json/max_size/
+    size_type max_size() const noexcept
+    {
+        switch (m_type)
+        {
+            case value_t::array:
+            {
+                // delegate call to array_t::max_size()
+                return m_value.array->max_size();
+            }
+
+            case value_t::object:
+            {
+                // delegate call to object_t::max_size()
+                return m_value.object->max_size();
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                // all other types have max_size() == size()
+                return size();
+            }
+        }
+    }
+
+    /// @}
+
+
+    ///////////////
+    // modifiers //
+    ///////////////
+
+    /// @name modifiers
+    /// @{
+
+    /// @brief clears the contents
+    /// @sa https://json.nlohmann.me/api/basic_json/clear/
+    void clear() noexcept
+    {
+        switch (m_type)
+        {
+            case value_t::number_integer:
+            {
+                m_value.number_integer = 0;
+                break;
+            }
+
+            case value_t::number_unsigned:
+            {
+                m_value.number_unsigned = 0;
+                break;
+            }
+
+            case value_t::number_float:
+            {
+                m_value.number_float = 0.0;
+                break;
+            }
+
+            case value_t::boolean:
+            {
+                m_value.boolean = false;
+                break;
+            }
+
+            case value_t::string:
+            {
+                m_value.string->clear();
+                break;
+            }
+
+            case value_t::binary:
+            {
+                m_value.binary->clear();
+                break;
+            }
+
+            case value_t::array:
+            {
+                m_value.array->clear();
+                break;
+            }
+
+            case value_t::object:
+            {
+                m_value.object->clear();
+                break;
+            }
+
+            case value_t::null:
+            case value_t::discarded:
+            default:
+                break;
+        }
+    }
+
+    /// @brief add an object to an array
+    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
+    void push_back(basic_json&& val)
+    {
+        // push_back only works for null objects or arrays
+        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_array())))
+        {
+            JSON_THROW(type_error::create(308, "cannot use push_back() with " + std::string(type_name()), *this));
+        }
+
+        // transform null object into an array
+        if (is_null())
+        {
+            m_type = value_t::array;
+            m_value = value_t::array;
+            assert_invariant();
+        }
+
+        // add element to array (move semantics)
+        const auto old_capacity = m_value.array->capacity();
+        m_value.array->push_back(std::move(val));
+        set_parent(m_value.array->back(), old_capacity);
+        // if val is moved from, basic_json move constructor marks it null, so we do not call the destructor
+    }
+
+    /// @brief add an object to an array
+    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
+    reference operator+=(basic_json&& val)
+    {
+        push_back(std::move(val));
+        return *this;
+    }
+
+    /// @brief add an object to an array
+    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
+    void push_back(const basic_json& val)
+    {
+        // push_back only works for null objects or arrays
+        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_array())))
+        {
+            JSON_THROW(type_error::create(308, "cannot use push_back() with " + std::string(type_name()), *this));
+        }
+
+        // transform null object into an array
+        if (is_null())
+        {
+            m_type = value_t::array;
+            m_value = value_t::array;
+            assert_invariant();
+        }
+
+        // add element to array
+        const auto old_capacity = m_value.array->capacity();
+        m_value.array->push_back(val);
+        set_parent(m_value.array->back(), old_capacity);
+    }
+
+    /// @brief add an object to an array
+    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
+    reference operator+=(const basic_json& val)
+    {
+        push_back(val);
+        return *this;
+    }
+
+    /// @brief add an object to an object
+    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
+    void push_back(const typename object_t::value_type& val)
+    {
+        // push_back only works for null objects or objects
+        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_object())))
+        {
+            JSON_THROW(type_error::create(308, "cannot use push_back() with " + std::string(type_name()), *this));
+        }
+
+        // transform null object into an object
+        if (is_null())
+        {
+            m_type = value_t::object;
+            m_value = value_t::object;
+            assert_invariant();
+        }
+
+        // add element to object
+        auto res = m_value.object->insert(val);
+        set_parent(res.first->second);
+    }
+
+    /// @brief add an object to an object
+    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
+    reference operator+=(const typename object_t::value_type& val)
+    {
+        push_back(val);
+        return *this;
+    }
+
+    /// @brief add an object to an object
+    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
+    void push_back(initializer_list_t init)
+    {
+        if (is_object() && init.size() == 2 && (*init.begin())->is_string())
+        {
+            basic_json&& key = init.begin()->moved_or_copied();
+            push_back(typename object_t::value_type(
+                          std::move(key.get_ref<string_t&>()), (init.begin() + 1)->moved_or_copied()));
+        }
+        else
+        {
+            push_back(basic_json(init));
+        }
+    }
+
+    /// @brief add an object to an object
+    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
+    reference operator+=(initializer_list_t init)
+    {
+        push_back(init);
+        return *this;
+    }
+
+    /// @brief add an object to an array
+    /// @sa https://json.nlohmann.me/api/basic_json/emplace_back/
+    template<class... Args>
+    reference emplace_back(Args&& ... args)
+    {
+        // emplace_back only works for null objects or arrays
+        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_array())))
+        {
+            JSON_THROW(type_error::create(311, "cannot use emplace_back() with " + std::string(type_name()), *this));
+        }
+
+        // transform null object into an array
+        if (is_null())
+        {
+            m_type = value_t::array;
+            m_value = value_t::array;
+            assert_invariant();
+        }
+
+        // add element to array (perfect forwarding)
+        const auto old_capacity = m_value.array->capacity();
+        m_value.array->emplace_back(std::forward<Args>(args)...);
+        return set_parent(m_value.array->back(), old_capacity);
+    }
+
+    /// @brief add an object to an object if key does not exist
+    /// @sa https://json.nlohmann.me/api/basic_json/emplace/
+    template<class... Args>
+    std::pair<iterator, bool> emplace(Args&& ... args)
+    {
+        // emplace only works for null objects or arrays
+        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_object())))
+        {
+            JSON_THROW(type_error::create(311, "cannot use emplace() with " + std::string(type_name()), *this));
+        }
+
+        // transform null object into an object
+        if (is_null())
+        {
+            m_type = value_t::object;
+            m_value = value_t::object;
+            assert_invariant();
+        }
+
+        // add element to array (perfect forwarding)
+        auto res = m_value.object->emplace(std::forward<Args>(args)...);
+        set_parent(res.first->second);
+
+        // create result iterator and set iterator to the result of emplace
+        auto it = begin();
+        it.m_it.object_iterator = res.first;
+
+        // return pair of iterator and boolean
+        return {it, res.second};
+    }
+
+    /// Helper for insertion of an iterator
+    /// @note: This uses std::distance to support GCC 4.8,
+    ///        see https://github.com/nlohmann/json/pull/1257
+    template<typename... Args>
+    iterator insert_iterator(const_iterator pos, Args&& ... args)
+    {
+        iterator result(this);
+        JSON_ASSERT(m_value.array != nullptr);
+
+        auto insert_pos = std::distance(m_value.array->begin(), pos.m_it.array_iterator);
+        m_value.array->insert(pos.m_it.array_iterator, std::forward<Args>(args)...);
+        result.m_it.array_iterator = m_value.array->begin() + insert_pos;
+
+        // This could have been written as:
+        // result.m_it.array_iterator = m_value.array->insert(pos.m_it.array_iterator, cnt, val);
+        // but the return value of insert is missing in GCC 4.8, so it is written this way instead.
+
+        set_parents();
+        return result;
+    }
+
+    /// @brief inserts element into array
+    /// @sa https://json.nlohmann.me/api/basic_json/insert/
+    iterator insert(const_iterator pos, const basic_json& val)
+    {
+        // insert only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            // check if iterator pos fits to this JSON value
+            if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
+            {
+                JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
+            }
+
+            // insert to array and return iterator
+            return insert_iterator(pos, val);
+        }
+
+        JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
+    }
+
+    /// @brief inserts element into array
+    /// @sa https://json.nlohmann.me/api/basic_json/insert/
+    iterator insert(const_iterator pos, basic_json&& val)
+    {
+        return insert(pos, val);
+    }
+
+    /// @brief inserts copies of element into array
+    /// @sa https://json.nlohmann.me/api/basic_json/insert/
+    iterator insert(const_iterator pos, size_type cnt, const basic_json& val)
+    {
+        // insert only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            // check if iterator pos fits to this JSON value
+            if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
+            {
+                JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
+            }
+
+            // insert to array and return iterator
+            return insert_iterator(pos, cnt, val);
+        }
+
+        JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
+    }
+
+    /// @brief inserts range of elements into array
+    /// @sa https://json.nlohmann.me/api/basic_json/insert/
+    iterator insert(const_iterator pos, const_iterator first, const_iterator last)
+    {
+        // insert only works for arrays
+        if (JSON_HEDLEY_UNLIKELY(!is_array()))
+        {
+            JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
+        }
+
+        // check if iterator pos fits to this JSON value
+        if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
+        {
+            JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
+        }
+
+        // check if range iterators belong to the same JSON object
+        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(210, "iterators do not fit", *this));
+        }
+
+        if (JSON_HEDLEY_UNLIKELY(first.m_object == this))
+        {
+            JSON_THROW(invalid_iterator::create(211, "passed iterators may not belong to container", *this));
+        }
+
+        // insert to array and return iterator
+        return insert_iterator(pos, first.m_it.array_iterator, last.m_it.array_iterator);
+    }
+
+    /// @brief inserts elements from initializer list into array
+    /// @sa https://json.nlohmann.me/api/basic_json/insert/
+    iterator insert(const_iterator pos, initializer_list_t ilist)
+    {
+        // insert only works for arrays
+        if (JSON_HEDLEY_UNLIKELY(!is_array()))
+        {
+            JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
+        }
+
+        // check if iterator pos fits to this JSON value
+        if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
+        {
+            JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
+        }
+
+        // insert to array and return iterator
+        return insert_iterator(pos, ilist.begin(), ilist.end());
+    }
+
+    /// @brief inserts range of elements into object
+    /// @sa https://json.nlohmann.me/api/basic_json/insert/
+    void insert(const_iterator first, const_iterator last)
+    {
+        // insert only works for objects
+        if (JSON_HEDLEY_UNLIKELY(!is_object()))
+        {
+            JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
+        }
+
+        // check if range iterators belong to the same JSON object
+        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(210, "iterators do not fit", *this));
+        }
+
+        // passed iterators must belong to objects
+        if (JSON_HEDLEY_UNLIKELY(!first.m_object->is_object()))
+        {
+            JSON_THROW(invalid_iterator::create(202, "iterators first and last must point to objects", *this));
+        }
+
+        m_value.object->insert(first.m_it.object_iterator, last.m_it.object_iterator);
+    }
+
+    /// @brief updates a JSON object from another object, overwriting existing keys
+    /// @sa https://json.nlohmann.me/api/basic_json/update/
+    void update(const_reference j, bool merge_objects = false)
+    {
+        update(j.begin(), j.end(), merge_objects);
+    }
+
+    /// @brief updates a JSON object from another object, overwriting existing keys
+    /// @sa https://json.nlohmann.me/api/basic_json/update/
+    void update(const_iterator first, const_iterator last, bool merge_objects = false)
+    {
+        // implicitly convert null value to an empty object
+        if (is_null())
+        {
+            m_type = value_t::object;
+            m_value.object = create<object_t>();
+            assert_invariant();
+        }
+
+        if (JSON_HEDLEY_UNLIKELY(!is_object()))
+        {
+            JSON_THROW(type_error::create(312, "cannot use update() with " + std::string(type_name()), *this));
+        }
+
+        // check if range iterators belong to the same JSON object
+        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
+        {
+            JSON_THROW(invalid_iterator::create(210, "iterators do not fit", *this));
+        }
+
+        // passed iterators must belong to objects
+        if (JSON_HEDLEY_UNLIKELY(!first.m_object->is_object()))
+        {
+            JSON_THROW(type_error::create(312, "cannot use update() with " + std::string(first.m_object->type_name()), *first.m_object));
+        }
+
+        for (auto it = first; it != last; ++it)
+        {
+            if (merge_objects && it.value().is_object())
+            {
+                auto it2 = m_value.object->find(it.key());
+                if (it2 != m_value.object->end())
+                {
+                    it2->second.update(it.value(), true);
+                    continue;
+                }
+            }
+            m_value.object->operator[](it.key()) = it.value();
+#if JSON_DIAGNOSTICS
+            m_value.object->operator[](it.key()).m_parent = this;
+#endif
+        }
+    }
+
+    /// @brief exchanges the values
+    /// @sa https://json.nlohmann.me/api/basic_json/swap/
+    void swap(reference other) noexcept (
+        std::is_nothrow_move_constructible<value_t>::value&&
+        std::is_nothrow_move_assignable<value_t>::value&&
+        std::is_nothrow_move_constructible<json_value>::value&&
+        std::is_nothrow_move_assignable<json_value>::value
+    )
+    {
+        std::swap(m_type, other.m_type);
+        std::swap(m_value, other.m_value);
+
+        set_parents();
+        other.set_parents();
+        assert_invariant();
+    }
+
+    /// @brief exchanges the values
+    /// @sa https://json.nlohmann.me/api/basic_json/swap/
+    friend void swap(reference left, reference right) noexcept (
+        std::is_nothrow_move_constructible<value_t>::value&&
+        std::is_nothrow_move_assignable<value_t>::value&&
+        std::is_nothrow_move_constructible<json_value>::value&&
+        std::is_nothrow_move_assignable<json_value>::value
+    )
+    {
+        left.swap(right);
+    }
+
+    /// @brief exchanges the values
+    /// @sa https://json.nlohmann.me/api/basic_json/swap/
+    void swap(array_t& other) // NOLINT(bugprone-exception-escape)
+    {
+        // swap only works for arrays
+        if (JSON_HEDLEY_LIKELY(is_array()))
+        {
+            std::swap(*(m_value.array), other);
+        }
+        else
+        {
+            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief exchanges the values
+    /// @sa https://json.nlohmann.me/api/basic_json/swap/
+    void swap(object_t& other) // NOLINT(bugprone-exception-escape)
+    {
+        // swap only works for objects
+        if (JSON_HEDLEY_LIKELY(is_object()))
+        {
+            std::swap(*(m_value.object), other);
+        }
+        else
+        {
+            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief exchanges the values
+    /// @sa https://json.nlohmann.me/api/basic_json/swap/
+    void swap(string_t& other) // NOLINT(bugprone-exception-escape)
+    {
+        // swap only works for strings
+        if (JSON_HEDLEY_LIKELY(is_string()))
+        {
+            std::swap(*(m_value.string), other);
+        }
+        else
+        {
+            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief exchanges the values
+    /// @sa https://json.nlohmann.me/api/basic_json/swap/
+    void swap(binary_t& other) // NOLINT(bugprone-exception-escape)
+    {
+        // swap only works for strings
+        if (JSON_HEDLEY_LIKELY(is_binary()))
+        {
+            std::swap(*(m_value.binary), other);
+        }
+        else
+        {
+            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @brief exchanges the values
+    /// @sa https://json.nlohmann.me/api/basic_json/swap/
+    void swap(typename binary_t::container_type& other) // NOLINT(bugprone-exception-escape)
+    {
+        // swap only works for strings
+        if (JSON_HEDLEY_LIKELY(is_binary()))
+        {
+            std::swap(*(m_value.binary), other);
+        }
+        else
+        {
+            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
+        }
+    }
+
+    /// @}
+
+  public:
+    //////////////////////////////////////////
+    // lexicographical comparison operators //
+    //////////////////////////////////////////
+
+    /// @name lexicographical comparison operators
+    /// @{
+
+    /// @brief comparison: equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_eq/
+    friend bool operator==(const_reference lhs, const_reference rhs) noexcept
+    {
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wfloat-equal"
+#endif
+        const auto lhs_type = lhs.type();
+        const auto rhs_type = rhs.type();
+
+        if (lhs_type == rhs_type)
+        {
+            switch (lhs_type)
+            {
+                case value_t::array:
+                    return *lhs.m_value.array == *rhs.m_value.array;
+
+                case value_t::object:
+                    return *lhs.m_value.object == *rhs.m_value.object;
+
+                case value_t::null:
+                    return true;
+
+                case value_t::string:
+                    return *lhs.m_value.string == *rhs.m_value.string;
+
+                case value_t::boolean:
+                    return lhs.m_value.boolean == rhs.m_value.boolean;
+
+                case value_t::number_integer:
+                    return lhs.m_value.number_integer == rhs.m_value.number_integer;
+
+                case value_t::number_unsigned:
+                    return lhs.m_value.number_unsigned == rhs.m_value.number_unsigned;
+
+                case value_t::number_float:
+                    return lhs.m_value.number_float == rhs.m_value.number_float;
+
+                case value_t::binary:
+                    return *lhs.m_value.binary == *rhs.m_value.binary;
+
+                case value_t::discarded:
+                default:
+                    return false;
+            }
+        }
+        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_float)
+        {
+            return static_cast<number_float_t>(lhs.m_value.number_integer) == rhs.m_value.number_float;
+        }
+        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_integer)
+        {
+            return lhs.m_value.number_float == static_cast<number_float_t>(rhs.m_value.number_integer);
+        }
+        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_float)
+        {
+            return static_cast<number_float_t>(lhs.m_value.number_unsigned) == rhs.m_value.number_float;
+        }
+        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_unsigned)
+        {
+            return lhs.m_value.number_float == static_cast<number_float_t>(rhs.m_value.number_unsigned);
+        }
+        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_integer)
+        {
+            return static_cast<number_integer_t>(lhs.m_value.number_unsigned) == rhs.m_value.number_integer;
+        }
+        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_unsigned)
+        {
+            return lhs.m_value.number_integer == static_cast<number_integer_t>(rhs.m_value.number_unsigned);
+        }
+
+        return false;
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+    }
+
+    /// @brief comparison: equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_eq/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator==(const_reference lhs, ScalarType rhs) noexcept
+    {
+        return lhs == basic_json(rhs);
+    }
+
+    /// @brief comparison: equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_eq/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator==(ScalarType lhs, const_reference rhs) noexcept
+    {
+        return basic_json(lhs) == rhs;
+    }
+
+    /// @brief comparison: not equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ne/
+    friend bool operator!=(const_reference lhs, const_reference rhs) noexcept
+    {
+        return !(lhs == rhs);
+    }
+
+    /// @brief comparison: not equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ne/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator!=(const_reference lhs, ScalarType rhs) noexcept
+    {
+        return lhs != basic_json(rhs);
+    }
+
+    /// @brief comparison: not equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ne/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator!=(ScalarType lhs, const_reference rhs) noexcept
+    {
+        return basic_json(lhs) != rhs;
+    }
+
+    /// @brief comparison: less than
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_lt/
+    friend bool operator<(const_reference lhs, const_reference rhs) noexcept
+    {
+        const auto lhs_type = lhs.type();
+        const auto rhs_type = rhs.type();
+
+        if (lhs_type == rhs_type)
+        {
+            switch (lhs_type)
+            {
+                case value_t::array:
+                    // note parentheses are necessary, see
+                    // https://github.com/nlohmann/json/issues/1530
+                    return (*lhs.m_value.array) < (*rhs.m_value.array);
+
+                case value_t::object:
+                    return (*lhs.m_value.object) < (*rhs.m_value.object);
+
+                case value_t::null:
+                    return false;
+
+                case value_t::string:
+                    return (*lhs.m_value.string) < (*rhs.m_value.string);
+
+                case value_t::boolean:
+                    return (lhs.m_value.boolean) < (rhs.m_value.boolean);
+
+                case value_t::number_integer:
+                    return (lhs.m_value.number_integer) < (rhs.m_value.number_integer);
+
+                case value_t::number_unsigned:
+                    return (lhs.m_value.number_unsigned) < (rhs.m_value.number_unsigned);
+
+                case value_t::number_float:
+                    return (lhs.m_value.number_float) < (rhs.m_value.number_float);
+
+                case value_t::binary:
+                    return (*lhs.m_value.binary) < (*rhs.m_value.binary);
+
+                case value_t::discarded:
+                default:
+                    return false;
+            }
+        }
+        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_float)
+        {
+            return static_cast<number_float_t>(lhs.m_value.number_integer) < rhs.m_value.number_float;
+        }
+        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_integer)
+        {
+            return lhs.m_value.number_float < static_cast<number_float_t>(rhs.m_value.number_integer);
+        }
+        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_float)
+        {
+            return static_cast<number_float_t>(lhs.m_value.number_unsigned) < rhs.m_value.number_float;
+        }
+        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_unsigned)
+        {
+            return lhs.m_value.number_float < static_cast<number_float_t>(rhs.m_value.number_unsigned);
+        }
+        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_unsigned)
+        {
+            return lhs.m_value.number_integer < static_cast<number_integer_t>(rhs.m_value.number_unsigned);
+        }
+        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_integer)
+        {
+            return static_cast<number_integer_t>(lhs.m_value.number_unsigned) < rhs.m_value.number_integer;
+        }
+
+        // We only reach this line if we cannot compare values. In that case,
+        // we compare types. Note we have to call the operator explicitly,
+        // because MSVC has problems otherwise.
+        return operator<(lhs_type, rhs_type);
+    }
+
+    /// @brief comparison: less than
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_lt/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator<(const_reference lhs, ScalarType rhs) noexcept
+    {
+        return lhs < basic_json(rhs);
+    }
+
+    /// @brief comparison: less than
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_lt/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator<(ScalarType lhs, const_reference rhs) noexcept
+    {
+        return basic_json(lhs) < rhs;
+    }
+
+    /// @brief comparison: less than or equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_le/
+    friend bool operator<=(const_reference lhs, const_reference rhs) noexcept
+    {
+        return !(rhs < lhs);
+    }
+
+    /// @brief comparison: less than or equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_le/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator<=(const_reference lhs, ScalarType rhs) noexcept
+    {
+        return lhs <= basic_json(rhs);
+    }
+
+    /// @brief comparison: less than or equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_le/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator<=(ScalarType lhs, const_reference rhs) noexcept
+    {
+        return basic_json(lhs) <= rhs;
+    }
+
+    /// @brief comparison: greater than
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_gt/
+    friend bool operator>(const_reference lhs, const_reference rhs) noexcept
+    {
+        return !(lhs <= rhs);
+    }
+
+    /// @brief comparison: greater than
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_gt/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator>(const_reference lhs, ScalarType rhs) noexcept
+    {
+        return lhs > basic_json(rhs);
+    }
+
+    /// @brief comparison: greater than
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_gt/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator>(ScalarType lhs, const_reference rhs) noexcept
+    {
+        return basic_json(lhs) > rhs;
+    }
+
+    /// @brief comparison: greater than or equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ge/
+    friend bool operator>=(const_reference lhs, const_reference rhs) noexcept
+    {
+        return !(lhs < rhs);
+    }
+
+    /// @brief comparison: greater than or equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ge/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator>=(const_reference lhs, ScalarType rhs) noexcept
+    {
+        return lhs >= basic_json(rhs);
+    }
+
+    /// @brief comparison: greater than or equal
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ge/
+    template<typename ScalarType, typename std::enable_if<
+                 std::is_scalar<ScalarType>::value, int>::type = 0>
+    friend bool operator>=(ScalarType lhs, const_reference rhs) noexcept
+    {
+        return basic_json(lhs) >= rhs;
+    }
+
+    /// @}
+
+    ///////////////////
+    // serialization //
+    ///////////////////
+
+    /// @name serialization
+    /// @{
+#ifndef JSON_NO_IO
+    /// @brief serialize to stream
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ltlt/
+    friend std::ostream& operator<<(std::ostream& o, const basic_json& j)
+    {
+        // read width member and use it as indentation parameter if nonzero
+        const bool pretty_print = o.width() > 0;
+        const auto indentation = pretty_print ? o.width() : 0;
+
+        // reset width to 0 for subsequent calls to this stream
+        o.width(0);
+
+        // do the actual serialization
+        serializer s(detail::output_adapter<char>(o), o.fill());
+        s.dump(j, pretty_print, false, static_cast<unsigned int>(indentation));
+        return o;
+    }
+
+    /// @brief serialize to stream
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_ltlt/
+    /// @deprecated This function is deprecated since 3.0.0 and will be removed in
+    ///             version 4.0.0 of the library. Please use
+    ///             operator<<(std::ostream&, const basic_json&) instead; that is,
+    ///             replace calls like `j >> o;` with `o << j;`.
+    JSON_HEDLEY_DEPRECATED_FOR(3.0.0, operator<<(std::ostream&, const basic_json&))
+    friend std::ostream& operator>>(const basic_json& j, std::ostream& o)
+    {
+        return o << j;
+    }
+#endif  // JSON_NO_IO
+    /// @}
+
+
+    /////////////////////
+    // deserialization //
+    /////////////////////
+
+    /// @name deserialization
+    /// @{
+
+    /// @brief deserialize from a compatible input
+    /// @sa https://json.nlohmann.me/api/basic_json/parse/
+    template<typename InputType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json parse(InputType&& i,
+                            const parser_callback_t cb = nullptr,
+                            const bool allow_exceptions = true,
+                            const bool ignore_comments = false)
+    {
+        basic_json result;
+        parser(detail::input_adapter(std::forward<InputType>(i)), cb, allow_exceptions, ignore_comments).parse(true, result);
+        return result;
+    }
+
+    /// @brief deserialize from a pair of character iterators
+    /// @sa https://json.nlohmann.me/api/basic_json/parse/
+    template<typename IteratorType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json parse(IteratorType first,
+                            IteratorType last,
+                            const parser_callback_t cb = nullptr,
+                            const bool allow_exceptions = true,
+                            const bool ignore_comments = false)
+    {
+        basic_json result;
+        parser(detail::input_adapter(std::move(first), std::move(last)), cb, allow_exceptions, ignore_comments).parse(true, result);
+        return result;
+    }
+
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, parse(ptr, ptr + len))
+    static basic_json parse(detail::span_input_adapter&& i,
+                            const parser_callback_t cb = nullptr,
+                            const bool allow_exceptions = true,
+                            const bool ignore_comments = false)
+    {
+        basic_json result;
+        parser(i.get(), cb, allow_exceptions, ignore_comments).parse(true, result);
+        return result;
+    }
+
+    /// @brief check if the input is valid JSON
+    /// @sa https://json.nlohmann.me/api/basic_json/accept/
+    template<typename InputType>
+    static bool accept(InputType&& i,
+                       const bool ignore_comments = false)
+    {
+        return parser(detail::input_adapter(std::forward<InputType>(i)), nullptr, false, ignore_comments).accept(true);
+    }
+
+    /// @brief check if the input is valid JSON
+    /// @sa https://json.nlohmann.me/api/basic_json/accept/
+    template<typename IteratorType>
+    static bool accept(IteratorType first, IteratorType last,
+                       const bool ignore_comments = false)
+    {
+        return parser(detail::input_adapter(std::move(first), std::move(last)), nullptr, false, ignore_comments).accept(true);
+    }
+
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, accept(ptr, ptr + len))
+    static bool accept(detail::span_input_adapter&& i,
+                       const bool ignore_comments = false)
+    {
+        return parser(i.get(), nullptr, false, ignore_comments).accept(true);
+    }
+
+    /// @brief generate SAX events
+    /// @sa https://json.nlohmann.me/api/basic_json/sax_parse/
+    template <typename InputType, typename SAX>
+    JSON_HEDLEY_NON_NULL(2)
+    static bool sax_parse(InputType&& i, SAX* sax,
+                          input_format_t format = input_format_t::json,
+                          const bool strict = true,
+                          const bool ignore_comments = false)
+    {
+        auto ia = detail::input_adapter(std::forward<InputType>(i));
+        return format == input_format_t::json
+               ? parser(std::move(ia), nullptr, true, ignore_comments).sax_parse(sax, strict)
+               : detail::binary_reader<basic_json, decltype(ia), SAX>(std::move(ia)).sax_parse(format, sax, strict);
+    }
+
+    /// @brief generate SAX events
+    /// @sa https://json.nlohmann.me/api/basic_json/sax_parse/
+    template<class IteratorType, class SAX>
+    JSON_HEDLEY_NON_NULL(3)
+    static bool sax_parse(IteratorType first, IteratorType last, SAX* sax,
+                          input_format_t format = input_format_t::json,
+                          const bool strict = true,
+                          const bool ignore_comments = false)
+    {
+        auto ia = detail::input_adapter(std::move(first), std::move(last));
+        return format == input_format_t::json
+               ? parser(std::move(ia), nullptr, true, ignore_comments).sax_parse(sax, strict)
+               : detail::binary_reader<basic_json, decltype(ia), SAX>(std::move(ia)).sax_parse(format, sax, strict);
+    }
+
+    /// @brief generate SAX events
+    /// @sa https://json.nlohmann.me/api/basic_json/sax_parse/
+    /// @deprecated This function is deprecated since 3.8.0 and will be removed in
+    ///             version 4.0.0 of the library. Please use
+    ///             sax_parse(ptr, ptr + len) instead.
+    template <typename SAX>
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, sax_parse(ptr, ptr + len, ...))
+    JSON_HEDLEY_NON_NULL(2)
+    static bool sax_parse(detail::span_input_adapter&& i, SAX* sax,
+                          input_format_t format = input_format_t::json,
+                          const bool strict = true,
+                          const bool ignore_comments = false)
+    {
+        auto ia = i.get();
+        return format == input_format_t::json
+               // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
+               ? parser(std::move(ia), nullptr, true, ignore_comments).sax_parse(sax, strict)
+               // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
+               : detail::binary_reader<basic_json, decltype(ia), SAX>(std::move(ia)).sax_parse(format, sax, strict);
+    }
+#ifndef JSON_NO_IO
+    /// @brief deserialize from stream
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_gtgt/
+    /// @deprecated This stream operator is deprecated since 3.0.0 and will be removed in
+    ///             version 4.0.0 of the library. Please use
+    ///             operator>>(std::istream&, basic_json&) instead; that is,
+    ///             replace calls like `j << i;` with `i >> j;`.
+    JSON_HEDLEY_DEPRECATED_FOR(3.0.0, operator>>(std::istream&, basic_json&))
+    friend std::istream& operator<<(basic_json& j, std::istream& i)
+    {
+        return operator>>(i, j);
+    }
+
+    /// @brief deserialize from stream
+    /// @sa https://json.nlohmann.me/api/basic_json/operator_gtgt/
+    friend std::istream& operator>>(std::istream& i, basic_json& j)
+    {
+        parser(detail::input_adapter(i)).parse(false, j);
+        return i;
+    }
+#endif  // JSON_NO_IO
+    /// @}
+
+    ///////////////////////////
+    // convenience functions //
+    ///////////////////////////
+
+    /// @brief return the type as string
+    /// @sa https://json.nlohmann.me/api/basic_json/type_name/
+    JSON_HEDLEY_RETURNS_NON_NULL
+    const char* type_name() const noexcept
+    {
+        switch (m_type)
+        {
+            case value_t::null:
+                return "null";
+            case value_t::object:
+                return "object";
+            case value_t::array:
+                return "array";
+            case value_t::string:
+                return "string";
+            case value_t::boolean:
+                return "boolean";
+            case value_t::binary:
+                return "binary";
+            case value_t::discarded:
+                return "discarded";
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            default:
+                return "number";
+        }
+    }
+
+
+  JSON_PRIVATE_UNLESS_TESTED:
+    //////////////////////
+    // member variables //
+    //////////////////////
+
+    /// the type of the current element
+    value_t m_type = value_t::null;
+
+    /// the value of the current element
+    json_value m_value = {};
+
+#if JSON_DIAGNOSTICS
+    /// a pointer to a parent value (for debugging purposes)
+    basic_json* m_parent = nullptr;
+#endif
+
+    //////////////////////////////////////////
+    // binary serialization/deserialization //
+    //////////////////////////////////////////
+
+    /// @name binary serialization/deserialization support
+    /// @{
+
+  public:
+    /// @brief create a CBOR serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_cbor/
+    static std::vector<std::uint8_t> to_cbor(const basic_json& j)
+    {
+        std::vector<std::uint8_t> result;
+        to_cbor(j, result);
+        return result;
+    }
+
+    /// @brief create a CBOR serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_cbor/
+    static void to_cbor(const basic_json& j, detail::output_adapter<std::uint8_t> o)
+    {
+        binary_writer<std::uint8_t>(o).write_cbor(j);
+    }
+
+    /// @brief create a CBOR serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_cbor/
+    static void to_cbor(const basic_json& j, detail::output_adapter<char> o)
+    {
+        binary_writer<char>(o).write_cbor(j);
+    }
+
+    /// @brief create a MessagePack serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_msgpack/
+    static std::vector<std::uint8_t> to_msgpack(const basic_json& j)
+    {
+        std::vector<std::uint8_t> result;
+        to_msgpack(j, result);
+        return result;
+    }
+
+    /// @brief create a MessagePack serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_msgpack/
+    static void to_msgpack(const basic_json& j, detail::output_adapter<std::uint8_t> o)
+    {
+        binary_writer<std::uint8_t>(o).write_msgpack(j);
+    }
+
+    /// @brief create a MessagePack serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_msgpack/
+    static void to_msgpack(const basic_json& j, detail::output_adapter<char> o)
+    {
+        binary_writer<char>(o).write_msgpack(j);
+    }
+
+    /// @brief create a UBJSON serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_ubjson/
+    static std::vector<std::uint8_t> to_ubjson(const basic_json& j,
+            const bool use_size = false,
+            const bool use_type = false)
+    {
+        std::vector<std::uint8_t> result;
+        to_ubjson(j, result, use_size, use_type);
+        return result;
+    }
+
+    /// @brief create a UBJSON serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_ubjson/
+    static void to_ubjson(const basic_json& j, detail::output_adapter<std::uint8_t> o,
+                          const bool use_size = false, const bool use_type = false)
+    {
+        binary_writer<std::uint8_t>(o).write_ubjson(j, use_size, use_type);
+    }
+
+    /// @brief create a UBJSON serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_ubjson/
+    static void to_ubjson(const basic_json& j, detail::output_adapter<char> o,
+                          const bool use_size = false, const bool use_type = false)
+    {
+        binary_writer<char>(o).write_ubjson(j, use_size, use_type);
+    }
+
+    /// @brief create a BSON serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_bson/
+    static std::vector<std::uint8_t> to_bson(const basic_json& j)
+    {
+        std::vector<std::uint8_t> result;
+        to_bson(j, result);
+        return result;
+    }
+
+    /// @brief create a BSON serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_bson/
+    static void to_bson(const basic_json& j, detail::output_adapter<std::uint8_t> o)
+    {
+        binary_writer<std::uint8_t>(o).write_bson(j);
+    }
+
+    /// @brief create a BSON serialization of a given JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/to_bson/
+    static void to_bson(const basic_json& j, detail::output_adapter<char> o)
+    {
+        binary_writer<char>(o).write_bson(j);
+    }
+
+    /// @brief create a JSON value from an input in CBOR format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_cbor/
+    template<typename InputType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_cbor(InputType&& i,
+                                const bool strict = true,
+                                const bool allow_exceptions = true,
+                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::forward<InputType>(i));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::cbor, &sdp, strict, tag_handler);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    /// @brief create a JSON value from an input in CBOR format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_cbor/
+    template<typename IteratorType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_cbor(IteratorType first, IteratorType last,
+                                const bool strict = true,
+                                const bool allow_exceptions = true,
+                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::move(first), std::move(last));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::cbor, &sdp, strict, tag_handler);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    template<typename T>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_cbor(ptr, ptr + len))
+    static basic_json from_cbor(const T* ptr, std::size_t len,
+                                const bool strict = true,
+                                const bool allow_exceptions = true,
+                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
+    {
+        return from_cbor(ptr, ptr + len, strict, allow_exceptions, tag_handler);
+    }
+
+
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_cbor(ptr, ptr + len))
+    static basic_json from_cbor(detail::span_input_adapter&& i,
+                                const bool strict = true,
+                                const bool allow_exceptions = true,
+                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = i.get();
+        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::cbor, &sdp, strict, tag_handler);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    /// @brief create a JSON value from an input in MessagePack format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_msgpack/
+    template<typename InputType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_msgpack(InputType&& i,
+                                   const bool strict = true,
+                                   const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::forward<InputType>(i));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::msgpack, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    /// @brief create a JSON value from an input in MessagePack format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_msgpack/
+    template<typename IteratorType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_msgpack(IteratorType first, IteratorType last,
+                                   const bool strict = true,
+                                   const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::move(first), std::move(last));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::msgpack, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    template<typename T>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_msgpack(ptr, ptr + len))
+    static basic_json from_msgpack(const T* ptr, std::size_t len,
+                                   const bool strict = true,
+                                   const bool allow_exceptions = true)
+    {
+        return from_msgpack(ptr, ptr + len, strict, allow_exceptions);
+    }
+
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_msgpack(ptr, ptr + len))
+    static basic_json from_msgpack(detail::span_input_adapter&& i,
+                                   const bool strict = true,
+                                   const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = i.get();
+        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::msgpack, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    /// @brief create a JSON value from an input in UBJSON format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_ubjson/
+    template<typename InputType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_ubjson(InputType&& i,
+                                  const bool strict = true,
+                                  const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::forward<InputType>(i));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::ubjson, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    /// @brief create a JSON value from an input in UBJSON format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_ubjson/
+    template<typename IteratorType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_ubjson(IteratorType first, IteratorType last,
+                                  const bool strict = true,
+                                  const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::move(first), std::move(last));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::ubjson, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    template<typename T>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_ubjson(ptr, ptr + len))
+    static basic_json from_ubjson(const T* ptr, std::size_t len,
+                                  const bool strict = true,
+                                  const bool allow_exceptions = true)
+    {
+        return from_ubjson(ptr, ptr + len, strict, allow_exceptions);
+    }
+
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_ubjson(ptr, ptr + len))
+    static basic_json from_ubjson(detail::span_input_adapter&& i,
+                                  const bool strict = true,
+                                  const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = i.get();
+        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::ubjson, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    /// @brief create a JSON value from an input in BSON format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_bson/
+    template<typename InputType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_bson(InputType&& i,
+                                const bool strict = true,
+                                const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::forward<InputType>(i));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::bson, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    /// @brief create a JSON value from an input in BSON format
+    /// @sa https://json.nlohmann.me/api/basic_json/from_bson/
+    template<typename IteratorType>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json from_bson(IteratorType first, IteratorType last,
+                                const bool strict = true,
+                                const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = detail::input_adapter(std::move(first), std::move(last));
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::bson, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+
+    template<typename T>
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_bson(ptr, ptr + len))
+    static basic_json from_bson(const T* ptr, std::size_t len,
+                                const bool strict = true,
+                                const bool allow_exceptions = true)
+    {
+        return from_bson(ptr, ptr + len, strict, allow_exceptions);
+    }
+
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_bson(ptr, ptr + len))
+    static basic_json from_bson(detail::span_input_adapter&& i,
+                                const bool strict = true,
+                                const bool allow_exceptions = true)
+    {
+        basic_json result;
+        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
+        auto ia = i.get();
+        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
+        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::bson, &sdp, strict);
+        return res ? result : basic_json(value_t::discarded);
+    }
+    /// @}
+
+    //////////////////////////
+    // JSON Pointer support //
+    //////////////////////////
+
+    /// @name JSON Pointer functions
+    /// @{
+
+    /// @brief access specified element via JSON Pointer
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    reference operator[](const json_pointer& ptr)
+    {
+        return ptr.get_unchecked(this);
+    }
+
+    /// @brief access specified element via JSON Pointer
+    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
+    const_reference operator[](const json_pointer& ptr) const
+    {
+        return ptr.get_unchecked(this);
+    }
+
+    /// @brief access specified element via JSON Pointer
+    /// @sa https://json.nlohmann.me/api/basic_json/at/
+    reference at(const json_pointer& ptr)
+    {
+        return ptr.get_checked(this);
+    }
+
+    /// @brief access specified element via JSON Pointer
+    /// @sa https://json.nlohmann.me/api/basic_json/at/
+    const_reference at(const json_pointer& ptr) const
+    {
+        return ptr.get_checked(this);
+    }
+
+    /// @brief return flattened JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/flatten/
+    basic_json flatten() const
+    {
+        basic_json result(value_t::object);
+        json_pointer::flatten("", *this, result);
+        return result;
+    }
+
+    /// @brief unflatten a previously flattened JSON value
+    /// @sa https://json.nlohmann.me/api/basic_json/unflatten/
+    basic_json unflatten() const
+    {
+        return json_pointer::unflatten(*this);
+    }
+
+    /// @}
+
+    //////////////////////////
+    // JSON Patch functions //
+    //////////////////////////
+
+    /// @name JSON Patch functions
+    /// @{
+
+    /// @brief applies a JSON patch
+    /// @sa https://json.nlohmann.me/api/basic_json/patch/
+    basic_json patch(const basic_json& json_patch) const
+    {
+        // make a working copy to apply the patch to
+        basic_json result = *this;
+
+        // the valid JSON Patch operations
+        enum class patch_operations {add, remove, replace, move, copy, test, invalid};
+
+        const auto get_op = [](const std::string & op)
+        {
+            if (op == "add")
+            {
+                return patch_operations::add;
+            }
+            if (op == "remove")
+            {
+                return patch_operations::remove;
+            }
+            if (op == "replace")
+            {
+                return patch_operations::replace;
+            }
+            if (op == "move")
+            {
+                return patch_operations::move;
+            }
+            if (op == "copy")
+            {
+                return patch_operations::copy;
+            }
+            if (op == "test")
+            {
+                return patch_operations::test;
+            }
+
+            return patch_operations::invalid;
+        };
+
+        // wrapper for "add" operation; add value at ptr
+        const auto operation_add = [&result](json_pointer & ptr, basic_json val)
+        {
+            // adding to the root of the target document means replacing it
+            if (ptr.empty())
+            {
+                result = val;
+                return;
+            }
+
+            // make sure the top element of the pointer exists
+            json_pointer top_pointer = ptr.top();
+            if (top_pointer != ptr)
+            {
+                result.at(top_pointer);
+            }
+
+            // get reference to parent of JSON pointer ptr
+            const auto last_path = ptr.back();
+            ptr.pop_back();
+            basic_json& parent = result[ptr];
+
+            switch (parent.m_type)
+            {
+                case value_t::null:
+                case value_t::object:
+                {
+                    // use operator[] to add value
+                    parent[last_path] = val;
+                    break;
+                }
+
+                case value_t::array:
+                {
+                    if (last_path == "-")
+                    {
+                        // special case: append to back
+                        parent.push_back(val);
+                    }
+                    else
+                    {
+                        const auto idx = json_pointer::array_index(last_path);
+                        if (JSON_HEDLEY_UNLIKELY(idx > parent.size()))
+                        {
+                            // avoid undefined behavior
+                            JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", parent));
+                        }
+
+                        // default case: insert add offset
+                        parent.insert(parent.begin() + static_cast<difference_type>(idx), val);
+                    }
+                    break;
+                }
+
+                // if there exists a parent it cannot be primitive
+                case value_t::string: // LCOV_EXCL_LINE
+                case value_t::boolean: // LCOV_EXCL_LINE
+                case value_t::number_integer: // LCOV_EXCL_LINE
+                case value_t::number_unsigned: // LCOV_EXCL_LINE
+                case value_t::number_float: // LCOV_EXCL_LINE
+                case value_t::binary: // LCOV_EXCL_LINE
+                case value_t::discarded: // LCOV_EXCL_LINE
+                default:            // LCOV_EXCL_LINE
+                    JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
+            }
+        };
+
+        // wrapper for "remove" operation; remove value at ptr
+        const auto operation_remove = [this, &result](json_pointer & ptr)
+        {
+            // get reference to parent of JSON pointer ptr
+            const auto last_path = ptr.back();
+            ptr.pop_back();
+            basic_json& parent = result.at(ptr);
+
+            // remove child
+            if (parent.is_object())
+            {
+                // perform range check
+                auto it = parent.find(last_path);
+                if (JSON_HEDLEY_LIKELY(it != parent.end()))
+                {
+                    parent.erase(it);
+                }
+                else
+                {
+                    JSON_THROW(out_of_range::create(403, "key '" + last_path + "' not found", *this));
+                }
+            }
+            else if (parent.is_array())
+            {
+                // note erase performs range check
+                parent.erase(json_pointer::array_index(last_path));
+            }
+        };
+
+        // type check: top level value must be an array
+        if (JSON_HEDLEY_UNLIKELY(!json_patch.is_array()))
+        {
+            JSON_THROW(parse_error::create(104, 0, "JSON patch must be an array of objects", json_patch));
+        }
+
+        // iterate and apply the operations
+        for (const auto& val : json_patch)
+        {
+            // wrapper to get a value for an operation
+            const auto get_value = [&val](const std::string & op,
+                                          const std::string & member,
+                                          bool string_type) -> basic_json &
+            {
+                // find value
+                auto it = val.m_value.object->find(member);
+
+                // context-sensitive error message
+                const auto error_msg = (op == "op") ? "operation" : "operation '" + op + "'";
+
+                // check if desired value is present
+                if (JSON_HEDLEY_UNLIKELY(it == val.m_value.object->end()))
+                {
+                    // NOLINTNEXTLINE(performance-inefficient-string-concatenation)
+                    JSON_THROW(parse_error::create(105, 0, error_msg + " must have member '" + member + "'", val));
+                }
+
+                // check if result is of type string
+                if (JSON_HEDLEY_UNLIKELY(string_type && !it->second.is_string()))
+                {
+                    // NOLINTNEXTLINE(performance-inefficient-string-concatenation)
+                    JSON_THROW(parse_error::create(105, 0, error_msg + " must have string member '" + member + "'", val));
+                }
+
+                // no error: return value
+                return it->second;
+            };
+
+            // type check: every element of the array must be an object
+            if (JSON_HEDLEY_UNLIKELY(!val.is_object()))
+            {
+                JSON_THROW(parse_error::create(104, 0, "JSON patch must be an array of objects", val));
+            }
+
+            // collect mandatory members
+            const auto op = get_value("op", "op", true).template get<std::string>();
+            const auto path = get_value(op, "path", true).template get<std::string>();
+            json_pointer ptr(path);
+
+            switch (get_op(op))
+            {
+                case patch_operations::add:
+                {
+                    operation_add(ptr, get_value("add", "value", false));
+                    break;
+                }
+
+                case patch_operations::remove:
+                {
+                    operation_remove(ptr);
+                    break;
+                }
+
+                case patch_operations::replace:
+                {
+                    // the "path" location must exist - use at()
+                    result.at(ptr) = get_value("replace", "value", false);
+                    break;
+                }
+
+                case patch_operations::move:
+                {
+                    const auto from_path = get_value("move", "from", true).template get<std::string>();
+                    json_pointer from_ptr(from_path);
+
+                    // the "from" location must exist - use at()
+                    basic_json v = result.at(from_ptr);
+
+                    // The move operation is functionally identical to a
+                    // "remove" operation on the "from" location, followed
+                    // immediately by an "add" operation at the target
+                    // location with the value that was just removed.
+                    operation_remove(from_ptr);
+                    operation_add(ptr, v);
+                    break;
+                }
+
+                case patch_operations::copy:
+                {
+                    const auto from_path = get_value("copy", "from", true).template get<std::string>();
+                    const json_pointer from_ptr(from_path);
+
+                    // the "from" location must exist - use at()
+                    basic_json v = result.at(from_ptr);
+
+                    // The copy is functionally identical to an "add"
+                    // operation at the target location using the value
+                    // specified in the "from" member.
+                    operation_add(ptr, v);
+                    break;
+                }
+
+                case patch_operations::test:
+                {
+                    bool success = false;
+                    JSON_TRY
+                    {
+                        // check if "value" matches the one at "path"
+                        // the "path" location must exist - use at()
+                        success = (result.at(ptr) == get_value("test", "value", false));
+                    }
+                    JSON_INTERNAL_CATCH (out_of_range&)
+                    {
+                        // ignore out of range errors: success remains false
+                    }
+
+                    // throw an exception if test fails
+                    if (JSON_HEDLEY_UNLIKELY(!success))
+                    {
+                        JSON_THROW(other_error::create(501, "unsuccessful: " + val.dump(), val));
+                    }
+
+                    break;
+                }
+
+                case patch_operations::invalid:
+                default:
+                {
+                    // op must be "add", "remove", "replace", "move", "copy", or
+                    // "test"
+                    JSON_THROW(parse_error::create(105, 0, "operation value '" + op + "' is invalid", val));
+                }
+            }
+        }
+
+        return result;
+    }
+
+    /// @brief creates a diff as a JSON patch
+    /// @sa https://json.nlohmann.me/api/basic_json/diff/
+    JSON_HEDLEY_WARN_UNUSED_RESULT
+    static basic_json diff(const basic_json& source, const basic_json& target,
+                           const std::string& path = "")
+    {
+        // the patch
+        basic_json result(value_t::array);
+
+        // if the values are the same, return empty patch
+        if (source == target)
+        {
+            return result;
+        }
+
+        if (source.type() != target.type())
+        {
+            // different types: replace value
+            result.push_back(
+            {
+                {"op", "replace"}, {"path", path}, {"value", target}
+            });
+            return result;
+        }
+
+        switch (source.type())
+        {
+            case value_t::array:
+            {
+                // first pass: traverse common elements
+                std::size_t i = 0;
+                while (i < source.size() && i < target.size())
+                {
+                    // recursive call to compare array values at index i
+                    auto temp_diff = diff(source[i], target[i], path + "/" + std::to_string(i));
+                    result.insert(result.end(), temp_diff.begin(), temp_diff.end());
+                    ++i;
+                }
+
+                // We now reached the end of at least one array
+                // in a second pass, traverse the remaining elements
+
+                // remove my remaining elements
+                const auto end_index = static_cast<difference_type>(result.size());
+                while (i < source.size())
+                {
+                    // add operations in reverse order to avoid invalid
+                    // indices
+                    result.insert(result.begin() + end_index, object(
+                    {
+                        {"op", "remove"},
+                        {"path", path + "/" + std::to_string(i)}
+                    }));
+                    ++i;
+                }
+
+                // add other remaining elements
+                while (i < target.size())
+                {
+                    result.push_back(
+                    {
+                        {"op", "add"},
+                        {"path", path + "/-"},
+                        {"value", target[i]}
+                    });
+                    ++i;
+                }
+
+                break;
+            }
+
+            case value_t::object:
+            {
+                // first pass: traverse this object's elements
+                for (auto it = source.cbegin(); it != source.cend(); ++it)
+                {
+                    // escape the key name to be used in a JSON patch
+                    const auto path_key = path + "/" + detail::escape(it.key());
+
+                    if (target.find(it.key()) != target.end())
+                    {
+                        // recursive call to compare object values at key it
+                        auto temp_diff = diff(it.value(), target[it.key()], path_key);
+                        result.insert(result.end(), temp_diff.begin(), temp_diff.end());
+                    }
+                    else
+                    {
+                        // found a key that is not in o -> remove it
+                        result.push_back(object(
+                        {
+                            {"op", "remove"}, {"path", path_key}
+                        }));
+                    }
+                }
+
+                // second pass: traverse other object's elements
+                for (auto it = target.cbegin(); it != target.cend(); ++it)
+                {
+                    if (source.find(it.key()) == source.end())
+                    {
+                        // found a key that is not in this -> add it
+                        const auto path_key = path + "/" + detail::escape(it.key());
+                        result.push_back(
+                        {
+                            {"op", "add"}, {"path", path_key},
+                            {"value", it.value()}
+                        });
+                    }
+                }
+
+                break;
+            }
+
+            case value_t::null:
+            case value_t::string:
+            case value_t::boolean:
+            case value_t::number_integer:
+            case value_t::number_unsigned:
+            case value_t::number_float:
+            case value_t::binary:
+            case value_t::discarded:
+            default:
+            {
+                // both primitive type: replace value
+                result.push_back(
+                {
+                    {"op", "replace"}, {"path", path}, {"value", target}
+                });
+                break;
+            }
+        }
+
+        return result;
+    }
+
+    /// @}
+
+    ////////////////////////////////
+    // JSON Merge Patch functions //
+    ////////////////////////////////
+
+    /// @name JSON Merge Patch functions
+    /// @{
+
+    /// @brief applies a JSON Merge Patch
+    /// @sa https://json.nlohmann.me/api/basic_json/merge_patch/
+    void merge_patch(const basic_json& apply_patch)
+    {
+        if (apply_patch.is_object())
+        {
+            if (!is_object())
+            {
+                *this = object();
+            }
+            for (auto it = apply_patch.begin(); it != apply_patch.end(); ++it)
+            {
+                if (it.value().is_null())
+                {
+                    erase(it.key());
+                }
+                else
+                {
+                    operator[](it.key()).merge_patch(it.value());
+                }
+            }
+        }
+        else
+        {
+            *this = apply_patch;
+        }
+    }
+
+    /// @}
+};
+
+/// @brief user-defined to_string function for JSON values
+/// @sa https://json.nlohmann.me/api/basic_json/to_string/
+NLOHMANN_BASIC_JSON_TPL_DECLARATION
+std::string to_string(const NLOHMANN_BASIC_JSON_TPL& j)
+{
+    return j.dump();
+}
+
+} // namespace nlohmann
+
+///////////////////////
+// nonmember support //
+///////////////////////
+
+namespace std // NOLINT(cert-dcl58-cpp)
+{
+
+/// @brief hash value for JSON objects
+/// @sa https://json.nlohmann.me/api/basic_json/std_hash/
+NLOHMANN_BASIC_JSON_TPL_DECLARATION
+struct hash<nlohmann::NLOHMANN_BASIC_JSON_TPL>
+{
+    std::size_t operator()(const nlohmann::NLOHMANN_BASIC_JSON_TPL& j) const
+    {
+        return nlohmann::detail::hash(j);
+    }
+};
+
+// specialization for std::less<value_t>
+template<>
+struct less< ::nlohmann::detail::value_t> // do not remove the space after '<', see https://github.com/nlohmann/json/pull/679
+{
+    /*!
+    @brief compare two value_t enum values
+    @since version 3.0.0
+    */
+    bool operator()(nlohmann::detail::value_t lhs,
+                    nlohmann::detail::value_t rhs) const noexcept
+    {
+        return nlohmann::detail::operator<(lhs, rhs);
+    }
+};
+
+// C++20 prohibit function specialization in the std namespace.
+#ifndef JSON_HAS_CPP_20
+
+/// @brief exchanges the values of two JSON objects
+/// @sa https://json.nlohmann.me/api/basic_json/std_swap/
+NLOHMANN_BASIC_JSON_TPL_DECLARATION
+inline void swap(nlohmann::NLOHMANN_BASIC_JSON_TPL& j1, nlohmann::NLOHMANN_BASIC_JSON_TPL& j2) noexcept(  // NOLINT(readability-inconsistent-declaration-parameter-name)
+    is_nothrow_move_constructible<nlohmann::NLOHMANN_BASIC_JSON_TPL>::value&&                          // NOLINT(misc-redundant-expression)
+    is_nothrow_move_assignable<nlohmann::NLOHMANN_BASIC_JSON_TPL>::value)
+{
+    j1.swap(j2);
+}
+
+#endif
+
+} // namespace std
+
+/// @brief user-defined string literal for JSON values
+/// @sa https://json.nlohmann.me/api/basic_json/operator_literal_json/
+JSON_HEDLEY_NON_NULL(1)
+inline nlohmann::json operator "" _json(const char* s, std::size_t n)
+{
+    return nlohmann::json::parse(s, s + n);
+}
+
+/// @brief user-defined string literal for JSON pointer
+/// @sa https://json.nlohmann.me/api/basic_json/operator_literal_json_pointer/
+JSON_HEDLEY_NON_NULL(1)
+inline nlohmann::json::json_pointer operator "" _json_pointer(const char* s, std::size_t n)
+{
+    return nlohmann::json::json_pointer(std::string(s, n));
+}
+
+// #include <nlohmann/detail/macro_unscope.hpp>
+
+
+// restore clang diagnostic settings
+#if defined(__clang__)
+    #pragma clang diagnostic pop
+#endif
+
+// clean up
+#undef JSON_ASSERT
+#undef JSON_INTERNAL_CATCH
+#undef JSON_CATCH
+#undef JSON_THROW
+#undef JSON_TRY
+#undef JSON_PRIVATE_UNLESS_TESTED
+#undef JSON_HAS_CPP_11
+#undef JSON_HAS_CPP_14
+#undef JSON_HAS_CPP_17
+#undef JSON_HAS_CPP_20
+#undef JSON_HAS_FILESYSTEM
+#undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
+#undef NLOHMANN_BASIC_JSON_TPL_DECLARATION
+#undef NLOHMANN_BASIC_JSON_TPL
+#undef JSON_EXPLICIT
+#undef NLOHMANN_CAN_CALL_STD_FUNC_IMPL
+
+// #include <nlohmann/thirdparty/hedley/hedley_undef.hpp>
+
+
+#undef JSON_HEDLEY_ALWAYS_INLINE
+#undef JSON_HEDLEY_ARM_VERSION
+#undef JSON_HEDLEY_ARM_VERSION_CHECK
+#undef JSON_HEDLEY_ARRAY_PARAM
+#undef JSON_HEDLEY_ASSUME
+#undef JSON_HEDLEY_BEGIN_C_DECLS
+#undef JSON_HEDLEY_CLANG_HAS_ATTRIBUTE
+#undef JSON_HEDLEY_CLANG_HAS_BUILTIN
+#undef JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE
+#undef JSON_HEDLEY_CLANG_HAS_DECLSPEC_DECLSPEC_ATTRIBUTE
+#undef JSON_HEDLEY_CLANG_HAS_EXTENSION
+#undef JSON_HEDLEY_CLANG_HAS_FEATURE
+#undef JSON_HEDLEY_CLANG_HAS_WARNING
+#undef JSON_HEDLEY_COMPCERT_VERSION
+#undef JSON_HEDLEY_COMPCERT_VERSION_CHECK
+#undef JSON_HEDLEY_CONCAT
+#undef JSON_HEDLEY_CONCAT3
+#undef JSON_HEDLEY_CONCAT3_EX
+#undef JSON_HEDLEY_CONCAT_EX
+#undef JSON_HEDLEY_CONST
+#undef JSON_HEDLEY_CONSTEXPR
+#undef JSON_HEDLEY_CONST_CAST
+#undef JSON_HEDLEY_CPP_CAST
+#undef JSON_HEDLEY_CRAY_VERSION
+#undef JSON_HEDLEY_CRAY_VERSION_CHECK
+#undef JSON_HEDLEY_C_DECL
+#undef JSON_HEDLEY_DEPRECATED
+#undef JSON_HEDLEY_DEPRECATED_FOR
+#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL
+#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_
+#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED
+#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES
+#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS
+#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION
+#undef JSON_HEDLEY_DIAGNOSTIC_POP
+#undef JSON_HEDLEY_DIAGNOSTIC_PUSH
+#undef JSON_HEDLEY_DMC_VERSION
+#undef JSON_HEDLEY_DMC_VERSION_CHECK
+#undef JSON_HEDLEY_EMPTY_BASES
+#undef JSON_HEDLEY_EMSCRIPTEN_VERSION
+#undef JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK
+#undef JSON_HEDLEY_END_C_DECLS
+#undef JSON_HEDLEY_FLAGS
+#undef JSON_HEDLEY_FLAGS_CAST
+#undef JSON_HEDLEY_GCC_HAS_ATTRIBUTE
+#undef JSON_HEDLEY_GCC_HAS_BUILTIN
+#undef JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE
+#undef JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE
+#undef JSON_HEDLEY_GCC_HAS_EXTENSION
+#undef JSON_HEDLEY_GCC_HAS_FEATURE
+#undef JSON_HEDLEY_GCC_HAS_WARNING
+#undef JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK
+#undef JSON_HEDLEY_GCC_VERSION
+#undef JSON_HEDLEY_GCC_VERSION_CHECK
+#undef JSON_HEDLEY_GNUC_HAS_ATTRIBUTE
+#undef JSON_HEDLEY_GNUC_HAS_BUILTIN
+#undef JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE
+#undef JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE
+#undef JSON_HEDLEY_GNUC_HAS_EXTENSION
+#undef JSON_HEDLEY_GNUC_HAS_FEATURE
+#undef JSON_HEDLEY_GNUC_HAS_WARNING
+#undef JSON_HEDLEY_GNUC_VERSION
+#undef JSON_HEDLEY_GNUC_VERSION_CHECK
+#undef JSON_HEDLEY_HAS_ATTRIBUTE
+#undef JSON_HEDLEY_HAS_BUILTIN
+#undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE
+#undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS
+#undef JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE
+#undef JSON_HEDLEY_HAS_EXTENSION
+#undef JSON_HEDLEY_HAS_FEATURE
+#undef JSON_HEDLEY_HAS_WARNING
+#undef JSON_HEDLEY_IAR_VERSION
+#undef JSON_HEDLEY_IAR_VERSION_CHECK
+#undef JSON_HEDLEY_IBM_VERSION
+#undef JSON_HEDLEY_IBM_VERSION_CHECK
+#undef JSON_HEDLEY_IMPORT
+#undef JSON_HEDLEY_INLINE
+#undef JSON_HEDLEY_INTEL_CL_VERSION
+#undef JSON_HEDLEY_INTEL_CL_VERSION_CHECK
+#undef JSON_HEDLEY_INTEL_VERSION
+#undef JSON_HEDLEY_INTEL_VERSION_CHECK
+#undef JSON_HEDLEY_IS_CONSTANT
+#undef JSON_HEDLEY_IS_CONSTEXPR_
+#undef JSON_HEDLEY_LIKELY
+#undef JSON_HEDLEY_MALLOC
+#undef JSON_HEDLEY_MCST_LCC_VERSION
+#undef JSON_HEDLEY_MCST_LCC_VERSION_CHECK
+#undef JSON_HEDLEY_MESSAGE
+#undef JSON_HEDLEY_MSVC_VERSION
+#undef JSON_HEDLEY_MSVC_VERSION_CHECK
+#undef JSON_HEDLEY_NEVER_INLINE
+#undef JSON_HEDLEY_NON_NULL
+#undef JSON_HEDLEY_NO_ESCAPE
+#undef JSON_HEDLEY_NO_RETURN
+#undef JSON_HEDLEY_NO_THROW
+#undef JSON_HEDLEY_NULL
+#undef JSON_HEDLEY_PELLES_VERSION
+#undef JSON_HEDLEY_PELLES_VERSION_CHECK
+#undef JSON_HEDLEY_PGI_VERSION
+#undef JSON_HEDLEY_PGI_VERSION_CHECK
+#undef JSON_HEDLEY_PREDICT
+#undef JSON_HEDLEY_PRINTF_FORMAT
+#undef JSON_HEDLEY_PRIVATE
+#undef JSON_HEDLEY_PUBLIC
+#undef JSON_HEDLEY_PURE
+#undef JSON_HEDLEY_REINTERPRET_CAST
+#undef JSON_HEDLEY_REQUIRE
+#undef JSON_HEDLEY_REQUIRE_CONSTEXPR
+#undef JSON_HEDLEY_REQUIRE_MSG
+#undef JSON_HEDLEY_RESTRICT
+#undef JSON_HEDLEY_RETURNS_NON_NULL
+#undef JSON_HEDLEY_SENTINEL
+#undef JSON_HEDLEY_STATIC_ASSERT
+#undef JSON_HEDLEY_STATIC_CAST
+#undef JSON_HEDLEY_STRINGIFY
+#undef JSON_HEDLEY_STRINGIFY_EX
+#undef JSON_HEDLEY_SUNPRO_VERSION
+#undef JSON_HEDLEY_SUNPRO_VERSION_CHECK
+#undef JSON_HEDLEY_TINYC_VERSION
+#undef JSON_HEDLEY_TINYC_VERSION_CHECK
+#undef JSON_HEDLEY_TI_ARMCL_VERSION
+#undef JSON_HEDLEY_TI_ARMCL_VERSION_CHECK
+#undef JSON_HEDLEY_TI_CL2000_VERSION
+#undef JSON_HEDLEY_TI_CL2000_VERSION_CHECK
+#undef JSON_HEDLEY_TI_CL430_VERSION
+#undef JSON_HEDLEY_TI_CL430_VERSION_CHECK
+#undef JSON_HEDLEY_TI_CL6X_VERSION
+#undef JSON_HEDLEY_TI_CL6X_VERSION_CHECK
+#undef JSON_HEDLEY_TI_CL7X_VERSION
+#undef JSON_HEDLEY_TI_CL7X_VERSION_CHECK
+#undef JSON_HEDLEY_TI_CLPRU_VERSION
+#undef JSON_HEDLEY_TI_CLPRU_VERSION_CHECK
+#undef JSON_HEDLEY_TI_VERSION
+#undef JSON_HEDLEY_TI_VERSION_CHECK
+#undef JSON_HEDLEY_UNAVAILABLE
+#undef JSON_HEDLEY_UNLIKELY
+#undef JSON_HEDLEY_UNPREDICTABLE
+#undef JSON_HEDLEY_UNREACHABLE
+#undef JSON_HEDLEY_UNREACHABLE_RETURN
+#undef JSON_HEDLEY_VERSION
+#undef JSON_HEDLEY_VERSION_DECODE_MAJOR
+#undef JSON_HEDLEY_VERSION_DECODE_MINOR
+#undef JSON_HEDLEY_VERSION_DECODE_REVISION
+#undef JSON_HEDLEY_VERSION_ENCODE
+#undef JSON_HEDLEY_WARNING
+#undef JSON_HEDLEY_WARN_UNUSED_RESULT
+#undef JSON_HEDLEY_WARN_UNUSED_RESULT_MSG
+#undef JSON_HEDLEY_FALL_THROUGH
+
+
+
+#endif  // INCLUDE_NLOHMANN_JSON_HPP_
diff -pruN 8.0.1-5/src/third-party/pantor/inja.hpp 8.2.0~beta1-1~exp1/src/third-party/pantor/inja.hpp
--- 8.0.1-5/src/third-party/pantor/inja.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/third-party/pantor/inja.hpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,4470 @@
+/*
+  ___        _          Version 3.3
+ |_ _|_ __  (_) __ _    https://github.com/pantor/inja
+  | || '_ \ | |/ _` |   Licensed under the MIT License <http://opensource.org/licenses/MIT>.
+  | || | | || | (_| |
+ |___|_| |_|/ |\__,_|   Copyright (c) 2018-2021 Lars Berscheid
+          |__/       
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+The above copyright notice and this permission notice shall be included in all
+copies or substantial portions of the Software.
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+SOFTWARE.
+*/
+
+#ifndef INCLUDE_INJA_INJA_HPP_
+#define INCLUDE_INJA_INJA_HPP_
+
+#include "../nlohmann/json.hpp" // <nlohmann/json.hpp>
+
+namespace inja {
+#ifndef INJA_DATA_TYPE
+  using json = nlohmann::json;
+#else
+  using json = INJA_DATA_TYPE;
+#endif
+}
+
+#if (defined(__cpp_exceptions) || defined(__EXCEPTIONS) || defined(_CPPUNWIND)) && !defined(INJA_NOEXCEPTION)
+  #ifndef INJA_THROW
+    #define INJA_THROW(exception) throw exception
+  #endif
+#else
+  #include <cstdlib>
+  #ifndef INJA_THROW
+    #define INJA_THROW(exception) std::abort(); std::ignore = exception
+  #endif
+  #ifndef INJA_NOEXCEPTION
+    #define INJA_NOEXCEPTION
+  #endif
+#endif
+
+// #include "environment.hpp"
+#ifndef INCLUDE_INJA_ENVIRONMENT_HPP_
+#define INCLUDE_INJA_ENVIRONMENT_HPP_
+
+#include <fstream>
+#include <iostream>
+#include <memory>
+#include <sstream>
+#include <string>
+
+// #include "config.hpp"
+#ifndef INCLUDE_INJA_CONFIG_HPP_
+#define INCLUDE_INJA_CONFIG_HPP_
+
+#include <functional>
+#include <string>
+
+// #include "string_view.hpp"
+// Copyright 2017-2019 by Martin Moene
+//
+// string-view lite, a C++17-like string_view for C++98 and later.
+// For more information see https://github.com/martinmoene/string-view-lite
+//
+// Distributed under the Boost Software License, Version 1.0.
+// (See accompanying file LICENSE.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
+
+
+
+#ifndef NONSTD_SV_LITE_H_INCLUDED
+#define NONSTD_SV_LITE_H_INCLUDED
+
+#define string_view_lite_MAJOR 1
+#define string_view_lite_MINOR 4
+#define string_view_lite_PATCH 0
+
+#define string_view_lite_VERSION                                                                                       \
+  nssv_STRINGIFY(string_view_lite_MAJOR) "." nssv_STRINGIFY(string_view_lite_MINOR) "." nssv_STRINGIFY(                \
+      string_view_lite_PATCH)
+
+#define nssv_STRINGIFY(x) nssv_STRINGIFY_(x)
+#define nssv_STRINGIFY_(x) #x
+
+// string-view lite configuration:
+
+#define nssv_STRING_VIEW_DEFAULT 0
+#define nssv_STRING_VIEW_NONSTD 1
+#define nssv_STRING_VIEW_STD 2
+
+#if !defined(nssv_CONFIG_SELECT_STRING_VIEW)
+#define nssv_CONFIG_SELECT_STRING_VIEW (nssv_HAVE_STD_STRING_VIEW ? nssv_STRING_VIEW_STD : nssv_STRING_VIEW_NONSTD)
+#endif
+
+#if defined(nssv_CONFIG_SELECT_STD_STRING_VIEW) || defined(nssv_CONFIG_SELECT_NONSTD_STRING_VIEW)
+#error nssv_CONFIG_SELECT_STD_STRING_VIEW and nssv_CONFIG_SELECT_NONSTD_STRING_VIEW are deprecated and removed, please use nssv_CONFIG_SELECT_STRING_VIEW=nssv_STRING_VIEW_...
+#endif
+
+#ifndef nssv_CONFIG_STD_SV_OPERATOR
+#define nssv_CONFIG_STD_SV_OPERATOR 0
+#endif
+
+#ifndef nssv_CONFIG_USR_SV_OPERATOR
+#define nssv_CONFIG_USR_SV_OPERATOR 1
+#endif
+
+#ifdef nssv_CONFIG_CONVERSION_STD_STRING
+#define nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS nssv_CONFIG_CONVERSION_STD_STRING
+#define nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS nssv_CONFIG_CONVERSION_STD_STRING
+#endif
+
+#ifndef nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS
+#define nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS 1
+#endif
+
+#ifndef nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
+#define nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS 1
+#endif
+
+// Control presence of exception handling (try and auto discover):
+
+#ifndef nssv_CONFIG_NO_EXCEPTIONS
+#if defined(__cpp_exceptions) || defined(__EXCEPTIONS) || defined(_CPPUNWIND)
+#define nssv_CONFIG_NO_EXCEPTIONS 0
+#else
+#define nssv_CONFIG_NO_EXCEPTIONS 1
+#endif
+#endif
+
+// C++ language version detection (C++20 is speculative):
+// Note: VC14.0/1900 (VS2015) lacks too much from C++14.
+
+#ifndef nssv_CPLUSPLUS
+#if defined(_MSVC_LANG) && !defined(__clang__)
+#define nssv_CPLUSPLUS (_MSC_VER == 1900 ? 201103L : _MSVC_LANG)
+#else
+#define nssv_CPLUSPLUS __cplusplus
+#endif
+#endif
+
+#define nssv_CPP98_OR_GREATER (nssv_CPLUSPLUS >= 199711L)
+#define nssv_CPP11_OR_GREATER (nssv_CPLUSPLUS >= 201103L)
+#define nssv_CPP11_OR_GREATER_ (nssv_CPLUSPLUS >= 201103L)
+#define nssv_CPP14_OR_GREATER (nssv_CPLUSPLUS >= 201402L)
+#define nssv_CPP17_OR_GREATER (nssv_CPLUSPLUS >= 201703L)
+#define nssv_CPP20_OR_GREATER (nssv_CPLUSPLUS >= 202000L)
+
+// use C++17 std::string_view if available and requested:
+
+#if nssv_CPP17_OR_GREATER && defined(__has_include)
+#if __has_include(<string_view> )
+#define nssv_HAVE_STD_STRING_VIEW 1
+#else
+#define nssv_HAVE_STD_STRING_VIEW 0
+#endif
+#else
+#define nssv_HAVE_STD_STRING_VIEW 0
+#endif
+
+#define nssv_USES_STD_STRING_VIEW                                                                                      \
+  ((nssv_CONFIG_SELECT_STRING_VIEW == nssv_STRING_VIEW_STD) ||                                                         \
+   ((nssv_CONFIG_SELECT_STRING_VIEW == nssv_STRING_VIEW_DEFAULT) && nssv_HAVE_STD_STRING_VIEW))
+
+#define nssv_HAVE_STARTS_WITH (nssv_CPP20_OR_GREATER || !nssv_USES_STD_STRING_VIEW)
+#define nssv_HAVE_ENDS_WITH nssv_HAVE_STARTS_WITH
+
+//
+// Use C++17 std::string_view:
+//
+
+#if nssv_USES_STD_STRING_VIEW
+
+#include <string_view>
+
+// Extensions for std::string:
+
+#if nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
+
+namespace nonstd {
+
+template <class CharT, class Traits, class Allocator = std::allocator<CharT>>
+std::basic_string<CharT, Traits, Allocator> to_string(std::basic_string_view<CharT, Traits> v,
+                                                      Allocator const &a = Allocator()) {
+  return std::basic_string<CharT, Traits, Allocator>(v.begin(), v.end(), a);
+}
+
+template <class CharT, class Traits, class Allocator>
+std::basic_string_view<CharT, Traits> to_string_view(std::basic_string<CharT, Traits, Allocator> const &s) {
+  return std::basic_string_view<CharT, Traits>(s.data(), s.size());
+}
+
+// Literal operators sv and _sv:
+
+#if nssv_CONFIG_STD_SV_OPERATOR
+
+using namespace std::literals::string_view_literals;
+
+#endif
+
+#if nssv_CONFIG_USR_SV_OPERATOR
+
+inline namespace literals {
+inline namespace string_view_literals {
+
+constexpr std::string_view operator"" _sv(const char *str, size_t len) noexcept // (1)
+{
+  return std::string_view {str, len};
+}
+
+constexpr std::u16string_view operator"" _sv(const char16_t *str, size_t len) noexcept // (2)
+{
+  return std::u16string_view {str, len};
+}
+
+constexpr std::u32string_view operator"" _sv(const char32_t *str, size_t len) noexcept // (3)
+{
+  return std::u32string_view {str, len};
+}
+
+constexpr std::wstring_view operator"" _sv(const wchar_t *str, size_t len) noexcept // (4)
+{
+  return std::wstring_view {str, len};
+}
+
+} // namespace string_view_literals
+} // namespace literals
+
+#endif // nssv_CONFIG_USR_SV_OPERATOR
+
+} // namespace nonstd
+
+#endif // nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
+
+namespace nonstd {
+
+using std::basic_string_view;
+using std::string_view;
+using std::u16string_view;
+using std::u32string_view;
+using std::wstring_view;
+
+// literal "sv" and "_sv", see above
+
+using std::operator==;
+using std::operator!=;
+using std::operator<;
+using std::operator<=;
+using std::operator>;
+using std::operator>=;
+
+using std::operator<<;
+
+} // namespace nonstd
+
+#else // nssv_HAVE_STD_STRING_VIEW
+
+//
+// Before C++17: use string_view lite:
+//
+
+// Compiler versions:
+//
+// MSVC++ 6.0  _MSC_VER == 1200 (Visual Studio 6.0)
+// MSVC++ 7.0  _MSC_VER == 1300 (Visual Studio .NET 2002)
+// MSVC++ 7.1  _MSC_VER == 1310 (Visual Studio .NET 2003)
+// MSVC++ 8.0  _MSC_VER == 1400 (Visual Studio 2005)
+// MSVC++ 9.0  _MSC_VER == 1500 (Visual Studio 2008)
+// MSVC++ 10.0 _MSC_VER == 1600 (Visual Studio 2010)
+// MSVC++ 11.0 _MSC_VER == 1700 (Visual Studio 2012)
+// MSVC++ 12.0 _MSC_VER == 1800 (Visual Studio 2013)
+// MSVC++ 14.0 _MSC_VER == 1900 (Visual Studio 2015)
+// MSVC++ 14.1 _MSC_VER >= 1910 (Visual Studio 2017)
+
+#if defined(_MSC_VER) && !defined(__clang__)
+#define nssv_COMPILER_MSVC_VER (_MSC_VER)
+#define nssv_COMPILER_MSVC_VERSION (_MSC_VER / 10 - 10 * (5 + (_MSC_VER < 1900)))
+#else
+#define nssv_COMPILER_MSVC_VER 0
+#define nssv_COMPILER_MSVC_VERSION 0
+#endif
+
+#define nssv_COMPILER_VERSION(major, minor, patch) (10 * (10 * (major) + (minor)) + (patch))
+
+#if defined(__clang__)
+#define nssv_COMPILER_CLANG_VERSION nssv_COMPILER_VERSION(__clang_major__, __clang_minor__, __clang_patchlevel__)
+#else
+#define nssv_COMPILER_CLANG_VERSION 0
+#endif
+
+#if defined(__GNUC__) && !defined(__clang__)
+#define nssv_COMPILER_GNUC_VERSION nssv_COMPILER_VERSION(__GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__)
+#else
+#define nssv_COMPILER_GNUC_VERSION 0
+#endif
+
+// half-open range [lo..hi):
+#define nssv_BETWEEN(v, lo, hi) ((lo) <= (v) && (v) < (hi))
+
+// Presence of language and library features:
+
+#ifdef _HAS_CPP0X
+#define nssv_HAS_CPP0X _HAS_CPP0X
+#else
+#define nssv_HAS_CPP0X 0
+#endif
+
+// Unless defined otherwise below, consider VC14 as C++11 for variant-lite:
+
+#if nssv_COMPILER_MSVC_VER >= 1900
+#undef nssv_CPP11_OR_GREATER
+#define nssv_CPP11_OR_GREATER 1
+#endif
+
+#define nssv_CPP11_90 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1500)
+#define nssv_CPP11_100 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1600)
+#define nssv_CPP11_110 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1700)
+#define nssv_CPP11_120 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1800)
+#define nssv_CPP11_140 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1900)
+#define nssv_CPP11_141 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1910)
+
+#define nssv_CPP14_000 (nssv_CPP14_OR_GREATER)
+#define nssv_CPP17_000 (nssv_CPP17_OR_GREATER)
+
+// Presence of C++11 language features:
+
+#define nssv_HAVE_CONSTEXPR_11 nssv_CPP11_140
+#define nssv_HAVE_EXPLICIT_CONVERSION nssv_CPP11_140
+#define nssv_HAVE_INLINE_NAMESPACE nssv_CPP11_140
+#define nssv_HAVE_NOEXCEPT nssv_CPP11_140
+#define nssv_HAVE_NULLPTR nssv_CPP11_100
+#define nssv_HAVE_REF_QUALIFIER nssv_CPP11_140
+#define nssv_HAVE_UNICODE_LITERALS nssv_CPP11_140
+#define nssv_HAVE_USER_DEFINED_LITERALS nssv_CPP11_140
+#define nssv_HAVE_WCHAR16_T nssv_CPP11_100
+#define nssv_HAVE_WCHAR32_T nssv_CPP11_100
+
+#if !((nssv_CPP11_OR_GREATER && nssv_COMPILER_CLANG_VERSION) || nssv_BETWEEN(nssv_COMPILER_CLANG_VERSION, 300, 400))
+#define nssv_HAVE_STD_DEFINED_LITERALS nssv_CPP11_140
+#else
+#define nssv_HAVE_STD_DEFINED_LITERALS 0
+#endif
+
+// Presence of C++14 language features:
+
+#define nssv_HAVE_CONSTEXPR_14 nssv_CPP14_000
+
+// Presence of C++17 language features:
+
+#define nssv_HAVE_NODISCARD nssv_CPP17_000
+
+// Presence of C++ library features:
+
+#define nssv_HAVE_STD_HASH nssv_CPP11_120
+
+// C++ feature usage:
+
+#if nssv_HAVE_CONSTEXPR_11
+#define nssv_constexpr constexpr
+#else
+#define nssv_constexpr /*constexpr*/
+#endif
+
+#if nssv_HAVE_CONSTEXPR_14
+#define nssv_constexpr14 constexpr
+#else
+#define nssv_constexpr14 /*constexpr*/
+#endif
+
+#if nssv_HAVE_EXPLICIT_CONVERSION
+#define nssv_explicit explicit
+#else
+#define nssv_explicit /*explicit*/
+#endif
+
+#if nssv_HAVE_INLINE_NAMESPACE
+#define nssv_inline_ns inline
+#else
+#define nssv_inline_ns /*inline*/
+#endif
+
+#if nssv_HAVE_NOEXCEPT
+#define nssv_noexcept noexcept
+#else
+#define nssv_noexcept /*noexcept*/
+#endif
+
+//#if nssv_HAVE_REF_QUALIFIER
+//# define nssv_ref_qual  &
+//# define nssv_refref_qual  &&
+//#else
+//# define nssv_ref_qual  /*&*/
+//# define nssv_refref_qual  /*&&*/
+//#endif
+
+#if nssv_HAVE_NULLPTR
+#define nssv_nullptr nullptr
+#else
+#define nssv_nullptr NULL
+#endif
+
+#if nssv_HAVE_NODISCARD
+#define nssv_nodiscard [[nodiscard]]
+#else
+#define nssv_nodiscard /*[[nodiscard]]*/
+#endif
+
+// Additional includes:
+
+#include <algorithm>
+#include <cassert>
+#include <iterator>
+#include <limits>
+#include <ostream>
+#include <string> // std::char_traits<>
+
+#if !nssv_CONFIG_NO_EXCEPTIONS
+#include <stdexcept>
+#endif
+
+#if nssv_CPP11_OR_GREATER
+#include <type_traits>
+#endif
+
+// Clang, GNUC, MSVC warning suppression macros:
+
+#if defined(__clang__)
+#pragma clang diagnostic ignored "-Wreserved-user-defined-literal"
+#pragma clang diagnostic push
+#pragma clang diagnostic ignored "-Wuser-defined-literals"
+#elif defined(__GNUC__)
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wliteral-suffix"
+#endif // __clang__
+
+#if nssv_COMPILER_MSVC_VERSION >= 140
+#define nssv_SUPPRESS_MSGSL_WARNING(expr) [[gsl::suppress(expr)]]
+#define nssv_SUPPRESS_MSVC_WARNING(code, descr) __pragma(warning(suppress : code))
+#define nssv_DISABLE_MSVC_WARNINGS(codes) __pragma(warning(push)) __pragma(warning(disable : codes))
+#else
+#define nssv_SUPPRESS_MSGSL_WARNING(expr)
+#define nssv_SUPPRESS_MSVC_WARNING(code, descr)
+#define nssv_DISABLE_MSVC_WARNINGS(codes)
+#endif
+
+#if defined(__clang__)
+#define nssv_RESTORE_WARNINGS() _Pragma("clang diagnostic pop")
+#elif defined(__GNUC__)
+#define nssv_RESTORE_WARNINGS() _Pragma("GCC diagnostic pop")
+#elif nssv_COMPILER_MSVC_VERSION >= 140
+#define nssv_RESTORE_WARNINGS() __pragma(warning(pop))
+#else
+#define nssv_RESTORE_WARNINGS()
+#endif
+
+// Suppress the following MSVC (GSL) warnings:
+// - C4455, non-gsl   : 'operator ""sv': literal suffix identifiers that do not
+//                      start with an underscore are reserved
+// - C26472, gsl::t.1 : don't use a static_cast for arithmetic conversions;
+//                      use brace initialization, gsl::narrow_cast or gsl::narow
+// - C26481: gsl::b.1 : don't use pointer arithmetic. Use span instead
+
+nssv_DISABLE_MSVC_WARNINGS(4455 26481 26472)
+    // nssv_DISABLE_CLANG_WARNINGS( "-Wuser-defined-literals" )
+    // nssv_DISABLE_GNUC_WARNINGS( -Wliteral-suffix )
+
+    namespace nonstd {
+  namespace sv_lite {
+
+#if nssv_CPP11_OR_GREATER
+
+  namespace detail {
+
+  // Expect tail call optimization to make length() non-recursive:
+
+  template <typename CharT> inline constexpr std::size_t length(CharT *s, std::size_t result = 0) {
+    return *s == '\0' ? result : length(s + 1, result + 1);
+  }
+
+  } // namespace detail
+
+#endif // nssv_CPP11_OR_GREATER
+
+  template <class CharT, class Traits = std::char_traits<CharT>> class basic_string_view;
+
+  //
+  // basic_string_view:
+  //
+
+  template <class CharT, class Traits /* = std::char_traits<CharT> */
+            >
+  class basic_string_view {
+  public:
+    // Member types:
+
+    typedef Traits traits_type;
+    typedef CharT value_type;
+
+    typedef CharT *pointer;
+    typedef CharT const *const_pointer;
+    typedef CharT &reference;
+    typedef CharT const &const_reference;
+
+    typedef const_pointer iterator;
+    typedef const_pointer const_iterator;
+    typedef std::reverse_iterator<const_iterator> reverse_iterator;
+    typedef std::reverse_iterator<const_iterator> const_reverse_iterator;
+
+    typedef std::size_t size_type;
+    typedef std::ptrdiff_t difference_type;
+
+    // 24.4.2.1 Construction and assignment:
+
+    nssv_constexpr basic_string_view() nssv_noexcept : data_(nssv_nullptr), size_(0) {}
+
+#if nssv_CPP11_OR_GREATER
+    nssv_constexpr basic_string_view(basic_string_view const &other) nssv_noexcept = default;
+#else
+    nssv_constexpr basic_string_view(basic_string_view const &other) nssv_noexcept : data_(other.data_),
+                                                                                     size_(other.size_) {}
+#endif
+
+    nssv_constexpr basic_string_view(CharT const *s, size_type count) nssv_noexcept // non-standard noexcept
+        : data_(s),
+          size_(count) {}
+
+    nssv_constexpr basic_string_view(CharT const *s) nssv_noexcept // non-standard noexcept
+        : data_(s)
+#if nssv_CPP17_OR_GREATER
+        ,
+          size_(Traits::length(s))
+#elif nssv_CPP11_OR_GREATER
+        ,
+          size_(detail::length(s))
+#else
+        ,
+          size_(Traits::length(s))
+#endif
+    {
+    }
+
+    // Assignment:
+
+#if nssv_CPP11_OR_GREATER
+    nssv_constexpr14 basic_string_view &operator=(basic_string_view const &other) nssv_noexcept = default;
+#else
+    nssv_constexpr14 basic_string_view &operator=(basic_string_view const &other) nssv_noexcept {
+      data_ = other.data_;
+      size_ = other.size_;
+      return *this;
+    }
+#endif
+
+    // 24.4.2.2 Iterator support:
+
+    nssv_constexpr const_iterator begin() const nssv_noexcept { return data_; }
+    nssv_constexpr const_iterator end() const nssv_noexcept { return data_ + size_; }
+
+    nssv_constexpr const_iterator cbegin() const nssv_noexcept { return begin(); }
+    nssv_constexpr const_iterator cend() const nssv_noexcept { return end(); }
+
+    nssv_constexpr const_reverse_iterator rbegin() const nssv_noexcept { return const_reverse_iterator(end()); }
+    nssv_constexpr const_reverse_iterator rend() const nssv_noexcept { return const_reverse_iterator(begin()); }
+
+    nssv_constexpr const_reverse_iterator crbegin() const nssv_noexcept { return rbegin(); }
+    nssv_constexpr const_reverse_iterator crend() const nssv_noexcept { return rend(); }
+
+    // 24.4.2.3 Capacity:
+
+    nssv_constexpr size_type size() const nssv_noexcept { return size_; }
+    nssv_constexpr size_type length() const nssv_noexcept { return size_; }
+    nssv_constexpr size_type max_size() const nssv_noexcept { return (std::numeric_limits<size_type>::max)(); }
+
+    // since C++20
+    nssv_nodiscard nssv_constexpr bool empty() const nssv_noexcept { return 0 == size_; }
+
+    // 24.4.2.4 Element access:
+
+    nssv_constexpr const_reference operator[](size_type pos) const { return data_at(pos); }
+
+    nssv_constexpr14 const_reference at(size_type pos) const {
+#if nssv_CONFIG_NO_EXCEPTIONS
+      assert(pos < size());
+#else
+      if (pos >= size()) {
+        throw std::out_of_range("nonstd::string_view::at()");
+      }
+#endif
+      return data_at(pos);
+    }
+
+    nssv_constexpr const_reference front() const { return data_at(0); }
+    nssv_constexpr const_reference back() const { return data_at(size() - 1); }
+
+    nssv_constexpr const_pointer data() const nssv_noexcept { return data_; }
+
+    // 24.4.2.5 Modifiers:
+
+    nssv_constexpr14 void remove_prefix(size_type n) {
+      assert(n <= size());
+      data_ += n;
+      size_ -= n;
+    }
+
+    nssv_constexpr14 void remove_suffix(size_type n) {
+      assert(n <= size());
+      size_ -= n;
+    }
+
+    nssv_constexpr14 void swap(basic_string_view &other) nssv_noexcept {
+      using std::swap;
+      swap(data_, other.data_);
+      swap(size_, other.size_);
+    }
+
+    // 24.4.2.6 String operations:
+
+    size_type copy(CharT *dest, size_type n, size_type pos = 0) const {
+#if nssv_CONFIG_NO_EXCEPTIONS
+      assert(pos <= size());
+#else
+      if (pos > size()) {
+        throw std::out_of_range("nonstd::string_view::copy()");
+      }
+#endif
+      const size_type rlen = (std::min)(n, size() - pos);
+
+      (void)Traits::copy(dest, data() + pos, rlen);
+
+      return rlen;
+    }
+
+    nssv_constexpr14 basic_string_view substr(size_type pos = 0, size_type n = npos) const {
+#if nssv_CONFIG_NO_EXCEPTIONS
+      assert(pos <= size());
+#else
+      if (pos > size()) {
+        throw std::out_of_range("nonstd::string_view::substr()");
+      }
+#endif
+      return basic_string_view(data() + pos, (std::min)(n, size() - pos));
+    }
+
+    // compare(), 6x:
+
+    nssv_constexpr14 int compare(basic_string_view other) const nssv_noexcept // (1)
+    {
+      if (const int result = Traits::compare(data(), other.data(), (std::min)(size(), other.size()))) {
+        return result;
+      }
+
+      return size() == other.size() ? 0 : size() < other.size() ? -1 : 1;
+    }
+
+    nssv_constexpr int compare(size_type pos1, size_type n1, basic_string_view other) const // (2)
+    {
+      return substr(pos1, n1).compare(other);
+    }
+
+    nssv_constexpr int compare(size_type pos1, size_type n1, basic_string_view other, size_type pos2,
+                               size_type n2) const // (3)
+    {
+      return substr(pos1, n1).compare(other.substr(pos2, n2));
+    }
+
+    nssv_constexpr int compare(CharT const *s) const // (4)
+    {
+      return compare(basic_string_view(s));
+    }
+
+    nssv_constexpr int compare(size_type pos1, size_type n1, CharT const *s) const // (5)
+    {
+      return substr(pos1, n1).compare(basic_string_view(s));
+    }
+
+    nssv_constexpr int compare(size_type pos1, size_type n1, CharT const *s, size_type n2) const // (6)
+    {
+      return substr(pos1, n1).compare(basic_string_view(s, n2));
+    }
+
+    // 24.4.2.7 Searching:
+
+    // starts_with(), 3x, since C++20:
+
+    nssv_constexpr bool starts_with(basic_string_view v) const nssv_noexcept // (1)
+    {
+      return size() >= v.size() && compare(0, v.size(), v) == 0;
+    }
+
+    nssv_constexpr bool starts_with(CharT c) const nssv_noexcept // (2)
+    {
+      return starts_with(basic_string_view(&c, 1));
+    }
+
+    nssv_constexpr bool starts_with(CharT const *s) const // (3)
+    {
+      return starts_with(basic_string_view(s));
+    }
+
+    // ends_with(), 3x, since C++20:
+
+    nssv_constexpr bool ends_with(basic_string_view v) const nssv_noexcept // (1)
+    {
+      return size() >= v.size() && compare(size() - v.size(), npos, v) == 0;
+    }
+
+    nssv_constexpr bool ends_with(CharT c) const nssv_noexcept // (2)
+    {
+      return ends_with(basic_string_view(&c, 1));
+    }
+
+    nssv_constexpr bool ends_with(CharT const *s) const // (3)
+    {
+      return ends_with(basic_string_view(s));
+    }
+
+    // find(), 4x:
+
+    nssv_constexpr14 size_type find(basic_string_view v, size_type pos = 0) const nssv_noexcept // (1)
+    {
+      return assert(v.size() == 0 || v.data() != nssv_nullptr),
+             pos >= size() ? npos : to_pos(std::search(cbegin() + pos, cend(), v.cbegin(), v.cend(), Traits::eq));
+    }
+
+    nssv_constexpr14 size_type find(CharT c, size_type pos = 0) const nssv_noexcept // (2)
+    {
+      return find(basic_string_view(&c, 1), pos);
+    }
+
+    nssv_constexpr14 size_type find(CharT const *s, size_type pos, size_type n) const // (3)
+    {
+      return find(basic_string_view(s, n), pos);
+    }
+
+    nssv_constexpr14 size_type find(CharT const *s, size_type pos = 0) const // (4)
+    {
+      return find(basic_string_view(s), pos);
+    }
+
+    // rfind(), 4x:
+
+    nssv_constexpr14 size_type rfind(basic_string_view v, size_type pos = npos) const nssv_noexcept // (1)
+    {
+      if (size() < v.size()) {
+        return npos;
+      }
+
+      if (v.empty()) {
+        return (std::min)(size(), pos);
+      }
+
+      const_iterator last = cbegin() + (std::min)(size() - v.size(), pos) + v.size();
+      const_iterator result = std::find_end(cbegin(), last, v.cbegin(), v.cend(), Traits::eq);
+
+      return result != last ? size_type(result - cbegin()) : npos;
+    }
+
+    nssv_constexpr14 size_type rfind(CharT c, size_type pos = npos) const nssv_noexcept // (2)
+    {
+      return rfind(basic_string_view(&c, 1), pos);
+    }
+
+    nssv_constexpr14 size_type rfind(CharT const *s, size_type pos, size_type n) const // (3)
+    {
+      return rfind(basic_string_view(s, n), pos);
+    }
+
+    nssv_constexpr14 size_type rfind(CharT const *s, size_type pos = npos) const // (4)
+    {
+      return rfind(basic_string_view(s), pos);
+    }
+
+    // find_first_of(), 4x:
+
+    nssv_constexpr size_type find_first_of(basic_string_view v, size_type pos = 0) const nssv_noexcept // (1)
+    {
+      return pos >= size() ? npos
+                           : to_pos(std::find_first_of(cbegin() + pos, cend(), v.cbegin(), v.cend(), Traits::eq));
+    }
+
+    nssv_constexpr size_type find_first_of(CharT c, size_type pos = 0) const nssv_noexcept // (2)
+    {
+      return find_first_of(basic_string_view(&c, 1), pos);
+    }
+
+    nssv_constexpr size_type find_first_of(CharT const *s, size_type pos, size_type n) const // (3)
+    {
+      return find_first_of(basic_string_view(s, n), pos);
+    }
+
+    nssv_constexpr size_type find_first_of(CharT const *s, size_type pos = 0) const // (4)
+    {
+      return find_first_of(basic_string_view(s), pos);
+    }
+
+    // find_last_of(), 4x:
+
+    nssv_constexpr size_type find_last_of(basic_string_view v, size_type pos = npos) const nssv_noexcept // (1)
+    {
+      return empty() ? npos
+                     : pos >= size() ? find_last_of(v, size() - 1)
+                                     : to_pos(std::find_first_of(const_reverse_iterator(cbegin() + pos + 1), crend(),
+                                                                 v.cbegin(), v.cend(), Traits::eq));
+    }
+
+    nssv_constexpr size_type find_last_of(CharT c, size_type pos = npos) const nssv_noexcept // (2)
+    {
+      return find_last_of(basic_string_view(&c, 1), pos);
+    }
+
+    nssv_constexpr size_type find_last_of(CharT const *s, size_type pos, size_type count) const // (3)
+    {
+      return find_last_of(basic_string_view(s, count), pos);
+    }
+
+    nssv_constexpr size_type find_last_of(CharT const *s, size_type pos = npos) const // (4)
+    {
+      return find_last_of(basic_string_view(s), pos);
+    }
+
+    // find_first_not_of(), 4x:
+
+    nssv_constexpr size_type find_first_not_of(basic_string_view v, size_type pos = 0) const nssv_noexcept // (1)
+    {
+      return pos >= size() ? npos : to_pos(std::find_if(cbegin() + pos, cend(), not_in_view(v)));
+    }
+
+    nssv_constexpr size_type find_first_not_of(CharT c, size_type pos = 0) const nssv_noexcept // (2)
+    {
+      return find_first_not_of(basic_string_view(&c, 1), pos);
+    }
+
+    nssv_constexpr size_type find_first_not_of(CharT const *s, size_type pos, size_type count) const // (3)
+    {
+      return find_first_not_of(basic_string_view(s, count), pos);
+    }
+
+    nssv_constexpr size_type find_first_not_of(CharT const *s, size_type pos = 0) const // (4)
+    {
+      return find_first_not_of(basic_string_view(s), pos);
+    }
+
+    // find_last_not_of(), 4x:
+
+    nssv_constexpr size_type find_last_not_of(basic_string_view v, size_type pos = npos) const nssv_noexcept // (1)
+    {
+      return empty() ? npos
+                     : pos >= size()
+                           ? find_last_not_of(v, size() - 1)
+                           : to_pos(std::find_if(const_reverse_iterator(cbegin() + pos + 1), crend(), not_in_view(v)));
+    }
+
+    nssv_constexpr size_type find_last_not_of(CharT c, size_type pos = npos) const nssv_noexcept // (2)
+    {
+      return find_last_not_of(basic_string_view(&c, 1), pos);
+    }
+
+    nssv_constexpr size_type find_last_not_of(CharT const *s, size_type pos, size_type count) const // (3)
+    {
+      return find_last_not_of(basic_string_view(s, count), pos);
+    }
+
+    nssv_constexpr size_type find_last_not_of(CharT const *s, size_type pos = npos) const // (4)
+    {
+      return find_last_not_of(basic_string_view(s), pos);
+    }
+
+    // Constants:
+
+#if nssv_CPP17_OR_GREATER
+    static nssv_constexpr size_type npos = size_type(-1);
+#elif nssv_CPP11_OR_GREATER
+    enum : size_type { npos = size_type(-1) };
+#else
+    enum { npos = size_type(-1) };
+#endif
+
+  private:
+    struct not_in_view {
+      const basic_string_view v;
+
+      nssv_constexpr explicit not_in_view(basic_string_view v) : v(v) {}
+
+      nssv_constexpr bool operator()(CharT c) const { return npos == v.find_first_of(c); }
+    };
+
+    nssv_constexpr size_type to_pos(const_iterator it) const { return it == cend() ? npos : size_type(it - cbegin()); }
+
+    nssv_constexpr size_type to_pos(const_reverse_iterator it) const {
+      return it == crend() ? npos : size_type(crend() - it - 1);
+    }
+
+    nssv_constexpr const_reference data_at(size_type pos) const {
+#if nssv_BETWEEN(nssv_COMPILER_GNUC_VERSION, 1, 500)
+      return data_[pos];
+#else
+      return assert(pos < size()), data_[pos];
+#endif
+    }
+
+  private:
+    const_pointer data_;
+    size_type size_;
+
+  public:
+#if nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS
+
+    template <class Allocator>
+    basic_string_view(std::basic_string<CharT, Traits, Allocator> const &s) nssv_noexcept : data_(s.data()),
+                                                                                            size_(s.size()) {}
+
+#if nssv_HAVE_EXPLICIT_CONVERSION
+
+    template <class Allocator> explicit operator std::basic_string<CharT, Traits, Allocator>() const {
+      return to_string(Allocator());
+    }
+
+#endif // nssv_HAVE_EXPLICIT_CONVERSION
+
+#if nssv_CPP11_OR_GREATER
+
+    template <class Allocator = std::allocator<CharT>>
+    std::basic_string<CharT, Traits, Allocator> to_string(Allocator const &a = Allocator()) const {
+      return std::basic_string<CharT, Traits, Allocator>(begin(), end(), a);
+    }
+
+#else
+
+    std::basic_string<CharT, Traits> to_string() const { return std::basic_string<CharT, Traits>(begin(), end()); }
+
+    template <class Allocator> std::basic_string<CharT, Traits, Allocator> to_string(Allocator const &a) const {
+      return std::basic_string<CharT, Traits, Allocator>(begin(), end(), a);
+    }
+
+#endif // nssv_CPP11_OR_GREATER
+
+#endif // nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS
+  };
+
+  //
+  // Non-member functions:
+  //
+
+  // 24.4.3 Non-member comparison functions:
+  // lexicographically compare two string views (function template):
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) == 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) != 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs,
+                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) < 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) <= 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs,
+                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) > 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) >= 0;
+  }
+
+  // Let S be basic_string_view<CharT, Traits>, and sv be an instance of S.
+  // Implementations shall provide sufficient additional overloads marked
+  // constexpr and noexcept so that an object t with an implicit conversion
+  // to S can be compared according to Table 67.
+
+#if !nssv_CPP11_OR_GREATER || nssv_BETWEEN(nssv_COMPILER_MSVC_VERSION, 100, 141)
+
+  // accomodate for older compilers:
+
+  // ==
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
+    return lhs.compare(rhs) == 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator==(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return rhs.compare(lhs) == 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs,
+                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.size() == rhs.size() && lhs.compare(rhs) == 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator==(std::basic_string<CharT, Traits> rhs,
+                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
+    return lhs.size() == rhs.size() && lhs.compare(rhs) == 0;
+  }
+
+  // !=
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
+    return lhs.compare(rhs) != 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator!=(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return rhs.compare(lhs) != 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs,
+                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.size() != rhs.size() && lhs.compare(rhs) != 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator!=(std::basic_string<CharT, Traits> rhs,
+                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
+    return lhs.size() != rhs.size() || rhs.compare(lhs) != 0;
+  }
+
+  // <
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
+    return lhs.compare(rhs) < 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return rhs.compare(lhs) > 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs,
+                                std::basic_string<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) < 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<(std::basic_string<CharT, Traits> rhs,
+                                basic_string_view<CharT, Traits> lhs) nssv_noexcept {
+    return rhs.compare(lhs) > 0;
+  }
+
+  // <=
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
+    return lhs.compare(rhs) <= 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<=(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return rhs.compare(lhs) >= 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs,
+                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) <= 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator<=(std::basic_string<CharT, Traits> rhs,
+                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
+    return rhs.compare(lhs) >= 0;
+  }
+
+  // >
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
+    return lhs.compare(rhs) > 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return rhs.compare(lhs) < 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs,
+                                std::basic_string<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) > 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>(std::basic_string<CharT, Traits> rhs,
+                                basic_string_view<CharT, Traits> lhs) nssv_noexcept {
+    return rhs.compare(lhs) < 0;
+  }
+
+  // >=
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
+    return lhs.compare(rhs) >= 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>=(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return rhs.compare(lhs) <= 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs,
+                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) >= 0;
+  }
+
+  template <class CharT, class Traits>
+  nssv_constexpr bool operator>=(std::basic_string<CharT, Traits> rhs,
+                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
+    return rhs.compare(lhs) <= 0;
+  }
+
+#else // newer compilers:
+
+#define nssv_BASIC_STRING_VIEW_I(T, U) typename std::decay<basic_string_view<T, U>>::type
+
+#if nssv_BETWEEN(nssv_COMPILER_MSVC_VERSION, 140, 150)
+#define nssv_MSVC_ORDER(x) , int = x
+#else
+#define nssv_MSVC_ORDER(x) /*, int=x*/
+#endif
+
+  // ==
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
+  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs,
+                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
+    return lhs.compare(rhs) == 0;
+  }
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
+  nssv_constexpr bool operator==(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.size() == rhs.size() && lhs.compare(rhs) == 0;
+  }
+
+  // !=
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
+  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs,
+                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
+    return lhs.size() != rhs.size() || lhs.compare(rhs) != 0;
+  }
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
+  nssv_constexpr bool operator!=(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) != 0;
+  }
+
+  // <
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
+  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs,
+                                nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
+    return lhs.compare(rhs) < 0;
+  }
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
+  nssv_constexpr bool operator<(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
+                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) < 0;
+  }
+
+  // <=
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
+  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs,
+                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
+    return lhs.compare(rhs) <= 0;
+  }
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
+  nssv_constexpr bool operator<=(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) <= 0;
+  }
+
+  // >
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
+  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs,
+                                nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
+    return lhs.compare(rhs) > 0;
+  }
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
+  nssv_constexpr bool operator>(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
+                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) > 0;
+  }
+
+  // >=
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
+  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs,
+                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
+    return lhs.compare(rhs) >= 0;
+  }
+
+  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
+  nssv_constexpr bool operator>=(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
+                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
+    return lhs.compare(rhs) >= 0;
+  }
+
+#undef nssv_MSVC_ORDER
+#undef nssv_BASIC_STRING_VIEW_I
+
+#endif // compiler-dependent approach to comparisons
+
+  // 24.4.4 Inserters and extractors:
+
+  namespace detail {
+
+  template <class Stream> void write_padding(Stream &os, std::streamsize n) {
+    for (std::streamsize i = 0; i < n; ++i)
+      os.rdbuf()->sputc(os.fill());
+  }
+
+  template <class Stream, class View> Stream &write_to_stream(Stream &os, View const &sv) {
+    typename Stream::sentry sentry(os);
+
+    if (!os)
+      return os;
+
+    const std::streamsize length = static_cast<std::streamsize>(sv.length());
+
+    // Whether, and how, to pad:
+    const bool pad = (length < os.width());
+    const bool left_pad = pad && (os.flags() & std::ios_base::adjustfield) == std::ios_base::right;
+
+    if (left_pad)
+      write_padding(os, os.width() - length);
+
+    // Write span characters:
+    os.rdbuf()->sputn(sv.begin(), length);
+
+    if (pad && !left_pad)
+      write_padding(os, os.width() - length);
+
+    // Reset output stream width:
+    os.width(0);
+
+    return os;
+  }
+
+  } // namespace detail
+
+  template <class CharT, class Traits>
+  std::basic_ostream<CharT, Traits> &operator<<(std::basic_ostream<CharT, Traits> &os,
+                                                basic_string_view<CharT, Traits> sv) {
+    return detail::write_to_stream(os, sv);
+  }
+
+  // Several typedefs for common character types are provided:
+
+  typedef basic_string_view<char> string_view;
+  typedef basic_string_view<wchar_t> wstring_view;
+#if nssv_HAVE_WCHAR16_T
+  typedef basic_string_view<char16_t> u16string_view;
+  typedef basic_string_view<char32_t> u32string_view;
+#endif
+
+  } // namespace sv_lite
+} // namespace nonstd::sv_lite
+
+//
+// 24.4.6 Suffix for basic_string_view literals:
+//
+
+#if nssv_HAVE_USER_DEFINED_LITERALS
+
+namespace nonstd {
+nssv_inline_ns namespace literals {
+  nssv_inline_ns namespace string_view_literals {
+
+#if nssv_CONFIG_STD_SV_OPERATOR && nssv_HAVE_STD_DEFINED_LITERALS
+
+    nssv_constexpr nonstd::sv_lite::string_view operator"" sv(const char *str, size_t len) nssv_noexcept // (1)
+    {
+      return nonstd::sv_lite::string_view {str, len};
+    }
+
+    nssv_constexpr nonstd::sv_lite::u16string_view operator"" sv(const char16_t *str, size_t len) nssv_noexcept // (2)
+    {
+      return nonstd::sv_lite::u16string_view {str, len};
+    }
+
+    nssv_constexpr nonstd::sv_lite::u32string_view operator"" sv(const char32_t *str, size_t len) nssv_noexcept // (3)
+    {
+      return nonstd::sv_lite::u32string_view {str, len};
+    }
+
+    nssv_constexpr nonstd::sv_lite::wstring_view operator"" sv(const wchar_t *str, size_t len) nssv_noexcept // (4)
+    {
+      return nonstd::sv_lite::wstring_view {str, len};
+    }
+
+#endif // nssv_CONFIG_STD_SV_OPERATOR && nssv_HAVE_STD_DEFINED_LITERALS
+
+#if nssv_CONFIG_USR_SV_OPERATOR
+
+    nssv_constexpr nonstd::sv_lite::string_view operator"" _sv(const char *str, size_t len) nssv_noexcept // (1)
+    {
+      return nonstd::sv_lite::string_view {str, len};
+    }
+
+    nssv_constexpr nonstd::sv_lite::u16string_view operator"" _sv(const char16_t *str, size_t len) nssv_noexcept // (2)
+    {
+      return nonstd::sv_lite::u16string_view {str, len};
+    }
+
+    nssv_constexpr nonstd::sv_lite::u32string_view operator"" _sv(const char32_t *str, size_t len) nssv_noexcept // (3)
+    {
+      return nonstd::sv_lite::u32string_view {str, len};
+    }
+
+    nssv_constexpr nonstd::sv_lite::wstring_view operator"" _sv(const wchar_t *str, size_t len) nssv_noexcept // (4)
+    {
+      return nonstd::sv_lite::wstring_view {str, len};
+    }
+
+#endif // nssv_CONFIG_USR_SV_OPERATOR
+  }
+}
+} // namespace nonstd
+
+#endif
+
+//
+// Extensions for std::string:
+//
+
+#if nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
+
+namespace nonstd {
+namespace sv_lite {
+
+// Exclude MSVC 14 (19.00): it yields ambiguous to_string():
+
+#if nssv_CPP11_OR_GREATER && nssv_COMPILER_MSVC_VERSION != 140
+
+template <class CharT, class Traits, class Allocator = std::allocator<CharT>>
+std::basic_string<CharT, Traits, Allocator> to_string(basic_string_view<CharT, Traits> v,
+                                                      Allocator const &a = Allocator()) {
+  return std::basic_string<CharT, Traits, Allocator>(v.begin(), v.end(), a);
+}
+
+#else
+
+template <class CharT, class Traits> std::basic_string<CharT, Traits> to_string(basic_string_view<CharT, Traits> v) {
+  return std::basic_string<CharT, Traits>(v.begin(), v.end());
+}
+
+template <class CharT, class Traits, class Allocator>
+std::basic_string<CharT, Traits, Allocator> to_string(basic_string_view<CharT, Traits> v, Allocator const &a) {
+  return std::basic_string<CharT, Traits, Allocator>(v.begin(), v.end(), a);
+}
+
+#endif // nssv_CPP11_OR_GREATER
+
+template <class CharT, class Traits, class Allocator>
+basic_string_view<CharT, Traits> to_string_view(std::basic_string<CharT, Traits, Allocator> const &s) {
+  return basic_string_view<CharT, Traits>(s.data(), s.size());
+}
+
+} // namespace sv_lite
+} // namespace nonstd
+
+#endif // nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
+
+//
+// make types and algorithms available in namespace nonstd:
+//
+
+namespace nonstd {
+
+using sv_lite::basic_string_view;
+using sv_lite::string_view;
+using sv_lite::wstring_view;
+
+#if nssv_HAVE_WCHAR16_T
+using sv_lite::u16string_view;
+#endif
+#if nssv_HAVE_WCHAR32_T
+using sv_lite::u32string_view;
+#endif
+
+// literal "sv"
+
+using sv_lite::operator==;
+using sv_lite::operator!=;
+using sv_lite::operator<;
+using sv_lite::operator<=;
+using sv_lite::operator>;
+using sv_lite::operator>=;
+
+using sv_lite::operator<<;
+
+#if nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
+using sv_lite::to_string;
+using sv_lite::to_string_view;
+#endif
+
+} // namespace nonstd
+
+// 24.4.5 Hash support (C++11):
+
+// Note: The hash value of a string view object is equal to the hash value of
+// the corresponding string object.
+
+#if nssv_HAVE_STD_HASH
+
+#include <functional>
+
+namespace std {
+
+template <> struct hash<nonstd::string_view> {
+public:
+  std::size_t operator()(nonstd::string_view v) const nssv_noexcept {
+    return std::hash<std::string>()(std::string(v.data(), v.size()));
+  }
+};
+
+template <> struct hash<nonstd::wstring_view> {
+public:
+  std::size_t operator()(nonstd::wstring_view v) const nssv_noexcept {
+    return std::hash<std::wstring>()(std::wstring(v.data(), v.size()));
+  }
+};
+
+template <> struct hash<nonstd::u16string_view> {
+public:
+  std::size_t operator()(nonstd::u16string_view v) const nssv_noexcept {
+    return std::hash<std::u16string>()(std::u16string(v.data(), v.size()));
+  }
+};
+
+template <> struct hash<nonstd::u32string_view> {
+public:
+  std::size_t operator()(nonstd::u32string_view v) const nssv_noexcept {
+    return std::hash<std::u32string>()(std::u32string(v.data(), v.size()));
+  }
+};
+
+} // namespace std
+
+#endif // nssv_HAVE_STD_HASH
+
+nssv_RESTORE_WARNINGS()
+
+#endif // nssv_HAVE_STD_STRING_VIEW
+#endif // NONSTD_SV_LITE_H_INCLUDED
+
+// #include "template.hpp"
+#ifndef INCLUDE_INJA_TEMPLATE_HPP_
+#define INCLUDE_INJA_TEMPLATE_HPP_
+
+#include <map>
+#include <memory>
+#include <string>
+#include <vector>
+
+// #include "node.hpp"
+#ifndef INCLUDE_INJA_NODE_HPP_
+#define INCLUDE_INJA_NODE_HPP_
+
+#include <string>
+#include <utility>
+
+// #include "function_storage.hpp"
+#ifndef INCLUDE_INJA_FUNCTION_STORAGE_HPP_
+#define INCLUDE_INJA_FUNCTION_STORAGE_HPP_
+
+#include <vector>
+
+// #include "string_view.hpp"
+
+
+namespace inja {
+
+using Arguments = std::vector<const json *>;
+using CallbackFunction = std::function<json(Arguments &args)>;
+using VoidCallbackFunction = std::function<void(Arguments &args)>;
+
+/*!
+ * \brief Class for builtin functions and user-defined callbacks.
+ */
+class FunctionStorage {
+public:
+  enum class Operation {
+    Not,
+    And,
+    Or,
+    In,
+    Equal,
+    NotEqual,
+    Greater,
+    GreaterEqual,
+    Less,
+    LessEqual,
+    Add,
+    Subtract,
+    Multiplication,
+    Division,
+    Power,
+    Modulo,
+    AtId,
+    At,
+    Default,
+    DivisibleBy,
+    Even,
+    Exists,
+    ExistsInObject,
+    First,
+    Float,
+    Int,
+    IsArray,
+    IsBoolean,
+    IsFloat,
+    IsInteger,
+    IsNumber,
+    IsObject,
+    IsString,
+    Last,
+    Length,
+    Lower,
+    Max,
+    Min,
+    Odd,
+    Range,
+    Round,
+    Sort,
+    Upper,
+    Super,
+    Join,
+    Callback,
+    ParenLeft,
+    ParenRight,
+    None,
+  };
+
+  struct FunctionData {
+    explicit FunctionData(const Operation &op, const CallbackFunction &cb = CallbackFunction{}) : operation(op), callback(cb) {}
+    const Operation operation;
+    const CallbackFunction callback;
+  };
+
+private:
+  const int VARIADIC {-1};
+
+  std::map<std::pair<std::string, int>, FunctionData> function_storage = {
+    {std::make_pair("at", 2), FunctionData { Operation::At }},
+    {std::make_pair("default", 2), FunctionData { Operation::Default }},
+    {std::make_pair("divisibleBy", 2), FunctionData { Operation::DivisibleBy }},
+    {std::make_pair("even", 1), FunctionData { Operation::Even }},
+    {std::make_pair("exists", 1), FunctionData { Operation::Exists }},
+    {std::make_pair("existsIn", 2), FunctionData { Operation::ExistsInObject }},
+    {std::make_pair("first", 1), FunctionData { Operation::First }},
+    {std::make_pair("float", 1), FunctionData { Operation::Float }},
+    {std::make_pair("int", 1), FunctionData { Operation::Int }},
+    {std::make_pair("isArray", 1), FunctionData { Operation::IsArray }},
+    {std::make_pair("isBoolean", 1), FunctionData { Operation::IsBoolean }},
+    {std::make_pair("isFloat", 1), FunctionData { Operation::IsFloat }},
+    {std::make_pair("isInteger", 1), FunctionData { Operation::IsInteger }},
+    {std::make_pair("isNumber", 1), FunctionData { Operation::IsNumber }},
+    {std::make_pair("isObject", 1), FunctionData { Operation::IsObject }},
+    {std::make_pair("isString", 1), FunctionData { Operation::IsString }},
+    {std::make_pair("last", 1), FunctionData { Operation::Last }},
+    {std::make_pair("length", 1), FunctionData { Operation::Length }},
+    {std::make_pair("lower", 1), FunctionData { Operation::Lower }},
+    {std::make_pair("max", 1), FunctionData { Operation::Max }},
+    {std::make_pair("min", 1), FunctionData { Operation::Min }},
+    {std::make_pair("odd", 1), FunctionData { Operation::Odd }},
+    {std::make_pair("range", 1), FunctionData { Operation::Range }},
+    {std::make_pair("round", 2), FunctionData { Operation::Round }},
+    {std::make_pair("sort", 1), FunctionData { Operation::Sort }},
+    {std::make_pair("upper", 1), FunctionData { Operation::Upper }},
+    {std::make_pair("super", 0), FunctionData { Operation::Super }},
+    {std::make_pair("super", 1), FunctionData { Operation::Super }},
+    {std::make_pair("join", 2), FunctionData { Operation::Join }},
+  };
+
+public:
+  void add_builtin(nonstd::string_view name, int num_args, Operation op) {
+    function_storage.emplace(std::make_pair(static_cast<std::string>(name), num_args), FunctionData { op });
+  }
+
+  void add_callback(nonstd::string_view name, int num_args, const CallbackFunction &callback) {
+    function_storage.emplace(std::make_pair(static_cast<std::string>(name), num_args), FunctionData { Operation::Callback, callback });
+  }
+
+  FunctionData find_function(nonstd::string_view name, int num_args) const {
+    auto it = function_storage.find(std::make_pair(static_cast<std::string>(name), num_args));
+    if (it != function_storage.end()) {
+      return it->second;
+
+    // Find variadic function
+    } else if (num_args > 0) {
+      it = function_storage.find(std::make_pair(static_cast<std::string>(name), VARIADIC));
+      if (it != function_storage.end()) {
+        return it->second;
+      }
+    }
+
+    return FunctionData { Operation::None };
+  }
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_FUNCTION_STORAGE_HPP_
+
+// #include "string_view.hpp"
+
+// #include "utils.hpp"
+#ifndef INCLUDE_INJA_UTILS_HPP_
+#define INCLUDE_INJA_UTILS_HPP_
+
+#include <algorithm>
+#include <fstream>
+#include <string>
+#include <utility>
+
+// #include "exceptions.hpp"
+#ifndef INCLUDE_INJA_EXCEPTIONS_HPP_
+#define INCLUDE_INJA_EXCEPTIONS_HPP_
+
+#include <stdexcept>
+#include <string>
+
+namespace inja {
+
+struct SourceLocation {
+  size_t line;
+  size_t column;
+};
+
+struct InjaError : public std::runtime_error {
+  const std::string type;
+  const std::string message;
+
+  const SourceLocation location;
+
+  explicit InjaError(const std::string &type, const std::string &message)
+      : std::runtime_error("[inja.exception." + type + "] " + message), type(type), message(message), location({0, 0}) {}
+
+  explicit InjaError(const std::string &type, const std::string &message, SourceLocation location)
+      : std::runtime_error("[inja.exception." + type + "] (at " + std::to_string(location.line) + ":" +
+                           std::to_string(location.column) + ") " + message),
+        type(type), message(message), location(location) {}
+};
+
+struct ParserError : public InjaError {
+  explicit ParserError(const std::string &message, SourceLocation location) : InjaError("parser_error", message, location) {}
+};
+
+struct RenderError : public InjaError {
+  explicit RenderError(const std::string &message, SourceLocation location) : InjaError("render_error", message, location) {}
+};
+
+struct FileError : public InjaError {
+  explicit FileError(const std::string &message) : InjaError("file_error", message) {}
+  explicit FileError(const std::string &message, SourceLocation location) : InjaError("file_error", message, location) {}
+};
+
+struct JsonError : public InjaError {
+  explicit JsonError(const std::string &message, SourceLocation location) : InjaError("json_error", message, location) {}
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_EXCEPTIONS_HPP_
+
+// #include "string_view.hpp"
+
+
+namespace inja {
+
+namespace string_view {
+inline nonstd::string_view slice(nonstd::string_view view, size_t start, size_t end) {
+  start = std::min(start, view.size());
+  end = std::min(std::max(start, end), view.size());
+  return view.substr(start, end - start);
+}
+
+inline std::pair<nonstd::string_view, nonstd::string_view> split(nonstd::string_view view, char Separator) {
+  size_t idx = view.find(Separator);
+  if (idx == nonstd::string_view::npos) {
+    return std::make_pair(view, nonstd::string_view());
+  }
+  return std::make_pair(slice(view, 0, idx), slice(view, idx + 1, nonstd::string_view::npos));
+}
+
+inline bool starts_with(nonstd::string_view view, nonstd::string_view prefix) {
+  return (view.size() >= prefix.size() && view.compare(0, prefix.size(), prefix) == 0);
+}
+} // namespace string_view
+
+inline SourceLocation get_source_location(nonstd::string_view content, size_t pos) {
+  // Get line and offset position (starts at 1:1)
+  auto sliced = string_view::slice(content, 0, pos);
+  std::size_t last_newline = sliced.rfind("\n");
+
+  if (last_newline == nonstd::string_view::npos) {
+    return {1, sliced.length() + 1};
+  }
+
+  // Count newlines
+  size_t count_lines = 0;
+  size_t search_start = 0;
+  while (search_start <= sliced.size()) {
+    search_start = sliced.find("\n", search_start) + 1;
+    if (search_start == 0) {
+      break;
+    }
+    count_lines += 1;
+  }
+
+  return {count_lines + 1, sliced.length() - last_newline};
+}
+
+inline void replace_substring(std::string& s, const std::string& f,
+                              const std::string& t)
+{
+  if (f.empty()) return;
+  for (auto pos = s.find(f);                  // find first occurrence of f
+            pos != std::string::npos;         // make sure f was found
+            s.replace(pos, f.size(), t),      // replace with t, and
+            pos = s.find(f, pos + t.size()))  // find next occurrence of f
+  {}
+}
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_UTILS_HPP_
+
+
+
+namespace inja {
+
+class NodeVisitor;
+class BlockNode;
+class TextNode;
+class ExpressionNode;
+class LiteralNode;
+class JsonNode;
+class FunctionNode;
+class ExpressionListNode;
+class StatementNode;
+class ForStatementNode;
+class ForArrayStatementNode;
+class ForObjectStatementNode;
+class IfStatementNode;
+class IncludeStatementNode;
+class ExtendsStatementNode;
+class BlockStatementNode;
+class SetStatementNode;
+
+
+class NodeVisitor {
+public:
+  virtual ~NodeVisitor() = default;
+
+  virtual void visit(const BlockNode& node) = 0;
+  virtual void visit(const TextNode& node) = 0;
+  virtual void visit(const ExpressionNode& node) = 0;
+  virtual void visit(const LiteralNode& node) = 0;
+  virtual void visit(const JsonNode& node) = 0;
+  virtual void visit(const FunctionNode& node) = 0;
+  virtual void visit(const ExpressionListNode& node) = 0;
+  virtual void visit(const StatementNode& node) = 0;
+  virtual void visit(const ForStatementNode& node) = 0;
+  virtual void visit(const ForArrayStatementNode& node) = 0;
+  virtual void visit(const ForObjectStatementNode& node) = 0;
+  virtual void visit(const IfStatementNode& node) = 0;
+  virtual void visit(const IncludeStatementNode& node) = 0;
+  virtual void visit(const ExtendsStatementNode& node) = 0;
+  virtual void visit(const BlockStatementNode& node) = 0;
+  virtual void visit(const SetStatementNode& node) = 0;
+};
+
+/*!
+ * \brief Base node class for the abstract syntax tree (AST).
+ */
+class AstNode {
+public:
+  virtual void accept(NodeVisitor& v) const = 0;
+
+  size_t pos;
+
+  AstNode(size_t pos) : pos(pos) { }
+  virtual ~AstNode() { }
+};
+
+
+class BlockNode : public AstNode {
+public:
+  std::vector<std::shared_ptr<AstNode>> nodes;
+
+  explicit BlockNode() : AstNode(0) {}
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class TextNode : public AstNode {
+public:
+  const size_t length;
+
+  explicit TextNode(size_t pos, size_t length): AstNode(pos), length(length) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class ExpressionNode : public AstNode {
+public:
+  explicit ExpressionNode(size_t pos) : AstNode(pos) {}
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class LiteralNode : public ExpressionNode {
+public:
+  const json value;
+
+  explicit LiteralNode(const json& value, size_t pos) : ExpressionNode(pos), value(value) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class JsonNode : public ExpressionNode {
+public:
+  const std::string name;
+  const json::json_pointer ptr;
+
+  static std::string convert_dot_to_json_ptr(nonstd::string_view ptr_name) {
+    std::string result;
+    do {
+      nonstd::string_view part;
+      std::tie(part, ptr_name) = string_view::split(ptr_name, '.');
+      result.push_back('/');
+      result.append(part.begin(), part.end());
+    } while (!ptr_name.empty());
+    return result;
+  }
+
+  explicit JsonNode(nonstd::string_view ptr_name, size_t pos) : ExpressionNode(pos), name(ptr_name), ptr(json::json_pointer(convert_dot_to_json_ptr(ptr_name))) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class FunctionNode : public ExpressionNode {
+  using Op = FunctionStorage::Operation;
+
+public:
+  enum class Associativity {
+    Left,
+    Right,
+  };
+
+  unsigned int precedence;
+  Associativity associativity;
+
+  Op operation;
+
+  std::string name;
+  int number_args; // Should also be negative -> -1 for unknown number
+  std::vector<std::shared_ptr<ExpressionNode>> arguments;
+  CallbackFunction callback;
+
+  explicit FunctionNode(nonstd::string_view name, size_t pos) : ExpressionNode(pos), precedence(8), associativity(Associativity::Left), operation(Op::Callback), name(name), number_args(1) { }
+  explicit FunctionNode(Op operation, size_t pos) : ExpressionNode(pos), operation(operation), number_args(1) {
+    switch (operation) {
+      case Op::Not: {
+        number_args = 1;
+        precedence = 4;
+        associativity = Associativity::Left;
+      } break;
+      case Op::And: {
+        number_args = 2;
+        precedence = 1;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Or: {
+        number_args = 2;
+        precedence = 1;
+        associativity = Associativity::Left;
+      } break;
+      case Op::In: {
+        number_args = 2;
+        precedence = 2;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Equal: {
+        number_args = 2;
+        precedence = 2;
+        associativity = Associativity::Left;
+      } break;
+      case Op::NotEqual: {
+        number_args = 2;
+        precedence = 2;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Greater: {
+        number_args = 2;
+        precedence = 2;
+        associativity = Associativity::Left;
+      } break;
+      case Op::GreaterEqual: {
+        number_args = 2;
+        precedence = 2;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Less: {
+        number_args = 2;
+        precedence = 2;
+        associativity = Associativity::Left;
+      } break;
+      case Op::LessEqual: {
+        number_args = 2;
+        precedence = 2;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Add: {
+        number_args = 2;
+        precedence = 3;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Subtract: {
+        number_args = 2;
+        precedence = 3;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Multiplication: {
+        number_args = 2;
+        precedence = 4;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Division: {
+        number_args = 2;
+        precedence = 4;
+        associativity = Associativity::Left;
+      } break;
+      case Op::Power: {
+        number_args = 2;
+        precedence = 5;
+        associativity = Associativity::Right;
+      } break;
+      case Op::Modulo: {
+        number_args = 2;
+        precedence = 4;
+        associativity = Associativity::Left;
+      } break;
+      case Op::AtId: {
+        number_args = 2;
+        precedence = 8;
+        associativity = Associativity::Left;
+      } break;
+      default: {
+        precedence = 1;
+        associativity = Associativity::Left;
+      }
+    }
+  }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class ExpressionListNode : public AstNode {
+public:
+  std::shared_ptr<ExpressionNode> root;
+
+  explicit ExpressionListNode() : AstNode(0) { }
+  explicit ExpressionListNode(size_t pos) : AstNode(pos) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class StatementNode : public AstNode {
+public:
+  StatementNode(size_t pos) : AstNode(pos) { }
+
+  virtual void accept(NodeVisitor& v) const = 0;
+};
+
+class ForStatementNode : public StatementNode {
+public:
+  ExpressionListNode condition;
+  BlockNode body;
+  BlockNode *const parent;
+
+  ForStatementNode(BlockNode *const parent, size_t pos) : StatementNode(pos), parent(parent) { }
+
+  virtual void accept(NodeVisitor& v) const = 0;
+};
+
+class ForArrayStatementNode : public ForStatementNode {
+public:
+  const std::string value;
+
+  explicit ForArrayStatementNode(const std::string& value, BlockNode *const parent, size_t pos) : ForStatementNode(parent, pos), value(value) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class ForObjectStatementNode : public ForStatementNode {
+public:
+  const std::string key;
+  const std::string value;
+
+  explicit ForObjectStatementNode(const std::string& key, const std::string& value, BlockNode *const parent, size_t pos) : ForStatementNode(parent, pos), key(key), value(value) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class IfStatementNode : public StatementNode {
+public:
+  ExpressionListNode condition;
+  BlockNode true_statement;
+  BlockNode false_statement;
+  BlockNode *const parent;
+
+  const bool is_nested;
+  bool has_false_statement {false};
+
+  explicit IfStatementNode(BlockNode *const parent, size_t pos) : StatementNode(pos), parent(parent), is_nested(false) { }
+  explicit IfStatementNode(bool is_nested, BlockNode *const parent, size_t pos) : StatementNode(pos), parent(parent), is_nested(is_nested) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class IncludeStatementNode : public StatementNode {
+public:
+  const std::string file;
+
+  explicit IncludeStatementNode(const std::string& file, size_t pos) : StatementNode(pos), file(file) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+class ExtendsStatementNode : public StatementNode {
+public:
+  const std::string file;
+
+  explicit ExtendsStatementNode(const std::string& file, size_t pos) : StatementNode(pos), file(file) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  };
+};
+
+class BlockStatementNode : public StatementNode {
+public:
+  const std::string name;
+  BlockNode block;
+  BlockNode *const parent;
+
+  explicit BlockStatementNode(BlockNode *const parent, const std::string& name, size_t pos) : StatementNode(pos), name(name), parent(parent) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  };
+};
+
+class SetStatementNode : public StatementNode {
+public:
+  const std::string key;
+  ExpressionListNode expression;
+
+  explicit SetStatementNode(const std::string& key, size_t pos) : StatementNode(pos), key(key) { }
+
+  void accept(NodeVisitor& v) const {
+    v.visit(*this);
+  }
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_NODE_HPP_
+
+// #include "statistics.hpp"
+#ifndef INCLUDE_INJA_STATISTICS_HPP_
+#define INCLUDE_INJA_STATISTICS_HPP_
+
+// #include "node.hpp"
+
+
+
+namespace inja {
+
+/*!
+ * \brief A class for counting statistics on a Template.
+ */
+class StatisticsVisitor : public NodeVisitor {
+  void visit(const BlockNode& node) {
+    for (auto& n : node.nodes) {
+      n->accept(*this);
+    }
+  }
+
+  void visit(const TextNode&) { }
+  void visit(const ExpressionNode&) { }
+  void visit(const LiteralNode&) { }
+
+  void visit(const JsonNode&) {
+    variable_counter += 1;
+  }
+
+  void visit(const FunctionNode& node) {
+    for (auto& n : node.arguments) {
+      n->accept(*this);
+    }
+  }
+
+  void visit(const ExpressionListNode& node) {
+    node.root->accept(*this);
+  }
+
+  void visit(const StatementNode&) { }
+  void visit(const ForStatementNode&) { }
+
+  void visit(const ForArrayStatementNode& node) {
+    node.condition.accept(*this);
+    node.body.accept(*this);
+  }
+
+  void visit(const ForObjectStatementNode& node) {
+    node.condition.accept(*this);
+    node.body.accept(*this);
+  }
+
+  void visit(const IfStatementNode& node) {
+    node.condition.accept(*this);
+    node.true_statement.accept(*this);
+    node.false_statement.accept(*this);
+  }
+
+  void visit(const IncludeStatementNode&) { }
+
+  void visit(const ExtendsStatementNode&) { }
+
+  void visit(const BlockStatementNode& node) {
+    node.block.accept(*this);
+  }
+
+  void visit(const SetStatementNode&) { }
+
+public:
+  unsigned int variable_counter;
+
+  explicit StatisticsVisitor() : variable_counter(0) { }
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_STATISTICS_HPP_
+
+
+
+namespace inja {
+
+/*!
+ * \brief The main inja Template.
+ */
+struct Template {
+  BlockNode root;
+  std::string content;
+  std::map<std::string, std::shared_ptr<BlockStatementNode>> block_storage;
+
+  explicit Template() { }
+  explicit Template(const std::string& content): content(content) { }
+
+  /// Return number of variables (total number, not distinct ones) in the template
+  int count_variables() {
+    auto statistic_visitor = StatisticsVisitor();
+    root.accept(statistic_visitor);
+    return statistic_visitor.variable_counter;
+  }
+};
+
+using TemplateStorage = std::map<std::string, Template>;
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_TEMPLATE_HPP_
+
+
+namespace inja {
+
+/*!
+ * \brief Class for lexer configuration.
+ */
+struct LexerConfig {
+  std::string statement_open {"{%"};
+  std::string statement_open_no_lstrip {"{%+"};
+  std::string statement_open_force_lstrip {"{%-"};
+  std::string statement_close {"%}"};
+  std::string statement_close_force_rstrip {"-%}"};
+  std::string line_statement {"##"};
+  std::string expression_open {"{{"};
+  std::string expression_open_force_lstrip {"{{-"};
+  std::string expression_close {"}}"};
+  std::string expression_close_force_rstrip {"-}}"};
+  std::string comment_open {"{#"};
+  std::string comment_open_force_lstrip {"{#-"};
+  std::string comment_close {"#}"};
+  std::string comment_close_force_rstrip {"-#}"};
+  std::string open_chars {"#{"};
+
+  bool trim_blocks {false};
+  bool lstrip_blocks {false};
+
+  void update_open_chars() {
+    open_chars = "";
+    if (open_chars.find(line_statement[0]) == std::string::npos) {
+      open_chars += line_statement[0];
+    }
+    if (open_chars.find(statement_open[0]) == std::string::npos) {
+      open_chars += statement_open[0];
+    }
+    if (open_chars.find(statement_open_no_lstrip[0]) == std::string::npos) {
+      open_chars += statement_open_no_lstrip[0];
+    }
+    if (open_chars.find(statement_open_force_lstrip[0]) == std::string::npos) {
+      open_chars += statement_open_force_lstrip[0];
+    }
+    if (open_chars.find(expression_open[0]) == std::string::npos) {
+      open_chars += expression_open[0];
+    }
+    if (open_chars.find(expression_open_force_lstrip[0]) == std::string::npos) {
+      open_chars += expression_open_force_lstrip[0];
+    }
+    if (open_chars.find(comment_open[0]) == std::string::npos) {
+      open_chars += comment_open[0];
+    }
+    if (open_chars.find(comment_open_force_lstrip[0]) == std::string::npos) {
+      open_chars += comment_open_force_lstrip[0];
+    }
+  }
+};
+
+/*!
+ * \brief Class for parser configuration.
+ */
+struct ParserConfig {
+  bool search_included_templates_in_files {true};
+
+  std::function<Template(const std::string&, const std::string&)> include_callback;
+};
+
+/*!
+ * \brief Class for render configuration.
+ */
+struct RenderConfig {
+  bool throw_at_missing_includes {true};
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_CONFIG_HPP_
+
+// #include "function_storage.hpp"
+
+// #include "parser.hpp"
+#ifndef INCLUDE_INJA_PARSER_HPP_
+#define INCLUDE_INJA_PARSER_HPP_
+
+#include <limits>
+#include <stack>
+#include <string>
+#include <utility>
+#include <queue>
+#include <vector>
+
+// #include "config.hpp"
+
+// #include "exceptions.hpp"
+
+// #include "function_storage.hpp"
+
+// #include "lexer.hpp"
+#ifndef INCLUDE_INJA_LEXER_HPP_
+#define INCLUDE_INJA_LEXER_HPP_
+
+#include <cctype>
+#include <locale>
+
+// #include "config.hpp"
+
+// #include "token.hpp"
+#ifndef INCLUDE_INJA_TOKEN_HPP_
+#define INCLUDE_INJA_TOKEN_HPP_
+
+#include <string>
+
+// #include "string_view.hpp"
+
+
+namespace inja {
+
+/*!
+ * \brief Helper-class for the inja Lexer.
+ */
+struct Token {
+  enum class Kind {
+    Text,
+    ExpressionOpen,     // {{
+    ExpressionClose,    // }}
+    LineStatementOpen,  // ##
+    LineStatementClose, // \n
+    StatementOpen,      // {%
+    StatementClose,     // %}
+    CommentOpen,        // {#
+    CommentClose,       // #}
+    Id,                 // this, this.foo
+    Number,             // 1, 2, -1, 5.2, -5.3
+    String,             // "this"
+    Plus,               // +
+    Minus,              // -
+    Times,              // *
+    Slash,              // /
+    Percent,            // %
+    Power,              // ^
+    Comma,              // ,
+    Dot,                // .
+    Colon,              // :
+    LeftParen,          // (
+    RightParen,         // )
+    LeftBracket,        // [
+    RightBracket,       // ]
+    LeftBrace,          // {
+    RightBrace,         // }
+    Equal,              // ==
+    NotEqual,           // !=
+    GreaterThan,        // >
+    GreaterEqual,       // >=
+    LessThan,           // <
+    LessEqual,          // <=
+    Unknown,
+    Eof,
+  };
+  
+  Kind kind {Kind::Unknown};
+  nonstd::string_view text;
+
+  explicit constexpr Token() = default;
+  explicit constexpr Token(Kind kind, nonstd::string_view text) : kind(kind), text(text) {}
+
+  std::string describe() const {
+    switch (kind) {
+    case Kind::Text:
+      return "<text>";
+    case Kind::LineStatementClose:
+      return "<eol>";
+    case Kind::Eof:
+      return "<eof>";
+    default:
+      return static_cast<std::string>(text);
+    }
+  }
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_TOKEN_HPP_
+
+// #include "utils.hpp"
+
+
+namespace inja {
+
+/*!
+ * \brief Class for lexing an inja Template.
+ */
+class Lexer {
+  enum class State {
+    Text,
+    ExpressionStart,
+    ExpressionStartForceLstrip,
+    ExpressionBody,
+    LineStart,
+    LineBody,
+    StatementStart,
+    StatementStartNoLstrip,
+    StatementStartForceLstrip,
+    StatementBody,
+    CommentStart,
+    CommentStartForceLstrip,
+    CommentBody,
+  };
+
+  enum class MinusState {
+    Operator,
+    Number,
+  };
+
+  const LexerConfig &config;
+
+  State state;
+  MinusState minus_state;
+  nonstd::string_view m_in;
+  size_t tok_start;
+  size_t pos;
+
+
+  Token scan_body(nonstd::string_view close, Token::Kind closeKind, nonstd::string_view close_trim = nonstd::string_view(), bool trim = false) {
+  again:
+    // skip whitespace (except for \n as it might be a close)
+    if (tok_start >= m_in.size()) {
+      return make_token(Token::Kind::Eof);
+    }
+    const char ch = m_in[tok_start];
+    if (ch == ' ' || ch == '\t' || ch == '\r') {
+      tok_start += 1;
+      goto again;
+    }
+
+    // check for close
+    if (!close_trim.empty() && inja::string_view::starts_with(m_in.substr(tok_start), close_trim)) {
+      state = State::Text;
+      pos = tok_start + close_trim.size();
+      const Token tok = make_token(closeKind);
+      skip_whitespaces_and_newlines();
+      return tok;
+    }
+
+    if (inja::string_view::starts_with(m_in.substr(tok_start), close)) {
+      state = State::Text;
+      pos = tok_start + close.size();
+      const Token tok = make_token(closeKind);
+      if (trim) {
+        skip_whitespaces_and_first_newline();
+      }
+      return tok;
+    }
+
+    // skip \n
+    if (ch == '\n') {
+      tok_start += 1;
+      goto again;
+    }
+
+    pos = tok_start + 1;
+    if (std::isalpha(ch)) {
+      minus_state = MinusState::Operator;
+      return scan_id();
+    }
+
+    const MinusState current_minus_state = minus_state;
+    if (minus_state == MinusState::Operator) {
+      minus_state = MinusState::Number;
+    }
+
+    switch (ch) {
+    case '+':
+      return make_token(Token::Kind::Plus);
+    case '-':
+      if (current_minus_state == MinusState::Operator) {
+        return make_token(Token::Kind::Minus);
+      }
+      return scan_number();
+    case '*':
+      return make_token(Token::Kind::Times);
+    case '/':
+      return make_token(Token::Kind::Slash);
+    case '^':
+      return make_token(Token::Kind::Power);
+    case '%':
+      return make_token(Token::Kind::Percent);
+    case '.':
+      return make_token(Token::Kind::Dot);
+    case ',':
+      return make_token(Token::Kind::Comma);
+    case ':':
+      return make_token(Token::Kind::Colon);
+    case '(':
+      return make_token(Token::Kind::LeftParen);
+    case ')':
+      minus_state = MinusState::Operator;
+      return make_token(Token::Kind::RightParen);
+    case '[':
+      return make_token(Token::Kind::LeftBracket);
+    case ']':
+      minus_state = MinusState::Operator;
+      return make_token(Token::Kind::RightBracket);
+    case '{':
+      return make_token(Token::Kind::LeftBrace);
+    case '}':
+      minus_state = MinusState::Operator;
+      return make_token(Token::Kind::RightBrace);
+    case '>':
+      if (pos < m_in.size() && m_in[pos] == '=') {
+        pos += 1;
+        return make_token(Token::Kind::GreaterEqual);
+      }
+      return make_token(Token::Kind::GreaterThan);
+    case '<':
+      if (pos < m_in.size() && m_in[pos] == '=') {
+        pos += 1;
+        return make_token(Token::Kind::LessEqual);
+      }
+      return make_token(Token::Kind::LessThan);
+    case '=':
+      if (pos < m_in.size() && m_in[pos] == '=') {
+        pos += 1;
+        return make_token(Token::Kind::Equal);
+      }
+      return make_token(Token::Kind::Unknown);
+    case '!':
+      if (pos < m_in.size() && m_in[pos] == '=') {
+        pos += 1;
+        return make_token(Token::Kind::NotEqual);
+      }
+      return make_token(Token::Kind::Unknown);
+    case '\"':
+      return scan_string();
+    case '0':
+    case '1':
+    case '2':
+    case '3':
+    case '4':
+    case '5':
+    case '6':
+    case '7':
+    case '8':
+    case '9':
+      minus_state = MinusState::Operator;
+      return scan_number();
+    case '_':
+    case '@':
+    case '$':
+      minus_state = MinusState::Operator;
+      return scan_id();
+    default:
+      return make_token(Token::Kind::Unknown);
+    }
+  }
+
+  Token scan_id() {
+    for (;;) {
+      if (pos >= m_in.size()) {
+        break;
+      }
+      const char ch = m_in[pos];
+      if (!std::isalnum(ch) && ch != '.' && ch != '/' && ch != '_' && ch != '-') {
+        break;
+      }
+      pos += 1;
+    }
+    return make_token(Token::Kind::Id);
+  }
+
+  Token scan_number() {
+    for (;;) {
+      if (pos >= m_in.size()) {
+        break;
+      }
+      const char ch = m_in[pos];
+      // be very permissive in lexer (we'll catch errors when conversion happens)
+      if (!std::isdigit(ch) && ch != '.' && ch != 'e' && ch != 'E' && ch != '+' && ch != '-') {
+        break;
+      }
+      pos += 1;
+    }
+    return make_token(Token::Kind::Number);
+  }
+
+  Token scan_string() {
+    bool escape {false};
+    for (;;) {
+      if (pos >= m_in.size()) {
+        break;
+      }
+      const char ch = m_in[pos++];
+      if (ch == '\\') {
+        escape = true;
+      } else if (!escape && ch == m_in[tok_start]) {
+        break;
+      } else {
+        escape = false;
+      }
+    }
+    return make_token(Token::Kind::String);
+  }
+
+  Token make_token(Token::Kind kind) const { return Token(kind, string_view::slice(m_in, tok_start, pos)); }
+
+  void skip_whitespaces_and_newlines() {
+    if (pos < m_in.size()) {
+      while (pos < m_in.size() && (m_in[pos] == ' ' || m_in[pos] == '\t' || m_in[pos] == '\n' || m_in[pos] == '\r')) {
+        pos += 1;
+      }
+    }
+  }
+
+  void skip_whitespaces_and_first_newline() {
+    if (pos < m_in.size()) {
+      while (pos < m_in.size() && (m_in[pos] == ' ' || m_in[pos] == '\t')) {
+        pos += 1;
+      }
+    }
+
+    if (pos < m_in.size()) {
+      const char ch = m_in[pos];
+      if (ch == '\n') {
+        pos += 1;
+      } else if (ch == '\r') {
+        pos += 1;
+        if (pos < m_in.size() && m_in[pos] == '\n') {
+          pos += 1;
+        }
+      }
+    }
+  }
+
+  static nonstd::string_view clear_final_line_if_whitespace(nonstd::string_view text) {
+    nonstd::string_view result = text;
+    while (!result.empty()) {
+      const char ch = result.back();
+      if (ch == ' ' || ch == '\t') {
+        result.remove_suffix(1);
+      } else if (ch == '\n' || ch == '\r') {
+        break;
+      } else {
+        return text;
+      }
+    }
+    return result;
+  }
+
+public:
+  explicit Lexer(const LexerConfig &config) : config(config), state(State::Text), minus_state(MinusState::Number) {}
+
+  SourceLocation current_position() const {
+    return get_source_location(m_in, tok_start);
+  }
+
+  void start(nonstd::string_view input) {
+    m_in = input;
+    tok_start = 0;
+    pos = 0;
+    state = State::Text;
+    minus_state = MinusState::Number;
+
+    // Consume byte order mark (BOM) for UTF-8
+    if (inja::string_view::starts_with(m_in, "\xEF\xBB\xBF")) {
+      m_in = m_in.substr(3);
+    }
+  }
+
+  Token scan() {
+    tok_start = pos;
+
+  again:
+    if (tok_start >= m_in.size()) {
+      return make_token(Token::Kind::Eof);
+    }
+
+    switch (state) {
+    default:
+    case State::Text: {
+      // fast-scan to first open character
+      const size_t open_start = m_in.substr(pos).find_first_of(config.open_chars);
+      if (open_start == nonstd::string_view::npos) {
+        // didn't find open, return remaining text as text token
+        pos = m_in.size();
+        return make_token(Token::Kind::Text);
+      }
+      pos += open_start;
+
+      // try to match one of the opening sequences, and get the close
+      nonstd::string_view open_str = m_in.substr(pos);
+      bool must_lstrip = false;
+      if (inja::string_view::starts_with(open_str, config.expression_open)) {
+        if (inja::string_view::starts_with(open_str, config.expression_open_force_lstrip)) {
+          state = State::ExpressionStartForceLstrip;
+          must_lstrip = true;
+        } else {
+          state = State::ExpressionStart;
+        }
+      } else if (inja::string_view::starts_with(open_str, config.statement_open)) {
+        if (inja::string_view::starts_with(open_str, config.statement_open_no_lstrip)) {
+          state = State::StatementStartNoLstrip;
+        } else if (inja::string_view::starts_with(open_str, config.statement_open_force_lstrip )) {
+          state = State::StatementStartForceLstrip;
+          must_lstrip = true;
+        } else {
+          state = State::StatementStart;
+          must_lstrip = config.lstrip_blocks;
+        }
+      } else if (inja::string_view::starts_with(open_str, config.comment_open)) {
+        if (inja::string_view::starts_with(open_str, config.comment_open_force_lstrip)) {
+          state = State::CommentStartForceLstrip;
+          must_lstrip = true;
+        } else {
+          state = State::CommentStart;
+          must_lstrip = config.lstrip_blocks;
+        }
+      } else if ((pos == 0 || m_in[pos - 1] == '\n') && inja::string_view::starts_with(open_str, config.line_statement)) {
+        state = State::LineStart;
+      } else {
+        pos += 1; // wasn't actually an opening sequence
+        goto again;
+      }
+
+      nonstd::string_view text = string_view::slice(m_in, tok_start, pos);
+      if (must_lstrip) {
+        text = clear_final_line_if_whitespace(text);
+      }
+
+      if (text.empty()) {
+        goto again; // don't generate empty token
+      }
+      return Token(Token::Kind::Text, text);
+    }
+    case State::ExpressionStart: {
+      state = State::ExpressionBody;
+      pos += config.expression_open.size();
+      return make_token(Token::Kind::ExpressionOpen);
+    }
+    case State::ExpressionStartForceLstrip: {
+      state = State::ExpressionBody;
+      pos += config.expression_open_force_lstrip.size();
+      return make_token(Token::Kind::ExpressionOpen);
+    }
+    case State::LineStart: {
+      state = State::LineBody;
+      pos += config.line_statement.size();
+      return make_token(Token::Kind::LineStatementOpen);
+    }
+    case State::StatementStart: {
+      state = State::StatementBody;
+      pos += config.statement_open.size();
+      return make_token(Token::Kind::StatementOpen);
+    }
+    case State::StatementStartNoLstrip: {
+      state = State::StatementBody;
+      pos += config.statement_open_no_lstrip.size();
+      return make_token(Token::Kind::StatementOpen);
+    }
+    case State::StatementStartForceLstrip: {
+      state = State::StatementBody;
+      pos += config.statement_open_force_lstrip.size();
+      return make_token(Token::Kind::StatementOpen);
+    }
+    case State::CommentStart: {
+      state = State::CommentBody;
+      pos += config.comment_open.size();
+      return make_token(Token::Kind::CommentOpen);
+    }
+    case State::CommentStartForceLstrip: {
+      state = State::CommentBody;
+      pos += config.comment_open_force_lstrip.size();
+      return make_token(Token::Kind::CommentOpen);
+    }
+    case State::ExpressionBody:
+      return scan_body(config.expression_close, Token::Kind::ExpressionClose, config.expression_close_force_rstrip);
+    case State::LineBody:
+      return scan_body("\n", Token::Kind::LineStatementClose);
+    case State::StatementBody:
+      return scan_body(config.statement_close, Token::Kind::StatementClose, config.statement_close_force_rstrip, config.trim_blocks);
+    case State::CommentBody: {
+      // fast-scan to comment close
+      const size_t end = m_in.substr(pos).find(config.comment_close);
+      if (end == nonstd::string_view::npos) {
+        pos = m_in.size();
+        return make_token(Token::Kind::Eof);
+      }
+
+      // Check for trim pattern
+      const bool must_rstrip = inja::string_view::starts_with(m_in.substr(pos + end - 1), config.comment_close_force_rstrip);
+
+      // return the entire comment in the close token
+      state = State::Text;
+      pos += end + config.comment_close.size();
+      Token tok = make_token(Token::Kind::CommentClose);
+
+      if (must_rstrip || config.trim_blocks) {
+        skip_whitespaces_and_first_newline();
+      }
+      return tok;
+    }
+    }
+  }
+
+  const LexerConfig &get_config() const {
+    return config;
+  }
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_LEXER_HPP_
+
+// #include "node.hpp"
+
+// #include "template.hpp"
+
+// #include "token.hpp"
+
+// #include "utils.hpp"
+
+
+
+namespace inja {
+
+/*!
+ * \brief Class for parsing an inja Template.
+ */
+class Parser {
+  const ParserConfig &config;
+
+  Lexer lexer;
+  TemplateStorage &template_storage;
+  const FunctionStorage &function_storage;
+
+  Token tok, peek_tok;
+  bool have_peek_tok {false};
+
+  size_t current_paren_level {0};
+  size_t current_bracket_level {0};
+  size_t current_brace_level {0};
+
+  nonstd::string_view json_literal_start;
+
+  BlockNode *current_block {nullptr};
+  ExpressionListNode *current_expression_list {nullptr};
+  std::stack<std::pair<FunctionNode*, size_t>> function_stack;
+  std::vector<std::shared_ptr<ExpressionNode>> arguments;
+
+  std::stack<std::shared_ptr<FunctionNode>> operator_stack;
+  std::stack<IfStatementNode*> if_statement_stack;
+  std::stack<ForStatementNode*> for_statement_stack;
+  std::stack<BlockStatementNode*> block_statement_stack;
+
+  inline void throw_parser_error(const std::string &message) {
+    INJA_THROW(ParserError(message, lexer.current_position()));
+  }
+
+  inline void get_next_token() {
+    if (have_peek_tok) {
+      tok = peek_tok;
+      have_peek_tok = false;
+    } else {
+      tok = lexer.scan();
+    }
+  }
+
+  inline void get_peek_token() {
+    if (!have_peek_tok) {
+      peek_tok = lexer.scan();
+      have_peek_tok = true;
+    }
+  }
+
+  inline void add_json_literal(const char* content_ptr) {
+    nonstd::string_view json_text(json_literal_start.data(), tok.text.data() - json_literal_start.data() + tok.text.size());
+    arguments.emplace_back(std::make_shared<LiteralNode>(json::parse(json_text), json_text.data() - content_ptr));
+  }
+
+  inline void add_operator() {
+    auto function = operator_stack.top();
+    operator_stack.pop();
+
+    for (int i = 0; i < function->number_args; ++i) {
+      function->arguments.insert(function->arguments.begin(), arguments.back());
+      arguments.pop_back();
+    }
+    arguments.emplace_back(function);
+  }
+
+  void add_to_template_storage(nonstd::string_view path, std::string& template_name) {
+    if (template_storage.find(template_name) != template_storage.end()) {
+      return;
+    }
+
+    std::string original_path = static_cast<std::string>(path);
+    std::string original_name = template_name;
+
+    if (config.search_included_templates_in_files) {
+      // Build the relative path
+      template_name = original_path + original_name;
+      if (template_name.compare(0, 2, "./") == 0) {
+        template_name.erase(0, 2);
+      }
+
+      if (template_storage.find(template_name) == template_storage.end()) {
+        // Load file
+        std::ifstream file;
+        file.open(template_name);
+        if (!file.fail()) {
+          std::string text((std::istreambuf_iterator<char>(file)), std::istreambuf_iterator<char>());
+
+          auto include_template = Template(text);
+          template_storage.emplace(template_name, include_template);
+          parse_into_template(template_storage[template_name], template_name);
+          return;
+
+        } else if (!config.include_callback) {
+          INJA_THROW(FileError("failed accessing file at '" + template_name + "'"));
+        }
+      }
+    }
+
+    // Try include callback
+    if (config.include_callback) {
+      auto include_template = config.include_callback(original_path, original_name);
+      template_storage.emplace(template_name, include_template);
+    }
+  }
+
+  bool parse_expression(Template &tmpl, Token::Kind closing) {
+    while (tok.kind != closing && tok.kind != Token::Kind::Eof) {
+      // Literals
+      switch (tok.kind) {
+      case Token::Kind::String: {
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          json_literal_start = tok.text;
+          add_json_literal(tmpl.content.c_str());
+        }
+
+      } break;
+      case Token::Kind::Number: {
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          json_literal_start = tok.text;
+          add_json_literal(tmpl.content.c_str());
+        }
+
+      } break;
+      case Token::Kind::LeftBracket: {
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          json_literal_start = tok.text;
+        }
+        current_bracket_level += 1;
+
+      } break;
+      case Token::Kind::LeftBrace: {
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          json_literal_start = tok.text;
+        }
+        current_brace_level += 1;
+
+      } break;
+      case Token::Kind::RightBracket: {
+        if (current_bracket_level == 0) {
+          throw_parser_error("unexpected ']'");
+        }
+
+        current_bracket_level -= 1;
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          add_json_literal(tmpl.content.c_str());
+        }
+
+      } break;
+      case Token::Kind::RightBrace: {
+        if (current_brace_level == 0) {
+          throw_parser_error("unexpected '}'");
+        }
+
+        current_brace_level -= 1;
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          add_json_literal(tmpl.content.c_str());
+        }
+
+      } break;
+      case Token::Kind::Id: {
+        get_peek_token();
+
+        // Json Literal
+        if (tok.text == static_cast<decltype(tok.text)>("true") || tok.text == static_cast<decltype(tok.text)>("false") || tok.text == static_cast<decltype(tok.text)>("null")) {
+          if (current_brace_level == 0 && current_bracket_level == 0) {
+            json_literal_start = tok.text;
+            add_json_literal(tmpl.content.c_str());
+          }
+
+	      // Operator
+        } else if (tok.text == "and" || tok.text == "or" || tok.text == "in" || tok.text == "not") {
+          goto parse_operator;
+
+        // Functions
+        } else if (peek_tok.kind == Token::Kind::LeftParen) {
+          operator_stack.emplace(std::make_shared<FunctionNode>(static_cast<std::string>(tok.text), tok.text.data() - tmpl.content.c_str()));
+          function_stack.emplace(operator_stack.top().get(), current_paren_level);       
+
+        // Variables
+        } else {
+          arguments.emplace_back(std::make_shared<JsonNode>(static_cast<std::string>(tok.text), tok.text.data() - tmpl.content.c_str()));
+        }
+
+      // Operators
+      } break;
+      case Token::Kind::Equal:
+      case Token::Kind::NotEqual:
+      case Token::Kind::GreaterThan:
+      case Token::Kind::GreaterEqual:
+      case Token::Kind::LessThan:
+      case Token::Kind::LessEqual:
+      case Token::Kind::Plus:
+      case Token::Kind::Minus:
+      case Token::Kind::Times:
+      case Token::Kind::Slash:
+      case Token::Kind::Power:
+      case Token::Kind::Percent:
+      case Token::Kind::Dot: {
+
+  parse_operator:
+        FunctionStorage::Operation operation;
+        switch (tok.kind) {
+        case Token::Kind::Id: {
+          if (tok.text == "and") {
+            operation = FunctionStorage::Operation::And;
+          } else if (tok.text == "or") {
+            operation = FunctionStorage::Operation::Or;
+          } else if (tok.text == "in") {
+            operation = FunctionStorage::Operation::In;
+          } else if (tok.text == "not") {
+            operation = FunctionStorage::Operation::Not;
+          } else {
+            throw_parser_error("unknown operator in parser.");
+          }
+        } break;
+        case Token::Kind::Equal: {
+          operation = FunctionStorage::Operation::Equal;
+        } break;
+        case Token::Kind::NotEqual: {
+          operation = FunctionStorage::Operation::NotEqual;
+        } break;
+        case Token::Kind::GreaterThan: {
+          operation = FunctionStorage::Operation::Greater;
+        } break;
+        case Token::Kind::GreaterEqual: {
+          operation = FunctionStorage::Operation::GreaterEqual;
+        } break;
+        case Token::Kind::LessThan: {
+          operation = FunctionStorage::Operation::Less;
+        } break;
+        case Token::Kind::LessEqual: {
+          operation = FunctionStorage::Operation::LessEqual;
+        } break;
+        case Token::Kind::Plus: {
+          operation = FunctionStorage::Operation::Add;
+        } break;
+        case Token::Kind::Minus: {
+          operation = FunctionStorage::Operation::Subtract;
+        } break;
+        case Token::Kind::Times: {
+          operation = FunctionStorage::Operation::Multiplication;
+        } break;
+        case Token::Kind::Slash: {
+          operation = FunctionStorage::Operation::Division;
+        } break;
+        case Token::Kind::Power: {
+          operation = FunctionStorage::Operation::Power;
+        } break;
+        case Token::Kind::Percent: {
+          operation = FunctionStorage::Operation::Modulo;
+        } break;
+        case Token::Kind::Dot: {
+          operation = FunctionStorage::Operation::AtId;
+        } break;
+        default: {
+          throw_parser_error("unknown operator in parser.");
+        }
+        }
+        auto function_node = std::make_shared<FunctionNode>(operation, tok.text.data() - tmpl.content.c_str());
+
+        while (!operator_stack.empty() && ((operator_stack.top()->precedence > function_node->precedence) || (operator_stack.top()->precedence == function_node->precedence && function_node->associativity == FunctionNode::Associativity::Left)) && (operator_stack.top()->operation != FunctionStorage::Operation::ParenLeft)) {
+          add_operator();
+        }
+
+        operator_stack.emplace(function_node);
+
+      } break;
+      case Token::Kind::Comma: {
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          if (function_stack.empty()) {
+            throw_parser_error("unexpected ','");
+          }
+
+          function_stack.top().first->number_args += 1;
+        }
+
+      } break;
+      case Token::Kind::Colon: {
+        if (current_brace_level == 0 && current_bracket_level == 0) {
+          throw_parser_error("unexpected ':'");
+        }
+
+      } break;
+      case Token::Kind::LeftParen: {
+        current_paren_level += 1;
+        operator_stack.emplace(std::make_shared<FunctionNode>(FunctionStorage::Operation::ParenLeft, tok.text.data() - tmpl.content.c_str()));
+
+        get_peek_token();
+        if (peek_tok.kind == Token::Kind::RightParen) {
+          if (!function_stack.empty() && function_stack.top().second == current_paren_level - 1) {
+            function_stack.top().first->number_args = 0;
+          }
+        }
+
+      } break;
+      case Token::Kind::RightParen: {
+        current_paren_level -= 1;
+        while (!operator_stack.empty() && operator_stack.top()->operation != FunctionStorage::Operation::ParenLeft) {
+          add_operator();
+        }
+
+        if (!operator_stack.empty() && operator_stack.top()->operation == FunctionStorage::Operation::ParenLeft) {
+          operator_stack.pop();
+        }
+
+        if (!function_stack.empty() && function_stack.top().second == current_paren_level) {
+          auto func = function_stack.top().first;
+          auto function_data = function_storage.find_function(func->name, func->number_args);
+          if (function_data.operation == FunctionStorage::Operation::None) {
+            throw_parser_error("unknown function " + func->name);
+          }
+          func->operation = function_data.operation;
+          if (function_data.operation == FunctionStorage::Operation::Callback) {
+            func->callback = function_data.callback;
+          }
+
+          if (operator_stack.empty()) {
+            throw_parser_error("internal error at function " + func->name);
+          }
+
+          add_operator();
+          function_stack.pop();
+        }
+      }
+      default:
+        break;
+      }
+
+      get_next_token();
+    }
+
+    while (!operator_stack.empty()) {
+      add_operator();
+    }
+
+    if (arguments.size() == 1) {
+      current_expression_list->root = arguments[0];
+      arguments = {};
+
+    } else if (arguments.size() > 1) {
+      throw_parser_error("malformed expression");
+    }
+    
+    return true;
+  }
+
+  bool parse_statement(Template &tmpl, Token::Kind closing, nonstd::string_view path) {
+    if (tok.kind != Token::Kind::Id) {
+      return false;
+    }
+
+    if (tok.text == static_cast<decltype(tok.text)>("if")) {
+      get_next_token();
+
+      auto if_statement_node = std::make_shared<IfStatementNode>(current_block, tok.text.data() - tmpl.content.c_str());
+      current_block->nodes.emplace_back(if_statement_node);
+      if_statement_stack.emplace(if_statement_node.get());
+      current_block = &if_statement_node->true_statement;
+      current_expression_list = &if_statement_node->condition;
+
+      if (!parse_expression(tmpl, closing)) {
+        return false;
+      }
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("else")) {
+      if (if_statement_stack.empty()) {
+        throw_parser_error("else without matching if");
+      }
+      auto &if_statement_data = if_statement_stack.top();
+      get_next_token();
+
+      if_statement_data->has_false_statement = true;
+      current_block = &if_statement_data->false_statement;
+
+      // Chained else if
+      if (tok.kind == Token::Kind::Id && tok.text == static_cast<decltype(tok.text)>("if")) {
+        get_next_token();
+
+        auto if_statement_node = std::make_shared<IfStatementNode>(true, current_block, tok.text.data() - tmpl.content.c_str());
+        current_block->nodes.emplace_back(if_statement_node);
+        if_statement_stack.emplace(if_statement_node.get());
+        current_block = &if_statement_node->true_statement;
+        current_expression_list = &if_statement_node->condition;
+
+        if (!parse_expression(tmpl, closing)) {
+          return false;
+        }
+      }
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("endif")) {
+      if (if_statement_stack.empty()) {
+        throw_parser_error("endif without matching if");
+      }
+
+      // Nested if statements
+      while (if_statement_stack.top()->is_nested) {
+        if_statement_stack.pop();
+      }
+
+      auto &if_statement_data = if_statement_stack.top();
+      get_next_token();
+
+      current_block = if_statement_data->parent;
+      if_statement_stack.pop();
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("block")) {
+      get_next_token();
+
+      if (tok.kind != Token::Kind::Id) {
+        throw_parser_error("expected block name, got '" + tok.describe() + "'");
+      }
+
+      const std::string block_name = static_cast<std::string>(tok.text);
+
+      auto block_statement_node = std::make_shared<BlockStatementNode>(current_block, block_name, tok.text.data() - tmpl.content.c_str());
+      current_block->nodes.emplace_back(block_statement_node);
+      block_statement_stack.emplace(block_statement_node.get());
+      current_block = &block_statement_node->block;
+      auto success = tmpl.block_storage.emplace(block_name, block_statement_node);
+      if (!success.second) {
+        throw_parser_error("block with the name '" + block_name + "' does already exist");
+      }
+
+      get_next_token();
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("endblock")) {
+      if (block_statement_stack.empty()) {
+        throw_parser_error("endblock without matching block");
+      }
+
+      auto &block_statement_data = block_statement_stack.top();
+      get_next_token();
+
+      current_block = block_statement_data->parent;
+      block_statement_stack.pop();
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("for")) {
+      get_next_token();
+
+      // options: for a in arr; for a, b in obj
+      if (tok.kind != Token::Kind::Id) {
+        throw_parser_error("expected id, got '" + tok.describe() + "'");
+      }
+
+      Token value_token = tok;
+      get_next_token();
+
+      // Object type
+      std::shared_ptr<ForStatementNode> for_statement_node;
+      if (tok.kind == Token::Kind::Comma) {
+        get_next_token();
+        if (tok.kind != Token::Kind::Id) {
+          throw_parser_error("expected id, got '" + tok.describe() + "'");
+        }
+
+        Token key_token = std::move(value_token);
+        value_token = tok;
+        get_next_token();
+
+        for_statement_node = std::make_shared<ForObjectStatementNode>(static_cast<std::string>(key_token.text), static_cast<std::string>(value_token.text), current_block, tok.text.data() - tmpl.content.c_str());
+
+      // Array type
+      } else {
+        for_statement_node = std::make_shared<ForArrayStatementNode>(static_cast<std::string>(value_token.text), current_block, tok.text.data() - tmpl.content.c_str());
+      }
+
+      current_block->nodes.emplace_back(for_statement_node);
+      for_statement_stack.emplace(for_statement_node.get());
+      current_block = &for_statement_node->body;
+      current_expression_list = &for_statement_node->condition;
+
+      if (tok.kind != Token::Kind::Id || tok.text != static_cast<decltype(tok.text)>("in")) {
+        throw_parser_error("expected 'in', got '" + tok.describe() + "'");
+      }
+      get_next_token();
+
+      if (!parse_expression(tmpl, closing)) {
+        return false;
+      }
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("endfor")) {
+      if (for_statement_stack.empty()) {
+        throw_parser_error("endfor without matching for");
+      }
+
+      auto &for_statement_data = for_statement_stack.top();
+      get_next_token();
+
+      current_block = for_statement_data->parent;
+      for_statement_stack.pop();
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("include")) {
+      get_next_token();
+
+      if (tok.kind != Token::Kind::String) {
+        throw_parser_error("expected string, got '" + tok.describe() + "'");
+      }
+
+      std::string template_name = json::parse(tok.text).get_ref<const std::string &>();
+      add_to_template_storage(path, template_name);
+
+      current_block->nodes.emplace_back(std::make_shared<IncludeStatementNode>(template_name, tok.text.data() - tmpl.content.c_str()));
+
+      get_next_token();
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("extends")) {
+      get_next_token();
+
+      if (tok.kind != Token::Kind::String) {
+        throw_parser_error("expected string, got '" + tok.describe() + "'");
+      }
+
+      std::string template_name = json::parse(tok.text).get_ref<const std::string &>();
+      add_to_template_storage(path, template_name);
+
+      current_block->nodes.emplace_back(std::make_shared<ExtendsStatementNode>(template_name, tok.text.data() - tmpl.content.c_str()));
+
+      get_next_token();
+
+    } else if (tok.text == static_cast<decltype(tok.text)>("set")) {
+      get_next_token();
+
+      if (tok.kind != Token::Kind::Id) {
+        throw_parser_error("expected variable name, got '" + tok.describe() + "'");
+      }
+
+      std::string key = static_cast<std::string>(tok.text);
+      get_next_token();
+
+      auto set_statement_node = std::make_shared<SetStatementNode>(key, tok.text.data() - tmpl.content.c_str());
+      current_block->nodes.emplace_back(set_statement_node);
+      current_expression_list = &set_statement_node->expression;
+
+      if (tok.text != static_cast<decltype(tok.text)>("=")) {
+        throw_parser_error("expected '=', got '" + tok.describe() + "'");
+      }
+      get_next_token();
+
+      if (!parse_expression(tmpl, closing)) {
+        return false;
+      }
+
+    } else {
+      return false;
+    }
+    return true;
+  }
+
+  void parse_into(Template &tmpl, nonstd::string_view path) {
+    lexer.start(tmpl.content);
+    current_block = &tmpl.root;
+
+    for (;;) {
+      get_next_token();
+      switch (tok.kind) {
+      case Token::Kind::Eof: {
+        if (!if_statement_stack.empty()) {
+          throw_parser_error("unmatched if");
+        }
+        if (!for_statement_stack.empty()) {
+          throw_parser_error("unmatched for");
+        }
+      } return;
+      case Token::Kind::Text: {
+        current_block->nodes.emplace_back(std::make_shared<TextNode>(tok.text.data() - tmpl.content.c_str(), tok.text.size()));
+      } break;
+      case Token::Kind::StatementOpen: {
+        get_next_token();
+        if (!parse_statement(tmpl, Token::Kind::StatementClose, path)) {
+          throw_parser_error("expected statement, got '" + tok.describe() + "'");
+        }
+        if (tok.kind != Token::Kind::StatementClose) {
+          throw_parser_error("expected statement close, got '" + tok.describe() + "'");
+        }
+      } break;
+      case Token::Kind::LineStatementOpen: {
+        get_next_token();
+        if (!parse_statement(tmpl, Token::Kind::LineStatementClose, path)) {
+          throw_parser_error("expected statement, got '" + tok.describe() + "'");
+        }
+        if (tok.kind != Token::Kind::LineStatementClose && tok.kind != Token::Kind::Eof) {
+          throw_parser_error("expected line statement close, got '" + tok.describe() + "'");
+        }
+      } break;
+      case Token::Kind::ExpressionOpen: {
+        get_next_token();
+
+        auto expression_list_node = std::make_shared<ExpressionListNode>(tok.text.data() - tmpl.content.c_str());
+        current_block->nodes.emplace_back(expression_list_node);
+        current_expression_list = expression_list_node.get();
+
+        if (!parse_expression(tmpl, Token::Kind::ExpressionClose)) {
+          throw_parser_error("expected expression, got '" + tok.describe() + "'");
+        }
+
+        if (tok.kind != Token::Kind::ExpressionClose) {
+          throw_parser_error("expected expression close, got '" + tok.describe() + "'");
+        }
+      } break;
+      case Token::Kind::CommentOpen: {
+        get_next_token();
+        if (tok.kind != Token::Kind::CommentClose) {
+          throw_parser_error("expected comment close, got '" + tok.describe() + "'");
+        }
+      } break;
+      default: {
+        throw_parser_error("unexpected token '" + tok.describe() + "'");
+      } break;
+      }
+    }
+  }
+
+
+public:
+  explicit Parser(const ParserConfig &parser_config, const LexerConfig &lexer_config,
+                  TemplateStorage &template_storage, const FunctionStorage &function_storage)
+      : config(parser_config), lexer(lexer_config), template_storage(template_storage), function_storage(function_storage) { }
+
+  Template parse(nonstd::string_view input, nonstd::string_view path) {
+    auto result = Template(static_cast<std::string>(input));
+    parse_into(result, path);
+    return result;
+  }
+
+  Template parse(nonstd::string_view input) {
+    return parse(input, "./");
+  }
+
+  void parse_into_template(Template& tmpl, nonstd::string_view filename) {
+    nonstd::string_view path = filename.substr(0, filename.find_last_of("/\\") + 1);
+
+    // StringRef path = sys::path::parent_path(filename);
+    auto sub_parser = Parser(config, lexer.get_config(), template_storage, function_storage);
+    sub_parser.parse_into(tmpl, path);
+  }
+
+  std::string load_file(const std::string& filename) {
+    std::ifstream file;
+    file.open(filename);
+    if (file.fail()) {
+      INJA_THROW(FileError("failed accessing file at '" + filename + "'"));
+    }
+    std::string text((std::istreambuf_iterator<char>(file)), std::istreambuf_iterator<char>());
+    return text;
+  }
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_PARSER_HPP_
+
+// #include "renderer.hpp"
+#ifndef INCLUDE_INJA_RENDERER_HPP_
+#define INCLUDE_INJA_RENDERER_HPP_
+
+#include <algorithm>
+#include <numeric>
+#include <string>
+#include <utility>
+#include <vector>
+
+// #include "config.hpp"
+
+// #include "exceptions.hpp"
+
+// #include "node.hpp"
+
+// #include "template.hpp"
+
+// #include "utils.hpp"
+
+
+namespace inja {
+
+/*!
+ * \brief Class for rendering a Template with data.
+ */
+class Renderer : public NodeVisitor  {
+  using Op = FunctionStorage::Operation;
+
+  const RenderConfig config;
+  const TemplateStorage &template_storage;
+  const FunctionStorage &function_storage;
+
+  const Template *current_template;
+  size_t current_level {0};
+  std::vector<const Template*> template_stack;
+  std::vector<const BlockStatementNode*> block_statement_stack;
+
+  const json *json_input;
+  std::ostream *output_stream;
+
+  json json_additional_data;
+  json* current_loop_data = &json_additional_data["loop"];
+
+  std::vector<std::shared_ptr<json>> json_tmp_stack;
+  std::stack<const json*> json_eval_stack;
+  std::stack<const JsonNode*> not_found_stack;
+
+  bool break_rendering {false};
+
+  bool truthy(const json* data) const {
+    if (data->is_boolean()) {
+      return data->get<bool>();
+    } else if (data->is_number()) {
+      return (*data != 0);
+    } else if (data->is_null()) {
+      return false;
+    }
+    return !data->empty();
+  }
+
+  void print_json(const std::shared_ptr<json> value) {
+    if (value->is_string()) {
+      *output_stream << value->get_ref<const json::string_t&>();
+    } else if (value->is_number_integer()) {
+      *output_stream << value->get<const json::number_integer_t>();
+    } else if (value->is_null()) {
+    } else {
+      *output_stream << value->dump();
+    }
+  }
+
+  const std::shared_ptr<json> eval_expression_list(const ExpressionListNode& expression_list) {
+    if (!expression_list.root) {
+      throw_renderer_error("empty expression", expression_list);
+    }
+
+    expression_list.root->accept(*this);
+
+    if (json_eval_stack.empty()) {
+      throw_renderer_error("empty expression", expression_list);
+    } else if (json_eval_stack.size() != 1) {
+      throw_renderer_error("malformed expression", expression_list);
+    }
+
+    const auto result = json_eval_stack.top();
+    json_eval_stack.pop();
+
+    if (!result) {
+      if (not_found_stack.empty()) {
+        throw_renderer_error("expression could not be evaluated", expression_list);
+      }
+
+      auto node = not_found_stack.top();
+      not_found_stack.pop();
+
+      throw_renderer_error("variable '" + static_cast<std::string>(node->name) + "' not found", *node);
+    }
+    return std::make_shared<json>(*result);
+  }
+
+  void throw_renderer_error(const std::string &message, const AstNode& node) {
+    SourceLocation loc = get_source_location(current_template->content, node.pos);
+    INJA_THROW(RenderError(message, loc));
+  }
+
+  template<size_t N, size_t N_start = 0, bool throw_not_found=true>
+  std::array<const json*, N> get_arguments(const FunctionNode& node) {
+    if (node.arguments.size() < N_start + N) {
+      throw_renderer_error("function needs " + std::to_string(N_start + N) + " variables, but has only found " + std::to_string(node.arguments.size()), node);
+    }
+
+    for (size_t i = N_start; i < N_start + N; i += 1) {
+      node.arguments[i]->accept(*this);
+    }
+
+    if (json_eval_stack.size() < N) {
+      throw_renderer_error("function needs " + std::to_string(N) + " variables, but has only found " + std::to_string(json_eval_stack.size()), node);
+    }
+
+    std::array<const json*, N> result;
+    for (size_t i = 0; i < N; i += 1) {
+      result[N - i - 1] = json_eval_stack.top();
+      json_eval_stack.pop();
+
+      if (!result[N - i - 1]) {
+        const auto json_node = not_found_stack.top();
+        not_found_stack.pop();
+
+        if (throw_not_found) {
+          throw_renderer_error("variable '" + static_cast<std::string>(json_node->name) + "' not found", *json_node);
+        }
+      }
+    }
+    return result;
+  }
+
+  template<bool throw_not_found=true>
+  Arguments get_argument_vector(const FunctionNode& node) {
+    const size_t N = node.arguments.size();
+    for (auto a: node.arguments) {
+      a->accept(*this);
+    }
+
+    if (json_eval_stack.size() < N) {
+      throw_renderer_error("function needs " + std::to_string(N) + " variables, but has only found " + std::to_string(json_eval_stack.size()), node);
+    }
+
+    Arguments result {N};
+    for (size_t i = 0; i < N; i += 1) {
+      result[N - i - 1] = json_eval_stack.top();
+      json_eval_stack.pop();
+
+      if (!result[N - i - 1]) {
+        const auto json_node = not_found_stack.top();
+        not_found_stack.pop();
+
+        if (throw_not_found) {
+          throw_renderer_error("variable '" + static_cast<std::string>(json_node->name) + "' not found", *json_node);
+        }
+      }
+    }
+    return result;
+  }
+
+  void visit(const BlockNode& node) {
+    for (auto& n : node.nodes) {
+      n->accept(*this);
+
+      if (break_rendering) {
+        break;
+      }
+    }
+  }
+
+  void visit(const TextNode& node) {
+    output_stream->write(current_template->content.c_str() + node.pos, node.length);
+  }
+
+  void visit(const ExpressionNode&) { }
+
+  void visit(const LiteralNode& node) {
+    json_eval_stack.push(&node.value);
+  }
+
+  void visit(const JsonNode& node) {
+    if (json_additional_data.contains(node.ptr)) {
+      json_eval_stack.push(&(json_additional_data[node.ptr]));
+
+    } else if (json_input->contains(node.ptr)) {
+      json_eval_stack.push(&(*json_input)[node.ptr]);
+
+    } else {
+      // Try to evaluate as a no-argument callback
+      const auto function_data = function_storage.find_function(node.name, 0);
+      if (function_data.operation == FunctionStorage::Operation::Callback) {
+        Arguments empty_args {};
+        const auto value = std::make_shared<json>(function_data.callback(empty_args));
+        json_tmp_stack.push_back(value);
+        json_eval_stack.push(value.get());
+
+      } else {
+        json_eval_stack.push(nullptr);
+        not_found_stack.emplace(&node);
+      }
+    }
+  }
+
+  void visit(const FunctionNode& node) {
+    std::shared_ptr<json> result_ptr;
+
+    switch (node.operation) {
+    case Op::Not: {
+      const auto args = get_arguments<1>(node);
+      result_ptr = std::make_shared<json>(!truthy(args[0]));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::And: {
+      result_ptr = std::make_shared<json>(truthy(get_arguments<1, 0>(node)[0]) && truthy(get_arguments<1, 1>(node)[0]));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Or: {
+      result_ptr = std::make_shared<json>(truthy(get_arguments<1, 0>(node)[0]) || truthy(get_arguments<1, 1>(node)[0]));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::In: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(std::find(args[1]->begin(), args[1]->end(), *args[0]) != args[1]->end());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Equal: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(*args[0] == *args[1]);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::NotEqual: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(*args[0] != *args[1]);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Greater: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(*args[0] > *args[1]);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::GreaterEqual: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(*args[0] >= *args[1]);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Less: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(*args[0] < *args[1]);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::LessEqual: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(*args[0] <= *args[1]);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Add: {
+      const auto args = get_arguments<2>(node);
+      if (args[0]->is_string() && args[1]->is_string()) {
+        result_ptr = std::make_shared<json>(args[0]->get_ref<const std::string&>() + args[1]->get_ref<const std::string&>());
+        json_tmp_stack.push_back(result_ptr);
+      } else if (args[0]->is_number_integer() && args[1]->is_number_integer()) {
+        result_ptr = std::make_shared<json>(args[0]->get<int>() + args[1]->get<int>());
+        json_tmp_stack.push_back(result_ptr);
+      } else {
+        result_ptr = std::make_shared<json>(args[0]->get<double>() + args[1]->get<double>());
+        json_tmp_stack.push_back(result_ptr);
+      }
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Subtract: {
+      const auto args = get_arguments<2>(node);
+      if (args[0]->is_number_integer() && args[1]->is_number_integer()) {
+        result_ptr = std::make_shared<json>(args[0]->get<int>() - args[1]->get<int>());
+        json_tmp_stack.push_back(result_ptr);
+      } else {
+        result_ptr = std::make_shared<json>(args[0]->get<double>() - args[1]->get<double>());
+        json_tmp_stack.push_back(result_ptr);
+      }
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Multiplication: {
+      const auto args = get_arguments<2>(node);
+      if (args[0]->is_number_integer() && args[1]->is_number_integer()) {
+        result_ptr = std::make_shared<json>(args[0]->get<int>() * args[1]->get<int>());
+        json_tmp_stack.push_back(result_ptr);
+      } else {
+        result_ptr = std::make_shared<json>(args[0]->get<double>() * args[1]->get<double>());
+        json_tmp_stack.push_back(result_ptr);
+      }
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Division: {
+      const auto args = get_arguments<2>(node);
+      if (args[1]->get<double>() == 0) {
+        throw_renderer_error("division by zero", node);
+      }
+      result_ptr = std::make_shared<json>(args[0]->get<double>() / args[1]->get<double>());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Power: {
+      const auto args = get_arguments<2>(node);
+      if (args[0]->is_number_integer() && args[1]->get<int>() >= 0) {
+        int result = static_cast<int>(std::pow(args[0]->get<int>(), args[1]->get<int>()));
+        result_ptr = std::make_shared<json>(std::move(result));
+        json_tmp_stack.push_back(result_ptr);
+      } else {
+        double result = std::pow(args[0]->get<double>(), args[1]->get<int>());
+        result_ptr = std::make_shared<json>(std::move(result));
+        json_tmp_stack.push_back(result_ptr);
+      }
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Modulo: {
+      const auto args = get_arguments<2>(node);
+      result_ptr = std::make_shared<json>(args[0]->get<int>() % args[1]->get<int>());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::AtId: {
+      const auto container = get_arguments<1, 0, false>(node)[0];
+      node.arguments[1]->accept(*this);
+      if (not_found_stack.empty()) {
+        throw_renderer_error("could not find element with given name", node);
+      }
+      const auto id_node = not_found_stack.top();
+      not_found_stack.pop();
+      json_eval_stack.pop();
+      json_eval_stack.push(&container->at(id_node->name));
+    } break;
+    case Op::At: {
+      const auto args = get_arguments<2>(node);
+      if (args[0]->is_object()) {
+        json_eval_stack.push(&args[0]->at(args[1]->get<std::string>()));
+      } else {
+        json_eval_stack.push(&args[0]->at(args[1]->get<int>()));
+      }
+    } break;
+    case Op::Default: {
+      const auto test_arg = get_arguments<1, 0, false>(node)[0];
+      json_eval_stack.push(test_arg ? test_arg : get_arguments<1, 1>(node)[0]);
+    } break;
+    case Op::DivisibleBy: {
+      const auto args = get_arguments<2>(node);
+      const int divisor = args[1]->get<int>();
+      result_ptr = std::make_shared<json>((divisor != 0) && (args[0]->get<int>() % divisor == 0));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Even: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->get<int>() % 2 == 0);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Exists: {
+      auto &&name = get_arguments<1>(node)[0]->get_ref<const std::string &>();
+      result_ptr = std::make_shared<json>(json_input->contains(json::json_pointer(JsonNode::convert_dot_to_json_ptr(name))));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::ExistsInObject: {
+      const auto args = get_arguments<2>(node);
+      auto &&name = args[1]->get_ref<const std::string &>();
+      result_ptr = std::make_shared<json>(args[0]->find(name) != args[0]->end());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::First: {
+      const auto result = &get_arguments<1>(node)[0]->front();
+      json_eval_stack.push(result);
+    } break;
+    case Op::Float: {
+      result_ptr = std::make_shared<json>(std::stod(get_arguments<1>(node)[0]->get_ref<const std::string &>()));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Int: {
+      result_ptr = std::make_shared<json>(std::stoi(get_arguments<1>(node)[0]->get_ref<const std::string &>()));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Last: {
+      const auto result = &get_arguments<1>(node)[0]->back();
+      json_eval_stack.push(result);
+    } break;
+    case Op::Length: {
+      const auto val = get_arguments<1>(node)[0];
+      if (val->is_string()) {
+        result_ptr = std::make_shared<json>(val->get_ref<const std::string &>().length());
+      } else {
+        result_ptr = std::make_shared<json>(val->size());
+      }
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Lower: {
+      std::string result = get_arguments<1>(node)[0]->get<std::string>();
+      std::transform(result.begin(), result.end(), result.begin(), ::tolower);
+      result_ptr = std::make_shared<json>(std::move(result));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Max: {
+      const auto args = get_arguments<1>(node);
+      const auto result = std::max_element(args[0]->begin(), args[0]->end());
+      json_eval_stack.push(&(*result));
+    } break;
+    case Op::Min: {
+      const auto args = get_arguments<1>(node);
+      const auto result = std::min_element(args[0]->begin(), args[0]->end());
+      json_eval_stack.push(&(*result));
+    } break;
+    case Op::Odd: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->get<int>() % 2 != 0);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Range: {
+      std::vector<int> result(get_arguments<1>(node)[0]->get<int>());
+      std::iota(result.begin(), result.end(), 0);
+      result_ptr = std::make_shared<json>(std::move(result));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Round: {
+      const auto args = get_arguments<2>(node);
+      const int precision = args[1]->get<int>();
+      const double result = std::round(args[0]->get<double>() * std::pow(10.0, precision)) / std::pow(10.0, precision);
+      if(0==precision){
+        result_ptr = std::make_shared<json>(int(result));
+      }else{
+        result_ptr = std::make_shared<json>(std::move(result));
+      }
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Sort: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->get<std::vector<json>>());
+      std::sort(result_ptr->begin(), result_ptr->end());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Upper: {
+      std::string result = get_arguments<1>(node)[0]->get<std::string>();
+      std::transform(result.begin(), result.end(), result.begin(), ::toupper);
+      result_ptr = std::make_shared<json>(std::move(result));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::IsBoolean: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_boolean());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::IsNumber: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_number());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::IsInteger: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_number_integer());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::IsFloat: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_number_float());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::IsObject: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_object());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::IsArray: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_array());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::IsString: {
+      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_string());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Callback: {
+      auto args = get_argument_vector(node);
+      result_ptr = std::make_shared<json>(node.callback(args));
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Super: {
+      const auto args = get_argument_vector(node);
+      const size_t old_level = current_level;
+      const size_t level_diff = (args.size() == 1) ? args[0]->get<int>() : 1;
+      const size_t level = current_level + level_diff;
+
+      if (block_statement_stack.empty()) {
+        throw_renderer_error("super() call is not within a block", node);
+      }
+
+      if (level < 1 || level > template_stack.size() - 1) {
+        throw_renderer_error("level of super() call does not match parent templates (between 1 and " + std::to_string(template_stack.size() - 1) + ")", node);
+      }
+
+      const auto current_block_statement = block_statement_stack.back();
+      const Template *new_template = template_stack.at(level);
+      const Template *old_template = current_template;
+      const auto block_it = new_template->block_storage.find(current_block_statement->name);
+      if (block_it != new_template->block_storage.end()) {
+        current_template = new_template;
+        current_level = level;
+        block_it->second->block.accept(*this);
+        current_level = old_level;
+        current_template = old_template;
+      } else {
+        throw_renderer_error("could not find block with name '" + current_block_statement->name + "'", node);
+      }
+      result_ptr = std::make_shared<json>(nullptr);
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::Join: {
+      const auto args = get_arguments<2>(node);
+      const auto separator = args[1]->get<std::string>();
+      std::ostringstream os;
+      std::string sep;
+      for (const auto& value : *args[0]) {
+        os << sep;
+        if (value.is_string()) {
+          os << value.get<std::string>(); // otherwise the value is surrounded with ""
+        } else {
+          os << value;
+        }
+        sep = separator;
+      }
+      result_ptr = std::make_shared<json>(os.str());
+      json_tmp_stack.push_back(result_ptr);
+      json_eval_stack.push(result_ptr.get());
+    } break;
+    case Op::ParenLeft:
+    case Op::ParenRight:
+    case Op::None:
+      break;
+    }
+  }
+
+  void visit(const ExpressionListNode& node) {
+    print_json(eval_expression_list(node));
+  }
+
+  void visit(const StatementNode&) { }
+
+  void visit(const ForStatementNode&) { }
+
+  void visit(const ForArrayStatementNode& node) {
+    const auto result = eval_expression_list(node.condition);
+    if (!result->is_array()) {
+      throw_renderer_error("object must be an array", node);
+    }
+
+    if (!current_loop_data->empty()) {
+      auto tmp = *current_loop_data; // Because of clang-3
+      (*current_loop_data)["parent"] = std::move(tmp);
+    }
+
+    size_t index = 0;
+    (*current_loop_data)["is_first"] = true;
+    (*current_loop_data)["is_last"] = (result->size() <= 1);
+    for (auto it = result->begin(); it != result->end(); ++it) {
+      json_additional_data[static_cast<std::string>(node.value)] = *it;
+
+      (*current_loop_data)["index"] = index;
+      (*current_loop_data)["index1"] = index + 1;
+      if (index == 1) {
+        (*current_loop_data)["is_first"] = false;
+      }
+      if (index == result->size() - 1) {
+        (*current_loop_data)["is_last"] = true;
+      }
+
+      node.body.accept(*this);
+      ++index;
+    }
+
+    json_additional_data[static_cast<std::string>(node.value)].clear();
+    if (!(*current_loop_data)["parent"].empty()) {
+      const auto tmp = (*current_loop_data)["parent"];
+      *current_loop_data = std::move(tmp);
+    } else {
+      current_loop_data = &json_additional_data["loop"];
+    }
+  }
+
+  void visit(const ForObjectStatementNode& node) {
+    const auto result = eval_expression_list(node.condition);
+    if (!result->is_object()) {
+      throw_renderer_error("object must be an object", node);
+    }
+
+    if (!current_loop_data->empty()) {
+      (*current_loop_data)["parent"] = std::move(*current_loop_data);
+    }
+
+    size_t index = 0;
+    (*current_loop_data)["is_first"] = true;
+    (*current_loop_data)["is_last"] = (result->size() <= 1);
+    for (auto it = result->begin(); it != result->end(); ++it) {
+      json_additional_data[static_cast<std::string>(node.key)] = it.key();
+      json_additional_data[static_cast<std::string>(node.value)] = it.value();
+
+      (*current_loop_data)["index"] = index;
+      (*current_loop_data)["index1"] = index + 1;
+      if (index == 1) {
+        (*current_loop_data)["is_first"] = false;
+      }
+      if (index == result->size() - 1) {
+        (*current_loop_data)["is_last"] = true;
+      }
+
+      node.body.accept(*this);
+      ++index;
+    }
+
+    json_additional_data[static_cast<std::string>(node.key)].clear();
+    json_additional_data[static_cast<std::string>(node.value)].clear();
+    if (!(*current_loop_data)["parent"].empty()) {
+      *current_loop_data = std::move((*current_loop_data)["parent"]);
+    } else {
+      current_loop_data = &json_additional_data["loop"];
+    }
+  }
+
+  void visit(const IfStatementNode& node) {
+    const auto result = eval_expression_list(node.condition);
+    if (truthy(result.get())) {
+      node.true_statement.accept(*this);
+    } else if (node.has_false_statement) {
+      node.false_statement.accept(*this);
+    }
+  }
+
+  void visit(const IncludeStatementNode& node) {
+    auto sub_renderer = Renderer(config, template_storage, function_storage);
+    const auto included_template_it = template_storage.find(node.file);
+    if (included_template_it != template_storage.end()) {
+      sub_renderer.render_to(*output_stream, included_template_it->second, *json_input, &json_additional_data);
+    } else if (config.throw_at_missing_includes) {
+      throw_renderer_error("include '" + node.file + "' not found", node);
+    }
+  }
+
+  void visit(const ExtendsStatementNode& node) {
+    const auto included_template_it = template_storage.find(node.file);
+    if (included_template_it != template_storage.end()) {
+      const Template *parent_template = &included_template_it->second;
+      render_to(*output_stream, *parent_template, *json_input, &json_additional_data);
+      break_rendering = true;
+    } else if (config.throw_at_missing_includes) {
+      throw_renderer_error("extends '" + node.file + "' not found", node);
+    }
+  }
+
+  void visit(const BlockStatementNode& node) {
+    const size_t old_level = current_level;
+    current_level = 0;
+    current_template = template_stack.front();
+    const auto block_it = current_template->block_storage.find(node.name);
+    if (block_it != current_template->block_storage.end()) {
+      block_statement_stack.emplace_back(&node);
+      block_it->second->block.accept(*this);
+      block_statement_stack.pop_back(); 
+    }
+    current_level = old_level;
+    current_template = template_stack.back();
+  }
+
+  void visit(const SetStatementNode& node) {
+    std::string ptr = node.key;
+    replace_substring(ptr, ".", "/");
+    ptr = "/" + ptr;
+    json_additional_data[json::json_pointer(ptr)] = *eval_expression_list(node.expression);
+  }
+
+public:
+  Renderer(const RenderConfig& config, const TemplateStorage &template_storage, const FunctionStorage &function_storage)
+      : config(config), template_storage(template_storage), function_storage(function_storage) { }
+
+  void render_to(std::ostream &os, const Template &tmpl, const json &data, json *loop_data = nullptr) {
+    output_stream = &os;
+    current_template = &tmpl;
+    json_input = &data;
+    if (loop_data) {
+      json_additional_data = *loop_data;
+      current_loop_data = &json_additional_data["loop"];
+    }
+
+    template_stack.emplace_back(current_template);
+    current_template->root.accept(*this);
+
+    json_tmp_stack.clear();
+  }
+};
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_RENDERER_HPP_
+
+// #include "string_view.hpp"
+
+// #include "template.hpp"
+
+// #include "utils.hpp"
+
+
+namespace inja {
+
+/*!
+ * \brief Class for changing the configuration.
+ */
+class Environment {
+  std::string input_path;
+  std::string output_path;
+
+  LexerConfig lexer_config;
+  ParserConfig parser_config;
+  RenderConfig render_config;
+
+  FunctionStorage function_storage;
+  TemplateStorage template_storage;
+
+public:
+  Environment() : Environment("") {}
+
+  explicit Environment(const std::string &global_path) : input_path(global_path), output_path(global_path) {}
+
+  Environment(const std::string &input_path, const std::string &output_path)
+      : input_path(input_path), output_path(output_path) {}
+
+  /// Sets the opener and closer for template statements
+  void set_statement(const std::string &open, const std::string &close) {
+    lexer_config.statement_open = open;
+    lexer_config.statement_open_no_lstrip = open + "+";
+    lexer_config.statement_open_force_lstrip = open + "-";
+    lexer_config.statement_close = close;
+    lexer_config.statement_close_force_rstrip = "-" + close;
+    lexer_config.update_open_chars();
+  }
+
+  /// Sets the opener for template line statements
+  void set_line_statement(const std::string &open) {
+    lexer_config.line_statement = open;
+    lexer_config.update_open_chars();
+  }
+
+  /// Sets the opener and closer for template expressions
+  void set_expression(const std::string &open, const std::string &close) {
+    lexer_config.expression_open = open;
+    lexer_config.expression_open_force_lstrip = open + "-";
+    lexer_config.expression_close = close;
+    lexer_config.expression_close_force_rstrip = "-" + close;
+    lexer_config.update_open_chars();
+  }
+
+  /// Sets the opener and closer for template comments
+  void set_comment(const std::string &open, const std::string &close) {
+    lexer_config.comment_open = open;
+    lexer_config.comment_open_force_lstrip = open + "-";
+    lexer_config.comment_close = close;
+    lexer_config.comment_close_force_rstrip = "-" + close;
+    lexer_config.update_open_chars();
+  }
+
+  /// Sets whether to remove the first newline after a block
+  void set_trim_blocks(bool trim_blocks) {
+    lexer_config.trim_blocks = trim_blocks;
+  }
+
+  /// Sets whether to strip the spaces and tabs from the start of a line to a block
+  void set_lstrip_blocks(bool lstrip_blocks) {
+    lexer_config.lstrip_blocks = lstrip_blocks;
+  }
+
+  /// Sets the element notation syntax
+  void set_search_included_templates_in_files(bool search_in_files) {
+    parser_config.search_included_templates_in_files = search_in_files;
+  }
+
+  /// Sets whether a missing include will throw an error
+  void set_throw_at_missing_includes(bool will_throw) {
+    render_config.throw_at_missing_includes = will_throw;
+  }
+
+  Template parse(nonstd::string_view input) {
+    Parser parser(parser_config, lexer_config, template_storage, function_storage);
+    return parser.parse(input);
+  }
+
+  Template parse_template(const std::string &filename) {
+    Parser parser(parser_config, lexer_config, template_storage, function_storage);
+    auto result = Template(parser.load_file(input_path + static_cast<std::string>(filename)));
+    parser.parse_into_template(result, input_path + static_cast<std::string>(filename));
+    return result;
+  }
+
+  Template parse_file(const std::string &filename) {
+    return parse_template(filename);
+  }
+
+  std::string render(nonstd::string_view input, const json &data) { return render(parse(input), data); }
+
+  std::string render(const Template &tmpl, const json &data) {
+    std::stringstream os;
+    render_to(os, tmpl, data);
+    return os.str();
+  }
+
+  std::string render_file(const std::string &filename, const json &data) {
+    return render(parse_template(filename), data);
+  }
+
+  std::string render_file_with_json_file(const std::string &filename, const std::string &filename_data) {
+    const json data = load_json(filename_data);
+    return render_file(filename, data);
+  }
+
+  void write(const std::string &filename, const json &data, const std::string &filename_out) {
+    std::ofstream file(output_path + filename_out);
+    file << render_file(filename, data);
+    file.close();
+  }
+
+  void write(const Template &temp, const json &data, const std::string &filename_out) {
+    std::ofstream file(output_path + filename_out);
+    file << render(temp, data);
+    file.close();
+  }
+
+  void write_with_json_file(const std::string &filename, const std::string &filename_data,
+                            const std::string &filename_out) {
+    const json data = load_json(filename_data);
+    write(filename, data, filename_out);
+  }
+
+  void write_with_json_file(const Template &temp, const std::string &filename_data, const std::string &filename_out) {
+    const json data = load_json(filename_data);
+    write(temp, data, filename_out);
+  }
+
+  std::ostream &render_to(std::ostream &os, const Template &tmpl, const json &data) {
+    Renderer(render_config, template_storage, function_storage).render_to(os, tmpl, data);
+    return os;
+  }
+
+  std::string load_file(const std::string &filename) {
+    Parser parser(parser_config, lexer_config, template_storage, function_storage);
+    return parser.load_file(input_path + filename);
+  }
+
+  json load_json(const std::string &filename) {
+    std::ifstream file;
+    file.open(input_path + filename);
+    if (file.fail()) {
+      INJA_THROW(FileError("failed accessing file at '" + input_path + filename + "'"));
+    }
+    json j;
+    file >> j;
+    return j;
+  }
+
+  /*!
+  @brief Adds a variadic callback
+  */
+  void add_callback(const std::string &name, const CallbackFunction &callback) {
+    add_callback(name, -1, callback);
+  }
+
+  /*!
+  @brief Adds a variadic void callback
+  */
+  void add_void_callback(const std::string &name, const VoidCallbackFunction &callback) {
+    add_void_callback(name, -1, callback);
+  }
+
+  /*!
+  @brief Adds a callback with given number or arguments
+  */
+  void add_callback(const std::string &name, int num_args, const CallbackFunction &callback) {
+    function_storage.add_callback(name, num_args, callback);
+  }
+
+  /*!
+  @brief Adds a void callback with given number or arguments
+  */
+  void add_void_callback(const std::string &name, int num_args, const VoidCallbackFunction &callback) {
+    function_storage.add_callback(name, num_args, [callback](Arguments& args) { callback(args); return json(); });
+  }
+
+  /** Includes a template with a given name into the environment.
+   * Then, a template can be rendered in another template using the
+   * include "<name>" syntax.
+   */
+  void include_template(const std::string &name, const Template &tmpl) {
+    template_storage[name] = tmpl;
+  }
+
+  /*!
+  @brief Sets a function that is called when an included file is not found
+  */
+  void set_include_callback(const std::function<Template(const std::string&, const std::string&)>& callback) {
+    parser_config.include_callback = callback;
+  }
+};
+
+/*!
+@brief render with default settings to a string
+*/
+inline std::string render(nonstd::string_view input, const json &data) {
+  return Environment().render(input, data);
+}
+
+/*!
+@brief render with default settings to the given output stream
+*/
+inline void render_to(std::ostream &os, nonstd::string_view input, const json &data) {
+  Environment env;
+  env.render_to(os, env.parse(input), data);
+}
+
+} // namespace inja
+
+#endif // INCLUDE_INJA_ENVIRONMENT_HPP_
+
+// #include "exceptions.hpp"
+
+// #include "parser.hpp"
+
+// #include "renderer.hpp"
+
+// #include "string_view.hpp"
+
+// #include "template.hpp"
+
+
+#endif // INCLUDE_INJA_INJA_HPP_
diff -pruN 8.0.1-5/src/uthash.h 8.2.0~beta1-1~exp1/src/uthash.h
--- 8.0.1-5/src/uthash.h	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/uthash.h	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,940 @@
+/*
+Copyright (c) 2003-2013, Troy D. Hanson     http://troydhanson.github.com/uthash/
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are met:
+
+    * Redistributions of source code must retain the above copyright
+      notice, this list of conditions and the following disclaimer.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
+IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
+OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+*/
+
+#ifndef UT_HASH_H
+#define UT_HASH_H 
+
+#include <string.h>   /* memcmp,strlen */
+#include <stddef.h>   /* ptrdiff_t */
+#include <stdlib.h>   /* exit() */
+
+/* These macros use decltype or the earlier __typeof GNU extension.
+   As decltype is only available in newer compilers (VS2010 or gcc 4.3+
+   when compiling c++ source) this code uses whatever method is needed
+   or, for VS2008 where neither is available, uses casting workarounds. */
+#ifdef _MSC_VER         /* MS compiler */
+#if _MSC_VER >= 1600 && defined(__cplusplus)  /* VS2010 or newer in C++ mode */
+#define DECLTYPE(x) (decltype(x))
+#else                   /* VS2008 or older (or VS2010 in C mode) */
+#define NO_DECLTYPE
+#define DECLTYPE(x)
+#endif
+#else                   /* GNU, Sun and other compilers */
+#define DECLTYPE(x) (__typeof(x))
+#endif
+
+#ifdef NO_DECLTYPE
+#define DECLTYPE_ASSIGN(dst,src)                                                 \
+do {                                                                             \
+  char **_da_dst = (char**)(&(dst));                                             \
+  *_da_dst = (char*)(src);                                                       \
+} while(0)
+#else 
+#define DECLTYPE_ASSIGN(dst,src)                                                 \
+do {                                                                             \
+  (dst) = DECLTYPE(dst)(src);                                                    \
+} while(0)
+#endif
+
+/* a number of the hash function use uint32_t which isn't defined on win32 */
+#ifdef _MSC_VER
+typedef unsigned int uint32_t;
+typedef unsigned char uint8_t;
+#else
+#include <inttypes.h>   /* uint32_t */
+#endif
+
+#define UT_HASH_VERSION 1.9.8
+
+#ifndef uthash_fatal
+#define uthash_fatal(msg) exit(-1)        /* fatal error (out of memory,etc) */
+#endif
+#ifndef uthash_malloc
+#define uthash_malloc(sz) malloc(sz)      /* malloc fcn                      */
+#endif
+#ifndef uthash_free
+#define uthash_free(ptr,sz) free(ptr)     /* free fcn                        */
+#endif
+
+#ifndef uthash_noexpand_fyi
+#define uthash_noexpand_fyi(tbl)          /* can be defined to log noexpand  */
+#endif
+#ifndef uthash_expand_fyi
+#define uthash_expand_fyi(tbl)            /* can be defined to log expands   */
+#endif
+
+/* initial number of buckets */
+#define UT_HASH_INITIAL_NUM_BUCKETS 32      /* initial number of buckets        */
+#define UT_HASH_INITIAL_NUM_BUCKETS_LOG2 5  /* lg2 of initial number of buckets */
+#define UT_HASH_BKT_CAPACITY_THRESH 10      /* expand when bucket count reaches */
+
+/* calculate the element whose hash handle address is hhe */
+#define ELMT_FROM_HH(tbl,hhp) ((void*)(((char*)(hhp)) - ((tbl)->hho)))
+
+#define UT_HASH_FIND(hh,head,keyptr,keylen,out)                                     \
+do {                                                                             \
+  unsigned _hf_bkt,_hf_hashv;                                                    \
+  out=NULL;                                                                      \
+  if (head) {                                                                    \
+     UT_HASH_FCN(keyptr,keylen, (head)->hh.tbl->num_buckets, _hf_hashv, _hf_bkt);   \
+     if (UT_HASH_BLOOM_TEST((head)->hh.tbl, _hf_hashv)) {                           \
+       UT_HASH_FIND_IN_BKT((head)->hh.tbl, hh, (head)->hh.tbl->buckets[ _hf_bkt ],  \
+                        keyptr,keylen,out);                                      \
+     }                                                                           \
+  }                                                                              \
+} while (0)
+
+#ifdef UT_HASH_BLOOM
+#define UT_HASH_BLOOM_BITLEN (1ULL << UT_HASH_BLOOM)
+#define UT_HASH_BLOOM_BYTELEN (UT_HASH_BLOOM_BITLEN/8) + ((UT_HASH_BLOOM_BITLEN%8) ? 1:0)
+#define UT_HASH_BLOOM_MAKE(tbl)                                                     \
+do {                                                                             \
+  (tbl)->bloom_nbits = UT_HASH_BLOOM;                                               \
+  (tbl)->bloom_bv = (uint8_t*)uthash_malloc(UT_HASH_BLOOM_BYTELEN);                 \
+  if (!((tbl)->bloom_bv))  { uthash_fatal( "out of memory"); }                   \
+  memset((tbl)->bloom_bv, 0, UT_HASH_BLOOM_BYTELEN);                                \
+  (tbl)->bloom_sig = UT_HASH_BLOOM_SIGNATURE;                                       \
+} while (0) 
+
+#define UT_HASH_BLOOM_FREE(tbl)                                                     \
+do {                                                                             \
+  uthash_free((tbl)->bloom_bv, UT_HASH_BLOOM_BYTELEN);                              \
+} while (0) 
+
+#define UT_HASH_BLOOM_BITSET(bv,idx) (bv[(idx)/8] |= (1U << ((idx)%8)))
+#define UT_HASH_BLOOM_BITTEST(bv,idx) (bv[(idx)/8] & (1U << ((idx)%8)))
+
+#define UT_HASH_BLOOM_ADD(tbl,hashv)                                                \
+  UT_HASH_BLOOM_BITSET((tbl)->bloom_bv, (hashv & (uint32_t)((1ULL << (tbl)->bloom_nbits) - 1)))
+
+#define UT_HASH_BLOOM_TEST(tbl,hashv)                                               \
+  UT_HASH_BLOOM_BITTEST((tbl)->bloom_bv, (hashv & (uint32_t)((1ULL << (tbl)->bloom_nbits) - 1)))
+
+#else
+#define UT_HASH_BLOOM_MAKE(tbl) 
+#define UT_HASH_BLOOM_FREE(tbl) 
+#define UT_HASH_BLOOM_ADD(tbl,hashv) 
+#define UT_HASH_BLOOM_TEST(tbl,hashv) (1)
+#define UT_HASH_BLOOM_BYTELEN 0
+#endif
+
+#define UT_HASH_MAKE_TABLE(hh,head)                                                 \
+do {                                                                             \
+  (head)->hh.tbl = (UT_hash_table*)uthash_malloc(                                \
+                  sizeof(UT_hash_table));                                        \
+  if (!((head)->hh.tbl))  { uthash_fatal( "out of memory"); }                    \
+  memset((head)->hh.tbl, 0, sizeof(UT_hash_table));                              \
+  (head)->hh.tbl->tail = &((head)->hh);                                          \
+  (head)->hh.tbl->num_buckets = UT_HASH_INITIAL_NUM_BUCKETS;                        \
+  (head)->hh.tbl->log2_num_buckets = UT_HASH_INITIAL_NUM_BUCKETS_LOG2;              \
+  (head)->hh.tbl->hho = (char*)(&(head)->hh) - (char*)(head);                    \
+  (head)->hh.tbl->buckets = (UT_hash_bucket*)uthash_malloc(                      \
+          UT_HASH_INITIAL_NUM_BUCKETS*sizeof(struct UT_hash_bucket));               \
+  if (! (head)->hh.tbl->buckets) { uthash_fatal( "out of memory"); }             \
+  memset((head)->hh.tbl->buckets, 0,                                             \
+          UT_HASH_INITIAL_NUM_BUCKETS*sizeof(struct UT_hash_bucket));               \
+  UT_HASH_BLOOM_MAKE((head)->hh.tbl);                                               \
+  (head)->hh.tbl->signature = UT_HASH_SIGNATURE;                                    \
+} while(0)
+
+#define UT_HASH_ADD(hh,head,fieldname,keylen_in,add)                                \
+        UT_HASH_ADD_KEYPTR(hh,head,&((add)->fieldname),keylen_in,add)
+
+#define UT_HASH_REPLACE(hh,head,fieldname,keylen_in,add,replaced)                   \
+do {                                                                             \
+  replaced=NULL;                                                                 \
+  UT_HASH_FIND(hh,head,&((add)->fieldname),keylen_in,replaced);                     \
+  if (replaced!=NULL) {                                                          \
+     UT_HASH_DELETE(hh,head,replaced);                                              \
+  };                                                                             \
+  UT_HASH_ADD(hh,head,fieldname,keylen_in,add);                                     \
+} while(0)
+ 
+#define UT_HASH_ADD_KEYPTR(hh,head,keyptr,keylen_in,add)                            \
+do {                                                                             \
+ unsigned _ha_bkt;                                                               \
+ (add)->hh.next = NULL;                                                          \
+ (add)->hh.key = (char*)keyptr;                                                  \
+ (add)->hh.keylen = (unsigned)keylen_in;                                                   \
+ if (!(head)) {                                                                  \
+    head = (add);                                                                \
+    (head)->hh.prev = NULL;                                                      \
+    UT_HASH_MAKE_TABLE(hh,head);                                                    \
+ } else {                                                                        \
+    (head)->hh.tbl->tail->next = (add);                                          \
+    (add)->hh.prev = ELMT_FROM_HH((head)->hh.tbl, (head)->hh.tbl->tail);         \
+    (head)->hh.tbl->tail = &((add)->hh);                                         \
+ }                                                                               \
+ (head)->hh.tbl->num_items++;                                                    \
+ (add)->hh.tbl = (head)->hh.tbl;                                                 \
+ UT_HASH_FCN(keyptr,keylen_in, (head)->hh.tbl->num_buckets,                         \
+         (add)->hh.hashv, _ha_bkt);                                              \
+ UT_HASH_ADD_TO_BKT((head)->hh.tbl->buckets[_ha_bkt],&(add)->hh);                   \
+ UT_HASH_BLOOM_ADD((head)->hh.tbl,(add)->hh.hashv);                                 \
+ UT_HASH_EMIT_KEY(hh,head,keyptr,keylen_in);                                        \
+ UT_HASH_FSCK(hh,head);                                                             \
+} while(0)
+
+#define UT_HASH_TO_BKT( hashv, num_bkts, bkt )                                      \
+do {                                                                             \
+  bkt = ((hashv) & ((num_bkts) - 1));                                            \
+} while(0)
+
+/* delete "delptr" from the hash table.
+ * "the usual" patch-up process for the app-order doubly-linked-list.
+ * The use of _hd_hh_del below deserves special explanation.
+ * These used to be expressed using (delptr) but that led to a bug
+ * if someone used the same symbol for the head and deletee, like
+ *  UT_HASH_DELETE(hh,users,users);
+ * We want that to work, but by changing the head (users) below
+ * we were forfeiting our ability to further refer to the deletee (users)
+ * in the patch-up process. Solution: use scratch space to
+ * copy the deletee pointer, then the latter references are via that
+ * scratch pointer rather than through the repointed (users) symbol.
+ */
+#define UT_HASH_DELETE(hh,head,delptr)                                              \
+do {                                                                             \
+    unsigned _hd_bkt;                                                            \
+    struct UT_hash_handle *_hd_hh_del;                                           \
+    if ( ((delptr)->hh.prev == NULL) && ((delptr)->hh.next == NULL) )  {         \
+        uthash_free((head)->hh.tbl->buckets,                                     \
+                    (head)->hh.tbl->num_buckets*sizeof(struct UT_hash_bucket) ); \
+        UT_HASH_BLOOM_FREE((head)->hh.tbl);                                         \
+        uthash_free((head)->hh.tbl, sizeof(UT_hash_table));                      \
+        head = NULL;                                                             \
+    } else {                                                                     \
+        _hd_hh_del = &((delptr)->hh);                                            \
+        if ((delptr) == ELMT_FROM_HH((head)->hh.tbl,(head)->hh.tbl->tail)) {     \
+            (head)->hh.tbl->tail =                                               \
+                (UT_hash_handle*)((ptrdiff_t)((delptr)->hh.prev) +               \
+                (head)->hh.tbl->hho);                                            \
+        }                                                                        \
+        if ((delptr)->hh.prev) {                                                 \
+            ((UT_hash_handle*)((ptrdiff_t)((delptr)->hh.prev) +                  \
+                    (head)->hh.tbl->hho))->next = (delptr)->hh.next;             \
+        } else {                                                                 \
+            DECLTYPE_ASSIGN(head,(delptr)->hh.next);                             \
+        }                                                                        \
+        if (_hd_hh_del->next) {                                                  \
+            ((UT_hash_handle*)((ptrdiff_t)_hd_hh_del->next +                     \
+                    (head)->hh.tbl->hho))->prev =                                \
+                    _hd_hh_del->prev;                                            \
+        }                                                                        \
+        UT_HASH_TO_BKT( _hd_hh_del->hashv, (head)->hh.tbl->num_buckets, _hd_bkt);   \
+        UT_HASH_DEL_IN_BKT(hh,(head)->hh.tbl->buckets[_hd_bkt], _hd_hh_del);        \
+        (head)->hh.tbl->num_items--;                                             \
+    }                                                                            \
+    UT_HASH_FSCK(hh,head);                                                          \
+} while (0)
+
+
+/* convenience forms of UT_HASH_FIND/UT_HASH_ADD/UT_HASH_DEL */
+#define UT_HASH_FIND_STR(head,findstr,out)                                          \
+    UT_HASH_FIND(hh,head,findstr,strlen(findstr),out)
+#define UT_HASH_ADD_STR(head,strfield,add)                                          \
+    UT_HASH_ADD(hh,head,strfield,strlen(add->strfield),add)
+#define UT_HASH_REPLACE_STR(head,strfield,add,replaced)                             \
+  UT_HASH_REPLACE(hh,head,strfield,strlen(add->strfield),add,replaced)
+#define UT_HASH_FIND_INT(head,findint,out)                                          \
+    UT_HASH_FIND(hh,head,findint,sizeof(int),out)
+#define UT_HASH_ADD_INT(head,intfield,add)                                          \
+    UT_HASH_ADD(hh,head,intfield,sizeof(int),add)
+#define UT_HASH_REPLACE_INT(head,intfield,add,replaced)                             \
+    UT_HASH_REPLACE(hh,head,intfield,sizeof(int),add,replaced)
+#define UT_HASH_FIND_PTR(head,findptr,out)                                          \
+    UT_HASH_FIND(hh,head,findptr,sizeof(void *),out)
+#define UT_HASH_ADD_PTR(head,ptrfield,add)                                          \
+    UT_HASH_ADD(hh,head,ptrfield,sizeof(void *),add)
+#define UT_HASH_REPLACE_PTR(head,ptrfield,add)                                      \
+    UT_HASH_REPLACE(hh,head,ptrfield,sizeof(void *),add,replaced)
+#define UT_HASH_DEL(head,delptr)                                                    \
+    UT_HASH_DELETE(hh,head,delptr)
+
+/* UT_HASH_FSCK checks hash integrity on every add/delete when UT_HASH_DEBUG is defined.
+ * This is for uthash developer only; it compiles away if UT_HASH_DEBUG isn't defined.
+ */
+#ifdef UT_HASH_DEBUG
+#define UT_HASH_OOPS(...) do { fprintf(stderr,__VA_ARGS__); exit(-1); } while (0)
+#define UT_HASH_FSCK(hh,head)                                                       \
+do {                                                                             \
+    unsigned _bkt_i;                                                             \
+    unsigned _count, _bkt_count;                                                 \
+    char *_prev;                                                                 \
+    struct UT_hash_handle *_thh;                                                 \
+    if (head) {                                                                  \
+        _count = 0;                                                              \
+        for( _bkt_i = 0; _bkt_i < (head)->hh.tbl->num_buckets; _bkt_i++) {       \
+            _bkt_count = 0;                                                      \
+            _thh = (head)->hh.tbl->buckets[_bkt_i].hh_head;                      \
+            _prev = NULL;                                                        \
+            while (_thh) {                                                       \
+               if (_prev != (char*)(_thh->hh_prev)) {                            \
+                   UT_HASH_OOPS("invalid hh_prev %p, actual %p\n",                  \
+                    _thh->hh_prev, _prev );                                      \
+               }                                                                 \
+               _bkt_count++;                                                     \
+               _prev = (char*)(_thh);                                            \
+               _thh = _thh->hh_next;                                             \
+            }                                                                    \
+            _count += _bkt_count;                                                \
+            if ((head)->hh.tbl->buckets[_bkt_i].count !=  _bkt_count) {          \
+               UT_HASH_OOPS("invalid bucket count %d, actual %d\n",                 \
+                (head)->hh.tbl->buckets[_bkt_i].count, _bkt_count);              \
+            }                                                                    \
+        }                                                                        \
+        if (_count != (head)->hh.tbl->num_items) {                               \
+            UT_HASH_OOPS("invalid hh item count %d, actual %d\n",                   \
+                (head)->hh.tbl->num_items, _count );                             \
+        }                                                                        \
+        /* traverse hh in app order; check next/prev integrity, count */         \
+        _count = 0;                                                              \
+        _prev = NULL;                                                            \
+        _thh =  &(head)->hh;                                                     \
+        while (_thh) {                                                           \
+           _count++;                                                             \
+           if (_prev !=(char*)(_thh->prev)) {                                    \
+              UT_HASH_OOPS("invalid prev %p, actual %p\n",                          \
+                    _thh->prev, _prev );                                         \
+           }                                                                     \
+           _prev = (char*)ELMT_FROM_HH((head)->hh.tbl, _thh);                    \
+           _thh = ( _thh->next ?  (UT_hash_handle*)((char*)(_thh->next) +        \
+                                  (head)->hh.tbl->hho) : NULL );                 \
+        }                                                                        \
+        if (_count != (head)->hh.tbl->num_items) {                               \
+            UT_HASH_OOPS("invalid app item count %d, actual %d\n",                  \
+                (head)->hh.tbl->num_items, _count );                             \
+        }                                                                        \
+    }                                                                            \
+} while (0)
+#else
+#define UT_HASH_FSCK(hh,head) 
+#endif
+
+/* When compiled with -DUT_HASH_EMIT_KEYS, length-prefixed keys are emitted to 
+ * the descriptor to which this macro is defined for tuning the hash function.
+ * The app can #include <unistd.h> to get the prototype for write(2). */
+#ifdef UT_HASH_EMIT_KEYS
+#define UT_HASH_EMIT_KEY(hh,head,keyptr,fieldlen)                                   \
+do {                                                                             \
+    unsigned _klen = fieldlen;                                                   \
+    write(UT_HASH_EMIT_KEYS, &_klen, sizeof(_klen));                                \
+    write(UT_HASH_EMIT_KEYS, keyptr, fieldlen);                                     \
+} while (0)
+#else 
+#define UT_HASH_EMIT_KEY(hh,head,keyptr,fieldlen)                    
+#endif
+
+/* default to Jenkin's hash unless overridden e.g. DUT_HASH_FUNCTION=UT_HASH_SAX */
+#ifdef UT_HASH_FUNCTION 
+#define UT_HASH_FCN UT_HASH_FUNCTION
+#else
+#define UT_HASH_FCN UT_HASH_JEN
+#endif
+
+/* The Bernstein hash function, used in Perl prior to v5.6 */
+#define UT_HASH_BER(key,keylen,num_bkts,hashv,bkt)                                  \
+do {                                                                             \
+  unsigned _hb_keylen=keylen;                                                    \
+  char *_hb_key=(char*)(key);                                                    \
+  (hashv) = 0;                                                                   \
+  while (_hb_keylen--)  { (hashv) = ((hashv) * 33) + *_hb_key++; }               \
+  bkt = (hashv) & (num_bkts-1);                                                  \
+} while (0)
+
+
+/* SAX/FNV/OAT/JEN hash functions are macro variants of those listed at 
+ * http://eternallyconfuzzled.com/tuts/algorithms/jsw_tut_hashing.aspx */
+#define UT_HASH_SAX(key,keylen,num_bkts,hashv,bkt)                                  \
+do {                                                                             \
+  unsigned _sx_i;                                                                \
+  char *_hs_key=(char*)(key);                                                    \
+  hashv = 0;                                                                     \
+  for(_sx_i=0; _sx_i < keylen; _sx_i++)                                          \
+      hashv ^= (hashv << 5) + (hashv >> 2) + _hs_key[_sx_i];                     \
+  bkt = hashv & (num_bkts-1);                                                    \
+} while (0)
+
+#define UT_HASH_FNV(key,keylen,num_bkts,hashv,bkt)                                  \
+do {                                                                             \
+  unsigned _fn_i;                                                                \
+  char *_hf_key=(char*)(key);                                                    \
+  hashv = 2166136261UL;                                                          \
+  for(_fn_i=0; _fn_i < keylen; _fn_i++)                                          \
+      hashv = (hashv * 16777619) ^ _hf_key[_fn_i];                               \
+  bkt = hashv & (num_bkts-1);                                                    \
+} while(0) 
+ 
+#define UT_HASH_OAT(key,keylen,num_bkts,hashv,bkt)                                  \
+do {                                                                             \
+  unsigned _ho_i;                                                                \
+  char *_ho_key=(char*)(key);                                                    \
+  hashv = 0;                                                                     \
+  for(_ho_i=0; _ho_i < keylen; _ho_i++) {                                        \
+      hashv += _ho_key[_ho_i];                                                   \
+      hashv += (hashv << 10);                                                    \
+      hashv ^= (hashv >> 6);                                                     \
+  }                                                                              \
+  hashv += (hashv << 3);                                                         \
+  hashv ^= (hashv >> 11);                                                        \
+  hashv += (hashv << 15);                                                        \
+  bkt = hashv & (num_bkts-1);                                                    \
+} while(0)
+
+#define UT_HASH_JEN_MIX(a,b,c)                                                      \
+do {                                                                             \
+  a -= b; a -= c; a ^= ( c >> 13 );                                              \
+  b -= c; b -= a; b ^= ( a << 8 );                                               \
+  c -= a; c -= b; c ^= ( b >> 13 );                                              \
+  a -= b; a -= c; a ^= ( c >> 12 );                                              \
+  b -= c; b -= a; b ^= ( a << 16 );                                              \
+  c -= a; c -= b; c ^= ( b >> 5 );                                               \
+  a -= b; a -= c; a ^= ( c >> 3 );                                               \
+  b -= c; b -= a; b ^= ( a << 10 );                                              \
+  c -= a; c -= b; c ^= ( b >> 15 );                                              \
+} while (0)
+
+#define UT_HASH_JEN(key,keylen,num_bkts,hashv,bkt)                                  \
+do {                                                                             \
+  unsigned _hj_i,_hj_j,_hj_k;                                                    \
+  unsigned char *_hj_key=(unsigned char*)(key);                                  \
+  hashv = 0xfeedbeef;                                                            \
+  _hj_i = _hj_j = 0x9e3779b9;                                                    \
+  _hj_k = (unsigned)keylen;                                                      \
+  while (_hj_k >= 12) {                                                          \
+    _hj_i +=    (_hj_key[0] + ( (unsigned)_hj_key[1] << 8 )                      \
+        + ( (unsigned)_hj_key[2] << 16 )                                         \
+        + ( (unsigned)_hj_key[3] << 24 ) );                                      \
+    _hj_j +=    (_hj_key[4] + ( (unsigned)_hj_key[5] << 8 )                      \
+        + ( (unsigned)_hj_key[6] << 16 )                                         \
+        + ( (unsigned)_hj_key[7] << 24 ) );                                      \
+    hashv += (_hj_key[8] + ( (unsigned)_hj_key[9] << 8 )                         \
+        + ( (unsigned)_hj_key[10] << 16 )                                        \
+        + ( (unsigned)_hj_key[11] << 24 ) );                                     \
+                                                                                 \
+     UT_HASH_JEN_MIX(_hj_i, _hj_j, hashv);                                          \
+                                                                                 \
+     _hj_key += 12;                                                              \
+     _hj_k -= 12;                                                                \
+  }                                                                              \
+  hashv += keylen;                                                               \
+  switch ( _hj_k ) {                                                             \
+     case 11: hashv += ( (unsigned)_hj_key[10] << 24 ); /* FALLTHROUGH */        \
+     case 10: hashv += ( (unsigned)_hj_key[9] << 16 );  /* FALLTHROUGH */        \
+     case 9:  hashv += ( (unsigned)_hj_key[8] << 8 );   /* FALLTHROUGH */        \
+     case 8:  _hj_j += ( (unsigned)_hj_key[7] << 24 );  /* FALLTHROUGH */        \
+     case 7:  _hj_j += ( (unsigned)_hj_key[6] << 16 );  /* FALLTHROUGH */        \
+     case 6:  _hj_j += ( (unsigned)_hj_key[5] << 8 );   /* FALLTHROUGH */        \
+     case 5:  _hj_j += _hj_key[4];                      /* FALLTHROUGH */        \
+     case 4:  _hj_i += ( (unsigned)_hj_key[3] << 24 );  /* FALLTHROUGH */        \
+     case 3:  _hj_i += ( (unsigned)_hj_key[2] << 16 );  /* FALLTHROUGH */        \
+     case 2:  _hj_i += ( (unsigned)_hj_key[1] << 8 );   /* FALLTHROUGH */        \
+     case 1:  _hj_i += _hj_key[0];                                               \
+  }                                                                              \
+  UT_HASH_JEN_MIX(_hj_i, _hj_j, hashv);                                             \
+  bkt = hashv & (num_bkts-1);                                                    \
+} while(0)
+
+/* The Paul Hsieh hash function */
+#undef get16bits
+#if (defined(__GNUC__) && defined(__i386__)) || defined(__WATCOMC__)             \
+  || defined(_MSC_VER) || defined (__BORLANDC__) || defined (__TURBOC__)
+#define get16bits(d) (*((const uint16_t *) (d)))
+#endif
+
+#if !defined (get16bits)
+#define get16bits(d) ((((uint32_t)(((const uint8_t *)(d))[1])) << 8)             \
+                       +(uint32_t)(((const uint8_t *)(d))[0]) )
+#endif
+#define UT_HASH_SFH(key,keylen,num_bkts,hashv,bkt)                                  \
+do {                                                                             \
+  unsigned char *_sfh_key=(unsigned char*)(key);                                 \
+  uint32_t _sfh_tmp, _sfh_len = keylen;                                          \
+                                                                                 \
+  int _sfh_rem = _sfh_len & 3;                                                   \
+  _sfh_len >>= 2;                                                                \
+  hashv = 0xcafebabe;                                                            \
+                                                                                 \
+  /* Main loop */                                                                \
+  for (;_sfh_len > 0; _sfh_len--) {                                              \
+    hashv    += get16bits (_sfh_key);                                            \
+    _sfh_tmp       = (uint32_t)(get16bits (_sfh_key+2)) << 11  ^ hashv;          \
+    hashv     = (hashv << 16) ^ _sfh_tmp;                                        \
+    _sfh_key += 2*sizeof (uint16_t);                                             \
+    hashv    += hashv >> 11;                                                     \
+  }                                                                              \
+                                                                                 \
+  /* Handle end cases */                                                         \
+  switch (_sfh_rem) {                                                            \
+    case 3: hashv += get16bits (_sfh_key);                                       \
+            hashv ^= hashv << 16;                                                \
+            hashv ^= (uint32_t)(_sfh_key[sizeof (uint16_t)] << 18);              \
+            hashv += hashv >> 11;                                                \
+            break;                                                               \
+    case 2: hashv += get16bits (_sfh_key);                                       \
+            hashv ^= hashv << 11;                                                \
+            hashv += hashv >> 17;                                                \
+            break;                                                               \
+    case 1: hashv += *_sfh_key;                                                  \
+            hashv ^= hashv << 10;                                                \
+            hashv += hashv >> 1;                                                 \
+  }                                                                              \
+                                                                                 \
+    /* Force "avalanching" of final 127 bits */                                  \
+    hashv ^= hashv << 3;                                                         \
+    hashv += hashv >> 5;                                                         \
+    hashv ^= hashv << 4;                                                         \
+    hashv += hashv >> 17;                                                        \
+    hashv ^= hashv << 25;                                                        \
+    hashv += hashv >> 6;                                                         \
+    bkt = hashv & (num_bkts-1);                                                  \
+} while(0) 
+
+#ifdef UT_HASH_USING_NO_STRICT_ALIASING
+/* The MurmurHash exploits some CPU's (x86,x86_64) tolerance for unaligned reads.
+ * For other types of CPU's (e.g. Sparc) an unaligned read causes a bus error.
+ * MurmurHash uses the faster approach only on CPU's where we know it's safe. 
+ *
+ * Note the preprocessor built-in defines can be emitted using:
+ *
+ *   gcc -m64 -dM -E - < /dev/null                  (on gcc)
+ *   cc -## a.c (where a.c is a simple test file)   (Sun Studio)
+ */
+#if (defined(__i386__) || defined(__x86_64__)  || defined(_M_IX86))
+#define MUR_GETBLOCK(p,i) p[i]
+#else /* non intel */
+#define MUR_PLUS0_ALIGNED(p) (((unsigned long)p & 0x3) == 0)
+#define MUR_PLUS1_ALIGNED(p) (((unsigned long)p & 0x3) == 1)
+#define MUR_PLUS2_ALIGNED(p) (((unsigned long)p & 0x3) == 2)
+#define MUR_PLUS3_ALIGNED(p) (((unsigned long)p & 0x3) == 3)
+#define WP(p) ((uint32_t*)((unsigned long)(p) & ~3UL))
+#if (defined(__BIG_ENDIAN__) || defined(SPARC) || defined(__ppc__) || defined(__ppc64__))
+#define MUR_THREE_ONE(p) ((((*WP(p))&0x00ffffff) << 8) | (((*(WP(p)+1))&0xff000000) >> 24))
+#define MUR_TWO_TWO(p)   ((((*WP(p))&0x0000ffff) <<16) | (((*(WP(p)+1))&0xffff0000) >> 16))
+#define MUR_ONE_THREE(p) ((((*WP(p))&0x000000ff) <<24) | (((*(WP(p)+1))&0xffffff00) >>  8))
+#else /* assume little endian non-intel */
+#define MUR_THREE_ONE(p) ((((*WP(p))&0xffffff00) >> 8) | (((*(WP(p)+1))&0x000000ff) << 24))
+#define MUR_TWO_TWO(p)   ((((*WP(p))&0xffff0000) >>16) | (((*(WP(p)+1))&0x0000ffff) << 16))
+#define MUR_ONE_THREE(p) ((((*WP(p))&0xff000000) >>24) | (((*(WP(p)+1))&0x00ffffff) <<  8))
+#endif
+#define MUR_GETBLOCK(p,i) (MUR_PLUS0_ALIGNED(p) ? ((p)[i]) :           \
+                            (MUR_PLUS1_ALIGNED(p) ? MUR_THREE_ONE(p) : \
+                             (MUR_PLUS2_ALIGNED(p) ? MUR_TWO_TWO(p) :  \
+                                                      MUR_ONE_THREE(p))))
+#endif
+#define MUR_ROTL32(x,r) (((x) << (r)) | ((x) >> (32 - (r))))
+#define MUR_FMIX(_h) \
+do {                 \
+  _h ^= _h >> 16;    \
+  _h *= 0x85ebca6b;  \
+  _h ^= _h >> 13;    \
+  _h *= 0xc2b2ae35l; \
+  _h ^= _h >> 16;    \
+} while(0)
+
+#define UT_HASH_MUR(key,keylen,num_bkts,hashv,bkt)                        \
+do {                                                                   \
+  const uint8_t *_mur_data = (const uint8_t*)(key);                    \
+  const int _mur_nblocks = (keylen) / 4;                               \
+  uint32_t _mur_h1 = 0xf88D5353;                                       \
+  uint32_t _mur_c1 = 0xcc9e2d51;                                       \
+  uint32_t _mur_c2 = 0x1b873593;                                       \
+  uint32_t _mur_k1 = 0;                                                \
+  const uint8_t *_mur_tail;                                            \
+  const uint32_t *_mur_blocks = (const uint32_t*)(_mur_data+_mur_nblocks*4); \
+  int _mur_i;                                                          \
+  for(_mur_i = -_mur_nblocks; _mur_i; _mur_i++) {                      \
+    _mur_k1 = MUR_GETBLOCK(_mur_blocks,_mur_i);                        \
+    _mur_k1 *= _mur_c1;                                                \
+    _mur_k1 = MUR_ROTL32(_mur_k1,15);                                  \
+    _mur_k1 *= _mur_c2;                                                \
+                                                                       \
+    _mur_h1 ^= _mur_k1;                                                \
+    _mur_h1 = MUR_ROTL32(_mur_h1,13);                                  \
+    _mur_h1 = _mur_h1*5+0xe6546b64;                                    \
+  }                                                                    \
+  _mur_tail = (const uint8_t*)(_mur_data + _mur_nblocks*4);            \
+  _mur_k1=0;                                                           \
+  switch((keylen) & 3) {                                               \
+    case 3: _mur_k1 ^= _mur_tail[2] << 16;                             \
+    case 2: _mur_k1 ^= _mur_tail[1] << 8;                              \
+    case 1: _mur_k1 ^= _mur_tail[0];                                   \
+    _mur_k1 *= _mur_c1;                                                \
+    _mur_k1 = MUR_ROTL32(_mur_k1,15);                                  \
+    _mur_k1 *= _mur_c2;                                                \
+    _mur_h1 ^= _mur_k1;                                                \
+  }                                                                    \
+  _mur_h1 ^= (keylen);                                                 \
+  MUR_FMIX(_mur_h1);                                                   \
+  hashv = _mur_h1;                                                     \
+  bkt = hashv & (num_bkts-1);                                          \
+} while(0)
+#endif  /* UT_HASH_USING_NO_STRICT_ALIASING */
+
+/* key comparison function; return 0 if keys equal */
+#define UT_HASH_KEYCMP(a,b,len) memcmp(a,b,len) 
+
+/* iterate over items in a known bucket to find desired item */
+#define UT_HASH_FIND_IN_BKT(tbl,hh,head,keyptr,keylen_in,out)                       \
+do {                                                                             \
+ if (head.hh_head) DECLTYPE_ASSIGN(out,ELMT_FROM_HH(tbl,head.hh_head));          \
+ else out=NULL;                                                                  \
+ while (out) {                                                                   \
+    if ((out)->hh.keylen == keylen_in) {                                           \
+        if ((UT_HASH_KEYCMP((out)->hh.key,keyptr,keylen_in)) == 0) break;             \
+    }                                                                            \
+    if ((out)->hh.hh_next) DECLTYPE_ASSIGN(out,ELMT_FROM_HH(tbl,(out)->hh.hh_next)); \
+    else out = NULL;                                                             \
+ }                                                                               \
+} while(0)
+
+/* add an item to a bucket  */
+#define UT_HASH_ADD_TO_BKT(head,addhh)                                              \
+do {                                                                             \
+ head.count++;                                                                   \
+ (addhh)->hh_next = head.hh_head;                                                \
+ (addhh)->hh_prev = NULL;                                                        \
+ if (head.hh_head) { (head).hh_head->hh_prev = (addhh); }                        \
+ (head).hh_head=addhh;                                                           \
+ if (head.count >= ((head.expand_mult+1) * UT_HASH_BKT_CAPACITY_THRESH)             \
+     && (addhh)->tbl->noexpand != 1) {                                           \
+       UT_HASH_EXPAND_BUCKETS((addhh)->tbl);                                        \
+ }                                                                               \
+} while(0)
+
+/* remove an item from a given bucket */
+#define UT_HASH_DEL_IN_BKT(hh,head,hh_del)                                          \
+    (head).count--;                                                              \
+    if ((head).hh_head == hh_del) {                                              \
+      (head).hh_head = hh_del->hh_next;                                          \
+    }                                                                            \
+    if (hh_del->hh_prev) {                                                       \
+        hh_del->hh_prev->hh_next = hh_del->hh_next;                              \
+    }                                                                            \
+    if (hh_del->hh_next) {                                                       \
+        hh_del->hh_next->hh_prev = hh_del->hh_prev;                              \
+    }                                                                
+
+/* Bucket expansion has the effect of doubling the number of buckets
+ * and redistributing the items into the new buckets. Ideally the
+ * items will distribute more or less evenly into the new buckets
+ * (the extent to which this is true is a measure of the quality of
+ * the hash function as it applies to the key domain). 
+ * 
+ * With the items distributed into more buckets, the chain length
+ * (item count) in each bucket is reduced. Thus by expanding buckets
+ * the hash keeps a bound on the chain length. This bounded chain 
+ * length is the essence of how a hash provides constant time lookup.
+ * 
+ * The calculation of tbl->ideal_chain_maxlen below deserves some
+ * explanation. First, keep in mind that we're calculating the ideal
+ * maximum chain length based on the *new* (doubled) bucket count.
+ * In fractions this is just n/b (n=number of items,b=new num buckets).
+ * Since the ideal chain length is an integer, we want to calculate 
+ * ceil(n/b). We don't depend on floating point arithmetic in this
+ * hash, so to calculate ceil(n/b) with integers we could write
+ * 
+ *      ceil(n/b) = (n/b) + ((n%b)?1:0)
+ * 
+ * and in fact a previous version of this hash did just that.
+ * But now we have improved things a bit by recognizing that b is
+ * always a power of two. We keep its base 2 log handy (call it lb),
+ * so now we can write this with a bit shift and logical AND:
+ * 
+ *      ceil(n/b) = (n>>lb) + ( (n & (b-1)) ? 1:0)
+ * 
+ */
+#define UT_HASH_EXPAND_BUCKETS(tbl)                                                 \
+do {                                                                             \
+    unsigned _he_bkt;                                                            \
+    unsigned _he_bkt_i;                                                          \
+    struct UT_hash_handle *_he_thh, *_he_hh_nxt;                                 \
+    UT_hash_bucket *_he_new_buckets, *_he_newbkt;                                \
+    _he_new_buckets = (UT_hash_bucket*)uthash_malloc(                            \
+             2 * tbl->num_buckets * sizeof(struct UT_hash_bucket));              \
+    if (!_he_new_buckets) { uthash_fatal( "out of memory"); }                    \
+    memset(_he_new_buckets, 0,                                                   \
+            2 * tbl->num_buckets * sizeof(struct UT_hash_bucket));               \
+    tbl->ideal_chain_maxlen =                                                    \
+       (tbl->num_items >> (tbl->log2_num_buckets+1)) +                           \
+       ((tbl->num_items & ((tbl->num_buckets*2)-1)) ? 1 : 0);                    \
+    tbl->nonideal_items = 0;                                                     \
+    for(_he_bkt_i = 0; _he_bkt_i < tbl->num_buckets; _he_bkt_i++)                \
+    {                                                                            \
+        _he_thh = tbl->buckets[ _he_bkt_i ].hh_head;                             \
+        while (_he_thh) {                                                        \
+           _he_hh_nxt = _he_thh->hh_next;                                        \
+           UT_HASH_TO_BKT( _he_thh->hashv, tbl->num_buckets*2, _he_bkt);            \
+           _he_newbkt = &(_he_new_buckets[ _he_bkt ]);                           \
+           if (++(_he_newbkt->count) > tbl->ideal_chain_maxlen) {                \
+             tbl->nonideal_items++;                                              \
+             _he_newbkt->expand_mult = _he_newbkt->count /                       \
+                                        tbl->ideal_chain_maxlen;                 \
+           }                                                                     \
+           _he_thh->hh_prev = NULL;                                              \
+           _he_thh->hh_next = _he_newbkt->hh_head;                               \
+           if (_he_newbkt->hh_head) _he_newbkt->hh_head->hh_prev =               \
+                _he_thh;                                                         \
+           _he_newbkt->hh_head = _he_thh;                                        \
+           _he_thh = _he_hh_nxt;                                                 \
+        }                                                                        \
+    }                                                                            \
+    uthash_free( tbl->buckets, tbl->num_buckets*sizeof(struct UT_hash_bucket) ); \
+    tbl->num_buckets *= 2;                                                       \
+    tbl->log2_num_buckets++;                                                     \
+    tbl->buckets = _he_new_buckets;                                              \
+    tbl->ineff_expands = (tbl->nonideal_items > (tbl->num_items >> 1)) ?         \
+        (tbl->ineff_expands+1) : 0;                                              \
+    if (tbl->ineff_expands > 1) {                                                \
+        tbl->noexpand=1;                                                         \
+        uthash_noexpand_fyi(tbl);                                                \
+    }                                                                            \
+    uthash_expand_fyi(tbl);                                                      \
+} while(0)
+
+
+/* This is an adaptation of Simon Tatham's O(n log(n)) mergesort */
+/* Note that UT_HASH_SORT assumes the hash handle name to be hh. 
+ * UT_HASH_SRT was added to allow the hash handle name to be passed in. */
+#define UT_HASH_SORT(head,cmpfcn) UT_HASH_SRT(hh,head,cmpfcn)
+#define UT_HASH_SRT(hh,head,cmpfcn)                                                 \
+do {                                                                             \
+  unsigned _hs_i;                                                                \
+  unsigned _hs_looping,_hs_nmerges,_hs_insize,_hs_psize,_hs_qsize;               \
+  struct UT_hash_handle *_hs_p, *_hs_q, *_hs_e, *_hs_list, *_hs_tail;            \
+  if (head) {                                                                    \
+      _hs_insize = 1;                                                            \
+      _hs_looping = 1;                                                           \
+      _hs_list = &((head)->hh);                                                  \
+      while (_hs_looping) {                                                      \
+          _hs_p = _hs_list;                                                      \
+          _hs_list = NULL;                                                       \
+          _hs_tail = NULL;                                                       \
+          _hs_nmerges = 0;                                                       \
+          while (_hs_p) {                                                        \
+              _hs_nmerges++;                                                     \
+              _hs_q = _hs_p;                                                     \
+              _hs_psize = 0;                                                     \
+              for ( _hs_i = 0; _hs_i  < _hs_insize; _hs_i++ ) {                  \
+                  _hs_psize++;                                                   \
+                  _hs_q = (UT_hash_handle*)((_hs_q->next) ?                      \
+                          ((void*)((char*)(_hs_q->next) +                        \
+                          (head)->hh.tbl->hho)) : NULL);                         \
+                  if (! (_hs_q) ) break;                                         \
+              }                                                                  \
+              _hs_qsize = _hs_insize;                                            \
+              while ((_hs_psize > 0) || ((_hs_qsize > 0) && _hs_q )) {           \
+                  if (_hs_psize == 0) {                                          \
+                      _hs_e = _hs_q;                                             \
+                      _hs_q = (UT_hash_handle*)((_hs_q->next) ?                  \
+                              ((void*)((char*)(_hs_q->next) +                    \
+                              (head)->hh.tbl->hho)) : NULL);                     \
+                      _hs_qsize--;                                               \
+                  } else if ( (_hs_qsize == 0) || !(_hs_q) ) {                   \
+                      _hs_e = _hs_p;                                             \
+                      _hs_p = (UT_hash_handle*)((_hs_p->next) ?                  \
+                              ((void*)((char*)(_hs_p->next) +                    \
+                              (head)->hh.tbl->hho)) : NULL);                     \
+                      _hs_psize--;                                               \
+                  } else if ((                                                   \
+                      cmpfcn(DECLTYPE(head)(ELMT_FROM_HH((head)->hh.tbl,_hs_p)), \
+                             DECLTYPE(head)(ELMT_FROM_HH((head)->hh.tbl,_hs_q))) \
+                             ) <= 0) {                                           \
+                      _hs_e = _hs_p;                                             \
+                      _hs_p = (UT_hash_handle*)((_hs_p->next) ?                  \
+                              ((void*)((char*)(_hs_p->next) +                    \
+                              (head)->hh.tbl->hho)) : NULL);                     \
+                      _hs_psize--;                                               \
+                  } else {                                                       \
+                      _hs_e = _hs_q;                                             \
+                      _hs_q = (UT_hash_handle*)((_hs_q->next) ?                  \
+                              ((void*)((char*)(_hs_q->next) +                    \
+                              (head)->hh.tbl->hho)) : NULL);                     \
+                      _hs_qsize--;                                               \
+                  }                                                              \
+                  if ( _hs_tail ) {                                              \
+                      _hs_tail->next = ((_hs_e) ?                                \
+                            ELMT_FROM_HH((head)->hh.tbl,_hs_e) : NULL);          \
+                  } else {                                                       \
+                      _hs_list = _hs_e;                                          \
+                  }                                                              \
+                  _hs_e->prev = ((_hs_tail) ?                                    \
+                     ELMT_FROM_HH((head)->hh.tbl,_hs_tail) : NULL);              \
+                  _hs_tail = _hs_e;                                              \
+              }                                                                  \
+              _hs_p = _hs_q;                                                     \
+          }                                                                      \
+          _hs_tail->next = NULL;                                                 \
+          if ( _hs_nmerges <= 1 ) {                                              \
+              _hs_looping=0;                                                     \
+              (head)->hh.tbl->tail = _hs_tail;                                   \
+              DECLTYPE_ASSIGN(head,ELMT_FROM_HH((head)->hh.tbl, _hs_list));      \
+          }                                                                      \
+          _hs_insize *= 2;                                                       \
+      }                                                                          \
+      UT_HASH_FSCK(hh,head);                                                        \
+ }                                                                               \
+} while (0)
+
+/* This function selects items from one hash into another hash. 
+ * The end result is that the selected items have dual presence 
+ * in both hashes. There is no copy of the items made; rather 
+ * they are added into the new hash through a secondary hash 
+ * hash handle that must be present in the structure. */
+#define UT_HASH_SELECT(hh_dst, dst, hh_src, src, cond)                              \
+do {                                                                             \
+  unsigned _src_bkt, _dst_bkt;                                                   \
+  void *_last_elt=NULL, *_elt;                                                   \
+  UT_hash_handle *_src_hh, *_dst_hh, *_last_elt_hh=NULL;                         \
+  ptrdiff_t _dst_hho = ((char*)(&(dst)->hh_dst) - (char*)(dst));                 \
+  if (src) {                                                                     \
+    for(_src_bkt=0; _src_bkt < (src)->hh_src.tbl->num_buckets; _src_bkt++) {     \
+      for(_src_hh = (src)->hh_src.tbl->buckets[_src_bkt].hh_head;                \
+          _src_hh;                                                               \
+          _src_hh = _src_hh->hh_next) {                                          \
+          _elt = ELMT_FROM_HH((src)->hh_src.tbl, _src_hh);                       \
+          if (cond(_elt)) {                                                      \
+            _dst_hh = (UT_hash_handle*)(((char*)_elt) + _dst_hho);               \
+            _dst_hh->key = _src_hh->key;                                         \
+            _dst_hh->keylen = _src_hh->keylen;                                   \
+            _dst_hh->hashv = _src_hh->hashv;                                     \
+            _dst_hh->prev = _last_elt;                                           \
+            _dst_hh->next = NULL;                                                \
+            if (_last_elt_hh) { _last_elt_hh->next = _elt; }                     \
+            if (!dst) {                                                          \
+              DECLTYPE_ASSIGN(dst,_elt);                                         \
+              UT_HASH_MAKE_TABLE(hh_dst,dst);                                       \
+            } else {                                                             \
+              _dst_hh->tbl = (dst)->hh_dst.tbl;                                  \
+            }                                                                    \
+            UT_HASH_TO_BKT(_dst_hh->hashv, _dst_hh->tbl->num_buckets, _dst_bkt);    \
+            UT_HASH_ADD_TO_BKT(_dst_hh->tbl->buckets[_dst_bkt],_dst_hh);            \
+            (dst)->hh_dst.tbl->num_items++;                                      \
+            _last_elt = _elt;                                                    \
+            _last_elt_hh = _dst_hh;                                              \
+          }                                                                      \
+      }                                                                          \
+    }                                                                            \
+  }                                                                              \
+  UT_HASH_FSCK(hh_dst,dst);                                                         \
+} while (0)
+
+#define UT_HASH_CLEAR(hh,head)                                                      \
+do {                                                                             \
+  if (head) {                                                                    \
+    uthash_free((head)->hh.tbl->buckets,                                         \
+                (head)->hh.tbl->num_buckets*sizeof(struct UT_hash_bucket));      \
+    UT_HASH_BLOOM_FREE((head)->hh.tbl);                                             \
+    uthash_free((head)->hh.tbl, sizeof(UT_hash_table));                          \
+    (head)=NULL;                                                                 \
+  }                                                                              \
+} while(0)
+
+#define UT_HASH_OVERHEAD(hh,head)                                                   \
+ (size_t)((((head)->hh.tbl->num_items   * sizeof(UT_hash_handle))   +            \
+           ((head)->hh.tbl->num_buckets * sizeof(UT_hash_bucket))   +            \
+            (sizeof(UT_hash_table))                                 +            \
+            (UT_HASH_BLOOM_BYTELEN)))
+
+#ifdef NO_DECLTYPE
+#define UT_HASH_ITER(hh,head,el,tmp)                                                \
+for((el)=(head), (*(char**)(&(tmp)))=(char*)((head)?(head)->hh.next:NULL);       \
+  el; (el)=(tmp),(*(char**)(&(tmp)))=(char*)((tmp)?(tmp)->hh.next:NULL)) 
+#else
+#define UT_HASH_ITER(hh,head,el,tmp)                                                \
+for((el)=(head),(tmp)=DECLTYPE(el)((head)?(head)->hh.next:NULL);                 \
+  el; (el)=(tmp),(tmp)=DECLTYPE(el)((tmp)?(tmp)->hh.next:NULL))
+#endif
+
+/* obtain a count of items in the hash */
+#define UT_HASH_COUNT(head) UT_HASH_CNT(hh,head) 
+#define UT_HASH_CNT(hh,head) ((head)?((head)->hh.tbl->num_items):0)
+
+typedef struct UT_hash_bucket {
+   struct UT_hash_handle *hh_head;
+   unsigned count;
+
+   /* expand_mult is normally set to 0. In this situation, the max chain length
+    * threshold is enforced at its default value, UT_HASH_BKT_CAPACITY_THRESH. (If
+    * the bucket's chain exceeds this length, bucket expansion is triggered). 
+    * However, setting expand_mult to a non-zero value delays bucket expansion
+    * (that would be triggered by additions to this particular bucket)
+    * until its chain length reaches a *multiple* of UT_HASH_BKT_CAPACITY_THRESH.
+    * (The multiplier is simply expand_mult+1). The whole idea of this
+    * multiplier is to reduce bucket expansions, since they are expensive, in
+    * situations where we know that a particular bucket tends to be overused.
+    * It is better to let its chain length grow to a longer yet-still-bounded
+    * value, than to do an O(n) bucket expansion too often. 
+    */
+   unsigned expand_mult;
+
+} UT_hash_bucket;
+
+/* random signature used only to find hash tables in external analysis */
+#define UT_HASH_SIGNATURE 0xa0111fe1
+#define UT_HASH_BLOOM_SIGNATURE 0xb12220f2
+
+typedef struct UT_hash_table {
+   UT_hash_bucket *buckets;
+   unsigned num_buckets, log2_num_buckets;
+   unsigned num_items;
+   struct UT_hash_handle *tail; /* tail hh in app order, for fast append    */
+   ptrdiff_t hho; /* hash handle offset (byte pos of hash handle in element */
+
+   /* in an ideal situation (all buckets used equally), no bucket would have
+    * more than ceil(#items/#buckets) items. that's the ideal chain length. */
+   unsigned ideal_chain_maxlen;
+
+   /* nonideal_items is the number of items in the hash whose chain position
+    * exceeds the ideal chain maxlen. these items pay the penalty for an uneven
+    * hash distribution; reaching them in a chain traversal takes >ideal steps */
+   unsigned nonideal_items;
+
+   /* ineffective expands occur when a bucket doubling was performed, but 
+    * afterward, more than half the items in the hash had nonideal chain
+    * positions. If this happens on two consecutive expansions we inhibit any
+    * further expansion, as it's not helping; this happens when the hash
+    * function isn't a good fit for the key domain. When expansion is inhibited
+    * the hash will still work, albeit no longer in constant time. */
+   unsigned ineff_expands, noexpand;
+
+   uint32_t signature; /* used only to find hash tables in external analysis */
+#ifdef UT_HASH_BLOOM
+   uint32_t bloom_sig; /* used only to test bloom exists in external analysis */
+   uint8_t *bloom_bv;
+   char bloom_nbits;
+#endif
+
+} UT_hash_table;
+
+typedef struct UT_hash_handle {
+   struct UT_hash_table *tbl;
+   void *prev;                       /* prev element in app order      */
+   void *next;                       /* next element in app order      */
+   struct UT_hash_handle *hh_prev;   /* previous hh in bucket order    */
+   struct UT_hash_handle *hh_next;   /* next hh in bucket order        */
+   void *key;                        /* ptr to enclosing struct's key  */
+   unsigned keylen;                  /* enclosing struct's key len     */
+   unsigned hashv;                   /* result of hash-fcn(key)        */
+} UT_hash_handle;
+
+#endif /* UT_HASH_H */
diff -pruN 8.0.1-5/src/version.rc.in 8.2.0~beta1-1~exp1/src/version.rc.in
--- 8.0.1-5/src/version.rc.in	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/version.rc.in	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,53 @@
+#include "winres.h"
+
+#define VER_FILEVERSION             @MapServer_VERSION_MAJOR@,@MapServer_VERSION_MINOR@,@MapServer_VERSION_REVISION@,0
+#define VER_FILEVERSION_STR         "@MapServer_VERSION_STRING@\0"
+
+#define VER_PRODUCTVERSION             @MapServer_VERSION_MAJOR@,@MapServer_VERSION_MINOR@,@MapServer_VERSION_REVISION@,0
+#define VER_PRODUCTVERSION_STR         "@MapServer_VERSION_STRING@\0"
+
+#ifndef DEBUG
+#define VER_DEBUG                   0
+#else
+#define VER_DEBUG                   VS_FF_DEBUG
+#endif
+
+VS_VERSION_INFO VERSIONINFO
+	FILEVERSION    	VER_FILEVERSION
+	PRODUCTVERSION 	VER_PRODUCTVERSION
+    FILEFLAGSMASK VS_FFI_FILEFLAGSMASK
+	FILEFLAGS      	VER_DEBUG
+    FILEOS VOS__WINDOWS32
+    FILETYPE VFT_DLL
+    FILESUBTYPE VFT2_UNKNOWN
+BEGIN
+    BLOCK "StringFileInfo"
+    BEGIN
+        BLOCK "040904E4"
+        BEGIN
+            VALUE "CompanyName",      "MapServer"
+            VALUE "FileDescription",  "MapServer"
+            VALUE "FileVersion",      VER_FILEVERSION_STR
+            VALUE "InternalName",     ""
+            VALUE "LegalCopyright",   "Copyright (c) 2017 MapServer"
+            VALUE "LegalTrademarks1", ""
+            VALUE "LegalTrademarks2", ""
+            VALUE "OriginalFilename", ""
+            VALUE "ProductName",      "MapServer"
+            VALUE "ProductVersion",   VER_PRODUCTVERSION_STR
+        END
+    END
+
+    BLOCK "VarFileInfo"
+    BEGIN
+        /* The following line should only be modified for localized versions.     */
+        /* It consists of any number of WORD,WORD pairs, with each pair           */
+        /* describing a language,codepage combination supported by the file.      */
+        /*                                                                        */
+        /* For example, a file might have values "0x409,1252" indicating that it  */
+        /* supports English language (0x409) in the Windows ANSI codepage (1252). */
+
+        VALUE "Translation", 0x409, 1252
+
+    END
+END
\ No newline at end of file
diff -pruN 8.0.1-5/src/xmlmapfile/mapfile.xsd 8.2.0~beta1-1~exp1/src/xmlmapfile/mapfile.xsd
--- 8.0.1-5/src/xmlmapfile/mapfile.xsd	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/xmlmapfile/mapfile.xsd	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,844 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:ms="http://www.mapserver.org/mapserver" targetNamespace="http://www.mapserver.org/mapserver" elementFormDefault="qualified" attributeFormDefault="unqualified" version="6.2.1">
+	<!-- Definition of types -->
+	<xs:simpleType name="rgbColorValueType">
+		<xs:restriction base="xs:integer">
+			<xs:minInclusive value="-1"/>
+			<xs:maxInclusive value="255"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:complexType name="rgbColorType">
+		<xs:attribute name="red" type="ms:rgbColorValueType" use="required"/>
+		<xs:attribute name="green" type="ms:rgbColorValueType" use="required"/>
+		<xs:attribute name="blue" type="ms:rgbColorValueType" use="required"/>
+	</xs:complexType>
+	<xs:simpleType name="rgbColorExtendedValueType">
+		<xs:restriction base="xs:integer">
+			<xs:minInclusive value="-1"/>
+			<xs:maxInclusive value="255"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:complexType name="rgbExtendedColorType">
+		<xs:attribute name="red" type="ms:rgbColorExtendedValueType" use="required"/>
+		<xs:attribute name="green" type="ms:rgbColorExtendedValueType" use="required"/>
+		<xs:attribute name="blue" type="ms:rgbColorExtendedValueType" use="required"/>
+	</xs:complexType>
+	<xs:simpleType name="stateEnum">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="ON"/>
+			<xs:enumeration value="OFF"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="embedStateEnum">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="EMBED"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="stateEnumUnion">
+		<xs:union memberTypes="ms:stateEnum ms:embedStateEnum"/>
+	</xs:simpleType>
+	<xs:simpleType name="booleanEnum">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="TRUE"/>
+			<xs:enumeration value="FALSE"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="positionEnum">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="UL"/>
+			<xs:enumeration value="UC"/>
+			<xs:enumeration value="UR"/>
+			<xs:enumeration value="LL"/>
+			<xs:enumeration value="LC"/>
+			<xs:enumeration value="LR"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="fullPositionEnum">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="CL"/>
+			<xs:enumeration value="CC"/>
+			<xs:enumeration value="CR"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:complexType name="sizeType">
+		<xs:attribute name="x" type="xs:nonNegativeInteger"/>
+		<xs:attribute name="y" type="xs:nonNegativeInteger"/>
+	</xs:complexType>
+	<xs:complexType name="dataRangeType">
+		<xs:attribute name="min" type="xs:double"/>
+		<xs:attribute name="max" type="xs:double"/>
+	</xs:complexType>
+	<xs:complexType name="colorRangeType">
+		<xs:attribute name="rgbColorStart" type="xs:string" use="required"/>
+		<xs:attribute name="rgbColorEnd" type="xs:string" use="required"/>
+		<xs:attribute name="rangeItem" type="xs:string" use="required"/>
+	</xs:complexType>
+	<xs:complexType name="pointType">
+		<xs:attribute name="x" type="xs:float"/>
+		<xs:attribute name="y" type="xs:float"/>
+	</xs:complexType>
+	<xs:simpleType name="angleType">
+		<xs:restriction base="xs:double">
+			<xs:minInclusive value="-360"/>
+			<xs:maxInclusive value="360"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="attributeType">
+		<xs:restriction base="xs:string">
+			<xs:pattern value="\[.+\]"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="debugModeEnum">
+		<xs:restriction base="xs:string">
+			<xs:pattern value="[oO][nN]|[oO][fF][fF]|1|2|3|4|5"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="unitType">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="FEET"/>
+			<xs:enumeration value="INCHES"/>
+			<xs:enumeration value="KILOMETERS"/>
+			<xs:enumeration value="METERS"/>
+			<xs:enumeration value="MILES"/>
+			<xs:enumeration value="NAUTICALMILES"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="extendedUnitType">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="PIXELS"/>
+			<xs:enumeration value="DD"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:simpleType name="unitTypeUnion">
+		<xs:union memberTypes="ms:unitType ms:extendedUnitType"/>
+	</xs:simpleType>
+	<xs:complexType name="itemType">
+		<xs:sequence>
+			<xs:element name="item" minOccurs="0" maxOccurs="unbounded">
+				<xs:complexType>
+					<xs:simpleContent>
+						<xs:extension base="xs:string">
+							<xs:attribute name="name" type="xs:string" use="required"/>
+						</xs:extension>
+					</xs:simpleContent>
+				</xs:complexType>
+			</xs:element>
+		</xs:sequence>
+	</xs:complexType>
+	<xs:simpleType name="alignEnum">
+		<xs:restriction base="xs:string">
+			<xs:enumeration value="LEFT"/>
+			<xs:enumeration value="CENTER"/>
+			<xs:enumeration value="RIGHT"/>
+		</xs:restriction>
+	</xs:simpleType>
+	<xs:complexType name="expressionType">
+		<xs:simpleContent>
+			<xs:extension base="xs:string">
+				<xs:attribute name="type" default="CONSTANT">
+					<xs:simpleType>
+						<xs:restriction base="xs:string">
+							<xs:enumeration value="CONSTANT"/>
+							<xs:enumeration value="REGEX"/>
+							<xs:enumeration value="MSEXPR"/>
+						</xs:restriction>
+					</xs:simpleType>
+				</xs:attribute>
+			</xs:extension>
+		</xs:simpleContent>
+	</xs:complexType>
+	<xs:complexType name="symbolType">
+		<xs:simpleContent>
+			<xs:extension base="xs:string">
+				<xs:attribute name="type" default="ID">
+					<xs:simpleType>
+						<xs:restriction base="xs:string">
+							<xs:enumeration value="ID"/>
+							<xs:enumeration value="NAME"/>
+						</xs:restriction>
+					</xs:simpleType>
+				</xs:attribute>
+			</xs:extension>
+		</xs:simpleContent>
+	</xs:complexType>
+	<!-- Definition of Mapfile elements -->
+	<!-- QUERYMAP Definition -->
+	<xs:complexType name="QueryMap">
+		<xs:all>
+			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
+			<xs:element name="style" minOccurs="0">
+				<xs:simpleType>
+					<xs:restriction base="xs:string">
+						<xs:enumeration value="NORMAL"/>
+						<xs:enumeration value="HILITE"/>
+						<xs:enumeration value="SELECTED"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+		</xs:all>
+		<xs:attribute name="status" type="ms:stateEnum"/>
+	</xs:complexType>
+	<!-- WEB Definition -->
+	<xs:complexType name="Web">
+		<xs:sequence>
+			<xs:element name="browseFormat" type="xs:string" minOccurs="0"/>
+			<xs:element name="empty" type="xs:string" minOccurs="0"/>
+			<xs:element name="error" type="xs:string" minOccurs="0"/>
+			<xs:element name="footer" type="xs:string" minOccurs="0"/>
+			<xs:element name="header" type="xs:string" minOccurs="0"/>
+			<xs:element name="imagePath" type="xs:string" minOccurs="0"/>
+			<xs:element name="tempPath" type="xs:string" minOccurs="0"/>
+			<xs:element name="imageUrl" type="xs:string" minOccurs="0"/>
+			<xs:element name="legendFormat" type="xs:string" minOccurs="0"/>
+			<xs:element name="log" type="xs:string" minOccurs="0"/>
+			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="maxTemplate" type="xs:string" minOccurs="0"/>
+			<xs:element name="Metadata" type="ms:itemType" minOccurs="0"/>
+			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="minTemplate" type="xs:string" minOccurs="0"/>
+			<xs:element name="queryFormat" type="xs:string" minOccurs="0"/>
+			<xs:element name="template" type="xs:string" minOccurs="0"/>
+			<xs:element name="Validation" type="ms:itemType" minOccurs="0"/>
+		</xs:sequence>
+	</xs:complexType>
+	<!-- OUTPUTFORMAT Definition -->
+	<xs:complexType name="OutputFormat">
+		<xs:sequence>
+			<xs:element name="driver" type="xs:string" minOccurs="0"/>
+			<xs:element name="extension" type="xs:string" minOccurs="0"/>
+			<xs:element name="formatOption" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
+			<xs:element name="imageMode">
+				<xs:simpleType>
+					<xs:restriction base="xs:string">
+						<xs:enumeration value="PC256"/>
+						<xs:enumeration value="RGB"/>
+						<xs:enumeration value="RGBA"/>
+						<xs:enumeration value="BYTE"/>
+						<xs:enumeration value="INT16"/>
+						<xs:enumeration value="FLOAT32"/>
+						<xs:enumeration value="FEATURE"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="mimeType" type="xs:string" minOccurs="0"/>
+			<xs:element name="transparent" type="ms:stateEnum" minOccurs="0"/>
+		</xs:sequence>
+		<xs:attribute name="name" type="xs:string"/>
+	</xs:complexType>
+	<!-- LEGEND Definition -->
+	<xs:complexType name="Legend">
+		<xs:all>
+			<xs:element name="imageColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="keySize" type="ms:sizeType" minOccurs="0"/>
+			<xs:element name="keySpacing" type="ms:sizeType" minOccurs="0"/>
+			<xs:element name="Label" type="ms:Label" minOccurs="0"/>
+			<xs:element name="outlineColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="position" type="ms:positionEnum" minOccurs="0"/>
+			<xs:element name="postLabelCache" type="ms:booleanEnum" minOccurs="0"/>
+			<xs:element name="template" type="xs:string" minOccurs="0"/>
+		</xs:all>
+		<xs:attribute name="status" type="ms:stateEnumUnion"/>
+	</xs:complexType>
+	<!-- SCALEBAR Definition -->
+	<xs:complexType name="ScaleBar">
+		<xs:sequence>
+			<xs:element name="align" type="ms:alignEnum" minOccurs="0" default="CENTER"/>
+			<xs:element name="backgroundColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="imageColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="intervals" type="xs:positiveInteger" default="4" minOccurs="0"/>
+			<xs:element name="Label" type="ms:Label" minOccurs="0"/>
+			<xs:element name="outlineColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="position" type="ms:positionEnum" default="LR" minOccurs="0"/>
+			<xs:element name="postLabelCache" type="ms:booleanEnum" default="FALSE" minOccurs="0"/>
+			<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
+			<xs:element name="style" minOccurs="0">
+				<xs:simpleType>
+					<xs:restriction base="xs:integer">
+						<xs:minInclusive value="0"/>
+						<xs:maxInclusive value="1"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="transparent" type="ms:stateEnum" minOccurs="0"/>
+			<xs:element name="units" type="ms:unitType" default="MILES" minOccurs="0"/>
+		</xs:sequence>
+		<xs:attribute name="status" type="ms:stateEnumUnion" default="OFF"/>
+	</xs:complexType>
+	<!-- LABEL Definition -->
+	<xs:complexType name="Label">
+		<xs:sequence>
+			<xs:element name="align" type="ms:alignEnum" minOccurs="0"/>
+			<xs:element name="angle" minOccurs="0">
+				<xs:simpleType id="labelAngleType">
+					<xs:union memberTypes="ms:angleType ms:attributeType">
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:pattern value="[aA][uU][tT][oO]|[fF][oO][lL][lL][oO][wW]|[aA][uU][tT][oO]2"/>
+								<!-- attribute -->
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="antialias" type="ms:booleanEnum" minOccurs="0"/>
+			<xs:element name="buffer" type="xs:integer" minOccurs="0"/>
+			<xs:choice minOccurs="0">
+				<xs:element name="color" type="ms:rgbColorType"/>
+				<xs:element name="colorAttribute" type="ms:attributeType"/>
+			</xs:choice>
+			<xs:element name="encoding" minOccurs="0"/>
+			<xs:element name="expression" type="ms:expressionType" minOccurs="0"/>
+			<xs:element name="font" type="xs:string" minOccurs="0"/>
+			<xs:element name="force" type="ms:booleanEnum" default="FALSE" minOccurs="0"/>
+			<xs:element name="maxLength" type="xs:integer" default="0" minOccurs="0"/>
+			<xs:element name="maxOverlapAngle" type="xs:float" minOccurs="0"/>
+			<xs:element name="maxSize" type="xs:integer" default="256" minOccurs="0"/>
+			<xs:element name="minDistance" type="xs:integer" minOccurs="0"/>
+			<xs:element name="minFeatureSize" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="xs:integer">
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:enumeration value="AUTO"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="minSize" type="xs:integer" default="4" minOccurs="0"/>
+			<xs:element name="offset" type="ms:sizeType" minOccurs="0"/>
+			<xs:choice minOccurs="0">
+				<xs:element name="outlineColor" type="ms:rgbColorType"/>
+				<xs:element name="outlineColorAttribute" type="ms:attributeType"/>
+			</xs:choice>
+			<xs:element name="outlineWidth" type="xs:double" default="1" minOccurs="0"/>
+			<xs:element name="partials" type="ms:booleanEnum" minOccurs="0"/>
+			<xs:element name="position" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="ms:positionEnum ms:fullPositionEnum">
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:enumeration value="AUTO"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="priority" default="1" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="ms:attributeType">
+						<xs:simpleType>
+							<xs:restriction base="xs:integer">
+								<xs:minInclusive value="1"/>
+								<xs:maxInclusive value="10"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="repeatDistance" type="xs:integer" minOccurs="0"/>
+			<xs:element name="shadowColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="shadowSize" type="ms:sizeType" minOccurs="0"/>
+			<xs:element name="size">
+				<xs:simpleType>
+					<xs:union memberTypes="ms:attributeType xs:positiveInteger">
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:enumeration value="TINY"/>
+								<xs:enumeration value="SMALL"/>
+								<xs:enumeration value="MEDIUM"/>
+								<xs:enumeration value="LARGE"/>
+								<xs:enumeration value="GIANT"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="Style" type="ms:Style" minOccurs="0" maxOccurs="unbounded"/>
+			<xs:element name="text" type="xs:string" minOccurs="0"/>
+			<xs:element name="wrap" type="xs:string" minOccurs="0"/>
+		</xs:sequence>
+		<xs:attribute name="type" use="required">
+			<xs:simpleType>
+				<xs:restriction base="xs:string">
+					<xs:enumeration value="BITMAP"/>
+					<xs:enumeration value="TRUETYPE"/>
+				</xs:restriction>
+			</xs:simpleType>
+		</xs:attribute>
+	</xs:complexType>
+	<!-- LABELLEADER Definition -->
+	<xs:complexType name="LabelLeader">
+		<xs:sequence>
+			<xs:element name="gridstep" type="xs:positiveInteger" minOccurs="0"/>
+			<xs:element name="maxdistance" type="xs:positiveInteger" minOccurs="0"/>
+			<xs:element name="Style" type="ms:Style" minOccurs="0" maxOccurs="unbounded"/>
+		</xs:sequence>
+	</xs:complexType>
+	<!-- STYLE Definition -->
+	<xs:complexType name="Style">
+		<xs:sequence>
+			<xs:element name="angle" default="0" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="xs:double ms:attributeType">
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:enumeration value="AUTO"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="antialias" type="ms:booleanEnum" minOccurs="0"/>
+			<xs:element name="backgroundColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="colorRange" type="ms:colorRangeType" minOccurs="0"/>
+			<xs:element name="dataRange" type="ms:dataRangeType" minOccurs="0"/>
+			<xs:choice minOccurs="0">
+				<xs:element name="color" type="ms:rgbColorType"/>
+				<xs:element name="colorAttribute" type="ms:attributeType"/>
+			</xs:choice>
+			<xs:element name="gap" type="xs:integer" default="0" minOccurs="0"/>
+			<xs:element name="geomTransform" minOccurs="0">
+				<xs:simpleType>
+					<xs:restriction base="xs:string">
+						<xs:enumeration value="BBOX"/>
+						<xs:enumeration value="END"/>
+						<xs:enumeration value="LABELPNT"/>
+						<xs:enumeration value="LABELPOLY"/>
+						<xs:enumeration value="START"/>
+						<xs:enumeration value="VERTICES"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="initialGap" type="xs:double" minOccurs="0"/>
+			<xs:element name="lineCap" default="BUTT" minOccurs="0">
+				<xs:simpleType>
+					<xs:restriction base="xs:string">
+						<xs:enumeration value="BUTT"/>
+						<xs:enumeration value="ROUND"/>
+						<xs:enumeration value="SQUARE"/>
+						<xs:enumeration value="TRIANGLE"/>
+						<xs:enumeration value="SVG"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="lineJoin" minOccurs="0">
+				<xs:simpleType>
+					<xs:restriction base="xs:string">
+						<xs:enumeration value="ROUND"/>
+						<xs:enumeration value="MITER"/>
+						<xs:enumeration value="BEVEL"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="lineJoinMaxSize" type="xs:integer" default="3" minOccurs="0"/>
+			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="maxSize" type="xs:float" default="500" minOccurs="0"/>
+			<xs:element name="maxWidth" type="xs:float" default="32" minOccurs="0"/>
+			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="minSize" type="xs:float" default="0" minOccurs="0"/>
+			<xs:element name="minWidth" type="xs:float" default="0" minOccurs="0"/>
+			<xs:element name="offset" type="ms:sizeType" minOccurs="0"/>
+			<xs:element name="opacity" type="xs:integer" default="0" minOccurs="0"/>
+			<xs:choice minOccurs="0">
+				<xs:element name="outlineColor" type="ms:rgbColorType"/>
+				<xs:element name="outlineColorAttribute" type="ms:attributeType"/>
+			</xs:choice>
+			<xs:element name="pattern" minOccurs="0">
+				<xs:simpleType>
+					<xs:list itemType="xs:float"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="polarOffset" minOccurs="0">
+				<xs:simpleType>
+					<xs:union
+						memberTypes="xs:positiveInteger ms:attributeType xs:positiveInteger ms:attributeType"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="size" default="1" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="xs:double ms:attributeType"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="symbol" type="ms:symbolType" default="1" minOccurs="0"/>
+			<xs:element name="width" default="1" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="xs:double ms:attributeType"/>
+				</xs:simpleType>
+			</xs:element>
+		</xs:sequence>
+	</xs:complexType>
+	<!-- CLASS Definition -->
+	<xs:complexType name="Class">
+		<xs:sequence>
+			<xs:element name="backgroundColor" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="debug" type="ms:stateEnum" minOccurs="0"/>
+			<xs:element name="expression" type="ms:expressionType" minOccurs="0"/>
+			<xs:element name="group" type="xs:string" minOccurs="0"/>
+			<xs:element name="keyImage" type="xs:string" minOccurs="0"/>
+			<xs:element name="Label" type="ms:Label" minOccurs="0" maxOccurs="unbounded"/>
+			<xs:element name="LabelLeader" type="ms:LabelLeader" minOccurs="0"/>
+			<xs:element name="maxSize" type="xs:integer" default="50" minOccurs="0"/>
+			<xs:element name="minSize" type="xs:integer" default="0" minOccurs="0"/>
+			<xs:choice minOccurs="0">
+				<xs:element name="outlineColor" type="ms:rgbColorType"/>
+				<xs:element name="outlineColorAttribute" type="ms:attributeType"/>
+			</xs:choice>
+			<xs:element name="size" type="xs:positiveInteger" default="1" minOccurs="0"/>
+			<xs:element name="Style" type="ms:Style" minOccurs="0" maxOccurs="unbounded"/>
+			<xs:element name="symbol" type="ms:symbolType" default="1" minOccurs="0"/>
+			<xs:element name="template" type="xs:string" minOccurs="0"/>
+			<xs:element name="text" type="xs:string" minOccurs="0"/>
+		</xs:sequence>
+		<xs:attribute name="name" type="xs:string"/>
+		<xs:attribute name="status" type="ms:stateEnum" default="ON"/>
+	</xs:complexType>
+	
+	<!-- SYMBOL Definition -->
+	<xs:complexType name="Symbol">
+		<xs:sequence>
+			<xs:element name="anchorPoint" type="ms:pointType" minOccurs="0"/>
+			<xs:element name="antialias" type="ms:booleanEnum" minOccurs="0"/>
+			<xs:element name="character" type="xs:string" minOccurs="0"/>
+			<xs:element name="filled" type="ms:booleanEnum" minOccurs="0"/>
+			<xs:element name="font" type="xs:string" minOccurs="0"/>
+			<xs:element name="image" type="xs:string" minOccurs="0"/>
+			<xs:element name="Points" minOccurs="0">
+				<xs:complexType>
+					<xs:sequence>
+						<xs:element name="point" type="ms:pointType" minOccurs="0" maxOccurs="unbounded"/>
+					</xs:sequence>
+				</xs:complexType>
+			</xs:element>
+			<xs:element name="transparent" type="xs:integer" minOccurs="0"/>
+		</xs:sequence>
+		<xs:attribute name="name" type="xs:string"/>
+		<xs:attribute name="type" use="required">
+			<xs:simpleType>
+				<xs:restriction base="xs:string">
+					<xs:enumeration value="VECTOR"/>
+					<xs:enumeration value="ELLIPSE"/>
+					<xs:enumeration value="PIXMAP"/>
+					<xs:enumeration value="TRUETYPE"/>
+					<xs:enumeration value="HATCH"/>
+					<xs:enumeration value="SIMPLE"/>
+				</xs:restriction>
+			</xs:simpleType>
+		</xs:attribute>
+	</xs:complexType>
+	<!-- FEATURE Definition -->
+	<xs:complexType name="Feature">
+		<xs:all>
+			<xs:element name="Points" minOccurs="0">
+				<xs:complexType>
+					<xs:sequence>
+						<xs:element name="point" type="ms:pointType" minOccurs="0" maxOccurs="unbounded"/>
+					</xs:sequence>
+				</xs:complexType>
+			</xs:element>
+			<xs:element name="items" type="xs:string" minOccurs="0"/>
+			<xs:element name="text" type="xs:string" minOccurs="0"/>
+			<xs:element name="wkt" type="xs:string" minOccurs="0"/>
+		</xs:all>
+	</xs:complexType>
+	<!-- GRID Definition -->
+	<xs:complexType name="Grid">
+		<xs:sequence>
+			<xs:element name="labelFormat" type="xs:string" minOccurs="0"/>
+			<xs:element name="maxArcs" type="xs:double" minOccurs="0"/>
+			<xs:element name="maxInterval" type="xs:double" minOccurs="0"/>
+			<xs:element name="maxSubdivide" type="xs:double" default="256" minOccurs="0"/>
+			<xs:element name="minArcs" type="xs:double" minOccurs="0"/>
+			<xs:element name="minInterval" type="xs:double" minOccurs="0"/>
+			<xs:element name="minSubdivide" type="xs:double" minOccurs="0"/>
+		</xs:sequence>
+	</xs:complexType>
+	<!-- JOIN Definition -->
+	<xs:complexType name="Join">
+		<xs:sequence>
+			<xs:element name="connection" type="xs:string" minOccurs="0"/>
+			<xs:element name="connectionType" minOccurs="0">
+				<xs:simpleType>
+					<xs:restriction base="xs:string">
+						<xs:enumeration value="MYSQL"/>
+						<xs:enumeration value="POSTGRESQL"/>
+						<xs:enumeration value="CSV"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="footer" type="xs:string" minOccurs="0"/>
+			<xs:element name="from" type="xs:string" minOccurs="0"/>
+			<xs:element name="header" type="xs:string" minOccurs="0"/>
+			<xs:element name="table" type="xs:string" minOccurs="0"/>
+			<xs:element name="template" type="xs:string" minOccurs="0"/>
+			<xs:element name="to" type="xs:string"/>
+		</xs:sequence>
+		<xs:attribute name="name" type="xs:string" use="required"/>
+		<xs:attribute name="type" default="ONE-TO-ONE">
+			<xs:simpleType>
+				<xs:restriction base="xs:string">
+					<xs:enumeration value="ONE-TO-ONE"/>
+					<xs:enumeration value="ONE-TO-MANY"/>
+				</xs:restriction>
+			</xs:simpleType>
+		</xs:attribute>
+	</xs:complexType>
+	<!-- REFERENCE Definition -->
+	<xs:complexType name="Reference">
+		<xs:sequence>
+			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="extent" minOccurs="0">
+				<xs:simpleType>
+					<xs:list itemType="xs:double"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="image" type="xs:string" minOccurs="0"/>
+			<xs:element name="marker" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="xs:positiveInteger xs:string"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="markerSize" type="xs:positiveInteger" minOccurs="0"/>
+			<xs:element name="maxBoxSize" type="xs:positiveInteger" minOccurs="0"/>
+			<xs:element name="minBoxSize" type="xs:positiveInteger" minOccurs="0"/>
+			<xs:element name="outlineColor" type="ms:rgbExtendedColorType" minOccurs="0"/>
+			<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
+		</xs:sequence>
+		<xs:attribute name="status" type="ms:stateEnum" default="OFF"/>
+	</xs:complexType>
+	<!-- CLUSTER Definition -->
+	<xs:complexType name="Cluster">
+		<xs:sequence>
+			<xs:element name="buffer" type="xs:float" minOccurs="0"/>
+			<xs:element name="filter" type="ms:expressionType" minOccurs="0"/>
+			<xs:element name="group" type="ms:expressionType" minOccurs="0"/>
+			<xs:element name="maxdistance" type="xs:positiveInteger" minOccurs="0"/>
+			<xs:element name="region" type="xs:string" minOccurs="0"/>
+		</xs:sequence>
+	</xs:complexType>
+	<!--COMPOSITE Definition-->
+	<xs:complexType name="CompoSite">
+		<xs:sequence>
+			<xs:element name="compop" type="xs:string" minOccurs="0"/>
+			<xs:element name="opacity" type="xs:integer" default="100" minOccurs="0"/>
+		</xs:sequence>
+	</xs:complexType>
+	<!-- LAYER Definition -->
+	<xs:complexType name="Layer">
+		<xs:sequence>
+			<xs:element name="Class" type="ms:Class" minOccurs="0" maxOccurs="unbounded"/>
+			<xs:element name="CompoSite" type="ms:CompoSite" minOccurs="0"/>
+			<xs:element name="classGroup" type="xs:string" minOccurs="0"/>
+			<xs:element name="classItem" type="xs:string" minOccurs="0"/>
+			<xs:element name="Cluster" type="ms:Cluster" minOccurs="0"/>
+			<xs:element name="connection" type="xs:string" minOccurs="0"/>
+			<xs:element name="connectionType" minOccurs="0">
+				<xs:simpleType>
+					<xs:restriction base="xs:string">
+						<xs:enumeration value="LOCAL"/>
+						<xs:enumeration value="SDE"/>
+						<xs:enumeration value="OGR"/>
+						<xs:enumeration value="FLATGEOBUF"/>
+						<xs:enumeration value="WFS"/>
+						<xs:enumeration value="POSTGIS"/>
+						<xs:enumeration value="ORACLESPATIAL"/>
+						<xs:enumeration value="WMS"/>
+						<xs:enumeration value="PLUGIN"/>
+						<xs:enumeration value="UNION"/>
+					</xs:restriction>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="data" type="xs:string" minOccurs="0"/>
+			<xs:element name="debug" type="ms:debugModeEnum" default="OFF" minOccurs="0"/>			
+			<xs:element name="extent" minOccurs="0">
+				<xs:simpleType>
+					<xs:list itemType="xs:double"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="Feature" type="ms:Feature" minOccurs="0" maxOccurs="unbounded"/>
+			<xs:element name="filter" type="ms:expressionType" minOccurs="0"/>
+			<xs:element name="filterItem" type="xs:string" minOccurs="0"/>
+			<xs:element name="footer" type="xs:string" minOccurs="0"/>
+			<xs:element name="Grid" type="ms:Grid" minOccurs="0"/>
+			<xs:element name="group" type="xs:string" minOccurs="0"/>
+			<xs:element name="header" type="xs:string" minOccurs="0"/>
+			<xs:element name="Join" type="ms:Join" minOccurs="0"/>
+			<xs:element name="labelCache" type="ms:stateEnum" default="ON" minOccurs="0"/>
+			<xs:element name="labelItem" type="xs:string" minOccurs="0"/>
+			<xs:element name="labelMaxScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="labelMinScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="labelRequires" type="xs:string" minOccurs="0"/>
+			<xs:element name="mask" type="xs:string" minOccurs="0"/>
+			<xs:element name="maxFeatures" type="xs:positiveInteger" minOccurs="0"/>
+			<xs:element name="maxGeoWidth" type="xs:double" minOccurs="0"/>
+			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="Metadata" type="ms:itemType" minOccurs="0"/>
+			<xs:element name="minGeoWidth" type="xs:double" minOccurs="0"/>
+			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="offsite" type="ms:rgbColorType" minOccurs="0"/>
+			<xs:element name="opacity" minOccurs="0">
+				<xs:simpleType>
+					<xs:union>
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:enumeration value="ALPHA"/>
+							</xs:restriction>
+						</xs:simpleType>
+						<xs:simpleType>
+							<xs:restriction base="xs:integer">
+								<xs:minInclusive value="0"/>
+								<xs:maxInclusive value="100"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="plugin" type="xs:string" minOccurs="0"/>
+			<xs:element name="postLabelCache" type="ms:booleanEnum" default="FALSE" minOccurs="0"/>
+			<xs:element name="processing" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
+			<xs:element name="projection" minOccurs="0">
+				<xs:simpleType>
+					<xs:list itemType="xs:string"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="requires" type="xs:string" minOccurs="0"/>
+			<xs:element name="sizeUnits" default="PIXELS" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="ms:unitType">
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:enumeration value="PIXELS"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="styleItem" type="xs:string" minOccurs="0"/>
+			<xs:element name="symbolScaleDenom" type="xs:double" minOccurs="0"/>
+			<xs:element name="template" type="xs:string" minOccurs="0"/>
+			<xs:element name="tileIndex" type="xs:string" minOccurs="0"/>
+			<xs:element name="tileItem" type="xs:string" default="LOCATION" minOccurs="0"/>
+			<xs:element name="tolerance" type="xs:double" minOccurs="0"/>
+			<xs:element name="toleranceUnits" type="ms:unitTypeUnion" default="PIXELS" minOccurs="0"/>
+			<xs:element name="transform" default="TRUE" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="ms:booleanEnum ms:fullPositionEnum"/>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="units" minOccurs="0">
+				<xs:simpleType>
+					<xs:union memberTypes="ms:unitType ms:extendedUnitType">
+						<xs:simpleType>
+							<xs:restriction base="xs:string">
+								<xs:enumeration value="PERCENTAGES"/>
+							</xs:restriction>
+						</xs:simpleType>
+					</xs:union>
+				</xs:simpleType>
+			</xs:element>
+			<xs:element name="Validation" type="ms:itemType" minOccurs="0"/>
+		</xs:sequence>
+		<xs:attribute name="name" type="xs:string" use="required"/>
+		<xs:attribute name="type" use="required">
+			<xs:simpleType>
+				<xs:restriction base="xs:string">
+					<xs:enumeration value="POINT"/>
+					<xs:enumeration value="LINE"/>
+					<xs:enumeration value="POLYGON"/>
+					<xs:enumeration value="CIRCLE"/>
+					<xs:enumeration value="ANNOTATION"/>
+					<xs:enumeration value="RASTER"/>
+					<xs:enumeration value="QUERY"/>
+					<xs:enumeration value="CHART"/>
+				</xs:restriction>
+			</xs:simpleType>
+		</xs:attribute>
+		<xs:attribute name="status" default="ON">
+			<xs:simpleType>
+				<xs:union memberTypes="ms:stateEnum">
+					<xs:simpleType>
+						<xs:restriction base="xs:string">
+							<xs:enumeration value="DEFAULT"/>
+						</xs:restriction>
+					</xs:simpleType>
+				</xs:union>
+			</xs:simpleType>
+		</xs:attribute>
+	</xs:complexType>
+	<!-- LAYERSET Definition -->
+	<xs:element name="LayerSet">
+		<xs:complexType>
+			<xs:sequence>
+				<xs:element name="Layer" type="ms:Layer" minOccurs="0" maxOccurs="unbounded"/>
+			</xs:sequence>
+		</xs:complexType>
+	</xs:element>
+	<!-- SYMBOLSET Definition -->
+	<xs:element name="SymbolSet">
+		<xs:complexType>
+			<xs:sequence>
+				<xs:element name="Symbol" type="ms:Symbol" minOccurs="0" maxOccurs="unbounded"/>
+			</xs:sequence>
+		</xs:complexType>
+	</xs:element>
+	<!-- MAP Definition -->
+	<xs:element name="Map">
+		<xs:complexType>
+			<xs:sequence>
+				<xs:element name="angle" type="xs:double" default="0" minOccurs="0"/>
+				<xs:element name="Config" type="ms:itemType" minOccurs="0"/>
+				<xs:element name="dataPattern" type="xs:string" minOccurs="0"/>
+				<xs:element name="debug" type="ms:debugModeEnum" default="OFF" minOccurs="0"/>
+				<xs:element name="defResolution" type="xs:positiveInteger" default="72" minOccurs="0"/>
+				<xs:element name="extent" minOccurs="0">
+					<xs:simpleType>
+						<xs:list itemType="xs:double"/>
+					</xs:simpleType>
+				</xs:element>
+				<xs:element name="fontSet" type="xs:string" minOccurs="0"/>
+				<xs:element name="imageColor" type="ms:rgbColorType" minOccurs="0"/>
+				<xs:element name="imageType" type="xs:string" minOccurs="0"/>
+				<xs:element name="include" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
+				<xs:element name="Layer" type="ms:Layer" minOccurs="0" maxOccurs="unbounded"/>
+				<xs:element name="Legend" type="ms:Legend" minOccurs="0"/>
+				<xs:element name="maxSize" type="xs:positiveInteger" minOccurs="0"/>
+				<xs:element name="OutputFormat" type="ms:OutputFormat" maxOccurs="unbounded"/>
+				<xs:element name="projection" minOccurs="0">
+					<xs:simpleType>
+						<xs:list itemType="xs:string"/>
+					</xs:simpleType>
+				</xs:element>
+				<xs:element name="QueryMap" type="ms:QueryMap" minOccurs="0"/>
+				<xs:element name="Reference" type="ms:Reference" minOccurs="0"/>
+				<xs:element name="resolution" type="xs:positiveInteger" default="72" minOccurs="0"/>
+				<xs:element name="ScaleBar" type="ms:ScaleBar" minOccurs="0"/>
+				<xs:element name="scaleDenom" type="xs:double" minOccurs="0"/>
+				<xs:element name="shapePath" type="xs:string" minOccurs="0"/>
+				<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
+				<xs:element name="Symbol" type="ms:Symbol" minOccurs="0" maxOccurs="unbounded"/>
+				<xs:element name="symbolSet" type="xs:string" minOccurs="0"/>
+				<xs:element name="templatePattern" type="xs:string" minOccurs="0"/>
+				<xs:element name="units" default="METERS" minOccurs="0">
+					<xs:simpleType>
+						<xs:union memberTypes="ms:unitType">
+							<xs:simpleType>
+								<xs:restriction base="xs:string">
+									<xs:enumeration value="DD"/>
+								</xs:restriction>
+							</xs:simpleType>
+						</xs:union>
+					</xs:simpleType>
+				</xs:element>
+				<xs:element name="Web" type="ms:Web" minOccurs="0" maxOccurs="unbounded"/>
+			</xs:sequence>
+			<xs:attribute name="name" type="xs:string" use="required"/>
+			<xs:attribute name="status" type="ms:stateEnum" default="ON"/>
+			<xs:attribute name="version" type="xs:string" use="required"/>
+		</xs:complexType>
+	</xs:element>
+</xs:schema>
diff -pruN 8.0.1-5/src/xmlmapfile/mapfile.xsl 8.2.0~beta1-1~exp1/src/xmlmapfile/mapfile.xsl
--- 8.0.1-5/src/xmlmapfile/mapfile.xsl	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/xmlmapfile/mapfile.xsl	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,1616 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet version="1.0"
+                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns:dyn="http://exslt.org/dynamic"
+                xmlns:ms="http://www.mapserver.org/mapserver"
+                extension-element-prefixes="dyn">
+ 
+<xsl:output  method="text"/>
+
+<xsl:variable name="smallcase" select="'abcdefghijklmnopqrstuvwxyz'"/>
+<xsl:variable name="uppercase" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
+
+<xsl:template name="getString">
+  <xsl:param name="nodeName"/>
+  <xsl:param name="quote" select="'0'"/>
+  <xsl:if test="*[concat('ms:',name()) = $nodeName] | *[name() = $nodeName]">
+    <xsl:choose>
+      <xsl:when test="$quote = '1'">
+        <xsl:value-of select="translate(substring-after($nodeName,'ms:'), $smallcase, $uppercase)"/><xsl:text> "</xsl:text><xsl:value-of select="dyn:evaluate($nodeName)"/><xsl:text>"</xsl:text>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:value-of select="translate(substring-after($nodeName,'ms:'), $smallcase, $uppercase)"/><xsl:text> </xsl:text><xsl:value-of select="dyn:evaluate($nodeName)"/>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:if>
+</xsl:template>
+
+<xsl:template name="indent">
+  <xsl:param name="count"/>
+  <xsl:if test="$count &gt; 0">
+    <xsl:call-template name="indent">
+      <xsl:with-param name="count" select="$count - 1"/>
+    </xsl:call-template>
+    <xsl:value-of select="'  '"/>
+  </xsl:if>
+</xsl:template>
+
+<xsl:template name="print">
+  <xsl:param name="text" select="'null'"/>
+  <xsl:param name="indent"/>
+  <xsl:param name="quote" select="'0'"/>
+  <xsl:param name="node" select="/"/>
+
+  <xsl:variable name="textValue">
+    <xsl:choose>
+      <xsl:when test="$text = 'null'">
+            <xsl:call-template name="getString">
+              <xsl:with-param name="nodeName" select="$node"/>
+              <xsl:with-param name="quote" select="$quote"/>
+            </xsl:call-template>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:value-of select="$text"/>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:variable>
+
+  <xsl:choose>
+  <xsl:when test="$text = 'null'">
+    <xsl:if test="$textValue != ''">
+      <xsl:call-template name="indent">
+           <xsl:with-param name="count" select="$indent"/>
+       </xsl:call-template>
+         <xsl:value-of select="$textValue"/>
+       <xsl:text>
+</xsl:text>
+    </xsl:if>
+  </xsl:when>
+  <xsl:otherwise>
+    <xsl:if test="$node">
+       <xsl:call-template name="indent">
+           <xsl:with-param name="count" select="$indent"/>
+       </xsl:call-template>
+         <xsl:value-of select="$textValue"/>
+       <xsl:text>
+</xsl:text>
+    </xsl:if>
+  </xsl:otherwise>
+  </xsl:choose>
+</xsl:template>
+
+<xsl:template name="printExpression">
+  <xsl:param name="indent"/>
+  <xsl:param name="node" select="/"/>
+
+  <xsl:if test="$node">
+    <xsl:variable name="quote">
+      <xsl:choose>
+        <xsl:when test="(dyn:evaluate($node)/@type = 'CONSTANT') or (not(dyn:evaluate($node)/@type))">
+          <xsl:value-of select='1'/>
+        </xsl:when>
+        <xsl:otherwise>
+          <xsl:value-of select='0'/>
+        </xsl:otherwise>
+      </xsl:choose>
+    </xsl:variable>
+
+    <xsl:variable name="textValue">
+      <xsl:call-template name="getString">
+        <xsl:with-param name="nodeName" select="$node"/>
+        <xsl:with-param name="quote" select="$quote"/>
+      </xsl:call-template>
+    </xsl:variable>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="quote" select="$quote"/>
+      <xsl:with-param name="text" select="$textValue"/>
+    </xsl:call-template>
+
+  </xsl:if>
+</xsl:template>
+
+<xsl:template name="printSymbol">
+  <xsl:param name="indent"/>
+  <xsl:param name="node" select="/"/>
+
+  <xsl:if test="$node">
+    <xsl:variable name="quote">
+      <xsl:choose>
+        <xsl:when test="dyn:evaluate($node)/@type = 'NAME'">
+          <xsl:value-of select='1'/>
+        </xsl:when>
+        <xsl:otherwise>
+          <xsl:value-of select='0'/>
+        </xsl:otherwise>
+      </xsl:choose>
+    </xsl:variable>
+
+    <xsl:variable name="textValue">
+      <xsl:call-template name="getString">
+        <xsl:with-param name="nodeName" select="$node"/>
+        <xsl:with-param name="quote" select="$quote"/>
+      </xsl:call-template>
+    </xsl:variable>
+    
+    <xsl:call-template name="print">
+      <xsl:with-param name="quote" select="$quote"/>
+      <xsl:with-param name="text" select="$textValue"/>
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:call-template>
+
+  </xsl:if>
+</xsl:template>
+
+  <xsl:template match="/">
+    <xsl:apply-templates select="ms:SymbolSet"/>
+    <xsl:apply-templates select="ms:LayerSet"/>
+    <xsl:apply-templates select="ms:Map"/>
+  </xsl:template>
+
+<xsl:template match="ms:color | ms:backgroundColor | ms:outlineColor | ms:shadowColor | ms:imageColor | ms:offsite">
+  <xsl:param name="indent"/>
+   <xsl:choose>
+     <xsl:when test="starts-with(name(), 'ms:')">
+       <xsl:call-template name="print">
+         <xsl:with-param name="text" select="concat(translate(substring-after(name(), 'ms:'), $smallcase, $uppercase),' ', @red, ' ', @green, ' ', @blue)"/>
+         <xsl:with-param name="indent" select="$indent"/>
+       </xsl:call-template>
+     </xsl:when>
+     <xsl:otherwise>
+       <xsl:call-template name="print">
+         <xsl:with-param name="text" select="concat(translate(name(), $smallcase, $uppercase),' ', @red, ' ', @green, ' ', @blue)"/>
+         <xsl:with-param name="indent" select="$indent"/>
+       </xsl:call-template>
+     </xsl:otherwise>
+   </xsl:choose>
+</xsl:template>
+
+ <xsl:template match="ms:colorAttribute | ms:outlineColorAttribute">
+  <xsl:param name="indent"/>
+  <xsl:param name="tagName" select="translate(name(), $smallcase, $uppercase)"/>
+  <xsl:call-template name="print">
+    <xsl:with-param name="text" select="concat($tagName, ' ',.)"/>
+    <xsl:with-param name="indent" select="$indent"/>
+  </xsl:call-template>
+</xsl:template>
+
+<xsl:template match="ms:size | ms:offset | ms:keySize | ms:keySpacing | ms:shadowSize | ms:anchorPoint">
+  <xsl:param name="indent"/>
+  <xsl:choose>
+    <xsl:when test="starts-with(name(), 'ms:')">
+      <xsl:call-template name="print">
+        <xsl:with-param name="text" select="concat(translate(substring-after(name(), 'ms:'), $smallcase, $uppercase), ' ', @x, ' ', @y)"/>
+        <xsl:with-param name="indent" select="$indent"/>
+      </xsl:call-template>
+    </xsl:when>
+    <xsl:otherwise>
+      <xsl:call-template name="print">
+        <xsl:with-param name="text" select="concat(translate(name(), $smallcase, $uppercase), ' ', @x, ' ', @y)"/>
+        <xsl:with-param name="indent" select="$indent"/>
+      </xsl:call-template>
+    </xsl:otherwise>
+  </xsl:choose>
+</xsl:template>
+
+<xsl:template match="ms:Points">
+  <xsl:param name="indent"/>
+  <xsl:call-template name="print">
+    <xsl:with-param name="text" select="'POINTS'"/>
+    <xsl:with-param name="indent" select="$indent - 1"/>
+  </xsl:call-template>
+  <xsl:for-each select="ms:point">
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat(@x,' ',@y)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:call-template>
+  </xsl:for-each>
+  <xsl:call-template name="print">
+    <xsl:with-param name="text" select="'END'"/>
+    <xsl:with-param name="indent" select="$indent - 1"/>
+  </xsl:call-template>
+</xsl:template>
+
+<xsl:template match="ms:Metadata | ms:Validation">
+  <xsl:param name="indent"/>
+  <xsl:choose>
+    <xsl:when test="starts-with(name(), 'ms:')">
+      <xsl:call-template name="print">
+        <xsl:with-param name="text" select="translate(substring-after(name(), 'ms:'),$smallcase, $uppercase)"/>
+        <xsl:with-param name="indent" select="$indent -1"/>
+      </xsl:call-template>
+    </xsl:when>
+    <xsl:otherwise>
+      <xsl:call-template name="print">
+        <xsl:with-param name="text" select="translate(name(),$smallcase, $uppercase)"/>
+        <xsl:with-param name="indent" select="$indent -1"/>
+      </xsl:call-template>
+    </xsl:otherwise>
+    </xsl:choose>
+  <xsl:for-each select="ms:item">
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('&#34;',@name,'&#34; ','&#34;',.,'&#34;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:call-template>
+  </xsl:for-each>
+  <xsl:call-template name="print">
+    <xsl:with-param name="text" select="'END'"/>
+    <xsl:with-param name="indent" select="$indent - 1"/>
+  </xsl:call-template>
+ </xsl:template>
+
+<xsl:template match="ms:Config">
+  <xsl:param name="indent"/>
+  <xsl:for-each select="ms:item">
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('CONFIG ','&#34;',@name,'&#34; ','&#34;',.,'&#34;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:call-template>
+  </xsl:for-each>
+ </xsl:template>
+
+
+<xsl:template match="ms:projection">
+  <xsl:param name="indent"/>
+  <xsl:call-template name="print">
+    <xsl:with-param name="text" select="'PROJECTION'"/>
+    <xsl:with-param name="indent" select="$indent - 1"/>
+  </xsl:call-template>
+  <xsl:call-template name="split-projection">
+    <xsl:with-param name="list" select="."/>
+    <xsl:with-param name="indent" select="$indent"/>
+  </xsl:call-template>
+  <xsl:call-template name="print">
+    <xsl:with-param name="text" select="'END'"/>
+    <xsl:with-param name="indent" select="$indent - 1"/>
+  </xsl:call-template>
+ </xsl:template>
+
+ <xsl:template name="split-projection">
+   <xsl:param name="list"/>
+   <xsl:param name="indent"/>
+   <xsl:variable name="newlist" select="concat(normalize-space($list), ' ')" />
+   <xsl:variable name="first" select="substring-before($newlist, ' ')" />
+   <xsl:variable name="remaining" select="substring-after($newlist, ' ')" />
+   <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('&#34;',$first,'&#34;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:call-template>
+   <xsl:if test="$remaining">
+     <xsl:call-template name="split-projection">
+       <xsl:with-param name="list" select="$remaining" />
+       <xsl:with-param name="indent" select="$indent" />
+     </xsl:call-template>
+   </xsl:if>
+  </xsl:template>
+
+  <xsl:template match="ms:pattern">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('PATTERN ',.,' END')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template match="ms:QueryMap">
+    <xsl:param name="indent"/>
+
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'QUERYMAP'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@status"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:color">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:size">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:style'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+
+  </xsl:template>
+
+
+  <xsl:template match="ms:Web">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'WEB'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:browseFormat'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:empty'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:error'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:footer'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:header'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:imagePath'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:tempPath'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:imageUrl'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:legendFormat'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:log'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxTemplate'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Metadata">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minTemplate'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:queryFormat'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:template'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Validation">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template match="ms:OutputFormat">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'OUTPUTFORMAT'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@name"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:driver'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:extension'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:for-each select="ms:formatOption">
+       <xsl:call-template name="print">
+         <xsl:with-param name="indent" select="$indent"/>
+         <xsl:with-param name="text" select="concat('FORMATOPTION ','&#34;',.,'&#34;')"/>
+       </xsl:call-template>
+    </xsl:for-each>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:imageMode'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:mimeType'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:transparent'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:Reference">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'REFERENCE'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@status"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:color">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:extent'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:image'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:marker'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:markerSize'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxBoxSize'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minBoxSize'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:outlineColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:size">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template match="ms:Legend">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'LEGEND'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@status"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:imageColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:keySize">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:keySpacing">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:Label">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:outlineColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:position'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:postLabelCache'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:template'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:Label">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'LABEL'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@type"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:align'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:angle'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:antialias'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:buffer'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxOverlapAngle'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:color">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:colorAttribute">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="tagName" select="'COLOR'"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:encoding'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="printExpression">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:expression'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:font'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:force'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxLength'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxSize'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minDistance'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minFeatureSize'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minSize'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:offset">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:outlineColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:outlineColorAttribute">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="tagName" select="'OUTLINECOLOR'"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:outlineWidth'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:partials'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:position'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:priority'"/>
+    </xsl:call-template>
+   <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:repeatDistance'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:shadowColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:shadowSize">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:size'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Style">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:text'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>    
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:wrap'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:ScaleBar">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'SCALEBAR'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@status"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:align'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:backgroundColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:color">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:imageColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:intervals'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Label">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:outlineColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:position'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:postLabelCache'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:size">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:style'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:transparent'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:units'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:LabelLeader">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'LEADER'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:gridstep'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxdistance'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Style">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template match="ms:Style">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'STYLE'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:angle'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:antialias'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:color">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:colorAttribute">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="tagName" select="'COLOR'"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:geomTransform'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:initialGap'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxSize'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxWidth'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minSize'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minWidth'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:gap'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:lineCap'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:lineJoin'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:lineJoinMaxSize'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:pattern">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:polarOffset'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:offset">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:opacity'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:outlineColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:outlineColorAttribute">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="tagName" select="'OUTLINECOLOR'"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:size'"/>
+    </xsl:call-template>
+    <xsl:call-template name="printSymbol">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:symbol'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:width'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:CompoSite">
+    <xsl:param name="indent"/>
+	<xsl:call-template name="print">
+      <xsl:with-param name="text" select="'COMPOSITE'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+	<xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:Opacity'"/>
+    </xsl:call-template>
+	<xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:Compop'"/>
+    </xsl:call-template>
+  <xsl:template>
+  
+  <xsl:template match="ms:Class">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'CLASS'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@name"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@status"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:backgroundColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:color">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:debug'"/>
+    </xsl:call-template>
+    <xsl:call-template name="printExpression">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:expression'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:group'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:keyImage'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:for-each select="ms:Label">
+      <xsl:apply-templates select=".">
+        <xsl:with-param name="indent" select="$indent + 1"/>
+      </xsl:apply-templates>
+    </xsl:for-each>
+    <xsl:apply-templates select="ms:LabelLeader">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxSize'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minSize'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:outlineColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:outlineColorAttribute">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="tagName" select="'OUTLINECOLOR'"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:size'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Style">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="printSymbol">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:symbol'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:template'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:text'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:Symbol">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'SYMBOL'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@name"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@type"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:anchorPoint">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:antialias'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:character'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+     <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:filled'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:font'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:image'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Points">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:transparent'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:Feature">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'FEATURE'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Points">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:items'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:text'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:wkt'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:Grid">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'GRID'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:labelFormat'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxArcs'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxInterval'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxSubdivide'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minArcs'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minInterval'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minSubdivide'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template match="ms:Join">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'JOIN'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@name"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@type"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:connection'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:connectionType'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:footer'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:from'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:header'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:table'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:template'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:to'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+   <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:Layer">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'LAYER'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@name"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@type"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@status"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Class">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:CompoSite">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:classGroup'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:classItem'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:connection'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:connectionType'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:data'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:debug'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:extent'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Feature">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="printExpression">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:filter'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:filterItem'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:footer'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Grid">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:group'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:header'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Join">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:labelCache'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:labelItem'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:labelMaxScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:labelMinScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:labelRequires'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:mask'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxFeatures'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxGeoWidth'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Metadata">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minGeoWidth'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:offsite">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:opacity'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:plugin'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:postLabelCache'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Cluster">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:for-each select="ms:processing">
+      <xsl:call-template name="print">
+        <xsl:with-param name="indent" select="$indent"/>
+        <xsl:with-param name="text">
+          <xsl:value-of select="concat('PROCESSING ','&#34;',.,'&#34;')"/>
+        </xsl:with-param>
+      </xsl:call-template>
+    </xsl:for-each>
+    <xsl:apply-templates select="ms:projection">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:requires'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:sizeUnits'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:styleItem'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:symbolScaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:template'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:tileIndex'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:tileItem'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:tolerance'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:toleranceUnits'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:transform'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:units'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Validation">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template match="ms:Cluster">
+    <xsl:param name="indent"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'CLUSTER'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxdistance'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:region'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="printExpression">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:group'"/>
+    </xsl:call-template>
+    <xsl:call-template name="printExpression">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:filter'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+      <xsl:with-param name="indent" select="$indent - 1"/>
+    </xsl:call-template>
+  </xsl:template>
+  
+  <xsl:template match="ms:SymbolSet">
+    <xsl:param name="indent" select="0"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'SYMBOLSET&#xa;'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Symbol">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+   <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template match="ms:LayerSet">
+    <xsl:param name="indent" select="0"/>
+    <xsl:apply-templates select="ms:Layer">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+  </xsl:template>
+
+  <xsl:template match="ms:Map">
+    <xsl:param name="indent" select="0"/>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'MAP&#xa;'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@name"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="@status"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:angle'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Config">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:dataPattern'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:debug'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:defResolution'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:extent'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:fontSet'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:imageColor">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:imageType'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:for-each select="ms:include">
+      <xsl:call-template name="print">
+        <xsl:with-param name="indent" select="$indent"/>
+        <xsl:with-param name="text">
+          <xsl:value-of select="concat('INCLUDE ','&#34;',.,'&#34;')"/>
+        </xsl:with-param>
+      </xsl:call-template>
+      </xsl:for-each>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:maxSize'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:projection">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:resolution'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:scaleDenom'"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:shapePath'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:size">
+      <xsl:with-param name="indent" select="$indent"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:symbolSet'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:templatePattern'"/>
+      <xsl:with-param name="quote" select="1"/>
+    </xsl:call-template>
+    <xsl:call-template name="print">
+      <xsl:with-param name="indent" select="$indent"/>
+      <xsl:with-param name="node" select="'ms:units'"/>
+    </xsl:call-template>
+    <xsl:apply-templates select="ms:Web">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:OutputFormat">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:QueryMap">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:Reference">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:Legend">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:ScaleBar">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:Layer">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:apply-templates select="ms:Symbol">
+      <xsl:with-param name="indent" select="$indent + 1"/>
+    </xsl:apply-templates>
+    <xsl:call-template name="print">
+      <xsl:with-param name="text" select="'END&#xa;'"/>
+    </xsl:call-template>
+  </xsl:template>
+
+</xsl:stylesheet>
+
+
diff -pruN 8.0.1-5/src/xmlmapfile/tests/layerset.xml 8.2.0~beta1-1~exp1/src/xmlmapfile/tests/layerset.xml
--- 8.0.1-5/src/xmlmapfile/tests/layerset.xml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/xmlmapfile/tests/layerset.xml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,157 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<LayerSet xmlns="http://www.mapserver.org/mapserver" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.mapserver.org/mapserver ../mapfile.xsd">
+  <Layer name="layer1" type="CHART" status="DEFAULT">
+    <Class name="class1Layer1" status="ON">
+      <backgroundColor red="244" green="43" blue="22"/>
+      <color red="244" green="43" blue="22"/>
+      <debug>ON</debug>
+      <expression type="MSEXPR">(length('[NAME_E]') &lt; 8)</expression>
+      <group>group1</group>
+      <keyImage>/home/myusername/layer1.png</keyImage>
+      <Label type="TRUETYPE">
+        <align>LEFT</align>
+        <angle>AUTO2</angle>
+        <antialias>TRUE</antialias>
+        <buffer>2</buffer>
+        <colorAttribute>[myColor]</colorAttribute>
+        <encoding>ISO 8859-1</encoding>
+        <font>serif</font>
+        <force>TRUE</force>
+        <maxLength>244</maxLength>
+        <maxSize>244</maxSize>
+        <minDistance>24</minDistance>
+        <minFeatureSize>AUTO</minFeatureSize>
+        <minSize>6</minSize>
+        <offset x="12" y="33"/>
+        <outlineColor red="-1" green="-1" blue="-1"/>
+        <outlineWidth>13</outlineWidth>
+        <partials>TRUE</partials>
+        <position>AUTO</position>
+        <priority>5</priority>
+        <repeatDistance>80</repeatDistance>
+        <shadowColor red="244" green="43" blue="22"/>
+        <shadowSize x="15" y="14"/>
+        <size>TINY</size>
+        <text>Test</text>
+        <wrap>\n</wrap>
+      </Label>
+      <LabelLeader>
+        <gridstep>6</gridstep>
+        <maxdistance>15</maxdistance>
+            <Style>
+                <initialGap>2</initialGap>
+            </Style>
+      </LabelLeader>
+      <maxScaleDenom>24000</maxScaleDenom>
+      <maxSize>50</maxSize>
+      <minScaleDenom>1000000</minScaleDenom>
+      <minSize>10</minSize>
+      <outlineColor red="33" green="44" blue="55"/>
+      <size>12</size>
+      <Style>
+        <angle>434</angle>
+        <antialias>TRUE</antialias>
+        <backgroundColor red="244" green="43" blue="22"/>
+        <color red="244" green="43" blue="22"/>
+        <gap>13</gap>
+        <geomTransform>VERTICES</geomTransform>
+        <lineCap>ROUND</lineCap>
+        <lineJoin>BEVEL</lineJoin>
+        <lineJoinMaxSize>3</lineJoinMaxSize>
+        <maxSize>244</maxSize>
+        <maxWidth>28</maxWidth>
+        <minSize>6</minSize>
+        <minWidth>24</minWidth>
+        <offset x="12" y="33"/>
+        <opacity>1253</opacity>
+        <outlineColorAttribute>[myOulineColorAttribute]</outlineColorAttribute>
+        <pattern>2 3</pattern>
+        <size>[mySize]</size>
+        <symbol type="NAME">star.gif</symbol>
+        <width>[myWidth]</width>
+      </Style>
+            <Style>
+                <initialGap>2</initialGap>
+            </Style>
+      <symbol type="ID">261</symbol>
+      <template>http://mapgears.com/templates/myTemplates1.html</template>
+      <text>myText1</text>
+    </Class>
+    <classGroup>group1</classGroup>
+    <classItem>population</classItem>
+    <Cluster>
+      <buffer>3.3</buffer>
+      <filter type="MSEXPR">(type=’road’ and size &lt; 2)</filter>
+      <group type="REGEX">/ddea/i</group>
+      <maxdistance>20</maxdistance>
+      <region>region1</region>
+    </Cluster>
+    <connection>user=nobody password=****** dbname=dbname host=localhost port=5432</connection>
+    <connectionType>SDE</connectionType>
+    <data>../data</data>
+    <debug>1</debug>
+    <extent>-180.0 -90.0 180.0 90.0</extent>
+    <Feature>
+      <wkt>POINT(2000 2500)</wkt>
+    </Feature>
+    <filter type="MSEXPR">(type=’road’ and size &lt; 2)</filter>
+    <filterItem>pop</filterItem>
+    <footer>http://mapgears.com/templates/myfooter1.html</footer>
+    <Grid>
+      <labelFormat>DDMMSS</labelFormat>
+      <maxArcs>5.0</maxArcs>
+      <maxInterval>0.5</maxInterval>
+      <maxSubdivide>0.07</maxSubdivide>
+      <minArcs>1.0</minArcs>
+      <minInterval>0.05</minInterval>
+      <minSubdivide>0.01</minSubdivide>
+    </Grid>
+    <group>group1</group>
+    <header>http://mapgears.com/templates/myHeader1.html</header>
+    <Join name="myJoin1" type="ONE-TO-MANY">
+      <connection>user=nobody password=****** dbname=dbname host=localhost port=5432</connection>
+      <connectionType>POSTGRESQL</connectionType>
+      <from>ID</from>
+      <table>./data/lookup.dbf</table>
+      <template>http://mapgears.com/templates/myJoin1.html</template>
+      <to>IDENT</to>
+    </Join>
+    <labelCache>ON</labelCache>
+    <labelItem>myLabel1</labelItem>
+    <labelMaxScaleDenom>2334342</labelMaxScaleDenom>
+    <labelMinScaleDenom>100000</labelMinScaleDenom>
+    <labelRequires>![orthoquads]</labelRequires>
+    <mask>layerName</mask>
+    <maxFeatures>250000</maxFeatures>
+    <maxScaleDenom>300000</maxScaleDenom>
+    <Metadata>
+      <item name="description">Cities</item>
+      <item name="title">The Cities</item>
+      <item name="author">Norm</item>
+    </Metadata>
+    <minScaleDenom>120000</minScaleDenom>
+    <offsite red="244" green="43" blue="22"/>
+    <opacity>ALPHA</opacity>
+    <plugin>myPlugin.lib</plugin>
+    <postLabelCache>TRUE</postLabelCache>
+    <processing>CLOSE_CONNECTION=DEFER</processing>
+    <processing>SCALE=AUTO</processing>
+    <projection>init=epsg:4326 ellps=WGS84 datum=WGS84</projection>
+    <requires>[orthoquads]</requires>
+    <sizeUnits>METERS</sizeUnits>
+    <styleItem>Go</styleItem>
+    <symbolScaleDenom>24000</symbolScaleDenom>
+    <template>myLayer1.html</template>
+    <tileIndex>tiger/index.shp</tileIndex>
+    <tileItem>LOCATION</tileItem>
+    <tolerance>5</tolerance>
+    <toleranceUnits>DD</toleranceUnits>
+    <transform>TRUE</transform>
+    <units>METERS</units>
+    <Validation>
+      <item name="firstname">^[a-zA-Z\-]+$</item>
+      <item name="taxid">^[A-Z]{2}[0-9]{6}$</item>
+    </Validation>
+  </Layer>
+</LayerSet>
+
diff -pruN 8.0.1-5/src/xmlmapfile/tests/mapfile-test.xml 8.2.0~beta1-1~exp1/src/xmlmapfile/tests/mapfile-test.xml
--- 8.0.1-5/src/xmlmapfile/tests/mapfile-test.xml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/xmlmapfile/tests/mapfile-test.xml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,207 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<Map name="xmlmapfile" xmlns="http://www.mapserver.org/mapserver" status="ON" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.mapserver.org/mapserver ../mapfile.xsd" version="5.6.0">
+	<angle>10</angle>
+	<Config>
+		<item name="CGI_CONTEXT_URL">http://mapgears.com/context/mapgears.xml</item>
+		<item name="MS_ENCRYPTION_KEY">dfas2klaed2v 3384knkju3k23</item>
+		<item name="MS_ERRORFILE">/tmp/ms_error.txt</item>
+	</Config>
+	<dataPattern>$#[a-e]?</dataPattern>
+	<debug>2</debug>
+	<defResolution>72</defResolution>
+	<extent>-180.0 -90.0 180.0 90.0</extent>
+	<fontSet>../etc/fonts.txt</fontSet>
+	<imageColor red="0" green="255" blue="255"/>
+	<imageType>png</imageType>
+        <include>/tmp/myLayerSet.map</include>
+        <include>/tmp/AnotherLayerSet.map</include>
+	<Legend status="ON">
+		<imageColor red="255" green="255" blue="255"/>
+		<keySize x="20" y="10"/>
+		<keySpacing x="5" y="5"/>
+		<Label type="TRUETYPE">
+			<align>CENTER</align>
+			<angle>FOLLOW</angle>
+			<antialias>TRUE</antialias>
+			<buffer>2</buffer>
+			<colorAttribute>[myColor]</colorAttribute>
+			<encoding>ISO 8859-1</encoding>
+			<font>serif</font>
+			<force>TRUE</force>
+			<maxLength>244</maxLength>
+			<maxOverlapAngle>30</maxOverlapAngle>
+			<maxSize>244</maxSize>
+			<minDistance>24</minDistance>
+			<minFeatureSize>AUTO</minFeatureSize>
+			<minSize>6</minSize>
+			<offset x="12" y="33"/>
+			<outlineColor red="244" green="43" blue="22"/>
+			<outlineWidth>13</outlineWidth>
+			<partials>TRUE</partials>
+			<position>LL</position>
+			<priority>5</priority>
+			<shadowColor red="244" green="43" blue="22"/>
+			<shadowSize x="15" y="14"/>
+			<size>SMALL</size>
+			<wrap>\n</wrap>
+		</Label>
+		<outlineColor red="244" green="43" blue="22"/>
+		<position>LR</position>
+		<postLabelCache>FALSE</postLabelCache>
+		<template>ttt.html</template>
+	</Legend>
+	<maxSize>2048</maxSize>
+        <OutputFormat name="GTiff">
+          <driver>GDAL/GTIFF</driver>
+          <extension>tiff</extension>
+          <formatOption>TILED=YES</formatOption>
+          <formatOption>TRANSPARENCY=TRUE</formatOption>
+          <imageMode>FLOAT32</imageMode>
+          <mimeType>image/tiff</mimeType>
+          <transparent>OFF</transparent>
+        </OutputFormat>
+        <OutputFormat name="PNG">
+          <driver>AGG/PNG</driver>
+          <extension>png</extension>
+          <formatOption>TILED=YES</formatOption>
+          <imageMode>RGBA</imageMode>
+          <mimeType>image/png</mimeType>
+          <transparent>ON</transparent>
+        </OutputFormat>
+	<projection>
+          proj=utm
+          ellps=GRS80
+          datum=NAD83
+          zone=15
+          units=m
+          north
+          no_defs
+        </projection>
+	<QueryMap status="ON">
+		<color red="244" green="43" blue="22"/>
+		<size x="600" y="400"/>
+		<style>SELECTED</style>
+	</QueryMap>
+	<Reference status="ON">
+		<color red="244" green="43" blue="22"/>
+		<extent>-10.0 -9.0 10.0 9.0</extent>
+		<image>/home/myusername/ref1.png</image>
+		<marker>star</marker>
+		<markerSize>3</markerSize>
+		<maxBoxSize>24</maxBoxSize>
+		<minBoxSize>4</minBoxSize>
+		<outlineColor red="244" green="43" blue="22"/>
+		<size x="6" y="4"/>
+	</Reference>
+	<resolution>72</resolution>
+	<ScaleBar status="EMBED">
+		<align>CENTER</align>
+		<backgroundColor red="244" green="43" blue="22"/>
+		<color red="244" green="43" blue="22"/>
+		<imageColor red="0" green="255" blue="255"/>
+		<intervals>5</intervals>
+		<Label type="TRUETYPE">
+			<align>CENTER</align>
+			<angle>[myAngle]</angle>
+			<antialias>FALSE</antialias>
+			<buffer>2</buffer>
+			<colorAttribute>[myColor]</colorAttribute>
+			<encoding>ISO 8859-1</encoding>
+			<font>serif</font>
+			<force>TRUE</force>
+			<maxLength>244</maxLength>
+			<maxSize>244</maxSize>
+			<minDistance>24</minDistance>
+			<minFeatureSize>AUTO</minFeatureSize>
+			<minSize>6</minSize>
+			<offset x="12" y="33"/>
+			<outlineColor red="244" green="43" blue="22"/>
+			<outlineWidth>13</outlineWidth>
+			<partials>TRUE</partials>
+			<position>LL</position>
+			<priority>5</priority>
+			<shadowColor red="244" green="43" blue="22"/>
+			<shadowSize x="15" y="14"/>
+			<size>SMALL</size>
+                        <Style>
+                          <geomTransform>VERTICES</geomTransform>
+                          <initialGap>20.5</initialGap>
+                          <polarOffset>[uv_length_2] [uv_angle]</polarOffset>
+                        </Style>
+                        <Style>
+                          <initialGap>2</initialGap>
+                        </Style>
+			<wrap>\n</wrap>
+		</Label>
+		<outlineColor red="12" green="45" blue="12"/>
+		<position>LR</position>
+		<postLabelCache>TRUE</postLabelCache>
+		<size x="90" y="8"/>
+		<style>0</style>
+                <transparent>ON</transparent>
+		<units>NAUTICALMILES</units>
+	</ScaleBar>
+	<scaleDenom>24000</scaleDenom>
+	<shapePath>../data</shapePath>
+	<size x="600" y="400"/>
+	<Symbol name="mySymbol2-test2" type="SIMPLE">
+		<antialias>FALSE</antialias>
+		<character>C</character>
+		<filled>TRUE</filled>
+		<font>serif</font>
+		<image>/tmp/test.gif</image>
+		<Points>
+			<point x="2" y="-3"/>
+		</Points>
+		<transparent>123</transparent>
+	</Symbol>
+        <Symbol name="mySymbol222-test1" type="SIMPLE">
+          <antialias>FALSE</antialias>
+          <character>C</character>
+          <filled>TRUE</filled>
+          <font>serif</font>
+          <image>/tmp/test.gif</image>
+          <Points>
+            <point x="2" y="-3"/>
+          </Points>
+          <transparent>123</transparent>
+        </Symbol>
+	<symbolSet>/tmp/mySymbolSet.sym</symbolSet>
+	<templatePattern>[$ir-wz]*.html</templatePattern>
+	<units>MILES</units>
+        <Web>
+          <browseFormat>text/html</browseFormat>
+          <empty>../errors/queryfail1.html</empty>
+          <error>../errors/error1.html</error>
+          <footer>../templates/footer1.html</footer>
+          <header>../templates/header.html</header>
+          <imagePath>/tmp/ms_tmp/</imagePath>
+          <imageUrl>/ms_tmp/</imageUrl>
+          <legendFormat>text/html</legendFormat>
+          <log>../logs/ms.log</log>
+          <maxScaleDenom>240000</maxScaleDenom>
+          <maxTemplate>../templates/maxtemplate1.html</maxTemplate>
+          <Metadata>
+            <item name="description">Cities</item>
+            <item name="title">The Cities</item>
+            <item name="author">Norm</item>
+          </Metadata>
+          <minScaleDenom>120000</minScaleDenom>
+          <minTemplate>../templates/mintemplate1.html</minTemplate>
+          <queryFormat>text/html</queryFormat>
+          <template>http://mapgears.com/templates/myTemplates1.html</template>
+          <Validation>
+            <item name="firstname">^[a-zA-Z\-]+$</item>
+            <item name="taxid">^[A-Z]{2}[0-9]{6}$</item>
+          </Validation>
+	</Web>
+</Map>
+
+
+
+
+
+
+
+
+
diff -pruN 8.0.1-5/src/xmlmapfile/tests/symbolset.xml 8.2.0~beta1-1~exp1/src/xmlmapfile/tests/symbolset.xml
--- 8.0.1-5/src/xmlmapfile/tests/symbolset.xml	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/src/xmlmapfile/tests/symbolset.xml	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,26 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<SymbolSet xmlns="http://www.mapserver.org/mapserver" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.mapserver.org/mapserver ../mapfile.xsd">
+	<Symbol name="mySymbol2" type="SIMPLE">
+		<antialias>FALSE</antialias>
+		<character>C</character>
+		<filled>TRUE</filled>
+		<font>serif</font>
+		<image>/tmp/test.gif</image>
+		<Points>
+			<point x="2" y="-3"/>
+		</Points>
+		<transparent>0</transparent>
+	</Symbol>
+        <Symbol name="mySymbol222" type="SIMPLE">
+          <anchorPoint x="0.5" y="0.2"/>
+          <antialias>FALSE</antialias>
+          <character>C</character>
+          <filled>TRUE</filled>
+          <font>serif</font>
+          <image>/tmp/test.gif</image>
+          <Points>
+            <point x="2" y="-3"/>
+          </Points>
+          <transparent>123</transparent>
+        </Symbol>
+</SymbolSet>
diff -pruN 8.0.1-5/strptime.c 8.2.0~beta1-1~exp1/strptime.c
--- 8.0.1-5/strptime.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/strptime.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,442 +0,0 @@
-/*
- * Copyright (c) 1999 Kungliga Tekniska Högskolan
- * (Royal Institute of Technology, Stockholm, Sweden).
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * 3. Neither the name of KTH nor the names of its contributors may be
- *    used to endorse or promote products derived from this software without
- *    specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY KTH AND ITS CONTRIBUTORS ``AS IS'' AND ANY
- * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL KTH OR ITS CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
- * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
- * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
- * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
- * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-
-#include <ctype.h>
-#include <stdlib.h>
-#include <stddef.h>
-#include <stdio.h>
-#include <string.h>
-#include <time.h>
-#include "mapserver.h"
-
-static const char *const abb_weekdays[] = {
-  "Sun",
-  "Mon",
-  "Tue",
-  "Wed",
-  "Thu",
-  "Fri",
-  "Sat",
-  NULL
-};
-
-static const char *const full_weekdays[] = {
-  "Sunday",
-  "Monday",
-  "Tuesday",
-  "Wednesday",
-  "Thursday",
-  "Friday",
-  "Saturday",
-  NULL
-};
-
-static const char *const abb_month[] = {
-  "Jan",
-  "Feb",
-  "Mar",
-  "Apr",
-  "May",
-  "Jun",
-  "Jul",
-  "Aug",
-  "Sep",
-  "Oct",
-  "Nov",
-  "Dec",
-  NULL
-};
-
-static const char *const full_month[] = {
-  "January",
-  "February",
-  "Mars",
-  "April",
-  "May",
-  "June",
-  "July",
-  "August",
-  "September",
-  "October",
-  "November",
-  "December",
-  NULL,
-};
-
-static const char *const ampm[] = {
-  "am",
-  "pm",
-  NULL
-};
-
-/*
- * tm_year is relative this year
- */
-static const int tm_year_base = 1900;
-
-/*
- * Return TRUE iff `year' was a leap year.
- * Needed for strptime.
- */
-static int
-is_leap_year (int year)
-{
-  return (year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0);
-}
-
-/* Needed for strptime. */
-static int
-match_string (const char **buf, const char *const*strs)
-{
-  int i = 0;
-
-  for (i = 0; strs[i] != NULL; ++i) {
-    int len = strlen (strs[i]);
-
-    if (strncasecmp (*buf, strs[i], len) == 0) {
-      *buf += len;
-      return i;
-    }
-  }
-  return -1;
-}
-
-/* Needed for strptime. */
-static int
-first_day (int year)
-{
-  int ret = 4;
-
-  for (; year > 1970; --year)
-    ret = (ret + 365 + is_leap_year (year) ? 1 : 0) % 7;
-  return ret;
-}
-
-/*
- * Set `timeptr' given `wnum' (week number [0, 53])
- * Needed for strptime
- */
-
-static void
-set_week_number_sun (struct tm *timeptr, int wnum)
-{
-  int fday = first_day (timeptr->tm_year + tm_year_base);
-
-  timeptr->tm_yday = wnum * 7 + timeptr->tm_wday - fday;
-  if (timeptr->tm_yday < 0) {
-    timeptr->tm_wday = fday;
-    timeptr->tm_yday = 0;
-  }
-}
-
-/*
- * Set `timeptr' given `wnum' (week number [0, 53])
- * Needed for strptime
- */
-
-static void
-set_week_number_mon (struct tm *timeptr, int wnum)
-{
-  int fday = (first_day (timeptr->tm_year + tm_year_base) + 6) % 7;
-
-  timeptr->tm_yday = wnum * 7 + (timeptr->tm_wday + 6) % 7 - fday;
-  if (timeptr->tm_yday < 0) {
-    timeptr->tm_wday = (fday + 1) % 7;
-    timeptr->tm_yday = 0;
-  }
-}
-
-/*
- * Set `timeptr' given `wnum' (week number [0, 53])
- * Needed for strptime
- */
-static void
-set_week_number_mon4 (struct tm *timeptr, int wnum)
-{
-  int fday = (first_day (timeptr->tm_year + tm_year_base) + 6) % 7;
-  int offset = 0;
-
-  if (fday < 4)
-    offset += 7;
-
-  timeptr->tm_yday = offset + (wnum - 1) * 7 + timeptr->tm_wday - fday;
-  if (timeptr->tm_yday < 0) {
-    timeptr->tm_wday = fday;
-    timeptr->tm_yday = 0;
-  }
-}
-
-/* strptime: roken */
-/* extern "C" */
-char *
-/* strptime (const char *buf, const char *format, struct tm *timeptr) */
-strptime (const char *buf, const char *format, struct tm *timeptr)
-{
-  char c;
-
-  for (; (c = *format) != '\0'; ++format) {
-    char *s;
-    int ret;
-
-    if (isspace (c)) {
-      while (isspace (*buf))
-        ++buf;
-    } else if (c == '%' && format[1] != '\0') {
-      c = *++format;
-      if (c == 'E' || c == 'O')
-        c = *++format;
-      switch (c) {
-        case 'A' :
-          ret = match_string (&buf, full_weekdays);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_wday = ret;
-          break;
-        case 'a' :
-          ret = match_string (&buf, abb_weekdays);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_wday = ret;
-          break;
-        case 'B' :
-          ret = match_string (&buf, full_month);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_mon = ret;
-          break;
-        case 'b' :
-        case 'h' :
-          ret = match_string (&buf, abb_month);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_mon = ret;
-          break;
-        case 'C' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_year = (ret * 100) - tm_year_base;
-          buf = s;
-          break;
-        case 'c' :
-          abort ();
-        case 'D' :    /* %m/%d/%y */
-          s = strptime (buf, "%m/%d/%y", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'd' :
-        case 'e' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_mday = ret;
-          buf = s;
-          break;
-        case 'H' :
-        case 'k' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_hour = ret;
-          buf = s;
-          break;
-        case 'I' :
-        case 'l' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          if (ret == 12)
-            timeptr->tm_hour = 0;
-          else
-            timeptr->tm_hour = ret;
-          buf = s;
-          break;
-        case 'j' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_yday = ret - 1;
-          buf = s;
-          break;
-        case 'm' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_mon = ret - 1;
-          buf = s;
-          break;
-        case 'M' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_min = ret;
-          buf = s;
-          break;
-        case 'n' :
-          if (*buf == '\n')
-            ++buf;
-          else
-            return NULL;
-          break;
-        case 'p' :
-          ret = match_string (&buf, ampm);
-          if (ret < 0)
-            return NULL;
-          if (timeptr->tm_hour == 0) {
-            if (ret == 1)
-              timeptr->tm_hour = 12;
-          } else
-            timeptr->tm_hour += 12;
-          break;
-        case 'r' :    /* %I:%M:%S %p */
-          s = strptime (buf, "%I:%M:%S %p", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'R' :    /* %H:%M */
-          s = strptime (buf, "%H:%M", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'S' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_sec = ret;
-          buf = s;
-          break;
-        case 't' :
-          if (*buf == '\t')
-            ++buf;
-          else
-            return NULL;
-          break;
-        case 'T' :    /* %H:%M:%S */
-        case 'X' :
-          s = strptime (buf, "%H:%M:%S", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'u' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_wday = ret - 1;
-          buf = s;
-          break;
-        case 'w' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_wday = ret;
-          buf = s;
-          break;
-        case 'U' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          set_week_number_sun (timeptr, ret);
-          buf = s;
-          break;
-        case 'V' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          set_week_number_mon4 (timeptr, ret);
-          buf = s;
-          break;
-        case 'W' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          set_week_number_mon (timeptr, ret);
-          buf = s;
-          break;
-        case 'x' :
-          s = strptime (buf, "%Y:%m:%d", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'y' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          if (ret < 70)
-            timeptr->tm_year = 100 + ret;
-          else
-            timeptr->tm_year = ret;
-          buf = s;
-          break;
-        case 'Y' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_year = ret - tm_year_base;
-          buf = s;
-          break;
-        case 'Z' :
-          abort ();
-        case '\0' :
-          --format;
-          /* FALLTHROUGH */
-        case '%' :
-          if (*buf == '%')
-            ++buf;
-          else
-            return NULL;
-          break;
-        default :
-          if (*buf == '%' || *++buf == c)
-            ++buf;
-          else
-            return NULL;
-          break;
-      }
-    } else {
-      if (*buf == c)
-        ++buf;
-      else
-        return NULL;
-    }
-  }
-  return (char *)buf;
-}
-
-#endif
diff -pruN 8.0.1-5/sym2img.c 8.2.0~beta1-1~exp1/sym2img.c
--- 8.0.1-5/sym2img.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/sym2img.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,178 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Commandline utility to render symbols to a raster.
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <gd.h>
-#include <gdfontt.h>
-
-#include "mapserver.h"
-
-
-
-#define MAXCOLORS 256
-#define CELLSIZE 100
-#define NCOLS 5
-#define RATIO .5
-#define LBUF 5 /* space to reserve around line symbols */
-
-int main(int argc, char *argv[])
-{
-  FILE *stream;
-  int ns,n,k;
-  gdImagePtr img;
-  shapeObj p;
-  int i,j;
-  int ncols,nrows;
-  char buffer[256];
-  int gray, green, red, black, white;
-  classObj class;
-  symbolSetObj symbolSet;
-
-  /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 2 ) {
-    fprintf(stdout, "Syntax: sym2img [symbolset] [outfile]\n" );
-    exit(0);
-  }
-
-  /* Initialize the polygon/polyline */
-  p.line = (lineObj *)malloc(sizeof(lineObj));
-  p.numlines = 1;
-  p.line[0].point = (pointObj *)malloc(sizeof(pointObj)*4);
-  p.line[0].numpoints = 4;
-
-  /* Initialize the symbol and font sets */
-  symbolSet.filename = msStrdup(argv[1]);
-
-  /*
-  ** load the symbol file
-  */
-  if(msLoadSymbolSet(&symbolSet) == -1) {
-    msWriteError(stderr);
-    exit(1);
-  }
-
-  ns = symbolSet.numsymbols;
-
-  if(ns < NCOLS) {
-    ncols = ns;
-    nrows = 1;
-  } else {
-    ncols = NCOLS;
-    nrows = (int)ceil((double)ns/NCOLS);
-  }
-
-  img = gdImageCreate(ncols*CELLSIZE, nrows*CELLSIZE);
-
-  gray = gdImageColorAllocate(img, 222, 222, 222);
-  white = gdImageColorAllocate(img, 255, 255, 255);
-  green = gdImageColorAllocate(img, 40, 170, 40);
-  black = gdImageColorAllocate(img, 0, 0, 0);
-  red = gdImageColorAllocate(img, 255, 0, 0);
-
-  class.color = red;
-  class.backgroundcolor = white;
-  class.outlinecolor = black;
-
-  n=0;
-
-  for(i=0; n<ns; i+=CELLSIZE) {
-    k=0;
-    for(j=0; n<ns; j+=CELLSIZE) {
-      if (k == ncols) break;
-      k++;
-      gdImageFilledRectangle(img,j,i,j+CELLSIZE, i+CELLSIZE, gray);
-
-      class.symbol = n;
-
-      switch(symbolSet.type) {
-        case(MS_MARKERSET):
-          class.sizescaled = RATIO*CELLSIZE;
-          p.line[0].point[0].x = MS_NINT(j + CELLSIZE/2);
-          p.line[0].point[0].y = MS_NINT(i + CELLSIZE/2);
-          p.line[0].numpoints = 1;
-          msDrawMarkerSymbol(&(symbolSet), img, &(p.line[0].point[0]), &(class));
-          break;
-
-        case(MS_LINESET):
-          class.sizescaled = 1;
-          p.line[0].point[0].x = j;
-          p.line[0].point[0].y = i + (CELLSIZE-LBUF) - 1;
-          p.line[0].point[1].x = j + MS_NINT((CELLSIZE-LBUF)/3.0) - 1;
-          p.line[0].point[1].y = i;
-          p.line[0].point[2].x = j + MS_NINT(2*(CELLSIZE-LBUF)/3.0) - 1;
-          p.line[0].point[2].y = i + (CELLSIZE-LBUF) - 1;
-          p.line[0].point[3].x = j + (CELLSIZE-LBUF) - 1;
-          p.line[0].point[3].y = i;
-          p.line[0].numpoints = 4;
-          msDrawLineSymbol(map, img, &p, &(class));
-          break;
-
-        case(MS_SHADESET):
-          class.sizescaled = 5;
-          p.line[0].point[0].x = j;
-          p.line[0].point[0].y = i;
-          p.line[0].point[1].x = j + CELLSIZE-1;
-          p.line[0].point[1].y = i;
-          p.line[0].point[2].x = j + CELLSIZE-1;
-          p.line[0].point[2].y = i + CELLSIZE-1 ;
-          p.line[0].point[3].x = j;
-          p.line[0].point[3].y = i + CELLSIZE-1;
-          p.line[0].numpoints = 4;
-          msDrawShadeSymbol(&(symbolSet), img, &p, &(class));
-          break;
-
-        default:
-          break;
-      }
-
-      if(symbolSet.symbol[n]->name)
-        snprintf(buffer, sizeof(buffer), "%d - %s", n, symbolSet.symbol[n]->name);
-      else
-        snprintf(buffer, sizeof(buffer), "%d", n);
-      gdImageString(img, gdFontTiny, j+1, i+1, buffer, black);
-
-      n++;
-    }
-  }
-
-  if((stream = fopen(argv[2],"wb")) == NULL) { /* open the file */
-    fprintf(stderr, "Unable to open output file: %s\n", argv[2]);
-    exit(1);
-  }
-#ifndef USE_GD_GIF
-  gdImageGif(img, stream);
-#else
-  gdImagePng(img, stream);
-#endif
-  gdImageDestroy(img);
-  free(symbolSet.filename);
-  fclose(stream);
-
-  return(MS_TRUE);
-}
-
diff -pruN 8.0.1-5/testcopy.c 8.2.0~beta1-1~exp1/testcopy.c
--- 8.0.1-5/testcopy.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/testcopy.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,85 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Test of msCopyMap()
- * Author:   Sean Gilles
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include "mapserver.h"
-
-
-
-void printAtts(mapObj*, const char*);
-
-int main(int argc, char *argv[])
-{
-
-  mapObj *original_map, *clone_map;
-
-  /* ---------------------------------------------------------------------
-   * Test 1: free original before freeing clone
-   * --------------------------------------------------------------------- */
-
-  /* Load map file */
-  original_map = msLoadMap("tests/test.map", NULL);
-
-  if (original_map ==  NULL) {
-    /* Write errors */
-    msWriteError(stderr);
-    msResetErrorList();
-    exit(0);
-  }
-
-  /* Dump out some attributes */
-  printAtts(original_map, "Original");
-
-  /* Clone it */
-  clone_map = msNewMapObj();
-  msCopyMap(clone_map, original_map);
-
-  /* Write errors */
-  msWriteError(stderr);
-  msResetErrorList();
-
-  /* Free */
-  msFreeMap(original_map);
-
-  /* Dump clone's attributes */
-  printAtts(clone_map, "Clone");
-
-  /* Free clone */
-  msFreeMap(clone_map);
-
-  exit(0);
-}
-
-void printAtts(mapObj *map, const char *title)
-{
-  printf("\n%s Attributes\n----------------------\n", title);
-  printf("Map Name: %s\n", map->name);
-  printf("Numlayers: %d\n", map->numlayers);
-  printf("Map Fontset Filename: %s\n", map->fontset.filename);
-  printf("Map Symbolset Filename: %s\n", map->symbolset.filename);
-}
diff -pruN 8.0.1-5/testexpr.c 8.2.0~beta1-1~exp1/testexpr.c
--- 8.0.1-5/testexpr.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/testexpr.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,71 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Commandline tester for expression evaluation
- * Author:   Steve Lime and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#include <time.h>
-
-#include "mapserver.h"
-#include "mapparser.h"
-#include "mapfile.h"
-
-
-
-extern int msyyparse();
-extern int msyylex();
-extern char *msyystring_buffer;
-
-extern int msyyresult; /* result of parsing, true/false */
-extern int msyystate;
-extern char *msyystring;
-
-int main(int argc, char *argv[])
-{
-  int status;
-
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
-    printf("%s\n", msGetVersion());
-    exit(0);
-  }
-
-  /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 2) {
-    fprintf(stdout, "Syntax: testexpr [string]\n");
-    exit(0);
-  }
-
-  msyystate = MS_TOKENIZE_EXPRESSION;
-  msyystring = argv[1];
-
-  status = msyyparse();
-  if(status != 0)
-    printf("Error parsing expression near %s.\n", msyystring_buffer);
-  else
-    printf("Expression evalulated to: %d.\n", msyyresult);
-
-  exit(0);
-}
diff -pruN 8.0.1-5/tests/unit/test.cpp 8.2.0~beta1-1~exp1/tests/unit/test.cpp
--- 8.0.1-5/tests/unit/test.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 8.2.0~beta1-1~exp1/tests/unit/test.cpp	2024-06-06 20:07:58.000000000 +0000
@@ -0,0 +1,74 @@
+#include "mapserver.h"
+#include "maperror.h"
+
+/* ----------------------------------------------------------------------- */
+
+int gTestRetCode = 0;
+
+// Poor man GoogleTest like framework
+
+static void EXPECT_STREQ_func(const char *got, const char *expected,
+                              const char *function, int line) {
+  if (strcmp(got, expected) != 0) {
+    fprintf(stderr, "EXPECT_STREQ(\"%s\", \"%s\") failed at %s:%d\n", got,
+            expected, function, line);
+    gTestRetCode = 1;
+  }
+}
+
+#define EXPECT_STREQ(got, expected)                                            \
+  EXPECT_STREQ_func(got, expected, __func__, __LINE__)
+
+/* ----------------------------------------------------------------------- */
+
+static void testRedactCredentials() {
+  {
+    std::string s("foo");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "foo");
+  }
+  {
+    std::string s("password=");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "password=");
+  }
+  {
+    std::string s("PG:dbname=foo password=mypassword");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "PG:dbname=foo password=*");
+  }
+  {
+    std::string s("PG:dbname=foo password=mypassword\n");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "PG:dbname=foo password=*\n");
+  }
+  {
+    std::string s("PG:dbname=foo password=mypassword something=else\n");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "PG:dbname=foo password=* something=else\n");
+  }
+  {
+    std::string s(
+        "PG:dbname=foo password='mypassword with\"\\'space' something=else\n");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "PG:dbname=foo password='*' something=else\n");
+  }
+  {
+    std::string s("\\SQL2019;DATABASE=msautotest;pwd=Password12!;uid=sa;\n");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "\\SQL2019;DATABASE=msautotest;pwd=*;uid=sa;\n");
+  }
+  {
+    std::string s(
+        "\\SQL2019;DATABASE=msautotest;pwd={Password12!;foo};uid=sa;\n");
+    msRedactCredentials(&s[0]);
+    EXPECT_STREQ(s.data(), "\\SQL2019;DATABASE=msautotest;pwd={*};uid=sa;\n");
+  }
+}
+
+/* ----------------------------------------------------------------------- */
+
+int main() {
+  testRedactCredentials();
+  return gTestRetCode;
+}
diff -pruN 8.0.1-5/textlayout.c 8.2.0~beta1-1~exp1/textlayout.c
--- 8.0.1-5/textlayout.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/textlayout.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,894 +0,0 @@
-/******************************************************************************
- *
- * Project:  MapServer
- * Purpose:  Text Layout functions, eventually using Harfbuzz and Fribidi/ICU
- * Author:   Thomas Bonfort and the MapServer team.
- *
- ******************************************************************************
- * Copyright (c) 1996-2013 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-
-#include <float.h>
-#include "mapserver.h"
-
-#ifdef USE_ICONV
-#include <iconv.h>
-#include <wchar.h>
-#endif
-#include "fontcache.h"
-#include FT_ADVANCES_H
-#include FT_TYPES_H
-
-typedef struct{
-  unsigned int *unicodes;
-  unsigned int *codepoints;
-#ifdef USE_FRIBIDI
-  FriBidiCharType *ctypes;
-  FriBidiLevel *bidi_levels;
-#endif
-#ifdef USE_HARFBUZZ
-  hb_script_t *scripts;
-#endif
-} TextInfo;
-
-typedef struct {
-  int offset; /* offset in TextInfo entries where the current run is starting */
-  int length; /* number of unicode glyphs in this run */
-#ifdef USE_FRIBIDI
-  FriBidiLevel rtl; /* bidi embedding level of run: -1 to skip shaping, otherwise if pair:ltr, odd:rtl */
-  hb_script_t script; /* script: latin, arabic, thai, etc... */
-#endif
-  int line_number;
-  face_element *face; /* font face to use for this run */
-} text_run;
-
-#ifdef USE_HARFBUZZ
-struct _ms_hb_user_data {
-  text_run *run;
-  TextInfo *info;
-  int glyph_size;
-};
-
-const char *_ms_script_prefix_en = "en:";
-const char *_ms_script_prefix_ar = "ar:";
-const char *_ms_script_prefix_cn = "cn:";
-const char *_ms_script_prefix_hy = "hy:";
-const char *_ms_script_prefix_bn = "bn:";
-const char *_ms_script_prefix_iu = "iu";
-const char *_ms_script_prefix_chr= "chr:";
-const char *_ms_script_prefix_cop= "cop:";
-const char *_ms_script_prefix_ru = "ru:";
-const char *_ms_script_prefix_hi = "hi:";
-const char *_ms_script_prefix_ka = "ka:";
-const char *_ms_script_prefix_el = "el:";
-const char *_ms_script_prefix_gu = "gu:";
-const char *_ms_script_prefix_pa = "pa:";
-const char *_ms_script_prefix_ko = "ko:";
-const char *_ms_script_prefix_he = "he:";
-const char *_ms_script_prefix_ja = "ja:";
-const char *_ms_script_prefix_kn = "kn:";
-const char *_ms_script_prefix_lo = "lo:";
-const char *_ms_script_prefix_ml = "ml:";
-const char *_ms_script_prefix_mn = "mn:";
-const char *_ms_script_prefix_or = "or:";
-const char *_ms_script_prefix_syr= "syr:";
-const char *_ms_script_prefix_ta = "ta:";
-const char *_ms_script_prefix_te = "te:";
-const char *_ms_script_prefix_th = "th:";
-const char *_ms_script_prefix_bo = "bo:";
-const char *_ms_script_prefix_am = "am:";
-const char *_ms_script_prefix_km = "km:";
-const char *_ms_script_prefix_my = "my:";
-const char *_ms_script_prefix_si = "si:";
-const char *_ms_script_prefix_dv = "dv:";
-const char *_ms_script_prefix_bku= "bku:";
-const char *_ms_script_prefix_hnn= "hnn:";
-const char *_ms_script_prefix_tl = "tl:";
-const char *_ms_script_prefix_tbw= "tbw:";
-const char *_ms_script_prefix_uga= "uga:";
-const char *_ms_script_prefix_bug= "bug:";
-const char *_ms_script_prefix_peo= "peo:";
-const char *_ms_script_prefix_syl= "syl:";
-const char *_ms_script_prefix_nko= "nko:";
-
-const char* prefix_from_script(hb_script_t script) {
-  switch(script) {
-  case HB_SCRIPT_LATIN:               return _ms_script_prefix_en;
-  case HB_SCRIPT_ARABIC:              return _ms_script_prefix_ar;
-  case HB_SCRIPT_HAN:                 return _ms_script_prefix_cn;
-  case HB_SCRIPT_ARMENIAN:            return _ms_script_prefix_hy;
-  case HB_SCRIPT_BENGALI:             return _ms_script_prefix_bn;
-  case HB_SCRIPT_CANADIAN_ABORIGINAL: return _ms_script_prefix_iu;
-  case HB_SCRIPT_CHEROKEE:            return _ms_script_prefix_chr;
-  case HB_SCRIPT_COPTIC:              return _ms_script_prefix_cop;
-  case HB_SCRIPT_CYRILLIC:            return _ms_script_prefix_ru;
-  case HB_SCRIPT_DEVANAGARI:          return _ms_script_prefix_hi;
-  case HB_SCRIPT_GEORGIAN:            return _ms_script_prefix_ka;
-  case HB_SCRIPT_GREEK:               return _ms_script_prefix_el;
-  case HB_SCRIPT_GUJARATI:            return _ms_script_prefix_gu;
-  case HB_SCRIPT_GURMUKHI:            return _ms_script_prefix_pa;
-  case HB_SCRIPT_HANGUL:              return _ms_script_prefix_ko;
-  case HB_SCRIPT_HEBREW:              return _ms_script_prefix_he;
-  case HB_SCRIPT_HIRAGANA:            return _ms_script_prefix_ja;
-  case HB_SCRIPT_KANNADA:             return _ms_script_prefix_kn;
-  case HB_SCRIPT_KATAKANA:            return _ms_script_prefix_ja;
-  case HB_SCRIPT_LAO:                 return _ms_script_prefix_lo;
-  case HB_SCRIPT_MALAYALAM:           return _ms_script_prefix_ml;
-  case HB_SCRIPT_MONGOLIAN:           return _ms_script_prefix_mn;
-  case HB_SCRIPT_ORIYA:               return _ms_script_prefix_or;
-  case HB_SCRIPT_SYRIAC:              return _ms_script_prefix_syr;
-  case HB_SCRIPT_TAMIL:               return _ms_script_prefix_ta;
-  case HB_SCRIPT_TELUGU:              return _ms_script_prefix_te;
-  case HB_SCRIPT_THAI:                return _ms_script_prefix_th;
-  case HB_SCRIPT_TIBETAN:             return _ms_script_prefix_bo;
-  case HB_SCRIPT_ETHIOPIC:            return _ms_script_prefix_am;
-  case HB_SCRIPT_KHMER:               return _ms_script_prefix_km;
-  case HB_SCRIPT_MYANMAR:             return _ms_script_prefix_my;
-  case HB_SCRIPT_SINHALA:             return _ms_script_prefix_si;
-  case HB_SCRIPT_THAANA:              return _ms_script_prefix_dv;
-  case HB_SCRIPT_BUHID:               return _ms_script_prefix_bku;
-  case HB_SCRIPT_HANUNOO:             return _ms_script_prefix_hnn;
-  case HB_SCRIPT_TAGALOG:             return _ms_script_prefix_tl;
-  case HB_SCRIPT_TAGBANWA:            return _ms_script_prefix_tbw;
-  case HB_SCRIPT_UGARITIC:            return _ms_script_prefix_uga;
-  case HB_SCRIPT_BUGINESE:            return _ms_script_prefix_bug;
-  case HB_SCRIPT_OLD_PERSIAN:         return _ms_script_prefix_peo;
-  case HB_SCRIPT_SYLOTI_NAGRI:        return _ms_script_prefix_syl;
-  case HB_SCRIPT_NKO:                 return _ms_script_prefix_nko;
-  default:
-    return NULL;
-
-  }
-}
-
-hb_feature_t hbfeatures[2] = {
-    {HB_TAG('v','e','r','t'),0,0,INT_MAX},
-    {HB_TAG('k','e','r','n'),0,0,INT_MAX}
-};
-
-static hb_bool_t _ms_get_glyph_func (hb_font_t *font, void *font_data,
-    hb_codepoint_t unicode, hb_codepoint_t variation_selector, hb_codepoint_t *glyph,
-		void *user_data)
-
-{
-  (void)font;
-  (void)variation_selector;
-  (void)user_data;
-  /* first check our run, as we have probably already computed this */
-  int i;
-  struct _ms_hb_user_data *ud = font_data;
-  unsigned int *unicodes = ud->info->unicodes + ud->run->offset;
-
-  for(i=0; i<ud->run->length; i++) {
-    if(unicodes[i] == unicode) {
-      *glyph = *(ud->info->codepoints + ud->run->offset + i);
-      return *glyph != 0;
-    }
-  }
-
-  {
-    FT_Face ft_face = ud->run->face->face;
-
-#ifdef HAVE_FT_FACE_GETCHARVARIANTINDEX
-    if ((variation_selector)) {
-      *glyph = FT_Face_GetCharVariantIndex (ft_face, unicode, variation_selector);
-      return *glyph != 0;
-    }
-#endif
-
-    *glyph = FT_Get_Char_Index (ft_face, unicode);
-    return *glyph != 0;
-  }
-}
-
-#if HB_VERSION_ATLEAST(1,2,3)
-static hb_bool_t _ms_get_nominal_glyph_func(hb_font_t *font, void *font_data,
-                                            hb_codepoint_t unicode,
-                                            hb_codepoint_t *glyph,
-                                            void *user_data)
-{
-    return _ms_get_glyph_func(font, font_data, unicode, 0, glyph, user_data);
-}
-
-static hb_bool_t _ms_get_variation_glyph_func(hb_font_t *font, void *font_data,
-                                              hb_codepoint_t unicode,
-                                              hb_codepoint_t variation_selector,
-                                              hb_codepoint_t *glyph,
-                                              void *user_data)
-{
-    return _ms_get_glyph_func(font, font_data, unicode, variation_selector, glyph, user_data);
-}
-#endif
-
-static hb_position_t _ms_get_glyph_h_advance_func (hb_font_t *font, void *font_data,
-			   hb_codepoint_t glyph, void *user_data)
-{
-  (void)font;
-  (void)user_data;
-  struct _ms_hb_user_data *ud = font_data;
-  glyph_element *glyphc = msGetGlyphByIndex(ud->run->face,ud->glyph_size,glyph);
-  if(!glyphc)
-    return 0;
-  return glyphc->metrics.advance * 64;
-}
-
-static hb_position_t _ms_get_glyph_v_advance_func (hb_font_t *font, void *font_data,
-    hb_codepoint_t glyph, void *user_data)
-{
-  (void)font;
-  (void)font_data;
-  (void)glyph;
-  (void)user_data;
-  return 0; /* we don't support vertical layouts */
-}
-#endif
-
-static int check_single_font(fontSetObj *fontset, char *fontkey, text_run *run, TextInfo *glyphs, int ignore_missing) {
-  int i;
-  face_element *fcache = NULL;
-  if(fontset && fontkey) {
-    char *fontkey2 = strchr(fontkey,':'); /* try skipping prefix */
-    if(fontkey2) {
-      fcache = msGetFontFace(fontkey2+1, fontset);
-    }
-  }
-  if(!fcache)
-    fcache = msGetFontFace(fontkey, fontset);
-  run->face = fcache;
-  if(MS_UNLIKELY(!fcache)) return MS_FAILURE;
-  for(i=0; i<run->length; i++) {
-    unsigned int codepoint = msGetGlyphIndex(fcache, glyphs->unicodes[run->offset+i]);
-    if(codepoint || ignore_missing)
-    {
-      if( codepoint == 0 )
-      {
-          msDebug("Unable to find glyph for codepoint %u. Using ? as fallback.\n", glyphs->unicodes[run->offset+i]);
-          codepoint = msGetGlyphIndex(fcache, '?');
-      }
-      glyphs->codepoints[run->offset+i] = codepoint;
-    }
-    else
-      return MS_FAILURE;
-  }
-  return MS_SUCCESS;
-}
-
-static int get_face_for_run(fontSetObj *fontset, char *fontlist, text_run *run, TextInfo *glyphs) {
-  char *startfont, *endfont;
-#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
-  const char *prefix = NULL;
-#endif
-
-  if(!fontset || !fontlist) {
-    int ok = check_single_font(fontset,fontlist,run,glyphs,0);
-    (void)ok;
-    return MS_SUCCESS;
-  }
-
-#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
-  if(run->rtl >= 0) {
-    prefix = prefix_from_script(run->script);
-  } else {
-    prefix = _ms_script_prefix_en;
-  }
-
-  if(prefix) {
-    /* we'll first look for a font who's prefixed by the current script prefix, e.g, given the
-     * fontlist "arial,ar:arialuni,cn:cjk" check the "cjk" font first for HAN scripts
-     */
-    int prefixlen = strlen(prefix);
-    startfont = fontlist;
-    for(;;) {
-      if(!*startfont) break;
-      endfont = strchr(startfont,',');
-      if(!strncmp(startfont,prefix,prefixlen)) {
-        startfont += strlen(prefix);
-        if(endfont) *endfont = 0;
-        int ok = check_single_font(fontset,startfont,run,glyphs,0);
-        if(endfont) {
-          *endfont = ',';
-          if(ok == MS_SUCCESS) return MS_SUCCESS;
-          startfont = endfont+1; /* go to next font in list */
-        } else {
-          if(ok == MS_SUCCESS) return MS_SUCCESS;
-          break;
-        }
-      }
-      if(endfont)
-       startfont = endfont+1;
-      else break;
-    }
-  }
-#endif
-
-  /* no prefix, or prefix search didn't return satisfying result */
-  startfont = fontlist;
-  for(;;) {
-    if(!*startfont) break;
-    endfont = strchr(startfont,',');
-    if(endfont) *endfont = 0;
-    int ok = check_single_font(fontset,startfont,run,glyphs,!endfont); /* ignore failing glyphs if we're using the last font in the list */
-    if(endfont) {
-      *endfont = ',';
-      if(ok == MS_SUCCESS) return MS_SUCCESS;
-      startfont = endfont+1; /* go to next font in list */
-    } else {
-      if(ok == MS_SUCCESS) return MS_SUCCESS;
-      break;
-    }
-  }
-
-  return MS_FAILURE;
-}
-
-#ifdef USE_HARFBUZZ
-hb_font_t* get_hb_font(struct _ms_hb_user_data *font_data) {
-  face_element *fcache = font_data->run->face;
-  hb_font_element *hbf = fcache->hbfont;
-  FT_Face face = fcache->face;
-  int reqsize = MS_NINT(font_data->glyph_size *96.0 / 72.0);
-
-  if(reqsize != fcache->face->size->metrics.x_ppem) {
-    FT_Set_Pixel_Sizes(face,0,reqsize);
-  }
-
-  if(!hbf) {
-    hbf = msSmallMalloc(sizeof(hb_font_element));
-    hbf->hbparentfont = hb_ft_font_create(face,NULL);
-    hbf->hbfont = hb_font_create_sub_font(hbf->hbparentfont);
-    hbf->funcs = hb_font_funcs_create();
-    hb_font_funcs_set_glyph_h_advance_func(hbf->funcs, _ms_get_glyph_h_advance_func, NULL, NULL);
-#if HB_VERSION_ATLEAST(1,2,3)
-    hb_font_funcs_set_nominal_glyph_func(hbf->funcs, _ms_get_nominal_glyph_func, NULL, NULL);
-    hb_font_funcs_set_variation_glyph_func(hbf->funcs, _ms_get_variation_glyph_func, NULL, NULL);
-#else
-    hb_font_funcs_set_glyph_func(hbf->funcs, _ms_get_glyph_func, NULL, NULL);
-#endif
-    hb_font_funcs_set_glyph_v_advance_func(hbf->funcs, _ms_get_glyph_v_advance_func, NULL, NULL);
-    hbf->cursize = reqsize;
-    fcache->hbfont = hbf;
-    hb_font_set_funcs(hbf->hbfont, hbf->funcs, font_data, NULL);
-  } else {
-    if(hbf->cursize != reqsize) {
-      hb_font_set_scale (hbf->hbparentfont,
-          ((uint64_t) face->size->metrics.x_scale * (uint64_t) face->units_per_EM) >> 16,
-          ((uint64_t) face->size->metrics.y_scale * (uint64_t) face->units_per_EM) >> 16);
-      hb_font_set_ppem (hbf->hbparentfont, face->size->metrics.x_ppem, face->size->metrics.y_ppem);
-      hbf->cursize = reqsize;
-    }
-  }
-  hb_font_set_funcs_data(hbf->hbfont,font_data,NULL);
-  return hbf->hbfont;
-}
-
-/*
- *  Return non-zero (true) if the given unicode array contains
- *  only ASCII and ISO Latin-1 characters, otherwise return zero.
- */
-int unicode_is_latin1(const unsigned int *unicode, long nglyphs)
-{
-  long i;
-
-  for (i=0; i < nglyphs; i++) {
-    if(unicode[i] < 0x2B0) continue;
-    return 0;
-  }
-  return 1;
-}
-
-void get_scripts(unsigned int *cp, int len, hb_script_t *scripts) {
-  int i;
-  int backwards_scan = 0;
-  hb_unicode_funcs_t *ufuncs = hb_unicode_funcs_get_default();
-  hb_script_t last_script = HB_SCRIPT_UNKNOWN;
-
-  // determine script (forward scan)
-  for (i = 0; i < len; i++) {
-    scripts[i] = hb_unicode_script(ufuncs, cp[i]);
-
-    // common/inherit codepoints inherit script from context
-    if (scripts[i] == HB_SCRIPT_COMMON ||
-        scripts[i] == HB_SCRIPT_INHERITED) {
-      // unknown is not a valid context
-      if (last_script != HB_SCRIPT_UNKNOWN)
-        scripts[i] = last_script;
-      else
-        // do a backwards scan to check if next codepoint
-        // contains a valid script for context
-        backwards_scan = 1;
-    } else {
-      last_script = scripts[i];
-    }
-  }
-
-  // determine script (backwards scan, if needed)
-  last_script = HB_SCRIPT_UNKNOWN;
-  for (i = len - 1; i >= 0 && backwards_scan; i--) {
-    // common/inherit codepoints inherit script from context
-    if (scripts[i] == HB_SCRIPT_COMMON ||
-        scripts[i] == HB_SCRIPT_INHERITED) {
-      // unknown script is not a valid context
-      if (last_script != HB_SCRIPT_UNKNOWN)
-        scripts[i] = last_script;
-    } else {
-      last_script = scripts[i];
-    }
-  }
-}
-#endif
-
-/* returns 1 if this is a codepoint we should skip. only checks \r for now */
-static int skip_unicode(unsigned int unicode) {
-  switch(unicode) {
-  case '\r':
-    return 1;
-    break;
-  default:
-    return 0;
-  }
-}
-
-#define MS_RTL_LTR 0
-#define MS_RTL_RTL 1
-#define MS_RTL_MIXED 2
-
-struct line_desc{
-  int length;
-  int rtl;
-} ;
-
-int msLayoutTextSymbol(mapObj *map, textSymbolObj *ts, textPathObj *tgret) {
-#define STATIC_GLYPHS 100
-#define STATIC_LINES 10
-  text_run static_runs[STATIC_GLYPHS];
-  int i,nruns, start, ret=MS_SUCCESS;
-  size_t text_num_bytes;
-  char *inp;
-  unsigned int static_unicodes[STATIC_GLYPHS];
-  unsigned int static_codepoints[STATIC_GLYPHS];
-#ifdef USE_FRIBIDI
-  FriBidiCharType static_ctypes[STATIC_GLYPHS];
-  FriBidiLevel static_bidi_levels[STATIC_GLYPHS];
-#endif
-#ifdef USE_HARFBUZZ
-  hb_script_t static_scripts[STATIC_GLYPHS];
-  hb_buffer_t *buf = NULL;
-#endif
-  struct line_desc static_line_descs[STATIC_LINES];
-  int alloc_glyphs = 0;
-  struct line_desc *line_descs = NULL;
-  text_run *runs;
-  double oldpeny=3455,peny,penx=0; /*oldpeny is set to an unreasonable default initial value */
-  fontSetObj *fontset = NULL;
-
-  TextInfo glyphs;
-  int num_glyphs = 0;
-
-  assert(ts->annotext && *ts->annotext); /* ensure we have at least one character/glyph to treat */
-
-  if(map) fontset = &map->fontset;
-  /* go through iconv beforehand, so we know we're handling utf8 */
-#ifdef USE_ICONV
-  if(ts->label->encoding && strcasecmp(ts->label->encoding,"UTF-8")) {
-    iconv_t cd;
-    size_t len, bufleft;
-    char *encoded_text,*outp;
-    len = strlen(ts->annotext);
-    bufleft = len*6;
-    encoded_text = msSmallMalloc(bufleft+1);
-    cd = iconv_open("UTF-8", ts->label->encoding);
-
-    if(cd == (iconv_t)-1) {
-      msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
-               "msGetEncodedString()", ts->label->encoding);
-      return MS_FAILURE;
-    }
-
-    inp = ts->annotext;
-    outp = encoded_text;
-
-    while(len>0) {
-      const size_t iconv_status = iconv(cd, &inp, &len, &outp, &bufleft);
-      if(iconv_status == (size_t)-1) {
-        break;
-      }
-    }
-
-    text_num_bytes = outp - encoded_text;
-    encoded_text[text_num_bytes] = 0;
-    free(ts->annotext);
-    ts->annotext = encoded_text;
-    iconv_close(cd);
-  } else
-#endif
-  {
-    text_num_bytes = strlen(ts->annotext);
-  }
-
-  if( text_num_bytes == 0 )
-      return 0;
-
-  if(text_num_bytes > STATIC_GLYPHS) {
-#ifdef USE_FRIBIDI
-    glyphs.bidi_levels = msSmallMalloc(text_num_bytes * sizeof(FriBidiLevel));
-    glyphs.ctypes = msSmallMalloc(text_num_bytes * sizeof(FriBidiCharType));
-#endif
-    glyphs.unicodes = msSmallMalloc(text_num_bytes * sizeof(unsigned int));
-    glyphs.codepoints = msSmallMalloc(text_num_bytes * sizeof(unsigned int));
-#ifdef USE_HARFBUZZ
-    glyphs.scripts = msSmallMalloc(text_num_bytes * sizeof(hb_script_t));
-#endif
-    runs = msSmallMalloc(text_num_bytes * sizeof(text_run));
-  } else {
-#ifdef USE_FRIBIDI
-    glyphs.bidi_levels = static_bidi_levels;
-    glyphs.ctypes = static_ctypes;
-#endif
-    glyphs.unicodes = static_unicodes;
-    glyphs.codepoints = static_codepoints;
-#ifdef USE_HARFBUZZ
-    glyphs.scripts = static_scripts;
-#endif
-    runs = static_runs;
-  }
-
-  /* populate the unicode entries once and for all */
-  inp = ts->annotext;
-  while(*inp) {
-    unsigned int unicode;
-    inp += msUTF8ToUniChar(inp, &unicode);
-    if(!skip_unicode(unicode)){
-      glyphs.unicodes[num_glyphs++] = unicode;
-    }
-  }
-
-  if(ts->label->wrap || ts->label->maxlength > 0) {
-    if(ts->label->wrap && ts->label->maxlength == 0) {
-      for(i=0;i<num_glyphs;i++) {
-        /* replace all occurences of the wrap character with a newline */
-        if(glyphs.unicodes[i]== (unsigned)ts->label->wrap)
-          glyphs.unicodes[i]= '\n';
-      }
-    } else {
-      assert(ts->label->maxlength > 0);
-      if(num_glyphs > ts->label->maxlength) {
-        int num_cur_glyph_on_line = 0; /*count for the number of glyphs on the current line*/
-        for(i=0; i<num_glyphs; i++) {
-          /* wrap at wrap character or at ZERO WIDTH SPACE (unicode 0x200b), if
-           * current line is too long */
-          if((glyphs.unicodes[i] == (unsigned)ts->label->wrap || glyphs.unicodes[i] == (unsigned)0x200b)
-              && num_cur_glyph_on_line >= ts->label->maxlength) {
-            glyphs.unicodes[i]= '\n';
-            num_cur_glyph_on_line = 0;
-          } else {
-            num_cur_glyph_on_line++;
-          }
-        }
-      }
-    }
-    /*
-     * TODO RFC98: RFC40 negative label->wrap. This is left out for the moment as it requires
-     * handling a realloc and imho is never used and is an overly-complex use-case.
-     */
-  }
-
-  /* split our text into runs (one for each line) */
-  nruns = 0;
-  start = 0;
-  runs[0].offset = 0;
-  runs[0].line_number = 0;
-  for(i=0; i<num_glyphs; i++) {
-    if(glyphs.unicodes[i]!= '\n') continue;
-    runs[nruns].length = i - start; /* length of current line (without \n) */
-    start = i+1; /* start of next line */
-    runs[nruns+1].line_number = runs[nruns].line_number+1;
-    runs[nruns+1].offset = start;
-    nruns++;
-  }
-  /* unless the last glyph was a \n, we need to "close" the last run */
-  if(glyphs.unicodes[num_glyphs-1]!= '\n') {
-    runs[nruns].length = num_glyphs - start;
-    nruns++;
-  }
-
-  if(runs[nruns-1].line_number+1 > STATIC_LINES) {
-    line_descs = msSmallMalloc((runs[nruns-1].line_number + 1)*sizeof(struct line_desc));
-  } else {
-    line_descs = static_line_descs;
-  }
-
-#ifdef USE_FRIBIDI
-  for(i=0;i<nruns;i++) {
-    /* check the run (at this stage, one run per line), decide if we need to go through bidi and/or shaping */
-    if(unicode_is_latin1(glyphs.unicodes + runs[i].offset, runs[i].length)) {
-      runs[i].rtl = -1;
-      line_descs[i].rtl = MS_RTL_LTR;
-    } else {
-      runs[i].rtl = 0;
-    }
-  }
-
-  for(i=0; i<nruns; i++) {
-    /* split the text into bidi runs */
-    if(runs[i].rtl >= 0) {
-      int j, cur_run_start, original_num_glyphs, original_offset;
-      FriBidiLevel prevlevel;
-      FriBidiParType dir = FRIBIDI_PAR_LTR;
-      original_offset = cur_run_start = runs[i].offset;
-      original_num_glyphs = runs[i].length;
-      fribidi_get_bidi_types(glyphs.unicodes + original_offset, runs[i].length, glyphs.ctypes + original_offset);
-      {
-          FriBidiLevel level = fribidi_get_par_embedding_levels(glyphs.ctypes + original_offset, runs[i].length, &dir, glyphs.bidi_levels + runs[i].offset);
-          (void)level;
-      }
-      /* if we have different embedding levels, create a run for each one */
-      runs[i].rtl = prevlevel = glyphs.bidi_levels[original_offset];
-      line_descs[runs[i].line_number].rtl = (prevlevel%2) ? MS_RTL_RTL:MS_RTL_LTR;
-      for(j=1; j<original_num_glyphs; j++) {
-        if(glyphs.bidi_levels[original_offset+j] != prevlevel) {
-          line_descs[runs[i].line_number].rtl = MS_RTL_MIXED;
-          /* create a new run for the different embedding level */
-          nruns++;
-
-          /* first move remaining runs */
-          memmove(runs+i+2,runs+i+1,(nruns-i-2)*sizeof(text_run));
-
-          i++;
-          /* new run inherints line number */
-          runs[i].line_number = runs[i-1].line_number;
-          runs[i].offset = original_offset + j;
-          runs[i].length = (runs[i-1].offset + runs[i-1].length) - runs[i].offset;
-          runs[i-1].length = runs[i].offset - runs[i-1].offset;
-
-
-          /* new run starts at current postition */
-          runs[i].rtl = prevlevel = glyphs.bidi_levels[original_offset+j];
-        }
-      }
-    }
-  }
-#else
-  for(i=0;i<nruns;i++) {
-    line_descs[i].rtl = MS_RTL_LTR;
-  }
-#endif
-
-#ifdef USE_FRIBIDI
-  /* determine the scripts of each run, and split again into runs with identical script */
-  for(i=0; i<nruns; i++) {
-    if(runs[i].rtl == -1) {
-      runs[i].script = HB_SCRIPT_LATIN;
-      continue; /* skip runs we have determined we are latin (no shaping needed) */
-    } else {
-      int j, cur_run_start, original_num_glyphs, original_offset;
-      hb_script_t prevscript;
-      original_offset = cur_run_start = runs[i].offset;
-      original_num_glyphs = runs[i].length;
-      get_scripts(glyphs.unicodes + original_offset, runs[i].length, glyphs.scripts + original_offset);
-      /* if we have different scripts, create a run for each one */
-      runs[i].script = prevscript = glyphs.scripts[original_offset];
-      for(j=1; j<original_num_glyphs; j++) {
-        if(glyphs.scripts[original_offset+j] != prevscript) {
-          /* create a new run for the different embedding level */
-          nruns++;
-
-          /* first move remaining runs */
-          memmove(runs+i+2,runs+i+1,(nruns-i-2)*sizeof(text_run));
-
-          i++;
-          /* new run inherints line number and rtl*/
-          runs[i].line_number = runs[i-1].line_number;
-          runs[i].rtl = runs[i-1].rtl;
-          runs[i].offset = original_offset + j;
-          runs[i].length = (runs[i-1].offset + runs[i-1].length) - runs[i].offset;
-          runs[i-1].length = runs[i].offset - runs[i-1].offset;
-
-
-          runs[i].script = prevscript = glyphs.scripts[original_offset+j];
-        }
-      }
-    }
-  }
-#endif
-
-  for(i=0; i<nruns; i++) {
-    ret = get_face_for_run(fontset, ts->label->font, runs+i, &glyphs);
-    if(MS_UNLIKELY(ret == MS_FAILURE))
-      goto cleanup;
-  }
-
-  /*
-   * determine the font face to use for a given run. No splitting needed here for
-   * now, as we suppose that the decomposition of each run into individual bidi
-   * direction and script level is sufficient to ensure that a given run can be
-   * represented by a single font (i.e. there's no need to look into multiple fonts
-   * to find the glyphs of the run)
-   */
-
-
-  tgret->numlines = runs[nruns-1].line_number + 1;
-  tgret->bounds.bbox.minx = 0;
-  tgret->bounds.bbox.miny = FLT_MAX;
-  tgret->bounds.bbox.maxx = tgret->bounds.bbox.maxy = -FLT_MAX;
-
-
-  for(i=0;i<nruns;i++) {
-    if(!runs[i].face) continue;
-    peny = (1 - tgret->numlines + runs[i].line_number) * tgret->line_height;
-    if(peny != oldpeny) {
-      if(i>0) line_descs[runs[i-1].line_number].length = penx;
-      if(penx > tgret->bounds.bbox.maxx)
-        tgret->bounds.bbox.maxx = penx;
-      oldpeny = peny;
-      penx = 0;
-    }
-#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
-    if(runs[i].rtl == -1 || runs[i].script == HB_SCRIPT_LATIN || runs[i].script == HB_SCRIPT_COMMON)
-#endif
-    {
-      /* use our basic shaper */
-      unsigned int *codepoint = glyphs.codepoints + runs[i].offset;
-      alloc_glyphs += runs[i].length;
-      tgret->glyphs = msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
-      for(int j=0;j<runs[i].length;j++) {
-        glyphObj *g = &tgret->glyphs[tgret->numglyphs + j];
-        g->glyph = msGetGlyphByIndex(runs[i].face,tgret->glyph_size, *codepoint);
-        g->face = runs[i].face;
-        codepoint++;
-        g->pnt.x = penx;
-        g->pnt.y = peny;
-        g->rot = 0.0;
-        penx += g->glyph->metrics.advance;
-        if(runs[i].line_number == 0 && peny - g->glyph->metrics.maxy < tgret->bounds.bbox.miny) /*compute minimal y, only for the first line */
-          tgret->bounds.bbox.miny = peny - g->glyph->metrics.maxy;
-        if(peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
-          tgret->bounds.bbox.maxy = peny - g->glyph->metrics.miny;
-      }
-#if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
-    } else {
-      struct _ms_hb_user_data user_data;
-      hb_font_t *font;
-      hb_glyph_info_t *glyph_info;
-      hb_glyph_position_t *glyph_pos;
-      if(!buf) {
-        buf = hb_buffer_create();
-      }
-      user_data.info = &glyphs;
-      user_data.run = runs + i;
-      user_data.glyph_size = tgret->glyph_size;
-      hb_buffer_clear_contents(buf);
-      hb_buffer_set_script (buf, runs[i].script);
-      font = get_hb_font(&user_data);
-      hb_buffer_set_direction(buf, (runs[i].rtl%2) ? HB_DIRECTION_RTL :HB_DIRECTION_LTR);
-      hb_buffer_add_utf32(buf,glyphs.unicodes + runs[i].offset, runs[i].length, 0, runs[i].length);
-      hb_shape(font,buf,hbfeatures,2);
-
-      unsigned int glyph_count;
-      glyph_info = hb_buffer_get_glyph_infos(buf, &glyph_count);
-      glyph_pos = hb_buffer_get_glyph_positions(buf, &glyph_count);
-      alloc_glyphs += glyph_count;
-      tgret->glyphs = msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
-      for(unsigned j=0;j<glyph_count;j++) {
-        glyphObj *g = &tgret->glyphs[tgret->numglyphs + j];
-        g->glyph = msGetGlyphByIndex(runs[i].face,tgret->glyph_size,glyph_info[j].codepoint);
-        g->face = runs[i].face;
-        g->pnt.x = penx + glyph_pos[j].x_offset/64;
-        g->pnt.y = peny - glyph_pos[j].y_offset/64;
-        g->rot = 0;
-        penx += glyph_pos[j].x_advance/64.0;
-        /* peny -= glyph_pos[j].y_advance/64; // we don't do vertical layouts */
-        if(runs[i].line_number == 0 && peny - g->glyph->metrics.maxy < tgret->bounds.bbox.miny) /*compute minimal y, only for the first line */
-          tgret->bounds.bbox.miny = peny - g->glyph->metrics.maxy;
-        if(peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
-          tgret->bounds.bbox.maxy = peny - g->glyph->metrics.miny;
-      }
-#endif
-    }
-    tgret->numglyphs = alloc_glyphs;
-    line_descs[runs[nruns-1].line_number].length = penx;
-    if(penx > tgret->bounds.bbox.maxx)
-      tgret->bounds.bbox.maxx = penx;
-  }
-
-#ifdef USE_HARFBUZZ
-  if(buf) {
-    hb_buffer_destroy(buf);
-  }
-#endif
-
-  if(tgret->numlines > 1) {
-    int max_line_length = 0;
-    int line = -1;
-    double cur_line_offset = 0;
-    int prev_default_align = MS_ALIGN_LEFT; /* if we have mixed rtl status, use the alignment of the previous
-                                               line. this defaults to left-alignment if the first line is mixed */
-    int cur_default_align = 0;
-    for(i=0; i<tgret->numlines; i++) {
-      if(line_descs[i].length > max_line_length) {
-        max_line_length = line_descs[i].length;
-      }
-    }
-    oldpeny = 3455;
-    for(i=0; i<alloc_glyphs; i++) {
-      if(tgret->glyphs[i].pnt.y != oldpeny) {
-        oldpeny = tgret->glyphs[i].pnt.y;
-        line++;
-        /* compute offset to apply to coming line */
-        switch(ts->label->align) {
-        case MS_ALIGN_CENTER:
-          cur_line_offset = (max_line_length - line_descs[line].length)/2.0;
-          break;
-        case MS_ALIGN_RIGHT:
-          cur_line_offset = (max_line_length - line_descs[line].length);
-          break;
-        case MS_ALIGN_LEFT:
-          cur_line_offset = 0;
-          break;
-        case MS_ALIGN_DEFAULT:
-        default:
-          switch(line_descs[line].rtl) {
-          case MS_RTL_MIXED:
-            cur_default_align = prev_default_align;
-            break;
-          case MS_RTL_RTL:
-            cur_default_align = prev_default_align = MS_RTL_RTL;
-            break;
-          case MS_RTL_LTR:
-            cur_default_align = prev_default_align = MS_RTL_LTR;
-            break;
-          }
-          switch(cur_default_align) {
-          case MS_RTL_RTL:
-            /* align to the right */
-            cur_line_offset = (max_line_length - line_descs[line].length);
-            break;
-          case MS_RTL_LTR:
-            cur_line_offset = 0;
-            break;
-          }
-        }
-      }
-      tgret->glyphs[i].pnt.x += cur_line_offset;
-    }
-  }
-  /*
-   * msDebug("bounds for %s: %f %f %f %f\n",ts->annotext,tgret->bounds.bbox.minx,tgret->bounds.bbox.miny,tgret->bounds.bbox.maxx,tgret->bounds.bbox.maxy);
-   */
-
-cleanup:
-  if(line_descs != static_line_descs) free(line_descs);
-  if(glyphs.codepoints != static_codepoints) {
-#ifdef USE_FRIBIDI
-    free(glyphs.bidi_levels);
-    free(glyphs.ctypes);
-#endif
-    free(glyphs.codepoints);
-#ifdef USE_HARFBUZZ
-    free(glyphs.scripts);
-#endif
-    free(glyphs.unicodes);
-    free(runs);
-  }
-  return ret;
-
-
-}
diff -pruN 8.0.1-5/third-party/include_nlohmann_json.hpp 8.2.0~beta1-1~exp1/third-party/include_nlohmann_json.hpp
--- 8.0.1-5/third-party/include_nlohmann_json.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/third-party/include_nlohmann_json.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,41 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Wrapper for nlohmann/json.hpp
- * Author:   Even Rouault <even dot rouault at spatialys dot com>
- *
- * Notes: Derived from PROJ project file of the same name.
- *
- ******************************************************************************
- * Copyright (c) 2019, Even Rouault <even dot rouault at spatialys dot com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included
- * in all copies or substantial portions of the Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#if defined(__GNUC__)
-#pragma GCC system_header
-#endif
-
-// avoid any clash if other packages (e.g. PROJ) are using another version of nlohmann/json.hpp
-#define nlohmann ms_nlohmann
-
-#if !defined(DOXYGEN_ENABLED)
-#include "nlohmann/json.hpp"
-#endif
diff -pruN 8.0.1-5/third-party/include_pantor_inja.hpp 8.2.0~beta1-1~exp1/third-party/include_pantor_inja.hpp
--- 8.0.1-5/third-party/include_pantor_inja.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/third-party/include_pantor_inja.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,36 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Wrapper for pantor/inja.hpp
- * Author:   Even Rouault <even dot rouault at spatialys dot com>
- *
- ******************************************************************************
- * Copyright (c) 2019, Even Rouault <even dot rouault at spatialys dot com>
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included
- * in all copies or substantial portions of the Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- ****************************************************************************/
-
-#if defined(__GNUC__)
-#pragma GCC system_header
-#endif
-
-#if !defined(DOXYGEN_ENABLED)
-#include "pantor/inja.hpp"
-#endif
diff -pruN 8.0.1-5/third-party/nlohmann/json.hpp 8.2.0~beta1-1~exp1/third-party/nlohmann/json.hpp
--- 8.0.1-5/third-party/nlohmann/json.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/third-party/nlohmann/json.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,22091 +0,0 @@
-/*
-    __ _____ _____ _____
- __|  |   __|     |   | |  JSON for Modern C++
-|  |  |__   |  |  | | | |  version 3.10.5
-|_____|_____|_____|_|___|  https://github.com/nlohmann/json
-
-Licensed under the MIT License <http://opensource.org/licenses/MIT>.
-SPDX-License-Identifier: MIT
-Copyright (c) 2013-2022 Niels Lohmann <http://nlohmann.me>.
-
-Permission is hereby  granted, free of charge, to any  person obtaining a copy
-of this software and associated  documentation files (the "Software"), to deal
-in the Software  without restriction, including without  limitation the rights
-to  use, copy,  modify, merge,  publish, distribute,  sublicense, and/or  sell
-copies  of  the Software,  and  to  permit persons  to  whom  the Software  is
-furnished to do so, subject to the following conditions:
-
-The above copyright notice and this permission notice shall be included in all
-copies or substantial portions of the Software.
-
-THE SOFTWARE  IS PROVIDED "AS  IS", WITHOUT WARRANTY  OF ANY KIND,  EXPRESS OR
-IMPLIED,  INCLUDING BUT  NOT  LIMITED TO  THE  WARRANTIES OF  MERCHANTABILITY,
-FITNESS FOR  A PARTICULAR PURPOSE AND  NONINFRINGEMENT. IN NO EVENT  SHALL THE
-AUTHORS  OR COPYRIGHT  HOLDERS  BE  LIABLE FOR  ANY  CLAIM,  DAMAGES OR  OTHER
-LIABILITY, WHETHER IN AN ACTION OF  CONTRACT, TORT OR OTHERWISE, ARISING FROM,
-OUT OF OR IN CONNECTION WITH THE SOFTWARE  OR THE USE OR OTHER DEALINGS IN THE
-SOFTWARE.
-*/
-
-/****************************************************************************\
- * Note on documentation: The source files contain links to the online      *
- * documentation of the public API at https://json.nlohmann.me. This URL    *
- * contains the most recent documentation and should also be applicable to  *
- * previous versions; documentation for deprecated functions is not         *
- * removed, but marked deprecated. See "Generate documentation" section in  *
- * file doc/README.md.                                                      *
-\****************************************************************************/
-
-#ifndef INCLUDE_NLOHMANN_JSON_HPP_
-#define INCLUDE_NLOHMANN_JSON_HPP_
-
-#define NLOHMANN_JSON_VERSION_MAJOR 3
-#define NLOHMANN_JSON_VERSION_MINOR 10
-#define NLOHMANN_JSON_VERSION_PATCH 5
-
-#include <algorithm> // all_of, find, for_each
-#include <cstddef> // nullptr_t, ptrdiff_t, size_t
-#include <functional> // hash, less
-#include <initializer_list> // initializer_list
-#ifndef JSON_NO_IO
-    #include <iosfwd> // istream, ostream
-#endif  // JSON_NO_IO
-#include <iterator> // random_access_iterator_tag
-#include <memory> // unique_ptr
-#include <numeric> // accumulate
-#include <string> // string, stoi, to_string
-#include <utility> // declval, forward, move, pair, swap
-#include <vector> // vector
-
-// #include <nlohmann/adl_serializer.hpp>
-
-
-#include <type_traits>
-#include <utility>
-
-// #include <nlohmann/detail/conversions/from_json.hpp>
-
-
-#include <algorithm> // transform
-#include <array> // array
-#include <forward_list> // forward_list
-#include <iterator> // inserter, front_inserter, end
-#include <map> // map
-#include <string> // string
-#include <tuple> // tuple, make_tuple
-#include <type_traits> // is_arithmetic, is_same, is_enum, underlying_type, is_convertible
-#include <unordered_map> // unordered_map
-#include <utility> // pair, declval
-#include <valarray> // valarray
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-
-#include <exception> // exception
-#include <stdexcept> // runtime_error
-#include <string> // to_string
-#include <vector> // vector
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-#include <array> // array
-#include <cstddef> // size_t
-#include <cstdint> // uint8_t
-#include <string> // string
-
-namespace nlohmann
-{
-namespace detail
-{
-///////////////////////////
-// JSON type enumeration //
-///////////////////////////
-
-/*!
-@brief the JSON type enumeration
-
-This enumeration collects the different JSON types. It is internally used to
-distinguish the stored values, and the functions @ref basic_json::is_null(),
-@ref basic_json::is_object(), @ref basic_json::is_array(),
-@ref basic_json::is_string(), @ref basic_json::is_boolean(),
-@ref basic_json::is_number() (with @ref basic_json::is_number_integer(),
-@ref basic_json::is_number_unsigned(), and @ref basic_json::is_number_float()),
-@ref basic_json::is_discarded(), @ref basic_json::is_primitive(), and
-@ref basic_json::is_structured() rely on it.
-
-@note There are three enumeration entries (number_integer, number_unsigned, and
-number_float), because the library distinguishes these three types for numbers:
-@ref basic_json::number_unsigned_t is used for unsigned integers,
-@ref basic_json::number_integer_t is used for signed integers, and
-@ref basic_json::number_float_t is used for floating-point numbers or to
-approximate integers which do not fit in the limits of their respective type.
-
-@sa see @ref basic_json::basic_json(const value_t value_type) -- create a JSON
-value with the default value for a given type
-
-@since version 1.0.0
-*/
-enum class value_t : std::uint8_t
-{
-    null,             ///< null value
-    object,           ///< object (unordered set of name/value pairs)
-    array,            ///< array (ordered collection of values)
-    string,           ///< string value
-    boolean,          ///< boolean value
-    number_integer,   ///< number value (signed integer)
-    number_unsigned,  ///< number value (unsigned integer)
-    number_float,     ///< number value (floating-point)
-    binary,           ///< binary array (ordered collection of bytes)
-    discarded         ///< discarded by the parser callback function
-};
-
-/*!
-@brief comparison operator for JSON types
-
-Returns an ordering that is similar to Python:
-- order: null < boolean < number < object < array < string < binary
-- furthermore, each type is not smaller than itself
-- discarded values are not comparable
-- binary is represented as a b"" string in python and directly comparable to a
-  string; however, making a binary array directly comparable with a string would
-  be surprising behavior in a JSON file.
-
-@since version 1.0.0
-*/
-inline bool operator<(const value_t lhs, const value_t rhs) noexcept
-{
-    static constexpr std::array<std::uint8_t, 9> order = {{
-            0 /* null */, 3 /* object */, 4 /* array */, 5 /* string */,
-            1 /* boolean */, 2 /* integer */, 2 /* unsigned */, 2 /* float */,
-            6 /* binary */
-        }
-    };
-
-    const auto l_index = static_cast<std::size_t>(lhs);
-    const auto r_index = static_cast<std::size_t>(rhs);
-    return l_index < order.size() && r_index < order.size() && order[l_index] < order[r_index];
-}
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/string_escape.hpp>
-
-
-#include <string>
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-#include <utility> // declval, pair
-// #include <nlohmann/thirdparty/hedley/hedley.hpp>
-
-
-/* Hedley - https://nemequ.github.io/hedley
- * Created by Evan Nemerson <evan@nemerson.com>
- *
- * To the extent possible under law, the author(s) have dedicated all
- * copyright and related and neighboring rights to this software to
- * the public domain worldwide. This software is distributed without
- * any warranty.
- *
- * For details, see <http://creativecommons.org/publicdomain/zero/1.0/>.
- * SPDX-License-Identifier: CC0-1.0
- */
-
-#if !defined(JSON_HEDLEY_VERSION) || (JSON_HEDLEY_VERSION < 15)
-#if defined(JSON_HEDLEY_VERSION)
-    #undef JSON_HEDLEY_VERSION
-#endif
-#define JSON_HEDLEY_VERSION 15
-
-#if defined(JSON_HEDLEY_STRINGIFY_EX)
-    #undef JSON_HEDLEY_STRINGIFY_EX
-#endif
-#define JSON_HEDLEY_STRINGIFY_EX(x) #x
-
-#if defined(JSON_HEDLEY_STRINGIFY)
-    #undef JSON_HEDLEY_STRINGIFY
-#endif
-#define JSON_HEDLEY_STRINGIFY(x) JSON_HEDLEY_STRINGIFY_EX(x)
-
-#if defined(JSON_HEDLEY_CONCAT_EX)
-    #undef JSON_HEDLEY_CONCAT_EX
-#endif
-#define JSON_HEDLEY_CONCAT_EX(a,b) a##b
-
-#if defined(JSON_HEDLEY_CONCAT)
-    #undef JSON_HEDLEY_CONCAT
-#endif
-#define JSON_HEDLEY_CONCAT(a,b) JSON_HEDLEY_CONCAT_EX(a,b)
-
-#if defined(JSON_HEDLEY_CONCAT3_EX)
-    #undef JSON_HEDLEY_CONCAT3_EX
-#endif
-#define JSON_HEDLEY_CONCAT3_EX(a,b,c) a##b##c
-
-#if defined(JSON_HEDLEY_CONCAT3)
-    #undef JSON_HEDLEY_CONCAT3
-#endif
-#define JSON_HEDLEY_CONCAT3(a,b,c) JSON_HEDLEY_CONCAT3_EX(a,b,c)
-
-#if defined(JSON_HEDLEY_VERSION_ENCODE)
-    #undef JSON_HEDLEY_VERSION_ENCODE
-#endif
-#define JSON_HEDLEY_VERSION_ENCODE(major,minor,revision) (((major) * 1000000) + ((minor) * 1000) + (revision))
-
-#if defined(JSON_HEDLEY_VERSION_DECODE_MAJOR)
-    #undef JSON_HEDLEY_VERSION_DECODE_MAJOR
-#endif
-#define JSON_HEDLEY_VERSION_DECODE_MAJOR(version) ((version) / 1000000)
-
-#if defined(JSON_HEDLEY_VERSION_DECODE_MINOR)
-    #undef JSON_HEDLEY_VERSION_DECODE_MINOR
-#endif
-#define JSON_HEDLEY_VERSION_DECODE_MINOR(version) (((version) % 1000000) / 1000)
-
-#if defined(JSON_HEDLEY_VERSION_DECODE_REVISION)
-    #undef JSON_HEDLEY_VERSION_DECODE_REVISION
-#endif
-#define JSON_HEDLEY_VERSION_DECODE_REVISION(version) ((version) % 1000)
-
-#if defined(JSON_HEDLEY_GNUC_VERSION)
-    #undef JSON_HEDLEY_GNUC_VERSION
-#endif
-#if defined(__GNUC__) && defined(__GNUC_PATCHLEVEL__)
-    #define JSON_HEDLEY_GNUC_VERSION JSON_HEDLEY_VERSION_ENCODE(__GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__)
-#elif defined(__GNUC__)
-    #define JSON_HEDLEY_GNUC_VERSION JSON_HEDLEY_VERSION_ENCODE(__GNUC__, __GNUC_MINOR__, 0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_VERSION_CHECK)
-    #undef JSON_HEDLEY_GNUC_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_GNUC_VERSION)
-    #define JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_GNUC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_MSVC_VERSION)
-    #undef JSON_HEDLEY_MSVC_VERSION
-#endif
-#if defined(_MSC_FULL_VER) && (_MSC_FULL_VER >= 140000000) && !defined(__ICL)
-    #define JSON_HEDLEY_MSVC_VERSION JSON_HEDLEY_VERSION_ENCODE(_MSC_FULL_VER / 10000000, (_MSC_FULL_VER % 10000000) / 100000, (_MSC_FULL_VER % 100000) / 100)
-#elif defined(_MSC_FULL_VER) && !defined(__ICL)
-    #define JSON_HEDLEY_MSVC_VERSION JSON_HEDLEY_VERSION_ENCODE(_MSC_FULL_VER / 1000000, (_MSC_FULL_VER % 1000000) / 10000, (_MSC_FULL_VER % 10000) / 10)
-#elif defined(_MSC_VER) && !defined(__ICL)
-    #define JSON_HEDLEY_MSVC_VERSION JSON_HEDLEY_VERSION_ENCODE(_MSC_VER / 100, _MSC_VER % 100, 0)
-#endif
-
-#if defined(JSON_HEDLEY_MSVC_VERSION_CHECK)
-    #undef JSON_HEDLEY_MSVC_VERSION_CHECK
-#endif
-#if !defined(JSON_HEDLEY_MSVC_VERSION)
-    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (0)
-#elif defined(_MSC_VER) && (_MSC_VER >= 1400)
-    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (_MSC_FULL_VER >= ((major * 10000000) + (minor * 100000) + (patch)))
-#elif defined(_MSC_VER) && (_MSC_VER >= 1200)
-    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (_MSC_FULL_VER >= ((major * 1000000) + (minor * 10000) + (patch)))
-#else
-    #define JSON_HEDLEY_MSVC_VERSION_CHECK(major,minor,patch) (_MSC_VER >= ((major * 100) + (minor)))
-#endif
-
-#if defined(JSON_HEDLEY_INTEL_VERSION)
-    #undef JSON_HEDLEY_INTEL_VERSION
-#endif
-#if defined(__INTEL_COMPILER) && defined(__INTEL_COMPILER_UPDATE) && !defined(__ICL)
-    #define JSON_HEDLEY_INTEL_VERSION JSON_HEDLEY_VERSION_ENCODE(__INTEL_COMPILER / 100, __INTEL_COMPILER % 100, __INTEL_COMPILER_UPDATE)
-#elif defined(__INTEL_COMPILER) && !defined(__ICL)
-    #define JSON_HEDLEY_INTEL_VERSION JSON_HEDLEY_VERSION_ENCODE(__INTEL_COMPILER / 100, __INTEL_COMPILER % 100, 0)
-#endif
-
-#if defined(JSON_HEDLEY_INTEL_VERSION_CHECK)
-    #undef JSON_HEDLEY_INTEL_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_INTEL_VERSION)
-    #define JSON_HEDLEY_INTEL_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_INTEL_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_INTEL_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_INTEL_CL_VERSION)
-    #undef JSON_HEDLEY_INTEL_CL_VERSION
-#endif
-#if defined(__INTEL_COMPILER) && defined(__INTEL_COMPILER_UPDATE) && defined(__ICL)
-    #define JSON_HEDLEY_INTEL_CL_VERSION JSON_HEDLEY_VERSION_ENCODE(__INTEL_COMPILER, __INTEL_COMPILER_UPDATE, 0)
-#endif
-
-#if defined(JSON_HEDLEY_INTEL_CL_VERSION_CHECK)
-    #undef JSON_HEDLEY_INTEL_CL_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_INTEL_CL_VERSION)
-    #define JSON_HEDLEY_INTEL_CL_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_INTEL_CL_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_INTEL_CL_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_PGI_VERSION)
-    #undef JSON_HEDLEY_PGI_VERSION
-#endif
-#if defined(__PGI) && defined(__PGIC__) && defined(__PGIC_MINOR__) && defined(__PGIC_PATCHLEVEL__)
-    #define JSON_HEDLEY_PGI_VERSION JSON_HEDLEY_VERSION_ENCODE(__PGIC__, __PGIC_MINOR__, __PGIC_PATCHLEVEL__)
-#endif
-
-#if defined(JSON_HEDLEY_PGI_VERSION_CHECK)
-    #undef JSON_HEDLEY_PGI_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_PGI_VERSION)
-    #define JSON_HEDLEY_PGI_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_PGI_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_PGI_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_SUNPRO_VERSION)
-    #undef JSON_HEDLEY_SUNPRO_VERSION
-#endif
-#if defined(__SUNPRO_C) && (__SUNPRO_C > 0x1000)
-    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((((__SUNPRO_C >> 16) & 0xf) * 10) + ((__SUNPRO_C >> 12) & 0xf), (((__SUNPRO_C >> 8) & 0xf) * 10) + ((__SUNPRO_C >> 4) & 0xf), (__SUNPRO_C & 0xf) * 10)
-#elif defined(__SUNPRO_C)
-    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((__SUNPRO_C >> 8) & 0xf, (__SUNPRO_C >> 4) & 0xf, (__SUNPRO_C) & 0xf)
-#elif defined(__SUNPRO_CC) && (__SUNPRO_CC > 0x1000)
-    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((((__SUNPRO_CC >> 16) & 0xf) * 10) + ((__SUNPRO_CC >> 12) & 0xf), (((__SUNPRO_CC >> 8) & 0xf) * 10) + ((__SUNPRO_CC >> 4) & 0xf), (__SUNPRO_CC & 0xf) * 10)
-#elif defined(__SUNPRO_CC)
-    #define JSON_HEDLEY_SUNPRO_VERSION JSON_HEDLEY_VERSION_ENCODE((__SUNPRO_CC >> 8) & 0xf, (__SUNPRO_CC >> 4) & 0xf, (__SUNPRO_CC) & 0xf)
-#endif
-
-#if defined(JSON_HEDLEY_SUNPRO_VERSION_CHECK)
-    #undef JSON_HEDLEY_SUNPRO_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_SUNPRO_VERSION)
-    #define JSON_HEDLEY_SUNPRO_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_SUNPRO_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_SUNPRO_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_EMSCRIPTEN_VERSION)
-    #undef JSON_HEDLEY_EMSCRIPTEN_VERSION
-#endif
-#if defined(__EMSCRIPTEN__)
-    #define JSON_HEDLEY_EMSCRIPTEN_VERSION JSON_HEDLEY_VERSION_ENCODE(__EMSCRIPTEN_major__, __EMSCRIPTEN_minor__, __EMSCRIPTEN_tiny__)
-#endif
-
-#if defined(JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK)
-    #undef JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_EMSCRIPTEN_VERSION)
-    #define JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_EMSCRIPTEN_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_ARM_VERSION)
-    #undef JSON_HEDLEY_ARM_VERSION
-#endif
-#if defined(__CC_ARM) && defined(__ARMCOMPILER_VERSION)
-    #define JSON_HEDLEY_ARM_VERSION JSON_HEDLEY_VERSION_ENCODE(__ARMCOMPILER_VERSION / 1000000, (__ARMCOMPILER_VERSION % 1000000) / 10000, (__ARMCOMPILER_VERSION % 10000) / 100)
-#elif defined(__CC_ARM) && defined(__ARMCC_VERSION)
-    #define JSON_HEDLEY_ARM_VERSION JSON_HEDLEY_VERSION_ENCODE(__ARMCC_VERSION / 1000000, (__ARMCC_VERSION % 1000000) / 10000, (__ARMCC_VERSION % 10000) / 100)
-#endif
-
-#if defined(JSON_HEDLEY_ARM_VERSION_CHECK)
-    #undef JSON_HEDLEY_ARM_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_ARM_VERSION)
-    #define JSON_HEDLEY_ARM_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_ARM_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_ARM_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_IBM_VERSION)
-    #undef JSON_HEDLEY_IBM_VERSION
-#endif
-#if defined(__ibmxl__)
-    #define JSON_HEDLEY_IBM_VERSION JSON_HEDLEY_VERSION_ENCODE(__ibmxl_version__, __ibmxl_release__, __ibmxl_modification__)
-#elif defined(__xlC__) && defined(__xlC_ver__)
-    #define JSON_HEDLEY_IBM_VERSION JSON_HEDLEY_VERSION_ENCODE(__xlC__ >> 8, __xlC__ & 0xff, (__xlC_ver__ >> 8) & 0xff)
-#elif defined(__xlC__)
-    #define JSON_HEDLEY_IBM_VERSION JSON_HEDLEY_VERSION_ENCODE(__xlC__ >> 8, __xlC__ & 0xff, 0)
-#endif
-
-#if defined(JSON_HEDLEY_IBM_VERSION_CHECK)
-    #undef JSON_HEDLEY_IBM_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_IBM_VERSION)
-    #define JSON_HEDLEY_IBM_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_IBM_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_IBM_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TI_VERSION)
-    #undef JSON_HEDLEY_TI_VERSION
-#endif
-#if \
-    defined(__TI_COMPILER_VERSION__) && \
-    ( \
-      defined(__TMS470__) || defined(__TI_ARM__) || \
-      defined(__MSP430__) || \
-      defined(__TMS320C2000__) \
-    )
-#if (__TI_COMPILER_VERSION__ >= 16000000)
-    #define JSON_HEDLEY_TI_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
-#endif
-#endif
-
-#if defined(JSON_HEDLEY_TI_VERSION_CHECK)
-    #undef JSON_HEDLEY_TI_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TI_VERSION)
-    #define JSON_HEDLEY_TI_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TI_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL2000_VERSION)
-    #undef JSON_HEDLEY_TI_CL2000_VERSION
-#endif
-#if defined(__TI_COMPILER_VERSION__) && defined(__TMS320C2000__)
-    #define JSON_HEDLEY_TI_CL2000_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL2000_VERSION_CHECK)
-    #undef JSON_HEDLEY_TI_CL2000_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TI_CL2000_VERSION)
-    #define JSON_HEDLEY_TI_CL2000_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL2000_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TI_CL2000_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL430_VERSION)
-    #undef JSON_HEDLEY_TI_CL430_VERSION
-#endif
-#if defined(__TI_COMPILER_VERSION__) && defined(__MSP430__)
-    #define JSON_HEDLEY_TI_CL430_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL430_VERSION_CHECK)
-    #undef JSON_HEDLEY_TI_CL430_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TI_CL430_VERSION)
-    #define JSON_HEDLEY_TI_CL430_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL430_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TI_CL430_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TI_ARMCL_VERSION)
-    #undef JSON_HEDLEY_TI_ARMCL_VERSION
-#endif
-#if defined(__TI_COMPILER_VERSION__) && (defined(__TMS470__) || defined(__TI_ARM__))
-    #define JSON_HEDLEY_TI_ARMCL_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
-#endif
-
-#if defined(JSON_HEDLEY_TI_ARMCL_VERSION_CHECK)
-    #undef JSON_HEDLEY_TI_ARMCL_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TI_ARMCL_VERSION)
-    #define JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_ARMCL_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL6X_VERSION)
-    #undef JSON_HEDLEY_TI_CL6X_VERSION
-#endif
-#if defined(__TI_COMPILER_VERSION__) && defined(__TMS320C6X__)
-    #define JSON_HEDLEY_TI_CL6X_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL6X_VERSION_CHECK)
-    #undef JSON_HEDLEY_TI_CL6X_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TI_CL6X_VERSION)
-    #define JSON_HEDLEY_TI_CL6X_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL6X_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TI_CL6X_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL7X_VERSION)
-    #undef JSON_HEDLEY_TI_CL7X_VERSION
-#endif
-#if defined(__TI_COMPILER_VERSION__) && defined(__C7000__)
-    #define JSON_HEDLEY_TI_CL7X_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
-#endif
-
-#if defined(JSON_HEDLEY_TI_CL7X_VERSION_CHECK)
-    #undef JSON_HEDLEY_TI_CL7X_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TI_CL7X_VERSION)
-    #define JSON_HEDLEY_TI_CL7X_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CL7X_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TI_CL7X_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TI_CLPRU_VERSION)
-    #undef JSON_HEDLEY_TI_CLPRU_VERSION
-#endif
-#if defined(__TI_COMPILER_VERSION__) && defined(__PRU__)
-    #define JSON_HEDLEY_TI_CLPRU_VERSION JSON_HEDLEY_VERSION_ENCODE(__TI_COMPILER_VERSION__ / 1000000, (__TI_COMPILER_VERSION__ % 1000000) / 1000, (__TI_COMPILER_VERSION__ % 1000))
-#endif
-
-#if defined(JSON_HEDLEY_TI_CLPRU_VERSION_CHECK)
-    #undef JSON_HEDLEY_TI_CLPRU_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TI_CLPRU_VERSION)
-    #define JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TI_CLPRU_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_CRAY_VERSION)
-    #undef JSON_HEDLEY_CRAY_VERSION
-#endif
-#if defined(_CRAYC)
-    #if defined(_RELEASE_PATCHLEVEL)
-        #define JSON_HEDLEY_CRAY_VERSION JSON_HEDLEY_VERSION_ENCODE(_RELEASE_MAJOR, _RELEASE_MINOR, _RELEASE_PATCHLEVEL)
-    #else
-        #define JSON_HEDLEY_CRAY_VERSION JSON_HEDLEY_VERSION_ENCODE(_RELEASE_MAJOR, _RELEASE_MINOR, 0)
-    #endif
-#endif
-
-#if defined(JSON_HEDLEY_CRAY_VERSION_CHECK)
-    #undef JSON_HEDLEY_CRAY_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_CRAY_VERSION)
-    #define JSON_HEDLEY_CRAY_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_CRAY_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_CRAY_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_IAR_VERSION)
-    #undef JSON_HEDLEY_IAR_VERSION
-#endif
-#if defined(__IAR_SYSTEMS_ICC__)
-    #if __VER__ > 1000
-        #define JSON_HEDLEY_IAR_VERSION JSON_HEDLEY_VERSION_ENCODE((__VER__ / 1000000), ((__VER__ / 1000) % 1000), (__VER__ % 1000))
-    #else
-        #define JSON_HEDLEY_IAR_VERSION JSON_HEDLEY_VERSION_ENCODE(__VER__ / 100, __VER__ % 100, 0)
-    #endif
-#endif
-
-#if defined(JSON_HEDLEY_IAR_VERSION_CHECK)
-    #undef JSON_HEDLEY_IAR_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_IAR_VERSION)
-    #define JSON_HEDLEY_IAR_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_IAR_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_IAR_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_TINYC_VERSION)
-    #undef JSON_HEDLEY_TINYC_VERSION
-#endif
-#if defined(__TINYC__)
-    #define JSON_HEDLEY_TINYC_VERSION JSON_HEDLEY_VERSION_ENCODE(__TINYC__ / 1000, (__TINYC__ / 100) % 10, __TINYC__ % 100)
-#endif
-
-#if defined(JSON_HEDLEY_TINYC_VERSION_CHECK)
-    #undef JSON_HEDLEY_TINYC_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_TINYC_VERSION)
-    #define JSON_HEDLEY_TINYC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_TINYC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_TINYC_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_DMC_VERSION)
-    #undef JSON_HEDLEY_DMC_VERSION
-#endif
-#if defined(__DMC__)
-    #define JSON_HEDLEY_DMC_VERSION JSON_HEDLEY_VERSION_ENCODE(__DMC__ >> 8, (__DMC__ >> 4) & 0xf, __DMC__ & 0xf)
-#endif
-
-#if defined(JSON_HEDLEY_DMC_VERSION_CHECK)
-    #undef JSON_HEDLEY_DMC_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_DMC_VERSION)
-    #define JSON_HEDLEY_DMC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_DMC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_DMC_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_COMPCERT_VERSION)
-    #undef JSON_HEDLEY_COMPCERT_VERSION
-#endif
-#if defined(__COMPCERT_VERSION__)
-    #define JSON_HEDLEY_COMPCERT_VERSION JSON_HEDLEY_VERSION_ENCODE(__COMPCERT_VERSION__ / 10000, (__COMPCERT_VERSION__ / 100) % 100, __COMPCERT_VERSION__ % 100)
-#endif
-
-#if defined(JSON_HEDLEY_COMPCERT_VERSION_CHECK)
-    #undef JSON_HEDLEY_COMPCERT_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_COMPCERT_VERSION)
-    #define JSON_HEDLEY_COMPCERT_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_COMPCERT_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_COMPCERT_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_PELLES_VERSION)
-    #undef JSON_HEDLEY_PELLES_VERSION
-#endif
-#if defined(__POCC__)
-    #define JSON_HEDLEY_PELLES_VERSION JSON_HEDLEY_VERSION_ENCODE(__POCC__ / 100, __POCC__ % 100, 0)
-#endif
-
-#if defined(JSON_HEDLEY_PELLES_VERSION_CHECK)
-    #undef JSON_HEDLEY_PELLES_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_PELLES_VERSION)
-    #define JSON_HEDLEY_PELLES_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_PELLES_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_PELLES_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_MCST_LCC_VERSION)
-    #undef JSON_HEDLEY_MCST_LCC_VERSION
-#endif
-#if defined(__LCC__) && defined(__LCC_MINOR__)
-    #define JSON_HEDLEY_MCST_LCC_VERSION JSON_HEDLEY_VERSION_ENCODE(__LCC__ / 100, __LCC__ % 100, __LCC_MINOR__)
-#endif
-
-#if defined(JSON_HEDLEY_MCST_LCC_VERSION_CHECK)
-    #undef JSON_HEDLEY_MCST_LCC_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_MCST_LCC_VERSION)
-    #define JSON_HEDLEY_MCST_LCC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_MCST_LCC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_MCST_LCC_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_VERSION)
-    #undef JSON_HEDLEY_GCC_VERSION
-#endif
-#if \
-    defined(JSON_HEDLEY_GNUC_VERSION) && \
-    !defined(__clang__) && \
-    !defined(JSON_HEDLEY_INTEL_VERSION) && \
-    !defined(JSON_HEDLEY_PGI_VERSION) && \
-    !defined(JSON_HEDLEY_ARM_VERSION) && \
-    !defined(JSON_HEDLEY_CRAY_VERSION) && \
-    !defined(JSON_HEDLEY_TI_VERSION) && \
-    !defined(JSON_HEDLEY_TI_ARMCL_VERSION) && \
-    !defined(JSON_HEDLEY_TI_CL430_VERSION) && \
-    !defined(JSON_HEDLEY_TI_CL2000_VERSION) && \
-    !defined(JSON_HEDLEY_TI_CL6X_VERSION) && \
-    !defined(JSON_HEDLEY_TI_CL7X_VERSION) && \
-    !defined(JSON_HEDLEY_TI_CLPRU_VERSION) && \
-    !defined(__COMPCERT__) && \
-    !defined(JSON_HEDLEY_MCST_LCC_VERSION)
-    #define JSON_HEDLEY_GCC_VERSION JSON_HEDLEY_GNUC_VERSION
-#endif
-
-#if defined(JSON_HEDLEY_GCC_VERSION_CHECK)
-    #undef JSON_HEDLEY_GCC_VERSION_CHECK
-#endif
-#if defined(JSON_HEDLEY_GCC_VERSION)
-    #define JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch) (JSON_HEDLEY_GCC_VERSION >= JSON_HEDLEY_VERSION_ENCODE(major, minor, patch))
-#else
-    #define JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch) (0)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_ATTRIBUTE)
-    #undef JSON_HEDLEY_HAS_ATTRIBUTE
-#endif
-#if \
-  defined(__has_attribute) && \
-  ( \
-    (!defined(JSON_HEDLEY_IAR_VERSION) || JSON_HEDLEY_IAR_VERSION_CHECK(8,5,9)) \
-  )
-#  define JSON_HEDLEY_HAS_ATTRIBUTE(attribute) __has_attribute(attribute)
-#else
-#  define JSON_HEDLEY_HAS_ATTRIBUTE(attribute) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_HAS_ATTRIBUTE)
-    #undef JSON_HEDLEY_GNUC_HAS_ATTRIBUTE
-#endif
-#if defined(__has_attribute)
-    #define JSON_HEDLEY_GNUC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_HAS_ATTRIBUTE(attribute)
-#else
-    #define JSON_HEDLEY_GNUC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_HAS_ATTRIBUTE)
-    #undef JSON_HEDLEY_GCC_HAS_ATTRIBUTE
-#endif
-#if defined(__has_attribute)
-    #define JSON_HEDLEY_GCC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_HAS_ATTRIBUTE(attribute)
-#else
-    #define JSON_HEDLEY_GCC_HAS_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_CPP_ATTRIBUTE)
-    #undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE
-#endif
-#if \
-    defined(__has_cpp_attribute) && \
-    defined(__cplusplus) && \
-    (!defined(JSON_HEDLEY_SUNPRO_VERSION) || JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0))
-    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE(attribute) __has_cpp_attribute(attribute)
-#else
-    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE(attribute) (0)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS)
-    #undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS
-#endif
-#if !defined(__cplusplus) || !defined(__has_cpp_attribute)
-    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(ns,attribute) (0)
-#elif \
-    !defined(JSON_HEDLEY_PGI_VERSION) && \
-    !defined(JSON_HEDLEY_IAR_VERSION) && \
-    (!defined(JSON_HEDLEY_SUNPRO_VERSION) || JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0)) && \
-    (!defined(JSON_HEDLEY_MSVC_VERSION) || JSON_HEDLEY_MSVC_VERSION_CHECK(19,20,0))
-    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(ns,attribute) JSON_HEDLEY_HAS_CPP_ATTRIBUTE(ns::attribute)
-#else
-    #define JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(ns,attribute) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE)
-    #undef JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE
-#endif
-#if defined(__has_cpp_attribute) && defined(__cplusplus)
-    #define JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) __has_cpp_attribute(attribute)
-#else
-    #define JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE)
-    #undef JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE
-#endif
-#if defined(__has_cpp_attribute) && defined(__cplusplus)
-    #define JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) __has_cpp_attribute(attribute)
-#else
-    #define JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_BUILTIN)
-    #undef JSON_HEDLEY_HAS_BUILTIN
-#endif
-#if defined(__has_builtin)
-    #define JSON_HEDLEY_HAS_BUILTIN(builtin) __has_builtin(builtin)
-#else
-    #define JSON_HEDLEY_HAS_BUILTIN(builtin) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_HAS_BUILTIN)
-    #undef JSON_HEDLEY_GNUC_HAS_BUILTIN
-#endif
-#if defined(__has_builtin)
-    #define JSON_HEDLEY_GNUC_HAS_BUILTIN(builtin,major,minor,patch) __has_builtin(builtin)
-#else
-    #define JSON_HEDLEY_GNUC_HAS_BUILTIN(builtin,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_HAS_BUILTIN)
-    #undef JSON_HEDLEY_GCC_HAS_BUILTIN
-#endif
-#if defined(__has_builtin)
-    #define JSON_HEDLEY_GCC_HAS_BUILTIN(builtin,major,minor,patch) __has_builtin(builtin)
-#else
-    #define JSON_HEDLEY_GCC_HAS_BUILTIN(builtin,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_FEATURE)
-    #undef JSON_HEDLEY_HAS_FEATURE
-#endif
-#if defined(__has_feature)
-    #define JSON_HEDLEY_HAS_FEATURE(feature) __has_feature(feature)
-#else
-    #define JSON_HEDLEY_HAS_FEATURE(feature) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_HAS_FEATURE)
-    #undef JSON_HEDLEY_GNUC_HAS_FEATURE
-#endif
-#if defined(__has_feature)
-    #define JSON_HEDLEY_GNUC_HAS_FEATURE(feature,major,minor,patch) __has_feature(feature)
-#else
-    #define JSON_HEDLEY_GNUC_HAS_FEATURE(feature,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_HAS_FEATURE)
-    #undef JSON_HEDLEY_GCC_HAS_FEATURE
-#endif
-#if defined(__has_feature)
-    #define JSON_HEDLEY_GCC_HAS_FEATURE(feature,major,minor,patch) __has_feature(feature)
-#else
-    #define JSON_HEDLEY_GCC_HAS_FEATURE(feature,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_EXTENSION)
-    #undef JSON_HEDLEY_HAS_EXTENSION
-#endif
-#if defined(__has_extension)
-    #define JSON_HEDLEY_HAS_EXTENSION(extension) __has_extension(extension)
-#else
-    #define JSON_HEDLEY_HAS_EXTENSION(extension) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_HAS_EXTENSION)
-    #undef JSON_HEDLEY_GNUC_HAS_EXTENSION
-#endif
-#if defined(__has_extension)
-    #define JSON_HEDLEY_GNUC_HAS_EXTENSION(extension,major,minor,patch) __has_extension(extension)
-#else
-    #define JSON_HEDLEY_GNUC_HAS_EXTENSION(extension,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_HAS_EXTENSION)
-    #undef JSON_HEDLEY_GCC_HAS_EXTENSION
-#endif
-#if defined(__has_extension)
-    #define JSON_HEDLEY_GCC_HAS_EXTENSION(extension,major,minor,patch) __has_extension(extension)
-#else
-    #define JSON_HEDLEY_GCC_HAS_EXTENSION(extension,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE)
-    #undef JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE
-#endif
-#if defined(__has_declspec_attribute)
-    #define JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE(attribute) __has_declspec_attribute(attribute)
-#else
-    #define JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE(attribute) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE)
-    #undef JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE
-#endif
-#if defined(__has_declspec_attribute)
-    #define JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) __has_declspec_attribute(attribute)
-#else
-    #define JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE)
-    #undef JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE
-#endif
-#if defined(__has_declspec_attribute)
-    #define JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) __has_declspec_attribute(attribute)
-#else
-    #define JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE(attribute,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_HAS_WARNING)
-    #undef JSON_HEDLEY_HAS_WARNING
-#endif
-#if defined(__has_warning)
-    #define JSON_HEDLEY_HAS_WARNING(warning) __has_warning(warning)
-#else
-    #define JSON_HEDLEY_HAS_WARNING(warning) (0)
-#endif
-
-#if defined(JSON_HEDLEY_GNUC_HAS_WARNING)
-    #undef JSON_HEDLEY_GNUC_HAS_WARNING
-#endif
-#if defined(__has_warning)
-    #define JSON_HEDLEY_GNUC_HAS_WARNING(warning,major,minor,patch) __has_warning(warning)
-#else
-    #define JSON_HEDLEY_GNUC_HAS_WARNING(warning,major,minor,patch) JSON_HEDLEY_GNUC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_GCC_HAS_WARNING)
-    #undef JSON_HEDLEY_GCC_HAS_WARNING
-#endif
-#if defined(__has_warning)
-    #define JSON_HEDLEY_GCC_HAS_WARNING(warning,major,minor,patch) __has_warning(warning)
-#else
-    #define JSON_HEDLEY_GCC_HAS_WARNING(warning,major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if \
-    (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L)) || \
-    defined(__clang__) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,0,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0) || \
-    JSON_HEDLEY_PGI_VERSION_CHECK(18,4,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,7,0) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(2,0,1) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,1,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,0,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_CRAY_VERSION_CHECK(5,0,0) || \
-    JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,17) || \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(8,0,0) || \
-    (JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) && defined(__C99_PRAGMA_OPERATOR))
-    #define JSON_HEDLEY_PRAGMA(value) _Pragma(#value)
-#elif JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0)
-    #define JSON_HEDLEY_PRAGMA(value) __pragma(value)
-#else
-    #define JSON_HEDLEY_PRAGMA(value)
-#endif
-
-#if defined(JSON_HEDLEY_DIAGNOSTIC_PUSH)
-    #undef JSON_HEDLEY_DIAGNOSTIC_PUSH
-#endif
-#if defined(JSON_HEDLEY_DIAGNOSTIC_POP)
-    #undef JSON_HEDLEY_DIAGNOSTIC_POP
-#endif
-#if defined(__clang__)
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("clang diagnostic push")
-    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("clang diagnostic pop")
-#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("warning(push)")
-    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("warning(pop)")
-#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,6,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("GCC diagnostic push")
-    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("GCC diagnostic pop")
-#elif \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH __pragma(warning(push))
-    #define JSON_HEDLEY_DIAGNOSTIC_POP __pragma(warning(pop))
-#elif JSON_HEDLEY_ARM_VERSION_CHECK(5,6,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("push")
-    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("pop")
-#elif \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,4,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,1,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("diag_push")
-    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("diag_pop")
-#elif JSON_HEDLEY_PELLES_VERSION_CHECK(2,90,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH _Pragma("warning(push)")
-    #define JSON_HEDLEY_DIAGNOSTIC_POP _Pragma("warning(pop)")
-#else
-    #define JSON_HEDLEY_DIAGNOSTIC_PUSH
-    #define JSON_HEDLEY_DIAGNOSTIC_POP
-#endif
-
-/* JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_ is for
-   HEDLEY INTERNAL USE ONLY.  API subject to change without notice. */
-#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_)
-    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_
-#endif
-#if defined(__cplusplus)
-#  if JSON_HEDLEY_HAS_WARNING("-Wc++98-compat")
-#    if JSON_HEDLEY_HAS_WARNING("-Wc++17-extensions")
-#      if JSON_HEDLEY_HAS_WARNING("-Wc++1z-extensions")
-#        define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(xpr) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    _Pragma("clang diagnostic ignored \"-Wc++98-compat\"") \
-    _Pragma("clang diagnostic ignored \"-Wc++17-extensions\"") \
-    _Pragma("clang diagnostic ignored \"-Wc++1z-extensions\"") \
-    xpr \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#      else
-#        define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(xpr) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    _Pragma("clang diagnostic ignored \"-Wc++98-compat\"") \
-    _Pragma("clang diagnostic ignored \"-Wc++17-extensions\"") \
-    xpr \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#      endif
-#    else
-#      define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(xpr) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    _Pragma("clang diagnostic ignored \"-Wc++98-compat\"") \
-    xpr \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#    endif
-#  endif
-#endif
-#if !defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(x) x
-#endif
-
-#if defined(JSON_HEDLEY_CONST_CAST)
-    #undef JSON_HEDLEY_CONST_CAST
-#endif
-#if defined(__cplusplus)
-#  define JSON_HEDLEY_CONST_CAST(T, expr) (const_cast<T>(expr))
-#elif \
-  JSON_HEDLEY_HAS_WARNING("-Wcast-qual") || \
-  JSON_HEDLEY_GCC_VERSION_CHECK(4,6,0) || \
-  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
-#  define JSON_HEDLEY_CONST_CAST(T, expr) (__extension__ ({ \
-        JSON_HEDLEY_DIAGNOSTIC_PUSH \
-        JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL \
-        ((T) (expr)); \
-        JSON_HEDLEY_DIAGNOSTIC_POP \
-    }))
-#else
-#  define JSON_HEDLEY_CONST_CAST(T, expr) ((T) (expr))
-#endif
-
-#if defined(JSON_HEDLEY_REINTERPRET_CAST)
-    #undef JSON_HEDLEY_REINTERPRET_CAST
-#endif
-#if defined(__cplusplus)
-    #define JSON_HEDLEY_REINTERPRET_CAST(T, expr) (reinterpret_cast<T>(expr))
-#else
-    #define JSON_HEDLEY_REINTERPRET_CAST(T, expr) ((T) (expr))
-#endif
-
-#if defined(JSON_HEDLEY_STATIC_CAST)
-    #undef JSON_HEDLEY_STATIC_CAST
-#endif
-#if defined(__cplusplus)
-    #define JSON_HEDLEY_STATIC_CAST(T, expr) (static_cast<T>(expr))
-#else
-    #define JSON_HEDLEY_STATIC_CAST(T, expr) ((T) (expr))
-#endif
-
-#if defined(JSON_HEDLEY_CPP_CAST)
-    #undef JSON_HEDLEY_CPP_CAST
-#endif
-#if defined(__cplusplus)
-#  if JSON_HEDLEY_HAS_WARNING("-Wold-style-cast")
-#    define JSON_HEDLEY_CPP_CAST(T, expr) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    _Pragma("clang diagnostic ignored \"-Wold-style-cast\"") \
-    ((T) (expr)) \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#  elif JSON_HEDLEY_IAR_VERSION_CHECK(8,3,0)
-#    define JSON_HEDLEY_CPP_CAST(T, expr) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    _Pragma("diag_suppress=Pe137") \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#  else
-#    define JSON_HEDLEY_CPP_CAST(T, expr) ((T) (expr))
-#  endif
-#else
-#  define JSON_HEDLEY_CPP_CAST(T, expr) (expr)
-#endif
-
-#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED)
-    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wdeprecated-declarations")
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("clang diagnostic ignored \"-Wdeprecated-declarations\"")
-#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("warning(disable:1478 1786)")
-#elif JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED __pragma(warning(disable:1478 1786))
-#elif JSON_HEDLEY_PGI_VERSION_CHECK(20,7,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1215,1216,1444,1445")
-#elif JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1215,1444")
-#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,3,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("GCC diagnostic ignored \"-Wdeprecated-declarations\"")
-#elif JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED __pragma(warning(disable:4996))
-#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1215,1444")
-#elif \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress 1291,1718")
-#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,13,0) && !defined(__cplusplus)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("error_messages(off,E_DEPRECATED_ATT,E_DEPRECATED_ATT_MESS)")
-#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,13,0) && defined(__cplusplus)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("error_messages(off,symdeprecated,symdeprecated2)")
-#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("diag_suppress=Pe1444,Pe1215")
-#elif JSON_HEDLEY_PELLES_VERSION_CHECK(2,90,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED _Pragma("warn(disable:2241)")
-#else
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED
-#endif
-
-#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS)
-    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wunknown-pragmas")
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("clang diagnostic ignored \"-Wunknown-pragmas\"")
-#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("warning(disable:161)")
-#elif JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS __pragma(warning(disable:161))
-#elif JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 1675")
-#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,3,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("GCC diagnostic ignored \"-Wunknown-pragmas\"")
-#elif JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS __pragma(warning(disable:4068))
-#elif \
-    JSON_HEDLEY_TI_VERSION_CHECK(16,9,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,0,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,3,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 163")
-#elif JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 163")
-#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress=Pe161")
-#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS _Pragma("diag_suppress 161")
-#else
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS
-#endif
-
-#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES)
-    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wunknown-attributes")
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("clang diagnostic ignored \"-Wunknown-attributes\"")
-#elif JSON_HEDLEY_GCC_VERSION_CHECK(4,6,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("GCC diagnostic ignored \"-Wdeprecated-declarations\"")
-#elif JSON_HEDLEY_INTEL_VERSION_CHECK(17,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("warning(disable:1292)")
-#elif JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES __pragma(warning(disable:1292))
-#elif JSON_HEDLEY_MSVC_VERSION_CHECK(19,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES __pragma(warning(disable:5030))
-#elif JSON_HEDLEY_PGI_VERSION_CHECK(20,7,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1097,1098")
-#elif JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1097")
-#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,14,0) && defined(__cplusplus)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("error_messages(off,attrskipunsup)")
-#elif \
-    JSON_HEDLEY_TI_VERSION_CHECK(18,1,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,3,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1173")
-#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress=Pe1097")
-#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES _Pragma("diag_suppress 1097")
-#else
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES
-#endif
-
-#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL)
-    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wcast-qual")
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL _Pragma("clang diagnostic ignored \"-Wcast-qual\"")
-#elif JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL _Pragma("warning(disable:2203 2331)")
-#elif JSON_HEDLEY_GCC_VERSION_CHECK(3,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL _Pragma("GCC diagnostic ignored \"-Wcast-qual\"")
-#else
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL
-#endif
-
-#if defined(JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION)
-    #undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wunused-function")
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION _Pragma("clang diagnostic ignored \"-Wunused-function\"")
-#elif JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION _Pragma("GCC diagnostic ignored \"-Wunused-function\"")
-#elif JSON_HEDLEY_MSVC_VERSION_CHECK(1,0,0)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION __pragma(warning(disable:4505))
-#elif JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION _Pragma("diag_suppress 3142")
-#else
-    #define JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION
-#endif
-
-#if defined(JSON_HEDLEY_DEPRECATED)
-    #undef JSON_HEDLEY_DEPRECATED
-#endif
-#if defined(JSON_HEDLEY_DEPRECATED_FOR)
-    #undef JSON_HEDLEY_DEPRECATED_FOR
-#endif
-#if \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(14,0,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_DEPRECATED(since) __declspec(deprecated("Since " # since))
-    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __declspec(deprecated("Since " #since "; use " #replacement))
-#elif \
-    (JSON_HEDLEY_HAS_EXTENSION(attribute_deprecated_with_message) && !defined(JSON_HEDLEY_IAR_VERSION)) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(4,5,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(5,6,0) || \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,13,0) || \
-    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(18,1,0) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(18,1,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,3,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,3,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_DEPRECATED(since) __attribute__((__deprecated__("Since " #since)))
-    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __attribute__((__deprecated__("Since " #since "; use " #replacement)))
-#elif defined(__cplusplus) && (__cplusplus >= 201402L)
-    #define JSON_HEDLEY_DEPRECATED(since) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[deprecated("Since " #since)]])
-    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[deprecated("Since " #since "; use " #replacement)]])
-#elif \
-    JSON_HEDLEY_HAS_ATTRIBUTE(deprecated) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10) || \
-    JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
-    #define JSON_HEDLEY_DEPRECATED(since) __attribute__((__deprecated__))
-    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __attribute__((__deprecated__))
-#elif \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
-    JSON_HEDLEY_PELLES_VERSION_CHECK(6,50,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_DEPRECATED(since) __declspec(deprecated)
-    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) __declspec(deprecated)
-#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-    #define JSON_HEDLEY_DEPRECATED(since) _Pragma("deprecated")
-    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement) _Pragma("deprecated")
-#else
-    #define JSON_HEDLEY_DEPRECATED(since)
-    #define JSON_HEDLEY_DEPRECATED_FOR(since, replacement)
-#endif
-
-#if defined(JSON_HEDLEY_UNAVAILABLE)
-    #undef JSON_HEDLEY_UNAVAILABLE
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(warning) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(4,3,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_UNAVAILABLE(available_since) __attribute__((__warning__("Not available until " #available_since)))
-#else
-    #define JSON_HEDLEY_UNAVAILABLE(available_since)
-#endif
-
-#if defined(JSON_HEDLEY_WARN_UNUSED_RESULT)
-    #undef JSON_HEDLEY_WARN_UNUSED_RESULT
-#endif
-#if defined(JSON_HEDLEY_WARN_UNUSED_RESULT_MSG)
-    #undef JSON_HEDLEY_WARN_UNUSED_RESULT_MSG
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(warn_unused_result) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0) && defined(__cplusplus)) || \
-    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT __attribute__((__warn_unused_result__))
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) __attribute__((__warn_unused_result__))
-#elif (JSON_HEDLEY_HAS_CPP_ATTRIBUTE(nodiscard) >= 201907L)
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard]])
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard(msg)]])
-#elif JSON_HEDLEY_HAS_CPP_ATTRIBUTE(nodiscard)
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard]])
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[nodiscard]])
-#elif defined(_Check_return_) /* SAL */
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT _Check_return_
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg) _Check_return_
-#else
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT
-    #define JSON_HEDLEY_WARN_UNUSED_RESULT_MSG(msg)
-#endif
-
-#if defined(JSON_HEDLEY_SENTINEL)
-    #undef JSON_HEDLEY_SENTINEL
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(sentinel) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(4,0,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(5,4,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_SENTINEL(position) __attribute__((__sentinel__(position)))
-#else
-    #define JSON_HEDLEY_SENTINEL(position)
-#endif
-
-#if defined(JSON_HEDLEY_NO_RETURN)
-    #undef JSON_HEDLEY_NO_RETURN
-#endif
-#if JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-    #define JSON_HEDLEY_NO_RETURN __noreturn
-#elif \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_NO_RETURN __attribute__((__noreturn__))
-#elif defined(__STDC_VERSION__) && __STDC_VERSION__ >= 201112L
-    #define JSON_HEDLEY_NO_RETURN _Noreturn
-#elif defined(__cplusplus) && (__cplusplus >= 201103L)
-    #define JSON_HEDLEY_NO_RETURN JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[noreturn]])
-#elif \
-    JSON_HEDLEY_HAS_ATTRIBUTE(noreturn) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,2,0) || \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
-    #define JSON_HEDLEY_NO_RETURN __attribute__((__noreturn__))
-#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
-    #define JSON_HEDLEY_NO_RETURN _Pragma("does_not_return")
-#elif \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_NO_RETURN __declspec(noreturn)
-#elif JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,0,0) && defined(__cplusplus)
-    #define JSON_HEDLEY_NO_RETURN _Pragma("FUNC_NEVER_RETURNS;")
-#elif JSON_HEDLEY_COMPCERT_VERSION_CHECK(3,2,0)
-    #define JSON_HEDLEY_NO_RETURN __attribute((noreturn))
-#elif JSON_HEDLEY_PELLES_VERSION_CHECK(9,0,0)
-    #define JSON_HEDLEY_NO_RETURN __declspec(noreturn)
-#else
-    #define JSON_HEDLEY_NO_RETURN
-#endif
-
-#if defined(JSON_HEDLEY_NO_ESCAPE)
-    #undef JSON_HEDLEY_NO_ESCAPE
-#endif
-#if JSON_HEDLEY_HAS_ATTRIBUTE(noescape)
-    #define JSON_HEDLEY_NO_ESCAPE __attribute__((__noescape__))
-#else
-    #define JSON_HEDLEY_NO_ESCAPE
-#endif
-
-#if defined(JSON_HEDLEY_UNREACHABLE)
-    #undef JSON_HEDLEY_UNREACHABLE
-#endif
-#if defined(JSON_HEDLEY_UNREACHABLE_RETURN)
-    #undef JSON_HEDLEY_UNREACHABLE_RETURN
-#endif
-#if defined(JSON_HEDLEY_ASSUME)
-    #undef JSON_HEDLEY_ASSUME
-#endif
-#if \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_ASSUME(expr) __assume(expr)
-#elif JSON_HEDLEY_HAS_BUILTIN(__builtin_assume)
-    #define JSON_HEDLEY_ASSUME(expr) __builtin_assume(expr)
-#elif \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(4,0,0)
-    #if defined(__cplusplus)
-        #define JSON_HEDLEY_ASSUME(expr) std::_nassert(expr)
-    #else
-        #define JSON_HEDLEY_ASSUME(expr) _nassert(expr)
-    #endif
-#endif
-#if \
-    (JSON_HEDLEY_HAS_BUILTIN(__builtin_unreachable) && (!defined(JSON_HEDLEY_ARM_VERSION))) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(4,5,0) || \
-    JSON_HEDLEY_PGI_VERSION_CHECK(18,10,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(13,1,5) || \
-    JSON_HEDLEY_CRAY_VERSION_CHECK(10,0,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_UNREACHABLE() __builtin_unreachable()
-#elif defined(JSON_HEDLEY_ASSUME)
-    #define JSON_HEDLEY_UNREACHABLE() JSON_HEDLEY_ASSUME(0)
-#endif
-#if !defined(JSON_HEDLEY_ASSUME)
-    #if defined(JSON_HEDLEY_UNREACHABLE)
-        #define JSON_HEDLEY_ASSUME(expr) JSON_HEDLEY_STATIC_CAST(void, ((expr) ? 1 : (JSON_HEDLEY_UNREACHABLE(), 1)))
-    #else
-        #define JSON_HEDLEY_ASSUME(expr) JSON_HEDLEY_STATIC_CAST(void, expr)
-    #endif
-#endif
-#if defined(JSON_HEDLEY_UNREACHABLE)
-    #if  \
-        JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,0) || \
-        JSON_HEDLEY_TI_CL6X_VERSION_CHECK(4,0,0)
-        #define JSON_HEDLEY_UNREACHABLE_RETURN(value) return (JSON_HEDLEY_STATIC_CAST(void, JSON_HEDLEY_ASSUME(0)), (value))
-    #else
-        #define JSON_HEDLEY_UNREACHABLE_RETURN(value) JSON_HEDLEY_UNREACHABLE()
-    #endif
-#else
-    #define JSON_HEDLEY_UNREACHABLE_RETURN(value) return (value)
-#endif
-#if !defined(JSON_HEDLEY_UNREACHABLE)
-    #define JSON_HEDLEY_UNREACHABLE() JSON_HEDLEY_ASSUME(0)
-#endif
-
-JSON_HEDLEY_DIAGNOSTIC_PUSH
-#if JSON_HEDLEY_HAS_WARNING("-Wpedantic")
-    #pragma clang diagnostic ignored "-Wpedantic"
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wc++98-compat-pedantic") && defined(__cplusplus)
-    #pragma clang diagnostic ignored "-Wc++98-compat-pedantic"
-#endif
-#if JSON_HEDLEY_GCC_HAS_WARNING("-Wvariadic-macros",4,0,0)
-    #if defined(__clang__)
-        #pragma clang diagnostic ignored "-Wvariadic-macros"
-    #elif defined(JSON_HEDLEY_GCC_VERSION)
-        #pragma GCC diagnostic ignored "-Wvariadic-macros"
-    #endif
-#endif
-#if defined(JSON_HEDLEY_NON_NULL)
-    #undef JSON_HEDLEY_NON_NULL
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(nonnull) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,3,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0)
-    #define JSON_HEDLEY_NON_NULL(...) __attribute__((__nonnull__(__VA_ARGS__)))
-#else
-    #define JSON_HEDLEY_NON_NULL(...)
-#endif
-JSON_HEDLEY_DIAGNOSTIC_POP
-
-#if defined(JSON_HEDLEY_PRINTF_FORMAT)
-    #undef JSON_HEDLEY_PRINTF_FORMAT
-#endif
-#if defined(__MINGW32__) && JSON_HEDLEY_GCC_HAS_ATTRIBUTE(format,4,4,0) && !defined(__USE_MINGW_ANSI_STDIO)
-    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __attribute__((__format__(ms_printf, string_idx, first_to_check)))
-#elif defined(__MINGW32__) && JSON_HEDLEY_GCC_HAS_ATTRIBUTE(format,4,4,0) && defined(__USE_MINGW_ANSI_STDIO)
-    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __attribute__((__format__(gnu_printf, string_idx, first_to_check)))
-#elif \
-    JSON_HEDLEY_HAS_ATTRIBUTE(format) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(5,6,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __attribute__((__format__(__printf__, string_idx, first_to_check)))
-#elif JSON_HEDLEY_PELLES_VERSION_CHECK(6,0,0)
-    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check) __declspec(vaformat(printf,string_idx,first_to_check))
-#else
-    #define JSON_HEDLEY_PRINTF_FORMAT(string_idx,first_to_check)
-#endif
-
-#if defined(JSON_HEDLEY_CONSTEXPR)
-    #undef JSON_HEDLEY_CONSTEXPR
-#endif
-#if defined(__cplusplus)
-    #if __cplusplus >= 201103L
-        #define JSON_HEDLEY_CONSTEXPR JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(constexpr)
-    #endif
-#endif
-#if !defined(JSON_HEDLEY_CONSTEXPR)
-    #define JSON_HEDLEY_CONSTEXPR
-#endif
-
-#if defined(JSON_HEDLEY_PREDICT)
-    #undef JSON_HEDLEY_PREDICT
-#endif
-#if defined(JSON_HEDLEY_LIKELY)
-    #undef JSON_HEDLEY_LIKELY
-#endif
-#if defined(JSON_HEDLEY_UNLIKELY)
-    #undef JSON_HEDLEY_UNLIKELY
-#endif
-#if defined(JSON_HEDLEY_UNPREDICTABLE)
-    #undef JSON_HEDLEY_UNPREDICTABLE
-#endif
-#if JSON_HEDLEY_HAS_BUILTIN(__builtin_unpredictable)
-    #define JSON_HEDLEY_UNPREDICTABLE(expr) __builtin_unpredictable((expr))
-#endif
-#if \
-  (JSON_HEDLEY_HAS_BUILTIN(__builtin_expect_with_probability) && !defined(JSON_HEDLEY_PGI_VERSION)) || \
-  JSON_HEDLEY_GCC_VERSION_CHECK(9,0,0) || \
-  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-#  define JSON_HEDLEY_PREDICT(expr, value, probability) __builtin_expect_with_probability(  (expr), (value), (probability))
-#  define JSON_HEDLEY_PREDICT_TRUE(expr, probability)   __builtin_expect_with_probability(!!(expr),    1   , (probability))
-#  define JSON_HEDLEY_PREDICT_FALSE(expr, probability)  __builtin_expect_with_probability(!!(expr),    0   , (probability))
-#  define JSON_HEDLEY_LIKELY(expr)                      __builtin_expect                 (!!(expr),    1                  )
-#  define JSON_HEDLEY_UNLIKELY(expr)                    __builtin_expect                 (!!(expr),    0                  )
-#elif \
-  (JSON_HEDLEY_HAS_BUILTIN(__builtin_expect) && !defined(JSON_HEDLEY_INTEL_CL_VERSION)) || \
-  JSON_HEDLEY_GCC_VERSION_CHECK(3,0,0) || \
-  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-  (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,15,0) && defined(__cplusplus)) || \
-  JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-  JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-  JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-  JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,7,0) || \
-  JSON_HEDLEY_TI_CL430_VERSION_CHECK(3,1,0) || \
-  JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,1,0) || \
-  JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,1,0) || \
-  JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-  JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-  JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,27) || \
-  JSON_HEDLEY_CRAY_VERSION_CHECK(8,1,0) || \
-  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-#  define JSON_HEDLEY_PREDICT(expr, expected, probability) \
-    (((probability) >= 0.9) ? __builtin_expect((expr), (expected)) : (JSON_HEDLEY_STATIC_CAST(void, expected), (expr)))
-#  define JSON_HEDLEY_PREDICT_TRUE(expr, probability) \
-    (__extension__ ({ \
-        double hedley_probability_ = (probability); \
-        ((hedley_probability_ >= 0.9) ? __builtin_expect(!!(expr), 1) : ((hedley_probability_ <= 0.1) ? __builtin_expect(!!(expr), 0) : !!(expr))); \
-    }))
-#  define JSON_HEDLEY_PREDICT_FALSE(expr, probability) \
-    (__extension__ ({ \
-        double hedley_probability_ = (probability); \
-        ((hedley_probability_ >= 0.9) ? __builtin_expect(!!(expr), 0) : ((hedley_probability_ <= 0.1) ? __builtin_expect(!!(expr), 1) : !!(expr))); \
-    }))
-#  define JSON_HEDLEY_LIKELY(expr)   __builtin_expect(!!(expr), 1)
-#  define JSON_HEDLEY_UNLIKELY(expr) __builtin_expect(!!(expr), 0)
-#else
-#  define JSON_HEDLEY_PREDICT(expr, expected, probability) (JSON_HEDLEY_STATIC_CAST(void, expected), (expr))
-#  define JSON_HEDLEY_PREDICT_TRUE(expr, probability) (!!(expr))
-#  define JSON_HEDLEY_PREDICT_FALSE(expr, probability) (!!(expr))
-#  define JSON_HEDLEY_LIKELY(expr) (!!(expr))
-#  define JSON_HEDLEY_UNLIKELY(expr) (!!(expr))
-#endif
-#if !defined(JSON_HEDLEY_UNPREDICTABLE)
-    #define JSON_HEDLEY_UNPREDICTABLE(expr) JSON_HEDLEY_PREDICT(expr, 1, 0.5)
-#endif
-
-#if defined(JSON_HEDLEY_MALLOC)
-    #undef JSON_HEDLEY_MALLOC
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(malloc) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(12,1,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_MALLOC __attribute__((__malloc__))
-#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
-    #define JSON_HEDLEY_MALLOC _Pragma("returns_new_memory")
-#elif \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(14,0,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_MALLOC __declspec(restrict)
-#else
-    #define JSON_HEDLEY_MALLOC
-#endif
-
-#if defined(JSON_HEDLEY_PURE)
-    #undef JSON_HEDLEY_PURE
-#endif
-#if \
-  JSON_HEDLEY_HAS_ATTRIBUTE(pure) || \
-  JSON_HEDLEY_GCC_VERSION_CHECK(2,96,0) || \
-  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-  JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
-  JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-  JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-  JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-  (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-  (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-  (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-  (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-  JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-  JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-  JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
-  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-#  define JSON_HEDLEY_PURE __attribute__((__pure__))
-#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
-#  define JSON_HEDLEY_PURE _Pragma("does_not_write_global_data")
-#elif defined(__cplusplus) && \
-    ( \
-      JSON_HEDLEY_TI_CL430_VERSION_CHECK(2,0,1) || \
-      JSON_HEDLEY_TI_CL6X_VERSION_CHECK(4,0,0) || \
-      JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) \
-    )
-#  define JSON_HEDLEY_PURE _Pragma("FUNC_IS_PURE;")
-#else
-#  define JSON_HEDLEY_PURE
-#endif
-
-#if defined(JSON_HEDLEY_CONST)
-    #undef JSON_HEDLEY_CONST
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(const) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(2,5,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_CONST __attribute__((__const__))
-#elif \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0)
-    #define JSON_HEDLEY_CONST _Pragma("no_side_effect")
-#else
-    #define JSON_HEDLEY_CONST JSON_HEDLEY_PURE
-#endif
-
-#if defined(JSON_HEDLEY_RESTRICT)
-    #undef JSON_HEDLEY_RESTRICT
-#endif
-#if defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L) && !defined(__cplusplus)
-    #define JSON_HEDLEY_RESTRICT restrict
-#elif \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,1,0) || \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(14,0,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-    JSON_HEDLEY_PGI_VERSION_CHECK(17,10,0) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,4) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,1,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,14,0) && defined(__cplusplus)) || \
-    JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0) || \
-    defined(__clang__) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_RESTRICT __restrict
-#elif JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,3,0) && !defined(__cplusplus)
-    #define JSON_HEDLEY_RESTRICT _Restrict
-#else
-    #define JSON_HEDLEY_RESTRICT
-#endif
-
-#if defined(JSON_HEDLEY_INLINE)
-    #undef JSON_HEDLEY_INLINE
-#endif
-#if \
-    (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L)) || \
-    (defined(__cplusplus) && (__cplusplus >= 199711L))
-    #define JSON_HEDLEY_INLINE inline
-#elif \
-    defined(JSON_HEDLEY_GCC_VERSION) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(6,2,0)
-    #define JSON_HEDLEY_INLINE __inline__
-#elif \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(12,0,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,1,0) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(3,1,0) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,2,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(8,0,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_INLINE __inline
-#else
-    #define JSON_HEDLEY_INLINE
-#endif
-
-#if defined(JSON_HEDLEY_ALWAYS_INLINE)
-    #undef JSON_HEDLEY_ALWAYS_INLINE
-#endif
-#if \
-  JSON_HEDLEY_HAS_ATTRIBUTE(always_inline) || \
-  JSON_HEDLEY_GCC_VERSION_CHECK(4,0,0) || \
-  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-  JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
-  JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-  JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-  JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-  (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-  (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-  (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-  (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-  JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-  JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-  JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-  JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10) || \
-  JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
-#  define JSON_HEDLEY_ALWAYS_INLINE __attribute__((__always_inline__)) JSON_HEDLEY_INLINE
-#elif \
-  JSON_HEDLEY_MSVC_VERSION_CHECK(12,0,0) || \
-  JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-#  define JSON_HEDLEY_ALWAYS_INLINE __forceinline
-#elif defined(__cplusplus) && \
-    ( \
-      JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-      JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-      JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-      JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,1,0) || \
-      JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-      JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) \
-    )
-#  define JSON_HEDLEY_ALWAYS_INLINE _Pragma("FUNC_ALWAYS_INLINE;")
-#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-#  define JSON_HEDLEY_ALWAYS_INLINE _Pragma("inline=forced")
-#else
-#  define JSON_HEDLEY_ALWAYS_INLINE JSON_HEDLEY_INLINE
-#endif
-
-#if defined(JSON_HEDLEY_NEVER_INLINE)
-    #undef JSON_HEDLEY_NEVER_INLINE
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(noinline) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(4,0,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(10,1,0) || \
-    JSON_HEDLEY_TI_VERSION_CHECK(15,12,0) || \
-    (JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(4,8,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_ARMCL_VERSION_CHECK(5,2,0) || \
-    (JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL2000_VERSION_CHECK(6,4,0) || \
-    (JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,0,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL430_VERSION_CHECK(4,3,0) || \
-    (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) || \
-    JSON_HEDLEY_TI_CL7X_VERSION_CHECK(1,2,0) || \
-    JSON_HEDLEY_TI_CLPRU_VERSION_CHECK(2,1,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10) || \
-    JSON_HEDLEY_IAR_VERSION_CHECK(8,10,0)
-    #define JSON_HEDLEY_NEVER_INLINE __attribute__((__noinline__))
-#elif \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(13,10,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_NEVER_INLINE __declspec(noinline)
-#elif JSON_HEDLEY_PGI_VERSION_CHECK(10,2,0)
-    #define JSON_HEDLEY_NEVER_INLINE _Pragma("noinline")
-#elif JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,0,0) && defined(__cplusplus)
-    #define JSON_HEDLEY_NEVER_INLINE _Pragma("FUNC_CANNOT_INLINE;")
-#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-    #define JSON_HEDLEY_NEVER_INLINE _Pragma("inline=never")
-#elif JSON_HEDLEY_COMPCERT_VERSION_CHECK(3,2,0)
-    #define JSON_HEDLEY_NEVER_INLINE __attribute((noinline))
-#elif JSON_HEDLEY_PELLES_VERSION_CHECK(9,0,0)
-    #define JSON_HEDLEY_NEVER_INLINE __declspec(noinline)
-#else
-    #define JSON_HEDLEY_NEVER_INLINE
-#endif
-
-#if defined(JSON_HEDLEY_PRIVATE)
-    #undef JSON_HEDLEY_PRIVATE
-#endif
-#if defined(JSON_HEDLEY_PUBLIC)
-    #undef JSON_HEDLEY_PUBLIC
-#endif
-#if defined(JSON_HEDLEY_IMPORT)
-    #undef JSON_HEDLEY_IMPORT
-#endif
-#if defined(_WIN32) || defined(__CYGWIN__)
-#  define JSON_HEDLEY_PRIVATE
-#  define JSON_HEDLEY_PUBLIC   __declspec(dllexport)
-#  define JSON_HEDLEY_IMPORT   __declspec(dllimport)
-#else
-#  if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(visibility) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,3,0) || \
-    JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,11,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(13,1,0) || \
-    ( \
-      defined(__TI_EABI__) && \
-      ( \
-        (JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,2,0) && defined(__TI_GNU_ATTRIBUTE_SUPPORT__)) || \
-        JSON_HEDLEY_TI_CL6X_VERSION_CHECK(7,5,0) \
-      ) \
-    ) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-#    define JSON_HEDLEY_PRIVATE __attribute__((__visibility__("hidden")))
-#    define JSON_HEDLEY_PUBLIC  __attribute__((__visibility__("default")))
-#  else
-#    define JSON_HEDLEY_PRIVATE
-#    define JSON_HEDLEY_PUBLIC
-#  endif
-#  define JSON_HEDLEY_IMPORT    extern
-#endif
-
-#if defined(JSON_HEDLEY_NO_THROW)
-    #undef JSON_HEDLEY_NO_THROW
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(nothrow) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,3,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_NO_THROW __attribute__((__nothrow__))
-#elif \
-    JSON_HEDLEY_MSVC_VERSION_CHECK(13,1,0) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0)
-    #define JSON_HEDLEY_NO_THROW __declspec(nothrow)
-#else
-    #define JSON_HEDLEY_NO_THROW
-#endif
-
-#if defined(JSON_HEDLEY_FALL_THROUGH)
-    #undef JSON_HEDLEY_FALL_THROUGH
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(fallthrough) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(7,0,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_FALL_THROUGH __attribute__((__fallthrough__))
-#elif JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS(clang,fallthrough)
-    #define JSON_HEDLEY_FALL_THROUGH JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[clang::fallthrough]])
-#elif JSON_HEDLEY_HAS_CPP_ATTRIBUTE(fallthrough)
-    #define JSON_HEDLEY_FALL_THROUGH JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_([[fallthrough]])
-#elif defined(__fallthrough) /* SAL */
-    #define JSON_HEDLEY_FALL_THROUGH __fallthrough
-#else
-    #define JSON_HEDLEY_FALL_THROUGH
-#endif
-
-#if defined(JSON_HEDLEY_RETURNS_NON_NULL)
-    #undef JSON_HEDLEY_RETURNS_NON_NULL
-#endif
-#if \
-    JSON_HEDLEY_HAS_ATTRIBUTE(returns_nonnull) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(4,9,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_RETURNS_NON_NULL __attribute__((__returns_nonnull__))
-#elif defined(_Ret_notnull_) /* SAL */
-    #define JSON_HEDLEY_RETURNS_NON_NULL _Ret_notnull_
-#else
-    #define JSON_HEDLEY_RETURNS_NON_NULL
-#endif
-
-#if defined(JSON_HEDLEY_ARRAY_PARAM)
-    #undef JSON_HEDLEY_ARRAY_PARAM
-#endif
-#if \
-    defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L) && \
-    !defined(__STDC_NO_VLA__) && \
-    !defined(__cplusplus) && \
-    !defined(JSON_HEDLEY_PGI_VERSION) && \
-    !defined(JSON_HEDLEY_TINYC_VERSION)
-    #define JSON_HEDLEY_ARRAY_PARAM(name) (name)
-#else
-    #define JSON_HEDLEY_ARRAY_PARAM(name)
-#endif
-
-#if defined(JSON_HEDLEY_IS_CONSTANT)
-    #undef JSON_HEDLEY_IS_CONSTANT
-#endif
-#if defined(JSON_HEDLEY_REQUIRE_CONSTEXPR)
-    #undef JSON_HEDLEY_REQUIRE_CONSTEXPR
-#endif
-/* JSON_HEDLEY_IS_CONSTEXPR_ is for
-   HEDLEY INTERNAL USE ONLY.  API subject to change without notice. */
-#if defined(JSON_HEDLEY_IS_CONSTEXPR_)
-    #undef JSON_HEDLEY_IS_CONSTEXPR_
-#endif
-#if \
-    JSON_HEDLEY_HAS_BUILTIN(__builtin_constant_p) || \
-    JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0) || \
-    JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-    JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,19) || \
-    JSON_HEDLEY_ARM_VERSION_CHECK(4,1,0) || \
-    JSON_HEDLEY_IBM_VERSION_CHECK(13,1,0) || \
-    JSON_HEDLEY_TI_CL6X_VERSION_CHECK(6,1,0) || \
-    (JSON_HEDLEY_SUNPRO_VERSION_CHECK(5,10,0) && !defined(__cplusplus)) || \
-    JSON_HEDLEY_CRAY_VERSION_CHECK(8,1,0) || \
-    JSON_HEDLEY_MCST_LCC_VERSION_CHECK(1,25,10)
-    #define JSON_HEDLEY_IS_CONSTANT(expr) __builtin_constant_p(expr)
-#endif
-#if !defined(__cplusplus)
-#  if \
-       JSON_HEDLEY_HAS_BUILTIN(__builtin_types_compatible_p) || \
-       JSON_HEDLEY_GCC_VERSION_CHECK(3,4,0) || \
-       JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-       JSON_HEDLEY_IBM_VERSION_CHECK(13,1,0) || \
-       JSON_HEDLEY_CRAY_VERSION_CHECK(8,1,0) || \
-       JSON_HEDLEY_ARM_VERSION_CHECK(5,4,0) || \
-       JSON_HEDLEY_TINYC_VERSION_CHECK(0,9,24)
-#if defined(__INTPTR_TYPE__)
-    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) __builtin_types_compatible_p(__typeof__((1 ? (void*) ((__INTPTR_TYPE__) ((expr) * 0)) : (int*) 0)), int*)
-#else
-    #include <stdint.h>
-    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) __builtin_types_compatible_p(__typeof__((1 ? (void*) ((intptr_t) ((expr) * 0)) : (int*) 0)), int*)
-#endif
-#  elif \
-       ( \
-          defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 201112L) && \
-          !defined(JSON_HEDLEY_SUNPRO_VERSION) && \
-          !defined(JSON_HEDLEY_PGI_VERSION) && \
-          !defined(JSON_HEDLEY_IAR_VERSION)) || \
-       (JSON_HEDLEY_HAS_EXTENSION(c_generic_selections) && !defined(JSON_HEDLEY_IAR_VERSION)) || \
-       JSON_HEDLEY_GCC_VERSION_CHECK(4,9,0) || \
-       JSON_HEDLEY_INTEL_VERSION_CHECK(17,0,0) || \
-       JSON_HEDLEY_IBM_VERSION_CHECK(12,1,0) || \
-       JSON_HEDLEY_ARM_VERSION_CHECK(5,3,0)
-#if defined(__INTPTR_TYPE__)
-    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) _Generic((1 ? (void*) ((__INTPTR_TYPE__) ((expr) * 0)) : (int*) 0), int*: 1, void*: 0)
-#else
-    #include <stdint.h>
-    #define JSON_HEDLEY_IS_CONSTEXPR_(expr) _Generic((1 ? (void*) ((intptr_t) * 0) : (int*) 0), int*: 1, void*: 0)
-#endif
-#  elif \
-       defined(JSON_HEDLEY_GCC_VERSION) || \
-       defined(JSON_HEDLEY_INTEL_VERSION) || \
-       defined(JSON_HEDLEY_TINYC_VERSION) || \
-       defined(JSON_HEDLEY_TI_ARMCL_VERSION) || \
-       JSON_HEDLEY_TI_CL430_VERSION_CHECK(18,12,0) || \
-       defined(JSON_HEDLEY_TI_CL2000_VERSION) || \
-       defined(JSON_HEDLEY_TI_CL6X_VERSION) || \
-       defined(JSON_HEDLEY_TI_CL7X_VERSION) || \
-       defined(JSON_HEDLEY_TI_CLPRU_VERSION) || \
-       defined(__clang__)
-#    define JSON_HEDLEY_IS_CONSTEXPR_(expr) ( \
-        sizeof(void) != \
-        sizeof(*( \
-                  1 ? \
-                  ((void*) ((expr) * 0L) ) : \
-((struct { char v[sizeof(void) * 2]; } *) 1) \
-                ) \
-              ) \
-                                            )
-#  endif
-#endif
-#if defined(JSON_HEDLEY_IS_CONSTEXPR_)
-    #if !defined(JSON_HEDLEY_IS_CONSTANT)
-        #define JSON_HEDLEY_IS_CONSTANT(expr) JSON_HEDLEY_IS_CONSTEXPR_(expr)
-    #endif
-    #define JSON_HEDLEY_REQUIRE_CONSTEXPR(expr) (JSON_HEDLEY_IS_CONSTEXPR_(expr) ? (expr) : (-1))
-#else
-    #if !defined(JSON_HEDLEY_IS_CONSTANT)
-        #define JSON_HEDLEY_IS_CONSTANT(expr) (0)
-    #endif
-    #define JSON_HEDLEY_REQUIRE_CONSTEXPR(expr) (expr)
-#endif
-
-#if defined(JSON_HEDLEY_BEGIN_C_DECLS)
-    #undef JSON_HEDLEY_BEGIN_C_DECLS
-#endif
-#if defined(JSON_HEDLEY_END_C_DECLS)
-    #undef JSON_HEDLEY_END_C_DECLS
-#endif
-#if defined(JSON_HEDLEY_C_DECL)
-    #undef JSON_HEDLEY_C_DECL
-#endif
-#if defined(__cplusplus)
-    #define JSON_HEDLEY_BEGIN_C_DECLS extern "C" {
-    #define JSON_HEDLEY_END_C_DECLS }
-    #define JSON_HEDLEY_C_DECL extern "C"
-#else
-    #define JSON_HEDLEY_BEGIN_C_DECLS
-    #define JSON_HEDLEY_END_C_DECLS
-    #define JSON_HEDLEY_C_DECL
-#endif
-
-#if defined(JSON_HEDLEY_STATIC_ASSERT)
-    #undef JSON_HEDLEY_STATIC_ASSERT
-#endif
-#if \
-  !defined(__cplusplus) && ( \
-      (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 201112L)) || \
-      (JSON_HEDLEY_HAS_FEATURE(c_static_assert) && !defined(JSON_HEDLEY_INTEL_CL_VERSION)) || \
-      JSON_HEDLEY_GCC_VERSION_CHECK(6,0,0) || \
-      JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0) || \
-      defined(_Static_assert) \
-    )
-#  define JSON_HEDLEY_STATIC_ASSERT(expr, message) _Static_assert(expr, message)
-#elif \
-  (defined(__cplusplus) && (__cplusplus >= 201103L)) || \
-  JSON_HEDLEY_MSVC_VERSION_CHECK(16,0,0) || \
-  JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-#  define JSON_HEDLEY_STATIC_ASSERT(expr, message) JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(static_assert(expr, message))
-#else
-#  define JSON_HEDLEY_STATIC_ASSERT(expr, message)
-#endif
-
-#if defined(JSON_HEDLEY_NULL)
-    #undef JSON_HEDLEY_NULL
-#endif
-#if defined(__cplusplus)
-    #if __cplusplus >= 201103L
-        #define JSON_HEDLEY_NULL JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_(nullptr)
-    #elif defined(NULL)
-        #define JSON_HEDLEY_NULL NULL
-    #else
-        #define JSON_HEDLEY_NULL JSON_HEDLEY_STATIC_CAST(void*, 0)
-    #endif
-#elif defined(NULL)
-    #define JSON_HEDLEY_NULL NULL
-#else
-    #define JSON_HEDLEY_NULL ((void*) 0)
-#endif
-
-#if defined(JSON_HEDLEY_MESSAGE)
-    #undef JSON_HEDLEY_MESSAGE
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wunknown-pragmas")
-#  define JSON_HEDLEY_MESSAGE(msg) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS \
-    JSON_HEDLEY_PRAGMA(message msg) \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#elif \
-  JSON_HEDLEY_GCC_VERSION_CHECK(4,4,0) || \
-  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
-#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(message msg)
-#elif JSON_HEDLEY_CRAY_VERSION_CHECK(5,0,0)
-#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(_CRI message msg)
-#elif JSON_HEDLEY_IAR_VERSION_CHECK(8,0,0)
-#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(message(msg))
-#elif JSON_HEDLEY_PELLES_VERSION_CHECK(2,0,0)
-#  define JSON_HEDLEY_MESSAGE(msg) JSON_HEDLEY_PRAGMA(message(msg))
-#else
-#  define JSON_HEDLEY_MESSAGE(msg)
-#endif
-
-#if defined(JSON_HEDLEY_WARNING)
-    #undef JSON_HEDLEY_WARNING
-#endif
-#if JSON_HEDLEY_HAS_WARNING("-Wunknown-pragmas")
-#  define JSON_HEDLEY_WARNING(msg) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS \
-    JSON_HEDLEY_PRAGMA(clang warning msg) \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#elif \
-  JSON_HEDLEY_GCC_VERSION_CHECK(4,8,0) || \
-  JSON_HEDLEY_PGI_VERSION_CHECK(18,4,0) || \
-  JSON_HEDLEY_INTEL_VERSION_CHECK(13,0,0)
-#  define JSON_HEDLEY_WARNING(msg) JSON_HEDLEY_PRAGMA(GCC warning msg)
-#elif \
-  JSON_HEDLEY_MSVC_VERSION_CHECK(15,0,0) || \
-  JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-#  define JSON_HEDLEY_WARNING(msg) JSON_HEDLEY_PRAGMA(message(msg))
-#else
-#  define JSON_HEDLEY_WARNING(msg) JSON_HEDLEY_MESSAGE(msg)
-#endif
-
-#if defined(JSON_HEDLEY_REQUIRE)
-    #undef JSON_HEDLEY_REQUIRE
-#endif
-#if defined(JSON_HEDLEY_REQUIRE_MSG)
-    #undef JSON_HEDLEY_REQUIRE_MSG
-#endif
-#if JSON_HEDLEY_HAS_ATTRIBUTE(diagnose_if)
-#  if JSON_HEDLEY_HAS_WARNING("-Wgcc-compat")
-#    define JSON_HEDLEY_REQUIRE(expr) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    _Pragma("clang diagnostic ignored \"-Wgcc-compat\"") \
-    __attribute__((diagnose_if(!(expr), #expr, "error"))) \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#    define JSON_HEDLEY_REQUIRE_MSG(expr,msg) \
-    JSON_HEDLEY_DIAGNOSTIC_PUSH \
-    _Pragma("clang diagnostic ignored \"-Wgcc-compat\"") \
-    __attribute__((diagnose_if(!(expr), msg, "error"))) \
-    JSON_HEDLEY_DIAGNOSTIC_POP
-#  else
-#    define JSON_HEDLEY_REQUIRE(expr) __attribute__((diagnose_if(!(expr), #expr, "error")))
-#    define JSON_HEDLEY_REQUIRE_MSG(expr,msg) __attribute__((diagnose_if(!(expr), msg, "error")))
-#  endif
-#else
-#  define JSON_HEDLEY_REQUIRE(expr)
-#  define JSON_HEDLEY_REQUIRE_MSG(expr,msg)
-#endif
-
-#if defined(JSON_HEDLEY_FLAGS)
-    #undef JSON_HEDLEY_FLAGS
-#endif
-#if JSON_HEDLEY_HAS_ATTRIBUTE(flag_enum) && (!defined(__cplusplus) || JSON_HEDLEY_HAS_WARNING("-Wbitfield-enum-conversion"))
-    #define JSON_HEDLEY_FLAGS __attribute__((__flag_enum__))
-#else
-    #define JSON_HEDLEY_FLAGS
-#endif
-
-#if defined(JSON_HEDLEY_FLAGS_CAST)
-    #undef JSON_HEDLEY_FLAGS_CAST
-#endif
-#if JSON_HEDLEY_INTEL_VERSION_CHECK(19,0,0)
-#  define JSON_HEDLEY_FLAGS_CAST(T, expr) (__extension__ ({ \
-        JSON_HEDLEY_DIAGNOSTIC_PUSH \
-        _Pragma("warning(disable:188)") \
-        ((T) (expr)); \
-        JSON_HEDLEY_DIAGNOSTIC_POP \
-    }))
-#else
-#  define JSON_HEDLEY_FLAGS_CAST(T, expr) JSON_HEDLEY_STATIC_CAST(T, expr)
-#endif
-
-#if defined(JSON_HEDLEY_EMPTY_BASES)
-    #undef JSON_HEDLEY_EMPTY_BASES
-#endif
-#if \
-    (JSON_HEDLEY_MSVC_VERSION_CHECK(19,0,23918) && !JSON_HEDLEY_MSVC_VERSION_CHECK(20,0,0)) || \
-    JSON_HEDLEY_INTEL_CL_VERSION_CHECK(2021,1,0)
-    #define JSON_HEDLEY_EMPTY_BASES __declspec(empty_bases)
-#else
-    #define JSON_HEDLEY_EMPTY_BASES
-#endif
-
-/* Remaining macros are deprecated. */
-
-#if defined(JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK)
-    #undef JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK
-#endif
-#if defined(__clang__)
-    #define JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK(major,minor,patch) (0)
-#else
-    #define JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK(major,minor,patch) JSON_HEDLEY_GCC_VERSION_CHECK(major,minor,patch)
-#endif
-
-#if defined(JSON_HEDLEY_CLANG_HAS_ATTRIBUTE)
-    #undef JSON_HEDLEY_CLANG_HAS_ATTRIBUTE
-#endif
-#define JSON_HEDLEY_CLANG_HAS_ATTRIBUTE(attribute) JSON_HEDLEY_HAS_ATTRIBUTE(attribute)
-
-#if defined(JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE)
-    #undef JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE
-#endif
-#define JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE(attribute) JSON_HEDLEY_HAS_CPP_ATTRIBUTE(attribute)
-
-#if defined(JSON_HEDLEY_CLANG_HAS_BUILTIN)
-    #undef JSON_HEDLEY_CLANG_HAS_BUILTIN
-#endif
-#define JSON_HEDLEY_CLANG_HAS_BUILTIN(builtin) JSON_HEDLEY_HAS_BUILTIN(builtin)
-
-#if defined(JSON_HEDLEY_CLANG_HAS_FEATURE)
-    #undef JSON_HEDLEY_CLANG_HAS_FEATURE
-#endif
-#define JSON_HEDLEY_CLANG_HAS_FEATURE(feature) JSON_HEDLEY_HAS_FEATURE(feature)
-
-#if defined(JSON_HEDLEY_CLANG_HAS_EXTENSION)
-    #undef JSON_HEDLEY_CLANG_HAS_EXTENSION
-#endif
-#define JSON_HEDLEY_CLANG_HAS_EXTENSION(extension) JSON_HEDLEY_HAS_EXTENSION(extension)
-
-#if defined(JSON_HEDLEY_CLANG_HAS_DECLSPEC_DECLSPEC_ATTRIBUTE)
-    #undef JSON_HEDLEY_CLANG_HAS_DECLSPEC_DECLSPEC_ATTRIBUTE
-#endif
-#define JSON_HEDLEY_CLANG_HAS_DECLSPEC_ATTRIBUTE(attribute) JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE(attribute)
-
-#if defined(JSON_HEDLEY_CLANG_HAS_WARNING)
-    #undef JSON_HEDLEY_CLANG_HAS_WARNING
-#endif
-#define JSON_HEDLEY_CLANG_HAS_WARNING(warning) JSON_HEDLEY_HAS_WARNING(warning)
-
-#endif /* !defined(JSON_HEDLEY_VERSION) || (JSON_HEDLEY_VERSION < X) */
-
-// #include <nlohmann/detail/meta/detected.hpp>
-
-
-#include <type_traits>
-
-// #include <nlohmann/detail/meta/void_t.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-template<typename ...Ts> struct make_void
-{
-    using type = void;
-};
-template<typename ...Ts> using void_t = typename make_void<Ts...>::type;
-} // namespace detail
-}  // namespace nlohmann
-
-
-// https://en.cppreference.com/w/cpp/experimental/is_detected
-namespace nlohmann
-{
-namespace detail
-{
-struct nonesuch
-{
-    nonesuch() = delete;
-    ~nonesuch() = delete;
-    nonesuch(nonesuch const&) = delete;
-    nonesuch(nonesuch const&&) = delete;
-    void operator=(nonesuch const&) = delete;
-    void operator=(nonesuch&&) = delete;
-};
-
-template<class Default,
-         class AlwaysVoid,
-         template<class...> class Op,
-         class... Args>
-struct detector
-{
-    using value_t = std::false_type;
-    using type = Default;
-};
-
-template<class Default, template<class...> class Op, class... Args>
-struct detector<Default, void_t<Op<Args...>>, Op, Args...>
-{
-    using value_t = std::true_type;
-    using type = Op<Args...>;
-};
-
-template<template<class...> class Op, class... Args>
-using is_detected = typename detector<nonesuch, void, Op, Args...>::value_t;
-
-template<template<class...> class Op, class... Args>
-struct is_detected_lazy : is_detected<Op, Args...> { };
-
-template<template<class...> class Op, class... Args>
-using detected_t = typename detector<nonesuch, void, Op, Args...>::type;
-
-template<class Default, template<class...> class Op, class... Args>
-using detected_or = detector<Default, void, Op, Args...>;
-
-template<class Default, template<class...> class Op, class... Args>
-using detected_or_t = typename detected_or<Default, Op, Args...>::type;
-
-template<class Expected, template<class...> class Op, class... Args>
-using is_detected_exact = std::is_same<Expected, detected_t<Op, Args...>>;
-
-template<class To, template<class...> class Op, class... Args>
-using is_detected_convertible =
-    std::is_convertible<detected_t<Op, Args...>, To>;
-}  // namespace detail
-}  // namespace nlohmann
-
-
-// This file contains all internal macro definitions
-// You MUST include macro_unscope.hpp at the end of json.hpp to undef all of them
-
-// exclude unsupported compilers
-#if !defined(JSON_SKIP_UNSUPPORTED_COMPILER_CHECK)
-    #if defined(__clang__)
-        #if (__clang_major__ * 10000 + __clang_minor__ * 100 + __clang_patchlevel__) < 30400
-            #error "unsupported Clang version - see https://github.com/nlohmann/json#supported-compilers"
-        #endif
-    #elif defined(__GNUC__) && !(defined(__ICC) || defined(__INTEL_COMPILER))
-        #if (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__) < 40800
-            #error "unsupported GCC version - see https://github.com/nlohmann/json#supported-compilers"
-        #endif
-    #endif
-#endif
-
-// C++ language standard detection
-// if the user manually specified the used c++ version this is skipped
-#if !defined(JSON_HAS_CPP_20) && !defined(JSON_HAS_CPP_17) && !defined(JSON_HAS_CPP_14) && !defined(JSON_HAS_CPP_11)
-    #if (defined(__cplusplus) && __cplusplus >= 202002L) || (defined(_MSVC_LANG) && _MSVC_LANG >= 202002L)
-        #define JSON_HAS_CPP_20
-        #define JSON_HAS_CPP_17
-        #define JSON_HAS_CPP_14
-    #elif (defined(__cplusplus) && __cplusplus >= 201703L) || (defined(_HAS_CXX17) && _HAS_CXX17 == 1) // fix for issue #464
-        #define JSON_HAS_CPP_17
-        #define JSON_HAS_CPP_14
-    #elif (defined(__cplusplus) && __cplusplus >= 201402L) || (defined(_HAS_CXX14) && _HAS_CXX14 == 1)
-        #define JSON_HAS_CPP_14
-    #endif
-    // the cpp 11 flag is always specified because it is the minimal required version
-    #define JSON_HAS_CPP_11
-#endif
-
-#if !defined(JSON_HAS_FILESYSTEM) && !defined(JSON_HAS_EXPERIMENTAL_FILESYSTEM)
-    #ifdef JSON_HAS_CPP_17
-        #if defined(__cpp_lib_filesystem)
-            #define JSON_HAS_FILESYSTEM 1
-        #elif defined(__cpp_lib_experimental_filesystem)
-            #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 1
-        #elif !defined(__has_include)
-            #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 1
-        #elif __has_include(<filesystem>)
-            #define JSON_HAS_FILESYSTEM 1
-        #elif __has_include(<experimental/filesystem>)
-            #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 1
-        #endif
-
-        // std::filesystem does not work on MinGW GCC 8: https://sourceforge.net/p/mingw-w64/bugs/737/
-        #if defined(__MINGW32__) && defined(__GNUC__) && __GNUC__ == 8
-            #undef JSON_HAS_FILESYSTEM
-            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-        #endif
-
-        // no filesystem support before GCC 8: https://en.cppreference.com/w/cpp/compiler_support
-        #if defined(__GNUC__) && !defined(__clang__) && __GNUC__ < 8
-            #undef JSON_HAS_FILESYSTEM
-            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-        #endif
-
-        // no filesystem support before Clang 7: https://en.cppreference.com/w/cpp/compiler_support
-        #if defined(__clang_major__) && __clang_major__ < 7
-            #undef JSON_HAS_FILESYSTEM
-            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-        #endif
-
-        // no filesystem support before MSVC 19.14: https://en.cppreference.com/w/cpp/compiler_support
-        #if defined(_MSC_VER) && _MSC_VER < 1940
-            #undef JSON_HAS_FILESYSTEM
-            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-        #endif
-
-        // no filesystem support before iOS 13
-        #if defined(__IPHONE_OS_VERSION_MIN_REQUIRED) && __IPHONE_OS_VERSION_MIN_REQUIRED < 130000
-            #undef JSON_HAS_FILESYSTEM
-            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-        #endif
-
-        // no filesystem support before macOS Catalina
-        #if defined(__MAC_OS_X_VERSION_MIN_REQUIRED) && __MAC_OS_X_VERSION_MIN_REQUIRED < 101500
-            #undef JSON_HAS_FILESYSTEM
-            #undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-        #endif
-    #endif
-#endif
-
-#ifndef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-    #define JSON_HAS_EXPERIMENTAL_FILESYSTEM 0
-#endif
-
-#ifndef JSON_HAS_FILESYSTEM
-    #define JSON_HAS_FILESYSTEM 0
-#endif
-
-// disable documentation warnings on clang
-#if defined(__clang__)
-    #pragma clang diagnostic push
-    #pragma clang diagnostic ignored "-Wdocumentation"
-    #pragma clang diagnostic ignored "-Wdocumentation-unknown-command"
-#endif
-
-// allow disabling exceptions
-#if (defined(__cpp_exceptions) || defined(__EXCEPTIONS) || defined(_CPPUNWIND)) && !defined(JSON_NOEXCEPTION)
-    #define JSON_THROW(exception) throw exception
-    #define JSON_TRY try
-    #define JSON_CATCH(exception) catch(exception)
-    #define JSON_INTERNAL_CATCH(exception) catch(exception)
-#else
-    #include <cstdlib>
-    #define JSON_THROW(exception) std::abort()
-    #define JSON_TRY if(true)
-    #define JSON_CATCH(exception) if(false)
-    #define JSON_INTERNAL_CATCH(exception) if(false)
-#endif
-
-// override exception macros
-#if defined(JSON_THROW_USER)
-    #undef JSON_THROW
-    #define JSON_THROW JSON_THROW_USER
-#endif
-#if defined(JSON_TRY_USER)
-    #undef JSON_TRY
-    #define JSON_TRY JSON_TRY_USER
-#endif
-#if defined(JSON_CATCH_USER)
-    #undef JSON_CATCH
-    #define JSON_CATCH JSON_CATCH_USER
-    #undef JSON_INTERNAL_CATCH
-    #define JSON_INTERNAL_CATCH JSON_CATCH_USER
-#endif
-#if defined(JSON_INTERNAL_CATCH_USER)
-    #undef JSON_INTERNAL_CATCH
-    #define JSON_INTERNAL_CATCH JSON_INTERNAL_CATCH_USER
-#endif
-
-// allow overriding assert
-#if !defined(JSON_ASSERT)
-    #include <cassert> // assert
-    #define JSON_ASSERT(x) assert(x)
-#endif
-
-// allow to access some private functions (needed by the test suite)
-#if defined(JSON_TESTS_PRIVATE)
-    #define JSON_PRIVATE_UNLESS_TESTED public
-#else
-    #define JSON_PRIVATE_UNLESS_TESTED private
-#endif
-
-/*!
-@brief macro to briefly define a mapping between an enum and JSON
-@def NLOHMANN_JSON_SERIALIZE_ENUM
-@since version 3.4.0
-*/
-#define NLOHMANN_JSON_SERIALIZE_ENUM(ENUM_TYPE, ...)                                            \
-    template<typename BasicJsonType>                                                            \
-    inline void to_json(BasicJsonType& j, const ENUM_TYPE& e)                                   \
-    {                                                                                           \
-        static_assert(std::is_enum<ENUM_TYPE>::value, #ENUM_TYPE " must be an enum!");          \
-        static const std::pair<ENUM_TYPE, BasicJsonType> m[] = __VA_ARGS__;                     \
-        auto it = std::find_if(std::begin(m), std::end(m),                                      \
-                               [e](const std::pair<ENUM_TYPE, BasicJsonType>& ej_pair) -> bool  \
-        {                                                                                       \
-            return ej_pair.first == e;                                                          \
-        });                                                                                     \
-        j = ((it != std::end(m)) ? it : std::begin(m))->second;                                 \
-    }                                                                                           \
-    template<typename BasicJsonType>                                                            \
-    inline void from_json(const BasicJsonType& j, ENUM_TYPE& e)                                 \
-    {                                                                                           \
-        static_assert(std::is_enum<ENUM_TYPE>::value, #ENUM_TYPE " must be an enum!");          \
-        static const std::pair<ENUM_TYPE, BasicJsonType> m[] = __VA_ARGS__;                     \
-        auto it = std::find_if(std::begin(m), std::end(m),                                      \
-                               [&j](const std::pair<ENUM_TYPE, BasicJsonType>& ej_pair) -> bool \
-        {                                                                                       \
-            return ej_pair.second == j;                                                         \
-        });                                                                                     \
-        e = ((it != std::end(m)) ? it : std::begin(m))->first;                                  \
-    }
-
-// Ugly macros to avoid uglier copy-paste when specializing basic_json. They
-// may be removed in the future once the class is split.
-
-#define NLOHMANN_BASIC_JSON_TPL_DECLARATION                                \
-    template<template<typename, typename, typename...> class ObjectType,   \
-             template<typename, typename...> class ArrayType,              \
-             class StringType, class BooleanType, class NumberIntegerType, \
-             class NumberUnsignedType, class NumberFloatType,              \
-             template<typename> class AllocatorType,                       \
-             template<typename, typename = void> class JSONSerializer,     \
-             class BinaryType>
-
-#define NLOHMANN_BASIC_JSON_TPL                                            \
-    basic_json<ObjectType, ArrayType, StringType, BooleanType,             \
-    NumberIntegerType, NumberUnsignedType, NumberFloatType,                \
-    AllocatorType, JSONSerializer, BinaryType>
-
-// Macros to simplify conversion from/to types
-
-#define NLOHMANN_JSON_EXPAND( x ) x
-#define NLOHMANN_JSON_GET_MACRO(_1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, _51, _52, _53, _54, _55, _56, _57, _58, _59, _60, _61, _62, _63, _64, NAME,...) NAME
-#define NLOHMANN_JSON_PASTE(...) NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_GET_MACRO(__VA_ARGS__, \
-        NLOHMANN_JSON_PASTE64, \
-        NLOHMANN_JSON_PASTE63, \
-        NLOHMANN_JSON_PASTE62, \
-        NLOHMANN_JSON_PASTE61, \
-        NLOHMANN_JSON_PASTE60, \
-        NLOHMANN_JSON_PASTE59, \
-        NLOHMANN_JSON_PASTE58, \
-        NLOHMANN_JSON_PASTE57, \
-        NLOHMANN_JSON_PASTE56, \
-        NLOHMANN_JSON_PASTE55, \
-        NLOHMANN_JSON_PASTE54, \
-        NLOHMANN_JSON_PASTE53, \
-        NLOHMANN_JSON_PASTE52, \
-        NLOHMANN_JSON_PASTE51, \
-        NLOHMANN_JSON_PASTE50, \
-        NLOHMANN_JSON_PASTE49, \
-        NLOHMANN_JSON_PASTE48, \
-        NLOHMANN_JSON_PASTE47, \
-        NLOHMANN_JSON_PASTE46, \
-        NLOHMANN_JSON_PASTE45, \
-        NLOHMANN_JSON_PASTE44, \
-        NLOHMANN_JSON_PASTE43, \
-        NLOHMANN_JSON_PASTE42, \
-        NLOHMANN_JSON_PASTE41, \
-        NLOHMANN_JSON_PASTE40, \
-        NLOHMANN_JSON_PASTE39, \
-        NLOHMANN_JSON_PASTE38, \
-        NLOHMANN_JSON_PASTE37, \
-        NLOHMANN_JSON_PASTE36, \
-        NLOHMANN_JSON_PASTE35, \
-        NLOHMANN_JSON_PASTE34, \
-        NLOHMANN_JSON_PASTE33, \
-        NLOHMANN_JSON_PASTE32, \
-        NLOHMANN_JSON_PASTE31, \
-        NLOHMANN_JSON_PASTE30, \
-        NLOHMANN_JSON_PASTE29, \
-        NLOHMANN_JSON_PASTE28, \
-        NLOHMANN_JSON_PASTE27, \
-        NLOHMANN_JSON_PASTE26, \
-        NLOHMANN_JSON_PASTE25, \
-        NLOHMANN_JSON_PASTE24, \
-        NLOHMANN_JSON_PASTE23, \
-        NLOHMANN_JSON_PASTE22, \
-        NLOHMANN_JSON_PASTE21, \
-        NLOHMANN_JSON_PASTE20, \
-        NLOHMANN_JSON_PASTE19, \
-        NLOHMANN_JSON_PASTE18, \
-        NLOHMANN_JSON_PASTE17, \
-        NLOHMANN_JSON_PASTE16, \
-        NLOHMANN_JSON_PASTE15, \
-        NLOHMANN_JSON_PASTE14, \
-        NLOHMANN_JSON_PASTE13, \
-        NLOHMANN_JSON_PASTE12, \
-        NLOHMANN_JSON_PASTE11, \
-        NLOHMANN_JSON_PASTE10, \
-        NLOHMANN_JSON_PASTE9, \
-        NLOHMANN_JSON_PASTE8, \
-        NLOHMANN_JSON_PASTE7, \
-        NLOHMANN_JSON_PASTE6, \
-        NLOHMANN_JSON_PASTE5, \
-        NLOHMANN_JSON_PASTE4, \
-        NLOHMANN_JSON_PASTE3, \
-        NLOHMANN_JSON_PASTE2, \
-        NLOHMANN_JSON_PASTE1)(__VA_ARGS__))
-#define NLOHMANN_JSON_PASTE2(func, v1) func(v1)
-#define NLOHMANN_JSON_PASTE3(func, v1, v2) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE2(func, v2)
-#define NLOHMANN_JSON_PASTE4(func, v1, v2, v3) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE3(func, v2, v3)
-#define NLOHMANN_JSON_PASTE5(func, v1, v2, v3, v4) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE4(func, v2, v3, v4)
-#define NLOHMANN_JSON_PASTE6(func, v1, v2, v3, v4, v5) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE5(func, v2, v3, v4, v5)
-#define NLOHMANN_JSON_PASTE7(func, v1, v2, v3, v4, v5, v6) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE6(func, v2, v3, v4, v5, v6)
-#define NLOHMANN_JSON_PASTE8(func, v1, v2, v3, v4, v5, v6, v7) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE7(func, v2, v3, v4, v5, v6, v7)
-#define NLOHMANN_JSON_PASTE9(func, v1, v2, v3, v4, v5, v6, v7, v8) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE8(func, v2, v3, v4, v5, v6, v7, v8)
-#define NLOHMANN_JSON_PASTE10(func, v1, v2, v3, v4, v5, v6, v7, v8, v9) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE9(func, v2, v3, v4, v5, v6, v7, v8, v9)
-#define NLOHMANN_JSON_PASTE11(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE10(func, v2, v3, v4, v5, v6, v7, v8, v9, v10)
-#define NLOHMANN_JSON_PASTE12(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE11(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11)
-#define NLOHMANN_JSON_PASTE13(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE12(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12)
-#define NLOHMANN_JSON_PASTE14(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE13(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13)
-#define NLOHMANN_JSON_PASTE15(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE14(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14)
-#define NLOHMANN_JSON_PASTE16(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE15(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15)
-#define NLOHMANN_JSON_PASTE17(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE16(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16)
-#define NLOHMANN_JSON_PASTE18(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE17(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17)
-#define NLOHMANN_JSON_PASTE19(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE18(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18)
-#define NLOHMANN_JSON_PASTE20(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE19(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19)
-#define NLOHMANN_JSON_PASTE21(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE20(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20)
-#define NLOHMANN_JSON_PASTE22(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE21(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21)
-#define NLOHMANN_JSON_PASTE23(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE22(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22)
-#define NLOHMANN_JSON_PASTE24(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE23(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23)
-#define NLOHMANN_JSON_PASTE25(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE24(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24)
-#define NLOHMANN_JSON_PASTE26(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE25(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25)
-#define NLOHMANN_JSON_PASTE27(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE26(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26)
-#define NLOHMANN_JSON_PASTE28(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE27(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27)
-#define NLOHMANN_JSON_PASTE29(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE28(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28)
-#define NLOHMANN_JSON_PASTE30(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE29(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29)
-#define NLOHMANN_JSON_PASTE31(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE30(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30)
-#define NLOHMANN_JSON_PASTE32(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE31(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31)
-#define NLOHMANN_JSON_PASTE33(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE32(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32)
-#define NLOHMANN_JSON_PASTE34(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE33(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33)
-#define NLOHMANN_JSON_PASTE35(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE34(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34)
-#define NLOHMANN_JSON_PASTE36(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE35(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35)
-#define NLOHMANN_JSON_PASTE37(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE36(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36)
-#define NLOHMANN_JSON_PASTE38(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE37(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37)
-#define NLOHMANN_JSON_PASTE39(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE38(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38)
-#define NLOHMANN_JSON_PASTE40(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE39(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39)
-#define NLOHMANN_JSON_PASTE41(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE40(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40)
-#define NLOHMANN_JSON_PASTE42(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE41(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41)
-#define NLOHMANN_JSON_PASTE43(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE42(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42)
-#define NLOHMANN_JSON_PASTE44(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE43(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43)
-#define NLOHMANN_JSON_PASTE45(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE44(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44)
-#define NLOHMANN_JSON_PASTE46(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE45(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45)
-#define NLOHMANN_JSON_PASTE47(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE46(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46)
-#define NLOHMANN_JSON_PASTE48(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE47(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47)
-#define NLOHMANN_JSON_PASTE49(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE48(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48)
-#define NLOHMANN_JSON_PASTE50(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE49(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49)
-#define NLOHMANN_JSON_PASTE51(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE50(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50)
-#define NLOHMANN_JSON_PASTE52(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE51(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51)
-#define NLOHMANN_JSON_PASTE53(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE52(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52)
-#define NLOHMANN_JSON_PASTE54(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE53(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53)
-#define NLOHMANN_JSON_PASTE55(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE54(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54)
-#define NLOHMANN_JSON_PASTE56(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE55(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55)
-#define NLOHMANN_JSON_PASTE57(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE56(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56)
-#define NLOHMANN_JSON_PASTE58(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE57(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57)
-#define NLOHMANN_JSON_PASTE59(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE58(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58)
-#define NLOHMANN_JSON_PASTE60(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE59(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59)
-#define NLOHMANN_JSON_PASTE61(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE60(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60)
-#define NLOHMANN_JSON_PASTE62(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE61(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61)
-#define NLOHMANN_JSON_PASTE63(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE62(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62)
-#define NLOHMANN_JSON_PASTE64(func, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62, v63) NLOHMANN_JSON_PASTE2(func, v1) NLOHMANN_JSON_PASTE63(func, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36, v37, v38, v39, v40, v41, v42, v43, v44, v45, v46, v47, v48, v49, v50, v51, v52, v53, v54, v55, v56, v57, v58, v59, v60, v61, v62, v63)
-
-#define NLOHMANN_JSON_TO(v1) nlohmann_json_j[#v1] = nlohmann_json_t.v1;
-#define NLOHMANN_JSON_FROM(v1) nlohmann_json_j.at(#v1).get_to(nlohmann_json_t.v1);
-
-/*!
-@brief macro
-@def NLOHMANN_DEFINE_TYPE_INTRUSIVE
-@since version 3.9.0
-*/
-#define NLOHMANN_DEFINE_TYPE_INTRUSIVE(Type, ...)  \
-    friend void to_json(nlohmann::json& nlohmann_json_j, const Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_TO, __VA_ARGS__)) } \
-    friend void from_json(const nlohmann::json& nlohmann_json_j, Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_FROM, __VA_ARGS__)) }
-
-/*!
-@brief macro
-@def NLOHMANN_DEFINE_TYPE_NON_INTRUSIVE
-@since version 3.9.0
-*/
-#define NLOHMANN_DEFINE_TYPE_NON_INTRUSIVE(Type, ...)  \
-    inline void to_json(nlohmann::json& nlohmann_json_j, const Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_TO, __VA_ARGS__)) } \
-    inline void from_json(const nlohmann::json& nlohmann_json_j, Type& nlohmann_json_t) { NLOHMANN_JSON_EXPAND(NLOHMANN_JSON_PASTE(NLOHMANN_JSON_FROM, __VA_ARGS__)) }
-
-
-// inspired from https://stackoverflow.com/a/26745591
-// allows to call any std function as if (e.g. with begin):
-// using std::begin; begin(x);
-//
-// it allows using the detected idiom to retrieve the return type
-// of such an expression
-#define NLOHMANN_CAN_CALL_STD_FUNC_IMPL(std_name)                                 \
-    namespace detail {                                                            \
-    using std::std_name;                                                          \
-    \
-    template<typename... T>                                                       \
-    using result_of_##std_name = decltype(std_name(std::declval<T>()...));        \
-    }                                                                             \
-    \
-    namespace detail2 {                                                           \
-    struct std_name##_tag                                                         \
-    {                                                                             \
-    };                                                                            \
-    \
-    template<typename... T>                                                       \
-    std_name##_tag std_name(T&&...);                                              \
-    \
-    template<typename... T>                                                       \
-    using result_of_##std_name = decltype(std_name(std::declval<T>()...));        \
-    \
-    template<typename... T>                                                       \
-    struct would_call_std_##std_name                                              \
-    {                                                                             \
-        static constexpr auto const value = ::nlohmann::detail::                  \
-                                            is_detected_exact<std_name##_tag, result_of_##std_name, T...>::value; \
-    };                                                                            \
-    } /* namespace detail2 */ \
-    \
-    template<typename... T>                                                       \
-    struct would_call_std_##std_name : detail2::would_call_std_##std_name<T...>   \
-    {                                                                             \
-    }
-
-#ifndef JSON_USE_IMPLICIT_CONVERSIONS
-    #define JSON_USE_IMPLICIT_CONVERSIONS 1
-#endif
-
-#if JSON_USE_IMPLICIT_CONVERSIONS
-    #define JSON_EXPLICIT
-#else
-    #define JSON_EXPLICIT explicit
-#endif
-
-#ifndef JSON_DIAGNOSTICS
-    #define JSON_DIAGNOSTICS 0
-#endif
-
-
-namespace nlohmann
-{
-namespace detail
-{
-
-/*!
-@brief replace all occurrences of a substring by another string
-
-@param[in,out] s  the string to manipulate; changed so that all
-               occurrences of @a f are replaced with @a t
-@param[in]     f  the substring to replace with @a t
-@param[in]     t  the string to replace @a f
-
-@pre The search string @a f must not be empty. **This precondition is
-enforced with an assertion.**
-
-@since version 2.0.0
-*/
-inline void replace_substring(std::string& s, const std::string& f,
-                              const std::string& t)
-{
-    JSON_ASSERT(!f.empty());
-    for (auto pos = s.find(f);                // find first occurrence of f
-            pos != std::string::npos;         // make sure f was found
-            s.replace(pos, f.size(), t),      // replace with t, and
-            pos = s.find(f, pos + t.size()))  // find next occurrence of f
-    {}
-}
-
-/*!
- * @brief string escaping as described in RFC 6901 (Sect. 4)
- * @param[in] s string to escape
- * @return    escaped string
- *
- * Note the order of escaping "~" to "~0" and "/" to "~1" is important.
- */
-inline std::string escape(std::string s)
-{
-    replace_substring(s, "~", "~0");
-    replace_substring(s, "/", "~1");
-    return s;
-}
-
-/*!
- * @brief string unescaping as described in RFC 6901 (Sect. 4)
- * @param[in] s string to unescape
- * @return    unescaped string
- *
- * Note the order of escaping "~1" to "/" and "~0" to "~" is important.
- */
-static void unescape(std::string& s)
-{
-    replace_substring(s, "~1", "/");
-    replace_substring(s, "~0", "~");
-}
-
-} // namespace detail
-} // namespace nlohmann
-
-// #include <nlohmann/detail/input/position_t.hpp>
-
-
-#include <cstddef> // size_t
-
-namespace nlohmann
-{
-namespace detail
-{
-/// struct to capture the start position of the current token
-struct position_t
-{
-    /// the total number of characters read
-    std::size_t chars_read_total = 0;
-    /// the number of characters read in the current line
-    std::size_t chars_read_current_line = 0;
-    /// the number of lines read
-    std::size_t lines_read = 0;
-
-    /// conversion to size_t to preserve SAX interface
-    constexpr operator size_t() const
-    {
-        return chars_read_total;
-    }
-};
-
-} // namespace detail
-} // namespace nlohmann
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-////////////////
-// exceptions //
-////////////////
-
-/// @brief general exception of the @ref basic_json class
-/// @sa https://json.nlohmann.me/api/basic_json/exception/
-class exception : public std::exception
-{
-  public:
-    /// returns the explanatory string
-    const char* what() const noexcept override
-    {
-        return m.what();
-    }
-
-    /// the id of the exception
-    const int id; // NOLINT(cppcoreguidelines-non-private-member-variables-in-classes)
-
-  protected:
-    JSON_HEDLEY_NON_NULL(3)
-    exception(int id_, const char* what_arg) : id(id_), m(what_arg) {} // NOLINT(bugprone-throw-keyword-missing)
-
-    static std::string name(const std::string& ename, int id_)
-    {
-        return "[json.exception." + ename + "." + std::to_string(id_) + "] ";
-    }
-
-    template<typename BasicJsonType>
-    static std::string diagnostics(const BasicJsonType& leaf_element)
-    {
-#if JSON_DIAGNOSTICS
-        std::vector<std::string> tokens;
-        for (const auto* current = &leaf_element; current->m_parent != nullptr; current = current->m_parent)
-        {
-            switch (current->m_parent->type())
-            {
-                case value_t::array:
-                {
-                    for (std::size_t i = 0; i < current->m_parent->m_value.array->size(); ++i)
-                    {
-                        if (&current->m_parent->m_value.array->operator[](i) == current)
-                        {
-                            tokens.emplace_back(std::to_string(i));
-                            break;
-                        }
-                    }
-                    break;
-                }
-
-                case value_t::object:
-                {
-                    for (const auto& element : *current->m_parent->m_value.object)
-                    {
-                        if (&element.second == current)
-                        {
-                            tokens.emplace_back(element.first.c_str());
-                            break;
-                        }
-                    }
-                    break;
-                }
-
-                case value_t::null: // LCOV_EXCL_LINE
-                case value_t::string: // LCOV_EXCL_LINE
-                case value_t::boolean: // LCOV_EXCL_LINE
-                case value_t::number_integer: // LCOV_EXCL_LINE
-                case value_t::number_unsigned: // LCOV_EXCL_LINE
-                case value_t::number_float: // LCOV_EXCL_LINE
-                case value_t::binary: // LCOV_EXCL_LINE
-                case value_t::discarded: // LCOV_EXCL_LINE
-                default:   // LCOV_EXCL_LINE
-                    break; // LCOV_EXCL_LINE
-            }
-        }
-
-        if (tokens.empty())
-        {
-            return "";
-        }
-
-        return "(" + std::accumulate(tokens.rbegin(), tokens.rend(), std::string{},
-                                     [](const std::string & a, const std::string & b)
-        {
-            return a + "/" + detail::escape(b);
-        }) + ") ";
-#else
-        static_cast<void>(leaf_element);
-        return "";
-#endif
-    }
-
-  private:
-    /// an exception object as storage for error messages
-    std::runtime_error m;
-};
-
-/// @brief exception indicating a parse error
-/// @sa https://json.nlohmann.me/api/basic_json/parse_error/
-class parse_error : public exception
-{
-  public:
-    /*!
-    @brief create a parse error exception
-    @param[in] id_       the id of the exception
-    @param[in] pos       the position where the error occurred (or with
-                         chars_read_total=0 if the position cannot be
-                         determined)
-    @param[in] what_arg  the explanatory string
-    @return parse_error object
-    */
-    template<typename BasicJsonType>
-    static parse_error create(int id_, const position_t& pos, const std::string& what_arg, const BasicJsonType& context)
-    {
-        std::string w = exception::name("parse_error", id_) + "parse error" +
-                        position_string(pos) + ": " + exception::diagnostics(context) + what_arg;
-        return {id_, pos.chars_read_total, w.c_str()};
-    }
-
-    template<typename BasicJsonType>
-    static parse_error create(int id_, std::size_t byte_, const std::string& what_arg, const BasicJsonType& context)
-    {
-        std::string w = exception::name("parse_error", id_) + "parse error" +
-                        (byte_ != 0 ? (" at byte " + std::to_string(byte_)) : "") +
-                        ": " + exception::diagnostics(context) + what_arg;
-        return {id_, byte_, w.c_str()};
-    }
-
-    /*!
-    @brief byte index of the parse error
-
-    The byte index of the last read character in the input file.
-
-    @note For an input with n bytes, 1 is the index of the first character and
-          n+1 is the index of the terminating null byte or the end of file.
-          This also holds true when reading a byte vector (CBOR or MessagePack).
-    */
-    const std::size_t byte;
-
-  private:
-    parse_error(int id_, std::size_t byte_, const char* what_arg)
-        : exception(id_, what_arg), byte(byte_) {}
-
-    static std::string position_string(const position_t& pos)
-    {
-        return " at line " + std::to_string(pos.lines_read + 1) +
-               ", column " + std::to_string(pos.chars_read_current_line);
-    }
-};
-
-/// @brief exception indicating errors with iterators
-/// @sa https://json.nlohmann.me/api/basic_json/invalid_iterator/
-class invalid_iterator : public exception
-{
-  public:
-    template<typename BasicJsonType>
-    static invalid_iterator create(int id_, const std::string& what_arg, const BasicJsonType& context)
-    {
-        std::string w = exception::name("invalid_iterator", id_) + exception::diagnostics(context) + what_arg;
-        return {id_, w.c_str()};
-    }
-
-  private:
-    JSON_HEDLEY_NON_NULL(3)
-    invalid_iterator(int id_, const char* what_arg)
-        : exception(id_, what_arg) {}
-};
-
-/// @brief exception indicating executing a member function with a wrong type
-/// @sa https://json.nlohmann.me/api/basic_json/type_error/
-class type_error : public exception
-{
-  public:
-    template<typename BasicJsonType>
-    static type_error create(int id_, const std::string& what_arg, const BasicJsonType& context)
-    {
-        std::string w = exception::name("type_error", id_) + exception::diagnostics(context) + what_arg;
-        return {id_, w.c_str()};
-    }
-
-  private:
-    JSON_HEDLEY_NON_NULL(3)
-    type_error(int id_, const char* what_arg) : exception(id_, what_arg) {}
-};
-
-/// @brief exception indicating access out of the defined range
-/// @sa https://json.nlohmann.me/api/basic_json/out_of_range/
-class out_of_range : public exception
-{
-  public:
-    template<typename BasicJsonType>
-    static out_of_range create(int id_, const std::string& what_arg, const BasicJsonType& context)
-    {
-        std::string w = exception::name("out_of_range", id_) + exception::diagnostics(context) + what_arg;
-        return {id_, w.c_str()};
-    }
-
-  private:
-    JSON_HEDLEY_NON_NULL(3)
-    out_of_range(int id_, const char* what_arg) : exception(id_, what_arg) {}
-};
-
-/// @brief exception indicating other library errors
-/// @sa https://json.nlohmann.me/api/basic_json/other_error/
-class other_error : public exception
-{
-  public:
-    template<typename BasicJsonType>
-    static other_error create(int id_, const std::string& what_arg, const BasicJsonType& context)
-    {
-        std::string w = exception::name("other_error", id_) + exception::diagnostics(context) + what_arg;
-        return {id_, w.c_str()};
-    }
-
-  private:
-    JSON_HEDLEY_NON_NULL(3)
-    other_error(int id_, const char* what_arg) : exception(id_, what_arg) {}
-};
-
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/meta/cpp_future.hpp>
-
-
-#include <cstddef> // size_t
-#include <type_traits> // conditional, enable_if, false_type, integral_constant, is_constructible, is_integral, is_same, remove_cv, remove_reference, true_type
-#include <utility> // index_sequence, make_index_sequence, index_sequence_for
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-
-template<typename T>
-using uncvref_t = typename std::remove_cv<typename std::remove_reference<T>::type>::type;
-
-#ifdef JSON_HAS_CPP_14
-
-// the following utilities are natively available in C++14
-using std::enable_if_t;
-using std::index_sequence;
-using std::make_index_sequence;
-using std::index_sequence_for;
-
-#else
-
-// alias templates to reduce boilerplate
-template<bool B, typename T = void>
-using enable_if_t = typename std::enable_if<B, T>::type;
-
-// The following code is taken from https://github.com/abseil/abseil-cpp/blob/10cb35e459f5ecca5b2ff107635da0bfa41011b4/absl/utility/utility.h
-// which is part of Google Abseil (https://github.com/abseil/abseil-cpp), licensed under the Apache License 2.0.
-
-//// START OF CODE FROM GOOGLE ABSEIL
-
-// integer_sequence
-//
-// Class template representing a compile-time integer sequence. An instantiation
-// of `integer_sequence<T, Ints...>` has a sequence of integers encoded in its
-// type through its template arguments (which is a common need when
-// working with C++11 variadic templates). `absl::integer_sequence` is designed
-// to be a drop-in replacement for C++14's `std::integer_sequence`.
-//
-// Example:
-//
-//   template< class T, T... Ints >
-//   void user_function(integer_sequence<T, Ints...>);
-//
-//   int main()
-//   {
-//     // user_function's `T` will be deduced to `int` and `Ints...`
-//     // will be deduced to `0, 1, 2, 3, 4`.
-//     user_function(make_integer_sequence<int, 5>());
-//   }
-template <typename T, T... Ints>
-struct integer_sequence
-{
-    using value_type = T;
-    static constexpr std::size_t size() noexcept
-    {
-        return sizeof...(Ints);
-    }
-};
-
-// index_sequence
-//
-// A helper template for an `integer_sequence` of `size_t`,
-// `absl::index_sequence` is designed to be a drop-in replacement for C++14's
-// `std::index_sequence`.
-template <size_t... Ints>
-using index_sequence = integer_sequence<size_t, Ints...>;
-
-namespace utility_internal
-{
-
-template <typename Seq, size_t SeqSize, size_t Rem>
-struct Extend;
-
-// Note that SeqSize == sizeof...(Ints). It's passed explicitly for efficiency.
-template <typename T, T... Ints, size_t SeqSize>
-struct Extend<integer_sequence<T, Ints...>, SeqSize, 0>
-{
-    using type = integer_sequence < T, Ints..., (Ints + SeqSize)... >;
-};
-
-template <typename T, T... Ints, size_t SeqSize>
-struct Extend<integer_sequence<T, Ints...>, SeqSize, 1>
-{
-    using type = integer_sequence < T, Ints..., (Ints + SeqSize)..., 2 * SeqSize >;
-};
-
-// Recursion helper for 'make_integer_sequence<T, N>'.
-// 'Gen<T, N>::type' is an alias for 'integer_sequence<T, 0, 1, ... N-1>'.
-template <typename T, size_t N>
-struct Gen
-{
-    using type =
-        typename Extend < typename Gen < T, N / 2 >::type, N / 2, N % 2 >::type;
-};
-
-template <typename T>
-struct Gen<T, 0>
-{
-    using type = integer_sequence<T>;
-};
-
-}  // namespace utility_internal
-
-// Compile-time sequences of integers
-
-// make_integer_sequence
-//
-// This template alias is equivalent to
-// `integer_sequence<int, 0, 1, ..., N-1>`, and is designed to be a drop-in
-// replacement for C++14's `std::make_integer_sequence`.
-template <typename T, T N>
-using make_integer_sequence = typename utility_internal::Gen<T, N>::type;
-
-// make_index_sequence
-//
-// This template alias is equivalent to `index_sequence<0, 1, ..., N-1>`,
-// and is designed to be a drop-in replacement for C++14's
-// `std::make_index_sequence`.
-template <size_t N>
-using make_index_sequence = make_integer_sequence<size_t, N>;
-
-// index_sequence_for
-//
-// Converts a typename pack into an index sequence of the same length, and
-// is designed to be a drop-in replacement for C++14's
-// `std::index_sequence_for()`
-template <typename... Ts>
-using index_sequence_for = make_index_sequence<sizeof...(Ts)>;
-
-//// END OF CODE FROM GOOGLE ABSEIL
-
-#endif
-
-// dispatch utility (taken from ranges-v3)
-template<unsigned N> struct priority_tag : priority_tag < N - 1 > {};
-template<> struct priority_tag<0> {};
-
-// taken from ranges-v3
-template<typename T>
-struct static_const
-{
-    static constexpr T value{};
-};
-
-template<typename T>
-constexpr T static_const<T>::value; // NOLINT(readability-redundant-declaration)
-
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/meta/identity_tag.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-// dispatching helper struct
-template <class T> struct identity_tag {};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-
-#include <limits> // numeric_limits
-#include <type_traits> // false_type, is_constructible, is_integral, is_same, true_type
-#include <utility> // declval
-#include <tuple> // tuple
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-// #include <nlohmann/detail/iterators/iterator_traits.hpp>
-
-
-#include <iterator> // random_access_iterator_tag
-
-// #include <nlohmann/detail/meta/void_t.hpp>
-
-// #include <nlohmann/detail/meta/cpp_future.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-template<typename It, typename = void>
-struct iterator_types {};
-
-template<typename It>
-struct iterator_types <
-    It,
-    void_t<typename It::difference_type, typename It::value_type, typename It::pointer,
-    typename It::reference, typename It::iterator_category >>
-{
-    using difference_type = typename It::difference_type;
-    using value_type = typename It::value_type;
-    using pointer = typename It::pointer;
-    using reference = typename It::reference;
-    using iterator_category = typename It::iterator_category;
-};
-
-// This is required as some compilers implement std::iterator_traits in a way that
-// doesn't work with SFINAE. See https://github.com/nlohmann/json/issues/1341.
-template<typename T, typename = void>
-struct iterator_traits
-{
-};
-
-template<typename T>
-struct iterator_traits < T, enable_if_t < !std::is_pointer<T>::value >>
-            : iterator_types<T>
-{
-};
-
-template<typename T>
-struct iterator_traits<T*, enable_if_t<std::is_object<T>::value>>
-{
-    using iterator_category = std::random_access_iterator_tag;
-    using value_type = T;
-    using difference_type = ptrdiff_t;
-    using pointer = T*;
-    using reference = T&;
-};
-} // namespace detail
-} // namespace nlohmann
-
-// #include <nlohmann/detail/meta/call_std/begin.hpp>
-
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-NLOHMANN_CAN_CALL_STD_FUNC_IMPL(begin);
-} // namespace nlohmann
-
-// #include <nlohmann/detail/meta/call_std/end.hpp>
-
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-NLOHMANN_CAN_CALL_STD_FUNC_IMPL(end);
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/meta/cpp_future.hpp>
-
-// #include <nlohmann/detail/meta/detected.hpp>
-
-// #include <nlohmann/json_fwd.hpp>
-#ifndef INCLUDE_NLOHMANN_JSON_FWD_HPP_
-#define INCLUDE_NLOHMANN_JSON_FWD_HPP_
-
-#include <cstdint> // int64_t, uint64_t
-#include <map> // map
-#include <memory> // allocator
-#include <string> // string
-#include <vector> // vector
-
-/*!
-@brief namespace for Niels Lohmann
-@see https://github.com/nlohmann
-@since version 1.0.0
-*/
-namespace nlohmann
-{
-/*!
-@brief default JSONSerializer template argument
-
-This serializer ignores the template arguments and uses ADL
-([argument-dependent lookup](https://en.cppreference.com/w/cpp/language/adl))
-for serialization.
-*/
-template<typename T = void, typename SFINAE = void>
-struct adl_serializer;
-
-/// a class to store JSON values
-/// @sa https://json.nlohmann.me/api/basic_json/
-template<template<typename U, typename V, typename... Args> class ObjectType =
-         std::map,
-         template<typename U, typename... Args> class ArrayType = std::vector,
-         class StringType = std::string, class BooleanType = bool,
-         class NumberIntegerType = std::int64_t,
-         class NumberUnsignedType = std::uint64_t,
-         class NumberFloatType = double,
-         template<typename U> class AllocatorType = std::allocator,
-         template<typename T, typename SFINAE = void> class JSONSerializer =
-         adl_serializer,
-         class BinaryType = std::vector<std::uint8_t>>
-class basic_json;
-
-/// @brief JSON Pointer defines a string syntax for identifying a specific value within a JSON document
-/// @sa https://json.nlohmann.me/api/json_pointer/
-template<typename BasicJsonType>
-class json_pointer;
-
-/*!
-@brief default specialization
-@sa https://json.nlohmann.me/api/json/
-*/
-using json = basic_json<>;
-
-/// @brief a minimal map-like container that preserves insertion order
-/// @sa https://json.nlohmann.me/api/ordered_map/
-template<class Key, class T, class IgnoredLess, class Allocator>
-struct ordered_map;
-
-/// @brief specialization that maintains the insertion order of object keys
-/// @sa https://json.nlohmann.me/api/ordered_json/
-using ordered_json = basic_json<nlohmann::ordered_map>;
-
-}  // namespace nlohmann
-
-#endif  // INCLUDE_NLOHMANN_JSON_FWD_HPP_
-
-
-namespace nlohmann
-{
-/*!
-@brief detail namespace with internal helper functions
-
-This namespace collects functions that should not be exposed,
-implementations of some @ref basic_json methods, and meta-programming helpers.
-
-@since version 2.1.0
-*/
-namespace detail
-{
-/////////////
-// helpers //
-/////////////
-
-// Note to maintainers:
-//
-// Every trait in this file expects a non CV-qualified type.
-// The only exceptions are in the 'aliases for detected' section
-// (i.e. those of the form: decltype(T::member_function(std::declval<T>())))
-//
-// In this case, T has to be properly CV-qualified to constraint the function arguments
-// (e.g. to_json(BasicJsonType&, const T&))
-
-template<typename> struct is_basic_json : std::false_type {};
-
-NLOHMANN_BASIC_JSON_TPL_DECLARATION
-struct is_basic_json<NLOHMANN_BASIC_JSON_TPL> : std::true_type {};
-
-//////////////////////
-// json_ref helpers //
-//////////////////////
-
-template<typename>
-class json_ref;
-
-template<typename>
-struct is_json_ref : std::false_type {};
-
-template<typename T>
-struct is_json_ref<json_ref<T>> : std::true_type {};
-
-//////////////////////////
-// aliases for detected //
-//////////////////////////
-
-template<typename T>
-using mapped_type_t = typename T::mapped_type;
-
-template<typename T>
-using key_type_t = typename T::key_type;
-
-template<typename T>
-using value_type_t = typename T::value_type;
-
-template<typename T>
-using difference_type_t = typename T::difference_type;
-
-template<typename T>
-using pointer_t = typename T::pointer;
-
-template<typename T>
-using reference_t = typename T::reference;
-
-template<typename T>
-using iterator_category_t = typename T::iterator_category;
-
-template<typename T, typename... Args>
-using to_json_function = decltype(T::to_json(std::declval<Args>()...));
-
-template<typename T, typename... Args>
-using from_json_function = decltype(T::from_json(std::declval<Args>()...));
-
-template<typename T, typename U>
-using get_template_function = decltype(std::declval<T>().template get<U>());
-
-// trait checking if JSONSerializer<T>::from_json(json const&, udt&) exists
-template<typename BasicJsonType, typename T, typename = void>
-struct has_from_json : std::false_type {};
-
-// trait checking if j.get<T> is valid
-// use this trait instead of std::is_constructible or std::is_convertible,
-// both rely on, or make use of implicit conversions, and thus fail when T
-// has several constructors/operator= (see https://github.com/nlohmann/json/issues/958)
-template <typename BasicJsonType, typename T>
-struct is_getable
-{
-    static constexpr bool value = is_detected<get_template_function, const BasicJsonType&, T>::value;
-};
-
-template<typename BasicJsonType, typename T>
-struct has_from_json < BasicJsonType, T, enable_if_t < !is_basic_json<T>::value >>
-{
-    using serializer = typename BasicJsonType::template json_serializer<T, void>;
-
-    static constexpr bool value =
-        is_detected_exact<void, from_json_function, serializer,
-        const BasicJsonType&, T&>::value;
-};
-
-// This trait checks if JSONSerializer<T>::from_json(json const&) exists
-// this overload is used for non-default-constructible user-defined-types
-template<typename BasicJsonType, typename T, typename = void>
-struct has_non_default_from_json : std::false_type {};
-
-template<typename BasicJsonType, typename T>
-struct has_non_default_from_json < BasicJsonType, T, enable_if_t < !is_basic_json<T>::value >>
-{
-    using serializer = typename BasicJsonType::template json_serializer<T, void>;
-
-    static constexpr bool value =
-        is_detected_exact<T, from_json_function, serializer,
-        const BasicJsonType&>::value;
-};
-
-// This trait checks if BasicJsonType::json_serializer<T>::to_json exists
-// Do not evaluate the trait when T is a basic_json type, to avoid template instantiation infinite recursion.
-template<typename BasicJsonType, typename T, typename = void>
-struct has_to_json : std::false_type {};
-
-template<typename BasicJsonType, typename T>
-struct has_to_json < BasicJsonType, T, enable_if_t < !is_basic_json<T>::value >>
-{
-    using serializer = typename BasicJsonType::template json_serializer<T, void>;
-
-    static constexpr bool value =
-        is_detected_exact<void, to_json_function, serializer, BasicJsonType&,
-        T>::value;
-};
-
-
-///////////////////
-// is_ functions //
-///////////////////
-
-// https://en.cppreference.com/w/cpp/types/conjunction
-template<class...> struct conjunction : std::true_type { };
-template<class B1> struct conjunction<B1> : B1 { };
-template<class B1, class... Bn>
-struct conjunction<B1, Bn...>
-: std::conditional<bool(B1::value), conjunction<Bn...>, B1>::type {};
-
-// https://en.cppreference.com/w/cpp/types/negation
-template<class B> struct negation : std::integral_constant < bool, !B::value > { };
-
-// Reimplementation of is_constructible and is_default_constructible, due to them being broken for
-// std::pair and std::tuple until LWG 2367 fix (see https://cplusplus.github.io/LWG/lwg-defects.html#2367).
-// This causes compile errors in e.g. clang 3.5 or gcc 4.9.
-template <typename T>
-struct is_default_constructible : std::is_default_constructible<T> {};
-
-template <typename T1, typename T2>
-struct is_default_constructible<std::pair<T1, T2>>
-            : conjunction<is_default_constructible<T1>, is_default_constructible<T2>> {};
-
-template <typename T1, typename T2>
-struct is_default_constructible<const std::pair<T1, T2>>
-            : conjunction<is_default_constructible<T1>, is_default_constructible<T2>> {};
-
-template <typename... Ts>
-struct is_default_constructible<std::tuple<Ts...>>
-            : conjunction<is_default_constructible<Ts>...> {};
-
-template <typename... Ts>
-struct is_default_constructible<const std::tuple<Ts...>>
-            : conjunction<is_default_constructible<Ts>...> {};
-
-
-template <typename T, typename... Args>
-struct is_constructible : std::is_constructible<T, Args...> {};
-
-template <typename T1, typename T2>
-struct is_constructible<std::pair<T1, T2>> : is_default_constructible<std::pair<T1, T2>> {};
-
-template <typename T1, typename T2>
-struct is_constructible<const std::pair<T1, T2>> : is_default_constructible<const std::pair<T1, T2>> {};
-
-template <typename... Ts>
-struct is_constructible<std::tuple<Ts...>> : is_default_constructible<std::tuple<Ts...>> {};
-
-template <typename... Ts>
-struct is_constructible<const std::tuple<Ts...>> : is_default_constructible<const std::tuple<Ts...>> {};
-
-
-template<typename T, typename = void>
-struct is_iterator_traits : std::false_type {};
-
-template<typename T>
-struct is_iterator_traits<iterator_traits<T>>
-{
-  private:
-    using traits = iterator_traits<T>;
-
-  public:
-    static constexpr auto value =
-        is_detected<value_type_t, traits>::value &&
-        is_detected<difference_type_t, traits>::value &&
-        is_detected<pointer_t, traits>::value &&
-        is_detected<iterator_category_t, traits>::value &&
-        is_detected<reference_t, traits>::value;
-};
-
-template<typename T>
-struct is_range
-{
-  private:
-    using t_ref = typename std::add_lvalue_reference<T>::type;
-
-    using iterator = detected_t<result_of_begin, t_ref>;
-    using sentinel = detected_t<result_of_end, t_ref>;
-
-    // to be 100% correct, it should use https://en.cppreference.com/w/cpp/iterator/input_or_output_iterator
-    // and https://en.cppreference.com/w/cpp/iterator/sentinel_for
-    // but reimplementing these would be too much work, as a lot of other concepts are used underneath
-    static constexpr auto is_iterator_begin =
-        is_iterator_traits<iterator_traits<iterator>>::value;
-
-  public:
-    static constexpr bool value = !std::is_same<iterator, nonesuch>::value && !std::is_same<sentinel, nonesuch>::value && is_iterator_begin;
-};
-
-template<typename R>
-using iterator_t = enable_if_t<is_range<R>::value, result_of_begin<decltype(std::declval<R&>())>>;
-
-template<typename T>
-using range_value_t = value_type_t<iterator_traits<iterator_t<T>>>;
-
-// The following implementation of is_complete_type is taken from
-// https://blogs.msdn.microsoft.com/vcblog/2015/12/02/partial-support-for-expression-sfinae-in-vs-2015-update-1/
-// and is written by Xiang Fan who agreed to using it in this library.
-
-template<typename T, typename = void>
-struct is_complete_type : std::false_type {};
-
-template<typename T>
-struct is_complete_type<T, decltype(void(sizeof(T)))> : std::true_type {};
-
-template<typename BasicJsonType, typename CompatibleObjectType,
-         typename = void>
-struct is_compatible_object_type_impl : std::false_type {};
-
-template<typename BasicJsonType, typename CompatibleObjectType>
-struct is_compatible_object_type_impl <
-    BasicJsonType, CompatibleObjectType,
-    enable_if_t < is_detected<mapped_type_t, CompatibleObjectType>::value&&
-    is_detected<key_type_t, CompatibleObjectType>::value >>
-{
-    using object_t = typename BasicJsonType::object_t;
-
-    // macOS's is_constructible does not play well with nonesuch...
-    static constexpr bool value =
-        is_constructible<typename object_t::key_type,
-        typename CompatibleObjectType::key_type>::value &&
-        is_constructible<typename object_t::mapped_type,
-        typename CompatibleObjectType::mapped_type>::value;
-};
-
-template<typename BasicJsonType, typename CompatibleObjectType>
-struct is_compatible_object_type
-    : is_compatible_object_type_impl<BasicJsonType, CompatibleObjectType> {};
-
-template<typename BasicJsonType, typename ConstructibleObjectType,
-         typename = void>
-struct is_constructible_object_type_impl : std::false_type {};
-
-template<typename BasicJsonType, typename ConstructibleObjectType>
-struct is_constructible_object_type_impl <
-    BasicJsonType, ConstructibleObjectType,
-    enable_if_t < is_detected<mapped_type_t, ConstructibleObjectType>::value&&
-    is_detected<key_type_t, ConstructibleObjectType>::value >>
-{
-    using object_t = typename BasicJsonType::object_t;
-
-    static constexpr bool value =
-        (is_default_constructible<ConstructibleObjectType>::value &&
-         (std::is_move_assignable<ConstructibleObjectType>::value ||
-          std::is_copy_assignable<ConstructibleObjectType>::value) &&
-         (is_constructible<typename ConstructibleObjectType::key_type,
-          typename object_t::key_type>::value &&
-          std::is_same <
-          typename object_t::mapped_type,
-          typename ConstructibleObjectType::mapped_type >::value)) ||
-        (has_from_json<BasicJsonType,
-         typename ConstructibleObjectType::mapped_type>::value ||
-         has_non_default_from_json <
-         BasicJsonType,
-         typename ConstructibleObjectType::mapped_type >::value);
-};
-
-template<typename BasicJsonType, typename ConstructibleObjectType>
-struct is_constructible_object_type
-    : is_constructible_object_type_impl<BasicJsonType,
-      ConstructibleObjectType> {};
-
-template<typename BasicJsonType, typename CompatibleStringType>
-struct is_compatible_string_type
-{
-    static constexpr auto value =
-        is_constructible<typename BasicJsonType::string_t, CompatibleStringType>::value;
-};
-
-template<typename BasicJsonType, typename ConstructibleStringType>
-struct is_constructible_string_type
-{
-    static constexpr auto value =
-        is_constructible<ConstructibleStringType,
-        typename BasicJsonType::string_t>::value;
-};
-
-template<typename BasicJsonType, typename CompatibleArrayType, typename = void>
-struct is_compatible_array_type_impl : std::false_type {};
-
-template<typename BasicJsonType, typename CompatibleArrayType>
-struct is_compatible_array_type_impl <
-    BasicJsonType, CompatibleArrayType,
-    enable_if_t <
-    is_detected<iterator_t, CompatibleArrayType>::value&&
-    is_iterator_traits<iterator_traits<detected_t<iterator_t, CompatibleArrayType>>>::value&&
-// special case for types like std::filesystem::path whose iterator's value_type are themselves
-// c.f. https://github.com/nlohmann/json/pull/3073
-    !std::is_same<CompatibleArrayType, detected_t<range_value_t, CompatibleArrayType>>::value >>
-{
-    static constexpr bool value =
-        is_constructible<BasicJsonType,
-        range_value_t<CompatibleArrayType>>::value;
-};
-
-template<typename BasicJsonType, typename CompatibleArrayType>
-struct is_compatible_array_type
-    : is_compatible_array_type_impl<BasicJsonType, CompatibleArrayType> {};
-
-template<typename BasicJsonType, typename ConstructibleArrayType, typename = void>
-struct is_constructible_array_type_impl : std::false_type {};
-
-template<typename BasicJsonType, typename ConstructibleArrayType>
-struct is_constructible_array_type_impl <
-    BasicJsonType, ConstructibleArrayType,
-    enable_if_t<std::is_same<ConstructibleArrayType,
-    typename BasicJsonType::value_type>::value >>
-            : std::true_type {};
-
-template<typename BasicJsonType, typename ConstructibleArrayType>
-struct is_constructible_array_type_impl <
-    BasicJsonType, ConstructibleArrayType,
-    enable_if_t < !std::is_same<ConstructibleArrayType,
-    typename BasicJsonType::value_type>::value&&
-    !is_compatible_string_type<BasicJsonType, ConstructibleArrayType>::value&&
-    is_default_constructible<ConstructibleArrayType>::value&&
-(std::is_move_assignable<ConstructibleArrayType>::value ||
- std::is_copy_assignable<ConstructibleArrayType>::value)&&
-is_detected<iterator_t, ConstructibleArrayType>::value&&
-is_iterator_traits<iterator_traits<detected_t<iterator_t, ConstructibleArrayType>>>::value&&
-is_detected<range_value_t, ConstructibleArrayType>::value&&
-// special case for types like std::filesystem::path whose iterator's value_type are themselves
-// c.f. https://github.com/nlohmann/json/pull/3073
-!std::is_same<ConstructibleArrayType, detected_t<range_value_t, ConstructibleArrayType>>::value&&
-        is_complete_type <
-        detected_t<range_value_t, ConstructibleArrayType >>::value >>
-{
-    using value_type = range_value_t<ConstructibleArrayType>;
-
-    static constexpr bool value =
-        std::is_same<value_type,
-        typename BasicJsonType::array_t::value_type>::value ||
-        has_from_json<BasicJsonType,
-        value_type>::value ||
-        has_non_default_from_json <
-        BasicJsonType,
-        value_type >::value;
-};
-
-template<typename BasicJsonType, typename ConstructibleArrayType>
-struct is_constructible_array_type
-    : is_constructible_array_type_impl<BasicJsonType, ConstructibleArrayType> {};
-
-template<typename RealIntegerType, typename CompatibleNumberIntegerType,
-         typename = void>
-struct is_compatible_integer_type_impl : std::false_type {};
-
-template<typename RealIntegerType, typename CompatibleNumberIntegerType>
-struct is_compatible_integer_type_impl <
-    RealIntegerType, CompatibleNumberIntegerType,
-    enable_if_t < std::is_integral<RealIntegerType>::value&&
-    std::is_integral<CompatibleNumberIntegerType>::value&&
-    !std::is_same<bool, CompatibleNumberIntegerType>::value >>
-{
-    // is there an assert somewhere on overflows?
-    using RealLimits = std::numeric_limits<RealIntegerType>;
-    using CompatibleLimits = std::numeric_limits<CompatibleNumberIntegerType>;
-
-    static constexpr auto value =
-        is_constructible<RealIntegerType,
-        CompatibleNumberIntegerType>::value &&
-        CompatibleLimits::is_integer &&
-        RealLimits::is_signed == CompatibleLimits::is_signed;
-};
-
-template<typename RealIntegerType, typename CompatibleNumberIntegerType>
-struct is_compatible_integer_type
-    : is_compatible_integer_type_impl<RealIntegerType,
-      CompatibleNumberIntegerType> {};
-
-template<typename BasicJsonType, typename CompatibleType, typename = void>
-struct is_compatible_type_impl: std::false_type {};
-
-template<typename BasicJsonType, typename CompatibleType>
-struct is_compatible_type_impl <
-    BasicJsonType, CompatibleType,
-    enable_if_t<is_complete_type<CompatibleType>::value >>
-{
-    static constexpr bool value =
-        has_to_json<BasicJsonType, CompatibleType>::value;
-};
-
-template<typename BasicJsonType, typename CompatibleType>
-struct is_compatible_type
-    : is_compatible_type_impl<BasicJsonType, CompatibleType> {};
-
-template<typename T1, typename T2>
-struct is_constructible_tuple : std::false_type {};
-
-template<typename T1, typename... Args>
-struct is_constructible_tuple<T1, std::tuple<Args...>> : conjunction<is_constructible<T1, Args>...> {};
-
-// a naive helper to check if a type is an ordered_map (exploits the fact that
-// ordered_map inherits capacity() from std::vector)
-template <typename T>
-struct is_ordered_map
-{
-    using one = char;
-
-    struct two
-    {
-        char x[2]; // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
-    };
-
-    template <typename C> static one test( decltype(&C::capacity) ) ;
-    template <typename C> static two test(...);
-
-    enum { value = sizeof(test<T>(nullptr)) == sizeof(char) }; // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-};
-
-// to avoid useless casts (see https://github.com/nlohmann/json/issues/2893#issuecomment-889152324)
-template < typename T, typename U, enable_if_t < !std::is_same<T, U>::value, int > = 0 >
-T conditional_static_cast(U value)
-{
-    return static_cast<T>(value);
-}
-
-template<typename T, typename U, enable_if_t<std::is_same<T, U>::value, int> = 0>
-T conditional_static_cast(U value)
-{
-    return value;
-}
-
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-#if JSON_HAS_EXPERIMENTAL_FILESYSTEM
-#include <experimental/filesystem>
-namespace nlohmann::detail
-{
-namespace std_fs = std::experimental::filesystem;
-} // namespace nlohmann::detail
-#elif JSON_HAS_FILESYSTEM
-#include <filesystem>
-namespace nlohmann::detail
-{
-namespace std_fs = std::filesystem;
-} // namespace nlohmann::detail
-#endif
-
-namespace nlohmann
-{
-namespace detail
-{
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, typename std::nullptr_t& n)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_null()))
-    {
-        JSON_THROW(type_error::create(302, "type must be null, but is " + std::string(j.type_name()), j));
-    }
-    n = nullptr;
-}
-
-// overloads for basic_json template parameters
-template < typename BasicJsonType, typename ArithmeticType,
-           enable_if_t < std::is_arithmetic<ArithmeticType>::value&&
-                         !std::is_same<ArithmeticType, typename BasicJsonType::boolean_t>::value,
-                         int > = 0 >
-void get_arithmetic_value(const BasicJsonType& j, ArithmeticType& val)
-{
-    switch (static_cast<value_t>(j))
-    {
-        case value_t::number_unsigned:
-        {
-            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_unsigned_t*>());
-            break;
-        }
-        case value_t::number_integer:
-        {
-            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_integer_t*>());
-            break;
-        }
-        case value_t::number_float:
-        {
-            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_float_t*>());
-            break;
-        }
-
-        case value_t::null:
-        case value_t::object:
-        case value_t::array:
-        case value_t::string:
-        case value_t::boolean:
-        case value_t::binary:
-        case value_t::discarded:
-        default:
-            JSON_THROW(type_error::create(302, "type must be number, but is " + std::string(j.type_name()), j));
-    }
-}
-
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, typename BasicJsonType::boolean_t& b)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_boolean()))
-    {
-        JSON_THROW(type_error::create(302, "type must be boolean, but is " + std::string(j.type_name()), j));
-    }
-    b = *j.template get_ptr<const typename BasicJsonType::boolean_t*>();
-}
-
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, typename BasicJsonType::string_t& s)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_string()))
-    {
-        JSON_THROW(type_error::create(302, "type must be string, but is " + std::string(j.type_name()), j));
-    }
-    s = *j.template get_ptr<const typename BasicJsonType::string_t*>();
-}
-
-template <
-    typename BasicJsonType, typename ConstructibleStringType,
-    enable_if_t <
-        is_constructible_string_type<BasicJsonType, ConstructibleStringType>::value&&
-        !std::is_same<typename BasicJsonType::string_t,
-                      ConstructibleStringType>::value,
-        int > = 0 >
-void from_json(const BasicJsonType& j, ConstructibleStringType& s)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_string()))
-    {
-        JSON_THROW(type_error::create(302, "type must be string, but is " + std::string(j.type_name()), j));
-    }
-
-    s = *j.template get_ptr<const typename BasicJsonType::string_t*>();
-}
-
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, typename BasicJsonType::number_float_t& val)
-{
-    get_arithmetic_value(j, val);
-}
-
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, typename BasicJsonType::number_unsigned_t& val)
-{
-    get_arithmetic_value(j, val);
-}
-
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, typename BasicJsonType::number_integer_t& val)
-{
-    get_arithmetic_value(j, val);
-}
-
-template<typename BasicJsonType, typename EnumType,
-         enable_if_t<std::is_enum<EnumType>::value, int> = 0>
-void from_json(const BasicJsonType& j, EnumType& e)
-{
-    typename std::underlying_type<EnumType>::type val;
-    get_arithmetic_value(j, val);
-    e = static_cast<EnumType>(val);
-}
-
-// forward_list doesn't have an insert method
-template<typename BasicJsonType, typename T, typename Allocator,
-         enable_if_t<is_getable<BasicJsonType, T>::value, int> = 0>
-void from_json(const BasicJsonType& j, std::forward_list<T, Allocator>& l)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
-    {
-        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
-    }
-    l.clear();
-    std::transform(j.rbegin(), j.rend(),
-                   std::front_inserter(l), [](const BasicJsonType & i)
-    {
-        return i.template get<T>();
-    });
-}
-
-// valarray doesn't have an insert method
-template<typename BasicJsonType, typename T,
-         enable_if_t<is_getable<BasicJsonType, T>::value, int> = 0>
-void from_json(const BasicJsonType& j, std::valarray<T>& l)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
-    {
-        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
-    }
-    l.resize(j.size());
-    std::transform(j.begin(), j.end(), std::begin(l),
-                   [](const BasicJsonType & elem)
-    {
-        return elem.template get<T>();
-    });
-}
-
-template<typename BasicJsonType, typename T, std::size_t N>
-auto from_json(const BasicJsonType& j, T (&arr)[N])  // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
--> decltype(j.template get<T>(), void())
-{
-    for (std::size_t i = 0; i < N; ++i)
-    {
-        arr[i] = j.at(i).template get<T>();
-    }
-}
-
-template<typename BasicJsonType>
-void from_json_array_impl(const BasicJsonType& j, typename BasicJsonType::array_t& arr, priority_tag<3> /*unused*/)
-{
-    arr = *j.template get_ptr<const typename BasicJsonType::array_t*>();
-}
-
-template<typename BasicJsonType, typename T, std::size_t N>
-auto from_json_array_impl(const BasicJsonType& j, std::array<T, N>& arr,
-                          priority_tag<2> /*unused*/)
--> decltype(j.template get<T>(), void())
-{
-    for (std::size_t i = 0; i < N; ++i)
-    {
-        arr[i] = j.at(i).template get<T>();
-    }
-}
-
-template<typename BasicJsonType, typename ConstructibleArrayType,
-         enable_if_t<
-             std::is_assignable<ConstructibleArrayType&, ConstructibleArrayType>::value,
-             int> = 0>
-auto from_json_array_impl(const BasicJsonType& j, ConstructibleArrayType& arr, priority_tag<1> /*unused*/)
--> decltype(
-    arr.reserve(std::declval<typename ConstructibleArrayType::size_type>()),
-    j.template get<typename ConstructibleArrayType::value_type>(),
-    void())
-{
-    using std::end;
-
-    ConstructibleArrayType ret;
-    ret.reserve(j.size());
-    std::transform(j.begin(), j.end(),
-                   std::inserter(ret, end(ret)), [](const BasicJsonType & i)
-    {
-        // get<BasicJsonType>() returns *this, this won't call a from_json
-        // method when value_type is BasicJsonType
-        return i.template get<typename ConstructibleArrayType::value_type>();
-    });
-    arr = std::move(ret);
-}
-
-template<typename BasicJsonType, typename ConstructibleArrayType,
-         enable_if_t<
-             std::is_assignable<ConstructibleArrayType&, ConstructibleArrayType>::value,
-             int> = 0>
-void from_json_array_impl(const BasicJsonType& j, ConstructibleArrayType& arr,
-                          priority_tag<0> /*unused*/)
-{
-    using std::end;
-
-    ConstructibleArrayType ret;
-    std::transform(
-        j.begin(), j.end(), std::inserter(ret, end(ret)),
-        [](const BasicJsonType & i)
-    {
-        // get<BasicJsonType>() returns *this, this won't call a from_json
-        // method when value_type is BasicJsonType
-        return i.template get<typename ConstructibleArrayType::value_type>();
-    });
-    arr = std::move(ret);
-}
-
-template < typename BasicJsonType, typename ConstructibleArrayType,
-           enable_if_t <
-               is_constructible_array_type<BasicJsonType, ConstructibleArrayType>::value&&
-               !is_constructible_object_type<BasicJsonType, ConstructibleArrayType>::value&&
-               !is_constructible_string_type<BasicJsonType, ConstructibleArrayType>::value&&
-               !std::is_same<ConstructibleArrayType, typename BasicJsonType::binary_t>::value&&
-               !is_basic_json<ConstructibleArrayType>::value,
-               int > = 0 >
-auto from_json(const BasicJsonType& j, ConstructibleArrayType& arr)
--> decltype(from_json_array_impl(j, arr, priority_tag<3> {}),
-j.template get<typename ConstructibleArrayType::value_type>(),
-void())
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
-    {
-        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
-    }
-
-    from_json_array_impl(j, arr, priority_tag<3> {});
-}
-
-template < typename BasicJsonType, typename T, std::size_t... Idx >
-std::array<T, sizeof...(Idx)> from_json_inplace_array_impl(BasicJsonType&& j,
-        identity_tag<std::array<T, sizeof...(Idx)>> /*unused*/, index_sequence<Idx...> /*unused*/)
-{
-    return { { std::forward<BasicJsonType>(j).at(Idx).template get<T>()... } };
-}
-
-template < typename BasicJsonType, typename T, std::size_t N >
-auto from_json(BasicJsonType&& j, identity_tag<std::array<T, N>> tag)
--> decltype(from_json_inplace_array_impl(std::forward<BasicJsonType>(j), tag, make_index_sequence<N> {}))
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
-    {
-        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
-    }
-
-    return from_json_inplace_array_impl(std::forward<BasicJsonType>(j), tag, make_index_sequence<N> {});
-}
-
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, typename BasicJsonType::binary_t& bin)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_binary()))
-    {
-        JSON_THROW(type_error::create(302, "type must be binary, but is " + std::string(j.type_name()), j));
-    }
-
-    bin = *j.template get_ptr<const typename BasicJsonType::binary_t*>();
-}
-
-template<typename BasicJsonType, typename ConstructibleObjectType,
-         enable_if_t<is_constructible_object_type<BasicJsonType, ConstructibleObjectType>::value, int> = 0>
-void from_json(const BasicJsonType& j, ConstructibleObjectType& obj)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_object()))
-    {
-        JSON_THROW(type_error::create(302, "type must be object, but is " + std::string(j.type_name()), j));
-    }
-
-    ConstructibleObjectType ret;
-    const auto* inner_object = j.template get_ptr<const typename BasicJsonType::object_t*>();
-    using value_type = typename ConstructibleObjectType::value_type;
-    std::transform(
-        inner_object->begin(), inner_object->end(),
-        std::inserter(ret, ret.begin()),
-        [](typename BasicJsonType::object_t::value_type const & p)
-    {
-        return value_type(p.first, p.second.template get<typename ConstructibleObjectType::mapped_type>());
-    });
-    obj = std::move(ret);
-}
-
-// overload for arithmetic types, not chosen for basic_json template arguments
-// (BooleanType, etc..); note: Is it really necessary to provide explicit
-// overloads for boolean_t etc. in case of a custom BooleanType which is not
-// an arithmetic type?
-template < typename BasicJsonType, typename ArithmeticType,
-           enable_if_t <
-               std::is_arithmetic<ArithmeticType>::value&&
-               !std::is_same<ArithmeticType, typename BasicJsonType::number_unsigned_t>::value&&
-               !std::is_same<ArithmeticType, typename BasicJsonType::number_integer_t>::value&&
-               !std::is_same<ArithmeticType, typename BasicJsonType::number_float_t>::value&&
-               !std::is_same<ArithmeticType, typename BasicJsonType::boolean_t>::value,
-               int > = 0 >
-void from_json(const BasicJsonType& j, ArithmeticType& val)
-{
-    switch (static_cast<value_t>(j))
-    {
-        case value_t::number_unsigned:
-        {
-            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_unsigned_t*>());
-            break;
-        }
-        case value_t::number_integer:
-        {
-            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_integer_t*>());
-            break;
-        }
-        case value_t::number_float:
-        {
-            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::number_float_t*>());
-            break;
-        }
-        case value_t::boolean:
-        {
-            val = static_cast<ArithmeticType>(*j.template get_ptr<const typename BasicJsonType::boolean_t*>());
-            break;
-        }
-
-        case value_t::null:
-        case value_t::object:
-        case value_t::array:
-        case value_t::string:
-        case value_t::binary:
-        case value_t::discarded:
-        default:
-            JSON_THROW(type_error::create(302, "type must be number, but is " + std::string(j.type_name()), j));
-    }
-}
-
-template<typename BasicJsonType, typename... Args, std::size_t... Idx>
-std::tuple<Args...> from_json_tuple_impl_base(BasicJsonType&& j, index_sequence<Idx...> /*unused*/)
-{
-    return std::make_tuple(std::forward<BasicJsonType>(j).at(Idx).template get<Args>()...);
-}
-
-template < typename BasicJsonType, class A1, class A2 >
-std::pair<A1, A2> from_json_tuple_impl(BasicJsonType&& j, identity_tag<std::pair<A1, A2>> /*unused*/, priority_tag<0> /*unused*/)
-{
-    return {std::forward<BasicJsonType>(j).at(0).template get<A1>(),
-            std::forward<BasicJsonType>(j).at(1).template get<A2>()};
-}
-
-template<typename BasicJsonType, typename A1, typename A2>
-void from_json_tuple_impl(BasicJsonType&& j, std::pair<A1, A2>& p, priority_tag<1> /*unused*/)
-{
-    p = from_json_tuple_impl(std::forward<BasicJsonType>(j), identity_tag<std::pair<A1, A2>> {}, priority_tag<0> {});
-}
-
-template<typename BasicJsonType, typename... Args>
-std::tuple<Args...> from_json_tuple_impl(BasicJsonType&& j, identity_tag<std::tuple<Args...>> /*unused*/, priority_tag<2> /*unused*/)
-{
-    return from_json_tuple_impl_base<BasicJsonType, Args...>(std::forward<BasicJsonType>(j), index_sequence_for<Args...> {});
-}
-
-template<typename BasicJsonType, typename... Args>
-void from_json_tuple_impl(BasicJsonType&& j, std::tuple<Args...>& t, priority_tag<3> /*unused*/)
-{
-    t = from_json_tuple_impl_base<BasicJsonType, Args...>(std::forward<BasicJsonType>(j), index_sequence_for<Args...> {});
-}
-
-template<typename BasicJsonType, typename TupleRelated>
-auto from_json(BasicJsonType&& j, TupleRelated&& t)
--> decltype(from_json_tuple_impl(std::forward<BasicJsonType>(j), std::forward<TupleRelated>(t), priority_tag<3> {}))
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
-    {
-        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
-    }
-
-    return from_json_tuple_impl(std::forward<BasicJsonType>(j), std::forward<TupleRelated>(t), priority_tag<3> {});
-}
-
-template < typename BasicJsonType, typename Key, typename Value, typename Compare, typename Allocator,
-           typename = enable_if_t < !std::is_constructible <
-                                        typename BasicJsonType::string_t, Key >::value >>
-void from_json(const BasicJsonType& j, std::map<Key, Value, Compare, Allocator>& m)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
-    {
-        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
-    }
-    m.clear();
-    for (const auto& p : j)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!p.is_array()))
-        {
-            JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(p.type_name()), j));
-        }
-        m.emplace(p.at(0).template get<Key>(), p.at(1).template get<Value>());
-    }
-}
-
-template < typename BasicJsonType, typename Key, typename Value, typename Hash, typename KeyEqual, typename Allocator,
-           typename = enable_if_t < !std::is_constructible <
-                                        typename BasicJsonType::string_t, Key >::value >>
-void from_json(const BasicJsonType& j, std::unordered_map<Key, Value, Hash, KeyEqual, Allocator>& m)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_array()))
-    {
-        JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(j.type_name()), j));
-    }
-    m.clear();
-    for (const auto& p : j)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!p.is_array()))
-        {
-            JSON_THROW(type_error::create(302, "type must be array, but is " + std::string(p.type_name()), j));
-        }
-        m.emplace(p.at(0).template get<Key>(), p.at(1).template get<Value>());
-    }
-}
-
-#if JSON_HAS_FILESYSTEM || JSON_HAS_EXPERIMENTAL_FILESYSTEM
-template<typename BasicJsonType>
-void from_json(const BasicJsonType& j, std_fs::path& p)
-{
-    if (JSON_HEDLEY_UNLIKELY(!j.is_string()))
-    {
-        JSON_THROW(type_error::create(302, "type must be string, but is " + std::string(j.type_name()), j));
-    }
-    p = *j.template get_ptr<const typename BasicJsonType::string_t*>();
-}
-#endif
-
-struct from_json_fn
-{
-    template<typename BasicJsonType, typename T>
-    auto operator()(const BasicJsonType& j, T&& val) const
-    noexcept(noexcept(from_json(j, std::forward<T>(val))))
-    -> decltype(from_json(j, std::forward<T>(val)))
-    {
-        return from_json(j, std::forward<T>(val));
-    }
-};
-}  // namespace detail
-
-/// namespace to hold default `from_json` function
-/// to see why this is required:
-/// http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2015/n4381.html
-namespace // NOLINT(cert-dcl59-cpp,fuchsia-header-anon-namespaces,google-build-namespaces)
-{
-constexpr const auto& from_json = detail::static_const<detail::from_json_fn>::value; // NOLINT(misc-definitions-in-headers)
-} // namespace
-} // namespace nlohmann
-
-// #include <nlohmann/detail/conversions/to_json.hpp>
-
-
-#include <algorithm> // copy
-#include <iterator> // begin, end
-#include <string> // string
-#include <tuple> // tuple, get
-#include <type_traits> // is_same, is_constructible, is_floating_point, is_enum, underlying_type
-#include <utility> // move, forward, declval, pair
-#include <valarray> // valarray
-#include <vector> // vector
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/iterators/iteration_proxy.hpp>
-
-
-#include <cstddef> // size_t
-#include <iterator> // input_iterator_tag
-#include <string> // string, to_string
-#include <tuple> // tuple_size, get, tuple_element
-#include <utility> // move
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-template<typename string_type>
-void int_to_string( string_type& target, std::size_t value )
-{
-    // For ADL
-    using std::to_string;
-    target = to_string(value);
-}
-template<typename IteratorType> class iteration_proxy_value
-{
-  public:
-    using difference_type = std::ptrdiff_t;
-    using value_type = iteration_proxy_value;
-    using pointer = value_type * ;
-    using reference = value_type & ;
-    using iterator_category = std::input_iterator_tag;
-    using string_type = typename std::remove_cv< typename std::remove_reference<decltype( std::declval<IteratorType>().key() ) >::type >::type;
-
-  private:
-    /// the iterator
-    IteratorType anchor;
-    /// an index for arrays (used to create key names)
-    std::size_t array_index = 0;
-    /// last stringified array index
-    mutable std::size_t array_index_last = 0;
-    /// a string representation of the array index
-    mutable string_type array_index_str = "0";
-    /// an empty string (to return a reference for primitive values)
-    const string_type empty_str{};
-
-  public:
-    explicit iteration_proxy_value(IteratorType it) noexcept
-        : anchor(std::move(it))
-    {}
-
-    /// dereference operator (needed for range-based for)
-    iteration_proxy_value& operator*()
-    {
-        return *this;
-    }
-
-    /// increment operator (needed for range-based for)
-    iteration_proxy_value& operator++()
-    {
-        ++anchor;
-        ++array_index;
-
-        return *this;
-    }
-
-    /// equality operator (needed for InputIterator)
-    bool operator==(const iteration_proxy_value& o) const
-    {
-        return anchor == o.anchor;
-    }
-
-    /// inequality operator (needed for range-based for)
-    bool operator!=(const iteration_proxy_value& o) const
-    {
-        return anchor != o.anchor;
-    }
-
-    /// return key of the iterator
-    const string_type& key() const
-    {
-        JSON_ASSERT(anchor.m_object != nullptr);
-
-        switch (anchor.m_object->type())
-        {
-            // use integer array index as key
-            case value_t::array:
-            {
-                if (array_index != array_index_last)
-                {
-                    int_to_string( array_index_str, array_index );
-                    array_index_last = array_index;
-                }
-                return array_index_str;
-            }
-
-            // use key from the object
-            case value_t::object:
-                return anchor.key();
-
-            // use an empty key for all primitive types
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-                return empty_str;
-        }
-    }
-
-    /// return value of the iterator
-    typename IteratorType::reference value() const
-    {
-        return anchor.value();
-    }
-};
-
-/// proxy class for the items() function
-template<typename IteratorType> class iteration_proxy
-{
-  private:
-    /// the container to iterate
-    typename IteratorType::reference container;
-
-  public:
-    /// construct iteration proxy from a container
-    explicit iteration_proxy(typename IteratorType::reference cont) noexcept
-        : container(cont) {}
-
-    /// return iterator begin (needed for range-based for)
-    iteration_proxy_value<IteratorType> begin() noexcept
-    {
-        return iteration_proxy_value<IteratorType>(container.begin());
-    }
-
-    /// return iterator end (needed for range-based for)
-    iteration_proxy_value<IteratorType> end() noexcept
-    {
-        return iteration_proxy_value<IteratorType>(container.end());
-    }
-};
-// Structured Bindings Support
-// For further reference see https://blog.tartanllama.xyz/structured-bindings/
-// And see https://github.com/nlohmann/json/pull/1391
-template<std::size_t N, typename IteratorType, enable_if_t<N == 0, int> = 0>
-auto get(const nlohmann::detail::iteration_proxy_value<IteratorType>& i) -> decltype(i.key())
-{
-    return i.key();
-}
-// Structured Bindings Support
-// For further reference see https://blog.tartanllama.xyz/structured-bindings/
-// And see https://github.com/nlohmann/json/pull/1391
-template<std::size_t N, typename IteratorType, enable_if_t<N == 1, int> = 0>
-auto get(const nlohmann::detail::iteration_proxy_value<IteratorType>& i) -> decltype(i.value())
-{
-    return i.value();
-}
-}  // namespace detail
-}  // namespace nlohmann
-
-// The Addition to the STD Namespace is required to add
-// Structured Bindings Support to the iteration_proxy_value class
-// For further reference see https://blog.tartanllama.xyz/structured-bindings/
-// And see https://github.com/nlohmann/json/pull/1391
-namespace std
-{
-#if defined(__clang__)
-    // Fix: https://github.com/nlohmann/json/issues/1401
-    #pragma clang diagnostic push
-    #pragma clang diagnostic ignored "-Wmismatched-tags"
-#endif
-template<typename IteratorType>
-class tuple_size<::nlohmann::detail::iteration_proxy_value<IteratorType>>
-            : public std::integral_constant<std::size_t, 2> {};
-
-template<std::size_t N, typename IteratorType>
-class tuple_element<N, ::nlohmann::detail::iteration_proxy_value<IteratorType >>
-{
-  public:
-    using type = decltype(
-                     get<N>(std::declval <
-                            ::nlohmann::detail::iteration_proxy_value<IteratorType >> ()));
-};
-#if defined(__clang__)
-    #pragma clang diagnostic pop
-#endif
-} // namespace std
-
-// #include <nlohmann/detail/meta/cpp_future.hpp>
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-#if JSON_HAS_EXPERIMENTAL_FILESYSTEM
-#include <experimental/filesystem>
-namespace nlohmann::detail
-{
-namespace std_fs = std::experimental::filesystem;
-} // namespace nlohmann::detail
-#elif JSON_HAS_FILESYSTEM
-#include <filesystem>
-namespace nlohmann::detail
-{
-namespace std_fs = std::filesystem;
-} // namespace nlohmann::detail
-#endif
-
-namespace nlohmann
-{
-namespace detail
-{
-//////////////////
-// constructors //
-//////////////////
-
-/*
- * Note all external_constructor<>::construct functions need to call
- * j.m_value.destroy(j.m_type) to avoid a memory leak in case j contains an
- * allocated value (e.g., a string). See bug issue
- * https://github.com/nlohmann/json/issues/2865 for more information.
- */
-
-template<value_t> struct external_constructor;
-
-template<>
-struct external_constructor<value_t::boolean>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::boolean_t b) noexcept
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::boolean;
-        j.m_value = b;
-        j.assert_invariant();
-    }
-};
-
-template<>
-struct external_constructor<value_t::string>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, const typename BasicJsonType::string_t& s)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::string;
-        j.m_value = s;
-        j.assert_invariant();
-    }
-
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::string_t&& s)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::string;
-        j.m_value = std::move(s);
-        j.assert_invariant();
-    }
-
-    template < typename BasicJsonType, typename CompatibleStringType,
-               enable_if_t < !std::is_same<CompatibleStringType, typename BasicJsonType::string_t>::value,
-                             int > = 0 >
-    static void construct(BasicJsonType& j, const CompatibleStringType& str)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::string;
-        j.m_value.string = j.template create<typename BasicJsonType::string_t>(str);
-        j.assert_invariant();
-    }
-};
-
-template<>
-struct external_constructor<value_t::binary>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, const typename BasicJsonType::binary_t& b)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::binary;
-        j.m_value = typename BasicJsonType::binary_t(b);
-        j.assert_invariant();
-    }
-
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::binary_t&& b)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::binary;
-        j.m_value = typename BasicJsonType::binary_t(std::move(b));
-        j.assert_invariant();
-    }
-};
-
-template<>
-struct external_constructor<value_t::number_float>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::number_float_t val) noexcept
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::number_float;
-        j.m_value = val;
-        j.assert_invariant();
-    }
-};
-
-template<>
-struct external_constructor<value_t::number_unsigned>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::number_unsigned_t val) noexcept
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::number_unsigned;
-        j.m_value = val;
-        j.assert_invariant();
-    }
-};
-
-template<>
-struct external_constructor<value_t::number_integer>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::number_integer_t val) noexcept
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::number_integer;
-        j.m_value = val;
-        j.assert_invariant();
-    }
-};
-
-template<>
-struct external_constructor<value_t::array>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, const typename BasicJsonType::array_t& arr)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::array;
-        j.m_value = arr;
-        j.set_parents();
-        j.assert_invariant();
-    }
-
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::array_t&& arr)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::array;
-        j.m_value = std::move(arr);
-        j.set_parents();
-        j.assert_invariant();
-    }
-
-    template < typename BasicJsonType, typename CompatibleArrayType,
-               enable_if_t < !std::is_same<CompatibleArrayType, typename BasicJsonType::array_t>::value,
-                             int > = 0 >
-    static void construct(BasicJsonType& j, const CompatibleArrayType& arr)
-    {
-        using std::begin;
-        using std::end;
-
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::array;
-        j.m_value.array = j.template create<typename BasicJsonType::array_t>(begin(arr), end(arr));
-        j.set_parents();
-        j.assert_invariant();
-    }
-
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, const std::vector<bool>& arr)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::array;
-        j.m_value = value_t::array;
-        j.m_value.array->reserve(arr.size());
-        for (const bool x : arr)
-        {
-            j.m_value.array->push_back(x);
-            j.set_parent(j.m_value.array->back());
-        }
-        j.assert_invariant();
-    }
-
-    template<typename BasicJsonType, typename T,
-             enable_if_t<std::is_convertible<T, BasicJsonType>::value, int> = 0>
-    static void construct(BasicJsonType& j, const std::valarray<T>& arr)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::array;
-        j.m_value = value_t::array;
-        j.m_value.array->resize(arr.size());
-        if (arr.size() > 0)
-        {
-            std::copy(std::begin(arr), std::end(arr), j.m_value.array->begin());
-        }
-        j.set_parents();
-        j.assert_invariant();
-    }
-};
-
-template<>
-struct external_constructor<value_t::object>
-{
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, const typename BasicJsonType::object_t& obj)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::object;
-        j.m_value = obj;
-        j.set_parents();
-        j.assert_invariant();
-    }
-
-    template<typename BasicJsonType>
-    static void construct(BasicJsonType& j, typename BasicJsonType::object_t&& obj)
-    {
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::object;
-        j.m_value = std::move(obj);
-        j.set_parents();
-        j.assert_invariant();
-    }
-
-    template < typename BasicJsonType, typename CompatibleObjectType,
-               enable_if_t < !std::is_same<CompatibleObjectType, typename BasicJsonType::object_t>::value, int > = 0 >
-    static void construct(BasicJsonType& j, const CompatibleObjectType& obj)
-    {
-        using std::begin;
-        using std::end;
-
-        j.m_value.destroy(j.m_type);
-        j.m_type = value_t::object;
-        j.m_value.object = j.template create<typename BasicJsonType::object_t>(begin(obj), end(obj));
-        j.set_parents();
-        j.assert_invariant();
-    }
-};
-
-/////////////
-// to_json //
-/////////////
-
-template<typename BasicJsonType, typename T,
-         enable_if_t<std::is_same<T, typename BasicJsonType::boolean_t>::value, int> = 0>
-void to_json(BasicJsonType& j, T b) noexcept
-{
-    external_constructor<value_t::boolean>::construct(j, b);
-}
-
-template<typename BasicJsonType, typename CompatibleString,
-         enable_if_t<std::is_constructible<typename BasicJsonType::string_t, CompatibleString>::value, int> = 0>
-void to_json(BasicJsonType& j, const CompatibleString& s)
-{
-    external_constructor<value_t::string>::construct(j, s);
-}
-
-template<typename BasicJsonType>
-void to_json(BasicJsonType& j, typename BasicJsonType::string_t&& s)
-{
-    external_constructor<value_t::string>::construct(j, std::move(s));
-}
-
-template<typename BasicJsonType, typename FloatType,
-         enable_if_t<std::is_floating_point<FloatType>::value, int> = 0>
-void to_json(BasicJsonType& j, FloatType val) noexcept
-{
-    external_constructor<value_t::number_float>::construct(j, static_cast<typename BasicJsonType::number_float_t>(val));
-}
-
-template<typename BasicJsonType, typename CompatibleNumberUnsignedType,
-         enable_if_t<is_compatible_integer_type<typename BasicJsonType::number_unsigned_t, CompatibleNumberUnsignedType>::value, int> = 0>
-void to_json(BasicJsonType& j, CompatibleNumberUnsignedType val) noexcept
-{
-    external_constructor<value_t::number_unsigned>::construct(j, static_cast<typename BasicJsonType::number_unsigned_t>(val));
-}
-
-template<typename BasicJsonType, typename CompatibleNumberIntegerType,
-         enable_if_t<is_compatible_integer_type<typename BasicJsonType::number_integer_t, CompatibleNumberIntegerType>::value, int> = 0>
-void to_json(BasicJsonType& j, CompatibleNumberIntegerType val) noexcept
-{
-    external_constructor<value_t::number_integer>::construct(j, static_cast<typename BasicJsonType::number_integer_t>(val));
-}
-
-template<typename BasicJsonType, typename EnumType,
-         enable_if_t<std::is_enum<EnumType>::value, int> = 0>
-void to_json(BasicJsonType& j, EnumType e) noexcept
-{
-    using underlying_type = typename std::underlying_type<EnumType>::type;
-    external_constructor<value_t::number_integer>::construct(j, static_cast<underlying_type>(e));
-}
-
-template<typename BasicJsonType>
-void to_json(BasicJsonType& j, const std::vector<bool>& e)
-{
-    external_constructor<value_t::array>::construct(j, e);
-}
-
-template < typename BasicJsonType, typename CompatibleArrayType,
-           enable_if_t < is_compatible_array_type<BasicJsonType,
-                         CompatibleArrayType>::value&&
-                         !is_compatible_object_type<BasicJsonType, CompatibleArrayType>::value&&
-                         !is_compatible_string_type<BasicJsonType, CompatibleArrayType>::value&&
-                         !std::is_same<typename BasicJsonType::binary_t, CompatibleArrayType>::value&&
-                         !is_basic_json<CompatibleArrayType>::value,
-                         int > = 0 >
-void to_json(BasicJsonType& j, const CompatibleArrayType& arr)
-{
-    external_constructor<value_t::array>::construct(j, arr);
-}
-
-template<typename BasicJsonType>
-void to_json(BasicJsonType& j, const typename BasicJsonType::binary_t& bin)
-{
-    external_constructor<value_t::binary>::construct(j, bin);
-}
-
-template<typename BasicJsonType, typename T,
-         enable_if_t<std::is_convertible<T, BasicJsonType>::value, int> = 0>
-void to_json(BasicJsonType& j, const std::valarray<T>& arr)
-{
-    external_constructor<value_t::array>::construct(j, std::move(arr));
-}
-
-template<typename BasicJsonType>
-void to_json(BasicJsonType& j, typename BasicJsonType::array_t&& arr)
-{
-    external_constructor<value_t::array>::construct(j, std::move(arr));
-}
-
-template < typename BasicJsonType, typename CompatibleObjectType,
-           enable_if_t < is_compatible_object_type<BasicJsonType, CompatibleObjectType>::value&& !is_basic_json<CompatibleObjectType>::value, int > = 0 >
-void to_json(BasicJsonType& j, const CompatibleObjectType& obj)
-{
-    external_constructor<value_t::object>::construct(j, obj);
-}
-
-template<typename BasicJsonType>
-void to_json(BasicJsonType& j, typename BasicJsonType::object_t&& obj)
-{
-    external_constructor<value_t::object>::construct(j, std::move(obj));
-}
-
-template <
-    typename BasicJsonType, typename T, std::size_t N,
-    enable_if_t < !std::is_constructible<typename BasicJsonType::string_t,
-                  const T(&)[N]>::value, // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
-                  int > = 0 >
-void to_json(BasicJsonType& j, const T(&arr)[N]) // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
-{
-    external_constructor<value_t::array>::construct(j, arr);
-}
-
-template < typename BasicJsonType, typename T1, typename T2, enable_if_t < std::is_constructible<BasicJsonType, T1>::value&& std::is_constructible<BasicJsonType, T2>::value, int > = 0 >
-void to_json(BasicJsonType& j, const std::pair<T1, T2>& p)
-{
-    j = { p.first, p.second };
-}
-
-// for https://github.com/nlohmann/json/pull/1134
-template<typename BasicJsonType, typename T,
-         enable_if_t<std::is_same<T, iteration_proxy_value<typename BasicJsonType::iterator>>::value, int> = 0>
-void to_json(BasicJsonType& j, const T& b)
-{
-    j = { {b.key(), b.value()} };
-}
-
-template<typename BasicJsonType, typename Tuple, std::size_t... Idx>
-void to_json_tuple_impl(BasicJsonType& j, const Tuple& t, index_sequence<Idx...> /*unused*/)
-{
-    j = { std::get<Idx>(t)... };
-}
-
-template<typename BasicJsonType, typename T, enable_if_t<is_constructible_tuple<BasicJsonType, T>::value, int > = 0>
-void to_json(BasicJsonType& j, const T& t)
-{
-    to_json_tuple_impl(j, t, make_index_sequence<std::tuple_size<T>::value> {});
-}
-
-#if JSON_HAS_FILESYSTEM || JSON_HAS_EXPERIMENTAL_FILESYSTEM
-template<typename BasicJsonType>
-void to_json(BasicJsonType& j, const std_fs::path& p)
-{
-    j = p.string();
-}
-#endif
-
-struct to_json_fn
-{
-    template<typename BasicJsonType, typename T>
-    auto operator()(BasicJsonType& j, T&& val) const noexcept(noexcept(to_json(j, std::forward<T>(val))))
-    -> decltype(to_json(j, std::forward<T>(val)), void())
-    {
-        return to_json(j, std::forward<T>(val));
-    }
-};
-}  // namespace detail
-
-/// namespace to hold default `to_json` function
-/// to see why this is required:
-/// http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2015/n4381.html
-namespace // NOLINT(cert-dcl59-cpp,fuchsia-header-anon-namespaces,google-build-namespaces)
-{
-constexpr const auto& to_json = detail::static_const<detail::to_json_fn>::value; // NOLINT(misc-definitions-in-headers)
-} // namespace
-} // namespace nlohmann
-
-// #include <nlohmann/detail/meta/identity_tag.hpp>
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-
-namespace nlohmann
-{
-
-/// @sa https://json.nlohmann.me/api/adl_serializer/
-template<typename ValueType, typename>
-struct adl_serializer
-{
-    /// @brief convert a JSON value to any value type
-    /// @sa https://json.nlohmann.me/api/adl_serializer/from_json/
-    template<typename BasicJsonType, typename TargetType = ValueType>
-    static auto from_json(BasicJsonType && j, TargetType& val) noexcept(
-        noexcept(::nlohmann::from_json(std::forward<BasicJsonType>(j), val)))
-    -> decltype(::nlohmann::from_json(std::forward<BasicJsonType>(j), val), void())
-    {
-        ::nlohmann::from_json(std::forward<BasicJsonType>(j), val);
-    }
-
-    /// @brief convert a JSON value to any value type
-    /// @sa https://json.nlohmann.me/api/adl_serializer/from_json/
-    template<typename BasicJsonType, typename TargetType = ValueType>
-    static auto from_json(BasicJsonType && j) noexcept(
-    noexcept(::nlohmann::from_json(std::forward<BasicJsonType>(j), detail::identity_tag<TargetType> {})))
-    -> decltype(::nlohmann::from_json(std::forward<BasicJsonType>(j), detail::identity_tag<TargetType> {}))
-    {
-        return ::nlohmann::from_json(std::forward<BasicJsonType>(j), detail::identity_tag<TargetType> {});
-    }
-
-    /// @brief convert any value type to a JSON value
-    /// @sa https://json.nlohmann.me/api/adl_serializer/to_json/
-    template<typename BasicJsonType, typename TargetType = ValueType>
-    static auto to_json(BasicJsonType& j, TargetType && val) noexcept(
-        noexcept(::nlohmann::to_json(j, std::forward<TargetType>(val))))
-    -> decltype(::nlohmann::to_json(j, std::forward<TargetType>(val)), void())
-    {
-        ::nlohmann::to_json(j, std::forward<TargetType>(val));
-    }
-};
-}  // namespace nlohmann
-
-// #include <nlohmann/byte_container_with_subtype.hpp>
-
-
-#include <cstdint> // uint8_t, uint64_t
-#include <tuple> // tie
-#include <utility> // move
-
-namespace nlohmann
-{
-
-/// @brief an internal type for a backed binary type
-/// @sa https://json.nlohmann.me/api/byte_container_with_subtype/
-template<typename BinaryType>
-class byte_container_with_subtype : public BinaryType
-{
-  public:
-    using container_type = BinaryType;
-    using subtype_type = std::uint64_t;
-
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
-    byte_container_with_subtype() noexcept(noexcept(container_type()))
-        : container_type()
-    {}
-
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
-    byte_container_with_subtype(const container_type& b) noexcept(noexcept(container_type(b)))
-        : container_type(b)
-    {}
-
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
-    byte_container_with_subtype(container_type&& b) noexcept(noexcept(container_type(std::move(b))))
-        : container_type(std::move(b))
-    {}
-
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
-    byte_container_with_subtype(const container_type& b, subtype_type subtype_) noexcept(noexcept(container_type(b)))
-        : container_type(b)
-        , m_subtype(subtype_)
-        , m_has_subtype(true)
-    {}
-
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/byte_container_with_subtype/
-    byte_container_with_subtype(container_type&& b, subtype_type subtype_) noexcept(noexcept(container_type(std::move(b))))
-        : container_type(std::move(b))
-        , m_subtype(subtype_)
-        , m_has_subtype(true)
-    {}
-
-    bool operator==(const byte_container_with_subtype& rhs) const
-    {
-        return std::tie(static_cast<const BinaryType&>(*this), m_subtype, m_has_subtype) ==
-               std::tie(static_cast<const BinaryType&>(rhs), rhs.m_subtype, rhs.m_has_subtype);
-    }
-
-    bool operator!=(const byte_container_with_subtype& rhs) const
-    {
-        return !(rhs == *this);
-    }
-
-    /// @brief sets the binary subtype
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/set_subtype/
-    void set_subtype(subtype_type subtype_) noexcept
-    {
-        m_subtype = subtype_;
-        m_has_subtype = true;
-    }
-
-    /// @brief return the binary subtype
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/subtype/
-    constexpr subtype_type subtype() const noexcept
-    {
-        return m_has_subtype ? m_subtype : static_cast<subtype_type>(-1);
-    }
-
-    /// @brief return whether the value has a subtype
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/has_subtype/
-    constexpr bool has_subtype() const noexcept
-    {
-        return m_has_subtype;
-    }
-
-    /// @brief clears the binary subtype
-    /// @sa https://json.nlohmann.me/api/byte_container_with_subtype/clear_subtype/
-    void clear_subtype() noexcept
-    {
-        m_subtype = 0;
-        m_has_subtype = false;
-    }
-
-  private:
-    subtype_type m_subtype = 0;
-    bool m_has_subtype = false;
-};
-
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/conversions/from_json.hpp>
-
-// #include <nlohmann/detail/conversions/to_json.hpp>
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-// #include <nlohmann/detail/hash.hpp>
-
-
-#include <cstdint> // uint8_t
-#include <cstddef> // size_t
-#include <functional> // hash
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-
-// boost::hash_combine
-inline std::size_t combine(std::size_t seed, std::size_t h) noexcept
-{
-    seed ^= h + 0x9e3779b9 + (seed << 6U) + (seed >> 2U);
-    return seed;
-}
-
-/*!
-@brief hash a JSON value
-
-The hash function tries to rely on std::hash where possible. Furthermore, the
-type of the JSON value is taken into account to have different hash values for
-null, 0, 0U, and false, etc.
-
-@tparam BasicJsonType basic_json specialization
-@param j JSON value to hash
-@return hash value of j
-*/
-template<typename BasicJsonType>
-std::size_t hash(const BasicJsonType& j)
-{
-    using string_t = typename BasicJsonType::string_t;
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-
-    const auto type = static_cast<std::size_t>(j.type());
-    switch (j.type())
-    {
-        case BasicJsonType::value_t::null:
-        case BasicJsonType::value_t::discarded:
-        {
-            return combine(type, 0);
-        }
-
-        case BasicJsonType::value_t::object:
-        {
-            auto seed = combine(type, j.size());
-            for (const auto& element : j.items())
-            {
-                const auto h = std::hash<string_t> {}(element.key());
-                seed = combine(seed, h);
-                seed = combine(seed, hash(element.value()));
-            }
-            return seed;
-        }
-
-        case BasicJsonType::value_t::array:
-        {
-            auto seed = combine(type, j.size());
-            for (const auto& element : j)
-            {
-                seed = combine(seed, hash(element));
-            }
-            return seed;
-        }
-
-        case BasicJsonType::value_t::string:
-        {
-            const auto h = std::hash<string_t> {}(j.template get_ref<const string_t&>());
-            return combine(type, h);
-        }
-
-        case BasicJsonType::value_t::boolean:
-        {
-            const auto h = std::hash<bool> {}(j.template get<bool>());
-            return combine(type, h);
-        }
-
-        case BasicJsonType::value_t::number_integer:
-        {
-            const auto h = std::hash<number_integer_t> {}(j.template get<number_integer_t>());
-            return combine(type, h);
-        }
-
-        case BasicJsonType::value_t::number_unsigned:
-        {
-            const auto h = std::hash<number_unsigned_t> {}(j.template get<number_unsigned_t>());
-            return combine(type, h);
-        }
-
-        case BasicJsonType::value_t::number_float:
-        {
-            const auto h = std::hash<number_float_t> {}(j.template get<number_float_t>());
-            return combine(type, h);
-        }
-
-        case BasicJsonType::value_t::binary:
-        {
-            auto seed = combine(type, j.get_binary().size());
-            const auto h = std::hash<bool> {}(j.get_binary().has_subtype());
-            seed = combine(seed, h);
-            seed = combine(seed, static_cast<std::size_t>(j.get_binary().subtype()));
-            for (const auto byte : j.get_binary())
-            {
-                seed = combine(seed, std::hash<std::uint8_t> {}(byte));
-            }
-            return seed;
-        }
-
-        default:                   // LCOV_EXCL_LINE
-            JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-            return 0;              // LCOV_EXCL_LINE
-    }
-}
-
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/input/binary_reader.hpp>
-
-
-#include <algorithm> // generate_n
-#include <array> // array
-#include <cmath> // ldexp
-#include <cstddef> // size_t
-#include <cstdint> // uint8_t, uint16_t, uint32_t, uint64_t
-#include <cstdio> // snprintf
-#include <cstring> // memcpy
-#include <iterator> // back_inserter
-#include <limits> // numeric_limits
-#include <string> // char_traits, string
-#include <utility> // make_pair, move
-#include <vector> // vector
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-// #include <nlohmann/detail/input/input_adapters.hpp>
-
-
-#include <array> // array
-#include <cstddef> // size_t
-#include <cstring> // strlen
-#include <iterator> // begin, end, iterator_traits, random_access_iterator_tag, distance, next
-#include <memory> // shared_ptr, make_shared, addressof
-#include <numeric> // accumulate
-#include <string> // string, char_traits
-#include <type_traits> // enable_if, is_base_of, is_pointer, is_integral, remove_pointer
-#include <utility> // pair, declval
-
-#ifndef JSON_NO_IO
-    #include <cstdio>   // FILE *
-    #include <istream>  // istream
-#endif                  // JSON_NO_IO
-
-// #include <nlohmann/detail/iterators/iterator_traits.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-/// the supported input formats
-enum class input_format_t { json, cbor, msgpack, ubjson, bson };
-
-////////////////////
-// input adapters //
-////////////////////
-
-#ifndef JSON_NO_IO
-/*!
-Input adapter for stdio file access. This adapter read only 1 byte and do not use any
- buffer. This adapter is a very low level adapter.
-*/
-class file_input_adapter
-{
-  public:
-    using char_type = char;
-
-    JSON_HEDLEY_NON_NULL(2)
-    explicit file_input_adapter(std::FILE* f) noexcept
-        : m_file(f)
-    {}
-
-    // make class move-only
-    file_input_adapter(const file_input_adapter&) = delete;
-    file_input_adapter(file_input_adapter&&) noexcept = default;
-    file_input_adapter& operator=(const file_input_adapter&) = delete;
-    file_input_adapter& operator=(file_input_adapter&&) = delete;
-    ~file_input_adapter() = default;
-
-    std::char_traits<char>::int_type get_character() noexcept
-    {
-        return std::fgetc(m_file);
-    }
-
-  private:
-    /// the file pointer to read from
-    std::FILE* m_file;
-};
-
-
-/*!
-Input adapter for a (caching) istream. Ignores a UFT Byte Order Mark at
-beginning of input. Does not support changing the underlying std::streambuf
-in mid-input. Maintains underlying std::istream and std::streambuf to support
-subsequent use of standard std::istream operations to process any input
-characters following those used in parsing the JSON input.  Clears the
-std::istream flags; any input errors (e.g., EOF) will be detected by the first
-subsequent call for input from the std::istream.
-*/
-class input_stream_adapter
-{
-  public:
-    using char_type = char;
-
-    ~input_stream_adapter()
-    {
-        // clear stream flags; we use underlying streambuf I/O, do not
-        // maintain ifstream flags, except eof
-        if (is != nullptr)
-        {
-            is->clear(is->rdstate() & std::ios::eofbit);
-        }
-    }
-
-    explicit input_stream_adapter(std::istream& i)
-        : is(&i), sb(i.rdbuf())
-    {}
-
-    // delete because of pointer members
-    input_stream_adapter(const input_stream_adapter&) = delete;
-    input_stream_adapter& operator=(input_stream_adapter&) = delete;
-    input_stream_adapter& operator=(input_stream_adapter&&) = delete;
-
-    input_stream_adapter(input_stream_adapter&& rhs) noexcept
-        : is(rhs.is), sb(rhs.sb)
-    {
-        rhs.is = nullptr;
-        rhs.sb = nullptr;
-    }
-
-    // std::istream/std::streambuf use std::char_traits<char>::to_int_type, to
-    // ensure that std::char_traits<char>::eof() and the character 0xFF do not
-    // end up as the same value, e.g. 0xFFFFFFFF.
-    std::char_traits<char>::int_type get_character()
-    {
-        auto res = sb->sbumpc();
-        // set eof manually, as we don't use the istream interface.
-        if (JSON_HEDLEY_UNLIKELY(res == std::char_traits<char>::eof()))
-        {
-            is->clear(is->rdstate() | std::ios::eofbit);
-        }
-        return res;
-    }
-
-  private:
-    /// the associated input stream
-    std::istream* is = nullptr;
-    std::streambuf* sb = nullptr;
-};
-#endif  // JSON_NO_IO
-
-// General-purpose iterator-based adapter. It might not be as fast as
-// theoretically possible for some containers, but it is extremely versatile.
-template<typename IteratorType>
-class iterator_input_adapter
-{
-  public:
-    using char_type = typename std::iterator_traits<IteratorType>::value_type;
-
-    iterator_input_adapter(IteratorType first, IteratorType last)
-        : current(std::move(first)), end(std::move(last))
-    {}
-
-    typename std::char_traits<char_type>::int_type get_character()
-    {
-        if (JSON_HEDLEY_LIKELY(current != end))
-        {
-            auto result = std::char_traits<char_type>::to_int_type(*current);
-            std::advance(current, 1);
-            return result;
-        }
-
-        return std::char_traits<char_type>::eof();
-    }
-
-  private:
-    IteratorType current;
-    IteratorType end;
-
-    template<typename BaseInputAdapter, size_t T>
-    friend struct wide_string_input_helper;
-
-    bool empty() const
-    {
-        return current == end;
-    }
-};
-
-
-template<typename BaseInputAdapter, size_t T>
-struct wide_string_input_helper;
-
-template<typename BaseInputAdapter>
-struct wide_string_input_helper<BaseInputAdapter, 4>
-{
-    // UTF-32
-    static void fill_buffer(BaseInputAdapter& input,
-                            std::array<std::char_traits<char>::int_type, 4>& utf8_bytes,
-                            size_t& utf8_bytes_index,
-                            size_t& utf8_bytes_filled)
-    {
-        utf8_bytes_index = 0;
-
-        if (JSON_HEDLEY_UNLIKELY(input.empty()))
-        {
-            utf8_bytes[0] = std::char_traits<char>::eof();
-            utf8_bytes_filled = 1;
-        }
-        else
-        {
-            // get the current character
-            const auto wc = input.get_character();
-
-            // UTF-32 to UTF-8 encoding
-            if (wc < 0x80)
-            {
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
-                utf8_bytes_filled = 1;
-            }
-            else if (wc <= 0x7FF)
-            {
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xC0u | ((static_cast<unsigned int>(wc) >> 6u) & 0x1Fu));
-                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
-                utf8_bytes_filled = 2;
-            }
-            else if (wc <= 0xFFFF)
-            {
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xE0u | ((static_cast<unsigned int>(wc) >> 12u) & 0x0Fu));
-                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 6u) & 0x3Fu));
-                utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
-                utf8_bytes_filled = 3;
-            }
-            else if (wc <= 0x10FFFF)
-            {
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xF0u | ((static_cast<unsigned int>(wc) >> 18u) & 0x07u));
-                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 12u) & 0x3Fu));
-                utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 6u) & 0x3Fu));
-                utf8_bytes[3] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
-                utf8_bytes_filled = 4;
-            }
-            else
-            {
-                // unknown character
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
-                utf8_bytes_filled = 1;
-            }
-        }
-    }
-};
-
-template<typename BaseInputAdapter>
-struct wide_string_input_helper<BaseInputAdapter, 2>
-{
-    // UTF-16
-    static void fill_buffer(BaseInputAdapter& input,
-                            std::array<std::char_traits<char>::int_type, 4>& utf8_bytes,
-                            size_t& utf8_bytes_index,
-                            size_t& utf8_bytes_filled)
-    {
-        utf8_bytes_index = 0;
-
-        if (JSON_HEDLEY_UNLIKELY(input.empty()))
-        {
-            utf8_bytes[0] = std::char_traits<char>::eof();
-            utf8_bytes_filled = 1;
-        }
-        else
-        {
-            // get the current character
-            const auto wc = input.get_character();
-
-            // UTF-16 to UTF-8 encoding
-            if (wc < 0x80)
-            {
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
-                utf8_bytes_filled = 1;
-            }
-            else if (wc <= 0x7FF)
-            {
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xC0u | ((static_cast<unsigned int>(wc) >> 6u)));
-                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
-                utf8_bytes_filled = 2;
-            }
-            else if (0xD800 > wc || wc >= 0xE000)
-            {
-                utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xE0u | ((static_cast<unsigned int>(wc) >> 12u)));
-                utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((static_cast<unsigned int>(wc) >> 6u) & 0x3Fu));
-                utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | (static_cast<unsigned int>(wc) & 0x3Fu));
-                utf8_bytes_filled = 3;
-            }
-            else
-            {
-                if (JSON_HEDLEY_UNLIKELY(!input.empty()))
-                {
-                    const auto wc2 = static_cast<unsigned int>(input.get_character());
-                    const auto charcode = 0x10000u + (((static_cast<unsigned int>(wc) & 0x3FFu) << 10u) | (wc2 & 0x3FFu));
-                    utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(0xF0u | (charcode >> 18u));
-                    utf8_bytes[1] = static_cast<std::char_traits<char>::int_type>(0x80u | ((charcode >> 12u) & 0x3Fu));
-                    utf8_bytes[2] = static_cast<std::char_traits<char>::int_type>(0x80u | ((charcode >> 6u) & 0x3Fu));
-                    utf8_bytes[3] = static_cast<std::char_traits<char>::int_type>(0x80u | (charcode & 0x3Fu));
-                    utf8_bytes_filled = 4;
-                }
-                else
-                {
-                    utf8_bytes[0] = static_cast<std::char_traits<char>::int_type>(wc);
-                    utf8_bytes_filled = 1;
-                }
-            }
-        }
-    }
-};
-
-// Wraps another input apdater to convert wide character types into individual bytes.
-template<typename BaseInputAdapter, typename WideCharType>
-class wide_string_input_adapter
-{
-  public:
-    using char_type = char;
-
-    wide_string_input_adapter(BaseInputAdapter base)
-        : base_adapter(base) {}
-
-    typename std::char_traits<char>::int_type get_character() noexcept
-    {
-        // check if buffer needs to be filled
-        if (utf8_bytes_index == utf8_bytes_filled)
-        {
-            fill_buffer<sizeof(WideCharType)>();
-
-            JSON_ASSERT(utf8_bytes_filled > 0);
-            JSON_ASSERT(utf8_bytes_index == 0);
-        }
-
-        // use buffer
-        JSON_ASSERT(utf8_bytes_filled > 0);
-        JSON_ASSERT(utf8_bytes_index < utf8_bytes_filled);
-        return utf8_bytes[utf8_bytes_index++];
-    }
-
-  private:
-    BaseInputAdapter base_adapter;
-
-    template<size_t T>
-    void fill_buffer()
-    {
-        wide_string_input_helper<BaseInputAdapter, T>::fill_buffer(base_adapter, utf8_bytes, utf8_bytes_index, utf8_bytes_filled);
-    }
-
-    /// a buffer for UTF-8 bytes
-    std::array<std::char_traits<char>::int_type, 4> utf8_bytes = {{0, 0, 0, 0}};
-
-    /// index to the utf8_codes array for the next valid byte
-    std::size_t utf8_bytes_index = 0;
-    /// number of valid bytes in the utf8_codes array
-    std::size_t utf8_bytes_filled = 0;
-};
-
-
-template<typename IteratorType, typename Enable = void>
-struct iterator_input_adapter_factory
-{
-    using iterator_type = IteratorType;
-    using char_type = typename std::iterator_traits<iterator_type>::value_type;
-    using adapter_type = iterator_input_adapter<iterator_type>;
-
-    static adapter_type create(IteratorType first, IteratorType last)
-    {
-        return adapter_type(std::move(first), std::move(last));
-    }
-};
-
-template<typename T>
-struct is_iterator_of_multibyte
-{
-    using value_type = typename std::iterator_traits<T>::value_type;
-    enum
-    {
-        value = sizeof(value_type) > 1
-    };
-};
-
-template<typename IteratorType>
-struct iterator_input_adapter_factory<IteratorType, enable_if_t<is_iterator_of_multibyte<IteratorType>::value>>
-{
-    using iterator_type = IteratorType;
-    using char_type = typename std::iterator_traits<iterator_type>::value_type;
-    using base_adapter_type = iterator_input_adapter<iterator_type>;
-    using adapter_type = wide_string_input_adapter<base_adapter_type, char_type>;
-
-    static adapter_type create(IteratorType first, IteratorType last)
-    {
-        return adapter_type(base_adapter_type(std::move(first), std::move(last)));
-    }
-};
-
-// General purpose iterator-based input
-template<typename IteratorType>
-typename iterator_input_adapter_factory<IteratorType>::adapter_type input_adapter(IteratorType first, IteratorType last)
-{
-    using factory_type = iterator_input_adapter_factory<IteratorType>;
-    return factory_type::create(first, last);
-}
-
-// Convenience shorthand from container to iterator
-// Enables ADL on begin(container) and end(container)
-// Encloses the using declarations in namespace for not to leak them to outside scope
-
-namespace container_input_adapter_factory_impl
-{
-
-using std::begin;
-using std::end;
-
-template<typename ContainerType, typename Enable = void>
-struct container_input_adapter_factory {};
-
-template<typename ContainerType>
-struct container_input_adapter_factory< ContainerType,
-       void_t<decltype(begin(std::declval<ContainerType>()), end(std::declval<ContainerType>()))>>
-       {
-           using adapter_type = decltype(input_adapter(begin(std::declval<ContainerType>()), end(std::declval<ContainerType>())));
-
-           static adapter_type create(const ContainerType& container)
-{
-    return input_adapter(begin(container), end(container));
-}
-       };
-
-} // namespace container_input_adapter_factory_impl
-
-template<typename ContainerType>
-typename container_input_adapter_factory_impl::container_input_adapter_factory<ContainerType>::adapter_type input_adapter(const ContainerType& container)
-{
-    return container_input_adapter_factory_impl::container_input_adapter_factory<ContainerType>::create(container);
-}
-
-#ifndef JSON_NO_IO
-// Special cases with fast paths
-inline file_input_adapter input_adapter(std::FILE* file)
-{
-    return file_input_adapter(file);
-}
-
-inline input_stream_adapter input_adapter(std::istream& stream)
-{
-    return input_stream_adapter(stream);
-}
-
-inline input_stream_adapter input_adapter(std::istream&& stream)
-{
-    return input_stream_adapter(stream);
-}
-#endif  // JSON_NO_IO
-
-using contiguous_bytes_input_adapter = decltype(input_adapter(std::declval<const char*>(), std::declval<const char*>()));
-
-// Null-delimited strings, and the like.
-template < typename CharT,
-           typename std::enable_if <
-               std::is_pointer<CharT>::value&&
-               !std::is_array<CharT>::value&&
-               std::is_integral<typename std::remove_pointer<CharT>::type>::value&&
-               sizeof(typename std::remove_pointer<CharT>::type) == 1,
-               int >::type = 0 >
-contiguous_bytes_input_adapter input_adapter(CharT b)
-{
-    auto length = std::strlen(reinterpret_cast<const char*>(b));
-    const auto* ptr = reinterpret_cast<const char*>(b);
-    return input_adapter(ptr, ptr + length);
-}
-
-template<typename T, std::size_t N>
-auto input_adapter(T (&array)[N]) -> decltype(input_adapter(array, array + N)) // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
-{
-    return input_adapter(array, array + N);
-}
-
-// This class only handles inputs of input_buffer_adapter type.
-// It's required so that expressions like {ptr, len} can be implicitly cast
-// to the correct adapter.
-class span_input_adapter
-{
-  public:
-    template < typename CharT,
-               typename std::enable_if <
-                   std::is_pointer<CharT>::value&&
-                   std::is_integral<typename std::remove_pointer<CharT>::type>::value&&
-                   sizeof(typename std::remove_pointer<CharT>::type) == 1,
-                   int >::type = 0 >
-    span_input_adapter(CharT b, std::size_t l)
-        : ia(reinterpret_cast<const char*>(b), reinterpret_cast<const char*>(b) + l) {}
-
-    template<class IteratorType,
-             typename std::enable_if<
-                 std::is_same<typename iterator_traits<IteratorType>::iterator_category, std::random_access_iterator_tag>::value,
-                 int>::type = 0>
-    span_input_adapter(IteratorType first, IteratorType last)
-        : ia(input_adapter(first, last)) {}
-
-    contiguous_bytes_input_adapter&& get()
-    {
-        return std::move(ia); // NOLINT(hicpp-move-const-arg,performance-move-const-arg)
-    }
-
-  private:
-    contiguous_bytes_input_adapter ia;
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/input/json_sax.hpp>
-
-
-#include <cstddef>
-#include <string> // string
-#include <utility> // move
-#include <vector> // vector
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-
-/*!
-@brief SAX interface
-
-This class describes the SAX interface used by @ref nlohmann::json::sax_parse.
-Each function is called in different situations while the input is parsed. The
-boolean return value informs the parser whether to continue processing the
-input.
-*/
-template<typename BasicJsonType>
-struct json_sax
-{
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-
-    /*!
-    @brief a null value was read
-    @return whether parsing should proceed
-    */
-    virtual bool null() = 0;
-
-    /*!
-    @brief a boolean value was read
-    @param[in] val  boolean value
-    @return whether parsing should proceed
-    */
-    virtual bool boolean(bool val) = 0;
-
-    /*!
-    @brief an integer number was read
-    @param[in] val  integer value
-    @return whether parsing should proceed
-    */
-    virtual bool number_integer(number_integer_t val) = 0;
-
-    /*!
-    @brief an unsigned integer number was read
-    @param[in] val  unsigned integer value
-    @return whether parsing should proceed
-    */
-    virtual bool number_unsigned(number_unsigned_t val) = 0;
-
-    /*!
-    @brief a floating-point number was read
-    @param[in] val  floating-point value
-    @param[in] s    raw token value
-    @return whether parsing should proceed
-    */
-    virtual bool number_float(number_float_t val, const string_t& s) = 0;
-
-    /*!
-    @brief a string value was read
-    @param[in] val  string value
-    @return whether parsing should proceed
-    @note It is safe to move the passed string value.
-    */
-    virtual bool string(string_t& val) = 0;
-
-    /*!
-    @brief a binary value was read
-    @param[in] val  binary value
-    @return whether parsing should proceed
-    @note It is safe to move the passed binary value.
-    */
-    virtual bool binary(binary_t& val) = 0;
-
-    /*!
-    @brief the beginning of an object was read
-    @param[in] elements  number of object elements or -1 if unknown
-    @return whether parsing should proceed
-    @note binary formats may report the number of elements
-    */
-    virtual bool start_object(std::size_t elements) = 0;
-
-    /*!
-    @brief an object key was read
-    @param[in] val  object key
-    @return whether parsing should proceed
-    @note It is safe to move the passed string.
-    */
-    virtual bool key(string_t& val) = 0;
-
-    /*!
-    @brief the end of an object was read
-    @return whether parsing should proceed
-    */
-    virtual bool end_object() = 0;
-
-    /*!
-    @brief the beginning of an array was read
-    @param[in] elements  number of array elements or -1 if unknown
-    @return whether parsing should proceed
-    @note binary formats may report the number of elements
-    */
-    virtual bool start_array(std::size_t elements) = 0;
-
-    /*!
-    @brief the end of an array was read
-    @return whether parsing should proceed
-    */
-    virtual bool end_array() = 0;
-
-    /*!
-    @brief a parse error occurred
-    @param[in] position    the position in the input where the error occurs
-    @param[in] last_token  the last read token
-    @param[in] ex          an exception object describing the error
-    @return whether parsing should proceed (must return false)
-    */
-    virtual bool parse_error(std::size_t position,
-                             const std::string& last_token,
-                             const detail::exception& ex) = 0;
-
-    json_sax() = default;
-    json_sax(const json_sax&) = default;
-    json_sax(json_sax&&) noexcept = default;
-    json_sax& operator=(const json_sax&) = default;
-    json_sax& operator=(json_sax&&) noexcept = default;
-    virtual ~json_sax() = default;
-};
-
-
-namespace detail
-{
-/*!
-@brief SAX implementation to create a JSON value from SAX events
-
-This class implements the @ref json_sax interface and processes the SAX events
-to create a JSON value which makes it basically a DOM parser. The structure or
-hierarchy of the JSON value is managed by the stack `ref_stack` which contains
-a pointer to the respective array or object for each recursion depth.
-
-After successful parsing, the value that is passed by reference to the
-constructor contains the parsed value.
-
-@tparam BasicJsonType  the JSON type
-*/
-template<typename BasicJsonType>
-class json_sax_dom_parser
-{
-  public:
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-
-    /*!
-    @param[in,out] r  reference to a JSON value that is manipulated while
-                       parsing
-    @param[in] allow_exceptions_  whether parse errors yield exceptions
-    */
-    explicit json_sax_dom_parser(BasicJsonType& r, const bool allow_exceptions_ = true)
-        : root(r), allow_exceptions(allow_exceptions_)
-    {}
-
-    // make class move-only
-    json_sax_dom_parser(const json_sax_dom_parser&) = delete;
-    json_sax_dom_parser(json_sax_dom_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    json_sax_dom_parser& operator=(const json_sax_dom_parser&) = delete;
-    json_sax_dom_parser& operator=(json_sax_dom_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    ~json_sax_dom_parser() = default;
-
-    bool null()
-    {
-        handle_value(nullptr);
-        return true;
-    }
-
-    bool boolean(bool val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool number_integer(number_integer_t val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool number_unsigned(number_unsigned_t val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool number_float(number_float_t val, const string_t& /*unused*/)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool string(string_t& val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool binary(binary_t& val)
-    {
-        handle_value(std::move(val));
-        return true;
-    }
-
-    bool start_object(std::size_t len)
-    {
-        ref_stack.push_back(handle_value(BasicJsonType::value_t::object));
-
-        if (JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
-        {
-            JSON_THROW(out_of_range::create(408, "excessive object size: " + std::to_string(len), *ref_stack.back()));
-        }
-
-        return true;
-    }
-
-    bool key(string_t& val)
-    {
-        // add null at given key and store the reference for later
-        object_element = &(ref_stack.back()->m_value.object->operator[](val));
-        return true;
-    }
-
-    bool end_object()
-    {
-        ref_stack.back()->set_parents();
-        ref_stack.pop_back();
-        return true;
-    }
-
-    bool start_array(std::size_t len)
-    {
-        ref_stack.push_back(handle_value(BasicJsonType::value_t::array));
-
-        if (JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
-        {
-            JSON_THROW(out_of_range::create(408, "excessive array size: " + std::to_string(len), *ref_stack.back()));
-        }
-
-        return true;
-    }
-
-    bool end_array()
-    {
-        ref_stack.back()->set_parents();
-        ref_stack.pop_back();
-        return true;
-    }
-
-    template<class Exception>
-    bool parse_error(std::size_t /*unused*/, const std::string& /*unused*/,
-                     const Exception& ex)
-    {
-        errored = true;
-        static_cast<void>(ex);
-        if (allow_exceptions)
-        {
-            JSON_THROW(ex);
-        }
-        return false;
-    }
-
-    constexpr bool is_errored() const
-    {
-        return errored;
-    }
-
-  private:
-    /*!
-    @invariant If the ref stack is empty, then the passed value will be the new
-               root.
-    @invariant If the ref stack contains a value, then it is an array or an
-               object to which we can add elements
-    */
-    template<typename Value>
-    JSON_HEDLEY_RETURNS_NON_NULL
-    BasicJsonType* handle_value(Value&& v)
-    {
-        if (ref_stack.empty())
-        {
-            root = BasicJsonType(std::forward<Value>(v));
-            return &root;
-        }
-
-        JSON_ASSERT(ref_stack.back()->is_array() || ref_stack.back()->is_object());
-
-        if (ref_stack.back()->is_array())
-        {
-            ref_stack.back()->m_value.array->emplace_back(std::forward<Value>(v));
-            return &(ref_stack.back()->m_value.array->back());
-        }
-
-        JSON_ASSERT(ref_stack.back()->is_object());
-        JSON_ASSERT(object_element);
-        *object_element = BasicJsonType(std::forward<Value>(v));
-        return object_element;
-    }
-
-    /// the parsed JSON value
-    BasicJsonType& root;
-    /// stack to model hierarchy of values
-    std::vector<BasicJsonType*> ref_stack {};
-    /// helper to hold the reference for the next object element
-    BasicJsonType* object_element = nullptr;
-    /// whether a syntax error occurred
-    bool errored = false;
-    /// whether to throw exceptions in case of errors
-    const bool allow_exceptions = true;
-};
-
-template<typename BasicJsonType>
-class json_sax_dom_callback_parser
-{
-  public:
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-    using parser_callback_t = typename BasicJsonType::parser_callback_t;
-    using parse_event_t = typename BasicJsonType::parse_event_t;
-
-    json_sax_dom_callback_parser(BasicJsonType& r,
-                                 const parser_callback_t cb,
-                                 const bool allow_exceptions_ = true)
-        : root(r), callback(cb), allow_exceptions(allow_exceptions_)
-    {
-        keep_stack.push_back(true);
-    }
-
-    // make class move-only
-    json_sax_dom_callback_parser(const json_sax_dom_callback_parser&) = delete;
-    json_sax_dom_callback_parser(json_sax_dom_callback_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    json_sax_dom_callback_parser& operator=(const json_sax_dom_callback_parser&) = delete;
-    json_sax_dom_callback_parser& operator=(json_sax_dom_callback_parser&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    ~json_sax_dom_callback_parser() = default;
-
-    bool null()
-    {
-        handle_value(nullptr);
-        return true;
-    }
-
-    bool boolean(bool val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool number_integer(number_integer_t val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool number_unsigned(number_unsigned_t val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool number_float(number_float_t val, const string_t& /*unused*/)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool string(string_t& val)
-    {
-        handle_value(val);
-        return true;
-    }
-
-    bool binary(binary_t& val)
-    {
-        handle_value(std::move(val));
-        return true;
-    }
-
-    bool start_object(std::size_t len)
-    {
-        // check callback for object start
-        const bool keep = callback(static_cast<int>(ref_stack.size()), parse_event_t::object_start, discarded);
-        keep_stack.push_back(keep);
-
-        auto val = handle_value(BasicJsonType::value_t::object, true);
-        ref_stack.push_back(val.second);
-
-        // check object limit
-        if (ref_stack.back() && JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
-        {
-            JSON_THROW(out_of_range::create(408, "excessive object size: " + std::to_string(len), *ref_stack.back()));
-        }
-
-        return true;
-    }
-
-    bool key(string_t& val)
-    {
-        BasicJsonType k = BasicJsonType(val);
-
-        // check callback for key
-        const bool keep = callback(static_cast<int>(ref_stack.size()), parse_event_t::key, k);
-        key_keep_stack.push_back(keep);
-
-        // add discarded value at given key and store the reference for later
-        if (keep && ref_stack.back())
-        {
-            object_element = &(ref_stack.back()->m_value.object->operator[](val) = discarded);
-        }
-
-        return true;
-    }
-
-    bool end_object()
-    {
-        if (ref_stack.back())
-        {
-            if (!callback(static_cast<int>(ref_stack.size()) - 1, parse_event_t::object_end, *ref_stack.back()))
-            {
-                // discard object
-                *ref_stack.back() = discarded;
-            }
-            else
-            {
-                ref_stack.back()->set_parents();
-            }
-        }
-
-        JSON_ASSERT(!ref_stack.empty());
-        JSON_ASSERT(!keep_stack.empty());
-        ref_stack.pop_back();
-        keep_stack.pop_back();
-
-        if (!ref_stack.empty() && ref_stack.back() && ref_stack.back()->is_structured())
-        {
-            // remove discarded value
-            for (auto it = ref_stack.back()->begin(); it != ref_stack.back()->end(); ++it)
-            {
-                if (it->is_discarded())
-                {
-                    ref_stack.back()->erase(it);
-                    break;
-                }
-            }
-        }
-
-        return true;
-    }
-
-    bool start_array(std::size_t len)
-    {
-        const bool keep = callback(static_cast<int>(ref_stack.size()), parse_event_t::array_start, discarded);
-        keep_stack.push_back(keep);
-
-        auto val = handle_value(BasicJsonType::value_t::array, true);
-        ref_stack.push_back(val.second);
-
-        // check array limit
-        if (ref_stack.back() && JSON_HEDLEY_UNLIKELY(len != static_cast<std::size_t>(-1) && len > ref_stack.back()->max_size()))
-        {
-            JSON_THROW(out_of_range::create(408, "excessive array size: " + std::to_string(len), *ref_stack.back()));
-        }
-
-        return true;
-    }
-
-    bool end_array()
-    {
-        bool keep = true;
-
-        if (ref_stack.back())
-        {
-            keep = callback(static_cast<int>(ref_stack.size()) - 1, parse_event_t::array_end, *ref_stack.back());
-            if (keep)
-            {
-                ref_stack.back()->set_parents();
-            }
-            else
-            {
-                // discard array
-                *ref_stack.back() = discarded;
-            }
-        }
-
-        JSON_ASSERT(!ref_stack.empty());
-        JSON_ASSERT(!keep_stack.empty());
-        ref_stack.pop_back();
-        keep_stack.pop_back();
-
-        // remove discarded value
-        if (!keep && !ref_stack.empty() && ref_stack.back()->is_array())
-        {
-            ref_stack.back()->m_value.array->pop_back();
-        }
-
-        return true;
-    }
-
-    template<class Exception>
-    bool parse_error(std::size_t /*unused*/, const std::string& /*unused*/,
-                     const Exception& ex)
-    {
-        errored = true;
-        static_cast<void>(ex);
-        if (allow_exceptions)
-        {
-            JSON_THROW(ex);
-        }
-        return false;
-    }
-
-    constexpr bool is_errored() const
-    {
-        return errored;
-    }
-
-  private:
-    /*!
-    @param[in] v  value to add to the JSON value we build during parsing
-    @param[in] skip_callback  whether we should skip calling the callback
-               function; this is required after start_array() and
-               start_object() SAX events, because otherwise we would call the
-               callback function with an empty array or object, respectively.
-
-    @invariant If the ref stack is empty, then the passed value will be the new
-               root.
-    @invariant If the ref stack contains a value, then it is an array or an
-               object to which we can add elements
-
-    @return pair of boolean (whether value should be kept) and pointer (to the
-            passed value in the ref_stack hierarchy; nullptr if not kept)
-    */
-    template<typename Value>
-    std::pair<bool, BasicJsonType*> handle_value(Value&& v, const bool skip_callback = false)
-    {
-        JSON_ASSERT(!keep_stack.empty());
-
-        // do not handle this value if we know it would be added to a discarded
-        // container
-        if (!keep_stack.back())
-        {
-            return {false, nullptr};
-        }
-
-        // create value
-        auto value = BasicJsonType(std::forward<Value>(v));
-
-        // check callback
-        const bool keep = skip_callback || callback(static_cast<int>(ref_stack.size()), parse_event_t::value, value);
-
-        // do not handle this value if we just learnt it shall be discarded
-        if (!keep)
-        {
-            return {false, nullptr};
-        }
-
-        if (ref_stack.empty())
-        {
-            root = std::move(value);
-            return {true, &root};
-        }
-
-        // skip this value if we already decided to skip the parent
-        // (https://github.com/nlohmann/json/issues/971#issuecomment-413678360)
-        if (!ref_stack.back())
-        {
-            return {false, nullptr};
-        }
-
-        // we now only expect arrays and objects
-        JSON_ASSERT(ref_stack.back()->is_array() || ref_stack.back()->is_object());
-
-        // array
-        if (ref_stack.back()->is_array())
-        {
-            ref_stack.back()->m_value.array->emplace_back(std::move(value));
-            return {true, &(ref_stack.back()->m_value.array->back())};
-        }
-
-        // object
-        JSON_ASSERT(ref_stack.back()->is_object());
-        // check if we should store an element for the current key
-        JSON_ASSERT(!key_keep_stack.empty());
-        const bool store_element = key_keep_stack.back();
-        key_keep_stack.pop_back();
-
-        if (!store_element)
-        {
-            return {false, nullptr};
-        }
-
-        JSON_ASSERT(object_element);
-        *object_element = std::move(value);
-        return {true, object_element};
-    }
-
-    /// the parsed JSON value
-    BasicJsonType& root;
-    /// stack to model hierarchy of values
-    std::vector<BasicJsonType*> ref_stack {};
-    /// stack to manage which values to keep
-    std::vector<bool> keep_stack {};
-    /// stack to manage which object keys to keep
-    std::vector<bool> key_keep_stack {};
-    /// helper to hold the reference for the next object element
-    BasicJsonType* object_element = nullptr;
-    /// whether a syntax error occurred
-    bool errored = false;
-    /// callback function
-    const parser_callback_t callback = nullptr;
-    /// whether to throw exceptions in case of errors
-    const bool allow_exceptions = true;
-    /// a discarded value for the callback
-    BasicJsonType discarded = BasicJsonType::value_t::discarded;
-};
-
-template<typename BasicJsonType>
-class json_sax_acceptor
-{
-  public:
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-
-    bool null()
-    {
-        return true;
-    }
-
-    bool boolean(bool /*unused*/)
-    {
-        return true;
-    }
-
-    bool number_integer(number_integer_t /*unused*/)
-    {
-        return true;
-    }
-
-    bool number_unsigned(number_unsigned_t /*unused*/)
-    {
-        return true;
-    }
-
-    bool number_float(number_float_t /*unused*/, const string_t& /*unused*/)
-    {
-        return true;
-    }
-
-    bool string(string_t& /*unused*/)
-    {
-        return true;
-    }
-
-    bool binary(binary_t& /*unused*/)
-    {
-        return true;
-    }
-
-    bool start_object(std::size_t /*unused*/ = static_cast<std::size_t>(-1))
-    {
-        return true;
-    }
-
-    bool key(string_t& /*unused*/)
-    {
-        return true;
-    }
-
-    bool end_object()
-    {
-        return true;
-    }
-
-    bool start_array(std::size_t /*unused*/ = static_cast<std::size_t>(-1))
-    {
-        return true;
-    }
-
-    bool end_array()
-    {
-        return true;
-    }
-
-    bool parse_error(std::size_t /*unused*/, const std::string& /*unused*/, const detail::exception& /*unused*/)
-    {
-        return false;
-    }
-};
-}  // namespace detail
-
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/input/lexer.hpp>
-
-
-#include <array> // array
-#include <clocale> // localeconv
-#include <cstddef> // size_t
-#include <cstdio> // snprintf
-#include <cstdlib> // strtof, strtod, strtold, strtoll, strtoull
-#include <initializer_list> // initializer_list
-#include <string> // char_traits, string
-#include <utility> // move
-#include <vector> // vector
-
-// #include <nlohmann/detail/input/input_adapters.hpp>
-
-// #include <nlohmann/detail/input/position_t.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-///////////
-// lexer //
-///////////
-
-template<typename BasicJsonType>
-class lexer_base
-{
-  public:
-    /// token types for the parser
-    enum class token_type
-    {
-        uninitialized,    ///< indicating the scanner is uninitialized
-        literal_true,     ///< the `true` literal
-        literal_false,    ///< the `false` literal
-        literal_null,     ///< the `null` literal
-        value_string,     ///< a string -- use get_string() for actual value
-        value_unsigned,   ///< an unsigned integer -- use get_number_unsigned() for actual value
-        value_integer,    ///< a signed integer -- use get_number_integer() for actual value
-        value_float,      ///< an floating point number -- use get_number_float() for actual value
-        begin_array,      ///< the character for array begin `[`
-        begin_object,     ///< the character for object begin `{`
-        end_array,        ///< the character for array end `]`
-        end_object,       ///< the character for object end `}`
-        name_separator,   ///< the name separator `:`
-        value_separator,  ///< the value separator `,`
-        parse_error,      ///< indicating a parse error
-        end_of_input,     ///< indicating the end of the input buffer
-        literal_or_value  ///< a literal or the begin of a value (only for diagnostics)
-    };
-
-    /// return name of values of type token_type (only used for errors)
-    JSON_HEDLEY_RETURNS_NON_NULL
-    JSON_HEDLEY_CONST
-    static const char* token_type_name(const token_type t) noexcept
-    {
-        switch (t)
-        {
-            case token_type::uninitialized:
-                return "<uninitialized>";
-            case token_type::literal_true:
-                return "true literal";
-            case token_type::literal_false:
-                return "false literal";
-            case token_type::literal_null:
-                return "null literal";
-            case token_type::value_string:
-                return "string literal";
-            case token_type::value_unsigned:
-            case token_type::value_integer:
-            case token_type::value_float:
-                return "number literal";
-            case token_type::begin_array:
-                return "'['";
-            case token_type::begin_object:
-                return "'{'";
-            case token_type::end_array:
-                return "']'";
-            case token_type::end_object:
-                return "'}'";
-            case token_type::name_separator:
-                return "':'";
-            case token_type::value_separator:
-                return "','";
-            case token_type::parse_error:
-                return "<parse error>";
-            case token_type::end_of_input:
-                return "end of input";
-            case token_type::literal_or_value:
-                return "'[', '{', or a literal";
-            // LCOV_EXCL_START
-            default: // catch non-enum values
-                return "unknown token";
-                // LCOV_EXCL_STOP
-        }
-    }
-};
-/*!
-@brief lexical analysis
-
-This class organizes the lexical analysis during JSON deserialization.
-*/
-template<typename BasicJsonType, typename InputAdapterType>
-class lexer : public lexer_base<BasicJsonType>
-{
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using char_type = typename InputAdapterType::char_type;
-    using char_int_type = typename std::char_traits<char_type>::int_type;
-
-  public:
-    using token_type = typename lexer_base<BasicJsonType>::token_type;
-
-    explicit lexer(InputAdapterType&& adapter, bool ignore_comments_ = false) noexcept
-        : ia(std::move(adapter))
-        , ignore_comments(ignore_comments_)
-        , decimal_point_char(static_cast<char_int_type>(get_decimal_point()))
-    {}
-
-    // delete because of pointer members
-    lexer(const lexer&) = delete;
-    lexer(lexer&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    lexer& operator=(lexer&) = delete;
-    lexer& operator=(lexer&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    ~lexer() = default;
-
-  private:
-    /////////////////////
-    // locales
-    /////////////////////
-
-    /// return the locale-dependent decimal point
-    JSON_HEDLEY_PURE
-    static char get_decimal_point() noexcept
-    {
-        const auto* loc = localeconv();
-        JSON_ASSERT(loc != nullptr);
-        return (loc->decimal_point == nullptr) ? '.' : *(loc->decimal_point);
-    }
-
-    /////////////////////
-    // scan functions
-    /////////////////////
-
-    /*!
-    @brief get codepoint from 4 hex characters following `\u`
-
-    For input "\u c1 c2 c3 c4" the codepoint is:
-      (c1 * 0x1000) + (c2 * 0x0100) + (c3 * 0x0010) + c4
-    = (c1 << 12) + (c2 << 8) + (c3 << 4) + (c4 << 0)
-
-    Furthermore, the possible characters '0'..'9', 'A'..'F', and 'a'..'f'
-    must be converted to the integers 0x0..0x9, 0xA..0xF, 0xA..0xF, resp. The
-    conversion is done by subtracting the offset (0x30, 0x37, and 0x57)
-    between the ASCII value of the character and the desired integer value.
-
-    @return codepoint (0x0000..0xFFFF) or -1 in case of an error (e.g. EOF or
-            non-hex character)
-    */
-    int get_codepoint()
-    {
-        // this function only makes sense after reading `\u`
-        JSON_ASSERT(current == 'u');
-        int codepoint = 0;
-
-        const auto factors = { 12u, 8u, 4u, 0u };
-        for (const auto factor : factors)
-        {
-            get();
-
-            if (current >= '0' && current <= '9')
-            {
-                codepoint += static_cast<int>((static_cast<unsigned int>(current) - 0x30u) << factor);
-            }
-            else if (current >= 'A' && current <= 'F')
-            {
-                codepoint += static_cast<int>((static_cast<unsigned int>(current) - 0x37u) << factor);
-            }
-            else if (current >= 'a' && current <= 'f')
-            {
-                codepoint += static_cast<int>((static_cast<unsigned int>(current) - 0x57u) << factor);
-            }
-            else
-            {
-                return -1;
-            }
-        }
-
-        JSON_ASSERT(0x0000 <= codepoint && codepoint <= 0xFFFF);
-        return codepoint;
-    }
-
-    /*!
-    @brief check if the next byte(s) are inside a given range
-
-    Adds the current byte and, for each passed range, reads a new byte and
-    checks if it is inside the range. If a violation was detected, set up an
-    error message and return false. Otherwise, return true.
-
-    @param[in] ranges  list of integers; interpreted as list of pairs of
-                       inclusive lower and upper bound, respectively
-
-    @pre The passed list @a ranges must have 2, 4, or 6 elements; that is,
-         1, 2, or 3 pairs. This precondition is enforced by an assertion.
-
-    @return true if and only if no range violation was detected
-    */
-    bool next_byte_in_range(std::initializer_list<char_int_type> ranges)
-    {
-        JSON_ASSERT(ranges.size() == 2 || ranges.size() == 4 || ranges.size() == 6);
-        add(current);
-
-        for (auto range = ranges.begin(); range != ranges.end(); ++range)
-        {
-            get();
-            if (JSON_HEDLEY_LIKELY(*range <= current && current <= *(++range)))
-            {
-                add(current);
-            }
-            else
-            {
-                error_message = "invalid string: ill-formed UTF-8 byte";
-                return false;
-            }
-        }
-
-        return true;
-    }
-
-    /*!
-    @brief scan a string literal
-
-    This function scans a string according to Sect. 7 of RFC 8259. While
-    scanning, bytes are escaped and copied into buffer token_buffer. Then the
-    function returns successfully, token_buffer is *not* null-terminated (as it
-    may contain \0 bytes), and token_buffer.size() is the number of bytes in the
-    string.
-
-    @return token_type::value_string if string could be successfully scanned,
-            token_type::parse_error otherwise
-
-    @note In case of errors, variable error_message contains a textual
-          description.
-    */
-    token_type scan_string()
-    {
-        // reset token_buffer (ignore opening quote)
-        reset();
-
-        // we entered the function by reading an open quote
-        JSON_ASSERT(current == '\"');
-
-        while (true)
-        {
-            // get next character
-            switch (get())
-            {
-                // end of file while parsing string
-                case std::char_traits<char_type>::eof():
-                {
-                    error_message = "invalid string: missing closing quote";
-                    return token_type::parse_error;
-                }
-
-                // closing quote
-                case '\"':
-                {
-                    return token_type::value_string;
-                }
-
-                // escapes
-                case '\\':
-                {
-                    switch (get())
-                    {
-                        // quotation mark
-                        case '\"':
-                            add('\"');
-                            break;
-                        // reverse solidus
-                        case '\\':
-                            add('\\');
-                            break;
-                        // solidus
-                        case '/':
-                            add('/');
-                            break;
-                        // backspace
-                        case 'b':
-                            add('\b');
-                            break;
-                        // form feed
-                        case 'f':
-                            add('\f');
-                            break;
-                        // line feed
-                        case 'n':
-                            add('\n');
-                            break;
-                        // carriage return
-                        case 'r':
-                            add('\r');
-                            break;
-                        // tab
-                        case 't':
-                            add('\t');
-                            break;
-
-                        // unicode escapes
-                        case 'u':
-                        {
-                            const int codepoint1 = get_codepoint();
-                            int codepoint = codepoint1; // start with codepoint1
-
-                            if (JSON_HEDLEY_UNLIKELY(codepoint1 == -1))
-                            {
-                                error_message = "invalid string: '\\u' must be followed by 4 hex digits";
-                                return token_type::parse_error;
-                            }
-
-                            // check if code point is a high surrogate
-                            if (0xD800 <= codepoint1 && codepoint1 <= 0xDBFF)
-                            {
-                                // expect next \uxxxx entry
-                                if (JSON_HEDLEY_LIKELY(get() == '\\' && get() == 'u'))
-                                {
-                                    const int codepoint2 = get_codepoint();
-
-                                    if (JSON_HEDLEY_UNLIKELY(codepoint2 == -1))
-                                    {
-                                        error_message = "invalid string: '\\u' must be followed by 4 hex digits";
-                                        return token_type::parse_error;
-                                    }
-
-                                    // check if codepoint2 is a low surrogate
-                                    if (JSON_HEDLEY_LIKELY(0xDC00 <= codepoint2 && codepoint2 <= 0xDFFF))
-                                    {
-                                        // overwrite codepoint
-                                        codepoint = static_cast<int>(
-                                                        // high surrogate occupies the most significant 22 bits
-                                                        (static_cast<unsigned int>(codepoint1) << 10u)
-                                                        // low surrogate occupies the least significant 15 bits
-                                                        + static_cast<unsigned int>(codepoint2)
-                                                        // there is still the 0xD800, 0xDC00 and 0x10000 noise
-                                                        // in the result, so we have to subtract with:
-                                                        // (0xD800 << 10) + DC00 - 0x10000 = 0x35FDC00
-                                                        - 0x35FDC00u);
-                                    }
-                                    else
-                                    {
-                                        error_message = "invalid string: surrogate U+D800..U+DBFF must be followed by U+DC00..U+DFFF";
-                                        return token_type::parse_error;
-                                    }
-                                }
-                                else
-                                {
-                                    error_message = "invalid string: surrogate U+D800..U+DBFF must be followed by U+DC00..U+DFFF";
-                                    return token_type::parse_error;
-                                }
-                            }
-                            else
-                            {
-                                if (JSON_HEDLEY_UNLIKELY(0xDC00 <= codepoint1 && codepoint1 <= 0xDFFF))
-                                {
-                                    error_message = "invalid string: surrogate U+DC00..U+DFFF must follow U+D800..U+DBFF";
-                                    return token_type::parse_error;
-                                }
-                            }
-
-                            // result of the above calculation yields a proper codepoint
-                            JSON_ASSERT(0x00 <= codepoint && codepoint <= 0x10FFFF);
-
-                            // translate codepoint into bytes
-                            if (codepoint < 0x80)
-                            {
-                                // 1-byte characters: 0xxxxxxx (ASCII)
-                                add(static_cast<char_int_type>(codepoint));
-                            }
-                            else if (codepoint <= 0x7FF)
-                            {
-                                // 2-byte characters: 110xxxxx 10xxxxxx
-                                add(static_cast<char_int_type>(0xC0u | (static_cast<unsigned int>(codepoint) >> 6u)));
-                                add(static_cast<char_int_type>(0x80u | (static_cast<unsigned int>(codepoint) & 0x3Fu)));
-                            }
-                            else if (codepoint <= 0xFFFF)
-                            {
-                                // 3-byte characters: 1110xxxx 10xxxxxx 10xxxxxx
-                                add(static_cast<char_int_type>(0xE0u | (static_cast<unsigned int>(codepoint) >> 12u)));
-                                add(static_cast<char_int_type>(0x80u | ((static_cast<unsigned int>(codepoint) >> 6u) & 0x3Fu)));
-                                add(static_cast<char_int_type>(0x80u | (static_cast<unsigned int>(codepoint) & 0x3Fu)));
-                            }
-                            else
-                            {
-                                // 4-byte characters: 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
-                                add(static_cast<char_int_type>(0xF0u | (static_cast<unsigned int>(codepoint) >> 18u)));
-                                add(static_cast<char_int_type>(0x80u | ((static_cast<unsigned int>(codepoint) >> 12u) & 0x3Fu)));
-                                add(static_cast<char_int_type>(0x80u | ((static_cast<unsigned int>(codepoint) >> 6u) & 0x3Fu)));
-                                add(static_cast<char_int_type>(0x80u | (static_cast<unsigned int>(codepoint) & 0x3Fu)));
-                            }
-
-                            break;
-                        }
-
-                        // other characters after escape
-                        default:
-                            error_message = "invalid string: forbidden character after backslash";
-                            return token_type::parse_error;
-                    }
-
-                    break;
-                }
-
-                // invalid control characters
-                case 0x00:
-                {
-                    error_message = "invalid string: control character U+0000 (NUL) must be escaped to \\u0000";
-                    return token_type::parse_error;
-                }
-
-                case 0x01:
-                {
-                    error_message = "invalid string: control character U+0001 (SOH) must be escaped to \\u0001";
-                    return token_type::parse_error;
-                }
-
-                case 0x02:
-                {
-                    error_message = "invalid string: control character U+0002 (STX) must be escaped to \\u0002";
-                    return token_type::parse_error;
-                }
-
-                case 0x03:
-                {
-                    error_message = "invalid string: control character U+0003 (ETX) must be escaped to \\u0003";
-                    return token_type::parse_error;
-                }
-
-                case 0x04:
-                {
-                    error_message = "invalid string: control character U+0004 (EOT) must be escaped to \\u0004";
-                    return token_type::parse_error;
-                }
-
-                case 0x05:
-                {
-                    error_message = "invalid string: control character U+0005 (ENQ) must be escaped to \\u0005";
-                    return token_type::parse_error;
-                }
-
-                case 0x06:
-                {
-                    error_message = "invalid string: control character U+0006 (ACK) must be escaped to \\u0006";
-                    return token_type::parse_error;
-                }
-
-                case 0x07:
-                {
-                    error_message = "invalid string: control character U+0007 (BEL) must be escaped to \\u0007";
-                    return token_type::parse_error;
-                }
-
-                case 0x08:
-                {
-                    error_message = "invalid string: control character U+0008 (BS) must be escaped to \\u0008 or \\b";
-                    return token_type::parse_error;
-                }
-
-                case 0x09:
-                {
-                    error_message = "invalid string: control character U+0009 (HT) must be escaped to \\u0009 or \\t";
-                    return token_type::parse_error;
-                }
-
-                case 0x0A:
-                {
-                    error_message = "invalid string: control character U+000A (LF) must be escaped to \\u000A or \\n";
-                    return token_type::parse_error;
-                }
-
-                case 0x0B:
-                {
-                    error_message = "invalid string: control character U+000B (VT) must be escaped to \\u000B";
-                    return token_type::parse_error;
-                }
-
-                case 0x0C:
-                {
-                    error_message = "invalid string: control character U+000C (FF) must be escaped to \\u000C or \\f";
-                    return token_type::parse_error;
-                }
-
-                case 0x0D:
-                {
-                    error_message = "invalid string: control character U+000D (CR) must be escaped to \\u000D or \\r";
-                    return token_type::parse_error;
-                }
-
-                case 0x0E:
-                {
-                    error_message = "invalid string: control character U+000E (SO) must be escaped to \\u000E";
-                    return token_type::parse_error;
-                }
-
-                case 0x0F:
-                {
-                    error_message = "invalid string: control character U+000F (SI) must be escaped to \\u000F";
-                    return token_type::parse_error;
-                }
-
-                case 0x10:
-                {
-                    error_message = "invalid string: control character U+0010 (DLE) must be escaped to \\u0010";
-                    return token_type::parse_error;
-                }
-
-                case 0x11:
-                {
-                    error_message = "invalid string: control character U+0011 (DC1) must be escaped to \\u0011";
-                    return token_type::parse_error;
-                }
-
-                case 0x12:
-                {
-                    error_message = "invalid string: control character U+0012 (DC2) must be escaped to \\u0012";
-                    return token_type::parse_error;
-                }
-
-                case 0x13:
-                {
-                    error_message = "invalid string: control character U+0013 (DC3) must be escaped to \\u0013";
-                    return token_type::parse_error;
-                }
-
-                case 0x14:
-                {
-                    error_message = "invalid string: control character U+0014 (DC4) must be escaped to \\u0014";
-                    return token_type::parse_error;
-                }
-
-                case 0x15:
-                {
-                    error_message = "invalid string: control character U+0015 (NAK) must be escaped to \\u0015";
-                    return token_type::parse_error;
-                }
-
-                case 0x16:
-                {
-                    error_message = "invalid string: control character U+0016 (SYN) must be escaped to \\u0016";
-                    return token_type::parse_error;
-                }
-
-                case 0x17:
-                {
-                    error_message = "invalid string: control character U+0017 (ETB) must be escaped to \\u0017";
-                    return token_type::parse_error;
-                }
-
-                case 0x18:
-                {
-                    error_message = "invalid string: control character U+0018 (CAN) must be escaped to \\u0018";
-                    return token_type::parse_error;
-                }
-
-                case 0x19:
-                {
-                    error_message = "invalid string: control character U+0019 (EM) must be escaped to \\u0019";
-                    return token_type::parse_error;
-                }
-
-                case 0x1A:
-                {
-                    error_message = "invalid string: control character U+001A (SUB) must be escaped to \\u001A";
-                    return token_type::parse_error;
-                }
-
-                case 0x1B:
-                {
-                    error_message = "invalid string: control character U+001B (ESC) must be escaped to \\u001B";
-                    return token_type::parse_error;
-                }
-
-                case 0x1C:
-                {
-                    error_message = "invalid string: control character U+001C (FS) must be escaped to \\u001C";
-                    return token_type::parse_error;
-                }
-
-                case 0x1D:
-                {
-                    error_message = "invalid string: control character U+001D (GS) must be escaped to \\u001D";
-                    return token_type::parse_error;
-                }
-
-                case 0x1E:
-                {
-                    error_message = "invalid string: control character U+001E (RS) must be escaped to \\u001E";
-                    return token_type::parse_error;
-                }
-
-                case 0x1F:
-                {
-                    error_message = "invalid string: control character U+001F (US) must be escaped to \\u001F";
-                    return token_type::parse_error;
-                }
-
-                // U+0020..U+007F (except U+0022 (quote) and U+005C (backspace))
-                case 0x20:
-                case 0x21:
-                case 0x23:
-                case 0x24:
-                case 0x25:
-                case 0x26:
-                case 0x27:
-                case 0x28:
-                case 0x29:
-                case 0x2A:
-                case 0x2B:
-                case 0x2C:
-                case 0x2D:
-                case 0x2E:
-                case 0x2F:
-                case 0x30:
-                case 0x31:
-                case 0x32:
-                case 0x33:
-                case 0x34:
-                case 0x35:
-                case 0x36:
-                case 0x37:
-                case 0x38:
-                case 0x39:
-                case 0x3A:
-                case 0x3B:
-                case 0x3C:
-                case 0x3D:
-                case 0x3E:
-                case 0x3F:
-                case 0x40:
-                case 0x41:
-                case 0x42:
-                case 0x43:
-                case 0x44:
-                case 0x45:
-                case 0x46:
-                case 0x47:
-                case 0x48:
-                case 0x49:
-                case 0x4A:
-                case 0x4B:
-                case 0x4C:
-                case 0x4D:
-                case 0x4E:
-                case 0x4F:
-                case 0x50:
-                case 0x51:
-                case 0x52:
-                case 0x53:
-                case 0x54:
-                case 0x55:
-                case 0x56:
-                case 0x57:
-                case 0x58:
-                case 0x59:
-                case 0x5A:
-                case 0x5B:
-                case 0x5D:
-                case 0x5E:
-                case 0x5F:
-                case 0x60:
-                case 0x61:
-                case 0x62:
-                case 0x63:
-                case 0x64:
-                case 0x65:
-                case 0x66:
-                case 0x67:
-                case 0x68:
-                case 0x69:
-                case 0x6A:
-                case 0x6B:
-                case 0x6C:
-                case 0x6D:
-                case 0x6E:
-                case 0x6F:
-                case 0x70:
-                case 0x71:
-                case 0x72:
-                case 0x73:
-                case 0x74:
-                case 0x75:
-                case 0x76:
-                case 0x77:
-                case 0x78:
-                case 0x79:
-                case 0x7A:
-                case 0x7B:
-                case 0x7C:
-                case 0x7D:
-                case 0x7E:
-                case 0x7F:
-                {
-                    add(current);
-                    break;
-                }
-
-                // U+0080..U+07FF: bytes C2..DF 80..BF
-                case 0xC2:
-                case 0xC3:
-                case 0xC4:
-                case 0xC5:
-                case 0xC6:
-                case 0xC7:
-                case 0xC8:
-                case 0xC9:
-                case 0xCA:
-                case 0xCB:
-                case 0xCC:
-                case 0xCD:
-                case 0xCE:
-                case 0xCF:
-                case 0xD0:
-                case 0xD1:
-                case 0xD2:
-                case 0xD3:
-                case 0xD4:
-                case 0xD5:
-                case 0xD6:
-                case 0xD7:
-                case 0xD8:
-                case 0xD9:
-                case 0xDA:
-                case 0xDB:
-                case 0xDC:
-                case 0xDD:
-                case 0xDE:
-                case 0xDF:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!next_byte_in_range({0x80, 0xBF})))
-                    {
-                        return token_type::parse_error;
-                    }
-                    break;
-                }
-
-                // U+0800..U+0FFF: bytes E0 A0..BF 80..BF
-                case 0xE0:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0xA0, 0xBF, 0x80, 0xBF}))))
-                    {
-                        return token_type::parse_error;
-                    }
-                    break;
-                }
-
-                // U+1000..U+CFFF: bytes E1..EC 80..BF 80..BF
-                // U+E000..U+FFFF: bytes EE..EF 80..BF 80..BF
-                case 0xE1:
-                case 0xE2:
-                case 0xE3:
-                case 0xE4:
-                case 0xE5:
-                case 0xE6:
-                case 0xE7:
-                case 0xE8:
-                case 0xE9:
-                case 0xEA:
-                case 0xEB:
-                case 0xEC:
-                case 0xEE:
-                case 0xEF:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0xBF, 0x80, 0xBF}))))
-                    {
-                        return token_type::parse_error;
-                    }
-                    break;
-                }
-
-                // U+D000..U+D7FF: bytes ED 80..9F 80..BF
-                case 0xED:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0x9F, 0x80, 0xBF}))))
-                    {
-                        return token_type::parse_error;
-                    }
-                    break;
-                }
-
-                // U+10000..U+3FFFF F0 90..BF 80..BF 80..BF
-                case 0xF0:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x90, 0xBF, 0x80, 0xBF, 0x80, 0xBF}))))
-                    {
-                        return token_type::parse_error;
-                    }
-                    break;
-                }
-
-                // U+40000..U+FFFFF F1..F3 80..BF 80..BF 80..BF
-                case 0xF1:
-                case 0xF2:
-                case 0xF3:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0xBF, 0x80, 0xBF, 0x80, 0xBF}))))
-                    {
-                        return token_type::parse_error;
-                    }
-                    break;
-                }
-
-                // U+100000..U+10FFFF F4 80..8F 80..BF 80..BF
-                case 0xF4:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!(next_byte_in_range({0x80, 0x8F, 0x80, 0xBF, 0x80, 0xBF}))))
-                    {
-                        return token_type::parse_error;
-                    }
-                    break;
-                }
-
-                // remaining bytes (80..C1 and F5..FF) are ill-formed
-                default:
-                {
-                    error_message = "invalid string: ill-formed UTF-8 byte";
-                    return token_type::parse_error;
-                }
-            }
-        }
-    }
-
-    /*!
-     * @brief scan a comment
-     * @return whether comment could be scanned successfully
-     */
-    bool scan_comment()
-    {
-        switch (get())
-        {
-            // single-line comments skip input until a newline or EOF is read
-            case '/':
-            {
-                while (true)
-                {
-                    switch (get())
-                    {
-                        case '\n':
-                        case '\r':
-                        case std::char_traits<char_type>::eof():
-                        case '\0':
-                            return true;
-
-                        default:
-                            break;
-                    }
-                }
-            }
-
-            // multi-line comments skip input until */ is read
-            case '*':
-            {
-                while (true)
-                {
-                    switch (get())
-                    {
-                        case std::char_traits<char_type>::eof():
-                        case '\0':
-                        {
-                            error_message = "invalid comment; missing closing '*/'";
-                            return false;
-                        }
-
-                        case '*':
-                        {
-                            switch (get())
-                            {
-                                case '/':
-                                    return true;
-
-                                default:
-                                {
-                                    unget();
-                                    continue;
-                                }
-                            }
-                        }
-
-                        default:
-                            continue;
-                    }
-                }
-            }
-
-            // unexpected character after reading '/'
-            default:
-            {
-                error_message = "invalid comment; expecting '/' or '*' after '/'";
-                return false;
-            }
-        }
-    }
-
-    JSON_HEDLEY_NON_NULL(2)
-    static void strtof(float& f, const char* str, char** endptr) noexcept
-    {
-        f = std::strtof(str, endptr);
-    }
-
-    JSON_HEDLEY_NON_NULL(2)
-    static void strtof(double& f, const char* str, char** endptr) noexcept
-    {
-        f = std::strtod(str, endptr);
-    }
-
-    JSON_HEDLEY_NON_NULL(2)
-    static void strtof(long double& f, const char* str, char** endptr) noexcept
-    {
-        f = std::strtold(str, endptr);
-    }
-
-    /*!
-    @brief scan a number literal
-
-    This function scans a string according to Sect. 6 of RFC 8259.
-
-    The function is realized with a deterministic finite state machine derived
-    from the grammar described in RFC 8259. Starting in state "init", the
-    input is read and used to determined the next state. Only state "done"
-    accepts the number. State "error" is a trap state to model errors. In the
-    table below, "anything" means any character but the ones listed before.
-
-    state    | 0        | 1-9      | e E      | +       | -       | .        | anything
-    ---------|----------|----------|----------|---------|---------|----------|-----------
-    init     | zero     | any1     | [error]  | [error] | minus   | [error]  | [error]
-    minus    | zero     | any1     | [error]  | [error] | [error] | [error]  | [error]
-    zero     | done     | done     | exponent | done    | done    | decimal1 | done
-    any1     | any1     | any1     | exponent | done    | done    | decimal1 | done
-    decimal1 | decimal2 | decimal2 | [error]  | [error] | [error] | [error]  | [error]
-    decimal2 | decimal2 | decimal2 | exponent | done    | done    | done     | done
-    exponent | any2     | any2     | [error]  | sign    | sign    | [error]  | [error]
-    sign     | any2     | any2     | [error]  | [error] | [error] | [error]  | [error]
-    any2     | any2     | any2     | done     | done    | done    | done     | done
-
-    The state machine is realized with one label per state (prefixed with
-    "scan_number_") and `goto` statements between them. The state machine
-    contains cycles, but any cycle can be left when EOF is read. Therefore,
-    the function is guaranteed to terminate.
-
-    During scanning, the read bytes are stored in token_buffer. This string is
-    then converted to a signed integer, an unsigned integer, or a
-    floating-point number.
-
-    @return token_type::value_unsigned, token_type::value_integer, or
-            token_type::value_float if number could be successfully scanned,
-            token_type::parse_error otherwise
-
-    @note The scanner is independent of the current locale. Internally, the
-          locale's decimal point is used instead of `.` to work with the
-          locale-dependent converters.
-    */
-    token_type scan_number()  // lgtm [cpp/use-of-goto]
-    {
-        // reset token_buffer to store the number's bytes
-        reset();
-
-        // the type of the parsed number; initially set to unsigned; will be
-        // changed if minus sign, decimal point or exponent is read
-        token_type number_type = token_type::value_unsigned;
-
-        // state (init): we just found out we need to scan a number
-        switch (current)
-        {
-            case '-':
-            {
-                add(current);
-                goto scan_number_minus;
-            }
-
-            case '0':
-            {
-                add(current);
-                goto scan_number_zero;
-            }
-
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_any1;
-            }
-
-            // all other characters are rejected outside scan_number()
-            default:            // LCOV_EXCL_LINE
-                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-        }
-
-scan_number_minus:
-        // state: we just parsed a leading minus sign
-        number_type = token_type::value_integer;
-        switch (get())
-        {
-            case '0':
-            {
-                add(current);
-                goto scan_number_zero;
-            }
-
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_any1;
-            }
-
-            default:
-            {
-                error_message = "invalid number; expected digit after '-'";
-                return token_type::parse_error;
-            }
-        }
-
-scan_number_zero:
-        // state: we just parse a zero (maybe with a leading minus sign)
-        switch (get())
-        {
-            case '.':
-            {
-                add(decimal_point_char);
-                goto scan_number_decimal1;
-            }
-
-            case 'e':
-            case 'E':
-            {
-                add(current);
-                goto scan_number_exponent;
-            }
-
-            default:
-                goto scan_number_done;
-        }
-
-scan_number_any1:
-        // state: we just parsed a number 0-9 (maybe with a leading minus sign)
-        switch (get())
-        {
-            case '0':
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_any1;
-            }
-
-            case '.':
-            {
-                add(decimal_point_char);
-                goto scan_number_decimal1;
-            }
-
-            case 'e':
-            case 'E':
-            {
-                add(current);
-                goto scan_number_exponent;
-            }
-
-            default:
-                goto scan_number_done;
-        }
-
-scan_number_decimal1:
-        // state: we just parsed a decimal point
-        number_type = token_type::value_float;
-        switch (get())
-        {
-            case '0':
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_decimal2;
-            }
-
-            default:
-            {
-                error_message = "invalid number; expected digit after '.'";
-                return token_type::parse_error;
-            }
-        }
-
-scan_number_decimal2:
-        // we just parsed at least one number after a decimal point
-        switch (get())
-        {
-            case '0':
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_decimal2;
-            }
-
-            case 'e':
-            case 'E':
-            {
-                add(current);
-                goto scan_number_exponent;
-            }
-
-            default:
-                goto scan_number_done;
-        }
-
-scan_number_exponent:
-        // we just parsed an exponent
-        number_type = token_type::value_float;
-        switch (get())
-        {
-            case '+':
-            case '-':
-            {
-                add(current);
-                goto scan_number_sign;
-            }
-
-            case '0':
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_any2;
-            }
-
-            default:
-            {
-                error_message =
-                    "invalid number; expected '+', '-', or digit after exponent";
-                return token_type::parse_error;
-            }
-        }
-
-scan_number_sign:
-        // we just parsed an exponent sign
-        switch (get())
-        {
-            case '0':
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_any2;
-            }
-
-            default:
-            {
-                error_message = "invalid number; expected digit after exponent sign";
-                return token_type::parse_error;
-            }
-        }
-
-scan_number_any2:
-        // we just parsed a number after the exponent or exponent sign
-        switch (get())
-        {
-            case '0':
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-            {
-                add(current);
-                goto scan_number_any2;
-            }
-
-            default:
-                goto scan_number_done;
-        }
-
-scan_number_done:
-        // unget the character after the number (we only read it to know that
-        // we are done scanning a number)
-        unget();
-
-        char* endptr = nullptr; // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-        errno = 0;
-
-        // try to parse integers first and fall back to floats
-        if (number_type == token_type::value_unsigned)
-        {
-            const auto x = std::strtoull(token_buffer.data(), &endptr, 10);
-
-            // we checked the number format before
-            JSON_ASSERT(endptr == token_buffer.data() + token_buffer.size());
-
-            if (errno == 0)
-            {
-                value_unsigned = static_cast<number_unsigned_t>(x);
-                if (value_unsigned == x)
-                {
-                    return token_type::value_unsigned;
-                }
-            }
-        }
-        else if (number_type == token_type::value_integer)
-        {
-            const auto x = std::strtoll(token_buffer.data(), &endptr, 10);
-
-            // we checked the number format before
-            JSON_ASSERT(endptr == token_buffer.data() + token_buffer.size());
-
-            if (errno == 0)
-            {
-                value_integer = static_cast<number_integer_t>(x);
-                if (value_integer == x)
-                {
-                    return token_type::value_integer;
-                }
-            }
-        }
-
-        // this code is reached if we parse a floating-point number or if an
-        // integer conversion above failed
-        strtof(value_float, token_buffer.data(), &endptr);
-
-        // we checked the number format before
-        JSON_ASSERT(endptr == token_buffer.data() + token_buffer.size());
-
-        return token_type::value_float;
-    }
-
-    /*!
-    @param[in] literal_text  the literal text to expect
-    @param[in] length        the length of the passed literal text
-    @param[in] return_type   the token type to return on success
-    */
-    JSON_HEDLEY_NON_NULL(2)
-    token_type scan_literal(const char_type* literal_text, const std::size_t length,
-                            token_type return_type)
-    {
-        JSON_ASSERT(std::char_traits<char_type>::to_char_type(current) == literal_text[0]);
-        for (std::size_t i = 1; i < length; ++i)
-        {
-            if (JSON_HEDLEY_UNLIKELY(std::char_traits<char_type>::to_char_type(get()) != literal_text[i]))
-            {
-                error_message = "invalid literal";
-                return token_type::parse_error;
-            }
-        }
-        return return_type;
-    }
-
-    /////////////////////
-    // input management
-    /////////////////////
-
-    /// reset token_buffer; current character is beginning of token
-    void reset() noexcept
-    {
-        token_buffer.clear();
-        token_string.clear();
-        token_string.push_back(std::char_traits<char_type>::to_char_type(current));
-    }
-
-    /*
-    @brief get next character from the input
-
-    This function provides the interface to the used input adapter. It does
-    not throw in case the input reached EOF, but returns a
-    `std::char_traits<char>::eof()` in that case.  Stores the scanned characters
-    for use in error messages.
-
-    @return character read from the input
-    */
-    char_int_type get()
-    {
-        ++position.chars_read_total;
-        ++position.chars_read_current_line;
-
-        if (next_unget)
-        {
-            // just reset the next_unget variable and work with current
-            next_unget = false;
-        }
-        else
-        {
-            current = ia.get_character();
-        }
-
-        if (JSON_HEDLEY_LIKELY(current != std::char_traits<char_type>::eof()))
-        {
-            token_string.push_back(std::char_traits<char_type>::to_char_type(current));
-        }
-
-        if (current == '\n')
-        {
-            ++position.lines_read;
-            position.chars_read_current_line = 0;
-        }
-
-        return current;
-    }
-
-    /*!
-    @brief unget current character (read it again on next get)
-
-    We implement unget by setting variable next_unget to true. The input is not
-    changed - we just simulate ungetting by modifying chars_read_total,
-    chars_read_current_line, and token_string. The next call to get() will
-    behave as if the unget character is read again.
-    */
-    void unget()
-    {
-        next_unget = true;
-
-        --position.chars_read_total;
-
-        // in case we "unget" a newline, we have to also decrement the lines_read
-        if (position.chars_read_current_line == 0)
-        {
-            if (position.lines_read > 0)
-            {
-                --position.lines_read;
-            }
-        }
-        else
-        {
-            --position.chars_read_current_line;
-        }
-
-        if (JSON_HEDLEY_LIKELY(current != std::char_traits<char_type>::eof()))
-        {
-            JSON_ASSERT(!token_string.empty());
-            token_string.pop_back();
-        }
-    }
-
-    /// add a character to token_buffer
-    void add(char_int_type c)
-    {
-        token_buffer.push_back(static_cast<typename string_t::value_type>(c));
-    }
-
-  public:
-    /////////////////////
-    // value getters
-    /////////////////////
-
-    /// return integer value
-    constexpr number_integer_t get_number_integer() const noexcept
-    {
-        return value_integer;
-    }
-
-    /// return unsigned integer value
-    constexpr number_unsigned_t get_number_unsigned() const noexcept
-    {
-        return value_unsigned;
-    }
-
-    /// return floating-point value
-    constexpr number_float_t get_number_float() const noexcept
-    {
-        return value_float;
-    }
-
-    /// return current string value (implicitly resets the token; useful only once)
-    string_t& get_string()
-    {
-        return token_buffer;
-    }
-
-    /////////////////////
-    // diagnostics
-    /////////////////////
-
-    /// return position of last read token
-    constexpr position_t get_position() const noexcept
-    {
-        return position;
-    }
-
-    /// return the last read token (for errors only).  Will never contain EOF
-    /// (an arbitrary value that is not a valid char value, often -1), because
-    /// 255 may legitimately occur.  May contain NUL, which should be escaped.
-    std::string get_token_string() const
-    {
-        // escape control characters
-        std::string result;
-        for (const auto c : token_string)
-        {
-            if (static_cast<unsigned char>(c) <= '\x1F')
-            {
-                // escape control characters
-                std::array<char, 9> cs{{}};
-                static_cast<void>((std::snprintf)(cs.data(), cs.size(), "<U+%.4X>", static_cast<unsigned char>(c))); // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-                result += cs.data();
-            }
-            else
-            {
-                // add character as is
-                result.push_back(static_cast<std::string::value_type>(c));
-            }
-        }
-
-        return result;
-    }
-
-    /// return syntax error message
-    JSON_HEDLEY_RETURNS_NON_NULL
-    constexpr const char* get_error_message() const noexcept
-    {
-        return error_message;
-    }
-
-    /////////////////////
-    // actual scanner
-    /////////////////////
-
-    /*!
-    @brief skip the UTF-8 byte order mark
-    @return true iff there is no BOM or the correct BOM has been skipped
-    */
-    bool skip_bom()
-    {
-        if (get() == 0xEF)
-        {
-            // check if we completely parse the BOM
-            return get() == 0xBB && get() == 0xBF;
-        }
-
-        // the first character is not the beginning of the BOM; unget it to
-        // process is later
-        unget();
-        return true;
-    }
-
-    void skip_whitespace()
-    {
-        do
-        {
-            get();
-        }
-        while (current == ' ' || current == '\t' || current == '\n' || current == '\r');
-    }
-
-    token_type scan()
-    {
-        // initially, skip the BOM
-        if (position.chars_read_total == 0 && !skip_bom())
-        {
-            error_message = "invalid BOM; must be 0xEF 0xBB 0xBF if given";
-            return token_type::parse_error;
-        }
-
-        // read next character and ignore whitespace
-        skip_whitespace();
-
-        // ignore comments
-        while (ignore_comments && current == '/')
-        {
-            if (!scan_comment())
-            {
-                return token_type::parse_error;
-            }
-
-            // skip following whitespace
-            skip_whitespace();
-        }
-
-        switch (current)
-        {
-            // structural characters
-            case '[':
-                return token_type::begin_array;
-            case ']':
-                return token_type::end_array;
-            case '{':
-                return token_type::begin_object;
-            case '}':
-                return token_type::end_object;
-            case ':':
-                return token_type::name_separator;
-            case ',':
-                return token_type::value_separator;
-
-            // literals
-            case 't':
-            {
-                std::array<char_type, 4> true_literal = {{static_cast<char_type>('t'), static_cast<char_type>('r'), static_cast<char_type>('u'), static_cast<char_type>('e')}};
-                return scan_literal(true_literal.data(), true_literal.size(), token_type::literal_true);
-            }
-            case 'f':
-            {
-                std::array<char_type, 5> false_literal = {{static_cast<char_type>('f'), static_cast<char_type>('a'), static_cast<char_type>('l'), static_cast<char_type>('s'), static_cast<char_type>('e')}};
-                return scan_literal(false_literal.data(), false_literal.size(), token_type::literal_false);
-            }
-            case 'n':
-            {
-                std::array<char_type, 4> null_literal = {{static_cast<char_type>('n'), static_cast<char_type>('u'), static_cast<char_type>('l'), static_cast<char_type>('l')}};
-                return scan_literal(null_literal.data(), null_literal.size(), token_type::literal_null);
-            }
-
-            // string
-            case '\"':
-                return scan_string();
-
-            // number
-            case '-':
-            case '0':
-            case '1':
-            case '2':
-            case '3':
-            case '4':
-            case '5':
-            case '6':
-            case '7':
-            case '8':
-            case '9':
-                return scan_number();
-
-            // end of input (the null byte is needed when parsing from
-            // string literals)
-            case '\0':
-            case std::char_traits<char_type>::eof():
-                return token_type::end_of_input;
-
-            // error
-            default:
-                error_message = "invalid literal";
-                return token_type::parse_error;
-        }
-    }
-
-  private:
-    /// input adapter
-    InputAdapterType ia;
-
-    /// whether comments should be ignored (true) or signaled as errors (false)
-    const bool ignore_comments = false;
-
-    /// the current character
-    char_int_type current = std::char_traits<char_type>::eof();
-
-    /// whether the next get() call should just return current
-    bool next_unget = false;
-
-    /// the start position of the current token
-    position_t position {};
-
-    /// raw input token string (for error messages)
-    std::vector<char_type> token_string {};
-
-    /// buffer for variable-length tokens (numbers, strings)
-    string_t token_buffer {};
-
-    /// a description of occurred lexer errors
-    const char* error_message = "";
-
-    // number values
-    number_integer_t value_integer = 0;
-    number_unsigned_t value_unsigned = 0;
-    number_float_t value_float = 0;
-
-    /// the decimal point
-    const char_int_type decimal_point_char = '.';
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/meta/is_sax.hpp>
-
-
-#include <cstdint> // size_t
-#include <utility> // declval
-#include <string> // string
-
-// #include <nlohmann/detail/meta/detected.hpp>
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-template<typename T>
-using null_function_t = decltype(std::declval<T&>().null());
-
-template<typename T>
-using boolean_function_t =
-    decltype(std::declval<T&>().boolean(std::declval<bool>()));
-
-template<typename T, typename Integer>
-using number_integer_function_t =
-    decltype(std::declval<T&>().number_integer(std::declval<Integer>()));
-
-template<typename T, typename Unsigned>
-using number_unsigned_function_t =
-    decltype(std::declval<T&>().number_unsigned(std::declval<Unsigned>()));
-
-template<typename T, typename Float, typename String>
-using number_float_function_t = decltype(std::declval<T&>().number_float(
-                                    std::declval<Float>(), std::declval<const String&>()));
-
-template<typename T, typename String>
-using string_function_t =
-    decltype(std::declval<T&>().string(std::declval<String&>()));
-
-template<typename T, typename Binary>
-using binary_function_t =
-    decltype(std::declval<T&>().binary(std::declval<Binary&>()));
-
-template<typename T>
-using start_object_function_t =
-    decltype(std::declval<T&>().start_object(std::declval<std::size_t>()));
-
-template<typename T, typename String>
-using key_function_t =
-    decltype(std::declval<T&>().key(std::declval<String&>()));
-
-template<typename T>
-using end_object_function_t = decltype(std::declval<T&>().end_object());
-
-template<typename T>
-using start_array_function_t =
-    decltype(std::declval<T&>().start_array(std::declval<std::size_t>()));
-
-template<typename T>
-using end_array_function_t = decltype(std::declval<T&>().end_array());
-
-template<typename T, typename Exception>
-using parse_error_function_t = decltype(std::declval<T&>().parse_error(
-        std::declval<std::size_t>(), std::declval<const std::string&>(),
-        std::declval<const Exception&>()));
-
-template<typename SAX, typename BasicJsonType>
-struct is_sax
-{
-  private:
-    static_assert(is_basic_json<BasicJsonType>::value,
-                  "BasicJsonType must be of type basic_json<...>");
-
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-    using exception_t = typename BasicJsonType::exception;
-
-  public:
-    static constexpr bool value =
-        is_detected_exact<bool, null_function_t, SAX>::value &&
-        is_detected_exact<bool, boolean_function_t, SAX>::value &&
-        is_detected_exact<bool, number_integer_function_t, SAX, number_integer_t>::value &&
-        is_detected_exact<bool, number_unsigned_function_t, SAX, number_unsigned_t>::value &&
-        is_detected_exact<bool, number_float_function_t, SAX, number_float_t, string_t>::value &&
-        is_detected_exact<bool, string_function_t, SAX, string_t>::value &&
-        is_detected_exact<bool, binary_function_t, SAX, binary_t>::value &&
-        is_detected_exact<bool, start_object_function_t, SAX>::value &&
-        is_detected_exact<bool, key_function_t, SAX, string_t>::value &&
-        is_detected_exact<bool, end_object_function_t, SAX>::value &&
-        is_detected_exact<bool, start_array_function_t, SAX>::value &&
-        is_detected_exact<bool, end_array_function_t, SAX>::value &&
-        is_detected_exact<bool, parse_error_function_t, SAX, exception_t>::value;
-};
-
-template<typename SAX, typename BasicJsonType>
-struct is_sax_static_asserts
-{
-  private:
-    static_assert(is_basic_json<BasicJsonType>::value,
-                  "BasicJsonType must be of type basic_json<...>");
-
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-    using exception_t = typename BasicJsonType::exception;
-
-  public:
-    static_assert(is_detected_exact<bool, null_function_t, SAX>::value,
-                  "Missing/invalid function: bool null()");
-    static_assert(is_detected_exact<bool, boolean_function_t, SAX>::value,
-                  "Missing/invalid function: bool boolean(bool)");
-    static_assert(is_detected_exact<bool, boolean_function_t, SAX>::value,
-                  "Missing/invalid function: bool boolean(bool)");
-    static_assert(
-        is_detected_exact<bool, number_integer_function_t, SAX,
-        number_integer_t>::value,
-        "Missing/invalid function: bool number_integer(number_integer_t)");
-    static_assert(
-        is_detected_exact<bool, number_unsigned_function_t, SAX,
-        number_unsigned_t>::value,
-        "Missing/invalid function: bool number_unsigned(number_unsigned_t)");
-    static_assert(is_detected_exact<bool, number_float_function_t, SAX,
-                  number_float_t, string_t>::value,
-                  "Missing/invalid function: bool number_float(number_float_t, const string_t&)");
-    static_assert(
-        is_detected_exact<bool, string_function_t, SAX, string_t>::value,
-        "Missing/invalid function: bool string(string_t&)");
-    static_assert(
-        is_detected_exact<bool, binary_function_t, SAX, binary_t>::value,
-        "Missing/invalid function: bool binary(binary_t&)");
-    static_assert(is_detected_exact<bool, start_object_function_t, SAX>::value,
-                  "Missing/invalid function: bool start_object(std::size_t)");
-    static_assert(is_detected_exact<bool, key_function_t, SAX, string_t>::value,
-                  "Missing/invalid function: bool key(string_t&)");
-    static_assert(is_detected_exact<bool, end_object_function_t, SAX>::value,
-                  "Missing/invalid function: bool end_object()");
-    static_assert(is_detected_exact<bool, start_array_function_t, SAX>::value,
-                  "Missing/invalid function: bool start_array(std::size_t)");
-    static_assert(is_detected_exact<bool, end_array_function_t, SAX>::value,
-                  "Missing/invalid function: bool end_array()");
-    static_assert(
-        is_detected_exact<bool, parse_error_function_t, SAX, exception_t>::value,
-        "Missing/invalid function: bool parse_error(std::size_t, const "
-        "std::string&, const exception&)");
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-
-/// how to treat CBOR tags
-enum class cbor_tag_handler_t
-{
-    error,   ///< throw a parse_error exception in case of a tag
-    ignore,  ///< ignore tags
-    store    ///< store tags as binary type
-};
-
-/*!
-@brief determine system byte order
-
-@return true if and only if system's byte order is little endian
-
-@note from https://stackoverflow.com/a/1001328/266378
-*/
-static inline bool little_endianness(int num = 1) noexcept
-{
-    return *reinterpret_cast<char*>(&num) == 1;
-}
-
-
-///////////////////
-// binary reader //
-///////////////////
-
-/*!
-@brief deserialization of CBOR, MessagePack, and UBJSON values
-*/
-template<typename BasicJsonType, typename InputAdapterType, typename SAX = json_sax_dom_parser<BasicJsonType>>
-class binary_reader
-{
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-    using json_sax_t = SAX;
-    using char_type = typename InputAdapterType::char_type;
-    using char_int_type = typename std::char_traits<char_type>::int_type;
-
-  public:
-    /*!
-    @brief create a binary reader
-
-    @param[in] adapter  input adapter to read from
-    */
-    explicit binary_reader(InputAdapterType&& adapter) noexcept : ia(std::move(adapter))
-    {
-        (void)detail::is_sax_static_asserts<SAX, BasicJsonType> {};
-    }
-
-    // make class move-only
-    binary_reader(const binary_reader&) = delete;
-    binary_reader(binary_reader&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    binary_reader& operator=(const binary_reader&) = delete;
-    binary_reader& operator=(binary_reader&&) = default; // NOLINT(hicpp-noexcept-move,performance-noexcept-move-constructor)
-    ~binary_reader() = default;
-
-    /*!
-    @param[in] format  the binary format to parse
-    @param[in] sax_    a SAX event processor
-    @param[in] strict  whether to expect the input to be consumed completed
-    @param[in] tag_handler  how to treat CBOR tags
-
-    @return whether parsing was successful
-    */
-    JSON_HEDLEY_NON_NULL(3)
-    bool sax_parse(const input_format_t format,
-                   json_sax_t* sax_,
-                   const bool strict = true,
-                   const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
-    {
-        sax = sax_;
-        bool result = false;
-
-        switch (format)
-        {
-            case input_format_t::bson:
-                result = parse_bson_internal();
-                break;
-
-            case input_format_t::cbor:
-                result = parse_cbor_internal(true, tag_handler);
-                break;
-
-            case input_format_t::msgpack:
-                result = parse_msgpack_internal();
-                break;
-
-            case input_format_t::ubjson:
-                result = parse_ubjson_internal();
-                break;
-
-            case input_format_t::json: // LCOV_EXCL_LINE
-            default:            // LCOV_EXCL_LINE
-                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-        }
-
-        // strict mode: next byte must be EOF
-        if (result && strict)
-        {
-            if (format == input_format_t::ubjson)
-            {
-                get_ignore_noop();
-            }
-            else
-            {
-                get();
-            }
-
-            if (JSON_HEDLEY_UNLIKELY(current != std::char_traits<char_type>::eof()))
-            {
-                return sax->parse_error(chars_read, get_token_string(),
-                                        parse_error::create(110, chars_read, exception_message(format, "expected end of input; last byte: 0x" + get_token_string(), "value"), BasicJsonType()));
-            }
-        }
-
-        return result;
-    }
-
-  private:
-    //////////
-    // BSON //
-    //////////
-
-    /*!
-    @brief Reads in a BSON-object and passes it to the SAX-parser.
-    @return whether a valid BSON-value was passed to the SAX parser
-    */
-    bool parse_bson_internal()
-    {
-        std::int32_t document_size{};
-        get_number<std::int32_t, true>(input_format_t::bson, document_size);
-
-        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(static_cast<std::size_t>(-1))))
-        {
-            return false;
-        }
-
-        if (JSON_HEDLEY_UNLIKELY(!parse_bson_element_list(/*is_array*/false)))
-        {
-            return false;
-        }
-
-        return sax->end_object();
-    }
-
-    /*!
-    @brief Parses a C-style string from the BSON input.
-    @param[in,out] result  A reference to the string variable where the read
-                            string is to be stored.
-    @return `true` if the \x00-byte indicating the end of the string was
-             encountered before the EOF; false` indicates an unexpected EOF.
-    */
-    bool get_bson_cstr(string_t& result)
-    {
-        auto out = std::back_inserter(result);
-        while (true)
-        {
-            get();
-            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::bson, "cstring")))
-            {
-                return false;
-            }
-            if (current == 0x00)
-            {
-                return true;
-            }
-            *out++ = static_cast<typename string_t::value_type>(current);
-        }
-    }
-
-    /*!
-    @brief Parses a zero-terminated string of length @a len from the BSON
-           input.
-    @param[in] len  The length (including the zero-byte at the end) of the
-                    string to be read.
-    @param[in,out] result  A reference to the string variable where the read
-                            string is to be stored.
-    @tparam NumberType The type of the length @a len
-    @pre len >= 1
-    @return `true` if the string was successfully parsed
-    */
-    template<typename NumberType>
-    bool get_bson_string(const NumberType len, string_t& result)
-    {
-        if (JSON_HEDLEY_UNLIKELY(len < 1))
-        {
-            auto last_token = get_token_string();
-            return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::bson, "string length must be at least 1, is " + std::to_string(len), "string"), BasicJsonType()));
-        }
-
-        return get_string(input_format_t::bson, len - static_cast<NumberType>(1), result) && get() != std::char_traits<char_type>::eof();
-    }
-
-    /*!
-    @brief Parses a byte array input of length @a len from the BSON input.
-    @param[in] len  The length of the byte array to be read.
-    @param[in,out] result  A reference to the binary variable where the read
-                            array is to be stored.
-    @tparam NumberType The type of the length @a len
-    @pre len >= 0
-    @return `true` if the byte array was successfully parsed
-    */
-    template<typename NumberType>
-    bool get_bson_binary(const NumberType len, binary_t& result)
-    {
-        if (JSON_HEDLEY_UNLIKELY(len < 0))
-        {
-            auto last_token = get_token_string();
-            return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::bson, "byte array length cannot be negative, is " + std::to_string(len), "binary"), BasicJsonType()));
-        }
-
-        // All BSON binary values have a subtype
-        std::uint8_t subtype{};
-        get_number<std::uint8_t>(input_format_t::bson, subtype);
-        result.set_subtype(subtype);
-
-        return get_binary(input_format_t::bson, len, result);
-    }
-
-    /*!
-    @brief Read a BSON document element of the given @a element_type.
-    @param[in] element_type The BSON element type, c.f. http://bsonspec.org/spec.html
-    @param[in] element_type_parse_position The position in the input stream,
-               where the `element_type` was read.
-    @warning Not all BSON element types are supported yet. An unsupported
-             @a element_type will give rise to a parse_error.114:
-             Unsupported BSON record type 0x...
-    @return whether a valid BSON-object/array was passed to the SAX parser
-    */
-    bool parse_bson_element_internal(const char_int_type element_type,
-                                     const std::size_t element_type_parse_position)
-    {
-        switch (element_type)
-        {
-            case 0x01: // double
-            {
-                double number{};
-                return get_number<double, true>(input_format_t::bson, number) && sax->number_float(static_cast<number_float_t>(number), "");
-            }
-
-            case 0x02: // string
-            {
-                std::int32_t len{};
-                string_t value;
-                return get_number<std::int32_t, true>(input_format_t::bson, len) && get_bson_string(len, value) && sax->string(value);
-            }
-
-            case 0x03: // object
-            {
-                return parse_bson_internal();
-            }
-
-            case 0x04: // array
-            {
-                return parse_bson_array();
-            }
-
-            case 0x05: // binary
-            {
-                std::int32_t len{};
-                binary_t value;
-                return get_number<std::int32_t, true>(input_format_t::bson, len) && get_bson_binary(len, value) && sax->binary(value);
-            }
-
-            case 0x08: // boolean
-            {
-                return sax->boolean(get() != 0);
-            }
-
-            case 0x0A: // null
-            {
-                return sax->null();
-            }
-
-            case 0x10: // int32
-            {
-                std::int32_t value{};
-                return get_number<std::int32_t, true>(input_format_t::bson, value) && sax->number_integer(value);
-            }
-
-            case 0x12: // int64
-            {
-                std::int64_t value{};
-                return get_number<std::int64_t, true>(input_format_t::bson, value) && sax->number_integer(value);
-            }
-
-            default: // anything else not supported (yet)
-            {
-                std::array<char, 3> cr{{}};
-                static_cast<void>((std::snprintf)(cr.data(), cr.size(), "%.2hhX", static_cast<unsigned char>(element_type))); // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-                return sax->parse_error(element_type_parse_position, std::string(cr.data()), parse_error::create(114, element_type_parse_position, "Unsupported BSON record type 0x" + std::string(cr.data()), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @brief Read a BSON element list (as specified in the BSON-spec)
-
-    The same binary layout is used for objects and arrays, hence it must be
-    indicated with the argument @a is_array which one is expected
-    (true --> array, false --> object).
-
-    @param[in] is_array Determines if the element list being read is to be
-                        treated as an object (@a is_array == false), or as an
-                        array (@a is_array == true).
-    @return whether a valid BSON-object/array was passed to the SAX parser
-    */
-    bool parse_bson_element_list(const bool is_array)
-    {
-        string_t key;
-
-        while (auto element_type = get())
-        {
-            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::bson, "element list")))
-            {
-                return false;
-            }
-
-            const std::size_t element_type_parse_position = chars_read;
-            if (JSON_HEDLEY_UNLIKELY(!get_bson_cstr(key)))
-            {
-                return false;
-            }
-
-            if (!is_array && !sax->key(key))
-            {
-                return false;
-            }
-
-            if (JSON_HEDLEY_UNLIKELY(!parse_bson_element_internal(element_type, element_type_parse_position)))
-            {
-                return false;
-            }
-
-            // get_bson_cstr only appends
-            key.clear();
-        }
-
-        return true;
-    }
-
-    /*!
-    @brief Reads an array from the BSON input and passes it to the SAX-parser.
-    @return whether a valid BSON-array was passed to the SAX parser
-    */
-    bool parse_bson_array()
-    {
-        std::int32_t document_size{};
-        get_number<std::int32_t, true>(input_format_t::bson, document_size);
-
-        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(static_cast<std::size_t>(-1))))
-        {
-            return false;
-        }
-
-        if (JSON_HEDLEY_UNLIKELY(!parse_bson_element_list(/*is_array*/true)))
-        {
-            return false;
-        }
-
-        return sax->end_array();
-    }
-
-    //////////
-    // CBOR //
-    //////////
-
-    /*!
-    @param[in] get_char  whether a new character should be retrieved from the
-                         input (true) or whether the last read character should
-                         be considered instead (false)
-    @param[in] tag_handler how CBOR tags should be treated
-
-    @return whether a valid CBOR value was passed to the SAX parser
-    */
-    bool parse_cbor_internal(const bool get_char,
-                             const cbor_tag_handler_t tag_handler)
-    {
-        switch (get_char ? get() : current)
-        {
-            // EOF
-            case std::char_traits<char_type>::eof():
-                return unexpect_eof(input_format_t::cbor, "value");
-
-            // Integer 0x00..0x17 (0..23)
-            case 0x00:
-            case 0x01:
-            case 0x02:
-            case 0x03:
-            case 0x04:
-            case 0x05:
-            case 0x06:
-            case 0x07:
-            case 0x08:
-            case 0x09:
-            case 0x0A:
-            case 0x0B:
-            case 0x0C:
-            case 0x0D:
-            case 0x0E:
-            case 0x0F:
-            case 0x10:
-            case 0x11:
-            case 0x12:
-            case 0x13:
-            case 0x14:
-            case 0x15:
-            case 0x16:
-            case 0x17:
-                return sax->number_unsigned(static_cast<number_unsigned_t>(current));
-
-            case 0x18: // Unsigned integer (one-byte uint8_t follows)
-            {
-                std::uint8_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
-            }
-
-            case 0x19: // Unsigned integer (two-byte uint16_t follows)
-            {
-                std::uint16_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
-            }
-
-            case 0x1A: // Unsigned integer (four-byte uint32_t follows)
-            {
-                std::uint32_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
-            }
-
-            case 0x1B: // Unsigned integer (eight-byte uint64_t follows)
-            {
-                std::uint64_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_unsigned(number);
-            }
-
-            // Negative integer -1-0x00..-1-0x17 (-1..-24)
-            case 0x20:
-            case 0x21:
-            case 0x22:
-            case 0x23:
-            case 0x24:
-            case 0x25:
-            case 0x26:
-            case 0x27:
-            case 0x28:
-            case 0x29:
-            case 0x2A:
-            case 0x2B:
-            case 0x2C:
-            case 0x2D:
-            case 0x2E:
-            case 0x2F:
-            case 0x30:
-            case 0x31:
-            case 0x32:
-            case 0x33:
-            case 0x34:
-            case 0x35:
-            case 0x36:
-            case 0x37:
-                return sax->number_integer(static_cast<std::int8_t>(0x20 - 1 - current));
-
-            case 0x38: // Negative integer (one-byte uint8_t follows)
-            {
-                std::uint8_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1) - number);
-            }
-
-            case 0x39: // Negative integer -1-n (two-byte uint16_t follows)
-            {
-                std::uint16_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1) - number);
-            }
-
-            case 0x3A: // Negative integer -1-n (four-byte uint32_t follows)
-            {
-                std::uint32_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1) - number);
-            }
-
-            case 0x3B: // Negative integer -1-n (eight-byte uint64_t follows)
-            {
-                std::uint64_t number{};
-                return get_number(input_format_t::cbor, number) && sax->number_integer(static_cast<number_integer_t>(-1)
-                        - static_cast<number_integer_t>(number));
-            }
-
-            // Binary data (0x00..0x17 bytes follow)
-            case 0x40:
-            case 0x41:
-            case 0x42:
-            case 0x43:
-            case 0x44:
-            case 0x45:
-            case 0x46:
-            case 0x47:
-            case 0x48:
-            case 0x49:
-            case 0x4A:
-            case 0x4B:
-            case 0x4C:
-            case 0x4D:
-            case 0x4E:
-            case 0x4F:
-            case 0x50:
-            case 0x51:
-            case 0x52:
-            case 0x53:
-            case 0x54:
-            case 0x55:
-            case 0x56:
-            case 0x57:
-            case 0x58: // Binary data (one-byte uint8_t for n follows)
-            case 0x59: // Binary data (two-byte uint16_t for n follow)
-            case 0x5A: // Binary data (four-byte uint32_t for n follow)
-            case 0x5B: // Binary data (eight-byte uint64_t for n follow)
-            case 0x5F: // Binary data (indefinite length)
-            {
-                binary_t b;
-                return get_cbor_binary(b) && sax->binary(b);
-            }
-
-            // UTF-8 string (0x00..0x17 bytes follow)
-            case 0x60:
-            case 0x61:
-            case 0x62:
-            case 0x63:
-            case 0x64:
-            case 0x65:
-            case 0x66:
-            case 0x67:
-            case 0x68:
-            case 0x69:
-            case 0x6A:
-            case 0x6B:
-            case 0x6C:
-            case 0x6D:
-            case 0x6E:
-            case 0x6F:
-            case 0x70:
-            case 0x71:
-            case 0x72:
-            case 0x73:
-            case 0x74:
-            case 0x75:
-            case 0x76:
-            case 0x77:
-            case 0x78: // UTF-8 string (one-byte uint8_t for n follows)
-            case 0x79: // UTF-8 string (two-byte uint16_t for n follow)
-            case 0x7A: // UTF-8 string (four-byte uint32_t for n follow)
-            case 0x7B: // UTF-8 string (eight-byte uint64_t for n follow)
-            case 0x7F: // UTF-8 string (indefinite length)
-            {
-                string_t s;
-                return get_cbor_string(s) && sax->string(s);
-            }
-
-            // array (0x00..0x17 data items follow)
-            case 0x80:
-            case 0x81:
-            case 0x82:
-            case 0x83:
-            case 0x84:
-            case 0x85:
-            case 0x86:
-            case 0x87:
-            case 0x88:
-            case 0x89:
-            case 0x8A:
-            case 0x8B:
-            case 0x8C:
-            case 0x8D:
-            case 0x8E:
-            case 0x8F:
-            case 0x90:
-            case 0x91:
-            case 0x92:
-            case 0x93:
-            case 0x94:
-            case 0x95:
-            case 0x96:
-            case 0x97:
-                return get_cbor_array(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x1Fu), tag_handler);
-
-            case 0x98: // array (one-byte uint8_t for n follows)
-            {
-                std::uint8_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_array(static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0x99: // array (two-byte uint16_t for n follow)
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_array(static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0x9A: // array (four-byte uint32_t for n follow)
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_array(static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0x9B: // array (eight-byte uint64_t for n follow)
-            {
-                std::uint64_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_array(detail::conditional_static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0x9F: // array (indefinite length)
-                return get_cbor_array(static_cast<std::size_t>(-1), tag_handler);
-
-            // map (0x00..0x17 pairs of data items follow)
-            case 0xA0:
-            case 0xA1:
-            case 0xA2:
-            case 0xA3:
-            case 0xA4:
-            case 0xA5:
-            case 0xA6:
-            case 0xA7:
-            case 0xA8:
-            case 0xA9:
-            case 0xAA:
-            case 0xAB:
-            case 0xAC:
-            case 0xAD:
-            case 0xAE:
-            case 0xAF:
-            case 0xB0:
-            case 0xB1:
-            case 0xB2:
-            case 0xB3:
-            case 0xB4:
-            case 0xB5:
-            case 0xB6:
-            case 0xB7:
-                return get_cbor_object(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x1Fu), tag_handler);
-
-            case 0xB8: // map (one-byte uint8_t for n follows)
-            {
-                std::uint8_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_object(static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0xB9: // map (two-byte uint16_t for n follow)
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_object(static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0xBA: // map (four-byte uint32_t for n follow)
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_object(static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0xBB: // map (eight-byte uint64_t for n follow)
-            {
-                std::uint64_t len{};
-                return get_number(input_format_t::cbor, len) && get_cbor_object(detail::conditional_static_cast<std::size_t>(len), tag_handler);
-            }
-
-            case 0xBF: // map (indefinite length)
-                return get_cbor_object(static_cast<std::size_t>(-1), tag_handler);
-
-            case 0xC6: // tagged item
-            case 0xC7:
-            case 0xC8:
-            case 0xC9:
-            case 0xCA:
-            case 0xCB:
-            case 0xCC:
-            case 0xCD:
-            case 0xCE:
-            case 0xCF:
-            case 0xD0:
-            case 0xD1:
-            case 0xD2:
-            case 0xD3:
-            case 0xD4:
-            case 0xD8: // tagged item (1 bytes follow)
-            case 0xD9: // tagged item (2 bytes follow)
-            case 0xDA: // tagged item (4 bytes follow)
-            case 0xDB: // tagged item (8 bytes follow)
-            {
-                switch (tag_handler)
-                {
-                    case cbor_tag_handler_t::error:
-                    {
-                        auto last_token = get_token_string();
-                        return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::cbor, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
-                    }
-
-                    case cbor_tag_handler_t::ignore:
-                    {
-                        // ignore binary subtype
-                        switch (current)
-                        {
-                            case 0xD8:
-                            {
-                                std::uint8_t subtype_to_ignore{};
-                                get_number(input_format_t::cbor, subtype_to_ignore);
-                                break;
-                            }
-                            case 0xD9:
-                            {
-                                std::uint16_t subtype_to_ignore{};
-                                get_number(input_format_t::cbor, subtype_to_ignore);
-                                break;
-                            }
-                            case 0xDA:
-                            {
-                                std::uint32_t subtype_to_ignore{};
-                                get_number(input_format_t::cbor, subtype_to_ignore);
-                                break;
-                            }
-                            case 0xDB:
-                            {
-                                std::uint64_t subtype_to_ignore{};
-                                get_number(input_format_t::cbor, subtype_to_ignore);
-                                break;
-                            }
-                            default:
-                                break;
-                        }
-                        return parse_cbor_internal(true, tag_handler);
-                    }
-
-                    case cbor_tag_handler_t::store:
-                    {
-                        binary_t b;
-                        // use binary subtype and store in binary container
-                        switch (current)
-                        {
-                            case 0xD8:
-                            {
-                                std::uint8_t subtype{};
-                                get_number(input_format_t::cbor, subtype);
-                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
-                                break;
-                            }
-                            case 0xD9:
-                            {
-                                std::uint16_t subtype{};
-                                get_number(input_format_t::cbor, subtype);
-                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
-                                break;
-                            }
-                            case 0xDA:
-                            {
-                                std::uint32_t subtype{};
-                                get_number(input_format_t::cbor, subtype);
-                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
-                                break;
-                            }
-                            case 0xDB:
-                            {
-                                std::uint64_t subtype{};
-                                get_number(input_format_t::cbor, subtype);
-                                b.set_subtype(detail::conditional_static_cast<typename binary_t::subtype_type>(subtype));
-                                break;
-                            }
-                            default:
-                                return parse_cbor_internal(true, tag_handler);
-                        }
-                        get();
-                        return get_cbor_binary(b) && sax->binary(b);
-                    }
-
-                    default:                 // LCOV_EXCL_LINE
-                        JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-                        return false;        // LCOV_EXCL_LINE
-                }
-            }
-
-            case 0xF4: // false
-                return sax->boolean(false);
-
-            case 0xF5: // true
-                return sax->boolean(true);
-
-            case 0xF6: // null
-                return sax->null();
-
-            case 0xF9: // Half-Precision Float (two-byte IEEE 754)
-            {
-                const auto byte1_raw = get();
-                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "number")))
-                {
-                    return false;
-                }
-                const auto byte2_raw = get();
-                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "number")))
-                {
-                    return false;
-                }
-
-                const auto byte1 = static_cast<unsigned char>(byte1_raw);
-                const auto byte2 = static_cast<unsigned char>(byte2_raw);
-
-                // code from RFC 7049, Appendix D, Figure 3:
-                // As half-precision floating-point numbers were only added
-                // to IEEE 754 in 2008, today's programming platforms often
-                // still only have limited support for them. It is very
-                // easy to include at least decoding support for them even
-                // without such support. An example of a small decoder for
-                // half-precision floating-point numbers in the C language
-                // is shown in Fig. 3.
-                const auto half = static_cast<unsigned int>((byte1 << 8u) + byte2);
-                const double val = [&half]
-                {
-                    const int exp = (half >> 10u) & 0x1Fu;
-                    const unsigned int mant = half & 0x3FFu;
-                    JSON_ASSERT(0 <= exp&& exp <= 32);
-                    JSON_ASSERT(mant <= 1024);
-                    switch (exp)
-                    {
-                        case 0:
-                            return std::ldexp(mant, -24);
-                        case 31:
-                            return (mant == 0)
-                            ? std::numeric_limits<double>::infinity()
-                            : std::numeric_limits<double>::quiet_NaN();
-                        default:
-                            return std::ldexp(mant + 1024, exp - 25);
-                    }
-                }();
-                return sax->number_float((half & 0x8000u) != 0
-                                         ? static_cast<number_float_t>(-val)
-                                         : static_cast<number_float_t>(val), "");
-            }
-
-            case 0xFA: // Single-Precision Float (four-byte IEEE 754)
-            {
-                float number{};
-                return get_number(input_format_t::cbor, number) && sax->number_float(static_cast<number_float_t>(number), "");
-            }
-
-            case 0xFB: // Double-Precision Float (eight-byte IEEE 754)
-            {
-                double number{};
-                return get_number(input_format_t::cbor, number) && sax->number_float(static_cast<number_float_t>(number), "");
-            }
-
-            default: // anything else (0xFF is handled inside the other types)
-            {
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::cbor, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @brief reads a CBOR string
-
-    This function first reads starting bytes to determine the expected
-    string length and then copies this number of bytes into a string.
-    Additionally, CBOR's strings with indefinite lengths are supported.
-
-    @param[out] result  created string
-
-    @return whether string creation completed
-    */
-    bool get_cbor_string(string_t& result)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "string")))
-        {
-            return false;
-        }
-
-        switch (current)
-        {
-            // UTF-8 string (0x00..0x17 bytes follow)
-            case 0x60:
-            case 0x61:
-            case 0x62:
-            case 0x63:
-            case 0x64:
-            case 0x65:
-            case 0x66:
-            case 0x67:
-            case 0x68:
-            case 0x69:
-            case 0x6A:
-            case 0x6B:
-            case 0x6C:
-            case 0x6D:
-            case 0x6E:
-            case 0x6F:
-            case 0x70:
-            case 0x71:
-            case 0x72:
-            case 0x73:
-            case 0x74:
-            case 0x75:
-            case 0x76:
-            case 0x77:
-            {
-                return get_string(input_format_t::cbor, static_cast<unsigned int>(current) & 0x1Fu, result);
-            }
-
-            case 0x78: // UTF-8 string (one-byte uint8_t for n follows)
-            {
-                std::uint8_t len{};
-                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
-            }
-
-            case 0x79: // UTF-8 string (two-byte uint16_t for n follow)
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
-            }
-
-            case 0x7A: // UTF-8 string (four-byte uint32_t for n follow)
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
-            }
-
-            case 0x7B: // UTF-8 string (eight-byte uint64_t for n follow)
-            {
-                std::uint64_t len{};
-                return get_number(input_format_t::cbor, len) && get_string(input_format_t::cbor, len, result);
-            }
-
-            case 0x7F: // UTF-8 string (indefinite length)
-            {
-                while (get() != 0xFF)
-                {
-                    string_t chunk;
-                    if (!get_cbor_string(chunk))
-                    {
-                        return false;
-                    }
-                    result.append(chunk);
-                }
-                return true;
-            }
-
-            default:
-            {
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::cbor, "expected length specification (0x60-0x7B) or indefinite string type (0x7F); last byte: 0x" + last_token, "string"), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @brief reads a CBOR byte array
-
-    This function first reads starting bytes to determine the expected
-    byte array length and then copies this number of bytes into the byte array.
-    Additionally, CBOR's byte arrays with indefinite lengths are supported.
-
-    @param[out] result  created byte array
-
-    @return whether byte array creation completed
-    */
-    bool get_cbor_binary(binary_t& result)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::cbor, "binary")))
-        {
-            return false;
-        }
-
-        switch (current)
-        {
-            // Binary data (0x00..0x17 bytes follow)
-            case 0x40:
-            case 0x41:
-            case 0x42:
-            case 0x43:
-            case 0x44:
-            case 0x45:
-            case 0x46:
-            case 0x47:
-            case 0x48:
-            case 0x49:
-            case 0x4A:
-            case 0x4B:
-            case 0x4C:
-            case 0x4D:
-            case 0x4E:
-            case 0x4F:
-            case 0x50:
-            case 0x51:
-            case 0x52:
-            case 0x53:
-            case 0x54:
-            case 0x55:
-            case 0x56:
-            case 0x57:
-            {
-                return get_binary(input_format_t::cbor, static_cast<unsigned int>(current) & 0x1Fu, result);
-            }
-
-            case 0x58: // Binary data (one-byte uint8_t for n follows)
-            {
-                std::uint8_t len{};
-                return get_number(input_format_t::cbor, len) &&
-                       get_binary(input_format_t::cbor, len, result);
-            }
-
-            case 0x59: // Binary data (two-byte uint16_t for n follow)
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::cbor, len) &&
-                       get_binary(input_format_t::cbor, len, result);
-            }
-
-            case 0x5A: // Binary data (four-byte uint32_t for n follow)
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::cbor, len) &&
-                       get_binary(input_format_t::cbor, len, result);
-            }
-
-            case 0x5B: // Binary data (eight-byte uint64_t for n follow)
-            {
-                std::uint64_t len{};
-                return get_number(input_format_t::cbor, len) &&
-                       get_binary(input_format_t::cbor, len, result);
-            }
-
-            case 0x5F: // Binary data (indefinite length)
-            {
-                while (get() != 0xFF)
-                {
-                    binary_t chunk;
-                    if (!get_cbor_binary(chunk))
-                    {
-                        return false;
-                    }
-                    result.insert(result.end(), chunk.begin(), chunk.end());
-                }
-                return true;
-            }
-
-            default:
-            {
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::cbor, "expected length specification (0x40-0x5B) or indefinite binary array type (0x5F); last byte: 0x" + last_token, "binary"), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @param[in] len  the length of the array or static_cast<std::size_t>(-1) for an
-                    array of indefinite size
-    @param[in] tag_handler how CBOR tags should be treated
-    @return whether array creation completed
-    */
-    bool get_cbor_array(const std::size_t len,
-                        const cbor_tag_handler_t tag_handler)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(len)))
-        {
-            return false;
-        }
-
-        if (len != static_cast<std::size_t>(-1))
-        {
-            for (std::size_t i = 0; i < len; ++i)
-            {
-                if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(true, tag_handler)))
-                {
-                    return false;
-                }
-            }
-        }
-        else
-        {
-            while (get() != 0xFF)
-            {
-                if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(false, tag_handler)))
-                {
-                    return false;
-                }
-            }
-        }
-
-        return sax->end_array();
-    }
-
-    /*!
-    @param[in] len  the length of the object or static_cast<std::size_t>(-1) for an
-                    object of indefinite size
-    @param[in] tag_handler how CBOR tags should be treated
-    @return whether object creation completed
-    */
-    bool get_cbor_object(const std::size_t len,
-                         const cbor_tag_handler_t tag_handler)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(len)))
-        {
-            return false;
-        }
-
-        if (len != 0)
-        {
-            string_t key;
-            if (len != static_cast<std::size_t>(-1))
-            {
-                for (std::size_t i = 0; i < len; ++i)
-                {
-                    get();
-                    if (JSON_HEDLEY_UNLIKELY(!get_cbor_string(key) || !sax->key(key)))
-                    {
-                        return false;
-                    }
-
-                    if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(true, tag_handler)))
-                    {
-                        return false;
-                    }
-                    key.clear();
-                }
-            }
-            else
-            {
-                while (get() != 0xFF)
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!get_cbor_string(key) || !sax->key(key)))
-                    {
-                        return false;
-                    }
-
-                    if (JSON_HEDLEY_UNLIKELY(!parse_cbor_internal(true, tag_handler)))
-                    {
-                        return false;
-                    }
-                    key.clear();
-                }
-            }
-        }
-
-        return sax->end_object();
-    }
-
-    /////////////
-    // MsgPack //
-    /////////////
-
-    /*!
-    @return whether a valid MessagePack value was passed to the SAX parser
-    */
-    bool parse_msgpack_internal()
-    {
-        switch (get())
-        {
-            // EOF
-            case std::char_traits<char_type>::eof():
-                return unexpect_eof(input_format_t::msgpack, "value");
-
-            // positive fixint
-            case 0x00:
-            case 0x01:
-            case 0x02:
-            case 0x03:
-            case 0x04:
-            case 0x05:
-            case 0x06:
-            case 0x07:
-            case 0x08:
-            case 0x09:
-            case 0x0A:
-            case 0x0B:
-            case 0x0C:
-            case 0x0D:
-            case 0x0E:
-            case 0x0F:
-            case 0x10:
-            case 0x11:
-            case 0x12:
-            case 0x13:
-            case 0x14:
-            case 0x15:
-            case 0x16:
-            case 0x17:
-            case 0x18:
-            case 0x19:
-            case 0x1A:
-            case 0x1B:
-            case 0x1C:
-            case 0x1D:
-            case 0x1E:
-            case 0x1F:
-            case 0x20:
-            case 0x21:
-            case 0x22:
-            case 0x23:
-            case 0x24:
-            case 0x25:
-            case 0x26:
-            case 0x27:
-            case 0x28:
-            case 0x29:
-            case 0x2A:
-            case 0x2B:
-            case 0x2C:
-            case 0x2D:
-            case 0x2E:
-            case 0x2F:
-            case 0x30:
-            case 0x31:
-            case 0x32:
-            case 0x33:
-            case 0x34:
-            case 0x35:
-            case 0x36:
-            case 0x37:
-            case 0x38:
-            case 0x39:
-            case 0x3A:
-            case 0x3B:
-            case 0x3C:
-            case 0x3D:
-            case 0x3E:
-            case 0x3F:
-            case 0x40:
-            case 0x41:
-            case 0x42:
-            case 0x43:
-            case 0x44:
-            case 0x45:
-            case 0x46:
-            case 0x47:
-            case 0x48:
-            case 0x49:
-            case 0x4A:
-            case 0x4B:
-            case 0x4C:
-            case 0x4D:
-            case 0x4E:
-            case 0x4F:
-            case 0x50:
-            case 0x51:
-            case 0x52:
-            case 0x53:
-            case 0x54:
-            case 0x55:
-            case 0x56:
-            case 0x57:
-            case 0x58:
-            case 0x59:
-            case 0x5A:
-            case 0x5B:
-            case 0x5C:
-            case 0x5D:
-            case 0x5E:
-            case 0x5F:
-            case 0x60:
-            case 0x61:
-            case 0x62:
-            case 0x63:
-            case 0x64:
-            case 0x65:
-            case 0x66:
-            case 0x67:
-            case 0x68:
-            case 0x69:
-            case 0x6A:
-            case 0x6B:
-            case 0x6C:
-            case 0x6D:
-            case 0x6E:
-            case 0x6F:
-            case 0x70:
-            case 0x71:
-            case 0x72:
-            case 0x73:
-            case 0x74:
-            case 0x75:
-            case 0x76:
-            case 0x77:
-            case 0x78:
-            case 0x79:
-            case 0x7A:
-            case 0x7B:
-            case 0x7C:
-            case 0x7D:
-            case 0x7E:
-            case 0x7F:
-                return sax->number_unsigned(static_cast<number_unsigned_t>(current));
-
-            // fixmap
-            case 0x80:
-            case 0x81:
-            case 0x82:
-            case 0x83:
-            case 0x84:
-            case 0x85:
-            case 0x86:
-            case 0x87:
-            case 0x88:
-            case 0x89:
-            case 0x8A:
-            case 0x8B:
-            case 0x8C:
-            case 0x8D:
-            case 0x8E:
-            case 0x8F:
-                return get_msgpack_object(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x0Fu));
-
-            // fixarray
-            case 0x90:
-            case 0x91:
-            case 0x92:
-            case 0x93:
-            case 0x94:
-            case 0x95:
-            case 0x96:
-            case 0x97:
-            case 0x98:
-            case 0x99:
-            case 0x9A:
-            case 0x9B:
-            case 0x9C:
-            case 0x9D:
-            case 0x9E:
-            case 0x9F:
-                return get_msgpack_array(static_cast<std::size_t>(static_cast<unsigned int>(current) & 0x0Fu));
-
-            // fixstr
-            case 0xA0:
-            case 0xA1:
-            case 0xA2:
-            case 0xA3:
-            case 0xA4:
-            case 0xA5:
-            case 0xA6:
-            case 0xA7:
-            case 0xA8:
-            case 0xA9:
-            case 0xAA:
-            case 0xAB:
-            case 0xAC:
-            case 0xAD:
-            case 0xAE:
-            case 0xAF:
-            case 0xB0:
-            case 0xB1:
-            case 0xB2:
-            case 0xB3:
-            case 0xB4:
-            case 0xB5:
-            case 0xB6:
-            case 0xB7:
-            case 0xB8:
-            case 0xB9:
-            case 0xBA:
-            case 0xBB:
-            case 0xBC:
-            case 0xBD:
-            case 0xBE:
-            case 0xBF:
-            case 0xD9: // str 8
-            case 0xDA: // str 16
-            case 0xDB: // str 32
-            {
-                string_t s;
-                return get_msgpack_string(s) && sax->string(s);
-            }
-
-            case 0xC0: // nil
-                return sax->null();
-
-            case 0xC2: // false
-                return sax->boolean(false);
-
-            case 0xC3: // true
-                return sax->boolean(true);
-
-            case 0xC4: // bin 8
-            case 0xC5: // bin 16
-            case 0xC6: // bin 32
-            case 0xC7: // ext 8
-            case 0xC8: // ext 16
-            case 0xC9: // ext 32
-            case 0xD4: // fixext 1
-            case 0xD5: // fixext 2
-            case 0xD6: // fixext 4
-            case 0xD7: // fixext 8
-            case 0xD8: // fixext 16
-            {
-                binary_t b;
-                return get_msgpack_binary(b) && sax->binary(b);
-            }
-
-            case 0xCA: // float 32
-            {
-                float number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_float(static_cast<number_float_t>(number), "");
-            }
-
-            case 0xCB: // float 64
-            {
-                double number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_float(static_cast<number_float_t>(number), "");
-            }
-
-            case 0xCC: // uint 8
-            {
-                std::uint8_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
-            }
-
-            case 0xCD: // uint 16
-            {
-                std::uint16_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
-            }
-
-            case 0xCE: // uint 32
-            {
-                std::uint32_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
-            }
-
-            case 0xCF: // uint 64
-            {
-                std::uint64_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_unsigned(number);
-            }
-
-            case 0xD0: // int 8
-            {
-                std::int8_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
-            }
-
-            case 0xD1: // int 16
-            {
-                std::int16_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
-            }
-
-            case 0xD2: // int 32
-            {
-                std::int32_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
-            }
-
-            case 0xD3: // int 64
-            {
-                std::int64_t number{};
-                return get_number(input_format_t::msgpack, number) && sax->number_integer(number);
-            }
-
-            case 0xDC: // array 16
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::msgpack, len) && get_msgpack_array(static_cast<std::size_t>(len));
-            }
-
-            case 0xDD: // array 32
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::msgpack, len) && get_msgpack_array(static_cast<std::size_t>(len));
-            }
-
-            case 0xDE: // map 16
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::msgpack, len) && get_msgpack_object(static_cast<std::size_t>(len));
-            }
-
-            case 0xDF: // map 32
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::msgpack, len) && get_msgpack_object(static_cast<std::size_t>(len));
-            }
-
-            // negative fixint
-            case 0xE0:
-            case 0xE1:
-            case 0xE2:
-            case 0xE3:
-            case 0xE4:
-            case 0xE5:
-            case 0xE6:
-            case 0xE7:
-            case 0xE8:
-            case 0xE9:
-            case 0xEA:
-            case 0xEB:
-            case 0xEC:
-            case 0xED:
-            case 0xEE:
-            case 0xEF:
-            case 0xF0:
-            case 0xF1:
-            case 0xF2:
-            case 0xF3:
-            case 0xF4:
-            case 0xF5:
-            case 0xF6:
-            case 0xF7:
-            case 0xF8:
-            case 0xF9:
-            case 0xFA:
-            case 0xFB:
-            case 0xFC:
-            case 0xFD:
-            case 0xFE:
-            case 0xFF:
-                return sax->number_integer(static_cast<std::int8_t>(current));
-
-            default: // anything else
-            {
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::msgpack, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @brief reads a MessagePack string
-
-    This function first reads starting bytes to determine the expected
-    string length and then copies this number of bytes into a string.
-
-    @param[out] result  created string
-
-    @return whether string creation completed
-    */
-    bool get_msgpack_string(string_t& result)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::msgpack, "string")))
-        {
-            return false;
-        }
-
-        switch (current)
-        {
-            // fixstr
-            case 0xA0:
-            case 0xA1:
-            case 0xA2:
-            case 0xA3:
-            case 0xA4:
-            case 0xA5:
-            case 0xA6:
-            case 0xA7:
-            case 0xA8:
-            case 0xA9:
-            case 0xAA:
-            case 0xAB:
-            case 0xAC:
-            case 0xAD:
-            case 0xAE:
-            case 0xAF:
-            case 0xB0:
-            case 0xB1:
-            case 0xB2:
-            case 0xB3:
-            case 0xB4:
-            case 0xB5:
-            case 0xB6:
-            case 0xB7:
-            case 0xB8:
-            case 0xB9:
-            case 0xBA:
-            case 0xBB:
-            case 0xBC:
-            case 0xBD:
-            case 0xBE:
-            case 0xBF:
-            {
-                return get_string(input_format_t::msgpack, static_cast<unsigned int>(current) & 0x1Fu, result);
-            }
-
-            case 0xD9: // str 8
-            {
-                std::uint8_t len{};
-                return get_number(input_format_t::msgpack, len) && get_string(input_format_t::msgpack, len, result);
-            }
-
-            case 0xDA: // str 16
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::msgpack, len) && get_string(input_format_t::msgpack, len, result);
-            }
-
-            case 0xDB: // str 32
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::msgpack, len) && get_string(input_format_t::msgpack, len, result);
-            }
-
-            default:
-            {
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::msgpack, "expected length specification (0xA0-0xBF, 0xD9-0xDB); last byte: 0x" + last_token, "string"), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @brief reads a MessagePack byte array
-
-    This function first reads starting bytes to determine the expected
-    byte array length and then copies this number of bytes into a byte array.
-
-    @param[out] result  created byte array
-
-    @return whether byte array creation completed
-    */
-    bool get_msgpack_binary(binary_t& result)
-    {
-        // helper function to set the subtype
-        auto assign_and_return_true = [&result](std::int8_t subtype)
-        {
-            result.set_subtype(static_cast<std::uint8_t>(subtype));
-            return true;
-        };
-
-        switch (current)
-        {
-            case 0xC4: // bin 8
-            {
-                std::uint8_t len{};
-                return get_number(input_format_t::msgpack, len) &&
-                       get_binary(input_format_t::msgpack, len, result);
-            }
-
-            case 0xC5: // bin 16
-            {
-                std::uint16_t len{};
-                return get_number(input_format_t::msgpack, len) &&
-                       get_binary(input_format_t::msgpack, len, result);
-            }
-
-            case 0xC6: // bin 32
-            {
-                std::uint32_t len{};
-                return get_number(input_format_t::msgpack, len) &&
-                       get_binary(input_format_t::msgpack, len, result);
-            }
-
-            case 0xC7: // ext 8
-            {
-                std::uint8_t len{};
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, len) &&
-                       get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, len, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            case 0xC8: // ext 16
-            {
-                std::uint16_t len{};
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, len) &&
-                       get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, len, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            case 0xC9: // ext 32
-            {
-                std::uint32_t len{};
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, len) &&
-                       get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, len, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            case 0xD4: // fixext 1
-            {
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, 1, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            case 0xD5: // fixext 2
-            {
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, 2, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            case 0xD6: // fixext 4
-            {
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, 4, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            case 0xD7: // fixext 8
-            {
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, 8, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            case 0xD8: // fixext 16
-            {
-                std::int8_t subtype{};
-                return get_number(input_format_t::msgpack, subtype) &&
-                       get_binary(input_format_t::msgpack, 16, result) &&
-                       assign_and_return_true(subtype);
-            }
-
-            default:           // LCOV_EXCL_LINE
-                return false;  // LCOV_EXCL_LINE
-        }
-    }
-
-    /*!
-    @param[in] len  the length of the array
-    @return whether array creation completed
-    */
-    bool get_msgpack_array(const std::size_t len)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(len)))
-        {
-            return false;
-        }
-
-        for (std::size_t i = 0; i < len; ++i)
-        {
-            if (JSON_HEDLEY_UNLIKELY(!parse_msgpack_internal()))
-            {
-                return false;
-            }
-        }
-
-        return sax->end_array();
-    }
-
-    /*!
-    @param[in] len  the length of the object
-    @return whether object creation completed
-    */
-    bool get_msgpack_object(const std::size_t len)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(len)))
-        {
-            return false;
-        }
-
-        string_t key;
-        for (std::size_t i = 0; i < len; ++i)
-        {
-            get();
-            if (JSON_HEDLEY_UNLIKELY(!get_msgpack_string(key) || !sax->key(key)))
-            {
-                return false;
-            }
-
-            if (JSON_HEDLEY_UNLIKELY(!parse_msgpack_internal()))
-            {
-                return false;
-            }
-            key.clear();
-        }
-
-        return sax->end_object();
-    }
-
-    ////////////
-    // UBJSON //
-    ////////////
-
-    /*!
-    @param[in] get_char  whether a new character should be retrieved from the
-                         input (true, default) or whether the last read
-                         character should be considered instead
-
-    @return whether a valid UBJSON value was passed to the SAX parser
-    */
-    bool parse_ubjson_internal(const bool get_char = true)
-    {
-        return get_ubjson_value(get_char ? get_ignore_noop() : current);
-    }
-
-    /*!
-    @brief reads a UBJSON string
-
-    This function is either called after reading the 'S' byte explicitly
-    indicating a string, or in case of an object key where the 'S' byte can be
-    left out.
-
-    @param[out] result   created string
-    @param[in] get_char  whether a new character should be retrieved from the
-                         input (true, default) or whether the last read
-                         character should be considered instead
-
-    @return whether string creation completed
-    */
-    bool get_ubjson_string(string_t& result, const bool get_char = true)
-    {
-        if (get_char)
-        {
-            get();  // TODO(niels): may we ignore N here?
-        }
-
-        if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "value")))
-        {
-            return false;
-        }
-
-        switch (current)
-        {
-            case 'U':
-            {
-                std::uint8_t len{};
-                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
-            }
-
-            case 'i':
-            {
-                std::int8_t len{};
-                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
-            }
-
-            case 'I':
-            {
-                std::int16_t len{};
-                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
-            }
-
-            case 'l':
-            {
-                std::int32_t len{};
-                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
-            }
-
-            case 'L':
-            {
-                std::int64_t len{};
-                return get_number(input_format_t::ubjson, len) && get_string(input_format_t::ubjson, len, result);
-            }
-
-            default:
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::ubjson, "expected length type specification (U, i, I, l, L); last byte: 0x" + last_token, "string"), BasicJsonType()));
-        }
-    }
-
-    /*!
-    @param[out] result  determined size
-    @return whether size determination completed
-    */
-    bool get_ubjson_size_value(std::size_t& result)
-    {
-        switch (get_ignore_noop())
-        {
-            case 'U':
-            {
-                std::uint8_t number{};
-                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
-                {
-                    return false;
-                }
-                result = static_cast<std::size_t>(number);
-                return true;
-            }
-
-            case 'i':
-            {
-                std::int8_t number{};
-                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
-                {
-                    return false;
-                }
-                result = static_cast<std::size_t>(number); // NOLINT(bugprone-signed-char-misuse,cert-str34-c): number is not a char
-                return true;
-            }
-
-            case 'I':
-            {
-                std::int16_t number{};
-                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
-                {
-                    return false;
-                }
-                result = static_cast<std::size_t>(number);
-                return true;
-            }
-
-            case 'l':
-            {
-                std::int32_t number{};
-                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
-                {
-                    return false;
-                }
-                result = static_cast<std::size_t>(number);
-                return true;
-            }
-
-            case 'L':
-            {
-                std::int64_t number{};
-                if (JSON_HEDLEY_UNLIKELY(!get_number(input_format_t::ubjson, number)))
-                {
-                    return false;
-                }
-                result = static_cast<std::size_t>(number);
-                return true;
-            }
-
-            default:
-            {
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::ubjson, "expected length type specification (U, i, I, l, L) after '#'; last byte: 0x" + last_token, "size"), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @brief determine the type and size for a container
-
-    In the optimized UBJSON format, a type and a size can be provided to allow
-    for a more compact representation.
-
-    @param[out] result  pair of the size and the type
-
-    @return whether pair creation completed
-    */
-    bool get_ubjson_size_type(std::pair<std::size_t, char_int_type>& result)
-    {
-        result.first = string_t::npos; // size
-        result.second = 0; // type
-
-        get_ignore_noop();
-
-        if (current == '$')
-        {
-            result.second = get();  // must not ignore 'N', because 'N' maybe the type
-            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "type")))
-            {
-                return false;
-            }
-
-            get_ignore_noop();
-            if (JSON_HEDLEY_UNLIKELY(current != '#'))
-            {
-                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "value")))
-                {
-                    return false;
-                }
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::ubjson, "expected '#' after type information; last byte: 0x" + last_token, "size"), BasicJsonType()));
-            }
-
-            return get_ubjson_size_value(result.first);
-        }
-
-        if (current == '#')
-        {
-            return get_ubjson_size_value(result.first);
-        }
-
-        return true;
-    }
-
-    /*!
-    @param prefix  the previously read or set type prefix
-    @return whether value creation completed
-    */
-    bool get_ubjson_value(const char_int_type prefix)
-    {
-        switch (prefix)
-        {
-            case std::char_traits<char_type>::eof():  // EOF
-                return unexpect_eof(input_format_t::ubjson, "value");
-
-            case 'T':  // true
-                return sax->boolean(true);
-            case 'F':  // false
-                return sax->boolean(false);
-
-            case 'Z':  // null
-                return sax->null();
-
-            case 'U':
-            {
-                std::uint8_t number{};
-                return get_number(input_format_t::ubjson, number) && sax->number_unsigned(number);
-            }
-
-            case 'i':
-            {
-                std::int8_t number{};
-                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
-            }
-
-            case 'I':
-            {
-                std::int16_t number{};
-                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
-            }
-
-            case 'l':
-            {
-                std::int32_t number{};
-                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
-            }
-
-            case 'L':
-            {
-                std::int64_t number{};
-                return get_number(input_format_t::ubjson, number) && sax->number_integer(number);
-            }
-
-            case 'd':
-            {
-                float number{};
-                return get_number(input_format_t::ubjson, number) && sax->number_float(static_cast<number_float_t>(number), "");
-            }
-
-            case 'D':
-            {
-                double number{};
-                return get_number(input_format_t::ubjson, number) && sax->number_float(static_cast<number_float_t>(number), "");
-            }
-
-            case 'H':
-            {
-                return get_ubjson_high_precision_number();
-            }
-
-            case 'C':  // char
-            {
-                get();
-                if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "char")))
-                {
-                    return false;
-                }
-                if (JSON_HEDLEY_UNLIKELY(current > 127))
-                {
-                    auto last_token = get_token_string();
-                    return sax->parse_error(chars_read, last_token, parse_error::create(113, chars_read, exception_message(input_format_t::ubjson, "byte after 'C' must be in range 0x00..0x7F; last byte: 0x" + last_token, "char"), BasicJsonType()));
-                }
-                string_t s(1, static_cast<typename string_t::value_type>(current));
-                return sax->string(s);
-            }
-
-            case 'S':  // string
-            {
-                string_t s;
-                return get_ubjson_string(s) && sax->string(s);
-            }
-
-            case '[':  // array
-                return get_ubjson_array();
-
-            case '{':  // object
-                return get_ubjson_object();
-
-            default: // anything else
-            {
-                auto last_token = get_token_string();
-                return sax->parse_error(chars_read, last_token, parse_error::create(112, chars_read, exception_message(input_format_t::ubjson, "invalid byte: 0x" + last_token, "value"), BasicJsonType()));
-            }
-        }
-    }
-
-    /*!
-    @return whether array creation completed
-    */
-    bool get_ubjson_array()
-    {
-        std::pair<std::size_t, char_int_type> size_and_type;
-        if (JSON_HEDLEY_UNLIKELY(!get_ubjson_size_type(size_and_type)))
-        {
-            return false;
-        }
-
-        if (size_and_type.first != string_t::npos)
-        {
-            if (JSON_HEDLEY_UNLIKELY(!sax->start_array(size_and_type.first)))
-            {
-                return false;
-            }
-
-            if (size_and_type.second != 0)
-            {
-                if (size_and_type.second != 'N')
-                {
-                    for (std::size_t i = 0; i < size_and_type.first; ++i)
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!get_ubjson_value(size_and_type.second)))
-                        {
-                            return false;
-                        }
-                    }
-                }
-            }
-            else
-            {
-                for (std::size_t i = 0; i < size_and_type.first; ++i)
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal()))
-                    {
-                        return false;
-                    }
-                }
-            }
-        }
-        else
-        {
-            if (JSON_HEDLEY_UNLIKELY(!sax->start_array(static_cast<std::size_t>(-1))))
-            {
-                return false;
-            }
-
-            while (current != ']')
-            {
-                if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal(false)))
-                {
-                    return false;
-                }
-                get_ignore_noop();
-            }
-        }
-
-        return sax->end_array();
-    }
-
-    /*!
-    @return whether object creation completed
-    */
-    bool get_ubjson_object()
-    {
-        std::pair<std::size_t, char_int_type> size_and_type;
-        if (JSON_HEDLEY_UNLIKELY(!get_ubjson_size_type(size_and_type)))
-        {
-            return false;
-        }
-
-        string_t key;
-        if (size_and_type.first != string_t::npos)
-        {
-            if (JSON_HEDLEY_UNLIKELY(!sax->start_object(size_and_type.first)))
-            {
-                return false;
-            }
-
-            if (size_and_type.second != 0)
-            {
-                for (std::size_t i = 0; i < size_and_type.first; ++i)
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!get_ubjson_string(key) || !sax->key(key)))
-                    {
-                        return false;
-                    }
-                    if (JSON_HEDLEY_UNLIKELY(!get_ubjson_value(size_and_type.second)))
-                    {
-                        return false;
-                    }
-                    key.clear();
-                }
-            }
-            else
-            {
-                for (std::size_t i = 0; i < size_and_type.first; ++i)
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!get_ubjson_string(key) || !sax->key(key)))
-                    {
-                        return false;
-                    }
-                    if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal()))
-                    {
-                        return false;
-                    }
-                    key.clear();
-                }
-            }
-        }
-        else
-        {
-            if (JSON_HEDLEY_UNLIKELY(!sax->start_object(static_cast<std::size_t>(-1))))
-            {
-                return false;
-            }
-
-            while (current != '}')
-            {
-                if (JSON_HEDLEY_UNLIKELY(!get_ubjson_string(key, false) || !sax->key(key)))
-                {
-                    return false;
-                }
-                if (JSON_HEDLEY_UNLIKELY(!parse_ubjson_internal()))
-                {
-                    return false;
-                }
-                get_ignore_noop();
-                key.clear();
-            }
-        }
-
-        return sax->end_object();
-    }
-
-    // Note, no reader for UBJSON binary types is implemented because they do
-    // not exist
-
-    bool get_ubjson_high_precision_number()
-    {
-        // get size of following number string
-        std::size_t size{};
-        auto res = get_ubjson_size_value(size);
-        if (JSON_HEDLEY_UNLIKELY(!res))
-        {
-            return res;
-        }
-
-        // get number string
-        std::vector<char> number_vector;
-        for (std::size_t i = 0; i < size; ++i)
-        {
-            get();
-            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(input_format_t::ubjson, "number")))
-            {
-                return false;
-            }
-            number_vector.push_back(static_cast<char>(current));
-        }
-
-        // parse number string
-        using ia_type = decltype(detail::input_adapter(number_vector));
-        auto number_lexer = detail::lexer<BasicJsonType, ia_type>(detail::input_adapter(number_vector), false);
-        const auto result_number = number_lexer.scan();
-        const auto number_string = number_lexer.get_token_string();
-        const auto result_remainder = number_lexer.scan();
-
-        using token_type = typename detail::lexer_base<BasicJsonType>::token_type;
-
-        if (JSON_HEDLEY_UNLIKELY(result_remainder != token_type::end_of_input))
-        {
-            return sax->parse_error(chars_read, number_string, parse_error::create(115, chars_read, exception_message(input_format_t::ubjson, "invalid number text: " + number_lexer.get_token_string(), "high-precision number"), BasicJsonType()));
-        }
-
-        switch (result_number)
-        {
-            case token_type::value_integer:
-                return sax->number_integer(number_lexer.get_number_integer());
-            case token_type::value_unsigned:
-                return sax->number_unsigned(number_lexer.get_number_unsigned());
-            case token_type::value_float:
-                return sax->number_float(number_lexer.get_number_float(), std::move(number_string));
-            case token_type::uninitialized:
-            case token_type::literal_true:
-            case token_type::literal_false:
-            case token_type::literal_null:
-            case token_type::value_string:
-            case token_type::begin_array:
-            case token_type::begin_object:
-            case token_type::end_array:
-            case token_type::end_object:
-            case token_type::name_separator:
-            case token_type::value_separator:
-            case token_type::parse_error:
-            case token_type::end_of_input:
-            case token_type::literal_or_value:
-            default:
-                return sax->parse_error(chars_read, number_string, parse_error::create(115, chars_read, exception_message(input_format_t::ubjson, "invalid number text: " + number_lexer.get_token_string(), "high-precision number"), BasicJsonType()));
-        }
-    }
-
-    ///////////////////////
-    // Utility functions //
-    ///////////////////////
-
-    /*!
-    @brief get next character from the input
-
-    This function provides the interface to the used input adapter. It does
-    not throw in case the input reached EOF, but returns a -'ve valued
-    `std::char_traits<char_type>::eof()` in that case.
-
-    @return character read from the input
-    */
-    char_int_type get()
-    {
-        ++chars_read;
-        return current = ia.get_character();
-    }
-
-    /*!
-    @return character read from the input after ignoring all 'N' entries
-    */
-    char_int_type get_ignore_noop()
-    {
-        do
-        {
-            get();
-        }
-        while (current == 'N');
-
-        return current;
-    }
-
-    /*
-    @brief read a number from the input
-
-    @tparam NumberType the type of the number
-    @param[in] format   the current format (for diagnostics)
-    @param[out] result  number of type @a NumberType
-
-    @return whether conversion completed
-
-    @note This function needs to respect the system's endianness, because
-          bytes in CBOR, MessagePack, and UBJSON are stored in network order
-          (big endian) and therefore need reordering on little endian systems.
-    */
-    template<typename NumberType, bool InputIsLittleEndian = false>
-    bool get_number(const input_format_t format, NumberType& result)
-    {
-        // step 1: read input into array with system's byte order
-        std::array<std::uint8_t, sizeof(NumberType)> vec{};
-        for (std::size_t i = 0; i < sizeof(NumberType); ++i)
-        {
-            get();
-            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(format, "number")))
-            {
-                return false;
-            }
-
-            // reverse byte order prior to conversion if necessary
-            if (is_little_endian != InputIsLittleEndian)
-            {
-                vec[sizeof(NumberType) - i - 1] = static_cast<std::uint8_t>(current);
-            }
-            else
-            {
-                vec[i] = static_cast<std::uint8_t>(current); // LCOV_EXCL_LINE
-            }
-        }
-
-        // step 2: convert array into number of type T and return
-        std::memcpy(&result, vec.data(), sizeof(NumberType));
-        return true;
-    }
-
-    /*!
-    @brief create a string by reading characters from the input
-
-    @tparam NumberType the type of the number
-    @param[in] format the current format (for diagnostics)
-    @param[in] len number of characters to read
-    @param[out] result string created by reading @a len bytes
-
-    @return whether string creation completed
-
-    @note We can not reserve @a len bytes for the result, because @a len
-          may be too large. Usually, @ref unexpect_eof() detects the end of
-          the input before we run out of string memory.
-    */
-    template<typename NumberType>
-    bool get_string(const input_format_t format,
-                    const NumberType len,
-                    string_t& result)
-    {
-        bool success = true;
-        for (NumberType i = 0; i < len; i++)
-        {
-            get();
-            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(format, "string")))
-            {
-                success = false;
-                break;
-            }
-            result.push_back(static_cast<typename string_t::value_type>(current));
-        }
-        return success;
-    }
-
-    /*!
-    @brief create a byte array by reading bytes from the input
-
-    @tparam NumberType the type of the number
-    @param[in] format the current format (for diagnostics)
-    @param[in] len number of bytes to read
-    @param[out] result byte array created by reading @a len bytes
-
-    @return whether byte array creation completed
-
-    @note We can not reserve @a len bytes for the result, because @a len
-          may be too large. Usually, @ref unexpect_eof() detects the end of
-          the input before we run out of memory.
-    */
-    template<typename NumberType>
-    bool get_binary(const input_format_t format,
-                    const NumberType len,
-                    binary_t& result)
-    {
-        bool success = true;
-        for (NumberType i = 0; i < len; i++)
-        {
-            get();
-            if (JSON_HEDLEY_UNLIKELY(!unexpect_eof(format, "binary")))
-            {
-                success = false;
-                break;
-            }
-            result.push_back(static_cast<std::uint8_t>(current));
-        }
-        return success;
-    }
-
-    /*!
-    @param[in] format   the current format (for diagnostics)
-    @param[in] context  further context information (for diagnostics)
-    @return whether the last read character is not EOF
-    */
-    JSON_HEDLEY_NON_NULL(3)
-    bool unexpect_eof(const input_format_t format, const char* context) const
-    {
-        if (JSON_HEDLEY_UNLIKELY(current == std::char_traits<char_type>::eof()))
-        {
-            return sax->parse_error(chars_read, "<end of file>",
-                                    parse_error::create(110, chars_read, exception_message(format, "unexpected end of input", context), BasicJsonType()));
-        }
-        return true;
-    }
-
-    /*!
-    @return a string representation of the last read byte
-    */
-    std::string get_token_string() const
-    {
-        std::array<char, 3> cr{{}};
-        static_cast<void>((std::snprintf)(cr.data(), cr.size(), "%.2hhX", static_cast<unsigned char>(current))); // NOLINT(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-        return std::string{cr.data()};
-    }
-
-    /*!
-    @param[in] format   the current format
-    @param[in] detail   a detailed error message
-    @param[in] context  further context information
-    @return a message string to use in the parse_error exceptions
-    */
-    std::string exception_message(const input_format_t format,
-                                  const std::string& detail,
-                                  const std::string& context) const
-    {
-        std::string error_msg = "syntax error while parsing ";
-
-        switch (format)
-        {
-            case input_format_t::cbor:
-                error_msg += "CBOR";
-                break;
-
-            case input_format_t::msgpack:
-                error_msg += "MessagePack";
-                break;
-
-            case input_format_t::ubjson:
-                error_msg += "UBJSON";
-                break;
-
-            case input_format_t::bson:
-                error_msg += "BSON";
-                break;
-
-            case input_format_t::json: // LCOV_EXCL_LINE
-            default:            // LCOV_EXCL_LINE
-                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-        }
-
-        return error_msg + " " + context + ": " + detail;
-    }
-
-  private:
-    /// input adapter
-    InputAdapterType ia;
-
-    /// the current character
-    char_int_type current = std::char_traits<char_type>::eof();
-
-    /// the number of characters read
-    std::size_t chars_read = 0;
-
-    /// whether we can assume little endianness
-    const bool is_little_endian = little_endianness();
-
-    /// the SAX parser
-    json_sax_t* sax = nullptr;
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/input/input_adapters.hpp>
-
-// #include <nlohmann/detail/input/lexer.hpp>
-
-// #include <nlohmann/detail/input/parser.hpp>
-
-
-#include <cmath> // isfinite
-#include <cstdint> // uint8_t
-#include <functional> // function
-#include <string> // string
-#include <utility> // move
-#include <vector> // vector
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-// #include <nlohmann/detail/input/input_adapters.hpp>
-
-// #include <nlohmann/detail/input/json_sax.hpp>
-
-// #include <nlohmann/detail/input/lexer.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/meta/is_sax.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-////////////
-// parser //
-////////////
-
-enum class parse_event_t : std::uint8_t
-{
-    /// the parser read `{` and started to process a JSON object
-    object_start,
-    /// the parser read `}` and finished processing a JSON object
-    object_end,
-    /// the parser read `[` and started to process a JSON array
-    array_start,
-    /// the parser read `]` and finished processing a JSON array
-    array_end,
-    /// the parser read a key of a value in an object
-    key,
-    /// the parser finished reading a JSON value
-    value
-};
-
-template<typename BasicJsonType>
-using parser_callback_t =
-    std::function<bool(int /*depth*/, parse_event_t /*event*/, BasicJsonType& /*parsed*/)>;
-
-/*!
-@brief syntax analysis
-
-This class implements a recursive descent parser.
-*/
-template<typename BasicJsonType, typename InputAdapterType>
-class parser
-{
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using string_t = typename BasicJsonType::string_t;
-    using lexer_t = lexer<BasicJsonType, InputAdapterType>;
-    using token_type = typename lexer_t::token_type;
-
-  public:
-    /// a parser reading from an input adapter
-    explicit parser(InputAdapterType&& adapter,
-                    const parser_callback_t<BasicJsonType> cb = nullptr,
-                    const bool allow_exceptions_ = true,
-                    const bool skip_comments = false)
-        : callback(cb)
-        , m_lexer(std::move(adapter), skip_comments)
-        , allow_exceptions(allow_exceptions_)
-    {
-        // read first token
-        get_token();
-    }
-
-    /*!
-    @brief public parser interface
-
-    @param[in] strict      whether to expect the last token to be EOF
-    @param[in,out] result  parsed JSON value
-
-    @throw parse_error.101 in case of an unexpected token
-    @throw parse_error.102 if to_unicode fails or surrogate error
-    @throw parse_error.103 if to_unicode fails
-    */
-    void parse(const bool strict, BasicJsonType& result)
-    {
-        if (callback)
-        {
-            json_sax_dom_callback_parser<BasicJsonType> sdp(result, callback, allow_exceptions);
-            sax_parse_internal(&sdp);
-
-            // in strict mode, input must be completely read
-            if (strict && (get_token() != token_type::end_of_input))
-            {
-                sdp.parse_error(m_lexer.get_position(),
-                                m_lexer.get_token_string(),
-                                parse_error::create(101, m_lexer.get_position(),
-                                                    exception_message(token_type::end_of_input, "value"), BasicJsonType()));
-            }
-
-            // in case of an error, return discarded value
-            if (sdp.is_errored())
-            {
-                result = value_t::discarded;
-                return;
-            }
-
-            // set top-level value to null if it was discarded by the callback
-            // function
-            if (result.is_discarded())
-            {
-                result = nullptr;
-            }
-        }
-        else
-        {
-            json_sax_dom_parser<BasicJsonType> sdp(result, allow_exceptions);
-            sax_parse_internal(&sdp);
-
-            // in strict mode, input must be completely read
-            if (strict && (get_token() != token_type::end_of_input))
-            {
-                sdp.parse_error(m_lexer.get_position(),
-                                m_lexer.get_token_string(),
-                                parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_of_input, "value"), BasicJsonType()));
-            }
-
-            // in case of an error, return discarded value
-            if (sdp.is_errored())
-            {
-                result = value_t::discarded;
-                return;
-            }
-        }
-
-        result.assert_invariant();
-    }
-
-    /*!
-    @brief public accept interface
-
-    @param[in] strict  whether to expect the last token to be EOF
-    @return whether the input is a proper JSON text
-    */
-    bool accept(const bool strict = true)
-    {
-        json_sax_acceptor<BasicJsonType> sax_acceptor;
-        return sax_parse(&sax_acceptor, strict);
-    }
-
-    template<typename SAX>
-    JSON_HEDLEY_NON_NULL(2)
-    bool sax_parse(SAX* sax, const bool strict = true)
-    {
-        (void)detail::is_sax_static_asserts<SAX, BasicJsonType> {};
-        const bool result = sax_parse_internal(sax);
-
-        // strict mode: next byte must be EOF
-        if (result && strict && (get_token() != token_type::end_of_input))
-        {
-            return sax->parse_error(m_lexer.get_position(),
-                                    m_lexer.get_token_string(),
-                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_of_input, "value"), BasicJsonType()));
-        }
-
-        return result;
-    }
-
-  private:
-    template<typename SAX>
-    JSON_HEDLEY_NON_NULL(2)
-    bool sax_parse_internal(SAX* sax)
-    {
-        // stack to remember the hierarchy of structured values we are parsing
-        // true = array; false = object
-        std::vector<bool> states;
-        // value to avoid a goto (see comment where set to true)
-        bool skip_to_state_evaluation = false;
-
-        while (true)
-        {
-            if (!skip_to_state_evaluation)
-            {
-                // invariant: get_token() was called before each iteration
-                switch (last_token)
-                {
-                    case token_type::begin_object:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->start_object(static_cast<std::size_t>(-1))))
-                        {
-                            return false;
-                        }
-
-                        // closing } -> we are done
-                        if (get_token() == token_type::end_object)
-                        {
-                            if (JSON_HEDLEY_UNLIKELY(!sax->end_object()))
-                            {
-                                return false;
-                            }
-                            break;
-                        }
-
-                        // parse key
-                        if (JSON_HEDLEY_UNLIKELY(last_token != token_type::value_string))
-                        {
-                            return sax->parse_error(m_lexer.get_position(),
-                                                    m_lexer.get_token_string(),
-                                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::value_string, "object key"), BasicJsonType()));
-                        }
-                        if (JSON_HEDLEY_UNLIKELY(!sax->key(m_lexer.get_string())))
-                        {
-                            return false;
-                        }
-
-                        // parse separator (:)
-                        if (JSON_HEDLEY_UNLIKELY(get_token() != token_type::name_separator))
-                        {
-                            return sax->parse_error(m_lexer.get_position(),
-                                                    m_lexer.get_token_string(),
-                                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::name_separator, "object separator"), BasicJsonType()));
-                        }
-
-                        // remember we are now inside an object
-                        states.push_back(false);
-
-                        // parse values
-                        get_token();
-                        continue;
-                    }
-
-                    case token_type::begin_array:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->start_array(static_cast<std::size_t>(-1))))
-                        {
-                            return false;
-                        }
-
-                        // closing ] -> we are done
-                        if (get_token() == token_type::end_array)
-                        {
-                            if (JSON_HEDLEY_UNLIKELY(!sax->end_array()))
-                            {
-                                return false;
-                            }
-                            break;
-                        }
-
-                        // remember we are now inside an array
-                        states.push_back(true);
-
-                        // parse values (no need to call get_token)
-                        continue;
-                    }
-
-                    case token_type::value_float:
-                    {
-                        const auto res = m_lexer.get_number_float();
-
-                        if (JSON_HEDLEY_UNLIKELY(!std::isfinite(res)))
-                        {
-                            return sax->parse_error(m_lexer.get_position(),
-                                                    m_lexer.get_token_string(),
-                                                    out_of_range::create(406, "number overflow parsing '" + m_lexer.get_token_string() + "'", BasicJsonType()));
-                        }
-
-                        if (JSON_HEDLEY_UNLIKELY(!sax->number_float(res, m_lexer.get_string())))
-                        {
-                            return false;
-                        }
-
-                        break;
-                    }
-
-                    case token_type::literal_false:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->boolean(false)))
-                        {
-                            return false;
-                        }
-                        break;
-                    }
-
-                    case token_type::literal_null:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->null()))
-                        {
-                            return false;
-                        }
-                        break;
-                    }
-
-                    case token_type::literal_true:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->boolean(true)))
-                        {
-                            return false;
-                        }
-                        break;
-                    }
-
-                    case token_type::value_integer:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->number_integer(m_lexer.get_number_integer())))
-                        {
-                            return false;
-                        }
-                        break;
-                    }
-
-                    case token_type::value_string:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->string(m_lexer.get_string())))
-                        {
-                            return false;
-                        }
-                        break;
-                    }
-
-                    case token_type::value_unsigned:
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!sax->number_unsigned(m_lexer.get_number_unsigned())))
-                        {
-                            return false;
-                        }
-                        break;
-                    }
-
-                    case token_type::parse_error:
-                    {
-                        // using "uninitialized" to avoid "expected" message
-                        return sax->parse_error(m_lexer.get_position(),
-                                                m_lexer.get_token_string(),
-                                                parse_error::create(101, m_lexer.get_position(), exception_message(token_type::uninitialized, "value"), BasicJsonType()));
-                    }
-
-                    case token_type::uninitialized:
-                    case token_type::end_array:
-                    case token_type::end_object:
-                    case token_type::name_separator:
-                    case token_type::value_separator:
-                    case token_type::end_of_input:
-                    case token_type::literal_or_value:
-                    default: // the last token was unexpected
-                    {
-                        return sax->parse_error(m_lexer.get_position(),
-                                                m_lexer.get_token_string(),
-                                                parse_error::create(101, m_lexer.get_position(), exception_message(token_type::literal_or_value, "value"), BasicJsonType()));
-                    }
-                }
-            }
-            else
-            {
-                skip_to_state_evaluation = false;
-            }
-
-            // we reached this line after we successfully parsed a value
-            if (states.empty())
-            {
-                // empty stack: we reached the end of the hierarchy: done
-                return true;
-            }
-
-            if (states.back())  // array
-            {
-                // comma -> next value
-                if (get_token() == token_type::value_separator)
-                {
-                    // parse a new value
-                    get_token();
-                    continue;
-                }
-
-                // closing ]
-                if (JSON_HEDLEY_LIKELY(last_token == token_type::end_array))
-                {
-                    if (JSON_HEDLEY_UNLIKELY(!sax->end_array()))
-                    {
-                        return false;
-                    }
-
-                    // We are done with this array. Before we can parse a
-                    // new value, we need to evaluate the new state first.
-                    // By setting skip_to_state_evaluation to false, we
-                    // are effectively jumping to the beginning of this if.
-                    JSON_ASSERT(!states.empty());
-                    states.pop_back();
-                    skip_to_state_evaluation = true;
-                    continue;
-                }
-
-                return sax->parse_error(m_lexer.get_position(),
-                                        m_lexer.get_token_string(),
-                                        parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_array, "array"), BasicJsonType()));
-            }
-
-            // states.back() is false -> object
-
-            // comma -> next value
-            if (get_token() == token_type::value_separator)
-            {
-                // parse key
-                if (JSON_HEDLEY_UNLIKELY(get_token() != token_type::value_string))
-                {
-                    return sax->parse_error(m_lexer.get_position(),
-                                            m_lexer.get_token_string(),
-                                            parse_error::create(101, m_lexer.get_position(), exception_message(token_type::value_string, "object key"), BasicJsonType()));
-                }
-
-                if (JSON_HEDLEY_UNLIKELY(!sax->key(m_lexer.get_string())))
-                {
-                    return false;
-                }
-
-                // parse separator (:)
-                if (JSON_HEDLEY_UNLIKELY(get_token() != token_type::name_separator))
-                {
-                    return sax->parse_error(m_lexer.get_position(),
-                                            m_lexer.get_token_string(),
-                                            parse_error::create(101, m_lexer.get_position(), exception_message(token_type::name_separator, "object separator"), BasicJsonType()));
-                }
-
-                // parse values
-                get_token();
-                continue;
-            }
-
-            // closing }
-            if (JSON_HEDLEY_LIKELY(last_token == token_type::end_object))
-            {
-                if (JSON_HEDLEY_UNLIKELY(!sax->end_object()))
-                {
-                    return false;
-                }
-
-                // We are done with this object. Before we can parse a
-                // new value, we need to evaluate the new state first.
-                // By setting skip_to_state_evaluation to false, we
-                // are effectively jumping to the beginning of this if.
-                JSON_ASSERT(!states.empty());
-                states.pop_back();
-                skip_to_state_evaluation = true;
-                continue;
-            }
-
-            return sax->parse_error(m_lexer.get_position(),
-                                    m_lexer.get_token_string(),
-                                    parse_error::create(101, m_lexer.get_position(), exception_message(token_type::end_object, "object"), BasicJsonType()));
-        }
-    }
-
-    /// get next token from lexer
-    token_type get_token()
-    {
-        return last_token = m_lexer.scan();
-    }
-
-    std::string exception_message(const token_type expected, const std::string& context)
-    {
-        std::string error_msg = "syntax error ";
-
-        if (!context.empty())
-        {
-            error_msg += "while parsing " + context + " ";
-        }
-
-        error_msg += "- ";
-
-        if (last_token == token_type::parse_error)
-        {
-            error_msg += std::string(m_lexer.get_error_message()) + "; last read: '" +
-                         m_lexer.get_token_string() + "'";
-        }
-        else
-        {
-            error_msg += "unexpected " + std::string(lexer_t::token_type_name(last_token));
-        }
-
-        if (expected != token_type::uninitialized)
-        {
-            error_msg += "; expected " + std::string(lexer_t::token_type_name(expected));
-        }
-
-        return error_msg;
-    }
-
-  private:
-    /// callback function
-    const parser_callback_t<BasicJsonType> callback = nullptr;
-    /// the type of the last read token
-    token_type last_token = token_type::uninitialized;
-    /// the lexer
-    lexer_t m_lexer;
-    /// whether to throw exceptions in case of errors
-    const bool allow_exceptions = true;
-};
-
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/iterators/internal_iterator.hpp>
-
-
-// #include <nlohmann/detail/iterators/primitive_iterator.hpp>
-
-
-#include <cstddef> // ptrdiff_t
-#include <limits>  // numeric_limits
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-/*
-@brief an iterator for primitive JSON types
-
-This class models an iterator for primitive JSON types (boolean, number,
-string). It's only purpose is to allow the iterator/const_iterator classes
-to "iterate" over primitive values. Internally, the iterator is modeled by
-a `difference_type` variable. Value begin_value (`0`) models the begin,
-end_value (`1`) models past the end.
-*/
-class primitive_iterator_t
-{
-  private:
-    using difference_type = std::ptrdiff_t;
-    static constexpr difference_type begin_value = 0;
-    static constexpr difference_type end_value = begin_value + 1;
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    /// iterator as signed integer type
-    difference_type m_it = (std::numeric_limits<std::ptrdiff_t>::min)();
-
-  public:
-    constexpr difference_type get_value() const noexcept
-    {
-        return m_it;
-    }
-
-    /// set iterator to a defined beginning
-    void set_begin() noexcept
-    {
-        m_it = begin_value;
-    }
-
-    /// set iterator to a defined past the end
-    void set_end() noexcept
-    {
-        m_it = end_value;
-    }
-
-    /// return whether the iterator can be dereferenced
-    constexpr bool is_begin() const noexcept
-    {
-        return m_it == begin_value;
-    }
-
-    /// return whether the iterator is at end
-    constexpr bool is_end() const noexcept
-    {
-        return m_it == end_value;
-    }
-
-    friend constexpr bool operator==(primitive_iterator_t lhs, primitive_iterator_t rhs) noexcept
-    {
-        return lhs.m_it == rhs.m_it;
-    }
-
-    friend constexpr bool operator<(primitive_iterator_t lhs, primitive_iterator_t rhs) noexcept
-    {
-        return lhs.m_it < rhs.m_it;
-    }
-
-    primitive_iterator_t operator+(difference_type n) noexcept
-    {
-        auto result = *this;
-        result += n;
-        return result;
-    }
-
-    friend constexpr difference_type operator-(primitive_iterator_t lhs, primitive_iterator_t rhs) noexcept
-    {
-        return lhs.m_it - rhs.m_it;
-    }
-
-    primitive_iterator_t& operator++() noexcept
-    {
-        ++m_it;
-        return *this;
-    }
-
-    primitive_iterator_t const operator++(int) noexcept // NOLINT(readability-const-return-type)
-    {
-        auto result = *this;
-        ++m_it;
-        return result;
-    }
-
-    primitive_iterator_t& operator--() noexcept
-    {
-        --m_it;
-        return *this;
-    }
-
-    primitive_iterator_t const operator--(int) noexcept // NOLINT(readability-const-return-type)
-    {
-        auto result = *this;
-        --m_it;
-        return result;
-    }
-
-    primitive_iterator_t& operator+=(difference_type n) noexcept
-    {
-        m_it += n;
-        return *this;
-    }
-
-    primitive_iterator_t& operator-=(difference_type n) noexcept
-    {
-        m_it -= n;
-        return *this;
-    }
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-
-namespace nlohmann
-{
-namespace detail
-{
-/*!
-@brief an iterator value
-
-@note This structure could easily be a union, but MSVC currently does not allow
-unions members with complex constructors, see https://github.com/nlohmann/json/pull/105.
-*/
-template<typename BasicJsonType> struct internal_iterator
-{
-    /// iterator for JSON objects
-    typename BasicJsonType::object_t::iterator object_iterator {};
-    /// iterator for JSON arrays
-    typename BasicJsonType::array_t::iterator array_iterator {};
-    /// generic iterator for all other types
-    primitive_iterator_t primitive_iterator {};
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/iterators/iter_impl.hpp>
-
-
-#include <iterator> // iterator, random_access_iterator_tag, bidirectional_iterator_tag, advance, next
-#include <type_traits> // conditional, is_const, remove_const
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-// #include <nlohmann/detail/iterators/internal_iterator.hpp>
-
-// #include <nlohmann/detail/iterators/primitive_iterator.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/meta/cpp_future.hpp>
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-// forward declare, to be able to friend it later on
-template<typename IteratorType> class iteration_proxy;
-template<typename IteratorType> class iteration_proxy_value;
-
-/*!
-@brief a template for a bidirectional iterator for the @ref basic_json class
-This class implements a both iterators (iterator and const_iterator) for the
-@ref basic_json class.
-@note An iterator is called *initialized* when a pointer to a JSON value has
-      been set (e.g., by a constructor or a copy assignment). If the iterator is
-      default-constructed, it is *uninitialized* and most methods are undefined.
-      **The library uses assertions to detect calls on uninitialized iterators.**
-@requirement The class satisfies the following concept requirements:
--
-[BidirectionalIterator](https://en.cppreference.com/w/cpp/named_req/BidirectionalIterator):
-  The iterator that can be moved can be moved in both directions (i.e.
-  incremented and decremented).
-@since version 1.0.0, simplified in version 2.0.9, change to bidirectional
-       iterators in version 3.0.0 (see https://github.com/nlohmann/json/issues/593)
-*/
-template<typename BasicJsonType>
-class iter_impl // NOLINT(cppcoreguidelines-special-member-functions,hicpp-special-member-functions)
-{
-    /// the iterator with BasicJsonType of different const-ness
-    using other_iter_impl = iter_impl<typename std::conditional<std::is_const<BasicJsonType>::value, typename std::remove_const<BasicJsonType>::type, const BasicJsonType>::type>;
-    /// allow basic_json to access private members
-    friend other_iter_impl;
-    friend BasicJsonType;
-    friend iteration_proxy<iter_impl>;
-    friend iteration_proxy_value<iter_impl>;
-
-    using object_t = typename BasicJsonType::object_t;
-    using array_t = typename BasicJsonType::array_t;
-    // make sure BasicJsonType is basic_json or const basic_json
-    static_assert(is_basic_json<typename std::remove_const<BasicJsonType>::type>::value,
-                  "iter_impl only accepts (const) basic_json");
-
-  public:
-
-    /// The std::iterator class template (used as a base class to provide typedefs) is deprecated in C++17.
-    /// The C++ Standard has never required user-defined iterators to derive from std::iterator.
-    /// A user-defined iterator should provide publicly accessible typedefs named
-    /// iterator_category, value_type, difference_type, pointer, and reference.
-    /// Note that value_type is required to be non-const, even for constant iterators.
-    using iterator_category = std::bidirectional_iterator_tag;
-
-    /// the type of the values when the iterator is dereferenced
-    using value_type = typename BasicJsonType::value_type;
-    /// a type to represent differences between iterators
-    using difference_type = typename BasicJsonType::difference_type;
-    /// defines a pointer to the type iterated over (value_type)
-    using pointer = typename std::conditional<std::is_const<BasicJsonType>::value,
-          typename BasicJsonType::const_pointer,
-          typename BasicJsonType::pointer>::type;
-    /// defines a reference to the type iterated over (value_type)
-    using reference =
-        typename std::conditional<std::is_const<BasicJsonType>::value,
-        typename BasicJsonType::const_reference,
-        typename BasicJsonType::reference>::type;
-
-    iter_impl() = default;
-    ~iter_impl() = default;
-    iter_impl(iter_impl&&) noexcept = default;
-    iter_impl& operator=(iter_impl&&) noexcept = default;
-
-    /*!
-    @brief constructor for a given JSON instance
-    @param[in] object  pointer to a JSON object for this iterator
-    @pre object != nullptr
-    @post The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    explicit iter_impl(pointer object) noexcept : m_object(object)
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-            {
-                m_it.object_iterator = typename object_t::iterator();
-                break;
-            }
-
-            case value_t::array:
-            {
-                m_it.array_iterator = typename array_t::iterator();
-                break;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                m_it.primitive_iterator = primitive_iterator_t();
-                break;
-            }
-        }
-    }
-
-    /*!
-    @note The conventional copy constructor and copy assignment are implicitly
-          defined. Combined with the following converting constructor and
-          assignment, they support: (1) copy from iterator to iterator, (2)
-          copy from const iterator to const iterator, and (3) conversion from
-          iterator to const iterator. However conversion from const iterator
-          to iterator is not defined.
-    */
-
-    /*!
-    @brief const copy constructor
-    @param[in] other const iterator to copy from
-    @note This copy constructor had to be defined explicitly to circumvent a bug
-          occurring on msvc v19.0 compiler (VS 2015) debug build. For more
-          information refer to: https://github.com/nlohmann/json/issues/1608
-    */
-    iter_impl(const iter_impl<const BasicJsonType>& other) noexcept
-        : m_object(other.m_object), m_it(other.m_it)
-    {}
-
-    /*!
-    @brief converting assignment
-    @param[in] other const iterator to copy from
-    @return const/non-const iterator
-    @note It is not checked whether @a other is initialized.
-    */
-    iter_impl& operator=(const iter_impl<const BasicJsonType>& other) noexcept
-    {
-        if (&other != this)
-        {
-            m_object = other.m_object;
-            m_it = other.m_it;
-        }
-        return *this;
-    }
-
-    /*!
-    @brief converting constructor
-    @param[in] other  non-const iterator to copy from
-    @note It is not checked whether @a other is initialized.
-    */
-    iter_impl(const iter_impl<typename std::remove_const<BasicJsonType>::type>& other) noexcept
-        : m_object(other.m_object), m_it(other.m_it)
-    {}
-
-    /*!
-    @brief converting assignment
-    @param[in] other  non-const iterator to copy from
-    @return const/non-const iterator
-    @note It is not checked whether @a other is initialized.
-    */
-    iter_impl& operator=(const iter_impl<typename std::remove_const<BasicJsonType>::type>& other) noexcept // NOLINT(cert-oop54-cpp)
-    {
-        m_object = other.m_object;
-        m_it = other.m_it;
-        return *this;
-    }
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    /*!
-    @brief set the iterator to the first value
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    void set_begin() noexcept
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-            {
-                m_it.object_iterator = m_object->m_value.object->begin();
-                break;
-            }
-
-            case value_t::array:
-            {
-                m_it.array_iterator = m_object->m_value.array->begin();
-                break;
-            }
-
-            case value_t::null:
-            {
-                // set to end so begin()==end() is true: null is empty
-                m_it.primitive_iterator.set_end();
-                break;
-            }
-
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                m_it.primitive_iterator.set_begin();
-                break;
-            }
-        }
-    }
-
-    /*!
-    @brief set the iterator past the last value
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    void set_end() noexcept
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-            {
-                m_it.object_iterator = m_object->m_value.object->end();
-                break;
-            }
-
-            case value_t::array:
-            {
-                m_it.array_iterator = m_object->m_value.array->end();
-                break;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                m_it.primitive_iterator.set_end();
-                break;
-            }
-        }
-    }
-
-  public:
-    /*!
-    @brief return a reference to the value pointed to by the iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    reference operator*() const
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-            {
-                JSON_ASSERT(m_it.object_iterator != m_object->m_value.object->end());
-                return m_it.object_iterator->second;
-            }
-
-            case value_t::array:
-            {
-                JSON_ASSERT(m_it.array_iterator != m_object->m_value.array->end());
-                return *m_it.array_iterator;
-            }
-
-            case value_t::null:
-                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
-
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                if (JSON_HEDLEY_LIKELY(m_it.primitive_iterator.is_begin()))
-                {
-                    return *m_object;
-                }
-
-                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
-            }
-        }
-    }
-
-    /*!
-    @brief dereference the iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    pointer operator->() const
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-            {
-                JSON_ASSERT(m_it.object_iterator != m_object->m_value.object->end());
-                return &(m_it.object_iterator->second);
-            }
-
-            case value_t::array:
-            {
-                JSON_ASSERT(m_it.array_iterator != m_object->m_value.array->end());
-                return &*m_it.array_iterator;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                if (JSON_HEDLEY_LIKELY(m_it.primitive_iterator.is_begin()))
-                {
-                    return m_object;
-                }
-
-                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
-            }
-        }
-    }
-
-    /*!
-    @brief post-increment (it++)
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl const operator++(int) // NOLINT(readability-const-return-type)
-    {
-        auto result = *this;
-        ++(*this);
-        return result;
-    }
-
-    /*!
-    @brief pre-increment (++it)
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl& operator++()
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-            {
-                std::advance(m_it.object_iterator, 1);
-                break;
-            }
-
-            case value_t::array:
-            {
-                std::advance(m_it.array_iterator, 1);
-                break;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                ++m_it.primitive_iterator;
-                break;
-            }
-        }
-
-        return *this;
-    }
-
-    /*!
-    @brief post-decrement (it--)
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl const operator--(int) // NOLINT(readability-const-return-type)
-    {
-        auto result = *this;
-        --(*this);
-        return result;
-    }
-
-    /*!
-    @brief pre-decrement (--it)
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl& operator--()
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-            {
-                std::advance(m_it.object_iterator, -1);
-                break;
-            }
-
-            case value_t::array:
-            {
-                std::advance(m_it.array_iterator, -1);
-                break;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                --m_it.primitive_iterator;
-                break;
-            }
-        }
-
-        return *this;
-    }
-
-    /*!
-    @brief comparison: equal
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    template < typename IterImpl, detail::enable_if_t < (std::is_same<IterImpl, iter_impl>::value || std::is_same<IterImpl, other_iter_impl>::value), std::nullptr_t > = nullptr >
-    bool operator==(const IterImpl& other) const
-    {
-        // if objects are not the same, the comparison is undefined
-        if (JSON_HEDLEY_UNLIKELY(m_object != other.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(212, "cannot compare iterators of different containers", *m_object));
-        }
-
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-                return (m_it.object_iterator == other.m_it.object_iterator);
-
-            case value_t::array:
-                return (m_it.array_iterator == other.m_it.array_iterator);
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-                return (m_it.primitive_iterator == other.m_it.primitive_iterator);
-        }
-    }
-
-    /*!
-    @brief comparison: not equal
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    template < typename IterImpl, detail::enable_if_t < (std::is_same<IterImpl, iter_impl>::value || std::is_same<IterImpl, other_iter_impl>::value), std::nullptr_t > = nullptr >
-    bool operator!=(const IterImpl& other) const
-    {
-        return !operator==(other);
-    }
-
-    /*!
-    @brief comparison: smaller
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    bool operator<(const iter_impl& other) const
-    {
-        // if objects are not the same, the comparison is undefined
-        if (JSON_HEDLEY_UNLIKELY(m_object != other.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(212, "cannot compare iterators of different containers", *m_object));
-        }
-
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-                JSON_THROW(invalid_iterator::create(213, "cannot compare order of object iterators", *m_object));
-
-            case value_t::array:
-                return (m_it.array_iterator < other.m_it.array_iterator);
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-                return (m_it.primitive_iterator < other.m_it.primitive_iterator);
-        }
-    }
-
-    /*!
-    @brief comparison: less than or equal
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    bool operator<=(const iter_impl& other) const
-    {
-        return !other.operator < (*this);
-    }
-
-    /*!
-    @brief comparison: greater than
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    bool operator>(const iter_impl& other) const
-    {
-        return !operator<=(other);
-    }
-
-    /*!
-    @brief comparison: greater than or equal
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    bool operator>=(const iter_impl& other) const
-    {
-        return !operator<(other);
-    }
-
-    /*!
-    @brief add to iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl& operator+=(difference_type i)
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-                JSON_THROW(invalid_iterator::create(209, "cannot use offsets with object iterators", *m_object));
-
-            case value_t::array:
-            {
-                std::advance(m_it.array_iterator, i);
-                break;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                m_it.primitive_iterator += i;
-                break;
-            }
-        }
-
-        return *this;
-    }
-
-    /*!
-    @brief subtract from iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl& operator-=(difference_type i)
-    {
-        return operator+=(-i);
-    }
-
-    /*!
-    @brief add to iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl operator+(difference_type i) const
-    {
-        auto result = *this;
-        result += i;
-        return result;
-    }
-
-    /*!
-    @brief addition of distance and iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    friend iter_impl operator+(difference_type i, const iter_impl& it)
-    {
-        auto result = it;
-        result += i;
-        return result;
-    }
-
-    /*!
-    @brief subtract from iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    iter_impl operator-(difference_type i) const
-    {
-        auto result = *this;
-        result -= i;
-        return result;
-    }
-
-    /*!
-    @brief return difference
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    difference_type operator-(const iter_impl& other) const
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-                JSON_THROW(invalid_iterator::create(209, "cannot use offsets with object iterators", *m_object));
-
-            case value_t::array:
-                return m_it.array_iterator - other.m_it.array_iterator;
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-                return m_it.primitive_iterator - other.m_it.primitive_iterator;
-        }
-    }
-
-    /*!
-    @brief access to successor
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    reference operator[](difference_type n) const
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        switch (m_object->m_type)
-        {
-            case value_t::object:
-                JSON_THROW(invalid_iterator::create(208, "cannot use operator[] for object iterators", *m_object));
-
-            case value_t::array:
-                return *std::next(m_it.array_iterator, n);
-
-            case value_t::null:
-                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
-
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                if (JSON_HEDLEY_LIKELY(m_it.primitive_iterator.get_value() == -n))
-                {
-                    return *m_object;
-                }
-
-                JSON_THROW(invalid_iterator::create(214, "cannot get value", *m_object));
-            }
-        }
-    }
-
-    /*!
-    @brief return the key of an object iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    const typename object_t::key_type& key() const
-    {
-        JSON_ASSERT(m_object != nullptr);
-
-        if (JSON_HEDLEY_LIKELY(m_object->is_object()))
-        {
-            return m_it.object_iterator->first;
-        }
-
-        JSON_THROW(invalid_iterator::create(207, "cannot use key() for non-object iterators", *m_object));
-    }
-
-    /*!
-    @brief return the value of an iterator
-    @pre The iterator is initialized; i.e. `m_object != nullptr`.
-    */
-    reference value() const
-    {
-        return operator*();
-    }
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    /// associated JSON instance
-    pointer m_object = nullptr;
-    /// the actual iterator of the associated instance
-    internal_iterator<typename std::remove_const<BasicJsonType>::type> m_it {};
-};
-} // namespace detail
-} // namespace nlohmann
-
-// #include <nlohmann/detail/iterators/iteration_proxy.hpp>
-
-// #include <nlohmann/detail/iterators/json_reverse_iterator.hpp>
-
-
-#include <cstddef> // ptrdiff_t
-#include <iterator> // reverse_iterator
-#include <utility> // declval
-
-namespace nlohmann
-{
-namespace detail
-{
-//////////////////////
-// reverse_iterator //
-//////////////////////
-
-/*!
-@brief a template for a reverse iterator class
-
-@tparam Base the base iterator type to reverse. Valid types are @ref
-iterator (to create @ref reverse_iterator) and @ref const_iterator (to
-create @ref const_reverse_iterator).
-
-@requirement The class satisfies the following concept requirements:
--
-[BidirectionalIterator](https://en.cppreference.com/w/cpp/named_req/BidirectionalIterator):
-  The iterator that can be moved can be moved in both directions (i.e.
-  incremented and decremented).
-- [OutputIterator](https://en.cppreference.com/w/cpp/named_req/OutputIterator):
-  It is possible to write to the pointed-to element (only if @a Base is
-  @ref iterator).
-
-@since version 1.0.0
-*/
-template<typename Base>
-class json_reverse_iterator : public std::reverse_iterator<Base>
-{
-  public:
-    using difference_type = std::ptrdiff_t;
-    /// shortcut to the reverse iterator adapter
-    using base_iterator = std::reverse_iterator<Base>;
-    /// the reference type for the pointed-to element
-    using reference = typename Base::reference;
-
-    /// create reverse iterator from iterator
-    explicit json_reverse_iterator(const typename base_iterator::iterator_type& it) noexcept
-        : base_iterator(it) {}
-
-    /// create reverse iterator from base class
-    explicit json_reverse_iterator(const base_iterator& it) noexcept : base_iterator(it) {}
-
-    /// post-increment (it++)
-    json_reverse_iterator const operator++(int) // NOLINT(readability-const-return-type)
-    {
-        return static_cast<json_reverse_iterator>(base_iterator::operator++(1));
-    }
-
-    /// pre-increment (++it)
-    json_reverse_iterator& operator++()
-    {
-        return static_cast<json_reverse_iterator&>(base_iterator::operator++());
-    }
-
-    /// post-decrement (it--)
-    json_reverse_iterator const operator--(int) // NOLINT(readability-const-return-type)
-    {
-        return static_cast<json_reverse_iterator>(base_iterator::operator--(1));
-    }
-
-    /// pre-decrement (--it)
-    json_reverse_iterator& operator--()
-    {
-        return static_cast<json_reverse_iterator&>(base_iterator::operator--());
-    }
-
-    /// add to iterator
-    json_reverse_iterator& operator+=(difference_type i)
-    {
-        return static_cast<json_reverse_iterator&>(base_iterator::operator+=(i));
-    }
-
-    /// add to iterator
-    json_reverse_iterator operator+(difference_type i) const
-    {
-        return static_cast<json_reverse_iterator>(base_iterator::operator+(i));
-    }
-
-    /// subtract from iterator
-    json_reverse_iterator operator-(difference_type i) const
-    {
-        return static_cast<json_reverse_iterator>(base_iterator::operator-(i));
-    }
-
-    /// return difference
-    difference_type operator-(const json_reverse_iterator& other) const
-    {
-        return base_iterator(*this) - base_iterator(other);
-    }
-
-    /// access to successor
-    reference operator[](difference_type n) const
-    {
-        return *(this->operator+(n));
-    }
-
-    /// return the key of an object iterator
-    auto key() const -> decltype(std::declval<Base>().key())
-    {
-        auto it = --this->base();
-        return it.key();
-    }
-
-    /// return the value of an iterator
-    reference value() const
-    {
-        auto it = --this->base();
-        return it.operator * ();
-    }
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/iterators/primitive_iterator.hpp>
-
-// #include <nlohmann/detail/json_pointer.hpp>
-
-
-#include <algorithm> // all_of
-#include <cctype> // isdigit
-#include <limits> // max
-#include <numeric> // accumulate
-#include <string> // string
-#include <utility> // move
-#include <vector> // vector
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/string_escape.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-namespace nlohmann
-{
-
-/// @brief JSON Pointer defines a string syntax for identifying a specific value within a JSON document
-/// @sa https://json.nlohmann.me/api/json_pointer/
-template<typename BasicJsonType>
-class json_pointer
-{
-    // allow basic_json to access private members
-    NLOHMANN_BASIC_JSON_TPL_DECLARATION
-    friend class basic_json;
-
-  public:
-    /// @brief create JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/json_pointer/
-    explicit json_pointer(const std::string& s = "")
-        : reference_tokens(split(s))
-    {}
-
-    /// @brief return a string representation of the JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/to_string/
-    std::string to_string() const
-    {
-        return std::accumulate(reference_tokens.begin(), reference_tokens.end(),
-                               std::string{},
-                               [](const std::string & a, const std::string & b)
-        {
-            return a + "/" + detail::escape(b);
-        });
-    }
-
-    /// @brief return a string representation of the JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/operator_string/
-    operator std::string() const
-    {
-        return to_string();
-    }
-
-    /// @brief append another JSON pointer at the end of this JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slasheq/
-    json_pointer& operator/=(const json_pointer& ptr)
-    {
-        reference_tokens.insert(reference_tokens.end(),
-                                ptr.reference_tokens.begin(),
-                                ptr.reference_tokens.end());
-        return *this;
-    }
-
-    /// @brief append an unescaped reference token at the end of this JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slasheq/
-    json_pointer& operator/=(std::string token)
-    {
-        push_back(std::move(token));
-        return *this;
-    }
-
-    /// @brief append an array index at the end of this JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slasheq/
-    json_pointer& operator/=(std::size_t array_idx)
-    {
-        return *this /= std::to_string(array_idx);
-    }
-
-    /// @brief create a new JSON pointer by appending the right JSON pointer at the end of the left JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slash/
-    friend json_pointer operator/(const json_pointer& lhs,
-                                  const json_pointer& rhs)
-    {
-        return json_pointer(lhs) /= rhs;
-    }
-
-    /// @brief create a new JSON pointer by appending the unescaped token at the end of the JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slash/
-    friend json_pointer operator/(const json_pointer& lhs, std::string token) // NOLINT(performance-unnecessary-value-param)
-    {
-        return json_pointer(lhs) /= std::move(token);
-    }
-
-    /// @brief create a new JSON pointer by appending the array-index-token at the end of the JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/operator_slash/
-    friend json_pointer operator/(const json_pointer& lhs, std::size_t array_idx)
-    {
-        return json_pointer(lhs) /= array_idx;
-    }
-
-    /// @brief returns the parent of this JSON pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/parent_pointer/
-    json_pointer parent_pointer() const
-    {
-        if (empty())
-        {
-            return *this;
-        }
-
-        json_pointer res = *this;
-        res.pop_back();
-        return res;
-    }
-
-    /// @brief remove last reference token
-    /// @sa https://json.nlohmann.me/api/json_pointer/pop_back/
-    void pop_back()
-    {
-        if (JSON_HEDLEY_UNLIKELY(empty()))
-        {
-            JSON_THROW(detail::out_of_range::create(405, "JSON pointer has no parent", BasicJsonType()));
-        }
-
-        reference_tokens.pop_back();
-    }
-
-    /// @brief return last reference token
-    /// @sa https://json.nlohmann.me/api/json_pointer/back/
-    const std::string& back() const
-    {
-        if (JSON_HEDLEY_UNLIKELY(empty()))
-        {
-            JSON_THROW(detail::out_of_range::create(405, "JSON pointer has no parent", BasicJsonType()));
-        }
-
-        return reference_tokens.back();
-    }
-
-    /// @brief append an unescaped token at the end of the reference pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/push_back/
-    void push_back(const std::string& token)
-    {
-        reference_tokens.push_back(token);
-    }
-
-    /// @brief append an unescaped token at the end of the reference pointer
-    /// @sa https://json.nlohmann.me/api/json_pointer/push_back/
-    void push_back(std::string&& token)
-    {
-        reference_tokens.push_back(std::move(token));
-    }
-
-    /// @brief return whether pointer points to the root document
-    /// @sa https://json.nlohmann.me/api/json_pointer/empty/
-    bool empty() const noexcept
-    {
-        return reference_tokens.empty();
-    }
-
-  private:
-    /*!
-    @param[in] s  reference token to be converted into an array index
-
-    @return integer representation of @a s
-
-    @throw parse_error.106  if an array index begins with '0'
-    @throw parse_error.109  if an array index begins not with a digit
-    @throw out_of_range.404 if string @a s could not be converted to an integer
-    @throw out_of_range.410 if an array index exceeds size_type
-    */
-    static typename BasicJsonType::size_type array_index(const std::string& s)
-    {
-        using size_type = typename BasicJsonType::size_type;
-
-        // error condition (cf. RFC 6901, Sect. 4)
-        if (JSON_HEDLEY_UNLIKELY(s.size() > 1 && s[0] == '0'))
-        {
-            JSON_THROW(detail::parse_error::create(106, 0, "array index '" + s + "' must not begin with '0'", BasicJsonType()));
-        }
-
-        // error condition (cf. RFC 6901, Sect. 4)
-        if (JSON_HEDLEY_UNLIKELY(s.size() > 1 && !(s[0] >= '1' && s[0] <= '9')))
-        {
-            JSON_THROW(detail::parse_error::create(109, 0, "array index '" + s + "' is not a number", BasicJsonType()));
-        }
-
-        std::size_t processed_chars = 0;
-        unsigned long long res = 0;  // NOLINT(runtime/int)
-        JSON_TRY
-        {
-            res = std::stoull(s, &processed_chars);
-        }
-        JSON_CATCH(std::out_of_range&)
-        {
-            JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + s + "'", BasicJsonType()));
-        }
-
-        // check if the string was completely read
-        if (JSON_HEDLEY_UNLIKELY(processed_chars != s.size()))
-        {
-            JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + s + "'", BasicJsonType()));
-        }
-
-        // only triggered on special platforms (like 32bit), see also
-        // https://github.com/nlohmann/json/pull/2203
-        if (res >= static_cast<unsigned long long>((std::numeric_limits<size_type>::max)()))  // NOLINT(runtime/int)
-        {
-            JSON_THROW(detail::out_of_range::create(410, "array index " + s + " exceeds size_type", BasicJsonType())); // LCOV_EXCL_LINE
-        }
-
-        return static_cast<size_type>(res);
-    }
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    json_pointer top() const
-    {
-        if (JSON_HEDLEY_UNLIKELY(empty()))
-        {
-            JSON_THROW(detail::out_of_range::create(405, "JSON pointer has no parent", BasicJsonType()));
-        }
-
-        json_pointer result = *this;
-        result.reference_tokens = {reference_tokens[0]};
-        return result;
-    }
-
-  private:
-    /*!
-    @brief create and return a reference to the pointed to value
-
-    @complexity Linear in the number of reference tokens.
-
-    @throw parse_error.109 if array index is not a number
-    @throw type_error.313 if value cannot be unflattened
-    */
-    BasicJsonType& get_and_create(BasicJsonType& j) const
-    {
-        auto* result = &j;
-
-        // in case no reference tokens exist, return a reference to the JSON value
-        // j which will be overwritten by a primitive value
-        for (const auto& reference_token : reference_tokens)
-        {
-            switch (result->type())
-            {
-                case detail::value_t::null:
-                {
-                    if (reference_token == "0")
-                    {
-                        // start a new array if reference token is 0
-                        result = &result->operator[](0);
-                    }
-                    else
-                    {
-                        // start a new object otherwise
-                        result = &result->operator[](reference_token);
-                    }
-                    break;
-                }
-
-                case detail::value_t::object:
-                {
-                    // create an entry in the object
-                    result = &result->operator[](reference_token);
-                    break;
-                }
-
-                case detail::value_t::array:
-                {
-                    // create an entry in the array
-                    result = &result->operator[](array_index(reference_token));
-                    break;
-                }
-
-                /*
-                The following code is only reached if there exists a reference
-                token _and_ the current value is primitive. In this case, we have
-                an error situation, because primitive values may only occur as
-                single value; that is, with an empty list of reference tokens.
-                */
-                case detail::value_t::string:
-                case detail::value_t::boolean:
-                case detail::value_t::number_integer:
-                case detail::value_t::number_unsigned:
-                case detail::value_t::number_float:
-                case detail::value_t::binary:
-                case detail::value_t::discarded:
-                default:
-                    JSON_THROW(detail::type_error::create(313, "invalid value to unflatten", j));
-            }
-        }
-
-        return *result;
-    }
-
-    /*!
-    @brief return a reference to the pointed to value
-
-    @note This version does not throw if a value is not present, but tries to
-          create nested values instead. For instance, calling this function
-          with pointer `"/this/that"` on a null value is equivalent to calling
-          `operator[]("this").operator[]("that")` on that value, effectively
-          changing the null value to an object.
-
-    @param[in] ptr  a JSON value
-
-    @return reference to the JSON value pointed to by the JSON pointer
-
-    @complexity Linear in the length of the JSON pointer.
-
-    @throw parse_error.106   if an array index begins with '0'
-    @throw parse_error.109   if an array index was not a number
-    @throw out_of_range.404  if the JSON pointer can not be resolved
-    */
-    BasicJsonType& get_unchecked(BasicJsonType* ptr) const
-    {
-        for (const auto& reference_token : reference_tokens)
-        {
-            // convert null values to arrays or objects before continuing
-            if (ptr->is_null())
-            {
-                // check if reference token is a number
-                const bool nums =
-                    std::all_of(reference_token.begin(), reference_token.end(),
-                                [](const unsigned char x)
-                {
-                    return std::isdigit(x);
-                });
-
-                // change value to array for numbers or "-" or to object otherwise
-                *ptr = (nums || reference_token == "-")
-                       ? detail::value_t::array
-                       : detail::value_t::object;
-            }
-
-            switch (ptr->type())
-            {
-                case detail::value_t::object:
-                {
-                    // use unchecked object access
-                    ptr = &ptr->operator[](reference_token);
-                    break;
-                }
-
-                case detail::value_t::array:
-                {
-                    if (reference_token == "-")
-                    {
-                        // explicitly treat "-" as index beyond the end
-                        ptr = &ptr->operator[](ptr->m_value.array->size());
-                    }
-                    else
-                    {
-                        // convert array index to number; unchecked access
-                        ptr = &ptr->operator[](array_index(reference_token));
-                    }
-                    break;
-                }
-
-                case detail::value_t::null:
-                case detail::value_t::string:
-                case detail::value_t::boolean:
-                case detail::value_t::number_integer:
-                case detail::value_t::number_unsigned:
-                case detail::value_t::number_float:
-                case detail::value_t::binary:
-                case detail::value_t::discarded:
-                default:
-                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
-            }
-        }
-
-        return *ptr;
-    }
-
-    /*!
-    @throw parse_error.106   if an array index begins with '0'
-    @throw parse_error.109   if an array index was not a number
-    @throw out_of_range.402  if the array index '-' is used
-    @throw out_of_range.404  if the JSON pointer can not be resolved
-    */
-    BasicJsonType& get_checked(BasicJsonType* ptr) const
-    {
-        for (const auto& reference_token : reference_tokens)
-        {
-            switch (ptr->type())
-            {
-                case detail::value_t::object:
-                {
-                    // note: at performs range check
-                    ptr = &ptr->at(reference_token);
-                    break;
-                }
-
-                case detail::value_t::array:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
-                    {
-                        // "-" always fails the range check
-                        JSON_THROW(detail::out_of_range::create(402,
-                                                                "array index '-' (" + std::to_string(ptr->m_value.array->size()) +
-                                                                ") is out of range", *ptr));
-                    }
-
-                    // note: at performs range check
-                    ptr = &ptr->at(array_index(reference_token));
-                    break;
-                }
-
-                case detail::value_t::null:
-                case detail::value_t::string:
-                case detail::value_t::boolean:
-                case detail::value_t::number_integer:
-                case detail::value_t::number_unsigned:
-                case detail::value_t::number_float:
-                case detail::value_t::binary:
-                case detail::value_t::discarded:
-                default:
-                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
-            }
-        }
-
-        return *ptr;
-    }
-
-    /*!
-    @brief return a const reference to the pointed to value
-
-    @param[in] ptr  a JSON value
-
-    @return const reference to the JSON value pointed to by the JSON
-    pointer
-
-    @throw parse_error.106   if an array index begins with '0'
-    @throw parse_error.109   if an array index was not a number
-    @throw out_of_range.402  if the array index '-' is used
-    @throw out_of_range.404  if the JSON pointer can not be resolved
-    */
-    const BasicJsonType& get_unchecked(const BasicJsonType* ptr) const
-    {
-        for (const auto& reference_token : reference_tokens)
-        {
-            switch (ptr->type())
-            {
-                case detail::value_t::object:
-                {
-                    // use unchecked object access
-                    ptr = &ptr->operator[](reference_token);
-                    break;
-                }
-
-                case detail::value_t::array:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
-                    {
-                        // "-" cannot be used for const access
-                        JSON_THROW(detail::out_of_range::create(402, "array index '-' (" + std::to_string(ptr->m_value.array->size()) + ") is out of range", *ptr));
-                    }
-
-                    // use unchecked array access
-                    ptr = &ptr->operator[](array_index(reference_token));
-                    break;
-                }
-
-                case detail::value_t::null:
-                case detail::value_t::string:
-                case detail::value_t::boolean:
-                case detail::value_t::number_integer:
-                case detail::value_t::number_unsigned:
-                case detail::value_t::number_float:
-                case detail::value_t::binary:
-                case detail::value_t::discarded:
-                default:
-                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
-            }
-        }
-
-        return *ptr;
-    }
-
-    /*!
-    @throw parse_error.106   if an array index begins with '0'
-    @throw parse_error.109   if an array index was not a number
-    @throw out_of_range.402  if the array index '-' is used
-    @throw out_of_range.404  if the JSON pointer can not be resolved
-    */
-    const BasicJsonType& get_checked(const BasicJsonType* ptr) const
-    {
-        for (const auto& reference_token : reference_tokens)
-        {
-            switch (ptr->type())
-            {
-                case detail::value_t::object:
-                {
-                    // note: at performs range check
-                    ptr = &ptr->at(reference_token);
-                    break;
-                }
-
-                case detail::value_t::array:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
-                    {
-                        // "-" always fails the range check
-                        JSON_THROW(detail::out_of_range::create(402,
-                                                                "array index '-' (" + std::to_string(ptr->m_value.array->size()) +
-                                                                ") is out of range", *ptr));
-                    }
-
-                    // note: at performs range check
-                    ptr = &ptr->at(array_index(reference_token));
-                    break;
-                }
-
-                case detail::value_t::null:
-                case detail::value_t::string:
-                case detail::value_t::boolean:
-                case detail::value_t::number_integer:
-                case detail::value_t::number_unsigned:
-                case detail::value_t::number_float:
-                case detail::value_t::binary:
-                case detail::value_t::discarded:
-                default:
-                    JSON_THROW(detail::out_of_range::create(404, "unresolved reference token '" + reference_token + "'", *ptr));
-            }
-        }
-
-        return *ptr;
-    }
-
-    /*!
-    @throw parse_error.106   if an array index begins with '0'
-    @throw parse_error.109   if an array index was not a number
-    */
-    bool contains(const BasicJsonType* ptr) const
-    {
-        for (const auto& reference_token : reference_tokens)
-        {
-            switch (ptr->type())
-            {
-                case detail::value_t::object:
-                {
-                    if (!ptr->contains(reference_token))
-                    {
-                        // we did not find the key in the object
-                        return false;
-                    }
-
-                    ptr = &ptr->operator[](reference_token);
-                    break;
-                }
-
-                case detail::value_t::array:
-                {
-                    if (JSON_HEDLEY_UNLIKELY(reference_token == "-"))
-                    {
-                        // "-" always fails the range check
-                        return false;
-                    }
-                    if (JSON_HEDLEY_UNLIKELY(reference_token.size() == 1 && !("0" <= reference_token && reference_token <= "9")))
-                    {
-                        // invalid char
-                        return false;
-                    }
-                    if (JSON_HEDLEY_UNLIKELY(reference_token.size() > 1))
-                    {
-                        if (JSON_HEDLEY_UNLIKELY(!('1' <= reference_token[0] && reference_token[0] <= '9')))
-                        {
-                            // first char should be between '1' and '9'
-                            return false;
-                        }
-                        for (std::size_t i = 1; i < reference_token.size(); i++)
-                        {
-                            if (JSON_HEDLEY_UNLIKELY(!('0' <= reference_token[i] && reference_token[i] <= '9')))
-                            {
-                                // other char should be between '0' and '9'
-                                return false;
-                            }
-                        }
-                    }
-
-                    const auto idx = array_index(reference_token);
-                    if (idx >= ptr->size())
-                    {
-                        // index out of range
-                        return false;
-                    }
-
-                    ptr = &ptr->operator[](idx);
-                    break;
-                }
-
-                case detail::value_t::null:
-                case detail::value_t::string:
-                case detail::value_t::boolean:
-                case detail::value_t::number_integer:
-                case detail::value_t::number_unsigned:
-                case detail::value_t::number_float:
-                case detail::value_t::binary:
-                case detail::value_t::discarded:
-                default:
-                {
-                    // we do not expect primitive values if there is still a
-                    // reference token to process
-                    return false;
-                }
-            }
-        }
-
-        // no reference token left means we found a primitive value
-        return true;
-    }
-
-    /*!
-    @brief split the string input to reference tokens
-
-    @note This function is only called by the json_pointer constructor.
-          All exceptions below are documented there.
-
-    @throw parse_error.107  if the pointer is not empty or begins with '/'
-    @throw parse_error.108  if character '~' is not followed by '0' or '1'
-    */
-    static std::vector<std::string> split(const std::string& reference_string)
-    {
-        std::vector<std::string> result;
-
-        // special case: empty reference string -> no reference tokens
-        if (reference_string.empty())
-        {
-            return result;
-        }
-
-        // check if nonempty reference string begins with slash
-        if (JSON_HEDLEY_UNLIKELY(reference_string[0] != '/'))
-        {
-            JSON_THROW(detail::parse_error::create(107, 1, "JSON pointer must be empty or begin with '/' - was: '" + reference_string + "'", BasicJsonType()));
-        }
-
-        // extract the reference tokens:
-        // - slash: position of the last read slash (or end of string)
-        // - start: position after the previous slash
-        for (
-            // search for the first slash after the first character
-            std::size_t slash = reference_string.find_first_of('/', 1),
-            // set the beginning of the first reference token
-            start = 1;
-            // we can stop if start == 0 (if slash == std::string::npos)
-            start != 0;
-            // set the beginning of the next reference token
-            // (will eventually be 0 if slash == std::string::npos)
-            start = (slash == std::string::npos) ? 0 : slash + 1,
-            // find next slash
-            slash = reference_string.find_first_of('/', start))
-        {
-            // use the text between the beginning of the reference token
-            // (start) and the last slash (slash).
-            auto reference_token = reference_string.substr(start, slash - start);
-
-            // check reference tokens are properly escaped
-            for (std::size_t pos = reference_token.find_first_of('~');
-                    pos != std::string::npos;
-                    pos = reference_token.find_first_of('~', pos + 1))
-            {
-                JSON_ASSERT(reference_token[pos] == '~');
-
-                // ~ must be followed by 0 or 1
-                if (JSON_HEDLEY_UNLIKELY(pos == reference_token.size() - 1 ||
-                                         (reference_token[pos + 1] != '0' &&
-                                          reference_token[pos + 1] != '1')))
-                {
-                    JSON_THROW(detail::parse_error::create(108, 0, "escape character '~' must be followed with '0' or '1'", BasicJsonType()));
-                }
-            }
-
-            // finally, store the reference token
-            detail::unescape(reference_token);
-            result.push_back(reference_token);
-        }
-
-        return result;
-    }
-
-  private:
-    /*!
-    @param[in] reference_string  the reference string to the current value
-    @param[in] value             the value to consider
-    @param[in,out] result        the result object to insert values to
-
-    @note Empty objects or arrays are flattened to `null`.
-    */
-    static void flatten(const std::string& reference_string,
-                        const BasicJsonType& value,
-                        BasicJsonType& result)
-    {
-        switch (value.type())
-        {
-            case detail::value_t::array:
-            {
-                if (value.m_value.array->empty())
-                {
-                    // flatten empty array as null
-                    result[reference_string] = nullptr;
-                }
-                else
-                {
-                    // iterate array and use index as reference string
-                    for (std::size_t i = 0; i < value.m_value.array->size(); ++i)
-                    {
-                        flatten(reference_string + "/" + std::to_string(i),
-                                value.m_value.array->operator[](i), result);
-                    }
-                }
-                break;
-            }
-
-            case detail::value_t::object:
-            {
-                if (value.m_value.object->empty())
-                {
-                    // flatten empty object as null
-                    result[reference_string] = nullptr;
-                }
-                else
-                {
-                    // iterate object and use keys as reference string
-                    for (const auto& element : *value.m_value.object)
-                    {
-                        flatten(reference_string + "/" + detail::escape(element.first), element.second, result);
-                    }
-                }
-                break;
-            }
-
-            case detail::value_t::null:
-            case detail::value_t::string:
-            case detail::value_t::boolean:
-            case detail::value_t::number_integer:
-            case detail::value_t::number_unsigned:
-            case detail::value_t::number_float:
-            case detail::value_t::binary:
-            case detail::value_t::discarded:
-            default:
-            {
-                // add primitive value with its reference string
-                result[reference_string] = value;
-                break;
-            }
-        }
-    }
-
-    /*!
-    @param[in] value  flattened JSON
-
-    @return unflattened JSON
-
-    @throw parse_error.109 if array index is not a number
-    @throw type_error.314  if value is not an object
-    @throw type_error.315  if object values are not primitive
-    @throw type_error.313  if value cannot be unflattened
-    */
-    static BasicJsonType
-    unflatten(const BasicJsonType& value)
-    {
-        if (JSON_HEDLEY_UNLIKELY(!value.is_object()))
-        {
-            JSON_THROW(detail::type_error::create(314, "only objects can be unflattened", value));
-        }
-
-        BasicJsonType result;
-
-        // iterate the JSON object values
-        for (const auto& element : *value.m_value.object)
-        {
-            if (JSON_HEDLEY_UNLIKELY(!element.second.is_primitive()))
-            {
-                JSON_THROW(detail::type_error::create(315, "values in object must be primitive", element.second));
-            }
-
-            // assign value to reference pointed to by JSON pointer; Note that if
-            // the JSON pointer is "" (i.e., points to the whole value), function
-            // get_and_create returns a reference to result itself. An assignment
-            // will then create a primitive value.
-            json_pointer(element.first).get_and_create(result) = element.second;
-        }
-
-        return result;
-    }
-
-    /*!
-    @brief compares two JSON pointers for equality
-
-    @param[in] lhs  JSON pointer to compare
-    @param[in] rhs  JSON pointer to compare
-    @return whether @a lhs is equal to @a rhs
-
-    @complexity Linear in the length of the JSON pointer
-
-    @exceptionsafety No-throw guarantee: this function never throws exceptions.
-    */
-    friend bool operator==(json_pointer const& lhs,
-                           json_pointer const& rhs) noexcept
-    {
-        return lhs.reference_tokens == rhs.reference_tokens;
-    }
-
-    /*!
-    @brief compares two JSON pointers for inequality
-
-    @param[in] lhs  JSON pointer to compare
-    @param[in] rhs  JSON pointer to compare
-    @return whether @a lhs is not equal @a rhs
-
-    @complexity Linear in the length of the JSON pointer
-
-    @exceptionsafety No-throw guarantee: this function never throws exceptions.
-    */
-    friend bool operator!=(json_pointer const& lhs,
-                           json_pointer const& rhs) noexcept
-    {
-        return !(lhs == rhs);
-    }
-
-    /// the reference tokens
-    std::vector<std::string> reference_tokens;
-};
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/json_ref.hpp>
-
-
-#include <initializer_list>
-#include <utility>
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-template<typename BasicJsonType>
-class json_ref
-{
-  public:
-    using value_type = BasicJsonType;
-
-    json_ref(value_type&& value)
-        : owned_value(std::move(value))
-    {}
-
-    json_ref(const value_type& value)
-        : value_ref(&value)
-    {}
-
-    json_ref(std::initializer_list<json_ref> init)
-        : owned_value(init)
-    {}
-
-    template <
-        class... Args,
-        enable_if_t<std::is_constructible<value_type, Args...>::value, int> = 0 >
-    json_ref(Args && ... args)
-        : owned_value(std::forward<Args>(args)...)
-    {}
-
-    // class should be movable only
-    json_ref(json_ref&&) noexcept = default;
-    json_ref(const json_ref&) = delete;
-    json_ref& operator=(const json_ref&) = delete;
-    json_ref& operator=(json_ref&&) = delete;
-    ~json_ref() = default;
-
-    value_type moved_or_copied() const
-    {
-        if (value_ref == nullptr)
-        {
-            return std::move(owned_value);
-        }
-        return *value_ref;
-    }
-
-    value_type const& operator*() const
-    {
-        return value_ref ? *value_ref : owned_value;
-    }
-
-    value_type const* operator->() const
-    {
-        return &** this;
-    }
-
-  private:
-    mutable value_type owned_value = nullptr;
-    value_type const* value_ref = nullptr;
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/string_escape.hpp>
-
-// #include <nlohmann/detail/meta/cpp_future.hpp>
-
-// #include <nlohmann/detail/meta/type_traits.hpp>
-
-// #include <nlohmann/detail/output/binary_writer.hpp>
-
-
-#include <algorithm> // reverse
-#include <array> // array
-#include <cmath> // isnan, isinf
-#include <cstdint> // uint8_t, uint16_t, uint32_t, uint64_t
-#include <cstring> // memcpy
-#include <limits> // numeric_limits
-#include <string> // string
-#include <utility> // move
-
-// #include <nlohmann/detail/input/binary_reader.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/output/output_adapters.hpp>
-
-
-#include <algorithm> // copy
-#include <cstddef> // size_t
-#include <iterator> // back_inserter
-#include <memory> // shared_ptr, make_shared
-#include <string> // basic_string
-#include <vector> // vector
-
-#ifndef JSON_NO_IO
-    #include <ios>      // streamsize
-    #include <ostream>  // basic_ostream
-#endif  // JSON_NO_IO
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-/// abstract output adapter interface
-template<typename CharType> struct output_adapter_protocol
-{
-    virtual void write_character(CharType c) = 0;
-    virtual void write_characters(const CharType* s, std::size_t length) = 0;
-    virtual ~output_adapter_protocol() = default;
-
-    output_adapter_protocol() = default;
-    output_adapter_protocol(const output_adapter_protocol&) = default;
-    output_adapter_protocol(output_adapter_protocol&&) noexcept = default;
-    output_adapter_protocol& operator=(const output_adapter_protocol&) = default;
-    output_adapter_protocol& operator=(output_adapter_protocol&&) noexcept = default;
-};
-
-/// a type to simplify interfaces
-template<typename CharType>
-using output_adapter_t = std::shared_ptr<output_adapter_protocol<CharType>>;
-
-/// output adapter for byte vectors
-template<typename CharType, typename AllocatorType = std::allocator<CharType>>
-class output_vector_adapter : public output_adapter_protocol<CharType>
-{
-  public:
-    explicit output_vector_adapter(std::vector<CharType, AllocatorType>& vec) noexcept
-        : v(vec)
-    {}
-
-    void write_character(CharType c) override
-    {
-        v.push_back(c);
-    }
-
-    JSON_HEDLEY_NON_NULL(2)
-    void write_characters(const CharType* s, std::size_t length) override
-    {
-        std::copy(s, s + length, std::back_inserter(v));
-    }
-
-  private:
-    std::vector<CharType, AllocatorType>& v;
-};
-
-#ifndef JSON_NO_IO
-/// output adapter for output streams
-template<typename CharType>
-class output_stream_adapter : public output_adapter_protocol<CharType>
-{
-  public:
-    explicit output_stream_adapter(std::basic_ostream<CharType>& s) noexcept
-        : stream(s)
-    {}
-
-    void write_character(CharType c) override
-    {
-        stream.put(c);
-    }
-
-    JSON_HEDLEY_NON_NULL(2)
-    void write_characters(const CharType* s, std::size_t length) override
-    {
-        stream.write(s, static_cast<std::streamsize>(length));
-    }
-
-  private:
-    std::basic_ostream<CharType>& stream;
-};
-#endif  // JSON_NO_IO
-
-/// output adapter for basic_string
-template<typename CharType, typename StringType = std::basic_string<CharType>>
-class output_string_adapter : public output_adapter_protocol<CharType>
-{
-  public:
-    explicit output_string_adapter(StringType& s) noexcept
-        : str(s)
-    {}
-
-    void write_character(CharType c) override
-    {
-        str.push_back(c);
-    }
-
-    JSON_HEDLEY_NON_NULL(2)
-    void write_characters(const CharType* s, std::size_t length) override
-    {
-        str.append(s, length);
-    }
-
-  private:
-    StringType& str;
-};
-
-template<typename CharType, typename StringType = std::basic_string<CharType>>
-class output_adapter
-{
-  public:
-    template<typename AllocatorType = std::allocator<CharType>>
-    output_adapter(std::vector<CharType, AllocatorType>& vec)
-        : oa(std::make_shared<output_vector_adapter<CharType, AllocatorType>>(vec)) {}
-
-#ifndef JSON_NO_IO
-    output_adapter(std::basic_ostream<CharType>& s)
-        : oa(std::make_shared<output_stream_adapter<CharType>>(s)) {}
-#endif  // JSON_NO_IO
-
-    output_adapter(StringType& s)
-        : oa(std::make_shared<output_string_adapter<CharType, StringType>>(s)) {}
-
-    operator output_adapter_t<CharType>()
-    {
-        return oa;
-    }
-
-  private:
-    output_adapter_t<CharType> oa = nullptr;
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-
-namespace nlohmann
-{
-namespace detail
-{
-///////////////////
-// binary writer //
-///////////////////
-
-/*!
-@brief serialization to CBOR and MessagePack values
-*/
-template<typename BasicJsonType, typename CharType>
-class binary_writer
-{
-    using string_t = typename BasicJsonType::string_t;
-    using binary_t = typename BasicJsonType::binary_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-
-  public:
-    /*!
-    @brief create a binary writer
-
-    @param[in] adapter  output adapter to write to
-    */
-    explicit binary_writer(output_adapter_t<CharType> adapter) : oa(std::move(adapter))
-    {
-        JSON_ASSERT(oa);
-    }
-
-    /*!
-    @param[in] j  JSON value to serialize
-    @pre       j.type() == value_t::object
-    */
-    void write_bson(const BasicJsonType& j)
-    {
-        switch (j.type())
-        {
-            case value_t::object:
-            {
-                write_bson_object(*j.m_value.object);
-                break;
-            }
-
-            case value_t::null:
-            case value_t::array:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                JSON_THROW(type_error::create(317, "to serialize to BSON, top-level type must be object, but is " + std::string(j.type_name()), j));
-            }
-        }
-    }
-
-    /*!
-    @param[in] j  JSON value to serialize
-    */
-    void write_cbor(const BasicJsonType& j)
-    {
-        switch (j.type())
-        {
-            case value_t::null:
-            {
-                oa->write_character(to_char_type(0xF6));
-                break;
-            }
-
-            case value_t::boolean:
-            {
-                oa->write_character(j.m_value.boolean
-                                    ? to_char_type(0xF5)
-                                    : to_char_type(0xF4));
-                break;
-            }
-
-            case value_t::number_integer:
-            {
-                if (j.m_value.number_integer >= 0)
-                {
-                    // CBOR does not differentiate between positive signed
-                    // integers and unsigned integers. Therefore, we used the
-                    // code from the value_t::number_unsigned case here.
-                    if (j.m_value.number_integer <= 0x17)
-                    {
-                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_integer <= (std::numeric_limits<std::uint8_t>::max)())
-                    {
-                        oa->write_character(to_char_type(0x18));
-                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_integer <= (std::numeric_limits<std::uint16_t>::max)())
-                    {
-                        oa->write_character(to_char_type(0x19));
-                        write_number(static_cast<std::uint16_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_integer <= (std::numeric_limits<std::uint32_t>::max)())
-                    {
-                        oa->write_character(to_char_type(0x1A));
-                        write_number(static_cast<std::uint32_t>(j.m_value.number_integer));
-                    }
-                    else
-                    {
-                        oa->write_character(to_char_type(0x1B));
-                        write_number(static_cast<std::uint64_t>(j.m_value.number_integer));
-                    }
-                }
-                else
-                {
-                    // The conversions below encode the sign in the first
-                    // byte, and the value is converted to a positive number.
-                    const auto positive_number = -1 - j.m_value.number_integer;
-                    if (j.m_value.number_integer >= -24)
-                    {
-                        write_number(static_cast<std::uint8_t>(0x20 + positive_number));
-                    }
-                    else if (positive_number <= (std::numeric_limits<std::uint8_t>::max)())
-                    {
-                        oa->write_character(to_char_type(0x38));
-                        write_number(static_cast<std::uint8_t>(positive_number));
-                    }
-                    else if (positive_number <= (std::numeric_limits<std::uint16_t>::max)())
-                    {
-                        oa->write_character(to_char_type(0x39));
-                        write_number(static_cast<std::uint16_t>(positive_number));
-                    }
-                    else if (positive_number <= (std::numeric_limits<std::uint32_t>::max)())
-                    {
-                        oa->write_character(to_char_type(0x3A));
-                        write_number(static_cast<std::uint32_t>(positive_number));
-                    }
-                    else
-                    {
-                        oa->write_character(to_char_type(0x3B));
-                        write_number(static_cast<std::uint64_t>(positive_number));
-                    }
-                }
-                break;
-            }
-
-            case value_t::number_unsigned:
-            {
-                if (j.m_value.number_unsigned <= 0x17)
-                {
-                    write_number(static_cast<std::uint8_t>(j.m_value.number_unsigned));
-                }
-                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x18));
-                    write_number(static_cast<std::uint8_t>(j.m_value.number_unsigned));
-                }
-                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x19));
-                    write_number(static_cast<std::uint16_t>(j.m_value.number_unsigned));
-                }
-                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x1A));
-                    write_number(static_cast<std::uint32_t>(j.m_value.number_unsigned));
-                }
-                else
-                {
-                    oa->write_character(to_char_type(0x1B));
-                    write_number(static_cast<std::uint64_t>(j.m_value.number_unsigned));
-                }
-                break;
-            }
-
-            case value_t::number_float:
-            {
-                if (std::isnan(j.m_value.number_float))
-                {
-                    // NaN is 0xf97e00 in CBOR
-                    oa->write_character(to_char_type(0xF9));
-                    oa->write_character(to_char_type(0x7E));
-                    oa->write_character(to_char_type(0x00));
-                }
-                else if (std::isinf(j.m_value.number_float))
-                {
-                    // Infinity is 0xf97c00, -Infinity is 0xf9fc00
-                    oa->write_character(to_char_type(0xf9));
-                    oa->write_character(j.m_value.number_float > 0 ? to_char_type(0x7C) : to_char_type(0xFC));
-                    oa->write_character(to_char_type(0x00));
-                }
-                else
-                {
-                    write_compact_float(j.m_value.number_float, detail::input_format_t::cbor);
-                }
-                break;
-            }
-
-            case value_t::string:
-            {
-                // step 1: write control byte and the string length
-                const auto N = j.m_value.string->size();
-                if (N <= 0x17)
-                {
-                    write_number(static_cast<std::uint8_t>(0x60 + N));
-                }
-                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x78));
-                    write_number(static_cast<std::uint8_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x79));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x7A));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-                // LCOV_EXCL_START
-                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x7B));
-                    write_number(static_cast<std::uint64_t>(N));
-                }
-                // LCOV_EXCL_STOP
-
-                // step 2: write the string
-                oa->write_characters(
-                    reinterpret_cast<const CharType*>(j.m_value.string->c_str()),
-                    j.m_value.string->size());
-                break;
-            }
-
-            case value_t::array:
-            {
-                // step 1: write control byte and the array size
-                const auto N = j.m_value.array->size();
-                if (N <= 0x17)
-                {
-                    write_number(static_cast<std::uint8_t>(0x80 + N));
-                }
-                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x98));
-                    write_number(static_cast<std::uint8_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x99));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x9A));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-                // LCOV_EXCL_START
-                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x9B));
-                    write_number(static_cast<std::uint64_t>(N));
-                }
-                // LCOV_EXCL_STOP
-
-                // step 2: write each element
-                for (const auto& el : *j.m_value.array)
-                {
-                    write_cbor(el);
-                }
-                break;
-            }
-
-            case value_t::binary:
-            {
-                if (j.m_value.binary->has_subtype())
-                {
-                    if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint8_t>::max)())
-                    {
-                        write_number(static_cast<std::uint8_t>(0xd8));
-                        write_number(static_cast<std::uint8_t>(j.m_value.binary->subtype()));
-                    }
-                    else if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint16_t>::max)())
-                    {
-                        write_number(static_cast<std::uint8_t>(0xd9));
-                        write_number(static_cast<std::uint16_t>(j.m_value.binary->subtype()));
-                    }
-                    else if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint32_t>::max)())
-                    {
-                        write_number(static_cast<std::uint8_t>(0xda));
-                        write_number(static_cast<std::uint32_t>(j.m_value.binary->subtype()));
-                    }
-                    else if (j.m_value.binary->subtype() <= (std::numeric_limits<std::uint64_t>::max)())
-                    {
-                        write_number(static_cast<std::uint8_t>(0xdb));
-                        write_number(static_cast<std::uint64_t>(j.m_value.binary->subtype()));
-                    }
-                }
-
-                // step 1: write control byte and the binary array size
-                const auto N = j.m_value.binary->size();
-                if (N <= 0x17)
-                {
-                    write_number(static_cast<std::uint8_t>(0x40 + N));
-                }
-                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x58));
-                    write_number(static_cast<std::uint8_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x59));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x5A));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-                // LCOV_EXCL_START
-                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
-                {
-                    oa->write_character(to_char_type(0x5B));
-                    write_number(static_cast<std::uint64_t>(N));
-                }
-                // LCOV_EXCL_STOP
-
-                // step 2: write each element
-                oa->write_characters(
-                    reinterpret_cast<const CharType*>(j.m_value.binary->data()),
-                    N);
-
-                break;
-            }
-
-            case value_t::object:
-            {
-                // step 1: write control byte and the object size
-                const auto N = j.m_value.object->size();
-                if (N <= 0x17)
-                {
-                    write_number(static_cast<std::uint8_t>(0xA0 + N));
-                }
-                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    oa->write_character(to_char_type(0xB8));
-                    write_number(static_cast<std::uint8_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    oa->write_character(to_char_type(0xB9));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    oa->write_character(to_char_type(0xBA));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-                // LCOV_EXCL_START
-                else if (N <= (std::numeric_limits<std::uint64_t>::max)())
-                {
-                    oa->write_character(to_char_type(0xBB));
-                    write_number(static_cast<std::uint64_t>(N));
-                }
-                // LCOV_EXCL_STOP
-
-                // step 2: write each element
-                for (const auto& el : *j.m_value.object)
-                {
-                    write_cbor(el.first);
-                    write_cbor(el.second);
-                }
-                break;
-            }
-
-            case value_t::discarded:
-            default:
-                break;
-        }
-    }
-
-    /*!
-    @param[in] j  JSON value to serialize
-    */
-    void write_msgpack(const BasicJsonType& j)
-    {
-        switch (j.type())
-        {
-            case value_t::null: // nil
-            {
-                oa->write_character(to_char_type(0xC0));
-                break;
-            }
-
-            case value_t::boolean: // true and false
-            {
-                oa->write_character(j.m_value.boolean
-                                    ? to_char_type(0xC3)
-                                    : to_char_type(0xC2));
-                break;
-            }
-
-            case value_t::number_integer:
-            {
-                if (j.m_value.number_integer >= 0)
-                {
-                    // MessagePack does not differentiate between positive
-                    // signed integers and unsigned integers. Therefore, we used
-                    // the code from the value_t::number_unsigned case here.
-                    if (j.m_value.number_unsigned < 128)
-                    {
-                        // positive fixnum
-                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint8_t>::max)())
-                    {
-                        // uint 8
-                        oa->write_character(to_char_type(0xCC));
-                        write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint16_t>::max)())
-                    {
-                        // uint 16
-                        oa->write_character(to_char_type(0xCD));
-                        write_number(static_cast<std::uint16_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint32_t>::max)())
-                    {
-                        // uint 32
-                        oa->write_character(to_char_type(0xCE));
-                        write_number(static_cast<std::uint32_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint64_t>::max)())
-                    {
-                        // uint 64
-                        oa->write_character(to_char_type(0xCF));
-                        write_number(static_cast<std::uint64_t>(j.m_value.number_integer));
-                    }
-                }
-                else
-                {
-                    if (j.m_value.number_integer >= -32)
-                    {
-                        // negative fixnum
-                        write_number(static_cast<std::int8_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int8_t>::min)() &&
-                             j.m_value.number_integer <= (std::numeric_limits<std::int8_t>::max)())
-                    {
-                        // int 8
-                        oa->write_character(to_char_type(0xD0));
-                        write_number(static_cast<std::int8_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int16_t>::min)() &&
-                             j.m_value.number_integer <= (std::numeric_limits<std::int16_t>::max)())
-                    {
-                        // int 16
-                        oa->write_character(to_char_type(0xD1));
-                        write_number(static_cast<std::int16_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int32_t>::min)() &&
-                             j.m_value.number_integer <= (std::numeric_limits<std::int32_t>::max)())
-                    {
-                        // int 32
-                        oa->write_character(to_char_type(0xD2));
-                        write_number(static_cast<std::int32_t>(j.m_value.number_integer));
-                    }
-                    else if (j.m_value.number_integer >= (std::numeric_limits<std::int64_t>::min)() &&
-                             j.m_value.number_integer <= (std::numeric_limits<std::int64_t>::max)())
-                    {
-                        // int 64
-                        oa->write_character(to_char_type(0xD3));
-                        write_number(static_cast<std::int64_t>(j.m_value.number_integer));
-                    }
-                }
-                break;
-            }
-
-            case value_t::number_unsigned:
-            {
-                if (j.m_value.number_unsigned < 128)
-                {
-                    // positive fixnum
-                    write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
-                }
-                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    // uint 8
-                    oa->write_character(to_char_type(0xCC));
-                    write_number(static_cast<std::uint8_t>(j.m_value.number_integer));
-                }
-                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    // uint 16
-                    oa->write_character(to_char_type(0xCD));
-                    write_number(static_cast<std::uint16_t>(j.m_value.number_integer));
-                }
-                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    // uint 32
-                    oa->write_character(to_char_type(0xCE));
-                    write_number(static_cast<std::uint32_t>(j.m_value.number_integer));
-                }
-                else if (j.m_value.number_unsigned <= (std::numeric_limits<std::uint64_t>::max)())
-                {
-                    // uint 64
-                    oa->write_character(to_char_type(0xCF));
-                    write_number(static_cast<std::uint64_t>(j.m_value.number_integer));
-                }
-                break;
-            }
-
-            case value_t::number_float:
-            {
-                write_compact_float(j.m_value.number_float, detail::input_format_t::msgpack);
-                break;
-            }
-
-            case value_t::string:
-            {
-                // step 1: write control byte and the string length
-                const auto N = j.m_value.string->size();
-                if (N <= 31)
-                {
-                    // fixstr
-                    write_number(static_cast<std::uint8_t>(0xA0 | N));
-                }
-                else if (N <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    // str 8
-                    oa->write_character(to_char_type(0xD9));
-                    write_number(static_cast<std::uint8_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    // str 16
-                    oa->write_character(to_char_type(0xDA));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    // str 32
-                    oa->write_character(to_char_type(0xDB));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-
-                // step 2: write the string
-                oa->write_characters(
-                    reinterpret_cast<const CharType*>(j.m_value.string->c_str()),
-                    j.m_value.string->size());
-                break;
-            }
-
-            case value_t::array:
-            {
-                // step 1: write control byte and the array size
-                const auto N = j.m_value.array->size();
-                if (N <= 15)
-                {
-                    // fixarray
-                    write_number(static_cast<std::uint8_t>(0x90 | N));
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    // array 16
-                    oa->write_character(to_char_type(0xDC));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    // array 32
-                    oa->write_character(to_char_type(0xDD));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-
-                // step 2: write each element
-                for (const auto& el : *j.m_value.array)
-                {
-                    write_msgpack(el);
-                }
-                break;
-            }
-
-            case value_t::binary:
-            {
-                // step 0: determine if the binary type has a set subtype to
-                // determine whether or not to use the ext or fixext types
-                const bool use_ext = j.m_value.binary->has_subtype();
-
-                // step 1: write control byte and the byte string length
-                const auto N = j.m_value.binary->size();
-                if (N <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    std::uint8_t output_type{};
-                    bool fixed = true;
-                    if (use_ext)
-                    {
-                        switch (N)
-                        {
-                            case 1:
-                                output_type = 0xD4; // fixext 1
-                                break;
-                            case 2:
-                                output_type = 0xD5; // fixext 2
-                                break;
-                            case 4:
-                                output_type = 0xD6; // fixext 4
-                                break;
-                            case 8:
-                                output_type = 0xD7; // fixext 8
-                                break;
-                            case 16:
-                                output_type = 0xD8; // fixext 16
-                                break;
-                            default:
-                                output_type = 0xC7; // ext 8
-                                fixed = false;
-                                break;
-                        }
-
-                    }
-                    else
-                    {
-                        output_type = 0xC4; // bin 8
-                        fixed = false;
-                    }
-
-                    oa->write_character(to_char_type(output_type));
-                    if (!fixed)
-                    {
-                        write_number(static_cast<std::uint8_t>(N));
-                    }
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    std::uint8_t output_type = use_ext
-                                               ? 0xC8 // ext 16
-                                               : 0xC5; // bin 16
-
-                    oa->write_character(to_char_type(output_type));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    std::uint8_t output_type = use_ext
-                                               ? 0xC9 // ext 32
-                                               : 0xC6; // bin 32
-
-                    oa->write_character(to_char_type(output_type));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-
-                // step 1.5: if this is an ext type, write the subtype
-                if (use_ext)
-                {
-                    write_number(static_cast<std::int8_t>(j.m_value.binary->subtype()));
-                }
-
-                // step 2: write the byte string
-                oa->write_characters(
-                    reinterpret_cast<const CharType*>(j.m_value.binary->data()),
-                    N);
-
-                break;
-            }
-
-            case value_t::object:
-            {
-                // step 1: write control byte and the object size
-                const auto N = j.m_value.object->size();
-                if (N <= 15)
-                {
-                    // fixmap
-                    write_number(static_cast<std::uint8_t>(0x80 | (N & 0xF)));
-                }
-                else if (N <= (std::numeric_limits<std::uint16_t>::max)())
-                {
-                    // map 16
-                    oa->write_character(to_char_type(0xDE));
-                    write_number(static_cast<std::uint16_t>(N));
-                }
-                else if (N <= (std::numeric_limits<std::uint32_t>::max)())
-                {
-                    // map 32
-                    oa->write_character(to_char_type(0xDF));
-                    write_number(static_cast<std::uint32_t>(N));
-                }
-
-                // step 2: write each element
-                for (const auto& el : *j.m_value.object)
-                {
-                    write_msgpack(el.first);
-                    write_msgpack(el.second);
-                }
-                break;
-            }
-
-            case value_t::discarded:
-            default:
-                break;
-        }
-    }
-
-    /*!
-    @param[in] j  JSON value to serialize
-    @param[in] use_count   whether to use '#' prefixes (optimized format)
-    @param[in] use_type    whether to use '$' prefixes (optimized format)
-    @param[in] add_prefix  whether prefixes need to be used for this value
-    */
-    void write_ubjson(const BasicJsonType& j, const bool use_count,
-                      const bool use_type, const bool add_prefix = true)
-    {
-        switch (j.type())
-        {
-            case value_t::null:
-            {
-                if (add_prefix)
-                {
-                    oa->write_character(to_char_type('Z'));
-                }
-                break;
-            }
-
-            case value_t::boolean:
-            {
-                if (add_prefix)
-                {
-                    oa->write_character(j.m_value.boolean
-                                        ? to_char_type('T')
-                                        : to_char_type('F'));
-                }
-                break;
-            }
-
-            case value_t::number_integer:
-            {
-                write_number_with_ubjson_prefix(j.m_value.number_integer, add_prefix);
-                break;
-            }
-
-            case value_t::number_unsigned:
-            {
-                write_number_with_ubjson_prefix(j.m_value.number_unsigned, add_prefix);
-                break;
-            }
-
-            case value_t::number_float:
-            {
-                write_number_with_ubjson_prefix(j.m_value.number_float, add_prefix);
-                break;
-            }
-
-            case value_t::string:
-            {
-                if (add_prefix)
-                {
-                    oa->write_character(to_char_type('S'));
-                }
-                write_number_with_ubjson_prefix(j.m_value.string->size(), true);
-                oa->write_characters(
-                    reinterpret_cast<const CharType*>(j.m_value.string->c_str()),
-                    j.m_value.string->size());
-                break;
-            }
-
-            case value_t::array:
-            {
-                if (add_prefix)
-                {
-                    oa->write_character(to_char_type('['));
-                }
-
-                bool prefix_required = true;
-                if (use_type && !j.m_value.array->empty())
-                {
-                    JSON_ASSERT(use_count);
-                    const CharType first_prefix = ubjson_prefix(j.front());
-                    const bool same_prefix = std::all_of(j.begin() + 1, j.end(),
-                                                         [this, first_prefix](const BasicJsonType & v)
-                    {
-                        return ubjson_prefix(v) == first_prefix;
-                    });
-
-                    if (same_prefix)
-                    {
-                        prefix_required = false;
-                        oa->write_character(to_char_type('$'));
-                        oa->write_character(first_prefix);
-                    }
-                }
-
-                if (use_count)
-                {
-                    oa->write_character(to_char_type('#'));
-                    write_number_with_ubjson_prefix(j.m_value.array->size(), true);
-                }
-
-                for (const auto& el : *j.m_value.array)
-                {
-                    write_ubjson(el, use_count, use_type, prefix_required);
-                }
-
-                if (!use_count)
-                {
-                    oa->write_character(to_char_type(']'));
-                }
-
-                break;
-            }
-
-            case value_t::binary:
-            {
-                if (add_prefix)
-                {
-                    oa->write_character(to_char_type('['));
-                }
-
-                if (use_type && !j.m_value.binary->empty())
-                {
-                    JSON_ASSERT(use_count);
-                    oa->write_character(to_char_type('$'));
-                    oa->write_character('U');
-                }
-
-                if (use_count)
-                {
-                    oa->write_character(to_char_type('#'));
-                    write_number_with_ubjson_prefix(j.m_value.binary->size(), true);
-                }
-
-                if (use_type)
-                {
-                    oa->write_characters(
-                        reinterpret_cast<const CharType*>(j.m_value.binary->data()),
-                        j.m_value.binary->size());
-                }
-                else
-                {
-                    for (size_t i = 0; i < j.m_value.binary->size(); ++i)
-                    {
-                        oa->write_character(to_char_type('U'));
-                        oa->write_character(j.m_value.binary->data()[i]);
-                    }
-                }
-
-                if (!use_count)
-                {
-                    oa->write_character(to_char_type(']'));
-                }
-
-                break;
-            }
-
-            case value_t::object:
-            {
-                if (add_prefix)
-                {
-                    oa->write_character(to_char_type('{'));
-                }
-
-                bool prefix_required = true;
-                if (use_type && !j.m_value.object->empty())
-                {
-                    JSON_ASSERT(use_count);
-                    const CharType first_prefix = ubjson_prefix(j.front());
-                    const bool same_prefix = std::all_of(j.begin(), j.end(),
-                                                         [this, first_prefix](const BasicJsonType & v)
-                    {
-                        return ubjson_prefix(v) == first_prefix;
-                    });
-
-                    if (same_prefix)
-                    {
-                        prefix_required = false;
-                        oa->write_character(to_char_type('$'));
-                        oa->write_character(first_prefix);
-                    }
-                }
-
-                if (use_count)
-                {
-                    oa->write_character(to_char_type('#'));
-                    write_number_with_ubjson_prefix(j.m_value.object->size(), true);
-                }
-
-                for (const auto& el : *j.m_value.object)
-                {
-                    write_number_with_ubjson_prefix(el.first.size(), true);
-                    oa->write_characters(
-                        reinterpret_cast<const CharType*>(el.first.c_str()),
-                        el.first.size());
-                    write_ubjson(el.second, use_count, use_type, prefix_required);
-                }
-
-                if (!use_count)
-                {
-                    oa->write_character(to_char_type('}'));
-                }
-
-                break;
-            }
-
-            case value_t::discarded:
-            default:
-                break;
-        }
-    }
-
-  private:
-    //////////
-    // BSON //
-    //////////
-
-    /*!
-    @return The size of a BSON document entry header, including the id marker
-            and the entry name size (and its null-terminator).
-    */
-    static std::size_t calc_bson_entry_header_size(const string_t& name, const BasicJsonType& j)
-    {
-        const auto it = name.find(static_cast<typename string_t::value_type>(0));
-        if (JSON_HEDLEY_UNLIKELY(it != BasicJsonType::string_t::npos))
-        {
-            JSON_THROW(out_of_range::create(409, "BSON key cannot contain code point U+0000 (at byte " + std::to_string(it) + ")", j));
-            static_cast<void>(j);
-        }
-
-        return /*id*/ 1ul + name.size() + /*zero-terminator*/1u;
-    }
-
-    /*!
-    @brief Writes the given @a element_type and @a name to the output adapter
-    */
-    void write_bson_entry_header(const string_t& name,
-                                 const std::uint8_t element_type)
-    {
-        oa->write_character(to_char_type(element_type)); // boolean
-        oa->write_characters(
-            reinterpret_cast<const CharType*>(name.c_str()),
-            name.size() + 1u);
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and boolean value @a value
-    */
-    void write_bson_boolean(const string_t& name,
-                            const bool value)
-    {
-        write_bson_entry_header(name, 0x08);
-        oa->write_character(value ? to_char_type(0x01) : to_char_type(0x00));
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and double value @a value
-    */
-    void write_bson_double(const string_t& name,
-                           const double value)
-    {
-        write_bson_entry_header(name, 0x01);
-        write_number<double, true>(value);
-    }
-
-    /*!
-    @return The size of the BSON-encoded string in @a value
-    */
-    static std::size_t calc_bson_string_size(const string_t& value)
-    {
-        return sizeof(std::int32_t) + value.size() + 1ul;
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and string value @a value
-    */
-    void write_bson_string(const string_t& name,
-                           const string_t& value)
-    {
-        write_bson_entry_header(name, 0x02);
-
-        write_number<std::int32_t, true>(static_cast<std::int32_t>(value.size() + 1ul));
-        oa->write_characters(
-            reinterpret_cast<const CharType*>(value.c_str()),
-            value.size() + 1);
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and null value
-    */
-    void write_bson_null(const string_t& name)
-    {
-        write_bson_entry_header(name, 0x0A);
-    }
-
-    /*!
-    @return The size of the BSON-encoded integer @a value
-    */
-    static std::size_t calc_bson_integer_size(const std::int64_t value)
-    {
-        return (std::numeric_limits<std::int32_t>::min)() <= value && value <= (std::numeric_limits<std::int32_t>::max)()
-               ? sizeof(std::int32_t)
-               : sizeof(std::int64_t);
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and integer @a value
-    */
-    void write_bson_integer(const string_t& name,
-                            const std::int64_t value)
-    {
-        if ((std::numeric_limits<std::int32_t>::min)() <= value && value <= (std::numeric_limits<std::int32_t>::max)())
-        {
-            write_bson_entry_header(name, 0x10); // int32
-            write_number<std::int32_t, true>(static_cast<std::int32_t>(value));
-        }
-        else
-        {
-            write_bson_entry_header(name, 0x12); // int64
-            write_number<std::int64_t, true>(static_cast<std::int64_t>(value));
-        }
-    }
-
-    /*!
-    @return The size of the BSON-encoded unsigned integer in @a j
-    */
-    static constexpr std::size_t calc_bson_unsigned_size(const std::uint64_t value) noexcept
-    {
-        return (value <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
-               ? sizeof(std::int32_t)
-               : sizeof(std::int64_t);
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and unsigned @a value
-    */
-    void write_bson_unsigned(const string_t& name,
-                             const BasicJsonType& j)
-    {
-        if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
-        {
-            write_bson_entry_header(name, 0x10 /* int32 */);
-            write_number<std::int32_t, true>(static_cast<std::int32_t>(j.m_value.number_unsigned));
-        }
-        else if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int64_t>::max)()))
-        {
-            write_bson_entry_header(name, 0x12 /* int64 */);
-            write_number<std::int64_t, true>(static_cast<std::int64_t>(j.m_value.number_unsigned));
-        }
-        else
-        {
-            JSON_THROW(out_of_range::create(407, "integer number " + std::to_string(j.m_value.number_unsigned) + " cannot be represented by BSON as it does not fit int64", j));
-        }
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and object @a value
-    */
-    void write_bson_object_entry(const string_t& name,
-                                 const typename BasicJsonType::object_t& value)
-    {
-        write_bson_entry_header(name, 0x03); // object
-        write_bson_object(value);
-    }
-
-    /*!
-    @return The size of the BSON-encoded array @a value
-    */
-    static std::size_t calc_bson_array_size(const typename BasicJsonType::array_t& value)
-    {
-        std::size_t array_index = 0ul;
-
-        const std::size_t embedded_document_size = std::accumulate(std::begin(value), std::end(value), static_cast<std::size_t>(0), [&array_index](std::size_t result, const typename BasicJsonType::array_t::value_type & el)
-        {
-            return result + calc_bson_element_size(std::to_string(array_index++), el);
-        });
-
-        return sizeof(std::int32_t) + embedded_document_size + 1ul;
-    }
-
-    /*!
-    @return The size of the BSON-encoded binary array @a value
-    */
-    static std::size_t calc_bson_binary_size(const typename BasicJsonType::binary_t& value)
-    {
-        return sizeof(std::int32_t) + value.size() + 1ul;
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and array @a value
-    */
-    void write_bson_array(const string_t& name,
-                          const typename BasicJsonType::array_t& value)
-    {
-        write_bson_entry_header(name, 0x04); // array
-        write_number<std::int32_t, true>(static_cast<std::int32_t>(calc_bson_array_size(value)));
-
-        std::size_t array_index = 0ul;
-
-        for (const auto& el : value)
-        {
-            write_bson_element(std::to_string(array_index++), el);
-        }
-
-        oa->write_character(to_char_type(0x00));
-    }
-
-    /*!
-    @brief Writes a BSON element with key @a name and binary value @a value
-    */
-    void write_bson_binary(const string_t& name,
-                           const binary_t& value)
-    {
-        write_bson_entry_header(name, 0x05);
-
-        write_number<std::int32_t, true>(static_cast<std::int32_t>(value.size()));
-        write_number(value.has_subtype() ? static_cast<std::uint8_t>(value.subtype()) : static_cast<std::uint8_t>(0x00));
-
-        oa->write_characters(reinterpret_cast<const CharType*>(value.data()), value.size());
-    }
-
-    /*!
-    @brief Calculates the size necessary to serialize the JSON value @a j with its @a name
-    @return The calculated size for the BSON document entry for @a j with the given @a name.
-    */
-    static std::size_t calc_bson_element_size(const string_t& name,
-            const BasicJsonType& j)
-    {
-        const auto header_size = calc_bson_entry_header_size(name, j);
-        switch (j.type())
-        {
-            case value_t::object:
-                return header_size + calc_bson_object_size(*j.m_value.object);
-
-            case value_t::array:
-                return header_size + calc_bson_array_size(*j.m_value.array);
-
-            case value_t::binary:
-                return header_size + calc_bson_binary_size(*j.m_value.binary);
-
-            case value_t::boolean:
-                return header_size + 1ul;
-
-            case value_t::number_float:
-                return header_size + 8ul;
-
-            case value_t::number_integer:
-                return header_size + calc_bson_integer_size(j.m_value.number_integer);
-
-            case value_t::number_unsigned:
-                return header_size + calc_bson_unsigned_size(j.m_value.number_unsigned);
-
-            case value_t::string:
-                return header_size + calc_bson_string_size(*j.m_value.string);
-
-            case value_t::null:
-                return header_size + 0ul;
-
-            // LCOV_EXCL_START
-            case value_t::discarded:
-            default:
-                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert)
-                return 0ul;
-                // LCOV_EXCL_STOP
-        }
-    }
-
-    /*!
-    @brief Serializes the JSON value @a j to BSON and associates it with the
-           key @a name.
-    @param name The name to associate with the JSON entity @a j within the
-                current BSON document
-    */
-    void write_bson_element(const string_t& name,
-                            const BasicJsonType& j)
-    {
-        switch (j.type())
-        {
-            case value_t::object:
-                return write_bson_object_entry(name, *j.m_value.object);
-
-            case value_t::array:
-                return write_bson_array(name, *j.m_value.array);
-
-            case value_t::binary:
-                return write_bson_binary(name, *j.m_value.binary);
-
-            case value_t::boolean:
-                return write_bson_boolean(name, j.m_value.boolean);
-
-            case value_t::number_float:
-                return write_bson_double(name, j.m_value.number_float);
-
-            case value_t::number_integer:
-                return write_bson_integer(name, j.m_value.number_integer);
-
-            case value_t::number_unsigned:
-                return write_bson_unsigned(name, j);
-
-            case value_t::string:
-                return write_bson_string(name, *j.m_value.string);
-
-            case value_t::null:
-                return write_bson_null(name);
-
-            // LCOV_EXCL_START
-            case value_t::discarded:
-            default:
-                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert)
-                return;
-                // LCOV_EXCL_STOP
-        }
-    }
-
-    /*!
-    @brief Calculates the size of the BSON serialization of the given
-           JSON-object @a j.
-    @param[in] value  JSON value to serialize
-    @pre       value.type() == value_t::object
-    */
-    static std::size_t calc_bson_object_size(const typename BasicJsonType::object_t& value)
-    {
-        std::size_t document_size = std::accumulate(value.begin(), value.end(), static_cast<std::size_t>(0),
-                                    [](size_t result, const typename BasicJsonType::object_t::value_type & el)
-        {
-            return result += calc_bson_element_size(el.first, el.second);
-        });
-
-        return sizeof(std::int32_t) + document_size + 1ul;
-    }
-
-    /*!
-    @param[in] value  JSON value to serialize
-    @pre       value.type() == value_t::object
-    */
-    void write_bson_object(const typename BasicJsonType::object_t& value)
-    {
-        write_number<std::int32_t, true>(static_cast<std::int32_t>(calc_bson_object_size(value)));
-
-        for (const auto& el : value)
-        {
-            write_bson_element(el.first, el.second);
-        }
-
-        oa->write_character(to_char_type(0x00));
-    }
-
-    //////////
-    // CBOR //
-    //////////
-
-    static constexpr CharType get_cbor_float_prefix(float /*unused*/)
-    {
-        return to_char_type(0xFA);  // Single-Precision Float
-    }
-
-    static constexpr CharType get_cbor_float_prefix(double /*unused*/)
-    {
-        return to_char_type(0xFB);  // Double-Precision Float
-    }
-
-    /////////////
-    // MsgPack //
-    /////////////
-
-    static constexpr CharType get_msgpack_float_prefix(float /*unused*/)
-    {
-        return to_char_type(0xCA);  // float 32
-    }
-
-    static constexpr CharType get_msgpack_float_prefix(double /*unused*/)
-    {
-        return to_char_type(0xCB);  // float 64
-    }
-
-    ////////////
-    // UBJSON //
-    ////////////
-
-    // UBJSON: write number (floating point)
-    template<typename NumberType, typename std::enable_if<
-                 std::is_floating_point<NumberType>::value, int>::type = 0>
-    void write_number_with_ubjson_prefix(const NumberType n,
-                                         const bool add_prefix)
-    {
-        if (add_prefix)
-        {
-            oa->write_character(get_ubjson_float_prefix(n));
-        }
-        write_number(n);
-    }
-
-    // UBJSON: write number (unsigned integer)
-    template<typename NumberType, typename std::enable_if<
-                 std::is_unsigned<NumberType>::value, int>::type = 0>
-    void write_number_with_ubjson_prefix(const NumberType n,
-                                         const bool add_prefix)
-    {
-        if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int8_t>::max)()))
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('i'));  // int8
-            }
-            write_number(static_cast<std::uint8_t>(n));
-        }
-        else if (n <= (std::numeric_limits<std::uint8_t>::max)())
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('U'));  // uint8
-            }
-            write_number(static_cast<std::uint8_t>(n));
-        }
-        else if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int16_t>::max)()))
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('I'));  // int16
-            }
-            write_number(static_cast<std::int16_t>(n));
-        }
-        else if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('l'));  // int32
-            }
-            write_number(static_cast<std::int32_t>(n));
-        }
-        else if (n <= static_cast<std::uint64_t>((std::numeric_limits<std::int64_t>::max)()))
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('L'));  // int64
-            }
-            write_number(static_cast<std::int64_t>(n));
-        }
-        else
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('H'));  // high-precision number
-            }
-
-            const auto number = BasicJsonType(n).dump();
-            write_number_with_ubjson_prefix(number.size(), true);
-            for (std::size_t i = 0; i < number.size(); ++i)
-            {
-                oa->write_character(to_char_type(static_cast<std::uint8_t>(number[i])));
-            }
-        }
-    }
-
-    // UBJSON: write number (signed integer)
-    template < typename NumberType, typename std::enable_if <
-                   std::is_signed<NumberType>::value&&
-                   !std::is_floating_point<NumberType>::value, int >::type = 0 >
-    void write_number_with_ubjson_prefix(const NumberType n,
-                                         const bool add_prefix)
-    {
-        if ((std::numeric_limits<std::int8_t>::min)() <= n && n <= (std::numeric_limits<std::int8_t>::max)())
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('i'));  // int8
-            }
-            write_number(static_cast<std::int8_t>(n));
-        }
-        else if (static_cast<std::int64_t>((std::numeric_limits<std::uint8_t>::min)()) <= n && n <= static_cast<std::int64_t>((std::numeric_limits<std::uint8_t>::max)()))
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('U'));  // uint8
-            }
-            write_number(static_cast<std::uint8_t>(n));
-        }
-        else if ((std::numeric_limits<std::int16_t>::min)() <= n && n <= (std::numeric_limits<std::int16_t>::max)())
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('I'));  // int16
-            }
-            write_number(static_cast<std::int16_t>(n));
-        }
-        else if ((std::numeric_limits<std::int32_t>::min)() <= n && n <= (std::numeric_limits<std::int32_t>::max)())
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('l'));  // int32
-            }
-            write_number(static_cast<std::int32_t>(n));
-        }
-        else if ((std::numeric_limits<std::int64_t>::min)() <= n && n <= (std::numeric_limits<std::int64_t>::max)())
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('L'));  // int64
-            }
-            write_number(static_cast<std::int64_t>(n));
-        }
-        // LCOV_EXCL_START
-        else
-        {
-            if (add_prefix)
-            {
-                oa->write_character(to_char_type('H'));  // high-precision number
-            }
-
-            const auto number = BasicJsonType(n).dump();
-            write_number_with_ubjson_prefix(number.size(), true);
-            for (std::size_t i = 0; i < number.size(); ++i)
-            {
-                oa->write_character(to_char_type(static_cast<std::uint8_t>(number[i])));
-            }
-        }
-        // LCOV_EXCL_STOP
-    }
-
-    /*!
-    @brief determine the type prefix of container values
-    */
-    CharType ubjson_prefix(const BasicJsonType& j) const noexcept
-    {
-        switch (j.type())
-        {
-            case value_t::null:
-                return 'Z';
-
-            case value_t::boolean:
-                return j.m_value.boolean ? 'T' : 'F';
-
-            case value_t::number_integer:
-            {
-                if ((std::numeric_limits<std::int8_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int8_t>::max)())
-                {
-                    return 'i';
-                }
-                if ((std::numeric_limits<std::uint8_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::uint8_t>::max)())
-                {
-                    return 'U';
-                }
-                if ((std::numeric_limits<std::int16_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int16_t>::max)())
-                {
-                    return 'I';
-                }
-                if ((std::numeric_limits<std::int32_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int32_t>::max)())
-                {
-                    return 'l';
-                }
-                if ((std::numeric_limits<std::int64_t>::min)() <= j.m_value.number_integer && j.m_value.number_integer <= (std::numeric_limits<std::int64_t>::max)())
-                {
-                    return 'L';
-                }
-                // anything else is treated as high-precision number
-                return 'H'; // LCOV_EXCL_LINE
-            }
-
-            case value_t::number_unsigned:
-            {
-                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int8_t>::max)()))
-                {
-                    return 'i';
-                }
-                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::uint8_t>::max)()))
-                {
-                    return 'U';
-                }
-                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int16_t>::max)()))
-                {
-                    return 'I';
-                }
-                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int32_t>::max)()))
-                {
-                    return 'l';
-                }
-                if (j.m_value.number_unsigned <= static_cast<std::uint64_t>((std::numeric_limits<std::int64_t>::max)()))
-                {
-                    return 'L';
-                }
-                // anything else is treated as high-precision number
-                return 'H'; // LCOV_EXCL_LINE
-            }
-
-            case value_t::number_float:
-                return get_ubjson_float_prefix(j.m_value.number_float);
-
-            case value_t::string:
-                return 'S';
-
-            case value_t::array: // fallthrough
-            case value_t::binary:
-                return '[';
-
-            case value_t::object:
-                return '{';
-
-            case value_t::discarded:
-            default:  // discarded values
-                return 'N';
-        }
-    }
-
-    static constexpr CharType get_ubjson_float_prefix(float /*unused*/)
-    {
-        return 'd';  // float 32
-    }
-
-    static constexpr CharType get_ubjson_float_prefix(double /*unused*/)
-    {
-        return 'D';  // float 64
-    }
-
-    ///////////////////////
-    // Utility functions //
-    ///////////////////////
-
-    /*
-    @brief write a number to output input
-    @param[in] n number of type @a NumberType
-    @tparam NumberType the type of the number
-    @tparam OutputIsLittleEndian Set to true if output data is
-                                 required to be little endian
-
-    @note This function needs to respect the system's endianness, because bytes
-          in CBOR, MessagePack, and UBJSON are stored in network order (big
-          endian) and therefore need reordering on little endian systems.
-    */
-    template<typename NumberType, bool OutputIsLittleEndian = false>
-    void write_number(const NumberType n)
-    {
-        // step 1: write number to array of length NumberType
-        std::array<CharType, sizeof(NumberType)> vec{};
-        std::memcpy(vec.data(), &n, sizeof(NumberType));
-
-        // step 2: write array to output (with possible reordering)
-        if (is_little_endian != OutputIsLittleEndian)
-        {
-            // reverse byte order prior to conversion if necessary
-            std::reverse(vec.begin(), vec.end());
-        }
-
-        oa->write_characters(vec.data(), sizeof(NumberType));
-    }
-
-    void write_compact_float(const number_float_t n, detail::input_format_t format)
-    {
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wfloat-equal"
-#endif
-        if (static_cast<double>(n) >= static_cast<double>(std::numeric_limits<float>::lowest()) &&
-                static_cast<double>(n) <= static_cast<double>((std::numeric_limits<float>::max)()) &&
-                static_cast<double>(static_cast<float>(n)) == static_cast<double>(n))
-        {
-            oa->write_character(format == detail::input_format_t::cbor
-                                ? get_cbor_float_prefix(static_cast<float>(n))
-                                : get_msgpack_float_prefix(static_cast<float>(n)));
-            write_number(static_cast<float>(n));
-        }
-        else
-        {
-            oa->write_character(format == detail::input_format_t::cbor
-                                ? get_cbor_float_prefix(n)
-                                : get_msgpack_float_prefix(n));
-            write_number(n);
-        }
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-    }
-
-  public:
-    // The following to_char_type functions are implement the conversion
-    // between uint8_t and CharType. In case CharType is not unsigned,
-    // such a conversion is required to allow values greater than 128.
-    // See <https://github.com/nlohmann/json/issues/1286> for a discussion.
-    template < typename C = CharType,
-               enable_if_t < std::is_signed<C>::value && std::is_signed<char>::value > * = nullptr >
-    static constexpr CharType to_char_type(std::uint8_t x) noexcept
-    {
-        return *reinterpret_cast<char*>(&x);
-    }
-
-    template < typename C = CharType,
-               enable_if_t < std::is_signed<C>::value && std::is_unsigned<char>::value > * = nullptr >
-    static CharType to_char_type(std::uint8_t x) noexcept
-    {
-        static_assert(sizeof(std::uint8_t) == sizeof(CharType), "size of CharType must be equal to std::uint8_t");
-        static_assert(std::is_trivial<CharType>::value, "CharType must be trivial");
-        CharType result;
-        std::memcpy(&result, &x, sizeof(x));
-        return result;
-    }
-
-    template<typename C = CharType,
-             enable_if_t<std::is_unsigned<C>::value>* = nullptr>
-    static constexpr CharType to_char_type(std::uint8_t x) noexcept
-    {
-        return x;
-    }
-
-    template < typename InputCharType, typename C = CharType,
-               enable_if_t <
-                   std::is_signed<C>::value &&
-                   std::is_signed<char>::value &&
-                   std::is_same<char, typename std::remove_cv<InputCharType>::type>::value
-                   > * = nullptr >
-    static constexpr CharType to_char_type(InputCharType x) noexcept
-    {
-        return x;
-    }
-
-  private:
-    /// whether we can assume little endianness
-    const bool is_little_endian = little_endianness();
-
-    /// the output
-    output_adapter_t<CharType> oa = nullptr;
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/output/output_adapters.hpp>
-
-// #include <nlohmann/detail/output/serializer.hpp>
-
-
-#include <algorithm> // reverse, remove, fill, find, none_of
-#include <array> // array
-#include <clocale> // localeconv, lconv
-#include <cmath> // labs, isfinite, isnan, signbit
-#include <cstddef> // size_t, ptrdiff_t
-#include <cstdint> // uint8_t
-#include <cstdio> // snprintf
-#include <limits> // numeric_limits
-#include <string> // string, char_traits
-#include <iomanip> // setfill, setw
-#include <sstream> // stringstream
-#include <type_traits> // is_same
-#include <utility> // move
-
-// #include <nlohmann/detail/conversions/to_chars.hpp>
-
-
-#include <array> // array
-#include <cmath>   // signbit, isfinite
-#include <cstdint> // intN_t, uintN_t
-#include <cstring> // memcpy, memmove
-#include <limits> // numeric_limits
-#include <type_traits> // conditional
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-
-/*!
-@brief implements the Grisu2 algorithm for binary to decimal floating-point
-conversion.
-
-This implementation is a slightly modified version of the reference
-implementation which may be obtained from
-http://florian.loitsch.com/publications (bench.tar.gz).
-
-The code is distributed under the MIT license, Copyright (c) 2009 Florian Loitsch.
-
-For a detailed description of the algorithm see:
-
-[1] Loitsch, "Printing Floating-Point Numbers Quickly and Accurately with
-    Integers", Proceedings of the ACM SIGPLAN 2010 Conference on Programming
-    Language Design and Implementation, PLDI 2010
-[2] Burger, Dybvig, "Printing Floating-Point Numbers Quickly and Accurately",
-    Proceedings of the ACM SIGPLAN 1996 Conference on Programming Language
-    Design and Implementation, PLDI 1996
-*/
-namespace dtoa_impl
-{
-
-template<typename Target, typename Source>
-Target reinterpret_bits(const Source source)
-{
-    static_assert(sizeof(Target) == sizeof(Source), "size mismatch");
-
-    Target target;
-    std::memcpy(&target, &source, sizeof(Source));
-    return target;
-}
-
-struct diyfp // f * 2^e
-{
-    static constexpr int kPrecision = 64; // = q
-
-    std::uint64_t f = 0;
-    int e = 0;
-
-    constexpr diyfp(std::uint64_t f_, int e_) noexcept : f(f_), e(e_) {}
-
-    /*!
-    @brief returns x - y
-    @pre x.e == y.e and x.f >= y.f
-    */
-    static diyfp sub(const diyfp& x, const diyfp& y) noexcept
-    {
-        JSON_ASSERT(x.e == y.e);
-        JSON_ASSERT(x.f >= y.f);
-
-        return {x.f - y.f, x.e};
-    }
-
-    /*!
-    @brief returns x * y
-    @note The result is rounded. (Only the upper q bits are returned.)
-    */
-    static diyfp mul(const diyfp& x, const diyfp& y) noexcept
-    {
-        static_assert(kPrecision == 64, "internal error");
-
-        // Computes:
-        //  f = round((x.f * y.f) / 2^q)
-        //  e = x.e + y.e + q
-
-        // Emulate the 64-bit * 64-bit multiplication:
-        //
-        // p = u * v
-        //   = (u_lo + 2^32 u_hi) (v_lo + 2^32 v_hi)
-        //   = (u_lo v_lo         ) + 2^32 ((u_lo v_hi         ) + (u_hi v_lo         )) + 2^64 (u_hi v_hi         )
-        //   = (p0                ) + 2^32 ((p1                ) + (p2                )) + 2^64 (p3                )
-        //   = (p0_lo + 2^32 p0_hi) + 2^32 ((p1_lo + 2^32 p1_hi) + (p2_lo + 2^32 p2_hi)) + 2^64 (p3                )
-        //   = (p0_lo             ) + 2^32 (p0_hi + p1_lo + p2_lo                      ) + 2^64 (p1_hi + p2_hi + p3)
-        //   = (p0_lo             ) + 2^32 (Q                                          ) + 2^64 (H                 )
-        //   = (p0_lo             ) + 2^32 (Q_lo + 2^32 Q_hi                           ) + 2^64 (H                 )
-        //
-        // (Since Q might be larger than 2^32 - 1)
-        //
-        //   = (p0_lo + 2^32 Q_lo) + 2^64 (Q_hi + H)
-        //
-        // (Q_hi + H does not overflow a 64-bit int)
-        //
-        //   = p_lo + 2^64 p_hi
-
-        const std::uint64_t u_lo = x.f & 0xFFFFFFFFu;
-        const std::uint64_t u_hi = x.f >> 32u;
-        const std::uint64_t v_lo = y.f & 0xFFFFFFFFu;
-        const std::uint64_t v_hi = y.f >> 32u;
-
-        const std::uint64_t p0 = u_lo * v_lo;
-        const std::uint64_t p1 = u_lo * v_hi;
-        const std::uint64_t p2 = u_hi * v_lo;
-        const std::uint64_t p3 = u_hi * v_hi;
-
-        const std::uint64_t p0_hi = p0 >> 32u;
-        const std::uint64_t p1_lo = p1 & 0xFFFFFFFFu;
-        const std::uint64_t p1_hi = p1 >> 32u;
-        const std::uint64_t p2_lo = p2 & 0xFFFFFFFFu;
-        const std::uint64_t p2_hi = p2 >> 32u;
-
-        std::uint64_t Q = p0_hi + p1_lo + p2_lo;
-
-        // The full product might now be computed as
-        //
-        // p_hi = p3 + p2_hi + p1_hi + (Q >> 32)
-        // p_lo = p0_lo + (Q << 32)
-        //
-        // But in this particular case here, the full p_lo is not required.
-        // Effectively we only need to add the highest bit in p_lo to p_hi (and
-        // Q_hi + 1 does not overflow).
-
-        Q += std::uint64_t{1} << (64u - 32u - 1u); // round, ties up
-
-        const std::uint64_t h = p3 + p2_hi + p1_hi + (Q >> 32u);
-
-        return {h, x.e + y.e + 64};
-    }
-
-    /*!
-    @brief normalize x such that the significand is >= 2^(q-1)
-    @pre x.f != 0
-    */
-    static diyfp normalize(diyfp x) noexcept
-    {
-        JSON_ASSERT(x.f != 0);
-
-        while ((x.f >> 63u) == 0)
-        {
-            x.f <<= 1u;
-            x.e--;
-        }
-
-        return x;
-    }
-
-    /*!
-    @brief normalize x such that the result has the exponent E
-    @pre e >= x.e and the upper e - x.e bits of x.f must be zero.
-    */
-    static diyfp normalize_to(const diyfp& x, const int target_exponent) noexcept
-    {
-        const int delta = x.e - target_exponent;
-
-        JSON_ASSERT(delta >= 0);
-        JSON_ASSERT(((x.f << delta) >> delta) == x.f);
-
-        return {x.f << delta, target_exponent};
-    }
-};
-
-struct boundaries
-{
-    diyfp w;
-    diyfp minus;
-    diyfp plus;
-};
-
-/*!
-Compute the (normalized) diyfp representing the input number 'value' and its
-boundaries.
-
-@pre value must be finite and positive
-*/
-template<typename FloatType>
-boundaries compute_boundaries(FloatType value)
-{
-    JSON_ASSERT(std::isfinite(value));
-    JSON_ASSERT(value > 0);
-
-    // Convert the IEEE representation into a diyfp.
-    //
-    // If v is denormal:
-    //      value = 0.F * 2^(1 - bias) = (          F) * 2^(1 - bias - (p-1))
-    // If v is normalized:
-    //      value = 1.F * 2^(E - bias) = (2^(p-1) + F) * 2^(E - bias - (p-1))
-
-    static_assert(std::numeric_limits<FloatType>::is_iec559,
-                  "internal error: dtoa_short requires an IEEE-754 floating-point implementation");
-
-    constexpr int      kPrecision = std::numeric_limits<FloatType>::digits; // = p (includes the hidden bit)
-    constexpr int      kBias      = std::numeric_limits<FloatType>::max_exponent - 1 + (kPrecision - 1);
-    constexpr int      kMinExp    = 1 - kBias;
-    constexpr std::uint64_t kHiddenBit = std::uint64_t{1} << (kPrecision - 1); // = 2^(p-1)
-
-    using bits_type = typename std::conditional<kPrecision == 24, std::uint32_t, std::uint64_t >::type;
-
-    const auto bits = static_cast<std::uint64_t>(reinterpret_bits<bits_type>(value));
-    const std::uint64_t E = bits >> (kPrecision - 1);
-    const std::uint64_t F = bits & (kHiddenBit - 1);
-
-    const bool is_denormal = E == 0;
-    const diyfp v = is_denormal
-                    ? diyfp(F, kMinExp)
-                    : diyfp(F + kHiddenBit, static_cast<int>(E) - kBias);
-
-    // Compute the boundaries m- and m+ of the floating-point value
-    // v = f * 2^e.
-    //
-    // Determine v- and v+, the floating-point predecessor and successor if v,
-    // respectively.
-    //
-    //      v- = v - 2^e        if f != 2^(p-1) or e == e_min                (A)
-    //         = v - 2^(e-1)    if f == 2^(p-1) and e > e_min                (B)
-    //
-    //      v+ = v + 2^e
-    //
-    // Let m- = (v- + v) / 2 and m+ = (v + v+) / 2. All real numbers _strictly_
-    // between m- and m+ round to v, regardless of how the input rounding
-    // algorithm breaks ties.
-    //
-    //      ---+-------------+-------------+-------------+-------------+---  (A)
-    //         v-            m-            v             m+            v+
-    //
-    //      -----------------+------+------+-------------+-------------+---  (B)
-    //                       v-     m-     v             m+            v+
-
-    const bool lower_boundary_is_closer = F == 0 && E > 1;
-    const diyfp m_plus = diyfp(2 * v.f + 1, v.e - 1);
-    const diyfp m_minus = lower_boundary_is_closer
-                          ? diyfp(4 * v.f - 1, v.e - 2)  // (B)
-                          : diyfp(2 * v.f - 1, v.e - 1); // (A)
-
-    // Determine the normalized w+ = m+.
-    const diyfp w_plus = diyfp::normalize(m_plus);
-
-    // Determine w- = m- such that e_(w-) = e_(w+).
-    const diyfp w_minus = diyfp::normalize_to(m_minus, w_plus.e);
-
-    return {diyfp::normalize(v), w_minus, w_plus};
-}
-
-// Given normalized diyfp w, Grisu needs to find a (normalized) cached
-// power-of-ten c, such that the exponent of the product c * w = f * 2^e lies
-// within a certain range [alpha, gamma] (Definition 3.2 from [1])
-//
-//      alpha <= e = e_c + e_w + q <= gamma
-//
-// or
-//
-//      f_c * f_w * 2^alpha <= f_c 2^(e_c) * f_w 2^(e_w) * 2^q
-//                          <= f_c * f_w * 2^gamma
-//
-// Since c and w are normalized, i.e. 2^(q-1) <= f < 2^q, this implies
-//
-//      2^(q-1) * 2^(q-1) * 2^alpha <= c * w * 2^q < 2^q * 2^q * 2^gamma
-//
-// or
-//
-//      2^(q - 2 + alpha) <= c * w < 2^(q + gamma)
-//
-// The choice of (alpha,gamma) determines the size of the table and the form of
-// the digit generation procedure. Using (alpha,gamma)=(-60,-32) works out well
-// in practice:
-//
-// The idea is to cut the number c * w = f * 2^e into two parts, which can be
-// processed independently: An integral part p1, and a fractional part p2:
-//
-//      f * 2^e = ( (f div 2^-e) * 2^-e + (f mod 2^-e) ) * 2^e
-//              = (f div 2^-e) + (f mod 2^-e) * 2^e
-//              = p1 + p2 * 2^e
-//
-// The conversion of p1 into decimal form requires a series of divisions and
-// modulos by (a power of) 10. These operations are faster for 32-bit than for
-// 64-bit integers, so p1 should ideally fit into a 32-bit integer. This can be
-// achieved by choosing
-//
-//      -e >= 32   or   e <= -32 := gamma
-//
-// In order to convert the fractional part
-//
-//      p2 * 2^e = p2 / 2^-e = d[-1] / 10^1 + d[-2] / 10^2 + ...
-//
-// into decimal form, the fraction is repeatedly multiplied by 10 and the digits
-// d[-i] are extracted in order:
-//
-//      (10 * p2) div 2^-e = d[-1]
-//      (10 * p2) mod 2^-e = d[-2] / 10^1 + ...
-//
-// The multiplication by 10 must not overflow. It is sufficient to choose
-//
-//      10 * p2 < 16 * p2 = 2^4 * p2 <= 2^64.
-//
-// Since p2 = f mod 2^-e < 2^-e,
-//
-//      -e <= 60   or   e >= -60 := alpha
-
-constexpr int kAlpha = -60;
-constexpr int kGamma = -32;
-
-struct cached_power // c = f * 2^e ~= 10^k
-{
-    std::uint64_t f;
-    int e;
-    int k;
-};
-
-/*!
-For a normalized diyfp w = f * 2^e, this function returns a (normalized) cached
-power-of-ten c = f_c * 2^e_c, such that the exponent of the product w * c
-satisfies (Definition 3.2 from [1])
-
-     alpha <= e_c + e + q <= gamma.
-*/
-inline cached_power get_cached_power_for_binary_exponent(int e)
-{
-    // Now
-    //
-    //      alpha <= e_c + e + q <= gamma                                    (1)
-    //      ==> f_c * 2^alpha <= c * 2^e * 2^q
-    //
-    // and since the c's are normalized, 2^(q-1) <= f_c,
-    //
-    //      ==> 2^(q - 1 + alpha) <= c * 2^(e + q)
-    //      ==> 2^(alpha - e - 1) <= c
-    //
-    // If c were an exact power of ten, i.e. c = 10^k, one may determine k as
-    //
-    //      k = ceil( log_10( 2^(alpha - e - 1) ) )
-    //        = ceil( (alpha - e - 1) * log_10(2) )
-    //
-    // From the paper:
-    // "In theory the result of the procedure could be wrong since c is rounded,
-    //  and the computation itself is approximated [...]. In practice, however,
-    //  this simple function is sufficient."
-    //
-    // For IEEE double precision floating-point numbers converted into
-    // normalized diyfp's w = f * 2^e, with q = 64,
-    //
-    //      e >= -1022      (min IEEE exponent)
-    //           -52        (p - 1)
-    //           -52        (p - 1, possibly normalize denormal IEEE numbers)
-    //           -11        (normalize the diyfp)
-    //         = -1137
-    //
-    // and
-    //
-    //      e <= +1023      (max IEEE exponent)
-    //           -52        (p - 1)
-    //           -11        (normalize the diyfp)
-    //         = 960
-    //
-    // This binary exponent range [-1137,960] results in a decimal exponent
-    // range [-307,324]. One does not need to store a cached power for each
-    // k in this range. For each such k it suffices to find a cached power
-    // such that the exponent of the product lies in [alpha,gamma].
-    // This implies that the difference of the decimal exponents of adjacent
-    // table entries must be less than or equal to
-    //
-    //      floor( (gamma - alpha) * log_10(2) ) = 8.
-    //
-    // (A smaller distance gamma-alpha would require a larger table.)
-
-    // NB:
-    // Actually this function returns c, such that -60 <= e_c + e + 64 <= -34.
-
-    constexpr int kCachedPowersMinDecExp = -300;
-    constexpr int kCachedPowersDecStep = 8;
-
-    static constexpr std::array<cached_power, 79> kCachedPowers =
-    {
-        {
-            { 0xAB70FE17C79AC6CA, -1060, -300 },
-            { 0xFF77B1FCBEBCDC4F, -1034, -292 },
-            { 0xBE5691EF416BD60C, -1007, -284 },
-            { 0x8DD01FAD907FFC3C,  -980, -276 },
-            { 0xD3515C2831559A83,  -954, -268 },
-            { 0x9D71AC8FADA6C9B5,  -927, -260 },
-            { 0xEA9C227723EE8BCB,  -901, -252 },
-            { 0xAECC49914078536D,  -874, -244 },
-            { 0x823C12795DB6CE57,  -847, -236 },
-            { 0xC21094364DFB5637,  -821, -228 },
-            { 0x9096EA6F3848984F,  -794, -220 },
-            { 0xD77485CB25823AC7,  -768, -212 },
-            { 0xA086CFCD97BF97F4,  -741, -204 },
-            { 0xEF340A98172AACE5,  -715, -196 },
-            { 0xB23867FB2A35B28E,  -688, -188 },
-            { 0x84C8D4DFD2C63F3B,  -661, -180 },
-            { 0xC5DD44271AD3CDBA,  -635, -172 },
-            { 0x936B9FCEBB25C996,  -608, -164 },
-            { 0xDBAC6C247D62A584,  -582, -156 },
-            { 0xA3AB66580D5FDAF6,  -555, -148 },
-            { 0xF3E2F893DEC3F126,  -529, -140 },
-            { 0xB5B5ADA8AAFF80B8,  -502, -132 },
-            { 0x87625F056C7C4A8B,  -475, -124 },
-            { 0xC9BCFF6034C13053,  -449, -116 },
-            { 0x964E858C91BA2655,  -422, -108 },
-            { 0xDFF9772470297EBD,  -396, -100 },
-            { 0xA6DFBD9FB8E5B88F,  -369,  -92 },
-            { 0xF8A95FCF88747D94,  -343,  -84 },
-            { 0xB94470938FA89BCF,  -316,  -76 },
-            { 0x8A08F0F8BF0F156B,  -289,  -68 },
-            { 0xCDB02555653131B6,  -263,  -60 },
-            { 0x993FE2C6D07B7FAC,  -236,  -52 },
-            { 0xE45C10C42A2B3B06,  -210,  -44 },
-            { 0xAA242499697392D3,  -183,  -36 },
-            { 0xFD87B5F28300CA0E,  -157,  -28 },
-            { 0xBCE5086492111AEB,  -130,  -20 },
-            { 0x8CBCCC096F5088CC,  -103,  -12 },
-            { 0xD1B71758E219652C,   -77,   -4 },
-            { 0x9C40000000000000,   -50,    4 },
-            { 0xE8D4A51000000000,   -24,   12 },
-            { 0xAD78EBC5AC620000,     3,   20 },
-            { 0x813F3978F8940984,    30,   28 },
-            { 0xC097CE7BC90715B3,    56,   36 },
-            { 0x8F7E32CE7BEA5C70,    83,   44 },
-            { 0xD5D238A4ABE98068,   109,   52 },
-            { 0x9F4F2726179A2245,   136,   60 },
-            { 0xED63A231D4C4FB27,   162,   68 },
-            { 0xB0DE65388CC8ADA8,   189,   76 },
-            { 0x83C7088E1AAB65DB,   216,   84 },
-            { 0xC45D1DF942711D9A,   242,   92 },
-            { 0x924D692CA61BE758,   269,  100 },
-            { 0xDA01EE641A708DEA,   295,  108 },
-            { 0xA26DA3999AEF774A,   322,  116 },
-            { 0xF209787BB47D6B85,   348,  124 },
-            { 0xB454E4A179DD1877,   375,  132 },
-            { 0x865B86925B9BC5C2,   402,  140 },
-            { 0xC83553C5C8965D3D,   428,  148 },
-            { 0x952AB45CFA97A0B3,   455,  156 },
-            { 0xDE469FBD99A05FE3,   481,  164 },
-            { 0xA59BC234DB398C25,   508,  172 },
-            { 0xF6C69A72A3989F5C,   534,  180 },
-            { 0xB7DCBF5354E9BECE,   561,  188 },
-            { 0x88FCF317F22241E2,   588,  196 },
-            { 0xCC20CE9BD35C78A5,   614,  204 },
-            { 0x98165AF37B2153DF,   641,  212 },
-            { 0xE2A0B5DC971F303A,   667,  220 },
-            { 0xA8D9D1535CE3B396,   694,  228 },
-            { 0xFB9B7CD9A4A7443C,   720,  236 },
-            { 0xBB764C4CA7A44410,   747,  244 },
-            { 0x8BAB8EEFB6409C1A,   774,  252 },
-            { 0xD01FEF10A657842C,   800,  260 },
-            { 0x9B10A4E5E9913129,   827,  268 },
-            { 0xE7109BFBA19C0C9D,   853,  276 },
-            { 0xAC2820D9623BF429,   880,  284 },
-            { 0x80444B5E7AA7CF85,   907,  292 },
-            { 0xBF21E44003ACDD2D,   933,  300 },
-            { 0x8E679C2F5E44FF8F,   960,  308 },
-            { 0xD433179D9C8CB841,   986,  316 },
-            { 0x9E19DB92B4E31BA9,  1013,  324 },
-        }
-    };
-
-    // This computation gives exactly the same results for k as
-    //      k = ceil((kAlpha - e - 1) * 0.30102999566398114)
-    // for |e| <= 1500, but doesn't require floating-point operations.
-    // NB: log_10(2) ~= 78913 / 2^18
-    JSON_ASSERT(e >= -1500);
-    JSON_ASSERT(e <=  1500);
-    const int f = kAlpha - e - 1;
-    const int k = (f * 78913) / (1 << 18) + static_cast<int>(f > 0);
-
-    const int index = (-kCachedPowersMinDecExp + k + (kCachedPowersDecStep - 1)) / kCachedPowersDecStep;
-    JSON_ASSERT(index >= 0);
-    JSON_ASSERT(static_cast<std::size_t>(index) < kCachedPowers.size());
-
-    const cached_power cached = kCachedPowers[static_cast<std::size_t>(index)];
-    JSON_ASSERT(kAlpha <= cached.e + e + 64);
-    JSON_ASSERT(kGamma >= cached.e + e + 64);
-
-    return cached;
-}
-
-/*!
-For n != 0, returns k, such that pow10 := 10^(k-1) <= n < 10^k.
-For n == 0, returns 1 and sets pow10 := 1.
-*/
-inline int find_largest_pow10(const std::uint32_t n, std::uint32_t& pow10)
-{
-    // LCOV_EXCL_START
-    if (n >= 1000000000)
-    {
-        pow10 = 1000000000;
-        return 10;
-    }
-    // LCOV_EXCL_STOP
-    if (n >= 100000000)
-    {
-        pow10 = 100000000;
-        return  9;
-    }
-    if (n >= 10000000)
-    {
-        pow10 = 10000000;
-        return  8;
-    }
-    if (n >= 1000000)
-    {
-        pow10 = 1000000;
-        return  7;
-    }
-    if (n >= 100000)
-    {
-        pow10 = 100000;
-        return  6;
-    }
-    if (n >= 10000)
-    {
-        pow10 = 10000;
-        return  5;
-    }
-    if (n >= 1000)
-    {
-        pow10 = 1000;
-        return  4;
-    }
-    if (n >= 100)
-    {
-        pow10 = 100;
-        return  3;
-    }
-    if (n >= 10)
-    {
-        pow10 = 10;
-        return  2;
-    }
-
-    pow10 = 1;
-    return 1;
-}
-
-inline void grisu2_round(char* buf, int len, std::uint64_t dist, std::uint64_t delta,
-                         std::uint64_t rest, std::uint64_t ten_k)
-{
-    JSON_ASSERT(len >= 1);
-    JSON_ASSERT(dist <= delta);
-    JSON_ASSERT(rest <= delta);
-    JSON_ASSERT(ten_k > 0);
-
-    //               <--------------------------- delta ---->
-    //                                  <---- dist --------->
-    // --------------[------------------+-------------------]--------------
-    //               M-                 w                   M+
-    //
-    //                                  ten_k
-    //                                <------>
-    //                                       <---- rest ---->
-    // --------------[------------------+----+--------------]--------------
-    //                                  w    V
-    //                                       = buf * 10^k
-    //
-    // ten_k represents a unit-in-the-last-place in the decimal representation
-    // stored in buf.
-    // Decrement buf by ten_k while this takes buf closer to w.
-
-    // The tests are written in this order to avoid overflow in unsigned
-    // integer arithmetic.
-
-    while (rest < dist
-            && delta - rest >= ten_k
-            && (rest + ten_k < dist || dist - rest > rest + ten_k - dist))
-    {
-        JSON_ASSERT(buf[len - 1] != '0');
-        buf[len - 1]--;
-        rest += ten_k;
-    }
-}
-
-/*!
-Generates V = buffer * 10^decimal_exponent, such that M- <= V <= M+.
-M- and M+ must be normalized and share the same exponent -60 <= e <= -32.
-*/
-inline void grisu2_digit_gen(char* buffer, int& length, int& decimal_exponent,
-                             diyfp M_minus, diyfp w, diyfp M_plus)
-{
-    static_assert(kAlpha >= -60, "internal error");
-    static_assert(kGamma <= -32, "internal error");
-
-    // Generates the digits (and the exponent) of a decimal floating-point
-    // number V = buffer * 10^decimal_exponent in the range [M-, M+]. The diyfp's
-    // w, M- and M+ share the same exponent e, which satisfies alpha <= e <= gamma.
-    //
-    //               <--------------------------- delta ---->
-    //                                  <---- dist --------->
-    // --------------[------------------+-------------------]--------------
-    //               M-                 w                   M+
-    //
-    // Grisu2 generates the digits of M+ from left to right and stops as soon as
-    // V is in [M-,M+].
-
-    JSON_ASSERT(M_plus.e >= kAlpha);
-    JSON_ASSERT(M_plus.e <= kGamma);
-
-    std::uint64_t delta = diyfp::sub(M_plus, M_minus).f; // (significand of (M+ - M-), implicit exponent is e)
-    std::uint64_t dist  = diyfp::sub(M_plus, w      ).f; // (significand of (M+ - w ), implicit exponent is e)
-
-    // Split M+ = f * 2^e into two parts p1 and p2 (note: e < 0):
-    //
-    //      M+ = f * 2^e
-    //         = ((f div 2^-e) * 2^-e + (f mod 2^-e)) * 2^e
-    //         = ((p1        ) * 2^-e + (p2        )) * 2^e
-    //         = p1 + p2 * 2^e
-
-    const diyfp one(std::uint64_t{1} << -M_plus.e, M_plus.e);
-
-    auto p1 = static_cast<std::uint32_t>(M_plus.f >> -one.e); // p1 = f div 2^-e (Since -e >= 32, p1 fits into a 32-bit int.)
-    std::uint64_t p2 = M_plus.f & (one.f - 1);                    // p2 = f mod 2^-e
-
-    // 1)
-    //
-    // Generate the digits of the integral part p1 = d[n-1]...d[1]d[0]
-
-    JSON_ASSERT(p1 > 0);
-
-    std::uint32_t pow10{};
-    const int k = find_largest_pow10(p1, pow10);
-
-    //      10^(k-1) <= p1 < 10^k, pow10 = 10^(k-1)
-    //
-    //      p1 = (p1 div 10^(k-1)) * 10^(k-1) + (p1 mod 10^(k-1))
-    //         = (d[k-1]         ) * 10^(k-1) + (p1 mod 10^(k-1))
-    //
-    //      M+ = p1                                             + p2 * 2^e
-    //         = d[k-1] * 10^(k-1) + (p1 mod 10^(k-1))          + p2 * 2^e
-    //         = d[k-1] * 10^(k-1) + ((p1 mod 10^(k-1)) * 2^-e + p2) * 2^e
-    //         = d[k-1] * 10^(k-1) + (                         rest) * 2^e
-    //
-    // Now generate the digits d[n] of p1 from left to right (n = k-1,...,0)
-    //
-    //      p1 = d[k-1]...d[n] * 10^n + d[n-1]...d[0]
-    //
-    // but stop as soon as
-    //
-    //      rest * 2^e = (d[n-1]...d[0] * 2^-e + p2) * 2^e <= delta * 2^e
-
-    int n = k;
-    while (n > 0)
-    {
-        // Invariants:
-        //      M+ = buffer * 10^n + (p1 + p2 * 2^e)    (buffer = 0 for n = k)
-        //      pow10 = 10^(n-1) <= p1 < 10^n
-        //
-        const std::uint32_t d = p1 / pow10;  // d = p1 div 10^(n-1)
-        const std::uint32_t r = p1 % pow10;  // r = p1 mod 10^(n-1)
-        //
-        //      M+ = buffer * 10^n + (d * 10^(n-1) + r) + p2 * 2^e
-        //         = (buffer * 10 + d) * 10^(n-1) + (r + p2 * 2^e)
-        //
-        JSON_ASSERT(d <= 9);
-        buffer[length++] = static_cast<char>('0' + d); // buffer := buffer * 10 + d
-        //
-        //      M+ = buffer * 10^(n-1) + (r + p2 * 2^e)
-        //
-        p1 = r;
-        n--;
-        //
-        //      M+ = buffer * 10^n + (p1 + p2 * 2^e)
-        //      pow10 = 10^n
-        //
-
-        // Now check if enough digits have been generated.
-        // Compute
-        //
-        //      p1 + p2 * 2^e = (p1 * 2^-e + p2) * 2^e = rest * 2^e
-        //
-        // Note:
-        // Since rest and delta share the same exponent e, it suffices to
-        // compare the significands.
-        const std::uint64_t rest = (std::uint64_t{p1} << -one.e) + p2;
-        if (rest <= delta)
-        {
-            // V = buffer * 10^n, with M- <= V <= M+.
-
-            decimal_exponent += n;
-
-            // We may now just stop. But instead look if the buffer could be
-            // decremented to bring V closer to w.
-            //
-            // pow10 = 10^n is now 1 ulp in the decimal representation V.
-            // The rounding procedure works with diyfp's with an implicit
-            // exponent of e.
-            //
-            //      10^n = (10^n * 2^-e) * 2^e = ulp * 2^e
-            //
-            const std::uint64_t ten_n = std::uint64_t{pow10} << -one.e;
-            grisu2_round(buffer, length, dist, delta, rest, ten_n);
-
-            return;
-        }
-
-        pow10 /= 10;
-        //
-        //      pow10 = 10^(n-1) <= p1 < 10^n
-        // Invariants restored.
-    }
-
-    // 2)
-    //
-    // The digits of the integral part have been generated:
-    //
-    //      M+ = d[k-1]...d[1]d[0] + p2 * 2^e
-    //         = buffer            + p2 * 2^e
-    //
-    // Now generate the digits of the fractional part p2 * 2^e.
-    //
-    // Note:
-    // No decimal point is generated: the exponent is adjusted instead.
-    //
-    // p2 actually represents the fraction
-    //
-    //      p2 * 2^e
-    //          = p2 / 2^-e
-    //          = d[-1] / 10^1 + d[-2] / 10^2 + ...
-    //
-    // Now generate the digits d[-m] of p1 from left to right (m = 1,2,...)
-    //
-    //      p2 * 2^e = d[-1]d[-2]...d[-m] * 10^-m
-    //                      + 10^-m * (d[-m-1] / 10^1 + d[-m-2] / 10^2 + ...)
-    //
-    // using
-    //
-    //      10^m * p2 = ((10^m * p2) div 2^-e) * 2^-e + ((10^m * p2) mod 2^-e)
-    //                = (                   d) * 2^-e + (                   r)
-    //
-    // or
-    //      10^m * p2 * 2^e = d + r * 2^e
-    //
-    // i.e.
-    //
-    //      M+ = buffer + p2 * 2^e
-    //         = buffer + 10^-m * (d + r * 2^e)
-    //         = (buffer * 10^m + d) * 10^-m + 10^-m * r * 2^e
-    //
-    // and stop as soon as 10^-m * r * 2^e <= delta * 2^e
-
-    JSON_ASSERT(p2 > delta);
-
-    int m = 0;
-    for (;;)
-    {
-        // Invariant:
-        //      M+ = buffer * 10^-m + 10^-m * (d[-m-1] / 10 + d[-m-2] / 10^2 + ...) * 2^e
-        //         = buffer * 10^-m + 10^-m * (p2                                 ) * 2^e
-        //         = buffer * 10^-m + 10^-m * (1/10 * (10 * p2)                   ) * 2^e
-        //         = buffer * 10^-m + 10^-m * (1/10 * ((10*p2 div 2^-e) * 2^-e + (10*p2 mod 2^-e)) * 2^e
-        //
-        JSON_ASSERT(p2 <= (std::numeric_limits<std::uint64_t>::max)() / 10);
-        p2 *= 10;
-        const std::uint64_t d = p2 >> -one.e;     // d = (10 * p2) div 2^-e
-        const std::uint64_t r = p2 & (one.f - 1); // r = (10 * p2) mod 2^-e
-        //
-        //      M+ = buffer * 10^-m + 10^-m * (1/10 * (d * 2^-e + r) * 2^e
-        //         = buffer * 10^-m + 10^-m * (1/10 * (d + r * 2^e))
-        //         = (buffer * 10 + d) * 10^(-m-1) + 10^(-m-1) * r * 2^e
-        //
-        JSON_ASSERT(d <= 9);
-        buffer[length++] = static_cast<char>('0' + d); // buffer := buffer * 10 + d
-        //
-        //      M+ = buffer * 10^(-m-1) + 10^(-m-1) * r * 2^e
-        //
-        p2 = r;
-        m++;
-        //
-        //      M+ = buffer * 10^-m + 10^-m * p2 * 2^e
-        // Invariant restored.
-
-        // Check if enough digits have been generated.
-        //
-        //      10^-m * p2 * 2^e <= delta * 2^e
-        //              p2 * 2^e <= 10^m * delta * 2^e
-        //                    p2 <= 10^m * delta
-        delta *= 10;
-        dist  *= 10;
-        if (p2 <= delta)
-        {
-            break;
-        }
-    }
-
-    // V = buffer * 10^-m, with M- <= V <= M+.
-
-    decimal_exponent -= m;
-
-    // 1 ulp in the decimal representation is now 10^-m.
-    // Since delta and dist are now scaled by 10^m, we need to do the
-    // same with ulp in order to keep the units in sync.
-    //
-    //      10^m * 10^-m = 1 = 2^-e * 2^e = ten_m * 2^e
-    //
-    const std::uint64_t ten_m = one.f;
-    grisu2_round(buffer, length, dist, delta, p2, ten_m);
-
-    // By construction this algorithm generates the shortest possible decimal
-    // number (Loitsch, Theorem 6.2) which rounds back to w.
-    // For an input number of precision p, at least
-    //
-    //      N = 1 + ceil(p * log_10(2))
-    //
-    // decimal digits are sufficient to identify all binary floating-point
-    // numbers (Matula, "In-and-Out conversions").
-    // This implies that the algorithm does not produce more than N decimal
-    // digits.
-    //
-    //      N = 17 for p = 53 (IEEE double precision)
-    //      N = 9  for p = 24 (IEEE single precision)
-}
-
-/*!
-v = buf * 10^decimal_exponent
-len is the length of the buffer (number of decimal digits)
-The buffer must be large enough, i.e. >= max_digits10.
-*/
-JSON_HEDLEY_NON_NULL(1)
-inline void grisu2(char* buf, int& len, int& decimal_exponent,
-                   diyfp m_minus, diyfp v, diyfp m_plus)
-{
-    JSON_ASSERT(m_plus.e == m_minus.e);
-    JSON_ASSERT(m_plus.e == v.e);
-
-    //  --------(-----------------------+-----------------------)--------    (A)
-    //          m-                      v                       m+
-    //
-    //  --------------------(-----------+-----------------------)--------    (B)
-    //                      m-          v                       m+
-    //
-    // First scale v (and m- and m+) such that the exponent is in the range
-    // [alpha, gamma].
-
-    const cached_power cached = get_cached_power_for_binary_exponent(m_plus.e);
-
-    const diyfp c_minus_k(cached.f, cached.e); // = c ~= 10^-k
-
-    // The exponent of the products is = v.e + c_minus_k.e + q and is in the range [alpha,gamma]
-    const diyfp w       = diyfp::mul(v,       c_minus_k);
-    const diyfp w_minus = diyfp::mul(m_minus, c_minus_k);
-    const diyfp w_plus  = diyfp::mul(m_plus,  c_minus_k);
-
-    //  ----(---+---)---------------(---+---)---------------(---+---)----
-    //          w-                      w                       w+
-    //          = c*m-                  = c*v                   = c*m+
-    //
-    // diyfp::mul rounds its result and c_minus_k is approximated too. w, w- and
-    // w+ are now off by a small amount.
-    // In fact:
-    //
-    //      w - v * 10^k < 1 ulp
-    //
-    // To account for this inaccuracy, add resp. subtract 1 ulp.
-    //
-    //  --------+---[---------------(---+---)---------------]---+--------
-    //          w-  M-                  w                   M+  w+
-    //
-    // Now any number in [M-, M+] (bounds included) will round to w when input,
-    // regardless of how the input rounding algorithm breaks ties.
-    //
-    // And digit_gen generates the shortest possible such number in [M-, M+].
-    // Note that this does not mean that Grisu2 always generates the shortest
-    // possible number in the interval (m-, m+).
-    const diyfp M_minus(w_minus.f + 1, w_minus.e);
-    const diyfp M_plus (w_plus.f  - 1, w_plus.e );
-
-    decimal_exponent = -cached.k; // = -(-k) = k
-
-    grisu2_digit_gen(buf, len, decimal_exponent, M_minus, w, M_plus);
-}
-
-/*!
-v = buf * 10^decimal_exponent
-len is the length of the buffer (number of decimal digits)
-The buffer must be large enough, i.e. >= max_digits10.
-*/
-template<typename FloatType>
-JSON_HEDLEY_NON_NULL(1)
-void grisu2(char* buf, int& len, int& decimal_exponent, FloatType value)
-{
-    static_assert(diyfp::kPrecision >= std::numeric_limits<FloatType>::digits + 3,
-                  "internal error: not enough precision");
-
-    JSON_ASSERT(std::isfinite(value));
-    JSON_ASSERT(value > 0);
-
-    // If the neighbors (and boundaries) of 'value' are always computed for double-precision
-    // numbers, all float's can be recovered using strtod (and strtof). However, the resulting
-    // decimal representations are not exactly "short".
-    //
-    // The documentation for 'std::to_chars' (https://en.cppreference.com/w/cpp/utility/to_chars)
-    // says "value is converted to a string as if by std::sprintf in the default ("C") locale"
-    // and since sprintf promotes floats to doubles, I think this is exactly what 'std::to_chars'
-    // does.
-    // On the other hand, the documentation for 'std::to_chars' requires that "parsing the
-    // representation using the corresponding std::from_chars function recovers value exactly". That
-    // indicates that single precision floating-point numbers should be recovered using
-    // 'std::strtof'.
-    //
-    // NB: If the neighbors are computed for single-precision numbers, there is a single float
-    //     (7.0385307e-26f) which can't be recovered using strtod. The resulting double precision
-    //     value is off by 1 ulp.
-#if 0
-    const boundaries w = compute_boundaries(static_cast<double>(value));
-#else
-    const boundaries w = compute_boundaries(value);
-#endif
-
-    grisu2(buf, len, decimal_exponent, w.minus, w.w, w.plus);
-}
-
-/*!
-@brief appends a decimal representation of e to buf
-@return a pointer to the element following the exponent.
-@pre -1000 < e < 1000
-*/
-JSON_HEDLEY_NON_NULL(1)
-JSON_HEDLEY_RETURNS_NON_NULL
-inline char* append_exponent(char* buf, int e)
-{
-    JSON_ASSERT(e > -1000);
-    JSON_ASSERT(e <  1000);
-
-    if (e < 0)
-    {
-        e = -e;
-        *buf++ = '-';
-    }
-    else
-    {
-        *buf++ = '+';
-    }
-
-    auto k = static_cast<std::uint32_t>(e);
-    if (k < 10)
-    {
-        // Always print at least two digits in the exponent.
-        // This is for compatibility with printf("%g").
-        *buf++ = '0';
-        *buf++ = static_cast<char>('0' + k);
-    }
-    else if (k < 100)
-    {
-        *buf++ = static_cast<char>('0' + k / 10);
-        k %= 10;
-        *buf++ = static_cast<char>('0' + k);
-    }
-    else
-    {
-        *buf++ = static_cast<char>('0' + k / 100);
-        k %= 100;
-        *buf++ = static_cast<char>('0' + k / 10);
-        k %= 10;
-        *buf++ = static_cast<char>('0' + k);
-    }
-
-    return buf;
-}
-
-/*!
-@brief prettify v = buf * 10^decimal_exponent
-
-If v is in the range [10^min_exp, 10^max_exp) it will be printed in fixed-point
-notation. Otherwise it will be printed in exponential notation.
-
-@pre min_exp < 0
-@pre max_exp > 0
-*/
-JSON_HEDLEY_NON_NULL(1)
-JSON_HEDLEY_RETURNS_NON_NULL
-inline char* format_buffer(char* buf, int len, int decimal_exponent,
-                           int min_exp, int max_exp)
-{
-    JSON_ASSERT(min_exp < 0);
-    JSON_ASSERT(max_exp > 0);
-
-    const int k = len;
-    const int n = len + decimal_exponent;
-
-    // v = buf * 10^(n-k)
-    // k is the length of the buffer (number of decimal digits)
-    // n is the position of the decimal point relative to the start of the buffer.
-
-    if (k <= n && n <= max_exp)
-    {
-        // digits[000]
-        // len <= max_exp + 2
-
-        std::memset(buf + k, '0', static_cast<size_t>(n) - static_cast<size_t>(k));
-        // Make it look like a floating-point number (#362, #378)
-        buf[n + 0] = '.';
-        buf[n + 1] = '0';
-        return buf + (static_cast<size_t>(n) + 2);
-    }
-
-    if (0 < n && n <= max_exp)
-    {
-        // dig.its
-        // len <= max_digits10 + 1
-
-        JSON_ASSERT(k > n);
-
-        std::memmove(buf + (static_cast<size_t>(n) + 1), buf + n, static_cast<size_t>(k) - static_cast<size_t>(n));
-        buf[n] = '.';
-        return buf + (static_cast<size_t>(k) + 1U);
-    }
-
-    if (min_exp < n && n <= 0)
-    {
-        // 0.[000]digits
-        // len <= 2 + (-min_exp - 1) + max_digits10
-
-        std::memmove(buf + (2 + static_cast<size_t>(-n)), buf, static_cast<size_t>(k));
-        buf[0] = '0';
-        buf[1] = '.';
-        std::memset(buf + 2, '0', static_cast<size_t>(-n));
-        return buf + (2U + static_cast<size_t>(-n) + static_cast<size_t>(k));
-    }
-
-    if (k == 1)
-    {
-        // dE+123
-        // len <= 1 + 5
-
-        buf += 1;
-    }
-    else
-    {
-        // d.igitsE+123
-        // len <= max_digits10 + 1 + 5
-
-        std::memmove(buf + 2, buf + 1, static_cast<size_t>(k) - 1);
-        buf[1] = '.';
-        buf += 1 + static_cast<size_t>(k);
-    }
-
-    *buf++ = 'e';
-    return append_exponent(buf, n - 1);
-}
-
-} // namespace dtoa_impl
-
-/*!
-@brief generates a decimal representation of the floating-point number value in [first, last).
-
-The format of the resulting decimal representation is similar to printf's %g
-format. Returns an iterator pointing past-the-end of the decimal representation.
-
-@note The input number must be finite, i.e. NaN's and Inf's are not supported.
-@note The buffer must be large enough.
-@note The result is NOT null-terminated.
-*/
-template<typename FloatType>
-JSON_HEDLEY_NON_NULL(1, 2)
-JSON_HEDLEY_RETURNS_NON_NULL
-char* to_chars(char* first, const char* last, FloatType value)
-{
-    static_cast<void>(last); // maybe unused - fix warning
-    JSON_ASSERT(std::isfinite(value));
-
-    // Use signbit(value) instead of (value < 0) since signbit works for -0.
-    if (std::signbit(value))
-    {
-        value = -value;
-        *first++ = '-';
-    }
-
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wfloat-equal"
-#endif
-    if (value == 0) // +-0
-    {
-        *first++ = '0';
-        // Make it look like a floating-point number (#362, #378)
-        *first++ = '.';
-        *first++ = '0';
-        return first;
-    }
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-
-    JSON_ASSERT(last - first >= std::numeric_limits<FloatType>::max_digits10);
-
-    // Compute v = buffer * 10^decimal_exponent.
-    // The decimal digits are stored in the buffer, which needs to be interpreted
-    // as an unsigned decimal integer.
-    // len is the length of the buffer, i.e. the number of decimal digits.
-    int len = 0;
-    int decimal_exponent = 0;
-    dtoa_impl::grisu2(first, len, decimal_exponent, value);
-
-    JSON_ASSERT(len <= std::numeric_limits<FloatType>::max_digits10);
-
-    // Format the buffer like printf("%.*g", prec, value)
-    constexpr int kMinExp = -4;
-    // Use digits10 here to increase compatibility with version 2.
-    constexpr int kMaxExp = std::numeric_limits<FloatType>::digits10;
-
-    JSON_ASSERT(last - first >= kMaxExp + 2);
-    JSON_ASSERT(last - first >= 2 + (-kMinExp - 1) + std::numeric_limits<FloatType>::max_digits10);
-    JSON_ASSERT(last - first >= std::numeric_limits<FloatType>::max_digits10 + 6);
-
-    return dtoa_impl::format_buffer(first, len, decimal_exponent, kMinExp, kMaxExp);
-}
-
-} // namespace detail
-} // namespace nlohmann
-
-// #include <nlohmann/detail/exceptions.hpp>
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-// #include <nlohmann/detail/meta/cpp_future.hpp>
-
-// #include <nlohmann/detail/output/binary_writer.hpp>
-
-// #include <nlohmann/detail/output/output_adapters.hpp>
-
-// #include <nlohmann/detail/value_t.hpp>
-
-
-namespace nlohmann
-{
-namespace detail
-{
-///////////////////
-// serialization //
-///////////////////
-
-/// how to treat decoding errors
-enum class error_handler_t
-{
-    strict,  ///< throw a type_error exception in case of invalid UTF-8
-    replace, ///< replace invalid UTF-8 sequences with U+FFFD
-    ignore   ///< ignore invalid UTF-8 sequences
-};
-
-template<typename BasicJsonType>
-class serializer
-{
-    using string_t = typename BasicJsonType::string_t;
-    using number_float_t = typename BasicJsonType::number_float_t;
-    using number_integer_t = typename BasicJsonType::number_integer_t;
-    using number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-    using binary_char_t = typename BasicJsonType::binary_t::value_type;
-    static constexpr std::uint8_t UTF8_ACCEPT = 0;
-    static constexpr std::uint8_t UTF8_REJECT = 1;
-
-  public:
-    /*!
-    @param[in] s  output stream to serialize to
-    @param[in] ichar  indentation character to use
-    @param[in] error_handler_  how to react on decoding errors
-    */
-    serializer(output_adapter_t<char> s, const char ichar,
-               error_handler_t error_handler_ = error_handler_t::strict)
-        : o(std::move(s))
-        , loc(std::localeconv())
-        , thousands_sep(loc->thousands_sep == nullptr ? '\0' : std::char_traits<char>::to_char_type(* (loc->thousands_sep)))
-        , decimal_point(loc->decimal_point == nullptr ? '\0' : std::char_traits<char>::to_char_type(* (loc->decimal_point)))
-        , indent_char(ichar)
-        , indent_string(512, indent_char)
-        , error_handler(error_handler_)
-    {}
-
-    // delete because of pointer members
-    serializer(const serializer&) = delete;
-    serializer& operator=(const serializer&) = delete;
-    serializer(serializer&&) = delete;
-    serializer& operator=(serializer&&) = delete;
-    ~serializer() = default;
-
-    /*!
-    @brief internal implementation of the serialization function
-
-    This function is called by the public member function dump and organizes
-    the serialization internally. The indentation level is propagated as
-    additional parameter. In case of arrays and objects, the function is
-    called recursively.
-
-    - strings and object keys are escaped using `escape_string()`
-    - integer numbers are converted implicitly via `operator<<`
-    - floating-point numbers are converted to a string using `"%g"` format
-    - binary values are serialized as objects containing the subtype and the
-      byte array
-
-    @param[in] val               value to serialize
-    @param[in] pretty_print      whether the output shall be pretty-printed
-    @param[in] ensure_ascii If @a ensure_ascii is true, all non-ASCII characters
-    in the output are escaped with `\uXXXX` sequences, and the result consists
-    of ASCII characters only.
-    @param[in] indent_step       the indent level
-    @param[in] current_indent    the current indent level (only used internally)
-    */
-    void dump(const BasicJsonType& val,
-              const bool pretty_print,
-              const bool ensure_ascii,
-              const unsigned int indent_step,
-              const unsigned int current_indent = 0)
-    {
-        switch (val.m_type)
-        {
-            case value_t::object:
-            {
-                if (val.m_value.object->empty())
-                {
-                    o->write_characters("{}", 2);
-                    return;
-                }
-
-                if (pretty_print)
-                {
-                    o->write_characters("{\n", 2);
-
-                    // variable to hold indentation for recursive calls
-                    const auto new_indent = current_indent + indent_step;
-                    if (JSON_HEDLEY_UNLIKELY(indent_string.size() < new_indent))
-                    {
-                        indent_string.resize(indent_string.size() * 2, ' ');
-                    }
-
-                    // first n-1 elements
-                    auto i = val.m_value.object->cbegin();
-                    for (std::size_t cnt = 0; cnt < val.m_value.object->size() - 1; ++cnt, ++i)
-                    {
-                        o->write_characters(indent_string.c_str(), new_indent);
-                        o->write_character('\"');
-                        dump_escaped(i->first, ensure_ascii);
-                        o->write_characters("\": ", 3);
-                        dump(i->second, true, ensure_ascii, indent_step, new_indent);
-                        o->write_characters(",\n", 2);
-                    }
-
-                    // last element
-                    JSON_ASSERT(i != val.m_value.object->cend());
-                    JSON_ASSERT(std::next(i) == val.m_value.object->cend());
-                    o->write_characters(indent_string.c_str(), new_indent);
-                    o->write_character('\"');
-                    dump_escaped(i->first, ensure_ascii);
-                    o->write_characters("\": ", 3);
-                    dump(i->second, true, ensure_ascii, indent_step, new_indent);
-
-                    o->write_character('\n');
-                    o->write_characters(indent_string.c_str(), current_indent);
-                    o->write_character('}');
-                }
-                else
-                {
-                    o->write_character('{');
-
-                    // first n-1 elements
-                    auto i = val.m_value.object->cbegin();
-                    for (std::size_t cnt = 0; cnt < val.m_value.object->size() - 1; ++cnt, ++i)
-                    {
-                        o->write_character('\"');
-                        dump_escaped(i->first, ensure_ascii);
-                        o->write_characters("\":", 2);
-                        dump(i->second, false, ensure_ascii, indent_step, current_indent);
-                        o->write_character(',');
-                    }
-
-                    // last element
-                    JSON_ASSERT(i != val.m_value.object->cend());
-                    JSON_ASSERT(std::next(i) == val.m_value.object->cend());
-                    o->write_character('\"');
-                    dump_escaped(i->first, ensure_ascii);
-                    o->write_characters("\":", 2);
-                    dump(i->second, false, ensure_ascii, indent_step, current_indent);
-
-                    o->write_character('}');
-                }
-
-                return;
-            }
-
-            case value_t::array:
-            {
-                if (val.m_value.array->empty())
-                {
-                    o->write_characters("[]", 2);
-                    return;
-                }
-
-                if (pretty_print)
-                {
-                    o->write_characters("[\n", 2);
-
-                    // variable to hold indentation for recursive calls
-                    const auto new_indent = current_indent + indent_step;
-                    if (JSON_HEDLEY_UNLIKELY(indent_string.size() < new_indent))
-                    {
-                        indent_string.resize(indent_string.size() * 2, ' ');
-                    }
-
-                    // first n-1 elements
-                    for (auto i = val.m_value.array->cbegin();
-                            i != val.m_value.array->cend() - 1; ++i)
-                    {
-                        o->write_characters(indent_string.c_str(), new_indent);
-                        dump(*i, true, ensure_ascii, indent_step, new_indent);
-                        o->write_characters(",\n", 2);
-                    }
-
-                    // last element
-                    JSON_ASSERT(!val.m_value.array->empty());
-                    o->write_characters(indent_string.c_str(), new_indent);
-                    dump(val.m_value.array->back(), true, ensure_ascii, indent_step, new_indent);
-
-                    o->write_character('\n');
-                    o->write_characters(indent_string.c_str(), current_indent);
-                    o->write_character(']');
-                }
-                else
-                {
-                    o->write_character('[');
-
-                    // first n-1 elements
-                    for (auto i = val.m_value.array->cbegin();
-                            i != val.m_value.array->cend() - 1; ++i)
-                    {
-                        dump(*i, false, ensure_ascii, indent_step, current_indent);
-                        o->write_character(',');
-                    }
-
-                    // last element
-                    JSON_ASSERT(!val.m_value.array->empty());
-                    dump(val.m_value.array->back(), false, ensure_ascii, indent_step, current_indent);
-
-                    o->write_character(']');
-                }
-
-                return;
-            }
-
-            case value_t::string:
-            {
-                o->write_character('\"');
-                dump_escaped(*val.m_value.string, ensure_ascii);
-                o->write_character('\"');
-                return;
-            }
-
-            case value_t::binary:
-            {
-                if (pretty_print)
-                {
-                    o->write_characters("{\n", 2);
-
-                    // variable to hold indentation for recursive calls
-                    const auto new_indent = current_indent + indent_step;
-                    if (JSON_HEDLEY_UNLIKELY(indent_string.size() < new_indent))
-                    {
-                        indent_string.resize(indent_string.size() * 2, ' ');
-                    }
-
-                    o->write_characters(indent_string.c_str(), new_indent);
-
-                    o->write_characters("\"bytes\": [", 10);
-
-                    if (!val.m_value.binary->empty())
-                    {
-                        for (auto i = val.m_value.binary->cbegin();
-                                i != val.m_value.binary->cend() - 1; ++i)
-                        {
-                            dump_integer(*i);
-                            o->write_characters(", ", 2);
-                        }
-                        dump_integer(val.m_value.binary->back());
-                    }
-
-                    o->write_characters("],\n", 3);
-                    o->write_characters(indent_string.c_str(), new_indent);
-
-                    o->write_characters("\"subtype\": ", 11);
-                    if (val.m_value.binary->has_subtype())
-                    {
-                        dump_integer(val.m_value.binary->subtype());
-                    }
-                    else
-                    {
-                        o->write_characters("null", 4);
-                    }
-                    o->write_character('\n');
-                    o->write_characters(indent_string.c_str(), current_indent);
-                    o->write_character('}');
-                }
-                else
-                {
-                    o->write_characters("{\"bytes\":[", 10);
-
-                    if (!val.m_value.binary->empty())
-                    {
-                        for (auto i = val.m_value.binary->cbegin();
-                                i != val.m_value.binary->cend() - 1; ++i)
-                        {
-                            dump_integer(*i);
-                            o->write_character(',');
-                        }
-                        dump_integer(val.m_value.binary->back());
-                    }
-
-                    o->write_characters("],\"subtype\":", 12);
-                    if (val.m_value.binary->has_subtype())
-                    {
-                        dump_integer(val.m_value.binary->subtype());
-                        o->write_character('}');
-                    }
-                    else
-                    {
-                        o->write_characters("null}", 5);
-                    }
-                }
-                return;
-            }
-
-            case value_t::boolean:
-            {
-                if (val.m_value.boolean)
-                {
-                    o->write_characters("true", 4);
-                }
-                else
-                {
-                    o->write_characters("false", 5);
-                }
-                return;
-            }
-
-            case value_t::number_integer:
-            {
-                dump_integer(val.m_value.number_integer);
-                return;
-            }
-
-            case value_t::number_unsigned:
-            {
-                dump_integer(val.m_value.number_unsigned);
-                return;
-            }
-
-            case value_t::number_float:
-            {
-                dump_float(val.m_value.number_float);
-                return;
-            }
-
-            case value_t::discarded:
-            {
-                o->write_characters("<discarded>", 11);
-                return;
-            }
-
-            case value_t::null:
-            {
-                o->write_characters("null", 4);
-                return;
-            }
-
-            default:            // LCOV_EXCL_LINE
-                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-        }
-    }
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    /*!
-    @brief dump escaped string
-
-    Escape a string by replacing certain special characters by a sequence of an
-    escape character (backslash) and another character and other control
-    characters by a sequence of "\u" followed by a four-digit hex
-    representation. The escaped string is written to output stream @a o.
-
-    @param[in] s  the string to escape
-    @param[in] ensure_ascii  whether to escape non-ASCII characters with
-                             \uXXXX sequences
-
-    @complexity Linear in the length of string @a s.
-    */
-    void dump_escaped(const string_t& s, const bool ensure_ascii)
-    {
-        std::uint32_t codepoint{};
-        std::uint8_t state = UTF8_ACCEPT;
-        std::size_t bytes = 0;  // number of bytes written to string_buffer
-
-        // number of bytes written at the point of the last valid byte
-        std::size_t bytes_after_last_accept = 0;
-        std::size_t undumped_chars = 0;
-
-        for (std::size_t i = 0; i < s.size(); ++i)
-        {
-            const auto byte = static_cast<std::uint8_t>(s[i]);
-
-            switch (decode(state, codepoint, byte))
-            {
-                case UTF8_ACCEPT:  // decode found a new code point
-                {
-                    switch (codepoint)
-                    {
-                        case 0x08: // backspace
-                        {
-                            string_buffer[bytes++] = '\\';
-                            string_buffer[bytes++] = 'b';
-                            break;
-                        }
-
-                        case 0x09: // horizontal tab
-                        {
-                            string_buffer[bytes++] = '\\';
-                            string_buffer[bytes++] = 't';
-                            break;
-                        }
-
-                        case 0x0A: // newline
-                        {
-                            string_buffer[bytes++] = '\\';
-                            string_buffer[bytes++] = 'n';
-                            break;
-                        }
-
-                        case 0x0C: // formfeed
-                        {
-                            string_buffer[bytes++] = '\\';
-                            string_buffer[bytes++] = 'f';
-                            break;
-                        }
-
-                        case 0x0D: // carriage return
-                        {
-                            string_buffer[bytes++] = '\\';
-                            string_buffer[bytes++] = 'r';
-                            break;
-                        }
-
-                        case 0x22: // quotation mark
-                        {
-                            string_buffer[bytes++] = '\\';
-                            string_buffer[bytes++] = '\"';
-                            break;
-                        }
-
-                        case 0x5C: // reverse solidus
-                        {
-                            string_buffer[bytes++] = '\\';
-                            string_buffer[bytes++] = '\\';
-                            break;
-                        }
-
-                        default:
-                        {
-                            // escape control characters (0x00..0x1F) or, if
-                            // ensure_ascii parameter is used, non-ASCII characters
-                            if ((codepoint <= 0x1F) || (ensure_ascii && (codepoint >= 0x7F)))
-                            {
-                                if (codepoint <= 0xFFFF)
-                                {
-                                    // NOLINTNEXTLINE(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-                                    static_cast<void>((std::snprintf)(string_buffer.data() + bytes, 7, "\\u%04x",
-                                                                      static_cast<std::uint16_t>(codepoint)));
-                                    bytes += 6;
-                                }
-                                else
-                                {
-                                    // NOLINTNEXTLINE(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-                                    static_cast<void>((std::snprintf)(string_buffer.data() + bytes, 13, "\\u%04x\\u%04x",
-                                                                      static_cast<std::uint16_t>(0xD7C0u + (codepoint >> 10u)),
-                                                                      static_cast<std::uint16_t>(0xDC00u + (codepoint & 0x3FFu))));
-                                    bytes += 12;
-                                }
-                            }
-                            else
-                            {
-                                // copy byte to buffer (all previous bytes
-                                // been copied have in default case above)
-                                string_buffer[bytes++] = s[i];
-                            }
-                            break;
-                        }
-                    }
-
-                    // write buffer and reset index; there must be 13 bytes
-                    // left, as this is the maximal number of bytes to be
-                    // written ("\uxxxx\uxxxx\0") for one code point
-                    if (string_buffer.size() - bytes < 13)
-                    {
-                        o->write_characters(string_buffer.data(), bytes);
-                        bytes = 0;
-                    }
-
-                    // remember the byte position of this accept
-                    bytes_after_last_accept = bytes;
-                    undumped_chars = 0;
-                    break;
-                }
-
-                case UTF8_REJECT:  // decode found invalid UTF-8 byte
-                {
-                    switch (error_handler)
-                    {
-                        case error_handler_t::strict:
-                        {
-                            std::stringstream ss;
-                            ss << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << (byte | 0);
-                            JSON_THROW(type_error::create(316, "invalid UTF-8 byte at index " + std::to_string(i) + ": 0x" + ss.str(), BasicJsonType()));
-                        }
-
-                        case error_handler_t::ignore:
-                        case error_handler_t::replace:
-                        {
-                            // in case we saw this character the first time, we
-                            // would like to read it again, because the byte
-                            // may be OK for itself, but just not OK for the
-                            // previous sequence
-                            if (undumped_chars > 0)
-                            {
-                                --i;
-                            }
-
-                            // reset length buffer to the last accepted index;
-                            // thus removing/ignoring the invalid characters
-                            bytes = bytes_after_last_accept;
-
-                            if (error_handler == error_handler_t::replace)
-                            {
-                                // add a replacement character
-                                if (ensure_ascii)
-                                {
-                                    string_buffer[bytes++] = '\\';
-                                    string_buffer[bytes++] = 'u';
-                                    string_buffer[bytes++] = 'f';
-                                    string_buffer[bytes++] = 'f';
-                                    string_buffer[bytes++] = 'f';
-                                    string_buffer[bytes++] = 'd';
-                                }
-                                else
-                                {
-                                    string_buffer[bytes++] = detail::binary_writer<BasicJsonType, char>::to_char_type('\xEF');
-                                    string_buffer[bytes++] = detail::binary_writer<BasicJsonType, char>::to_char_type('\xBF');
-                                    string_buffer[bytes++] = detail::binary_writer<BasicJsonType, char>::to_char_type('\xBD');
-                                }
-
-                                // write buffer and reset index; there must be 13 bytes
-                                // left, as this is the maximal number of bytes to be
-                                // written ("\uxxxx\uxxxx\0") for one code point
-                                if (string_buffer.size() - bytes < 13)
-                                {
-                                    o->write_characters(string_buffer.data(), bytes);
-                                    bytes = 0;
-                                }
-
-                                bytes_after_last_accept = bytes;
-                            }
-
-                            undumped_chars = 0;
-
-                            // continue processing the string
-                            state = UTF8_ACCEPT;
-                            break;
-                        }
-
-                        default:            // LCOV_EXCL_LINE
-                            JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-                    }
-                    break;
-                }
-
-                default:  // decode found yet incomplete multi-byte code point
-                {
-                    if (!ensure_ascii)
-                    {
-                        // code point will not be escaped - copy byte to buffer
-                        string_buffer[bytes++] = s[i];
-                    }
-                    ++undumped_chars;
-                    break;
-                }
-            }
-        }
-
-        // we finished processing the string
-        if (JSON_HEDLEY_LIKELY(state == UTF8_ACCEPT))
-        {
-            // write buffer
-            if (bytes > 0)
-            {
-                o->write_characters(string_buffer.data(), bytes);
-            }
-        }
-        else
-        {
-            // we finish reading, but do not accept: string was incomplete
-            switch (error_handler)
-            {
-                case error_handler_t::strict:
-                {
-                    std::stringstream ss;
-                    ss << std::uppercase << std::setfill('0') << std::setw(2) << std::hex << (static_cast<std::uint8_t>(s.back()) | 0);
-                    JSON_THROW(type_error::create(316, "incomplete UTF-8 string; last byte: 0x" + ss.str(), BasicJsonType()));
-                }
-
-                case error_handler_t::ignore:
-                {
-                    // write all accepted bytes
-                    o->write_characters(string_buffer.data(), bytes_after_last_accept);
-                    break;
-                }
-
-                case error_handler_t::replace:
-                {
-                    // write all accepted bytes
-                    o->write_characters(string_buffer.data(), bytes_after_last_accept);
-                    // add a replacement character
-                    if (ensure_ascii)
-                    {
-                        o->write_characters("\\ufffd", 6);
-                    }
-                    else
-                    {
-                        o->write_characters("\xEF\xBF\xBD", 3);
-                    }
-                    break;
-                }
-
-                default:            // LCOV_EXCL_LINE
-                    JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-            }
-        }
-    }
-
-  private:
-    /*!
-    @brief count digits
-
-    Count the number of decimal (base 10) digits for an input unsigned integer.
-
-    @param[in] x  unsigned integer number to count its digits
-    @return    number of decimal digits
-    */
-    inline unsigned int count_digits(number_unsigned_t x) noexcept
-    {
-        unsigned int n_digits = 1;
-        for (;;)
-        {
-            if (x < 10)
-            {
-                return n_digits;
-            }
-            if (x < 100)
-            {
-                return n_digits + 1;
-            }
-            if (x < 1000)
-            {
-                return n_digits + 2;
-            }
-            if (x < 10000)
-            {
-                return n_digits + 3;
-            }
-            x = x / 10000u;
-            n_digits += 4;
-        }
-    }
-
-    // templates to avoid warnings about useless casts
-    template <typename NumberType, enable_if_t<std::is_signed<NumberType>::value, int> = 0>
-    bool is_negative_number(NumberType x)
-    {
-        return x < 0;
-    }
-
-    template < typename NumberType, enable_if_t <std::is_unsigned<NumberType>::value, int > = 0 >
-    bool is_negative_number(NumberType /*unused*/)
-    {
-        return false;
-    }
-
-    /*!
-    @brief dump an integer
-
-    Dump a given integer to output stream @a o. Works internally with
-    @a number_buffer.
-
-    @param[in] x  integer number (signed or unsigned) to dump
-    @tparam NumberType either @a number_integer_t or @a number_unsigned_t
-    */
-    template < typename NumberType, detail::enable_if_t <
-                   std::is_integral<NumberType>::value ||
-                   std::is_same<NumberType, number_unsigned_t>::value ||
-                   std::is_same<NumberType, number_integer_t>::value ||
-                   std::is_same<NumberType, binary_char_t>::value,
-                   int > = 0 >
-    void dump_integer(NumberType x)
-    {
-        static constexpr std::array<std::array<char, 2>, 100> digits_to_99
-        {
-            {
-                {{'0', '0'}}, {{'0', '1'}}, {{'0', '2'}}, {{'0', '3'}}, {{'0', '4'}}, {{'0', '5'}}, {{'0', '6'}}, {{'0', '7'}}, {{'0', '8'}}, {{'0', '9'}},
-                {{'1', '0'}}, {{'1', '1'}}, {{'1', '2'}}, {{'1', '3'}}, {{'1', '4'}}, {{'1', '5'}}, {{'1', '6'}}, {{'1', '7'}}, {{'1', '8'}}, {{'1', '9'}},
-                {{'2', '0'}}, {{'2', '1'}}, {{'2', '2'}}, {{'2', '3'}}, {{'2', '4'}}, {{'2', '5'}}, {{'2', '6'}}, {{'2', '7'}}, {{'2', '8'}}, {{'2', '9'}},
-                {{'3', '0'}}, {{'3', '1'}}, {{'3', '2'}}, {{'3', '3'}}, {{'3', '4'}}, {{'3', '5'}}, {{'3', '6'}}, {{'3', '7'}}, {{'3', '8'}}, {{'3', '9'}},
-                {{'4', '0'}}, {{'4', '1'}}, {{'4', '2'}}, {{'4', '3'}}, {{'4', '4'}}, {{'4', '5'}}, {{'4', '6'}}, {{'4', '7'}}, {{'4', '8'}}, {{'4', '9'}},
-                {{'5', '0'}}, {{'5', '1'}}, {{'5', '2'}}, {{'5', '3'}}, {{'5', '4'}}, {{'5', '5'}}, {{'5', '6'}}, {{'5', '7'}}, {{'5', '8'}}, {{'5', '9'}},
-                {{'6', '0'}}, {{'6', '1'}}, {{'6', '2'}}, {{'6', '3'}}, {{'6', '4'}}, {{'6', '5'}}, {{'6', '6'}}, {{'6', '7'}}, {{'6', '8'}}, {{'6', '9'}},
-                {{'7', '0'}}, {{'7', '1'}}, {{'7', '2'}}, {{'7', '3'}}, {{'7', '4'}}, {{'7', '5'}}, {{'7', '6'}}, {{'7', '7'}}, {{'7', '8'}}, {{'7', '9'}},
-                {{'8', '0'}}, {{'8', '1'}}, {{'8', '2'}}, {{'8', '3'}}, {{'8', '4'}}, {{'8', '5'}}, {{'8', '6'}}, {{'8', '7'}}, {{'8', '8'}}, {{'8', '9'}},
-                {{'9', '0'}}, {{'9', '1'}}, {{'9', '2'}}, {{'9', '3'}}, {{'9', '4'}}, {{'9', '5'}}, {{'9', '6'}}, {{'9', '7'}}, {{'9', '8'}}, {{'9', '9'}},
-            }
-        };
-
-        // special case for "0"
-        if (x == 0)
-        {
-            o->write_character('0');
-            return;
-        }
-
-        // use a pointer to fill the buffer
-        auto buffer_ptr = number_buffer.begin(); // NOLINT(llvm-qualified-auto,readability-qualified-auto,cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-
-        number_unsigned_t abs_value;
-
-        unsigned int n_chars{};
-
-        if (is_negative_number(x))
-        {
-            *buffer_ptr = '-';
-            abs_value = remove_sign(static_cast<number_integer_t>(x));
-
-            // account one more byte for the minus sign
-            n_chars = 1 + count_digits(abs_value);
-        }
-        else
-        {
-            abs_value = static_cast<number_unsigned_t>(x);
-            n_chars = count_digits(abs_value);
-        }
-
-        // spare 1 byte for '\0'
-        JSON_ASSERT(n_chars < number_buffer.size() - 1);
-
-        // jump to the end to generate the string from backward,
-        // so we later avoid reversing the result
-        buffer_ptr += n_chars;
-
-        // Fast int2ascii implementation inspired by "Fastware" talk by Andrei Alexandrescu
-        // See: https://www.youtube.com/watch?v=o4-CwDo2zpg
-        while (abs_value >= 100)
-        {
-            const auto digits_index = static_cast<unsigned>((abs_value % 100));
-            abs_value /= 100;
-            *(--buffer_ptr) = digits_to_99[digits_index][1];
-            *(--buffer_ptr) = digits_to_99[digits_index][0];
-        }
-
-        if (abs_value >= 10)
-        {
-            const auto digits_index = static_cast<unsigned>(abs_value);
-            *(--buffer_ptr) = digits_to_99[digits_index][1];
-            *(--buffer_ptr) = digits_to_99[digits_index][0];
-        }
-        else
-        {
-            *(--buffer_ptr) = static_cast<char>('0' + abs_value);
-        }
-
-        o->write_characters(number_buffer.data(), n_chars);
-    }
-
-    /*!
-    @brief dump a floating-point number
-
-    Dump a given floating-point number to output stream @a o. Works internally
-    with @a number_buffer.
-
-    @param[in] x  floating-point number to dump
-    */
-    void dump_float(number_float_t x)
-    {
-        // NaN / inf
-        if (!std::isfinite(x))
-        {
-            o->write_characters("null", 4);
-            return;
-        }
-
-        // If number_float_t is an IEEE-754 single or double precision number,
-        // use the Grisu2 algorithm to produce short numbers which are
-        // guaranteed to round-trip, using strtof and strtod, resp.
-        //
-        // NB: The test below works if <long double> == <double>.
-        static constexpr bool is_ieee_single_or_double
-            = (std::numeric_limits<number_float_t>::is_iec559 && std::numeric_limits<number_float_t>::digits == 24 && std::numeric_limits<number_float_t>::max_exponent == 128) ||
-              (std::numeric_limits<number_float_t>::is_iec559 && std::numeric_limits<number_float_t>::digits == 53 && std::numeric_limits<number_float_t>::max_exponent == 1024);
-
-        dump_float(x, std::integral_constant<bool, is_ieee_single_or_double>());
-    }
-
-    void dump_float(number_float_t x, std::true_type /*is_ieee_single_or_double*/)
-    {
-        auto* begin = number_buffer.data();
-        auto* end = ::nlohmann::detail::to_chars(begin, begin + number_buffer.size(), x);
-
-        o->write_characters(begin, static_cast<size_t>(end - begin));
-    }
-
-    void dump_float(number_float_t x, std::false_type /*is_ieee_single_or_double*/)
-    {
-        // get number of digits for a float -> text -> float round-trip
-        static constexpr auto d = std::numeric_limits<number_float_t>::max_digits10;
-
-        // the actual conversion
-        // NOLINTNEXTLINE(cppcoreguidelines-pro-type-vararg,hicpp-vararg)
-        std::ptrdiff_t len = (std::snprintf)(number_buffer.data(), number_buffer.size(), "%.*g", d, x);
-
-        // negative value indicates an error
-        JSON_ASSERT(len > 0);
-        // check if buffer was large enough
-        JSON_ASSERT(static_cast<std::size_t>(len) < number_buffer.size());
-
-        // erase thousands separator
-        if (thousands_sep != '\0')
-        {
-            // NOLINTNEXTLINE(readability-qualified-auto,llvm-qualified-auto): std::remove returns an iterator, see https://github.com/nlohmann/json/issues/3081
-            const auto end = std::remove(number_buffer.begin(), number_buffer.begin() + len, thousands_sep);
-            std::fill(end, number_buffer.end(), '\0');
-            JSON_ASSERT((end - number_buffer.begin()) <= len);
-            len = (end - number_buffer.begin());
-        }
-
-        // convert decimal point to '.'
-        if (decimal_point != '\0' && decimal_point != '.')
-        {
-            // NOLINTNEXTLINE(readability-qualified-auto,llvm-qualified-auto): std::find returns an iterator, see https://github.com/nlohmann/json/issues/3081
-            const auto dec_pos = std::find(number_buffer.begin(), number_buffer.end(), decimal_point);
-            if (dec_pos != number_buffer.end())
-            {
-                *dec_pos = '.';
-            }
-        }
-
-        o->write_characters(number_buffer.data(), static_cast<std::size_t>(len));
-
-        // determine if we need to append ".0"
-        const bool value_is_int_like =
-            std::none_of(number_buffer.begin(), number_buffer.begin() + len + 1,
-                         [](char c)
-        {
-            return c == '.' || c == 'e';
-        });
-
-        if (value_is_int_like)
-        {
-            o->write_characters(".0", 2);
-        }
-    }
-
-    /*!
-    @brief check whether a string is UTF-8 encoded
-
-    The function checks each byte of a string whether it is UTF-8 encoded. The
-    result of the check is stored in the @a state parameter. The function must
-    be called initially with state 0 (accept). State 1 means the string must
-    be rejected, because the current byte is not allowed. If the string is
-    completely processed, but the state is non-zero, the string ended
-    prematurely; that is, the last byte indicated more bytes should have
-    followed.
-
-    @param[in,out] state  the state of the decoding
-    @param[in,out] codep  codepoint (valid only if resulting state is UTF8_ACCEPT)
-    @param[in] byte       next byte to decode
-    @return               new state
-
-    @note The function has been edited: a std::array is used.
-
-    @copyright Copyright (c) 2008-2009 Bjoern Hoehrmann <bjoern@hoehrmann.de>
-    @sa http://bjoern.hoehrmann.de/utf-8/decoder/dfa/
-    */
-    static std::uint8_t decode(std::uint8_t& state, std::uint32_t& codep, const std::uint8_t byte) noexcept
-    {
-        static const std::array<std::uint8_t, 400> utf8d =
-        {
-            {
-                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 00..1F
-                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 20..3F
-                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 40..5F
-                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 60..7F
-                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, // 80..9F
-                7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, // A0..BF
-                8, 8, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, // C0..DF
-                0xA, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x3, 0x4, 0x3, 0x3, // E0..EF
-                0xB, 0x6, 0x6, 0x6, 0x5, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, // F0..FF
-                0x0, 0x1, 0x2, 0x3, 0x5, 0x8, 0x7, 0x1, 0x1, 0x1, 0x4, 0x6, 0x1, 0x1, 0x1, 0x1, // s0..s0
-                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, // s1..s2
-                1, 2, 1, 1, 1, 1, 1, 2, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, // s3..s4
-                1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, // s5..s6
-                1, 3, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 // s7..s8
-            }
-        };
-
-        JSON_ASSERT(byte < utf8d.size());
-        const std::uint8_t type = utf8d[byte];
-
-        codep = (state != UTF8_ACCEPT)
-                ? (byte & 0x3fu) | (codep << 6u)
-                : (0xFFu >> type) & (byte);
-
-        std::size_t index = 256u + static_cast<size_t>(state) * 16u + static_cast<size_t>(type);
-        JSON_ASSERT(index < 400);
-        state = utf8d[index];
-        return state;
-    }
-
-    /*
-     * Overload to make the compiler happy while it is instantiating
-     * dump_integer for number_unsigned_t.
-     * Must never be called.
-     */
-    number_unsigned_t remove_sign(number_unsigned_t x)
-    {
-        JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-        return x; // LCOV_EXCL_LINE
-    }
-
-    /*
-     * Helper function for dump_integer
-     *
-     * This function takes a negative signed integer and returns its absolute
-     * value as unsigned integer. The plus/minus shuffling is necessary as we can
-     * not directly remove the sign of an arbitrary signed integer as the
-     * absolute values of INT_MIN and INT_MAX are usually not the same. See
-     * #1708 for details.
-     */
-    inline number_unsigned_t remove_sign(number_integer_t x) noexcept
-    {
-        JSON_ASSERT(x < 0 && x < (std::numeric_limits<number_integer_t>::max)()); // NOLINT(misc-redundant-expression)
-        return static_cast<number_unsigned_t>(-(x + 1)) + 1;
-    }
-
-  private:
-    /// the output of the serializer
-    output_adapter_t<char> o = nullptr;
-
-    /// a (hopefully) large enough character buffer
-    std::array<char, 64> number_buffer{{}};
-
-    /// the locale
-    const std::lconv* loc = nullptr;
-    /// the locale's thousand separator character
-    const char thousands_sep = '\0';
-    /// the locale's decimal point character
-    const char decimal_point = '\0';
-
-    /// string buffer
-    std::array<char, 512> string_buffer{{}};
-
-    /// the indentation character
-    const char indent_char;
-    /// the indentation string
-    string_t indent_string;
-
-    /// error_handler how to react on decoding errors
-    const error_handler_t error_handler;
-};
-}  // namespace detail
-}  // namespace nlohmann
-
-// #include <nlohmann/detail/value_t.hpp>
-
-// #include <nlohmann/json_fwd.hpp>
-
-// #include <nlohmann/ordered_map.hpp>
-
-
-#include <functional> // less
-#include <initializer_list> // initializer_list
-#include <iterator> // input_iterator_tag, iterator_traits
-#include <memory> // allocator
-#include <stdexcept> // for out_of_range
-#include <type_traits> // enable_if, is_convertible
-#include <utility> // pair
-#include <vector> // vector
-
-// #include <nlohmann/detail/macro_scope.hpp>
-
-
-namespace nlohmann
-{
-
-/// ordered_map: a minimal map-like container that preserves insertion order
-/// for use within nlohmann::basic_json<ordered_map>
-template <class Key, class T, class IgnoredLess = std::less<Key>,
-          class Allocator = std::allocator<std::pair<const Key, T>>>
-                  struct ordered_map : std::vector<std::pair<const Key, T>, Allocator>
-{
-    using key_type = Key;
-    using mapped_type = T;
-    using Container = std::vector<std::pair<const Key, T>, Allocator>;
-    using iterator = typename Container::iterator;
-    using const_iterator = typename Container::const_iterator;
-    using size_type = typename Container::size_type;
-    using value_type = typename Container::value_type;
-
-    // Explicit constructors instead of `using Container::Container`
-    // otherwise older compilers choke on it (GCC <= 5.5, xcode <= 9.4)
-    ordered_map(const Allocator& alloc = Allocator()) : Container{alloc} {}
-    template <class It>
-    ordered_map(It first, It last, const Allocator& alloc = Allocator())
-        : Container{first, last, alloc} {}
-    ordered_map(std::initializer_list<T> init, const Allocator& alloc = Allocator() )
-        : Container{init, alloc} {}
-
-    std::pair<iterator, bool> emplace(const key_type& key, T&& t)
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == key)
-            {
-                return {it, false};
-            }
-        }
-        Container::emplace_back(key, t);
-        return {--this->end(), true};
-    }
-
-    T& operator[](const Key& key)
-    {
-        return emplace(key, T{}).first->second;
-    }
-
-    const T& operator[](const Key& key) const
-    {
-        return at(key);
-    }
-
-    T& at(const Key& key)
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == key)
-            {
-                return it->second;
-            }
-        }
-
-        JSON_THROW(std::out_of_range("key not found"));
-    }
-
-    const T& at(const Key& key) const
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == key)
-            {
-                return it->second;
-            }
-        }
-
-        JSON_THROW(std::out_of_range("key not found"));
-    }
-
-    size_type erase(const Key& key)
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == key)
-            {
-                // Since we cannot move const Keys, re-construct them in place
-                for (auto next = it; ++next != this->end(); ++it)
-                {
-                    it->~value_type(); // Destroy but keep allocation
-                    new (&*it) value_type{std::move(*next)};
-                }
-                Container::pop_back();
-                return 1;
-            }
-        }
-        return 0;
-    }
-
-    iterator erase(iterator pos)
-    {
-        return erase(pos, std::next(pos));
-    }
-
-    iterator erase(iterator first, iterator last)
-    {
-        const auto elements_affected = std::distance(first, last);
-        const auto offset = std::distance(Container::begin(), first);
-
-        // This is the start situation. We need to delete elements_affected
-        // elements (3 in this example: e, f, g), and need to return an
-        // iterator past the last deleted element (h in this example).
-        // Note that offset is the distance from the start of the vector
-        // to first. We will need this later.
-
-        // [ a, b, c, d, e, f, g, h, i, j ]
-        //               ^        ^
-        //             first    last
-
-        // Since we cannot move const Keys, we re-construct them in place.
-        // We start at first and re-construct (viz. copy) the elements from
-        // the back of the vector. Example for first iteration:
-
-        //               ,--------.
-        //               v        |   destroy e and re-construct with h
-        // [ a, b, c, d, e, f, g, h, i, j ]
-        //               ^        ^
-        //               it       it + elements_affected
-
-        for (auto it = first; std::next(it, elements_affected) != Container::end(); ++it)
-        {
-            it->~value_type(); // destroy but keep allocation
-            new (&*it) value_type{std::move(*std::next(it, elements_affected))}; // "move" next element to it
-        }
-
-        // [ a, b, c, d, h, i, j, h, i, j ]
-        //               ^        ^
-        //             first    last
-
-        // remove the unneeded elements at the end of the vector
-        Container::resize(this->size() - static_cast<size_type>(elements_affected));
-
-        // [ a, b, c, d, h, i, j ]
-        //               ^        ^
-        //             first    last
-
-        // first is now pointing past the last deleted element, but we cannot
-        // use this iterator, because it may have been invalidated by the
-        // resize call. Instead, we can return begin() + offset.
-        return Container::begin() + offset;
-    }
-
-    size_type count(const Key& key) const
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == key)
-            {
-                return 1;
-            }
-        }
-        return 0;
-    }
-
-    iterator find(const Key& key)
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == key)
-            {
-                return it;
-            }
-        }
-        return Container::end();
-    }
-
-    const_iterator find(const Key& key) const
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == key)
-            {
-                return it;
-            }
-        }
-        return Container::end();
-    }
-
-    std::pair<iterator, bool> insert( value_type&& value )
-    {
-        return emplace(value.first, std::move(value.second));
-    }
-
-    std::pair<iterator, bool> insert( const value_type& value )
-    {
-        for (auto it = this->begin(); it != this->end(); ++it)
-        {
-            if (it->first == value.first)
-            {
-                return {it, false};
-            }
-        }
-        Container::push_back(value);
-        return {--this->end(), true};
-    }
-
-    template<typename InputIt>
-    using require_input_iter = typename std::enable_if<std::is_convertible<typename std::iterator_traits<InputIt>::iterator_category,
-            std::input_iterator_tag>::value>::type;
-
-    template<typename InputIt, typename = require_input_iter<InputIt>>
-    void insert(InputIt first, InputIt last)
-    {
-        for (auto it = first; it != last; ++it)
-        {
-            insert(*it);
-        }
-    }
-};
-
-}  // namespace nlohmann
-
-
-#if defined(JSON_HAS_CPP_17)
-    #include <string_view>
-#endif
-
-/*!
-@brief namespace for Niels Lohmann
-@see https://github.com/nlohmann
-@since version 1.0.0
-*/
-namespace nlohmann
-{
-
-/*!
-@brief a class to store JSON values
-
-@internal
-@invariant The member variables @a m_value and @a m_type have the following
-relationship:
-- If `m_type == value_t::object`, then `m_value.object != nullptr`.
-- If `m_type == value_t::array`, then `m_value.array != nullptr`.
-- If `m_type == value_t::string`, then `m_value.string != nullptr`.
-The invariants are checked by member function assert_invariant().
-
-@note ObjectType trick from https://stackoverflow.com/a/9860911
-@endinternal
-
-@since version 1.0.0
-
-@nosubgrouping
-*/
-NLOHMANN_BASIC_JSON_TPL_DECLARATION
-class basic_json // NOLINT(cppcoreguidelines-special-member-functions,hicpp-special-member-functions)
-{
-  private:
-    template<detail::value_t> friend struct detail::external_constructor;
-    friend ::nlohmann::json_pointer<basic_json>;
-
-    template<typename BasicJsonType, typename InputType>
-    friend class ::nlohmann::detail::parser;
-    friend ::nlohmann::detail::serializer<basic_json>;
-    template<typename BasicJsonType>
-    friend class ::nlohmann::detail::iter_impl;
-    template<typename BasicJsonType, typename CharType>
-    friend class ::nlohmann::detail::binary_writer;
-    template<typename BasicJsonType, typename InputType, typename SAX>
-    friend class ::nlohmann::detail::binary_reader;
-    template<typename BasicJsonType>
-    friend class ::nlohmann::detail::json_sax_dom_parser;
-    template<typename BasicJsonType>
-    friend class ::nlohmann::detail::json_sax_dom_callback_parser;
-    friend class ::nlohmann::detail::exception;
-
-    /// workaround type for MSVC
-    using basic_json_t = NLOHMANN_BASIC_JSON_TPL;
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    // convenience aliases for types residing in namespace detail;
-    using lexer = ::nlohmann::detail::lexer_base<basic_json>;
-
-    template<typename InputAdapterType>
-    static ::nlohmann::detail::parser<basic_json, InputAdapterType> parser(
-        InputAdapterType adapter,
-        detail::parser_callback_t<basic_json>cb = nullptr,
-        const bool allow_exceptions = true,
-        const bool ignore_comments = false
-                                 )
-    {
-        return ::nlohmann::detail::parser<basic_json, InputAdapterType>(std::move(adapter),
-                std::move(cb), allow_exceptions, ignore_comments);
-    }
-
-  private:
-    using primitive_iterator_t = ::nlohmann::detail::primitive_iterator_t;
-    template<typename BasicJsonType>
-    using internal_iterator = ::nlohmann::detail::internal_iterator<BasicJsonType>;
-    template<typename BasicJsonType>
-    using iter_impl = ::nlohmann::detail::iter_impl<BasicJsonType>;
-    template<typename Iterator>
-    using iteration_proxy = ::nlohmann::detail::iteration_proxy<Iterator>;
-    template<typename Base> using json_reverse_iterator = ::nlohmann::detail::json_reverse_iterator<Base>;
-
-    template<typename CharType>
-    using output_adapter_t = ::nlohmann::detail::output_adapter_t<CharType>;
-
-    template<typename InputType>
-    using binary_reader = ::nlohmann::detail::binary_reader<basic_json, InputType>;
-    template<typename CharType> using binary_writer = ::nlohmann::detail::binary_writer<basic_json, CharType>;
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    using serializer = ::nlohmann::detail::serializer<basic_json>;
-
-  public:
-    using value_t = detail::value_t;
-    /// JSON Pointer, see @ref nlohmann::json_pointer
-    using json_pointer = ::nlohmann::json_pointer<basic_json>;
-    template<typename T, typename SFINAE>
-    using json_serializer = JSONSerializer<T, SFINAE>;
-    /// how to treat decoding errors
-    using error_handler_t = detail::error_handler_t;
-    /// how to treat CBOR tags
-    using cbor_tag_handler_t = detail::cbor_tag_handler_t;
-    /// helper type for initializer lists of basic_json values
-    using initializer_list_t = std::initializer_list<detail::json_ref<basic_json>>;
-
-    using input_format_t = detail::input_format_t;
-    /// SAX interface type, see @ref nlohmann::json_sax
-    using json_sax_t = json_sax<basic_json>;
-
-    ////////////////
-    // exceptions //
-    ////////////////
-
-    /// @name exceptions
-    /// Classes to implement user-defined exceptions.
-    /// @{
-
-    using exception = detail::exception;
-    using parse_error = detail::parse_error;
-    using invalid_iterator = detail::invalid_iterator;
-    using type_error = detail::type_error;
-    using out_of_range = detail::out_of_range;
-    using other_error = detail::other_error;
-
-    /// @}
-
-
-    /////////////////////
-    // container types //
-    /////////////////////
-
-    /// @name container types
-    /// The canonic container types to use @ref basic_json like any other STL
-    /// container.
-    /// @{
-
-    /// the type of elements in a basic_json container
-    using value_type = basic_json;
-
-    /// the type of an element reference
-    using reference = value_type&;
-    /// the type of an element const reference
-    using const_reference = const value_type&;
-
-    /// a type to represent differences between iterators
-    using difference_type = std::ptrdiff_t;
-    /// a type to represent container sizes
-    using size_type = std::size_t;
-
-    /// the allocator type
-    using allocator_type = AllocatorType<basic_json>;
-
-    /// the type of an element pointer
-    using pointer = typename std::allocator_traits<allocator_type>::pointer;
-    /// the type of an element const pointer
-    using const_pointer = typename std::allocator_traits<allocator_type>::const_pointer;
-
-    /// an iterator for a basic_json container
-    using iterator = iter_impl<basic_json>;
-    /// a const iterator for a basic_json container
-    using const_iterator = iter_impl<const basic_json>;
-    /// a reverse iterator for a basic_json container
-    using reverse_iterator = json_reverse_iterator<typename basic_json::iterator>;
-    /// a const reverse iterator for a basic_json container
-    using const_reverse_iterator = json_reverse_iterator<typename basic_json::const_iterator>;
-
-    /// @}
-
-
-    /// @brief returns the allocator associated with the container
-    /// @sa https://json.nlohmann.me/api/basic_json/get_allocator/
-    static allocator_type get_allocator()
-    {
-        return allocator_type();
-    }
-
-    /// @brief returns version information on the library
-    /// @sa https://json.nlohmann.me/api/basic_json/meta/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json meta()
-    {
-        basic_json result;
-
-        result["copyright"] = "(C) 2013-2022 Niels Lohmann";
-        result["name"] = "JSON for Modern C++";
-        result["url"] = "https://github.com/nlohmann/json";
-        result["version"]["string"] =
-            std::to_string(NLOHMANN_JSON_VERSION_MAJOR) + "." +
-            std::to_string(NLOHMANN_JSON_VERSION_MINOR) + "." +
-            std::to_string(NLOHMANN_JSON_VERSION_PATCH);
-        result["version"]["major"] = NLOHMANN_JSON_VERSION_MAJOR;
-        result["version"]["minor"] = NLOHMANN_JSON_VERSION_MINOR;
-        result["version"]["patch"] = NLOHMANN_JSON_VERSION_PATCH;
-
-#ifdef _WIN32
-        result["platform"] = "win32";
-#elif defined __linux__
-        result["platform"] = "linux";
-#elif defined __APPLE__
-        result["platform"] = "apple";
-#elif defined __unix__
-        result["platform"] = "unix";
-#else
-        result["platform"] = "unknown";
-#endif
-
-#if defined(__ICC) || defined(__INTEL_COMPILER)
-        result["compiler"] = {{"family", "icc"}, {"version", __INTEL_COMPILER}};
-#elif defined(__clang__)
-        result["compiler"] = {{"family", "clang"}, {"version", __clang_version__}};
-#elif defined(__GNUC__) || defined(__GNUG__)
-        result["compiler"] = {{"family", "gcc"}, {"version", std::to_string(__GNUC__) + "." + std::to_string(__GNUC_MINOR__) + "." + std::to_string(__GNUC_PATCHLEVEL__)}};
-#elif defined(__HP_cc) || defined(__HP_aCC)
-        result["compiler"] = "hp"
-#elif defined(__IBMCPP__)
-        result["compiler"] = {{"family", "ilecpp"}, {"version", __IBMCPP__}};
-#elif defined(_MSC_VER)
-        result["compiler"] = {{"family", "msvc"}, {"version", _MSC_VER}};
-#elif defined(__PGI)
-        result["compiler"] = {{"family", "pgcpp"}, {"version", __PGI}};
-#elif defined(__SUNPRO_CC)
-        result["compiler"] = {{"family", "sunpro"}, {"version", __SUNPRO_CC}};
-#else
-        result["compiler"] = {{"family", "unknown"}, {"version", "unknown"}};
-#endif
-
-#ifdef __cplusplus
-        result["compiler"]["c++"] = std::to_string(__cplusplus);
-#else
-        result["compiler"]["c++"] = "unknown";
-#endif
-        return result;
-    }
-
-
-    ///////////////////////////
-    // JSON value data types //
-    ///////////////////////////
-
-    /// @name JSON value data types
-    /// The data types to store a JSON value. These types are derived from
-    /// the template arguments passed to class @ref basic_json.
-    /// @{
-
-    /// @brief object key comparator type
-    /// @sa https://json.nlohmann.me/api/basic_json/object_comparator_t/
-#if defined(JSON_HAS_CPP_14)
-    // Use transparent comparator if possible, combined with perfect forwarding
-    // on find() and count() calls prevents unnecessary string construction.
-    using object_comparator_t = std::less<>;
-#else
-    using object_comparator_t = std::less<StringType>;
-#endif
-
-    /// @brief a type for an object
-    /// @sa https://json.nlohmann.me/api/basic_json/object_t/
-    using object_t = ObjectType<StringType,
-          basic_json,
-          object_comparator_t,
-          AllocatorType<std::pair<const StringType,
-          basic_json>>>;
-
-    /// @brief a type for an array
-    /// @sa https://json.nlohmann.me/api/basic_json/array_t/
-    using array_t = ArrayType<basic_json, AllocatorType<basic_json>>;
-
-    /// @brief a type for a string
-    /// @sa https://json.nlohmann.me/api/basic_json/string_t/
-    using string_t = StringType;
-
-    /// @brief a type for a boolean
-    /// @sa https://json.nlohmann.me/api/basic_json/boolean_t/
-    using boolean_t = BooleanType;
-
-    /// @brief a type for a number (integer)
-    /// @sa https://json.nlohmann.me/api/basic_json/number_integer_t/
-    using number_integer_t = NumberIntegerType;
-
-    /// @brief a type for a number (unsigned)
-    /// @sa https://json.nlohmann.me/api/basic_json/number_unsigned_t/
-    using number_unsigned_t = NumberUnsignedType;
-
-    /// @brief a type for a number (floating-point)
-    /// @sa https://json.nlohmann.me/api/basic_json/number_float_t/
-    using number_float_t = NumberFloatType;
-
-    /// @brief a type for a packed binary type
-    /// @sa https://json.nlohmann.me/api/basic_json/binary_t/
-    using binary_t = nlohmann::byte_container_with_subtype<BinaryType>;
-
-    /// @}
-
-  private:
-
-    /// helper for exception-safe object creation
-    template<typename T, typename... Args>
-    JSON_HEDLEY_RETURNS_NON_NULL
-    static T* create(Args&& ... args)
-    {
-        AllocatorType<T> alloc;
-        using AllocatorTraits = std::allocator_traits<AllocatorType<T>>;
-
-        auto deleter = [&](T * obj)
-        {
-            AllocatorTraits::deallocate(alloc, obj, 1);
-        };
-        std::unique_ptr<T, decltype(deleter)> obj(AllocatorTraits::allocate(alloc, 1), deleter);
-        AllocatorTraits::construct(alloc, obj.get(), std::forward<Args>(args)...);
-        JSON_ASSERT(obj != nullptr);
-        return obj.release();
-    }
-
-    ////////////////////////
-    // JSON value storage //
-    ////////////////////////
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    /*!
-    @brief a JSON value
-
-    The actual storage for a JSON value of the @ref basic_json class. This
-    union combines the different storage types for the JSON value types
-    defined in @ref value_t.
-
-    JSON type | value_t type    | used type
-    --------- | --------------- | ------------------------
-    object    | object          | pointer to @ref object_t
-    array     | array           | pointer to @ref array_t
-    string    | string          | pointer to @ref string_t
-    boolean   | boolean         | @ref boolean_t
-    number    | number_integer  | @ref number_integer_t
-    number    | number_unsigned | @ref number_unsigned_t
-    number    | number_float    | @ref number_float_t
-    binary    | binary          | pointer to @ref binary_t
-    null      | null            | *no value is stored*
-
-    @note Variable-length types (objects, arrays, and strings) are stored as
-    pointers. The size of the union should not exceed 64 bits if the default
-    value types are used.
-
-    @since version 1.0.0
-    */
-    union json_value
-    {
-        /// object (stored with pointer to save storage)
-        object_t* object;
-        /// array (stored with pointer to save storage)
-        array_t* array;
-        /// string (stored with pointer to save storage)
-        string_t* string;
-        /// binary (stored with pointer to save storage)
-        binary_t* binary;
-        /// boolean
-        boolean_t boolean;
-        /// number (integer)
-        number_integer_t number_integer;
-        /// number (unsigned integer)
-        number_unsigned_t number_unsigned;
-        /// number (floating-point)
-        number_float_t number_float;
-
-        /// default constructor (for null values)
-        json_value() = default;
-        /// constructor for booleans
-        json_value(boolean_t v) noexcept : boolean(v) {}
-        /// constructor for numbers (integer)
-        json_value(number_integer_t v) noexcept : number_integer(v) {}
-        /// constructor for numbers (unsigned)
-        json_value(number_unsigned_t v) noexcept : number_unsigned(v) {}
-        /// constructor for numbers (floating-point)
-        json_value(number_float_t v) noexcept : number_float(v) {}
-        /// constructor for empty values of a given type
-        json_value(value_t t)
-        {
-            switch (t)
-            {
-                case value_t::object:
-                {
-                    object = create<object_t>();
-                    break;
-                }
-
-                case value_t::array:
-                {
-                    array = create<array_t>();
-                    break;
-                }
-
-                case value_t::string:
-                {
-                    string = create<string_t>("");
-                    break;
-                }
-
-                case value_t::binary:
-                {
-                    binary = create<binary_t>();
-                    break;
-                }
-
-                case value_t::boolean:
-                {
-                    boolean = static_cast<boolean_t>(false);
-                    break;
-                }
-
-                case value_t::number_integer:
-                {
-                    number_integer = static_cast<number_integer_t>(0);
-                    break;
-                }
-
-                case value_t::number_unsigned:
-                {
-                    number_unsigned = static_cast<number_unsigned_t>(0);
-                    break;
-                }
-
-                case value_t::number_float:
-                {
-                    number_float = static_cast<number_float_t>(0.0);
-                    break;
-                }
-
-                case value_t::null:
-                {
-                    object = nullptr;  // silence warning, see #821
-                    break;
-                }
-
-                case value_t::discarded:
-                default:
-                {
-                    object = nullptr;  // silence warning, see #821
-                    if (JSON_HEDLEY_UNLIKELY(t == value_t::null))
-                    {
-                        JSON_THROW(other_error::create(500, "961c151d2e87f2686a955a9be24d316f1362bf21 3.10.5", basic_json())); // LCOV_EXCL_LINE
-                    }
-                    break;
-                }
-            }
-        }
-
-        /// constructor for strings
-        json_value(const string_t& value) : string(create<string_t>(value)) {}
-
-        /// constructor for rvalue strings
-        json_value(string_t&& value) : string(create<string_t>(std::move(value))) {}
-
-        /// constructor for objects
-        json_value(const object_t& value) : object(create<object_t>(value)) {}
-
-        /// constructor for rvalue objects
-        json_value(object_t&& value) : object(create<object_t>(std::move(value))) {}
-
-        /// constructor for arrays
-        json_value(const array_t& value) : array(create<array_t>(value)) {}
-
-        /// constructor for rvalue arrays
-        json_value(array_t&& value) : array(create<array_t>(std::move(value))) {}
-
-        /// constructor for binary arrays
-        json_value(const typename binary_t::container_type& value) : binary(create<binary_t>(value)) {}
-
-        /// constructor for rvalue binary arrays
-        json_value(typename binary_t::container_type&& value) : binary(create<binary_t>(std::move(value))) {}
-
-        /// constructor for binary arrays (internal type)
-        json_value(const binary_t& value) : binary(create<binary_t>(value)) {}
-
-        /// constructor for rvalue binary arrays (internal type)
-        json_value(binary_t&& value) : binary(create<binary_t>(std::move(value))) {}
-
-        void destroy(value_t t)
-        {
-            if (t == value_t::array || t == value_t::object)
-            {
-                // flatten the current json_value to a heap-allocated stack
-                std::vector<basic_json> stack;
-
-                // move the top-level items to stack
-                if (t == value_t::array)
-                {
-                    stack.reserve(array->size());
-                    std::move(array->begin(), array->end(), std::back_inserter(stack));
-                }
-                else
-                {
-                    stack.reserve(object->size());
-                    for (auto&& it : *object)
-                    {
-                        stack.push_back(std::move(it.second));
-                    }
-                }
-
-                while (!stack.empty())
-                {
-                    // move the last item to local variable to be processed
-                    basic_json current_item(std::move(stack.back()));
-                    stack.pop_back();
-
-                    // if current_item is array/object, move
-                    // its children to the stack to be processed later
-                    if (current_item.is_array())
-                    {
-                        std::move(current_item.m_value.array->begin(), current_item.m_value.array->end(), std::back_inserter(stack));
-
-                        current_item.m_value.array->clear();
-                    }
-                    else if (current_item.is_object())
-                    {
-                        for (auto&& it : *current_item.m_value.object)
-                        {
-                            stack.push_back(std::move(it.second));
-                        }
-
-                        current_item.m_value.object->clear();
-                    }
-
-                    // it's now safe that current_item get destructed
-                    // since it doesn't have any children
-                }
-            }
-
-            switch (t)
-            {
-                case value_t::object:
-                {
-                    AllocatorType<object_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, object);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, object, 1);
-                    break;
-                }
-
-                case value_t::array:
-                {
-                    AllocatorType<array_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, array);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, array, 1);
-                    break;
-                }
-
-                case value_t::string:
-                {
-                    AllocatorType<string_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, string);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, string, 1);
-                    break;
-                }
-
-                case value_t::binary:
-                {
-                    AllocatorType<binary_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, binary);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, binary, 1);
-                    break;
-                }
-
-                case value_t::null:
-                case value_t::boolean:
-                case value_t::number_integer:
-                case value_t::number_unsigned:
-                case value_t::number_float:
-                case value_t::discarded:
-                default:
-                {
-                    break;
-                }
-            }
-        }
-    };
-
-  private:
-    /*!
-    @brief checks the class invariants
-
-    This function asserts the class invariants. It needs to be called at the
-    end of every constructor to make sure that created objects respect the
-    invariant. Furthermore, it has to be called each time the type of a JSON
-    value is changed, because the invariant expresses a relationship between
-    @a m_type and @a m_value.
-
-    Furthermore, the parent relation is checked for arrays and objects: If
-    @a check_parents true and the value is an array or object, then the
-    container's elements must have the current value as parent.
-
-    @param[in] check_parents  whether the parent relation should be checked.
-               The value is true by default and should only be set to false
-               during destruction of objects when the invariant does not
-               need to hold.
-    */
-    void assert_invariant(bool check_parents = true) const noexcept
-    {
-        JSON_ASSERT(m_type != value_t::object || m_value.object != nullptr);
-        JSON_ASSERT(m_type != value_t::array || m_value.array != nullptr);
-        JSON_ASSERT(m_type != value_t::string || m_value.string != nullptr);
-        JSON_ASSERT(m_type != value_t::binary || m_value.binary != nullptr);
-
-#if JSON_DIAGNOSTICS
-        JSON_TRY
-        {
-            // cppcheck-suppress assertWithSideEffect
-            JSON_ASSERT(!check_parents || !is_structured() || std::all_of(begin(), end(), [this](const basic_json & j)
-            {
-                return j.m_parent == this;
-            }));
-        }
-        JSON_CATCH(...) {} // LCOV_EXCL_LINE
-#endif
-        static_cast<void>(check_parents);
-    }
-
-    void set_parents()
-    {
-#if JSON_DIAGNOSTICS
-        switch (m_type)
-        {
-            case value_t::array:
-            {
-                for (auto& element : *m_value.array)
-                {
-                    element.m_parent = this;
-                }
-                break;
-            }
-
-            case value_t::object:
-            {
-                for (auto& element : *m_value.object)
-                {
-                    element.second.m_parent = this;
-                }
-                break;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-                break;
-        }
-#endif
-    }
-
-    iterator set_parents(iterator it, typename iterator::difference_type count_set_parents)
-    {
-#if JSON_DIAGNOSTICS
-        for (typename iterator::difference_type i = 0; i < count_set_parents; ++i)
-        {
-            (it + i)->m_parent = this;
-        }
-#else
-        static_cast<void>(count_set_parents);
-#endif
-        return it;
-    }
-
-    reference set_parent(reference j, std::size_t old_capacity = static_cast<std::size_t>(-1))
-    {
-#if JSON_DIAGNOSTICS
-        if (old_capacity != static_cast<std::size_t>(-1))
-        {
-            // see https://github.com/nlohmann/json/issues/2838
-            JSON_ASSERT(type() == value_t::array);
-            if (JSON_HEDLEY_UNLIKELY(m_value.array->capacity() != old_capacity))
-            {
-                // capacity has changed: update all parents
-                set_parents();
-                return j;
-            }
-        }
-
-        // ordered_json uses a vector internally, so pointers could have
-        // been invalidated; see https://github.com/nlohmann/json/issues/2962
-#ifdef JSON_HEDLEY_MSVC_VERSION
-#pragma warning(push )
-#pragma warning(disable : 4127) // ignore warning to replace if with if constexpr
-#endif
-        if (detail::is_ordered_map<object_t>::value)
-        {
-            set_parents();
-            return j;
-        }
-#ifdef JSON_HEDLEY_MSVC_VERSION
-#pragma warning( pop )
-#endif
-
-        j.m_parent = this;
-#else
-        static_cast<void>(j);
-        static_cast<void>(old_capacity);
-#endif
-        return j;
-    }
-
-  public:
-    //////////////////////////
-    // JSON parser callback //
-    //////////////////////////
-
-    /// @brief parser event types
-    /// @sa https://json.nlohmann.me/api/basic_json/parse_event_t/
-    using parse_event_t = detail::parse_event_t;
-
-    /// @brief per-element parser callback type
-    /// @sa https://json.nlohmann.me/api/basic_json/parser_callback_t/
-    using parser_callback_t = detail::parser_callback_t<basic_json>;
-
-    //////////////////
-    // constructors //
-    //////////////////
-
-    /// @name constructors and destructors
-    /// Constructors of class @ref basic_json, copy/move constructor, copy
-    /// assignment, static functions creating objects, and the destructor.
-    /// @{
-
-    /// @brief create an empty value with a given type
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    basic_json(const value_t v)
-        : m_type(v), m_value(v)
-    {
-        assert_invariant();
-    }
-
-    /// @brief create a null object
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    basic_json(std::nullptr_t = nullptr) noexcept
-        : basic_json(value_t::null)
-    {
-        assert_invariant();
-    }
-
-    /// @brief create a JSON value from compatible types
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    template < typename CompatibleType,
-               typename U = detail::uncvref_t<CompatibleType>,
-               detail::enable_if_t <
-                   !detail::is_basic_json<U>::value && detail::is_compatible_type<basic_json_t, U>::value, int > = 0 >
-    basic_json(CompatibleType && val) noexcept(noexcept( // NOLINT(bugprone-forwarding-reference-overload,bugprone-exception-escape)
-                JSONSerializer<U>::to_json(std::declval<basic_json_t&>(),
-                                           std::forward<CompatibleType>(val))))
-    {
-        JSONSerializer<U>::to_json(*this, std::forward<CompatibleType>(val));
-        set_parents();
-        assert_invariant();
-    }
-
-    /// @brief create a JSON value from an existing one
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    template < typename BasicJsonType,
-               detail::enable_if_t <
-                   detail::is_basic_json<BasicJsonType>::value&& !std::is_same<basic_json, BasicJsonType>::value, int > = 0 >
-    basic_json(const BasicJsonType& val)
-    {
-        using other_boolean_t = typename BasicJsonType::boolean_t;
-        using other_number_float_t = typename BasicJsonType::number_float_t;
-        using other_number_integer_t = typename BasicJsonType::number_integer_t;
-        using other_number_unsigned_t = typename BasicJsonType::number_unsigned_t;
-        using other_string_t = typename BasicJsonType::string_t;
-        using other_object_t = typename BasicJsonType::object_t;
-        using other_array_t = typename BasicJsonType::array_t;
-        using other_binary_t = typename BasicJsonType::binary_t;
-
-        switch (val.type())
-        {
-            case value_t::boolean:
-                JSONSerializer<other_boolean_t>::to_json(*this, val.template get<other_boolean_t>());
-                break;
-            case value_t::number_float:
-                JSONSerializer<other_number_float_t>::to_json(*this, val.template get<other_number_float_t>());
-                break;
-            case value_t::number_integer:
-                JSONSerializer<other_number_integer_t>::to_json(*this, val.template get<other_number_integer_t>());
-                break;
-            case value_t::number_unsigned:
-                JSONSerializer<other_number_unsigned_t>::to_json(*this, val.template get<other_number_unsigned_t>());
-                break;
-            case value_t::string:
-                JSONSerializer<other_string_t>::to_json(*this, val.template get_ref<const other_string_t&>());
-                break;
-            case value_t::object:
-                JSONSerializer<other_object_t>::to_json(*this, val.template get_ref<const other_object_t&>());
-                break;
-            case value_t::array:
-                JSONSerializer<other_array_t>::to_json(*this, val.template get_ref<const other_array_t&>());
-                break;
-            case value_t::binary:
-                JSONSerializer<other_binary_t>::to_json(*this, val.template get_ref<const other_binary_t&>());
-                break;
-            case value_t::null:
-                *this = nullptr;
-                break;
-            case value_t::discarded:
-                m_type = value_t::discarded;
-                break;
-            default:            // LCOV_EXCL_LINE
-                JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-        }
-        set_parents();
-        assert_invariant();
-    }
-
-    /// @brief create a container (array or object) from an initializer list
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    basic_json(initializer_list_t init,
-               bool type_deduction = true,
-               value_t manual_type = value_t::array)
-    {
-        // check if each element is an array with two elements whose first
-        // element is a string
-        bool is_an_object = std::all_of(init.begin(), init.end(),
-                                        [](const detail::json_ref<basic_json>& element_ref)
-        {
-            return element_ref->is_array() && element_ref->size() == 2 && (*element_ref)[0].is_string();
-        });
-
-        // adjust type if type deduction is not wanted
-        if (!type_deduction)
-        {
-            // if array is wanted, do not create an object though possible
-            if (manual_type == value_t::array)
-            {
-                is_an_object = false;
-            }
-
-            // if object is wanted but impossible, throw an exception
-            if (JSON_HEDLEY_UNLIKELY(manual_type == value_t::object && !is_an_object))
-            {
-                JSON_THROW(type_error::create(301, "cannot create object from initializer list", basic_json()));
-            }
-        }
-
-        if (is_an_object)
-        {
-            // the initializer list is a list of pairs -> create object
-            m_type = value_t::object;
-            m_value = value_t::object;
-
-            for (auto& element_ref : init)
-            {
-                auto element = element_ref.moved_or_copied();
-                m_value.object->emplace(
-                    std::move(*((*element.m_value.array)[0].m_value.string)),
-                    std::move((*element.m_value.array)[1]));
-            }
-        }
-        else
-        {
-            // the initializer list describes an array -> create array
-            m_type = value_t::array;
-            m_value.array = create<array_t>(init.begin(), init.end());
-        }
-
-        set_parents();
-        assert_invariant();
-    }
-
-    /// @brief explicitly create a binary array (without subtype)
-    /// @sa https://json.nlohmann.me/api/basic_json/binary/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json binary(const typename binary_t::container_type& init)
-    {
-        auto res = basic_json();
-        res.m_type = value_t::binary;
-        res.m_value = init;
-        return res;
-    }
-
-    /// @brief explicitly create a binary array (with subtype)
-    /// @sa https://json.nlohmann.me/api/basic_json/binary/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json binary(const typename binary_t::container_type& init, typename binary_t::subtype_type subtype)
-    {
-        auto res = basic_json();
-        res.m_type = value_t::binary;
-        res.m_value = binary_t(init, subtype);
-        return res;
-    }
-
-    /// @brief explicitly create a binary array
-    /// @sa https://json.nlohmann.me/api/basic_json/binary/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json binary(typename binary_t::container_type&& init)
-    {
-        auto res = basic_json();
-        res.m_type = value_t::binary;
-        res.m_value = std::move(init);
-        return res;
-    }
-
-    /// @brief explicitly create a binary array (with subtype)
-    /// @sa https://json.nlohmann.me/api/basic_json/binary/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json binary(typename binary_t::container_type&& init, typename binary_t::subtype_type subtype)
-    {
-        auto res = basic_json();
-        res.m_type = value_t::binary;
-        res.m_value = binary_t(std::move(init), subtype);
-        return res;
-    }
-
-    /// @brief explicitly create an array from an initializer list
-    /// @sa https://json.nlohmann.me/api/basic_json/array/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json array(initializer_list_t init = {})
-    {
-        return basic_json(init, false, value_t::array);
-    }
-
-    /// @brief explicitly create an object from an initializer list
-    /// @sa https://json.nlohmann.me/api/basic_json/object/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json object(initializer_list_t init = {})
-    {
-        return basic_json(init, false, value_t::object);
-    }
-
-    /// @brief construct an array with count copies of given value
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    basic_json(size_type cnt, const basic_json& val)
-        : m_type(value_t::array)
-    {
-        m_value.array = create<array_t>(cnt, val);
-        set_parents();
-        assert_invariant();
-    }
-
-    /// @brief construct a JSON container given an iterator range
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    template < class InputIT, typename std::enable_if <
-                   std::is_same<InputIT, typename basic_json_t::iterator>::value ||
-                   std::is_same<InputIT, typename basic_json_t::const_iterator>::value, int >::type = 0 >
-    basic_json(InputIT first, InputIT last)
-    {
-        JSON_ASSERT(first.m_object != nullptr);
-        JSON_ASSERT(last.m_object != nullptr);
-
-        // make sure iterator fits the current value
-        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(201, "iterators are not compatible", basic_json()));
-        }
-
-        // copy type from first iterator
-        m_type = first.m_object->m_type;
-
-        // check if iterator range is complete for primitive values
-        switch (m_type)
-        {
-            case value_t::boolean:
-            case value_t::number_float:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::string:
-            {
-                if (JSON_HEDLEY_UNLIKELY(!first.m_it.primitive_iterator.is_begin()
-                                         || !last.m_it.primitive_iterator.is_end()))
-                {
-                    JSON_THROW(invalid_iterator::create(204, "iterators out of range", *first.m_object));
-                }
-                break;
-            }
-
-            case value_t::null:
-            case value_t::object:
-            case value_t::array:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-                break;
-        }
-
-        switch (m_type)
-        {
-            case value_t::number_integer:
-            {
-                m_value.number_integer = first.m_object->m_value.number_integer;
-                break;
-            }
-
-            case value_t::number_unsigned:
-            {
-                m_value.number_unsigned = first.m_object->m_value.number_unsigned;
-                break;
-            }
-
-            case value_t::number_float:
-            {
-                m_value.number_float = first.m_object->m_value.number_float;
-                break;
-            }
-
-            case value_t::boolean:
-            {
-                m_value.boolean = first.m_object->m_value.boolean;
-                break;
-            }
-
-            case value_t::string:
-            {
-                m_value = *first.m_object->m_value.string;
-                break;
-            }
-
-            case value_t::object:
-            {
-                m_value.object = create<object_t>(first.m_it.object_iterator,
-                                                  last.m_it.object_iterator);
-                break;
-            }
-
-            case value_t::array:
-            {
-                m_value.array = create<array_t>(first.m_it.array_iterator,
-                                                last.m_it.array_iterator);
-                break;
-            }
-
-            case value_t::binary:
-            {
-                m_value = *first.m_object->m_value.binary;
-                break;
-            }
-
-            case value_t::null:
-            case value_t::discarded:
-            default:
-                JSON_THROW(invalid_iterator::create(206, "cannot construct with iterators from " + std::string(first.m_object->type_name()), *first.m_object));
-        }
-
-        set_parents();
-        assert_invariant();
-    }
-
-
-    ///////////////////////////////////////
-    // other constructors and destructor //
-    ///////////////////////////////////////
-
-    template<typename JsonRef,
-             detail::enable_if_t<detail::conjunction<detail::is_json_ref<JsonRef>,
-                                 std::is_same<typename JsonRef::value_type, basic_json>>::value, int> = 0 >
-    basic_json(const JsonRef& ref) : basic_json(ref.moved_or_copied()) {}
-
-    /// @brief copy constructor
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    basic_json(const basic_json& other)
-        : m_type(other.m_type)
-    {
-        // check of passed value is valid
-        other.assert_invariant();
-
-        switch (m_type)
-        {
-            case value_t::object:
-            {
-                m_value = *other.m_value.object;
-                break;
-            }
-
-            case value_t::array:
-            {
-                m_value = *other.m_value.array;
-                break;
-            }
-
-            case value_t::string:
-            {
-                m_value = *other.m_value.string;
-                break;
-            }
-
-            case value_t::boolean:
-            {
-                m_value = other.m_value.boolean;
-                break;
-            }
-
-            case value_t::number_integer:
-            {
-                m_value = other.m_value.number_integer;
-                break;
-            }
-
-            case value_t::number_unsigned:
-            {
-                m_value = other.m_value.number_unsigned;
-                break;
-            }
-
-            case value_t::number_float:
-            {
-                m_value = other.m_value.number_float;
-                break;
-            }
-
-            case value_t::binary:
-            {
-                m_value = *other.m_value.binary;
-                break;
-            }
-
-            case value_t::null:
-            case value_t::discarded:
-            default:
-                break;
-        }
-
-        set_parents();
-        assert_invariant();
-    }
-
-    /// @brief move constructor
-    /// @sa https://json.nlohmann.me/api/basic_json/basic_json/
-    basic_json(basic_json&& other) noexcept
-        : m_type(std::move(other.m_type)),
-          m_value(std::move(other.m_value))
-    {
-        // check that passed value is valid
-        other.assert_invariant(false);
-
-        // invalidate payload
-        other.m_type = value_t::null;
-        other.m_value = {};
-
-        set_parents();
-        assert_invariant();
-    }
-
-    /// @brief copy assignment
-    /// @sa https://json.nlohmann.me/api/basic_json/operator=/
-    basic_json& operator=(basic_json other) noexcept (
-        std::is_nothrow_move_constructible<value_t>::value&&
-        std::is_nothrow_move_assignable<value_t>::value&&
-        std::is_nothrow_move_constructible<json_value>::value&&
-        std::is_nothrow_move_assignable<json_value>::value
-    )
-    {
-        // check that passed value is valid
-        other.assert_invariant();
-
-        using std::swap;
-        swap(m_type, other.m_type);
-        swap(m_value, other.m_value);
-
-        set_parents();
-        assert_invariant();
-        return *this;
-    }
-
-    /// @brief destructor
-    /// @sa https://json.nlohmann.me/api/basic_json/~basic_json/
-    ~basic_json() noexcept
-    {
-        assert_invariant(false);
-        m_value.destroy(m_type);
-    }
-
-    /// @}
-
-  public:
-    ///////////////////////
-    // object inspection //
-    ///////////////////////
-
-    /// @name object inspection
-    /// Functions to inspect the type of a JSON value.
-    /// @{
-
-    /// @brief serialization
-    /// @sa https://json.nlohmann.me/api/basic_json/dump/
-    string_t dump(const int indent = -1,
-                  const char indent_char = ' ',
-                  const bool ensure_ascii = false,
-                  const error_handler_t error_handler = error_handler_t::strict) const
-    {
-        string_t result;
-        serializer s(detail::output_adapter<char, string_t>(result), indent_char, error_handler);
-
-        if (indent >= 0)
-        {
-            s.dump(*this, true, ensure_ascii, static_cast<unsigned int>(indent));
-        }
-        else
-        {
-            s.dump(*this, false, ensure_ascii, 0);
-        }
-
-        return result;
-    }
-
-    /// @brief return the type of the JSON value (explicit)
-    /// @sa https://json.nlohmann.me/api/basic_json/type/
-    constexpr value_t type() const noexcept
-    {
-        return m_type;
-    }
-
-    /// @brief return whether type is primitive
-    /// @sa https://json.nlohmann.me/api/basic_json/is_primitive/
-    constexpr bool is_primitive() const noexcept
-    {
-        return is_null() || is_string() || is_boolean() || is_number() || is_binary();
-    }
-
-    /// @brief return whether type is structured
-    /// @sa https://json.nlohmann.me/api/basic_json/is_structured/
-    constexpr bool is_structured() const noexcept
-    {
-        return is_array() || is_object();
-    }
-
-    /// @brief return whether value is null
-    /// @sa https://json.nlohmann.me/api/basic_json/is_null/
-    constexpr bool is_null() const noexcept
-    {
-        return m_type == value_t::null;
-    }
-
-    /// @brief return whether value is a boolean
-    /// @sa https://json.nlohmann.me/api/basic_json/is_boolean/
-    constexpr bool is_boolean() const noexcept
-    {
-        return m_type == value_t::boolean;
-    }
-
-    /// @brief return whether value is a number
-    /// @sa https://json.nlohmann.me/api/basic_json/is_number/
-    constexpr bool is_number() const noexcept
-    {
-        return is_number_integer() || is_number_float();
-    }
-
-    /// @brief return whether value is an integer number
-    /// @sa https://json.nlohmann.me/api/basic_json/is_number_integer/
-    constexpr bool is_number_integer() const noexcept
-    {
-        return m_type == value_t::number_integer || m_type == value_t::number_unsigned;
-    }
-
-    /// @brief return whether value is an unsigned integer number
-    /// @sa https://json.nlohmann.me/api/basic_json/is_number_unsigned/
-    constexpr bool is_number_unsigned() const noexcept
-    {
-        return m_type == value_t::number_unsigned;
-    }
-
-    /// @brief return whether value is a floating-point number
-    /// @sa https://json.nlohmann.me/api/basic_json/is_number_float/
-    constexpr bool is_number_float() const noexcept
-    {
-        return m_type == value_t::number_float;
-    }
-
-    /// @brief return whether value is an object
-    /// @sa https://json.nlohmann.me/api/basic_json/is_object/
-    constexpr bool is_object() const noexcept
-    {
-        return m_type == value_t::object;
-    }
-
-    /// @brief return whether value is an array
-    /// @sa https://json.nlohmann.me/api/basic_json/is_array/
-    constexpr bool is_array() const noexcept
-    {
-        return m_type == value_t::array;
-    }
-
-    /// @brief return whether value is a string
-    /// @sa https://json.nlohmann.me/api/basic_json/is_string/
-    constexpr bool is_string() const noexcept
-    {
-        return m_type == value_t::string;
-    }
-
-    /// @brief return whether value is a binary array
-    /// @sa https://json.nlohmann.me/api/basic_json/is_binary/
-    constexpr bool is_binary() const noexcept
-    {
-        return m_type == value_t::binary;
-    }
-
-    /// @brief return whether value is discarded
-    /// @sa https://json.nlohmann.me/api/basic_json/is_discarded/
-    constexpr bool is_discarded() const noexcept
-    {
-        return m_type == value_t::discarded;
-    }
-
-    /// @brief return the type of the JSON value (implicit)
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_value_t/
-    constexpr operator value_t() const noexcept
-    {
-        return m_type;
-    }
-
-    /// @}
-
-  private:
-    //////////////////
-    // value access //
-    //////////////////
-
-    /// get a boolean (explicit)
-    boolean_t get_impl(boolean_t* /*unused*/) const
-    {
-        if (JSON_HEDLEY_LIKELY(is_boolean()))
-        {
-            return m_value.boolean;
-        }
-
-        JSON_THROW(type_error::create(302, "type must be boolean, but is " + std::string(type_name()), *this));
-    }
-
-    /// get a pointer to the value (object)
-    object_t* get_impl_ptr(object_t* /*unused*/) noexcept
-    {
-        return is_object() ? m_value.object : nullptr;
-    }
-
-    /// get a pointer to the value (object)
-    constexpr const object_t* get_impl_ptr(const object_t* /*unused*/) const noexcept
-    {
-        return is_object() ? m_value.object : nullptr;
-    }
-
-    /// get a pointer to the value (array)
-    array_t* get_impl_ptr(array_t* /*unused*/) noexcept
-    {
-        return is_array() ? m_value.array : nullptr;
-    }
-
-    /// get a pointer to the value (array)
-    constexpr const array_t* get_impl_ptr(const array_t* /*unused*/) const noexcept
-    {
-        return is_array() ? m_value.array : nullptr;
-    }
-
-    /// get a pointer to the value (string)
-    string_t* get_impl_ptr(string_t* /*unused*/) noexcept
-    {
-        return is_string() ? m_value.string : nullptr;
-    }
-
-    /// get a pointer to the value (string)
-    constexpr const string_t* get_impl_ptr(const string_t* /*unused*/) const noexcept
-    {
-        return is_string() ? m_value.string : nullptr;
-    }
-
-    /// get a pointer to the value (boolean)
-    boolean_t* get_impl_ptr(boolean_t* /*unused*/) noexcept
-    {
-        return is_boolean() ? &m_value.boolean : nullptr;
-    }
-
-    /// get a pointer to the value (boolean)
-    constexpr const boolean_t* get_impl_ptr(const boolean_t* /*unused*/) const noexcept
-    {
-        return is_boolean() ? &m_value.boolean : nullptr;
-    }
-
-    /// get a pointer to the value (integer number)
-    number_integer_t* get_impl_ptr(number_integer_t* /*unused*/) noexcept
-    {
-        return is_number_integer() ? &m_value.number_integer : nullptr;
-    }
-
-    /// get a pointer to the value (integer number)
-    constexpr const number_integer_t* get_impl_ptr(const number_integer_t* /*unused*/) const noexcept
-    {
-        return is_number_integer() ? &m_value.number_integer : nullptr;
-    }
-
-    /// get a pointer to the value (unsigned number)
-    number_unsigned_t* get_impl_ptr(number_unsigned_t* /*unused*/) noexcept
-    {
-        return is_number_unsigned() ? &m_value.number_unsigned : nullptr;
-    }
-
-    /// get a pointer to the value (unsigned number)
-    constexpr const number_unsigned_t* get_impl_ptr(const number_unsigned_t* /*unused*/) const noexcept
-    {
-        return is_number_unsigned() ? &m_value.number_unsigned : nullptr;
-    }
-
-    /// get a pointer to the value (floating-point number)
-    number_float_t* get_impl_ptr(number_float_t* /*unused*/) noexcept
-    {
-        return is_number_float() ? &m_value.number_float : nullptr;
-    }
-
-    /// get a pointer to the value (floating-point number)
-    constexpr const number_float_t* get_impl_ptr(const number_float_t* /*unused*/) const noexcept
-    {
-        return is_number_float() ? &m_value.number_float : nullptr;
-    }
-
-    /// get a pointer to the value (binary)
-    binary_t* get_impl_ptr(binary_t* /*unused*/) noexcept
-    {
-        return is_binary() ? m_value.binary : nullptr;
-    }
-
-    /// get a pointer to the value (binary)
-    constexpr const binary_t* get_impl_ptr(const binary_t* /*unused*/) const noexcept
-    {
-        return is_binary() ? m_value.binary : nullptr;
-    }
-
-    /*!
-    @brief helper function to implement get_ref()
-
-    This function helps to implement get_ref() without code duplication for
-    const and non-const overloads
-
-    @tparam ThisType will be deduced as `basic_json` or `const basic_json`
-
-    @throw type_error.303 if ReferenceType does not match underlying value
-    type of the current JSON
-    */
-    template<typename ReferenceType, typename ThisType>
-    static ReferenceType get_ref_impl(ThisType& obj)
-    {
-        // delegate the call to get_ptr<>()
-        auto* ptr = obj.template get_ptr<typename std::add_pointer<ReferenceType>::type>();
-
-        if (JSON_HEDLEY_LIKELY(ptr != nullptr))
-        {
-            return *ptr;
-        }
-
-        JSON_THROW(type_error::create(303, "incompatible ReferenceType for get_ref, actual type is " + std::string(obj.type_name()), obj));
-    }
-
-  public:
-    /// @name value access
-    /// Direct access to the stored value of a JSON value.
-    /// @{
-
-    /// @brief get a pointer value (implicit)
-    /// @sa https://json.nlohmann.me/api/basic_json/get_ptr/
-    template<typename PointerType, typename std::enable_if<
-                 std::is_pointer<PointerType>::value, int>::type = 0>
-    auto get_ptr() noexcept -> decltype(std::declval<basic_json_t&>().get_impl_ptr(std::declval<PointerType>()))
-    {
-        // delegate the call to get_impl_ptr<>()
-        return get_impl_ptr(static_cast<PointerType>(nullptr));
-    }
-
-    /// @brief get a pointer value (implicit)
-    /// @sa https://json.nlohmann.me/api/basic_json/get_ptr/
-    template < typename PointerType, typename std::enable_if <
-                   std::is_pointer<PointerType>::value&&
-                   std::is_const<typename std::remove_pointer<PointerType>::type>::value, int >::type = 0 >
-    constexpr auto get_ptr() const noexcept -> decltype(std::declval<const basic_json_t&>().get_impl_ptr(std::declval<PointerType>()))
-    {
-        // delegate the call to get_impl_ptr<>() const
-        return get_impl_ptr(static_cast<PointerType>(nullptr));
-    }
-
-  private:
-    /*!
-    @brief get a value (explicit)
-
-    Explicit type conversion between the JSON value and a compatible value
-    which is [CopyConstructible](https://en.cppreference.com/w/cpp/named_req/CopyConstructible)
-    and [DefaultConstructible](https://en.cppreference.com/w/cpp/named_req/DefaultConstructible).
-    The value is converted by calling the @ref json_serializer<ValueType>
-    `from_json()` method.
-
-    The function is equivalent to executing
-    @code {.cpp}
-    ValueType ret;
-    JSONSerializer<ValueType>::from_json(*this, ret);
-    return ret;
-    @endcode
-
-    This overloads is chosen if:
-    - @a ValueType is not @ref basic_json,
-    - @ref json_serializer<ValueType> has a `from_json()` method of the form
-      `void from_json(const basic_json&, ValueType&)`, and
-    - @ref json_serializer<ValueType> does not have a `from_json()` method of
-      the form `ValueType from_json(const basic_json&)`
-
-    @tparam ValueType the returned value type
-
-    @return copy of the JSON value, converted to @a ValueType
-
-    @throw what @ref json_serializer<ValueType> `from_json()` method throws
-
-    @liveexample{The example below shows several conversions from JSON values
-    to other types. There a few things to note: (1) Floating-point numbers can
-    be converted to integers\, (2) A JSON array can be converted to a standard
-    `std::vector<short>`\, (3) A JSON object can be converted to C++
-    associative containers such as `std::unordered_map<std::string\,
-    json>`.,get__ValueType_const}
-
-    @since version 2.1.0
-    */
-    template < typename ValueType,
-               detail::enable_if_t <
-                   detail::is_default_constructible<ValueType>::value&&
-                   detail::has_from_json<basic_json_t, ValueType>::value,
-                   int > = 0 >
-    ValueType get_impl(detail::priority_tag<0> /*unused*/) const noexcept(noexcept(
-                JSONSerializer<ValueType>::from_json(std::declval<const basic_json_t&>(), std::declval<ValueType&>())))
-    {
-        auto ret = ValueType();
-        JSONSerializer<ValueType>::from_json(*this, ret);
-        return ret;
-    }
-
-    /*!
-    @brief get a value (explicit); special case
-
-    Explicit type conversion between the JSON value and a compatible value
-    which is **not** [CopyConstructible](https://en.cppreference.com/w/cpp/named_req/CopyConstructible)
-    and **not** [DefaultConstructible](https://en.cppreference.com/w/cpp/named_req/DefaultConstructible).
-    The value is converted by calling the @ref json_serializer<ValueType>
-    `from_json()` method.
-
-    The function is equivalent to executing
-    @code {.cpp}
-    return JSONSerializer<ValueType>::from_json(*this);
-    @endcode
-
-    This overloads is chosen if:
-    - @a ValueType is not @ref basic_json and
-    - @ref json_serializer<ValueType> has a `from_json()` method of the form
-      `ValueType from_json(const basic_json&)`
-
-    @note If @ref json_serializer<ValueType> has both overloads of
-    `from_json()`, this one is chosen.
-
-    @tparam ValueType the returned value type
-
-    @return copy of the JSON value, converted to @a ValueType
-
-    @throw what @ref json_serializer<ValueType> `from_json()` method throws
-
-    @since version 2.1.0
-    */
-    template < typename ValueType,
-               detail::enable_if_t <
-                   detail::has_non_default_from_json<basic_json_t, ValueType>::value,
-                   int > = 0 >
-    ValueType get_impl(detail::priority_tag<1> /*unused*/) const noexcept(noexcept(
-                JSONSerializer<ValueType>::from_json(std::declval<const basic_json_t&>())))
-    {
-        return JSONSerializer<ValueType>::from_json(*this);
-    }
-
-    /*!
-    @brief get special-case overload
-
-    This overloads converts the current @ref basic_json in a different
-    @ref basic_json type
-
-    @tparam BasicJsonType == @ref basic_json
-
-    @return a copy of *this, converted into @a BasicJsonType
-
-    @complexity Depending on the implementation of the called `from_json()`
-                method.
-
-    @since version 3.2.0
-    */
-    template < typename BasicJsonType,
-               detail::enable_if_t <
-                   detail::is_basic_json<BasicJsonType>::value,
-                   int > = 0 >
-    BasicJsonType get_impl(detail::priority_tag<2> /*unused*/) const
-    {
-        return *this;
-    }
-
-    /*!
-    @brief get special-case overload
-
-    This overloads avoids a lot of template boilerplate, it can be seen as the
-    identity method
-
-    @tparam BasicJsonType == @ref basic_json
-
-    @return a copy of *this
-
-    @complexity Constant.
-
-    @since version 2.1.0
-    */
-    template<typename BasicJsonType,
-             detail::enable_if_t<
-                 std::is_same<BasicJsonType, basic_json_t>::value,
-                 int> = 0>
-    basic_json get_impl(detail::priority_tag<3> /*unused*/) const
-    {
-        return *this;
-    }
-
-    /*!
-    @brief get a pointer value (explicit)
-    @copydoc get()
-    */
-    template<typename PointerType,
-             detail::enable_if_t<
-                 std::is_pointer<PointerType>::value,
-                 int> = 0>
-    constexpr auto get_impl(detail::priority_tag<4> /*unused*/) const noexcept
-    -> decltype(std::declval<const basic_json_t&>().template get_ptr<PointerType>())
-    {
-        // delegate the call to get_ptr
-        return get_ptr<PointerType>();
-    }
-
-  public:
-    /*!
-    @brief get a (pointer) value (explicit)
-
-    Performs explicit type conversion between the JSON value and a compatible value if required.
-
-    - If the requested type is a pointer to the internally stored JSON value that pointer is returned.
-    No copies are made.
-
-    - If the requested type is the current @ref basic_json, or a different @ref basic_json convertible
-    from the current @ref basic_json.
-
-    - Otherwise the value is converted by calling the @ref json_serializer<ValueType> `from_json()`
-    method.
-
-    @tparam ValueTypeCV the provided value type
-    @tparam ValueType the returned value type
-
-    @return copy of the JSON value, converted to @tparam ValueType if necessary
-
-    @throw what @ref json_serializer<ValueType> `from_json()` method throws if conversion is required
-
-    @since version 2.1.0
-    */
-    template < typename ValueTypeCV, typename ValueType = detail::uncvref_t<ValueTypeCV>>
-#if defined(JSON_HAS_CPP_14)
-    constexpr
-#endif
-    auto get() const noexcept(
-    noexcept(std::declval<const basic_json_t&>().template get_impl<ValueType>(detail::priority_tag<4> {})))
-    -> decltype(std::declval<const basic_json_t&>().template get_impl<ValueType>(detail::priority_tag<4> {}))
-    {
-        // we cannot static_assert on ValueTypeCV being non-const, because
-        // there is support for get<const basic_json_t>(), which is why we
-        // still need the uncvref
-        static_assert(!std::is_reference<ValueTypeCV>::value,
-                      "get() cannot be used with reference types, you might want to use get_ref()");
-        return get_impl<ValueType>(detail::priority_tag<4> {});
-    }
-
-    /*!
-    @brief get a pointer value (explicit)
-
-    Explicit pointer access to the internally stored JSON value. No copies are
-    made.
-
-    @warning The pointer becomes invalid if the underlying JSON object
-    changes.
-
-    @tparam PointerType pointer type; must be a pointer to @ref array_t, @ref
-    object_t, @ref string_t, @ref boolean_t, @ref number_integer_t,
-    @ref number_unsigned_t, or @ref number_float_t.
-
-    @return pointer to the internally stored JSON value if the requested
-    pointer type @a PointerType fits to the JSON value; `nullptr` otherwise
-
-    @complexity Constant.
-
-    @liveexample{The example below shows how pointers to internal values of a
-    JSON value can be requested. Note that no type conversions are made and a
-    `nullptr` is returned if the value and the requested pointer type does not
-    match.,get__PointerType}
-
-    @sa see @ref get_ptr() for explicit pointer-member access
-
-    @since version 1.0.0
-    */
-    template<typename PointerType, typename std::enable_if<
-                 std::is_pointer<PointerType>::value, int>::type = 0>
-    auto get() noexcept -> decltype(std::declval<basic_json_t&>().template get_ptr<PointerType>())
-    {
-        // delegate the call to get_ptr
-        return get_ptr<PointerType>();
-    }
-
-    /// @brief get a value (explicit)
-    /// @sa https://json.nlohmann.me/api/basic_json/get_to/
-    template < typename ValueType,
-               detail::enable_if_t <
-                   !detail::is_basic_json<ValueType>::value&&
-                   detail::has_from_json<basic_json_t, ValueType>::value,
-                   int > = 0 >
-    ValueType & get_to(ValueType& v) const noexcept(noexcept(
-                JSONSerializer<ValueType>::from_json(std::declval<const basic_json_t&>(), v)))
-    {
-        JSONSerializer<ValueType>::from_json(*this, v);
-        return v;
-    }
-
-    // specialization to allow calling get_to with a basic_json value
-    // see https://github.com/nlohmann/json/issues/2175
-    template<typename ValueType,
-             detail::enable_if_t <
-                 detail::is_basic_json<ValueType>::value,
-                 int> = 0>
-    ValueType & get_to(ValueType& v) const
-    {
-        v = *this;
-        return v;
-    }
-
-    template <
-        typename T, std::size_t N,
-        typename Array = T (&)[N], // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
-        detail::enable_if_t <
-            detail::has_from_json<basic_json_t, Array>::value, int > = 0 >
-    Array get_to(T (&v)[N]) const // NOLINT(cppcoreguidelines-avoid-c-arrays,hicpp-avoid-c-arrays,modernize-avoid-c-arrays)
-    noexcept(noexcept(JSONSerializer<Array>::from_json(
-                          std::declval<const basic_json_t&>(), v)))
-    {
-        JSONSerializer<Array>::from_json(*this, v);
-        return v;
-    }
-
-    /// @brief get a reference value (implicit)
-    /// @sa https://json.nlohmann.me/api/basic_json/get_ref/
-    template<typename ReferenceType, typename std::enable_if<
-                 std::is_reference<ReferenceType>::value, int>::type = 0>
-    ReferenceType get_ref()
-    {
-        // delegate call to get_ref_impl
-        return get_ref_impl<ReferenceType>(*this);
-    }
-
-    /// @brief get a reference value (implicit)
-    /// @sa https://json.nlohmann.me/api/basic_json/get_ref/
-    template < typename ReferenceType, typename std::enable_if <
-                   std::is_reference<ReferenceType>::value&&
-                   std::is_const<typename std::remove_reference<ReferenceType>::type>::value, int >::type = 0 >
-    ReferenceType get_ref() const
-    {
-        // delegate call to get_ref_impl
-        return get_ref_impl<ReferenceType>(*this);
-    }
-
-    /*!
-    @brief get a value (implicit)
-
-    Implicit type conversion between the JSON value and a compatible value.
-    The call is realized by calling @ref get() const.
-
-    @tparam ValueType non-pointer type compatible to the JSON value, for
-    instance `int` for JSON integer numbers, `bool` for JSON booleans, or
-    `std::vector` types for JSON arrays. The character type of @ref string_t
-    as well as an initializer list of this type is excluded to avoid
-    ambiguities as these types implicitly convert to `std::string`.
-
-    @return copy of the JSON value, converted to type @a ValueType
-
-    @throw type_error.302 in case passed type @a ValueType is incompatible
-    to the JSON value type (e.g., the JSON value is of type boolean, but a
-    string is requested); see example below
-
-    @complexity Linear in the size of the JSON value.
-
-    @liveexample{The example below shows several conversions from JSON values
-    to other types. There a few things to note: (1) Floating-point numbers can
-    be converted to integers\, (2) A JSON array can be converted to a standard
-    `std::vector<short>`\, (3) A JSON object can be converted to C++
-    associative containers such as `std::unordered_map<std::string\,
-    json>`.,operator__ValueType}
-
-    @since version 1.0.0
-    */
-    template < typename ValueType, typename std::enable_if <
-                   detail::conjunction <
-                       detail::negation<std::is_pointer<ValueType>>,
-                       detail::negation<std::is_same<ValueType, detail::json_ref<basic_json>>>,
-                                        detail::negation<std::is_same<ValueType, typename string_t::value_type>>,
-                                        detail::negation<detail::is_basic_json<ValueType>>,
-                                        detail::negation<std::is_same<ValueType, std::initializer_list<typename string_t::value_type>>>,
-
-#if defined(JSON_HAS_CPP_17) && (defined(__GNUC__) || (defined(_MSC_VER) && _MSC_VER >= 1910 && _MSC_VER <= 1914))
-                                                detail::negation<std::is_same<ValueType, std::string_view>>,
-#endif
-                                                detail::is_detected_lazy<detail::get_template_function, const basic_json_t&, ValueType>
-                                                >::value, int >::type = 0 >
-                                        JSON_EXPLICIT operator ValueType() const
-    {
-        // delegate the call to get<>() const
-        return get<ValueType>();
-    }
-
-    /// @brief get a binary value
-    /// @sa https://json.nlohmann.me/api/basic_json/get_binary/
-    binary_t& get_binary()
-    {
-        if (!is_binary())
-        {
-            JSON_THROW(type_error::create(302, "type must be binary, but is " + std::string(type_name()), *this));
-        }
-
-        return *get_ptr<binary_t*>();
-    }
-
-    /// @brief get a binary value
-    /// @sa https://json.nlohmann.me/api/basic_json/get_binary/
-    const binary_t& get_binary() const
-    {
-        if (!is_binary())
-        {
-            JSON_THROW(type_error::create(302, "type must be binary, but is " + std::string(type_name()), *this));
-        }
-
-        return *get_ptr<const binary_t*>();
-    }
-
-    /// @}
-
-
-    ////////////////////
-    // element access //
-    ////////////////////
-
-    /// @name element access
-    /// Access to the JSON value.
-    /// @{
-
-    /// @brief access specified array element with bounds checking
-    /// @sa https://json.nlohmann.me/api/basic_json/at/
-    reference at(size_type idx)
-    {
-        // at only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            JSON_TRY
-            {
-                return set_parent(m_value.array->at(idx));
-            }
-            JSON_CATCH (std::out_of_range&)
-            {
-                // create better exception explanation
-                JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", *this));
-            }
-        }
-        else
-        {
-            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief access specified array element with bounds checking
-    /// @sa https://json.nlohmann.me/api/basic_json/at/
-    const_reference at(size_type idx) const
-    {
-        // at only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            JSON_TRY
-            {
-                return m_value.array->at(idx);
-            }
-            JSON_CATCH (std::out_of_range&)
-            {
-                // create better exception explanation
-                JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", *this));
-            }
-        }
-        else
-        {
-            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief access specified object element with bounds checking
-    /// @sa https://json.nlohmann.me/api/basic_json/at/
-    reference at(const typename object_t::key_type& key)
-    {
-        // at only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            JSON_TRY
-            {
-                return set_parent(m_value.object->at(key));
-            }
-            JSON_CATCH (std::out_of_range&)
-            {
-                // create better exception explanation
-                JSON_THROW(out_of_range::create(403, "key '" + key + "' not found", *this));
-            }
-        }
-        else
-        {
-            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief access specified object element with bounds checking
-    /// @sa https://json.nlohmann.me/api/basic_json/at/
-    const_reference at(const typename object_t::key_type& key) const
-    {
-        // at only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            JSON_TRY
-            {
-                return m_value.object->at(key);
-            }
-            JSON_CATCH (std::out_of_range&)
-            {
-                // create better exception explanation
-                JSON_THROW(out_of_range::create(403, "key '" + key + "' not found", *this));
-            }
-        }
-        else
-        {
-            JSON_THROW(type_error::create(304, "cannot use at() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief access specified array element
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    reference operator[](size_type idx)
-    {
-        // implicitly convert null value to an empty array
-        if (is_null())
-        {
-            m_type = value_t::array;
-            m_value.array = create<array_t>();
-            assert_invariant();
-        }
-
-        // operator[] only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            // fill up array with null values if given idx is outside range
-            if (idx >= m_value.array->size())
-            {
-#if JSON_DIAGNOSTICS
-                // remember array size & capacity before resizing
-                const auto old_size = m_value.array->size();
-                const auto old_capacity = m_value.array->capacity();
-#endif
-                m_value.array->resize(idx + 1);
-
-#if JSON_DIAGNOSTICS
-                if (JSON_HEDLEY_UNLIKELY(m_value.array->capacity() != old_capacity))
-                {
-                    // capacity has changed: update all parents
-                    set_parents();
-                }
-                else
-                {
-                    // set parent for values added above
-                    set_parents(begin() + static_cast<typename iterator::difference_type>(old_size), static_cast<typename iterator::difference_type>(idx + 1 - old_size));
-                }
-#endif
-                assert_invariant();
-            }
-
-            return m_value.array->operator[](idx);
-        }
-
-        JSON_THROW(type_error::create(305, "cannot use operator[] with a numeric argument with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified array element
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    const_reference operator[](size_type idx) const
-    {
-        // const operator[] only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            return m_value.array->operator[](idx);
-        }
-
-        JSON_THROW(type_error::create(305, "cannot use operator[] with a numeric argument with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified object element
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    reference operator[](const typename object_t::key_type& key)
-    {
-        // implicitly convert null value to an empty object
-        if (is_null())
-        {
-            m_type = value_t::object;
-            m_value.object = create<object_t>();
-            assert_invariant();
-        }
-
-        // operator[] only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            return set_parent(m_value.object->operator[](key));
-        }
-
-        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified object element
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    const_reference operator[](const typename object_t::key_type& key) const
-    {
-        // const operator[] only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            JSON_ASSERT(m_value.object->find(key) != m_value.object->end());
-            return m_value.object->find(key)->second;
-        }
-
-        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified object element
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    template<typename T>
-    JSON_HEDLEY_NON_NULL(2)
-    reference operator[](T* key)
-    {
-        // implicitly convert null to object
-        if (is_null())
-        {
-            m_type = value_t::object;
-            m_value = value_t::object;
-            assert_invariant();
-        }
-
-        // at only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            return set_parent(m_value.object->operator[](key));
-        }
-
-        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified object element
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    template<typename T>
-    JSON_HEDLEY_NON_NULL(2)
-    const_reference operator[](T* key) const
-    {
-        // at only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            JSON_ASSERT(m_value.object->find(key) != m_value.object->end());
-            return m_value.object->find(key)->second;
-        }
-
-        JSON_THROW(type_error::create(305, "cannot use operator[] with a string argument with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified object element with default value
-    /// @sa https://json.nlohmann.me/api/basic_json/value/
-    /// using std::is_convertible in a std::enable_if will fail when using explicit conversions
-    template < class ValueType, typename std::enable_if <
-                   detail::is_getable<basic_json_t, ValueType>::value
-                   && !std::is_same<value_t, ValueType>::value, int >::type = 0 >
-    ValueType value(const typename object_t::key_type& key, const ValueType& default_value) const
-    {
-        // at only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            // if key is found, return value and given default value otherwise
-            const auto it = find(key);
-            if (it != end())
-            {
-                return it->template get<ValueType>();
-            }
-
-            return default_value;
-        }
-
-        JSON_THROW(type_error::create(306, "cannot use value() with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified object element with default value
-    /// @sa https://json.nlohmann.me/api/basic_json/value/
-    /// overload for a default value of type const char*
-    string_t value(const typename object_t::key_type& key, const char* default_value) const
-    {
-        return value(key, string_t(default_value));
-    }
-
-    /// @brief access specified object element via JSON Pointer with default value
-    /// @sa https://json.nlohmann.me/api/basic_json/value/
-    template<class ValueType, typename std::enable_if<
-                 detail::is_getable<basic_json_t, ValueType>::value, int>::type = 0>
-    ValueType value(const json_pointer& ptr, const ValueType& default_value) const
-    {
-        // at only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            // if pointer resolves a value, return it or use default value
-            JSON_TRY
-            {
-                return ptr.get_checked(this).template get<ValueType>();
-            }
-            JSON_INTERNAL_CATCH (out_of_range&)
-            {
-                return default_value;
-            }
-        }
-
-        JSON_THROW(type_error::create(306, "cannot use value() with " + std::string(type_name()), *this));
-    }
-
-    /// @brief access specified object element via JSON Pointer with default value
-    /// @sa https://json.nlohmann.me/api/basic_json/value/
-    /// overload for a default value of type const char*
-    JSON_HEDLEY_NON_NULL(3)
-    string_t value(const json_pointer& ptr, const char* default_value) const
-    {
-        return value(ptr, string_t(default_value));
-    }
-
-    /// @brief access the first element
-    /// @sa https://json.nlohmann.me/api/basic_json/front/
-    reference front()
-    {
-        return *begin();
-    }
-
-    /// @brief access the first element
-    /// @sa https://json.nlohmann.me/api/basic_json/front/
-    const_reference front() const
-    {
-        return *cbegin();
-    }
-
-    /// @brief access the last element
-    /// @sa https://json.nlohmann.me/api/basic_json/back/
-    reference back()
-    {
-        auto tmp = end();
-        --tmp;
-        return *tmp;
-    }
-
-    /// @brief access the last element
-    /// @sa https://json.nlohmann.me/api/basic_json/back/
-    const_reference back() const
-    {
-        auto tmp = cend();
-        --tmp;
-        return *tmp;
-    }
-
-    /// @brief remove element given an iterator
-    /// @sa https://json.nlohmann.me/api/basic_json/erase/
-    template < class IteratorType, typename std::enable_if <
-                   std::is_same<IteratorType, typename basic_json_t::iterator>::value ||
-                   std::is_same<IteratorType, typename basic_json_t::const_iterator>::value, int >::type
-               = 0 >
-    IteratorType erase(IteratorType pos)
-    {
-        // make sure iterator fits the current value
-        if (JSON_HEDLEY_UNLIKELY(this != pos.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
-        }
-
-        IteratorType result = end();
-
-        switch (m_type)
-        {
-            case value_t::boolean:
-            case value_t::number_float:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::string:
-            case value_t::binary:
-            {
-                if (JSON_HEDLEY_UNLIKELY(!pos.m_it.primitive_iterator.is_begin()))
-                {
-                    JSON_THROW(invalid_iterator::create(205, "iterator out of range", *this));
-                }
-
-                if (is_string())
-                {
-                    AllocatorType<string_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.string);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.string, 1);
-                    m_value.string = nullptr;
-                }
-                else if (is_binary())
-                {
-                    AllocatorType<binary_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.binary);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.binary, 1);
-                    m_value.binary = nullptr;
-                }
-
-                m_type = value_t::null;
-                assert_invariant();
-                break;
-            }
-
-            case value_t::object:
-            {
-                result.m_it.object_iterator = m_value.object->erase(pos.m_it.object_iterator);
-                break;
-            }
-
-            case value_t::array:
-            {
-                result.m_it.array_iterator = m_value.array->erase(pos.m_it.array_iterator);
-                break;
-            }
-
-            case value_t::null:
-            case value_t::discarded:
-            default:
-                JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
-        }
-
-        return result;
-    }
-
-    /// @brief remove elements given an iterator range
-    /// @sa https://json.nlohmann.me/api/basic_json/erase/
-    template < class IteratorType, typename std::enable_if <
-                   std::is_same<IteratorType, typename basic_json_t::iterator>::value ||
-                   std::is_same<IteratorType, typename basic_json_t::const_iterator>::value, int >::type
-               = 0 >
-    IteratorType erase(IteratorType first, IteratorType last)
-    {
-        // make sure iterator fits the current value
-        if (JSON_HEDLEY_UNLIKELY(this != first.m_object || this != last.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(203, "iterators do not fit current value", *this));
-        }
-
-        IteratorType result = end();
-
-        switch (m_type)
-        {
-            case value_t::boolean:
-            case value_t::number_float:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::string:
-            case value_t::binary:
-            {
-                if (JSON_HEDLEY_LIKELY(!first.m_it.primitive_iterator.is_begin()
-                                       || !last.m_it.primitive_iterator.is_end()))
-                {
-                    JSON_THROW(invalid_iterator::create(204, "iterators out of range", *this));
-                }
-
-                if (is_string())
-                {
-                    AllocatorType<string_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.string);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.string, 1);
-                    m_value.string = nullptr;
-                }
-                else if (is_binary())
-                {
-                    AllocatorType<binary_t> alloc;
-                    std::allocator_traits<decltype(alloc)>::destroy(alloc, m_value.binary);
-                    std::allocator_traits<decltype(alloc)>::deallocate(alloc, m_value.binary, 1);
-                    m_value.binary = nullptr;
-                }
-
-                m_type = value_t::null;
-                assert_invariant();
-                break;
-            }
-
-            case value_t::object:
-            {
-                result.m_it.object_iterator = m_value.object->erase(first.m_it.object_iterator,
-                                              last.m_it.object_iterator);
-                break;
-            }
-
-            case value_t::array:
-            {
-                result.m_it.array_iterator = m_value.array->erase(first.m_it.array_iterator,
-                                             last.m_it.array_iterator);
-                break;
-            }
-
-            case value_t::null:
-            case value_t::discarded:
-            default:
-                JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
-        }
-
-        return result;
-    }
-
-    /// @brief remove element from a JSON object given a key
-    /// @sa https://json.nlohmann.me/api/basic_json/erase/
-    size_type erase(const typename object_t::key_type& key)
-    {
-        // this erase only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            return m_value.object->erase(key);
-        }
-
-        JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
-    }
-
-    /// @brief remove element from a JSON array given an index
-    /// @sa https://json.nlohmann.me/api/basic_json/erase/
-    void erase(const size_type idx)
-    {
-        // this erase only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            if (JSON_HEDLEY_UNLIKELY(idx >= size()))
-            {
-                JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", *this));
-            }
-
-            m_value.array->erase(m_value.array->begin() + static_cast<difference_type>(idx));
-        }
-        else
-        {
-            JSON_THROW(type_error::create(307, "cannot use erase() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @}
-
-
-    ////////////
-    // lookup //
-    ////////////
-
-    /// @name lookup
-    /// @{
-
-    /// @brief find an element in a JSON object
-    /// @sa https://json.nlohmann.me/api/basic_json/find/
-    template<typename KeyT>
-    iterator find(KeyT&& key)
-    {
-        auto result = end();
-
-        if (is_object())
-        {
-            result.m_it.object_iterator = m_value.object->find(std::forward<KeyT>(key));
-        }
-
-        return result;
-    }
-
-    /// @brief find an element in a JSON object
-    /// @sa https://json.nlohmann.me/api/basic_json/find/
-    template<typename KeyT>
-    const_iterator find(KeyT&& key) const
-    {
-        auto result = cend();
-
-        if (is_object())
-        {
-            result.m_it.object_iterator = m_value.object->find(std::forward<KeyT>(key));
-        }
-
-        return result;
-    }
-
-    /// @brief returns the number of occurrences of a key in a JSON object
-    /// @sa https://json.nlohmann.me/api/basic_json/count/
-    template<typename KeyT>
-    size_type count(KeyT&& key) const
-    {
-        // return 0 for all nonobject types
-        return is_object() ? m_value.object->count(std::forward<KeyT>(key)) : 0;
-    }
-
-    /// @brief check the existence of an element in a JSON object
-    /// @sa https://json.nlohmann.me/api/basic_json/contains/
-    template < typename KeyT, typename std::enable_if <
-                   !std::is_same<typename std::decay<KeyT>::type, json_pointer>::value, int >::type = 0 >
-    bool contains(KeyT && key) const
-    {
-        return is_object() && m_value.object->find(std::forward<KeyT>(key)) != m_value.object->end();
-    }
-
-    /// @brief check the existence of an element in a JSON object given a JSON pointer
-    /// @sa https://json.nlohmann.me/api/basic_json/contains/
-    bool contains(const json_pointer& ptr) const
-    {
-        return ptr.contains(this);
-    }
-
-    /// @}
-
-
-    ///////////////
-    // iterators //
-    ///////////////
-
-    /// @name iterators
-    /// @{
-
-    /// @brief returns an iterator to the first element
-    /// @sa https://json.nlohmann.me/api/basic_json/begin/
-    iterator begin() noexcept
-    {
-        iterator result(this);
-        result.set_begin();
-        return result;
-    }
-
-    /// @brief returns an iterator to the first element
-    /// @sa https://json.nlohmann.me/api/basic_json/begin/
-    const_iterator begin() const noexcept
-    {
-        return cbegin();
-    }
-
-    /// @brief returns a const iterator to the first element
-    /// @sa https://json.nlohmann.me/api/basic_json/cbegin/
-    const_iterator cbegin() const noexcept
-    {
-        const_iterator result(this);
-        result.set_begin();
-        return result;
-    }
-
-    /// @brief returns an iterator to one past the last element
-    /// @sa https://json.nlohmann.me/api/basic_json/end/
-    iterator end() noexcept
-    {
-        iterator result(this);
-        result.set_end();
-        return result;
-    }
-
-    /// @brief returns an iterator to one past the last element
-    /// @sa https://json.nlohmann.me/api/basic_json/end/
-    const_iterator end() const noexcept
-    {
-        return cend();
-    }
-
-    /// @brief returns an iterator to one past the last element
-    /// @sa https://json.nlohmann.me/api/basic_json/cend/
-    const_iterator cend() const noexcept
-    {
-        const_iterator result(this);
-        result.set_end();
-        return result;
-    }
-
-    /// @brief returns an iterator to the reverse-beginning
-    /// @sa https://json.nlohmann.me/api/basic_json/rbegin/
-    reverse_iterator rbegin() noexcept
-    {
-        return reverse_iterator(end());
-    }
-
-    /// @brief returns an iterator to the reverse-beginning
-    /// @sa https://json.nlohmann.me/api/basic_json/rbegin/
-    const_reverse_iterator rbegin() const noexcept
-    {
-        return crbegin();
-    }
-
-    /// @brief returns an iterator to the reverse-end
-    /// @sa https://json.nlohmann.me/api/basic_json/rend/
-    reverse_iterator rend() noexcept
-    {
-        return reverse_iterator(begin());
-    }
-
-    /// @brief returns an iterator to the reverse-end
-    /// @sa https://json.nlohmann.me/api/basic_json/rend/
-    const_reverse_iterator rend() const noexcept
-    {
-        return crend();
-    }
-
-    /// @brief returns a const reverse iterator to the last element
-    /// @sa https://json.nlohmann.me/api/basic_json/crbegin/
-    const_reverse_iterator crbegin() const noexcept
-    {
-        return const_reverse_iterator(cend());
-    }
-
-    /// @brief returns a const reverse iterator to one before the first
-    /// @sa https://json.nlohmann.me/api/basic_json/crend/
-    const_reverse_iterator crend() const noexcept
-    {
-        return const_reverse_iterator(cbegin());
-    }
-
-  public:
-    /// @brief wrapper to access iterator member functions in range-based for
-    /// @sa https://json.nlohmann.me/api/basic_json/items/
-    /// @deprecated This function is deprecated since 3.1.0 and will be removed in
-    ///             version 4.0.0 of the library. Please use @ref items() instead;
-    ///             that is, replace `json::iterator_wrapper(j)` with `j.items()`.
-    JSON_HEDLEY_DEPRECATED_FOR(3.1.0, items())
-    static iteration_proxy<iterator> iterator_wrapper(reference ref) noexcept
-    {
-        return ref.items();
-    }
-
-    /// @brief wrapper to access iterator member functions in range-based for
-    /// @sa https://json.nlohmann.me/api/basic_json/items/
-    /// @deprecated This function is deprecated since 3.1.0 and will be removed in
-    ///         version 4.0.0 of the library. Please use @ref items() instead;
-    ///         that is, replace `json::iterator_wrapper(j)` with `j.items()`.
-    JSON_HEDLEY_DEPRECATED_FOR(3.1.0, items())
-    static iteration_proxy<const_iterator> iterator_wrapper(const_reference ref) noexcept
-    {
-        return ref.items();
-    }
-
-    /// @brief helper to access iterator member functions in range-based for
-    /// @sa https://json.nlohmann.me/api/basic_json/items/
-    iteration_proxy<iterator> items() noexcept
-    {
-        return iteration_proxy<iterator>(*this);
-    }
-
-    /// @brief helper to access iterator member functions in range-based for
-    /// @sa https://json.nlohmann.me/api/basic_json/items/
-    iteration_proxy<const_iterator> items() const noexcept
-    {
-        return iteration_proxy<const_iterator>(*this);
-    }
-
-    /// @}
-
-
-    //////////////
-    // capacity //
-    //////////////
-
-    /// @name capacity
-    /// @{
-
-    /// @brief checks whether the container is empty.
-    /// @sa https://json.nlohmann.me/api/basic_json/empty/
-    bool empty() const noexcept
-    {
-        switch (m_type)
-        {
-            case value_t::null:
-            {
-                // null values are empty
-                return true;
-            }
-
-            case value_t::array:
-            {
-                // delegate call to array_t::empty()
-                return m_value.array->empty();
-            }
-
-            case value_t::object:
-            {
-                // delegate call to object_t::empty()
-                return m_value.object->empty();
-            }
-
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                // all other types are nonempty
-                return false;
-            }
-        }
-    }
-
-    /// @brief returns the number of elements
-    /// @sa https://json.nlohmann.me/api/basic_json/size/
-    size_type size() const noexcept
-    {
-        switch (m_type)
-        {
-            case value_t::null:
-            {
-                // null values are empty
-                return 0;
-            }
-
-            case value_t::array:
-            {
-                // delegate call to array_t::size()
-                return m_value.array->size();
-            }
-
-            case value_t::object:
-            {
-                // delegate call to object_t::size()
-                return m_value.object->size();
-            }
-
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                // all other types have size 1
-                return 1;
-            }
-        }
-    }
-
-    /// @brief returns the maximum possible number of elements
-    /// @sa https://json.nlohmann.me/api/basic_json/max_size/
-    size_type max_size() const noexcept
-    {
-        switch (m_type)
-        {
-            case value_t::array:
-            {
-                // delegate call to array_t::max_size()
-                return m_value.array->max_size();
-            }
-
-            case value_t::object:
-            {
-                // delegate call to object_t::max_size()
-                return m_value.object->max_size();
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                // all other types have max_size() == size()
-                return size();
-            }
-        }
-    }
-
-    /// @}
-
-
-    ///////////////
-    // modifiers //
-    ///////////////
-
-    /// @name modifiers
-    /// @{
-
-    /// @brief clears the contents
-    /// @sa https://json.nlohmann.me/api/basic_json/clear/
-    void clear() noexcept
-    {
-        switch (m_type)
-        {
-            case value_t::number_integer:
-            {
-                m_value.number_integer = 0;
-                break;
-            }
-
-            case value_t::number_unsigned:
-            {
-                m_value.number_unsigned = 0;
-                break;
-            }
-
-            case value_t::number_float:
-            {
-                m_value.number_float = 0.0;
-                break;
-            }
-
-            case value_t::boolean:
-            {
-                m_value.boolean = false;
-                break;
-            }
-
-            case value_t::string:
-            {
-                m_value.string->clear();
-                break;
-            }
-
-            case value_t::binary:
-            {
-                m_value.binary->clear();
-                break;
-            }
-
-            case value_t::array:
-            {
-                m_value.array->clear();
-                break;
-            }
-
-            case value_t::object:
-            {
-                m_value.object->clear();
-                break;
-            }
-
-            case value_t::null:
-            case value_t::discarded:
-            default:
-                break;
-        }
-    }
-
-    /// @brief add an object to an array
-    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
-    void push_back(basic_json&& val)
-    {
-        // push_back only works for null objects or arrays
-        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_array())))
-        {
-            JSON_THROW(type_error::create(308, "cannot use push_back() with " + std::string(type_name()), *this));
-        }
-
-        // transform null object into an array
-        if (is_null())
-        {
-            m_type = value_t::array;
-            m_value = value_t::array;
-            assert_invariant();
-        }
-
-        // add element to array (move semantics)
-        const auto old_capacity = m_value.array->capacity();
-        m_value.array->push_back(std::move(val));
-        set_parent(m_value.array->back(), old_capacity);
-        // if val is moved from, basic_json move constructor marks it null, so we do not call the destructor
-    }
-
-    /// @brief add an object to an array
-    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
-    reference operator+=(basic_json&& val)
-    {
-        push_back(std::move(val));
-        return *this;
-    }
-
-    /// @brief add an object to an array
-    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
-    void push_back(const basic_json& val)
-    {
-        // push_back only works for null objects or arrays
-        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_array())))
-        {
-            JSON_THROW(type_error::create(308, "cannot use push_back() with " + std::string(type_name()), *this));
-        }
-
-        // transform null object into an array
-        if (is_null())
-        {
-            m_type = value_t::array;
-            m_value = value_t::array;
-            assert_invariant();
-        }
-
-        // add element to array
-        const auto old_capacity = m_value.array->capacity();
-        m_value.array->push_back(val);
-        set_parent(m_value.array->back(), old_capacity);
-    }
-
-    /// @brief add an object to an array
-    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
-    reference operator+=(const basic_json& val)
-    {
-        push_back(val);
-        return *this;
-    }
-
-    /// @brief add an object to an object
-    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
-    void push_back(const typename object_t::value_type& val)
-    {
-        // push_back only works for null objects or objects
-        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_object())))
-        {
-            JSON_THROW(type_error::create(308, "cannot use push_back() with " + std::string(type_name()), *this));
-        }
-
-        // transform null object into an object
-        if (is_null())
-        {
-            m_type = value_t::object;
-            m_value = value_t::object;
-            assert_invariant();
-        }
-
-        // add element to object
-        auto res = m_value.object->insert(val);
-        set_parent(res.first->second);
-    }
-
-    /// @brief add an object to an object
-    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
-    reference operator+=(const typename object_t::value_type& val)
-    {
-        push_back(val);
-        return *this;
-    }
-
-    /// @brief add an object to an object
-    /// @sa https://json.nlohmann.me/api/basic_json/push_back/
-    void push_back(initializer_list_t init)
-    {
-        if (is_object() && init.size() == 2 && (*init.begin())->is_string())
-        {
-            basic_json&& key = init.begin()->moved_or_copied();
-            push_back(typename object_t::value_type(
-                          std::move(key.get_ref<string_t&>()), (init.begin() + 1)->moved_or_copied()));
-        }
-        else
-        {
-            push_back(basic_json(init));
-        }
-    }
-
-    /// @brief add an object to an object
-    /// @sa https://json.nlohmann.me/api/basic_json/operator+=/
-    reference operator+=(initializer_list_t init)
-    {
-        push_back(init);
-        return *this;
-    }
-
-    /// @brief add an object to an array
-    /// @sa https://json.nlohmann.me/api/basic_json/emplace_back/
-    template<class... Args>
-    reference emplace_back(Args&& ... args)
-    {
-        // emplace_back only works for null objects or arrays
-        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_array())))
-        {
-            JSON_THROW(type_error::create(311, "cannot use emplace_back() with " + std::string(type_name()), *this));
-        }
-
-        // transform null object into an array
-        if (is_null())
-        {
-            m_type = value_t::array;
-            m_value = value_t::array;
-            assert_invariant();
-        }
-
-        // add element to array (perfect forwarding)
-        const auto old_capacity = m_value.array->capacity();
-        m_value.array->emplace_back(std::forward<Args>(args)...);
-        return set_parent(m_value.array->back(), old_capacity);
-    }
-
-    /// @brief add an object to an object if key does not exist
-    /// @sa https://json.nlohmann.me/api/basic_json/emplace/
-    template<class... Args>
-    std::pair<iterator, bool> emplace(Args&& ... args)
-    {
-        // emplace only works for null objects or arrays
-        if (JSON_HEDLEY_UNLIKELY(!(is_null() || is_object())))
-        {
-            JSON_THROW(type_error::create(311, "cannot use emplace() with " + std::string(type_name()), *this));
-        }
-
-        // transform null object into an object
-        if (is_null())
-        {
-            m_type = value_t::object;
-            m_value = value_t::object;
-            assert_invariant();
-        }
-
-        // add element to array (perfect forwarding)
-        auto res = m_value.object->emplace(std::forward<Args>(args)...);
-        set_parent(res.first->second);
-
-        // create result iterator and set iterator to the result of emplace
-        auto it = begin();
-        it.m_it.object_iterator = res.first;
-
-        // return pair of iterator and boolean
-        return {it, res.second};
-    }
-
-    /// Helper for insertion of an iterator
-    /// @note: This uses std::distance to support GCC 4.8,
-    ///        see https://github.com/nlohmann/json/pull/1257
-    template<typename... Args>
-    iterator insert_iterator(const_iterator pos, Args&& ... args)
-    {
-        iterator result(this);
-        JSON_ASSERT(m_value.array != nullptr);
-
-        auto insert_pos = std::distance(m_value.array->begin(), pos.m_it.array_iterator);
-        m_value.array->insert(pos.m_it.array_iterator, std::forward<Args>(args)...);
-        result.m_it.array_iterator = m_value.array->begin() + insert_pos;
-
-        // This could have been written as:
-        // result.m_it.array_iterator = m_value.array->insert(pos.m_it.array_iterator, cnt, val);
-        // but the return value of insert is missing in GCC 4.8, so it is written this way instead.
-
-        set_parents();
-        return result;
-    }
-
-    /// @brief inserts element into array
-    /// @sa https://json.nlohmann.me/api/basic_json/insert/
-    iterator insert(const_iterator pos, const basic_json& val)
-    {
-        // insert only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            // check if iterator pos fits to this JSON value
-            if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
-            {
-                JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
-            }
-
-            // insert to array and return iterator
-            return insert_iterator(pos, val);
-        }
-
-        JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
-    }
-
-    /// @brief inserts element into array
-    /// @sa https://json.nlohmann.me/api/basic_json/insert/
-    iterator insert(const_iterator pos, basic_json&& val)
-    {
-        return insert(pos, val);
-    }
-
-    /// @brief inserts copies of element into array
-    /// @sa https://json.nlohmann.me/api/basic_json/insert/
-    iterator insert(const_iterator pos, size_type cnt, const basic_json& val)
-    {
-        // insert only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            // check if iterator pos fits to this JSON value
-            if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
-            {
-                JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
-            }
-
-            // insert to array and return iterator
-            return insert_iterator(pos, cnt, val);
-        }
-
-        JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
-    }
-
-    /// @brief inserts range of elements into array
-    /// @sa https://json.nlohmann.me/api/basic_json/insert/
-    iterator insert(const_iterator pos, const_iterator first, const_iterator last)
-    {
-        // insert only works for arrays
-        if (JSON_HEDLEY_UNLIKELY(!is_array()))
-        {
-            JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
-        }
-
-        // check if iterator pos fits to this JSON value
-        if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
-        {
-            JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
-        }
-
-        // check if range iterators belong to the same JSON object
-        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(210, "iterators do not fit", *this));
-        }
-
-        if (JSON_HEDLEY_UNLIKELY(first.m_object == this))
-        {
-            JSON_THROW(invalid_iterator::create(211, "passed iterators may not belong to container", *this));
-        }
-
-        // insert to array and return iterator
-        return insert_iterator(pos, first.m_it.array_iterator, last.m_it.array_iterator);
-    }
-
-    /// @brief inserts elements from initializer list into array
-    /// @sa https://json.nlohmann.me/api/basic_json/insert/
-    iterator insert(const_iterator pos, initializer_list_t ilist)
-    {
-        // insert only works for arrays
-        if (JSON_HEDLEY_UNLIKELY(!is_array()))
-        {
-            JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
-        }
-
-        // check if iterator pos fits to this JSON value
-        if (JSON_HEDLEY_UNLIKELY(pos.m_object != this))
-        {
-            JSON_THROW(invalid_iterator::create(202, "iterator does not fit current value", *this));
-        }
-
-        // insert to array and return iterator
-        return insert_iterator(pos, ilist.begin(), ilist.end());
-    }
-
-    /// @brief inserts range of elements into object
-    /// @sa https://json.nlohmann.me/api/basic_json/insert/
-    void insert(const_iterator first, const_iterator last)
-    {
-        // insert only works for objects
-        if (JSON_HEDLEY_UNLIKELY(!is_object()))
-        {
-            JSON_THROW(type_error::create(309, "cannot use insert() with " + std::string(type_name()), *this));
-        }
-
-        // check if range iterators belong to the same JSON object
-        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(210, "iterators do not fit", *this));
-        }
-
-        // passed iterators must belong to objects
-        if (JSON_HEDLEY_UNLIKELY(!first.m_object->is_object()))
-        {
-            JSON_THROW(invalid_iterator::create(202, "iterators first and last must point to objects", *this));
-        }
-
-        m_value.object->insert(first.m_it.object_iterator, last.m_it.object_iterator);
-    }
-
-    /// @brief updates a JSON object from another object, overwriting existing keys
-    /// @sa https://json.nlohmann.me/api/basic_json/update/
-    void update(const_reference j, bool merge_objects = false)
-    {
-        update(j.begin(), j.end(), merge_objects);
-    }
-
-    /// @brief updates a JSON object from another object, overwriting existing keys
-    /// @sa https://json.nlohmann.me/api/basic_json/update/
-    void update(const_iterator first, const_iterator last, bool merge_objects = false)
-    {
-        // implicitly convert null value to an empty object
-        if (is_null())
-        {
-            m_type = value_t::object;
-            m_value.object = create<object_t>();
-            assert_invariant();
-        }
-
-        if (JSON_HEDLEY_UNLIKELY(!is_object()))
-        {
-            JSON_THROW(type_error::create(312, "cannot use update() with " + std::string(type_name()), *this));
-        }
-
-        // check if range iterators belong to the same JSON object
-        if (JSON_HEDLEY_UNLIKELY(first.m_object != last.m_object))
-        {
-            JSON_THROW(invalid_iterator::create(210, "iterators do not fit", *this));
-        }
-
-        // passed iterators must belong to objects
-        if (JSON_HEDLEY_UNLIKELY(!first.m_object->is_object()))
-        {
-            JSON_THROW(type_error::create(312, "cannot use update() with " + std::string(first.m_object->type_name()), *first.m_object));
-        }
-
-        for (auto it = first; it != last; ++it)
-        {
-            if (merge_objects && it.value().is_object())
-            {
-                auto it2 = m_value.object->find(it.key());
-                if (it2 != m_value.object->end())
-                {
-                    it2->second.update(it.value(), true);
-                    continue;
-                }
-            }
-            m_value.object->operator[](it.key()) = it.value();
-#if JSON_DIAGNOSTICS
-            m_value.object->operator[](it.key()).m_parent = this;
-#endif
-        }
-    }
-
-    /// @brief exchanges the values
-    /// @sa https://json.nlohmann.me/api/basic_json/swap/
-    void swap(reference other) noexcept (
-        std::is_nothrow_move_constructible<value_t>::value&&
-        std::is_nothrow_move_assignable<value_t>::value&&
-        std::is_nothrow_move_constructible<json_value>::value&&
-        std::is_nothrow_move_assignable<json_value>::value
-    )
-    {
-        std::swap(m_type, other.m_type);
-        std::swap(m_value, other.m_value);
-
-        set_parents();
-        other.set_parents();
-        assert_invariant();
-    }
-
-    /// @brief exchanges the values
-    /// @sa https://json.nlohmann.me/api/basic_json/swap/
-    friend void swap(reference left, reference right) noexcept (
-        std::is_nothrow_move_constructible<value_t>::value&&
-        std::is_nothrow_move_assignable<value_t>::value&&
-        std::is_nothrow_move_constructible<json_value>::value&&
-        std::is_nothrow_move_assignable<json_value>::value
-    )
-    {
-        left.swap(right);
-    }
-
-    /// @brief exchanges the values
-    /// @sa https://json.nlohmann.me/api/basic_json/swap/
-    void swap(array_t& other) // NOLINT(bugprone-exception-escape)
-    {
-        // swap only works for arrays
-        if (JSON_HEDLEY_LIKELY(is_array()))
-        {
-            std::swap(*(m_value.array), other);
-        }
-        else
-        {
-            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief exchanges the values
-    /// @sa https://json.nlohmann.me/api/basic_json/swap/
-    void swap(object_t& other) // NOLINT(bugprone-exception-escape)
-    {
-        // swap only works for objects
-        if (JSON_HEDLEY_LIKELY(is_object()))
-        {
-            std::swap(*(m_value.object), other);
-        }
-        else
-        {
-            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief exchanges the values
-    /// @sa https://json.nlohmann.me/api/basic_json/swap/
-    void swap(string_t& other) // NOLINT(bugprone-exception-escape)
-    {
-        // swap only works for strings
-        if (JSON_HEDLEY_LIKELY(is_string()))
-        {
-            std::swap(*(m_value.string), other);
-        }
-        else
-        {
-            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief exchanges the values
-    /// @sa https://json.nlohmann.me/api/basic_json/swap/
-    void swap(binary_t& other) // NOLINT(bugprone-exception-escape)
-    {
-        // swap only works for strings
-        if (JSON_HEDLEY_LIKELY(is_binary()))
-        {
-            std::swap(*(m_value.binary), other);
-        }
-        else
-        {
-            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @brief exchanges the values
-    /// @sa https://json.nlohmann.me/api/basic_json/swap/
-    void swap(typename binary_t::container_type& other) // NOLINT(bugprone-exception-escape)
-    {
-        // swap only works for strings
-        if (JSON_HEDLEY_LIKELY(is_binary()))
-        {
-            std::swap(*(m_value.binary), other);
-        }
-        else
-        {
-            JSON_THROW(type_error::create(310, "cannot use swap() with " + std::string(type_name()), *this));
-        }
-    }
-
-    /// @}
-
-  public:
-    //////////////////////////////////////////
-    // lexicographical comparison operators //
-    //////////////////////////////////////////
-
-    /// @name lexicographical comparison operators
-    /// @{
-
-    /// @brief comparison: equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_eq/
-    friend bool operator==(const_reference lhs, const_reference rhs) noexcept
-    {
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wfloat-equal"
-#endif
-        const auto lhs_type = lhs.type();
-        const auto rhs_type = rhs.type();
-
-        if (lhs_type == rhs_type)
-        {
-            switch (lhs_type)
-            {
-                case value_t::array:
-                    return *lhs.m_value.array == *rhs.m_value.array;
-
-                case value_t::object:
-                    return *lhs.m_value.object == *rhs.m_value.object;
-
-                case value_t::null:
-                    return true;
-
-                case value_t::string:
-                    return *lhs.m_value.string == *rhs.m_value.string;
-
-                case value_t::boolean:
-                    return lhs.m_value.boolean == rhs.m_value.boolean;
-
-                case value_t::number_integer:
-                    return lhs.m_value.number_integer == rhs.m_value.number_integer;
-
-                case value_t::number_unsigned:
-                    return lhs.m_value.number_unsigned == rhs.m_value.number_unsigned;
-
-                case value_t::number_float:
-                    return lhs.m_value.number_float == rhs.m_value.number_float;
-
-                case value_t::binary:
-                    return *lhs.m_value.binary == *rhs.m_value.binary;
-
-                case value_t::discarded:
-                default:
-                    return false;
-            }
-        }
-        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_float)
-        {
-            return static_cast<number_float_t>(lhs.m_value.number_integer) == rhs.m_value.number_float;
-        }
-        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_integer)
-        {
-            return lhs.m_value.number_float == static_cast<number_float_t>(rhs.m_value.number_integer);
-        }
-        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_float)
-        {
-            return static_cast<number_float_t>(lhs.m_value.number_unsigned) == rhs.m_value.number_float;
-        }
-        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_unsigned)
-        {
-            return lhs.m_value.number_float == static_cast<number_float_t>(rhs.m_value.number_unsigned);
-        }
-        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_integer)
-        {
-            return static_cast<number_integer_t>(lhs.m_value.number_unsigned) == rhs.m_value.number_integer;
-        }
-        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_unsigned)
-        {
-            return lhs.m_value.number_integer == static_cast<number_integer_t>(rhs.m_value.number_unsigned);
-        }
-
-        return false;
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-    }
-
-    /// @brief comparison: equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_eq/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator==(const_reference lhs, ScalarType rhs) noexcept
-    {
-        return lhs == basic_json(rhs);
-    }
-
-    /// @brief comparison: equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_eq/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator==(ScalarType lhs, const_reference rhs) noexcept
-    {
-        return basic_json(lhs) == rhs;
-    }
-
-    /// @brief comparison: not equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ne/
-    friend bool operator!=(const_reference lhs, const_reference rhs) noexcept
-    {
-        return !(lhs == rhs);
-    }
-
-    /// @brief comparison: not equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ne/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator!=(const_reference lhs, ScalarType rhs) noexcept
-    {
-        return lhs != basic_json(rhs);
-    }
-
-    /// @brief comparison: not equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ne/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator!=(ScalarType lhs, const_reference rhs) noexcept
-    {
-        return basic_json(lhs) != rhs;
-    }
-
-    /// @brief comparison: less than
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_lt/
-    friend bool operator<(const_reference lhs, const_reference rhs) noexcept
-    {
-        const auto lhs_type = lhs.type();
-        const auto rhs_type = rhs.type();
-
-        if (lhs_type == rhs_type)
-        {
-            switch (lhs_type)
-            {
-                case value_t::array:
-                    // note parentheses are necessary, see
-                    // https://github.com/nlohmann/json/issues/1530
-                    return (*lhs.m_value.array) < (*rhs.m_value.array);
-
-                case value_t::object:
-                    return (*lhs.m_value.object) < (*rhs.m_value.object);
-
-                case value_t::null:
-                    return false;
-
-                case value_t::string:
-                    return (*lhs.m_value.string) < (*rhs.m_value.string);
-
-                case value_t::boolean:
-                    return (lhs.m_value.boolean) < (rhs.m_value.boolean);
-
-                case value_t::number_integer:
-                    return (lhs.m_value.number_integer) < (rhs.m_value.number_integer);
-
-                case value_t::number_unsigned:
-                    return (lhs.m_value.number_unsigned) < (rhs.m_value.number_unsigned);
-
-                case value_t::number_float:
-                    return (lhs.m_value.number_float) < (rhs.m_value.number_float);
-
-                case value_t::binary:
-                    return (*lhs.m_value.binary) < (*rhs.m_value.binary);
-
-                case value_t::discarded:
-                default:
-                    return false;
-            }
-        }
-        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_float)
-        {
-            return static_cast<number_float_t>(lhs.m_value.number_integer) < rhs.m_value.number_float;
-        }
-        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_integer)
-        {
-            return lhs.m_value.number_float < static_cast<number_float_t>(rhs.m_value.number_integer);
-        }
-        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_float)
-        {
-            return static_cast<number_float_t>(lhs.m_value.number_unsigned) < rhs.m_value.number_float;
-        }
-        else if (lhs_type == value_t::number_float && rhs_type == value_t::number_unsigned)
-        {
-            return lhs.m_value.number_float < static_cast<number_float_t>(rhs.m_value.number_unsigned);
-        }
-        else if (lhs_type == value_t::number_integer && rhs_type == value_t::number_unsigned)
-        {
-            return lhs.m_value.number_integer < static_cast<number_integer_t>(rhs.m_value.number_unsigned);
-        }
-        else if (lhs_type == value_t::number_unsigned && rhs_type == value_t::number_integer)
-        {
-            return static_cast<number_integer_t>(lhs.m_value.number_unsigned) < rhs.m_value.number_integer;
-        }
-
-        // We only reach this line if we cannot compare values. In that case,
-        // we compare types. Note we have to call the operator explicitly,
-        // because MSVC has problems otherwise.
-        return operator<(lhs_type, rhs_type);
-    }
-
-    /// @brief comparison: less than
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_lt/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator<(const_reference lhs, ScalarType rhs) noexcept
-    {
-        return lhs < basic_json(rhs);
-    }
-
-    /// @brief comparison: less than
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_lt/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator<(ScalarType lhs, const_reference rhs) noexcept
-    {
-        return basic_json(lhs) < rhs;
-    }
-
-    /// @brief comparison: less than or equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_le/
-    friend bool operator<=(const_reference lhs, const_reference rhs) noexcept
-    {
-        return !(rhs < lhs);
-    }
-
-    /// @brief comparison: less than or equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_le/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator<=(const_reference lhs, ScalarType rhs) noexcept
-    {
-        return lhs <= basic_json(rhs);
-    }
-
-    /// @brief comparison: less than or equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_le/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator<=(ScalarType lhs, const_reference rhs) noexcept
-    {
-        return basic_json(lhs) <= rhs;
-    }
-
-    /// @brief comparison: greater than
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_gt/
-    friend bool operator>(const_reference lhs, const_reference rhs) noexcept
-    {
-        return !(lhs <= rhs);
-    }
-
-    /// @brief comparison: greater than
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_gt/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator>(const_reference lhs, ScalarType rhs) noexcept
-    {
-        return lhs > basic_json(rhs);
-    }
-
-    /// @brief comparison: greater than
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_gt/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator>(ScalarType lhs, const_reference rhs) noexcept
-    {
-        return basic_json(lhs) > rhs;
-    }
-
-    /// @brief comparison: greater than or equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ge/
-    friend bool operator>=(const_reference lhs, const_reference rhs) noexcept
-    {
-        return !(lhs < rhs);
-    }
-
-    /// @brief comparison: greater than or equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ge/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator>=(const_reference lhs, ScalarType rhs) noexcept
-    {
-        return lhs >= basic_json(rhs);
-    }
-
-    /// @brief comparison: greater than or equal
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ge/
-    template<typename ScalarType, typename std::enable_if<
-                 std::is_scalar<ScalarType>::value, int>::type = 0>
-    friend bool operator>=(ScalarType lhs, const_reference rhs) noexcept
-    {
-        return basic_json(lhs) >= rhs;
-    }
-
-    /// @}
-
-    ///////////////////
-    // serialization //
-    ///////////////////
-
-    /// @name serialization
-    /// @{
-#ifndef JSON_NO_IO
-    /// @brief serialize to stream
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ltlt/
-    friend std::ostream& operator<<(std::ostream& o, const basic_json& j)
-    {
-        // read width member and use it as indentation parameter if nonzero
-        const bool pretty_print = o.width() > 0;
-        const auto indentation = pretty_print ? o.width() : 0;
-
-        // reset width to 0 for subsequent calls to this stream
-        o.width(0);
-
-        // do the actual serialization
-        serializer s(detail::output_adapter<char>(o), o.fill());
-        s.dump(j, pretty_print, false, static_cast<unsigned int>(indentation));
-        return o;
-    }
-
-    /// @brief serialize to stream
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_ltlt/
-    /// @deprecated This function is deprecated since 3.0.0 and will be removed in
-    ///             version 4.0.0 of the library. Please use
-    ///             operator<<(std::ostream&, const basic_json&) instead; that is,
-    ///             replace calls like `j >> o;` with `o << j;`.
-    JSON_HEDLEY_DEPRECATED_FOR(3.0.0, operator<<(std::ostream&, const basic_json&))
-    friend std::ostream& operator>>(const basic_json& j, std::ostream& o)
-    {
-        return o << j;
-    }
-#endif  // JSON_NO_IO
-    /// @}
-
-
-    /////////////////////
-    // deserialization //
-    /////////////////////
-
-    /// @name deserialization
-    /// @{
-
-    /// @brief deserialize from a compatible input
-    /// @sa https://json.nlohmann.me/api/basic_json/parse/
-    template<typename InputType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json parse(InputType&& i,
-                            const parser_callback_t cb = nullptr,
-                            const bool allow_exceptions = true,
-                            const bool ignore_comments = false)
-    {
-        basic_json result;
-        parser(detail::input_adapter(std::forward<InputType>(i)), cb, allow_exceptions, ignore_comments).parse(true, result);
-        return result;
-    }
-
-    /// @brief deserialize from a pair of character iterators
-    /// @sa https://json.nlohmann.me/api/basic_json/parse/
-    template<typename IteratorType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json parse(IteratorType first,
-                            IteratorType last,
-                            const parser_callback_t cb = nullptr,
-                            const bool allow_exceptions = true,
-                            const bool ignore_comments = false)
-    {
-        basic_json result;
-        parser(detail::input_adapter(std::move(first), std::move(last)), cb, allow_exceptions, ignore_comments).parse(true, result);
-        return result;
-    }
-
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, parse(ptr, ptr + len))
-    static basic_json parse(detail::span_input_adapter&& i,
-                            const parser_callback_t cb = nullptr,
-                            const bool allow_exceptions = true,
-                            const bool ignore_comments = false)
-    {
-        basic_json result;
-        parser(i.get(), cb, allow_exceptions, ignore_comments).parse(true, result);
-        return result;
-    }
-
-    /// @brief check if the input is valid JSON
-    /// @sa https://json.nlohmann.me/api/basic_json/accept/
-    template<typename InputType>
-    static bool accept(InputType&& i,
-                       const bool ignore_comments = false)
-    {
-        return parser(detail::input_adapter(std::forward<InputType>(i)), nullptr, false, ignore_comments).accept(true);
-    }
-
-    /// @brief check if the input is valid JSON
-    /// @sa https://json.nlohmann.me/api/basic_json/accept/
-    template<typename IteratorType>
-    static bool accept(IteratorType first, IteratorType last,
-                       const bool ignore_comments = false)
-    {
-        return parser(detail::input_adapter(std::move(first), std::move(last)), nullptr, false, ignore_comments).accept(true);
-    }
-
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, accept(ptr, ptr + len))
-    static bool accept(detail::span_input_adapter&& i,
-                       const bool ignore_comments = false)
-    {
-        return parser(i.get(), nullptr, false, ignore_comments).accept(true);
-    }
-
-    /// @brief generate SAX events
-    /// @sa https://json.nlohmann.me/api/basic_json/sax_parse/
-    template <typename InputType, typename SAX>
-    JSON_HEDLEY_NON_NULL(2)
-    static bool sax_parse(InputType&& i, SAX* sax,
-                          input_format_t format = input_format_t::json,
-                          const bool strict = true,
-                          const bool ignore_comments = false)
-    {
-        auto ia = detail::input_adapter(std::forward<InputType>(i));
-        return format == input_format_t::json
-               ? parser(std::move(ia), nullptr, true, ignore_comments).sax_parse(sax, strict)
-               : detail::binary_reader<basic_json, decltype(ia), SAX>(std::move(ia)).sax_parse(format, sax, strict);
-    }
-
-    /// @brief generate SAX events
-    /// @sa https://json.nlohmann.me/api/basic_json/sax_parse/
-    template<class IteratorType, class SAX>
-    JSON_HEDLEY_NON_NULL(3)
-    static bool sax_parse(IteratorType first, IteratorType last, SAX* sax,
-                          input_format_t format = input_format_t::json,
-                          const bool strict = true,
-                          const bool ignore_comments = false)
-    {
-        auto ia = detail::input_adapter(std::move(first), std::move(last));
-        return format == input_format_t::json
-               ? parser(std::move(ia), nullptr, true, ignore_comments).sax_parse(sax, strict)
-               : detail::binary_reader<basic_json, decltype(ia), SAX>(std::move(ia)).sax_parse(format, sax, strict);
-    }
-
-    /// @brief generate SAX events
-    /// @sa https://json.nlohmann.me/api/basic_json/sax_parse/
-    /// @deprecated This function is deprecated since 3.8.0 and will be removed in
-    ///             version 4.0.0 of the library. Please use
-    ///             sax_parse(ptr, ptr + len) instead.
-    template <typename SAX>
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, sax_parse(ptr, ptr + len, ...))
-    JSON_HEDLEY_NON_NULL(2)
-    static bool sax_parse(detail::span_input_adapter&& i, SAX* sax,
-                          input_format_t format = input_format_t::json,
-                          const bool strict = true,
-                          const bool ignore_comments = false)
-    {
-        auto ia = i.get();
-        return format == input_format_t::json
-               // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
-               ? parser(std::move(ia), nullptr, true, ignore_comments).sax_parse(sax, strict)
-               // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
-               : detail::binary_reader<basic_json, decltype(ia), SAX>(std::move(ia)).sax_parse(format, sax, strict);
-    }
-#ifndef JSON_NO_IO
-    /// @brief deserialize from stream
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_gtgt/
-    /// @deprecated This stream operator is deprecated since 3.0.0 and will be removed in
-    ///             version 4.0.0 of the library. Please use
-    ///             operator>>(std::istream&, basic_json&) instead; that is,
-    ///             replace calls like `j << i;` with `i >> j;`.
-    JSON_HEDLEY_DEPRECATED_FOR(3.0.0, operator>>(std::istream&, basic_json&))
-    friend std::istream& operator<<(basic_json& j, std::istream& i)
-    {
-        return operator>>(i, j);
-    }
-
-    /// @brief deserialize from stream
-    /// @sa https://json.nlohmann.me/api/basic_json/operator_gtgt/
-    friend std::istream& operator>>(std::istream& i, basic_json& j)
-    {
-        parser(detail::input_adapter(i)).parse(false, j);
-        return i;
-    }
-#endif  // JSON_NO_IO
-    /// @}
-
-    ///////////////////////////
-    // convenience functions //
-    ///////////////////////////
-
-    /// @brief return the type as string
-    /// @sa https://json.nlohmann.me/api/basic_json/type_name/
-    JSON_HEDLEY_RETURNS_NON_NULL
-    const char* type_name() const noexcept
-    {
-        switch (m_type)
-        {
-            case value_t::null:
-                return "null";
-            case value_t::object:
-                return "object";
-            case value_t::array:
-                return "array";
-            case value_t::string:
-                return "string";
-            case value_t::boolean:
-                return "boolean";
-            case value_t::binary:
-                return "binary";
-            case value_t::discarded:
-                return "discarded";
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            default:
-                return "number";
-        }
-    }
-
-
-  JSON_PRIVATE_UNLESS_TESTED:
-    //////////////////////
-    // member variables //
-    //////////////////////
-
-    /// the type of the current element
-    value_t m_type = value_t::null;
-
-    /// the value of the current element
-    json_value m_value = {};
-
-#if JSON_DIAGNOSTICS
-    /// a pointer to a parent value (for debugging purposes)
-    basic_json* m_parent = nullptr;
-#endif
-
-    //////////////////////////////////////////
-    // binary serialization/deserialization //
-    //////////////////////////////////////////
-
-    /// @name binary serialization/deserialization support
-    /// @{
-
-  public:
-    /// @brief create a CBOR serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_cbor/
-    static std::vector<std::uint8_t> to_cbor(const basic_json& j)
-    {
-        std::vector<std::uint8_t> result;
-        to_cbor(j, result);
-        return result;
-    }
-
-    /// @brief create a CBOR serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_cbor/
-    static void to_cbor(const basic_json& j, detail::output_adapter<std::uint8_t> o)
-    {
-        binary_writer<std::uint8_t>(o).write_cbor(j);
-    }
-
-    /// @brief create a CBOR serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_cbor/
-    static void to_cbor(const basic_json& j, detail::output_adapter<char> o)
-    {
-        binary_writer<char>(o).write_cbor(j);
-    }
-
-    /// @brief create a MessagePack serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_msgpack/
-    static std::vector<std::uint8_t> to_msgpack(const basic_json& j)
-    {
-        std::vector<std::uint8_t> result;
-        to_msgpack(j, result);
-        return result;
-    }
-
-    /// @brief create a MessagePack serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_msgpack/
-    static void to_msgpack(const basic_json& j, detail::output_adapter<std::uint8_t> o)
-    {
-        binary_writer<std::uint8_t>(o).write_msgpack(j);
-    }
-
-    /// @brief create a MessagePack serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_msgpack/
-    static void to_msgpack(const basic_json& j, detail::output_adapter<char> o)
-    {
-        binary_writer<char>(o).write_msgpack(j);
-    }
-
-    /// @brief create a UBJSON serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_ubjson/
-    static std::vector<std::uint8_t> to_ubjson(const basic_json& j,
-            const bool use_size = false,
-            const bool use_type = false)
-    {
-        std::vector<std::uint8_t> result;
-        to_ubjson(j, result, use_size, use_type);
-        return result;
-    }
-
-    /// @brief create a UBJSON serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_ubjson/
-    static void to_ubjson(const basic_json& j, detail::output_adapter<std::uint8_t> o,
-                          const bool use_size = false, const bool use_type = false)
-    {
-        binary_writer<std::uint8_t>(o).write_ubjson(j, use_size, use_type);
-    }
-
-    /// @brief create a UBJSON serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_ubjson/
-    static void to_ubjson(const basic_json& j, detail::output_adapter<char> o,
-                          const bool use_size = false, const bool use_type = false)
-    {
-        binary_writer<char>(o).write_ubjson(j, use_size, use_type);
-    }
-
-    /// @brief create a BSON serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_bson/
-    static std::vector<std::uint8_t> to_bson(const basic_json& j)
-    {
-        std::vector<std::uint8_t> result;
-        to_bson(j, result);
-        return result;
-    }
-
-    /// @brief create a BSON serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_bson/
-    static void to_bson(const basic_json& j, detail::output_adapter<std::uint8_t> o)
-    {
-        binary_writer<std::uint8_t>(o).write_bson(j);
-    }
-
-    /// @brief create a BSON serialization of a given JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/to_bson/
-    static void to_bson(const basic_json& j, detail::output_adapter<char> o)
-    {
-        binary_writer<char>(o).write_bson(j);
-    }
-
-    /// @brief create a JSON value from an input in CBOR format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_cbor/
-    template<typename InputType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_cbor(InputType&& i,
-                                const bool strict = true,
-                                const bool allow_exceptions = true,
-                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::forward<InputType>(i));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::cbor, &sdp, strict, tag_handler);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    /// @brief create a JSON value from an input in CBOR format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_cbor/
-    template<typename IteratorType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_cbor(IteratorType first, IteratorType last,
-                                const bool strict = true,
-                                const bool allow_exceptions = true,
-                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::move(first), std::move(last));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::cbor, &sdp, strict, tag_handler);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    template<typename T>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_cbor(ptr, ptr + len))
-    static basic_json from_cbor(const T* ptr, std::size_t len,
-                                const bool strict = true,
-                                const bool allow_exceptions = true,
-                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
-    {
-        return from_cbor(ptr, ptr + len, strict, allow_exceptions, tag_handler);
-    }
-
-
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_cbor(ptr, ptr + len))
-    static basic_json from_cbor(detail::span_input_adapter&& i,
-                                const bool strict = true,
-                                const bool allow_exceptions = true,
-                                const cbor_tag_handler_t tag_handler = cbor_tag_handler_t::error)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = i.get();
-        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::cbor, &sdp, strict, tag_handler);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    /// @brief create a JSON value from an input in MessagePack format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_msgpack/
-    template<typename InputType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_msgpack(InputType&& i,
-                                   const bool strict = true,
-                                   const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::forward<InputType>(i));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::msgpack, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    /// @brief create a JSON value from an input in MessagePack format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_msgpack/
-    template<typename IteratorType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_msgpack(IteratorType first, IteratorType last,
-                                   const bool strict = true,
-                                   const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::move(first), std::move(last));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::msgpack, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    template<typename T>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_msgpack(ptr, ptr + len))
-    static basic_json from_msgpack(const T* ptr, std::size_t len,
-                                   const bool strict = true,
-                                   const bool allow_exceptions = true)
-    {
-        return from_msgpack(ptr, ptr + len, strict, allow_exceptions);
-    }
-
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_msgpack(ptr, ptr + len))
-    static basic_json from_msgpack(detail::span_input_adapter&& i,
-                                   const bool strict = true,
-                                   const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = i.get();
-        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::msgpack, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    /// @brief create a JSON value from an input in UBJSON format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_ubjson/
-    template<typename InputType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_ubjson(InputType&& i,
-                                  const bool strict = true,
-                                  const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::forward<InputType>(i));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::ubjson, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    /// @brief create a JSON value from an input in UBJSON format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_ubjson/
-    template<typename IteratorType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_ubjson(IteratorType first, IteratorType last,
-                                  const bool strict = true,
-                                  const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::move(first), std::move(last));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::ubjson, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    template<typename T>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_ubjson(ptr, ptr + len))
-    static basic_json from_ubjson(const T* ptr, std::size_t len,
-                                  const bool strict = true,
-                                  const bool allow_exceptions = true)
-    {
-        return from_ubjson(ptr, ptr + len, strict, allow_exceptions);
-    }
-
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_ubjson(ptr, ptr + len))
-    static basic_json from_ubjson(detail::span_input_adapter&& i,
-                                  const bool strict = true,
-                                  const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = i.get();
-        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::ubjson, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    /// @brief create a JSON value from an input in BSON format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_bson/
-    template<typename InputType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_bson(InputType&& i,
-                                const bool strict = true,
-                                const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::forward<InputType>(i));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::bson, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    /// @brief create a JSON value from an input in BSON format
-    /// @sa https://json.nlohmann.me/api/basic_json/from_bson/
-    template<typename IteratorType>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json from_bson(IteratorType first, IteratorType last,
-                                const bool strict = true,
-                                const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = detail::input_adapter(std::move(first), std::move(last));
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::bson, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-
-    template<typename T>
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_bson(ptr, ptr + len))
-    static basic_json from_bson(const T* ptr, std::size_t len,
-                                const bool strict = true,
-                                const bool allow_exceptions = true)
-    {
-        return from_bson(ptr, ptr + len, strict, allow_exceptions);
-    }
-
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    JSON_HEDLEY_DEPRECATED_FOR(3.8.0, from_bson(ptr, ptr + len))
-    static basic_json from_bson(detail::span_input_adapter&& i,
-                                const bool strict = true,
-                                const bool allow_exceptions = true)
-    {
-        basic_json result;
-        detail::json_sax_dom_parser<basic_json> sdp(result, allow_exceptions);
-        auto ia = i.get();
-        // NOLINTNEXTLINE(hicpp-move-const-arg,performance-move-const-arg)
-        const bool res = binary_reader<decltype(ia)>(std::move(ia)).sax_parse(input_format_t::bson, &sdp, strict);
-        return res ? result : basic_json(value_t::discarded);
-    }
-    /// @}
-
-    //////////////////////////
-    // JSON Pointer support //
-    //////////////////////////
-
-    /// @name JSON Pointer functions
-    /// @{
-
-    /// @brief access specified element via JSON Pointer
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    reference operator[](const json_pointer& ptr)
-    {
-        return ptr.get_unchecked(this);
-    }
-
-    /// @brief access specified element via JSON Pointer
-    /// @sa https://json.nlohmann.me/api/basic_json/operator%5B%5D/
-    const_reference operator[](const json_pointer& ptr) const
-    {
-        return ptr.get_unchecked(this);
-    }
-
-    /// @brief access specified element via JSON Pointer
-    /// @sa https://json.nlohmann.me/api/basic_json/at/
-    reference at(const json_pointer& ptr)
-    {
-        return ptr.get_checked(this);
-    }
-
-    /// @brief access specified element via JSON Pointer
-    /// @sa https://json.nlohmann.me/api/basic_json/at/
-    const_reference at(const json_pointer& ptr) const
-    {
-        return ptr.get_checked(this);
-    }
-
-    /// @brief return flattened JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/flatten/
-    basic_json flatten() const
-    {
-        basic_json result(value_t::object);
-        json_pointer::flatten("", *this, result);
-        return result;
-    }
-
-    /// @brief unflatten a previously flattened JSON value
-    /// @sa https://json.nlohmann.me/api/basic_json/unflatten/
-    basic_json unflatten() const
-    {
-        return json_pointer::unflatten(*this);
-    }
-
-    /// @}
-
-    //////////////////////////
-    // JSON Patch functions //
-    //////////////////////////
-
-    /// @name JSON Patch functions
-    /// @{
-
-    /// @brief applies a JSON patch
-    /// @sa https://json.nlohmann.me/api/basic_json/patch/
-    basic_json patch(const basic_json& json_patch) const
-    {
-        // make a working copy to apply the patch to
-        basic_json result = *this;
-
-        // the valid JSON Patch operations
-        enum class patch_operations {add, remove, replace, move, copy, test, invalid};
-
-        const auto get_op = [](const std::string & op)
-        {
-            if (op == "add")
-            {
-                return patch_operations::add;
-            }
-            if (op == "remove")
-            {
-                return patch_operations::remove;
-            }
-            if (op == "replace")
-            {
-                return patch_operations::replace;
-            }
-            if (op == "move")
-            {
-                return patch_operations::move;
-            }
-            if (op == "copy")
-            {
-                return patch_operations::copy;
-            }
-            if (op == "test")
-            {
-                return patch_operations::test;
-            }
-
-            return patch_operations::invalid;
-        };
-
-        // wrapper for "add" operation; add value at ptr
-        const auto operation_add = [&result](json_pointer & ptr, basic_json val)
-        {
-            // adding to the root of the target document means replacing it
-            if (ptr.empty())
-            {
-                result = val;
-                return;
-            }
-
-            // make sure the top element of the pointer exists
-            json_pointer top_pointer = ptr.top();
-            if (top_pointer != ptr)
-            {
-                result.at(top_pointer);
-            }
-
-            // get reference to parent of JSON pointer ptr
-            const auto last_path = ptr.back();
-            ptr.pop_back();
-            basic_json& parent = result[ptr];
-
-            switch (parent.m_type)
-            {
-                case value_t::null:
-                case value_t::object:
-                {
-                    // use operator[] to add value
-                    parent[last_path] = val;
-                    break;
-                }
-
-                case value_t::array:
-                {
-                    if (last_path == "-")
-                    {
-                        // special case: append to back
-                        parent.push_back(val);
-                    }
-                    else
-                    {
-                        const auto idx = json_pointer::array_index(last_path);
-                        if (JSON_HEDLEY_UNLIKELY(idx > parent.size()))
-                        {
-                            // avoid undefined behavior
-                            JSON_THROW(out_of_range::create(401, "array index " + std::to_string(idx) + " is out of range", parent));
-                        }
-
-                        // default case: insert add offset
-                        parent.insert(parent.begin() + static_cast<difference_type>(idx), val);
-                    }
-                    break;
-                }
-
-                // if there exists a parent it cannot be primitive
-                case value_t::string: // LCOV_EXCL_LINE
-                case value_t::boolean: // LCOV_EXCL_LINE
-                case value_t::number_integer: // LCOV_EXCL_LINE
-                case value_t::number_unsigned: // LCOV_EXCL_LINE
-                case value_t::number_float: // LCOV_EXCL_LINE
-                case value_t::binary: // LCOV_EXCL_LINE
-                case value_t::discarded: // LCOV_EXCL_LINE
-                default:            // LCOV_EXCL_LINE
-                    JSON_ASSERT(false); // NOLINT(cert-dcl03-c,hicpp-static-assert,misc-static-assert) LCOV_EXCL_LINE
-            }
-        };
-
-        // wrapper for "remove" operation; remove value at ptr
-        const auto operation_remove = [this, &result](json_pointer & ptr)
-        {
-            // get reference to parent of JSON pointer ptr
-            const auto last_path = ptr.back();
-            ptr.pop_back();
-            basic_json& parent = result.at(ptr);
-
-            // remove child
-            if (parent.is_object())
-            {
-                // perform range check
-                auto it = parent.find(last_path);
-                if (JSON_HEDLEY_LIKELY(it != parent.end()))
-                {
-                    parent.erase(it);
-                }
-                else
-                {
-                    JSON_THROW(out_of_range::create(403, "key '" + last_path + "' not found", *this));
-                }
-            }
-            else if (parent.is_array())
-            {
-                // note erase performs range check
-                parent.erase(json_pointer::array_index(last_path));
-            }
-        };
-
-        // type check: top level value must be an array
-        if (JSON_HEDLEY_UNLIKELY(!json_patch.is_array()))
-        {
-            JSON_THROW(parse_error::create(104, 0, "JSON patch must be an array of objects", json_patch));
-        }
-
-        // iterate and apply the operations
-        for (const auto& val : json_patch)
-        {
-            // wrapper to get a value for an operation
-            const auto get_value = [&val](const std::string & op,
-                                          const std::string & member,
-                                          bool string_type) -> basic_json &
-            {
-                // find value
-                auto it = val.m_value.object->find(member);
-
-                // context-sensitive error message
-                const auto error_msg = (op == "op") ? "operation" : "operation '" + op + "'";
-
-                // check if desired value is present
-                if (JSON_HEDLEY_UNLIKELY(it == val.m_value.object->end()))
-                {
-                    // NOLINTNEXTLINE(performance-inefficient-string-concatenation)
-                    JSON_THROW(parse_error::create(105, 0, error_msg + " must have member '" + member + "'", val));
-                }
-
-                // check if result is of type string
-                if (JSON_HEDLEY_UNLIKELY(string_type && !it->second.is_string()))
-                {
-                    // NOLINTNEXTLINE(performance-inefficient-string-concatenation)
-                    JSON_THROW(parse_error::create(105, 0, error_msg + " must have string member '" + member + "'", val));
-                }
-
-                // no error: return value
-                return it->second;
-            };
-
-            // type check: every element of the array must be an object
-            if (JSON_HEDLEY_UNLIKELY(!val.is_object()))
-            {
-                JSON_THROW(parse_error::create(104, 0, "JSON patch must be an array of objects", val));
-            }
-
-            // collect mandatory members
-            const auto op = get_value("op", "op", true).template get<std::string>();
-            const auto path = get_value(op, "path", true).template get<std::string>();
-            json_pointer ptr(path);
-
-            switch (get_op(op))
-            {
-                case patch_operations::add:
-                {
-                    operation_add(ptr, get_value("add", "value", false));
-                    break;
-                }
-
-                case patch_operations::remove:
-                {
-                    operation_remove(ptr);
-                    break;
-                }
-
-                case patch_operations::replace:
-                {
-                    // the "path" location must exist - use at()
-                    result.at(ptr) = get_value("replace", "value", false);
-                    break;
-                }
-
-                case patch_operations::move:
-                {
-                    const auto from_path = get_value("move", "from", true).template get<std::string>();
-                    json_pointer from_ptr(from_path);
-
-                    // the "from" location must exist - use at()
-                    basic_json v = result.at(from_ptr);
-
-                    // The move operation is functionally identical to a
-                    // "remove" operation on the "from" location, followed
-                    // immediately by an "add" operation at the target
-                    // location with the value that was just removed.
-                    operation_remove(from_ptr);
-                    operation_add(ptr, v);
-                    break;
-                }
-
-                case patch_operations::copy:
-                {
-                    const auto from_path = get_value("copy", "from", true).template get<std::string>();
-                    const json_pointer from_ptr(from_path);
-
-                    // the "from" location must exist - use at()
-                    basic_json v = result.at(from_ptr);
-
-                    // The copy is functionally identical to an "add"
-                    // operation at the target location using the value
-                    // specified in the "from" member.
-                    operation_add(ptr, v);
-                    break;
-                }
-
-                case patch_operations::test:
-                {
-                    bool success = false;
-                    JSON_TRY
-                    {
-                        // check if "value" matches the one at "path"
-                        // the "path" location must exist - use at()
-                        success = (result.at(ptr) == get_value("test", "value", false));
-                    }
-                    JSON_INTERNAL_CATCH (out_of_range&)
-                    {
-                        // ignore out of range errors: success remains false
-                    }
-
-                    // throw an exception if test fails
-                    if (JSON_HEDLEY_UNLIKELY(!success))
-                    {
-                        JSON_THROW(other_error::create(501, "unsuccessful: " + val.dump(), val));
-                    }
-
-                    break;
-                }
-
-                case patch_operations::invalid:
-                default:
-                {
-                    // op must be "add", "remove", "replace", "move", "copy", or
-                    // "test"
-                    JSON_THROW(parse_error::create(105, 0, "operation value '" + op + "' is invalid", val));
-                }
-            }
-        }
-
-        return result;
-    }
-
-    /// @brief creates a diff as a JSON patch
-    /// @sa https://json.nlohmann.me/api/basic_json/diff/
-    JSON_HEDLEY_WARN_UNUSED_RESULT
-    static basic_json diff(const basic_json& source, const basic_json& target,
-                           const std::string& path = "")
-    {
-        // the patch
-        basic_json result(value_t::array);
-
-        // if the values are the same, return empty patch
-        if (source == target)
-        {
-            return result;
-        }
-
-        if (source.type() != target.type())
-        {
-            // different types: replace value
-            result.push_back(
-            {
-                {"op", "replace"}, {"path", path}, {"value", target}
-            });
-            return result;
-        }
-
-        switch (source.type())
-        {
-            case value_t::array:
-            {
-                // first pass: traverse common elements
-                std::size_t i = 0;
-                while (i < source.size() && i < target.size())
-                {
-                    // recursive call to compare array values at index i
-                    auto temp_diff = diff(source[i], target[i], path + "/" + std::to_string(i));
-                    result.insert(result.end(), temp_diff.begin(), temp_diff.end());
-                    ++i;
-                }
-
-                // We now reached the end of at least one array
-                // in a second pass, traverse the remaining elements
-
-                // remove my remaining elements
-                const auto end_index = static_cast<difference_type>(result.size());
-                while (i < source.size())
-                {
-                    // add operations in reverse order to avoid invalid
-                    // indices
-                    result.insert(result.begin() + end_index, object(
-                    {
-                        {"op", "remove"},
-                        {"path", path + "/" + std::to_string(i)}
-                    }));
-                    ++i;
-                }
-
-                // add other remaining elements
-                while (i < target.size())
-                {
-                    result.push_back(
-                    {
-                        {"op", "add"},
-                        {"path", path + "/-"},
-                        {"value", target[i]}
-                    });
-                    ++i;
-                }
-
-                break;
-            }
-
-            case value_t::object:
-            {
-                // first pass: traverse this object's elements
-                for (auto it = source.cbegin(); it != source.cend(); ++it)
-                {
-                    // escape the key name to be used in a JSON patch
-                    const auto path_key = path + "/" + detail::escape(it.key());
-
-                    if (target.find(it.key()) != target.end())
-                    {
-                        // recursive call to compare object values at key it
-                        auto temp_diff = diff(it.value(), target[it.key()], path_key);
-                        result.insert(result.end(), temp_diff.begin(), temp_diff.end());
-                    }
-                    else
-                    {
-                        // found a key that is not in o -> remove it
-                        result.push_back(object(
-                        {
-                            {"op", "remove"}, {"path", path_key}
-                        }));
-                    }
-                }
-
-                // second pass: traverse other object's elements
-                for (auto it = target.cbegin(); it != target.cend(); ++it)
-                {
-                    if (source.find(it.key()) == source.end())
-                    {
-                        // found a key that is not in this -> add it
-                        const auto path_key = path + "/" + detail::escape(it.key());
-                        result.push_back(
-                        {
-                            {"op", "add"}, {"path", path_key},
-                            {"value", it.value()}
-                        });
-                    }
-                }
-
-                break;
-            }
-
-            case value_t::null:
-            case value_t::string:
-            case value_t::boolean:
-            case value_t::number_integer:
-            case value_t::number_unsigned:
-            case value_t::number_float:
-            case value_t::binary:
-            case value_t::discarded:
-            default:
-            {
-                // both primitive type: replace value
-                result.push_back(
-                {
-                    {"op", "replace"}, {"path", path}, {"value", target}
-                });
-                break;
-            }
-        }
-
-        return result;
-    }
-
-    /// @}
-
-    ////////////////////////////////
-    // JSON Merge Patch functions //
-    ////////////////////////////////
-
-    /// @name JSON Merge Patch functions
-    /// @{
-
-    /// @brief applies a JSON Merge Patch
-    /// @sa https://json.nlohmann.me/api/basic_json/merge_patch/
-    void merge_patch(const basic_json& apply_patch)
-    {
-        if (apply_patch.is_object())
-        {
-            if (!is_object())
-            {
-                *this = object();
-            }
-            for (auto it = apply_patch.begin(); it != apply_patch.end(); ++it)
-            {
-                if (it.value().is_null())
-                {
-                    erase(it.key());
-                }
-                else
-                {
-                    operator[](it.key()).merge_patch(it.value());
-                }
-            }
-        }
-        else
-        {
-            *this = apply_patch;
-        }
-    }
-
-    /// @}
-};
-
-/// @brief user-defined to_string function for JSON values
-/// @sa https://json.nlohmann.me/api/basic_json/to_string/
-NLOHMANN_BASIC_JSON_TPL_DECLARATION
-std::string to_string(const NLOHMANN_BASIC_JSON_TPL& j)
-{
-    return j.dump();
-}
-
-} // namespace nlohmann
-
-///////////////////////
-// nonmember support //
-///////////////////////
-
-namespace std // NOLINT(cert-dcl58-cpp)
-{
-
-/// @brief hash value for JSON objects
-/// @sa https://json.nlohmann.me/api/basic_json/std_hash/
-NLOHMANN_BASIC_JSON_TPL_DECLARATION
-struct hash<nlohmann::NLOHMANN_BASIC_JSON_TPL>
-{
-    std::size_t operator()(const nlohmann::NLOHMANN_BASIC_JSON_TPL& j) const
-    {
-        return nlohmann::detail::hash(j);
-    }
-};
-
-// specialization for std::less<value_t>
-template<>
-struct less< ::nlohmann::detail::value_t> // do not remove the space after '<', see https://github.com/nlohmann/json/pull/679
-{
-    /*!
-    @brief compare two value_t enum values
-    @since version 3.0.0
-    */
-    bool operator()(nlohmann::detail::value_t lhs,
-                    nlohmann::detail::value_t rhs) const noexcept
-    {
-        return nlohmann::detail::operator<(lhs, rhs);
-    }
-};
-
-// C++20 prohibit function specialization in the std namespace.
-#ifndef JSON_HAS_CPP_20
-
-/// @brief exchanges the values of two JSON objects
-/// @sa https://json.nlohmann.me/api/basic_json/std_swap/
-NLOHMANN_BASIC_JSON_TPL_DECLARATION
-inline void swap(nlohmann::NLOHMANN_BASIC_JSON_TPL& j1, nlohmann::NLOHMANN_BASIC_JSON_TPL& j2) noexcept(  // NOLINT(readability-inconsistent-declaration-parameter-name)
-    is_nothrow_move_constructible<nlohmann::NLOHMANN_BASIC_JSON_TPL>::value&&                          // NOLINT(misc-redundant-expression)
-    is_nothrow_move_assignable<nlohmann::NLOHMANN_BASIC_JSON_TPL>::value)
-{
-    j1.swap(j2);
-}
-
-#endif
-
-} // namespace std
-
-/// @brief user-defined string literal for JSON values
-/// @sa https://json.nlohmann.me/api/basic_json/operator_literal_json/
-JSON_HEDLEY_NON_NULL(1)
-inline nlohmann::json operator "" _json(const char* s, std::size_t n)
-{
-    return nlohmann::json::parse(s, s + n);
-}
-
-/// @brief user-defined string literal for JSON pointer
-/// @sa https://json.nlohmann.me/api/basic_json/operator_literal_json_pointer/
-JSON_HEDLEY_NON_NULL(1)
-inline nlohmann::json::json_pointer operator "" _json_pointer(const char* s, std::size_t n)
-{
-    return nlohmann::json::json_pointer(std::string(s, n));
-}
-
-// #include <nlohmann/detail/macro_unscope.hpp>
-
-
-// restore clang diagnostic settings
-#if defined(__clang__)
-    #pragma clang diagnostic pop
-#endif
-
-// clean up
-#undef JSON_ASSERT
-#undef JSON_INTERNAL_CATCH
-#undef JSON_CATCH
-#undef JSON_THROW
-#undef JSON_TRY
-#undef JSON_PRIVATE_UNLESS_TESTED
-#undef JSON_HAS_CPP_11
-#undef JSON_HAS_CPP_14
-#undef JSON_HAS_CPP_17
-#undef JSON_HAS_CPP_20
-#undef JSON_HAS_FILESYSTEM
-#undef JSON_HAS_EXPERIMENTAL_FILESYSTEM
-#undef NLOHMANN_BASIC_JSON_TPL_DECLARATION
-#undef NLOHMANN_BASIC_JSON_TPL
-#undef JSON_EXPLICIT
-#undef NLOHMANN_CAN_CALL_STD_FUNC_IMPL
-
-// #include <nlohmann/thirdparty/hedley/hedley_undef.hpp>
-
-
-#undef JSON_HEDLEY_ALWAYS_INLINE
-#undef JSON_HEDLEY_ARM_VERSION
-#undef JSON_HEDLEY_ARM_VERSION_CHECK
-#undef JSON_HEDLEY_ARRAY_PARAM
-#undef JSON_HEDLEY_ASSUME
-#undef JSON_HEDLEY_BEGIN_C_DECLS
-#undef JSON_HEDLEY_CLANG_HAS_ATTRIBUTE
-#undef JSON_HEDLEY_CLANG_HAS_BUILTIN
-#undef JSON_HEDLEY_CLANG_HAS_CPP_ATTRIBUTE
-#undef JSON_HEDLEY_CLANG_HAS_DECLSPEC_DECLSPEC_ATTRIBUTE
-#undef JSON_HEDLEY_CLANG_HAS_EXTENSION
-#undef JSON_HEDLEY_CLANG_HAS_FEATURE
-#undef JSON_HEDLEY_CLANG_HAS_WARNING
-#undef JSON_HEDLEY_COMPCERT_VERSION
-#undef JSON_HEDLEY_COMPCERT_VERSION_CHECK
-#undef JSON_HEDLEY_CONCAT
-#undef JSON_HEDLEY_CONCAT3
-#undef JSON_HEDLEY_CONCAT3_EX
-#undef JSON_HEDLEY_CONCAT_EX
-#undef JSON_HEDLEY_CONST
-#undef JSON_HEDLEY_CONSTEXPR
-#undef JSON_HEDLEY_CONST_CAST
-#undef JSON_HEDLEY_CPP_CAST
-#undef JSON_HEDLEY_CRAY_VERSION
-#undef JSON_HEDLEY_CRAY_VERSION_CHECK
-#undef JSON_HEDLEY_C_DECL
-#undef JSON_HEDLEY_DEPRECATED
-#undef JSON_HEDLEY_DEPRECATED_FOR
-#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CAST_QUAL
-#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_CPP98_COMPAT_WRAP_
-#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_DEPRECATED
-#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_CPP_ATTRIBUTES
-#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNKNOWN_PRAGMAS
-#undef JSON_HEDLEY_DIAGNOSTIC_DISABLE_UNUSED_FUNCTION
-#undef JSON_HEDLEY_DIAGNOSTIC_POP
-#undef JSON_HEDLEY_DIAGNOSTIC_PUSH
-#undef JSON_HEDLEY_DMC_VERSION
-#undef JSON_HEDLEY_DMC_VERSION_CHECK
-#undef JSON_HEDLEY_EMPTY_BASES
-#undef JSON_HEDLEY_EMSCRIPTEN_VERSION
-#undef JSON_HEDLEY_EMSCRIPTEN_VERSION_CHECK
-#undef JSON_HEDLEY_END_C_DECLS
-#undef JSON_HEDLEY_FLAGS
-#undef JSON_HEDLEY_FLAGS_CAST
-#undef JSON_HEDLEY_GCC_HAS_ATTRIBUTE
-#undef JSON_HEDLEY_GCC_HAS_BUILTIN
-#undef JSON_HEDLEY_GCC_HAS_CPP_ATTRIBUTE
-#undef JSON_HEDLEY_GCC_HAS_DECLSPEC_ATTRIBUTE
-#undef JSON_HEDLEY_GCC_HAS_EXTENSION
-#undef JSON_HEDLEY_GCC_HAS_FEATURE
-#undef JSON_HEDLEY_GCC_HAS_WARNING
-#undef JSON_HEDLEY_GCC_NOT_CLANG_VERSION_CHECK
-#undef JSON_HEDLEY_GCC_VERSION
-#undef JSON_HEDLEY_GCC_VERSION_CHECK
-#undef JSON_HEDLEY_GNUC_HAS_ATTRIBUTE
-#undef JSON_HEDLEY_GNUC_HAS_BUILTIN
-#undef JSON_HEDLEY_GNUC_HAS_CPP_ATTRIBUTE
-#undef JSON_HEDLEY_GNUC_HAS_DECLSPEC_ATTRIBUTE
-#undef JSON_HEDLEY_GNUC_HAS_EXTENSION
-#undef JSON_HEDLEY_GNUC_HAS_FEATURE
-#undef JSON_HEDLEY_GNUC_HAS_WARNING
-#undef JSON_HEDLEY_GNUC_VERSION
-#undef JSON_HEDLEY_GNUC_VERSION_CHECK
-#undef JSON_HEDLEY_HAS_ATTRIBUTE
-#undef JSON_HEDLEY_HAS_BUILTIN
-#undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE
-#undef JSON_HEDLEY_HAS_CPP_ATTRIBUTE_NS
-#undef JSON_HEDLEY_HAS_DECLSPEC_ATTRIBUTE
-#undef JSON_HEDLEY_HAS_EXTENSION
-#undef JSON_HEDLEY_HAS_FEATURE
-#undef JSON_HEDLEY_HAS_WARNING
-#undef JSON_HEDLEY_IAR_VERSION
-#undef JSON_HEDLEY_IAR_VERSION_CHECK
-#undef JSON_HEDLEY_IBM_VERSION
-#undef JSON_HEDLEY_IBM_VERSION_CHECK
-#undef JSON_HEDLEY_IMPORT
-#undef JSON_HEDLEY_INLINE
-#undef JSON_HEDLEY_INTEL_CL_VERSION
-#undef JSON_HEDLEY_INTEL_CL_VERSION_CHECK
-#undef JSON_HEDLEY_INTEL_VERSION
-#undef JSON_HEDLEY_INTEL_VERSION_CHECK
-#undef JSON_HEDLEY_IS_CONSTANT
-#undef JSON_HEDLEY_IS_CONSTEXPR_
-#undef JSON_HEDLEY_LIKELY
-#undef JSON_HEDLEY_MALLOC
-#undef JSON_HEDLEY_MCST_LCC_VERSION
-#undef JSON_HEDLEY_MCST_LCC_VERSION_CHECK
-#undef JSON_HEDLEY_MESSAGE
-#undef JSON_HEDLEY_MSVC_VERSION
-#undef JSON_HEDLEY_MSVC_VERSION_CHECK
-#undef JSON_HEDLEY_NEVER_INLINE
-#undef JSON_HEDLEY_NON_NULL
-#undef JSON_HEDLEY_NO_ESCAPE
-#undef JSON_HEDLEY_NO_RETURN
-#undef JSON_HEDLEY_NO_THROW
-#undef JSON_HEDLEY_NULL
-#undef JSON_HEDLEY_PELLES_VERSION
-#undef JSON_HEDLEY_PELLES_VERSION_CHECK
-#undef JSON_HEDLEY_PGI_VERSION
-#undef JSON_HEDLEY_PGI_VERSION_CHECK
-#undef JSON_HEDLEY_PREDICT
-#undef JSON_HEDLEY_PRINTF_FORMAT
-#undef JSON_HEDLEY_PRIVATE
-#undef JSON_HEDLEY_PUBLIC
-#undef JSON_HEDLEY_PURE
-#undef JSON_HEDLEY_REINTERPRET_CAST
-#undef JSON_HEDLEY_REQUIRE
-#undef JSON_HEDLEY_REQUIRE_CONSTEXPR
-#undef JSON_HEDLEY_REQUIRE_MSG
-#undef JSON_HEDLEY_RESTRICT
-#undef JSON_HEDLEY_RETURNS_NON_NULL
-#undef JSON_HEDLEY_SENTINEL
-#undef JSON_HEDLEY_STATIC_ASSERT
-#undef JSON_HEDLEY_STATIC_CAST
-#undef JSON_HEDLEY_STRINGIFY
-#undef JSON_HEDLEY_STRINGIFY_EX
-#undef JSON_HEDLEY_SUNPRO_VERSION
-#undef JSON_HEDLEY_SUNPRO_VERSION_CHECK
-#undef JSON_HEDLEY_TINYC_VERSION
-#undef JSON_HEDLEY_TINYC_VERSION_CHECK
-#undef JSON_HEDLEY_TI_ARMCL_VERSION
-#undef JSON_HEDLEY_TI_ARMCL_VERSION_CHECK
-#undef JSON_HEDLEY_TI_CL2000_VERSION
-#undef JSON_HEDLEY_TI_CL2000_VERSION_CHECK
-#undef JSON_HEDLEY_TI_CL430_VERSION
-#undef JSON_HEDLEY_TI_CL430_VERSION_CHECK
-#undef JSON_HEDLEY_TI_CL6X_VERSION
-#undef JSON_HEDLEY_TI_CL6X_VERSION_CHECK
-#undef JSON_HEDLEY_TI_CL7X_VERSION
-#undef JSON_HEDLEY_TI_CL7X_VERSION_CHECK
-#undef JSON_HEDLEY_TI_CLPRU_VERSION
-#undef JSON_HEDLEY_TI_CLPRU_VERSION_CHECK
-#undef JSON_HEDLEY_TI_VERSION
-#undef JSON_HEDLEY_TI_VERSION_CHECK
-#undef JSON_HEDLEY_UNAVAILABLE
-#undef JSON_HEDLEY_UNLIKELY
-#undef JSON_HEDLEY_UNPREDICTABLE
-#undef JSON_HEDLEY_UNREACHABLE
-#undef JSON_HEDLEY_UNREACHABLE_RETURN
-#undef JSON_HEDLEY_VERSION
-#undef JSON_HEDLEY_VERSION_DECODE_MAJOR
-#undef JSON_HEDLEY_VERSION_DECODE_MINOR
-#undef JSON_HEDLEY_VERSION_DECODE_REVISION
-#undef JSON_HEDLEY_VERSION_ENCODE
-#undef JSON_HEDLEY_WARNING
-#undef JSON_HEDLEY_WARN_UNUSED_RESULT
-#undef JSON_HEDLEY_WARN_UNUSED_RESULT_MSG
-#undef JSON_HEDLEY_FALL_THROUGH
-
-
-
-#endif  // INCLUDE_NLOHMANN_JSON_HPP_
diff -pruN 8.0.1-5/third-party/pantor/inja.hpp 8.2.0~beta1-1~exp1/third-party/pantor/inja.hpp
--- 8.0.1-5/third-party/pantor/inja.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/third-party/pantor/inja.hpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,4470 +0,0 @@
-/*
-  ___        _          Version 3.3
- |_ _|_ __  (_) __ _    https://github.com/pantor/inja
-  | || '_ \ | |/ _` |   Licensed under the MIT License <http://opensource.org/licenses/MIT>.
-  | || | | || | (_| |
- |___|_| |_|/ |\__,_|   Copyright (c) 2018-2021 Lars Berscheid
-          |__/       
-Permission is hereby granted, free of charge, to any person obtaining a copy
-of this software and associated documentation files (the "Software"), to deal
-in the Software without restriction, including without limitation the rights
-to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-copies of the Software, and to permit persons to whom the Software is
-furnished to do so, subject to the following conditions:
-The above copyright notice and this permission notice shall be included in all
-copies or substantial portions of the Software.
-THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
-IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
-AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
-OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
-SOFTWARE.
-*/
-
-#ifndef INCLUDE_INJA_INJA_HPP_
-#define INCLUDE_INJA_INJA_HPP_
-
-#include "../nlohmann/json.hpp" // <nlohmann/json.hpp>
-
-namespace inja {
-#ifndef INJA_DATA_TYPE
-  using json = nlohmann::json;
-#else
-  using json = INJA_DATA_TYPE;
-#endif
-}
-
-#if (defined(__cpp_exceptions) || defined(__EXCEPTIONS) || defined(_CPPUNWIND)) && !defined(INJA_NOEXCEPTION)
-  #ifndef INJA_THROW
-    #define INJA_THROW(exception) throw exception
-  #endif
-#else
-  #include <cstdlib>
-  #ifndef INJA_THROW
-    #define INJA_THROW(exception) std::abort(); std::ignore = exception
-  #endif
-  #ifndef INJA_NOEXCEPTION
-    #define INJA_NOEXCEPTION
-  #endif
-#endif
-
-// #include "environment.hpp"
-#ifndef INCLUDE_INJA_ENVIRONMENT_HPP_
-#define INCLUDE_INJA_ENVIRONMENT_HPP_
-
-#include <fstream>
-#include <iostream>
-#include <memory>
-#include <sstream>
-#include <string>
-
-// #include "config.hpp"
-#ifndef INCLUDE_INJA_CONFIG_HPP_
-#define INCLUDE_INJA_CONFIG_HPP_
-
-#include <functional>
-#include <string>
-
-// #include "string_view.hpp"
-// Copyright 2017-2019 by Martin Moene
-//
-// string-view lite, a C++17-like string_view for C++98 and later.
-// For more information see https://github.com/martinmoene/string-view-lite
-//
-// Distributed under the Boost Software License, Version 1.0.
-// (See accompanying file LICENSE.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
-
-
-
-#ifndef NONSTD_SV_LITE_H_INCLUDED
-#define NONSTD_SV_LITE_H_INCLUDED
-
-#define string_view_lite_MAJOR 1
-#define string_view_lite_MINOR 4
-#define string_view_lite_PATCH 0
-
-#define string_view_lite_VERSION                                                                                       \
-  nssv_STRINGIFY(string_view_lite_MAJOR) "." nssv_STRINGIFY(string_view_lite_MINOR) "." nssv_STRINGIFY(                \
-      string_view_lite_PATCH)
-
-#define nssv_STRINGIFY(x) nssv_STRINGIFY_(x)
-#define nssv_STRINGIFY_(x) #x
-
-// string-view lite configuration:
-
-#define nssv_STRING_VIEW_DEFAULT 0
-#define nssv_STRING_VIEW_NONSTD 1
-#define nssv_STRING_VIEW_STD 2
-
-#if !defined(nssv_CONFIG_SELECT_STRING_VIEW)
-#define nssv_CONFIG_SELECT_STRING_VIEW (nssv_HAVE_STD_STRING_VIEW ? nssv_STRING_VIEW_STD : nssv_STRING_VIEW_NONSTD)
-#endif
-
-#if defined(nssv_CONFIG_SELECT_STD_STRING_VIEW) || defined(nssv_CONFIG_SELECT_NONSTD_STRING_VIEW)
-#error nssv_CONFIG_SELECT_STD_STRING_VIEW and nssv_CONFIG_SELECT_NONSTD_STRING_VIEW are deprecated and removed, please use nssv_CONFIG_SELECT_STRING_VIEW=nssv_STRING_VIEW_...
-#endif
-
-#ifndef nssv_CONFIG_STD_SV_OPERATOR
-#define nssv_CONFIG_STD_SV_OPERATOR 0
-#endif
-
-#ifndef nssv_CONFIG_USR_SV_OPERATOR
-#define nssv_CONFIG_USR_SV_OPERATOR 1
-#endif
-
-#ifdef nssv_CONFIG_CONVERSION_STD_STRING
-#define nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS nssv_CONFIG_CONVERSION_STD_STRING
-#define nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS nssv_CONFIG_CONVERSION_STD_STRING
-#endif
-
-#ifndef nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS
-#define nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS 1
-#endif
-
-#ifndef nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
-#define nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS 1
-#endif
-
-// Control presence of exception handling (try and auto discover):
-
-#ifndef nssv_CONFIG_NO_EXCEPTIONS
-#if defined(__cpp_exceptions) || defined(__EXCEPTIONS) || defined(_CPPUNWIND)
-#define nssv_CONFIG_NO_EXCEPTIONS 0
-#else
-#define nssv_CONFIG_NO_EXCEPTIONS 1
-#endif
-#endif
-
-// C++ language version detection (C++20 is speculative):
-// Note: VC14.0/1900 (VS2015) lacks too much from C++14.
-
-#ifndef nssv_CPLUSPLUS
-#if defined(_MSVC_LANG) && !defined(__clang__)
-#define nssv_CPLUSPLUS (_MSC_VER == 1900 ? 201103L : _MSVC_LANG)
-#else
-#define nssv_CPLUSPLUS __cplusplus
-#endif
-#endif
-
-#define nssv_CPP98_OR_GREATER (nssv_CPLUSPLUS >= 199711L)
-#define nssv_CPP11_OR_GREATER (nssv_CPLUSPLUS >= 201103L)
-#define nssv_CPP11_OR_GREATER_ (nssv_CPLUSPLUS >= 201103L)
-#define nssv_CPP14_OR_GREATER (nssv_CPLUSPLUS >= 201402L)
-#define nssv_CPP17_OR_GREATER (nssv_CPLUSPLUS >= 201703L)
-#define nssv_CPP20_OR_GREATER (nssv_CPLUSPLUS >= 202000L)
-
-// use C++17 std::string_view if available and requested:
-
-#if nssv_CPP17_OR_GREATER && defined(__has_include)
-#if __has_include(<string_view> )
-#define nssv_HAVE_STD_STRING_VIEW 1
-#else
-#define nssv_HAVE_STD_STRING_VIEW 0
-#endif
-#else
-#define nssv_HAVE_STD_STRING_VIEW 0
-#endif
-
-#define nssv_USES_STD_STRING_VIEW                                                                                      \
-  ((nssv_CONFIG_SELECT_STRING_VIEW == nssv_STRING_VIEW_STD) ||                                                         \
-   ((nssv_CONFIG_SELECT_STRING_VIEW == nssv_STRING_VIEW_DEFAULT) && nssv_HAVE_STD_STRING_VIEW))
-
-#define nssv_HAVE_STARTS_WITH (nssv_CPP20_OR_GREATER || !nssv_USES_STD_STRING_VIEW)
-#define nssv_HAVE_ENDS_WITH nssv_HAVE_STARTS_WITH
-
-//
-// Use C++17 std::string_view:
-//
-
-#if nssv_USES_STD_STRING_VIEW
-
-#include <string_view>
-
-// Extensions for std::string:
-
-#if nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
-
-namespace nonstd {
-
-template <class CharT, class Traits, class Allocator = std::allocator<CharT>>
-std::basic_string<CharT, Traits, Allocator> to_string(std::basic_string_view<CharT, Traits> v,
-                                                      Allocator const &a = Allocator()) {
-  return std::basic_string<CharT, Traits, Allocator>(v.begin(), v.end(), a);
-}
-
-template <class CharT, class Traits, class Allocator>
-std::basic_string_view<CharT, Traits> to_string_view(std::basic_string<CharT, Traits, Allocator> const &s) {
-  return std::basic_string_view<CharT, Traits>(s.data(), s.size());
-}
-
-// Literal operators sv and _sv:
-
-#if nssv_CONFIG_STD_SV_OPERATOR
-
-using namespace std::literals::string_view_literals;
-
-#endif
-
-#if nssv_CONFIG_USR_SV_OPERATOR
-
-inline namespace literals {
-inline namespace string_view_literals {
-
-constexpr std::string_view operator"" _sv(const char *str, size_t len) noexcept // (1)
-{
-  return std::string_view {str, len};
-}
-
-constexpr std::u16string_view operator"" _sv(const char16_t *str, size_t len) noexcept // (2)
-{
-  return std::u16string_view {str, len};
-}
-
-constexpr std::u32string_view operator"" _sv(const char32_t *str, size_t len) noexcept // (3)
-{
-  return std::u32string_view {str, len};
-}
-
-constexpr std::wstring_view operator"" _sv(const wchar_t *str, size_t len) noexcept // (4)
-{
-  return std::wstring_view {str, len};
-}
-
-} // namespace string_view_literals
-} // namespace literals
-
-#endif // nssv_CONFIG_USR_SV_OPERATOR
-
-} // namespace nonstd
-
-#endif // nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
-
-namespace nonstd {
-
-using std::basic_string_view;
-using std::string_view;
-using std::u16string_view;
-using std::u32string_view;
-using std::wstring_view;
-
-// literal "sv" and "_sv", see above
-
-using std::operator==;
-using std::operator!=;
-using std::operator<;
-using std::operator<=;
-using std::operator>;
-using std::operator>=;
-
-using std::operator<<;
-
-} // namespace nonstd
-
-#else // nssv_HAVE_STD_STRING_VIEW
-
-//
-// Before C++17: use string_view lite:
-//
-
-// Compiler versions:
-//
-// MSVC++ 6.0  _MSC_VER == 1200 (Visual Studio 6.0)
-// MSVC++ 7.0  _MSC_VER == 1300 (Visual Studio .NET 2002)
-// MSVC++ 7.1  _MSC_VER == 1310 (Visual Studio .NET 2003)
-// MSVC++ 8.0  _MSC_VER == 1400 (Visual Studio 2005)
-// MSVC++ 9.0  _MSC_VER == 1500 (Visual Studio 2008)
-// MSVC++ 10.0 _MSC_VER == 1600 (Visual Studio 2010)
-// MSVC++ 11.0 _MSC_VER == 1700 (Visual Studio 2012)
-// MSVC++ 12.0 _MSC_VER == 1800 (Visual Studio 2013)
-// MSVC++ 14.0 _MSC_VER == 1900 (Visual Studio 2015)
-// MSVC++ 14.1 _MSC_VER >= 1910 (Visual Studio 2017)
-
-#if defined(_MSC_VER) && !defined(__clang__)
-#define nssv_COMPILER_MSVC_VER (_MSC_VER)
-#define nssv_COMPILER_MSVC_VERSION (_MSC_VER / 10 - 10 * (5 + (_MSC_VER < 1900)))
-#else
-#define nssv_COMPILER_MSVC_VER 0
-#define nssv_COMPILER_MSVC_VERSION 0
-#endif
-
-#define nssv_COMPILER_VERSION(major, minor, patch) (10 * (10 * (major) + (minor)) + (patch))
-
-#if defined(__clang__)
-#define nssv_COMPILER_CLANG_VERSION nssv_COMPILER_VERSION(__clang_major__, __clang_minor__, __clang_patchlevel__)
-#else
-#define nssv_COMPILER_CLANG_VERSION 0
-#endif
-
-#if defined(__GNUC__) && !defined(__clang__)
-#define nssv_COMPILER_GNUC_VERSION nssv_COMPILER_VERSION(__GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__)
-#else
-#define nssv_COMPILER_GNUC_VERSION 0
-#endif
-
-// half-open range [lo..hi):
-#define nssv_BETWEEN(v, lo, hi) ((lo) <= (v) && (v) < (hi))
-
-// Presence of language and library features:
-
-#ifdef _HAS_CPP0X
-#define nssv_HAS_CPP0X _HAS_CPP0X
-#else
-#define nssv_HAS_CPP0X 0
-#endif
-
-// Unless defined otherwise below, consider VC14 as C++11 for variant-lite:
-
-#if nssv_COMPILER_MSVC_VER >= 1900
-#undef nssv_CPP11_OR_GREATER
-#define nssv_CPP11_OR_GREATER 1
-#endif
-
-#define nssv_CPP11_90 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1500)
-#define nssv_CPP11_100 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1600)
-#define nssv_CPP11_110 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1700)
-#define nssv_CPP11_120 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1800)
-#define nssv_CPP11_140 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1900)
-#define nssv_CPP11_141 (nssv_CPP11_OR_GREATER_ || nssv_COMPILER_MSVC_VER >= 1910)
-
-#define nssv_CPP14_000 (nssv_CPP14_OR_GREATER)
-#define nssv_CPP17_000 (nssv_CPP17_OR_GREATER)
-
-// Presence of C++11 language features:
-
-#define nssv_HAVE_CONSTEXPR_11 nssv_CPP11_140
-#define nssv_HAVE_EXPLICIT_CONVERSION nssv_CPP11_140
-#define nssv_HAVE_INLINE_NAMESPACE nssv_CPP11_140
-#define nssv_HAVE_NOEXCEPT nssv_CPP11_140
-#define nssv_HAVE_NULLPTR nssv_CPP11_100
-#define nssv_HAVE_REF_QUALIFIER nssv_CPP11_140
-#define nssv_HAVE_UNICODE_LITERALS nssv_CPP11_140
-#define nssv_HAVE_USER_DEFINED_LITERALS nssv_CPP11_140
-#define nssv_HAVE_WCHAR16_T nssv_CPP11_100
-#define nssv_HAVE_WCHAR32_T nssv_CPP11_100
-
-#if !((nssv_CPP11_OR_GREATER && nssv_COMPILER_CLANG_VERSION) || nssv_BETWEEN(nssv_COMPILER_CLANG_VERSION, 300, 400))
-#define nssv_HAVE_STD_DEFINED_LITERALS nssv_CPP11_140
-#else
-#define nssv_HAVE_STD_DEFINED_LITERALS 0
-#endif
-
-// Presence of C++14 language features:
-
-#define nssv_HAVE_CONSTEXPR_14 nssv_CPP14_000
-
-// Presence of C++17 language features:
-
-#define nssv_HAVE_NODISCARD nssv_CPP17_000
-
-// Presence of C++ library features:
-
-#define nssv_HAVE_STD_HASH nssv_CPP11_120
-
-// C++ feature usage:
-
-#if nssv_HAVE_CONSTEXPR_11
-#define nssv_constexpr constexpr
-#else
-#define nssv_constexpr /*constexpr*/
-#endif
-
-#if nssv_HAVE_CONSTEXPR_14
-#define nssv_constexpr14 constexpr
-#else
-#define nssv_constexpr14 /*constexpr*/
-#endif
-
-#if nssv_HAVE_EXPLICIT_CONVERSION
-#define nssv_explicit explicit
-#else
-#define nssv_explicit /*explicit*/
-#endif
-
-#if nssv_HAVE_INLINE_NAMESPACE
-#define nssv_inline_ns inline
-#else
-#define nssv_inline_ns /*inline*/
-#endif
-
-#if nssv_HAVE_NOEXCEPT
-#define nssv_noexcept noexcept
-#else
-#define nssv_noexcept /*noexcept*/
-#endif
-
-//#if nssv_HAVE_REF_QUALIFIER
-//# define nssv_ref_qual  &
-//# define nssv_refref_qual  &&
-//#else
-//# define nssv_ref_qual  /*&*/
-//# define nssv_refref_qual  /*&&*/
-//#endif
-
-#if nssv_HAVE_NULLPTR
-#define nssv_nullptr nullptr
-#else
-#define nssv_nullptr NULL
-#endif
-
-#if nssv_HAVE_NODISCARD
-#define nssv_nodiscard [[nodiscard]]
-#else
-#define nssv_nodiscard /*[[nodiscard]]*/
-#endif
-
-// Additional includes:
-
-#include <algorithm>
-#include <cassert>
-#include <iterator>
-#include <limits>
-#include <ostream>
-#include <string> // std::char_traits<>
-
-#if !nssv_CONFIG_NO_EXCEPTIONS
-#include <stdexcept>
-#endif
-
-#if nssv_CPP11_OR_GREATER
-#include <type_traits>
-#endif
-
-// Clang, GNUC, MSVC warning suppression macros:
-
-#if defined(__clang__)
-#pragma clang diagnostic ignored "-Wreserved-user-defined-literal"
-#pragma clang diagnostic push
-#pragma clang diagnostic ignored "-Wuser-defined-literals"
-#elif defined(__GNUC__)
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wliteral-suffix"
-#endif // __clang__
-
-#if nssv_COMPILER_MSVC_VERSION >= 140
-#define nssv_SUPPRESS_MSGSL_WARNING(expr) [[gsl::suppress(expr)]]
-#define nssv_SUPPRESS_MSVC_WARNING(code, descr) __pragma(warning(suppress : code))
-#define nssv_DISABLE_MSVC_WARNINGS(codes) __pragma(warning(push)) __pragma(warning(disable : codes))
-#else
-#define nssv_SUPPRESS_MSGSL_WARNING(expr)
-#define nssv_SUPPRESS_MSVC_WARNING(code, descr)
-#define nssv_DISABLE_MSVC_WARNINGS(codes)
-#endif
-
-#if defined(__clang__)
-#define nssv_RESTORE_WARNINGS() _Pragma("clang diagnostic pop")
-#elif defined(__GNUC__)
-#define nssv_RESTORE_WARNINGS() _Pragma("GCC diagnostic pop")
-#elif nssv_COMPILER_MSVC_VERSION >= 140
-#define nssv_RESTORE_WARNINGS() __pragma(warning(pop))
-#else
-#define nssv_RESTORE_WARNINGS()
-#endif
-
-// Suppress the following MSVC (GSL) warnings:
-// - C4455, non-gsl   : 'operator ""sv': literal suffix identifiers that do not
-//                      start with an underscore are reserved
-// - C26472, gsl::t.1 : don't use a static_cast for arithmetic conversions;
-//                      use brace initialization, gsl::narrow_cast or gsl::narow
-// - C26481: gsl::b.1 : don't use pointer arithmetic. Use span instead
-
-nssv_DISABLE_MSVC_WARNINGS(4455 26481 26472)
-    // nssv_DISABLE_CLANG_WARNINGS( "-Wuser-defined-literals" )
-    // nssv_DISABLE_GNUC_WARNINGS( -Wliteral-suffix )
-
-    namespace nonstd {
-  namespace sv_lite {
-
-#if nssv_CPP11_OR_GREATER
-
-  namespace detail {
-
-  // Expect tail call optimization to make length() non-recursive:
-
-  template <typename CharT> inline constexpr std::size_t length(CharT *s, std::size_t result = 0) {
-    return *s == '\0' ? result : length(s + 1, result + 1);
-  }
-
-  } // namespace detail
-
-#endif // nssv_CPP11_OR_GREATER
-
-  template <class CharT, class Traits = std::char_traits<CharT>> class basic_string_view;
-
-  //
-  // basic_string_view:
-  //
-
-  template <class CharT, class Traits /* = std::char_traits<CharT> */
-            >
-  class basic_string_view {
-  public:
-    // Member types:
-
-    typedef Traits traits_type;
-    typedef CharT value_type;
-
-    typedef CharT *pointer;
-    typedef CharT const *const_pointer;
-    typedef CharT &reference;
-    typedef CharT const &const_reference;
-
-    typedef const_pointer iterator;
-    typedef const_pointer const_iterator;
-    typedef std::reverse_iterator<const_iterator> reverse_iterator;
-    typedef std::reverse_iterator<const_iterator> const_reverse_iterator;
-
-    typedef std::size_t size_type;
-    typedef std::ptrdiff_t difference_type;
-
-    // 24.4.2.1 Construction and assignment:
-
-    nssv_constexpr basic_string_view() nssv_noexcept : data_(nssv_nullptr), size_(0) {}
-
-#if nssv_CPP11_OR_GREATER
-    nssv_constexpr basic_string_view(basic_string_view const &other) nssv_noexcept = default;
-#else
-    nssv_constexpr basic_string_view(basic_string_view const &other) nssv_noexcept : data_(other.data_),
-                                                                                     size_(other.size_) {}
-#endif
-
-    nssv_constexpr basic_string_view(CharT const *s, size_type count) nssv_noexcept // non-standard noexcept
-        : data_(s),
-          size_(count) {}
-
-    nssv_constexpr basic_string_view(CharT const *s) nssv_noexcept // non-standard noexcept
-        : data_(s)
-#if nssv_CPP17_OR_GREATER
-        ,
-          size_(Traits::length(s))
-#elif nssv_CPP11_OR_GREATER
-        ,
-          size_(detail::length(s))
-#else
-        ,
-          size_(Traits::length(s))
-#endif
-    {
-    }
-
-    // Assignment:
-
-#if nssv_CPP11_OR_GREATER
-    nssv_constexpr14 basic_string_view &operator=(basic_string_view const &other) nssv_noexcept = default;
-#else
-    nssv_constexpr14 basic_string_view &operator=(basic_string_view const &other) nssv_noexcept {
-      data_ = other.data_;
-      size_ = other.size_;
-      return *this;
-    }
-#endif
-
-    // 24.4.2.2 Iterator support:
-
-    nssv_constexpr const_iterator begin() const nssv_noexcept { return data_; }
-    nssv_constexpr const_iterator end() const nssv_noexcept { return data_ + size_; }
-
-    nssv_constexpr const_iterator cbegin() const nssv_noexcept { return begin(); }
-    nssv_constexpr const_iterator cend() const nssv_noexcept { return end(); }
-
-    nssv_constexpr const_reverse_iterator rbegin() const nssv_noexcept { return const_reverse_iterator(end()); }
-    nssv_constexpr const_reverse_iterator rend() const nssv_noexcept { return const_reverse_iterator(begin()); }
-
-    nssv_constexpr const_reverse_iterator crbegin() const nssv_noexcept { return rbegin(); }
-    nssv_constexpr const_reverse_iterator crend() const nssv_noexcept { return rend(); }
-
-    // 24.4.2.3 Capacity:
-
-    nssv_constexpr size_type size() const nssv_noexcept { return size_; }
-    nssv_constexpr size_type length() const nssv_noexcept { return size_; }
-    nssv_constexpr size_type max_size() const nssv_noexcept { return (std::numeric_limits<size_type>::max)(); }
-
-    // since C++20
-    nssv_nodiscard nssv_constexpr bool empty() const nssv_noexcept { return 0 == size_; }
-
-    // 24.4.2.4 Element access:
-
-    nssv_constexpr const_reference operator[](size_type pos) const { return data_at(pos); }
-
-    nssv_constexpr14 const_reference at(size_type pos) const {
-#if nssv_CONFIG_NO_EXCEPTIONS
-      assert(pos < size());
-#else
-      if (pos >= size()) {
-        throw std::out_of_range("nonstd::string_view::at()");
-      }
-#endif
-      return data_at(pos);
-    }
-
-    nssv_constexpr const_reference front() const { return data_at(0); }
-    nssv_constexpr const_reference back() const { return data_at(size() - 1); }
-
-    nssv_constexpr const_pointer data() const nssv_noexcept { return data_; }
-
-    // 24.4.2.5 Modifiers:
-
-    nssv_constexpr14 void remove_prefix(size_type n) {
-      assert(n <= size());
-      data_ += n;
-      size_ -= n;
-    }
-
-    nssv_constexpr14 void remove_suffix(size_type n) {
-      assert(n <= size());
-      size_ -= n;
-    }
-
-    nssv_constexpr14 void swap(basic_string_view &other) nssv_noexcept {
-      using std::swap;
-      swap(data_, other.data_);
-      swap(size_, other.size_);
-    }
-
-    // 24.4.2.6 String operations:
-
-    size_type copy(CharT *dest, size_type n, size_type pos = 0) const {
-#if nssv_CONFIG_NO_EXCEPTIONS
-      assert(pos <= size());
-#else
-      if (pos > size()) {
-        throw std::out_of_range("nonstd::string_view::copy()");
-      }
-#endif
-      const size_type rlen = (std::min)(n, size() - pos);
-
-      (void)Traits::copy(dest, data() + pos, rlen);
-
-      return rlen;
-    }
-
-    nssv_constexpr14 basic_string_view substr(size_type pos = 0, size_type n = npos) const {
-#if nssv_CONFIG_NO_EXCEPTIONS
-      assert(pos <= size());
-#else
-      if (pos > size()) {
-        throw std::out_of_range("nonstd::string_view::substr()");
-      }
-#endif
-      return basic_string_view(data() + pos, (std::min)(n, size() - pos));
-    }
-
-    // compare(), 6x:
-
-    nssv_constexpr14 int compare(basic_string_view other) const nssv_noexcept // (1)
-    {
-      if (const int result = Traits::compare(data(), other.data(), (std::min)(size(), other.size()))) {
-        return result;
-      }
-
-      return size() == other.size() ? 0 : size() < other.size() ? -1 : 1;
-    }
-
-    nssv_constexpr int compare(size_type pos1, size_type n1, basic_string_view other) const // (2)
-    {
-      return substr(pos1, n1).compare(other);
-    }
-
-    nssv_constexpr int compare(size_type pos1, size_type n1, basic_string_view other, size_type pos2,
-                               size_type n2) const // (3)
-    {
-      return substr(pos1, n1).compare(other.substr(pos2, n2));
-    }
-
-    nssv_constexpr int compare(CharT const *s) const // (4)
-    {
-      return compare(basic_string_view(s));
-    }
-
-    nssv_constexpr int compare(size_type pos1, size_type n1, CharT const *s) const // (5)
-    {
-      return substr(pos1, n1).compare(basic_string_view(s));
-    }
-
-    nssv_constexpr int compare(size_type pos1, size_type n1, CharT const *s, size_type n2) const // (6)
-    {
-      return substr(pos1, n1).compare(basic_string_view(s, n2));
-    }
-
-    // 24.4.2.7 Searching:
-
-    // starts_with(), 3x, since C++20:
-
-    nssv_constexpr bool starts_with(basic_string_view v) const nssv_noexcept // (1)
-    {
-      return size() >= v.size() && compare(0, v.size(), v) == 0;
-    }
-
-    nssv_constexpr bool starts_with(CharT c) const nssv_noexcept // (2)
-    {
-      return starts_with(basic_string_view(&c, 1));
-    }
-
-    nssv_constexpr bool starts_with(CharT const *s) const // (3)
-    {
-      return starts_with(basic_string_view(s));
-    }
-
-    // ends_with(), 3x, since C++20:
-
-    nssv_constexpr bool ends_with(basic_string_view v) const nssv_noexcept // (1)
-    {
-      return size() >= v.size() && compare(size() - v.size(), npos, v) == 0;
-    }
-
-    nssv_constexpr bool ends_with(CharT c) const nssv_noexcept // (2)
-    {
-      return ends_with(basic_string_view(&c, 1));
-    }
-
-    nssv_constexpr bool ends_with(CharT const *s) const // (3)
-    {
-      return ends_with(basic_string_view(s));
-    }
-
-    // find(), 4x:
-
-    nssv_constexpr14 size_type find(basic_string_view v, size_type pos = 0) const nssv_noexcept // (1)
-    {
-      return assert(v.size() == 0 || v.data() != nssv_nullptr),
-             pos >= size() ? npos : to_pos(std::search(cbegin() + pos, cend(), v.cbegin(), v.cend(), Traits::eq));
-    }
-
-    nssv_constexpr14 size_type find(CharT c, size_type pos = 0) const nssv_noexcept // (2)
-    {
-      return find(basic_string_view(&c, 1), pos);
-    }
-
-    nssv_constexpr14 size_type find(CharT const *s, size_type pos, size_type n) const // (3)
-    {
-      return find(basic_string_view(s, n), pos);
-    }
-
-    nssv_constexpr14 size_type find(CharT const *s, size_type pos = 0) const // (4)
-    {
-      return find(basic_string_view(s), pos);
-    }
-
-    // rfind(), 4x:
-
-    nssv_constexpr14 size_type rfind(basic_string_view v, size_type pos = npos) const nssv_noexcept // (1)
-    {
-      if (size() < v.size()) {
-        return npos;
-      }
-
-      if (v.empty()) {
-        return (std::min)(size(), pos);
-      }
-
-      const_iterator last = cbegin() + (std::min)(size() - v.size(), pos) + v.size();
-      const_iterator result = std::find_end(cbegin(), last, v.cbegin(), v.cend(), Traits::eq);
-
-      return result != last ? size_type(result - cbegin()) : npos;
-    }
-
-    nssv_constexpr14 size_type rfind(CharT c, size_type pos = npos) const nssv_noexcept // (2)
-    {
-      return rfind(basic_string_view(&c, 1), pos);
-    }
-
-    nssv_constexpr14 size_type rfind(CharT const *s, size_type pos, size_type n) const // (3)
-    {
-      return rfind(basic_string_view(s, n), pos);
-    }
-
-    nssv_constexpr14 size_type rfind(CharT const *s, size_type pos = npos) const // (4)
-    {
-      return rfind(basic_string_view(s), pos);
-    }
-
-    // find_first_of(), 4x:
-
-    nssv_constexpr size_type find_first_of(basic_string_view v, size_type pos = 0) const nssv_noexcept // (1)
-    {
-      return pos >= size() ? npos
-                           : to_pos(std::find_first_of(cbegin() + pos, cend(), v.cbegin(), v.cend(), Traits::eq));
-    }
-
-    nssv_constexpr size_type find_first_of(CharT c, size_type pos = 0) const nssv_noexcept // (2)
-    {
-      return find_first_of(basic_string_view(&c, 1), pos);
-    }
-
-    nssv_constexpr size_type find_first_of(CharT const *s, size_type pos, size_type n) const // (3)
-    {
-      return find_first_of(basic_string_view(s, n), pos);
-    }
-
-    nssv_constexpr size_type find_first_of(CharT const *s, size_type pos = 0) const // (4)
-    {
-      return find_first_of(basic_string_view(s), pos);
-    }
-
-    // find_last_of(), 4x:
-
-    nssv_constexpr size_type find_last_of(basic_string_view v, size_type pos = npos) const nssv_noexcept // (1)
-    {
-      return empty() ? npos
-                     : pos >= size() ? find_last_of(v, size() - 1)
-                                     : to_pos(std::find_first_of(const_reverse_iterator(cbegin() + pos + 1), crend(),
-                                                                 v.cbegin(), v.cend(), Traits::eq));
-    }
-
-    nssv_constexpr size_type find_last_of(CharT c, size_type pos = npos) const nssv_noexcept // (2)
-    {
-      return find_last_of(basic_string_view(&c, 1), pos);
-    }
-
-    nssv_constexpr size_type find_last_of(CharT const *s, size_type pos, size_type count) const // (3)
-    {
-      return find_last_of(basic_string_view(s, count), pos);
-    }
-
-    nssv_constexpr size_type find_last_of(CharT const *s, size_type pos = npos) const // (4)
-    {
-      return find_last_of(basic_string_view(s), pos);
-    }
-
-    // find_first_not_of(), 4x:
-
-    nssv_constexpr size_type find_first_not_of(basic_string_view v, size_type pos = 0) const nssv_noexcept // (1)
-    {
-      return pos >= size() ? npos : to_pos(std::find_if(cbegin() + pos, cend(), not_in_view(v)));
-    }
-
-    nssv_constexpr size_type find_first_not_of(CharT c, size_type pos = 0) const nssv_noexcept // (2)
-    {
-      return find_first_not_of(basic_string_view(&c, 1), pos);
-    }
-
-    nssv_constexpr size_type find_first_not_of(CharT const *s, size_type pos, size_type count) const // (3)
-    {
-      return find_first_not_of(basic_string_view(s, count), pos);
-    }
-
-    nssv_constexpr size_type find_first_not_of(CharT const *s, size_type pos = 0) const // (4)
-    {
-      return find_first_not_of(basic_string_view(s), pos);
-    }
-
-    // find_last_not_of(), 4x:
-
-    nssv_constexpr size_type find_last_not_of(basic_string_view v, size_type pos = npos) const nssv_noexcept // (1)
-    {
-      return empty() ? npos
-                     : pos >= size()
-                           ? find_last_not_of(v, size() - 1)
-                           : to_pos(std::find_if(const_reverse_iterator(cbegin() + pos + 1), crend(), not_in_view(v)));
-    }
-
-    nssv_constexpr size_type find_last_not_of(CharT c, size_type pos = npos) const nssv_noexcept // (2)
-    {
-      return find_last_not_of(basic_string_view(&c, 1), pos);
-    }
-
-    nssv_constexpr size_type find_last_not_of(CharT const *s, size_type pos, size_type count) const // (3)
-    {
-      return find_last_not_of(basic_string_view(s, count), pos);
-    }
-
-    nssv_constexpr size_type find_last_not_of(CharT const *s, size_type pos = npos) const // (4)
-    {
-      return find_last_not_of(basic_string_view(s), pos);
-    }
-
-    // Constants:
-
-#if nssv_CPP17_OR_GREATER
-    static nssv_constexpr size_type npos = size_type(-1);
-#elif nssv_CPP11_OR_GREATER
-    enum : size_type { npos = size_type(-1) };
-#else
-    enum { npos = size_type(-1) };
-#endif
-
-  private:
-    struct not_in_view {
-      const basic_string_view v;
-
-      nssv_constexpr explicit not_in_view(basic_string_view v) : v(v) {}
-
-      nssv_constexpr bool operator()(CharT c) const { return npos == v.find_first_of(c); }
-    };
-
-    nssv_constexpr size_type to_pos(const_iterator it) const { return it == cend() ? npos : size_type(it - cbegin()); }
-
-    nssv_constexpr size_type to_pos(const_reverse_iterator it) const {
-      return it == crend() ? npos : size_type(crend() - it - 1);
-    }
-
-    nssv_constexpr const_reference data_at(size_type pos) const {
-#if nssv_BETWEEN(nssv_COMPILER_GNUC_VERSION, 1, 500)
-      return data_[pos];
-#else
-      return assert(pos < size()), data_[pos];
-#endif
-    }
-
-  private:
-    const_pointer data_;
-    size_type size_;
-
-  public:
-#if nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS
-
-    template <class Allocator>
-    basic_string_view(std::basic_string<CharT, Traits, Allocator> const &s) nssv_noexcept : data_(s.data()),
-                                                                                            size_(s.size()) {}
-
-#if nssv_HAVE_EXPLICIT_CONVERSION
-
-    template <class Allocator> explicit operator std::basic_string<CharT, Traits, Allocator>() const {
-      return to_string(Allocator());
-    }
-
-#endif // nssv_HAVE_EXPLICIT_CONVERSION
-
-#if nssv_CPP11_OR_GREATER
-
-    template <class Allocator = std::allocator<CharT>>
-    std::basic_string<CharT, Traits, Allocator> to_string(Allocator const &a = Allocator()) const {
-      return std::basic_string<CharT, Traits, Allocator>(begin(), end(), a);
-    }
-
-#else
-
-    std::basic_string<CharT, Traits> to_string() const { return std::basic_string<CharT, Traits>(begin(), end()); }
-
-    template <class Allocator> std::basic_string<CharT, Traits, Allocator> to_string(Allocator const &a) const {
-      return std::basic_string<CharT, Traits, Allocator>(begin(), end(), a);
-    }
-
-#endif // nssv_CPP11_OR_GREATER
-
-#endif // nssv_CONFIG_CONVERSION_STD_STRING_CLASS_METHODS
-  };
-
-  //
-  // Non-member functions:
-  //
-
-  // 24.4.3 Non-member comparison functions:
-  // lexicographically compare two string views (function template):
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) == 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) != 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs,
-                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) < 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) <= 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs,
-                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) > 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) >= 0;
-  }
-
-  // Let S be basic_string_view<CharT, Traits>, and sv be an instance of S.
-  // Implementations shall provide sufficient additional overloads marked
-  // constexpr and noexcept so that an object t with an implicit conversion
-  // to S can be compared according to Table 67.
-
-#if !nssv_CPP11_OR_GREATER || nssv_BETWEEN(nssv_COMPILER_MSVC_VERSION, 100, 141)
-
-  // accomodate for older compilers:
-
-  // ==
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
-    return lhs.compare(rhs) == 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator==(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return rhs.compare(lhs) == 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs,
-                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.size() == rhs.size() && lhs.compare(rhs) == 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator==(std::basic_string<CharT, Traits> rhs,
-                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
-    return lhs.size() == rhs.size() && lhs.compare(rhs) == 0;
-  }
-
-  // !=
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
-    return lhs.compare(rhs) != 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator!=(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return rhs.compare(lhs) != 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs,
-                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.size() != rhs.size() && lhs.compare(rhs) != 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator!=(std::basic_string<CharT, Traits> rhs,
-                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
-    return lhs.size() != rhs.size() || rhs.compare(lhs) != 0;
-  }
-
-  // <
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
-    return lhs.compare(rhs) < 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return rhs.compare(lhs) > 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs,
-                                std::basic_string<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) < 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<(std::basic_string<CharT, Traits> rhs,
-                                basic_string_view<CharT, Traits> lhs) nssv_noexcept {
-    return rhs.compare(lhs) > 0;
-  }
-
-  // <=
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
-    return lhs.compare(rhs) <= 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<=(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return rhs.compare(lhs) >= 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs,
-                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) <= 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator<=(std::basic_string<CharT, Traits> rhs,
-                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
-    return rhs.compare(lhs) >= 0;
-  }
-
-  // >
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
-    return lhs.compare(rhs) > 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return rhs.compare(lhs) < 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs,
-                                std::basic_string<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) > 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>(std::basic_string<CharT, Traits> rhs,
-                                basic_string_view<CharT, Traits> lhs) nssv_noexcept {
-    return rhs.compare(lhs) < 0;
-  }
-
-  // >=
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs, char const *rhs) nssv_noexcept {
-    return lhs.compare(rhs) >= 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>=(char const *lhs, basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return rhs.compare(lhs) <= 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs,
-                                 std::basic_string<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) >= 0;
-  }
-
-  template <class CharT, class Traits>
-  nssv_constexpr bool operator>=(std::basic_string<CharT, Traits> rhs,
-                                 basic_string_view<CharT, Traits> lhs) nssv_noexcept {
-    return rhs.compare(lhs) <= 0;
-  }
-
-#else // newer compilers:
-
-#define nssv_BASIC_STRING_VIEW_I(T, U) typename std::decay<basic_string_view<T, U>>::type
-
-#if nssv_BETWEEN(nssv_COMPILER_MSVC_VERSION, 140, 150)
-#define nssv_MSVC_ORDER(x) , int = x
-#else
-#define nssv_MSVC_ORDER(x) /*, int=x*/
-#endif
-
-  // ==
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
-  nssv_constexpr bool operator==(basic_string_view<CharT, Traits> lhs,
-                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
-    return lhs.compare(rhs) == 0;
-  }
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
-  nssv_constexpr bool operator==(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.size() == rhs.size() && lhs.compare(rhs) == 0;
-  }
-
-  // !=
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
-  nssv_constexpr bool operator!=(basic_string_view<CharT, Traits> lhs,
-                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
-    return lhs.size() != rhs.size() || lhs.compare(rhs) != 0;
-  }
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
-  nssv_constexpr bool operator!=(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) != 0;
-  }
-
-  // <
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
-  nssv_constexpr bool operator<(basic_string_view<CharT, Traits> lhs,
-                                nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
-    return lhs.compare(rhs) < 0;
-  }
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
-  nssv_constexpr bool operator<(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
-                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) < 0;
-  }
-
-  // <=
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
-  nssv_constexpr bool operator<=(basic_string_view<CharT, Traits> lhs,
-                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
-    return lhs.compare(rhs) <= 0;
-  }
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
-  nssv_constexpr bool operator<=(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) <= 0;
-  }
-
-  // >
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
-  nssv_constexpr bool operator>(basic_string_view<CharT, Traits> lhs,
-                                nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
-    return lhs.compare(rhs) > 0;
-  }
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
-  nssv_constexpr bool operator>(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
-                                basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) > 0;
-  }
-
-  // >=
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(1)>
-  nssv_constexpr bool operator>=(basic_string_view<CharT, Traits> lhs,
-                                 nssv_BASIC_STRING_VIEW_I(CharT, Traits) rhs) nssv_noexcept {
-    return lhs.compare(rhs) >= 0;
-  }
-
-  template <class CharT, class Traits nssv_MSVC_ORDER(2)>
-  nssv_constexpr bool operator>=(nssv_BASIC_STRING_VIEW_I(CharT, Traits) lhs,
-                                 basic_string_view<CharT, Traits> rhs) nssv_noexcept {
-    return lhs.compare(rhs) >= 0;
-  }
-
-#undef nssv_MSVC_ORDER
-#undef nssv_BASIC_STRING_VIEW_I
-
-#endif // compiler-dependent approach to comparisons
-
-  // 24.4.4 Inserters and extractors:
-
-  namespace detail {
-
-  template <class Stream> void write_padding(Stream &os, std::streamsize n) {
-    for (std::streamsize i = 0; i < n; ++i)
-      os.rdbuf()->sputc(os.fill());
-  }
-
-  template <class Stream, class View> Stream &write_to_stream(Stream &os, View const &sv) {
-    typename Stream::sentry sentry(os);
-
-    if (!os)
-      return os;
-
-    const std::streamsize length = static_cast<std::streamsize>(sv.length());
-
-    // Whether, and how, to pad:
-    const bool pad = (length < os.width());
-    const bool left_pad = pad && (os.flags() & std::ios_base::adjustfield) == std::ios_base::right;
-
-    if (left_pad)
-      write_padding(os, os.width() - length);
-
-    // Write span characters:
-    os.rdbuf()->sputn(sv.begin(), length);
-
-    if (pad && !left_pad)
-      write_padding(os, os.width() - length);
-
-    // Reset output stream width:
-    os.width(0);
-
-    return os;
-  }
-
-  } // namespace detail
-
-  template <class CharT, class Traits>
-  std::basic_ostream<CharT, Traits> &operator<<(std::basic_ostream<CharT, Traits> &os,
-                                                basic_string_view<CharT, Traits> sv) {
-    return detail::write_to_stream(os, sv);
-  }
-
-  // Several typedefs for common character types are provided:
-
-  typedef basic_string_view<char> string_view;
-  typedef basic_string_view<wchar_t> wstring_view;
-#if nssv_HAVE_WCHAR16_T
-  typedef basic_string_view<char16_t> u16string_view;
-  typedef basic_string_view<char32_t> u32string_view;
-#endif
-
-  } // namespace sv_lite
-} // namespace nonstd::sv_lite
-
-//
-// 24.4.6 Suffix for basic_string_view literals:
-//
-
-#if nssv_HAVE_USER_DEFINED_LITERALS
-
-namespace nonstd {
-nssv_inline_ns namespace literals {
-  nssv_inline_ns namespace string_view_literals {
-
-#if nssv_CONFIG_STD_SV_OPERATOR && nssv_HAVE_STD_DEFINED_LITERALS
-
-    nssv_constexpr nonstd::sv_lite::string_view operator"" sv(const char *str, size_t len) nssv_noexcept // (1)
-    {
-      return nonstd::sv_lite::string_view {str, len};
-    }
-
-    nssv_constexpr nonstd::sv_lite::u16string_view operator"" sv(const char16_t *str, size_t len) nssv_noexcept // (2)
-    {
-      return nonstd::sv_lite::u16string_view {str, len};
-    }
-
-    nssv_constexpr nonstd::sv_lite::u32string_view operator"" sv(const char32_t *str, size_t len) nssv_noexcept // (3)
-    {
-      return nonstd::sv_lite::u32string_view {str, len};
-    }
-
-    nssv_constexpr nonstd::sv_lite::wstring_view operator"" sv(const wchar_t *str, size_t len) nssv_noexcept // (4)
-    {
-      return nonstd::sv_lite::wstring_view {str, len};
-    }
-
-#endif // nssv_CONFIG_STD_SV_OPERATOR && nssv_HAVE_STD_DEFINED_LITERALS
-
-#if nssv_CONFIG_USR_SV_OPERATOR
-
-    nssv_constexpr nonstd::sv_lite::string_view operator"" _sv(const char *str, size_t len) nssv_noexcept // (1)
-    {
-      return nonstd::sv_lite::string_view {str, len};
-    }
-
-    nssv_constexpr nonstd::sv_lite::u16string_view operator"" _sv(const char16_t *str, size_t len) nssv_noexcept // (2)
-    {
-      return nonstd::sv_lite::u16string_view {str, len};
-    }
-
-    nssv_constexpr nonstd::sv_lite::u32string_view operator"" _sv(const char32_t *str, size_t len) nssv_noexcept // (3)
-    {
-      return nonstd::sv_lite::u32string_view {str, len};
-    }
-
-    nssv_constexpr nonstd::sv_lite::wstring_view operator"" _sv(const wchar_t *str, size_t len) nssv_noexcept // (4)
-    {
-      return nonstd::sv_lite::wstring_view {str, len};
-    }
-
-#endif // nssv_CONFIG_USR_SV_OPERATOR
-  }
-}
-} // namespace nonstd
-
-#endif
-
-//
-// Extensions for std::string:
-//
-
-#if nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
-
-namespace nonstd {
-namespace sv_lite {
-
-// Exclude MSVC 14 (19.00): it yields ambiguous to_string():
-
-#if nssv_CPP11_OR_GREATER && nssv_COMPILER_MSVC_VERSION != 140
-
-template <class CharT, class Traits, class Allocator = std::allocator<CharT>>
-std::basic_string<CharT, Traits, Allocator> to_string(basic_string_view<CharT, Traits> v,
-                                                      Allocator const &a = Allocator()) {
-  return std::basic_string<CharT, Traits, Allocator>(v.begin(), v.end(), a);
-}
-
-#else
-
-template <class CharT, class Traits> std::basic_string<CharT, Traits> to_string(basic_string_view<CharT, Traits> v) {
-  return std::basic_string<CharT, Traits>(v.begin(), v.end());
-}
-
-template <class CharT, class Traits, class Allocator>
-std::basic_string<CharT, Traits, Allocator> to_string(basic_string_view<CharT, Traits> v, Allocator const &a) {
-  return std::basic_string<CharT, Traits, Allocator>(v.begin(), v.end(), a);
-}
-
-#endif // nssv_CPP11_OR_GREATER
-
-template <class CharT, class Traits, class Allocator>
-basic_string_view<CharT, Traits> to_string_view(std::basic_string<CharT, Traits, Allocator> const &s) {
-  return basic_string_view<CharT, Traits>(s.data(), s.size());
-}
-
-} // namespace sv_lite
-} // namespace nonstd
-
-#endif // nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
-
-//
-// make types and algorithms available in namespace nonstd:
-//
-
-namespace nonstd {
-
-using sv_lite::basic_string_view;
-using sv_lite::string_view;
-using sv_lite::wstring_view;
-
-#if nssv_HAVE_WCHAR16_T
-using sv_lite::u16string_view;
-#endif
-#if nssv_HAVE_WCHAR32_T
-using sv_lite::u32string_view;
-#endif
-
-// literal "sv"
-
-using sv_lite::operator==;
-using sv_lite::operator!=;
-using sv_lite::operator<;
-using sv_lite::operator<=;
-using sv_lite::operator>;
-using sv_lite::operator>=;
-
-using sv_lite::operator<<;
-
-#if nssv_CONFIG_CONVERSION_STD_STRING_FREE_FUNCTIONS
-using sv_lite::to_string;
-using sv_lite::to_string_view;
-#endif
-
-} // namespace nonstd
-
-// 24.4.5 Hash support (C++11):
-
-// Note: The hash value of a string view object is equal to the hash value of
-// the corresponding string object.
-
-#if nssv_HAVE_STD_HASH
-
-#include <functional>
-
-namespace std {
-
-template <> struct hash<nonstd::string_view> {
-public:
-  std::size_t operator()(nonstd::string_view v) const nssv_noexcept {
-    return std::hash<std::string>()(std::string(v.data(), v.size()));
-  }
-};
-
-template <> struct hash<nonstd::wstring_view> {
-public:
-  std::size_t operator()(nonstd::wstring_view v) const nssv_noexcept {
-    return std::hash<std::wstring>()(std::wstring(v.data(), v.size()));
-  }
-};
-
-template <> struct hash<nonstd::u16string_view> {
-public:
-  std::size_t operator()(nonstd::u16string_view v) const nssv_noexcept {
-    return std::hash<std::u16string>()(std::u16string(v.data(), v.size()));
-  }
-};
-
-template <> struct hash<nonstd::u32string_view> {
-public:
-  std::size_t operator()(nonstd::u32string_view v) const nssv_noexcept {
-    return std::hash<std::u32string>()(std::u32string(v.data(), v.size()));
-  }
-};
-
-} // namespace std
-
-#endif // nssv_HAVE_STD_HASH
-
-nssv_RESTORE_WARNINGS()
-
-#endif // nssv_HAVE_STD_STRING_VIEW
-#endif // NONSTD_SV_LITE_H_INCLUDED
-
-// #include "template.hpp"
-#ifndef INCLUDE_INJA_TEMPLATE_HPP_
-#define INCLUDE_INJA_TEMPLATE_HPP_
-
-#include <map>
-#include <memory>
-#include <string>
-#include <vector>
-
-// #include "node.hpp"
-#ifndef INCLUDE_INJA_NODE_HPP_
-#define INCLUDE_INJA_NODE_HPP_
-
-#include <string>
-#include <utility>
-
-// #include "function_storage.hpp"
-#ifndef INCLUDE_INJA_FUNCTION_STORAGE_HPP_
-#define INCLUDE_INJA_FUNCTION_STORAGE_HPP_
-
-#include <vector>
-
-// #include "string_view.hpp"
-
-
-namespace inja {
-
-using Arguments = std::vector<const json *>;
-using CallbackFunction = std::function<json(Arguments &args)>;
-using VoidCallbackFunction = std::function<void(Arguments &args)>;
-
-/*!
- * \brief Class for builtin functions and user-defined callbacks.
- */
-class FunctionStorage {
-public:
-  enum class Operation {
-    Not,
-    And,
-    Or,
-    In,
-    Equal,
-    NotEqual,
-    Greater,
-    GreaterEqual,
-    Less,
-    LessEqual,
-    Add,
-    Subtract,
-    Multiplication,
-    Division,
-    Power,
-    Modulo,
-    AtId,
-    At,
-    Default,
-    DivisibleBy,
-    Even,
-    Exists,
-    ExistsInObject,
-    First,
-    Float,
-    Int,
-    IsArray,
-    IsBoolean,
-    IsFloat,
-    IsInteger,
-    IsNumber,
-    IsObject,
-    IsString,
-    Last,
-    Length,
-    Lower,
-    Max,
-    Min,
-    Odd,
-    Range,
-    Round,
-    Sort,
-    Upper,
-    Super,
-    Join,
-    Callback,
-    ParenLeft,
-    ParenRight,
-    None,
-  };
-
-  struct FunctionData {
-    explicit FunctionData(const Operation &op, const CallbackFunction &cb = CallbackFunction{}) : operation(op), callback(cb) {}
-    const Operation operation;
-    const CallbackFunction callback;
-  };
-
-private:
-  const int VARIADIC {-1};
-
-  std::map<std::pair<std::string, int>, FunctionData> function_storage = {
-    {std::make_pair("at", 2), FunctionData { Operation::At }},
-    {std::make_pair("default", 2), FunctionData { Operation::Default }},
-    {std::make_pair("divisibleBy", 2), FunctionData { Operation::DivisibleBy }},
-    {std::make_pair("even", 1), FunctionData { Operation::Even }},
-    {std::make_pair("exists", 1), FunctionData { Operation::Exists }},
-    {std::make_pair("existsIn", 2), FunctionData { Operation::ExistsInObject }},
-    {std::make_pair("first", 1), FunctionData { Operation::First }},
-    {std::make_pair("float", 1), FunctionData { Operation::Float }},
-    {std::make_pair("int", 1), FunctionData { Operation::Int }},
-    {std::make_pair("isArray", 1), FunctionData { Operation::IsArray }},
-    {std::make_pair("isBoolean", 1), FunctionData { Operation::IsBoolean }},
-    {std::make_pair("isFloat", 1), FunctionData { Operation::IsFloat }},
-    {std::make_pair("isInteger", 1), FunctionData { Operation::IsInteger }},
-    {std::make_pair("isNumber", 1), FunctionData { Operation::IsNumber }},
-    {std::make_pair("isObject", 1), FunctionData { Operation::IsObject }},
-    {std::make_pair("isString", 1), FunctionData { Operation::IsString }},
-    {std::make_pair("last", 1), FunctionData { Operation::Last }},
-    {std::make_pair("length", 1), FunctionData { Operation::Length }},
-    {std::make_pair("lower", 1), FunctionData { Operation::Lower }},
-    {std::make_pair("max", 1), FunctionData { Operation::Max }},
-    {std::make_pair("min", 1), FunctionData { Operation::Min }},
-    {std::make_pair("odd", 1), FunctionData { Operation::Odd }},
-    {std::make_pair("range", 1), FunctionData { Operation::Range }},
-    {std::make_pair("round", 2), FunctionData { Operation::Round }},
-    {std::make_pair("sort", 1), FunctionData { Operation::Sort }},
-    {std::make_pair("upper", 1), FunctionData { Operation::Upper }},
-    {std::make_pair("super", 0), FunctionData { Operation::Super }},
-    {std::make_pair("super", 1), FunctionData { Operation::Super }},
-    {std::make_pair("join", 2), FunctionData { Operation::Join }},
-  };
-
-public:
-  void add_builtin(nonstd::string_view name, int num_args, Operation op) {
-    function_storage.emplace(std::make_pair(static_cast<std::string>(name), num_args), FunctionData { op });
-  }
-
-  void add_callback(nonstd::string_view name, int num_args, const CallbackFunction &callback) {
-    function_storage.emplace(std::make_pair(static_cast<std::string>(name), num_args), FunctionData { Operation::Callback, callback });
-  }
-
-  FunctionData find_function(nonstd::string_view name, int num_args) const {
-    auto it = function_storage.find(std::make_pair(static_cast<std::string>(name), num_args));
-    if (it != function_storage.end()) {
-      return it->second;
-
-    // Find variadic function
-    } else if (num_args > 0) {
-      it = function_storage.find(std::make_pair(static_cast<std::string>(name), VARIADIC));
-      if (it != function_storage.end()) {
-        return it->second;
-      }
-    }
-
-    return FunctionData { Operation::None };
-  }
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_FUNCTION_STORAGE_HPP_
-
-// #include "string_view.hpp"
-
-// #include "utils.hpp"
-#ifndef INCLUDE_INJA_UTILS_HPP_
-#define INCLUDE_INJA_UTILS_HPP_
-
-#include <algorithm>
-#include <fstream>
-#include <string>
-#include <utility>
-
-// #include "exceptions.hpp"
-#ifndef INCLUDE_INJA_EXCEPTIONS_HPP_
-#define INCLUDE_INJA_EXCEPTIONS_HPP_
-
-#include <stdexcept>
-#include <string>
-
-namespace inja {
-
-struct SourceLocation {
-  size_t line;
-  size_t column;
-};
-
-struct InjaError : public std::runtime_error {
-  const std::string type;
-  const std::string message;
-
-  const SourceLocation location;
-
-  explicit InjaError(const std::string &type, const std::string &message)
-      : std::runtime_error("[inja.exception." + type + "] " + message), type(type), message(message), location({0, 0}) {}
-
-  explicit InjaError(const std::string &type, const std::string &message, SourceLocation location)
-      : std::runtime_error("[inja.exception." + type + "] (at " + std::to_string(location.line) + ":" +
-                           std::to_string(location.column) + ") " + message),
-        type(type), message(message), location(location) {}
-};
-
-struct ParserError : public InjaError {
-  explicit ParserError(const std::string &message, SourceLocation location) : InjaError("parser_error", message, location) {}
-};
-
-struct RenderError : public InjaError {
-  explicit RenderError(const std::string &message, SourceLocation location) : InjaError("render_error", message, location) {}
-};
-
-struct FileError : public InjaError {
-  explicit FileError(const std::string &message) : InjaError("file_error", message) {}
-  explicit FileError(const std::string &message, SourceLocation location) : InjaError("file_error", message, location) {}
-};
-
-struct JsonError : public InjaError {
-  explicit JsonError(const std::string &message, SourceLocation location) : InjaError("json_error", message, location) {}
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_EXCEPTIONS_HPP_
-
-// #include "string_view.hpp"
-
-
-namespace inja {
-
-namespace string_view {
-inline nonstd::string_view slice(nonstd::string_view view, size_t start, size_t end) {
-  start = std::min(start, view.size());
-  end = std::min(std::max(start, end), view.size());
-  return view.substr(start, end - start);
-}
-
-inline std::pair<nonstd::string_view, nonstd::string_view> split(nonstd::string_view view, char Separator) {
-  size_t idx = view.find(Separator);
-  if (idx == nonstd::string_view::npos) {
-    return std::make_pair(view, nonstd::string_view());
-  }
-  return std::make_pair(slice(view, 0, idx), slice(view, idx + 1, nonstd::string_view::npos));
-}
-
-inline bool starts_with(nonstd::string_view view, nonstd::string_view prefix) {
-  return (view.size() >= prefix.size() && view.compare(0, prefix.size(), prefix) == 0);
-}
-} // namespace string_view
-
-inline SourceLocation get_source_location(nonstd::string_view content, size_t pos) {
-  // Get line and offset position (starts at 1:1)
-  auto sliced = string_view::slice(content, 0, pos);
-  std::size_t last_newline = sliced.rfind("\n");
-
-  if (last_newline == nonstd::string_view::npos) {
-    return {1, sliced.length() + 1};
-  }
-
-  // Count newlines
-  size_t count_lines = 0;
-  size_t search_start = 0;
-  while (search_start <= sliced.size()) {
-    search_start = sliced.find("\n", search_start) + 1;
-    if (search_start == 0) {
-      break;
-    }
-    count_lines += 1;
-  }
-
-  return {count_lines + 1, sliced.length() - last_newline};
-}
-
-inline void replace_substring(std::string& s, const std::string& f,
-                              const std::string& t)
-{
-  if (f.empty()) return;
-  for (auto pos = s.find(f);                  // find first occurrence of f
-            pos != std::string::npos;         // make sure f was found
-            s.replace(pos, f.size(), t),      // replace with t, and
-            pos = s.find(f, pos + t.size()))  // find next occurrence of f
-  {}
-}
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_UTILS_HPP_
-
-
-
-namespace inja {
-
-class NodeVisitor;
-class BlockNode;
-class TextNode;
-class ExpressionNode;
-class LiteralNode;
-class JsonNode;
-class FunctionNode;
-class ExpressionListNode;
-class StatementNode;
-class ForStatementNode;
-class ForArrayStatementNode;
-class ForObjectStatementNode;
-class IfStatementNode;
-class IncludeStatementNode;
-class ExtendsStatementNode;
-class BlockStatementNode;
-class SetStatementNode;
-
-
-class NodeVisitor {
-public:
-  virtual ~NodeVisitor() = default;
-
-  virtual void visit(const BlockNode& node) = 0;
-  virtual void visit(const TextNode& node) = 0;
-  virtual void visit(const ExpressionNode& node) = 0;
-  virtual void visit(const LiteralNode& node) = 0;
-  virtual void visit(const JsonNode& node) = 0;
-  virtual void visit(const FunctionNode& node) = 0;
-  virtual void visit(const ExpressionListNode& node) = 0;
-  virtual void visit(const StatementNode& node) = 0;
-  virtual void visit(const ForStatementNode& node) = 0;
-  virtual void visit(const ForArrayStatementNode& node) = 0;
-  virtual void visit(const ForObjectStatementNode& node) = 0;
-  virtual void visit(const IfStatementNode& node) = 0;
-  virtual void visit(const IncludeStatementNode& node) = 0;
-  virtual void visit(const ExtendsStatementNode& node) = 0;
-  virtual void visit(const BlockStatementNode& node) = 0;
-  virtual void visit(const SetStatementNode& node) = 0;
-};
-
-/*!
- * \brief Base node class for the abstract syntax tree (AST).
- */
-class AstNode {
-public:
-  virtual void accept(NodeVisitor& v) const = 0;
-
-  size_t pos;
-
-  AstNode(size_t pos) : pos(pos) { }
-  virtual ~AstNode() { }
-};
-
-
-class BlockNode : public AstNode {
-public:
-  std::vector<std::shared_ptr<AstNode>> nodes;
-
-  explicit BlockNode() : AstNode(0) {}
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class TextNode : public AstNode {
-public:
-  const size_t length;
-
-  explicit TextNode(size_t pos, size_t length): AstNode(pos), length(length) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class ExpressionNode : public AstNode {
-public:
-  explicit ExpressionNode(size_t pos) : AstNode(pos) {}
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class LiteralNode : public ExpressionNode {
-public:
-  const json value;
-
-  explicit LiteralNode(const json& value, size_t pos) : ExpressionNode(pos), value(value) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class JsonNode : public ExpressionNode {
-public:
-  const std::string name;
-  const json::json_pointer ptr;
-
-  static std::string convert_dot_to_json_ptr(nonstd::string_view ptr_name) {
-    std::string result;
-    do {
-      nonstd::string_view part;
-      std::tie(part, ptr_name) = string_view::split(ptr_name, '.');
-      result.push_back('/');
-      result.append(part.begin(), part.end());
-    } while (!ptr_name.empty());
-    return result;
-  }
-
-  explicit JsonNode(nonstd::string_view ptr_name, size_t pos) : ExpressionNode(pos), name(ptr_name), ptr(json::json_pointer(convert_dot_to_json_ptr(ptr_name))) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class FunctionNode : public ExpressionNode {
-  using Op = FunctionStorage::Operation;
-
-public:
-  enum class Associativity {
-    Left,
-    Right,
-  };
-
-  unsigned int precedence;
-  Associativity associativity;
-
-  Op operation;
-
-  std::string name;
-  int number_args; // Should also be negative -> -1 for unknown number
-  std::vector<std::shared_ptr<ExpressionNode>> arguments;
-  CallbackFunction callback;
-
-  explicit FunctionNode(nonstd::string_view name, size_t pos) : ExpressionNode(pos), precedence(8), associativity(Associativity::Left), operation(Op::Callback), name(name), number_args(1) { }
-  explicit FunctionNode(Op operation, size_t pos) : ExpressionNode(pos), operation(operation), number_args(1) {
-    switch (operation) {
-      case Op::Not: {
-        number_args = 1;
-        precedence = 4;
-        associativity = Associativity::Left;
-      } break;
-      case Op::And: {
-        number_args = 2;
-        precedence = 1;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Or: {
-        number_args = 2;
-        precedence = 1;
-        associativity = Associativity::Left;
-      } break;
-      case Op::In: {
-        number_args = 2;
-        precedence = 2;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Equal: {
-        number_args = 2;
-        precedence = 2;
-        associativity = Associativity::Left;
-      } break;
-      case Op::NotEqual: {
-        number_args = 2;
-        precedence = 2;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Greater: {
-        number_args = 2;
-        precedence = 2;
-        associativity = Associativity::Left;
-      } break;
-      case Op::GreaterEqual: {
-        number_args = 2;
-        precedence = 2;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Less: {
-        number_args = 2;
-        precedence = 2;
-        associativity = Associativity::Left;
-      } break;
-      case Op::LessEqual: {
-        number_args = 2;
-        precedence = 2;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Add: {
-        number_args = 2;
-        precedence = 3;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Subtract: {
-        number_args = 2;
-        precedence = 3;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Multiplication: {
-        number_args = 2;
-        precedence = 4;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Division: {
-        number_args = 2;
-        precedence = 4;
-        associativity = Associativity::Left;
-      } break;
-      case Op::Power: {
-        number_args = 2;
-        precedence = 5;
-        associativity = Associativity::Right;
-      } break;
-      case Op::Modulo: {
-        number_args = 2;
-        precedence = 4;
-        associativity = Associativity::Left;
-      } break;
-      case Op::AtId: {
-        number_args = 2;
-        precedence = 8;
-        associativity = Associativity::Left;
-      } break;
-      default: {
-        precedence = 1;
-        associativity = Associativity::Left;
-      }
-    }
-  }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class ExpressionListNode : public AstNode {
-public:
-  std::shared_ptr<ExpressionNode> root;
-
-  explicit ExpressionListNode() : AstNode(0) { }
-  explicit ExpressionListNode(size_t pos) : AstNode(pos) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class StatementNode : public AstNode {
-public:
-  StatementNode(size_t pos) : AstNode(pos) { }
-
-  virtual void accept(NodeVisitor& v) const = 0;
-};
-
-class ForStatementNode : public StatementNode {
-public:
-  ExpressionListNode condition;
-  BlockNode body;
-  BlockNode *const parent;
-
-  ForStatementNode(BlockNode *const parent, size_t pos) : StatementNode(pos), parent(parent) { }
-
-  virtual void accept(NodeVisitor& v) const = 0;
-};
-
-class ForArrayStatementNode : public ForStatementNode {
-public:
-  const std::string value;
-
-  explicit ForArrayStatementNode(const std::string& value, BlockNode *const parent, size_t pos) : ForStatementNode(parent, pos), value(value) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class ForObjectStatementNode : public ForStatementNode {
-public:
-  const std::string key;
-  const std::string value;
-
-  explicit ForObjectStatementNode(const std::string& key, const std::string& value, BlockNode *const parent, size_t pos) : ForStatementNode(parent, pos), key(key), value(value) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class IfStatementNode : public StatementNode {
-public:
-  ExpressionListNode condition;
-  BlockNode true_statement;
-  BlockNode false_statement;
-  BlockNode *const parent;
-
-  const bool is_nested;
-  bool has_false_statement {false};
-
-  explicit IfStatementNode(BlockNode *const parent, size_t pos) : StatementNode(pos), parent(parent), is_nested(false) { }
-  explicit IfStatementNode(bool is_nested, BlockNode *const parent, size_t pos) : StatementNode(pos), parent(parent), is_nested(is_nested) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class IncludeStatementNode : public StatementNode {
-public:
-  const std::string file;
-
-  explicit IncludeStatementNode(const std::string& file, size_t pos) : StatementNode(pos), file(file) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-class ExtendsStatementNode : public StatementNode {
-public:
-  const std::string file;
-
-  explicit ExtendsStatementNode(const std::string& file, size_t pos) : StatementNode(pos), file(file) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  };
-};
-
-class BlockStatementNode : public StatementNode {
-public:
-  const std::string name;
-  BlockNode block;
-  BlockNode *const parent;
-
-  explicit BlockStatementNode(BlockNode *const parent, const std::string& name, size_t pos) : StatementNode(pos), name(name), parent(parent) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  };
-};
-
-class SetStatementNode : public StatementNode {
-public:
-  const std::string key;
-  ExpressionListNode expression;
-
-  explicit SetStatementNode(const std::string& key, size_t pos) : StatementNode(pos), key(key) { }
-
-  void accept(NodeVisitor& v) const {
-    v.visit(*this);
-  }
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_NODE_HPP_
-
-// #include "statistics.hpp"
-#ifndef INCLUDE_INJA_STATISTICS_HPP_
-#define INCLUDE_INJA_STATISTICS_HPP_
-
-// #include "node.hpp"
-
-
-
-namespace inja {
-
-/*!
- * \brief A class for counting statistics on a Template.
- */
-class StatisticsVisitor : public NodeVisitor {
-  void visit(const BlockNode& node) {
-    for (auto& n : node.nodes) {
-      n->accept(*this);
-    }
-  }
-
-  void visit(const TextNode&) { }
-  void visit(const ExpressionNode&) { }
-  void visit(const LiteralNode&) { }
-
-  void visit(const JsonNode&) {
-    variable_counter += 1;
-  }
-
-  void visit(const FunctionNode& node) {
-    for (auto& n : node.arguments) {
-      n->accept(*this);
-    }
-  }
-
-  void visit(const ExpressionListNode& node) {
-    node.root->accept(*this);
-  }
-
-  void visit(const StatementNode&) { }
-  void visit(const ForStatementNode&) { }
-
-  void visit(const ForArrayStatementNode& node) {
-    node.condition.accept(*this);
-    node.body.accept(*this);
-  }
-
-  void visit(const ForObjectStatementNode& node) {
-    node.condition.accept(*this);
-    node.body.accept(*this);
-  }
-
-  void visit(const IfStatementNode& node) {
-    node.condition.accept(*this);
-    node.true_statement.accept(*this);
-    node.false_statement.accept(*this);
-  }
-
-  void visit(const IncludeStatementNode&) { }
-
-  void visit(const ExtendsStatementNode&) { }
-
-  void visit(const BlockStatementNode& node) {
-    node.block.accept(*this);
-  }
-
-  void visit(const SetStatementNode&) { }
-
-public:
-  unsigned int variable_counter;
-
-  explicit StatisticsVisitor() : variable_counter(0) { }
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_STATISTICS_HPP_
-
-
-
-namespace inja {
-
-/*!
- * \brief The main inja Template.
- */
-struct Template {
-  BlockNode root;
-  std::string content;
-  std::map<std::string, std::shared_ptr<BlockStatementNode>> block_storage;
-
-  explicit Template() { }
-  explicit Template(const std::string& content): content(content) { }
-
-  /// Return number of variables (total number, not distinct ones) in the template
-  int count_variables() {
-    auto statistic_visitor = StatisticsVisitor();
-    root.accept(statistic_visitor);
-    return statistic_visitor.variable_counter;
-  }
-};
-
-using TemplateStorage = std::map<std::string, Template>;
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_TEMPLATE_HPP_
-
-
-namespace inja {
-
-/*!
- * \brief Class for lexer configuration.
- */
-struct LexerConfig {
-  std::string statement_open {"{%"};
-  std::string statement_open_no_lstrip {"{%+"};
-  std::string statement_open_force_lstrip {"{%-"};
-  std::string statement_close {"%}"};
-  std::string statement_close_force_rstrip {"-%}"};
-  std::string line_statement {"##"};
-  std::string expression_open {"{{"};
-  std::string expression_open_force_lstrip {"{{-"};
-  std::string expression_close {"}}"};
-  std::string expression_close_force_rstrip {"-}}"};
-  std::string comment_open {"{#"};
-  std::string comment_open_force_lstrip {"{#-"};
-  std::string comment_close {"#}"};
-  std::string comment_close_force_rstrip {"-#}"};
-  std::string open_chars {"#{"};
-
-  bool trim_blocks {false};
-  bool lstrip_blocks {false};
-
-  void update_open_chars() {
-    open_chars = "";
-    if (open_chars.find(line_statement[0]) == std::string::npos) {
-      open_chars += line_statement[0];
-    }
-    if (open_chars.find(statement_open[0]) == std::string::npos) {
-      open_chars += statement_open[0];
-    }
-    if (open_chars.find(statement_open_no_lstrip[0]) == std::string::npos) {
-      open_chars += statement_open_no_lstrip[0];
-    }
-    if (open_chars.find(statement_open_force_lstrip[0]) == std::string::npos) {
-      open_chars += statement_open_force_lstrip[0];
-    }
-    if (open_chars.find(expression_open[0]) == std::string::npos) {
-      open_chars += expression_open[0];
-    }
-    if (open_chars.find(expression_open_force_lstrip[0]) == std::string::npos) {
-      open_chars += expression_open_force_lstrip[0];
-    }
-    if (open_chars.find(comment_open[0]) == std::string::npos) {
-      open_chars += comment_open[0];
-    }
-    if (open_chars.find(comment_open_force_lstrip[0]) == std::string::npos) {
-      open_chars += comment_open_force_lstrip[0];
-    }
-  }
-};
-
-/*!
- * \brief Class for parser configuration.
- */
-struct ParserConfig {
-  bool search_included_templates_in_files {true};
-
-  std::function<Template(const std::string&, const std::string&)> include_callback;
-};
-
-/*!
- * \brief Class for render configuration.
- */
-struct RenderConfig {
-  bool throw_at_missing_includes {true};
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_CONFIG_HPP_
-
-// #include "function_storage.hpp"
-
-// #include "parser.hpp"
-#ifndef INCLUDE_INJA_PARSER_HPP_
-#define INCLUDE_INJA_PARSER_HPP_
-
-#include <limits>
-#include <stack>
-#include <string>
-#include <utility>
-#include <queue>
-#include <vector>
-
-// #include "config.hpp"
-
-// #include "exceptions.hpp"
-
-// #include "function_storage.hpp"
-
-// #include "lexer.hpp"
-#ifndef INCLUDE_INJA_LEXER_HPP_
-#define INCLUDE_INJA_LEXER_HPP_
-
-#include <cctype>
-#include <locale>
-
-// #include "config.hpp"
-
-// #include "token.hpp"
-#ifndef INCLUDE_INJA_TOKEN_HPP_
-#define INCLUDE_INJA_TOKEN_HPP_
-
-#include <string>
-
-// #include "string_view.hpp"
-
-
-namespace inja {
-
-/*!
- * \brief Helper-class for the inja Lexer.
- */
-struct Token {
-  enum class Kind {
-    Text,
-    ExpressionOpen,     // {{
-    ExpressionClose,    // }}
-    LineStatementOpen,  // ##
-    LineStatementClose, // \n
-    StatementOpen,      // {%
-    StatementClose,     // %}
-    CommentOpen,        // {#
-    CommentClose,       // #}
-    Id,                 // this, this.foo
-    Number,             // 1, 2, -1, 5.2, -5.3
-    String,             // "this"
-    Plus,               // +
-    Minus,              // -
-    Times,              // *
-    Slash,              // /
-    Percent,            // %
-    Power,              // ^
-    Comma,              // ,
-    Dot,                // .
-    Colon,              // :
-    LeftParen,          // (
-    RightParen,         // )
-    LeftBracket,        // [
-    RightBracket,       // ]
-    LeftBrace,          // {
-    RightBrace,         // }
-    Equal,              // ==
-    NotEqual,           // !=
-    GreaterThan,        // >
-    GreaterEqual,       // >=
-    LessThan,           // <
-    LessEqual,          // <=
-    Unknown,
-    Eof,
-  };
-  
-  Kind kind {Kind::Unknown};
-  nonstd::string_view text;
-
-  explicit constexpr Token() = default;
-  explicit constexpr Token(Kind kind, nonstd::string_view text) : kind(kind), text(text) {}
-
-  std::string describe() const {
-    switch (kind) {
-    case Kind::Text:
-      return "<text>";
-    case Kind::LineStatementClose:
-      return "<eol>";
-    case Kind::Eof:
-      return "<eof>";
-    default:
-      return static_cast<std::string>(text);
-    }
-  }
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_TOKEN_HPP_
-
-// #include "utils.hpp"
-
-
-namespace inja {
-
-/*!
- * \brief Class for lexing an inja Template.
- */
-class Lexer {
-  enum class State {
-    Text,
-    ExpressionStart,
-    ExpressionStartForceLstrip,
-    ExpressionBody,
-    LineStart,
-    LineBody,
-    StatementStart,
-    StatementStartNoLstrip,
-    StatementStartForceLstrip,
-    StatementBody,
-    CommentStart,
-    CommentStartForceLstrip,
-    CommentBody,
-  };
-
-  enum class MinusState {
-    Operator,
-    Number,
-  };
-
-  const LexerConfig &config;
-
-  State state;
-  MinusState minus_state;
-  nonstd::string_view m_in;
-  size_t tok_start;
-  size_t pos;
-
-
-  Token scan_body(nonstd::string_view close, Token::Kind closeKind, nonstd::string_view close_trim = nonstd::string_view(), bool trim = false) {
-  again:
-    // skip whitespace (except for \n as it might be a close)
-    if (tok_start >= m_in.size()) {
-      return make_token(Token::Kind::Eof);
-    }
-    const char ch = m_in[tok_start];
-    if (ch == ' ' || ch == '\t' || ch == '\r') {
-      tok_start += 1;
-      goto again;
-    }
-
-    // check for close
-    if (!close_trim.empty() && inja::string_view::starts_with(m_in.substr(tok_start), close_trim)) {
-      state = State::Text;
-      pos = tok_start + close_trim.size();
-      const Token tok = make_token(closeKind);
-      skip_whitespaces_and_newlines();
-      return tok;
-    }
-
-    if (inja::string_view::starts_with(m_in.substr(tok_start), close)) {
-      state = State::Text;
-      pos = tok_start + close.size();
-      const Token tok = make_token(closeKind);
-      if (trim) {
-        skip_whitespaces_and_first_newline();
-      }
-      return tok;
-    }
-
-    // skip \n
-    if (ch == '\n') {
-      tok_start += 1;
-      goto again;
-    }
-
-    pos = tok_start + 1;
-    if (std::isalpha(ch)) {
-      minus_state = MinusState::Operator;
-      return scan_id();
-    }
-
-    const MinusState current_minus_state = minus_state;
-    if (minus_state == MinusState::Operator) {
-      minus_state = MinusState::Number;
-    }
-
-    switch (ch) {
-    case '+':
-      return make_token(Token::Kind::Plus);
-    case '-':
-      if (current_minus_state == MinusState::Operator) {
-        return make_token(Token::Kind::Minus);
-      }
-      return scan_number();
-    case '*':
-      return make_token(Token::Kind::Times);
-    case '/':
-      return make_token(Token::Kind::Slash);
-    case '^':
-      return make_token(Token::Kind::Power);
-    case '%':
-      return make_token(Token::Kind::Percent);
-    case '.':
-      return make_token(Token::Kind::Dot);
-    case ',':
-      return make_token(Token::Kind::Comma);
-    case ':':
-      return make_token(Token::Kind::Colon);
-    case '(':
-      return make_token(Token::Kind::LeftParen);
-    case ')':
-      minus_state = MinusState::Operator;
-      return make_token(Token::Kind::RightParen);
-    case '[':
-      return make_token(Token::Kind::LeftBracket);
-    case ']':
-      minus_state = MinusState::Operator;
-      return make_token(Token::Kind::RightBracket);
-    case '{':
-      return make_token(Token::Kind::LeftBrace);
-    case '}':
-      minus_state = MinusState::Operator;
-      return make_token(Token::Kind::RightBrace);
-    case '>':
-      if (pos < m_in.size() && m_in[pos] == '=') {
-        pos += 1;
-        return make_token(Token::Kind::GreaterEqual);
-      }
-      return make_token(Token::Kind::GreaterThan);
-    case '<':
-      if (pos < m_in.size() && m_in[pos] == '=') {
-        pos += 1;
-        return make_token(Token::Kind::LessEqual);
-      }
-      return make_token(Token::Kind::LessThan);
-    case '=':
-      if (pos < m_in.size() && m_in[pos] == '=') {
-        pos += 1;
-        return make_token(Token::Kind::Equal);
-      }
-      return make_token(Token::Kind::Unknown);
-    case '!':
-      if (pos < m_in.size() && m_in[pos] == '=') {
-        pos += 1;
-        return make_token(Token::Kind::NotEqual);
-      }
-      return make_token(Token::Kind::Unknown);
-    case '\"':
-      return scan_string();
-    case '0':
-    case '1':
-    case '2':
-    case '3':
-    case '4':
-    case '5':
-    case '6':
-    case '7':
-    case '8':
-    case '9':
-      minus_state = MinusState::Operator;
-      return scan_number();
-    case '_':
-    case '@':
-    case '$':
-      minus_state = MinusState::Operator;
-      return scan_id();
-    default:
-      return make_token(Token::Kind::Unknown);
-    }
-  }
-
-  Token scan_id() {
-    for (;;) {
-      if (pos >= m_in.size()) {
-        break;
-      }
-      const char ch = m_in[pos];
-      if (!std::isalnum(ch) && ch != '.' && ch != '/' && ch != '_' && ch != '-') {
-        break;
-      }
-      pos += 1;
-    }
-    return make_token(Token::Kind::Id);
-  }
-
-  Token scan_number() {
-    for (;;) {
-      if (pos >= m_in.size()) {
-        break;
-      }
-      const char ch = m_in[pos];
-      // be very permissive in lexer (we'll catch errors when conversion happens)
-      if (!std::isdigit(ch) && ch != '.' && ch != 'e' && ch != 'E' && ch != '+' && ch != '-') {
-        break;
-      }
-      pos += 1;
-    }
-    return make_token(Token::Kind::Number);
-  }
-
-  Token scan_string() {
-    bool escape {false};
-    for (;;) {
-      if (pos >= m_in.size()) {
-        break;
-      }
-      const char ch = m_in[pos++];
-      if (ch == '\\') {
-        escape = true;
-      } else if (!escape && ch == m_in[tok_start]) {
-        break;
-      } else {
-        escape = false;
-      }
-    }
-    return make_token(Token::Kind::String);
-  }
-
-  Token make_token(Token::Kind kind) const { return Token(kind, string_view::slice(m_in, tok_start, pos)); }
-
-  void skip_whitespaces_and_newlines() {
-    if (pos < m_in.size()) {
-      while (pos < m_in.size() && (m_in[pos] == ' ' || m_in[pos] == '\t' || m_in[pos] == '\n' || m_in[pos] == '\r')) {
-        pos += 1;
-      }
-    }
-  }
-
-  void skip_whitespaces_and_first_newline() {
-    if (pos < m_in.size()) {
-      while (pos < m_in.size() && (m_in[pos] == ' ' || m_in[pos] == '\t')) {
-        pos += 1;
-      }
-    }
-
-    if (pos < m_in.size()) {
-      const char ch = m_in[pos];
-      if (ch == '\n') {
-        pos += 1;
-      } else if (ch == '\r') {
-        pos += 1;
-        if (pos < m_in.size() && m_in[pos] == '\n') {
-          pos += 1;
-        }
-      }
-    }
-  }
-
-  static nonstd::string_view clear_final_line_if_whitespace(nonstd::string_view text) {
-    nonstd::string_view result = text;
-    while (!result.empty()) {
-      const char ch = result.back();
-      if (ch == ' ' || ch == '\t') {
-        result.remove_suffix(1);
-      } else if (ch == '\n' || ch == '\r') {
-        break;
-      } else {
-        return text;
-      }
-    }
-    return result;
-  }
-
-public:
-  explicit Lexer(const LexerConfig &config) : config(config), state(State::Text), minus_state(MinusState::Number) {}
-
-  SourceLocation current_position() const {
-    return get_source_location(m_in, tok_start);
-  }
-
-  void start(nonstd::string_view input) {
-    m_in = input;
-    tok_start = 0;
-    pos = 0;
-    state = State::Text;
-    minus_state = MinusState::Number;
-
-    // Consume byte order mark (BOM) for UTF-8
-    if (inja::string_view::starts_with(m_in, "\xEF\xBB\xBF")) {
-      m_in = m_in.substr(3);
-    }
-  }
-
-  Token scan() {
-    tok_start = pos;
-
-  again:
-    if (tok_start >= m_in.size()) {
-      return make_token(Token::Kind::Eof);
-    }
-
-    switch (state) {
-    default:
-    case State::Text: {
-      // fast-scan to first open character
-      const size_t open_start = m_in.substr(pos).find_first_of(config.open_chars);
-      if (open_start == nonstd::string_view::npos) {
-        // didn't find open, return remaining text as text token
-        pos = m_in.size();
-        return make_token(Token::Kind::Text);
-      }
-      pos += open_start;
-
-      // try to match one of the opening sequences, and get the close
-      nonstd::string_view open_str = m_in.substr(pos);
-      bool must_lstrip = false;
-      if (inja::string_view::starts_with(open_str, config.expression_open)) {
-        if (inja::string_view::starts_with(open_str, config.expression_open_force_lstrip)) {
-          state = State::ExpressionStartForceLstrip;
-          must_lstrip = true;
-        } else {
-          state = State::ExpressionStart;
-        }
-      } else if (inja::string_view::starts_with(open_str, config.statement_open)) {
-        if (inja::string_view::starts_with(open_str, config.statement_open_no_lstrip)) {
-          state = State::StatementStartNoLstrip;
-        } else if (inja::string_view::starts_with(open_str, config.statement_open_force_lstrip )) {
-          state = State::StatementStartForceLstrip;
-          must_lstrip = true;
-        } else {
-          state = State::StatementStart;
-          must_lstrip = config.lstrip_blocks;
-        }
-      } else if (inja::string_view::starts_with(open_str, config.comment_open)) {
-        if (inja::string_view::starts_with(open_str, config.comment_open_force_lstrip)) {
-          state = State::CommentStartForceLstrip;
-          must_lstrip = true;
-        } else {
-          state = State::CommentStart;
-          must_lstrip = config.lstrip_blocks;
-        }
-      } else if ((pos == 0 || m_in[pos - 1] == '\n') && inja::string_view::starts_with(open_str, config.line_statement)) {
-        state = State::LineStart;
-      } else {
-        pos += 1; // wasn't actually an opening sequence
-        goto again;
-      }
-
-      nonstd::string_view text = string_view::slice(m_in, tok_start, pos);
-      if (must_lstrip) {
-        text = clear_final_line_if_whitespace(text);
-      }
-
-      if (text.empty()) {
-        goto again; // don't generate empty token
-      }
-      return Token(Token::Kind::Text, text);
-    }
-    case State::ExpressionStart: {
-      state = State::ExpressionBody;
-      pos += config.expression_open.size();
-      return make_token(Token::Kind::ExpressionOpen);
-    }
-    case State::ExpressionStartForceLstrip: {
-      state = State::ExpressionBody;
-      pos += config.expression_open_force_lstrip.size();
-      return make_token(Token::Kind::ExpressionOpen);
-    }
-    case State::LineStart: {
-      state = State::LineBody;
-      pos += config.line_statement.size();
-      return make_token(Token::Kind::LineStatementOpen);
-    }
-    case State::StatementStart: {
-      state = State::StatementBody;
-      pos += config.statement_open.size();
-      return make_token(Token::Kind::StatementOpen);
-    }
-    case State::StatementStartNoLstrip: {
-      state = State::StatementBody;
-      pos += config.statement_open_no_lstrip.size();
-      return make_token(Token::Kind::StatementOpen);
-    }
-    case State::StatementStartForceLstrip: {
-      state = State::StatementBody;
-      pos += config.statement_open_force_lstrip.size();
-      return make_token(Token::Kind::StatementOpen);
-    }
-    case State::CommentStart: {
-      state = State::CommentBody;
-      pos += config.comment_open.size();
-      return make_token(Token::Kind::CommentOpen);
-    }
-    case State::CommentStartForceLstrip: {
-      state = State::CommentBody;
-      pos += config.comment_open_force_lstrip.size();
-      return make_token(Token::Kind::CommentOpen);
-    }
-    case State::ExpressionBody:
-      return scan_body(config.expression_close, Token::Kind::ExpressionClose, config.expression_close_force_rstrip);
-    case State::LineBody:
-      return scan_body("\n", Token::Kind::LineStatementClose);
-    case State::StatementBody:
-      return scan_body(config.statement_close, Token::Kind::StatementClose, config.statement_close_force_rstrip, config.trim_blocks);
-    case State::CommentBody: {
-      // fast-scan to comment close
-      const size_t end = m_in.substr(pos).find(config.comment_close);
-      if (end == nonstd::string_view::npos) {
-        pos = m_in.size();
-        return make_token(Token::Kind::Eof);
-      }
-
-      // Check for trim pattern
-      const bool must_rstrip = inja::string_view::starts_with(m_in.substr(pos + end - 1), config.comment_close_force_rstrip);
-
-      // return the entire comment in the close token
-      state = State::Text;
-      pos += end + config.comment_close.size();
-      Token tok = make_token(Token::Kind::CommentClose);
-
-      if (must_rstrip || config.trim_blocks) {
-        skip_whitespaces_and_first_newline();
-      }
-      return tok;
-    }
-    }
-  }
-
-  const LexerConfig &get_config() const {
-    return config;
-  }
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_LEXER_HPP_
-
-// #include "node.hpp"
-
-// #include "template.hpp"
-
-// #include "token.hpp"
-
-// #include "utils.hpp"
-
-
-
-namespace inja {
-
-/*!
- * \brief Class for parsing an inja Template.
- */
-class Parser {
-  const ParserConfig &config;
-
-  Lexer lexer;
-  TemplateStorage &template_storage;
-  const FunctionStorage &function_storage;
-
-  Token tok, peek_tok;
-  bool have_peek_tok {false};
-
-  size_t current_paren_level {0};
-  size_t current_bracket_level {0};
-  size_t current_brace_level {0};
-
-  nonstd::string_view json_literal_start;
-
-  BlockNode *current_block {nullptr};
-  ExpressionListNode *current_expression_list {nullptr};
-  std::stack<std::pair<FunctionNode*, size_t>> function_stack;
-  std::vector<std::shared_ptr<ExpressionNode>> arguments;
-
-  std::stack<std::shared_ptr<FunctionNode>> operator_stack;
-  std::stack<IfStatementNode*> if_statement_stack;
-  std::stack<ForStatementNode*> for_statement_stack;
-  std::stack<BlockStatementNode*> block_statement_stack;
-
-  inline void throw_parser_error(const std::string &message) {
-    INJA_THROW(ParserError(message, lexer.current_position()));
-  }
-
-  inline void get_next_token() {
-    if (have_peek_tok) {
-      tok = peek_tok;
-      have_peek_tok = false;
-    } else {
-      tok = lexer.scan();
-    }
-  }
-
-  inline void get_peek_token() {
-    if (!have_peek_tok) {
-      peek_tok = lexer.scan();
-      have_peek_tok = true;
-    }
-  }
-
-  inline void add_json_literal(const char* content_ptr) {
-    nonstd::string_view json_text(json_literal_start.data(), tok.text.data() - json_literal_start.data() + tok.text.size());
-    arguments.emplace_back(std::make_shared<LiteralNode>(json::parse(json_text), json_text.data() - content_ptr));
-  }
-
-  inline void add_operator() {
-    auto function = operator_stack.top();
-    operator_stack.pop();
-
-    for (int i = 0; i < function->number_args; ++i) {
-      function->arguments.insert(function->arguments.begin(), arguments.back());
-      arguments.pop_back();
-    }
-    arguments.emplace_back(function);
-  }
-
-  void add_to_template_storage(nonstd::string_view path, std::string& template_name) {
-    if (template_storage.find(template_name) != template_storage.end()) {
-      return;
-    }
-
-    std::string original_path = static_cast<std::string>(path);
-    std::string original_name = template_name;
-
-    if (config.search_included_templates_in_files) {
-      // Build the relative path
-      template_name = original_path + original_name;
-      if (template_name.compare(0, 2, "./") == 0) {
-        template_name.erase(0, 2);
-      }
-
-      if (template_storage.find(template_name) == template_storage.end()) {
-        // Load file
-        std::ifstream file;
-        file.open(template_name);
-        if (!file.fail()) {
-          std::string text((std::istreambuf_iterator<char>(file)), std::istreambuf_iterator<char>());
-
-          auto include_template = Template(text);
-          template_storage.emplace(template_name, include_template);
-          parse_into_template(template_storage[template_name], template_name);
-          return;
-
-        } else if (!config.include_callback) {
-          INJA_THROW(FileError("failed accessing file at '" + template_name + "'"));
-        }
-      }
-    }
-
-    // Try include callback
-    if (config.include_callback) {
-      auto include_template = config.include_callback(original_path, original_name);
-      template_storage.emplace(template_name, include_template);
-    }
-  }
-
-  bool parse_expression(Template &tmpl, Token::Kind closing) {
-    while (tok.kind != closing && tok.kind != Token::Kind::Eof) {
-      // Literals
-      switch (tok.kind) {
-      case Token::Kind::String: {
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          json_literal_start = tok.text;
-          add_json_literal(tmpl.content.c_str());
-        }
-
-      } break;
-      case Token::Kind::Number: {
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          json_literal_start = tok.text;
-          add_json_literal(tmpl.content.c_str());
-        }
-
-      } break;
-      case Token::Kind::LeftBracket: {
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          json_literal_start = tok.text;
-        }
-        current_bracket_level += 1;
-
-      } break;
-      case Token::Kind::LeftBrace: {
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          json_literal_start = tok.text;
-        }
-        current_brace_level += 1;
-
-      } break;
-      case Token::Kind::RightBracket: {
-        if (current_bracket_level == 0) {
-          throw_parser_error("unexpected ']'");
-        }
-
-        current_bracket_level -= 1;
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          add_json_literal(tmpl.content.c_str());
-        }
-
-      } break;
-      case Token::Kind::RightBrace: {
-        if (current_brace_level == 0) {
-          throw_parser_error("unexpected '}'");
-        }
-
-        current_brace_level -= 1;
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          add_json_literal(tmpl.content.c_str());
-        }
-
-      } break;
-      case Token::Kind::Id: {
-        get_peek_token();
-
-        // Json Literal
-        if (tok.text == static_cast<decltype(tok.text)>("true") || tok.text == static_cast<decltype(tok.text)>("false") || tok.text == static_cast<decltype(tok.text)>("null")) {
-          if (current_brace_level == 0 && current_bracket_level == 0) {
-            json_literal_start = tok.text;
-            add_json_literal(tmpl.content.c_str());
-          }
-
-	      // Operator
-        } else if (tok.text == "and" || tok.text == "or" || tok.text == "in" || tok.text == "not") {
-          goto parse_operator;
-
-        // Functions
-        } else if (peek_tok.kind == Token::Kind::LeftParen) {
-          operator_stack.emplace(std::make_shared<FunctionNode>(static_cast<std::string>(tok.text), tok.text.data() - tmpl.content.c_str()));
-          function_stack.emplace(operator_stack.top().get(), current_paren_level);       
-
-        // Variables
-        } else {
-          arguments.emplace_back(std::make_shared<JsonNode>(static_cast<std::string>(tok.text), tok.text.data() - tmpl.content.c_str()));
-        }
-
-      // Operators
-      } break;
-      case Token::Kind::Equal:
-      case Token::Kind::NotEqual:
-      case Token::Kind::GreaterThan:
-      case Token::Kind::GreaterEqual:
-      case Token::Kind::LessThan:
-      case Token::Kind::LessEqual:
-      case Token::Kind::Plus:
-      case Token::Kind::Minus:
-      case Token::Kind::Times:
-      case Token::Kind::Slash:
-      case Token::Kind::Power:
-      case Token::Kind::Percent:
-      case Token::Kind::Dot: {
-
-  parse_operator:
-        FunctionStorage::Operation operation;
-        switch (tok.kind) {
-        case Token::Kind::Id: {
-          if (tok.text == "and") {
-            operation = FunctionStorage::Operation::And;
-          } else if (tok.text == "or") {
-            operation = FunctionStorage::Operation::Or;
-          } else if (tok.text == "in") {
-            operation = FunctionStorage::Operation::In;
-          } else if (tok.text == "not") {
-            operation = FunctionStorage::Operation::Not;
-          } else {
-            throw_parser_error("unknown operator in parser.");
-          }
-        } break;
-        case Token::Kind::Equal: {
-          operation = FunctionStorage::Operation::Equal;
-        } break;
-        case Token::Kind::NotEqual: {
-          operation = FunctionStorage::Operation::NotEqual;
-        } break;
-        case Token::Kind::GreaterThan: {
-          operation = FunctionStorage::Operation::Greater;
-        } break;
-        case Token::Kind::GreaterEqual: {
-          operation = FunctionStorage::Operation::GreaterEqual;
-        } break;
-        case Token::Kind::LessThan: {
-          operation = FunctionStorage::Operation::Less;
-        } break;
-        case Token::Kind::LessEqual: {
-          operation = FunctionStorage::Operation::LessEqual;
-        } break;
-        case Token::Kind::Plus: {
-          operation = FunctionStorage::Operation::Add;
-        } break;
-        case Token::Kind::Minus: {
-          operation = FunctionStorage::Operation::Subtract;
-        } break;
-        case Token::Kind::Times: {
-          operation = FunctionStorage::Operation::Multiplication;
-        } break;
-        case Token::Kind::Slash: {
-          operation = FunctionStorage::Operation::Division;
-        } break;
-        case Token::Kind::Power: {
-          operation = FunctionStorage::Operation::Power;
-        } break;
-        case Token::Kind::Percent: {
-          operation = FunctionStorage::Operation::Modulo;
-        } break;
-        case Token::Kind::Dot: {
-          operation = FunctionStorage::Operation::AtId;
-        } break;
-        default: {
-          throw_parser_error("unknown operator in parser.");
-        }
-        }
-        auto function_node = std::make_shared<FunctionNode>(operation, tok.text.data() - tmpl.content.c_str());
-
-        while (!operator_stack.empty() && ((operator_stack.top()->precedence > function_node->precedence) || (operator_stack.top()->precedence == function_node->precedence && function_node->associativity == FunctionNode::Associativity::Left)) && (operator_stack.top()->operation != FunctionStorage::Operation::ParenLeft)) {
-          add_operator();
-        }
-
-        operator_stack.emplace(function_node);
-
-      } break;
-      case Token::Kind::Comma: {
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          if (function_stack.empty()) {
-            throw_parser_error("unexpected ','");
-          }
-
-          function_stack.top().first->number_args += 1;
-        }
-
-      } break;
-      case Token::Kind::Colon: {
-        if (current_brace_level == 0 && current_bracket_level == 0) {
-          throw_parser_error("unexpected ':'");
-        }
-
-      } break;
-      case Token::Kind::LeftParen: {
-        current_paren_level += 1;
-        operator_stack.emplace(std::make_shared<FunctionNode>(FunctionStorage::Operation::ParenLeft, tok.text.data() - tmpl.content.c_str()));
-
-        get_peek_token();
-        if (peek_tok.kind == Token::Kind::RightParen) {
-          if (!function_stack.empty() && function_stack.top().second == current_paren_level - 1) {
-            function_stack.top().first->number_args = 0;
-          }
-        }
-
-      } break;
-      case Token::Kind::RightParen: {
-        current_paren_level -= 1;
-        while (!operator_stack.empty() && operator_stack.top()->operation != FunctionStorage::Operation::ParenLeft) {
-          add_operator();
-        }
-
-        if (!operator_stack.empty() && operator_stack.top()->operation == FunctionStorage::Operation::ParenLeft) {
-          operator_stack.pop();
-        }
-
-        if (!function_stack.empty() && function_stack.top().second == current_paren_level) {
-          auto func = function_stack.top().first;
-          auto function_data = function_storage.find_function(func->name, func->number_args);
-          if (function_data.operation == FunctionStorage::Operation::None) {
-            throw_parser_error("unknown function " + func->name);
-          }
-          func->operation = function_data.operation;
-          if (function_data.operation == FunctionStorage::Operation::Callback) {
-            func->callback = function_data.callback;
-          }
-
-          if (operator_stack.empty()) {
-            throw_parser_error("internal error at function " + func->name);
-          }
-
-          add_operator();
-          function_stack.pop();
-        }
-      }
-      default:
-        break;
-      }
-
-      get_next_token();
-    }
-
-    while (!operator_stack.empty()) {
-      add_operator();
-    }
-
-    if (arguments.size() == 1) {
-      current_expression_list->root = arguments[0];
-      arguments = {};
-
-    } else if (arguments.size() > 1) {
-      throw_parser_error("malformed expression");
-    }
-    
-    return true;
-  }
-
-  bool parse_statement(Template &tmpl, Token::Kind closing, nonstd::string_view path) {
-    if (tok.kind != Token::Kind::Id) {
-      return false;
-    }
-
-    if (tok.text == static_cast<decltype(tok.text)>("if")) {
-      get_next_token();
-
-      auto if_statement_node = std::make_shared<IfStatementNode>(current_block, tok.text.data() - tmpl.content.c_str());
-      current_block->nodes.emplace_back(if_statement_node);
-      if_statement_stack.emplace(if_statement_node.get());
-      current_block = &if_statement_node->true_statement;
-      current_expression_list = &if_statement_node->condition;
-
-      if (!parse_expression(tmpl, closing)) {
-        return false;
-      }
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("else")) {
-      if (if_statement_stack.empty()) {
-        throw_parser_error("else without matching if");
-      }
-      auto &if_statement_data = if_statement_stack.top();
-      get_next_token();
-
-      if_statement_data->has_false_statement = true;
-      current_block = &if_statement_data->false_statement;
-
-      // Chained else if
-      if (tok.kind == Token::Kind::Id && tok.text == static_cast<decltype(tok.text)>("if")) {
-        get_next_token();
-
-        auto if_statement_node = std::make_shared<IfStatementNode>(true, current_block, tok.text.data() - tmpl.content.c_str());
-        current_block->nodes.emplace_back(if_statement_node);
-        if_statement_stack.emplace(if_statement_node.get());
-        current_block = &if_statement_node->true_statement;
-        current_expression_list = &if_statement_node->condition;
-
-        if (!parse_expression(tmpl, closing)) {
-          return false;
-        }
-      }
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("endif")) {
-      if (if_statement_stack.empty()) {
-        throw_parser_error("endif without matching if");
-      }
-
-      // Nested if statements
-      while (if_statement_stack.top()->is_nested) {
-        if_statement_stack.pop();
-      }
-
-      auto &if_statement_data = if_statement_stack.top();
-      get_next_token();
-
-      current_block = if_statement_data->parent;
-      if_statement_stack.pop();
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("block")) {
-      get_next_token();
-
-      if (tok.kind != Token::Kind::Id) {
-        throw_parser_error("expected block name, got '" + tok.describe() + "'");
-      }
-
-      const std::string block_name = static_cast<std::string>(tok.text);
-
-      auto block_statement_node = std::make_shared<BlockStatementNode>(current_block, block_name, tok.text.data() - tmpl.content.c_str());
-      current_block->nodes.emplace_back(block_statement_node);
-      block_statement_stack.emplace(block_statement_node.get());
-      current_block = &block_statement_node->block;
-      auto success = tmpl.block_storage.emplace(block_name, block_statement_node);
-      if (!success.second) {
-        throw_parser_error("block with the name '" + block_name + "' does already exist");
-      }
-
-      get_next_token();
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("endblock")) {
-      if (block_statement_stack.empty()) {
-        throw_parser_error("endblock without matching block");
-      }
-
-      auto &block_statement_data = block_statement_stack.top();
-      get_next_token();
-
-      current_block = block_statement_data->parent;
-      block_statement_stack.pop();
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("for")) {
-      get_next_token();
-
-      // options: for a in arr; for a, b in obj
-      if (tok.kind != Token::Kind::Id) {
-        throw_parser_error("expected id, got '" + tok.describe() + "'");
-      }
-
-      Token value_token = tok;
-      get_next_token();
-
-      // Object type
-      std::shared_ptr<ForStatementNode> for_statement_node;
-      if (tok.kind == Token::Kind::Comma) {
-        get_next_token();
-        if (tok.kind != Token::Kind::Id) {
-          throw_parser_error("expected id, got '" + tok.describe() + "'");
-        }
-
-        Token key_token = std::move(value_token);
-        value_token = tok;
-        get_next_token();
-
-        for_statement_node = std::make_shared<ForObjectStatementNode>(static_cast<std::string>(key_token.text), static_cast<std::string>(value_token.text), current_block, tok.text.data() - tmpl.content.c_str());
-
-      // Array type
-      } else {
-        for_statement_node = std::make_shared<ForArrayStatementNode>(static_cast<std::string>(value_token.text), current_block, tok.text.data() - tmpl.content.c_str());
-      }
-
-      current_block->nodes.emplace_back(for_statement_node);
-      for_statement_stack.emplace(for_statement_node.get());
-      current_block = &for_statement_node->body;
-      current_expression_list = &for_statement_node->condition;
-
-      if (tok.kind != Token::Kind::Id || tok.text != static_cast<decltype(tok.text)>("in")) {
-        throw_parser_error("expected 'in', got '" + tok.describe() + "'");
-      }
-      get_next_token();
-
-      if (!parse_expression(tmpl, closing)) {
-        return false;
-      }
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("endfor")) {
-      if (for_statement_stack.empty()) {
-        throw_parser_error("endfor without matching for");
-      }
-
-      auto &for_statement_data = for_statement_stack.top();
-      get_next_token();
-
-      current_block = for_statement_data->parent;
-      for_statement_stack.pop();
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("include")) {
-      get_next_token();
-
-      if (tok.kind != Token::Kind::String) {
-        throw_parser_error("expected string, got '" + tok.describe() + "'");
-      }
-
-      std::string template_name = json::parse(tok.text).get_ref<const std::string &>();
-      add_to_template_storage(path, template_name);
-
-      current_block->nodes.emplace_back(std::make_shared<IncludeStatementNode>(template_name, tok.text.data() - tmpl.content.c_str()));
-
-      get_next_token();
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("extends")) {
-      get_next_token();
-
-      if (tok.kind != Token::Kind::String) {
-        throw_parser_error("expected string, got '" + tok.describe() + "'");
-      }
-
-      std::string template_name = json::parse(tok.text).get_ref<const std::string &>();
-      add_to_template_storage(path, template_name);
-
-      current_block->nodes.emplace_back(std::make_shared<ExtendsStatementNode>(template_name, tok.text.data() - tmpl.content.c_str()));
-
-      get_next_token();
-
-    } else if (tok.text == static_cast<decltype(tok.text)>("set")) {
-      get_next_token();
-
-      if (tok.kind != Token::Kind::Id) {
-        throw_parser_error("expected variable name, got '" + tok.describe() + "'");
-      }
-
-      std::string key = static_cast<std::string>(tok.text);
-      get_next_token();
-
-      auto set_statement_node = std::make_shared<SetStatementNode>(key, tok.text.data() - tmpl.content.c_str());
-      current_block->nodes.emplace_back(set_statement_node);
-      current_expression_list = &set_statement_node->expression;
-
-      if (tok.text != static_cast<decltype(tok.text)>("=")) {
-        throw_parser_error("expected '=', got '" + tok.describe() + "'");
-      }
-      get_next_token();
-
-      if (!parse_expression(tmpl, closing)) {
-        return false;
-      }
-
-    } else {
-      return false;
-    }
-    return true;
-  }
-
-  void parse_into(Template &tmpl, nonstd::string_view path) {
-    lexer.start(tmpl.content);
-    current_block = &tmpl.root;
-
-    for (;;) {
-      get_next_token();
-      switch (tok.kind) {
-      case Token::Kind::Eof: {
-        if (!if_statement_stack.empty()) {
-          throw_parser_error("unmatched if");
-        }
-        if (!for_statement_stack.empty()) {
-          throw_parser_error("unmatched for");
-        }
-      } return;
-      case Token::Kind::Text: {
-        current_block->nodes.emplace_back(std::make_shared<TextNode>(tok.text.data() - tmpl.content.c_str(), tok.text.size()));
-      } break;
-      case Token::Kind::StatementOpen: {
-        get_next_token();
-        if (!parse_statement(tmpl, Token::Kind::StatementClose, path)) {
-          throw_parser_error("expected statement, got '" + tok.describe() + "'");
-        }
-        if (tok.kind != Token::Kind::StatementClose) {
-          throw_parser_error("expected statement close, got '" + tok.describe() + "'");
-        }
-      } break;
-      case Token::Kind::LineStatementOpen: {
-        get_next_token();
-        if (!parse_statement(tmpl, Token::Kind::LineStatementClose, path)) {
-          throw_parser_error("expected statement, got '" + tok.describe() + "'");
-        }
-        if (tok.kind != Token::Kind::LineStatementClose && tok.kind != Token::Kind::Eof) {
-          throw_parser_error("expected line statement close, got '" + tok.describe() + "'");
-        }
-      } break;
-      case Token::Kind::ExpressionOpen: {
-        get_next_token();
-
-        auto expression_list_node = std::make_shared<ExpressionListNode>(tok.text.data() - tmpl.content.c_str());
-        current_block->nodes.emplace_back(expression_list_node);
-        current_expression_list = expression_list_node.get();
-
-        if (!parse_expression(tmpl, Token::Kind::ExpressionClose)) {
-          throw_parser_error("expected expression, got '" + tok.describe() + "'");
-        }
-
-        if (tok.kind != Token::Kind::ExpressionClose) {
-          throw_parser_error("expected expression close, got '" + tok.describe() + "'");
-        }
-      } break;
-      case Token::Kind::CommentOpen: {
-        get_next_token();
-        if (tok.kind != Token::Kind::CommentClose) {
-          throw_parser_error("expected comment close, got '" + tok.describe() + "'");
-        }
-      } break;
-      default: {
-        throw_parser_error("unexpected token '" + tok.describe() + "'");
-      } break;
-      }
-    }
-  }
-
-
-public:
-  explicit Parser(const ParserConfig &parser_config, const LexerConfig &lexer_config,
-                  TemplateStorage &template_storage, const FunctionStorage &function_storage)
-      : config(parser_config), lexer(lexer_config), template_storage(template_storage), function_storage(function_storage) { }
-
-  Template parse(nonstd::string_view input, nonstd::string_view path) {
-    auto result = Template(static_cast<std::string>(input));
-    parse_into(result, path);
-    return result;
-  }
-
-  Template parse(nonstd::string_view input) {
-    return parse(input, "./");
-  }
-
-  void parse_into_template(Template& tmpl, nonstd::string_view filename) {
-    nonstd::string_view path = filename.substr(0, filename.find_last_of("/\\") + 1);
-
-    // StringRef path = sys::path::parent_path(filename);
-    auto sub_parser = Parser(config, lexer.get_config(), template_storage, function_storage);
-    sub_parser.parse_into(tmpl, path);
-  }
-
-  std::string load_file(const std::string& filename) {
-    std::ifstream file;
-    file.open(filename);
-    if (file.fail()) {
-      INJA_THROW(FileError("failed accessing file at '" + filename + "'"));
-    }
-    std::string text((std::istreambuf_iterator<char>(file)), std::istreambuf_iterator<char>());
-    return text;
-  }
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_PARSER_HPP_
-
-// #include "renderer.hpp"
-#ifndef INCLUDE_INJA_RENDERER_HPP_
-#define INCLUDE_INJA_RENDERER_HPP_
-
-#include <algorithm>
-#include <numeric>
-#include <string>
-#include <utility>
-#include <vector>
-
-// #include "config.hpp"
-
-// #include "exceptions.hpp"
-
-// #include "node.hpp"
-
-// #include "template.hpp"
-
-// #include "utils.hpp"
-
-
-namespace inja {
-
-/*!
- * \brief Class for rendering a Template with data.
- */
-class Renderer : public NodeVisitor  {
-  using Op = FunctionStorage::Operation;
-
-  const RenderConfig config;
-  const TemplateStorage &template_storage;
-  const FunctionStorage &function_storage;
-
-  const Template *current_template;
-  size_t current_level {0};
-  std::vector<const Template*> template_stack;
-  std::vector<const BlockStatementNode*> block_statement_stack;
-
-  const json *json_input;
-  std::ostream *output_stream;
-
-  json json_additional_data;
-  json* current_loop_data = &json_additional_data["loop"];
-
-  std::vector<std::shared_ptr<json>> json_tmp_stack;
-  std::stack<const json*> json_eval_stack;
-  std::stack<const JsonNode*> not_found_stack;
-
-  bool break_rendering {false};
-
-  bool truthy(const json* data) const {
-    if (data->is_boolean()) {
-      return data->get<bool>();
-    } else if (data->is_number()) {
-      return (*data != 0);
-    } else if (data->is_null()) {
-      return false;
-    }
-    return !data->empty();
-  }
-
-  void print_json(const std::shared_ptr<json> value) {
-    if (value->is_string()) {
-      *output_stream << value->get_ref<const json::string_t&>();
-    } else if (value->is_number_integer()) {
-      *output_stream << value->get<const json::number_integer_t>();
-    } else if (value->is_null()) {
-    } else {
-      *output_stream << value->dump();
-    }
-  }
-
-  const std::shared_ptr<json> eval_expression_list(const ExpressionListNode& expression_list) {
-    if (!expression_list.root) {
-      throw_renderer_error("empty expression", expression_list);
-    }
-
-    expression_list.root->accept(*this);
-
-    if (json_eval_stack.empty()) {
-      throw_renderer_error("empty expression", expression_list);
-    } else if (json_eval_stack.size() != 1) {
-      throw_renderer_error("malformed expression", expression_list);
-    }
-
-    const auto result = json_eval_stack.top();
-    json_eval_stack.pop();
-
-    if (!result) {
-      if (not_found_stack.empty()) {
-        throw_renderer_error("expression could not be evaluated", expression_list);
-      }
-
-      auto node = not_found_stack.top();
-      not_found_stack.pop();
-
-      throw_renderer_error("variable '" + static_cast<std::string>(node->name) + "' not found", *node);
-    }
-    return std::make_shared<json>(*result);
-  }
-
-  void throw_renderer_error(const std::string &message, const AstNode& node) {
-    SourceLocation loc = get_source_location(current_template->content, node.pos);
-    INJA_THROW(RenderError(message, loc));
-  }
-
-  template<size_t N, size_t N_start = 0, bool throw_not_found=true>
-  std::array<const json*, N> get_arguments(const FunctionNode& node) {
-    if (node.arguments.size() < N_start + N) {
-      throw_renderer_error("function needs " + std::to_string(N_start + N) + " variables, but has only found " + std::to_string(node.arguments.size()), node);
-    }
-
-    for (size_t i = N_start; i < N_start + N; i += 1) {
-      node.arguments[i]->accept(*this);
-    }
-
-    if (json_eval_stack.size() < N) {
-      throw_renderer_error("function needs " + std::to_string(N) + " variables, but has only found " + std::to_string(json_eval_stack.size()), node);
-    }
-
-    std::array<const json*, N> result;
-    for (size_t i = 0; i < N; i += 1) {
-      result[N - i - 1] = json_eval_stack.top();
-      json_eval_stack.pop();
-
-      if (!result[N - i - 1]) {
-        const auto json_node = not_found_stack.top();
-        not_found_stack.pop();
-
-        if (throw_not_found) {
-          throw_renderer_error("variable '" + static_cast<std::string>(json_node->name) + "' not found", *json_node);
-        }
-      }
-    }
-    return result;
-  }
-
-  template<bool throw_not_found=true>
-  Arguments get_argument_vector(const FunctionNode& node) {
-    const size_t N = node.arguments.size();
-    for (auto a: node.arguments) {
-      a->accept(*this);
-    }
-
-    if (json_eval_stack.size() < N) {
-      throw_renderer_error("function needs " + std::to_string(N) + " variables, but has only found " + std::to_string(json_eval_stack.size()), node);
-    }
-
-    Arguments result {N};
-    for (size_t i = 0; i < N; i += 1) {
-      result[N - i - 1] = json_eval_stack.top();
-      json_eval_stack.pop();
-
-      if (!result[N - i - 1]) {
-        const auto json_node = not_found_stack.top();
-        not_found_stack.pop();
-
-        if (throw_not_found) {
-          throw_renderer_error("variable '" + static_cast<std::string>(json_node->name) + "' not found", *json_node);
-        }
-      }
-    }
-    return result;
-  }
-
-  void visit(const BlockNode& node) {
-    for (auto& n : node.nodes) {
-      n->accept(*this);
-
-      if (break_rendering) {
-        break;
-      }
-    }
-  }
-
-  void visit(const TextNode& node) {
-    output_stream->write(current_template->content.c_str() + node.pos, node.length);
-  }
-
-  void visit(const ExpressionNode&) { }
-
-  void visit(const LiteralNode& node) {
-    json_eval_stack.push(&node.value);
-  }
-
-  void visit(const JsonNode& node) {
-    if (json_additional_data.contains(node.ptr)) {
-      json_eval_stack.push(&(json_additional_data[node.ptr]));
-
-    } else if (json_input->contains(node.ptr)) {
-      json_eval_stack.push(&(*json_input)[node.ptr]);
-
-    } else {
-      // Try to evaluate as a no-argument callback
-      const auto function_data = function_storage.find_function(node.name, 0);
-      if (function_data.operation == FunctionStorage::Operation::Callback) {
-        Arguments empty_args {};
-        const auto value = std::make_shared<json>(function_data.callback(empty_args));
-        json_tmp_stack.push_back(value);
-        json_eval_stack.push(value.get());
-
-      } else {
-        json_eval_stack.push(nullptr);
-        not_found_stack.emplace(&node);
-      }
-    }
-  }
-
-  void visit(const FunctionNode& node) {
-    std::shared_ptr<json> result_ptr;
-
-    switch (node.operation) {
-    case Op::Not: {
-      const auto args = get_arguments<1>(node);
-      result_ptr = std::make_shared<json>(!truthy(args[0]));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::And: {
-      result_ptr = std::make_shared<json>(truthy(get_arguments<1, 0>(node)[0]) && truthy(get_arguments<1, 1>(node)[0]));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Or: {
-      result_ptr = std::make_shared<json>(truthy(get_arguments<1, 0>(node)[0]) || truthy(get_arguments<1, 1>(node)[0]));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::In: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(std::find(args[1]->begin(), args[1]->end(), *args[0]) != args[1]->end());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Equal: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(*args[0] == *args[1]);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::NotEqual: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(*args[0] != *args[1]);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Greater: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(*args[0] > *args[1]);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::GreaterEqual: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(*args[0] >= *args[1]);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Less: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(*args[0] < *args[1]);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::LessEqual: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(*args[0] <= *args[1]);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Add: {
-      const auto args = get_arguments<2>(node);
-      if (args[0]->is_string() && args[1]->is_string()) {
-        result_ptr = std::make_shared<json>(args[0]->get_ref<const std::string&>() + args[1]->get_ref<const std::string&>());
-        json_tmp_stack.push_back(result_ptr);
-      } else if (args[0]->is_number_integer() && args[1]->is_number_integer()) {
-        result_ptr = std::make_shared<json>(args[0]->get<int>() + args[1]->get<int>());
-        json_tmp_stack.push_back(result_ptr);
-      } else {
-        result_ptr = std::make_shared<json>(args[0]->get<double>() + args[1]->get<double>());
-        json_tmp_stack.push_back(result_ptr);
-      }
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Subtract: {
-      const auto args = get_arguments<2>(node);
-      if (args[0]->is_number_integer() && args[1]->is_number_integer()) {
-        result_ptr = std::make_shared<json>(args[0]->get<int>() - args[1]->get<int>());
-        json_tmp_stack.push_back(result_ptr);
-      } else {
-        result_ptr = std::make_shared<json>(args[0]->get<double>() - args[1]->get<double>());
-        json_tmp_stack.push_back(result_ptr);
-      }
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Multiplication: {
-      const auto args = get_arguments<2>(node);
-      if (args[0]->is_number_integer() && args[1]->is_number_integer()) {
-        result_ptr = std::make_shared<json>(args[0]->get<int>() * args[1]->get<int>());
-        json_tmp_stack.push_back(result_ptr);
-      } else {
-        result_ptr = std::make_shared<json>(args[0]->get<double>() * args[1]->get<double>());
-        json_tmp_stack.push_back(result_ptr);
-      }
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Division: {
-      const auto args = get_arguments<2>(node);
-      if (args[1]->get<double>() == 0) {
-        throw_renderer_error("division by zero", node);
-      }
-      result_ptr = std::make_shared<json>(args[0]->get<double>() / args[1]->get<double>());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Power: {
-      const auto args = get_arguments<2>(node);
-      if (args[0]->is_number_integer() && args[1]->get<int>() >= 0) {
-        int result = static_cast<int>(std::pow(args[0]->get<int>(), args[1]->get<int>()));
-        result_ptr = std::make_shared<json>(std::move(result));
-        json_tmp_stack.push_back(result_ptr);
-      } else {
-        double result = std::pow(args[0]->get<double>(), args[1]->get<int>());
-        result_ptr = std::make_shared<json>(std::move(result));
-        json_tmp_stack.push_back(result_ptr);
-      }
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Modulo: {
-      const auto args = get_arguments<2>(node);
-      result_ptr = std::make_shared<json>(args[0]->get<int>() % args[1]->get<int>());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::AtId: {
-      const auto container = get_arguments<1, 0, false>(node)[0];
-      node.arguments[1]->accept(*this);
-      if (not_found_stack.empty()) {
-        throw_renderer_error("could not find element with given name", node);
-      }
-      const auto id_node = not_found_stack.top();
-      not_found_stack.pop();
-      json_eval_stack.pop();
-      json_eval_stack.push(&container->at(id_node->name));
-    } break;
-    case Op::At: {
-      const auto args = get_arguments<2>(node);
-      if (args[0]->is_object()) {
-        json_eval_stack.push(&args[0]->at(args[1]->get<std::string>()));
-      } else {
-        json_eval_stack.push(&args[0]->at(args[1]->get<int>()));
-      }
-    } break;
-    case Op::Default: {
-      const auto test_arg = get_arguments<1, 0, false>(node)[0];
-      json_eval_stack.push(test_arg ? test_arg : get_arguments<1, 1>(node)[0]);
-    } break;
-    case Op::DivisibleBy: {
-      const auto args = get_arguments<2>(node);
-      const int divisor = args[1]->get<int>();
-      result_ptr = std::make_shared<json>((divisor != 0) && (args[0]->get<int>() % divisor == 0));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Even: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->get<int>() % 2 == 0);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Exists: {
-      auto &&name = get_arguments<1>(node)[0]->get_ref<const std::string &>();
-      result_ptr = std::make_shared<json>(json_input->contains(json::json_pointer(JsonNode::convert_dot_to_json_ptr(name))));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::ExistsInObject: {
-      const auto args = get_arguments<2>(node);
-      auto &&name = args[1]->get_ref<const std::string &>();
-      result_ptr = std::make_shared<json>(args[0]->find(name) != args[0]->end());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::First: {
-      const auto result = &get_arguments<1>(node)[0]->front();
-      json_eval_stack.push(result);
-    } break;
-    case Op::Float: {
-      result_ptr = std::make_shared<json>(std::stod(get_arguments<1>(node)[0]->get_ref<const std::string &>()));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Int: {
-      result_ptr = std::make_shared<json>(std::stoi(get_arguments<1>(node)[0]->get_ref<const std::string &>()));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Last: {
-      const auto result = &get_arguments<1>(node)[0]->back();
-      json_eval_stack.push(result);
-    } break;
-    case Op::Length: {
-      const auto val = get_arguments<1>(node)[0];
-      if (val->is_string()) {
-        result_ptr = std::make_shared<json>(val->get_ref<const std::string &>().length());
-      } else {
-        result_ptr = std::make_shared<json>(val->size());
-      }
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Lower: {
-      std::string result = get_arguments<1>(node)[0]->get<std::string>();
-      std::transform(result.begin(), result.end(), result.begin(), ::tolower);
-      result_ptr = std::make_shared<json>(std::move(result));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Max: {
-      const auto args = get_arguments<1>(node);
-      const auto result = std::max_element(args[0]->begin(), args[0]->end());
-      json_eval_stack.push(&(*result));
-    } break;
-    case Op::Min: {
-      const auto args = get_arguments<1>(node);
-      const auto result = std::min_element(args[0]->begin(), args[0]->end());
-      json_eval_stack.push(&(*result));
-    } break;
-    case Op::Odd: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->get<int>() % 2 != 0);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Range: {
-      std::vector<int> result(get_arguments<1>(node)[0]->get<int>());
-      std::iota(result.begin(), result.end(), 0);
-      result_ptr = std::make_shared<json>(std::move(result));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Round: {
-      const auto args = get_arguments<2>(node);
-      const int precision = args[1]->get<int>();
-      const double result = std::round(args[0]->get<double>() * std::pow(10.0, precision)) / std::pow(10.0, precision);
-      if(0==precision){
-        result_ptr = std::make_shared<json>(int(result));
-      }else{
-        result_ptr = std::make_shared<json>(std::move(result));
-      }
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Sort: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->get<std::vector<json>>());
-      std::sort(result_ptr->begin(), result_ptr->end());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Upper: {
-      std::string result = get_arguments<1>(node)[0]->get<std::string>();
-      std::transform(result.begin(), result.end(), result.begin(), ::toupper);
-      result_ptr = std::make_shared<json>(std::move(result));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::IsBoolean: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_boolean());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::IsNumber: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_number());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::IsInteger: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_number_integer());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::IsFloat: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_number_float());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::IsObject: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_object());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::IsArray: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_array());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::IsString: {
-      result_ptr = std::make_shared<json>(get_arguments<1>(node)[0]->is_string());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Callback: {
-      auto args = get_argument_vector(node);
-      result_ptr = std::make_shared<json>(node.callback(args));
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Super: {
-      const auto args = get_argument_vector(node);
-      const size_t old_level = current_level;
-      const size_t level_diff = (args.size() == 1) ? args[0]->get<int>() : 1;
-      const size_t level = current_level + level_diff;
-
-      if (block_statement_stack.empty()) {
-        throw_renderer_error("super() call is not within a block", node);
-      }
-
-      if (level < 1 || level > template_stack.size() - 1) {
-        throw_renderer_error("level of super() call does not match parent templates (between 1 and " + std::to_string(template_stack.size() - 1) + ")", node);
-      }
-
-      const auto current_block_statement = block_statement_stack.back();
-      const Template *new_template = template_stack.at(level);
-      const Template *old_template = current_template;
-      const auto block_it = new_template->block_storage.find(current_block_statement->name);
-      if (block_it != new_template->block_storage.end()) {
-        current_template = new_template;
-        current_level = level;
-        block_it->second->block.accept(*this);
-        current_level = old_level;
-        current_template = old_template;
-      } else {
-        throw_renderer_error("could not find block with name '" + current_block_statement->name + "'", node);
-      }
-      result_ptr = std::make_shared<json>(nullptr);
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::Join: {
-      const auto args = get_arguments<2>(node);
-      const auto separator = args[1]->get<std::string>();
-      std::ostringstream os;
-      std::string sep;
-      for (const auto& value : *args[0]) {
-        os << sep;
-        if (value.is_string()) {
-          os << value.get<std::string>(); // otherwise the value is surrounded with ""
-        } else {
-          os << value;
-        }
-        sep = separator;
-      }
-      result_ptr = std::make_shared<json>(os.str());
-      json_tmp_stack.push_back(result_ptr);
-      json_eval_stack.push(result_ptr.get());
-    } break;
-    case Op::ParenLeft:
-    case Op::ParenRight:
-    case Op::None:
-      break;
-    }
-  }
-
-  void visit(const ExpressionListNode& node) {
-    print_json(eval_expression_list(node));
-  }
-
-  void visit(const StatementNode&) { }
-
-  void visit(const ForStatementNode&) { }
-
-  void visit(const ForArrayStatementNode& node) {
-    const auto result = eval_expression_list(node.condition);
-    if (!result->is_array()) {
-      throw_renderer_error("object must be an array", node);
-    }
-
-    if (!current_loop_data->empty()) {
-      auto tmp = *current_loop_data; // Because of clang-3
-      (*current_loop_data)["parent"] = std::move(tmp);
-    }
-
-    size_t index = 0;
-    (*current_loop_data)["is_first"] = true;
-    (*current_loop_data)["is_last"] = (result->size() <= 1);
-    for (auto it = result->begin(); it != result->end(); ++it) {
-      json_additional_data[static_cast<std::string>(node.value)] = *it;
-
-      (*current_loop_data)["index"] = index;
-      (*current_loop_data)["index1"] = index + 1;
-      if (index == 1) {
-        (*current_loop_data)["is_first"] = false;
-      }
-      if (index == result->size() - 1) {
-        (*current_loop_data)["is_last"] = true;
-      }
-
-      node.body.accept(*this);
-      ++index;
-    }
-
-    json_additional_data[static_cast<std::string>(node.value)].clear();
-    if (!(*current_loop_data)["parent"].empty()) {
-      const auto tmp = (*current_loop_data)["parent"];
-      *current_loop_data = std::move(tmp);
-    } else {
-      current_loop_data = &json_additional_data["loop"];
-    }
-  }
-
-  void visit(const ForObjectStatementNode& node) {
-    const auto result = eval_expression_list(node.condition);
-    if (!result->is_object()) {
-      throw_renderer_error("object must be an object", node);
-    }
-
-    if (!current_loop_data->empty()) {
-      (*current_loop_data)["parent"] = std::move(*current_loop_data);
-    }
-
-    size_t index = 0;
-    (*current_loop_data)["is_first"] = true;
-    (*current_loop_data)["is_last"] = (result->size() <= 1);
-    for (auto it = result->begin(); it != result->end(); ++it) {
-      json_additional_data[static_cast<std::string>(node.key)] = it.key();
-      json_additional_data[static_cast<std::string>(node.value)] = it.value();
-
-      (*current_loop_data)["index"] = index;
-      (*current_loop_data)["index1"] = index + 1;
-      if (index == 1) {
-        (*current_loop_data)["is_first"] = false;
-      }
-      if (index == result->size() - 1) {
-        (*current_loop_data)["is_last"] = true;
-      }
-
-      node.body.accept(*this);
-      ++index;
-    }
-
-    json_additional_data[static_cast<std::string>(node.key)].clear();
-    json_additional_data[static_cast<std::string>(node.value)].clear();
-    if (!(*current_loop_data)["parent"].empty()) {
-      *current_loop_data = std::move((*current_loop_data)["parent"]);
-    } else {
-      current_loop_data = &json_additional_data["loop"];
-    }
-  }
-
-  void visit(const IfStatementNode& node) {
-    const auto result = eval_expression_list(node.condition);
-    if (truthy(result.get())) {
-      node.true_statement.accept(*this);
-    } else if (node.has_false_statement) {
-      node.false_statement.accept(*this);
-    }
-  }
-
-  void visit(const IncludeStatementNode& node) {
-    auto sub_renderer = Renderer(config, template_storage, function_storage);
-    const auto included_template_it = template_storage.find(node.file);
-    if (included_template_it != template_storage.end()) {
-      sub_renderer.render_to(*output_stream, included_template_it->second, *json_input, &json_additional_data);
-    } else if (config.throw_at_missing_includes) {
-      throw_renderer_error("include '" + node.file + "' not found", node);
-    }
-  }
-
-  void visit(const ExtendsStatementNode& node) {
-    const auto included_template_it = template_storage.find(node.file);
-    if (included_template_it != template_storage.end()) {
-      const Template *parent_template = &included_template_it->second;
-      render_to(*output_stream, *parent_template, *json_input, &json_additional_data);
-      break_rendering = true;
-    } else if (config.throw_at_missing_includes) {
-      throw_renderer_error("extends '" + node.file + "' not found", node);
-    }
-  }
-
-  void visit(const BlockStatementNode& node) {
-    const size_t old_level = current_level;
-    current_level = 0;
-    current_template = template_stack.front();
-    const auto block_it = current_template->block_storage.find(node.name);
-    if (block_it != current_template->block_storage.end()) {
-      block_statement_stack.emplace_back(&node);
-      block_it->second->block.accept(*this);
-      block_statement_stack.pop_back(); 
-    }
-    current_level = old_level;
-    current_template = template_stack.back();
-  }
-
-  void visit(const SetStatementNode& node) {
-    std::string ptr = node.key;
-    replace_substring(ptr, ".", "/");
-    ptr = "/" + ptr;
-    json_additional_data[json::json_pointer(ptr)] = *eval_expression_list(node.expression);
-  }
-
-public:
-  Renderer(const RenderConfig& config, const TemplateStorage &template_storage, const FunctionStorage &function_storage)
-      : config(config), template_storage(template_storage), function_storage(function_storage) { }
-
-  void render_to(std::ostream &os, const Template &tmpl, const json &data, json *loop_data = nullptr) {
-    output_stream = &os;
-    current_template = &tmpl;
-    json_input = &data;
-    if (loop_data) {
-      json_additional_data = *loop_data;
-      current_loop_data = &json_additional_data["loop"];
-    }
-
-    template_stack.emplace_back(current_template);
-    current_template->root.accept(*this);
-
-    json_tmp_stack.clear();
-  }
-};
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_RENDERER_HPP_
-
-// #include "string_view.hpp"
-
-// #include "template.hpp"
-
-// #include "utils.hpp"
-
-
-namespace inja {
-
-/*!
- * \brief Class for changing the configuration.
- */
-class Environment {
-  std::string input_path;
-  std::string output_path;
-
-  LexerConfig lexer_config;
-  ParserConfig parser_config;
-  RenderConfig render_config;
-
-  FunctionStorage function_storage;
-  TemplateStorage template_storage;
-
-public:
-  Environment() : Environment("") {}
-
-  explicit Environment(const std::string &global_path) : input_path(global_path), output_path(global_path) {}
-
-  Environment(const std::string &input_path, const std::string &output_path)
-      : input_path(input_path), output_path(output_path) {}
-
-  /// Sets the opener and closer for template statements
-  void set_statement(const std::string &open, const std::string &close) {
-    lexer_config.statement_open = open;
-    lexer_config.statement_open_no_lstrip = open + "+";
-    lexer_config.statement_open_force_lstrip = open + "-";
-    lexer_config.statement_close = close;
-    lexer_config.statement_close_force_rstrip = "-" + close;
-    lexer_config.update_open_chars();
-  }
-
-  /// Sets the opener for template line statements
-  void set_line_statement(const std::string &open) {
-    lexer_config.line_statement = open;
-    lexer_config.update_open_chars();
-  }
-
-  /// Sets the opener and closer for template expressions
-  void set_expression(const std::string &open, const std::string &close) {
-    lexer_config.expression_open = open;
-    lexer_config.expression_open_force_lstrip = open + "-";
-    lexer_config.expression_close = close;
-    lexer_config.expression_close_force_rstrip = "-" + close;
-    lexer_config.update_open_chars();
-  }
-
-  /// Sets the opener and closer for template comments
-  void set_comment(const std::string &open, const std::string &close) {
-    lexer_config.comment_open = open;
-    lexer_config.comment_open_force_lstrip = open + "-";
-    lexer_config.comment_close = close;
-    lexer_config.comment_close_force_rstrip = "-" + close;
-    lexer_config.update_open_chars();
-  }
-
-  /// Sets whether to remove the first newline after a block
-  void set_trim_blocks(bool trim_blocks) {
-    lexer_config.trim_blocks = trim_blocks;
-  }
-
-  /// Sets whether to strip the spaces and tabs from the start of a line to a block
-  void set_lstrip_blocks(bool lstrip_blocks) {
-    lexer_config.lstrip_blocks = lstrip_blocks;
-  }
-
-  /// Sets the element notation syntax
-  void set_search_included_templates_in_files(bool search_in_files) {
-    parser_config.search_included_templates_in_files = search_in_files;
-  }
-
-  /// Sets whether a missing include will throw an error
-  void set_throw_at_missing_includes(bool will_throw) {
-    render_config.throw_at_missing_includes = will_throw;
-  }
-
-  Template parse(nonstd::string_view input) {
-    Parser parser(parser_config, lexer_config, template_storage, function_storage);
-    return parser.parse(input);
-  }
-
-  Template parse_template(const std::string &filename) {
-    Parser parser(parser_config, lexer_config, template_storage, function_storage);
-    auto result = Template(parser.load_file(input_path + static_cast<std::string>(filename)));
-    parser.parse_into_template(result, input_path + static_cast<std::string>(filename));
-    return result;
-  }
-
-  Template parse_file(const std::string &filename) {
-    return parse_template(filename);
-  }
-
-  std::string render(nonstd::string_view input, const json &data) { return render(parse(input), data); }
-
-  std::string render(const Template &tmpl, const json &data) {
-    std::stringstream os;
-    render_to(os, tmpl, data);
-    return os.str();
-  }
-
-  std::string render_file(const std::string &filename, const json &data) {
-    return render(parse_template(filename), data);
-  }
-
-  std::string render_file_with_json_file(const std::string &filename, const std::string &filename_data) {
-    const json data = load_json(filename_data);
-    return render_file(filename, data);
-  }
-
-  void write(const std::string &filename, const json &data, const std::string &filename_out) {
-    std::ofstream file(output_path + filename_out);
-    file << render_file(filename, data);
-    file.close();
-  }
-
-  void write(const Template &temp, const json &data, const std::string &filename_out) {
-    std::ofstream file(output_path + filename_out);
-    file << render(temp, data);
-    file.close();
-  }
-
-  void write_with_json_file(const std::string &filename, const std::string &filename_data,
-                            const std::string &filename_out) {
-    const json data = load_json(filename_data);
-    write(filename, data, filename_out);
-  }
-
-  void write_with_json_file(const Template &temp, const std::string &filename_data, const std::string &filename_out) {
-    const json data = load_json(filename_data);
-    write(temp, data, filename_out);
-  }
-
-  std::ostream &render_to(std::ostream &os, const Template &tmpl, const json &data) {
-    Renderer(render_config, template_storage, function_storage).render_to(os, tmpl, data);
-    return os;
-  }
-
-  std::string load_file(const std::string &filename) {
-    Parser parser(parser_config, lexer_config, template_storage, function_storage);
-    return parser.load_file(input_path + filename);
-  }
-
-  json load_json(const std::string &filename) {
-    std::ifstream file;
-    file.open(input_path + filename);
-    if (file.fail()) {
-      INJA_THROW(FileError("failed accessing file at '" + input_path + filename + "'"));
-    }
-    json j;
-    file >> j;
-    return j;
-  }
-
-  /*!
-  @brief Adds a variadic callback
-  */
-  void add_callback(const std::string &name, const CallbackFunction &callback) {
-    add_callback(name, -1, callback);
-  }
-
-  /*!
-  @brief Adds a variadic void callback
-  */
-  void add_void_callback(const std::string &name, const VoidCallbackFunction &callback) {
-    add_void_callback(name, -1, callback);
-  }
-
-  /*!
-  @brief Adds a callback with given number or arguments
-  */
-  void add_callback(const std::string &name, int num_args, const CallbackFunction &callback) {
-    function_storage.add_callback(name, num_args, callback);
-  }
-
-  /*!
-  @brief Adds a void callback with given number or arguments
-  */
-  void add_void_callback(const std::string &name, int num_args, const VoidCallbackFunction &callback) {
-    function_storage.add_callback(name, num_args, [callback](Arguments& args) { callback(args); return json(); });
-  }
-
-  /** Includes a template with a given name into the environment.
-   * Then, a template can be rendered in another template using the
-   * include "<name>" syntax.
-   */
-  void include_template(const std::string &name, const Template &tmpl) {
-    template_storage[name] = tmpl;
-  }
-
-  /*!
-  @brief Sets a function that is called when an included file is not found
-  */
-  void set_include_callback(const std::function<Template(const std::string&, const std::string&)>& callback) {
-    parser_config.include_callback = callback;
-  }
-};
-
-/*!
-@brief render with default settings to a string
-*/
-inline std::string render(nonstd::string_view input, const json &data) {
-  return Environment().render(input, data);
-}
-
-/*!
-@brief render with default settings to the given output stream
-*/
-inline void render_to(std::ostream &os, nonstd::string_view input, const json &data) {
-  Environment env;
-  env.render_to(os, env.parse(input), data);
-}
-
-} // namespace inja
-
-#endif // INCLUDE_INJA_ENVIRONMENT_HPP_
-
-// #include "exceptions.hpp"
-
-// #include "parser.hpp"
-
-// #include "renderer.hpp"
-
-// #include "string_view.hpp"
-
-// #include "template.hpp"
-
-
-#endif // INCLUDE_INJA_INJA_HPP_
diff -pruN 8.0.1-5/tile4ms.c 8.2.0~beta1-1~exp1/tile4ms.c
--- 8.0.1-5/tile4ms.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/tile4ms.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,296 +0,0 @@
-/******************************************************************************
- * $Id$
- *
- * Project:  MapServer
- * Purpose:  Create shapefile of rectangles from extents of several shapefiles
- *           (=tiles)
- *           Create DBF with file names for shape tiles, in column LOCATION as
- *           required by mapserv.
- *           For use with Mapserv tiling capability.
- * Author:   Herbie Freytag hfreytag@dlwc.nsw.gov.au
- *
- * Note:
- * Resulting shape files do not display in ArcView.
- *
- ******************************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota.
- *
- * Permission is hereby granted, free of charge, to any person obtaining a
- * copy of this software and associated documentation files (the "Software"),
- * to deal in the Software without restriction, including without limitation
- * the rights to use, copy, modify, merge, publish, distribute, sublicense,
- * and/or sell copies of the Software, and to permit persons to whom the
- * Software is furnished to do so, subject to the following conditions:
- *
- * The above copyright notice and this permission notice shall be included in
- * all copies of this Software or works derived from this Software.
- *
- * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
- * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
- * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
- * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
- * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
- * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
- * DEALINGS IN THE SOFTWARE.
- *****************************************************************************/
-
-/*
-* This is a modified version of Herbie's program that works with MapServer's
-* shapelib and should be using the MapServer makefile.
-*
-*/
-
-#include "mapserver.h"
-#include <string.h>
-
-
-
-/***********************************************************************/
-int process_shapefiles(char *metaFileNameP, char *tileFileNameP,
-                       int tile_path_only)
-{
-  SHPHandle   hSHP, tileSHP;
-  rectObj     extentRect;
-  lineObj     line;
-  shapeObj    shapeRect;
-  DBFHandle   tileDBF;
-  DBFHandle   shpDBF;
-
-  typedef struct DBFFieldDef_struct {
-    DBFFieldType  type;
-    char          name[12];
-    int           width;
-    int           decimals;
-  } DBFFieldDef;
-
-  DBFFieldDef     *theFields = NULL;
-  char            fldname[256];
-  int             width;
-  int             decimals;
-  int             fieldCnt;
-  int             i;
-
-  FILE        *metaFP = NULL;
-  char        *p;
-  char        tileshapeName[256];
-  char        tiledbfName[256];
-  char        shapeFileName[256];
-  int     entityNum;
-
-  int     tilesFound = 0;
-  int     tilesProcessed = 0;
-
-  msInitShape(&shapeRect);
-  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*5);
-  line.numpoints = 5;
-
-  /* open metafile */
-  /* ------------- */
-  if (NULL==(metaFP=fopen(metaFileNameP, "r"))) {
-    printf( "Unable to open:%s\n", metaFileNameP);
-    return(1);
-  }
-
-
-  /* create new tileindex shapefiles and create a header */
-  /* -------------------------------------------------- */
-  snprintf(tileshapeName, sizeof(tileshapeName), "%s.shp", tileFileNameP);
-
-  if(NULL==(tileSHP=msSHPCreate(tileFileNameP, SHP_POLYGON))) {
-    fclose(metaFP);
-    printf("Unable to create %s.shp (.shx)\n", tileFileNameP);
-    return(1);
-  }
-
-
-  /* create new tileindex dbf-file */
-  /* ----------------------------- */
-  snprintf(tiledbfName, sizeof(tiledbfName), "%s.dbf", tileFileNameP);
-  if (NULL==(tileDBF=msDBFCreate(tiledbfName))) {
-    fclose(metaFP);
-    msSHPClose(tileSHP);
-    printf("DBFCreate(%s) failed.\n", tiledbfName);
-    return(1);
-  }
-
-  if(msDBFAddField(tileDBF, "LOCATION", FTString, 255, 0 )== -1 ) {
-    fclose(metaFP);
-    msSHPClose(tileSHP);
-    msDBFClose(tileDBF);
-    printf("DBFAddField(fieldname='LOCATION') failed.\n");
-    return(1);
-  }
-
-
-
-  /* loop through files listed in metafile */
-  /* ===================================== */
-  while (fgets(shapeFileName, 255, metaFP)) {
-
-
-    if ((p=strchr(shapeFileName, '\n')) != NULL) *p='\0';
-
-    if (!strlen(shapeFileName))
-      break;
-
-    tilesFound++;
-
-    /* read the DBFFields for this shapefile */
-    /* and save them if the first, otherwise compare them */
-
-    shpDBF = msDBFOpen(shapeFileName, "rb");
-
-    if( shpDBF == NULL ) {
-      printf( "Aborted. Unable to open DBF:%s\n", shapeFileName);
-      break;
-    }
-
-    if( theFields == NULL ) {
-      fieldCnt = msDBFGetFieldCount(shpDBF);
-      theFields = (DBFFieldDef *) msSmallCalloc(fieldCnt, sizeof(DBFFieldDef));
-      for (i=0; i<fieldCnt; i++) {
-        theFields[i].type = msDBFGetFieldInfo(shpDBF, i,
-                                              theFields[i].name,
-                                              &theFields[i].width, &theFields[i].decimals);
-        if( theFields[i].type == FTInvalid ) {
-          printf( "Aborted. DBF Invalid field (%d of %d) file:%s\n",
-                  i, fieldCnt, shapeFileName);
-          break;
-        }
-      }
-    } else {
-      fieldCnt = msDBFGetFieldCount(shpDBF);
-      for (i=0; i<fieldCnt; i++) {
-        if( theFields[i].type != msDBFGetFieldInfo(shpDBF, i, fldname, &width, &decimals) ||
-            strcmp(theFields[i].name, fldname) ||
-            theFields[i].width != width || theFields[i].decimals != decimals ) {
-          printf( "Aborted. DBF fields do not match for file:%s\n", shapeFileName);
-          break;
-        }
-      }
-    }
-    msDBFClose(shpDBF);
-
-    /* Get rid of .shp extension if it was included. */
-    if (strlen(shapeFileName) > 4 &&
-        (p=shapeFileName+strlen(shapeFileName)-4) &&
-        strcasecmp(p, ".shp") == 0)
-      *p = '\0';
-
-    if (!strlen(shapeFileName))
-      break;
-
-    /* read extent from shapefile */
-    /* -------------------------- */
-    hSHP = msSHPOpen(shapeFileName, "rb");
-
-    if( hSHP == NULL )  {
-      printf( "Aborted. Unable to open SHP:%s\n", shapeFileName);
-      break;
-    }
-
-    msSHPReadBounds(hSHP, -1, &extentRect);
-    /* SHPGetInfo(hSHP, &nEntities, &nShapeType, adfBndsMin, adfBndsMax); */
-
-    /* printf("File:  %s Bounds 0/1: (%15.10lg,%15.10lg)\n\t(%15.10lg,%15.10lg)\n", shapeFileName, adfBndsMin[0], adfBndsMin[1], adfBndsMax[0], adfBndsMax[1] ); */
-
-    msSHPClose(hSHP);
-
-
-    /* create rectangle describing current shapefile extent */
-    /* ---------------------------------------------------- */
-
-    line.point[0].x = line.point[4].x = extentRect.minx; /* bottom left */
-    line.point[0].y = line.point[4].y  = extentRect.miny;
-    line.point[1].x = extentRect.minx; /* top left */
-    line.point[1].y = extentRect.maxy;
-    line.point[2].x = extentRect.maxx; /* top left */
-    line.point[2].y = extentRect.maxy;
-    line.point[3].x = extentRect.maxx; /* bottom right */
-    line.point[3].y = extentRect.miny;
-
-
-    /* create and add shape object.  Returns link to entry in DBF file */
-    /* --------------------------------------------------------------- */
-
-    shapeRect.type = MS_SHAPE_POLYGON;
-    msAddLine(&shapeRect, &line);
-    entityNum = msSHPWriteShape( tileSHP, &shapeRect );
-
-    msFreeShape(&shapeRect);
-
-    /* store filepath of current shapefile as attribute of rectangle */
-    /* ------------------------------------------------------------- */
-
-    /* Strip off filename if requested */
-    if (tile_path_only) {
-      char *pszTmp;
-      if ((pszTmp = strrchr(shapeFileName, '/')) != NULL ||
-          (pszTmp = strrchr(shapeFileName, '\\')) != NULL ) {
-        *(pszTmp+1) = '\0';  /* Keep the trailing '/' only. */
-      }
-    }
-
-    msDBFWriteStringAttribute(tileDBF, entityNum, 0, shapeFileName);
-
-    tilesProcessed++;
-
-  }
-
-  msSHPClose(tileSHP);
-  msDBFClose(tileDBF);
-
-  fclose(metaFP);
-
-  free(line.point);
-  free(theFields);
-
-
-  printf("Processed %i of %i files\n", tilesProcessed, tilesFound);
-
-
-  return (0);
-
-}
-
-/***********************************************************************/
-void print_usage_and_exit(void)
-{
-
-  printf("\nusage: tile4ms <meta-file> <tile-file> [-tile-path-only]\n");
-  printf("<meta-file>\tINPUT  file containing list of shapefile names\n\t\t(complete paths 255 chars max, no extension)\n");
-  printf("<tile-file>\tOUTPUT shape file of extent rectangles and names\n\t\tof tiles in <tile-file>.dbf\n");
-  printf("-tile-path-only\tOptional flag.  If specified then only the path to the \n\t\tshape files will be stored in the LOCATION field\n\t\tinstead of storing the full filename.\n\n");
-  exit(1);
-}
-
-
-
-/***********************************************************************/
-int main( int argc, char **argv )
-{
-  int tile_path_only = 0;
-
-  /* stun user with existence of help  */
-  /* -------------------------------- */
-  if ((argc == 2)&&(strstr(argv[1], "-h"))) {
-    print_usage_and_exit();
-  }
-
-
-  /* check arguments */
-  /* --------------- */
-  if( argc < 3 ) {
-    print_usage_and_exit();
-  }
-
-  if ( argc == 4 && strcmp(argv[3],"-tile-path-only") == 0) {
-    tile_path_only = 1;
-  }
-
-  process_shapefiles(argv[1], argv[2], tile_path_only);
-
-
-  exit(0);
-}
-
diff -pruN 8.0.1-5/uthash.h 8.2.0~beta1-1~exp1/uthash.h
--- 8.0.1-5/uthash.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/uthash.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,940 +0,0 @@
-/*
-Copyright (c) 2003-2013, Troy D. Hanson     http://troydhanson.github.com/uthash/
-All rights reserved.
-
-Redistribution and use in source and binary forms, with or without
-modification, are permitted provided that the following conditions are met:
-
-    * Redistributions of source code must retain the above copyright
-      notice, this list of conditions and the following disclaimer.
-
-THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
-IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
-TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
-PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
-OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
-EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
-PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
-PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
-LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
-NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-*/
-
-#ifndef UT_HASH_H
-#define UT_HASH_H 
-
-#include <string.h>   /* memcmp,strlen */
-#include <stddef.h>   /* ptrdiff_t */
-#include <stdlib.h>   /* exit() */
-
-/* These macros use decltype or the earlier __typeof GNU extension.
-   As decltype is only available in newer compilers (VS2010 or gcc 4.3+
-   when compiling c++ source) this code uses whatever method is needed
-   or, for VS2008 where neither is available, uses casting workarounds. */
-#ifdef _MSC_VER         /* MS compiler */
-#if _MSC_VER >= 1600 && defined(__cplusplus)  /* VS2010 or newer in C++ mode */
-#define DECLTYPE(x) (decltype(x))
-#else                   /* VS2008 or older (or VS2010 in C mode) */
-#define NO_DECLTYPE
-#define DECLTYPE(x)
-#endif
-#else                   /* GNU, Sun and other compilers */
-#define DECLTYPE(x) (__typeof(x))
-#endif
-
-#ifdef NO_DECLTYPE
-#define DECLTYPE_ASSIGN(dst,src)                                                 \
-do {                                                                             \
-  char **_da_dst = (char**)(&(dst));                                             \
-  *_da_dst = (char*)(src);                                                       \
-} while(0)
-#else 
-#define DECLTYPE_ASSIGN(dst,src)                                                 \
-do {                                                                             \
-  (dst) = DECLTYPE(dst)(src);                                                    \
-} while(0)
-#endif
-
-/* a number of the hash function use uint32_t which isn't defined on win32 */
-#ifdef _MSC_VER
-typedef unsigned int uint32_t;
-typedef unsigned char uint8_t;
-#else
-#include <inttypes.h>   /* uint32_t */
-#endif
-
-#define UT_HASH_VERSION 1.9.8
-
-#ifndef uthash_fatal
-#define uthash_fatal(msg) exit(-1)        /* fatal error (out of memory,etc) */
-#endif
-#ifndef uthash_malloc
-#define uthash_malloc(sz) malloc(sz)      /* malloc fcn                      */
-#endif
-#ifndef uthash_free
-#define uthash_free(ptr,sz) free(ptr)     /* free fcn                        */
-#endif
-
-#ifndef uthash_noexpand_fyi
-#define uthash_noexpand_fyi(tbl)          /* can be defined to log noexpand  */
-#endif
-#ifndef uthash_expand_fyi
-#define uthash_expand_fyi(tbl)            /* can be defined to log expands   */
-#endif
-
-/* initial number of buckets */
-#define UT_HASH_INITIAL_NUM_BUCKETS 32      /* initial number of buckets        */
-#define UT_HASH_INITIAL_NUM_BUCKETS_LOG2 5  /* lg2 of initial number of buckets */
-#define UT_HASH_BKT_CAPACITY_THRESH 10      /* expand when bucket count reaches */
-
-/* calculate the element whose hash handle address is hhe */
-#define ELMT_FROM_HH(tbl,hhp) ((void*)(((char*)(hhp)) - ((tbl)->hho)))
-
-#define UT_HASH_FIND(hh,head,keyptr,keylen,out)                                     \
-do {                                                                             \
-  unsigned _hf_bkt,_hf_hashv;                                                    \
-  out=NULL;                                                                      \
-  if (head) {                                                                    \
-     UT_HASH_FCN(keyptr,keylen, (head)->hh.tbl->num_buckets, _hf_hashv, _hf_bkt);   \
-     if (UT_HASH_BLOOM_TEST((head)->hh.tbl, _hf_hashv)) {                           \
-       UT_HASH_FIND_IN_BKT((head)->hh.tbl, hh, (head)->hh.tbl->buckets[ _hf_bkt ],  \
-                        keyptr,keylen,out);                                      \
-     }                                                                           \
-  }                                                                              \
-} while (0)
-
-#ifdef UT_HASH_BLOOM
-#define UT_HASH_BLOOM_BITLEN (1ULL << UT_HASH_BLOOM)
-#define UT_HASH_BLOOM_BYTELEN (UT_HASH_BLOOM_BITLEN/8) + ((UT_HASH_BLOOM_BITLEN%8) ? 1:0)
-#define UT_HASH_BLOOM_MAKE(tbl)                                                     \
-do {                                                                             \
-  (tbl)->bloom_nbits = UT_HASH_BLOOM;                                               \
-  (tbl)->bloom_bv = (uint8_t*)uthash_malloc(UT_HASH_BLOOM_BYTELEN);                 \
-  if (!((tbl)->bloom_bv))  { uthash_fatal( "out of memory"); }                   \
-  memset((tbl)->bloom_bv, 0, UT_HASH_BLOOM_BYTELEN);                                \
-  (tbl)->bloom_sig = UT_HASH_BLOOM_SIGNATURE;                                       \
-} while (0) 
-
-#define UT_HASH_BLOOM_FREE(tbl)                                                     \
-do {                                                                             \
-  uthash_free((tbl)->bloom_bv, UT_HASH_BLOOM_BYTELEN);                              \
-} while (0) 
-
-#define UT_HASH_BLOOM_BITSET(bv,idx) (bv[(idx)/8] |= (1U << ((idx)%8)))
-#define UT_HASH_BLOOM_BITTEST(bv,idx) (bv[(idx)/8] & (1U << ((idx)%8)))
-
-#define UT_HASH_BLOOM_ADD(tbl,hashv)                                                \
-  UT_HASH_BLOOM_BITSET((tbl)->bloom_bv, (hashv & (uint32_t)((1ULL << (tbl)->bloom_nbits) - 1)))
-
-#define UT_HASH_BLOOM_TEST(tbl,hashv)                                               \
-  UT_HASH_BLOOM_BITTEST((tbl)->bloom_bv, (hashv & (uint32_t)((1ULL << (tbl)->bloom_nbits) - 1)))
-
-#else
-#define UT_HASH_BLOOM_MAKE(tbl) 
-#define UT_HASH_BLOOM_FREE(tbl) 
-#define UT_HASH_BLOOM_ADD(tbl,hashv) 
-#define UT_HASH_BLOOM_TEST(tbl,hashv) (1)
-#define UT_HASH_BLOOM_BYTELEN 0
-#endif
-
-#define UT_HASH_MAKE_TABLE(hh,head)                                                 \
-do {                                                                             \
-  (head)->hh.tbl = (UT_hash_table*)uthash_malloc(                                \
-                  sizeof(UT_hash_table));                                        \
-  if (!((head)->hh.tbl))  { uthash_fatal( "out of memory"); }                    \
-  memset((head)->hh.tbl, 0, sizeof(UT_hash_table));                              \
-  (head)->hh.tbl->tail = &((head)->hh);                                          \
-  (head)->hh.tbl->num_buckets = UT_HASH_INITIAL_NUM_BUCKETS;                        \
-  (head)->hh.tbl->log2_num_buckets = UT_HASH_INITIAL_NUM_BUCKETS_LOG2;              \
-  (head)->hh.tbl->hho = (char*)(&(head)->hh) - (char*)(head);                    \
-  (head)->hh.tbl->buckets = (UT_hash_bucket*)uthash_malloc(                      \
-          UT_HASH_INITIAL_NUM_BUCKETS*sizeof(struct UT_hash_bucket));               \
-  if (! (head)->hh.tbl->buckets) { uthash_fatal( "out of memory"); }             \
-  memset((head)->hh.tbl->buckets, 0,                                             \
-          UT_HASH_INITIAL_NUM_BUCKETS*sizeof(struct UT_hash_bucket));               \
-  UT_HASH_BLOOM_MAKE((head)->hh.tbl);                                               \
-  (head)->hh.tbl->signature = UT_HASH_SIGNATURE;                                    \
-} while(0)
-
-#define UT_HASH_ADD(hh,head,fieldname,keylen_in,add)                                \
-        UT_HASH_ADD_KEYPTR(hh,head,&((add)->fieldname),keylen_in,add)
-
-#define UT_HASH_REPLACE(hh,head,fieldname,keylen_in,add,replaced)                   \
-do {                                                                             \
-  replaced=NULL;                                                                 \
-  UT_HASH_FIND(hh,head,&((add)->fieldname),keylen_in,replaced);                     \
-  if (replaced!=NULL) {                                                          \
-     UT_HASH_DELETE(hh,head,replaced);                                              \
-  };                                                                             \
-  UT_HASH_ADD(hh,head,fieldname,keylen_in,add);                                     \
-} while(0)
- 
-#define UT_HASH_ADD_KEYPTR(hh,head,keyptr,keylen_in,add)                            \
-do {                                                                             \
- unsigned _ha_bkt;                                                               \
- (add)->hh.next = NULL;                                                          \
- (add)->hh.key = (char*)keyptr;                                                  \
- (add)->hh.keylen = (unsigned)keylen_in;                                                   \
- if (!(head)) {                                                                  \
-    head = (add);                                                                \
-    (head)->hh.prev = NULL;                                                      \
-    UT_HASH_MAKE_TABLE(hh,head);                                                    \
- } else {                                                                        \
-    (head)->hh.tbl->tail->next = (add);                                          \
-    (add)->hh.prev = ELMT_FROM_HH((head)->hh.tbl, (head)->hh.tbl->tail);         \
-    (head)->hh.tbl->tail = &((add)->hh);                                         \
- }                                                                               \
- (head)->hh.tbl->num_items++;                                                    \
- (add)->hh.tbl = (head)->hh.tbl;                                                 \
- UT_HASH_FCN(keyptr,keylen_in, (head)->hh.tbl->num_buckets,                         \
-         (add)->hh.hashv, _ha_bkt);                                              \
- UT_HASH_ADD_TO_BKT((head)->hh.tbl->buckets[_ha_bkt],&(add)->hh);                   \
- UT_HASH_BLOOM_ADD((head)->hh.tbl,(add)->hh.hashv);                                 \
- UT_HASH_EMIT_KEY(hh,head,keyptr,keylen_in);                                        \
- UT_HASH_FSCK(hh,head);                                                             \
-} while(0)
-
-#define UT_HASH_TO_BKT( hashv, num_bkts, bkt )                                      \
-do {                                                                             \
-  bkt = ((hashv) & ((num_bkts) - 1));                                            \
-} while(0)
-
-/* delete "delptr" from the hash table.
- * "the usual" patch-up process for the app-order doubly-linked-list.
- * The use of _hd_hh_del below deserves special explanation.
- * These used to be expressed using (delptr) but that led to a bug
- * if someone used the same symbol for the head and deletee, like
- *  UT_HASH_DELETE(hh,users,users);
- * We want that to work, but by changing the head (users) below
- * we were forfeiting our ability to further refer to the deletee (users)
- * in the patch-up process. Solution: use scratch space to
- * copy the deletee pointer, then the latter references are via that
- * scratch pointer rather than through the repointed (users) symbol.
- */
-#define UT_HASH_DELETE(hh,head,delptr)                                              \
-do {                                                                             \
-    unsigned _hd_bkt;                                                            \
-    struct UT_hash_handle *_hd_hh_del;                                           \
-    if ( ((delptr)->hh.prev == NULL) && ((delptr)->hh.next == NULL) )  {         \
-        uthash_free((head)->hh.tbl->buckets,                                     \
-                    (head)->hh.tbl->num_buckets*sizeof(struct UT_hash_bucket) ); \
-        UT_HASH_BLOOM_FREE((head)->hh.tbl);                                         \
-        uthash_free((head)->hh.tbl, sizeof(UT_hash_table));                      \
-        head = NULL;                                                             \
-    } else {                                                                     \
-        _hd_hh_del = &((delptr)->hh);                                            \
-        if ((delptr) == ELMT_FROM_HH((head)->hh.tbl,(head)->hh.tbl->tail)) {     \
-            (head)->hh.tbl->tail =                                               \
-                (UT_hash_handle*)((ptrdiff_t)((delptr)->hh.prev) +               \
-                (head)->hh.tbl->hho);                                            \
-        }                                                                        \
-        if ((delptr)->hh.prev) {                                                 \
-            ((UT_hash_handle*)((ptrdiff_t)((delptr)->hh.prev) +                  \
-                    (head)->hh.tbl->hho))->next = (delptr)->hh.next;             \
-        } else {                                                                 \
-            DECLTYPE_ASSIGN(head,(delptr)->hh.next);                             \
-        }                                                                        \
-        if (_hd_hh_del->next) {                                                  \
-            ((UT_hash_handle*)((ptrdiff_t)_hd_hh_del->next +                     \
-                    (head)->hh.tbl->hho))->prev =                                \
-                    _hd_hh_del->prev;                                            \
-        }                                                                        \
-        UT_HASH_TO_BKT( _hd_hh_del->hashv, (head)->hh.tbl->num_buckets, _hd_bkt);   \
-        UT_HASH_DEL_IN_BKT(hh,(head)->hh.tbl->buckets[_hd_bkt], _hd_hh_del);        \
-        (head)->hh.tbl->num_items--;                                             \
-    }                                                                            \
-    UT_HASH_FSCK(hh,head);                                                          \
-} while (0)
-
-
-/* convenience forms of UT_HASH_FIND/UT_HASH_ADD/UT_HASH_DEL */
-#define UT_HASH_FIND_STR(head,findstr,out)                                          \
-    UT_HASH_FIND(hh,head,findstr,strlen(findstr),out)
-#define UT_HASH_ADD_STR(head,strfield,add)                                          \
-    UT_HASH_ADD(hh,head,strfield,strlen(add->strfield),add)
-#define UT_HASH_REPLACE_STR(head,strfield,add,replaced)                             \
-  UT_HASH_REPLACE(hh,head,strfield,strlen(add->strfield),add,replaced)
-#define UT_HASH_FIND_INT(head,findint,out)                                          \
-    UT_HASH_FIND(hh,head,findint,sizeof(int),out)
-#define UT_HASH_ADD_INT(head,intfield,add)                                          \
-    UT_HASH_ADD(hh,head,intfield,sizeof(int),add)
-#define UT_HASH_REPLACE_INT(head,intfield,add,replaced)                             \
-    UT_HASH_REPLACE(hh,head,intfield,sizeof(int),add,replaced)
-#define UT_HASH_FIND_PTR(head,findptr,out)                                          \
-    UT_HASH_FIND(hh,head,findptr,sizeof(void *),out)
-#define UT_HASH_ADD_PTR(head,ptrfield,add)                                          \
-    UT_HASH_ADD(hh,head,ptrfield,sizeof(void *),add)
-#define UT_HASH_REPLACE_PTR(head,ptrfield,add)                                      \
-    UT_HASH_REPLACE(hh,head,ptrfield,sizeof(void *),add,replaced)
-#define UT_HASH_DEL(head,delptr)                                                    \
-    UT_HASH_DELETE(hh,head,delptr)
-
-/* UT_HASH_FSCK checks hash integrity on every add/delete when UT_HASH_DEBUG is defined.
- * This is for uthash developer only; it compiles away if UT_HASH_DEBUG isn't defined.
- */
-#ifdef UT_HASH_DEBUG
-#define UT_HASH_OOPS(...) do { fprintf(stderr,__VA_ARGS__); exit(-1); } while (0)
-#define UT_HASH_FSCK(hh,head)                                                       \
-do {                                                                             \
-    unsigned _bkt_i;                                                             \
-    unsigned _count, _bkt_count;                                                 \
-    char *_prev;                                                                 \
-    struct UT_hash_handle *_thh;                                                 \
-    if (head) {                                                                  \
-        _count = 0;                                                              \
-        for( _bkt_i = 0; _bkt_i < (head)->hh.tbl->num_buckets; _bkt_i++) {       \
-            _bkt_count = 0;                                                      \
-            _thh = (head)->hh.tbl->buckets[_bkt_i].hh_head;                      \
-            _prev = NULL;                                                        \
-            while (_thh) {                                                       \
-               if (_prev != (char*)(_thh->hh_prev)) {                            \
-                   UT_HASH_OOPS("invalid hh_prev %p, actual %p\n",                  \
-                    _thh->hh_prev, _prev );                                      \
-               }                                                                 \
-               _bkt_count++;                                                     \
-               _prev = (char*)(_thh);                                            \
-               _thh = _thh->hh_next;                                             \
-            }                                                                    \
-            _count += _bkt_count;                                                \
-            if ((head)->hh.tbl->buckets[_bkt_i].count !=  _bkt_count) {          \
-               UT_HASH_OOPS("invalid bucket count %d, actual %d\n",                 \
-                (head)->hh.tbl->buckets[_bkt_i].count, _bkt_count);              \
-            }                                                                    \
-        }                                                                        \
-        if (_count != (head)->hh.tbl->num_items) {                               \
-            UT_HASH_OOPS("invalid hh item count %d, actual %d\n",                   \
-                (head)->hh.tbl->num_items, _count );                             \
-        }                                                                        \
-        /* traverse hh in app order; check next/prev integrity, count */         \
-        _count = 0;                                                              \
-        _prev = NULL;                                                            \
-        _thh =  &(head)->hh;                                                     \
-        while (_thh) {                                                           \
-           _count++;                                                             \
-           if (_prev !=(char*)(_thh->prev)) {                                    \
-              UT_HASH_OOPS("invalid prev %p, actual %p\n",                          \
-                    _thh->prev, _prev );                                         \
-           }                                                                     \
-           _prev = (char*)ELMT_FROM_HH((head)->hh.tbl, _thh);                    \
-           _thh = ( _thh->next ?  (UT_hash_handle*)((char*)(_thh->next) +        \
-                                  (head)->hh.tbl->hho) : NULL );                 \
-        }                                                                        \
-        if (_count != (head)->hh.tbl->num_items) {                               \
-            UT_HASH_OOPS("invalid app item count %d, actual %d\n",                  \
-                (head)->hh.tbl->num_items, _count );                             \
-        }                                                                        \
-    }                                                                            \
-} while (0)
-#else
-#define UT_HASH_FSCK(hh,head) 
-#endif
-
-/* When compiled with -DUT_HASH_EMIT_KEYS, length-prefixed keys are emitted to 
- * the descriptor to which this macro is defined for tuning the hash function.
- * The app can #include <unistd.h> to get the prototype for write(2). */
-#ifdef UT_HASH_EMIT_KEYS
-#define UT_HASH_EMIT_KEY(hh,head,keyptr,fieldlen)                                   \
-do {                                                                             \
-    unsigned _klen = fieldlen;                                                   \
-    write(UT_HASH_EMIT_KEYS, &_klen, sizeof(_klen));                                \
-    write(UT_HASH_EMIT_KEYS, keyptr, fieldlen);                                     \
-} while (0)
-#else 
-#define UT_HASH_EMIT_KEY(hh,head,keyptr,fieldlen)                    
-#endif
-
-/* default to Jenkin's hash unless overridden e.g. DUT_HASH_FUNCTION=UT_HASH_SAX */
-#ifdef UT_HASH_FUNCTION 
-#define UT_HASH_FCN UT_HASH_FUNCTION
-#else
-#define UT_HASH_FCN UT_HASH_JEN
-#endif
-
-/* The Bernstein hash function, used in Perl prior to v5.6 */
-#define UT_HASH_BER(key,keylen,num_bkts,hashv,bkt)                                  \
-do {                                                                             \
-  unsigned _hb_keylen=keylen;                                                    \
-  char *_hb_key=(char*)(key);                                                    \
-  (hashv) = 0;                                                                   \
-  while (_hb_keylen--)  { (hashv) = ((hashv) * 33) + *_hb_key++; }               \
-  bkt = (hashv) & (num_bkts-1);                                                  \
-} while (0)
-
-
-/* SAX/FNV/OAT/JEN hash functions are macro variants of those listed at 
- * http://eternallyconfuzzled.com/tuts/algorithms/jsw_tut_hashing.aspx */
-#define UT_HASH_SAX(key,keylen,num_bkts,hashv,bkt)                                  \
-do {                                                                             \
-  unsigned _sx_i;                                                                \
-  char *_hs_key=(char*)(key);                                                    \
-  hashv = 0;                                                                     \
-  for(_sx_i=0; _sx_i < keylen; _sx_i++)                                          \
-      hashv ^= (hashv << 5) + (hashv >> 2) + _hs_key[_sx_i];                     \
-  bkt = hashv & (num_bkts-1);                                                    \
-} while (0)
-
-#define UT_HASH_FNV(key,keylen,num_bkts,hashv,bkt)                                  \
-do {                                                                             \
-  unsigned _fn_i;                                                                \
-  char *_hf_key=(char*)(key);                                                    \
-  hashv = 2166136261UL;                                                          \
-  for(_fn_i=0; _fn_i < keylen; _fn_i++)                                          \
-      hashv = (hashv * 16777619) ^ _hf_key[_fn_i];                               \
-  bkt = hashv & (num_bkts-1);                                                    \
-} while(0) 
- 
-#define UT_HASH_OAT(key,keylen,num_bkts,hashv,bkt)                                  \
-do {                                                                             \
-  unsigned _ho_i;                                                                \
-  char *_ho_key=(char*)(key);                                                    \
-  hashv = 0;                                                                     \
-  for(_ho_i=0; _ho_i < keylen; _ho_i++) {                                        \
-      hashv += _ho_key[_ho_i];                                                   \
-      hashv += (hashv << 10);                                                    \
-      hashv ^= (hashv >> 6);                                                     \
-  }                                                                              \
-  hashv += (hashv << 3);                                                         \
-  hashv ^= (hashv >> 11);                                                        \
-  hashv += (hashv << 15);                                                        \
-  bkt = hashv & (num_bkts-1);                                                    \
-} while(0)
-
-#define UT_HASH_JEN_MIX(a,b,c)                                                      \
-do {                                                                             \
-  a -= b; a -= c; a ^= ( c >> 13 );                                              \
-  b -= c; b -= a; b ^= ( a << 8 );                                               \
-  c -= a; c -= b; c ^= ( b >> 13 );                                              \
-  a -= b; a -= c; a ^= ( c >> 12 );                                              \
-  b -= c; b -= a; b ^= ( a << 16 );                                              \
-  c -= a; c -= b; c ^= ( b >> 5 );                                               \
-  a -= b; a -= c; a ^= ( c >> 3 );                                               \
-  b -= c; b -= a; b ^= ( a << 10 );                                              \
-  c -= a; c -= b; c ^= ( b >> 15 );                                              \
-} while (0)
-
-#define UT_HASH_JEN(key,keylen,num_bkts,hashv,bkt)                                  \
-do {                                                                             \
-  unsigned _hj_i,_hj_j,_hj_k;                                                    \
-  unsigned char *_hj_key=(unsigned char*)(key);                                  \
-  hashv = 0xfeedbeef;                                                            \
-  _hj_i = _hj_j = 0x9e3779b9;                                                    \
-  _hj_k = (unsigned)keylen;                                                      \
-  while (_hj_k >= 12) {                                                          \
-    _hj_i +=    (_hj_key[0] + ( (unsigned)_hj_key[1] << 8 )                      \
-        + ( (unsigned)_hj_key[2] << 16 )                                         \
-        + ( (unsigned)_hj_key[3] << 24 ) );                                      \
-    _hj_j +=    (_hj_key[4] + ( (unsigned)_hj_key[5] << 8 )                      \
-        + ( (unsigned)_hj_key[6] << 16 )                                         \
-        + ( (unsigned)_hj_key[7] << 24 ) );                                      \
-    hashv += (_hj_key[8] + ( (unsigned)_hj_key[9] << 8 )                         \
-        + ( (unsigned)_hj_key[10] << 16 )                                        \
-        + ( (unsigned)_hj_key[11] << 24 ) );                                     \
-                                                                                 \
-     UT_HASH_JEN_MIX(_hj_i, _hj_j, hashv);                                          \
-                                                                                 \
-     _hj_key += 12;                                                              \
-     _hj_k -= 12;                                                                \
-  }                                                                              \
-  hashv += keylen;                                                               \
-  switch ( _hj_k ) {                                                             \
-     case 11: hashv += ( (unsigned)_hj_key[10] << 24 ); /* FALLTHROUGH */        \
-     case 10: hashv += ( (unsigned)_hj_key[9] << 16 );  /* FALLTHROUGH */        \
-     case 9:  hashv += ( (unsigned)_hj_key[8] << 8 );   /* FALLTHROUGH */        \
-     case 8:  _hj_j += ( (unsigned)_hj_key[7] << 24 );  /* FALLTHROUGH */        \
-     case 7:  _hj_j += ( (unsigned)_hj_key[6] << 16 );  /* FALLTHROUGH */        \
-     case 6:  _hj_j += ( (unsigned)_hj_key[5] << 8 );   /* FALLTHROUGH */        \
-     case 5:  _hj_j += _hj_key[4];                      /* FALLTHROUGH */        \
-     case 4:  _hj_i += ( (unsigned)_hj_key[3] << 24 );  /* FALLTHROUGH */        \
-     case 3:  _hj_i += ( (unsigned)_hj_key[2] << 16 );  /* FALLTHROUGH */        \
-     case 2:  _hj_i += ( (unsigned)_hj_key[1] << 8 );   /* FALLTHROUGH */        \
-     case 1:  _hj_i += _hj_key[0];                                               \
-  }                                                                              \
-  UT_HASH_JEN_MIX(_hj_i, _hj_j, hashv);                                             \
-  bkt = hashv & (num_bkts-1);                                                    \
-} while(0)
-
-/* The Paul Hsieh hash function */
-#undef get16bits
-#if (defined(__GNUC__) && defined(__i386__)) || defined(__WATCOMC__)             \
-  || defined(_MSC_VER) || defined (__BORLANDC__) || defined (__TURBOC__)
-#define get16bits(d) (*((const uint16_t *) (d)))
-#endif
-
-#if !defined (get16bits)
-#define get16bits(d) ((((uint32_t)(((const uint8_t *)(d))[1])) << 8)             \
-                       +(uint32_t)(((const uint8_t *)(d))[0]) )
-#endif
-#define UT_HASH_SFH(key,keylen,num_bkts,hashv,bkt)                                  \
-do {                                                                             \
-  unsigned char *_sfh_key=(unsigned char*)(key);                                 \
-  uint32_t _sfh_tmp, _sfh_len = keylen;                                          \
-                                                                                 \
-  int _sfh_rem = _sfh_len & 3;                                                   \
-  _sfh_len >>= 2;                                                                \
-  hashv = 0xcafebabe;                                                            \
-                                                                                 \
-  /* Main loop */                                                                \
-  for (;_sfh_len > 0; _sfh_len--) {                                              \
-    hashv    += get16bits (_sfh_key);                                            \
-    _sfh_tmp       = (uint32_t)(get16bits (_sfh_key+2)) << 11  ^ hashv;          \
-    hashv     = (hashv << 16) ^ _sfh_tmp;                                        \
-    _sfh_key += 2*sizeof (uint16_t);                                             \
-    hashv    += hashv >> 11;                                                     \
-  }                                                                              \
-                                                                                 \
-  /* Handle end cases */                                                         \
-  switch (_sfh_rem) {                                                            \
-    case 3: hashv += get16bits (_sfh_key);                                       \
-            hashv ^= hashv << 16;                                                \
-            hashv ^= (uint32_t)(_sfh_key[sizeof (uint16_t)] << 18);              \
-            hashv += hashv >> 11;                                                \
-            break;                                                               \
-    case 2: hashv += get16bits (_sfh_key);                                       \
-            hashv ^= hashv << 11;                                                \
-            hashv += hashv >> 17;                                                \
-            break;                                                               \
-    case 1: hashv += *_sfh_key;                                                  \
-            hashv ^= hashv << 10;                                                \
-            hashv += hashv >> 1;                                                 \
-  }                                                                              \
-                                                                                 \
-    /* Force "avalanching" of final 127 bits */                                  \
-    hashv ^= hashv << 3;                                                         \
-    hashv += hashv >> 5;                                                         \
-    hashv ^= hashv << 4;                                                         \
-    hashv += hashv >> 17;                                                        \
-    hashv ^= hashv << 25;                                                        \
-    hashv += hashv >> 6;                                                         \
-    bkt = hashv & (num_bkts-1);                                                  \
-} while(0) 
-
-#ifdef UT_HASH_USING_NO_STRICT_ALIASING
-/* The MurmurHash exploits some CPU's (x86,x86_64) tolerance for unaligned reads.
- * For other types of CPU's (e.g. Sparc) an unaligned read causes a bus error.
- * MurmurHash uses the faster approach only on CPU's where we know it's safe. 
- *
- * Note the preprocessor built-in defines can be emitted using:
- *
- *   gcc -m64 -dM -E - < /dev/null                  (on gcc)
- *   cc -## a.c (where a.c is a simple test file)   (Sun Studio)
- */
-#if (defined(__i386__) || defined(__x86_64__)  || defined(_M_IX86))
-#define MUR_GETBLOCK(p,i) p[i]
-#else /* non intel */
-#define MUR_PLUS0_ALIGNED(p) (((unsigned long)p & 0x3) == 0)
-#define MUR_PLUS1_ALIGNED(p) (((unsigned long)p & 0x3) == 1)
-#define MUR_PLUS2_ALIGNED(p) (((unsigned long)p & 0x3) == 2)
-#define MUR_PLUS3_ALIGNED(p) (((unsigned long)p & 0x3) == 3)
-#define WP(p) ((uint32_t*)((unsigned long)(p) & ~3UL))
-#if (defined(__BIG_ENDIAN__) || defined(SPARC) || defined(__ppc__) || defined(__ppc64__))
-#define MUR_THREE_ONE(p) ((((*WP(p))&0x00ffffff) << 8) | (((*(WP(p)+1))&0xff000000) >> 24))
-#define MUR_TWO_TWO(p)   ((((*WP(p))&0x0000ffff) <<16) | (((*(WP(p)+1))&0xffff0000) >> 16))
-#define MUR_ONE_THREE(p) ((((*WP(p))&0x000000ff) <<24) | (((*(WP(p)+1))&0xffffff00) >>  8))
-#else /* assume little endian non-intel */
-#define MUR_THREE_ONE(p) ((((*WP(p))&0xffffff00) >> 8) | (((*(WP(p)+1))&0x000000ff) << 24))
-#define MUR_TWO_TWO(p)   ((((*WP(p))&0xffff0000) >>16) | (((*(WP(p)+1))&0x0000ffff) << 16))
-#define MUR_ONE_THREE(p) ((((*WP(p))&0xff000000) >>24) | (((*(WP(p)+1))&0x00ffffff) <<  8))
-#endif
-#define MUR_GETBLOCK(p,i) (MUR_PLUS0_ALIGNED(p) ? ((p)[i]) :           \
-                            (MUR_PLUS1_ALIGNED(p) ? MUR_THREE_ONE(p) : \
-                             (MUR_PLUS2_ALIGNED(p) ? MUR_TWO_TWO(p) :  \
-                                                      MUR_ONE_THREE(p))))
-#endif
-#define MUR_ROTL32(x,r) (((x) << (r)) | ((x) >> (32 - (r))))
-#define MUR_FMIX(_h) \
-do {                 \
-  _h ^= _h >> 16;    \
-  _h *= 0x85ebca6b;  \
-  _h ^= _h >> 13;    \
-  _h *= 0xc2b2ae35l; \
-  _h ^= _h >> 16;    \
-} while(0)
-
-#define UT_HASH_MUR(key,keylen,num_bkts,hashv,bkt)                        \
-do {                                                                   \
-  const uint8_t *_mur_data = (const uint8_t*)(key);                    \
-  const int _mur_nblocks = (keylen) / 4;                               \
-  uint32_t _mur_h1 = 0xf88D5353;                                       \
-  uint32_t _mur_c1 = 0xcc9e2d51;                                       \
-  uint32_t _mur_c2 = 0x1b873593;                                       \
-  uint32_t _mur_k1 = 0;                                                \
-  const uint8_t *_mur_tail;                                            \
-  const uint32_t *_mur_blocks = (const uint32_t*)(_mur_data+_mur_nblocks*4); \
-  int _mur_i;                                                          \
-  for(_mur_i = -_mur_nblocks; _mur_i; _mur_i++) {                      \
-    _mur_k1 = MUR_GETBLOCK(_mur_blocks,_mur_i);                        \
-    _mur_k1 *= _mur_c1;                                                \
-    _mur_k1 = MUR_ROTL32(_mur_k1,15);                                  \
-    _mur_k1 *= _mur_c2;                                                \
-                                                                       \
-    _mur_h1 ^= _mur_k1;                                                \
-    _mur_h1 = MUR_ROTL32(_mur_h1,13);                                  \
-    _mur_h1 = _mur_h1*5+0xe6546b64;                                    \
-  }                                                                    \
-  _mur_tail = (const uint8_t*)(_mur_data + _mur_nblocks*4);            \
-  _mur_k1=0;                                                           \
-  switch((keylen) & 3) {                                               \
-    case 3: _mur_k1 ^= _mur_tail[2] << 16;                             \
-    case 2: _mur_k1 ^= _mur_tail[1] << 8;                              \
-    case 1: _mur_k1 ^= _mur_tail[0];                                   \
-    _mur_k1 *= _mur_c1;                                                \
-    _mur_k1 = MUR_ROTL32(_mur_k1,15);                                  \
-    _mur_k1 *= _mur_c2;                                                \
-    _mur_h1 ^= _mur_k1;                                                \
-  }                                                                    \
-  _mur_h1 ^= (keylen);                                                 \
-  MUR_FMIX(_mur_h1);                                                   \
-  hashv = _mur_h1;                                                     \
-  bkt = hashv & (num_bkts-1);                                          \
-} while(0)
-#endif  /* UT_HASH_USING_NO_STRICT_ALIASING */
-
-/* key comparison function; return 0 if keys equal */
-#define UT_HASH_KEYCMP(a,b,len) memcmp(a,b,len) 
-
-/* iterate over items in a known bucket to find desired item */
-#define UT_HASH_FIND_IN_BKT(tbl,hh,head,keyptr,keylen_in,out)                       \
-do {                                                                             \
- if (head.hh_head) DECLTYPE_ASSIGN(out,ELMT_FROM_HH(tbl,head.hh_head));          \
- else out=NULL;                                                                  \
- while (out) {                                                                   \
-    if ((out)->hh.keylen == keylen_in) {                                           \
-        if ((UT_HASH_KEYCMP((out)->hh.key,keyptr,keylen_in)) == 0) break;             \
-    }                                                                            \
-    if ((out)->hh.hh_next) DECLTYPE_ASSIGN(out,ELMT_FROM_HH(tbl,(out)->hh.hh_next)); \
-    else out = NULL;                                                             \
- }                                                                               \
-} while(0)
-
-/* add an item to a bucket  */
-#define UT_HASH_ADD_TO_BKT(head,addhh)                                              \
-do {                                                                             \
- head.count++;                                                                   \
- (addhh)->hh_next = head.hh_head;                                                \
- (addhh)->hh_prev = NULL;                                                        \
- if (head.hh_head) { (head).hh_head->hh_prev = (addhh); }                        \
- (head).hh_head=addhh;                                                           \
- if (head.count >= ((head.expand_mult+1) * UT_HASH_BKT_CAPACITY_THRESH)             \
-     && (addhh)->tbl->noexpand != 1) {                                           \
-       UT_HASH_EXPAND_BUCKETS((addhh)->tbl);                                        \
- }                                                                               \
-} while(0)
-
-/* remove an item from a given bucket */
-#define UT_HASH_DEL_IN_BKT(hh,head,hh_del)                                          \
-    (head).count--;                                                              \
-    if ((head).hh_head == hh_del) {                                              \
-      (head).hh_head = hh_del->hh_next;                                          \
-    }                                                                            \
-    if (hh_del->hh_prev) {                                                       \
-        hh_del->hh_prev->hh_next = hh_del->hh_next;                              \
-    }                                                                            \
-    if (hh_del->hh_next) {                                                       \
-        hh_del->hh_next->hh_prev = hh_del->hh_prev;                              \
-    }                                                                
-
-/* Bucket expansion has the effect of doubling the number of buckets
- * and redistributing the items into the new buckets. Ideally the
- * items will distribute more or less evenly into the new buckets
- * (the extent to which this is true is a measure of the quality of
- * the hash function as it applies to the key domain). 
- * 
- * With the items distributed into more buckets, the chain length
- * (item count) in each bucket is reduced. Thus by expanding buckets
- * the hash keeps a bound on the chain length. This bounded chain 
- * length is the essence of how a hash provides constant time lookup.
- * 
- * The calculation of tbl->ideal_chain_maxlen below deserves some
- * explanation. First, keep in mind that we're calculating the ideal
- * maximum chain length based on the *new* (doubled) bucket count.
- * In fractions this is just n/b (n=number of items,b=new num buckets).
- * Since the ideal chain length is an integer, we want to calculate 
- * ceil(n/b). We don't depend on floating point arithmetic in this
- * hash, so to calculate ceil(n/b) with integers we could write
- * 
- *      ceil(n/b) = (n/b) + ((n%b)?1:0)
- * 
- * and in fact a previous version of this hash did just that.
- * But now we have improved things a bit by recognizing that b is
- * always a power of two. We keep its base 2 log handy (call it lb),
- * so now we can write this with a bit shift and logical AND:
- * 
- *      ceil(n/b) = (n>>lb) + ( (n & (b-1)) ? 1:0)
- * 
- */
-#define UT_HASH_EXPAND_BUCKETS(tbl)                                                 \
-do {                                                                             \
-    unsigned _he_bkt;                                                            \
-    unsigned _he_bkt_i;                                                          \
-    struct UT_hash_handle *_he_thh, *_he_hh_nxt;                                 \
-    UT_hash_bucket *_he_new_buckets, *_he_newbkt;                                \
-    _he_new_buckets = (UT_hash_bucket*)uthash_malloc(                            \
-             2 * tbl->num_buckets * sizeof(struct UT_hash_bucket));              \
-    if (!_he_new_buckets) { uthash_fatal( "out of memory"); }                    \
-    memset(_he_new_buckets, 0,                                                   \
-            2 * tbl->num_buckets * sizeof(struct UT_hash_bucket));               \
-    tbl->ideal_chain_maxlen =                                                    \
-       (tbl->num_items >> (tbl->log2_num_buckets+1)) +                           \
-       ((tbl->num_items & ((tbl->num_buckets*2)-1)) ? 1 : 0);                    \
-    tbl->nonideal_items = 0;                                                     \
-    for(_he_bkt_i = 0; _he_bkt_i < tbl->num_buckets; _he_bkt_i++)                \
-    {                                                                            \
-        _he_thh = tbl->buckets[ _he_bkt_i ].hh_head;                             \
-        while (_he_thh) {                                                        \
-           _he_hh_nxt = _he_thh->hh_next;                                        \
-           UT_HASH_TO_BKT( _he_thh->hashv, tbl->num_buckets*2, _he_bkt);            \
-           _he_newbkt = &(_he_new_buckets[ _he_bkt ]);                           \
-           if (++(_he_newbkt->count) > tbl->ideal_chain_maxlen) {                \
-             tbl->nonideal_items++;                                              \
-             _he_newbkt->expand_mult = _he_newbkt->count /                       \
-                                        tbl->ideal_chain_maxlen;                 \
-           }                                                                     \
-           _he_thh->hh_prev = NULL;                                              \
-           _he_thh->hh_next = _he_newbkt->hh_head;                               \
-           if (_he_newbkt->hh_head) _he_newbkt->hh_head->hh_prev =               \
-                _he_thh;                                                         \
-           _he_newbkt->hh_head = _he_thh;                                        \
-           _he_thh = _he_hh_nxt;                                                 \
-        }                                                                        \
-    }                                                                            \
-    uthash_free( tbl->buckets, tbl->num_buckets*sizeof(struct UT_hash_bucket) ); \
-    tbl->num_buckets *= 2;                                                       \
-    tbl->log2_num_buckets++;                                                     \
-    tbl->buckets = _he_new_buckets;                                              \
-    tbl->ineff_expands = (tbl->nonideal_items > (tbl->num_items >> 1)) ?         \
-        (tbl->ineff_expands+1) : 0;                                              \
-    if (tbl->ineff_expands > 1) {                                                \
-        tbl->noexpand=1;                                                         \
-        uthash_noexpand_fyi(tbl);                                                \
-    }                                                                            \
-    uthash_expand_fyi(tbl);                                                      \
-} while(0)
-
-
-/* This is an adaptation of Simon Tatham's O(n log(n)) mergesort */
-/* Note that UT_HASH_SORT assumes the hash handle name to be hh. 
- * UT_HASH_SRT was added to allow the hash handle name to be passed in. */
-#define UT_HASH_SORT(head,cmpfcn) UT_HASH_SRT(hh,head,cmpfcn)
-#define UT_HASH_SRT(hh,head,cmpfcn)                                                 \
-do {                                                                             \
-  unsigned _hs_i;                                                                \
-  unsigned _hs_looping,_hs_nmerges,_hs_insize,_hs_psize,_hs_qsize;               \
-  struct UT_hash_handle *_hs_p, *_hs_q, *_hs_e, *_hs_list, *_hs_tail;            \
-  if (head) {                                                                    \
-      _hs_insize = 1;                                                            \
-      _hs_looping = 1;                                                           \
-      _hs_list = &((head)->hh);                                                  \
-      while (_hs_looping) {                                                      \
-          _hs_p = _hs_list;                                                      \
-          _hs_list = NULL;                                                       \
-          _hs_tail = NULL;                                                       \
-          _hs_nmerges = 0;                                                       \
-          while (_hs_p) {                                                        \
-              _hs_nmerges++;                                                     \
-              _hs_q = _hs_p;                                                     \
-              _hs_psize = 0;                                                     \
-              for ( _hs_i = 0; _hs_i  < _hs_insize; _hs_i++ ) {                  \
-                  _hs_psize++;                                                   \
-                  _hs_q = (UT_hash_handle*)((_hs_q->next) ?                      \
-                          ((void*)((char*)(_hs_q->next) +                        \
-                          (head)->hh.tbl->hho)) : NULL);                         \
-                  if (! (_hs_q) ) break;                                         \
-              }                                                                  \
-              _hs_qsize = _hs_insize;                                            \
-              while ((_hs_psize > 0) || ((_hs_qsize > 0) && _hs_q )) {           \
-                  if (_hs_psize == 0) {                                          \
-                      _hs_e = _hs_q;                                             \
-                      _hs_q = (UT_hash_handle*)((_hs_q->next) ?                  \
-                              ((void*)((char*)(_hs_q->next) +                    \
-                              (head)->hh.tbl->hho)) : NULL);                     \
-                      _hs_qsize--;                                               \
-                  } else if ( (_hs_qsize == 0) || !(_hs_q) ) {                   \
-                      _hs_e = _hs_p;                                             \
-                      _hs_p = (UT_hash_handle*)((_hs_p->next) ?                  \
-                              ((void*)((char*)(_hs_p->next) +                    \
-                              (head)->hh.tbl->hho)) : NULL);                     \
-                      _hs_psize--;                                               \
-                  } else if ((                                                   \
-                      cmpfcn(DECLTYPE(head)(ELMT_FROM_HH((head)->hh.tbl,_hs_p)), \
-                             DECLTYPE(head)(ELMT_FROM_HH((head)->hh.tbl,_hs_q))) \
-                             ) <= 0) {                                           \
-                      _hs_e = _hs_p;                                             \
-                      _hs_p = (UT_hash_handle*)((_hs_p->next) ?                  \
-                              ((void*)((char*)(_hs_p->next) +                    \
-                              (head)->hh.tbl->hho)) : NULL);                     \
-                      _hs_psize--;                                               \
-                  } else {                                                       \
-                      _hs_e = _hs_q;                                             \
-                      _hs_q = (UT_hash_handle*)((_hs_q->next) ?                  \
-                              ((void*)((char*)(_hs_q->next) +                    \
-                              (head)->hh.tbl->hho)) : NULL);                     \
-                      _hs_qsize--;                                               \
-                  }                                                              \
-                  if ( _hs_tail ) {                                              \
-                      _hs_tail->next = ((_hs_e) ?                                \
-                            ELMT_FROM_HH((head)->hh.tbl,_hs_e) : NULL);          \
-                  } else {                                                       \
-                      _hs_list = _hs_e;                                          \
-                  }                                                              \
-                  _hs_e->prev = ((_hs_tail) ?                                    \
-                     ELMT_FROM_HH((head)->hh.tbl,_hs_tail) : NULL);              \
-                  _hs_tail = _hs_e;                                              \
-              }                                                                  \
-              _hs_p = _hs_q;                                                     \
-          }                                                                      \
-          _hs_tail->next = NULL;                                                 \
-          if ( _hs_nmerges <= 1 ) {                                              \
-              _hs_looping=0;                                                     \
-              (head)->hh.tbl->tail = _hs_tail;                                   \
-              DECLTYPE_ASSIGN(head,ELMT_FROM_HH((head)->hh.tbl, _hs_list));      \
-          }                                                                      \
-          _hs_insize *= 2;                                                       \
-      }                                                                          \
-      UT_HASH_FSCK(hh,head);                                                        \
- }                                                                               \
-} while (0)
-
-/* This function selects items from one hash into another hash. 
- * The end result is that the selected items have dual presence 
- * in both hashes. There is no copy of the items made; rather 
- * they are added into the new hash through a secondary hash 
- * hash handle that must be present in the structure. */
-#define UT_HASH_SELECT(hh_dst, dst, hh_src, src, cond)                              \
-do {                                                                             \
-  unsigned _src_bkt, _dst_bkt;                                                   \
-  void *_last_elt=NULL, *_elt;                                                   \
-  UT_hash_handle *_src_hh, *_dst_hh, *_last_elt_hh=NULL;                         \
-  ptrdiff_t _dst_hho = ((char*)(&(dst)->hh_dst) - (char*)(dst));                 \
-  if (src) {                                                                     \
-    for(_src_bkt=0; _src_bkt < (src)->hh_src.tbl->num_buckets; _src_bkt++) {     \
-      for(_src_hh = (src)->hh_src.tbl->buckets[_src_bkt].hh_head;                \
-          _src_hh;                                                               \
-          _src_hh = _src_hh->hh_next) {                                          \
-          _elt = ELMT_FROM_HH((src)->hh_src.tbl, _src_hh);                       \
-          if (cond(_elt)) {                                                      \
-            _dst_hh = (UT_hash_handle*)(((char*)_elt) + _dst_hho);               \
-            _dst_hh->key = _src_hh->key;                                         \
-            _dst_hh->keylen = _src_hh->keylen;                                   \
-            _dst_hh->hashv = _src_hh->hashv;                                     \
-            _dst_hh->prev = _last_elt;                                           \
-            _dst_hh->next = NULL;                                                \
-            if (_last_elt_hh) { _last_elt_hh->next = _elt; }                     \
-            if (!dst) {                                                          \
-              DECLTYPE_ASSIGN(dst,_elt);                                         \
-              UT_HASH_MAKE_TABLE(hh_dst,dst);                                       \
-            } else {                                                             \
-              _dst_hh->tbl = (dst)->hh_dst.tbl;                                  \
-            }                                                                    \
-            UT_HASH_TO_BKT(_dst_hh->hashv, _dst_hh->tbl->num_buckets, _dst_bkt);    \
-            UT_HASH_ADD_TO_BKT(_dst_hh->tbl->buckets[_dst_bkt],_dst_hh);            \
-            (dst)->hh_dst.tbl->num_items++;                                      \
-            _last_elt = _elt;                                                    \
-            _last_elt_hh = _dst_hh;                                              \
-          }                                                                      \
-      }                                                                          \
-    }                                                                            \
-  }                                                                              \
-  UT_HASH_FSCK(hh_dst,dst);                                                         \
-} while (0)
-
-#define UT_HASH_CLEAR(hh,head)                                                      \
-do {                                                                             \
-  if (head) {                                                                    \
-    uthash_free((head)->hh.tbl->buckets,                                         \
-                (head)->hh.tbl->num_buckets*sizeof(struct UT_hash_bucket));      \
-    UT_HASH_BLOOM_FREE((head)->hh.tbl);                                             \
-    uthash_free((head)->hh.tbl, sizeof(UT_hash_table));                          \
-    (head)=NULL;                                                                 \
-  }                                                                              \
-} while(0)
-
-#define UT_HASH_OVERHEAD(hh,head)                                                   \
- (size_t)((((head)->hh.tbl->num_items   * sizeof(UT_hash_handle))   +            \
-           ((head)->hh.tbl->num_buckets * sizeof(UT_hash_bucket))   +            \
-            (sizeof(UT_hash_table))                                 +            \
-            (UT_HASH_BLOOM_BYTELEN)))
-
-#ifdef NO_DECLTYPE
-#define UT_HASH_ITER(hh,head,el,tmp)                                                \
-for((el)=(head), (*(char**)(&(tmp)))=(char*)((head)?(head)->hh.next:NULL);       \
-  el; (el)=(tmp),(*(char**)(&(tmp)))=(char*)((tmp)?(tmp)->hh.next:NULL)) 
-#else
-#define UT_HASH_ITER(hh,head,el,tmp)                                                \
-for((el)=(head),(tmp)=DECLTYPE(el)((head)?(head)->hh.next:NULL);                 \
-  el; (el)=(tmp),(tmp)=DECLTYPE(el)((tmp)?(tmp)->hh.next:NULL))
-#endif
-
-/* obtain a count of items in the hash */
-#define UT_HASH_COUNT(head) UT_HASH_CNT(hh,head) 
-#define UT_HASH_CNT(hh,head) ((head)?((head)->hh.tbl->num_items):0)
-
-typedef struct UT_hash_bucket {
-   struct UT_hash_handle *hh_head;
-   unsigned count;
-
-   /* expand_mult is normally set to 0. In this situation, the max chain length
-    * threshold is enforced at its default value, UT_HASH_BKT_CAPACITY_THRESH. (If
-    * the bucket's chain exceeds this length, bucket expansion is triggered). 
-    * However, setting expand_mult to a non-zero value delays bucket expansion
-    * (that would be triggered by additions to this particular bucket)
-    * until its chain length reaches a *multiple* of UT_HASH_BKT_CAPACITY_THRESH.
-    * (The multiplier is simply expand_mult+1). The whole idea of this
-    * multiplier is to reduce bucket expansions, since they are expensive, in
-    * situations where we know that a particular bucket tends to be overused.
-    * It is better to let its chain length grow to a longer yet-still-bounded
-    * value, than to do an O(n) bucket expansion too often. 
-    */
-   unsigned expand_mult;
-
-} UT_hash_bucket;
-
-/* random signature used only to find hash tables in external analysis */
-#define UT_HASH_SIGNATURE 0xa0111fe1
-#define UT_HASH_BLOOM_SIGNATURE 0xb12220f2
-
-typedef struct UT_hash_table {
-   UT_hash_bucket *buckets;
-   unsigned num_buckets, log2_num_buckets;
-   unsigned num_items;
-   struct UT_hash_handle *tail; /* tail hh in app order, for fast append    */
-   ptrdiff_t hho; /* hash handle offset (byte pos of hash handle in element */
-
-   /* in an ideal situation (all buckets used equally), no bucket would have
-    * more than ceil(#items/#buckets) items. that's the ideal chain length. */
-   unsigned ideal_chain_maxlen;
-
-   /* nonideal_items is the number of items in the hash whose chain position
-    * exceeds the ideal chain maxlen. these items pay the penalty for an uneven
-    * hash distribution; reaching them in a chain traversal takes >ideal steps */
-   unsigned nonideal_items;
-
-   /* ineffective expands occur when a bucket doubling was performed, but 
-    * afterward, more than half the items in the hash had nonideal chain
-    * positions. If this happens on two consecutive expansions we inhibit any
-    * further expansion, as it's not helping; this happens when the hash
-    * function isn't a good fit for the key domain. When expansion is inhibited
-    * the hash will still work, albeit no longer in constant time. */
-   unsigned ineff_expands, noexpand;
-
-   uint32_t signature; /* used only to find hash tables in external analysis */
-#ifdef UT_HASH_BLOOM
-   uint32_t bloom_sig; /* used only to test bloom exists in external analysis */
-   uint8_t *bloom_bv;
-   char bloom_nbits;
-#endif
-
-} UT_hash_table;
-
-typedef struct UT_hash_handle {
-   struct UT_hash_table *tbl;
-   void *prev;                       /* prev element in app order      */
-   void *next;                       /* next element in app order      */
-   struct UT_hash_handle *hh_prev;   /* previous hh in bucket order    */
-   struct UT_hash_handle *hh_next;   /* next hh in bucket order        */
-   void *key;                        /* ptr to enclosing struct's key  */
-   unsigned keylen;                  /* enclosing struct's key len     */
-   unsigned hashv;                   /* result of hash-fcn(key)        */
-} UT_hash_handle;
-
-#endif /* UT_HASH_H */
diff -pruN 8.0.1-5/version.rc.in 8.2.0~beta1-1~exp1/version.rc.in
--- 8.0.1-5/version.rc.in	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/version.rc.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,53 +0,0 @@
-#include "winres.h"
-
-#define VER_FILEVERSION             @MapServer_VERSION_MAJOR@,@MapServer_VERSION_MINOR@,@MapServer_VERSION_REVISION@,0
-#define VER_FILEVERSION_STR         "@MapServer_VERSION_STRING@\0"
-
-#define VER_PRODUCTVERSION             @MapServer_VERSION_MAJOR@,@MapServer_VERSION_MINOR@,@MapServer_VERSION_REVISION@,0
-#define VER_PRODUCTVERSION_STR         "@MapServer_VERSION_STRING@\0"
-
-#ifndef DEBUG
-#define VER_DEBUG                   0
-#else
-#define VER_DEBUG                   VS_FF_DEBUG
-#endif
-
-VS_VERSION_INFO VERSIONINFO
-	FILEVERSION    	VER_FILEVERSION
-	PRODUCTVERSION 	VER_PRODUCTVERSION
-    FILEFLAGSMASK VS_FFI_FILEFLAGSMASK
-	FILEFLAGS      	VER_DEBUG
-    FILEOS VOS__WINDOWS32
-    FILETYPE VFT_DLL
-    FILESUBTYPE VFT2_UNKNOWN
-BEGIN
-    BLOCK "StringFileInfo"
-    BEGIN
-        BLOCK "040904E4"
-        BEGIN
-            VALUE "CompanyName",      "MapServer"
-            VALUE "FileDescription",  "MapServer"
-            VALUE "FileVersion",      VER_FILEVERSION_STR
-            VALUE "InternalName",     ""
-            VALUE "LegalCopyright",   "Copyright (c) 2017 MapServer"
-            VALUE "LegalTrademarks1", ""
-            VALUE "LegalTrademarks2", ""
-            VALUE "OriginalFilename", ""
-            VALUE "ProductName",      "MapServer"
-            VALUE "ProductVersion",   VER_PRODUCTVERSION_STR
-        END
-    END
-
-    BLOCK "VarFileInfo"
-    BEGIN
-        /* The following line should only be modified for localized versions.     */
-        /* It consists of any number of WORD,WORD pairs, with each pair           */
-        /* describing a language,codepage combination supported by the file.      */
-        /*                                                                        */
-        /* For example, a file might have values "0x409,1252" indicating that it  */
-        /* supports English language (0x409) in the Windows ANSI codepage (1252). */
-
-        VALUE "Translation", 0x409, 1252
-
-    END
-END
\ No newline at end of file
diff -pruN 8.0.1-5/xmlmapfile/mapfile.xsd 8.2.0~beta1-1~exp1/xmlmapfile/mapfile.xsd
--- 8.0.1-5/xmlmapfile/mapfile.xsd	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/xmlmapfile/mapfile.xsd	1970-01-01 00:00:00.000000000 +0000
@@ -1,844 +0,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:ms="http://www.mapserver.org/mapserver" targetNamespace="http://www.mapserver.org/mapserver" elementFormDefault="qualified" attributeFormDefault="unqualified" version="6.2.1">
-	<!-- Definition of types -->
-	<xs:simpleType name="rgbColorValueType">
-		<xs:restriction base="xs:integer">
-			<xs:minInclusive value="-1"/>
-			<xs:maxInclusive value="255"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:complexType name="rgbColorType">
-		<xs:attribute name="red" type="ms:rgbColorValueType" use="required"/>
-		<xs:attribute name="green" type="ms:rgbColorValueType" use="required"/>
-		<xs:attribute name="blue" type="ms:rgbColorValueType" use="required"/>
-	</xs:complexType>
-	<xs:simpleType name="rgbColorExtendedValueType">
-		<xs:restriction base="xs:integer">
-			<xs:minInclusive value="-1"/>
-			<xs:maxInclusive value="255"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:complexType name="rgbExtendedColorType">
-		<xs:attribute name="red" type="ms:rgbColorExtendedValueType" use="required"/>
-		<xs:attribute name="green" type="ms:rgbColorExtendedValueType" use="required"/>
-		<xs:attribute name="blue" type="ms:rgbColorExtendedValueType" use="required"/>
-	</xs:complexType>
-	<xs:simpleType name="stateEnum">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="ON"/>
-			<xs:enumeration value="OFF"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="embedStateEnum">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="EMBED"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="stateEnumUnion">
-		<xs:union memberTypes="ms:stateEnum ms:embedStateEnum"/>
-	</xs:simpleType>
-	<xs:simpleType name="booleanEnum">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="TRUE"/>
-			<xs:enumeration value="FALSE"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="positionEnum">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="UL"/>
-			<xs:enumeration value="UC"/>
-			<xs:enumeration value="UR"/>
-			<xs:enumeration value="LL"/>
-			<xs:enumeration value="LC"/>
-			<xs:enumeration value="LR"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="fullPositionEnum">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="CL"/>
-			<xs:enumeration value="CC"/>
-			<xs:enumeration value="CR"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:complexType name="sizeType">
-		<xs:attribute name="x" type="xs:nonNegativeInteger"/>
-		<xs:attribute name="y" type="xs:nonNegativeInteger"/>
-	</xs:complexType>
-	<xs:complexType name="dataRangeType">
-		<xs:attribute name="min" type="xs:double"/>
-		<xs:attribute name="max" type="xs:double"/>
-	</xs:complexType>
-	<xs:complexType name="colorRangeType">
-		<xs:attribute name="rgbColorStart" type="xs:string" use="required"/>
-		<xs:attribute name="rgbColorEnd" type="xs:string" use="required"/>
-		<xs:attribute name="rangeItem" type="xs:string" use="required"/>
-	</xs:complexType>
-	<xs:complexType name="pointType">
-		<xs:attribute name="x" type="xs:float"/>
-		<xs:attribute name="y" type="xs:float"/>
-	</xs:complexType>
-	<xs:simpleType name="angleType">
-		<xs:restriction base="xs:double">
-			<xs:minInclusive value="-360"/>
-			<xs:maxInclusive value="360"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="attributeType">
-		<xs:restriction base="xs:string">
-			<xs:pattern value="\[.+\]"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="debugModeEnum">
-		<xs:restriction base="xs:string">
-			<xs:pattern value="[oO][nN]|[oO][fF][fF]|1|2|3|4|5"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="unitType">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="FEET"/>
-			<xs:enumeration value="INCHES"/>
-			<xs:enumeration value="KILOMETERS"/>
-			<xs:enumeration value="METERS"/>
-			<xs:enumeration value="MILES"/>
-			<xs:enumeration value="NAUTICALMILES"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="extendedUnitType">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="PIXELS"/>
-			<xs:enumeration value="DD"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:simpleType name="unitTypeUnion">
-		<xs:union memberTypes="ms:unitType ms:extendedUnitType"/>
-	</xs:simpleType>
-	<xs:complexType name="itemType">
-		<xs:sequence>
-			<xs:element name="item" minOccurs="0" maxOccurs="unbounded">
-				<xs:complexType>
-					<xs:simpleContent>
-						<xs:extension base="xs:string">
-							<xs:attribute name="name" type="xs:string" use="required"/>
-						</xs:extension>
-					</xs:simpleContent>
-				</xs:complexType>
-			</xs:element>
-		</xs:sequence>
-	</xs:complexType>
-	<xs:simpleType name="alignEnum">
-		<xs:restriction base="xs:string">
-			<xs:enumeration value="LEFT"/>
-			<xs:enumeration value="CENTER"/>
-			<xs:enumeration value="RIGHT"/>
-		</xs:restriction>
-	</xs:simpleType>
-	<xs:complexType name="expressionType">
-		<xs:simpleContent>
-			<xs:extension base="xs:string">
-				<xs:attribute name="type" default="CONSTANT">
-					<xs:simpleType>
-						<xs:restriction base="xs:string">
-							<xs:enumeration value="CONSTANT"/>
-							<xs:enumeration value="REGEX"/>
-							<xs:enumeration value="MSEXPR"/>
-						</xs:restriction>
-					</xs:simpleType>
-				</xs:attribute>
-			</xs:extension>
-		</xs:simpleContent>
-	</xs:complexType>
-	<xs:complexType name="symbolType">
-		<xs:simpleContent>
-			<xs:extension base="xs:string">
-				<xs:attribute name="type" default="ID">
-					<xs:simpleType>
-						<xs:restriction base="xs:string">
-							<xs:enumeration value="ID"/>
-							<xs:enumeration value="NAME"/>
-						</xs:restriction>
-					</xs:simpleType>
-				</xs:attribute>
-			</xs:extension>
-		</xs:simpleContent>
-	</xs:complexType>
-	<!-- Definition of Mapfile elements -->
-	<!-- QUERYMAP Definition -->
-	<xs:complexType name="QueryMap">
-		<xs:all>
-			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
-			<xs:element name="style" minOccurs="0">
-				<xs:simpleType>
-					<xs:restriction base="xs:string">
-						<xs:enumeration value="NORMAL"/>
-						<xs:enumeration value="HILITE"/>
-						<xs:enumeration value="SELECTED"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-		</xs:all>
-		<xs:attribute name="status" type="ms:stateEnum"/>
-	</xs:complexType>
-	<!-- WEB Definition -->
-	<xs:complexType name="Web">
-		<xs:sequence>
-			<xs:element name="browseFormat" type="xs:string" minOccurs="0"/>
-			<xs:element name="empty" type="xs:string" minOccurs="0"/>
-			<xs:element name="error" type="xs:string" minOccurs="0"/>
-			<xs:element name="footer" type="xs:string" minOccurs="0"/>
-			<xs:element name="header" type="xs:string" minOccurs="0"/>
-			<xs:element name="imagePath" type="xs:string" minOccurs="0"/>
-			<xs:element name="tempPath" type="xs:string" minOccurs="0"/>
-			<xs:element name="imageUrl" type="xs:string" minOccurs="0"/>
-			<xs:element name="legendFormat" type="xs:string" minOccurs="0"/>
-			<xs:element name="log" type="xs:string" minOccurs="0"/>
-			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="maxTemplate" type="xs:string" minOccurs="0"/>
-			<xs:element name="Metadata" type="ms:itemType" minOccurs="0"/>
-			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="minTemplate" type="xs:string" minOccurs="0"/>
-			<xs:element name="queryFormat" type="xs:string" minOccurs="0"/>
-			<xs:element name="template" type="xs:string" minOccurs="0"/>
-			<xs:element name="Validation" type="ms:itemType" minOccurs="0"/>
-		</xs:sequence>
-	</xs:complexType>
-	<!-- OUTPUTFORMAT Definition -->
-	<xs:complexType name="OutputFormat">
-		<xs:sequence>
-			<xs:element name="driver" type="xs:string" minOccurs="0"/>
-			<xs:element name="extension" type="xs:string" minOccurs="0"/>
-			<xs:element name="formatOption" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
-			<xs:element name="imageMode">
-				<xs:simpleType>
-					<xs:restriction base="xs:string">
-						<xs:enumeration value="PC256"/>
-						<xs:enumeration value="RGB"/>
-						<xs:enumeration value="RGBA"/>
-						<xs:enumeration value="BYTE"/>
-						<xs:enumeration value="INT16"/>
-						<xs:enumeration value="FLOAT32"/>
-						<xs:enumeration value="FEATURE"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="mimeType" type="xs:string" minOccurs="0"/>
-			<xs:element name="transparent" type="ms:stateEnum" minOccurs="0"/>
-		</xs:sequence>
-		<xs:attribute name="name" type="xs:string"/>
-	</xs:complexType>
-	<!-- LEGEND Definition -->
-	<xs:complexType name="Legend">
-		<xs:all>
-			<xs:element name="imageColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="keySize" type="ms:sizeType" minOccurs="0"/>
-			<xs:element name="keySpacing" type="ms:sizeType" minOccurs="0"/>
-			<xs:element name="Label" type="ms:Label" minOccurs="0"/>
-			<xs:element name="outlineColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="position" type="ms:positionEnum" minOccurs="0"/>
-			<xs:element name="postLabelCache" type="ms:booleanEnum" minOccurs="0"/>
-			<xs:element name="template" type="xs:string" minOccurs="0"/>
-		</xs:all>
-		<xs:attribute name="status" type="ms:stateEnumUnion"/>
-	</xs:complexType>
-	<!-- SCALEBAR Definition -->
-	<xs:complexType name="ScaleBar">
-		<xs:sequence>
-			<xs:element name="align" type="ms:alignEnum" minOccurs="0" default="CENTER"/>
-			<xs:element name="backgroundColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="imageColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="intervals" type="xs:positiveInteger" default="4" minOccurs="0"/>
-			<xs:element name="Label" type="ms:Label" minOccurs="0"/>
-			<xs:element name="outlineColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="position" type="ms:positionEnum" default="LR" minOccurs="0"/>
-			<xs:element name="postLabelCache" type="ms:booleanEnum" default="FALSE" minOccurs="0"/>
-			<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
-			<xs:element name="style" minOccurs="0">
-				<xs:simpleType>
-					<xs:restriction base="xs:integer">
-						<xs:minInclusive value="0"/>
-						<xs:maxInclusive value="1"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="transparent" type="ms:stateEnum" minOccurs="0"/>
-			<xs:element name="units" type="ms:unitType" default="MILES" minOccurs="0"/>
-		</xs:sequence>
-		<xs:attribute name="status" type="ms:stateEnumUnion" default="OFF"/>
-	</xs:complexType>
-	<!-- LABEL Definition -->
-	<xs:complexType name="Label">
-		<xs:sequence>
-			<xs:element name="align" type="ms:alignEnum" minOccurs="0"/>
-			<xs:element name="angle" minOccurs="0">
-				<xs:simpleType id="labelAngleType">
-					<xs:union memberTypes="ms:angleType ms:attributeType">
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:pattern value="[aA][uU][tT][oO]|[fF][oO][lL][lL][oO][wW]|[aA][uU][tT][oO]2"/>
-								<!-- attribute -->
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="antialias" type="ms:booleanEnum" minOccurs="0"/>
-			<xs:element name="buffer" type="xs:integer" minOccurs="0"/>
-			<xs:choice minOccurs="0">
-				<xs:element name="color" type="ms:rgbColorType"/>
-				<xs:element name="colorAttribute" type="ms:attributeType"/>
-			</xs:choice>
-			<xs:element name="encoding" minOccurs="0"/>
-			<xs:element name="expression" type="ms:expressionType" minOccurs="0"/>
-			<xs:element name="font" type="xs:string" minOccurs="0"/>
-			<xs:element name="force" type="ms:booleanEnum" default="FALSE" minOccurs="0"/>
-			<xs:element name="maxLength" type="xs:integer" default="0" minOccurs="0"/>
-			<xs:element name="maxOverlapAngle" type="xs:float" minOccurs="0"/>
-			<xs:element name="maxSize" type="xs:integer" default="256" minOccurs="0"/>
-			<xs:element name="minDistance" type="xs:integer" minOccurs="0"/>
-			<xs:element name="minFeatureSize" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="xs:integer">
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:enumeration value="AUTO"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="minSize" type="xs:integer" default="4" minOccurs="0"/>
-			<xs:element name="offset" type="ms:sizeType" minOccurs="0"/>
-			<xs:choice minOccurs="0">
-				<xs:element name="outlineColor" type="ms:rgbColorType"/>
-				<xs:element name="outlineColorAttribute" type="ms:attributeType"/>
-			</xs:choice>
-			<xs:element name="outlineWidth" type="xs:double" default="1" minOccurs="0"/>
-			<xs:element name="partials" type="ms:booleanEnum" minOccurs="0"/>
-			<xs:element name="position" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="ms:positionEnum ms:fullPositionEnum">
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:enumeration value="AUTO"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="priority" default="1" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="ms:attributeType">
-						<xs:simpleType>
-							<xs:restriction base="xs:integer">
-								<xs:minInclusive value="1"/>
-								<xs:maxInclusive value="10"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="repeatDistance" type="xs:integer" minOccurs="0"/>
-			<xs:element name="shadowColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="shadowSize" type="ms:sizeType" minOccurs="0"/>
-			<xs:element name="size">
-				<xs:simpleType>
-					<xs:union memberTypes="ms:attributeType xs:positiveInteger">
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:enumeration value="TINY"/>
-								<xs:enumeration value="SMALL"/>
-								<xs:enumeration value="MEDIUM"/>
-								<xs:enumeration value="LARGE"/>
-								<xs:enumeration value="GIANT"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="Style" type="ms:Style" minOccurs="0" maxOccurs="unbounded"/>
-			<xs:element name="text" type="xs:string" minOccurs="0"/>
-			<xs:element name="wrap" type="xs:string" minOccurs="0"/>
-		</xs:sequence>
-		<xs:attribute name="type" use="required">
-			<xs:simpleType>
-				<xs:restriction base="xs:string">
-					<xs:enumeration value="BITMAP"/>
-					<xs:enumeration value="TRUETYPE"/>
-				</xs:restriction>
-			</xs:simpleType>
-		</xs:attribute>
-	</xs:complexType>
-	<!-- LABELLEADER Definition -->
-	<xs:complexType name="LabelLeader">
-		<xs:sequence>
-			<xs:element name="gridstep" type="xs:positiveInteger" minOccurs="0"/>
-			<xs:element name="maxdistance" type="xs:positiveInteger" minOccurs="0"/>
-			<xs:element name="Style" type="ms:Style" minOccurs="0" maxOccurs="unbounded"/>
-		</xs:sequence>
-	</xs:complexType>
-	<!-- STYLE Definition -->
-	<xs:complexType name="Style">
-		<xs:sequence>
-			<xs:element name="angle" default="0" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="xs:double ms:attributeType">
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:enumeration value="AUTO"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="antialias" type="ms:booleanEnum" minOccurs="0"/>
-			<xs:element name="backgroundColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="colorRange" type="ms:colorRangeType" minOccurs="0"/>
-			<xs:element name="dataRange" type="ms:dataRangeType" minOccurs="0"/>
-			<xs:choice minOccurs="0">
-				<xs:element name="color" type="ms:rgbColorType"/>
-				<xs:element name="colorAttribute" type="ms:attributeType"/>
-			</xs:choice>
-			<xs:element name="gap" type="xs:integer" default="0" minOccurs="0"/>
-			<xs:element name="geomTransform" minOccurs="0">
-				<xs:simpleType>
-					<xs:restriction base="xs:string">
-						<xs:enumeration value="BBOX"/>
-						<xs:enumeration value="END"/>
-						<xs:enumeration value="LABELPNT"/>
-						<xs:enumeration value="LABELPOLY"/>
-						<xs:enumeration value="START"/>
-						<xs:enumeration value="VERTICES"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="initialGap" type="xs:double" minOccurs="0"/>
-			<xs:element name="lineCap" default="BUTT" minOccurs="0">
-				<xs:simpleType>
-					<xs:restriction base="xs:string">
-						<xs:enumeration value="BUTT"/>
-						<xs:enumeration value="ROUND"/>
-						<xs:enumeration value="SQUARE"/>
-						<xs:enumeration value="TRIANGLE"/>
-						<xs:enumeration value="SVG"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="lineJoin" minOccurs="0">
-				<xs:simpleType>
-					<xs:restriction base="xs:string">
-						<xs:enumeration value="ROUND"/>
-						<xs:enumeration value="MITER"/>
-						<xs:enumeration value="BEVEL"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="lineJoinMaxSize" type="xs:integer" default="3" minOccurs="0"/>
-			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="maxSize" type="xs:float" default="500" minOccurs="0"/>
-			<xs:element name="maxWidth" type="xs:float" default="32" minOccurs="0"/>
-			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="minSize" type="xs:float" default="0" minOccurs="0"/>
-			<xs:element name="minWidth" type="xs:float" default="0" minOccurs="0"/>
-			<xs:element name="offset" type="ms:sizeType" minOccurs="0"/>
-			<xs:element name="opacity" type="xs:integer" default="0" minOccurs="0"/>
-			<xs:choice minOccurs="0">
-				<xs:element name="outlineColor" type="ms:rgbColorType"/>
-				<xs:element name="outlineColorAttribute" type="ms:attributeType"/>
-			</xs:choice>
-			<xs:element name="pattern" minOccurs="0">
-				<xs:simpleType>
-					<xs:list itemType="xs:float"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="polarOffset" minOccurs="0">
-				<xs:simpleType>
-					<xs:union
-						memberTypes="xs:positiveInteger ms:attributeType xs:positiveInteger ms:attributeType"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="size" default="1" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="xs:double ms:attributeType"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="symbol" type="ms:symbolType" default="1" minOccurs="0"/>
-			<xs:element name="width" default="1" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="xs:double ms:attributeType"/>
-				</xs:simpleType>
-			</xs:element>
-		</xs:sequence>
-	</xs:complexType>
-	<!-- CLASS Definition -->
-	<xs:complexType name="Class">
-		<xs:sequence>
-			<xs:element name="backgroundColor" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="debug" type="ms:stateEnum" minOccurs="0"/>
-			<xs:element name="expression" type="ms:expressionType" minOccurs="0"/>
-			<xs:element name="group" type="xs:string" minOccurs="0"/>
-			<xs:element name="keyImage" type="xs:string" minOccurs="0"/>
-			<xs:element name="Label" type="ms:Label" minOccurs="0" maxOccurs="unbounded"/>
-			<xs:element name="LabelLeader" type="ms:LabelLeader" minOccurs="0"/>
-			<xs:element name="maxSize" type="xs:integer" default="50" minOccurs="0"/>
-			<xs:element name="minSize" type="xs:integer" default="0" minOccurs="0"/>
-			<xs:choice minOccurs="0">
-				<xs:element name="outlineColor" type="ms:rgbColorType"/>
-				<xs:element name="outlineColorAttribute" type="ms:attributeType"/>
-			</xs:choice>
-			<xs:element name="size" type="xs:positiveInteger" default="1" minOccurs="0"/>
-			<xs:element name="Style" type="ms:Style" minOccurs="0" maxOccurs="unbounded"/>
-			<xs:element name="symbol" type="ms:symbolType" default="1" minOccurs="0"/>
-			<xs:element name="template" type="xs:string" minOccurs="0"/>
-			<xs:element name="text" type="xs:string" minOccurs="0"/>
-		</xs:sequence>
-		<xs:attribute name="name" type="xs:string"/>
-		<xs:attribute name="status" type="ms:stateEnum" default="ON"/>
-	</xs:complexType>
-	
-	<!-- SYMBOL Definition -->
-	<xs:complexType name="Symbol">
-		<xs:sequence>
-			<xs:element name="anchorPoint" type="ms:pointType" minOccurs="0"/>
-			<xs:element name="antialias" type="ms:booleanEnum" minOccurs="0"/>
-			<xs:element name="character" type="xs:string" minOccurs="0"/>
-			<xs:element name="filled" type="ms:booleanEnum" minOccurs="0"/>
-			<xs:element name="font" type="xs:string" minOccurs="0"/>
-			<xs:element name="image" type="xs:string" minOccurs="0"/>
-			<xs:element name="Points" minOccurs="0">
-				<xs:complexType>
-					<xs:sequence>
-						<xs:element name="point" type="ms:pointType" minOccurs="0" maxOccurs="unbounded"/>
-					</xs:sequence>
-				</xs:complexType>
-			</xs:element>
-			<xs:element name="transparent" type="xs:integer" minOccurs="0"/>
-		</xs:sequence>
-		<xs:attribute name="name" type="xs:string"/>
-		<xs:attribute name="type" use="required">
-			<xs:simpleType>
-				<xs:restriction base="xs:string">
-					<xs:enumeration value="VECTOR"/>
-					<xs:enumeration value="ELLIPSE"/>
-					<xs:enumeration value="PIXMAP"/>
-					<xs:enumeration value="TRUETYPE"/>
-					<xs:enumeration value="HATCH"/>
-					<xs:enumeration value="SIMPLE"/>
-				</xs:restriction>
-			</xs:simpleType>
-		</xs:attribute>
-	</xs:complexType>
-	<!-- FEATURE Definition -->
-	<xs:complexType name="Feature">
-		<xs:all>
-			<xs:element name="Points" minOccurs="0">
-				<xs:complexType>
-					<xs:sequence>
-						<xs:element name="point" type="ms:pointType" minOccurs="0" maxOccurs="unbounded"/>
-					</xs:sequence>
-				</xs:complexType>
-			</xs:element>
-			<xs:element name="items" type="xs:string" minOccurs="0"/>
-			<xs:element name="text" type="xs:string" minOccurs="0"/>
-			<xs:element name="wkt" type="xs:string" minOccurs="0"/>
-		</xs:all>
-	</xs:complexType>
-	<!-- GRID Definition -->
-	<xs:complexType name="Grid">
-		<xs:sequence>
-			<xs:element name="labelFormat" type="xs:string" minOccurs="0"/>
-			<xs:element name="maxArcs" type="xs:double" minOccurs="0"/>
-			<xs:element name="maxInterval" type="xs:double" minOccurs="0"/>
-			<xs:element name="maxSubdivide" type="xs:double" default="256" minOccurs="0"/>
-			<xs:element name="minArcs" type="xs:double" minOccurs="0"/>
-			<xs:element name="minInterval" type="xs:double" minOccurs="0"/>
-			<xs:element name="minSubdivide" type="xs:double" minOccurs="0"/>
-		</xs:sequence>
-	</xs:complexType>
-	<!-- JOIN Definition -->
-	<xs:complexType name="Join">
-		<xs:sequence>
-			<xs:element name="connection" type="xs:string" minOccurs="0"/>
-			<xs:element name="connectionType" minOccurs="0">
-				<xs:simpleType>
-					<xs:restriction base="xs:string">
-						<xs:enumeration value="MYSQL"/>
-						<xs:enumeration value="POSTGRESQL"/>
-						<xs:enumeration value="CSV"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="footer" type="xs:string" minOccurs="0"/>
-			<xs:element name="from" type="xs:string" minOccurs="0"/>
-			<xs:element name="header" type="xs:string" minOccurs="0"/>
-			<xs:element name="table" type="xs:string" minOccurs="0"/>
-			<xs:element name="template" type="xs:string" minOccurs="0"/>
-			<xs:element name="to" type="xs:string"/>
-		</xs:sequence>
-		<xs:attribute name="name" type="xs:string" use="required"/>
-		<xs:attribute name="type" default="ONE-TO-ONE">
-			<xs:simpleType>
-				<xs:restriction base="xs:string">
-					<xs:enumeration value="ONE-TO-ONE"/>
-					<xs:enumeration value="ONE-TO-MANY"/>
-				</xs:restriction>
-			</xs:simpleType>
-		</xs:attribute>
-	</xs:complexType>
-	<!-- REFERENCE Definition -->
-	<xs:complexType name="Reference">
-		<xs:sequence>
-			<xs:element name="color" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="extent" minOccurs="0">
-				<xs:simpleType>
-					<xs:list itemType="xs:double"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="image" type="xs:string" minOccurs="0"/>
-			<xs:element name="marker" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="xs:positiveInteger xs:string"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="markerSize" type="xs:positiveInteger" minOccurs="0"/>
-			<xs:element name="maxBoxSize" type="xs:positiveInteger" minOccurs="0"/>
-			<xs:element name="minBoxSize" type="xs:positiveInteger" minOccurs="0"/>
-			<xs:element name="outlineColor" type="ms:rgbExtendedColorType" minOccurs="0"/>
-			<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
-		</xs:sequence>
-		<xs:attribute name="status" type="ms:stateEnum" default="OFF"/>
-	</xs:complexType>
-	<!-- CLUSTER Definition -->
-	<xs:complexType name="Cluster">
-		<xs:sequence>
-			<xs:element name="buffer" type="xs:float" minOccurs="0"/>
-			<xs:element name="filter" type="ms:expressionType" minOccurs="0"/>
-			<xs:element name="group" type="ms:expressionType" minOccurs="0"/>
-			<xs:element name="maxdistance" type="xs:positiveInteger" minOccurs="0"/>
-			<xs:element name="region" type="xs:string" minOccurs="0"/>
-		</xs:sequence>
-	</xs:complexType>
-	<!--COMPOSITE Definition-->
-	<xs:complexType name="CompoSite">
-		<xs:sequence>
-			<xs:element name="compop" type="xs:string" minOccurs="0"/>
-			<xs:element name="opacity" type="xs:integer" default="100" minOccurs="0"/>
-		</xs:sequence>
-	</xs:complexType>
-	<!-- LAYER Definition -->
-	<xs:complexType name="Layer">
-		<xs:sequence>
-			<xs:element name="Class" type="ms:Class" minOccurs="0" maxOccurs="unbounded"/>
-			<xs:element name="CompoSite" type="ms:CompoSite" minOccurs="0"/>
-			<xs:element name="classGroup" type="xs:string" minOccurs="0"/>
-			<xs:element name="classItem" type="xs:string" minOccurs="0"/>
-			<xs:element name="Cluster" type="ms:Cluster" minOccurs="0"/>
-			<xs:element name="connection" type="xs:string" minOccurs="0"/>
-			<xs:element name="connectionType" minOccurs="0">
-				<xs:simpleType>
-					<xs:restriction base="xs:string">
-						<xs:enumeration value="LOCAL"/>
-						<xs:enumeration value="SDE"/>
-						<xs:enumeration value="OGR"/>
-						<xs:enumeration value="FLATGEOBUF"/>
-						<xs:enumeration value="WFS"/>
-						<xs:enumeration value="POSTGIS"/>
-						<xs:enumeration value="ORACLESPATIAL"/>
-						<xs:enumeration value="WMS"/>
-						<xs:enumeration value="PLUGIN"/>
-						<xs:enumeration value="UNION"/>
-					</xs:restriction>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="data" type="xs:string" minOccurs="0"/>
-			<xs:element name="debug" type="ms:debugModeEnum" default="OFF" minOccurs="0"/>			
-			<xs:element name="extent" minOccurs="0">
-				<xs:simpleType>
-					<xs:list itemType="xs:double"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="Feature" type="ms:Feature" minOccurs="0" maxOccurs="unbounded"/>
-			<xs:element name="filter" type="ms:expressionType" minOccurs="0"/>
-			<xs:element name="filterItem" type="xs:string" minOccurs="0"/>
-			<xs:element name="footer" type="xs:string" minOccurs="0"/>
-			<xs:element name="Grid" type="ms:Grid" minOccurs="0"/>
-			<xs:element name="group" type="xs:string" minOccurs="0"/>
-			<xs:element name="header" type="xs:string" minOccurs="0"/>
-			<xs:element name="Join" type="ms:Join" minOccurs="0"/>
-			<xs:element name="labelCache" type="ms:stateEnum" default="ON" minOccurs="0"/>
-			<xs:element name="labelItem" type="xs:string" minOccurs="0"/>
-			<xs:element name="labelMaxScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="labelMinScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="labelRequires" type="xs:string" minOccurs="0"/>
-			<xs:element name="mask" type="xs:string" minOccurs="0"/>
-			<xs:element name="maxFeatures" type="xs:positiveInteger" minOccurs="0"/>
-			<xs:element name="maxGeoWidth" type="xs:double" minOccurs="0"/>
-			<xs:element name="maxScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="Metadata" type="ms:itemType" minOccurs="0"/>
-			<xs:element name="minGeoWidth" type="xs:double" minOccurs="0"/>
-			<xs:element name="minScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="offsite" type="ms:rgbColorType" minOccurs="0"/>
-			<xs:element name="opacity" minOccurs="0">
-				<xs:simpleType>
-					<xs:union>
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:enumeration value="ALPHA"/>
-							</xs:restriction>
-						</xs:simpleType>
-						<xs:simpleType>
-							<xs:restriction base="xs:integer">
-								<xs:minInclusive value="0"/>
-								<xs:maxInclusive value="100"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="plugin" type="xs:string" minOccurs="0"/>
-			<xs:element name="postLabelCache" type="ms:booleanEnum" default="FALSE" minOccurs="0"/>
-			<xs:element name="processing" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
-			<xs:element name="projection" minOccurs="0">
-				<xs:simpleType>
-					<xs:list itemType="xs:string"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="requires" type="xs:string" minOccurs="0"/>
-			<xs:element name="sizeUnits" default="PIXELS" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="ms:unitType">
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:enumeration value="PIXELS"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="styleItem" type="xs:string" minOccurs="0"/>
-			<xs:element name="symbolScaleDenom" type="xs:double" minOccurs="0"/>
-			<xs:element name="template" type="xs:string" minOccurs="0"/>
-			<xs:element name="tileIndex" type="xs:string" minOccurs="0"/>
-			<xs:element name="tileItem" type="xs:string" default="LOCATION" minOccurs="0"/>
-			<xs:element name="tolerance" type="xs:double" minOccurs="0"/>
-			<xs:element name="toleranceUnits" type="ms:unitTypeUnion" default="PIXELS" minOccurs="0"/>
-			<xs:element name="transform" default="TRUE" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="ms:booleanEnum ms:fullPositionEnum"/>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="units" minOccurs="0">
-				<xs:simpleType>
-					<xs:union memberTypes="ms:unitType ms:extendedUnitType">
-						<xs:simpleType>
-							<xs:restriction base="xs:string">
-								<xs:enumeration value="PERCENTAGES"/>
-							</xs:restriction>
-						</xs:simpleType>
-					</xs:union>
-				</xs:simpleType>
-			</xs:element>
-			<xs:element name="Validation" type="ms:itemType" minOccurs="0"/>
-		</xs:sequence>
-		<xs:attribute name="name" type="xs:string" use="required"/>
-		<xs:attribute name="type" use="required">
-			<xs:simpleType>
-				<xs:restriction base="xs:string">
-					<xs:enumeration value="POINT"/>
-					<xs:enumeration value="LINE"/>
-					<xs:enumeration value="POLYGON"/>
-					<xs:enumeration value="CIRCLE"/>
-					<xs:enumeration value="ANNOTATION"/>
-					<xs:enumeration value="RASTER"/>
-					<xs:enumeration value="QUERY"/>
-					<xs:enumeration value="CHART"/>
-				</xs:restriction>
-			</xs:simpleType>
-		</xs:attribute>
-		<xs:attribute name="status" default="ON">
-			<xs:simpleType>
-				<xs:union memberTypes="ms:stateEnum">
-					<xs:simpleType>
-						<xs:restriction base="xs:string">
-							<xs:enumeration value="DEFAULT"/>
-						</xs:restriction>
-					</xs:simpleType>
-				</xs:union>
-			</xs:simpleType>
-		</xs:attribute>
-	</xs:complexType>
-	<!-- LAYERSET Definition -->
-	<xs:element name="LayerSet">
-		<xs:complexType>
-			<xs:sequence>
-				<xs:element name="Layer" type="ms:Layer" minOccurs="0" maxOccurs="unbounded"/>
-			</xs:sequence>
-		</xs:complexType>
-	</xs:element>
-	<!-- SYMBOLSET Definition -->
-	<xs:element name="SymbolSet">
-		<xs:complexType>
-			<xs:sequence>
-				<xs:element name="Symbol" type="ms:Symbol" minOccurs="0" maxOccurs="unbounded"/>
-			</xs:sequence>
-		</xs:complexType>
-	</xs:element>
-	<!-- MAP Definition -->
-	<xs:element name="Map">
-		<xs:complexType>
-			<xs:sequence>
-				<xs:element name="angle" type="xs:double" default="0" minOccurs="0"/>
-				<xs:element name="Config" type="ms:itemType" minOccurs="0"/>
-				<xs:element name="dataPattern" type="xs:string" minOccurs="0"/>
-				<xs:element name="debug" type="ms:debugModeEnum" default="OFF" minOccurs="0"/>
-				<xs:element name="defResolution" type="xs:positiveInteger" default="72" minOccurs="0"/>
-				<xs:element name="extent" minOccurs="0">
-					<xs:simpleType>
-						<xs:list itemType="xs:double"/>
-					</xs:simpleType>
-				</xs:element>
-				<xs:element name="fontSet" type="xs:string" minOccurs="0"/>
-				<xs:element name="imageColor" type="ms:rgbColorType" minOccurs="0"/>
-				<xs:element name="imageType" type="xs:string" minOccurs="0"/>
-				<xs:element name="include" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
-				<xs:element name="Layer" type="ms:Layer" minOccurs="0" maxOccurs="unbounded"/>
-				<xs:element name="Legend" type="ms:Legend" minOccurs="0"/>
-				<xs:element name="maxSize" type="xs:positiveInteger" minOccurs="0"/>
-				<xs:element name="OutputFormat" type="ms:OutputFormat" maxOccurs="unbounded"/>
-				<xs:element name="projection" minOccurs="0">
-					<xs:simpleType>
-						<xs:list itemType="xs:string"/>
-					</xs:simpleType>
-				</xs:element>
-				<xs:element name="QueryMap" type="ms:QueryMap" minOccurs="0"/>
-				<xs:element name="Reference" type="ms:Reference" minOccurs="0"/>
-				<xs:element name="resolution" type="xs:positiveInteger" default="72" minOccurs="0"/>
-				<xs:element name="ScaleBar" type="ms:ScaleBar" minOccurs="0"/>
-				<xs:element name="scaleDenom" type="xs:double" minOccurs="0"/>
-				<xs:element name="shapePath" type="xs:string" minOccurs="0"/>
-				<xs:element name="size" type="ms:sizeType" minOccurs="0"/>
-				<xs:element name="Symbol" type="ms:Symbol" minOccurs="0" maxOccurs="unbounded"/>
-				<xs:element name="symbolSet" type="xs:string" minOccurs="0"/>
-				<xs:element name="templatePattern" type="xs:string" minOccurs="0"/>
-				<xs:element name="units" default="METERS" minOccurs="0">
-					<xs:simpleType>
-						<xs:union memberTypes="ms:unitType">
-							<xs:simpleType>
-								<xs:restriction base="xs:string">
-									<xs:enumeration value="DD"/>
-								</xs:restriction>
-							</xs:simpleType>
-						</xs:union>
-					</xs:simpleType>
-				</xs:element>
-				<xs:element name="Web" type="ms:Web" minOccurs="0" maxOccurs="unbounded"/>
-			</xs:sequence>
-			<xs:attribute name="name" type="xs:string" use="required"/>
-			<xs:attribute name="status" type="ms:stateEnum" default="ON"/>
-			<xs:attribute name="version" type="xs:string" use="required"/>
-		</xs:complexType>
-	</xs:element>
-</xs:schema>
diff -pruN 8.0.1-5/xmlmapfile/mapfile.xsl 8.2.0~beta1-1~exp1/xmlmapfile/mapfile.xsl
--- 8.0.1-5/xmlmapfile/mapfile.xsl	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/xmlmapfile/mapfile.xsl	1970-01-01 00:00:00.000000000 +0000
@@ -1,1616 +0,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<xsl:stylesheet version="1.0"
-                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-                xmlns:dyn="http://exslt.org/dynamic"
-                xmlns:ms="http://www.mapserver.org/mapserver"
-                extension-element-prefixes="dyn">
- 
-<xsl:output  method="text"/>
-
-<xsl:variable name="smallcase" select="'abcdefghijklmnopqrstuvwxyz'"/>
-<xsl:variable name="uppercase" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
-
-<xsl:template name="getString">
-  <xsl:param name="nodeName"/>
-  <xsl:param name="quote" select="'0'"/>
-  <xsl:if test="*[concat('ms:',name()) = $nodeName] | *[name() = $nodeName]">
-    <xsl:choose>
-      <xsl:when test="$quote = '1'">
-        <xsl:value-of select="translate(substring-after($nodeName,'ms:'), $smallcase, $uppercase)"/><xsl:text> "</xsl:text><xsl:value-of select="dyn:evaluate($nodeName)"/><xsl:text>"</xsl:text>
-      </xsl:when>
-      <xsl:otherwise>
-        <xsl:value-of select="translate(substring-after($nodeName,'ms:'), $smallcase, $uppercase)"/><xsl:text> </xsl:text><xsl:value-of select="dyn:evaluate($nodeName)"/>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:if>
-</xsl:template>
-
-<xsl:template name="indent">
-  <xsl:param name="count"/>
-  <xsl:if test="$count &gt; 0">
-    <xsl:call-template name="indent">
-      <xsl:with-param name="count" select="$count - 1"/>
-    </xsl:call-template>
-    <xsl:value-of select="'  '"/>
-  </xsl:if>
-</xsl:template>
-
-<xsl:template name="print">
-  <xsl:param name="text" select="'null'"/>
-  <xsl:param name="indent"/>
-  <xsl:param name="quote" select="'0'"/>
-  <xsl:param name="node" select="/"/>
-
-  <xsl:variable name="textValue">
-    <xsl:choose>
-      <xsl:when test="$text = 'null'">
-            <xsl:call-template name="getString">
-              <xsl:with-param name="nodeName" select="$node"/>
-              <xsl:with-param name="quote" select="$quote"/>
-            </xsl:call-template>
-      </xsl:when>
-      <xsl:otherwise>
-        <xsl:value-of select="$text"/>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:variable>
-
-  <xsl:choose>
-  <xsl:when test="$text = 'null'">
-    <xsl:if test="$textValue != ''">
-      <xsl:call-template name="indent">
-           <xsl:with-param name="count" select="$indent"/>
-       </xsl:call-template>
-         <xsl:value-of select="$textValue"/>
-       <xsl:text>
-</xsl:text>
-    </xsl:if>
-  </xsl:when>
-  <xsl:otherwise>
-    <xsl:if test="$node">
-       <xsl:call-template name="indent">
-           <xsl:with-param name="count" select="$indent"/>
-       </xsl:call-template>
-         <xsl:value-of select="$textValue"/>
-       <xsl:text>
-</xsl:text>
-    </xsl:if>
-  </xsl:otherwise>
-  </xsl:choose>
-</xsl:template>
-
-<xsl:template name="printExpression">
-  <xsl:param name="indent"/>
-  <xsl:param name="node" select="/"/>
-
-  <xsl:if test="$node">
-    <xsl:variable name="quote">
-      <xsl:choose>
-        <xsl:when test="(dyn:evaluate($node)/@type = 'CONSTANT') or (not(dyn:evaluate($node)/@type))">
-          <xsl:value-of select='1'/>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:value-of select='0'/>
-        </xsl:otherwise>
-      </xsl:choose>
-    </xsl:variable>
-
-    <xsl:variable name="textValue">
-      <xsl:call-template name="getString">
-        <xsl:with-param name="nodeName" select="$node"/>
-        <xsl:with-param name="quote" select="$quote"/>
-      </xsl:call-template>
-    </xsl:variable>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="quote" select="$quote"/>
-      <xsl:with-param name="text" select="$textValue"/>
-    </xsl:call-template>
-
-  </xsl:if>
-</xsl:template>
-
-<xsl:template name="printSymbol">
-  <xsl:param name="indent"/>
-  <xsl:param name="node" select="/"/>
-
-  <xsl:if test="$node">
-    <xsl:variable name="quote">
-      <xsl:choose>
-        <xsl:when test="dyn:evaluate($node)/@type = 'NAME'">
-          <xsl:value-of select='1'/>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:value-of select='0'/>
-        </xsl:otherwise>
-      </xsl:choose>
-    </xsl:variable>
-
-    <xsl:variable name="textValue">
-      <xsl:call-template name="getString">
-        <xsl:with-param name="nodeName" select="$node"/>
-        <xsl:with-param name="quote" select="$quote"/>
-      </xsl:call-template>
-    </xsl:variable>
-    
-    <xsl:call-template name="print">
-      <xsl:with-param name="quote" select="$quote"/>
-      <xsl:with-param name="text" select="$textValue"/>
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:call-template>
-
-  </xsl:if>
-</xsl:template>
-
-  <xsl:template match="/">
-    <xsl:apply-templates select="ms:SymbolSet"/>
-    <xsl:apply-templates select="ms:LayerSet"/>
-    <xsl:apply-templates select="ms:Map"/>
-  </xsl:template>
-
-<xsl:template match="ms:color | ms:backgroundColor | ms:outlineColor | ms:shadowColor | ms:imageColor | ms:offsite">
-  <xsl:param name="indent"/>
-   <xsl:choose>
-     <xsl:when test="starts-with(name(), 'ms:')">
-       <xsl:call-template name="print">
-         <xsl:with-param name="text" select="concat(translate(substring-after(name(), 'ms:'), $smallcase, $uppercase),' ', @red, ' ', @green, ' ', @blue)"/>
-         <xsl:with-param name="indent" select="$indent"/>
-       </xsl:call-template>
-     </xsl:when>
-     <xsl:otherwise>
-       <xsl:call-template name="print">
-         <xsl:with-param name="text" select="concat(translate(name(), $smallcase, $uppercase),' ', @red, ' ', @green, ' ', @blue)"/>
-         <xsl:with-param name="indent" select="$indent"/>
-       </xsl:call-template>
-     </xsl:otherwise>
-   </xsl:choose>
-</xsl:template>
-
- <xsl:template match="ms:colorAttribute | ms:outlineColorAttribute">
-  <xsl:param name="indent"/>
-  <xsl:param name="tagName" select="translate(name(), $smallcase, $uppercase)"/>
-  <xsl:call-template name="print">
-    <xsl:with-param name="text" select="concat($tagName, ' ',.)"/>
-    <xsl:with-param name="indent" select="$indent"/>
-  </xsl:call-template>
-</xsl:template>
-
-<xsl:template match="ms:size | ms:offset | ms:keySize | ms:keySpacing | ms:shadowSize | ms:anchorPoint">
-  <xsl:param name="indent"/>
-  <xsl:choose>
-    <xsl:when test="starts-with(name(), 'ms:')">
-      <xsl:call-template name="print">
-        <xsl:with-param name="text" select="concat(translate(substring-after(name(), 'ms:'), $smallcase, $uppercase), ' ', @x, ' ', @y)"/>
-        <xsl:with-param name="indent" select="$indent"/>
-      </xsl:call-template>
-    </xsl:when>
-    <xsl:otherwise>
-      <xsl:call-template name="print">
-        <xsl:with-param name="text" select="concat(translate(name(), $smallcase, $uppercase), ' ', @x, ' ', @y)"/>
-        <xsl:with-param name="indent" select="$indent"/>
-      </xsl:call-template>
-    </xsl:otherwise>
-  </xsl:choose>
-</xsl:template>
-
-<xsl:template match="ms:Points">
-  <xsl:param name="indent"/>
-  <xsl:call-template name="print">
-    <xsl:with-param name="text" select="'POINTS'"/>
-    <xsl:with-param name="indent" select="$indent - 1"/>
-  </xsl:call-template>
-  <xsl:for-each select="ms:point">
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat(@x,' ',@y)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:call-template>
-  </xsl:for-each>
-  <xsl:call-template name="print">
-    <xsl:with-param name="text" select="'END'"/>
-    <xsl:with-param name="indent" select="$indent - 1"/>
-  </xsl:call-template>
-</xsl:template>
-
-<xsl:template match="ms:Metadata | ms:Validation">
-  <xsl:param name="indent"/>
-  <xsl:choose>
-    <xsl:when test="starts-with(name(), 'ms:')">
-      <xsl:call-template name="print">
-        <xsl:with-param name="text" select="translate(substring-after(name(), 'ms:'),$smallcase, $uppercase)"/>
-        <xsl:with-param name="indent" select="$indent -1"/>
-      </xsl:call-template>
-    </xsl:when>
-    <xsl:otherwise>
-      <xsl:call-template name="print">
-        <xsl:with-param name="text" select="translate(name(),$smallcase, $uppercase)"/>
-        <xsl:with-param name="indent" select="$indent -1"/>
-      </xsl:call-template>
-    </xsl:otherwise>
-    </xsl:choose>
-  <xsl:for-each select="ms:item">
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('&#34;',@name,'&#34; ','&#34;',.,'&#34;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:call-template>
-  </xsl:for-each>
-  <xsl:call-template name="print">
-    <xsl:with-param name="text" select="'END'"/>
-    <xsl:with-param name="indent" select="$indent - 1"/>
-  </xsl:call-template>
- </xsl:template>
-
-<xsl:template match="ms:Config">
-  <xsl:param name="indent"/>
-  <xsl:for-each select="ms:item">
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('CONFIG ','&#34;',@name,'&#34; ','&#34;',.,'&#34;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:call-template>
-  </xsl:for-each>
- </xsl:template>
-
-
-<xsl:template match="ms:projection">
-  <xsl:param name="indent"/>
-  <xsl:call-template name="print">
-    <xsl:with-param name="text" select="'PROJECTION'"/>
-    <xsl:with-param name="indent" select="$indent - 1"/>
-  </xsl:call-template>
-  <xsl:call-template name="split-projection">
-    <xsl:with-param name="list" select="."/>
-    <xsl:with-param name="indent" select="$indent"/>
-  </xsl:call-template>
-  <xsl:call-template name="print">
-    <xsl:with-param name="text" select="'END'"/>
-    <xsl:with-param name="indent" select="$indent - 1"/>
-  </xsl:call-template>
- </xsl:template>
-
- <xsl:template name="split-projection">
-   <xsl:param name="list"/>
-   <xsl:param name="indent"/>
-   <xsl:variable name="newlist" select="concat(normalize-space($list), ' ')" />
-   <xsl:variable name="first" select="substring-before($newlist, ' ')" />
-   <xsl:variable name="remaining" select="substring-after($newlist, ' ')" />
-   <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('&#34;',$first,'&#34;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:call-template>
-   <xsl:if test="$remaining">
-     <xsl:call-template name="split-projection">
-       <xsl:with-param name="list" select="$remaining" />
-       <xsl:with-param name="indent" select="$indent" />
-     </xsl:call-template>
-   </xsl:if>
-  </xsl:template>
-
-  <xsl:template match="ms:pattern">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('PATTERN ',.,' END')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:call-template>
-  </xsl:template>
-
-  <xsl:template match="ms:QueryMap">
-    <xsl:param name="indent"/>
-
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'QUERYMAP'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@status"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:color">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:size">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:style'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-
-  </xsl:template>
-
-
-  <xsl:template match="ms:Web">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'WEB'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:browseFormat'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:empty'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:error'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:footer'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:header'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:imagePath'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:tempPath'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:imageUrl'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:legendFormat'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:log'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxTemplate'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Metadata">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minTemplate'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:queryFormat'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:template'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Validation">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-
-  <xsl:template match="ms:OutputFormat">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'OUTPUTFORMAT'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@name"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:driver'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:extension'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:for-each select="ms:formatOption">
-       <xsl:call-template name="print">
-         <xsl:with-param name="indent" select="$indent"/>
-         <xsl:with-param name="text" select="concat('FORMATOPTION ','&#34;',.,'&#34;')"/>
-       </xsl:call-template>
-    </xsl:for-each>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:imageMode'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:mimeType'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:transparent'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:Reference">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'REFERENCE'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@status"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:color">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:extent'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:image'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:marker'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:markerSize'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxBoxSize'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minBoxSize'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:outlineColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:size">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-
-  <xsl:template match="ms:Legend">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'LEGEND'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@status"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:imageColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:keySize">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:keySpacing">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:Label">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:outlineColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:position'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:postLabelCache'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:template'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:Label">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'LABEL'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@type"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:align'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:angle'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:antialias'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:buffer'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxOverlapAngle'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:color">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:colorAttribute">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="tagName" select="'COLOR'"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:encoding'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="printExpression">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:expression'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:font'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:force'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxLength'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxSize'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minDistance'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minFeatureSize'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minSize'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:offset">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:outlineColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:outlineColorAttribute">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="tagName" select="'OUTLINECOLOR'"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:outlineWidth'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:partials'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:position'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:priority'"/>
-    </xsl:call-template>
-   <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:repeatDistance'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:shadowColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:shadowSize">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:size'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Style">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:text'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>    
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:wrap'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:ScaleBar">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'SCALEBAR'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@status"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:align'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:backgroundColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:color">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:imageColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:intervals'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Label">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:outlineColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:position'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:postLabelCache'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:size">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:style'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:transparent'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:units'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:LabelLeader">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'LEADER'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:gridstep'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxdistance'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Style">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-
-  <xsl:template match="ms:Style">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'STYLE'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:angle'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:antialias'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:color">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:colorAttribute">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="tagName" select="'COLOR'"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:geomTransform'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:initialGap'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxSize'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxWidth'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minSize'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minWidth'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:gap'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:lineCap'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:lineJoin'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:lineJoinMaxSize'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:pattern">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:polarOffset'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:offset">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:opacity'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:outlineColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:outlineColorAttribute">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="tagName" select="'OUTLINECOLOR'"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:size'"/>
-    </xsl:call-template>
-    <xsl:call-template name="printSymbol">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:symbol'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:width'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:CompoSite">
-    <xsl:param name="indent"/>
-	<xsl:call-template name="print">
-      <xsl:with-param name="text" select="'COMPOSITE'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-	<xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:Opacity'"/>
-    </xsl:call-template>
-	<xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:Compop'"/>
-    </xsl:call-template>
-  <xsl:template>
-  
-  <xsl:template match="ms:Class">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'CLASS'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@name"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@status"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:backgroundColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:color">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:debug'"/>
-    </xsl:call-template>
-    <xsl:call-template name="printExpression">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:expression'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:group'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:keyImage'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:for-each select="ms:Label">
-      <xsl:apply-templates select=".">
-        <xsl:with-param name="indent" select="$indent + 1"/>
-      </xsl:apply-templates>
-    </xsl:for-each>
-    <xsl:apply-templates select="ms:LabelLeader">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxSize'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minSize'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:outlineColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:outlineColorAttribute">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="tagName" select="'OUTLINECOLOR'"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:size'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Style">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="printSymbol">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:symbol'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:template'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:text'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:Symbol">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'SYMBOL'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@name"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@type"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:anchorPoint">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:antialias'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:character'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-     <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:filled'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:font'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:image'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Points">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:transparent'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:Feature">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'FEATURE'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Points">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:items'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:text'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:wkt'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:Grid">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'GRID'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:labelFormat'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxArcs'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxInterval'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxSubdivide'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minArcs'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minInterval'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minSubdivide'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-
-  <xsl:template match="ms:Join">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'JOIN'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@name"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@type"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:connection'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:connectionType'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:footer'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:from'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:header'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:table'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:template'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:to'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-   <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:Layer">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'LAYER'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@name"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('TYPE ',@type)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@type"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@status"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Class">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:CompoSite">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:classGroup'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:classItem'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:connection'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:connectionType'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:data'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:debug'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:extent'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Feature">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="printExpression">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:filter'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:filterItem'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:footer'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Grid">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:group'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:header'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Join">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:labelCache'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:labelItem'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:labelMaxScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:labelMinScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:labelRequires'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:mask'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxFeatures'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxGeoWidth'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Metadata">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minGeoWidth'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:minScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:offsite">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:opacity'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:plugin'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:postLabelCache'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Cluster">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:for-each select="ms:processing">
-      <xsl:call-template name="print">
-        <xsl:with-param name="indent" select="$indent"/>
-        <xsl:with-param name="text">
-          <xsl:value-of select="concat('PROCESSING ','&#34;',.,'&#34;')"/>
-        </xsl:with-param>
-      </xsl:call-template>
-    </xsl:for-each>
-    <xsl:apply-templates select="ms:projection">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:requires'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:sizeUnits'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:styleItem'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:symbolScaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:template'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:tileIndex'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:tileItem'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:tolerance'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:toleranceUnits'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:transform'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:units'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Validation">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-
-  <xsl:template match="ms:Cluster">
-    <xsl:param name="indent"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'CLUSTER'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxdistance'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:region'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="printExpression">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:group'"/>
-    </xsl:call-template>
-    <xsl:call-template name="printExpression">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:filter'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-      <xsl:with-param name="indent" select="$indent - 1"/>
-    </xsl:call-template>
-  </xsl:template>
-  
-  <xsl:template match="ms:SymbolSet">
-    <xsl:param name="indent" select="0"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'SYMBOLSET&#xa;'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Symbol">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-   <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-    </xsl:call-template>
-  </xsl:template>
-
-  <xsl:template match="ms:LayerSet">
-    <xsl:param name="indent" select="0"/>
-    <xsl:apply-templates select="ms:Layer">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-  </xsl:template>
-
-  <xsl:template match="ms:Map">
-    <xsl:param name="indent" select="0"/>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'MAP&#xa;'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('NAME ','&quot;',@name,'&quot;')"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@name"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="concat('STATUS ',@status)"/>
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="@status"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:angle'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Config">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:dataPattern'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:debug'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:defResolution'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:extent'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:fontSet'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:imageColor">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:imageType'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:for-each select="ms:include">
-      <xsl:call-template name="print">
-        <xsl:with-param name="indent" select="$indent"/>
-        <xsl:with-param name="text">
-          <xsl:value-of select="concat('INCLUDE ','&#34;',.,'&#34;')"/>
-        </xsl:with-param>
-      </xsl:call-template>
-      </xsl:for-each>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:maxSize'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:projection">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:resolution'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:scaleDenom'"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:shapePath'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:size">
-      <xsl:with-param name="indent" select="$indent"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:symbolSet'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:templatePattern'"/>
-      <xsl:with-param name="quote" select="1"/>
-    </xsl:call-template>
-    <xsl:call-template name="print">
-      <xsl:with-param name="indent" select="$indent"/>
-      <xsl:with-param name="node" select="'ms:units'"/>
-    </xsl:call-template>
-    <xsl:apply-templates select="ms:Web">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:OutputFormat">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:QueryMap">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:Reference">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:Legend">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:ScaleBar">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:Layer">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:apply-templates select="ms:Symbol">
-      <xsl:with-param name="indent" select="$indent + 1"/>
-    </xsl:apply-templates>
-    <xsl:call-template name="print">
-      <xsl:with-param name="text" select="'END&#xa;'"/>
-    </xsl:call-template>
-  </xsl:template>
-
-</xsl:stylesheet>
-
-
diff -pruN 8.0.1-5/xmlmapfile/tests/layerset.xml 8.2.0~beta1-1~exp1/xmlmapfile/tests/layerset.xml
--- 8.0.1-5/xmlmapfile/tests/layerset.xml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/xmlmapfile/tests/layerset.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,157 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<LayerSet xmlns="http://www.mapserver.org/mapserver" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.mapserver.org/mapserver ../mapfile.xsd">
-  <Layer name="layer1" type="CHART" status="DEFAULT">
-    <Class name="class1Layer1" status="ON">
-      <backgroundColor red="244" green="43" blue="22"/>
-      <color red="244" green="43" blue="22"/>
-      <debug>ON</debug>
-      <expression type="MSEXPR">(length('[NAME_E]') &lt; 8)</expression>
-      <group>group1</group>
-      <keyImage>/home/myusername/layer1.png</keyImage>
-      <Label type="TRUETYPE">
-        <align>LEFT</align>
-        <angle>AUTO2</angle>
-        <antialias>TRUE</antialias>
-        <buffer>2</buffer>
-        <colorAttribute>[myColor]</colorAttribute>
-        <encoding>ISO 8859-1</encoding>
-        <font>serif</font>
-        <force>TRUE</force>
-        <maxLength>244</maxLength>
-        <maxSize>244</maxSize>
-        <minDistance>24</minDistance>
-        <minFeatureSize>AUTO</minFeatureSize>
-        <minSize>6</minSize>
-        <offset x="12" y="33"/>
-        <outlineColor red="-1" green="-1" blue="-1"/>
-        <outlineWidth>13</outlineWidth>
-        <partials>TRUE</partials>
-        <position>AUTO</position>
-        <priority>5</priority>
-        <repeatDistance>80</repeatDistance>
-        <shadowColor red="244" green="43" blue="22"/>
-        <shadowSize x="15" y="14"/>
-        <size>TINY</size>
-        <text>Test</text>
-        <wrap>\n</wrap>
-      </Label>
-      <LabelLeader>
-        <gridstep>6</gridstep>
-        <maxdistance>15</maxdistance>
-            <Style>
-                <initialGap>2</initialGap>
-            </Style>
-      </LabelLeader>
-      <maxScaleDenom>24000</maxScaleDenom>
-      <maxSize>50</maxSize>
-      <minScaleDenom>1000000</minScaleDenom>
-      <minSize>10</minSize>
-      <outlineColor red="33" green="44" blue="55"/>
-      <size>12</size>
-      <Style>
-        <angle>434</angle>
-        <antialias>TRUE</antialias>
-        <backgroundColor red="244" green="43" blue="22"/>
-        <color red="244" green="43" blue="22"/>
-        <gap>13</gap>
-        <geomTransform>VERTICES</geomTransform>
-        <lineCap>ROUND</lineCap>
-        <lineJoin>BEVEL</lineJoin>
-        <lineJoinMaxSize>3</lineJoinMaxSize>
-        <maxSize>244</maxSize>
-        <maxWidth>28</maxWidth>
-        <minSize>6</minSize>
-        <minWidth>24</minWidth>
-        <offset x="12" y="33"/>
-        <opacity>1253</opacity>
-        <outlineColorAttribute>[myOulineColorAttribute]</outlineColorAttribute>
-        <pattern>2 3</pattern>
-        <size>[mySize]</size>
-        <symbol type="NAME">star.gif</symbol>
-        <width>[myWidth]</width>
-      </Style>
-            <Style>
-                <initialGap>2</initialGap>
-            </Style>
-      <symbol type="ID">261</symbol>
-      <template>http://mapgears.com/templates/myTemplates1.html</template>
-      <text>myText1</text>
-    </Class>
-    <classGroup>group1</classGroup>
-    <classItem>population</classItem>
-    <Cluster>
-      <buffer>3.3</buffer>
-      <filter type="MSEXPR">(type=’road’ and size &lt; 2)</filter>
-      <group type="REGEX">/ddea/i</group>
-      <maxdistance>20</maxdistance>
-      <region>region1</region>
-    </Cluster>
-    <connection>user=nobody password=****** dbname=dbname host=localhost port=5432</connection>
-    <connectionType>SDE</connectionType>
-    <data>../data</data>
-    <debug>1</debug>
-    <extent>-180.0 -90.0 180.0 90.0</extent>
-    <Feature>
-      <wkt>POINT(2000 2500)</wkt>
-    </Feature>
-    <filter type="MSEXPR">(type=’road’ and size &lt; 2)</filter>
-    <filterItem>pop</filterItem>
-    <footer>http://mapgears.com/templates/myfooter1.html</footer>
-    <Grid>
-      <labelFormat>DDMMSS</labelFormat>
-      <maxArcs>5.0</maxArcs>
-      <maxInterval>0.5</maxInterval>
-      <maxSubdivide>0.07</maxSubdivide>
-      <minArcs>1.0</minArcs>
-      <minInterval>0.05</minInterval>
-      <minSubdivide>0.01</minSubdivide>
-    </Grid>
-    <group>group1</group>
-    <header>http://mapgears.com/templates/myHeader1.html</header>
-    <Join name="myJoin1" type="ONE-TO-MANY">
-      <connection>user=nobody password=****** dbname=dbname host=localhost port=5432</connection>
-      <connectionType>POSTGRESQL</connectionType>
-      <from>ID</from>
-      <table>./data/lookup.dbf</table>
-      <template>http://mapgears.com/templates/myJoin1.html</template>
-      <to>IDENT</to>
-    </Join>
-    <labelCache>ON</labelCache>
-    <labelItem>myLabel1</labelItem>
-    <labelMaxScaleDenom>2334342</labelMaxScaleDenom>
-    <labelMinScaleDenom>100000</labelMinScaleDenom>
-    <labelRequires>![orthoquads]</labelRequires>
-    <mask>layerName</mask>
-    <maxFeatures>250000</maxFeatures>
-    <maxScaleDenom>300000</maxScaleDenom>
-    <Metadata>
-      <item name="description">Cities</item>
-      <item name="title">The Cities</item>
-      <item name="author">Norm</item>
-    </Metadata>
-    <minScaleDenom>120000</minScaleDenom>
-    <offsite red="244" green="43" blue="22"/>
-    <opacity>ALPHA</opacity>
-    <plugin>myPlugin.lib</plugin>
-    <postLabelCache>TRUE</postLabelCache>
-    <processing>CLOSE_CONNECTION=DEFER</processing>
-    <processing>SCALE=AUTO</processing>
-    <projection>init=epsg:4326 ellps=WGS84 datum=WGS84</projection>
-    <requires>[orthoquads]</requires>
-    <sizeUnits>METERS</sizeUnits>
-    <styleItem>Go</styleItem>
-    <symbolScaleDenom>24000</symbolScaleDenom>
-    <template>myLayer1.html</template>
-    <tileIndex>tiger/index.shp</tileIndex>
-    <tileItem>LOCATION</tileItem>
-    <tolerance>5</tolerance>
-    <toleranceUnits>DD</toleranceUnits>
-    <transform>TRUE</transform>
-    <units>METERS</units>
-    <Validation>
-      <item name="firstname">^[a-zA-Z\-]+$</item>
-      <item name="taxid">^[A-Z]{2}[0-9]{6}$</item>
-    </Validation>
-  </Layer>
-</LayerSet>
-
diff -pruN 8.0.1-5/xmlmapfile/tests/mapfile-test.xml 8.2.0~beta1-1~exp1/xmlmapfile/tests/mapfile-test.xml
--- 8.0.1-5/xmlmapfile/tests/mapfile-test.xml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/xmlmapfile/tests/mapfile-test.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,207 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<Map name="xmlmapfile" xmlns="http://www.mapserver.org/mapserver" status="ON" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.mapserver.org/mapserver ../mapfile.xsd" version="5.6.0">
-	<angle>10</angle>
-	<Config>
-		<item name="CGI_CONTEXT_URL">http://mapgears.com/context/mapgears.xml</item>
-		<item name="MS_ENCRYPTION_KEY">dfas2klaed2v 3384knkju3k23</item>
-		<item name="MS_ERRORFILE">/tmp/ms_error.txt</item>
-	</Config>
-	<dataPattern>$#[a-e]?</dataPattern>
-	<debug>2</debug>
-	<defResolution>72</defResolution>
-	<extent>-180.0 -90.0 180.0 90.0</extent>
-	<fontSet>../etc/fonts.txt</fontSet>
-	<imageColor red="0" green="255" blue="255"/>
-	<imageType>png</imageType>
-        <include>/tmp/myLayerSet.map</include>
-        <include>/tmp/AnotherLayerSet.map</include>
-	<Legend status="ON">
-		<imageColor red="255" green="255" blue="255"/>
-		<keySize x="20" y="10"/>
-		<keySpacing x="5" y="5"/>
-		<Label type="TRUETYPE">
-			<align>CENTER</align>
-			<angle>FOLLOW</angle>
-			<antialias>TRUE</antialias>
-			<buffer>2</buffer>
-			<colorAttribute>[myColor]</colorAttribute>
-			<encoding>ISO 8859-1</encoding>
-			<font>serif</font>
-			<force>TRUE</force>
-			<maxLength>244</maxLength>
-			<maxOverlapAngle>30</maxOverlapAngle>
-			<maxSize>244</maxSize>
-			<minDistance>24</minDistance>
-			<minFeatureSize>AUTO</minFeatureSize>
-			<minSize>6</minSize>
-			<offset x="12" y="33"/>
-			<outlineColor red="244" green="43" blue="22"/>
-			<outlineWidth>13</outlineWidth>
-			<partials>TRUE</partials>
-			<position>LL</position>
-			<priority>5</priority>
-			<shadowColor red="244" green="43" blue="22"/>
-			<shadowSize x="15" y="14"/>
-			<size>SMALL</size>
-			<wrap>\n</wrap>
-		</Label>
-		<outlineColor red="244" green="43" blue="22"/>
-		<position>LR</position>
-		<postLabelCache>FALSE</postLabelCache>
-		<template>ttt.html</template>
-	</Legend>
-	<maxSize>2048</maxSize>
-        <OutputFormat name="GTiff">
-          <driver>GDAL/GTIFF</driver>
-          <extension>tiff</extension>
-          <formatOption>TILED=YES</formatOption>
-          <formatOption>TRANSPARENCY=TRUE</formatOption>
-          <imageMode>FLOAT32</imageMode>
-          <mimeType>image/tiff</mimeType>
-          <transparent>OFF</transparent>
-        </OutputFormat>
-        <OutputFormat name="PNG">
-          <driver>AGG/PNG</driver>
-          <extension>png</extension>
-          <formatOption>TILED=YES</formatOption>
-          <imageMode>RGBA</imageMode>
-          <mimeType>image/png</mimeType>
-          <transparent>ON</transparent>
-        </OutputFormat>
-	<projection>
-          proj=utm
-          ellps=GRS80
-          datum=NAD83
-          zone=15
-          units=m
-          north
-          no_defs
-        </projection>
-	<QueryMap status="ON">
-		<color red="244" green="43" blue="22"/>
-		<size x="600" y="400"/>
-		<style>SELECTED</style>
-	</QueryMap>
-	<Reference status="ON">
-		<color red="244" green="43" blue="22"/>
-		<extent>-10.0 -9.0 10.0 9.0</extent>
-		<image>/home/myusername/ref1.png</image>
-		<marker>star</marker>
-		<markerSize>3</markerSize>
-		<maxBoxSize>24</maxBoxSize>
-		<minBoxSize>4</minBoxSize>
-		<outlineColor red="244" green="43" blue="22"/>
-		<size x="6" y="4"/>
-	</Reference>
-	<resolution>72</resolution>
-	<ScaleBar status="EMBED">
-		<align>CENTER</align>
-		<backgroundColor red="244" green="43" blue="22"/>
-		<color red="244" green="43" blue="22"/>
-		<imageColor red="0" green="255" blue="255"/>
-		<intervals>5</intervals>
-		<Label type="TRUETYPE">
-			<align>CENTER</align>
-			<angle>[myAngle]</angle>
-			<antialias>FALSE</antialias>
-			<buffer>2</buffer>
-			<colorAttribute>[myColor]</colorAttribute>
-			<encoding>ISO 8859-1</encoding>
-			<font>serif</font>
-			<force>TRUE</force>
-			<maxLength>244</maxLength>
-			<maxSize>244</maxSize>
-			<minDistance>24</minDistance>
-			<minFeatureSize>AUTO</minFeatureSize>
-			<minSize>6</minSize>
-			<offset x="12" y="33"/>
-			<outlineColor red="244" green="43" blue="22"/>
-			<outlineWidth>13</outlineWidth>
-			<partials>TRUE</partials>
-			<position>LL</position>
-			<priority>5</priority>
-			<shadowColor red="244" green="43" blue="22"/>
-			<shadowSize x="15" y="14"/>
-			<size>SMALL</size>
-                        <Style>
-                          <geomTransform>VERTICES</geomTransform>
-                          <initialGap>20.5</initialGap>
-                          <polarOffset>[uv_length_2] [uv_angle]</polarOffset>
-                        </Style>
-                        <Style>
-                          <initialGap>2</initialGap>
-                        </Style>
-			<wrap>\n</wrap>
-		</Label>
-		<outlineColor red="12" green="45" blue="12"/>
-		<position>LR</position>
-		<postLabelCache>TRUE</postLabelCache>
-		<size x="90" y="8"/>
-		<style>0</style>
-                <transparent>ON</transparent>
-		<units>NAUTICALMILES</units>
-	</ScaleBar>
-	<scaleDenom>24000</scaleDenom>
-	<shapePath>../data</shapePath>
-	<size x="600" y="400"/>
-	<Symbol name="mySymbol2-test2" type="SIMPLE">
-		<antialias>FALSE</antialias>
-		<character>C</character>
-		<filled>TRUE</filled>
-		<font>serif</font>
-		<image>/tmp/test.gif</image>
-		<Points>
-			<point x="2" y="-3"/>
-		</Points>
-		<transparent>123</transparent>
-	</Symbol>
-        <Symbol name="mySymbol222-test1" type="SIMPLE">
-          <antialias>FALSE</antialias>
-          <character>C</character>
-          <filled>TRUE</filled>
-          <font>serif</font>
-          <image>/tmp/test.gif</image>
-          <Points>
-            <point x="2" y="-3"/>
-          </Points>
-          <transparent>123</transparent>
-        </Symbol>
-	<symbolSet>/tmp/mySymbolSet.sym</symbolSet>
-	<templatePattern>[$ir-wz]*.html</templatePattern>
-	<units>MILES</units>
-        <Web>
-          <browseFormat>text/html</browseFormat>
-          <empty>../errors/queryfail1.html</empty>
-          <error>../errors/error1.html</error>
-          <footer>../templates/footer1.html</footer>
-          <header>../templates/header.html</header>
-          <imagePath>/tmp/ms_tmp/</imagePath>
-          <imageUrl>/ms_tmp/</imageUrl>
-          <legendFormat>text/html</legendFormat>
-          <log>../logs/ms.log</log>
-          <maxScaleDenom>240000</maxScaleDenom>
-          <maxTemplate>../templates/maxtemplate1.html</maxTemplate>
-          <Metadata>
-            <item name="description">Cities</item>
-            <item name="title">The Cities</item>
-            <item name="author">Norm</item>
-          </Metadata>
-          <minScaleDenom>120000</minScaleDenom>
-          <minTemplate>../templates/mintemplate1.html</minTemplate>
-          <queryFormat>text/html</queryFormat>
-          <template>http://mapgears.com/templates/myTemplates1.html</template>
-          <Validation>
-            <item name="firstname">^[a-zA-Z\-]+$</item>
-            <item name="taxid">^[A-Z]{2}[0-9]{6}$</item>
-          </Validation>
-	</Web>
-</Map>
-
-
-
-
-
-
-
-
-
diff -pruN 8.0.1-5/xmlmapfile/tests/symbolset.xml 8.2.0~beta1-1~exp1/xmlmapfile/tests/symbolset.xml
--- 8.0.1-5/xmlmapfile/tests/symbolset.xml	2023-04-17 17:26:04.000000000 +0000
+++ 8.2.0~beta1-1~exp1/xmlmapfile/tests/symbolset.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,26 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<SymbolSet xmlns="http://www.mapserver.org/mapserver" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.mapserver.org/mapserver ../mapfile.xsd">
-	<Symbol name="mySymbol2" type="SIMPLE">
-		<antialias>FALSE</antialias>
-		<character>C</character>
-		<filled>TRUE</filled>
-		<font>serif</font>
-		<image>/tmp/test.gif</image>
-		<Points>
-			<point x="2" y="-3"/>
-		</Points>
-		<transparent>0</transparent>
-	</Symbol>
-        <Symbol name="mySymbol222" type="SIMPLE">
-          <anchorPoint x="0.5" y="0.2"/>
-          <antialias>FALSE</antialias>
-          <character>C</character>
-          <filled>TRUE</filled>
-          <font>serif</font>
-          <image>/tmp/test.gif</image>
-          <Points>
-            <point x="2" y="-3"/>
-          </Points>
-          <transparent>123</transparent>
-        </Symbol>
-</SymbolSet>
